/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the RISCV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 100;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(4),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s32,
  GILLT_p0s64,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_nxv1s1,
  GILLT_nxv1s8,
  GILLT_nxv1s16,
  GILLT_nxv1s32,
  GILLT_nxv1s64,
  GILLT_nxv2s1,
  GILLT_nxv2s8,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s8,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv4s64,
  GILLT_nxv8s1,
  GILLT_nxv8s8,
  GILLT_nxv8s16,
  GILLT_nxv8s32,
  GILLT_nxv8s64,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
  GILLT_nxv16s16,
  GILLT_nxv16s32,
  GILLT_nxv32s1,
  GILLT_nxv32s8,
  GILLT_nxv32s16,
  GILLT_nxv64s1,
  GILLT_nxv64s8,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 32),
  LLT::pointer(0, 64),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(1), 8),
  LLT::vector(ElementCount::getScalable(1), 16),
  LLT::vector(ElementCount::getScalable(1), 32),
  LLT::vector(ElementCount::getScalable(1), 64),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 8),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 8),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(4), 64),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 8),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(8), 32),
  LLT::vector(ElementCount::getScalable(8), 64),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
  LLT::vector(ElementCount::getScalable(16), 16),
  LLT::vector(ElementCount::getScalable(16), 32),
  LLT::vector(ElementCount::getScalable(32), 1),
  LLT::vector(ElementCount::getScalable(32), 8),
  LLT::vector(ElementCount::getScalable(32), 16),
  LLT::vector(ElementCount::getScalable(64), 1),
  LLT::vector(ElementCount::getScalable(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasStdExtZicbopBit = 34,
  Feature_HasStdExtZicondBit = 35,
  Feature_HasStdExtZihintpauseBit = 22,
  Feature_HasStdExtZimopBit = 33,
  Feature_HasStdExtZicfilpBit = 2,
  Feature_NoStdExtZicfilpBit = 1,
  Feature_HasStdExtZilsdBit = 36,
  Feature_HasStdExtZmmulBit = 23,
  Feature_HasStdExtMBit = 24,
  Feature_HasStdExtABit = 26,
  Feature_HasStdExtZtsoBit = 28,
  Feature_NotHasStdExtZtsoBit = 27,
  Feature_HasStdExtZabhaBit = 31,
  Feature_HasStdExtZacasBit = 30,
  Feature_NoStdExtZacasBit = 29,
  Feature_HasStdExtZalasrBit = 32,
  Feature_HasStdExtFBit = 5,
  Feature_HasStdExtDBit = 7,
  Feature_HasStdExtZfhminBit = 12,
  Feature_HasStdExtZfhBit = 10,
  Feature_HasStdExtZfaBit = 37,
  Feature_NoStdExtZfaBit = 8,
  Feature_HasStdExtZfinxBit = 6,
  Feature_HasStdExtZdinxBit = 9,
  Feature_HasStdExtZhinxminBit = 13,
  Feature_HasStdExtZhinxBit = 11,
  Feature_HasStdExtZcaBit = 20,
  Feature_HasStdExtCBit = 18,
  Feature_HasStdExtZbaBit = 43,
  Feature_NotHasStdExtZbaBit = 21,
  Feature_HasStdExtZbbBit = 40,
  Feature_NoStdExtZbbBit = 42,
  Feature_HasStdExtZbcBit = 45,
  Feature_HasStdExtZbsBit = 39,
  Feature_HasStdExtZbkbBit = 41,
  Feature_NoStdExtZbkbBit = 97,
  Feature_HasStdExtZbkxBit = 46,
  Feature_HasStdExtZbbOrZbkbBit = 38,
  Feature_HasStdExtZbcOrZbkcBit = 44,
  Feature_HasStdExtZkndBit = 47,
  Feature_HasStdExtZkneBit = 49,
  Feature_HasStdExtZkndOrZkneBit = 48,
  Feature_HasStdExtZknhBit = 50,
  Feature_HasStdExtZksedBit = 51,
  Feature_HasStdExtZkshBit = 52,
  Feature_HasStdExtZvkbBit = 60,
  Feature_HasStdExtZvbbBit = 59,
  Feature_HasStdExtZvbcBit = 64,
  Feature_HasStdExtZvkgBit = 61,
  Feature_HasStdExtZvknedBit = 62,
  Feature_HasStdExtZvknhaBit = 65,
  Feature_HasStdExtZvknhbBit = 66,
  Feature_HasStdExtZvksedBit = 67,
  Feature_HasStdExtZvkshBit = 63,
  Feature_HasVInstructionsBit = 14,
  Feature_HasVInstructionsI64Bit = 55,
  Feature_HasVInstructionsAnyFBit = 54,
  Feature_HasVInstructionsF16MinimalBit = 57,
  Feature_HasVInstructionsF16Bit = 53,
  Feature_HasVInstructionsF64Bit = 58,
  Feature_HasVInstructionsFullMultiplyBit = 56,
  Feature_HasVendorXVentanaCondOpsBit = 68,
  Feature_HasVendorXTHeadBaBit = 69,
  Feature_HasVendorXTHeadBbBit = 70,
  Feature_HasVendorXTHeadBsBit = 71,
  Feature_HasVendorXTHeadCondMovBit = 72,
  Feature_HasVendorXTHeadFMemIdxBit = 77,
  Feature_HasVendorXTHeadMacBit = 73,
  Feature_HasVendorXTHeadMemIdxBit = 76,
  Feature_HasVendorXTHeadMemPairBit = 75,
  Feature_HasVendorXTHeadVdotBit = 74,
  Feature_HasVendorXSfvcpBit = 78,
  Feature_HasVendorXSfvqmaccdodBit = 79,
  Feature_HasVendorXSfvqmaccqoqBit = 80,
  Feature_HasVendorXSfvfnrclipxfqfBit = 81,
  Feature_HasVendorXCVbitmanipBit = 83,
  Feature_HasVendorXCVmacBit = 86,
  Feature_HasVendorXCVmemBit = 82,
  Feature_HasVendorXCValuBit = 84,
  Feature_HasVendorXCVbiBit = 85,
  Feature_UseCCMovInsnBit = 95,
  Feature_HasVendorXqciaBit = 90,
  Feature_HasVendorXqcibiBit = 91,
  Feature_HasVendorXqcibmBit = 92,
  Feature_HasVendorXqcicmBit = 94,
  Feature_HasVendorXqciintBit = 93,
  Feature_HasVendorXqciliaBit = 87,
  Feature_HasVendorXqciloBit = 88,
  Feature_HasVendorXqcislsBit = 89,
  Feature_HasVendorXAndesPerfBit = 96,
  Feature_IsRV64Bit = 4,
  Feature_IsRV32Bit = 3,
  Feature_HasShortForwardBranchOptBit = 15,
  Feature_NoShortForwardBranchOptBit = 17,
  Feature_HasConditionalMoveFusionBit = 16,
  Feature_NoConditionalMoveFusionBit = 0,
  Feature_HasAtomicLdStBit = 25,
  Feature_OptForMinSizeBit = 19,
  Feature_HwMode1Bit = 99,
  Feature_HwMode0Bit = 98,
};

PredicateBitset RISCVInstructionSelector::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasStdExtZicbop())
    Features.set(Feature_HasStdExtZicbopBit);
  if (Subtarget->hasStdExtZicond())
    Features.set(Feature_HasStdExtZicondBit);
  if (Subtarget->hasStdExtZihintpause())
    Features.set(Feature_HasStdExtZihintpauseBit);
  if (Subtarget->hasStdExtZimop())
    Features.set(Feature_HasStdExtZimopBit);
  if (Subtarget->hasStdExtZicfilp())
    Features.set(Feature_HasStdExtZicfilpBit);
  if (!Subtarget->hasStdExtZicfilp())
    Features.set(Feature_NoStdExtZicfilpBit);
  if (Subtarget->hasStdExtZilsd())
    Features.set(Feature_HasStdExtZilsdBit);
  if (Subtarget->hasStdExtZmmul())
    Features.set(Feature_HasStdExtZmmulBit);
  if (Subtarget->hasStdExtM())
    Features.set(Feature_HasStdExtMBit);
  if (Subtarget->hasStdExtA())
    Features.set(Feature_HasStdExtABit);
  if (Subtarget->hasStdExtZtso())
    Features.set(Feature_HasStdExtZtsoBit);
  if (!Subtarget->hasStdExtZtso())
    Features.set(Feature_NotHasStdExtZtsoBit);
  if (Subtarget->hasStdExtZabha())
    Features.set(Feature_HasStdExtZabhaBit);
  if (Subtarget->hasStdExtZacas())
    Features.set(Feature_HasStdExtZacasBit);
  if (!Subtarget->hasStdExtZacas())
    Features.set(Feature_NoStdExtZacasBit);
  if (Subtarget->hasStdExtZalasr())
    Features.set(Feature_HasStdExtZalasrBit);
  if (Subtarget->hasStdExtF())
    Features.set(Feature_HasStdExtFBit);
  if (Subtarget->hasStdExtD())
    Features.set(Feature_HasStdExtDBit);
  if (Subtarget->hasStdExtZfhmin())
    Features.set(Feature_HasStdExtZfhminBit);
  if (Subtarget->hasStdExtZfh())
    Features.set(Feature_HasStdExtZfhBit);
  if (Subtarget->hasStdExtZfa())
    Features.set(Feature_HasStdExtZfaBit);
  if (!Subtarget->hasStdExtZfa())
    Features.set(Feature_NoStdExtZfaBit);
  if (Subtarget->hasStdExtZfinx())
    Features.set(Feature_HasStdExtZfinxBit);
  if (Subtarget->hasStdExtZdinx())
    Features.set(Feature_HasStdExtZdinxBit);
  if (Subtarget->hasStdExtZhinxmin())
    Features.set(Feature_HasStdExtZhinxminBit);
  if (Subtarget->hasStdExtZhinx())
    Features.set(Feature_HasStdExtZhinxBit);
  if (Subtarget->hasStdExtZca())
    Features.set(Feature_HasStdExtZcaBit);
  if (Subtarget->hasStdExtC())
    Features.set(Feature_HasStdExtCBit);
  if (Subtarget->hasStdExtZba())
    Features.set(Feature_HasStdExtZbaBit);
  if (!Subtarget->hasStdExtZba())
    Features.set(Feature_NotHasStdExtZbaBit);
  if (Subtarget->hasStdExtZbb())
    Features.set(Feature_HasStdExtZbbBit);
  if (!Subtarget->hasStdExtZbb())
    Features.set(Feature_NoStdExtZbbBit);
  if (Subtarget->hasStdExtZbc())
    Features.set(Feature_HasStdExtZbcBit);
  if (Subtarget->hasStdExtZbs())
    Features.set(Feature_HasStdExtZbsBit);
  if (Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbkbBit);
  if (!Subtarget->hasStdExtZbkb())
    Features.set(Feature_NoStdExtZbkbBit);
  if (Subtarget->hasStdExtZbkx())
    Features.set(Feature_HasStdExtZbkxBit);
  if (Subtarget->hasStdExtZbb() || Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbbOrZbkbBit);
  if (Subtarget->hasStdExtZbc() || Subtarget->hasStdExtZbkc())
    Features.set(Feature_HasStdExtZbcOrZbkcBit);
  if (Subtarget->hasStdExtZknd())
    Features.set(Feature_HasStdExtZkndBit);
  if (Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkneBit);
  if (Subtarget->hasStdExtZknd() || Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkndOrZkneBit);
  if (Subtarget->hasStdExtZknh())
    Features.set(Feature_HasStdExtZknhBit);
  if (Subtarget->hasStdExtZksed())
    Features.set(Feature_HasStdExtZksedBit);
  if (Subtarget->hasStdExtZksh())
    Features.set(Feature_HasStdExtZkshBit);
  if (Subtarget->hasStdExtZvkb())
    Features.set(Feature_HasStdExtZvkbBit);
  if (Subtarget->hasStdExtZvbb())
    Features.set(Feature_HasStdExtZvbbBit);
  if (Subtarget->hasStdExtZvbc())
    Features.set(Feature_HasStdExtZvbcBit);
  if (Subtarget->hasStdExtZvkg())
    Features.set(Feature_HasStdExtZvkgBit);
  if (Subtarget->hasStdExtZvkned())
    Features.set(Feature_HasStdExtZvknedBit);
  if (Subtarget->hasStdExtZvknha())
    Features.set(Feature_HasStdExtZvknhaBit);
  if (Subtarget->hasStdExtZvknhb())
    Features.set(Feature_HasStdExtZvknhbBit);
  if (Subtarget->hasStdExtZvksed())
    Features.set(Feature_HasStdExtZvksedBit);
  if (Subtarget->hasStdExtZvksh())
    Features.set(Feature_HasStdExtZvkshBit);
  if (Subtarget->hasVInstructions())
    Features.set(Feature_HasVInstructionsBit);
  if (Subtarget->hasVInstructionsI64())
    Features.set(Feature_HasVInstructionsI64Bit);
  if (Subtarget->hasVInstructionsAnyF())
    Features.set(Feature_HasVInstructionsAnyFBit);
  if (Subtarget->hasVInstructionsF16Minimal())
    Features.set(Feature_HasVInstructionsF16MinimalBit);
  if (Subtarget->hasVInstructionsF16())
    Features.set(Feature_HasVInstructionsF16Bit);
  if (Subtarget->hasVInstructionsF64())
    Features.set(Feature_HasVInstructionsF64Bit);
  if (Subtarget->hasVInstructionsFullMultiply())
    Features.set(Feature_HasVInstructionsFullMultiplyBit);
  if (Subtarget->hasVendorXVentanaCondOps())
    Features.set(Feature_HasVendorXVentanaCondOpsBit);
  if (Subtarget->hasVendorXTHeadBa())
    Features.set(Feature_HasVendorXTHeadBaBit);
  if (Subtarget->hasVendorXTHeadBb())
    Features.set(Feature_HasVendorXTHeadBbBit);
  if (Subtarget->hasVendorXTHeadBs())
    Features.set(Feature_HasVendorXTHeadBsBit);
  if (Subtarget->hasVendorXTHeadCondMov())
    Features.set(Feature_HasVendorXTHeadCondMovBit);
  if (Subtarget->hasVendorXTHeadFMemIdx())
    Features.set(Feature_HasVendorXTHeadFMemIdxBit);
  if (Subtarget->hasVendorXTHeadMac())
    Features.set(Feature_HasVendorXTHeadMacBit);
  if (Subtarget->hasVendorXTHeadMemIdx())
    Features.set(Feature_HasVendorXTHeadMemIdxBit);
  if (Subtarget->hasVendorXTHeadMemPair())
    Features.set(Feature_HasVendorXTHeadMemPairBit);
  if (Subtarget->hasVendorXTHeadVdot())
    Features.set(Feature_HasVendorXTHeadVdotBit);
  if (Subtarget->hasVendorXSfvcp())
    Features.set(Feature_HasVendorXSfvcpBit);
  if (Subtarget->hasVendorXSfvqmaccdod())
    Features.set(Feature_HasVendorXSfvqmaccdodBit);
  if (Subtarget->hasVendorXSfvqmaccqoq())
    Features.set(Feature_HasVendorXSfvqmaccqoqBit);
  if (Subtarget->hasVendorXSfvfnrclipxfqf())
    Features.set(Feature_HasVendorXSfvfnrclipxfqfBit);
  if (Subtarget->hasVendorXCVbitmanip())
    Features.set(Feature_HasVendorXCVbitmanipBit);
  if (Subtarget->hasVendorXCVmac())
    Features.set(Feature_HasVendorXCVmacBit);
  if (Subtarget->hasVendorXCVmem())
    Features.set(Feature_HasVendorXCVmemBit);
  if (Subtarget->hasVendorXCValu())
    Features.set(Feature_HasVendorXCValuBit);
  if (Subtarget->hasVendorXCVbi())
    Features.set(Feature_HasVendorXCVbiBit);
  if (Subtarget->useCCMovInsn())
    Features.set(Feature_UseCCMovInsnBit);
  if (Subtarget->hasVendorXqcia())
    Features.set(Feature_HasVendorXqciaBit);
  if (Subtarget->hasVendorXqcibi())
    Features.set(Feature_HasVendorXqcibiBit);
  if (Subtarget->hasVendorXqcibm())
    Features.set(Feature_HasVendorXqcibmBit);
  if (Subtarget->hasVendorXqcicm())
    Features.set(Feature_HasVendorXqcicmBit);
  if (Subtarget->hasVendorXqciint())
    Features.set(Feature_HasVendorXqciintBit);
  if (Subtarget->hasVendorXqcilia())
    Features.set(Feature_HasVendorXqciliaBit);
  if (Subtarget->hasVendorXqcilo())
    Features.set(Feature_HasVendorXqciloBit);
  if (Subtarget->hasVendorXqcisls())
    Features.set(Feature_HasVendorXqcislsBit);
  if (Subtarget->hasVendorXAndesPerf())
    Features.set(Feature_HasVendorXAndesPerfBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_IsRV64Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_IsRV32Bit);
  if (Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_HasShortForwardBranchOptBit);
  if (!Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_NoShortForwardBranchOptBit);
  if (Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_HasConditionalMoveFusionBit);
  if (!Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_NoConditionalMoveFusionBit);
  if (Subtarget->hasStdExtA() || Subtarget->hasForcedAtomics())
    Features.set(Feature_HasAtomicLdStBit);
  if (MF ? MF->getFunction().hasMinSize() : false)
    Features.set(Feature_OptForMinSizeBit);
  if (!((Subtarget->is64Bit())))
    Features.set(Feature_HwMode1Bit);
  if ((Subtarget->is64Bit()))
    Features.set(Feature_HwMode0Bit);
  return Features;
}

void RISCVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVInstructionSelector::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HwMode0,
  GIFBS_HwMode1,
  GIFBS_HasAtomicLdSt_HwMode0,
  GIFBS_HasAtomicLdSt_HwMode1,
  GIFBS_HasShortForwardBranchOpt_HwMode0,
  GIFBS_HasShortForwardBranchOpt_HwMode1,
  GIFBS_HasStdExtA_HwMode0,
  GIFBS_HasStdExtA_HwMode1,
  GIFBS_HasStdExtD,
  GIFBS_HasStdExtD_HwMode0,
  GIFBS_HasStdExtD_HwMode1,
  GIFBS_HasStdExtF,
  GIFBS_HasStdExtF_HwMode0,
  GIFBS_HasStdExtF_HwMode1,
  GIFBS_HasStdExtM_HwMode0,
  GIFBS_HasStdExtM_HwMode1,
  GIFBS_HasStdExtZalasr_HwMode0,
  GIFBS_HasStdExtZalasr_HwMode1,
  GIFBS_HasStdExtZba_HwMode0,
  GIFBS_HasStdExtZba_HwMode1,
  GIFBS_HasStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_HwMode1,
  GIFBS_HasStdExtZbkb_HwMode0,
  GIFBS_HasStdExtZbkb_HwMode1,
  GIFBS_HasStdExtZbkx_HwMode0,
  GIFBS_HasStdExtZbkx_HwMode1,
  GIFBS_HasStdExtZbs_HwMode0,
  GIFBS_HasStdExtZbs_HwMode1,
  GIFBS_HasStdExtZfa,
  GIFBS_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtZfh,
  GIFBS_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtZfinx,
  GIFBS_HasStdExtZfinx_HwMode0,
  GIFBS_HasStdExtZfinx_HwMode1,
  GIFBS_HasStdExtZhinx,
  GIFBS_HasStdExtZhinx_HwMode0,
  GIFBS_HasStdExtZhinx_HwMode1,
  GIFBS_HasStdExtZhinxmin_HwMode0,
  GIFBS_HasStdExtZhinxmin_HwMode1,
  GIFBS_HasStdExtZihintpause_HwMode0,
  GIFBS_HasStdExtZihintpause_HwMode1,
  GIFBS_HasStdExtZmmul_HwMode0,
  GIFBS_HasStdExtZmmul_HwMode1,
  GIFBS_HasStdExtZvbb_HwMode0,
  GIFBS_HasStdExtZvbb_HwMode1,
  GIFBS_HasStdExtZvbc_HwMode0,
  GIFBS_HasStdExtZvbc_HwMode1,
  GIFBS_HasStdExtZvkb_HwMode0,
  GIFBS_HasStdExtZvkb_HwMode1,
  GIFBS_HasStdExtZvkg_HwMode0,
  GIFBS_HasStdExtZvkg_HwMode1,
  GIFBS_HasStdExtZvkned_HwMode0,
  GIFBS_HasStdExtZvkned_HwMode1,
  GIFBS_HasStdExtZvknha_HwMode0,
  GIFBS_HasStdExtZvknha_HwMode1,
  GIFBS_HasStdExtZvknhb_HwMode0,
  GIFBS_HasStdExtZvknhb_HwMode1,
  GIFBS_HasStdExtZvksed_HwMode0,
  GIFBS_HasStdExtZvksed_HwMode1,
  GIFBS_HasStdExtZvksh_HwMode0,
  GIFBS_HasStdExtZvksh_HwMode1,
  GIFBS_HasVInstructions_HwMode0,
  GIFBS_HasVInstructions_HwMode1,
  GIFBS_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsFullMultiply_HwMode0,
  GIFBS_HasVInstructionsFullMultiply_HwMode1,
  GIFBS_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_HwMode0,
  GIFBS_HasVendorXAndesPerf_HwMode1,
  GIFBS_HasVendorXCVmac_HwMode0,
  GIFBS_HasVendorXCVmac_HwMode1,
  GIFBS_HasVendorXSfvcp_HwMode0,
  GIFBS_HasVendorXSfvcp_HwMode1,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1,
  GIFBS_HasVendorXSfvqmaccdod_HwMode0,
  GIFBS_HasVendorXSfvqmaccdod_HwMode1,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode0,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode1,
  GIFBS_HasVendorXTHeadBa_HwMode0,
  GIFBS_HasVendorXTHeadBa_HwMode1,
  GIFBS_HasVendorXTHeadBb_HwMode0,
  GIFBS_HasVendorXTHeadBb_HwMode1,
  GIFBS_HasVendorXTHeadBs_HwMode0,
  GIFBS_HasVendorXTHeadBs_HwMode1,
  GIFBS_HasVendorXTHeadCondMov_HwMode0,
  GIFBS_HasVendorXTHeadCondMov_HwMode1,
  GIFBS_HasVendorXTHeadMac_HwMode0,
  GIFBS_HasVendorXTHeadMac_HwMode1,
  GIFBS_HasVendorXTHeadVdot_HwMode0,
  GIFBS_HasVendorXTHeadVdot_HwMode1,
  GIFBS_IsRV32_HwMode0,
  GIFBS_IsRV32_HwMode1,
  GIFBS_IsRV64_HwMode0,
  GIFBS_IsRV64_HwMode1,
  GIFBS_UseCCMovInsn_HwMode0,
  GIFBS_UseCCMovInsn_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_IsRV64_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode1,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfa,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtD_IsRV32_HwMode0,
  GIFBS_HasStdExtD_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV64_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode1,
  GIFBS_HasStdExtF_IsRV64_HwMode0,
  GIFBS_HasStdExtM_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode1,
  GIFBS_HasStdExtZba_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV64_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfh_IsRV32_HwMode0,
  GIFBS_HasStdExtZfh_IsRV32_HwMode1,
  GIFBS_HasStdExtZfh_IsRV64_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZfinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZhinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZknd_IsRV32_HwMode1,
  GIFBS_HasStdExtZknd_IsRV64_HwMode0,
  GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZkne_IsRV32_HwMode1,
  GIFBS_HasStdExtZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZknh_IsRV32_HwMode1,
  GIFBS_HasStdExtZknh_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode1,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1,
  GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0,
  GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode1,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcibm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcicm_IsRV32_HwMode0,
  GIFBS_HasVendorXqcicm_IsRV32_HwMode1,
  GIFBS_HasVendorXqcilia_IsRV32_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1,
  GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HwMode0Bit, },
  {Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode1Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode0Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, },
  {Feature_HasStdExtDBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, },
  {Feature_HasStdExtFBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZihintpauseBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode0Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndOrZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXAndesPerfBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcicmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqciliaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZilsdBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcibmBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_GIAddrRegImm,
  GICP_GIShiftMask32,
  GICP_GIShiftMaskXLen,
  GICP_GIVLOp,
  GICP_gi_sexti32,
  GICP_gi_sh1add_op,
  GICP_gi_sh1add_uw_op,
  GICP_gi_sh2add_op,
  GICP_gi_sh2add_uw_op,
  GICP_gi_sh3add_op,
  GICP_gi_sh3add_uw_op,
  GICP_gi_zexti16,
  GICP_gi_zexti32,
  GICP_gi_zexti8,
};
// See constructor for table contents

RISCVInstructionSelector::ComplexMatcherMemFn
RISCVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &RISCVInstructionSelector::selectAddrRegImm, // GIAddrRegImm
  &RISCVInstructionSelector::selectShiftMask32, // GIShiftMask32
  &RISCVInstructionSelector::selectShiftMaskXLen, // GIShiftMaskXLen
  &RISCVInstructionSelector::renderVLOp, // GIVLOp
  &RISCVInstructionSelector::selectSExtBits<32>, // gi_sexti32
  &RISCVInstructionSelector::selectSHXADDOp<1>, // gi_sh1add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<1>, // gi_sh1add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<2>, // gi_sh2add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<2>, // gi_sh2add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<3>, // gi_sh3add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<3>, // gi_sh3add_uw_op
  &RISCVInstructionSelector::selectZExtBits<16>, // gi_zexti16
  &RISCVInstructionSelector::selectZExtBits<32>, // gi_zexti32
  &RISCVInstructionSelector::selectZExtBits<8>, // gi_zexti8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_like_non_imm12 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_add_non_imm12,
  GICXXPred_MI_Predicate_anonymous_9921,
  GICXXPred_MI_Predicate_anonymous_9923,
  GICXXPred_MI_Predicate_anonymous_10011,
  GICXXPred_MI_Predicate_anonymous_10025,
  GICXXPred_MI_Predicate_anonymous_10029,
  GICXXPred_MI_Predicate_anonymous_10031,
  GICXXPred_MI_Predicate_anonymous_10033,
  GICXXPred_MI_Predicate_anonymous_10035,
  GICXXPred_MI_Predicate_anonymous_10038,
  GICXXPred_MI_Predicate_anonymous_10040,
  GICXXPred_MI_Predicate_anonymous_10053,
  GICXXPred_MI_Predicate_anonymous_10066,
  GICXXPred_MI_Predicate_anonymous_11262,
};
bool RISCVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_like_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_like_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_add_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_9921: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9923: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10011: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10025: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10029: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10031: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10033: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10035: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10038: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10040: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10053: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10066: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_11262: {
     return hasAllHUsers(MI); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AddiPair = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BCLRMask,
  GICXXPred_I64_Predicate_LeadingOnesMask,
  GICXXPred_I64_Predicate_LeadingOnesWMask,
  GICXXPred_I64_Predicate_SingleBitSetMask,
  GICXXPred_I64_Predicate_allonessew8,
  GICXXPred_I64_Predicate_allonessew16,
  GICXXPred_I64_Predicate_allonessew32,
  GICXXPred_I64_Predicate_allonessew64,
  GICXXPred_I64_Predicate_bare_simm9_lsb0,
  GICXXPred_I64_Predicate_bare_simm12_lsb0,
  GICXXPred_I64_Predicate_bare_simm13_lsb0,
  GICXXPred_I64_Predicate_byteselect,
  GICXXPred_I64_Predicate_c_lui_imm,
  GICXXPred_I64_Predicate_csr_sysreg,
  GICXXPred_I64_Predicate_cv_tuimm2,
  GICXXPred_I64_Predicate_cv_tuimm5,
  GICXXPred_I64_Predicate_cv_uimm10,
  GICXXPred_I64_Predicate_immzero,
  GICXXPred_I64_Predicate_payload1,
  GICXXPred_I64_Predicate_payload2,
  GICXXPred_I64_Predicate_payload5,
  GICXXPred_I64_Predicate_powerOf2Minus1,
  GICXXPred_I64_Predicate_rnum,
  GICXXPred_I64_Predicate_simm5,
  GICXXPred_I64_Predicate_simm5_plus1,
  GICXXPred_I64_Predicate_simm5_plus1_nonzero,
  GICXXPred_I64_Predicate_simm5nonzero,
  GICXXPred_I64_Predicate_simm6,
  GICXXPred_I64_Predicate_simm6nonzero,
  GICXXPred_I64_Predicate_simm10_lsb0000nonzero,
  GICXXPred_I64_Predicate_simm11,
  GICXXPred_I64_Predicate_simm12,
  GICXXPred_I64_Predicate_simm12Minus1Nonzero,
  GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1,
  GICXXPred_I64_Predicate_simm12Plus1,
  GICXXPred_I64_Predicate_simm12Plus1i32,
  GICXXPred_I64_Predicate_simm12_lsb00000,
  GICXXPred_I64_Predicate_simm12_no6,
  GICXXPred_I64_Predicate_simm12_plus1,
  GICXXPred_I64_Predicate_simm16nonzero,
  GICXXPred_I64_Predicate_simm20_li,
  GICXXPred_I64_Predicate_simm21_lsb0_jal,
  GICXXPred_I64_Predicate_simm26,
  GICXXPred_I64_Predicate_simm26_nosimm12,
  GICXXPred_I64_Predicate_simm32_nosimm26,
  GICXXPred_I64_Predicate_tsimm5,
  GICXXPred_I64_Predicate_tuimm5,
  GICXXPred_I64_Predicate_u32simm12,
  GICXXPred_I64_Predicate_uimm1,
  GICXXPred_I64_Predicate_uimm2,
  GICXXPred_I64_Predicate_uimm2_3,
  GICXXPred_I64_Predicate_uimm2_4,
  GICXXPred_I64_Predicate_uimm2_lsb0,
  GICXXPred_I64_Predicate_uimm3,
  GICXXPred_I64_Predicate_uimm4,
  GICXXPred_I64_Predicate_uimm5,
  GICXXPred_I64_Predicate_uimm5_lsb0,
  GICXXPred_I64_Predicate_uimm5_plus1,
  GICXXPred_I64_Predicate_uimm5ge6_plus1,
  GICXXPred_I64_Predicate_uimm5gt3,
  GICXXPred_I64_Predicate_uimm5i32,
  GICXXPred_I64_Predicate_uimm5nonzero,
  GICXXPred_I64_Predicate_uimm5slist,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_lsb0,
  GICXXPred_I64_Predicate_uimm6gt32,
  GICXXPred_I64_Predicate_uimm7_lsb00,
  GICXXPred_I64_Predicate_uimm7_lsb000,
  GICXXPred_I64_Predicate_uimm8_lsb00,
  GICXXPred_I64_Predicate_uimm8_lsb000,
  GICXXPred_I64_Predicate_uimm9_lsb000,
  GICXXPred_I64_Predicate_uimm10,
  GICXXPred_I64_Predicate_uimm10_lsb00nonzero,
  GICXXPred_I64_Predicate_uimm11,
  GICXXPred_I64_Predicate_uimm14lsb00,
  GICXXPred_I64_Predicate_uimm16nonzero,
  GICXXPred_I64_Predicate_uimmlog2xlen,
  GICXXPred_I64_Predicate_uimmlog2xlennonzero,
};
bool RISCVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AddiPair: {
    
      // The immediate operand must be in range [-4096,-2049] or [2048,4094].
      return (-4096 <= Imm && Imm <= -2049) || (2048 <= Imm && Imm <= 4094);
    
    llvm_unreachable("AddiPair should have returned");
  }
  case GICXXPred_I64_Predicate_BCLRMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(~Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(~Imm);
    
    llvm_unreachable("BCLRMask should have returned");
  }
  case GICXXPred_I64_Predicate_LeadingOnesMask: {
    
      return !isInt<32>(Imm) && isMask_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_LeadingOnesWMask: {
    
      // If the value is a uint32 but not an int32, it must have bit 31 set and
      // bits 63:32 cleared. After that we're looking for a shifted mask but not
      // an all ones mask.
      return !isInt<32>(Imm) && isUInt<32>(Imm) && isShiftedMask_64(Imm) &&
             Imm != UINT64_C(0xffffffff);
    
    llvm_unreachable("LeadingOnesWMask should have returned");
  }
  case GICXXPred_I64_Predicate_SingleBitSetMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(Imm);
    
    llvm_unreachable("SingleBitSetMask should have returned");
  }
  case GICXXPred_I64_Predicate_allonessew8: {
    return SignExtend64<8>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew16: {
    return SignExtend64<16>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew32: {
    return SignExtend64<32>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew64: {
    return Imm == -1LL;
  }
  case GICXXPred_I64_Predicate_bare_simm9_lsb0: {
    return isShiftedInt<8, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm12_lsb0: {
    return isShiftedInt<11, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm13_lsb0: {
    return isShiftedInt<12, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_byteselect: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_c_lui_imm: {
    return (Imm != 0) &&
                                     (isUInt<5>(Imm) ||
                                      (Imm >= 0xfffe0 && Imm <= 0xfffff));
  }
  case GICXXPred_I64_Predicate_csr_sysreg: {
    return isUInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immzero: {
    return (Imm == 0);
  }
  case GICXXPred_I64_Predicate_payload1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_payload2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_payload5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_powerOf2Minus1: {
     return isPowerOf2_32(Imm+1); 
  }
  case GICXXPred_I64_Predicate_rnum: {
    return (Imm >= 0 && Imm <= 10);
  }
  case GICXXPred_I64_Predicate_simm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm5_plus1: {
    return (isInt<5>(Imm) && Imm != -16) || Imm == 16;
  }
  case GICXXPred_I64_Predicate_simm5_plus1_nonzero: {
    return Imm != 0 && ((isInt<5>(Imm) && Imm != -16) || Imm == 16);
  }
  case GICXXPred_I64_Predicate_simm5nonzero: {
    return (Imm != 0) && isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6nonzero: {
    return (Imm != 0) && isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10_lsb0000nonzero: {
    return (Imm != 0) && isShiftedInt<6, 4>(Imm);
  }
  case GICXXPred_I64_Predicate_simm11: {
    return isInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12: {
    return isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12Minus1Nonzero: {
    
      return (Imm >= -2049 && Imm < 0) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1: {
    
      return (Imm >= -2049 && Imm < -1) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Plus1: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12Plus1i32: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12_lsb00000: {
    return isShiftedInt<7, 5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_no6: {
    
      return isInt<12>(Imm) && !isInt<6>(Imm) && isInt<12>(-Imm);
  }
  case GICXXPred_I64_Predicate_simm12_plus1: {
    return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm16nonzero: {
    return (Imm != 0) && isInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_simm20_li: {
    return isInt<20>(Imm);
  }
  case GICXXPred_I64_Predicate_simm21_lsb0_jal: {
    return isShiftedInt<20, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26: {
    return isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26_nosimm12: {
    
      return isInt<26>(Imm) && !isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm32_nosimm26: {
    
      return isInt<32>(Imm) && !isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_tsimm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_u32simm12: {
    
      return isUInt<32>(Imm) && isInt<12>(SignExtend64<32>(Imm));
    
  }
  case GICXXPred_I64_Predicate_uimm1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2_3: {
    
      return isShiftedUInt<2, 3>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_4: {
    
      return isShiftedUInt<2, 4>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_lsb0: {
    return isShiftedUInt<1, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_lsb0: {
    return isShiftedUInt<4, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_plus1: {
    return (isUInt<5>(Imm) && (Imm != 0)) || (Imm == 32);
  }
  case GICXXPred_I64_Predicate_uimm5ge6_plus1: {
    return (Imm >= 6) && (isUInt<5>(Imm) || (Imm == 32));
  }
  case GICXXPred_I64_Predicate_uimm5gt3: {
    return (Imm > 3) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5i32: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5nonzero: {
    return (Imm != 0) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5slist: {
    return ((Imm == 0)  ||
                (Imm == 1)  ||
                (Imm == 2)  ||
                (Imm == 4)  ||
                (Imm == 8)  ||
                (Imm == 16) ||
                (Imm == 15) ||
                (Imm == 31));
  }
  case GICXXPred_I64_Predicate_uimm6: {
    return isUInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6_lsb0: {
    return isShiftedUInt<5, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6gt32: {
    
      return isUInt<6>(Imm) && Imm > 32;
    
  }
  case GICXXPred_I64_Predicate_uimm7_lsb00: {
    return isShiftedUInt<5, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb000: {
    return isShiftedUInt<4, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb00: {
    return isShiftedUInt<6, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb000: {
    return isShiftedUInt<5, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm9_lsb000: {
    return isShiftedUInt<6, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10_lsb00nonzero: {
    return isShiftedUInt<8, 2>(Imm) && (Imm != 0);
  }
  case GICXXPred_I64_Predicate_uimm11: {
    return isUInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm14lsb00: {
    return isShiftedUInt<12, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm16nonzero: {
    return (Imm != 0) && isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_uimmlog2xlen: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm);
      return isUInt<5>(Imm);
    
    llvm_unreachable("uimmlog2xlen should have returned");
  }
  case GICXXPred_I64_Predicate_uimmlog2xlennonzero: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm) && (Imm != 0);
      return isUInt<5>(Imm) && (Imm != 0);
    
    llvm_unreachable("uimmlog2xlennonzero should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_Shifted32OnesMask = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_TrailingOnesMask,
};
bool RISCVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_Shifted32OnesMask: {
    
      if (!Imm.isShiftedMask())
        return false;
    
      unsigned TrailingZeros = Imm.countr_zero();
      return TrailingZeros > 0 && TrailingZeros < 32 &&
             Imm == UINT64_C(0xFFFFFFFF) << TrailingZeros;
    
    llvm_unreachable("Shifted32OnesMask should have returned");
  }
  case GICXXPred_APInt_Predicate_TrailingOnesMask: {
    
      return !isInt<12>(Imm.getSExtValue()) && isMask_64(Imm.getZExtValue());
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("RISCVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderAddiPairImmLarge,
  GICR_renderAddiPairImmSmall,
  GICR_renderFrameIndex,
  GICR_renderImmPlus1,
  GICR_renderImmSubFrom32,
  GICR_renderImmSubFromXLen,
  GICR_renderNegImm,
  GICR_renderTrailingZeros,
  GICR_renderXLenSubTrailingOnes,
};
RISCVInstructionSelector::CustomRendererFn
RISCVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &RISCVInstructionSelector::renderAddiPairImmLarge,
  &RISCVInstructionSelector::renderAddiPairImmSmall,
  &RISCVInstructionSelector::renderFrameIndex,
  &RISCVInstructionSelector::renderImmPlus1,
  &RISCVInstructionSelector::renderImmSubFrom32,
  &RISCVInstructionSelector::renderImmSubFromXLen,
  &RISCVInstructionSelector::renderNegImm,
  &RISCVInstructionSelector::renderTrailingZeros,
  &RISCVInstructionSelector::renderXLenSubTrailingOnes,
};

bool RISCVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool RISCVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("RISCVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*       0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(333), /*)*//*default:*//*Label 125*/ GIMT_Encode4(2450999),
     /*      10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1130),
     /*      14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(61071),
     /*      18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(80304),
     /*      22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(107358),
     /*      26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(110092),
     /*      30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(112826),
     /*      34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(115605), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(118339),
     /*      50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(128297),
     /*      54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(140918), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 10*/ GIMT_Encode4(155825), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      94 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(155886), GIMT_Encode4(0),
     /*     102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(155947), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     126 */ /*TargetOpcode::G_BITCAST*//*Label 13*/ GIMT_Encode4(156038), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 14*/ GIMT_Encode4(156405),
     /*     146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 15*/ GIMT_Encode4(156603),
     /*     150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 16*/ GIMT_Encode4(156801),
     /*     154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 17*/ GIMT_Encode4(157381),
     /*     158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 18*/ GIMT_Encode4(157591),
     /*     162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 19*/ GIMT_Encode4(157789),
     /*     166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 20*/ GIMT_Encode4(157828),
     /*     170 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(157867),
     /*     174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(166845),
     /*     178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(167959), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     194 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(168593), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 25*/ GIMT_Encode4(175493),
     /*     210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 26*/ GIMT_Encode4(180379),
     /*     214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 27*/ GIMT_Encode4(183289), GIMT_Encode4(0),
     /*     222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 28*/ GIMT_Encode4(186199),
     /*     226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 29*/ GIMT_Encode4(189109),
     /*     230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 30*/ GIMT_Encode4(190021),
     /*     234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 31*/ GIMT_Encode4(192931),
     /*     238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 32*/ GIMT_Encode4(195841),
     /*     242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 33*/ GIMT_Encode4(198751),
     /*     246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 34*/ GIMT_Encode4(201661),
     /*     250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 35*/ GIMT_Encode4(204571), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(207481), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(207699),
     /*     318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(2205992), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(2207560), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     354 */ /*TargetOpcode::G_SEXT*//*Label 40*/ GIMT_Encode4(2210681),
     /*     358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 41*/ GIMT_Encode4(2214156),
     /*     362 */ /*TargetOpcode::G_ZEXT*//*Label 42*/ GIMT_Encode4(2215199),
     /*     366 */ /*TargetOpcode::G_SHL*//*Label 43*/ GIMT_Encode4(2218886),
     /*     370 */ /*TargetOpcode::G_LSHR*//*Label 44*/ GIMT_Encode4(2227482),
     /*     374 */ /*TargetOpcode::G_ASHR*//*Label 45*/ GIMT_Encode4(2230513), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     386 */ /*TargetOpcode::G_ROTR*//*Label 46*/ GIMT_Encode4(2233452),
     /*     390 */ /*TargetOpcode::G_ROTL*//*Label 47*/ GIMT_Encode4(2236392),
     /*     394 */ /*TargetOpcode::G_ICMP*//*Label 48*/ GIMT_Encode4(2239302),
     /*     398 */ /*TargetOpcode::G_FCMP*//*Label 49*/ GIMT_Encode4(2265965), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     410 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(2273427), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     454 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(2279147),
     /*     458 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(2281881),
     /*     462 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(2284615),
     /*     466 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(2287468),
     /*     470 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(2290321),
     /*     474 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(2293174),
     /*     478 */ /*TargetOpcode::G_USHLSAT*//*Label 57*/ GIMT_Encode4(2296027),
     /*     482 */ /*TargetOpcode::G_SSHLSAT*//*Label 58*/ GIMT_Encode4(2296085), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(2296143),
     /*     522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(2298571),
     /*     526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(2300999),
     /*     530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(2303427), GIMT_Encode4(0),
     /*     538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(2320072), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(2322500),
     /*     590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(2324471),
     /*     594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(2324924),
     /*     598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(2326460),
     /*     602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(2331346),
     /*     606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(2336232),
     /*     610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(2341518), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     622 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(2346804),
     /*     626 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 72*/ GIMT_Encode4(2348775), GIMT_Encode4(0),
     /*     634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 73*/ GIMT_Encode4(2354837),
     /*     638 */ /*TargetOpcode::G_FMINNUM*//*Label 74*/ GIMT_Encode4(2355027),
     /*     642 */ /*TargetOpcode::G_FMAXNUM*//*Label 75*/ GIMT_Encode4(2357112), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     654 */ /*TargetOpcode::G_FMINIMUM*//*Label 76*/ GIMT_Encode4(2359197),
     /*     658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 77*/ GIMT_Encode4(2359323),
     /*     662 */ /*TargetOpcode::G_FMINIMUMNUM*//*Label 78*/ GIMT_Encode4(2359449),
     /*     666 */ /*TargetOpcode::G_FMAXIMUMNUM*//*Label 79*/ GIMT_Encode4(2361534), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     702 */ /*TargetOpcode::G_SMIN*//*Label 80*/ GIMT_Encode4(2363619),
     /*     706 */ /*TargetOpcode::G_SMAX*//*Label 81*/ GIMT_Encode4(2366395),
     /*     710 */ /*TargetOpcode::G_UMIN*//*Label 82*/ GIMT_Encode4(2369171),
     /*     714 */ /*TargetOpcode::G_UMAX*//*Label 83*/ GIMT_Encode4(2371947),
     /*     718 */ /*TargetOpcode::G_ABS*//*Label 84*/ GIMT_Encode4(2374723),
     /*     722 */ /*TargetOpcode::G_LROUND*//*Label 85*/ GIMT_Encode4(2374881),
     /*     726 */ /*TargetOpcode::G_LLROUND*//*Label 86*/ GIMT_Encode4(2375461),
     /*     730 */ /*TargetOpcode::G_BR*//*Label 87*/ GIMT_Encode4(2375671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     774 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(2375687), GIMT_Encode4(0),
     /*     782 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(2378315), GIMT_Encode4(0),
     /*     790 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(2381085),
     /*     794 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(2383636),
     /*     798 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(2386171),
     /*     802 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(2388717), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     850 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(2388915),
     /*     854 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(2391091),
     /*     858 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(2391289),
     /*     862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(2391487), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(2391685),
     /*     894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(2394113),
     /*     898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(2396541),
     /*     902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(2398969), GIMT_Encode4(0),
     /*     910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(2401397),
     /*     914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(2418042), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     950 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(2420218),
     /*     954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(2420231), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    1050 */ /*RISCV::G_CLZW*//*Label 106*/ GIMT_Encode4(2420244),
     /*    1054 */ /*RISCV::G_CTZW*//*Label 107*/ GIMT_Encode4(2420339),
     /*    1058 */ /*RISCV::G_DIVUW*//*Label 108*/ GIMT_Encode4(2420369),
     /*    1062 */ /*RISCV::G_DIVW*//*Label 109*/ GIMT_Encode4(2420406),
     /*    1066 */ /*RISCV::G_FCLASS*//*Label 110*/ GIMT_Encode4(2420443),
     /*    1070 */ /*RISCV::G_FCVT_WU_RV64*//*Label 111*/ GIMT_Encode4(2420803),
     /*    1074 */ /*RISCV::G_FCVT_W_RV64*//*Label 112*/ GIMT_Encode4(2421001),
     /*    1078 */ /*RISCV::G_READ_VLENB*//*Label 113*/ GIMT_Encode4(2421199),
     /*    1082 */ /*RISCV::G_REMUW*//*Label 114*/ GIMT_Encode4(2421259),
     /*    1086 */ /*RISCV::G_ROLW*//*Label 115*/ GIMT_Encode4(2421296),
     /*    1090 */ /*RISCV::G_RORW*//*Label 116*/ GIMT_Encode4(2421421),
     /*    1094 */ /*RISCV::G_SLLW*//*Label 117*/ GIMT_Encode4(2421542), GIMT_Encode4(0),
     /*    1102 */ /*RISCV::G_SRAW*//*Label 118*/ GIMT_Encode4(2421589),
     /*    1106 */ /*RISCV::G_SRLW*//*Label 119*/ GIMT_Encode4(2421636),
     /*    1110 */ /*RISCV::G_VMCLR_VL*//*Label 120*/ GIMT_Encode4(2421683),
     /*    1114 */ /*RISCV::G_VMSET_VL*//*Label 121*/ GIMT_Encode4(2422332),
     /*    1118 */ /*RISCV::G_VMV_V_V_VL*//*Label 122*/ GIMT_Encode4(2422981),
     /*    1122 */ /*RISCV::G_VSLIDEDOWN_VL*//*Label 123*/ GIMT_Encode4(2427239),
     /*    1126 */ /*RISCV::G_VSLIDEUP_VL*//*Label 124*/ GIMT_Encode4(2439119),
     /*    1130 */ // Label 0: @1130
     /*    1130 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 150*/ GIMT_Encode4(61070),
     /*    1141 */ /*GILLT_s32*//*Label 126*/ GIMT_Encode4(1265),
     /*    1145 */ /*GILLT_s64*//*Label 127*/ GIMT_Encode4(3530), GIMT_Encode4(0),
     /*    1153 */ /*GILLT_nxv1s8*//*Label 128*/ GIMT_Encode4(11430),
     /*    1157 */ /*GILLT_nxv1s16*//*Label 129*/ GIMT_Encode4(11825),
     /*    1161 */ /*GILLT_nxv1s32*//*Label 130*/ GIMT_Encode4(14950),
     /*    1165 */ /*GILLT_nxv1s64*//*Label 131*/ GIMT_Encode4(18075), GIMT_Encode4(0),
     /*    1173 */ /*GILLT_nxv2s8*//*Label 132*/ GIMT_Encode4(21200),
     /*    1177 */ /*GILLT_nxv2s16*//*Label 133*/ GIMT_Encode4(21595),
     /*    1181 */ /*GILLT_nxv2s32*//*Label 134*/ GIMT_Encode4(24720),
     /*    1185 */ /*GILLT_nxv2s64*//*Label 135*/ GIMT_Encode4(27845), GIMT_Encode4(0),
     /*    1193 */ /*GILLT_nxv4s8*//*Label 136*/ GIMT_Encode4(30970),
     /*    1197 */ /*GILLT_nxv4s16*//*Label 137*/ GIMT_Encode4(31365),
     /*    1201 */ /*GILLT_nxv4s32*//*Label 138*/ GIMT_Encode4(34490),
     /*    1205 */ /*GILLT_nxv4s64*//*Label 139*/ GIMT_Encode4(37615), GIMT_Encode4(0),
     /*    1213 */ /*GILLT_nxv8s8*//*Label 140*/ GIMT_Encode4(40740),
     /*    1217 */ /*GILLT_nxv8s16*//*Label 141*/ GIMT_Encode4(41135),
     /*    1221 */ /*GILLT_nxv8s32*//*Label 142*/ GIMT_Encode4(44260),
     /*    1225 */ /*GILLT_nxv8s64*//*Label 143*/ GIMT_Encode4(47385), GIMT_Encode4(0),
     /*    1233 */ /*GILLT_nxv16s8*//*Label 144*/ GIMT_Encode4(50510),
     /*    1237 */ /*GILLT_nxv16s16*//*Label 145*/ GIMT_Encode4(50905),
     /*    1241 */ /*GILLT_nxv16s32*//*Label 146*/ GIMT_Encode4(54030), GIMT_Encode4(0),
     /*    1249 */ /*GILLT_nxv32s8*//*Label 147*/ GIMT_Encode4(57155),
     /*    1253 */ /*GILLT_nxv32s16*//*Label 148*/ GIMT_Encode4(57550), GIMT_Encode4(0),
     /*    1261 */ /*GILLT_nxv64s8*//*Label 149*/ GIMT_Encode4(60675),
     /*    1265 */ // Label 126: @1265
     /*    1265 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3529),
     /*    1270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*    1273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*    1276 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(1324), // Rule ID 2566 //
     /*    1281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1288 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    1292 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    1296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1311 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:2:x, GPR:{ *:[i32] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1322 */     GIR_RootConstrainSelectedInstOperands,
     /*    1323 */     // GIR_Coverage, 2566,
     /*    1323 */     GIR_EraseRootFromParent_Done,
     /*    1324 */   // Label 152: @1324
     /*    1324 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(1372), // Rule ID 2576 //
     /*    1329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1336 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    1340 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    1344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1359 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:4:x, GPR:{ *:[i32] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1370 */     GIR_RootConstrainSelectedInstOperands,
     /*    1371 */     // GIR_Coverage, 2576,
     /*    1371 */     GIR_EraseRootFromParent_Done,
     /*    1372 */   // Label 153: @1372
     /*    1372 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(1420), // Rule ID 2586 //
     /*    1377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1384 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    1388 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    1392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1407 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:6:x, GPR:{ *:[i32] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1418 */     GIR_RootConstrainSelectedInstOperands,
     /*    1419 */     // GIR_Coverage, 2586,
     /*    1419 */     GIR_EraseRootFromParent_Done,
     /*    1420 */   // Label 154: @1420
     /*    1420 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(1471), // Rule ID 62532 //
     /*    1425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1432 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    1436 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    1440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1455 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs2:$pred:24:x, GPR:{ *:[i32] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1469 */     GIR_RootConstrainSelectedInstOperands,
     /*    1470 */     // GIR_Coverage, 62532,
     /*    1470 */     GIR_EraseRootFromParent_Done,
     /*    1471 */   // Label 155: @1471
     /*    1471 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(1522), // Rule ID 62536 //
     /*    1476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1483 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    1487 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    1491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1506 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs2:$pred:25:x, GPR:{ *:[i32] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1520 */     GIR_RootConstrainSelectedInstOperands,
     /*    1521 */     // GIR_Coverage, 62536,
     /*    1521 */     GIR_EraseRootFromParent_Done,
     /*    1522 */   // Label 156: @1522
     /*    1522 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(1573), // Rule ID 62540 //
     /*    1527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1534 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    1538 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    1542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1557 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs2:$pred:26:x, GPR:{ *:[i32] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1571 */     GIR_RootConstrainSelectedInstOperands,
     /*    1572 */     // GIR_Coverage, 62540,
     /*    1572 */     GIR_EraseRootFromParent_Done,
     /*    1573 */   // Label 157: @1573
     /*    1573 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(1621), // Rule ID 65036 //
     /*    1578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1585 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    1589 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    1593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1608 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:28:x, GPR:{ *:[i32] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    1611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1619 */     GIR_RootConstrainSelectedInstOperands,
     /*    1620 */     // GIR_Coverage, 65036,
     /*    1620 */     GIR_EraseRootFromParent_Done,
     /*    1621 */   // Label 158: @1621
     /*    1621 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(1669), // Rule ID 65046 //
     /*    1626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1633 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    1637 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    1641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1656 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:30:x, GPR:{ *:[i32] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    1659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1667 */     GIR_RootConstrainSelectedInstOperands,
     /*    1668 */     // GIR_Coverage, 65046,
     /*    1668 */     GIR_EraseRootFromParent_Done,
     /*    1669 */   // Label 159: @1669
     /*    1669 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(1717), // Rule ID 65056 //
     /*    1674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    1677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1681 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    1685 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    1689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1704 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:32:x, GPR:{ *:[i32] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    1707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1715 */     GIR_RootConstrainSelectedInstOperands,
     /*    1716 */     // GIR_Coverage, 65056,
     /*    1716 */     GIR_EraseRootFromParent_Done,
     /*    1717 */   // Label 160: @1717
     /*    1717 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(1765), // Rule ID 65515 //
     /*    1722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1729 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    1733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1737 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    1741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1752 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:2:y, sh1add_op:{ *:[i32] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1763 */     GIR_RootConstrainSelectedInstOperands,
     /*    1764 */     // GIR_Coverage, 65515,
     /*    1764 */     GIR_EraseRootFromParent_Done,
     /*    1765 */   // Label 161: @1765
     /*    1765 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(1813), // Rule ID 65523 //
     /*    1770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1777 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    1781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1785 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    1789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1800 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:4:y, sh2add_op:{ *:[i32] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1811 */     GIR_RootConstrainSelectedInstOperands,
     /*    1812 */     // GIR_Coverage, 65523,
     /*    1812 */     GIR_EraseRootFromParent_Done,
     /*    1813 */   // Label 162: @1813
     /*    1813 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(1861), // Rule ID 65531 //
     /*    1818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1825 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    1829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1833 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    1837 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1848 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:6:y, sh3add_op:{ *:[i32] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1859 */     GIR_RootConstrainSelectedInstOperands,
     /*    1860 */     // GIR_Coverage, 65531,
     /*    1860 */     GIR_EraseRootFromParent_Done,
     /*    1861 */   // Label 163: @1861
     /*    1861 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(1912), // Rule ID 74349 //
     /*    1866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1873 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    1877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1881 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    1885 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1896 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:24:y, sh1add_op:{ *:[i32] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1910 */     GIR_RootConstrainSelectedInstOperands,
     /*    1911 */     // GIR_Coverage, 74349,
     /*    1911 */     GIR_EraseRootFromParent_Done,
     /*    1912 */   // Label 164: @1912
     /*    1912 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(1963), // Rule ID 74353 //
     /*    1917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1924 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    1928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1932 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    1936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1947 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:25:y, sh2add_op:{ *:[i32] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1954 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1961 */     GIR_RootConstrainSelectedInstOperands,
     /*    1962 */     // GIR_Coverage, 74353,
     /*    1962 */     GIR_EraseRootFromParent_Done,
     /*    1963 */   // Label 165: @1963
     /*    1963 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2014), // Rule ID 74357 //
     /*    1968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1975 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    1979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1983 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    1987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1998 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:26:y, sh3add_op:{ *:[i32] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    2009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    2012 */     GIR_RootConstrainSelectedInstOperands,
     /*    2013 */     // GIR_Coverage, 74357,
     /*    2013 */     GIR_EraseRootFromParent_Done,
     /*    2014 */   // Label 166: @2014
     /*    2014 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2062), // Rule ID 74370 //
     /*    2019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2026 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    2030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2034 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    2038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    2049 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:28:y, sh1add_op:{ *:[i32] }:$rs1:$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2060 */     GIR_RootConstrainSelectedInstOperands,
     /*    2061 */     // GIR_Coverage, 74370,
     /*    2061 */     GIR_EraseRootFromParent_Done,
     /*    2062 */   // Label 167: @2062
     /*    2062 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2110), // Rule ID 74378 //
     /*    2067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2074 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    2078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2082 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    2086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    2097 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:30:y, sh2add_op:{ *:[i32] }:$rs1:$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2108 */     GIR_RootConstrainSelectedInstOperands,
     /*    2109 */     // GIR_Coverage, 74378,
     /*    2109 */     GIR_EraseRootFromParent_Done,
     /*    2110 */   // Label 168: @2110
     /*    2110 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2158), // Rule ID 74386 //
     /*    2115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2122 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    2126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2130 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    2134 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    2145 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:32:y, sh3add_op:{ *:[i32] }:$rs1:$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    2154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2156 */     GIR_RootConstrainSelectedInstOperands,
     /*    2157 */     // GIR_Coverage, 74386,
     /*    2157 */     GIR_EraseRootFromParent_Done,
     /*    2158 */   // Label 169: @2158
     /*    2158 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2226), // Rule ID 2560 //
     /*    2163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2170 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    2174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2195 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2199 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    2203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2207 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2213 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x, GPR:{ *:[i32] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2224 */     GIR_RootConstrainSelectedInstOperands,
     /*    2225 */     // GIR_Coverage, 2560,
     /*    2225 */     GIR_EraseRootFromParent_Done,
     /*    2226 */   // Label 170: @2226
     /*    2226 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2294), // Rule ID 2570 //
     /*    2231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2238 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    2242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2263 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2267 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    2271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2275 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2281 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x, GPR:{ *:[i32] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2292 */     GIR_RootConstrainSelectedInstOperands,
     /*    2293 */     // GIR_Coverage, 2570,
     /*    2293 */     GIR_EraseRootFromParent_Done,
     /*    2294 */   // Label 171: @2294
     /*    2294 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2362), // Rule ID 2580 //
     /*    2299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2306 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    2310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2335 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    2339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2343 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2349 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x, GPR:{ *:[i32] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2360 */     GIR_RootConstrainSelectedInstOperands,
     /*    2361 */     // GIR_Coverage, 2580,
     /*    2361 */     GIR_EraseRootFromParent_Done,
     /*    2362 */   // Label 172: @2362
     /*    2362 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2430), // Rule ID 65030 //
     /*    2367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2374 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    2378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2399 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2403 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    2407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2411 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2417 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:27:x, GPR:{ *:[i32] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2428 */     GIR_RootConstrainSelectedInstOperands,
     /*    2429 */     // GIR_Coverage, 65030,
     /*    2429 */     GIR_EraseRootFromParent_Done,
     /*    2430 */   // Label 173: @2430
     /*    2430 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2498), // Rule ID 65040 //
     /*    2435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2442 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    2446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2467 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2471 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    2475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2479 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2485 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:29:x, GPR:{ *:[i32] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2496 */     GIR_RootConstrainSelectedInstOperands,
     /*    2497 */     // GIR_Coverage, 65040,
     /*    2497 */     GIR_EraseRootFromParent_Done,
     /*    2498 */   // Label 174: @2498
     /*    2498 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2566), // Rule ID 65050 //
     /*    2503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2510 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    2514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2535 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2539 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    2543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2553 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:31:x, GPR:{ *:[i32] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2564 */     GIR_RootConstrainSelectedInstOperands,
     /*    2565 */     // GIR_Coverage, 65050,
     /*    2565 */     GIR_EraseRootFromParent_Done,
     /*    2566 */   // Label 175: @2566
     /*    2566 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2634), // Rule ID 65511 //
     /*    2571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2578 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    2582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2586 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    2590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2611 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2621 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:1:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2632 */     GIR_RootConstrainSelectedInstOperands,
     /*    2633 */     // GIR_Coverage, 65511,
     /*    2633 */     GIR_EraseRootFromParent_Done,
     /*    2634 */   // Label 176: @2634
     /*    2634 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2702), // Rule ID 65519 //
     /*    2639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2646 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    2650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2654 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    2658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2689 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:3:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2700 */     GIR_RootConstrainSelectedInstOperands,
     /*    2701 */     // GIR_Coverage, 65519,
     /*    2701 */     GIR_EraseRootFromParent_Done,
     /*    2702 */   // Label 177: @2702
     /*    2702 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2770), // Rule ID 65527 //
     /*    2707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2714 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    2718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2722 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    2726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2747 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2751 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2757 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:5:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2768 */     GIR_RootConstrainSelectedInstOperands,
     /*    2769 */     // GIR_Coverage, 65527,
     /*    2769 */     GIR_EraseRootFromParent_Done,
     /*    2770 */   // Label 178: @2770
     /*    2770 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2838), // Rule ID 74366 //
     /*    2775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2782 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*    2786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2790 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*    2794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2815 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2819 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2825 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:27:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    2828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2836 */     GIR_RootConstrainSelectedInstOperands,
     /*    2837 */     // GIR_Coverage, 74366,
     /*    2837 */     GIR_EraseRootFromParent_Done,
     /*    2838 */   // Label 179: @2838
     /*    2838 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2906), // Rule ID 74374 //
     /*    2843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2850 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*    2854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2858 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*    2862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2883 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2893 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:29:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    2896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2904 */     GIR_RootConstrainSelectedInstOperands,
     /*    2905 */     // GIR_Coverage, 74374,
     /*    2905 */     GIR_EraseRootFromParent_Done,
     /*    2906 */   // Label 180: @2906
     /*    2906 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2974), // Rule ID 74382 //
     /*    2911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /*    2914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2918 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*    2922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2926 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*    2930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2951 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2961 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:31:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    2964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2972 */     GIR_RootConstrainSelectedInstOperands,
     /*    2973 */     // GIR_Coverage, 74382,
     /*    2973 */     GIR_EraseRootFromParent_Done,
     /*    2974 */   // Label 181: @2974
     /*    2974 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3053), // Rule ID 62526 //
     /*    2979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    2982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2986 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    2990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3019 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3023 */     // MIs[2] Operand 1
     /*    3023 */     // No operand predicates
     /*    3023 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    3027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3037 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i32] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    3044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3051 */     GIR_RootConstrainSelectedInstOperands,
     /*    3052 */     // GIR_Coverage, 62526,
     /*    3052 */     GIR_EraseRootFromParent_Done,
     /*    3053 */   // Label 182: @3053
     /*    3053 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3132), // Rule ID 74345 //
     /*    3058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    3061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3065 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    3069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3073 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    3077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    3102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3106 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    3110 */     // MIs[2] Operand 1
     /*    3110 */     // No operand predicates
     /*    3110 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3116 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:23:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    3116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    3119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    3127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    3130 */     GIR_RootConstrainSelectedInstOperands,
     /*    3131 */     // GIR_Coverage, 74345,
     /*    3131 */     GIR_EraseRootFromParent_Done,
     /*    3132 */   // Label 183: @3132
     /*    3132 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3181), // Rule ID 121 //
     /*    3137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    3152 */     // MIs[1] Operand 1
     /*    3152 */     // No operand predicates
     /*    3152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    3156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3164 */     // MIs[2] Operand 1
     /*    3164 */     // No operand predicates
     /*    3164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3166 */     // (add:{ *:[i32] } (frameindex:{ *:[i32] }):$fi, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i32] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i32] }:$fi), (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)
     /*    3166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3171 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    3176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    3179 */     GIR_RootConstrainSelectedInstOperands,
     /*    3180 */     // GIR_Coverage, 121,
     /*    3180 */     GIR_EraseRootFromParent_Done,
     /*    3181 */   // Label 184: @3181
     /*    3181 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3223), // Rule ID 81 //
     /*    3186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    3209 */     // MIs[1] Operand 1
     /*    3209 */     // No operand predicates
     /*    3209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3211 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*    3211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3221 */     GIR_RootConstrainSelectedInstOperands,
     /*    3222 */     // GIR_Coverage, 81,
     /*    3222 */     GIR_EraseRootFromParent_Done,
     /*    3223 */   // Label 185: @3223
     /*    3223 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3295), // Rule ID 292 //
     /*    3228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    3251 */     // MIs[1] Operand 1
     /*    3251 */     // No operand predicates
     /*    3251 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10053),
     /*    3255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3257 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10053>>:$rs2)  =>  (ADDI:{ *:[i32] } (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (AddiPairImmLarge:{ *:[i32] } (imm:{ *:[i32] }):$rs2)), (AddiPairImmSmall:{ *:[i32] } (imm:{ *:[i32] }):$rs2))
     /*    3257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*    3260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    3269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    3273 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    3278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    3280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    3283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    3288 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    3293 */     GIR_RootConstrainSelectedInstOperands,
     /*    3294 */     // GIR_Coverage, 292,
     /*    3294 */     GIR_EraseRootFromParent_Done,
     /*    3295 */   // Label 186: @3295
     /*    3295 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3337), // Rule ID 64524 //
     /*    3300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*    3323 */     // MIs[1] Operand 1
     /*    3323 */     // No operand predicates
     /*    3323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3325 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ADDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*    3325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDAI),
     /*    3328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3335 */     GIR_RootConstrainSelectedInstOperands,
     /*    3336 */     // GIR_Coverage, 64524,
     /*    3336 */     GIR_EraseRootFromParent_Done,
     /*    3337 */   // Label 187: @3337
     /*    3337 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3379), // Rule ID 64528 //
     /*    3342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    3345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    3353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    3361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*    3365 */     // MIs[1] Operand 1
     /*    3365 */     // No operand predicates
     /*    3365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3367 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ADDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*    3367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDI),
     /*    3370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    3374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    3377 */     GIR_RootConstrainSelectedInstOperands,
     /*    3378 */     // GIR_Coverage, 64528,
     /*    3378 */     GIR_EraseRootFromParent_Done,
     /*    3379 */   // Label 188: @3379
     /*    3379 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3440), // Rule ID 74359 //
     /*    3384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3423 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rd)  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    3430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3438 */     GIR_RootConstrainSelectedInstOperands,
     /*    3439 */     // GIR_Coverage, 74359,
     /*    3439 */     GIR_EraseRootFromParent_Done,
     /*    3440 */   // Label 189: @3440
     /*    3440 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(3501), // Rule ID 62593 //
     /*    3445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    3448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    3464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    3468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    3472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    3484 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    3487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    3489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    3491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    3495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    3499 */     GIR_RootConstrainSelectedInstOperands,
     /*    3500 */     // GIR_Coverage, 62593,
     /*    3500 */     GIR_EraseRootFromParent_Done,
     /*    3501 */   // Label 190: @3501
     /*    3501 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3528), // Rule ID 79 //
     /*    3506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    3509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3521 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    3521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    3526 */     GIR_RootConstrainSelectedInstOperands,
     /*    3527 */     // GIR_Coverage, 79,
     /*    3527 */     GIR_Done,
     /*    3528 */   // Label 191: @3528
     /*    3528 */   GIM_Reject,
     /*    3529 */ // Label 151: @3529
     /*    3529 */ GIM_Reject,
     /*    3530 */ // Label 127: @3530
     /*    3530 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(11429),
     /*    3535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*    3538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*    3541 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(3636), // Rule ID 2606 //
     /*    3546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3553 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*    3557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3594 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3598 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3609 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*    3613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3623 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x, GPR:{ *:[i64] }:$rs2:$pred:10:y)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3634 */     GIR_RootConstrainSelectedInstOperands,
     /*    3635 */     // GIR_Coverage, 2606,
     /*    3635 */     GIR_EraseRootFromParent_Done,
     /*    3636 */   // Label 193: @3636
     /*    3636 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(3731), // Rule ID 2610 //
     /*    3641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3648 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:12:x
     /*    3652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3689 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3693 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3704 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:12:y
     /*    3708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3712 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3718 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x, GPR:{ *:[i64] }:$rs2:$pred:12:y)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3729 */     GIR_RootConstrainSelectedInstOperands,
     /*    3730 */     // GIR_Coverage, 2610,
     /*    3730 */     GIR_EraseRootFromParent_Done,
     /*    3731 */   // Label 194: @3731
     /*    3731 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3826), // Rule ID 65086 //
     /*    3736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    3739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3743 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:40:x
     /*    3747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3775 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3784 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3788 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3799 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:40:y
     /*    3803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3807 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3813 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:40:x, GPR:{ *:[i64] }:$rs2:$pred:40:y)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    3816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3824 */     GIR_RootConstrainSelectedInstOperands,
     /*    3825 */     // GIR_Coverage, 65086,
     /*    3825 */     GIR_EraseRootFromParent_Done,
     /*    3826 */   // Label 195: @3826
     /*    3826 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3921), // Rule ID 65090 //
     /*    3831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    3834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3838 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:42:x
     /*    3842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3879 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3883 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3894 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:42:y
     /*    3898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3902 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3908 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:42:x, GPR:{ *:[i64] }:$rs2:$pred:42:y)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    3911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3919 */     GIR_RootConstrainSelectedInstOperands,
     /*    3920 */     // GIR_Coverage, 65090,
     /*    3920 */     GIR_EraseRootFromParent_Done,
     /*    3921 */   // Label 196: @3921
     /*    3921 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(4016), // Rule ID 2601 //
     /*    3926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3933 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*    3937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3974 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3985 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    3989 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*    3993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3997 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4003 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x, GPR:{ *:[i64] }:$rs2:$pred:8:y)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4014 */     GIR_RootConstrainSelectedInstOperands,
     /*    4015 */     // GIR_Coverage, 2601,
     /*    4015 */     GIR_EraseRootFromParent_Done,
     /*    4016 */   // Label 197: @4016
     /*    4016 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(4111), // Rule ID 2620 //
     /*    4021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4028 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*    4032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4069 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4084 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*    4088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4092 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4098 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x, GPR:{ *:[i64] }:$rs2:$pred:16:y)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4109 */     GIR_RootConstrainSelectedInstOperands,
     /*    4110 */     // GIR_Coverage, 2620,
     /*    4110 */     GIR_EraseRootFromParent_Done,
     /*    4111 */   // Label 198: @4111
     /*    4111 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4206), // Rule ID 2625 //
     /*    4116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4123 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:18:x
     /*    4127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4164 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4175 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4179 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:18:y
     /*    4183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4193 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x, GPR:{ *:[i64] }:$rs2:$pred:18:y)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4204 */     GIR_RootConstrainSelectedInstOperands,
     /*    4205 */     // GIR_Coverage, 2625,
     /*    4205 */     GIR_EraseRootFromParent_Done,
     /*    4206 */   // Label 199: @4206
     /*    4206 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4301), // Rule ID 65071 //
     /*    4211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4218 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:34:x
     /*    4222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4259 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4270 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4274 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:34:y
     /*    4278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4282 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4288 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:34:x, GPR:{ *:[i64] }:$rs2:$pred:34:y)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4299 */     GIR_RootConstrainSelectedInstOperands,
     /*    4300 */     // GIR_Coverage, 65071,
     /*    4300 */     GIR_EraseRootFromParent_Done,
     /*    4301 */   // Label 200: @4301
     /*    4301 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4396), // Rule ID 65076 //
     /*    4306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4313 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:36:x
     /*    4317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4345 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4354 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4365 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    4369 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:36:y
     /*    4373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4377 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4383 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:36:x, GPR:{ *:[i64] }:$rs2:$pred:36:y)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4394 */     GIR_RootConstrainSelectedInstOperands,
     /*    4395 */     // GIR_Coverage, 65076,
     /*    4395 */     GIR_EraseRootFromParent_Done,
     /*    4396 */   // Label 201: @4396
     /*    4396 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4491), // Rule ID 65081 //
     /*    4401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4408 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:38:x
     /*    4412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4449 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4460 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    4464 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:38:y
     /*    4468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4472 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4478 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:38:x, GPR:{ *:[i64] }:$rs2:$pred:38:y)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    4481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4489 */     GIR_RootConstrainSelectedInstOperands,
     /*    4490 */     // GIR_Coverage, 65081,
     /*    4490 */     GIR_EraseRootFromParent_Done,
     /*    4491 */   // Label 202: @4491
     /*    4491 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4586), // Rule ID 65541 //
     /*    4496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4503 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:10:y
     /*    4507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4511 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:10:x
     /*    4515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4552 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4556 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4567 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4573 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:10:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:10:x)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4584 */     GIR_RootConstrainSelectedInstOperands,
     /*    4585 */     // GIR_Coverage, 65541,
     /*    4585 */     GIR_EraseRootFromParent_Done,
     /*    4586 */   // Label 203: @4586
     /*    4586 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4681), // Rule ID 65545 //
     /*    4591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4598 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:12:y
     /*    4602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4606 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:12:x
     /*    4610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4647 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4651 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4662 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4668 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:12:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4679 */     GIR_RootConstrainSelectedInstOperands,
     /*    4680 */     // GIR_Coverage, 65545,
     /*    4680 */     GIR_EraseRootFromParent_Done,
     /*    4681 */   // Label 204: @4681
     /*    4681 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4776), // Rule ID 74404 //
     /*    4686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4693 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:40:y
     /*    4697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4701 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:40:x
     /*    4705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4742 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    4746 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    4757 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4763 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:40:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:40:x)<<P:40:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    4766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4774 */     GIR_RootConstrainSelectedInstOperands,
     /*    4775 */     // GIR_Coverage, 74404,
     /*    4775 */     GIR_EraseRootFromParent_Done,
     /*    4776 */   // Label 205: @4776
     /*    4776 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4871), // Rule ID 74408 //
     /*    4781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    4784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4788 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:42:y
     /*    4792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4796 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:42:x
     /*    4800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4837 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    4841 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    4852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4858 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:42:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:42:x)<<P:42:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    4861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4869 */     GIR_RootConstrainSelectedInstOperands,
     /*    4870 */     // GIR_Coverage, 74408,
     /*    4870 */     GIR_EraseRootFromParent_Done,
     /*    4871 */   // Label 206: @4871
     /*    4871 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(4966), // Rule ID 65537 //
     /*    4876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4883 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:8:y
     /*    4887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4891 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:8:x
     /*    4895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    4915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    4923 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    4927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4932 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4943 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    4947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    4953 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:8:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    4962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4964 */     GIR_RootConstrainSelectedInstOperands,
     /*    4965 */     // GIR_Coverage, 65537,
     /*    4965 */     GIR_EraseRootFromParent_Done,
     /*    4966 */   // Label 207: @4966
     /*    4966 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(5061), // Rule ID 65553 //
     /*    4971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4978 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:16:y
     /*    4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4986 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:16:x
     /*    4990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    4994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    4998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5027 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5038 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5042 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5048 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:16:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:16:x)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5059 */     GIR_RootConstrainSelectedInstOperands,
     /*    5060 */     // GIR_Coverage, 65553,
     /*    5060 */     GIR_EraseRootFromParent_Done,
     /*    5061 */   // Label 208: @5061
     /*    5061 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(5156), // Rule ID 65557 //
     /*    5066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5073 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:18:y
     /*    5077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5081 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:18:x
     /*    5085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5122 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5133 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5137 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5143 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:18:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:18:x)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5154 */     GIR_RootConstrainSelectedInstOperands,
     /*    5155 */     // GIR_Coverage, 65557,
     /*    5155 */     GIR_EraseRootFromParent_Done,
     /*    5156 */   // Label 209: @5156
     /*    5156 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(5251), // Rule ID 74392 //
     /*    5161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5168 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:34:y
     /*    5172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5176 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:34:x
     /*    5180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5208 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5217 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5228 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5232 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5238 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:34:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:34:x)<<P:34:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    5241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5249 */     GIR_RootConstrainSelectedInstOperands,
     /*    5250 */     // GIR_Coverage, 74392,
     /*    5250 */     GIR_EraseRootFromParent_Done,
     /*    5251 */   // Label 210: @5251
     /*    5251 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(5346), // Rule ID 74396 //
     /*    5256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5263 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:36:y
     /*    5267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5271 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:36:x
     /*    5275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5303 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5312 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5323 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5327 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5333 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:36:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:36:x)<<P:36:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    5336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5344 */     GIR_RootConstrainSelectedInstOperands,
     /*    5345 */     // GIR_Coverage, 74396,
     /*    5345 */     GIR_EraseRootFromParent_Done,
     /*    5346 */   // Label 211: @5346
     /*    5346 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(5441), // Rule ID 74400 //
     /*    5351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    5354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5358 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:38:y
     /*    5362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5366 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:38:x
     /*    5370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    5390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    5398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    5402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5407 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5418 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5422 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    5428 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:38:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:38:x)<<P:38:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    5431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    5437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5439 */     GIR_RootConstrainSelectedInstOperands,
     /*    5440 */     // GIR_Coverage, 74400,
     /*    5440 */     GIR_EraseRootFromParent_Done,
     /*    5441 */   // Label 212: @5441
     /*    5441 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5489), // Rule ID 2565 //
     /*    5446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5453 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    5457 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    5461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5476 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:2:x, GPR:{ *:[i64] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5481 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5487 */     GIR_RootConstrainSelectedInstOperands,
     /*    5488 */     // GIR_Coverage, 2565,
     /*    5488 */     GIR_EraseRootFromParent_Done,
     /*    5489 */   // Label 213: @5489
     /*    5489 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(5537), // Rule ID 2575 //
     /*    5494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5501 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    5505 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    5509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5524 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:4:x, GPR:{ *:[i64] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5529 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5535 */     GIR_RootConstrainSelectedInstOperands,
     /*    5536 */     // GIR_Coverage, 2575,
     /*    5536 */     GIR_EraseRootFromParent_Done,
     /*    5537 */   // Label 214: @5537
     /*    5537 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(5585), // Rule ID 2585 //
     /*    5542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5549 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    5553 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    5557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    5572 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:6:x, GPR:{ *:[i64] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    5575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5583 */     GIR_RootConstrainSelectedInstOperands,
     /*    5584 */     // GIR_Coverage, 2585,
     /*    5584 */     GIR_EraseRootFromParent_Done,
     /*    5585 */   // Label 215: @5585
     /*    5585 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5633), // Rule ID 2604 //
     /*    5590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5597 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*    5601 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*    5605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    5620 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x, GPR:{ *:[i64] }:$rs2:$pred:9:y)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5625 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5631 */     GIR_RootConstrainSelectedInstOperands,
     /*    5632 */     // GIR_Coverage, 2604,
     /*    5632 */     GIR_EraseRootFromParent_Done,
     /*    5633 */   // Label 216: @5633
     /*    5633 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5681), // Rule ID 2623 //
     /*    5638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5645 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:17:x
     /*    5649 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:17:y
     /*    5653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5657 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    5668 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x, GPR:{ *:[i64] }:$rs2:$pred:17:y)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5679 */     GIR_RootConstrainSelectedInstOperands,
     /*    5680 */     // GIR_Coverage, 2623,
     /*    5680 */     GIR_EraseRootFromParent_Done,
     /*    5681 */   // Label 217: @5681
     /*    5681 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5729), // Rule ID 2628 //
     /*    5686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5693 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:19:x
     /*    5697 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:19:y
     /*    5701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5705 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    5716 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x, GPR:{ *:[i64] }:$rs2:$pred:19:y)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5727 */     GIR_RootConstrainSelectedInstOperands,
     /*    5728 */     // GIR_Coverage, 2628,
     /*    5728 */     GIR_EraseRootFromParent_Done,
     /*    5729 */   // Label 218: @5729
     /*    5729 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(5780), // Rule ID 62531 //
     /*    5734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5741 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    5745 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    5749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5764 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs2:$pred:24:x, GPR:{ *:[i64] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    5764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    5778 */     GIR_RootConstrainSelectedInstOperands,
     /*    5779 */     // GIR_Coverage, 62531,
     /*    5779 */     GIR_EraseRootFromParent_Done,
     /*    5780 */   // Label 219: @5780
     /*    5780 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(5831), // Rule ID 62535 //
     /*    5785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5792 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    5796 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    5800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5804 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5815 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs2:$pred:25:x, GPR:{ *:[i64] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    5815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5822 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    5829 */     GIR_RootConstrainSelectedInstOperands,
     /*    5830 */     // GIR_Coverage, 62535,
     /*    5830 */     GIR_EraseRootFromParent_Done,
     /*    5831 */   // Label 220: @5831
     /*    5831 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(5882), // Rule ID 62539 //
     /*    5836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    5839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5843 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    5847 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    5851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    5866 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs2:$pred:26:x, GPR:{ *:[i64] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    5866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    5869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    5873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    5877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    5880 */     GIR_RootConstrainSelectedInstOperands,
     /*    5881 */     // GIR_Coverage, 62539,
     /*    5881 */     GIR_EraseRootFromParent_Done,
     /*    5882 */   // Label 221: @5882
     /*    5882 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(5930), // Rule ID 65035 //
     /*    5887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5894 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:28:x
     /*    5898 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:28:y
     /*    5902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5906 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    5917 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:28:x, GPR:{ *:[i64] }:$rs2:$pred:28:y)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    5920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5928 */     GIR_RootConstrainSelectedInstOperands,
     /*    5929 */     // GIR_Coverage, 65035,
     /*    5929 */     GIR_EraseRootFromParent_Done,
     /*    5930 */   // Label 222: @5930
     /*    5930 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(5978), // Rule ID 65045 //
     /*    5935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5942 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:30:x
     /*    5946 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:30:y
     /*    5950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    5965 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:30:x, GPR:{ *:[i64] }:$rs2:$pred:30:y)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    5968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    5974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5976 */     GIR_RootConstrainSelectedInstOperands,
     /*    5977 */     // GIR_Coverage, 65045,
     /*    5977 */     GIR_EraseRootFromParent_Done,
     /*    5978 */   // Label 223: @5978
     /*    5978 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6026), // Rule ID 65055 //
     /*    5983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    5986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5990 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:32:x
     /*    5994 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:32:y
     /*    5998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6002 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6013 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:32:x, GPR:{ *:[i64] }:$rs2:$pred:32:y)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6024 */     GIR_RootConstrainSelectedInstOperands,
     /*    6025 */     // GIR_Coverage, 65055,
     /*    6025 */     GIR_EraseRootFromParent_Done,
     /*    6026 */   // Label 224: @6026
     /*    6026 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6074), // Rule ID 65074 //
     /*    6031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6038 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:35:x
     /*    6042 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:35:y
     /*    6046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6050 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6061 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:35:x, GPR:{ *:[i64] }:$rs2:$pred:35:y)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6066 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6072 */     GIR_RootConstrainSelectedInstOperands,
     /*    6073 */     // GIR_Coverage, 65074,
     /*    6073 */     GIR_EraseRootFromParent_Done,
     /*    6074 */   // Label 225: @6074
     /*    6074 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6122), // Rule ID 65079 //
     /*    6079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6086 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:37:x
     /*    6090 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:37:y
     /*    6094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6098 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6109 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:37:x, GPR:{ *:[i64] }:$rs2:$pred:37:y)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6120 */     GIR_RootConstrainSelectedInstOperands,
     /*    6121 */     // GIR_Coverage, 65079,
     /*    6121 */     GIR_EraseRootFromParent_Done,
     /*    6122 */   // Label 226: @6122
     /*    6122 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6170), // Rule ID 65084 //
     /*    6127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6134 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:39:x
     /*    6138 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:39:y
     /*    6142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6157 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:39:x, GPR:{ *:[i64] }:$rs2:$pred:39:y)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6168 */     GIR_RootConstrainSelectedInstOperands,
     /*    6169 */     // GIR_Coverage, 65084,
     /*    6169 */     GIR_EraseRootFromParent_Done,
     /*    6170 */   // Label 227: @6170
     /*    6170 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6218), // Rule ID 65514 //
     /*    6175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6182 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    6186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6190 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    6194 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6205 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:2:y, sh1add_op:{ *:[i64] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    6208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6216 */     GIR_RootConstrainSelectedInstOperands,
     /*    6217 */     // GIR_Coverage, 65514,
     /*    6217 */     GIR_EraseRootFromParent_Done,
     /*    6218 */   // Label 228: @6218
     /*    6218 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6266), // Rule ID 65522 //
     /*    6223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6230 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    6234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6238 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    6242 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6253 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:4:y, sh2add_op:{ *:[i64] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    6256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6264 */     GIR_RootConstrainSelectedInstOperands,
     /*    6265 */     // GIR_Coverage, 65522,
     /*    6265 */     GIR_EraseRootFromParent_Done,
     /*    6266 */   // Label 229: @6266
     /*    6266 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6314), // Rule ID 65530 //
     /*    6271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6278 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    6282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6286 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    6290 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6301 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:6:y, sh3add_op:{ *:[i64] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6312 */     GIR_RootConstrainSelectedInstOperands,
     /*    6313 */     // GIR_Coverage, 65530,
     /*    6313 */     GIR_EraseRootFromParent_Done,
     /*    6314 */   // Label 230: @6314
     /*    6314 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(6362), // Rule ID 65539 //
     /*    6319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6326 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:9:y
     /*    6330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6334 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:9:x
     /*    6338 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6349 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:9:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:9:x)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6360 */     GIR_RootConstrainSelectedInstOperands,
     /*    6361 */     // GIR_Coverage, 65539,
     /*    6361 */     GIR_EraseRootFromParent_Done,
     /*    6362 */   // Label 231: @6362
     /*    6362 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6410), // Rule ID 65555 //
     /*    6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6374 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:17:y
     /*    6378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6382 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:17:x
     /*    6386 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6397 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:17:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:17:x)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6408 */     GIR_RootConstrainSelectedInstOperands,
     /*    6409 */     // GIR_Coverage, 65555,
     /*    6409 */     GIR_EraseRootFromParent_Done,
     /*    6410 */   // Label 232: @6410
     /*    6410 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(6458), // Rule ID 65559 //
     /*    6415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6422 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:19:y
     /*    6426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6430 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:19:x
     /*    6434 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6445 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:19:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:19:x)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6456 */     GIR_RootConstrainSelectedInstOperands,
     /*    6457 */     // GIR_Coverage, 65559,
     /*    6457 */     GIR_EraseRootFromParent_Done,
     /*    6458 */   // Label 233: @6458
     /*    6458 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(6509), // Rule ID 74348 //
     /*    6463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6470 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    6474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6478 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    6482 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6493 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:24:y, sh1add_op:{ *:[i64] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    6493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    6507 */     GIR_RootConstrainSelectedInstOperands,
     /*    6508 */     // GIR_Coverage, 74348,
     /*    6508 */     GIR_EraseRootFromParent_Done,
     /*    6509 */   // Label 234: @6509
     /*    6509 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(6560), // Rule ID 74352 //
     /*    6514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6521 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    6525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6529 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    6533 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6544 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:25:y, sh2add_op:{ *:[i64] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    6544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    6558 */     GIR_RootConstrainSelectedInstOperands,
     /*    6559 */     // GIR_Coverage, 74352,
     /*    6559 */     GIR_EraseRootFromParent_Done,
     /*    6560 */   // Label 235: @6560
     /*    6560 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(6611), // Rule ID 74356 //
     /*    6565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6572 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    6576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6580 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    6584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6595 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:26:y, sh3add_op:{ *:[i64] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    6595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6602 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    6606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    6609 */     GIR_RootConstrainSelectedInstOperands,
     /*    6610 */     // GIR_Coverage, 74356,
     /*    6610 */     GIR_EraseRootFromParent_Done,
     /*    6611 */   // Label 236: @6611
     /*    6611 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(6659), // Rule ID 74369 //
     /*    6616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6623 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:28:y
     /*    6627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6631 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:28:x
     /*    6635 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    6646 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:28:y, sh1add_op:{ *:[i64] }:$rs1:$pred:28:x)<<P:28:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    6649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6657 */     GIR_RootConstrainSelectedInstOperands,
     /*    6658 */     // GIR_Coverage, 74369,
     /*    6658 */     GIR_EraseRootFromParent_Done,
     /*    6659 */   // Label 237: @6659
     /*    6659 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(6707), // Rule ID 74377 //
     /*    6664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6671 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:30:y
     /*    6675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6679 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:30:x
     /*    6683 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    6694 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:30:y, sh2add_op:{ *:[i64] }:$rs1:$pred:30:x)<<P:30:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    6697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6705 */     GIR_RootConstrainSelectedInstOperands,
     /*    6706 */     // GIR_Coverage, 74377,
     /*    6706 */     GIR_EraseRootFromParent_Done,
     /*    6707 */   // Label 238: @6707
     /*    6707 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(6755), // Rule ID 74385 //
     /*    6712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    6715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6719 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:32:y
     /*    6723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6727 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:32:x
     /*    6731 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    6742 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:32:y, sh3add_op:{ *:[i64] }:$rs1:$pred:32:x)<<P:32:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    6745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6753 */     GIR_RootConstrainSelectedInstOperands,
     /*    6754 */     // GIR_Coverage, 74385,
     /*    6754 */     GIR_EraseRootFromParent_Done,
     /*    6755 */   // Label 239: @6755
     /*    6755 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(6803), // Rule ID 74394 //
     /*    6760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6767 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:35:y
     /*    6771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6775 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:35:x
     /*    6779 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    6790 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:35:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:35:x)<<P:35:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    6793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6795 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6801 */     GIR_RootConstrainSelectedInstOperands,
     /*    6802 */     // GIR_Coverage, 74394,
     /*    6802 */     GIR_EraseRootFromParent_Done,
     /*    6803 */   // Label 240: @6803
     /*    6803 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(6851), // Rule ID 74398 //
     /*    6808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6815 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:37:y
     /*    6819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6823 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:37:x
     /*    6827 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    6838 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:37:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:37:x)<<P:37:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    6841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6843 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6849 */     GIR_RootConstrainSelectedInstOperands,
     /*    6850 */     // GIR_Coverage, 74398,
     /*    6850 */     GIR_EraseRootFromParent_Done,
     /*    6851 */   // Label 241: @6851
     /*    6851 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(6899), // Rule ID 74402 //
     /*    6856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    6859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6863 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:39:y
     /*    6867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6871 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:39:x
     /*    6875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    6886 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:39:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:39:x)<<P:39:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    6889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6891 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    6895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6897 */     GIR_RootConstrainSelectedInstOperands,
     /*    6898 */     // GIR_Coverage, 74402,
     /*    6898 */     GIR_EraseRootFromParent_Done,
     /*    6899 */   // Label 242: @6899
     /*    6899 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(6974), // Rule ID 2596 //
     /*    6904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6911 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*    6915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6936 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    6947 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*    6951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6961 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x, GPR:{ *:[i64] }:$rs2:$pred:7:y)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    6964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    6972 */     GIR_RootConstrainSelectedInstOperands,
     /*    6973 */     // GIR_Coverage, 2596,
     /*    6973 */     GIR_EraseRootFromParent_Done,
     /*    6974 */   // Label 243: @6974
     /*    6974 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(7069), // Rule ID 2608 //
     /*    6979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6986 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*    6990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7011 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7022 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*    7026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7030 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7036 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x, GPR:{ *:[i64] }:$rs2:$pred:11:y)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    7060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7067 */     GIR_RootConstrainSelectedInstOperands,
     /*    7068 */     // GIR_Coverage, 2608,
     /*    7068 */     GIR_EraseRootFromParent_Done,
     /*    7069 */   // Label 244: @7069
     /*    7069 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(7164), // Rule ID 2612 //
     /*    7074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7081 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*    7085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7117 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*    7121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7125 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7131 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x, GPR:{ *:[i64] }:$rs2:$pred:13:y)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7143 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    7155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7162 */     GIR_RootConstrainSelectedInstOperands,
     /*    7163 */     // GIR_Coverage, 2612,
     /*    7163 */     GIR_EraseRootFromParent_Done,
     /*    7164 */   // Label 245: @7164
     /*    7164 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(7259), // Rule ID 2614 //
     /*    7169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7176 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*    7180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7201 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7212 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*    7216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7220 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7226 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x, GPR:{ *:[i64] }:$rs2:$pred:14:y)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7242 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7257 */     GIR_RootConstrainSelectedInstOperands,
     /*    7258 */     // GIR_Coverage, 2614,
     /*    7258 */     GIR_EraseRootFromParent_Done,
     /*    7259 */   // Label 246: @7259
     /*    7259 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(7354), // Rule ID 2616 //
     /*    7264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7271 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:15:x
     /*    7275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7296 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    7307 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:15:y
     /*    7311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7315 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7321 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x, GPR:{ *:[i64] }:$rs2:$pred:15:y)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    7345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7352 */     GIR_RootConstrainSelectedInstOperands,
     /*    7353 */     // GIR_Coverage, 2616,
     /*    7353 */     GIR_EraseRootFromParent_Done,
     /*    7354 */   // Label 247: @7354
     /*    7354 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(7449), // Rule ID 2630 //
     /*    7359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7366 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:20:x
     /*    7370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7391 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    7402 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:20:y
     /*    7406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7416 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x, GPR:{ *:[i64] }:$rs2:$pred:20:y)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    7440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7447 */     GIR_RootConstrainSelectedInstOperands,
     /*    7448 */     // GIR_Coverage, 2630,
     /*    7448 */     GIR_EraseRootFromParent_Done,
     /*    7449 */   // Label 248: @7449
     /*    7449 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(7544), // Rule ID 2632 //
     /*    7454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7461 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:21:x
     /*    7465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7486 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    7497 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:21:y
     /*    7501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7505 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7511 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x, GPR:{ *:[i64] }:$rs2:$pred:21:y)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7523 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7527 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    7535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7542 */     GIR_RootConstrainSelectedInstOperands,
     /*    7543 */     // GIR_Coverage, 2632,
     /*    7543 */     GIR_EraseRootFromParent_Done,
     /*    7544 */   // Label 249: @7544
     /*    7544 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(7639), // Rule ID 2634 //
     /*    7549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    7552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7556 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:22:x
     /*    7560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7581 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7592 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:22:y
     /*    7596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7600 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7606 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x, GPR:{ *:[i64] }:$rs2:$pred:22:y)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    7630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7637 */     GIR_RootConstrainSelectedInstOperands,
     /*    7638 */     // GIR_Coverage, 2634,
     /*    7638 */     GIR_EraseRootFromParent_Done,
     /*    7639 */   // Label 250: @7639
     /*    7639 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(7714), // Rule ID 65066 //
     /*    7644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7651 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:33:x
     /*    7655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7676 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    7687 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:33:y
     /*    7691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7701 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:33:x, GPR:{ *:[i64] }:$rs2:$pred:33:y)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    7704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7712 */     GIR_RootConstrainSelectedInstOperands,
     /*    7713 */     // GIR_Coverage, 65066,
     /*    7713 */     GIR_EraseRootFromParent_Done,
     /*    7714 */   // Label 251: @7714
     /*    7714 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(7809), // Rule ID 65088 //
     /*    7719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7726 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:41:x
     /*    7730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7751 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    7762 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:41:y
     /*    7766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7770 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7776 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:41:x, GPR:{ *:[i64] }:$rs2:$pred:41:y)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7788 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7792 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    7795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    7800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7807 */     GIR_RootConstrainSelectedInstOperands,
     /*    7808 */     // GIR_Coverage, 65088,
     /*    7808 */     GIR_EraseRootFromParent_Done,
     /*    7809 */   // Label 252: @7809
     /*    7809 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(7904), // Rule ID 65092 //
     /*    7814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7821 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:43:x
     /*    7825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    7857 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:43:y
     /*    7861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7865 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7871 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:43:x, GPR:{ *:[i64] }:$rs2:$pred:43:y)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    7878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7883 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7887 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    7890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7902 */     GIR_RootConstrainSelectedInstOperands,
     /*    7903 */     // GIR_Coverage, 65092,
     /*    7903 */     GIR_EraseRootFromParent_Done,
     /*    7904 */   // Label 253: @7904
     /*    7904 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(7999), // Rule ID 65094 //
     /*    7909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    7912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7916 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:44:x
     /*    7920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    7928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7941 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    7952 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:44:y
     /*    7956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    7964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7966 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:44:x, GPR:{ *:[i64] }:$rs2:$pred:44:y)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    7966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    7973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7982 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    7985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    7990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7997 */     GIR_RootConstrainSelectedInstOperands,
     /*    7998 */     // GIR_Coverage, 65094,
     /*    7998 */     GIR_EraseRootFromParent_Done,
     /*    7999 */   // Label 254: @7999
     /*    7999 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(8094), // Rule ID 65096 //
     /*    8004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8011 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:45:x
     /*    8015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8036 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    8047 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:45:y
     /*    8051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8061 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:45:x, GPR:{ *:[i64] }:$rs2:$pred:45:y)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8077 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8092 */     GIR_RootConstrainSelectedInstOperands,
     /*    8093 */     // GIR_Coverage, 65096,
     /*    8093 */     GIR_EraseRootFromParent_Done,
     /*    8094 */   // Label 255: @8094
     /*    8094 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(8189), // Rule ID 65098 //
     /*    8099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8106 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:46:x
     /*    8110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8131 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    8142 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:46:y
     /*    8146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8150 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8156 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:46:x, GPR:{ *:[i64] }:$rs2:$pred:46:y)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8168 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8172 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    8180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8187 */     GIR_RootConstrainSelectedInstOperands,
     /*    8188 */     // GIR_Coverage, 65098,
     /*    8188 */     GIR_EraseRootFromParent_Done,
     /*    8189 */   // Label 256: @8189
     /*    8189 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(8284), // Rule ID 65100 //
     /*    8194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8201 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:47:x
     /*    8205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8226 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    8237 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:47:y
     /*    8241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8245 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8251 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:47:x, GPR:{ *:[i64] }:$rs2:$pred:47:y)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8263 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8267 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    8270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    8275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8282 */     GIR_RootConstrainSelectedInstOperands,
     /*    8283 */     // GIR_Coverage, 65100,
     /*    8283 */     GIR_EraseRootFromParent_Done,
     /*    8284 */   // Label 257: @8284
     /*    8284 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(8379), // Rule ID 65102 //
     /*    8289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    8292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8296 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:48:x
     /*    8300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8321 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    8332 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:48:y
     /*    8336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8340 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8346 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:48:x, GPR:{ *:[i64] }:$rs2:$pred:48:y)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    8353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    8365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    8370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8377 */     GIR_RootConstrainSelectedInstOperands,
     /*    8378 */     // GIR_Coverage, 65102,
     /*    8378 */     GIR_EraseRootFromParent_Done,
     /*    8379 */   // Label 258: @8379
     /*    8379 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(8447), // Rule ID 2559 //
     /*    8384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8391 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    8395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8416 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8420 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    8424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8428 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8434 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x, GPR:{ *:[i64] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    8437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8445 */     GIR_RootConstrainSelectedInstOperands,
     /*    8446 */     // GIR_Coverage, 2559,
     /*    8446 */     GIR_EraseRootFromParent_Done,
     /*    8447 */   // Label 259: @8447
     /*    8447 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(8515), // Rule ID 2569 //
     /*    8452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8459 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    8463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8488 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    8492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8502 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x, GPR:{ *:[i64] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    8505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8513 */     GIR_RootConstrainSelectedInstOperands,
     /*    8514 */     // GIR_Coverage, 2569,
     /*    8514 */     GIR_EraseRootFromParent_Done,
     /*    8515 */   // Label 260: @8515
     /*    8515 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(8583), // Rule ID 2579 //
     /*    8520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    8523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8527 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    8531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8552 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    8556 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    8560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8570 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x, GPR:{ *:[i64] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    8573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8581 */     GIR_RootConstrainSelectedInstOperands,
     /*    8582 */     // GIR_Coverage, 2579,
     /*    8582 */     GIR_EraseRootFromParent_Done,
     /*    8583 */   // Label 261: @8583
     /*    8583 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(8651), // Rule ID 65029 //
     /*    8588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8595 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:27:x
     /*    8599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8620 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    8624 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:27:y
     /*    8628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8632 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8638 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:27:x, GPR:{ *:[i64] }:$rs2:$pred:27:y)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*    8641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8649 */     GIR_RootConstrainSelectedInstOperands,
     /*    8650 */     // GIR_Coverage, 65029,
     /*    8650 */     GIR_EraseRootFromParent_Done,
     /*    8651 */   // Label 262: @8651
     /*    8651 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(8719), // Rule ID 65039 //
     /*    8656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8663 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:29:x
     /*    8667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8688 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    8692 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:29:y
     /*    8696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8706 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:29:x, GPR:{ *:[i64] }:$rs2:$pred:29:y)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*    8709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8717 */     GIR_RootConstrainSelectedInstOperands,
     /*    8718 */     // GIR_Coverage, 65039,
     /*    8718 */     GIR_EraseRootFromParent_Done,
     /*    8719 */   // Label 263: @8719
     /*    8719 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(8787), // Rule ID 65049 //
     /*    8724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*    8727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8731 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:31:x
     /*    8735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    8743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8756 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    8760 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:31:y
     /*    8764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8768 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8774 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:31:x, GPR:{ *:[i64] }:$rs2:$pred:31:y)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*    8777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    8785 */     GIR_RootConstrainSelectedInstOperands,
     /*    8786 */     // GIR_Coverage, 65049,
     /*    8786 */     GIR_EraseRootFromParent_Done,
     /*    8787 */   // Label 264: @8787
     /*    8787 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(8862), // Rule ID 65533 //
     /*    8792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8799 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:7:y
     /*    8803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8807 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:7:x
     /*    8811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8832 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    8843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8849 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:7:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    8849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    8852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    8860 */     GIR_RootConstrainSelectedInstOperands,
     /*    8861 */     // GIR_Coverage, 65533,
     /*    8861 */     GIR_EraseRootFromParent_Done,
     /*    8862 */   // Label 265: @8862
     /*    8862 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(8957), // Rule ID 65543 //
     /*    8867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8874 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:11:y
     /*    8878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8882 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:11:x
     /*    8886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8907 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    8918 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    8922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    8924 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:11:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:11:x)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    8924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    8927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    8931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    8936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    8940 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    8943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    8945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    8948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    8953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    8955 */     GIR_RootConstrainSelectedInstOperands,
     /*    8956 */     // GIR_Coverage, 65543,
     /*    8956 */     GIR_EraseRootFromParent_Done,
     /*    8957 */   // Label 266: @8957
     /*    8957 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(9052), // Rule ID 65547 //
     /*    8962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    8965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8969 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:13:y
     /*    8973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    8977 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:13:x
     /*    8981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    8989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    8993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    8997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9002 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9013 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9019 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:13:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:13:x)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    9043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9050 */     GIR_RootConstrainSelectedInstOperands,
     /*    9051 */     // GIR_Coverage, 65547,
     /*    9051 */     GIR_EraseRootFromParent_Done,
     /*    9052 */   // Label 267: @9052
     /*    9052 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(9147), // Rule ID 65549 //
     /*    9057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9064 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:14:y
     /*    9068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9072 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:14:x
     /*    9076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9097 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9114 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:14:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:14:x)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9130 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9145 */     GIR_RootConstrainSelectedInstOperands,
     /*    9146 */     // GIR_Coverage, 65549,
     /*    9146 */     GIR_EraseRootFromParent_Done,
     /*    9147 */   // Label 268: @9147
     /*    9147 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(9242), // Rule ID 65551 //
     /*    9152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9159 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:15:y
     /*    9163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9167 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:15:x
     /*    9171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9192 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9203 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9209 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:15:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:15:x)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9221 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9225 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    9233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9240 */     GIR_RootConstrainSelectedInstOperands,
     /*    9241 */     // GIR_Coverage, 65551,
     /*    9241 */     GIR_EraseRootFromParent_Done,
     /*    9242 */   // Label 269: @9242
     /*    9242 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(9337), // Rule ID 65561 //
     /*    9247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9254 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:20:y
     /*    9258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9262 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:20:x
     /*    9266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9287 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    9298 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9304 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:20:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:20:x)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9320 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    9328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9335 */     GIR_RootConstrainSelectedInstOperands,
     /*    9336 */     // GIR_Coverage, 65561,
     /*    9336 */     GIR_EraseRootFromParent_Done,
     /*    9337 */   // Label 270: @9337
     /*    9337 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(9432), // Rule ID 65563 //
     /*    9342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9349 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:21:y
     /*    9353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9357 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:21:x
     /*    9361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9382 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    9393 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9399 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:21:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:21:x)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9415 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    9423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9430 */     GIR_RootConstrainSelectedInstOperands,
     /*    9431 */     // GIR_Coverage, 65563,
     /*    9431 */     GIR_EraseRootFromParent_Done,
     /*    9432 */   // Label 271: @9432
     /*    9432 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(9527), // Rule ID 65565 //
     /*    9437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    9440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9444 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:22:y
     /*    9448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9452 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:22:x
     /*    9456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9477 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9488 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9494 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:22:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:22:x)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    9518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9525 */     GIR_RootConstrainSelectedInstOperands,
     /*    9526 */     // GIR_Coverage, 65565,
     /*    9526 */     GIR_EraseRootFromParent_Done,
     /*    9527 */   // Label 272: @9527
     /*    9527 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(9602), // Rule ID 74388 //
     /*    9532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9539 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:33:y
     /*    9543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9547 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:33:x
     /*    9551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9572 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    9583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9589 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:33:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:33:x)<<P:33:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    9589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*    9592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9600 */     GIR_RootConstrainSelectedInstOperands,
     /*    9601 */     // GIR_Coverage, 74388,
     /*    9601 */     GIR_EraseRootFromParent_Done,
     /*    9602 */   // Label 273: @9602
     /*    9602 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(9697), // Rule ID 74406 //
     /*    9607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9614 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:41:y
     /*    9618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9622 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:41:x
     /*    9626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9647 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    9658 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9664 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:41:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:41:x)<<P:41:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    9683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*    9688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9695 */     GIR_RootConstrainSelectedInstOperands,
     /*    9696 */     // GIR_Coverage, 74406,
     /*    9696 */     GIR_EraseRootFromParent_Done,
     /*    9697 */   // Label 274: @9697
     /*    9697 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(9792), // Rule ID 74410 //
     /*    9702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9709 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:43:y
     /*    9713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9717 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:43:x
     /*    9721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9742 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    9753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9759 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:43:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:43:x)<<P:43:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9771 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9775 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    9778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*    9783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9790 */     GIR_RootConstrainSelectedInstOperands,
     /*    9791 */     // GIR_Coverage, 74410,
     /*    9791 */     GIR_EraseRootFromParent_Done,
     /*    9792 */   // Label 275: @9792
     /*    9792 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(9887), // Rule ID 74412 //
     /*    9797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9804 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:44:y
     /*    9808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9812 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:44:x
     /*    9816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9837 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    9848 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9854 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:44:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:44:x)<<P:44:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    9861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    9878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9885 */     GIR_RootConstrainSelectedInstOperands,
     /*    9886 */     // GIR_Coverage, 74412,
     /*    9886 */     GIR_EraseRootFromParent_Done,
     /*    9887 */   // Label 276: @9887
     /*    9887 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(9982), // Rule ID 74414 //
     /*    9892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9899 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:45:y
     /*    9903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9907 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:45:x
     /*    9911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    9919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    9923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    9927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9932 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    9943 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    9947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9949 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:45:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:45:x)<<P:45:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    9949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    9952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    9956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    9968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*    9973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    9980 */     GIR_RootConstrainSelectedInstOperands,
     /*    9981 */     // GIR_Coverage, 74414,
     /*    9981 */     GIR_EraseRootFromParent_Done,
     /*    9982 */   // Label 277: @9982
     /*    9982 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(10077), // Rule ID 74416 //
     /*    9987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*    9990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    9994 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:46:y
     /*    9998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10002 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:46:x
     /*   10006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10027 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*   10038 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10044 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:46:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:46:x)<<P:46:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10060 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   10063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H_ZE),
     /*   10068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10075 */     GIR_RootConstrainSelectedInstOperands,
     /*   10076 */     // GIR_Coverage, 74416,
     /*   10076 */     GIR_EraseRootFromParent_Done,
     /*   10077 */   // Label 278: @10077
     /*   10077 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(10172), // Rule ID 74418 //
     /*   10082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10089 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:47:y
     /*   10093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10097 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:47:x
     /*   10101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10122 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*   10133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10139 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:47:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:47:x)<<P:47:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*   10158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W_ZE),
     /*   10163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10170 */     GIR_RootConstrainSelectedInstOperands,
     /*   10171 */     // GIR_Coverage, 74418,
     /*   10171 */     GIR_EraseRootFromParent_Done,
     /*   10172 */   // Label 279: @10172
     /*   10172 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(10267), // Rule ID 74420 //
     /*   10177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*   10180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10184 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:48:y
     /*   10188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10192 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:48:x
     /*   10196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   10204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10217 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*   10228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10234 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:48:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:48:x)<<P:48:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D_ZE:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*   10234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*   10241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*   10253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D_ZE),
     /*   10258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10265 */     GIR_RootConstrainSelectedInstOperands,
     /*   10266 */     // GIR_Coverage, 74420,
     /*   10266 */     GIR_EraseRootFromParent_Done,
     /*   10267 */   // Label 280: @10267
     /*   10267 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(10335), // Rule ID 65510 //
     /*   10272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10279 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*   10283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10287 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*   10291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10312 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10316 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10322 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:1:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*   10325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10333 */     GIR_RootConstrainSelectedInstOperands,
     /*   10334 */     // GIR_Coverage, 65510,
     /*   10334 */     GIR_EraseRootFromParent_Done,
     /*   10335 */   // Label 281: @10335
     /*   10335 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(10403), // Rule ID 65518 //
     /*   10340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10347 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*   10351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10355 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*   10359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10380 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10384 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10390 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:3:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*   10393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10401 */     GIR_RootConstrainSelectedInstOperands,
     /*   10402 */     // GIR_Coverage, 65518,
     /*   10402 */     GIR_EraseRootFromParent_Done,
     /*   10403 */   // Label 282: @10403
     /*   10403 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(10471), // Rule ID 65526 //
     /*   10408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*   10411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10415 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*   10419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10423 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*   10427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10448 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10458 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:5:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*   10461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10469 */     GIR_RootConstrainSelectedInstOperands,
     /*   10470 */     // GIR_Coverage, 65526,
     /*   10470 */     GIR_EraseRootFromParent_Done,
     /*   10471 */   // Label 283: @10471
     /*   10471 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(10539), // Rule ID 74365 //
     /*   10476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10483 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:27:y
     /*   10487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10491 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:27:x
     /*   10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10516 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   10520 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10526 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:27:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:27:x)<<P:27:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_H),
     /*   10529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10537 */     GIR_RootConstrainSelectedInstOperands,
     /*   10538 */     // GIR_Coverage, 74365,
     /*   10538 */     GIR_EraseRootFromParent_Done,
     /*   10539 */   // Label 284: @10539
     /*   10539 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(10607), // Rule ID 74373 //
     /*   10544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10551 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:29:y
     /*   10555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10559 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:29:x
     /*   10563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10584 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*   10588 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10594 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:29:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:29:x)<<P:29:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_W),
     /*   10597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10605 */     GIR_RootConstrainSelectedInstOperands,
     /*   10606 */     // GIR_Coverage, 74373,
     /*   10606 */     GIR_EraseRootFromParent_Done,
     /*   10607 */   // Label 285: @10607
     /*   10607 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(10675), // Rule ID 74381 //
     /*   10612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /*   10615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10619 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:31:y
     /*   10623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10627 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:31:x
     /*   10631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10652 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*   10656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10662 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:31:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:31:x)<<P:31:Predicate_add_like_non_imm12>>  =>  (NDS_LEA_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   10662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_D),
     /*   10665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10673 */     GIR_RootConstrainSelectedInstOperands,
     /*   10674 */     // GIR_Coverage, 74381,
     /*   10674 */     GIR_EraseRootFromParent_Done,
     /*   10675 */   // Label 286: @10675
     /*   10675 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(10754), // Rule ID 62525 //
     /*   10680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   10683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10687 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*   10691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   10716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   10724 */     // MIs[2] Operand 1
     /*   10724 */     // No operand predicates
     /*   10724 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*   10728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10732 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10738 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i64] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   10738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   10741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*   10745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   10749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   10752 */     GIR_RootConstrainSelectedInstOperands,
     /*   10753 */     // GIR_Coverage, 62525,
     /*   10753 */     GIR_EraseRootFromParent_Done,
     /*   10754 */   // Label 287: @10754
     /*   10754 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(10833), // Rule ID 74344 //
     /*   10759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*   10762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10766 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*   10770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10774 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*   10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   10803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10807 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*   10811 */     // MIs[2] Operand 1
     /*   10811 */     // No operand predicates
     /*   10811 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*   10815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10817 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:23:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*   10817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*   10820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   10828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*   10831 */     GIR_RootConstrainSelectedInstOperands,
     /*   10832 */     // GIR_Coverage, 74344,
     /*   10832 */     GIR_EraseRootFromParent_Done,
     /*   10833 */   // Label 288: @10833
     /*   10833 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(10882), // Rule ID 120 //
     /*   10838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   10841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*   10853 */     // MIs[1] Operand 1
     /*   10853 */     // No operand predicates
     /*   10853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   10857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10861 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   10865 */     // MIs[2] Operand 1
     /*   10865 */     // No operand predicates
     /*   10865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   10867 */     // (add:{ *:[i64] } (frameindex:{ *:[i64] }):$fi, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i64] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i64] }:$fi), (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)
     /*   10867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   10870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10872 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*   10877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*   10880 */     GIR_RootConstrainSelectedInstOperands,
     /*   10881 */     // GIR_Coverage, 120,
     /*   10881 */     GIR_EraseRootFromParent_Done,
     /*   10882 */   // Label 289: @10882
     /*   10882 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(10928), // Rule ID 271 //
     /*   10887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   10890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   10910 */     // MIs[1] Operand 1
     /*   10910 */     // No operand predicates
     /*   10910 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10025),
     /*   10914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10916 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)<<P:Predicate_anonymous_10025>>  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   10916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   10926 */     GIR_RootConstrainSelectedInstOperands,
     /*   10927 */     // GIR_Coverage, 271,
     /*   10927 */     GIR_EraseRootFromParent_Done,
     /*   10928 */   // Label 290: @10928
     /*   10928 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(11004), // Rule ID 293 //
     /*   10933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   10936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   10944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   10952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   10956 */     // MIs[1] Operand 1
     /*   10956 */     // No operand predicates
     /*   10956 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10053),
     /*   10960 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10025),
     /*   10964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10966 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10053>>:$rs2)<<P:Predicate_anonymous_10025>>  =>  (ADDIW:{ *:[i64] } (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   10966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   10969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   10982 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   10987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*   10992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10997 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11002 */     GIR_RootConstrainSelectedInstOperands,
     /*   11003 */     // GIR_Coverage, 293,
     /*   11003 */     GIR_EraseRootFromParent_Done,
     /*   11004 */   // Label 291: @11004
     /*   11004 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(11069), // Rule ID 74360 //
     /*   11009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11046 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10025),
     /*   11050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11052 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)<<P:Predicate_anonymous_10025>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11067 */     GIR_RootConstrainSelectedInstOperands,
     /*   11068 */     // GIR_Coverage, 74360,
     /*   11068 */     GIR_EraseRootFromParent_Done,
     /*   11069 */   // Label 292: @11069
     /*   11069 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(11134), // Rule ID 62596 //
     /*   11074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   11077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10025),
     /*   11115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11117 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10025>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*   11120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11132 */     GIR_RootConstrainSelectedInstOperands,
     /*   11133 */     // GIR_Coverage, 62596,
     /*   11133 */     GIR_EraseRootFromParent_Done,
     /*   11134 */   // Label 293: @11134
     /*   11134 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(11176), // Rule ID 80 //
     /*   11139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*   11162 */     // MIs[1] Operand 1
     /*   11162 */     // No operand predicates
     /*   11162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11164 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*   11164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   11174 */     GIR_RootConstrainSelectedInstOperands,
     /*   11175 */     // GIR_Coverage, 80,
     /*   11175 */     GIR_EraseRootFromParent_Done,
     /*   11176 */   // Label 294: @11176
     /*   11176 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(11248), // Rule ID 291 //
     /*   11181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   11200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*   11204 */     // MIs[1] Operand 1
     /*   11204 */     // No operand predicates
     /*   11204 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10053),
     /*   11208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11210 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10053>>:$rs2)  =>  (ADDI:{ *:[i64] } (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*   11210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   11213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*   11226 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*   11231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*   11236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11241 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*   11246 */     GIR_RootConstrainSelectedInstOperands,
     /*   11247 */     // GIR_Coverage, 291,
     /*   11247 */     GIR_EraseRootFromParent_Done,
     /*   11248 */   // Label 295: @11248
     /*   11248 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(11309), // Rule ID 74358 //
     /*   11253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11292 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11307 */     GIR_RootConstrainSelectedInstOperands,
     /*   11308 */     // GIR_Coverage, 74358,
     /*   11308 */     GIR_EraseRootFromParent_Done,
     /*   11309 */   // Label 296: @11309
     /*   11309 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(11370), // Rule ID 62592 //
     /*   11314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   11317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   11337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   11341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11353 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*   11356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   11358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   11368 */     GIR_RootConstrainSelectedInstOperands,
     /*   11369 */     // GIR_Coverage, 62592,
     /*   11369 */     GIR_EraseRootFromParent_Done,
     /*   11370 */   // Label 297: @11370
     /*   11370 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(11401), // Rule ID 270 //
     /*   11375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   11378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11390 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10025),
     /*   11394 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10025>>  =>  (ADDW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADDW),
     /*   11399 */     GIR_RootConstrainSelectedInstOperands,
     /*   11400 */     // GIR_Coverage, 270,
     /*   11400 */     GIR_Done,
     /*   11401 */   // Label 298: @11401
     /*   11401 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(11428), // Rule ID 78 //
     /*   11406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   11409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   11421 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   11421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*   11426 */     GIR_RootConstrainSelectedInstOperands,
     /*   11427 */     // GIR_Coverage, 78,
     /*   11427 */     GIR_Done,
     /*   11428 */   // Label 299: @11428
     /*   11428 */   GIM_Reject,
     /*   11429 */ // Label 192: @11429
     /*   11429 */ GIM_Reject,
     /*   11430 */ // Label 128: @11430
     /*   11430 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(11824),
     /*   11435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11445 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(11513), // Rule ID 69308 //
     /*   11450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11487 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11511 */     GIR_RootConstrainSelectedInstOperands,
     /*   11512 */     // GIR_Coverage, 69308,
     /*   11512 */     GIR_EraseRootFromParent_Done,
     /*   11513 */   // Label 301: @11513
     /*   11513 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(11581), // Rule ID 69309 //
     /*   11518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11537 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11555 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   11555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11579 */     GIR_RootConstrainSelectedInstOperands,
     /*   11580 */     // GIR_Coverage, 69309,
     /*   11580 */     GIR_EraseRootFromParent_Done,
     /*   11581 */   // Label 302: @11581
     /*   11581 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11649), // Rule ID 45916 //
     /*   11586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11609 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11623 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11647 */     GIR_RootConstrainSelectedInstOperands,
     /*   11648 */     // GIR_Coverage, 45916,
     /*   11648 */     GIR_EraseRootFromParent_Done,
     /*   11649 */   // Label 303: @11649
     /*   11649 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11717), // Rule ID 45917 //
     /*   11654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   11677 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   11691 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   11691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*   11694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   11700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   11704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   11706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11715 */     GIR_RootConstrainSelectedInstOperands,
     /*   11716 */     // GIR_Coverage, 45917,
     /*   11716 */     GIR_EraseRootFromParent_Done,
     /*   11717 */   // Label 304: @11717
     /*   11717 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11770), // Rule ID 45744 //
     /*   11722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11733 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   11733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   11736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   11750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11768 */     GIR_RootConstrainSelectedInstOperands,
     /*   11769 */     // GIR_Coverage, 45744,
     /*   11769 */     GIR_EraseRootFromParent_Done,
     /*   11770 */   // Label 305: @11770
     /*   11770 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(11823), // Rule ID 45745 //
     /*   11775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11786 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   11786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   11789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   11793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   11798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   11800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*   11803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   11808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   11810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   11812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11821 */     GIR_RootConstrainSelectedInstOperands,
     /*   11822 */     // GIR_Coverage, 45745,
     /*   11822 */     GIR_EraseRootFromParent_Done,
     /*   11823 */   // Label 306: @11823
     /*   11823 */   GIM_Reject,
     /*   11824 */ // Label 300: @11824
     /*   11824 */ GIM_Reject,
     /*   11825 */ // Label 129: @11825
     /*   11825 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14949),
     /*   11830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11840 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(11936), // Rule ID 69222 //
     /*   11845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11864 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11893 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11897 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11899 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11910 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   11910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   11913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   11931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11934 */     GIR_RootConstrainSelectedInstOperands,
     /*   11935 */     // GIR_Coverage, 69222,
     /*   11935 */     GIR_EraseRootFromParent_Done,
     /*   11936 */   // Label 308: @11936
     /*   11936 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(12032), // Rule ID 69223 //
     /*   11941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   11960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11974 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11989 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   11993 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11995 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12004 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12006 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12030 */     GIR_RootConstrainSelectedInstOperands,
     /*   12031 */     // GIR_Coverage, 69223,
     /*   12031 */     GIR_EraseRootFromParent_Done,
     /*   12032 */   // Label 309: @12032
     /*   12032 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12128), // Rule ID 71048 //
     /*   12037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12056 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12070 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12077 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12081 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12085 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12089 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12091 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12102 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12126 */     GIR_RootConstrainSelectedInstOperands,
     /*   12127 */     // GIR_Coverage, 71048,
     /*   12127 */     GIR_EraseRootFromParent_Done,
     /*   12128 */   // Label 310: @12128
     /*   12128 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12224), // Rule ID 71049 //
     /*   12133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12152 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12166 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12185 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12187 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12196 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12198 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12222 */     GIR_RootConstrainSelectedInstOperands,
     /*   12223 */     // GIR_Coverage, 71049,
     /*   12223 */     GIR_EraseRootFromParent_Done,
     /*   12224 */   // Label 311: @12224
     /*   12224 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12320), // Rule ID 71050 //
     /*   12229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12248 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12262 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12281 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12283 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12292 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12294 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12318 */     GIR_RootConstrainSelectedInstOperands,
     /*   12319 */     // GIR_Coverage, 71050,
     /*   12319 */     GIR_EraseRootFromParent_Done,
     /*   12320 */   // Label 312: @12320
     /*   12320 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12416), // Rule ID 71051 //
     /*   12325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12344 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12358 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12373 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12377 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12379 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12390 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12414 */     GIR_RootConstrainSelectedInstOperands,
     /*   12415 */     // GIR_Coverage, 71051,
     /*   12415 */     GIR_EraseRootFromParent_Done,
     /*   12416 */   // Label 313: @12416
     /*   12416 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12512), // Rule ID 70926 //
     /*   12421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12440 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12454 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12469 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12473 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12475 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12486 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12510 */     GIR_RootConstrainSelectedInstOperands,
     /*   12511 */     // GIR_Coverage, 70926,
     /*   12511 */     GIR_EraseRootFromParent_Done,
     /*   12512 */   // Label 314: @12512
     /*   12512 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12608), // Rule ID 70927 //
     /*   12517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12557 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12561 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12565 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12569 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12571 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12582 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   12585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   12589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12606 */     GIR_RootConstrainSelectedInstOperands,
     /*   12607 */     // GIR_Coverage, 70927,
     /*   12607 */     GIR_EraseRootFromParent_Done,
     /*   12608 */   // Label 315: @12608
     /*   12608 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12704), // Rule ID 45828 //
     /*   12613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12636 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12650 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12669 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12671 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12678 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12702 */     GIR_RootConstrainSelectedInstOperands,
     /*   12703 */     // GIR_Coverage, 45828,
     /*   12703 */     GIR_EraseRootFromParent_Done,
     /*   12704 */   // Label 316: @12704
     /*   12704 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12800), // Rule ID 45829 //
     /*   12709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12732 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12746 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12757 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12761 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12765 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12774 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*   12777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12798 */     GIR_RootConstrainSelectedInstOperands,
     /*   12799 */     // GIR_Coverage, 45829,
     /*   12799 */     GIR_EraseRootFromParent_Done,
     /*   12800 */   // Label 317: @12800
     /*   12800 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(12896), // Rule ID 52148 //
     /*   12805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12828 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12842 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12853 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12857 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12861 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12863 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12868 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12870 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   12870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12894 */     GIR_RootConstrainSelectedInstOperands,
     /*   12895 */     // GIR_Coverage, 52148,
     /*   12895 */     GIR_EraseRootFromParent_Done,
     /*   12896 */   // Label 318: @12896
     /*   12896 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(12992), // Rule ID 52149 //
     /*   12901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   12924 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12938 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12953 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   12957 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12959 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12964 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12966 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   12966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   12969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12990 */     GIR_RootConstrainSelectedInstOperands,
     /*   12991 */     // GIR_Coverage, 52149,
     /*   12991 */     GIR_EraseRootFromParent_Done,
     /*   12992 */   // Label 319: @12992
     /*   12992 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13088), // Rule ID 71046 //
     /*   12997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13034 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13049 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13053 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13060 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13062 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13086 */     GIR_RootConstrainSelectedInstOperands,
     /*   13087 */     // GIR_Coverage, 71046,
     /*   13087 */     GIR_EraseRootFromParent_Done,
     /*   13088 */   // Label 320: @13088
     /*   13088 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13184), // Rule ID 71047 //
     /*   13093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13116 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13130 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13145 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13149 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13151 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13158 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*   13161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   13169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   13173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13182 */     GIR_RootConstrainSelectedInstOperands,
     /*   13183 */     // GIR_Coverage, 71047,
     /*   13183 */     GIR_EraseRootFromParent_Done,
     /*   13184 */   // Label 321: @13184
     /*   13184 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13280), // Rule ID 52088 //
     /*   13189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13212 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13226 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13241 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13245 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13247 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13254 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   13254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13278 */     GIR_RootConstrainSelectedInstOperands,
     /*   13279 */     // GIR_Coverage, 52088,
     /*   13279 */     GIR_EraseRootFromParent_Done,
     /*   13280 */   // Label 322: @13280
     /*   13280 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13376), // Rule ID 52089 //
     /*   13285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13308 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   13314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13322 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   13333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13337 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13341 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   13343 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   13350 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   13350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*   13353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   13357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   13365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13374 */     GIR_RootConstrainSelectedInstOperands,
     /*   13375 */     // GIR_Coverage, 52089,
     /*   13375 */     GIR_EraseRootFromParent_Done,
     /*   13376 */   // Label 323: @13376
     /*   13376 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13465), // Rule ID 46674 //
     /*   13381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13396 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13415 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13424 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13463 */     GIR_RootConstrainSelectedInstOperands,
     /*   13464 */     // GIR_Coverage, 46674,
     /*   13464 */     GIR_EraseRootFromParent_Done,
     /*   13465 */   // Label 324: @13465
     /*   13465 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(13554), // Rule ID 46675 //
     /*   13470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13485 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13504 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13513 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13552 */     GIR_RootConstrainSelectedInstOperands,
     /*   13553 */     // GIR_Coverage, 46675,
     /*   13553 */     GIR_EraseRootFromParent_Done,
     /*   13554 */   // Label 325: @13554
     /*   13554 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(13643), // Rule ID 45820 //
     /*   13559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13593 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13602 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   13619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13641 */     GIR_RootConstrainSelectedInstOperands,
     /*   13642 */     // GIR_Coverage, 45820,
     /*   13642 */     GIR_EraseRootFromParent_Done,
     /*   13643 */   // Label 326: @13643
     /*   13643 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(13732), // Rule ID 45821 //
     /*   13648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13663 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13682 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13691 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*   13708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13730 */     GIR_RootConstrainSelectedInstOperands,
     /*   13731 */     // GIR_Coverage, 45821,
     /*   13731 */     GIR_EraseRootFromParent_Done,
     /*   13732 */   // Label 327: @13732
     /*   13732 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(13821), // Rule ID 46554 //
     /*   13737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13771 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13780 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   13780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13819 */     GIR_RootConstrainSelectedInstOperands,
     /*   13820 */     // GIR_Coverage, 46554,
     /*   13820 */     GIR_EraseRootFromParent_Done,
     /*   13821 */   // Label 328: @13821
     /*   13821 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(13910), // Rule ID 46555 //
     /*   13826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   13852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   13860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   13862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   13869 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   13869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   13872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*   13886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   13895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   13899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13908 */     GIR_RootConstrainSelectedInstOperands,
     /*   13909 */     // GIR_Coverage, 46555,
     /*   13909 */     GIR_EraseRootFromParent_Done,
     /*   13910 */   // Label 329: @13910
     /*   13910 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(13978), // Rule ID 70618 //
     /*   13915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   13934 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13952 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   13955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   13961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13976 */     GIR_RootConstrainSelectedInstOperands,
     /*   13977 */     // GIR_Coverage, 70618,
     /*   13977 */     GIR_EraseRootFromParent_Done,
     /*   13978 */   // Label 330: @13978
     /*   13978 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14046), // Rule ID 70619 //
     /*   13983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14020 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14044 */     GIR_RootConstrainSelectedInstOperands,
     /*   14045 */     // GIR_Coverage, 70619,
     /*   14045 */     GIR_EraseRootFromParent_Done,
     /*   14046 */   // Label 331: @14046
     /*   14046 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(14101), // Rule ID 69610 //
     /*   14051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14079 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14099 */     GIR_RootConstrainSelectedInstOperands,
     /*   14100 */     // GIR_Coverage, 69610,
     /*   14100 */     GIR_EraseRootFromParent_Done,
     /*   14101 */   // Label 332: @14101
     /*   14101 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(14156), // Rule ID 69611 //
     /*   14106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14134 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14154 */     GIR_RootConstrainSelectedInstOperands,
     /*   14155 */     // GIR_Coverage, 69611,
     /*   14155 */     GIR_EraseRootFromParent_Done,
     /*   14156 */   // Label 333: @14156
     /*   14156 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(14211), // Rule ID 69218 //
     /*   14161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14176 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14189 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14209 */     GIR_RootConstrainSelectedInstOperands,
     /*   14210 */     // GIR_Coverage, 69218,
     /*   14210 */     GIR_EraseRootFromParent_Done,
     /*   14211 */   // Label 334: @14211
     /*   14211 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(14266), // Rule ID 69219 //
     /*   14216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14244 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14264 */     GIR_RootConstrainSelectedInstOperands,
     /*   14265 */     // GIR_Coverage, 69219,
     /*   14265 */     GIR_EraseRootFromParent_Done,
     /*   14266 */   // Label 335: @14266
     /*   14266 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(14321), // Rule ID 69520 //
     /*   14271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14286 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14299 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14319 */     GIR_RootConstrainSelectedInstOperands,
     /*   14320 */     // GIR_Coverage, 69520,
     /*   14320 */     GIR_EraseRootFromParent_Done,
     /*   14321 */   // Label 336: @14321
     /*   14321 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(14376), // Rule ID 69521 //
     /*   14326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14341 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14354 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14374 */     GIR_RootConstrainSelectedInstOperands,
     /*   14375 */     // GIR_Coverage, 69521,
     /*   14375 */     GIR_EraseRootFromParent_Done,
     /*   14376 */   // Label 337: @14376
     /*   14376 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(14444), // Rule ID 51868 //
     /*   14381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14404 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14418 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   14418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14442 */     GIR_RootConstrainSelectedInstOperands,
     /*   14443 */     // GIR_Coverage, 51868,
     /*   14443 */     GIR_EraseRootFromParent_Done,
     /*   14444 */   // Label 338: @14444
     /*   14444 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(14512), // Rule ID 51869 //
     /*   14449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   14468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   14472 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14486 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   14486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   14489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   14495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14510 */     GIR_RootConstrainSelectedInstOperands,
     /*   14511 */     // GIR_Coverage, 51869,
     /*   14511 */     GIR_EraseRootFromParent_Done,
     /*   14512 */   // Label 339: @14512
     /*   14512 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(14567), // Rule ID 46734 //
     /*   14517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14545 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14565 */     GIR_RootConstrainSelectedInstOperands,
     /*   14566 */     // GIR_Coverage, 46734,
     /*   14566 */     GIR_EraseRootFromParent_Done,
     /*   14567 */   // Label 340: @14567
     /*   14567 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(14622), // Rule ID 46735 //
     /*   14572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   14587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14600 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14620 */     GIR_RootConstrainSelectedInstOperands,
     /*   14621 */     // GIR_Coverage, 46735,
     /*   14621 */     GIR_EraseRootFromParent_Done,
     /*   14622 */   // Label 341: @14622
     /*   14622 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(14677), // Rule ID 45824 //
     /*   14627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14655 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14675 */     GIR_RootConstrainSelectedInstOperands,
     /*   14676 */     // GIR_Coverage, 45824,
     /*   14676 */     GIR_EraseRootFromParent_Done,
     /*   14677 */   // Label 342: @14677
     /*   14677 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(14732), // Rule ID 45825 //
     /*   14682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14710 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   14713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14730 */     GIR_RootConstrainSelectedInstOperands,
     /*   14731 */     // GIR_Coverage, 45825,
     /*   14731 */     GIR_EraseRootFromParent_Done,
     /*   14732 */   // Label 343: @14732
     /*   14732 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(14787), // Rule ID 46614 //
     /*   14737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14756 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14765 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   14765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14785 */     GIR_RootConstrainSelectedInstOperands,
     /*   14786 */     // GIR_Coverage, 46614,
     /*   14786 */     GIR_EraseRootFromParent_Done,
     /*   14787 */   // Label 344: @14787
     /*   14787 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(14842), // Rule ID 46615 //
     /*   14792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   14811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   14820 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   14820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   14823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   14827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   14831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14840 */     GIR_RootConstrainSelectedInstOperands,
     /*   14841 */     // GIR_Coverage, 46615,
     /*   14841 */     GIR_EraseRootFromParent_Done,
     /*   14842 */   // Label 345: @14842
     /*   14842 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(14895), // Rule ID 46100 //
     /*   14847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14858 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   14858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   14875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14893 */     GIR_RootConstrainSelectedInstOperands,
     /*   14894 */     // GIR_Coverage, 46100,
     /*   14894 */     GIR_EraseRootFromParent_Done,
     /*   14895 */   // Label 346: @14895
     /*   14895 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(14948), // Rule ID 46101 //
     /*   14900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   14903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14911 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   14911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   14914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   14918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   14923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   14925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   14928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   14933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   14935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   14937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   14943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   14946 */     GIR_RootConstrainSelectedInstOperands,
     /*   14947 */     // GIR_Coverage, 46101,
     /*   14947 */     GIR_EraseRootFromParent_Done,
     /*   14948 */   // Label 347: @14948
     /*   14948 */   GIM_Reject,
     /*   14949 */ // Label 307: @14949
     /*   14949 */ GIM_Reject,
     /*   14950 */ // Label 130: @14950
     /*   14950 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(18074),
     /*   14955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   14961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14965 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15061), // Rule ID 70824 //
     /*   14970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   14973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   14989 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15018 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15022 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15024 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15033 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15035 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15059 */     GIR_RootConstrainSelectedInstOperands,
     /*   15060 */     // GIR_Coverage, 70824,
     /*   15060 */     GIR_EraseRootFromParent_Done,
     /*   15061 */   // Label 349: @15061
     /*   15061 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15157), // Rule ID 70825 //
     /*   15066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15099 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15114 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15118 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15120 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15131 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15155 */     GIR_RootConstrainSelectedInstOperands,
     /*   15156 */     // GIR_Coverage, 70825,
     /*   15156 */     GIR_EraseRootFromParent_Done,
     /*   15157 */   // Label 350: @15157
     /*   15157 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15253), // Rule ID 71084 //
     /*   15162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15195 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15214 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15216 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15225 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15227 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15251 */     GIR_RootConstrainSelectedInstOperands,
     /*   15252 */     // GIR_Coverage, 71084,
     /*   15252 */     GIR_EraseRootFromParent_Done,
     /*   15253 */   // Label 351: @15253
     /*   15253 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15349), // Rule ID 71085 //
     /*   15258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15277 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15291 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15310 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15312 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15323 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15347 */     GIR_RootConstrainSelectedInstOperands,
     /*   15348 */     // GIR_Coverage, 71085,
     /*   15348 */     GIR_EraseRootFromParent_Done,
     /*   15349 */   // Label 352: @15349
     /*   15349 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15445), // Rule ID 71086 //
     /*   15354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15373 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15387 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15406 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15408 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15417 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15419 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15443 */     GIR_RootConstrainSelectedInstOperands,
     /*   15444 */     // GIR_Coverage, 71086,
     /*   15444 */     GIR_EraseRootFromParent_Done,
     /*   15445 */   // Label 353: @15445
     /*   15445 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15541), // Rule ID 71087 //
     /*   15450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15483 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15498 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15502 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15504 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15513 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15515 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15539 */     GIR_RootConstrainSelectedInstOperands,
     /*   15540 */     // GIR_Coverage, 71087,
     /*   15540 */     GIR_EraseRootFromParent_Done,
     /*   15541 */   // Label 354: @15541
     /*   15541 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(15637), // Rule ID 70938 //
     /*   15546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15598 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15600 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15609 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15611 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   15614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15635 */     GIR_RootConstrainSelectedInstOperands,
     /*   15636 */     // GIR_Coverage, 70938,
     /*   15636 */     GIR_EraseRootFromParent_Done,
     /*   15637 */   // Label 355: @15637
     /*   15637 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(15733), // Rule ID 70939 //
     /*   15642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15675 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15690 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15694 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15696 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15705 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15707 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   15710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   15714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15731 */     GIR_RootConstrainSelectedInstOperands,
     /*   15732 */     // GIR_Coverage, 70939,
     /*   15732 */     GIR_EraseRootFromParent_Done,
     /*   15733 */   // Label 356: @15733
     /*   15733 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(15829), // Rule ID 52042 //
     /*   15738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15761 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15775 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15794 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15796 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15801 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15803 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15827 */     GIR_RootConstrainSelectedInstOperands,
     /*   15828 */     // GIR_Coverage, 52042,
     /*   15828 */     GIR_EraseRootFromParent_Done,
     /*   15829 */   // Label 357: @15829
     /*   15829 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(15925), // Rule ID 52043 //
     /*   15834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   15837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15857 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15871 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15886 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15890 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15892 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15897 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15899 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   15899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   15902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   15920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15923 */     GIR_RootConstrainSelectedInstOperands,
     /*   15924 */     // GIR_Coverage, 52043,
     /*   15924 */     GIR_EraseRootFromParent_Done,
     /*   15925 */   // Label 358: @15925
     /*   15925 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16021), // Rule ID 52160 //
     /*   15930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   15933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   15953 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15978 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15982 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   15986 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15988 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15995 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   15995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   15998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16019 */     GIR_RootConstrainSelectedInstOperands,
     /*   16020 */     // GIR_Coverage, 52160,
     /*   16020 */     GIR_EraseRootFromParent_Done,
     /*   16021 */   // Label 359: @16021
     /*   16021 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16117), // Rule ID 52161 //
     /*   16026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16063 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16082 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16084 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16091 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16115 */     GIR_RootConstrainSelectedInstOperands,
     /*   16116 */     // GIR_Coverage, 52161,
     /*   16116 */     GIR_EraseRootFromParent_Done,
     /*   16117 */   // Label 360: @16117
     /*   16117 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16213), // Rule ID 71082 //
     /*   16122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16145 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16174 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16178 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16180 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16185 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16187 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16211 */     GIR_RootConstrainSelectedInstOperands,
     /*   16212 */     // GIR_Coverage, 71082,
     /*   16212 */     GIR_EraseRootFromParent_Done,
     /*   16213 */   // Label 361: @16213
     /*   16213 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16309), // Rule ID 71083 //
     /*   16218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16241 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16255 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16270 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16274 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16276 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16281 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16283 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   16286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   16294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   16298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16307 */     GIR_RootConstrainSelectedInstOperands,
     /*   16308 */     // GIR_Coverage, 71083,
     /*   16308 */     GIR_EraseRootFromParent_Done,
     /*   16309 */   // Label 362: @16309
     /*   16309 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16405), // Rule ID 52100 //
     /*   16314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16337 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16366 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16370 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16372 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16379 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   16379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16403 */     GIR_RootConstrainSelectedInstOperands,
     /*   16404 */     // GIR_Coverage, 52100,
     /*   16404 */     GIR_EraseRootFromParent_Done,
     /*   16405 */   // Label 363: @16405
     /*   16405 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16501), // Rule ID 52101 //
     /*   16410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   16433 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   16439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16447 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   16458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16462 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16466 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   16468 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   16475 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   16475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   16478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   16482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   16490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16499 */     GIR_RootConstrainSelectedInstOperands,
     /*   16500 */     // GIR_Coverage, 52101,
     /*   16500 */     GIR_EraseRootFromParent_Done,
     /*   16501 */   // Label 364: @16501
     /*   16501 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16590), // Rule ID 46698 //
     /*   16506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16549 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16588 */     GIR_RootConstrainSelectedInstOperands,
     /*   16589 */     // GIR_Coverage, 46698,
     /*   16589 */     GIR_EraseRootFromParent_Done,
     /*   16590 */   // Label 365: @16590
     /*   16590 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16679), // Rule ID 46699 //
     /*   16595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16629 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16638 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16677 */     GIR_RootConstrainSelectedInstOperands,
     /*   16678 */     // GIR_Coverage, 46699,
     /*   16678 */     GIR_EraseRootFromParent_Done,
     /*   16679 */   // Label 366: @16679
     /*   16679 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16768), // Rule ID 46462 //
     /*   16684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16727 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   16744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16766 */     GIR_RootConstrainSelectedInstOperands,
     /*   16767 */     // GIR_Coverage, 46462,
     /*   16767 */     GIR_EraseRootFromParent_Done,
     /*   16768 */   // Label 367: @16768
     /*   16768 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16857), // Rule ID 46463 //
     /*   16773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16816 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   16833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16855 */     GIR_RootConstrainSelectedInstOperands,
     /*   16856 */     // GIR_Coverage, 46463,
     /*   16856 */     GIR_EraseRootFromParent_Done,
     /*   16857 */   // Label 368: @16857
     /*   16857 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16946), // Rule ID 46578 //
     /*   16862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   16865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16896 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16905 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   16905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   16922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   16941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16944 */     GIR_RootConstrainSelectedInstOperands,
     /*   16945 */     // GIR_Coverage, 46578,
     /*   16945 */     GIR_EraseRootFromParent_Done,
     /*   16946 */   // Label 369: @16946
     /*   16946 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17035), // Rule ID 46579 //
     /*   16951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   16954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   16977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   16985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16994 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   16994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   16997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   17011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   17020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17033 */     GIR_RootConstrainSelectedInstOperands,
     /*   17034 */     // GIR_Coverage, 46579,
     /*   17034 */     GIR_EraseRootFromParent_Done,
     /*   17035 */   // Label 370: @17035
     /*   17035 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17103), // Rule ID 70634 //
     /*   17040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17059 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17077 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17101 */     GIR_RootConstrainSelectedInstOperands,
     /*   17102 */     // GIR_Coverage, 70634,
     /*   17102 */     GIR_EraseRootFromParent_Done,
     /*   17103 */   // Label 371: @17103
     /*   17103 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17171), // Rule ID 70635 //
     /*   17108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17127 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17145 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17169 */     GIR_RootConstrainSelectedInstOperands,
     /*   17170 */     // GIR_Coverage, 70635,
     /*   17170 */     GIR_EraseRootFromParent_Done,
     /*   17171 */   // Label 372: @17171
     /*   17171 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17226), // Rule ID 69634 //
     /*   17176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17204 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17224 */     GIR_RootConstrainSelectedInstOperands,
     /*   17225 */     // GIR_Coverage, 69634,
     /*   17225 */     GIR_EraseRootFromParent_Done,
     /*   17226 */   // Label 373: @17226
     /*   17226 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17281), // Rule ID 69635 //
     /*   17231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17259 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17279 */     GIR_RootConstrainSelectedInstOperands,
     /*   17280 */     // GIR_Coverage, 69635,
     /*   17280 */     GIR_EraseRootFromParent_Done,
     /*   17281 */   // Label 374: @17281
     /*   17281 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17336), // Rule ID 69454 //
     /*   17286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17314 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17334 */     GIR_RootConstrainSelectedInstOperands,
     /*   17335 */     // GIR_Coverage, 69454,
     /*   17335 */     GIR_EraseRootFromParent_Done,
     /*   17336 */   // Label 375: @17336
     /*   17336 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17391), // Rule ID 69455 //
     /*   17341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17369 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17389 */     GIR_RootConstrainSelectedInstOperands,
     /*   17390 */     // GIR_Coverage, 69455,
     /*   17390 */     GIR_EraseRootFromParent_Done,
     /*   17391 */   // Label 376: @17391
     /*   17391 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17446), // Rule ID 69544 //
     /*   17396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17424 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17444 */     GIR_RootConstrainSelectedInstOperands,
     /*   17445 */     // GIR_Coverage, 69544,
     /*   17445 */     GIR_EraseRootFromParent_Done,
     /*   17446 */   // Label 377: @17446
     /*   17446 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17501), // Rule ID 69545 //
     /*   17451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17466 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17479 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17499 */     GIR_RootConstrainSelectedInstOperands,
     /*   17500 */     // GIR_Coverage, 69545,
     /*   17500 */     GIR_EraseRootFromParent_Done,
     /*   17501 */   // Label 378: @17501
     /*   17501 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17569), // Rule ID 51876 //
     /*   17506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17529 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17543 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   17543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17567 */     GIR_RootConstrainSelectedInstOperands,
     /*   17568 */     // GIR_Coverage, 51876,
     /*   17568 */     GIR_EraseRootFromParent_Done,
     /*   17569 */   // Label 379: @17569
     /*   17569 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17637), // Rule ID 51877 //
     /*   17574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   17593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   17597 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17611 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   17611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   17614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   17632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17635 */     GIR_RootConstrainSelectedInstOperands,
     /*   17636 */     // GIR_Coverage, 51877,
     /*   17636 */     GIR_EraseRootFromParent_Done,
     /*   17637 */   // Label 380: @17637
     /*   17637 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17692), // Rule ID 46758 //
     /*   17642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17670 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17690 */     GIR_RootConstrainSelectedInstOperands,
     /*   17691 */     // GIR_Coverage, 46758,
     /*   17691 */     GIR_EraseRootFromParent_Done,
     /*   17692 */   // Label 381: @17692
     /*   17692 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17747), // Rule ID 46759 //
     /*   17697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   17712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17725 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17745 */     GIR_RootConstrainSelectedInstOperands,
     /*   17746 */     // GIR_Coverage, 46759,
     /*   17746 */     GIR_EraseRootFromParent_Done,
     /*   17747 */   // Label 382: @17747
     /*   17747 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17802), // Rule ID 46518 //
     /*   17752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17780 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17800 */     GIR_RootConstrainSelectedInstOperands,
     /*   17801 */     // GIR_Coverage, 46518,
     /*   17801 */     GIR_EraseRootFromParent_Done,
     /*   17802 */   // Label 383: @17802
     /*   17802 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17857), // Rule ID 46519 //
     /*   17807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17835 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   17838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17855 */     GIR_RootConstrainSelectedInstOperands,
     /*   17856 */     // GIR_Coverage, 46519,
     /*   17856 */     GIR_EraseRootFromParent_Done,
     /*   17857 */   // Label 384: @17857
     /*   17857 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17912), // Rule ID 46638 //
     /*   17862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17890 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   17890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17910 */     GIR_RootConstrainSelectedInstOperands,
     /*   17911 */     // GIR_Coverage, 46638,
     /*   17911 */     GIR_EraseRootFromParent_Done,
     /*   17912 */   // Label 385: @17912
     /*   17912 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17967), // Rule ID 46639 //
     /*   17917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   17936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17945 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   17945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   17948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   17962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17965 */     GIR_RootConstrainSelectedInstOperands,
     /*   17966 */     // GIR_Coverage, 46639,
     /*   17966 */     GIR_EraseRootFromParent_Done,
     /*   17967 */   // Label 386: @17967
     /*   17967 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18020), // Rule ID 46108 //
     /*   17972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17983 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   17983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   17986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18018 */     GIR_RootConstrainSelectedInstOperands,
     /*   18019 */     // GIR_Coverage, 46108,
     /*   18019 */     GIR_EraseRootFromParent_Done,
     /*   18020 */   // Label 387: @18020
     /*   18020 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18073), // Rule ID 46109 //
     /*   18025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18036 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   18036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   18039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   18043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   18048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   18050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   18053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   18058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   18060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   18062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18071 */     GIR_RootConstrainSelectedInstOperands,
     /*   18072 */     // GIR_Coverage, 46109,
     /*   18072 */     GIR_EraseRootFromParent_Done,
     /*   18073 */   // Label 388: @18073
     /*   18073 */   GIM_Reject,
     /*   18074 */ // Label 348: @18074
     /*   18074 */ GIM_Reject,
     /*   18075 */ // Label 131: @18075
     /*   18075 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(21199),
     /*   18080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18090 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18186), // Rule ID 70834 //
     /*   18095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18114 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18147 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18149 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18160 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18184 */     GIR_RootConstrainSelectedInstOperands,
     /*   18185 */     // GIR_Coverage, 70834,
     /*   18185 */     GIR_EraseRootFromParent_Done,
     /*   18186 */   // Label 390: @18186
     /*   18186 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18282), // Rule ID 70835 //
     /*   18191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18224 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18243 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18256 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18280 */     GIR_RootConstrainSelectedInstOperands,
     /*   18281 */     // GIR_Coverage, 70835,
     /*   18281 */     GIR_EraseRootFromParent_Done,
     /*   18282 */   // Label 391: @18282
     /*   18282 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18378), // Rule ID 71114 //
     /*   18287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18320 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18335 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18339 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18341 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18352 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18376 */     GIR_RootConstrainSelectedInstOperands,
     /*   18377 */     // GIR_Coverage, 71114,
     /*   18377 */     GIR_EraseRootFromParent_Done,
     /*   18378 */   // Label 392: @18378
     /*   18378 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18474), // Rule ID 71115 //
     /*   18383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18416 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18431 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18435 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18437 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18448 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18472 */     GIR_RootConstrainSelectedInstOperands,
     /*   18473 */     // GIR_Coverage, 71115,
     /*   18473 */     GIR_EraseRootFromParent_Done,
     /*   18474 */   // Label 393: @18474
     /*   18474 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18570), // Rule ID 71116 //
     /*   18479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18512 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18527 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18531 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18533 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18544 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18568 */     GIR_RootConstrainSelectedInstOperands,
     /*   18569 */     // GIR_Coverage, 71116,
     /*   18569 */     GIR_EraseRootFromParent_Done,
     /*   18570 */   // Label 394: @18570
     /*   18570 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18666), // Rule ID 71117 //
     /*   18575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18594 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18608 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18615 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18619 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18623 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18627 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18629 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18640 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   18643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18664 */     GIR_RootConstrainSelectedInstOperands,
     /*   18665 */     // GIR_Coverage, 71117,
     /*   18665 */     GIR_EraseRootFromParent_Done,
     /*   18666 */   // Label 395: @18666
     /*   18666 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18762), // Rule ID 70948 //
     /*   18671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18690 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18704 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18719 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18723 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18725 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18736 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   18739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18760 */     GIR_RootConstrainSelectedInstOperands,
     /*   18761 */     // GIR_Coverage, 70948,
     /*   18761 */     GIR_EraseRootFromParent_Done,
     /*   18762 */   // Label 396: @18762
     /*   18762 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18858), // Rule ID 70949 //
     /*   18767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18800 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18802 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18819 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18821 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18832 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   18832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   18835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18856 */     GIR_RootConstrainSelectedInstOperands,
     /*   18857 */     // GIR_Coverage, 70949,
     /*   18857 */     GIR_EraseRootFromParent_Done,
     /*   18858 */   // Label 397: @18858
     /*   18858 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18954), // Rule ID 52052 //
     /*   18863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   18866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18886 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18900 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18915 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18919 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18928 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   18928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   18931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   18949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18952 */     GIR_RootConstrainSelectedInstOperands,
     /*   18953 */     // GIR_Coverage, 52052,
     /*   18953 */     GIR_EraseRootFromParent_Done,
     /*   18954 */   // Label 398: @18954
     /*   18954 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(19050), // Rule ID 52053 //
     /*   18959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   18962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   18978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   18982 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   18996 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19011 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19015 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19024 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   19027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19048 */     GIR_RootConstrainSelectedInstOperands,
     /*   19049 */     // GIR_Coverage, 52053,
     /*   19049 */     GIR_EraseRootFromParent_Done,
     /*   19050 */   // Label 399: @19050
     /*   19050 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(19146), // Rule ID 52170 //
     /*   19055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19111 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19113 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19120 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19144 */     GIR_RootConstrainSelectedInstOperands,
     /*   19145 */     // GIR_Coverage, 52170,
     /*   19145 */     GIR_EraseRootFromParent_Done,
     /*   19146 */   // Label 400: @19146
     /*   19146 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(19242), // Rule ID 52171 //
     /*   19151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19188 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19203 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19207 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19209 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19216 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19240 */     GIR_RootConstrainSelectedInstOperands,
     /*   19241 */     // GIR_Coverage, 52171,
     /*   19241 */     GIR_EraseRootFromParent_Done,
     /*   19242 */   // Label 401: @19242
     /*   19242 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(19338), // Rule ID 71112 //
     /*   19247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19270 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19284 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19299 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19303 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19312 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19336 */     GIR_RootConstrainSelectedInstOperands,
     /*   19337 */     // GIR_Coverage, 71112,
     /*   19337 */     GIR_EraseRootFromParent_Done,
     /*   19338 */   // Label 402: @19338
     /*   19338 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(19434), // Rule ID 71113 //
     /*   19343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19399 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19401 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19406 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19408 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   19411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   19419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   19423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19432 */     GIR_RootConstrainSelectedInstOperands,
     /*   19433 */     // GIR_Coverage, 71113,
     /*   19433 */     GIR_EraseRootFromParent_Done,
     /*   19434 */   // Label 403: @19434
     /*   19434 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(19530), // Rule ID 52110 //
     /*   19439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19462 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19495 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19504 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   19504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19528 */     GIR_RootConstrainSelectedInstOperands,
     /*   19529 */     // GIR_Coverage, 52110,
     /*   19529 */     GIR_EraseRootFromParent_Done,
     /*   19530 */   // Label 404: @19530
     /*   19530 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(19626), // Rule ID 52111 //
     /*   19535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   19546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   19554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   19558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   19564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19572 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   19583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19591 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19598 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19600 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   19600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   19603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19624 */     GIR_RootConstrainSelectedInstOperands,
     /*   19625 */     // GIR_Coverage, 52111,
     /*   19625 */     GIR_EraseRootFromParent_Done,
     /*   19626 */   // Label 405: @19626
     /*   19626 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(19715), // Rule ID 46718 //
     /*   19631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19665 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19674 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   19691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19713 */     GIR_RootConstrainSelectedInstOperands,
     /*   19714 */     // GIR_Coverage, 46718,
     /*   19714 */     GIR_EraseRootFromParent_Done,
     /*   19715 */   // Label 406: @19715
     /*   19715 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(19804), // Rule ID 46719 //
     /*   19720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19735 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19754 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19763 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   19780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19802 */     GIR_RootConstrainSelectedInstOperands,
     /*   19803 */     // GIR_Coverage, 46719,
     /*   19803 */     GIR_EraseRootFromParent_Done,
     /*   19804 */   // Label 407: @19804
     /*   19804 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(19893), // Rule ID 46482 //
     /*   19809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19824 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19843 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19852 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   19852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   19869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19891 */     GIR_RootConstrainSelectedInstOperands,
     /*   19892 */     // GIR_Coverage, 46482,
     /*   19892 */     GIR_EraseRootFromParent_Done,
     /*   19893 */   // Label 408: @19893
     /*   19893 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(19982), // Rule ID 46483 //
     /*   19898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   19901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19928 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   19932 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19941 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   19941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   19944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   19958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   19977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19980 */     GIR_RootConstrainSelectedInstOperands,
     /*   19981 */     // GIR_Coverage, 46483,
     /*   19981 */     GIR_EraseRootFromParent_Done,
     /*   19982 */   // Label 409: @19982
     /*   19982 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(20071), // Rule ID 46598 //
     /*   19987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   19990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20021 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20030 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   20030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20069 */     GIR_RootConstrainSelectedInstOperands,
     /*   20070 */     // GIR_Coverage, 46598,
     /*   20070 */     GIR_EraseRootFromParent_Done,
     /*   20071 */   // Label 410: @20071
     /*   20071 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(20160), // Rule ID 46599 //
     /*   20076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   20102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20110 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20117 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   20119 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   20119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   20122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   20136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   20145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20158 */     GIR_RootConstrainSelectedInstOperands,
     /*   20159 */     // GIR_Coverage, 46599,
     /*   20159 */     GIR_EraseRootFromParent_Done,
     /*   20160 */   // Label 411: @20160
     /*   20160 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(20228), // Rule ID 70666 //
     /*   20165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20184 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20202 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20226 */     GIR_RootConstrainSelectedInstOperands,
     /*   20227 */     // GIR_Coverage, 70666,
     /*   20227 */     GIR_EraseRootFromParent_Done,
     /*   20228 */   // Label 412: @20228
     /*   20228 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(20296), // Rule ID 70667 //
     /*   20233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20252 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20270 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20294 */     GIR_RootConstrainSelectedInstOperands,
     /*   20295 */     // GIR_Coverage, 70667,
     /*   20295 */     GIR_EraseRootFromParent_Done,
     /*   20296 */   // Label 413: @20296
     /*   20296 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(20351), // Rule ID 69654 //
     /*   20301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20329 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20349 */     GIR_RootConstrainSelectedInstOperands,
     /*   20350 */     // GIR_Coverage, 69654,
     /*   20350 */     GIR_EraseRootFromParent_Done,
     /*   20351 */   // Label 414: @20351
     /*   20351 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(20406), // Rule ID 69655 //
     /*   20356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20384 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20404 */     GIR_RootConstrainSelectedInstOperands,
     /*   20405 */     // GIR_Coverage, 69655,
     /*   20405 */     GIR_EraseRootFromParent_Done,
     /*   20406 */   // Label 415: @20406
     /*   20406 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(20461), // Rule ID 69474 //
     /*   20411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20439 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20459 */     GIR_RootConstrainSelectedInstOperands,
     /*   20460 */     // GIR_Coverage, 69474,
     /*   20460 */     GIR_EraseRootFromParent_Done,
     /*   20461 */   // Label 416: @20461
     /*   20461 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(20516), // Rule ID 69475 //
     /*   20466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20494 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20514 */     GIR_RootConstrainSelectedInstOperands,
     /*   20515 */     // GIR_Coverage, 69475,
     /*   20515 */     GIR_EraseRootFromParent_Done,
     /*   20516 */   // Label 417: @20516
     /*   20516 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(20571), // Rule ID 69564 //
     /*   20521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20549 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20569 */     GIR_RootConstrainSelectedInstOperands,
     /*   20570 */     // GIR_Coverage, 69564,
     /*   20570 */     GIR_EraseRootFromParent_Done,
     /*   20571 */   // Label 418: @20571
     /*   20571 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(20626), // Rule ID 69565 //
     /*   20576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20604 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20624 */     GIR_RootConstrainSelectedInstOperands,
     /*   20625 */     // GIR_Coverage, 69565,
     /*   20625 */     GIR_EraseRootFromParent_Done,
     /*   20626 */   // Label 419: @20626
     /*   20626 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(20694), // Rule ID 51892 //
     /*   20631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   20634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20668 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   20668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20692 */     GIR_RootConstrainSelectedInstOperands,
     /*   20693 */     // GIR_Coverage, 51892,
     /*   20693 */     GIR_EraseRootFromParent_Done,
     /*   20694 */   // Label 420: @20694
     /*   20694 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(20762), // Rule ID 51893 //
     /*   20699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   20702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   20718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   20722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20736 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   20736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   20739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   20757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20760 */     GIR_RootConstrainSelectedInstOperands,
     /*   20761 */     // GIR_Coverage, 51893,
     /*   20761 */     GIR_EraseRootFromParent_Done,
     /*   20762 */   // Label 421: @20762
     /*   20762 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(20817), // Rule ID 46778 //
     /*   20767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20795 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20815 */     GIR_RootConstrainSelectedInstOperands,
     /*   20816 */     // GIR_Coverage, 46778,
     /*   20816 */     GIR_EraseRootFromParent_Done,
     /*   20817 */   // Label 422: @20817
     /*   20817 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20872), // Rule ID 46779 //
     /*   20822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20850 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   20853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20870 */     GIR_RootConstrainSelectedInstOperands,
     /*   20871 */     // GIR_Coverage, 46779,
     /*   20871 */     GIR_EraseRootFromParent_Done,
     /*   20872 */   // Label 423: @20872
     /*   20872 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20927), // Rule ID 46538 //
     /*   20877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20905 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   20905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20925 */     GIR_RootConstrainSelectedInstOperands,
     /*   20926 */     // GIR_Coverage, 46538,
     /*   20926 */     GIR_EraseRootFromParent_Done,
     /*   20927 */   // Label 424: @20927
     /*   20927 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20982), // Rule ID 46539 //
     /*   20932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   20935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   20951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20960 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   20960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   20963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   20977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20980 */     GIR_RootConstrainSelectedInstOperands,
     /*   20981 */     // GIR_Coverage, 46539,
     /*   20981 */     GIR_EraseRootFromParent_Done,
     /*   20982 */   // Label 425: @20982
     /*   20982 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(21037), // Rule ID 46658 //
     /*   20987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   20990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21006 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21015 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   21015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21035 */     GIR_RootConstrainSelectedInstOperands,
     /*   21036 */     // GIR_Coverage, 46658,
     /*   21036 */     GIR_EraseRootFromParent_Done,
     /*   21037 */   // Label 426: @21037
     /*   21037 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(21092), // Rule ID 46659 //
     /*   21042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   21045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   21061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21070 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   21070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   21073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   21087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21090 */     GIR_RootConstrainSelectedInstOperands,
     /*   21091 */     // GIR_Coverage, 46659,
     /*   21091 */     GIR_EraseRootFromParent_Done,
     /*   21092 */   // Label 427: @21092
     /*   21092 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(21145), // Rule ID 46124 //
     /*   21097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   21100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21108 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   21108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21143 */     GIR_RootConstrainSelectedInstOperands,
     /*   21144 */     // GIR_Coverage, 46124,
     /*   21144 */     GIR_EraseRootFromParent_Done,
     /*   21145 */   // Label 428: @21145
     /*   21145 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(21198), // Rule ID 46125 //
     /*   21150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   21153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21161 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   21161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   21164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   21178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   21193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21196 */     GIR_RootConstrainSelectedInstOperands,
     /*   21197 */     // GIR_Coverage, 46125,
     /*   21197 */     GIR_EraseRootFromParent_Done,
     /*   21198 */   // Label 429: @21198
     /*   21198 */   GIM_Reject,
     /*   21199 */ // Label 389: @21199
     /*   21199 */ GIM_Reject,
     /*   21200 */ // Label 132: @21200
     /*   21200 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(21594),
     /*   21205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21215 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(21283), // Rule ID 70602 //
     /*   21220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21257 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21281 */     GIR_RootConstrainSelectedInstOperands,
     /*   21282 */     // GIR_Coverage, 70602,
     /*   21282 */     GIR_EraseRootFromParent_Done,
     /*   21283 */   // Label 431: @21283
     /*   21283 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21351), // Rule ID 70603 //
     /*   21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21325 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21349 */     GIR_RootConstrainSelectedInstOperands,
     /*   21350 */     // GIR_Coverage, 70603,
     /*   21350 */     GIR_EraseRootFromParent_Done,
     /*   21351 */   // Label 432: @21351
     /*   21351 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21419), // Rule ID 51860 //
     /*   21356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21379 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21393 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21417 */     GIR_RootConstrainSelectedInstOperands,
     /*   21418 */     // GIR_Coverage, 51860,
     /*   21418 */     GIR_EraseRootFromParent_Done,
     /*   21419 */   // Label 433: @21419
     /*   21419 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21487), // Rule ID 51861 //
     /*   21424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   21447 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   21461 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   21464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   21470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   21474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   21476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21485 */     GIR_RootConstrainSelectedInstOperands,
     /*   21486 */     // GIR_Coverage, 51861,
     /*   21486 */     GIR_EraseRootFromParent_Done,
     /*   21487 */   // Label 434: @21487
     /*   21487 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21540), // Rule ID 46092 //
     /*   21492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21503 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   21503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21538 */     GIR_RootConstrainSelectedInstOperands,
     /*   21539 */     // GIR_Coverage, 46092,
     /*   21539 */     GIR_EraseRootFromParent_Done,
     /*   21540 */   // Label 435: @21540
     /*   21540 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21593), // Rule ID 46093 //
     /*   21545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21556 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   21556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   21559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   21563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   21568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   21570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   21573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   21578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   21580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   21582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21591 */     GIR_RootConstrainSelectedInstOperands,
     /*   21592 */     // GIR_Coverage, 46093,
     /*   21592 */     GIR_EraseRootFromParent_Done,
     /*   21593 */   // Label 436: @21593
     /*   21593 */   GIM_Reject,
     /*   21594 */ // Label 430: @21594
     /*   21594 */ GIM_Reject,
     /*   21595 */ // Label 133: @21595
     /*   21595 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(24719),
     /*   21600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21610 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21706), // Rule ID 70814 //
     /*   21615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21634 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21648 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21663 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21667 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21669 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21680 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21704 */     GIR_RootConstrainSelectedInstOperands,
     /*   21705 */     // GIR_Coverage, 70814,
     /*   21705 */     GIR_EraseRootFromParent_Done,
     /*   21706 */   // Label 438: @21706
     /*   21706 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21802), // Rule ID 70815 //
     /*   21711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21744 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21763 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21765 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21776 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   21779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21800 */     GIR_RootConstrainSelectedInstOperands,
     /*   21801 */     // GIR_Coverage, 70815,
     /*   21801 */     GIR_EraseRootFromParent_Done,
     /*   21802 */   // Label 439: @21802
     /*   21802 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21898), // Rule ID 71054 //
     /*   21807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21840 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21855 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21859 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21861 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21870 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21872 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   21872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   21875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21896 */     GIR_RootConstrainSelectedInstOperands,
     /*   21897 */     // GIR_Coverage, 71054,
     /*   21897 */     GIR_EraseRootFromParent_Done,
     /*   21898 */   // Label 440: @21898
     /*   21898 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(21994), // Rule ID 71055 //
     /*   21903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   21922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21936 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21951 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   21955 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21957 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21966 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21968 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   21968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   21971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   21989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21992 */     GIR_RootConstrainSelectedInstOperands,
     /*   21993 */     // GIR_Coverage, 71055,
     /*   21993 */     GIR_EraseRootFromParent_Done,
     /*   21994 */   // Label 441: @21994
     /*   21994 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22090), // Rule ID 71056 //
     /*   21999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22018 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22032 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22051 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22053 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22064 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22088 */     GIR_RootConstrainSelectedInstOperands,
     /*   22089 */     // GIR_Coverage, 71056,
     /*   22089 */     GIR_EraseRootFromParent_Done,
     /*   22090 */   // Label 442: @22090
     /*   22090 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22186), // Rule ID 71057 //
     /*   22095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22114 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22147 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22149 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22160 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22184 */     GIR_RootConstrainSelectedInstOperands,
     /*   22185 */     // GIR_Coverage, 71057,
     /*   22185 */     GIR_EraseRootFromParent_Done,
     /*   22186 */   // Label 443: @22186
     /*   22186 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22282), // Rule ID 70928 //
     /*   22191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22224 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22243 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22254 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22256 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22280 */     GIR_RootConstrainSelectedInstOperands,
     /*   22281 */     // GIR_Coverage, 70928,
     /*   22281 */     GIR_EraseRootFromParent_Done,
     /*   22282 */   // Label 444: @22282
     /*   22282 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22378), // Rule ID 70929 //
     /*   22287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22320 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22335 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22339 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22341 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22350 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22352 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   22355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   22359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22376 */     GIR_RootConstrainSelectedInstOperands,
     /*   22377 */     // GIR_Coverage, 70929,
     /*   22377 */     GIR_EraseRootFromParent_Done,
     /*   22378 */   // Label 445: @22378
     /*   22378 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22474), // Rule ID 52032 //
     /*   22383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22406 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22435 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22439 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22441 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22448 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22472 */     GIR_RootConstrainSelectedInstOperands,
     /*   22473 */     // GIR_Coverage, 52032,
     /*   22473 */     GIR_EraseRootFromParent_Done,
     /*   22474 */   // Label 446: @22474
     /*   22474 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22570), // Rule ID 52033 //
     /*   22479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22502 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22516 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22535 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22537 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22544 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   22547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22568 */     GIR_RootConstrainSelectedInstOperands,
     /*   22569 */     // GIR_Coverage, 52033,
     /*   22569 */     GIR_EraseRootFromParent_Done,
     /*   22570 */   // Label 447: @22570
     /*   22570 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22666), // Rule ID 52150 //
     /*   22575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22598 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22612 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22619 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22623 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22627 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22631 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22633 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22640 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22664 */     GIR_RootConstrainSelectedInstOperands,
     /*   22665 */     // GIR_Coverage, 52150,
     /*   22665 */     GIR_EraseRootFromParent_Done,
     /*   22666 */   // Label 448: @22666
     /*   22666 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22762), // Rule ID 52151 //
     /*   22671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22694 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22723 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22727 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22736 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22760 */     GIR_RootConstrainSelectedInstOperands,
     /*   22761 */     // GIR_Coverage, 52151,
     /*   22761 */     GIR_EraseRootFromParent_Done,
     /*   22762 */   // Label 449: @22762
     /*   22762 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22858), // Rule ID 71052 //
     /*   22767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22804 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22811 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22815 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22819 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22823 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22832 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   22832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22856 */     GIR_RootConstrainSelectedInstOperands,
     /*   22857 */     // GIR_Coverage, 71052,
     /*   22857 */     GIR_EraseRootFromParent_Done,
     /*   22858 */   // Label 450: @22858
     /*   22858 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22954), // Rule ID 71053 //
     /*   22863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22886 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22900 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22915 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22919 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22921 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22928 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   22928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   22931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   22939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   22943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22952 */     GIR_RootConstrainSelectedInstOperands,
     /*   22953 */     // GIR_Coverage, 71053,
     /*   22953 */     GIR_EraseRootFromParent_Done,
     /*   22954 */   // Label 451: @22954
     /*   22954 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(23050), // Rule ID 52090 //
     /*   22959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   22982 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   22996 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23011 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23015 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23022 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23024 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23048 */     GIR_RootConstrainSelectedInstOperands,
     /*   23049 */     // GIR_Coverage, 52090,
     /*   23049 */     GIR_EraseRootFromParent_Done,
     /*   23050 */   // Label 452: @23050
     /*   23050 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23146), // Rule ID 52091 //
     /*   23055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23099 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23103 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23107 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23111 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23113 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23118 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23120 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   23123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   23127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23144 */     GIR_RootConstrainSelectedInstOperands,
     /*   23145 */     // GIR_Coverage, 52091,
     /*   23145 */     GIR_EraseRootFromParent_Done,
     /*   23146 */   // Label 453: @23146
     /*   23146 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23235), // Rule ID 46678 //
     /*   23151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23166 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23185 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23194 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23233 */     GIR_RootConstrainSelectedInstOperands,
     /*   23234 */     // GIR_Coverage, 46678,
     /*   23234 */     GIR_EraseRootFromParent_Done,
     /*   23235 */   // Label 454: @23235
     /*   23235 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23324), // Rule ID 46679 //
     /*   23240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23255 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23274 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23283 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23322 */     GIR_RootConstrainSelectedInstOperands,
     /*   23323 */     // GIR_Coverage, 46679,
     /*   23323 */     GIR_EraseRootFromParent_Done,
     /*   23324 */   // Label 455: @23324
     /*   23324 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23413), // Rule ID 46442 //
     /*   23329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23344 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23363 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23372 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23411 */     GIR_RootConstrainSelectedInstOperands,
     /*   23412 */     // GIR_Coverage, 46442,
     /*   23412 */     GIR_EraseRootFromParent_Done,
     /*   23413 */   // Label 456: @23413
     /*   23413 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23502), // Rule ID 46443 //
     /*   23418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23433 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23452 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23461 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   23478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23500 */     GIR_RootConstrainSelectedInstOperands,
     /*   23501 */     // GIR_Coverage, 46443,
     /*   23501 */     GIR_EraseRootFromParent_Done,
     /*   23502 */   // Label 457: @23502
     /*   23502 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23591), // Rule ID 46558 //
     /*   23507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23541 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23550 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   23550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23589 */     GIR_RootConstrainSelectedInstOperands,
     /*   23590 */     // GIR_Coverage, 46558,
     /*   23590 */     GIR_EraseRootFromParent_Done,
     /*   23591 */   // Label 458: @23591
     /*   23591 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23680), // Rule ID 46559 //
     /*   23596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   23622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   23639 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   23639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   23642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   23656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   23665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23678 */     GIR_RootConstrainSelectedInstOperands,
     /*   23679 */     // GIR_Coverage, 46559,
     /*   23679 */     GIR_EraseRootFromParent_Done,
     /*   23680 */   // Label 459: @23680
     /*   23680 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23748), // Rule ID 70626 //
     /*   23685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23704 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23722 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   23722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   23725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23746 */     GIR_RootConstrainSelectedInstOperands,
     /*   23747 */     // GIR_Coverage, 70626,
     /*   23747 */     GIR_EraseRootFromParent_Done,
     /*   23748 */   // Label 460: @23748
     /*   23748 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23816), // Rule ID 70627 //
     /*   23753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   23772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23790 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   23790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   23793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23814 */     GIR_RootConstrainSelectedInstOperands,
     /*   23815 */     // GIR_Coverage, 70627,
     /*   23815 */     GIR_EraseRootFromParent_Done,
     /*   23816 */   // Label 461: @23816
     /*   23816 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23871), // Rule ID 69614 //
     /*   23821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23849 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   23852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23869 */     GIR_RootConstrainSelectedInstOperands,
     /*   23870 */     // GIR_Coverage, 69614,
     /*   23870 */     GIR_EraseRootFromParent_Done,
     /*   23871 */   // Label 462: @23871
     /*   23871 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23926), // Rule ID 69615 //
     /*   23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23891 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23904 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   23904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   23907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23924 */     GIR_RootConstrainSelectedInstOperands,
     /*   23925 */     // GIR_Coverage, 69615,
     /*   23925 */     GIR_EraseRootFromParent_Done,
     /*   23926 */   // Label 463: @23926
     /*   23926 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23981), // Rule ID 69434 //
     /*   23931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   23946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23959 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   23959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   23962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23979 */     GIR_RootConstrainSelectedInstOperands,
     /*   23980 */     // GIR_Coverage, 69434,
     /*   23980 */     GIR_EraseRootFromParent_Done,
     /*   23981 */   // Label 464: @23981
     /*   23981 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(24036), // Rule ID 69435 //
     /*   23986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24001 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24014 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24034 */     GIR_RootConstrainSelectedInstOperands,
     /*   24035 */     // GIR_Coverage, 69435,
     /*   24035 */     GIR_EraseRootFromParent_Done,
     /*   24036 */   // Label 465: @24036
     /*   24036 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(24091), // Rule ID 69524 //
     /*   24041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24056 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24069 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24089 */     GIR_RootConstrainSelectedInstOperands,
     /*   24090 */     // GIR_Coverage, 69524,
     /*   24090 */     GIR_EraseRootFromParent_Done,
     /*   24091 */   // Label 466: @24091
     /*   24091 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(24146), // Rule ID 69525 //
     /*   24096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24124 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24144 */     GIR_RootConstrainSelectedInstOperands,
     /*   24145 */     // GIR_Coverage, 69525,
     /*   24145 */     GIR_EraseRootFromParent_Done,
     /*   24146 */   // Label 467: @24146
     /*   24146 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(24214), // Rule ID 51872 //
     /*   24151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24188 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24212 */     GIR_RootConstrainSelectedInstOperands,
     /*   24213 */     // GIR_Coverage, 51872,
     /*   24213 */     GIR_EraseRootFromParent_Done,
     /*   24214 */   // Label 468: @24214
     /*   24214 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(24282), // Rule ID 51873 //
     /*   24219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   24242 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24256 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   24259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   24265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24280 */     GIR_RootConstrainSelectedInstOperands,
     /*   24281 */     // GIR_Coverage, 51873,
     /*   24281 */     GIR_EraseRootFromParent_Done,
     /*   24282 */   // Label 469: @24282
     /*   24282 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(24337), // Rule ID 46738 //
     /*   24287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24315 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24335 */     GIR_RootConstrainSelectedInstOperands,
     /*   24336 */     // GIR_Coverage, 46738,
     /*   24336 */     GIR_EraseRootFromParent_Done,
     /*   24337 */   // Label 470: @24337
     /*   24337 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24392), // Rule ID 46739 //
     /*   24342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   24357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24370 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24390 */     GIR_RootConstrainSelectedInstOperands,
     /*   24391 */     // GIR_Coverage, 46739,
     /*   24391 */     GIR_EraseRootFromParent_Done,
     /*   24392 */   // Label 471: @24392
     /*   24392 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24447), // Rule ID 46498 //
     /*   24397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24425 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24445 */     GIR_RootConstrainSelectedInstOperands,
     /*   24446 */     // GIR_Coverage, 46498,
     /*   24446 */     GIR_EraseRootFromParent_Done,
     /*   24447 */   // Label 472: @24447
     /*   24447 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24502), // Rule ID 46499 //
     /*   24452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24471 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24480 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   24483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24500 */     GIR_RootConstrainSelectedInstOperands,
     /*   24501 */     // GIR_Coverage, 46499,
     /*   24501 */     GIR_EraseRootFromParent_Done,
     /*   24502 */   // Label 473: @24502
     /*   24502 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24557), // Rule ID 46618 //
     /*   24507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24526 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24535 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   24535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24555 */     GIR_RootConstrainSelectedInstOperands,
     /*   24556 */     // GIR_Coverage, 46618,
     /*   24556 */     GIR_EraseRootFromParent_Done,
     /*   24557 */   // Label 474: @24557
     /*   24557 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24612), // Rule ID 46619 //
     /*   24562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   24581 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   24590 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   24590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   24593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   24597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   24601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24610 */     GIR_RootConstrainSelectedInstOperands,
     /*   24611 */     // GIR_Coverage, 46619,
     /*   24611 */     GIR_EraseRootFromParent_Done,
     /*   24612 */   // Label 475: @24612
     /*   24612 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24665), // Rule ID 46104 //
     /*   24617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24628 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   24628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   24645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24663 */     GIR_RootConstrainSelectedInstOperands,
     /*   24664 */     // GIR_Coverage, 46104,
     /*   24664 */     GIR_EraseRootFromParent_Done,
     /*   24665 */   // Label 476: @24665
     /*   24665 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24718), // Rule ID 46105 //
     /*   24670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24681 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   24681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   24684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   24688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   24693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   24695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   24698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   24705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   24707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   24716 */     GIR_RootConstrainSelectedInstOperands,
     /*   24717 */     // GIR_Coverage, 46105,
     /*   24717 */     GIR_EraseRootFromParent_Done,
     /*   24718 */   // Label 477: @24718
     /*   24718 */   GIM_Reject,
     /*   24719 */ // Label 437: @24719
     /*   24719 */ GIM_Reject,
     /*   24720 */ // Label 134: @24720
     /*   24720 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(27844),
     /*   24725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24735 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24831), // Rule ID 70826 //
     /*   24740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24759 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24773 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24788 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24792 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24794 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24805 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   24808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24829 */     GIR_RootConstrainSelectedInstOperands,
     /*   24830 */     // GIR_Coverage, 70826,
     /*   24830 */     GIR_EraseRootFromParent_Done,
     /*   24831 */   // Label 479: @24831
     /*   24831 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(24927), // Rule ID 70827 //
     /*   24836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   24839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24855 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24869 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24888 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24890 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24901 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   24901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   24904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   24922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24925 */     GIR_RootConstrainSelectedInstOperands,
     /*   24926 */     // GIR_Coverage, 70827,
     /*   24926 */     GIR_EraseRootFromParent_Done,
     /*   24927 */   // Label 480: @24927
     /*   24927 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(25023), // Rule ID 71090 //
     /*   24932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   24935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   24951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24980 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   24984 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24986 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24997 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   24997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25021 */     GIR_RootConstrainSelectedInstOperands,
     /*   25022 */     // GIR_Coverage, 71090,
     /*   25022 */     GIR_EraseRootFromParent_Done,
     /*   25023 */   // Label 481: @25023
     /*   25023 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(25119), // Rule ID 71091 //
     /*   25028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25047 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25061 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25063 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25080 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25082 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25091 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25093 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25117 */     GIR_RootConstrainSelectedInstOperands,
     /*   25118 */     // GIR_Coverage, 71091,
     /*   25118 */     GIR_EraseRootFromParent_Done,
     /*   25119 */   // Label 482: @25119
     /*   25119 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(25215), // Rule ID 71092 //
     /*   25124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25143 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25157 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25176 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25178 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25189 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25213 */     GIR_RootConstrainSelectedInstOperands,
     /*   25214 */     // GIR_Coverage, 71092,
     /*   25214 */     GIR_EraseRootFromParent_Done,
     /*   25215 */   // Label 483: @25215
     /*   25215 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(25311), // Rule ID 71093 //
     /*   25220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25253 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25268 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25272 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25285 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25309 */     GIR_RootConstrainSelectedInstOperands,
     /*   25310 */     // GIR_Coverage, 71093,
     /*   25310 */     GIR_EraseRootFromParent_Done,
     /*   25311 */   // Label 484: @25311
     /*   25311 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(25407), // Rule ID 70940 //
     /*   25316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25335 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25349 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25368 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25370 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25381 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25405 */     GIR_RootConstrainSelectedInstOperands,
     /*   25406 */     // GIR_Coverage, 70940,
     /*   25406 */     GIR_EraseRootFromParent_Done,
     /*   25407 */   // Label 485: @25407
     /*   25407 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(25503), // Rule ID 70941 //
     /*   25412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25445 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25464 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25466 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25477 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   25480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   25484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25501 */     GIR_RootConstrainSelectedInstOperands,
     /*   25502 */     // GIR_Coverage, 70941,
     /*   25502 */     GIR_EraseRootFromParent_Done,
     /*   25503 */   // Label 486: @25503
     /*   25503 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(25599), // Rule ID 52044 //
     /*   25508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25545 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25560 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25564 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25566 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25571 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25573 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25597 */     GIR_RootConstrainSelectedInstOperands,
     /*   25598 */     // GIR_Coverage, 52044,
     /*   25598 */     GIR_EraseRootFromParent_Done,
     /*   25599 */   // Label 487: @25599
     /*   25599 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(25695), // Rule ID 52045 //
     /*   25604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25627 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25641 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25660 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25662 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25669 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   25672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25693 */     GIR_RootConstrainSelectedInstOperands,
     /*   25694 */     // GIR_Coverage, 52045,
     /*   25694 */     GIR_EraseRootFromParent_Done,
     /*   25695 */   // Label 488: @25695
     /*   25695 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(25791), // Rule ID 52162 //
     /*   25700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25723 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25737 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25756 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25758 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25765 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25789 */     GIR_RootConstrainSelectedInstOperands,
     /*   25790 */     // GIR_Coverage, 52162,
     /*   25790 */     GIR_EraseRootFromParent_Done,
     /*   25791 */   // Label 489: @25791
     /*   25791 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(25887), // Rule ID 52163 //
     /*   25796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25833 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25852 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25854 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25861 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   25861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25885 */     GIR_RootConstrainSelectedInstOperands,
     /*   25886 */     // GIR_Coverage, 52163,
     /*   25886 */     GIR_EraseRootFromParent_Done,
     /*   25887 */   // Label 490: @25887
     /*   25887 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(25983), // Rule ID 71088 //
     /*   25892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   25895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   25915 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25929 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   25948 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25950 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25957 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   25957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   25960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   25978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25981 */     GIR_RootConstrainSelectedInstOperands,
     /*   25982 */     // GIR_Coverage, 71088,
     /*   25982 */     GIR_EraseRootFromParent_Done,
     /*   25983 */   // Label 491: @25983
     /*   25983 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(26079), // Rule ID 71089 //
     /*   25988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   25991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26025 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26032 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26036 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26040 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26044 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26046 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26053 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   26056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   26064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   26068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26077 */     GIR_RootConstrainSelectedInstOperands,
     /*   26078 */     // GIR_Coverage, 71089,
     /*   26078 */     GIR_EraseRootFromParent_Done,
     /*   26079 */   // Label 492: @26079
     /*   26079 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(26175), // Rule ID 52102 //
     /*   26084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26121 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26140 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26142 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26149 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26173 */     GIR_RootConstrainSelectedInstOperands,
     /*   26174 */     // GIR_Coverage, 52102,
     /*   26174 */     GIR_EraseRootFromParent_Done,
     /*   26175 */   // Label 493: @26175
     /*   26175 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(26271), // Rule ID 52103 //
     /*   26180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26199 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26203 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   26209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   26228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26232 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26236 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   26238 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   26245 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   26245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   26248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   26252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   26260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26269 */     GIR_RootConstrainSelectedInstOperands,
     /*   26270 */     // GIR_Coverage, 52103,
     /*   26270 */     GIR_EraseRootFromParent_Done,
     /*   26271 */   // Label 494: @26271
     /*   26271 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(26360), // Rule ID 46702 //
     /*   26276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26310 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26319 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26358 */     GIR_RootConstrainSelectedInstOperands,
     /*   26359 */     // GIR_Coverage, 46702,
     /*   26359 */     GIR_EraseRootFromParent_Done,
     /*   26360 */   // Label 495: @26360
     /*   26360 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(26449), // Rule ID 46703 //
     /*   26365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26380 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26399 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26408 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26447 */     GIR_RootConstrainSelectedInstOperands,
     /*   26448 */     // GIR_Coverage, 46703,
     /*   26448 */     GIR_EraseRootFromParent_Done,
     /*   26449 */   // Label 496: @26449
     /*   26449 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(26538), // Rule ID 46466 //
     /*   26454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26488 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26497 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26536 */     GIR_RootConstrainSelectedInstOperands,
     /*   26537 */     // GIR_Coverage, 46466,
     /*   26537 */     GIR_EraseRootFromParent_Done,
     /*   26538 */   // Label 497: @26538
     /*   26538 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(26627), // Rule ID 46467 //
     /*   26543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26577 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26586 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   26603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26625 */     GIR_RootConstrainSelectedInstOperands,
     /*   26626 */     // GIR_Coverage, 46467,
     /*   26626 */     GIR_EraseRootFromParent_Done,
     /*   26627 */   // Label 498: @26627
     /*   26627 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(26716), // Rule ID 46582 //
     /*   26632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26666 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26675 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   26675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26714 */     GIR_RootConstrainSelectedInstOperands,
     /*   26715 */     // GIR_Coverage, 46582,
     /*   26715 */     GIR_EraseRootFromParent_Done,
     /*   26716 */   // Label 499: @26716
     /*   26716 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(26805), // Rule ID 46583 //
     /*   26721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   26747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26755 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   26757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   26764 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   26764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   26767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   26781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   26790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   26794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26803 */     GIR_RootConstrainSelectedInstOperands,
     /*   26804 */     // GIR_Coverage, 46583,
     /*   26804 */     GIR_EraseRootFromParent_Done,
     /*   26805 */   // Label 500: @26805
     /*   26805 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(26873), // Rule ID 70658 //
     /*   26810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26829 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26847 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   26847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   26850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26871 */     GIR_RootConstrainSelectedInstOperands,
     /*   26872 */     // GIR_Coverage, 70658,
     /*   26872 */     GIR_EraseRootFromParent_Done,
     /*   26873 */   // Label 501: @26873
     /*   26873 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(26941), // Rule ID 70659 //
     /*   26878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   26897 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26915 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   26918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26939 */     GIR_RootConstrainSelectedInstOperands,
     /*   26940 */     // GIR_Coverage, 70659,
     /*   26940 */     GIR_EraseRootFromParent_Done,
     /*   26941 */   // Label 502: @26941
     /*   26941 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(26996), // Rule ID 69638 //
     /*   26946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   26961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26974 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   26974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   26977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   26991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26994 */     GIR_RootConstrainSelectedInstOperands,
     /*   26995 */     // GIR_Coverage, 69638,
     /*   26995 */     GIR_EraseRootFromParent_Done,
     /*   26996 */   // Label 503: @26996
     /*   26996 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(27051), // Rule ID 69639 //
     /*   27001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27029 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27049 */     GIR_RootConstrainSelectedInstOperands,
     /*   27050 */     // GIR_Coverage, 69639,
     /*   27050 */     GIR_EraseRootFromParent_Done,
     /*   27051 */   // Label 504: @27051
     /*   27051 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(27106), // Rule ID 69458 //
     /*   27056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27084 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27104 */     GIR_RootConstrainSelectedInstOperands,
     /*   27105 */     // GIR_Coverage, 69458,
     /*   27105 */     GIR_EraseRootFromParent_Done,
     /*   27106 */   // Label 505: @27106
     /*   27106 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(27161), // Rule ID 69459 //
     /*   27111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27139 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27159 */     GIR_RootConstrainSelectedInstOperands,
     /*   27160 */     // GIR_Coverage, 69459,
     /*   27160 */     GIR_EraseRootFromParent_Done,
     /*   27161 */   // Label 506: @27161
     /*   27161 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(27216), // Rule ID 69548 //
     /*   27166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27194 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27214 */     GIR_RootConstrainSelectedInstOperands,
     /*   27215 */     // GIR_Coverage, 69548,
     /*   27215 */     GIR_EraseRootFromParent_Done,
     /*   27216 */   // Label 507: @27216
     /*   27216 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(27271), // Rule ID 69549 //
     /*   27221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27249 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27269 */     GIR_RootConstrainSelectedInstOperands,
     /*   27270 */     // GIR_Coverage, 69549,
     /*   27270 */     GIR_EraseRootFromParent_Done,
     /*   27271 */   // Label 508: @27271
     /*   27271 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(27339), // Rule ID 51888 //
     /*   27276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27313 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27337 */     GIR_RootConstrainSelectedInstOperands,
     /*   27338 */     // GIR_Coverage, 51888,
     /*   27338 */     GIR_EraseRootFromParent_Done,
     /*   27339 */   // Label 509: @27339
     /*   27339 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(27407), // Rule ID 51889 //
     /*   27344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   27367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27381 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   27381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   27384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27405 */     GIR_RootConstrainSelectedInstOperands,
     /*   27406 */     // GIR_Coverage, 51889,
     /*   27406 */     GIR_EraseRootFromParent_Done,
     /*   27407 */   // Label 510: @27407
     /*   27407 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(27462), // Rule ID 46762 //
     /*   27412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27440 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27460 */     GIR_RootConstrainSelectedInstOperands,
     /*   27461 */     // GIR_Coverage, 46762,
     /*   27461 */     GIR_EraseRootFromParent_Done,
     /*   27462 */   // Label 511: @27462
     /*   27462 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(27517), // Rule ID 46763 //
     /*   27467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   27482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27495 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27515 */     GIR_RootConstrainSelectedInstOperands,
     /*   27516 */     // GIR_Coverage, 46763,
     /*   27516 */     GIR_EraseRootFromParent_Done,
     /*   27517 */   // Label 512: @27517
     /*   27517 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(27572), // Rule ID 46522 //
     /*   27522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27550 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27570 */     GIR_RootConstrainSelectedInstOperands,
     /*   27571 */     // GIR_Coverage, 46522,
     /*   27571 */     GIR_EraseRootFromParent_Done,
     /*   27572 */   // Label 513: @27572
     /*   27572 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(27627), // Rule ID 46523 //
     /*   27577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27605 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   27608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27625 */     GIR_RootConstrainSelectedInstOperands,
     /*   27626 */     // GIR_Coverage, 46523,
     /*   27626 */     GIR_EraseRootFromParent_Done,
     /*   27627 */   // Label 514: @27627
     /*   27627 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(27682), // Rule ID 46642 //
     /*   27632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27660 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   27660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27680 */     GIR_RootConstrainSelectedInstOperands,
     /*   27681 */     // GIR_Coverage, 46642,
     /*   27681 */     GIR_EraseRootFromParent_Done,
     /*   27682 */   // Label 515: @27682
     /*   27682 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(27737), // Rule ID 46643 //
     /*   27687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   27706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27715 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   27715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   27718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   27732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27735 */     GIR_RootConstrainSelectedInstOperands,
     /*   27736 */     // GIR_Coverage, 46643,
     /*   27736 */     GIR_EraseRootFromParent_Done,
     /*   27737 */   // Label 516: @27737
     /*   27737 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(27790), // Rule ID 46120 //
     /*   27742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27753 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   27753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   27770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27788 */     GIR_RootConstrainSelectedInstOperands,
     /*   27789 */     // GIR_Coverage, 46120,
     /*   27789 */     GIR_EraseRootFromParent_Done,
     /*   27790 */   // Label 517: @27790
     /*   27790 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(27843), // Rule ID 46121 //
     /*   27795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27806 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   27806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   27809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   27823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27841 */     GIR_RootConstrainSelectedInstOperands,
     /*   27842 */     // GIR_Coverage, 46121,
     /*   27842 */     GIR_EraseRootFromParent_Done,
     /*   27843 */   // Label 518: @27843
     /*   27843 */   GIM_Reject,
     /*   27844 */ // Label 478: @27844
     /*   27844 */ GIM_Reject,
     /*   27845 */ // Label 135: @27845
     /*   27845 */ GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(30969),
     /*   27850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   27860 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(27956), // Rule ID 70836 //
     /*   27865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   27868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27884 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27898 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27917 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   27928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27930 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   27930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   27933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   27945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   27951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27954 */     GIR_RootConstrainSelectedInstOperands,
     /*   27955 */     // GIR_Coverage, 70836,
     /*   27955 */     GIR_EraseRootFromParent_Done,
     /*   27956 */   // Label 520: @27956
     /*   27956 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(28052), // Rule ID 70837 //
     /*   27961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   27964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   27976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   27980 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   27994 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28013 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28026 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28050 */     GIR_RootConstrainSelectedInstOperands,
     /*   28051 */     // GIR_Coverage, 70837,
     /*   28051 */     GIR_EraseRootFromParent_Done,
     /*   28052 */   // Label 521: @28052
     /*   28052 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(28148), // Rule ID 71120 //
     /*   28057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28090 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28109 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28111 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28122 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28146 */     GIR_RootConstrainSelectedInstOperands,
     /*   28147 */     // GIR_Coverage, 71120,
     /*   28147 */     GIR_EraseRootFromParent_Done,
     /*   28148 */   // Label 522: @28148
     /*   28148 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(28244), // Rule ID 71121 //
     /*   28153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28172 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28186 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28193 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28197 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28201 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28205 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28207 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28218 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28242 */     GIR_RootConstrainSelectedInstOperands,
     /*   28243 */     // GIR_Coverage, 71121,
     /*   28243 */     GIR_EraseRootFromParent_Done,
     /*   28244 */   // Label 523: @28244
     /*   28244 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(28340), // Rule ID 71122 //
     /*   28249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28268 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28278 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28282 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28301 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28303 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28314 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28338 */     GIR_RootConstrainSelectedInstOperands,
     /*   28339 */     // GIR_Coverage, 71122,
     /*   28339 */     GIR_EraseRootFromParent_Done,
     /*   28340 */   // Label 524: @28340
     /*   28340 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(28436), // Rule ID 71123 //
     /*   28345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28364 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28378 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28393 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28397 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28399 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28410 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28434 */     GIR_RootConstrainSelectedInstOperands,
     /*   28435 */     // GIR_Coverage, 71123,
     /*   28435 */     GIR_EraseRootFromParent_Done,
     /*   28436 */   // Label 525: @28436
     /*   28436 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(28532), // Rule ID 70950 //
     /*   28441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28460 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28489 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28493 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28495 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28506 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28530 */     GIR_RootConstrainSelectedInstOperands,
     /*   28531 */     // GIR_Coverage, 70950,
     /*   28531 */     GIR_EraseRootFromParent_Done,
     /*   28532 */   // Label 526: @28532
     /*   28532 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(28628), // Rule ID 70951 //
     /*   28537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28570 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28577 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28581 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28585 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28589 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28591 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28602 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   28605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28626 */     GIR_RootConstrainSelectedInstOperands,
     /*   28627 */     // GIR_Coverage, 70951,
     /*   28627 */     GIR_EraseRootFromParent_Done,
     /*   28628 */   // Label 527: @28628
     /*   28628 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(28724), // Rule ID 52054 //
     /*   28633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28689 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28698 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28722 */     GIR_RootConstrainSelectedInstOperands,
     /*   28723 */     // GIR_Coverage, 52054,
     /*   28723 */     GIR_EraseRootFromParent_Done,
     /*   28724 */   // Label 528: @28724
     /*   28724 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(28820), // Rule ID 52055 //
     /*   28729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28781 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28785 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28794 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   28797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28818 */     GIR_RootConstrainSelectedInstOperands,
     /*   28819 */     // GIR_Coverage, 52055,
     /*   28819 */     GIR_EraseRootFromParent_Done,
     /*   28820 */   // Label 529: @28820
     /*   28820 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(28916), // Rule ID 52172 //
     /*   28825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   28828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28881 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28883 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28890 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   28890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   28911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28914 */     GIR_RootConstrainSelectedInstOperands,
     /*   28915 */     // GIR_Coverage, 52172,
     /*   28915 */     GIR_EraseRootFromParent_Done,
     /*   28916 */   // Label 530: @28916
     /*   28916 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(29012), // Rule ID 52173 //
     /*   28921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   28924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   28928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   28940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   28944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   28977 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28986 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   28986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   28989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29010 */     GIR_RootConstrainSelectedInstOperands,
     /*   29011 */     // GIR_Coverage, 52173,
     /*   29011 */     GIR_EraseRootFromParent_Done,
     /*   29012 */   // Label 531: @29012
     /*   29012 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(29108), // Rule ID 71118 //
     /*   29017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29069 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29073 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29082 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29106 */     GIR_RootConstrainSelectedInstOperands,
     /*   29107 */     // GIR_Coverage, 71118,
     /*   29107 */     GIR_EraseRootFromParent_Done,
     /*   29108 */   // Label 532: @29108
     /*   29108 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(29204), // Rule ID 71119 //
     /*   29113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29150 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29169 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29171 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29178 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   29181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   29189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   29193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29202 */     GIR_RootConstrainSelectedInstOperands,
     /*   29203 */     // GIR_Coverage, 71119,
     /*   29203 */     GIR_EraseRootFromParent_Done,
     /*   29204 */   // Label 533: @29204
     /*   29204 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(29300), // Rule ID 52112 //
     /*   29209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29232 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29246 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29265 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29267 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29274 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   29274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29298 */     GIR_RootConstrainSelectedInstOperands,
     /*   29299 */     // GIR_Coverage, 52112,
     /*   29299 */     GIR_EraseRootFromParent_Done,
     /*   29300 */   // Label 534: @29300
     /*   29300 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(29396), // Rule ID 52113 //
     /*   29305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   29334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29342 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   29353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29361 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   29363 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29368 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   29370 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   29370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   29373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   29377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   29385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29394 */     GIR_RootConstrainSelectedInstOperands,
     /*   29395 */     // GIR_Coverage, 52113,
     /*   29395 */     GIR_EraseRootFromParent_Done,
     /*   29396 */   // Label 535: @29396
     /*   29396 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(29485), // Rule ID 46722 //
     /*   29401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29435 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29444 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29483 */     GIR_RootConstrainSelectedInstOperands,
     /*   29484 */     // GIR_Coverage, 46722,
     /*   29484 */     GIR_EraseRootFromParent_Done,
     /*   29485 */   // Label 536: @29485
     /*   29485 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(29574), // Rule ID 46723 //
     /*   29490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29505 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29524 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29526 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29533 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29572 */     GIR_RootConstrainSelectedInstOperands,
     /*   29573 */     // GIR_Coverage, 46723,
     /*   29573 */     GIR_EraseRootFromParent_Done,
     /*   29574 */   // Label 537: @29574
     /*   29574 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(29663), // Rule ID 46486 //
     /*   29579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29594 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29601 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29605 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29609 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29613 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29622 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   29639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29661 */     GIR_RootConstrainSelectedInstOperands,
     /*   29662 */     // GIR_Coverage, 46486,
     /*   29662 */     GIR_EraseRootFromParent_Done,
     /*   29663 */   // Label 538: @29663
     /*   29663 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(29752), // Rule ID 46487 //
     /*   29668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29683 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29702 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29711 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   29728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29750 */     GIR_RootConstrainSelectedInstOperands,
     /*   29751 */     // GIR_Coverage, 46487,
     /*   29751 */     GIR_EraseRootFromParent_Done,
     /*   29752 */   // Label 539: @29752
     /*   29752 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(29841), // Rule ID 46602 //
     /*   29757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   29760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29791 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29800 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   29800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29839 */     GIR_RootConstrainSelectedInstOperands,
     /*   29840 */     // GIR_Coverage, 46602,
     /*   29840 */     GIR_EraseRootFromParent_Done,
     /*   29841 */   // Label 540: @29841
     /*   29841 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(29930), // Rule ID 46603 //
     /*   29846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   29849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29861 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   29880 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29889 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   29889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   29892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   29906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   29925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29928 */     GIR_RootConstrainSelectedInstOperands,
     /*   29929 */     // GIR_Coverage, 46603,
     /*   29929 */     GIR_EraseRootFromParent_Done,
     /*   29930 */   // Label 541: @29930
     /*   29930 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(29998), // Rule ID 70746 //
     /*   29935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   29938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   29950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   29954 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   29970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29972 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   29972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   29975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   29981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   29993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29996 */     GIR_RootConstrainSelectedInstOperands,
     /*   29997 */     // GIR_Coverage, 70746,
     /*   29997 */     GIR_EraseRootFromParent_Done,
     /*   29998 */   // Label 542: @29998
     /*   29998 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(30066), // Rule ID 70747 //
     /*   30003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30040 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30064 */     GIR_RootConstrainSelectedInstOperands,
     /*   30065 */     // GIR_Coverage, 70747,
     /*   30065 */     GIR_EraseRootFromParent_Done,
     /*   30066 */   // Label 543: @30066
     /*   30066 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(30121), // Rule ID 69658 //
     /*   30071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30099 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30119 */     GIR_RootConstrainSelectedInstOperands,
     /*   30120 */     // GIR_Coverage, 69658,
     /*   30120 */     GIR_EraseRootFromParent_Done,
     /*   30121 */   // Label 544: @30121
     /*   30121 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(30176), // Rule ID 69659 //
     /*   30126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30141 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30154 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30174 */     GIR_RootConstrainSelectedInstOperands,
     /*   30175 */     // GIR_Coverage, 69659,
     /*   30175 */     GIR_EraseRootFromParent_Done,
     /*   30176 */   // Label 545: @30176
     /*   30176 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(30231), // Rule ID 69478 //
     /*   30181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30209 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30229 */     GIR_RootConstrainSelectedInstOperands,
     /*   30230 */     // GIR_Coverage, 69478,
     /*   30230 */     GIR_EraseRootFromParent_Done,
     /*   30231 */   // Label 546: @30231
     /*   30231 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(30286), // Rule ID 69479 //
     /*   30236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30264 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30284 */     GIR_RootConstrainSelectedInstOperands,
     /*   30285 */     // GIR_Coverage, 69479,
     /*   30285 */     GIR_EraseRootFromParent_Done,
     /*   30286 */   // Label 547: @30286
     /*   30286 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(30341), // Rule ID 69568 //
     /*   30291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30319 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30339 */     GIR_RootConstrainSelectedInstOperands,
     /*   30340 */     // GIR_Coverage, 69568,
     /*   30340 */     GIR_EraseRootFromParent_Done,
     /*   30341 */   // Label 548: @30341
     /*   30341 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(30396), // Rule ID 69569 //
     /*   30346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30374 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30394 */     GIR_RootConstrainSelectedInstOperands,
     /*   30395 */     // GIR_Coverage, 69569,
     /*   30395 */     GIR_EraseRootFromParent_Done,
     /*   30396 */   // Label 549: @30396
     /*   30396 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(30464), // Rule ID 51932 //
     /*   30401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30438 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   30438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30462 */     GIR_RootConstrainSelectedInstOperands,
     /*   30463 */     // GIR_Coverage, 51932,
     /*   30463 */     GIR_EraseRootFromParent_Done,
     /*   30464 */   // Label 550: @30464
     /*   30464 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(30532), // Rule ID 51933 //
     /*   30469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   30488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   30492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30506 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   30506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   30509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   30515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30530 */     GIR_RootConstrainSelectedInstOperands,
     /*   30531 */     // GIR_Coverage, 51933,
     /*   30531 */     GIR_EraseRootFromParent_Done,
     /*   30532 */   // Label 551: @30532
     /*   30532 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(30587), // Rule ID 46782 //
     /*   30537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30565 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30585 */     GIR_RootConstrainSelectedInstOperands,
     /*   30586 */     // GIR_Coverage, 46782,
     /*   30586 */     GIR_EraseRootFromParent_Done,
     /*   30587 */   // Label 552: @30587
     /*   30587 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(30642), // Rule ID 46783 //
     /*   30592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30620 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30640 */     GIR_RootConstrainSelectedInstOperands,
     /*   30641 */     // GIR_Coverage, 46783,
     /*   30641 */     GIR_EraseRootFromParent_Done,
     /*   30642 */   // Label 553: @30642
     /*   30642 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(30697), // Rule ID 46542 //
     /*   30647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30675 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30695 */     GIR_RootConstrainSelectedInstOperands,
     /*   30696 */     // GIR_Coverage, 46542,
     /*   30696 */     GIR_EraseRootFromParent_Done,
     /*   30697 */   // Label 554: @30697
     /*   30697 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(30752), // Rule ID 46543 //
     /*   30702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30730 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   30733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30750 */     GIR_RootConstrainSelectedInstOperands,
     /*   30751 */     // GIR_Coverage, 46543,
     /*   30751 */     GIR_EraseRootFromParent_Done,
     /*   30752 */   // Label 555: @30752
     /*   30752 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(30807), // Rule ID 46662 //
     /*   30757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   30760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30785 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   30785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30805 */     GIR_RootConstrainSelectedInstOperands,
     /*   30806 */     // GIR_Coverage, 46662,
     /*   30806 */     GIR_EraseRootFromParent_Done,
     /*   30807 */   // Label 556: @30807
     /*   30807 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(30862), // Rule ID 46663 //
     /*   30812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   30815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   30831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30840 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   30840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   30843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   30857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30860 */     GIR_RootConstrainSelectedInstOperands,
     /*   30861 */     // GIR_Coverage, 46663,
     /*   30861 */     GIR_EraseRootFromParent_Done,
     /*   30862 */   // Label 557: @30862
     /*   30862 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(30915), // Rule ID 46164 //
     /*   30867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   30870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30878 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   30878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   30895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30913 */     GIR_RootConstrainSelectedInstOperands,
     /*   30914 */     // GIR_Coverage, 46164,
     /*   30914 */     GIR_EraseRootFromParent_Done,
     /*   30915 */   // Label 558: @30915
     /*   30915 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(30968), // Rule ID 46165 //
     /*   30920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   30923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30931 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   30931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   30934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   30948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   30963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30966 */     GIR_RootConstrainSelectedInstOperands,
     /*   30967 */     // GIR_Coverage, 46165,
     /*   30967 */     GIR_EraseRootFromParent_Done,
     /*   30968 */   // Label 559: @30968
     /*   30968 */   GIM_Reject,
     /*   30969 */ // Label 519: @30969
     /*   30969 */ GIM_Reject,
     /*   30970 */ // Label 136: @30970
     /*   30970 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(31364),
     /*   30975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   30978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   30981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30985 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(31053), // Rule ID 70610 //
     /*   30990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31027 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31051 */     GIR_RootConstrainSelectedInstOperands,
     /*   31052 */     // GIR_Coverage, 70610,
     /*   31052 */     GIR_EraseRootFromParent_Done,
     /*   31053 */   // Label 561: @31053
     /*   31053 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(31121), // Rule ID 70611 //
     /*   31058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31077 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31095 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31119 */     GIR_RootConstrainSelectedInstOperands,
     /*   31120 */     // GIR_Coverage, 70611,
     /*   31120 */     GIR_EraseRootFromParent_Done,
     /*   31121 */   // Label 562: @31121
     /*   31121 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(31189), // Rule ID 51864 //
     /*   31126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31163 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31187 */     GIR_RootConstrainSelectedInstOperands,
     /*   31188 */     // GIR_Coverage, 51864,
     /*   31188 */     GIR_EraseRootFromParent_Done,
     /*   31189 */   // Label 563: @31189
     /*   31189 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(31257), // Rule ID 51865 //
     /*   31194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   31217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   31231 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   31234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   31240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   31244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   31246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31255 */     GIR_RootConstrainSelectedInstOperands,
     /*   31256 */     // GIR_Coverage, 51865,
     /*   31256 */     GIR_EraseRootFromParent_Done,
     /*   31257 */   // Label 564: @31257
     /*   31257 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(31310), // Rule ID 46096 //
     /*   31262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31273 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   31273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31308 */     GIR_RootConstrainSelectedInstOperands,
     /*   31309 */     // GIR_Coverage, 46096,
     /*   31309 */     GIR_EraseRootFromParent_Done,
     /*   31310 */   // Label 565: @31310
     /*   31310 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(31363), // Rule ID 46097 //
     /*   31315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31326 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   31326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   31329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   31343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   31348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   31350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   31352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31361 */     GIR_RootConstrainSelectedInstOperands,
     /*   31362 */     // GIR_Coverage, 46097,
     /*   31362 */     GIR_EraseRootFromParent_Done,
     /*   31363 */   // Label 566: @31363
     /*   31363 */   GIM_Reject,
     /*   31364 */ // Label 560: @31364
     /*   31364 */ GIM_Reject,
     /*   31365 */ // Label 137: @31365
     /*   31365 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(34489),
     /*   31370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31380 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(31476), // Rule ID 70816 //
     /*   31385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31404 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31418 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31433 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31437 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31439 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31450 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31474 */     GIR_RootConstrainSelectedInstOperands,
     /*   31475 */     // GIR_Coverage, 70816,
     /*   31475 */     GIR_EraseRootFromParent_Done,
     /*   31476 */   // Label 568: @31476
     /*   31476 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(31572), // Rule ID 70817 //
     /*   31481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31514 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31521 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31525 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31529 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31533 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31535 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31544 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31546 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   31549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31570 */     GIR_RootConstrainSelectedInstOperands,
     /*   31571 */     // GIR_Coverage, 70817,
     /*   31571 */     GIR_EraseRootFromParent_Done,
     /*   31572 */   // Label 569: @31572
     /*   31572 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(31668), // Rule ID 71060 //
     /*   31577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31610 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31625 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31629 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31631 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31642 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31666 */     GIR_RootConstrainSelectedInstOperands,
     /*   31667 */     // GIR_Coverage, 71060,
     /*   31667 */     GIR_EraseRootFromParent_Done,
     /*   31668 */   // Label 570: @31668
     /*   31668 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(31764), // Rule ID 71061 //
     /*   31673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31692 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31706 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31713 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31717 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31721 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31725 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31727 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31738 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31762 */     GIR_RootConstrainSelectedInstOperands,
     /*   31763 */     // GIR_Coverage, 71061,
     /*   31763 */     GIR_EraseRootFromParent_Done,
     /*   31764 */   // Label 571: @31764
     /*   31764 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(31860), // Rule ID 71062 //
     /*   31769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31802 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31821 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31823 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31834 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   31834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31858 */     GIR_RootConstrainSelectedInstOperands,
     /*   31859 */     // GIR_Coverage, 71062,
     /*   31859 */     GIR_EraseRootFromParent_Done,
     /*   31860 */   // Label 572: @31860
     /*   31860 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(31956), // Rule ID 71063 //
     /*   31865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31884 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31898 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31913 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31917 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31930 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   31930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   31933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   31951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31954 */     GIR_RootConstrainSelectedInstOperands,
     /*   31955 */     // GIR_Coverage, 71063,
     /*   31955 */     GIR_EraseRootFromParent_Done,
     /*   31956 */   // Label 573: @31956
     /*   31956 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(32052), // Rule ID 70930 //
     /*   31961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   31980 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   31994 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32013 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32026 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32050 */     GIR_RootConstrainSelectedInstOperands,
     /*   32051 */     // GIR_Coverage, 70930,
     /*   32051 */     GIR_EraseRootFromParent_Done,
     /*   32052 */   // Label 574: @32052
     /*   32052 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(32148), // Rule ID 70931 //
     /*   32057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32090 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32097 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32101 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32105 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32109 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32111 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32122 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   32129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32146 */     GIR_RootConstrainSelectedInstOperands,
     /*   32147 */     // GIR_Coverage, 70931,
     /*   32147 */     GIR_EraseRootFromParent_Done,
     /*   32148 */   // Label 575: @32148
     /*   32148 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(32244), // Rule ID 52034 //
     /*   32153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32176 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32190 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32209 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32211 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32216 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32218 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32242 */     GIR_RootConstrainSelectedInstOperands,
     /*   32243 */     // GIR_Coverage, 52034,
     /*   32243 */     GIR_EraseRootFromParent_Done,
     /*   32244 */   // Label 576: @32244
     /*   32244 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(32340), // Rule ID 52035 //
     /*   32249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32286 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32301 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32305 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32307 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32312 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32314 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   32317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32338 */     GIR_RootConstrainSelectedInstOperands,
     /*   32339 */     // GIR_Coverage, 52035,
     /*   32339 */     GIR_EraseRootFromParent_Done,
     /*   32340 */   // Label 577: @32340
     /*   32340 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(32436), // Rule ID 52152 //
     /*   32345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32382 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32397 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32401 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32410 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32434 */     GIR_RootConstrainSelectedInstOperands,
     /*   32435 */     // GIR_Coverage, 52152,
     /*   32435 */     GIR_EraseRootFromParent_Done,
     /*   32436 */   // Label 578: @32436
     /*   32436 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(32532), // Rule ID 52153 //
     /*   32441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32464 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32489 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32493 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32497 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32499 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32506 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32530 */     GIR_RootConstrainSelectedInstOperands,
     /*   32531 */     // GIR_Coverage, 52153,
     /*   32531 */     GIR_EraseRootFromParent_Done,
     /*   32532 */   // Label 579: @32532
     /*   32532 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(32628), // Rule ID 71058 //
     /*   32537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32560 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32574 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32589 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32593 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32595 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32602 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32626 */     GIR_RootConstrainSelectedInstOperands,
     /*   32627 */     // GIR_Coverage, 71058,
     /*   32627 */     GIR_EraseRootFromParent_Done,
     /*   32628 */   // Label 580: @32628
     /*   32628 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(32724), // Rule ID 71059 //
     /*   32633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32689 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32691 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32698 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   32701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   32709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   32713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32722 */     GIR_RootConstrainSelectedInstOperands,
     /*   32723 */     // GIR_Coverage, 71059,
     /*   32723 */     GIR_EraseRootFromParent_Done,
     /*   32724 */   // Label 581: @32724
     /*   32724 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(32820), // Rule ID 52092 //
     /*   32729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32773 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32777 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32781 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32785 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32794 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   32794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32818 */     GIR_RootConstrainSelectedInstOperands,
     /*   32819 */     // GIR_Coverage, 52092,
     /*   32819 */     GIR_EraseRootFromParent_Done,
     /*   32820 */   // Label 582: @32820
     /*   32820 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(32916), // Rule ID 52093 //
     /*   32825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   32848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   32854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32862 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   32873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32881 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   32883 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   32890 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   32890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   32893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   32897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   32905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32914 */     GIR_RootConstrainSelectedInstOperands,
     /*   32915 */     // GIR_Coverage, 52093,
     /*   32915 */     GIR_EraseRootFromParent_Done,
     /*   32916 */   // Label 583: @32916
     /*   32916 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(33005), // Rule ID 46682 //
     /*   32921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   32947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   32955 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32964 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   32964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   32967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   32981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33003 */     GIR_RootConstrainSelectedInstOperands,
     /*   33004 */     // GIR_Coverage, 46682,
     /*   33004 */     GIR_EraseRootFromParent_Done,
     /*   33005 */   // Label 584: @33005
     /*   33005 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(33094), // Rule ID 46683 //
     /*   33010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33025 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33044 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33053 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33092 */     GIR_RootConstrainSelectedInstOperands,
     /*   33093 */     // GIR_Coverage, 46683,
     /*   33093 */     GIR_EraseRootFromParent_Done,
     /*   33094 */   // Label 585: @33094
     /*   33094 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(33183), // Rule ID 46446 //
     /*   33099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33114 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33133 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33142 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33181 */     GIR_RootConstrainSelectedInstOperands,
     /*   33182 */     // GIR_Coverage, 46446,
     /*   33182 */     GIR_EraseRootFromParent_Done,
     /*   33183 */   // Label 586: @33183
     /*   33183 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(33272), // Rule ID 46447 //
     /*   33188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33203 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33222 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33231 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   33248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33270 */     GIR_RootConstrainSelectedInstOperands,
     /*   33271 */     // GIR_Coverage, 46447,
     /*   33271 */     GIR_EraseRootFromParent_Done,
     /*   33272 */   // Label 587: @33272
     /*   33272 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(33361), // Rule ID 46562 //
     /*   33277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33311 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33320 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   33320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33359 */     GIR_RootConstrainSelectedInstOperands,
     /*   33360 */     // GIR_Coverage, 46562,
     /*   33360 */     GIR_EraseRootFromParent_Done,
     /*   33361 */   // Label 588: @33361
     /*   33361 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(33450), // Rule ID 46563 //
     /*   33366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   33392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33400 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   33409 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   33409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   33412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   33426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   33435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33448 */     GIR_RootConstrainSelectedInstOperands,
     /*   33449 */     // GIR_Coverage, 46563,
     /*   33449 */     GIR_EraseRootFromParent_Done,
     /*   33450 */   // Label 589: @33450
     /*   33450 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(33518), // Rule ID 70650 //
     /*   33455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33474 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33492 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33516 */     GIR_RootConstrainSelectedInstOperands,
     /*   33517 */     // GIR_Coverage, 70650,
     /*   33517 */     GIR_EraseRootFromParent_Done,
     /*   33518 */   // Label 590: @33518
     /*   33518 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(33586), // Rule ID 70651 //
     /*   33523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33560 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   33560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33584 */     GIR_RootConstrainSelectedInstOperands,
     /*   33585 */     // GIR_Coverage, 70651,
     /*   33585 */     GIR_EraseRootFromParent_Done,
     /*   33586 */   // Label 591: @33586
     /*   33586 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(33641), // Rule ID 69618 //
     /*   33591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33619 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33639 */     GIR_RootConstrainSelectedInstOperands,
     /*   33640 */     // GIR_Coverage, 69618,
     /*   33640 */     GIR_EraseRootFromParent_Done,
     /*   33641 */   // Label 592: @33641
     /*   33641 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(33696), // Rule ID 69619 //
     /*   33646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33674 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33694 */     GIR_RootConstrainSelectedInstOperands,
     /*   33695 */     // GIR_Coverage, 69619,
     /*   33695 */     GIR_EraseRootFromParent_Done,
     /*   33696 */   // Label 593: @33696
     /*   33696 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(33751), // Rule ID 69438 //
     /*   33701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33729 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   33732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33749 */     GIR_RootConstrainSelectedInstOperands,
     /*   33750 */     // GIR_Coverage, 69438,
     /*   33750 */     GIR_EraseRootFromParent_Done,
     /*   33751 */   // Label 594: @33751
     /*   33751 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(33806), // Rule ID 69439 //
     /*   33756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33784 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   33787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33804 */     GIR_RootConstrainSelectedInstOperands,
     /*   33805 */     // GIR_Coverage, 69439,
     /*   33805 */     GIR_EraseRootFromParent_Done,
     /*   33806 */   // Label 595: @33806
     /*   33806 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(33861), // Rule ID 69528 //
     /*   33811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33839 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   33839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33859 */     GIR_RootConstrainSelectedInstOperands,
     /*   33860 */     // GIR_Coverage, 69528,
     /*   33860 */     GIR_EraseRootFromParent_Done,
     /*   33861 */   // Label 596: @33861
     /*   33861 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(33916), // Rule ID 69529 //
     /*   33866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   33881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33894 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   33894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   33897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33914 */     GIR_RootConstrainSelectedInstOperands,
     /*   33915 */     // GIR_Coverage, 69529,
     /*   33915 */     GIR_EraseRootFromParent_Done,
     /*   33916 */   // Label 597: @33916
     /*   33916 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(33984), // Rule ID 51884 //
     /*   33921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   33944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33958 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   33961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33982 */     GIR_RootConstrainSelectedInstOperands,
     /*   33983 */     // GIR_Coverage, 51884,
     /*   33983 */     GIR_EraseRootFromParent_Done,
     /*   33984 */   // Label 598: @33984
     /*   33984 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(34052), // Rule ID 51885 //
     /*   33989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   34012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34026 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   34029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   34035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34050 */     GIR_RootConstrainSelectedInstOperands,
     /*   34051 */     // GIR_Coverage, 51885,
     /*   34051 */     GIR_EraseRootFromParent_Done,
     /*   34052 */   // Label 599: @34052
     /*   34052 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(34107), // Rule ID 46742 //
     /*   34057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34085 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34105 */     GIR_RootConstrainSelectedInstOperands,
     /*   34106 */     // GIR_Coverage, 46742,
     /*   34106 */     GIR_EraseRootFromParent_Done,
     /*   34107 */   // Label 600: @34107
     /*   34107 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(34162), // Rule ID 46743 //
     /*   34112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   34127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34140 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34160 */     GIR_RootConstrainSelectedInstOperands,
     /*   34161 */     // GIR_Coverage, 46743,
     /*   34161 */     GIR_EraseRootFromParent_Done,
     /*   34162 */   // Label 601: @34162
     /*   34162 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(34217), // Rule ID 46502 //
     /*   34167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34195 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34215 */     GIR_RootConstrainSelectedInstOperands,
     /*   34216 */     // GIR_Coverage, 46502,
     /*   34216 */     GIR_EraseRootFromParent_Done,
     /*   34217 */   // Label 602: @34217
     /*   34217 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(34272), // Rule ID 46503 //
     /*   34222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34241 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34250 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   34253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34270 */     GIR_RootConstrainSelectedInstOperands,
     /*   34271 */     // GIR_Coverage, 46503,
     /*   34271 */     GIR_EraseRootFromParent_Done,
     /*   34272 */   // Label 603: @34272
     /*   34272 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(34327), // Rule ID 46622 //
     /*   34277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34296 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34305 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   34305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34325 */     GIR_RootConstrainSelectedInstOperands,
     /*   34326 */     // GIR_Coverage, 46622,
     /*   34326 */     GIR_EraseRootFromParent_Done,
     /*   34327 */   // Label 604: @34327
     /*   34327 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(34382), // Rule ID 46623 //
     /*   34332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   34351 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   34360 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   34360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   34363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   34367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   34371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34380 */     GIR_RootConstrainSelectedInstOperands,
     /*   34381 */     // GIR_Coverage, 46623,
     /*   34381 */     GIR_EraseRootFromParent_Done,
     /*   34382 */   // Label 605: @34382
     /*   34382 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(34435), // Rule ID 46116 //
     /*   34387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34398 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   34398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34433 */     GIR_RootConstrainSelectedInstOperands,
     /*   34434 */     // GIR_Coverage, 46116,
     /*   34434 */     GIR_EraseRootFromParent_Done,
     /*   34435 */   // Label 606: @34435
     /*   34435 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(34488), // Rule ID 46117 //
     /*   34440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34451 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   34451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   34454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   34458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   34463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   34465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   34468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   34473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   34475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   34477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   34486 */     GIR_RootConstrainSelectedInstOperands,
     /*   34487 */     // GIR_Coverage, 46117,
     /*   34487 */     GIR_EraseRootFromParent_Done,
     /*   34488 */   // Label 607: @34488
     /*   34488 */   GIM_Reject,
     /*   34489 */ // Label 567: @34489
     /*   34489 */ GIM_Reject,
     /*   34490 */ // Label 138: @34490
     /*   34490 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37614),
     /*   34495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34505 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(34601), // Rule ID 70828 //
     /*   34510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34525 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34529 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34543 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34558 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34562 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34564 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34575 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   34578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34599 */     GIR_RootConstrainSelectedInstOperands,
     /*   34600 */     // GIR_Coverage, 70828,
     /*   34600 */     GIR_EraseRootFromParent_Done,
     /*   34601 */   // Label 609: @34601
     /*   34601 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(34697), // Rule ID 70829 //
     /*   34606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34625 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34654 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34658 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34660 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34669 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34671 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   34674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34695 */     GIR_RootConstrainSelectedInstOperands,
     /*   34696 */     // GIR_Coverage, 70829,
     /*   34696 */     GIR_EraseRootFromParent_Done,
     /*   34697 */   // Label 610: @34697
     /*   34697 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(34793), // Rule ID 71096 //
     /*   34702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34735 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34750 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34754 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34756 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34765 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34767 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34791 */     GIR_RootConstrainSelectedInstOperands,
     /*   34792 */     // GIR_Coverage, 71096,
     /*   34792 */     GIR_EraseRootFromParent_Done,
     /*   34793 */   // Label 611: @34793
     /*   34793 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(34889), // Rule ID 71097 //
     /*   34798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34817 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34831 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34846 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34850 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34852 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34863 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   34863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34887 */     GIR_RootConstrainSelectedInstOperands,
     /*   34888 */     // GIR_Coverage, 71097,
     /*   34888 */     GIR_EraseRootFromParent_Done,
     /*   34889 */   // Label 612: @34889
     /*   34889 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(34985), // Rule ID 71098 //
     /*   34894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   34897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   34913 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   34946 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34948 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   34953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34957 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34959 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   34959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   34962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   34970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   34974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   34980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34983 */     GIR_RootConstrainSelectedInstOperands,
     /*   34984 */     // GIR_Coverage, 71098,
     /*   34984 */     GIR_EraseRootFromParent_Done,
     /*   34985 */   // Label 613: @34985
     /*   34985 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(35081), // Rule ID 71099 //
     /*   34990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   34993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35023 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35042 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35044 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35053 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35055 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35079 */     GIR_RootConstrainSelectedInstOperands,
     /*   35080 */     // GIR_Coverage, 71099,
     /*   35080 */     GIR_EraseRootFromParent_Done,
     /*   35081 */   // Label 614: @35081
     /*   35081 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(35177), // Rule ID 70942 //
     /*   35086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35105 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35119 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35138 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35140 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35149 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35151 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35175 */     GIR_RootConstrainSelectedInstOperands,
     /*   35176 */     // GIR_Coverage, 70942,
     /*   35176 */     GIR_EraseRootFromParent_Done,
     /*   35177 */   // Label 615: @35177
     /*   35177 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(35273), // Rule ID 70943 //
     /*   35182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35215 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35234 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35236 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35245 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35247 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   35254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35271 */     GIR_RootConstrainSelectedInstOperands,
     /*   35272 */     // GIR_Coverage, 70943,
     /*   35272 */     GIR_EraseRootFromParent_Done,
     /*   35273 */   // Label 616: @35273
     /*   35273 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(35369), // Rule ID 52046 //
     /*   35278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35315 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35334 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35336 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35343 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35367 */     GIR_RootConstrainSelectedInstOperands,
     /*   35368 */     // GIR_Coverage, 52046,
     /*   35368 */     GIR_EraseRootFromParent_Done,
     /*   35369 */   // Label 617: @35369
     /*   35369 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(35465), // Rule ID 52047 //
     /*   35374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35397 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35411 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35426 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35430 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35432 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35439 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   35442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35463 */     GIR_RootConstrainSelectedInstOperands,
     /*   35464 */     // GIR_Coverage, 52047,
     /*   35464 */     GIR_EraseRootFromParent_Done,
     /*   35465 */   // Label 618: @35465
     /*   35465 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(35561), // Rule ID 52164 //
     /*   35470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35493 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35522 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35526 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35528 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35533 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35535 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35559 */     GIR_RootConstrainSelectedInstOperands,
     /*   35560 */     // GIR_Coverage, 52164,
     /*   35560 */     GIR_EraseRootFromParent_Done,
     /*   35561 */   // Label 619: @35561
     /*   35561 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(35657), // Rule ID 52165 //
     /*   35566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35603 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35622 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35624 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35629 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35631 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35655 */     GIR_RootConstrainSelectedInstOperands,
     /*   35656 */     // GIR_Coverage, 52165,
     /*   35656 */     GIR_EraseRootFromParent_Done,
     /*   35657 */   // Label 620: @35657
     /*   35657 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(35753), // Rule ID 71094 //
     /*   35662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35699 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35718 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35720 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35727 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35751 */     GIR_RootConstrainSelectedInstOperands,
     /*   35752 */     // GIR_Coverage, 71094,
     /*   35752 */     GIR_EraseRootFromParent_Done,
     /*   35753 */   // Label 621: @35753
     /*   35753 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(35849), // Rule ID 71095 //
     /*   35758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35814 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35816 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35823 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   35823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   35826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   35834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   35838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35847 */     GIR_RootConstrainSelectedInstOperands,
     /*   35848 */     // GIR_Coverage, 71095,
     /*   35848 */     GIR_EraseRootFromParent_Done,
     /*   35849 */   // Label 622: @35849
     /*   35849 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(35945), // Rule ID 52104 //
     /*   35854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   35857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35891 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35910 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35917 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35919 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   35919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   35922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   35940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35943 */     GIR_RootConstrainSelectedInstOperands,
     /*   35944 */     // GIR_Coverage, 52104,
     /*   35944 */     GIR_EraseRootFromParent_Done,
     /*   35945 */   // Label 623: @35945
     /*   35945 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(36041), // Rule ID 52105 //
     /*   35950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   35953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   35961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   35973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   35979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   35987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   35994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36006 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   36008 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   36015 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   36018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   36022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   36030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36039 */     GIR_RootConstrainSelectedInstOperands,
     /*   36040 */     // GIR_Coverage, 52105,
     /*   36040 */     GIR_EraseRootFromParent_Done,
     /*   36041 */   // Label 624: @36041
     /*   36041 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(36130), // Rule ID 46706 //
     /*   36046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36061 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36080 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36089 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36128 */     GIR_RootConstrainSelectedInstOperands,
     /*   36129 */     // GIR_Coverage, 46706,
     /*   36129 */     GIR_EraseRootFromParent_Done,
     /*   36130 */   // Label 625: @36130
     /*   36130 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(36219), // Rule ID 46707 //
     /*   36135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36169 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36178 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36217 */     GIR_RootConstrainSelectedInstOperands,
     /*   36218 */     // GIR_Coverage, 46707,
     /*   36218 */     GIR_EraseRootFromParent_Done,
     /*   36219 */   // Label 626: @36219
     /*   36219 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(36308), // Rule ID 46470 //
     /*   36224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36239 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36258 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36267 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36306 */     GIR_RootConstrainSelectedInstOperands,
     /*   36307 */     // GIR_Coverage, 46470,
     /*   36307 */     GIR_EraseRootFromParent_Done,
     /*   36308 */   // Label 627: @36308
     /*   36308 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(36397), // Rule ID 46471 //
     /*   36313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36347 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36356 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   36373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36395 */     GIR_RootConstrainSelectedInstOperands,
     /*   36396 */     // GIR_Coverage, 46471,
     /*   36396 */     GIR_EraseRootFromParent_Done,
     /*   36397 */   // Label 628: @36397
     /*   36397 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(36486), // Rule ID 46586 //
     /*   36402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36436 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36445 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   36445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36484 */     GIR_RootConstrainSelectedInstOperands,
     /*   36485 */     // GIR_Coverage, 46586,
     /*   36485 */     GIR_EraseRootFromParent_Done,
     /*   36486 */   // Label 629: @36486
     /*   36486 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(36575), // Rule ID 46587 //
     /*   36491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   36517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36525 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   36527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   36534 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   36534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   36537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   36551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   36560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   36564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36573 */     GIR_RootConstrainSelectedInstOperands,
     /*   36574 */     // GIR_Coverage, 46587,
     /*   36574 */     GIR_EraseRootFromParent_Done,
     /*   36575 */   // Label 630: @36575
     /*   36575 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(36643), // Rule ID 70722 //
     /*   36580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36617 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   36617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   36620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36641 */     GIR_RootConstrainSelectedInstOperands,
     /*   36642 */     // GIR_Coverage, 70722,
     /*   36642 */     GIR_EraseRootFromParent_Done,
     /*   36643 */   // Label 631: @36643
     /*   36643 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(36711), // Rule ID 70723 //
     /*   36648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   36667 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36685 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   36685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   36688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36709 */     GIR_RootConstrainSelectedInstOperands,
     /*   36710 */     // GIR_Coverage, 70723,
     /*   36710 */     GIR_EraseRootFromParent_Done,
     /*   36711 */   // Label 632: @36711
     /*   36711 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(36766), // Rule ID 69642 //
     /*   36716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36731 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36744 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36764 */     GIR_RootConstrainSelectedInstOperands,
     /*   36765 */     // GIR_Coverage, 69642,
     /*   36765 */     GIR_EraseRootFromParent_Done,
     /*   36766 */   // Label 633: @36766
     /*   36766 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(36821), // Rule ID 69643 //
     /*   36771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36799 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36819 */     GIR_RootConstrainSelectedInstOperands,
     /*   36820 */     // GIR_Coverage, 69643,
     /*   36820 */     GIR_EraseRootFromParent_Done,
     /*   36821 */   // Label 634: @36821
     /*   36821 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(36876), // Rule ID 69462 //
     /*   36826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36854 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   36857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36874 */     GIR_RootConstrainSelectedInstOperands,
     /*   36875 */     // GIR_Coverage, 69462,
     /*   36875 */     GIR_EraseRootFromParent_Done,
     /*   36876 */   // Label 635: @36876
     /*   36876 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(36931), // Rule ID 69463 //
     /*   36881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36909 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   36909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   36912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36929 */     GIR_RootConstrainSelectedInstOperands,
     /*   36930 */     // GIR_Coverage, 69463,
     /*   36930 */     GIR_EraseRootFromParent_Done,
     /*   36931 */   // Label 636: @36931
     /*   36931 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(36986), // Rule ID 69552 //
     /*   36936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   36951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36964 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   36964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   36967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   36981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36984 */     GIR_RootConstrainSelectedInstOperands,
     /*   36985 */     // GIR_Coverage, 69552,
     /*   36985 */     GIR_EraseRootFromParent_Done,
     /*   36986 */   // Label 637: @36986
     /*   36986 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(37041), // Rule ID 69553 //
     /*   36991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37006 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37019 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37039 */     GIR_RootConstrainSelectedInstOperands,
     /*   37040 */     // GIR_Coverage, 69553,
     /*   37040 */     GIR_EraseRootFromParent_Done,
     /*   37041 */   // Label 638: @37041
     /*   37041 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(37109), // Rule ID 51920 //
     /*   37046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37083 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37107 */     GIR_RootConstrainSelectedInstOperands,
     /*   37108 */     // GIR_Coverage, 51920,
     /*   37108 */     GIR_EraseRootFromParent_Done,
     /*   37109 */   // Label 639: @37109
     /*   37109 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(37177), // Rule ID 51921 //
     /*   37114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   37137 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37151 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   37154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   37160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37175 */     GIR_RootConstrainSelectedInstOperands,
     /*   37176 */     // GIR_Coverage, 51921,
     /*   37176 */     GIR_EraseRootFromParent_Done,
     /*   37177 */   // Label 640: @37177
     /*   37177 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(37232), // Rule ID 46766 //
     /*   37182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37210 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37230 */     GIR_RootConstrainSelectedInstOperands,
     /*   37231 */     // GIR_Coverage, 46766,
     /*   37231 */     GIR_EraseRootFromParent_Done,
     /*   37232 */   // Label 641: @37232
     /*   37232 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(37287), // Rule ID 46767 //
     /*   37237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   37252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37265 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37285 */     GIR_RootConstrainSelectedInstOperands,
     /*   37286 */     // GIR_Coverage, 46767,
     /*   37286 */     GIR_EraseRootFromParent_Done,
     /*   37287 */   // Label 642: @37287
     /*   37287 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(37342), // Rule ID 46526 //
     /*   37292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37320 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37340 */     GIR_RootConstrainSelectedInstOperands,
     /*   37341 */     // GIR_Coverage, 46526,
     /*   37341 */     GIR_EraseRootFromParent_Done,
     /*   37342 */   // Label 643: @37342
     /*   37342 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(37397), // Rule ID 46527 //
     /*   37347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37375 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   37378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37395 */     GIR_RootConstrainSelectedInstOperands,
     /*   37396 */     // GIR_Coverage, 46527,
     /*   37396 */     GIR_EraseRootFromParent_Done,
     /*   37397 */   // Label 644: @37397
     /*   37397 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(37452), // Rule ID 46646 //
     /*   37402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37430 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   37430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37450 */     GIR_RootConstrainSelectedInstOperands,
     /*   37451 */     // GIR_Coverage, 46646,
     /*   37451 */     GIR_EraseRootFromParent_Done,
     /*   37452 */   // Label 645: @37452
     /*   37452 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(37507), // Rule ID 46647 //
     /*   37457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   37476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   37485 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   37485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   37488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   37492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   37496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   37502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37505 */     GIR_RootConstrainSelectedInstOperands,
     /*   37506 */     // GIR_Coverage, 46647,
     /*   37506 */     GIR_EraseRootFromParent_Done,
     /*   37507 */   // Label 646: @37507
     /*   37507 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(37560), // Rule ID 46152 //
     /*   37512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37523 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   37523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   37540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   37547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37558 */     GIR_RootConstrainSelectedInstOperands,
     /*   37559 */     // GIR_Coverage, 46152,
     /*   37559 */     GIR_EraseRootFromParent_Done,
     /*   37560 */   // Label 647: @37560
     /*   37560 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(37613), // Rule ID 46153 //
     /*   37565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37576 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   37576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   37579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   37583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   37588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   37593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   37600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37611 */     GIR_RootConstrainSelectedInstOperands,
     /*   37612 */     // GIR_Coverage, 46153,
     /*   37612 */     GIR_EraseRootFromParent_Done,
     /*   37613 */   // Label 648: @37613
     /*   37613 */   GIM_Reject,
     /*   37614 */ // Label 608: @37614
     /*   37614 */ GIM_Reject,
     /*   37615 */ // Label 139: @37615
     /*   37615 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(40739),
     /*   37620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37630 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(37726), // Rule ID 70838 //
     /*   37635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   37638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37668 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37687 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37689 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37700 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   37703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37724 */     GIR_RootConstrainSelectedInstOperands,
     /*   37725 */     // GIR_Coverage, 70838,
     /*   37725 */     GIR_EraseRootFromParent_Done,
     /*   37726 */   // Label 650: @37726
     /*   37726 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(37822), // Rule ID 70839 //
     /*   37731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   37734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37783 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37796 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   37799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37820 */     GIR_RootConstrainSelectedInstOperands,
     /*   37821 */     // GIR_Coverage, 70839,
     /*   37821 */     GIR_EraseRootFromParent_Done,
     /*   37822 */   // Label 651: @37822
     /*   37822 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(37918), // Rule ID 71126 //
     /*   37827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   37830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37879 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37892 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   37892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   37895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   37913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37916 */     GIR_RootConstrainSelectedInstOperands,
     /*   37917 */     // GIR_Coverage, 71126,
     /*   37917 */     GIR_EraseRootFromParent_Done,
     /*   37918 */   // Label 652: @37918
     /*   37918 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(38014), // Rule ID 71127 //
     /*   37923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   37926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   37938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   37942 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37956 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37971 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   37975 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37977 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   37986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37988 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   37988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   37991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38012 */     GIR_RootConstrainSelectedInstOperands,
     /*   38013 */     // GIR_Coverage, 71127,
     /*   38013 */     GIR_EraseRootFromParent_Done,
     /*   38014 */   // Label 653: @38014
     /*   38014 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(38110), // Rule ID 71128 //
     /*   38019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38038 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38052 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38071 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38073 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38084 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38108 */     GIR_RootConstrainSelectedInstOperands,
     /*   38109 */     // GIR_Coverage, 71128,
     /*   38109 */     GIR_EraseRootFromParent_Done,
     /*   38110 */   // Label 654: @38110
     /*   38110 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(38206), // Rule ID 71129 //
     /*   38115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38148 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38163 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38167 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38169 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38180 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38204 */     GIR_RootConstrainSelectedInstOperands,
     /*   38205 */     // GIR_Coverage, 71129,
     /*   38205 */     GIR_EraseRootFromParent_Done,
     /*   38206 */   // Label 655: @38206
     /*   38206 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(38302), // Rule ID 70952 //
     /*   38211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38230 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38244 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38259 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38263 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38265 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38276 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38300 */     GIR_RootConstrainSelectedInstOperands,
     /*   38301 */     // GIR_Coverage, 70952,
     /*   38301 */     GIR_EraseRootFromParent_Done,
     /*   38302 */   // Label 656: @38302
     /*   38302 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(38398), // Rule ID 70953 //
     /*   38307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38340 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38347 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38351 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38355 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38359 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38361 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38372 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   38375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   38379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38396 */     GIR_RootConstrainSelectedInstOperands,
     /*   38397 */     // GIR_Coverage, 70953,
     /*   38397 */     GIR_EraseRootFromParent_Done,
     /*   38398 */   // Label 657: @38398
     /*   38398 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(38494), // Rule ID 52056 //
     /*   38403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38459 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38468 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38492 */     GIR_RootConstrainSelectedInstOperands,
     /*   38493 */     // GIR_Coverage, 52056,
     /*   38493 */     GIR_EraseRootFromParent_Done,
     /*   38494 */   // Label 658: @38494
     /*   38494 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(38590), // Rule ID 52057 //
     /*   38499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38555 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38564 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   38567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38588 */     GIR_RootConstrainSelectedInstOperands,
     /*   38589 */     // GIR_Coverage, 52057,
     /*   38589 */     GIR_EraseRootFromParent_Done,
     /*   38590 */   // Label 659: @38590
     /*   38590 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(38686), // Rule ID 52174 //
     /*   38595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38618 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38647 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38651 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38660 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38684 */     GIR_RootConstrainSelectedInstOperands,
     /*   38685 */     // GIR_Coverage, 52174,
     /*   38685 */     GIR_EraseRootFromParent_Done,
     /*   38686 */   // Label 660: @38686
     /*   38686 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(38782), // Rule ID 52175 //
     /*   38691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38743 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38747 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38749 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38754 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38756 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38780 */     GIR_RootConstrainSelectedInstOperands,
     /*   38781 */     // GIR_Coverage, 52175,
     /*   38781 */     GIR_EraseRootFromParent_Done,
     /*   38782 */   // Label 661: @38782
     /*   38782 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(38878), // Rule ID 71124 //
     /*   38787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38824 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38839 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38843 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38845 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38852 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   38852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38876 */     GIR_RootConstrainSelectedInstOperands,
     /*   38877 */     // GIR_Coverage, 71124,
     /*   38877 */     GIR_EraseRootFromParent_Done,
     /*   38878 */   // Label 662: @38878
     /*   38878 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(38974), // Rule ID 71125 //
     /*   38883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   38886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   38906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38920 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38931 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38935 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   38939 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38941 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38948 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   38948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   38951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   38969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38972 */     GIR_RootConstrainSelectedInstOperands,
     /*   38973 */     // GIR_Coverage, 71125,
     /*   38973 */     GIR_EraseRootFromParent_Done,
     /*   38974 */   // Label 663: @38974
     /*   38974 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(39070), // Rule ID 52114 //
     /*   38979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   38982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   38986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   38998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39002 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39027 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39031 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39035 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39037 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39042 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39044 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39068 */     GIR_RootConstrainSelectedInstOperands,
     /*   39069 */     // GIR_Coverage, 52114,
     /*   39069 */     GIR_EraseRootFromParent_Done,
     /*   39070 */   // Label 664: @39070
     /*   39070 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(39166), // Rule ID 52115 //
     /*   39075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   39104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39112 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   39123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39131 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   39133 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   39140 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   39143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   39147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   39155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39164 */     GIR_RootConstrainSelectedInstOperands,
     /*   39165 */     // GIR_Coverage, 52115,
     /*   39165 */     GIR_EraseRootFromParent_Done,
     /*   39166 */   // Label 665: @39166
     /*   39166 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(39255), // Rule ID 46726 //
     /*   39171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39205 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39212 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39214 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39253 */     GIR_RootConstrainSelectedInstOperands,
     /*   39254 */     // GIR_Coverage, 46726,
     /*   39254 */     GIR_EraseRootFromParent_Done,
     /*   39255 */   // Label 666: @39255
     /*   39255 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(39344), // Rule ID 46727 //
     /*   39260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39275 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39294 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39303 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39342 */     GIR_RootConstrainSelectedInstOperands,
     /*   39343 */     // GIR_Coverage, 46727,
     /*   39343 */     GIR_EraseRootFromParent_Done,
     /*   39344 */   // Label 667: @39344
     /*   39344 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(39433), // Rule ID 46490 //
     /*   39349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39364 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39383 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39392 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39431 */     GIR_RootConstrainSelectedInstOperands,
     /*   39432 */     // GIR_Coverage, 46490,
     /*   39432 */     GIR_EraseRootFromParent_Done,
     /*   39433 */   // Label 668: @39433
     /*   39433 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(39522), // Rule ID 46491 //
     /*   39438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39453 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39472 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39481 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   39498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39520 */     GIR_RootConstrainSelectedInstOperands,
     /*   39521 */     // GIR_Coverage, 46491,
     /*   39521 */     GIR_EraseRootFromParent_Done,
     /*   39522 */   // Label 669: @39522
     /*   39522 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(39611), // Rule ID 46606 //
     /*   39527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39542 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39561 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39570 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   39570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39609 */     GIR_RootConstrainSelectedInstOperands,
     /*   39610 */     // GIR_Coverage, 46606,
     /*   39610 */     GIR_EraseRootFromParent_Done,
     /*   39611 */   // Label 670: @39611
     /*   39611 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(39700), // Rule ID 46607 //
     /*   39616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39631 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39650 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39659 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   39659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   39662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   39676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39698 */     GIR_RootConstrainSelectedInstOperands,
     /*   39699 */     // GIR_Coverage, 46607,
     /*   39699 */     GIR_EraseRootFromParent_Done,
     /*   39700 */   // Label 671: @39700
     /*   39700 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(39768), // Rule ID 70754 //
     /*   39705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   39708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39742 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   39742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   39745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   39763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39766 */     GIR_RootConstrainSelectedInstOperands,
     /*   39767 */     // GIR_Coverage, 70754,
     /*   39767 */     GIR_EraseRootFromParent_Done,
     /*   39768 */   // Label 672: @39768
     /*   39768 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(39836), // Rule ID 70755 //
     /*   39773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   39776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   39788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   39792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39810 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   39810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   39813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   39831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39834 */     GIR_RootConstrainSelectedInstOperands,
     /*   39835 */     // GIR_Coverage, 70755,
     /*   39835 */     GIR_EraseRootFromParent_Done,
     /*   39836 */   // Label 673: @39836
     /*   39836 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(39891), // Rule ID 69662 //
     /*   39841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39856 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39869 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   39872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39889 */     GIR_RootConstrainSelectedInstOperands,
     /*   39890 */     // GIR_Coverage, 69662,
     /*   39890 */     GIR_EraseRootFromParent_Done,
     /*   39891 */   // Label 674: @39891
     /*   39891 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(39946), // Rule ID 69663 //
     /*   39896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   39899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39911 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39924 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   39924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   39927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39944 */     GIR_RootConstrainSelectedInstOperands,
     /*   39945 */     // GIR_Coverage, 69663,
     /*   39945 */     GIR_EraseRootFromParent_Done,
     /*   39946 */   // Label 675: @39946
     /*   39946 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(40001), // Rule ID 69482 //
     /*   39951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   39954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   39966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   39977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39979 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   39979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   39982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   39996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39999 */     GIR_RootConstrainSelectedInstOperands,
     /*   40000 */     // GIR_Coverage, 69482,
     /*   40000 */     GIR_EraseRootFromParent_Done,
     /*   40001 */   // Label 676: @40001
     /*   40001 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(40056), // Rule ID 69483 //
     /*   40006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40034 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40054 */     GIR_RootConstrainSelectedInstOperands,
     /*   40055 */     // GIR_Coverage, 69483,
     /*   40055 */     GIR_EraseRootFromParent_Done,
     /*   40056 */   // Label 677: @40056
     /*   40056 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(40111), // Rule ID 69572 //
     /*   40061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40089 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40109 */     GIR_RootConstrainSelectedInstOperands,
     /*   40110 */     // GIR_Coverage, 69572,
     /*   40110 */     GIR_EraseRootFromParent_Done,
     /*   40111 */   // Label 678: @40111
     /*   40111 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(40166), // Rule ID 69573 //
     /*   40116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40144 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40164 */     GIR_RootConstrainSelectedInstOperands,
     /*   40165 */     // GIR_Coverage, 69573,
     /*   40165 */     GIR_EraseRootFromParent_Done,
     /*   40166 */   // Label 679: @40166
     /*   40166 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(40234), // Rule ID 51936 //
     /*   40171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40208 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   40208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40232 */     GIR_RootConstrainSelectedInstOperands,
     /*   40233 */     // GIR_Coverage, 51936,
     /*   40233 */     GIR_EraseRootFromParent_Done,
     /*   40234 */   // Label 680: @40234
     /*   40234 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(40302), // Rule ID 51937 //
     /*   40239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   40258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   40262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40276 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   40276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   40279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40300 */     GIR_RootConstrainSelectedInstOperands,
     /*   40301 */     // GIR_Coverage, 51937,
     /*   40301 */     GIR_EraseRootFromParent_Done,
     /*   40302 */   // Label 681: @40302
     /*   40302 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(40357), // Rule ID 46786 //
     /*   40307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40335 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40355 */     GIR_RootConstrainSelectedInstOperands,
     /*   40356 */     // GIR_Coverage, 46786,
     /*   40356 */     GIR_EraseRootFromParent_Done,
     /*   40357 */   // Label 682: @40357
     /*   40357 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(40412), // Rule ID 46787 //
     /*   40362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   40377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40390 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40410 */     GIR_RootConstrainSelectedInstOperands,
     /*   40411 */     // GIR_Coverage, 46787,
     /*   40411 */     GIR_EraseRootFromParent_Done,
     /*   40412 */   // Label 683: @40412
     /*   40412 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(40467), // Rule ID 46546 //
     /*   40417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40445 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40465 */     GIR_RootConstrainSelectedInstOperands,
     /*   40466 */     // GIR_Coverage, 46546,
     /*   40466 */     GIR_EraseRootFromParent_Done,
     /*   40467 */   // Label 684: @40467
     /*   40467 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(40522), // Rule ID 46547 //
     /*   40472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40500 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   40503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40520 */     GIR_RootConstrainSelectedInstOperands,
     /*   40521 */     // GIR_Coverage, 46547,
     /*   40521 */     GIR_EraseRootFromParent_Done,
     /*   40522 */   // Label 685: @40522
     /*   40522 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(40577), // Rule ID 46666 //
     /*   40527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   40530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40555 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   40555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40575 */     GIR_RootConstrainSelectedInstOperands,
     /*   40576 */     // GIR_Coverage, 46666,
     /*   40576 */     GIR_EraseRootFromParent_Done,
     /*   40577 */   // Label 686: @40577
     /*   40577 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(40632), // Rule ID 46667 //
     /*   40582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   40585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   40601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40610 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   40610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   40613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   40627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40630 */     GIR_RootConstrainSelectedInstOperands,
     /*   40631 */     // GIR_Coverage, 46667,
     /*   40631 */     GIR_EraseRootFromParent_Done,
     /*   40632 */   // Label 687: @40632
     /*   40632 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(40685), // Rule ID 46168 //
     /*   40637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   40640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40648 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   40648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   40665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40683 */     GIR_RootConstrainSelectedInstOperands,
     /*   40684 */     // GIR_Coverage, 46168,
     /*   40684 */     GIR_EraseRootFromParent_Done,
     /*   40685 */   // Label 688: @40685
     /*   40685 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(40738), // Rule ID 46169 //
     /*   40690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   40693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40701 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   40701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   40704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   40718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   40733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40736 */     GIR_RootConstrainSelectedInstOperands,
     /*   40737 */     // GIR_Coverage, 46169,
     /*   40737 */     GIR_EraseRootFromParent_Done,
     /*   40738 */   // Label 689: @40738
     /*   40738 */   GIM_Reject,
     /*   40739 */ // Label 649: @40739
     /*   40739 */ GIM_Reject,
     /*   40740 */ // Label 140: @40740
     /*   40740 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(41134),
     /*   40745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40755 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(40823), // Rule ID 70642 //
     /*   40760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40797 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   40797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40821 */     GIR_RootConstrainSelectedInstOperands,
     /*   40822 */     // GIR_Coverage, 70642,
     /*   40822 */     GIR_EraseRootFromParent_Done,
     /*   40823 */   // Label 691: @40823
     /*   40823 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(40891), // Rule ID 70643 //
     /*   40828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40847 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40865 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   40865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40889 */     GIR_RootConstrainSelectedInstOperands,
     /*   40890 */     // GIR_Coverage, 70643,
     /*   40890 */     GIR_EraseRootFromParent_Done,
     /*   40891 */   // Label 692: @40891
     /*   40891 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(40959), // Rule ID 51880 //
     /*   40896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40919 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40933 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   40933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   40936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   40942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40957 */     GIR_RootConstrainSelectedInstOperands,
     /*   40958 */     // GIR_Coverage, 51880,
     /*   40958 */     GIR_EraseRootFromParent_Done,
     /*   40959 */   // Label 693: @40959
     /*   40959 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(41027), // Rule ID 51881 //
     /*   40964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   40987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   41001 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   41004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   41010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   41014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   41016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41025 */     GIR_RootConstrainSelectedInstOperands,
     /*   41026 */     // GIR_Coverage, 51881,
     /*   41026 */     GIR_EraseRootFromParent_Done,
     /*   41027 */   // Label 694: @41027
     /*   41027 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(41080), // Rule ID 46112 //
     /*   41032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41043 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   41043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41078 */     GIR_RootConstrainSelectedInstOperands,
     /*   41079 */     // GIR_Coverage, 46112,
     /*   41079 */     GIR_EraseRootFromParent_Done,
     /*   41080 */   // Label 695: @41080
     /*   41080 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(41133), // Rule ID 46113 //
     /*   41085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41096 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   41096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   41099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   41113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   41120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   41122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41131 */     GIR_RootConstrainSelectedInstOperands,
     /*   41132 */     // GIR_Coverage, 46113,
     /*   41132 */     GIR_EraseRootFromParent_Done,
     /*   41133 */   // Label 696: @41133
     /*   41133 */   GIM_Reject,
     /*   41134 */ // Label 690: @41134
     /*   41134 */ GIM_Reject,
     /*   41135 */ // Label 141: @41135
     /*   41135 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(44259),
     /*   41140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41150 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(41246), // Rule ID 70818 //
     /*   41155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41174 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41188 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41195 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41199 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41203 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41207 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41209 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41220 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41244 */     GIR_RootConstrainSelectedInstOperands,
     /*   41245 */     // GIR_Coverage, 70818,
     /*   41245 */     GIR_EraseRootFromParent_Done,
     /*   41246 */   // Label 698: @41246
     /*   41246 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(41342), // Rule ID 70819 //
     /*   41251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41266 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41270 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41284 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41291 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41295 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41299 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41303 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41305 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41316 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41340 */     GIR_RootConstrainSelectedInstOperands,
     /*   41341 */     // GIR_Coverage, 70819,
     /*   41341 */     GIR_EraseRootFromParent_Done,
     /*   41342 */   // Label 699: @41342
     /*   41342 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(41438), // Rule ID 71066 //
     /*   41347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41399 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41401 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41412 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41436 */     GIR_RootConstrainSelectedInstOperands,
     /*   41437 */     // GIR_Coverage, 71066,
     /*   41437 */     GIR_EraseRootFromParent_Done,
     /*   41438 */   // Label 700: @41438
     /*   41438 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(41534), // Rule ID 71067 //
     /*   41443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41462 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41495 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41508 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41532 */     GIR_RootConstrainSelectedInstOperands,
     /*   41533 */     // GIR_Coverage, 71067,
     /*   41533 */     GIR_EraseRootFromParent_Done,
     /*   41534 */   // Label 701: @41534
     /*   41534 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(41630), // Rule ID 71068 //
     /*   41539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41572 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41591 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41593 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41604 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41628 */     GIR_RootConstrainSelectedInstOperands,
     /*   41629 */     // GIR_Coverage, 71068,
     /*   41629 */     GIR_EraseRootFromParent_Done,
     /*   41630 */   // Label 702: @41630
     /*   41630 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(41726), // Rule ID 71069 //
     /*   41635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41668 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41683 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41687 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41689 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41700 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   41703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41724 */     GIR_RootConstrainSelectedInstOperands,
     /*   41725 */     // GIR_Coverage, 71069,
     /*   41725 */     GIR_EraseRootFromParent_Done,
     /*   41726 */   // Label 703: @41726
     /*   41726 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(41822), // Rule ID 70932 //
     /*   41731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41771 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41775 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41779 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41783 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41785 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41794 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41796 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   41799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41820 */     GIR_RootConstrainSelectedInstOperands,
     /*   41821 */     // GIR_Coverage, 70932,
     /*   41821 */     GIR_EraseRootFromParent_Done,
     /*   41822 */   // Label 704: @41822
     /*   41822 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(41918), // Rule ID 70933 //
     /*   41827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41842 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41860 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41862 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41879 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41892 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   41892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   41895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   41899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41916 */     GIR_RootConstrainSelectedInstOperands,
     /*   41917 */     // GIR_Coverage, 70933,
     /*   41917 */     GIR_EraseRootFromParent_Done,
     /*   41918 */   // Label 705: @41918
     /*   41918 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(42014), // Rule ID 52036 //
     /*   41923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   41946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   41979 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41981 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   41986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41988 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   41988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   41991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42012 */     GIR_RootConstrainSelectedInstOperands,
     /*   42013 */     // GIR_Coverage, 52036,
     /*   42013 */     GIR_EraseRootFromParent_Done,
     /*   42014 */   // Label 706: @42014
     /*   42014 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(42110), // Rule ID 52037 //
     /*   42019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42042 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42071 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42075 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42077 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42084 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   42087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42108 */     GIR_RootConstrainSelectedInstOperands,
     /*   42109 */     // GIR_Coverage, 52037,
     /*   42109 */     GIR_EraseRootFromParent_Done,
     /*   42110 */   // Label 707: @42110
     /*   42110 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(42206), // Rule ID 52154 //
     /*   42115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42138 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42152 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42167 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42171 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42173 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42180 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42204 */     GIR_RootConstrainSelectedInstOperands,
     /*   42205 */     // GIR_Coverage, 52154,
     /*   42205 */     GIR_EraseRootFromParent_Done,
     /*   42206 */   // Label 708: @42206
     /*   42206 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(42302), // Rule ID 52155 //
     /*   42211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42234 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42248 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42263 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42267 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42276 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42300 */     GIR_RootConstrainSelectedInstOperands,
     /*   42301 */     // GIR_Coverage, 52155,
     /*   42301 */     GIR_EraseRootFromParent_Done,
     /*   42302 */   // Label 709: @42302
     /*   42302 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(42398), // Rule ID 71064 //
     /*   42307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42330 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42359 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42363 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42365 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42372 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42396 */     GIR_RootConstrainSelectedInstOperands,
     /*   42397 */     // GIR_Coverage, 71064,
     /*   42397 */     GIR_EraseRootFromParent_Done,
     /*   42398 */   // Label 710: @42398
     /*   42398 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(42494), // Rule ID 71065 //
     /*   42403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42459 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42468 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   42471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   42479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   42483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42492 */     GIR_RootConstrainSelectedInstOperands,
     /*   42493 */     // GIR_Coverage, 71065,
     /*   42493 */     GIR_EraseRootFromParent_Done,
     /*   42494 */   // Label 711: @42494
     /*   42494 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(42590), // Rule ID 52094 //
     /*   42499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42522 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42547 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42551 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42555 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42562 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42564 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   42564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42588 */     GIR_RootConstrainSelectedInstOperands,
     /*   42589 */     // GIR_Coverage, 52094,
     /*   42589 */     GIR_EraseRootFromParent_Done,
     /*   42590 */   // Label 712: @42590
     /*   42590 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(42686), // Rule ID 52095 //
     /*   42595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   42618 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   42624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   42643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42647 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42651 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   42653 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   42660 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   42660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   42663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   42667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   42675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42684 */     GIR_RootConstrainSelectedInstOperands,
     /*   42685 */     // GIR_Coverage, 52095,
     /*   42685 */     GIR_EraseRootFromParent_Done,
     /*   42686 */   // Label 713: @42686
     /*   42686 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(42775), // Rule ID 46686 //
     /*   42691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42706 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42725 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42734 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   42734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   42751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42773 */     GIR_RootConstrainSelectedInstOperands,
     /*   42774 */     // GIR_Coverage, 46686,
     /*   42774 */     GIR_EraseRootFromParent_Done,
     /*   42775 */   // Label 714: @42775
     /*   42775 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(42864), // Rule ID 46687 //
     /*   42780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42795 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42814 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42821 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42823 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   42823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   42840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42862 */     GIR_RootConstrainSelectedInstOperands,
     /*   42863 */     // GIR_Coverage, 46687,
     /*   42863 */     GIR_EraseRootFromParent_Done,
     /*   42864 */   // Label 715: @42864
     /*   42864 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(42953), // Rule ID 46450 //
     /*   42869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42884 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42903 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42912 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   42912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   42915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   42929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42951 */     GIR_RootConstrainSelectedInstOperands,
     /*   42952 */     // GIR_Coverage, 46450,
     /*   42952 */     GIR_EraseRootFromParent_Done,
     /*   42953 */   // Label 716: @42953
     /*   42953 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(43042), // Rule ID 46451 //
     /*   42958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   42992 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42994 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   42999 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43001 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   43018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43040 */     GIR_RootConstrainSelectedInstOperands,
     /*   43041 */     // GIR_Coverage, 46451,
     /*   43041 */     GIR_EraseRootFromParent_Done,
     /*   43042 */   // Label 717: @43042
     /*   43042 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(43131), // Rule ID 46566 //
     /*   43047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43062 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43081 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43090 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   43090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43129 */     GIR_RootConstrainSelectedInstOperands,
     /*   43130 */     // GIR_Coverage, 46566,
     /*   43130 */     GIR_EraseRootFromParent_Done,
     /*   43131 */   // Label 718: @43131
     /*   43131 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(43220), // Rule ID 46567 //
     /*   43136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   43162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43170 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   43179 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   43179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   43182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   43196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   43205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43218 */     GIR_RootConstrainSelectedInstOperands,
     /*   43219 */     // GIR_Coverage, 46567,
     /*   43219 */     GIR_EraseRootFromParent_Done,
     /*   43220 */   // Label 719: @43220
     /*   43220 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(43288), // Rule ID 70698 //
     /*   43225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43244 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43262 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43286 */     GIR_RootConstrainSelectedInstOperands,
     /*   43287 */     // GIR_Coverage, 70698,
     /*   43287 */     GIR_EraseRootFromParent_Done,
     /*   43288 */   // Label 720: @43288
     /*   43288 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(43356), // Rule ID 70699 //
     /*   43293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43330 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43354 */     GIR_RootConstrainSelectedInstOperands,
     /*   43355 */     // GIR_Coverage, 70699,
     /*   43355 */     GIR_EraseRootFromParent_Done,
     /*   43356 */   // Label 721: @43356
     /*   43356 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(43411), // Rule ID 69622 //
     /*   43361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43389 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43409 */     GIR_RootConstrainSelectedInstOperands,
     /*   43410 */     // GIR_Coverage, 69622,
     /*   43410 */     GIR_EraseRootFromParent_Done,
     /*   43411 */   // Label 722: @43411
     /*   43411 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(43466), // Rule ID 69623 //
     /*   43416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43444 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43464 */     GIR_RootConstrainSelectedInstOperands,
     /*   43465 */     // GIR_Coverage, 69623,
     /*   43465 */     GIR_EraseRootFromParent_Done,
     /*   43466 */   // Label 723: @43466
     /*   43466 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(43521), // Rule ID 69442 //
     /*   43471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43499 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43519 */     GIR_RootConstrainSelectedInstOperands,
     /*   43520 */     // GIR_Coverage, 69442,
     /*   43520 */     GIR_EraseRootFromParent_Done,
     /*   43521 */   // Label 724: @43521
     /*   43521 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(43576), // Rule ID 69443 //
     /*   43526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43554 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43574 */     GIR_RootConstrainSelectedInstOperands,
     /*   43575 */     // GIR_Coverage, 69443,
     /*   43575 */     GIR_EraseRootFromParent_Done,
     /*   43576 */   // Label 725: @43576
     /*   43576 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(43631), // Rule ID 69532 //
     /*   43581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43609 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43629 */     GIR_RootConstrainSelectedInstOperands,
     /*   43630 */     // GIR_Coverage, 69532,
     /*   43630 */     GIR_EraseRootFromParent_Done,
     /*   43631 */   // Label 726: @43631
     /*   43631 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(43686), // Rule ID 69533 //
     /*   43636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43664 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43684 */     GIR_RootConstrainSelectedInstOperands,
     /*   43685 */     // GIR_Coverage, 69533,
     /*   43685 */     GIR_EraseRootFromParent_Done,
     /*   43686 */   // Label 727: @43686
     /*   43686 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(43754), // Rule ID 51908 //
     /*   43691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43728 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43752 */     GIR_RootConstrainSelectedInstOperands,
     /*   43753 */     // GIR_Coverage, 51908,
     /*   43753 */     GIR_EraseRootFromParent_Done,
     /*   43754 */   // Label 728: @43754
     /*   43754 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(43822), // Rule ID 51909 //
     /*   43759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   43782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43796 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   43799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   43805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43820 */     GIR_RootConstrainSelectedInstOperands,
     /*   43821 */     // GIR_Coverage, 51909,
     /*   43821 */     GIR_EraseRootFromParent_Done,
     /*   43822 */   // Label 729: @43822
     /*   43822 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(43877), // Rule ID 46746 //
     /*   43827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43855 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43875 */     GIR_RootConstrainSelectedInstOperands,
     /*   43876 */     // GIR_Coverage, 46746,
     /*   43876 */     GIR_EraseRootFromParent_Done,
     /*   43877 */   // Label 730: @43877
     /*   43877 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(43932), // Rule ID 46747 //
     /*   43882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   43897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43910 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   43910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   43913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43930 */     GIR_RootConstrainSelectedInstOperands,
     /*   43931 */     // GIR_Coverage, 46747,
     /*   43931 */     GIR_EraseRootFromParent_Done,
     /*   43932 */   // Label 731: @43932
     /*   43932 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(43987), // Rule ID 46506 //
     /*   43937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   43956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   43963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43965 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   43965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   43968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43985 */     GIR_RootConstrainSelectedInstOperands,
     /*   43986 */     // GIR_Coverage, 46506,
     /*   43986 */     GIR_EraseRootFromParent_Done,
     /*   43987 */   // Label 732: @43987
     /*   43987 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(44042), // Rule ID 46507 //
     /*   43992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44020 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   44023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44040 */     GIR_RootConstrainSelectedInstOperands,
     /*   44041 */     // GIR_Coverage, 46507,
     /*   44041 */     GIR_EraseRootFromParent_Done,
     /*   44042 */   // Label 733: @44042
     /*   44042 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(44097), // Rule ID 46626 //
     /*   44047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44075 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   44075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44095 */     GIR_RootConstrainSelectedInstOperands,
     /*   44096 */     // GIR_Coverage, 46626,
     /*   44096 */     GIR_EraseRootFromParent_Done,
     /*   44097 */   // Label 734: @44097
     /*   44097 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(44152), // Rule ID 46627 //
     /*   44102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   44121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   44128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   44130 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   44130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   44133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   44137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   44141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44150 */     GIR_RootConstrainSelectedInstOperands,
     /*   44151 */     // GIR_Coverage, 46627,
     /*   44151 */     GIR_EraseRootFromParent_Done,
     /*   44152 */   // Label 735: @44152
     /*   44152 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(44205), // Rule ID 46140 //
     /*   44157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44168 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   44168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44203 */     GIR_RootConstrainSelectedInstOperands,
     /*   44204 */     // GIR_Coverage, 46140,
     /*   44204 */     GIR_EraseRootFromParent_Done,
     /*   44205 */   // Label 736: @44205
     /*   44205 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(44258), // Rule ID 46141 //
     /*   44210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44221 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   44221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   44224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   44238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   44245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   44247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44256 */     GIR_RootConstrainSelectedInstOperands,
     /*   44257 */     // GIR_Coverage, 46141,
     /*   44257 */     GIR_EraseRootFromParent_Done,
     /*   44258 */   // Label 737: @44258
     /*   44258 */   GIM_Reject,
     /*   44259 */ // Label 697: @44259
     /*   44259 */ GIM_Reject,
     /*   44260 */ // Label 142: @44260
     /*   44260 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(47384),
     /*   44265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44275 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(44371), // Rule ID 70830 //
     /*   44280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44313 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44332 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44334 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44343 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44345 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44369 */     GIR_RootConstrainSelectedInstOperands,
     /*   44370 */     // GIR_Coverage, 70830,
     /*   44370 */     GIR_EraseRootFromParent_Done,
     /*   44371 */   // Label 739: @44371
     /*   44371 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(44467), // Rule ID 70831 //
     /*   44376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44395 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44409 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44424 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44428 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44430 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44441 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   44444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44465 */     GIR_RootConstrainSelectedInstOperands,
     /*   44466 */     // GIR_Coverage, 70831,
     /*   44466 */     GIR_EraseRootFromParent_Done,
     /*   44467 */   // Label 740: @44467
     /*   44467 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(44563), // Rule ID 71102 //
     /*   44472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44505 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44520 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44524 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44526 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44537 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44561 */     GIR_RootConstrainSelectedInstOperands,
     /*   44562 */     // GIR_Coverage, 71102,
     /*   44562 */     GIR_EraseRootFromParent_Done,
     /*   44563 */   // Label 741: @44563
     /*   44563 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(44659), // Rule ID 71103 //
     /*   44568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44601 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44616 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44620 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44622 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44631 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44633 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44657 */     GIR_RootConstrainSelectedInstOperands,
     /*   44658 */     // GIR_Coverage, 71103,
     /*   44658 */     GIR_EraseRootFromParent_Done,
     /*   44659 */   // Label 742: @44659
     /*   44659 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(44755), // Rule ID 71104 //
     /*   44664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44683 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44697 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44712 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44716 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44718 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44727 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44729 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44753 */     GIR_RootConstrainSelectedInstOperands,
     /*   44754 */     // GIR_Coverage, 71104,
     /*   44754 */     GIR_EraseRootFromParent_Done,
     /*   44755 */   // Label 743: @44755
     /*   44755 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(44851), // Rule ID 71105 //
     /*   44760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44793 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44812 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44814 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44825 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   44825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   44828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44849 */     GIR_RootConstrainSelectedInstOperands,
     /*   44850 */     // GIR_Coverage, 71105,
     /*   44850 */     GIR_EraseRootFromParent_Done,
     /*   44851 */   // Label 744: @44851
     /*   44851 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(44947), // Rule ID 70944 //
     /*   44856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   44859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44889 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44896 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44900 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44904 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44908 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44910 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44921 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   44921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   44924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   44942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44945 */     GIR_RootConstrainSelectedInstOperands,
     /*   44946 */     // GIR_Coverage, 70944,
     /*   44946 */     GIR_EraseRootFromParent_Done,
     /*   44947 */   // Label 745: @44947
     /*   44947 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(45043), // Rule ID 70945 //
     /*   44952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   44955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   44971 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   44985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   44992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45000 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45004 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45006 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45017 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   45024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45041 */     GIR_RootConstrainSelectedInstOperands,
     /*   45042 */     // GIR_Coverage, 70945,
     /*   45042 */     GIR_EraseRootFromParent_Done,
     /*   45043 */   // Label 746: @45043
     /*   45043 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(45139), // Rule ID 52048 //
     /*   45048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45104 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45106 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45111 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45113 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45137 */     GIR_RootConstrainSelectedInstOperands,
     /*   45138 */     // GIR_Coverage, 52048,
     /*   45138 */     GIR_EraseRootFromParent_Done,
     /*   45139 */   // Label 747: @45139
     /*   45139 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(45235), // Rule ID 52049 //
     /*   45144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45200 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45202 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45209 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   45212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45233 */     GIR_RootConstrainSelectedInstOperands,
     /*   45234 */     // GIR_Coverage, 52049,
     /*   45234 */     GIR_EraseRootFromParent_Done,
     /*   45235 */   // Label 748: @45235
     /*   45235 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(45331), // Rule ID 52166 //
     /*   45240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45263 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45277 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45292 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45296 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45303 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45305 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45329 */     GIR_RootConstrainSelectedInstOperands,
     /*   45330 */     // GIR_Coverage, 52166,
     /*   45330 */     GIR_EraseRootFromParent_Done,
     /*   45331 */   // Label 749: @45331
     /*   45331 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(45427), // Rule ID 52167 //
     /*   45336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45373 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45392 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45394 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45401 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45425 */     GIR_RootConstrainSelectedInstOperands,
     /*   45426 */     // GIR_Coverage, 52167,
     /*   45426 */     GIR_EraseRootFromParent_Done,
     /*   45427 */   // Label 750: @45427
     /*   45427 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(45523), // Rule ID 71100 //
     /*   45432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45488 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45490 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45497 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45521 */     GIR_RootConstrainSelectedInstOperands,
     /*   45522 */     // GIR_Coverage, 71100,
     /*   45522 */     GIR_EraseRootFromParent_Done,
     /*   45523 */   // Label 751: @45523
     /*   45523 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(45619), // Rule ID 71101 //
     /*   45528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45580 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45584 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45586 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45591 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45593 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   45596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   45604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   45608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45617 */     GIR_RootConstrainSelectedInstOperands,
     /*   45618 */     // GIR_Coverage, 71101,
     /*   45618 */     GIR_EraseRootFromParent_Done,
     /*   45619 */   // Label 752: @45619
     /*   45619 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(45715), // Rule ID 52106 //
     /*   45624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45661 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45680 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45682 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45689 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   45689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45713 */     GIR_RootConstrainSelectedInstOperands,
     /*   45714 */     // GIR_Coverage, 52106,
     /*   45714 */     GIR_EraseRootFromParent_Done,
     /*   45715 */   // Label 753: @45715
     /*   45715 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(45811), // Rule ID 52107 //
     /*   45720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   45743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   45749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45757 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   45768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45772 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45776 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   45778 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45783 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   45785 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   45785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   45788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   45792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   45800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45809 */     GIR_RootConstrainSelectedInstOperands,
     /*   45810 */     // GIR_Coverage, 52107,
     /*   45810 */     GIR_EraseRootFromParent_Done,
     /*   45811 */   // Label 754: @45811
     /*   45811 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(45900), // Rule ID 46710 //
     /*   45816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45859 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   45859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   45876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45898 */     GIR_RootConstrainSelectedInstOperands,
     /*   45899 */     // GIR_Coverage, 46710,
     /*   45899 */     GIR_EraseRootFromParent_Done,
     /*   45900 */   // Label 755: @45900
     /*   45900 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(45989), // Rule ID 46711 //
     /*   45905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   45908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   45939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   45946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45948 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   45948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   45951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   45965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   45984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45987 */     GIR_RootConstrainSelectedInstOperands,
     /*   45988 */     // GIR_Coverage, 46711,
     /*   45988 */     GIR_EraseRootFromParent_Done,
     /*   45989 */   // Label 756: @45989
     /*   45989 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(46078), // Rule ID 46474 //
     /*   45994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   45997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46028 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46037 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46076 */     GIR_RootConstrainSelectedInstOperands,
     /*   46077 */     // GIR_Coverage, 46474,
     /*   46077 */     GIR_EraseRootFromParent_Done,
     /*   46078 */   // Label 757: @46078
     /*   46078 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(46167), // Rule ID 46475 //
     /*   46083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46117 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46126 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   46143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46165 */     GIR_RootConstrainSelectedInstOperands,
     /*   46166 */     // GIR_Coverage, 46475,
     /*   46166 */     GIR_EraseRootFromParent_Done,
     /*   46167 */   // Label 758: @46167
     /*   46167 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(46256), // Rule ID 46590 //
     /*   46172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46206 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46215 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   46215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46254 */     GIR_RootConstrainSelectedInstOperands,
     /*   46255 */     // GIR_Coverage, 46590,
     /*   46255 */     GIR_EraseRootFromParent_Done,
     /*   46256 */   // Label 759: @46256
     /*   46256 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(46345), // Rule ID 46591 //
     /*   46261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46276 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   46287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46295 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   46304 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   46304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   46307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   46321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   46330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46343 */     GIR_RootConstrainSelectedInstOperands,
     /*   46344 */     // GIR_Coverage, 46591,
     /*   46344 */     GIR_EraseRootFromParent_Done,
     /*   46345 */   // Label 760: @46345
     /*   46345 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(46413), // Rule ID 70730 //
     /*   46350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46369 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46387 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46411 */     GIR_RootConstrainSelectedInstOperands,
     /*   46412 */     // GIR_Coverage, 70730,
     /*   46412 */     GIR_EraseRootFromParent_Done,
     /*   46413 */   // Label 761: @46413
     /*   46413 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(46481), // Rule ID 70731 //
     /*   46418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46455 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46479 */     GIR_RootConstrainSelectedInstOperands,
     /*   46480 */     // GIR_Coverage, 70731,
     /*   46480 */     GIR_EraseRootFromParent_Done,
     /*   46481 */   // Label 762: @46481
     /*   46481 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(46536), // Rule ID 69646 //
     /*   46486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46501 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46514 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46534 */     GIR_RootConstrainSelectedInstOperands,
     /*   46535 */     // GIR_Coverage, 69646,
     /*   46535 */     GIR_EraseRootFromParent_Done,
     /*   46536 */   // Label 763: @46536
     /*   46536 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(46591), // Rule ID 69647 //
     /*   46541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46569 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46589 */     GIR_RootConstrainSelectedInstOperands,
     /*   46590 */     // GIR_Coverage, 69647,
     /*   46590 */     GIR_EraseRootFromParent_Done,
     /*   46591 */   // Label 764: @46591
     /*   46591 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(46646), // Rule ID 69466 //
     /*   46596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46624 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   46627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46644 */     GIR_RootConstrainSelectedInstOperands,
     /*   46645 */     // GIR_Coverage, 69466,
     /*   46645 */     GIR_EraseRootFromParent_Done,
     /*   46646 */   // Label 765: @46646
     /*   46646 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(46701), // Rule ID 69467 //
     /*   46651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46679 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   46682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46699 */     GIR_RootConstrainSelectedInstOperands,
     /*   46700 */     // GIR_Coverage, 69467,
     /*   46700 */     GIR_EraseRootFromParent_Done,
     /*   46701 */   // Label 766: @46701
     /*   46701 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(46756), // Rule ID 69556 //
     /*   46706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46734 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46754 */     GIR_RootConstrainSelectedInstOperands,
     /*   46755 */     // GIR_Coverage, 69556,
     /*   46755 */     GIR_EraseRootFromParent_Done,
     /*   46756 */   // Label 767: @46756
     /*   46756 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(46811), // Rule ID 69557 //
     /*   46761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46789 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   46789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46809 */     GIR_RootConstrainSelectedInstOperands,
     /*   46810 */     // GIR_Coverage, 69557,
     /*   46810 */     GIR_EraseRootFromParent_Done,
     /*   46811 */   // Label 768: @46811
     /*   46811 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(46879), // Rule ID 51924 //
     /*   46816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46839 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46853 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46877 */     GIR_RootConstrainSelectedInstOperands,
     /*   46878 */     // GIR_Coverage, 51924,
     /*   46878 */     GIR_EraseRootFromParent_Done,
     /*   46879 */   // Label 769: @46879
     /*   46879 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(46947), // Rule ID 51925 //
     /*   46884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   46907 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46921 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   46924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46945 */     GIR_RootConstrainSelectedInstOperands,
     /*   46946 */     // GIR_Coverage, 51925,
     /*   46946 */     GIR_EraseRootFromParent_Done,
     /*   46947 */   // Label 770: @46947
     /*   46947 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(47002), // Rule ID 46770 //
     /*   46952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   46971 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46980 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   46980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   46983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   46997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47000 */     GIR_RootConstrainSelectedInstOperands,
     /*   47001 */     // GIR_Coverage, 46770,
     /*   47001 */     GIR_EraseRootFromParent_Done,
     /*   47002 */   // Label 771: @47002
     /*   47002 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(47057), // Rule ID 46771 //
     /*   47007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   47022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47035 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47055 */     GIR_RootConstrainSelectedInstOperands,
     /*   47056 */     // GIR_Coverage, 46771,
     /*   47056 */     GIR_EraseRootFromParent_Done,
     /*   47057 */   // Label 772: @47057
     /*   47057 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(47112), // Rule ID 46530 //
     /*   47062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47081 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47090 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47110 */     GIR_RootConstrainSelectedInstOperands,
     /*   47111 */     // GIR_Coverage, 46530,
     /*   47111 */     GIR_EraseRootFromParent_Done,
     /*   47112 */   // Label 773: @47112
     /*   47112 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(47167), // Rule ID 46531 //
     /*   47117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47145 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   47148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47165 */     GIR_RootConstrainSelectedInstOperands,
     /*   47166 */     // GIR_Coverage, 46531,
     /*   47166 */     GIR_EraseRootFromParent_Done,
     /*   47167 */   // Label 774: @47167
     /*   47167 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(47222), // Rule ID 46650 //
     /*   47172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47200 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   47200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47220 */     GIR_RootConstrainSelectedInstOperands,
     /*   47221 */     // GIR_Coverage, 46650,
     /*   47221 */     GIR_EraseRootFromParent_Done,
     /*   47222 */   // Label 775: @47222
     /*   47222 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(47277), // Rule ID 46651 //
     /*   47227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   47246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   47255 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   47255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   47258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   47262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   47266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   47272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47275 */     GIR_RootConstrainSelectedInstOperands,
     /*   47276 */     // GIR_Coverage, 46651,
     /*   47276 */     GIR_EraseRootFromParent_Done,
     /*   47277 */   // Label 776: @47277
     /*   47277 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(47330), // Rule ID 46156 //
     /*   47282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47293 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   47293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47328 */     GIR_RootConstrainSelectedInstOperands,
     /*   47329 */     // GIR_Coverage, 46156,
     /*   47329 */     GIR_EraseRootFromParent_Done,
     /*   47330 */   // Label 777: @47330
     /*   47330 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(47383), // Rule ID 46157 //
     /*   47335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47346 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   47346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   47349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   47353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   47358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   47360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   47363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   47368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   47370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   47372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47381 */     GIR_RootConstrainSelectedInstOperands,
     /*   47382 */     // GIR_Coverage, 46157,
     /*   47382 */     GIR_EraseRootFromParent_Done,
     /*   47383 */   // Label 778: @47383
     /*   47383 */   GIM_Reject,
     /*   47384 */ // Label 738: @47384
     /*   47384 */ GIM_Reject,
     /*   47385 */ // Label 143: @47385
     /*   47385 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50509),
     /*   47390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47400 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(47496), // Rule ID 70840 //
     /*   47405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47438 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47457 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47470 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47494 */     GIR_RootConstrainSelectedInstOperands,
     /*   47495 */     // GIR_Coverage, 70840,
     /*   47495 */     GIR_EraseRootFromParent_Done,
     /*   47496 */   // Label 780: @47496
     /*   47496 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(47592), // Rule ID 70841 //
     /*   47501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47534 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47553 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47566 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   47569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47590 */     GIR_RootConstrainSelectedInstOperands,
     /*   47591 */     // GIR_Coverage, 70841,
     /*   47591 */     GIR_EraseRootFromParent_Done,
     /*   47592 */   // Label 781: @47592
     /*   47592 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(47688), // Rule ID 71132 //
     /*   47597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47645 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47649 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47651 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47662 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47686 */     GIR_RootConstrainSelectedInstOperands,
     /*   47687 */     // GIR_Coverage, 71132,
     /*   47687 */     GIR_EraseRootFromParent_Done,
     /*   47688 */   // Label 782: @47688
     /*   47688 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(47784), // Rule ID 71133 //
     /*   47693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47726 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47733 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47737 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47741 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47745 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47747 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47758 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47782 */     GIR_RootConstrainSelectedInstOperands,
     /*   47783 */     // GIR_Coverage, 71133,
     /*   47783 */     GIR_EraseRootFromParent_Done,
     /*   47784 */   // Label 783: @47784
     /*   47784 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(47880), // Rule ID 71134 //
     /*   47789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47822 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47837 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47841 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47843 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47854 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   47854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47878 */     GIR_RootConstrainSelectedInstOperands,
     /*   47879 */     // GIR_Coverage, 71134,
     /*   47879 */     GIR_EraseRootFromParent_Done,
     /*   47880 */   // Label 784: @47880
     /*   47880 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(47976), // Rule ID 71135 //
     /*   47885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   47888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   47904 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47918 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47933 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   47937 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47939 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   47948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47950 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   47950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   47953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   47971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47974 */     GIR_RootConstrainSelectedInstOperands,
     /*   47975 */     // GIR_Coverage, 71135,
     /*   47975 */     GIR_EraseRootFromParent_Done,
     /*   47976 */   // Label 785: @47976
     /*   47976 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(48072), // Rule ID 70954 //
     /*   47981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   47984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   47996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48000 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48014 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48033 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48035 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48046 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48070 */     GIR_RootConstrainSelectedInstOperands,
     /*   48071 */     // GIR_Coverage, 70954,
     /*   48071 */     GIR_EraseRootFromParent_Done,
     /*   48072 */   // Label 786: @48072
     /*   48072 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(48168), // Rule ID 70955 //
     /*   48077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48110 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48125 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48129 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48142 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   48149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48166 */     GIR_RootConstrainSelectedInstOperands,
     /*   48167 */     // GIR_Coverage, 70955,
     /*   48167 */     GIR_EraseRootFromParent_Done,
     /*   48168 */   // Label 787: @48168
     /*   48168 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(48264), // Rule ID 52058 //
     /*   48173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48225 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48229 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48238 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48262 */     GIR_RootConstrainSelectedInstOperands,
     /*   48263 */     // GIR_Coverage, 52058,
     /*   48263 */     GIR_EraseRootFromParent_Done,
     /*   48264 */   // Label 788: @48264
     /*   48264 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(48360), // Rule ID 52059 //
     /*   48269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48325 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48334 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   48337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48358 */     GIR_RootConstrainSelectedInstOperands,
     /*   48359 */     // GIR_Coverage, 52059,
     /*   48359 */     GIR_EraseRootFromParent_Done,
     /*   48360 */   // Label 789: @48360
     /*   48360 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(48456), // Rule ID 52176 //
     /*   48365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48402 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48421 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48423 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48430 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48454 */     GIR_RootConstrainSelectedInstOperands,
     /*   48455 */     // GIR_Coverage, 52176,
     /*   48455 */     GIR_EraseRootFromParent_Done,
     /*   48456 */   // Label 790: @48456
     /*   48456 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(48552), // Rule ID 52177 //
     /*   48461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48498 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48517 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48519 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48526 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48550 */     GIR_RootConstrainSelectedInstOperands,
     /*   48551 */     // GIR_Coverage, 52177,
     /*   48551 */     GIR_EraseRootFromParent_Done,
     /*   48552 */   // Label 791: @48552
     /*   48552 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(48648), // Rule ID 71130 //
     /*   48557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48580 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48594 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48609 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48613 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48622 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48646 */     GIR_RootConstrainSelectedInstOperands,
     /*   48647 */     // GIR_Coverage, 71130,
     /*   48647 */     GIR_EraseRootFromParent_Done,
     /*   48648 */   // Label 792: @48648
     /*   48648 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(48744), // Rule ID 71131 //
     /*   48653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48690 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48709 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48716 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48718 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   48721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48742 */     GIR_RootConstrainSelectedInstOperands,
     /*   48743 */     // GIR_Coverage, 71131,
     /*   48743 */     GIR_EraseRootFromParent_Done,
     /*   48744 */   // Label 793: @48744
     /*   48744 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(48840), // Rule ID 52116 //
     /*   48749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48786 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48801 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48805 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48807 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48812 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48814 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   48814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48838 */     GIR_RootConstrainSelectedInstOperands,
     /*   48839 */     // GIR_Coverage, 52116,
     /*   48839 */     GIR_EraseRootFromParent_Done,
     /*   48840 */   // Label 794: @48840
     /*   48840 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(48936), // Rule ID 52117 //
     /*   48845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   48848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   48852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   48864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   48868 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48882 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48889 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48893 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48897 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48901 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48910 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   48910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   48913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   48931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48934 */     GIR_RootConstrainSelectedInstOperands,
     /*   48935 */     // GIR_Coverage, 52117,
     /*   48935 */     GIR_EraseRootFromParent_Done,
     /*   48936 */   // Label 795: @48936
     /*   48936 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49025), // Rule ID 46730 //
     /*   48941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   48944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   48975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48984 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   48984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   48987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49023 */     GIR_RootConstrainSelectedInstOperands,
     /*   49024 */     // GIR_Coverage, 46730,
     /*   49024 */     GIR_EraseRootFromParent_Done,
     /*   49025 */   // Label 796: @49025
     /*   49025 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49114), // Rule ID 46731 //
     /*   49030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49073 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49112 */     GIR_RootConstrainSelectedInstOperands,
     /*   49113 */     // GIR_Coverage, 46731,
     /*   49113 */     GIR_EraseRootFromParent_Done,
     /*   49114 */   // Label 797: @49114
     /*   49114 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49203), // Rule ID 46494 //
     /*   49119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49162 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49201 */     GIR_RootConstrainSelectedInstOperands,
     /*   49202 */     // GIR_Coverage, 46494,
     /*   49202 */     GIR_EraseRootFromParent_Done,
     /*   49203 */   // Label 798: @49203
     /*   49203 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49292), // Rule ID 46495 //
     /*   49208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49251 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   49268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49290 */     GIR_RootConstrainSelectedInstOperands,
     /*   49291 */     // GIR_Coverage, 46495,
     /*   49291 */     GIR_EraseRootFromParent_Done,
     /*   49292 */   // Label 799: @49292
     /*   49292 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49381), // Rule ID 46610 //
     /*   49297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49340 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   49340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49379 */     GIR_RootConstrainSelectedInstOperands,
     /*   49380 */     // GIR_Coverage, 46610,
     /*   49380 */     GIR_EraseRootFromParent_Done,
     /*   49381 */   // Label 800: @49381
     /*   49381 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49470), // Rule ID 46611 //
     /*   49386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   49412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   49429 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   49429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   49432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   49446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   49455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   49459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49468 */     GIR_RootConstrainSelectedInstOperands,
     /*   49469 */     // GIR_Coverage, 46611,
     /*   49469 */     GIR_EraseRootFromParent_Done,
     /*   49470 */   // Label 801: @49470
     /*   49470 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49538), // Rule ID 70762 //
     /*   49475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49494 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49512 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49536 */     GIR_RootConstrainSelectedInstOperands,
     /*   49537 */     // GIR_Coverage, 70762,
     /*   49537 */     GIR_EraseRootFromParent_Done,
     /*   49538 */   // Label 802: @49538
     /*   49538 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49606), // Rule ID 70763 //
     /*   49543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   49546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49580 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   49580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49604 */     GIR_RootConstrainSelectedInstOperands,
     /*   49605 */     // GIR_Coverage, 70763,
     /*   49605 */     GIR_EraseRootFromParent_Done,
     /*   49606 */   // Label 803: @49606
     /*   49606 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(49661), // Rule ID 69666 //
     /*   49611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49626 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49639 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49659 */     GIR_RootConstrainSelectedInstOperands,
     /*   49660 */     // GIR_Coverage, 69666,
     /*   49660 */     GIR_EraseRootFromParent_Done,
     /*   49661 */   // Label 804: @49661
     /*   49661 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(49716), // Rule ID 69667 //
     /*   49666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49694 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49714 */     GIR_RootConstrainSelectedInstOperands,
     /*   49715 */     // GIR_Coverage, 69667,
     /*   49715 */     GIR_EraseRootFromParent_Done,
     /*   49716 */   // Label 805: @49716
     /*   49716 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(49771), // Rule ID 69486 //
     /*   49721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49749 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   49752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49769 */     GIR_RootConstrainSelectedInstOperands,
     /*   49770 */     // GIR_Coverage, 69486,
     /*   49770 */     GIR_EraseRootFromParent_Done,
     /*   49771 */   // Label 806: @49771
     /*   49771 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49826), // Rule ID 69487 //
     /*   49776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49804 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   49807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49824 */     GIR_RootConstrainSelectedInstOperands,
     /*   49825 */     // GIR_Coverage, 69487,
     /*   49825 */     GIR_EraseRootFromParent_Done,
     /*   49826 */   // Label 807: @49826
     /*   49826 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(49881), // Rule ID 69576 //
     /*   49831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   49834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49859 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   49859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49879 */     GIR_RootConstrainSelectedInstOperands,
     /*   49880 */     // GIR_Coverage, 69576,
     /*   49880 */     GIR_EraseRootFromParent_Done,
     /*   49881 */   // Label 808: @49881
     /*   49881 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(49936), // Rule ID 69577 //
     /*   49886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   49889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   49901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49914 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   49914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   49917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   49931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49934 */     GIR_RootConstrainSelectedInstOperands,
     /*   49935 */     // GIR_Coverage, 69577,
     /*   49935 */     GIR_EraseRootFromParent_Done,
     /*   49936 */   // Label 809: @49936
     /*   49936 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(50004), // Rule ID 51940 //
     /*   49941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   49944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   49960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   49964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49978 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   49978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   49981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   49999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50002 */     GIR_RootConstrainSelectedInstOperands,
     /*   50003 */     // GIR_Coverage, 51940,
     /*   50003 */     GIR_EraseRootFromParent_Done,
     /*   50004 */   // Label 810: @50004
     /*   50004 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(50072), // Rule ID 51941 //
     /*   50009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   50028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   50032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50046 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   50046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   50049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50070 */     GIR_RootConstrainSelectedInstOperands,
     /*   50071 */     // GIR_Coverage, 51941,
     /*   50071 */     GIR_EraseRootFromParent_Done,
     /*   50072 */   // Label 811: @50072
     /*   50072 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(50127), // Rule ID 46790 //
     /*   50077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50105 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50125 */     GIR_RootConstrainSelectedInstOperands,
     /*   50126 */     // GIR_Coverage, 46790,
     /*   50126 */     GIR_EraseRootFromParent_Done,
     /*   50127 */   // Label 812: @50127
     /*   50127 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(50182), // Rule ID 46791 //
     /*   50132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   50147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50160 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50180 */     GIR_RootConstrainSelectedInstOperands,
     /*   50181 */     // GIR_Coverage, 46791,
     /*   50181 */     GIR_EraseRootFromParent_Done,
     /*   50182 */   // Label 813: @50182
     /*   50182 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(50237), // Rule ID 46550 //
     /*   50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50215 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50235 */     GIR_RootConstrainSelectedInstOperands,
     /*   50236 */     // GIR_Coverage, 46550,
     /*   50236 */     GIR_EraseRootFromParent_Done,
     /*   50237 */   // Label 814: @50237
     /*   50237 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(50292), // Rule ID 46551 //
     /*   50242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50270 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   50273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50290 */     GIR_RootConstrainSelectedInstOperands,
     /*   50291 */     // GIR_Coverage, 46551,
     /*   50291 */     GIR_EraseRootFromParent_Done,
     /*   50292 */   // Label 815: @50292
     /*   50292 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(50347), // Rule ID 46670 //
     /*   50297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   50300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50325 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   50325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50345 */     GIR_RootConstrainSelectedInstOperands,
     /*   50346 */     // GIR_Coverage, 46670,
     /*   50346 */     GIR_EraseRootFromParent_Done,
     /*   50347 */   // Label 816: @50347
     /*   50347 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(50402), // Rule ID 46671 //
     /*   50352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   50355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   50371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50380 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   50380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   50383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   50397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50400 */     GIR_RootConstrainSelectedInstOperands,
     /*   50401 */     // GIR_Coverage, 46671,
     /*   50401 */     GIR_EraseRootFromParent_Done,
     /*   50402 */   // Label 817: @50402
     /*   50402 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(50455), // Rule ID 46172 //
     /*   50407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   50410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50418 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   50418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50453 */     GIR_RootConstrainSelectedInstOperands,
     /*   50454 */     // GIR_Coverage, 46172,
     /*   50454 */     GIR_EraseRootFromParent_Done,
     /*   50455 */   // Label 818: @50455
     /*   50455 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(50508), // Rule ID 46173 //
     /*   50460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   50463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50471 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   50471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   50474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   50488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   50503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50506 */     GIR_RootConstrainSelectedInstOperands,
     /*   50507 */     // GIR_Coverage, 46173,
     /*   50507 */     GIR_EraseRootFromParent_Done,
     /*   50508 */   // Label 819: @50508
     /*   50508 */   GIM_Reject,
     /*   50509 */ // Label 779: @50509
     /*   50509 */ GIM_Reject,
     /*   50510 */ // Label 144: @50510
     /*   50510 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(50904),
     /*   50515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50525 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(50593), // Rule ID 70674 //
     /*   50530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50549 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50567 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50591 */     GIR_RootConstrainSelectedInstOperands,
     /*   50592 */     // GIR_Coverage, 70674,
     /*   50592 */     GIR_EraseRootFromParent_Done,
     /*   50593 */   // Label 821: @50593
     /*   50593 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(50661), // Rule ID 70675 //
     /*   50598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50617 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50635 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   50635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50659 */     GIR_RootConstrainSelectedInstOperands,
     /*   50660 */     // GIR_Coverage, 70675,
     /*   50660 */     GIR_EraseRootFromParent_Done,
     /*   50661 */   // Label 822: @50661
     /*   50661 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(50729), // Rule ID 51896 //
     /*   50666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50703 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50727 */     GIR_RootConstrainSelectedInstOperands,
     /*   50728 */     // GIR_Coverage, 51896,
     /*   50728 */     GIR_EraseRootFromParent_Done,
     /*   50729 */   // Label 823: @50729
     /*   50729 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(50797), // Rule ID 51897 //
     /*   50734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   50757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   50771 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   50771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   50774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   50780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   50784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   50786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50795 */     GIR_RootConstrainSelectedInstOperands,
     /*   50796 */     // GIR_Coverage, 51897,
     /*   50796 */     GIR_EraseRootFromParent_Done,
     /*   50797 */   // Label 824: @50797
     /*   50797 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(50850), // Rule ID 46128 //
     /*   50802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50813 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   50813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   50816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   50830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50848 */     GIR_RootConstrainSelectedInstOperands,
     /*   50849 */     // GIR_Coverage, 46128,
     /*   50849 */     GIR_EraseRootFromParent_Done,
     /*   50850 */   // Label 825: @50850
     /*   50850 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(50903), // Rule ID 46129 //
     /*   50855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50866 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   50866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   50869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   50873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   50878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   50880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   50883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   50888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   50890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   50892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   50901 */     GIR_RootConstrainSelectedInstOperands,
     /*   50902 */     // GIR_Coverage, 46129,
     /*   50902 */     GIR_EraseRootFromParent_Done,
     /*   50903 */   // Label 826: @50903
     /*   50903 */   GIM_Reject,
     /*   50904 */ // Label 820: @50904
     /*   50904 */ GIM_Reject,
     /*   50905 */ // Label 145: @50905
     /*   50905 */ GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(54029),
     /*   50910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   50916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50920 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(51016), // Rule ID 70820 //
     /*   50925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   50944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50958 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   50977 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   50984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50990 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   50990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   50993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51014 */     GIR_RootConstrainSelectedInstOperands,
     /*   51015 */     // GIR_Coverage, 70820,
     /*   51015 */     GIR_EraseRootFromParent_Done,
     /*   51016 */   // Label 828: @51016
     /*   51016 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(51112), // Rule ID 70821 //
     /*   51021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51069 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51073 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51086 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51110 */     GIR_RootConstrainSelectedInstOperands,
     /*   51111 */     // GIR_Coverage, 70821,
     /*   51111 */     GIR_EraseRootFromParent_Done,
     /*   51112 */   // Label 829: @51112
     /*   51112 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(51208), // Rule ID 71072 //
     /*   51117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51150 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51157 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51161 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51165 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51169 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51171 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51180 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51182 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51206 */     GIR_RootConstrainSelectedInstOperands,
     /*   51207 */     // GIR_Coverage, 71072,
     /*   51207 */     GIR_EraseRootFromParent_Done,
     /*   51208 */   // Label 830: @51208
     /*   51208 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(51304), // Rule ID 71073 //
     /*   51213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51232 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51246 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51253 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51257 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51261 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51265 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51267 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51278 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51302 */     GIR_RootConstrainSelectedInstOperands,
     /*   51303 */     // GIR_Coverage, 71073,
     /*   51303 */     GIR_EraseRootFromParent_Done,
     /*   51304 */   // Label 831: @51304
     /*   51304 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(51400), // Rule ID 71074 //
     /*   51309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51342 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51349 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51353 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51357 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51361 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51363 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51374 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51398 */     GIR_RootConstrainSelectedInstOperands,
     /*   51399 */     // GIR_Coverage, 71074,
     /*   51399 */     GIR_EraseRootFromParent_Done,
     /*   51400 */   // Label 832: @51400
     /*   51400 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(51496), // Rule ID 71075 //
     /*   51405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51438 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51453 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51457 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51459 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51470 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51494 */     GIR_RootConstrainSelectedInstOperands,
     /*   51495 */     // GIR_Coverage, 71075,
     /*   51495 */     GIR_EraseRootFromParent_Done,
     /*   51496 */   // Label 833: @51496
     /*   51496 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(51592), // Rule ID 70934 //
     /*   51501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51534 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51553 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51555 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51566 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   51569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51590 */     GIR_RootConstrainSelectedInstOperands,
     /*   51591 */     // GIR_Coverage, 70934,
     /*   51591 */     GIR_EraseRootFromParent_Done,
     /*   51592 */   // Label 834: @51592
     /*   51592 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(51688), // Rule ID 70935 //
     /*   51597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51630 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51632 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51641 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51645 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51649 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51651 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51660 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51662 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   51665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   51669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51686 */     GIR_RootConstrainSelectedInstOperands,
     /*   51687 */     // GIR_Coverage, 70935,
     /*   51687 */     GIR_EraseRootFromParent_Done,
     /*   51688 */   // Label 835: @51688
     /*   51688 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(51784), // Rule ID 52038 //
     /*   51693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51730 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51745 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51749 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51751 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51756 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51758 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51782 */     GIR_RootConstrainSelectedInstOperands,
     /*   51783 */     // GIR_Coverage, 52038,
     /*   51783 */     GIR_EraseRootFromParent_Done,
     /*   51784 */   // Label 836: @51784
     /*   51784 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(51880), // Rule ID 52039 //
     /*   51789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51812 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51826 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51841 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51845 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51847 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51852 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51854 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   51854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   51857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51878 */     GIR_RootConstrainSelectedInstOperands,
     /*   51879 */     // GIR_Coverage, 52039,
     /*   51879 */     GIR_EraseRootFromParent_Done,
     /*   51880 */   // Label 837: @51880
     /*   51880 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(51976), // Rule ID 52156 //
     /*   51885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   51908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51922 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   51941 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51943 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   51948 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51950 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   51950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   51953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51974 */     GIR_RootConstrainSelectedInstOperands,
     /*   51975 */     // GIR_Coverage, 52156,
     /*   51975 */     GIR_EraseRootFromParent_Done,
     /*   51976 */   // Label 838: @51976
     /*   51976 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(52072), // Rule ID 52157 //
     /*   51981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52004 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52033 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52037 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52039 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52044 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52046 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52070 */     GIR_RootConstrainSelectedInstOperands,
     /*   52071 */     // GIR_Coverage, 52157,
     /*   52071 */     GIR_EraseRootFromParent_Done,
     /*   52072 */   // Label 839: @52072
     /*   52072 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(52168), // Rule ID 71070 //
     /*   52077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52114 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52129 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52133 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52135 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52142 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52166 */     GIR_RootConstrainSelectedInstOperands,
     /*   52167 */     // GIR_Coverage, 71070,
     /*   52167 */     GIR_EraseRootFromParent_Done,
     /*   52168 */   // Label 840: @52168
     /*   52168 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(52264), // Rule ID 71071 //
     /*   52173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52225 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52229 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52238 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   52241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   52249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   52253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52262 */     GIR_RootConstrainSelectedInstOperands,
     /*   52263 */     // GIR_Coverage, 71071,
     /*   52263 */     GIR_EraseRootFromParent_Done,
     /*   52264 */   // Label 841: @52264
     /*   52264 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(52360), // Rule ID 52096 //
     /*   52269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52325 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52334 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   52334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52358 */     GIR_RootConstrainSelectedInstOperands,
     /*   52359 */     // GIR_Coverage, 52096,
     /*   52359 */     GIR_EraseRootFromParent_Done,
     /*   52360 */   // Label 842: @52360
     /*   52360 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(52456), // Rule ID 52097 //
     /*   52365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   52388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   52394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52402 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   52413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52421 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   52423 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   52430 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   52430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   52433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   52437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   52445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52454 */     GIR_RootConstrainSelectedInstOperands,
     /*   52455 */     // GIR_Coverage, 52097,
     /*   52455 */     GIR_EraseRootFromParent_Done,
     /*   52456 */   // Label 843: @52456
     /*   52456 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52545), // Rule ID 46690 //
     /*   52461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52476 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52495 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52504 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52543 */     GIR_RootConstrainSelectedInstOperands,
     /*   52544 */     // GIR_Coverage, 46690,
     /*   52544 */     GIR_EraseRootFromParent_Done,
     /*   52545 */   // Label 844: @52545
     /*   52545 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(52634), // Rule ID 46691 //
     /*   52550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52565 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52584 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52593 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52632 */     GIR_RootConstrainSelectedInstOperands,
     /*   52633 */     // GIR_Coverage, 46691,
     /*   52633 */     GIR_EraseRootFromParent_Done,
     /*   52634 */   // Label 845: @52634
     /*   52634 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(52723), // Rule ID 46454 //
     /*   52639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52654 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52673 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52682 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   52699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52721 */     GIR_RootConstrainSelectedInstOperands,
     /*   52722 */     // GIR_Coverage, 46454,
     /*   52722 */     GIR_EraseRootFromParent_Done,
     /*   52723 */   // Label 846: @52723
     /*   52723 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(52812), // Rule ID 46455 //
     /*   52728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52762 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52771 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   52788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52810 */     GIR_RootConstrainSelectedInstOperands,
     /*   52811 */     // GIR_Coverage, 46455,
     /*   52811 */     GIR_EraseRootFromParent_Done,
     /*   52812 */   // Label 847: @52812
     /*   52812 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(52901), // Rule ID 46570 //
     /*   52817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52851 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52860 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   52860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52899 */     GIR_RootConstrainSelectedInstOperands,
     /*   52900 */     // GIR_Coverage, 46570,
     /*   52900 */     GIR_EraseRootFromParent_Done,
     /*   52901 */   // Label 848: @52901
     /*   52901 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(52990), // Rule ID 46571 //
     /*   52906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52921 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   52932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   52940 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   52942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   52947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   52949 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   52949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   52952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   52966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   52975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   52979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52988 */     GIR_RootConstrainSelectedInstOperands,
     /*   52989 */     // GIR_Coverage, 46571,
     /*   52989 */     GIR_EraseRootFromParent_Done,
     /*   52990 */   // Label 849: @52990
     /*   52990 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(53058), // Rule ID 70706 //
     /*   52995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53032 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53056 */     GIR_RootConstrainSelectedInstOperands,
     /*   53057 */     // GIR_Coverage, 70706,
     /*   53057 */     GIR_EraseRootFromParent_Done,
     /*   53058 */   // Label 850: @53058
     /*   53058 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(53126), // Rule ID 70707 //
     /*   53063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53100 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53124 */     GIR_RootConstrainSelectedInstOperands,
     /*   53125 */     // GIR_Coverage, 70707,
     /*   53125 */     GIR_EraseRootFromParent_Done,
     /*   53126 */   // Label 851: @53126
     /*   53126 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(53181), // Rule ID 69626 //
     /*   53131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53159 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53179 */     GIR_RootConstrainSelectedInstOperands,
     /*   53180 */     // GIR_Coverage, 69626,
     /*   53180 */     GIR_EraseRootFromParent_Done,
     /*   53181 */   // Label 852: @53181
     /*   53181 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(53236), // Rule ID 69627 //
     /*   53186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53214 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53234 */     GIR_RootConstrainSelectedInstOperands,
     /*   53235 */     // GIR_Coverage, 69627,
     /*   53235 */     GIR_EraseRootFromParent_Done,
     /*   53236 */   // Label 853: @53236
     /*   53236 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(53291), // Rule ID 69446 //
     /*   53241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53269 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53289 */     GIR_RootConstrainSelectedInstOperands,
     /*   53290 */     // GIR_Coverage, 69446,
     /*   53290 */     GIR_EraseRootFromParent_Done,
     /*   53291 */   // Label 854: @53291
     /*   53291 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(53346), // Rule ID 69447 //
     /*   53296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53324 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53344 */     GIR_RootConstrainSelectedInstOperands,
     /*   53345 */     // GIR_Coverage, 69447,
     /*   53345 */     GIR_EraseRootFromParent_Done,
     /*   53346 */   // Label 855: @53346
     /*   53346 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53401), // Rule ID 69536 //
     /*   53351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53379 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53399 */     GIR_RootConstrainSelectedInstOperands,
     /*   53400 */     // GIR_Coverage, 69536,
     /*   53400 */     GIR_EraseRootFromParent_Done,
     /*   53401 */   // Label 856: @53401
     /*   53401 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(53456), // Rule ID 69537 //
     /*   53406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53434 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53454 */     GIR_RootConstrainSelectedInstOperands,
     /*   53455 */     // GIR_Coverage, 69537,
     /*   53455 */     GIR_EraseRootFromParent_Done,
     /*   53456 */   // Label 857: @53456
     /*   53456 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(53524), // Rule ID 51912 //
     /*   53461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53498 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   53498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53522 */     GIR_RootConstrainSelectedInstOperands,
     /*   53523 */     // GIR_Coverage, 51912,
     /*   53523 */     GIR_EraseRootFromParent_Done,
     /*   53524 */   // Label 858: @53524
     /*   53524 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53592), // Rule ID 51913 //
     /*   53529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   53548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   53552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53566 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   53566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53590 */     GIR_RootConstrainSelectedInstOperands,
     /*   53591 */     // GIR_Coverage, 51913,
     /*   53591 */     GIR_EraseRootFromParent_Done,
     /*   53592 */   // Label 859: @53592
     /*   53592 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53647), // Rule ID 46750 //
     /*   53597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53625 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53645 */     GIR_RootConstrainSelectedInstOperands,
     /*   53646 */     // GIR_Coverage, 46750,
     /*   53646 */     GIR_EraseRootFromParent_Done,
     /*   53647 */   // Label 860: @53647
     /*   53647 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53702), // Rule ID 46751 //
     /*   53652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   53667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53671 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53680 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53700 */     GIR_RootConstrainSelectedInstOperands,
     /*   53701 */     // GIR_Coverage, 46751,
     /*   53701 */     GIR_EraseRootFromParent_Done,
     /*   53702 */   // Label 861: @53702
     /*   53702 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53757), // Rule ID 46510 //
     /*   53707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53735 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53755 */     GIR_RootConstrainSelectedInstOperands,
     /*   53756 */     // GIR_Coverage, 46510,
     /*   53756 */     GIR_EraseRootFromParent_Done,
     /*   53757 */   // Label 862: @53757
     /*   53757 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53812), // Rule ID 46511 //
     /*   53762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53790 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   53793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53810 */     GIR_RootConstrainSelectedInstOperands,
     /*   53811 */     // GIR_Coverage, 46511,
     /*   53811 */     GIR_EraseRootFromParent_Done,
     /*   53812 */   // Label 863: @53812
     /*   53812 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53867), // Rule ID 46630 //
     /*   53817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53845 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53865 */     GIR_RootConstrainSelectedInstOperands,
     /*   53866 */     // GIR_Coverage, 46630,
     /*   53866 */     GIR_EraseRootFromParent_Done,
     /*   53867 */   // Label 864: @53867
     /*   53867 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53922), // Rule ID 46631 //
     /*   53872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   53891 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   53898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53900 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   53903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53920 */     GIR_RootConstrainSelectedInstOperands,
     /*   53921 */     // GIR_Coverage, 46631,
     /*   53921 */     GIR_EraseRootFromParent_Done,
     /*   53922 */   // Label 865: @53922
     /*   53922 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53975), // Rule ID 46144 //
     /*   53927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53938 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   53938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   53955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   53970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53973 */     GIR_RootConstrainSelectedInstOperands,
     /*   53974 */     // GIR_Coverage, 46144,
     /*   53974 */     GIR_EraseRootFromParent_Done,
     /*   53975 */   // Label 866: @53975
     /*   53975 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(54028), // Rule ID 46145 //
     /*   53980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53991 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   53991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   53994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   54003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   54005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   54008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   54013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   54015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   54017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54026 */     GIR_RootConstrainSelectedInstOperands,
     /*   54027 */     // GIR_Coverage, 46145,
     /*   54027 */     GIR_EraseRootFromParent_Done,
     /*   54028 */   // Label 867: @54028
     /*   54028 */   GIM_Reject,
     /*   54029 */ // Label 827: @54029
     /*   54029 */ GIM_Reject,
     /*   54030 */ // Label 146: @54030
     /*   54030 */ GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(57154),
     /*   54035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54045 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(54141), // Rule ID 70832 //
     /*   54050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54083 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54102 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54104 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54115 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54139 */     GIR_RootConstrainSelectedInstOperands,
     /*   54140 */     // GIR_Coverage, 70832,
     /*   54140 */     GIR_EraseRootFromParent_Done,
     /*   54141 */   // Label 869: @54141
     /*   54141 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(54237), // Rule ID 70833 //
     /*   54146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54179 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54198 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54200 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54211 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54235 */     GIR_RootConstrainSelectedInstOperands,
     /*   54236 */     // GIR_Coverage, 70833,
     /*   54236 */     GIR_EraseRootFromParent_Done,
     /*   54237 */   // Label 870: @54237
     /*   54237 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54333), // Rule ID 71108 //
     /*   54242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54294 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54296 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54307 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54331 */     GIR_RootConstrainSelectedInstOperands,
     /*   54332 */     // GIR_Coverage, 71108,
     /*   54332 */     GIR_EraseRootFromParent_Done,
     /*   54333 */   // Label 871: @54333
     /*   54333 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54429), // Rule ID 71109 //
     /*   54338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54357 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54371 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54386 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54390 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54392 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54403 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54427 */     GIR_RootConstrainSelectedInstOperands,
     /*   54428 */     // GIR_Coverage, 71109,
     /*   54428 */     GIR_EraseRootFromParent_Done,
     /*   54429 */   // Label 872: @54429
     /*   54429 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54525), // Rule ID 71110 //
     /*   54434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54453 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54467 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54482 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54486 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54488 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54499 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54523 */     GIR_RootConstrainSelectedInstOperands,
     /*   54524 */     // GIR_Coverage, 71110,
     /*   54524 */     GIR_EraseRootFromParent_Done,
     /*   54525 */   // Label 873: @54525
     /*   54525 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54621), // Rule ID 71111 //
     /*   54530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54549 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54578 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54582 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54584 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54595 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54619 */     GIR_RootConstrainSelectedInstOperands,
     /*   54620 */     // GIR_Coverage, 71111,
     /*   54620 */     GIR_EraseRootFromParent_Done,
     /*   54621 */   // Label 874: @54621
     /*   54621 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54717), // Rule ID 70946 //
     /*   54626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54645 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54659 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54678 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54680 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54691 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54715 */     GIR_RootConstrainSelectedInstOperands,
     /*   54716 */     // GIR_Coverage, 70946,
     /*   54716 */     GIR_EraseRootFromParent_Done,
     /*   54717 */   // Label 875: @54717
     /*   54717 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54813), // Rule ID 70947 //
     /*   54722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54741 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54755 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54762 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54766 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54770 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54774 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54776 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54787 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54811 */     GIR_RootConstrainSelectedInstOperands,
     /*   54812 */     // GIR_Coverage, 70947,
     /*   54812 */     GIR_EraseRootFromParent_Done,
     /*   54813 */   // Label 876: @54813
     /*   54813 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(54909), // Rule ID 52050 //
     /*   54818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54874 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54876 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54883 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   54883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   54904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54907 */     GIR_RootConstrainSelectedInstOperands,
     /*   54908 */     // GIR_Coverage, 52050,
     /*   54908 */     GIR_EraseRootFromParent_Done,
     /*   54909 */   // Label 877: @54909
     /*   54909 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(55005), // Rule ID 52051 //
     /*   54914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   54933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   54937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   54970 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54979 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   54979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55003 */     GIR_RootConstrainSelectedInstOperands,
     /*   55004 */     // GIR_Coverage, 52051,
     /*   55004 */     GIR_EraseRootFromParent_Done,
     /*   55005 */   // Label 878: @55005
     /*   55005 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(55101), // Rule ID 52168 //
     /*   55010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55033 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55047 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55066 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55068 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55075 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55099 */     GIR_RootConstrainSelectedInstOperands,
     /*   55100 */     // GIR_Coverage, 52168,
     /*   55100 */     GIR_EraseRootFromParent_Done,
     /*   55101 */   // Label 879: @55101
     /*   55101 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55197), // Rule ID 52169 //
     /*   55106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55143 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55162 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55164 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55169 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55171 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55195 */     GIR_RootConstrainSelectedInstOperands,
     /*   55196 */     // GIR_Coverage, 52169,
     /*   55196 */     GIR_EraseRootFromParent_Done,
     /*   55197 */   // Label 880: @55197
     /*   55197 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55293), // Rule ID 71106 //
     /*   55202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55239 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55258 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55260 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55265 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55267 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55291 */     GIR_RootConstrainSelectedInstOperands,
     /*   55292 */     // GIR_Coverage, 71106,
     /*   55292 */     GIR_EraseRootFromParent_Done,
     /*   55293 */   // Label 881: @55293
     /*   55293 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55389), // Rule ID 71107 //
     /*   55298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55321 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55335 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55354 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55356 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55361 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55363 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   55366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   55374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   55378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55387 */     GIR_RootConstrainSelectedInstOperands,
     /*   55388 */     // GIR_Coverage, 71107,
     /*   55388 */     GIR_EraseRootFromParent_Done,
     /*   55389 */   // Label 882: @55389
     /*   55389 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55485), // Rule ID 52108 //
     /*   55394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55417 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55431 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55450 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55452 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55457 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55459 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55483 */     GIR_RootConstrainSelectedInstOperands,
     /*   55484 */     // GIR_Coverage, 52108,
     /*   55484 */     GIR_EraseRootFromParent_Done,
     /*   55485 */   // Label 883: @55485
     /*   55485 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55581), // Rule ID 52109 //
     /*   55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   55501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   55509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   55513 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   55519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55527 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   55538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55546 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   55548 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   55555 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   55558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   55562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   55570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55579 */     GIR_RootConstrainSelectedInstOperands,
     /*   55580 */     // GIR_Coverage, 52109,
     /*   55580 */     GIR_EraseRootFromParent_Done,
     /*   55581 */   // Label 884: @55581
     /*   55581 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55670), // Rule ID 46714 //
     /*   55586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55620 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55629 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55668 */     GIR_RootConstrainSelectedInstOperands,
     /*   55669 */     // GIR_Coverage, 46714,
     /*   55669 */     GIR_EraseRootFromParent_Done,
     /*   55670 */   // Label 885: @55670
     /*   55670 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55759), // Rule ID 46715 //
     /*   55675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55690 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55709 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55718 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   55718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55757 */     GIR_RootConstrainSelectedInstOperands,
     /*   55758 */     // GIR_Coverage, 46715,
     /*   55758 */     GIR_EraseRootFromParent_Done,
     /*   55759 */   // Label 886: @55759
     /*   55759 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55848), // Rule ID 46478 //
     /*   55764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55798 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55807 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55846 */     GIR_RootConstrainSelectedInstOperands,
     /*   55847 */     // GIR_Coverage, 46478,
     /*   55847 */     GIR_EraseRootFromParent_Done,
     /*   55848 */   // Label 887: @55848
     /*   55848 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55937), // Rule ID 46479 //
     /*   55853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55868 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55887 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55896 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   55896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55935 */     GIR_RootConstrainSelectedInstOperands,
     /*   55936 */     // GIR_Coverage, 46479,
     /*   55936 */     GIR_EraseRootFromParent_Done,
     /*   55937 */   // Label 888: @55937
     /*   55937 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(56026), // Rule ID 46594 //
     /*   55942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55957 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   55976 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55985 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   55985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   55988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56024 */     GIR_RootConstrainSelectedInstOperands,
     /*   56025 */     // GIR_Coverage, 46594,
     /*   56025 */     GIR_EraseRootFromParent_Done,
     /*   56026 */   // Label 889: @56026
     /*   56026 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(56115), // Rule ID 46595 //
     /*   56031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56046 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   56057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56065 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   56067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   56074 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   56077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   56091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   56100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   56104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56113 */     GIR_RootConstrainSelectedInstOperands,
     /*   56114 */     // GIR_Coverage, 46595,
     /*   56114 */     GIR_EraseRootFromParent_Done,
     /*   56115 */   // Label 890: @56115
     /*   56115 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(56183), // Rule ID 70738 //
     /*   56120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56139 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56157 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56181 */     GIR_RootConstrainSelectedInstOperands,
     /*   56182 */     // GIR_Coverage, 70738,
     /*   56182 */     GIR_EraseRootFromParent_Done,
     /*   56183 */   // Label 891: @56183
     /*   56183 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(56251), // Rule ID 70739 //
     /*   56188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56207 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56225 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56249 */     GIR_RootConstrainSelectedInstOperands,
     /*   56250 */     // GIR_Coverage, 70739,
     /*   56250 */     GIR_EraseRootFromParent_Done,
     /*   56251 */   // Label 892: @56251
     /*   56251 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56306), // Rule ID 69650 //
     /*   56256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56271 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56284 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56304 */     GIR_RootConstrainSelectedInstOperands,
     /*   56305 */     // GIR_Coverage, 69650,
     /*   56305 */     GIR_EraseRootFromParent_Done,
     /*   56306 */   // Label 893: @56306
     /*   56306 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56361), // Rule ID 69651 //
     /*   56311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56339 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56359 */     GIR_RootConstrainSelectedInstOperands,
     /*   56360 */     // GIR_Coverage, 69651,
     /*   56360 */     GIR_EraseRootFromParent_Done,
     /*   56361 */   // Label 894: @56361
     /*   56361 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56416), // Rule ID 69470 //
     /*   56366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56394 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56414 */     GIR_RootConstrainSelectedInstOperands,
     /*   56415 */     // GIR_Coverage, 69470,
     /*   56415 */     GIR_EraseRootFromParent_Done,
     /*   56416 */   // Label 895: @56416
     /*   56416 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56471), // Rule ID 69471 //
     /*   56421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56449 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56469 */     GIR_RootConstrainSelectedInstOperands,
     /*   56470 */     // GIR_Coverage, 69471,
     /*   56470 */     GIR_EraseRootFromParent_Done,
     /*   56471 */   // Label 896: @56471
     /*   56471 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56526), // Rule ID 69560 //
     /*   56476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56504 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56524 */     GIR_RootConstrainSelectedInstOperands,
     /*   56525 */     // GIR_Coverage, 69560,
     /*   56525 */     GIR_EraseRootFromParent_Done,
     /*   56526 */   // Label 897: @56526
     /*   56526 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56581), // Rule ID 69561 //
     /*   56531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56559 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56579 */     GIR_RootConstrainSelectedInstOperands,
     /*   56580 */     // GIR_Coverage, 69561,
     /*   56580 */     GIR_EraseRootFromParent_Done,
     /*   56581 */   // Label 898: @56581
     /*   56581 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56649), // Rule ID 51928 //
     /*   56586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56609 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56623 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   56623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56647 */     GIR_RootConstrainSelectedInstOperands,
     /*   56648 */     // GIR_Coverage, 51928,
     /*   56648 */     GIR_EraseRootFromParent_Done,
     /*   56649 */   // Label 899: @56649
     /*   56649 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56717), // Rule ID 51929 //
     /*   56654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   56673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   56677 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56691 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   56691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   56712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56715 */     GIR_RootConstrainSelectedInstOperands,
     /*   56716 */     // GIR_Coverage, 51929,
     /*   56716 */     GIR_EraseRootFromParent_Done,
     /*   56717 */   // Label 900: @56717
     /*   56717 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56772), // Rule ID 46774 //
     /*   56722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56741 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56750 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56770 */     GIR_RootConstrainSelectedInstOperands,
     /*   56771 */     // GIR_Coverage, 46774,
     /*   56771 */     GIR_EraseRootFromParent_Done,
     /*   56772 */   // Label 901: @56772
     /*   56772 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56827), // Rule ID 46775 //
     /*   56777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56805 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56825 */     GIR_RootConstrainSelectedInstOperands,
     /*   56826 */     // GIR_Coverage, 46775,
     /*   56826 */     GIR_EraseRootFromParent_Done,
     /*   56827 */   // Label 902: @56827
     /*   56827 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56882), // Rule ID 46534 //
     /*   56832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56851 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56860 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56880 */     GIR_RootConstrainSelectedInstOperands,
     /*   56881 */     // GIR_Coverage, 46534,
     /*   56881 */     GIR_EraseRootFromParent_Done,
     /*   56882 */   // Label 903: @56882
     /*   56882 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(56937), // Rule ID 46535 //
     /*   56887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56915 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56935 */     GIR_RootConstrainSelectedInstOperands,
     /*   56936 */     // GIR_Coverage, 46535,
     /*   56936 */     GIR_EraseRootFromParent_Done,
     /*   56937 */   // Label 904: @56937
     /*   56937 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(56992), // Rule ID 46654 //
     /*   56942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   56961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56970 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56990 */     GIR_RootConstrainSelectedInstOperands,
     /*   56991 */     // GIR_Coverage, 46654,
     /*   56991 */     GIR_EraseRootFromParent_Done,
     /*   56992 */   // Label 905: @56992
     /*   56992 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(57047), // Rule ID 46655 //
     /*   56997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   57016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57025 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   57025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   57028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   57042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57045 */     GIR_RootConstrainSelectedInstOperands,
     /*   57046 */     // GIR_Coverage, 46655,
     /*   57046 */     GIR_EraseRootFromParent_Done,
     /*   57047 */   // Label 906: @57047
     /*   57047 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(57100), // Rule ID 46160 //
     /*   57052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57063 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   57063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57098 */     GIR_RootConstrainSelectedInstOperands,
     /*   57099 */     // GIR_Coverage, 46160,
     /*   57099 */     GIR_EraseRootFromParent_Done,
     /*   57100 */   // Label 907: @57100
     /*   57100 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(57153), // Rule ID 46161 //
     /*   57105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57116 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   57116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   57119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   57133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   57148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57151 */     GIR_RootConstrainSelectedInstOperands,
     /*   57152 */     // GIR_Coverage, 46161,
     /*   57152 */     GIR_EraseRootFromParent_Done,
     /*   57153 */   // Label 908: @57153
     /*   57153 */   GIM_Reject,
     /*   57154 */ // Label 868: @57154
     /*   57154 */ GIM_Reject,
     /*   57155 */ // Label 147: @57155
     /*   57155 */ GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(57549),
     /*   57160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57170 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(57238), // Rule ID 70682 //
     /*   57175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57212 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57236 */     GIR_RootConstrainSelectedInstOperands,
     /*   57237 */     // GIR_Coverage, 70682,
     /*   57237 */     GIR_EraseRootFromParent_Done,
     /*   57238 */   // Label 910: @57238
     /*   57238 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57306), // Rule ID 70683 //
     /*   57243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57280 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57304 */     GIR_RootConstrainSelectedInstOperands,
     /*   57305 */     // GIR_Coverage, 70683,
     /*   57305 */     GIR_EraseRootFromParent_Done,
     /*   57306 */   // Label 911: @57306
     /*   57306 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57374), // Rule ID 51900 //
     /*   57311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57334 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57348 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57372 */     GIR_RootConstrainSelectedInstOperands,
     /*   57373 */     // GIR_Coverage, 51900,
     /*   57373 */     GIR_EraseRootFromParent_Done,
     /*   57374 */   // Label 912: @57374
     /*   57374 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57442), // Rule ID 51901 //
     /*   57379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   57402 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57416 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   57419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57440 */     GIR_RootConstrainSelectedInstOperands,
     /*   57441 */     // GIR_Coverage, 51901,
     /*   57441 */     GIR_EraseRootFromParent_Done,
     /*   57442 */   // Label 913: @57442
     /*   57442 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57495), // Rule ID 46132 //
     /*   57447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57458 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   57458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57493 */     GIR_RootConstrainSelectedInstOperands,
     /*   57494 */     // GIR_Coverage, 46132,
     /*   57494 */     GIR_EraseRootFromParent_Done,
     /*   57495 */   // Label 914: @57495
     /*   57495 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(57548), // Rule ID 46133 //
     /*   57500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57511 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   57511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   57514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   57528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57546 */     GIR_RootConstrainSelectedInstOperands,
     /*   57547 */     // GIR_Coverage, 46133,
     /*   57547 */     GIR_EraseRootFromParent_Done,
     /*   57548 */   // Label 915: @57548
     /*   57548 */   GIM_Reject,
     /*   57549 */ // Label 909: @57549
     /*   57549 */ GIM_Reject,
     /*   57550 */ // Label 148: @57550
     /*   57550 */ GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(60674),
     /*   57555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57565 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57661), // Rule ID 70822 //
     /*   57570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57603 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57622 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57624 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57635 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   57638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57659 */     GIR_RootConstrainSelectedInstOperands,
     /*   57660 */     // GIR_Coverage, 70822,
     /*   57660 */     GIR_EraseRootFromParent_Done,
     /*   57661 */   // Label 917: @57661
     /*   57661 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57757), // Rule ID 70823 //
     /*   57666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57699 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57718 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57720 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57729 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57731 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   57734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57755 */     GIR_RootConstrainSelectedInstOperands,
     /*   57756 */     // GIR_Coverage, 70823,
     /*   57756 */     GIR_EraseRootFromParent_Done,
     /*   57757 */   // Label 918: @57757
     /*   57757 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57853), // Rule ID 71078 //
     /*   57762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57814 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57816 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57825 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57827 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   57830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57851 */     GIR_RootConstrainSelectedInstOperands,
     /*   57852 */     // GIR_Coverage, 71078,
     /*   57852 */     GIR_EraseRootFromParent_Done,
     /*   57853 */   // Label 919: @57853
     /*   57853 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57949), // Rule ID 71079 //
     /*   57858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   57887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57891 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57910 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   57912 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   57921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   57923 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   57926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   57930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   57938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57947 */     GIR_RootConstrainSelectedInstOperands,
     /*   57948 */     // GIR_Coverage, 71079,
     /*   57948 */     GIR_EraseRootFromParent_Done,
     /*   57949 */   // Label 920: @57949
     /*   57949 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(58045), // Rule ID 71080 //
     /*   57954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   57969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   57973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   57979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   57983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   57987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   57994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   57998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58006 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58008 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58019 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58043 */     GIR_RootConstrainSelectedInstOperands,
     /*   58044 */     // GIR_Coverage, 71080,
     /*   58044 */     GIR_EraseRootFromParent_Done,
     /*   58045 */   // Label 921: @58045
     /*   58045 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(58141), // Rule ID 71081 //
     /*   58050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58069 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58083 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58102 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58104 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58113 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58115 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58139 */     GIR_RootConstrainSelectedInstOperands,
     /*   58140 */     // GIR_Coverage, 71081,
     /*   58140 */     GIR_EraseRootFromParent_Done,
     /*   58141 */   // Label 922: @58141
     /*   58141 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(58237), // Rule ID 70936 //
     /*   58146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58179 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58198 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58200 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58209 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58211 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58235 */     GIR_RootConstrainSelectedInstOperands,
     /*   58236 */     // GIR_Coverage, 70936,
     /*   58236 */     GIR_EraseRootFromParent_Done,
     /*   58237 */   // Label 923: @58237
     /*   58237 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(58333), // Rule ID 70937 //
     /*   58242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58294 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58296 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58307 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   58314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58331 */     GIR_RootConstrainSelectedInstOperands,
     /*   58332 */     // GIR_Coverage, 70937,
     /*   58332 */     GIR_EraseRootFromParent_Done,
     /*   58333 */   // Label 924: @58333
     /*   58333 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(58429), // Rule ID 52040 //
     /*   58338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58371 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58375 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58377 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58390 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58394 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58396 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58403 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58427 */     GIR_RootConstrainSelectedInstOperands,
     /*   58428 */     // GIR_Coverage, 52040,
     /*   58428 */     GIR_EraseRootFromParent_Done,
     /*   58429 */   // Label 925: @58429
     /*   58429 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(58525), // Rule ID 52041 //
     /*   58434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58457 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58471 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58490 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58492 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58499 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   58502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58523 */     GIR_RootConstrainSelectedInstOperands,
     /*   58524 */     // GIR_Coverage, 52041,
     /*   58524 */     GIR_EraseRootFromParent_Done,
     /*   58525 */   // Label 926: @58525
     /*   58525 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(58621), // Rule ID 52158 //
     /*   58530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58567 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58582 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58586 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58588 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58593 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58595 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58619 */     GIR_RootConstrainSelectedInstOperands,
     /*   58620 */     // GIR_Coverage, 52158,
     /*   58620 */     GIR_EraseRootFromParent_Done,
     /*   58621 */   // Label 927: @58621
     /*   58621 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(58717), // Rule ID 52159 //
     /*   58626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58649 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58663 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58682 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58684 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58691 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58715 */     GIR_RootConstrainSelectedInstOperands,
     /*   58716 */     // GIR_Coverage, 52159,
     /*   58716 */     GIR_EraseRootFromParent_Done,
     /*   58717 */   // Label 928: @58717
     /*   58717 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(58813), // Rule ID 71076 //
     /*   58722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58745 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58774 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58778 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58780 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58787 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58811 */     GIR_RootConstrainSelectedInstOperands,
     /*   58812 */     // GIR_Coverage, 71076,
     /*   58812 */     GIR_EraseRootFromParent_Done,
     /*   58813 */   // Label 929: @58813
     /*   58813 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(58909), // Rule ID 71077 //
     /*   58818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58874 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58876 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58881 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58883 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   58886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   58894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   58898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58907 */     GIR_RootConstrainSelectedInstOperands,
     /*   58908 */     // GIR_Coverage, 71077,
     /*   58908 */     GIR_EraseRootFromParent_Done,
     /*   58909 */   // Label 930: @58909
     /*   58909 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(59005), // Rule ID 52098 //
     /*   58914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   58921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   58933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   58937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   58943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   58962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   58970 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   58972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   58977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   58979 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   58982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   58986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   58994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59003 */     GIR_RootConstrainSelectedInstOperands,
     /*   59004 */     // GIR_Coverage, 52098,
     /*   59004 */     GIR_EraseRootFromParent_Done,
     /*   59005 */   // Label 931: @59005
     /*   59005 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(59101), // Rule ID 52099 //
     /*   59010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59033 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   59039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59047 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   59058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59066 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   59068 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59073 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   59075 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   59078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   59082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   59090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59099 */     GIR_RootConstrainSelectedInstOperands,
     /*   59100 */     // GIR_Coverage, 52099,
     /*   59100 */     GIR_EraseRootFromParent_Done,
     /*   59101 */   // Label 932: @59101
     /*   59101 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(59190), // Rule ID 46694 //
     /*   59106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59149 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59188 */     GIR_RootConstrainSelectedInstOperands,
     /*   59189 */     // GIR_Coverage, 46694,
     /*   59189 */     GIR_EraseRootFromParent_Done,
     /*   59190 */   // Label 933: @59190
     /*   59190 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(59279), // Rule ID 46695 //
     /*   59195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59238 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59277 */     GIR_RootConstrainSelectedInstOperands,
     /*   59278 */     // GIR_Coverage, 46695,
     /*   59278 */     GIR_EraseRootFromParent_Done,
     /*   59279 */   // Label 934: @59279
     /*   59279 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(59368), // Rule ID 46458 //
     /*   59284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59318 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59327 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59366 */     GIR_RootConstrainSelectedInstOperands,
     /*   59367 */     // GIR_Coverage, 46458,
     /*   59367 */     GIR_EraseRootFromParent_Done,
     /*   59368 */   // Label 935: @59368
     /*   59368 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(59457), // Rule ID 46459 //
     /*   59373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59407 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59416 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   59433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59455 */     GIR_RootConstrainSelectedInstOperands,
     /*   59456 */     // GIR_Coverage, 46459,
     /*   59456 */     GIR_EraseRootFromParent_Done,
     /*   59457 */   // Label 936: @59457
     /*   59457 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(59546), // Rule ID 46574 //
     /*   59462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59496 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59505 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   59505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59544 */     GIR_RootConstrainSelectedInstOperands,
     /*   59545 */     // GIR_Coverage, 46574,
     /*   59545 */     GIR_EraseRootFromParent_Done,
     /*   59546 */   // Label 937: @59546
     /*   59546 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(59635), // Rule ID 46575 //
     /*   59551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59566 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59585 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59594 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   59594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   59597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   59611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59633 */     GIR_RootConstrainSelectedInstOperands,
     /*   59634 */     // GIR_Coverage, 46575,
     /*   59634 */     GIR_EraseRootFromParent_Done,
     /*   59635 */   // Label 938: @59635
     /*   59635 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(59703), // Rule ID 70714 //
     /*   59640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59659 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59677 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   59677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   59680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59701 */     GIR_RootConstrainSelectedInstOperands,
     /*   59702 */     // GIR_Coverage, 70714,
     /*   59702 */     GIR_EraseRootFromParent_Done,
     /*   59703 */   // Label 939: @59703
     /*   59703 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(59771), // Rule ID 70715 //
     /*   59708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   59723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   59727 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59745 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   59745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   59748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59769 */     GIR_RootConstrainSelectedInstOperands,
     /*   59770 */     // GIR_Coverage, 70715,
     /*   59770 */     GIR_EraseRootFromParent_Done,
     /*   59771 */   // Label 940: @59771
     /*   59771 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(59826), // Rule ID 69630 //
     /*   59776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59804 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   59807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59824 */     GIR_RootConstrainSelectedInstOperands,
     /*   59825 */     // GIR_Coverage, 69630,
     /*   59825 */     GIR_EraseRootFromParent_Done,
     /*   59826 */   // Label 941: @59826
     /*   59826 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(59881), // Rule ID 69631 //
     /*   59831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59859 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   59862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59879 */     GIR_RootConstrainSelectedInstOperands,
     /*   59880 */     // GIR_Coverage, 69631,
     /*   59880 */     GIR_EraseRootFromParent_Done,
     /*   59881 */   // Label 942: @59881
     /*   59881 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(59936), // Rule ID 69450 //
     /*   59886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59914 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   59914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   59917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59934 */     GIR_RootConstrainSelectedInstOperands,
     /*   59935 */     // GIR_Coverage, 69450,
     /*   59935 */     GIR_EraseRootFromParent_Done,
     /*   59936 */   // Label 943: @59936
     /*   59936 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(59991), // Rule ID 69451 //
     /*   59941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   59956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   59963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   59967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59969 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   59969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   59972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   59976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59989 */     GIR_RootConstrainSelectedInstOperands,
     /*   59990 */     // GIR_Coverage, 69451,
     /*   59990 */     GIR_EraseRootFromParent_Done,
     /*   59991 */   // Label 944: @59991
     /*   59991 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(60046), // Rule ID 69540 //
     /*   59996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60024 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60044 */     GIR_RootConstrainSelectedInstOperands,
     /*   60045 */     // GIR_Coverage, 69540,
     /*   60045 */     GIR_EraseRootFromParent_Done,
     /*   60046 */   // Label 945: @60046
     /*   60046 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(60101), // Rule ID 69541 //
     /*   60051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60079 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60099 */     GIR_RootConstrainSelectedInstOperands,
     /*   60100 */     // GIR_Coverage, 69541,
     /*   60100 */     GIR_EraseRootFromParent_Done,
     /*   60101 */   // Label 946: @60101
     /*   60101 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(60169), // Rule ID 51916 //
     /*   60106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60143 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   60143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60167 */     GIR_RootConstrainSelectedInstOperands,
     /*   60168 */     // GIR_Coverage, 51916,
     /*   60168 */     GIR_EraseRootFromParent_Done,
     /*   60169 */   // Label 947: @60169
     /*   60169 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(60237), // Rule ID 51917 //
     /*   60174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   60193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   60197 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60211 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   60211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60235 */     GIR_RootConstrainSelectedInstOperands,
     /*   60236 */     // GIR_Coverage, 51917,
     /*   60236 */     GIR_EraseRootFromParent_Done,
     /*   60237 */   // Label 948: @60237
     /*   60237 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(60292), // Rule ID 46754 //
     /*   60242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60270 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60290 */     GIR_RootConstrainSelectedInstOperands,
     /*   60291 */     // GIR_Coverage, 46754,
     /*   60291 */     GIR_EraseRootFromParent_Done,
     /*   60292 */   // Label 949: @60292
     /*   60292 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(60347), // Rule ID 46755 //
     /*   60297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60325 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60345 */     GIR_RootConstrainSelectedInstOperands,
     /*   60346 */     // GIR_Coverage, 46755,
     /*   60346 */     GIR_EraseRootFromParent_Done,
     /*   60347 */   // Label 950: @60347
     /*   60347 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(60402), // Rule ID 46514 //
     /*   60352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60380 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60400 */     GIR_RootConstrainSelectedInstOperands,
     /*   60401 */     // GIR_Coverage, 46514,
     /*   60401 */     GIR_EraseRootFromParent_Done,
     /*   60402 */   // Label 951: @60402
     /*   60402 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(60457), // Rule ID 46515 //
     /*   60407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60435 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   60438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60455 */     GIR_RootConstrainSelectedInstOperands,
     /*   60456 */     // GIR_Coverage, 46515,
     /*   60456 */     GIR_EraseRootFromParent_Done,
     /*   60457 */   // Label 952: @60457
     /*   60457 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(60512), // Rule ID 46634 //
     /*   60462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60490 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60510 */     GIR_RootConstrainSelectedInstOperands,
     /*   60511 */     // GIR_Coverage, 46634,
     /*   60511 */     GIR_EraseRootFromParent_Done,
     /*   60512 */   // Label 953: @60512
     /*   60512 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(60567), // Rule ID 46635 //
     /*   60517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   60536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   60543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60545 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   60548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60565 */     GIR_RootConstrainSelectedInstOperands,
     /*   60566 */     // GIR_Coverage, 46635,
     /*   60566 */     GIR_EraseRootFromParent_Done,
     /*   60567 */   // Label 954: @60567
     /*   60567 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(60620), // Rule ID 46148 //
     /*   60572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60583 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   60583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60618 */     GIR_RootConstrainSelectedInstOperands,
     /*   60619 */     // GIR_Coverage, 46148,
     /*   60619 */     GIR_EraseRootFromParent_Done,
     /*   60620 */   // Label 955: @60620
     /*   60620 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(60673), // Rule ID 46149 //
     /*   60625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60636 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   60636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   60639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   60668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60671 */     GIR_RootConstrainSelectedInstOperands,
     /*   60672 */     // GIR_Coverage, 46149,
     /*   60672 */     GIR_EraseRootFromParent_Done,
     /*   60673 */   // Label 956: @60673
     /*   60673 */   GIM_Reject,
     /*   60674 */ // Label 916: @60674
     /*   60674 */ GIM_Reject,
     /*   60675 */ // Label 149: @60675
     /*   60675 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(61069),
     /*   60680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60690 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(60758), // Rule ID 70690 //
     /*   60695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60732 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60756 */     GIR_RootConstrainSelectedInstOperands,
     /*   60757 */     // GIR_Coverage, 70690,
     /*   60757 */     GIR_EraseRootFromParent_Done,
     /*   60758 */   // Label 958: @60758
     /*   60758 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(60826), // Rule ID 70691 //
     /*   60763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60782 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60800 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60824 */     GIR_RootConstrainSelectedInstOperands,
     /*   60825 */     // GIR_Coverage, 70691,
     /*   60825 */     GIR_EraseRootFromParent_Done,
     /*   60826 */   // Label 959: @60826
     /*   60826 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(60894), // Rule ID 51904 //
     /*   60831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60868 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   60868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60892 */     GIR_RootConstrainSelectedInstOperands,
     /*   60893 */     // GIR_Coverage, 51904,
     /*   60893 */     GIR_EraseRootFromParent_Done,
     /*   60894 */   // Label 960: @60894
     /*   60894 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(60962), // Rule ID 51905 //
     /*   60899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   60918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   60922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60936 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   60936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   60939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60960 */     GIR_RootConstrainSelectedInstOperands,
     /*   60961 */     // GIR_Coverage, 51905,
     /*   60961 */     GIR_EraseRootFromParent_Done,
     /*   60962 */   // Label 961: @60962
     /*   60962 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(61015), // Rule ID 46136 //
     /*   60967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   60978 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   60978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   60981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   60995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61013 */     GIR_RootConstrainSelectedInstOperands,
     /*   61014 */     // GIR_Coverage, 46136,
     /*   61014 */     GIR_EraseRootFromParent_Done,
     /*   61015 */   // Label 962: @61015
     /*   61015 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(61068), // Rule ID 46137 //
     /*   61020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   61031 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   61034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   61048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61066 */     GIR_RootConstrainSelectedInstOperands,
     /*   61067 */     // GIR_Coverage, 46137,
     /*   61067 */     GIR_EraseRootFromParent_Done,
     /*   61068 */   // Label 963: @61068
     /*   61068 */   GIM_Reject,
     /*   61069 */ // Label 957: @61069
     /*   61069 */ GIM_Reject,
     /*   61070 */ // Label 150: @61070
     /*   61070 */ GIM_Reject,
     /*   61071 */ // Label 1: @61071
     /*   61071 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 988*/ GIMT_Encode4(80303),
     /*   61082 */ /*GILLT_s32*//*Label 964*/ GIMT_Encode4(61206),
     /*   61086 */ /*GILLT_s64*//*Label 965*/ GIMT_Encode4(61453), GIMT_Encode4(0),
     /*   61094 */ /*GILLT_nxv1s8*//*Label 966*/ GIMT_Encode4(61729),
     /*   61098 */ /*GILLT_nxv1s16*//*Label 967*/ GIMT_Encode4(61976),
     /*   61102 */ /*GILLT_nxv1s32*//*Label 968*/ GIMT_Encode4(63099),
     /*   61106 */ /*GILLT_nxv1s64*//*Label 969*/ GIMT_Encode4(64222), GIMT_Encode4(0),
     /*   61114 */ /*GILLT_nxv2s8*//*Label 970*/ GIMT_Encode4(65345),
     /*   61118 */ /*GILLT_nxv2s16*//*Label 971*/ GIMT_Encode4(65592),
     /*   61122 */ /*GILLT_nxv2s32*//*Label 972*/ GIMT_Encode4(66715),
     /*   61126 */ /*GILLT_nxv2s64*//*Label 973*/ GIMT_Encode4(67838), GIMT_Encode4(0),
     /*   61134 */ /*GILLT_nxv4s8*//*Label 974*/ GIMT_Encode4(68961),
     /*   61138 */ /*GILLT_nxv4s16*//*Label 975*/ GIMT_Encode4(69208),
     /*   61142 */ /*GILLT_nxv4s32*//*Label 976*/ GIMT_Encode4(70331),
     /*   61146 */ /*GILLT_nxv4s64*//*Label 977*/ GIMT_Encode4(71454), GIMT_Encode4(0),
     /*   61154 */ /*GILLT_nxv8s8*//*Label 978*/ GIMT_Encode4(72577),
     /*   61158 */ /*GILLT_nxv8s16*//*Label 979*/ GIMT_Encode4(72824),
     /*   61162 */ /*GILLT_nxv8s32*//*Label 980*/ GIMT_Encode4(73947),
     /*   61166 */ /*GILLT_nxv8s64*//*Label 981*/ GIMT_Encode4(75070), GIMT_Encode4(0),
     /*   61174 */ /*GILLT_nxv16s8*//*Label 982*/ GIMT_Encode4(76193),
     /*   61178 */ /*GILLT_nxv16s16*//*Label 983*/ GIMT_Encode4(76440),
     /*   61182 */ /*GILLT_nxv16s32*//*Label 984*/ GIMT_Encode4(77563), GIMT_Encode4(0),
     /*   61190 */ /*GILLT_nxv32s8*//*Label 985*/ GIMT_Encode4(78686),
     /*   61194 */ /*GILLT_nxv32s16*//*Label 986*/ GIMT_Encode4(78933), GIMT_Encode4(0),
     /*   61202 */ /*GILLT_nxv64s8*//*Label 987*/ GIMT_Encode4(80056),
     /*   61206 */ // Label 964: @61206
     /*   61206 */ GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(61452),
     /*   61211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   61214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   61217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61221 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(61296), // Rule ID 104 //
     /*   61226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*   61229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61249 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61256 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61262 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i64] }), 31:{ *:[i64] })
     /*   61262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61278 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61294 */     GIR_RootConstrainSelectedInstOperands,
     /*   61295 */     // GIR_Coverage, 104,
     /*   61295 */     GIR_EraseRootFromParent_Done,
     /*   61296 */   // Label 990: @61296
     /*   61296 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(61371), // Rule ID 105 //
     /*   61301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*   61304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61331 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61337 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i32] }), 31:{ *:[i32] })
     /*   61337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   61340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61353 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   61356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   61369 */     GIR_RootConstrainSelectedInstOperands,
     /*   61370 */     // GIR_Coverage, 105,
     /*   61370 */     GIR_EraseRootFromParent_Done,
     /*   61371 */   // Label 991: @61371
     /*   61371 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(61428), // Rule ID 62595 //
     /*   61376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*   61379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   61395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   61399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61411 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULS:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61426 */     GIR_RootConstrainSelectedInstOperands,
     /*   61427 */     // GIR_Coverage, 62595,
     /*   61427 */     GIR_EraseRootFromParent_Done,
     /*   61428 */   // Label 992: @61428
     /*   61428 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(61451), // Rule ID 83 //
     /*   61433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   61436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61444 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   61444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61449 */     GIR_RootConstrainSelectedInstOperands,
     /*   61450 */     // GIR_Coverage, 83,
     /*   61450 */     GIR_Done,
     /*   61451 */   // Label 993: @61451
     /*   61451 */   GIM_Reject,
     /*   61452 */ // Label 989: @61452
     /*   61452 */ GIM_Reject,
     /*   61453 */ // Label 965: @61453
     /*   61453 */ GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(61728),
     /*   61458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   61461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   61464 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(61543), // Rule ID 106 //
     /*   61469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   61480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   61488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   61507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61509 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 1:{ *:[i64] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, 63:{ *:[i64] }), 63:{ *:[i64] })
     /*   61509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   61512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   61516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   61525 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*   61528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   61533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /*   61541 */     GIR_RootConstrainSelectedInstOperands,
     /*   61542 */     // GIR_Coverage, 106,
     /*   61542 */     GIR_EraseRootFromParent_Done,
     /*   61543 */   // Label 995: @61543
     /*   61543 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61608), // Rule ID 62597 //
     /*   61548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   61551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61585 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10029),
     /*   61589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61591 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10029>>  =>  (TH_MULSW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULSW),
     /*   61594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61606 */     GIR_RootConstrainSelectedInstOperands,
     /*   61607 */     // GIR_Coverage, 62597,
     /*   61607 */     GIR_EraseRootFromParent_Done,
     /*   61608 */   // Label 996: @61608
     /*   61608 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61669), // Rule ID 62594 //
     /*   61613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   61616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   61636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   61640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61652 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULS:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   61655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   61657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   61659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   61667 */     GIR_RootConstrainSelectedInstOperands,
     /*   61668 */     // GIR_Coverage, 62594,
     /*   61668 */     GIR_EraseRootFromParent_Done,
     /*   61669 */   // Label 997: @61669
     /*   61669 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61700), // Rule ID 273 //
     /*   61674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   61677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61689 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10029),
     /*   61693 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10029>>  =>  (SUBW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUBW),
     /*   61698 */     GIR_RootConstrainSelectedInstOperands,
     /*   61699 */     // GIR_Coverage, 273,
     /*   61699 */     GIR_Done,
     /*   61700 */   // Label 998: @61700
     /*   61700 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61727), // Rule ID 82 //
     /*   61705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   61708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   61720 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (SUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   61720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   61725 */     GIR_RootConstrainSelectedInstOperands,
     /*   61726 */     // GIR_Coverage, 82,
     /*   61726 */     GIR_Done,
     /*   61727 */   // Label 999: @61727
     /*   61727 */   GIM_Reject,
     /*   61728 */ // Label 994: @61728
     /*   61728 */ GIM_Reject,
     /*   61729 */ // Label 966: @61729
     /*   61729 */ GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(61975),
     /*   61734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61748 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(61812), // Rule ID 51944 //
     /*   61753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61772 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61786 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   61786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   61789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61810 */     GIR_RootConstrainSelectedInstOperands,
     /*   61811 */     // GIR_Coverage, 51944,
     /*   61811 */     GIR_EraseRootFromParent_Done,
     /*   61812 */   // Label 1001: @61812
     /*   61812 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61876), // Rule ID 51945 //
     /*   61817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   61832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   61836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61850 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   61853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61874 */     GIR_RootConstrainSelectedInstOperands,
     /*   61875 */     // GIR_Coverage, 51945,
     /*   61875 */     GIR_EraseRootFromParent_Done,
     /*   61876 */   // Label 1002: @61876
     /*   61876 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(61925), // Rule ID 46218 //
     /*   61881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61888 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   61891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   61905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61923 */     GIR_RootConstrainSelectedInstOperands,
     /*   61924 */     // GIR_Coverage, 46218,
     /*   61924 */     GIR_EraseRootFromParent_Done,
     /*   61925 */   // Label 1003: @61925
     /*   61925 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61974), // Rule ID 46219 //
     /*   61930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61937 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   61940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   61954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61972 */     GIR_RootConstrainSelectedInstOperands,
     /*   61973 */     // GIR_Coverage, 46219,
     /*   61973 */     GIR_EraseRootFromParent_Done,
     /*   61974 */   // Label 1004: @61974
     /*   61974 */   GIM_Reject,
     /*   61975 */ // Label 1000: @61975
     /*   61975 */ GIM_Reject,
     /*   61976 */ // Label 967: @61976
     /*   61976 */ GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(63098),
     /*   61981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   61984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   61987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61991 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(62080), // Rule ID 47214 //
     /*   61996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62030 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62039 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62078 */     GIR_RootConstrainSelectedInstOperands,
     /*   62079 */     // GIR_Coverage, 47214,
     /*   62079 */     GIR_EraseRootFromParent_Done,
     /*   62080 */   // Label 1006: @62080
     /*   62080 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(62169), // Rule ID 47215 //
     /*   62085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62119 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62128 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62167 */     GIR_RootConstrainSelectedInstOperands,
     /*   62168 */     // GIR_Coverage, 47215,
     /*   62168 */     GIR_EraseRootFromParent_Done,
     /*   62169 */   // Label 1007: @62169
     /*   62169 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(62258), // Rule ID 46974 //
     /*   62174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62189 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62208 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62217 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62256 */     GIR_RootConstrainSelectedInstOperands,
     /*   62257 */     // GIR_Coverage, 46974,
     /*   62257 */     GIR_EraseRootFromParent_Done,
     /*   62258 */   // Label 1008: @62258
     /*   62258 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(62347), // Rule ID 46975 //
     /*   62263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62278 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62297 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62306 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   62323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62345 */     GIR_RootConstrainSelectedInstOperands,
     /*   62346 */     // GIR_Coverage, 46975,
     /*   62346 */     GIR_EraseRootFromParent_Done,
     /*   62347 */   // Label 1009: @62347
     /*   62347 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(62436), // Rule ID 47094 //
     /*   62352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62386 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62395 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   62395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62434 */     GIR_RootConstrainSelectedInstOperands,
     /*   62435 */     // GIR_Coverage, 47094,
     /*   62435 */     GIR_EraseRootFromParent_Done,
     /*   62436 */   // Label 1010: @62436
     /*   62436 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(62525), // Rule ID 47095 //
     /*   62441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62456 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62475 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62484 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   62484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   62487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   62501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62523 */     GIR_RootConstrainSelectedInstOperands,
     /*   62524 */     // GIR_Coverage, 47095,
     /*   62524 */     GIR_EraseRootFromParent_Done,
     /*   62525 */   // Label 1011: @62525
     /*   62525 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(62593), // Rule ID 51956 //
     /*   62530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62567 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   62567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   62570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62591 */     GIR_RootConstrainSelectedInstOperands,
     /*   62592 */     // GIR_Coverage, 51956,
     /*   62592 */     GIR_EraseRootFromParent_Done,
     /*   62593 */   // Label 1012: @62593
     /*   62593 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(62661), // Rule ID 51957 //
     /*   62598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   62617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   62621 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62635 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   62635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   62638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62659 */     GIR_RootConstrainSelectedInstOperands,
     /*   62660 */     // GIR_Coverage, 51957,
     /*   62660 */     GIR_EraseRootFromParent_Done,
     /*   62661 */   // Label 1013: @62661
     /*   62661 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(62716), // Rule ID 47274 //
     /*   62666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62694 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62714 */     GIR_RootConstrainSelectedInstOperands,
     /*   62715 */     // GIR_Coverage, 47274,
     /*   62715 */     GIR_EraseRootFromParent_Done,
     /*   62716 */   // Label 1014: @62716
     /*   62716 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(62771), // Rule ID 47275 //
     /*   62721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62740 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62749 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62769 */     GIR_RootConstrainSelectedInstOperands,
     /*   62770 */     // GIR_Coverage, 47275,
     /*   62770 */     GIR_EraseRootFromParent_Done,
     /*   62771 */   // Label 1015: @62771
     /*   62771 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(62826), // Rule ID 47034 //
     /*   62776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62795 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62804 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   62807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62824 */     GIR_RootConstrainSelectedInstOperands,
     /*   62825 */     // GIR_Coverage, 47034,
     /*   62825 */     GIR_EraseRootFromParent_Done,
     /*   62826 */   // Label 1016: @62826
     /*   62826 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62881), // Rule ID 47035 //
     /*   62831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62850 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62859 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   62862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62879 */     GIR_RootConstrainSelectedInstOperands,
     /*   62880 */     // GIR_Coverage, 47035,
     /*   62880 */     GIR_EraseRootFromParent_Done,
     /*   62881 */   // Label 1017: @62881
     /*   62881 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(62936), // Rule ID 47154 //
     /*   62886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62905 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62914 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62934 */     GIR_RootConstrainSelectedInstOperands,
     /*   62935 */     // GIR_Coverage, 47154,
     /*   62935 */     GIR_EraseRootFromParent_Done,
     /*   62936 */   // Label 1018: @62936
     /*   62936 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(62991), // Rule ID 47155 //
     /*   62941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   62960 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62969 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   62972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62989 */     GIR_RootConstrainSelectedInstOperands,
     /*   62990 */     // GIR_Coverage, 47155,
     /*   62990 */     GIR_EraseRootFromParent_Done,
     /*   62991 */   // Label 1019: @62991
     /*   62991 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(63044), // Rule ID 46230 //
     /*   62996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63007 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63042 */     GIR_RootConstrainSelectedInstOperands,
     /*   63043 */     // GIR_Coverage, 46230,
     /*   63043 */     GIR_EraseRootFromParent_Done,
     /*   63044 */   // Label 1020: @63044
     /*   63044 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(63097), // Rule ID 46231 //
     /*   63049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63060 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   63063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   63077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63095 */     GIR_RootConstrainSelectedInstOperands,
     /*   63096 */     // GIR_Coverage, 46231,
     /*   63096 */     GIR_EraseRootFromParent_Done,
     /*   63097 */   // Label 1021: @63097
     /*   63097 */   GIM_Reject,
     /*   63098 */ // Label 1005: @63098
     /*   63098 */ GIM_Reject,
     /*   63099 */ // Label 968: @63099
     /*   63099 */ GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(64221),
     /*   63104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63114 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(63203), // Rule ID 47238 //
     /*   63119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63162 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63201 */     GIR_RootConstrainSelectedInstOperands,
     /*   63202 */     // GIR_Coverage, 47238,
     /*   63202 */     GIR_EraseRootFromParent_Done,
     /*   63203 */   // Label 1023: @63203
     /*   63203 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(63292), // Rule ID 47239 //
     /*   63208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63251 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63290 */     GIR_RootConstrainSelectedInstOperands,
     /*   63291 */     // GIR_Coverage, 47239,
     /*   63291 */     GIR_EraseRootFromParent_Done,
     /*   63292 */   // Label 1024: @63292
     /*   63292 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(63381), // Rule ID 46998 //
     /*   63297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63340 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63379 */     GIR_RootConstrainSelectedInstOperands,
     /*   63380 */     // GIR_Coverage, 46998,
     /*   63380 */     GIR_EraseRootFromParent_Done,
     /*   63381 */   // Label 1025: @63381
     /*   63381 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(63470), // Rule ID 46999 //
     /*   63386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63429 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   63446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63468 */     GIR_RootConstrainSelectedInstOperands,
     /*   63469 */     // GIR_Coverage, 46999,
     /*   63469 */     GIR_EraseRootFromParent_Done,
     /*   63470 */   // Label 1026: @63470
     /*   63470 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(63559), // Rule ID 47118 //
     /*   63475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63490 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63509 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63518 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63557 */     GIR_RootConstrainSelectedInstOperands,
     /*   63558 */     // GIR_Coverage, 47118,
     /*   63558 */     GIR_EraseRootFromParent_Done,
     /*   63559 */   // Label 1027: @63559
     /*   63559 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(63648), // Rule ID 47119 //
     /*   63564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63607 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   63610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   63624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63646 */     GIR_RootConstrainSelectedInstOperands,
     /*   63647 */     // GIR_Coverage, 47119,
     /*   63647 */     GIR_EraseRootFromParent_Done,
     /*   63648 */   // Label 1028: @63648
     /*   63648 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(63716), // Rule ID 51964 //
     /*   63653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63690 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   63690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   63693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63714 */     GIR_RootConstrainSelectedInstOperands,
     /*   63715 */     // GIR_Coverage, 51964,
     /*   63715 */     GIR_EraseRootFromParent_Done,
     /*   63716 */   // Label 1029: @63716
     /*   63716 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(63784), // Rule ID 51965 //
     /*   63721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   63740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   63744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63758 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   63758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   63761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63782 */     GIR_RootConstrainSelectedInstOperands,
     /*   63783 */     // GIR_Coverage, 51965,
     /*   63783 */     GIR_EraseRootFromParent_Done,
     /*   63784 */   // Label 1030: @63784
     /*   63784 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(63839), // Rule ID 47298 //
     /*   63789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63817 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   63820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63837 */     GIR_RootConstrainSelectedInstOperands,
     /*   63838 */     // GIR_Coverage, 47298,
     /*   63838 */     GIR_EraseRootFromParent_Done,
     /*   63839 */   // Label 1031: @63839
     /*   63839 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(63894), // Rule ID 47299 //
     /*   63844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63872 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   63875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63892 */     GIR_RootConstrainSelectedInstOperands,
     /*   63893 */     // GIR_Coverage, 47299,
     /*   63893 */     GIR_EraseRootFromParent_Done,
     /*   63894 */   // Label 1032: @63894
     /*   63894 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(63949), // Rule ID 47058 //
     /*   63899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63927 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   63930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63947 */     GIR_RootConstrainSelectedInstOperands,
     /*   63948 */     // GIR_Coverage, 47058,
     /*   63948 */     GIR_EraseRootFromParent_Done,
     /*   63949 */   // Label 1033: @63949
     /*   63949 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(64004), // Rule ID 47059 //
     /*   63954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   63973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63982 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   63985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64002 */     GIR_RootConstrainSelectedInstOperands,
     /*   64003 */     // GIR_Coverage, 47059,
     /*   64003 */     GIR_EraseRootFromParent_Done,
     /*   64004 */   // Label 1034: @64004
     /*   64004 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(64059), // Rule ID 47178 //
     /*   64009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64037 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   64037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64057 */     GIR_RootConstrainSelectedInstOperands,
     /*   64058 */     // GIR_Coverage, 47178,
     /*   64058 */     GIR_EraseRootFromParent_Done,
     /*   64059 */   // Label 1035: @64059
     /*   64059 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(64114), // Rule ID 47179 //
     /*   64064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   64083 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64092 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   64092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   64095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   64109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64112 */     GIR_RootConstrainSelectedInstOperands,
     /*   64113 */     // GIR_Coverage, 47179,
     /*   64113 */     GIR_EraseRootFromParent_Done,
     /*   64114 */   // Label 1036: @64114
     /*   64114 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(64167), // Rule ID 46238 //
     /*   64119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64130 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64165 */     GIR_RootConstrainSelectedInstOperands,
     /*   64166 */     // GIR_Coverage, 46238,
     /*   64166 */     GIR_EraseRootFromParent_Done,
     /*   64167 */   // Label 1037: @64167
     /*   64167 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(64220), // Rule ID 46239 //
     /*   64172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64183 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   64186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   64200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64218 */     GIR_RootConstrainSelectedInstOperands,
     /*   64219 */     // GIR_Coverage, 46239,
     /*   64219 */     GIR_EraseRootFromParent_Done,
     /*   64220 */   // Label 1038: @64220
     /*   64220 */   GIM_Reject,
     /*   64221 */ // Label 1022: @64221
     /*   64221 */ GIM_Reject,
     /*   64222 */ // Label 969: @64222
     /*   64222 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(65344),
     /*   64227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64237 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(64326), // Rule ID 47258 //
     /*   64242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64257 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64276 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64285 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64324 */     GIR_RootConstrainSelectedInstOperands,
     /*   64325 */     // GIR_Coverage, 47258,
     /*   64325 */     GIR_EraseRootFromParent_Done,
     /*   64326 */   // Label 1040: @64326
     /*   64326 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(64415), // Rule ID 47259 //
     /*   64331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64346 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64365 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64374 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64413 */     GIR_RootConstrainSelectedInstOperands,
     /*   64414 */     // GIR_Coverage, 47259,
     /*   64414 */     GIR_EraseRootFromParent_Done,
     /*   64415 */   // Label 1041: @64415
     /*   64415 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(64504), // Rule ID 47018 //
     /*   64420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64435 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64454 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64461 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64463 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64502 */     GIR_RootConstrainSelectedInstOperands,
     /*   64503 */     // GIR_Coverage, 47018,
     /*   64503 */     GIR_EraseRootFromParent_Done,
     /*   64504 */   // Label 1042: @64504
     /*   64504 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(64593), // Rule ID 47019 //
     /*   64509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64524 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64543 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64552 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   64569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64591 */     GIR_RootConstrainSelectedInstOperands,
     /*   64592 */     // GIR_Coverage, 47019,
     /*   64592 */     GIR_EraseRootFromParent_Done,
     /*   64593 */   // Label 1043: @64593
     /*   64593 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(64682), // Rule ID 47138 //
     /*   64598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64613 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64632 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64641 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64680 */     GIR_RootConstrainSelectedInstOperands,
     /*   64681 */     // GIR_Coverage, 47138,
     /*   64681 */     GIR_EraseRootFromParent_Done,
     /*   64682 */   // Label 1044: @64682
     /*   64682 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(64771), // Rule ID 47139 //
     /*   64687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64702 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64721 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64730 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   64733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   64747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64769 */     GIR_RootConstrainSelectedInstOperands,
     /*   64770 */     // GIR_Coverage, 47139,
     /*   64770 */     GIR_EraseRootFromParent_Done,
     /*   64771 */   // Label 1045: @64771
     /*   64771 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(64839), // Rule ID 51980 //
     /*   64776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   64779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64799 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64813 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   64813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   64816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64837 */     GIR_RootConstrainSelectedInstOperands,
     /*   64838 */     // GIR_Coverage, 51980,
     /*   64838 */     GIR_EraseRootFromParent_Done,
     /*   64839 */   // Label 1046: @64839
     /*   64839 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(64907), // Rule ID 51981 //
     /*   64844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   64847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   64863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   64867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64881 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   64881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   64884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64905 */     GIR_RootConstrainSelectedInstOperands,
     /*   64906 */     // GIR_Coverage, 51981,
     /*   64906 */     GIR_EraseRootFromParent_Done,
     /*   64907 */   // Label 1047: @64907
     /*   64907 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(64962), // Rule ID 47318 //
     /*   64912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64940 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   64940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   64943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64960 */     GIR_RootConstrainSelectedInstOperands,
     /*   64961 */     // GIR_Coverage, 47318,
     /*   64961 */     GIR_EraseRootFromParent_Done,
     /*   64962 */   // Label 1048: @64962
     /*   64962 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(65017), // Rule ID 47319 //
     /*   64967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   64986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64995 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   64995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   64998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65015 */     GIR_RootConstrainSelectedInstOperands,
     /*   65016 */     // GIR_Coverage, 47319,
     /*   65016 */     GIR_EraseRootFromParent_Done,
     /*   65017 */   // Label 1049: @65017
     /*   65017 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(65072), // Rule ID 47078 //
     /*   65022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65041 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65050 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65070 */     GIR_RootConstrainSelectedInstOperands,
     /*   65071 */     // GIR_Coverage, 47078,
     /*   65071 */     GIR_EraseRootFromParent_Done,
     /*   65072 */   // Label 1050: @65072
     /*   65072 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(65127), // Rule ID 47079 //
     /*   65077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65105 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65125 */     GIR_RootConstrainSelectedInstOperands,
     /*   65126 */     // GIR_Coverage, 47079,
     /*   65126 */     GIR_EraseRootFromParent_Done,
     /*   65127 */   // Label 1051: @65127
     /*   65127 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(65182), // Rule ID 47198 //
     /*   65132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   65135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65160 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   65160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65180 */     GIR_RootConstrainSelectedInstOperands,
     /*   65181 */     // GIR_Coverage, 47198,
     /*   65181 */     GIR_EraseRootFromParent_Done,
     /*   65182 */   // Label 1052: @65182
     /*   65182 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(65237), // Rule ID 47199 //
     /*   65187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   65190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   65206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65215 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   65215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   65232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65235 */     GIR_RootConstrainSelectedInstOperands,
     /*   65236 */     // GIR_Coverage, 47199,
     /*   65236 */     GIR_EraseRootFromParent_Done,
     /*   65237 */   // Label 1053: @65237
     /*   65237 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(65290), // Rule ID 46254 //
     /*   65242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   65245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65253 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   65253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65288 */     GIR_RootConstrainSelectedInstOperands,
     /*   65289 */     // GIR_Coverage, 46254,
     /*   65289 */     GIR_EraseRootFromParent_Done,
     /*   65290 */   // Label 1054: @65290
     /*   65290 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(65343), // Rule ID 46255 //
     /*   65295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   65298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65306 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   65306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   65309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   65323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   65338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65341 */     GIR_RootConstrainSelectedInstOperands,
     /*   65342 */     // GIR_Coverage, 46255,
     /*   65342 */     GIR_EraseRootFromParent_Done,
     /*   65343 */   // Label 1055: @65343
     /*   65343 */   GIM_Reject,
     /*   65344 */ // Label 1039: @65344
     /*   65344 */ GIM_Reject,
     /*   65345 */ // Label 970: @65345
     /*   65345 */ GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(65591),
     /*   65350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65364 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(65428), // Rule ID 51948 //
     /*   65369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65402 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   65402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65426 */     GIR_RootConstrainSelectedInstOperands,
     /*   65427 */     // GIR_Coverage, 51948,
     /*   65427 */     GIR_EraseRootFromParent_Done,
     /*   65428 */   // Label 1057: @65428
     /*   65428 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(65492), // Rule ID 51949 //
     /*   65433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   65452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65466 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   65466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   65469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65490 */     GIR_RootConstrainSelectedInstOperands,
     /*   65491 */     // GIR_Coverage, 51949,
     /*   65491 */     GIR_EraseRootFromParent_Done,
     /*   65492 */   // Label 1058: @65492
     /*   65492 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(65541), // Rule ID 46222 //
     /*   65497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65504 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65539 */     GIR_RootConstrainSelectedInstOperands,
     /*   65540 */     // GIR_Coverage, 46222,
     /*   65540 */     GIR_EraseRootFromParent_Done,
     /*   65541 */   // Label 1059: @65541
     /*   65541 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(65590), // Rule ID 46223 //
     /*   65546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65553 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   65556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   65570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65588 */     GIR_RootConstrainSelectedInstOperands,
     /*   65589 */     // GIR_Coverage, 46223,
     /*   65589 */     GIR_EraseRootFromParent_Done,
     /*   65590 */   // Label 1060: @65590
     /*   65590 */   GIM_Reject,
     /*   65591 */ // Label 1056: @65591
     /*   65591 */ GIM_Reject,
     /*   65592 */ // Label 971: @65592
     /*   65592 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(66714),
     /*   65597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   65600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   65603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65607 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(65696), // Rule ID 47218 //
     /*   65612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65627 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65646 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65655 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   65672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65694 */     GIR_RootConstrainSelectedInstOperands,
     /*   65695 */     // GIR_Coverage, 47218,
     /*   65695 */     GIR_EraseRootFromParent_Done,
     /*   65696 */   // Label 1062: @65696
     /*   65696 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(65785), // Rule ID 47219 //
     /*   65701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65735 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65744 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   65761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65783 */     GIR_RootConstrainSelectedInstOperands,
     /*   65784 */     // GIR_Coverage, 47219,
     /*   65784 */     GIR_EraseRootFromParent_Done,
     /*   65785 */   // Label 1063: @65785
     /*   65785 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(65874), // Rule ID 46978 //
     /*   65790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65805 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65824 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65826 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65833 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   65850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65872 */     GIR_RootConstrainSelectedInstOperands,
     /*   65873 */     // GIR_Coverage, 46978,
     /*   65873 */     GIR_EraseRootFromParent_Done,
     /*   65874 */   // Label 1064: @65874
     /*   65874 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(65963), // Rule ID 46979 //
     /*   65879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65894 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65913 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65922 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   65925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   65939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65961 */     GIR_RootConstrainSelectedInstOperands,
     /*   65962 */     // GIR_Coverage, 46979,
     /*   65962 */     GIR_EraseRootFromParent_Done,
     /*   65963 */   // Label 1065: @65963
     /*   65963 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(66052), // Rule ID 47098 //
     /*   65968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   65983 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66002 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66011 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   66011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66050 */     GIR_RootConstrainSelectedInstOperands,
     /*   66051 */     // GIR_Coverage, 47098,
     /*   66051 */     GIR_EraseRootFromParent_Done,
     /*   66052 */   // Label 1066: @66052
     /*   66052 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(66141), // Rule ID 47099 //
     /*   66057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66072 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66091 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66100 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   66100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   66117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66139 */     GIR_RootConstrainSelectedInstOperands,
     /*   66140 */     // GIR_Coverage, 47099,
     /*   66140 */     GIR_EraseRootFromParent_Done,
     /*   66141 */   // Label 1067: @66141
     /*   66141 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(66209), // Rule ID 51960 //
     /*   66146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66169 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66183 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   66183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66207 */     GIR_RootConstrainSelectedInstOperands,
     /*   66208 */     // GIR_Coverage, 51960,
     /*   66208 */     GIR_EraseRootFromParent_Done,
     /*   66209 */   // Label 1068: @66209
     /*   66209 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(66277), // Rule ID 51961 //
     /*   66214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   66237 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66251 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   66251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   66254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66275 */     GIR_RootConstrainSelectedInstOperands,
     /*   66276 */     // GIR_Coverage, 51961,
     /*   66276 */     GIR_EraseRootFromParent_Done,
     /*   66277 */   // Label 1069: @66277
     /*   66277 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(66332), // Rule ID 47278 //
     /*   66282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66310 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66330 */     GIR_RootConstrainSelectedInstOperands,
     /*   66331 */     // GIR_Coverage, 47278,
     /*   66331 */     GIR_EraseRootFromParent_Done,
     /*   66332 */   // Label 1070: @66332
     /*   66332 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(66387), // Rule ID 47279 //
     /*   66337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66365 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66385 */     GIR_RootConstrainSelectedInstOperands,
     /*   66386 */     // GIR_Coverage, 47279,
     /*   66386 */     GIR_EraseRootFromParent_Done,
     /*   66387 */   // Label 1071: @66387
     /*   66387 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(66442), // Rule ID 47038 //
     /*   66392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66420 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66440 */     GIR_RootConstrainSelectedInstOperands,
     /*   66441 */     // GIR_Coverage, 47038,
     /*   66441 */     GIR_EraseRootFromParent_Done,
     /*   66442 */   // Label 1072: @66442
     /*   66442 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(66497), // Rule ID 47039 //
     /*   66447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66466 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66475 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   66478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66495 */     GIR_RootConstrainSelectedInstOperands,
     /*   66496 */     // GIR_Coverage, 47039,
     /*   66496 */     GIR_EraseRootFromParent_Done,
     /*   66497 */   // Label 1073: @66497
     /*   66497 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(66552), // Rule ID 47158 //
     /*   66502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66530 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66550 */     GIR_RootConstrainSelectedInstOperands,
     /*   66551 */     // GIR_Coverage, 47158,
     /*   66551 */     GIR_EraseRootFromParent_Done,
     /*   66552 */   // Label 1074: @66552
     /*   66552 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(66607), // Rule ID 47159 //
     /*   66557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   66576 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66585 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   66588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66605 */     GIR_RootConstrainSelectedInstOperands,
     /*   66606 */     // GIR_Coverage, 47159,
     /*   66606 */     GIR_EraseRootFromParent_Done,
     /*   66607 */   // Label 1075: @66607
     /*   66607 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(66660), // Rule ID 46234 //
     /*   66612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66623 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   66640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66658 */     GIR_RootConstrainSelectedInstOperands,
     /*   66659 */     // GIR_Coverage, 46234,
     /*   66659 */     GIR_EraseRootFromParent_Done,
     /*   66660 */   // Label 1076: @66660
     /*   66660 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(66713), // Rule ID 46235 //
     /*   66665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66676 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   66679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   66693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66711 */     GIR_RootConstrainSelectedInstOperands,
     /*   66712 */     // GIR_Coverage, 46235,
     /*   66712 */     GIR_EraseRootFromParent_Done,
     /*   66713 */   // Label 1077: @66713
     /*   66713 */   GIM_Reject,
     /*   66714 */ // Label 1061: @66714
     /*   66714 */ GIM_Reject,
     /*   66715 */ // Label 972: @66715
     /*   66715 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(67837),
     /*   66720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   66723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   66726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66730 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(66819), // Rule ID 47242 //
     /*   66735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66750 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66769 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66771 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66776 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66778 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   66795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66817 */     GIR_RootConstrainSelectedInstOperands,
     /*   66818 */     // GIR_Coverage, 47242,
     /*   66818 */     GIR_EraseRootFromParent_Done,
     /*   66819 */   // Label 1079: @66819
     /*   66819 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(66908), // Rule ID 47243 //
     /*   66824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66839 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66858 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66867 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   66884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66906 */     GIR_RootConstrainSelectedInstOperands,
     /*   66907 */     // GIR_Coverage, 47243,
     /*   66907 */     GIR_EraseRootFromParent_Done,
     /*   66908 */   // Label 1080: @66908
     /*   66908 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(66997), // Rule ID 47002 //
     /*   66913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   66947 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66956 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   66959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   66973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66995 */     GIR_RootConstrainSelectedInstOperands,
     /*   66996 */     // GIR_Coverage, 47002,
     /*   66996 */     GIR_EraseRootFromParent_Done,
     /*   66997 */   // Label 1081: @66997
     /*   66997 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(67086), // Rule ID 47003 //
     /*   67002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67017 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67036 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67045 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   67062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67084 */     GIR_RootConstrainSelectedInstOperands,
     /*   67085 */     // GIR_Coverage, 47003,
     /*   67085 */     GIR_EraseRootFromParent_Done,
     /*   67086 */   // Label 1082: @67086
     /*   67086 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(67175), // Rule ID 47122 //
     /*   67091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67106 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67125 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67134 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   67134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67173 */     GIR_RootConstrainSelectedInstOperands,
     /*   67174 */     // GIR_Coverage, 47122,
     /*   67174 */     GIR_EraseRootFromParent_Done,
     /*   67175 */   // Label 1083: @67175
     /*   67175 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(67264), // Rule ID 47123 //
     /*   67180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67195 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67214 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67223 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   67223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   67240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67262 */     GIR_RootConstrainSelectedInstOperands,
     /*   67263 */     // GIR_Coverage, 47123,
     /*   67263 */     GIR_EraseRootFromParent_Done,
     /*   67264 */   // Label 1084: @67264
     /*   67264 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(67332), // Rule ID 51976 //
     /*   67269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67306 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   67306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67330 */     GIR_RootConstrainSelectedInstOperands,
     /*   67331 */     // GIR_Coverage, 51976,
     /*   67331 */     GIR_EraseRootFromParent_Done,
     /*   67332 */   // Label 1085: @67332
     /*   67332 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(67400), // Rule ID 51977 //
     /*   67337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   67360 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67374 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   67374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   67377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67398 */     GIR_RootConstrainSelectedInstOperands,
     /*   67399 */     // GIR_Coverage, 51977,
     /*   67399 */     GIR_EraseRootFromParent_Done,
     /*   67400 */   // Label 1086: @67400
     /*   67400 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(67455), // Rule ID 47302 //
     /*   67405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67433 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67453 */     GIR_RootConstrainSelectedInstOperands,
     /*   67454 */     // GIR_Coverage, 47302,
     /*   67454 */     GIR_EraseRootFromParent_Done,
     /*   67455 */   // Label 1087: @67455
     /*   67455 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(67510), // Rule ID 47303 //
     /*   67460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67479 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67488 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67508 */     GIR_RootConstrainSelectedInstOperands,
     /*   67509 */     // GIR_Coverage, 47303,
     /*   67509 */     GIR_EraseRootFromParent_Done,
     /*   67510 */   // Label 1088: @67510
     /*   67510 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(67565), // Rule ID 47062 //
     /*   67515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67534 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67543 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   67546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67563 */     GIR_RootConstrainSelectedInstOperands,
     /*   67564 */     // GIR_Coverage, 47062,
     /*   67564 */     GIR_EraseRootFromParent_Done,
     /*   67565 */   // Label 1089: @67565
     /*   67565 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(67620), // Rule ID 47063 //
     /*   67570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67598 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   67601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67618 */     GIR_RootConstrainSelectedInstOperands,
     /*   67619 */     // GIR_Coverage, 47063,
     /*   67619 */     GIR_EraseRootFromParent_Done,
     /*   67620 */   // Label 1090: @67620
     /*   67620 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(67675), // Rule ID 47182 //
     /*   67625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67644 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67653 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67673 */     GIR_RootConstrainSelectedInstOperands,
     /*   67674 */     // GIR_Coverage, 47182,
     /*   67674 */     GIR_EraseRootFromParent_Done,
     /*   67675 */   // Label 1091: @67675
     /*   67675 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(67730), // Rule ID 47183 //
     /*   67680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   67699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67708 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   67711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67728 */     GIR_RootConstrainSelectedInstOperands,
     /*   67729 */     // GIR_Coverage, 47183,
     /*   67729 */     GIR_EraseRootFromParent_Done,
     /*   67730 */   // Label 1092: @67730
     /*   67730 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(67783), // Rule ID 46250 //
     /*   67735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67746 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   67763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67781 */     GIR_RootConstrainSelectedInstOperands,
     /*   67782 */     // GIR_Coverage, 46250,
     /*   67782 */     GIR_EraseRootFromParent_Done,
     /*   67783 */   // Label 1093: @67783
     /*   67783 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(67836), // Rule ID 46251 //
     /*   67788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67799 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   67802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   67816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67834 */     GIR_RootConstrainSelectedInstOperands,
     /*   67835 */     // GIR_Coverage, 46251,
     /*   67835 */     GIR_EraseRootFromParent_Done,
     /*   67836 */   // Label 1094: @67836
     /*   67836 */   GIM_Reject,
     /*   67837 */ // Label 1078: @67837
     /*   67837 */ GIM_Reject,
     /*   67838 */ // Label 973: @67838
     /*   67838 */ GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(68960),
     /*   67843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   67846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   67849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67853 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(67942), // Rule ID 47262 //
     /*   67858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   67861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67873 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67892 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67901 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   67904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   67918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67940 */     GIR_RootConstrainSelectedInstOperands,
     /*   67941 */     // GIR_Coverage, 47262,
     /*   67941 */     GIR_EraseRootFromParent_Done,
     /*   67942 */   // Label 1096: @67942
     /*   67942 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(68031), // Rule ID 47263 //
     /*   67947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   67950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67962 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   67981 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67990 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   67993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68029 */     GIR_RootConstrainSelectedInstOperands,
     /*   68030 */     // GIR_Coverage, 47263,
     /*   68030 */     GIR_EraseRootFromParent_Done,
     /*   68031 */   // Label 1097: @68031
     /*   68031 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(68120), // Rule ID 47022 //
     /*   68036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68051 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68070 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68079 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68118 */     GIR_RootConstrainSelectedInstOperands,
     /*   68119 */     // GIR_Coverage, 47022,
     /*   68119 */     GIR_EraseRootFromParent_Done,
     /*   68120 */   // Label 1098: @68120
     /*   68120 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(68209), // Rule ID 47023 //
     /*   68125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68168 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68207 */     GIR_RootConstrainSelectedInstOperands,
     /*   68208 */     // GIR_Coverage, 47023,
     /*   68208 */     GIR_EraseRootFromParent_Done,
     /*   68209 */   // Label 1099: @68209
     /*   68209 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(68298), // Rule ID 47142 //
     /*   68214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68229 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68248 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68257 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   68257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68296 */     GIR_RootConstrainSelectedInstOperands,
     /*   68297 */     // GIR_Coverage, 47142,
     /*   68297 */     GIR_EraseRootFromParent_Done,
     /*   68298 */   // Label 1100: @68298
     /*   68298 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(68387), // Rule ID 47143 //
     /*   68303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68337 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68346 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   68346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68385 */     GIR_RootConstrainSelectedInstOperands,
     /*   68386 */     // GIR_Coverage, 47143,
     /*   68386 */     GIR_EraseRootFromParent_Done,
     /*   68387 */   // Label 1101: @68387
     /*   68387 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(68455), // Rule ID 52020 //
     /*   68392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68415 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68429 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   68429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68453 */     GIR_RootConstrainSelectedInstOperands,
     /*   68454 */     // GIR_Coverage, 52020,
     /*   68454 */     GIR_EraseRootFromParent_Done,
     /*   68455 */   // Label 1102: @68455
     /*   68455 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(68523), // Rule ID 52021 //
     /*   68460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   68479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   68483 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68497 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   68497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   68500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68521 */     GIR_RootConstrainSelectedInstOperands,
     /*   68522 */     // GIR_Coverage, 52021,
     /*   68522 */     GIR_EraseRootFromParent_Done,
     /*   68523 */   // Label 1103: @68523
     /*   68523 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(68578), // Rule ID 47322 //
     /*   68528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68556 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68576 */     GIR_RootConstrainSelectedInstOperands,
     /*   68577 */     // GIR_Coverage, 47322,
     /*   68577 */     GIR_EraseRootFromParent_Done,
     /*   68578 */   // Label 1104: @68578
     /*   68578 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(68633), // Rule ID 47323 //
     /*   68583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68611 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68631 */     GIR_RootConstrainSelectedInstOperands,
     /*   68632 */     // GIR_Coverage, 47323,
     /*   68632 */     GIR_EraseRootFromParent_Done,
     /*   68633 */   // Label 1105: @68633
     /*   68633 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(68688), // Rule ID 47082 //
     /*   68638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68657 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68666 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   68669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68686 */     GIR_RootConstrainSelectedInstOperands,
     /*   68687 */     // GIR_Coverage, 47082,
     /*   68687 */     GIR_EraseRootFromParent_Done,
     /*   68688 */   // Label 1106: @68688
     /*   68688 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(68743), // Rule ID 47083 //
     /*   68693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68721 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   68724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68741 */     GIR_RootConstrainSelectedInstOperands,
     /*   68742 */     // GIR_Coverage, 47083,
     /*   68742 */     GIR_EraseRootFromParent_Done,
     /*   68743 */   // Label 1107: @68743
     /*   68743 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(68798), // Rule ID 47202 //
     /*   68748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68776 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68796 */     GIR_RootConstrainSelectedInstOperands,
     /*   68797 */     // GIR_Coverage, 47202,
     /*   68797 */     GIR_EraseRootFromParent_Done,
     /*   68798 */   // Label 1108: @68798
     /*   68798 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(68853), // Rule ID 47203 //
     /*   68803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   68822 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68831 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   68834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68851 */     GIR_RootConstrainSelectedInstOperands,
     /*   68852 */     // GIR_Coverage, 47203,
     /*   68852 */     GIR_EraseRootFromParent_Done,
     /*   68853 */   // Label 1109: @68853
     /*   68853 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(68906), // Rule ID 46294 //
     /*   68858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68869 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   68869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   68886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68904 */     GIR_RootConstrainSelectedInstOperands,
     /*   68905 */     // GIR_Coverage, 46294,
     /*   68905 */     GIR_EraseRootFromParent_Done,
     /*   68906 */   // Label 1110: @68906
     /*   68906 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(68959), // Rule ID 46295 //
     /*   68911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68922 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   68922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   68925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   68939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68957 */     GIR_RootConstrainSelectedInstOperands,
     /*   68958 */     // GIR_Coverage, 46295,
     /*   68958 */     GIR_EraseRootFromParent_Done,
     /*   68959 */   // Label 1111: @68959
     /*   68959 */   GIM_Reject,
     /*   68960 */ // Label 1095: @68960
     /*   68960 */ GIM_Reject,
     /*   68961 */ // Label 974: @68961
     /*   68961 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(69207),
     /*   68966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   68969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   68972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68980 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(69044), // Rule ID 51952 //
     /*   68985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69004 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69018 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69042 */     GIR_RootConstrainSelectedInstOperands,
     /*   69043 */     // GIR_Coverage, 51952,
     /*   69043 */     GIR_EraseRootFromParent_Done,
     /*   69044 */   // Label 1113: @69044
     /*   69044 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(69108), // Rule ID 51953 //
     /*   69049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   69068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69082 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   69085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69106 */     GIR_RootConstrainSelectedInstOperands,
     /*   69107 */     // GIR_Coverage, 51953,
     /*   69107 */     GIR_EraseRootFromParent_Done,
     /*   69108 */   // Label 1114: @69108
     /*   69108 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(69157), // Rule ID 46226 //
     /*   69113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69120 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69155 */     GIR_RootConstrainSelectedInstOperands,
     /*   69156 */     // GIR_Coverage, 46226,
     /*   69156 */     GIR_EraseRootFromParent_Done,
     /*   69157 */   // Label 1115: @69157
     /*   69157 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(69206), // Rule ID 46227 //
     /*   69162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69169 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   69172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   69186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69204 */     GIR_RootConstrainSelectedInstOperands,
     /*   69205 */     // GIR_Coverage, 46227,
     /*   69205 */     GIR_EraseRootFromParent_Done,
     /*   69206 */   // Label 1116: @69206
     /*   69206 */   GIM_Reject,
     /*   69207 */ // Label 1112: @69207
     /*   69207 */ GIM_Reject,
     /*   69208 */ // Label 975: @69208
     /*   69208 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(70330),
     /*   69213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69223 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(69312), // Rule ID 47222 //
     /*   69228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69243 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69262 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69271 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69310 */     GIR_RootConstrainSelectedInstOperands,
     /*   69311 */     // GIR_Coverage, 47222,
     /*   69311 */     GIR_EraseRootFromParent_Done,
     /*   69312 */   // Label 1118: @69312
     /*   69312 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(69401), // Rule ID 47223 //
     /*   69317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69332 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69360 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69399 */     GIR_RootConstrainSelectedInstOperands,
     /*   69400 */     // GIR_Coverage, 47223,
     /*   69400 */     GIR_EraseRootFromParent_Done,
     /*   69401 */   // Label 1119: @69401
     /*   69401 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(69490), // Rule ID 46982 //
     /*   69406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69449 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69488 */     GIR_RootConstrainSelectedInstOperands,
     /*   69489 */     // GIR_Coverage, 46982,
     /*   69489 */     GIR_EraseRootFromParent_Done,
     /*   69490 */   // Label 1120: @69490
     /*   69490 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(69579), // Rule ID 46983 //
     /*   69495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69529 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69538 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   69555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69577 */     GIR_RootConstrainSelectedInstOperands,
     /*   69578 */     // GIR_Coverage, 46983,
     /*   69578 */     GIR_EraseRootFromParent_Done,
     /*   69579 */   // Label 1121: @69579
     /*   69579 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(69668), // Rule ID 47102 //
     /*   69584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69618 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69627 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69666 */     GIR_RootConstrainSelectedInstOperands,
     /*   69667 */     // GIR_Coverage, 47102,
     /*   69667 */     GIR_EraseRootFromParent_Done,
     /*   69668 */   // Label 1122: @69668
     /*   69668 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(69757), // Rule ID 47103 //
     /*   69673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69688 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69707 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69716 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   69719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   69733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69755 */     GIR_RootConstrainSelectedInstOperands,
     /*   69756 */     // GIR_Coverage, 47103,
     /*   69756 */     GIR_EraseRootFromParent_Done,
     /*   69757 */   // Label 1123: @69757
     /*   69757 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(69825), // Rule ID 51972 //
     /*   69762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69785 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69799 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   69799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   69802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69823 */     GIR_RootConstrainSelectedInstOperands,
     /*   69824 */     // GIR_Coverage, 51972,
     /*   69824 */     GIR_EraseRootFromParent_Done,
     /*   69825 */   // Label 1124: @69825
     /*   69825 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(69893), // Rule ID 51973 //
     /*   69830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   69849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   69853 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69867 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   69867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   69870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69891 */     GIR_RootConstrainSelectedInstOperands,
     /*   69892 */     // GIR_Coverage, 51973,
     /*   69892 */     GIR_EraseRootFromParent_Done,
     /*   69893 */   // Label 1125: @69893
     /*   69893 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(69948), // Rule ID 47282 //
     /*   69898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69917 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69926 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   69929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69946 */     GIR_RootConstrainSelectedInstOperands,
     /*   69947 */     // GIR_Coverage, 47282,
     /*   69947 */     GIR_EraseRootFromParent_Done,
     /*   69948 */   // Label 1126: @69948
     /*   69948 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(70003), // Rule ID 47283 //
     /*   69953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   69972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69981 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   69984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70001 */     GIR_RootConstrainSelectedInstOperands,
     /*   70002 */     // GIR_Coverage, 47283,
     /*   70002 */     GIR_EraseRootFromParent_Done,
     /*   70003 */   // Label 1127: @70003
     /*   70003 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(70058), // Rule ID 47042 //
     /*   70008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70027 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70036 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70056 */     GIR_RootConstrainSelectedInstOperands,
     /*   70057 */     // GIR_Coverage, 47042,
     /*   70057 */     GIR_EraseRootFromParent_Done,
     /*   70058 */   // Label 1128: @70058
     /*   70058 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(70113), // Rule ID 47043 //
     /*   70063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70091 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   70094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70111 */     GIR_RootConstrainSelectedInstOperands,
     /*   70112 */     // GIR_Coverage, 47043,
     /*   70112 */     GIR_EraseRootFromParent_Done,
     /*   70113 */   // Label 1129: @70113
     /*   70113 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(70168), // Rule ID 47162 //
     /*   70118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70137 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70146 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   70146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70166 */     GIR_RootConstrainSelectedInstOperands,
     /*   70167 */     // GIR_Coverage, 47162,
     /*   70167 */     GIR_EraseRootFromParent_Done,
     /*   70168 */   // Label 1130: @70168
     /*   70168 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(70223), // Rule ID 47163 //
     /*   70173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   70192 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70201 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   70201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   70204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70221 */     GIR_RootConstrainSelectedInstOperands,
     /*   70222 */     // GIR_Coverage, 47163,
     /*   70222 */     GIR_EraseRootFromParent_Done,
     /*   70223 */   // Label 1131: @70223
     /*   70223 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(70276), // Rule ID 46246 //
     /*   70228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70239 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70274 */     GIR_RootConstrainSelectedInstOperands,
     /*   70275 */     // GIR_Coverage, 46246,
     /*   70275 */     GIR_EraseRootFromParent_Done,
     /*   70276 */   // Label 1132: @70276
     /*   70276 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(70329), // Rule ID 46247 //
     /*   70281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70292 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   70295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   70309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70327 */     GIR_RootConstrainSelectedInstOperands,
     /*   70328 */     // GIR_Coverage, 46247,
     /*   70328 */     GIR_EraseRootFromParent_Done,
     /*   70329 */   // Label 1133: @70329
     /*   70329 */   GIM_Reject,
     /*   70330 */ // Label 1117: @70330
     /*   70330 */ GIM_Reject,
     /*   70331 */ // Label 976: @70331
     /*   70331 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(71453),
     /*   70336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70346 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(70435), // Rule ID 47246 //
     /*   70351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70385 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70394 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70433 */     GIR_RootConstrainSelectedInstOperands,
     /*   70434 */     // GIR_Coverage, 47246,
     /*   70434 */     GIR_EraseRootFromParent_Done,
     /*   70435 */   // Label 1135: @70435
     /*   70435 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(70524), // Rule ID 47247 //
     /*   70440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70483 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70522 */     GIR_RootConstrainSelectedInstOperands,
     /*   70523 */     // GIR_Coverage, 47247,
     /*   70523 */     GIR_EraseRootFromParent_Done,
     /*   70524 */   // Label 1136: @70524
     /*   70524 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(70613), // Rule ID 47006 //
     /*   70529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70572 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   70589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70611 */     GIR_RootConstrainSelectedInstOperands,
     /*   70612 */     // GIR_Coverage, 47006,
     /*   70612 */     GIR_EraseRootFromParent_Done,
     /*   70613 */   // Label 1137: @70613
     /*   70613 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(70702), // Rule ID 47007 //
     /*   70618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70652 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70661 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   70678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70700 */     GIR_RootConstrainSelectedInstOperands,
     /*   70701 */     // GIR_Coverage, 47007,
     /*   70701 */     GIR_EraseRootFromParent_Done,
     /*   70702 */   // Label 1138: @70702
     /*   70702 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(70791), // Rule ID 47126 //
     /*   70707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70750 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70789 */     GIR_RootConstrainSelectedInstOperands,
     /*   70790 */     // GIR_Coverage, 47126,
     /*   70790 */     GIR_EraseRootFromParent_Done,
     /*   70791 */   // Label 1139: @70791
     /*   70791 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(70880), // Rule ID 47127 //
     /*   70796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   70830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   70837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70839 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   70842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   70856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70878 */     GIR_RootConstrainSelectedInstOperands,
     /*   70879 */     // GIR_Coverage, 47127,
     /*   70879 */     GIR_EraseRootFromParent_Done,
     /*   70880 */   // Label 1140: @70880
     /*   70880 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(70948), // Rule ID 52008 //
     /*   70885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70922 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   70922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   70925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70946 */     GIR_RootConstrainSelectedInstOperands,
     /*   70947 */     // GIR_Coverage, 52008,
     /*   70947 */     GIR_EraseRootFromParent_Done,
     /*   70948 */   // Label 1141: @70948
     /*   70948 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(71016), // Rule ID 52009 //
     /*   70953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   70972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   70976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70990 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   70990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   70993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71014 */     GIR_RootConstrainSelectedInstOperands,
     /*   71015 */     // GIR_Coverage, 52009,
     /*   71015 */     GIR_EraseRootFromParent_Done,
     /*   71016 */   // Label 1142: @71016
     /*   71016 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71071), // Rule ID 47306 //
     /*   71021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71049 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71069 */     GIR_RootConstrainSelectedInstOperands,
     /*   71070 */     // GIR_Coverage, 47306,
     /*   71070 */     GIR_EraseRootFromParent_Done,
     /*   71071 */   // Label 1143: @71071
     /*   71071 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71126), // Rule ID 47307 //
     /*   71076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71095 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71104 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71124 */     GIR_RootConstrainSelectedInstOperands,
     /*   71125 */     // GIR_Coverage, 47307,
     /*   71125 */     GIR_EraseRootFromParent_Done,
     /*   71126 */   // Label 1144: @71126
     /*   71126 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71181), // Rule ID 47066 //
     /*   71131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71159 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71179 */     GIR_RootConstrainSelectedInstOperands,
     /*   71180 */     // GIR_Coverage, 47066,
     /*   71180 */     GIR_EraseRootFromParent_Done,
     /*   71181 */   // Label 1145: @71181
     /*   71181 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71236), // Rule ID 47067 //
     /*   71186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71205 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71214 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   71217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71234 */     GIR_RootConstrainSelectedInstOperands,
     /*   71235 */     // GIR_Coverage, 47067,
     /*   71235 */     GIR_EraseRootFromParent_Done,
     /*   71236 */   // Label 1146: @71236
     /*   71236 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71291), // Rule ID 47186 //
     /*   71241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71260 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71269 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   71269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71289 */     GIR_RootConstrainSelectedInstOperands,
     /*   71290 */     // GIR_Coverage, 47186,
     /*   71290 */     GIR_EraseRootFromParent_Done,
     /*   71291 */   // Label 1147: @71291
     /*   71291 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71346), // Rule ID 47187 //
     /*   71296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   71315 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   71322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71324 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   71324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   71327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   71341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71344 */     GIR_RootConstrainSelectedInstOperands,
     /*   71345 */     // GIR_Coverage, 47187,
     /*   71345 */     GIR_EraseRootFromParent_Done,
     /*   71346 */   // Label 1148: @71346
     /*   71346 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71399), // Rule ID 46282 //
     /*   71351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   71354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71362 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71397 */     GIR_RootConstrainSelectedInstOperands,
     /*   71398 */     // GIR_Coverage, 46282,
     /*   71398 */     GIR_EraseRootFromParent_Done,
     /*   71399 */   // Label 1149: @71399
     /*   71399 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71452), // Rule ID 46283 //
     /*   71404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   71407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71415 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   71418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   71432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   71439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   71441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71450 */     GIR_RootConstrainSelectedInstOperands,
     /*   71451 */     // GIR_Coverage, 46283,
     /*   71451 */     GIR_EraseRootFromParent_Done,
     /*   71452 */   // Label 1150: @71452
     /*   71452 */   GIM_Reject,
     /*   71453 */ // Label 1134: @71453
     /*   71453 */ GIM_Reject,
     /*   71454 */ // Label 977: @71454
     /*   71454 */ GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(72576),
     /*   71459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   71462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   71465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71469 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71558), // Rule ID 47266 //
     /*   71474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71489 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71508 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71517 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71556 */     GIR_RootConstrainSelectedInstOperands,
     /*   71557 */     // GIR_Coverage, 47266,
     /*   71557 */     GIR_EraseRootFromParent_Done,
     /*   71558 */   // Label 1152: @71558
     /*   71558 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71647), // Rule ID 47267 //
     /*   71563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71578 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71597 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71606 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71645 */     GIR_RootConstrainSelectedInstOperands,
     /*   71646 */     // GIR_Coverage, 47267,
     /*   71646 */     GIR_EraseRootFromParent_Done,
     /*   71647 */   // Label 1153: @71647
     /*   71647 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(71736), // Rule ID 47026 //
     /*   71652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71667 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71686 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71695 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   71712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71734 */     GIR_RootConstrainSelectedInstOperands,
     /*   71735 */     // GIR_Coverage, 47026,
     /*   71735 */     GIR_EraseRootFromParent_Done,
     /*   71736 */   // Label 1154: @71736
     /*   71736 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(71825), // Rule ID 47027 //
     /*   71741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71756 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71771 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71775 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71784 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   71801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71823 */     GIR_RootConstrainSelectedInstOperands,
     /*   71824 */     // GIR_Coverage, 47027,
     /*   71824 */     GIR_EraseRootFromParent_Done,
     /*   71825 */   // Label 1155: @71825
     /*   71825 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71914), // Rule ID 47146 //
     /*   71830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71845 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71864 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71873 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71912 */     GIR_RootConstrainSelectedInstOperands,
     /*   71913 */     // GIR_Coverage, 47146,
     /*   71913 */     GIR_EraseRootFromParent_Done,
     /*   71914 */   // Label 1156: @71914
     /*   71914 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(72003), // Rule ID 47147 //
     /*   71919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71934 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   71953 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   71960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71962 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   71965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   71979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72001 */     GIR_RootConstrainSelectedInstOperands,
     /*   72002 */     // GIR_Coverage, 47147,
     /*   72002 */     GIR_EraseRootFromParent_Done,
     /*   72003 */   // Label 1157: @72003
     /*   72003 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72071), // Rule ID 52024 //
     /*   72008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72031 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72045 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   72045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72069 */     GIR_RootConstrainSelectedInstOperands,
     /*   72070 */     // GIR_Coverage, 52024,
     /*   72070 */     GIR_EraseRootFromParent_Done,
     /*   72071 */   // Label 1158: @72071
     /*   72071 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72139), // Rule ID 52025 //
     /*   72076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   72095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   72099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72113 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   72113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72137 */     GIR_RootConstrainSelectedInstOperands,
     /*   72138 */     // GIR_Coverage, 52025,
     /*   72138 */     GIR_EraseRootFromParent_Done,
     /*   72139 */   // Label 1159: @72139
     /*   72139 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72194), // Rule ID 47326 //
     /*   72144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72172 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72192 */     GIR_RootConstrainSelectedInstOperands,
     /*   72193 */     // GIR_Coverage, 47326,
     /*   72193 */     GIR_EraseRootFromParent_Done,
     /*   72194 */   // Label 1160: @72194
     /*   72194 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72249), // Rule ID 47327 //
     /*   72199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72227 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72247 */     GIR_RootConstrainSelectedInstOperands,
     /*   72248 */     // GIR_Coverage, 47327,
     /*   72248 */     GIR_EraseRootFromParent_Done,
     /*   72249 */   // Label 1161: @72249
     /*   72249 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72304), // Rule ID 47086 //
     /*   72254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72282 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72302 */     GIR_RootConstrainSelectedInstOperands,
     /*   72303 */     // GIR_Coverage, 47086,
     /*   72303 */     GIR_EraseRootFromParent_Done,
     /*   72304 */   // Label 1162: @72304
     /*   72304 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72359), // Rule ID 47087 //
     /*   72309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72337 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   72340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72357 */     GIR_RootConstrainSelectedInstOperands,
     /*   72358 */     // GIR_Coverage, 47087,
     /*   72358 */     GIR_EraseRootFromParent_Done,
     /*   72359 */   // Label 1163: @72359
     /*   72359 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72414), // Rule ID 47206 //
     /*   72364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   72367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72383 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72392 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   72392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72412 */     GIR_RootConstrainSelectedInstOperands,
     /*   72413 */     // GIR_Coverage, 47206,
     /*   72413 */     GIR_EraseRootFromParent_Done,
     /*   72414 */   // Label 1164: @72414
     /*   72414 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72469), // Rule ID 47207 //
     /*   72419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   72422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   72438 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72447 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   72447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   72450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   72464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72467 */     GIR_RootConstrainSelectedInstOperands,
     /*   72468 */     // GIR_Coverage, 47207,
     /*   72468 */     GIR_EraseRootFromParent_Done,
     /*   72469 */   // Label 1165: @72469
     /*   72469 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72522), // Rule ID 46298 //
     /*   72474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   72477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72485 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   72485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72520 */     GIR_RootConstrainSelectedInstOperands,
     /*   72521 */     // GIR_Coverage, 46298,
     /*   72521 */     GIR_EraseRootFromParent_Done,
     /*   72522 */   // Label 1166: @72522
     /*   72522 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72575), // Rule ID 46299 //
     /*   72527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72538 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   72538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   72541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   72555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72573 */     GIR_RootConstrainSelectedInstOperands,
     /*   72574 */     // GIR_Coverage, 46299,
     /*   72574 */     GIR_EraseRootFromParent_Done,
     /*   72575 */   // Label 1167: @72575
     /*   72575 */   GIM_Reject,
     /*   72576 */ // Label 1151: @72576
     /*   72576 */ GIM_Reject,
     /*   72577 */ // Label 978: @72577
     /*   72577 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72823),
     /*   72582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72596 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72660), // Rule ID 51968 //
     /*   72601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72634 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   72634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   72637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72658 */     GIR_RootConstrainSelectedInstOperands,
     /*   72659 */     // GIR_Coverage, 51968,
     /*   72659 */     GIR_EraseRootFromParent_Done,
     /*   72660 */   // Label 1169: @72660
     /*   72660 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72724), // Rule ID 51969 //
     /*   72665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   72684 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72698 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   72698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   72701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72722 */     GIR_RootConstrainSelectedInstOperands,
     /*   72723 */     // GIR_Coverage, 51969,
     /*   72723 */     GIR_EraseRootFromParent_Done,
     /*   72724 */   // Label 1170: @72724
     /*   72724 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72773), // Rule ID 46242 //
     /*   72729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72736 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   72739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   72753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72771 */     GIR_RootConstrainSelectedInstOperands,
     /*   72772 */     // GIR_Coverage, 46242,
     /*   72772 */     GIR_EraseRootFromParent_Done,
     /*   72773 */   // Label 1171: @72773
     /*   72773 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72822), // Rule ID 46243 //
     /*   72778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72785 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   72788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   72802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72820 */     GIR_RootConstrainSelectedInstOperands,
     /*   72821 */     // GIR_Coverage, 46243,
     /*   72821 */     GIR_EraseRootFromParent_Done,
     /*   72822 */   // Label 1172: @72822
     /*   72822 */   GIM_Reject,
     /*   72823 */ // Label 1168: @72823
     /*   72823 */ GIM_Reject,
     /*   72824 */ // Label 979: @72824
     /*   72824 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(73946),
     /*   72829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   72832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   72835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72839 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72928), // Rule ID 47226 //
     /*   72844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72859 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72887 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   72890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   72904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72926 */     GIR_RootConstrainSelectedInstOperands,
     /*   72927 */     // GIR_Coverage, 47226,
     /*   72927 */     GIR_EraseRootFromParent_Done,
     /*   72928 */   // Label 1174: @72928
     /*   72928 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(73017), // Rule ID 47227 //
     /*   72933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   72967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   72974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72976 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   72979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   72993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73015 */     GIR_RootConstrainSelectedInstOperands,
     /*   73016 */     // GIR_Coverage, 47227,
     /*   73016 */     GIR_EraseRootFromParent_Done,
     /*   73017 */   // Label 1175: @73017
     /*   73017 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(73106), // Rule ID 46986 //
     /*   73022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73037 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73065 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73104 */     GIR_RootConstrainSelectedInstOperands,
     /*   73105 */     // GIR_Coverage, 46986,
     /*   73105 */     GIR_EraseRootFromParent_Done,
     /*   73106 */   // Label 1176: @73106
     /*   73106 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(73195), // Rule ID 46987 //
     /*   73111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73154 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   73171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73193 */     GIR_RootConstrainSelectedInstOperands,
     /*   73194 */     // GIR_Coverage, 46987,
     /*   73194 */     GIR_EraseRootFromParent_Done,
     /*   73195 */   // Label 1177: @73195
     /*   73195 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(73284), // Rule ID 47106 //
     /*   73200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73234 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73243 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   73243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73282 */     GIR_RootConstrainSelectedInstOperands,
     /*   73283 */     // GIR_Coverage, 47106,
     /*   73283 */     GIR_EraseRootFromParent_Done,
     /*   73284 */   // Label 1178: @73284
     /*   73284 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(73373), // Rule ID 47107 //
     /*   73289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73323 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73332 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   73332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   73349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73371 */     GIR_RootConstrainSelectedInstOperands,
     /*   73372 */     // GIR_Coverage, 47107,
     /*   73372 */     GIR_EraseRootFromParent_Done,
     /*   73373 */   // Label 1179: @73373
     /*   73373 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(73441), // Rule ID 51996 //
     /*   73378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73415 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   73415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73439 */     GIR_RootConstrainSelectedInstOperands,
     /*   73440 */     // GIR_Coverage, 51996,
     /*   73440 */     GIR_EraseRootFromParent_Done,
     /*   73441 */   // Label 1180: @73441
     /*   73441 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73509), // Rule ID 51997 //
     /*   73446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   73461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   73469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73483 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   73483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   73486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   73492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73507 */     GIR_RootConstrainSelectedInstOperands,
     /*   73508 */     // GIR_Coverage, 51997,
     /*   73508 */     GIR_EraseRootFromParent_Done,
     /*   73509 */   // Label 1181: @73509
     /*   73509 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73564), // Rule ID 47286 //
     /*   73514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73533 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73542 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73562 */     GIR_RootConstrainSelectedInstOperands,
     /*   73563 */     // GIR_Coverage, 47286,
     /*   73563 */     GIR_EraseRootFromParent_Done,
     /*   73564 */   // Label 1182: @73564
     /*   73564 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73619), // Rule ID 47287 //
     /*   73569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73588 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73597 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73617 */     GIR_RootConstrainSelectedInstOperands,
     /*   73618 */     // GIR_Coverage, 47287,
     /*   73618 */     GIR_EraseRootFromParent_Done,
     /*   73619 */   // Label 1183: @73619
     /*   73619 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73674), // Rule ID 47046 //
     /*   73624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73652 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   73655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73672 */     GIR_RootConstrainSelectedInstOperands,
     /*   73673 */     // GIR_Coverage, 47046,
     /*   73673 */     GIR_EraseRootFromParent_Done,
     /*   73674 */   // Label 1184: @73674
     /*   73674 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73729), // Rule ID 47047 //
     /*   73679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73698 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73707 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   73710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73727 */     GIR_RootConstrainSelectedInstOperands,
     /*   73728 */     // GIR_Coverage, 47047,
     /*   73728 */     GIR_EraseRootFromParent_Done,
     /*   73729 */   // Label 1185: @73729
     /*   73729 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73784), // Rule ID 47166 //
     /*   73734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73762 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73782 */     GIR_RootConstrainSelectedInstOperands,
     /*   73783 */     // GIR_Coverage, 47166,
     /*   73783 */     GIR_EraseRootFromParent_Done,
     /*   73784 */   // Label 1186: @73784
     /*   73784 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73839), // Rule ID 47167 //
     /*   73789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   73808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   73815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73817 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   73820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73837 */     GIR_RootConstrainSelectedInstOperands,
     /*   73838 */     // GIR_Coverage, 47167,
     /*   73838 */     GIR_EraseRootFromParent_Done,
     /*   73839 */   // Label 1187: @73839
     /*   73839 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73892), // Rule ID 46270 //
     /*   73844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73855 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   73872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73890 */     GIR_RootConstrainSelectedInstOperands,
     /*   73891 */     // GIR_Coverage, 46270,
     /*   73891 */     GIR_EraseRootFromParent_Done,
     /*   73892 */   // Label 1188: @73892
     /*   73892 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73945), // Rule ID 46271 //
     /*   73897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73908 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   73911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   73925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73943 */     GIR_RootConstrainSelectedInstOperands,
     /*   73944 */     // GIR_Coverage, 46271,
     /*   73944 */     GIR_EraseRootFromParent_Done,
     /*   73945 */   // Label 1189: @73945
     /*   73945 */   GIM_Reject,
     /*   73946 */ // Label 1173: @73946
     /*   73946 */ GIM_Reject,
     /*   73947 */ // Label 980: @73947
     /*   73947 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(75069),
     /*   73952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   73955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   73958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73962 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(74051), // Rule ID 47250 //
     /*   73967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   73982 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74001 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74010 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74049 */     GIR_RootConstrainSelectedInstOperands,
     /*   74050 */     // GIR_Coverage, 47250,
     /*   74050 */     GIR_EraseRootFromParent_Done,
     /*   74051 */   // Label 1191: @74051
     /*   74051 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(74140), // Rule ID 47251 //
     /*   74056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74090 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74099 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74138 */     GIR_RootConstrainSelectedInstOperands,
     /*   74139 */     // GIR_Coverage, 47251,
     /*   74139 */     GIR_EraseRootFromParent_Done,
     /*   74140 */   // Label 1192: @74140
     /*   74140 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74229), // Rule ID 47010 //
     /*   74145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74160 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74179 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74188 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74227 */     GIR_RootConstrainSelectedInstOperands,
     /*   74228 */     // GIR_Coverage, 47010,
     /*   74228 */     GIR_EraseRootFromParent_Done,
     /*   74229 */   // Label 1193: @74229
     /*   74229 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74318), // Rule ID 47011 //
     /*   74234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74249 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74268 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74277 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   74294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74316 */     GIR_RootConstrainSelectedInstOperands,
     /*   74317 */     // GIR_Coverage, 47011,
     /*   74317 */     GIR_EraseRootFromParent_Done,
     /*   74318 */   // Label 1194: @74318
     /*   74318 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74407), // Rule ID 47130 //
     /*   74323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74357 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74366 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   74366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74405 */     GIR_RootConstrainSelectedInstOperands,
     /*   74406 */     // GIR_Coverage, 47130,
     /*   74406 */     GIR_EraseRootFromParent_Done,
     /*   74407 */   // Label 1195: @74407
     /*   74407 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74496), // Rule ID 47131 //
     /*   74412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74446 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74455 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   74455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   74472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74494 */     GIR_RootConstrainSelectedInstOperands,
     /*   74495 */     // GIR_Coverage, 47131,
     /*   74495 */     GIR_EraseRootFromParent_Done,
     /*   74496 */   // Label 1196: @74496
     /*   74496 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74564), // Rule ID 52012 //
     /*   74501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74524 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74538 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   74538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74562 */     GIR_RootConstrainSelectedInstOperands,
     /*   74563 */     // GIR_Coverage, 52012,
     /*   74563 */     GIR_EraseRootFromParent_Done,
     /*   74564 */   // Label 1197: @74564
     /*   74564 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74632), // Rule ID 52013 //
     /*   74569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   74588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   74592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74606 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   74606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74630 */     GIR_RootConstrainSelectedInstOperands,
     /*   74631 */     // GIR_Coverage, 52013,
     /*   74631 */     GIR_EraseRootFromParent_Done,
     /*   74632 */   // Label 1198: @74632
     /*   74632 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74687), // Rule ID 47310 //
     /*   74637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74665 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74685 */     GIR_RootConstrainSelectedInstOperands,
     /*   74686 */     // GIR_Coverage, 47310,
     /*   74686 */     GIR_EraseRootFromParent_Done,
     /*   74687 */   // Label 1199: @74687
     /*   74687 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74742), // Rule ID 47311 //
     /*   74692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74711 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74720 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74740 */     GIR_RootConstrainSelectedInstOperands,
     /*   74741 */     // GIR_Coverage, 47311,
     /*   74741 */     GIR_EraseRootFromParent_Done,
     /*   74742 */   // Label 1200: @74742
     /*   74742 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74797), // Rule ID 47070 //
     /*   74747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74775 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   74778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74795 */     GIR_RootConstrainSelectedInstOperands,
     /*   74796 */     // GIR_Coverage, 47070,
     /*   74796 */     GIR_EraseRootFromParent_Done,
     /*   74797 */   // Label 1201: @74797
     /*   74797 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74852), // Rule ID 47071 //
     /*   74802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74830 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   74833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74850 */     GIR_RootConstrainSelectedInstOperands,
     /*   74851 */     // GIR_Coverage, 47071,
     /*   74851 */     GIR_EraseRootFromParent_Done,
     /*   74852 */   // Label 1202: @74852
     /*   74852 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74907), // Rule ID 47190 //
     /*   74857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74876 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74885 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74905 */     GIR_RootConstrainSelectedInstOperands,
     /*   74906 */     // GIR_Coverage, 47190,
     /*   74906 */     GIR_EraseRootFromParent_Done,
     /*   74907 */   // Label 1203: @74907
     /*   74907 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74962), // Rule ID 47191 //
     /*   74912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   74931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   74938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74940 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   74943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74960 */     GIR_RootConstrainSelectedInstOperands,
     /*   74961 */     // GIR_Coverage, 47191,
     /*   74961 */     GIR_EraseRootFromParent_Done,
     /*   74962 */   // Label 1204: @74962
     /*   74962 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75015), // Rule ID 46286 //
     /*   74967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74978 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   74978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   74981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   74995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75013 */     GIR_RootConstrainSelectedInstOperands,
     /*   75014 */     // GIR_Coverage, 46286,
     /*   75014 */     GIR_EraseRootFromParent_Done,
     /*   75015 */   // Label 1205: @75015
     /*   75015 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75068), // Rule ID 46287 //
     /*   75020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75031 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   75034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   75048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75066 */     GIR_RootConstrainSelectedInstOperands,
     /*   75067 */     // GIR_Coverage, 46287,
     /*   75067 */     GIR_EraseRootFromParent_Done,
     /*   75068 */   // Label 1206: @75068
     /*   75068 */   GIM_Reject,
     /*   75069 */ // Label 1190: @75069
     /*   75069 */ GIM_Reject,
     /*   75070 */ // Label 981: @75070
     /*   75070 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(76192),
     /*   75075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75085 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75174), // Rule ID 47270 //
     /*   75090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75105 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75124 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75133 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75172 */     GIR_RootConstrainSelectedInstOperands,
     /*   75173 */     // GIR_Coverage, 47270,
     /*   75173 */     GIR_EraseRootFromParent_Done,
     /*   75174 */   // Label 1208: @75174
     /*   75174 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75263), // Rule ID 47271 //
     /*   75179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75213 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75222 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75261 */     GIR_RootConstrainSelectedInstOperands,
     /*   75262 */     // GIR_Coverage, 47271,
     /*   75262 */     GIR_EraseRootFromParent_Done,
     /*   75263 */   // Label 1209: @75263
     /*   75263 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75352), // Rule ID 47030 //
     /*   75268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75283 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75302 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75311 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75350 */     GIR_RootConstrainSelectedInstOperands,
     /*   75351 */     // GIR_Coverage, 47030,
     /*   75351 */     GIR_EraseRootFromParent_Done,
     /*   75352 */   // Label 1210: @75352
     /*   75352 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75441), // Rule ID 47031 //
     /*   75357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75372 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75391 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75400 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75439 */     GIR_RootConstrainSelectedInstOperands,
     /*   75440 */     // GIR_Coverage, 47031,
     /*   75440 */     GIR_EraseRootFromParent_Done,
     /*   75441 */   // Label 1211: @75441
     /*   75441 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75530), // Rule ID 47150 //
     /*   75446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75461 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75480 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75489 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   75489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75528 */     GIR_RootConstrainSelectedInstOperands,
     /*   75529 */     // GIR_Coverage, 47150,
     /*   75529 */     GIR_EraseRootFromParent_Done,
     /*   75530 */   // Label 1212: @75530
     /*   75530 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75619), // Rule ID 47151 //
     /*   75535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75550 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75569 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75578 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   75578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   75581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75617 */     GIR_RootConstrainSelectedInstOperands,
     /*   75618 */     // GIR_Coverage, 47151,
     /*   75618 */     GIR_EraseRootFromParent_Done,
     /*   75619 */   // Label 1213: @75619
     /*   75619 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75687), // Rule ID 52028 //
     /*   75624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   75627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75661 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   75661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   75682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75685 */     GIR_RootConstrainSelectedInstOperands,
     /*   75686 */     // GIR_Coverage, 52028,
     /*   75686 */     GIR_EraseRootFromParent_Done,
     /*   75687 */   // Label 1214: @75687
     /*   75687 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75755), // Rule ID 52029 //
     /*   75692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   75695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   75711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   75715 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75729 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   75729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   75750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75753 */     GIR_RootConstrainSelectedInstOperands,
     /*   75754 */     // GIR_Coverage, 52029,
     /*   75754 */     GIR_EraseRootFromParent_Done,
     /*   75755 */   // Label 1215: @75755
     /*   75755 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75810), // Rule ID 47330 //
     /*   75760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75788 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75808 */     GIR_RootConstrainSelectedInstOperands,
     /*   75809 */     // GIR_Coverage, 47330,
     /*   75809 */     GIR_EraseRootFromParent_Done,
     /*   75810 */   // Label 1216: @75810
     /*   75810 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75865), // Rule ID 47331 //
     /*   75815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75843 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75863 */     GIR_RootConstrainSelectedInstOperands,
     /*   75864 */     // GIR_Coverage, 47331,
     /*   75864 */     GIR_EraseRootFromParent_Done,
     /*   75865 */   // Label 1217: @75865
     /*   75865 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75920), // Rule ID 47090 //
     /*   75870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75898 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   75898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75918 */     GIR_RootConstrainSelectedInstOperands,
     /*   75919 */     // GIR_Coverage, 47090,
     /*   75919 */     GIR_EraseRootFromParent_Done,
     /*   75920 */   // Label 1218: @75920
     /*   75920 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75975), // Rule ID 47091 //
     /*   75925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   75928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75953 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   75953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   75970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75973 */     GIR_RootConstrainSelectedInstOperands,
     /*   75974 */     // GIR_Coverage, 47091,
     /*   75974 */     GIR_EraseRootFromParent_Done,
     /*   75975 */   // Label 1219: @75975
     /*   75975 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76030), // Rule ID 47210 //
     /*   75980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   75983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   75999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76008 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   76008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76028 */     GIR_RootConstrainSelectedInstOperands,
     /*   76029 */     // GIR_Coverage, 47210,
     /*   76029 */     GIR_EraseRootFromParent_Done,
     /*   76030 */   // Label 1220: @76030
     /*   76030 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76085), // Rule ID 47211 //
     /*   76035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   76038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   76054 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76063 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   76063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   76066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   76080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76083 */     GIR_RootConstrainSelectedInstOperands,
     /*   76084 */     // GIR_Coverage, 47211,
     /*   76084 */     GIR_EraseRootFromParent_Done,
     /*   76085 */   // Label 1221: @76085
     /*   76085 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76138), // Rule ID 46302 //
     /*   76090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   76093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76101 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   76101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76136 */     GIR_RootConstrainSelectedInstOperands,
     /*   76137 */     // GIR_Coverage, 46302,
     /*   76137 */     GIR_EraseRootFromParent_Done,
     /*   76138 */   // Label 1222: @76138
     /*   76138 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76191), // Rule ID 46303 //
     /*   76143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   76146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76154 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   76154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   76157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   76186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76189 */     GIR_RootConstrainSelectedInstOperands,
     /*   76190 */     // GIR_Coverage, 46303,
     /*   76190 */     GIR_EraseRootFromParent_Done,
     /*   76191 */   // Label 1223: @76191
     /*   76191 */   GIM_Reject,
     /*   76192 */ // Label 1207: @76192
     /*   76192 */ GIM_Reject,
     /*   76193 */ // Label 982: @76193
     /*   76193 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(76439),
     /*   76198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76212 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(76276), // Rule ID 51984 //
     /*   76217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76250 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   76250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76274 */     GIR_RootConstrainSelectedInstOperands,
     /*   76275 */     // GIR_Coverage, 51984,
     /*   76275 */     GIR_EraseRootFromParent_Done,
     /*   76276 */   // Label 1225: @76276
     /*   76276 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(76340), // Rule ID 51985 //
     /*   76281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   76300 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76314 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   76314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   76317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76338 */     GIR_RootConstrainSelectedInstOperands,
     /*   76339 */     // GIR_Coverage, 51985,
     /*   76339 */     GIR_EraseRootFromParent_Done,
     /*   76340 */   // Label 1226: @76340
     /*   76340 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(76389), // Rule ID 46258 //
     /*   76345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76352 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76387 */     GIR_RootConstrainSelectedInstOperands,
     /*   76388 */     // GIR_Coverage, 46258,
     /*   76388 */     GIR_EraseRootFromParent_Done,
     /*   76389 */   // Label 1227: @76389
     /*   76389 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(76438), // Rule ID 46259 //
     /*   76394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76401 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   76404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   76418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76436 */     GIR_RootConstrainSelectedInstOperands,
     /*   76437 */     // GIR_Coverage, 46259,
     /*   76437 */     GIR_EraseRootFromParent_Done,
     /*   76438 */   // Label 1228: @76438
     /*   76438 */   GIM_Reject,
     /*   76439 */ // Label 1224: @76439
     /*   76439 */ GIM_Reject,
     /*   76440 */ // Label 983: @76440
     /*   76440 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77562),
     /*   76445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   76448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   76451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   76455 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(76544), // Rule ID 47230 //
     /*   76460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76494 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76503 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76542 */     GIR_RootConstrainSelectedInstOperands,
     /*   76543 */     // GIR_Coverage, 47230,
     /*   76543 */     GIR_EraseRootFromParent_Done,
     /*   76544 */   // Label 1230: @76544
     /*   76544 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(76633), // Rule ID 47231 //
     /*   76549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76592 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76631 */     GIR_RootConstrainSelectedInstOperands,
     /*   76632 */     // GIR_Coverage, 47231,
     /*   76632 */     GIR_EraseRootFromParent_Done,
     /*   76633 */   // Label 1231: @76633
     /*   76633 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(76722), // Rule ID 46990 //
     /*   76638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76681 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   76698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76720 */     GIR_RootConstrainSelectedInstOperands,
     /*   76721 */     // GIR_Coverage, 46990,
     /*   76721 */     GIR_EraseRootFromParent_Done,
     /*   76722 */   // Label 1232: @76722
     /*   76722 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(76811), // Rule ID 46991 //
     /*   76727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76770 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   76787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76809 */     GIR_RootConstrainSelectedInstOperands,
     /*   76810 */     // GIR_Coverage, 46991,
     /*   76810 */     GIR_EraseRootFromParent_Done,
     /*   76811 */   // Label 1233: @76811
     /*   76811 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(76900), // Rule ID 47110 //
     /*   76816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76859 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76898 */     GIR_RootConstrainSelectedInstOperands,
     /*   76899 */     // GIR_Coverage, 47110,
     /*   76899 */     GIR_EraseRootFromParent_Done,
     /*   76900 */   // Label 1234: @76900
     /*   76900 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(76989), // Rule ID 47111 //
     /*   76905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   76935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   76939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   76946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76948 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   76951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   76965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76987 */     GIR_RootConstrainSelectedInstOperands,
     /*   76988 */     // GIR_Coverage, 47111,
     /*   76988 */     GIR_EraseRootFromParent_Done,
     /*   76989 */   // Label 1235: @76989
     /*   76989 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(77057), // Rule ID 52000 //
     /*   76994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77017 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77031 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   77031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77055 */     GIR_RootConstrainSelectedInstOperands,
     /*   77056 */     // GIR_Coverage, 52000,
     /*   77056 */     GIR_EraseRootFromParent_Done,
     /*   77057 */   // Label 1236: @77057
     /*   77057 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(77125), // Rule ID 52001 //
     /*   77062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   77077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   77085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77099 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   77099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   77102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   77108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77123 */     GIR_RootConstrainSelectedInstOperands,
     /*   77124 */     // GIR_Coverage, 52001,
     /*   77124 */     GIR_EraseRootFromParent_Done,
     /*   77125 */   // Label 1237: @77125
     /*   77125 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(77180), // Rule ID 47290 //
     /*   77130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77158 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77178 */     GIR_RootConstrainSelectedInstOperands,
     /*   77179 */     // GIR_Coverage, 47290,
     /*   77179 */     GIR_EraseRootFromParent_Done,
     /*   77180 */   // Label 1238: @77180
     /*   77180 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(77235), // Rule ID 47291 //
     /*   77185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77204 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77213 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77233 */     GIR_RootConstrainSelectedInstOperands,
     /*   77234 */     // GIR_Coverage, 47291,
     /*   77234 */     GIR_EraseRootFromParent_Done,
     /*   77235 */   // Label 1239: @77235
     /*   77235 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(77290), // Rule ID 47050 //
     /*   77240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77259 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77268 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77288 */     GIR_RootConstrainSelectedInstOperands,
     /*   77289 */     // GIR_Coverage, 47050,
     /*   77289 */     GIR_EraseRootFromParent_Done,
     /*   77290 */   // Label 1240: @77290
     /*   77290 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(77345), // Rule ID 47051 //
     /*   77295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77323 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   77326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77343 */     GIR_RootConstrainSelectedInstOperands,
     /*   77344 */     // GIR_Coverage, 47051,
     /*   77344 */     GIR_EraseRootFromParent_Done,
     /*   77345 */   // Label 1241: @77345
     /*   77345 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(77400), // Rule ID 47170 //
     /*   77350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77369 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77378 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   77378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77398 */     GIR_RootConstrainSelectedInstOperands,
     /*   77399 */     // GIR_Coverage, 47170,
     /*   77399 */     GIR_EraseRootFromParent_Done,
     /*   77400 */   // Label 1242: @77400
     /*   77400 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(77455), // Rule ID 47171 //
     /*   77405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   77416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   77424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   77431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   77433 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   77433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   77436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   77440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   77453 */     GIR_RootConstrainSelectedInstOperands,
     /*   77454 */     // GIR_Coverage, 47171,
     /*   77454 */     GIR_EraseRootFromParent_Done,
     /*   77455 */   // Label 1243: @77455
     /*   77455 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(77508), // Rule ID 46274 //
     /*   77460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77471 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77506 */     GIR_RootConstrainSelectedInstOperands,
     /*   77507 */     // GIR_Coverage, 46274,
     /*   77507 */     GIR_EraseRootFromParent_Done,
     /*   77508 */   // Label 1244: @77508
     /*   77508 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(77561), // Rule ID 46275 //
     /*   77513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77524 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   77527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   77541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   77548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   77550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77559 */     GIR_RootConstrainSelectedInstOperands,
     /*   77560 */     // GIR_Coverage, 46275,
     /*   77560 */     GIR_EraseRootFromParent_Done,
     /*   77561 */   // Label 1245: @77561
     /*   77561 */   GIM_Reject,
     /*   77562 */ // Label 1229: @77562
     /*   77562 */ GIM_Reject,
     /*   77563 */ // Label 984: @77563
     /*   77563 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(78685),
     /*   77568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   77571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   77574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   77578 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(77667), // Rule ID 47254 //
     /*   77583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77598 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77617 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77626 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77665 */     GIR_RootConstrainSelectedInstOperands,
     /*   77666 */     // GIR_Coverage, 47254,
     /*   77666 */     GIR_EraseRootFromParent_Done,
     /*   77667 */   // Label 1247: @77667
     /*   77667 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(77756), // Rule ID 47255 //
     /*   77672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77687 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77706 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77715 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77754 */     GIR_RootConstrainSelectedInstOperands,
     /*   77755 */     // GIR_Coverage, 47255,
     /*   77755 */     GIR_EraseRootFromParent_Done,
     /*   77756 */   // Label 1248: @77756
     /*   77756 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(77845), // Rule ID 47014 //
     /*   77761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77795 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77804 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   77821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77843 */     GIR_RootConstrainSelectedInstOperands,
     /*   77844 */     // GIR_Coverage, 47014,
     /*   77844 */     GIR_EraseRootFromParent_Done,
     /*   77845 */   // Label 1249: @77845
     /*   77845 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(77934), // Rule ID 47015 //
     /*   77850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77865 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77884 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77893 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   77893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   77910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   77929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77932 */     GIR_RootConstrainSelectedInstOperands,
     /*   77933 */     // GIR_Coverage, 47015,
     /*   77933 */     GIR_EraseRootFromParent_Done,
     /*   77934 */   // Label 1250: @77934
     /*   77934 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(78023), // Rule ID 47134 //
     /*   77939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77954 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   77973 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   77980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77982 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   77982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   77985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   77999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78021 */     GIR_RootConstrainSelectedInstOperands,
     /*   78022 */     // GIR_Coverage, 47134,
     /*   78022 */     GIR_EraseRootFromParent_Done,
     /*   78023 */   // Label 1251: @78023
     /*   78023 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(78112), // Rule ID 47135 //
     /*   78028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78043 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78062 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78071 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   78088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78110 */     GIR_RootConstrainSelectedInstOperands,
     /*   78111 */     // GIR_Coverage, 47135,
     /*   78111 */     GIR_EraseRootFromParent_Done,
     /*   78112 */   // Label 1252: @78112
     /*   78112 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(78180), // Rule ID 52016 //
     /*   78117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78140 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78154 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   78154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78178 */     GIR_RootConstrainSelectedInstOperands,
     /*   78179 */     // GIR_Coverage, 52016,
     /*   78179 */     GIR_EraseRootFromParent_Done,
     /*   78180 */   // Label 1253: @78180
     /*   78180 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(78248), // Rule ID 52017 //
     /*   78185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   78204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   78208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78222 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   78222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   78225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78246 */     GIR_RootConstrainSelectedInstOperands,
     /*   78247 */     // GIR_Coverage, 52017,
     /*   78247 */     GIR_EraseRootFromParent_Done,
     /*   78248 */   // Label 1254: @78248
     /*   78248 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(78303), // Rule ID 47314 //
     /*   78253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78281 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78301 */     GIR_RootConstrainSelectedInstOperands,
     /*   78302 */     // GIR_Coverage, 47314,
     /*   78302 */     GIR_EraseRootFromParent_Done,
     /*   78303 */   // Label 1255: @78303
     /*   78303 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(78358), // Rule ID 47315 //
     /*   78308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78336 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78356 */     GIR_RootConstrainSelectedInstOperands,
     /*   78357 */     // GIR_Coverage, 47315,
     /*   78357 */     GIR_EraseRootFromParent_Done,
     /*   78358 */   // Label 1256: @78358
     /*   78358 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(78413), // Rule ID 47074 //
     /*   78363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78391 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78411 */     GIR_RootConstrainSelectedInstOperands,
     /*   78412 */     // GIR_Coverage, 47074,
     /*   78412 */     GIR_EraseRootFromParent_Done,
     /*   78413 */   // Label 1257: @78413
     /*   78413 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(78468), // Rule ID 47075 //
     /*   78418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78446 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   78449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78466 */     GIR_RootConstrainSelectedInstOperands,
     /*   78467 */     // GIR_Coverage, 47075,
     /*   78467 */     GIR_EraseRootFromParent_Done,
     /*   78468 */   // Label 1258: @78468
     /*   78468 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(78523), // Rule ID 47194 //
     /*   78473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78501 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   78501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78521 */     GIR_RootConstrainSelectedInstOperands,
     /*   78522 */     // GIR_Coverage, 47194,
     /*   78522 */     GIR_EraseRootFromParent_Done,
     /*   78523 */   // Label 1259: @78523
     /*   78523 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(78578), // Rule ID 47195 //
     /*   78528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   78547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78556 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   78556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   78559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78576 */     GIR_RootConstrainSelectedInstOperands,
     /*   78577 */     // GIR_Coverage, 47195,
     /*   78577 */     GIR_EraseRootFromParent_Done,
     /*   78578 */   // Label 1260: @78578
     /*   78578 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(78631), // Rule ID 46290 //
     /*   78583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78594 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   78594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   78611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78629 */     GIR_RootConstrainSelectedInstOperands,
     /*   78630 */     // GIR_Coverage, 46290,
     /*   78630 */     GIR_EraseRootFromParent_Done,
     /*   78631 */   // Label 1261: @78631
     /*   78631 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(78684), // Rule ID 46291 //
     /*   78636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78647 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   78647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   78650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   78664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   78679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78682 */     GIR_RootConstrainSelectedInstOperands,
     /*   78683 */     // GIR_Coverage, 46291,
     /*   78683 */     GIR_EraseRootFromParent_Done,
     /*   78684 */   // Label 1262: @78684
     /*   78684 */   GIM_Reject,
     /*   78685 */ // Label 1246: @78685
     /*   78685 */ GIM_Reject,
     /*   78686 */ // Label 985: @78686
     /*   78686 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(78932),
     /*   78691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78705 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(78769), // Rule ID 51988 //
     /*   78710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78729 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78743 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   78743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   78746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78767 */     GIR_RootConstrainSelectedInstOperands,
     /*   78768 */     // GIR_Coverage, 51988,
     /*   78768 */     GIR_EraseRootFromParent_Done,
     /*   78769 */   // Label 1264: @78769
     /*   78769 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(78833), // Rule ID 51989 //
     /*   78774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   78781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   78785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   78793 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   78807 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   78807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   78810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   78816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   78822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   78831 */     GIR_RootConstrainSelectedInstOperands,
     /*   78832 */     // GIR_Coverage, 51989,
     /*   78832 */     GIR_EraseRootFromParent_Done,
     /*   78833 */   // Label 1265: @78833
     /*   78833 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(78882), // Rule ID 46262 //
     /*   78838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78845 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   78845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   78848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78880 */     GIR_RootConstrainSelectedInstOperands,
     /*   78881 */     // GIR_Coverage, 46262,
     /*   78881 */     GIR_EraseRootFromParent_Done,
     /*   78882 */   // Label 1266: @78882
     /*   78882 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(78931), // Rule ID 46263 //
     /*   78887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78894 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   78894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   78897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   78911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78929 */     GIR_RootConstrainSelectedInstOperands,
     /*   78930 */     // GIR_Coverage, 46263,
     /*   78930 */     GIR_EraseRootFromParent_Done,
     /*   78931 */   // Label 1267: @78931
     /*   78931 */   GIM_Reject,
     /*   78932 */ // Label 1263: @78932
     /*   78932 */ GIM_Reject,
     /*   78933 */ // Label 986: @78933
     /*   78933 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(80055),
     /*   78938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   78941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   78944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   78948 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(79037), // Rule ID 47234 //
     /*   78953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   78987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   78994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78996 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   78996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   78999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79035 */     GIR_RootConstrainSelectedInstOperands,
     /*   79036 */     // GIR_Coverage, 47234,
     /*   79036 */     GIR_EraseRootFromParent_Done,
     /*   79037 */   // Label 1269: @79037
     /*   79037 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(79126), // Rule ID 47235 //
     /*   79042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79057 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79076 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79085 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79124 */     GIR_RootConstrainSelectedInstOperands,
     /*   79125 */     // GIR_Coverage, 47235,
     /*   79125 */     GIR_EraseRootFromParent_Done,
     /*   79126 */   // Label 1270: @79126
     /*   79126 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(79215), // Rule ID 46994 //
     /*   79131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79174 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79213 */     GIR_RootConstrainSelectedInstOperands,
     /*   79214 */     // GIR_Coverage, 46994,
     /*   79214 */     GIR_EraseRootFromParent_Done,
     /*   79215 */   // Label 1271: @79215
     /*   79215 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(79304), // Rule ID 46995 //
     /*   79220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79235 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79254 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79263 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   79280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79302 */     GIR_RootConstrainSelectedInstOperands,
     /*   79303 */     // GIR_Coverage, 46995,
     /*   79303 */     GIR_EraseRootFromParent_Done,
     /*   79304 */   // Label 1272: @79304
     /*   79304 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(79393), // Rule ID 47114 //
     /*   79309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79343 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79352 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   79352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79391 */     GIR_RootConstrainSelectedInstOperands,
     /*   79392 */     // GIR_Coverage, 47114,
     /*   79392 */     GIR_EraseRootFromParent_Done,
     /*   79393 */   // Label 1273: @79393
     /*   79393 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(79482), // Rule ID 47115 //
     /*   79398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79413 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79441 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   79441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   79458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79480 */     GIR_RootConstrainSelectedInstOperands,
     /*   79481 */     // GIR_Coverage, 47115,
     /*   79481 */     GIR_EraseRootFromParent_Done,
     /*   79482 */   // Label 1274: @79482
     /*   79482 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(79550), // Rule ID 52004 //
     /*   79487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79524 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   79524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   79527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79548 */     GIR_RootConstrainSelectedInstOperands,
     /*   79549 */     // GIR_Coverage, 52004,
     /*   79549 */     GIR_EraseRootFromParent_Done,
     /*   79550 */   // Label 1275: @79550
     /*   79550 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(79618), // Rule ID 52005 //
     /*   79555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   79570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   79574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   79578 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79592 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   79592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   79595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   79601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79616 */     GIR_RootConstrainSelectedInstOperands,
     /*   79617 */     // GIR_Coverage, 52005,
     /*   79617 */     GIR_EraseRootFromParent_Done,
     /*   79618 */   // Label 1276: @79618
     /*   79618 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(79673), // Rule ID 47294 //
     /*   79623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79651 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79671 */     GIR_RootConstrainSelectedInstOperands,
     /*   79672 */     // GIR_Coverage, 47294,
     /*   79672 */     GIR_EraseRootFromParent_Done,
     /*   79673 */   // Label 1277: @79673
     /*   79673 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(79728), // Rule ID 47295 //
     /*   79678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79706 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79726 */     GIR_RootConstrainSelectedInstOperands,
     /*   79727 */     // GIR_Coverage, 47295,
     /*   79727 */     GIR_EraseRootFromParent_Done,
     /*   79728 */   // Label 1278: @79728
     /*   79728 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(79783), // Rule ID 47054 //
     /*   79733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79761 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   79764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79781 */     GIR_RootConstrainSelectedInstOperands,
     /*   79782 */     // GIR_Coverage, 47054,
     /*   79782 */     GIR_EraseRootFromParent_Done,
     /*   79783 */   // Label 1279: @79783
     /*   79783 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(79838), // Rule ID 47055 //
     /*   79788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79807 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79816 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   79819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79836 */     GIR_RootConstrainSelectedInstOperands,
     /*   79837 */     // GIR_Coverage, 47055,
     /*   79837 */     GIR_EraseRootFromParent_Done,
     /*   79838 */   // Label 1280: @79838
     /*   79838 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(79893), // Rule ID 47174 //
     /*   79843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79871 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   79871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79891 */     GIR_RootConstrainSelectedInstOperands,
     /*   79892 */     // GIR_Coverage, 47174,
     /*   79892 */     GIR_EraseRootFromParent_Done,
     /*   79893 */   // Label 1281: @79893
     /*   79893 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(79948), // Rule ID 47175 //
     /*   79898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   79909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   79917 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   79924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   79926 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   79926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   79929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   79933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   79946 */     GIR_RootConstrainSelectedInstOperands,
     /*   79947 */     // GIR_Coverage, 47175,
     /*   79947 */     GIR_EraseRootFromParent_Done,
     /*   79948 */   // Label 1282: @79948
     /*   79948 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(80001), // Rule ID 46278 //
     /*   79953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   79964 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   79967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   79981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   79988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   79990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79999 */     GIR_RootConstrainSelectedInstOperands,
     /*   80000 */     // GIR_Coverage, 46278,
     /*   80000 */     GIR_EraseRootFromParent_Done,
     /*   80001 */   // Label 1283: @80001
     /*   80001 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(80054), // Rule ID 46279 //
     /*   80006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80017 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   80017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   80020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80052 */     GIR_RootConstrainSelectedInstOperands,
     /*   80053 */     // GIR_Coverage, 46279,
     /*   80053 */     GIR_EraseRootFromParent_Done,
     /*   80054 */   // Label 1284: @80054
     /*   80054 */   GIM_Reject,
     /*   80055 */ // Label 1268: @80055
     /*   80055 */ GIM_Reject,
     /*   80056 */ // Label 987: @80056
     /*   80056 */ GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(80302),
     /*   80061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80075 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(80139), // Rule ID 51992 //
     /*   80080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80099 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80113 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   80113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80137 */     GIR_RootConstrainSelectedInstOperands,
     /*   80138 */     // GIR_Coverage, 51992,
     /*   80138 */     GIR_EraseRootFromParent_Done,
     /*   80139 */   // Label 1286: @80139
     /*   80139 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(80203), // Rule ID 51993 //
     /*   80144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   80151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   80155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   80159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   80163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   80177 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   80177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   80180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   80186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   80192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   80201 */     GIR_RootConstrainSelectedInstOperands,
     /*   80202 */     // GIR_Coverage, 51993,
     /*   80202 */     GIR_EraseRootFromParent_Done,
     /*   80203 */   // Label 1287: @80203
     /*   80203 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(80252), // Rule ID 46266 //
     /*   80208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80215 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80250 */     GIR_RootConstrainSelectedInstOperands,
     /*   80251 */     // GIR_Coverage, 46266,
     /*   80251 */     GIR_EraseRootFromParent_Done,
     /*   80252 */   // Label 1288: @80252
     /*   80252 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(80301), // Rule ID 46267 //
     /*   80257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   80264 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   80267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   80281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80299 */     GIR_RootConstrainSelectedInstOperands,
     /*   80300 */     // GIR_Coverage, 46267,
     /*   80300 */     GIR_EraseRootFromParent_Done,
     /*   80301 */   // Label 1289: @80301
     /*   80301 */   GIM_Reject,
     /*   80302 */ // Label 1285: @80302
     /*   80302 */ GIM_Reject,
     /*   80303 */ // Label 988: @80303
     /*   80303 */ GIM_Reject,
     /*   80304 */ // Label 2: @80304
     /*   80304 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1314*/ GIMT_Encode4(107357),
     /*   80315 */ /*GILLT_s32*//*Label 1290*/ GIMT_Encode4(80439),
     /*   80319 */ /*GILLT_s64*//*Label 1291*/ GIMT_Encode4(80473), GIMT_Encode4(0),
     /*   80327 */ /*GILLT_nxv1s8*//*Label 1292*/ GIMT_Encode4(80677),
     /*   80331 */ /*GILLT_nxv1s16*//*Label 1293*/ GIMT_Encode4(80792),
     /*   80335 */ /*GILLT_nxv1s32*//*Label 1294*/ GIMT_Encode4(82517),
     /*   80339 */ /*GILLT_nxv1s64*//*Label 1295*/ GIMT_Encode4(84242), GIMT_Encode4(0),
     /*   80347 */ /*GILLT_nxv2s8*//*Label 1296*/ GIMT_Encode4(85967),
     /*   80351 */ /*GILLT_nxv2s16*//*Label 1297*/ GIMT_Encode4(86082),
     /*   80355 */ /*GILLT_nxv2s32*//*Label 1298*/ GIMT_Encode4(87807),
     /*   80359 */ /*GILLT_nxv2s64*//*Label 1299*/ GIMT_Encode4(89532), GIMT_Encode4(0),
     /*   80367 */ /*GILLT_nxv4s8*//*Label 1300*/ GIMT_Encode4(91257),
     /*   80371 */ /*GILLT_nxv4s16*//*Label 1301*/ GIMT_Encode4(91372),
     /*   80375 */ /*GILLT_nxv4s32*//*Label 1302*/ GIMT_Encode4(93097),
     /*   80379 */ /*GILLT_nxv4s64*//*Label 1303*/ GIMT_Encode4(94822), GIMT_Encode4(0),
     /*   80387 */ /*GILLT_nxv8s8*//*Label 1304*/ GIMT_Encode4(96547),
     /*   80391 */ /*GILLT_nxv8s16*//*Label 1305*/ GIMT_Encode4(96662),
     /*   80395 */ /*GILLT_nxv8s32*//*Label 1306*/ GIMT_Encode4(98387),
     /*   80399 */ /*GILLT_nxv8s64*//*Label 1307*/ GIMT_Encode4(100112), GIMT_Encode4(0),
     /*   80407 */ /*GILLT_nxv16s8*//*Label 1308*/ GIMT_Encode4(101837),
     /*   80411 */ /*GILLT_nxv16s16*//*Label 1309*/ GIMT_Encode4(101952),
     /*   80415 */ /*GILLT_nxv16s32*//*Label 1310*/ GIMT_Encode4(103677), GIMT_Encode4(0),
     /*   80423 */ /*GILLT_nxv32s8*//*Label 1311*/ GIMT_Encode4(105402),
     /*   80427 */ /*GILLT_nxv32s16*//*Label 1312*/ GIMT_Encode4(105517), GIMT_Encode4(0),
     /*   80435 */ /*GILLT_nxv64s8*//*Label 1313*/ GIMT_Encode4(107242),
     /*   80439 */ // Label 1290: @80439
     /*   80439 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(80472), // Rule ID 298 //
     /*   80444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /*   80447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   80450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   80453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80465 */   // (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MUL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   80465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80470 */   GIR_RootConstrainSelectedInstOperands,
     /*   80471 */   // GIR_Coverage, 298,
     /*   80471 */   GIR_Done,
     /*   80472 */ // Label 1315: @80472
     /*   80472 */ GIM_Reject,
     /*   80473 */ // Label 1291: @80473
     /*   80473 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(80676),
     /*   80478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   80481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   80484 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(80617), // Rule ID 320 //
     /*   80489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0),
     /*   80492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   80508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   80512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80517 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   80528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   80536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   80540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   80544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80549 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*   80560 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80562 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 4294967295:{ *:[i64] }))  =>  (MULHU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))
     /*   80562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   80565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   80569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80574 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   80578 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*   80581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   80583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   80586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   80590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*   80602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /*   80607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   80615 */     GIR_RootConstrainSelectedInstOperands,
     /*   80616 */     // GIR_Coverage, 320,
     /*   80616 */     GIR_EraseRootFromParent_Done,
     /*   80617 */   // Label 1317: @80617
     /*   80617 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(80648), // Rule ID 313 //
     /*   80622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_HwMode0),
     /*   80625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80637 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10066),
     /*   80641 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10066>>  =>  (MULW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   80641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULW),
     /*   80646 */     GIR_RootConstrainSelectedInstOperands,
     /*   80647 */     // GIR_Coverage, 313,
     /*   80647 */     GIR_Done,
     /*   80648 */   // Label 1318: @80648
     /*   80648 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(80675), // Rule ID 297 //
     /*   80653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /*   80656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   80668 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MUL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   80668 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   80673 */     GIR_RootConstrainSelectedInstOperands,
     /*   80674 */     // GIR_Coverage, 297,
     /*   80674 */     GIR_Done,
     /*   80675 */   // Label 1319: @80675
     /*   80675 */   GIM_Reject,
     /*   80676 */ // Label 1316: @80676
     /*   80676 */ GIM_Reject,
     /*   80677 */ // Label 1292: @80677
     /*   80677 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(80791),
     /*   80682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   80688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80700 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(80745), // Rule ID 50854 //
     /*   80705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80708 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   80711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   80725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80743 */     GIR_RootConstrainSelectedInstOperands,
     /*   80744 */     // GIR_Coverage, 50854,
     /*   80744 */     GIR_EraseRootFromParent_Done,
     /*   80745 */   // Label 1321: @80745
     /*   80745 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(80790), // Rule ID 50855 //
     /*   80750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80753 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   80756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   80770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80788 */     GIR_RootConstrainSelectedInstOperands,
     /*   80789 */     // GIR_Coverage, 50855,
     /*   80789 */     GIR_EraseRootFromParent_Done,
     /*   80790 */   // Label 1322: @80790
     /*   80790 */   GIM_Reject,
     /*   80791 */ // Label 1320: @80791
     /*   80791 */ GIM_Reject,
     /*   80792 */ // Label 1293: @80792
     /*   80792 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(82516),
     /*   80797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   80800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   80803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80807 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(80896), // Rule ID 51620 //
     /*   80812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80855 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   80855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   80858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   80872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80894 */     GIR_RootConstrainSelectedInstOperands,
     /*   80895 */     // GIR_Coverage, 51620,
     /*   80895 */     GIR_EraseRootFromParent_Done,
     /*   80896 */   // Label 1324: @80896
     /*   80896 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(80985), // Rule ID 51621 //
     /*   80901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80916 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   80935 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80944 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   80944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   80947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   80961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80983 */     GIR_RootConstrainSelectedInstOperands,
     /*   80984 */     // GIR_Coverage, 51621,
     /*   80984 */     GIR_EraseRootFromParent_Done,
     /*   80985 */   // Label 1325: @80985
     /*   80985 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(81074), // Rule ID 70542 //
     /*   80990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81005 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81024 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81033 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81072 */     GIR_RootConstrainSelectedInstOperands,
     /*   81073 */     // GIR_Coverage, 70542,
     /*   81073 */     GIR_EraseRootFromParent_Done,
     /*   81074 */   // Label 1326: @81074
     /*   81074 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(81163), // Rule ID 70543 //
     /*   81079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81113 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81122 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81161 */     GIR_RootConstrainSelectedInstOperands,
     /*   81162 */     // GIR_Coverage, 70543,
     /*   81162 */     GIR_EraseRootFromParent_Done,
     /*   81163 */   // Label 1327: @81163
     /*   81163 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(81252), // Rule ID 70422 //
     /*   81168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81183 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81198 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81202 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81211 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81250 */     GIR_RootConstrainSelectedInstOperands,
     /*   81251 */     // GIR_Coverage, 70422,
     /*   81251 */     GIR_EraseRootFromParent_Done,
     /*   81252 */   // Label 1328: @81252
     /*   81252 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(81341), // Rule ID 70423 //
     /*   81257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81291 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81300 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81339 */     GIR_RootConstrainSelectedInstOperands,
     /*   81340 */     // GIR_Coverage, 70423,
     /*   81340 */     GIR_EraseRootFromParent_Done,
     /*   81341 */   // Label 1329: @81341
     /*   81341 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(81430), // Rule ID 51800 //
     /*   81346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81380 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81389 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81428 */     GIR_RootConstrainSelectedInstOperands,
     /*   81429 */     // GIR_Coverage, 51800,
     /*   81429 */     GIR_EraseRootFromParent_Done,
     /*   81430 */   // Label 1330: @81430
     /*   81430 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(81519), // Rule ID 51801 //
     /*   81435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81450 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81478 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81517 */     GIR_RootConstrainSelectedInstOperands,
     /*   81518 */     // GIR_Coverage, 51801,
     /*   81518 */     GIR_EraseRootFromParent_Done,
     /*   81519 */   // Label 1331: @81519
     /*   81519 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(81608), // Rule ID 51500 //
     /*   81524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81539 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81567 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   81584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81606 */     GIR_RootConstrainSelectedInstOperands,
     /*   81607 */     // GIR_Coverage, 51500,
     /*   81607 */     GIR_EraseRootFromParent_Done,
     /*   81608 */   // Label 1332: @81608
     /*   81608 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(81697), // Rule ID 51501 //
     /*   81613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81628 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81647 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81656 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   81673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81695 */     GIR_RootConstrainSelectedInstOperands,
     /*   81696 */     // GIR_Coverage, 51501,
     /*   81696 */     GIR_EraseRootFromParent_Done,
     /*   81697 */   // Label 1333: @81697
     /*   81697 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(81786), // Rule ID 51740 //
     /*   81702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81717 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81745 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81784 */     GIR_RootConstrainSelectedInstOperands,
     /*   81785 */     // GIR_Coverage, 51740,
     /*   81785 */     GIR_EraseRootFromParent_Done,
     /*   81786 */   // Label 1334: @81786
     /*   81786 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(81875), // Rule ID 51741 //
     /*   81791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81806 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81825 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81834 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   81851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81873 */     GIR_RootConstrainSelectedInstOperands,
     /*   81874 */     // GIR_Coverage, 51741,
     /*   81874 */     GIR_EraseRootFromParent_Done,
     /*   81875 */   // Label 1335: @81875
     /*   81875 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(81964), // Rule ID 51680 //
     /*   81880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81895 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81914 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81923 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   81926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   81940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81962 */     GIR_RootConstrainSelectedInstOperands,
     /*   81963 */     // GIR_Coverage, 51680,
     /*   81963 */     GIR_EraseRootFromParent_Done,
     /*   81964 */   // Label 1336: @81964
     /*   81964 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(82053), // Rule ID 51681 //
     /*   81969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   81984 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82012 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82051 */     GIR_RootConstrainSelectedInstOperands,
     /*   82052 */     // GIR_Coverage, 51681,
     /*   82052 */     GIR_EraseRootFromParent_Done,
     /*   82053 */   // Label 1337: @82053
     /*   82053 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(82142), // Rule ID 70482 //
     /*   82058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82073 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82101 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82140 */     GIR_RootConstrainSelectedInstOperands,
     /*   82141 */     // GIR_Coverage, 70482,
     /*   82141 */     GIR_EraseRootFromParent_Done,
     /*   82142 */   // Label 1338: @82142
     /*   82142 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(82231), // Rule ID 70483 //
     /*   82147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82162 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82190 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   82207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82229 */     GIR_RootConstrainSelectedInstOperands,
     /*   82230 */     // GIR_Coverage, 70483,
     /*   82230 */     GIR_EraseRootFromParent_Done,
     /*   82231 */   // Label 1339: @82231
     /*   82231 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(82320), // Rule ID 51560 //
     /*   82236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82270 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82279 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82318 */     GIR_RootConstrainSelectedInstOperands,
     /*   82319 */     // GIR_Coverage, 51560,
     /*   82319 */     GIR_EraseRootFromParent_Done,
     /*   82320 */   // Label 1340: @82320
     /*   82320 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(82409), // Rule ID 51561 //
     /*   82325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82340 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   82359 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82368 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   82385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82407 */     GIR_RootConstrainSelectedInstOperands,
     /*   82408 */     // GIR_Coverage, 51561,
     /*   82408 */     GIR_EraseRootFromParent_Done,
     /*   82409 */   // Label 1341: @82409
     /*   82409 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(82462), // Rule ID 50866 //
     /*   82414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82425 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82460 */     GIR_RootConstrainSelectedInstOperands,
     /*   82461 */     // GIR_Coverage, 50866,
     /*   82461 */     GIR_EraseRootFromParent_Done,
     /*   82462 */   // Label 1342: @82462
     /*   82462 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(82515), // Rule ID 50867 //
     /*   82467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82478 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   82481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   82495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   82502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   82504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82513 */     GIR_RootConstrainSelectedInstOperands,
     /*   82514 */     // GIR_Coverage, 50867,
     /*   82514 */     GIR_EraseRootFromParent_Done,
     /*   82515 */   // Label 1343: @82515
     /*   82515 */   GIM_Reject,
     /*   82516 */ // Label 1323: @82516
     /*   82516 */ GIM_Reject,
     /*   82517 */ // Label 1294: @82517
     /*   82517 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(84241),
     /*   82522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   82525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   82528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82532 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(82621), // Rule ID 51644 //
     /*   82537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82571 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82580 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82619 */     GIR_RootConstrainSelectedInstOperands,
     /*   82620 */     // GIR_Coverage, 51644,
     /*   82620 */     GIR_EraseRootFromParent_Done,
     /*   82621 */   // Label 1345: @82621
     /*   82621 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(82710), // Rule ID 51645 //
     /*   82626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82669 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82708 */     GIR_RootConstrainSelectedInstOperands,
     /*   82709 */     // GIR_Coverage, 51645,
     /*   82709 */     GIR_EraseRootFromParent_Done,
     /*   82710 */   // Label 1346: @82710
     /*   82710 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(82799), // Rule ID 70566 //
     /*   82715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82758 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82797 */     GIR_RootConstrainSelectedInstOperands,
     /*   82798 */     // GIR_Coverage, 70566,
     /*   82798 */     GIR_EraseRootFromParent_Done,
     /*   82799 */   // Label 1347: @82799
     /*   82799 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(82888), // Rule ID 70567 //
     /*   82804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82847 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   82847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82886 */     GIR_RootConstrainSelectedInstOperands,
     /*   82887 */     // GIR_Coverage, 70567,
     /*   82887 */     GIR_EraseRootFromParent_Done,
     /*   82888 */   // Label 1348: @82888
     /*   82888 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(82977), // Rule ID 70446 //
     /*   82893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82936 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   82936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   82939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   82972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82975 */     GIR_RootConstrainSelectedInstOperands,
     /*   82976 */     // GIR_Coverage, 70446,
     /*   82976 */     GIR_EraseRootFromParent_Done,
     /*   82977 */   // Label 1349: @82977
     /*   82977 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(83066), // Rule ID 70447 //
     /*   82982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   82997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83025 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83064 */     GIR_RootConstrainSelectedInstOperands,
     /*   83065 */     // GIR_Coverage, 70447,
     /*   83065 */     GIR_EraseRootFromParent_Done,
     /*   83066 */   // Label 1350: @83066
     /*   83066 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(83155), // Rule ID 51824 //
     /*   83071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83114 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83153 */     GIR_RootConstrainSelectedInstOperands,
     /*   83154 */     // GIR_Coverage, 51824,
     /*   83154 */     GIR_EraseRootFromParent_Done,
     /*   83155 */   // Label 1351: @83155
     /*   83155 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(83244), // Rule ID 51825 //
     /*   83160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83203 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83242 */     GIR_RootConstrainSelectedInstOperands,
     /*   83243 */     // GIR_Coverage, 51825,
     /*   83243 */     GIR_EraseRootFromParent_Done,
     /*   83244 */   // Label 1352: @83244
     /*   83244 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(83333), // Rule ID 51524 //
     /*   83249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83283 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83292 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83331 */     GIR_RootConstrainSelectedInstOperands,
     /*   83332 */     // GIR_Coverage, 51524,
     /*   83332 */     GIR_EraseRootFromParent_Done,
     /*   83333 */   // Label 1353: @83333
     /*   83333 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(83422), // Rule ID 51525 //
     /*   83338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83353 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83381 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   83398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83420 */     GIR_RootConstrainSelectedInstOperands,
     /*   83421 */     // GIR_Coverage, 51525,
     /*   83421 */     GIR_EraseRootFromParent_Done,
     /*   83422 */   // Label 1354: @83422
     /*   83422 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(83511), // Rule ID 51764 //
     /*   83427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83470 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83509 */     GIR_RootConstrainSelectedInstOperands,
     /*   83510 */     // GIR_Coverage, 51764,
     /*   83510 */     GIR_EraseRootFromParent_Done,
     /*   83511 */   // Label 1355: @83511
     /*   83511 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(83600), // Rule ID 51765 //
     /*   83516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83559 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83598 */     GIR_RootConstrainSelectedInstOperands,
     /*   83599 */     // GIR_Coverage, 51765,
     /*   83599 */     GIR_EraseRootFromParent_Done,
     /*   83600 */   // Label 1356: @83600
     /*   83600 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(83689), // Rule ID 51704 //
     /*   83605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83648 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83687 */     GIR_RootConstrainSelectedInstOperands,
     /*   83688 */     // GIR_Coverage, 51704,
     /*   83688 */     GIR_EraseRootFromParent_Done,
     /*   83689 */   // Label 1357: @83689
     /*   83689 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(83778), // Rule ID 51705 //
     /*   83694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83737 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83776 */     GIR_RootConstrainSelectedInstOperands,
     /*   83777 */     // GIR_Coverage, 51705,
     /*   83777 */     GIR_EraseRootFromParent_Done,
     /*   83778 */   // Label 1358: @83778
     /*   83778 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(83867), // Rule ID 70506 //
     /*   83783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83826 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83865 */     GIR_RootConstrainSelectedInstOperands,
     /*   83866 */     // GIR_Coverage, 70506,
     /*   83866 */     GIR_EraseRootFromParent_Done,
     /*   83867 */   // Label 1359: @83867
     /*   83867 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(83956), // Rule ID 70507 //
     /*   83872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83915 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   83918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83954 */     GIR_RootConstrainSelectedInstOperands,
     /*   83955 */     // GIR_Coverage, 70507,
     /*   83955 */     GIR_EraseRootFromParent_Done,
     /*   83956 */   // Label 1360: @83956
     /*   83956 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(84045), // Rule ID 51584 //
     /*   83961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   83995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84004 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84043 */     GIR_RootConstrainSelectedInstOperands,
     /*   84044 */     // GIR_Coverage, 51584,
     /*   84044 */     GIR_EraseRootFromParent_Done,
     /*   84045 */   // Label 1361: @84045
     /*   84045 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(84134), // Rule ID 51585 //
     /*   84050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   84084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84093 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   84110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84132 */     GIR_RootConstrainSelectedInstOperands,
     /*   84133 */     // GIR_Coverage, 51585,
     /*   84133 */     GIR_EraseRootFromParent_Done,
     /*   84134 */   // Label 1362: @84134
     /*   84134 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(84187), // Rule ID 50874 //
     /*   84139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84150 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84185 */     GIR_RootConstrainSelectedInstOperands,
     /*   84186 */     // GIR_Coverage, 50874,
     /*   84186 */     GIR_EraseRootFromParent_Done,
     /*   84187 */   // Label 1363: @84187
     /*   84187 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(84240), // Rule ID 50875 //
     /*   84192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84203 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   84206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   84220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   84227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   84229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84238 */     GIR_RootConstrainSelectedInstOperands,
     /*   84239 */     // GIR_Coverage, 50875,
     /*   84239 */     GIR_EraseRootFromParent_Done,
     /*   84240 */   // Label 1364: @84240
     /*   84240 */   GIM_Reject,
     /*   84241 */ // Label 1344: @84241
     /*   84241 */ GIM_Reject,
     /*   84242 */ // Label 1295: @84242
     /*   84242 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(85966),
     /*   84247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   84250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   84253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84257 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(84346), // Rule ID 51664 //
     /*   84262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84277 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84296 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84305 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84344 */     GIR_RootConstrainSelectedInstOperands,
     /*   84345 */     // GIR_Coverage, 51664,
     /*   84345 */     GIR_EraseRootFromParent_Done,
     /*   84346 */   // Label 1366: @84346
     /*   84346 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(84435), // Rule ID 51665 //
     /*   84351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84385 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84394 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84433 */     GIR_RootConstrainSelectedInstOperands,
     /*   84434 */     // GIR_Coverage, 51665,
     /*   84434 */     GIR_EraseRootFromParent_Done,
     /*   84435 */   // Label 1367: @84435
     /*   84435 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(84524), // Rule ID 70586 //
     /*   84440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84483 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84522 */     GIR_RootConstrainSelectedInstOperands,
     /*   84523 */     // GIR_Coverage, 70586,
     /*   84523 */     GIR_EraseRootFromParent_Done,
     /*   84524 */   // Label 1368: @84524
     /*   84524 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(84613), // Rule ID 70587 //
     /*   84529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84572 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84611 */     GIR_RootConstrainSelectedInstOperands,
     /*   84612 */     // GIR_Coverage, 70587,
     /*   84612 */     GIR_EraseRootFromParent_Done,
     /*   84613 */   // Label 1369: @84613
     /*   84613 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(84702), // Rule ID 70466 //
     /*   84618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84652 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84661 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84700 */     GIR_RootConstrainSelectedInstOperands,
     /*   84701 */     // GIR_Coverage, 70466,
     /*   84701 */     GIR_EraseRootFromParent_Done,
     /*   84702 */   // Label 1370: @84702
     /*   84702 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(84791), // Rule ID 70467 //
     /*   84707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84750 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84789 */     GIR_RootConstrainSelectedInstOperands,
     /*   84790 */     // GIR_Coverage, 70467,
     /*   84790 */     GIR_EraseRootFromParent_Done,
     /*   84791 */   // Label 1371: @84791
     /*   84791 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(84880), // Rule ID 51844 //
     /*   84796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84839 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   84839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84878 */     GIR_RootConstrainSelectedInstOperands,
     /*   84879 */     // GIR_Coverage, 51844,
     /*   84879 */     GIR_EraseRootFromParent_Done,
     /*   84880 */   // Label 1372: @84880
     /*   84880 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(84969), // Rule ID 51845 //
     /*   84885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   84888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84900 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84919 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84928 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   84928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   84931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   84964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84967 */     GIR_RootConstrainSelectedInstOperands,
     /*   84968 */     // GIR_Coverage, 51845,
     /*   84968 */     GIR_EraseRootFromParent_Done,
     /*   84969 */   // Label 1373: @84969
     /*   84969 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(85058), // Rule ID 51544 //
     /*   84974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   84977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   84989 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85008 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85017 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85056 */     GIR_RootConstrainSelectedInstOperands,
     /*   85057 */     // GIR_Coverage, 51544,
     /*   85057 */     GIR_EraseRootFromParent_Done,
     /*   85058 */   // Label 1374: @85058
     /*   85058 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(85147), // Rule ID 51545 //
     /*   85063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85078 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85097 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85106 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   85123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85145 */     GIR_RootConstrainSelectedInstOperands,
     /*   85146 */     // GIR_Coverage, 51545,
     /*   85146 */     GIR_EraseRootFromParent_Done,
     /*   85147 */   // Label 1375: @85147
     /*   85147 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(85236), // Rule ID 51784 //
     /*   85152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85186 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85195 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85234 */     GIR_RootConstrainSelectedInstOperands,
     /*   85235 */     // GIR_Coverage, 51784,
     /*   85235 */     GIR_EraseRootFromParent_Done,
     /*   85236 */   // Label 1376: @85236
     /*   85236 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(85325), // Rule ID 51785 //
     /*   85241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85284 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85323 */     GIR_RootConstrainSelectedInstOperands,
     /*   85324 */     // GIR_Coverage, 51785,
     /*   85324 */     GIR_EraseRootFromParent_Done,
     /*   85325 */   // Label 1377: @85325
     /*   85325 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(85414), // Rule ID 51724 //
     /*   85330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85345 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85364 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85373 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85412 */     GIR_RootConstrainSelectedInstOperands,
     /*   85413 */     // GIR_Coverage, 51724,
     /*   85413 */     GIR_EraseRootFromParent_Done,
     /*   85414 */   // Label 1378: @85414
     /*   85414 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(85503), // Rule ID 51725 //
     /*   85419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85462 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85501 */     GIR_RootConstrainSelectedInstOperands,
     /*   85502 */     // GIR_Coverage, 51725,
     /*   85502 */     GIR_EraseRootFromParent_Done,
     /*   85503 */   // Label 1379: @85503
     /*   85503 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(85592), // Rule ID 70526 //
     /*   85508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85523 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85542 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85551 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85590 */     GIR_RootConstrainSelectedInstOperands,
     /*   85591 */     // GIR_Coverage, 70526,
     /*   85591 */     GIR_EraseRootFromParent_Done,
     /*   85592 */   // Label 1380: @85592
     /*   85592 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(85681), // Rule ID 70527 //
     /*   85597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85631 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85640 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85679 */     GIR_RootConstrainSelectedInstOperands,
     /*   85680 */     // GIR_Coverage, 70527,
     /*   85680 */     GIR_EraseRootFromParent_Done,
     /*   85681 */   // Label 1381: @85681
     /*   85681 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(85770), // Rule ID 51604 //
     /*   85686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85729 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85768 */     GIR_RootConstrainSelectedInstOperands,
     /*   85769 */     // GIR_Coverage, 51604,
     /*   85769 */     GIR_EraseRootFromParent_Done,
     /*   85770 */   // Label 1382: @85770
     /*   85770 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(85859), // Rule ID 51605 //
     /*   85775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   85809 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85818 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85857 */     GIR_RootConstrainSelectedInstOperands,
     /*   85858 */     // GIR_Coverage, 51605,
     /*   85858 */     GIR_EraseRootFromParent_Done,
     /*   85859 */   // Label 1383: @85859
     /*   85859 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(85912), // Rule ID 50890 //
     /*   85864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   85867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85875 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   85875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   85907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85910 */     GIR_RootConstrainSelectedInstOperands,
     /*   85911 */     // GIR_Coverage, 50890,
     /*   85911 */     GIR_EraseRootFromParent_Done,
     /*   85912 */   // Label 1384: @85912
     /*   85912 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(85965), // Rule ID 50891 //
     /*   85917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   85920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85928 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   85928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   85931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   85960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85963 */     GIR_RootConstrainSelectedInstOperands,
     /*   85964 */     // GIR_Coverage, 50891,
     /*   85964 */     GIR_EraseRootFromParent_Done,
     /*   85965 */   // Label 1385: @85965
     /*   85965 */   GIM_Reject,
     /*   85966 */ // Label 1365: @85966
     /*   85966 */ GIM_Reject,
     /*   85967 */ // Label 1296: @85967
     /*   85967 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(86081),
     /*   85972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   85975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   85978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85990 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(86035), // Rule ID 50858 //
     /*   85995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   85998 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   85998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86033 */     GIR_RootConstrainSelectedInstOperands,
     /*   86034 */     // GIR_Coverage, 50858,
     /*   86034 */     GIR_EraseRootFromParent_Done,
     /*   86035 */   // Label 1387: @86035
     /*   86035 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(86080), // Rule ID 50859 //
     /*   86040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86043 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   86046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   86060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   86067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   86069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86078 */     GIR_RootConstrainSelectedInstOperands,
     /*   86079 */     // GIR_Coverage, 50859,
     /*   86079 */     GIR_EraseRootFromParent_Done,
     /*   86080 */   // Label 1388: @86080
     /*   86080 */   GIM_Reject,
     /*   86081 */ // Label 1386: @86081
     /*   86081 */ GIM_Reject,
     /*   86082 */ // Label 1297: @86082
     /*   86082 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(87806),
     /*   86087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   86090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   86093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86097 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(86186), // Rule ID 51624 //
     /*   86102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86117 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86145 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86184 */     GIR_RootConstrainSelectedInstOperands,
     /*   86185 */     // GIR_Coverage, 51624,
     /*   86185 */     GIR_EraseRootFromParent_Done,
     /*   86186 */   // Label 1390: @86186
     /*   86186 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(86275), // Rule ID 51625 //
     /*   86191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86234 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86273 */     GIR_RootConstrainSelectedInstOperands,
     /*   86274 */     // GIR_Coverage, 51625,
     /*   86274 */     GIR_EraseRootFromParent_Done,
     /*   86275 */   // Label 1391: @86275
     /*   86275 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(86364), // Rule ID 70546 //
     /*   86280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86295 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86314 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86323 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86362 */     GIR_RootConstrainSelectedInstOperands,
     /*   86363 */     // GIR_Coverage, 70546,
     /*   86363 */     GIR_EraseRootFromParent_Done,
     /*   86364 */   // Label 1392: @86364
     /*   86364 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(86453), // Rule ID 70547 //
     /*   86369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86384 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86403 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86412 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86451 */     GIR_RootConstrainSelectedInstOperands,
     /*   86452 */     // GIR_Coverage, 70547,
     /*   86452 */     GIR_EraseRootFromParent_Done,
     /*   86453 */   // Label 1393: @86453
     /*   86453 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(86542), // Rule ID 70426 //
     /*   86458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86473 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86492 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86501 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86540 */     GIR_RootConstrainSelectedInstOperands,
     /*   86541 */     // GIR_Coverage, 70426,
     /*   86541 */     GIR_EraseRootFromParent_Done,
     /*   86542 */   // Label 1394: @86542
     /*   86542 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(86631), // Rule ID 70427 //
     /*   86547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86562 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86581 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86590 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   86607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86629 */     GIR_RootConstrainSelectedInstOperands,
     /*   86630 */     // GIR_Coverage, 70427,
     /*   86630 */     GIR_EraseRootFromParent_Done,
     /*   86631 */   // Label 1395: @86631
     /*   86631 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(86720), // Rule ID 51804 //
     /*   86636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86670 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86672 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86679 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86718 */     GIR_RootConstrainSelectedInstOperands,
     /*   86719 */     // GIR_Coverage, 51804,
     /*   86719 */     GIR_EraseRootFromParent_Done,
     /*   86720 */   // Label 1396: @86720
     /*   86720 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(86809), // Rule ID 51805 //
     /*   86725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86740 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86768 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   86785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86807 */     GIR_RootConstrainSelectedInstOperands,
     /*   86808 */     // GIR_Coverage, 51805,
     /*   86808 */     GIR_EraseRootFromParent_Done,
     /*   86809 */   // Label 1397: @86809
     /*   86809 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(86898), // Rule ID 51504 //
     /*   86814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86829 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86848 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86857 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   86857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   86874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86896 */     GIR_RootConstrainSelectedInstOperands,
     /*   86897 */     // GIR_Coverage, 51504,
     /*   86897 */     GIR_EraseRootFromParent_Done,
     /*   86898 */   // Label 1398: @86898
     /*   86898 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(86987), // Rule ID 51505 //
     /*   86903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   86906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   86937 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86946 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   86946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   86949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   86963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86985 */     GIR_RootConstrainSelectedInstOperands,
     /*   86986 */     // GIR_Coverage, 51505,
     /*   86986 */     GIR_EraseRootFromParent_Done,
     /*   86987 */   // Label 1399: @86987
     /*   86987 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(87076), // Rule ID 51744 //
     /*   86992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   86995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87026 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87035 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87074 */     GIR_RootConstrainSelectedInstOperands,
     /*   87075 */     // GIR_Coverage, 51744,
     /*   87075 */     GIR_EraseRootFromParent_Done,
     /*   87076 */   // Label 1400: @87076
     /*   87076 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(87165), // Rule ID 51745 //
     /*   87081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87115 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87124 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87163 */     GIR_RootConstrainSelectedInstOperands,
     /*   87164 */     // GIR_Coverage, 51745,
     /*   87164 */     GIR_EraseRootFromParent_Done,
     /*   87165 */   // Label 1401: @87165
     /*   87165 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(87254), // Rule ID 51684 //
     /*   87170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87185 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87204 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87213 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87252 */     GIR_RootConstrainSelectedInstOperands,
     /*   87253 */     // GIR_Coverage, 51684,
     /*   87253 */     GIR_EraseRootFromParent_Done,
     /*   87254 */   // Label 1402: @87254
     /*   87254 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(87343), // Rule ID 51685 //
     /*   87259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87274 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87293 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87302 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87341 */     GIR_RootConstrainSelectedInstOperands,
     /*   87342 */     // GIR_Coverage, 51685,
     /*   87342 */     GIR_EraseRootFromParent_Done,
     /*   87343 */   // Label 1403: @87343
     /*   87343 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(87432), // Rule ID 70486 //
     /*   87348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87363 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87382 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87391 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87430 */     GIR_RootConstrainSelectedInstOperands,
     /*   87431 */     // GIR_Coverage, 70486,
     /*   87431 */     GIR_EraseRootFromParent_Done,
     /*   87432 */   // Label 1404: @87432
     /*   87432 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(87521), // Rule ID 70487 //
     /*   87437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87471 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87480 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   87497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87519 */     GIR_RootConstrainSelectedInstOperands,
     /*   87520 */     // GIR_Coverage, 70487,
     /*   87520 */     GIR_EraseRootFromParent_Done,
     /*   87521 */   // Label 1405: @87521
     /*   87521 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(87610), // Rule ID 51564 //
     /*   87526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87560 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87569 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87608 */     GIR_RootConstrainSelectedInstOperands,
     /*   87609 */     // GIR_Coverage, 51564,
     /*   87609 */     GIR_EraseRootFromParent_Done,
     /*   87610 */   // Label 1406: @87610
     /*   87610 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(87699), // Rule ID 51565 //
     /*   87615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87630 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   87649 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87658 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   87675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87697 */     GIR_RootConstrainSelectedInstOperands,
     /*   87698 */     // GIR_Coverage, 51565,
     /*   87698 */     GIR_EraseRootFromParent_Done,
     /*   87699 */   // Label 1407: @87699
     /*   87699 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(87752), // Rule ID 50870 //
     /*   87704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87715 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   87715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87750 */     GIR_RootConstrainSelectedInstOperands,
     /*   87751 */     // GIR_Coverage, 50870,
     /*   87751 */     GIR_EraseRootFromParent_Done,
     /*   87752 */   // Label 1408: @87752
     /*   87752 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(87805), // Rule ID 50871 //
     /*   87757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87768 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   87768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   87771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87803 */     GIR_RootConstrainSelectedInstOperands,
     /*   87804 */     // GIR_Coverage, 50871,
     /*   87804 */     GIR_EraseRootFromParent_Done,
     /*   87805 */   // Label 1409: @87805
     /*   87805 */   GIM_Reject,
     /*   87806 */ // Label 1389: @87806
     /*   87806 */ GIM_Reject,
     /*   87807 */ // Label 1298: @87807
     /*   87807 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(89531),
     /*   87812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   87815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   87818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87822 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(87911), // Rule ID 51648 //
     /*   87827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87838 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87842 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87861 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87863 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87870 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   87870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   87873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87909 */     GIR_RootConstrainSelectedInstOperands,
     /*   87910 */     // GIR_Coverage, 51648,
     /*   87910 */     GIR_EraseRootFromParent_Done,
     /*   87911 */   // Label 1411: @87911
     /*   87911 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(88000), // Rule ID 51649 //
     /*   87916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   87950 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87952 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87959 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   87959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   87962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   87995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87998 */     GIR_RootConstrainSelectedInstOperands,
     /*   87999 */     // GIR_Coverage, 51649,
     /*   87999 */     GIR_EraseRootFromParent_Done,
     /*   88000 */   // Label 1412: @88000
     /*   88000 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(88089), // Rule ID 70570 //
     /*   88005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88020 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88039 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88048 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88087 */     GIR_RootConstrainSelectedInstOperands,
     /*   88088 */     // GIR_Coverage, 70570,
     /*   88088 */     GIR_EraseRootFromParent_Done,
     /*   88089 */   // Label 1413: @88089
     /*   88089 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(88178), // Rule ID 70571 //
     /*   88094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88109 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88128 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88137 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88176 */     GIR_RootConstrainSelectedInstOperands,
     /*   88177 */     // GIR_Coverage, 70571,
     /*   88177 */     GIR_EraseRootFromParent_Done,
     /*   88178 */   // Label 1414: @88178
     /*   88178 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(88267), // Rule ID 70450 //
     /*   88183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88217 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88226 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88265 */     GIR_RootConstrainSelectedInstOperands,
     /*   88266 */     // GIR_Coverage, 70450,
     /*   88266 */     GIR_EraseRootFromParent_Done,
     /*   88267 */   // Label 1415: @88267
     /*   88267 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(88356), // Rule ID 70451 //
     /*   88272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88287 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88315 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88354 */     GIR_RootConstrainSelectedInstOperands,
     /*   88355 */     // GIR_Coverage, 70451,
     /*   88355 */     GIR_EraseRootFromParent_Done,
     /*   88356 */   // Label 1416: @88356
     /*   88356 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(88445), // Rule ID 51828 //
     /*   88361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88395 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88404 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88443 */     GIR_RootConstrainSelectedInstOperands,
     /*   88444 */     // GIR_Coverage, 51828,
     /*   88444 */     GIR_EraseRootFromParent_Done,
     /*   88445 */   // Label 1417: @88445
     /*   88445 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(88534), // Rule ID 51829 //
     /*   88450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88465 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88484 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88493 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88532 */     GIR_RootConstrainSelectedInstOperands,
     /*   88533 */     // GIR_Coverage, 51829,
     /*   88533 */     GIR_EraseRootFromParent_Done,
     /*   88534 */   // Label 1418: @88534
     /*   88534 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(88623), // Rule ID 51528 //
     /*   88539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88554 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88573 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88582 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88621 */     GIR_RootConstrainSelectedInstOperands,
     /*   88622 */     // GIR_Coverage, 51528,
     /*   88622 */     GIR_EraseRootFromParent_Done,
     /*   88623 */   // Label 1419: @88623
     /*   88623 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(88712), // Rule ID 51529 //
     /*   88628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88662 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88671 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88710 */     GIR_RootConstrainSelectedInstOperands,
     /*   88711 */     // GIR_Coverage, 51529,
     /*   88711 */     GIR_EraseRootFromParent_Done,
     /*   88712 */   // Label 1420: @88712
     /*   88712 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(88801), // Rule ID 51768 //
     /*   88717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88732 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88751 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88760 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88799 */     GIR_RootConstrainSelectedInstOperands,
     /*   88800 */     // GIR_Coverage, 51768,
     /*   88800 */     GIR_EraseRootFromParent_Done,
     /*   88801 */   // Label 1421: @88801
     /*   88801 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(88890), // Rule ID 51769 //
     /*   88806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88840 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88849 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88888 */     GIR_RootConstrainSelectedInstOperands,
     /*   88889 */     // GIR_Coverage, 51769,
     /*   88889 */     GIR_EraseRootFromParent_Done,
     /*   88890 */   // Label 1422: @88890
     /*   88890 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(88979), // Rule ID 51708 //
     /*   88895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88910 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88929 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88938 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   88941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88977 */     GIR_RootConstrainSelectedInstOperands,
     /*   88978 */     // GIR_Coverage, 51708,
     /*   88978 */     GIR_EraseRootFromParent_Done,
     /*   88979 */   // Label 1423: @88979
     /*   88979 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(89068), // Rule ID 51709 //
     /*   88984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   88999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89027 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89066 */     GIR_RootConstrainSelectedInstOperands,
     /*   89067 */     // GIR_Coverage, 51709,
     /*   89067 */     GIR_EraseRootFromParent_Done,
     /*   89068 */   // Label 1424: @89068
     /*   89068 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(89157), // Rule ID 70510 //
     /*   89073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89088 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89107 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89116 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89155 */     GIR_RootConstrainSelectedInstOperands,
     /*   89156 */     // GIR_Coverage, 70510,
     /*   89156 */     GIR_EraseRootFromParent_Done,
     /*   89157 */   // Label 1425: @89157
     /*   89157 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(89246), // Rule ID 70511 //
     /*   89162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89177 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89196 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89205 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   89222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89244 */     GIR_RootConstrainSelectedInstOperands,
     /*   89245 */     // GIR_Coverage, 70511,
     /*   89245 */     GIR_EraseRootFromParent_Done,
     /*   89246 */   // Label 1426: @89246
     /*   89246 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(89335), // Rule ID 51588 //
     /*   89251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89266 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89285 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89294 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89333 */     GIR_RootConstrainSelectedInstOperands,
     /*   89334 */     // GIR_Coverage, 51588,
     /*   89334 */     GIR_EraseRootFromParent_Done,
     /*   89335 */   // Label 1427: @89335
     /*   89335 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(89424), // Rule ID 51589 //
     /*   89340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89355 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   89374 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89383 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   89400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89422 */     GIR_RootConstrainSelectedInstOperands,
     /*   89423 */     // GIR_Coverage, 51589,
     /*   89423 */     GIR_EraseRootFromParent_Done,
     /*   89424 */   // Label 1428: @89424
     /*   89424 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(89477), // Rule ID 50886 //
     /*   89429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89440 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89475 */     GIR_RootConstrainSelectedInstOperands,
     /*   89476 */     // GIR_Coverage, 50886,
     /*   89476 */     GIR_EraseRootFromParent_Done,
     /*   89477 */   // Label 1429: @89477
     /*   89477 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(89530), // Rule ID 50887 //
     /*   89482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89493 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   89496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   89510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   89517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   89519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89528 */     GIR_RootConstrainSelectedInstOperands,
     /*   89529 */     // GIR_Coverage, 50887,
     /*   89529 */     GIR_EraseRootFromParent_Done,
     /*   89530 */   // Label 1430: @89530
     /*   89530 */   GIM_Reject,
     /*   89531 */ // Label 1410: @89531
     /*   89531 */ GIM_Reject,
     /*   89532 */ // Label 1299: @89532
     /*   89532 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91256),
     /*   89537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   89540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   89543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   89547 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(89636), // Rule ID 51668 //
     /*   89552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89567 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89586 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89595 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89634 */     GIR_RootConstrainSelectedInstOperands,
     /*   89635 */     // GIR_Coverage, 51668,
     /*   89635 */     GIR_EraseRootFromParent_Done,
     /*   89636 */   // Label 1432: @89636
     /*   89636 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(89725), // Rule ID 51669 //
     /*   89641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   89644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89675 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89684 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89723 */     GIR_RootConstrainSelectedInstOperands,
     /*   89724 */     // GIR_Coverage, 51669,
     /*   89724 */     GIR_EraseRootFromParent_Done,
     /*   89725 */   // Label 1433: @89725
     /*   89725 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(89814), // Rule ID 70590 //
     /*   89730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89745 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89764 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89773 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89812 */     GIR_RootConstrainSelectedInstOperands,
     /*   89813 */     // GIR_Coverage, 70590,
     /*   89813 */     GIR_EraseRootFromParent_Done,
     /*   89814 */   // Label 1434: @89814
     /*   89814 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(89903), // Rule ID 70591 //
     /*   89819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   89822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89853 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89862 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   89862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89901 */     GIR_RootConstrainSelectedInstOperands,
     /*   89902 */     // GIR_Coverage, 70591,
     /*   89902 */     GIR_EraseRootFromParent_Done,
     /*   89903 */   // Label 1435: @89903
     /*   89903 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(89992), // Rule ID 70470 //
     /*   89908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   89911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89923 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   89942 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89951 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   89951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   89954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   89987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89990 */     GIR_RootConstrainSelectedInstOperands,
     /*   89991 */     // GIR_Coverage, 70470,
     /*   89991 */     GIR_EraseRootFromParent_Done,
     /*   89992 */   // Label 1436: @89992
     /*   89992 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(90081), // Rule ID 70471 //
     /*   89997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90012 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90031 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90040 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90079 */     GIR_RootConstrainSelectedInstOperands,
     /*   90080 */     // GIR_Coverage, 70471,
     /*   90080 */     GIR_EraseRootFromParent_Done,
     /*   90081 */   // Label 1437: @90081
     /*   90081 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(90170), // Rule ID 51848 //
     /*   90086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90101 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90120 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90129 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90168 */     GIR_RootConstrainSelectedInstOperands,
     /*   90169 */     // GIR_Coverage, 51848,
     /*   90169 */     GIR_EraseRootFromParent_Done,
     /*   90170 */   // Label 1438: @90170
     /*   90170 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(90259), // Rule ID 51849 //
     /*   90175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90209 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90218 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90257 */     GIR_RootConstrainSelectedInstOperands,
     /*   90258 */     // GIR_Coverage, 51849,
     /*   90258 */     GIR_EraseRootFromParent_Done,
     /*   90259 */   // Label 1439: @90259
     /*   90259 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(90348), // Rule ID 51548 //
     /*   90264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90279 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90298 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90300 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90307 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90346 */     GIR_RootConstrainSelectedInstOperands,
     /*   90347 */     // GIR_Coverage, 51548,
     /*   90347 */     GIR_EraseRootFromParent_Done,
     /*   90348 */   // Label 1440: @90348
     /*   90348 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(90437), // Rule ID 51549 //
     /*   90353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90368 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90387 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90396 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   90413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90435 */     GIR_RootConstrainSelectedInstOperands,
     /*   90436 */     // GIR_Coverage, 51549,
     /*   90436 */     GIR_EraseRootFromParent_Done,
     /*   90437 */   // Label 1441: @90437
     /*   90437 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(90526), // Rule ID 51788 //
     /*   90442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90457 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90485 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90524 */     GIR_RootConstrainSelectedInstOperands,
     /*   90525 */     // GIR_Coverage, 51788,
     /*   90525 */     GIR_EraseRootFromParent_Done,
     /*   90526 */   // Label 1442: @90526
     /*   90526 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(90615), // Rule ID 51789 //
     /*   90531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90574 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90613 */     GIR_RootConstrainSelectedInstOperands,
     /*   90614 */     // GIR_Coverage, 51789,
     /*   90614 */     GIR_EraseRootFromParent_Done,
     /*   90615 */   // Label 1443: @90615
     /*   90615 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(90704), // Rule ID 51728 //
     /*   90620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90635 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90654 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90663 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90702 */     GIR_RootConstrainSelectedInstOperands,
     /*   90703 */     // GIR_Coverage, 51728,
     /*   90703 */     GIR_EraseRootFromParent_Done,
     /*   90704 */   // Label 1444: @90704
     /*   90704 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(90793), // Rule ID 51729 //
     /*   90709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90743 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90752 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90791 */     GIR_RootConstrainSelectedInstOperands,
     /*   90792 */     // GIR_Coverage, 51729,
     /*   90792 */     GIR_EraseRootFromParent_Done,
     /*   90793 */   // Label 1445: @90793
     /*   90793 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(90882), // Rule ID 70530 //
     /*   90798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90813 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90832 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90841 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90880 */     GIR_RootConstrainSelectedInstOperands,
     /*   90881 */     // GIR_Coverage, 70530,
     /*   90881 */     GIR_EraseRootFromParent_Done,
     /*   90882 */   // Label 1446: @90882
     /*   90882 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(90971), // Rule ID 70531 //
     /*   90887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90921 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90930 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   90933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90969 */     GIR_RootConstrainSelectedInstOperands,
     /*   90970 */     // GIR_Coverage, 70531,
     /*   90970 */     GIR_EraseRootFromParent_Done,
     /*   90971 */   // Label 1447: @90971
     /*   90971 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(91060), // Rule ID 51608 //
     /*   90976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   90991 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91010 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91019 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91058 */     GIR_RootConstrainSelectedInstOperands,
     /*   91059 */     // GIR_Coverage, 51608,
     /*   91059 */     GIR_EraseRootFromParent_Done,
     /*   91060 */   // Label 1448: @91060
     /*   91060 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(91149), // Rule ID 51609 //
     /*   91065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91080 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   91099 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91108 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   91125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91147 */     GIR_RootConstrainSelectedInstOperands,
     /*   91148 */     // GIR_Coverage, 51609,
     /*   91148 */     GIR_EraseRootFromParent_Done,
     /*   91149 */   // Label 1449: @91149
     /*   91149 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(91202), // Rule ID 50930 //
     /*   91154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   91157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91165 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   91165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91200 */     GIR_RootConstrainSelectedInstOperands,
     /*   91201 */     // GIR_Coverage, 50930,
     /*   91201 */     GIR_EraseRootFromParent_Done,
     /*   91202 */   // Label 1450: @91202
     /*   91202 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(91255), // Rule ID 50931 //
     /*   91207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   91210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91218 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   91218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   91221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   91235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   91250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91253 */     GIR_RootConstrainSelectedInstOperands,
     /*   91254 */     // GIR_Coverage, 50931,
     /*   91254 */     GIR_EraseRootFromParent_Done,
     /*   91255 */   // Label 1451: @91255
     /*   91255 */   GIM_Reject,
     /*   91256 */ // Label 1431: @91256
     /*   91256 */ GIM_Reject,
     /*   91257 */ // Label 1300: @91257
     /*   91257 */ GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(91371),
     /*   91262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   91268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91280 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(91325), // Rule ID 50862 //
     /*   91285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91288 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91323 */     GIR_RootConstrainSelectedInstOperands,
     /*   91324 */     // GIR_Coverage, 50862,
     /*   91324 */     GIR_EraseRootFromParent_Done,
     /*   91325 */   // Label 1453: @91325
     /*   91325 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(91370), // Rule ID 50863 //
     /*   91330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91333 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   91336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   91350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   91357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   91359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91368 */     GIR_RootConstrainSelectedInstOperands,
     /*   91369 */     // GIR_Coverage, 50863,
     /*   91369 */     GIR_EraseRootFromParent_Done,
     /*   91370 */   // Label 1454: @91370
     /*   91370 */   GIM_Reject,
     /*   91371 */ // Label 1452: @91371
     /*   91371 */ GIM_Reject,
     /*   91372 */ // Label 1301: @91372
     /*   91372 */ GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93096),
     /*   91377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   91380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   91383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91387 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(91476), // Rule ID 51628 //
     /*   91392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91407 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91426 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91435 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91474 */     GIR_RootConstrainSelectedInstOperands,
     /*   91475 */     // GIR_Coverage, 51628,
     /*   91475 */     GIR_EraseRootFromParent_Done,
     /*   91476 */   // Label 1456: @91476
     /*   91476 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(91565), // Rule ID 51629 //
     /*   91481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91511 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91515 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91524 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91563 */     GIR_RootConstrainSelectedInstOperands,
     /*   91564 */     // GIR_Coverage, 51629,
     /*   91564 */     GIR_EraseRootFromParent_Done,
     /*   91565 */   // Label 1457: @91565
     /*   91565 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(91654), // Rule ID 70550 //
     /*   91570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91585 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91604 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91613 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91652 */     GIR_RootConstrainSelectedInstOperands,
     /*   91653 */     // GIR_Coverage, 70550,
     /*   91653 */     GIR_EraseRootFromParent_Done,
     /*   91654 */   // Label 1458: @91654
     /*   91654 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(91743), // Rule ID 70551 //
     /*   91659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91674 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91693 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91702 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91741 */     GIR_RootConstrainSelectedInstOperands,
     /*   91742 */     // GIR_Coverage, 70551,
     /*   91742 */     GIR_EraseRootFromParent_Done,
     /*   91743 */   // Label 1459: @91743
     /*   91743 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(91832), // Rule ID 70430 //
     /*   91748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91763 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91782 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91791 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91830 */     GIR_RootConstrainSelectedInstOperands,
     /*   91831 */     // GIR_Coverage, 70430,
     /*   91831 */     GIR_EraseRootFromParent_Done,
     /*   91832 */   // Label 1460: @91832
     /*   91832 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(91921), // Rule ID 70431 //
     /*   91837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   91840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91871 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91880 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   91880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   91897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91919 */     GIR_RootConstrainSelectedInstOperands,
     /*   91920 */     // GIR_Coverage, 70431,
     /*   91920 */     GIR_EraseRootFromParent_Done,
     /*   91921 */   // Label 1461: @91921
     /*   91921 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(92010), // Rule ID 51808 //
     /*   91926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   91929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91941 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   91960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   91967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91969 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   91969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   91972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   91986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92008 */     GIR_RootConstrainSelectedInstOperands,
     /*   92009 */     // GIR_Coverage, 51808,
     /*   92009 */     GIR_EraseRootFromParent_Done,
     /*   92010 */   // Label 1462: @92010
     /*   92010 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(92099), // Rule ID 51809 //
     /*   92015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92049 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92058 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92097 */     GIR_RootConstrainSelectedInstOperands,
     /*   92098 */     // GIR_Coverage, 51809,
     /*   92098 */     GIR_EraseRootFromParent_Done,
     /*   92099 */   // Label 1463: @92099
     /*   92099 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(92188), // Rule ID 51508 //
     /*   92104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92119 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92138 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92147 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92186 */     GIR_RootConstrainSelectedInstOperands,
     /*   92187 */     // GIR_Coverage, 51508,
     /*   92187 */     GIR_EraseRootFromParent_Done,
     /*   92188 */   // Label 1464: @92188
     /*   92188 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(92277), // Rule ID 51509 //
     /*   92193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92227 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92236 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   92253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92275 */     GIR_RootConstrainSelectedInstOperands,
     /*   92276 */     // GIR_Coverage, 51509,
     /*   92276 */     GIR_EraseRootFromParent_Done,
     /*   92277 */   // Label 1465: @92277
     /*   92277 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(92366), // Rule ID 51748 //
     /*   92282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92297 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92325 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92364 */     GIR_RootConstrainSelectedInstOperands,
     /*   92365 */     // GIR_Coverage, 51748,
     /*   92365 */     GIR_EraseRootFromParent_Done,
     /*   92366 */   // Label 1466: @92366
     /*   92366 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(92455), // Rule ID 51749 //
     /*   92371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92386 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92405 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92414 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92453 */     GIR_RootConstrainSelectedInstOperands,
     /*   92454 */     // GIR_Coverage, 51749,
     /*   92454 */     GIR_EraseRootFromParent_Done,
     /*   92455 */   // Label 1467: @92455
     /*   92455 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(92544), // Rule ID 51688 //
     /*   92460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92494 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92503 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92542 */     GIR_RootConstrainSelectedInstOperands,
     /*   92543 */     // GIR_Coverage, 51688,
     /*   92543 */     GIR_EraseRootFromParent_Done,
     /*   92544 */   // Label 1468: @92544
     /*   92544 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(92633), // Rule ID 51689 //
     /*   92549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92592 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92631 */     GIR_RootConstrainSelectedInstOperands,
     /*   92632 */     // GIR_Coverage, 51689,
     /*   92632 */     GIR_EraseRootFromParent_Done,
     /*   92633 */   // Label 1469: @92633
     /*   92633 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(92722), // Rule ID 70490 //
     /*   92638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92681 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92720 */     GIR_RootConstrainSelectedInstOperands,
     /*   92721 */     // GIR_Coverage, 70490,
     /*   92721 */     GIR_EraseRootFromParent_Done,
     /*   92722 */   // Label 1470: @92722
     /*   92722 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(92811), // Rule ID 70491 //
     /*   92727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92770 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   92787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92809 */     GIR_RootConstrainSelectedInstOperands,
     /*   92810 */     // GIR_Coverage, 70491,
     /*   92810 */     GIR_EraseRootFromParent_Done,
     /*   92811 */   // Label 1471: @92811
     /*   92811 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(92900), // Rule ID 51568 //
     /*   92816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92859 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92898 */     GIR_RootConstrainSelectedInstOperands,
     /*   92899 */     // GIR_Coverage, 51568,
     /*   92899 */     GIR_EraseRootFromParent_Done,
     /*   92900 */   // Label 1472: @92900
     /*   92900 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(92989), // Rule ID 51569 //
     /*   92905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   92939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92948 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   92951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   92965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92987 */     GIR_RootConstrainSelectedInstOperands,
     /*   92988 */     // GIR_Coverage, 51569,
     /*   92988 */     GIR_EraseRootFromParent_Done,
     /*   92989 */   // Label 1473: @92989
     /*   92989 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93042), // Rule ID 50882 //
     /*   92994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93005 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93040 */     GIR_RootConstrainSelectedInstOperands,
     /*   93041 */     // GIR_Coverage, 50882,
     /*   93041 */     GIR_EraseRootFromParent_Done,
     /*   93042 */   // Label 1474: @93042
     /*   93042 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93095), // Rule ID 50883 //
     /*   93047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93058 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   93061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   93075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   93082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   93084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93093 */     GIR_RootConstrainSelectedInstOperands,
     /*   93094 */     // GIR_Coverage, 50883,
     /*   93094 */     GIR_EraseRootFromParent_Done,
     /*   93095 */   // Label 1475: @93095
     /*   93095 */   GIM_Reject,
     /*   93096 */ // Label 1455: @93096
     /*   93096 */ GIM_Reject,
     /*   93097 */ // Label 1302: @93097
     /*   93097 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(94821),
     /*   93102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   93105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   93108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   93112 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93201), // Rule ID 51652 //
     /*   93117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93132 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93151 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93160 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93199 */     GIR_RootConstrainSelectedInstOperands,
     /*   93200 */     // GIR_Coverage, 51652,
     /*   93200 */     GIR_EraseRootFromParent_Done,
     /*   93201 */   // Label 1477: @93201
     /*   93201 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93290), // Rule ID 51653 //
     /*   93206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93221 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93240 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93249 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93288 */     GIR_RootConstrainSelectedInstOperands,
     /*   93289 */     // GIR_Coverage, 51653,
     /*   93289 */     GIR_EraseRootFromParent_Done,
     /*   93290 */   // Label 1478: @93290
     /*   93290 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93379), // Rule ID 70574 //
     /*   93295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93310 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93329 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93338 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93377 */     GIR_RootConstrainSelectedInstOperands,
     /*   93378 */     // GIR_Coverage, 70574,
     /*   93378 */     GIR_EraseRootFromParent_Done,
     /*   93379 */   // Label 1479: @93379
     /*   93379 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93468), // Rule ID 70575 //
     /*   93384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93399 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93418 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93427 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93466 */     GIR_RootConstrainSelectedInstOperands,
     /*   93467 */     // GIR_Coverage, 70575,
     /*   93467 */     GIR_EraseRootFromParent_Done,
     /*   93468 */   // Label 1480: @93468
     /*   93468 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(93557), // Rule ID 70454 //
     /*   93473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93516 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93555 */     GIR_RootConstrainSelectedInstOperands,
     /*   93556 */     // GIR_Coverage, 70454,
     /*   93556 */     GIR_EraseRootFromParent_Done,
     /*   93557 */   // Label 1481: @93557
     /*   93557 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(93646), // Rule ID 70455 //
     /*   93562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93596 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93605 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93644 */     GIR_RootConstrainSelectedInstOperands,
     /*   93645 */     // GIR_Coverage, 70455,
     /*   93645 */     GIR_EraseRootFromParent_Done,
     /*   93646 */   // Label 1482: @93646
     /*   93646 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(93735), // Rule ID 51832 //
     /*   93651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93685 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93694 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93733 */     GIR_RootConstrainSelectedInstOperands,
     /*   93734 */     // GIR_Coverage, 51832,
     /*   93734 */     GIR_EraseRootFromParent_Done,
     /*   93735 */   // Label 1483: @93735
     /*   93735 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(93824), // Rule ID 51833 //
     /*   93740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93755 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93774 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93783 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93822 */     GIR_RootConstrainSelectedInstOperands,
     /*   93823 */     // GIR_Coverage, 51833,
     /*   93823 */     GIR_EraseRootFromParent_Done,
     /*   93824 */   // Label 1484: @93824
     /*   93824 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(93913), // Rule ID 51532 //
     /*   93829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93863 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93872 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   93872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93911 */     GIR_RootConstrainSelectedInstOperands,
     /*   93912 */     // GIR_Coverage, 51532,
     /*   93912 */     GIR_EraseRootFromParent_Done,
     /*   93913 */   // Label 1485: @93913
     /*   93913 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(94002), // Rule ID 51533 //
     /*   93918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93933 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   93952 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93961 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   93961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   93964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   93997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94000 */     GIR_RootConstrainSelectedInstOperands,
     /*   94001 */     // GIR_Coverage, 51533,
     /*   94001 */     GIR_EraseRootFromParent_Done,
     /*   94002 */   // Label 1486: @94002
     /*   94002 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94091), // Rule ID 51772 //
     /*   94007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94041 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94050 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94089 */     GIR_RootConstrainSelectedInstOperands,
     /*   94090 */     // GIR_Coverage, 51772,
     /*   94090 */     GIR_EraseRootFromParent_Done,
     /*   94091 */   // Label 1487: @94091
     /*   94091 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94180), // Rule ID 51773 //
     /*   94096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94130 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94139 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94178 */     GIR_RootConstrainSelectedInstOperands,
     /*   94179 */     // GIR_Coverage, 51773,
     /*   94179 */     GIR_EraseRootFromParent_Done,
     /*   94180 */   // Label 1488: @94180
     /*   94180 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94269), // Rule ID 51712 //
     /*   94185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94200 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94219 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94228 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94267 */     GIR_RootConstrainSelectedInstOperands,
     /*   94268 */     // GIR_Coverage, 51712,
     /*   94268 */     GIR_EraseRootFromParent_Done,
     /*   94269 */   // Label 1489: @94269
     /*   94269 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94358), // Rule ID 51713 //
     /*   94274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94289 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94308 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94317 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94356 */     GIR_RootConstrainSelectedInstOperands,
     /*   94357 */     // GIR_Coverage, 51713,
     /*   94357 */     GIR_EraseRootFromParent_Done,
     /*   94358 */   // Label 1490: @94358
     /*   94358 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94447), // Rule ID 70514 //
     /*   94363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94397 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94406 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94445 */     GIR_RootConstrainSelectedInstOperands,
     /*   94446 */     // GIR_Coverage, 70514,
     /*   94446 */     GIR_EraseRootFromParent_Done,
     /*   94447 */   // Label 1491: @94447
     /*   94447 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94536), // Rule ID 70515 //
     /*   94452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94467 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94486 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94495 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   94512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94534 */     GIR_RootConstrainSelectedInstOperands,
     /*   94535 */     // GIR_Coverage, 70515,
     /*   94535 */     GIR_EraseRootFromParent_Done,
     /*   94536 */   // Label 1492: @94536
     /*   94536 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94625), // Rule ID 51592 //
     /*   94541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94575 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94584 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94623 */     GIR_RootConstrainSelectedInstOperands,
     /*   94624 */     // GIR_Coverage, 51592,
     /*   94624 */     GIR_EraseRootFromParent_Done,
     /*   94625 */   // Label 1493: @94625
     /*   94625 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(94714), // Rule ID 51593 //
     /*   94630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94645 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   94664 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94673 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94712 */     GIR_RootConstrainSelectedInstOperands,
     /*   94713 */     // GIR_Coverage, 51593,
     /*   94713 */     GIR_EraseRootFromParent_Done,
     /*   94714 */   // Label 1494: @94714
     /*   94714 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(94767), // Rule ID 50918 //
     /*   94719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94730 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   94730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94765 */     GIR_RootConstrainSelectedInstOperands,
     /*   94766 */     // GIR_Coverage, 50918,
     /*   94766 */     GIR_EraseRootFromParent_Done,
     /*   94767 */   // Label 1495: @94767
     /*   94767 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(94820), // Rule ID 50919 //
     /*   94772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94783 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   94783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   94786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94818 */     GIR_RootConstrainSelectedInstOperands,
     /*   94819 */     // GIR_Coverage, 50919,
     /*   94819 */     GIR_EraseRootFromParent_Done,
     /*   94820 */   // Label 1496: @94820
     /*   94820 */   GIM_Reject,
     /*   94821 */ // Label 1476: @94821
     /*   94821 */ GIM_Reject,
     /*   94822 */ // Label 1303: @94822
     /*   94822 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(96546),
     /*   94827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   94830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   94833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   94837 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(94926), // Rule ID 51672 //
     /*   94842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   94845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94857 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94876 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94885 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   94885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   94888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   94921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94924 */     GIR_RootConstrainSelectedInstOperands,
     /*   94925 */     // GIR_Coverage, 51672,
     /*   94925 */     GIR_EraseRootFromParent_Done,
     /*   94926 */   // Label 1498: @94926
     /*   94926 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95015), // Rule ID 51673 //
     /*   94931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   94934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94961 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   94965 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94974 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   94974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   94977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95013 */     GIR_RootConstrainSelectedInstOperands,
     /*   95014 */     // GIR_Coverage, 51673,
     /*   95014 */     GIR_EraseRootFromParent_Done,
     /*   95015 */   // Label 1499: @95015
     /*   95015 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95104), // Rule ID 70594 //
     /*   95020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95035 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95054 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95063 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95102 */     GIR_RootConstrainSelectedInstOperands,
     /*   95103 */     // GIR_Coverage, 70594,
     /*   95103 */     GIR_EraseRootFromParent_Done,
     /*   95104 */   // Label 1500: @95104
     /*   95104 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95193), // Rule ID 70595 //
     /*   95109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95124 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95143 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95152 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95191 */     GIR_RootConstrainSelectedInstOperands,
     /*   95192 */     // GIR_Coverage, 70595,
     /*   95192 */     GIR_EraseRootFromParent_Done,
     /*   95193 */   // Label 1501: @95193
     /*   95193 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95282), // Rule ID 70474 //
     /*   95198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95213 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95232 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95241 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95280 */     GIR_RootConstrainSelectedInstOperands,
     /*   95281 */     // GIR_Coverage, 70474,
     /*   95281 */     GIR_EraseRootFromParent_Done,
     /*   95282 */   // Label 1502: @95282
     /*   95282 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(95371), // Rule ID 70475 //
     /*   95287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95302 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95321 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95330 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95369 */     GIR_RootConstrainSelectedInstOperands,
     /*   95370 */     // GIR_Coverage, 70475,
     /*   95370 */     GIR_EraseRootFromParent_Done,
     /*   95371 */   // Label 1503: @95371
     /*   95371 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(95460), // Rule ID 51852 //
     /*   95376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95391 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95410 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95419 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95458 */     GIR_RootConstrainSelectedInstOperands,
     /*   95459 */     // GIR_Coverage, 51852,
     /*   95459 */     GIR_EraseRootFromParent_Done,
     /*   95460 */   // Label 1504: @95460
     /*   95460 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(95549), // Rule ID 51853 //
     /*   95465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95480 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95499 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95508 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95547 */     GIR_RootConstrainSelectedInstOperands,
     /*   95548 */     // GIR_Coverage, 51853,
     /*   95548 */     GIR_EraseRootFromParent_Done,
     /*   95549 */   // Label 1505: @95549
     /*   95549 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(95638), // Rule ID 51552 //
     /*   95554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95569 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95588 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95597 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95636 */     GIR_RootConstrainSelectedInstOperands,
     /*   95637 */     // GIR_Coverage, 51552,
     /*   95637 */     GIR_EraseRootFromParent_Done,
     /*   95638 */   // Label 1506: @95638
     /*   95638 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(95727), // Rule ID 51553 //
     /*   95643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95658 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95677 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95686 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95725 */     GIR_RootConstrainSelectedInstOperands,
     /*   95726 */     // GIR_Coverage, 51553,
     /*   95726 */     GIR_EraseRootFromParent_Done,
     /*   95727 */   // Label 1507: @95727
     /*   95727 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(95816), // Rule ID 51792 //
     /*   95732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95747 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95775 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95814 */     GIR_RootConstrainSelectedInstOperands,
     /*   95815 */     // GIR_Coverage, 51792,
     /*   95815 */     GIR_EraseRootFromParent_Done,
     /*   95816 */   // Label 1508: @95816
     /*   95816 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(95905), // Rule ID 51793 //
     /*   95821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   95824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95864 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95903 */     GIR_RootConstrainSelectedInstOperands,
     /*   95904 */     // GIR_Coverage, 51793,
     /*   95904 */     GIR_EraseRootFromParent_Done,
     /*   95905 */   // Label 1509: @95905
     /*   95905 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(95994), // Rule ID 51732 //
     /*   95910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   95913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95925 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   95944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95953 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   95956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95992 */     GIR_RootConstrainSelectedInstOperands,
     /*   95993 */     // GIR_Coverage, 51732,
     /*   95993 */     GIR_EraseRootFromParent_Done,
     /*   95994 */   // Label 1510: @95994
     /*   95994 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96083), // Rule ID 51733 //
     /*   95999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96033 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96042 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96081 */     GIR_RootConstrainSelectedInstOperands,
     /*   96082 */     // GIR_Coverage, 51733,
     /*   96082 */     GIR_EraseRootFromParent_Done,
     /*   96083 */   // Label 1511: @96083
     /*   96083 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96172), // Rule ID 70534 //
     /*   96088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96103 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96122 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96131 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96170 */     GIR_RootConstrainSelectedInstOperands,
     /*   96171 */     // GIR_Coverage, 70534,
     /*   96171 */     GIR_EraseRootFromParent_Done,
     /*   96172 */   // Label 1512: @96172
     /*   96172 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96261), // Rule ID 70535 //
     /*   96177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96192 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96211 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96220 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   96237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96259 */     GIR_RootConstrainSelectedInstOperands,
     /*   96260 */     // GIR_Coverage, 70535,
     /*   96260 */     GIR_EraseRootFromParent_Done,
     /*   96261 */   // Label 1513: @96261
     /*   96261 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96350), // Rule ID 51612 //
     /*   96266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96281 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96300 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96309 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96348 */     GIR_RootConstrainSelectedInstOperands,
     /*   96349 */     // GIR_Coverage, 51612,
     /*   96349 */     GIR_EraseRootFromParent_Done,
     /*   96350 */   // Label 1514: @96350
     /*   96350 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(96439), // Rule ID 51613 //
     /*   96355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96370 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   96389 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96398 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   96415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96437 */     GIR_RootConstrainSelectedInstOperands,
     /*   96438 */     // GIR_Coverage, 51613,
     /*   96438 */     GIR_EraseRootFromParent_Done,
     /*   96439 */   // Label 1515: @96439
     /*   96439 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(96492), // Rule ID 50934 //
     /*   96444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   96447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96455 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   96455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96490 */     GIR_RootConstrainSelectedInstOperands,
     /*   96491 */     // GIR_Coverage, 50934,
     /*   96491 */     GIR_EraseRootFromParent_Done,
     /*   96492 */   // Label 1516: @96492
     /*   96492 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(96545), // Rule ID 50935 //
     /*   96497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   96500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96508 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   96508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   96511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   96525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   96540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96543 */     GIR_RootConstrainSelectedInstOperands,
     /*   96544 */     // GIR_Coverage, 50935,
     /*   96544 */     GIR_EraseRootFromParent_Done,
     /*   96545 */   // Label 1517: @96545
     /*   96545 */   GIM_Reject,
     /*   96546 */ // Label 1497: @96546
     /*   96546 */ GIM_Reject,
     /*   96547 */ // Label 1304: @96547
     /*   96547 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(96661),
     /*   96552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   96558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96570 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(96615), // Rule ID 50878 //
     /*   96575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96578 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   96581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   96595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96613 */     GIR_RootConstrainSelectedInstOperands,
     /*   96614 */     // GIR_Coverage, 50878,
     /*   96614 */     GIR_EraseRootFromParent_Done,
     /*   96615 */   // Label 1519: @96615
     /*   96615 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(96660), // Rule ID 50879 //
     /*   96620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96623 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   96626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   96640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   96647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   96649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96658 */     GIR_RootConstrainSelectedInstOperands,
     /*   96659 */     // GIR_Coverage, 50879,
     /*   96659 */     GIR_EraseRootFromParent_Done,
     /*   96660 */   // Label 1520: @96660
     /*   96660 */   GIM_Reject,
     /*   96661 */ // Label 1518: @96661
     /*   96661 */ GIM_Reject,
     /*   96662 */ // Label 1305: @96662
     /*   96662 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(98386),
     /*   96667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   96670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   96673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   96677 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(96766), // Rule ID 51632 //
     /*   96682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96716 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96725 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   96742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96764 */     GIR_RootConstrainSelectedInstOperands,
     /*   96765 */     // GIR_Coverage, 51632,
     /*   96765 */     GIR_EraseRootFromParent_Done,
     /*   96766 */   // Label 1522: @96766
     /*   96766 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(96855), // Rule ID 51633 //
     /*   96771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96805 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96814 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   96831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96853 */     GIR_RootConstrainSelectedInstOperands,
     /*   96854 */     // GIR_Coverage, 51633,
     /*   96854 */     GIR_EraseRootFromParent_Done,
     /*   96855 */   // Label 1523: @96855
     /*   96855 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(96944), // Rule ID 70554 //
     /*   96860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   96863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96875 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96894 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96903 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   96903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   96920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96942 */     GIR_RootConstrainSelectedInstOperands,
     /*   96943 */     // GIR_Coverage, 70554,
     /*   96943 */     GIR_EraseRootFromParent_Done,
     /*   96944 */   // Label 1524: @96944
     /*   96944 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(97033), // Rule ID 70555 //
     /*   96949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   96952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96964 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   96983 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   96990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96992 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   96992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   96995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97031 */     GIR_RootConstrainSelectedInstOperands,
     /*   97032 */     // GIR_Coverage, 70555,
     /*   97032 */     GIR_EraseRootFromParent_Done,
     /*   97033 */   // Label 1525: @97033
     /*   97033 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97122), // Rule ID 70434 //
     /*   97038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97072 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97074 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97081 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97120 */     GIR_RootConstrainSelectedInstOperands,
     /*   97121 */     // GIR_Coverage, 70434,
     /*   97121 */     GIR_EraseRootFromParent_Done,
     /*   97122 */   // Label 1526: @97122
     /*   97122 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(97211), // Rule ID 70435 //
     /*   97127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97142 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97161 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97163 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97170 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97209 */     GIR_RootConstrainSelectedInstOperands,
     /*   97210 */     // GIR_Coverage, 70435,
     /*   97210 */     GIR_EraseRootFromParent_Done,
     /*   97211 */   // Label 1527: @97211
     /*   97211 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(97300), // Rule ID 51812 //
     /*   97216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97250 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97259 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97298 */     GIR_RootConstrainSelectedInstOperands,
     /*   97299 */     // GIR_Coverage, 51812,
     /*   97299 */     GIR_EraseRootFromParent_Done,
     /*   97300 */   // Label 1528: @97300
     /*   97300 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(97389), // Rule ID 51813 //
     /*   97305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97320 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97339 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97348 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97387 */     GIR_RootConstrainSelectedInstOperands,
     /*   97388 */     // GIR_Coverage, 51813,
     /*   97388 */     GIR_EraseRootFromParent_Done,
     /*   97389 */   // Label 1529: @97389
     /*   97389 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(97478), // Rule ID 51512 //
     /*   97394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97409 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97428 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97437 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97476 */     GIR_RootConstrainSelectedInstOperands,
     /*   97477 */     // GIR_Coverage, 51512,
     /*   97477 */     GIR_EraseRootFromParent_Done,
     /*   97478 */   // Label 1530: @97478
     /*   97478 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(97567), // Rule ID 51513 //
     /*   97483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97498 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97517 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97526 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   97543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97565 */     GIR_RootConstrainSelectedInstOperands,
     /*   97566 */     // GIR_Coverage, 51513,
     /*   97566 */     GIR_EraseRootFromParent_Done,
     /*   97567 */   // Label 1531: @97567
     /*   97567 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(97656), // Rule ID 51752 //
     /*   97572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97606 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97615 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97654 */     GIR_RootConstrainSelectedInstOperands,
     /*   97655 */     // GIR_Coverage, 51752,
     /*   97655 */     GIR_EraseRootFromParent_Done,
     /*   97656 */   // Label 1532: @97656
     /*   97656 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(97745), // Rule ID 51753 //
     /*   97661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97695 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97704 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97743 */     GIR_RootConstrainSelectedInstOperands,
     /*   97744 */     // GIR_Coverage, 51753,
     /*   97744 */     GIR_EraseRootFromParent_Done,
     /*   97745 */   // Label 1533: @97745
     /*   97745 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(97834), // Rule ID 51692 //
     /*   97750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97784 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97793 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97832 */     GIR_RootConstrainSelectedInstOperands,
     /*   97833 */     // GIR_Coverage, 51692,
     /*   97833 */     GIR_EraseRootFromParent_Done,
     /*   97834 */   // Label 1534: @97834
     /*   97834 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(97923), // Rule ID 51693 //
     /*   97839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97873 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97882 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   97899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97921 */     GIR_RootConstrainSelectedInstOperands,
     /*   97922 */     // GIR_Coverage, 51693,
     /*   97922 */     GIR_EraseRootFromParent_Done,
     /*   97923 */   // Label 1535: @97923
     /*   97923 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98012), // Rule ID 70494 //
     /*   97928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   97962 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   97969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97971 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   97974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   97988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98010 */     GIR_RootConstrainSelectedInstOperands,
     /*   98011 */     // GIR_Coverage, 70494,
     /*   98011 */     GIR_EraseRootFromParent_Done,
     /*   98012 */   // Label 1536: @98012
     /*   98012 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98101), // Rule ID 70495 //
     /*   98017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98051 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98060 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   98077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98099 */     GIR_RootConstrainSelectedInstOperands,
     /*   98100 */     // GIR_Coverage, 70495,
     /*   98100 */     GIR_EraseRootFromParent_Done,
     /*   98101 */   // Label 1537: @98101
     /*   98101 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(98190), // Rule ID 51572 //
     /*   98106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98149 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98188 */     GIR_RootConstrainSelectedInstOperands,
     /*   98189 */     // GIR_Coverage, 51572,
     /*   98189 */     GIR_EraseRootFromParent_Done,
     /*   98190 */   // Label 1538: @98190
     /*   98190 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(98279), // Rule ID 51573 //
     /*   98195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   98229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   98236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98238 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   98255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98277 */     GIR_RootConstrainSelectedInstOperands,
     /*   98278 */     // GIR_Coverage, 51573,
     /*   98278 */     GIR_EraseRootFromParent_Done,
     /*   98279 */   // Label 1539: @98279
     /*   98279 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(98332), // Rule ID 50906 //
     /*   98284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98295 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98330 */     GIR_RootConstrainSelectedInstOperands,
     /*   98331 */     // GIR_Coverage, 50906,
     /*   98331 */     GIR_EraseRootFromParent_Done,
     /*   98332 */   // Label 1540: @98332
     /*   98332 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(98385), // Rule ID 50907 //
     /*   98337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98348 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   98351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   98365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   98372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   98374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98383 */     GIR_RootConstrainSelectedInstOperands,
     /*   98384 */     // GIR_Coverage, 50907,
     /*   98384 */     GIR_EraseRootFromParent_Done,
     /*   98385 */   // Label 1541: @98385
     /*   98385 */   GIM_Reject,
     /*   98386 */ // Label 1521: @98386
     /*   98386 */ GIM_Reject,
     /*   98387 */ // Label 1306: @98387
     /*   98387 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(100111),
     /*   98392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   98395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   98398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   98402 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(98491), // Rule ID 51656 //
     /*   98407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98422 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98441 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98450 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98489 */     GIR_RootConstrainSelectedInstOperands,
     /*   98490 */     // GIR_Coverage, 51656,
     /*   98490 */     GIR_EraseRootFromParent_Done,
     /*   98491 */   // Label 1543: @98491
     /*   98491 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(98580), // Rule ID 51657 //
     /*   98496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98511 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98530 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98539 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98578 */     GIR_RootConstrainSelectedInstOperands,
     /*   98579 */     // GIR_Coverage, 51657,
     /*   98579 */     GIR_EraseRootFromParent_Done,
     /*   98580 */   // Label 1544: @98580
     /*   98580 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(98669), // Rule ID 70578 //
     /*   98585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98600 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98619 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98628 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98667 */     GIR_RootConstrainSelectedInstOperands,
     /*   98668 */     // GIR_Coverage, 70578,
     /*   98668 */     GIR_EraseRootFromParent_Done,
     /*   98669 */   // Label 1545: @98669
     /*   98669 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(98758), // Rule ID 70579 //
     /*   98674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98708 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98717 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98756 */     GIR_RootConstrainSelectedInstOperands,
     /*   98757 */     // GIR_Coverage, 70579,
     /*   98757 */     GIR_EraseRootFromParent_Done,
     /*   98758 */   // Label 1546: @98758
     /*   98758 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(98847), // Rule ID 70458 //
     /*   98763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98778 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98797 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98799 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98806 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98845 */     GIR_RootConstrainSelectedInstOperands,
     /*   98846 */     // GIR_Coverage, 70458,
     /*   98846 */     GIR_EraseRootFromParent_Done,
     /*   98847 */   // Label 1547: @98847
     /*   98847 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(98936), // Rule ID 70459 //
     /*   98852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98867 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98895 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   98895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   98931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98934 */     GIR_RootConstrainSelectedInstOperands,
     /*   98935 */     // GIR_Coverage, 70459,
     /*   98935 */     GIR_EraseRootFromParent_Done,
     /*   98936 */   // Label 1548: @98936
     /*   98936 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(99025), // Rule ID 51836 //
     /*   98941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   98975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98984 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   98984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   98987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99023 */     GIR_RootConstrainSelectedInstOperands,
     /*   99024 */     // GIR_Coverage, 51836,
     /*   99024 */     GIR_EraseRootFromParent_Done,
     /*   99025 */   // Label 1549: @99025
     /*   99025 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(99114), // Rule ID 51837 //
     /*   99030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99045 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99064 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99073 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99112 */     GIR_RootConstrainSelectedInstOperands,
     /*   99113 */     // GIR_Coverage, 51837,
     /*   99113 */     GIR_EraseRootFromParent_Done,
     /*   99114 */   // Label 1550: @99114
     /*   99114 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(99203), // Rule ID 51536 //
     /*   99119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99153 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99162 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99201 */     GIR_RootConstrainSelectedInstOperands,
     /*   99202 */     // GIR_Coverage, 51536,
     /*   99202 */     GIR_EraseRootFromParent_Done,
     /*   99203 */   // Label 1551: @99203
     /*   99203 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(99292), // Rule ID 51537 //
     /*   99208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99223 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99242 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99251 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   99268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99290 */     GIR_RootConstrainSelectedInstOperands,
     /*   99291 */     // GIR_Coverage, 51537,
     /*   99291 */     GIR_EraseRootFromParent_Done,
     /*   99292 */   // Label 1552: @99292
     /*   99292 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(99381), // Rule ID 51776 //
     /*   99297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99340 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99379 */     GIR_RootConstrainSelectedInstOperands,
     /*   99380 */     // GIR_Coverage, 51776,
     /*   99380 */     GIR_EraseRootFromParent_Done,
     /*   99381 */   // Label 1553: @99381
     /*   99381 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(99470), // Rule ID 51777 //
     /*   99386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99429 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99468 */     GIR_RootConstrainSelectedInstOperands,
     /*   99469 */     // GIR_Coverage, 51777,
     /*   99469 */     GIR_EraseRootFromParent_Done,
     /*   99470 */   // Label 1554: @99470
     /*   99470 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(99559), // Rule ID 51716 //
     /*   99475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99490 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99509 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99518 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99557 */     GIR_RootConstrainSelectedInstOperands,
     /*   99558 */     // GIR_Coverage, 51716,
     /*   99558 */     GIR_EraseRootFromParent_Done,
     /*   99559 */   // Label 1555: @99559
     /*   99559 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(99648), // Rule ID 51717 //
     /*   99564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99607 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99646 */     GIR_RootConstrainSelectedInstOperands,
     /*   99647 */     // GIR_Coverage, 51717,
     /*   99647 */     GIR_EraseRootFromParent_Done,
     /*   99648 */   // Label 1556: @99648
     /*   99648 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(99737), // Rule ID 70518 //
     /*   99653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99687 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99696 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99735 */     GIR_RootConstrainSelectedInstOperands,
     /*   99736 */     // GIR_Coverage, 70518,
     /*   99736 */     GIR_EraseRootFromParent_Done,
     /*   99737 */   // Label 1557: @99737
     /*   99737 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(99826), // Rule ID 70519 //
     /*   99742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99785 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99824 */     GIR_RootConstrainSelectedInstOperands,
     /*   99825 */     // GIR_Coverage, 70519,
     /*   99825 */     GIR_EraseRootFromParent_Done,
     /*   99826 */   // Label 1558: @99826
     /*   99826 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(99915), // Rule ID 51596 //
     /*   99831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99865 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99874 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99913 */     GIR_RootConstrainSelectedInstOperands,
     /*   99914 */     // GIR_Coverage, 51596,
     /*   99914 */     GIR_EraseRootFromParent_Done,
     /*   99915 */   // Label 1559: @99915
     /*   99915 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(100004), // Rule ID 51597 //
     /*   99920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   99954 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99963 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   99966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100002 */     GIR_RootConstrainSelectedInstOperands,
     /*  100003 */     // GIR_Coverage, 51597,
     /*  100003 */     GIR_EraseRootFromParent_Done,
     /*  100004 */   // Label 1560: @100004
     /*  100004 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(100057), // Rule ID 50922 //
     /*  100009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100020 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100055 */     GIR_RootConstrainSelectedInstOperands,
     /*  100056 */     // GIR_Coverage, 50922,
     /*  100056 */     GIR_EraseRootFromParent_Done,
     /*  100057 */   // Label 1561: @100057
     /*  100057 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(100110), // Rule ID 50923 //
     /*  100062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100073 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  100076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  100090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  100097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  100099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100108 */     GIR_RootConstrainSelectedInstOperands,
     /*  100109 */     // GIR_Coverage, 50923,
     /*  100109 */     GIR_EraseRootFromParent_Done,
     /*  100110 */   // Label 1562: @100110
     /*  100110 */   GIM_Reject,
     /*  100111 */ // Label 1542: @100111
     /*  100111 */ GIM_Reject,
     /*  100112 */ // Label 1307: @100112
     /*  100112 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101836),
     /*  100117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  100120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  100123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  100127 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(100216), // Rule ID 51676 //
     /*  100132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100147 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100166 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100175 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100214 */     GIR_RootConstrainSelectedInstOperands,
     /*  100215 */     // GIR_Coverage, 51676,
     /*  100215 */     GIR_EraseRootFromParent_Done,
     /*  100216 */   // Label 1564: @100216
     /*  100216 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(100305), // Rule ID 51677 //
     /*  100221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100255 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100264 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100303 */     GIR_RootConstrainSelectedInstOperands,
     /*  100304 */     // GIR_Coverage, 51677,
     /*  100304 */     GIR_EraseRootFromParent_Done,
     /*  100305 */   // Label 1565: @100305
     /*  100305 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(100394), // Rule ID 70598 //
     /*  100310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100325 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100353 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100392 */     GIR_RootConstrainSelectedInstOperands,
     /*  100393 */     // GIR_Coverage, 70598,
     /*  100393 */     GIR_EraseRootFromParent_Done,
     /*  100394 */   // Label 1566: @100394
     /*  100394 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(100483), // Rule ID 70599 //
     /*  100399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100414 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100433 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100442 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100481 */     GIR_RootConstrainSelectedInstOperands,
     /*  100482 */     // GIR_Coverage, 70599,
     /*  100482 */     GIR_EraseRootFromParent_Done,
     /*  100483 */   // Label 1567: @100483
     /*  100483 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(100572), // Rule ID 70478 //
     /*  100488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100503 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100522 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100531 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100570 */     GIR_RootConstrainSelectedInstOperands,
     /*  100571 */     // GIR_Coverage, 70478,
     /*  100571 */     GIR_EraseRootFromParent_Done,
     /*  100572 */   // Label 1568: @100572
     /*  100572 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(100661), // Rule ID 70479 //
     /*  100577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100611 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100620 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100659 */     GIR_RootConstrainSelectedInstOperands,
     /*  100660 */     // GIR_Coverage, 70479,
     /*  100660 */     GIR_EraseRootFromParent_Done,
     /*  100661 */   // Label 1569: @100661
     /*  100661 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(100750), // Rule ID 51856 //
     /*  100666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100700 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100709 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100748 */     GIR_RootConstrainSelectedInstOperands,
     /*  100749 */     // GIR_Coverage, 51856,
     /*  100749 */     GIR_EraseRootFromParent_Done,
     /*  100750 */   // Label 1570: @100750
     /*  100750 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(100839), // Rule ID 51857 //
     /*  100755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100770 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100789 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100798 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100837 */     GIR_RootConstrainSelectedInstOperands,
     /*  100838 */     // GIR_Coverage, 51857,
     /*  100838 */     GIR_EraseRootFromParent_Done,
     /*  100839 */   // Label 1571: @100839
     /*  100839 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(100928), // Rule ID 51556 //
     /*  100844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  100847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100859 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100878 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100887 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  100887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  100904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  100923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100926 */     GIR_RootConstrainSelectedInstOperands,
     /*  100927 */     // GIR_Coverage, 51556,
     /*  100927 */     GIR_EraseRootFromParent_Done,
     /*  100928 */   // Label 1572: @100928
     /*  100928 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(101017), // Rule ID 51557 //
     /*  100933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  100936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100948 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  100967 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100976 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  100976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  100979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  100993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101015 */     GIR_RootConstrainSelectedInstOperands,
     /*  101016 */     // GIR_Coverage, 51557,
     /*  101016 */     GIR_EraseRootFromParent_Done,
     /*  101017 */   // Label 1573: @101017
     /*  101017 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(101106), // Rule ID 51796 //
     /*  101022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101037 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101065 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101104 */     GIR_RootConstrainSelectedInstOperands,
     /*  101105 */     // GIR_Coverage, 51796,
     /*  101105 */     GIR_EraseRootFromParent_Done,
     /*  101106 */   // Label 1574: @101106
     /*  101106 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(101195), // Rule ID 51797 //
     /*  101111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101154 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101193 */     GIR_RootConstrainSelectedInstOperands,
     /*  101194 */     // GIR_Coverage, 51797,
     /*  101194 */     GIR_EraseRootFromParent_Done,
     /*  101195 */   // Label 1575: @101195
     /*  101195 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(101284), // Rule ID 51736 //
     /*  101200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101234 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101243 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101282 */     GIR_RootConstrainSelectedInstOperands,
     /*  101283 */     // GIR_Coverage, 51736,
     /*  101283 */     GIR_EraseRootFromParent_Done,
     /*  101284 */   // Label 1576: @101284
     /*  101284 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(101373), // Rule ID 51737 //
     /*  101289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101323 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101332 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101371 */     GIR_RootConstrainSelectedInstOperands,
     /*  101372 */     // GIR_Coverage, 51737,
     /*  101372 */     GIR_EraseRootFromParent_Done,
     /*  101373 */   // Label 1577: @101373
     /*  101373 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(101462), // Rule ID 70538 //
     /*  101378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101393 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101412 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101421 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101460 */     GIR_RootConstrainSelectedInstOperands,
     /*  101461 */     // GIR_Coverage, 70538,
     /*  101461 */     GIR_EraseRootFromParent_Done,
     /*  101462 */   // Label 1578: @101462
     /*  101462 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(101551), // Rule ID 70539 //
     /*  101467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101482 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101501 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101510 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101549 */     GIR_RootConstrainSelectedInstOperands,
     /*  101550 */     // GIR_Coverage, 70539,
     /*  101550 */     GIR_EraseRootFromParent_Done,
     /*  101551 */   // Label 1579: @101551
     /*  101551 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(101640), // Rule ID 51616 //
     /*  101556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  101559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101571 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101590 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101599 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101638 */     GIR_RootConstrainSelectedInstOperands,
     /*  101639 */     // GIR_Coverage, 51616,
     /*  101639 */     GIR_EraseRootFromParent_Done,
     /*  101640 */   // Label 1580: @101640
     /*  101640 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(101729), // Rule ID 51617 //
     /*  101645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  101648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101660 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  101679 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101688 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101727 */     GIR_RootConstrainSelectedInstOperands,
     /*  101728 */     // GIR_Coverage, 51617,
     /*  101728 */     GIR_EraseRootFromParent_Done,
     /*  101729 */   // Label 1581: @101729
     /*  101729 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(101782), // Rule ID 50938 //
     /*  101734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  101737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101745 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  101745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  101777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101780 */     GIR_RootConstrainSelectedInstOperands,
     /*  101781 */     // GIR_Coverage, 50938,
     /*  101781 */     GIR_EraseRootFromParent_Done,
     /*  101782 */   // Label 1582: @101782
     /*  101782 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(101835), // Rule ID 50939 //
     /*  101787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  101790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101798 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  101798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  101801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  101830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101833 */     GIR_RootConstrainSelectedInstOperands,
     /*  101834 */     // GIR_Coverage, 50939,
     /*  101834 */     GIR_EraseRootFromParent_Done,
     /*  101835 */   // Label 1583: @101835
     /*  101835 */   GIM_Reject,
     /*  101836 */ // Label 1563: @101836
     /*  101836 */ GIM_Reject,
     /*  101837 */ // Label 1308: @101837
     /*  101837 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(101951),
     /*  101842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  101845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  101848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101860 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(101905), // Rule ID 50894 //
     /*  101865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101868 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  101868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  101871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  101885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101903 */     GIR_RootConstrainSelectedInstOperands,
     /*  101904 */     // GIR_Coverage, 50894,
     /*  101904 */     GIR_EraseRootFromParent_Done,
     /*  101905 */   // Label 1585: @101905
     /*  101905 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(101950), // Rule ID 50895 //
     /*  101910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101913 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  101913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  101916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  101930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101948 */     GIR_RootConstrainSelectedInstOperands,
     /*  101949 */     // GIR_Coverage, 50895,
     /*  101949 */     GIR_EraseRootFromParent_Done,
     /*  101950 */   // Label 1586: @101950
     /*  101950 */   GIM_Reject,
     /*  101951 */ // Label 1584: @101951
     /*  101951 */ GIM_Reject,
     /*  101952 */ // Label 1309: @101952
     /*  101952 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103676),
     /*  101957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  101960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  101963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101967 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(102056), // Rule ID 51636 //
     /*  101972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  101987 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  101994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102006 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102015 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102054 */     GIR_RootConstrainSelectedInstOperands,
     /*  102055 */     // GIR_Coverage, 51636,
     /*  102055 */     GIR_EraseRootFromParent_Done,
     /*  102056 */   // Label 1588: @102056
     /*  102056 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(102145), // Rule ID 51637 //
     /*  102061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102095 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102104 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102143 */     GIR_RootConstrainSelectedInstOperands,
     /*  102144 */     // GIR_Coverage, 51637,
     /*  102144 */     GIR_EraseRootFromParent_Done,
     /*  102145 */   // Label 1589: @102145
     /*  102145 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(102234), // Rule ID 70558 //
     /*  102150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102184 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102193 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102232 */     GIR_RootConstrainSelectedInstOperands,
     /*  102233 */     // GIR_Coverage, 70558,
     /*  102233 */     GIR_EraseRootFromParent_Done,
     /*  102234 */   // Label 1590: @102234
     /*  102234 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(102323), // Rule ID 70559 //
     /*  102239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102273 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102282 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102321 */     GIR_RootConstrainSelectedInstOperands,
     /*  102322 */     // GIR_Coverage, 70559,
     /*  102322 */     GIR_EraseRootFromParent_Done,
     /*  102323 */   // Label 1591: @102323
     /*  102323 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(102412), // Rule ID 70438 //
     /*  102328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102362 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102371 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102410 */     GIR_RootConstrainSelectedInstOperands,
     /*  102411 */     // GIR_Coverage, 70438,
     /*  102411 */     GIR_EraseRootFromParent_Done,
     /*  102412 */   // Label 1592: @102412
     /*  102412 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(102501), // Rule ID 70439 //
     /*  102417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102432 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102451 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102460 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  102477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102499 */     GIR_RootConstrainSelectedInstOperands,
     /*  102500 */     // GIR_Coverage, 70439,
     /*  102500 */     GIR_EraseRootFromParent_Done,
     /*  102501 */   // Label 1593: @102501
     /*  102501 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(102590), // Rule ID 51816 //
     /*  102506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102549 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102588 */     GIR_RootConstrainSelectedInstOperands,
     /*  102589 */     // GIR_Coverage, 51816,
     /*  102589 */     GIR_EraseRootFromParent_Done,
     /*  102590 */   // Label 1594: @102590
     /*  102590 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(102679), // Rule ID 51817 //
     /*  102595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102610 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102629 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102638 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102677 */     GIR_RootConstrainSelectedInstOperands,
     /*  102678 */     // GIR_Coverage, 51817,
     /*  102678 */     GIR_EraseRootFromParent_Done,
     /*  102679 */   // Label 1595: @102679
     /*  102679 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(102768), // Rule ID 51516 //
     /*  102684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102699 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102718 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102727 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  102744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102766 */     GIR_RootConstrainSelectedInstOperands,
     /*  102767 */     // GIR_Coverage, 51516,
     /*  102767 */     GIR_EraseRootFromParent_Done,
     /*  102768 */   // Label 1596: @102768
     /*  102768 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(102857), // Rule ID 51517 //
     /*  102773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102788 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102807 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102816 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  102833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102855 */     GIR_RootConstrainSelectedInstOperands,
     /*  102856 */     // GIR_Coverage, 51517,
     /*  102856 */     GIR_EraseRootFromParent_Done,
     /*  102857 */   // Label 1597: @102857
     /*  102857 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(102946), // Rule ID 51756 //
     /*  102862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102896 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102905 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  102922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102944 */     GIR_RootConstrainSelectedInstOperands,
     /*  102945 */     // GIR_Coverage, 51756,
     /*  102945 */     GIR_EraseRootFromParent_Done,
     /*  102946 */   // Label 1598: @102946
     /*  102946 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(103035), // Rule ID 51757 //
     /*  102951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  102985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  102992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102994 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  102997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103033 */     GIR_RootConstrainSelectedInstOperands,
     /*  103034 */     // GIR_Coverage, 51757,
     /*  103034 */     GIR_EraseRootFromParent_Done,
     /*  103035 */   // Label 1599: @103035
     /*  103035 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(103124), // Rule ID 51696 //
     /*  103040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103074 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103083 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103122 */     GIR_RootConstrainSelectedInstOperands,
     /*  103123 */     // GIR_Coverage, 51696,
     /*  103123 */     GIR_EraseRootFromParent_Done,
     /*  103124 */   // Label 1600: @103124
     /*  103124 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(103213), // Rule ID 51697 //
     /*  103129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103144 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103163 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103172 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103211 */     GIR_RootConstrainSelectedInstOperands,
     /*  103212 */     // GIR_Coverage, 51697,
     /*  103212 */     GIR_EraseRootFromParent_Done,
     /*  103213 */   // Label 1601: @103213
     /*  103213 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(103302), // Rule ID 70498 //
     /*  103218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103233 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103252 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103261 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103300 */     GIR_RootConstrainSelectedInstOperands,
     /*  103301 */     // GIR_Coverage, 70498,
     /*  103301 */     GIR_EraseRootFromParent_Done,
     /*  103302 */   // Label 1602: @103302
     /*  103302 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(103391), // Rule ID 70499 //
     /*  103307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103322 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103341 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103350 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  103367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103389 */     GIR_RootConstrainSelectedInstOperands,
     /*  103390 */     // GIR_Coverage, 70499,
     /*  103390 */     GIR_EraseRootFromParent_Done,
     /*  103391 */   // Label 1603: @103391
     /*  103391 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(103480), // Rule ID 51576 //
     /*  103396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103430 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103439 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103478 */     GIR_RootConstrainSelectedInstOperands,
     /*  103479 */     // GIR_Coverage, 51576,
     /*  103479 */     GIR_EraseRootFromParent_Done,
     /*  103480 */   // Label 1604: @103480
     /*  103480 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(103569), // Rule ID 51577 //
     /*  103485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  103515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  103519 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  103526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103528 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  103545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103567 */     GIR_RootConstrainSelectedInstOperands,
     /*  103568 */     // GIR_Coverage, 51577,
     /*  103568 */     GIR_EraseRootFromParent_Done,
     /*  103569 */   // Label 1605: @103569
     /*  103569 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(103622), // Rule ID 50910 //
     /*  103574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103585 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  103602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103620 */     GIR_RootConstrainSelectedInstOperands,
     /*  103621 */     // GIR_Coverage, 50910,
     /*  103621 */     GIR_EraseRootFromParent_Done,
     /*  103622 */   // Label 1606: @103622
     /*  103622 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(103675), // Rule ID 50911 //
     /*  103627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103638 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  103641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  103655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103673 */     GIR_RootConstrainSelectedInstOperands,
     /*  103674 */     // GIR_Coverage, 50911,
     /*  103674 */     GIR_EraseRootFromParent_Done,
     /*  103675 */   // Label 1607: @103675
     /*  103675 */   GIM_Reject,
     /*  103676 */ // Label 1587: @103676
     /*  103676 */ GIM_Reject,
     /*  103677 */ // Label 1310: @103677
     /*  103677 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(105401),
     /*  103682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  103685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  103688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103692 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(103781), // Rule ID 51660 //
     /*  103697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103731 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103740 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  103757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103779 */     GIR_RootConstrainSelectedInstOperands,
     /*  103780 */     // GIR_Coverage, 51660,
     /*  103780 */     GIR_EraseRootFromParent_Done,
     /*  103781 */   // Label 1609: @103781
     /*  103781 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(103870), // Rule ID 51661 //
     /*  103786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103801 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103820 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103829 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  103846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103868 */     GIR_RootConstrainSelectedInstOperands,
     /*  103869 */     // GIR_Coverage, 51661,
     /*  103869 */     GIR_EraseRootFromParent_Done,
     /*  103870 */   // Label 1610: @103870
     /*  103870 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(103959), // Rule ID 70582 //
     /*  103875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103909 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  103911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  103918 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  103921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  103935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  103944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  103948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103957 */     GIR_RootConstrainSelectedInstOperands,
     /*  103958 */     // GIR_Coverage, 70582,
     /*  103958 */     GIR_EraseRootFromParent_Done,
     /*  103959 */   // Label 1611: @103959
     /*  103959 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(104048), // Rule ID 70583 //
     /*  103964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  103971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  103975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103979 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  103981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  103986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  103990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  103994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  103998 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104007 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104046 */     GIR_RootConstrainSelectedInstOperands,
     /*  104047 */     // GIR_Coverage, 70583,
     /*  104047 */     GIR_EraseRootFromParent_Done,
     /*  104048 */   // Label 1612: @104048
     /*  104048 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(104137), // Rule ID 70462 //
     /*  104053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104068 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104087 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104096 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104135 */     GIR_RootConstrainSelectedInstOperands,
     /*  104136 */     // GIR_Coverage, 70462,
     /*  104136 */     GIR_EraseRootFromParent_Done,
     /*  104137 */   // Label 1613: @104137
     /*  104137 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(104226), // Rule ID 70463 //
     /*  104142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104157 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104176 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104185 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  104211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  104215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104224 */     GIR_RootConstrainSelectedInstOperands,
     /*  104225 */     // GIR_Coverage, 70463,
     /*  104225 */     GIR_EraseRootFromParent_Done,
     /*  104226 */   // Label 1614: @104226
     /*  104226 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(104315), // Rule ID 51840 //
     /*  104231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104265 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104274 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104313 */     GIR_RootConstrainSelectedInstOperands,
     /*  104314 */     // GIR_Coverage, 51840,
     /*  104314 */     GIR_EraseRootFromParent_Done,
     /*  104315 */   // Label 1615: @104315
     /*  104315 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(104404), // Rule ID 51841 //
     /*  104320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104335 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104354 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104363 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104402 */     GIR_RootConstrainSelectedInstOperands,
     /*  104403 */     // GIR_Coverage, 51841,
     /*  104403 */     GIR_EraseRootFromParent_Done,
     /*  104404 */   // Label 1616: @104404
     /*  104404 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(104493), // Rule ID 51540 //
     /*  104409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104443 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104452 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104491 */     GIR_RootConstrainSelectedInstOperands,
     /*  104492 */     // GIR_Coverage, 51540,
     /*  104492 */     GIR_EraseRootFromParent_Done,
     /*  104493 */   // Label 1617: @104493
     /*  104493 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(104582), // Rule ID 51541 //
     /*  104498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104513 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104532 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104541 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  104558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104580 */     GIR_RootConstrainSelectedInstOperands,
     /*  104581 */     // GIR_Coverage, 51541,
     /*  104581 */     GIR_EraseRootFromParent_Done,
     /*  104582 */   // Label 1618: @104582
     /*  104582 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(104671), // Rule ID 51780 //
     /*  104587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104621 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104630 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104669 */     GIR_RootConstrainSelectedInstOperands,
     /*  104670 */     // GIR_Coverage, 51780,
     /*  104670 */     GIR_EraseRootFromParent_Done,
     /*  104671 */   // Label 1619: @104671
     /*  104671 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(104760), // Rule ID 51781 //
     /*  104676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104691 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104710 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104719 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  104736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104758 */     GIR_RootConstrainSelectedInstOperands,
     /*  104759 */     // GIR_Coverage, 51781,
     /*  104759 */     GIR_EraseRootFromParent_Done,
     /*  104760 */   // Label 1620: @104760
     /*  104760 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(104849), // Rule ID 51720 //
     /*  104765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104780 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104799 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104808 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104847 */     GIR_RootConstrainSelectedInstOperands,
     /*  104848 */     // GIR_Coverage, 51720,
     /*  104848 */     GIR_EraseRootFromParent_Done,
     /*  104849 */   // Label 1621: @104849
     /*  104849 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(104938), // Rule ID 51721 //
     /*  104854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104869 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  104884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104888 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104897 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  104914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  104923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  104927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104936 */     GIR_RootConstrainSelectedInstOperands,
     /*  104937 */     // GIR_Coverage, 51721,
     /*  104937 */     GIR_EraseRootFromParent_Done,
     /*  104938 */   // Label 1622: @104938
     /*  104938 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(105027), // Rule ID 70522 //
     /*  104943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  104950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  104954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  104960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  104969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  104973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  104977 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  104979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  104986 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  104989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105025 */     GIR_RootConstrainSelectedInstOperands,
     /*  105026 */     // GIR_Coverage, 70522,
     /*  105026 */     GIR_EraseRootFromParent_Done,
     /*  105027 */   // Label 1623: @105027
     /*  105027 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(105116), // Rule ID 70523 //
     /*  105032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105047 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105066 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105075 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105114 */     GIR_RootConstrainSelectedInstOperands,
     /*  105115 */     // GIR_Coverage, 70523,
     /*  105115 */     GIR_EraseRootFromParent_Done,
     /*  105116 */   // Label 1624: @105116
     /*  105116 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(105205), // Rule ID 51600 //
     /*  105121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105155 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105164 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105203 */     GIR_RootConstrainSelectedInstOperands,
     /*  105204 */     // GIR_Coverage, 51600,
     /*  105204 */     GIR_EraseRootFromParent_Done,
     /*  105205 */   // Label 1625: @105205
     /*  105205 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(105294), // Rule ID 51601 //
     /*  105210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105244 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105253 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105292 */     GIR_RootConstrainSelectedInstOperands,
     /*  105293 */     // GIR_Coverage, 51601,
     /*  105293 */     GIR_EraseRootFromParent_Done,
     /*  105294 */   // Label 1626: @105294
     /*  105294 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(105347), // Rule ID 50926 //
     /*  105299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105310 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  105310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105345 */     GIR_RootConstrainSelectedInstOperands,
     /*  105346 */     // GIR_Coverage, 50926,
     /*  105346 */     GIR_EraseRootFromParent_Done,
     /*  105347 */   // Label 1627: @105347
     /*  105347 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(105400), // Rule ID 50927 //
     /*  105352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105363 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  105363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  105380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105398 */     GIR_RootConstrainSelectedInstOperands,
     /*  105399 */     // GIR_Coverage, 50927,
     /*  105399 */     GIR_EraseRootFromParent_Done,
     /*  105400 */   // Label 1628: @105400
     /*  105400 */   GIM_Reject,
     /*  105401 */ // Label 1608: @105401
     /*  105401 */ GIM_Reject,
     /*  105402 */ // Label 1311: @105402
     /*  105402 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(105516),
     /*  105407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  105413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105425 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(105470), // Rule ID 50898 //
     /*  105430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105433 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105468 */     GIR_RootConstrainSelectedInstOperands,
     /*  105469 */     // GIR_Coverage, 50898,
     /*  105469 */     GIR_EraseRootFromParent_Done,
     /*  105470 */   // Label 1630: @105470
     /*  105470 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(105515), // Rule ID 50899 //
     /*  105475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105478 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  105495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105513 */     GIR_RootConstrainSelectedInstOperands,
     /*  105514 */     // GIR_Coverage, 50899,
     /*  105514 */     GIR_EraseRootFromParent_Done,
     /*  105515 */   // Label 1631: @105515
     /*  105515 */   GIM_Reject,
     /*  105516 */ // Label 1629: @105516
     /*  105516 */ GIM_Reject,
     /*  105517 */ // Label 1312: @105517
     /*  105517 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(107241),
     /*  105522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  105525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  105528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105532 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(105621), // Rule ID 51640 //
     /*  105537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105552 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105571 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105580 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105619 */     GIR_RootConstrainSelectedInstOperands,
     /*  105620 */     // GIR_Coverage, 51640,
     /*  105620 */     GIR_EraseRootFromParent_Done,
     /*  105621 */   // Label 1633: @105621
     /*  105621 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(105710), // Rule ID 51641 //
     /*  105626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105641 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105660 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105669 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  105695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  105699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105708 */     GIR_RootConstrainSelectedInstOperands,
     /*  105709 */     // GIR_Coverage, 51641,
     /*  105709 */     GIR_EraseRootFromParent_Done,
     /*  105710 */   // Label 1634: @105710
     /*  105710 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(105799), // Rule ID 70562 //
     /*  105715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105730 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105749 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105758 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105797 */     GIR_RootConstrainSelectedInstOperands,
     /*  105798 */     // GIR_Coverage, 70562,
     /*  105798 */     GIR_EraseRootFromParent_Done,
     /*  105799 */   // Label 1635: @105799
     /*  105799 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(105888), // Rule ID 70563 //
     /*  105804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105819 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  105834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105838 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105847 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  105864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105886 */     GIR_RootConstrainSelectedInstOperands,
     /*  105887 */     // GIR_Coverage, 70563,
     /*  105887 */     GIR_EraseRootFromParent_Done,
     /*  105888 */   // Label 1636: @105888
     /*  105888 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(105977), // Rule ID 70442 //
     /*  105893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  105919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  105923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105927 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  105929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  105936 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  105953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  105962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  105966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105975 */     GIR_RootConstrainSelectedInstOperands,
     /*  105976 */     // GIR_Coverage, 70442,
     /*  105976 */     GIR_EraseRootFromParent_Done,
     /*  105977 */   // Label 1637: @105977
     /*  105977 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(106066), // Rule ID 70443 //
     /*  105982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  105989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  105993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  105999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106016 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106025 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106064 */     GIR_RootConstrainSelectedInstOperands,
     /*  106065 */     // GIR_Coverage, 70443,
     /*  106065 */     GIR_EraseRootFromParent_Done,
     /*  106066 */   // Label 1638: @106066
     /*  106066 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106155), // Rule ID 51820 //
     /*  106071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106114 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106153 */     GIR_RootConstrainSelectedInstOperands,
     /*  106154 */     // GIR_Coverage, 51820,
     /*  106154 */     GIR_EraseRootFromParent_Done,
     /*  106155 */   // Label 1639: @106155
     /*  106155 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106244), // Rule ID 51821 //
     /*  106160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106194 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106203 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106242 */     GIR_RootConstrainSelectedInstOperands,
     /*  106243 */     // GIR_Coverage, 51821,
     /*  106243 */     GIR_EraseRootFromParent_Done,
     /*  106244 */   // Label 1640: @106244
     /*  106244 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106333), // Rule ID 51520 //
     /*  106249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106264 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106283 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106292 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106331 */     GIR_RootConstrainSelectedInstOperands,
     /*  106332 */     // GIR_Coverage, 51520,
     /*  106332 */     GIR_EraseRootFromParent_Done,
     /*  106333 */   // Label 1641: @106333
     /*  106333 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106422), // Rule ID 51521 //
     /*  106338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106353 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106372 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106381 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  106398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106420 */     GIR_RootConstrainSelectedInstOperands,
     /*  106421 */     // GIR_Coverage, 51521,
     /*  106421 */     GIR_EraseRootFromParent_Done,
     /*  106422 */   // Label 1642: @106422
     /*  106422 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106511), // Rule ID 51760 //
     /*  106427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106470 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106509 */     GIR_RootConstrainSelectedInstOperands,
     /*  106510 */     // GIR_Coverage, 51760,
     /*  106510 */     GIR_EraseRootFromParent_Done,
     /*  106511 */   // Label 1643: @106511
     /*  106511 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(106600), // Rule ID 51761 //
     /*  106516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106559 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106598 */     GIR_RootConstrainSelectedInstOperands,
     /*  106599 */     // GIR_Coverage, 51761,
     /*  106599 */     GIR_EraseRootFromParent_Done,
     /*  106600 */   // Label 1644: @106600
     /*  106600 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(106689), // Rule ID 51700 //
     /*  106605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106648 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106687 */     GIR_RootConstrainSelectedInstOperands,
     /*  106688 */     // GIR_Coverage, 51700,
     /*  106688 */     GIR_EraseRootFromParent_Done,
     /*  106689 */   // Label 1645: @106689
     /*  106689 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(106778), // Rule ID 51701 //
     /*  106694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  106724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106737 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  106754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  106763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  106767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106776 */     GIR_RootConstrainSelectedInstOperands,
     /*  106777 */     // GIR_Coverage, 51701,
     /*  106777 */     GIR_EraseRootFromParent_Done,
     /*  106778 */   // Label 1646: @106778
     /*  106778 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(106867), // Rule ID 70502 //
     /*  106783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106826 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106865 */     GIR_RootConstrainSelectedInstOperands,
     /*  106866 */     // GIR_Coverage, 70502,
     /*  106866 */     GIR_EraseRootFromParent_Done,
     /*  106867 */   // Label 1647: @106867
     /*  106867 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(106956), // Rule ID 70503 //
     /*  106872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  106902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  106915 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  106918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  106932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  106941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  106945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106954 */     GIR_RootConstrainSelectedInstOperands,
     /*  106955 */     // GIR_Coverage, 70503,
     /*  106955 */     GIR_EraseRootFromParent_Done,
     /*  106956 */   // Label 1648: @106956
     /*  106956 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(107045), // Rule ID 51580 //
     /*  106961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  106968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  106978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  106983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  106987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  106991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  106995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  106997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107004 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107043 */     GIR_RootConstrainSelectedInstOperands,
     /*  107044 */     // GIR_Coverage, 51580,
     /*  107044 */     GIR_EraseRootFromParent_Done,
     /*  107045 */   // Label 1649: @107045
     /*  107045 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107134), // Rule ID 51581 //
     /*  107050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  107057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  107067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  107076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  107080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  107084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  107086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  107093 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  107110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  107119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  107123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107132 */     GIR_RootConstrainSelectedInstOperands,
     /*  107133 */     // GIR_Coverage, 51581,
     /*  107133 */     GIR_EraseRootFromParent_Done,
     /*  107134 */   // Label 1650: @107134
     /*  107134 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107187), // Rule ID 50914 //
     /*  107139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107150 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107185 */     GIR_RootConstrainSelectedInstOperands,
     /*  107186 */     // GIR_Coverage, 50914,
     /*  107186 */     GIR_EraseRootFromParent_Done,
     /*  107187 */   // Label 1651: @107187
     /*  107187 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107240), // Rule ID 50915 //
     /*  107192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107203 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  107206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107238 */     GIR_RootConstrainSelectedInstOperands,
     /*  107239 */     // GIR_Coverage, 50915,
     /*  107239 */     GIR_EraseRootFromParent_Done,
     /*  107240 */   // Label 1652: @107240
     /*  107240 */   GIM_Reject,
     /*  107241 */ // Label 1632: @107241
     /*  107241 */ GIM_Reject,
     /*  107242 */ // Label 1313: @107242
     /*  107242 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107356),
     /*  107247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  107250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  107253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107265 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107310), // Rule ID 50902 //
     /*  107270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107273 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107308 */     GIR_RootConstrainSelectedInstOperands,
     /*  107309 */     // GIR_Coverage, 50902,
     /*  107309 */     GIR_EraseRootFromParent_Done,
     /*  107310 */   // Label 1654: @107310
     /*  107310 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107355), // Rule ID 50903 //
     /*  107315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107318 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  107321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  107335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107353 */     GIR_RootConstrainSelectedInstOperands,
     /*  107354 */     // GIR_Coverage, 50903,
     /*  107354 */     GIR_EraseRootFromParent_Done,
     /*  107355 */   // Label 1655: @107355
     /*  107355 */   GIM_Reject,
     /*  107356 */ // Label 1653: @107356
     /*  107356 */ GIM_Reject,
     /*  107357 */ // Label 1314: @107357
     /*  107357 */ GIM_Reject,
     /*  107358 */ // Label 3: @107358
     /*  107358 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1680*/ GIMT_Encode4(110091),
     /*  107369 */ /*GILLT_s32*//*Label 1656*/ GIMT_Encode4(107493),
     /*  107373 */ /*GILLT_s64*//*Label 1657*/ GIMT_Encode4(107527), GIMT_Encode4(0),
     /*  107381 */ /*GILLT_nxv1s8*//*Label 1658*/ GIMT_Encode4(107561),
     /*  107385 */ /*GILLT_nxv1s16*//*Label 1659*/ GIMT_Encode4(107676),
     /*  107389 */ /*GILLT_nxv1s32*//*Label 1660*/ GIMT_Encode4(107791),
     /*  107393 */ /*GILLT_nxv1s64*//*Label 1661*/ GIMT_Encode4(107906), GIMT_Encode4(0),
     /*  107401 */ /*GILLT_nxv2s8*//*Label 1662*/ GIMT_Encode4(108021),
     /*  107405 */ /*GILLT_nxv2s16*//*Label 1663*/ GIMT_Encode4(108136),
     /*  107409 */ /*GILLT_nxv2s32*//*Label 1664*/ GIMT_Encode4(108251),
     /*  107413 */ /*GILLT_nxv2s64*//*Label 1665*/ GIMT_Encode4(108366), GIMT_Encode4(0),
     /*  107421 */ /*GILLT_nxv4s8*//*Label 1666*/ GIMT_Encode4(108481),
     /*  107425 */ /*GILLT_nxv4s16*//*Label 1667*/ GIMT_Encode4(108596),
     /*  107429 */ /*GILLT_nxv4s32*//*Label 1668*/ GIMT_Encode4(108711),
     /*  107433 */ /*GILLT_nxv4s64*//*Label 1669*/ GIMT_Encode4(108826), GIMT_Encode4(0),
     /*  107441 */ /*GILLT_nxv8s8*//*Label 1670*/ GIMT_Encode4(108941),
     /*  107445 */ /*GILLT_nxv8s16*//*Label 1671*/ GIMT_Encode4(109056),
     /*  107449 */ /*GILLT_nxv8s32*//*Label 1672*/ GIMT_Encode4(109171),
     /*  107453 */ /*GILLT_nxv8s64*//*Label 1673*/ GIMT_Encode4(109286), GIMT_Encode4(0),
     /*  107461 */ /*GILLT_nxv16s8*//*Label 1674*/ GIMT_Encode4(109401),
     /*  107465 */ /*GILLT_nxv16s16*//*Label 1675*/ GIMT_Encode4(109516),
     /*  107469 */ /*GILLT_nxv16s32*//*Label 1676*/ GIMT_Encode4(109631), GIMT_Encode4(0),
     /*  107477 */ /*GILLT_nxv32s8*//*Label 1677*/ GIMT_Encode4(109746),
     /*  107481 */ /*GILLT_nxv32s16*//*Label 1678*/ GIMT_Encode4(109861), GIMT_Encode4(0),
     /*  107489 */ /*GILLT_nxv64s8*//*Label 1679*/ GIMT_Encode4(109976),
     /*  107493 */ // Label 1656: @107493
     /*  107493 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(107526), // Rule ID 306 //
     /*  107498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  107501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  107504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  107507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107519 */   // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  107519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107524 */   GIR_RootConstrainSelectedInstOperands,
     /*  107525 */   // GIR_Coverage, 306,
     /*  107525 */   GIR_Done,
     /*  107526 */ // Label 1681: @107526
     /*  107526 */ GIM_Reject,
     /*  107527 */ // Label 1657: @107527
     /*  107527 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(107560), // Rule ID 305 //
     /*  107532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  107535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  107538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  107541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  107553 */   // (sdiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  107553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  107558 */   GIR_RootConstrainSelectedInstOperands,
     /*  107559 */   // GIR_Coverage, 305,
     /*  107559 */   GIR_Done,
     /*  107560 */ // Label 1682: @107560
     /*  107560 */ GIM_Reject,
     /*  107561 */ // Label 1658: @107561
     /*  107561 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(107675),
     /*  107566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  107569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  107572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107584 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(107629), // Rule ID 51206 //
     /*  107589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107592 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  107595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  107609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107627 */     GIR_RootConstrainSelectedInstOperands,
     /*  107628 */     // GIR_Coverage, 51206,
     /*  107628 */     GIR_EraseRootFromParent_Done,
     /*  107629 */   // Label 1684: @107629
     /*  107629 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(107674), // Rule ID 51207 //
     /*  107634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107637 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  107640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  107654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107672 */     GIR_RootConstrainSelectedInstOperands,
     /*  107673 */     // GIR_Coverage, 51207,
     /*  107673 */     GIR_EraseRootFromParent_Done,
     /*  107674 */   // Label 1685: @107674
     /*  107674 */   GIM_Reject,
     /*  107675 */ // Label 1683: @107675
     /*  107675 */ GIM_Reject,
     /*  107676 */ // Label 1659: @107676
     /*  107676 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(107790),
     /*  107681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  107684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  107687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107699 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(107744), // Rule ID 51218 //
     /*  107704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107707 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  107710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  107724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107742 */     GIR_RootConstrainSelectedInstOperands,
     /*  107743 */     // GIR_Coverage, 51218,
     /*  107743 */     GIR_EraseRootFromParent_Done,
     /*  107744 */   // Label 1687: @107744
     /*  107744 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(107789), // Rule ID 51219 //
     /*  107749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107752 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  107755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  107769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107787 */     GIR_RootConstrainSelectedInstOperands,
     /*  107788 */     // GIR_Coverage, 51219,
     /*  107788 */     GIR_EraseRootFromParent_Done,
     /*  107789 */   // Label 1688: @107789
     /*  107789 */   GIM_Reject,
     /*  107790 */ // Label 1686: @107790
     /*  107790 */ GIM_Reject,
     /*  107791 */ // Label 1660: @107791
     /*  107791 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(107905),
     /*  107796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  107799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  107802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107814 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(107859), // Rule ID 51226 //
     /*  107819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107822 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  107822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  107825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  107839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107857 */     GIR_RootConstrainSelectedInstOperands,
     /*  107858 */     // GIR_Coverage, 51226,
     /*  107858 */     GIR_EraseRootFromParent_Done,
     /*  107859 */   // Label 1690: @107859
     /*  107859 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(107904), // Rule ID 51227 //
     /*  107864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107867 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  107867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  107870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  107884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107902 */     GIR_RootConstrainSelectedInstOperands,
     /*  107903 */     // GIR_Coverage, 51227,
     /*  107903 */     GIR_EraseRootFromParent_Done,
     /*  107904 */   // Label 1691: @107904
     /*  107904 */   GIM_Reject,
     /*  107905 */ // Label 1689: @107905
     /*  107905 */ GIM_Reject,
     /*  107906 */ // Label 1661: @107906
     /*  107906 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108020),
     /*  107911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  107914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  107917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107929 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(107974), // Rule ID 51242 //
     /*  107934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  107937 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  107937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  107940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  107954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  107969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107972 */     GIR_RootConstrainSelectedInstOperands,
     /*  107973 */     // GIR_Coverage, 51242,
     /*  107973 */     GIR_EraseRootFromParent_Done,
     /*  107974 */   // Label 1693: @107974
     /*  107974 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108019), // Rule ID 51243 //
     /*  107979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  107982 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  107982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  107985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  107999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108017 */     GIR_RootConstrainSelectedInstOperands,
     /*  108018 */     // GIR_Coverage, 51243,
     /*  108018 */     GIR_EraseRootFromParent_Done,
     /*  108019 */   // Label 1694: @108019
     /*  108019 */   GIM_Reject,
     /*  108020 */ // Label 1692: @108020
     /*  108020 */ GIM_Reject,
     /*  108021 */ // Label 1662: @108021
     /*  108021 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108135),
     /*  108026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  108029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  108032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108044 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108089), // Rule ID 51210 //
     /*  108049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108052 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108087 */     GIR_RootConstrainSelectedInstOperands,
     /*  108088 */     // GIR_Coverage, 51210,
     /*  108088 */     GIR_EraseRootFromParent_Done,
     /*  108089 */   // Label 1696: @108089
     /*  108089 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108134), // Rule ID 51211 //
     /*  108094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108097 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  108100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  108114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108132 */     GIR_RootConstrainSelectedInstOperands,
     /*  108133 */     // GIR_Coverage, 51211,
     /*  108133 */     GIR_EraseRootFromParent_Done,
     /*  108134 */   // Label 1697: @108134
     /*  108134 */   GIM_Reject,
     /*  108135 */ // Label 1695: @108135
     /*  108135 */ GIM_Reject,
     /*  108136 */ // Label 1663: @108136
     /*  108136 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108250),
     /*  108141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  108144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  108147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108159 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108204), // Rule ID 51222 //
     /*  108164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108167 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108202 */     GIR_RootConstrainSelectedInstOperands,
     /*  108203 */     // GIR_Coverage, 51222,
     /*  108203 */     GIR_EraseRootFromParent_Done,
     /*  108204 */   // Label 1699: @108204
     /*  108204 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108249), // Rule ID 51223 //
     /*  108209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108212 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  108215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  108229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108247 */     GIR_RootConstrainSelectedInstOperands,
     /*  108248 */     // GIR_Coverage, 51223,
     /*  108248 */     GIR_EraseRootFromParent_Done,
     /*  108249 */   // Label 1700: @108249
     /*  108249 */   GIM_Reject,
     /*  108250 */ // Label 1698: @108250
     /*  108250 */ GIM_Reject,
     /*  108251 */ // Label 1664: @108251
     /*  108251 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108365),
     /*  108256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  108259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  108262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108274 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108319), // Rule ID 51238 //
     /*  108279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108282 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108317 */     GIR_RootConstrainSelectedInstOperands,
     /*  108318 */     // GIR_Coverage, 51238,
     /*  108318 */     GIR_EraseRootFromParent_Done,
     /*  108319 */   // Label 1702: @108319
     /*  108319 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108364), // Rule ID 51239 //
     /*  108324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108327 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  108330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  108344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108362 */     GIR_RootConstrainSelectedInstOperands,
     /*  108363 */     // GIR_Coverage, 51239,
     /*  108363 */     GIR_EraseRootFromParent_Done,
     /*  108364 */   // Label 1703: @108364
     /*  108364 */   GIM_Reject,
     /*  108365 */ // Label 1701: @108365
     /*  108365 */ GIM_Reject,
     /*  108366 */ // Label 1665: @108366
     /*  108366 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108480),
     /*  108371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  108374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  108377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108389 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108434), // Rule ID 51282 //
     /*  108394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108397 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108432 */     GIR_RootConstrainSelectedInstOperands,
     /*  108433 */     // GIR_Coverage, 51282,
     /*  108433 */     GIR_EraseRootFromParent_Done,
     /*  108434 */   // Label 1705: @108434
     /*  108434 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(108479), // Rule ID 51283 //
     /*  108439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108442 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  108445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  108459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108477 */     GIR_RootConstrainSelectedInstOperands,
     /*  108478 */     // GIR_Coverage, 51283,
     /*  108478 */     GIR_EraseRootFromParent_Done,
     /*  108479 */   // Label 1706: @108479
     /*  108479 */   GIM_Reject,
     /*  108480 */ // Label 1704: @108480
     /*  108480 */ GIM_Reject,
     /*  108481 */ // Label 1666: @108481
     /*  108481 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(108595),
     /*  108486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  108489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  108492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108504 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(108549), // Rule ID 51214 //
     /*  108509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108512 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  108529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108547 */     GIR_RootConstrainSelectedInstOperands,
     /*  108548 */     // GIR_Coverage, 51214,
     /*  108548 */     GIR_EraseRootFromParent_Done,
     /*  108549 */   // Label 1708: @108549
     /*  108549 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(108594), // Rule ID 51215 //
     /*  108554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108557 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  108560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  108574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108592 */     GIR_RootConstrainSelectedInstOperands,
     /*  108593 */     // GIR_Coverage, 51215,
     /*  108593 */     GIR_EraseRootFromParent_Done,
     /*  108594 */   // Label 1709: @108594
     /*  108594 */   GIM_Reject,
     /*  108595 */ // Label 1707: @108595
     /*  108595 */ GIM_Reject,
     /*  108596 */ // Label 1667: @108596
     /*  108596 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(108710),
     /*  108601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  108604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  108607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108619 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(108664), // Rule ID 51234 //
     /*  108624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108627 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  108630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  108644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108662 */     GIR_RootConstrainSelectedInstOperands,
     /*  108663 */     // GIR_Coverage, 51234,
     /*  108663 */     GIR_EraseRootFromParent_Done,
     /*  108664 */   // Label 1711: @108664
     /*  108664 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(108709), // Rule ID 51235 //
     /*  108669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108672 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  108675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  108689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108707 */     GIR_RootConstrainSelectedInstOperands,
     /*  108708 */     // GIR_Coverage, 51235,
     /*  108708 */     GIR_EraseRootFromParent_Done,
     /*  108709 */   // Label 1712: @108709
     /*  108709 */   GIM_Reject,
     /*  108710 */ // Label 1710: @108710
     /*  108710 */ GIM_Reject,
     /*  108711 */ // Label 1668: @108711
     /*  108711 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(108825),
     /*  108716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  108719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  108722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108734 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(108779), // Rule ID 51270 //
     /*  108739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108742 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  108745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  108759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108777 */     GIR_RootConstrainSelectedInstOperands,
     /*  108778 */     // GIR_Coverage, 51270,
     /*  108778 */     GIR_EraseRootFromParent_Done,
     /*  108779 */   // Label 1714: @108779
     /*  108779 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(108824), // Rule ID 51271 //
     /*  108784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108787 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  108790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  108804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108822 */     GIR_RootConstrainSelectedInstOperands,
     /*  108823 */     // GIR_Coverage, 51271,
     /*  108823 */     GIR_EraseRootFromParent_Done,
     /*  108824 */   // Label 1715: @108824
     /*  108824 */   GIM_Reject,
     /*  108825 */ // Label 1713: @108825
     /*  108825 */ GIM_Reject,
     /*  108826 */ // Label 1669: @108826
     /*  108826 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(108940),
     /*  108831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  108834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  108837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108849 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(108894), // Rule ID 51286 //
     /*  108854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  108857 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  108857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  108860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  108874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108892 */     GIR_RootConstrainSelectedInstOperands,
     /*  108893 */     // GIR_Coverage, 51286,
     /*  108893 */     GIR_EraseRootFromParent_Done,
     /*  108894 */   // Label 1717: @108894
     /*  108894 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(108939), // Rule ID 51287 //
     /*  108899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  108902 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  108902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  108905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  108919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108937 */     GIR_RootConstrainSelectedInstOperands,
     /*  108938 */     // GIR_Coverage, 51287,
     /*  108938 */     GIR_EraseRootFromParent_Done,
     /*  108939 */   // Label 1718: @108939
     /*  108939 */   GIM_Reject,
     /*  108940 */ // Label 1716: @108940
     /*  108940 */ GIM_Reject,
     /*  108941 */ // Label 1670: @108941
     /*  108941 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109055),
     /*  108946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  108949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  108952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108964 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109009), // Rule ID 51230 //
     /*  108969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108972 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  108975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  108989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109007 */     GIR_RootConstrainSelectedInstOperands,
     /*  109008 */     // GIR_Coverage, 51230,
     /*  109008 */     GIR_EraseRootFromParent_Done,
     /*  109009 */   // Label 1720: @109009
     /*  109009 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109054), // Rule ID 51231 //
     /*  109014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109017 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  109020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  109034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109052 */     GIR_RootConstrainSelectedInstOperands,
     /*  109053 */     // GIR_Coverage, 51231,
     /*  109053 */     GIR_EraseRootFromParent_Done,
     /*  109054 */   // Label 1721: @109054
     /*  109054 */   GIM_Reject,
     /*  109055 */ // Label 1719: @109055
     /*  109055 */ GIM_Reject,
     /*  109056 */ // Label 1671: @109056
     /*  109056 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109170),
     /*  109061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  109064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  109067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109079 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109124), // Rule ID 51258 //
     /*  109084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109087 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109122 */     GIR_RootConstrainSelectedInstOperands,
     /*  109123 */     // GIR_Coverage, 51258,
     /*  109123 */     GIR_EraseRootFromParent_Done,
     /*  109124 */   // Label 1723: @109124
     /*  109124 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109169), // Rule ID 51259 //
     /*  109129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109132 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  109135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  109149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109167 */     GIR_RootConstrainSelectedInstOperands,
     /*  109168 */     // GIR_Coverage, 51259,
     /*  109168 */     GIR_EraseRootFromParent_Done,
     /*  109169 */   // Label 1724: @109169
     /*  109169 */   GIM_Reject,
     /*  109170 */ // Label 1722: @109170
     /*  109170 */ GIM_Reject,
     /*  109171 */ // Label 1672: @109171
     /*  109171 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109285),
     /*  109176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  109179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  109182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109194 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(109239), // Rule ID 51274 //
     /*  109199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109202 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109237 */     GIR_RootConstrainSelectedInstOperands,
     /*  109238 */     // GIR_Coverage, 51274,
     /*  109238 */     GIR_EraseRootFromParent_Done,
     /*  109239 */   // Label 1726: @109239
     /*  109239 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(109284), // Rule ID 51275 //
     /*  109244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109247 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  109250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  109264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109282 */     GIR_RootConstrainSelectedInstOperands,
     /*  109283 */     // GIR_Coverage, 51275,
     /*  109283 */     GIR_EraseRootFromParent_Done,
     /*  109284 */   // Label 1727: @109284
     /*  109284 */   GIM_Reject,
     /*  109285 */ // Label 1725: @109285
     /*  109285 */ GIM_Reject,
     /*  109286 */ // Label 1673: @109286
     /*  109286 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(109400),
     /*  109291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  109294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  109297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109309 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(109354), // Rule ID 51290 //
     /*  109314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109317 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109352 */     GIR_RootConstrainSelectedInstOperands,
     /*  109353 */     // GIR_Coverage, 51290,
     /*  109353 */     GIR_EraseRootFromParent_Done,
     /*  109354 */   // Label 1729: @109354
     /*  109354 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(109399), // Rule ID 51291 //
     /*  109359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109362 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  109365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  109379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109397 */     GIR_RootConstrainSelectedInstOperands,
     /*  109398 */     // GIR_Coverage, 51291,
     /*  109398 */     GIR_EraseRootFromParent_Done,
     /*  109399 */   // Label 1730: @109399
     /*  109399 */   GIM_Reject,
     /*  109400 */ // Label 1728: @109400
     /*  109400 */ GIM_Reject,
     /*  109401 */ // Label 1674: @109401
     /*  109401 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(109515),
     /*  109406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  109409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  109412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109424 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(109469), // Rule ID 51246 //
     /*  109429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109432 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109467 */     GIR_RootConstrainSelectedInstOperands,
     /*  109468 */     // GIR_Coverage, 51246,
     /*  109468 */     GIR_EraseRootFromParent_Done,
     /*  109469 */   // Label 1732: @109469
     /*  109469 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(109514), // Rule ID 51247 //
     /*  109474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109477 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  109480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  109494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109512 */     GIR_RootConstrainSelectedInstOperands,
     /*  109513 */     // GIR_Coverage, 51247,
     /*  109513 */     GIR_EraseRootFromParent_Done,
     /*  109514 */   // Label 1733: @109514
     /*  109514 */   GIM_Reject,
     /*  109515 */ // Label 1731: @109515
     /*  109515 */ GIM_Reject,
     /*  109516 */ // Label 1675: @109516
     /*  109516 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(109630),
     /*  109521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  109524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  109527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109539 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(109584), // Rule ID 51262 //
     /*  109544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109547 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  109550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  109564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109582 */     GIR_RootConstrainSelectedInstOperands,
     /*  109583 */     // GIR_Coverage, 51262,
     /*  109583 */     GIR_EraseRootFromParent_Done,
     /*  109584 */   // Label 1735: @109584
     /*  109584 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(109629), // Rule ID 51263 //
     /*  109589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109592 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  109595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  109609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109627 */     GIR_RootConstrainSelectedInstOperands,
     /*  109628 */     // GIR_Coverage, 51263,
     /*  109628 */     GIR_EraseRootFromParent_Done,
     /*  109629 */   // Label 1736: @109629
     /*  109629 */   GIM_Reject,
     /*  109630 */ // Label 1734: @109630
     /*  109630 */ GIM_Reject,
     /*  109631 */ // Label 1676: @109631
     /*  109631 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(109745),
     /*  109636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  109639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  109642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109650 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109654 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(109699), // Rule ID 51278 //
     /*  109659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109662 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  109665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  109679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109697 */     GIR_RootConstrainSelectedInstOperands,
     /*  109698 */     // GIR_Coverage, 51278,
     /*  109698 */     GIR_EraseRootFromParent_Done,
     /*  109699 */   // Label 1738: @109699
     /*  109699 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(109744), // Rule ID 51279 //
     /*  109704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109707 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  109710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  109724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109742 */     GIR_RootConstrainSelectedInstOperands,
     /*  109743 */     // GIR_Coverage, 51279,
     /*  109743 */     GIR_EraseRootFromParent_Done,
     /*  109744 */   // Label 1739: @109744
     /*  109744 */   GIM_Reject,
     /*  109745 */ // Label 1737: @109745
     /*  109745 */ GIM_Reject,
     /*  109746 */ // Label 1677: @109746
     /*  109746 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(109860),
     /*  109751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  109754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  109757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  109769 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(109814), // Rule ID 51250 //
     /*  109774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109777 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  109780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  109794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109812 */     GIR_RootConstrainSelectedInstOperands,
     /*  109813 */     // GIR_Coverage, 51250,
     /*  109813 */     GIR_EraseRootFromParent_Done,
     /*  109814 */   // Label 1741: @109814
     /*  109814 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(109859), // Rule ID 51251 //
     /*  109819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109822 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  109825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  109839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109857 */     GIR_RootConstrainSelectedInstOperands,
     /*  109858 */     // GIR_Coverage, 51251,
     /*  109858 */     GIR_EraseRootFromParent_Done,
     /*  109859 */   // Label 1742: @109859
     /*  109859 */   GIM_Reject,
     /*  109860 */ // Label 1740: @109860
     /*  109860 */ GIM_Reject,
     /*  109861 */ // Label 1678: @109861
     /*  109861 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(109975),
     /*  109866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  109869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  109872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109884 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(109929), // Rule ID 51266 //
     /*  109889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109892 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  109895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  109909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109927 */     GIR_RootConstrainSelectedInstOperands,
     /*  109928 */     // GIR_Coverage, 51266,
     /*  109928 */     GIR_EraseRootFromParent_Done,
     /*  109929 */   // Label 1744: @109929
     /*  109929 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(109974), // Rule ID 51267 //
     /*  109934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109937 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  109940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  109954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109972 */     GIR_RootConstrainSelectedInstOperands,
     /*  109973 */     // GIR_Coverage, 51267,
     /*  109973 */     GIR_EraseRootFromParent_Done,
     /*  109974 */   // Label 1745: @109974
     /*  109974 */   GIM_Reject,
     /*  109975 */ // Label 1743: @109975
     /*  109975 */ GIM_Reject,
     /*  109976 */ // Label 1679: @109976
     /*  109976 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110090),
     /*  109981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  109984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  109987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  109999 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110044), // Rule ID 51254 //
     /*  110004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110007 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110042 */     GIR_RootConstrainSelectedInstOperands,
     /*  110043 */     // GIR_Coverage, 51254,
     /*  110043 */     GIR_EraseRootFromParent_Done,
     /*  110044 */   // Label 1747: @110044
     /*  110044 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110089), // Rule ID 51255 //
     /*  110049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110052 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  110055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  110069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110087 */     GIR_RootConstrainSelectedInstOperands,
     /*  110088 */     // GIR_Coverage, 51255,
     /*  110088 */     GIR_EraseRootFromParent_Done,
     /*  110089 */   // Label 1748: @110089
     /*  110089 */   GIM_Reject,
     /*  110090 */ // Label 1746: @110090
     /*  110090 */ GIM_Reject,
     /*  110091 */ // Label 1680: @110091
     /*  110091 */ GIM_Reject,
     /*  110092 */ // Label 4: @110092
     /*  110092 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1773*/ GIMT_Encode4(112825),
     /*  110103 */ /*GILLT_s32*//*Label 1749*/ GIMT_Encode4(110227),
     /*  110107 */ /*GILLT_s64*//*Label 1750*/ GIMT_Encode4(110261), GIMT_Encode4(0),
     /*  110115 */ /*GILLT_nxv1s8*//*Label 1751*/ GIMT_Encode4(110295),
     /*  110119 */ /*GILLT_nxv1s16*//*Label 1752*/ GIMT_Encode4(110410),
     /*  110123 */ /*GILLT_nxv1s32*//*Label 1753*/ GIMT_Encode4(110525),
     /*  110127 */ /*GILLT_nxv1s64*//*Label 1754*/ GIMT_Encode4(110640), GIMT_Encode4(0),
     /*  110135 */ /*GILLT_nxv2s8*//*Label 1755*/ GIMT_Encode4(110755),
     /*  110139 */ /*GILLT_nxv2s16*//*Label 1756*/ GIMT_Encode4(110870),
     /*  110143 */ /*GILLT_nxv2s32*//*Label 1757*/ GIMT_Encode4(110985),
     /*  110147 */ /*GILLT_nxv2s64*//*Label 1758*/ GIMT_Encode4(111100), GIMT_Encode4(0),
     /*  110155 */ /*GILLT_nxv4s8*//*Label 1759*/ GIMT_Encode4(111215),
     /*  110159 */ /*GILLT_nxv4s16*//*Label 1760*/ GIMT_Encode4(111330),
     /*  110163 */ /*GILLT_nxv4s32*//*Label 1761*/ GIMT_Encode4(111445),
     /*  110167 */ /*GILLT_nxv4s64*//*Label 1762*/ GIMT_Encode4(111560), GIMT_Encode4(0),
     /*  110175 */ /*GILLT_nxv8s8*//*Label 1763*/ GIMT_Encode4(111675),
     /*  110179 */ /*GILLT_nxv8s16*//*Label 1764*/ GIMT_Encode4(111790),
     /*  110183 */ /*GILLT_nxv8s32*//*Label 1765*/ GIMT_Encode4(111905),
     /*  110187 */ /*GILLT_nxv8s64*//*Label 1766*/ GIMT_Encode4(112020), GIMT_Encode4(0),
     /*  110195 */ /*GILLT_nxv16s8*//*Label 1767*/ GIMT_Encode4(112135),
     /*  110199 */ /*GILLT_nxv16s16*//*Label 1768*/ GIMT_Encode4(112250),
     /*  110203 */ /*GILLT_nxv16s32*//*Label 1769*/ GIMT_Encode4(112365), GIMT_Encode4(0),
     /*  110211 */ /*GILLT_nxv32s8*//*Label 1770*/ GIMT_Encode4(112480),
     /*  110215 */ /*GILLT_nxv32s16*//*Label 1771*/ GIMT_Encode4(112595), GIMT_Encode4(0),
     /*  110223 */ /*GILLT_nxv64s8*//*Label 1772*/ GIMT_Encode4(112710),
     /*  110227 */ // Label 1749: @110227
     /*  110227 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(110260), // Rule ID 308 //
     /*  110232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  110235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  110238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  110241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110253 */   // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIVU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  110253 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110258 */   GIR_RootConstrainSelectedInstOperands,
     /*  110259 */   // GIR_Coverage, 308,
     /*  110259 */   GIR_Done,
     /*  110260 */ // Label 1774: @110260
     /*  110260 */ GIM_Reject,
     /*  110261 */ // Label 1750: @110261
     /*  110261 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(110294), // Rule ID 307 //
     /*  110266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  110269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  110272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  110275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  110287 */   // (udiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  110287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  110292 */   GIR_RootConstrainSelectedInstOperands,
     /*  110293 */   // GIR_Coverage, 307,
     /*  110293 */   GIR_Done,
     /*  110294 */ // Label 1775: @110294
     /*  110294 */ GIM_Reject,
     /*  110295 */ // Label 1751: @110295
     /*  110295 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(110409),
     /*  110300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  110303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  110306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110318 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(110363), // Rule ID 51118 //
     /*  110323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110326 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110361 */     GIR_RootConstrainSelectedInstOperands,
     /*  110362 */     // GIR_Coverage, 51118,
     /*  110362 */     GIR_EraseRootFromParent_Done,
     /*  110363 */   // Label 1777: @110363
     /*  110363 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(110408), // Rule ID 51119 //
     /*  110368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110371 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  110374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  110388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110406 */     GIR_RootConstrainSelectedInstOperands,
     /*  110407 */     // GIR_Coverage, 51119,
     /*  110407 */     GIR_EraseRootFromParent_Done,
     /*  110408 */   // Label 1778: @110408
     /*  110408 */   GIM_Reject,
     /*  110409 */ // Label 1776: @110409
     /*  110409 */ GIM_Reject,
     /*  110410 */ // Label 1752: @110410
     /*  110410 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(110524),
     /*  110415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  110418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  110421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110433 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(110478), // Rule ID 51130 //
     /*  110438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110441 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110476 */     GIR_RootConstrainSelectedInstOperands,
     /*  110477 */     // GIR_Coverage, 51130,
     /*  110477 */     GIR_EraseRootFromParent_Done,
     /*  110478 */   // Label 1780: @110478
     /*  110478 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(110523), // Rule ID 51131 //
     /*  110483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110486 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  110489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  110503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110521 */     GIR_RootConstrainSelectedInstOperands,
     /*  110522 */     // GIR_Coverage, 51131,
     /*  110522 */     GIR_EraseRootFromParent_Done,
     /*  110523 */   // Label 1781: @110523
     /*  110523 */   GIM_Reject,
     /*  110524 */ // Label 1779: @110524
     /*  110524 */ GIM_Reject,
     /*  110525 */ // Label 1753: @110525
     /*  110525 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(110639),
     /*  110530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  110533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  110536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110548 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(110593), // Rule ID 51138 //
     /*  110553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110556 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  110556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  110559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  110573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110591 */     GIR_RootConstrainSelectedInstOperands,
     /*  110592 */     // GIR_Coverage, 51138,
     /*  110592 */     GIR_EraseRootFromParent_Done,
     /*  110593 */   // Label 1783: @110593
     /*  110593 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(110638), // Rule ID 51139 //
     /*  110598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110601 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  110601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  110604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  110618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110636 */     GIR_RootConstrainSelectedInstOperands,
     /*  110637 */     // GIR_Coverage, 51139,
     /*  110637 */     GIR_EraseRootFromParent_Done,
     /*  110638 */   // Label 1784: @110638
     /*  110638 */   GIM_Reject,
     /*  110639 */ // Label 1782: @110639
     /*  110639 */ GIM_Reject,
     /*  110640 */ // Label 1754: @110640
     /*  110640 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(110754),
     /*  110645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  110648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  110651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110663 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(110708), // Rule ID 51154 //
     /*  110668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  110671 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  110671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  110674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  110688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110706 */     GIR_RootConstrainSelectedInstOperands,
     /*  110707 */     // GIR_Coverage, 51154,
     /*  110707 */     GIR_EraseRootFromParent_Done,
     /*  110708 */   // Label 1786: @110708
     /*  110708 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(110753), // Rule ID 51155 //
     /*  110713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  110716 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  110716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  110719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  110733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110751 */     GIR_RootConstrainSelectedInstOperands,
     /*  110752 */     // GIR_Coverage, 51155,
     /*  110752 */     GIR_EraseRootFromParent_Done,
     /*  110753 */   // Label 1787: @110753
     /*  110753 */   GIM_Reject,
     /*  110754 */ // Label 1785: @110754
     /*  110754 */ GIM_Reject,
     /*  110755 */ // Label 1755: @110755
     /*  110755 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(110869),
     /*  110760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  110763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  110766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110778 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(110823), // Rule ID 51122 //
     /*  110783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110786 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  110789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  110803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110821 */     GIR_RootConstrainSelectedInstOperands,
     /*  110822 */     // GIR_Coverage, 51122,
     /*  110822 */     GIR_EraseRootFromParent_Done,
     /*  110823 */   // Label 1789: @110823
     /*  110823 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(110868), // Rule ID 51123 //
     /*  110828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110831 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  110834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  110848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110866 */     GIR_RootConstrainSelectedInstOperands,
     /*  110867 */     // GIR_Coverage, 51123,
     /*  110867 */     GIR_EraseRootFromParent_Done,
     /*  110868 */   // Label 1790: @110868
     /*  110868 */   GIM_Reject,
     /*  110869 */ // Label 1788: @110869
     /*  110869 */ GIM_Reject,
     /*  110870 */ // Label 1756: @110870
     /*  110870 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(110984),
     /*  110875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  110878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  110881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110893 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(110938), // Rule ID 51134 //
     /*  110898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110901 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  110904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  110918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110936 */     GIR_RootConstrainSelectedInstOperands,
     /*  110937 */     // GIR_Coverage, 51134,
     /*  110937 */     GIR_EraseRootFromParent_Done,
     /*  110938 */   // Label 1792: @110938
     /*  110938 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(110983), // Rule ID 51135 //
     /*  110943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110946 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  110949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  110963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110981 */     GIR_RootConstrainSelectedInstOperands,
     /*  110982 */     // GIR_Coverage, 51135,
     /*  110982 */     GIR_EraseRootFromParent_Done,
     /*  110983 */   // Label 1793: @110983
     /*  110983 */   GIM_Reject,
     /*  110984 */ // Label 1791: @110984
     /*  110984 */ GIM_Reject,
     /*  110985 */ // Label 1757: @110985
     /*  110985 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(111099),
     /*  110990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  110993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  110996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111008 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(111053), // Rule ID 51150 //
     /*  111013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111016 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111051 */     GIR_RootConstrainSelectedInstOperands,
     /*  111052 */     // GIR_Coverage, 51150,
     /*  111052 */     GIR_EraseRootFromParent_Done,
     /*  111053 */   // Label 1795: @111053
     /*  111053 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(111098), // Rule ID 51151 //
     /*  111058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111061 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  111064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  111078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111096 */     GIR_RootConstrainSelectedInstOperands,
     /*  111097 */     // GIR_Coverage, 51151,
     /*  111097 */     GIR_EraseRootFromParent_Done,
     /*  111098 */   // Label 1796: @111098
     /*  111098 */   GIM_Reject,
     /*  111099 */ // Label 1794: @111099
     /*  111099 */ GIM_Reject,
     /*  111100 */ // Label 1758: @111100
     /*  111100 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(111214),
     /*  111105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  111108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  111111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111123 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(111168), // Rule ID 51194 //
     /*  111128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111131 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111166 */     GIR_RootConstrainSelectedInstOperands,
     /*  111167 */     // GIR_Coverage, 51194,
     /*  111167 */     GIR_EraseRootFromParent_Done,
     /*  111168 */   // Label 1798: @111168
     /*  111168 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(111213), // Rule ID 51195 //
     /*  111173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111176 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  111179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  111193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111211 */     GIR_RootConstrainSelectedInstOperands,
     /*  111212 */     // GIR_Coverage, 51195,
     /*  111212 */     GIR_EraseRootFromParent_Done,
     /*  111213 */   // Label 1799: @111213
     /*  111213 */   GIM_Reject,
     /*  111214 */ // Label 1797: @111214
     /*  111214 */ GIM_Reject,
     /*  111215 */ // Label 1759: @111215
     /*  111215 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(111329),
     /*  111220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  111223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  111226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111238 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(111283), // Rule ID 51126 //
     /*  111243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111246 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111281 */     GIR_RootConstrainSelectedInstOperands,
     /*  111282 */     // GIR_Coverage, 51126,
     /*  111282 */     GIR_EraseRootFromParent_Done,
     /*  111283 */   // Label 1801: @111283
     /*  111283 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(111328), // Rule ID 51127 //
     /*  111288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111291 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  111294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  111308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111326 */     GIR_RootConstrainSelectedInstOperands,
     /*  111327 */     // GIR_Coverage, 51127,
     /*  111327 */     GIR_EraseRootFromParent_Done,
     /*  111328 */   // Label 1802: @111328
     /*  111328 */   GIM_Reject,
     /*  111329 */ // Label 1800: @111329
     /*  111329 */ GIM_Reject,
     /*  111330 */ // Label 1760: @111330
     /*  111330 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(111444),
     /*  111335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  111338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  111341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111353 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(111398), // Rule ID 51146 //
     /*  111358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111361 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111396 */     GIR_RootConstrainSelectedInstOperands,
     /*  111397 */     // GIR_Coverage, 51146,
     /*  111397 */     GIR_EraseRootFromParent_Done,
     /*  111398 */   // Label 1804: @111398
     /*  111398 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(111443), // Rule ID 51147 //
     /*  111403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111406 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  111409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  111423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111441 */     GIR_RootConstrainSelectedInstOperands,
     /*  111442 */     // GIR_Coverage, 51147,
     /*  111442 */     GIR_EraseRootFromParent_Done,
     /*  111443 */   // Label 1805: @111443
     /*  111443 */   GIM_Reject,
     /*  111444 */ // Label 1803: @111444
     /*  111444 */ GIM_Reject,
     /*  111445 */ // Label 1761: @111445
     /*  111445 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(111559),
     /*  111450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  111453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  111456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111468 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(111513), // Rule ID 51182 //
     /*  111473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111476 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111511 */     GIR_RootConstrainSelectedInstOperands,
     /*  111512 */     // GIR_Coverage, 51182,
     /*  111512 */     GIR_EraseRootFromParent_Done,
     /*  111513 */   // Label 1807: @111513
     /*  111513 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(111558), // Rule ID 51183 //
     /*  111518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111521 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  111524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  111538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111556 */     GIR_RootConstrainSelectedInstOperands,
     /*  111557 */     // GIR_Coverage, 51183,
     /*  111557 */     GIR_EraseRootFromParent_Done,
     /*  111558 */   // Label 1808: @111558
     /*  111558 */   GIM_Reject,
     /*  111559 */ // Label 1806: @111559
     /*  111559 */ GIM_Reject,
     /*  111560 */ // Label 1762: @111560
     /*  111560 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(111674),
     /*  111565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  111568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  111571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111583 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(111628), // Rule ID 51198 //
     /*  111588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  111591 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  111591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  111594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  111608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111626 */     GIR_RootConstrainSelectedInstOperands,
     /*  111627 */     // GIR_Coverage, 51198,
     /*  111627 */     GIR_EraseRootFromParent_Done,
     /*  111628 */   // Label 1810: @111628
     /*  111628 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(111673), // Rule ID 51199 //
     /*  111633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  111636 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  111636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  111639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  111653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  111668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111671 */     GIR_RootConstrainSelectedInstOperands,
     /*  111672 */     // GIR_Coverage, 51199,
     /*  111672 */     GIR_EraseRootFromParent_Done,
     /*  111673 */   // Label 1811: @111673
     /*  111673 */   GIM_Reject,
     /*  111674 */ // Label 1809: @111674
     /*  111674 */ GIM_Reject,
     /*  111675 */ // Label 1763: @111675
     /*  111675 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(111789),
     /*  111680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  111683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  111686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111698 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(111743), // Rule ID 51142 //
     /*  111703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111706 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  111709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  111723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111741 */     GIR_RootConstrainSelectedInstOperands,
     /*  111742 */     // GIR_Coverage, 51142,
     /*  111742 */     GIR_EraseRootFromParent_Done,
     /*  111743 */   // Label 1813: @111743
     /*  111743 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(111788), // Rule ID 51143 //
     /*  111748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111751 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  111754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  111768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111786 */     GIR_RootConstrainSelectedInstOperands,
     /*  111787 */     // GIR_Coverage, 51143,
     /*  111787 */     GIR_EraseRootFromParent_Done,
     /*  111788 */   // Label 1814: @111788
     /*  111788 */   GIM_Reject,
     /*  111789 */ // Label 1812: @111789
     /*  111789 */ GIM_Reject,
     /*  111790 */ // Label 1764: @111790
     /*  111790 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(111904),
     /*  111795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  111798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  111801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  111813 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(111858), // Rule ID 51170 //
     /*  111818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111821 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  111824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  111838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111856 */     GIR_RootConstrainSelectedInstOperands,
     /*  111857 */     // GIR_Coverage, 51170,
     /*  111857 */     GIR_EraseRootFromParent_Done,
     /*  111858 */   // Label 1816: @111858
     /*  111858 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(111903), // Rule ID 51171 //
     /*  111863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111866 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  111869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  111883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111901 */     GIR_RootConstrainSelectedInstOperands,
     /*  111902 */     // GIR_Coverage, 51171,
     /*  111902 */     GIR_EraseRootFromParent_Done,
     /*  111903 */   // Label 1817: @111903
     /*  111903 */   GIM_Reject,
     /*  111904 */ // Label 1815: @111904
     /*  111904 */ GIM_Reject,
     /*  111905 */ // Label 1765: @111905
     /*  111905 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112019),
     /*  111910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  111913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  111916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111928 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(111973), // Rule ID 51186 //
     /*  111933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111936 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  111939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  111953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111971 */     GIR_RootConstrainSelectedInstOperands,
     /*  111972 */     // GIR_Coverage, 51186,
     /*  111972 */     GIR_EraseRootFromParent_Done,
     /*  111973 */   // Label 1819: @111973
     /*  111973 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112018), // Rule ID 51187 //
     /*  111978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111981 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  111984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  111998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112016 */     GIR_RootConstrainSelectedInstOperands,
     /*  112017 */     // GIR_Coverage, 51187,
     /*  112017 */     GIR_EraseRootFromParent_Done,
     /*  112018 */   // Label 1820: @112018
     /*  112018 */   GIM_Reject,
     /*  112019 */ // Label 1818: @112019
     /*  112019 */ GIM_Reject,
     /*  112020 */ // Label 1766: @112020
     /*  112020 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112134),
     /*  112025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  112028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  112031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112043 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112088), // Rule ID 51202 //
     /*  112048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112051 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112086 */     GIR_RootConstrainSelectedInstOperands,
     /*  112087 */     // GIR_Coverage, 51202,
     /*  112087 */     GIR_EraseRootFromParent_Done,
     /*  112088 */   // Label 1822: @112088
     /*  112088 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112133), // Rule ID 51203 //
     /*  112093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112096 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  112099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  112113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112131 */     GIR_RootConstrainSelectedInstOperands,
     /*  112132 */     // GIR_Coverage, 51203,
     /*  112132 */     GIR_EraseRootFromParent_Done,
     /*  112133 */   // Label 1823: @112133
     /*  112133 */   GIM_Reject,
     /*  112134 */ // Label 1821: @112134
     /*  112134 */ GIM_Reject,
     /*  112135 */ // Label 1767: @112135
     /*  112135 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112249),
     /*  112140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  112143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  112146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112158 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(112203), // Rule ID 51158 //
     /*  112163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112166 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112201 */     GIR_RootConstrainSelectedInstOperands,
     /*  112202 */     // GIR_Coverage, 51158,
     /*  112202 */     GIR_EraseRootFromParent_Done,
     /*  112203 */   // Label 1825: @112203
     /*  112203 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(112248), // Rule ID 51159 //
     /*  112208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112211 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  112214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  112228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112246 */     GIR_RootConstrainSelectedInstOperands,
     /*  112247 */     // GIR_Coverage, 51159,
     /*  112247 */     GIR_EraseRootFromParent_Done,
     /*  112248 */   // Label 1826: @112248
     /*  112248 */   GIM_Reject,
     /*  112249 */ // Label 1824: @112249
     /*  112249 */ GIM_Reject,
     /*  112250 */ // Label 1768: @112250
     /*  112250 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(112364),
     /*  112255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  112258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  112261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112273 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(112318), // Rule ID 51174 //
     /*  112278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112281 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112316 */     GIR_RootConstrainSelectedInstOperands,
     /*  112317 */     // GIR_Coverage, 51174,
     /*  112317 */     GIR_EraseRootFromParent_Done,
     /*  112318 */   // Label 1828: @112318
     /*  112318 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(112363), // Rule ID 51175 //
     /*  112323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112326 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  112329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  112343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112361 */     GIR_RootConstrainSelectedInstOperands,
     /*  112362 */     // GIR_Coverage, 51175,
     /*  112362 */     GIR_EraseRootFromParent_Done,
     /*  112363 */   // Label 1829: @112363
     /*  112363 */   GIM_Reject,
     /*  112364 */ // Label 1827: @112364
     /*  112364 */ GIM_Reject,
     /*  112365 */ // Label 1769: @112365
     /*  112365 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(112479),
     /*  112370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  112373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  112376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112388 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(112433), // Rule ID 51190 //
     /*  112393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112396 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112431 */     GIR_RootConstrainSelectedInstOperands,
     /*  112432 */     // GIR_Coverage, 51190,
     /*  112432 */     GIR_EraseRootFromParent_Done,
     /*  112433 */   // Label 1831: @112433
     /*  112433 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(112478), // Rule ID 51191 //
     /*  112438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112441 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  112444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  112458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112476 */     GIR_RootConstrainSelectedInstOperands,
     /*  112477 */     // GIR_Coverage, 51191,
     /*  112477 */     GIR_EraseRootFromParent_Done,
     /*  112478 */   // Label 1832: @112478
     /*  112478 */   GIM_Reject,
     /*  112479 */ // Label 1830: @112479
     /*  112479 */ GIM_Reject,
     /*  112480 */ // Label 1770: @112480
     /*  112480 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(112594),
     /*  112485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  112488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  112491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112503 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(112548), // Rule ID 51162 //
     /*  112508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112511 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  112528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112546 */     GIR_RootConstrainSelectedInstOperands,
     /*  112547 */     // GIR_Coverage, 51162,
     /*  112547 */     GIR_EraseRootFromParent_Done,
     /*  112548 */   // Label 1834: @112548
     /*  112548 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(112593), // Rule ID 51163 //
     /*  112553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112556 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  112559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  112573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112591 */     GIR_RootConstrainSelectedInstOperands,
     /*  112592 */     // GIR_Coverage, 51163,
     /*  112592 */     GIR_EraseRootFromParent_Done,
     /*  112593 */   // Label 1835: @112593
     /*  112593 */   GIM_Reject,
     /*  112594 */ // Label 1833: @112594
     /*  112594 */ GIM_Reject,
     /*  112595 */ // Label 1771: @112595
     /*  112595 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(112709),
     /*  112600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  112603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  112606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112618 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(112663), // Rule ID 51178 //
     /*  112623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112626 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  112629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  112643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112661 */     GIR_RootConstrainSelectedInstOperands,
     /*  112662 */     // GIR_Coverage, 51178,
     /*  112662 */     GIR_EraseRootFromParent_Done,
     /*  112663 */   // Label 1837: @112663
     /*  112663 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(112708), // Rule ID 51179 //
     /*  112668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112671 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  112674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  112688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112706 */     GIR_RootConstrainSelectedInstOperands,
     /*  112707 */     // GIR_Coverage, 51179,
     /*  112707 */     GIR_EraseRootFromParent_Done,
     /*  112708 */   // Label 1838: @112708
     /*  112708 */   GIM_Reject,
     /*  112709 */ // Label 1836: @112709
     /*  112709 */ GIM_Reject,
     /*  112710 */ // Label 1772: @112710
     /*  112710 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(112824),
     /*  112715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  112718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  112721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  112733 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(112778), // Rule ID 51166 //
     /*  112738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112741 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  112744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  112758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112776 */     GIR_RootConstrainSelectedInstOperands,
     /*  112777 */     // GIR_Coverage, 51166,
     /*  112777 */     GIR_EraseRootFromParent_Done,
     /*  112778 */   // Label 1840: @112778
     /*  112778 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(112823), // Rule ID 51167 //
     /*  112783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112786 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  112789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  112803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112821 */     GIR_RootConstrainSelectedInstOperands,
     /*  112822 */     // GIR_Coverage, 51167,
     /*  112822 */     GIR_EraseRootFromParent_Done,
     /*  112823 */   // Label 1841: @112823
     /*  112823 */   GIM_Reject,
     /*  112824 */ // Label 1839: @112824
     /*  112824 */ GIM_Reject,
     /*  112825 */ // Label 1773: @112825
     /*  112825 */ GIM_Reject,
     /*  112826 */ // Label 5: @112826
     /*  112826 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1866*/ GIMT_Encode4(115604),
     /*  112837 */ /*GILLT_s32*//*Label 1842*/ GIMT_Encode4(112961),
     /*  112841 */ /*GILLT_s64*//*Label 1843*/ GIMT_Encode4(112995), GIMT_Encode4(0),
     /*  112849 */ /*GILLT_nxv1s8*//*Label 1844*/ GIMT_Encode4(113074),
     /*  112853 */ /*GILLT_nxv1s16*//*Label 1845*/ GIMT_Encode4(113189),
     /*  112857 */ /*GILLT_nxv1s32*//*Label 1846*/ GIMT_Encode4(113304),
     /*  112861 */ /*GILLT_nxv1s64*//*Label 1847*/ GIMT_Encode4(113419), GIMT_Encode4(0),
     /*  112869 */ /*GILLT_nxv2s8*//*Label 1848*/ GIMT_Encode4(113534),
     /*  112873 */ /*GILLT_nxv2s16*//*Label 1849*/ GIMT_Encode4(113649),
     /*  112877 */ /*GILLT_nxv2s32*//*Label 1850*/ GIMT_Encode4(113764),
     /*  112881 */ /*GILLT_nxv2s64*//*Label 1851*/ GIMT_Encode4(113879), GIMT_Encode4(0),
     /*  112889 */ /*GILLT_nxv4s8*//*Label 1852*/ GIMT_Encode4(113994),
     /*  112893 */ /*GILLT_nxv4s16*//*Label 1853*/ GIMT_Encode4(114109),
     /*  112897 */ /*GILLT_nxv4s32*//*Label 1854*/ GIMT_Encode4(114224),
     /*  112901 */ /*GILLT_nxv4s64*//*Label 1855*/ GIMT_Encode4(114339), GIMT_Encode4(0),
     /*  112909 */ /*GILLT_nxv8s8*//*Label 1856*/ GIMT_Encode4(114454),
     /*  112913 */ /*GILLT_nxv8s16*//*Label 1857*/ GIMT_Encode4(114569),
     /*  112917 */ /*GILLT_nxv8s32*//*Label 1858*/ GIMT_Encode4(114684),
     /*  112921 */ /*GILLT_nxv8s64*//*Label 1859*/ GIMT_Encode4(114799), GIMT_Encode4(0),
     /*  112929 */ /*GILLT_nxv16s8*//*Label 1860*/ GIMT_Encode4(114914),
     /*  112933 */ /*GILLT_nxv16s16*//*Label 1861*/ GIMT_Encode4(115029),
     /*  112937 */ /*GILLT_nxv16s32*//*Label 1862*/ GIMT_Encode4(115144), GIMT_Encode4(0),
     /*  112945 */ /*GILLT_nxv32s8*//*Label 1863*/ GIMT_Encode4(115259),
     /*  112949 */ /*GILLT_nxv32s16*//*Label 1864*/ GIMT_Encode4(115374), GIMT_Encode4(0),
     /*  112957 */ /*GILLT_nxv64s8*//*Label 1865*/ GIMT_Encode4(115489),
     /*  112961 */ // Label 1842: @112961
     /*  112961 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(112994), // Rule ID 310 //
     /*  112966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  112969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  112972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  112975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  112987 */   // (srem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REM:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  112987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  112992 */   GIR_RootConstrainSelectedInstOperands,
     /*  112993 */   // GIR_Coverage, 310,
     /*  112993 */   GIR_Done,
     /*  112994 */ // Label 1867: @112994
     /*  112994 */ GIM_Reject,
     /*  112995 */ // Label 1843: @112995
     /*  112995 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(113073),
     /*  113000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  113003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  113006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113010 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(113049), // Rule ID 319 //
     /*  113015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /*  113018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /*  113025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_sexti32),
     /*  113032 */     // (srem:{ *:[i64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (REMW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::REMW),
     /*  113035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  113042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  113047 */     GIR_RootConstrainSelectedInstOperands,
     /*  113048 */     // GIR_Coverage, 319,
     /*  113048 */     GIR_EraseRootFromParent_Done,
     /*  113049 */   // Label 1869: @113049
     /*  113049 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(113072), // Rule ID 309 //
     /*  113054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  113057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  113065 */     // (srem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  113065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  113070 */     GIR_RootConstrainSelectedInstOperands,
     /*  113071 */     // GIR_Coverage, 309,
     /*  113071 */     GIR_Done,
     /*  113072 */   // Label 1870: @113072
     /*  113072 */   GIM_Reject,
     /*  113073 */ // Label 1868: @113073
     /*  113073 */ GIM_Reject,
     /*  113074 */ // Label 1844: @113074
     /*  113074 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(113188),
     /*  113079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  113082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  113085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113097 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(113142), // Rule ID 51382 //
     /*  113102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113105 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113140 */     GIR_RootConstrainSelectedInstOperands,
     /*  113141 */     // GIR_Coverage, 51382,
     /*  113141 */     GIR_EraseRootFromParent_Done,
     /*  113142 */   // Label 1872: @113142
     /*  113142 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(113187), // Rule ID 51383 //
     /*  113147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113150 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  113153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  113167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113185 */     GIR_RootConstrainSelectedInstOperands,
     /*  113186 */     // GIR_Coverage, 51383,
     /*  113186 */     GIR_EraseRootFromParent_Done,
     /*  113187 */   // Label 1873: @113187
     /*  113187 */   GIM_Reject,
     /*  113188 */ // Label 1871: @113188
     /*  113188 */ GIM_Reject,
     /*  113189 */ // Label 1845: @113189
     /*  113189 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(113303),
     /*  113194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  113197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  113200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113212 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(113257), // Rule ID 51394 //
     /*  113217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113220 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113255 */     GIR_RootConstrainSelectedInstOperands,
     /*  113256 */     // GIR_Coverage, 51394,
     /*  113256 */     GIR_EraseRootFromParent_Done,
     /*  113257 */   // Label 1875: @113257
     /*  113257 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(113302), // Rule ID 51395 //
     /*  113262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113265 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  113268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  113282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113300 */     GIR_RootConstrainSelectedInstOperands,
     /*  113301 */     // GIR_Coverage, 51395,
     /*  113301 */     GIR_EraseRootFromParent_Done,
     /*  113302 */   // Label 1876: @113302
     /*  113302 */   GIM_Reject,
     /*  113303 */ // Label 1874: @113303
     /*  113303 */ GIM_Reject,
     /*  113304 */ // Label 1846: @113304
     /*  113304 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(113418),
     /*  113309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  113312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  113315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113327 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(113372), // Rule ID 51402 //
     /*  113332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113335 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113370 */     GIR_RootConstrainSelectedInstOperands,
     /*  113371 */     // GIR_Coverage, 51402,
     /*  113371 */     GIR_EraseRootFromParent_Done,
     /*  113372 */   // Label 1878: @113372
     /*  113372 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(113417), // Rule ID 51403 //
     /*  113377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113380 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  113383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  113397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113415 */     GIR_RootConstrainSelectedInstOperands,
     /*  113416 */     // GIR_Coverage, 51403,
     /*  113416 */     GIR_EraseRootFromParent_Done,
     /*  113417 */   // Label 1879: @113417
     /*  113417 */   GIM_Reject,
     /*  113418 */ // Label 1877: @113418
     /*  113418 */ GIM_Reject,
     /*  113419 */ // Label 1847: @113419
     /*  113419 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(113533),
     /*  113424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  113427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  113430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113442 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(113487), // Rule ID 51418 //
     /*  113447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113450 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113485 */     GIR_RootConstrainSelectedInstOperands,
     /*  113486 */     // GIR_Coverage, 51418,
     /*  113486 */     GIR_EraseRootFromParent_Done,
     /*  113487 */   // Label 1881: @113487
     /*  113487 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(113532), // Rule ID 51419 //
     /*  113492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113495 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  113498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  113512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113530 */     GIR_RootConstrainSelectedInstOperands,
     /*  113531 */     // GIR_Coverage, 51419,
     /*  113531 */     GIR_EraseRootFromParent_Done,
     /*  113532 */   // Label 1882: @113532
     /*  113532 */   GIM_Reject,
     /*  113533 */ // Label 1880: @113533
     /*  113533 */ GIM_Reject,
     /*  113534 */ // Label 1848: @113534
     /*  113534 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(113648),
     /*  113539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  113542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  113545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113557 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(113602), // Rule ID 51386 //
     /*  113562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113565 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  113568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  113582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113600 */     GIR_RootConstrainSelectedInstOperands,
     /*  113601 */     // GIR_Coverage, 51386,
     /*  113601 */     GIR_EraseRootFromParent_Done,
     /*  113602 */   // Label 1884: @113602
     /*  113602 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(113647), // Rule ID 51387 //
     /*  113607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113610 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  113613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  113627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113645 */     GIR_RootConstrainSelectedInstOperands,
     /*  113646 */     // GIR_Coverage, 51387,
     /*  113646 */     GIR_EraseRootFromParent_Done,
     /*  113647 */   // Label 1885: @113647
     /*  113647 */   GIM_Reject,
     /*  113648 */ // Label 1883: @113648
     /*  113648 */ GIM_Reject,
     /*  113649 */ // Label 1849: @113649
     /*  113649 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(113763),
     /*  113654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  113657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  113660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113672 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(113717), // Rule ID 51398 //
     /*  113677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113680 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  113683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  113697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113715 */     GIR_RootConstrainSelectedInstOperands,
     /*  113716 */     // GIR_Coverage, 51398,
     /*  113716 */     GIR_EraseRootFromParent_Done,
     /*  113717 */   // Label 1887: @113717
     /*  113717 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(113762), // Rule ID 51399 //
     /*  113722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113725 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  113728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  113742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113760 */     GIR_RootConstrainSelectedInstOperands,
     /*  113761 */     // GIR_Coverage, 51399,
     /*  113761 */     GIR_EraseRootFromParent_Done,
     /*  113762 */   // Label 1888: @113762
     /*  113762 */   GIM_Reject,
     /*  113763 */ // Label 1886: @113763
     /*  113763 */ GIM_Reject,
     /*  113764 */ // Label 1850: @113764
     /*  113764 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(113878),
     /*  113769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  113772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  113775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113787 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(113832), // Rule ID 51414 //
     /*  113792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113795 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  113798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  113812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113830 */     GIR_RootConstrainSelectedInstOperands,
     /*  113831 */     // GIR_Coverage, 51414,
     /*  113831 */     GIR_EraseRootFromParent_Done,
     /*  113832 */   // Label 1890: @113832
     /*  113832 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(113877), // Rule ID 51415 //
     /*  113837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113840 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  113843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  113857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113875 */     GIR_RootConstrainSelectedInstOperands,
     /*  113876 */     // GIR_Coverage, 51415,
     /*  113876 */     GIR_EraseRootFromParent_Done,
     /*  113877 */   // Label 1891: @113877
     /*  113877 */   GIM_Reject,
     /*  113878 */ // Label 1889: @113878
     /*  113878 */ GIM_Reject,
     /*  113879 */ // Label 1851: @113879
     /*  113879 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(113993),
     /*  113884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  113887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  113890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113902 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(113947), // Rule ID 51458 //
     /*  113907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113910 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  113913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  113927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113945 */     GIR_RootConstrainSelectedInstOperands,
     /*  113946 */     // GIR_Coverage, 51458,
     /*  113946 */     GIR_EraseRootFromParent_Done,
     /*  113947 */   // Label 1893: @113947
     /*  113947 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(113992), // Rule ID 51459 //
     /*  113952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113955 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  113958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  113972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113990 */     GIR_RootConstrainSelectedInstOperands,
     /*  113991 */     // GIR_Coverage, 51459,
     /*  113991 */     GIR_EraseRootFromParent_Done,
     /*  113992 */   // Label 1894: @113992
     /*  113992 */   GIM_Reject,
     /*  113993 */ // Label 1892: @113993
     /*  113993 */ GIM_Reject,
     /*  113994 */ // Label 1852: @113994
     /*  113994 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(114108),
     /*  113999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  114002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  114005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114017 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(114062), // Rule ID 51390 //
     /*  114022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114025 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114047 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114060 */     GIR_RootConstrainSelectedInstOperands,
     /*  114061 */     // GIR_Coverage, 51390,
     /*  114061 */     GIR_EraseRootFromParent_Done,
     /*  114062 */   // Label 1896: @114062
     /*  114062 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(114107), // Rule ID 51391 //
     /*  114067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114070 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  114073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  114087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114105 */     GIR_RootConstrainSelectedInstOperands,
     /*  114106 */     // GIR_Coverage, 51391,
     /*  114106 */     GIR_EraseRootFromParent_Done,
     /*  114107 */   // Label 1897: @114107
     /*  114107 */   GIM_Reject,
     /*  114108 */ // Label 1895: @114108
     /*  114108 */ GIM_Reject,
     /*  114109 */ // Label 1853: @114109
     /*  114109 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(114223),
     /*  114114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  114117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  114120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114132 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(114177), // Rule ID 51410 //
     /*  114137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114140 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114175 */     GIR_RootConstrainSelectedInstOperands,
     /*  114176 */     // GIR_Coverage, 51410,
     /*  114176 */     GIR_EraseRootFromParent_Done,
     /*  114177 */   // Label 1899: @114177
     /*  114177 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(114222), // Rule ID 51411 //
     /*  114182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114185 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  114188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  114202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114220 */     GIR_RootConstrainSelectedInstOperands,
     /*  114221 */     // GIR_Coverage, 51411,
     /*  114221 */     GIR_EraseRootFromParent_Done,
     /*  114222 */   // Label 1900: @114222
     /*  114222 */   GIM_Reject,
     /*  114223 */ // Label 1898: @114223
     /*  114223 */ GIM_Reject,
     /*  114224 */ // Label 1854: @114224
     /*  114224 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(114338),
     /*  114229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  114232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  114235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114247 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(114292), // Rule ID 51446 //
     /*  114252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114255 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114290 */     GIR_RootConstrainSelectedInstOperands,
     /*  114291 */     // GIR_Coverage, 51446,
     /*  114291 */     GIR_EraseRootFromParent_Done,
     /*  114292 */   // Label 1902: @114292
     /*  114292 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(114337), // Rule ID 51447 //
     /*  114297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114300 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  114303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  114317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114335 */     GIR_RootConstrainSelectedInstOperands,
     /*  114336 */     // GIR_Coverage, 51447,
     /*  114336 */     GIR_EraseRootFromParent_Done,
     /*  114337 */   // Label 1903: @114337
     /*  114337 */   GIM_Reject,
     /*  114338 */ // Label 1901: @114338
     /*  114338 */ GIM_Reject,
     /*  114339 */ // Label 1855: @114339
     /*  114339 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(114453),
     /*  114344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  114347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  114350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114362 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(114407), // Rule ID 51462 //
     /*  114367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114370 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114405 */     GIR_RootConstrainSelectedInstOperands,
     /*  114406 */     // GIR_Coverage, 51462,
     /*  114406 */     GIR_EraseRootFromParent_Done,
     /*  114407 */   // Label 1905: @114407
     /*  114407 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(114452), // Rule ID 51463 //
     /*  114412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114415 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  114418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  114432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114450 */     GIR_RootConstrainSelectedInstOperands,
     /*  114451 */     // GIR_Coverage, 51463,
     /*  114451 */     GIR_EraseRootFromParent_Done,
     /*  114452 */   // Label 1906: @114452
     /*  114452 */   GIM_Reject,
     /*  114453 */ // Label 1904: @114453
     /*  114453 */ GIM_Reject,
     /*  114454 */ // Label 1856: @114454
     /*  114454 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(114568),
     /*  114459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  114462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  114465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  114477 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(114522), // Rule ID 51406 //
     /*  114482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114485 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114520 */     GIR_RootConstrainSelectedInstOperands,
     /*  114521 */     // GIR_Coverage, 51406,
     /*  114521 */     GIR_EraseRootFromParent_Done,
     /*  114522 */   // Label 1908: @114522
     /*  114522 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(114567), // Rule ID 51407 //
     /*  114527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114530 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  114533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  114547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114565 */     GIR_RootConstrainSelectedInstOperands,
     /*  114566 */     // GIR_Coverage, 51407,
     /*  114566 */     GIR_EraseRootFromParent_Done,
     /*  114567 */   // Label 1909: @114567
     /*  114567 */   GIM_Reject,
     /*  114568 */ // Label 1907: @114568
     /*  114568 */ GIM_Reject,
     /*  114569 */ // Label 1857: @114569
     /*  114569 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(114683),
     /*  114574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  114577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  114580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114592 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(114637), // Rule ID 51434 //
     /*  114597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114600 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  114603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  114617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114635 */     GIR_RootConstrainSelectedInstOperands,
     /*  114636 */     // GIR_Coverage, 51434,
     /*  114636 */     GIR_EraseRootFromParent_Done,
     /*  114637 */   // Label 1911: @114637
     /*  114637 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(114682), // Rule ID 51435 //
     /*  114642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114645 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  114648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  114662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114680 */     GIR_RootConstrainSelectedInstOperands,
     /*  114681 */     // GIR_Coverage, 51435,
     /*  114681 */     GIR_EraseRootFromParent_Done,
     /*  114682 */   // Label 1912: @114682
     /*  114682 */   GIM_Reject,
     /*  114683 */ // Label 1910: @114683
     /*  114683 */ GIM_Reject,
     /*  114684 */ // Label 1858: @114684
     /*  114684 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(114798),
     /*  114689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  114692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  114695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  114707 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(114752), // Rule ID 51450 //
     /*  114712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114715 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  114715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  114718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  114732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114750 */     GIR_RootConstrainSelectedInstOperands,
     /*  114751 */     // GIR_Coverage, 51450,
     /*  114751 */     GIR_EraseRootFromParent_Done,
     /*  114752 */   // Label 1914: @114752
     /*  114752 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(114797), // Rule ID 51451 //
     /*  114757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114760 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  114760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  114763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  114777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  114792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114795 */     GIR_RootConstrainSelectedInstOperands,
     /*  114796 */     // GIR_Coverage, 51451,
     /*  114796 */     GIR_EraseRootFromParent_Done,
     /*  114797 */   // Label 1915: @114797
     /*  114797 */   GIM_Reject,
     /*  114798 */ // Label 1913: @114798
     /*  114798 */ GIM_Reject,
     /*  114799 */ // Label 1859: @114799
     /*  114799 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(114913),
     /*  114804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  114807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  114810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114818 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114822 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(114867), // Rule ID 51466 //
     /*  114827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  114830 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  114830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  114833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  114847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114865 */     GIR_RootConstrainSelectedInstOperands,
     /*  114866 */     // GIR_Coverage, 51466,
     /*  114866 */     GIR_EraseRootFromParent_Done,
     /*  114867 */   // Label 1917: @114867
     /*  114867 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(114912), // Rule ID 51467 //
     /*  114872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  114875 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  114875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  114878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  114892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  114907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114910 */     GIR_RootConstrainSelectedInstOperands,
     /*  114911 */     // GIR_Coverage, 51467,
     /*  114911 */     GIR_EraseRootFromParent_Done,
     /*  114912 */   // Label 1918: @114912
     /*  114912 */   GIM_Reject,
     /*  114913 */ // Label 1916: @114913
     /*  114913 */ GIM_Reject,
     /*  114914 */ // Label 1860: @114914
     /*  114914 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(115028),
     /*  114919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  114922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  114925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  114937 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(114982), // Rule ID 51422 //
     /*  114942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114945 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  114948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  114962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114980 */     GIR_RootConstrainSelectedInstOperands,
     /*  114981 */     // GIR_Coverage, 51422,
     /*  114981 */     GIR_EraseRootFromParent_Done,
     /*  114982 */   // Label 1920: @114982
     /*  114982 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(115027), // Rule ID 51423 //
     /*  114987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114990 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  114993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  115007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115025 */     GIR_RootConstrainSelectedInstOperands,
     /*  115026 */     // GIR_Coverage, 51423,
     /*  115026 */     GIR_EraseRootFromParent_Done,
     /*  115027 */   // Label 1921: @115027
     /*  115027 */   GIM_Reject,
     /*  115028 */ // Label 1919: @115028
     /*  115028 */ GIM_Reject,
     /*  115029 */ // Label 1861: @115029
     /*  115029 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(115143),
     /*  115034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  115037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  115040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115052 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(115097), // Rule ID 51438 //
     /*  115057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115060 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115095 */     GIR_RootConstrainSelectedInstOperands,
     /*  115096 */     // GIR_Coverage, 51438,
     /*  115096 */     GIR_EraseRootFromParent_Done,
     /*  115097 */   // Label 1923: @115097
     /*  115097 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(115142), // Rule ID 51439 //
     /*  115102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115105 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  115108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  115122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115140 */     GIR_RootConstrainSelectedInstOperands,
     /*  115141 */     // GIR_Coverage, 51439,
     /*  115141 */     GIR_EraseRootFromParent_Done,
     /*  115142 */   // Label 1924: @115142
     /*  115142 */   GIM_Reject,
     /*  115143 */ // Label 1922: @115143
     /*  115143 */ GIM_Reject,
     /*  115144 */ // Label 1862: @115144
     /*  115144 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(115258),
     /*  115149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  115152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  115155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115167 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(115212), // Rule ID 51454 //
     /*  115172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115175 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  115175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115210 */     GIR_RootConstrainSelectedInstOperands,
     /*  115211 */     // GIR_Coverage, 51454,
     /*  115211 */     GIR_EraseRootFromParent_Done,
     /*  115212 */   // Label 1926: @115212
     /*  115212 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(115257), // Rule ID 51455 //
     /*  115217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115220 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  115220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  115223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  115237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  115252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115255 */     GIR_RootConstrainSelectedInstOperands,
     /*  115256 */     // GIR_Coverage, 51455,
     /*  115256 */     GIR_EraseRootFromParent_Done,
     /*  115257 */   // Label 1927: @115257
     /*  115257 */   GIM_Reject,
     /*  115258 */ // Label 1925: @115258
     /*  115258 */ GIM_Reject,
     /*  115259 */ // Label 1863: @115259
     /*  115259 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(115373),
     /*  115264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  115267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  115270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  115282 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(115327), // Rule ID 51426 //
     /*  115287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115290 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115325 */     GIR_RootConstrainSelectedInstOperands,
     /*  115326 */     // GIR_Coverage, 51426,
     /*  115326 */     GIR_EraseRootFromParent_Done,
     /*  115327 */   // Label 1929: @115327
     /*  115327 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(115372), // Rule ID 51427 //
     /*  115332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115335 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  115338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  115352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115370 */     GIR_RootConstrainSelectedInstOperands,
     /*  115371 */     // GIR_Coverage, 51427,
     /*  115371 */     GIR_EraseRootFromParent_Done,
     /*  115372 */   // Label 1930: @115372
     /*  115372 */   GIM_Reject,
     /*  115373 */ // Label 1928: @115373
     /*  115373 */ GIM_Reject,
     /*  115374 */ // Label 1864: @115374
     /*  115374 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(115488),
     /*  115379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  115382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  115385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115397 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(115442), // Rule ID 51442 //
     /*  115402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115405 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115440 */     GIR_RootConstrainSelectedInstOperands,
     /*  115441 */     // GIR_Coverage, 51442,
     /*  115441 */     GIR_EraseRootFromParent_Done,
     /*  115442 */   // Label 1932: @115442
     /*  115442 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(115487), // Rule ID 51443 //
     /*  115447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115450 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  115453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  115467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115485 */     GIR_RootConstrainSelectedInstOperands,
     /*  115486 */     // GIR_Coverage, 51443,
     /*  115486 */     GIR_EraseRootFromParent_Done,
     /*  115487 */   // Label 1933: @115487
     /*  115487 */   GIM_Reject,
     /*  115488 */ // Label 1931: @115488
     /*  115488 */ GIM_Reject,
     /*  115489 */ // Label 1865: @115489
     /*  115489 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(115603),
     /*  115494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  115497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  115500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115508 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  115512 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(115557), // Rule ID 51430 //
     /*  115517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115520 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  115537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115555 */     GIR_RootConstrainSelectedInstOperands,
     /*  115556 */     // GIR_Coverage, 51430,
     /*  115556 */     GIR_EraseRootFromParent_Done,
     /*  115557 */   // Label 1935: @115557
     /*  115557 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(115602), // Rule ID 51431 //
     /*  115562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115565 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  115568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  115582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115600 */     GIR_RootConstrainSelectedInstOperands,
     /*  115601 */     // GIR_Coverage, 51431,
     /*  115601 */     GIR_EraseRootFromParent_Done,
     /*  115602 */   // Label 1936: @115602
     /*  115602 */   GIM_Reject,
     /*  115603 */ // Label 1934: @115603
     /*  115603 */ GIM_Reject,
     /*  115604 */ // Label 1866: @115604
     /*  115604 */ GIM_Reject,
     /*  115605 */ // Label 6: @115605
     /*  115605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1961*/ GIMT_Encode4(118338),
     /*  115616 */ /*GILLT_s32*//*Label 1937*/ GIMT_Encode4(115740),
     /*  115620 */ /*GILLT_s64*//*Label 1938*/ GIMT_Encode4(115774), GIMT_Encode4(0),
     /*  115628 */ /*GILLT_nxv1s8*//*Label 1939*/ GIMT_Encode4(115808),
     /*  115632 */ /*GILLT_nxv1s16*//*Label 1940*/ GIMT_Encode4(115923),
     /*  115636 */ /*GILLT_nxv1s32*//*Label 1941*/ GIMT_Encode4(116038),
     /*  115640 */ /*GILLT_nxv1s64*//*Label 1942*/ GIMT_Encode4(116153), GIMT_Encode4(0),
     /*  115648 */ /*GILLT_nxv2s8*//*Label 1943*/ GIMT_Encode4(116268),
     /*  115652 */ /*GILLT_nxv2s16*//*Label 1944*/ GIMT_Encode4(116383),
     /*  115656 */ /*GILLT_nxv2s32*//*Label 1945*/ GIMT_Encode4(116498),
     /*  115660 */ /*GILLT_nxv2s64*//*Label 1946*/ GIMT_Encode4(116613), GIMT_Encode4(0),
     /*  115668 */ /*GILLT_nxv4s8*//*Label 1947*/ GIMT_Encode4(116728),
     /*  115672 */ /*GILLT_nxv4s16*//*Label 1948*/ GIMT_Encode4(116843),
     /*  115676 */ /*GILLT_nxv4s32*//*Label 1949*/ GIMT_Encode4(116958),
     /*  115680 */ /*GILLT_nxv4s64*//*Label 1950*/ GIMT_Encode4(117073), GIMT_Encode4(0),
     /*  115688 */ /*GILLT_nxv8s8*//*Label 1951*/ GIMT_Encode4(117188),
     /*  115692 */ /*GILLT_nxv8s16*//*Label 1952*/ GIMT_Encode4(117303),
     /*  115696 */ /*GILLT_nxv8s32*//*Label 1953*/ GIMT_Encode4(117418),
     /*  115700 */ /*GILLT_nxv8s64*//*Label 1954*/ GIMT_Encode4(117533), GIMT_Encode4(0),
     /*  115708 */ /*GILLT_nxv16s8*//*Label 1955*/ GIMT_Encode4(117648),
     /*  115712 */ /*GILLT_nxv16s16*//*Label 1956*/ GIMT_Encode4(117763),
     /*  115716 */ /*GILLT_nxv16s32*//*Label 1957*/ GIMT_Encode4(117878), GIMT_Encode4(0),
     /*  115724 */ /*GILLT_nxv32s8*//*Label 1958*/ GIMT_Encode4(117993),
     /*  115728 */ /*GILLT_nxv32s16*//*Label 1959*/ GIMT_Encode4(118108), GIMT_Encode4(0),
     /*  115736 */ /*GILLT_nxv64s8*//*Label 1960*/ GIMT_Encode4(118223),
     /*  115740 */ // Label 1937: @115740
     /*  115740 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(115773), // Rule ID 312 //
     /*  115745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  115748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  115751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  115754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115766 */   // (urem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REMU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  115766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  115771 */   GIR_RootConstrainSelectedInstOperands,
     /*  115772 */   // GIR_Coverage, 312,
     /*  115772 */   GIR_Done,
     /*  115773 */ // Label 1962: @115773
     /*  115773 */ GIM_Reject,
     /*  115774 */ // Label 1938: @115774
     /*  115774 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(115807), // Rule ID 311 //
     /*  115779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  115782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  115785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  115788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115800 */   // (urem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  115800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  115805 */   GIR_RootConstrainSelectedInstOperands,
     /*  115806 */   // GIR_Coverage, 311,
     /*  115806 */   GIR_Done,
     /*  115807 */ // Label 1963: @115807
     /*  115807 */ GIM_Reject,
     /*  115808 */ // Label 1939: @115808
     /*  115808 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(115922),
     /*  115813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  115816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  115819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115831 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(115876), // Rule ID 51294 //
     /*  115836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115839 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  115839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  115842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  115856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115874 */     GIR_RootConstrainSelectedInstOperands,
     /*  115875 */     // GIR_Coverage, 51294,
     /*  115875 */     GIR_EraseRootFromParent_Done,
     /*  115876 */   // Label 1965: @115876
     /*  115876 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(115921), // Rule ID 51295 //
     /*  115881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115884 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  115884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  115887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  115901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115919 */     GIR_RootConstrainSelectedInstOperands,
     /*  115920 */     // GIR_Coverage, 51295,
     /*  115920 */     GIR_EraseRootFromParent_Done,
     /*  115921 */   // Label 1966: @115921
     /*  115921 */   GIM_Reject,
     /*  115922 */ // Label 1964: @115922
     /*  115922 */ GIM_Reject,
     /*  115923 */ // Label 1940: @115923
     /*  115923 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(116037),
     /*  115928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  115931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  115934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  115946 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(115991), // Rule ID 51306 //
     /*  115951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  115954 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  115954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  115957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  115961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  115971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  115980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  115983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  115986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  115989 */     GIR_RootConstrainSelectedInstOperands,
     /*  115990 */     // GIR_Coverage, 51306,
     /*  115990 */     GIR_EraseRootFromParent_Done,
     /*  115991 */   // Label 1968: @115991
     /*  115991 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(116036), // Rule ID 51307 //
     /*  115996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  115999 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  115999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  116002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  116016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116034 */     GIR_RootConstrainSelectedInstOperands,
     /*  116035 */     // GIR_Coverage, 51307,
     /*  116035 */     GIR_EraseRootFromParent_Done,
     /*  116036 */   // Label 1969: @116036
     /*  116036 */   GIM_Reject,
     /*  116037 */ // Label 1967: @116037
     /*  116037 */ GIM_Reject,
     /*  116038 */ // Label 1941: @116038
     /*  116038 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(116152),
     /*  116043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  116046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  116049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116061 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(116106), // Rule ID 51314 //
     /*  116066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116069 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116104 */     GIR_RootConstrainSelectedInstOperands,
     /*  116105 */     // GIR_Coverage, 51314,
     /*  116105 */     GIR_EraseRootFromParent_Done,
     /*  116106 */   // Label 1971: @116106
     /*  116106 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(116151), // Rule ID 51315 //
     /*  116111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116114 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  116117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  116131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116149 */     GIR_RootConstrainSelectedInstOperands,
     /*  116150 */     // GIR_Coverage, 51315,
     /*  116150 */     GIR_EraseRootFromParent_Done,
     /*  116151 */   // Label 1972: @116151
     /*  116151 */   GIM_Reject,
     /*  116152 */ // Label 1970: @116152
     /*  116152 */ GIM_Reject,
     /*  116153 */ // Label 1942: @116153
     /*  116153 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(116267),
     /*  116158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  116161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  116164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116176 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(116221), // Rule ID 51330 //
     /*  116181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116184 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116219 */     GIR_RootConstrainSelectedInstOperands,
     /*  116220 */     // GIR_Coverage, 51330,
     /*  116220 */     GIR_EraseRootFromParent_Done,
     /*  116221 */   // Label 1974: @116221
     /*  116221 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(116266), // Rule ID 51331 //
     /*  116226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116229 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  116232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  116246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116264 */     GIR_RootConstrainSelectedInstOperands,
     /*  116265 */     // GIR_Coverage, 51331,
     /*  116265 */     GIR_EraseRootFromParent_Done,
     /*  116266 */   // Label 1975: @116266
     /*  116266 */   GIM_Reject,
     /*  116267 */ // Label 1973: @116267
     /*  116267 */ GIM_Reject,
     /*  116268 */ // Label 1943: @116268
     /*  116268 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(116382),
     /*  116273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  116276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  116279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116291 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(116336), // Rule ID 51298 //
     /*  116296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116299 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116334 */     GIR_RootConstrainSelectedInstOperands,
     /*  116335 */     // GIR_Coverage, 51298,
     /*  116335 */     GIR_EraseRootFromParent_Done,
     /*  116336 */   // Label 1977: @116336
     /*  116336 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(116381), // Rule ID 51299 //
     /*  116341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116344 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  116347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  116361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116379 */     GIR_RootConstrainSelectedInstOperands,
     /*  116380 */     // GIR_Coverage, 51299,
     /*  116380 */     GIR_EraseRootFromParent_Done,
     /*  116381 */   // Label 1978: @116381
     /*  116381 */   GIM_Reject,
     /*  116382 */ // Label 1976: @116382
     /*  116382 */ GIM_Reject,
     /*  116383 */ // Label 1944: @116383
     /*  116383 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(116497),
     /*  116388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  116391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  116394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116406 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(116451), // Rule ID 51310 //
     /*  116411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116414 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116449 */     GIR_RootConstrainSelectedInstOperands,
     /*  116450 */     // GIR_Coverage, 51310,
     /*  116450 */     GIR_EraseRootFromParent_Done,
     /*  116451 */   // Label 1980: @116451
     /*  116451 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(116496), // Rule ID 51311 //
     /*  116456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116459 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  116462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  116476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116494 */     GIR_RootConstrainSelectedInstOperands,
     /*  116495 */     // GIR_Coverage, 51311,
     /*  116495 */     GIR_EraseRootFromParent_Done,
     /*  116496 */   // Label 1981: @116496
     /*  116496 */   GIM_Reject,
     /*  116497 */ // Label 1979: @116497
     /*  116497 */ GIM_Reject,
     /*  116498 */ // Label 1945: @116498
     /*  116498 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(116612),
     /*  116503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  116506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  116509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116521 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(116566), // Rule ID 51326 //
     /*  116526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116529 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  116532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  116546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116564 */     GIR_RootConstrainSelectedInstOperands,
     /*  116565 */     // GIR_Coverage, 51326,
     /*  116565 */     GIR_EraseRootFromParent_Done,
     /*  116566 */   // Label 1983: @116566
     /*  116566 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(116611), // Rule ID 51327 //
     /*  116571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116574 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  116574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  116577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  116591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  116606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116609 */     GIR_RootConstrainSelectedInstOperands,
     /*  116610 */     // GIR_Coverage, 51327,
     /*  116610 */     GIR_EraseRootFromParent_Done,
     /*  116611 */   // Label 1984: @116611
     /*  116611 */   GIM_Reject,
     /*  116612 */ // Label 1982: @116612
     /*  116612 */ GIM_Reject,
     /*  116613 */ // Label 1946: @116613
     /*  116613 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(116727),
     /*  116618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  116621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  116624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116636 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(116681), // Rule ID 51370 //
     /*  116641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  116644 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  116644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  116647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  116661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116679 */     GIR_RootConstrainSelectedInstOperands,
     /*  116680 */     // GIR_Coverage, 51370,
     /*  116680 */     GIR_EraseRootFromParent_Done,
     /*  116681 */   // Label 1986: @116681
     /*  116681 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(116726), // Rule ID 51371 //
     /*  116686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  116689 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  116689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  116692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  116706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  116721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116724 */     GIR_RootConstrainSelectedInstOperands,
     /*  116725 */     // GIR_Coverage, 51371,
     /*  116725 */     GIR_EraseRootFromParent_Done,
     /*  116726 */   // Label 1987: @116726
     /*  116726 */   GIM_Reject,
     /*  116727 */ // Label 1985: @116727
     /*  116727 */ GIM_Reject,
     /*  116728 */ // Label 1947: @116728
     /*  116728 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(116842),
     /*  116733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  116736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  116739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116751 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(116796), // Rule ID 51302 //
     /*  116756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116759 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  116759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  116762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  116776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116794 */     GIR_RootConstrainSelectedInstOperands,
     /*  116795 */     // GIR_Coverage, 51302,
     /*  116795 */     GIR_EraseRootFromParent_Done,
     /*  116796 */   // Label 1989: @116796
     /*  116796 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(116841), // Rule ID 51303 //
     /*  116801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116804 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  116804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  116807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  116821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116839 */     GIR_RootConstrainSelectedInstOperands,
     /*  116840 */     // GIR_Coverage, 51303,
     /*  116840 */     GIR_EraseRootFromParent_Done,
     /*  116841 */   // Label 1990: @116841
     /*  116841 */   GIM_Reject,
     /*  116842 */ // Label 1988: @116842
     /*  116842 */ GIM_Reject,
     /*  116843 */ // Label 1948: @116843
     /*  116843 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(116957),
     /*  116848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  116851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  116854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116866 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(116911), // Rule ID 51322 //
     /*  116871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116874 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  116874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  116877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  116891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116909 */     GIR_RootConstrainSelectedInstOperands,
     /*  116910 */     // GIR_Coverage, 51322,
     /*  116910 */     GIR_EraseRootFromParent_Done,
     /*  116911 */   // Label 1992: @116911
     /*  116911 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(116956), // Rule ID 51323 //
     /*  116916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116919 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  116919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  116922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  116936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  116945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  116951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  116954 */     GIR_RootConstrainSelectedInstOperands,
     /*  116955 */     // GIR_Coverage, 51323,
     /*  116955 */     GIR_EraseRootFromParent_Done,
     /*  116956 */   // Label 1993: @116956
     /*  116956 */   GIM_Reject,
     /*  116957 */ // Label 1991: @116957
     /*  116957 */ GIM_Reject,
     /*  116958 */ // Label 1949: @116958
     /*  116958 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(117072),
     /*  116963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  116966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  116969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  116981 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(117026), // Rule ID 51358 //
     /*  116986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116989 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  116989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  116992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  116996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117024 */     GIR_RootConstrainSelectedInstOperands,
     /*  117025 */     // GIR_Coverage, 51358,
     /*  117025 */     GIR_EraseRootFromParent_Done,
     /*  117026 */   // Label 1995: @117026
     /*  117026 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(117071), // Rule ID 51359 //
     /*  117031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117034 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  117037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  117051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117069 */     GIR_RootConstrainSelectedInstOperands,
     /*  117070 */     // GIR_Coverage, 51359,
     /*  117070 */     GIR_EraseRootFromParent_Done,
     /*  117071 */   // Label 1996: @117071
     /*  117071 */   GIM_Reject,
     /*  117072 */ // Label 1994: @117072
     /*  117072 */ GIM_Reject,
     /*  117073 */ // Label 1950: @117073
     /*  117073 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(117187),
     /*  117078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  117081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  117084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117096 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(117141), // Rule ID 51374 //
     /*  117101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117104 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117139 */     GIR_RootConstrainSelectedInstOperands,
     /*  117140 */     // GIR_Coverage, 51374,
     /*  117140 */     GIR_EraseRootFromParent_Done,
     /*  117141 */   // Label 1998: @117141
     /*  117141 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(117186), // Rule ID 51375 //
     /*  117146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117149 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  117152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  117166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117184 */     GIR_RootConstrainSelectedInstOperands,
     /*  117185 */     // GIR_Coverage, 51375,
     /*  117185 */     GIR_EraseRootFromParent_Done,
     /*  117186 */   // Label 1999: @117186
     /*  117186 */   GIM_Reject,
     /*  117187 */ // Label 1997: @117187
     /*  117187 */ GIM_Reject,
     /*  117188 */ // Label 1951: @117188
     /*  117188 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(117302),
     /*  117193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  117196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  117199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117211 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(117256), // Rule ID 51318 //
     /*  117216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117219 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117254 */     GIR_RootConstrainSelectedInstOperands,
     /*  117255 */     // GIR_Coverage, 51318,
     /*  117255 */     GIR_EraseRootFromParent_Done,
     /*  117256 */   // Label 2001: @117256
     /*  117256 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(117301), // Rule ID 51319 //
     /*  117261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117264 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  117267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  117281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117299 */     GIR_RootConstrainSelectedInstOperands,
     /*  117300 */     // GIR_Coverage, 51319,
     /*  117300 */     GIR_EraseRootFromParent_Done,
     /*  117301 */   // Label 2002: @117301
     /*  117301 */   GIM_Reject,
     /*  117302 */ // Label 2000: @117302
     /*  117302 */ GIM_Reject,
     /*  117303 */ // Label 1952: @117303
     /*  117303 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(117417),
     /*  117308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  117311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  117314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117326 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(117371), // Rule ID 51346 //
     /*  117331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117334 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117369 */     GIR_RootConstrainSelectedInstOperands,
     /*  117370 */     // GIR_Coverage, 51346,
     /*  117370 */     GIR_EraseRootFromParent_Done,
     /*  117371 */   // Label 2004: @117371
     /*  117371 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(117416), // Rule ID 51347 //
     /*  117376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117379 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  117382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  117396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117414 */     GIR_RootConstrainSelectedInstOperands,
     /*  117415 */     // GIR_Coverage, 51347,
     /*  117415 */     GIR_EraseRootFromParent_Done,
     /*  117416 */   // Label 2005: @117416
     /*  117416 */   GIM_Reject,
     /*  117417 */ // Label 2003: @117417
     /*  117417 */ GIM_Reject,
     /*  117418 */ // Label 1953: @117418
     /*  117418 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(117532),
     /*  117423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  117426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  117429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117441 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(117486), // Rule ID 51362 //
     /*  117446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117449 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117484 */     GIR_RootConstrainSelectedInstOperands,
     /*  117485 */     // GIR_Coverage, 51362,
     /*  117485 */     GIR_EraseRootFromParent_Done,
     /*  117486 */   // Label 2007: @117486
     /*  117486 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(117531), // Rule ID 51363 //
     /*  117491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117494 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  117497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  117511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117529 */     GIR_RootConstrainSelectedInstOperands,
     /*  117530 */     // GIR_Coverage, 51363,
     /*  117530 */     GIR_EraseRootFromParent_Done,
     /*  117531 */   // Label 2008: @117531
     /*  117531 */   GIM_Reject,
     /*  117532 */ // Label 2006: @117532
     /*  117532 */ GIM_Reject,
     /*  117533 */ // Label 1954: @117533
     /*  117533 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(117647),
     /*  117538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  117541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  117544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117556 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(117601), // Rule ID 51378 //
     /*  117561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117564 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  117567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  117581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117599 */     GIR_RootConstrainSelectedInstOperands,
     /*  117600 */     // GIR_Coverage, 51378,
     /*  117600 */     GIR_EraseRootFromParent_Done,
     /*  117601 */   // Label 2010: @117601
     /*  117601 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(117646), // Rule ID 51379 //
     /*  117606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117609 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  117612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  117626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117644 */     GIR_RootConstrainSelectedInstOperands,
     /*  117645 */     // GIR_Coverage, 51379,
     /*  117645 */     GIR_EraseRootFromParent_Done,
     /*  117646 */   // Label 2011: @117646
     /*  117646 */   GIM_Reject,
     /*  117647 */ // Label 2009: @117647
     /*  117647 */ GIM_Reject,
     /*  117648 */ // Label 1955: @117648
     /*  117648 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(117762),
     /*  117653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  117656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  117659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117667 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  117671 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(117716), // Rule ID 51334 //
     /*  117676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117679 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  117682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  117696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117714 */     GIR_RootConstrainSelectedInstOperands,
     /*  117715 */     // GIR_Coverage, 51334,
     /*  117715 */     GIR_EraseRootFromParent_Done,
     /*  117716 */   // Label 2013: @117716
     /*  117716 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(117761), // Rule ID 51335 //
     /*  117721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117724 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  117727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  117741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117759 */     GIR_RootConstrainSelectedInstOperands,
     /*  117760 */     // GIR_Coverage, 51335,
     /*  117760 */     GIR_EraseRootFromParent_Done,
     /*  117761 */   // Label 2014: @117761
     /*  117761 */   GIM_Reject,
     /*  117762 */ // Label 2012: @117762
     /*  117762 */ GIM_Reject,
     /*  117763 */ // Label 1956: @117763
     /*  117763 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(117877),
     /*  117768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  117771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  117774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  117786 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(117831), // Rule ID 51350 //
     /*  117791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117794 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  117797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  117811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117829 */     GIR_RootConstrainSelectedInstOperands,
     /*  117830 */     // GIR_Coverage, 51350,
     /*  117830 */     GIR_EraseRootFromParent_Done,
     /*  117831 */   // Label 2016: @117831
     /*  117831 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(117876), // Rule ID 51351 //
     /*  117836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117839 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  117842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  117856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117874 */     GIR_RootConstrainSelectedInstOperands,
     /*  117875 */     // GIR_Coverage, 51351,
     /*  117875 */     GIR_EraseRootFromParent_Done,
     /*  117876 */   // Label 2017: @117876
     /*  117876 */   GIM_Reject,
     /*  117877 */ // Label 2015: @117877
     /*  117877 */ GIM_Reject,
     /*  117878 */ // Label 1957: @117878
     /*  117878 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(117992),
     /*  117883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  117886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  117889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  117901 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(117946), // Rule ID 51366 //
     /*  117906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117909 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  117912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  117926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117944 */     GIR_RootConstrainSelectedInstOperands,
     /*  117945 */     // GIR_Coverage, 51366,
     /*  117945 */     GIR_EraseRootFromParent_Done,
     /*  117946 */   // Label 2019: @117946
     /*  117946 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(117991), // Rule ID 51367 //
     /*  117951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117954 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  117957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  117971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117989 */     GIR_RootConstrainSelectedInstOperands,
     /*  117990 */     // GIR_Coverage, 51367,
     /*  117990 */     GIR_EraseRootFromParent_Done,
     /*  117991 */   // Label 2020: @117991
     /*  117991 */   GIM_Reject,
     /*  117992 */ // Label 2018: @117992
     /*  117992 */ GIM_Reject,
     /*  117993 */ // Label 1958: @117993
     /*  117993 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(118107),
     /*  117998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  118001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  118004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  118016 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(118061), // Rule ID 51338 //
     /*  118021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118024 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118059 */     GIR_RootConstrainSelectedInstOperands,
     /*  118060 */     // GIR_Coverage, 51338,
     /*  118060 */     GIR_EraseRootFromParent_Done,
     /*  118061 */   // Label 2022: @118061
     /*  118061 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(118106), // Rule ID 51339 //
     /*  118066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118069 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  118072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  118086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118104 */     GIR_RootConstrainSelectedInstOperands,
     /*  118105 */     // GIR_Coverage, 51339,
     /*  118105 */     GIR_EraseRootFromParent_Done,
     /*  118106 */   // Label 2023: @118106
     /*  118106 */   GIM_Reject,
     /*  118107 */ // Label 2021: @118107
     /*  118107 */ GIM_Reject,
     /*  118108 */ // Label 1959: @118108
     /*  118108 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(118222),
     /*  118113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  118116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  118119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118127 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118131 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(118176), // Rule ID 51354 //
     /*  118136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118139 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  118139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118174 */     GIR_RootConstrainSelectedInstOperands,
     /*  118175 */     // GIR_Coverage, 51354,
     /*  118175 */     GIR_EraseRootFromParent_Done,
     /*  118176 */   // Label 2025: @118176
     /*  118176 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(118221), // Rule ID 51355 //
     /*  118181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118184 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  118184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  118187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  118201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118219 */     GIR_RootConstrainSelectedInstOperands,
     /*  118220 */     // GIR_Coverage, 51355,
     /*  118220 */     GIR_EraseRootFromParent_Done,
     /*  118221 */   // Label 2026: @118221
     /*  118221 */   GIM_Reject,
     /*  118222 */ // Label 2024: @118222
     /*  118222 */ GIM_Reject,
     /*  118223 */ // Label 1960: @118223
     /*  118223 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(118337),
     /*  118228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  118231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  118234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  118246 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(118291), // Rule ID 51342 //
     /*  118251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118254 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118289 */     GIR_RootConstrainSelectedInstOperands,
     /*  118290 */     // GIR_Coverage, 51342,
     /*  118290 */     GIR_EraseRootFromParent_Done,
     /*  118291 */   // Label 2028: @118291
     /*  118291 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(118336), // Rule ID 51343 //
     /*  118296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118299 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  118302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  118316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118334 */     GIR_RootConstrainSelectedInstOperands,
     /*  118335 */     // GIR_Coverage, 51343,
     /*  118335 */     GIR_EraseRootFromParent_Done,
     /*  118336 */   // Label 2029: @118336
     /*  118336 */   GIM_Reject,
     /*  118337 */ // Label 2027: @118337
     /*  118337 */ GIM_Reject,
     /*  118338 */ // Label 1961: @118338
     /*  118338 */ GIM_Reject,
     /*  118339 */ // Label 7: @118339
     /*  118339 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2061*/ GIMT_Encode4(128296),
     /*  118350 */ /*GILLT_s32*//*Label 2030*/ GIMT_Encode4(118474),
     /*  118354 */ /*GILLT_s64*//*Label 2031*/ GIMT_Encode4(120168),
     /*  118358 */ /*GILLT_nxv1s1*//*Label 2032*/ GIMT_Encode4(121489),
     /*  118362 */ /*GILLT_nxv1s8*//*Label 2033*/ GIMT_Encode4(122100),
     /*  118366 */ /*GILLT_nxv1s16*//*Label 2034*/ GIMT_Encode4(122215),
     /*  118370 */ /*GILLT_nxv1s32*//*Label 2035*/ GIMT_Encode4(122330),
     /*  118374 */ /*GILLT_nxv1s64*//*Label 2036*/ GIMT_Encode4(122445),
     /*  118378 */ /*GILLT_nxv2s1*//*Label 2037*/ GIMT_Encode4(122560),
     /*  118382 */ /*GILLT_nxv2s8*//*Label 2038*/ GIMT_Encode4(123171),
     /*  118386 */ /*GILLT_nxv2s16*//*Label 2039*/ GIMT_Encode4(123286),
     /*  118390 */ /*GILLT_nxv2s32*//*Label 2040*/ GIMT_Encode4(123401),
     /*  118394 */ /*GILLT_nxv2s64*//*Label 2041*/ GIMT_Encode4(123516),
     /*  118398 */ /*GILLT_nxv4s1*//*Label 2042*/ GIMT_Encode4(123631),
     /*  118402 */ /*GILLT_nxv4s8*//*Label 2043*/ GIMT_Encode4(124242),
     /*  118406 */ /*GILLT_nxv4s16*//*Label 2044*/ GIMT_Encode4(124357),
     /*  118410 */ /*GILLT_nxv4s32*//*Label 2045*/ GIMT_Encode4(124472),
     /*  118414 */ /*GILLT_nxv4s64*//*Label 2046*/ GIMT_Encode4(124587),
     /*  118418 */ /*GILLT_nxv8s1*//*Label 2047*/ GIMT_Encode4(124702),
     /*  118422 */ /*GILLT_nxv8s8*//*Label 2048*/ GIMT_Encode4(125313),
     /*  118426 */ /*GILLT_nxv8s16*//*Label 2049*/ GIMT_Encode4(125428),
     /*  118430 */ /*GILLT_nxv8s32*//*Label 2050*/ GIMT_Encode4(125543),
     /*  118434 */ /*GILLT_nxv8s64*//*Label 2051*/ GIMT_Encode4(125658),
     /*  118438 */ /*GILLT_nxv16s1*//*Label 2052*/ GIMT_Encode4(125773),
     /*  118442 */ /*GILLT_nxv16s8*//*Label 2053*/ GIMT_Encode4(126384),
     /*  118446 */ /*GILLT_nxv16s16*//*Label 2054*/ GIMT_Encode4(126499),
     /*  118450 */ /*GILLT_nxv16s32*//*Label 2055*/ GIMT_Encode4(126614),
     /*  118454 */ /*GILLT_nxv32s1*//*Label 2056*/ GIMT_Encode4(126729),
     /*  118458 */ /*GILLT_nxv32s8*//*Label 2057*/ GIMT_Encode4(127340),
     /*  118462 */ /*GILLT_nxv32s16*//*Label 2058*/ GIMT_Encode4(127455),
     /*  118466 */ /*GILLT_nxv64s1*//*Label 2059*/ GIMT_Encode4(127570),
     /*  118470 */ /*GILLT_nxv64s8*//*Label 2060*/ GIMT_Encode4(128181),
     /*  118474 */ // Label 2030: @118474
     /*  118474 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(120167),
     /*  118479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  118482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  118485 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(118574), // Rule ID 65485 //
     /*  118490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118525 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118529 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  118538 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  118549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  118558 */     // (and:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] })), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  118561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  118568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  118572 */     GIR_RootConstrainSelectedInstOperands,
     /*  118573 */     // GIR_Coverage, 65485,
     /*  118573 */     GIR_EraseRootFromParent_Done,
     /*  118574 */   // Label 2063: @118574
     /*  118574 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(118663), // Rule ID 2540 //
     /*  118579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  118582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  118594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118623 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  118627 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  118638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  118647 */     // (and:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1)), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  118650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  118657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  118661 */     GIR_RootConstrainSelectedInstOperands,
     /*  118662 */     // GIR_Coverage, 2540,
     /*  118662 */     GIR_EraseRootFromParent_Done,
     /*  118663 */   // Label 2064: @118663
     /*  118663 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(118742), // Rule ID 2467 //
     /*  118668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118707 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  118711 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  118715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118721 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118728 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  118731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  118735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  118740 */     GIR_RootConstrainSelectedInstOperands,
     /*  118741 */     // GIR_Coverage, 2467,
     /*  118741 */     GIR_EraseRootFromParent_Done,
     /*  118742 */   // Label 2065: @118742
     /*  118742 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(118821), // Rule ID 65473 //
     /*  118747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  118762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  118782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  118790 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  118794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  118798 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118800 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118807 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  118810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  118819 */     GIR_RootConstrainSelectedInstOperands,
     /*  118820 */     // GIR_Coverage, 65473,
     /*  118820 */     GIR_EraseRootFromParent_Done,
     /*  118821 */   // Label 2066: @118821
     /*  118821 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(118886), // Rule ID 2487 //
     /*  118826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  118862 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  118866 */     // MIs[2] Operand 1
     /*  118866 */     // No operand predicates
     /*  118866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118872 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (BEXTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  118872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  118875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  118881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  118884 */     GIR_RootConstrainSelectedInstOperands,
     /*  118885 */     // GIR_Coverage, 2487,
     /*  118885 */     GIR_EraseRootFromParent_Done,
     /*  118886 */   // Label 2067: @118886
     /*  118886 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(118951), // Rule ID 62571 //
     /*  118891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode1),
     /*  118894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  118927 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  118931 */     // MIs[2] Operand 1
     /*  118931 */     // No operand predicates
     /*  118931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118937 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (TH_TST:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  118937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  118940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  118946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  118949 */     GIR_RootConstrainSelectedInstOperands,
     /*  118950 */     // GIR_Coverage, 62571,
     /*  118950 */     GIR_EraseRootFromParent_Done,
     /*  118951 */   // Label 2068: @118951
     /*  118951 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(119013), // Rule ID 2475 //
     /*  118956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  118959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  118971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  118975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  118979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  118984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  118988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  118990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  118997 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), 1:{ *:[i32] })  =>  (BEXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  118997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  119000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  119006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  119011 */     GIR_RootConstrainSelectedInstOperands,
     /*  119012 */     // GIR_Coverage, 2475,
     /*  119012 */     GIR_EraseRootFromParent_Done,
     /*  119013 */   // Label 2069: @119013
     /*  119013 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(119069), // Rule ID 2469 //
     /*  119018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119056 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119067 */     GIR_RootConstrainSelectedInstOperands,
     /*  119068 */     // GIR_Coverage, 2469,
     /*  119068 */     GIR_EraseRootFromParent_Done,
     /*  119069 */   // Label 2070: @119069
     /*  119069 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(119125), // Rule ID 65459 //
     /*  119074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119102 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119112 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119123 */     GIR_RootConstrainSelectedInstOperands,
     /*  119124 */     // GIR_Coverage, 65459,
     /*  119124 */     GIR_EraseRootFromParent_Done,
     /*  119125 */   // Label 2071: @119125
     /*  119125 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(119181), // Rule ID 65475 //
     /*  119130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  119133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  119149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119153 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119157 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  119161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119168 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  119171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119179 */     GIR_RootConstrainSelectedInstOperands,
     /*  119180 */     // GIR_Coverage, 65475,
     /*  119180 */     GIR_EraseRootFromParent_Done,
     /*  119181 */   // Label 2072: @119181
     /*  119181 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(119237), // Rule ID 2443 //
     /*  119186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  119189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  119209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  119213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119218 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  119222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119224 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  119224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  119227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119235 */     GIR_RootConstrainSelectedInstOperands,
     /*  119236 */     // GIR_Coverage, 2443,
     /*  119236 */     GIR_EraseRootFromParent_Done,
     /*  119237 */   // Label 2073: @119237
     /*  119237 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(119273), // Rule ID 64472 //
     /*  119242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119253 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119264 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 65535:{ *:[i32] })  =>  (CV_EXTHZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  119267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119271 */     GIR_RootConstrainSelectedInstOperands,
     /*  119272 */     // GIR_Coverage, 64472,
     /*  119272 */     GIR_EraseRootFromParent_Done,
     /*  119273 */   // Label 2074: @119273
     /*  119273 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(119309), // Rule ID 64474 //
     /*  119278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  119281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119289 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119300 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 255:{ *:[i32] })  =>  (CV_EXTBZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  119300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  119303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119307 */     GIR_RootConstrainSelectedInstOperands,
     /*  119308 */     // GIR_Coverage, 64474,
     /*  119308 */     GIR_EraseRootFromParent_Done,
     /*  119309 */   // Label 2075: @119309
     /*  119309 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(119345), // Rule ID 2551 //
     /*  119314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /*  119317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119325 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119336 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119343 */     GIR_RootConstrainSelectedInstOperands,
     /*  119344 */     // GIR_Coverage, 2551,
     /*  119344 */     GIR_EraseRootFromParent_Done,
     /*  119345 */   // Label 2076: @119345
     /*  119345 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(119381), // Rule ID 2552 //
     /*  119350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /*  119353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119361 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119372 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  119372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  119375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119379 */     GIR_RootConstrainSelectedInstOperands,
     /*  119380 */     // GIR_Coverage, 2552,
     /*  119380 */     GIR_EraseRootFromParent_Done,
     /*  119381 */   // Label 2077: @119381
     /*  119381 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(119423), // Rule ID 2554 //
     /*  119386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /*  119389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119397 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119408 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i64] })
     /*  119408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119421 */     GIR_RootConstrainSelectedInstOperands,
     /*  119422 */     // GIR_Coverage, 2554,
     /*  119422 */     GIR_EraseRootFromParent_Done,
     /*  119423 */   // Label 2078: @119423
     /*  119423 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(119465), // Rule ID 2555 //
     /*  119428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /*  119431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119439 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  119450 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i32] })
     /*  119450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  119453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  119463 */     GIR_RootConstrainSelectedInstOperands,
     /*  119464 */     // GIR_Coverage, 2555,
     /*  119464 */     GIR_EraseRootFromParent_Done,
     /*  119465 */   // Label 2079: @119465
     /*  119465 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(119500), // Rule ID 64622 //
     /*  119470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /*  119485 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 63:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  119485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119498 */     GIR_RootConstrainSelectedInstOperands,
     /*  119499 */     // GIR_Coverage, 64622,
     /*  119499 */     GIR_EraseRootFromParent_Done,
     /*  119500 */   // Label 2080: @119500
     /*  119500 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(119535), // Rule ID 64623 //
     /*  119505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /*  119520 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 63:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  119520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119533 */     GIR_RootConstrainSelectedInstOperands,
     /*  119534 */     // GIR_Coverage, 64623,
     /*  119534 */     GIR_EraseRootFromParent_Done,
     /*  119535 */   // Label 2081: @119535
     /*  119535 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(119570), // Rule ID 64624 //
     /*  119540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 127,
     /*  119555 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 127:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 7:{ *:[i64] }, 0:{ *:[i64] })
     /*  119555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  119565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119568 */     GIR_RootConstrainSelectedInstOperands,
     /*  119569 */     // GIR_Coverage, 64624,
     /*  119569 */     GIR_EraseRootFromParent_Done,
     /*  119570 */   // Label 2082: @119570
     /*  119570 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(119605), // Rule ID 64625 //
     /*  119575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 127,
     /*  119590 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 127:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 7:{ *:[i32] }, 0:{ *:[i32] })
     /*  119590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  119600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119603 */     GIR_RootConstrainSelectedInstOperands,
     /*  119604 */     // GIR_Coverage, 64625,
     /*  119604 */     GIR_EraseRootFromParent_Done,
     /*  119605 */   // Label 2083: @119605
     /*  119605 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(119647), // Rule ID 64626 //
     /*  119610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119621 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119632 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 255:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 8:{ *:[i64] }, 0:{ *:[i64] })
     /*  119632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  119642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119645 */     GIR_RootConstrainSelectedInstOperands,
     /*  119646 */     // GIR_Coverage, 64626,
     /*  119646 */     GIR_EraseRootFromParent_Done,
     /*  119647 */   // Label 2084: @119647
     /*  119647 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(119689), // Rule ID 64627 //
     /*  119652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119663 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  119674 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 255:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 8:{ *:[i32] }, 0:{ *:[i32] })
     /*  119674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  119684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119687 */     GIR_RootConstrainSelectedInstOperands,
     /*  119688 */     // GIR_Coverage, 64627,
     /*  119688 */     GIR_EraseRootFromParent_Done,
     /*  119689 */   // Label 2085: @119689
     /*  119689 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(119731), // Rule ID 64628 //
     /*  119694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119705 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(511),
     /*  119716 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 511:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 9:{ *:[i64] }, 0:{ *:[i64] })
     /*  119716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*  119726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119729 */     GIR_RootConstrainSelectedInstOperands,
     /*  119730 */     // GIR_Coverage, 64628,
     /*  119730 */     GIR_EraseRootFromParent_Done,
     /*  119731 */   // Label 2086: @119731
     /*  119731 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(119773), // Rule ID 64629 //
     /*  119736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119747 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(511),
     /*  119758 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 511:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 9:{ *:[i32] }, 0:{ *:[i32] })
     /*  119758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*  119768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119771 */     GIR_RootConstrainSelectedInstOperands,
     /*  119772 */     // GIR_Coverage, 64629,
     /*  119772 */     GIR_EraseRootFromParent_Done,
     /*  119773 */   // Label 2087: @119773
     /*  119773 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(119815), // Rule ID 64630 //
     /*  119778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119789 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1023),
     /*  119800 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 1023:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 10:{ *:[i64] }, 0:{ *:[i64] })
     /*  119800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/10,
     /*  119810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119813 */     GIR_RootConstrainSelectedInstOperands,
     /*  119814 */     // GIR_Coverage, 64630,
     /*  119814 */     GIR_EraseRootFromParent_Done,
     /*  119815 */   // Label 2088: @119815
     /*  119815 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(119857), // Rule ID 64631 //
     /*  119820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119831 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1023),
     /*  119842 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 1023:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 10:{ *:[i32] }, 0:{ *:[i32] })
     /*  119842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/10,
     /*  119852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119855 */     GIR_RootConstrainSelectedInstOperands,
     /*  119856 */     // GIR_Coverage, 64631,
     /*  119856 */     GIR_EraseRootFromParent_Done,
     /*  119857 */   // Label 2089: @119857
     /*  119857 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(119899), // Rule ID 64632 //
     /*  119862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /*  119865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119873 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2047),
     /*  119884 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 2047:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 11:{ *:[i64] }, 0:{ *:[i64] })
     /*  119884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /*  119894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119897 */     GIR_RootConstrainSelectedInstOperands,
     /*  119898 */     // GIR_Coverage, 64632,
     /*  119898 */     GIR_EraseRootFromParent_Done,
     /*  119899 */   // Label 2090: @119899
     /*  119899 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(119941), // Rule ID 64633 //
     /*  119904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /*  119907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  119915 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2047),
     /*  119926 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 2047:{ *:[i32] })  =>  (QC_EXTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs, 11:{ *:[i32] }, 0:{ *:[i32] })
     /*  119926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXTU),
     /*  119929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  119933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /*  119936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119939 */     GIR_RootConstrainSelectedInstOperands,
     /*  119940 */     // GIR_Coverage, 64633,
     /*  119940 */     GIR_EraseRootFromParent_Done,
     /*  119941 */   // Label 2091: @119941
     /*  119941 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(119983), // Rule ID 91 //
     /*  119946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  119949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  119965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  119969 */     // MIs[1] Operand 1
     /*  119969 */     // No operand predicates
     /*  119969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  119971 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  119971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  119974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  119981 */     GIR_RootConstrainSelectedInstOperands,
     /*  119982 */     // GIR_Coverage, 91,
     /*  119982 */     GIR_EraseRootFromParent_Done,
     /*  119983 */   // Label 2092: @119983
     /*  119983 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(120055), // Rule ID 109 //
     /*  119988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  119991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  119999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120007 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  120011 */     // MIs[1] Operand 1
     /*  120011 */     // No operand predicates
     /*  120011 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9923),
     /*  120015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120017 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9923>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask))
     /*  120017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  120020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  120033 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  120043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120048 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  120053 */     GIR_RootConstrainSelectedInstOperands,
     /*  120054 */     // GIR_Coverage, 109,
     /*  120054 */     GIR_EraseRootFromParent_Done,
     /*  120055 */   // Label 2093: @120055
     /*  120055 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(120097), // Rule ID 64525 //
     /*  120060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  120063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  120083 */     // MIs[1] Operand 1
     /*  120083 */     // No operand predicates
     /*  120083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120085 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ANDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  120085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDAI),
     /*  120088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  120090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120095 */     GIR_RootConstrainSelectedInstOperands,
     /*  120096 */     // GIR_Coverage, 64525,
     /*  120096 */     GIR_EraseRootFromParent_Done,
     /*  120097 */   // Label 2094: @120097
     /*  120097 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(120139), // Rule ID 64529 //
     /*  120102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  120105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  120113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  120125 */     // MIs[1] Operand 1
     /*  120125 */     // No operand predicates
     /*  120125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120127 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ANDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  120127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDI),
     /*  120130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  120137 */     GIR_RootConstrainSelectedInstOperands,
     /*  120138 */     // GIR_Coverage, 64529,
     /*  120138 */     GIR_EraseRootFromParent_Done,
     /*  120139 */   // Label 2095: @120139
     /*  120139 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(120166), // Rule ID 89 //
     /*  120144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  120147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120159 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (AND:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  120159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  120164 */     GIR_RootConstrainSelectedInstOperands,
     /*  120165 */     // GIR_Coverage, 89,
     /*  120165 */     GIR_Done,
     /*  120166 */   // Label 2096: @120166
     /*  120166 */   GIM_Reject,
     /*  120167 */ // Label 2062: @120167
     /*  120167 */ GIM_Reject,
     /*  120168 */ // Label 2031: @120168
     /*  120168 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(121488),
     /*  120173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  120176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  120179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120183 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(120268), // Rule ID 65484 //
     /*  120188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  120191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  120199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120228 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  120232 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  120252 */     // (and:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] })), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  120255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  120262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  120266 */     GIR_RootConstrainSelectedInstOperands,
     /*  120267 */     // GIR_Coverage, 65484,
     /*  120267 */     GIR_EraseRootFromParent_Done,
     /*  120268 */   // Label 2098: @120268
     /*  120268 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(120353), // Rule ID 2539 //
     /*  120273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  120276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  120284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120304 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120313 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  120317 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  120337 */     // (and:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1)), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  120340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  120347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  120351 */     GIR_RootConstrainSelectedInstOperands,
     /*  120352 */     // GIR_Coverage, 2539,
     /*  120352 */     GIR_EraseRootFromParent_Done,
     /*  120353 */   // Label 2099: @120353
     /*  120353 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(120428), // Rule ID 2466 //
     /*  120358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120389 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120393 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120397 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120407 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120414 */     // (and:{ *:[i64] } (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120426 */     GIR_RootConstrainSelectedInstOperands,
     /*  120427 */     // GIR_Coverage, 2466,
     /*  120427 */     GIR_EraseRootFromParent_Done,
     /*  120428 */   // Label 2100: @120428
     /*  120428 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(120503), // Rule ID 65472 //
     /*  120433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  120464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  120472 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  120476 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120482 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120489 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120501 */     GIR_RootConstrainSelectedInstOperands,
     /*  120502 */     // GIR_Coverage, 65472,
     /*  120502 */     GIR_EraseRootFromParent_Done,
     /*  120503 */   // Label 2101: @120503
     /*  120503 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(120564), // Rule ID 2486 //
     /*  120508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120540 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  120544 */     // MIs[2] Operand 1
     /*  120544 */     // No operand predicates
     /*  120544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120550 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (BEXTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  120550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  120553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  120562 */     GIR_RootConstrainSelectedInstOperands,
     /*  120563 */     // GIR_Coverage, 2486,
     /*  120563 */     GIR_EraseRootFromParent_Done,
     /*  120564 */   // Label 2102: @120564
     /*  120564 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(120625), // Rule ID 62570 //
     /*  120569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode0),
     /*  120572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  120601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  120605 */     // MIs[2] Operand 1
     /*  120605 */     // No operand predicates
     /*  120605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120611 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (TH_TST:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  120611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  120614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  120623 */     GIR_RootConstrainSelectedInstOperands,
     /*  120624 */     // GIR_Coverage, 62570,
     /*  120624 */     GIR_EraseRootFromParent_Done,
     /*  120625 */   // Label 2103: @120625
     /*  120625 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(120683), // Rule ID 2474 //
     /*  120630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  120641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  120658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  120667 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), 1:{ *:[i64] })  =>  (BEXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  120670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  120676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  120681 */     GIR_RootConstrainSelectedInstOperands,
     /*  120682 */     // GIR_Coverage, 2474,
     /*  120682 */     GIR_EraseRootFromParent_Done,
     /*  120683 */   // Label 2104: @120683
     /*  120683 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(120735), // Rule ID 2468 //
     /*  120688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  120699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120707 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  120711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120722 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120733 */     GIR_RootConstrainSelectedInstOperands,
     /*  120734 */     // GIR_Coverage, 2468,
     /*  120734 */     GIR_EraseRootFromParent_Done,
     /*  120735 */   // Label 2105: @120735
     /*  120735 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(120787), // Rule ID 65458 //
     /*  120740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  120743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120764 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120774 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  120777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120785 */     GIR_RootConstrainSelectedInstOperands,
     /*  120786 */     // GIR_Coverage, 65458,
     /*  120786 */     GIR_EraseRootFromParent_Done,
     /*  120787 */   // Label 2106: @120787
     /*  120787 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(120839), // Rule ID 65474 //
     /*  120792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  120795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  120807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120815 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  120819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120826 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  120829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120837 */     GIR_RootConstrainSelectedInstOperands,
     /*  120838 */     // GIR_Coverage, 65474,
     /*  120838 */     GIR_EraseRootFromParent_Done,
     /*  120839 */   // Label 2107: @120839
     /*  120839 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(120891), // Rule ID 2442 //
     /*  120844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  120847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  120863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  120867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120872 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  120876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  120878 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  120878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  120881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120889 */     GIR_RootConstrainSelectedInstOperands,
     /*  120890 */     // GIR_Coverage, 2442,
     /*  120890 */     GIR_EraseRootFromParent_Done,
     /*  120891 */   // Label 2108: @120891
     /*  120891 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(120923), // Rule ID 64471 //
     /*  120896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  120899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120903 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  120914 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 65535:{ *:[i64] })  =>  (CV_EXTHZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  120914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  120917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120921 */     GIR_RootConstrainSelectedInstOperands,
     /*  120922 */     // GIR_Coverage, 64471,
     /*  120922 */     GIR_EraseRootFromParent_Done,
     /*  120923 */   // Label 2109: @120923
     /*  120923 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(120955), // Rule ID 64473 //
     /*  120928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  120931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120935 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  120946 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 255:{ *:[i64] })  =>  (CV_EXTBZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  120946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  120949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120953 */     GIR_RootConstrainSelectedInstOperands,
     /*  120954 */     // GIR_Coverage, 64473,
     /*  120954 */     GIR_EraseRootFromParent_Done,
     /*  120955 */   // Label 2110: @120955
     /*  120955 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(121012), // Rule ID 258 //
     /*  120960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /*  120963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  120967 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  120978 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] })  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), 32:{ *:[i64] })
     /*  120978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  120981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  120985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  120994 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  120997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /*  121010 */     GIR_RootConstrainSelectedInstOperands,
     /*  121011 */     // GIR_Coverage, 258,
     /*  121011 */     GIR_EraseRootFromParent_Done,
     /*  121012 */   // Label 2111: @121012
     /*  121012 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(121044), // Rule ID 2553 //
     /*  121017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /*  121020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121024 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121035 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs)
     /*  121035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /*  121038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121042 */     GIR_RootConstrainSelectedInstOperands,
     /*  121043 */     // GIR_Coverage, 2553,
     /*  121043 */     GIR_EraseRootFromParent_Done,
     /*  121044 */   // Label 2112: @121044
     /*  121044 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(121082), // Rule ID 2556 //
     /*  121049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /*  121052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121056 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  121067 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  121070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121080 */     GIR_RootConstrainSelectedInstOperands,
     /*  121081 */     // GIR_Coverage, 2556,
     /*  121081 */     GIR_EraseRootFromParent_Done,
     /*  121082 */   // Label 2113: @121082
     /*  121082 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(121120), // Rule ID 2599 //
     /*  121087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  121090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121094 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121105 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*  121108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121118 */     GIR_RootConstrainSelectedInstOperands,
     /*  121119 */     // GIR_Coverage, 2599,
     /*  121119 */     GIR_EraseRootFromParent_Done,
     /*  121120 */   // Label 2114: @121120
     /*  121120 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(121158), // Rule ID 65069 //
     /*  121125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_IsRV64_HwMode0),
     /*  121128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121132 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  121143 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (NDS_LEA_B_ZE:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  121143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_LEA_B_ZE),
     /*  121146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  121150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  121156 */     GIR_RootConstrainSelectedInstOperands,
     /*  121157 */     // GIR_Coverage, 65069,
     /*  121157 */     GIR_EraseRootFromParent_Done,
     /*  121158 */   // Label 2115: @121158
     /*  121158 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(121196), // Rule ID 90 //
     /*  121163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  121182 */     // MIs[1] Operand 1
     /*  121182 */     // No operand predicates
     /*  121182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121184 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  121184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  121187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  121194 */     GIR_RootConstrainSelectedInstOperands,
     /*  121195 */     // GIR_Coverage, 90,
     /*  121195 */     GIR_EraseRootFromParent_Done,
     /*  121196 */   // Label 2116: @121196
     /*  121196 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(121264), // Rule ID 107 //
     /*  121201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesMask),
     /*  121220 */     // MIs[1] Operand 1
     /*  121220 */     // No operand predicates
     /*  121220 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9921),
     /*  121224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121226 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesMask>><<P:Predicate_anonymous_9921>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121242 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121257 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121262 */     GIR_RootConstrainSelectedInstOperands,
     /*  121263 */     // GIR_Coverage, 107,
     /*  121263 */     GIR_EraseRootFromParent_Done,
     /*  121264 */   // Label 2117: @121264
     /*  121264 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(121332), // Rule ID 108 //
     /*  121269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121284 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  121288 */     // MIs[1] Operand 1
     /*  121288 */     // No operand predicates
     /*  121288 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9923),
     /*  121292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121294 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9923>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121310 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  121315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121325 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  121330 */     GIR_RootConstrainSelectedInstOperands,
     /*  121331 */     // GIR_Coverage, 108,
     /*  121331 */     GIR_EraseRootFromParent_Done,
     /*  121332 */   // Label 2118: @121332
     /*  121332 */   GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(121400), // Rule ID 260 //
     /*  121337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  121340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesWMask),
     /*  121356 */     // MIs[1] Operand 1
     /*  121356 */     // No operand predicates
     /*  121356 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10011),
     /*  121360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121362 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesWMask>><<P:Predicate_anonymous_10011>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLIW:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  121362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*  121369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  121378 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  121388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121393 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121398 */     GIR_RootConstrainSelectedInstOperands,
     /*  121399 */     // GIR_Coverage, 260,
     /*  121399 */     GIR_EraseRootFromParent_Done,
     /*  121400 */   // Label 2119: @121400
     /*  121400 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(121464), // Rule ID 2618 //
     /*  121405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  121408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  121420 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_Shifted32OnesMask),
     /*  121424 */     // MIs[1] Operand 1
     /*  121424 */     // No operand predicates
     /*  121424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  121426 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>><<X:TrailingZeros>>:$mask)  =>  (SLLI_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask))
     /*  121426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  121429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  121433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  121442 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /*  121452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121457 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  121462 */     GIR_RootConstrainSelectedInstOperands,
     /*  121463 */     // GIR_Coverage, 2618,
     /*  121463 */     GIR_EraseRootFromParent_Done,
     /*  121464 */   // Label 2120: @121464
     /*  121464 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(121487), // Rule ID 88 //
     /*  121469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  121472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  121480 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AND:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  121480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  121485 */     GIR_RootConstrainSelectedInstOperands,
     /*  121486 */     // GIR_Coverage, 88,
     /*  121486 */     GIR_Done,
     /*  121487 */   // Label 2121: @121487
     /*  121487 */   GIM_Reject,
     /*  121488 */ // Label 2097: @121488
     /*  121488 */ GIM_Reject,
     /*  121489 */ // Label 2032: @121489
     /*  121489 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(122099),
     /*  121494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121504 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(121570), // Rule ID 71684 //
     /*  121509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121551 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121568 */     GIR_RootConstrainSelectedInstOperands,
     /*  121569 */     // GIR_Coverage, 71684,
     /*  121569 */     GIR_EraseRootFromParent_Done,
     /*  121570 */   // Label 2123: @121570
     /*  121570 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(121636), // Rule ID 71685 //
     /*  121575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121617 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121634 */     GIR_RootConstrainSelectedInstOperands,
     /*  121635 */     // GIR_Coverage, 71685,
     /*  121635 */     GIR_EraseRootFromParent_Done,
     /*  121636 */   // Label 2124: @121636
     /*  121636 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(121702), // Rule ID 71682 //
     /*  121641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121683 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121700 */     GIR_RootConstrainSelectedInstOperands,
     /*  121701 */     // GIR_Coverage, 71682,
     /*  121701 */     GIR_EraseRootFromParent_Done,
     /*  121702 */   // Label 2125: @121702
     /*  121702 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(121768), // Rule ID 71683 //
     /*  121707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121749 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121766 */     GIR_RootConstrainSelectedInstOperands,
     /*  121767 */     // GIR_Coverage, 71683,
     /*  121767 */     GIR_EraseRootFromParent_Done,
     /*  121768 */   // Label 2126: @121768
     /*  121768 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(121834), // Rule ID 71680 //
     /*  121773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121815 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121832 */     GIR_RootConstrainSelectedInstOperands,
     /*  121833 */     // GIR_Coverage, 71680,
     /*  121833 */     GIR_EraseRootFromParent_Done,
     /*  121834 */   // Label 2127: @121834
     /*  121834 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(121900), // Rule ID 71681 //
     /*  121839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121881 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121898 */     GIR_RootConstrainSelectedInstOperands,
     /*  121899 */     // GIR_Coverage, 71681,
     /*  121899 */     GIR_EraseRootFromParent_Done,
     /*  121900 */   // Label 2128: @121900
     /*  121900 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(121966), // Rule ID 53170 //
     /*  121905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121947 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  121950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121964 */     GIR_RootConstrainSelectedInstOperands,
     /*  121965 */     // GIR_Coverage, 53170,
     /*  121965 */     GIR_EraseRootFromParent_Done,
     /*  121966 */   // Label 2129: @121966
     /*  121966 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(122032), // Rule ID 53171 //
     /*  121971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  121990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  121994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122013 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  122016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122030 */     GIR_RootConstrainSelectedInstOperands,
     /*  122031 */     // GIR_Coverage, 53171,
     /*  122031 */     GIR_EraseRootFromParent_Done,
     /*  122032 */   // Label 2130: @122032
     /*  122032 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(122065), // Rule ID 53158 //
     /*  122037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122048 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  122051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122063 */     GIR_RootConstrainSelectedInstOperands,
     /*  122064 */     // GIR_Coverage, 53158,
     /*  122064 */     GIR_EraseRootFromParent_Done,
     /*  122065 */   // Label 2131: @122065
     /*  122065 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(122098), // Rule ID 53159 //
     /*  122070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122081 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  122084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122096 */     GIR_RootConstrainSelectedInstOperands,
     /*  122097 */     // GIR_Coverage, 53159,
     /*  122097 */     GIR_EraseRootFromParent_Done,
     /*  122098 */   // Label 2132: @122098
     /*  122098 */   GIM_Reject,
     /*  122099 */ // Label 2122: @122099
     /*  122099 */ GIM_Reject,
     /*  122100 */ // Label 2033: @122100
     /*  122100 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(122214),
     /*  122105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  122108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  122111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122123 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(122168), // Rule ID 47650 //
     /*  122128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122131 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  122131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  122134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  122148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122166 */     GIR_RootConstrainSelectedInstOperands,
     /*  122167 */     // GIR_Coverage, 47650,
     /*  122167 */     GIR_EraseRootFromParent_Done,
     /*  122168 */   // Label 2134: @122168
     /*  122168 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(122213), // Rule ID 47651 //
     /*  122173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122176 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  122176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  122179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  122193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122211 */     GIR_RootConstrainSelectedInstOperands,
     /*  122212 */     // GIR_Coverage, 47651,
     /*  122212 */     GIR_EraseRootFromParent_Done,
     /*  122213 */   // Label 2135: @122213
     /*  122213 */   GIM_Reject,
     /*  122214 */ // Label 2133: @122214
     /*  122214 */ GIM_Reject,
     /*  122215 */ // Label 2034: @122215
     /*  122215 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(122329),
     /*  122220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  122223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  122226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122238 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(122283), // Rule ID 47662 //
     /*  122243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122246 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  122246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  122249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122281 */     GIR_RootConstrainSelectedInstOperands,
     /*  122282 */     // GIR_Coverage, 47662,
     /*  122282 */     GIR_EraseRootFromParent_Done,
     /*  122283 */   // Label 2137: @122283
     /*  122283 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(122328), // Rule ID 47663 //
     /*  122288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122291 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  122291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  122294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  122308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122326 */     GIR_RootConstrainSelectedInstOperands,
     /*  122327 */     // GIR_Coverage, 47663,
     /*  122327 */     GIR_EraseRootFromParent_Done,
     /*  122328 */   // Label 2138: @122328
     /*  122328 */   GIM_Reject,
     /*  122329 */ // Label 2136: @122329
     /*  122329 */ GIM_Reject,
     /*  122330 */ // Label 2035: @122330
     /*  122330 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(122444),
     /*  122335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  122338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  122341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122353 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(122398), // Rule ID 47670 //
     /*  122358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122361 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  122361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  122364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122396 */     GIR_RootConstrainSelectedInstOperands,
     /*  122397 */     // GIR_Coverage, 47670,
     /*  122397 */     GIR_EraseRootFromParent_Done,
     /*  122398 */   // Label 2140: @122398
     /*  122398 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(122443), // Rule ID 47671 //
     /*  122403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122406 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  122406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  122409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  122423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122441 */     GIR_RootConstrainSelectedInstOperands,
     /*  122442 */     // GIR_Coverage, 47671,
     /*  122442 */     GIR_EraseRootFromParent_Done,
     /*  122443 */   // Label 2141: @122443
     /*  122443 */   GIM_Reject,
     /*  122444 */ // Label 2139: @122444
     /*  122444 */ GIM_Reject,
     /*  122445 */ // Label 2036: @122445
     /*  122445 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(122559),
     /*  122450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  122453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  122456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122468 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(122513), // Rule ID 47686 //
     /*  122473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  122476 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  122476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122511 */     GIR_RootConstrainSelectedInstOperands,
     /*  122512 */     // GIR_Coverage, 47686,
     /*  122512 */     GIR_EraseRootFromParent_Done,
     /*  122513 */   // Label 2143: @122513
     /*  122513 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(122558), // Rule ID 47687 //
     /*  122518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  122521 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  122521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  122524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  122538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  122553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122556 */     GIR_RootConstrainSelectedInstOperands,
     /*  122557 */     // GIR_Coverage, 47687,
     /*  122557 */     GIR_EraseRootFromParent_Done,
     /*  122558 */   // Label 2144: @122558
     /*  122558 */   GIM_Reject,
     /*  122559 */ // Label 2142: @122559
     /*  122559 */ GIM_Reject,
     /*  122560 */ // Label 2037: @122560
     /*  122560 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(123170),
     /*  122565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122575 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(122641), // Rule ID 71712 //
     /*  122580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122622 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122639 */     GIR_RootConstrainSelectedInstOperands,
     /*  122640 */     // GIR_Coverage, 71712,
     /*  122640 */     GIR_EraseRootFromParent_Done,
     /*  122641 */   // Label 2146: @122641
     /*  122641 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(122707), // Rule ID 71713 //
     /*  122646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122688 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122705 */     GIR_RootConstrainSelectedInstOperands,
     /*  122706 */     // GIR_Coverage, 71713,
     /*  122706 */     GIR_EraseRootFromParent_Done,
     /*  122707 */   // Label 2147: @122707
     /*  122707 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(122773), // Rule ID 71710 //
     /*  122712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122754 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122771 */     GIR_RootConstrainSelectedInstOperands,
     /*  122772 */     // GIR_Coverage, 71710,
     /*  122772 */     GIR_EraseRootFromParent_Done,
     /*  122773 */   // Label 2148: @122773
     /*  122773 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(122839), // Rule ID 71711 //
     /*  122778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122820 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122837 */     GIR_RootConstrainSelectedInstOperands,
     /*  122838 */     // GIR_Coverage, 71711,
     /*  122838 */     GIR_EraseRootFromParent_Done,
     /*  122839 */   // Label 2149: @122839
     /*  122839 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(122905), // Rule ID 71708 //
     /*  122844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122886 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122903 */     GIR_RootConstrainSelectedInstOperands,
     /*  122904 */     // GIR_Coverage, 71708,
     /*  122904 */     GIR_EraseRootFromParent_Done,
     /*  122905 */   // Label 2150: @122905
     /*  122905 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(122971), // Rule ID 71709 //
     /*  122910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122952 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  122955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122969 */     GIR_RootConstrainSelectedInstOperands,
     /*  122970 */     // GIR_Coverage, 71709,
     /*  122970 */     GIR_EraseRootFromParent_Done,
     /*  122971 */   // Label 2151: @122971
     /*  122971 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(123037), // Rule ID 53188 //
     /*  122976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  122995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  122999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123018 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123035 */     GIR_RootConstrainSelectedInstOperands,
     /*  123036 */     // GIR_Coverage, 53188,
     /*  123036 */     GIR_EraseRootFromParent_Done,
     /*  123037 */   // Label 2152: @123037
     /*  123037 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(123103), // Rule ID 53189 //
     /*  123042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  123061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  123065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123084 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  123087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123101 */     GIR_RootConstrainSelectedInstOperands,
     /*  123102 */     // GIR_Coverage, 53189,
     /*  123102 */     GIR_EraseRootFromParent_Done,
     /*  123103 */   // Label 2153: @123103
     /*  123103 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(123136), // Rule ID 53176 //
     /*  123108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123119 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  123122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123134 */     GIR_RootConstrainSelectedInstOperands,
     /*  123135 */     // GIR_Coverage, 53176,
     /*  123135 */     GIR_EraseRootFromParent_Done,
     /*  123136 */   // Label 2154: @123136
     /*  123136 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(123169), // Rule ID 53177 //
     /*  123141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123152 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  123155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123167 */     GIR_RootConstrainSelectedInstOperands,
     /*  123168 */     // GIR_Coverage, 53177,
     /*  123168 */     GIR_EraseRootFromParent_Done,
     /*  123169 */   // Label 2155: @123169
     /*  123169 */   GIM_Reject,
     /*  123170 */ // Label 2145: @123170
     /*  123170 */ GIM_Reject,
     /*  123171 */ // Label 2038: @123171
     /*  123171 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(123285),
     /*  123176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  123179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  123182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123190 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123194 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(123239), // Rule ID 47654 //
     /*  123199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123202 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  123202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  123205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  123219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123237 */     GIR_RootConstrainSelectedInstOperands,
     /*  123238 */     // GIR_Coverage, 47654,
     /*  123238 */     GIR_EraseRootFromParent_Done,
     /*  123239 */   // Label 2157: @123239
     /*  123239 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(123284), // Rule ID 47655 //
     /*  123244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123247 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  123247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  123250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  123264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123282 */     GIR_RootConstrainSelectedInstOperands,
     /*  123283 */     // GIR_Coverage, 47655,
     /*  123283 */     GIR_EraseRootFromParent_Done,
     /*  123284 */   // Label 2158: @123284
     /*  123284 */   GIM_Reject,
     /*  123285 */ // Label 2156: @123285
     /*  123285 */ GIM_Reject,
     /*  123286 */ // Label 2039: @123286
     /*  123286 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(123400),
     /*  123291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  123294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  123297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123309 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(123354), // Rule ID 47666 //
     /*  123314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123317 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  123317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  123320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123352 */     GIR_RootConstrainSelectedInstOperands,
     /*  123353 */     // GIR_Coverage, 47666,
     /*  123353 */     GIR_EraseRootFromParent_Done,
     /*  123354 */   // Label 2160: @123354
     /*  123354 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(123399), // Rule ID 47667 //
     /*  123359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123362 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  123362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  123365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  123379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  123394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123397 */     GIR_RootConstrainSelectedInstOperands,
     /*  123398 */     // GIR_Coverage, 47667,
     /*  123398 */     GIR_EraseRootFromParent_Done,
     /*  123399 */   // Label 2161: @123399
     /*  123399 */   GIM_Reject,
     /*  123400 */ // Label 2159: @123400
     /*  123400 */ GIM_Reject,
     /*  123401 */ // Label 2040: @123401
     /*  123401 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(123515),
     /*  123406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  123409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  123412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123424 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(123469), // Rule ID 47682 //
     /*  123429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123432 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  123432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123467 */     GIR_RootConstrainSelectedInstOperands,
     /*  123468 */     // GIR_Coverage, 47682,
     /*  123468 */     GIR_EraseRootFromParent_Done,
     /*  123469 */   // Label 2163: @123469
     /*  123469 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(123514), // Rule ID 47683 //
     /*  123474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123477 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  123477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  123480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  123494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  123509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123512 */     GIR_RootConstrainSelectedInstOperands,
     /*  123513 */     // GIR_Coverage, 47683,
     /*  123513 */     GIR_EraseRootFromParent_Done,
     /*  123514 */   // Label 2164: @123514
     /*  123514 */   GIM_Reject,
     /*  123515 */ // Label 2162: @123515
     /*  123515 */ GIM_Reject,
     /*  123516 */ // Label 2041: @123516
     /*  123516 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(123630),
     /*  123521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  123524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  123527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  123539 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(123584), // Rule ID 47726 //
     /*  123544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  123547 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  123547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  123550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  123564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123582 */     GIR_RootConstrainSelectedInstOperands,
     /*  123583 */     // GIR_Coverage, 47726,
     /*  123583 */     GIR_EraseRootFromParent_Done,
     /*  123584 */   // Label 2166: @123584
     /*  123584 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(123629), // Rule ID 47727 //
     /*  123589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  123592 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  123592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  123595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  123609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  123624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123627 */     GIR_RootConstrainSelectedInstOperands,
     /*  123628 */     // GIR_Coverage, 47727,
     /*  123628 */     GIR_EraseRootFromParent_Done,
     /*  123629 */   // Label 2167: @123629
     /*  123629 */   GIM_Reject,
     /*  123630 */ // Label 2165: @123630
     /*  123630 */ GIM_Reject,
     /*  123631 */ // Label 2042: @123631
     /*  123631 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(124241),
     /*  123636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123646 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(123712), // Rule ID 71740 //
     /*  123651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123691 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123693 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123710 */     GIR_RootConstrainSelectedInstOperands,
     /*  123711 */     // GIR_Coverage, 71740,
     /*  123711 */     GIR_EraseRootFromParent_Done,
     /*  123712 */   // Label 2169: @123712
     /*  123712 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(123778), // Rule ID 71741 //
     /*  123717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123759 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123776 */     GIR_RootConstrainSelectedInstOperands,
     /*  123777 */     // GIR_Coverage, 71741,
     /*  123777 */     GIR_EraseRootFromParent_Done,
     /*  123778 */   // Label 2170: @123778
     /*  123778 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(123844), // Rule ID 71738 //
     /*  123783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123825 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123842 */     GIR_RootConstrainSelectedInstOperands,
     /*  123843 */     // GIR_Coverage, 71738,
     /*  123843 */     GIR_EraseRootFromParent_Done,
     /*  123844 */   // Label 2171: @123844
     /*  123844 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(123910), // Rule ID 71739 //
     /*  123849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123891 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123908 */     GIR_RootConstrainSelectedInstOperands,
     /*  123909 */     // GIR_Coverage, 71739,
     /*  123909 */     GIR_EraseRootFromParent_Done,
     /*  123910 */   // Label 2172: @123910
     /*  123910 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(123976), // Rule ID 71736 //
     /*  123915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  123934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  123938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123957 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  123960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123974 */     GIR_RootConstrainSelectedInstOperands,
     /*  123975 */     // GIR_Coverage, 71736,
     /*  123975 */     GIR_EraseRootFromParent_Done,
     /*  123976 */   // Label 2173: @123976
     /*  123976 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(124042), // Rule ID 71737 //
     /*  123981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124023 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124040 */     GIR_RootConstrainSelectedInstOperands,
     /*  124041 */     // GIR_Coverage, 71737,
     /*  124041 */     GIR_EraseRootFromParent_Done,
     /*  124042 */   // Label 2174: @124042
     /*  124042 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(124108), // Rule ID 53206 //
     /*  124047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124089 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124106 */     GIR_RootConstrainSelectedInstOperands,
     /*  124107 */     // GIR_Coverage, 53206,
     /*  124107 */     GIR_EraseRootFromParent_Done,
     /*  124108 */   // Label 2175: @124108
     /*  124108 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(124174), // Rule ID 53207 //
     /*  124113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  124132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  124136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124155 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  124158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124172 */     GIR_RootConstrainSelectedInstOperands,
     /*  124173 */     // GIR_Coverage, 53207,
     /*  124173 */     GIR_EraseRootFromParent_Done,
     /*  124174 */   // Label 2176: @124174
     /*  124174 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(124207), // Rule ID 53194 //
     /*  124179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124190 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  124193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124205 */     GIR_RootConstrainSelectedInstOperands,
     /*  124206 */     // GIR_Coverage, 53194,
     /*  124206 */     GIR_EraseRootFromParent_Done,
     /*  124207 */   // Label 2177: @124207
     /*  124207 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(124240), // Rule ID 53195 //
     /*  124212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124223 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  124226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124238 */     GIR_RootConstrainSelectedInstOperands,
     /*  124239 */     // GIR_Coverage, 53195,
     /*  124239 */     GIR_EraseRootFromParent_Done,
     /*  124240 */   // Label 2178: @124240
     /*  124240 */   GIM_Reject,
     /*  124241 */ // Label 2168: @124241
     /*  124241 */ GIM_Reject,
     /*  124242 */ // Label 2043: @124242
     /*  124242 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(124356),
     /*  124247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  124250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  124253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124265 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(124310), // Rule ID 47658 //
     /*  124270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124273 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  124273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  124276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  124290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124308 */     GIR_RootConstrainSelectedInstOperands,
     /*  124309 */     // GIR_Coverage, 47658,
     /*  124309 */     GIR_EraseRootFromParent_Done,
     /*  124310 */   // Label 2180: @124310
     /*  124310 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(124355), // Rule ID 47659 //
     /*  124315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124318 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  124318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  124321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  124335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124353 */     GIR_RootConstrainSelectedInstOperands,
     /*  124354 */     // GIR_Coverage, 47659,
     /*  124354 */     GIR_EraseRootFromParent_Done,
     /*  124355 */   // Label 2181: @124355
     /*  124355 */   GIM_Reject,
     /*  124356 */ // Label 2179: @124356
     /*  124356 */ GIM_Reject,
     /*  124357 */ // Label 2044: @124357
     /*  124357 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(124471),
     /*  124362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  124365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  124368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124380 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(124425), // Rule ID 47678 //
     /*  124385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124388 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  124388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  124391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124423 */     GIR_RootConstrainSelectedInstOperands,
     /*  124424 */     // GIR_Coverage, 47678,
     /*  124424 */     GIR_EraseRootFromParent_Done,
     /*  124425 */   // Label 2183: @124425
     /*  124425 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(124470), // Rule ID 47679 //
     /*  124430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124433 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  124433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  124436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  124450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  124465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124468 */     GIR_RootConstrainSelectedInstOperands,
     /*  124469 */     // GIR_Coverage, 47679,
     /*  124469 */     GIR_EraseRootFromParent_Done,
     /*  124470 */   // Label 2184: @124470
     /*  124470 */   GIM_Reject,
     /*  124471 */ // Label 2182: @124471
     /*  124471 */ GIM_Reject,
     /*  124472 */ // Label 2045: @124472
     /*  124472 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(124586),
     /*  124477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  124480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  124483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124491 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  124495 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(124540), // Rule ID 47714 //
     /*  124500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124503 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  124503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124538 */     GIR_RootConstrainSelectedInstOperands,
     /*  124539 */     // GIR_Coverage, 47714,
     /*  124539 */     GIR_EraseRootFromParent_Done,
     /*  124540 */   // Label 2186: @124540
     /*  124540 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(124585), // Rule ID 47715 //
     /*  124545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124548 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  124548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  124551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  124565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  124580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124583 */     GIR_RootConstrainSelectedInstOperands,
     /*  124584 */     // GIR_Coverage, 47715,
     /*  124584 */     GIR_EraseRootFromParent_Done,
     /*  124585 */   // Label 2187: @124585
     /*  124585 */   GIM_Reject,
     /*  124586 */ // Label 2185: @124586
     /*  124586 */ GIM_Reject,
     /*  124587 */ // Label 2046: @124587
     /*  124587 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(124701),
     /*  124592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  124595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  124598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  124610 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(124655), // Rule ID 47730 //
     /*  124615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  124618 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  124618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  124621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  124635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124653 */     GIR_RootConstrainSelectedInstOperands,
     /*  124654 */     // GIR_Coverage, 47730,
     /*  124654 */     GIR_EraseRootFromParent_Done,
     /*  124655 */   // Label 2189: @124655
     /*  124655 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(124700), // Rule ID 47731 //
     /*  124660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  124663 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  124663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  124666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  124670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  124680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  124687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  124689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  124695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  124698 */     GIR_RootConstrainSelectedInstOperands,
     /*  124699 */     // GIR_Coverage, 47731,
     /*  124699 */     GIR_EraseRootFromParent_Done,
     /*  124700 */   // Label 2190: @124700
     /*  124700 */   GIM_Reject,
     /*  124701 */ // Label 2188: @124701
     /*  124701 */ GIM_Reject,
     /*  124702 */ // Label 2047: @124702
     /*  124702 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(125312),
     /*  124707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124717 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(124783), // Rule ID 71768 //
     /*  124722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124764 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124781 */     GIR_RootConstrainSelectedInstOperands,
     /*  124782 */     // GIR_Coverage, 71768,
     /*  124782 */     GIR_EraseRootFromParent_Done,
     /*  124783 */   // Label 2192: @124783
     /*  124783 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(124849), // Rule ID 71769 //
     /*  124788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124830 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  124841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124847 */     GIR_RootConstrainSelectedInstOperands,
     /*  124848 */     // GIR_Coverage, 71769,
     /*  124848 */     GIR_EraseRootFromParent_Done,
     /*  124849 */   // Label 2193: @124849
     /*  124849 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(124915), // Rule ID 71766 //
     /*  124854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  124890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124896 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  124896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124913 */     GIR_RootConstrainSelectedInstOperands,
     /*  124914 */     // GIR_Coverage, 71766,
     /*  124914 */     GIR_EraseRootFromParent_Done,
     /*  124915 */   // Label 2194: @124915
     /*  124915 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(124981), // Rule ID 71767 //
     /*  124920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  124923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  124931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  124935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  124939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  124952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  124962 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  124962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  124965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  124969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  124973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  124976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  124979 */     GIR_RootConstrainSelectedInstOperands,
     /*  124980 */     // GIR_Coverage, 71767,
     /*  124980 */     GIR_EraseRootFromParent_Done,
     /*  124981 */   // Label 2195: @124981
     /*  124981 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(125047), // Rule ID 71764 //
     /*  124986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  124989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  124993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  124997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125017 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125028 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125045 */     GIR_RootConstrainSelectedInstOperands,
     /*  125046 */     // GIR_Coverage, 71764,
     /*  125046 */     GIR_EraseRootFromParent_Done,
     /*  125047 */   // Label 2196: @125047
     /*  125047 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(125113), // Rule ID 71765 //
     /*  125052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125094 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125111 */     GIR_RootConstrainSelectedInstOperands,
     /*  125112 */     // GIR_Coverage, 71765,
     /*  125112 */     GIR_EraseRootFromParent_Done,
     /*  125113 */   // Label 2197: @125113
     /*  125113 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(125179), // Rule ID 53224 //
     /*  125118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125160 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125177 */     GIR_RootConstrainSelectedInstOperands,
     /*  125178 */     // GIR_Coverage, 53224,
     /*  125178 */     GIR_EraseRootFromParent_Done,
     /*  125179 */   // Label 2198: @125179
     /*  125179 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(125245), // Rule ID 53225 //
     /*  125184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  125203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  125207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125226 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  125229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125243 */     GIR_RootConstrainSelectedInstOperands,
     /*  125244 */     // GIR_Coverage, 53225,
     /*  125244 */     GIR_EraseRootFromParent_Done,
     /*  125245 */   // Label 2199: @125245
     /*  125245 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(125278), // Rule ID 53212 //
     /*  125250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125261 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  125264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125276 */     GIR_RootConstrainSelectedInstOperands,
     /*  125277 */     // GIR_Coverage, 53212,
     /*  125277 */     GIR_EraseRootFromParent_Done,
     /*  125278 */   // Label 2200: @125278
     /*  125278 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(125311), // Rule ID 53213 //
     /*  125283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125294 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  125297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125309 */     GIR_RootConstrainSelectedInstOperands,
     /*  125310 */     // GIR_Coverage, 53213,
     /*  125310 */     GIR_EraseRootFromParent_Done,
     /*  125311 */   // Label 2201: @125311
     /*  125311 */   GIM_Reject,
     /*  125312 */ // Label 2191: @125312
     /*  125312 */ GIM_Reject,
     /*  125313 */ // Label 2048: @125313
     /*  125313 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(125427),
     /*  125318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  125321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  125324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125336 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(125381), // Rule ID 47674 //
     /*  125341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125344 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  125344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  125347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  125361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125379 */     GIR_RootConstrainSelectedInstOperands,
     /*  125380 */     // GIR_Coverage, 47674,
     /*  125380 */     GIR_EraseRootFromParent_Done,
     /*  125381 */   // Label 2203: @125381
     /*  125381 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(125426), // Rule ID 47675 //
     /*  125386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125389 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  125389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  125392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  125406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125424 */     GIR_RootConstrainSelectedInstOperands,
     /*  125425 */     // GIR_Coverage, 47675,
     /*  125425 */     GIR_EraseRootFromParent_Done,
     /*  125426 */   // Label 2204: @125426
     /*  125426 */   GIM_Reject,
     /*  125427 */ // Label 2202: @125427
     /*  125427 */ GIM_Reject,
     /*  125428 */ // Label 2049: @125428
     /*  125428 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(125542),
     /*  125433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  125436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  125439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  125451 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(125496), // Rule ID 47702 //
     /*  125456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125459 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  125459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125494 */     GIR_RootConstrainSelectedInstOperands,
     /*  125495 */     // GIR_Coverage, 47702,
     /*  125495 */     GIR_EraseRootFromParent_Done,
     /*  125496 */   // Label 2206: @125496
     /*  125496 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(125541), // Rule ID 47703 //
     /*  125501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125504 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  125504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  125507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  125521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  125536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125539 */     GIR_RootConstrainSelectedInstOperands,
     /*  125540 */     // GIR_Coverage, 47703,
     /*  125540 */     GIR_EraseRootFromParent_Done,
     /*  125541 */   // Label 2207: @125541
     /*  125541 */   GIM_Reject,
     /*  125542 */ // Label 2205: @125542
     /*  125542 */ GIM_Reject,
     /*  125543 */ // Label 2050: @125543
     /*  125543 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(125657),
     /*  125548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  125551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  125554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  125566 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(125611), // Rule ID 47718 //
     /*  125571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125574 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  125574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  125577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125609 */     GIR_RootConstrainSelectedInstOperands,
     /*  125610 */     // GIR_Coverage, 47718,
     /*  125610 */     GIR_EraseRootFromParent_Done,
     /*  125611 */   // Label 2209: @125611
     /*  125611 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(125656), // Rule ID 47719 //
     /*  125616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125619 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  125619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  125622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  125636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  125651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125654 */     GIR_RootConstrainSelectedInstOperands,
     /*  125655 */     // GIR_Coverage, 47719,
     /*  125655 */     GIR_EraseRootFromParent_Done,
     /*  125656 */   // Label 2210: @125656
     /*  125656 */   GIM_Reject,
     /*  125657 */ // Label 2208: @125657
     /*  125657 */ GIM_Reject,
     /*  125658 */ // Label 2051: @125658
     /*  125658 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(125772),
     /*  125663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  125666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  125669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  125681 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(125726), // Rule ID 47734 //
     /*  125686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  125689 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  125689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  125692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  125706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125724 */     GIR_RootConstrainSelectedInstOperands,
     /*  125725 */     // GIR_Coverage, 47734,
     /*  125725 */     GIR_EraseRootFromParent_Done,
     /*  125726 */   // Label 2212: @125726
     /*  125726 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(125771), // Rule ID 47735 //
     /*  125731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  125734 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  125734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  125737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  125741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  125751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  125758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  125760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  125766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  125769 */     GIR_RootConstrainSelectedInstOperands,
     /*  125770 */     // GIR_Coverage, 47735,
     /*  125770 */     GIR_EraseRootFromParent_Done,
     /*  125771 */   // Label 2213: @125771
     /*  125771 */   GIM_Reject,
     /*  125772 */ // Label 2211: @125772
     /*  125772 */ GIM_Reject,
     /*  125773 */ // Label 2052: @125773
     /*  125773 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(126383),
     /*  125778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125788 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(125854), // Rule ID 71796 //
     /*  125793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125835 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125852 */     GIR_RootConstrainSelectedInstOperands,
     /*  125853 */     // GIR_Coverage, 71796,
     /*  125853 */     GIR_EraseRootFromParent_Done,
     /*  125854 */   // Label 2215: @125854
     /*  125854 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(125920), // Rule ID 71797 //
     /*  125859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125901 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  125901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  125912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125918 */     GIR_RootConstrainSelectedInstOperands,
     /*  125919 */     // GIR_Coverage, 71797,
     /*  125919 */     GIR_EraseRootFromParent_Done,
     /*  125920 */   // Label 2216: @125920
     /*  125920 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(125986), // Rule ID 71794 //
     /*  125925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  125928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  125936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  125940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  125944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  125953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  125957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  125961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  125965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125967 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  125967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  125970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  125974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  125981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  125984 */     GIR_RootConstrainSelectedInstOperands,
     /*  125985 */     // GIR_Coverage, 71794,
     /*  125985 */     GIR_EraseRootFromParent_Done,
     /*  125986 */   // Label 2217: @125986
     /*  125986 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(126052), // Rule ID 71795 //
     /*  125991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  125994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126033 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126050 */     GIR_RootConstrainSelectedInstOperands,
     /*  126051 */     // GIR_Coverage, 71795,
     /*  126051 */     GIR_EraseRootFromParent_Done,
     /*  126052 */   // Label 2218: @126052
     /*  126052 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(126118), // Rule ID 71792 //
     /*  126057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126099 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126116 */     GIR_RootConstrainSelectedInstOperands,
     /*  126117 */     // GIR_Coverage, 71792,
     /*  126117 */     GIR_EraseRootFromParent_Done,
     /*  126118 */   // Label 2219: @126118
     /*  126118 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(126184), // Rule ID 71793 //
     /*  126123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126165 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126182 */     GIR_RootConstrainSelectedInstOperands,
     /*  126183 */     // GIR_Coverage, 71793,
     /*  126183 */     GIR_EraseRootFromParent_Done,
     /*  126184 */   // Label 2220: @126184
     /*  126184 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(126250), // Rule ID 53242 //
     /*  126189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126231 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126248 */     GIR_RootConstrainSelectedInstOperands,
     /*  126249 */     // GIR_Coverage, 53242,
     /*  126249 */     GIR_EraseRootFromParent_Done,
     /*  126250 */   // Label 2221: @126250
     /*  126250 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(126316), // Rule ID 53243 //
     /*  126255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  126274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  126278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126297 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  126300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126314 */     GIR_RootConstrainSelectedInstOperands,
     /*  126315 */     // GIR_Coverage, 53243,
     /*  126315 */     GIR_EraseRootFromParent_Done,
     /*  126316 */   // Label 2222: @126316
     /*  126316 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(126349), // Rule ID 53230 //
     /*  126321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126332 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  126335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126347 */     GIR_RootConstrainSelectedInstOperands,
     /*  126348 */     // GIR_Coverage, 53230,
     /*  126348 */     GIR_EraseRootFromParent_Done,
     /*  126349 */   // Label 2223: @126349
     /*  126349 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(126382), // Rule ID 53231 //
     /*  126354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126365 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  126368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126380 */     GIR_RootConstrainSelectedInstOperands,
     /*  126381 */     // GIR_Coverage, 53231,
     /*  126381 */     GIR_EraseRootFromParent_Done,
     /*  126382 */   // Label 2224: @126382
     /*  126382 */   GIM_Reject,
     /*  126383 */ // Label 2214: @126383
     /*  126383 */ GIM_Reject,
     /*  126384 */ // Label 2053: @126384
     /*  126384 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(126498),
     /*  126389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  126392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  126395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  126407 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(126452), // Rule ID 47690 //
     /*  126412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126415 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  126415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  126418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126450 */     GIR_RootConstrainSelectedInstOperands,
     /*  126451 */     // GIR_Coverage, 47690,
     /*  126451 */     GIR_EraseRootFromParent_Done,
     /*  126452 */   // Label 2226: @126452
     /*  126452 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(126497), // Rule ID 47691 //
     /*  126457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126460 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  126460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  126463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  126477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126495 */     GIR_RootConstrainSelectedInstOperands,
     /*  126496 */     // GIR_Coverage, 47691,
     /*  126496 */     GIR_EraseRootFromParent_Done,
     /*  126497 */   // Label 2227: @126497
     /*  126497 */   GIM_Reject,
     /*  126498 */ // Label 2225: @126498
     /*  126498 */ GIM_Reject,
     /*  126499 */ // Label 2054: @126499
     /*  126499 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126613),
     /*  126504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  126507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  126510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  126522 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(126567), // Rule ID 47706 //
     /*  126527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126530 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  126530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  126533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126565 */     GIR_RootConstrainSelectedInstOperands,
     /*  126566 */     // GIR_Coverage, 47706,
     /*  126566 */     GIR_EraseRootFromParent_Done,
     /*  126567 */   // Label 2229: @126567
     /*  126567 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(126612), // Rule ID 47707 //
     /*  126572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126575 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  126575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  126578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  126592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  126607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126610 */     GIR_RootConstrainSelectedInstOperands,
     /*  126611 */     // GIR_Coverage, 47707,
     /*  126611 */     GIR_EraseRootFromParent_Done,
     /*  126612 */   // Label 2230: @126612
     /*  126612 */   GIM_Reject,
     /*  126613 */ // Label 2228: @126613
     /*  126613 */ GIM_Reject,
     /*  126614 */ // Label 2055: @126614
     /*  126614 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(126728),
     /*  126619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  126622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  126625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  126637 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(126682), // Rule ID 47722 //
     /*  126642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126645 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  126645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  126648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126680 */     GIR_RootConstrainSelectedInstOperands,
     /*  126681 */     // GIR_Coverage, 47722,
     /*  126681 */     GIR_EraseRootFromParent_Done,
     /*  126682 */   // Label 2232: @126682
     /*  126682 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(126727), // Rule ID 47723 //
     /*  126687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126690 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  126690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  126693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  126697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  126707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  126716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  126722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  126725 */     GIR_RootConstrainSelectedInstOperands,
     /*  126726 */     // GIR_Coverage, 47723,
     /*  126726 */     GIR_EraseRootFromParent_Done,
     /*  126727 */   // Label 2233: @126727
     /*  126727 */   GIM_Reject,
     /*  126728 */ // Label 2231: @126728
     /*  126728 */ GIM_Reject,
     /*  126729 */ // Label 2056: @126729
     /*  126729 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(127339),
     /*  126734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126744 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(126810), // Rule ID 71824 //
     /*  126749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126791 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126808 */     GIR_RootConstrainSelectedInstOperands,
     /*  126809 */     // GIR_Coverage, 71824,
     /*  126809 */     GIR_EraseRootFromParent_Done,
     /*  126810 */   // Label 2235: @126810
     /*  126810 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(126876), // Rule ID 71825 //
     /*  126815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126857 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  126868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126874 */     GIR_RootConstrainSelectedInstOperands,
     /*  126875 */     // GIR_Coverage, 71825,
     /*  126875 */     GIR_EraseRootFromParent_Done,
     /*  126876 */   // Label 2236: @126876
     /*  126876 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(126942), // Rule ID 71822 //
     /*  126881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  126884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126923 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  126923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  126937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  126940 */     GIR_RootConstrainSelectedInstOperands,
     /*  126941 */     // GIR_Coverage, 71822,
     /*  126941 */     GIR_EraseRootFromParent_Done,
     /*  126942 */   // Label 2237: @126942
     /*  126942 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(127008), // Rule ID 71823 //
     /*  126947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  126950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  126962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  126966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  126979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  126983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  126987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  126989 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  126989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  126992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127006 */     GIR_RootConstrainSelectedInstOperands,
     /*  127007 */     // GIR_Coverage, 71823,
     /*  127007 */     GIR_EraseRootFromParent_Done,
     /*  127008 */   // Label 2238: @127008
     /*  127008 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(127074), // Rule ID 71820 //
     /*  127013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127055 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127072 */     GIR_RootConstrainSelectedInstOperands,
     /*  127073 */     // GIR_Coverage, 71820,
     /*  127073 */     GIR_EraseRootFromParent_Done,
     /*  127074 */   // Label 2239: @127074
     /*  127074 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(127140), // Rule ID 71821 //
     /*  127079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127121 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127138 */     GIR_RootConstrainSelectedInstOperands,
     /*  127139 */     // GIR_Coverage, 71821,
     /*  127139 */     GIR_EraseRootFromParent_Done,
     /*  127140 */   // Label 2240: @127140
     /*  127140 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(127206), // Rule ID 53260 //
     /*  127145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127187 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127204 */     GIR_RootConstrainSelectedInstOperands,
     /*  127205 */     // GIR_Coverage, 53260,
     /*  127205 */     GIR_EraseRootFromParent_Done,
     /*  127206 */   // Label 2241: @127206
     /*  127206 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(127272), // Rule ID 53261 //
     /*  127211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  127230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  127234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127253 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  127256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127270 */     GIR_RootConstrainSelectedInstOperands,
     /*  127271 */     // GIR_Coverage, 53261,
     /*  127271 */     GIR_EraseRootFromParent_Done,
     /*  127272 */   // Label 2242: @127272
     /*  127272 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(127305), // Rule ID 53248 //
     /*  127277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127288 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  127291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127303 */     GIR_RootConstrainSelectedInstOperands,
     /*  127304 */     // GIR_Coverage, 53248,
     /*  127304 */     GIR_EraseRootFromParent_Done,
     /*  127305 */   // Label 2243: @127305
     /*  127305 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(127338), // Rule ID 53249 //
     /*  127310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127321 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  127324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127336 */     GIR_RootConstrainSelectedInstOperands,
     /*  127337 */     // GIR_Coverage, 53249,
     /*  127337 */     GIR_EraseRootFromParent_Done,
     /*  127338 */   // Label 2244: @127338
     /*  127338 */   GIM_Reject,
     /*  127339 */ // Label 2234: @127339
     /*  127339 */ GIM_Reject,
     /*  127340 */ // Label 2057: @127340
     /*  127340 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(127454),
     /*  127345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  127348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  127351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  127363 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(127408), // Rule ID 47694 //
     /*  127368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127371 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  127371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  127374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127406 */     GIR_RootConstrainSelectedInstOperands,
     /*  127407 */     // GIR_Coverage, 47694,
     /*  127407 */     GIR_EraseRootFromParent_Done,
     /*  127408 */   // Label 2246: @127408
     /*  127408 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(127453), // Rule ID 47695 //
     /*  127413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127416 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  127416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  127419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  127433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127451 */     GIR_RootConstrainSelectedInstOperands,
     /*  127452 */     // GIR_Coverage, 47695,
     /*  127452 */     GIR_EraseRootFromParent_Done,
     /*  127453 */   // Label 2247: @127453
     /*  127453 */   GIM_Reject,
     /*  127454 */ // Label 2245: @127454
     /*  127454 */ GIM_Reject,
     /*  127455 */ // Label 2058: @127455
     /*  127455 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(127569),
     /*  127460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  127463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  127466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  127478 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(127523), // Rule ID 47710 //
     /*  127483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127486 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  127486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127521 */     GIR_RootConstrainSelectedInstOperands,
     /*  127522 */     // GIR_Coverage, 47710,
     /*  127522 */     GIR_EraseRootFromParent_Done,
     /*  127523 */   // Label 2249: @127523
     /*  127523 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(127568), // Rule ID 47711 //
     /*  127528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127531 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  127531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  127534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  127538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  127548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  127557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  127563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  127566 */     GIR_RootConstrainSelectedInstOperands,
     /*  127567 */     // GIR_Coverage, 47711,
     /*  127567 */     GIR_EraseRootFromParent_Done,
     /*  127568 */   // Label 2250: @127568
     /*  127568 */   GIM_Reject,
     /*  127569 */ // Label 2248: @127569
     /*  127569 */ GIM_Reject,
     /*  127570 */ // Label 2059: @127570
     /*  127570 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128180),
     /*  127575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127585 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(127651), // Rule ID 71852 //
     /*  127590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127632 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127649 */     GIR_RootConstrainSelectedInstOperands,
     /*  127650 */     // GIR_Coverage, 71852,
     /*  127650 */     GIR_EraseRootFromParent_Done,
     /*  127651 */   // Label 2252: @127651
     /*  127651 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(127717), // Rule ID 71853 //
     /*  127656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127698 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127715 */     GIR_RootConstrainSelectedInstOperands,
     /*  127716 */     // GIR_Coverage, 71853,
     /*  127716 */     GIR_EraseRootFromParent_Done,
     /*  127717 */   // Label 2253: @127717
     /*  127717 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(127783), // Rule ID 71850 //
     /*  127722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127764 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127781 */     GIR_RootConstrainSelectedInstOperands,
     /*  127782 */     // GIR_Coverage, 71850,
     /*  127782 */     GIR_EraseRootFromParent_Done,
     /*  127783 */   // Label 2254: @127783
     /*  127783 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(127849), // Rule ID 71851 //
     /*  127788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  127816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127830 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  127837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  127841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127847 */     GIR_RootConstrainSelectedInstOperands,
     /*  127848 */     // GIR_Coverage, 71851,
     /*  127848 */     GIR_EraseRootFromParent_Done,
     /*  127849 */   // Label 2255: @127849
     /*  127849 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(127915), // Rule ID 71848 //
     /*  127854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127896 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  127896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127913 */     GIR_RootConstrainSelectedInstOperands,
     /*  127914 */     // GIR_Coverage, 71848,
     /*  127914 */     GIR_EraseRootFromParent_Done,
     /*  127915 */   // Label 2256: @127915
     /*  127915 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(127981), // Rule ID 71849 //
     /*  127920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  127923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  127935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  127939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  127943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  127951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  127955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127960 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  127962 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  127962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  127965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  127969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  127973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  127976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  127979 */     GIR_RootConstrainSelectedInstOperands,
     /*  127980 */     // GIR_Coverage, 71849,
     /*  127980 */     GIR_EraseRootFromParent_Done,
     /*  127981 */   // Label 2257: @127981
     /*  127981 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(128047), // Rule ID 53278 //
     /*  127986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  127989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  127993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  127997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128028 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128045 */     GIR_RootConstrainSelectedInstOperands,
     /*  128046 */     // GIR_Coverage, 53278,
     /*  128046 */     GIR_EraseRootFromParent_Done,
     /*  128047 */   // Label 2258: @128047
     /*  128047 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(128113), // Rule ID 53279 //
     /*  128052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  128067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  128071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  128075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  128088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128094 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  128097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128111 */     GIR_RootConstrainSelectedInstOperands,
     /*  128112 */     // GIR_Coverage, 53279,
     /*  128112 */     GIR_EraseRootFromParent_Done,
     /*  128113 */   // Label 2259: @128113
     /*  128113 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(128146), // Rule ID 53266 //
     /*  128118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128129 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  128129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  128132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128144 */     GIR_RootConstrainSelectedInstOperands,
     /*  128145 */     // GIR_Coverage, 53266,
     /*  128145 */     GIR_EraseRootFromParent_Done,
     /*  128146 */   // Label 2260: @128146
     /*  128146 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(128179), // Rule ID 53267 //
     /*  128151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  128162 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  128162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  128165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  128177 */     GIR_RootConstrainSelectedInstOperands,
     /*  128178 */     // GIR_Coverage, 53267,
     /*  128178 */     GIR_EraseRootFromParent_Done,
     /*  128179 */   // Label 2261: @128179
     /*  128179 */   GIM_Reject,
     /*  128180 */ // Label 2251: @128180
     /*  128180 */ GIM_Reject,
     /*  128181 */ // Label 2060: @128181
     /*  128181 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(128295),
     /*  128186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  128189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  128192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  128204 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(128249), // Rule ID 47698 //
     /*  128209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  128212 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  128212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  128215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128247 */     GIR_RootConstrainSelectedInstOperands,
     /*  128248 */     // GIR_Coverage, 47698,
     /*  128248 */     GIR_EraseRootFromParent_Done,
     /*  128249 */   // Label 2263: @128249
     /*  128249 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(128294), // Rule ID 47699 //
     /*  128254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  128257 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  128257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  128260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  128264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  128274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  128281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  128283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  128286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  128292 */     GIR_RootConstrainSelectedInstOperands,
     /*  128293 */     // GIR_Coverage, 47699,
     /*  128293 */     GIR_EraseRootFromParent_Done,
     /*  128294 */   // Label 2264: @128294
     /*  128294 */   GIM_Reject,
     /*  128295 */ // Label 2262: @128295
     /*  128295 */ GIM_Reject,
     /*  128296 */ // Label 2061: @128296
     /*  128296 */ GIM_Reject,
     /*  128297 */ // Label 8: @128297
     /*  128297 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2296*/ GIMT_Encode4(140917),
     /*  128308 */ /*GILLT_s32*//*Label 2265*/ GIMT_Encode4(128432),
     /*  128312 */ /*GILLT_s64*//*Label 2266*/ GIMT_Encode4(131162),
     /*  128316 */ /*GILLT_nxv1s1*//*Label 2267*/ GIMT_Encode4(134110),
     /*  128320 */ /*GILLT_nxv1s8*//*Label 2268*/ GIMT_Encode4(134721),
     /*  128324 */ /*GILLT_nxv1s16*//*Label 2269*/ GIMT_Encode4(134836),
     /*  128328 */ /*GILLT_nxv1s32*//*Label 2270*/ GIMT_Encode4(134951),
     /*  128332 */ /*GILLT_nxv1s64*//*Label 2271*/ GIMT_Encode4(135066),
     /*  128336 */ /*GILLT_nxv2s1*//*Label 2272*/ GIMT_Encode4(135181),
     /*  128340 */ /*GILLT_nxv2s8*//*Label 2273*/ GIMT_Encode4(135792),
     /*  128344 */ /*GILLT_nxv2s16*//*Label 2274*/ GIMT_Encode4(135907),
     /*  128348 */ /*GILLT_nxv2s32*//*Label 2275*/ GIMT_Encode4(136022),
     /*  128352 */ /*GILLT_nxv2s64*//*Label 2276*/ GIMT_Encode4(136137),
     /*  128356 */ /*GILLT_nxv4s1*//*Label 2277*/ GIMT_Encode4(136252),
     /*  128360 */ /*GILLT_nxv4s8*//*Label 2278*/ GIMT_Encode4(136863),
     /*  128364 */ /*GILLT_nxv4s16*//*Label 2279*/ GIMT_Encode4(136978),
     /*  128368 */ /*GILLT_nxv4s32*//*Label 2280*/ GIMT_Encode4(137093),
     /*  128372 */ /*GILLT_nxv4s64*//*Label 2281*/ GIMT_Encode4(137208),
     /*  128376 */ /*GILLT_nxv8s1*//*Label 2282*/ GIMT_Encode4(137323),
     /*  128380 */ /*GILLT_nxv8s8*//*Label 2283*/ GIMT_Encode4(137934),
     /*  128384 */ /*GILLT_nxv8s16*//*Label 2284*/ GIMT_Encode4(138049),
     /*  128388 */ /*GILLT_nxv8s32*//*Label 2285*/ GIMT_Encode4(138164),
     /*  128392 */ /*GILLT_nxv8s64*//*Label 2286*/ GIMT_Encode4(138279),
     /*  128396 */ /*GILLT_nxv16s1*//*Label 2287*/ GIMT_Encode4(138394),
     /*  128400 */ /*GILLT_nxv16s8*//*Label 2288*/ GIMT_Encode4(139005),
     /*  128404 */ /*GILLT_nxv16s16*//*Label 2289*/ GIMT_Encode4(139120),
     /*  128408 */ /*GILLT_nxv16s32*//*Label 2290*/ GIMT_Encode4(139235),
     /*  128412 */ /*GILLT_nxv32s1*//*Label 2291*/ GIMT_Encode4(139350),
     /*  128416 */ /*GILLT_nxv32s8*//*Label 2292*/ GIMT_Encode4(139961),
     /*  128420 */ /*GILLT_nxv32s16*//*Label 2293*/ GIMT_Encode4(140076),
     /*  128424 */ /*GILLT_nxv64s1*//*Label 2294*/ GIMT_Encode4(140191),
     /*  128428 */ /*GILLT_nxv64s8*//*Label 2295*/ GIMT_Encode4(140802),
     /*  128432 */ // Label 2265: @128432
     /*  128432 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(131161),
     /*  128437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  128440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  128443 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(128638), // Rule ID 65502 //
     /*  128448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128483 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128487 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128499 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128503 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128507 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128511 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128515 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128519 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128523 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  128527 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128531 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128535 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128539 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128543 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  128547 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128556 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128563 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128570 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128577 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128577 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128580 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128584 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  128594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  128599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  128618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  128623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128636 */     GIR_RootConstrainSelectedInstOperands,
     /*  128637 */     // GIR_Coverage, 65502,
     /*  128637 */     GIR_EraseRootFromParent_Done,
     /*  128638 */   // Label 2298: @128638
     /*  128638 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(128833), // Rule ID 65504 //
     /*  128643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  128670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128682 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128694 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128698 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128702 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128706 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128710 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128714 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128718 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  128722 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128726 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128730 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128734 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128738 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  128742 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128758 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128765 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128772 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128772 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128775 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128779 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  128789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  128794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  128813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  128818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128831 */     GIR_RootConstrainSelectedInstOperands,
     /*  128832 */     // GIR_Coverage, 65504,
     /*  128832 */     GIR_EraseRootFromParent_Done,
     /*  128833 */   // Label 2299: @128833
     /*  128833 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(129028), // Rule ID 65498 //
     /*  128838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  128841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  128857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  128861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  128873 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  128877 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  128885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  128889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  128893 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  128897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  128901 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128905 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  128909 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  128913 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  128917 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  128921 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128925 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  128929 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  128933 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  128937 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128946 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128953 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128960 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128967 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  128967 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  128970 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128974 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  128984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  128989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  128994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  129008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  129013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129026 */     GIR_RootConstrainSelectedInstOperands,
     /*  129027 */     // GIR_Coverage, 65498,
     /*  129027 */     GIR_EraseRootFromParent_Done,
     /*  129028 */   // Label 2300: @129028
     /*  129028 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(129223), // Rule ID 65500 //
     /*  129033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129068 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129072 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  129076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  129080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129088 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129092 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  129096 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129100 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129104 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129108 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  129112 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  129116 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129120 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129124 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129128 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  129132 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129141 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129148 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129155 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129162 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129162 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129165 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129169 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  129179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  129184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  129203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  129208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129221 */     GIR_RootConstrainSelectedInstOperands,
     /*  129222 */     // GIR_Coverage, 65500,
     /*  129222 */     GIR_EraseRootFromParent_Done,
     /*  129223 */   // Label 2301: @129223
     /*  129223 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(129418), // Rule ID 65492 //
     /*  129228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129267 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129279 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129283 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129287 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  129291 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129295 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129299 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129303 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129307 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129311 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129315 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129319 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129323 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129327 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129336 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129343 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129350 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129357 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  129374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  129379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  129398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  129403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129416 */     GIR_RootConstrainSelectedInstOperands,
     /*  129417 */     // GIR_Coverage, 65492,
     /*  129417 */     GIR_EraseRootFromParent_Done,
     /*  129418 */   // Label 2302: @129418
     /*  129418 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(129613), // Rule ID 65496 //
     /*  129423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129462 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129474 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129478 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129482 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129494 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129498 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129502 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  129506 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129510 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129514 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129518 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129522 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129524 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129531 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129538 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129545 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129552 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  129569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  129574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  129593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  129598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129611 */     GIR_RootConstrainSelectedInstOperands,
     /*  129612 */     // GIR_Coverage, 65496,
     /*  129612 */     GIR_EraseRootFromParent_Done,
     /*  129613 */   // Label 2303: @129613
     /*  129613 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(129808), // Rule ID 2547 //
     /*  129618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129657 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  129661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129673 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129677 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  129681 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129685 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129689 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129693 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129697 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  129701 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129705 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129709 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129713 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129717 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129719 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129726 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129733 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129740 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129747 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129747 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129750 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129754 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  129764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  129769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  129788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  129793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  129806 */     GIR_RootConstrainSelectedInstOperands,
     /*  129807 */     // GIR_Coverage, 2547,
     /*  129807 */     GIR_EraseRootFromParent_Done,
     /*  129808 */   // Label 2304: @129808
     /*  129808 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(130003), // Rule ID 65494 //
     /*  129813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  129816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  129832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  129836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  129852 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  129856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  129860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  129868 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  129872 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  129876 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  129880 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  129884 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  129888 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  129892 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  129896 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129900 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  129904 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  129908 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  129912 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  129914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  129921 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  129928 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  129935 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  129942 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  129942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  129945 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129949 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  129959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  129964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  129966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  129969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  129973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  129978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  129983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  129988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  129990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  129998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  130001 */     GIR_RootConstrainSelectedInstOperands,
     /*  130002 */     // GIR_Coverage, 65494,
     /*  130002 */     GIR_EraseRootFromParent_Done,
     /*  130003 */   // Label 2305: @130003
     /*  130003 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(130108), // Rule ID 2542 //
     /*  130008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130031 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  130035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  130039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130051 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  130055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130064 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130071 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  130071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  130098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  130106 */     GIR_RootConstrainSelectedInstOperands,
     /*  130107 */     // GIR_Coverage, 2542,
     /*  130107 */     GIR_EraseRootFromParent_Done,
     /*  130108 */   // Label 2306: @130108
     /*  130108 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(130213), // Rule ID 65487 //
     /*  130113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130136 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  130144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130156 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  130160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130169 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130176 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  130176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  130179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  130198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  130203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  130211 */     GIR_RootConstrainSelectedInstOperands,
     /*  130212 */     // GIR_Coverage, 65487,
     /*  130212 */     GIR_EraseRootFromParent_Done,
     /*  130213 */   // Label 2307: @130213
     /*  130213 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(130302), // Rule ID 65481 //
     /*  130218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  130233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130262 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130266 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  130277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130286 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  130300 */     GIR_RootConstrainSelectedInstOperands,
     /*  130301 */     // GIR_Coverage, 65481,
     /*  130301 */     GIR_EraseRootFromParent_Done,
     /*  130302 */   // Label 2308: @130302
     /*  130302 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130391), // Rule ID 2536 //
     /*  130307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  130322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  130346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130351 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  130355 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  130366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130375 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  130389 */     GIR_RootConstrainSelectedInstOperands,
     /*  130390 */     // GIR_Coverage, 2536,
     /*  130390 */     GIR_EraseRootFromParent_Done,
     /*  130391 */   // Label 2309: @130391
     /*  130391 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(130456), // Rule ID 65483 //
     /*  130396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130419 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130439 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  130454 */     GIR_RootConstrainSelectedInstOperands,
     /*  130455 */     // GIR_Coverage, 65483,
     /*  130455 */     GIR_EraseRootFromParent_Done,
     /*  130456 */   // Label 2310: @130456
     /*  130456 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(130521), // Rule ID 2538 //
     /*  130461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  130497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130504 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  130514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130519 */     GIR_RootConstrainSelectedInstOperands,
     /*  130520 */     // GIR_Coverage, 2538,
     /*  130520 */     GIR_EraseRootFromParent_Done,
     /*  130521 */   // Label 2311: @130521
     /*  130521 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(130587), // Rule ID 65489 //
     /*  130526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130554 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130558 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11262),
     /*  130562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130571 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }))<<P:Predicate_anonymous_11262>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130585 */     GIR_RootConstrainSelectedInstOperands,
     /*  130586 */     // GIR_Coverage, 65489,
     /*  130586 */     GIR_EraseRootFromParent_Done,
     /*  130587 */   // Label 2312: @130587
     /*  130587 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(130653), // Rule ID 2544 //
     /*  130592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  130595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130620 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  130624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11262),
     /*  130628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  130637 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))<<P:Predicate_anonymous_11262>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  130640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130651 */     GIR_RootConstrainSelectedInstOperands,
     /*  130652 */     // GIR_Coverage, 2544,
     /*  130652 */     GIR_EraseRootFromParent_Done,
     /*  130653 */   // Label 2313: @130653
     /*  130653 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(130715), // Rule ID 2545 //
     /*  130658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130677 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130686 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  130699 */     // (or:{ *:[i32] } (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130713 */     GIR_RootConstrainSelectedInstOperands,
     /*  130714 */     // GIR_Coverage, 2545,
     /*  130714 */     GIR_EraseRootFromParent_Done,
     /*  130715 */   // Label 2314: @130715
     /*  130715 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(130777), // Rule ID 65490 //
     /*  130720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  130723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130748 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  130752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  130761 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }), (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  130764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  130771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130775 */     GIR_RootConstrainSelectedInstOperands,
     /*  130776 */     // GIR_Coverage, 65490,
     /*  130776 */     GIR_EraseRootFromParent_Done,
     /*  130777 */   // Label 2315: @130777
     /*  130777 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(130836), // Rule ID 2471 //
     /*  130782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  130785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  130809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  130822 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  130825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130834 */     GIR_RootConstrainSelectedInstOperands,
     /*  130835 */     // GIR_Coverage, 2471,
     /*  130835 */     GIR_EraseRootFromParent_Done,
     /*  130836 */   // Label 2316: @130836
     /*  130836 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(130895), // Rule ID 65477 //
     /*  130841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  130844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  130860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130868 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  130872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130874 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  130881 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  130884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  130893 */     GIR_RootConstrainSelectedInstOperands,
     /*  130894 */     // GIR_Coverage, 65477,
     /*  130894 */     GIR_EraseRootFromParent_Done,
     /*  130895 */   // Label 2317: @130895
     /*  130895 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(130951), // Rule ID 65461 //
     /*  130900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  130903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130928 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  130932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130938 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  130941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130949 */     GIR_RootConstrainSelectedInstOperands,
     /*  130950 */     // GIR_Coverage, 65461,
     /*  130950 */     GIR_EraseRootFromParent_Done,
     /*  130951 */   // Label 2318: @130951
     /*  130951 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131007), // Rule ID 2445 //
     /*  130956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  130959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  130979 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  130983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  130988 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  130992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  130994 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  130994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  130997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131005 */     GIR_RootConstrainSelectedInstOperands,
     /*  131006 */     // GIR_Coverage, 2445,
     /*  131006 */     GIR_EraseRootFromParent_Done,
     /*  131007 */   // Label 2319: @131007
     /*  131007 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131049), // Rule ID 87 //
     /*  131012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  131015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  131035 */     // MIs[1] Operand 1
     /*  131035 */     // No operand predicates
     /*  131035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131037 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  131037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  131040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131047 */     GIR_RootConstrainSelectedInstOperands,
     /*  131048 */     // GIR_Coverage, 87,
     /*  131048 */     GIR_EraseRootFromParent_Done,
     /*  131049 */   // Label 2320: @131049
     /*  131049 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(131091), // Rule ID 64526 //
     /*  131054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  131057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  131077 */     // MIs[1] Operand 1
     /*  131077 */     // No operand predicates
     /*  131077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131079 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  131079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORAI),
     /*  131082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  131084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131089 */     GIR_RootConstrainSelectedInstOperands,
     /*  131090 */     // GIR_Coverage, 64526,
     /*  131090 */     GIR_EraseRootFromParent_Done,
     /*  131091 */   // Label 2321: @131091
     /*  131091 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(131133), // Rule ID 64530 //
     /*  131096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  131099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  131107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  131115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  131119 */     // MIs[1] Operand 1
     /*  131119 */     // No operand predicates
     /*  131119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  131121 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  131121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORI),
     /*  131124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  131131 */     GIR_RootConstrainSelectedInstOperands,
     /*  131132 */     // GIR_Coverage, 64530,
     /*  131132 */     GIR_EraseRootFromParent_Done,
     /*  131133 */   // Label 2322: @131133
     /*  131133 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(131160), // Rule ID 85 //
     /*  131138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  131141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131153 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (OR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  131153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  131158 */     GIR_RootConstrainSelectedInstOperands,
     /*  131159 */     // GIR_Coverage, 85,
     /*  131159 */     GIR_Done,
     /*  131160 */   // Label 2323: @131160
     /*  131160 */   GIM_Reject,
     /*  131161 */ // Label 2297: @131161
     /*  131161 */ GIM_Reject,
     /*  131162 */ // Label 2266: @131162
     /*  131162 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(134109),
     /*  131167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  131170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  131173 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(131368), // Rule ID 65501 //
     /*  131178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131217 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131229 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131233 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131237 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131241 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131245 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131249 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131253 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  131257 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131261 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131265 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131269 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131273 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  131277 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131293 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131300 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131307 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  131324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  131329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  131348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  131353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131366 */     GIR_RootConstrainSelectedInstOperands,
     /*  131367 */     // GIR_Coverage, 65501,
     /*  131367 */     GIR_EraseRootFromParent_Done,
     /*  131368 */   // Label 2325: @131368
     /*  131368 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(131563), // Rule ID 65503 //
     /*  131373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131412 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131424 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131428 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131432 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131436 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131440 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131444 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131448 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  131452 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131456 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131460 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131464 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131468 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  131472 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131488 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131495 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131502 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131502 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131505 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131509 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  131543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  131548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131561 */     GIR_RootConstrainSelectedInstOperands,
     /*  131562 */     // GIR_Coverage, 65503,
     /*  131562 */     GIR_EraseRootFromParent_Done,
     /*  131563 */   // Label 2326: @131563
     /*  131563 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(131758), // Rule ID 65497 //
     /*  131568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131603 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131607 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131635 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131639 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131643 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  131647 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131651 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131655 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131659 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131663 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  131667 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131676 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131683 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131690 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131697 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  131714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  131719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  131738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  131743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131756 */     GIR_RootConstrainSelectedInstOperands,
     /*  131757 */     // GIR_Coverage, 65497,
     /*  131757 */     GIR_EraseRootFromParent_Done,
     /*  131758 */   // Label 2327: @131758
     /*  131758 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(131953), // Rule ID 65499 //
     /*  131763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131798 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131802 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  131806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  131810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  131818 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  131822 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  131826 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131830 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  131834 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  131838 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  131842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  131846 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131850 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  131854 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  131858 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  131862 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  131864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  131871 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  131878 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  131885 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  131892 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  131892 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  131895 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131899 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  131909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  131914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  131916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  131919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  131923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  131933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  131938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  131943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  131951 */     GIR_RootConstrainSelectedInstOperands,
     /*  131952 */     // GIR_Coverage, 65499,
     /*  131952 */     GIR_EraseRootFromParent_Done,
     /*  131953 */   // Label 2328: @131953
     /*  131953 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132148), // Rule ID 65491 //
     /*  131958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  131961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  131965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  131973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  131977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  131981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  131989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  131997 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132013 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132017 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  132021 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132025 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132029 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132033 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132037 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  132041 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132045 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132049 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132053 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132057 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132059 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132066 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132073 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132080 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132087 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  132128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  132133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132146 */     GIR_RootConstrainSelectedInstOperands,
     /*  132147 */     // GIR_Coverage, 65491,
     /*  132147 */     GIR_EraseRootFromParent_Done,
     /*  132148 */   // Label 2329: @132148
     /*  132148 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132343), // Rule ID 65495 //
     /*  132153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132192 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132208 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132212 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  132216 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132220 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132224 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132228 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132232 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  132236 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132240 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132244 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132248 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132252 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132261 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132268 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132275 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132282 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132282 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132285 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132289 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  132299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  132304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  132323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  132328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132341 */     GIR_RootConstrainSelectedInstOperands,
     /*  132342 */     // GIR_Coverage, 65495,
     /*  132342 */     GIR_EraseRootFromParent_Done,
     /*  132343 */   // Label 2330: @132343
     /*  132343 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(132538), // Rule ID 2546 //
     /*  132348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132387 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132407 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  132411 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132415 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132419 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132423 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132427 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  132431 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132435 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132439 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132443 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132447 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132449 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132456 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132463 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132470 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132477 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  132494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  132499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132536 */     GIR_RootConstrainSelectedInstOperands,
     /*  132537 */     // GIR_Coverage, 2546,
     /*  132537 */     GIR_EraseRootFromParent_Done,
     /*  132538 */   // Label 2331: @132538
     /*  132538 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(132733), // Rule ID 65493 //
     /*  132543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  132546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132566 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132570 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132574 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132578 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132582 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  132590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132594 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  132598 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  132602 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  132606 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  132610 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  132614 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  132618 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  132622 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  132626 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132630 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  132634 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  132638 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  132642 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  132644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132651 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132658 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  132665 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  132672 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  132672 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  132675 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132679 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  132689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  132694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  132696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  132713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  132718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  132723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  132731 */     GIR_RootConstrainSelectedInstOperands,
     /*  132732 */     // GIR_Coverage, 65493,
     /*  132732 */     GIR_EraseRootFromParent_Done,
     /*  132733 */   // Label 2332: @132733
     /*  132733 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(132838), // Rule ID 2541 //
     /*  132738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132761 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  132765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  132769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132781 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  132785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132801 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  132801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  132818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  132823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  132828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  132836 */     GIR_RootConstrainSelectedInstOperands,
     /*  132837 */     // GIR_Coverage, 2541,
     /*  132837 */     GIR_EraseRootFromParent_Done,
     /*  132838 */   // Label 2333: @132838
     /*  132838 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(132943), // Rule ID 65486 //
     /*  132843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132866 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  132870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  132874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132886 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  132890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132892 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  132899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  132906 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  132906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  132909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  132913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  132923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  132928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  132933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  132941 */     GIR_RootConstrainSelectedInstOperands,
     /*  132942 */     // GIR_Coverage, 65486,
     /*  132942 */     GIR_EraseRootFromParent_Done,
     /*  132943 */   // Label 2334: @132943
     /*  132943 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133032), // Rule ID 65480 //
     /*  132948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  132951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  132963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  132967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  132971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  132979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  132987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  132992 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  132996 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  133007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133016 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133030 */     GIR_RootConstrainSelectedInstOperands,
     /*  133031 */     // GIR_Coverage, 65480,
     /*  133031 */     GIR_EraseRootFromParent_Done,
     /*  133032 */   // Label 2335: @133032
     /*  133032 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133121), // Rule ID 2535 //
     /*  133037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  133052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133081 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  133085 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  133096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133105 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133119 */     GIR_RootConstrainSelectedInstOperands,
     /*  133120 */     // GIR_Coverage, 2535,
     /*  133120 */     GIR_EraseRootFromParent_Done,
     /*  133121 */   // Label 2336: @133121
     /*  133121 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133186), // Rule ID 65482 //
     /*  133126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133149 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133169 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  133184 */     GIR_RootConstrainSelectedInstOperands,
     /*  133185 */     // GIR_Coverage, 65482,
     /*  133185 */     GIR_EraseRootFromParent_Done,
     /*  133186 */   // Label 2337: @133186
     /*  133186 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133251), // Rule ID 2537 //
     /*  133191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133214 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  133227 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133234 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  133244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133249 */     GIR_RootConstrainSelectedInstOperands,
     /*  133250 */     // GIR_Coverage, 2537,
     /*  133250 */     GIR_EraseRootFromParent_Done,
     /*  133251 */   // Label 2338: @133251
     /*  133251 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133336), // Rule ID 65507 //
     /*  133256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  133271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133287 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133296 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133300 */     // MIs[1] Operand 2
     /*  133300 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  133311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133320 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133334 */     GIR_RootConstrainSelectedInstOperands,
     /*  133335 */     // GIR_Coverage, 65507,
     /*  133335 */     GIR_EraseRootFromParent_Done,
     /*  133336 */   // Label 2339: @133336
     /*  133336 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133421), // Rule ID 2550 //
     /*  133341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  133356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133372 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  133376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133381 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  133385 */     // MIs[1] Operand 2
     /*  133385 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  133396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133405 */     // (or:{ *:[i64] } (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  133419 */     GIR_RootConstrainSelectedInstOperands,
     /*  133420 */     // GIR_Coverage, 2550,
     /*  133420 */     GIR_EraseRootFromParent_Done,
     /*  133421 */   // Label 2340: @133421
     /*  133421 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133487), // Rule ID 65488 //
     /*  133426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133454 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133458 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11262),
     /*  133462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133471 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }))<<P:Predicate_anonymous_11262>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133485 */     GIR_RootConstrainSelectedInstOperands,
     /*  133486 */     // GIR_Coverage, 65488,
     /*  133486 */     GIR_EraseRootFromParent_Done,
     /*  133487 */   // Label 2341: @133487
     /*  133487 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(133553), // Rule ID 65506 //
     /*  133492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133524 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10038),
     /*  133528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133537 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }))<<P:Predicate_anonymous_10038>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133551 */     GIR_RootConstrainSelectedInstOperands,
     /*  133552 */     // GIR_Coverage, 65506,
     /*  133552 */     GIR_EraseRootFromParent_Done,
     /*  133553 */   // Label 2342: @133553
     /*  133553 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(133619), // Rule ID 2543 //
     /*  133558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  133561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133586 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  133590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11262),
     /*  133594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  133603 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_11262>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  133606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133617 */     GIR_RootConstrainSelectedInstOperands,
     /*  133618 */     // GIR_Coverage, 2543,
     /*  133618 */     GIR_EraseRootFromParent_Done,
     /*  133619 */   // Label 2343: @133619
     /*  133619 */   GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(133685), // Rule ID 2549 //
     /*  133624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133652 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  133656 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10038),
     /*  133660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  133669 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_10038>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  133672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133683 */     GIR_RootConstrainSelectedInstOperands,
     /*  133684 */     // GIR_Coverage, 2549,
     /*  133684 */     GIR_EraseRootFromParent_Done,
     /*  133685 */   // Label 2344: @133685
     /*  133685 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(133747), // Rule ID 2548 //
     /*  133690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133718 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  133722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  133731 */     // (or:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133745 */     GIR_RootConstrainSelectedInstOperands,
     /*  133746 */     // GIR_Coverage, 2548,
     /*  133746 */     GIR_EraseRootFromParent_Done,
     /*  133747 */   // Label 2345: @133747
     /*  133747 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(133809), // Rule ID 65505 //
     /*  133752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  133755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133780 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  133784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  133793 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }), (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  133796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  133803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133807 */     GIR_RootConstrainSelectedInstOperands,
     /*  133808 */     // GIR_Coverage, 65505,
     /*  133808 */     GIR_EraseRootFromParent_Done,
     /*  133809 */   // Label 2346: @133809
     /*  133809 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(133868), // Rule ID 2470 //
     /*  133814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  133817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133837 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  133841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  133854 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  133857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133866 */     GIR_RootConstrainSelectedInstOperands,
     /*  133867 */     // GIR_Coverage, 2470,
     /*  133867 */     GIR_EraseRootFromParent_Done,
     /*  133868 */   // Label 2347: @133868
     /*  133868 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(133927), // Rule ID 65476 //
     /*  133873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  133876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  133892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133900 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  133904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  133913 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  133916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  133925 */     GIR_RootConstrainSelectedInstOperands,
     /*  133926 */     // GIR_Coverage, 65476,
     /*  133926 */     GIR_EraseRootFromParent_Done,
     /*  133927 */   // Label 2348: @133927
     /*  133927 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(133983), // Rule ID 65460 //
     /*  133932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  133935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  133951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  133955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133960 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  133964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  133970 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  133970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  133973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133981 */     GIR_RootConstrainSelectedInstOperands,
     /*  133982 */     // GIR_Coverage, 65460,
     /*  133982 */     GIR_EraseRootFromParent_Done,
     /*  133983 */   // Label 2349: @133983
     /*  133983 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134039), // Rule ID 2444 //
     /*  133988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  133991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  133999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  134011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  134015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134020 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  134024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134026 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  134029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134037 */     GIR_RootConstrainSelectedInstOperands,
     /*  134038 */     // GIR_Coverage, 2444,
     /*  134038 */     GIR_EraseRootFromParent_Done,
     /*  134039 */   // Label 2350: @134039
     /*  134039 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134081), // Rule ID 86 //
     /*  134044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  134047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  134063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  134067 */     // MIs[1] Operand 1
     /*  134067 */     // No operand predicates
     /*  134067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  134069 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  134069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  134072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  134079 */     GIR_RootConstrainSelectedInstOperands,
     /*  134080 */     // GIR_Coverage, 86,
     /*  134080 */     GIR_EraseRootFromParent_Done,
     /*  134081 */   // Label 2351: @134081
     /*  134081 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(134108), // Rule ID 84 //
     /*  134086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  134089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  134101 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (OR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  134101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  134106 */     GIR_RootConstrainSelectedInstOperands,
     /*  134107 */     // GIR_Coverage, 84,
     /*  134107 */     GIR_Done,
     /*  134108 */   // Label 2352: @134108
     /*  134108 */   GIM_Reject,
     /*  134109 */ // Label 2324: @134109
     /*  134109 */ GIM_Reject,
     /*  134110 */ // Label 2267: @134110
     /*  134110 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(134720),
     /*  134115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134125 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(134191), // Rule ID 71690 //
     /*  134130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134172 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134189 */     GIR_RootConstrainSelectedInstOperands,
     /*  134190 */     // GIR_Coverage, 71690,
     /*  134190 */     GIR_EraseRootFromParent_Done,
     /*  134191 */   // Label 2354: @134191
     /*  134191 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(134257), // Rule ID 71691 //
     /*  134196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134238 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134255 */     GIR_RootConstrainSelectedInstOperands,
     /*  134256 */     // GIR_Coverage, 71691,
     /*  134256 */     GIR_EraseRootFromParent_Done,
     /*  134257 */   // Label 2355: @134257
     /*  134257 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(134323), // Rule ID 71688 //
     /*  134262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134304 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134321 */     GIR_RootConstrainSelectedInstOperands,
     /*  134322 */     // GIR_Coverage, 71688,
     /*  134322 */     GIR_EraseRootFromParent_Done,
     /*  134323 */   // Label 2356: @134323
     /*  134323 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(134389), // Rule ID 71689 //
     /*  134328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134370 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134387 */     GIR_RootConstrainSelectedInstOperands,
     /*  134388 */     // GIR_Coverage, 71689,
     /*  134388 */     GIR_EraseRootFromParent_Done,
     /*  134389 */   // Label 2357: @134389
     /*  134389 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(134455), // Rule ID 71686 //
     /*  134394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134436 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134453 */     GIR_RootConstrainSelectedInstOperands,
     /*  134454 */     // GIR_Coverage, 71686,
     /*  134454 */     GIR_EraseRootFromParent_Done,
     /*  134455 */   // Label 2358: @134455
     /*  134455 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(134521), // Rule ID 71687 //
     /*  134460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134491 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134495 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134502 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134519 */     GIR_RootConstrainSelectedInstOperands,
     /*  134520 */     // GIR_Coverage, 71687,
     /*  134520 */     GIR_EraseRootFromParent_Done,
     /*  134521 */   // Label 2359: @134521
     /*  134521 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(134587), // Rule ID 53172 //
     /*  134526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134568 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134585 */     GIR_RootConstrainSelectedInstOperands,
     /*  134586 */     // GIR_Coverage, 53172,
     /*  134586 */     GIR_EraseRootFromParent_Done,
     /*  134587 */   // Label 2360: @134587
     /*  134587 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(134653), // Rule ID 53173 //
     /*  134592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  134611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  134615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134634 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  134637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134651 */     GIR_RootConstrainSelectedInstOperands,
     /*  134652 */     // GIR_Coverage, 53173,
     /*  134652 */     GIR_EraseRootFromParent_Done,
     /*  134653 */   // Label 2361: @134653
     /*  134653 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(134686), // Rule ID 53160 //
     /*  134658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134669 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  134672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134684 */     GIR_RootConstrainSelectedInstOperands,
     /*  134685 */     // GIR_Coverage, 53160,
     /*  134685 */     GIR_EraseRootFromParent_Done,
     /*  134686 */   // Label 2362: @134686
     /*  134686 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(134719), // Rule ID 53161 //
     /*  134691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134702 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  134705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134717 */     GIR_RootConstrainSelectedInstOperands,
     /*  134718 */     // GIR_Coverage, 53161,
     /*  134718 */     GIR_EraseRootFromParent_Done,
     /*  134719 */   // Label 2363: @134719
     /*  134719 */   GIM_Reject,
     /*  134720 */ // Label 2353: @134720
     /*  134720 */ GIM_Reject,
     /*  134721 */ // Label 2268: @134721
     /*  134721 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(134835),
     /*  134726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  134729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  134732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134744 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(134789), // Rule ID 47782 //
     /*  134749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134752 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  134752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  134755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  134769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134787 */     GIR_RootConstrainSelectedInstOperands,
     /*  134788 */     // GIR_Coverage, 47782,
     /*  134788 */     GIR_EraseRootFromParent_Done,
     /*  134789 */   // Label 2365: @134789
     /*  134789 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(134834), // Rule ID 47783 //
     /*  134794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134797 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  134797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  134800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  134814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134832 */     GIR_RootConstrainSelectedInstOperands,
     /*  134833 */     // GIR_Coverage, 47783,
     /*  134833 */     GIR_EraseRootFromParent_Done,
     /*  134834 */   // Label 2366: @134834
     /*  134834 */   GIM_Reject,
     /*  134835 */ // Label 2364: @134835
     /*  134835 */ GIM_Reject,
     /*  134836 */ // Label 2269: @134836
     /*  134836 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(134950),
     /*  134841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  134844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  134847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134859 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(134904), // Rule ID 47794 //
     /*  134864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134867 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  134867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  134870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  134884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134902 */     GIR_RootConstrainSelectedInstOperands,
     /*  134903 */     // GIR_Coverage, 47794,
     /*  134903 */     GIR_EraseRootFromParent_Done,
     /*  134904 */   // Label 2368: @134904
     /*  134904 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(134949), // Rule ID 47795 //
     /*  134909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134912 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  134912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  134915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  134929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134947 */     GIR_RootConstrainSelectedInstOperands,
     /*  134948 */     // GIR_Coverage, 47795,
     /*  134948 */     GIR_EraseRootFromParent_Done,
     /*  134949 */   // Label 2369: @134949
     /*  134949 */   GIM_Reject,
     /*  134950 */ // Label 2367: @134950
     /*  134950 */ GIM_Reject,
     /*  134951 */ // Label 2270: @134951
     /*  134951 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(135065),
     /*  134956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  134959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  134962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134974 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(135019), // Rule ID 47802 //
     /*  134979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134982 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  134982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  134985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  134999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135017 */     GIR_RootConstrainSelectedInstOperands,
     /*  135018 */     // GIR_Coverage, 47802,
     /*  135018 */     GIR_EraseRootFromParent_Done,
     /*  135019 */   // Label 2371: @135019
     /*  135019 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(135064), // Rule ID 47803 //
     /*  135024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135027 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  135027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  135030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  135059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135062 */     GIR_RootConstrainSelectedInstOperands,
     /*  135063 */     // GIR_Coverage, 47803,
     /*  135063 */     GIR_EraseRootFromParent_Done,
     /*  135064 */   // Label 2372: @135064
     /*  135064 */   GIM_Reject,
     /*  135065 */ // Label 2370: @135065
     /*  135065 */ GIM_Reject,
     /*  135066 */ // Label 2271: @135066
     /*  135066 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(135180),
     /*  135071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  135074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  135077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135089 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(135134), // Rule ID 47818 //
     /*  135094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  135097 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  135097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  135100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135132 */     GIR_RootConstrainSelectedInstOperands,
     /*  135133 */     // GIR_Coverage, 47818,
     /*  135133 */     GIR_EraseRootFromParent_Done,
     /*  135134 */   // Label 2374: @135134
     /*  135134 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(135179), // Rule ID 47819 //
     /*  135139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  135142 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  135142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  135145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  135159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  135174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135177 */     GIR_RootConstrainSelectedInstOperands,
     /*  135178 */     // GIR_Coverage, 47819,
     /*  135178 */     GIR_EraseRootFromParent_Done,
     /*  135179 */   // Label 2375: @135179
     /*  135179 */   GIM_Reject,
     /*  135180 */ // Label 2373: @135180
     /*  135180 */ GIM_Reject,
     /*  135181 */ // Label 2272: @135181
     /*  135181 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(135791),
     /*  135186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135196 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(135262), // Rule ID 71718 //
     /*  135201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135243 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135260 */     GIR_RootConstrainSelectedInstOperands,
     /*  135261 */     // GIR_Coverage, 71718,
     /*  135261 */     GIR_EraseRootFromParent_Done,
     /*  135262 */   // Label 2377: @135262
     /*  135262 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(135328), // Rule ID 71719 //
     /*  135267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135309 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135326 */     GIR_RootConstrainSelectedInstOperands,
     /*  135327 */     // GIR_Coverage, 71719,
     /*  135327 */     GIR_EraseRootFromParent_Done,
     /*  135328 */   // Label 2378: @135328
     /*  135328 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(135394), // Rule ID 71716 //
     /*  135333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135375 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135392 */     GIR_RootConstrainSelectedInstOperands,
     /*  135393 */     // GIR_Coverage, 71716,
     /*  135393 */     GIR_EraseRootFromParent_Done,
     /*  135394 */   // Label 2379: @135394
     /*  135394 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(135460), // Rule ID 71717 //
     /*  135399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135441 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135458 */     GIR_RootConstrainSelectedInstOperands,
     /*  135459 */     // GIR_Coverage, 71717,
     /*  135459 */     GIR_EraseRootFromParent_Done,
     /*  135460 */   // Label 2380: @135460
     /*  135460 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(135526), // Rule ID 71714 //
     /*  135465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135507 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135524 */     GIR_RootConstrainSelectedInstOperands,
     /*  135525 */     // GIR_Coverage, 71714,
     /*  135525 */     GIR_EraseRootFromParent_Done,
     /*  135526 */   // Label 2381: @135526
     /*  135526 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(135592), // Rule ID 71715 //
     /*  135531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135571 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135573 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135590 */     GIR_RootConstrainSelectedInstOperands,
     /*  135591 */     // GIR_Coverage, 71715,
     /*  135591 */     GIR_EraseRootFromParent_Done,
     /*  135592 */   // Label 2382: @135592
     /*  135592 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(135658), // Rule ID 53190 //
     /*  135597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135639 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135656 */     GIR_RootConstrainSelectedInstOperands,
     /*  135657 */     // GIR_Coverage, 53190,
     /*  135657 */     GIR_EraseRootFromParent_Done,
     /*  135658 */   // Label 2383: @135658
     /*  135658 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(135724), // Rule ID 53191 //
     /*  135663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  135682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  135686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135705 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  135708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135722 */     GIR_RootConstrainSelectedInstOperands,
     /*  135723 */     // GIR_Coverage, 53191,
     /*  135723 */     GIR_EraseRootFromParent_Done,
     /*  135724 */   // Label 2384: @135724
     /*  135724 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(135757), // Rule ID 53178 //
     /*  135729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135740 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  135743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135755 */     GIR_RootConstrainSelectedInstOperands,
     /*  135756 */     // GIR_Coverage, 53178,
     /*  135756 */     GIR_EraseRootFromParent_Done,
     /*  135757 */   // Label 2385: @135757
     /*  135757 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(135790), // Rule ID 53179 //
     /*  135762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135773 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  135776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135788 */     GIR_RootConstrainSelectedInstOperands,
     /*  135789 */     // GIR_Coverage, 53179,
     /*  135789 */     GIR_EraseRootFromParent_Done,
     /*  135790 */   // Label 2386: @135790
     /*  135790 */   GIM_Reject,
     /*  135791 */ // Label 2376: @135791
     /*  135791 */ GIM_Reject,
     /*  135792 */ // Label 2273: @135792
     /*  135792 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(135906),
     /*  135797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  135800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  135803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135815 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(135860), // Rule ID 47786 //
     /*  135820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135823 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  135823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  135826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135858 */     GIR_RootConstrainSelectedInstOperands,
     /*  135859 */     // GIR_Coverage, 47786,
     /*  135859 */     GIR_EraseRootFromParent_Done,
     /*  135860 */   // Label 2388: @135860
     /*  135860 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(135905), // Rule ID 47787 //
     /*  135865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135868 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  135868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  135871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  135885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135903 */     GIR_RootConstrainSelectedInstOperands,
     /*  135904 */     // GIR_Coverage, 47787,
     /*  135904 */     GIR_EraseRootFromParent_Done,
     /*  135905 */   // Label 2389: @135905
     /*  135905 */   GIM_Reject,
     /*  135906 */ // Label 2387: @135906
     /*  135906 */ GIM_Reject,
     /*  135907 */ // Label 2274: @135907
     /*  135907 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(136021),
     /*  135912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  135915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  135918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135930 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(135975), // Rule ID 47798 //
     /*  135935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135938 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  135938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  135941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  135955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135973 */     GIR_RootConstrainSelectedInstOperands,
     /*  135974 */     // GIR_Coverage, 47798,
     /*  135974 */     GIR_EraseRootFromParent_Done,
     /*  135975 */   // Label 2391: @135975
     /*  135975 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(136020), // Rule ID 47799 //
     /*  135980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135983 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  135983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  135986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  136015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136018 */     GIR_RootConstrainSelectedInstOperands,
     /*  136019 */     // GIR_Coverage, 47799,
     /*  136019 */     GIR_EraseRootFromParent_Done,
     /*  136020 */   // Label 2392: @136020
     /*  136020 */   GIM_Reject,
     /*  136021 */ // Label 2390: @136021
     /*  136021 */ GIM_Reject,
     /*  136022 */ // Label 2275: @136022
     /*  136022 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(136136),
     /*  136027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  136030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  136033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136045 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(136090), // Rule ID 47814 //
     /*  136050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136053 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  136053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  136056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136088 */     GIR_RootConstrainSelectedInstOperands,
     /*  136089 */     // GIR_Coverage, 47814,
     /*  136089 */     GIR_EraseRootFromParent_Done,
     /*  136090 */   // Label 2394: @136090
     /*  136090 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(136135), // Rule ID 47815 //
     /*  136095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136098 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  136098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  136101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  136115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  136130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136133 */     GIR_RootConstrainSelectedInstOperands,
     /*  136134 */     // GIR_Coverage, 47815,
     /*  136134 */     GIR_EraseRootFromParent_Done,
     /*  136135 */   // Label 2395: @136135
     /*  136135 */   GIM_Reject,
     /*  136136 */ // Label 2393: @136136
     /*  136136 */ GIM_Reject,
     /*  136137 */ // Label 2276: @136137
     /*  136137 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(136251),
     /*  136142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  136145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  136148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  136160 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(136205), // Rule ID 47858 //
     /*  136165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  136168 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  136168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  136171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136203 */     GIR_RootConstrainSelectedInstOperands,
     /*  136204 */     // GIR_Coverage, 47858,
     /*  136204 */     GIR_EraseRootFromParent_Done,
     /*  136205 */   // Label 2397: @136205
     /*  136205 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(136250), // Rule ID 47859 //
     /*  136210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  136213 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  136213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  136216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  136230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  136245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136248 */     GIR_RootConstrainSelectedInstOperands,
     /*  136249 */     // GIR_Coverage, 47859,
     /*  136249 */     GIR_EraseRootFromParent_Done,
     /*  136250 */   // Label 2398: @136250
     /*  136250 */   GIM_Reject,
     /*  136251 */ // Label 2396: @136251
     /*  136251 */ GIM_Reject,
     /*  136252 */ // Label 2277: @136252
     /*  136252 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(136862),
     /*  136257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136267 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(136333), // Rule ID 71746 //
     /*  136272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136314 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136331 */     GIR_RootConstrainSelectedInstOperands,
     /*  136332 */     // GIR_Coverage, 71746,
     /*  136332 */     GIR_EraseRootFromParent_Done,
     /*  136333 */   // Label 2400: @136333
     /*  136333 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(136399), // Rule ID 71747 //
     /*  136338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136378 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136380 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136397 */     GIR_RootConstrainSelectedInstOperands,
     /*  136398 */     // GIR_Coverage, 71747,
     /*  136398 */     GIR_EraseRootFromParent_Done,
     /*  136399 */   // Label 2401: @136399
     /*  136399 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(136465), // Rule ID 71744 //
     /*  136404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136446 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136463 */     GIR_RootConstrainSelectedInstOperands,
     /*  136464 */     // GIR_Coverage, 71744,
     /*  136464 */     GIR_EraseRootFromParent_Done,
     /*  136465 */   // Label 2402: @136465
     /*  136465 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(136531), // Rule ID 71745 //
     /*  136470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136512 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136529 */     GIR_RootConstrainSelectedInstOperands,
     /*  136530 */     // GIR_Coverage, 71745,
     /*  136530 */     GIR_EraseRootFromParent_Done,
     /*  136531 */   // Label 2403: @136531
     /*  136531 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(136597), // Rule ID 71742 //
     /*  136536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136578 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136595 */     GIR_RootConstrainSelectedInstOperands,
     /*  136596 */     // GIR_Coverage, 71742,
     /*  136596 */     GIR_EraseRootFromParent_Done,
     /*  136597 */   // Label 2404: @136597
     /*  136597 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(136663), // Rule ID 71743 //
     /*  136602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  136629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136633 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136644 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136661 */     GIR_RootConstrainSelectedInstOperands,
     /*  136662 */     // GIR_Coverage, 71743,
     /*  136662 */     GIR_EraseRootFromParent_Done,
     /*  136663 */   // Label 2405: @136663
     /*  136663 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(136729), // Rule ID 53208 //
     /*  136668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136710 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136727 */     GIR_RootConstrainSelectedInstOperands,
     /*  136728 */     // GIR_Coverage, 53208,
     /*  136728 */     GIR_EraseRootFromParent_Done,
     /*  136729 */   // Label 2406: @136729
     /*  136729 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(136795), // Rule ID 53209 //
     /*  136734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  136753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  136757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136776 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  136779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136793 */     GIR_RootConstrainSelectedInstOperands,
     /*  136794 */     // GIR_Coverage, 53209,
     /*  136794 */     GIR_EraseRootFromParent_Done,
     /*  136795 */   // Label 2407: @136795
     /*  136795 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(136828), // Rule ID 53196 //
     /*  136800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136811 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  136814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136826 */     GIR_RootConstrainSelectedInstOperands,
     /*  136827 */     // GIR_Coverage, 53196,
     /*  136827 */     GIR_EraseRootFromParent_Done,
     /*  136828 */   // Label 2408: @136828
     /*  136828 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(136861), // Rule ID 53197 //
     /*  136833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136844 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  136847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136859 */     GIR_RootConstrainSelectedInstOperands,
     /*  136860 */     // GIR_Coverage, 53197,
     /*  136860 */     GIR_EraseRootFromParent_Done,
     /*  136861 */   // Label 2409: @136861
     /*  136861 */   GIM_Reject,
     /*  136862 */ // Label 2399: @136862
     /*  136862 */ GIM_Reject,
     /*  136863 */ // Label 2278: @136863
     /*  136863 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(136977),
     /*  136868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  136871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  136874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136886 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(136931), // Rule ID 47790 //
     /*  136891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136894 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  136894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  136897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136929 */     GIR_RootConstrainSelectedInstOperands,
     /*  136930 */     // GIR_Coverage, 47790,
     /*  136930 */     GIR_EraseRootFromParent_Done,
     /*  136931 */   // Label 2411: @136931
     /*  136931 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(136976), // Rule ID 47791 //
     /*  136936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136939 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  136939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  136942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  136956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136974 */     GIR_RootConstrainSelectedInstOperands,
     /*  136975 */     // GIR_Coverage, 47791,
     /*  136975 */     GIR_EraseRootFromParent_Done,
     /*  136976 */   // Label 2412: @136976
     /*  136976 */   GIM_Reject,
     /*  136977 */ // Label 2410: @136977
     /*  136977 */ GIM_Reject,
     /*  136978 */ // Label 2279: @136978
     /*  136978 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(137092),
     /*  136983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  136986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  136989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137001 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(137046), // Rule ID 47810 //
     /*  137006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137009 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  137009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  137012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137044 */     GIR_RootConstrainSelectedInstOperands,
     /*  137045 */     // GIR_Coverage, 47810,
     /*  137045 */     GIR_EraseRootFromParent_Done,
     /*  137046 */   // Label 2414: @137046
     /*  137046 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(137091), // Rule ID 47811 //
     /*  137051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137054 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  137054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  137057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  137086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137089 */     GIR_RootConstrainSelectedInstOperands,
     /*  137090 */     // GIR_Coverage, 47811,
     /*  137090 */     GIR_EraseRootFromParent_Done,
     /*  137091 */   // Label 2415: @137091
     /*  137091 */   GIM_Reject,
     /*  137092 */ // Label 2413: @137092
     /*  137092 */ GIM_Reject,
     /*  137093 */ // Label 2280: @137093
     /*  137093 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(137207),
     /*  137098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  137101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  137104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  137116 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(137161), // Rule ID 47846 //
     /*  137121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137124 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  137124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  137127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137159 */     GIR_RootConstrainSelectedInstOperands,
     /*  137160 */     // GIR_Coverage, 47846,
     /*  137160 */     GIR_EraseRootFromParent_Done,
     /*  137161 */   // Label 2417: @137161
     /*  137161 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(137206), // Rule ID 47847 //
     /*  137166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137169 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  137169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  137172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  137186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  137201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137204 */     GIR_RootConstrainSelectedInstOperands,
     /*  137205 */     // GIR_Coverage, 47847,
     /*  137205 */     GIR_EraseRootFromParent_Done,
     /*  137206 */   // Label 2418: @137206
     /*  137206 */   GIM_Reject,
     /*  137207 */ // Label 2416: @137207
     /*  137207 */ GIM_Reject,
     /*  137208 */ // Label 2281: @137208
     /*  137208 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(137322),
     /*  137213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  137216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  137219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  137231 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(137276), // Rule ID 47862 //
     /*  137236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  137239 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  137239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  137242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137274 */     GIR_RootConstrainSelectedInstOperands,
     /*  137275 */     // GIR_Coverage, 47862,
     /*  137275 */     GIR_EraseRootFromParent_Done,
     /*  137276 */   // Label 2420: @137276
     /*  137276 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(137321), // Rule ID 47863 //
     /*  137281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  137284 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  137284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  137287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  137301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  137316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137319 */     GIR_RootConstrainSelectedInstOperands,
     /*  137320 */     // GIR_Coverage, 47863,
     /*  137320 */     GIR_EraseRootFromParent_Done,
     /*  137321 */   // Label 2421: @137321
     /*  137321 */   GIM_Reject,
     /*  137322 */ // Label 2419: @137322
     /*  137322 */ GIM_Reject,
     /*  137323 */ // Label 2282: @137323
     /*  137323 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(137933),
     /*  137328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137338 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(137404), // Rule ID 71774 //
     /*  137343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137385 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137402 */     GIR_RootConstrainSelectedInstOperands,
     /*  137403 */     // GIR_Coverage, 71774,
     /*  137403 */     GIR_EraseRootFromParent_Done,
     /*  137404 */   // Label 2423: @137404
     /*  137404 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(137470), // Rule ID 71775 //
     /*  137409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137451 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137468 */     GIR_RootConstrainSelectedInstOperands,
     /*  137469 */     // GIR_Coverage, 71775,
     /*  137469 */     GIR_EraseRootFromParent_Done,
     /*  137470 */   // Label 2424: @137470
     /*  137470 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(137536), // Rule ID 71772 //
     /*  137475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137517 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137534 */     GIR_RootConstrainSelectedInstOperands,
     /*  137535 */     // GIR_Coverage, 71772,
     /*  137535 */     GIR_EraseRootFromParent_Done,
     /*  137536 */   // Label 2425: @137536
     /*  137536 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(137602), // Rule ID 71773 //
     /*  137541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137583 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137600 */     GIR_RootConstrainSelectedInstOperands,
     /*  137601 */     // GIR_Coverage, 71773,
     /*  137601 */     GIR_EraseRootFromParent_Done,
     /*  137602 */   // Label 2426: @137602
     /*  137602 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(137668), // Rule ID 71770 //
     /*  137607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137649 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137666 */     GIR_RootConstrainSelectedInstOperands,
     /*  137667 */     // GIR_Coverage, 71770,
     /*  137667 */     GIR_EraseRootFromParent_Done,
     /*  137668 */   // Label 2427: @137668
     /*  137668 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(137734), // Rule ID 71771 //
     /*  137673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137715 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137732 */     GIR_RootConstrainSelectedInstOperands,
     /*  137733 */     // GIR_Coverage, 71771,
     /*  137733 */     GIR_EraseRootFromParent_Done,
     /*  137734 */   // Label 2428: @137734
     /*  137734 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(137800), // Rule ID 53226 //
     /*  137739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137781 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137798 */     GIR_RootConstrainSelectedInstOperands,
     /*  137799 */     // GIR_Coverage, 53226,
     /*  137799 */     GIR_EraseRootFromParent_Done,
     /*  137800 */   // Label 2429: @137800
     /*  137800 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(137866), // Rule ID 53227 //
     /*  137805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  137824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  137828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137847 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  137850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137864 */     GIR_RootConstrainSelectedInstOperands,
     /*  137865 */     // GIR_Coverage, 53227,
     /*  137865 */     GIR_EraseRootFromParent_Done,
     /*  137866 */   // Label 2430: @137866
     /*  137866 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(137899), // Rule ID 53214 //
     /*  137871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137882 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  137885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137897 */     GIR_RootConstrainSelectedInstOperands,
     /*  137898 */     // GIR_Coverage, 53214,
     /*  137898 */     GIR_EraseRootFromParent_Done,
     /*  137899 */   // Label 2431: @137899
     /*  137899 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(137932), // Rule ID 53215 //
     /*  137904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137915 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  137918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137930 */     GIR_RootConstrainSelectedInstOperands,
     /*  137931 */     // GIR_Coverage, 53215,
     /*  137931 */     GIR_EraseRootFromParent_Done,
     /*  137932 */   // Label 2432: @137932
     /*  137932 */   GIM_Reject,
     /*  137933 */ // Label 2422: @137933
     /*  137933 */ GIM_Reject,
     /*  137934 */ // Label 2283: @137934
     /*  137934 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(138048),
     /*  137939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  137942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  137945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137957 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(138002), // Rule ID 47806 //
     /*  137962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137965 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  137965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  137968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  137972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  137982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  137997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138000 */     GIR_RootConstrainSelectedInstOperands,
     /*  138001 */     // GIR_Coverage, 47806,
     /*  138001 */     GIR_EraseRootFromParent_Done,
     /*  138002 */   // Label 2434: @138002
     /*  138002 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(138047), // Rule ID 47807 //
     /*  138007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138010 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  138010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  138013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  138027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138045 */     GIR_RootConstrainSelectedInstOperands,
     /*  138046 */     // GIR_Coverage, 47807,
     /*  138046 */     GIR_EraseRootFromParent_Done,
     /*  138047 */   // Label 2435: @138047
     /*  138047 */   GIM_Reject,
     /*  138048 */ // Label 2433: @138048
     /*  138048 */ GIM_Reject,
     /*  138049 */ // Label 2284: @138049
     /*  138049 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(138163),
     /*  138054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  138057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  138060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  138072 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(138117), // Rule ID 47834 //
     /*  138077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138080 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  138080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  138083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138115 */     GIR_RootConstrainSelectedInstOperands,
     /*  138116 */     // GIR_Coverage, 47834,
     /*  138116 */     GIR_EraseRootFromParent_Done,
     /*  138117 */   // Label 2437: @138117
     /*  138117 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(138162), // Rule ID 47835 //
     /*  138122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138125 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  138125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  138128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  138142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  138157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138160 */     GIR_RootConstrainSelectedInstOperands,
     /*  138161 */     // GIR_Coverage, 47835,
     /*  138161 */     GIR_EraseRootFromParent_Done,
     /*  138162 */   // Label 2438: @138162
     /*  138162 */   GIM_Reject,
     /*  138163 */ // Label 2436: @138163
     /*  138163 */ GIM_Reject,
     /*  138164 */ // Label 2285: @138164
     /*  138164 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(138278),
     /*  138169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  138172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  138175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  138187 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(138232), // Rule ID 47850 //
     /*  138192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138195 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  138195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  138198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138230 */     GIR_RootConstrainSelectedInstOperands,
     /*  138231 */     // GIR_Coverage, 47850,
     /*  138231 */     GIR_EraseRootFromParent_Done,
     /*  138232 */   // Label 2440: @138232
     /*  138232 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(138277), // Rule ID 47851 //
     /*  138237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138240 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  138240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  138243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  138257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  138272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138275 */     GIR_RootConstrainSelectedInstOperands,
     /*  138276 */     // GIR_Coverage, 47851,
     /*  138276 */     GIR_EraseRootFromParent_Done,
     /*  138277 */   // Label 2441: @138277
     /*  138277 */   GIM_Reject,
     /*  138278 */ // Label 2439: @138278
     /*  138278 */ GIM_Reject,
     /*  138279 */ // Label 2286: @138279
     /*  138279 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(138393),
     /*  138284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  138287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  138290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  138302 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(138347), // Rule ID 47866 //
     /*  138307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  138310 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  138310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  138313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138345 */     GIR_RootConstrainSelectedInstOperands,
     /*  138346 */     // GIR_Coverage, 47866,
     /*  138346 */     GIR_EraseRootFromParent_Done,
     /*  138347 */   // Label 2443: @138347
     /*  138347 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(138392), // Rule ID 47867 //
     /*  138352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  138355 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  138355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  138358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  138362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  138367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  138369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  138372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  138377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  138387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  138390 */     GIR_RootConstrainSelectedInstOperands,
     /*  138391 */     // GIR_Coverage, 47867,
     /*  138391 */     GIR_EraseRootFromParent_Done,
     /*  138392 */   // Label 2444: @138392
     /*  138392 */   GIM_Reject,
     /*  138393 */ // Label 2442: @138393
     /*  138393 */ GIM_Reject,
     /*  138394 */ // Label 2287: @138394
     /*  138394 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(139004),
     /*  138399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138409 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(138475), // Rule ID 71802 //
     /*  138414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138456 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138473 */     GIR_RootConstrainSelectedInstOperands,
     /*  138474 */     // GIR_Coverage, 71802,
     /*  138474 */     GIR_EraseRootFromParent_Done,
     /*  138475 */   // Label 2446: @138475
     /*  138475 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(138541), // Rule ID 71803 //
     /*  138480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138522 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138539 */     GIR_RootConstrainSelectedInstOperands,
     /*  138540 */     // GIR_Coverage, 71803,
     /*  138540 */     GIR_EraseRootFromParent_Done,
     /*  138541 */   // Label 2447: @138541
     /*  138541 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(138607), // Rule ID 71800 //
     /*  138546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138588 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138605 */     GIR_RootConstrainSelectedInstOperands,
     /*  138606 */     // GIR_Coverage, 71800,
     /*  138606 */     GIR_EraseRootFromParent_Done,
     /*  138607 */   // Label 2448: @138607
     /*  138607 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(138673), // Rule ID 71801 //
     /*  138612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138654 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  138661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138671 */     GIR_RootConstrainSelectedInstOperands,
     /*  138672 */     // GIR_Coverage, 71801,
     /*  138672 */     GIR_EraseRootFromParent_Done,
     /*  138673 */   // Label 2449: @138673
     /*  138673 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(138739), // Rule ID 71798 //
     /*  138678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138720 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138737 */     GIR_RootConstrainSelectedInstOperands,
     /*  138738 */     // GIR_Coverage, 71798,
     /*  138738 */     GIR_EraseRootFromParent_Done,
     /*  138739 */   // Label 2450: @138739
     /*  138739 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(138805), // Rule ID 71799 //
     /*  138744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138786 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138803 */     GIR_RootConstrainSelectedInstOperands,
     /*  138804 */     // GIR_Coverage, 71799,
     /*  138804 */     GIR_EraseRootFromParent_Done,
     /*  138805 */   // Label 2451: @138805
     /*  138805 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(138871), // Rule ID 53244 //
     /*  138810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138852 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138869 */     GIR_RootConstrainSelectedInstOperands,
     /*  138870 */     // GIR_Coverage, 53244,
     /*  138870 */     GIR_EraseRootFromParent_Done,
     /*  138871 */   // Label 2452: @138871
     /*  138871 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(138937), // Rule ID 53245 //
     /*  138876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  138895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  138899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138918 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  138921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  138929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138935 */     GIR_RootConstrainSelectedInstOperands,
     /*  138936 */     // GIR_Coverage, 53245,
     /*  138936 */     GIR_EraseRootFromParent_Done,
     /*  138937 */   // Label 2453: @138937
     /*  138937 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(138970), // Rule ID 53232 //
     /*  138942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138953 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  138956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138968 */     GIR_RootConstrainSelectedInstOperands,
     /*  138969 */     // GIR_Coverage, 53232,
     /*  138969 */     GIR_EraseRootFromParent_Done,
     /*  138970 */   // Label 2454: @138970
     /*  138970 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(139003), // Rule ID 53233 //
     /*  138975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138986 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  138989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139001 */     GIR_RootConstrainSelectedInstOperands,
     /*  139002 */     // GIR_Coverage, 53233,
     /*  139002 */     GIR_EraseRootFromParent_Done,
     /*  139003 */   // Label 2455: @139003
     /*  139003 */   GIM_Reject,
     /*  139004 */ // Label 2445: @139004
     /*  139004 */ GIM_Reject,
     /*  139005 */ // Label 2288: @139005
     /*  139005 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(139119),
     /*  139010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  139013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  139016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  139028 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(139073), // Rule ID 47822 //
     /*  139033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139036 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  139036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  139039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  139053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139071 */     GIR_RootConstrainSelectedInstOperands,
     /*  139072 */     // GIR_Coverage, 47822,
     /*  139072 */     GIR_EraseRootFromParent_Done,
     /*  139073 */   // Label 2457: @139073
     /*  139073 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(139118), // Rule ID 47823 //
     /*  139078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139081 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  139081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  139084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  139098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139116 */     GIR_RootConstrainSelectedInstOperands,
     /*  139117 */     // GIR_Coverage, 47823,
     /*  139117 */     GIR_EraseRootFromParent_Done,
     /*  139118 */   // Label 2458: @139118
     /*  139118 */   GIM_Reject,
     /*  139119 */ // Label 2456: @139119
     /*  139119 */ GIM_Reject,
     /*  139120 */ // Label 2289: @139120
     /*  139120 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(139234),
     /*  139125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  139128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  139131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139143 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(139188), // Rule ID 47838 //
     /*  139148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139151 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  139151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  139154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139186 */     GIR_RootConstrainSelectedInstOperands,
     /*  139187 */     // GIR_Coverage, 47838,
     /*  139187 */     GIR_EraseRootFromParent_Done,
     /*  139188 */   // Label 2460: @139188
     /*  139188 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(139233), // Rule ID 47839 //
     /*  139193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139196 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  139196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  139199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  139213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139231 */     GIR_RootConstrainSelectedInstOperands,
     /*  139232 */     // GIR_Coverage, 47839,
     /*  139232 */     GIR_EraseRootFromParent_Done,
     /*  139233 */   // Label 2461: @139233
     /*  139233 */   GIM_Reject,
     /*  139234 */ // Label 2459: @139234
     /*  139234 */ GIM_Reject,
     /*  139235 */ // Label 2290: @139235
     /*  139235 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(139349),
     /*  139240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  139243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  139246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  139258 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(139303), // Rule ID 47854 //
     /*  139263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139266 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  139266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  139269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139301 */     GIR_RootConstrainSelectedInstOperands,
     /*  139302 */     // GIR_Coverage, 47854,
     /*  139302 */     GIR_EraseRootFromParent_Done,
     /*  139303 */   // Label 2463: @139303
     /*  139303 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(139348), // Rule ID 47855 //
     /*  139308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139311 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  139311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  139314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  139328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139346 */     GIR_RootConstrainSelectedInstOperands,
     /*  139347 */     // GIR_Coverage, 47855,
     /*  139347 */     GIR_EraseRootFromParent_Done,
     /*  139348 */   // Label 2464: @139348
     /*  139348 */   GIM_Reject,
     /*  139349 */ // Label 2462: @139349
     /*  139349 */ GIM_Reject,
     /*  139350 */ // Label 2291: @139350
     /*  139350 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(139960),
     /*  139355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139365 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(139431), // Rule ID 71830 //
     /*  139370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139412 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139429 */     GIR_RootConstrainSelectedInstOperands,
     /*  139430 */     // GIR_Coverage, 71830,
     /*  139430 */     GIR_EraseRootFromParent_Done,
     /*  139431 */   // Label 2466: @139431
     /*  139431 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(139497), // Rule ID 71831 //
     /*  139436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139478 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139495 */     GIR_RootConstrainSelectedInstOperands,
     /*  139496 */     // GIR_Coverage, 71831,
     /*  139496 */     GIR_EraseRootFromParent_Done,
     /*  139497 */   // Label 2467: @139497
     /*  139497 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(139563), // Rule ID 71828 //
     /*  139502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139544 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139561 */     GIR_RootConstrainSelectedInstOperands,
     /*  139562 */     // GIR_Coverage, 71828,
     /*  139562 */     GIR_EraseRootFromParent_Done,
     /*  139563 */   // Label 2468: @139563
     /*  139563 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(139629), // Rule ID 71829 //
     /*  139568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139610 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  139617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139627 */     GIR_RootConstrainSelectedInstOperands,
     /*  139628 */     // GIR_Coverage, 71829,
     /*  139628 */     GIR_EraseRootFromParent_Done,
     /*  139629 */   // Label 2469: @139629
     /*  139629 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(139695), // Rule ID 71826 //
     /*  139634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139676 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139693 */     GIR_RootConstrainSelectedInstOperands,
     /*  139694 */     // GIR_Coverage, 71826,
     /*  139694 */     GIR_EraseRootFromParent_Done,
     /*  139695 */   // Label 2470: @139695
     /*  139695 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(139761), // Rule ID 71827 //
     /*  139700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139742 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139759 */     GIR_RootConstrainSelectedInstOperands,
     /*  139760 */     // GIR_Coverage, 71827,
     /*  139760 */     GIR_EraseRootFromParent_Done,
     /*  139761 */   // Label 2471: @139761
     /*  139761 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(139827), // Rule ID 53262 //
     /*  139766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139808 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139825 */     GIR_RootConstrainSelectedInstOperands,
     /*  139826 */     // GIR_Coverage, 53262,
     /*  139826 */     GIR_EraseRootFromParent_Done,
     /*  139827 */   // Label 2472: @139827
     /*  139827 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(139893), // Rule ID 53263 //
     /*  139832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  139843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  139851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  139855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139874 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  139877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  139885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139891 */     GIR_RootConstrainSelectedInstOperands,
     /*  139892 */     // GIR_Coverage, 53263,
     /*  139892 */     GIR_EraseRootFromParent_Done,
     /*  139893 */   // Label 2473: @139893
     /*  139893 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(139926), // Rule ID 53250 //
     /*  139898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139909 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  139912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139924 */     GIR_RootConstrainSelectedInstOperands,
     /*  139925 */     // GIR_Coverage, 53250,
     /*  139925 */     GIR_EraseRootFromParent_Done,
     /*  139926 */   // Label 2474: @139926
     /*  139926 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(139959), // Rule ID 53251 //
     /*  139931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139942 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  139945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139957 */     GIR_RootConstrainSelectedInstOperands,
     /*  139958 */     // GIR_Coverage, 53251,
     /*  139958 */     GIR_EraseRootFromParent_Done,
     /*  139959 */   // Label 2475: @139959
     /*  139959 */   GIM_Reject,
     /*  139960 */ // Label 2465: @139960
     /*  139960 */ GIM_Reject,
     /*  139961 */ // Label 2292: @139961
     /*  139961 */ GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(140075),
     /*  139966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  139969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  139972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  139984 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(140029), // Rule ID 47826 //
     /*  139989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139992 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  139992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  139995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  140009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140027 */     GIR_RootConstrainSelectedInstOperands,
     /*  140028 */     // GIR_Coverage, 47826,
     /*  140028 */     GIR_EraseRootFromParent_Done,
     /*  140029 */   // Label 2477: @140029
     /*  140029 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(140074), // Rule ID 47827 //
     /*  140034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140037 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  140037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  140040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  140054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140072 */     GIR_RootConstrainSelectedInstOperands,
     /*  140073 */     // GIR_Coverage, 47827,
     /*  140073 */     GIR_EraseRootFromParent_Done,
     /*  140074 */   // Label 2478: @140074
     /*  140074 */   GIM_Reject,
     /*  140075 */ // Label 2476: @140075
     /*  140075 */ GIM_Reject,
     /*  140076 */ // Label 2293: @140076
     /*  140076 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(140190),
     /*  140081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  140084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  140087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140099 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(140144), // Rule ID 47842 //
     /*  140104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140107 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  140107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  140110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140142 */     GIR_RootConstrainSelectedInstOperands,
     /*  140143 */     // GIR_Coverage, 47842,
     /*  140143 */     GIR_EraseRootFromParent_Done,
     /*  140144 */   // Label 2480: @140144
     /*  140144 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(140189), // Rule ID 47843 //
     /*  140149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140152 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  140152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  140155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  140184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140187 */     GIR_RootConstrainSelectedInstOperands,
     /*  140188 */     // GIR_Coverage, 47843,
     /*  140188 */     GIR_EraseRootFromParent_Done,
     /*  140189 */   // Label 2481: @140189
     /*  140189 */   GIM_Reject,
     /*  140190 */ // Label 2479: @140190
     /*  140190 */ GIM_Reject,
     /*  140191 */ // Label 2294: @140191
     /*  140191 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(140801),
     /*  140196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140206 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(140272), // Rule ID 71858 //
     /*  140211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140253 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140270 */     GIR_RootConstrainSelectedInstOperands,
     /*  140271 */     // GIR_Coverage, 71858,
     /*  140271 */     GIR_EraseRootFromParent_Done,
     /*  140272 */   // Label 2483: @140272
     /*  140272 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(140338), // Rule ID 71859 //
     /*  140277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140319 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140336 */     GIR_RootConstrainSelectedInstOperands,
     /*  140337 */     // GIR_Coverage, 71859,
     /*  140337 */     GIR_EraseRootFromParent_Done,
     /*  140338 */   // Label 2484: @140338
     /*  140338 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(140404), // Rule ID 71856 //
     /*  140343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140385 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140402 */     GIR_RootConstrainSelectedInstOperands,
     /*  140403 */     // GIR_Coverage, 71856,
     /*  140403 */     GIR_EraseRootFromParent_Done,
     /*  140404 */   // Label 2485: @140404
     /*  140404 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(140470), // Rule ID 71857 //
     /*  140409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140451 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  140458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140468 */     GIR_RootConstrainSelectedInstOperands,
     /*  140469 */     // GIR_Coverage, 71857,
     /*  140469 */     GIR_EraseRootFromParent_Done,
     /*  140470 */   // Label 2486: @140470
     /*  140470 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(140536), // Rule ID 71854 //
     /*  140475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140517 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140534 */     GIR_RootConstrainSelectedInstOperands,
     /*  140535 */     // GIR_Coverage, 71854,
     /*  140535 */     GIR_EraseRootFromParent_Done,
     /*  140536 */   // Label 2487: @140536
     /*  140536 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(140602), // Rule ID 71855 //
     /*  140541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140583 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140600 */     GIR_RootConstrainSelectedInstOperands,
     /*  140601 */     // GIR_Coverage, 71855,
     /*  140601 */     GIR_EraseRootFromParent_Done,
     /*  140602 */   // Label 2488: @140602
     /*  140602 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(140668), // Rule ID 53280 //
     /*  140607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140649 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140666 */     GIR_RootConstrainSelectedInstOperands,
     /*  140667 */     // GIR_Coverage, 53280,
     /*  140667 */     GIR_EraseRootFromParent_Done,
     /*  140668 */   // Label 2489: @140668
     /*  140668 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(140734), // Rule ID 53281 //
     /*  140673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  140692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  140696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140715 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  140718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  140726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140732 */     GIR_RootConstrainSelectedInstOperands,
     /*  140733 */     // GIR_Coverage, 53281,
     /*  140733 */     GIR_EraseRootFromParent_Done,
     /*  140734 */   // Label 2490: @140734
     /*  140734 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(140767), // Rule ID 53268 //
     /*  140739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140750 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  140753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140765 */     GIR_RootConstrainSelectedInstOperands,
     /*  140766 */     // GIR_Coverage, 53268,
     /*  140766 */     GIR_EraseRootFromParent_Done,
     /*  140767 */   // Label 2491: @140767
     /*  140767 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(140800), // Rule ID 53269 //
     /*  140772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140783 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  140786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140798 */     GIR_RootConstrainSelectedInstOperands,
     /*  140799 */     // GIR_Coverage, 53269,
     /*  140799 */     GIR_EraseRootFromParent_Done,
     /*  140800 */   // Label 2492: @140800
     /*  140800 */   GIM_Reject,
     /*  140801 */ // Label 2482: @140801
     /*  140801 */ GIM_Reject,
     /*  140802 */ // Label 2295: @140802
     /*  140802 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(140916),
     /*  140807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  140810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  140813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  140825 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(140870), // Rule ID 47830 //
     /*  140830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140833 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  140833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  140836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140868 */     GIR_RootConstrainSelectedInstOperands,
     /*  140869 */     // GIR_Coverage, 47830,
     /*  140869 */     GIR_EraseRootFromParent_Done,
     /*  140870 */   // Label 2494: @140870
     /*  140870 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(140915), // Rule ID 47831 //
     /*  140875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140878 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  140878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  140881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  140885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  140890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  140892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  140895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  140900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  140902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  140913 */     GIR_RootConstrainSelectedInstOperands,
     /*  140914 */     // GIR_Coverage, 47831,
     /*  140914 */     GIR_EraseRootFromParent_Done,
     /*  140915 */   // Label 2495: @140915
     /*  140915 */   GIM_Reject,
     /*  140916 */ // Label 2493: @140916
     /*  140916 */ GIM_Reject,
     /*  140917 */ // Label 2296: @140917
     /*  140917 */ GIM_Reject,
     /*  140918 */ // Label 9: @140918
     /*  140918 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2527*/ GIMT_Encode4(155824),
     /*  140929 */ /*GILLT_s32*//*Label 2496*/ GIMT_Encode4(141053),
     /*  140933 */ /*GILLT_s64*//*Label 2497*/ GIMT_Encode4(141591),
     /*  140937 */ /*GILLT_nxv1s1*//*Label 2498*/ GIMT_Encode4(142017),
     /*  140941 */ /*GILLT_nxv1s8*//*Label 2499*/ GIMT_Encode4(143628),
     /*  140945 */ /*GILLT_nxv1s16*//*Label 2500*/ GIMT_Encode4(143743),
     /*  140949 */ /*GILLT_nxv1s32*//*Label 2501*/ GIMT_Encode4(143858),
     /*  140953 */ /*GILLT_nxv1s64*//*Label 2502*/ GIMT_Encode4(143973),
     /*  140957 */ /*GILLT_nxv2s1*//*Label 2503*/ GIMT_Encode4(144088),
     /*  140961 */ /*GILLT_nxv2s8*//*Label 2504*/ GIMT_Encode4(145699),
     /*  140965 */ /*GILLT_nxv2s16*//*Label 2505*/ GIMT_Encode4(145814),
     /*  140969 */ /*GILLT_nxv2s32*//*Label 2506*/ GIMT_Encode4(145929),
     /*  140973 */ /*GILLT_nxv2s64*//*Label 2507*/ GIMT_Encode4(146044),
     /*  140977 */ /*GILLT_nxv4s1*//*Label 2508*/ GIMT_Encode4(146159),
     /*  140981 */ /*GILLT_nxv4s8*//*Label 2509*/ GIMT_Encode4(147770),
     /*  140985 */ /*GILLT_nxv4s16*//*Label 2510*/ GIMT_Encode4(147885),
     /*  140989 */ /*GILLT_nxv4s32*//*Label 2511*/ GIMT_Encode4(148000),
     /*  140993 */ /*GILLT_nxv4s64*//*Label 2512*/ GIMT_Encode4(148115),
     /*  140997 */ /*GILLT_nxv8s1*//*Label 2513*/ GIMT_Encode4(148230),
     /*  141001 */ /*GILLT_nxv8s8*//*Label 2514*/ GIMT_Encode4(149841),
     /*  141005 */ /*GILLT_nxv8s16*//*Label 2515*/ GIMT_Encode4(149956),
     /*  141009 */ /*GILLT_nxv8s32*//*Label 2516*/ GIMT_Encode4(150071),
     /*  141013 */ /*GILLT_nxv8s64*//*Label 2517*/ GIMT_Encode4(150186),
     /*  141017 */ /*GILLT_nxv16s1*//*Label 2518*/ GIMT_Encode4(150301),
     /*  141021 */ /*GILLT_nxv16s8*//*Label 2519*/ GIMT_Encode4(151912),
     /*  141025 */ /*GILLT_nxv16s16*//*Label 2520*/ GIMT_Encode4(152027),
     /*  141029 */ /*GILLT_nxv16s32*//*Label 2521*/ GIMT_Encode4(152142),
     /*  141033 */ /*GILLT_nxv32s1*//*Label 2522*/ GIMT_Encode4(152257),
     /*  141037 */ /*GILLT_nxv32s8*//*Label 2523*/ GIMT_Encode4(153868),
     /*  141041 */ /*GILLT_nxv32s16*//*Label 2524*/ GIMT_Encode4(153983),
     /*  141045 */ /*GILLT_nxv64s1*//*Label 2525*/ GIMT_Encode4(154098),
     /*  141049 */ /*GILLT_nxv64s8*//*Label 2526*/ GIMT_Encode4(155709),
     /*  141053 */ // Label 2496: @141053
     /*  141053 */ GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(141590),
     /*  141058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  141061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  141064 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(141147), // Rule ID 2479 //
     /*  141069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141092 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  141096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141109 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] })  =>  (ADDI:{ *:[i32] } (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })
     /*  141109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  141112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  141116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141121 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  141127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  141137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141145 */     GIR_RootConstrainSelectedInstOperands,
     /*  141146 */     // GIR_Coverage, 2479,
     /*  141146 */     GIR_EraseRootFromParent_Done,
     /*  141147 */   // Label 2529: @141147
     /*  141147 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(141206), // Rule ID 2473 //
     /*  141152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141175 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141192 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141204 */     GIR_RootConstrainSelectedInstOperands,
     /*  141205 */     // GIR_Coverage, 2473,
     /*  141205 */     GIR_EraseRootFromParent_Done,
     /*  141206 */   // Label 2530: @141206
     /*  141206 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(141265), // Rule ID 65479 //
     /*  141211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  141214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141238 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141251 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141263 */     GIR_RootConstrainSelectedInstOperands,
     /*  141264 */     // GIR_Coverage, 65479,
     /*  141264 */     GIR_EraseRootFromParent_Done,
     /*  141265 */   // Label 2531: @141265
     /*  141265 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(141321), // Rule ID 65465 //
     /*  141270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141298 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141308 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs2)  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141319 */     GIR_RootConstrainSelectedInstOperands,
     /*  141320 */     // GIR_Coverage, 65465,
     /*  141320 */     GIR_EraseRootFromParent_Done,
     /*  141321 */   // Label 2532: @141321
     /*  141321 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(141380), // Rule ID 65463 //
     /*  141326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141365 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141378 */     GIR_RootConstrainSelectedInstOperands,
     /*  141379 */     // GIR_Coverage, 65463,
     /*  141379 */     GIR_EraseRootFromParent_Done,
     /*  141380 */   // Label 2533: @141380
     /*  141380 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(141436), // Rule ID 2447 //
     /*  141385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  141388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  141408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  141412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141423 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  141434 */     GIR_RootConstrainSelectedInstOperands,
     /*  141435 */     // GIR_Coverage, 2447,
     /*  141435 */     GIR_EraseRootFromParent_Done,
     /*  141436 */   // Label 2534: @141436
     /*  141436 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(141478), // Rule ID 95 //
     /*  141441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  141444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  141464 */     // MIs[1] Operand 1
     /*  141464 */     // No operand predicates
     /*  141464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141466 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  141466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  141469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141476 */     GIR_RootConstrainSelectedInstOperands,
     /*  141477 */     // GIR_Coverage, 95,
     /*  141477 */     GIR_EraseRootFromParent_Done,
     /*  141478 */   // Label 2535: @141478
     /*  141478 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(141520), // Rule ID 64527 //
     /*  141483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141502 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  141506 */     // MIs[1] Operand 1
     /*  141506 */     // No operand predicates
     /*  141506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141508 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_XORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  141508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORAI),
     /*  141511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  141513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141518 */     GIR_RootConstrainSelectedInstOperands,
     /*  141519 */     // GIR_Coverage, 64527,
     /*  141519 */     GIR_EraseRootFromParent_Done,
     /*  141520 */   // Label 2536: @141520
     /*  141520 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(141562), // Rule ID 64531 //
     /*  141525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  141528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  141536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  141548 */     // MIs[1] Operand 1
     /*  141548 */     // No operand predicates
     /*  141548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141550 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_XORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  141550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORI),
     /*  141553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141560 */     GIR_RootConstrainSelectedInstOperands,
     /*  141561 */     // GIR_Coverage, 64531,
     /*  141561 */     GIR_EraseRootFromParent_Done,
     /*  141562 */   // Label 2537: @141562
     /*  141562 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(141589), // Rule ID 93 //
     /*  141567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  141570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141582 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  141582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  141587 */     GIR_RootConstrainSelectedInstOperands,
     /*  141588 */     // GIR_Coverage, 93,
     /*  141588 */     GIR_Done,
     /*  141589 */   // Label 2538: @141589
     /*  141589 */   GIM_Reject,
     /*  141590 */ // Label 2528: @141590
     /*  141590 */ GIM_Reject,
     /*  141591 */ // Label 2497: @141591
     /*  141591 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(142016),
     /*  141596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  141599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  141602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141606 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(141685), // Rule ID 2478 //
     /*  141611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141630 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  141634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141640 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141647 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } -1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] })  =>  (ADDI:{ *:[i64] } (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })
     /*  141647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  141650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  141654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141659 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  141665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  141675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141683 */     GIR_RootConstrainSelectedInstOperands,
     /*  141684 */     // GIR_Coverage, 2478,
     /*  141684 */     GIR_EraseRootFromParent_Done,
     /*  141685 */   // Label 2540: @141685
     /*  141685 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(141740), // Rule ID 2472 //
     /*  141690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141709 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141726 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  141733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141738 */     GIR_RootConstrainSelectedInstOperands,
     /*  141739 */     // GIR_Coverage, 2472,
     /*  141739 */     GIR_EraseRootFromParent_Done,
     /*  141740 */   // Label 2541: @141740
     /*  141740 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(141795), // Rule ID 65478 //
     /*  141745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  141748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  141760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  141772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  141781 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  141784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  141793 */     GIR_RootConstrainSelectedInstOperands,
     /*  141794 */     // GIR_Coverage, 65478,
     /*  141794 */     GIR_EraseRootFromParent_Done,
     /*  141795 */   // Label 2542: @141795
     /*  141795 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(141847), // Rule ID 65464 //
     /*  141800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141824 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141834 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141845 */     GIR_RootConstrainSelectedInstOperands,
     /*  141846 */     // GIR_Coverage, 65464,
     /*  141846 */     GIR_EraseRootFromParent_Done,
     /*  141847 */   // Label 2543: @141847
     /*  141847 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(141902), // Rule ID 65462 //
     /*  141852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  141885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141887 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141900 */     GIR_RootConstrainSelectedInstOperands,
     /*  141901 */     // GIR_Coverage, 65462,
     /*  141901 */     GIR_EraseRootFromParent_Done,
     /*  141902 */   // Label 2544: @141902
     /*  141902 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(141954), // Rule ID 2446 //
     /*  141907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  141910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  141926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  141930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141935 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  141939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141941 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  141941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  141944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  141952 */     GIR_RootConstrainSelectedInstOperands,
     /*  141953 */     // GIR_Coverage, 2446,
     /*  141953 */     GIR_EraseRootFromParent_Done,
     /*  141954 */   // Label 2545: @141954
     /*  141954 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(141992), // Rule ID 94 //
     /*  141959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  141962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  141966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  141970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  141974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  141978 */     // MIs[1] Operand 1
     /*  141978 */     // No operand predicates
     /*  141978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  141980 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  141980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  141983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  141990 */     GIR_RootConstrainSelectedInstOperands,
     /*  141991 */     // GIR_Coverage, 94,
     /*  141991 */     GIR_EraseRootFromParent_Done,
     /*  141992 */   // Label 2546: @141992
     /*  141992 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(142015), // Rule ID 92 //
     /*  141997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  142000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  142008 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  142008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  142013 */     GIR_RootConstrainSelectedInstOperands,
     /*  142014 */     // GIR_Coverage, 92,
     /*  142014 */     GIR_Done,
     /*  142015 */   // Label 2547: @142015
     /*  142015 */   GIM_Reject,
     /*  142016 */ // Label 2539: @142016
     /*  142016 */ GIM_Reject,
     /*  142017 */ // Label 2498: @142017
     /*  142017 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(143627),
     /*  142022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142032 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(142101), // Rule ID 53164 //
     /*  142037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142080 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142099 */     GIR_RootConstrainSelectedInstOperands,
     /*  142100 */     // GIR_Coverage, 53164,
     /*  142100 */     GIR_EraseRootFromParent_Done,
     /*  142101 */   // Label 2549: @142101
     /*  142101 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(142170), // Rule ID 53165 //
     /*  142106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142149 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142168 */     GIR_RootConstrainSelectedInstOperands,
     /*  142169 */     // GIR_Coverage, 53165,
     /*  142169 */     GIR_EraseRootFromParent_Done,
     /*  142170 */   // Label 2550: @142170
     /*  142170 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(142239), // Rule ID 53166 //
     /*  142175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142218 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142237 */     GIR_RootConstrainSelectedInstOperands,
     /*  142238 */     // GIR_Coverage, 53166,
     /*  142238 */     GIR_EraseRootFromParent_Done,
     /*  142239 */   // Label 2551: @142239
     /*  142239 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(142308), // Rule ID 53167 //
     /*  142244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142287 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142306 */     GIR_RootConstrainSelectedInstOperands,
     /*  142307 */     // GIR_Coverage, 53167,
     /*  142307 */     GIR_EraseRootFromParent_Done,
     /*  142308 */   // Label 2552: @142308
     /*  142308 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(142374), // Rule ID 71672 //
     /*  142313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142355 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142372 */     GIR_RootConstrainSelectedInstOperands,
     /*  142373 */     // GIR_Coverage, 71672,
     /*  142373 */     GIR_EraseRootFromParent_Done,
     /*  142374 */   // Label 2553: @142374
     /*  142374 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(142440), // Rule ID 71673 //
     /*  142379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142421 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142438 */     GIR_RootConstrainSelectedInstOperands,
     /*  142439 */     // GIR_Coverage, 71673,
     /*  142439 */     GIR_EraseRootFromParent_Done,
     /*  142440 */   // Label 2554: @142440
     /*  142440 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(142506), // Rule ID 71670 //
     /*  142445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142487 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142504 */     GIR_RootConstrainSelectedInstOperands,
     /*  142505 */     // GIR_Coverage, 71670,
     /*  142505 */     GIR_EraseRootFromParent_Done,
     /*  142506 */   // Label 2555: @142506
     /*  142506 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(142572), // Rule ID 71671 //
     /*  142511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142553 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142570 */     GIR_RootConstrainSelectedInstOperands,
     /*  142571 */     // GIR_Coverage, 71671,
     /*  142571 */     GIR_EraseRootFromParent_Done,
     /*  142572 */   // Label 2556: @142572
     /*  142572 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(142641), // Rule ID 53168 //
     /*  142577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142620 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142639 */     GIR_RootConstrainSelectedInstOperands,
     /*  142640 */     // GIR_Coverage, 53168,
     /*  142640 */     GIR_EraseRootFromParent_Done,
     /*  142641 */   // Label 2557: @142641
     /*  142641 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(142710), // Rule ID 53169 //
     /*  142646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142689 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  142692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142708 */     GIR_RootConstrainSelectedInstOperands,
     /*  142709 */     // GIR_Coverage, 53169,
     /*  142709 */     GIR_EraseRootFromParent_Done,
     /*  142710 */   // Label 2558: @142710
     /*  142710 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(142779), // Rule ID 71666 //
     /*  142715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142758 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142777 */     GIR_RootConstrainSelectedInstOperands,
     /*  142778 */     // GIR_Coverage, 71666,
     /*  142778 */     GIR_EraseRootFromParent_Done,
     /*  142779 */   // Label 2559: @142779
     /*  142779 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(142848), // Rule ID 71667 //
     /*  142784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142811 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142827 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  142830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142846 */     GIR_RootConstrainSelectedInstOperands,
     /*  142847 */     // GIR_Coverage, 71667,
     /*  142847 */     GIR_EraseRootFromParent_Done,
     /*  142848 */   // Label 2560: @142848
     /*  142848 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(142917), // Rule ID 71668 //
     /*  142853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142896 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142915 */     GIR_RootConstrainSelectedInstOperands,
     /*  142916 */     // GIR_Coverage, 71668,
     /*  142916 */     GIR_EraseRootFromParent_Done,
     /*  142917 */   // Label 2561: @142917
     /*  142917 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(142986), // Rule ID 71669 //
     /*  142922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142945 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  142949 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  142953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142965 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  142968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142984 */     GIR_RootConstrainSelectedInstOperands,
     /*  142985 */     // GIR_Coverage, 71669,
     /*  142985 */     GIR_EraseRootFromParent_Done,
     /*  142986 */   // Label 2562: @142986
     /*  142986 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(143055), // Rule ID 71674 //
     /*  142991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143034 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143053 */     GIR_RootConstrainSelectedInstOperands,
     /*  143054 */     // GIR_Coverage, 71674,
     /*  143054 */     GIR_EraseRootFromParent_Done,
     /*  143055 */   // Label 2563: @143055
     /*  143055 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(143124), // Rule ID 71675 //
     /*  143060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143103 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  143112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  143116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143122 */     GIR_RootConstrainSelectedInstOperands,
     /*  143123 */     // GIR_Coverage, 71675,
     /*  143123 */     GIR_EraseRootFromParent_Done,
     /*  143124 */   // Label 2564: @143124
     /*  143124 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(143190), // Rule ID 71678 //
     /*  143129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143171 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143188 */     GIR_RootConstrainSelectedInstOperands,
     /*  143189 */     // GIR_Coverage, 71678,
     /*  143189 */     GIR_EraseRootFromParent_Done,
     /*  143190 */   // Label 2565: @143190
     /*  143190 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(143256), // Rule ID 71679 //
     /*  143195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143237 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143254 */     GIR_RootConstrainSelectedInstOperands,
     /*  143255 */     // GIR_Coverage, 71679,
     /*  143255 */     GIR_EraseRootFromParent_Done,
     /*  143256 */   // Label 2566: @143256
     /*  143256 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(143322), // Rule ID 71676 //
     /*  143261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143303 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143320 */     GIR_RootConstrainSelectedInstOperands,
     /*  143321 */     // GIR_Coverage, 71676,
     /*  143321 */     GIR_EraseRootFromParent_Done,
     /*  143322 */   // Label 2567: @143322
     /*  143322 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(143388), // Rule ID 71677 //
     /*  143327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  143346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  143350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  143359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143363 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143369 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  143372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  143380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143386 */     GIR_RootConstrainSelectedInstOperands,
     /*  143387 */     // GIR_Coverage, 71677,
     /*  143387 */     GIR_EraseRootFromParent_Done,
     /*  143388 */   // Label 2568: @143388
     /*  143388 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(143431), // Rule ID 71692 //
     /*  143393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143414 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143429 */     GIR_RootConstrainSelectedInstOperands,
     /*  143430 */     // GIR_Coverage, 71692,
     /*  143430 */     GIR_EraseRootFromParent_Done,
     /*  143431 */   // Label 2569: @143431
     /*  143431 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(143474), // Rule ID 71693 //
     /*  143436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143457 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  143466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143472 */     GIR_RootConstrainSelectedInstOperands,
     /*  143473 */     // GIR_Coverage, 71693,
     /*  143473 */     GIR_EraseRootFromParent_Done,
     /*  143474 */   // Label 2570: @143474
     /*  143474 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(143517), // Rule ID 53174 //
     /*  143479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143500 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143515 */     GIR_RootConstrainSelectedInstOperands,
     /*  143516 */     // GIR_Coverage, 53174,
     /*  143516 */     GIR_EraseRootFromParent_Done,
     /*  143517 */   // Label 2571: @143517
     /*  143517 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(143560), // Rule ID 53175 //
     /*  143522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143543 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  143546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143558 */     GIR_RootConstrainSelectedInstOperands,
     /*  143559 */     // GIR_Coverage, 53175,
     /*  143559 */     GIR_EraseRootFromParent_Done,
     /*  143560 */   // Label 2572: @143560
     /*  143560 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(143593), // Rule ID 53162 //
     /*  143565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143576 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  143579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143591 */     GIR_RootConstrainSelectedInstOperands,
     /*  143592 */     // GIR_Coverage, 53162,
     /*  143592 */     GIR_EraseRootFromParent_Done,
     /*  143593 */   // Label 2573: @143593
     /*  143593 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(143626), // Rule ID 53163 //
     /*  143598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143609 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  143612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143624 */     GIR_RootConstrainSelectedInstOperands,
     /*  143625 */     // GIR_Coverage, 53163,
     /*  143625 */     GIR_EraseRootFromParent_Done,
     /*  143626 */   // Label 2574: @143626
     /*  143626 */   GIM_Reject,
     /*  143627 */ // Label 2548: @143627
     /*  143627 */ GIM_Reject,
     /*  143628 */ // Label 2499: @143628
     /*  143628 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(143742),
     /*  143633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  143636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  143639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143651 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(143696), // Rule ID 47914 //
     /*  143656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143659 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  143659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  143662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  143676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143694 */     GIR_RootConstrainSelectedInstOperands,
     /*  143695 */     // GIR_Coverage, 47914,
     /*  143695 */     GIR_EraseRootFromParent_Done,
     /*  143696 */   // Label 2576: @143696
     /*  143696 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(143741), // Rule ID 47915 //
     /*  143701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143704 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  143704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  143707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  143721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143739 */     GIR_RootConstrainSelectedInstOperands,
     /*  143740 */     // GIR_Coverage, 47915,
     /*  143740 */     GIR_EraseRootFromParent_Done,
     /*  143741 */   // Label 2577: @143741
     /*  143741 */   GIM_Reject,
     /*  143742 */ // Label 2575: @143742
     /*  143742 */ GIM_Reject,
     /*  143743 */ // Label 2500: @143743
     /*  143743 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(143857),
     /*  143748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  143751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  143754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143766 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(143811), // Rule ID 47926 //
     /*  143771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143774 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  143774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  143777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  143791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143809 */     GIR_RootConstrainSelectedInstOperands,
     /*  143810 */     // GIR_Coverage, 47926,
     /*  143810 */     GIR_EraseRootFromParent_Done,
     /*  143811 */   // Label 2579: @143811
     /*  143811 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(143856), // Rule ID 47927 //
     /*  143816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143819 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  143819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  143822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  143836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143854 */     GIR_RootConstrainSelectedInstOperands,
     /*  143855 */     // GIR_Coverage, 47927,
     /*  143855 */     GIR_EraseRootFromParent_Done,
     /*  143856 */   // Label 2580: @143856
     /*  143856 */   GIM_Reject,
     /*  143857 */ // Label 2578: @143857
     /*  143857 */ GIM_Reject,
     /*  143858 */ // Label 2501: @143858
     /*  143858 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(143972),
     /*  143863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  143866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  143869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143881 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(143926), // Rule ID 47934 //
     /*  143886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143889 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  143889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  143892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143924 */     GIR_RootConstrainSelectedInstOperands,
     /*  143925 */     // GIR_Coverage, 47934,
     /*  143925 */     GIR_EraseRootFromParent_Done,
     /*  143926 */   // Label 2582: @143926
     /*  143926 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(143971), // Rule ID 47935 //
     /*  143931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143934 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  143934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  143937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143969 */     GIR_RootConstrainSelectedInstOperands,
     /*  143970 */     // GIR_Coverage, 47935,
     /*  143970 */     GIR_EraseRootFromParent_Done,
     /*  143971 */   // Label 2583: @143971
     /*  143971 */   GIM_Reject,
     /*  143972 */ // Label 2581: @143972
     /*  143972 */ GIM_Reject,
     /*  143973 */ // Label 2502: @143973
     /*  143973 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(144087),
     /*  143978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  143981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  143984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143996 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(144041), // Rule ID 47950 //
     /*  144001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  144004 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  144004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  144007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  144021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144039 */     GIR_RootConstrainSelectedInstOperands,
     /*  144040 */     // GIR_Coverage, 47950,
     /*  144040 */     GIR_EraseRootFromParent_Done,
     /*  144041 */   // Label 2585: @144041
     /*  144041 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(144086), // Rule ID 47951 //
     /*  144046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  144049 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  144049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  144052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  144056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  144061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  144063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  144066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  144071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  144073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  144081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  144084 */     GIR_RootConstrainSelectedInstOperands,
     /*  144085 */     // GIR_Coverage, 47951,
     /*  144085 */     GIR_EraseRootFromParent_Done,
     /*  144086 */   // Label 2586: @144086
     /*  144086 */   GIM_Reject,
     /*  144087 */ // Label 2584: @144087
     /*  144087 */ GIM_Reject,
     /*  144088 */ // Label 2503: @144088
     /*  144088 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(145698),
     /*  144093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144103 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(144172), // Rule ID 53182 //
     /*  144108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144151 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144170 */     GIR_RootConstrainSelectedInstOperands,
     /*  144171 */     // GIR_Coverage, 53182,
     /*  144171 */     GIR_EraseRootFromParent_Done,
     /*  144172 */   // Label 2588: @144172
     /*  144172 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(144241), // Rule ID 53183 //
     /*  144177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144220 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144239 */     GIR_RootConstrainSelectedInstOperands,
     /*  144240 */     // GIR_Coverage, 53183,
     /*  144240 */     GIR_EraseRootFromParent_Done,
     /*  144241 */   // Label 2589: @144241
     /*  144241 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(144310), // Rule ID 53184 //
     /*  144246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144289 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144308 */     GIR_RootConstrainSelectedInstOperands,
     /*  144309 */     // GIR_Coverage, 53184,
     /*  144309 */     GIR_EraseRootFromParent_Done,
     /*  144310 */   // Label 2590: @144310
     /*  144310 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(144379), // Rule ID 53185 //
     /*  144315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144358 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144377 */     GIR_RootConstrainSelectedInstOperands,
     /*  144378 */     // GIR_Coverage, 53185,
     /*  144378 */     GIR_EraseRootFromParent_Done,
     /*  144379 */   // Label 2591: @144379
     /*  144379 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(144445), // Rule ID 71700 //
     /*  144384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144426 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144443 */     GIR_RootConstrainSelectedInstOperands,
     /*  144444 */     // GIR_Coverage, 71700,
     /*  144444 */     GIR_EraseRootFromParent_Done,
     /*  144445 */   // Label 2592: @144445
     /*  144445 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(144511), // Rule ID 71701 //
     /*  144450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144492 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144509 */     GIR_RootConstrainSelectedInstOperands,
     /*  144510 */     // GIR_Coverage, 71701,
     /*  144510 */     GIR_EraseRootFromParent_Done,
     /*  144511 */   // Label 2593: @144511
     /*  144511 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(144577), // Rule ID 71698 //
     /*  144516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144558 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144575 */     GIR_RootConstrainSelectedInstOperands,
     /*  144576 */     // GIR_Coverage, 71698,
     /*  144576 */     GIR_EraseRootFromParent_Done,
     /*  144577 */   // Label 2594: @144577
     /*  144577 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(144643), // Rule ID 71699 //
     /*  144582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144597 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144624 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144641 */     GIR_RootConstrainSelectedInstOperands,
     /*  144642 */     // GIR_Coverage, 71699,
     /*  144642 */     GIR_EraseRootFromParent_Done,
     /*  144643 */   // Label 2595: @144643
     /*  144643 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(144712), // Rule ID 53186 //
     /*  144648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144689 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144691 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144710 */     GIR_RootConstrainSelectedInstOperands,
     /*  144711 */     // GIR_Coverage, 53186,
     /*  144711 */     GIR_EraseRootFromParent_Done,
     /*  144712 */   // Label 2596: @144712
     /*  144712 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(144781), // Rule ID 53187 //
     /*  144717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144760 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  144763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144779 */     GIR_RootConstrainSelectedInstOperands,
     /*  144780 */     // GIR_Coverage, 53187,
     /*  144780 */     GIR_EraseRootFromParent_Done,
     /*  144781 */   // Label 2597: @144781
     /*  144781 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(144850), // Rule ID 71694 //
     /*  144786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144829 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144848 */     GIR_RootConstrainSelectedInstOperands,
     /*  144849 */     // GIR_Coverage, 71694,
     /*  144849 */     GIR_EraseRootFromParent_Done,
     /*  144850 */   // Label 2598: @144850
     /*  144850 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(144919), // Rule ID 71695 //
     /*  144855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144898 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  144901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144917 */     GIR_RootConstrainSelectedInstOperands,
     /*  144918 */     // GIR_Coverage, 71695,
     /*  144918 */     GIR_EraseRootFromParent_Done,
     /*  144919 */   // Label 2599: @144919
     /*  144919 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(144988), // Rule ID 71696 //
     /*  144924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  144951 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  144955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144967 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  144970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144986 */     GIR_RootConstrainSelectedInstOperands,
     /*  144987 */     // GIR_Coverage, 71696,
     /*  144987 */     GIR_EraseRootFromParent_Done,
     /*  144988 */   // Label 2600: @144988
     /*  144988 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(145057), // Rule ID 71697 //
     /*  144993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145036 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  145039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145055 */     GIR_RootConstrainSelectedInstOperands,
     /*  145056 */     // GIR_Coverage, 71697,
     /*  145056 */     GIR_EraseRootFromParent_Done,
     /*  145057 */   // Label 2601: @145057
     /*  145057 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(145126), // Rule ID 71702 //
     /*  145062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145105 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145124 */     GIR_RootConstrainSelectedInstOperands,
     /*  145125 */     // GIR_Coverage, 71702,
     /*  145125 */     GIR_EraseRootFromParent_Done,
     /*  145126 */   // Label 2602: @145126
     /*  145126 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(145195), // Rule ID 71703 //
     /*  145131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145174 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  145183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  145187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145193 */     GIR_RootConstrainSelectedInstOperands,
     /*  145194 */     // GIR_Coverage, 71703,
     /*  145194 */     GIR_EraseRootFromParent_Done,
     /*  145195 */   // Label 2603: @145195
     /*  145195 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(145261), // Rule ID 71706 //
     /*  145200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  145227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145242 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  145251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145259 */     GIR_RootConstrainSelectedInstOperands,
     /*  145260 */     // GIR_Coverage, 71706,
     /*  145260 */     GIR_EraseRootFromParent_Done,
     /*  145261 */   // Label 2604: @145261
     /*  145261 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(145327), // Rule ID 71707 //
     /*  145266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  145293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145308 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  145317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145325 */     GIR_RootConstrainSelectedInstOperands,
     /*  145326 */     // GIR_Coverage, 71707,
     /*  145326 */     GIR_EraseRootFromParent_Done,
     /*  145327 */   // Label 2605: @145327
     /*  145327 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(145393), // Rule ID 71704 //
     /*  145332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145374 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145391 */     GIR_RootConstrainSelectedInstOperands,
     /*  145392 */     // GIR_Coverage, 71704,
     /*  145392 */     GIR_EraseRootFromParent_Done,
     /*  145393 */   // Label 2606: @145393
     /*  145393 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(145459), // Rule ID 71705 //
     /*  145398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  145417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  145421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  145430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145440 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  145443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  145451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145457 */     GIR_RootConstrainSelectedInstOperands,
     /*  145458 */     // GIR_Coverage, 71705,
     /*  145458 */     GIR_EraseRootFromParent_Done,
     /*  145459 */   // Label 2607: @145459
     /*  145459 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(145502), // Rule ID 71720 //
     /*  145464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145485 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145500 */     GIR_RootConstrainSelectedInstOperands,
     /*  145501 */     // GIR_Coverage, 71720,
     /*  145501 */     GIR_EraseRootFromParent_Done,
     /*  145502 */   // Label 2608: @145502
     /*  145502 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(145545), // Rule ID 71721 //
     /*  145507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145528 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145543 */     GIR_RootConstrainSelectedInstOperands,
     /*  145544 */     // GIR_Coverage, 71721,
     /*  145544 */     GIR_EraseRootFromParent_Done,
     /*  145545 */   // Label 2609: @145545
     /*  145545 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(145588), // Rule ID 53192 //
     /*  145550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145571 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145586 */     GIR_RootConstrainSelectedInstOperands,
     /*  145587 */     // GIR_Coverage, 53192,
     /*  145587 */     GIR_EraseRootFromParent_Done,
     /*  145588 */   // Label 2610: @145588
     /*  145588 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(145631), // Rule ID 53193 //
     /*  145593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145614 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  145617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145629 */     GIR_RootConstrainSelectedInstOperands,
     /*  145630 */     // GIR_Coverage, 53193,
     /*  145630 */     GIR_EraseRootFromParent_Done,
     /*  145631 */   // Label 2611: @145631
     /*  145631 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(145664), // Rule ID 53180 //
     /*  145636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145647 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  145650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145662 */     GIR_RootConstrainSelectedInstOperands,
     /*  145663 */     // GIR_Coverage, 53180,
     /*  145663 */     GIR_EraseRootFromParent_Done,
     /*  145664 */   // Label 2612: @145664
     /*  145664 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(145697), // Rule ID 53181 //
     /*  145669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145680 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  145683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145695 */     GIR_RootConstrainSelectedInstOperands,
     /*  145696 */     // GIR_Coverage, 53181,
     /*  145696 */     GIR_EraseRootFromParent_Done,
     /*  145697 */   // Label 2613: @145697
     /*  145697 */   GIM_Reject,
     /*  145698 */ // Label 2587: @145698
     /*  145698 */ GIM_Reject,
     /*  145699 */ // Label 2504: @145699
     /*  145699 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(145813),
     /*  145704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  145707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  145710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145722 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(145767), // Rule ID 47918 //
     /*  145727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145730 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  145730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  145733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  145747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145765 */     GIR_RootConstrainSelectedInstOperands,
     /*  145766 */     // GIR_Coverage, 47918,
     /*  145766 */     GIR_EraseRootFromParent_Done,
     /*  145767 */   // Label 2615: @145767
     /*  145767 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(145812), // Rule ID 47919 //
     /*  145772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145775 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  145775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  145778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  145792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145810 */     GIR_RootConstrainSelectedInstOperands,
     /*  145811 */     // GIR_Coverage, 47919,
     /*  145811 */     GIR_EraseRootFromParent_Done,
     /*  145812 */   // Label 2616: @145812
     /*  145812 */   GIM_Reject,
     /*  145813 */ // Label 2614: @145813
     /*  145813 */ GIM_Reject,
     /*  145814 */ // Label 2505: @145814
     /*  145814 */ GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(145928),
     /*  145819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  145822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  145825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145837 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(145882), // Rule ID 47930 //
     /*  145842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145845 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  145845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  145848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  145862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145880 */     GIR_RootConstrainSelectedInstOperands,
     /*  145881 */     // GIR_Coverage, 47930,
     /*  145881 */     GIR_EraseRootFromParent_Done,
     /*  145882 */   // Label 2618: @145882
     /*  145882 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(145927), // Rule ID 47931 //
     /*  145887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145890 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  145890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  145893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  145907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145925 */     GIR_RootConstrainSelectedInstOperands,
     /*  145926 */     // GIR_Coverage, 47931,
     /*  145926 */     GIR_EraseRootFromParent_Done,
     /*  145927 */   // Label 2619: @145927
     /*  145927 */   GIM_Reject,
     /*  145928 */ // Label 2617: @145928
     /*  145928 */ GIM_Reject,
     /*  145929 */ // Label 2506: @145929
     /*  145929 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(146043),
     /*  145934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  145937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  145940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145952 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(145997), // Rule ID 47946 //
     /*  145957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145960 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  145960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  145963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  145977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  145992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145995 */     GIR_RootConstrainSelectedInstOperands,
     /*  145996 */     // GIR_Coverage, 47946,
     /*  145996 */     GIR_EraseRootFromParent_Done,
     /*  145997 */   // Label 2621: @145997
     /*  145997 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(146042), // Rule ID 47947 //
     /*  146002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146005 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  146005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  146008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  146022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  146037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146040 */     GIR_RootConstrainSelectedInstOperands,
     /*  146041 */     // GIR_Coverage, 47947,
     /*  146041 */     GIR_EraseRootFromParent_Done,
     /*  146042 */   // Label 2622: @146042
     /*  146042 */   GIM_Reject,
     /*  146043 */ // Label 2620: @146043
     /*  146043 */ GIM_Reject,
     /*  146044 */ // Label 2507: @146044
     /*  146044 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(146158),
     /*  146049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  146052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  146055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  146067 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(146112), // Rule ID 47990 //
     /*  146072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  146075 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  146075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  146078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  146092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  146107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146110 */     GIR_RootConstrainSelectedInstOperands,
     /*  146111 */     // GIR_Coverage, 47990,
     /*  146111 */     GIR_EraseRootFromParent_Done,
     /*  146112 */   // Label 2624: @146112
     /*  146112 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(146157), // Rule ID 47991 //
     /*  146117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  146120 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  146120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  146123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  146127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  146132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  146134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  146137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  146142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  146144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  146152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  146155 */     GIR_RootConstrainSelectedInstOperands,
     /*  146156 */     // GIR_Coverage, 47991,
     /*  146156 */     GIR_EraseRootFromParent_Done,
     /*  146157 */   // Label 2625: @146157
     /*  146157 */   GIM_Reject,
     /*  146158 */ // Label 2623: @146158
     /*  146158 */ GIM_Reject,
     /*  146159 */ // Label 2508: @146159
     /*  146159 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(147769),
     /*  146164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146174 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(146243), // Rule ID 53200 //
     /*  146179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146222 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146241 */     GIR_RootConstrainSelectedInstOperands,
     /*  146242 */     // GIR_Coverage, 53200,
     /*  146242 */     GIR_EraseRootFromParent_Done,
     /*  146243 */   // Label 2627: @146243
     /*  146243 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(146312), // Rule ID 53201 //
     /*  146248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146291 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146310 */     GIR_RootConstrainSelectedInstOperands,
     /*  146311 */     // GIR_Coverage, 53201,
     /*  146311 */     GIR_EraseRootFromParent_Done,
     /*  146312 */   // Label 2628: @146312
     /*  146312 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(146381), // Rule ID 53202 //
     /*  146317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146360 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146379 */     GIR_RootConstrainSelectedInstOperands,
     /*  146380 */     // GIR_Coverage, 53202,
     /*  146380 */     GIR_EraseRootFromParent_Done,
     /*  146381 */   // Label 2629: @146381
     /*  146381 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(146450), // Rule ID 53203 //
     /*  146386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146429 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  146432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146448 */     GIR_RootConstrainSelectedInstOperands,
     /*  146449 */     // GIR_Coverage, 53203,
     /*  146449 */     GIR_EraseRootFromParent_Done,
     /*  146450 */   // Label 2630: @146450
     /*  146450 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(146516), // Rule ID 71728 //
     /*  146455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146497 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146514 */     GIR_RootConstrainSelectedInstOperands,
     /*  146515 */     // GIR_Coverage, 71728,
     /*  146515 */     GIR_EraseRootFromParent_Done,
     /*  146516 */   // Label 2631: @146516
     /*  146516 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(146582), // Rule ID 71729 //
     /*  146521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146563 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146580 */     GIR_RootConstrainSelectedInstOperands,
     /*  146581 */     // GIR_Coverage, 71729,
     /*  146581 */     GIR_EraseRootFromParent_Done,
     /*  146582 */   // Label 2632: @146582
     /*  146582 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(146648), // Rule ID 71726 //
     /*  146587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146629 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146646 */     GIR_RootConstrainSelectedInstOperands,
     /*  146647 */     // GIR_Coverage, 71726,
     /*  146647 */     GIR_EraseRootFromParent_Done,
     /*  146648 */   // Label 2633: @146648
     /*  146648 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(146714), // Rule ID 71727 //
     /*  146653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146695 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146712 */     GIR_RootConstrainSelectedInstOperands,
     /*  146713 */     // GIR_Coverage, 71727,
     /*  146713 */     GIR_EraseRootFromParent_Done,
     /*  146714 */   // Label 2634: @146714
     /*  146714 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(146783), // Rule ID 53204 //
     /*  146719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146762 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146781 */     GIR_RootConstrainSelectedInstOperands,
     /*  146782 */     // GIR_Coverage, 53204,
     /*  146782 */     GIR_EraseRootFromParent_Done,
     /*  146783 */   // Label 2635: @146783
     /*  146783 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(146852), // Rule ID 53205 //
     /*  146788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146831 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  146834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146850 */     GIR_RootConstrainSelectedInstOperands,
     /*  146851 */     // GIR_Coverage, 53205,
     /*  146851 */     GIR_EraseRootFromParent_Done,
     /*  146852 */   // Label 2636: @146852
     /*  146852 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(146921), // Rule ID 71722 //
     /*  146857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146900 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146919 */     GIR_RootConstrainSelectedInstOperands,
     /*  146920 */     // GIR_Coverage, 71722,
     /*  146920 */     GIR_EraseRootFromParent_Done,
     /*  146921 */   // Label 2637: @146921
     /*  146921 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(146990), // Rule ID 71723 //
     /*  146926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  146953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  146957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146969 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  146972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146988 */     GIR_RootConstrainSelectedInstOperands,
     /*  146989 */     // GIR_Coverage, 71723,
     /*  146989 */     GIR_EraseRootFromParent_Done,
     /*  146990 */   // Label 2638: @146990
     /*  146990 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(147059), // Rule ID 71724 //
     /*  146995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147038 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  147041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147057 */     GIR_RootConstrainSelectedInstOperands,
     /*  147058 */     // GIR_Coverage, 71724,
     /*  147058 */     GIR_EraseRootFromParent_Done,
     /*  147059 */   // Label 2639: @147059
     /*  147059 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(147128), // Rule ID 71725 //
     /*  147064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147107 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  147110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147126 */     GIR_RootConstrainSelectedInstOperands,
     /*  147127 */     // GIR_Coverage, 71725,
     /*  147127 */     GIR_EraseRootFromParent_Done,
     /*  147128 */   // Label 2640: @147128
     /*  147128 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(147197), // Rule ID 71730 //
     /*  147133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147176 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147195 */     GIR_RootConstrainSelectedInstOperands,
     /*  147196 */     // GIR_Coverage, 71730,
     /*  147196 */     GIR_EraseRootFromParent_Done,
     /*  147197 */   // Label 2641: @147197
     /*  147197 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(147266), // Rule ID 71731 //
     /*  147202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147245 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  147254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  147258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147264 */     GIR_RootConstrainSelectedInstOperands,
     /*  147265 */     // GIR_Coverage, 71731,
     /*  147265 */     GIR_EraseRootFromParent_Done,
     /*  147266 */   // Label 2642: @147266
     /*  147266 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(147332), // Rule ID 71734 //
     /*  147271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147313 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147330 */     GIR_RootConstrainSelectedInstOperands,
     /*  147331 */     // GIR_Coverage, 71734,
     /*  147331 */     GIR_EraseRootFromParent_Done,
     /*  147332 */   // Label 2643: @147332
     /*  147332 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(147398), // Rule ID 71735 //
     /*  147337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147379 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147396 */     GIR_RootConstrainSelectedInstOperands,
     /*  147397 */     // GIR_Coverage, 71735,
     /*  147397 */     GIR_EraseRootFromParent_Done,
     /*  147398 */   // Label 2644: @147398
     /*  147398 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(147464), // Rule ID 71732 //
     /*  147403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147445 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147462 */     GIR_RootConstrainSelectedInstOperands,
     /*  147463 */     // GIR_Coverage, 71732,
     /*  147463 */     GIR_EraseRootFromParent_Done,
     /*  147464 */   // Label 2645: @147464
     /*  147464 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(147530), // Rule ID 71733 //
     /*  147469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  147488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  147492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147511 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  147514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147528 */     GIR_RootConstrainSelectedInstOperands,
     /*  147529 */     // GIR_Coverage, 71733,
     /*  147529 */     GIR_EraseRootFromParent_Done,
     /*  147530 */   // Label 2646: @147530
     /*  147530 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(147573), // Rule ID 71748 //
     /*  147535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147556 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147571 */     GIR_RootConstrainSelectedInstOperands,
     /*  147572 */     // GIR_Coverage, 71748,
     /*  147572 */     GIR_EraseRootFromParent_Done,
     /*  147573 */   // Label 2647: @147573
     /*  147573 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(147616), // Rule ID 71749 //
     /*  147578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147599 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147614 */     GIR_RootConstrainSelectedInstOperands,
     /*  147615 */     // GIR_Coverage, 71749,
     /*  147615 */     GIR_EraseRootFromParent_Done,
     /*  147616 */   // Label 2648: @147616
     /*  147616 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(147659), // Rule ID 53210 //
     /*  147621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147642 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147657 */     GIR_RootConstrainSelectedInstOperands,
     /*  147658 */     // GIR_Coverage, 53210,
     /*  147658 */     GIR_EraseRootFromParent_Done,
     /*  147659 */   // Label 2649: @147659
     /*  147659 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(147702), // Rule ID 53211 //
     /*  147664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147685 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  147688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147700 */     GIR_RootConstrainSelectedInstOperands,
     /*  147701 */     // GIR_Coverage, 53211,
     /*  147701 */     GIR_EraseRootFromParent_Done,
     /*  147702 */   // Label 2650: @147702
     /*  147702 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(147735), // Rule ID 53198 //
     /*  147707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147718 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  147721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147733 */     GIR_RootConstrainSelectedInstOperands,
     /*  147734 */     // GIR_Coverage, 53198,
     /*  147734 */     GIR_EraseRootFromParent_Done,
     /*  147735 */   // Label 2651: @147735
     /*  147735 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(147768), // Rule ID 53199 //
     /*  147740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147751 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  147754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147766 */     GIR_RootConstrainSelectedInstOperands,
     /*  147767 */     // GIR_Coverage, 53199,
     /*  147767 */     GIR_EraseRootFromParent_Done,
     /*  147768 */   // Label 2652: @147768
     /*  147768 */   GIM_Reject,
     /*  147769 */ // Label 2626: @147769
     /*  147769 */ GIM_Reject,
     /*  147770 */ // Label 2509: @147770
     /*  147770 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(147884),
     /*  147775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  147778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  147781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147793 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(147838), // Rule ID 47922 //
     /*  147798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147801 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  147801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  147804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  147818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147836 */     GIR_RootConstrainSelectedInstOperands,
     /*  147837 */     // GIR_Coverage, 47922,
     /*  147837 */     GIR_EraseRootFromParent_Done,
     /*  147838 */   // Label 2654: @147838
     /*  147838 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(147883), // Rule ID 47923 //
     /*  147843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147846 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  147846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  147849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  147863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147881 */     GIR_RootConstrainSelectedInstOperands,
     /*  147882 */     // GIR_Coverage, 47923,
     /*  147882 */     GIR_EraseRootFromParent_Done,
     /*  147883 */   // Label 2655: @147883
     /*  147883 */   GIM_Reject,
     /*  147884 */ // Label 2653: @147884
     /*  147884 */ GIM_Reject,
     /*  147885 */ // Label 2510: @147885
     /*  147885 */ GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(147999),
     /*  147890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  147893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  147896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147908 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(147953), // Rule ID 47942 //
     /*  147913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147916 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  147916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  147919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  147933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  147948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147951 */     GIR_RootConstrainSelectedInstOperands,
     /*  147952 */     // GIR_Coverage, 47942,
     /*  147952 */     GIR_EraseRootFromParent_Done,
     /*  147953 */   // Label 2657: @147953
     /*  147953 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(147998), // Rule ID 47943 //
     /*  147958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147961 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  147961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  147964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  147978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  147993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147996 */     GIR_RootConstrainSelectedInstOperands,
     /*  147997 */     // GIR_Coverage, 47943,
     /*  147997 */     GIR_EraseRootFromParent_Done,
     /*  147998 */   // Label 2658: @147998
     /*  147998 */   GIM_Reject,
     /*  147999 */ // Label 2656: @147999
     /*  147999 */ GIM_Reject,
     /*  148000 */ // Label 2511: @148000
     /*  148000 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(148114),
     /*  148005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  148008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  148011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  148023 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(148068), // Rule ID 47978 //
     /*  148028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148031 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  148031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  148034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  148048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148066 */     GIR_RootConstrainSelectedInstOperands,
     /*  148067 */     // GIR_Coverage, 47978,
     /*  148067 */     GIR_EraseRootFromParent_Done,
     /*  148068 */   // Label 2660: @148068
     /*  148068 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(148113), // Rule ID 47979 //
     /*  148073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148076 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  148076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  148079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  148093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  148108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148111 */     GIR_RootConstrainSelectedInstOperands,
     /*  148112 */     // GIR_Coverage, 47979,
     /*  148112 */     GIR_EraseRootFromParent_Done,
     /*  148113 */   // Label 2661: @148113
     /*  148113 */   GIM_Reject,
     /*  148114 */ // Label 2659: @148114
     /*  148114 */ GIM_Reject,
     /*  148115 */ // Label 2512: @148115
     /*  148115 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(148229),
     /*  148120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  148123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  148126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  148138 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(148183), // Rule ID 47994 //
     /*  148143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  148146 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  148146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  148149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  148163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148181 */     GIR_RootConstrainSelectedInstOperands,
     /*  148182 */     // GIR_Coverage, 47994,
     /*  148182 */     GIR_EraseRootFromParent_Done,
     /*  148183 */   // Label 2663: @148183
     /*  148183 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(148228), // Rule ID 47995 //
     /*  148188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  148191 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  148191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  148194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  148198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  148203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  148205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  148208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  148213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  148215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  148223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  148226 */     GIR_RootConstrainSelectedInstOperands,
     /*  148227 */     // GIR_Coverage, 47995,
     /*  148227 */     GIR_EraseRootFromParent_Done,
     /*  148228 */   // Label 2664: @148228
     /*  148228 */   GIM_Reject,
     /*  148229 */ // Label 2662: @148229
     /*  148229 */ GIM_Reject,
     /*  148230 */ // Label 2513: @148230
     /*  148230 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(149840),
     /*  148235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148245 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(148314), // Rule ID 53218 //
     /*  148250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148293 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148312 */     GIR_RootConstrainSelectedInstOperands,
     /*  148313 */     // GIR_Coverage, 53218,
     /*  148313 */     GIR_EraseRootFromParent_Done,
     /*  148314 */   // Label 2666: @148314
     /*  148314 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(148383), // Rule ID 53219 //
     /*  148319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148362 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148381 */     GIR_RootConstrainSelectedInstOperands,
     /*  148382 */     // GIR_Coverage, 53219,
     /*  148382 */     GIR_EraseRootFromParent_Done,
     /*  148383 */   // Label 2667: @148383
     /*  148383 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(148452), // Rule ID 53220 //
     /*  148388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148431 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148450 */     GIR_RootConstrainSelectedInstOperands,
     /*  148451 */     // GIR_Coverage, 53220,
     /*  148451 */     GIR_EraseRootFromParent_Done,
     /*  148452 */   // Label 2668: @148452
     /*  148452 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(148521), // Rule ID 53221 //
     /*  148457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148500 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  148503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148519 */     GIR_RootConstrainSelectedInstOperands,
     /*  148520 */     // GIR_Coverage, 53221,
     /*  148520 */     GIR_EraseRootFromParent_Done,
     /*  148521 */   // Label 2669: @148521
     /*  148521 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(148587), // Rule ID 71756 //
     /*  148526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148568 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148585 */     GIR_RootConstrainSelectedInstOperands,
     /*  148586 */     // GIR_Coverage, 71756,
     /*  148586 */     GIR_EraseRootFromParent_Done,
     /*  148587 */   // Label 2670: @148587
     /*  148587 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(148653), // Rule ID 71757 //
     /*  148592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148634 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148651 */     GIR_RootConstrainSelectedInstOperands,
     /*  148652 */     // GIR_Coverage, 71757,
     /*  148652 */     GIR_EraseRootFromParent_Done,
     /*  148653 */   // Label 2671: @148653
     /*  148653 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(148719), // Rule ID 71754 //
     /*  148658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148700 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148717 */     GIR_RootConstrainSelectedInstOperands,
     /*  148718 */     // GIR_Coverage, 71754,
     /*  148718 */     GIR_EraseRootFromParent_Done,
     /*  148719 */   // Label 2672: @148719
     /*  148719 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(148785), // Rule ID 71755 //
     /*  148724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148766 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148783 */     GIR_RootConstrainSelectedInstOperands,
     /*  148784 */     // GIR_Coverage, 71755,
     /*  148784 */     GIR_EraseRootFromParent_Done,
     /*  148785 */   // Label 2673: @148785
     /*  148785 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(148854), // Rule ID 53222 //
     /*  148790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148833 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148852 */     GIR_RootConstrainSelectedInstOperands,
     /*  148853 */     // GIR_Coverage, 53222,
     /*  148853 */     GIR_EraseRootFromParent_Done,
     /*  148854 */   // Label 2674: @148854
     /*  148854 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(148923), // Rule ID 53223 //
     /*  148859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148902 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  148905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148921 */     GIR_RootConstrainSelectedInstOperands,
     /*  148922 */     // GIR_Coverage, 53223,
     /*  148922 */     GIR_EraseRootFromParent_Done,
     /*  148923 */   // Label 2675: @148923
     /*  148923 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(148992), // Rule ID 71750 //
     /*  148928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  148955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  148959 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148971 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  148974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148990 */     GIR_RootConstrainSelectedInstOperands,
     /*  148991 */     // GIR_Coverage, 71750,
     /*  148991 */     GIR_EraseRootFromParent_Done,
     /*  148992 */   // Label 2676: @148992
     /*  148992 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(149061), // Rule ID 71751 //
     /*  148997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149040 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149059 */     GIR_RootConstrainSelectedInstOperands,
     /*  149060 */     // GIR_Coverage, 71751,
     /*  149060 */     GIR_EraseRootFromParent_Done,
     /*  149061 */   // Label 2677: @149061
     /*  149061 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(149130), // Rule ID 71752 //
     /*  149066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149109 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  149112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149128 */     GIR_RootConstrainSelectedInstOperands,
     /*  149129 */     // GIR_Coverage, 71752,
     /*  149129 */     GIR_EraseRootFromParent_Done,
     /*  149130 */   // Label 2678: @149130
     /*  149130 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(149199), // Rule ID 71753 //
     /*  149135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149178 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  149181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149197 */     GIR_RootConstrainSelectedInstOperands,
     /*  149198 */     // GIR_Coverage, 71753,
     /*  149198 */     GIR_EraseRootFromParent_Done,
     /*  149199 */   // Label 2679: @149199
     /*  149199 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(149268), // Rule ID 71758 //
     /*  149204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149247 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149266 */     GIR_RootConstrainSelectedInstOperands,
     /*  149267 */     // GIR_Coverage, 71758,
     /*  149267 */     GIR_EraseRootFromParent_Done,
     /*  149268 */   // Label 2680: @149268
     /*  149268 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(149337), // Rule ID 71759 //
     /*  149273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149316 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  149325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  149329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149335 */     GIR_RootConstrainSelectedInstOperands,
     /*  149336 */     // GIR_Coverage, 71759,
     /*  149336 */     GIR_EraseRootFromParent_Done,
     /*  149337 */   // Label 2681: @149337
     /*  149337 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(149403), // Rule ID 71762 //
     /*  149342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149384 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149401 */     GIR_RootConstrainSelectedInstOperands,
     /*  149402 */     // GIR_Coverage, 71762,
     /*  149402 */     GIR_EraseRootFromParent_Done,
     /*  149403 */   // Label 2682: @149403
     /*  149403 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(149469), // Rule ID 71763 //
     /*  149408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149450 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149467 */     GIR_RootConstrainSelectedInstOperands,
     /*  149468 */     // GIR_Coverage, 71763,
     /*  149468 */     GIR_EraseRootFromParent_Done,
     /*  149469 */   // Label 2683: @149469
     /*  149469 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(149535), // Rule ID 71760 //
     /*  149474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149516 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149533 */     GIR_RootConstrainSelectedInstOperands,
     /*  149534 */     // GIR_Coverage, 71760,
     /*  149534 */     GIR_EraseRootFromParent_Done,
     /*  149535 */   // Label 2684: @149535
     /*  149535 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(149601), // Rule ID 71761 //
     /*  149540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  149559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  149563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149582 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  149585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  149593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149599 */     GIR_RootConstrainSelectedInstOperands,
     /*  149600 */     // GIR_Coverage, 71761,
     /*  149600 */     GIR_EraseRootFromParent_Done,
     /*  149601 */   // Label 2685: @149601
     /*  149601 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(149644), // Rule ID 71776 //
     /*  149606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149627 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149642 */     GIR_RootConstrainSelectedInstOperands,
     /*  149643 */     // GIR_Coverage, 71776,
     /*  149643 */     GIR_EraseRootFromParent_Done,
     /*  149644 */   // Label 2686: @149644
     /*  149644 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(149687), // Rule ID 71777 //
     /*  149649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149670 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149685 */     GIR_RootConstrainSelectedInstOperands,
     /*  149686 */     // GIR_Coverage, 71777,
     /*  149686 */     GIR_EraseRootFromParent_Done,
     /*  149687 */   // Label 2687: @149687
     /*  149687 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(149730), // Rule ID 53228 //
     /*  149692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149713 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149728 */     GIR_RootConstrainSelectedInstOperands,
     /*  149729 */     // GIR_Coverage, 53228,
     /*  149729 */     GIR_EraseRootFromParent_Done,
     /*  149730 */   // Label 2688: @149730
     /*  149730 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(149773), // Rule ID 53229 //
     /*  149735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149756 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  149759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149771 */     GIR_RootConstrainSelectedInstOperands,
     /*  149772 */     // GIR_Coverage, 53229,
     /*  149772 */     GIR_EraseRootFromParent_Done,
     /*  149773 */   // Label 2689: @149773
     /*  149773 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(149806), // Rule ID 53216 //
     /*  149778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149789 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  149792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149804 */     GIR_RootConstrainSelectedInstOperands,
     /*  149805 */     // GIR_Coverage, 53216,
     /*  149805 */     GIR_EraseRootFromParent_Done,
     /*  149806 */   // Label 2690: @149806
     /*  149806 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(149839), // Rule ID 53217 //
     /*  149811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149822 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  149825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149837 */     GIR_RootConstrainSelectedInstOperands,
     /*  149838 */     // GIR_Coverage, 53217,
     /*  149838 */     GIR_EraseRootFromParent_Done,
     /*  149839 */   // Label 2691: @149839
     /*  149839 */   GIM_Reject,
     /*  149840 */ // Label 2665: @149840
     /*  149840 */ GIM_Reject,
     /*  149841 */ // Label 2514: @149841
     /*  149841 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(149955),
     /*  149846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  149849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  149852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149864 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(149909), // Rule ID 47938 //
     /*  149869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149872 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  149872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  149875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  149889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149907 */     GIR_RootConstrainSelectedInstOperands,
     /*  149908 */     // GIR_Coverage, 47938,
     /*  149908 */     GIR_EraseRootFromParent_Done,
     /*  149909 */   // Label 2693: @149909
     /*  149909 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(149954), // Rule ID 47939 //
     /*  149914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149917 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  149917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  149920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  149934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149952 */     GIR_RootConstrainSelectedInstOperands,
     /*  149953 */     // GIR_Coverage, 47939,
     /*  149953 */     GIR_EraseRootFromParent_Done,
     /*  149954 */   // Label 2694: @149954
     /*  149954 */   GIM_Reject,
     /*  149955 */ // Label 2692: @149955
     /*  149955 */ GIM_Reject,
     /*  149956 */ // Label 2515: @149956
     /*  149956 */ GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(150070),
     /*  149961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  149964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  149967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  149979 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(150024), // Rule ID 47966 //
     /*  149984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149987 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  149987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  149990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  150004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150022 */     GIR_RootConstrainSelectedInstOperands,
     /*  150023 */     // GIR_Coverage, 47966,
     /*  150023 */     GIR_EraseRootFromParent_Done,
     /*  150024 */   // Label 2696: @150024
     /*  150024 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(150069), // Rule ID 47967 //
     /*  150029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150032 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  150032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  150035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  150049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  150064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150067 */     GIR_RootConstrainSelectedInstOperands,
     /*  150068 */     // GIR_Coverage, 47967,
     /*  150068 */     GIR_EraseRootFromParent_Done,
     /*  150069 */   // Label 2697: @150069
     /*  150069 */   GIM_Reject,
     /*  150070 */ // Label 2695: @150070
     /*  150070 */ GIM_Reject,
     /*  150071 */ // Label 2516: @150071
     /*  150071 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(150185),
     /*  150076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  150079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  150082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  150094 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(150139), // Rule ID 47982 //
     /*  150099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150102 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  150102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  150105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  150119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150137 */     GIR_RootConstrainSelectedInstOperands,
     /*  150138 */     // GIR_Coverage, 47982,
     /*  150138 */     GIR_EraseRootFromParent_Done,
     /*  150139 */   // Label 2699: @150139
     /*  150139 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(150184), // Rule ID 47983 //
     /*  150144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150147 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  150147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  150150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  150164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  150179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150182 */     GIR_RootConstrainSelectedInstOperands,
     /*  150183 */     // GIR_Coverage, 47983,
     /*  150183 */     GIR_EraseRootFromParent_Done,
     /*  150184 */   // Label 2700: @150184
     /*  150184 */   GIM_Reject,
     /*  150185 */ // Label 2698: @150185
     /*  150185 */ GIM_Reject,
     /*  150186 */ // Label 2517: @150186
     /*  150186 */ GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(150300),
     /*  150191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  150194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  150197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  150209 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(150254), // Rule ID 47998 //
     /*  150214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  150217 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  150217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  150220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  150234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  150249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150252 */     GIR_RootConstrainSelectedInstOperands,
     /*  150253 */     // GIR_Coverage, 47998,
     /*  150253 */     GIR_EraseRootFromParent_Done,
     /*  150254 */   // Label 2702: @150254
     /*  150254 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(150299), // Rule ID 47999 //
     /*  150259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  150262 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  150262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  150265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  150269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  150274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  150276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  150279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  150284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  150286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  150294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  150297 */     GIR_RootConstrainSelectedInstOperands,
     /*  150298 */     // GIR_Coverage, 47999,
     /*  150298 */     GIR_EraseRootFromParent_Done,
     /*  150299 */   // Label 2703: @150299
     /*  150299 */   GIM_Reject,
     /*  150300 */ // Label 2701: @150300
     /*  150300 */ GIM_Reject,
     /*  150301 */ // Label 2518: @150301
     /*  150301 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(151911),
     /*  150306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150316 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(150385), // Rule ID 53236 //
     /*  150321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150364 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150383 */     GIR_RootConstrainSelectedInstOperands,
     /*  150384 */     // GIR_Coverage, 53236,
     /*  150384 */     GIR_EraseRootFromParent_Done,
     /*  150385 */   // Label 2705: @150385
     /*  150385 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(150454), // Rule ID 53237 //
     /*  150390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150433 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  150436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150452 */     GIR_RootConstrainSelectedInstOperands,
     /*  150453 */     // GIR_Coverage, 53237,
     /*  150453 */     GIR_EraseRootFromParent_Done,
     /*  150454 */   // Label 2706: @150454
     /*  150454 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(150523), // Rule ID 53238 //
     /*  150459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150502 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150521 */     GIR_RootConstrainSelectedInstOperands,
     /*  150522 */     // GIR_Coverage, 53238,
     /*  150522 */     GIR_EraseRootFromParent_Done,
     /*  150523 */   // Label 2707: @150523
     /*  150523 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(150592), // Rule ID 53239 //
     /*  150528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150571 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  150574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150590 */     GIR_RootConstrainSelectedInstOperands,
     /*  150591 */     // GIR_Coverage, 53239,
     /*  150591 */     GIR_EraseRootFromParent_Done,
     /*  150592 */   // Label 2708: @150592
     /*  150592 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(150658), // Rule ID 71784 //
     /*  150597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150639 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150656 */     GIR_RootConstrainSelectedInstOperands,
     /*  150657 */     // GIR_Coverage, 71784,
     /*  150657 */     GIR_EraseRootFromParent_Done,
     /*  150658 */   // Label 2709: @150658
     /*  150658 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(150724), // Rule ID 71785 //
     /*  150663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150705 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150722 */     GIR_RootConstrainSelectedInstOperands,
     /*  150723 */     // GIR_Coverage, 71785,
     /*  150723 */     GIR_EraseRootFromParent_Done,
     /*  150724 */   // Label 2710: @150724
     /*  150724 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(150790), // Rule ID 71782 //
     /*  150729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150771 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150788 */     GIR_RootConstrainSelectedInstOperands,
     /*  150789 */     // GIR_Coverage, 71782,
     /*  150789 */     GIR_EraseRootFromParent_Done,
     /*  150790 */   // Label 2711: @150790
     /*  150790 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(150856), // Rule ID 71783 //
     /*  150795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150837 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150854 */     GIR_RootConstrainSelectedInstOperands,
     /*  150855 */     // GIR_Coverage, 71783,
     /*  150855 */     GIR_EraseRootFromParent_Done,
     /*  150856 */   // Label 2712: @150856
     /*  150856 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(150925), // Rule ID 53240 //
     /*  150861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150904 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150923 */     GIR_RootConstrainSelectedInstOperands,
     /*  150924 */     // GIR_Coverage, 53240,
     /*  150924 */     GIR_EraseRootFromParent_Done,
     /*  150925 */   // Label 2713: @150925
     /*  150925 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(150994), // Rule ID 53241 //
     /*  150930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  150945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  150949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150973 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  150976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150992 */     GIR_RootConstrainSelectedInstOperands,
     /*  150993 */     // GIR_Coverage, 53241,
     /*  150993 */     GIR_EraseRootFromParent_Done,
     /*  150994 */   // Label 2714: @150994
     /*  150994 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(151063), // Rule ID 71778 //
     /*  150999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151042 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151061 */     GIR_RootConstrainSelectedInstOperands,
     /*  151062 */     // GIR_Coverage, 71778,
     /*  151062 */     GIR_EraseRootFromParent_Done,
     /*  151063 */   // Label 2715: @151063
     /*  151063 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(151132), // Rule ID 71779 //
     /*  151068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  151091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151111 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151130 */     GIR_RootConstrainSelectedInstOperands,
     /*  151131 */     // GIR_Coverage, 71779,
     /*  151131 */     GIR_EraseRootFromParent_Done,
     /*  151132 */   // Label 2716: @151132
     /*  151132 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(151201), // Rule ID 71780 //
     /*  151137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151180 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151199 */     GIR_RootConstrainSelectedInstOperands,
     /*  151200 */     // GIR_Coverage, 71780,
     /*  151200 */     GIR_EraseRootFromParent_Done,
     /*  151201 */   // Label 2717: @151201
     /*  151201 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(151270), // Rule ID 71781 //
     /*  151206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  151229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151249 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  151252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151268 */     GIR_RootConstrainSelectedInstOperands,
     /*  151269 */     // GIR_Coverage, 71781,
     /*  151269 */     GIR_EraseRootFromParent_Done,
     /*  151270 */   // Label 2718: @151270
     /*  151270 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(151339), // Rule ID 71786 //
     /*  151275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151318 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151337 */     GIR_RootConstrainSelectedInstOperands,
     /*  151338 */     // GIR_Coverage, 71786,
     /*  151338 */     GIR_EraseRootFromParent_Done,
     /*  151339 */   // Label 2719: @151339
     /*  151339 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(151408), // Rule ID 71787 //
     /*  151344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  151363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151387 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  151396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  151400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151406 */     GIR_RootConstrainSelectedInstOperands,
     /*  151407 */     // GIR_Coverage, 71787,
     /*  151407 */     GIR_EraseRootFromParent_Done,
     /*  151408 */   // Label 2720: @151408
     /*  151408 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(151474), // Rule ID 71790 //
     /*  151413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151455 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151472 */     GIR_RootConstrainSelectedInstOperands,
     /*  151473 */     // GIR_Coverage, 71790,
     /*  151473 */     GIR_EraseRootFromParent_Done,
     /*  151474 */   // Label 2721: @151474
     /*  151474 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(151540), // Rule ID 71791 //
     /*  151479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  151506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151521 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  151530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151538 */     GIR_RootConstrainSelectedInstOperands,
     /*  151539 */     // GIR_Coverage, 71791,
     /*  151539 */     GIR_EraseRootFromParent_Done,
     /*  151540 */   // Label 2722: @151540
     /*  151540 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(151606), // Rule ID 71788 //
     /*  151545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  151585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151587 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151604 */     GIR_RootConstrainSelectedInstOperands,
     /*  151605 */     // GIR_Coverage, 71788,
     /*  151605 */     GIR_EraseRootFromParent_Done,
     /*  151606 */   // Label 2723: @151606
     /*  151606 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(151672), // Rule ID 71789 //
     /*  151611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  151626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  151630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  151634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  151643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  151651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  151653 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  151656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  151662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  151664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151670 */     GIR_RootConstrainSelectedInstOperands,
     /*  151671 */     // GIR_Coverage, 71789,
     /*  151671 */     GIR_EraseRootFromParent_Done,
     /*  151672 */   // Label 2724: @151672
     /*  151672 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(151715), // Rule ID 71804 //
     /*  151677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151698 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151713 */     GIR_RootConstrainSelectedInstOperands,
     /*  151714 */     // GIR_Coverage, 71804,
     /*  151714 */     GIR_EraseRootFromParent_Done,
     /*  151715 */   // Label 2725: @151715
     /*  151715 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(151758), // Rule ID 71805 //
     /*  151720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  151727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151741 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  151750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151756 */     GIR_RootConstrainSelectedInstOperands,
     /*  151757 */     // GIR_Coverage, 71805,
     /*  151757 */     GIR_EraseRootFromParent_Done,
     /*  151758 */   // Label 2726: @151758
     /*  151758 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(151801), // Rule ID 53246 //
     /*  151763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  151782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151784 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151799 */     GIR_RootConstrainSelectedInstOperands,
     /*  151800 */     // GIR_Coverage, 53246,
     /*  151800 */     GIR_EraseRootFromParent_Done,
     /*  151801 */   // Label 2727: @151801
     /*  151801 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(151844), // Rule ID 53247 //
     /*  151806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  151817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  151821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  151825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151827 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  151830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151842 */     GIR_RootConstrainSelectedInstOperands,
     /*  151843 */     // GIR_Coverage, 53247,
     /*  151843 */     GIR_EraseRootFromParent_Done,
     /*  151844 */   // Label 2728: @151844
     /*  151844 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(151877), // Rule ID 53234 //
     /*  151849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151860 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  151863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151875 */     GIR_RootConstrainSelectedInstOperands,
     /*  151876 */     // GIR_Coverage, 53234,
     /*  151876 */     GIR_EraseRootFromParent_Done,
     /*  151877 */   // Label 2729: @151877
     /*  151877 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(151910), // Rule ID 53235 //
     /*  151882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151893 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  151896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151908 */     GIR_RootConstrainSelectedInstOperands,
     /*  151909 */     // GIR_Coverage, 53235,
     /*  151909 */     GIR_EraseRootFromParent_Done,
     /*  151910 */   // Label 2730: @151910
     /*  151910 */   GIM_Reject,
     /*  151911 */ // Label 2704: @151911
     /*  151911 */ GIM_Reject,
     /*  151912 */ // Label 2519: @151912
     /*  151912 */ GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(152026),
     /*  151917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  151920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  151923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  151935 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(151980), // Rule ID 47954 //
     /*  151940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151943 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  151943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  151946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  151960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151978 */     GIR_RootConstrainSelectedInstOperands,
     /*  151979 */     // GIR_Coverage, 47954,
     /*  151979 */     GIR_EraseRootFromParent_Done,
     /*  151980 */   // Label 2732: @151980
     /*  151980 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(152025), // Rule ID 47955 //
     /*  151985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151988 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  151988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  151991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  152005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152023 */     GIR_RootConstrainSelectedInstOperands,
     /*  152024 */     // GIR_Coverage, 47955,
     /*  152024 */     GIR_EraseRootFromParent_Done,
     /*  152025 */   // Label 2733: @152025
     /*  152025 */   GIM_Reject,
     /*  152026 */ // Label 2731: @152026
     /*  152026 */ GIM_Reject,
     /*  152027 */ // Label 2520: @152027
     /*  152027 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(152141),
     /*  152032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  152035 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  152038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  152050 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(152095), // Rule ID 47970 //
     /*  152055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152058 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  152058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  152061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  152075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152093 */     GIR_RootConstrainSelectedInstOperands,
     /*  152094 */     // GIR_Coverage, 47970,
     /*  152094 */     GIR_EraseRootFromParent_Done,
     /*  152095 */   // Label 2735: @152095
     /*  152095 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(152140), // Rule ID 47971 //
     /*  152100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152103 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  152103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  152106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  152120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152138 */     GIR_RootConstrainSelectedInstOperands,
     /*  152139 */     // GIR_Coverage, 47971,
     /*  152139 */     GIR_EraseRootFromParent_Done,
     /*  152140 */   // Label 2736: @152140
     /*  152140 */   GIM_Reject,
     /*  152141 */ // Label 2734: @152141
     /*  152141 */ GIM_Reject,
     /*  152142 */ // Label 2521: @152142
     /*  152142 */ GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(152256),
     /*  152147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  152150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  152153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  152165 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(152210), // Rule ID 47986 //
     /*  152170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152173 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  152173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  152176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  152190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152208 */     GIR_RootConstrainSelectedInstOperands,
     /*  152209 */     // GIR_Coverage, 47986,
     /*  152209 */     GIR_EraseRootFromParent_Done,
     /*  152210 */   // Label 2738: @152210
     /*  152210 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(152255), // Rule ID 47987 //
     /*  152215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152218 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  152218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  152221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  152225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  152230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  152232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  152235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  152240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  152250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  152253 */     GIR_RootConstrainSelectedInstOperands,
     /*  152254 */     // GIR_Coverage, 47987,
     /*  152254 */     GIR_EraseRootFromParent_Done,
     /*  152255 */   // Label 2739: @152255
     /*  152255 */   GIM_Reject,
     /*  152256 */ // Label 2737: @152256
     /*  152256 */ GIM_Reject,
     /*  152257 */ // Label 2522: @152257
     /*  152257 */ GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(153867),
     /*  152262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152272 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(152341), // Rule ID 53254 //
     /*  152277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152320 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152339 */     GIR_RootConstrainSelectedInstOperands,
     /*  152340 */     // GIR_Coverage, 53254,
     /*  152340 */     GIR_EraseRootFromParent_Done,
     /*  152341 */   // Label 2741: @152341
     /*  152341 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(152410), // Rule ID 53255 //
     /*  152346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152389 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  152392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152408 */     GIR_RootConstrainSelectedInstOperands,
     /*  152409 */     // GIR_Coverage, 53255,
     /*  152409 */     GIR_EraseRootFromParent_Done,
     /*  152410 */   // Label 2742: @152410
     /*  152410 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(152479), // Rule ID 53256 //
     /*  152415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152458 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152477 */     GIR_RootConstrainSelectedInstOperands,
     /*  152478 */     // GIR_Coverage, 53256,
     /*  152478 */     GIR_EraseRootFromParent_Done,
     /*  152479 */   // Label 2743: @152479
     /*  152479 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(152548), // Rule ID 53257 //
     /*  152484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  152495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152527 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  152530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152546 */     GIR_RootConstrainSelectedInstOperands,
     /*  152547 */     // GIR_Coverage, 53257,
     /*  152547 */     GIR_EraseRootFromParent_Done,
     /*  152548 */   // Label 2744: @152548
     /*  152548 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(152614), // Rule ID 71812 //
     /*  152553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152595 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152612 */     GIR_RootConstrainSelectedInstOperands,
     /*  152613 */     // GIR_Coverage, 71812,
     /*  152613 */     GIR_EraseRootFromParent_Done,
     /*  152614 */   // Label 2745: @152614
     /*  152614 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(152680), // Rule ID 71813 //
     /*  152619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  152642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152661 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  152670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152678 */     GIR_RootConstrainSelectedInstOperands,
     /*  152679 */     // GIR_Coverage, 71813,
     /*  152679 */     GIR_EraseRootFromParent_Done,
     /*  152680 */   // Label 2746: @152680
     /*  152680 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(152746), // Rule ID 71810 //
     /*  152685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152725 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152727 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152744 */     GIR_RootConstrainSelectedInstOperands,
     /*  152745 */     // GIR_Coverage, 71810,
     /*  152745 */     GIR_EraseRootFromParent_Done,
     /*  152746 */   // Label 2747: @152746
     /*  152746 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(152812), // Rule ID 71811 //
     /*  152751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  152779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152783 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152793 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  152804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152810 */     GIR_RootConstrainSelectedInstOperands,
     /*  152811 */     // GIR_Coverage, 71811,
     /*  152811 */     GIR_EraseRootFromParent_Done,
     /*  152812 */   // Label 2748: @152812
     /*  152812 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(152881), // Rule ID 53258 //
     /*  152817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152854 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  152858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152860 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152879 */     GIR_RootConstrainSelectedInstOperands,
     /*  152880 */     // GIR_Coverage, 53258,
     /*  152880 */     GIR_EraseRootFromParent_Done,
     /*  152881 */   // Label 2749: @152881
     /*  152881 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(152950), // Rule ID 53259 //
     /*  152886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  152889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  152897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  152927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152929 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  152929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  152932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  152938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  152942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  152945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  152948 */     GIR_RootConstrainSelectedInstOperands,
     /*  152949 */     // GIR_Coverage, 53259,
     /*  152949 */     GIR_EraseRootFromParent_Done,
     /*  152950 */   // Label 2750: @152950
     /*  152950 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(153019), // Rule ID 71806 //
     /*  152955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  152958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  152962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  152966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  152970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  152974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  152978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  152982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  152986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  152996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  152998 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  152998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153017 */     GIR_RootConstrainSelectedInstOperands,
     /*  153018 */     // GIR_Coverage, 71806,
     /*  153018 */     GIR_EraseRootFromParent_Done,
     /*  153019 */   // Label 2751: @153019
     /*  153019 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(153088), // Rule ID 71807 //
     /*  153024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  153047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153067 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153086 */     GIR_RootConstrainSelectedInstOperands,
     /*  153087 */     // GIR_Coverage, 71807,
     /*  153087 */     GIR_EraseRootFromParent_Done,
     /*  153088 */   // Label 2752: @153088
     /*  153088 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(153157), // Rule ID 71808 //
     /*  153093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153136 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  153139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153155 */     GIR_RootConstrainSelectedInstOperands,
     /*  153156 */     // GIR_Coverage, 71808,
     /*  153156 */     GIR_EraseRootFromParent_Done,
     /*  153157 */   // Label 2753: @153157
     /*  153157 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(153226), // Rule ID 71809 //
     /*  153162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  153185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153205 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  153208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153224 */     GIR_RootConstrainSelectedInstOperands,
     /*  153225 */     // GIR_Coverage, 71809,
     /*  153225 */     GIR_EraseRootFromParent_Done,
     /*  153226 */   // Label 2754: @153226
     /*  153226 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(153295), // Rule ID 71814 //
     /*  153231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153274 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153293 */     GIR_RootConstrainSelectedInstOperands,
     /*  153294 */     // GIR_Coverage, 71814,
     /*  153294 */     GIR_EraseRootFromParent_Done,
     /*  153295 */   // Label 2755: @153295
     /*  153295 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(153364), // Rule ID 71815 //
     /*  153300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  153319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153343 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  153352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  153356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153362 */     GIR_RootConstrainSelectedInstOperands,
     /*  153363 */     // GIR_Coverage, 71815,
     /*  153363 */     GIR_EraseRootFromParent_Done,
     /*  153364 */   // Label 2756: @153364
     /*  153364 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(153430), // Rule ID 71818 //
     /*  153369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153411 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153428 */     GIR_RootConstrainSelectedInstOperands,
     /*  153429 */     // GIR_Coverage, 71818,
     /*  153429 */     GIR_EraseRootFromParent_Done,
     /*  153430 */   // Label 2757: @153430
     /*  153430 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(153496), // Rule ID 71819 //
     /*  153435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  153462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153477 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  153486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153494 */     GIR_RootConstrainSelectedInstOperands,
     /*  153495 */     // GIR_Coverage, 71819,
     /*  153495 */     GIR_EraseRootFromParent_Done,
     /*  153496 */   // Label 2758: @153496
     /*  153496 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(153562), // Rule ID 71816 //
     /*  153501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  153541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153543 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153560 */     GIR_RootConstrainSelectedInstOperands,
     /*  153561 */     // GIR_Coverage, 71816,
     /*  153561 */     GIR_EraseRootFromParent_Done,
     /*  153562 */   // Label 2759: @153562
     /*  153562 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(153628), // Rule ID 71817 //
     /*  153567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  153582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  153586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  153590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  153599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  153607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  153609 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  153612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  153618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  153620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153626 */     GIR_RootConstrainSelectedInstOperands,
     /*  153627 */     // GIR_Coverage, 71817,
     /*  153627 */     GIR_EraseRootFromParent_Done,
     /*  153628 */   // Label 2760: @153628
     /*  153628 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(153671), // Rule ID 71832 //
     /*  153633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153654 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153669 */     GIR_RootConstrainSelectedInstOperands,
     /*  153670 */     // GIR_Coverage, 71832,
     /*  153670 */     GIR_EraseRootFromParent_Done,
     /*  153671 */   // Label 2761: @153671
     /*  153671 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(153714), // Rule ID 71833 //
     /*  153676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  153683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153697 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  153706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153712 */     GIR_RootConstrainSelectedInstOperands,
     /*  153713 */     // GIR_Coverage, 71833,
     /*  153713 */     GIR_EraseRootFromParent_Done,
     /*  153714 */   // Label 2762: @153714
     /*  153714 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(153757), // Rule ID 53264 //
     /*  153719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  153738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153740 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153755 */     GIR_RootConstrainSelectedInstOperands,
     /*  153756 */     // GIR_Coverage, 53264,
     /*  153756 */     GIR_EraseRootFromParent_Done,
     /*  153757 */   // Label 2763: @153757
     /*  153757 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(153800), // Rule ID 53265 //
     /*  153762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  153773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  153777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  153781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  153783 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  153786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  153792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153798 */     GIR_RootConstrainSelectedInstOperands,
     /*  153799 */     // GIR_Coverage, 53265,
     /*  153799 */     GIR_EraseRootFromParent_Done,
     /*  153800 */   // Label 2764: @153800
     /*  153800 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(153833), // Rule ID 53252 //
     /*  153805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153816 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  153816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  153819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153831 */     GIR_RootConstrainSelectedInstOperands,
     /*  153832 */     // GIR_Coverage, 53252,
     /*  153832 */     GIR_EraseRootFromParent_Done,
     /*  153833 */   // Label 2765: @153833
     /*  153833 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(153866), // Rule ID 53253 //
     /*  153838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  153849 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  153849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  153852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153864 */     GIR_RootConstrainSelectedInstOperands,
     /*  153865 */     // GIR_Coverage, 53253,
     /*  153865 */     GIR_EraseRootFromParent_Done,
     /*  153866 */   // Label 2766: @153866
     /*  153866 */   GIM_Reject,
     /*  153867 */ // Label 2740: @153867
     /*  153867 */ GIM_Reject,
     /*  153868 */ // Label 2523: @153868
     /*  153868 */ GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(153982),
     /*  153873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  153876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  153879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  153891 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(153936), // Rule ID 47958 //
     /*  153896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  153899 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  153899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  153902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  153916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153934 */     GIR_RootConstrainSelectedInstOperands,
     /*  153935 */     // GIR_Coverage, 47958,
     /*  153935 */     GIR_EraseRootFromParent_Done,
     /*  153936 */   // Label 2768: @153936
     /*  153936 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(153981), // Rule ID 47959 //
     /*  153941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  153944 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  153944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  153947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  153951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  153956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  153958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  153961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  153966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  153970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  153973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  153979 */     GIR_RootConstrainSelectedInstOperands,
     /*  153980 */     // GIR_Coverage, 47959,
     /*  153980 */     GIR_EraseRootFromParent_Done,
     /*  153981 */   // Label 2769: @153981
     /*  153981 */   GIM_Reject,
     /*  153982 */ // Label 2767: @153982
     /*  153982 */ GIM_Reject,
     /*  153983 */ // Label 2524: @153983
     /*  153983 */ GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(154097),
     /*  153988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  153991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  153994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  153998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154002 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  154006 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(154051), // Rule ID 47974 //
     /*  154011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154014 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  154014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  154017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  154031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154049 */     GIR_RootConstrainSelectedInstOperands,
     /*  154050 */     // GIR_Coverage, 47974,
     /*  154050 */     GIR_EraseRootFromParent_Done,
     /*  154051 */   // Label 2771: @154051
     /*  154051 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(154096), // Rule ID 47975 //
     /*  154056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154059 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  154059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  154062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  154066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  154071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  154073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  154076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  154081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  154083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  154091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  154094 */     GIR_RootConstrainSelectedInstOperands,
     /*  154095 */     // GIR_Coverage, 47975,
     /*  154095 */     GIR_EraseRootFromParent_Done,
     /*  154096 */   // Label 2772: @154096
     /*  154096 */   GIM_Reject,
     /*  154097 */ // Label 2770: @154097
     /*  154097 */ GIM_Reject,
     /*  154098 */ // Label 2525: @154098
     /*  154098 */ GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(155708),
     /*  154103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154113 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(154182), // Rule ID 53272 //
     /*  154118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154161 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154180 */     GIR_RootConstrainSelectedInstOperands,
     /*  154181 */     // GIR_Coverage, 53272,
     /*  154181 */     GIR_EraseRootFromParent_Done,
     /*  154182 */   // Label 2774: @154182
     /*  154182 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(154251), // Rule ID 53273 //
     /*  154187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154230 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154249 */     GIR_RootConstrainSelectedInstOperands,
     /*  154250 */     // GIR_Coverage, 53273,
     /*  154250 */     GIR_EraseRootFromParent_Done,
     /*  154251 */   // Label 2775: @154251
     /*  154251 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(154320), // Rule ID 53274 //
     /*  154256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154299 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154318 */     GIR_RootConstrainSelectedInstOperands,
     /*  154319 */     // GIR_Coverage, 53274,
     /*  154319 */     GIR_EraseRootFromParent_Done,
     /*  154320 */   // Label 2776: @154320
     /*  154320 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(154389), // Rule ID 53275 //
     /*  154325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154368 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154387 */     GIR_RootConstrainSelectedInstOperands,
     /*  154388 */     // GIR_Coverage, 53275,
     /*  154388 */     GIR_EraseRootFromParent_Done,
     /*  154389 */   // Label 2777: @154389
     /*  154389 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(154455), // Rule ID 71840 //
     /*  154394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154436 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154453 */     GIR_RootConstrainSelectedInstOperands,
     /*  154454 */     // GIR_Coverage, 71840,
     /*  154454 */     GIR_EraseRootFromParent_Done,
     /*  154455 */   // Label 2778: @154455
     /*  154455 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(154521), // Rule ID 71841 //
     /*  154460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154500 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154502 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154519 */     GIR_RootConstrainSelectedInstOperands,
     /*  154520 */     // GIR_Coverage, 71841,
     /*  154520 */     GIR_EraseRootFromParent_Done,
     /*  154521 */   // Label 2779: @154521
     /*  154521 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(154587), // Rule ID 71838 //
     /*  154526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154568 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154585 */     GIR_RootConstrainSelectedInstOperands,
     /*  154586 */     // GIR_Coverage, 71838,
     /*  154586 */     GIR_EraseRootFromParent_Done,
     /*  154587 */   // Label 2780: @154587
     /*  154587 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(154653), // Rule ID 71839 //
     /*  154592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154634 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  154645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154651 */     GIR_RootConstrainSelectedInstOperands,
     /*  154652 */     // GIR_Coverage, 71839,
     /*  154652 */     GIR_EraseRootFromParent_Done,
     /*  154653 */   // Label 2781: @154653
     /*  154653 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(154722), // Rule ID 53276 //
     /*  154658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  154699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154701 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154720 */     GIR_RootConstrainSelectedInstOperands,
     /*  154721 */     // GIR_Coverage, 53276,
     /*  154721 */     GIR_EraseRootFromParent_Done,
     /*  154722 */   // Label 2782: @154722
     /*  154722 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(154791), // Rule ID 53277 //
     /*  154727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  154738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154770 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  154773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  154783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154789 */     GIR_RootConstrainSelectedInstOperands,
     /*  154790 */     // GIR_Coverage, 53277,
     /*  154790 */     GIR_EraseRootFromParent_Done,
     /*  154791 */   // Label 2783: @154791
     /*  154791 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(154860), // Rule ID 71834 //
     /*  154796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154839 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154858 */     GIR_RootConstrainSelectedInstOperands,
     /*  154859 */     // GIR_Coverage, 71834,
     /*  154859 */     GIR_EraseRootFromParent_Done,
     /*  154860 */   // Label 2784: @154860
     /*  154860 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(154929), // Rule ID 71835 //
     /*  154865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  154868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  154888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154892 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154896 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154908 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  154908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  154911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154927 */     GIR_RootConstrainSelectedInstOperands,
     /*  154928 */     // GIR_Coverage, 71835,
     /*  154928 */     GIR_EraseRootFromParent_Done,
     /*  154929 */   // Label 2785: @154929
     /*  154929 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(154998), // Rule ID 71836 //
     /*  154934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  154937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  154945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  154949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  154953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  154957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  154961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  154965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  154975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  154977 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  154977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  154980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  154986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  154990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  154993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  154996 */     GIR_RootConstrainSelectedInstOperands,
     /*  154997 */     // GIR_Coverage, 71836,
     /*  154997 */     GIR_EraseRootFromParent_Done,
     /*  154998 */   // Label 2786: @154998
     /*  154998 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(155067), // Rule ID 71837 //
     /*  155003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  155026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155039 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155046 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  155049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155065 */     GIR_RootConstrainSelectedInstOperands,
     /*  155066 */     // GIR_Coverage, 71837,
     /*  155066 */     GIR_EraseRootFromParent_Done,
     /*  155067 */   // Label 2787: @155067
     /*  155067 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155136), // Rule ID 71842 //
     /*  155072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155108 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155115 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155134 */     GIR_RootConstrainSelectedInstOperands,
     /*  155135 */     // GIR_Coverage, 71842,
     /*  155135 */     GIR_EraseRootFromParent_Done,
     /*  155136 */   // Label 2788: @155136
     /*  155136 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155205), // Rule ID 71843 //
     /*  155141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  155160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155184 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  155193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  155197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155203 */     GIR_RootConstrainSelectedInstOperands,
     /*  155204 */     // GIR_Coverage, 71843,
     /*  155204 */     GIR_EraseRootFromParent_Done,
     /*  155205 */   // Label 2789: @155205
     /*  155205 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(155271), // Rule ID 71846 //
     /*  155210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  155237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155241 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155252 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  155261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155269 */     GIR_RootConstrainSelectedInstOperands,
     /*  155270 */     // GIR_Coverage, 71846,
     /*  155270 */     GIR_EraseRootFromParent_Done,
     /*  155271 */   // Label 2790: @155271
     /*  155271 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(155337), // Rule ID 71847 //
     /*  155276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  155303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155318 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  155327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155335 */     GIR_RootConstrainSelectedInstOperands,
     /*  155336 */     // GIR_Coverage, 71847,
     /*  155336 */     GIR_EraseRootFromParent_Done,
     /*  155337 */   // Label 2791: @155337
     /*  155337 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(155403), // Rule ID 71844 //
     /*  155342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  155382 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155384 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155401 */     GIR_RootConstrainSelectedInstOperands,
     /*  155402 */     // GIR_Coverage, 71844,
     /*  155402 */     GIR_EraseRootFromParent_Done,
     /*  155403 */   // Label 2792: @155403
     /*  155403 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(155469), // Rule ID 71845 //
     /*  155408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  155423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  155427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  155431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  155450 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  155453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  155461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155467 */     GIR_RootConstrainSelectedInstOperands,
     /*  155468 */     // GIR_Coverage, 71845,
     /*  155468 */     GIR_EraseRootFromParent_Done,
     /*  155469 */   // Label 2793: @155469
     /*  155469 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(155512), // Rule ID 71860 //
     /*  155474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155495 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155510 */     GIR_RootConstrainSelectedInstOperands,
     /*  155511 */     // GIR_Coverage, 71860,
     /*  155511 */     GIR_EraseRootFromParent_Done,
     /*  155512 */   // Label 2794: @155512
     /*  155512 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(155555), // Rule ID 71861 //
     /*  155517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155538 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  155547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155553 */     GIR_RootConstrainSelectedInstOperands,
     /*  155554 */     // GIR_Coverage, 71861,
     /*  155554 */     GIR_EraseRootFromParent_Done,
     /*  155555 */   // Label 2795: @155555
     /*  155555 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(155598), // Rule ID 53282 //
     /*  155560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  155579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155581 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155596 */     GIR_RootConstrainSelectedInstOperands,
     /*  155597 */     // GIR_Coverage, 53282,
     /*  155597 */     GIR_EraseRootFromParent_Done,
     /*  155598 */   // Label 2796: @155598
     /*  155598 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(155641), // Rule ID 53283 //
     /*  155603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  155614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  155618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  155624 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  155627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  155633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155639 */     GIR_RootConstrainSelectedInstOperands,
     /*  155640 */     // GIR_Coverage, 53283,
     /*  155640 */     GIR_EraseRootFromParent_Done,
     /*  155641 */   // Label 2797: @155641
     /*  155641 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(155674), // Rule ID 53270 //
     /*  155646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155657 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  155657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  155660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155672 */     GIR_RootConstrainSelectedInstOperands,
     /*  155673 */     // GIR_Coverage, 53270,
     /*  155673 */     GIR_EraseRootFromParent_Done,
     /*  155674 */   // Label 2798: @155674
     /*  155674 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(155707), // Rule ID 53271 //
     /*  155679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  155690 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  155690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  155693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155705 */     GIR_RootConstrainSelectedInstOperands,
     /*  155706 */     // GIR_Coverage, 53271,
     /*  155706 */     GIR_EraseRootFromParent_Done,
     /*  155707 */   // Label 2799: @155707
     /*  155707 */   GIM_Reject,
     /*  155708 */ // Label 2773: @155708
     /*  155708 */ GIM_Reject,
     /*  155709 */ // Label 2526: @155709
     /*  155709 */ GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(155823),
     /*  155714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  155717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  155720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  155732 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(155777), // Rule ID 47962 //
     /*  155737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  155740 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  155740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  155743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  155757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155775 */     GIR_RootConstrainSelectedInstOperands,
     /*  155776 */     // GIR_Coverage, 47962,
     /*  155776 */     GIR_EraseRootFromParent_Done,
     /*  155777 */   // Label 2801: @155777
     /*  155777 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(155822), // Rule ID 47963 //
     /*  155782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  155785 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  155785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  155788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  155792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  155797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  155799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  155802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  155807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  155809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  155811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  155814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  155820 */     GIR_RootConstrainSelectedInstOperands,
     /*  155821 */     // GIR_Coverage, 47963,
     /*  155821 */     GIR_EraseRootFromParent_Done,
     /*  155822 */   // Label 2802: @155822
     /*  155822 */   GIM_Reject,
     /*  155823 */ // Label 2800: @155823
     /*  155823 */ GIM_Reject,
     /*  155824 */ // Label 2527: @155824
     /*  155824 */ GIM_Reject,
     /*  155825 */ // Label 10: @155825
     /*  155825 */ GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(155885),
     /*  155830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  155834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155838 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(155861), // Rule ID 116 //
     /*  155843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  155846 */     // MIs[0] Operand 1
     /*  155846 */     // No operand predicates
     /*  155846 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i64] })
     /*  155846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  155849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155851 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  155856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155859 */     GIR_RootConstrainSelectedInstOperands,
     /*  155860 */     // GIR_Coverage, 116,
     /*  155860 */     GIR_EraseRootFromParent_Done,
     /*  155861 */   // Label 2804: @155861
     /*  155861 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(155884), // Rule ID 117 //
     /*  155866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  155869 */     // MIs[0] Operand 1
     /*  155869 */     // No operand predicates
     /*  155869 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i32] })
     /*  155869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  155872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155874 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  155879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  155882 */     GIR_RootConstrainSelectedInstOperands,
     /*  155883 */     // GIR_Coverage, 117,
     /*  155883 */     GIR_EraseRootFromParent_Done,
     /*  155884 */   // Label 2805: @155884
     /*  155884 */   GIM_Reject,
     /*  155885 */ // Label 2803: @155885
     /*  155885 */ GIM_Reject,
     /*  155886 */ // Label 11: @155886
     /*  155886 */ GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(155946),
     /*  155891 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  155894 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  155897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  155903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155915 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(155930), // Rule ID 56 //
     /*  155920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  155923 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  155923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  155928 */     GIR_RootConstrainSelectedInstOperands,
     /*  155929 */     // GIR_Coverage, 56,
     /*  155929 */     GIR_Done,
     /*  155930 */   // Label 2807: @155930
     /*  155930 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(155945), // Rule ID 57 //
     /*  155935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  155938 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  155938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  155943 */     GIR_RootConstrainSelectedInstOperands,
     /*  155944 */     // GIR_Coverage, 57,
     /*  155944 */     GIR_Done,
     /*  155945 */   // Label 2808: @155945
     /*  155945 */   GIM_Reject,
     /*  155946 */ // Label 2806: @155946
     /*  155946 */ GIM_Reject,
     /*  155947 */ // Label 12: @155947
     /*  155947 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(156037),
     /*  155952 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  155955 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  155958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  155961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  155964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  155968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155976 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(155991), // Rule ID 54 //
     /*  155981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  155984 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  155984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  155989 */     GIR_RootConstrainSelectedInstOperands,
     /*  155990 */     // GIR_Coverage, 54,
     /*  155990 */     GIR_Done,
     /*  155991 */   // Label 2810: @155991
     /*  155991 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(156006), // Rule ID 55 //
     /*  155996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  155999 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  155999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  156004 */     GIR_RootConstrainSelectedInstOperands,
     /*  156005 */     // GIR_Coverage, 55,
     /*  156005 */     GIR_Done,
     /*  156006 */   // Label 2811: @156006
     /*  156006 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(156021), // Rule ID 2400 //
     /*  156011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0),
     /*  156014 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  156014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  156019 */     GIR_RootConstrainSelectedInstOperands,
     /*  156020 */     // GIR_Coverage, 2400,
     /*  156020 */     GIR_Done,
     /*  156021 */   // Label 2812: @156021
     /*  156021 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(156036), // Rule ID 2401 //
     /*  156026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1),
     /*  156029 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  156029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  156034 */     GIR_RootConstrainSelectedInstOperands,
     /*  156035 */     // GIR_Coverage, 2401,
     /*  156035 */     GIR_Done,
     /*  156036 */   // Label 2813: @156036
     /*  156036 */   GIM_Reject,
     /*  156037 */ // Label 2809: @156037
     /*  156037 */ GIM_Reject,
     /*  156038 */ // Label 13: @156038
     /*  156038 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2816*/ GIMT_Encode4(156404),
     /*  156049 */ /*GILLT_s32*//*Label 2814*/ GIMT_Encode4(156057),
     /*  156053 */ /*GILLT_s64*//*Label 2815*/ GIMT_Encode4(156294),
     /*  156057 */ // Label 2814: @156057
     /*  156057 */ GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(156293),
     /*  156062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156065 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(156088), // Rule ID 1443 //
     /*  156070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156081 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  156081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  156086 */     GIR_RootConstrainSelectedInstOperands,
     /*  156087 */     // GIR_Coverage, 1443,
     /*  156087 */     GIR_Done,
     /*  156088 */   // Label 2818: @156088
     /*  156088 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(156111), // Rule ID 1444 //
     /*  156093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156104 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  156104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  156109 */     GIR_RootConstrainSelectedInstOperands,
     /*  156110 */     // GIR_Coverage, 1444,
     /*  156110 */     GIR_Done,
     /*  156111 */   // Label 2819: @156111
     /*  156111 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(156134), // Rule ID 1445 //
     /*  156116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156127 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  156127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  156132 */     GIR_RootConstrainSelectedInstOperands,
     /*  156133 */     // GIR_Coverage, 1445,
     /*  156133 */     GIR_Done,
     /*  156134 */   // Label 2820: @156134
     /*  156134 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(156157), // Rule ID 1446 //
     /*  156139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156150 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  156150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  156155 */     GIR_RootConstrainSelectedInstOperands,
     /*  156156 */     // GIR_Coverage, 1446,
     /*  156156 */     GIR_Done,
     /*  156157 */   // Label 2821: @156157
     /*  156157 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(156195), // Rule ID 1447 //
     /*  156162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  156165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156173 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  156173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156178 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  156184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156194 */     // GIR_Coverage, 1447,
     /*  156194 */     GIR_EraseRootFromParent_Done,
     /*  156195 */   // Label 2822: @156195
     /*  156195 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(156233), // Rule ID 1448 //
     /*  156200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156211 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  156211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156216 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  156222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156232 */     // GIR_Coverage, 1448,
     /*  156232 */     GIR_EraseRootFromParent_Done,
     /*  156233 */   // Label 2823: @156233
     /*  156233 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(156292), // Rule ID 1449 //
     /*  156238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156249 */     // (bitconvert:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), FPR32INX:{ *:[f32] }:$rs1, sub_32:{ *:[i32] })
     /*  156249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  156252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  156256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  156261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  156263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  156266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  156268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  156271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  156276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156291 */     // GIR_Coverage, 1449,
     /*  156291 */     GIR_EraseRootFromParent_Done,
     /*  156292 */   // Label 2824: @156292
     /*  156292 */   GIM_Reject,
     /*  156293 */ // Label 2817: @156293
     /*  156293 */ GIM_Reject,
     /*  156294 */ // Label 2815: @156294
     /*  156294 */ GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(156403),
     /*  156299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156302 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(156325), // Rule ID 1896 //
     /*  156307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156318 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FMV_D_X:{ *:[f64] } GPR:{ *:[i64] }:$rs1)
     /*  156318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_D_X),
     /*  156323 */     GIR_RootConstrainSelectedInstOperands,
     /*  156324 */     // GIR_Coverage, 1896,
     /*  156324 */     GIR_Done,
     /*  156325 */   // Label 2826: @156325
     /*  156325 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(156348), // Rule ID 1897 //
     /*  156330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  156333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156341 */     // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMV_X_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)
     /*  156341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_D),
     /*  156346 */     GIR_RootConstrainSelectedInstOperands,
     /*  156347 */     // GIR_Coverage, 1897,
     /*  156347 */     GIR_Done,
     /*  156348 */   // Label 2827: @156348
     /*  156348 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(156375), // Rule ID 1924 //
     /*  156353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156364 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i32] })
     /*  156364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156374 */     // GIR_Coverage, 1924,
     /*  156374 */     GIR_Done,
     /*  156375 */   // Label 2828: @156375
     /*  156375 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(156402), // Rule ID 1925 //
     /*  156380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  156383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156391 */     // (bitconvert:{ *:[i64] } GPR:{ *:[f64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[i64] } GPR:{ *:[f64] }:$rs1, GPR:{ *:[i32] })
     /*  156391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  156396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156401 */     // GIR_Coverage, 1925,
     /*  156401 */     GIR_Done,
     /*  156402 */   // Label 2829: @156402
     /*  156402 */   GIM_Reject,
     /*  156403 */ // Label 2825: @156403
     /*  156403 */ GIM_Reject,
     /*  156404 */ // Label 2816: @156404
     /*  156404 */ GIM_Reject,
     /*  156405 */ // Label 14: @156405
     /*  156405 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2833*/ GIMT_Encode4(156602),
     /*  156416 */ /*GILLT_s16*//*Label 2830*/ GIMT_Encode4(156428),
     /*  156420 */ /*GILLT_s32*//*Label 2831*/ GIMT_Encode4(156486),
     /*  156424 */ /*GILLT_s64*//*Label 2832*/ GIMT_Encode4(156544),
     /*  156428 */ // Label 2830: @156428
     /*  156428 */ GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(156485),
     /*  156433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156444 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(156464), // Rule ID 2432 //
     /*  156449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  156452 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /*  156452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156462 */     GIR_RootConstrainSelectedInstOperands,
     /*  156463 */     // GIR_Coverage, 2432,
     /*  156463 */     GIR_EraseRootFromParent_Done,
     /*  156464 */   // Label 2835: @156464
     /*  156464 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(156484), // Rule ID 2433 //
     /*  156469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  156472 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /*  156472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156482 */     GIR_RootConstrainSelectedInstOperands,
     /*  156483 */     // GIR_Coverage, 2433,
     /*  156483 */     GIR_EraseRootFromParent_Done,
     /*  156484 */   // Label 2836: @156484
     /*  156484 */   GIM_Reject,
     /*  156485 */ // Label 2834: @156485
     /*  156485 */ GIM_Reject,
     /*  156486 */ // Label 2831: @156486
     /*  156486 */ GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(156543),
     /*  156491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156502 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(156522), // Rule ID 2350 //
     /*  156507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156510 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /*  156510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156520 */     GIR_RootConstrainSelectedInstOperands,
     /*  156521 */     // GIR_Coverage, 2350,
     /*  156521 */     GIR_EraseRootFromParent_Done,
     /*  156522 */   // Label 2838: @156522
     /*  156522 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(156542), // Rule ID 2351 //
     /*  156527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  156530 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /*  156530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156540 */     GIR_RootConstrainSelectedInstOperands,
     /*  156541 */     // GIR_Coverage, 2351,
     /*  156541 */     GIR_EraseRootFromParent_Done,
     /*  156542 */   // Label 2839: @156542
     /*  156542 */   GIM_Reject,
     /*  156543 */ // Label 2837: @156543
     /*  156543 */ GIM_Reject,
     /*  156544 */ // Label 2832: @156544
     /*  156544 */ GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(156601),
     /*  156549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156560 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(156580), // Rule ID 2390 //
     /*  156565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  156568 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /*  156568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156578 */     GIR_RootConstrainSelectedInstOperands,
     /*  156579 */     // GIR_Coverage, 2390,
     /*  156579 */     GIR_EraseRootFromParent_Done,
     /*  156580 */   // Label 2841: @156580
     /*  156580 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(156600), // Rule ID 2391 //
     /*  156585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  156588 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /*  156588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  156598 */     GIR_RootConstrainSelectedInstOperands,
     /*  156599 */     // GIR_Coverage, 2391,
     /*  156599 */     GIR_EraseRootFromParent_Done,
     /*  156600 */   // Label 2842: @156600
     /*  156600 */   GIM_Reject,
     /*  156601 */ // Label 2840: @156601
     /*  156601 */ GIM_Reject,
     /*  156602 */ // Label 2833: @156602
     /*  156602 */ GIM_Reject,
     /*  156603 */ // Label 15: @156603
     /*  156603 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2846*/ GIMT_Encode4(156800),
     /*  156614 */ /*GILLT_s16*//*Label 2843*/ GIMT_Encode4(156626),
     /*  156618 */ /*GILLT_s32*//*Label 2844*/ GIMT_Encode4(156684),
     /*  156622 */ /*GILLT_s64*//*Label 2845*/ GIMT_Encode4(156742),
     /*  156626 */ // Label 2843: @156626
     /*  156626 */ GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(156683),
     /*  156631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  156634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  156642 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(156662), // Rule ID 2416 //
     /*  156647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  156650 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /*  156650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156660 */     GIR_RootConstrainSelectedInstOperands,
     /*  156661 */     // GIR_Coverage, 2416,
     /*  156661 */     GIR_EraseRootFromParent_Done,
     /*  156662 */   // Label 2848: @156662
     /*  156662 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(156682), // Rule ID 2417 //
     /*  156667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  156670 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /*  156670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  156673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156680 */     GIR_RootConstrainSelectedInstOperands,
     /*  156681 */     // GIR_Coverage, 2417,
     /*  156681 */     GIR_EraseRootFromParent_Done,
     /*  156682 */   // Label 2849: @156682
     /*  156682 */   GIM_Reject,
     /*  156683 */ // Label 2847: @156683
     /*  156683 */ GIM_Reject,
     /*  156684 */ // Label 2844: @156684
     /*  156684 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(156741),
     /*  156689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156700 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(156720), // Rule ID 2334 //
     /*  156705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  156708 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /*  156708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156718 */     GIR_RootConstrainSelectedInstOperands,
     /*  156719 */     // GIR_Coverage, 2334,
     /*  156719 */     GIR_EraseRootFromParent_Done,
     /*  156720 */   // Label 2851: @156720
     /*  156720 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(156740), // Rule ID 2335 //
     /*  156725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  156728 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /*  156728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  156731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156738 */     GIR_RootConstrainSelectedInstOperands,
     /*  156739 */     // GIR_Coverage, 2335,
     /*  156739 */     GIR_EraseRootFromParent_Done,
     /*  156740 */   // Label 2852: @156740
     /*  156740 */   GIM_Reject,
     /*  156741 */ // Label 2850: @156741
     /*  156741 */ GIM_Reject,
     /*  156742 */ // Label 2845: @156742
     /*  156742 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(156799),
     /*  156747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156758 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(156778), // Rule ID 2374 //
     /*  156763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  156766 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /*  156766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156776 */     GIR_RootConstrainSelectedInstOperands,
     /*  156777 */     // GIR_Coverage, 2374,
     /*  156777 */     GIR_EraseRootFromParent_Done,
     /*  156778 */   // Label 2854: @156778
     /*  156778 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(156798), // Rule ID 2375 //
     /*  156783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  156786 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /*  156786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  156789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  156796 */     GIR_RootConstrainSelectedInstOperands,
     /*  156797 */     // GIR_Coverage, 2375,
     /*  156797 */     GIR_EraseRootFromParent_Done,
     /*  156798 */   // Label 2855: @156798
     /*  156798 */   GIM_Reject,
     /*  156799 */ // Label 2853: @156799
     /*  156799 */ GIM_Reject,
     /*  156800 */ // Label 2846: @156800
     /*  156800 */ GIM_Reject,
     /*  156801 */ // Label 16: @156801
     /*  156801 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2858*/ GIMT_Encode4(157380),
     /*  156812 */ /*GILLT_s32*//*Label 2856*/ GIMT_Encode4(156820),
     /*  156816 */ /*GILLT_s64*//*Label 2857*/ GIMT_Encode4(157193),
     /*  156820 */ // Label 2856: @156820
     /*  156820 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(156851), // Rule ID 1462 //
     /*  156825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  156828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156839 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  156842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156844 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156849 */   GIR_RootConstrainSelectedInstOperands,
     /*  156850 */   // GIR_Coverage, 1462,
     /*  156850 */   GIR_EraseRootFromParent_Done,
     /*  156851 */ // Label 2859: @156851
     /*  156851 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(156882), // Rule ID 1463 //
     /*  156856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  156859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156870 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  156870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  156873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156880 */   GIR_RootConstrainSelectedInstOperands,
     /*  156881 */   // GIR_Coverage, 1463,
     /*  156881 */   GIR_EraseRootFromParent_Done,
     /*  156882 */ // Label 2860: @156882
     /*  156882 */ GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(156913), // Rule ID 1488 //
     /*  156887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  156890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156901 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  156901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  156904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156906 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156911 */   GIR_RootConstrainSelectedInstOperands,
     /*  156912 */   // GIR_Coverage, 1488,
     /*  156912 */   GIR_EraseRootFromParent_Done,
     /*  156913 */ // Label 2861: @156913
     /*  156913 */ GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(156944), // Rule ID 1489 //
     /*  156918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  156921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  156924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156932 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  156932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  156935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156937 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156942 */   GIR_RootConstrainSelectedInstOperands,
     /*  156943 */   // GIR_Coverage, 1489,
     /*  156943 */   GIR_EraseRootFromParent_Done,
     /*  156944 */ // Label 2862: @156944
     /*  156944 */ GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(156975), // Rule ID 1856 //
     /*  156949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /*  156952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156963 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  156963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  156966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156968 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  156970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  156973 */   GIR_RootConstrainSelectedInstOperands,
     /*  156974 */   // GIR_Coverage, 1856,
     /*  156974 */   GIR_EraseRootFromParent_Done,
     /*  156975 */ // Label 2863: @156975
     /*  156975 */ GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(157006), // Rule ID 1857 //
     /*  156980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /*  156983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  156986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  156994 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  156994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  156997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156999 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157004 */   GIR_RootConstrainSelectedInstOperands,
     /*  157005 */   // GIR_Coverage, 1857,
     /*  157005 */   GIR_EraseRootFromParent_Done,
     /*  157006 */ // Label 2864: @157006
     /*  157006 */ GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(157037), // Rule ID 1882 //
     /*  157011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /*  157014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  157025 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  157028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157030 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157035 */   GIR_RootConstrainSelectedInstOperands,
     /*  157036 */   // GIR_Coverage, 1882,
     /*  157036 */   GIR_EraseRootFromParent_Done,
     /*  157037 */ // Label 2865: @157037
     /*  157037 */ GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(157068), // Rule ID 1883 //
     /*  157042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /*  157045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  157056 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  157056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  157059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157061 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157066 */   GIR_RootConstrainSelectedInstOperands,
     /*  157067 */   // GIR_Coverage, 1883,
     /*  157067 */   GIR_EraseRootFromParent_Done,
     /*  157068 */ // Label 2866: @157068
     /*  157068 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(157099), // Rule ID 2198 //
     /*  157073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /*  157076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157087 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  157090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157092 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157097 */   GIR_RootConstrainSelectedInstOperands,
     /*  157098 */   // GIR_Coverage, 2198,
     /*  157098 */   GIR_EraseRootFromParent_Done,
     /*  157099 */ // Label 2867: @157099
     /*  157099 */ GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(157130), // Rule ID 2199 //
     /*  157104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /*  157107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157118 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  157118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  157121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157123 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157128 */   GIR_RootConstrainSelectedInstOperands,
     /*  157129 */   // GIR_Coverage, 2199,
     /*  157129 */   GIR_EraseRootFromParent_Done,
     /*  157130 */ // Label 2868: @157130
     /*  157130 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(157161), // Rule ID 2224 //
     /*  157135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /*  157138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157149 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  157152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157154 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157159 */   GIR_RootConstrainSelectedInstOperands,
     /*  157160 */   // GIR_Coverage, 2224,
     /*  157160 */   GIR_EraseRootFromParent_Done,
     /*  157161 */ // Label 2869: @157161
     /*  157161 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(157192), // Rule ID 2225 //
     /*  157166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /*  157169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157180 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  157180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  157183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157185 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157190 */   GIR_RootConstrainSelectedInstOperands,
     /*  157191 */   // GIR_Coverage, 2225,
     /*  157191 */   GIR_EraseRootFromParent_Done,
     /*  157192 */ // Label 2870: @157192
     /*  157192 */ GIM_Reject,
     /*  157193 */ // Label 2857: @157193
     /*  157193 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(157224), // Rule ID 1515 //
     /*  157198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157212 */   // (lrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157217 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157222 */   GIR_RootConstrainSelectedInstOperands,
     /*  157223 */   // GIR_Coverage, 1515,
     /*  157223 */   GIR_EraseRootFromParent_Done,
     /*  157224 */ // Label 2871: @157224
     /*  157224 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(157255), // Rule ID 1543 //
     /*  157229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157243 */   // (lrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157248 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157253 */   GIR_RootConstrainSelectedInstOperands,
     /*  157254 */   // GIR_Coverage, 1543,
     /*  157254 */   GIR_EraseRootFromParent_Done,
     /*  157255 */ // Label 2872: @157255
     /*  157255 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(157286), // Rule ID 1913 //
     /*  157260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  157263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157274 */   // (lrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157274 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  157277 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157279 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157284 */   GIR_RootConstrainSelectedInstOperands,
     /*  157285 */   // GIR_Coverage, 1913,
     /*  157285 */   GIR_EraseRootFromParent_Done,
     /*  157286 */ // Label 2873: @157286
     /*  157286 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(157317), // Rule ID 1941 //
     /*  157291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  157294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157305 */   // (lrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  157308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157310 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157315 */   GIR_RootConstrainSelectedInstOperands,
     /*  157316 */   // GIR_Coverage, 1941,
     /*  157316 */   GIR_EraseRootFromParent_Done,
     /*  157317 */ // Label 2874: @157317
     /*  157317 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(157348), // Rule ID 2249 //
     /*  157322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  157325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157336 */   // (lrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  157339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157341 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157346 */   GIR_RootConstrainSelectedInstOperands,
     /*  157347 */   // GIR_Coverage, 2249,
     /*  157347 */   GIR_EraseRootFromParent_Done,
     /*  157348 */ // Label 2875: @157348
     /*  157348 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(157379), // Rule ID 2275 //
     /*  157353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  157356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157367 */   // (lrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  157370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157372 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157377 */   GIR_RootConstrainSelectedInstOperands,
     /*  157378 */   // GIR_Coverage, 2275,
     /*  157378 */   GIR_EraseRootFromParent_Done,
     /*  157379 */ // Label 2876: @157379
     /*  157379 */ GIM_Reject,
     /*  157380 */ // Label 2858: @157380
     /*  157380 */ GIM_Reject,
     /*  157381 */ // Label 17: @157381
     /*  157381 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(157590),
     /*  157386 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157389 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2881*/ GIMT_Encode4(157589),
     /*  157400 */   /*GILLT_s16*//*Label 2878*/ GIMT_Encode4(157412),
     /*  157404 */   /*GILLT_s32*//*Label 2879*/ GIMT_Encode4(157471),
     /*  157408 */   /*GILLT_s64*//*Label 2880*/ GIMT_Encode4(157530),
     /*  157412 */   // Label 2878: @157412
     /*  157412 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(157470),
     /*  157417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157421 */     GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(157445), // Rule ID 2251 //
     /*  157426 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  157429 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157433 */       // (llrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157433 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  157436 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157438 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157440 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157443 */       GIR_RootConstrainSelectedInstOperands,
     /*  157444 */       // GIR_Coverage, 2251,
     /*  157444 */       GIR_EraseRootFromParent_Done,
     /*  157445 */     // Label 2883: @157445
     /*  157445 */     GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(157469), // Rule ID 2277 //
     /*  157450 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  157453 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  157457 */       // (llrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  157457 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  157460 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157462 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157464 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157467 */       GIR_RootConstrainSelectedInstOperands,
     /*  157468 */       // GIR_Coverage, 2277,
     /*  157468 */       GIR_EraseRootFromParent_Done,
     /*  157469 */     // Label 2884: @157469
     /*  157469 */     GIM_Reject,
     /*  157470 */   // Label 2882: @157470
     /*  157470 */   GIM_Reject,
     /*  157471 */   // Label 2879: @157471
     /*  157471 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(157529),
     /*  157476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157480 */     GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(157504), // Rule ID 1517 //
     /*  157485 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  157488 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157492 */       // (llrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157492 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  157495 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157497 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157499 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157502 */       GIR_RootConstrainSelectedInstOperands,
     /*  157503 */       // GIR_Coverage, 1517,
     /*  157503 */       GIR_EraseRootFromParent_Done,
     /*  157504 */     // Label 2886: @157504
     /*  157504 */     GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(157528), // Rule ID 1545 //
     /*  157509 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  157512 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  157516 */       // (llrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  157516 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  157519 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157521 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157523 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157526 */       GIR_RootConstrainSelectedInstOperands,
     /*  157527 */       // GIR_Coverage, 1545,
     /*  157527 */       GIR_EraseRootFromParent_Done,
     /*  157528 */     // Label 2887: @157528
     /*  157528 */     GIM_Reject,
     /*  157529 */   // Label 2885: @157529
     /*  157529 */   GIM_Reject,
     /*  157530 */   // Label 2880: @157530
     /*  157530 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(157588),
     /*  157535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157539 */     GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(157563), // Rule ID 1915 //
     /*  157544 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  157547 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157551 */       // (llrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157551 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  157554 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157556 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157558 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157561 */       GIR_RootConstrainSelectedInstOperands,
     /*  157562 */       // GIR_Coverage, 1915,
     /*  157562 */       GIR_EraseRootFromParent_Done,
     /*  157563 */     // Label 2889: @157563
     /*  157563 */     GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(157587), // Rule ID 1943 //
     /*  157568 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  157571 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157575 */       // (llrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  157575 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  157578 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157580 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157582 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  157585 */       GIR_RootConstrainSelectedInstOperands,
     /*  157586 */       // GIR_Coverage, 1943,
     /*  157586 */       GIR_EraseRootFromParent_Done,
     /*  157587 */     // Label 2890: @157587
     /*  157587 */     GIM_Reject,
     /*  157588 */   // Label 2888: @157588
     /*  157588 */   GIM_Reject,
     /*  157589 */   // Label 2881: @157589
     /*  157589 */   GIM_Reject,
     /*  157590 */ // Label 2877: @157590
     /*  157590 */ GIM_Reject,
     /*  157591 */ // Label 18: @157591
     /*  157591 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2894*/ GIMT_Encode4(157788),
     /*  157602 */ /*GILLT_s16*//*Label 2891*/ GIMT_Encode4(157614),
     /*  157606 */ /*GILLT_s32*//*Label 2892*/ GIMT_Encode4(157672),
     /*  157610 */ /*GILLT_s64*//*Label 2893*/ GIMT_Encode4(157730),
     /*  157614 */ // Label 2891: @157614
     /*  157614 */ GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(157671),
     /*  157619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  157622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  157630 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(157650), // Rule ID 2420 //
     /*  157635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  157638 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /*  157638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157648 */     GIR_RootConstrainSelectedInstOperands,
     /*  157649 */     // GIR_Coverage, 2420,
     /*  157649 */     GIR_EraseRootFromParent_Done,
     /*  157650 */   // Label 2896: @157650
     /*  157650 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(157670), // Rule ID 2421 //
     /*  157655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  157658 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /*  157658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  157661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157668 */     GIR_RootConstrainSelectedInstOperands,
     /*  157669 */     // GIR_Coverage, 2421,
     /*  157669 */     GIR_EraseRootFromParent_Done,
     /*  157670 */   // Label 2897: @157670
     /*  157670 */   GIM_Reject,
     /*  157671 */ // Label 2895: @157671
     /*  157671 */ GIM_Reject,
     /*  157672 */ // Label 2892: @157672
     /*  157672 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(157729),
     /*  157677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  157680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  157688 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(157708), // Rule ID 2338 //
     /*  157693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  157696 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /*  157696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157706 */     GIR_RootConstrainSelectedInstOperands,
     /*  157707 */     // GIR_Coverage, 2338,
     /*  157707 */     GIR_EraseRootFromParent_Done,
     /*  157708 */   // Label 2899: @157708
     /*  157708 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(157728), // Rule ID 2339 //
     /*  157713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  157716 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /*  157716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  157719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157726 */     GIR_RootConstrainSelectedInstOperands,
     /*  157727 */     // GIR_Coverage, 2339,
     /*  157727 */     GIR_EraseRootFromParent_Done,
     /*  157728 */   // Label 2900: @157728
     /*  157728 */   GIM_Reject,
     /*  157729 */ // Label 2898: @157729
     /*  157729 */ GIM_Reject,
     /*  157730 */ // Label 2893: @157730
     /*  157730 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(157787),
     /*  157735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  157738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157746 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(157766), // Rule ID 2378 //
     /*  157751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  157754 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i64] })
     /*  157754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157764 */     GIR_RootConstrainSelectedInstOperands,
     /*  157765 */     // GIR_Coverage, 2378,
     /*  157765 */     GIR_EraseRootFromParent_Done,
     /*  157766 */   // Label 2902: @157766
     /*  157766 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(157786), // Rule ID 2379 //
     /*  157771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  157774 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i32] })
     /*  157774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  157777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  157781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  157784 */     GIR_RootConstrainSelectedInstOperands,
     /*  157785 */     // GIR_Coverage, 2379,
     /*  157785 */     GIR_EraseRootFromParent_Done,
     /*  157786 */   // Label 2903: @157786
     /*  157786 */   GIM_Reject,
     /*  157787 */ // Label 2901: @157787
     /*  157787 */ GIM_Reject,
     /*  157788 */ // Label 2894: @157788
     /*  157788 */ GIM_Reject,
     /*  157789 */ // Label 19: @157789
     /*  157789 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(157827), // Rule ID 287 //
     /*  157794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157797 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157804 */   // (readcyclecounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3072:{ *:[i64] }, X0:{ *:[i64] })
     /*  157804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  157807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157809 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3072),
     /*  157819 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  157825 */   GIR_RootConstrainSelectedInstOperands,
     /*  157826 */   // GIR_Coverage, 287,
     /*  157826 */   GIR_EraseRootFromParent_Done,
     /*  157827 */ // Label 2904: @157827
     /*  157827 */ GIM_Reject,
     /*  157828 */ // Label 20: @157828
     /*  157828 */ GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(157866), // Rule ID 288 //
     /*  157833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157836 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  157839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157843 */   // (readsteadycounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3073:{ *:[i64] }, X0:{ *:[i64] })
     /*  157843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  157846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157848 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3073),
     /*  157858 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  157864 */   GIR_RootConstrainSelectedInstOperands,
     /*  157865 */   // GIR_Coverage, 288,
     /*  157865 */   GIR_EraseRootFromParent_Done,
     /*  157866 */ // Label 2905: @157866
     /*  157866 */ GIM_Reject,
     /*  157867 */ // Label 21: @157867
     /*  157867 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 2940*/ GIMT_Encode4(166844),
     /*  157878 */ /*GILLT_p0s32*//*Label 2906*/ GIMT_Encode4(158014),
     /*  157882 */ /*GILLT_p0s64*//*Label 2907*/ GIMT_Encode4(158108),
     /*  157886 */ /*GILLT_s16*//*Label 2908*/ GIMT_Encode4(158202),
     /*  157890 */ /*GILLT_s32*//*Label 2909*/ GIMT_Encode4(158857),
     /*  157894 */ /*GILLT_s64*//*Label 2910*/ GIMT_Encode4(160312),
     /*  157898 */ /*GILLT_nxv1s1*//*Label 2911*/ GIMT_Encode4(161538),
     /*  157902 */ /*GILLT_nxv1s8*//*Label 2912*/ GIMT_Encode4(161658),
     /*  157906 */ /*GILLT_nxv1s16*//*Label 2913*/ GIMT_Encode4(161786),
     /*  157910 */ /*GILLT_nxv1s32*//*Label 2914*/ GIMT_Encode4(162024),
     /*  157914 */ /*GILLT_nxv1s64*//*Label 2915*/ GIMT_Encode4(162262),
     /*  157918 */ /*GILLT_nxv2s1*//*Label 2916*/ GIMT_Encode4(162500),
     /*  157922 */ /*GILLT_nxv2s8*//*Label 2917*/ GIMT_Encode4(162620),
     /*  157926 */ /*GILLT_nxv2s16*//*Label 2918*/ GIMT_Encode4(162748),
     /*  157930 */ /*GILLT_nxv2s32*//*Label 2919*/ GIMT_Encode4(162986),
     /*  157934 */ /*GILLT_nxv2s64*//*Label 2920*/ GIMT_Encode4(163224),
     /*  157938 */ /*GILLT_nxv4s1*//*Label 2921*/ GIMT_Encode4(163462),
     /*  157942 */ /*GILLT_nxv4s8*//*Label 2922*/ GIMT_Encode4(163582),
     /*  157946 */ /*GILLT_nxv4s16*//*Label 2923*/ GIMT_Encode4(163710),
     /*  157950 */ /*GILLT_nxv4s32*//*Label 2924*/ GIMT_Encode4(163948),
     /*  157954 */ /*GILLT_nxv4s64*//*Label 2925*/ GIMT_Encode4(164186),
     /*  157958 */ /*GILLT_nxv8s1*//*Label 2926*/ GIMT_Encode4(164424),
     /*  157962 */ /*GILLT_nxv8s8*//*Label 2927*/ GIMT_Encode4(164544),
     /*  157966 */ /*GILLT_nxv8s16*//*Label 2928*/ GIMT_Encode4(164672),
     /*  157970 */ /*GILLT_nxv8s32*//*Label 2929*/ GIMT_Encode4(164910),
     /*  157974 */ /*GILLT_nxv8s64*//*Label 2930*/ GIMT_Encode4(165148),
     /*  157978 */ /*GILLT_nxv16s1*//*Label 2931*/ GIMT_Encode4(165386),
     /*  157982 */ /*GILLT_nxv16s8*//*Label 2932*/ GIMT_Encode4(165506),
     /*  157986 */ /*GILLT_nxv16s16*//*Label 2933*/ GIMT_Encode4(165634),
     /*  157990 */ /*GILLT_nxv16s32*//*Label 2934*/ GIMT_Encode4(165872),
     /*  157994 */ /*GILLT_nxv32s1*//*Label 2935*/ GIMT_Encode4(166110),
     /*  157998 */ /*GILLT_nxv32s8*//*Label 2936*/ GIMT_Encode4(166230),
     /*  158002 */ /*GILLT_nxv32s16*//*Label 2937*/ GIMT_Encode4(166358),
     /*  158006 */ /*GILLT_nxv64s1*//*Label 2938*/ GIMT_Encode4(166596),
     /*  158010 */ /*GILLT_nxv64s8*//*Label 2939*/ GIMT_Encode4(166716),
     /*  158014 */ // Label 2906: @158014
     /*  158014 */ GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(158107),
     /*  158019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158022 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158034 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(158070), // Rule ID 65340 //
     /*  158039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  158042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158049 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  158052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158068 */     GIR_RootConstrainSelectedInstOperands,
     /*  158069 */     // GIR_Coverage, 65340,
     /*  158069 */     GIR_EraseRootFromParent_Done,
     /*  158070 */   // Label 2942: @158070
     /*  158070 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(158106), // Rule ID 65344 //
     /*  158075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  158078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158085 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  158088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158104 */     GIR_RootConstrainSelectedInstOperands,
     /*  158105 */     // GIR_Coverage, 65344,
     /*  158105 */     GIR_EraseRootFromParent_Done,
     /*  158106 */   // Label 2943: @158106
     /*  158106 */   GIM_Reject,
     /*  158107 */ // Label 2941: @158107
     /*  158107 */ GIM_Reject,
     /*  158108 */ // Label 2907: @158108
     /*  158108 */ GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(158201),
     /*  158113 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158116 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158128 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(158164), // Rule ID 65339 //
     /*  158133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  158136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158143 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  158146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158162 */     GIR_RootConstrainSelectedInstOperands,
     /*  158163 */     // GIR_Coverage, 65339,
     /*  158163 */     GIR_EraseRootFromParent_Done,
     /*  158164 */   // Label 2945: @158164
     /*  158164 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(158200), // Rule ID 65343 //
     /*  158169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  158172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158179 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  158182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158198 */     GIR_RootConstrainSelectedInstOperands,
     /*  158199 */     // GIR_Coverage, 65343,
     /*  158199 */     GIR_EraseRootFromParent_Done,
     /*  158200 */   // Label 2946: @158200
     /*  158200 */   GIM_Reject,
     /*  158201 */ // Label 2944: @158201
     /*  158201 */ GIM_Reject,
     /*  158202 */ // Label 2908: @158202
     /*  158202 */ GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(158253), // Rule ID 2146 //
     /*  158207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  158210 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158213 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158221 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158225 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158232 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  158235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158251 */   GIR_RootConstrainSelectedInstOperands,
     /*  158252 */   // GIR_Coverage, 2146,
     /*  158252 */   GIR_EraseRootFromParent_Done,
     /*  158253 */ // Label 2947: @158253
     /*  158253 */ GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(158304), // Rule ID 2147 //
     /*  158258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  158261 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158264 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  158272 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158276 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158283 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  158286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158293 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158298 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158302 */   GIR_RootConstrainSelectedInstOperands,
     /*  158303 */   // GIR_Coverage, 2147,
     /*  158303 */   GIR_EraseRootFromParent_Done,
     /*  158304 */ // Label 2948: @158304
     /*  158304 */ GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(158355), // Rule ID 2152 //
     /*  158309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  158312 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158315 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  158323 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158327 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158334 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  158337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158349 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158353 */   GIR_RootConstrainSelectedInstOperands,
     /*  158354 */   // GIR_Coverage, 2152,
     /*  158354 */   GIR_EraseRootFromParent_Done,
     /*  158355 */ // Label 2949: @158355
     /*  158355 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(158406), // Rule ID 2153 //
     /*  158360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  158363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  158374 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158385 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  158388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158400 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158404 */   GIR_RootConstrainSelectedInstOperands,
     /*  158405 */   // GIR_Coverage, 2153,
     /*  158405 */   GIR_EraseRootFromParent_Done,
     /*  158406 */ // Label 2950: @158406
     /*  158406 */ GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(158457), // Rule ID 65347 //
     /*  158411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158417 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158425 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158429 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158436 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158441 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158446 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158451 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158455 */   GIR_RootConstrainSelectedInstOperands,
     /*  158456 */   // GIR_Coverage, 65347,
     /*  158456 */   GIR_EraseRootFromParent_Done,
     /*  158457 */ // Label 2951: @158457
     /*  158457 */ GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(158508), // Rule ID 65348 //
     /*  158462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158465 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158468 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158476 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158487 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158506 */   GIR_RootConstrainSelectedInstOperands,
     /*  158507 */   // GIR_Coverage, 65348,
     /*  158507 */   GIR_EraseRootFromParent_Done,
     /*  158508 */ // Label 2952: @158508
     /*  158508 */ GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(158566), // Rule ID 65351 //
     /*  158513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158516 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158519 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158545 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158564 */   GIR_RootConstrainSelectedInstOperands,
     /*  158565 */   // GIR_Coverage, 65351,
     /*  158565 */   GIR_EraseRootFromParent_Done,
     /*  158566 */ // Label 2953: @158566
     /*  158566 */ GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(158624), // Rule ID 65352 //
     /*  158571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158577 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158581 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158603 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158622 */   GIR_RootConstrainSelectedInstOperands,
     /*  158623 */   // GIR_Coverage, 65352,
     /*  158623 */   GIR_EraseRootFromParent_Done,
     /*  158624 */ // Label 2954: @158624
     /*  158624 */ GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(158682), // Rule ID 65355 //
     /*  158629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  158632 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158635 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158639 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158650 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158654 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158661 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  158664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158676 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158680 */   GIR_RootConstrainSelectedInstOperands,
     /*  158681 */   // GIR_Coverage, 65355,
     /*  158681 */   GIR_EraseRootFromParent_Done,
     /*  158682 */ // Label 2955: @158682
     /*  158682 */ GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(158740), // Rule ID 65356 //
     /*  158687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  158690 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158693 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158697 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158719 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  158722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158738 */   GIR_RootConstrainSelectedInstOperands,
     /*  158739 */   // GIR_Coverage, 65356,
     /*  158739 */   GIR_EraseRootFromParent_Done,
     /*  158740 */ // Label 2956: @158740
     /*  158740 */ GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(158798), // Rule ID 65357 //
     /*  158745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  158748 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158751 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158755 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158766 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158770 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158777 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  158777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158796 */   GIR_RootConstrainSelectedInstOperands,
     /*  158797 */   // GIR_Coverage, 65357,
     /*  158797 */   GIR_EraseRootFromParent_Done,
     /*  158798 */ // Label 2957: @158798
     /*  158798 */ GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(158856), // Rule ID 65358 //
     /*  158803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  158806 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158809 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158813 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158824 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158835 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158854 */   GIR_RootConstrainSelectedInstOperands,
     /*  158855 */   // GIR_Coverage, 65358,
     /*  158855 */   GIR_EraseRootFromParent_Done,
     /*  158856 */ // Label 2958: @158856
     /*  158856 */ GIM_Reject,
     /*  158857 */ // Label 2909: @158857
     /*  158857 */ GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(158915), // Rule ID 233 //
     /*  158862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158865 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158868 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  158879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158887 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158894 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  158897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158909 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158913 */   GIR_RootConstrainSelectedInstOperands,
     /*  158914 */   // GIR_Coverage, 233,
     /*  158914 */   GIR_EraseRootFromParent_Done,
     /*  158915 */ // Label 2959: @158915
     /*  158915 */ GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(158973), // Rule ID 237 //
     /*  158920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  158923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158926 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  158937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158941 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158945 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  158952 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  158952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  158955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158957 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  158962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  158967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158971 */   GIR_RootConstrainSelectedInstOperands,
     /*  158972 */   // GIR_Coverage, 237,
     /*  158972 */   GIR_EraseRootFromParent_Done,
     /*  158973 */ // Label 2960: @158973
     /*  158973 */ GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(159024), // Rule ID 238 //
     /*  158978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  158981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158984 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158992 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158996 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159003 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159008 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159022 */   GIR_RootConstrainSelectedInstOperands,
     /*  159023 */   // GIR_Coverage, 238,
     /*  159023 */   GIR_EraseRootFromParent_Done,
     /*  159024 */ // Label 2961: @159024
     /*  159024 */ GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(159075), // Rule ID 239 //
     /*  159029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  159032 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159035 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159043 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159047 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159054 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159073 */   GIR_RootConstrainSelectedInstOperands,
     /*  159074 */   // GIR_Coverage, 239,
     /*  159074 */   GIR_EraseRootFromParent_Done,
     /*  159075 */ // Label 2962: @159075
     /*  159075 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(159136), // Rule ID 322 //
     /*  159080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159083 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159086 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159090 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159097 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159104 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159108 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159115 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10075>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  159118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159130 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159134 */   GIR_RootConstrainSelectedInstOperands,
     /*  159135 */   // GIR_Coverage, 322,
     /*  159135 */   GIR_EraseRootFromParent_Done,
     /*  159136 */ // Label 2963: @159136
     /*  159136 */ GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(159197), // Rule ID 326 //
     /*  159141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  159144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159147 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159151 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159158 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159169 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159176 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10077>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159186 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159191 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159195 */   GIR_RootConstrainSelectedInstOperands,
     /*  159196 */   // GIR_Coverage, 326,
     /*  159196 */   GIR_EraseRootFromParent_Done,
     /*  159197 */ // Label 2964: @159197
     /*  159197 */ GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(159258), // Rule ID 340 //
     /*  159202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode1),
     /*  159205 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159208 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159212 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159219 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159226 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159230 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159237 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10089>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159247 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159252 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159256 */   GIR_RootConstrainSelectedInstOperands,
     /*  159257 */   // GIR_Coverage, 340,
     /*  159257 */   GIR_EraseRootFromParent_Done,
     /*  159258 */ // Label 2965: @159258
     /*  159258 */ GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(159319), // Rule ID 342 //
     /*  159263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  159266 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159269 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159273 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159280 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159298 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10091>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159317 */   GIR_RootConstrainSelectedInstOperands,
     /*  159318 */   // GIR_Coverage, 342,
     /*  159318 */   GIR_EraseRootFromParent_Done,
     /*  159319 */ // Label 2966: @159319
     /*  159319 */ GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(159370), // Rule ID 1433 //
     /*  159324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  159327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159330 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  159338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159349 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  159352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159364 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159368 */   GIR_RootConstrainSelectedInstOperands,
     /*  159369 */   // GIR_Coverage, 1433,
     /*  159369 */   GIR_EraseRootFromParent_Done,
     /*  159370 */ // Label 2967: @159370
     /*  159370 */ GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(159421), // Rule ID 1434 //
     /*  159375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  159378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  159389 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159393 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159400 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  159403 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159405 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159419 */   GIR_RootConstrainSelectedInstOperands,
     /*  159420 */   // GIR_Coverage, 1434,
     /*  159420 */   GIR_EraseRootFromParent_Done,
     /*  159421 */ // Label 2968: @159421
     /*  159421 */ GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(159472), // Rule ID 1439 //
     /*  159426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  159429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  159440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159444 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159451 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  159454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159456 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159466 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159470 */   GIR_RootConstrainSelectedInstOperands,
     /*  159471 */   // GIR_Coverage, 1439,
     /*  159471 */   GIR_EraseRootFromParent_Done,
     /*  159472 */ // Label 2969: @159472
     /*  159472 */ GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(159523), // Rule ID 1440 //
     /*  159477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  159480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  159491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159502 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  159505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159517 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159521 */   GIR_RootConstrainSelectedInstOperands,
     /*  159522 */   // GIR_Coverage, 1440,
     /*  159522 */   GIR_EraseRootFromParent_Done,
     /*  159523 */ // Label 2970: @159523
     /*  159523 */ GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(159581), // Rule ID 65363 //
     /*  159528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  159531 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159534 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159538 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159549 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159553 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159560 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159579 */   GIR_RootConstrainSelectedInstOperands,
     /*  159580 */   // GIR_Coverage, 65363,
     /*  159580 */   GIR_EraseRootFromParent_Done,
     /*  159581 */ // Label 2971: @159581
     /*  159581 */ GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(159639), // Rule ID 65364 //
     /*  159586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  159589 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159596 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  159603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159611 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159618 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  159621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159637 */   GIR_RootConstrainSelectedInstOperands,
     /*  159638 */   // GIR_Coverage, 65364,
     /*  159638 */   GIR_EraseRootFromParent_Done,
     /*  159639 */ // Label 2972: @159639
     /*  159639 */ GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(159697), // Rule ID 65367 //
     /*  159644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  159647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159650 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159654 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159665 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159669 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159676 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159681 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159695 */   GIR_RootConstrainSelectedInstOperands,
     /*  159696 */   // GIR_Coverage, 65367,
     /*  159696 */   GIR_EraseRootFromParent_Done,
     /*  159697 */ // Label 2973: @159697
     /*  159697 */ GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(159755), // Rule ID 65368 //
     /*  159702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  159705 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159708 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159712 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159723 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159734 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  159737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159749 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159753 */   GIR_RootConstrainSelectedInstOperands,
     /*  159754 */   // GIR_Coverage, 65368,
     /*  159754 */   GIR_EraseRootFromParent_Done,
     /*  159755 */ // Label 2974: @159755
     /*  159755 */ GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(159813), // Rule ID 65369 //
     /*  159760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  159763 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159766 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159770 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159781 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159785 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159792 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  159792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159797 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159802 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159807 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159811 */   GIR_RootConstrainSelectedInstOperands,
     /*  159812 */   // GIR_Coverage, 65369,
     /*  159812 */   GIR_EraseRootFromParent_Done,
     /*  159813 */ // Label 2975: @159813
     /*  159813 */ GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(159871), // Rule ID 65370 //
     /*  159818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  159821 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159824 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159828 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159839 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159843 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  159850 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  159850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  159853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  159860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  159865 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159869 */   GIR_RootConstrainSelectedInstOperands,
     /*  159870 */   // GIR_Coverage, 65370,
     /*  159870 */   GIR_EraseRootFromParent_Done,
     /*  159871 */ // Label 2976: @159871
     /*  159871 */ GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(159915), // Rule ID 1098 //
     /*  159876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  159879 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159882 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159893 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159900 */   // MIs[0] rs1
     /*  159900 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159908 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10579>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  159908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  159913 */   GIR_RootConstrainSelectedInstOperands,
     /*  159914 */   // GIR_Coverage, 1098,
     /*  159914 */   GIR_Done,
     /*  159915 */ // Label 2977: @159915
     /*  159915 */ GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(159959), // Rule ID 1102 //
     /*  159920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  159923 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159926 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  159937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  159940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159944 */   // MIs[0] rs1
     /*  159944 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159952 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10581>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  159952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  159957 */   GIR_RootConstrainSelectedInstOperands,
     /*  159958 */   // GIR_Coverage, 1102,
     /*  159958 */   GIR_Done,
     /*  159959 */ // Label 2978: @159959
     /*  159959 */ GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(160003), // Rule ID 1106 //
     /*  159964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  159967 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  159970 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159974 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  159981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  159984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159988 */   // MIs[0] rs1
     /*  159988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159996 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10583>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  159996 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160001 */   GIR_RootConstrainSelectedInstOperands,
     /*  160002 */   // GIR_Coverage, 1106,
     /*  160002 */   GIR_Done,
     /*  160003 */ // Label 2979: @160003
     /*  160003 */ GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(160047), // Rule ID 1110 //
     /*  160008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  160011 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160014 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160018 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160025 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160032 */   // MIs[0] rs1
     /*  160032 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160040 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10585>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  160045 */   GIR_RootConstrainSelectedInstOperands,
     /*  160046 */   // GIR_Coverage, 1110,
     /*  160046 */   GIR_Done,
     /*  160047 */ // Label 2980: @160047
     /*  160047 */ GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(160091), // Rule ID 1126 //
     /*  160052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160055 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160058 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160062 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160076 */   // MIs[0] rs1
     /*  160076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160084 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10599>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160089 */   GIR_RootConstrainSelectedInstOperands,
     /*  160090 */   // GIR_Coverage, 1126,
     /*  160090 */   GIR_Done,
     /*  160091 */ // Label 2981: @160091
     /*  160091 */ GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(160135), // Rule ID 1128 //
     /*  160096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  160099 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160106 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160113 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160120 */   // MIs[0] rs1
     /*  160120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160128 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10601>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160133 */   GIR_RootConstrainSelectedInstOperands,
     /*  160134 */   // GIR_Coverage, 1128,
     /*  160134 */   GIR_Done,
     /*  160135 */ // Label 2982: @160135
     /*  160135 */ GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(160179), // Rule ID 1130 //
     /*  160140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160143 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160146 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160150 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160157 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160164 */   // MIs[0] rs1
     /*  160164 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160172 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10603>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160177 */   GIR_RootConstrainSelectedInstOperands,
     /*  160178 */   // GIR_Coverage, 1130,
     /*  160178 */   GIR_Done,
     /*  160179 */ // Label 2983: @160179
     /*  160179 */ GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(160223), // Rule ID 1134 //
     /*  160184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160187 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160190 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160201 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160208 */   // MIs[0] rs1
     /*  160208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160216 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10605>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  160221 */   GIR_RootConstrainSelectedInstOperands,
     /*  160222 */   // GIR_Coverage, 1134,
     /*  160222 */   GIR_Done,
     /*  160223 */ // Label 2984: @160223
     /*  160223 */ GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(160267), // Rule ID 1138 //
     /*  160228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160231 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160234 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160238 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160252 */   // MIs[0] rs1
     /*  160252 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160260 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10607>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  160265 */   GIR_RootConstrainSelectedInstOperands,
     /*  160266 */   // GIR_Coverage, 1138,
     /*  160266 */   GIR_Done,
     /*  160267 */ // Label 2985: @160267
     /*  160267 */ GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(160311), // Rule ID 1140 //
     /*  160272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  160275 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160278 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160282 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  160292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160296 */   // MIs[0] rs1
     /*  160296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160304 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10609>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  160304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  160309 */   GIR_RootConstrainSelectedInstOperands,
     /*  160310 */   // GIR_Coverage, 1140,
     /*  160310 */   GIR_Done,
     /*  160311 */ // Label 2986: @160311
     /*  160311 */ GIM_Reject,
     /*  160312 */ // Label 2910: @160312
     /*  160312 */ GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(160370), // Rule ID 232 //
     /*  160317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  160320 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160323 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160327 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160342 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160349 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  160352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160354 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160359 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160364 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160368 */   GIR_RootConstrainSelectedInstOperands,
     /*  160369 */   // GIR_Coverage, 232,
     /*  160369 */   GIR_EraseRootFromParent_Done,
     /*  160370 */ // Label 2987: @160370
     /*  160370 */ GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(160428), // Rule ID 236 //
     /*  160375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  160378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160381 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160385 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160400 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160407 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160426 */   GIR_RootConstrainSelectedInstOperands,
     /*  160427 */   // GIR_Coverage, 236,
     /*  160427 */   GIR_EraseRootFromParent_Done,
     /*  160428 */ // Label 2988: @160428
     /*  160428 */ GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(160486), // Rule ID 282 //
     /*  160433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160439 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160443 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160454 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160458 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160465 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160480 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160484 */   GIR_RootConstrainSelectedInstOperands,
     /*  160485 */   // GIR_Coverage, 282,
     /*  160485 */   GIR_EraseRootFromParent_Done,
     /*  160486 */ // Label 2989: @160486
     /*  160486 */ GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(160537), // Rule ID 284 //
     /*  160491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  160494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160505 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160509 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160516 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  160519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160531 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160535 */   GIR_RootConstrainSelectedInstOperands,
     /*  160536 */   // GIR_Coverage, 284,
     /*  160536 */   GIR_EraseRootFromParent_Done,
     /*  160537 */ // Label 2990: @160537
     /*  160537 */ GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(160598), // Rule ID 321 //
     /*  160542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  160545 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160548 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160552 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  160559 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160570 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160577 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10075>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  160580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160596 */   GIR_RootConstrainSelectedInstOperands,
     /*  160597 */   // GIR_Coverage, 321,
     /*  160597 */   GIR_EraseRootFromParent_Done,
     /*  160598 */ // Label 2991: @160598
     /*  160598 */ GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(160659), // Rule ID 325 //
     /*  160603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  160606 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160609 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160613 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  160620 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160627 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160631 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160638 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10077>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  160641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160653 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160657 */   GIR_RootConstrainSelectedInstOperands,
     /*  160658 */   // GIR_Coverage, 325,
     /*  160658 */   GIR_EraseRootFromParent_Done,
     /*  160659 */ // Label 2992: @160659
     /*  160659 */ GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(160720), // Rule ID 339 //
     /*  160664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode0),
     /*  160667 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160670 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160674 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160681 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160688 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160692 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160699 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10089>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160718 */   GIR_RootConstrainSelectedInstOperands,
     /*  160719 */   // GIR_Coverage, 339,
     /*  160719 */   GIR_EraseRootFromParent_Done,
     /*  160720 */ // Label 2993: @160720
     /*  160720 */ GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(160781), // Rule ID 341 //
     /*  160725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  160728 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160731 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160735 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  160742 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160749 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160753 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160760 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10091>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  160763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160770 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160775 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160779 */   GIR_RootConstrainSelectedInstOperands,
     /*  160780 */   // GIR_Coverage, 341,
     /*  160780 */   GIR_EraseRootFromParent_Done,
     /*  160781 */ // Label 2994: @160781
     /*  160781 */ GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(160842), // Rule ID 347 //
     /*  160786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  160789 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  160792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160796 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  160803 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  160806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160810 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160814 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160821 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10095>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  160824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160831 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160836 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160840 */   GIR_RootConstrainSelectedInstOperands,
     /*  160841 */   // GIR_Coverage, 347,
     /*  160841 */   GIR_EraseRootFromParent_Done,
     /*  160842 */ // Label 2995: @160842
     /*  160842 */ GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(160893), // Rule ID 1831 //
     /*  160847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  160850 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  160861 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160865 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160872 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  160875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160891 */   GIR_RootConstrainSelectedInstOperands,
     /*  160892 */   // GIR_Coverage, 1831,
     /*  160892 */   GIR_EraseRootFromParent_Done,
     /*  160893 */ // Label 2996: @160893
     /*  160893 */ GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(160944), // Rule ID 1832 //
     /*  160898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  160901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160904 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  160912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160916 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160923 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  160923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  160926 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160928 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160938 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160942 */   GIR_RootConstrainSelectedInstOperands,
     /*  160943 */   // GIR_Coverage, 1832,
     /*  160943 */   GIR_EraseRootFromParent_Done,
     /*  160944 */ // Label 2997: @160944
     /*  160944 */ GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(160995), // Rule ID 1836 //
     /*  160949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  160952 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160955 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160963 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160967 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  160974 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  160974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  160977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  160984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  160989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160993 */   GIR_RootConstrainSelectedInstOperands,
     /*  160994 */   // GIR_Coverage, 1836,
     /*  160994 */   GIR_EraseRootFromParent_Done,
     /*  160995 */ // Label 2998: @160995
     /*  160995 */ GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(161046), // Rule ID 1840 //
     /*  161000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  161003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161018 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161025 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  161025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161030 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161035 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161040 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161044 */   GIR_RootConstrainSelectedInstOperands,
     /*  161045 */   // GIR_Coverage, 1840,
     /*  161045 */   GIR_EraseRootFromParent_Done,
     /*  161046 */ // Label 2999: @161046
     /*  161046 */ GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(161097), // Rule ID 1841 //
     /*  161051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  161054 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161057 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  161065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161069 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  161076 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_RV32:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  161076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD_RV32),
     /*  161079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  161086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  161091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161095 */   GIR_RootConstrainSelectedInstOperands,
     /*  161096 */   // GIR_Coverage, 1841,
     /*  161096 */   GIR_EraseRootFromParent_Done,
     /*  161097 */ // Label 3000: @161097
     /*  161097 */ GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(161141), // Rule ID 1097 //
     /*  161102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161105 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161108 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161112 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161126 */   // MIs[0] rs1
     /*  161126 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161134 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10579>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161139 */   GIR_RootConstrainSelectedInstOperands,
     /*  161140 */   // GIR_Coverage, 1097,
     /*  161140 */   GIR_Done,
     /*  161141 */ // Label 3001: @161141
     /*  161141 */ GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(161185), // Rule ID 1101 //
     /*  161146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161149 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161152 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161156 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  161163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161170 */   // MIs[0] rs1
     /*  161170 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161178 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10581>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  161183 */   GIR_RootConstrainSelectedInstOperands,
     /*  161184 */   // GIR_Coverage, 1101,
     /*  161184 */   GIR_Done,
     /*  161185 */ // Label 3002: @161185
     /*  161185 */ GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(161229), // Rule ID 1105 //
     /*  161190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161193 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161196 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161200 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161207 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161214 */   // MIs[0] rs1
     /*  161214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161222 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10583>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  161227 */   GIR_RootConstrainSelectedInstOperands,
     /*  161228 */   // GIR_Coverage, 1105,
     /*  161228 */   GIR_Done,
     /*  161229 */ // Label 3003: @161229
     /*  161229 */ GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(161273), // Rule ID 1109 //
     /*  161234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  161237 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161240 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  161251 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161258 */   // MIs[0] rs1
     /*  161258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161266 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10585>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  161271 */   GIR_RootConstrainSelectedInstOperands,
     /*  161272 */   // GIR_Coverage, 1109,
     /*  161272 */   GIR_Done,
     /*  161273 */ // Label 3004: @161273
     /*  161273 */ GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(161317), // Rule ID 1125 //
     /*  161278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  161281 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161284 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161295 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161302 */   // MIs[0] rs1
     /*  161302 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161310 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10599>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161315 */   GIR_RootConstrainSelectedInstOperands,
     /*  161316 */   // GIR_Coverage, 1125,
     /*  161316 */   GIR_Done,
     /*  161317 */ // Label 3005: @161317
     /*  161317 */ GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(161361), // Rule ID 1127 //
     /*  161322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  161325 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161328 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161332 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161346 */   // MIs[0] rs1
     /*  161346 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161354 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10601>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161359 */   GIR_RootConstrainSelectedInstOperands,
     /*  161360 */   // GIR_Coverage, 1127,
     /*  161360 */   GIR_Done,
     /*  161361 */ // Label 3006: @161361
     /*  161361 */ GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(161405), // Rule ID 1129 //
     /*  161366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161369 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161372 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161376 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161383 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161390 */   // MIs[0] rs1
     /*  161390 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161398 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10603>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161403 */   GIR_RootConstrainSelectedInstOperands,
     /*  161404 */   // GIR_Coverage, 1129,
     /*  161404 */   GIR_Done,
     /*  161405 */ // Label 3007: @161405
     /*  161405 */ GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(161449), // Rule ID 1133 //
     /*  161410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161413 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161416 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161420 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  161427 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161434 */   // MIs[0] rs1
     /*  161434 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161442 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10605>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  161447 */   GIR_RootConstrainSelectedInstOperands,
     /*  161448 */   // GIR_Coverage, 1133,
     /*  161448 */   GIR_Done,
     /*  161449 */ // Label 3008: @161449
     /*  161449 */ GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(161493), // Rule ID 1137 //
     /*  161454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161457 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161464 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161471 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  161474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161478 */   // MIs[0] rs1
     /*  161478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161486 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10607>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161491 */   GIR_RootConstrainSelectedInstOperands,
     /*  161492 */   // GIR_Coverage, 1137,
     /*  161492 */   GIR_Done,
     /*  161493 */ // Label 3009: @161493
     /*  161493 */ GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(161537), // Rule ID 1139 //
     /*  161498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  161501 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  161504 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  161515 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  161518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161522 */   // MIs[0] rs1
     /*  161522 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161530 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10609>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  161530 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  161535 */   GIR_RootConstrainSelectedInstOperands,
     /*  161536 */   // GIR_Coverage, 1139,
     /*  161536 */   GIR_Done,
     /*  161537 */ // Label 3010: @161537
     /*  161537 */ GIM_Reject,
     /*  161538 */ // Label 2911: @161538
     /*  161538 */ GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(161657),
     /*  161543 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161562 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(161609), // Rule ID 45740 //
     /*  161567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161570 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  161570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  161573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  161587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  161600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161607 */     GIR_RootConstrainSelectedInstOperands,
     /*  161608 */     // GIR_Coverage, 45740,
     /*  161608 */     GIR_EraseRootFromParent_Done,
     /*  161609 */   // Label 3012: @161609
     /*  161609 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(161656), // Rule ID 45741 //
     /*  161614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161617 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  161617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  161620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  161634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  161647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161654 */     GIR_RootConstrainSelectedInstOperands,
     /*  161655 */     // GIR_Coverage, 45741,
     /*  161655 */     GIR_EraseRootFromParent_Done,
     /*  161656 */   // Label 3013: @161656
     /*  161656 */   GIM_Reject,
     /*  161657 */ // Label 3011: @161657
     /*  161657 */ GIM_Reject,
     /*  161658 */ // Label 2912: @161658
     /*  161658 */ GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(161785),
     /*  161663 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161666 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161674 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(161729), // Rule ID 45736 //
     /*  161679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161682 */     // MIs[0] rs1
     /*  161682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161690 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  161690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  161693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  161707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161723 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161727 */     GIR_RootConstrainSelectedInstOperands,
     /*  161728 */     // GIR_Coverage, 45736,
     /*  161728 */     GIR_EraseRootFromParent_Done,
     /*  161729 */   // Label 3015: @161729
     /*  161729 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(161784), // Rule ID 45737 //
     /*  161734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161737 */     // MIs[0] rs1
     /*  161737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161745 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  161745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  161748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  161762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161782 */     GIR_RootConstrainSelectedInstOperands,
     /*  161783 */     // GIR_Coverage, 45737,
     /*  161783 */     GIR_EraseRootFromParent_Done,
     /*  161784 */   // Label 3016: @161784
     /*  161784 */   GIM_Reject,
     /*  161785 */ // Label 3014: @161785
     /*  161785 */ GIM_Reject,
     /*  161786 */ // Label 2913: @161786
     /*  161786 */ GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(162023),
     /*  161791 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161794 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161802 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(161857), // Rule ID 45932 //
     /*  161807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161810 */     // MIs[0] rs1
     /*  161810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161818 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  161818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  161821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  161835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161855 */     GIR_RootConstrainSelectedInstOperands,
     /*  161856 */     // GIR_Coverage, 45932,
     /*  161856 */     GIR_EraseRootFromParent_Done,
     /*  161857 */   // Label 3018: @161857
     /*  161857 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(161912), // Rule ID 45933 //
     /*  161862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161865 */     // MIs[0] rs1
     /*  161865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161873 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  161873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  161876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  161890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161910 */     GIR_RootConstrainSelectedInstOperands,
     /*  161911 */     // GIR_Coverage, 45933,
     /*  161911 */     GIR_EraseRootFromParent_Done,
     /*  161912 */   // Label 3019: @161912
     /*  161912 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(161967), // Rule ID 46008 //
     /*  161917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  161920 */     // MIs[0] rs1
     /*  161920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161928 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  161928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  161931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  161945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161965 */     GIR_RootConstrainSelectedInstOperands,
     /*  161966 */     // GIR_Coverage, 46008,
     /*  161966 */     GIR_EraseRootFromParent_Done,
     /*  161967 */   // Label 3020: @161967
     /*  161967 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(162022), // Rule ID 46009 //
     /*  161972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  161975 */     // MIs[0] rs1
     /*  161975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161983 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  161983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  161986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  162000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162020 */     GIR_RootConstrainSelectedInstOperands,
     /*  162021 */     // GIR_Coverage, 46009,
     /*  162021 */     GIR_EraseRootFromParent_Done,
     /*  162022 */   // Label 3021: @162022
     /*  162022 */   GIM_Reject,
     /*  162023 */ // Label 3017: @162023
     /*  162023 */ GIM_Reject,
     /*  162024 */ // Label 2914: @162024
     /*  162024 */ GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(162261),
     /*  162029 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162032 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162040 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(162095), // Rule ID 45940 //
     /*  162045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162048 */     // MIs[0] rs1
     /*  162048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162056 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162093 */     GIR_RootConstrainSelectedInstOperands,
     /*  162094 */     // GIR_Coverage, 45940,
     /*  162094 */     GIR_EraseRootFromParent_Done,
     /*  162095 */   // Label 3023: @162095
     /*  162095 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(162150), // Rule ID 45941 //
     /*  162100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162103 */     // MIs[0] rs1
     /*  162103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162111 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162148 */     GIR_RootConstrainSelectedInstOperands,
     /*  162149 */     // GIR_Coverage, 45941,
     /*  162149 */     GIR_EraseRootFromParent_Done,
     /*  162150 */   // Label 3024: @162150
     /*  162150 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(162205), // Rule ID 46016 //
     /*  162155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  162158 */     // MIs[0] rs1
     /*  162158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162166 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162203 */     GIR_RootConstrainSelectedInstOperands,
     /*  162204 */     // GIR_Coverage, 46016,
     /*  162204 */     GIR_EraseRootFromParent_Done,
     /*  162205 */   // Label 3025: @162205
     /*  162205 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(162260), // Rule ID 46017 //
     /*  162210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  162213 */     // MIs[0] rs1
     /*  162213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162221 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  162224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  162238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162258 */     GIR_RootConstrainSelectedInstOperands,
     /*  162259 */     // GIR_Coverage, 46017,
     /*  162259 */     GIR_EraseRootFromParent_Done,
     /*  162260 */   // Label 3026: @162260
     /*  162260 */   GIM_Reject,
     /*  162261 */ // Label 3022: @162261
     /*  162261 */ GIM_Reject,
     /*  162262 */ // Label 2915: @162262
     /*  162262 */ GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(162499),
     /*  162267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162270 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162278 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(162333), // Rule ID 45956 //
     /*  162283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  162286 */     // MIs[0] rs1
     /*  162286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162294 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  162294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162331 */     GIR_RootConstrainSelectedInstOperands,
     /*  162332 */     // GIR_Coverage, 45956,
     /*  162332 */     GIR_EraseRootFromParent_Done,
     /*  162333 */   // Label 3028: @162333
     /*  162333 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(162388), // Rule ID 45957 //
     /*  162338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  162341 */     // MIs[0] rs1
     /*  162341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162349 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  162349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162386 */     GIR_RootConstrainSelectedInstOperands,
     /*  162387 */     // GIR_Coverage, 45957,
     /*  162387 */     GIR_EraseRootFromParent_Done,
     /*  162388 */   // Label 3029: @162388
     /*  162388 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(162443), // Rule ID 46028 //
     /*  162393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  162396 */     // MIs[0] rs1
     /*  162396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162404 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  162404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162437 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162441 */     GIR_RootConstrainSelectedInstOperands,
     /*  162442 */     // GIR_Coverage, 46028,
     /*  162442 */     GIR_EraseRootFromParent_Done,
     /*  162443 */   // Label 3030: @162443
     /*  162443 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(162498), // Rule ID 46029 //
     /*  162448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  162451 */     // MIs[0] rs1
     /*  162451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162459 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  162459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  162462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  162476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  162489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162496 */     GIR_RootConstrainSelectedInstOperands,
     /*  162497 */     // GIR_Coverage, 46029,
     /*  162497 */     GIR_EraseRootFromParent_Done,
     /*  162498 */   // Label 3031: @162498
     /*  162498 */   GIM_Reject,
     /*  162499 */ // Label 3027: @162499
     /*  162499 */ GIM_Reject,
     /*  162500 */ // Label 2916: @162500
     /*  162500 */ GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(162619),
     /*  162505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  162520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162524 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(162571), // Rule ID 46068 //
     /*  162529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162532 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  162532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  162535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  162549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162569 */     GIR_RootConstrainSelectedInstOperands,
     /*  162570 */     // GIR_Coverage, 46068,
     /*  162570 */     GIR_EraseRootFromParent_Done,
     /*  162571 */   // Label 3033: @162571
     /*  162571 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(162618), // Rule ID 46069 //
     /*  162576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162579 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  162579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  162582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  162596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162616 */     GIR_RootConstrainSelectedInstOperands,
     /*  162617 */     // GIR_Coverage, 46069,
     /*  162617 */     GIR_EraseRootFromParent_Done,
     /*  162618 */   // Label 3034: @162618
     /*  162618 */   GIM_Reject,
     /*  162619 */ // Label 3032: @162619
     /*  162619 */ GIM_Reject,
     /*  162620 */ // Label 2917: @162620
     /*  162620 */ GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(162747),
     /*  162625 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162628 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162636 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(162691), // Rule ID 45924 //
     /*  162641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162644 */     // MIs[0] rs1
     /*  162644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162652 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  162652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  162655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  162669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162689 */     GIR_RootConstrainSelectedInstOperands,
     /*  162690 */     // GIR_Coverage, 45924,
     /*  162690 */     GIR_EraseRootFromParent_Done,
     /*  162691 */   // Label 3036: @162691
     /*  162691 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(162746), // Rule ID 45925 //
     /*  162696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162699 */     // MIs[0] rs1
     /*  162699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162707 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  162707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  162710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  162724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162744 */     GIR_RootConstrainSelectedInstOperands,
     /*  162745 */     // GIR_Coverage, 45925,
     /*  162745 */     GIR_EraseRootFromParent_Done,
     /*  162746 */   // Label 3037: @162746
     /*  162746 */   GIM_Reject,
     /*  162747 */ // Label 3035: @162747
     /*  162747 */ GIM_Reject,
     /*  162748 */ // Label 2918: @162748
     /*  162748 */ GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(162985),
     /*  162753 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162756 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162764 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(162819), // Rule ID 45936 //
     /*  162769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162772 */     // MIs[0] rs1
     /*  162772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162780 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  162783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  162797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162817 */     GIR_RootConstrainSelectedInstOperands,
     /*  162818 */     // GIR_Coverage, 45936,
     /*  162818 */     GIR_EraseRootFromParent_Done,
     /*  162819 */   // Label 3039: @162819
     /*  162819 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(162874), // Rule ID 45937 //
     /*  162824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162827 */     // MIs[0] rs1
     /*  162827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162835 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  162838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  162852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162872 */     GIR_RootConstrainSelectedInstOperands,
     /*  162873 */     // GIR_Coverage, 45937,
     /*  162873 */     GIR_EraseRootFromParent_Done,
     /*  162874 */   // Label 3040: @162874
     /*  162874 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(162929), // Rule ID 46012 //
     /*  162879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  162882 */     // MIs[0] rs1
     /*  162882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162890 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  162893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  162907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162927 */     GIR_RootConstrainSelectedInstOperands,
     /*  162928 */     // GIR_Coverage, 46012,
     /*  162928 */     GIR_EraseRootFromParent_Done,
     /*  162929 */   // Label 3041: @162929
     /*  162929 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(162984), // Rule ID 46013 //
     /*  162934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  162937 */     // MIs[0] rs1
     /*  162937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162945 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  162948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  162962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162982 */     GIR_RootConstrainSelectedInstOperands,
     /*  162983 */     // GIR_Coverage, 46013,
     /*  162983 */     GIR_EraseRootFromParent_Done,
     /*  162984 */   // Label 3042: @162984
     /*  162984 */   GIM_Reject,
     /*  162985 */ // Label 3038: @162985
     /*  162985 */ GIM_Reject,
     /*  162986 */ // Label 2919: @162986
     /*  162986 */ GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(163223),
     /*  162991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162994 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163002 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(163057), // Rule ID 45952 //
     /*  163007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163010 */     // MIs[0] rs1
     /*  163010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163018 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163055 */     GIR_RootConstrainSelectedInstOperands,
     /*  163056 */     // GIR_Coverage, 45952,
     /*  163056 */     GIR_EraseRootFromParent_Done,
     /*  163057 */   // Label 3044: @163057
     /*  163057 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(163112), // Rule ID 45953 //
     /*  163062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163065 */     // MIs[0] rs1
     /*  163065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163073 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163110 */     GIR_RootConstrainSelectedInstOperands,
     /*  163111 */     // GIR_Coverage, 45953,
     /*  163111 */     GIR_EraseRootFromParent_Done,
     /*  163112 */   // Label 3045: @163112
     /*  163112 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(163167), // Rule ID 46024 //
     /*  163117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  163120 */     // MIs[0] rs1
     /*  163120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163128 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163165 */     GIR_RootConstrainSelectedInstOperands,
     /*  163166 */     // GIR_Coverage, 46024,
     /*  163166 */     GIR_EraseRootFromParent_Done,
     /*  163167 */   // Label 3046: @163167
     /*  163167 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(163222), // Rule ID 46025 //
     /*  163172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  163175 */     // MIs[0] rs1
     /*  163175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163183 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  163183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  163186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  163200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  163213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163220 */     GIR_RootConstrainSelectedInstOperands,
     /*  163221 */     // GIR_Coverage, 46025,
     /*  163221 */     GIR_EraseRootFromParent_Done,
     /*  163222 */   // Label 3047: @163222
     /*  163222 */   GIM_Reject,
     /*  163223 */ // Label 3043: @163223
     /*  163223 */ GIM_Reject,
     /*  163224 */ // Label 2920: @163224
     /*  163224 */ GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(163461),
     /*  163229 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163232 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163240 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(163295), // Rule ID 45996 //
     /*  163245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  163248 */     // MIs[0] rs1
     /*  163248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163256 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163293 */     GIR_RootConstrainSelectedInstOperands,
     /*  163294 */     // GIR_Coverage, 45996,
     /*  163294 */     GIR_EraseRootFromParent_Done,
     /*  163295 */   // Label 3049: @163295
     /*  163295 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(163350), // Rule ID 45997 //
     /*  163300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  163303 */     // MIs[0] rs1
     /*  163303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163311 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163348 */     GIR_RootConstrainSelectedInstOperands,
     /*  163349 */     // GIR_Coverage, 45997,
     /*  163349 */     GIR_EraseRootFromParent_Done,
     /*  163350 */   // Label 3050: @163350
     /*  163350 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(163405), // Rule ID 46056 //
     /*  163355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  163358 */     // MIs[0] rs1
     /*  163358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163366 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  163366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163403 */     GIR_RootConstrainSelectedInstOperands,
     /*  163404 */     // GIR_Coverage, 46056,
     /*  163404 */     GIR_EraseRootFromParent_Done,
     /*  163405 */   // Label 3051: @163405
     /*  163405 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(163460), // Rule ID 46057 //
     /*  163410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  163413 */     // MIs[0] rs1
     /*  163413 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163421 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  163421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  163424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  163438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  163451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163458 */     GIR_RootConstrainSelectedInstOperands,
     /*  163459 */     // GIR_Coverage, 46057,
     /*  163459 */     GIR_EraseRootFromParent_Done,
     /*  163460 */   // Label 3052: @163460
     /*  163460 */   GIM_Reject,
     /*  163461 */ // Label 3048: @163461
     /*  163461 */ GIM_Reject,
     /*  163462 */ // Label 2921: @163462
     /*  163462 */ GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(163581),
     /*  163467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163470 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163478 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  163482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163486 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(163533), // Rule ID 46072 //
     /*  163491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163494 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  163494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  163497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  163511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163531 */     GIR_RootConstrainSelectedInstOperands,
     /*  163532 */     // GIR_Coverage, 46072,
     /*  163532 */     GIR_EraseRootFromParent_Done,
     /*  163533 */   // Label 3054: @163533
     /*  163533 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(163580), // Rule ID 46073 //
     /*  163538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163541 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  163541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  163544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  163558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163578 */     GIR_RootConstrainSelectedInstOperands,
     /*  163579 */     // GIR_Coverage, 46073,
     /*  163579 */     GIR_EraseRootFromParent_Done,
     /*  163580 */   // Label 3055: @163580
     /*  163580 */   GIM_Reject,
     /*  163581 */ // Label 3053: @163581
     /*  163581 */ GIM_Reject,
     /*  163582 */ // Label 2922: @163582
     /*  163582 */ GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(163709),
     /*  163587 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163598 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(163653), // Rule ID 45928 //
     /*  163603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163606 */     // MIs[0] rs1
     /*  163606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163614 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  163614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  163617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  163631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163651 */     GIR_RootConstrainSelectedInstOperands,
     /*  163652 */     // GIR_Coverage, 45928,
     /*  163652 */     GIR_EraseRootFromParent_Done,
     /*  163653 */   // Label 3057: @163653
     /*  163653 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(163708), // Rule ID 45929 //
     /*  163658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163661 */     // MIs[0] rs1
     /*  163661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163669 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  163669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  163672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  163686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163706 */     GIR_RootConstrainSelectedInstOperands,
     /*  163707 */     // GIR_Coverage, 45929,
     /*  163707 */     GIR_EraseRootFromParent_Done,
     /*  163708 */   // Label 3058: @163708
     /*  163708 */   GIM_Reject,
     /*  163709 */ // Label 3056: @163709
     /*  163709 */ GIM_Reject,
     /*  163710 */ // Label 2923: @163710
     /*  163710 */ GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(163947),
     /*  163715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163718 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163726 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(163781), // Rule ID 45948 //
     /*  163731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163734 */     // MIs[0] rs1
     /*  163734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163742 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  163745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  163759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163779 */     GIR_RootConstrainSelectedInstOperands,
     /*  163780 */     // GIR_Coverage, 45948,
     /*  163780 */     GIR_EraseRootFromParent_Done,
     /*  163781 */   // Label 3060: @163781
     /*  163781 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(163836), // Rule ID 45949 //
     /*  163786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163789 */     // MIs[0] rs1
     /*  163789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163797 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  163800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  163814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163834 */     GIR_RootConstrainSelectedInstOperands,
     /*  163835 */     // GIR_Coverage, 45949,
     /*  163835 */     GIR_EraseRootFromParent_Done,
     /*  163836 */   // Label 3061: @163836
     /*  163836 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(163891), // Rule ID 46020 //
     /*  163841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  163844 */     // MIs[0] rs1
     /*  163844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163852 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  163855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  163869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163889 */     GIR_RootConstrainSelectedInstOperands,
     /*  163890 */     // GIR_Coverage, 46020,
     /*  163890 */     GIR_EraseRootFromParent_Done,
     /*  163891 */   // Label 3062: @163891
     /*  163891 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(163946), // Rule ID 46021 //
     /*  163896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  163899 */     // MIs[0] rs1
     /*  163899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163907 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  163910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  163924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163944 */     GIR_RootConstrainSelectedInstOperands,
     /*  163945 */     // GIR_Coverage, 46021,
     /*  163945 */     GIR_EraseRootFromParent_Done,
     /*  163946 */   // Label 3063: @163946
     /*  163946 */   GIM_Reject,
     /*  163947 */ // Label 3059: @163947
     /*  163947 */ GIM_Reject,
     /*  163948 */ // Label 2924: @163948
     /*  163948 */ GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(164185),
     /*  163953 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163956 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  163964 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(164019), // Rule ID 45984 //
     /*  163969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163972 */     // MIs[0] rs1
     /*  163972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163980 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  163980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  163983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  163997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164017 */     GIR_RootConstrainSelectedInstOperands,
     /*  164018 */     // GIR_Coverage, 45984,
     /*  164018 */     GIR_EraseRootFromParent_Done,
     /*  164019 */   // Label 3065: @164019
     /*  164019 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(164074), // Rule ID 45985 //
     /*  164024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164027 */     // MIs[0] rs1
     /*  164027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164035 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164072 */     GIR_RootConstrainSelectedInstOperands,
     /*  164073 */     // GIR_Coverage, 45985,
     /*  164073 */     GIR_EraseRootFromParent_Done,
     /*  164074 */   // Label 3066: @164074
     /*  164074 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(164129), // Rule ID 46044 //
     /*  164079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  164082 */     // MIs[0] rs1
     /*  164082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164090 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164127 */     GIR_RootConstrainSelectedInstOperands,
     /*  164128 */     // GIR_Coverage, 46044,
     /*  164128 */     GIR_EraseRootFromParent_Done,
     /*  164129 */   // Label 3067: @164129
     /*  164129 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(164184), // Rule ID 46045 //
     /*  164134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  164137 */     // MIs[0] rs1
     /*  164137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164145 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  164148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  164162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164182 */     GIR_RootConstrainSelectedInstOperands,
     /*  164183 */     // GIR_Coverage, 46045,
     /*  164183 */     GIR_EraseRootFromParent_Done,
     /*  164184 */   // Label 3068: @164184
     /*  164184 */   GIM_Reject,
     /*  164185 */ // Label 3064: @164185
     /*  164185 */ GIM_Reject,
     /*  164186 */ // Label 2925: @164186
     /*  164186 */ GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(164423),
     /*  164191 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164194 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  164202 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(164257), // Rule ID 46000 //
     /*  164207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  164210 */     // MIs[0] rs1
     /*  164210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164218 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164255 */     GIR_RootConstrainSelectedInstOperands,
     /*  164256 */     // GIR_Coverage, 46000,
     /*  164256 */     GIR_EraseRootFromParent_Done,
     /*  164257 */   // Label 3070: @164257
     /*  164257 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(164312), // Rule ID 46001 //
     /*  164262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  164265 */     // MIs[0] rs1
     /*  164265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164273 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164310 */     GIR_RootConstrainSelectedInstOperands,
     /*  164311 */     // GIR_Coverage, 46001,
     /*  164311 */     GIR_EraseRootFromParent_Done,
     /*  164312 */   // Label 3071: @164312
     /*  164312 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(164367), // Rule ID 46060 //
     /*  164317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  164320 */     // MIs[0] rs1
     /*  164320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164328 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  164328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164365 */     GIR_RootConstrainSelectedInstOperands,
     /*  164366 */     // GIR_Coverage, 46060,
     /*  164366 */     GIR_EraseRootFromParent_Done,
     /*  164367 */   // Label 3072: @164367
     /*  164367 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(164422), // Rule ID 46061 //
     /*  164372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  164375 */     // MIs[0] rs1
     /*  164375 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164383 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  164383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  164386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  164400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  164413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164420 */     GIR_RootConstrainSelectedInstOperands,
     /*  164421 */     // GIR_Coverage, 46061,
     /*  164421 */     GIR_EraseRootFromParent_Done,
     /*  164422 */   // Label 3073: @164422
     /*  164422 */   GIM_Reject,
     /*  164423 */ // Label 3069: @164423
     /*  164423 */ GIM_Reject,
     /*  164424 */ // Label 2926: @164424
     /*  164424 */ GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(164543),
     /*  164429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164448 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(164495), // Rule ID 46076 //
     /*  164453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164456 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  164456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  164459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  164473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164493 */     GIR_RootConstrainSelectedInstOperands,
     /*  164494 */     // GIR_Coverage, 46076,
     /*  164494 */     GIR_EraseRootFromParent_Done,
     /*  164495 */   // Label 3075: @164495
     /*  164495 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(164542), // Rule ID 46077 //
     /*  164500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164503 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  164503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  164506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  164520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  164533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164540 */     GIR_RootConstrainSelectedInstOperands,
     /*  164541 */     // GIR_Coverage, 46077,
     /*  164541 */     GIR_EraseRootFromParent_Done,
     /*  164542 */   // Label 3076: @164542
     /*  164542 */   GIM_Reject,
     /*  164543 */ // Label 3074: @164543
     /*  164543 */ GIM_Reject,
     /*  164544 */ // Label 2927: @164544
     /*  164544 */ GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(164671),
     /*  164549 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164552 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  164560 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(164615), // Rule ID 45944 //
     /*  164565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164568 */     // MIs[0] rs1
     /*  164568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164576 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  164576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  164579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  164593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164613 */     GIR_RootConstrainSelectedInstOperands,
     /*  164614 */     // GIR_Coverage, 45944,
     /*  164614 */     GIR_EraseRootFromParent_Done,
     /*  164615 */   // Label 3078: @164615
     /*  164615 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(164670), // Rule ID 45945 //
     /*  164620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164623 */     // MIs[0] rs1
     /*  164623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164631 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  164631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  164634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  164648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164668 */     GIR_RootConstrainSelectedInstOperands,
     /*  164669 */     // GIR_Coverage, 45945,
     /*  164669 */     GIR_EraseRootFromParent_Done,
     /*  164670 */   // Label 3079: @164670
     /*  164670 */   GIM_Reject,
     /*  164671 */ // Label 3077: @164671
     /*  164671 */ GIM_Reject,
     /*  164672 */ // Label 2928: @164672
     /*  164672 */ GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(164909),
     /*  164677 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164680 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  164688 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(164743), // Rule ID 45972 //
     /*  164693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164696 */     // MIs[0] rs1
     /*  164696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164704 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  164707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  164721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164741 */     GIR_RootConstrainSelectedInstOperands,
     /*  164742 */     // GIR_Coverage, 45972,
     /*  164742 */     GIR_EraseRootFromParent_Done,
     /*  164743 */   // Label 3081: @164743
     /*  164743 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(164798), // Rule ID 45973 //
     /*  164748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164751 */     // MIs[0] rs1
     /*  164751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164759 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  164762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  164776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164796 */     GIR_RootConstrainSelectedInstOperands,
     /*  164797 */     // GIR_Coverage, 45973,
     /*  164797 */     GIR_EraseRootFromParent_Done,
     /*  164798 */   // Label 3082: @164798
     /*  164798 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(164853), // Rule ID 46032 //
     /*  164803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  164806 */     // MIs[0] rs1
     /*  164806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164814 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  164814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  164817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  164831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164851 */     GIR_RootConstrainSelectedInstOperands,
     /*  164852 */     // GIR_Coverage, 46032,
     /*  164852 */     GIR_EraseRootFromParent_Done,
     /*  164853 */   // Label 3083: @164853
     /*  164853 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(164908), // Rule ID 46033 //
     /*  164858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  164861 */     // MIs[0] rs1
     /*  164861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164869 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  164869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  164872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  164886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  164899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164906 */     GIR_RootConstrainSelectedInstOperands,
     /*  164907 */     // GIR_Coverage, 46033,
     /*  164907 */     GIR_EraseRootFromParent_Done,
     /*  164908 */   // Label 3084: @164908
     /*  164908 */   GIM_Reject,
     /*  164909 */ // Label 3080: @164909
     /*  164909 */ GIM_Reject,
     /*  164910 */ // Label 2929: @164910
     /*  164910 */ GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(165147),
     /*  164915 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  164922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  164926 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(164981), // Rule ID 45988 //
     /*  164931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  164934 */     // MIs[0] rs1
     /*  164934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  164938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164942 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  164942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  164945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  164949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  164954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  164956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  164959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  164964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  164966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  164969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  164972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  164975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164979 */     GIR_RootConstrainSelectedInstOperands,
     /*  164980 */     // GIR_Coverage, 45988,
     /*  164980 */     GIR_EraseRootFromParent_Done,
     /*  164981 */   // Label 3086: @164981
     /*  164981 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(165036), // Rule ID 45989 //
     /*  164986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  164989 */     // MIs[0] rs1
     /*  164989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164997 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  164997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165034 */     GIR_RootConstrainSelectedInstOperands,
     /*  165035 */     // GIR_Coverage, 45989,
     /*  165035 */     GIR_EraseRootFromParent_Done,
     /*  165036 */   // Label 3087: @165036
     /*  165036 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(165091), // Rule ID 46048 //
     /*  165041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  165044 */     // MIs[0] rs1
     /*  165044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165052 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165089 */     GIR_RootConstrainSelectedInstOperands,
     /*  165090 */     // GIR_Coverage, 46048,
     /*  165090 */     GIR_EraseRootFromParent_Done,
     /*  165091 */   // Label 3088: @165091
     /*  165091 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(165146), // Rule ID 46049 //
     /*  165096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  165099 */     // MIs[0] rs1
     /*  165099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165107 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  165110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  165124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165144 */     GIR_RootConstrainSelectedInstOperands,
     /*  165145 */     // GIR_Coverage, 46049,
     /*  165145 */     GIR_EraseRootFromParent_Done,
     /*  165146 */   // Label 3089: @165146
     /*  165146 */   GIM_Reject,
     /*  165147 */ // Label 3085: @165147
     /*  165147 */ GIM_Reject,
     /*  165148 */ // Label 2930: @165148
     /*  165148 */ GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(165385),
     /*  165153 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165156 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165164 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(165219), // Rule ID 46004 //
     /*  165169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  165172 */     // MIs[0] rs1
     /*  165172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165180 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165217 */     GIR_RootConstrainSelectedInstOperands,
     /*  165218 */     // GIR_Coverage, 46004,
     /*  165218 */     GIR_EraseRootFromParent_Done,
     /*  165219 */   // Label 3091: @165219
     /*  165219 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(165274), // Rule ID 46005 //
     /*  165224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  165227 */     // MIs[0] rs1
     /*  165227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165235 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165272 */     GIR_RootConstrainSelectedInstOperands,
     /*  165273 */     // GIR_Coverage, 46005,
     /*  165273 */     GIR_EraseRootFromParent_Done,
     /*  165274 */   // Label 3092: @165274
     /*  165274 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(165329), // Rule ID 46064 //
     /*  165279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  165282 */     // MIs[0] rs1
     /*  165282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165290 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  165290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165327 */     GIR_RootConstrainSelectedInstOperands,
     /*  165328 */     // GIR_Coverage, 46064,
     /*  165328 */     GIR_EraseRootFromParent_Done,
     /*  165329 */   // Label 3093: @165329
     /*  165329 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(165384), // Rule ID 46065 //
     /*  165334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  165337 */     // MIs[0] rs1
     /*  165337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165345 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  165345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  165348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  165362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  165375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165382 */     GIR_RootConstrainSelectedInstOperands,
     /*  165383 */     // GIR_Coverage, 46065,
     /*  165383 */     GIR_EraseRootFromParent_Done,
     /*  165384 */   // Label 3094: @165384
     /*  165384 */   GIM_Reject,
     /*  165385 */ // Label 3090: @165385
     /*  165385 */ GIM_Reject,
     /*  165386 */ // Label 2931: @165386
     /*  165386 */ GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(165505),
     /*  165391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165394 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  165402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  165406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165410 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(165457), // Rule ID 46080 //
     /*  165415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165418 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  165418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  165421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  165435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165455 */     GIR_RootConstrainSelectedInstOperands,
     /*  165456 */     // GIR_Coverage, 46080,
     /*  165456 */     GIR_EraseRootFromParent_Done,
     /*  165457 */   // Label 3096: @165457
     /*  165457 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(165504), // Rule ID 46081 //
     /*  165462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165465 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  165465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  165468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  165482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  165495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165502 */     GIR_RootConstrainSelectedInstOperands,
     /*  165503 */     // GIR_Coverage, 46081,
     /*  165503 */     GIR_EraseRootFromParent_Done,
     /*  165504 */   // Label 3097: @165504
     /*  165504 */   GIM_Reject,
     /*  165505 */ // Label 3095: @165505
     /*  165505 */ GIM_Reject,
     /*  165506 */ // Label 2932: @165506
     /*  165506 */ GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(165633),
     /*  165511 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165514 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  165522 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(165577), // Rule ID 45960 //
     /*  165527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165530 */     // MIs[0] rs1
     /*  165530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165538 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  165538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  165541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  165555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165575 */     GIR_RootConstrainSelectedInstOperands,
     /*  165576 */     // GIR_Coverage, 45960,
     /*  165576 */     GIR_EraseRootFromParent_Done,
     /*  165577 */   // Label 3099: @165577
     /*  165577 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(165632), // Rule ID 45961 //
     /*  165582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165585 */     // MIs[0] rs1
     /*  165585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165593 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  165593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  165596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  165610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165630 */     GIR_RootConstrainSelectedInstOperands,
     /*  165631 */     // GIR_Coverage, 45961,
     /*  165631 */     GIR_EraseRootFromParent_Done,
     /*  165632 */   // Label 3100: @165632
     /*  165632 */   GIM_Reject,
     /*  165633 */ // Label 3098: @165633
     /*  165633 */ GIM_Reject,
     /*  165634 */ // Label 2933: @165634
     /*  165634 */ GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(165871),
     /*  165639 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165642 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  165650 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(165705), // Rule ID 45976 //
     /*  165655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165658 */     // MIs[0] rs1
     /*  165658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165666 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  165669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  165683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165703 */     GIR_RootConstrainSelectedInstOperands,
     /*  165704 */     // GIR_Coverage, 45976,
     /*  165704 */     GIR_EraseRootFromParent_Done,
     /*  165705 */   // Label 3102: @165705
     /*  165705 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(165760), // Rule ID 45977 //
     /*  165710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165713 */     // MIs[0] rs1
     /*  165713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165721 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  165724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  165738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165758 */     GIR_RootConstrainSelectedInstOperands,
     /*  165759 */     // GIR_Coverage, 45977,
     /*  165759 */     GIR_EraseRootFromParent_Done,
     /*  165760 */   // Label 3103: @165760
     /*  165760 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(165815), // Rule ID 46036 //
     /*  165765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  165768 */     // MIs[0] rs1
     /*  165768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165776 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  165776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  165779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  165793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165813 */     GIR_RootConstrainSelectedInstOperands,
     /*  165814 */     // GIR_Coverage, 46036,
     /*  165814 */     GIR_EraseRootFromParent_Done,
     /*  165815 */   // Label 3104: @165815
     /*  165815 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(165870), // Rule ID 46037 //
     /*  165820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  165823 */     // MIs[0] rs1
     /*  165823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165831 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  165831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  165834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  165848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  165861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165868 */     GIR_RootConstrainSelectedInstOperands,
     /*  165869 */     // GIR_Coverage, 46037,
     /*  165869 */     GIR_EraseRootFromParent_Done,
     /*  165870 */   // Label 3105: @165870
     /*  165870 */   GIM_Reject,
     /*  165871 */ // Label 3101: @165871
     /*  165871 */ GIM_Reject,
     /*  165872 */ // Label 2934: @165872
     /*  165872 */ GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(166109),
     /*  165877 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165880 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  165884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  165888 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(165943), // Rule ID 45992 //
     /*  165893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  165896 */     // MIs[0] rs1
     /*  165896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165904 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  165904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  165907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  165921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165941 */     GIR_RootConstrainSelectedInstOperands,
     /*  165942 */     // GIR_Coverage, 45992,
     /*  165942 */     GIR_EraseRootFromParent_Done,
     /*  165943 */   // Label 3107: @165943
     /*  165943 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(165998), // Rule ID 45993 //
     /*  165948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  165951 */     // MIs[0] rs1
     /*  165951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165959 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  165959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  165962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  165966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  165971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  165973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  165976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  165981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  165983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  165986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  165989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  165992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165996 */     GIR_RootConstrainSelectedInstOperands,
     /*  165997 */     // GIR_Coverage, 45993,
     /*  165997 */     GIR_EraseRootFromParent_Done,
     /*  165998 */   // Label 3108: @165998
     /*  165998 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(166053), // Rule ID 46052 //
     /*  166003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  166006 */     // MIs[0] rs1
     /*  166006 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166014 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  166014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166051 */     GIR_RootConstrainSelectedInstOperands,
     /*  166052 */     // GIR_Coverage, 46052,
     /*  166052 */     GIR_EraseRootFromParent_Done,
     /*  166053 */   // Label 3109: @166053
     /*  166053 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(166108), // Rule ID 46053 //
     /*  166058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  166061 */     // MIs[0] rs1
     /*  166061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166069 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  166069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  166072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  166086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  166099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166106 */     GIR_RootConstrainSelectedInstOperands,
     /*  166107 */     // GIR_Coverage, 46053,
     /*  166107 */     GIR_EraseRootFromParent_Done,
     /*  166108 */   // Label 3110: @166108
     /*  166108 */   GIM_Reject,
     /*  166109 */ // Label 3106: @166109
     /*  166109 */ GIM_Reject,
     /*  166110 */ // Label 2935: @166110
     /*  166110 */ GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(166229),
     /*  166115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166118 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166126 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166134 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(166181), // Rule ID 46084 //
     /*  166139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166142 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166179 */     GIR_RootConstrainSelectedInstOperands,
     /*  166180 */     // GIR_Coverage, 46084,
     /*  166180 */     GIR_EraseRootFromParent_Done,
     /*  166181 */   // Label 3112: @166181
     /*  166181 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(166228), // Rule ID 46085 //
     /*  166186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166189 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  166189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  166192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  166206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166226 */     GIR_RootConstrainSelectedInstOperands,
     /*  166227 */     // GIR_Coverage, 46085,
     /*  166227 */     GIR_EraseRootFromParent_Done,
     /*  166228 */   // Label 3113: @166228
     /*  166228 */   GIM_Reject,
     /*  166229 */ // Label 3111: @166229
     /*  166229 */ GIM_Reject,
     /*  166230 */ // Label 2936: @166230
     /*  166230 */ GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(166357),
     /*  166235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  166246 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(166301), // Rule ID 45964 //
     /*  166251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166254 */     // MIs[0] rs1
     /*  166254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166262 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  166265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  166279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166299 */     GIR_RootConstrainSelectedInstOperands,
     /*  166300 */     // GIR_Coverage, 45964,
     /*  166300 */     GIR_EraseRootFromParent_Done,
     /*  166301 */   // Label 3115: @166301
     /*  166301 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(166356), // Rule ID 45965 //
     /*  166306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166309 */     // MIs[0] rs1
     /*  166309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166317 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  166320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  166334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166354 */     GIR_RootConstrainSelectedInstOperands,
     /*  166355 */     // GIR_Coverage, 45965,
     /*  166355 */     GIR_EraseRootFromParent_Done,
     /*  166356 */   // Label 3116: @166356
     /*  166356 */   GIM_Reject,
     /*  166357 */ // Label 3114: @166357
     /*  166357 */ GIM_Reject,
     /*  166358 */ // Label 2937: @166358
     /*  166358 */ GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(166595),
     /*  166363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166374 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(166429), // Rule ID 45980 //
     /*  166379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166382 */     // MIs[0] rs1
     /*  166382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166390 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166427 */     GIR_RootConstrainSelectedInstOperands,
     /*  166428 */     // GIR_Coverage, 45980,
     /*  166428 */     GIR_EraseRootFromParent_Done,
     /*  166429 */   // Label 3118: @166429
     /*  166429 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(166484), // Rule ID 45981 //
     /*  166434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166437 */     // MIs[0] rs1
     /*  166437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166445 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166482 */     GIR_RootConstrainSelectedInstOperands,
     /*  166483 */     // GIR_Coverage, 45981,
     /*  166483 */     GIR_EraseRootFromParent_Done,
     /*  166484 */   // Label 3119: @166484
     /*  166484 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(166539), // Rule ID 46040 //
     /*  166489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  166492 */     // MIs[0] rs1
     /*  166492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166500 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  166500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166537 */     GIR_RootConstrainSelectedInstOperands,
     /*  166538 */     // GIR_Coverage, 46040,
     /*  166538 */     GIR_EraseRootFromParent_Done,
     /*  166539 */   // Label 3120: @166539
     /*  166539 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(166594), // Rule ID 46041 //
     /*  166544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  166547 */     // MIs[0] rs1
     /*  166547 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166555 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  166555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  166558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  166572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  166585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166592 */     GIR_RootConstrainSelectedInstOperands,
     /*  166593 */     // GIR_Coverage, 46041,
     /*  166593 */     GIR_EraseRootFromParent_Done,
     /*  166594 */   // Label 3121: @166594
     /*  166594 */   GIM_Reject,
     /*  166595 */ // Label 3117: @166595
     /*  166595 */ GIM_Reject,
     /*  166596 */ // Label 2938: @166596
     /*  166596 */ GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(166715),
     /*  166601 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166604 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  166612 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166620 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(166667), // Rule ID 46088 //
     /*  166625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166628 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  166628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  166631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  166645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166665 */     GIR_RootConstrainSelectedInstOperands,
     /*  166666 */     // GIR_Coverage, 46088,
     /*  166666 */     GIR_EraseRootFromParent_Done,
     /*  166667 */   // Label 3123: @166667
     /*  166667 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(166714), // Rule ID 46089 //
     /*  166672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166675 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  166675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  166678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  166692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  166705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166712 */     GIR_RootConstrainSelectedInstOperands,
     /*  166713 */     // GIR_Coverage, 46089,
     /*  166713 */     GIR_EraseRootFromParent_Done,
     /*  166714 */   // Label 3124: @166714
     /*  166714 */   GIM_Reject,
     /*  166715 */ // Label 3122: @166715
     /*  166715 */ GIM_Reject,
     /*  166716 */ // Label 2939: @166716
     /*  166716 */ GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(166843),
     /*  166721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  166728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  166732 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(166787), // Rule ID 45968 //
     /*  166737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  166740 */     // MIs[0] rs1
     /*  166740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  166744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166748 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  166748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  166751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  166765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166785 */     GIR_RootConstrainSelectedInstOperands,
     /*  166786 */     // GIR_Coverage, 45968,
     /*  166786 */     GIR_EraseRootFromParent_Done,
     /*  166787 */   // Label 3126: @166787
     /*  166787 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(166842), // Rule ID 45969 //
     /*  166792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  166795 */     // MIs[0] rs1
     /*  166795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166803 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  166803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  166806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  166810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  166815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  166817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  166820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  166825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  166827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  166830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  166836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166840 */     GIR_RootConstrainSelectedInstOperands,
     /*  166841 */     // GIR_Coverage, 45969,
     /*  166841 */     GIR_EraseRootFromParent_Done,
     /*  166842 */   // Label 3127: @166842
     /*  166842 */   GIM_Reject,
     /*  166843 */ // Label 3125: @166843
     /*  166843 */ GIM_Reject,
     /*  166844 */ // Label 2940: @166844
     /*  166844 */ GIM_Reject,
     /*  166845 */ // Label 22: @166845
     /*  166845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3130*/ GIMT_Encode4(167958),
     /*  166856 */ /*GILLT_s32*//*Label 3128*/ GIMT_Encode4(166864),
     /*  166860 */ /*GILLT_s64*//*Label 3129*/ GIMT_Encode4(167384),
     /*  166864 */ // Label 3128: @166864
     /*  166864 */ GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(166918), // Rule ID 231 //
     /*  166869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  166872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166875 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  166882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166897 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  166897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  166900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166902 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166912 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166916 */   GIR_RootConstrainSelectedInstOperands,
     /*  166917 */   // GIR_Coverage, 231,
     /*  166917 */   GIR_EraseRootFromParent_Done,
     /*  166918 */ // Label 3131: @166918
     /*  166918 */ GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(166972), // Rule ID 235 //
     /*  166923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  166926 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166929 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  166936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166940 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166944 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166951 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  166951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  166954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166966 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166970 */   GIR_RootConstrainSelectedInstOperands,
     /*  166971 */   // GIR_Coverage, 235,
     /*  166971 */   GIR_EraseRootFromParent_Done,
     /*  166972 */ // Label 3132: @166972
     /*  166972 */ GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(167029), // Rule ID 324 //
     /*  166977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  166980 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  166983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  166990 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  166993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167001 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167008 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10075>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167018 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167027 */   GIR_RootConstrainSelectedInstOperands,
     /*  167028 */   // GIR_Coverage, 324,
     /*  167028 */   GIR_EraseRootFromParent_Done,
     /*  167029 */ // Label 3133: @167029
     /*  167029 */ GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(167086), // Rule ID 328 //
     /*  167034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  167037 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167040 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167047 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167065 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10077>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167084 */   GIR_RootConstrainSelectedInstOperands,
     /*  167085 */   // GIR_Coverage, 328,
     /*  167085 */   GIR_EraseRootFromParent_Done,
     /*  167086 */ // Label 3134: @167086
     /*  167086 */ GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(167143), // Rule ID 344 //
     /*  167091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  167094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167104 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167111 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167115 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167122 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10091>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  167125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167141 */   GIR_RootConstrainSelectedInstOperands,
     /*  167142 */   // GIR_Coverage, 344,
     /*  167142 */   GIR_EraseRootFromParent_Done,
     /*  167143 */ // Label 3135: @167143
     /*  167143 */ GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(167183), // Rule ID 1100 //
     /*  167148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167151 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167161 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167168 */   // MIs[0] rs1
     /*  167168 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167176 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10579>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167181 */   GIR_RootConstrainSelectedInstOperands,
     /*  167182 */   // GIR_Coverage, 1100,
     /*  167182 */   GIR_Done,
     /*  167183 */ // Label 3136: @167183
     /*  167183 */ GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(167223), // Rule ID 1104 //
     /*  167188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167191 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167194 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167201 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167208 */   // MIs[0] rs1
     /*  167208 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167216 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10581>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167221 */   GIR_RootConstrainSelectedInstOperands,
     /*  167222 */   // GIR_Coverage, 1104,
     /*  167222 */   GIR_Done,
     /*  167223 */ // Label 3137: @167223
     /*  167223 */ GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(167263), // Rule ID 1108 //
     /*  167228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167231 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167234 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167248 */   // MIs[0] rs1
     /*  167248 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167256 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10583>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167261 */   GIR_RootConstrainSelectedInstOperands,
     /*  167262 */   // GIR_Coverage, 1108,
     /*  167262 */   GIR_Done,
     /*  167263 */ // Label 3138: @167263
     /*  167263 */ GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(167303), // Rule ID 1112 //
     /*  167268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  167271 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167274 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167288 */   // MIs[0] rs1
     /*  167288 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167296 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10585>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167296 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167301 */   GIR_RootConstrainSelectedInstOperands,
     /*  167302 */   // GIR_Coverage, 1112,
     /*  167302 */   GIR_Done,
     /*  167303 */ // Label 3139: @167303
     /*  167303 */ GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(167343), // Rule ID 1132 //
     /*  167308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  167311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167321 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167328 */   // MIs[0] rs1
     /*  167328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167336 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10603>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167341 */   GIR_RootConstrainSelectedInstOperands,
     /*  167342 */   // GIR_Coverage, 1132,
     /*  167342 */   GIR_Done,
     /*  167343 */ // Label 3140: @167343
     /*  167343 */ GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(167383), // Rule ID 1136 //
     /*  167348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  167351 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167361 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167368 */   // MIs[0] rs1
     /*  167368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167376 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10605>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  167376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167381 */   GIR_RootConstrainSelectedInstOperands,
     /*  167382 */   // GIR_Coverage, 1136,
     /*  167382 */   GIR_Done,
     /*  167383 */ // Label 3141: @167383
     /*  167383 */ GIM_Reject,
     /*  167384 */ // Label 3129: @167384
     /*  167384 */ GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(167438), // Rule ID 230 //
     /*  167389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167395 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167410 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167417 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167436 */   GIR_RootConstrainSelectedInstOperands,
     /*  167437 */   // GIR_Coverage, 230,
     /*  167437 */   GIR_EraseRootFromParent_Done,
     /*  167438 */ // Label 3142: @167438
     /*  167438 */ GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(167492), // Rule ID 234 //
     /*  167443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167446 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167471 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167476 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167481 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167486 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167490 */   GIR_RootConstrainSelectedInstOperands,
     /*  167491 */   // GIR_Coverage, 234,
     /*  167491 */   GIR_EraseRootFromParent_Done,
     /*  167492 */ // Label 3143: @167492
     /*  167492 */ GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(167546), // Rule ID 281 //
     /*  167497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  167500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167503 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167518 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167525 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  167528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167544 */   GIR_RootConstrainSelectedInstOperands,
     /*  167545 */   // GIR_Coverage, 281,
     /*  167545 */   GIR_EraseRootFromParent_Done,
     /*  167546 */ // Label 3144: @167546
     /*  167546 */ GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(167603), // Rule ID 323 //
     /*  167551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  167554 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167557 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167564 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167582 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10075>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  167585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167601 */   GIR_RootConstrainSelectedInstOperands,
     /*  167602 */   // GIR_Coverage, 323,
     /*  167602 */   GIR_EraseRootFromParent_Done,
     /*  167603 */ // Label 3145: @167603
     /*  167603 */ GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(167660), // Rule ID 327 //
     /*  167608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  167611 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167614 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167621 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167628 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167632 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167639 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10077>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  167642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167644 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167654 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167658 */   GIR_RootConstrainSelectedInstOperands,
     /*  167659 */   // GIR_Coverage, 327,
     /*  167659 */   GIR_EraseRootFromParent_Done,
     /*  167660 */ // Label 3146: @167660
     /*  167660 */ GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(167717), // Rule ID 343 //
     /*  167665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  167668 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167671 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167678 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167685 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167689 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167696 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10091>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  167699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  167701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167715 */   GIR_RootConstrainSelectedInstOperands,
     /*  167716 */   // GIR_Coverage, 343,
     /*  167716 */   GIR_EraseRootFromParent_Done,
     /*  167717 */ // Label 3147: @167717
     /*  167717 */ GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(167757), // Rule ID 1099 //
     /*  167722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  167725 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167742 */   // MIs[0] rs1
     /*  167742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167750 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10579>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167750 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167755 */   GIR_RootConstrainSelectedInstOperands,
     /*  167756 */   // GIR_Coverage, 1099,
     /*  167756 */   GIR_Done,
     /*  167757 */ // Label 3148: @167757
     /*  167757 */ GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(167797), // Rule ID 1103 //
     /*  167762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  167765 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167782 */   // MIs[0] rs1
     /*  167782 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167790 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10581>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  167795 */   GIR_RootConstrainSelectedInstOperands,
     /*  167796 */   // GIR_Coverage, 1103,
     /*  167796 */   GIR_Done,
     /*  167797 */ // Label 3149: @167797
     /*  167797 */ GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(167837), // Rule ID 1107 //
     /*  167802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  167805 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167808 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167822 */   // MIs[0] rs1
     /*  167822 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167830 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10583>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167835 */   GIR_RootConstrainSelectedInstOperands,
     /*  167836 */   // GIR_Coverage, 1107,
     /*  167836 */   GIR_Done,
     /*  167837 */ // Label 3150: @167837
     /*  167837 */ GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(167877), // Rule ID 1111 //
     /*  167842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  167845 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167848 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167855 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167862 */   // MIs[0] rs1
     /*  167862 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167870 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10585>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167870 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  167875 */   GIR_RootConstrainSelectedInstOperands,
     /*  167876 */   // GIR_Coverage, 1111,
     /*  167876 */   GIR_Done,
     /*  167877 */ // Label 3151: @167877
     /*  167877 */ GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(167917), // Rule ID 1131 //
     /*  167882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  167885 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167888 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  167898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167902 */   // MIs[0] rs1
     /*  167902 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167910 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10603>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167910 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167915 */   GIR_RootConstrainSelectedInstOperands,
     /*  167916 */   // GIR_Coverage, 1131,
     /*  167916 */   GIR_Done,
     /*  167917 */ // Label 3152: @167917
     /*  167917 */ GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(167957), // Rule ID 1135 //
     /*  167922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  167925 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167928 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  167935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  167938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167942 */   // MIs[0] rs1
     /*  167942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  167946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167950 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10605>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  167950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  167955 */   GIR_RootConstrainSelectedInstOperands,
     /*  167956 */   // GIR_Coverage, 1135,
     /*  167956 */   GIR_Done,
     /*  167957 */ // Label 3153: @167957
     /*  167957 */ GIM_Reject,
     /*  167958 */ // Label 3130: @167958
     /*  167958 */ GIM_Reject,
     /*  167959 */ // Label 23: @167959
     /*  167959 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3156*/ GIMT_Encode4(168592),
     /*  167970 */ /*GILLT_s32*//*Label 3154*/ GIMT_Encode4(167978),
     /*  167974 */ /*GILLT_s64*//*Label 3155*/ GIMT_Encode4(168258),
     /*  167978 */ // Label 3154: @167978
     /*  167978 */ GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(168032), // Rule ID 241 //
     /*  167983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  167986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167989 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168000 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168004 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168011 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168030 */   GIR_RootConstrainSelectedInstOperands,
     /*  168031 */   // GIR_Coverage, 241,
     /*  168031 */   GIR_EraseRootFromParent_Done,
     /*  168032 */ // Label 3157: @168032
     /*  168032 */ GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(168086), // Rule ID 243 //
     /*  168037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  168040 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168043 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168054 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168058 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168065 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168084 */   GIR_RootConstrainSelectedInstOperands,
     /*  168085 */   // GIR_Coverage, 243,
     /*  168085 */   GIR_EraseRootFromParent_Done,
     /*  168086 */ // Label 3158: @168086
     /*  168086 */ GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(168143), // Rule ID 330 //
     /*  168091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168094 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168097 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168104 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168111 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168115 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168122 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10079>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168137 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168141 */   GIR_RootConstrainSelectedInstOperands,
     /*  168142 */   // GIR_Coverage, 330,
     /*  168142 */   GIR_EraseRootFromParent_Done,
     /*  168143 */ // Label 3159: @168143
     /*  168143 */ GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(168200), // Rule ID 332 //
     /*  168148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168151 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168154 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168161 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168168 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168179 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10081>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168198 */   GIR_RootConstrainSelectedInstOperands,
     /*  168199 */   // GIR_Coverage, 332,
     /*  168199 */   GIR_EraseRootFromParent_Done,
     /*  168200 */ // Label 3160: @168200
     /*  168200 */ GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(168257), // Rule ID 346 //
     /*  168205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  168208 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168211 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168218 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168229 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168236 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10093>>  =>  (LWU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168251 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168255 */   GIR_RootConstrainSelectedInstOperands,
     /*  168256 */   // GIR_Coverage, 346,
     /*  168256 */   GIR_EraseRootFromParent_Done,
     /*  168257 */ // Label 3161: @168257
     /*  168257 */ GIM_Reject,
     /*  168258 */ // Label 3155: @168258
     /*  168258 */ GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(168312), // Rule ID 240 //
     /*  168263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  168266 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168269 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168284 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168291 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168310 */   GIR_RootConstrainSelectedInstOperands,
     /*  168311 */   // GIR_Coverage, 240,
     /*  168311 */   GIR_EraseRootFromParent_Done,
     /*  168312 */ // Label 3162: @168312
     /*  168312 */ GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(168366), // Rule ID 242 //
     /*  168317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  168320 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168338 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168345 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168360 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168364 */   GIR_RootConstrainSelectedInstOperands,
     /*  168365 */   // GIR_Coverage, 242,
     /*  168365 */   GIR_EraseRootFromParent_Done,
     /*  168366 */ // Label 3163: @168366
     /*  168366 */ GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(168420), // Rule ID 283 //
     /*  168371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  168374 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168377 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168388 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168392 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168399 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168404 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168414 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168418 */   GIR_RootConstrainSelectedInstOperands,
     /*  168419 */   // GIR_Coverage, 283,
     /*  168419 */   GIR_EraseRootFromParent_Done,
     /*  168420 */ // Label 3164: @168420
     /*  168420 */ GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(168477), // Rule ID 329 //
     /*  168425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168428 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168456 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10079>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  168459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168475 */   GIR_RootConstrainSelectedInstOperands,
     /*  168476 */   // GIR_Coverage, 329,
     /*  168476 */   GIR_EraseRootFromParent_Done,
     /*  168477 */ // Label 3165: @168477
     /*  168477 */ GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(168534), // Rule ID 331 //
     /*  168482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168485 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168488 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168495 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168502 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168506 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168513 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10081>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  168516 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168532 */   GIR_RootConstrainSelectedInstOperands,
     /*  168533 */   // GIR_Coverage, 331,
     /*  168533 */   GIR_EraseRootFromParent_Done,
     /*  168534 */ // Label 3166: @168534
     /*  168534 */ GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(168591), // Rule ID 345 //
     /*  168539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  168542 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168545 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  168552 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  168555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168559 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168563 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168570 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10093>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  168573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  168575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168589 */   GIR_RootConstrainSelectedInstOperands,
     /*  168590 */   // GIR_Coverage, 345,
     /*  168590 */   GIR_EraseRootFromParent_Done,
     /*  168591 */ // Label 3167: @168591
     /*  168591 */ GIM_Reject,
     /*  168592 */ // Label 3156: @168592
     /*  168592 */ GIM_Reject,
     /*  168593 */ // Label 24: @168593
     /*  168593 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 3202*/ GIMT_Encode4(175492),
     /*  168604 */ /*GILLT_p0s32*//*Label 3168*/ GIMT_Encode4(168740),
     /*  168608 */ /*GILLT_p0s64*//*Label 3169*/ GIMT_Encode4(168834),
     /*  168612 */ /*GILLT_s16*//*Label 3170*/ GIMT_Encode4(168928),
     /*  168616 */ /*GILLT_s32*//*Label 3171*/ GIMT_Encode4(169567),
     /*  168620 */ /*GILLT_s64*//*Label 3172*/ GIMT_Encode4(170869),
     /*  168624 */ /*GILLT_nxv1s1*//*Label 3173*/ GIMT_Encode4(171946),
     /*  168628 */ /*GILLT_nxv1s8*//*Label 3174*/ GIMT_Encode4(172026),
     /*  168632 */ /*GILLT_nxv1s16*//*Label 3175*/ GIMT_Encode4(172114),
     /*  168636 */ /*GILLT_nxv1s32*//*Label 3176*/ GIMT_Encode4(172272),
     /*  168640 */ /*GILLT_nxv1s64*//*Label 3177*/ GIMT_Encode4(172430),
     /*  168644 */ /*GILLT_nxv2s1*//*Label 3178*/ GIMT_Encode4(172588),
     /*  168648 */ /*GILLT_nxv2s8*//*Label 3179*/ GIMT_Encode4(172668),
     /*  168652 */ /*GILLT_nxv2s16*//*Label 3180*/ GIMT_Encode4(172756),
     /*  168656 */ /*GILLT_nxv2s32*//*Label 3181*/ GIMT_Encode4(172914),
     /*  168660 */ /*GILLT_nxv2s64*//*Label 3182*/ GIMT_Encode4(173072),
     /*  168664 */ /*GILLT_nxv4s1*//*Label 3183*/ GIMT_Encode4(173230),
     /*  168668 */ /*GILLT_nxv4s8*//*Label 3184*/ GIMT_Encode4(173310),
     /*  168672 */ /*GILLT_nxv4s16*//*Label 3185*/ GIMT_Encode4(173398),
     /*  168676 */ /*GILLT_nxv4s32*//*Label 3186*/ GIMT_Encode4(173556),
     /*  168680 */ /*GILLT_nxv4s64*//*Label 3187*/ GIMT_Encode4(173714),
     /*  168684 */ /*GILLT_nxv8s1*//*Label 3188*/ GIMT_Encode4(173872),
     /*  168688 */ /*GILLT_nxv8s8*//*Label 3189*/ GIMT_Encode4(173952),
     /*  168692 */ /*GILLT_nxv8s16*//*Label 3190*/ GIMT_Encode4(174040),
     /*  168696 */ /*GILLT_nxv8s32*//*Label 3191*/ GIMT_Encode4(174198),
     /*  168700 */ /*GILLT_nxv8s64*//*Label 3192*/ GIMT_Encode4(174356),
     /*  168704 */ /*GILLT_nxv16s1*//*Label 3193*/ GIMT_Encode4(174514),
     /*  168708 */ /*GILLT_nxv16s8*//*Label 3194*/ GIMT_Encode4(174594),
     /*  168712 */ /*GILLT_nxv16s16*//*Label 3195*/ GIMT_Encode4(174682),
     /*  168716 */ /*GILLT_nxv16s32*//*Label 3196*/ GIMT_Encode4(174840),
     /*  168720 */ /*GILLT_nxv32s1*//*Label 3197*/ GIMT_Encode4(174998),
     /*  168724 */ /*GILLT_nxv32s8*//*Label 3198*/ GIMT_Encode4(175078),
     /*  168728 */ /*GILLT_nxv32s16*//*Label 3199*/ GIMT_Encode4(175166),
     /*  168732 */ /*GILLT_nxv64s1*//*Label 3200*/ GIMT_Encode4(175324),
     /*  168736 */ /*GILLT_nxv64s8*//*Label 3201*/ GIMT_Encode4(175404),
     /*  168740 */ // Label 3168: @168740
     /*  168740 */ GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(168833),
     /*  168745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168756 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168760 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(168796), // Rule ID 65342 //
     /*  168765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  168768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168775 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  168778 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168794 */     GIR_RootConstrainSelectedInstOperands,
     /*  168795 */     // GIR_Coverage, 65342,
     /*  168795 */     GIR_EraseRootFromParent_Done,
     /*  168796 */   // Label 3204: @168796
     /*  168796 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(168832), // Rule ID 65346 //
     /*  168801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  168804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168811 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  168811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  168814 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168830 */     GIR_RootConstrainSelectedInstOperands,
     /*  168831 */     // GIR_Coverage, 65346,
     /*  168831 */     GIR_EraseRootFromParent_Done,
     /*  168832 */   // Label 3205: @168832
     /*  168832 */   GIM_Reject,
     /*  168833 */ // Label 3203: @168833
     /*  168833 */ GIM_Reject,
     /*  168834 */ // Label 3169: @168834
     /*  168834 */ GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(168927),
     /*  168839 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168842 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168850 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168854 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(168890), // Rule ID 65341 //
     /*  168859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  168862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168869 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  168872 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168888 */     GIR_RootConstrainSelectedInstOperands,
     /*  168889 */     // GIR_Coverage, 65341,
     /*  168889 */     GIR_EraseRootFromParent_Done,
     /*  168890 */   // Label 3207: @168890
     /*  168890 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(168926), // Rule ID 65345 //
     /*  168895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  168898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168905 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  168908 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168924 */     GIR_RootConstrainSelectedInstOperands,
     /*  168925 */     // GIR_Coverage, 65345,
     /*  168925 */     GIR_EraseRootFromParent_Done,
     /*  168926 */   // Label 3208: @168926
     /*  168926 */   GIM_Reject,
     /*  168927 */ // Label 3206: @168927
     /*  168927 */ GIM_Reject,
     /*  168928 */ // Label 3170: @168928
     /*  168928 */ GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(168982), // Rule ID 65359 //
     /*  168933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  168936 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168950 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  168954 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  168961 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  168961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  168964 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  168966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  168971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  168976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  168980 */   GIR_RootConstrainSelectedInstOperands,
     /*  168981 */   // GIR_Coverage, 65359,
     /*  168981 */   GIR_EraseRootFromParent_Done,
     /*  168982 */ // Label 3209: @168982
     /*  168982 */ GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(169036), // Rule ID 65360 //
     /*  168987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  168990 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  168993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169015 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169018 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169034 */   GIR_RootConstrainSelectedInstOperands,
     /*  169035 */   // GIR_Coverage, 65360,
     /*  169035 */   GIR_EraseRootFromParent_Done,
     /*  169036 */ // Label 3210: @169036
     /*  169036 */ GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(169090), // Rule ID 65361 //
     /*  169041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  169044 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169047 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169058 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169062 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169069 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169072 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169074 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169079 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169088 */   GIR_RootConstrainSelectedInstOperands,
     /*  169089 */   // GIR_Coverage, 65361,
     /*  169089 */   GIR_EraseRootFromParent_Done,
     /*  169090 */ // Label 3211: @169090
     /*  169090 */ GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(169144), // Rule ID 65362 //
     /*  169095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169098 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169123 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169126 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169142 */   GIR_RootConstrainSelectedInstOperands,
     /*  169143 */   // GIR_Coverage, 65362,
     /*  169143 */   GIR_EraseRootFromParent_Done,
     /*  169144 */ // Label 3212: @169144
     /*  169144 */ GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(169195), // Rule ID 2148 //
     /*  169149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  169152 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169155 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  169163 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169167 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169174 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  169177 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169189 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169193 */   GIR_RootConstrainSelectedInstOperands,
     /*  169194 */   // GIR_Coverage, 2148,
     /*  169194 */   GIR_EraseRootFromParent_Done,
     /*  169195 */ // Label 3213: @169195
     /*  169195 */ GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(169246), // Rule ID 2149 //
     /*  169200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  169203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  169214 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169218 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169225 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  169228 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169244 */   GIR_RootConstrainSelectedInstOperands,
     /*  169245 */   // GIR_Coverage, 2149,
     /*  169245 */   GIR_EraseRootFromParent_Done,
     /*  169246 */ // Label 3214: @169246
     /*  169246 */ GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(169297), // Rule ID 2154 //
     /*  169251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  169254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169257 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  169265 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169269 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169276 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  169279 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169295 */   GIR_RootConstrainSelectedInstOperands,
     /*  169296 */   // GIR_Coverage, 2154,
     /*  169296 */   GIR_EraseRootFromParent_Done,
     /*  169297 */ // Label 3215: @169297
     /*  169297 */ GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(169348), // Rule ID 2155 //
     /*  169302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  169305 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169308 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  169316 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169320 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169327 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  169330 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169332 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169337 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169342 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169346 */   GIR_RootConstrainSelectedInstOperands,
     /*  169347 */   // GIR_Coverage, 2155,
     /*  169347 */   GIR_EraseRootFromParent_Done,
     /*  169348 */ // Label 3216: @169348
     /*  169348 */ GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(169399), // Rule ID 65349 //
     /*  169353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169356 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169359 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169367 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169371 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169378 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169381 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169383 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169393 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169397 */   GIR_RootConstrainSelectedInstOperands,
     /*  169398 */   // GIR_Coverage, 65349,
     /*  169398 */   GIR_EraseRootFromParent_Done,
     /*  169399 */ // Label 3217: @169399
     /*  169399 */ GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(169450), // Rule ID 65350 //
     /*  169404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169407 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169410 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169418 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169422 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169429 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169432 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169434 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169439 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169444 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169448 */   GIR_RootConstrainSelectedInstOperands,
     /*  169449 */   // GIR_Coverage, 65350,
     /*  169449 */   GIR_EraseRootFromParent_Done,
     /*  169450 */ // Label 3218: @169450
     /*  169450 */ GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(169508), // Rule ID 65353 //
     /*  169455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169458 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169461 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169465 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169476 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169487 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169490 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169506 */   GIR_RootConstrainSelectedInstOperands,
     /*  169507 */   // GIR_Coverage, 65353,
     /*  169507 */   GIR_EraseRootFromParent_Done,
     /*  169508 */ // Label 3219: @169508
     /*  169508 */ GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(169566), // Rule ID 65354 //
     /*  169513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169516 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169519 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169534 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169538 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169545 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169548 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169555 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169564 */   GIR_RootConstrainSelectedInstOperands,
     /*  169565 */   // GIR_Coverage, 65354,
     /*  169565 */   GIR_EraseRootFromParent_Done,
     /*  169566 */ // Label 3220: @169566
     /*  169566 */ GIM_Reject,
     /*  169567 */ // Label 3171: @169567
     /*  169567 */ GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(169624), // Rule ID 334 //
     /*  169572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169575 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169578 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169585 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  169588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169603 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10083>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169606 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169622 */   GIR_RootConstrainSelectedInstOperands,
     /*  169623 */   // GIR_Coverage, 334,
     /*  169623 */   GIR_EraseRootFromParent_Done,
     /*  169624 */ // Label 3221: @169624
     /*  169624 */ GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(169681), // Rule ID 336 //
     /*  169629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169632 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169635 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169642 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  169645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169649 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169653 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169660 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10085>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169663 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169665 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169675 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169679 */   GIR_RootConstrainSelectedInstOperands,
     /*  169680 */   // GIR_Coverage, 336,
     /*  169680 */   GIR_EraseRootFromParent_Done,
     /*  169681 */ // Label 3222: @169681
     /*  169681 */ GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(169738), // Rule ID 338 //
     /*  169686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169689 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169692 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169699 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  169702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169706 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169710 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169717 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10087>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169720 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169722 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169727 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169732 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169736 */   GIR_RootConstrainSelectedInstOperands,
     /*  169737 */   // GIR_Coverage, 338,
     /*  169737 */   GIR_EraseRootFromParent_Done,
     /*  169738 */ // Label 3223: @169738
     /*  169738 */ GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(169792), // Rule ID 65365 //
     /*  169743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  169746 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169749 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169760 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169764 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169771 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169774 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169776 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169781 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169786 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169790 */   GIR_RootConstrainSelectedInstOperands,
     /*  169791 */   // GIR_Coverage, 65365,
     /*  169791 */   GIR_EraseRootFromParent_Done,
     /*  169792 */ // Label 3224: @169792
     /*  169792 */ GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(169846), // Rule ID 65366 //
     /*  169797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  169800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169818 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169825 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169828 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169830 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169835 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169840 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169844 */   GIR_RootConstrainSelectedInstOperands,
     /*  169845 */   // GIR_Coverage, 65366,
     /*  169845 */   GIR_EraseRootFromParent_Done,
     /*  169846 */ // Label 3225: @169846
     /*  169846 */ GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(169904), // Rule ID 245 //
     /*  169851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169854 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169857 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169861 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169872 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169876 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169883 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169886 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169893 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169898 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169902 */   GIR_RootConstrainSelectedInstOperands,
     /*  169903 */   // GIR_Coverage, 245,
     /*  169903 */   GIR_EraseRootFromParent_Done,
     /*  169904 */ // Label 3226: @169904
     /*  169904 */ GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(169962), // Rule ID 247 //
     /*  169909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169915 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169919 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169930 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169934 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169941 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169944 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169956 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169960 */   GIR_RootConstrainSelectedInstOperands,
     /*  169961 */   // GIR_Coverage, 247,
     /*  169961 */   GIR_EraseRootFromParent_Done,
     /*  169962 */ // Label 3227: @169962
     /*  169962 */ GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(170013), // Rule ID 248 //
     /*  169967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169970 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169973 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169981 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169985 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169992 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169995 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170011 */   GIR_RootConstrainSelectedInstOperands,
     /*  170012 */   // GIR_Coverage, 248,
     /*  170012 */   GIR_EraseRootFromParent_Done,
     /*  170013 */ // Label 3228: @170013
     /*  170013 */ GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(170064), // Rule ID 249 //
     /*  170018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  170021 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170024 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170032 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170036 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170043 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170046 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170058 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170062 */   GIR_RootConstrainSelectedInstOperands,
     /*  170063 */   // GIR_Coverage, 249,
     /*  170063 */   GIR_EraseRootFromParent_Done,
     /*  170064 */ // Label 3229: @170064
     /*  170064 */ GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(170115), // Rule ID 1435 //
     /*  170069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  170072 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170075 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  170083 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170087 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170094 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  170097 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170099 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170113 */   GIR_RootConstrainSelectedInstOperands,
     /*  170114 */   // GIR_Coverage, 1435,
     /*  170114 */   GIR_EraseRootFromParent_Done,
     /*  170115 */ // Label 3230: @170115
     /*  170115 */ GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(170166), // Rule ID 1436 //
     /*  170120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  170123 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170126 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  170134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170145 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  170148 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170160 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170164 */   GIR_RootConstrainSelectedInstOperands,
     /*  170165 */   // GIR_Coverage, 1436,
     /*  170165 */   GIR_EraseRootFromParent_Done,
     /*  170166 */ // Label 3231: @170166
     /*  170166 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(170217), // Rule ID 1441 //
     /*  170171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  170174 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170177 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  170185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170196 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  170199 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170215 */   GIR_RootConstrainSelectedInstOperands,
     /*  170216 */   // GIR_Coverage, 1441,
     /*  170216 */   GIR_EraseRootFromParent_Done,
     /*  170217 */ // Label 3232: @170217
     /*  170217 */ GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(170268), // Rule ID 1442 //
     /*  170222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  170225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170228 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  170236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170240 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170247 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  170250 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170266 */   GIR_RootConstrainSelectedInstOperands,
     /*  170267 */   // GIR_Coverage, 1442,
     /*  170267 */   GIR_EraseRootFromParent_Done,
     /*  170268 */ // Label 3233: @170268
     /*  170268 */ GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(170326), // Rule ID 65371 //
     /*  170273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170276 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170279 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170283 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170294 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170298 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170305 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170308 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170320 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170324 */   GIR_RootConstrainSelectedInstOperands,
     /*  170325 */   // GIR_Coverage, 65371,
     /*  170325 */   GIR_EraseRootFromParent_Done,
     /*  170326 */ // Label 3234: @170326
     /*  170326 */ GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(170384), // Rule ID 65372 //
     /*  170331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  170334 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170337 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170341 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170352 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170356 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170363 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170366 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170382 */   GIR_RootConstrainSelectedInstOperands,
     /*  170383 */   // GIR_Coverage, 65372,
     /*  170383 */   GIR_EraseRootFromParent_Done,
     /*  170384 */ // Label 3235: @170384
     /*  170384 */ GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(170442), // Rule ID 65373 //
     /*  170389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170395 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170399 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170410 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170414 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170421 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170424 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170426 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170436 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170440 */   GIR_RootConstrainSelectedInstOperands,
     /*  170441 */   // GIR_Coverage, 65373,
     /*  170441 */   GIR_EraseRootFromParent_Done,
     /*  170442 */ // Label 3236: @170442
     /*  170442 */ GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(170500), // Rule ID 65374 //
     /*  170447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  170450 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170453 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170457 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170479 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170482 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170498 */   GIR_RootConstrainSelectedInstOperands,
     /*  170499 */   // GIR_Coverage, 65374,
     /*  170499 */   GIR_EraseRootFromParent_Done,
     /*  170500 */ // Label 3237: @170500
     /*  170500 */ GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(170546), // Rule ID 1114 //
     /*  170505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170508 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170511 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170518 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170525 */   // MIs[0] rs1
     /*  170525 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170533 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10587>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  170536 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170538 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170544 */   GIR_RootConstrainSelectedInstOperands,
     /*  170545 */   // GIR_Coverage, 1114,
     /*  170545 */   GIR_EraseRootFromParent_Done,
     /*  170546 */ // Label 3238: @170546
     /*  170546 */ GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(170592), // Rule ID 1116 //
     /*  170551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170554 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170557 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170564 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170571 */   // MIs[0] rs1
     /*  170571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170579 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10589>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  170582 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170584 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170586 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170590 */   GIR_RootConstrainSelectedInstOperands,
     /*  170591 */   // GIR_Coverage, 1116,
     /*  170591 */   GIR_EraseRootFromParent_Done,
     /*  170592 */ // Label 3239: @170592
     /*  170592 */ GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(170638), // Rule ID 1118 //
     /*  170597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170600 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170603 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170617 */   // MIs[0] rs1
     /*  170617 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170625 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10591>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  170628 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170630 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170632 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170636 */   GIR_RootConstrainSelectedInstOperands,
     /*  170637 */   // GIR_Coverage, 1118,
     /*  170637 */   GIR_EraseRootFromParent_Done,
     /*  170638 */ // Label 3240: @170638
     /*  170638 */ GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(170684), // Rule ID 1120 //
     /*  170643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170646 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170649 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170656 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170663 */   // MIs[0] rs1
     /*  170663 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170671 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10593>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  170674 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170676 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170682 */   GIR_RootConstrainSelectedInstOperands,
     /*  170683 */   // GIR_Coverage, 1120,
     /*  170683 */   GIR_EraseRootFromParent_Done,
     /*  170684 */ // Label 3241: @170684
     /*  170684 */ GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(170730), // Rule ID 1122 //
     /*  170689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170692 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170702 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170709 */   // MIs[0] rs1
     /*  170709 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170717 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10595>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  170720 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170722 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170728 */   GIR_RootConstrainSelectedInstOperands,
     /*  170729 */   // GIR_Coverage, 1122,
     /*  170729 */   GIR_EraseRootFromParent_Done,
     /*  170730 */ // Label 3242: @170730
     /*  170730 */ GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(170776), // Rule ID 1124 //
     /*  170735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170738 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170741 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170748 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170755 */   // MIs[0] rs1
     /*  170755 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170763 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10597>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  170766 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170768 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170774 */   GIR_RootConstrainSelectedInstOperands,
     /*  170775 */   // GIR_Coverage, 1124,
     /*  170775 */   GIR_EraseRootFromParent_Done,
     /*  170776 */ // Label 3243: @170776
     /*  170776 */ GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(170822), // Rule ID 1142 //
     /*  170781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  170784 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  170794 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170801 */   // MIs[0] rs1
     /*  170801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170809 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10611>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  170812 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170814 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170820 */   GIR_RootConstrainSelectedInstOperands,
     /*  170821 */   // GIR_Coverage, 1142,
     /*  170821 */   GIR_EraseRootFromParent_Done,
     /*  170822 */ // Label 3244: @170822
     /*  170822 */ GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(170868), // Rule ID 1144 //
     /*  170827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  170830 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170833 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  170840 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170847 */   // MIs[0] rs1
     /*  170847 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170855 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10613>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  170858 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170860 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170862 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170866 */   GIR_RootConstrainSelectedInstOperands,
     /*  170867 */   // GIR_Coverage, 1144,
     /*  170867 */   GIR_EraseRootFromParent_Done,
     /*  170868 */ // Label 3245: @170868
     /*  170868 */ GIM_Reject,
     /*  170869 */ // Label 3172: @170869
     /*  170869 */ GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(170926), // Rule ID 333 //
     /*  170874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170877 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170880 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170887 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170894 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170898 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170905 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10083>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170908 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170924 */   GIR_RootConstrainSelectedInstOperands,
     /*  170925 */   // GIR_Coverage, 333,
     /*  170925 */   GIR_EraseRootFromParent_Done,
     /*  170926 */ // Label 3246: @170926
     /*  170926 */ GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(170983), // Rule ID 335 //
     /*  170931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170934 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170944 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170951 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170955 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170962 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10085>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170965 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170981 */   GIR_RootConstrainSelectedInstOperands,
     /*  170982 */   // GIR_Coverage, 335,
     /*  170982 */   GIR_EraseRootFromParent_Done,
     /*  170983 */ // Label 3247: @170983
     /*  170983 */ GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(171040), // Rule ID 337 //
     /*  170988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170991 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170994 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171001 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171019 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10087>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171022 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171038 */   GIR_RootConstrainSelectedInstOperands,
     /*  171039 */   // GIR_Coverage, 337,
     /*  171039 */   GIR_EraseRootFromParent_Done,
     /*  171040 */ // Label 3248: @171040
     /*  171040 */ GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(171097), // Rule ID 348 //
     /*  171045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  171048 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171051 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171058 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171069 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171076 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10097>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171079 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171081 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171091 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171095 */   GIR_RootConstrainSelectedInstOperands,
     /*  171096 */   // GIR_Coverage, 348,
     /*  171096 */   GIR_EraseRootFromParent_Done,
     /*  171097 */ // Label 3249: @171097
     /*  171097 */ GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(171155), // Rule ID 244 //
     /*  171102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171105 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171108 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171112 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171123 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171134 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  171137 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171144 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171153 */   GIR_RootConstrainSelectedInstOperands,
     /*  171154 */   // GIR_Coverage, 244,
     /*  171154 */   GIR_EraseRootFromParent_Done,
     /*  171155 */ // Label 3250: @171155
     /*  171155 */ GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(171213), // Rule ID 246 //
     /*  171160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  171163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171166 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171170 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171181 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171185 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171192 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  171195 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171211 */   GIR_RootConstrainSelectedInstOperands,
     /*  171212 */   // GIR_Coverage, 246,
     /*  171212 */   GIR_EraseRootFromParent_Done,
     /*  171213 */ // Label 3251: @171213
     /*  171213 */ GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(171271), // Rule ID 285 //
     /*  171218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171221 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171224 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171250 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  171253 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171269 */   GIR_RootConstrainSelectedInstOperands,
     /*  171270 */   // GIR_Coverage, 285,
     /*  171270 */   GIR_EraseRootFromParent_Done,
     /*  171271 */ // Label 3252: @171271
     /*  171271 */ GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(171322), // Rule ID 286 //
     /*  171276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  171279 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171282 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171294 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171301 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171304 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171320 */   GIR_RootConstrainSelectedInstOperands,
     /*  171321 */   // GIR_Coverage, 286,
     /*  171321 */   GIR_EraseRootFromParent_Done,
     /*  171322 */ // Label 3253: @171322
     /*  171322 */ GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(171373), // Rule ID 1833 //
     /*  171327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  171330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171333 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  171341 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171345 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171352 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  171355 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171357 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171371 */   GIR_RootConstrainSelectedInstOperands,
     /*  171372 */   // GIR_Coverage, 1833,
     /*  171372 */   GIR_EraseRootFromParent_Done,
     /*  171373 */ // Label 3254: @171373
     /*  171373 */ GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(171424), // Rule ID 1834 //
     /*  171378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  171381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171384 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  171392 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171396 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171403 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  171406 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171413 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171418 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171422 */   GIR_RootConstrainSelectedInstOperands,
     /*  171423 */   // GIR_Coverage, 1834,
     /*  171423 */   GIR_EraseRootFromParent_Done,
     /*  171424 */ // Label 3255: @171424
     /*  171424 */ GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(171475), // Rule ID 1837 //
     /*  171429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  171432 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171435 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171443 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171447 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171454 */   // (st GPR:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171457 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171473 */   GIR_RootConstrainSelectedInstOperands,
     /*  171474 */   // GIR_Coverage, 1837,
     /*  171474 */   GIR_EraseRootFromParent_Done,
     /*  171475 */ // Label 3256: @171475
     /*  171475 */ GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(171526), // Rule ID 1842 //
     /*  171480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode0),
     /*  171483 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171486 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  171494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171498 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171505 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  171508 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171510 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171520 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171524 */   GIR_RootConstrainSelectedInstOperands,
     /*  171525 */   // GIR_Coverage, 1842,
     /*  171525 */   GIR_EraseRootFromParent_Done,
     /*  171526 */ // Label 3257: @171526
     /*  171526 */ GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(171577), // Rule ID 1843 //
     /*  171531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZilsd_IsRV32_HwMode1),
     /*  171534 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171537 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  171545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171556 */   // (st GPRPair:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD_RV32 GPRPair:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  171556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RV32),
     /*  171559 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171571 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171575 */   GIR_RootConstrainSelectedInstOperands,
     /*  171576 */   // GIR_Coverage, 1843,
     /*  171576 */   GIR_EraseRootFromParent_Done,
     /*  171577 */ // Label 3258: @171577
     /*  171577 */ GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(171623), // Rule ID 1113 //
     /*  171582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171585 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171588 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171595 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171602 */   // MIs[0] rs1
     /*  171602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171610 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10587>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171613 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171615 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171617 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171621 */   GIR_RootConstrainSelectedInstOperands,
     /*  171622 */   // GIR_Coverage, 1113,
     /*  171622 */   GIR_EraseRootFromParent_Done,
     /*  171623 */ // Label 3259: @171623
     /*  171623 */ GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(171669), // Rule ID 1115 //
     /*  171628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171631 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171634 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171641 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171648 */   // MIs[0] rs1
     /*  171648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171656 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10589>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171659 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171661 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171667 */   GIR_RootConstrainSelectedInstOperands,
     /*  171668 */   // GIR_Coverage, 1115,
     /*  171668 */   GIR_EraseRootFromParent_Done,
     /*  171669 */ // Label 3260: @171669
     /*  171669 */ GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(171715), // Rule ID 1117 //
     /*  171674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171677 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171680 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171694 */   // MIs[0] rs1
     /*  171694 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171702 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10591>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171705 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171707 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171713 */   GIR_RootConstrainSelectedInstOperands,
     /*  171714 */   // GIR_Coverage, 1117,
     /*  171714 */   GIR_EraseRootFromParent_Done,
     /*  171715 */ // Label 3261: @171715
     /*  171715 */ GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(171761), // Rule ID 1119 //
     /*  171720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171723 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171726 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171733 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171740 */   // MIs[0] rs1
     /*  171740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171748 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10593>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171751 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171753 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171755 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171759 */   GIR_RootConstrainSelectedInstOperands,
     /*  171760 */   // GIR_Coverage, 1119,
     /*  171760 */   GIR_EraseRootFromParent_Done,
     /*  171761 */ // Label 3262: @171761
     /*  171761 */ GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(171807), // Rule ID 1121 //
     /*  171766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171769 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171772 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171779 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171786 */   // MIs[0] rs1
     /*  171786 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171794 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10595>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171797 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171799 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171805 */   GIR_RootConstrainSelectedInstOperands,
     /*  171806 */   // GIR_Coverage, 1121,
     /*  171806 */   GIR_EraseRootFromParent_Done,
     /*  171807 */ // Label 3263: @171807
     /*  171807 */ GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(171853), // Rule ID 1123 //
     /*  171812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171815 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171818 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171825 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171832 */   // MIs[0] rs1
     /*  171832 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171840 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10597>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171843 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171845 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171847 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171851 */   GIR_RootConstrainSelectedInstOperands,
     /*  171852 */   // GIR_Coverage, 1123,
     /*  171852 */   GIR_EraseRootFromParent_Done,
     /*  171853 */ // Label 3264: @171853
     /*  171853 */ GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(171899), // Rule ID 1141 //
     /*  171858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  171861 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171864 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171871 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171878 */   // MIs[0] rs1
     /*  171878 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171886 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10611>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171889 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171891 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171893 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171897 */   GIR_RootConstrainSelectedInstOperands,
     /*  171898 */   // GIR_Coverage, 1141,
     /*  171898 */   GIR_EraseRootFromParent_Done,
     /*  171899 */ // Label 3265: @171899
     /*  171899 */ GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(171945), // Rule ID 1143 //
     /*  171904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  171907 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171910 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171917 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171924 */   // MIs[0] rs1
     /*  171924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171932 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10613>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171935 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171937 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171939 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171943 */   GIR_RootConstrainSelectedInstOperands,
     /*  171944 */   // GIR_Coverage, 1143,
     /*  171944 */   GIR_EraseRootFromParent_Done,
     /*  171945 */ // Label 3266: @171945
     /*  171945 */ GIM_Reject,
     /*  171946 */ // Label 3173: @171946
     /*  171946 */ GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(172025),
     /*  171951 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171954 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171962 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171970 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(171997), // Rule ID 45742 //
     /*  171975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171978 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  171978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  171981 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  171991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171995 */     GIR_RootConstrainSelectedInstOperands,
     /*  171996 */     // GIR_Coverage, 45742,
     /*  171996 */     GIR_EraseRootFromParent_Done,
     /*  171997 */   // Label 3268: @171997
     /*  171997 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(172024), // Rule ID 45743 //
     /*  172002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172005 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  172005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  172008 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172022 */     GIR_RootConstrainSelectedInstOperands,
     /*  172023 */     // GIR_Coverage, 45743,
     /*  172023 */     GIR_EraseRootFromParent_Done,
     /*  172024 */   // Label 3269: @172024
     /*  172024 */   GIM_Reject,
     /*  172025 */ // Label 3267: @172025
     /*  172025 */ GIM_Reject,
     /*  172026 */ // Label 3174: @172026
     /*  172026 */ GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(172113),
     /*  172031 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172034 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172042 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(172077), // Rule ID 45738 //
     /*  172047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172050 */     // MIs[0] rs1
     /*  172050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172058 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  172058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  172061 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172075 */     GIR_RootConstrainSelectedInstOperands,
     /*  172076 */     // GIR_Coverage, 45738,
     /*  172076 */     GIR_EraseRootFromParent_Done,
     /*  172077 */   // Label 3271: @172077
     /*  172077 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(172112), // Rule ID 45739 //
     /*  172082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172085 */     // MIs[0] rs1
     /*  172085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172093 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  172093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  172096 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172110 */     GIR_RootConstrainSelectedInstOperands,
     /*  172111 */     // GIR_Coverage, 45739,
     /*  172111 */     GIR_EraseRootFromParent_Done,
     /*  172112 */   // Label 3272: @172112
     /*  172112 */   GIM_Reject,
     /*  172113 */ // Label 3270: @172113
     /*  172113 */ GIM_Reject,
     /*  172114 */ // Label 3175: @172114
     /*  172114 */ GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(172271),
     /*  172119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172122 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172130 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(172165), // Rule ID 45934 //
     /*  172135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172138 */     // MIs[0] rs1
     /*  172138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172146 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172149 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172163 */     GIR_RootConstrainSelectedInstOperands,
     /*  172164 */     // GIR_Coverage, 45934,
     /*  172164 */     GIR_EraseRootFromParent_Done,
     /*  172165 */   // Label 3274: @172165
     /*  172165 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(172200), // Rule ID 45935 //
     /*  172170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172173 */     // MIs[0] rs1
     /*  172173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172181 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172184 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172194 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172198 */     GIR_RootConstrainSelectedInstOperands,
     /*  172199 */     // GIR_Coverage, 45935,
     /*  172199 */     GIR_EraseRootFromParent_Done,
     /*  172200 */   // Label 3275: @172200
     /*  172200 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(172235), // Rule ID 46010 //
     /*  172205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  172208 */     // MIs[0] rs1
     /*  172208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172216 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172219 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172233 */     GIR_RootConstrainSelectedInstOperands,
     /*  172234 */     // GIR_Coverage, 46010,
     /*  172234 */     GIR_EraseRootFromParent_Done,
     /*  172235 */   // Label 3276: @172235
     /*  172235 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(172270), // Rule ID 46011 //
     /*  172240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  172243 */     // MIs[0] rs1
     /*  172243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172251 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  172254 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172268 */     GIR_RootConstrainSelectedInstOperands,
     /*  172269 */     // GIR_Coverage, 46011,
     /*  172269 */     GIR_EraseRootFromParent_Done,
     /*  172270 */   // Label 3277: @172270
     /*  172270 */   GIM_Reject,
     /*  172271 */ // Label 3273: @172271
     /*  172271 */ GIM_Reject,
     /*  172272 */ // Label 3176: @172272
     /*  172272 */ GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(172429),
     /*  172277 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172280 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172288 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(172323), // Rule ID 45942 //
     /*  172293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172296 */     // MIs[0] rs1
     /*  172296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172304 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172307 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172321 */     GIR_RootConstrainSelectedInstOperands,
     /*  172322 */     // GIR_Coverage, 45942,
     /*  172322 */     GIR_EraseRootFromParent_Done,
     /*  172323 */   // Label 3279: @172323
     /*  172323 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(172358), // Rule ID 45943 //
     /*  172328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172331 */     // MIs[0] rs1
     /*  172331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172339 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172342 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172356 */     GIR_RootConstrainSelectedInstOperands,
     /*  172357 */     // GIR_Coverage, 45943,
     /*  172357 */     GIR_EraseRootFromParent_Done,
     /*  172358 */   // Label 3280: @172358
     /*  172358 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(172393), // Rule ID 46018 //
     /*  172363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  172366 */     // MIs[0] rs1
     /*  172366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172374 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172377 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172391 */     GIR_RootConstrainSelectedInstOperands,
     /*  172392 */     // GIR_Coverage, 46018,
     /*  172392 */     GIR_EraseRootFromParent_Done,
     /*  172393 */   // Label 3281: @172393
     /*  172393 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(172428), // Rule ID 46019 //
     /*  172398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  172401 */     // MIs[0] rs1
     /*  172401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172409 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  172412 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172426 */     GIR_RootConstrainSelectedInstOperands,
     /*  172427 */     // GIR_Coverage, 46019,
     /*  172427 */     GIR_EraseRootFromParent_Done,
     /*  172428 */   // Label 3282: @172428
     /*  172428 */   GIM_Reject,
     /*  172429 */ // Label 3278: @172429
     /*  172429 */ GIM_Reject,
     /*  172430 */ // Label 3177: @172430
     /*  172430 */ GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(172587),
     /*  172435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172446 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(172481), // Rule ID 45958 //
     /*  172451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  172454 */     // MIs[0] rs1
     /*  172454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172462 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172465 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172479 */     GIR_RootConstrainSelectedInstOperands,
     /*  172480 */     // GIR_Coverage, 45958,
     /*  172480 */     GIR_EraseRootFromParent_Done,
     /*  172481 */   // Label 3284: @172481
     /*  172481 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(172516), // Rule ID 45959 //
     /*  172486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  172489 */     // MIs[0] rs1
     /*  172489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172497 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  172497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172500 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172514 */     GIR_RootConstrainSelectedInstOperands,
     /*  172515 */     // GIR_Coverage, 45959,
     /*  172515 */     GIR_EraseRootFromParent_Done,
     /*  172516 */   // Label 3285: @172516
     /*  172516 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(172551), // Rule ID 46030 //
     /*  172521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  172524 */     // MIs[0] rs1
     /*  172524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172532 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172535 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172549 */     GIR_RootConstrainSelectedInstOperands,
     /*  172550 */     // GIR_Coverage, 46030,
     /*  172550 */     GIR_EraseRootFromParent_Done,
     /*  172551 */   // Label 3286: @172551
     /*  172551 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(172586), // Rule ID 46031 //
     /*  172556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  172559 */     // MIs[0] rs1
     /*  172559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172567 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  172567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172570 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172584 */     GIR_RootConstrainSelectedInstOperands,
     /*  172585 */     // GIR_Coverage, 46031,
     /*  172585 */     GIR_EraseRootFromParent_Done,
     /*  172586 */   // Label 3287: @172586
     /*  172586 */   GIM_Reject,
     /*  172587 */ // Label 3283: @172587
     /*  172587 */ GIM_Reject,
     /*  172588 */ // Label 3178: @172588
     /*  172588 */ GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(172667),
     /*  172593 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172596 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172604 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172612 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(172639), // Rule ID 46070 //
     /*  172617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172620 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  172620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  172623 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172637 */     GIR_RootConstrainSelectedInstOperands,
     /*  172638 */     // GIR_Coverage, 46070,
     /*  172638 */     GIR_EraseRootFromParent_Done,
     /*  172639 */   // Label 3289: @172639
     /*  172639 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(172666), // Rule ID 46071 //
     /*  172644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172647 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  172647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  172650 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172664 */     GIR_RootConstrainSelectedInstOperands,
     /*  172665 */     // GIR_Coverage, 46071,
     /*  172665 */     GIR_EraseRootFromParent_Done,
     /*  172666 */   // Label 3290: @172666
     /*  172666 */   GIM_Reject,
     /*  172667 */ // Label 3288: @172667
     /*  172667 */ GIM_Reject,
     /*  172668 */ // Label 3179: @172668
     /*  172668 */ GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(172755),
     /*  172673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172676 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172684 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(172719), // Rule ID 45926 //
     /*  172689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172692 */     // MIs[0] rs1
     /*  172692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172700 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  172700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  172703 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172717 */     GIR_RootConstrainSelectedInstOperands,
     /*  172718 */     // GIR_Coverage, 45926,
     /*  172718 */     GIR_EraseRootFromParent_Done,
     /*  172719 */   // Label 3292: @172719
     /*  172719 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(172754), // Rule ID 45927 //
     /*  172724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172727 */     // MIs[0] rs1
     /*  172727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172735 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  172735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  172738 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172752 */     GIR_RootConstrainSelectedInstOperands,
     /*  172753 */     // GIR_Coverage, 45927,
     /*  172753 */     GIR_EraseRootFromParent_Done,
     /*  172754 */   // Label 3293: @172754
     /*  172754 */   GIM_Reject,
     /*  172755 */ // Label 3291: @172755
     /*  172755 */ GIM_Reject,
     /*  172756 */ // Label 3180: @172756
     /*  172756 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(172913),
     /*  172761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172772 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(172807), // Rule ID 45938 //
     /*  172777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172780 */     // MIs[0] rs1
     /*  172780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172788 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172791 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172805 */     GIR_RootConstrainSelectedInstOperands,
     /*  172806 */     // GIR_Coverage, 45938,
     /*  172806 */     GIR_EraseRootFromParent_Done,
     /*  172807 */   // Label 3295: @172807
     /*  172807 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(172842), // Rule ID 45939 //
     /*  172812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172815 */     // MIs[0] rs1
     /*  172815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172823 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172826 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172840 */     GIR_RootConstrainSelectedInstOperands,
     /*  172841 */     // GIR_Coverage, 45939,
     /*  172841 */     GIR_EraseRootFromParent_Done,
     /*  172842 */   // Label 3296: @172842
     /*  172842 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(172877), // Rule ID 46014 //
     /*  172847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  172850 */     // MIs[0] rs1
     /*  172850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172858 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172861 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172875 */     GIR_RootConstrainSelectedInstOperands,
     /*  172876 */     // GIR_Coverage, 46014,
     /*  172876 */     GIR_EraseRootFromParent_Done,
     /*  172877 */   // Label 3297: @172877
     /*  172877 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(172912), // Rule ID 46015 //
     /*  172882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  172885 */     // MIs[0] rs1
     /*  172885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172893 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172896 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172910 */     GIR_RootConstrainSelectedInstOperands,
     /*  172911 */     // GIR_Coverage, 46015,
     /*  172911 */     GIR_EraseRootFromParent_Done,
     /*  172912 */   // Label 3298: @172912
     /*  172912 */   GIM_Reject,
     /*  172913 */ // Label 3294: @172913
     /*  172913 */ GIM_Reject,
     /*  172914 */ // Label 3181: @172914
     /*  172914 */ GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(173071),
     /*  172919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172922 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172930 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(172965), // Rule ID 45954 //
     /*  172935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172938 */     // MIs[0] rs1
     /*  172938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172946 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  172949 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172963 */     GIR_RootConstrainSelectedInstOperands,
     /*  172964 */     // GIR_Coverage, 45954,
     /*  172964 */     GIR_EraseRootFromParent_Done,
     /*  172965 */   // Label 3300: @172965
     /*  172965 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(173000), // Rule ID 45955 //
     /*  172970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172973 */     // MIs[0] rs1
     /*  172973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172981 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  172984 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172998 */     GIR_RootConstrainSelectedInstOperands,
     /*  172999 */     // GIR_Coverage, 45955,
     /*  172999 */     GIR_EraseRootFromParent_Done,
     /*  173000 */   // Label 3301: @173000
     /*  173000 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(173035), // Rule ID 46026 //
     /*  173005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  173008 */     // MIs[0] rs1
     /*  173008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173016 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173019 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173033 */     GIR_RootConstrainSelectedInstOperands,
     /*  173034 */     // GIR_Coverage, 46026,
     /*  173034 */     GIR_EraseRootFromParent_Done,
     /*  173035 */   // Label 3302: @173035
     /*  173035 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(173070), // Rule ID 46027 //
     /*  173040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  173043 */     // MIs[0] rs1
     /*  173043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173051 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  173054 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173068 */     GIR_RootConstrainSelectedInstOperands,
     /*  173069 */     // GIR_Coverage, 46027,
     /*  173069 */     GIR_EraseRootFromParent_Done,
     /*  173070 */   // Label 3303: @173070
     /*  173070 */   GIM_Reject,
     /*  173071 */ // Label 3299: @173071
     /*  173071 */ GIM_Reject,
     /*  173072 */ // Label 3182: @173072
     /*  173072 */ GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(173229),
     /*  173077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173080 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173088 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(173123), // Rule ID 45998 //
     /*  173093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  173096 */     // MIs[0] rs1
     /*  173096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173104 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173107 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173121 */     GIR_RootConstrainSelectedInstOperands,
     /*  173122 */     // GIR_Coverage, 45998,
     /*  173122 */     GIR_EraseRootFromParent_Done,
     /*  173123 */   // Label 3305: @173123
     /*  173123 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(173158), // Rule ID 45999 //
     /*  173128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  173131 */     // MIs[0] rs1
     /*  173131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173139 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173142 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173156 */     GIR_RootConstrainSelectedInstOperands,
     /*  173157 */     // GIR_Coverage, 45999,
     /*  173157 */     GIR_EraseRootFromParent_Done,
     /*  173158 */   // Label 3306: @173158
     /*  173158 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(173193), // Rule ID 46058 //
     /*  173163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  173166 */     // MIs[0] rs1
     /*  173166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173174 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173177 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173191 */     GIR_RootConstrainSelectedInstOperands,
     /*  173192 */     // GIR_Coverage, 46058,
     /*  173192 */     GIR_EraseRootFromParent_Done,
     /*  173193 */   // Label 3307: @173193
     /*  173193 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(173228), // Rule ID 46059 //
     /*  173198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173201 */     // MIs[0] rs1
     /*  173201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173209 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  173212 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173226 */     GIR_RootConstrainSelectedInstOperands,
     /*  173227 */     // GIR_Coverage, 46059,
     /*  173227 */     GIR_EraseRootFromParent_Done,
     /*  173228 */   // Label 3308: @173228
     /*  173228 */   GIM_Reject,
     /*  173229 */ // Label 3304: @173229
     /*  173229 */ GIM_Reject,
     /*  173230 */ // Label 3183: @173230
     /*  173230 */ GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(173309),
     /*  173235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173246 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173254 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(173281), // Rule ID 46074 //
     /*  173259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173262 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  173262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  173265 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173279 */     GIR_RootConstrainSelectedInstOperands,
     /*  173280 */     // GIR_Coverage, 46074,
     /*  173280 */     GIR_EraseRootFromParent_Done,
     /*  173281 */   // Label 3310: @173281
     /*  173281 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(173308), // Rule ID 46075 //
     /*  173286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173289 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  173289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  173292 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173306 */     GIR_RootConstrainSelectedInstOperands,
     /*  173307 */     // GIR_Coverage, 46075,
     /*  173307 */     GIR_EraseRootFromParent_Done,
     /*  173308 */   // Label 3311: @173308
     /*  173308 */   GIM_Reject,
     /*  173309 */ // Label 3309: @173309
     /*  173309 */ GIM_Reject,
     /*  173310 */ // Label 3184: @173310
     /*  173310 */ GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(173397),
     /*  173315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173326 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(173361), // Rule ID 45930 //
     /*  173331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173334 */     // MIs[0] rs1
     /*  173334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173342 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  173342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  173345 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173359 */     GIR_RootConstrainSelectedInstOperands,
     /*  173360 */     // GIR_Coverage, 45930,
     /*  173360 */     GIR_EraseRootFromParent_Done,
     /*  173361 */   // Label 3313: @173361
     /*  173361 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(173396), // Rule ID 45931 //
     /*  173366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173369 */     // MIs[0] rs1
     /*  173369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173377 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  173377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  173380 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173394 */     GIR_RootConstrainSelectedInstOperands,
     /*  173395 */     // GIR_Coverage, 45931,
     /*  173395 */     GIR_EraseRootFromParent_Done,
     /*  173396 */   // Label 3314: @173396
     /*  173396 */   GIM_Reject,
     /*  173397 */ // Label 3312: @173397
     /*  173397 */ GIM_Reject,
     /*  173398 */ // Label 3185: @173398
     /*  173398 */ GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(173555),
     /*  173403 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173406 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173414 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(173449), // Rule ID 45950 //
     /*  173419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173422 */     // MIs[0] rs1
     /*  173422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173430 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173433 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173447 */     GIR_RootConstrainSelectedInstOperands,
     /*  173448 */     // GIR_Coverage, 45950,
     /*  173448 */     GIR_EraseRootFromParent_Done,
     /*  173449 */   // Label 3316: @173449
     /*  173449 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(173484), // Rule ID 45951 //
     /*  173454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173457 */     // MIs[0] rs1
     /*  173457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173465 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173468 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173478 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173482 */     GIR_RootConstrainSelectedInstOperands,
     /*  173483 */     // GIR_Coverage, 45951,
     /*  173483 */     GIR_EraseRootFromParent_Done,
     /*  173484 */   // Label 3317: @173484
     /*  173484 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(173519), // Rule ID 46022 //
     /*  173489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  173492 */     // MIs[0] rs1
     /*  173492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173500 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173503 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173517 */     GIR_RootConstrainSelectedInstOperands,
     /*  173518 */     // GIR_Coverage, 46022,
     /*  173518 */     GIR_EraseRootFromParent_Done,
     /*  173519 */   // Label 3318: @173519
     /*  173519 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(173554), // Rule ID 46023 //
     /*  173524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  173527 */     // MIs[0] rs1
     /*  173527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173535 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173538 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173552 */     GIR_RootConstrainSelectedInstOperands,
     /*  173553 */     // GIR_Coverage, 46023,
     /*  173553 */     GIR_EraseRootFromParent_Done,
     /*  173554 */   // Label 3319: @173554
     /*  173554 */   GIM_Reject,
     /*  173555 */ // Label 3315: @173555
     /*  173555 */ GIM_Reject,
     /*  173556 */ // Label 3186: @173556
     /*  173556 */ GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(173713),
     /*  173561 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173564 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173572 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(173607), // Rule ID 45986 //
     /*  173577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173580 */     // MIs[0] rs1
     /*  173580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173588 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173591 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173605 */     GIR_RootConstrainSelectedInstOperands,
     /*  173606 */     // GIR_Coverage, 45986,
     /*  173606 */     GIR_EraseRootFromParent_Done,
     /*  173607 */   // Label 3321: @173607
     /*  173607 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(173642), // Rule ID 45987 //
     /*  173612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173615 */     // MIs[0] rs1
     /*  173615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173623 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173626 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173640 */     GIR_RootConstrainSelectedInstOperands,
     /*  173641 */     // GIR_Coverage, 45987,
     /*  173641 */     GIR_EraseRootFromParent_Done,
     /*  173642 */   // Label 3322: @173642
     /*  173642 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(173677), // Rule ID 46046 //
     /*  173647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  173650 */     // MIs[0] rs1
     /*  173650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173658 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173661 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173675 */     GIR_RootConstrainSelectedInstOperands,
     /*  173676 */     // GIR_Coverage, 46046,
     /*  173676 */     GIR_EraseRootFromParent_Done,
     /*  173677 */   // Label 3323: @173677
     /*  173677 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(173712), // Rule ID 46047 //
     /*  173682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  173685 */     // MIs[0] rs1
     /*  173685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173693 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173696 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173710 */     GIR_RootConstrainSelectedInstOperands,
     /*  173711 */     // GIR_Coverage, 46047,
     /*  173711 */     GIR_EraseRootFromParent_Done,
     /*  173712 */   // Label 3324: @173712
     /*  173712 */   GIM_Reject,
     /*  173713 */ // Label 3320: @173713
     /*  173713 */ GIM_Reject,
     /*  173714 */ // Label 3187: @173714
     /*  173714 */ GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(173871),
     /*  173719 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173722 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  173730 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(173765), // Rule ID 46002 //
     /*  173735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  173738 */     // MIs[0] rs1
     /*  173738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173746 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173749 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173763 */     GIR_RootConstrainSelectedInstOperands,
     /*  173764 */     // GIR_Coverage, 46002,
     /*  173764 */     GIR_EraseRootFromParent_Done,
     /*  173765 */   // Label 3326: @173765
     /*  173765 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(173800), // Rule ID 46003 //
     /*  173770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  173773 */     // MIs[0] rs1
     /*  173773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173781 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173784 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173798 */     GIR_RootConstrainSelectedInstOperands,
     /*  173799 */     // GIR_Coverage, 46003,
     /*  173799 */     GIR_EraseRootFromParent_Done,
     /*  173800 */   // Label 3327: @173800
     /*  173800 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(173835), // Rule ID 46062 //
     /*  173805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  173808 */     // MIs[0] rs1
     /*  173808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173816 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173819 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173833 */     GIR_RootConstrainSelectedInstOperands,
     /*  173834 */     // GIR_Coverage, 46062,
     /*  173834 */     GIR_EraseRootFromParent_Done,
     /*  173835 */   // Label 3328: @173835
     /*  173835 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(173870), // Rule ID 46063 //
     /*  173840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173843 */     // MIs[0] rs1
     /*  173843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173851 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173854 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173868 */     GIR_RootConstrainSelectedInstOperands,
     /*  173869 */     // GIR_Coverage, 46063,
     /*  173869 */     GIR_EraseRootFromParent_Done,
     /*  173870 */   // Label 3329: @173870
     /*  173870 */   GIM_Reject,
     /*  173871 */ // Label 3325: @173871
     /*  173871 */ GIM_Reject,
     /*  173872 */ // Label 3188: @173872
     /*  173872 */ GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(173951),
     /*  173877 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173880 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173888 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173896 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(173923), // Rule ID 46078 //
     /*  173901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173904 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  173904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  173907 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173921 */     GIR_RootConstrainSelectedInstOperands,
     /*  173922 */     // GIR_Coverage, 46078,
     /*  173922 */     GIR_EraseRootFromParent_Done,
     /*  173923 */   // Label 3331: @173923
     /*  173923 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(173950), // Rule ID 46079 //
     /*  173928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173931 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  173931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  173934 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173948 */     GIR_RootConstrainSelectedInstOperands,
     /*  173949 */     // GIR_Coverage, 46079,
     /*  173949 */     GIR_EraseRootFromParent_Done,
     /*  173950 */   // Label 3332: @173950
     /*  173950 */   GIM_Reject,
     /*  173951 */ // Label 3330: @173951
     /*  173951 */ GIM_Reject,
     /*  173952 */ // Label 3189: @173952
     /*  173952 */ GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(174039),
     /*  173957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173960 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173968 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(174003), // Rule ID 45946 //
     /*  173973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173976 */     // MIs[0] rs1
     /*  173976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173984 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  173984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  173987 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174001 */     GIR_RootConstrainSelectedInstOperands,
     /*  174002 */     // GIR_Coverage, 45946,
     /*  174002 */     GIR_EraseRootFromParent_Done,
     /*  174003 */   // Label 3334: @174003
     /*  174003 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(174038), // Rule ID 45947 //
     /*  174008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174011 */     // MIs[0] rs1
     /*  174011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174019 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  174019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  174022 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174036 */     GIR_RootConstrainSelectedInstOperands,
     /*  174037 */     // GIR_Coverage, 45947,
     /*  174037 */     GIR_EraseRootFromParent_Done,
     /*  174038 */   // Label 3335: @174038
     /*  174038 */   GIM_Reject,
     /*  174039 */ // Label 3333: @174039
     /*  174039 */ GIM_Reject,
     /*  174040 */ // Label 3190: @174040
     /*  174040 */ GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(174197),
     /*  174045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174048 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174056 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(174091), // Rule ID 45974 //
     /*  174061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174064 */     // MIs[0] rs1
     /*  174064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174072 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174075 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174089 */     GIR_RootConstrainSelectedInstOperands,
     /*  174090 */     // GIR_Coverage, 45974,
     /*  174090 */     GIR_EraseRootFromParent_Done,
     /*  174091 */   // Label 3337: @174091
     /*  174091 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(174126), // Rule ID 45975 //
     /*  174096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174099 */     // MIs[0] rs1
     /*  174099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174107 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174110 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174124 */     GIR_RootConstrainSelectedInstOperands,
     /*  174125 */     // GIR_Coverage, 45975,
     /*  174125 */     GIR_EraseRootFromParent_Done,
     /*  174126 */   // Label 3338: @174126
     /*  174126 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(174161), // Rule ID 46034 //
     /*  174131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  174134 */     // MIs[0] rs1
     /*  174134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174142 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174145 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174159 */     GIR_RootConstrainSelectedInstOperands,
     /*  174160 */     // GIR_Coverage, 46034,
     /*  174160 */     GIR_EraseRootFromParent_Done,
     /*  174161 */   // Label 3339: @174161
     /*  174161 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(174196), // Rule ID 46035 //
     /*  174166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  174169 */     // MIs[0] rs1
     /*  174169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174177 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  174180 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174194 */     GIR_RootConstrainSelectedInstOperands,
     /*  174195 */     // GIR_Coverage, 46035,
     /*  174195 */     GIR_EraseRootFromParent_Done,
     /*  174196 */   // Label 3340: @174196
     /*  174196 */   GIM_Reject,
     /*  174197 */ // Label 3336: @174197
     /*  174197 */ GIM_Reject,
     /*  174198 */ // Label 3191: @174198
     /*  174198 */ GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(174355),
     /*  174203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174214 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(174249), // Rule ID 45990 //
     /*  174219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174222 */     // MIs[0] rs1
     /*  174222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174230 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174233 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174247 */     GIR_RootConstrainSelectedInstOperands,
     /*  174248 */     // GIR_Coverage, 45990,
     /*  174248 */     GIR_EraseRootFromParent_Done,
     /*  174249 */   // Label 3342: @174249
     /*  174249 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(174284), // Rule ID 45991 //
     /*  174254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174257 */     // MIs[0] rs1
     /*  174257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174265 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174268 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174282 */     GIR_RootConstrainSelectedInstOperands,
     /*  174283 */     // GIR_Coverage, 45991,
     /*  174283 */     GIR_EraseRootFromParent_Done,
     /*  174284 */   // Label 3343: @174284
     /*  174284 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(174319), // Rule ID 46050 //
     /*  174289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  174292 */     // MIs[0] rs1
     /*  174292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174300 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174303 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174317 */     GIR_RootConstrainSelectedInstOperands,
     /*  174318 */     // GIR_Coverage, 46050,
     /*  174318 */     GIR_EraseRootFromParent_Done,
     /*  174319 */   // Label 3344: @174319
     /*  174319 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(174354), // Rule ID 46051 //
     /*  174324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  174327 */     // MIs[0] rs1
     /*  174327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174335 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  174338 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174352 */     GIR_RootConstrainSelectedInstOperands,
     /*  174353 */     // GIR_Coverage, 46051,
     /*  174353 */     GIR_EraseRootFromParent_Done,
     /*  174354 */   // Label 3345: @174354
     /*  174354 */   GIM_Reject,
     /*  174355 */ // Label 3341: @174355
     /*  174355 */ GIM_Reject,
     /*  174356 */ // Label 3192: @174356
     /*  174356 */ GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(174513),
     /*  174361 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174364 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174372 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(174407), // Rule ID 46006 //
     /*  174377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  174380 */     // MIs[0] rs1
     /*  174380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174388 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174391 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174405 */     GIR_RootConstrainSelectedInstOperands,
     /*  174406 */     // GIR_Coverage, 46006,
     /*  174406 */     GIR_EraseRootFromParent_Done,
     /*  174407 */   // Label 3347: @174407
     /*  174407 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(174442), // Rule ID 46007 //
     /*  174412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  174415 */     // MIs[0] rs1
     /*  174415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174423 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174426 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174440 */     GIR_RootConstrainSelectedInstOperands,
     /*  174441 */     // GIR_Coverage, 46007,
     /*  174441 */     GIR_EraseRootFromParent_Done,
     /*  174442 */   // Label 3348: @174442
     /*  174442 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(174477), // Rule ID 46066 //
     /*  174447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  174450 */     // MIs[0] rs1
     /*  174450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174458 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  174458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174461 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174475 */     GIR_RootConstrainSelectedInstOperands,
     /*  174476 */     // GIR_Coverage, 46066,
     /*  174476 */     GIR_EraseRootFromParent_Done,
     /*  174477 */   // Label 3349: @174477
     /*  174477 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(174512), // Rule ID 46067 //
     /*  174482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  174485 */     // MIs[0] rs1
     /*  174485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174493 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  174493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  174496 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  174506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174510 */     GIR_RootConstrainSelectedInstOperands,
     /*  174511 */     // GIR_Coverage, 46067,
     /*  174511 */     GIR_EraseRootFromParent_Done,
     /*  174512 */   // Label 3350: @174512
     /*  174512 */   GIM_Reject,
     /*  174513 */ // Label 3346: @174513
     /*  174513 */ GIM_Reject,
     /*  174514 */ // Label 3193: @174514
     /*  174514 */ GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(174593),
     /*  174519 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174522 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174538 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(174565), // Rule ID 46082 //
     /*  174543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174546 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  174546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  174549 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174563 */     GIR_RootConstrainSelectedInstOperands,
     /*  174564 */     // GIR_Coverage, 46082,
     /*  174564 */     GIR_EraseRootFromParent_Done,
     /*  174565 */   // Label 3352: @174565
     /*  174565 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(174592), // Rule ID 46083 //
     /*  174570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174573 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  174573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  174576 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174590 */     GIR_RootConstrainSelectedInstOperands,
     /*  174591 */     // GIR_Coverage, 46083,
     /*  174591 */     GIR_EraseRootFromParent_Done,
     /*  174592 */   // Label 3353: @174592
     /*  174592 */   GIM_Reject,
     /*  174593 */ // Label 3351: @174593
     /*  174593 */ GIM_Reject,
     /*  174594 */ // Label 3194: @174594
     /*  174594 */ GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(174681),
     /*  174599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174602 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174610 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(174645), // Rule ID 45962 //
     /*  174615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174618 */     // MIs[0] rs1
     /*  174618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174626 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  174626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  174629 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174643 */     GIR_RootConstrainSelectedInstOperands,
     /*  174644 */     // GIR_Coverage, 45962,
     /*  174644 */     GIR_EraseRootFromParent_Done,
     /*  174645 */   // Label 3355: @174645
     /*  174645 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(174680), // Rule ID 45963 //
     /*  174650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174653 */     // MIs[0] rs1
     /*  174653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174661 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  174661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  174664 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174678 */     GIR_RootConstrainSelectedInstOperands,
     /*  174679 */     // GIR_Coverage, 45963,
     /*  174679 */     GIR_EraseRootFromParent_Done,
     /*  174680 */   // Label 3356: @174680
     /*  174680 */   GIM_Reject,
     /*  174681 */ // Label 3354: @174681
     /*  174681 */ GIM_Reject,
     /*  174682 */ // Label 3195: @174682
     /*  174682 */ GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(174839),
     /*  174687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174690 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174698 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(174733), // Rule ID 45978 //
     /*  174703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174706 */     // MIs[0] rs1
     /*  174706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174714 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174717 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174731 */     GIR_RootConstrainSelectedInstOperands,
     /*  174732 */     // GIR_Coverage, 45978,
     /*  174732 */     GIR_EraseRootFromParent_Done,
     /*  174733 */   // Label 3358: @174733
     /*  174733 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(174768), // Rule ID 45979 //
     /*  174738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174741 */     // MIs[0] rs1
     /*  174741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174749 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174752 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174766 */     GIR_RootConstrainSelectedInstOperands,
     /*  174767 */     // GIR_Coverage, 45979,
     /*  174767 */     GIR_EraseRootFromParent_Done,
     /*  174768 */   // Label 3359: @174768
     /*  174768 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(174803), // Rule ID 46038 //
     /*  174773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  174776 */     // MIs[0] rs1
     /*  174776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174784 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174787 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174801 */     GIR_RootConstrainSelectedInstOperands,
     /*  174802 */     // GIR_Coverage, 46038,
     /*  174802 */     GIR_EraseRootFromParent_Done,
     /*  174803 */   // Label 3360: @174803
     /*  174803 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(174838), // Rule ID 46039 //
     /*  174808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  174811 */     // MIs[0] rs1
     /*  174811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174819 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174822 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174836 */     GIR_RootConstrainSelectedInstOperands,
     /*  174837 */     // GIR_Coverage, 46039,
     /*  174837 */     GIR_EraseRootFromParent_Done,
     /*  174838 */   // Label 3361: @174838
     /*  174838 */   GIM_Reject,
     /*  174839 */ // Label 3357: @174839
     /*  174839 */ GIM_Reject,
     /*  174840 */ // Label 3196: @174840
     /*  174840 */ GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(174997),
     /*  174845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174856 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(174891), // Rule ID 45994 //
     /*  174861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174864 */     // MIs[0] rs1
     /*  174864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174872 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174875 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174889 */     GIR_RootConstrainSelectedInstOperands,
     /*  174890 */     // GIR_Coverage, 45994,
     /*  174890 */     GIR_EraseRootFromParent_Done,
     /*  174891 */   // Label 3363: @174891
     /*  174891 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(174926), // Rule ID 45995 //
     /*  174896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174899 */     // MIs[0] rs1
     /*  174899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174907 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174910 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174924 */     GIR_RootConstrainSelectedInstOperands,
     /*  174925 */     // GIR_Coverage, 45995,
     /*  174925 */     GIR_EraseRootFromParent_Done,
     /*  174926 */   // Label 3364: @174926
     /*  174926 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(174961), // Rule ID 46054 //
     /*  174931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  174934 */     // MIs[0] rs1
     /*  174934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174942 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174945 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174959 */     GIR_RootConstrainSelectedInstOperands,
     /*  174960 */     // GIR_Coverage, 46054,
     /*  174960 */     GIR_EraseRootFromParent_Done,
     /*  174961 */   // Label 3365: @174961
     /*  174961 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(174996), // Rule ID 46055 //
     /*  174966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  174969 */     // MIs[0] rs1
     /*  174969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174977 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174980 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174994 */     GIR_RootConstrainSelectedInstOperands,
     /*  174995 */     // GIR_Coverage, 46055,
     /*  174995 */     GIR_EraseRootFromParent_Done,
     /*  174996 */   // Label 3366: @174996
     /*  174996 */   GIM_Reject,
     /*  174997 */ // Label 3362: @174997
     /*  174997 */ GIM_Reject,
     /*  174998 */ // Label 3197: @174998
     /*  174998 */ GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(175077),
     /*  175003 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175014 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175022 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(175049), // Rule ID 46086 //
     /*  175027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175030 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  175033 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175047 */     GIR_RootConstrainSelectedInstOperands,
     /*  175048 */     // GIR_Coverage, 46086,
     /*  175048 */     GIR_EraseRootFromParent_Done,
     /*  175049 */   // Label 3368: @175049
     /*  175049 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(175076), // Rule ID 46087 //
     /*  175054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175057 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  175060 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175074 */     GIR_RootConstrainSelectedInstOperands,
     /*  175075 */     // GIR_Coverage, 46087,
     /*  175075 */     GIR_EraseRootFromParent_Done,
     /*  175076 */   // Label 3369: @175076
     /*  175076 */   GIM_Reject,
     /*  175077 */ // Label 3367: @175077
     /*  175077 */ GIM_Reject,
     /*  175078 */ // Label 3198: @175078
     /*  175078 */ GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(175165),
     /*  175083 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175086 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  175094 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(175129), // Rule ID 45966 //
     /*  175099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175102 */     // MIs[0] rs1
     /*  175102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175110 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  175113 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175127 */     GIR_RootConstrainSelectedInstOperands,
     /*  175128 */     // GIR_Coverage, 45966,
     /*  175128 */     GIR_EraseRootFromParent_Done,
     /*  175129 */   // Label 3371: @175129
     /*  175129 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(175164), // Rule ID 45967 //
     /*  175134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175137 */     // MIs[0] rs1
     /*  175137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175145 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  175148 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175162 */     GIR_RootConstrainSelectedInstOperands,
     /*  175163 */     // GIR_Coverage, 45967,
     /*  175163 */     GIR_EraseRootFromParent_Done,
     /*  175164 */   // Label 3372: @175164
     /*  175164 */   GIM_Reject,
     /*  175165 */ // Label 3370: @175165
     /*  175165 */ GIM_Reject,
     /*  175166 */ // Label 3199: @175166
     /*  175166 */ GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(175323),
     /*  175171 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175174 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175182 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(175217), // Rule ID 45982 //
     /*  175187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175190 */     // MIs[0] rs1
     /*  175190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175198 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175201 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175215 */     GIR_RootConstrainSelectedInstOperands,
     /*  175216 */     // GIR_Coverage, 45982,
     /*  175216 */     GIR_EraseRootFromParent_Done,
     /*  175217 */   // Label 3374: @175217
     /*  175217 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(175252), // Rule ID 45983 //
     /*  175222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175225 */     // MIs[0] rs1
     /*  175225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175233 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175236 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175250 */     GIR_RootConstrainSelectedInstOperands,
     /*  175251 */     // GIR_Coverage, 45983,
     /*  175251 */     GIR_EraseRootFromParent_Done,
     /*  175252 */   // Label 3375: @175252
     /*  175252 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(175287), // Rule ID 46042 //
     /*  175257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  175260 */     // MIs[0] rs1
     /*  175260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175268 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  175268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175271 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175285 */     GIR_RootConstrainSelectedInstOperands,
     /*  175286 */     // GIR_Coverage, 46042,
     /*  175286 */     GIR_EraseRootFromParent_Done,
     /*  175287 */   // Label 3376: @175287
     /*  175287 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(175322), // Rule ID 46043 //
     /*  175292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  175295 */     // MIs[0] rs1
     /*  175295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175303 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  175303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  175306 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175320 */     GIR_RootConstrainSelectedInstOperands,
     /*  175321 */     // GIR_Coverage, 46043,
     /*  175321 */     GIR_EraseRootFromParent_Done,
     /*  175322 */   // Label 3377: @175322
     /*  175322 */   GIM_Reject,
     /*  175323 */ // Label 3373: @175323
     /*  175323 */ GIM_Reject,
     /*  175324 */ // Label 3200: @175324
     /*  175324 */ GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(175403),
     /*  175329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175332 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  175340 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175348 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(175375), // Rule ID 46090 //
     /*  175353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175356 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  175356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  175359 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175373 */     GIR_RootConstrainSelectedInstOperands,
     /*  175374 */     // GIR_Coverage, 46090,
     /*  175374 */     GIR_EraseRootFromParent_Done,
     /*  175375 */   // Label 3379: @175375
     /*  175375 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(175402), // Rule ID 46091 //
     /*  175380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175383 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  175383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  175386 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  175396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175400 */     GIR_RootConstrainSelectedInstOperands,
     /*  175401 */     // GIR_Coverage, 46091,
     /*  175401 */     GIR_EraseRootFromParent_Done,
     /*  175402 */   // Label 3380: @175402
     /*  175402 */   GIM_Reject,
     /*  175403 */ // Label 3378: @175403
     /*  175403 */ GIM_Reject,
     /*  175404 */ // Label 3201: @175404
     /*  175404 */ GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(175491),
     /*  175409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  175412 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  175416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  175420 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(175455), // Rule ID 45970 //
     /*  175425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  175428 */     // MIs[0] rs1
     /*  175428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  175432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175436 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  175436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  175439 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175453 */     GIR_RootConstrainSelectedInstOperands,
     /*  175454 */     // GIR_Coverage, 45970,
     /*  175454 */     GIR_EraseRootFromParent_Done,
     /*  175455 */   // Label 3382: @175455
     /*  175455 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(175490), // Rule ID 45971 //
     /*  175460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  175463 */     // MIs[0] rs1
     /*  175463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175471 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  175471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  175474 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  175476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  175478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  175481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  175484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175488 */     GIR_RootConstrainSelectedInstOperands,
     /*  175489 */     // GIR_Coverage, 45971,
     /*  175489 */     GIR_EraseRootFromParent_Done,
     /*  175490 */   // Label 3383: @175490
     /*  175490 */   GIM_Reject,
     /*  175491 */ // Label 3381: @175491
     /*  175491 */ GIM_Reject,
     /*  175492 */ // Label 3202: @175492
     /*  175492 */ GIM_Reject,
     /*  175493 */ // Label 25: @175493
     /*  175493 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3386*/ GIMT_Encode4(180378),
     /*  175504 */ /*GILLT_s32*//*Label 3384*/ GIMT_Encode4(175512),
     /*  175508 */ /*GILLT_s64*//*Label 3385*/ GIMT_Encode4(177505),
     /*  175512 */ // Label 3384: @175512
     /*  175512 */ GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(177504),
     /*  175517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  175520 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  175523 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(175589), // Rule ID 651 //
     /*  175528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175538 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  175541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175545 */     // MIs[0] addr
     /*  175545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175561 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 2:{ *:[i32] })
     /*  175561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175569 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175574 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175576 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175578 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  175583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175587 */     GIR_RootConstrainSelectedInstOperands,
     /*  175588 */     // GIR_Coverage, 651,
     /*  175588 */     GIR_EraseRootFromParent_Done,
     /*  175589 */   // Label 3388: @175589
     /*  175589 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(175655), // Rule ID 653 //
     /*  175594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  175607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175611 */     // MIs[0] addr
     /*  175611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175627 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 4:{ *:[i32] })
     /*  175627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175635 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175640 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175642 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175644 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175653 */     GIR_RootConstrainSelectedInstOperands,
     /*  175654 */     // GIR_Coverage, 653,
     /*  175654 */     GIR_EraseRootFromParent_Done,
     /*  175655 */   // Label 3389: @175655
     /*  175655 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(175721), // Rule ID 655 //
     /*  175660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175677 */     // MIs[0] addr
     /*  175677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175693 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 5:{ *:[i32] })
     /*  175693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175701 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175706 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175708 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175710 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175719 */     GIR_RootConstrainSelectedInstOperands,
     /*  175720 */     // GIR_Coverage, 655,
     /*  175720 */     GIR_EraseRootFromParent_Done,
     /*  175721 */   // Label 3390: @175721
     /*  175721 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(175787), // Rule ID 657 //
     /*  175726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  175739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175743 */     // MIs[0] addr
     /*  175743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175759 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 6:{ *:[i32] })
     /*  175759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175767 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175772 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175774 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175776 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  175781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175785 */     GIR_RootConstrainSelectedInstOperands,
     /*  175786 */     // GIR_Coverage, 657,
     /*  175786 */     GIR_EraseRootFromParent_Done,
     /*  175787 */   // Label 3391: @175787
     /*  175787 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175853), // Rule ID 659 //
     /*  175792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175809 */     // MIs[0] addr
     /*  175809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175825 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 7:{ *:[i32] })
     /*  175825 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175833 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175838 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175840 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175842 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  175847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175851 */     GIR_RootConstrainSelectedInstOperands,
     /*  175852 */     // GIR_Coverage, 659,
     /*  175852 */     GIR_EraseRootFromParent_Done,
     /*  175853 */   // Label 3392: @175853
     /*  175853 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175908), // Rule ID 668 //
     /*  175858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175861 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  175871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175875 */     // MIs[0] addr
     /*  175875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175891 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  175894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175896 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175898 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175900 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175906 */     GIR_RootConstrainSelectedInstOperands,
     /*  175907 */     // GIR_Coverage, 668,
     /*  175907 */     GIR_EraseRootFromParent_Done,
     /*  175908 */   // Label 3393: @175908
     /*  175908 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175963), // Rule ID 670 //
     /*  175913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  175926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175930 */     // MIs[0] addr
     /*  175930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175946 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  175949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175951 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175953 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175955 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175961 */     GIR_RootConstrainSelectedInstOperands,
     /*  175962 */     // GIR_Coverage, 670,
     /*  175962 */     GIR_EraseRootFromParent_Done,
     /*  175963 */   // Label 3394: @175963
     /*  175963 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(176018), // Rule ID 672 //
     /*  175968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175971 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175978 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175985 */     // MIs[0] addr
     /*  175985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176001 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  176004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176006 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176008 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176010 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176016 */     GIR_RootConstrainSelectedInstOperands,
     /*  176017 */     // GIR_Coverage, 672,
     /*  176017 */     GIR_EraseRootFromParent_Done,
     /*  176018 */   // Label 3395: @176018
     /*  176018 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(176073), // Rule ID 674 //
     /*  176023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176040 */     // MIs[0] addr
     /*  176040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176056 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  176059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176061 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176063 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176065 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176071 */     GIR_RootConstrainSelectedInstOperands,
     /*  176072 */     // GIR_Coverage, 674,
     /*  176072 */     GIR_EraseRootFromParent_Done,
     /*  176073 */   // Label 3396: @176073
     /*  176073 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(176128), // Rule ID 676 //
     /*  176078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176095 */     // MIs[0] addr
     /*  176095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176111 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  176114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176116 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176118 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176120 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176126 */     GIR_RootConstrainSelectedInstOperands,
     /*  176127 */     // GIR_Coverage, 676,
     /*  176127 */     GIR_EraseRootFromParent_Done,
     /*  176128 */   // Label 3397: @176128
     /*  176128 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(176183), // Rule ID 678 //
     /*  176133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176136 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176143 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176150 */     // MIs[0] addr
     /*  176150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176166 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176171 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176173 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176175 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176181 */     GIR_RootConstrainSelectedInstOperands,
     /*  176182 */     // GIR_Coverage, 678,
     /*  176182 */     GIR_EraseRootFromParent_Done,
     /*  176183 */   // Label 3398: @176183
     /*  176183 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(176238), // Rule ID 680 //
     /*  176188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176191 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176205 */     // MIs[0] addr
     /*  176205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176221 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176226 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176228 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176230 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176236 */     GIR_RootConstrainSelectedInstOperands,
     /*  176237 */     // GIR_Coverage, 680,
     /*  176237 */     GIR_EraseRootFromParent_Done,
     /*  176238 */   // Label 3399: @176238
     /*  176238 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(176293), // Rule ID 682 //
     /*  176243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176260 */     // MIs[0] addr
     /*  176260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176276 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176281 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176283 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176285 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176291 */     GIR_RootConstrainSelectedInstOperands,
     /*  176292 */     // GIR_Coverage, 682,
     /*  176292 */     GIR_EraseRootFromParent_Done,
     /*  176293 */   // Label 3400: @176293
     /*  176293 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(176348), // Rule ID 684 //
     /*  176298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176301 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176308 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176315 */     // MIs[0] addr
     /*  176315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176331 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176336 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176338 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176340 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176346 */     GIR_RootConstrainSelectedInstOperands,
     /*  176347 */     // GIR_Coverage, 684,
     /*  176347 */     GIR_EraseRootFromParent_Done,
     /*  176348 */   // Label 3401: @176348
     /*  176348 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(176403), // Rule ID 686 //
     /*  176353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176356 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  176363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176370 */     // MIs[0] addr
     /*  176370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176386 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  176389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176391 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176393 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176395 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176401 */     GIR_RootConstrainSelectedInstOperands,
     /*  176402 */     // GIR_Coverage, 686,
     /*  176402 */     GIR_EraseRootFromParent_Done,
     /*  176403 */   // Label 3402: @176403
     /*  176403 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(176458), // Rule ID 1058 //
     /*  176408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176425 */     // MIs[0] addr
     /*  176425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176441 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176446 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176448 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176450 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176456 */     GIR_RootConstrainSelectedInstOperands,
     /*  176457 */     // GIR_Coverage, 1058,
     /*  176457 */     GIR_EraseRootFromParent_Done,
     /*  176458 */   // Label 3403: @176458
     /*  176458 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(176513), // Rule ID 1060 //
     /*  176463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176480 */     // MIs[0] addr
     /*  176480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176496 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  176499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176501 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176503 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176505 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176511 */     GIR_RootConstrainSelectedInstOperands,
     /*  176512 */     // GIR_Coverage, 1060,
     /*  176512 */     GIR_EraseRootFromParent_Done,
     /*  176513 */   // Label 3404: @176513
     /*  176513 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(176568), // Rule ID 1062 //
     /*  176518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176528 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176535 */     // MIs[0] addr
     /*  176535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176551 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  176554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176556 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176558 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176560 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176566 */     GIR_RootConstrainSelectedInstOperands,
     /*  176567 */     // GIR_Coverage, 1062,
     /*  176567 */     GIR_EraseRootFromParent_Done,
     /*  176568 */   // Label 3405: @176568
     /*  176568 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(176623), // Rule ID 1064 //
     /*  176573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176590 */     // MIs[0] addr
     /*  176590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176606 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  176609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176611 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176613 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176615 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176621 */     GIR_RootConstrainSelectedInstOperands,
     /*  176622 */     // GIR_Coverage, 1064,
     /*  176622 */     GIR_EraseRootFromParent_Done,
     /*  176623 */   // Label 3406: @176623
     /*  176623 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(176678), // Rule ID 1066 //
     /*  176628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176645 */     // MIs[0] addr
     /*  176645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176661 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  176664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176666 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176668 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176670 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176676 */     GIR_RootConstrainSelectedInstOperands,
     /*  176677 */     // GIR_Coverage, 1066,
     /*  176677 */     GIR_EraseRootFromParent_Done,
     /*  176678 */   // Label 3407: @176678
     /*  176678 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(176733), // Rule ID 1068 //
     /*  176683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176700 */     // MIs[0] addr
     /*  176700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176716 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176721 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176723 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176725 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176731 */     GIR_RootConstrainSelectedInstOperands,
     /*  176732 */     // GIR_Coverage, 1068,
     /*  176732 */     GIR_EraseRootFromParent_Done,
     /*  176733 */   // Label 3408: @176733
     /*  176733 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(176788), // Rule ID 1070 //
     /*  176738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176741 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176748 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176755 */     // MIs[0] addr
     /*  176755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176771 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176776 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176778 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176780 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176786 */     GIR_RootConstrainSelectedInstOperands,
     /*  176787 */     // GIR_Coverage, 1070,
     /*  176787 */     GIR_EraseRootFromParent_Done,
     /*  176788 */   // Label 3409: @176788
     /*  176788 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(176843), // Rule ID 1072 //
     /*  176793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176803 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176810 */     // MIs[0] addr
     /*  176810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176826 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176831 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176833 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176835 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176841 */     GIR_RootConstrainSelectedInstOperands,
     /*  176842 */     // GIR_Coverage, 1072,
     /*  176842 */     GIR_EraseRootFromParent_Done,
     /*  176843 */   // Label 3410: @176843
     /*  176843 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(176898), // Rule ID 1074 //
     /*  176848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176865 */     // MIs[0] addr
     /*  176865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176881 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176886 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176888 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176890 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176896 */     GIR_RootConstrainSelectedInstOperands,
     /*  176897 */     // GIR_Coverage, 1074,
     /*  176897 */     GIR_EraseRootFromParent_Done,
     /*  176898 */   // Label 3411: @176898
     /*  176898 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(176953), // Rule ID 1076 //
     /*  176903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176920 */     // MIs[0] addr
     /*  176920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176936 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176941 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176943 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176945 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176951 */     GIR_RootConstrainSelectedInstOperands,
     /*  176952 */     // GIR_Coverage, 1076,
     /*  176952 */     GIR_EraseRootFromParent_Done,
     /*  176953 */   // Label 3412: @176953
     /*  176953 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(177008), // Rule ID 1078 //
     /*  176958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176975 */     // MIs[0] addr
     /*  176975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176991 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  176994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176996 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176998 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177000 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177006 */     GIR_RootConstrainSelectedInstOperands,
     /*  177007 */     // GIR_Coverage, 1078,
     /*  177007 */     GIR_EraseRootFromParent_Done,
     /*  177008 */   // Label 3413: @177008
     /*  177008 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(177063), // Rule ID 1080 //
     /*  177013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177030 */     // MIs[0] addr
     /*  177030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177046 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  177049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177051 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177053 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177055 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177061 */     GIR_RootConstrainSelectedInstOperands,
     /*  177062 */     // GIR_Coverage, 1080,
     /*  177062 */     GIR_EraseRootFromParent_Done,
     /*  177063 */   // Label 3414: @177063
     /*  177063 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(177118), // Rule ID 1082 //
     /*  177068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177071 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177085 */     // MIs[0] addr
     /*  177085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177101 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  177104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177106 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177108 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177110 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177116 */     GIR_RootConstrainSelectedInstOperands,
     /*  177117 */     // GIR_Coverage, 1082,
     /*  177117 */     GIR_EraseRootFromParent_Done,
     /*  177118 */   // Label 3415: @177118
     /*  177118 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(177173), // Rule ID 1084 //
     /*  177123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177126 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177140 */     // MIs[0] addr
     /*  177140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177156 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  177159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177161 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177163 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177165 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177171 */     GIR_RootConstrainSelectedInstOperands,
     /*  177172 */     // GIR_Coverage, 1084,
     /*  177172 */     GIR_EraseRootFromParent_Done,
     /*  177173 */   // Label 3416: @177173
     /*  177173 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(177228), // Rule ID 1086 //
     /*  177178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  177181 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177195 */     // MIs[0] addr
     /*  177195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177211 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  177214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177216 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177218 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177220 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177226 */     GIR_RootConstrainSelectedInstOperands,
     /*  177227 */     // GIR_Coverage, 1086,
     /*  177227 */     GIR_EraseRootFromParent_Done,
     /*  177228 */   // Label 3417: @177228
     /*  177228 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(177283), // Rule ID 1088 //
     /*  177233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177250 */     // MIs[0] addr
     /*  177250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177266 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177271 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177273 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177275 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177281 */     GIR_RootConstrainSelectedInstOperands,
     /*  177282 */     // GIR_Coverage, 1088,
     /*  177282 */     GIR_EraseRootFromParent_Done,
     /*  177283 */   // Label 3418: @177283
     /*  177283 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(177338), // Rule ID 1090 //
     /*  177288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177291 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177298 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177305 */     // MIs[0] addr
     /*  177305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177321 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177326 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177328 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177330 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177336 */     GIR_RootConstrainSelectedInstOperands,
     /*  177337 */     // GIR_Coverage, 1090,
     /*  177337 */     GIR_EraseRootFromParent_Done,
     /*  177338 */   // Label 3419: @177338
     /*  177338 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(177393), // Rule ID 1092 //
     /*  177343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177360 */     // MIs[0] addr
     /*  177360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177376 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177381 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177383 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177385 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177391 */     GIR_RootConstrainSelectedInstOperands,
     /*  177392 */     // GIR_Coverage, 1092,
     /*  177392 */     GIR_EraseRootFromParent_Done,
     /*  177393 */   // Label 3420: @177393
     /*  177393 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(177448), // Rule ID 1094 //
     /*  177398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177415 */     // MIs[0] addr
     /*  177415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177431 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177436 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177438 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177440 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177446 */     GIR_RootConstrainSelectedInstOperands,
     /*  177447 */     // GIR_Coverage, 1094,
     /*  177447 */     GIR_EraseRootFromParent_Done,
     /*  177448 */   // Label 3421: @177448
     /*  177448 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(177503), // Rule ID 1096 //
     /*  177453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  177456 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  177463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177470 */     // MIs[0] addr
     /*  177470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  177474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177486 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  177486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  177489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177491 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177493 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177495 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177501 */     GIR_RootConstrainSelectedInstOperands,
     /*  177502 */     // GIR_Coverage, 1096,
     /*  177502 */     GIR_EraseRootFromParent_Done,
     /*  177503 */   // Label 3422: @177503
     /*  177503 */   GIM_Reject,
     /*  177504 */ // Label 3387: @177504
     /*  177504 */ GIM_Reject,
     /*  177505 */ // Label 3385: @177505
     /*  177505 */ GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(180377),
     /*  177510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  177513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  177516 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(177582), // Rule ID 650 //
     /*  177521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177538 */     // MIs[0] addr
     /*  177538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177554 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  177554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177562 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177567 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177569 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177571 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  177576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177580 */     GIR_RootConstrainSelectedInstOperands,
     /*  177581 */     // GIR_Coverage, 650,
     /*  177581 */     GIR_EraseRootFromParent_Done,
     /*  177582 */   // Label 3424: @177582
     /*  177582 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(177648), // Rule ID 652 //
     /*  177587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177604 */     // MIs[0] addr
     /*  177604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177620 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  177620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177628 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177633 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177635 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177637 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177646 */     GIR_RootConstrainSelectedInstOperands,
     /*  177647 */     // GIR_Coverage, 652,
     /*  177647 */     GIR_EraseRootFromParent_Done,
     /*  177648 */   // Label 3425: @177648
     /*  177648 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(177714), // Rule ID 654 //
     /*  177653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177670 */     // MIs[0] addr
     /*  177670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177686 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  177686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177694 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177699 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177701 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177703 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177712 */     GIR_RootConstrainSelectedInstOperands,
     /*  177713 */     // GIR_Coverage, 654,
     /*  177713 */     GIR_EraseRootFromParent_Done,
     /*  177714 */   // Label 3426: @177714
     /*  177714 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(177780), // Rule ID 656 //
     /*  177719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177722 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177736 */     // MIs[0] addr
     /*  177736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177752 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  177752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177760 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177765 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177767 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177769 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177778 */     GIR_RootConstrainSelectedInstOperands,
     /*  177779 */     // GIR_Coverage, 656,
     /*  177779 */     GIR_EraseRootFromParent_Done,
     /*  177780 */   // Label 3427: @177780
     /*  177780 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(177846), // Rule ID 658 //
     /*  177785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177802 */     // MIs[0] addr
     /*  177802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177818 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  177818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177826 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177831 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177833 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177835 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  177840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177844 */     GIR_RootConstrainSelectedInstOperands,
     /*  177845 */     // GIR_Coverage, 658,
     /*  177845 */     GIR_EraseRootFromParent_Done,
     /*  177846 */   // Label 3428: @177846
     /*  177846 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(177912), // Rule ID 660 //
     /*  177851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177868 */     // MIs[0] addr
     /*  177868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177884 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  177884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  177890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177892 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177897 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177899 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177901 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  177906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177910 */     GIR_RootConstrainSelectedInstOperands,
     /*  177911 */     // GIR_Coverage, 660,
     /*  177911 */     GIR_EraseRootFromParent_Done,
     /*  177912 */   // Label 3429: @177912
     /*  177912 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(177978), // Rule ID 661 //
     /*  177917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177934 */     // MIs[0] addr
     /*  177934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177950 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  177950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  177956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177958 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177963 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177965 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177967 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177976 */     GIR_RootConstrainSelectedInstOperands,
     /*  177977 */     // GIR_Coverage, 661,
     /*  177977 */     GIR_EraseRootFromParent_Done,
     /*  177978 */   // Label 3430: @177978
     /*  177978 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(178044), // Rule ID 662 //
     /*  177983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178000 */     // MIs[0] addr
     /*  178000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178016 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  178016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178024 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178029 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178031 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178033 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  178038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178042 */     GIR_RootConstrainSelectedInstOperands,
     /*  178043 */     // GIR_Coverage, 662,
     /*  178043 */     GIR_EraseRootFromParent_Done,
     /*  178044 */   // Label 3431: @178044
     /*  178044 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(178110), // Rule ID 663 //
     /*  178049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178066 */     // MIs[0] addr
     /*  178066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178082 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  178082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178090 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178095 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178097 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178099 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  178104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178108 */     GIR_RootConstrainSelectedInstOperands,
     /*  178109 */     // GIR_Coverage, 663,
     /*  178109 */     GIR_EraseRootFromParent_Done,
     /*  178110 */   // Label 3432: @178110
     /*  178110 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(178176), // Rule ID 664 //
     /*  178115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  178118 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178125 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178132 */     // MIs[0] addr
     /*  178132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  178136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178148 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  178148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  178151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  178154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  178156 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  178161 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178163 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178165 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  178170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178174 */     GIR_RootConstrainSelectedInstOperands,
     /*  178175 */     // GIR_Coverage, 664,
     /*  178175 */     GIR_EraseRootFromParent_Done,
     /*  178176 */   // Label 3433: @178176
     /*  178176 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(178231), // Rule ID 667 //
     /*  178181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178184 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178191 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178198 */     // MIs[0] addr
     /*  178198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178214 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178219 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178221 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178223 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178229 */     GIR_RootConstrainSelectedInstOperands,
     /*  178230 */     // GIR_Coverage, 667,
     /*  178230 */     GIR_EraseRootFromParent_Done,
     /*  178231 */   // Label 3434: @178231
     /*  178231 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(178286), // Rule ID 669 //
     /*  178236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178239 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178253 */     // MIs[0] addr
     /*  178253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178269 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  178272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178274 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178276 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178278 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178284 */     GIR_RootConstrainSelectedInstOperands,
     /*  178285 */     // GIR_Coverage, 669,
     /*  178285 */     GIR_EraseRootFromParent_Done,
     /*  178286 */   // Label 3435: @178286
     /*  178286 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(178341), // Rule ID 671 //
     /*  178291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178308 */     // MIs[0] addr
     /*  178308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178324 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  178327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178329 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178331 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178333 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178339 */     GIR_RootConstrainSelectedInstOperands,
     /*  178340 */     // GIR_Coverage, 671,
     /*  178340 */     GIR_EraseRootFromParent_Done,
     /*  178341 */   // Label 3436: @178341
     /*  178341 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(178396), // Rule ID 673 //
     /*  178346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178349 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178363 */     // MIs[0] addr
     /*  178363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178379 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  178382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178384 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178386 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178388 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178394 */     GIR_RootConstrainSelectedInstOperands,
     /*  178395 */     // GIR_Coverage, 673,
     /*  178395 */     GIR_EraseRootFromParent_Done,
     /*  178396 */   // Label 3437: @178396
     /*  178396 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(178451), // Rule ID 675 //
     /*  178401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178418 */     // MIs[0] addr
     /*  178418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178434 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  178437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178439 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178441 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178443 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178449 */     GIR_RootConstrainSelectedInstOperands,
     /*  178450 */     // GIR_Coverage, 675,
     /*  178450 */     GIR_EraseRootFromParent_Done,
     /*  178451 */   // Label 3438: @178451
     /*  178451 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(178506), // Rule ID 677 //
     /*  178456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178459 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178466 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178473 */     // MIs[0] addr
     /*  178473 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178489 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178494 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178496 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178498 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178504 */     GIR_RootConstrainSelectedInstOperands,
     /*  178505 */     // GIR_Coverage, 677,
     /*  178505 */     GIR_EraseRootFromParent_Done,
     /*  178506 */   // Label 3439: @178506
     /*  178506 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(178561), // Rule ID 679 //
     /*  178511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178514 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178521 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178528 */     // MIs[0] addr
     /*  178528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178544 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178549 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178551 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178553 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178559 */     GIR_RootConstrainSelectedInstOperands,
     /*  178560 */     // GIR_Coverage, 679,
     /*  178560 */     GIR_EraseRootFromParent_Done,
     /*  178561 */   // Label 3440: @178561
     /*  178561 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(178616), // Rule ID 681 //
     /*  178566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178569 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178576 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178583 */     // MIs[0] addr
     /*  178583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178599 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178604 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178606 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178608 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178614 */     GIR_RootConstrainSelectedInstOperands,
     /*  178615 */     // GIR_Coverage, 681,
     /*  178615 */     GIR_EraseRootFromParent_Done,
     /*  178616 */   // Label 3441: @178616
     /*  178616 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(178671), // Rule ID 683 //
     /*  178621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178638 */     // MIs[0] addr
     /*  178638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178654 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178659 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178661 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178663 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178669 */     GIR_RootConstrainSelectedInstOperands,
     /*  178670 */     // GIR_Coverage, 683,
     /*  178670 */     GIR_EraseRootFromParent_Done,
     /*  178671 */   // Label 3442: @178671
     /*  178671 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(178726), // Rule ID 685 //
     /*  178676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178693 */     // MIs[0] addr
     /*  178693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178709 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178714 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178716 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178718 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178724 */     GIR_RootConstrainSelectedInstOperands,
     /*  178725 */     // GIR_Coverage, 685,
     /*  178725 */     GIR_EraseRootFromParent_Done,
     /*  178726 */   // Label 3443: @178726
     /*  178726 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(178781), // Rule ID 687 //
     /*  178731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178734 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178748 */     // MIs[0] addr
     /*  178748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178764 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  178767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178769 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178771 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178773 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178779 */     GIR_RootConstrainSelectedInstOperands,
     /*  178780 */     // GIR_Coverage, 687,
     /*  178780 */     GIR_EraseRootFromParent_Done,
     /*  178781 */   // Label 3444: @178781
     /*  178781 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(178836), // Rule ID 688 //
     /*  178786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178789 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178796 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178803 */     // MIs[0] addr
     /*  178803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178819 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ),
     /*  178822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178824 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178826 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178828 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178834 */     GIR_RootConstrainSelectedInstOperands,
     /*  178835 */     // GIR_Coverage, 688,
     /*  178835 */     GIR_EraseRootFromParent_Done,
     /*  178836 */   // Label 3445: @178836
     /*  178836 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(178891), // Rule ID 689 //
     /*  178841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178858 */     // MIs[0] addr
     /*  178858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178874 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_RL),
     /*  178877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178879 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178881 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178883 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178889 */     GIR_RootConstrainSelectedInstOperands,
     /*  178890 */     // GIR_Coverage, 689,
     /*  178890 */     GIR_EraseRootFromParent_Done,
     /*  178891 */   // Label 3446: @178891
     /*  178891 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(178946), // Rule ID 690 //
     /*  178896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178899 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178906 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178913 */     // MIs[0] addr
     /*  178913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178929 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  178932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178934 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178936 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178938 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178944 */     GIR_RootConstrainSelectedInstOperands,
     /*  178945 */     // GIR_Coverage, 690,
     /*  178945 */     GIR_EraseRootFromParent_Done,
     /*  178946 */   // Label 3447: @178946
     /*  178946 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(179001), // Rule ID 691 //
     /*  178951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178954 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178961 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178968 */     // MIs[0] addr
     /*  178968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178984 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  178987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178989 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178991 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178993 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178999 */     GIR_RootConstrainSelectedInstOperands,
     /*  179000 */     // GIR_Coverage, 691,
     /*  179000 */     GIR_EraseRootFromParent_Done,
     /*  179001 */   // Label 3448: @179001
     /*  179001 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(179056), // Rule ID 692 //
     /*  179006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179009 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179016 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179023 */     // MIs[0] addr
     /*  179023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179039 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179044 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179046 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179048 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179054 */     GIR_RootConstrainSelectedInstOperands,
     /*  179055 */     // GIR_Coverage, 692,
     /*  179055 */     GIR_EraseRootFromParent_Done,
     /*  179056 */   // Label 3449: @179056
     /*  179056 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(179111), // Rule ID 693 //
     /*  179061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179078 */     // MIs[0] addr
     /*  179078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179094 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179099 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179101 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179103 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179109 */     GIR_RootConstrainSelectedInstOperands,
     /*  179110 */     // GIR_Coverage, 693,
     /*  179110 */     GIR_EraseRootFromParent_Done,
     /*  179111 */   // Label 3450: @179111
     /*  179111 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(179166), // Rule ID 694 //
     /*  179116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179119 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179133 */     // MIs[0] addr
     /*  179133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179149 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179154 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179156 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179158 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179164 */     GIR_RootConstrainSelectedInstOperands,
     /*  179165 */     // GIR_Coverage, 694,
     /*  179165 */     GIR_EraseRootFromParent_Done,
     /*  179166 */   // Label 3451: @179166
     /*  179166 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(179221), // Rule ID 695 //
     /*  179171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179188 */     // MIs[0] addr
     /*  179188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179204 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179209 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179211 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179213 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179219 */     GIR_RootConstrainSelectedInstOperands,
     /*  179220 */     // GIR_Coverage, 695,
     /*  179220 */     GIR_EraseRootFromParent_Done,
     /*  179221 */   // Label 3452: @179221
     /*  179221 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(179276), // Rule ID 696 //
     /*  179226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  179229 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  179236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179243 */     // MIs[0] addr
     /*  179243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179259 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  179262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179264 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179266 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179268 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179274 */     GIR_RootConstrainSelectedInstOperands,
     /*  179275 */     // GIR_Coverage, 696,
     /*  179275 */     GIR_EraseRootFromParent_Done,
     /*  179276 */   // Label 3453: @179276
     /*  179276 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(179331), // Rule ID 1057 //
     /*  179281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179284 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179298 */     // MIs[0] addr
     /*  179298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179314 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179319 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179321 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179323 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179329 */     GIR_RootConstrainSelectedInstOperands,
     /*  179330 */     // GIR_Coverage, 1057,
     /*  179330 */     GIR_EraseRootFromParent_Done,
     /*  179331 */   // Label 3454: @179331
     /*  179331 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(179386), // Rule ID 1059 //
     /*  179336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179339 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179346 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179353 */     // MIs[0] addr
     /*  179353 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179369 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  179372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179374 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179376 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179378 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179384 */     GIR_RootConstrainSelectedInstOperands,
     /*  179385 */     // GIR_Coverage, 1059,
     /*  179385 */     GIR_EraseRootFromParent_Done,
     /*  179386 */   // Label 3455: @179386
     /*  179386 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(179441), // Rule ID 1061 //
     /*  179391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179408 */     // MIs[0] addr
     /*  179408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179424 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  179427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179429 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179431 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179433 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179439 */     GIR_RootConstrainSelectedInstOperands,
     /*  179440 */     // GIR_Coverage, 1061,
     /*  179440 */     GIR_EraseRootFromParent_Done,
     /*  179441 */   // Label 3456: @179441
     /*  179441 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(179496), // Rule ID 1063 //
     /*  179446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179463 */     // MIs[0] addr
     /*  179463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179479 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  179482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179484 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179486 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179488 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179494 */     GIR_RootConstrainSelectedInstOperands,
     /*  179495 */     // GIR_Coverage, 1063,
     /*  179495 */     GIR_EraseRootFromParent_Done,
     /*  179496 */   // Label 3457: @179496
     /*  179496 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(179551), // Rule ID 1065 //
     /*  179501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179504 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179511 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179518 */     // MIs[0] addr
     /*  179518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179534 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  179537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179539 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179541 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179543 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179549 */     GIR_RootConstrainSelectedInstOperands,
     /*  179550 */     // GIR_Coverage, 1065,
     /*  179550 */     GIR_EraseRootFromParent_Done,
     /*  179551 */   // Label 3458: @179551
     /*  179551 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(179606), // Rule ID 1067 //
     /*  179556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179573 */     // MIs[0] addr
     /*  179573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179589 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179594 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179596 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179598 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179604 */     GIR_RootConstrainSelectedInstOperands,
     /*  179605 */     // GIR_Coverage, 1067,
     /*  179605 */     GIR_EraseRootFromParent_Done,
     /*  179606 */   // Label 3459: @179606
     /*  179606 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(179661), // Rule ID 1069 //
     /*  179611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179628 */     // MIs[0] addr
     /*  179628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179644 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179649 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179651 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179653 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179659 */     GIR_RootConstrainSelectedInstOperands,
     /*  179660 */     // GIR_Coverage, 1069,
     /*  179660 */     GIR_EraseRootFromParent_Done,
     /*  179661 */   // Label 3460: @179661
     /*  179661 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(179716), // Rule ID 1071 //
     /*  179666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179669 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179683 */     // MIs[0] addr
     /*  179683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179699 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179704 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179706 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179708 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179714 */     GIR_RootConstrainSelectedInstOperands,
     /*  179715 */     // GIR_Coverage, 1071,
     /*  179715 */     GIR_EraseRootFromParent_Done,
     /*  179716 */   // Label 3461: @179716
     /*  179716 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(179771), // Rule ID 1073 //
     /*  179721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179724 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179731 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179738 */     // MIs[0] addr
     /*  179738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179754 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179759 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179761 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179763 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179769 */     GIR_RootConstrainSelectedInstOperands,
     /*  179770 */     // GIR_Coverage, 1073,
     /*  179770 */     GIR_EraseRootFromParent_Done,
     /*  179771 */   // Label 3462: @179771
     /*  179771 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(179826), // Rule ID 1075 //
     /*  179776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179779 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179793 */     // MIs[0] addr
     /*  179793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179809 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179814 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179816 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179818 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179824 */     GIR_RootConstrainSelectedInstOperands,
     /*  179825 */     // GIR_Coverage, 1075,
     /*  179825 */     GIR_EraseRootFromParent_Done,
     /*  179826 */   // Label 3463: @179826
     /*  179826 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(179881), // Rule ID 1077 //
     /*  179831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179834 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179841 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179848 */     // MIs[0] addr
     /*  179848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179864 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  179867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179869 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179871 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179873 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179879 */     GIR_RootConstrainSelectedInstOperands,
     /*  179880 */     // GIR_Coverage, 1077,
     /*  179880 */     GIR_EraseRootFromParent_Done,
     /*  179881 */   // Label 3464: @179881
     /*  179881 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(179936), // Rule ID 1079 //
     /*  179886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179889 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179896 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179903 */     // MIs[0] addr
     /*  179903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179919 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  179922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179924 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179926 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179928 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179934 */     GIR_RootConstrainSelectedInstOperands,
     /*  179935 */     // GIR_Coverage, 1079,
     /*  179935 */     GIR_EraseRootFromParent_Done,
     /*  179936 */   // Label 3465: @179936
     /*  179936 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(179991), // Rule ID 1081 //
     /*  179941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179951 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179958 */     // MIs[0] addr
     /*  179958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179974 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  179977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179979 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179981 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179983 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179989 */     GIR_RootConstrainSelectedInstOperands,
     /*  179990 */     // GIR_Coverage, 1081,
     /*  179990 */     GIR_EraseRootFromParent_Done,
     /*  179991 */   // Label 3466: @179991
     /*  179991 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(180046), // Rule ID 1083 //
     /*  179996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180013 */     // MIs[0] addr
     /*  180013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180029 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  180032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180034 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180036 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180038 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180044 */     GIR_RootConstrainSelectedInstOperands,
     /*  180045 */     // GIR_Coverage, 1083,
     /*  180045 */     GIR_EraseRootFromParent_Done,
     /*  180046 */   // Label 3467: @180046
     /*  180046 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(180101), // Rule ID 1085 //
     /*  180051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  180054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180068 */     // MIs[0] addr
     /*  180068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180084 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  180087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180089 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180091 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180093 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180099 */     GIR_RootConstrainSelectedInstOperands,
     /*  180100 */     // GIR_Coverage, 1085,
     /*  180100 */     GIR_EraseRootFromParent_Done,
     /*  180101 */   // Label 3468: @180101
     /*  180101 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(180156), // Rule ID 1087 //
     /*  180106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180109 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180116 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180123 */     // MIs[0] addr
     /*  180123 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180139 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180144 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180146 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180148 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180154 */     GIR_RootConstrainSelectedInstOperands,
     /*  180155 */     // GIR_Coverage, 1087,
     /*  180155 */     GIR_EraseRootFromParent_Done,
     /*  180156 */   // Label 3469: @180156
     /*  180156 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(180211), // Rule ID 1089 //
     /*  180161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180178 */     // MIs[0] addr
     /*  180178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180194 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180199 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180201 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180203 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180209 */     GIR_RootConstrainSelectedInstOperands,
     /*  180210 */     // GIR_Coverage, 1089,
     /*  180210 */     GIR_EraseRootFromParent_Done,
     /*  180211 */   // Label 3470: @180211
     /*  180211 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(180266), // Rule ID 1091 //
     /*  180216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180219 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180226 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180233 */     // MIs[0] addr
     /*  180233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180249 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180254 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180256 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180258 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180264 */     GIR_RootConstrainSelectedInstOperands,
     /*  180265 */     // GIR_Coverage, 1091,
     /*  180265 */     GIR_EraseRootFromParent_Done,
     /*  180266 */   // Label 3471: @180266
     /*  180266 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(180321), // Rule ID 1093 //
     /*  180271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180274 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180281 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180288 */     // MIs[0] addr
     /*  180288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180304 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180309 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180311 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180313 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180319 */     GIR_RootConstrainSelectedInstOperands,
     /*  180320 */     // GIR_Coverage, 1093,
     /*  180320 */     GIR_EraseRootFromParent_Done,
     /*  180321 */   // Label 3472: @180321
     /*  180321 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(180376), // Rule ID 1095 //
     /*  180326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  180329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180343 */     // MIs[0] addr
     /*  180343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  180347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180359 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  180359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  180362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  180364 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  180366 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  180368 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  180370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  180374 */     GIR_RootConstrainSelectedInstOperands,
     /*  180375 */     // GIR_Coverage, 1095,
     /*  180375 */     GIR_EraseRootFromParent_Done,
     /*  180376 */   // Label 3473: @180376
     /*  180376 */   GIM_Reject,
     /*  180377 */ // Label 3423: @180377
     /*  180377 */ GIM_Reject,
     /*  180378 */ // Label 3386: @180378
     /*  180378 */ GIM_Reject,
     /*  180379 */ // Label 26: @180379
     /*  180379 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3476*/ GIMT_Encode4(183288),
     /*  180390 */ /*GILLT_s32*//*Label 3474*/ GIMT_Encode4(180398),
     /*  180394 */ /*GILLT_s64*//*Label 3475*/ GIMT_Encode4(181638),
     /*  180398 */ // Label 3474: @180398
     /*  180398 */ GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(181637),
     /*  180403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  180406 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(180447), // Rule ID 350 //
     /*  180411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180414 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180428 */     // MIs[0] rs1
     /*  180428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180440 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180445 */     GIR_RootConstrainSelectedInstOperands,
     /*  180446 */     // GIR_Coverage, 350,
     /*  180446 */     GIR_Done,
     /*  180447 */   // Label 3478: @180447
     /*  180447 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(180488), // Rule ID 352 //
     /*  180452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180455 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180462 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180469 */     // MIs[0] rs1
     /*  180469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180481 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  180486 */     GIR_RootConstrainSelectedInstOperands,
     /*  180487 */     // GIR_Coverage, 352,
     /*  180487 */     GIR_Done,
     /*  180488 */   // Label 3479: @180488
     /*  180488 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(180529), // Rule ID 354 //
     /*  180493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180496 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180503 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180510 */     // MIs[0] rs1
     /*  180510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180522 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  180527 */     GIR_RootConstrainSelectedInstOperands,
     /*  180528 */     // GIR_Coverage, 354,
     /*  180528 */     GIR_Done,
     /*  180529 */   // Label 3480: @180529
     /*  180529 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(180570), // Rule ID 356 //
     /*  180534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180537 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180544 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180551 */     // MIs[0] rs1
     /*  180551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180563 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  180568 */     GIR_RootConstrainSelectedInstOperands,
     /*  180569 */     // GIR_Coverage, 356,
     /*  180569 */     GIR_Done,
     /*  180570 */   // Label 3481: @180570
     /*  180570 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(180611), // Rule ID 358 //
     /*  180575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180592 */     // MIs[0] rs1
     /*  180592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180604 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  180609 */     GIR_RootConstrainSelectedInstOperands,
     /*  180610 */     // GIR_Coverage, 358,
     /*  180610 */     GIR_Done,
     /*  180611 */   // Label 3482: @180611
     /*  180611 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(180652), // Rule ID 360 //
     /*  180616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180619 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180626 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180633 */     // MIs[0] rs1
     /*  180633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180645 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180645 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180650 */     GIR_RootConstrainSelectedInstOperands,
     /*  180651 */     // GIR_Coverage, 360,
     /*  180651 */     GIR_Done,
     /*  180652 */   // Label 3483: @180652
     /*  180652 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(180693), // Rule ID 362 //
     /*  180657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180660 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180667 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180674 */     // MIs[0] rs1
     /*  180674 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180686 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180691 */     GIR_RootConstrainSelectedInstOperands,
     /*  180692 */     // GIR_Coverage, 362,
     /*  180692 */     GIR_Done,
     /*  180693 */   // Label 3484: @180693
     /*  180693 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(180734), // Rule ID 364 //
     /*  180698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180701 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180708 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180715 */     // MIs[0] rs1
     /*  180715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180727 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180732 */     GIR_RootConstrainSelectedInstOperands,
     /*  180733 */     // GIR_Coverage, 364,
     /*  180733 */     GIR_Done,
     /*  180734 */   // Label 3485: @180734
     /*  180734 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(180775), // Rule ID 366 //
     /*  180739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180742 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180749 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180756 */     // MIs[0] rs1
     /*  180756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180768 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180773 */     GIR_RootConstrainSelectedInstOperands,
     /*  180774 */     // GIR_Coverage, 366,
     /*  180774 */     GIR_Done,
     /*  180775 */   // Label 3486: @180775
     /*  180775 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(180816), // Rule ID 368 //
     /*  180780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180783 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180790 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180797 */     // MIs[0] rs1
     /*  180797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180809 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180814 */     GIR_RootConstrainSelectedInstOperands,
     /*  180815 */     // GIR_Coverage, 368,
     /*  180815 */     GIR_Done,
     /*  180816 */   // Label 3487: @180816
     /*  180816 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(180857), // Rule ID 698 //
     /*  180821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180824 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180838 */     // MIs[0] rs1
     /*  180838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180850 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  180855 */     GIR_RootConstrainSelectedInstOperands,
     /*  180856 */     // GIR_Coverage, 698,
     /*  180856 */     GIR_Done,
     /*  180857 */   // Label 3488: @180857
     /*  180857 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(180898), // Rule ID 700 //
     /*  180862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180865 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180872 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180879 */     // MIs[0] rs1
     /*  180879 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180891 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  180896 */     GIR_RootConstrainSelectedInstOperands,
     /*  180897 */     // GIR_Coverage, 700,
     /*  180897 */     GIR_Done,
     /*  180898 */   // Label 3489: @180898
     /*  180898 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(180939), // Rule ID 702 //
     /*  180903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180920 */     // MIs[0] rs1
     /*  180920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180932 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  180937 */     GIR_RootConstrainSelectedInstOperands,
     /*  180938 */     // GIR_Coverage, 702,
     /*  180938 */     GIR_Done,
     /*  180939 */   // Label 3490: @180939
     /*  180939 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(180980), // Rule ID 704 //
     /*  180944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180947 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180954 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180961 */     // MIs[0] rs1
     /*  180961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180973 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  180978 */     GIR_RootConstrainSelectedInstOperands,
     /*  180979 */     // GIR_Coverage, 704,
     /*  180979 */     GIR_Done,
     /*  180980 */   // Label 3491: @180980
     /*  180980 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(181021), // Rule ID 706 //
     /*  180985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180988 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181002 */     // MIs[0] rs1
     /*  181002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181014 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  181019 */     GIR_RootConstrainSelectedInstOperands,
     /*  181020 */     // GIR_Coverage, 706,
     /*  181020 */     GIR_Done,
     /*  181021 */   // Label 3492: @181021
     /*  181021 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(181062), // Rule ID 708 //
     /*  181026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181029 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181036 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181043 */     // MIs[0] rs1
     /*  181043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181055 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181060 */     GIR_RootConstrainSelectedInstOperands,
     /*  181061 */     // GIR_Coverage, 708,
     /*  181061 */     GIR_Done,
     /*  181062 */   // Label 3493: @181062
     /*  181062 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(181103), // Rule ID 710 //
     /*  181067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181084 */     // MIs[0] rs1
     /*  181084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181096 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181101 */     GIR_RootConstrainSelectedInstOperands,
     /*  181102 */     // GIR_Coverage, 710,
     /*  181102 */     GIR_Done,
     /*  181103 */   // Label 3494: @181103
     /*  181103 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(181144), // Rule ID 712 //
     /*  181108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181111 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181118 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181125 */     // MIs[0] rs1
     /*  181125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181137 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181142 */     GIR_RootConstrainSelectedInstOperands,
     /*  181143 */     // GIR_Coverage, 712,
     /*  181143 */     GIR_Done,
     /*  181144 */   // Label 3495: @181144
     /*  181144 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(181185), // Rule ID 714 //
     /*  181149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181152 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181159 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181166 */     // MIs[0] rs1
     /*  181166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181178 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181183 */     GIR_RootConstrainSelectedInstOperands,
     /*  181184 */     // GIR_Coverage, 714,
     /*  181184 */     GIR_Done,
     /*  181185 */   // Label 3496: @181185
     /*  181185 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(181226), // Rule ID 716 //
     /*  181190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181207 */     // MIs[0] rs1
     /*  181207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181219 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181224 */     GIR_RootConstrainSelectedInstOperands,
     /*  181225 */     // GIR_Coverage, 716,
     /*  181225 */     GIR_Done,
     /*  181226 */   // Label 3497: @181226
     /*  181226 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(181267), // Rule ID 878 //
     /*  181231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181234 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181241 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181248 */     // MIs[0] rs1
     /*  181248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181260 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181265 */     GIR_RootConstrainSelectedInstOperands,
     /*  181266 */     // GIR_Coverage, 878,
     /*  181266 */     GIR_Done,
     /*  181267 */   // Label 3498: @181267
     /*  181267 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(181308), // Rule ID 880 //
     /*  181272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181275 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181282 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181289 */     // MIs[0] rs1
     /*  181289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181301 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  181306 */     GIR_RootConstrainSelectedInstOperands,
     /*  181307 */     // GIR_Coverage, 880,
     /*  181307 */     GIR_Done,
     /*  181308 */   // Label 3499: @181308
     /*  181308 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(181349), // Rule ID 882 //
     /*  181313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181323 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181330 */     // MIs[0] rs1
     /*  181330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181342 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  181347 */     GIR_RootConstrainSelectedInstOperands,
     /*  181348 */     // GIR_Coverage, 882,
     /*  181348 */     GIR_Done,
     /*  181349 */   // Label 3500: @181349
     /*  181349 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(181390), // Rule ID 884 //
     /*  181354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181357 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181371 */     // MIs[0] rs1
     /*  181371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181383 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  181388 */     GIR_RootConstrainSelectedInstOperands,
     /*  181389 */     // GIR_Coverage, 884,
     /*  181389 */     GIR_Done,
     /*  181390 */   // Label 3501: @181390
     /*  181390 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(181431), // Rule ID 886 //
     /*  181395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  181398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181405 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181412 */     // MIs[0] rs1
     /*  181412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181424 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  181429 */     GIR_RootConstrainSelectedInstOperands,
     /*  181430 */     // GIR_Coverage, 886,
     /*  181430 */     GIR_Done,
     /*  181431 */   // Label 3502: @181431
     /*  181431 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(181472), // Rule ID 888 //
     /*  181436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181439 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181446 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181453 */     // MIs[0] rs1
     /*  181453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181465 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181470 */     GIR_RootConstrainSelectedInstOperands,
     /*  181471 */     // GIR_Coverage, 888,
     /*  181471 */     GIR_Done,
     /*  181472 */   // Label 3503: @181472
     /*  181472 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(181513), // Rule ID 890 //
     /*  181477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181480 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181487 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181494 */     // MIs[0] rs1
     /*  181494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181506 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181511 */     GIR_RootConstrainSelectedInstOperands,
     /*  181512 */     // GIR_Coverage, 890,
     /*  181512 */     GIR_Done,
     /*  181513 */   // Label 3504: @181513
     /*  181513 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(181554), // Rule ID 892 //
     /*  181518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181528 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181535 */     // MIs[0] rs1
     /*  181535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181547 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181552 */     GIR_RootConstrainSelectedInstOperands,
     /*  181553 */     // GIR_Coverage, 892,
     /*  181553 */     GIR_Done,
     /*  181554 */   // Label 3505: @181554
     /*  181554 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(181595), // Rule ID 894 //
     /*  181559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181562 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181569 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181576 */     // MIs[0] rs1
     /*  181576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181588 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181593 */     GIR_RootConstrainSelectedInstOperands,
     /*  181594 */     // GIR_Coverage, 894,
     /*  181594 */     GIR_Done,
     /*  181595 */   // Label 3506: @181595
     /*  181595 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(181636), // Rule ID 896 //
     /*  181600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181603 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181610 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181617 */     // MIs[0] rs1
     /*  181617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181629 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181634 */     GIR_RootConstrainSelectedInstOperands,
     /*  181635 */     // GIR_Coverage, 896,
     /*  181635 */     GIR_Done,
     /*  181636 */   // Label 3507: @181636
     /*  181636 */   GIM_Reject,
     /*  181637 */ // Label 3477: @181637
     /*  181637 */ GIM_Reject,
     /*  181638 */ // Label 3475: @181638
     /*  181638 */ GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(183287),
     /*  181643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  181646 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(181687), // Rule ID 349 //
     /*  181651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181668 */     // MIs[0] rs1
     /*  181668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181680 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181685 */     GIR_RootConstrainSelectedInstOperands,
     /*  181686 */     // GIR_Coverage, 349,
     /*  181686 */     GIR_Done,
     /*  181687 */   // Label 3509: @181687
     /*  181687 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(181728), // Rule ID 351 //
     /*  181692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181709 */     // MIs[0] rs1
     /*  181709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181721 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  181726 */     GIR_RootConstrainSelectedInstOperands,
     /*  181727 */     // GIR_Coverage, 351,
     /*  181727 */     GIR_Done,
     /*  181728 */   // Label 3510: @181728
     /*  181728 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(181769), // Rule ID 353 //
     /*  181733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181750 */     // MIs[0] rs1
     /*  181750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181762 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  181767 */     GIR_RootConstrainSelectedInstOperands,
     /*  181768 */     // GIR_Coverage, 353,
     /*  181768 */     GIR_Done,
     /*  181769 */   // Label 3511: @181769
     /*  181769 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(181810), // Rule ID 355 //
     /*  181774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181777 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181791 */     // MIs[0] rs1
     /*  181791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181803 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181803 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181808 */     GIR_RootConstrainSelectedInstOperands,
     /*  181809 */     // GIR_Coverage, 355,
     /*  181809 */     GIR_Done,
     /*  181810 */   // Label 3512: @181810
     /*  181810 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(181851), // Rule ID 357 //
     /*  181815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181818 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181832 */     // MIs[0] rs1
     /*  181832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181844 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181849 */     GIR_RootConstrainSelectedInstOperands,
     /*  181850 */     // GIR_Coverage, 357,
     /*  181850 */     GIR_Done,
     /*  181851 */   // Label 3513: @181851
     /*  181851 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(181892), // Rule ID 359 //
     /*  181856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181866 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181873 */     // MIs[0] rs1
     /*  181873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181885 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181890 */     GIR_RootConstrainSelectedInstOperands,
     /*  181891 */     // GIR_Coverage, 359,
     /*  181891 */     GIR_Done,
     /*  181892 */   // Label 3514: @181892
     /*  181892 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(181933), // Rule ID 361 //
     /*  181897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181914 */     // MIs[0] rs1
     /*  181914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181926 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181931 */     GIR_RootConstrainSelectedInstOperands,
     /*  181932 */     // GIR_Coverage, 361,
     /*  181932 */     GIR_Done,
     /*  181933 */   // Label 3515: @181933
     /*  181933 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(181974), // Rule ID 363 //
     /*  181938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181955 */     // MIs[0] rs1
     /*  181955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181967 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181972 */     GIR_RootConstrainSelectedInstOperands,
     /*  181973 */     // GIR_Coverage, 363,
     /*  181973 */     GIR_Done,
     /*  181974 */   // Label 3516: @181974
     /*  181974 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(182015), // Rule ID 365 //
     /*  181979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181996 */     // MIs[0] rs1
     /*  181996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182008 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182013 */     GIR_RootConstrainSelectedInstOperands,
     /*  182014 */     // GIR_Coverage, 365,
     /*  182014 */     GIR_Done,
     /*  182015 */   // Label 3517: @182015
     /*  182015 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(182056), // Rule ID 367 //
     /*  182020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  182023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182037 */     // MIs[0] rs1
     /*  182037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182049 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  182054 */     GIR_RootConstrainSelectedInstOperands,
     /*  182055 */     // GIR_Coverage, 367,
     /*  182055 */     GIR_Done,
     /*  182056 */   // Label 3518: @182056
     /*  182056 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(182097), // Rule ID 529 //
     /*  182061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182064 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182071 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182078 */     // MIs[0] rs1
     /*  182078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182090 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182095 */     GIR_RootConstrainSelectedInstOperands,
     /*  182096 */     // GIR_Coverage, 529,
     /*  182096 */     GIR_Done,
     /*  182097 */   // Label 3519: @182097
     /*  182097 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(182138), // Rule ID 530 //
     /*  182102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182105 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182112 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182119 */     // MIs[0] rs1
     /*  182119 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182131 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ),
     /*  182136 */     GIR_RootConstrainSelectedInstOperands,
     /*  182137 */     // GIR_Coverage, 530,
     /*  182137 */     GIR_Done,
     /*  182138 */   // Label 3520: @182138
     /*  182138 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(182179), // Rule ID 531 //
     /*  182143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182160 */     // MIs[0] rs1
     /*  182160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182172 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_RL),
     /*  182177 */     GIR_RootConstrainSelectedInstOperands,
     /*  182178 */     // GIR_Coverage, 531,
     /*  182178 */     GIR_Done,
     /*  182179 */   // Label 3521: @182179
     /*  182179 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(182220), // Rule ID 532 //
     /*  182184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182201 */     // MIs[0] rs1
     /*  182201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182213 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  182218 */     GIR_RootConstrainSelectedInstOperands,
     /*  182219 */     // GIR_Coverage, 532,
     /*  182219 */     GIR_Done,
     /*  182220 */   // Label 3522: @182220
     /*  182220 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(182261), // Rule ID 533 //
     /*  182225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  182228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182235 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182242 */     // MIs[0] rs1
     /*  182242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182254 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  182259 */     GIR_RootConstrainSelectedInstOperands,
     /*  182260 */     // GIR_Coverage, 533,
     /*  182260 */     GIR_Done,
     /*  182261 */   // Label 3523: @182261
     /*  182261 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(182302), // Rule ID 534 //
     /*  182266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182283 */     // MIs[0] rs1
     /*  182283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182295 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182300 */     GIR_RootConstrainSelectedInstOperands,
     /*  182301 */     // GIR_Coverage, 534,
     /*  182301 */     GIR_Done,
     /*  182302 */   // Label 3524: @182302
     /*  182302 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(182343), // Rule ID 535 //
     /*  182307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182324 */     // MIs[0] rs1
     /*  182324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182336 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182341 */     GIR_RootConstrainSelectedInstOperands,
     /*  182342 */     // GIR_Coverage, 535,
     /*  182342 */     GIR_Done,
     /*  182343 */   // Label 3525: @182343
     /*  182343 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(182384), // Rule ID 536 //
     /*  182348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182365 */     // MIs[0] rs1
     /*  182365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182377 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182382 */     GIR_RootConstrainSelectedInstOperands,
     /*  182383 */     // GIR_Coverage, 536,
     /*  182383 */     GIR_Done,
     /*  182384 */   // Label 3526: @182384
     /*  182384 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(182425), // Rule ID 537 //
     /*  182389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182406 */     // MIs[0] rs1
     /*  182406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182418 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182423 */     GIR_RootConstrainSelectedInstOperands,
     /*  182424 */     // GIR_Coverage, 537,
     /*  182424 */     GIR_Done,
     /*  182425 */   // Label 3527: @182425
     /*  182425 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(182466), // Rule ID 538 //
     /*  182430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  182433 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  182440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182447 */     // MIs[0] rs1
     /*  182447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182459 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  182464 */     GIR_RootConstrainSelectedInstOperands,
     /*  182465 */     // GIR_Coverage, 538,
     /*  182465 */     GIR_Done,
     /*  182466 */   // Label 3528: @182466
     /*  182466 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(182507), // Rule ID 697 //
     /*  182471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182488 */     // MIs[0] rs1
     /*  182488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182500 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182505 */     GIR_RootConstrainSelectedInstOperands,
     /*  182506 */     // GIR_Coverage, 697,
     /*  182506 */     GIR_Done,
     /*  182507 */   // Label 3529: @182507
     /*  182507 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(182548), // Rule ID 699 //
     /*  182512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182529 */     // MIs[0] rs1
     /*  182529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182541 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  182546 */     GIR_RootConstrainSelectedInstOperands,
     /*  182547 */     // GIR_Coverage, 699,
     /*  182547 */     GIR_Done,
     /*  182548 */   // Label 3530: @182548
     /*  182548 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(182589), // Rule ID 701 //
     /*  182553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182570 */     // MIs[0] rs1
     /*  182570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182582 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  182587 */     GIR_RootConstrainSelectedInstOperands,
     /*  182588 */     // GIR_Coverage, 701,
     /*  182588 */     GIR_Done,
     /*  182589 */   // Label 3531: @182589
     /*  182589 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(182630), // Rule ID 703 //
     /*  182594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182611 */     // MIs[0] rs1
     /*  182611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182623 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  182628 */     GIR_RootConstrainSelectedInstOperands,
     /*  182629 */     // GIR_Coverage, 703,
     /*  182629 */     GIR_Done,
     /*  182630 */   // Label 3532: @182630
     /*  182630 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(182671), // Rule ID 705 //
     /*  182635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182652 */     // MIs[0] rs1
     /*  182652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182664 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  182669 */     GIR_RootConstrainSelectedInstOperands,
     /*  182670 */     // GIR_Coverage, 705,
     /*  182670 */     GIR_Done,
     /*  182671 */   // Label 3533: @182671
     /*  182671 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(182712), // Rule ID 707 //
     /*  182676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182693 */     // MIs[0] rs1
     /*  182693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182705 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182710 */     GIR_RootConstrainSelectedInstOperands,
     /*  182711 */     // GIR_Coverage, 707,
     /*  182711 */     GIR_Done,
     /*  182712 */   // Label 3534: @182712
     /*  182712 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(182753), // Rule ID 709 //
     /*  182717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182734 */     // MIs[0] rs1
     /*  182734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182746 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182751 */     GIR_RootConstrainSelectedInstOperands,
     /*  182752 */     // GIR_Coverage, 709,
     /*  182752 */     GIR_Done,
     /*  182753 */   // Label 3535: @182753
     /*  182753 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(182794), // Rule ID 711 //
     /*  182758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182775 */     // MIs[0] rs1
     /*  182775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182787 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182792 */     GIR_RootConstrainSelectedInstOperands,
     /*  182793 */     // GIR_Coverage, 711,
     /*  182793 */     GIR_Done,
     /*  182794 */   // Label 3536: @182794
     /*  182794 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(182835), // Rule ID 713 //
     /*  182799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182816 */     // MIs[0] rs1
     /*  182816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182828 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182833 */     GIR_RootConstrainSelectedInstOperands,
     /*  182834 */     // GIR_Coverage, 713,
     /*  182834 */     GIR_Done,
     /*  182835 */   // Label 3537: @182835
     /*  182835 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(182876), // Rule ID 715 //
     /*  182840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182857 */     // MIs[0] rs1
     /*  182857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182869 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182874 */     GIR_RootConstrainSelectedInstOperands,
     /*  182875 */     // GIR_Coverage, 715,
     /*  182875 */     GIR_Done,
     /*  182876 */   // Label 3538: @182876
     /*  182876 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(182917), // Rule ID 877 //
     /*  182881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182898 */     // MIs[0] rs1
     /*  182898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182910 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182915 */     GIR_RootConstrainSelectedInstOperands,
     /*  182916 */     // GIR_Coverage, 877,
     /*  182916 */     GIR_Done,
     /*  182917 */   // Label 3539: @182917
     /*  182917 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(182958), // Rule ID 879 //
     /*  182922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182939 */     // MIs[0] rs1
     /*  182939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182951 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  182956 */     GIR_RootConstrainSelectedInstOperands,
     /*  182957 */     // GIR_Coverage, 879,
     /*  182957 */     GIR_Done,
     /*  182958 */   // Label 3540: @182958
     /*  182958 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(182999), // Rule ID 881 //
     /*  182963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182980 */     // MIs[0] rs1
     /*  182980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182992 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  182997 */     GIR_RootConstrainSelectedInstOperands,
     /*  182998 */     // GIR_Coverage, 881,
     /*  182998 */     GIR_Done,
     /*  182999 */   // Label 3541: @182999
     /*  182999 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(183040), // Rule ID 883 //
     /*  183004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183021 */     // MIs[0] rs1
     /*  183021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183033 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  183038 */     GIR_RootConstrainSelectedInstOperands,
     /*  183039 */     // GIR_Coverage, 883,
     /*  183039 */     GIR_Done,
     /*  183040 */   // Label 3542: @183040
     /*  183040 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(183081), // Rule ID 885 //
     /*  183045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  183048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183062 */     // MIs[0] rs1
     /*  183062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183074 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  183079 */     GIR_RootConstrainSelectedInstOperands,
     /*  183080 */     // GIR_Coverage, 885,
     /*  183080 */     GIR_Done,
     /*  183081 */   // Label 3543: @183081
     /*  183081 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(183122), // Rule ID 887 //
     /*  183086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183103 */     // MIs[0] rs1
     /*  183103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183115 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183120 */     GIR_RootConstrainSelectedInstOperands,
     /*  183121 */     // GIR_Coverage, 887,
     /*  183121 */     GIR_Done,
     /*  183122 */   // Label 3544: @183122
     /*  183122 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(183163), // Rule ID 889 //
     /*  183127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183144 */     // MIs[0] rs1
     /*  183144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183156 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183161 */     GIR_RootConstrainSelectedInstOperands,
     /*  183162 */     // GIR_Coverage, 889,
     /*  183162 */     GIR_Done,
     /*  183163 */   // Label 3545: @183163
     /*  183163 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(183204), // Rule ID 891 //
     /*  183168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183185 */     // MIs[0] rs1
     /*  183185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183197 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183202 */     GIR_RootConstrainSelectedInstOperands,
     /*  183203 */     // GIR_Coverage, 891,
     /*  183203 */     GIR_Done,
     /*  183204 */   // Label 3546: @183204
     /*  183204 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(183245), // Rule ID 893 //
     /*  183209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183212 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183219 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183226 */     // MIs[0] rs1
     /*  183226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183238 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183243 */     GIR_RootConstrainSelectedInstOperands,
     /*  183244 */     // GIR_Coverage, 893,
     /*  183244 */     GIR_Done,
     /*  183245 */   // Label 3547: @183245
     /*  183245 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(183286), // Rule ID 895 //
     /*  183250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  183253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183267 */     // MIs[0] rs1
     /*  183267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  183271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183279 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  183279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  183284 */     GIR_RootConstrainSelectedInstOperands,
     /*  183285 */     // GIR_Coverage, 895,
     /*  183285 */     GIR_Done,
     /*  183286 */   // Label 3548: @183286
     /*  183286 */   GIM_Reject,
     /*  183287 */ // Label 3508: @183287
     /*  183287 */ GIM_Reject,
     /*  183288 */ // Label 3476: @183288
     /*  183288 */ GIM_Reject,
     /*  183289 */ // Label 27: @183289
     /*  183289 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3551*/ GIMT_Encode4(186198),
     /*  183300 */ /*GILLT_s32*//*Label 3549*/ GIMT_Encode4(183308),
     /*  183304 */ /*GILLT_s64*//*Label 3550*/ GIMT_Encode4(184548),
     /*  183308 */ // Label 3549: @183308
     /*  183308 */ GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(184547),
     /*  183313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  183316 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(183357), // Rule ID 370 //
     /*  183321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183324 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183331 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183338 */     // MIs[0] rs1
     /*  183338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183350 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183355 */     GIR_RootConstrainSelectedInstOperands,
     /*  183356 */     // GIR_Coverage, 370,
     /*  183356 */     GIR_Done,
     /*  183357 */   // Label 3553: @183357
     /*  183357 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(183398), // Rule ID 372 //
     /*  183362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183379 */     // MIs[0] rs1
     /*  183379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183391 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  183396 */     GIR_RootConstrainSelectedInstOperands,
     /*  183397 */     // GIR_Coverage, 372,
     /*  183397 */     GIR_Done,
     /*  183398 */   // Label 3554: @183398
     /*  183398 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(183439), // Rule ID 374 //
     /*  183403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183413 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183420 */     // MIs[0] rs1
     /*  183420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183432 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  183437 */     GIR_RootConstrainSelectedInstOperands,
     /*  183438 */     // GIR_Coverage, 374,
     /*  183438 */     GIR_Done,
     /*  183439 */   // Label 3555: @183439
     /*  183439 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(183480), // Rule ID 376 //
     /*  183444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183461 */     // MIs[0] rs1
     /*  183461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183473 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  183478 */     GIR_RootConstrainSelectedInstOperands,
     /*  183479 */     // GIR_Coverage, 376,
     /*  183479 */     GIR_Done,
     /*  183480 */   // Label 3556: @183480
     /*  183480 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(183521), // Rule ID 378 //
     /*  183485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  183488 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183495 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183502 */     // MIs[0] rs1
     /*  183502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183514 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183514 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  183519 */     GIR_RootConstrainSelectedInstOperands,
     /*  183520 */     // GIR_Coverage, 378,
     /*  183520 */     GIR_Done,
     /*  183521 */   // Label 3557: @183521
     /*  183521 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(183562), // Rule ID 380 //
     /*  183526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183529 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183536 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183543 */     // MIs[0] rs1
     /*  183543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183555 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183560 */     GIR_RootConstrainSelectedInstOperands,
     /*  183561 */     // GIR_Coverage, 380,
     /*  183561 */     GIR_Done,
     /*  183562 */   // Label 3558: @183562
     /*  183562 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(183603), // Rule ID 382 //
     /*  183567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183584 */     // MIs[0] rs1
     /*  183584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183596 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183601 */     GIR_RootConstrainSelectedInstOperands,
     /*  183602 */     // GIR_Coverage, 382,
     /*  183602 */     GIR_Done,
     /*  183603 */   // Label 3559: @183603
     /*  183603 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(183644), // Rule ID 384 //
     /*  183608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183611 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183618 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183625 */     // MIs[0] rs1
     /*  183625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183637 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183642 */     GIR_RootConstrainSelectedInstOperands,
     /*  183643 */     // GIR_Coverage, 384,
     /*  183643 */     GIR_Done,
     /*  183644 */   // Label 3560: @183644
     /*  183644 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(183685), // Rule ID 386 //
     /*  183649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183652 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183666 */     // MIs[0] rs1
     /*  183666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183678 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183683 */     GIR_RootConstrainSelectedInstOperands,
     /*  183684 */     // GIR_Coverage, 386,
     /*  183684 */     GIR_Done,
     /*  183685 */   // Label 3561: @183685
     /*  183685 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(183726), // Rule ID 388 //
     /*  183690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183693 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183700 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183707 */     // MIs[0] rs1
     /*  183707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183719 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183724 */     GIR_RootConstrainSelectedInstOperands,
     /*  183725 */     // GIR_Coverage, 388,
     /*  183725 */     GIR_Done,
     /*  183726 */   // Label 3562: @183726
     /*  183726 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(183767), // Rule ID 718 //
     /*  183731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183734 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183741 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183748 */     // MIs[0] rs1
     /*  183748 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183760 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183760 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183765 */     GIR_RootConstrainSelectedInstOperands,
     /*  183766 */     // GIR_Coverage, 718,
     /*  183766 */     GIR_Done,
     /*  183767 */   // Label 3563: @183767
     /*  183767 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(183808), // Rule ID 720 //
     /*  183772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183775 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183782 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183789 */     // MIs[0] rs1
     /*  183789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183801 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  183806 */     GIR_RootConstrainSelectedInstOperands,
     /*  183807 */     // GIR_Coverage, 720,
     /*  183807 */     GIR_Done,
     /*  183808 */   // Label 3564: @183808
     /*  183808 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(183849), // Rule ID 722 //
     /*  183813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183816 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183823 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183830 */     // MIs[0] rs1
     /*  183830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183842 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  183847 */     GIR_RootConstrainSelectedInstOperands,
     /*  183848 */     // GIR_Coverage, 722,
     /*  183848 */     GIR_Done,
     /*  183849 */   // Label 3565: @183849
     /*  183849 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(183890), // Rule ID 724 //
     /*  183854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183864 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183871 */     // MIs[0] rs1
     /*  183871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183883 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  183888 */     GIR_RootConstrainSelectedInstOperands,
     /*  183889 */     // GIR_Coverage, 724,
     /*  183889 */     GIR_Done,
     /*  183890 */   // Label 3566: @183890
     /*  183890 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(183931), // Rule ID 726 //
     /*  183895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183912 */     // MIs[0] rs1
     /*  183912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183924 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  183929 */     GIR_RootConstrainSelectedInstOperands,
     /*  183930 */     // GIR_Coverage, 726,
     /*  183930 */     GIR_Done,
     /*  183931 */   // Label 3567: @183931
     /*  183931 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183972), // Rule ID 728 //
     /*  183936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183953 */     // MIs[0] rs1
     /*  183953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183965 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183970 */     GIR_RootConstrainSelectedInstOperands,
     /*  183971 */     // GIR_Coverage, 728,
     /*  183971 */     GIR_Done,
     /*  183972 */   // Label 3568: @183972
     /*  183972 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(184013), // Rule ID 730 //
     /*  183977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183994 */     // MIs[0] rs1
     /*  183994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184006 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184011 */     GIR_RootConstrainSelectedInstOperands,
     /*  184012 */     // GIR_Coverage, 730,
     /*  184012 */     GIR_Done,
     /*  184013 */   // Label 3569: @184013
     /*  184013 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(184054), // Rule ID 732 //
     /*  184018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184021 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184028 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184035 */     // MIs[0] rs1
     /*  184035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184047 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184052 */     GIR_RootConstrainSelectedInstOperands,
     /*  184053 */     // GIR_Coverage, 732,
     /*  184053 */     GIR_Done,
     /*  184054 */   // Label 3570: @184054
     /*  184054 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(184095), // Rule ID 734 //
     /*  184059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184062 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184076 */     // MIs[0] rs1
     /*  184076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184088 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184093 */     GIR_RootConstrainSelectedInstOperands,
     /*  184094 */     // GIR_Coverage, 734,
     /*  184094 */     GIR_Done,
     /*  184095 */   // Label 3571: @184095
     /*  184095 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(184136), // Rule ID 736 //
     /*  184100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184110 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184117 */     // MIs[0] rs1
     /*  184117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184129 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184134 */     GIR_RootConstrainSelectedInstOperands,
     /*  184135 */     // GIR_Coverage, 736,
     /*  184135 */     GIR_Done,
     /*  184136 */   // Label 3572: @184136
     /*  184136 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(184177), // Rule ID 898 //
     /*  184141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184158 */     // MIs[0] rs1
     /*  184158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184170 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184175 */     GIR_RootConstrainSelectedInstOperands,
     /*  184176 */     // GIR_Coverage, 898,
     /*  184176 */     GIR_Done,
     /*  184177 */   // Label 3573: @184177
     /*  184177 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(184218), // Rule ID 900 //
     /*  184182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184185 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184192 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184199 */     // MIs[0] rs1
     /*  184199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184211 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  184216 */     GIR_RootConstrainSelectedInstOperands,
     /*  184217 */     // GIR_Coverage, 900,
     /*  184217 */     GIR_Done,
     /*  184218 */   // Label 3574: @184218
     /*  184218 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(184259), // Rule ID 902 //
     /*  184223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184233 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184240 */     // MIs[0] rs1
     /*  184240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184252 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  184257 */     GIR_RootConstrainSelectedInstOperands,
     /*  184258 */     // GIR_Coverage, 902,
     /*  184258 */     GIR_Done,
     /*  184259 */   // Label 3575: @184259
     /*  184259 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(184300), // Rule ID 904 //
     /*  184264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184267 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184274 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184281 */     // MIs[0] rs1
     /*  184281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184293 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  184298 */     GIR_RootConstrainSelectedInstOperands,
     /*  184299 */     // GIR_Coverage, 904,
     /*  184299 */     GIR_Done,
     /*  184300 */   // Label 3576: @184300
     /*  184300 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(184341), // Rule ID 906 //
     /*  184305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  184308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184322 */     // MIs[0] rs1
     /*  184322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184334 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  184339 */     GIR_RootConstrainSelectedInstOperands,
     /*  184340 */     // GIR_Coverage, 906,
     /*  184340 */     GIR_Done,
     /*  184341 */   // Label 3577: @184341
     /*  184341 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(184382), // Rule ID 908 //
     /*  184346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184349 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184363 */     // MIs[0] rs1
     /*  184363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184375 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184380 */     GIR_RootConstrainSelectedInstOperands,
     /*  184381 */     // GIR_Coverage, 908,
     /*  184381 */     GIR_Done,
     /*  184382 */   // Label 3578: @184382
     /*  184382 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(184423), // Rule ID 910 //
     /*  184387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184404 */     // MIs[0] rs1
     /*  184404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184416 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184421 */     GIR_RootConstrainSelectedInstOperands,
     /*  184422 */     // GIR_Coverage, 910,
     /*  184422 */     GIR_Done,
     /*  184423 */   // Label 3579: @184423
     /*  184423 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(184464), // Rule ID 912 //
     /*  184428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184431 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184438 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184445 */     // MIs[0] rs1
     /*  184445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184457 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184462 */     GIR_RootConstrainSelectedInstOperands,
     /*  184463 */     // GIR_Coverage, 912,
     /*  184463 */     GIR_Done,
     /*  184464 */   // Label 3580: @184464
     /*  184464 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(184505), // Rule ID 914 //
     /*  184469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184486 */     // MIs[0] rs1
     /*  184486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184498 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184503 */     GIR_RootConstrainSelectedInstOperands,
     /*  184504 */     // GIR_Coverage, 914,
     /*  184504 */     GIR_Done,
     /*  184505 */   // Label 3581: @184505
     /*  184505 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(184546), // Rule ID 916 //
     /*  184510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184520 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184527 */     // MIs[0] rs1
     /*  184527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184539 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184544 */     GIR_RootConstrainSelectedInstOperands,
     /*  184545 */     // GIR_Coverage, 916,
     /*  184545 */     GIR_Done,
     /*  184546 */   // Label 3582: @184546
     /*  184546 */   GIM_Reject,
     /*  184547 */ // Label 3552: @184547
     /*  184547 */ GIM_Reject,
     /*  184548 */ // Label 3550: @184548
     /*  184548 */ GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(186197),
     /*  184553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  184556 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(184597), // Rule ID 369 //
     /*  184561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184578 */     // MIs[0] rs1
     /*  184578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184590 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184595 */     GIR_RootConstrainSelectedInstOperands,
     /*  184596 */     // GIR_Coverage, 369,
     /*  184596 */     GIR_Done,
     /*  184597 */   // Label 3584: @184597
     /*  184597 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(184638), // Rule ID 371 //
     /*  184602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184619 */     // MIs[0] rs1
     /*  184619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184631 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  184636 */     GIR_RootConstrainSelectedInstOperands,
     /*  184637 */     // GIR_Coverage, 371,
     /*  184637 */     GIR_Done,
     /*  184638 */   // Label 3585: @184638
     /*  184638 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(184679), // Rule ID 373 //
     /*  184643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184660 */     // MIs[0] rs1
     /*  184660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184672 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184672 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  184677 */     GIR_RootConstrainSelectedInstOperands,
     /*  184678 */     // GIR_Coverage, 373,
     /*  184678 */     GIR_Done,
     /*  184679 */   // Label 3586: @184679
     /*  184679 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(184720), // Rule ID 375 //
     /*  184684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184701 */     // MIs[0] rs1
     /*  184701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184713 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  184718 */     GIR_RootConstrainSelectedInstOperands,
     /*  184719 */     // GIR_Coverage, 375,
     /*  184719 */     GIR_Done,
     /*  184720 */   // Label 3587: @184720
     /*  184720 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(184761), // Rule ID 377 //
     /*  184725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184742 */     // MIs[0] rs1
     /*  184742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184754 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  184759 */     GIR_RootConstrainSelectedInstOperands,
     /*  184760 */     // GIR_Coverage, 377,
     /*  184760 */     GIR_Done,
     /*  184761 */   // Label 3588: @184761
     /*  184761 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(184802), // Rule ID 379 //
     /*  184766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184769 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184783 */     // MIs[0] rs1
     /*  184783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184795 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184800 */     GIR_RootConstrainSelectedInstOperands,
     /*  184801 */     // GIR_Coverage, 379,
     /*  184801 */     GIR_Done,
     /*  184802 */   // Label 3589: @184802
     /*  184802 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184843), // Rule ID 381 //
     /*  184807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184810 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184817 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184824 */     // MIs[0] rs1
     /*  184824 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184836 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184841 */     GIR_RootConstrainSelectedInstOperands,
     /*  184842 */     // GIR_Coverage, 381,
     /*  184842 */     GIR_Done,
     /*  184843 */   // Label 3590: @184843
     /*  184843 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184884), // Rule ID 383 //
     /*  184848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184851 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184865 */     // MIs[0] rs1
     /*  184865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184877 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184882 */     GIR_RootConstrainSelectedInstOperands,
     /*  184883 */     // GIR_Coverage, 383,
     /*  184883 */     GIR_Done,
     /*  184884 */   // Label 3591: @184884
     /*  184884 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184925), // Rule ID 385 //
     /*  184889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184906 */     // MIs[0] rs1
     /*  184906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184918 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184923 */     GIR_RootConstrainSelectedInstOperands,
     /*  184924 */     // GIR_Coverage, 385,
     /*  184924 */     GIR_Done,
     /*  184925 */   // Label 3592: @184925
     /*  184925 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184966), // Rule ID 387 //
     /*  184930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184947 */     // MIs[0] rs1
     /*  184947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184959 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184959 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184964 */     GIR_RootConstrainSelectedInstOperands,
     /*  184965 */     // GIR_Coverage, 387,
     /*  184965 */     GIR_Done,
     /*  184966 */   // Label 3593: @184966
     /*  184966 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(185007), // Rule ID 539 //
     /*  184971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  184974 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184981 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184988 */     // MIs[0] rs1
     /*  184988 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185000 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185005 */     GIR_RootConstrainSelectedInstOperands,
     /*  185006 */     // GIR_Coverage, 539,
     /*  185006 */     GIR_Done,
     /*  185007 */   // Label 3594: @185007
     /*  185007 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(185048), // Rule ID 540 //
     /*  185012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185015 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185022 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185029 */     // MIs[0] rs1
     /*  185029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185041 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ),
     /*  185046 */     GIR_RootConstrainSelectedInstOperands,
     /*  185047 */     // GIR_Coverage, 540,
     /*  185047 */     GIR_Done,
     /*  185048 */   // Label 3595: @185048
     /*  185048 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(185089), // Rule ID 541 //
     /*  185053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185070 */     // MIs[0] rs1
     /*  185070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185082 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_RL),
     /*  185087 */     GIR_RootConstrainSelectedInstOperands,
     /*  185088 */     // GIR_Coverage, 541,
     /*  185088 */     GIR_Done,
     /*  185089 */   // Label 3596: @185089
     /*  185089 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(185130), // Rule ID 542 //
     /*  185094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185111 */     // MIs[0] rs1
     /*  185111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185123 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  185128 */     GIR_RootConstrainSelectedInstOperands,
     /*  185129 */     // GIR_Coverage, 542,
     /*  185129 */     GIR_Done,
     /*  185130 */   // Label 3597: @185130
     /*  185130 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(185171), // Rule ID 543 //
     /*  185135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  185138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185152 */     // MIs[0] rs1
     /*  185152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185164 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  185169 */     GIR_RootConstrainSelectedInstOperands,
     /*  185170 */     // GIR_Coverage, 543,
     /*  185170 */     GIR_Done,
     /*  185171 */   // Label 3598: @185171
     /*  185171 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(185212), // Rule ID 544 //
     /*  185176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185179 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185193 */     // MIs[0] rs1
     /*  185193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185205 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185210 */     GIR_RootConstrainSelectedInstOperands,
     /*  185211 */     // GIR_Coverage, 544,
     /*  185211 */     GIR_Done,
     /*  185212 */   // Label 3599: @185212
     /*  185212 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(185253), // Rule ID 545 //
     /*  185217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185234 */     // MIs[0] rs1
     /*  185234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185246 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185251 */     GIR_RootConstrainSelectedInstOperands,
     /*  185252 */     // GIR_Coverage, 545,
     /*  185252 */     GIR_Done,
     /*  185253 */   // Label 3600: @185253
     /*  185253 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(185294), // Rule ID 546 //
     /*  185258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185275 */     // MIs[0] rs1
     /*  185275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185287 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185292 */     GIR_RootConstrainSelectedInstOperands,
     /*  185293 */     // GIR_Coverage, 546,
     /*  185293 */     GIR_Done,
     /*  185294 */   // Label 3601: @185294
     /*  185294 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(185335), // Rule ID 547 //
     /*  185299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185316 */     // MIs[0] rs1
     /*  185316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185328 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185333 */     GIR_RootConstrainSelectedInstOperands,
     /*  185334 */     // GIR_Coverage, 547,
     /*  185334 */     GIR_Done,
     /*  185335 */   // Label 3602: @185335
     /*  185335 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(185376), // Rule ID 548 //
     /*  185340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  185343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  185350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185357 */     // MIs[0] rs1
     /*  185357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185369 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  185374 */     GIR_RootConstrainSelectedInstOperands,
     /*  185375 */     // GIR_Coverage, 548,
     /*  185375 */     GIR_Done,
     /*  185376 */   // Label 3603: @185376
     /*  185376 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(185417), // Rule ID 717 //
     /*  185381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185398 */     // MIs[0] rs1
     /*  185398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185410 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185415 */     GIR_RootConstrainSelectedInstOperands,
     /*  185416 */     // GIR_Coverage, 717,
     /*  185416 */     GIR_Done,
     /*  185417 */   // Label 3604: @185417
     /*  185417 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(185458), // Rule ID 719 //
     /*  185422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185439 */     // MIs[0] rs1
     /*  185439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185451 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  185456 */     GIR_RootConstrainSelectedInstOperands,
     /*  185457 */     // GIR_Coverage, 719,
     /*  185457 */     GIR_Done,
     /*  185458 */   // Label 3605: @185458
     /*  185458 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(185499), // Rule ID 721 //
     /*  185463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185480 */     // MIs[0] rs1
     /*  185480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185492 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  185497 */     GIR_RootConstrainSelectedInstOperands,
     /*  185498 */     // GIR_Coverage, 721,
     /*  185498 */     GIR_Done,
     /*  185499 */   // Label 3606: @185499
     /*  185499 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(185540), // Rule ID 723 //
     /*  185504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185521 */     // MIs[0] rs1
     /*  185521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185533 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  185538 */     GIR_RootConstrainSelectedInstOperands,
     /*  185539 */     // GIR_Coverage, 723,
     /*  185539 */     GIR_Done,
     /*  185540 */   // Label 3607: @185540
     /*  185540 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(185581), // Rule ID 725 //
     /*  185545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185562 */     // MIs[0] rs1
     /*  185562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185574 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  185579 */     GIR_RootConstrainSelectedInstOperands,
     /*  185580 */     // GIR_Coverage, 725,
     /*  185580 */     GIR_Done,
     /*  185581 */   // Label 3608: @185581
     /*  185581 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(185622), // Rule ID 727 //
     /*  185586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185603 */     // MIs[0] rs1
     /*  185603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185615 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185620 */     GIR_RootConstrainSelectedInstOperands,
     /*  185621 */     // GIR_Coverage, 727,
     /*  185621 */     GIR_Done,
     /*  185622 */   // Label 3609: @185622
     /*  185622 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(185663), // Rule ID 729 //
     /*  185627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185644 */     // MIs[0] rs1
     /*  185644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185656 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185661 */     GIR_RootConstrainSelectedInstOperands,
     /*  185662 */     // GIR_Coverage, 729,
     /*  185662 */     GIR_Done,
     /*  185663 */   // Label 3610: @185663
     /*  185663 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(185704), // Rule ID 731 //
     /*  185668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185685 */     // MIs[0] rs1
     /*  185685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185697 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185702 */     GIR_RootConstrainSelectedInstOperands,
     /*  185703 */     // GIR_Coverage, 731,
     /*  185703 */     GIR_Done,
     /*  185704 */   // Label 3611: @185704
     /*  185704 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185745), // Rule ID 733 //
     /*  185709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185726 */     // MIs[0] rs1
     /*  185726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185738 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185743 */     GIR_RootConstrainSelectedInstOperands,
     /*  185744 */     // GIR_Coverage, 733,
     /*  185744 */     GIR_Done,
     /*  185745 */   // Label 3612: @185745
     /*  185745 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(185786), // Rule ID 735 //
     /*  185750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185767 */     // MIs[0] rs1
     /*  185767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185779 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185784 */     GIR_RootConstrainSelectedInstOperands,
     /*  185785 */     // GIR_Coverage, 735,
     /*  185785 */     GIR_Done,
     /*  185786 */   // Label 3613: @185786
     /*  185786 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(185827), // Rule ID 897 //
     /*  185791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185808 */     // MIs[0] rs1
     /*  185808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185820 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185825 */     GIR_RootConstrainSelectedInstOperands,
     /*  185826 */     // GIR_Coverage, 897,
     /*  185826 */     GIR_Done,
     /*  185827 */   // Label 3614: @185827
     /*  185827 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(185868), // Rule ID 899 //
     /*  185832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185849 */     // MIs[0] rs1
     /*  185849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185861 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  185866 */     GIR_RootConstrainSelectedInstOperands,
     /*  185867 */     // GIR_Coverage, 899,
     /*  185867 */     GIR_Done,
     /*  185868 */   // Label 3615: @185868
     /*  185868 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(185909), // Rule ID 901 //
     /*  185873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185890 */     // MIs[0] rs1
     /*  185890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185902 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  185907 */     GIR_RootConstrainSelectedInstOperands,
     /*  185908 */     // GIR_Coverage, 901,
     /*  185908 */     GIR_Done,
     /*  185909 */   // Label 3616: @185909
     /*  185909 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185950), // Rule ID 903 //
     /*  185914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185931 */     // MIs[0] rs1
     /*  185931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185943 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  185948 */     GIR_RootConstrainSelectedInstOperands,
     /*  185949 */     // GIR_Coverage, 903,
     /*  185949 */     GIR_Done,
     /*  185950 */   // Label 3617: @185950
     /*  185950 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(185991), // Rule ID 905 //
     /*  185955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185972 */     // MIs[0] rs1
     /*  185972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185984 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  185989 */     GIR_RootConstrainSelectedInstOperands,
     /*  185990 */     // GIR_Coverage, 905,
     /*  185990 */     GIR_Done,
     /*  185991 */   // Label 3618: @185991
     /*  185991 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(186032), // Rule ID 907 //
     /*  185996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186013 */     // MIs[0] rs1
     /*  186013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186025 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186030 */     GIR_RootConstrainSelectedInstOperands,
     /*  186031 */     // GIR_Coverage, 907,
     /*  186031 */     GIR_Done,
     /*  186032 */   // Label 3619: @186032
     /*  186032 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(186073), // Rule ID 909 //
     /*  186037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186054 */     // MIs[0] rs1
     /*  186054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186066 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186071 */     GIR_RootConstrainSelectedInstOperands,
     /*  186072 */     // GIR_Coverage, 909,
     /*  186072 */     GIR_Done,
     /*  186073 */   // Label 3620: @186073
     /*  186073 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(186114), // Rule ID 911 //
     /*  186078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186095 */     // MIs[0] rs1
     /*  186095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186107 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186112 */     GIR_RootConstrainSelectedInstOperands,
     /*  186113 */     // GIR_Coverage, 911,
     /*  186113 */     GIR_Done,
     /*  186114 */   // Label 3621: @186114
     /*  186114 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(186155), // Rule ID 913 //
     /*  186119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186136 */     // MIs[0] rs1
     /*  186136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186148 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186153 */     GIR_RootConstrainSelectedInstOperands,
     /*  186154 */     // GIR_Coverage, 913,
     /*  186154 */     GIR_Done,
     /*  186155 */   // Label 3622: @186155
     /*  186155 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(186196), // Rule ID 915 //
     /*  186160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  186163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186177 */     // MIs[0] rs1
     /*  186177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186189 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  186194 */     GIR_RootConstrainSelectedInstOperands,
     /*  186195 */     // GIR_Coverage, 915,
     /*  186195 */     GIR_Done,
     /*  186196 */   // Label 3623: @186196
     /*  186196 */   GIM_Reject,
     /*  186197 */ // Label 3583: @186197
     /*  186197 */ GIM_Reject,
     /*  186198 */ // Label 3551: @186198
     /*  186198 */ GIM_Reject,
     /*  186199 */ // Label 28: @186199
     /*  186199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3626*/ GIMT_Encode4(189108),
     /*  186210 */ /*GILLT_s32*//*Label 3624*/ GIMT_Encode4(186218),
     /*  186214 */ /*GILLT_s64*//*Label 3625*/ GIMT_Encode4(187458),
     /*  186218 */ // Label 3624: @186218
     /*  186218 */ GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(187457),
     /*  186223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  186226 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(186267), // Rule ID 390 //
     /*  186231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186234 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186241 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186248 */     // MIs[0] rs1
     /*  186248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186260 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186265 */     GIR_RootConstrainSelectedInstOperands,
     /*  186266 */     // GIR_Coverage, 390,
     /*  186266 */     GIR_Done,
     /*  186267 */   // Label 3628: @186267
     /*  186267 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(186308), // Rule ID 392 //
     /*  186272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186275 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186282 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186289 */     // MIs[0] rs1
     /*  186289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186301 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  186306 */     GIR_RootConstrainSelectedInstOperands,
     /*  186307 */     // GIR_Coverage, 392,
     /*  186307 */     GIR_Done,
     /*  186308 */   // Label 3629: @186308
     /*  186308 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(186349), // Rule ID 394 //
     /*  186313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186323 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186330 */     // MIs[0] rs1
     /*  186330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186342 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  186347 */     GIR_RootConstrainSelectedInstOperands,
     /*  186348 */     // GIR_Coverage, 394,
     /*  186348 */     GIR_Done,
     /*  186349 */   // Label 3630: @186349
     /*  186349 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(186390), // Rule ID 396 //
     /*  186354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186357 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186371 */     // MIs[0] rs1
     /*  186371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186383 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  186388 */     GIR_RootConstrainSelectedInstOperands,
     /*  186389 */     // GIR_Coverage, 396,
     /*  186389 */     GIR_Done,
     /*  186390 */   // Label 3631: @186390
     /*  186390 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(186431), // Rule ID 398 //
     /*  186395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  186398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186405 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186412 */     // MIs[0] rs1
     /*  186412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186424 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  186429 */     GIR_RootConstrainSelectedInstOperands,
     /*  186430 */     // GIR_Coverage, 398,
     /*  186430 */     GIR_Done,
     /*  186431 */   // Label 3632: @186431
     /*  186431 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(186472), // Rule ID 400 //
     /*  186436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186439 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186446 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186453 */     // MIs[0] rs1
     /*  186453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186465 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186470 */     GIR_RootConstrainSelectedInstOperands,
     /*  186471 */     // GIR_Coverage, 400,
     /*  186471 */     GIR_Done,
     /*  186472 */   // Label 3633: @186472
     /*  186472 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(186513), // Rule ID 402 //
     /*  186477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186480 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186487 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186494 */     // MIs[0] rs1
     /*  186494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186506 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186511 */     GIR_RootConstrainSelectedInstOperands,
     /*  186512 */     // GIR_Coverage, 402,
     /*  186512 */     GIR_Done,
     /*  186513 */   // Label 3634: @186513
     /*  186513 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(186554), // Rule ID 404 //
     /*  186518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186528 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186535 */     // MIs[0] rs1
     /*  186535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186547 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186552 */     GIR_RootConstrainSelectedInstOperands,
     /*  186553 */     // GIR_Coverage, 404,
     /*  186553 */     GIR_Done,
     /*  186554 */   // Label 3635: @186554
     /*  186554 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(186595), // Rule ID 406 //
     /*  186559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186562 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186569 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186576 */     // MIs[0] rs1
     /*  186576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186588 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186593 */     GIR_RootConstrainSelectedInstOperands,
     /*  186594 */     // GIR_Coverage, 406,
     /*  186594 */     GIR_Done,
     /*  186595 */   // Label 3636: @186595
     /*  186595 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(186636), // Rule ID 408 //
     /*  186600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186603 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186610 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186617 */     // MIs[0] rs1
     /*  186617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186629 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186634 */     GIR_RootConstrainSelectedInstOperands,
     /*  186635 */     // GIR_Coverage, 408,
     /*  186635 */     GIR_Done,
     /*  186636 */   // Label 3637: @186636
     /*  186636 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(186677), // Rule ID 738 //
     /*  186641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186644 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186651 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186658 */     // MIs[0] rs1
     /*  186658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186670 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186675 */     GIR_RootConstrainSelectedInstOperands,
     /*  186676 */     // GIR_Coverage, 738,
     /*  186676 */     GIR_Done,
     /*  186677 */   // Label 3638: @186677
     /*  186677 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186718), // Rule ID 740 //
     /*  186682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186685 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186699 */     // MIs[0] rs1
     /*  186699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186711 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  186716 */     GIR_RootConstrainSelectedInstOperands,
     /*  186717 */     // GIR_Coverage, 740,
     /*  186717 */     GIR_Done,
     /*  186718 */   // Label 3639: @186718
     /*  186718 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186759), // Rule ID 742 //
     /*  186723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186726 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186733 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186740 */     // MIs[0] rs1
     /*  186740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186752 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  186757 */     GIR_RootConstrainSelectedInstOperands,
     /*  186758 */     // GIR_Coverage, 742,
     /*  186758 */     GIR_Done,
     /*  186759 */   // Label 3640: @186759
     /*  186759 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(186800), // Rule ID 744 //
     /*  186764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186767 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186781 */     // MIs[0] rs1
     /*  186781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186793 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  186798 */     GIR_RootConstrainSelectedInstOperands,
     /*  186799 */     // GIR_Coverage, 744,
     /*  186799 */     GIR_Done,
     /*  186800 */   // Label 3641: @186800
     /*  186800 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(186841), // Rule ID 746 //
     /*  186805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186808 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186815 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186822 */     // MIs[0] rs1
     /*  186822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186834 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  186839 */     GIR_RootConstrainSelectedInstOperands,
     /*  186840 */     // GIR_Coverage, 746,
     /*  186840 */     GIR_Done,
     /*  186841 */   // Label 3642: @186841
     /*  186841 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(186882), // Rule ID 748 //
     /*  186846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186849 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186856 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186863 */     // MIs[0] rs1
     /*  186863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186875 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186880 */     GIR_RootConstrainSelectedInstOperands,
     /*  186881 */     // GIR_Coverage, 748,
     /*  186881 */     GIR_Done,
     /*  186882 */   // Label 3643: @186882
     /*  186882 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186923), // Rule ID 750 //
     /*  186887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186890 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186897 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186904 */     // MIs[0] rs1
     /*  186904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186916 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186921 */     GIR_RootConstrainSelectedInstOperands,
     /*  186922 */     // GIR_Coverage, 750,
     /*  186922 */     GIR_Done,
     /*  186923 */   // Label 3644: @186923
     /*  186923 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186964), // Rule ID 752 //
     /*  186928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186931 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186945 */     // MIs[0] rs1
     /*  186945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186957 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186962 */     GIR_RootConstrainSelectedInstOperands,
     /*  186963 */     // GIR_Coverage, 752,
     /*  186963 */     GIR_Done,
     /*  186964 */   // Label 3645: @186964
     /*  186964 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(187005), // Rule ID 754 //
     /*  186969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186972 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186979 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186986 */     // MIs[0] rs1
     /*  186986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186998 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187003 */     GIR_RootConstrainSelectedInstOperands,
     /*  187004 */     // GIR_Coverage, 754,
     /*  187004 */     GIR_Done,
     /*  187005 */   // Label 3646: @187005
     /*  187005 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(187046), // Rule ID 756 //
     /*  187010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187013 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187027 */     // MIs[0] rs1
     /*  187027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187039 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187044 */     GIR_RootConstrainSelectedInstOperands,
     /*  187045 */     // GIR_Coverage, 756,
     /*  187045 */     GIR_Done,
     /*  187046 */   // Label 3647: @187046
     /*  187046 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(187087), // Rule ID 918 //
     /*  187051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187068 */     // MIs[0] rs1
     /*  187068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187080 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187085 */     GIR_RootConstrainSelectedInstOperands,
     /*  187086 */     // GIR_Coverage, 918,
     /*  187086 */     GIR_Done,
     /*  187087 */   // Label 3648: @187087
     /*  187087 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(187128), // Rule ID 920 //
     /*  187092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187109 */     // MIs[0] rs1
     /*  187109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187121 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  187126 */     GIR_RootConstrainSelectedInstOperands,
     /*  187127 */     // GIR_Coverage, 920,
     /*  187127 */     GIR_Done,
     /*  187128 */   // Label 3649: @187128
     /*  187128 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(187169), // Rule ID 922 //
     /*  187133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187136 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187143 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187150 */     // MIs[0] rs1
     /*  187150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187162 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  187167 */     GIR_RootConstrainSelectedInstOperands,
     /*  187168 */     // GIR_Coverage, 922,
     /*  187168 */     GIR_Done,
     /*  187169 */   // Label 3650: @187169
     /*  187169 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(187210), // Rule ID 924 //
     /*  187174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187177 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187184 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187191 */     // MIs[0] rs1
     /*  187191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187203 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  187208 */     GIR_RootConstrainSelectedInstOperands,
     /*  187209 */     // GIR_Coverage, 924,
     /*  187209 */     GIR_Done,
     /*  187210 */   // Label 3651: @187210
     /*  187210 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(187251), // Rule ID 926 //
     /*  187215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  187218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187225 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187232 */     // MIs[0] rs1
     /*  187232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187244 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  187249 */     GIR_RootConstrainSelectedInstOperands,
     /*  187250 */     // GIR_Coverage, 926,
     /*  187250 */     GIR_Done,
     /*  187251 */   // Label 3652: @187251
     /*  187251 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(187292), // Rule ID 928 //
     /*  187256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187259 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187266 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187273 */     // MIs[0] rs1
     /*  187273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187285 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187290 */     GIR_RootConstrainSelectedInstOperands,
     /*  187291 */     // GIR_Coverage, 928,
     /*  187291 */     GIR_Done,
     /*  187292 */   // Label 3653: @187292
     /*  187292 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(187333), // Rule ID 930 //
     /*  187297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187314 */     // MIs[0] rs1
     /*  187314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187326 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187331 */     GIR_RootConstrainSelectedInstOperands,
     /*  187332 */     // GIR_Coverage, 930,
     /*  187332 */     GIR_Done,
     /*  187333 */   // Label 3654: @187333
     /*  187333 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(187374), // Rule ID 932 //
     /*  187338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187355 */     // MIs[0] rs1
     /*  187355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187367 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187372 */     GIR_RootConstrainSelectedInstOperands,
     /*  187373 */     // GIR_Coverage, 932,
     /*  187373 */     GIR_Done,
     /*  187374 */   // Label 3655: @187374
     /*  187374 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(187415), // Rule ID 934 //
     /*  187379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187382 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187389 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187396 */     // MIs[0] rs1
     /*  187396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187408 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187413 */     GIR_RootConstrainSelectedInstOperands,
     /*  187414 */     // GIR_Coverage, 934,
     /*  187414 */     GIR_Done,
     /*  187415 */   // Label 3656: @187415
     /*  187415 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(187456), // Rule ID 936 //
     /*  187420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  187423 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  187430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187437 */     // MIs[0] rs1
     /*  187437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  187441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187449 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  187449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  187454 */     GIR_RootConstrainSelectedInstOperands,
     /*  187455 */     // GIR_Coverage, 936,
     /*  187455 */     GIR_Done,
     /*  187456 */   // Label 3657: @187456
     /*  187456 */   GIM_Reject,
     /*  187457 */ // Label 3627: @187457
     /*  187457 */ GIM_Reject,
     /*  187458 */ // Label 3625: @187458
     /*  187458 */ GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(189107),
     /*  187463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  187466 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(187507), // Rule ID 389 //
     /*  187471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187488 */     // MIs[0] rs1
     /*  187488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187500 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187505 */     GIR_RootConstrainSelectedInstOperands,
     /*  187506 */     // GIR_Coverage, 389,
     /*  187506 */     GIR_Done,
     /*  187507 */   // Label 3659: @187507
     /*  187507 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(187548), // Rule ID 391 //
     /*  187512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187529 */     // MIs[0] rs1
     /*  187529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187541 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  187546 */     GIR_RootConstrainSelectedInstOperands,
     /*  187547 */     // GIR_Coverage, 391,
     /*  187547 */     GIR_Done,
     /*  187548 */   // Label 3660: @187548
     /*  187548 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(187589), // Rule ID 393 //
     /*  187553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187570 */     // MIs[0] rs1
     /*  187570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187582 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  187587 */     GIR_RootConstrainSelectedInstOperands,
     /*  187588 */     // GIR_Coverage, 393,
     /*  187588 */     GIR_Done,
     /*  187589 */   // Label 3661: @187589
     /*  187589 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(187630), // Rule ID 395 //
     /*  187594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187611 */     // MIs[0] rs1
     /*  187611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187623 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  187628 */     GIR_RootConstrainSelectedInstOperands,
     /*  187629 */     // GIR_Coverage, 395,
     /*  187629 */     GIR_Done,
     /*  187630 */   // Label 3662: @187630
     /*  187630 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(187671), // Rule ID 397 //
     /*  187635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187652 */     // MIs[0] rs1
     /*  187652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187664 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  187669 */     GIR_RootConstrainSelectedInstOperands,
     /*  187670 */     // GIR_Coverage, 397,
     /*  187670 */     GIR_Done,
     /*  187671 */   // Label 3663: @187671
     /*  187671 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(187712), // Rule ID 399 //
     /*  187676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187693 */     // MIs[0] rs1
     /*  187693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187705 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187710 */     GIR_RootConstrainSelectedInstOperands,
     /*  187711 */     // GIR_Coverage, 399,
     /*  187711 */     GIR_Done,
     /*  187712 */   // Label 3664: @187712
     /*  187712 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187753), // Rule ID 401 //
     /*  187717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187734 */     // MIs[0] rs1
     /*  187734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187746 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187751 */     GIR_RootConstrainSelectedInstOperands,
     /*  187752 */     // GIR_Coverage, 401,
     /*  187752 */     GIR_Done,
     /*  187753 */   // Label 3665: @187753
     /*  187753 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(187794), // Rule ID 403 //
     /*  187758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187775 */     // MIs[0] rs1
     /*  187775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187787 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187792 */     GIR_RootConstrainSelectedInstOperands,
     /*  187793 */     // GIR_Coverage, 403,
     /*  187793 */     GIR_Done,
     /*  187794 */   // Label 3666: @187794
     /*  187794 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(187835), // Rule ID 405 //
     /*  187799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187816 */     // MIs[0] rs1
     /*  187816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187828 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187833 */     GIR_RootConstrainSelectedInstOperands,
     /*  187834 */     // GIR_Coverage, 405,
     /*  187834 */     GIR_Done,
     /*  187835 */   // Label 3667: @187835
     /*  187835 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(187876), // Rule ID 407 //
     /*  187840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187857 */     // MIs[0] rs1
     /*  187857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187869 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187874 */     GIR_RootConstrainSelectedInstOperands,
     /*  187875 */     // GIR_Coverage, 407,
     /*  187875 */     GIR_Done,
     /*  187876 */   // Label 3668: @187876
     /*  187876 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(187917), // Rule ID 549 //
     /*  187881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187898 */     // MIs[0] rs1
     /*  187898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187910 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  187915 */     GIR_RootConstrainSelectedInstOperands,
     /*  187916 */     // GIR_Coverage, 549,
     /*  187916 */     GIR_Done,
     /*  187917 */   // Label 3669: @187917
     /*  187917 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187958), // Rule ID 550 //
     /*  187922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187939 */     // MIs[0] rs1
     /*  187939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187951 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ),
     /*  187956 */     GIR_RootConstrainSelectedInstOperands,
     /*  187957 */     // GIR_Coverage, 550,
     /*  187957 */     GIR_Done,
     /*  187958 */   // Label 3670: @187958
     /*  187958 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(187999), // Rule ID 551 //
     /*  187963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187980 */     // MIs[0] rs1
     /*  187980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187992 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_RL),
     /*  187997 */     GIR_RootConstrainSelectedInstOperands,
     /*  187998 */     // GIR_Coverage, 551,
     /*  187998 */     GIR_Done,
     /*  187999 */   // Label 3671: @187999
     /*  187999 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(188040), // Rule ID 552 //
     /*  188004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188021 */     // MIs[0] rs1
     /*  188021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188033 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  188038 */     GIR_RootConstrainSelectedInstOperands,
     /*  188039 */     // GIR_Coverage, 552,
     /*  188039 */     GIR_Done,
     /*  188040 */   // Label 3672: @188040
     /*  188040 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(188081), // Rule ID 553 //
     /*  188045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  188048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188062 */     // MIs[0] rs1
     /*  188062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188074 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  188079 */     GIR_RootConstrainSelectedInstOperands,
     /*  188080 */     // GIR_Coverage, 553,
     /*  188080 */     GIR_Done,
     /*  188081 */   // Label 3673: @188081
     /*  188081 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(188122), // Rule ID 554 //
     /*  188086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188103 */     // MIs[0] rs1
     /*  188103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188115 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188120 */     GIR_RootConstrainSelectedInstOperands,
     /*  188121 */     // GIR_Coverage, 554,
     /*  188121 */     GIR_Done,
     /*  188122 */   // Label 3674: @188122
     /*  188122 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(188163), // Rule ID 555 //
     /*  188127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188144 */     // MIs[0] rs1
     /*  188144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188156 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188161 */     GIR_RootConstrainSelectedInstOperands,
     /*  188162 */     // GIR_Coverage, 555,
     /*  188162 */     GIR_Done,
     /*  188163 */   // Label 3675: @188163
     /*  188163 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(188204), // Rule ID 556 //
     /*  188168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188185 */     // MIs[0] rs1
     /*  188185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188197 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188202 */     GIR_RootConstrainSelectedInstOperands,
     /*  188203 */     // GIR_Coverage, 556,
     /*  188203 */     GIR_Done,
     /*  188204 */   // Label 3676: @188204
     /*  188204 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(188245), // Rule ID 557 //
     /*  188209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188212 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188219 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188226 */     // MIs[0] rs1
     /*  188226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188238 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188243 */     GIR_RootConstrainSelectedInstOperands,
     /*  188244 */     // GIR_Coverage, 557,
     /*  188244 */     GIR_Done,
     /*  188245 */   // Label 3677: @188245
     /*  188245 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(188286), // Rule ID 558 //
     /*  188250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  188253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  188260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188267 */     // MIs[0] rs1
     /*  188267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188279 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  188284 */     GIR_RootConstrainSelectedInstOperands,
     /*  188285 */     // GIR_Coverage, 558,
     /*  188285 */     GIR_Done,
     /*  188286 */   // Label 3678: @188286
     /*  188286 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(188327), // Rule ID 737 //
     /*  188291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188308 */     // MIs[0] rs1
     /*  188308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188320 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188325 */     GIR_RootConstrainSelectedInstOperands,
     /*  188326 */     // GIR_Coverage, 737,
     /*  188326 */     GIR_Done,
     /*  188327 */   // Label 3679: @188327
     /*  188327 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(188368), // Rule ID 739 //
     /*  188332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188335 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188349 */     // MIs[0] rs1
     /*  188349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188361 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  188366 */     GIR_RootConstrainSelectedInstOperands,
     /*  188367 */     // GIR_Coverage, 739,
     /*  188367 */     GIR_Done,
     /*  188368 */   // Label 3680: @188368
     /*  188368 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(188409), // Rule ID 741 //
     /*  188373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188390 */     // MIs[0] rs1
     /*  188390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188402 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  188407 */     GIR_RootConstrainSelectedInstOperands,
     /*  188408 */     // GIR_Coverage, 741,
     /*  188408 */     GIR_Done,
     /*  188409 */   // Label 3681: @188409
     /*  188409 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(188450), // Rule ID 743 //
     /*  188414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188431 */     // MIs[0] rs1
     /*  188431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188443 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  188448 */     GIR_RootConstrainSelectedInstOperands,
     /*  188449 */     // GIR_Coverage, 743,
     /*  188449 */     GIR_Done,
     /*  188450 */   // Label 3682: @188450
     /*  188450 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(188491), // Rule ID 745 //
     /*  188455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188472 */     // MIs[0] rs1
     /*  188472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188484 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  188489 */     GIR_RootConstrainSelectedInstOperands,
     /*  188490 */     // GIR_Coverage, 745,
     /*  188490 */     GIR_Done,
     /*  188491 */   // Label 3683: @188491
     /*  188491 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(188532), // Rule ID 747 //
     /*  188496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188513 */     // MIs[0] rs1
     /*  188513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188525 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188530 */     GIR_RootConstrainSelectedInstOperands,
     /*  188531 */     // GIR_Coverage, 747,
     /*  188531 */     GIR_Done,
     /*  188532 */   // Label 3684: @188532
     /*  188532 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(188573), // Rule ID 749 //
     /*  188537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188554 */     // MIs[0] rs1
     /*  188554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188566 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188571 */     GIR_RootConstrainSelectedInstOperands,
     /*  188572 */     // GIR_Coverage, 749,
     /*  188572 */     GIR_Done,
     /*  188573 */   // Label 3685: @188573
     /*  188573 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(188614), // Rule ID 751 //
     /*  188578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188595 */     // MIs[0] rs1
     /*  188595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188607 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188612 */     GIR_RootConstrainSelectedInstOperands,
     /*  188613 */     // GIR_Coverage, 751,
     /*  188613 */     GIR_Done,
     /*  188614 */   // Label 3686: @188614
     /*  188614 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(188655), // Rule ID 753 //
     /*  188619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188636 */     // MIs[0] rs1
     /*  188636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188648 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188653 */     GIR_RootConstrainSelectedInstOperands,
     /*  188654 */     // GIR_Coverage, 753,
     /*  188654 */     GIR_Done,
     /*  188655 */   // Label 3687: @188655
     /*  188655 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(188696), // Rule ID 755 //
     /*  188660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188677 */     // MIs[0] rs1
     /*  188677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188689 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188694 */     GIR_RootConstrainSelectedInstOperands,
     /*  188695 */     // GIR_Coverage, 755,
     /*  188695 */     GIR_Done,
     /*  188696 */   // Label 3688: @188696
     /*  188696 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(188737), // Rule ID 917 //
     /*  188701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188718 */     // MIs[0] rs1
     /*  188718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188730 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188735 */     GIR_RootConstrainSelectedInstOperands,
     /*  188736 */     // GIR_Coverage, 917,
     /*  188736 */     GIR_Done,
     /*  188737 */   // Label 3689: @188737
     /*  188737 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(188778), // Rule ID 919 //
     /*  188742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188759 */     // MIs[0] rs1
     /*  188759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188771 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  188776 */     GIR_RootConstrainSelectedInstOperands,
     /*  188777 */     // GIR_Coverage, 919,
     /*  188777 */     GIR_Done,
     /*  188778 */   // Label 3690: @188778
     /*  188778 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(188819), // Rule ID 921 //
     /*  188783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188800 */     // MIs[0] rs1
     /*  188800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188812 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  188817 */     GIR_RootConstrainSelectedInstOperands,
     /*  188818 */     // GIR_Coverage, 921,
     /*  188818 */     GIR_Done,
     /*  188819 */   // Label 3691: @188819
     /*  188819 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(188860), // Rule ID 923 //
     /*  188824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188841 */     // MIs[0] rs1
     /*  188841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188853 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  188858 */     GIR_RootConstrainSelectedInstOperands,
     /*  188859 */     // GIR_Coverage, 923,
     /*  188859 */     GIR_Done,
     /*  188860 */   // Label 3692: @188860
     /*  188860 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(188901), // Rule ID 925 //
     /*  188865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188882 */     // MIs[0] rs1
     /*  188882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188894 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  188899 */     GIR_RootConstrainSelectedInstOperands,
     /*  188900 */     // GIR_Coverage, 925,
     /*  188900 */     GIR_Done,
     /*  188901 */   // Label 3693: @188901
     /*  188901 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(188942), // Rule ID 927 //
     /*  188906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188923 */     // MIs[0] rs1
     /*  188923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188935 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188940 */     GIR_RootConstrainSelectedInstOperands,
     /*  188941 */     // GIR_Coverage, 927,
     /*  188941 */     GIR_Done,
     /*  188942 */   // Label 3694: @188942
     /*  188942 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(188983), // Rule ID 929 //
     /*  188947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188964 */     // MIs[0] rs1
     /*  188964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188976 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188981 */     GIR_RootConstrainSelectedInstOperands,
     /*  188982 */     // GIR_Coverage, 929,
     /*  188982 */     GIR_Done,
     /*  188983 */   // Label 3695: @188983
     /*  188983 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(189024), // Rule ID 931 //
     /*  188988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189005 */     // MIs[0] rs1
     /*  189005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189017 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189022 */     GIR_RootConstrainSelectedInstOperands,
     /*  189023 */     // GIR_Coverage, 931,
     /*  189023 */     GIR_Done,
     /*  189024 */   // Label 3696: @189024
     /*  189024 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(189065), // Rule ID 933 //
     /*  189029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189046 */     // MIs[0] rs1
     /*  189046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189058 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189063 */     GIR_RootConstrainSelectedInstOperands,
     /*  189064 */     // GIR_Coverage, 933,
     /*  189064 */     GIR_Done,
     /*  189065 */   // Label 3697: @189065
     /*  189065 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(189106), // Rule ID 935 //
     /*  189070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  189073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  189080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189087 */     // MIs[0] rs1
     /*  189087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  189091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189099 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  189099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  189104 */     GIR_RootConstrainSelectedInstOperands,
     /*  189105 */     // GIR_Coverage, 935,
     /*  189105 */     GIR_Done,
     /*  189106 */   // Label 3698: @189106
     /*  189106 */   GIM_Reject,
     /*  189107 */ // Label 3658: @189107
     /*  189107 */ GIM_Reject,
     /*  189108 */ // Label 3626: @189108
     /*  189108 */ GIM_Reject,
     /*  189109 */ // Label 29: @189109
     /*  189109 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3701*/ GIMT_Encode4(190020),
     /*  189120 */ /*GILLT_s32*//*Label 3699*/ GIMT_Encode4(189128),
     /*  189124 */ /*GILLT_s64*//*Label 3700*/ GIMT_Encode4(189410),
     /*  189128 */ // Label 3699: @189128
     /*  189128 */ GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(189409),
     /*  189133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  189136 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189143 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(189196), // Rule ID 620 //
     /*  189148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189158 */     // MIs[0] addr
     /*  189158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189170 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 2:{ *:[i32] })
     /*  189170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189178 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189183 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189185 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189194 */     GIR_RootConstrainSelectedInstOperands,
     /*  189195 */     // GIR_Coverage, 620,
     /*  189195 */     GIR_EraseRootFromParent_Done,
     /*  189196 */   // Label 3703: @189196
     /*  189196 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(189249), // Rule ID 622 //
     /*  189201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189211 */     // MIs[0] addr
     /*  189211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189223 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 4:{ *:[i32] })
     /*  189223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189231 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189236 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189238 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189247 */     GIR_RootConstrainSelectedInstOperands,
     /*  189248 */     // GIR_Coverage, 622,
     /*  189248 */     GIR_EraseRootFromParent_Done,
     /*  189249 */   // Label 3704: @189249
     /*  189249 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(189302), // Rule ID 624 //
     /*  189254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189264 */     // MIs[0] addr
     /*  189264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189276 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 5:{ *:[i32] })
     /*  189276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189284 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189289 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189291 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189300 */     GIR_RootConstrainSelectedInstOperands,
     /*  189301 */     // GIR_Coverage, 624,
     /*  189301 */     GIR_EraseRootFromParent_Done,
     /*  189302 */   // Label 3705: @189302
     /*  189302 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(189355), // Rule ID 626 //
     /*  189307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189317 */     // MIs[0] addr
     /*  189317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189329 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 6:{ *:[i32] })
     /*  189329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189337 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189342 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189344 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189353 */     GIR_RootConstrainSelectedInstOperands,
     /*  189354 */     // GIR_Coverage, 626,
     /*  189354 */     GIR_EraseRootFromParent_Done,
     /*  189355 */   // Label 3706: @189355
     /*  189355 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(189408), // Rule ID 628 //
     /*  189360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  189363 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189370 */     // MIs[0] addr
     /*  189370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189382 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 7:{ *:[i32] })
     /*  189382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189390 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189395 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189397 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  189402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189406 */     GIR_RootConstrainSelectedInstOperands,
     /*  189407 */     // GIR_Coverage, 628,
     /*  189407 */     GIR_EraseRootFromParent_Done,
     /*  189408 */   // Label 3707: @189408
     /*  189408 */   GIM_Reject,
     /*  189409 */ // Label 3702: @189409
     /*  189409 */ GIM_Reject,
     /*  189410 */ // Label 3700: @189410
     /*  189410 */ GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(190019),
     /*  189415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  189418 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(189478), // Rule ID 619 //
     /*  189423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189440 */     // MIs[0] addr
     /*  189440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189452 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  189452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189460 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189465 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189467 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189476 */     GIR_RootConstrainSelectedInstOperands,
     /*  189477 */     // GIR_Coverage, 619,
     /*  189477 */     GIR_EraseRootFromParent_Done,
     /*  189478 */   // Label 3709: @189478
     /*  189478 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(189538), // Rule ID 621 //
     /*  189483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189486 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189493 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189500 */     // MIs[0] addr
     /*  189500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189512 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  189512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189520 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189525 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189527 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189536 */     GIR_RootConstrainSelectedInstOperands,
     /*  189537 */     // GIR_Coverage, 621,
     /*  189537 */     GIR_EraseRootFromParent_Done,
     /*  189538 */   // Label 3710: @189538
     /*  189538 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(189598), // Rule ID 623 //
     /*  189543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189560 */     // MIs[0] addr
     /*  189560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189572 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  189572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189580 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189585 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189587 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189596 */     GIR_RootConstrainSelectedInstOperands,
     /*  189597 */     // GIR_Coverage, 623,
     /*  189597 */     GIR_EraseRootFromParent_Done,
     /*  189598 */   // Label 3711: @189598
     /*  189598 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(189658), // Rule ID 625 //
     /*  189603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189620 */     // MIs[0] addr
     /*  189620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189632 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  189632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189640 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189645 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189647 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189656 */     GIR_RootConstrainSelectedInstOperands,
     /*  189657 */     // GIR_Coverage, 625,
     /*  189657 */     GIR_EraseRootFromParent_Done,
     /*  189658 */   // Label 3712: @189658
     /*  189658 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(189718), // Rule ID 627 //
     /*  189663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189680 */     // MIs[0] addr
     /*  189680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189692 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  189692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189700 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189705 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189707 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  189712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189716 */     GIR_RootConstrainSelectedInstOperands,
     /*  189717 */     // GIR_Coverage, 627,
     /*  189717 */     GIR_EraseRootFromParent_Done,
     /*  189718 */   // Label 3713: @189718
     /*  189718 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(189778), // Rule ID 637 //
     /*  189723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189726 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189733 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189740 */     // MIs[0] addr
     /*  189740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189752 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_monotonic>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  189752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189760 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189765 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189767 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189776 */     GIR_RootConstrainSelectedInstOperands,
     /*  189777 */     // GIR_Coverage, 637,
     /*  189777 */     GIR_EraseRootFromParent_Done,
     /*  189778 */   // Label 3714: @189778
     /*  189778 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(189838), // Rule ID 638 //
     /*  189783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189800 */     // MIs[0] addr
     /*  189800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189812 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acquire>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  189812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189820 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189825 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189827 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189836 */     GIR_RootConstrainSelectedInstOperands,
     /*  189837 */     // GIR_Coverage, 638,
     /*  189837 */     GIR_EraseRootFromParent_Done,
     /*  189838 */   // Label 3715: @189838
     /*  189838 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(189898), // Rule ID 639 //
     /*  189843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189860 */     // MIs[0] addr
     /*  189860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189872 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_release>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  189872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189880 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189885 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189887 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189896 */     GIR_RootConstrainSelectedInstOperands,
     /*  189897 */     // GIR_Coverage, 639,
     /*  189897 */     GIR_EraseRootFromParent_Done,
     /*  189898 */   // Label 3716: @189898
     /*  189898 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(189958), // Rule ID 640 //
     /*  189903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189920 */     // MIs[0] addr
     /*  189920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189932 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acq_rel>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  189932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189940 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189945 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189947 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189956 */     GIR_RootConstrainSelectedInstOperands,
     /*  189957 */     // GIR_Coverage, 640,
     /*  189957 */     GIR_EraseRootFromParent_Done,
     /*  189958 */   // Label 3717: @189958
     /*  189958 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(190018), // Rule ID 641 //
     /*  189963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189980 */     // MIs[0] addr
     /*  189980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189992 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_seq_cst>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  189992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  190000 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  190005 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  190007 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  190009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  190012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  190016 */     GIR_RootConstrainSelectedInstOperands,
     /*  190017 */     // GIR_Coverage, 641,
     /*  190017 */     GIR_EraseRootFromParent_Done,
     /*  190018 */   // Label 3718: @190018
     /*  190018 */   GIM_Reject,
     /*  190019 */ // Label 3708: @190019
     /*  190019 */ GIM_Reject,
     /*  190020 */ // Label 3701: @190020
     /*  190020 */ GIM_Reject,
     /*  190021 */ // Label 30: @190021
     /*  190021 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3721*/ GIMT_Encode4(192930),
     /*  190032 */ /*GILLT_s32*//*Label 3719*/ GIMT_Encode4(190040),
     /*  190036 */ /*GILLT_s64*//*Label 3720*/ GIMT_Encode4(191280),
     /*  190040 */ // Label 3719: @190040
     /*  190040 */ GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(191279),
     /*  190045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  190048 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(190089), // Rule ID 410 //
     /*  190053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190070 */     // MIs[0] rs1
     /*  190070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190082 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190087 */     GIR_RootConstrainSelectedInstOperands,
     /*  190088 */     // GIR_Coverage, 410,
     /*  190088 */     GIR_Done,
     /*  190089 */   // Label 3723: @190089
     /*  190089 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(190130), // Rule ID 412 //
     /*  190094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190111 */     // MIs[0] rs1
     /*  190111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190123 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  190128 */     GIR_RootConstrainSelectedInstOperands,
     /*  190129 */     // GIR_Coverage, 412,
     /*  190129 */     GIR_Done,
     /*  190130 */   // Label 3724: @190130
     /*  190130 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(190171), // Rule ID 414 //
     /*  190135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190152 */     // MIs[0] rs1
     /*  190152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190164 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  190169 */     GIR_RootConstrainSelectedInstOperands,
     /*  190170 */     // GIR_Coverage, 414,
     /*  190170 */     GIR_Done,
     /*  190171 */   // Label 3725: @190171
     /*  190171 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(190212), // Rule ID 416 //
     /*  190176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190179 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190193 */     // MIs[0] rs1
     /*  190193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190205 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190210 */     GIR_RootConstrainSelectedInstOperands,
     /*  190211 */     // GIR_Coverage, 416,
     /*  190211 */     GIR_Done,
     /*  190212 */   // Label 3726: @190212
     /*  190212 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(190253), // Rule ID 418 //
     /*  190217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  190220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190234 */     // MIs[0] rs1
     /*  190234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190246 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190251 */     GIR_RootConstrainSelectedInstOperands,
     /*  190252 */     // GIR_Coverage, 418,
     /*  190252 */     GIR_Done,
     /*  190253 */   // Label 3727: @190253
     /*  190253 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(190294), // Rule ID 420 //
     /*  190258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190275 */     // MIs[0] rs1
     /*  190275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190287 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190292 */     GIR_RootConstrainSelectedInstOperands,
     /*  190293 */     // GIR_Coverage, 420,
     /*  190293 */     GIR_Done,
     /*  190294 */   // Label 3728: @190294
     /*  190294 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(190335), // Rule ID 422 //
     /*  190299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190316 */     // MIs[0] rs1
     /*  190316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190328 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190333 */     GIR_RootConstrainSelectedInstOperands,
     /*  190334 */     // GIR_Coverage, 422,
     /*  190334 */     GIR_Done,
     /*  190335 */   // Label 3729: @190335
     /*  190335 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(190376), // Rule ID 424 //
     /*  190340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190357 */     // MIs[0] rs1
     /*  190357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190369 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190374 */     GIR_RootConstrainSelectedInstOperands,
     /*  190375 */     // GIR_Coverage, 424,
     /*  190375 */     GIR_Done,
     /*  190376 */   // Label 3730: @190376
     /*  190376 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(190417), // Rule ID 426 //
     /*  190381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190398 */     // MIs[0] rs1
     /*  190398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190410 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190415 */     GIR_RootConstrainSelectedInstOperands,
     /*  190416 */     // GIR_Coverage, 426,
     /*  190416 */     GIR_Done,
     /*  190417 */   // Label 3731: @190417
     /*  190417 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(190458), // Rule ID 428 //
     /*  190422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  190425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190439 */     // MIs[0] rs1
     /*  190439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190451 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190456 */     GIR_RootConstrainSelectedInstOperands,
     /*  190457 */     // GIR_Coverage, 428,
     /*  190457 */     GIR_Done,
     /*  190458 */   // Label 3732: @190458
     /*  190458 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(190499), // Rule ID 758 //
     /*  190463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190480 */     // MIs[0] rs1
     /*  190480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190492 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190497 */     GIR_RootConstrainSelectedInstOperands,
     /*  190498 */     // GIR_Coverage, 758,
     /*  190498 */     GIR_Done,
     /*  190499 */   // Label 3733: @190499
     /*  190499 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(190540), // Rule ID 760 //
     /*  190504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190521 */     // MIs[0] rs1
     /*  190521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190533 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  190538 */     GIR_RootConstrainSelectedInstOperands,
     /*  190539 */     // GIR_Coverage, 760,
     /*  190539 */     GIR_Done,
     /*  190540 */   // Label 3734: @190540
     /*  190540 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(190581), // Rule ID 762 //
     /*  190545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190562 */     // MIs[0] rs1
     /*  190562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190574 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  190579 */     GIR_RootConstrainSelectedInstOperands,
     /*  190580 */     // GIR_Coverage, 762,
     /*  190580 */     GIR_Done,
     /*  190581 */   // Label 3735: @190581
     /*  190581 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(190622), // Rule ID 764 //
     /*  190586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190603 */     // MIs[0] rs1
     /*  190603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190615 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  190620 */     GIR_RootConstrainSelectedInstOperands,
     /*  190621 */     // GIR_Coverage, 764,
     /*  190621 */     GIR_Done,
     /*  190622 */   // Label 3736: @190622
     /*  190622 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(190663), // Rule ID 766 //
     /*  190627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190644 */     // MIs[0] rs1
     /*  190644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190656 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  190661 */     GIR_RootConstrainSelectedInstOperands,
     /*  190662 */     // GIR_Coverage, 766,
     /*  190662 */     GIR_Done,
     /*  190663 */   // Label 3737: @190663
     /*  190663 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(190704), // Rule ID 768 //
     /*  190668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190685 */     // MIs[0] rs1
     /*  190685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190697 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190702 */     GIR_RootConstrainSelectedInstOperands,
     /*  190703 */     // GIR_Coverage, 768,
     /*  190703 */     GIR_Done,
     /*  190704 */   // Label 3738: @190704
     /*  190704 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(190745), // Rule ID 770 //
     /*  190709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190726 */     // MIs[0] rs1
     /*  190726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190738 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190743 */     GIR_RootConstrainSelectedInstOperands,
     /*  190744 */     // GIR_Coverage, 770,
     /*  190744 */     GIR_Done,
     /*  190745 */   // Label 3739: @190745
     /*  190745 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(190786), // Rule ID 772 //
     /*  190750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190767 */     // MIs[0] rs1
     /*  190767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190779 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190784 */     GIR_RootConstrainSelectedInstOperands,
     /*  190785 */     // GIR_Coverage, 772,
     /*  190785 */     GIR_Done,
     /*  190786 */   // Label 3740: @190786
     /*  190786 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(190827), // Rule ID 774 //
     /*  190791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190808 */     // MIs[0] rs1
     /*  190808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190820 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190825 */     GIR_RootConstrainSelectedInstOperands,
     /*  190826 */     // GIR_Coverage, 774,
     /*  190826 */     GIR_Done,
     /*  190827 */   // Label 3741: @190827
     /*  190827 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(190868), // Rule ID 776 //
     /*  190832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190849 */     // MIs[0] rs1
     /*  190849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190861 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190866 */     GIR_RootConstrainSelectedInstOperands,
     /*  190867 */     // GIR_Coverage, 776,
     /*  190867 */     GIR_Done,
     /*  190868 */   // Label 3742: @190868
     /*  190868 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(190909), // Rule ID 938 //
     /*  190873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190890 */     // MIs[0] rs1
     /*  190890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190902 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  190907 */     GIR_RootConstrainSelectedInstOperands,
     /*  190908 */     // GIR_Coverage, 938,
     /*  190908 */     GIR_Done,
     /*  190909 */   // Label 3743: @190909
     /*  190909 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(190950), // Rule ID 940 //
     /*  190914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190931 */     // MIs[0] rs1
     /*  190931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190943 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  190948 */     GIR_RootConstrainSelectedInstOperands,
     /*  190949 */     // GIR_Coverage, 940,
     /*  190949 */     GIR_Done,
     /*  190950 */   // Label 3744: @190950
     /*  190950 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(190991), // Rule ID 942 //
     /*  190955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190972 */     // MIs[0] rs1
     /*  190972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190984 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  190989 */     GIR_RootConstrainSelectedInstOperands,
     /*  190990 */     // GIR_Coverage, 942,
     /*  190990 */     GIR_Done,
     /*  190991 */   // Label 3745: @190991
     /*  190991 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(191032), // Rule ID 944 //
     /*  190996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191013 */     // MIs[0] rs1
     /*  191013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191025 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  191030 */     GIR_RootConstrainSelectedInstOperands,
     /*  191031 */     // GIR_Coverage, 944,
     /*  191031 */     GIR_Done,
     /*  191032 */   // Label 3746: @191032
     /*  191032 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(191073), // Rule ID 946 //
     /*  191037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  191040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191054 */     // MIs[0] rs1
     /*  191054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191066 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  191071 */     GIR_RootConstrainSelectedInstOperands,
     /*  191072 */     // GIR_Coverage, 946,
     /*  191072 */     GIR_Done,
     /*  191073 */   // Label 3747: @191073
     /*  191073 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(191114), // Rule ID 948 //
     /*  191078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191095 */     // MIs[0] rs1
     /*  191095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191107 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191112 */     GIR_RootConstrainSelectedInstOperands,
     /*  191113 */     // GIR_Coverage, 948,
     /*  191113 */     GIR_Done,
     /*  191114 */   // Label 3748: @191114
     /*  191114 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(191155), // Rule ID 950 //
     /*  191119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191136 */     // MIs[0] rs1
     /*  191136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191148 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191153 */     GIR_RootConstrainSelectedInstOperands,
     /*  191154 */     // GIR_Coverage, 950,
     /*  191154 */     GIR_Done,
     /*  191155 */   // Label 3749: @191155
     /*  191155 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(191196), // Rule ID 952 //
     /*  191160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191177 */     // MIs[0] rs1
     /*  191177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191189 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191194 */     GIR_RootConstrainSelectedInstOperands,
     /*  191195 */     // GIR_Coverage, 952,
     /*  191195 */     GIR_Done,
     /*  191196 */   // Label 3750: @191196
     /*  191196 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(191237), // Rule ID 954 //
     /*  191201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191218 */     // MIs[0] rs1
     /*  191218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191230 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191235 */     GIR_RootConstrainSelectedInstOperands,
     /*  191236 */     // GIR_Coverage, 954,
     /*  191236 */     GIR_Done,
     /*  191237 */   // Label 3751: @191237
     /*  191237 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(191278), // Rule ID 956 //
     /*  191242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  191245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  191252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191259 */     // MIs[0] rs1
     /*  191259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  191263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191271 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  191271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  191276 */     GIR_RootConstrainSelectedInstOperands,
     /*  191277 */     // GIR_Coverage, 956,
     /*  191277 */     GIR_Done,
     /*  191278 */   // Label 3752: @191278
     /*  191278 */   GIM_Reject,
     /*  191279 */ // Label 3722: @191279
     /*  191279 */ GIM_Reject,
     /*  191280 */ // Label 3720: @191280
     /*  191280 */ GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(192929),
     /*  191285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  191288 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(191329), // Rule ID 409 //
     /*  191293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191296 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191303 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191310 */     // MIs[0] rs1
     /*  191310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191322 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191327 */     GIR_RootConstrainSelectedInstOperands,
     /*  191328 */     // GIR_Coverage, 409,
     /*  191328 */     GIR_Done,
     /*  191329 */   // Label 3754: @191329
     /*  191329 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(191370), // Rule ID 411 //
     /*  191334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191337 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191344 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191351 */     // MIs[0] rs1
     /*  191351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191363 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  191368 */     GIR_RootConstrainSelectedInstOperands,
     /*  191369 */     // GIR_Coverage, 411,
     /*  191369 */     GIR_Done,
     /*  191370 */   // Label 3755: @191370
     /*  191370 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(191411), // Rule ID 413 //
     /*  191375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191378 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191385 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191392 */     // MIs[0] rs1
     /*  191392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191404 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  191409 */     GIR_RootConstrainSelectedInstOperands,
     /*  191410 */     // GIR_Coverage, 413,
     /*  191410 */     GIR_Done,
     /*  191411 */   // Label 3756: @191411
     /*  191411 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(191452), // Rule ID 415 //
     /*  191416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191419 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191426 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191433 */     // MIs[0] rs1
     /*  191433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191445 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  191450 */     GIR_RootConstrainSelectedInstOperands,
     /*  191451 */     // GIR_Coverage, 415,
     /*  191451 */     GIR_Done,
     /*  191452 */   // Label 3757: @191452
     /*  191452 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(191493), // Rule ID 417 //
     /*  191457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  191460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191474 */     // MIs[0] rs1
     /*  191474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191486 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191486 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  191491 */     GIR_RootConstrainSelectedInstOperands,
     /*  191492 */     // GIR_Coverage, 417,
     /*  191492 */     GIR_Done,
     /*  191493 */   // Label 3758: @191493
     /*  191493 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(191534), // Rule ID 419 //
     /*  191498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191515 */     // MIs[0] rs1
     /*  191515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191527 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191532 */     GIR_RootConstrainSelectedInstOperands,
     /*  191533 */     // GIR_Coverage, 419,
     /*  191533 */     GIR_Done,
     /*  191534 */   // Label 3759: @191534
     /*  191534 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(191575), // Rule ID 421 //
     /*  191539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191542 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191549 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191556 */     // MIs[0] rs1
     /*  191556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191568 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191573 */     GIR_RootConstrainSelectedInstOperands,
     /*  191574 */     // GIR_Coverage, 421,
     /*  191574 */     GIR_Done,
     /*  191575 */   // Label 3760: @191575
     /*  191575 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(191616), // Rule ID 423 //
     /*  191580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191590 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191597 */     // MIs[0] rs1
     /*  191597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191609 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191614 */     GIR_RootConstrainSelectedInstOperands,
     /*  191615 */     // GIR_Coverage, 423,
     /*  191615 */     GIR_Done,
     /*  191616 */   // Label 3761: @191616
     /*  191616 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(191657), // Rule ID 425 //
     /*  191621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191624 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191631 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191638 */     // MIs[0] rs1
     /*  191638 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191650 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191655 */     GIR_RootConstrainSelectedInstOperands,
     /*  191656 */     // GIR_Coverage, 425,
     /*  191656 */     GIR_Done,
     /*  191657 */   // Label 3762: @191657
     /*  191657 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(191698), // Rule ID 427 //
     /*  191662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191672 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191679 */     // MIs[0] rs1
     /*  191679 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191691 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191696 */     GIR_RootConstrainSelectedInstOperands,
     /*  191697 */     // GIR_Coverage, 427,
     /*  191697 */     GIR_Done,
     /*  191698 */   // Label 3763: @191698
     /*  191698 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(191739), // Rule ID 559 //
     /*  191703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191706 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191713 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191720 */     // MIs[0] rs1
     /*  191720 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191732 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191737 */     GIR_RootConstrainSelectedInstOperands,
     /*  191738 */     // GIR_Coverage, 559,
     /*  191738 */     GIR_Done,
     /*  191739 */   // Label 3764: @191739
     /*  191739 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(191780), // Rule ID 560 //
     /*  191744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191747 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191754 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191761 */     // MIs[0] rs1
     /*  191761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191773 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ),
     /*  191778 */     GIR_RootConstrainSelectedInstOperands,
     /*  191779 */     // GIR_Coverage, 560,
     /*  191779 */     GIR_Done,
     /*  191780 */   // Label 3765: @191780
     /*  191780 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(191821), // Rule ID 561 //
     /*  191785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191802 */     // MIs[0] rs1
     /*  191802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191814 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_RL),
     /*  191819 */     GIR_RootConstrainSelectedInstOperands,
     /*  191820 */     // GIR_Coverage, 561,
     /*  191820 */     GIR_Done,
     /*  191821 */   // Label 3766: @191821
     /*  191821 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(191862), // Rule ID 562 //
     /*  191826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191829 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191843 */     // MIs[0] rs1
     /*  191843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191855 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  191860 */     GIR_RootConstrainSelectedInstOperands,
     /*  191861 */     // GIR_Coverage, 562,
     /*  191861 */     GIR_Done,
     /*  191862 */   // Label 3767: @191862
     /*  191862 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(191903), // Rule ID 563 //
     /*  191867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191884 */     // MIs[0] rs1
     /*  191884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191896 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  191901 */     GIR_RootConstrainSelectedInstOperands,
     /*  191902 */     // GIR_Coverage, 563,
     /*  191902 */     GIR_Done,
     /*  191903 */   // Label 3768: @191903
     /*  191903 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(191944), // Rule ID 564 //
     /*  191908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191918 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191925 */     // MIs[0] rs1
     /*  191925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191937 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191942 */     GIR_RootConstrainSelectedInstOperands,
     /*  191943 */     // GIR_Coverage, 564,
     /*  191943 */     GIR_Done,
     /*  191944 */   // Label 3769: @191944
     /*  191944 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(191985), // Rule ID 565 //
     /*  191949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191966 */     // MIs[0] rs1
     /*  191966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191978 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191983 */     GIR_RootConstrainSelectedInstOperands,
     /*  191984 */     // GIR_Coverage, 565,
     /*  191984 */     GIR_Done,
     /*  191985 */   // Label 3770: @191985
     /*  191985 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(192026), // Rule ID 566 //
     /*  191990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192007 */     // MIs[0] rs1
     /*  192007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192019 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192024 */     GIR_RootConstrainSelectedInstOperands,
     /*  192025 */     // GIR_Coverage, 566,
     /*  192025 */     GIR_Done,
     /*  192026 */   // Label 3771: @192026
     /*  192026 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(192067), // Rule ID 567 //
     /*  192031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192048 */     // MIs[0] rs1
     /*  192048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192060 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192065 */     GIR_RootConstrainSelectedInstOperands,
     /*  192066 */     // GIR_Coverage, 567,
     /*  192066 */     GIR_Done,
     /*  192067 */   // Label 3772: @192067
     /*  192067 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(192108), // Rule ID 568 //
     /*  192072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  192075 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  192082 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192089 */     // MIs[0] rs1
     /*  192089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192101 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  192106 */     GIR_RootConstrainSelectedInstOperands,
     /*  192107 */     // GIR_Coverage, 568,
     /*  192107 */     GIR_Done,
     /*  192108 */   // Label 3773: @192108
     /*  192108 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(192149), // Rule ID 757 //
     /*  192113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192130 */     // MIs[0] rs1
     /*  192130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192142 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192147 */     GIR_RootConstrainSelectedInstOperands,
     /*  192148 */     // GIR_Coverage, 757,
     /*  192148 */     GIR_Done,
     /*  192149 */   // Label 3774: @192149
     /*  192149 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(192190), // Rule ID 759 //
     /*  192154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192171 */     // MIs[0] rs1
     /*  192171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192183 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  192188 */     GIR_RootConstrainSelectedInstOperands,
     /*  192189 */     // GIR_Coverage, 759,
     /*  192189 */     GIR_Done,
     /*  192190 */   // Label 3775: @192190
     /*  192190 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(192231), // Rule ID 761 //
     /*  192195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192212 */     // MIs[0] rs1
     /*  192212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192224 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  192229 */     GIR_RootConstrainSelectedInstOperands,
     /*  192230 */     // GIR_Coverage, 761,
     /*  192230 */     GIR_Done,
     /*  192231 */   // Label 3776: @192231
     /*  192231 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(192272), // Rule ID 763 //
     /*  192236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192239 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192253 */     // MIs[0] rs1
     /*  192253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192265 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  192270 */     GIR_RootConstrainSelectedInstOperands,
     /*  192271 */     // GIR_Coverage, 763,
     /*  192271 */     GIR_Done,
     /*  192272 */   // Label 3777: @192272
     /*  192272 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(192313), // Rule ID 765 //
     /*  192277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192294 */     // MIs[0] rs1
     /*  192294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192306 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  192311 */     GIR_RootConstrainSelectedInstOperands,
     /*  192312 */     // GIR_Coverage, 765,
     /*  192312 */     GIR_Done,
     /*  192313 */   // Label 3778: @192313
     /*  192313 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(192354), // Rule ID 767 //
     /*  192318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192335 */     // MIs[0] rs1
     /*  192335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192347 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192352 */     GIR_RootConstrainSelectedInstOperands,
     /*  192353 */     // GIR_Coverage, 767,
     /*  192353 */     GIR_Done,
     /*  192354 */   // Label 3779: @192354
     /*  192354 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(192395), // Rule ID 769 //
     /*  192359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192376 */     // MIs[0] rs1
     /*  192376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192388 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192393 */     GIR_RootConstrainSelectedInstOperands,
     /*  192394 */     // GIR_Coverage, 769,
     /*  192394 */     GIR_Done,
     /*  192395 */   // Label 3780: @192395
     /*  192395 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(192436), // Rule ID 771 //
     /*  192400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192417 */     // MIs[0] rs1
     /*  192417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192429 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192434 */     GIR_RootConstrainSelectedInstOperands,
     /*  192435 */     // GIR_Coverage, 771,
     /*  192435 */     GIR_Done,
     /*  192436 */   // Label 3781: @192436
     /*  192436 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(192477), // Rule ID 773 //
     /*  192441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192458 */     // MIs[0] rs1
     /*  192458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192470 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192475 */     GIR_RootConstrainSelectedInstOperands,
     /*  192476 */     // GIR_Coverage, 773,
     /*  192476 */     GIR_Done,
     /*  192477 */   // Label 3782: @192477
     /*  192477 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(192518), // Rule ID 775 //
     /*  192482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192499 */     // MIs[0] rs1
     /*  192499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192511 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192516 */     GIR_RootConstrainSelectedInstOperands,
     /*  192517 */     // GIR_Coverage, 775,
     /*  192517 */     GIR_Done,
     /*  192518 */   // Label 3783: @192518
     /*  192518 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(192559), // Rule ID 937 //
     /*  192523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192540 */     // MIs[0] rs1
     /*  192540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192552 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192557 */     GIR_RootConstrainSelectedInstOperands,
     /*  192558 */     // GIR_Coverage, 937,
     /*  192558 */     GIR_Done,
     /*  192559 */   // Label 3784: @192559
     /*  192559 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(192600), // Rule ID 939 //
     /*  192564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192581 */     // MIs[0] rs1
     /*  192581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192593 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  192598 */     GIR_RootConstrainSelectedInstOperands,
     /*  192599 */     // GIR_Coverage, 939,
     /*  192599 */     GIR_Done,
     /*  192600 */   // Label 3785: @192600
     /*  192600 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(192641), // Rule ID 941 //
     /*  192605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192622 */     // MIs[0] rs1
     /*  192622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192634 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  192639 */     GIR_RootConstrainSelectedInstOperands,
     /*  192640 */     // GIR_Coverage, 941,
     /*  192640 */     GIR_Done,
     /*  192641 */   // Label 3786: @192641
     /*  192641 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(192682), // Rule ID 943 //
     /*  192646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192663 */     // MIs[0] rs1
     /*  192663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192675 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  192680 */     GIR_RootConstrainSelectedInstOperands,
     /*  192681 */     // GIR_Coverage, 943,
     /*  192681 */     GIR_Done,
     /*  192682 */   // Label 3787: @192682
     /*  192682 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(192723), // Rule ID 945 //
     /*  192687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192704 */     // MIs[0] rs1
     /*  192704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192716 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  192721 */     GIR_RootConstrainSelectedInstOperands,
     /*  192722 */     // GIR_Coverage, 945,
     /*  192722 */     GIR_Done,
     /*  192723 */   // Label 3788: @192723
     /*  192723 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(192764), // Rule ID 947 //
     /*  192728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192745 */     // MIs[0] rs1
     /*  192745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192757 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192762 */     GIR_RootConstrainSelectedInstOperands,
     /*  192763 */     // GIR_Coverage, 947,
     /*  192763 */     GIR_Done,
     /*  192764 */   // Label 3789: @192764
     /*  192764 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(192805), // Rule ID 949 //
     /*  192769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192786 */     // MIs[0] rs1
     /*  192786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192798 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192803 */     GIR_RootConstrainSelectedInstOperands,
     /*  192804 */     // GIR_Coverage, 949,
     /*  192804 */     GIR_Done,
     /*  192805 */   // Label 3790: @192805
     /*  192805 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(192846), // Rule ID 951 //
     /*  192810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192827 */     // MIs[0] rs1
     /*  192827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192839 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192844 */     GIR_RootConstrainSelectedInstOperands,
     /*  192845 */     // GIR_Coverage, 951,
     /*  192845 */     GIR_Done,
     /*  192846 */   // Label 3791: @192846
     /*  192846 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(192887), // Rule ID 953 //
     /*  192851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192868 */     // MIs[0] rs1
     /*  192868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192880 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192885 */     GIR_RootConstrainSelectedInstOperands,
     /*  192886 */     // GIR_Coverage, 953,
     /*  192886 */     GIR_Done,
     /*  192887 */   // Label 3792: @192887
     /*  192887 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(192928), // Rule ID 955 //
     /*  192892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192909 */     // MIs[0] rs1
     /*  192909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192921 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192926 */     GIR_RootConstrainSelectedInstOperands,
     /*  192927 */     // GIR_Coverage, 955,
     /*  192927 */     GIR_Done,
     /*  192928 */   // Label 3793: @192928
     /*  192928 */   GIM_Reject,
     /*  192929 */ // Label 3753: @192929
     /*  192929 */ GIM_Reject,
     /*  192930 */ // Label 3721: @192930
     /*  192930 */ GIM_Reject,
     /*  192931 */ // Label 31: @192931
     /*  192931 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3796*/ GIMT_Encode4(195840),
     /*  192942 */ /*GILLT_s32*//*Label 3794*/ GIMT_Encode4(192950),
     /*  192946 */ /*GILLT_s64*//*Label 3795*/ GIMT_Encode4(194190),
     /*  192950 */ // Label 3794: @192950
     /*  192950 */ GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(194189),
     /*  192955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  192958 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(192999), // Rule ID 430 //
     /*  192963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  192966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192980 */     // MIs[0] rs1
     /*  192980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192992 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  192997 */     GIR_RootConstrainSelectedInstOperands,
     /*  192998 */     // GIR_Coverage, 430,
     /*  192998 */     GIR_Done,
     /*  192999 */   // Label 3798: @192999
     /*  192999 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(193040), // Rule ID 432 //
     /*  193004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193021 */     // MIs[0] rs1
     /*  193021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193033 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  193038 */     GIR_RootConstrainSelectedInstOperands,
     /*  193039 */     // GIR_Coverage, 432,
     /*  193039 */     GIR_Done,
     /*  193040 */   // Label 3799: @193040
     /*  193040 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(193081), // Rule ID 434 //
     /*  193045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193062 */     // MIs[0] rs1
     /*  193062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193074 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  193079 */     GIR_RootConstrainSelectedInstOperands,
     /*  193080 */     // GIR_Coverage, 434,
     /*  193080 */     GIR_Done,
     /*  193081 */   // Label 3800: @193081
     /*  193081 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(193122), // Rule ID 436 //
     /*  193086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193103 */     // MIs[0] rs1
     /*  193103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193115 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193120 */     GIR_RootConstrainSelectedInstOperands,
     /*  193121 */     // GIR_Coverage, 436,
     /*  193121 */     GIR_Done,
     /*  193122 */   // Label 3801: @193122
     /*  193122 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(193163), // Rule ID 438 //
     /*  193127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  193130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193144 */     // MIs[0] rs1
     /*  193144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193156 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193161 */     GIR_RootConstrainSelectedInstOperands,
     /*  193162 */     // GIR_Coverage, 438,
     /*  193162 */     GIR_Done,
     /*  193163 */   // Label 3802: @193163
     /*  193163 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(193204), // Rule ID 440 //
     /*  193168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193185 */     // MIs[0] rs1
     /*  193185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193197 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193202 */     GIR_RootConstrainSelectedInstOperands,
     /*  193203 */     // GIR_Coverage, 440,
     /*  193203 */     GIR_Done,
     /*  193204 */   // Label 3803: @193204
     /*  193204 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(193245), // Rule ID 442 //
     /*  193209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193212 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193219 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193226 */     // MIs[0] rs1
     /*  193226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193238 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193243 */     GIR_RootConstrainSelectedInstOperands,
     /*  193244 */     // GIR_Coverage, 442,
     /*  193244 */     GIR_Done,
     /*  193245 */   // Label 3804: @193245
     /*  193245 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(193286), // Rule ID 444 //
     /*  193250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193267 */     // MIs[0] rs1
     /*  193267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193279 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193284 */     GIR_RootConstrainSelectedInstOperands,
     /*  193285 */     // GIR_Coverage, 444,
     /*  193285 */     GIR_Done,
     /*  193286 */   // Label 3805: @193286
     /*  193286 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(193327), // Rule ID 446 //
     /*  193291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193308 */     // MIs[0] rs1
     /*  193308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193320 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193325 */     GIR_RootConstrainSelectedInstOperands,
     /*  193326 */     // GIR_Coverage, 446,
     /*  193326 */     GIR_Done,
     /*  193327 */   // Label 3806: @193327
     /*  193327 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(193368), // Rule ID 448 //
     /*  193332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  193335 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193349 */     // MIs[0] rs1
     /*  193349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193361 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193366 */     GIR_RootConstrainSelectedInstOperands,
     /*  193367 */     // GIR_Coverage, 448,
     /*  193367 */     GIR_Done,
     /*  193368 */   // Label 3807: @193368
     /*  193368 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(193409), // Rule ID 778 //
     /*  193373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193390 */     // MIs[0] rs1
     /*  193390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193402 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193407 */     GIR_RootConstrainSelectedInstOperands,
     /*  193408 */     // GIR_Coverage, 778,
     /*  193408 */     GIR_Done,
     /*  193409 */   // Label 3808: @193409
     /*  193409 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(193450), // Rule ID 780 //
     /*  193414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193431 */     // MIs[0] rs1
     /*  193431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193443 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  193448 */     GIR_RootConstrainSelectedInstOperands,
     /*  193449 */     // GIR_Coverage, 780,
     /*  193449 */     GIR_Done,
     /*  193450 */   // Label 3809: @193450
     /*  193450 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(193491), // Rule ID 782 //
     /*  193455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193472 */     // MIs[0] rs1
     /*  193472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193484 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  193489 */     GIR_RootConstrainSelectedInstOperands,
     /*  193490 */     // GIR_Coverage, 782,
     /*  193490 */     GIR_Done,
     /*  193491 */   // Label 3810: @193491
     /*  193491 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(193532), // Rule ID 784 //
     /*  193496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193513 */     // MIs[0] rs1
     /*  193513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193525 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  193530 */     GIR_RootConstrainSelectedInstOperands,
     /*  193531 */     // GIR_Coverage, 784,
     /*  193531 */     GIR_Done,
     /*  193532 */   // Label 3811: @193532
     /*  193532 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(193573), // Rule ID 786 //
     /*  193537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193554 */     // MIs[0] rs1
     /*  193554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193566 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  193571 */     GIR_RootConstrainSelectedInstOperands,
     /*  193572 */     // GIR_Coverage, 786,
     /*  193572 */     GIR_Done,
     /*  193573 */   // Label 3812: @193573
     /*  193573 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(193614), // Rule ID 788 //
     /*  193578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193595 */     // MIs[0] rs1
     /*  193595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193607 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193612 */     GIR_RootConstrainSelectedInstOperands,
     /*  193613 */     // GIR_Coverage, 788,
     /*  193613 */     GIR_Done,
     /*  193614 */   // Label 3813: @193614
     /*  193614 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(193655), // Rule ID 790 //
     /*  193619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193636 */     // MIs[0] rs1
     /*  193636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193648 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193653 */     GIR_RootConstrainSelectedInstOperands,
     /*  193654 */     // GIR_Coverage, 790,
     /*  193654 */     GIR_Done,
     /*  193655 */   // Label 3814: @193655
     /*  193655 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(193696), // Rule ID 792 //
     /*  193660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193677 */     // MIs[0] rs1
     /*  193677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193689 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193694 */     GIR_RootConstrainSelectedInstOperands,
     /*  193695 */     // GIR_Coverage, 792,
     /*  193695 */     GIR_Done,
     /*  193696 */   // Label 3815: @193696
     /*  193696 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(193737), // Rule ID 794 //
     /*  193701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193718 */     // MIs[0] rs1
     /*  193718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193730 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193735 */     GIR_RootConstrainSelectedInstOperands,
     /*  193736 */     // GIR_Coverage, 794,
     /*  193736 */     GIR_Done,
     /*  193737 */   // Label 3816: @193737
     /*  193737 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(193778), // Rule ID 796 //
     /*  193742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193759 */     // MIs[0] rs1
     /*  193759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193771 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193776 */     GIR_RootConstrainSelectedInstOperands,
     /*  193777 */     // GIR_Coverage, 796,
     /*  193777 */     GIR_Done,
     /*  193778 */   // Label 3817: @193778
     /*  193778 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(193819), // Rule ID 958 //
     /*  193783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193800 */     // MIs[0] rs1
     /*  193800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193812 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  193817 */     GIR_RootConstrainSelectedInstOperands,
     /*  193818 */     // GIR_Coverage, 958,
     /*  193818 */     GIR_Done,
     /*  193819 */   // Label 3818: @193819
     /*  193819 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(193860), // Rule ID 960 //
     /*  193824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193841 */     // MIs[0] rs1
     /*  193841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193853 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  193858 */     GIR_RootConstrainSelectedInstOperands,
     /*  193859 */     // GIR_Coverage, 960,
     /*  193859 */     GIR_Done,
     /*  193860 */   // Label 3819: @193860
     /*  193860 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(193901), // Rule ID 962 //
     /*  193865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193882 */     // MIs[0] rs1
     /*  193882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193894 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  193899 */     GIR_RootConstrainSelectedInstOperands,
     /*  193900 */     // GIR_Coverage, 962,
     /*  193900 */     GIR_Done,
     /*  193901 */   // Label 3820: @193901
     /*  193901 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(193942), // Rule ID 964 //
     /*  193906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193923 */     // MIs[0] rs1
     /*  193923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193935 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  193940 */     GIR_RootConstrainSelectedInstOperands,
     /*  193941 */     // GIR_Coverage, 964,
     /*  193941 */     GIR_Done,
     /*  193942 */   // Label 3821: @193942
     /*  193942 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(193983), // Rule ID 966 //
     /*  193947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193964 */     // MIs[0] rs1
     /*  193964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193976 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  193981 */     GIR_RootConstrainSelectedInstOperands,
     /*  193982 */     // GIR_Coverage, 966,
     /*  193982 */     GIR_Done,
     /*  193983 */   // Label 3822: @193983
     /*  193983 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(194024), // Rule ID 968 //
     /*  193988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194005 */     // MIs[0] rs1
     /*  194005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194017 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194022 */     GIR_RootConstrainSelectedInstOperands,
     /*  194023 */     // GIR_Coverage, 968,
     /*  194023 */     GIR_Done,
     /*  194024 */   // Label 3823: @194024
     /*  194024 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(194065), // Rule ID 970 //
     /*  194029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194046 */     // MIs[0] rs1
     /*  194046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194058 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194063 */     GIR_RootConstrainSelectedInstOperands,
     /*  194064 */     // GIR_Coverage, 970,
     /*  194064 */     GIR_Done,
     /*  194065 */   // Label 3824: @194065
     /*  194065 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(194106), // Rule ID 972 //
     /*  194070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194087 */     // MIs[0] rs1
     /*  194087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194099 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194104 */     GIR_RootConstrainSelectedInstOperands,
     /*  194105 */     // GIR_Coverage, 972,
     /*  194105 */     GIR_Done,
     /*  194106 */   // Label 3825: @194106
     /*  194106 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(194147), // Rule ID 974 //
     /*  194111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194128 */     // MIs[0] rs1
     /*  194128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194140 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194145 */     GIR_RootConstrainSelectedInstOperands,
     /*  194146 */     // GIR_Coverage, 974,
     /*  194146 */     GIR_Done,
     /*  194147 */   // Label 3826: @194147
     /*  194147 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(194188), // Rule ID 976 //
     /*  194152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  194155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194169 */     // MIs[0] rs1
     /*  194169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  194173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194181 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  194181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194186 */     GIR_RootConstrainSelectedInstOperands,
     /*  194187 */     // GIR_Coverage, 976,
     /*  194187 */     GIR_Done,
     /*  194188 */   // Label 3827: @194188
     /*  194188 */   GIM_Reject,
     /*  194189 */ // Label 3797: @194189
     /*  194189 */ GIM_Reject,
     /*  194190 */ // Label 3795: @194190
     /*  194190 */ GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(195839),
     /*  194195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  194198 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(194239), // Rule ID 429 //
     /*  194203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194206 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194213 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194220 */     // MIs[0] rs1
     /*  194220 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194232 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194237 */     GIR_RootConstrainSelectedInstOperands,
     /*  194238 */     // GIR_Coverage, 429,
     /*  194238 */     GIR_Done,
     /*  194239 */   // Label 3829: @194239
     /*  194239 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(194280), // Rule ID 431 //
     /*  194244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194247 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194254 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194261 */     // MIs[0] rs1
     /*  194261 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194273 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  194278 */     GIR_RootConstrainSelectedInstOperands,
     /*  194279 */     // GIR_Coverage, 431,
     /*  194279 */     GIR_Done,
     /*  194280 */   // Label 3830: @194280
     /*  194280 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(194321), // Rule ID 433 //
     /*  194285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194288 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194295 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194302 */     // MIs[0] rs1
     /*  194302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194314 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  194319 */     GIR_RootConstrainSelectedInstOperands,
     /*  194320 */     // GIR_Coverage, 433,
     /*  194320 */     GIR_Done,
     /*  194321 */   // Label 3831: @194321
     /*  194321 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(194362), // Rule ID 435 //
     /*  194326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194329 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194336 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194343 */     // MIs[0] rs1
     /*  194343 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194355 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  194360 */     GIR_RootConstrainSelectedInstOperands,
     /*  194361 */     // GIR_Coverage, 435,
     /*  194361 */     GIR_Done,
     /*  194362 */   // Label 3832: @194362
     /*  194362 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(194403), // Rule ID 437 //
     /*  194367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  194370 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194377 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194384 */     // MIs[0] rs1
     /*  194384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194396 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  194401 */     GIR_RootConstrainSelectedInstOperands,
     /*  194402 */     // GIR_Coverage, 437,
     /*  194402 */     GIR_Done,
     /*  194403 */   // Label 3833: @194403
     /*  194403 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(194444), // Rule ID 439 //
     /*  194408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194411 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194425 */     // MIs[0] rs1
     /*  194425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194437 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194442 */     GIR_RootConstrainSelectedInstOperands,
     /*  194443 */     // GIR_Coverage, 439,
     /*  194443 */     GIR_Done,
     /*  194444 */   // Label 3834: @194444
     /*  194444 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(194485), // Rule ID 441 //
     /*  194449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194452 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194459 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194466 */     // MIs[0] rs1
     /*  194466 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194478 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194483 */     GIR_RootConstrainSelectedInstOperands,
     /*  194484 */     // GIR_Coverage, 441,
     /*  194484 */     GIR_Done,
     /*  194485 */   // Label 3835: @194485
     /*  194485 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(194526), // Rule ID 443 //
     /*  194490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194500 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194507 */     // MIs[0] rs1
     /*  194507 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194519 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194524 */     GIR_RootConstrainSelectedInstOperands,
     /*  194525 */     // GIR_Coverage, 443,
     /*  194525 */     GIR_Done,
     /*  194526 */   // Label 3836: @194526
     /*  194526 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(194567), // Rule ID 445 //
     /*  194531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194548 */     // MIs[0] rs1
     /*  194548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194560 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194565 */     GIR_RootConstrainSelectedInstOperands,
     /*  194566 */     // GIR_Coverage, 445,
     /*  194566 */     GIR_Done,
     /*  194567 */   // Label 3837: @194567
     /*  194567 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(194608), // Rule ID 447 //
     /*  194572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194575 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194582 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194589 */     // MIs[0] rs1
     /*  194589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194601 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194601 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194606 */     GIR_RootConstrainSelectedInstOperands,
     /*  194607 */     // GIR_Coverage, 447,
     /*  194607 */     GIR_Done,
     /*  194608 */   // Label 3838: @194608
     /*  194608 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(194649), // Rule ID 569 //
     /*  194613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194616 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194623 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194630 */     // MIs[0] rs1
     /*  194630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194642 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194647 */     GIR_RootConstrainSelectedInstOperands,
     /*  194648 */     // GIR_Coverage, 569,
     /*  194648 */     GIR_Done,
     /*  194649 */   // Label 3839: @194649
     /*  194649 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(194690), // Rule ID 570 //
     /*  194654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194657 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194664 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194671 */     // MIs[0] rs1
     /*  194671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194683 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ),
     /*  194688 */     GIR_RootConstrainSelectedInstOperands,
     /*  194689 */     // GIR_Coverage, 570,
     /*  194689 */     GIR_Done,
     /*  194690 */   // Label 3840: @194690
     /*  194690 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(194731), // Rule ID 571 //
     /*  194695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194712 */     // MIs[0] rs1
     /*  194712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194724 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_RL),
     /*  194729 */     GIR_RootConstrainSelectedInstOperands,
     /*  194730 */     // GIR_Coverage, 571,
     /*  194730 */     GIR_Done,
     /*  194731 */   // Label 3841: @194731
     /*  194731 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(194772), // Rule ID 572 //
     /*  194736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194739 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194746 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194753 */     // MIs[0] rs1
     /*  194753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194765 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  194770 */     GIR_RootConstrainSelectedInstOperands,
     /*  194771 */     // GIR_Coverage, 572,
     /*  194771 */     GIR_Done,
     /*  194772 */   // Label 3842: @194772
     /*  194772 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(194813), // Rule ID 573 //
     /*  194777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194794 */     // MIs[0] rs1
     /*  194794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194806 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  194811 */     GIR_RootConstrainSelectedInstOperands,
     /*  194812 */     // GIR_Coverage, 573,
     /*  194812 */     GIR_Done,
     /*  194813 */   // Label 3843: @194813
     /*  194813 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(194854), // Rule ID 574 //
     /*  194818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194835 */     // MIs[0] rs1
     /*  194835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194847 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194852 */     GIR_RootConstrainSelectedInstOperands,
     /*  194853 */     // GIR_Coverage, 574,
     /*  194853 */     GIR_Done,
     /*  194854 */   // Label 3844: @194854
     /*  194854 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(194895), // Rule ID 575 //
     /*  194859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194862 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194869 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194876 */     // MIs[0] rs1
     /*  194876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194888 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194893 */     GIR_RootConstrainSelectedInstOperands,
     /*  194894 */     // GIR_Coverage, 575,
     /*  194894 */     GIR_Done,
     /*  194895 */   // Label 3845: @194895
     /*  194895 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(194936), // Rule ID 576 //
     /*  194900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194917 */     // MIs[0] rs1
     /*  194917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194929 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194934 */     GIR_RootConstrainSelectedInstOperands,
     /*  194935 */     // GIR_Coverage, 576,
     /*  194935 */     GIR_Done,
     /*  194936 */   // Label 3846: @194936
     /*  194936 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(194977), // Rule ID 577 //
     /*  194941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194951 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194958 */     // MIs[0] rs1
     /*  194958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194970 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194975 */     GIR_RootConstrainSelectedInstOperands,
     /*  194976 */     // GIR_Coverage, 577,
     /*  194976 */     GIR_Done,
     /*  194977 */   // Label 3847: @194977
     /*  194977 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(195018), // Rule ID 578 //
     /*  194982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194999 */     // MIs[0] rs1
     /*  194999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195011 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  195016 */     GIR_RootConstrainSelectedInstOperands,
     /*  195017 */     // GIR_Coverage, 578,
     /*  195017 */     GIR_Done,
     /*  195018 */   // Label 3848: @195018
     /*  195018 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(195059), // Rule ID 777 //
     /*  195023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195040 */     // MIs[0] rs1
     /*  195040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195052 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195057 */     GIR_RootConstrainSelectedInstOperands,
     /*  195058 */     // GIR_Coverage, 777,
     /*  195058 */     GIR_Done,
     /*  195059 */   // Label 3849: @195059
     /*  195059 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(195100), // Rule ID 779 //
     /*  195064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195081 */     // MIs[0] rs1
     /*  195081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195093 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  195098 */     GIR_RootConstrainSelectedInstOperands,
     /*  195099 */     // GIR_Coverage, 779,
     /*  195099 */     GIR_Done,
     /*  195100 */   // Label 3850: @195100
     /*  195100 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(195141), // Rule ID 781 //
     /*  195105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195122 */     // MIs[0] rs1
     /*  195122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195134 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  195139 */     GIR_RootConstrainSelectedInstOperands,
     /*  195140 */     // GIR_Coverage, 781,
     /*  195140 */     GIR_Done,
     /*  195141 */   // Label 3851: @195141
     /*  195141 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(195182), // Rule ID 783 //
     /*  195146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195149 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195163 */     // MIs[0] rs1
     /*  195163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195175 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  195180 */     GIR_RootConstrainSelectedInstOperands,
     /*  195181 */     // GIR_Coverage, 783,
     /*  195181 */     GIR_Done,
     /*  195182 */   // Label 3852: @195182
     /*  195182 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(195223), // Rule ID 785 //
     /*  195187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195204 */     // MIs[0] rs1
     /*  195204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195216 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  195221 */     GIR_RootConstrainSelectedInstOperands,
     /*  195222 */     // GIR_Coverage, 785,
     /*  195222 */     GIR_Done,
     /*  195223 */   // Label 3853: @195223
     /*  195223 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(195264), // Rule ID 787 //
     /*  195228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195245 */     // MIs[0] rs1
     /*  195245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195257 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195262 */     GIR_RootConstrainSelectedInstOperands,
     /*  195263 */     // GIR_Coverage, 787,
     /*  195263 */     GIR_Done,
     /*  195264 */   // Label 3854: @195264
     /*  195264 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(195305), // Rule ID 789 //
     /*  195269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195286 */     // MIs[0] rs1
     /*  195286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195298 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195303 */     GIR_RootConstrainSelectedInstOperands,
     /*  195304 */     // GIR_Coverage, 789,
     /*  195304 */     GIR_Done,
     /*  195305 */   // Label 3855: @195305
     /*  195305 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(195346), // Rule ID 791 //
     /*  195310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195327 */     // MIs[0] rs1
     /*  195327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195339 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195344 */     GIR_RootConstrainSelectedInstOperands,
     /*  195345 */     // GIR_Coverage, 791,
     /*  195345 */     GIR_Done,
     /*  195346 */   // Label 3856: @195346
     /*  195346 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(195387), // Rule ID 793 //
     /*  195351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195368 */     // MIs[0] rs1
     /*  195368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195380 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195385 */     GIR_RootConstrainSelectedInstOperands,
     /*  195386 */     // GIR_Coverage, 793,
     /*  195386 */     GIR_Done,
     /*  195387 */   // Label 3857: @195387
     /*  195387 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(195428), // Rule ID 795 //
     /*  195392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195409 */     // MIs[0] rs1
     /*  195409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195421 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  195426 */     GIR_RootConstrainSelectedInstOperands,
     /*  195427 */     // GIR_Coverage, 795,
     /*  195427 */     GIR_Done,
     /*  195428 */   // Label 3858: @195428
     /*  195428 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(195469), // Rule ID 957 //
     /*  195433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195450 */     // MIs[0] rs1
     /*  195450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195462 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195467 */     GIR_RootConstrainSelectedInstOperands,
     /*  195468 */     // GIR_Coverage, 957,
     /*  195468 */     GIR_Done,
     /*  195469 */   // Label 3859: @195469
     /*  195469 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(195510), // Rule ID 959 //
     /*  195474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195491 */     // MIs[0] rs1
     /*  195491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195503 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  195508 */     GIR_RootConstrainSelectedInstOperands,
     /*  195509 */     // GIR_Coverage, 959,
     /*  195509 */     GIR_Done,
     /*  195510 */   // Label 3860: @195510
     /*  195510 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(195551), // Rule ID 961 //
     /*  195515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195532 */     // MIs[0] rs1
     /*  195532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195544 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  195549 */     GIR_RootConstrainSelectedInstOperands,
     /*  195550 */     // GIR_Coverage, 961,
     /*  195550 */     GIR_Done,
     /*  195551 */   // Label 3861: @195551
     /*  195551 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(195592), // Rule ID 963 //
     /*  195556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195573 */     // MIs[0] rs1
     /*  195573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195585 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  195590 */     GIR_RootConstrainSelectedInstOperands,
     /*  195591 */     // GIR_Coverage, 963,
     /*  195591 */     GIR_Done,
     /*  195592 */   // Label 3862: @195592
     /*  195592 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(195633), // Rule ID 965 //
     /*  195597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195614 */     // MIs[0] rs1
     /*  195614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195626 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  195631 */     GIR_RootConstrainSelectedInstOperands,
     /*  195632 */     // GIR_Coverage, 965,
     /*  195632 */     GIR_Done,
     /*  195633 */   // Label 3863: @195633
     /*  195633 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(195674), // Rule ID 967 //
     /*  195638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195655 */     // MIs[0] rs1
     /*  195655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195667 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195672 */     GIR_RootConstrainSelectedInstOperands,
     /*  195673 */     // GIR_Coverage, 967,
     /*  195673 */     GIR_Done,
     /*  195674 */   // Label 3864: @195674
     /*  195674 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(195715), // Rule ID 969 //
     /*  195679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195696 */     // MIs[0] rs1
     /*  195696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195708 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195713 */     GIR_RootConstrainSelectedInstOperands,
     /*  195714 */     // GIR_Coverage, 969,
     /*  195714 */     GIR_Done,
     /*  195715 */   // Label 3865: @195715
     /*  195715 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(195756), // Rule ID 971 //
     /*  195720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195737 */     // MIs[0] rs1
     /*  195737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195749 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195754 */     GIR_RootConstrainSelectedInstOperands,
     /*  195755 */     // GIR_Coverage, 971,
     /*  195755 */     GIR_Done,
     /*  195756 */   // Label 3866: @195756
     /*  195756 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(195797), // Rule ID 973 //
     /*  195761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195778 */     // MIs[0] rs1
     /*  195778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195790 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195795 */     GIR_RootConstrainSelectedInstOperands,
     /*  195796 */     // GIR_Coverage, 973,
     /*  195796 */     GIR_Done,
     /*  195797 */   // Label 3867: @195797
     /*  195797 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(195838), // Rule ID 975 //
     /*  195802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195819 */     // MIs[0] rs1
     /*  195819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195831 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195836 */     GIR_RootConstrainSelectedInstOperands,
     /*  195837 */     // GIR_Coverage, 975,
     /*  195837 */     GIR_Done,
     /*  195838 */   // Label 3868: @195838
     /*  195838 */   GIM_Reject,
     /*  195839 */ // Label 3828: @195839
     /*  195839 */ GIM_Reject,
     /*  195840 */ // Label 3796: @195840
     /*  195840 */ GIM_Reject,
     /*  195841 */ // Label 32: @195841
     /*  195841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3871*/ GIMT_Encode4(198750),
     /*  195852 */ /*GILLT_s32*//*Label 3869*/ GIMT_Encode4(195860),
     /*  195856 */ /*GILLT_s64*//*Label 3870*/ GIMT_Encode4(197100),
     /*  195860 */ // Label 3869: @195860
     /*  195860 */ GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(197099),
     /*  195865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  195868 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(195909), // Rule ID 450 //
     /*  195873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195890 */     // MIs[0] rs1
     /*  195890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195902 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  195907 */     GIR_RootConstrainSelectedInstOperands,
     /*  195908 */     // GIR_Coverage, 450,
     /*  195908 */     GIR_Done,
     /*  195909 */   // Label 3873: @195909
     /*  195909 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(195950), // Rule ID 452 //
     /*  195914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195931 */     // MIs[0] rs1
     /*  195931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195943 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  195948 */     GIR_RootConstrainSelectedInstOperands,
     /*  195949 */     // GIR_Coverage, 452,
     /*  195949 */     GIR_Done,
     /*  195950 */   // Label 3874: @195950
     /*  195950 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(195991), // Rule ID 454 //
     /*  195955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195972 */     // MIs[0] rs1
     /*  195972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195984 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  195989 */     GIR_RootConstrainSelectedInstOperands,
     /*  195990 */     // GIR_Coverage, 454,
     /*  195990 */     GIR_Done,
     /*  195991 */   // Label 3875: @195991
     /*  195991 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(196032), // Rule ID 456 //
     /*  195996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196013 */     // MIs[0] rs1
     /*  196013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196025 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196030 */     GIR_RootConstrainSelectedInstOperands,
     /*  196031 */     // GIR_Coverage, 456,
     /*  196031 */     GIR_Done,
     /*  196032 */   // Label 3876: @196032
     /*  196032 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(196073), // Rule ID 458 //
     /*  196037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  196040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196054 */     // MIs[0] rs1
     /*  196054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196066 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196071 */     GIR_RootConstrainSelectedInstOperands,
     /*  196072 */     // GIR_Coverage, 458,
     /*  196072 */     GIR_Done,
     /*  196073 */   // Label 3877: @196073
     /*  196073 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(196114), // Rule ID 460 //
     /*  196078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196095 */     // MIs[0] rs1
     /*  196095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196107 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196112 */     GIR_RootConstrainSelectedInstOperands,
     /*  196113 */     // GIR_Coverage, 460,
     /*  196113 */     GIR_Done,
     /*  196114 */   // Label 3878: @196114
     /*  196114 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(196155), // Rule ID 462 //
     /*  196119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196136 */     // MIs[0] rs1
     /*  196136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196148 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196153 */     GIR_RootConstrainSelectedInstOperands,
     /*  196154 */     // GIR_Coverage, 462,
     /*  196154 */     GIR_Done,
     /*  196155 */   // Label 3879: @196155
     /*  196155 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(196196), // Rule ID 464 //
     /*  196160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196177 */     // MIs[0] rs1
     /*  196177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196189 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196194 */     GIR_RootConstrainSelectedInstOperands,
     /*  196195 */     // GIR_Coverage, 464,
     /*  196195 */     GIR_Done,
     /*  196196 */   // Label 3880: @196196
     /*  196196 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(196237), // Rule ID 466 //
     /*  196201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196218 */     // MIs[0] rs1
     /*  196218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196230 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196235 */     GIR_RootConstrainSelectedInstOperands,
     /*  196236 */     // GIR_Coverage, 466,
     /*  196236 */     GIR_Done,
     /*  196237 */   // Label 3881: @196237
     /*  196237 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(196278), // Rule ID 468 //
     /*  196242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  196245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196259 */     // MIs[0] rs1
     /*  196259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196271 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196276 */     GIR_RootConstrainSelectedInstOperands,
     /*  196277 */     // GIR_Coverage, 468,
     /*  196277 */     GIR_Done,
     /*  196278 */   // Label 3882: @196278
     /*  196278 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(196319), // Rule ID 798 //
     /*  196283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196300 */     // MIs[0] rs1
     /*  196300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196312 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196317 */     GIR_RootConstrainSelectedInstOperands,
     /*  196318 */     // GIR_Coverage, 798,
     /*  196318 */     GIR_Done,
     /*  196319 */   // Label 3883: @196319
     /*  196319 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(196360), // Rule ID 800 //
     /*  196324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196341 */     // MIs[0] rs1
     /*  196341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196353 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  196358 */     GIR_RootConstrainSelectedInstOperands,
     /*  196359 */     // GIR_Coverage, 800,
     /*  196359 */     GIR_Done,
     /*  196360 */   // Label 3884: @196360
     /*  196360 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(196401), // Rule ID 802 //
     /*  196365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196382 */     // MIs[0] rs1
     /*  196382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196394 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  196399 */     GIR_RootConstrainSelectedInstOperands,
     /*  196400 */     // GIR_Coverage, 802,
     /*  196400 */     GIR_Done,
     /*  196401 */   // Label 3885: @196401
     /*  196401 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(196442), // Rule ID 804 //
     /*  196406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196423 */     // MIs[0] rs1
     /*  196423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196435 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  196440 */     GIR_RootConstrainSelectedInstOperands,
     /*  196441 */     // GIR_Coverage, 804,
     /*  196441 */     GIR_Done,
     /*  196442 */   // Label 3886: @196442
     /*  196442 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(196483), // Rule ID 806 //
     /*  196447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196464 */     // MIs[0] rs1
     /*  196464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196476 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  196481 */     GIR_RootConstrainSelectedInstOperands,
     /*  196482 */     // GIR_Coverage, 806,
     /*  196482 */     GIR_Done,
     /*  196483 */   // Label 3887: @196483
     /*  196483 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(196524), // Rule ID 808 //
     /*  196488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196505 */     // MIs[0] rs1
     /*  196505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196517 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196522 */     GIR_RootConstrainSelectedInstOperands,
     /*  196523 */     // GIR_Coverage, 808,
     /*  196523 */     GIR_Done,
     /*  196524 */   // Label 3888: @196524
     /*  196524 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(196565), // Rule ID 810 //
     /*  196529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196546 */     // MIs[0] rs1
     /*  196546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196558 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196563 */     GIR_RootConstrainSelectedInstOperands,
     /*  196564 */     // GIR_Coverage, 810,
     /*  196564 */     GIR_Done,
     /*  196565 */   // Label 3889: @196565
     /*  196565 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(196606), // Rule ID 812 //
     /*  196570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196587 */     // MIs[0] rs1
     /*  196587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196599 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196604 */     GIR_RootConstrainSelectedInstOperands,
     /*  196605 */     // GIR_Coverage, 812,
     /*  196605 */     GIR_Done,
     /*  196606 */   // Label 3890: @196606
     /*  196606 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(196647), // Rule ID 814 //
     /*  196611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196628 */     // MIs[0] rs1
     /*  196628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196640 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196645 */     GIR_RootConstrainSelectedInstOperands,
     /*  196646 */     // GIR_Coverage, 814,
     /*  196646 */     GIR_Done,
     /*  196647 */   // Label 3891: @196647
     /*  196647 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(196688), // Rule ID 816 //
     /*  196652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196669 */     // MIs[0] rs1
     /*  196669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196681 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196686 */     GIR_RootConstrainSelectedInstOperands,
     /*  196687 */     // GIR_Coverage, 816,
     /*  196687 */     GIR_Done,
     /*  196688 */   // Label 3892: @196688
     /*  196688 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(196729), // Rule ID 978 //
     /*  196693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196710 */     // MIs[0] rs1
     /*  196710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196722 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196727 */     GIR_RootConstrainSelectedInstOperands,
     /*  196728 */     // GIR_Coverage, 978,
     /*  196728 */     GIR_Done,
     /*  196729 */   // Label 3893: @196729
     /*  196729 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(196770), // Rule ID 980 //
     /*  196734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196751 */     // MIs[0] rs1
     /*  196751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196763 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  196768 */     GIR_RootConstrainSelectedInstOperands,
     /*  196769 */     // GIR_Coverage, 980,
     /*  196769 */     GIR_Done,
     /*  196770 */   // Label 3894: @196770
     /*  196770 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(196811), // Rule ID 982 //
     /*  196775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196792 */     // MIs[0] rs1
     /*  196792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196804 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  196809 */     GIR_RootConstrainSelectedInstOperands,
     /*  196810 */     // GIR_Coverage, 982,
     /*  196810 */     GIR_Done,
     /*  196811 */   // Label 3895: @196811
     /*  196811 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(196852), // Rule ID 984 //
     /*  196816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196833 */     // MIs[0] rs1
     /*  196833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196845 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  196850 */     GIR_RootConstrainSelectedInstOperands,
     /*  196851 */     // GIR_Coverage, 984,
     /*  196851 */     GIR_Done,
     /*  196852 */   // Label 3896: @196852
     /*  196852 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(196893), // Rule ID 986 //
     /*  196857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196874 */     // MIs[0] rs1
     /*  196874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196886 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  196891 */     GIR_RootConstrainSelectedInstOperands,
     /*  196892 */     // GIR_Coverage, 986,
     /*  196892 */     GIR_Done,
     /*  196893 */   // Label 3897: @196893
     /*  196893 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(196934), // Rule ID 988 //
     /*  196898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196915 */     // MIs[0] rs1
     /*  196915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196927 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196932 */     GIR_RootConstrainSelectedInstOperands,
     /*  196933 */     // GIR_Coverage, 988,
     /*  196933 */     GIR_Done,
     /*  196934 */   // Label 3898: @196934
     /*  196934 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(196975), // Rule ID 990 //
     /*  196939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196956 */     // MIs[0] rs1
     /*  196956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196968 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196973 */     GIR_RootConstrainSelectedInstOperands,
     /*  196974 */     // GIR_Coverage, 990,
     /*  196974 */     GIR_Done,
     /*  196975 */   // Label 3899: @196975
     /*  196975 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(197016), // Rule ID 992 //
     /*  196980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196997 */     // MIs[0] rs1
     /*  196997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197009 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197014 */     GIR_RootConstrainSelectedInstOperands,
     /*  197015 */     // GIR_Coverage, 992,
     /*  197015 */     GIR_Done,
     /*  197016 */   // Label 3900: @197016
     /*  197016 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(197057), // Rule ID 994 //
     /*  197021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197038 */     // MIs[0] rs1
     /*  197038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197050 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197055 */     GIR_RootConstrainSelectedInstOperands,
     /*  197056 */     // GIR_Coverage, 994,
     /*  197056 */     GIR_Done,
     /*  197057 */   // Label 3901: @197057
     /*  197057 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(197098), // Rule ID 996 //
     /*  197062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  197065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197079 */     // MIs[0] rs1
     /*  197079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  197083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197091 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  197091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197096 */     GIR_RootConstrainSelectedInstOperands,
     /*  197097 */     // GIR_Coverage, 996,
     /*  197097 */     GIR_Done,
     /*  197098 */   // Label 3902: @197098
     /*  197098 */   GIM_Reject,
     /*  197099 */ // Label 3872: @197099
     /*  197099 */ GIM_Reject,
     /*  197100 */ // Label 3870: @197100
     /*  197100 */ GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(198749),
     /*  197105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  197108 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(197149), // Rule ID 449 //
     /*  197113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197130 */     // MIs[0] rs1
     /*  197130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197142 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197147 */     GIR_RootConstrainSelectedInstOperands,
     /*  197148 */     // GIR_Coverage, 449,
     /*  197148 */     GIR_Done,
     /*  197149 */   // Label 3904: @197149
     /*  197149 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(197190), // Rule ID 451 //
     /*  197154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197171 */     // MIs[0] rs1
     /*  197171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197183 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  197188 */     GIR_RootConstrainSelectedInstOperands,
     /*  197189 */     // GIR_Coverage, 451,
     /*  197189 */     GIR_Done,
     /*  197190 */   // Label 3905: @197190
     /*  197190 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(197231), // Rule ID 453 //
     /*  197195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197212 */     // MIs[0] rs1
     /*  197212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197224 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  197229 */     GIR_RootConstrainSelectedInstOperands,
     /*  197230 */     // GIR_Coverage, 453,
     /*  197230 */     GIR_Done,
     /*  197231 */   // Label 3906: @197231
     /*  197231 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(197272), // Rule ID 455 //
     /*  197236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197239 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197253 */     // MIs[0] rs1
     /*  197253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197265 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  197270 */     GIR_RootConstrainSelectedInstOperands,
     /*  197271 */     // GIR_Coverage, 455,
     /*  197271 */     GIR_Done,
     /*  197272 */   // Label 3907: @197272
     /*  197272 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(197313), // Rule ID 457 //
     /*  197277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  197280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197294 */     // MIs[0] rs1
     /*  197294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197306 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  197311 */     GIR_RootConstrainSelectedInstOperands,
     /*  197312 */     // GIR_Coverage, 457,
     /*  197312 */     GIR_Done,
     /*  197313 */   // Label 3908: @197313
     /*  197313 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(197354), // Rule ID 459 //
     /*  197318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197335 */     // MIs[0] rs1
     /*  197335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197347 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197352 */     GIR_RootConstrainSelectedInstOperands,
     /*  197353 */     // GIR_Coverage, 459,
     /*  197353 */     GIR_Done,
     /*  197354 */   // Label 3909: @197354
     /*  197354 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(197395), // Rule ID 461 //
     /*  197359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197376 */     // MIs[0] rs1
     /*  197376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197388 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197393 */     GIR_RootConstrainSelectedInstOperands,
     /*  197394 */     // GIR_Coverage, 461,
     /*  197394 */     GIR_Done,
     /*  197395 */   // Label 3910: @197395
     /*  197395 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(197436), // Rule ID 463 //
     /*  197400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197417 */     // MIs[0] rs1
     /*  197417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197429 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197434 */     GIR_RootConstrainSelectedInstOperands,
     /*  197435 */     // GIR_Coverage, 463,
     /*  197435 */     GIR_Done,
     /*  197436 */   // Label 3911: @197436
     /*  197436 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(197477), // Rule ID 465 //
     /*  197441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197458 */     // MIs[0] rs1
     /*  197458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197470 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197475 */     GIR_RootConstrainSelectedInstOperands,
     /*  197476 */     // GIR_Coverage, 465,
     /*  197476 */     GIR_Done,
     /*  197477 */   // Label 3912: @197477
     /*  197477 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(197518), // Rule ID 467 //
     /*  197482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  197485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  197492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197499 */     // MIs[0] rs1
     /*  197499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197511 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197516 */     GIR_RootConstrainSelectedInstOperands,
     /*  197517 */     // GIR_Coverage, 467,
     /*  197517 */     GIR_Done,
     /*  197518 */   // Label 3913: @197518
     /*  197518 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(197559), // Rule ID 579 //
     /*  197523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197540 */     // MIs[0] rs1
     /*  197540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197552 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197557 */     GIR_RootConstrainSelectedInstOperands,
     /*  197558 */     // GIR_Coverage, 579,
     /*  197558 */     GIR_Done,
     /*  197559 */   // Label 3914: @197559
     /*  197559 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(197600), // Rule ID 580 //
     /*  197564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197581 */     // MIs[0] rs1
     /*  197581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197593 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ),
     /*  197598 */     GIR_RootConstrainSelectedInstOperands,
     /*  197599 */     // GIR_Coverage, 580,
     /*  197599 */     GIR_Done,
     /*  197600 */   // Label 3915: @197600
     /*  197600 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(197641), // Rule ID 581 //
     /*  197605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197622 */     // MIs[0] rs1
     /*  197622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197634 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_RL),
     /*  197639 */     GIR_RootConstrainSelectedInstOperands,
     /*  197640 */     // GIR_Coverage, 581,
     /*  197640 */     GIR_Done,
     /*  197641 */   // Label 3916: @197641
     /*  197641 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(197682), // Rule ID 582 //
     /*  197646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197663 */     // MIs[0] rs1
     /*  197663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197675 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  197680 */     GIR_RootConstrainSelectedInstOperands,
     /*  197681 */     // GIR_Coverage, 582,
     /*  197681 */     GIR_Done,
     /*  197682 */   // Label 3917: @197682
     /*  197682 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(197723), // Rule ID 583 //
     /*  197687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197704 */     // MIs[0] rs1
     /*  197704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197716 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  197721 */     GIR_RootConstrainSelectedInstOperands,
     /*  197722 */     // GIR_Coverage, 583,
     /*  197722 */     GIR_Done,
     /*  197723 */   // Label 3918: @197723
     /*  197723 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(197764), // Rule ID 584 //
     /*  197728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197745 */     // MIs[0] rs1
     /*  197745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197757 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197762 */     GIR_RootConstrainSelectedInstOperands,
     /*  197763 */     // GIR_Coverage, 584,
     /*  197763 */     GIR_Done,
     /*  197764 */   // Label 3919: @197764
     /*  197764 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(197805), // Rule ID 585 //
     /*  197769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197786 */     // MIs[0] rs1
     /*  197786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197798 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197803 */     GIR_RootConstrainSelectedInstOperands,
     /*  197804 */     // GIR_Coverage, 585,
     /*  197804 */     GIR_Done,
     /*  197805 */   // Label 3920: @197805
     /*  197805 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(197846), // Rule ID 586 //
     /*  197810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197827 */     // MIs[0] rs1
     /*  197827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197839 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197844 */     GIR_RootConstrainSelectedInstOperands,
     /*  197845 */     // GIR_Coverage, 586,
     /*  197845 */     GIR_Done,
     /*  197846 */   // Label 3921: @197846
     /*  197846 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(197887), // Rule ID 587 //
     /*  197851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197868 */     // MIs[0] rs1
     /*  197868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197880 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197885 */     GIR_RootConstrainSelectedInstOperands,
     /*  197886 */     // GIR_Coverage, 587,
     /*  197886 */     GIR_Done,
     /*  197887 */   // Label 3922: @197887
     /*  197887 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(197928), // Rule ID 588 //
     /*  197892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197909 */     // MIs[0] rs1
     /*  197909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197921 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197926 */     GIR_RootConstrainSelectedInstOperands,
     /*  197927 */     // GIR_Coverage, 588,
     /*  197927 */     GIR_Done,
     /*  197928 */   // Label 3923: @197928
     /*  197928 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(197969), // Rule ID 797 //
     /*  197933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197950 */     // MIs[0] rs1
     /*  197950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197962 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197967 */     GIR_RootConstrainSelectedInstOperands,
     /*  197968 */     // GIR_Coverage, 797,
     /*  197968 */     GIR_Done,
     /*  197969 */   // Label 3924: @197969
     /*  197969 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(198010), // Rule ID 799 //
     /*  197974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197991 */     // MIs[0] rs1
     /*  197991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198003 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  198008 */     GIR_RootConstrainSelectedInstOperands,
     /*  198009 */     // GIR_Coverage, 799,
     /*  198009 */     GIR_Done,
     /*  198010 */   // Label 3925: @198010
     /*  198010 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(198051), // Rule ID 801 //
     /*  198015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198032 */     // MIs[0] rs1
     /*  198032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198044 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  198049 */     GIR_RootConstrainSelectedInstOperands,
     /*  198050 */     // GIR_Coverage, 801,
     /*  198050 */     GIR_Done,
     /*  198051 */   // Label 3926: @198051
     /*  198051 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(198092), // Rule ID 803 //
     /*  198056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198073 */     // MIs[0] rs1
     /*  198073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198085 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  198090 */     GIR_RootConstrainSelectedInstOperands,
     /*  198091 */     // GIR_Coverage, 803,
     /*  198091 */     GIR_Done,
     /*  198092 */   // Label 3927: @198092
     /*  198092 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(198133), // Rule ID 805 //
     /*  198097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198114 */     // MIs[0] rs1
     /*  198114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198126 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  198131 */     GIR_RootConstrainSelectedInstOperands,
     /*  198132 */     // GIR_Coverage, 805,
     /*  198132 */     GIR_Done,
     /*  198133 */   // Label 3928: @198133
     /*  198133 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(198174), // Rule ID 807 //
     /*  198138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198155 */     // MIs[0] rs1
     /*  198155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198167 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198172 */     GIR_RootConstrainSelectedInstOperands,
     /*  198173 */     // GIR_Coverage, 807,
     /*  198173 */     GIR_Done,
     /*  198174 */   // Label 3929: @198174
     /*  198174 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(198215), // Rule ID 809 //
     /*  198179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198196 */     // MIs[0] rs1
     /*  198196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198208 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198213 */     GIR_RootConstrainSelectedInstOperands,
     /*  198214 */     // GIR_Coverage, 809,
     /*  198214 */     GIR_Done,
     /*  198215 */   // Label 3930: @198215
     /*  198215 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(198256), // Rule ID 811 //
     /*  198220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198237 */     // MIs[0] rs1
     /*  198237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198249 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198254 */     GIR_RootConstrainSelectedInstOperands,
     /*  198255 */     // GIR_Coverage, 811,
     /*  198255 */     GIR_Done,
     /*  198256 */   // Label 3931: @198256
     /*  198256 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(198297), // Rule ID 813 //
     /*  198261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198278 */     // MIs[0] rs1
     /*  198278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198290 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198295 */     GIR_RootConstrainSelectedInstOperands,
     /*  198296 */     // GIR_Coverage, 813,
     /*  198296 */     GIR_Done,
     /*  198297 */   // Label 3932: @198297
     /*  198297 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(198338), // Rule ID 815 //
     /*  198302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198319 */     // MIs[0] rs1
     /*  198319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198331 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  198336 */     GIR_RootConstrainSelectedInstOperands,
     /*  198337 */     // GIR_Coverage, 815,
     /*  198337 */     GIR_Done,
     /*  198338 */   // Label 3933: @198338
     /*  198338 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(198379), // Rule ID 977 //
     /*  198343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198360 */     // MIs[0] rs1
     /*  198360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198372 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198377 */     GIR_RootConstrainSelectedInstOperands,
     /*  198378 */     // GIR_Coverage, 977,
     /*  198378 */     GIR_Done,
     /*  198379 */   // Label 3934: @198379
     /*  198379 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(198420), // Rule ID 979 //
     /*  198384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198401 */     // MIs[0] rs1
     /*  198401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198413 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  198418 */     GIR_RootConstrainSelectedInstOperands,
     /*  198419 */     // GIR_Coverage, 979,
     /*  198419 */     GIR_Done,
     /*  198420 */   // Label 3935: @198420
     /*  198420 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(198461), // Rule ID 981 //
     /*  198425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198442 */     // MIs[0] rs1
     /*  198442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198454 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  198459 */     GIR_RootConstrainSelectedInstOperands,
     /*  198460 */     // GIR_Coverage, 981,
     /*  198460 */     GIR_Done,
     /*  198461 */   // Label 3936: @198461
     /*  198461 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(198502), // Rule ID 983 //
     /*  198466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198483 */     // MIs[0] rs1
     /*  198483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198495 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  198500 */     GIR_RootConstrainSelectedInstOperands,
     /*  198501 */     // GIR_Coverage, 983,
     /*  198501 */     GIR_Done,
     /*  198502 */   // Label 3937: @198502
     /*  198502 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(198543), // Rule ID 985 //
     /*  198507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198524 */     // MIs[0] rs1
     /*  198524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198536 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  198541 */     GIR_RootConstrainSelectedInstOperands,
     /*  198542 */     // GIR_Coverage, 985,
     /*  198542 */     GIR_Done,
     /*  198543 */   // Label 3938: @198543
     /*  198543 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(198584), // Rule ID 987 //
     /*  198548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198565 */     // MIs[0] rs1
     /*  198565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198577 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198582 */     GIR_RootConstrainSelectedInstOperands,
     /*  198583 */     // GIR_Coverage, 987,
     /*  198583 */     GIR_Done,
     /*  198584 */   // Label 3939: @198584
     /*  198584 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(198625), // Rule ID 989 //
     /*  198589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198606 */     // MIs[0] rs1
     /*  198606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198618 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198623 */     GIR_RootConstrainSelectedInstOperands,
     /*  198624 */     // GIR_Coverage, 989,
     /*  198624 */     GIR_Done,
     /*  198625 */   // Label 3940: @198625
     /*  198625 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(198666), // Rule ID 991 //
     /*  198630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198647 */     // MIs[0] rs1
     /*  198647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198659 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198664 */     GIR_RootConstrainSelectedInstOperands,
     /*  198665 */     // GIR_Coverage, 991,
     /*  198665 */     GIR_Done,
     /*  198666 */   // Label 3941: @198666
     /*  198666 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(198707), // Rule ID 993 //
     /*  198671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198674 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198688 */     // MIs[0] rs1
     /*  198688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198700 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198705 */     GIR_RootConstrainSelectedInstOperands,
     /*  198706 */     // GIR_Coverage, 993,
     /*  198706 */     GIR_Done,
     /*  198707 */   // Label 3942: @198707
     /*  198707 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(198748), // Rule ID 995 //
     /*  198712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198715 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198722 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198729 */     // MIs[0] rs1
     /*  198729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198741 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198746 */     GIR_RootConstrainSelectedInstOperands,
     /*  198747 */     // GIR_Coverage, 995,
     /*  198747 */     GIR_Done,
     /*  198748 */   // Label 3943: @198748
     /*  198748 */   GIM_Reject,
     /*  198749 */ // Label 3903: @198749
     /*  198749 */ GIM_Reject,
     /*  198750 */ // Label 3871: @198750
     /*  198750 */ GIM_Reject,
     /*  198751 */ // Label 33: @198751
     /*  198751 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3946*/ GIMT_Encode4(201660),
     /*  198762 */ /*GILLT_s32*//*Label 3944*/ GIMT_Encode4(198770),
     /*  198766 */ /*GILLT_s64*//*Label 3945*/ GIMT_Encode4(200010),
     /*  198770 */ // Label 3944: @198770
     /*  198770 */ GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(200009),
     /*  198775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  198778 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(198819), // Rule ID 470 //
     /*  198783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198800 */     // MIs[0] rs1
     /*  198800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198812 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  198817 */     GIR_RootConstrainSelectedInstOperands,
     /*  198818 */     // GIR_Coverage, 470,
     /*  198818 */     GIR_Done,
     /*  198819 */   // Label 3948: @198819
     /*  198819 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(198860), // Rule ID 472 //
     /*  198824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198841 */     // MIs[0] rs1
     /*  198841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198853 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  198858 */     GIR_RootConstrainSelectedInstOperands,
     /*  198859 */     // GIR_Coverage, 472,
     /*  198859 */     GIR_Done,
     /*  198860 */   // Label 3949: @198860
     /*  198860 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(198901), // Rule ID 474 //
     /*  198865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198882 */     // MIs[0] rs1
     /*  198882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198894 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  198899 */     GIR_RootConstrainSelectedInstOperands,
     /*  198900 */     // GIR_Coverage, 474,
     /*  198900 */     GIR_Done,
     /*  198901 */   // Label 3950: @198901
     /*  198901 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(198942), // Rule ID 476 //
     /*  198906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198923 */     // MIs[0] rs1
     /*  198923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198935 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  198940 */     GIR_RootConstrainSelectedInstOperands,
     /*  198941 */     // GIR_Coverage, 476,
     /*  198941 */     GIR_Done,
     /*  198942 */   // Label 3951: @198942
     /*  198942 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(198983), // Rule ID 478 //
     /*  198947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198964 */     // MIs[0] rs1
     /*  198964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198976 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  198981 */     GIR_RootConstrainSelectedInstOperands,
     /*  198982 */     // GIR_Coverage, 478,
     /*  198982 */     GIR_Done,
     /*  198983 */   // Label 3952: @198983
     /*  198983 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(199024), // Rule ID 480 //
     /*  198988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  198991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199005 */     // MIs[0] rs1
     /*  199005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199017 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199022 */     GIR_RootConstrainSelectedInstOperands,
     /*  199023 */     // GIR_Coverage, 480,
     /*  199023 */     GIR_Done,
     /*  199024 */   // Label 3953: @199024
     /*  199024 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(199065), // Rule ID 482 //
     /*  199029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199046 */     // MIs[0] rs1
     /*  199046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199058 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199063 */     GIR_RootConstrainSelectedInstOperands,
     /*  199064 */     // GIR_Coverage, 482,
     /*  199064 */     GIR_Done,
     /*  199065 */   // Label 3954: @199065
     /*  199065 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(199106), // Rule ID 484 //
     /*  199070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199087 */     // MIs[0] rs1
     /*  199087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199099 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199104 */     GIR_RootConstrainSelectedInstOperands,
     /*  199105 */     // GIR_Coverage, 484,
     /*  199105 */     GIR_Done,
     /*  199106 */   // Label 3955: @199106
     /*  199106 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(199147), // Rule ID 486 //
     /*  199111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199128 */     // MIs[0] rs1
     /*  199128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199140 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199145 */     GIR_RootConstrainSelectedInstOperands,
     /*  199146 */     // GIR_Coverage, 486,
     /*  199146 */     GIR_Done,
     /*  199147 */   // Label 3956: @199147
     /*  199147 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(199188), // Rule ID 488 //
     /*  199152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  199155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199169 */     // MIs[0] rs1
     /*  199169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199181 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199186 */     GIR_RootConstrainSelectedInstOperands,
     /*  199187 */     // GIR_Coverage, 488,
     /*  199187 */     GIR_Done,
     /*  199188 */   // Label 3957: @199188
     /*  199188 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(199229), // Rule ID 818 //
     /*  199193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199210 */     // MIs[0] rs1
     /*  199210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199222 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199227 */     GIR_RootConstrainSelectedInstOperands,
     /*  199228 */     // GIR_Coverage, 818,
     /*  199228 */     GIR_Done,
     /*  199229 */   // Label 3958: @199229
     /*  199229 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(199270), // Rule ID 820 //
     /*  199234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199237 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199251 */     // MIs[0] rs1
     /*  199251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199263 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  199268 */     GIR_RootConstrainSelectedInstOperands,
     /*  199269 */     // GIR_Coverage, 820,
     /*  199269 */     GIR_Done,
     /*  199270 */   // Label 3959: @199270
     /*  199270 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(199311), // Rule ID 822 //
     /*  199275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199292 */     // MIs[0] rs1
     /*  199292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199304 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  199309 */     GIR_RootConstrainSelectedInstOperands,
     /*  199310 */     // GIR_Coverage, 822,
     /*  199310 */     GIR_Done,
     /*  199311 */   // Label 3960: @199311
     /*  199311 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(199352), // Rule ID 824 //
     /*  199316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199333 */     // MIs[0] rs1
     /*  199333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199345 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  199350 */     GIR_RootConstrainSelectedInstOperands,
     /*  199351 */     // GIR_Coverage, 824,
     /*  199351 */     GIR_Done,
     /*  199352 */   // Label 3961: @199352
     /*  199352 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(199393), // Rule ID 826 //
     /*  199357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199374 */     // MIs[0] rs1
     /*  199374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199386 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  199391 */     GIR_RootConstrainSelectedInstOperands,
     /*  199392 */     // GIR_Coverage, 826,
     /*  199392 */     GIR_Done,
     /*  199393 */   // Label 3962: @199393
     /*  199393 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(199434), // Rule ID 828 //
     /*  199398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199415 */     // MIs[0] rs1
     /*  199415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199427 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199432 */     GIR_RootConstrainSelectedInstOperands,
     /*  199433 */     // GIR_Coverage, 828,
     /*  199433 */     GIR_Done,
     /*  199434 */   // Label 3963: @199434
     /*  199434 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(199475), // Rule ID 830 //
     /*  199439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199456 */     // MIs[0] rs1
     /*  199456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199468 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199473 */     GIR_RootConstrainSelectedInstOperands,
     /*  199474 */     // GIR_Coverage, 830,
     /*  199474 */     GIR_Done,
     /*  199475 */   // Label 3964: @199475
     /*  199475 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(199516), // Rule ID 832 //
     /*  199480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199497 */     // MIs[0] rs1
     /*  199497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199509 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199514 */     GIR_RootConstrainSelectedInstOperands,
     /*  199515 */     // GIR_Coverage, 832,
     /*  199515 */     GIR_Done,
     /*  199516 */   // Label 3965: @199516
     /*  199516 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(199557), // Rule ID 834 //
     /*  199521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199538 */     // MIs[0] rs1
     /*  199538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199550 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199555 */     GIR_RootConstrainSelectedInstOperands,
     /*  199556 */     // GIR_Coverage, 834,
     /*  199556 */     GIR_Done,
     /*  199557 */   // Label 3966: @199557
     /*  199557 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(199598), // Rule ID 836 //
     /*  199562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199579 */     // MIs[0] rs1
     /*  199579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199591 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199596 */     GIR_RootConstrainSelectedInstOperands,
     /*  199597 */     // GIR_Coverage, 836,
     /*  199597 */     GIR_Done,
     /*  199598 */   // Label 3967: @199598
     /*  199598 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(199639), // Rule ID 998 //
     /*  199603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199620 */     // MIs[0] rs1
     /*  199620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199632 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199637 */     GIR_RootConstrainSelectedInstOperands,
     /*  199638 */     // GIR_Coverage, 998,
     /*  199638 */     GIR_Done,
     /*  199639 */   // Label 3968: @199639
     /*  199639 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(199680), // Rule ID 1000 //
     /*  199644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199661 */     // MIs[0] rs1
     /*  199661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199673 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  199678 */     GIR_RootConstrainSelectedInstOperands,
     /*  199679 */     // GIR_Coverage, 1000,
     /*  199679 */     GIR_Done,
     /*  199680 */   // Label 3969: @199680
     /*  199680 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(199721), // Rule ID 1002 //
     /*  199685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199702 */     // MIs[0] rs1
     /*  199702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199714 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  199719 */     GIR_RootConstrainSelectedInstOperands,
     /*  199720 */     // GIR_Coverage, 1002,
     /*  199720 */     GIR_Done,
     /*  199721 */   // Label 3970: @199721
     /*  199721 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(199762), // Rule ID 1004 //
     /*  199726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199743 */     // MIs[0] rs1
     /*  199743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199755 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  199760 */     GIR_RootConstrainSelectedInstOperands,
     /*  199761 */     // GIR_Coverage, 1004,
     /*  199761 */     GIR_Done,
     /*  199762 */   // Label 3971: @199762
     /*  199762 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(199803), // Rule ID 1006 //
     /*  199767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199784 */     // MIs[0] rs1
     /*  199784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199796 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  199801 */     GIR_RootConstrainSelectedInstOperands,
     /*  199802 */     // GIR_Coverage, 1006,
     /*  199802 */     GIR_Done,
     /*  199803 */   // Label 3972: @199803
     /*  199803 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(199844), // Rule ID 1008 //
     /*  199808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199811 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199825 */     // MIs[0] rs1
     /*  199825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199837 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199842 */     GIR_RootConstrainSelectedInstOperands,
     /*  199843 */     // GIR_Coverage, 1008,
     /*  199843 */     GIR_Done,
     /*  199844 */   // Label 3973: @199844
     /*  199844 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(199885), // Rule ID 1010 //
     /*  199849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199852 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199859 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199866 */     // MIs[0] rs1
     /*  199866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199878 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199883 */     GIR_RootConstrainSelectedInstOperands,
     /*  199884 */     // GIR_Coverage, 1010,
     /*  199884 */     GIR_Done,
     /*  199885 */   // Label 3974: @199885
     /*  199885 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(199926), // Rule ID 1012 //
     /*  199890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199907 */     // MIs[0] rs1
     /*  199907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199919 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199924 */     GIR_RootConstrainSelectedInstOperands,
     /*  199925 */     // GIR_Coverage, 1012,
     /*  199925 */     GIR_Done,
     /*  199926 */   // Label 3975: @199926
     /*  199926 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(199967), // Rule ID 1014 //
     /*  199931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199934 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199948 */     // MIs[0] rs1
     /*  199948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199960 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199965 */     GIR_RootConstrainSelectedInstOperands,
     /*  199966 */     // GIR_Coverage, 1014,
     /*  199966 */     GIR_Done,
     /*  199967 */   // Label 3976: @199967
     /*  199967 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(200008), // Rule ID 1016 //
     /*  199972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199975 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199982 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199989 */     // MIs[0] rs1
     /*  199989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200001 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  200001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200006 */     GIR_RootConstrainSelectedInstOperands,
     /*  200007 */     // GIR_Coverage, 1016,
     /*  200007 */     GIR_Done,
     /*  200008 */   // Label 3977: @200008
     /*  200008 */   GIM_Reject,
     /*  200009 */ // Label 3947: @200009
     /*  200009 */ GIM_Reject,
     /*  200010 */ // Label 3945: @200010
     /*  200010 */ GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(201659),
     /*  200015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  200018 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(200059), // Rule ID 469 //
     /*  200023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200040 */     // MIs[0] rs1
     /*  200040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200052 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200057 */     GIR_RootConstrainSelectedInstOperands,
     /*  200058 */     // GIR_Coverage, 469,
     /*  200058 */     GIR_Done,
     /*  200059 */   // Label 3979: @200059
     /*  200059 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(200100), // Rule ID 471 //
     /*  200064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200081 */     // MIs[0] rs1
     /*  200081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200093 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  200098 */     GIR_RootConstrainSelectedInstOperands,
     /*  200099 */     // GIR_Coverage, 471,
     /*  200099 */     GIR_Done,
     /*  200100 */   // Label 3980: @200100
     /*  200100 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(200141), // Rule ID 473 //
     /*  200105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200122 */     // MIs[0] rs1
     /*  200122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200134 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  200139 */     GIR_RootConstrainSelectedInstOperands,
     /*  200140 */     // GIR_Coverage, 473,
     /*  200140 */     GIR_Done,
     /*  200141 */   // Label 3981: @200141
     /*  200141 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(200182), // Rule ID 475 //
     /*  200146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200149 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200163 */     // MIs[0] rs1
     /*  200163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200175 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  200180 */     GIR_RootConstrainSelectedInstOperands,
     /*  200181 */     // GIR_Coverage, 475,
     /*  200181 */     GIR_Done,
     /*  200182 */   // Label 3982: @200182
     /*  200182 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(200223), // Rule ID 477 //
     /*  200187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  200190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200204 */     // MIs[0] rs1
     /*  200204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200216 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  200221 */     GIR_RootConstrainSelectedInstOperands,
     /*  200222 */     // GIR_Coverage, 477,
     /*  200222 */     GIR_Done,
     /*  200223 */   // Label 3983: @200223
     /*  200223 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(200264), // Rule ID 479 //
     /*  200228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200245 */     // MIs[0] rs1
     /*  200245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200257 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200262 */     GIR_RootConstrainSelectedInstOperands,
     /*  200263 */     // GIR_Coverage, 479,
     /*  200263 */     GIR_Done,
     /*  200264 */   // Label 3984: @200264
     /*  200264 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(200305), // Rule ID 481 //
     /*  200269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200286 */     // MIs[0] rs1
     /*  200286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200298 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200303 */     GIR_RootConstrainSelectedInstOperands,
     /*  200304 */     // GIR_Coverage, 481,
     /*  200304 */     GIR_Done,
     /*  200305 */   // Label 3985: @200305
     /*  200305 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(200346), // Rule ID 483 //
     /*  200310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200327 */     // MIs[0] rs1
     /*  200327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200339 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200344 */     GIR_RootConstrainSelectedInstOperands,
     /*  200345 */     // GIR_Coverage, 483,
     /*  200345 */     GIR_Done,
     /*  200346 */   // Label 3986: @200346
     /*  200346 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(200387), // Rule ID 485 //
     /*  200351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200368 */     // MIs[0] rs1
     /*  200368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200380 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200385 */     GIR_RootConstrainSelectedInstOperands,
     /*  200386 */     // GIR_Coverage, 485,
     /*  200386 */     GIR_Done,
     /*  200387 */   // Label 3987: @200387
     /*  200387 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(200428), // Rule ID 487 //
     /*  200392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  200395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  200402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200409 */     // MIs[0] rs1
     /*  200409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200421 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  200426 */     GIR_RootConstrainSelectedInstOperands,
     /*  200427 */     // GIR_Coverage, 487,
     /*  200427 */     GIR_Done,
     /*  200428 */   // Label 3988: @200428
     /*  200428 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(200469), // Rule ID 589 //
     /*  200433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200450 */     // MIs[0] rs1
     /*  200450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200462 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200467 */     GIR_RootConstrainSelectedInstOperands,
     /*  200468 */     // GIR_Coverage, 589,
     /*  200468 */     GIR_Done,
     /*  200469 */   // Label 3989: @200469
     /*  200469 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200510), // Rule ID 590 //
     /*  200474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200491 */     // MIs[0] rs1
     /*  200491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200503 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ),
     /*  200508 */     GIR_RootConstrainSelectedInstOperands,
     /*  200509 */     // GIR_Coverage, 590,
     /*  200509 */     GIR_Done,
     /*  200510 */   // Label 3990: @200510
     /*  200510 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200551), // Rule ID 591 //
     /*  200515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200532 */     // MIs[0] rs1
     /*  200532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200544 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_RL),
     /*  200549 */     GIR_RootConstrainSelectedInstOperands,
     /*  200550 */     // GIR_Coverage, 591,
     /*  200550 */     GIR_Done,
     /*  200551 */   // Label 3991: @200551
     /*  200551 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(200592), // Rule ID 592 //
     /*  200556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200573 */     // MIs[0] rs1
     /*  200573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200585 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  200590 */     GIR_RootConstrainSelectedInstOperands,
     /*  200591 */     // GIR_Coverage, 592,
     /*  200591 */     GIR_Done,
     /*  200592 */   // Label 3992: @200592
     /*  200592 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200633), // Rule ID 593 //
     /*  200597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200614 */     // MIs[0] rs1
     /*  200614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200626 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  200631 */     GIR_RootConstrainSelectedInstOperands,
     /*  200632 */     // GIR_Coverage, 593,
     /*  200632 */     GIR_Done,
     /*  200633 */   // Label 3993: @200633
     /*  200633 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200674), // Rule ID 594 //
     /*  200638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200655 */     // MIs[0] rs1
     /*  200655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200667 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200672 */     GIR_RootConstrainSelectedInstOperands,
     /*  200673 */     // GIR_Coverage, 594,
     /*  200673 */     GIR_Done,
     /*  200674 */   // Label 3994: @200674
     /*  200674 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200715), // Rule ID 595 //
     /*  200679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200696 */     // MIs[0] rs1
     /*  200696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200708 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200713 */     GIR_RootConstrainSelectedInstOperands,
     /*  200714 */     // GIR_Coverage, 595,
     /*  200714 */     GIR_Done,
     /*  200715 */   // Label 3995: @200715
     /*  200715 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200756), // Rule ID 596 //
     /*  200720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200737 */     // MIs[0] rs1
     /*  200737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200749 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200754 */     GIR_RootConstrainSelectedInstOperands,
     /*  200755 */     // GIR_Coverage, 596,
     /*  200755 */     GIR_Done,
     /*  200756 */   // Label 3996: @200756
     /*  200756 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(200797), // Rule ID 597 //
     /*  200761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200778 */     // MIs[0] rs1
     /*  200778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200790 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200795 */     GIR_RootConstrainSelectedInstOperands,
     /*  200796 */     // GIR_Coverage, 597,
     /*  200796 */     GIR_Done,
     /*  200797 */   // Label 3997: @200797
     /*  200797 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(200838), // Rule ID 598 //
     /*  200802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200819 */     // MIs[0] rs1
     /*  200819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200831 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200836 */     GIR_RootConstrainSelectedInstOperands,
     /*  200837 */     // GIR_Coverage, 598,
     /*  200837 */     GIR_Done,
     /*  200838 */   // Label 3998: @200838
     /*  200838 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(200879), // Rule ID 817 //
     /*  200843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200860 */     // MIs[0] rs1
     /*  200860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200872 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200877 */     GIR_RootConstrainSelectedInstOperands,
     /*  200878 */     // GIR_Coverage, 817,
     /*  200878 */     GIR_Done,
     /*  200879 */   // Label 3999: @200879
     /*  200879 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(200920), // Rule ID 819 //
     /*  200884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200901 */     // MIs[0] rs1
     /*  200901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200913 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  200918 */     GIR_RootConstrainSelectedInstOperands,
     /*  200919 */     // GIR_Coverage, 819,
     /*  200919 */     GIR_Done,
     /*  200920 */   // Label 4000: @200920
     /*  200920 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(200961), // Rule ID 821 //
     /*  200925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200942 */     // MIs[0] rs1
     /*  200942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200954 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  200959 */     GIR_RootConstrainSelectedInstOperands,
     /*  200960 */     // GIR_Coverage, 821,
     /*  200960 */     GIR_Done,
     /*  200961 */   // Label 4001: @200961
     /*  200961 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(201002), // Rule ID 823 //
     /*  200966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200983 */     // MIs[0] rs1
     /*  200983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200995 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  201000 */     GIR_RootConstrainSelectedInstOperands,
     /*  201001 */     // GIR_Coverage, 823,
     /*  201001 */     GIR_Done,
     /*  201002 */   // Label 4002: @201002
     /*  201002 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(201043), // Rule ID 825 //
     /*  201007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201024 */     // MIs[0] rs1
     /*  201024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201036 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  201041 */     GIR_RootConstrainSelectedInstOperands,
     /*  201042 */     // GIR_Coverage, 825,
     /*  201042 */     GIR_Done,
     /*  201043 */   // Label 4003: @201043
     /*  201043 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201084), // Rule ID 827 //
     /*  201048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201065 */     // MIs[0] rs1
     /*  201065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201077 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201082 */     GIR_RootConstrainSelectedInstOperands,
     /*  201083 */     // GIR_Coverage, 827,
     /*  201083 */     GIR_Done,
     /*  201084 */   // Label 4004: @201084
     /*  201084 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201125), // Rule ID 829 //
     /*  201089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201092 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201099 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201106 */     // MIs[0] rs1
     /*  201106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201118 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201123 */     GIR_RootConstrainSelectedInstOperands,
     /*  201124 */     // GIR_Coverage, 829,
     /*  201124 */     GIR_Done,
     /*  201125 */   // Label 4005: @201125
     /*  201125 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201166), // Rule ID 831 //
     /*  201130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201147 */     // MIs[0] rs1
     /*  201147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201159 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201164 */     GIR_RootConstrainSelectedInstOperands,
     /*  201165 */     // GIR_Coverage, 831,
     /*  201165 */     GIR_Done,
     /*  201166 */   // Label 4006: @201166
     /*  201166 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201207), // Rule ID 833 //
     /*  201171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201188 */     // MIs[0] rs1
     /*  201188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201200 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201205 */     GIR_RootConstrainSelectedInstOperands,
     /*  201206 */     // GIR_Coverage, 833,
     /*  201206 */     GIR_Done,
     /*  201207 */   // Label 4007: @201207
     /*  201207 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201248), // Rule ID 835 //
     /*  201212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201229 */     // MIs[0] rs1
     /*  201229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201241 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  201246 */     GIR_RootConstrainSelectedInstOperands,
     /*  201247 */     // GIR_Coverage, 835,
     /*  201247 */     GIR_Done,
     /*  201248 */   // Label 4008: @201248
     /*  201248 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201289), // Rule ID 997 //
     /*  201253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201270 */     // MIs[0] rs1
     /*  201270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201282 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201287 */     GIR_RootConstrainSelectedInstOperands,
     /*  201288 */     // GIR_Coverage, 997,
     /*  201288 */     GIR_Done,
     /*  201289 */   // Label 4009: @201289
     /*  201289 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201330), // Rule ID 999 //
     /*  201294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201311 */     // MIs[0] rs1
     /*  201311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201323 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  201328 */     GIR_RootConstrainSelectedInstOperands,
     /*  201329 */     // GIR_Coverage, 999,
     /*  201329 */     GIR_Done,
     /*  201330 */   // Label 4010: @201330
     /*  201330 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201371), // Rule ID 1001 //
     /*  201335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201352 */     // MIs[0] rs1
     /*  201352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201364 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  201369 */     GIR_RootConstrainSelectedInstOperands,
     /*  201370 */     // GIR_Coverage, 1001,
     /*  201370 */     GIR_Done,
     /*  201371 */   // Label 4011: @201371
     /*  201371 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201412), // Rule ID 1003 //
     /*  201376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201393 */     // MIs[0] rs1
     /*  201393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201405 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  201410 */     GIR_RootConstrainSelectedInstOperands,
     /*  201411 */     // GIR_Coverage, 1003,
     /*  201411 */     GIR_Done,
     /*  201412 */   // Label 4012: @201412
     /*  201412 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201453), // Rule ID 1005 //
     /*  201417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  201420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201434 */     // MIs[0] rs1
     /*  201434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201446 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  201451 */     GIR_RootConstrainSelectedInstOperands,
     /*  201452 */     // GIR_Coverage, 1005,
     /*  201452 */     GIR_Done,
     /*  201453 */   // Label 4013: @201453
     /*  201453 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201494), // Rule ID 1007 //
     /*  201458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201475 */     // MIs[0] rs1
     /*  201475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201487 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201492 */     GIR_RootConstrainSelectedInstOperands,
     /*  201493 */     // GIR_Coverage, 1007,
     /*  201493 */     GIR_Done,
     /*  201494 */   // Label 4014: @201494
     /*  201494 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201535), // Rule ID 1009 //
     /*  201499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201516 */     // MIs[0] rs1
     /*  201516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201528 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201533 */     GIR_RootConstrainSelectedInstOperands,
     /*  201534 */     // GIR_Coverage, 1009,
     /*  201534 */     GIR_Done,
     /*  201535 */   // Label 4015: @201535
     /*  201535 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201576), // Rule ID 1011 //
     /*  201540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201543 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201550 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201557 */     // MIs[0] rs1
     /*  201557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201569 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201574 */     GIR_RootConstrainSelectedInstOperands,
     /*  201575 */     // GIR_Coverage, 1011,
     /*  201575 */     GIR_Done,
     /*  201576 */   // Label 4016: @201576
     /*  201576 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201617), // Rule ID 1013 //
     /*  201581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201598 */     // MIs[0] rs1
     /*  201598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201610 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201615 */     GIR_RootConstrainSelectedInstOperands,
     /*  201616 */     // GIR_Coverage, 1013,
     /*  201616 */     GIR_Done,
     /*  201617 */   // Label 4017: @201617
     /*  201617 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201658), // Rule ID 1015 //
     /*  201622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201625 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201632 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201639 */     // MIs[0] rs1
     /*  201639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201651 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201656 */     GIR_RootConstrainSelectedInstOperands,
     /*  201657 */     // GIR_Coverage, 1015,
     /*  201657 */     GIR_Done,
     /*  201658 */   // Label 4018: @201658
     /*  201658 */   GIM_Reject,
     /*  201659 */ // Label 3978: @201659
     /*  201659 */ GIM_Reject,
     /*  201660 */ // Label 3946: @201660
     /*  201660 */ GIM_Reject,
     /*  201661 */ // Label 34: @201661
     /*  201661 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4021*/ GIMT_Encode4(204570),
     /*  201672 */ /*GILLT_s32*//*Label 4019*/ GIMT_Encode4(201680),
     /*  201676 */ /*GILLT_s64*//*Label 4020*/ GIMT_Encode4(202920),
     /*  201680 */ // Label 4019: @201680
     /*  201680 */ GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(202919),
     /*  201685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  201688 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(201729), // Rule ID 490 //
     /*  201693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201710 */     // MIs[0] rs1
     /*  201710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201722 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201727 */     GIR_RootConstrainSelectedInstOperands,
     /*  201728 */     // GIR_Coverage, 490,
     /*  201728 */     GIR_Done,
     /*  201729 */   // Label 4023: @201729
     /*  201729 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(201770), // Rule ID 492 //
     /*  201734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201751 */     // MIs[0] rs1
     /*  201751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201763 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  201768 */     GIR_RootConstrainSelectedInstOperands,
     /*  201769 */     // GIR_Coverage, 492,
     /*  201769 */     GIR_Done,
     /*  201770 */   // Label 4024: @201770
     /*  201770 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(201811), // Rule ID 494 //
     /*  201775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201792 */     // MIs[0] rs1
     /*  201792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201804 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  201809 */     GIR_RootConstrainSelectedInstOperands,
     /*  201810 */     // GIR_Coverage, 494,
     /*  201810 */     GIR_Done,
     /*  201811 */   // Label 4025: @201811
     /*  201811 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(201852), // Rule ID 496 //
     /*  201816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201833 */     // MIs[0] rs1
     /*  201833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201845 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  201850 */     GIR_RootConstrainSelectedInstOperands,
     /*  201851 */     // GIR_Coverage, 496,
     /*  201851 */     GIR_Done,
     /*  201852 */   // Label 4026: @201852
     /*  201852 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(201893), // Rule ID 498 //
     /*  201857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201874 */     // MIs[0] rs1
     /*  201874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201886 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  201891 */     GIR_RootConstrainSelectedInstOperands,
     /*  201892 */     // GIR_Coverage, 498,
     /*  201892 */     GIR_Done,
     /*  201893 */   // Label 4027: @201893
     /*  201893 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(201934), // Rule ID 500 //
     /*  201898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201915 */     // MIs[0] rs1
     /*  201915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201927 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201932 */     GIR_RootConstrainSelectedInstOperands,
     /*  201933 */     // GIR_Coverage, 500,
     /*  201933 */     GIR_Done,
     /*  201934 */   // Label 4028: @201934
     /*  201934 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(201975), // Rule ID 502 //
     /*  201939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201956 */     // MIs[0] rs1
     /*  201956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201968 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201973 */     GIR_RootConstrainSelectedInstOperands,
     /*  201974 */     // GIR_Coverage, 502,
     /*  201974 */     GIR_Done,
     /*  201975 */   // Label 4029: @201975
     /*  201975 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202016), // Rule ID 504 //
     /*  201980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201997 */     // MIs[0] rs1
     /*  201997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202009 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202014 */     GIR_RootConstrainSelectedInstOperands,
     /*  202015 */     // GIR_Coverage, 504,
     /*  202015 */     GIR_Done,
     /*  202016 */   // Label 4030: @202016
     /*  202016 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202057), // Rule ID 506 //
     /*  202021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202038 */     // MIs[0] rs1
     /*  202038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202050 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202055 */     GIR_RootConstrainSelectedInstOperands,
     /*  202056 */     // GIR_Coverage, 506,
     /*  202056 */     GIR_Done,
     /*  202057 */   // Label 4031: @202057
     /*  202057 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202098), // Rule ID 508 //
     /*  202062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  202065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202079 */     // MIs[0] rs1
     /*  202079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202091 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202096 */     GIR_RootConstrainSelectedInstOperands,
     /*  202097 */     // GIR_Coverage, 508,
     /*  202097 */     GIR_Done,
     /*  202098 */   // Label 4032: @202098
     /*  202098 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202139), // Rule ID 838 //
     /*  202103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202120 */     // MIs[0] rs1
     /*  202120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202132 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202137 */     GIR_RootConstrainSelectedInstOperands,
     /*  202138 */     // GIR_Coverage, 838,
     /*  202138 */     GIR_Done,
     /*  202139 */   // Label 4033: @202139
     /*  202139 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202180), // Rule ID 840 //
     /*  202144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202161 */     // MIs[0] rs1
     /*  202161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202173 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  202178 */     GIR_RootConstrainSelectedInstOperands,
     /*  202179 */     // GIR_Coverage, 840,
     /*  202179 */     GIR_Done,
     /*  202180 */   // Label 4034: @202180
     /*  202180 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202221), // Rule ID 842 //
     /*  202185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202202 */     // MIs[0] rs1
     /*  202202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202214 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  202219 */     GIR_RootConstrainSelectedInstOperands,
     /*  202220 */     // GIR_Coverage, 842,
     /*  202220 */     GIR_Done,
     /*  202221 */   // Label 4035: @202221
     /*  202221 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202262), // Rule ID 844 //
     /*  202226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202229 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202243 */     // MIs[0] rs1
     /*  202243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202255 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  202260 */     GIR_RootConstrainSelectedInstOperands,
     /*  202261 */     // GIR_Coverage, 844,
     /*  202261 */     GIR_Done,
     /*  202262 */   // Label 4036: @202262
     /*  202262 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202303), // Rule ID 846 //
     /*  202267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202284 */     // MIs[0] rs1
     /*  202284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202296 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  202301 */     GIR_RootConstrainSelectedInstOperands,
     /*  202302 */     // GIR_Coverage, 846,
     /*  202302 */     GIR_Done,
     /*  202303 */   // Label 4037: @202303
     /*  202303 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(202344), // Rule ID 848 //
     /*  202308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202325 */     // MIs[0] rs1
     /*  202325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202337 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202342 */     GIR_RootConstrainSelectedInstOperands,
     /*  202343 */     // GIR_Coverage, 848,
     /*  202343 */     GIR_Done,
     /*  202344 */   // Label 4038: @202344
     /*  202344 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(202385), // Rule ID 850 //
     /*  202349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202366 */     // MIs[0] rs1
     /*  202366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202378 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202383 */     GIR_RootConstrainSelectedInstOperands,
     /*  202384 */     // GIR_Coverage, 850,
     /*  202384 */     GIR_Done,
     /*  202385 */   // Label 4039: @202385
     /*  202385 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(202426), // Rule ID 852 //
     /*  202390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202407 */     // MIs[0] rs1
     /*  202407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202419 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202424 */     GIR_RootConstrainSelectedInstOperands,
     /*  202425 */     // GIR_Coverage, 852,
     /*  202425 */     GIR_Done,
     /*  202426 */   // Label 4040: @202426
     /*  202426 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(202467), // Rule ID 854 //
     /*  202431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202448 */     // MIs[0] rs1
     /*  202448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202460 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202465 */     GIR_RootConstrainSelectedInstOperands,
     /*  202466 */     // GIR_Coverage, 854,
     /*  202466 */     GIR_Done,
     /*  202467 */   // Label 4041: @202467
     /*  202467 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(202508), // Rule ID 856 //
     /*  202472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  202482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202489 */     // MIs[0] rs1
     /*  202489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202501 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  202506 */     GIR_RootConstrainSelectedInstOperands,
     /*  202507 */     // GIR_Coverage, 856,
     /*  202507 */     GIR_Done,
     /*  202508 */   // Label 4042: @202508
     /*  202508 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(202549), // Rule ID 1018 //
     /*  202513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202530 */     // MIs[0] rs1
     /*  202530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202542 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202547 */     GIR_RootConstrainSelectedInstOperands,
     /*  202548 */     // GIR_Coverage, 1018,
     /*  202548 */     GIR_Done,
     /*  202549 */   // Label 4043: @202549
     /*  202549 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(202590), // Rule ID 1020 //
     /*  202554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202571 */     // MIs[0] rs1
     /*  202571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202583 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  202588 */     GIR_RootConstrainSelectedInstOperands,
     /*  202589 */     // GIR_Coverage, 1020,
     /*  202589 */     GIR_Done,
     /*  202590 */   // Label 4044: @202590
     /*  202590 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(202631), // Rule ID 1022 //
     /*  202595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202598 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202605 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202612 */     // MIs[0] rs1
     /*  202612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202624 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  202629 */     GIR_RootConstrainSelectedInstOperands,
     /*  202630 */     // GIR_Coverage, 1022,
     /*  202630 */     GIR_Done,
     /*  202631 */   // Label 4045: @202631
     /*  202631 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(202672), // Rule ID 1024 //
     /*  202636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202653 */     // MIs[0] rs1
     /*  202653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202665 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  202670 */     GIR_RootConstrainSelectedInstOperands,
     /*  202671 */     // GIR_Coverage, 1024,
     /*  202671 */     GIR_Done,
     /*  202672 */   // Label 4046: @202672
     /*  202672 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(202713), // Rule ID 1026 //
     /*  202677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202694 */     // MIs[0] rs1
     /*  202694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202706 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  202711 */     GIR_RootConstrainSelectedInstOperands,
     /*  202712 */     // GIR_Coverage, 1026,
     /*  202712 */     GIR_Done,
     /*  202713 */   // Label 4047: @202713
     /*  202713 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(202754), // Rule ID 1028 //
     /*  202718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202728 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202735 */     // MIs[0] rs1
     /*  202735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202747 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202752 */     GIR_RootConstrainSelectedInstOperands,
     /*  202753 */     // GIR_Coverage, 1028,
     /*  202753 */     GIR_Done,
     /*  202754 */   // Label 4048: @202754
     /*  202754 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(202795), // Rule ID 1030 //
     /*  202759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202762 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202769 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202776 */     // MIs[0] rs1
     /*  202776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202788 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202793 */     GIR_RootConstrainSelectedInstOperands,
     /*  202794 */     // GIR_Coverage, 1030,
     /*  202794 */     GIR_Done,
     /*  202795 */   // Label 4049: @202795
     /*  202795 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(202836), // Rule ID 1032 //
     /*  202800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202803 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202817 */     // MIs[0] rs1
     /*  202817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202829 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202834 */     GIR_RootConstrainSelectedInstOperands,
     /*  202835 */     // GIR_Coverage, 1032,
     /*  202835 */     GIR_Done,
     /*  202836 */   // Label 4050: @202836
     /*  202836 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(202877), // Rule ID 1034 //
     /*  202841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202858 */     // MIs[0] rs1
     /*  202858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202870 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202875 */     GIR_RootConstrainSelectedInstOperands,
     /*  202876 */     // GIR_Coverage, 1034,
     /*  202876 */     GIR_Done,
     /*  202877 */   // Label 4051: @202877
     /*  202877 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(202918), // Rule ID 1036 //
     /*  202882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202899 */     // MIs[0] rs1
     /*  202899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202911 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202916 */     GIR_RootConstrainSelectedInstOperands,
     /*  202917 */     // GIR_Coverage, 1036,
     /*  202917 */     GIR_Done,
     /*  202918 */   // Label 4052: @202918
     /*  202918 */   GIM_Reject,
     /*  202919 */ // Label 4022: @202919
     /*  202919 */ GIM_Reject,
     /*  202920 */ // Label 4020: @202920
     /*  202920 */ GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(204569),
     /*  202925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  202928 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(202969), // Rule ID 489 //
     /*  202933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  202936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202950 */     // MIs[0] rs1
     /*  202950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202962 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202967 */     GIR_RootConstrainSelectedInstOperands,
     /*  202968 */     // GIR_Coverage, 489,
     /*  202968 */     GIR_Done,
     /*  202969 */   // Label 4054: @202969
     /*  202969 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203010), // Rule ID 491 //
     /*  202974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  202977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202991 */     // MIs[0] rs1
     /*  202991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203003 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  203008 */     GIR_RootConstrainSelectedInstOperands,
     /*  203009 */     // GIR_Coverage, 491,
     /*  203009 */     GIR_Done,
     /*  203010 */   // Label 4055: @203010
     /*  203010 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203051), // Rule ID 493 //
     /*  203015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203032 */     // MIs[0] rs1
     /*  203032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203044 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  203049 */     GIR_RootConstrainSelectedInstOperands,
     /*  203050 */     // GIR_Coverage, 493,
     /*  203050 */     GIR_Done,
     /*  203051 */   // Label 4056: @203051
     /*  203051 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(203092), // Rule ID 495 //
     /*  203056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203073 */     // MIs[0] rs1
     /*  203073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203085 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  203090 */     GIR_RootConstrainSelectedInstOperands,
     /*  203091 */     // GIR_Coverage, 495,
     /*  203091 */     GIR_Done,
     /*  203092 */   // Label 4057: @203092
     /*  203092 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(203133), // Rule ID 497 //
     /*  203097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  203100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203114 */     // MIs[0] rs1
     /*  203114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203126 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  203131 */     GIR_RootConstrainSelectedInstOperands,
     /*  203132 */     // GIR_Coverage, 497,
     /*  203132 */     GIR_Done,
     /*  203133 */   // Label 4058: @203133
     /*  203133 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(203174), // Rule ID 499 //
     /*  203138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203155 */     // MIs[0] rs1
     /*  203155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203167 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203172 */     GIR_RootConstrainSelectedInstOperands,
     /*  203173 */     // GIR_Coverage, 499,
     /*  203173 */     GIR_Done,
     /*  203174 */   // Label 4059: @203174
     /*  203174 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(203215), // Rule ID 501 //
     /*  203179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203196 */     // MIs[0] rs1
     /*  203196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203208 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203213 */     GIR_RootConstrainSelectedInstOperands,
     /*  203214 */     // GIR_Coverage, 501,
     /*  203214 */     GIR_Done,
     /*  203215 */   // Label 4060: @203215
     /*  203215 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(203256), // Rule ID 503 //
     /*  203220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203237 */     // MIs[0] rs1
     /*  203237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203249 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203254 */     GIR_RootConstrainSelectedInstOperands,
     /*  203255 */     // GIR_Coverage, 503,
     /*  203255 */     GIR_Done,
     /*  203256 */   // Label 4061: @203256
     /*  203256 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(203297), // Rule ID 505 //
     /*  203261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203278 */     // MIs[0] rs1
     /*  203278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203290 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203295 */     GIR_RootConstrainSelectedInstOperands,
     /*  203296 */     // GIR_Coverage, 505,
     /*  203296 */     GIR_Done,
     /*  203297 */   // Label 4062: @203297
     /*  203297 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(203338), // Rule ID 507 //
     /*  203302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  203305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  203312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203319 */     // MIs[0] rs1
     /*  203319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203331 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  203336 */     GIR_RootConstrainSelectedInstOperands,
     /*  203337 */     // GIR_Coverage, 507,
     /*  203337 */     GIR_Done,
     /*  203338 */   // Label 4063: @203338
     /*  203338 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(203379), // Rule ID 599 //
     /*  203343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203360 */     // MIs[0] rs1
     /*  203360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203372 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203377 */     GIR_RootConstrainSelectedInstOperands,
     /*  203378 */     // GIR_Coverage, 599,
     /*  203378 */     GIR_Done,
     /*  203379 */   // Label 4064: @203379
     /*  203379 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(203420), // Rule ID 600 //
     /*  203384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203401 */     // MIs[0] rs1
     /*  203401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203413 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ),
     /*  203418 */     GIR_RootConstrainSelectedInstOperands,
     /*  203419 */     // GIR_Coverage, 600,
     /*  203419 */     GIR_Done,
     /*  203420 */   // Label 4065: @203420
     /*  203420 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(203461), // Rule ID 601 //
     /*  203425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203442 */     // MIs[0] rs1
     /*  203442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203454 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_RL),
     /*  203459 */     GIR_RootConstrainSelectedInstOperands,
     /*  203460 */     // GIR_Coverage, 601,
     /*  203460 */     GIR_Done,
     /*  203461 */   // Label 4066: @203461
     /*  203461 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(203502), // Rule ID 602 //
     /*  203466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203483 */     // MIs[0] rs1
     /*  203483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203495 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  203500 */     GIR_RootConstrainSelectedInstOperands,
     /*  203501 */     // GIR_Coverage, 602,
     /*  203501 */     GIR_Done,
     /*  203502 */   // Label 4067: @203502
     /*  203502 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(203543), // Rule ID 603 //
     /*  203507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203524 */     // MIs[0] rs1
     /*  203524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203536 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  203541 */     GIR_RootConstrainSelectedInstOperands,
     /*  203542 */     // GIR_Coverage, 603,
     /*  203542 */     GIR_Done,
     /*  203543 */   // Label 4068: @203543
     /*  203543 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(203584), // Rule ID 604 //
     /*  203548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203565 */     // MIs[0] rs1
     /*  203565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203577 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203582 */     GIR_RootConstrainSelectedInstOperands,
     /*  203583 */     // GIR_Coverage, 604,
     /*  203583 */     GIR_Done,
     /*  203584 */   // Label 4069: @203584
     /*  203584 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(203625), // Rule ID 605 //
     /*  203589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203606 */     // MIs[0] rs1
     /*  203606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203618 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203623 */     GIR_RootConstrainSelectedInstOperands,
     /*  203624 */     // GIR_Coverage, 605,
     /*  203624 */     GIR_Done,
     /*  203625 */   // Label 4070: @203625
     /*  203625 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(203666), // Rule ID 606 //
     /*  203630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203647 */     // MIs[0] rs1
     /*  203647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203659 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203664 */     GIR_RootConstrainSelectedInstOperands,
     /*  203665 */     // GIR_Coverage, 606,
     /*  203665 */     GIR_Done,
     /*  203666 */   // Label 4071: @203666
     /*  203666 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(203707), // Rule ID 607 //
     /*  203671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203674 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203688 */     // MIs[0] rs1
     /*  203688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203700 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203705 */     GIR_RootConstrainSelectedInstOperands,
     /*  203706 */     // GIR_Coverage, 607,
     /*  203706 */     GIR_Done,
     /*  203707 */   // Label 4072: @203707
     /*  203707 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(203748), // Rule ID 608 //
     /*  203712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203715 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203722 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203729 */     // MIs[0] rs1
     /*  203729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203741 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203746 */     GIR_RootConstrainSelectedInstOperands,
     /*  203747 */     // GIR_Coverage, 608,
     /*  203747 */     GIR_Done,
     /*  203748 */   // Label 4073: @203748
     /*  203748 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(203789), // Rule ID 837 //
     /*  203753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203770 */     // MIs[0] rs1
     /*  203770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203782 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  203787 */     GIR_RootConstrainSelectedInstOperands,
     /*  203788 */     // GIR_Coverage, 837,
     /*  203788 */     GIR_Done,
     /*  203789 */   // Label 4074: @203789
     /*  203789 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(203830), // Rule ID 839 //
     /*  203794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203797 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203811 */     // MIs[0] rs1
     /*  203811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203823 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  203828 */     GIR_RootConstrainSelectedInstOperands,
     /*  203829 */     // GIR_Coverage, 839,
     /*  203829 */     GIR_Done,
     /*  203830 */   // Label 4075: @203830
     /*  203830 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(203871), // Rule ID 841 //
     /*  203835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203852 */     // MIs[0] rs1
     /*  203852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203864 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  203869 */     GIR_RootConstrainSelectedInstOperands,
     /*  203870 */     // GIR_Coverage, 841,
     /*  203870 */     GIR_Done,
     /*  203871 */   // Label 4076: @203871
     /*  203871 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(203912), // Rule ID 843 //
     /*  203876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203879 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203893 */     // MIs[0] rs1
     /*  203893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203905 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  203910 */     GIR_RootConstrainSelectedInstOperands,
     /*  203911 */     // GIR_Coverage, 843,
     /*  203911 */     GIR_Done,
     /*  203912 */   // Label 4077: @203912
     /*  203912 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(203953), // Rule ID 845 //
     /*  203917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203934 */     // MIs[0] rs1
     /*  203934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203946 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  203951 */     GIR_RootConstrainSelectedInstOperands,
     /*  203952 */     // GIR_Coverage, 845,
     /*  203952 */     GIR_Done,
     /*  203953 */   // Label 4078: @203953
     /*  203953 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(203994), // Rule ID 847 //
     /*  203958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203975 */     // MIs[0] rs1
     /*  203975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203987 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  203992 */     GIR_RootConstrainSelectedInstOperands,
     /*  203993 */     // GIR_Coverage, 847,
     /*  203993 */     GIR_Done,
     /*  203994 */   // Label 4079: @203994
     /*  203994 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(204035), // Rule ID 849 //
     /*  203999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204016 */     // MIs[0] rs1
     /*  204016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204028 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204033 */     GIR_RootConstrainSelectedInstOperands,
     /*  204034 */     // GIR_Coverage, 849,
     /*  204034 */     GIR_Done,
     /*  204035 */   // Label 4080: @204035
     /*  204035 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(204076), // Rule ID 851 //
     /*  204040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204043 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204050 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204057 */     // MIs[0] rs1
     /*  204057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204069 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204074 */     GIR_RootConstrainSelectedInstOperands,
     /*  204075 */     // GIR_Coverage, 851,
     /*  204075 */     GIR_Done,
     /*  204076 */   // Label 4081: @204076
     /*  204076 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(204117), // Rule ID 853 //
     /*  204081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204098 */     // MIs[0] rs1
     /*  204098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204110 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204115 */     GIR_RootConstrainSelectedInstOperands,
     /*  204116 */     // GIR_Coverage, 853,
     /*  204116 */     GIR_Done,
     /*  204117 */   // Label 4082: @204117
     /*  204117 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(204158), // Rule ID 855 //
     /*  204122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204139 */     // MIs[0] rs1
     /*  204139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204151 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  204156 */     GIR_RootConstrainSelectedInstOperands,
     /*  204157 */     // GIR_Coverage, 855,
     /*  204157 */     GIR_Done,
     /*  204158 */   // Label 4083: @204158
     /*  204158 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(204199), // Rule ID 1017 //
     /*  204163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204180 */     // MIs[0] rs1
     /*  204180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204192 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204197 */     GIR_RootConstrainSelectedInstOperands,
     /*  204198 */     // GIR_Coverage, 1017,
     /*  204198 */     GIR_Done,
     /*  204199 */   // Label 4084: @204199
     /*  204199 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(204240), // Rule ID 1019 //
     /*  204204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204221 */     // MIs[0] rs1
     /*  204221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204233 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  204238 */     GIR_RootConstrainSelectedInstOperands,
     /*  204239 */     // GIR_Coverage, 1019,
     /*  204239 */     GIR_Done,
     /*  204240 */   // Label 4085: @204240
     /*  204240 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(204281), // Rule ID 1021 //
     /*  204245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204262 */     // MIs[0] rs1
     /*  204262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204274 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  204279 */     GIR_RootConstrainSelectedInstOperands,
     /*  204280 */     // GIR_Coverage, 1021,
     /*  204280 */     GIR_Done,
     /*  204281 */   // Label 4086: @204281
     /*  204281 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(204322), // Rule ID 1023 //
     /*  204286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204303 */     // MIs[0] rs1
     /*  204303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204315 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  204320 */     GIR_RootConstrainSelectedInstOperands,
     /*  204321 */     // GIR_Coverage, 1023,
     /*  204321 */     GIR_Done,
     /*  204322 */   // Label 4087: @204322
     /*  204322 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(204363), // Rule ID 1025 //
     /*  204327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  204330 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204337 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204344 */     // MIs[0] rs1
     /*  204344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204356 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  204361 */     GIR_RootConstrainSelectedInstOperands,
     /*  204362 */     // GIR_Coverage, 1025,
     /*  204362 */     GIR_Done,
     /*  204363 */   // Label 4088: @204363
     /*  204363 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(204404), // Rule ID 1027 //
     /*  204368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204371 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204385 */     // MIs[0] rs1
     /*  204385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204397 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204402 */     GIR_RootConstrainSelectedInstOperands,
     /*  204403 */     // GIR_Coverage, 1027,
     /*  204403 */     GIR_Done,
     /*  204404 */   // Label 4089: @204404
     /*  204404 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(204445), // Rule ID 1029 //
     /*  204409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204412 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204426 */     // MIs[0] rs1
     /*  204426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204438 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204443 */     GIR_RootConstrainSelectedInstOperands,
     /*  204444 */     // GIR_Coverage, 1029,
     /*  204444 */     GIR_Done,
     /*  204445 */   // Label 4090: @204445
     /*  204445 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(204486), // Rule ID 1031 //
     /*  204450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204453 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204460 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204467 */     // MIs[0] rs1
     /*  204467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204479 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204484 */     GIR_RootConstrainSelectedInstOperands,
     /*  204485 */     // GIR_Coverage, 1031,
     /*  204485 */     GIR_Done,
     /*  204486 */   // Label 4091: @204486
     /*  204486 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(204527), // Rule ID 1033 //
     /*  204491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204494 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204501 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204508 */     // MIs[0] rs1
     /*  204508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204520 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204525 */     GIR_RootConstrainSelectedInstOperands,
     /*  204526 */     // GIR_Coverage, 1033,
     /*  204526 */     GIR_Done,
     /*  204527 */   // Label 4092: @204527
     /*  204527 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(204568), // Rule ID 1035 //
     /*  204532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204535 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204542 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204549 */     // MIs[0] rs1
     /*  204549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204561 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204566 */     GIR_RootConstrainSelectedInstOperands,
     /*  204567 */     // GIR_Coverage, 1035,
     /*  204567 */     GIR_Done,
     /*  204568 */   // Label 4093: @204568
     /*  204568 */   GIM_Reject,
     /*  204569 */ // Label 4053: @204569
     /*  204569 */ GIM_Reject,
     /*  204570 */ // Label 4021: @204570
     /*  204570 */ GIM_Reject,
     /*  204571 */ // Label 35: @204571
     /*  204571 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4096*/ GIMT_Encode4(207480),
     /*  204582 */ /*GILLT_s32*//*Label 4094*/ GIMT_Encode4(204590),
     /*  204586 */ /*GILLT_s64*//*Label 4095*/ GIMT_Encode4(205830),
     /*  204590 */ // Label 4094: @204590
     /*  204590 */ GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(205829),
     /*  204595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  204598 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(204639), // Rule ID 510 //
     /*  204603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204620 */     // MIs[0] rs1
     /*  204620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204632 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204637 */     GIR_RootConstrainSelectedInstOperands,
     /*  204638 */     // GIR_Coverage, 510,
     /*  204638 */     GIR_Done,
     /*  204639 */   // Label 4098: @204639
     /*  204639 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(204680), // Rule ID 512 //
     /*  204644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204661 */     // MIs[0] rs1
     /*  204661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204673 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  204678 */     GIR_RootConstrainSelectedInstOperands,
     /*  204679 */     // GIR_Coverage, 512,
     /*  204679 */     GIR_Done,
     /*  204680 */   // Label 4099: @204680
     /*  204680 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(204721), // Rule ID 514 //
     /*  204685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204702 */     // MIs[0] rs1
     /*  204702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204714 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  204719 */     GIR_RootConstrainSelectedInstOperands,
     /*  204720 */     // GIR_Coverage, 514,
     /*  204720 */     GIR_Done,
     /*  204721 */   // Label 4100: @204721
     /*  204721 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(204762), // Rule ID 516 //
     /*  204726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204743 */     // MIs[0] rs1
     /*  204743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204755 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  204760 */     GIR_RootConstrainSelectedInstOperands,
     /*  204761 */     // GIR_Coverage, 516,
     /*  204761 */     GIR_Done,
     /*  204762 */   // Label 4101: @204762
     /*  204762 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(204803), // Rule ID 518 //
     /*  204767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204784 */     // MIs[0] rs1
     /*  204784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204796 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  204801 */     GIR_RootConstrainSelectedInstOperands,
     /*  204802 */     // GIR_Coverage, 518,
     /*  204802 */     GIR_Done,
     /*  204803 */   // Label 4102: @204803
     /*  204803 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(204844), // Rule ID 520 //
     /*  204808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204811 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204825 */     // MIs[0] rs1
     /*  204825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204837 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204842 */     GIR_RootConstrainSelectedInstOperands,
     /*  204843 */     // GIR_Coverage, 520,
     /*  204843 */     GIR_Done,
     /*  204844 */   // Label 4103: @204844
     /*  204844 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(204885), // Rule ID 522 //
     /*  204849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204852 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204859 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204866 */     // MIs[0] rs1
     /*  204866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204878 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204883 */     GIR_RootConstrainSelectedInstOperands,
     /*  204884 */     // GIR_Coverage, 522,
     /*  204884 */     GIR_Done,
     /*  204885 */   // Label 4104: @204885
     /*  204885 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(204926), // Rule ID 524 //
     /*  204890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204907 */     // MIs[0] rs1
     /*  204907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204919 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204924 */     GIR_RootConstrainSelectedInstOperands,
     /*  204925 */     // GIR_Coverage, 524,
     /*  204925 */     GIR_Done,
     /*  204926 */   // Label 4105: @204926
     /*  204926 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(204967), // Rule ID 526 //
     /*  204931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204934 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204948 */     // MIs[0] rs1
     /*  204948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204960 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204965 */     GIR_RootConstrainSelectedInstOperands,
     /*  204966 */     // GIR_Coverage, 526,
     /*  204966 */     GIR_Done,
     /*  204967 */   // Label 4106: @204967
     /*  204967 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(205008), // Rule ID 528 //
     /*  204972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204975 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204982 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204989 */     // MIs[0] rs1
     /*  204989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205001 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205006 */     GIR_RootConstrainSelectedInstOperands,
     /*  205007 */     // GIR_Coverage, 528,
     /*  205007 */     GIR_Done,
     /*  205008 */   // Label 4107: @205008
     /*  205008 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(205049), // Rule ID 858 //
     /*  205013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205030 */     // MIs[0] rs1
     /*  205030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205042 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205047 */     GIR_RootConstrainSelectedInstOperands,
     /*  205048 */     // GIR_Coverage, 858,
     /*  205048 */     GIR_Done,
     /*  205049 */   // Label 4108: @205049
     /*  205049 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(205090), // Rule ID 860 //
     /*  205054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205064 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205071 */     // MIs[0] rs1
     /*  205071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205083 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  205088 */     GIR_RootConstrainSelectedInstOperands,
     /*  205089 */     // GIR_Coverage, 860,
     /*  205089 */     GIR_Done,
     /*  205090 */   // Label 4109: @205090
     /*  205090 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(205131), // Rule ID 862 //
     /*  205095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205112 */     // MIs[0] rs1
     /*  205112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205124 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  205129 */     GIR_RootConstrainSelectedInstOperands,
     /*  205130 */     // GIR_Coverage, 862,
     /*  205130 */     GIR_Done,
     /*  205131 */   // Label 4110: @205131
     /*  205131 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(205172), // Rule ID 864 //
     /*  205136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205139 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205146 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205153 */     // MIs[0] rs1
     /*  205153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205165 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  205170 */     GIR_RootConstrainSelectedInstOperands,
     /*  205171 */     // GIR_Coverage, 864,
     /*  205171 */     GIR_Done,
     /*  205172 */   // Label 4111: @205172
     /*  205172 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(205213), // Rule ID 866 //
     /*  205177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205187 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205194 */     // MIs[0] rs1
     /*  205194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205206 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  205211 */     GIR_RootConstrainSelectedInstOperands,
     /*  205212 */     // GIR_Coverage, 866,
     /*  205212 */     GIR_Done,
     /*  205213 */   // Label 4112: @205213
     /*  205213 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(205254), // Rule ID 868 //
     /*  205218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205235 */     // MIs[0] rs1
     /*  205235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205247 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205252 */     GIR_RootConstrainSelectedInstOperands,
     /*  205253 */     // GIR_Coverage, 868,
     /*  205253 */     GIR_Done,
     /*  205254 */   // Label 4113: @205254
     /*  205254 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(205295), // Rule ID 870 //
     /*  205259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205276 */     // MIs[0] rs1
     /*  205276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205288 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205293 */     GIR_RootConstrainSelectedInstOperands,
     /*  205294 */     // GIR_Coverage, 870,
     /*  205294 */     GIR_Done,
     /*  205295 */   // Label 4114: @205295
     /*  205295 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(205336), // Rule ID 872 //
     /*  205300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205317 */     // MIs[0] rs1
     /*  205317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205329 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205334 */     GIR_RootConstrainSelectedInstOperands,
     /*  205335 */     // GIR_Coverage, 872,
     /*  205335 */     GIR_Done,
     /*  205336 */   // Label 4115: @205336
     /*  205336 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(205377), // Rule ID 874 //
     /*  205341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205358 */     // MIs[0] rs1
     /*  205358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205370 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205375 */     GIR_RootConstrainSelectedInstOperands,
     /*  205376 */     // GIR_Coverage, 874,
     /*  205376 */     GIR_Done,
     /*  205377 */   // Label 4116: @205377
     /*  205377 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(205418), // Rule ID 876 //
     /*  205382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  205392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205399 */     // MIs[0] rs1
     /*  205399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205411 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  205416 */     GIR_RootConstrainSelectedInstOperands,
     /*  205417 */     // GIR_Coverage, 876,
     /*  205417 */     GIR_Done,
     /*  205418 */   // Label 4117: @205418
     /*  205418 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(205459), // Rule ID 1038 //
     /*  205423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205440 */     // MIs[0] rs1
     /*  205440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205452 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205457 */     GIR_RootConstrainSelectedInstOperands,
     /*  205458 */     // GIR_Coverage, 1038,
     /*  205458 */     GIR_Done,
     /*  205459 */   // Label 4118: @205459
     /*  205459 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(205500), // Rule ID 1040 //
     /*  205464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205467 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205481 */     // MIs[0] rs1
     /*  205481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205493 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  205498 */     GIR_RootConstrainSelectedInstOperands,
     /*  205499 */     // GIR_Coverage, 1040,
     /*  205499 */     GIR_Done,
     /*  205500 */   // Label 4119: @205500
     /*  205500 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(205541), // Rule ID 1042 //
     /*  205505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205515 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205522 */     // MIs[0] rs1
     /*  205522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205534 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  205539 */     GIR_RootConstrainSelectedInstOperands,
     /*  205540 */     // GIR_Coverage, 1042,
     /*  205540 */     GIR_Done,
     /*  205541 */   // Label 4120: @205541
     /*  205541 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(205582), // Rule ID 1044 //
     /*  205546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205556 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205563 */     // MIs[0] rs1
     /*  205563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205575 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  205580 */     GIR_RootConstrainSelectedInstOperands,
     /*  205581 */     // GIR_Coverage, 1044,
     /*  205581 */     GIR_Done,
     /*  205582 */   // Label 4121: @205582
     /*  205582 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(205623), // Rule ID 1046 //
     /*  205587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205604 */     // MIs[0] rs1
     /*  205604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205616 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  205621 */     GIR_RootConstrainSelectedInstOperands,
     /*  205622 */     // GIR_Coverage, 1046,
     /*  205622 */     GIR_Done,
     /*  205623 */   // Label 4122: @205623
     /*  205623 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(205664), // Rule ID 1048 //
     /*  205628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205645 */     // MIs[0] rs1
     /*  205645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205657 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205662 */     GIR_RootConstrainSelectedInstOperands,
     /*  205663 */     // GIR_Coverage, 1048,
     /*  205663 */     GIR_Done,
     /*  205664 */   // Label 4123: @205664
     /*  205664 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(205705), // Rule ID 1050 //
     /*  205669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205672 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205686 */     // MIs[0] rs1
     /*  205686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205698 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205703 */     GIR_RootConstrainSelectedInstOperands,
     /*  205704 */     // GIR_Coverage, 1050,
     /*  205704 */     GIR_Done,
     /*  205705 */   // Label 4124: @205705
     /*  205705 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(205746), // Rule ID 1052 //
     /*  205710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205727 */     // MIs[0] rs1
     /*  205727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205739 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205744 */     GIR_RootConstrainSelectedInstOperands,
     /*  205745 */     // GIR_Coverage, 1052,
     /*  205745 */     GIR_Done,
     /*  205746 */   // Label 4125: @205746
     /*  205746 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(205787), // Rule ID 1054 //
     /*  205751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205768 */     // MIs[0] rs1
     /*  205768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205780 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205785 */     GIR_RootConstrainSelectedInstOperands,
     /*  205786 */     // GIR_Coverage, 1054,
     /*  205786 */     GIR_Done,
     /*  205787 */   // Label 4126: @205787
     /*  205787 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(205828), // Rule ID 1056 //
     /*  205792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205809 */     // MIs[0] rs1
     /*  205809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205821 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205826 */     GIR_RootConstrainSelectedInstOperands,
     /*  205827 */     // GIR_Coverage, 1056,
     /*  205827 */     GIR_Done,
     /*  205828 */   // Label 4127: @205828
     /*  205828 */   GIM_Reject,
     /*  205829 */ // Label 4097: @205829
     /*  205829 */ GIM_Reject,
     /*  205830 */ // Label 4095: @205830
     /*  205830 */ GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(207479),
     /*  205835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  205838 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(205879), // Rule ID 509 //
     /*  205843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205860 */     // MIs[0] rs1
     /*  205860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205872 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205877 */     GIR_RootConstrainSelectedInstOperands,
     /*  205878 */     // GIR_Coverage, 509,
     /*  205878 */     GIR_Done,
     /*  205879 */   // Label 4129: @205879
     /*  205879 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(205920), // Rule ID 511 //
     /*  205884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205901 */     // MIs[0] rs1
     /*  205901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205913 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  205918 */     GIR_RootConstrainSelectedInstOperands,
     /*  205919 */     // GIR_Coverage, 511,
     /*  205919 */     GIR_Done,
     /*  205920 */   // Label 4130: @205920
     /*  205920 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(205961), // Rule ID 513 //
     /*  205925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205942 */     // MIs[0] rs1
     /*  205942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205954 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  205959 */     GIR_RootConstrainSelectedInstOperands,
     /*  205960 */     // GIR_Coverage, 513,
     /*  205960 */     GIR_Done,
     /*  205961 */   // Label 4131: @205961
     /*  205961 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(206002), // Rule ID 515 //
     /*  205966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205983 */     // MIs[0] rs1
     /*  205983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205995 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  206000 */     GIR_RootConstrainSelectedInstOperands,
     /*  206001 */     // GIR_Coverage, 515,
     /*  206001 */     GIR_Done,
     /*  206002 */   // Label 4132: @206002
     /*  206002 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(206043), // Rule ID 517 //
     /*  206007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  206010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206024 */     // MIs[0] rs1
     /*  206024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206036 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  206041 */     GIR_RootConstrainSelectedInstOperands,
     /*  206042 */     // GIR_Coverage, 517,
     /*  206042 */     GIR_Done,
     /*  206043 */   // Label 4133: @206043
     /*  206043 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(206084), // Rule ID 519 //
     /*  206048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206065 */     // MIs[0] rs1
     /*  206065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206077 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206082 */     GIR_RootConstrainSelectedInstOperands,
     /*  206083 */     // GIR_Coverage, 519,
     /*  206083 */     GIR_Done,
     /*  206084 */   // Label 4134: @206084
     /*  206084 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(206125), // Rule ID 521 //
     /*  206089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206092 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206099 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206106 */     // MIs[0] rs1
     /*  206106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206118 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206123 */     GIR_RootConstrainSelectedInstOperands,
     /*  206124 */     // GIR_Coverage, 521,
     /*  206124 */     GIR_Done,
     /*  206125 */   // Label 4135: @206125
     /*  206125 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(206166), // Rule ID 523 //
     /*  206130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206147 */     // MIs[0] rs1
     /*  206147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206159 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206164 */     GIR_RootConstrainSelectedInstOperands,
     /*  206165 */     // GIR_Coverage, 523,
     /*  206165 */     GIR_Done,
     /*  206166 */   // Label 4136: @206166
     /*  206166 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(206207), // Rule ID 525 //
     /*  206171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206188 */     // MIs[0] rs1
     /*  206188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206200 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206205 */     GIR_RootConstrainSelectedInstOperands,
     /*  206206 */     // GIR_Coverage, 525,
     /*  206206 */     GIR_Done,
     /*  206207 */   // Label 4137: @206207
     /*  206207 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(206248), // Rule ID 527 //
     /*  206212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  206215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  206222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206229 */     // MIs[0] rs1
     /*  206229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206241 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  206246 */     GIR_RootConstrainSelectedInstOperands,
     /*  206247 */     // GIR_Coverage, 527,
     /*  206247 */     GIR_Done,
     /*  206248 */   // Label 4138: @206248
     /*  206248 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(206289), // Rule ID 609 //
     /*  206253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206270 */     // MIs[0] rs1
     /*  206270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206282 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206287 */     GIR_RootConstrainSelectedInstOperands,
     /*  206288 */     // GIR_Coverage, 609,
     /*  206288 */     GIR_Done,
     /*  206289 */   // Label 4139: @206289
     /*  206289 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(206330), // Rule ID 610 //
     /*  206294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206311 */     // MIs[0] rs1
     /*  206311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206323 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ),
     /*  206328 */     GIR_RootConstrainSelectedInstOperands,
     /*  206329 */     // GIR_Coverage, 610,
     /*  206329 */     GIR_Done,
     /*  206330 */   // Label 4140: @206330
     /*  206330 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(206371), // Rule ID 611 //
     /*  206335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206352 */     // MIs[0] rs1
     /*  206352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206364 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_RL),
     /*  206369 */     GIR_RootConstrainSelectedInstOperands,
     /*  206370 */     // GIR_Coverage, 611,
     /*  206370 */     GIR_Done,
     /*  206371 */   // Label 4141: @206371
     /*  206371 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(206412), // Rule ID 612 //
     /*  206376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206393 */     // MIs[0] rs1
     /*  206393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206405 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  206410 */     GIR_RootConstrainSelectedInstOperands,
     /*  206411 */     // GIR_Coverage, 612,
     /*  206411 */     GIR_Done,
     /*  206412 */   // Label 4142: @206412
     /*  206412 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(206453), // Rule ID 613 //
     /*  206417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  206420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206434 */     // MIs[0] rs1
     /*  206434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206446 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  206451 */     GIR_RootConstrainSelectedInstOperands,
     /*  206452 */     // GIR_Coverage, 613,
     /*  206452 */     GIR_Done,
     /*  206453 */   // Label 4143: @206453
     /*  206453 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(206494), // Rule ID 614 //
     /*  206458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206475 */     // MIs[0] rs1
     /*  206475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206487 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206492 */     GIR_RootConstrainSelectedInstOperands,
     /*  206493 */     // GIR_Coverage, 614,
     /*  206493 */     GIR_Done,
     /*  206494 */   // Label 4144: @206494
     /*  206494 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(206535), // Rule ID 615 //
     /*  206499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206516 */     // MIs[0] rs1
     /*  206516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206528 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206533 */     GIR_RootConstrainSelectedInstOperands,
     /*  206534 */     // GIR_Coverage, 615,
     /*  206534 */     GIR_Done,
     /*  206535 */   // Label 4145: @206535
     /*  206535 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(206576), // Rule ID 616 //
     /*  206540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206543 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206550 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206557 */     // MIs[0] rs1
     /*  206557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206569 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206574 */     GIR_RootConstrainSelectedInstOperands,
     /*  206575 */     // GIR_Coverage, 616,
     /*  206575 */     GIR_Done,
     /*  206576 */   // Label 4146: @206576
     /*  206576 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(206617), // Rule ID 617 //
     /*  206581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206598 */     // MIs[0] rs1
     /*  206598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206610 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206615 */     GIR_RootConstrainSelectedInstOperands,
     /*  206616 */     // GIR_Coverage, 617,
     /*  206616 */     GIR_Done,
     /*  206617 */   // Label 4147: @206617
     /*  206617 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(206658), // Rule ID 618 //
     /*  206622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206625 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206632 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206639 */     // MIs[0] rs1
     /*  206639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206651 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206656 */     GIR_RootConstrainSelectedInstOperands,
     /*  206657 */     // GIR_Coverage, 618,
     /*  206657 */     GIR_Done,
     /*  206658 */   // Label 4148: @206658
     /*  206658 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(206699), // Rule ID 857 //
     /*  206663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206680 */     // MIs[0] rs1
     /*  206680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206692 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206697 */     GIR_RootConstrainSelectedInstOperands,
     /*  206698 */     // GIR_Coverage, 857,
     /*  206698 */     GIR_Done,
     /*  206699 */   // Label 4149: @206699
     /*  206699 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(206740), // Rule ID 859 //
     /*  206704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206721 */     // MIs[0] rs1
     /*  206721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206733 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  206738 */     GIR_RootConstrainSelectedInstOperands,
     /*  206739 */     // GIR_Coverage, 859,
     /*  206739 */     GIR_Done,
     /*  206740 */   // Label 4150: @206740
     /*  206740 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(206781), // Rule ID 861 //
     /*  206745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206748 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206755 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206762 */     // MIs[0] rs1
     /*  206762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206774 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  206779 */     GIR_RootConstrainSelectedInstOperands,
     /*  206780 */     // GIR_Coverage, 861,
     /*  206780 */     GIR_Done,
     /*  206781 */   // Label 4151: @206781
     /*  206781 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(206822), // Rule ID 863 //
     /*  206786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206789 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206796 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206803 */     // MIs[0] rs1
     /*  206803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206815 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  206820 */     GIR_RootConstrainSelectedInstOperands,
     /*  206821 */     // GIR_Coverage, 863,
     /*  206821 */     GIR_Done,
     /*  206822 */   // Label 4152: @206822
     /*  206822 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(206863), // Rule ID 865 //
     /*  206827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206844 */     // MIs[0] rs1
     /*  206844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206856 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  206861 */     GIR_RootConstrainSelectedInstOperands,
     /*  206862 */     // GIR_Coverage, 865,
     /*  206862 */     GIR_Done,
     /*  206863 */   // Label 4153: @206863
     /*  206863 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(206904), // Rule ID 867 //
     /*  206868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206885 */     // MIs[0] rs1
     /*  206885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206897 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206902 */     GIR_RootConstrainSelectedInstOperands,
     /*  206903 */     // GIR_Coverage, 867,
     /*  206903 */     GIR_Done,
     /*  206904 */   // Label 4154: @206904
     /*  206904 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(206945), // Rule ID 869 //
     /*  206909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206926 */     // MIs[0] rs1
     /*  206926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206938 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206943 */     GIR_RootConstrainSelectedInstOperands,
     /*  206944 */     // GIR_Coverage, 869,
     /*  206944 */     GIR_Done,
     /*  206945 */   // Label 4155: @206945
     /*  206945 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(206986), // Rule ID 871 //
     /*  206950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206967 */     // MIs[0] rs1
     /*  206967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206979 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206984 */     GIR_RootConstrainSelectedInstOperands,
     /*  206985 */     // GIR_Coverage, 871,
     /*  206985 */     GIR_Done,
     /*  206986 */   // Label 4156: @206986
     /*  206986 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(207027), // Rule ID 873 //
     /*  206991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207001 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207008 */     // MIs[0] rs1
     /*  207008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207020 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207025 */     GIR_RootConstrainSelectedInstOperands,
     /*  207026 */     // GIR_Coverage, 873,
     /*  207026 */     GIR_Done,
     /*  207027 */   // Label 4157: @207027
     /*  207027 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(207068), // Rule ID 875 //
     /*  207032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  207042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207049 */     // MIs[0] rs1
     /*  207049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207061 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  207066 */     GIR_RootConstrainSelectedInstOperands,
     /*  207067 */     // GIR_Coverage, 875,
     /*  207067 */     GIR_Done,
     /*  207068 */   // Label 4158: @207068
     /*  207068 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(207109), // Rule ID 1037 //
     /*  207073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207090 */     // MIs[0] rs1
     /*  207090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207102 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207107 */     GIR_RootConstrainSelectedInstOperands,
     /*  207108 */     // GIR_Coverage, 1037,
     /*  207108 */     GIR_Done,
     /*  207109 */   // Label 4159: @207109
     /*  207109 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(207150), // Rule ID 1039 //
     /*  207114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207131 */     // MIs[0] rs1
     /*  207131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207143 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  207148 */     GIR_RootConstrainSelectedInstOperands,
     /*  207149 */     // GIR_Coverage, 1039,
     /*  207149 */     GIR_Done,
     /*  207150 */   // Label 4160: @207150
     /*  207150 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(207191), // Rule ID 1041 //
     /*  207155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207172 */     // MIs[0] rs1
     /*  207172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207184 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  207189 */     GIR_RootConstrainSelectedInstOperands,
     /*  207190 */     // GIR_Coverage, 1041,
     /*  207190 */     GIR_Done,
     /*  207191 */   // Label 4161: @207191
     /*  207191 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(207232), // Rule ID 1043 //
     /*  207196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207213 */     // MIs[0] rs1
     /*  207213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207225 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  207230 */     GIR_RootConstrainSelectedInstOperands,
     /*  207231 */     // GIR_Coverage, 1043,
     /*  207231 */     GIR_Done,
     /*  207232 */   // Label 4162: @207232
     /*  207232 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(207273), // Rule ID 1045 //
     /*  207237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  207240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207254 */     // MIs[0] rs1
     /*  207254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207266 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  207271 */     GIR_RootConstrainSelectedInstOperands,
     /*  207272 */     // GIR_Coverage, 1045,
     /*  207272 */     GIR_Done,
     /*  207273 */   // Label 4163: @207273
     /*  207273 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(207314), // Rule ID 1047 //
     /*  207278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207281 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  207291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207295 */     // MIs[0] rs1
     /*  207295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207307 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207312 */     GIR_RootConstrainSelectedInstOperands,
     /*  207313 */     // GIR_Coverage, 1047,
     /*  207313 */     GIR_Done,
     /*  207314 */   // Label 4164: @207314
     /*  207314 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(207355), // Rule ID 1049 //
     /*  207319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207322 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  207332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207336 */     // MIs[0] rs1
     /*  207336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207348 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207353 */     GIR_RootConstrainSelectedInstOperands,
     /*  207354 */     // GIR_Coverage, 1049,
     /*  207354 */     GIR_Done,
     /*  207355 */   // Label 4165: @207355
     /*  207355 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(207396), // Rule ID 1051 //
     /*  207360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  207373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207377 */     // MIs[0] rs1
     /*  207377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207389 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207394 */     GIR_RootConstrainSelectedInstOperands,
     /*  207395 */     // GIR_Coverage, 1051,
     /*  207395 */     GIR_Done,
     /*  207396 */   // Label 4166: @207396
     /*  207396 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(207437), // Rule ID 1053 //
     /*  207401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  207414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207418 */     // MIs[0] rs1
     /*  207418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207430 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207435 */     GIR_RootConstrainSelectedInstOperands,
     /*  207436 */     // GIR_Coverage, 1053,
     /*  207436 */     GIR_Done,
     /*  207437 */   // Label 4167: @207437
     /*  207437 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(207478), // Rule ID 1055 //
     /*  207442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  207445 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  207452 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  207455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207459 */     // MIs[0] rs1
     /*  207459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  207463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  207471 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  207471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  207476 */     GIR_RootConstrainSelectedInstOperands,
     /*  207477 */     // GIR_Coverage, 1055,
     /*  207477 */     GIR_Done,
     /*  207478 */   // Label 4168: @207478
     /*  207478 */   GIM_Reject,
     /*  207479 */ // Label 4128: @207479
     /*  207479 */ GIM_Reject,
     /*  207480 */ // Label 4096: @207480
     /*  207480 */ GIM_Reject,
     /*  207481 */ // Label 36: @207481
     /*  207481 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4171*/ GIMT_Encode4(207698),
     /*  207492 */ /*GILLT_s32*//*Label 4169*/ GIMT_Encode4(207500),
     /*  207496 */ /*GILLT_s64*//*Label 4170*/ GIMT_Encode4(207599),
     /*  207500 */ // Label 4169: @207500
     /*  207500 */ GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(207526), // Rule ID 251 //
     /*  207505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207508 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  207512 */   // MIs[0] Operand 1
     /*  207512 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207515 */   // (atomic_fence 4:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 2:{ *:[i32] }, 3:{ *:[i32] })
     /*  207515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  207521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207524 */   GIR_RootConstrainSelectedInstOperands,
     /*  207525 */   // GIR_Coverage, 251,
     /*  207525 */   GIR_EraseRootFromParent_Done,
     /*  207526 */ // Label 4172: @207526
     /*  207526 */ GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(207552), // Rule ID 253 //
     /*  207531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207534 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  207538 */   // MIs[0] Operand 1
     /*  207538 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207541 */   // (atomic_fence 5:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  207541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  207550 */   GIR_RootConstrainSelectedInstOperands,
     /*  207551 */   // GIR_Coverage, 253,
     /*  207551 */   GIR_EraseRootFromParent_Done,
     /*  207552 */ // Label 4173: @207552
     /*  207552 */ GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(207572), // Rule ID 255 //
     /*  207557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207560 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  207564 */   // MIs[0] Operand 1
     /*  207564 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207567 */   // (atomic_fence 6:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE_TSO)
     /*  207567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  207570 */   GIR_RootConstrainSelectedInstOperands,
     /*  207571 */   // GIR_Coverage, 255,
     /*  207571 */   GIR_EraseRootFromParent_Done,
     /*  207572 */ // Label 4174: @207572
     /*  207572 */ GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(207598), // Rule ID 257 //
     /*  207577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207580 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  207584 */   // MIs[0] Operand 1
     /*  207584 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207587 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  207587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207596 */   GIR_RootConstrainSelectedInstOperands,
     /*  207597 */   // GIR_Coverage, 257,
     /*  207597 */   GIR_EraseRootFromParent_Done,
     /*  207598 */ // Label 4175: @207598
     /*  207598 */ GIM_Reject,
     /*  207599 */ // Label 4170: @207599
     /*  207599 */ GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(207625), // Rule ID 250 //
     /*  207604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207607 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  207611 */   // MIs[0] Operand 1
     /*  207611 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207614 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 2:{ *:[i64] }, 3:{ *:[i64] })
     /*  207614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  207620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207623 */   GIR_RootConstrainSelectedInstOperands,
     /*  207624 */   // GIR_Coverage, 250,
     /*  207624 */   GIR_EraseRootFromParent_Done,
     /*  207625 */ // Label 4176: @207625
     /*  207625 */ GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(207651), // Rule ID 252 //
     /*  207630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207633 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  207637 */   // MIs[0] Operand 1
     /*  207637 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207640 */   // (atomic_fence 5:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  207640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  207649 */   GIR_RootConstrainSelectedInstOperands,
     /*  207650 */   // GIR_Coverage, 252,
     /*  207650 */   GIR_EraseRootFromParent_Done,
     /*  207651 */ // Label 4177: @207651
     /*  207651 */ GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(207671), // Rule ID 254 //
     /*  207656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207659 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  207663 */   // MIs[0] Operand 1
     /*  207663 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207666 */   // (atomic_fence 6:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE_TSO)
     /*  207666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  207669 */   GIR_RootConstrainSelectedInstOperands,
     /*  207670 */   // GIR_Coverage, 254,
     /*  207670 */   GIR_EraseRootFromParent_Done,
     /*  207671 */ // Label 4178: @207671
     /*  207671 */ GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(207697), // Rule ID 256 //
     /*  207676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207679 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  207683 */   // MIs[0] Operand 1
     /*  207683 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207686 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  207686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207695 */   GIR_RootConstrainSelectedInstOperands,
     /*  207696 */   // GIR_Coverage, 256,
     /*  207696 */   GIR_EraseRootFromParent_Done,
     /*  207697 */ // Label 4179: @207697
     /*  207697 */ GIM_Reject,
     /*  207698 */ // Label 4171: @207698
     /*  207698 */ GIM_Reject,
     /*  207699 */ // Label 37: @207699
     /*  207699 */ GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(209184),
     /*  207704 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  207707 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(207752), // Rule ID 2712 //
     /*  207712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  207723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207737 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  207740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207750 */     GIR_RootConstrainSelectedInstOperands,
     /*  207751 */     // GIR_Coverage, 2712,
     /*  207751 */     GIR_EraseRootFromParent_Done,
     /*  207752 */   // Label 4181: @207752
     /*  207752 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(207797), // Rule ID 2713 //
     /*  207757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  207768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207782 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  207785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207795 */     GIR_RootConstrainSelectedInstOperands,
     /*  207796 */     // GIR_Coverage, 2713,
     /*  207796 */     GIR_EraseRootFromParent_Done,
     /*  207797 */   // Label 4182: @207797
     /*  207797 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(207842), // Rule ID 23262 //
     /*  207802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  207813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207827 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  207830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207840 */     GIR_RootConstrainSelectedInstOperands,
     /*  207841 */     // GIR_Coverage, 23262,
     /*  207841 */     GIR_EraseRootFromParent_Done,
     /*  207842 */   // Label 4183: @207842
     /*  207842 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(207887), // Rule ID 23263 //
     /*  207847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  207858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207872 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  207875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207885 */     GIR_RootConstrainSelectedInstOperands,
     /*  207886 */     // GIR_Coverage, 23263,
     /*  207886 */     GIR_EraseRootFromParent_Done,
     /*  207887 */   // Label 4184: @207887
     /*  207887 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(207932), // Rule ID 23264 //
     /*  207892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  207903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207917 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  207920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207930 */     GIR_RootConstrainSelectedInstOperands,
     /*  207931 */     // GIR_Coverage, 23264,
     /*  207931 */     GIR_EraseRootFromParent_Done,
     /*  207932 */   // Label 4185: @207932
     /*  207932 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(207977), // Rule ID 23265 //
     /*  207937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  207948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207962 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  207965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207975 */     GIR_RootConstrainSelectedInstOperands,
     /*  207976 */     // GIR_Coverage, 23265,
     /*  207976 */     GIR_EraseRootFromParent_Done,
     /*  207977 */   // Label 4186: @207977
     /*  207977 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(208022), // Rule ID 23266 //
     /*  207982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  207993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  208010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208020 */     GIR_RootConstrainSelectedInstOperands,
     /*  208021 */     // GIR_Coverage, 23266,
     /*  208021 */     GIR_EraseRootFromParent_Done,
     /*  208022 */   // Label 4187: @208022
     /*  208022 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(208067), // Rule ID 23267 //
     /*  208027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208052 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  208055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208065 */     GIR_RootConstrainSelectedInstOperands,
     /*  208066 */     // GIR_Coverage, 23267,
     /*  208066 */     GIR_EraseRootFromParent_Done,
     /*  208067 */   // Label 4188: @208067
     /*  208067 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(208112), // Rule ID 23268 //
     /*  208072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208097 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  208100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208110 */     GIR_RootConstrainSelectedInstOperands,
     /*  208111 */     // GIR_Coverage, 23268,
     /*  208111 */     GIR_EraseRootFromParent_Done,
     /*  208112 */   // Label 4189: @208112
     /*  208112 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(208157), // Rule ID 23269 //
     /*  208117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208142 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  208145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208155 */     GIR_RootConstrainSelectedInstOperands,
     /*  208156 */     // GIR_Coverage, 23269,
     /*  208156 */     GIR_EraseRootFromParent_Done,
     /*  208157 */   // Label 4190: @208157
     /*  208157 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(208202), // Rule ID 23270 //
     /*  208162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208187 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  208190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208200 */     GIR_RootConstrainSelectedInstOperands,
     /*  208201 */     // GIR_Coverage, 23270,
     /*  208201 */     GIR_EraseRootFromParent_Done,
     /*  208202 */   // Label 4191: @208202
     /*  208202 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(208247), // Rule ID 23271 //
     /*  208207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208232 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  208235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208245 */     GIR_RootConstrainSelectedInstOperands,
     /*  208246 */     // GIR_Coverage, 23271,
     /*  208246 */     GIR_EraseRootFromParent_Done,
     /*  208247 */   // Label 4192: @208247
     /*  208247 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(208292), // Rule ID 23272 //
     /*  208252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208277 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  208280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208290 */     GIR_RootConstrainSelectedInstOperands,
     /*  208291 */     // GIR_Coverage, 23272,
     /*  208291 */     GIR_EraseRootFromParent_Done,
     /*  208292 */   // Label 4193: @208292
     /*  208292 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(208337), // Rule ID 23273 //
     /*  208297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  208305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208322 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11418:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  208325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208335 */     GIR_RootConstrainSelectedInstOperands,
     /*  208336 */     // GIR_Coverage, 23273,
     /*  208336 */     GIR_EraseRootFromParent_Done,
     /*  208337 */   // Label 4194: @208337
     /*  208337 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(208382), // Rule ID 23274 //
     /*  208342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208367 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  208370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208380 */     GIR_RootConstrainSelectedInstOperands,
     /*  208381 */     // GIR_Coverage, 23274,
     /*  208381 */     GIR_EraseRootFromParent_Done,
     /*  208382 */   // Label 4195: @208382
     /*  208382 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(208427), // Rule ID 23275 //
     /*  208387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208412 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  208415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208425 */     GIR_RootConstrainSelectedInstOperands,
     /*  208426 */     // GIR_Coverage, 23275,
     /*  208426 */     GIR_EraseRootFromParent_Done,
     /*  208427 */   // Label 4196: @208427
     /*  208427 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(208472), // Rule ID 23276 //
     /*  208432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208457 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  208460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208470 */     GIR_RootConstrainSelectedInstOperands,
     /*  208471 */     // GIR_Coverage, 23276,
     /*  208471 */     GIR_EraseRootFromParent_Done,
     /*  208472 */   // Label 4197: @208472
     /*  208472 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(208517), // Rule ID 23277 //
     /*  208477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  208488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  208505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208515 */     GIR_RootConstrainSelectedInstOperands,
     /*  208516 */     // GIR_Coverage, 23277,
     /*  208516 */     GIR_EraseRootFromParent_Done,
     /*  208517 */   // Label 4198: @208517
     /*  208517 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(208562), // Rule ID 23278 //
     /*  208522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208547 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  208550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208560 */     GIR_RootConstrainSelectedInstOperands,
     /*  208561 */     // GIR_Coverage, 23278,
     /*  208561 */     GIR_EraseRootFromParent_Done,
     /*  208562 */   // Label 4199: @208562
     /*  208562 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(208607), // Rule ID 23279 //
     /*  208567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208592 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  208595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208605 */     GIR_RootConstrainSelectedInstOperands,
     /*  208606 */     // GIR_Coverage, 23279,
     /*  208606 */     GIR_EraseRootFromParent_Done,
     /*  208607 */   // Label 4200: @208607
     /*  208607 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(208652), // Rule ID 23280 //
     /*  208612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208637 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  208640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208650 */     GIR_RootConstrainSelectedInstOperands,
     /*  208651 */     // GIR_Coverage, 23280,
     /*  208651 */     GIR_EraseRootFromParent_Done,
     /*  208652 */   // Label 4201: @208652
     /*  208652 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(208697), // Rule ID 23281 //
     /*  208657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208682 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  208685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208695 */     GIR_RootConstrainSelectedInstOperands,
     /*  208696 */     // GIR_Coverage, 23281,
     /*  208696 */     GIR_EraseRootFromParent_Done,
     /*  208697 */   // Label 4202: @208697
     /*  208697 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(208742), // Rule ID 23282 //
     /*  208702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208727 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  208730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208740 */     GIR_RootConstrainSelectedInstOperands,
     /*  208741 */     // GIR_Coverage, 23282,
     /*  208741 */     GIR_EraseRootFromParent_Done,
     /*  208742 */   // Label 4203: @208742
     /*  208742 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(208787), // Rule ID 23283 //
     /*  208747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208772 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  208775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208785 */     GIR_RootConstrainSelectedInstOperands,
     /*  208786 */     // GIR_Coverage, 23283,
     /*  208786 */     GIR_EraseRootFromParent_Done,
     /*  208787 */   // Label 4204: @208787
     /*  208787 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(208832), // Rule ID 23284 //
     /*  208792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208817 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  208820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208830 */     GIR_RootConstrainSelectedInstOperands,
     /*  208831 */     // GIR_Coverage, 23284,
     /*  208831 */     GIR_EraseRootFromParent_Done,
     /*  208832 */   // Label 4205: @208832
     /*  208832 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(208877), // Rule ID 23285 //
     /*  208837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208862 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  208865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208875 */     GIR_RootConstrainSelectedInstOperands,
     /*  208876 */     // GIR_Coverage, 23285,
     /*  208876 */     GIR_EraseRootFromParent_Done,
     /*  208877 */   // Label 4206: @208877
     /*  208877 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(208922), // Rule ID 23286 //
     /*  208882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208907 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  208910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208920 */     GIR_RootConstrainSelectedInstOperands,
     /*  208921 */     // GIR_Coverage, 23286,
     /*  208921 */     GIR_EraseRootFromParent_Done,
     /*  208922 */   // Label 4207: @208922
     /*  208922 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(208967), // Rule ID 23287 //
     /*  208927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208952 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11446:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  208955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208965 */     GIR_RootConstrainSelectedInstOperands,
     /*  208966 */     // GIR_Coverage, 23287,
     /*  208966 */     GIR_EraseRootFromParent_Done,
     /*  208967 */   // Label 4208: @208967
     /*  208967 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(209003), // Rule ID 2649 //
     /*  208972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  208975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64im),
     /*  208980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  208983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208994 */     // (intrinsic_wo_chain:{ *:[i64] } 10964:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (AES64IM:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  208994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64IM),
     /*  208997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209001 */     GIR_RootConstrainSelectedInstOperands,
     /*  209002 */     // GIR_Coverage, 2649,
     /*  209002 */     GIR_EraseRootFromParent_Done,
     /*  209003 */   // Label 4209: @209003
     /*  209003 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(209039), // Rule ID 2670 //
     /*  209008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0),
     /*  209016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209030 */     // (intrinsic_wo_chain:{ *:[i64] } 11113:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0),
     /*  209033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209037 */     GIR_RootConstrainSelectedInstOperands,
     /*  209038 */     // GIR_Coverage, 2670,
     /*  209038 */     GIR_EraseRootFromParent_Done,
     /*  209039 */   // Label 4210: @209039
     /*  209039 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(209075), // Rule ID 2671 //
     /*  209044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1),
     /*  209052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209066 */     // (intrinsic_wo_chain:{ *:[i64] } 11116:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1),
     /*  209069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209073 */     GIR_RootConstrainSelectedInstOperands,
     /*  209074 */     // GIR_Coverage, 2671,
     /*  209074 */     GIR_EraseRootFromParent_Done,
     /*  209075 */   // Label 4211: @209075
     /*  209075 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(209111), // Rule ID 2672 //
     /*  209080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0),
     /*  209088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209102 */     // (intrinsic_wo_chain:{ *:[i64] } 11119:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0),
     /*  209105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209109 */     GIR_RootConstrainSelectedInstOperands,
     /*  209110 */     // GIR_Coverage, 2672,
     /*  209110 */     GIR_EraseRootFromParent_Done,
     /*  209111 */   // Label 4212: @209111
     /*  209111 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(209147), // Rule ID 2673 //
     /*  209116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  209119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1),
     /*  209124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  209130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209138 */     // (intrinsic_wo_chain:{ *:[i64] } 11121:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  209138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1),
     /*  209141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209145 */     GIR_RootConstrainSelectedInstOperands,
     /*  209146 */     // GIR_Coverage, 2673,
     /*  209146 */     GIR_EraseRootFromParent_Done,
     /*  209147 */   // Label 4213: @209147
     /*  209147 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(209183), // Rule ID 64440 //
     /*  209152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  209155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_clb),
     /*  209160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  209166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209174 */     // (intrinsic_wo_chain:{ *:[i32] } 10984:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1)  =>  (CV_CLB:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  209174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLB),
     /*  209177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209181 */     GIR_RootConstrainSelectedInstOperands,
     /*  209182 */     // GIR_Coverage, 64440,
     /*  209182 */     GIR_EraseRootFromParent_Done,
     /*  209183 */   // Label 4214: @209183
     /*  209183 */   GIM_Reject,
     /*  209184 */ // Label 4180: @209184
     /*  209184 */ GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(216472),
     /*  209189 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  209192 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(209246), // Rule ID 2682 //
     /*  209197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209229 */     // (intrinsic_wo_chain:{ *:[i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  209232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209244 */     GIR_RootConstrainSelectedInstOperands,
     /*  209245 */     // GIR_Coverage, 2682,
     /*  209245 */     GIR_EraseRootFromParent_Done,
     /*  209246 */   // Label 4216: @209246
     /*  209246 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(209300), // Rule ID 2683 //
     /*  209251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209283 */     // (intrinsic_wo_chain:{ *:[i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  209286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209298 */     GIR_RootConstrainSelectedInstOperands,
     /*  209299 */     // GIR_Coverage, 2683,
     /*  209299 */     GIR_EraseRootFromParent_Done,
     /*  209300 */   // Label 4217: @209300
     /*  209300 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(209354), // Rule ID 2688 //
     /*  209305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  209313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209337 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  209340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209352 */     GIR_RootConstrainSelectedInstOperands,
     /*  209353 */     // GIR_Coverage, 2688,
     /*  209353 */     GIR_EraseRootFromParent_Done,
     /*  209354 */   // Label 4218: @209354
     /*  209354 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(209408), // Rule ID 2689 //
     /*  209359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  209367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  209370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209391 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  209394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  209398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209406 */     GIR_RootConstrainSelectedInstOperands,
     /*  209407 */     // GIR_Coverage, 2689,
     /*  209407 */     GIR_EraseRootFromParent_Done,
     /*  209408 */   // Label 4219: @209408
     /*  209408 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(209465), // Rule ID 2708 //
     /*  209413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  209416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  209421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  209424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  209427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209445 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  209445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  209448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  209452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209463 */     GIR_RootConstrainSelectedInstOperands,
     /*  209464 */     // GIR_Coverage, 2708,
     /*  209464 */     GIR_EraseRootFromParent_Done,
     /*  209465 */   // Label 4220: @209465
     /*  209465 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(209522), // Rule ID 2709 //
     /*  209470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  209473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  209478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  209481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  209484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209502 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  209502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  209505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  209509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209520 */     GIR_RootConstrainSelectedInstOperands,
     /*  209521 */     // GIR_Coverage, 2709,
     /*  209521 */     GIR_EraseRootFromParent_Done,
     /*  209522 */   // Label 4221: @209522
     /*  209522 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(209576), // Rule ID 23288 //
     /*  209527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  209541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209559 */     // (intrinsic_wo_chain:{ *:[i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  209562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209574 */     GIR_RootConstrainSelectedInstOperands,
     /*  209575 */     // GIR_Coverage, 23288,
     /*  209575 */     GIR_EraseRootFromParent_Done,
     /*  209576 */   // Label 4222: @209576
     /*  209576 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(209630), // Rule ID 23289 //
     /*  209581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  209595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209613 */     // (intrinsic_wo_chain:{ *:[i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  209616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209628 */     GIR_RootConstrainSelectedInstOperands,
     /*  209629 */     // GIR_Coverage, 23289,
     /*  209629 */     GIR_EraseRootFromParent_Done,
     /*  209630 */   // Label 4223: @209630
     /*  209630 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(209684), // Rule ID 23292 //
     /*  209635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  209649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209667 */     // (intrinsic_wo_chain:{ *:[i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  209670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209682 */     GIR_RootConstrainSelectedInstOperands,
     /*  209683 */     // GIR_Coverage, 23292,
     /*  209683 */     GIR_EraseRootFromParent_Done,
     /*  209684 */   // Label 4224: @209684
     /*  209684 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(209738), // Rule ID 23293 //
     /*  209689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  209703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209721 */     // (intrinsic_wo_chain:{ *:[i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  209724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209736 */     GIR_RootConstrainSelectedInstOperands,
     /*  209737 */     // GIR_Coverage, 23293,
     /*  209737 */     GIR_EraseRootFromParent_Done,
     /*  209738 */   // Label 4225: @209738
     /*  209738 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(209792), // Rule ID 23296 //
     /*  209743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  209757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209775 */     // (intrinsic_wo_chain:{ *:[i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  209778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209790 */     GIR_RootConstrainSelectedInstOperands,
     /*  209791 */     // GIR_Coverage, 23296,
     /*  209791 */     GIR_EraseRootFromParent_Done,
     /*  209792 */   // Label 4226: @209792
     /*  209792 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(209846), // Rule ID 23297 //
     /*  209797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  209811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209829 */     // (intrinsic_wo_chain:{ *:[i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  209832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209844 */     GIR_RootConstrainSelectedInstOperands,
     /*  209845 */     // GIR_Coverage, 23297,
     /*  209845 */     GIR_EraseRootFromParent_Done,
     /*  209846 */   // Label 4227: @209846
     /*  209846 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(209900), // Rule ID 23300 //
     /*  209851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  209865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209883 */     // (intrinsic_wo_chain:{ *:[i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  209886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209898 */     GIR_RootConstrainSelectedInstOperands,
     /*  209899 */     // GIR_Coverage, 23300,
     /*  209899 */     GIR_EraseRootFromParent_Done,
     /*  209900 */   // Label 4228: @209900
     /*  209900 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(209954), // Rule ID 23301 //
     /*  209905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  209919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209937 */     // (intrinsic_wo_chain:{ *:[i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  209940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209952 */     GIR_RootConstrainSelectedInstOperands,
     /*  209953 */     // GIR_Coverage, 23301,
     /*  209953 */     GIR_EraseRootFromParent_Done,
     /*  209954 */   // Label 4229: @209954
     /*  209954 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(210008), // Rule ID 23304 //
     /*  209959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  209973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209991 */     // (intrinsic_wo_chain:{ *:[i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  209994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210006 */     GIR_RootConstrainSelectedInstOperands,
     /*  210007 */     // GIR_Coverage, 23304,
     /*  210007 */     GIR_EraseRootFromParent_Done,
     /*  210008 */   // Label 4230: @210008
     /*  210008 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(210062), // Rule ID 23305 //
     /*  210013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210045 */     // (intrinsic_wo_chain:{ *:[i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  210048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210060 */     GIR_RootConstrainSelectedInstOperands,
     /*  210061 */     // GIR_Coverage, 23305,
     /*  210061 */     GIR_EraseRootFromParent_Done,
     /*  210062 */   // Label 4231: @210062
     /*  210062 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(210116), // Rule ID 23308 //
     /*  210067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210099 */     // (intrinsic_wo_chain:{ *:[i64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  210102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210114 */     GIR_RootConstrainSelectedInstOperands,
     /*  210115 */     // GIR_Coverage, 23308,
     /*  210115 */     GIR_EraseRootFromParent_Done,
     /*  210116 */   // Label 4232: @210116
     /*  210116 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(210170), // Rule ID 23309 //
     /*  210121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  210129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210153 */     // (intrinsic_wo_chain:{ *:[i32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  210156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210168 */     GIR_RootConstrainSelectedInstOperands,
     /*  210169 */     // GIR_Coverage, 23309,
     /*  210169 */     GIR_EraseRootFromParent_Done,
     /*  210170 */   // Label 4233: @210170
     /*  210170 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(210224), // Rule ID 23312 //
     /*  210175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  210189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210207 */     // (intrinsic_wo_chain:{ *:[i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  210210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210222 */     GIR_RootConstrainSelectedInstOperands,
     /*  210223 */     // GIR_Coverage, 23312,
     /*  210223 */     GIR_EraseRootFromParent_Done,
     /*  210224 */   // Label 4234: @210224
     /*  210224 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(210278), // Rule ID 23313 //
     /*  210229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  210243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210261 */     // (intrinsic_wo_chain:{ *:[i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  210264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210276 */     GIR_RootConstrainSelectedInstOperands,
     /*  210277 */     // GIR_Coverage, 23313,
     /*  210277 */     GIR_EraseRootFromParent_Done,
     /*  210278 */   // Label 4235: @210278
     /*  210278 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(210332), // Rule ID 23316 //
     /*  210283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210315 */     // (intrinsic_wo_chain:{ *:[i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  210318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210330 */     GIR_RootConstrainSelectedInstOperands,
     /*  210331 */     // GIR_Coverage, 23316,
     /*  210331 */     GIR_EraseRootFromParent_Done,
     /*  210332 */   // Label 4236: @210332
     /*  210332 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(210386), // Rule ID 23317 //
     /*  210337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210369 */     // (intrinsic_wo_chain:{ *:[i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  210372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210384 */     GIR_RootConstrainSelectedInstOperands,
     /*  210385 */     // GIR_Coverage, 23317,
     /*  210385 */     GIR_EraseRootFromParent_Done,
     /*  210386 */   // Label 4237: @210386
     /*  210386 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(210440), // Rule ID 23320 //
     /*  210391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210423 */     // (intrinsic_wo_chain:{ *:[i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  210426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210438 */     GIR_RootConstrainSelectedInstOperands,
     /*  210439 */     // GIR_Coverage, 23320,
     /*  210439 */     GIR_EraseRootFromParent_Done,
     /*  210440 */   // Label 4238: @210440
     /*  210440 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(210494), // Rule ID 23321 //
     /*  210445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210477 */     // (intrinsic_wo_chain:{ *:[i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  210480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210492 */     GIR_RootConstrainSelectedInstOperands,
     /*  210493 */     // GIR_Coverage, 23321,
     /*  210493 */     GIR_EraseRootFromParent_Done,
     /*  210494 */   // Label 4239: @210494
     /*  210494 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(210548), // Rule ID 23324 //
     /*  210499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210531 */     // (intrinsic_wo_chain:{ *:[i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  210534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210546 */     GIR_RootConstrainSelectedInstOperands,
     /*  210547 */     // GIR_Coverage, 23324,
     /*  210547 */     GIR_EraseRootFromParent_Done,
     /*  210548 */   // Label 4240: @210548
     /*  210548 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(210602), // Rule ID 23325 //
     /*  210553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210585 */     // (intrinsic_wo_chain:{ *:[i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  210588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210600 */     GIR_RootConstrainSelectedInstOperands,
     /*  210601 */     // GIR_Coverage, 23325,
     /*  210601 */     GIR_EraseRootFromParent_Done,
     /*  210602 */   // Label 4241: @210602
     /*  210602 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(210656), // Rule ID 23328 //
     /*  210607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210639 */     // (intrinsic_wo_chain:{ *:[i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  210642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210654 */     GIR_RootConstrainSelectedInstOperands,
     /*  210655 */     // GIR_Coverage, 23328,
     /*  210655 */     GIR_EraseRootFromParent_Done,
     /*  210656 */   // Label 4242: @210656
     /*  210656 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(210710), // Rule ID 23329 //
     /*  210661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210693 */     // (intrinsic_wo_chain:{ *:[i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  210696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210708 */     GIR_RootConstrainSelectedInstOperands,
     /*  210709 */     // GIR_Coverage, 23329,
     /*  210709 */     GIR_EraseRootFromParent_Done,
     /*  210710 */   // Label 4243: @210710
     /*  210710 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(210764), // Rule ID 23332 //
     /*  210715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210747 */     // (intrinsic_wo_chain:{ *:[i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  210750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210762 */     GIR_RootConstrainSelectedInstOperands,
     /*  210763 */     // GIR_Coverage, 23332,
     /*  210763 */     GIR_EraseRootFromParent_Done,
     /*  210764 */   // Label 4244: @210764
     /*  210764 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(210818), // Rule ID 23333 //
     /*  210769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210801 */     // (intrinsic_wo_chain:{ *:[i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  210804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210816 */     GIR_RootConstrainSelectedInstOperands,
     /*  210817 */     // GIR_Coverage, 23333,
     /*  210817 */     GIR_EraseRootFromParent_Done,
     /*  210818 */   // Label 4245: @210818
     /*  210818 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(210872), // Rule ID 23336 //
     /*  210823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210855 */     // (intrinsic_wo_chain:{ *:[i64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  210858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210870 */     GIR_RootConstrainSelectedInstOperands,
     /*  210871 */     // GIR_Coverage, 23336,
     /*  210871 */     GIR_EraseRootFromParent_Done,
     /*  210872 */   // Label 4246: @210872
     /*  210872 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(210926), // Rule ID 23337 //
     /*  210877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210909 */     // (intrinsic_wo_chain:{ *:[i32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  210912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210924 */     GIR_RootConstrainSelectedInstOperands,
     /*  210925 */     // GIR_Coverage, 23337,
     /*  210925 */     GIR_EraseRootFromParent_Done,
     /*  210926 */   // Label 4247: @210926
     /*  210926 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(210980), // Rule ID 23340 //
     /*  210931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  210942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210963 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  210966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210978 */     GIR_RootConstrainSelectedInstOperands,
     /*  210979 */     // GIR_Coverage, 23340,
     /*  210979 */     GIR_EraseRootFromParent_Done,
     /*  210980 */   // Label 4248: @210980
     /*  210980 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(211034), // Rule ID 23341 //
     /*  210985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  210996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211017 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  211020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211032 */     GIR_RootConstrainSelectedInstOperands,
     /*  211033 */     // GIR_Coverage, 23341,
     /*  211033 */     GIR_EraseRootFromParent_Done,
     /*  211034 */   // Label 4249: @211034
     /*  211034 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(211088), // Rule ID 23344 //
     /*  211039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211071 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  211074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211086 */     GIR_RootConstrainSelectedInstOperands,
     /*  211087 */     // GIR_Coverage, 23344,
     /*  211087 */     GIR_EraseRootFromParent_Done,
     /*  211088 */   // Label 4250: @211088
     /*  211088 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(211142), // Rule ID 23345 //
     /*  211093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211125 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  211128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211140 */     GIR_RootConstrainSelectedInstOperands,
     /*  211141 */     // GIR_Coverage, 23345,
     /*  211141 */     GIR_EraseRootFromParent_Done,
     /*  211142 */   // Label 4251: @211142
     /*  211142 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(211196), // Rule ID 23348 //
     /*  211147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211179 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  211182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211194 */     GIR_RootConstrainSelectedInstOperands,
     /*  211195 */     // GIR_Coverage, 23348,
     /*  211195 */     GIR_EraseRootFromParent_Done,
     /*  211196 */   // Label 4252: @211196
     /*  211196 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(211250), // Rule ID 23349 //
     /*  211201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211233 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  211236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211248 */     GIR_RootConstrainSelectedInstOperands,
     /*  211249 */     // GIR_Coverage, 23349,
     /*  211249 */     GIR_EraseRootFromParent_Done,
     /*  211250 */   // Label 4253: @211250
     /*  211250 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(211304), // Rule ID 23352 //
     /*  211255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211287 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  211290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211302 */     GIR_RootConstrainSelectedInstOperands,
     /*  211303 */     // GIR_Coverage, 23352,
     /*  211303 */     GIR_EraseRootFromParent_Done,
     /*  211304 */   // Label 4254: @211304
     /*  211304 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(211358), // Rule ID 23353 //
     /*  211309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211341 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  211344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211356 */     GIR_RootConstrainSelectedInstOperands,
     /*  211357 */     // GIR_Coverage, 23353,
     /*  211357 */     GIR_EraseRootFromParent_Done,
     /*  211358 */   // Label 4255: @211358
     /*  211358 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(211412), // Rule ID 23356 //
     /*  211363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211395 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  211398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211410 */     GIR_RootConstrainSelectedInstOperands,
     /*  211411 */     // GIR_Coverage, 23356,
     /*  211411 */     GIR_EraseRootFromParent_Done,
     /*  211412 */   // Label 4256: @211412
     /*  211412 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(211466), // Rule ID 23357 //
     /*  211417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211449 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  211452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211464 */     GIR_RootConstrainSelectedInstOperands,
     /*  211465 */     // GIR_Coverage, 23357,
     /*  211465 */     GIR_EraseRootFromParent_Done,
     /*  211466 */   // Label 4257: @211466
     /*  211466 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(211520), // Rule ID 23360 //
     /*  211471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  211482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211503 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  211506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211518 */     GIR_RootConstrainSelectedInstOperands,
     /*  211519 */     // GIR_Coverage, 23360,
     /*  211519 */     GIR_EraseRootFromParent_Done,
     /*  211520 */   // Label 4258: @211520
     /*  211520 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(211574), // Rule ID 23361 //
     /*  211525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  211536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211557 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11442:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  211560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211572 */     GIR_RootConstrainSelectedInstOperands,
     /*  211573 */     // GIR_Coverage, 23361,
     /*  211573 */     GIR_EraseRootFromParent_Done,
     /*  211574 */   // Label 4259: @211574
     /*  211574 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(211628), // Rule ID 23364 //
     /*  211579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  211593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211611 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  211614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211626 */     GIR_RootConstrainSelectedInstOperands,
     /*  211627 */     // GIR_Coverage, 23364,
     /*  211627 */     GIR_EraseRootFromParent_Done,
     /*  211628 */   // Label 4260: @211628
     /*  211628 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(211682), // Rule ID 23365 //
     /*  211633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  211647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211665 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  211668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211680 */     GIR_RootConstrainSelectedInstOperands,
     /*  211681 */     // GIR_Coverage, 23365,
     /*  211681 */     GIR_EraseRootFromParent_Done,
     /*  211682 */   // Label 4261: @211682
     /*  211682 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(211736), // Rule ID 23368 //
     /*  211687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211719 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  211722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211734 */     GIR_RootConstrainSelectedInstOperands,
     /*  211735 */     // GIR_Coverage, 23368,
     /*  211735 */     GIR_EraseRootFromParent_Done,
     /*  211736 */   // Label 4262: @211736
     /*  211736 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(211790), // Rule ID 23369 //
     /*  211741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211773 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  211776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211788 */     GIR_RootConstrainSelectedInstOperands,
     /*  211789 */     // GIR_Coverage, 23369,
     /*  211789 */     GIR_EraseRootFromParent_Done,
     /*  211790 */   // Label 4263: @211790
     /*  211790 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(211844), // Rule ID 23372 //
     /*  211795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211827 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  211830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211842 */     GIR_RootConstrainSelectedInstOperands,
     /*  211843 */     // GIR_Coverage, 23372,
     /*  211843 */     GIR_EraseRootFromParent_Done,
     /*  211844 */   // Label 4264: @211844
     /*  211844 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(211898), // Rule ID 23373 //
     /*  211849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211881 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  211884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211896 */     GIR_RootConstrainSelectedInstOperands,
     /*  211897 */     // GIR_Coverage, 23373,
     /*  211897 */     GIR_EraseRootFromParent_Done,
     /*  211898 */   // Label 4265: @211898
     /*  211898 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(211952), // Rule ID 23376 //
     /*  211903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211935 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  211938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211950 */     GIR_RootConstrainSelectedInstOperands,
     /*  211951 */     // GIR_Coverage, 23376,
     /*  211951 */     GIR_EraseRootFromParent_Done,
     /*  211952 */   // Label 4266: @211952
     /*  211952 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(212006), // Rule ID 23377 //
     /*  211957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211989 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  211992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212004 */     GIR_RootConstrainSelectedInstOperands,
     /*  212005 */     // GIR_Coverage, 23377,
     /*  212005 */     GIR_EraseRootFromParent_Done,
     /*  212006 */   // Label 4267: @212006
     /*  212006 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(212060), // Rule ID 23380 //
     /*  212011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212043 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  212046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212058 */     GIR_RootConstrainSelectedInstOperands,
     /*  212059 */     // GIR_Coverage, 23380,
     /*  212059 */     GIR_EraseRootFromParent_Done,
     /*  212060 */   // Label 4268: @212060
     /*  212060 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(212114), // Rule ID 23381 //
     /*  212065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212097 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  212100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212112 */     GIR_RootConstrainSelectedInstOperands,
     /*  212113 */     // GIR_Coverage, 23381,
     /*  212113 */     GIR_EraseRootFromParent_Done,
     /*  212114 */   // Label 4269: @212114
     /*  212114 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(212168), // Rule ID 23384 //
     /*  212119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212151 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  212154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212166 */     GIR_RootConstrainSelectedInstOperands,
     /*  212167 */     // GIR_Coverage, 23384,
     /*  212167 */     GIR_EraseRootFromParent_Done,
     /*  212168 */   // Label 4270: @212168
     /*  212168 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(212222), // Rule ID 23385 //
     /*  212173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212205 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  212208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212220 */     GIR_RootConstrainSelectedInstOperands,
     /*  212221 */     // GIR_Coverage, 23385,
     /*  212221 */     GIR_EraseRootFromParent_Done,
     /*  212222 */   // Label 4271: @212222
     /*  212222 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(212276), // Rule ID 23388 //
     /*  212227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212259 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  212262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212274 */     GIR_RootConstrainSelectedInstOperands,
     /*  212275 */     // GIR_Coverage, 23388,
     /*  212275 */     GIR_EraseRootFromParent_Done,
     /*  212276 */   // Label 4272: @212276
     /*  212276 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(212330), // Rule ID 23389 //
     /*  212281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  212289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212313 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11455:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  212316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212328 */     GIR_RootConstrainSelectedInstOperands,
     /*  212329 */     // GIR_Coverage, 23389,
     /*  212329 */     GIR_EraseRootFromParent_Done,
     /*  212330 */   // Label 4273: @212330
     /*  212330 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(212384), // Rule ID 23392 //
     /*  212335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212367 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  212370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212382 */     GIR_RootConstrainSelectedInstOperands,
     /*  212383 */     // GIR_Coverage, 23392,
     /*  212383 */     GIR_EraseRootFromParent_Done,
     /*  212384 */   // Label 4274: @212384
     /*  212384 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(212438), // Rule ID 23393 //
     /*  212389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  212400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  212403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212421 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  212424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212436 */     GIR_RootConstrainSelectedInstOperands,
     /*  212437 */     // GIR_Coverage, 23393,
     /*  212437 */     GIR_EraseRootFromParent_Done,
     /*  212438 */   // Label 4275: @212438
     /*  212438 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(212492), // Rule ID 23396 //
     /*  212443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212475 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  212478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212490 */     GIR_RootConstrainSelectedInstOperands,
     /*  212491 */     // GIR_Coverage, 23396,
     /*  212491 */     GIR_EraseRootFromParent_Done,
     /*  212492 */   // Label 4276: @212492
     /*  212492 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(212546), // Rule ID 23397 //
     /*  212497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212529 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  212532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212544 */     GIR_RootConstrainSelectedInstOperands,
     /*  212545 */     // GIR_Coverage, 23397,
     /*  212545 */     GIR_EraseRootFromParent_Done,
     /*  212546 */   // Label 4277: @212546
     /*  212546 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(212600), // Rule ID 23400 //
     /*  212551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212583 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  212586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212598 */     GIR_RootConstrainSelectedInstOperands,
     /*  212599 */     // GIR_Coverage, 23400,
     /*  212599 */     GIR_EraseRootFromParent_Done,
     /*  212600 */   // Label 4278: @212600
     /*  212600 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(212654), // Rule ID 23401 //
     /*  212605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212637 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  212640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212652 */     GIR_RootConstrainSelectedInstOperands,
     /*  212653 */     // GIR_Coverage, 23401,
     /*  212653 */     GIR_EraseRootFromParent_Done,
     /*  212654 */   // Label 4279: @212654
     /*  212654 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(212708), // Rule ID 23404 //
     /*  212659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212691 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  212694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212706 */     GIR_RootConstrainSelectedInstOperands,
     /*  212707 */     // GIR_Coverage, 23404,
     /*  212707 */     GIR_EraseRootFromParent_Done,
     /*  212708 */   // Label 4280: @212708
     /*  212708 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(212762), // Rule ID 23405 //
     /*  212713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212745 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  212748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212760 */     GIR_RootConstrainSelectedInstOperands,
     /*  212761 */     // GIR_Coverage, 23405,
     /*  212761 */     GIR_EraseRootFromParent_Done,
     /*  212762 */   // Label 4281: @212762
     /*  212762 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(212816), // Rule ID 23408 //
     /*  212767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212799 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  212802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212814 */     GIR_RootConstrainSelectedInstOperands,
     /*  212815 */     // GIR_Coverage, 23408,
     /*  212815 */     GIR_EraseRootFromParent_Done,
     /*  212816 */   // Label 4282: @212816
     /*  212816 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(212870), // Rule ID 23409 //
     /*  212821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212853 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  212856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212868 */     GIR_RootConstrainSelectedInstOperands,
     /*  212869 */     // GIR_Coverage, 23409,
     /*  212869 */     GIR_EraseRootFromParent_Done,
     /*  212870 */   // Label 4283: @212870
     /*  212870 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(212924), // Rule ID 23412 //
     /*  212875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212907 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  212910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212922 */     GIR_RootConstrainSelectedInstOperands,
     /*  212923 */     // GIR_Coverage, 23412,
     /*  212923 */     GIR_EraseRootFromParent_Done,
     /*  212924 */   // Label 4284: @212924
     /*  212924 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(212978), // Rule ID 23413 //
     /*  212929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212961 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  212964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212976 */     GIR_RootConstrainSelectedInstOperands,
     /*  212977 */     // GIR_Coverage, 23413,
     /*  212977 */     GIR_EraseRootFromParent_Done,
     /*  212978 */   // Label 4285: @212978
     /*  212978 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(213032), // Rule ID 23416 //
     /*  212983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213015 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  213015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  213018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213030 */     GIR_RootConstrainSelectedInstOperands,
     /*  213031 */     // GIR_Coverage, 23416,
     /*  213031 */     GIR_EraseRootFromParent_Done,
     /*  213032 */   // Label 4286: @213032
     /*  213032 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(213086), // Rule ID 23417 //
     /*  213037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  213040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  213045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  213048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  213051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213069 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11467:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  213069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  213072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  213076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213084 */     GIR_RootConstrainSelectedInstOperands,
     /*  213085 */     // GIR_Coverage, 23417,
     /*  213085 */     GIR_EraseRootFromParent_Done,
     /*  213086 */   // Label 4287: @213086
     /*  213086 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(213143), // Rule ID 23504 //
     /*  213091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  213102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  213105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213123 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213141 */     GIR_RootConstrainSelectedInstOperands,
     /*  213142 */     // GIR_Coverage, 23504,
     /*  213142 */     GIR_EraseRootFromParent_Done,
     /*  213143 */   // Label 4288: @213143
     /*  213143 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(213200), // Rule ID 23505 //
     /*  213148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  213159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  213162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213180 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213198 */     GIR_RootConstrainSelectedInstOperands,
     /*  213199 */     // GIR_Coverage, 23505,
     /*  213199 */     GIR_EraseRootFromParent_Done,
     /*  213200 */   // Label 4289: @213200
     /*  213200 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(213257), // Rule ID 23508 //
     /*  213205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  213216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  213219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213237 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213255 */     GIR_RootConstrainSelectedInstOperands,
     /*  213256 */     // GIR_Coverage, 23508,
     /*  213256 */     GIR_EraseRootFromParent_Done,
     /*  213257 */   // Label 4290: @213257
     /*  213257 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(213314), // Rule ID 23509 //
     /*  213262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  213273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  213276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213312 */     GIR_RootConstrainSelectedInstOperands,
     /*  213313 */     // GIR_Coverage, 23509,
     /*  213313 */     GIR_EraseRootFromParent_Done,
     /*  213314 */   // Label 4291: @213314
     /*  213314 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(213371), // Rule ID 23512 //
     /*  213319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  213330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  213333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213351 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213369 */     GIR_RootConstrainSelectedInstOperands,
     /*  213370 */     // GIR_Coverage, 23512,
     /*  213370 */     GIR_EraseRootFromParent_Done,
     /*  213371 */   // Label 4292: @213371
     /*  213371 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(213428), // Rule ID 23513 //
     /*  213376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  213387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  213390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213408 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  213411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213426 */     GIR_RootConstrainSelectedInstOperands,
     /*  213427 */     // GIR_Coverage, 23513,
     /*  213427 */     GIR_EraseRootFromParent_Done,
     /*  213428 */   // Label 4293: @213428
     /*  213428 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(213485), // Rule ID 23516 //
     /*  213433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  213444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  213447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213465 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213483 */     GIR_RootConstrainSelectedInstOperands,
     /*  213484 */     // GIR_Coverage, 23516,
     /*  213484 */     GIR_EraseRootFromParent_Done,
     /*  213485 */   // Label 4294: @213485
     /*  213485 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(213542), // Rule ID 23517 //
     /*  213490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  213501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  213504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213522 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213540 */     GIR_RootConstrainSelectedInstOperands,
     /*  213541 */     // GIR_Coverage, 23517,
     /*  213541 */     GIR_EraseRootFromParent_Done,
     /*  213542 */   // Label 4295: @213542
     /*  213542 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(213599), // Rule ID 23520 //
     /*  213547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  213558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  213561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213579 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  213579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213597 */     GIR_RootConstrainSelectedInstOperands,
     /*  213598 */     // GIR_Coverage, 23520,
     /*  213598 */     GIR_EraseRootFromParent_Done,
     /*  213599 */   // Label 4296: @213599
     /*  213599 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(213656), // Rule ID 23521 //
     /*  213604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  213615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  213618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  213636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213654 */     GIR_RootConstrainSelectedInstOperands,
     /*  213655 */     // GIR_Coverage, 23521,
     /*  213655 */     GIR_EraseRootFromParent_Done,
     /*  213656 */   // Label 4297: @213656
     /*  213656 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(213713), // Rule ID 23524 //
     /*  213661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  213672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  213675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213693 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11321:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213711 */     GIR_RootConstrainSelectedInstOperands,
     /*  213712 */     // GIR_Coverage, 23524,
     /*  213712 */     GIR_EraseRootFromParent_Done,
     /*  213713 */   // Label 4298: @213713
     /*  213713 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(213770), // Rule ID 23525 //
     /*  213718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  213729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  213732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11321:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213768 */     GIR_RootConstrainSelectedInstOperands,
     /*  213769 */     // GIR_Coverage, 23525,
     /*  213769 */     GIR_EraseRootFromParent_Done,
     /*  213770 */   // Label 4299: @213770
     /*  213770 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(213827), // Rule ID 23528 //
     /*  213775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  213786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  213789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213807 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213825 */     GIR_RootConstrainSelectedInstOperands,
     /*  213826 */     // GIR_Coverage, 23528,
     /*  213826 */     GIR_EraseRootFromParent_Done,
     /*  213827 */   // Label 4300: @213827
     /*  213827 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(213884), // Rule ID 23529 //
     /*  213832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  213843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  213846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213864 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11321:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213882 */     GIR_RootConstrainSelectedInstOperands,
     /*  213883 */     // GIR_Coverage, 23529,
     /*  213883 */     GIR_EraseRootFromParent_Done,
     /*  213884 */   // Label 4301: @213884
     /*  213884 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(213941), // Rule ID 23532 //
     /*  213889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  213900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  213903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213921 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  213921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213939 */     GIR_RootConstrainSelectedInstOperands,
     /*  213940 */     // GIR_Coverage, 23532,
     /*  213940 */     GIR_EraseRootFromParent_Done,
     /*  213941 */   // Label 4302: @213941
     /*  213941 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(213998), // Rule ID 23533 //
     /*  213946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  213957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  213960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11321:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  213978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213996 */     GIR_RootConstrainSelectedInstOperands,
     /*  213997 */     // GIR_Coverage, 23533,
     /*  213997 */     GIR_EraseRootFromParent_Done,
     /*  213998 */   // Label 4303: @213998
     /*  213998 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(214055), // Rule ID 23536 //
     /*  214003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  214006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  214014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  214017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214035 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  214035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214053 */     GIR_RootConstrainSelectedInstOperands,
     /*  214054 */     // GIR_Coverage, 23536,
     /*  214054 */     GIR_EraseRootFromParent_Done,
     /*  214055 */   // Label 4304: @214055
     /*  214055 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(214112), // Rule ID 23537 //
     /*  214060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  214063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  214071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  214074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  214085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11321:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  214092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  214095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214110 */     GIR_RootConstrainSelectedInstOperands,
     /*  214111 */     // GIR_Coverage, 23537,
     /*  214111 */     GIR_EraseRootFromParent_Done,
     /*  214112 */   // Label 4305: @214112
     /*  214112 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(214169), // Rule ID 23540 //
     /*  214117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  214128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  214131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214149 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214167 */     GIR_RootConstrainSelectedInstOperands,
     /*  214168 */     // GIR_Coverage, 23540,
     /*  214168 */     GIR_EraseRootFromParent_Done,
     /*  214169 */   // Label 4306: @214169
     /*  214169 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(214226), // Rule ID 23541 //
     /*  214174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  214185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  214188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214224 */     GIR_RootConstrainSelectedInstOperands,
     /*  214225 */     // GIR_Coverage, 23541,
     /*  214225 */     GIR_EraseRootFromParent_Done,
     /*  214226 */   // Label 4307: @214226
     /*  214226 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(214283), // Rule ID 23544 //
     /*  214231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  214242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  214245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214263 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214281 */     GIR_RootConstrainSelectedInstOperands,
     /*  214282 */     // GIR_Coverage, 23544,
     /*  214282 */     GIR_EraseRootFromParent_Done,
     /*  214283 */   // Label 4308: @214283
     /*  214283 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(214340), // Rule ID 23545 //
     /*  214288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  214299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  214302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214320 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214338 */     GIR_RootConstrainSelectedInstOperands,
     /*  214339 */     // GIR_Coverage, 23545,
     /*  214339 */     GIR_EraseRootFromParent_Done,
     /*  214340 */   // Label 4309: @214340
     /*  214340 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(214397), // Rule ID 23548 //
     /*  214345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  214356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  214359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214377 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  214377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214395 */     GIR_RootConstrainSelectedInstOperands,
     /*  214396 */     // GIR_Coverage, 23548,
     /*  214396 */     GIR_EraseRootFromParent_Done,
     /*  214397 */   // Label 4310: @214397
     /*  214397 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(214454), // Rule ID 23549 //
     /*  214402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  214413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  214416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214434 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  214434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  214449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214452 */     GIR_RootConstrainSelectedInstOperands,
     /*  214453 */     // GIR_Coverage, 23549,
     /*  214453 */     GIR_EraseRootFromParent_Done,
     /*  214454 */   // Label 4311: @214454
     /*  214454 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(214511), // Rule ID 23552 //
     /*  214459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  214470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  214473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214491 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214509 */     GIR_RootConstrainSelectedInstOperands,
     /*  214510 */     // GIR_Coverage, 23552,
     /*  214510 */     GIR_EraseRootFromParent_Done,
     /*  214511 */   // Label 4312: @214511
     /*  214511 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(214568), // Rule ID 23553 //
     /*  214516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  214527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  214530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214566 */     GIR_RootConstrainSelectedInstOperands,
     /*  214567 */     // GIR_Coverage, 23553,
     /*  214567 */     GIR_EraseRootFromParent_Done,
     /*  214568 */   // Label 4313: @214568
     /*  214568 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(214625), // Rule ID 23556 //
     /*  214573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  214584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  214587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214605 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214623 */     GIR_RootConstrainSelectedInstOperands,
     /*  214624 */     // GIR_Coverage, 23556,
     /*  214624 */     GIR_EraseRootFromParent_Done,
     /*  214625 */   // Label 4314: @214625
     /*  214625 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(214682), // Rule ID 23557 //
     /*  214630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  214641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  214644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214662 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214680 */     GIR_RootConstrainSelectedInstOperands,
     /*  214681 */     // GIR_Coverage, 23557,
     /*  214681 */     GIR_EraseRootFromParent_Done,
     /*  214682 */   // Label 4315: @214682
     /*  214682 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(214739), // Rule ID 23560 //
     /*  214687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  214698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  214701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214719 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214737 */     GIR_RootConstrainSelectedInstOperands,
     /*  214738 */     // GIR_Coverage, 23560,
     /*  214738 */     GIR_EraseRootFromParent_Done,
     /*  214739 */   // Label 4316: @214739
     /*  214739 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(214796), // Rule ID 23561 //
     /*  214744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  214755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  214758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214794 */     GIR_RootConstrainSelectedInstOperands,
     /*  214795 */     // GIR_Coverage, 23561,
     /*  214795 */     GIR_EraseRootFromParent_Done,
     /*  214796 */   // Label 4317: @214796
     /*  214796 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(214853), // Rule ID 23564 //
     /*  214801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  214812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  214815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214851 */     GIR_RootConstrainSelectedInstOperands,
     /*  214852 */     // GIR_Coverage, 23564,
     /*  214852 */     GIR_EraseRootFromParent_Done,
     /*  214853 */   // Label 4318: @214853
     /*  214853 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(214910), // Rule ID 23565 //
     /*  214858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  214869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  214872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214908 */     GIR_RootConstrainSelectedInstOperands,
     /*  214909 */     // GIR_Coverage, 23565,
     /*  214909 */     GIR_EraseRootFromParent_Done,
     /*  214910 */   // Label 4319: @214910
     /*  214910 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(214967), // Rule ID 23568 //
     /*  214915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  214926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  214929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214947 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214965 */     GIR_RootConstrainSelectedInstOperands,
     /*  214966 */     // GIR_Coverage, 23568,
     /*  214966 */     GIR_EraseRootFromParent_Done,
     /*  214967 */   // Label 4320: @214967
     /*  214967 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(215024), // Rule ID 23569 //
     /*  214972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  214983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  214986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215004 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215022 */     GIR_RootConstrainSelectedInstOperands,
     /*  215023 */     // GIR_Coverage, 23569,
     /*  215023 */     GIR_EraseRootFromParent_Done,
     /*  215024 */   // Label 4321: @215024
     /*  215024 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(215081), // Rule ID 23572 //
     /*  215029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  215040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  215043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215061 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  215061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215079 */     GIR_RootConstrainSelectedInstOperands,
     /*  215080 */     // GIR_Coverage, 23572,
     /*  215080 */     GIR_EraseRootFromParent_Done,
     /*  215081 */   // Label 4322: @215081
     /*  215081 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(215138), // Rule ID 23573 //
     /*  215086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  215089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  215097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  215100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  215118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  215133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215136 */     GIR_RootConstrainSelectedInstOperands,
     /*  215137 */     // GIR_Coverage, 23573,
     /*  215137 */     GIR_EraseRootFromParent_Done,
     /*  215138 */   // Label 4323: @215138
     /*  215138 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(215195), // Rule ID 23576 //
     /*  215143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  215154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  215157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215175 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215193 */     GIR_RootConstrainSelectedInstOperands,
     /*  215194 */     // GIR_Coverage, 23576,
     /*  215194 */     GIR_EraseRootFromParent_Done,
     /*  215195 */   // Label 4324: @215195
     /*  215195 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(215252), // Rule ID 23577 //
     /*  215200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  215211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  215214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  215225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11321:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  215235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215250 */     GIR_RootConstrainSelectedInstOperands,
     /*  215251 */     // GIR_Coverage, 23577,
     /*  215251 */     GIR_EraseRootFromParent_Done,
     /*  215252 */   // Label 4325: @215252
     /*  215252 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(215309), // Rule ID 23580 //
     /*  215257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  215268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  215271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215289 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215307 */     GIR_RootConstrainSelectedInstOperands,
     /*  215308 */     // GIR_Coverage, 23580,
     /*  215308 */     GIR_EraseRootFromParent_Done,
     /*  215309 */   // Label 4326: @215309
     /*  215309 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(215366), // Rule ID 23581 //
     /*  215314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  215325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  215328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  215339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215346 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11321:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  215349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215364 */     GIR_RootConstrainSelectedInstOperands,
     /*  215365 */     // GIR_Coverage, 23581,
     /*  215365 */     GIR_EraseRootFromParent_Done,
     /*  215366 */   // Label 4327: @215366
     /*  215366 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(215423), // Rule ID 23584 //
     /*  215371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  215374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  215382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  215385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215403 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  215403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215421 */     GIR_RootConstrainSelectedInstOperands,
     /*  215422 */     // GIR_Coverage, 23584,
     /*  215422 */     GIR_EraseRootFromParent_Done,
     /*  215423 */   // Label 4328: @215423
     /*  215423 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(215480), // Rule ID 23585 //
     /*  215428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  215431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  215436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  215439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  215442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  215453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  215460 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11321:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  215460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  215463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  215467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  215472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  215475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  215478 */     GIR_RootConstrainSelectedInstOperands,
     /*  215479 */     // GIR_Coverage, 23585,
     /*  215479 */     GIR_EraseRootFromParent_Done,
     /*  215480 */   // Label 4329: @215480
     /*  215480 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(215526), // Rule ID 2651 //
     /*  215485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  215488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks1i),
     /*  215493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215507 */     // MIs[0] rnum
     /*  215507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  215510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_rnum),
     /*  215515 */     // (intrinsic_wo_chain:{ *:[i64] } 10965:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)  =>  (AES64KS1I:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)
     /*  215515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS1I),
     /*  215518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rnum
     /*  215524 */     GIR_RootConstrainSelectedInstOperands,
     /*  215525 */     // GIR_Coverage, 2651,
     /*  215525 */     GIR_EraseRootFromParent_Done,
     /*  215526 */   // Label 4330: @215526
     /*  215526 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(215571), // Rule ID 64448 //
     /*  215531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  215534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clip),
     /*  215539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215560 */     // (intrinsic_wo_chain:{ *:[i32] } 10975:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPR),
     /*  215563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215569 */     GIR_RootConstrainSelectedInstOperands,
     /*  215570 */     // GIR_Coverage, 64448,
     /*  215570 */     GIR_EraseRootFromParent_Done,
     /*  215571 */   // Label 4331: @215571
     /*  215571 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(215616), // Rule ID 64475 //
     /*  215576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  215579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clipu),
     /*  215584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215605 */     // (intrinsic_wo_chain:{ *:[i32] } 10976:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPUR),
     /*  215608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215614 */     GIR_RootConstrainSelectedInstOperands,
     /*  215615 */     // GIR_Coverage, 64475,
     /*  215615 */     GIR_EraseRootFromParent_Done,
     /*  215616 */   // Label 4332: @215616
     /*  215616 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(215661), // Rule ID 2641 //
     /*  215621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  215624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  215629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215650 */     // (intrinsic_wo_chain:{ *:[i64] } 11679:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM4:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  215653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215659 */     GIR_RootConstrainSelectedInstOperands,
     /*  215660 */     // GIR_Coverage, 2641,
     /*  215660 */     GIR_EraseRootFromParent_Done,
     /*  215661 */   // Label 4333: @215661
     /*  215661 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(215706), // Rule ID 2642 //
     /*  215666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  215669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  215674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215695 */     // (intrinsic_wo_chain:{ *:[i32] } 11679:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM4:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  215698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215704 */     GIR_RootConstrainSelectedInstOperands,
     /*  215705 */     // GIR_Coverage, 2642,
     /*  215705 */     GIR_EraseRootFromParent_Done,
     /*  215706 */   // Label 4334: @215706
     /*  215706 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(215751), // Rule ID 2643 //
     /*  215711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  215714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  215719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215740 */     // (intrinsic_wo_chain:{ *:[i64] } 11680:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM8:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  215743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215749 */     GIR_RootConstrainSelectedInstOperands,
     /*  215750 */     // GIR_Coverage, 2643,
     /*  215750 */     GIR_EraseRootFromParent_Done,
     /*  215751 */   // Label 4335: @215751
     /*  215751 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(215796), // Rule ID 2644 //
     /*  215756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  215759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  215764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215785 */     // (intrinsic_wo_chain:{ *:[i32] } 11680:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM8:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  215788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215794 */     GIR_RootConstrainSelectedInstOperands,
     /*  215795 */     // GIR_Coverage, 2644,
     /*  215795 */     GIR_EraseRootFromParent_Done,
     /*  215796 */   // Label 4336: @215796
     /*  215796 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(215841), // Rule ID 2647 //
     /*  215801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  215804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ds),
     /*  215809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215830 */     // (intrinsic_wo_chain:{ *:[i64] } 10960:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DS),
     /*  215833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215839 */     GIR_RootConstrainSelectedInstOperands,
     /*  215840 */     // GIR_Coverage, 2647,
     /*  215840 */     GIR_EraseRootFromParent_Done,
     /*  215841 */   // Label 4337: @215841
     /*  215841 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(215886), // Rule ID 2648 //
     /*  215846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  215849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64dsm),
     /*  215854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215875 */     // (intrinsic_wo_chain:{ *:[i64] } 10961:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DSM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DSM),
     /*  215878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215884 */     GIR_RootConstrainSelectedInstOperands,
     /*  215885 */     // GIR_Coverage, 2648,
     /*  215885 */     GIR_EraseRootFromParent_Done,
     /*  215886 */   // Label 4338: @215886
     /*  215886 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(215931), // Rule ID 2650 //
     /*  215891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  215894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks2),
     /*  215899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215920 */     // (intrinsic_wo_chain:{ *:[i64] } 10966:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64KS2:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS2),
     /*  215923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215929 */     GIR_RootConstrainSelectedInstOperands,
     /*  215930 */     // GIR_Coverage, 2650,
     /*  215930 */     GIR_EraseRootFromParent_Done,
     /*  215931 */   // Label 4339: @215931
     /*  215931 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(215976), // Rule ID 2654 //
     /*  215936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  215939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64es),
     /*  215944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215965 */     // (intrinsic_wo_chain:{ *:[i64] } 10962:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ES:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ES),
     /*  215968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215974 */     GIR_RootConstrainSelectedInstOperands,
     /*  215975 */     // GIR_Coverage, 2654,
     /*  215975 */     GIR_EraseRootFromParent_Done,
     /*  215976 */   // Label 4340: @215976
     /*  215976 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(216021), // Rule ID 2655 //
     /*  215981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  215984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64esm),
     /*  215989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216010 */     // (intrinsic_wo_chain:{ *:[i64] } 10963:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ESM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  216010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ESM),
     /*  216013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216019 */     GIR_RootConstrainSelectedInstOperands,
     /*  216020 */     // GIR_Coverage, 2655,
     /*  216020 */     GIR_EraseRootFromParent_Done,
     /*  216021 */   // Label 4341: @216021
     /*  216021 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(216066), // Rule ID 2664 //
     /*  216026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0l),
     /*  216034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216055 */     // (intrinsic_wo_chain:{ *:[i32] } 11115:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0L),
     /*  216058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216064 */     GIR_RootConstrainSelectedInstOperands,
     /*  216065 */     // GIR_Coverage, 2664,
     /*  216065 */     GIR_EraseRootFromParent_Done,
     /*  216066 */   // Label 4342: @216066
     /*  216066 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(216111), // Rule ID 2665 //
     /*  216071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0h),
     /*  216079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216100 */     // (intrinsic_wo_chain:{ *:[i32] } 11114:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0H),
     /*  216103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216109 */     GIR_RootConstrainSelectedInstOperands,
     /*  216110 */     // GIR_Coverage, 2665,
     /*  216110 */     GIR_EraseRootFromParent_Done,
     /*  216111 */   // Label 4343: @216111
     /*  216111 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(216156), // Rule ID 2666 //
     /*  216116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1l),
     /*  216124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216145 */     // (intrinsic_wo_chain:{ *:[i32] } 11118:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1L),
     /*  216148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216154 */     GIR_RootConstrainSelectedInstOperands,
     /*  216155 */     // GIR_Coverage, 2666,
     /*  216155 */     GIR_EraseRootFromParent_Done,
     /*  216156 */   // Label 4344: @216156
     /*  216156 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(216201), // Rule ID 2667 //
     /*  216161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1h),
     /*  216169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216190 */     // (intrinsic_wo_chain:{ *:[i32] } 11117:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1H),
     /*  216193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216199 */     GIR_RootConstrainSelectedInstOperands,
     /*  216200 */     // GIR_Coverage, 2667,
     /*  216200 */     GIR_EraseRootFromParent_Done,
     /*  216201 */   // Label 4345: @216201
     /*  216201 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(216246), // Rule ID 2668 //
     /*  216206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0r),
     /*  216214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216235 */     // (intrinsic_wo_chain:{ *:[i32] } 11120:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM0R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0R),
     /*  216238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216244 */     GIR_RootConstrainSelectedInstOperands,
     /*  216245 */     // GIR_Coverage, 2668,
     /*  216245 */     GIR_EraseRootFromParent_Done,
     /*  216246 */   // Label 4346: @216246
     /*  216246 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(216291), // Rule ID 2669 //
     /*  216251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  216254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1r),
     /*  216259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216280 */     // (intrinsic_wo_chain:{ *:[i32] } 11122:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM1R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1R),
     /*  216283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216289 */     GIR_RootConstrainSelectedInstOperands,
     /*  216290 */     // GIR_Coverage, 2669,
     /*  216290 */     GIR_EraseRootFromParent_Done,
     /*  216291 */   // Label 4347: @216291
     /*  216291 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(216336), // Rule ID 64425 //
     /*  216296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extract),
     /*  216304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216325 */     // (intrinsic_wo_chain:{ *:[i32] } 10985:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTR),
     /*  216328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216334 */     GIR_RootConstrainSelectedInstOperands,
     /*  216335 */     // GIR_Coverage, 64425,
     /*  216335 */     GIR_EraseRootFromParent_Done,
     /*  216336 */   // Label 4348: @216336
     /*  216336 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(216381), // Rule ID 64427 //
     /*  216341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extractu),
     /*  216349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216370 */     // (intrinsic_wo_chain:{ *:[i32] } 10986:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTUR),
     /*  216373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216379 */     GIR_RootConstrainSelectedInstOperands,
     /*  216380 */     // GIR_Coverage, 64427,
     /*  216380 */     GIR_EraseRootFromParent_Done,
     /*  216381 */   // Label 4349: @216381
     /*  216381 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(216426), // Rule ID 64429 //
     /*  216386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bclr),
     /*  216394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216415 */     // (intrinsic_wo_chain:{ *:[i32] } 10981:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BCLRR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BCLRR),
     /*  216418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216424 */     GIR_RootConstrainSelectedInstOperands,
     /*  216425 */     // GIR_Coverage, 64429,
     /*  216425 */     GIR_EraseRootFromParent_Done,
     /*  216426 */   // Label 4350: @216426
     /*  216426 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(216471), // Rule ID 64431 //
     /*  216431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  216434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bset),
     /*  216439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  216442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  216445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  216460 */     // (intrinsic_wo_chain:{ *:[i32] } 10983:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BSETR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  216460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BSETR),
     /*  216463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  216469 */     GIR_RootConstrainSelectedInstOperands,
     /*  216470 */     // GIR_Coverage, 64431,
     /*  216470 */     GIR_EraseRootFromParent_Done,
     /*  216471 */   // Label 4351: @216471
     /*  216471 */   GIM_Reject,
     /*  216472 */ // Label 4215: @216472
     /*  216472 */ GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(387377),
     /*  216477 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  216480 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(216554), // Rule ID 5462 //
     /*  216485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  216499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216525 */     // MIs[1] Operand 1
     /*  216525 */     // No operand predicates
     /*  216525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216534 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  216537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216552 */     GIR_RootConstrainSelectedInstOperands,
     /*  216553 */     // GIR_Coverage, 5462,
     /*  216553 */     GIR_EraseRootFromParent_Done,
     /*  216554 */   // Label 4353: @216554
     /*  216554 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(216628), // Rule ID 5463 //
     /*  216559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  216573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216599 */     // MIs[1] Operand 1
     /*  216599 */     // No operand predicates
     /*  216599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216608 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  216611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216626 */     GIR_RootConstrainSelectedInstOperands,
     /*  216627 */     // GIR_Coverage, 5463,
     /*  216627 */     GIR_EraseRootFromParent_Done,
     /*  216628 */   // Label 4354: @216628
     /*  216628 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(216702), // Rule ID 5464 //
     /*  216633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  216647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216673 */     // MIs[1] Operand 1
     /*  216673 */     // No operand predicates
     /*  216673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216682 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216700 */     GIR_RootConstrainSelectedInstOperands,
     /*  216701 */     // GIR_Coverage, 5464,
     /*  216701 */     GIR_EraseRootFromParent_Done,
     /*  216702 */   // Label 4355: @216702
     /*  216702 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(216776), // Rule ID 5465 //
     /*  216707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  216721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216747 */     // MIs[1] Operand 1
     /*  216747 */     // No operand predicates
     /*  216747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216756 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216774 */     GIR_RootConstrainSelectedInstOperands,
     /*  216775 */     // GIR_Coverage, 5465,
     /*  216775 */     GIR_EraseRootFromParent_Done,
     /*  216776 */   // Label 4356: @216776
     /*  216776 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(216850), // Rule ID 5466 //
     /*  216781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  216795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216821 */     // MIs[1] Operand 1
     /*  216821 */     // No operand predicates
     /*  216821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216830 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216848 */     GIR_RootConstrainSelectedInstOperands,
     /*  216849 */     // GIR_Coverage, 5466,
     /*  216849 */     GIR_EraseRootFromParent_Done,
     /*  216850 */   // Label 4357: @216850
     /*  216850 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(216924), // Rule ID 5467 //
     /*  216855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  216869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216895 */     // MIs[1] Operand 1
     /*  216895 */     // No operand predicates
     /*  216895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216922 */     GIR_RootConstrainSelectedInstOperands,
     /*  216923 */     // GIR_Coverage, 5467,
     /*  216923 */     GIR_EraseRootFromParent_Done,
     /*  216924 */   // Label 4358: @216924
     /*  216924 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(216998), // Rule ID 5468 //
     /*  216929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  216943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216969 */     // MIs[1] Operand 1
     /*  216969 */     // No operand predicates
     /*  216969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216978 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  216978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  216996 */     GIR_RootConstrainSelectedInstOperands,
     /*  216997 */     // GIR_Coverage, 5468,
     /*  216997 */     GIR_EraseRootFromParent_Done,
     /*  216998 */   // Label 4359: @216998
     /*  216998 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(217072), // Rule ID 5469 //
     /*  217003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  217017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217043 */     // MIs[1] Operand 1
     /*  217043 */     // No operand predicates
     /*  217043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  217055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217070 */     GIR_RootConstrainSelectedInstOperands,
     /*  217071 */     // GIR_Coverage, 5469,
     /*  217071 */     GIR_EraseRootFromParent_Done,
     /*  217072 */   // Label 4360: @217072
     /*  217072 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(217146), // Rule ID 5470 //
     /*  217077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217117 */     // MIs[1] Operand 1
     /*  217117 */     // No operand predicates
     /*  217117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217126 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217144 */     GIR_RootConstrainSelectedInstOperands,
     /*  217145 */     // GIR_Coverage, 5470,
     /*  217145 */     GIR_EraseRootFromParent_Done,
     /*  217146 */   // Label 4361: @217146
     /*  217146 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(217220), // Rule ID 5471 //
     /*  217151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  217165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217191 */     // MIs[1] Operand 1
     /*  217191 */     // No operand predicates
     /*  217191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217218 */     GIR_RootConstrainSelectedInstOperands,
     /*  217219 */     // GIR_Coverage, 5471,
     /*  217219 */     GIR_EraseRootFromParent_Done,
     /*  217220 */   // Label 4362: @217220
     /*  217220 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(217294), // Rule ID 5472 //
     /*  217225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217265 */     // MIs[1] Operand 1
     /*  217265 */     // No operand predicates
     /*  217265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217274 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  217274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217292 */     GIR_RootConstrainSelectedInstOperands,
     /*  217293 */     // GIR_Coverage, 5472,
     /*  217293 */     GIR_EraseRootFromParent_Done,
     /*  217294 */   // Label 4363: @217294
     /*  217294 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(217368), // Rule ID 5473 //
     /*  217299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  217313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217339 */     // MIs[1] Operand 1
     /*  217339 */     // No operand predicates
     /*  217339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217348 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  217348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  217351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217366 */     GIR_RootConstrainSelectedInstOperands,
     /*  217367 */     // GIR_Coverage, 5473,
     /*  217367 */     GIR_EraseRootFromParent_Done,
     /*  217368 */   // Label 4364: @217368
     /*  217368 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(217442), // Rule ID 5474 //
     /*  217373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217413 */     // MIs[1] Operand 1
     /*  217413 */     // No operand predicates
     /*  217413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217440 */     GIR_RootConstrainSelectedInstOperands,
     /*  217441 */     // GIR_Coverage, 5474,
     /*  217441 */     GIR_EraseRootFromParent_Done,
     /*  217442 */   // Label 4365: @217442
     /*  217442 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(217516), // Rule ID 5475 //
     /*  217447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  217461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217487 */     // MIs[1] Operand 1
     /*  217487 */     // No operand predicates
     /*  217487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217496 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217514 */     GIR_RootConstrainSelectedInstOperands,
     /*  217515 */     // GIR_Coverage, 5475,
     /*  217515 */     GIR_EraseRootFromParent_Done,
     /*  217516 */   // Label 4366: @217516
     /*  217516 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(217590), // Rule ID 5476 //
     /*  217521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217561 */     // MIs[1] Operand 1
     /*  217561 */     // No operand predicates
     /*  217561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217588 */     GIR_RootConstrainSelectedInstOperands,
     /*  217589 */     // GIR_Coverage, 5476,
     /*  217589 */     GIR_EraseRootFromParent_Done,
     /*  217590 */   // Label 4367: @217590
     /*  217590 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(217664), // Rule ID 5477 //
     /*  217595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217635 */     // MIs[1] Operand 1
     /*  217635 */     // No operand predicates
     /*  217635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217644 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217662 */     GIR_RootConstrainSelectedInstOperands,
     /*  217663 */     // GIR_Coverage, 5477,
     /*  217663 */     GIR_EraseRootFromParent_Done,
     /*  217664 */   // Label 4368: @217664
     /*  217664 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(217738), // Rule ID 5478 //
     /*  217669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217709 */     // MIs[1] Operand 1
     /*  217709 */     // No operand predicates
     /*  217709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217718 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  217718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217736 */     GIR_RootConstrainSelectedInstOperands,
     /*  217737 */     // GIR_Coverage, 5478,
     /*  217737 */     GIR_EraseRootFromParent_Done,
     /*  217738 */   // Label 4369: @217738
     /*  217738 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(217812), // Rule ID 5479 //
     /*  217743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217783 */     // MIs[1] Operand 1
     /*  217783 */     // No operand predicates
     /*  217783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  217792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217810 */     GIR_RootConstrainSelectedInstOperands,
     /*  217811 */     // GIR_Coverage, 5479,
     /*  217811 */     GIR_EraseRootFromParent_Done,
     /*  217812 */   // Label 4370: @217812
     /*  217812 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(217886), // Rule ID 5480 //
     /*  217817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  217820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217857 */     // MIs[1] Operand 1
     /*  217857 */     // No operand predicates
     /*  217857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217866 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  217866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217884 */     GIR_RootConstrainSelectedInstOperands,
     /*  217885 */     // GIR_Coverage, 5480,
     /*  217885 */     GIR_EraseRootFromParent_Done,
     /*  217886 */   // Label 4371: @217886
     /*  217886 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(217960), // Rule ID 5481 //
     /*  217891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  217894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217931 */     // MIs[1] Operand 1
     /*  217931 */     // No operand predicates
     /*  217931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217940 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  217940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217958 */     GIR_RootConstrainSelectedInstOperands,
     /*  217959 */     // GIR_Coverage, 5481,
     /*  217959 */     GIR_EraseRootFromParent_Done,
     /*  217960 */   // Label 4372: @217960
     /*  217960 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(218034), // Rule ID 5482 //
     /*  217965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  217976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  217979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218005 */     // MIs[1] Operand 1
     /*  218005 */     // No operand predicates
     /*  218005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218014 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218032 */     GIR_RootConstrainSelectedInstOperands,
     /*  218033 */     // GIR_Coverage, 5482,
     /*  218033 */     GIR_EraseRootFromParent_Done,
     /*  218034 */   // Label 4373: @218034
     /*  218034 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(218108), // Rule ID 5483 //
     /*  218039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  218053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218079 */     // MIs[1] Operand 1
     /*  218079 */     // No operand predicates
     /*  218079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218088 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218106 */     GIR_RootConstrainSelectedInstOperands,
     /*  218107 */     // GIR_Coverage, 5483,
     /*  218107 */     GIR_EraseRootFromParent_Done,
     /*  218108 */   // Label 4374: @218108
     /*  218108 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(218182), // Rule ID 5484 //
     /*  218113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218153 */     // MIs[1] Operand 1
     /*  218153 */     // No operand predicates
     /*  218153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218162 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218180 */     GIR_RootConstrainSelectedInstOperands,
     /*  218181 */     // GIR_Coverage, 5484,
     /*  218181 */     GIR_EraseRootFromParent_Done,
     /*  218182 */   // Label 4375: @218182
     /*  218182 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(218256), // Rule ID 5485 //
     /*  218187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  218201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218227 */     // MIs[1] Operand 1
     /*  218227 */     // No operand predicates
     /*  218227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218236 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218254 */     GIR_RootConstrainSelectedInstOperands,
     /*  218255 */     // GIR_Coverage, 5485,
     /*  218255 */     GIR_EraseRootFromParent_Done,
     /*  218256 */   // Label 4376: @218256
     /*  218256 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(218330), // Rule ID 5486 //
     /*  218261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  218272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218301 */     // MIs[1] Operand 1
     /*  218301 */     // No operand predicates
     /*  218301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218310 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  218310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218328 */     GIR_RootConstrainSelectedInstOperands,
     /*  218329 */     // GIR_Coverage, 5486,
     /*  218329 */     GIR_EraseRootFromParent_Done,
     /*  218330 */   // Label 4377: @218330
     /*  218330 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(218404), // Rule ID 5487 //
     /*  218335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  218346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  218349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218375 */     // MIs[1] Operand 1
     /*  218375 */     // No operand predicates
     /*  218375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218384 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  218384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  218402 */     GIR_RootConstrainSelectedInstOperands,
     /*  218403 */     // GIR_Coverage, 5487,
     /*  218403 */     GIR_EraseRootFromParent_Done,
     /*  218404 */   // Label 4378: @218404
     /*  218404 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(218478), // Rule ID 5488 //
     /*  218409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218449 */     // MIs[1] Operand 1
     /*  218449 */     // No operand predicates
     /*  218449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218458 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218476 */     GIR_RootConstrainSelectedInstOperands,
     /*  218477 */     // GIR_Coverage, 5488,
     /*  218477 */     GIR_EraseRootFromParent_Done,
     /*  218478 */   // Label 4379: @218478
     /*  218478 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(218552), // Rule ID 5489 //
     /*  218483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  218497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218523 */     // MIs[1] Operand 1
     /*  218523 */     // No operand predicates
     /*  218523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218532 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218550 */     GIR_RootConstrainSelectedInstOperands,
     /*  218551 */     // GIR_Coverage, 5489,
     /*  218551 */     GIR_EraseRootFromParent_Done,
     /*  218552 */   // Label 4380: @218552
     /*  218552 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(218626), // Rule ID 5490 //
     /*  218557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218597 */     // MIs[1] Operand 1
     /*  218597 */     // No operand predicates
     /*  218597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218624 */     GIR_RootConstrainSelectedInstOperands,
     /*  218625 */     // GIR_Coverage, 5490,
     /*  218625 */     GIR_EraseRootFromParent_Done,
     /*  218626 */   // Label 4381: @218626
     /*  218626 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(218700), // Rule ID 5491 //
     /*  218631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218671 */     // MIs[1] Operand 1
     /*  218671 */     // No operand predicates
     /*  218671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218698 */     GIR_RootConstrainSelectedInstOperands,
     /*  218699 */     // GIR_Coverage, 5491,
     /*  218699 */     GIR_EraseRootFromParent_Done,
     /*  218700 */   // Label 4382: @218700
     /*  218700 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(218774), // Rule ID 5492 //
     /*  218705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218745 */     // MIs[1] Operand 1
     /*  218745 */     // No operand predicates
     /*  218745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218754 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218772 */     GIR_RootConstrainSelectedInstOperands,
     /*  218773 */     // GIR_Coverage, 5492,
     /*  218773 */     GIR_EraseRootFromParent_Done,
     /*  218774 */   // Label 4383: @218774
     /*  218774 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(218848), // Rule ID 5493 //
     /*  218779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218819 */     // MIs[1] Operand 1
     /*  218819 */     // No operand predicates
     /*  218819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218828 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218846 */     GIR_RootConstrainSelectedInstOperands,
     /*  218847 */     // GIR_Coverage, 5493,
     /*  218847 */     GIR_EraseRootFromParent_Done,
     /*  218848 */   // Label 4384: @218848
     /*  218848 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(218922), // Rule ID 5494 //
     /*  218853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218893 */     // MIs[1] Operand 1
     /*  218893 */     // No operand predicates
     /*  218893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218902 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  218902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218920 */     GIR_RootConstrainSelectedInstOperands,
     /*  218921 */     // GIR_Coverage, 5494,
     /*  218921 */     GIR_EraseRootFromParent_Done,
     /*  218922 */   // Label 4385: @218922
     /*  218922 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(218996), // Rule ID 5495 //
     /*  218927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218967 */     // MIs[1] Operand 1
     /*  218967 */     // No operand predicates
     /*  218967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218976 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  218976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218994 */     GIR_RootConstrainSelectedInstOperands,
     /*  218995 */     // GIR_Coverage, 5495,
     /*  218995 */     GIR_EraseRootFromParent_Done,
     /*  218996 */   // Label 4386: @218996
     /*  218996 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(219070), // Rule ID 5496 //
     /*  219001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  219015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219041 */     // MIs[1] Operand 1
     /*  219041 */     // No operand predicates
     /*  219041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219050 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219068 */     GIR_RootConstrainSelectedInstOperands,
     /*  219069 */     // GIR_Coverage, 5496,
     /*  219069 */     GIR_EraseRootFromParent_Done,
     /*  219070 */   // Label 4387: @219070
     /*  219070 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(219144), // Rule ID 5497 //
     /*  219075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  219089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219115 */     // MIs[1] Operand 1
     /*  219115 */     // No operand predicates
     /*  219115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219142 */     GIR_RootConstrainSelectedInstOperands,
     /*  219143 */     // GIR_Coverage, 5497,
     /*  219143 */     GIR_EraseRootFromParent_Done,
     /*  219144 */   // Label 4388: @219144
     /*  219144 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(219218), // Rule ID 5498 //
     /*  219149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  219163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219189 */     // MIs[1] Operand 1
     /*  219189 */     // No operand predicates
     /*  219189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219198 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  219198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219216 */     GIR_RootConstrainSelectedInstOperands,
     /*  219217 */     // GIR_Coverage, 5498,
     /*  219217 */     GIR_EraseRootFromParent_Done,
     /*  219218 */   // Label 4389: @219218
     /*  219218 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(219292), // Rule ID 5499 //
     /*  219223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  219234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  219237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219263 */     // MIs[1] Operand 1
     /*  219263 */     // No operand predicates
     /*  219263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219272 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  219272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  219290 */     GIR_RootConstrainSelectedInstOperands,
     /*  219291 */     // GIR_Coverage, 5499,
     /*  219291 */     GIR_EraseRootFromParent_Done,
     /*  219292 */   // Label 4390: @219292
     /*  219292 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(219366), // Rule ID 5500 //
     /*  219297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219337 */     // MIs[1] Operand 1
     /*  219337 */     // No operand predicates
     /*  219337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219346 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219364 */     GIR_RootConstrainSelectedInstOperands,
     /*  219365 */     // GIR_Coverage, 5500,
     /*  219365 */     GIR_EraseRootFromParent_Done,
     /*  219366 */   // Label 4391: @219366
     /*  219366 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(219440), // Rule ID 5501 //
     /*  219371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  219385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  219399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219411 */     // MIs[1] Operand 1
     /*  219411 */     // No operand predicates
     /*  219411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  219423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219438 */     GIR_RootConstrainSelectedInstOperands,
     /*  219439 */     // GIR_Coverage, 5501,
     /*  219439 */     GIR_EraseRootFromParent_Done,
     /*  219440 */   // Label 4392: @219440
     /*  219440 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(219514), // Rule ID 5502 //
     /*  219445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219485 */     // MIs[1] Operand 1
     /*  219485 */     // No operand predicates
     /*  219485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219494 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219512 */     GIR_RootConstrainSelectedInstOperands,
     /*  219513 */     // GIR_Coverage, 5502,
     /*  219513 */     GIR_EraseRootFromParent_Done,
     /*  219514 */   // Label 4393: @219514
     /*  219514 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(219588), // Rule ID 5503 //
     /*  219519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219559 */     // MIs[1] Operand 1
     /*  219559 */     // No operand predicates
     /*  219559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219586 */     GIR_RootConstrainSelectedInstOperands,
     /*  219587 */     // GIR_Coverage, 5503,
     /*  219587 */     GIR_EraseRootFromParent_Done,
     /*  219588 */   // Label 4394: @219588
     /*  219588 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(219662), // Rule ID 5504 //
     /*  219593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219633 */     // MIs[1] Operand 1
     /*  219633 */     // No operand predicates
     /*  219633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219642 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219660 */     GIR_RootConstrainSelectedInstOperands,
     /*  219661 */     // GIR_Coverage, 5504,
     /*  219661 */     GIR_EraseRootFromParent_Done,
     /*  219662 */   // Label 4395: @219662
     /*  219662 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(219736), // Rule ID 5505 //
     /*  219667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219707 */     // MIs[1] Operand 1
     /*  219707 */     // No operand predicates
     /*  219707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219716 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219734 */     GIR_RootConstrainSelectedInstOperands,
     /*  219735 */     // GIR_Coverage, 5505,
     /*  219735 */     GIR_EraseRootFromParent_Done,
     /*  219736 */   // Label 4396: @219736
     /*  219736 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(219810), // Rule ID 7974 //
     /*  219741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  219752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  219755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219781 */     // MIs[1] Operand 1
     /*  219781 */     // No operand predicates
     /*  219781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219790 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  219790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  219793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219808 */     GIR_RootConstrainSelectedInstOperands,
     /*  219809 */     // GIR_Coverage, 7974,
     /*  219809 */     GIR_EraseRootFromParent_Done,
     /*  219810 */   // Label 4397: @219810
     /*  219810 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(219884), // Rule ID 7975 //
     /*  219815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  219826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  219829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219855 */     // MIs[1] Operand 1
     /*  219855 */     // No operand predicates
     /*  219855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  219864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  219867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219882 */     GIR_RootConstrainSelectedInstOperands,
     /*  219883 */     // GIR_Coverage, 7975,
     /*  219883 */     GIR_EraseRootFromParent_Done,
     /*  219884 */   // Label 4398: @219884
     /*  219884 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(219958), // Rule ID 7978 //
     /*  219889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  219903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219929 */     // MIs[1] Operand 1
     /*  219929 */     // No operand predicates
     /*  219929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219938 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  219938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  219941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219956 */     GIR_RootConstrainSelectedInstOperands,
     /*  219957 */     // GIR_Coverage, 7978,
     /*  219957 */     GIR_EraseRootFromParent_Done,
     /*  219958 */   // Label 4399: @219958
     /*  219958 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(220032), // Rule ID 7979 //
     /*  219963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  219977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220003 */     // MIs[1] Operand 1
     /*  220003 */     // No operand predicates
     /*  220003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220030 */     GIR_RootConstrainSelectedInstOperands,
     /*  220031 */     // GIR_Coverage, 7979,
     /*  220031 */     GIR_EraseRootFromParent_Done,
     /*  220032 */   // Label 4400: @220032
     /*  220032 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(220106), // Rule ID 7982 //
     /*  220037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220077 */     // MIs[1] Operand 1
     /*  220077 */     // No operand predicates
     /*  220077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220086 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220104 */     GIR_RootConstrainSelectedInstOperands,
     /*  220105 */     // GIR_Coverage, 7982,
     /*  220105 */     GIR_EraseRootFromParent_Done,
     /*  220106 */   // Label 4401: @220106
     /*  220106 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(220180), // Rule ID 7983 //
     /*  220111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  220125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220151 */     // MIs[1] Operand 1
     /*  220151 */     // No operand predicates
     /*  220151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220178 */     GIR_RootConstrainSelectedInstOperands,
     /*  220179 */     // GIR_Coverage, 7983,
     /*  220179 */     GIR_EraseRootFromParent_Done,
     /*  220180 */   // Label 4402: @220180
     /*  220180 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(220254), // Rule ID 7986 //
     /*  220185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220225 */     // MIs[1] Operand 1
     /*  220225 */     // No operand predicates
     /*  220225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220234 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220252 */     GIR_RootConstrainSelectedInstOperands,
     /*  220253 */     // GIR_Coverage, 7986,
     /*  220253 */     GIR_EraseRootFromParent_Done,
     /*  220254 */   // Label 4403: @220254
     /*  220254 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(220328), // Rule ID 7987 //
     /*  220259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  220273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220299 */     // MIs[1] Operand 1
     /*  220299 */     // No operand predicates
     /*  220299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220308 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  220311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220326 */     GIR_RootConstrainSelectedInstOperands,
     /*  220327 */     // GIR_Coverage, 7987,
     /*  220327 */     GIR_EraseRootFromParent_Done,
     /*  220328 */   // Label 4404: @220328
     /*  220328 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(220402), // Rule ID 7990 //
     /*  220333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220373 */     // MIs[1] Operand 1
     /*  220373 */     // No operand predicates
     /*  220373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220382 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220400 */     GIR_RootConstrainSelectedInstOperands,
     /*  220401 */     // GIR_Coverage, 7990,
     /*  220401 */     GIR_EraseRootFromParent_Done,
     /*  220402 */   // Label 4405: @220402
     /*  220402 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(220476), // Rule ID 7991 //
     /*  220407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  220421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220447 */     // MIs[1] Operand 1
     /*  220447 */     // No operand predicates
     /*  220447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220456 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220474 */     GIR_RootConstrainSelectedInstOperands,
     /*  220475 */     // GIR_Coverage, 7991,
     /*  220475 */     GIR_EraseRootFromParent_Done,
     /*  220476 */   // Label 4406: @220476
     /*  220476 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(220550), // Rule ID 7994 //
     /*  220481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  220495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220521 */     // MIs[1] Operand 1
     /*  220521 */     // No operand predicates
     /*  220521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220530 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  220530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220548 */     GIR_RootConstrainSelectedInstOperands,
     /*  220549 */     // GIR_Coverage, 7994,
     /*  220549 */     GIR_EraseRootFromParent_Done,
     /*  220550 */   // Label 4407: @220550
     /*  220550 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(220624), // Rule ID 7995 //
     /*  220555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  220569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220595 */     // MIs[1] Operand 1
     /*  220595 */     // No operand predicates
     /*  220595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220604 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  220604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220622 */     GIR_RootConstrainSelectedInstOperands,
     /*  220623 */     // GIR_Coverage, 7995,
     /*  220623 */     GIR_EraseRootFromParent_Done,
     /*  220624 */   // Label 4408: @220624
     /*  220624 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(220698), // Rule ID 7998 //
     /*  220629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  220643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220669 */     // MIs[1] Operand 1
     /*  220669 */     // No operand predicates
     /*  220669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220678 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220696 */     GIR_RootConstrainSelectedInstOperands,
     /*  220697 */     // GIR_Coverage, 7998,
     /*  220697 */     GIR_EraseRootFromParent_Done,
     /*  220698 */   // Label 4409: @220698
     /*  220698 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(220772), // Rule ID 7999 //
     /*  220703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  220717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220743 */     // MIs[1] Operand 1
     /*  220743 */     // No operand predicates
     /*  220743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220770 */     GIR_RootConstrainSelectedInstOperands,
     /*  220771 */     // GIR_Coverage, 7999,
     /*  220771 */     GIR_EraseRootFromParent_Done,
     /*  220772 */   // Label 4410: @220772
     /*  220772 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(220846), // Rule ID 8002 //
     /*  220777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  220791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220817 */     // MIs[1] Operand 1
     /*  220817 */     // No operand predicates
     /*  220817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220826 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220844 */     GIR_RootConstrainSelectedInstOperands,
     /*  220845 */     // GIR_Coverage, 8002,
     /*  220845 */     GIR_EraseRootFromParent_Done,
     /*  220846 */   // Label 4411: @220846
     /*  220846 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(220920), // Rule ID 8003 //
     /*  220851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  220865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220891 */     // MIs[1] Operand 1
     /*  220891 */     // No operand predicates
     /*  220891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220900 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220918 */     GIR_RootConstrainSelectedInstOperands,
     /*  220919 */     // GIR_Coverage, 8003,
     /*  220919 */     GIR_EraseRootFromParent_Done,
     /*  220920 */   // Label 4412: @220920
     /*  220920 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(220994), // Rule ID 8006 //
     /*  220925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  220939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220965 */     // MIs[1] Operand 1
     /*  220965 */     // No operand predicates
     /*  220965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220974 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  220974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220992 */     GIR_RootConstrainSelectedInstOperands,
     /*  220993 */     // GIR_Coverage, 8006,
     /*  220993 */     GIR_EraseRootFromParent_Done,
     /*  220994 */   // Label 4413: @220994
     /*  220994 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(221068), // Rule ID 8007 //
     /*  220999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  221010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  221013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221039 */     // MIs[1] Operand 1
     /*  221039 */     // No operand predicates
     /*  221039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221048 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221066 */     GIR_RootConstrainSelectedInstOperands,
     /*  221067 */     // GIR_Coverage, 8007,
     /*  221067 */     GIR_EraseRootFromParent_Done,
     /*  221068 */   // Label 4414: @221068
     /*  221068 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(221142), // Rule ID 8010 //
     /*  221073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  221076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221113 */     // MIs[1] Operand 1
     /*  221113 */     // No operand predicates
     /*  221113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221122 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  221122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221140 */     GIR_RootConstrainSelectedInstOperands,
     /*  221141 */     // GIR_Coverage, 8010,
     /*  221141 */     GIR_EraseRootFromParent_Done,
     /*  221142 */   // Label 4415: @221142
     /*  221142 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(221216), // Rule ID 8011 //
     /*  221147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  221150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  221158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  221161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221187 */     // MIs[1] Operand 1
     /*  221187 */     // No operand predicates
     /*  221187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221196 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  221196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  221199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  221214 */     GIR_RootConstrainSelectedInstOperands,
     /*  221215 */     // GIR_Coverage, 8011,
     /*  221215 */     GIR_EraseRootFromParent_Done,
     /*  221216 */   // Label 4416: @221216
     /*  221216 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(221290), // Rule ID 8014 //
     /*  221221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221261 */     // MIs[1] Operand 1
     /*  221261 */     // No operand predicates
     /*  221261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221270 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221288 */     GIR_RootConstrainSelectedInstOperands,
     /*  221289 */     // GIR_Coverage, 8014,
     /*  221289 */     GIR_EraseRootFromParent_Done,
     /*  221290 */   // Label 4417: @221290
     /*  221290 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(221364), // Rule ID 8015 //
     /*  221295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  221309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221335 */     // MIs[1] Operand 1
     /*  221335 */     // No operand predicates
     /*  221335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221344 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221362 */     GIR_RootConstrainSelectedInstOperands,
     /*  221363 */     // GIR_Coverage, 8015,
     /*  221363 */     GIR_EraseRootFromParent_Done,
     /*  221364 */   // Label 4418: @221364
     /*  221364 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(221438), // Rule ID 8018 //
     /*  221369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221409 */     // MIs[1] Operand 1
     /*  221409 */     // No operand predicates
     /*  221409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221418 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221436 */     GIR_RootConstrainSelectedInstOperands,
     /*  221437 */     // GIR_Coverage, 8018,
     /*  221437 */     GIR_EraseRootFromParent_Done,
     /*  221438 */   // Label 4419: @221438
     /*  221438 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(221512), // Rule ID 8019 //
     /*  221443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  221457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221483 */     // MIs[1] Operand 1
     /*  221483 */     // No operand predicates
     /*  221483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221492 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221510 */     GIR_RootConstrainSelectedInstOperands,
     /*  221511 */     // GIR_Coverage, 8019,
     /*  221511 */     GIR_EraseRootFromParent_Done,
     /*  221512 */   // Label 4420: @221512
     /*  221512 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(221586), // Rule ID 8022 //
     /*  221517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  221528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  221531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221557 */     // MIs[1] Operand 1
     /*  221557 */     // No operand predicates
     /*  221557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221566 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  221569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221584 */     GIR_RootConstrainSelectedInstOperands,
     /*  221585 */     // GIR_Coverage, 8022,
     /*  221585 */     GIR_EraseRootFromParent_Done,
     /*  221586 */   // Label 4421: @221586
     /*  221586 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(221660), // Rule ID 8023 //
     /*  221591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  221602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  221605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221631 */     // MIs[1] Operand 1
     /*  221631 */     // No operand predicates
     /*  221631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221640 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  221643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221658 */     GIR_RootConstrainSelectedInstOperands,
     /*  221659 */     // GIR_Coverage, 8023,
     /*  221659 */     GIR_EraseRootFromParent_Done,
     /*  221660 */   // Label 4422: @221660
     /*  221660 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(221734), // Rule ID 8026 //
     /*  221665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  221679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221705 */     // MIs[1] Operand 1
     /*  221705 */     // No operand predicates
     /*  221705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221732 */     GIR_RootConstrainSelectedInstOperands,
     /*  221733 */     // GIR_Coverage, 8026,
     /*  221733 */     GIR_EraseRootFromParent_Done,
     /*  221734 */   // Label 4423: @221734
     /*  221734 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(221808), // Rule ID 8027 //
     /*  221739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  221753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221779 */     // MIs[1] Operand 1
     /*  221779 */     // No operand predicates
     /*  221779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221806 */     GIR_RootConstrainSelectedInstOperands,
     /*  221807 */     // GIR_Coverage, 8027,
     /*  221807 */     GIR_EraseRootFromParent_Done,
     /*  221808 */   // Label 4424: @221808
     /*  221808 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(221882), // Rule ID 8030 //
     /*  221813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  221827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221853 */     // MIs[1] Operand 1
     /*  221853 */     // No operand predicates
     /*  221853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221862 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221880 */     GIR_RootConstrainSelectedInstOperands,
     /*  221881 */     // GIR_Coverage, 8030,
     /*  221881 */     GIR_EraseRootFromParent_Done,
     /*  221882 */   // Label 4425: @221882
     /*  221882 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(221956), // Rule ID 8031 //
     /*  221887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  221901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221927 */     // MIs[1] Operand 1
     /*  221927 */     // No operand predicates
     /*  221927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221936 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221954 */     GIR_RootConstrainSelectedInstOperands,
     /*  221955 */     // GIR_Coverage, 8031,
     /*  221955 */     GIR_EraseRootFromParent_Done,
     /*  221956 */   // Label 4426: @221956
     /*  221956 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(222030), // Rule ID 8034 //
     /*  221961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  221975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222001 */     // MIs[1] Operand 1
     /*  222001 */     // No operand predicates
     /*  222001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222010 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222028 */     GIR_RootConstrainSelectedInstOperands,
     /*  222029 */     // GIR_Coverage, 8034,
     /*  222029 */     GIR_EraseRootFromParent_Done,
     /*  222030 */   // Label 4427: @222030
     /*  222030 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(222104), // Rule ID 8035 //
     /*  222035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  222046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  222049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222075 */     // MIs[1] Operand 1
     /*  222075 */     // No operand predicates
     /*  222075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222084 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  222084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  222102 */     GIR_RootConstrainSelectedInstOperands,
     /*  222103 */     // GIR_Coverage, 8035,
     /*  222103 */     GIR_EraseRootFromParent_Done,
     /*  222104 */   // Label 4428: @222104
     /*  222104 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(222178), // Rule ID 8038 //
     /*  222109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222149 */     // MIs[1] Operand 1
     /*  222149 */     // No operand predicates
     /*  222149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222158 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222176 */     GIR_RootConstrainSelectedInstOperands,
     /*  222177 */     // GIR_Coverage, 8038,
     /*  222177 */     GIR_EraseRootFromParent_Done,
     /*  222178 */   // Label 4429: @222178
     /*  222178 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(222252), // Rule ID 8039 //
     /*  222183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  222197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222223 */     // MIs[1] Operand 1
     /*  222223 */     // No operand predicates
     /*  222223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222250 */     GIR_RootConstrainSelectedInstOperands,
     /*  222251 */     // GIR_Coverage, 8039,
     /*  222251 */     GIR_EraseRootFromParent_Done,
     /*  222252 */   // Label 4430: @222252
     /*  222252 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(222326), // Rule ID 8042 //
     /*  222257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222297 */     // MIs[1] Operand 1
     /*  222297 */     // No operand predicates
     /*  222297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222306 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222324 */     GIR_RootConstrainSelectedInstOperands,
     /*  222325 */     // GIR_Coverage, 8042,
     /*  222325 */     GIR_EraseRootFromParent_Done,
     /*  222326 */   // Label 4431: @222326
     /*  222326 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(222400), // Rule ID 8043 //
     /*  222331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  222345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222371 */     // MIs[1] Operand 1
     /*  222371 */     // No operand predicates
     /*  222371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222380 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222398 */     GIR_RootConstrainSelectedInstOperands,
     /*  222399 */     // GIR_Coverage, 8043,
     /*  222399 */     GIR_EraseRootFromParent_Done,
     /*  222400 */   // Label 4432: @222400
     /*  222400 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(222474), // Rule ID 8046 //
     /*  222405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222445 */     // MIs[1] Operand 1
     /*  222445 */     // No operand predicates
     /*  222445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222454 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  222454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222472 */     GIR_RootConstrainSelectedInstOperands,
     /*  222473 */     // GIR_Coverage, 8046,
     /*  222473 */     GIR_EraseRootFromParent_Done,
     /*  222474 */   // Label 4433: @222474
     /*  222474 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(222548), // Rule ID 8047 //
     /*  222479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  222490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  222493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222519 */     // MIs[1] Operand 1
     /*  222519 */     // No operand predicates
     /*  222519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222546 */     GIR_RootConstrainSelectedInstOperands,
     /*  222547 */     // GIR_Coverage, 8047,
     /*  222547 */     GIR_EraseRootFromParent_Done,
     /*  222548 */   // Label 4434: @222548
     /*  222548 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(222622), // Rule ID 8050 //
     /*  222553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  222556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  222567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222593 */     // MIs[1] Operand 1
     /*  222593 */     // No operand predicates
     /*  222593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222602 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222620 */     GIR_RootConstrainSelectedInstOperands,
     /*  222621 */     // GIR_Coverage, 8050,
     /*  222621 */     GIR_EraseRootFromParent_Done,
     /*  222622 */   // Label 4435: @222622
     /*  222622 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(222696), // Rule ID 8051 //
     /*  222627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  222630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  222641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222667 */     // MIs[1] Operand 1
     /*  222667 */     // No operand predicates
     /*  222667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222676 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222694 */     GIR_RootConstrainSelectedInstOperands,
     /*  222695 */     // GIR_Coverage, 8051,
     /*  222695 */     GIR_EraseRootFromParent_Done,
     /*  222696 */   // Label 4436: @222696
     /*  222696 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(222770), // Rule ID 8054 //
     /*  222701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  222704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  222715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222741 */     // MIs[1] Operand 1
     /*  222741 */     // No operand predicates
     /*  222741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222750 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222768 */     GIR_RootConstrainSelectedInstOperands,
     /*  222769 */     // GIR_Coverage, 8054,
     /*  222769 */     GIR_EraseRootFromParent_Done,
     /*  222770 */   // Label 4437: @222770
     /*  222770 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(222844), // Rule ID 8055 //
     /*  222775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  222778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  222789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222815 */     // MIs[1] Operand 1
     /*  222815 */     // No operand predicates
     /*  222815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222842 */     GIR_RootConstrainSelectedInstOperands,
     /*  222843 */     // GIR_Coverage, 8055,
     /*  222843 */     GIR_EraseRootFromParent_Done,
     /*  222844 */   // Label 4438: @222844
     /*  222844 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(222918), // Rule ID 8058 //
     /*  222849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  222852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  222863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222889 */     // MIs[1] Operand 1
     /*  222889 */     // No operand predicates
     /*  222889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222898 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222916 */     GIR_RootConstrainSelectedInstOperands,
     /*  222917 */     // GIR_Coverage, 8058,
     /*  222917 */     GIR_EraseRootFromParent_Done,
     /*  222918 */   // Label 4439: @222918
     /*  222918 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(222992), // Rule ID 8059 //
     /*  222923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  222926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  222937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222963 */     // MIs[1] Operand 1
     /*  222963 */     // No operand predicates
     /*  222963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222972 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222990 */     GIR_RootConstrainSelectedInstOperands,
     /*  222991 */     // GIR_Coverage, 8059,
     /*  222991 */     GIR_EraseRootFromParent_Done,
     /*  222992 */   // Label 4440: @222992
     /*  222992 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(223066), // Rule ID 8238 //
     /*  222997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223037 */     // MIs[1] Operand 1
     /*  223037 */     // No operand predicates
     /*  223037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223046 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  223049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223064 */     GIR_RootConstrainSelectedInstOperands,
     /*  223065 */     // GIR_Coverage, 8238,
     /*  223065 */     GIR_EraseRootFromParent_Done,
     /*  223066 */   // Label 4441: @223066
     /*  223066 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(223140), // Rule ID 8239 //
     /*  223071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  223085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223111 */     // MIs[1] Operand 1
     /*  223111 */     // No operand predicates
     /*  223111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223120 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  223123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223138 */     GIR_RootConstrainSelectedInstOperands,
     /*  223139 */     // GIR_Coverage, 8239,
     /*  223139 */     GIR_EraseRootFromParent_Done,
     /*  223140 */   // Label 4442: @223140
     /*  223140 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(223214), // Rule ID 8242 //
     /*  223145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223185 */     // MIs[1] Operand 1
     /*  223185 */     // No operand predicates
     /*  223185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223194 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223212 */     GIR_RootConstrainSelectedInstOperands,
     /*  223213 */     // GIR_Coverage, 8242,
     /*  223213 */     GIR_EraseRootFromParent_Done,
     /*  223214 */   // Label 4443: @223214
     /*  223214 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(223288), // Rule ID 8243 //
     /*  223219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  223233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223259 */     // MIs[1] Operand 1
     /*  223259 */     // No operand predicates
     /*  223259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223268 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223286 */     GIR_RootConstrainSelectedInstOperands,
     /*  223287 */     // GIR_Coverage, 8243,
     /*  223287 */     GIR_EraseRootFromParent_Done,
     /*  223288 */   // Label 4444: @223288
     /*  223288 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(223362), // Rule ID 8246 //
     /*  223293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223333 */     // MIs[1] Operand 1
     /*  223333 */     // No operand predicates
     /*  223333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223342 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223360 */     GIR_RootConstrainSelectedInstOperands,
     /*  223361 */     // GIR_Coverage, 8246,
     /*  223361 */     GIR_EraseRootFromParent_Done,
     /*  223362 */   // Label 4445: @223362
     /*  223362 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(223436), // Rule ID 8247 //
     /*  223367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  223381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223407 */     // MIs[1] Operand 1
     /*  223407 */     // No operand predicates
     /*  223407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223434 */     GIR_RootConstrainSelectedInstOperands,
     /*  223435 */     // GIR_Coverage, 8247,
     /*  223435 */     GIR_EraseRootFromParent_Done,
     /*  223436 */   // Label 4446: @223436
     /*  223436 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(223510), // Rule ID 8250 //
     /*  223441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  223455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223481 */     // MIs[1] Operand 1
     /*  223481 */     // No operand predicates
     /*  223481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223490 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223508 */     GIR_RootConstrainSelectedInstOperands,
     /*  223509 */     // GIR_Coverage, 8250,
     /*  223509 */     GIR_EraseRootFromParent_Done,
     /*  223510 */   // Label 4447: @223510
     /*  223510 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(223584), // Rule ID 8251 //
     /*  223515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  223529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223555 */     // MIs[1] Operand 1
     /*  223555 */     // No operand predicates
     /*  223555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223582 */     GIR_RootConstrainSelectedInstOperands,
     /*  223583 */     // GIR_Coverage, 8251,
     /*  223583 */     GIR_EraseRootFromParent_Done,
     /*  223584 */   // Label 4448: @223584
     /*  223584 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(223658), // Rule ID 8254 //
     /*  223589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  223603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223629 */     // MIs[1] Operand 1
     /*  223629 */     // No operand predicates
     /*  223629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223638 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223656 */     GIR_RootConstrainSelectedInstOperands,
     /*  223657 */     // GIR_Coverage, 8254,
     /*  223657 */     GIR_EraseRootFromParent_Done,
     /*  223658 */   // Label 4449: @223658
     /*  223658 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(223732), // Rule ID 8255 //
     /*  223663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  223677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223703 */     // MIs[1] Operand 1
     /*  223703 */     // No operand predicates
     /*  223703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223730 */     GIR_RootConstrainSelectedInstOperands,
     /*  223731 */     // GIR_Coverage, 8255,
     /*  223731 */     GIR_EraseRootFromParent_Done,
     /*  223732 */   // Label 4450: @223732
     /*  223732 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(223806), // Rule ID 8258 //
     /*  223737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  223751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223777 */     // MIs[1] Operand 1
     /*  223777 */     // No operand predicates
     /*  223777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  223786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223804 */     GIR_RootConstrainSelectedInstOperands,
     /*  223805 */     // GIR_Coverage, 8258,
     /*  223805 */     GIR_EraseRootFromParent_Done,
     /*  223806 */   // Label 4451: @223806
     /*  223806 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(223880), // Rule ID 8259 //
     /*  223811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  223825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223851 */     // MIs[1] Operand 1
     /*  223851 */     // No operand predicates
     /*  223851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223860 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223878 */     GIR_RootConstrainSelectedInstOperands,
     /*  223879 */     // GIR_Coverage, 8259,
     /*  223879 */     GIR_EraseRootFromParent_Done,
     /*  223880 */   // Label 4452: @223880
     /*  223880 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(223954), // Rule ID 8262 //
     /*  223885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  223899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223925 */     // MIs[1] Operand 1
     /*  223925 */     // No operand predicates
     /*  223925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223934 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223952 */     GIR_RootConstrainSelectedInstOperands,
     /*  223953 */     // GIR_Coverage, 8262,
     /*  223953 */     GIR_EraseRootFromParent_Done,
     /*  223954 */   // Label 4453: @223954
     /*  223954 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(224028), // Rule ID 8263 //
     /*  223959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  223973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223999 */     // MIs[1] Operand 1
     /*  223999 */     // No operand predicates
     /*  223999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224008 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224026 */     GIR_RootConstrainSelectedInstOperands,
     /*  224027 */     // GIR_Coverage, 8263,
     /*  224027 */     GIR_EraseRootFromParent_Done,
     /*  224028 */   // Label 4454: @224028
     /*  224028 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(224102), // Rule ID 8266 //
     /*  224033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224073 */     // MIs[1] Operand 1
     /*  224073 */     // No operand predicates
     /*  224073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224082 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224100 */     GIR_RootConstrainSelectedInstOperands,
     /*  224101 */     // GIR_Coverage, 8266,
     /*  224101 */     GIR_EraseRootFromParent_Done,
     /*  224102 */   // Label 4455: @224102
     /*  224102 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(224176), // Rule ID 8267 //
     /*  224107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  224121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224147 */     // MIs[1] Operand 1
     /*  224147 */     // No operand predicates
     /*  224147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224156 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224174 */     GIR_RootConstrainSelectedInstOperands,
     /*  224175 */     // GIR_Coverage, 8267,
     /*  224175 */     GIR_EraseRootFromParent_Done,
     /*  224176 */   // Label 4456: @224176
     /*  224176 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(224250), // Rule ID 8270 //
     /*  224181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224221 */     // MIs[1] Operand 1
     /*  224221 */     // No operand predicates
     /*  224221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224230 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224248 */     GIR_RootConstrainSelectedInstOperands,
     /*  224249 */     // GIR_Coverage, 8270,
     /*  224249 */     GIR_EraseRootFromParent_Done,
     /*  224250 */   // Label 4457: @224250
     /*  224250 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(224324), // Rule ID 8271 //
     /*  224255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  224266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  224269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224295 */     // MIs[1] Operand 1
     /*  224295 */     // No operand predicates
     /*  224295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224322 */     GIR_RootConstrainSelectedInstOperands,
     /*  224323 */     // GIR_Coverage, 8271,
     /*  224323 */     GIR_EraseRootFromParent_Done,
     /*  224324 */   // Label 4458: @224324
     /*  224324 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(224398), // Rule ID 8274 //
     /*  224329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  224332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224369 */     // MIs[1] Operand 1
     /*  224369 */     // No operand predicates
     /*  224369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224378 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  224378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224396 */     GIR_RootConstrainSelectedInstOperands,
     /*  224397 */     // GIR_Coverage, 8274,
     /*  224397 */     GIR_EraseRootFromParent_Done,
     /*  224398 */   // Label 4459: @224398
     /*  224398 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(224472), // Rule ID 8275 //
     /*  224403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  224406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  224414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  224417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224443 */     // MIs[1] Operand 1
     /*  224443 */     // No operand predicates
     /*  224443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224452 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  224452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  224455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  224470 */     GIR_RootConstrainSelectedInstOperands,
     /*  224471 */     // GIR_Coverage, 8275,
     /*  224471 */     GIR_EraseRootFromParent_Done,
     /*  224472 */   // Label 4460: @224472
     /*  224472 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(224546), // Rule ID 8278 //
     /*  224477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  224491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224517 */     // MIs[1] Operand 1
     /*  224517 */     // No operand predicates
     /*  224517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224544 */     GIR_RootConstrainSelectedInstOperands,
     /*  224545 */     // GIR_Coverage, 8278,
     /*  224545 */     GIR_EraseRootFromParent_Done,
     /*  224546 */   // Label 4461: @224546
     /*  224546 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(224620), // Rule ID 8279 //
     /*  224551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  224565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224591 */     // MIs[1] Operand 1
     /*  224591 */     // No operand predicates
     /*  224591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224600 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224618 */     GIR_RootConstrainSelectedInstOperands,
     /*  224619 */     // GIR_Coverage, 8279,
     /*  224619 */     GIR_EraseRootFromParent_Done,
     /*  224620 */   // Label 4462: @224620
     /*  224620 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(224694), // Rule ID 8282 //
     /*  224625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  224636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  224639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224665 */     // MIs[1] Operand 1
     /*  224665 */     // No operand predicates
     /*  224665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224674 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  224677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224692 */     GIR_RootConstrainSelectedInstOperands,
     /*  224693 */     // GIR_Coverage, 8282,
     /*  224693 */     GIR_EraseRootFromParent_Done,
     /*  224694 */   // Label 4463: @224694
     /*  224694 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(224768), // Rule ID 8283 //
     /*  224699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  224710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  224713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224739 */     // MIs[1] Operand 1
     /*  224739 */     // No operand predicates
     /*  224739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224748 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  224751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224766 */     GIR_RootConstrainSelectedInstOperands,
     /*  224767 */     // GIR_Coverage, 8283,
     /*  224767 */     GIR_EraseRootFromParent_Done,
     /*  224768 */   // Label 4464: @224768
     /*  224768 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(224842), // Rule ID 8286 //
     /*  224773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  224784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  224787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224813 */     // MIs[1] Operand 1
     /*  224813 */     // No operand predicates
     /*  224813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224822 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  224825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224840 */     GIR_RootConstrainSelectedInstOperands,
     /*  224841 */     // GIR_Coverage, 8286,
     /*  224841 */     GIR_EraseRootFromParent_Done,
     /*  224842 */   // Label 4465: @224842
     /*  224842 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(224916), // Rule ID 8287 //
     /*  224847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  224858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  224861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224887 */     // MIs[1] Operand 1
     /*  224887 */     // No operand predicates
     /*  224887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224896 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  224899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224914 */     GIR_RootConstrainSelectedInstOperands,
     /*  224915 */     // GIR_Coverage, 8287,
     /*  224915 */     GIR_EraseRootFromParent_Done,
     /*  224916 */   // Label 4466: @224916
     /*  224916 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(224990), // Rule ID 8290 //
     /*  224921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  224935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224961 */     // MIs[1] Operand 1
     /*  224961 */     // No operand predicates
     /*  224961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224970 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224988 */     GIR_RootConstrainSelectedInstOperands,
     /*  224989 */     // GIR_Coverage, 8290,
     /*  224989 */     GIR_EraseRootFromParent_Done,
     /*  224990 */   // Label 4467: @224990
     /*  224990 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225064), // Rule ID 8291 //
     /*  224995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  225009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225035 */     // MIs[1] Operand 1
     /*  225035 */     // No operand predicates
     /*  225035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225044 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225062 */     GIR_RootConstrainSelectedInstOperands,
     /*  225063 */     // GIR_Coverage, 8291,
     /*  225063 */     GIR_EraseRootFromParent_Done,
     /*  225064 */   // Label 4468: @225064
     /*  225064 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225138), // Rule ID 8294 //
     /*  225069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225109 */     // MIs[1] Operand 1
     /*  225109 */     // No operand predicates
     /*  225109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225118 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225136 */     GIR_RootConstrainSelectedInstOperands,
     /*  225137 */     // GIR_Coverage, 8294,
     /*  225137 */     GIR_EraseRootFromParent_Done,
     /*  225138 */   // Label 4469: @225138
     /*  225138 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225212), // Rule ID 8295 //
     /*  225143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  225157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225183 */     // MIs[1] Operand 1
     /*  225183 */     // No operand predicates
     /*  225183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225192 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225210 */     GIR_RootConstrainSelectedInstOperands,
     /*  225211 */     // GIR_Coverage, 8295,
     /*  225211 */     GIR_EraseRootFromParent_Done,
     /*  225212 */   // Label 4470: @225212
     /*  225212 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225286), // Rule ID 8298 //
     /*  225217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225257 */     // MIs[1] Operand 1
     /*  225257 */     // No operand predicates
     /*  225257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225266 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  225266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225284 */     GIR_RootConstrainSelectedInstOperands,
     /*  225285 */     // GIR_Coverage, 8298,
     /*  225285 */     GIR_EraseRootFromParent_Done,
     /*  225286 */   // Label 4471: @225286
     /*  225286 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225360), // Rule ID 8299 //
     /*  225291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  225302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  225305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225331 */     // MIs[1] Operand 1
     /*  225331 */     // No operand predicates
     /*  225331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225340 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  225340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  225358 */     GIR_RootConstrainSelectedInstOperands,
     /*  225359 */     // GIR_Coverage, 8299,
     /*  225359 */     GIR_EraseRootFromParent_Done,
     /*  225360 */   // Label 4472: @225360
     /*  225360 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(225434), // Rule ID 8302 //
     /*  225365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225405 */     // MIs[1] Operand 1
     /*  225405 */     // No operand predicates
     /*  225405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225414 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225432 */     GIR_RootConstrainSelectedInstOperands,
     /*  225433 */     // GIR_Coverage, 8302,
     /*  225433 */     GIR_EraseRootFromParent_Done,
     /*  225434 */   // Label 4473: @225434
     /*  225434 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(225508), // Rule ID 8303 //
     /*  225439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  225453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225479 */     // MIs[1] Operand 1
     /*  225479 */     // No operand predicates
     /*  225479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225506 */     GIR_RootConstrainSelectedInstOperands,
     /*  225507 */     // GIR_Coverage, 8303,
     /*  225507 */     GIR_EraseRootFromParent_Done,
     /*  225508 */   // Label 4474: @225508
     /*  225508 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(225582), // Rule ID 8306 //
     /*  225513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  225527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225553 */     // MIs[1] Operand 1
     /*  225553 */     // No operand predicates
     /*  225553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225562 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225580 */     GIR_RootConstrainSelectedInstOperands,
     /*  225581 */     // GIR_Coverage, 8306,
     /*  225581 */     GIR_EraseRootFromParent_Done,
     /*  225582 */   // Label 4475: @225582
     /*  225582 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(225656), // Rule ID 8307 //
     /*  225587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  225601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225627 */     // MIs[1] Operand 1
     /*  225627 */     // No operand predicates
     /*  225627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225654 */     GIR_RootConstrainSelectedInstOperands,
     /*  225655 */     // GIR_Coverage, 8307,
     /*  225655 */     GIR_EraseRootFromParent_Done,
     /*  225656 */   // Label 4476: @225656
     /*  225656 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(225730), // Rule ID 8310 //
     /*  225661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  225675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225701 */     // MIs[1] Operand 1
     /*  225701 */     // No operand predicates
     /*  225701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225710 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225728 */     GIR_RootConstrainSelectedInstOperands,
     /*  225729 */     // GIR_Coverage, 8310,
     /*  225729 */     GIR_EraseRootFromParent_Done,
     /*  225730 */   // Label 4477: @225730
     /*  225730 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(225804), // Rule ID 8311 //
     /*  225735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  225749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225775 */     // MIs[1] Operand 1
     /*  225775 */     // No operand predicates
     /*  225775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225784 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225802 */     GIR_RootConstrainSelectedInstOperands,
     /*  225803 */     // GIR_Coverage, 8311,
     /*  225803 */     GIR_EraseRootFromParent_Done,
     /*  225804 */   // Label 4478: @225804
     /*  225804 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(225878), // Rule ID 8314 //
     /*  225809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  225812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  225823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225849 */     // MIs[1] Operand 1
     /*  225849 */     // No operand predicates
     /*  225849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225858 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  225858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225876 */     GIR_RootConstrainSelectedInstOperands,
     /*  225877 */     // GIR_Coverage, 8314,
     /*  225877 */     GIR_EraseRootFromParent_Done,
     /*  225878 */   // Label 4479: @225878
     /*  225878 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(225952), // Rule ID 8315 //
     /*  225883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  225886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  225897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225923 */     // MIs[1] Operand 1
     /*  225923 */     // No operand predicates
     /*  225923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225932 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  225932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225950 */     GIR_RootConstrainSelectedInstOperands,
     /*  225951 */     // GIR_Coverage, 8315,
     /*  225951 */     GIR_EraseRootFromParent_Done,
     /*  225952 */   // Label 4480: @225952
     /*  225952 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226026), // Rule ID 8318 //
     /*  225957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  225960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  225971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225997 */     // MIs[1] Operand 1
     /*  225997 */     // No operand predicates
     /*  225997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226006 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226024 */     GIR_RootConstrainSelectedInstOperands,
     /*  226025 */     // GIR_Coverage, 8318,
     /*  226025 */     GIR_EraseRootFromParent_Done,
     /*  226026 */   // Label 4481: @226026
     /*  226026 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226100), // Rule ID 8319 //
     /*  226031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  226045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  226059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226071 */     // MIs[1] Operand 1
     /*  226071 */     // No operand predicates
     /*  226071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226080 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  226083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226098 */     GIR_RootConstrainSelectedInstOperands,
     /*  226099 */     // GIR_Coverage, 8319,
     /*  226099 */     GIR_EraseRootFromParent_Done,
     /*  226100 */   // Label 4482: @226100
     /*  226100 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226174), // Rule ID 8322 //
     /*  226105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  226108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226145 */     // MIs[1] Operand 1
     /*  226145 */     // No operand predicates
     /*  226145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226154 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  226154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226172 */     GIR_RootConstrainSelectedInstOperands,
     /*  226173 */     // GIR_Coverage, 8322,
     /*  226173 */     GIR_EraseRootFromParent_Done,
     /*  226174 */   // Label 4483: @226174
     /*  226174 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226248), // Rule ID 8323 //
     /*  226179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  226182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  226187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  226193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  226207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226219 */     // MIs[1] Operand 1
     /*  226219 */     // No operand predicates
     /*  226219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226228 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  226228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  226231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  226246 */     GIR_RootConstrainSelectedInstOperands,
     /*  226247 */     // GIR_Coverage, 8323,
     /*  226247 */     GIR_EraseRootFromParent_Done,
     /*  226248 */   // Label 4484: @226248
     /*  226248 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226322), // Rule ID 8854 //
     /*  226253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226293 */     // MIs[1] Operand 1
     /*  226293 */     // No operand predicates
     /*  226293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226302 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  226305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226320 */     GIR_RootConstrainSelectedInstOperands,
     /*  226321 */     // GIR_Coverage, 8854,
     /*  226321 */     GIR_EraseRootFromParent_Done,
     /*  226322 */   // Label 4485: @226322
     /*  226322 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226396), // Rule ID 8855 //
     /*  226327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  226341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226367 */     // MIs[1] Operand 1
     /*  226367 */     // No operand predicates
     /*  226367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226376 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  226379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226394 */     GIR_RootConstrainSelectedInstOperands,
     /*  226395 */     // GIR_Coverage, 8855,
     /*  226395 */     GIR_EraseRootFromParent_Done,
     /*  226396 */   // Label 4486: @226396
     /*  226396 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226470), // Rule ID 8858 //
     /*  226401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  226415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226441 */     // MIs[1] Operand 1
     /*  226441 */     // No operand predicates
     /*  226441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226450 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226468 */     GIR_RootConstrainSelectedInstOperands,
     /*  226469 */     // GIR_Coverage, 8858,
     /*  226469 */     GIR_EraseRootFromParent_Done,
     /*  226470 */   // Label 4487: @226470
     /*  226470 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226544), // Rule ID 8859 //
     /*  226475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  226489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226515 */     // MIs[1] Operand 1
     /*  226515 */     // No operand predicates
     /*  226515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226524 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226542 */     GIR_RootConstrainSelectedInstOperands,
     /*  226543 */     // GIR_Coverage, 8859,
     /*  226543 */     GIR_EraseRootFromParent_Done,
     /*  226544 */   // Label 4488: @226544
     /*  226544 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226618), // Rule ID 8862 //
     /*  226549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  226563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226589 */     // MIs[1] Operand 1
     /*  226589 */     // No operand predicates
     /*  226589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226598 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226616 */     GIR_RootConstrainSelectedInstOperands,
     /*  226617 */     // GIR_Coverage, 8862,
     /*  226617 */     GIR_EraseRootFromParent_Done,
     /*  226618 */   // Label 4489: @226618
     /*  226618 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226692), // Rule ID 8863 //
     /*  226623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  226637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226663 */     // MIs[1] Operand 1
     /*  226663 */     // No operand predicates
     /*  226663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226672 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226690 */     GIR_RootConstrainSelectedInstOperands,
     /*  226691 */     // GIR_Coverage, 8863,
     /*  226691 */     GIR_EraseRootFromParent_Done,
     /*  226692 */   // Label 4490: @226692
     /*  226692 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226766), // Rule ID 8866 //
     /*  226697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  226711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226737 */     // MIs[1] Operand 1
     /*  226737 */     // No operand predicates
     /*  226737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226746 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226764 */     GIR_RootConstrainSelectedInstOperands,
     /*  226765 */     // GIR_Coverage, 8866,
     /*  226765 */     GIR_EraseRootFromParent_Done,
     /*  226766 */   // Label 4491: @226766
     /*  226766 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226840), // Rule ID 8867 //
     /*  226771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  226785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226811 */     // MIs[1] Operand 1
     /*  226811 */     // No operand predicates
     /*  226811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226820 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226838 */     GIR_RootConstrainSelectedInstOperands,
     /*  226839 */     // GIR_Coverage, 8867,
     /*  226839 */     GIR_EraseRootFromParent_Done,
     /*  226840 */   // Label 4492: @226840
     /*  226840 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226914), // Rule ID 8870 //
     /*  226845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  226859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226885 */     // MIs[1] Operand 1
     /*  226885 */     // No operand predicates
     /*  226885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226894 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226912 */     GIR_RootConstrainSelectedInstOperands,
     /*  226913 */     // GIR_Coverage, 8870,
     /*  226913 */     GIR_EraseRootFromParent_Done,
     /*  226914 */   // Label 4493: @226914
     /*  226914 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(226988), // Rule ID 8871 //
     /*  226919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  226933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226959 */     // MIs[1] Operand 1
     /*  226959 */     // No operand predicates
     /*  226959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226986 */     GIR_RootConstrainSelectedInstOperands,
     /*  226987 */     // GIR_Coverage, 8871,
     /*  226987 */     GIR_EraseRootFromParent_Done,
     /*  226988 */   // Label 4494: @226988
     /*  226988 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(227062), // Rule ID 8874 //
     /*  226993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227033 */     // MIs[1] Operand 1
     /*  227033 */     // No operand predicates
     /*  227033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227042 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227060 */     GIR_RootConstrainSelectedInstOperands,
     /*  227061 */     // GIR_Coverage, 8874,
     /*  227061 */     GIR_EraseRootFromParent_Done,
     /*  227062 */   // Label 4495: @227062
     /*  227062 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(227136), // Rule ID 8875 //
     /*  227067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  227081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227107 */     // MIs[1] Operand 1
     /*  227107 */     // No operand predicates
     /*  227107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227116 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  227119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227134 */     GIR_RootConstrainSelectedInstOperands,
     /*  227135 */     // GIR_Coverage, 8875,
     /*  227135 */     GIR_EraseRootFromParent_Done,
     /*  227136 */   // Label 4496: @227136
     /*  227136 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(227210), // Rule ID 8878 //
     /*  227141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227181 */     // MIs[1] Operand 1
     /*  227181 */     // No operand predicates
     /*  227181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227208 */     GIR_RootConstrainSelectedInstOperands,
     /*  227209 */     // GIR_Coverage, 8878,
     /*  227209 */     GIR_EraseRootFromParent_Done,
     /*  227210 */   // Label 4497: @227210
     /*  227210 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(227284), // Rule ID 8879 //
     /*  227215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  227229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227255 */     // MIs[1] Operand 1
     /*  227255 */     // No operand predicates
     /*  227255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227282 */     GIR_RootConstrainSelectedInstOperands,
     /*  227283 */     // GIR_Coverage, 8879,
     /*  227283 */     GIR_EraseRootFromParent_Done,
     /*  227284 */   // Label 4498: @227284
     /*  227284 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(227358), // Rule ID 8882 //
     /*  227289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227329 */     // MIs[1] Operand 1
     /*  227329 */     // No operand predicates
     /*  227329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227338 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227356 */     GIR_RootConstrainSelectedInstOperands,
     /*  227357 */     // GIR_Coverage, 8882,
     /*  227357 */     GIR_EraseRootFromParent_Done,
     /*  227358 */   // Label 4499: @227358
     /*  227358 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227432), // Rule ID 8883 //
     /*  227363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  227374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  227377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227403 */     // MIs[1] Operand 1
     /*  227403 */     // No operand predicates
     /*  227403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227412 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227430 */     GIR_RootConstrainSelectedInstOperands,
     /*  227431 */     // GIR_Coverage, 8883,
     /*  227431 */     GIR_EraseRootFromParent_Done,
     /*  227432 */   // Label 4500: @227432
     /*  227432 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227506), // Rule ID 8886 //
     /*  227437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  227451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227477 */     // MIs[1] Operand 1
     /*  227477 */     // No operand predicates
     /*  227477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  227486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227504 */     GIR_RootConstrainSelectedInstOperands,
     /*  227505 */     // GIR_Coverage, 8886,
     /*  227505 */     GIR_EraseRootFromParent_Done,
     /*  227506 */   // Label 4501: @227506
     /*  227506 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227580), // Rule ID 8887 //
     /*  227511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  227525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227551 */     // MIs[1] Operand 1
     /*  227551 */     // No operand predicates
     /*  227551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227560 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227578 */     GIR_RootConstrainSelectedInstOperands,
     /*  227579 */     // GIR_Coverage, 8887,
     /*  227579 */     GIR_EraseRootFromParent_Done,
     /*  227580 */   // Label 4502: @227580
     /*  227580 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227654), // Rule ID 8890 //
     /*  227585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  227588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  227599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227625 */     // MIs[1] Operand 1
     /*  227625 */     // No operand predicates
     /*  227625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227634 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  227634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227652 */     GIR_RootConstrainSelectedInstOperands,
     /*  227653 */     // GIR_Coverage, 8890,
     /*  227653 */     GIR_EraseRootFromParent_Done,
     /*  227654 */   // Label 4503: @227654
     /*  227654 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227728), // Rule ID 8891 //
     /*  227659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  227662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  227673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227699 */     // MIs[1] Operand 1
     /*  227699 */     // No operand predicates
     /*  227699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  227708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227726 */     GIR_RootConstrainSelectedInstOperands,
     /*  227727 */     // GIR_Coverage, 8891,
     /*  227727 */     GIR_EraseRootFromParent_Done,
     /*  227728 */   // Label 4504: @227728
     /*  227728 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227802), // Rule ID 8894 //
     /*  227733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  227747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227773 */     // MIs[1] Operand 1
     /*  227773 */     // No operand predicates
     /*  227773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227782 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  227785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227800 */     GIR_RootConstrainSelectedInstOperands,
     /*  227801 */     // GIR_Coverage, 8894,
     /*  227801 */     GIR_EraseRootFromParent_Done,
     /*  227802 */   // Label 4505: @227802
     /*  227802 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227876), // Rule ID 8895 //
     /*  227807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  227821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227847 */     // MIs[1] Operand 1
     /*  227847 */     // No operand predicates
     /*  227847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227856 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  227859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227874 */     GIR_RootConstrainSelectedInstOperands,
     /*  227875 */     // GIR_Coverage, 8895,
     /*  227875 */     GIR_EraseRootFromParent_Done,
     /*  227876 */   // Label 4506: @227876
     /*  227876 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227950), // Rule ID 8898 //
     /*  227881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  227892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  227895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227921 */     // MIs[1] Operand 1
     /*  227921 */     // No operand predicates
     /*  227921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227930 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  227933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227948 */     GIR_RootConstrainSelectedInstOperands,
     /*  227949 */     // GIR_Coverage, 8898,
     /*  227949 */     GIR_EraseRootFromParent_Done,
     /*  227950 */   // Label 4507: @227950
     /*  227950 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(228024), // Rule ID 8899 //
     /*  227955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  227966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  227969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227995 */     // MIs[1] Operand 1
     /*  227995 */     // No operand predicates
     /*  227995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228004 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228022 */     GIR_RootConstrainSelectedInstOperands,
     /*  228023 */     // GIR_Coverage, 8899,
     /*  228023 */     GIR_EraseRootFromParent_Done,
     /*  228024 */   // Label 4508: @228024
     /*  228024 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(228098), // Rule ID 8902 //
     /*  228029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228069 */     // MIs[1] Operand 1
     /*  228069 */     // No operand predicates
     /*  228069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228078 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  228078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228096 */     GIR_RootConstrainSelectedInstOperands,
     /*  228097 */     // GIR_Coverage, 8902,
     /*  228097 */     GIR_EraseRootFromParent_Done,
     /*  228098 */   // Label 4509: @228098
     /*  228098 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(228172), // Rule ID 8903 //
     /*  228103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  228114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  228117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228143 */     // MIs[1] Operand 1
     /*  228143 */     // No operand predicates
     /*  228143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228152 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  228152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  228170 */     GIR_RootConstrainSelectedInstOperands,
     /*  228171 */     // GIR_Coverage, 8903,
     /*  228171 */     GIR_EraseRootFromParent_Done,
     /*  228172 */   // Label 4510: @228172
     /*  228172 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(228246), // Rule ID 8906 //
     /*  228177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228217 */     // MIs[1] Operand 1
     /*  228217 */     // No operand predicates
     /*  228217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228226 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228244 */     GIR_RootConstrainSelectedInstOperands,
     /*  228245 */     // GIR_Coverage, 8906,
     /*  228245 */     GIR_EraseRootFromParent_Done,
     /*  228246 */   // Label 4511: @228246
     /*  228246 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(228320), // Rule ID 8907 //
     /*  228251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  228265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228291 */     // MIs[1] Operand 1
     /*  228291 */     // No operand predicates
     /*  228291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228318 */     GIR_RootConstrainSelectedInstOperands,
     /*  228319 */     // GIR_Coverage, 8907,
     /*  228319 */     GIR_EraseRootFromParent_Done,
     /*  228320 */   // Label 4512: @228320
     /*  228320 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(228394), // Rule ID 8910 //
     /*  228325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228365 */     // MIs[1] Operand 1
     /*  228365 */     // No operand predicates
     /*  228365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228374 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228392 */     GIR_RootConstrainSelectedInstOperands,
     /*  228393 */     // GIR_Coverage, 8910,
     /*  228393 */     GIR_EraseRootFromParent_Done,
     /*  228394 */   // Label 4513: @228394
     /*  228394 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(228468), // Rule ID 8911 //
     /*  228399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  228413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228439 */     // MIs[1] Operand 1
     /*  228439 */     // No operand predicates
     /*  228439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228448 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228466 */     GIR_RootConstrainSelectedInstOperands,
     /*  228467 */     // GIR_Coverage, 8911,
     /*  228467 */     GIR_EraseRootFromParent_Done,
     /*  228468 */   // Label 4514: @228468
     /*  228468 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(228542), // Rule ID 8914 //
     /*  228473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  228487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228513 */     // MIs[1] Operand 1
     /*  228513 */     // No operand predicates
     /*  228513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228522 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228540 */     GIR_RootConstrainSelectedInstOperands,
     /*  228541 */     // GIR_Coverage, 8914,
     /*  228541 */     GIR_EraseRootFromParent_Done,
     /*  228542 */   // Label 4515: @228542
     /*  228542 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(228616), // Rule ID 8915 //
     /*  228547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  228561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228587 */     // MIs[1] Operand 1
     /*  228587 */     // No operand predicates
     /*  228587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228596 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228614 */     GIR_RootConstrainSelectedInstOperands,
     /*  228615 */     // GIR_Coverage, 8915,
     /*  228615 */     GIR_EraseRootFromParent_Done,
     /*  228616 */   // Label 4516: @228616
     /*  228616 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(228690), // Rule ID 8918 //
     /*  228621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  228635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228661 */     // MIs[1] Operand 1
     /*  228661 */     // No operand predicates
     /*  228661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228688 */     GIR_RootConstrainSelectedInstOperands,
     /*  228689 */     // GIR_Coverage, 8918,
     /*  228689 */     GIR_EraseRootFromParent_Done,
     /*  228690 */   // Label 4517: @228690
     /*  228690 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(228764), // Rule ID 8919 //
     /*  228695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  228709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228735 */     // MIs[1] Operand 1
     /*  228735 */     // No operand predicates
     /*  228735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228744 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228762 */     GIR_RootConstrainSelectedInstOperands,
     /*  228763 */     // GIR_Coverage, 8919,
     /*  228763 */     GIR_EraseRootFromParent_Done,
     /*  228764 */   // Label 4518: @228764
     /*  228764 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(228838), // Rule ID 8922 //
     /*  228769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  228783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228809 */     // MIs[1] Operand 1
     /*  228809 */     // No operand predicates
     /*  228809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228818 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228836 */     GIR_RootConstrainSelectedInstOperands,
     /*  228837 */     // GIR_Coverage, 8922,
     /*  228837 */     GIR_EraseRootFromParent_Done,
     /*  228838 */   // Label 4519: @228838
     /*  228838 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(228912), // Rule ID 8923 //
     /*  228843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  228857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228883 */     // MIs[1] Operand 1
     /*  228883 */     // No operand predicates
     /*  228883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228892 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228910 */     GIR_RootConstrainSelectedInstOperands,
     /*  228911 */     // GIR_Coverage, 8923,
     /*  228911 */     GIR_EraseRootFromParent_Done,
     /*  228912 */   // Label 4520: @228912
     /*  228912 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(228986), // Rule ID 8926 //
     /*  228917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  228931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228957 */     // MIs[1] Operand 1
     /*  228957 */     // No operand predicates
     /*  228957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228966 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228984 */     GIR_RootConstrainSelectedInstOperands,
     /*  228985 */     // GIR_Coverage, 8926,
     /*  228985 */     GIR_EraseRootFromParent_Done,
     /*  228986 */   // Label 4521: @228986
     /*  228986 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(229060), // Rule ID 8927 //
     /*  228991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  229002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  229005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229031 */     // MIs[1] Operand 1
     /*  229031 */     // No operand predicates
     /*  229031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229058 */     GIR_RootConstrainSelectedInstOperands,
     /*  229059 */     // GIR_Coverage, 8927,
     /*  229059 */     GIR_EraseRootFromParent_Done,
     /*  229060 */   // Label 4522: @229060
     /*  229060 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(229134), // Rule ID 8930 //
     /*  229065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229105 */     // MIs[1] Operand 1
     /*  229105 */     // No operand predicates
     /*  229105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229114 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229132 */     GIR_RootConstrainSelectedInstOperands,
     /*  229133 */     // GIR_Coverage, 8930,
     /*  229133 */     GIR_EraseRootFromParent_Done,
     /*  229134 */   // Label 4523: @229134
     /*  229134 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(229208), // Rule ID 8931 //
     /*  229139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  229153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  229167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229179 */     // MIs[1] Operand 1
     /*  229179 */     // No operand predicates
     /*  229179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229188 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  229191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229206 */     GIR_RootConstrainSelectedInstOperands,
     /*  229207 */     // GIR_Coverage, 8931,
     /*  229207 */     GIR_EraseRootFromParent_Done,
     /*  229208 */   // Label 4524: @229208
     /*  229208 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(229282), // Rule ID 8934 //
     /*  229213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229253 */     // MIs[1] Operand 1
     /*  229253 */     // No operand predicates
     /*  229253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229262 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229280 */     GIR_RootConstrainSelectedInstOperands,
     /*  229281 */     // GIR_Coverage, 8934,
     /*  229281 */     GIR_EraseRootFromParent_Done,
     /*  229282 */   // Label 4525: @229282
     /*  229282 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(229356), // Rule ID 8935 //
     /*  229287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  229301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  229315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229327 */     // MIs[1] Operand 1
     /*  229327 */     // No operand predicates
     /*  229327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229336 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  229339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229354 */     GIR_RootConstrainSelectedInstOperands,
     /*  229355 */     // GIR_Coverage, 8935,
     /*  229355 */     GIR_EraseRootFromParent_Done,
     /*  229356 */   // Label 4526: @229356
     /*  229356 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(229430), // Rule ID 8938 //
     /*  229361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  229364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229401 */     // MIs[1] Operand 1
     /*  229401 */     // No operand predicates
     /*  229401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  229410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229428 */     GIR_RootConstrainSelectedInstOperands,
     /*  229429 */     // GIR_Coverage, 8938,
     /*  229429 */     GIR_EraseRootFromParent_Done,
     /*  229430 */   // Label 4527: @229430
     /*  229430 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(229504), // Rule ID 8939 //
     /*  229435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  229438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  229443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  229449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  229463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229475 */     // MIs[1] Operand 1
     /*  229475 */     // No operand predicates
     /*  229475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229484 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  229484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  229487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  229502 */     GIR_RootConstrainSelectedInstOperands,
     /*  229503 */     // GIR_Coverage, 8939,
     /*  229503 */     GIR_EraseRootFromParent_Done,
     /*  229504 */   // Label 4528: @229504
     /*  229504 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(229578), // Rule ID 9118 //
     /*  229509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  229523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229549 */     // MIs[1] Operand 1
     /*  229549 */     // No operand predicates
     /*  229549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  229561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229576 */     GIR_RootConstrainSelectedInstOperands,
     /*  229577 */     // GIR_Coverage, 9118,
     /*  229577 */     GIR_EraseRootFromParent_Done,
     /*  229578 */   // Label 4529: @229578
     /*  229578 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(229652), // Rule ID 9119 //
     /*  229583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  229597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229623 */     // MIs[1] Operand 1
     /*  229623 */     // No operand predicates
     /*  229623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  229632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  229635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229650 */     GIR_RootConstrainSelectedInstOperands,
     /*  229651 */     // GIR_Coverage, 9119,
     /*  229651 */     GIR_EraseRootFromParent_Done,
     /*  229652 */   // Label 4530: @229652
     /*  229652 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(229726), // Rule ID 9122 //
     /*  229657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  229671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229697 */     // MIs[1] Operand 1
     /*  229697 */     // No operand predicates
     /*  229697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229706 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  229709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229724 */     GIR_RootConstrainSelectedInstOperands,
     /*  229725 */     // GIR_Coverage, 9122,
     /*  229725 */     GIR_EraseRootFromParent_Done,
     /*  229726 */   // Label 4531: @229726
     /*  229726 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(229800), // Rule ID 9123 //
     /*  229731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  229745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229771 */     // MIs[1] Operand 1
     /*  229771 */     // No operand predicates
     /*  229771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  229780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  229783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229798 */     GIR_RootConstrainSelectedInstOperands,
     /*  229799 */     // GIR_Coverage, 9123,
     /*  229799 */     GIR_EraseRootFromParent_Done,
     /*  229800 */   // Label 4532: @229800
     /*  229800 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(229874), // Rule ID 9126 //
     /*  229805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  229819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229845 */     // MIs[1] Operand 1
     /*  229845 */     // No operand predicates
     /*  229845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229854 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229872 */     GIR_RootConstrainSelectedInstOperands,
     /*  229873 */     // GIR_Coverage, 9126,
     /*  229873 */     GIR_EraseRootFromParent_Done,
     /*  229874 */   // Label 4533: @229874
     /*  229874 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(229948), // Rule ID 9127 //
     /*  229879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  229893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229919 */     // MIs[1] Operand 1
     /*  229919 */     // No operand predicates
     /*  229919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229928 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  229928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229946 */     GIR_RootConstrainSelectedInstOperands,
     /*  229947 */     // GIR_Coverage, 9127,
     /*  229947 */     GIR_EraseRootFromParent_Done,
     /*  229948 */   // Label 4534: @229948
     /*  229948 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(230022), // Rule ID 9130 //
     /*  229953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  229967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229993 */     // MIs[1] Operand 1
     /*  229993 */     // No operand predicates
     /*  229993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230002 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230020 */     GIR_RootConstrainSelectedInstOperands,
     /*  230021 */     // GIR_Coverage, 9130,
     /*  230021 */     GIR_EraseRootFromParent_Done,
     /*  230022 */   // Label 4535: @230022
     /*  230022 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(230096), // Rule ID 9131 //
     /*  230027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  230041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230067 */     // MIs[1] Operand 1
     /*  230067 */     // No operand predicates
     /*  230067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230076 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  230079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230094 */     GIR_RootConstrainSelectedInstOperands,
     /*  230095 */     // GIR_Coverage, 9131,
     /*  230095 */     GIR_EraseRootFromParent_Done,
     /*  230096 */   // Label 4536: @230096
     /*  230096 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(230170), // Rule ID 9134 //
     /*  230101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230141 */     // MIs[1] Operand 1
     /*  230141 */     // No operand predicates
     /*  230141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230168 */     GIR_RootConstrainSelectedInstOperands,
     /*  230169 */     // GIR_Coverage, 9134,
     /*  230169 */     GIR_EraseRootFromParent_Done,
     /*  230170 */   // Label 4537: @230170
     /*  230170 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(230244), // Rule ID 9135 //
     /*  230175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  230189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230215 */     // MIs[1] Operand 1
     /*  230215 */     // No operand predicates
     /*  230215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230224 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230242 */     GIR_RootConstrainSelectedInstOperands,
     /*  230243 */     // GIR_Coverage, 9135,
     /*  230243 */     GIR_EraseRootFromParent_Done,
     /*  230244 */   // Label 4538: @230244
     /*  230244 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(230318), // Rule ID 9138 //
     /*  230249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230289 */     // MIs[1] Operand 1
     /*  230289 */     // No operand predicates
     /*  230289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230298 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230316 */     GIR_RootConstrainSelectedInstOperands,
     /*  230317 */     // GIR_Coverage, 9138,
     /*  230317 */     GIR_EraseRootFromParent_Done,
     /*  230318 */   // Label 4539: @230318
     /*  230318 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(230392), // Rule ID 9139 //
     /*  230323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  230337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230363 */     // MIs[1] Operand 1
     /*  230363 */     // No operand predicates
     /*  230363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230372 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  230375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230390 */     GIR_RootConstrainSelectedInstOperands,
     /*  230391 */     // GIR_Coverage, 9139,
     /*  230391 */     GIR_EraseRootFromParent_Done,
     /*  230392 */   // Label 4540: @230392
     /*  230392 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(230466), // Rule ID 9142 //
     /*  230397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230437 */     // MIs[1] Operand 1
     /*  230437 */     // No operand predicates
     /*  230437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230446 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230464 */     GIR_RootConstrainSelectedInstOperands,
     /*  230465 */     // GIR_Coverage, 9142,
     /*  230465 */     GIR_EraseRootFromParent_Done,
     /*  230466 */   // Label 4541: @230466
     /*  230466 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(230540), // Rule ID 9143 //
     /*  230471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  230485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230511 */     // MIs[1] Operand 1
     /*  230511 */     // No operand predicates
     /*  230511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230520 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230538 */     GIR_RootConstrainSelectedInstOperands,
     /*  230539 */     // GIR_Coverage, 9143,
     /*  230539 */     GIR_EraseRootFromParent_Done,
     /*  230540 */   // Label 4542: @230540
     /*  230540 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(230614), // Rule ID 9146 //
     /*  230545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  230559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230585 */     // MIs[1] Operand 1
     /*  230585 */     // No operand predicates
     /*  230585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230594 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230612 */     GIR_RootConstrainSelectedInstOperands,
     /*  230613 */     // GIR_Coverage, 9146,
     /*  230613 */     GIR_EraseRootFromParent_Done,
     /*  230614 */   // Label 4543: @230614
     /*  230614 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(230688), // Rule ID 9147 //
     /*  230619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  230633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230659 */     // MIs[1] Operand 1
     /*  230659 */     // No operand predicates
     /*  230659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230686 */     GIR_RootConstrainSelectedInstOperands,
     /*  230687 */     // GIR_Coverage, 9147,
     /*  230687 */     GIR_EraseRootFromParent_Done,
     /*  230688 */   // Label 4544: @230688
     /*  230688 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(230762), // Rule ID 9150 //
     /*  230693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  230707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230733 */     // MIs[1] Operand 1
     /*  230733 */     // No operand predicates
     /*  230733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230742 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230760 */     GIR_RootConstrainSelectedInstOperands,
     /*  230761 */     // GIR_Coverage, 9150,
     /*  230761 */     GIR_EraseRootFromParent_Done,
     /*  230762 */   // Label 4545: @230762
     /*  230762 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(230836), // Rule ID 9151 //
     /*  230767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  230781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230807 */     // MIs[1] Operand 1
     /*  230807 */     // No operand predicates
     /*  230807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230834 */     GIR_RootConstrainSelectedInstOperands,
     /*  230835 */     // GIR_Coverage, 9151,
     /*  230835 */     GIR_EraseRootFromParent_Done,
     /*  230836 */   // Label 4546: @230836
     /*  230836 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(230910), // Rule ID 9154 //
     /*  230841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  230844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  230855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230881 */     // MIs[1] Operand 1
     /*  230881 */     // No operand predicates
     /*  230881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230890 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  230890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230908 */     GIR_RootConstrainSelectedInstOperands,
     /*  230909 */     // GIR_Coverage, 9154,
     /*  230909 */     GIR_EraseRootFromParent_Done,
     /*  230910 */   // Label 4547: @230910
     /*  230910 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(230984), // Rule ID 9155 //
     /*  230915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  230918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  230929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230955 */     // MIs[1] Operand 1
     /*  230955 */     // No operand predicates
     /*  230955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  230964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230982 */     GIR_RootConstrainSelectedInstOperands,
     /*  230983 */     // GIR_Coverage, 9155,
     /*  230983 */     GIR_EraseRootFromParent_Done,
     /*  230984 */   // Label 4548: @230984
     /*  230984 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(231058), // Rule ID 9158 //
     /*  230989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231029 */     // MIs[1] Operand 1
     /*  231029 */     // No operand predicates
     /*  231029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231038 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231056 */     GIR_RootConstrainSelectedInstOperands,
     /*  231057 */     // GIR_Coverage, 9158,
     /*  231057 */     GIR_EraseRootFromParent_Done,
     /*  231058 */   // Label 4549: @231058
     /*  231058 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(231132), // Rule ID 9159 //
     /*  231063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  231077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231103 */     // MIs[1] Operand 1
     /*  231103 */     // No operand predicates
     /*  231103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231112 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231130 */     GIR_RootConstrainSelectedInstOperands,
     /*  231131 */     // GIR_Coverage, 9159,
     /*  231131 */     GIR_EraseRootFromParent_Done,
     /*  231132 */   // Label 4550: @231132
     /*  231132 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(231206), // Rule ID 9162 //
     /*  231137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231177 */     // MIs[1] Operand 1
     /*  231177 */     // No operand predicates
     /*  231177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231186 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231204 */     GIR_RootConstrainSelectedInstOperands,
     /*  231205 */     // GIR_Coverage, 9162,
     /*  231205 */     GIR_EraseRootFromParent_Done,
     /*  231206 */   // Label 4551: @231206
     /*  231206 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(231280), // Rule ID 9163 //
     /*  231211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  231225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231251 */     // MIs[1] Operand 1
     /*  231251 */     // No operand predicates
     /*  231251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231260 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231278 */     GIR_RootConstrainSelectedInstOperands,
     /*  231279 */     // GIR_Coverage, 9163,
     /*  231279 */     GIR_EraseRootFromParent_Done,
     /*  231280 */   // Label 4552: @231280
     /*  231280 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(231354), // Rule ID 9166 //
     /*  231285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231325 */     // MIs[1] Operand 1
     /*  231325 */     // No operand predicates
     /*  231325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231334 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  231334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231352 */     GIR_RootConstrainSelectedInstOperands,
     /*  231353 */     // GIR_Coverage, 9166,
     /*  231353 */     GIR_EraseRootFromParent_Done,
     /*  231354 */   // Label 4553: @231354
     /*  231354 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(231428), // Rule ID 9167 //
     /*  231359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  231370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  231373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231399 */     // MIs[1] Operand 1
     /*  231399 */     // No operand predicates
     /*  231399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231408 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  231408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  231426 */     GIR_RootConstrainSelectedInstOperands,
     /*  231427 */     // GIR_Coverage, 9167,
     /*  231427 */     GIR_EraseRootFromParent_Done,
     /*  231428 */   // Label 4554: @231428
     /*  231428 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(231502), // Rule ID 9170 //
     /*  231433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  231447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231473 */     // MIs[1] Operand 1
     /*  231473 */     // No operand predicates
     /*  231473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231482 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231500 */     GIR_RootConstrainSelectedInstOperands,
     /*  231501 */     // GIR_Coverage, 9170,
     /*  231501 */     GIR_EraseRootFromParent_Done,
     /*  231502 */   // Label 4555: @231502
     /*  231502 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(231576), // Rule ID 9171 //
     /*  231507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  231521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231547 */     // MIs[1] Operand 1
     /*  231547 */     // No operand predicates
     /*  231547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231556 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231574 */     GIR_RootConstrainSelectedInstOperands,
     /*  231575 */     // GIR_Coverage, 9171,
     /*  231575 */     GIR_EraseRootFromParent_Done,
     /*  231576 */   // Label 4556: @231576
     /*  231576 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(231650), // Rule ID 9174 //
     /*  231581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  231595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231621 */     // MIs[1] Operand 1
     /*  231621 */     // No operand predicates
     /*  231621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231630 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231648 */     GIR_RootConstrainSelectedInstOperands,
     /*  231649 */     // GIR_Coverage, 9174,
     /*  231649 */     GIR_EraseRootFromParent_Done,
     /*  231650 */   // Label 4557: @231650
     /*  231650 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(231724), // Rule ID 9175 //
     /*  231655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  231669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231695 */     // MIs[1] Operand 1
     /*  231695 */     // No operand predicates
     /*  231695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231704 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231722 */     GIR_RootConstrainSelectedInstOperands,
     /*  231723 */     // GIR_Coverage, 9175,
     /*  231723 */     GIR_EraseRootFromParent_Done,
     /*  231724 */   // Label 4558: @231724
     /*  231724 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(231798), // Rule ID 9178 //
     /*  231729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  231743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231769 */     // MIs[1] Operand 1
     /*  231769 */     // No operand predicates
     /*  231769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231778 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231796 */     GIR_RootConstrainSelectedInstOperands,
     /*  231797 */     // GIR_Coverage, 9178,
     /*  231797 */     GIR_EraseRootFromParent_Done,
     /*  231798 */   // Label 4559: @231798
     /*  231798 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(231872), // Rule ID 9179 //
     /*  231803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  231817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231843 */     // MIs[1] Operand 1
     /*  231843 */     // No operand predicates
     /*  231843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231852 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231870 */     GIR_RootConstrainSelectedInstOperands,
     /*  231871 */     // GIR_Coverage, 9179,
     /*  231871 */     GIR_EraseRootFromParent_Done,
     /*  231872 */   // Label 4560: @231872
     /*  231872 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(231946), // Rule ID 9182 //
     /*  231877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  231891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231917 */     // MIs[1] Operand 1
     /*  231917 */     // No operand predicates
     /*  231917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231926 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231944 */     GIR_RootConstrainSelectedInstOperands,
     /*  231945 */     // GIR_Coverage, 9182,
     /*  231945 */     GIR_EraseRootFromParent_Done,
     /*  231946 */   // Label 4561: @231946
     /*  231946 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(232020), // Rule ID 9183 //
     /*  231951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  231965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231991 */     // MIs[1] Operand 1
     /*  231991 */     // No operand predicates
     /*  231991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232000 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232018 */     GIR_RootConstrainSelectedInstOperands,
     /*  232019 */     // GIR_Coverage, 9183,
     /*  232019 */     GIR_EraseRootFromParent_Done,
     /*  232020 */   // Label 4562: @232020
     /*  232020 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(232094), // Rule ID 9186 //
     /*  232025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232065 */     // MIs[1] Operand 1
     /*  232065 */     // No operand predicates
     /*  232065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232074 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232092 */     GIR_RootConstrainSelectedInstOperands,
     /*  232093 */     // GIR_Coverage, 9186,
     /*  232093 */     GIR_EraseRootFromParent_Done,
     /*  232094 */   // Label 4563: @232094
     /*  232094 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(232168), // Rule ID 9187 //
     /*  232099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  232113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232139 */     // MIs[1] Operand 1
     /*  232139 */     // No operand predicates
     /*  232139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232148 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232166 */     GIR_RootConstrainSelectedInstOperands,
     /*  232167 */     // GIR_Coverage, 9187,
     /*  232167 */     GIR_EraseRootFromParent_Done,
     /*  232168 */   // Label 4564: @232168
     /*  232168 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(232242), // Rule ID 9190 //
     /*  232173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232213 */     // MIs[1] Operand 1
     /*  232213 */     // No operand predicates
     /*  232213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232222 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  232222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232240 */     GIR_RootConstrainSelectedInstOperands,
     /*  232241 */     // GIR_Coverage, 9190,
     /*  232241 */     GIR_EraseRootFromParent_Done,
     /*  232242 */   // Label 4565: @232242
     /*  232242 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(232316), // Rule ID 9191 //
     /*  232247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  232258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  232261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232287 */     // MIs[1] Operand 1
     /*  232287 */     // No operand predicates
     /*  232287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232296 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  232296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  232314 */     GIR_RootConstrainSelectedInstOperands,
     /*  232315 */     // GIR_Coverage, 9191,
     /*  232315 */     GIR_EraseRootFromParent_Done,
     /*  232316 */   // Label 4566: @232316
     /*  232316 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(232390), // Rule ID 9194 //
     /*  232321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232361 */     // MIs[1] Operand 1
     /*  232361 */     // No operand predicates
     /*  232361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232370 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232388 */     GIR_RootConstrainSelectedInstOperands,
     /*  232389 */     // GIR_Coverage, 9194,
     /*  232389 */     GIR_EraseRootFromParent_Done,
     /*  232390 */   // Label 4567: @232390
     /*  232390 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(232464), // Rule ID 9195 //
     /*  232395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  232409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  232423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232435 */     // MIs[1] Operand 1
     /*  232435 */     // No operand predicates
     /*  232435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232444 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  232447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232462 */     GIR_RootConstrainSelectedInstOperands,
     /*  232463 */     // GIR_Coverage, 9195,
     /*  232463 */     GIR_EraseRootFromParent_Done,
     /*  232464 */   // Label 4568: @232464
     /*  232464 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(232538), // Rule ID 9198 //
     /*  232469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  232483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232509 */     // MIs[1] Operand 1
     /*  232509 */     // No operand predicates
     /*  232509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232536 */     GIR_RootConstrainSelectedInstOperands,
     /*  232537 */     // GIR_Coverage, 9198,
     /*  232537 */     GIR_EraseRootFromParent_Done,
     /*  232538 */   // Label 4569: @232538
     /*  232538 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(232612), // Rule ID 9199 //
     /*  232543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  232557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232583 */     // MIs[1] Operand 1
     /*  232583 */     // No operand predicates
     /*  232583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232592 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232610 */     GIR_RootConstrainSelectedInstOperands,
     /*  232611 */     // GIR_Coverage, 9199,
     /*  232611 */     GIR_EraseRootFromParent_Done,
     /*  232612 */   // Label 4570: @232612
     /*  232612 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(232686), // Rule ID 9202 //
     /*  232617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  232631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232657 */     // MIs[1] Operand 1
     /*  232657 */     // No operand predicates
     /*  232657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232666 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232684 */     GIR_RootConstrainSelectedInstOperands,
     /*  232685 */     // GIR_Coverage, 9202,
     /*  232685 */     GIR_EraseRootFromParent_Done,
     /*  232686 */   // Label 4571: @232686
     /*  232686 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(232760), // Rule ID 9203 //
     /*  232691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  232705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232731 */     // MIs[1] Operand 1
     /*  232731 */     // No operand predicates
     /*  232731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232758 */     GIR_RootConstrainSelectedInstOperands,
     /*  232759 */     // GIR_Coverage, 9203,
     /*  232759 */     GIR_EraseRootFromParent_Done,
     /*  232760 */   // Label 4572: @232760
     /*  232760 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(232834), // Rule ID 9294 //
     /*  232765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  232779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232805 */     // MIs[1] Operand 1
     /*  232805 */     // No operand predicates
     /*  232805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232814 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  232814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  232817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232832 */     GIR_RootConstrainSelectedInstOperands,
     /*  232833 */     // GIR_Coverage, 9294,
     /*  232833 */     GIR_EraseRootFromParent_Done,
     /*  232834 */   // Label 4573: @232834
     /*  232834 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(232908), // Rule ID 9295 //
     /*  232839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  232853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232879 */     // MIs[1] Operand 1
     /*  232879 */     // No operand predicates
     /*  232879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232888 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  232888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  232891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232906 */     GIR_RootConstrainSelectedInstOperands,
     /*  232907 */     // GIR_Coverage, 9295,
     /*  232907 */     GIR_EraseRootFromParent_Done,
     /*  232908 */   // Label 4574: @232908
     /*  232908 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(232982), // Rule ID 9298 //
     /*  232913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  232927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232953 */     // MIs[1] Operand 1
     /*  232953 */     // No operand predicates
     /*  232953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232962 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  232962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  232965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232980 */     GIR_RootConstrainSelectedInstOperands,
     /*  232981 */     // GIR_Coverage, 9298,
     /*  232981 */     GIR_EraseRootFromParent_Done,
     /*  232982 */   // Label 4575: @232982
     /*  232982 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(233056), // Rule ID 9299 //
     /*  232987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  233001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233027 */     // MIs[1] Operand 1
     /*  233027 */     // No operand predicates
     /*  233027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233036 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233054 */     GIR_RootConstrainSelectedInstOperands,
     /*  233055 */     // GIR_Coverage, 9299,
     /*  233055 */     GIR_EraseRootFromParent_Done,
     /*  233056 */   // Label 4576: @233056
     /*  233056 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(233130), // Rule ID 9302 //
     /*  233061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233101 */     // MIs[1] Operand 1
     /*  233101 */     // No operand predicates
     /*  233101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233110 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233128 */     GIR_RootConstrainSelectedInstOperands,
     /*  233129 */     // GIR_Coverage, 9302,
     /*  233129 */     GIR_EraseRootFromParent_Done,
     /*  233130 */   // Label 4577: @233130
     /*  233130 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(233204), // Rule ID 9303 //
     /*  233135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  233149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233175 */     // MIs[1] Operand 1
     /*  233175 */     // No operand predicates
     /*  233175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233202 */     GIR_RootConstrainSelectedInstOperands,
     /*  233203 */     // GIR_Coverage, 9303,
     /*  233203 */     GIR_EraseRootFromParent_Done,
     /*  233204 */   // Label 4578: @233204
     /*  233204 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(233278), // Rule ID 9306 //
     /*  233209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233249 */     // MIs[1] Operand 1
     /*  233249 */     // No operand predicates
     /*  233249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233258 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233276 */     GIR_RootConstrainSelectedInstOperands,
     /*  233277 */     // GIR_Coverage, 9306,
     /*  233277 */     GIR_EraseRootFromParent_Done,
     /*  233278 */   // Label 4579: @233278
     /*  233278 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(233352), // Rule ID 9307 //
     /*  233283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  233297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233323 */     // MIs[1] Operand 1
     /*  233323 */     // No operand predicates
     /*  233323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233332 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  233335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233350 */     GIR_RootConstrainSelectedInstOperands,
     /*  233351 */     // GIR_Coverage, 9307,
     /*  233351 */     GIR_EraseRootFromParent_Done,
     /*  233352 */   // Label 4580: @233352
     /*  233352 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(233426), // Rule ID 9310 //
     /*  233357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233397 */     // MIs[1] Operand 1
     /*  233397 */     // No operand predicates
     /*  233397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233424 */     GIR_RootConstrainSelectedInstOperands,
     /*  233425 */     // GIR_Coverage, 9310,
     /*  233425 */     GIR_EraseRootFromParent_Done,
     /*  233426 */   // Label 4581: @233426
     /*  233426 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(233500), // Rule ID 9311 //
     /*  233431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  233445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233471 */     // MIs[1] Operand 1
     /*  233471 */     // No operand predicates
     /*  233471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233480 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233498 */     GIR_RootConstrainSelectedInstOperands,
     /*  233499 */     // GIR_Coverage, 9311,
     /*  233499 */     GIR_EraseRootFromParent_Done,
     /*  233500 */   // Label 4582: @233500
     /*  233500 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(233574), // Rule ID 9314 //
     /*  233505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  233519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233545 */     // MIs[1] Operand 1
     /*  233545 */     // No operand predicates
     /*  233545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233554 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  233554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233572 */     GIR_RootConstrainSelectedInstOperands,
     /*  233573 */     // GIR_Coverage, 9314,
     /*  233573 */     GIR_EraseRootFromParent_Done,
     /*  233574 */   // Label 4583: @233574
     /*  233574 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(233648), // Rule ID 9315 //
     /*  233579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  233593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233619 */     // MIs[1] Operand 1
     /*  233619 */     // No operand predicates
     /*  233619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233628 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  233628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233646 */     GIR_RootConstrainSelectedInstOperands,
     /*  233647 */     // GIR_Coverage, 9315,
     /*  233647 */     GIR_EraseRootFromParent_Done,
     /*  233648 */   // Label 4584: @233648
     /*  233648 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(233722), // Rule ID 9318 //
     /*  233653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  233667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233693 */     // MIs[1] Operand 1
     /*  233693 */     // No operand predicates
     /*  233693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233720 */     GIR_RootConstrainSelectedInstOperands,
     /*  233721 */     // GIR_Coverage, 9318,
     /*  233721 */     GIR_EraseRootFromParent_Done,
     /*  233722 */   // Label 4585: @233722
     /*  233722 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(233796), // Rule ID 9319 //
     /*  233727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  233741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233767 */     // MIs[1] Operand 1
     /*  233767 */     // No operand predicates
     /*  233767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233776 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233794 */     GIR_RootConstrainSelectedInstOperands,
     /*  233795 */     // GIR_Coverage, 9319,
     /*  233795 */     GIR_EraseRootFromParent_Done,
     /*  233796 */   // Label 4586: @233796
     /*  233796 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(233870), // Rule ID 9322 //
     /*  233801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  233815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233841 */     // MIs[1] Operand 1
     /*  233841 */     // No operand predicates
     /*  233841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233868 */     GIR_RootConstrainSelectedInstOperands,
     /*  233869 */     // GIR_Coverage, 9322,
     /*  233869 */     GIR_EraseRootFromParent_Done,
     /*  233870 */   // Label 4587: @233870
     /*  233870 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(233944), // Rule ID 9323 //
     /*  233875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  233889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233915 */     // MIs[1] Operand 1
     /*  233915 */     // No operand predicates
     /*  233915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233924 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233942 */     GIR_RootConstrainSelectedInstOperands,
     /*  233943 */     // GIR_Coverage, 9323,
     /*  233943 */     GIR_EraseRootFromParent_Done,
     /*  233944 */   // Label 4588: @233944
     /*  233944 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(234018), // Rule ID 9326 //
     /*  233949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  233963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233989 */     // MIs[1] Operand 1
     /*  233989 */     // No operand predicates
     /*  233989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  233998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234016 */     GIR_RootConstrainSelectedInstOperands,
     /*  234017 */     // GIR_Coverage, 9326,
     /*  234017 */     GIR_EraseRootFromParent_Done,
     /*  234018 */   // Label 4589: @234018
     /*  234018 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(234092), // Rule ID 9327 //
     /*  234023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  234034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  234037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234063 */     // MIs[1] Operand 1
     /*  234063 */     // No operand predicates
     /*  234063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234072 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234090 */     GIR_RootConstrainSelectedInstOperands,
     /*  234091 */     // GIR_Coverage, 9327,
     /*  234091 */     GIR_EraseRootFromParent_Done,
     /*  234092 */   // Label 4590: @234092
     /*  234092 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(234166), // Rule ID 9330 //
     /*  234097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  234100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234137 */     // MIs[1] Operand 1
     /*  234137 */     // No operand predicates
     /*  234137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234146 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  234146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234164 */     GIR_RootConstrainSelectedInstOperands,
     /*  234165 */     // GIR_Coverage, 9330,
     /*  234165 */     GIR_EraseRootFromParent_Done,
     /*  234166 */   // Label 4591: @234166
     /*  234166 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(234240), // Rule ID 9331 //
     /*  234171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  234174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  234182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  234185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234211 */     // MIs[1] Operand 1
     /*  234211 */     // No operand predicates
     /*  234211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  234220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  234223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  234238 */     GIR_RootConstrainSelectedInstOperands,
     /*  234239 */     // GIR_Coverage, 9331,
     /*  234239 */     GIR_EraseRootFromParent_Done,
     /*  234240 */   // Label 4592: @234240
     /*  234240 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(234314), // Rule ID 9334 //
     /*  234245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234285 */     // MIs[1] Operand 1
     /*  234285 */     // No operand predicates
     /*  234285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234294 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234312 */     GIR_RootConstrainSelectedInstOperands,
     /*  234313 */     // GIR_Coverage, 9334,
     /*  234313 */     GIR_EraseRootFromParent_Done,
     /*  234314 */   // Label 4593: @234314
     /*  234314 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(234388), // Rule ID 9335 //
     /*  234319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  234333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234359 */     // MIs[1] Operand 1
     /*  234359 */     // No operand predicates
     /*  234359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234368 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234386 */     GIR_RootConstrainSelectedInstOperands,
     /*  234387 */     // GIR_Coverage, 9335,
     /*  234387 */     GIR_EraseRootFromParent_Done,
     /*  234388 */   // Label 4594: @234388
     /*  234388 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(234462), // Rule ID 9338 //
     /*  234393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234433 */     // MIs[1] Operand 1
     /*  234433 */     // No operand predicates
     /*  234433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234442 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234460 */     GIR_RootConstrainSelectedInstOperands,
     /*  234461 */     // GIR_Coverage, 9338,
     /*  234461 */     GIR_EraseRootFromParent_Done,
     /*  234462 */   // Label 4595: @234462
     /*  234462 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(234536), // Rule ID 9339 //
     /*  234467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  234481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234507 */     // MIs[1] Operand 1
     /*  234507 */     // No operand predicates
     /*  234507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234516 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234534 */     GIR_RootConstrainSelectedInstOperands,
     /*  234535 */     // GIR_Coverage, 9339,
     /*  234535 */     GIR_EraseRootFromParent_Done,
     /*  234536 */   // Label 4596: @234536
     /*  234536 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(234610), // Rule ID 9342 //
     /*  234541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  234552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  234555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234581 */     // MIs[1] Operand 1
     /*  234581 */     // No operand predicates
     /*  234581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234590 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  234593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234608 */     GIR_RootConstrainSelectedInstOperands,
     /*  234609 */     // GIR_Coverage, 9342,
     /*  234609 */     GIR_EraseRootFromParent_Done,
     /*  234610 */   // Label 4597: @234610
     /*  234610 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(234684), // Rule ID 9343 //
     /*  234615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  234626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  234629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234655 */     // MIs[1] Operand 1
     /*  234655 */     // No operand predicates
     /*  234655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234664 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  234667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234682 */     GIR_RootConstrainSelectedInstOperands,
     /*  234683 */     // GIR_Coverage, 9343,
     /*  234683 */     GIR_EraseRootFromParent_Done,
     /*  234684 */   // Label 4598: @234684
     /*  234684 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(234758), // Rule ID 9346 //
     /*  234689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  234703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234729 */     // MIs[1] Operand 1
     /*  234729 */     // No operand predicates
     /*  234729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234756 */     GIR_RootConstrainSelectedInstOperands,
     /*  234757 */     // GIR_Coverage, 9346,
     /*  234757 */     GIR_EraseRootFromParent_Done,
     /*  234758 */   // Label 4599: @234758
     /*  234758 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(234832), // Rule ID 9347 //
     /*  234763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  234777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234803 */     // MIs[1] Operand 1
     /*  234803 */     // No operand predicates
     /*  234803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234830 */     GIR_RootConstrainSelectedInstOperands,
     /*  234831 */     // GIR_Coverage, 9347,
     /*  234831 */     GIR_EraseRootFromParent_Done,
     /*  234832 */   // Label 4600: @234832
     /*  234832 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(234906), // Rule ID 9350 //
     /*  234837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  234851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234877 */     // MIs[1] Operand 1
     /*  234877 */     // No operand predicates
     /*  234877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234886 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234904 */     GIR_RootConstrainSelectedInstOperands,
     /*  234905 */     // GIR_Coverage, 9350,
     /*  234905 */     GIR_EraseRootFromParent_Done,
     /*  234906 */   // Label 4601: @234906
     /*  234906 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(234980), // Rule ID 9351 //
     /*  234911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  234925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234951 */     // MIs[1] Operand 1
     /*  234951 */     // No operand predicates
     /*  234951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234960 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234978 */     GIR_RootConstrainSelectedInstOperands,
     /*  234979 */     // GIR_Coverage, 9351,
     /*  234979 */     GIR_EraseRootFromParent_Done,
     /*  234980 */   // Label 4602: @234980
     /*  234980 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(235054), // Rule ID 9354 //
     /*  234985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  234999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235025 */     // MIs[1] Operand 1
     /*  235025 */     // No operand predicates
     /*  235025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235034 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  235034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235052 */     GIR_RootConstrainSelectedInstOperands,
     /*  235053 */     // GIR_Coverage, 9354,
     /*  235053 */     GIR_EraseRootFromParent_Done,
     /*  235054 */   // Label 4603: @235054
     /*  235054 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(235128), // Rule ID 9355 //
     /*  235059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  235070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  235073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235099 */     // MIs[1] Operand 1
     /*  235099 */     // No operand predicates
     /*  235099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235108 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  235108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  235126 */     GIR_RootConstrainSelectedInstOperands,
     /*  235127 */     // GIR_Coverage, 9355,
     /*  235127 */     GIR_EraseRootFromParent_Done,
     /*  235128 */   // Label 4604: @235128
     /*  235128 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(235202), // Rule ID 9358 //
     /*  235133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235173 */     // MIs[1] Operand 1
     /*  235173 */     // No operand predicates
     /*  235173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235182 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235200 */     GIR_RootConstrainSelectedInstOperands,
     /*  235201 */     // GIR_Coverage, 9358,
     /*  235201 */     GIR_EraseRootFromParent_Done,
     /*  235202 */   // Label 4605: @235202
     /*  235202 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(235276), // Rule ID 9359 //
     /*  235207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  235221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235247 */     // MIs[1] Operand 1
     /*  235247 */     // No operand predicates
     /*  235247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235256 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235274 */     GIR_RootConstrainSelectedInstOperands,
     /*  235275 */     // GIR_Coverage, 9359,
     /*  235275 */     GIR_EraseRootFromParent_Done,
     /*  235276 */   // Label 4606: @235276
     /*  235276 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(235350), // Rule ID 9362 //
     /*  235281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235321 */     // MIs[1] Operand 1
     /*  235321 */     // No operand predicates
     /*  235321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235330 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235348 */     GIR_RootConstrainSelectedInstOperands,
     /*  235349 */     // GIR_Coverage, 9362,
     /*  235349 */     GIR_EraseRootFromParent_Done,
     /*  235350 */   // Label 4607: @235350
     /*  235350 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(235424), // Rule ID 9363 //
     /*  235355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  235369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235395 */     // MIs[1] Operand 1
     /*  235395 */     // No operand predicates
     /*  235395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235404 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235422 */     GIR_RootConstrainSelectedInstOperands,
     /*  235423 */     // GIR_Coverage, 9363,
     /*  235423 */     GIR_EraseRootFromParent_Done,
     /*  235424 */   // Label 4608: @235424
     /*  235424 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(235498), // Rule ID 9366 //
     /*  235429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235469 */     // MIs[1] Operand 1
     /*  235469 */     // No operand predicates
     /*  235469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235478 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  235478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235496 */     GIR_RootConstrainSelectedInstOperands,
     /*  235497 */     // GIR_Coverage, 9366,
     /*  235497 */     GIR_EraseRootFromParent_Done,
     /*  235498 */   // Label 4609: @235498
     /*  235498 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(235572), // Rule ID 9367 //
     /*  235503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235543 */     // MIs[1] Operand 1
     /*  235543 */     // No operand predicates
     /*  235543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235552 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235570 */     GIR_RootConstrainSelectedInstOperands,
     /*  235571 */     // GIR_Coverage, 9367,
     /*  235571 */     GIR_EraseRootFromParent_Done,
     /*  235572 */   // Label 4610: @235572
     /*  235572 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(235646), // Rule ID 9370 //
     /*  235577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  235580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  235591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235617 */     // MIs[1] Operand 1
     /*  235617 */     // No operand predicates
     /*  235617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235626 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235644 */     GIR_RootConstrainSelectedInstOperands,
     /*  235645 */     // GIR_Coverage, 9370,
     /*  235645 */     GIR_EraseRootFromParent_Done,
     /*  235646 */   // Label 4611: @235646
     /*  235646 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(235720), // Rule ID 9371 //
     /*  235651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  235654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  235665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235691 */     // MIs[1] Operand 1
     /*  235691 */     // No operand predicates
     /*  235691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235700 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235718 */     GIR_RootConstrainSelectedInstOperands,
     /*  235719 */     // GIR_Coverage, 9371,
     /*  235719 */     GIR_EraseRootFromParent_Done,
     /*  235720 */   // Label 4612: @235720
     /*  235720 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(235794), // Rule ID 9374 //
     /*  235725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  235728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  235739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235765 */     // MIs[1] Operand 1
     /*  235765 */     // No operand predicates
     /*  235765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235774 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235792 */     GIR_RootConstrainSelectedInstOperands,
     /*  235793 */     // GIR_Coverage, 9374,
     /*  235793 */     GIR_EraseRootFromParent_Done,
     /*  235794 */   // Label 4613: @235794
     /*  235794 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(235868), // Rule ID 9375 //
     /*  235799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  235802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  235813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235839 */     // MIs[1] Operand 1
     /*  235839 */     // No operand predicates
     /*  235839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235866 */     GIR_RootConstrainSelectedInstOperands,
     /*  235867 */     // GIR_Coverage, 9375,
     /*  235867 */     GIR_EraseRootFromParent_Done,
     /*  235868 */   // Label 4614: @235868
     /*  235868 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(235942), // Rule ID 9378 //
     /*  235873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  235876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  235887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235913 */     // MIs[1] Operand 1
     /*  235913 */     // No operand predicates
     /*  235913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235922 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235940 */     GIR_RootConstrainSelectedInstOperands,
     /*  235941 */     // GIR_Coverage, 9378,
     /*  235941 */     GIR_EraseRootFromParent_Done,
     /*  235942 */   // Label 4615: @235942
     /*  235942 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(236016), // Rule ID 9379 //
     /*  235947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  235950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  235961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235987 */     // MIs[1] Operand 1
     /*  235987 */     // No operand predicates
     /*  235987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235996 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236014 */     GIR_RootConstrainSelectedInstOperands,
     /*  236015 */     // GIR_Coverage, 9379,
     /*  236015 */     GIR_EraseRootFromParent_Done,
     /*  236016 */   // Label 4616: @236016
     /*  236016 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(236090), // Rule ID 9470 //
     /*  236021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236061 */     // MIs[1] Operand 1
     /*  236061 */     // No operand predicates
     /*  236061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236070 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  236073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236088 */     GIR_RootConstrainSelectedInstOperands,
     /*  236089 */     // GIR_Coverage, 9470,
     /*  236089 */     GIR_EraseRootFromParent_Done,
     /*  236090 */   // Label 4617: @236090
     /*  236090 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(236164), // Rule ID 9471 //
     /*  236095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  236109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236135 */     // MIs[1] Operand 1
     /*  236135 */     // No operand predicates
     /*  236135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236144 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  236147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236162 */     GIR_RootConstrainSelectedInstOperands,
     /*  236163 */     // GIR_Coverage, 9471,
     /*  236163 */     GIR_EraseRootFromParent_Done,
     /*  236164 */   // Label 4618: @236164
     /*  236164 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(236238), // Rule ID 9474 //
     /*  236169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236209 */     // MIs[1] Operand 1
     /*  236209 */     // No operand predicates
     /*  236209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236236 */     GIR_RootConstrainSelectedInstOperands,
     /*  236237 */     // GIR_Coverage, 9474,
     /*  236237 */     GIR_EraseRootFromParent_Done,
     /*  236238 */   // Label 4619: @236238
     /*  236238 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(236312), // Rule ID 9475 //
     /*  236243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  236257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236283 */     // MIs[1] Operand 1
     /*  236283 */     // No operand predicates
     /*  236283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236292 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236310 */     GIR_RootConstrainSelectedInstOperands,
     /*  236311 */     // GIR_Coverage, 9475,
     /*  236311 */     GIR_EraseRootFromParent_Done,
     /*  236312 */   // Label 4620: @236312
     /*  236312 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(236386), // Rule ID 9478 //
     /*  236317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236357 */     // MIs[1] Operand 1
     /*  236357 */     // No operand predicates
     /*  236357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236366 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236384 */     GIR_RootConstrainSelectedInstOperands,
     /*  236385 */     // GIR_Coverage, 9478,
     /*  236385 */     GIR_EraseRootFromParent_Done,
     /*  236386 */   // Label 4621: @236386
     /*  236386 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(236460), // Rule ID 9479 //
     /*  236391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  236405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236431 */     // MIs[1] Operand 1
     /*  236431 */     // No operand predicates
     /*  236431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236458 */     GIR_RootConstrainSelectedInstOperands,
     /*  236459 */     // GIR_Coverage, 9479,
     /*  236459 */     GIR_EraseRootFromParent_Done,
     /*  236460 */   // Label 4622: @236460
     /*  236460 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(236534), // Rule ID 9482 //
     /*  236465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  236479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236505 */     // MIs[1] Operand 1
     /*  236505 */     // No operand predicates
     /*  236505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236514 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236532 */     GIR_RootConstrainSelectedInstOperands,
     /*  236533 */     // GIR_Coverage, 9482,
     /*  236533 */     GIR_EraseRootFromParent_Done,
     /*  236534 */   // Label 4623: @236534
     /*  236534 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(236608), // Rule ID 9483 //
     /*  236539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  236553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236579 */     // MIs[1] Operand 1
     /*  236579 */     // No operand predicates
     /*  236579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236588 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236606 */     GIR_RootConstrainSelectedInstOperands,
     /*  236607 */     // GIR_Coverage, 9483,
     /*  236607 */     GIR_EraseRootFromParent_Done,
     /*  236608 */   // Label 4624: @236608
     /*  236608 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(236682), // Rule ID 9486 //
     /*  236613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  236627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236653 */     // MIs[1] Operand 1
     /*  236653 */     // No operand predicates
     /*  236653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236680 */     GIR_RootConstrainSelectedInstOperands,
     /*  236681 */     // GIR_Coverage, 9486,
     /*  236681 */     GIR_EraseRootFromParent_Done,
     /*  236682 */   // Label 4625: @236682
     /*  236682 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(236756), // Rule ID 9487 //
     /*  236687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  236701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236727 */     // MIs[1] Operand 1
     /*  236727 */     // No operand predicates
     /*  236727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236736 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236754 */     GIR_RootConstrainSelectedInstOperands,
     /*  236755 */     // GIR_Coverage, 9487,
     /*  236755 */     GIR_EraseRootFromParent_Done,
     /*  236756 */   // Label 4626: @236756
     /*  236756 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(236830), // Rule ID 9490 //
     /*  236761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  236775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236801 */     // MIs[1] Operand 1
     /*  236801 */     // No operand predicates
     /*  236801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236810 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  236810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236828 */     GIR_RootConstrainSelectedInstOperands,
     /*  236829 */     // GIR_Coverage, 9490,
     /*  236829 */     GIR_EraseRootFromParent_Done,
     /*  236830 */   // Label 4627: @236830
     /*  236830 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(236904), // Rule ID 9491 //
     /*  236835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  236849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236875 */     // MIs[1] Operand 1
     /*  236875 */     // No operand predicates
     /*  236875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236902 */     GIR_RootConstrainSelectedInstOperands,
     /*  236903 */     // GIR_Coverage, 9491,
     /*  236903 */     GIR_EraseRootFromParent_Done,
     /*  236904 */   // Label 4628: @236904
     /*  236904 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(236978), // Rule ID 9494 //
     /*  236909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  236923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236949 */     // MIs[1] Operand 1
     /*  236949 */     // No operand predicates
     /*  236949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236976 */     GIR_RootConstrainSelectedInstOperands,
     /*  236977 */     // GIR_Coverage, 9494,
     /*  236977 */     GIR_EraseRootFromParent_Done,
     /*  236978 */   // Label 4629: @236978
     /*  236978 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(237052), // Rule ID 9495 //
     /*  236983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  236997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237023 */     // MIs[1] Operand 1
     /*  237023 */     // No operand predicates
     /*  237023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237050 */     GIR_RootConstrainSelectedInstOperands,
     /*  237051 */     // GIR_Coverage, 9495,
     /*  237051 */     GIR_EraseRootFromParent_Done,
     /*  237052 */   // Label 4630: @237052
     /*  237052 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(237126), // Rule ID 9498 //
     /*  237057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237097 */     // MIs[1] Operand 1
     /*  237097 */     // No operand predicates
     /*  237097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237124 */     GIR_RootConstrainSelectedInstOperands,
     /*  237125 */     // GIR_Coverage, 9498,
     /*  237125 */     GIR_EraseRootFromParent_Done,
     /*  237126 */   // Label 4631: @237126
     /*  237126 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(237200), // Rule ID 9499 //
     /*  237131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  237145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237171 */     // MIs[1] Operand 1
     /*  237171 */     // No operand predicates
     /*  237171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237198 */     GIR_RootConstrainSelectedInstOperands,
     /*  237199 */     // GIR_Coverage, 9499,
     /*  237199 */     GIR_EraseRootFromParent_Done,
     /*  237200 */   // Label 4632: @237200
     /*  237200 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(237274), // Rule ID 9502 //
     /*  237205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237245 */     // MIs[1] Operand 1
     /*  237245 */     // No operand predicates
     /*  237245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237254 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237272 */     GIR_RootConstrainSelectedInstOperands,
     /*  237273 */     // GIR_Coverage, 9502,
     /*  237273 */     GIR_EraseRootFromParent_Done,
     /*  237274 */   // Label 4633: @237274
     /*  237274 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(237348), // Rule ID 9503 //
     /*  237279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  237290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  237293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237319 */     // MIs[1] Operand 1
     /*  237319 */     // No operand predicates
     /*  237319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  237328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237346 */     GIR_RootConstrainSelectedInstOperands,
     /*  237347 */     // GIR_Coverage, 9503,
     /*  237347 */     GIR_EraseRootFromParent_Done,
     /*  237348 */   // Label 4634: @237348
     /*  237348 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(237422), // Rule ID 9506 //
     /*  237353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  237356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237393 */     // MIs[1] Operand 1
     /*  237393 */     // No operand predicates
     /*  237393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237402 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  237402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237420 */     GIR_RootConstrainSelectedInstOperands,
     /*  237421 */     // GIR_Coverage, 9506,
     /*  237421 */     GIR_EraseRootFromParent_Done,
     /*  237422 */   // Label 4635: @237422
     /*  237422 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(237496), // Rule ID 9507 //
     /*  237427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  237430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  237438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  237441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237467 */     // MIs[1] Operand 1
     /*  237467 */     // No operand predicates
     /*  237467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237476 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  237476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  237479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  237494 */     GIR_RootConstrainSelectedInstOperands,
     /*  237495 */     // GIR_Coverage, 9507,
     /*  237495 */     GIR_EraseRootFromParent_Done,
     /*  237496 */   // Label 4636: @237496
     /*  237496 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(237570), // Rule ID 9510 //
     /*  237501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  237515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237541 */     // MIs[1] Operand 1
     /*  237541 */     // No operand predicates
     /*  237541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237550 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237568 */     GIR_RootConstrainSelectedInstOperands,
     /*  237569 */     // GIR_Coverage, 9510,
     /*  237569 */     GIR_EraseRootFromParent_Done,
     /*  237570 */   // Label 4637: @237570
     /*  237570 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(237644), // Rule ID 9511 //
     /*  237575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  237589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237615 */     // MIs[1] Operand 1
     /*  237615 */     // No operand predicates
     /*  237615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237624 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237642 */     GIR_RootConstrainSelectedInstOperands,
     /*  237643 */     // GIR_Coverage, 9511,
     /*  237643 */     GIR_EraseRootFromParent_Done,
     /*  237644 */   // Label 4638: @237644
     /*  237644 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(237718), // Rule ID 9514 //
     /*  237649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  237660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  237663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237689 */     // MIs[1] Operand 1
     /*  237689 */     // No operand predicates
     /*  237689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237698 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  237701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237716 */     GIR_RootConstrainSelectedInstOperands,
     /*  237717 */     // GIR_Coverage, 9514,
     /*  237717 */     GIR_EraseRootFromParent_Done,
     /*  237718 */   // Label 4639: @237718
     /*  237718 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(237792), // Rule ID 9515 //
     /*  237723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  237734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  237737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237763 */     // MIs[1] Operand 1
     /*  237763 */     // No operand predicates
     /*  237763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237772 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  237775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237790 */     GIR_RootConstrainSelectedInstOperands,
     /*  237791 */     // GIR_Coverage, 9515,
     /*  237791 */     GIR_EraseRootFromParent_Done,
     /*  237792 */   // Label 4640: @237792
     /*  237792 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(237866), // Rule ID 9518 //
     /*  237797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  237808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  237811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237837 */     // MIs[1] Operand 1
     /*  237837 */     // No operand predicates
     /*  237837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237846 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  237849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237864 */     GIR_RootConstrainSelectedInstOperands,
     /*  237865 */     // GIR_Coverage, 9518,
     /*  237865 */     GIR_EraseRootFromParent_Done,
     /*  237866 */   // Label 4641: @237866
     /*  237866 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(237940), // Rule ID 9519 //
     /*  237871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  237882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  237885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237911 */     // MIs[1] Operand 1
     /*  237911 */     // No operand predicates
     /*  237911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237920 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  237923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237938 */     GIR_RootConstrainSelectedInstOperands,
     /*  237939 */     // GIR_Coverage, 9519,
     /*  237939 */     GIR_EraseRootFromParent_Done,
     /*  237940 */   // Label 4642: @237940
     /*  237940 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(238014), // Rule ID 9522 //
     /*  237945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  237959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237985 */     // MIs[1] Operand 1
     /*  237985 */     // No operand predicates
     /*  237985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237994 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238012 */     GIR_RootConstrainSelectedInstOperands,
     /*  238013 */     // GIR_Coverage, 9522,
     /*  238013 */     GIR_EraseRootFromParent_Done,
     /*  238014 */   // Label 4643: @238014
     /*  238014 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(238088), // Rule ID 9523 //
     /*  238019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  238033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238059 */     // MIs[1] Operand 1
     /*  238059 */     // No operand predicates
     /*  238059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238086 */     GIR_RootConstrainSelectedInstOperands,
     /*  238087 */     // GIR_Coverage, 9523,
     /*  238087 */     GIR_EraseRootFromParent_Done,
     /*  238088 */   // Label 4644: @238088
     /*  238088 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(238162), // Rule ID 9526 //
     /*  238093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238133 */     // MIs[1] Operand 1
     /*  238133 */     // No operand predicates
     /*  238133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238142 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238160 */     GIR_RootConstrainSelectedInstOperands,
     /*  238161 */     // GIR_Coverage, 9526,
     /*  238161 */     GIR_EraseRootFromParent_Done,
     /*  238162 */   // Label 4645: @238162
     /*  238162 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(238236), // Rule ID 9527 //
     /*  238167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  238181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238207 */     // MIs[1] Operand 1
     /*  238207 */     // No operand predicates
     /*  238207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238216 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238234 */     GIR_RootConstrainSelectedInstOperands,
     /*  238235 */     // GIR_Coverage, 9527,
     /*  238235 */     GIR_EraseRootFromParent_Done,
     /*  238236 */   // Label 4646: @238236
     /*  238236 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(238310), // Rule ID 9530 //
     /*  238241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238281 */     // MIs[1] Operand 1
     /*  238281 */     // No operand predicates
     /*  238281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238290 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  238290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238308 */     GIR_RootConstrainSelectedInstOperands,
     /*  238309 */     // GIR_Coverage, 9530,
     /*  238309 */     GIR_EraseRootFromParent_Done,
     /*  238310 */   // Label 4647: @238310
     /*  238310 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(238384), // Rule ID 9531 //
     /*  238315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  238326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  238329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238355 */     // MIs[1] Operand 1
     /*  238355 */     // No operand predicates
     /*  238355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238364 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  238364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  238382 */     GIR_RootConstrainSelectedInstOperands,
     /*  238383 */     // GIR_Coverage, 9531,
     /*  238383 */     GIR_EraseRootFromParent_Done,
     /*  238384 */   // Label 4648: @238384
     /*  238384 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(238458), // Rule ID 9534 //
     /*  238389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238429 */     // MIs[1] Operand 1
     /*  238429 */     // No operand predicates
     /*  238429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238456 */     GIR_RootConstrainSelectedInstOperands,
     /*  238457 */     // GIR_Coverage, 9534,
     /*  238457 */     GIR_EraseRootFromParent_Done,
     /*  238458 */   // Label 4649: @238458
     /*  238458 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(238532), // Rule ID 9535 //
     /*  238463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  238477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238503 */     // MIs[1] Operand 1
     /*  238503 */     // No operand predicates
     /*  238503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238530 */     GIR_RootConstrainSelectedInstOperands,
     /*  238531 */     // GIR_Coverage, 9535,
     /*  238531 */     GIR_EraseRootFromParent_Done,
     /*  238532 */   // Label 4650: @238532
     /*  238532 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(238606), // Rule ID 9538 //
     /*  238537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  238551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238577 */     // MIs[1] Operand 1
     /*  238577 */     // No operand predicates
     /*  238577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238586 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238604 */     GIR_RootConstrainSelectedInstOperands,
     /*  238605 */     // GIR_Coverage, 9538,
     /*  238605 */     GIR_EraseRootFromParent_Done,
     /*  238606 */   // Label 4651: @238606
     /*  238606 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(238680), // Rule ID 9539 //
     /*  238611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  238625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238651 */     // MIs[1] Operand 1
     /*  238651 */     // No operand predicates
     /*  238651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238678 */     GIR_RootConstrainSelectedInstOperands,
     /*  238679 */     // GIR_Coverage, 9539,
     /*  238679 */     GIR_EraseRootFromParent_Done,
     /*  238680 */   // Label 4652: @238680
     /*  238680 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(238754), // Rule ID 9542 //
     /*  238685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  238699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238725 */     // MIs[1] Operand 1
     /*  238725 */     // No operand predicates
     /*  238725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238734 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238752 */     GIR_RootConstrainSelectedInstOperands,
     /*  238753 */     // GIR_Coverage, 9542,
     /*  238753 */     GIR_EraseRootFromParent_Done,
     /*  238754 */   // Label 4653: @238754
     /*  238754 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(238828), // Rule ID 9543 //
     /*  238759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  238773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238799 */     // MIs[1] Operand 1
     /*  238799 */     // No operand predicates
     /*  238799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238808 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238826 */     GIR_RootConstrainSelectedInstOperands,
     /*  238827 */     // GIR_Coverage, 9543,
     /*  238827 */     GIR_EraseRootFromParent_Done,
     /*  238828 */   // Label 4654: @238828
     /*  238828 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(238902), // Rule ID 9546 //
     /*  238833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  238836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  238844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  238847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238873 */     // MIs[1] Operand 1
     /*  238873 */     // No operand predicates
     /*  238873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238882 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  238882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238900 */     GIR_RootConstrainSelectedInstOperands,
     /*  238901 */     // GIR_Coverage, 9546,
     /*  238901 */     GIR_EraseRootFromParent_Done,
     /*  238902 */   // Label 4655: @238902
     /*  238902 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(238976), // Rule ID 9547 //
     /*  238907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  238910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  238918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  238921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238947 */     // MIs[1] Operand 1
     /*  238947 */     // No operand predicates
     /*  238947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238956 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  238956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238974 */     GIR_RootConstrainSelectedInstOperands,
     /*  238975 */     // GIR_Coverage, 9547,
     /*  238975 */     GIR_EraseRootFromParent_Done,
     /*  238976 */   // Label 4656: @238976
     /*  238976 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(239050), // Rule ID 9550 //
     /*  238981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  238984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  238995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239021 */     // MIs[1] Operand 1
     /*  239021 */     // No operand predicates
     /*  239021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239030 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239048 */     GIR_RootConstrainSelectedInstOperands,
     /*  239049 */     // GIR_Coverage, 9550,
     /*  239049 */     GIR_EraseRootFromParent_Done,
     /*  239050 */   // Label 4657: @239050
     /*  239050 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(239124), // Rule ID 9551 //
     /*  239055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  239066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  239069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  239083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239095 */     // MIs[1] Operand 1
     /*  239095 */     // No operand predicates
     /*  239095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  239107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239122 */     GIR_RootConstrainSelectedInstOperands,
     /*  239123 */     // GIR_Coverage, 9551,
     /*  239123 */     GIR_EraseRootFromParent_Done,
     /*  239124 */   // Label 4658: @239124
     /*  239124 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(239198), // Rule ID 9554 //
     /*  239129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  239132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  239146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239169 */     // MIs[1] Operand 1
     /*  239169 */     // No operand predicates
     /*  239169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239178 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  239178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239196 */     GIR_RootConstrainSelectedInstOperands,
     /*  239197 */     // GIR_Coverage, 9554,
     /*  239197 */     GIR_EraseRootFromParent_Done,
     /*  239198 */   // Label 4659: @239198
     /*  239198 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(239272), // Rule ID 9555 //
     /*  239203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  239206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  239211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  239214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  239217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  239220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  239231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  239235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  239239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  239243 */     // MIs[1] Operand 1
     /*  239243 */     // No operand predicates
     /*  239243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  239245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239252 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  239252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  239255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  239262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  239270 */     GIR_RootConstrainSelectedInstOperands,
     /*  239271 */     // GIR_Coverage, 9555,
     /*  239271 */     GIR_EraseRootFromParent_Done,
     /*  239272 */   // Label 4660: @239272
     /*  239272 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(239328), // Rule ID 64445 //
     /*  239277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  239280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bitrev),
     /*  239285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  239288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  239291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239299 */     // MIs[0] pts
     /*  239299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  239302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  239307 */     // MIs[0] radix
     /*  239307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  239310 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm2),
     /*  239315 */     // (intrinsic_wo_chain:{ *:[i32] } 10982:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts)
     /*  239315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /*  239318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239322 */     GIR_RootToRootCopy, /*OpIdx*/4, // radix
     /*  239324 */     GIR_RootToRootCopy, /*OpIdx*/3, // pts
     /*  239326 */     GIR_RootConstrainSelectedInstOperands,
     /*  239327 */     // GIR_Coverage, 64445,
     /*  239327 */     GIR_EraseRootFromParent_Done,
     /*  239328 */   // Label 4661: @239328
     /*  239328 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(239391), // Rule ID 2684 //
     /*  239333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  239336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  239341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  239344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  239365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239372 */     // (intrinsic_wo_chain:{ *:[i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  239372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  239375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239379 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  239381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239389 */     GIR_RootConstrainSelectedInstOperands,
     /*  239390 */     // GIR_Coverage, 2684,
     /*  239390 */     GIR_EraseRootFromParent_Done,
     /*  239391 */   // Label 4662: @239391
     /*  239391 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(239454), // Rule ID 2685 //
     /*  239396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  239399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  239404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  239407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  239420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  239428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239435 */     // (intrinsic_wo_chain:{ *:[i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  239435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  239438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239442 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  239444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239452 */     GIR_RootConstrainSelectedInstOperands,
     /*  239453 */     // GIR_Coverage, 2685,
     /*  239453 */     GIR_EraseRootFromParent_Done,
     /*  239454 */   // Label 4663: @239454
     /*  239454 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(239520), // Rule ID 2692 //
     /*  239459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  239467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  239470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239498 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  239498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  239501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239518 */     GIR_RootConstrainSelectedInstOperands,
     /*  239519 */     // GIR_Coverage, 2692,
     /*  239519 */     GIR_EraseRootFromParent_Done,
     /*  239520 */   // Label 4664: @239520
     /*  239520 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(239586), // Rule ID 2693 //
     /*  239525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  239533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  239536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  239564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  239567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239584 */     GIR_RootConstrainSelectedInstOperands,
     /*  239585 */     // GIR_Coverage, 2693,
     /*  239585 */     GIR_EraseRootFromParent_Done,
     /*  239586 */   // Label 4665: @239586
     /*  239586 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(239652), // Rule ID 2696 //
     /*  239591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  239599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  239630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  239633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239650 */     GIR_RootConstrainSelectedInstOperands,
     /*  239651 */     // GIR_Coverage, 2696,
     /*  239651 */     GIR_EraseRootFromParent_Done,
     /*  239652 */   // Label 4666: @239652
     /*  239652 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(239718), // Rule ID 2697 //
     /*  239657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  239665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  239696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  239699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239716 */     GIR_RootConstrainSelectedInstOperands,
     /*  239717 */     // GIR_Coverage, 2697,
     /*  239717 */     GIR_EraseRootFromParent_Done,
     /*  239718 */   // Label 4667: @239718
     /*  239718 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(239784), // Rule ID 2700 //
     /*  239723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  239726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  239731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239762 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  239762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  239765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239782 */     GIR_RootConstrainSelectedInstOperands,
     /*  239783 */     // GIR_Coverage, 2700,
     /*  239783 */     GIR_EraseRootFromParent_Done,
     /*  239784 */   // Label 4668: @239784
     /*  239784 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(239850), // Rule ID 2701 //
     /*  239789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  239792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  239797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239828 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  239828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  239831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239848 */     GIR_RootConstrainSelectedInstOperands,
     /*  239849 */     // GIR_Coverage, 2701,
     /*  239849 */     GIR_EraseRootFromParent_Done,
     /*  239850 */   // Label 4669: @239850
     /*  239850 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(239913), // Rule ID 2714 //
     /*  239855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  239863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239894 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  239894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  239897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239911 */     GIR_RootConstrainSelectedInstOperands,
     /*  239912 */     // GIR_Coverage, 2714,
     /*  239912 */     GIR_EraseRootFromParent_Done,
     /*  239913 */   // Label 4670: @239913
     /*  239913 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(239976), // Rule ID 2715 //
     /*  239918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  239926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239957 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  239957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  239960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239974 */     GIR_RootConstrainSelectedInstOperands,
     /*  239975 */     // GIR_Coverage, 2715,
     /*  239975 */     GIR_EraseRootFromParent_Done,
     /*  239976 */   // Label 4671: @239976
     /*  239976 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(240039), // Rule ID 2726 //
     /*  239981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240020 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  240023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240037 */     GIR_RootConstrainSelectedInstOperands,
     /*  240038 */     // GIR_Coverage, 2726,
     /*  240038 */     GIR_EraseRootFromParent_Done,
     /*  240039 */   // Label 4672: @240039
     /*  240039 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(240102), // Rule ID 2727 //
     /*  240044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  240052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240083 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  240086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  240090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  240092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240100 */     GIR_RootConstrainSelectedInstOperands,
     /*  240101 */     // GIR_Coverage, 2727,
     /*  240101 */     GIR_EraseRootFromParent_Done,
     /*  240102 */   // Label 4673: @240102
     /*  240102 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(240165), // Rule ID 2734 //
     /*  240107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  240115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240146 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  240146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  240149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240163 */     GIR_RootConstrainSelectedInstOperands,
     /*  240164 */     // GIR_Coverage, 2734,
     /*  240164 */     GIR_EraseRootFromParent_Done,
     /*  240165 */   // Label 4674: @240165
     /*  240165 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(240228), // Rule ID 2735 //
     /*  240170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  240178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  240184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  240187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240209 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  240209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  240212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  240226 */     GIR_RootConstrainSelectedInstOperands,
     /*  240227 */     // GIR_Coverage, 2735,
     /*  240227 */     GIR_EraseRootFromParent_Done,
     /*  240228 */   // Label 4675: @240228
     /*  240228 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(240294), // Rule ID 2736 //
     /*  240233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  240236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  240241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240272 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  240275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240292 */     GIR_RootConstrainSelectedInstOperands,
     /*  240293 */     // GIR_Coverage, 2736,
     /*  240293 */     GIR_EraseRootFromParent_Done,
     /*  240294 */   // Label 4676: @240294
     /*  240294 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(240360), // Rule ID 2737 //
     /*  240299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  240302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  240307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  240310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  240313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240338 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  240341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240358 */     GIR_RootConstrainSelectedInstOperands,
     /*  240359 */     // GIR_Coverage, 2737,
     /*  240359 */     GIR_EraseRootFromParent_Done,
     /*  240360 */   // Label 4677: @240360
     /*  240360 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(240423), // Rule ID 2748 //
     /*  240365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  240373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  240379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240404 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  240404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  240407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240421 */     GIR_RootConstrainSelectedInstOperands,
     /*  240422 */     // GIR_Coverage, 2748,
     /*  240422 */     GIR_EraseRootFromParent_Done,
     /*  240423 */   // Label 4678: @240423
     /*  240423 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(240486), // Rule ID 2749 //
     /*  240428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  240436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  240439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  240442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  240445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240467 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  240467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  240470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  240474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240484 */     GIR_RootConstrainSelectedInstOperands,
     /*  240485 */     // GIR_Coverage, 2749,
     /*  240485 */     GIR_EraseRootFromParent_Done,
     /*  240486 */   // Label 4679: @240486
     /*  240486 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(240552), // Rule ID 4896 //
     /*  240491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  240502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  240508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  240533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240550 */     GIR_RootConstrainSelectedInstOperands,
     /*  240551 */     // GIR_Coverage, 4896,
     /*  240551 */     GIR_EraseRootFromParent_Done,
     /*  240552 */   // Label 4680: @240552
     /*  240552 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(240618), // Rule ID 4897 //
     /*  240557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  240568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  240574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240596 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  240599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240616 */     GIR_RootConstrainSelectedInstOperands,
     /*  240617 */     // GIR_Coverage, 4897,
     /*  240617 */     GIR_EraseRootFromParent_Done,
     /*  240618 */   // Label 4681: @240618
     /*  240618 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(240684), // Rule ID 4900 //
     /*  240623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  240634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  240640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240662 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  240665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240682 */     GIR_RootConstrainSelectedInstOperands,
     /*  240683 */     // GIR_Coverage, 4900,
     /*  240683 */     GIR_EraseRootFromParent_Done,
     /*  240684 */   // Label 4682: @240684
     /*  240684 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(240750), // Rule ID 4901 //
     /*  240689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  240700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  240706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240728 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11677:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  240731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240748 */     GIR_RootConstrainSelectedInstOperands,
     /*  240749 */     // GIR_Coverage, 4901,
     /*  240749 */     GIR_EraseRootFromParent_Done,
     /*  240750 */   // Label 4683: @240750
     /*  240750 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(240816), // Rule ID 4904 //
     /*  240755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  240766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  240769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  240772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  240797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240814 */     GIR_RootConstrainSelectedInstOperands,
     /*  240815 */     // GIR_Coverage, 4904,
     /*  240815 */     GIR_EraseRootFromParent_Done,
     /*  240816 */   // Label 4684: @240816
     /*  240816 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(240882), // Rule ID 4905 //
     /*  240821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  240832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  240835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  240838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  240863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240880 */     GIR_RootConstrainSelectedInstOperands,
     /*  240881 */     // GIR_Coverage, 4905,
     /*  240881 */     GIR_EraseRootFromParent_Done,
     /*  240882 */   // Label 4685: @240882
     /*  240882 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(240948), // Rule ID 4908 //
     /*  240887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  240898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  240901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  240904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  240929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240946 */     GIR_RootConstrainSelectedInstOperands,
     /*  240947 */     // GIR_Coverage, 4908,
     /*  240947 */     GIR_EraseRootFromParent_Done,
     /*  240948 */   // Label 4686: @240948
     /*  240948 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(241014), // Rule ID 4909 //
     /*  240953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  240964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  240967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  240970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  240995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241012 */     GIR_RootConstrainSelectedInstOperands,
     /*  241013 */     // GIR_Coverage, 4909,
     /*  241013 */     GIR_EraseRootFromParent_Done,
     /*  241014 */   // Label 4687: @241014
     /*  241014 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(241080), // Rule ID 4912 //
     /*  241019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  241030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  241033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  241036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241058 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  241058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241078 */     GIR_RootConstrainSelectedInstOperands,
     /*  241079 */     // GIR_Coverage, 4912,
     /*  241079 */     GIR_EraseRootFromParent_Done,
     /*  241080 */   // Label 4688: @241080
     /*  241080 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(241146), // Rule ID 4913 //
     /*  241085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  241096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  241099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  241102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241124 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  241124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  241141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241144 */     GIR_RootConstrainSelectedInstOperands,
     /*  241145 */     // GIR_Coverage, 4913,
     /*  241145 */     GIR_EraseRootFromParent_Done,
     /*  241146 */   // Label 4689: @241146
     /*  241146 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(241212), // Rule ID 4916 //
     /*  241151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241210 */     GIR_RootConstrainSelectedInstOperands,
     /*  241211 */     // GIR_Coverage, 4916,
     /*  241211 */     GIR_EraseRootFromParent_Done,
     /*  241212 */   // Label 4690: @241212
     /*  241212 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(241278), // Rule ID 4917 //
     /*  241217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  241234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  241259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241276 */     GIR_RootConstrainSelectedInstOperands,
     /*  241277 */     // GIR_Coverage, 4917,
     /*  241277 */     GIR_EraseRootFromParent_Done,
     /*  241278 */   // Label 4691: @241278
     /*  241278 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(241344), // Rule ID 4920 //
     /*  241283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  241294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241342 */     GIR_RootConstrainSelectedInstOperands,
     /*  241343 */     // GIR_Coverage, 4920,
     /*  241343 */     GIR_EraseRootFromParent_Done,
     /*  241344 */   // Label 4692: @241344
     /*  241344 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(241410), // Rule ID 4921 //
     /*  241349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  241360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  241366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241388 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241408 */     GIR_RootConstrainSelectedInstOperands,
     /*  241409 */     // GIR_Coverage, 4921,
     /*  241409 */     GIR_EraseRootFromParent_Done,
     /*  241410 */   // Label 4693: @241410
     /*  241410 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(241476), // Rule ID 4924 //
     /*  241415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  241426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  241429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241474 */     GIR_RootConstrainSelectedInstOperands,
     /*  241475 */     // GIR_Coverage, 4924,
     /*  241475 */     GIR_EraseRootFromParent_Done,
     /*  241476 */   // Label 4694: @241476
     /*  241476 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(241542), // Rule ID 4925 //
     /*  241481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  241492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  241495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  241498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241540 */     GIR_RootConstrainSelectedInstOperands,
     /*  241541 */     // GIR_Coverage, 4925,
     /*  241541 */     GIR_EraseRootFromParent_Done,
     /*  241542 */   // Label 4695: @241542
     /*  241542 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(241608), // Rule ID 4928 //
     /*  241547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  241558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  241561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  241564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241606 */     GIR_RootConstrainSelectedInstOperands,
     /*  241607 */     // GIR_Coverage, 4928,
     /*  241607 */     GIR_EraseRootFromParent_Done,
     /*  241608 */   // Label 4696: @241608
     /*  241608 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(241674), // Rule ID 4929 //
     /*  241613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  241624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  241627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  241630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241652 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241672 */     GIR_RootConstrainSelectedInstOperands,
     /*  241673 */     // GIR_Coverage, 4929,
     /*  241673 */     GIR_EraseRootFromParent_Done,
     /*  241674 */   // Label 4697: @241674
     /*  241674 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(241740), // Rule ID 4932 //
     /*  241679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  241690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  241693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  241696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241738 */     GIR_RootConstrainSelectedInstOperands,
     /*  241739 */     // GIR_Coverage, 4932,
     /*  241739 */     GIR_EraseRootFromParent_Done,
     /*  241740 */   // Label 4698: @241740
     /*  241740 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(241806), // Rule ID 4933 //
     /*  241745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  241756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  241759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  241762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241784 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241804 */     GIR_RootConstrainSelectedInstOperands,
     /*  241805 */     // GIR_Coverage, 4933,
     /*  241805 */     GIR_EraseRootFromParent_Done,
     /*  241806 */   // Label 4699: @241806
     /*  241806 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(241872), // Rule ID 4936 //
     /*  241811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  241814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  241822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  241828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241850 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  241850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241870 */     GIR_RootConstrainSelectedInstOperands,
     /*  241871 */     // GIR_Coverage, 4936,
     /*  241871 */     GIR_EraseRootFromParent_Done,
     /*  241872 */   // Label 4700: @241872
     /*  241872 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(241938), // Rule ID 4937 //
     /*  241877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  241880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  241888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  241894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  241916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241936 */     GIR_RootConstrainSelectedInstOperands,
     /*  241937 */     // GIR_Coverage, 4937,
     /*  241937 */     GIR_EraseRootFromParent_Done,
     /*  241938 */   // Label 4701: @241938
     /*  241938 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(242004), // Rule ID 4940 //
     /*  241943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  241946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  241954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  241957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  241960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  241982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242002 */     GIR_RootConstrainSelectedInstOperands,
     /*  242003 */     // GIR_Coverage, 4940,
     /*  242003 */     GIR_EraseRootFromParent_Done,
     /*  242004 */   // Label 4702: @242004
     /*  242004 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(242070), // Rule ID 4941 //
     /*  242009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  242020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  242026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  242051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242068 */     GIR_RootConstrainSelectedInstOperands,
     /*  242069 */     // GIR_Coverage, 4941,
     /*  242069 */     GIR_EraseRootFromParent_Done,
     /*  242070 */   // Label 4703: @242070
     /*  242070 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(242136), // Rule ID 4944 //
     /*  242075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242114 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242134 */     GIR_RootConstrainSelectedInstOperands,
     /*  242135 */     // GIR_Coverage, 4944,
     /*  242135 */     GIR_EraseRootFromParent_Done,
     /*  242136 */   // Label 4704: @242136
     /*  242136 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(242202), // Rule ID 4945 //
     /*  242141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  242158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242180 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  242183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242200 */     GIR_RootConstrainSelectedInstOperands,
     /*  242201 */     // GIR_Coverage, 4945,
     /*  242201 */     GIR_EraseRootFromParent_Done,
     /*  242202 */   // Label 4705: @242202
     /*  242202 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(242268), // Rule ID 4948 //
     /*  242207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242266 */     GIR_RootConstrainSelectedInstOperands,
     /*  242267 */     // GIR_Coverage, 4948,
     /*  242267 */     GIR_EraseRootFromParent_Done,
     /*  242268 */   // Label 4706: @242268
     /*  242268 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(242334), // Rule ID 4949 //
     /*  242273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  242290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  242315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242332 */     GIR_RootConstrainSelectedInstOperands,
     /*  242333 */     // GIR_Coverage, 4949,
     /*  242333 */     GIR_EraseRootFromParent_Done,
     /*  242334 */   // Label 4707: @242334
     /*  242334 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(242400), // Rule ID 4952 //
     /*  242339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  242350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  242353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  242356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  242381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242398 */     GIR_RootConstrainSelectedInstOperands,
     /*  242399 */     // GIR_Coverage, 4952,
     /*  242399 */     GIR_EraseRootFromParent_Done,
     /*  242400 */   // Label 4708: @242400
     /*  242400 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(242466), // Rule ID 4953 //
     /*  242405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  242416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  242419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  242422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  242447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242464 */     GIR_RootConstrainSelectedInstOperands,
     /*  242465 */     // GIR_Coverage, 4953,
     /*  242465 */     GIR_EraseRootFromParent_Done,
     /*  242466 */   // Label 4709: @242466
     /*  242466 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(242532), // Rule ID 4956 //
     /*  242471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  242482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  242485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  242488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242530 */     GIR_RootConstrainSelectedInstOperands,
     /*  242531 */     // GIR_Coverage, 4956,
     /*  242531 */     GIR_EraseRootFromParent_Done,
     /*  242532 */   // Label 4710: @242532
     /*  242532 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(242598), // Rule ID 4957 //
     /*  242537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  242548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  242551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  242554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11677:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242596 */     GIR_RootConstrainSelectedInstOperands,
     /*  242597 */     // GIR_Coverage, 4957,
     /*  242597 */     GIR_EraseRootFromParent_Done,
     /*  242598 */   // Label 4711: @242598
     /*  242598 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(242664), // Rule ID 4960 //
     /*  242603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  242614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  242620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  242645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242662 */     GIR_RootConstrainSelectedInstOperands,
     /*  242663 */     // GIR_Coverage, 4960,
     /*  242663 */     GIR_EraseRootFromParent_Done,
     /*  242664 */   // Label 4712: @242664
     /*  242664 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(242730), // Rule ID 4961 //
     /*  242669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  242680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  242686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  242711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242728 */     GIR_RootConstrainSelectedInstOperands,
     /*  242729 */     // GIR_Coverage, 4961,
     /*  242729 */     GIR_EraseRootFromParent_Done,
     /*  242730 */   // Label 4713: @242730
     /*  242730 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(242796), // Rule ID 4964 //
     /*  242735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  242752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  242777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242794 */     GIR_RootConstrainSelectedInstOperands,
     /*  242795 */     // GIR_Coverage, 4964,
     /*  242795 */     GIR_EraseRootFromParent_Done,
     /*  242796 */   // Label 4714: @242796
     /*  242796 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(242862), // Rule ID 4965 //
     /*  242801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  242818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  242843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242860 */     GIR_RootConstrainSelectedInstOperands,
     /*  242861 */     // GIR_Coverage, 4965,
     /*  242861 */     GIR_EraseRootFromParent_Done,
     /*  242862 */   // Label 4715: @242862
     /*  242862 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(242928), // Rule ID 4968 //
     /*  242867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  242884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  242909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242926 */     GIR_RootConstrainSelectedInstOperands,
     /*  242927 */     // GIR_Coverage, 4968,
     /*  242927 */     GIR_EraseRootFromParent_Done,
     /*  242928 */   // Label 4716: @242928
     /*  242928 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(242994), // Rule ID 4969 //
     /*  242933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  242950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  242975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242992 */     GIR_RootConstrainSelectedInstOperands,
     /*  242993 */     // GIR_Coverage, 4969,
     /*  242993 */     GIR_EraseRootFromParent_Done,
     /*  242994 */   // Label 4717: @242994
     /*  242994 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(243060), // Rule ID 4972 //
     /*  242999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243058 */     GIR_RootConstrainSelectedInstOperands,
     /*  243059 */     // GIR_Coverage, 4972,
     /*  243059 */     GIR_EraseRootFromParent_Done,
     /*  243060 */   // Label 4718: @243060
     /*  243060 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(243126), // Rule ID 4973 //
     /*  243065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  243082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  243107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243124 */     GIR_RootConstrainSelectedInstOperands,
     /*  243125 */     // GIR_Coverage, 4973,
     /*  243125 */     GIR_EraseRootFromParent_Done,
     /*  243126 */   // Label 4719: @243126
     /*  243126 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(243192), // Rule ID 4976 //
     /*  243131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243190 */     GIR_RootConstrainSelectedInstOperands,
     /*  243191 */     // GIR_Coverage, 4976,
     /*  243191 */     GIR_EraseRootFromParent_Done,
     /*  243192 */   // Label 4720: @243192
     /*  243192 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(243258), // Rule ID 4977 //
     /*  243197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  243214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243236 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  243239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243256 */     GIR_RootConstrainSelectedInstOperands,
     /*  243257 */     // GIR_Coverage, 4977,
     /*  243257 */     GIR_EraseRootFromParent_Done,
     /*  243258 */   // Label 4721: @243258
     /*  243258 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(243324), // Rule ID 4980 //
     /*  243263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243322 */     GIR_RootConstrainSelectedInstOperands,
     /*  243323 */     // GIR_Coverage, 4980,
     /*  243323 */     GIR_EraseRootFromParent_Done,
     /*  243324 */   // Label 4722: @243324
     /*  243324 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(243390), // Rule ID 4981 //
     /*  243329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  243346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  243371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243388 */     GIR_RootConstrainSelectedInstOperands,
     /*  243389 */     // GIR_Coverage, 4981,
     /*  243389 */     GIR_EraseRootFromParent_Done,
     /*  243390 */   // Label 4723: @243390
     /*  243390 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(243456), // Rule ID 4984 //
     /*  243395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  243412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243454 */     GIR_RootConstrainSelectedInstOperands,
     /*  243455 */     // GIR_Coverage, 4984,
     /*  243455 */     GIR_EraseRootFromParent_Done,
     /*  243456 */   // Label 4724: @243456
     /*  243456 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(243522), // Rule ID 4985 //
     /*  243461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  243478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  243503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243520 */     GIR_RootConstrainSelectedInstOperands,
     /*  243521 */     // GIR_Coverage, 4985,
     /*  243521 */     GIR_EraseRootFromParent_Done,
     /*  243522 */   // Label 4725: @243522
     /*  243522 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(243588), // Rule ID 4988 //
     /*  243527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  243569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243586 */     GIR_RootConstrainSelectedInstOperands,
     /*  243587 */     // GIR_Coverage, 4988,
     /*  243587 */     GIR_EraseRootFromParent_Done,
     /*  243588 */   // Label 4726: @243588
     /*  243588 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(243654), // Rule ID 4989 //
     /*  243593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11677:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  243635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243652 */     GIR_RootConstrainSelectedInstOperands,
     /*  243653 */     // GIR_Coverage, 4989,
     /*  243653 */     GIR_EraseRootFromParent_Done,
     /*  243654 */   // Label 4727: @243654
     /*  243654 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(243720), // Rule ID 4992 //
     /*  243659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  243701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243718 */     GIR_RootConstrainSelectedInstOperands,
     /*  243719 */     // GIR_Coverage, 4992,
     /*  243719 */     GIR_EraseRootFromParent_Done,
     /*  243720 */   // Label 4728: @243720
     /*  243720 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(243786), // Rule ID 4993 //
     /*  243725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11677:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  243767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243784 */     GIR_RootConstrainSelectedInstOperands,
     /*  243785 */     // GIR_Coverage, 4993,
     /*  243785 */     GIR_EraseRootFromParent_Done,
     /*  243786 */   // Label 4729: @243786
     /*  243786 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(243852), // Rule ID 4996 //
     /*  243791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243830 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  243833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243850 */     GIR_RootConstrainSelectedInstOperands,
     /*  243851 */     // GIR_Coverage, 4996,
     /*  243851 */     GIR_EraseRootFromParent_Done,
     /*  243852 */   // Label 4730: @243852
     /*  243852 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(243918), // Rule ID 4997 //
     /*  243857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243896 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11677:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  243899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243916 */     GIR_RootConstrainSelectedInstOperands,
     /*  243917 */     // GIR_Coverage, 4997,
     /*  243917 */     GIR_EraseRootFromParent_Done,
     /*  243918 */   // Label 4731: @243918
     /*  243918 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(243984), // Rule ID 5000 //
     /*  243923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  243940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243962 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  243965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243982 */     GIR_RootConstrainSelectedInstOperands,
     /*  243983 */     // GIR_Coverage, 5000,
     /*  243983 */     GIR_EraseRootFromParent_Done,
     /*  243984 */   // Label 4732: @243984
     /*  243984 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(244050), // Rule ID 5001 //
     /*  243989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  244000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  244003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11677:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  244028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  244031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  244045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244048 */     GIR_RootConstrainSelectedInstOperands,
     /*  244049 */     // GIR_Coverage, 5001,
     /*  244049 */     GIR_EraseRootFromParent_Done,
     /*  244050 */   // Label 4733: @244050
     /*  244050 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(244116), // Rule ID 5004 //
     /*  244055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  244097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244114 */     GIR_RootConstrainSelectedInstOperands,
     /*  244115 */     // GIR_Coverage, 5004,
     /*  244115 */     GIR_EraseRootFromParent_Done,
     /*  244116 */   // Label 4734: @244116
     /*  244116 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(244182), // Rule ID 5005 //
     /*  244121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  244132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  244135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  244138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244160 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  244163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244180 */     GIR_RootConstrainSelectedInstOperands,
     /*  244181 */     // GIR_Coverage, 5005,
     /*  244181 */     GIR_EraseRootFromParent_Done,
     /*  244182 */   // Label 4735: @244182
     /*  244182 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(244248), // Rule ID 5008 //
     /*  244187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244246 */     GIR_RootConstrainSelectedInstOperands,
     /*  244247 */     // GIR_Coverage, 5008,
     /*  244247 */     GIR_EraseRootFromParent_Done,
     /*  244248 */   // Label 4736: @244248
     /*  244248 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(244314), // Rule ID 5009 //
     /*  244253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  244264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  244267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  244270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244292 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244312 */     GIR_RootConstrainSelectedInstOperands,
     /*  244313 */     // GIR_Coverage, 5009,
     /*  244313 */     GIR_EraseRootFromParent_Done,
     /*  244314 */   // Label 4737: @244314
     /*  244314 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(244380), // Rule ID 5012 //
     /*  244319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244358 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244378 */     GIR_RootConstrainSelectedInstOperands,
     /*  244379 */     // GIR_Coverage, 5012,
     /*  244379 */     GIR_EraseRootFromParent_Done,
     /*  244380 */   // Label 4738: @244380
     /*  244380 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(244446), // Rule ID 5013 //
     /*  244385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  244396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  244399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  244402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244424 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11540:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244444 */     GIR_RootConstrainSelectedInstOperands,
     /*  244445 */     // GIR_Coverage, 5013,
     /*  244445 */     GIR_EraseRootFromParent_Done,
     /*  244446 */   // Label 4739: @244446
     /*  244446 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(244512), // Rule ID 5016 //
     /*  244451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  244493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244510 */     GIR_RootConstrainSelectedInstOperands,
     /*  244511 */     // GIR_Coverage, 5016,
     /*  244511 */     GIR_EraseRootFromParent_Done,
     /*  244512 */   // Label 4740: @244512
     /*  244512 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(244578), // Rule ID 5017 //
     /*  244517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  244559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244576 */     GIR_RootConstrainSelectedInstOperands,
     /*  244577 */     // GIR_Coverage, 5017,
     /*  244577 */     GIR_EraseRootFromParent_Done,
     /*  244578 */   // Label 4741: @244578
     /*  244578 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(244644), // Rule ID 5020 //
     /*  244583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244622 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  244625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244642 */     GIR_RootConstrainSelectedInstOperands,
     /*  244643 */     // GIR_Coverage, 5020,
     /*  244643 */     GIR_EraseRootFromParent_Done,
     /*  244644 */   // Label 4742: @244644
     /*  244644 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(244710), // Rule ID 5021 //
     /*  244649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  244691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244708 */     GIR_RootConstrainSelectedInstOperands,
     /*  244709 */     // GIR_Coverage, 5021,
     /*  244709 */     GIR_EraseRootFromParent_Done,
     /*  244710 */   // Label 4743: @244710
     /*  244710 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(244776), // Rule ID 5024 //
     /*  244715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244754 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  244757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244774 */     GIR_RootConstrainSelectedInstOperands,
     /*  244775 */     // GIR_Coverage, 5024,
     /*  244775 */     GIR_EraseRootFromParent_Done,
     /*  244776 */   // Label 4744: @244776
     /*  244776 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(244842), // Rule ID 5025 //
     /*  244781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244820 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  244823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244840 */     GIR_RootConstrainSelectedInstOperands,
     /*  244841 */     // GIR_Coverage, 5025,
     /*  244841 */     GIR_EraseRootFromParent_Done,
     /*  244842 */   // Label 4745: @244842
     /*  244842 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(244908), // Rule ID 5028 //
     /*  244847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  244858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  244861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244906 */     GIR_RootConstrainSelectedInstOperands,
     /*  244907 */     // GIR_Coverage, 5028,
     /*  244907 */     GIR_EraseRootFromParent_Done,
     /*  244908 */   // Label 4746: @244908
     /*  244908 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(244974), // Rule ID 5029 //
     /*  244913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  244924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  244927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244972 */     GIR_RootConstrainSelectedInstOperands,
     /*  244973 */     // GIR_Coverage, 5029,
     /*  244973 */     GIR_EraseRootFromParent_Done,
     /*  244974 */   // Label 4747: @244974
     /*  244974 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(245040), // Rule ID 5032 //
     /*  244979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  244990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  244993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  244996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245038 */     GIR_RootConstrainSelectedInstOperands,
     /*  245039 */     // GIR_Coverage, 5032,
     /*  245039 */     GIR_EraseRootFromParent_Done,
     /*  245040 */   // Label 4748: @245040
     /*  245040 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(245106), // Rule ID 5033 //
     /*  245045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  245062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245104 */     GIR_RootConstrainSelectedInstOperands,
     /*  245105 */     // GIR_Coverage, 5033,
     /*  245105 */     GIR_EraseRootFromParent_Done,
     /*  245106 */   // Label 4749: @245106
     /*  245106 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(245172), // Rule ID 5036 //
     /*  245111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245170 */     GIR_RootConstrainSelectedInstOperands,
     /*  245171 */     // GIR_Coverage, 5036,
     /*  245171 */     GIR_EraseRootFromParent_Done,
     /*  245172 */   // Label 4750: @245172
     /*  245172 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(245238), // Rule ID 5037 //
     /*  245177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  245194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245236 */     GIR_RootConstrainSelectedInstOperands,
     /*  245237 */     // GIR_Coverage, 5037,
     /*  245237 */     GIR_EraseRootFromParent_Done,
     /*  245238 */   // Label 4751: @245238
     /*  245238 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(245304), // Rule ID 5040 //
     /*  245243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245302 */     GIR_RootConstrainSelectedInstOperands,
     /*  245303 */     // GIR_Coverage, 5040,
     /*  245303 */     GIR_EraseRootFromParent_Done,
     /*  245304 */   // Label 4752: @245304
     /*  245304 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(245370), // Rule ID 5041 //
     /*  245309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  245326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245368 */     GIR_RootConstrainSelectedInstOperands,
     /*  245369 */     // GIR_Coverage, 5041,
     /*  245369 */     GIR_EraseRootFromParent_Done,
     /*  245370 */   // Label 4753: @245370
     /*  245370 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(245436), // Rule ID 5044 //
     /*  245375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245434 */     GIR_RootConstrainSelectedInstOperands,
     /*  245435 */     // GIR_Coverage, 5044,
     /*  245435 */     GIR_EraseRootFromParent_Done,
     /*  245436 */   // Label 4754: @245436
     /*  245436 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(245502), // Rule ID 5045 //
     /*  245441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  245452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  245455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  245458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245500 */     GIR_RootConstrainSelectedInstOperands,
     /*  245501 */     // GIR_Coverage, 5045,
     /*  245501 */     GIR_EraseRootFromParent_Done,
     /*  245502 */   // Label 4755: @245502
     /*  245502 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(245568), // Rule ID 5048 //
     /*  245507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245546 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245566 */     GIR_RootConstrainSelectedInstOperands,
     /*  245567 */     // GIR_Coverage, 5048,
     /*  245567 */     GIR_EraseRootFromParent_Done,
     /*  245568 */   // Label 4756: @245568
     /*  245568 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(245634), // Rule ID 5049 //
     /*  245573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245612 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245632 */     GIR_RootConstrainSelectedInstOperands,
     /*  245633 */     // GIR_Coverage, 5049,
     /*  245633 */     GIR_EraseRootFromParent_Done,
     /*  245634 */   // Label 4757: @245634
     /*  245634 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(245700), // Rule ID 5052 //
     /*  245639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245698 */     GIR_RootConstrainSelectedInstOperands,
     /*  245699 */     // GIR_Coverage, 5052,
     /*  245699 */     GIR_EraseRootFromParent_Done,
     /*  245700 */   // Label 4758: @245700
     /*  245700 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(245766), // Rule ID 5053 //
     /*  245705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245764 */     GIR_RootConstrainSelectedInstOperands,
     /*  245765 */     // GIR_Coverage, 5053,
     /*  245765 */     GIR_EraseRootFromParent_Done,
     /*  245766 */   // Label 4759: @245766
     /*  245766 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(245832), // Rule ID 5056 //
     /*  245771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  245788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245810 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245830 */     GIR_RootConstrainSelectedInstOperands,
     /*  245831 */     // GIR_Coverage, 5056,
     /*  245831 */     GIR_EraseRootFromParent_Done,
     /*  245832 */   // Label 4760: @245832
     /*  245832 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(245898), // Rule ID 5057 //
     /*  245837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  245854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245896 */     GIR_RootConstrainSelectedInstOperands,
     /*  245897 */     // GIR_Coverage, 5057,
     /*  245897 */     GIR_EraseRootFromParent_Done,
     /*  245898 */   // Label 4761: @245898
     /*  245898 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(245964), // Rule ID 5060 //
     /*  245903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  245914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  245917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  245920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245962 */     GIR_RootConstrainSelectedInstOperands,
     /*  245963 */     // GIR_Coverage, 5060,
     /*  245963 */     GIR_EraseRootFromParent_Done,
     /*  245964 */   // Label 4762: @245964
     /*  245964 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(246030), // Rule ID 5061 //
     /*  245969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  245980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  245983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  245986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246008 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  246011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246028 */     GIR_RootConstrainSelectedInstOperands,
     /*  246029 */     // GIR_Coverage, 5061,
     /*  246029 */     GIR_EraseRootFromParent_Done,
     /*  246030 */   // Label 4763: @246030
     /*  246030 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(246096), // Rule ID 5064 //
     /*  246035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  246077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246094 */     GIR_RootConstrainSelectedInstOperands,
     /*  246095 */     // GIR_Coverage, 5064,
     /*  246095 */     GIR_EraseRootFromParent_Done,
     /*  246096 */   // Label 4764: @246096
     /*  246096 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(246162), // Rule ID 5065 //
     /*  246101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  246112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  246115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  246143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246160 */     GIR_RootConstrainSelectedInstOperands,
     /*  246161 */     // GIR_Coverage, 5065,
     /*  246161 */     GIR_EraseRootFromParent_Done,
     /*  246162 */   // Label 4765: @246162
     /*  246162 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(246228), // Rule ID 5068 //
     /*  246167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246226 */     GIR_RootConstrainSelectedInstOperands,
     /*  246227 */     // GIR_Coverage, 5068,
     /*  246227 */     GIR_EraseRootFromParent_Done,
     /*  246228 */   // Label 4766: @246228
     /*  246228 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(246294), // Rule ID 5069 //
     /*  246233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  246244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  246247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11540:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246292 */     GIR_RootConstrainSelectedInstOperands,
     /*  246293 */     // GIR_Coverage, 5069,
     /*  246293 */     GIR_EraseRootFromParent_Done,
     /*  246294 */   // Label 4767: @246294
     /*  246294 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(246360), // Rule ID 5072 //
     /*  246299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246338 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246358 */     GIR_RootConstrainSelectedInstOperands,
     /*  246359 */     // GIR_Coverage, 5072,
     /*  246359 */     GIR_EraseRootFromParent_Done,
     /*  246360 */   // Label 4768: @246360
     /*  246360 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(246426), // Rule ID 5073 //
     /*  246365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  246376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  246379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246424 */     GIR_RootConstrainSelectedInstOperands,
     /*  246425 */     // GIR_Coverage, 5073,
     /*  246425 */     GIR_EraseRootFromParent_Done,
     /*  246426 */   // Label 4769: @246426
     /*  246426 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(246492), // Rule ID 5076 //
     /*  246431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  246473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246490 */     GIR_RootConstrainSelectedInstOperands,
     /*  246491 */     // GIR_Coverage, 5076,
     /*  246491 */     GIR_EraseRootFromParent_Done,
     /*  246492 */   // Label 4770: @246492
     /*  246492 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(246558), // Rule ID 5077 //
     /*  246497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  246539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246556 */     GIR_RootConstrainSelectedInstOperands,
     /*  246557 */     // GIR_Coverage, 5077,
     /*  246557 */     GIR_EraseRootFromParent_Done,
     /*  246558 */   // Label 4771: @246558
     /*  246558 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(246624), // Rule ID 5080 //
     /*  246563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  246605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246622 */     GIR_RootConstrainSelectedInstOperands,
     /*  246623 */     // GIR_Coverage, 5080,
     /*  246623 */     GIR_EraseRootFromParent_Done,
     /*  246624 */   // Label 4772: @246624
     /*  246624 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(246690), // Rule ID 5081 //
     /*  246629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  246671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246688 */     GIR_RootConstrainSelectedInstOperands,
     /*  246689 */     // GIR_Coverage, 5081,
     /*  246689 */     GIR_EraseRootFromParent_Done,
     /*  246690 */   // Label 4773: @246690
     /*  246690 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(246756), // Rule ID 5084 //
     /*  246695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246754 */     GIR_RootConstrainSelectedInstOperands,
     /*  246755 */     // GIR_Coverage, 5084,
     /*  246755 */     GIR_EraseRootFromParent_Done,
     /*  246756 */   // Label 4774: @246756
     /*  246756 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(246822), // Rule ID 5085 //
     /*  246761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246820 */     GIR_RootConstrainSelectedInstOperands,
     /*  246821 */     // GIR_Coverage, 5085,
     /*  246821 */     GIR_EraseRootFromParent_Done,
     /*  246822 */   // Label 4775: @246822
     /*  246822 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(246888), // Rule ID 5088 //
     /*  246827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  246844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246886 */     GIR_RootConstrainSelectedInstOperands,
     /*  246887 */     // GIR_Coverage, 5088,
     /*  246887 */     GIR_EraseRootFromParent_Done,
     /*  246888 */   // Label 4776: @246888
     /*  246888 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(246954), // Rule ID 5089 //
     /*  246893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  246910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246932 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246952 */     GIR_RootConstrainSelectedInstOperands,
     /*  246953 */     // GIR_Coverage, 5089,
     /*  246953 */     GIR_EraseRootFromParent_Done,
     /*  246954 */   // Label 4777: @246954
     /*  246954 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(247020), // Rule ID 5092 //
     /*  246959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  246976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247018 */     GIR_RootConstrainSelectedInstOperands,
     /*  247019 */     // GIR_Coverage, 5092,
     /*  247019 */     GIR_EraseRootFromParent_Done,
     /*  247020 */   // Label 4778: @247020
     /*  247020 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(247086), // Rule ID 5093 //
     /*  247025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  247042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  247067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247084 */     GIR_RootConstrainSelectedInstOperands,
     /*  247085 */     // GIR_Coverage, 5093,
     /*  247085 */     GIR_EraseRootFromParent_Done,
     /*  247086 */   // Label 4779: @247086
     /*  247086 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(247152), // Rule ID 5096 //
     /*  247091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247130 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247150 */     GIR_RootConstrainSelectedInstOperands,
     /*  247151 */     // GIR_Coverage, 5096,
     /*  247151 */     GIR_EraseRootFromParent_Done,
     /*  247152 */   // Label 4780: @247152
     /*  247152 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(247218), // Rule ID 5097 //
     /*  247157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  247174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  247199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247216 */     GIR_RootConstrainSelectedInstOperands,
     /*  247217 */     // GIR_Coverage, 5097,
     /*  247217 */     GIR_EraseRootFromParent_Done,
     /*  247218 */   // Label 4781: @247218
     /*  247218 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(247284), // Rule ID 5100 //
     /*  247223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247262 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  247265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247282 */     GIR_RootConstrainSelectedInstOperands,
     /*  247283 */     // GIR_Coverage, 5100,
     /*  247283 */     GIR_EraseRootFromParent_Done,
     /*  247284 */   // Label 4782: @247284
     /*  247284 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(247350), // Rule ID 5101 //
     /*  247289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  247300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  247303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  247306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11540:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  247331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247348 */     GIR_RootConstrainSelectedInstOperands,
     /*  247349 */     // GIR_Coverage, 5101,
     /*  247349 */     GIR_EraseRootFromParent_Done,
     /*  247350 */   // Label 4783: @247350
     /*  247350 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(247416), // Rule ID 5104 //
     /*  247355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  247397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247414 */     GIR_RootConstrainSelectedInstOperands,
     /*  247415 */     // GIR_Coverage, 5104,
     /*  247415 */     GIR_EraseRootFromParent_Done,
     /*  247416 */   // Label 4784: @247416
     /*  247416 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(247482), // Rule ID 5105 //
     /*  247421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  247432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  247435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  247449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247460 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11540:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  247463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247480 */     GIR_RootConstrainSelectedInstOperands,
     /*  247481 */     // GIR_Coverage, 5105,
     /*  247481 */     GIR_EraseRootFromParent_Done,
     /*  247482 */   // Label 4785: @247482
     /*  247482 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(247548), // Rule ID 5108 //
     /*  247487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  247529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247546 */     GIR_RootConstrainSelectedInstOperands,
     /*  247547 */     // GIR_Coverage, 5108,
     /*  247547 */     GIR_EraseRootFromParent_Done,
     /*  247548 */   // Label 4786: @247548
     /*  247548 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(247614), // Rule ID 5109 //
     /*  247553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247592 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11540:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  247595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247612 */     GIR_RootConstrainSelectedInstOperands,
     /*  247613 */     // GIR_Coverage, 5109,
     /*  247613 */     GIR_EraseRootFromParent_Done,
     /*  247614 */   // Label 4787: @247614
     /*  247614 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(247680), // Rule ID 5112 //
     /*  247619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247658 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  247661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247678 */     GIR_RootConstrainSelectedInstOperands,
     /*  247679 */     // GIR_Coverage, 5112,
     /*  247679 */     GIR_EraseRootFromParent_Done,
     /*  247680 */   // Label 4788: @247680
     /*  247680 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(247746), // Rule ID 5113 //
     /*  247685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247724 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11540:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  247727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247744 */     GIR_RootConstrainSelectedInstOperands,
     /*  247745 */     // GIR_Coverage, 5113,
     /*  247745 */     GIR_EraseRootFromParent_Done,
     /*  247746 */   // Label 4789: @247746
     /*  247746 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(247809), // Rule ID 5376 //
     /*  247751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  247762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  247765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247790 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  247790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  247793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247807 */     GIR_RootConstrainSelectedInstOperands,
     /*  247808 */     // GIR_Coverage, 5376,
     /*  247808 */     GIR_EraseRootFromParent_Done,
     /*  247809 */   // Label 4790: @247809
     /*  247809 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(247872), // Rule ID 5377 //
     /*  247814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  247825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  247828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247853 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  247853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  247856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247870 */     GIR_RootConstrainSelectedInstOperands,
     /*  247871 */     // GIR_Coverage, 5377,
     /*  247871 */     GIR_EraseRootFromParent_Done,
     /*  247872 */   // Label 4791: @247872
     /*  247872 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(247935), // Rule ID 5378 //
     /*  247877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  247888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  247891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247916 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  247916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247933 */     GIR_RootConstrainSelectedInstOperands,
     /*  247934 */     // GIR_Coverage, 5378,
     /*  247934 */     GIR_EraseRootFromParent_Done,
     /*  247935 */   // Label 4792: @247935
     /*  247935 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(247998), // Rule ID 5379 //
     /*  247940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  247951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  247954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247979 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  247979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247996 */     GIR_RootConstrainSelectedInstOperands,
     /*  247997 */     // GIR_Coverage, 5379,
     /*  247997 */     GIR_EraseRootFromParent_Done,
     /*  247998 */   // Label 4793: @247998
     /*  247998 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(248061), // Rule ID 5380 //
     /*  248003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  248017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248042 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248059 */     GIR_RootConstrainSelectedInstOperands,
     /*  248060 */     // GIR_Coverage, 5380,
     /*  248060 */     GIR_EraseRootFromParent_Done,
     /*  248061 */   // Label 4794: @248061
     /*  248061 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(248124), // Rule ID 5381 //
     /*  248066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  248080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  248083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248105 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  248108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248122 */     GIR_RootConstrainSelectedInstOperands,
     /*  248123 */     // GIR_Coverage, 5381,
     /*  248123 */     GIR_EraseRootFromParent_Done,
     /*  248124 */   // Label 4795: @248124
     /*  248124 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(248187), // Rule ID 5382 //
     /*  248129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248168 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248185 */     GIR_RootConstrainSelectedInstOperands,
     /*  248186 */     // GIR_Coverage, 5382,
     /*  248186 */     GIR_EraseRootFromParent_Done,
     /*  248187 */   // Label 4796: @248187
     /*  248187 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(248250), // Rule ID 5383 //
     /*  248192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  248206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  248209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248231 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248248 */     GIR_RootConstrainSelectedInstOperands,
     /*  248249 */     // GIR_Coverage, 5383,
     /*  248249 */     GIR_EraseRootFromParent_Done,
     /*  248250 */   // Label 4797: @248250
     /*  248250 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(248313), // Rule ID 5384 //
     /*  248255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  248272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248294 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  248294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248311 */     GIR_RootConstrainSelectedInstOperands,
     /*  248312 */     // GIR_Coverage, 5384,
     /*  248312 */     GIR_EraseRootFromParent_Done,
     /*  248313 */   // Label 4798: @248313
     /*  248313 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(248376), // Rule ID 5385 //
     /*  248318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  248332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  248335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248357 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  248357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  248360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248374 */     GIR_RootConstrainSelectedInstOperands,
     /*  248375 */     // GIR_Coverage, 5385,
     /*  248375 */     GIR_EraseRootFromParent_Done,
     /*  248376 */   // Label 4799: @248376
     /*  248376 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(248439), // Rule ID 5386 //
     /*  248381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  248395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248437 */     GIR_RootConstrainSelectedInstOperands,
     /*  248438 */     // GIR_Coverage, 5386,
     /*  248438 */     GIR_EraseRootFromParent_Done,
     /*  248439 */   // Label 4800: @248439
     /*  248439 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(248502), // Rule ID 5387 //
     /*  248444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  248458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  248461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248483 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248500 */     GIR_RootConstrainSelectedInstOperands,
     /*  248501 */     // GIR_Coverage, 5387,
     /*  248501 */     GIR_EraseRootFromParent_Done,
     /*  248502 */   // Label 4801: @248502
     /*  248502 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(248565), // Rule ID 5388 //
     /*  248507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248546 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248563 */     GIR_RootConstrainSelectedInstOperands,
     /*  248564 */     // GIR_Coverage, 5388,
     /*  248564 */     GIR_EraseRootFromParent_Done,
     /*  248565 */   // Label 4802: @248565
     /*  248565 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(248628), // Rule ID 5389 //
     /*  248570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248609 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248626 */     GIR_RootConstrainSelectedInstOperands,
     /*  248627 */     // GIR_Coverage, 5389,
     /*  248627 */     GIR_EraseRootFromParent_Done,
     /*  248628 */   // Label 4803: @248628
     /*  248628 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(248691), // Rule ID 5390 //
     /*  248633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  248650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248672 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  248672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248689 */     GIR_RootConstrainSelectedInstOperands,
     /*  248690 */     // GIR_Coverage, 5390,
     /*  248690 */     GIR_EraseRootFromParent_Done,
     /*  248691 */   // Label 4804: @248691
     /*  248691 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(248754), // Rule ID 5391 //
     /*  248696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  248713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248735 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  248735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248752 */     GIR_RootConstrainSelectedInstOperands,
     /*  248753 */     // GIR_Coverage, 5391,
     /*  248753 */     GIR_EraseRootFromParent_Done,
     /*  248754 */   // Label 4805: @248754
     /*  248754 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(248817), // Rule ID 5392 //
     /*  248759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  248762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  248773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  248776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248798 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  248798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248815 */     GIR_RootConstrainSelectedInstOperands,
     /*  248816 */     // GIR_Coverage, 5392,
     /*  248816 */     GIR_EraseRootFromParent_Done,
     /*  248817 */   // Label 4806: @248817
     /*  248817 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(248880), // Rule ID 5393 //
     /*  248822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  248825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  248836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  248839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248861 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  248861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248878 */     GIR_RootConstrainSelectedInstOperands,
     /*  248879 */     // GIR_Coverage, 5393,
     /*  248879 */     GIR_EraseRootFromParent_Done,
     /*  248880 */   // Label 4807: @248880
     /*  248880 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(248943), // Rule ID 5394 //
     /*  248885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  248896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  248899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248924 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  248927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248941 */     GIR_RootConstrainSelectedInstOperands,
     /*  248942 */     // GIR_Coverage, 5394,
     /*  248942 */     GIR_EraseRootFromParent_Done,
     /*  248943 */   // Label 4808: @248943
     /*  248943 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(249006), // Rule ID 5395 //
     /*  248948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  248959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  248962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248987 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  248990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249004 */     GIR_RootConstrainSelectedInstOperands,
     /*  249005 */     // GIR_Coverage, 5395,
     /*  249005 */     GIR_EraseRootFromParent_Done,
     /*  249006 */   // Label 4809: @249006
     /*  249006 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(249069), // Rule ID 5396 //
     /*  249011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  249025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  249028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249050 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249067 */     GIR_RootConstrainSelectedInstOperands,
     /*  249068 */     // GIR_Coverage, 5396,
     /*  249068 */     GIR_EraseRootFromParent_Done,
     /*  249069 */   // Label 4810: @249069
     /*  249069 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249132), // Rule ID 5397 //
     /*  249074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  249088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  249091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249113 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249130 */     GIR_RootConstrainSelectedInstOperands,
     /*  249131 */     // GIR_Coverage, 5397,
     /*  249131 */     GIR_EraseRootFromParent_Done,
     /*  249132 */   // Label 4811: @249132
     /*  249132 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(249195), // Rule ID 5398 //
     /*  249137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  249148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  249151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  249154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249176 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249193 */     GIR_RootConstrainSelectedInstOperands,
     /*  249194 */     // GIR_Coverage, 5398,
     /*  249194 */     GIR_EraseRootFromParent_Done,
     /*  249195 */   // Label 4812: @249195
     /*  249195 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(249258), // Rule ID 5399 //
     /*  249200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  249211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  249214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  249217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249239 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249256 */     GIR_RootConstrainSelectedInstOperands,
     /*  249257 */     // GIR_Coverage, 5399,
     /*  249257 */     GIR_EraseRootFromParent_Done,
     /*  249258 */   // Label 4813: @249258
     /*  249258 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(249321), // Rule ID 5400 //
     /*  249263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  249277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249319 */     GIR_RootConstrainSelectedInstOperands,
     /*  249320 */     // GIR_Coverage, 5400,
     /*  249320 */     GIR_EraseRootFromParent_Done,
     /*  249321 */   // Label 4814: @249321
     /*  249321 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(249384), // Rule ID 5401 //
     /*  249326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  249340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  249343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249365 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249382 */     GIR_RootConstrainSelectedInstOperands,
     /*  249383 */     // GIR_Coverage, 5401,
     /*  249383 */     GIR_EraseRootFromParent_Done,
     /*  249384 */   // Label 4815: @249384
     /*  249384 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(249447), // Rule ID 5402 //
     /*  249389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  249403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249428 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249445 */     GIR_RootConstrainSelectedInstOperands,
     /*  249446 */     // GIR_Coverage, 5402,
     /*  249446 */     GIR_EraseRootFromParent_Done,
     /*  249447 */   // Label 4816: @249447
     /*  249447 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(249510), // Rule ID 5403 //
     /*  249452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  249466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  249469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249491 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249508 */     GIR_RootConstrainSelectedInstOperands,
     /*  249509 */     // GIR_Coverage, 5403,
     /*  249509 */     GIR_EraseRootFromParent_Done,
     /*  249510 */   // Label 4817: @249510
     /*  249510 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(249573), // Rule ID 5404 //
     /*  249515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  249529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  249532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249554 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249571 */     GIR_RootConstrainSelectedInstOperands,
     /*  249572 */     // GIR_Coverage, 5404,
     /*  249572 */     GIR_EraseRootFromParent_Done,
     /*  249573 */   // Label 4818: @249573
     /*  249573 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(249636), // Rule ID 5405 //
     /*  249578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  249592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  249595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249617 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249634 */     GIR_RootConstrainSelectedInstOperands,
     /*  249635 */     // GIR_Coverage, 5405,
     /*  249635 */     GIR_EraseRootFromParent_Done,
     /*  249636 */   // Label 4819: @249636
     /*  249636 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(249699), // Rule ID 5406 //
     /*  249641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249697 */     GIR_RootConstrainSelectedInstOperands,
     /*  249698 */     // GIR_Coverage, 5406,
     /*  249698 */     GIR_EraseRootFromParent_Done,
     /*  249699 */   // Label 4820: @249699
     /*  249699 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(249762), // Rule ID 5407 //
     /*  249704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249743 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249760 */     GIR_RootConstrainSelectedInstOperands,
     /*  249761 */     // GIR_Coverage, 5407,
     /*  249761 */     GIR_EraseRootFromParent_Done,
     /*  249762 */   // Label 4821: @249762
     /*  249762 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(249825), // Rule ID 5408 //
     /*  249767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249806 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249823 */     GIR_RootConstrainSelectedInstOperands,
     /*  249824 */     // GIR_Coverage, 5408,
     /*  249824 */     GIR_EraseRootFromParent_Done,
     /*  249825 */   // Label 4822: @249825
     /*  249825 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(249888), // Rule ID 5409 //
     /*  249830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249869 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249886 */     GIR_RootConstrainSelectedInstOperands,
     /*  249887 */     // GIR_Coverage, 5409,
     /*  249887 */     GIR_EraseRootFromParent_Done,
     /*  249888 */   // Label 4823: @249888
     /*  249888 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(249951), // Rule ID 5410 //
     /*  249893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  249910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249932 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249949 */     GIR_RootConstrainSelectedInstOperands,
     /*  249950 */     // GIR_Coverage, 5410,
     /*  249950 */     GIR_EraseRootFromParent_Done,
     /*  249951 */   // Label 4824: @249951
     /*  249951 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(250014), // Rule ID 5411 //
     /*  249956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  249973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249995 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250012 */     GIR_RootConstrainSelectedInstOperands,
     /*  250013 */     // GIR_Coverage, 5411,
     /*  250013 */     GIR_EraseRootFromParent_Done,
     /*  250014 */   // Label 4825: @250014
     /*  250014 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(250077), // Rule ID 5412 //
     /*  250019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  250036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250058 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250075 */     GIR_RootConstrainSelectedInstOperands,
     /*  250076 */     // GIR_Coverage, 5412,
     /*  250076 */     GIR_EraseRootFromParent_Done,
     /*  250077 */   // Label 4826: @250077
     /*  250077 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(250140), // Rule ID 5413 //
     /*  250082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  250096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  250099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  250114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250121 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  250124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250138 */     GIR_RootConstrainSelectedInstOperands,
     /*  250139 */     // GIR_Coverage, 5413,
     /*  250139 */     GIR_EraseRootFromParent_Done,
     /*  250140 */   // Label 4827: @250140
     /*  250140 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(250203), // Rule ID 5414 //
     /*  250145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  250162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250201 */     GIR_RootConstrainSelectedInstOperands,
     /*  250202 */     // GIR_Coverage, 5414,
     /*  250202 */     GIR_EraseRootFromParent_Done,
     /*  250203 */   // Label 4828: @250203
     /*  250203 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(250266), // Rule ID 5415 //
     /*  250208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  250222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  250225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  250240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250247 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  250250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250264 */     GIR_RootConstrainSelectedInstOperands,
     /*  250265 */     // GIR_Coverage, 5415,
     /*  250265 */     GIR_EraseRootFromParent_Done,
     /*  250266 */   // Label 4829: @250266
     /*  250266 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(250329), // Rule ID 5416 //
     /*  250271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  250274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  250288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250310 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  250310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250327 */     GIR_RootConstrainSelectedInstOperands,
     /*  250328 */     // GIR_Coverage, 5416,
     /*  250328 */     GIR_EraseRootFromParent_Done,
     /*  250329 */   // Label 4830: @250329
     /*  250329 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(250392), // Rule ID 5417 //
     /*  250334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  250337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  250348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  250351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  250366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250373 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  250373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  250376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  250390 */     GIR_RootConstrainSelectedInstOperands,
     /*  250391 */     // GIR_Coverage, 5417,
     /*  250391 */     GIR_EraseRootFromParent_Done,
     /*  250392 */   // Label 4831: @250392
     /*  250392 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(250455), // Rule ID 5418 //
     /*  250397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  250411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250436 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  250439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250453 */     GIR_RootConstrainSelectedInstOperands,
     /*  250454 */     // GIR_Coverage, 5418,
     /*  250454 */     GIR_EraseRootFromParent_Done,
     /*  250455 */   // Label 4832: @250455
     /*  250455 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(250518), // Rule ID 5419 //
     /*  250460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  250474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250499 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  250502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250516 */     GIR_RootConstrainSelectedInstOperands,
     /*  250517 */     // GIR_Coverage, 5419,
     /*  250517 */     GIR_EraseRootFromParent_Done,
     /*  250518 */   // Label 4833: @250518
     /*  250518 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250581), // Rule ID 5420 //
     /*  250523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  250537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250562 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250579 */     GIR_RootConstrainSelectedInstOperands,
     /*  250580 */     // GIR_Coverage, 5420,
     /*  250580 */     GIR_EraseRootFromParent_Done,
     /*  250581 */   // Label 4834: @250581
     /*  250581 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250644), // Rule ID 5421 //
     /*  250586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  250600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250625 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250642 */     GIR_RootConstrainSelectedInstOperands,
     /*  250643 */     // GIR_Coverage, 5421,
     /*  250643 */     GIR_EraseRootFromParent_Done,
     /*  250644 */   // Label 4835: @250644
     /*  250644 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(250707), // Rule ID 5422 //
     /*  250649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  250663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250688 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250705 */     GIR_RootConstrainSelectedInstOperands,
     /*  250706 */     // GIR_Coverage, 5422,
     /*  250706 */     GIR_EraseRootFromParent_Done,
     /*  250707 */   // Label 4836: @250707
     /*  250707 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(250770), // Rule ID 5423 //
     /*  250712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  250726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250751 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250768 */     GIR_RootConstrainSelectedInstOperands,
     /*  250769 */     // GIR_Coverage, 5423,
     /*  250769 */     GIR_EraseRootFromParent_Done,
     /*  250770 */   // Label 4837: @250770
     /*  250770 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(250833), // Rule ID 5424 //
     /*  250775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  250789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250814 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  250814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250831 */     GIR_RootConstrainSelectedInstOperands,
     /*  250832 */     // GIR_Coverage, 5424,
     /*  250832 */     GIR_EraseRootFromParent_Done,
     /*  250833 */   // Label 4838: @250833
     /*  250833 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(250896), // Rule ID 5425 //
     /*  250838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  250852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250877 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  250877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250894 */     GIR_RootConstrainSelectedInstOperands,
     /*  250895 */     // GIR_Coverage, 5425,
     /*  250895 */     GIR_EraseRootFromParent_Done,
     /*  250896 */   // Label 4839: @250896
     /*  250896 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(250959), // Rule ID 5426 //
     /*  250901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  250915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  250940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250957 */     GIR_RootConstrainSelectedInstOperands,
     /*  250958 */     // GIR_Coverage, 5426,
     /*  250958 */     GIR_EraseRootFromParent_Done,
     /*  250959 */   // Label 4840: @250959
     /*  250959 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251022), // Rule ID 5427 //
     /*  250964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  250978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251003 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251020 */     GIR_RootConstrainSelectedInstOperands,
     /*  251021 */     // GIR_Coverage, 5427,
     /*  251021 */     GIR_EraseRootFromParent_Done,
     /*  251022 */   // Label 4841: @251022
     /*  251022 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251085), // Rule ID 5428 //
     /*  251027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  251041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251066 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  251066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251083 */     GIR_RootConstrainSelectedInstOperands,
     /*  251084 */     // GIR_Coverage, 5428,
     /*  251084 */     GIR_EraseRootFromParent_Done,
     /*  251085 */   // Label 4842: @251085
     /*  251085 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251148), // Rule ID 5429 //
     /*  251090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  251104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251129 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  251129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  251132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251146 */     GIR_RootConstrainSelectedInstOperands,
     /*  251147 */     // GIR_Coverage, 5429,
     /*  251147 */     GIR_EraseRootFromParent_Done,
     /*  251148 */   // Label 4843: @251148
     /*  251148 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251211), // Rule ID 5430 //
     /*  251153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  251167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251209 */     GIR_RootConstrainSelectedInstOperands,
     /*  251210 */     // GIR_Coverage, 5430,
     /*  251210 */     GIR_EraseRootFromParent_Done,
     /*  251211 */   // Label 4844: @251211
     /*  251211 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251274), // Rule ID 5431 //
     /*  251216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  251230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251255 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251272 */     GIR_RootConstrainSelectedInstOperands,
     /*  251273 */     // GIR_Coverage, 5431,
     /*  251273 */     GIR_EraseRootFromParent_Done,
     /*  251274 */   // Label 4845: @251274
     /*  251274 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(251337), // Rule ID 5432 //
     /*  251279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251318 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251335 */     GIR_RootConstrainSelectedInstOperands,
     /*  251336 */     // GIR_Coverage, 5432,
     /*  251336 */     GIR_EraseRootFromParent_Done,
     /*  251337 */   // Label 4846: @251337
     /*  251337 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(251400), // Rule ID 5433 //
     /*  251342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  251356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251381 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251398 */     GIR_RootConstrainSelectedInstOperands,
     /*  251399 */     // GIR_Coverage, 5433,
     /*  251399 */     GIR_EraseRootFromParent_Done,
     /*  251400 */   // Label 4847: @251400
     /*  251400 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(251463), // Rule ID 5434 //
     /*  251405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  251419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251444 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  251444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251461 */     GIR_RootConstrainSelectedInstOperands,
     /*  251462 */     // GIR_Coverage, 5434,
     /*  251462 */     GIR_EraseRootFromParent_Done,
     /*  251463 */   // Label 4848: @251463
     /*  251463 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(251526), // Rule ID 5435 //
     /*  251468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  251479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  251482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251507 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  251507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251524 */     GIR_RootConstrainSelectedInstOperands,
     /*  251525 */     // GIR_Coverage, 5435,
     /*  251525 */     GIR_EraseRootFromParent_Done,
     /*  251526 */   // Label 4849: @251526
     /*  251526 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(251589), // Rule ID 5436 //
     /*  251531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  251534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251570 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  251570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251587 */     GIR_RootConstrainSelectedInstOperands,
     /*  251588 */     // GIR_Coverage, 5436,
     /*  251588 */     GIR_EraseRootFromParent_Done,
     /*  251589 */   // Label 4850: @251589
     /*  251589 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(251652), // Rule ID 5437 //
     /*  251594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  251597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251633 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11408:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  251633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251650 */     GIR_RootConstrainSelectedInstOperands,
     /*  251651 */     // GIR_Coverage, 5437,
     /*  251651 */     GIR_EraseRootFromParent_Done,
     /*  251652 */   // Label 4851: @251652
     /*  251652 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(251715), // Rule ID 5438 //
     /*  251657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  251668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  251671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251696 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  251699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251713 */     GIR_RootConstrainSelectedInstOperands,
     /*  251714 */     // GIR_Coverage, 5438,
     /*  251714 */     GIR_EraseRootFromParent_Done,
     /*  251715 */   // Label 4852: @251715
     /*  251715 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(251778), // Rule ID 5439 //
     /*  251720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  251731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  251734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251759 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  251762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251776 */     GIR_RootConstrainSelectedInstOperands,
     /*  251777 */     // GIR_Coverage, 5439,
     /*  251777 */     GIR_EraseRootFromParent_Done,
     /*  251778 */   // Label 4853: @251778
     /*  251778 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(251841), // Rule ID 5440 //
     /*  251783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  251794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  251797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251822 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  251825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251839 */     GIR_RootConstrainSelectedInstOperands,
     /*  251840 */     // GIR_Coverage, 5440,
     /*  251840 */     GIR_EraseRootFromParent_Done,
     /*  251841 */   // Label 4854: @251841
     /*  251841 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(251904), // Rule ID 5441 //
     /*  251846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  251857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  251860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251885 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  251888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251902 */     GIR_RootConstrainSelectedInstOperands,
     /*  251903 */     // GIR_Coverage, 5441,
     /*  251903 */     GIR_EraseRootFromParent_Done,
     /*  251904 */   // Label 4855: @251904
     /*  251904 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(251967), // Rule ID 5442 //
     /*  251909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  251920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  251923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251948 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  251951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251965 */     GIR_RootConstrainSelectedInstOperands,
     /*  251966 */     // GIR_Coverage, 5442,
     /*  251966 */     GIR_EraseRootFromParent_Done,
     /*  251967 */   // Label 4856: @251967
     /*  251967 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(252030), // Rule ID 5443 //
     /*  251972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  251983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  251986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252011 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252028 */     GIR_RootConstrainSelectedInstOperands,
     /*  252029 */     // GIR_Coverage, 5443,
     /*  252029 */     GIR_EraseRootFromParent_Done,
     /*  252030 */   // Label 4857: @252030
     /*  252030 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(252093), // Rule ID 5444 //
     /*  252035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  252049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252074 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252091 */     GIR_RootConstrainSelectedInstOperands,
     /*  252092 */     // GIR_Coverage, 5444,
     /*  252092 */     GIR_EraseRootFromParent_Done,
     /*  252093 */   // Label 4858: @252093
     /*  252093 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(252156), // Rule ID 5445 //
     /*  252098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  252112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252137 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252154 */     GIR_RootConstrainSelectedInstOperands,
     /*  252155 */     // GIR_Coverage, 5445,
     /*  252155 */     GIR_EraseRootFromParent_Done,
     /*  252156 */   // Label 4859: @252156
     /*  252156 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(252219), // Rule ID 5446 //
     /*  252161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252217 */     GIR_RootConstrainSelectedInstOperands,
     /*  252218 */     // GIR_Coverage, 5446,
     /*  252218 */     GIR_EraseRootFromParent_Done,
     /*  252219 */   // Label 4860: @252219
     /*  252219 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(252282), // Rule ID 5447 //
     /*  252224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  252238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252263 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252280 */     GIR_RootConstrainSelectedInstOperands,
     /*  252281 */     // GIR_Coverage, 5447,
     /*  252281 */     GIR_EraseRootFromParent_Done,
     /*  252282 */   // Label 4861: @252282
     /*  252282 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(252345), // Rule ID 5448 //
     /*  252287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252326 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  252326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252343 */     GIR_RootConstrainSelectedInstOperands,
     /*  252344 */     // GIR_Coverage, 5448,
     /*  252344 */     GIR_EraseRootFromParent_Done,
     /*  252345 */   // Label 4862: @252345
     /*  252345 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252408), // Rule ID 5449 //
     /*  252350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  252361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  252364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252389 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  252389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  252406 */     GIR_RootConstrainSelectedInstOperands,
     /*  252407 */     // GIR_Coverage, 5449,
     /*  252407 */     GIR_EraseRootFromParent_Done,
     /*  252408 */   // Label 4863: @252408
     /*  252408 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252471), // Rule ID 5450 //
     /*  252413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252469 */     GIR_RootConstrainSelectedInstOperands,
     /*  252470 */     // GIR_Coverage, 5450,
     /*  252470 */     GIR_EraseRootFromParent_Done,
     /*  252471 */   // Label 4864: @252471
     /*  252471 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252534), // Rule ID 5451 //
     /*  252476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  252490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252515 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252532 */     GIR_RootConstrainSelectedInstOperands,
     /*  252533 */     // GIR_Coverage, 5451,
     /*  252533 */     GIR_EraseRootFromParent_Done,
     /*  252534 */   // Label 4865: @252534
     /*  252534 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252597), // Rule ID 5452 //
     /*  252539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  252553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252578 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252595 */     GIR_RootConstrainSelectedInstOperands,
     /*  252596 */     // GIR_Coverage, 5452,
     /*  252596 */     GIR_EraseRootFromParent_Done,
     /*  252597 */   // Label 4866: @252597
     /*  252597 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252660), // Rule ID 5453 //
     /*  252602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  252616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252641 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252658 */     GIR_RootConstrainSelectedInstOperands,
     /*  252659 */     // GIR_Coverage, 5453,
     /*  252659 */     GIR_EraseRootFromParent_Done,
     /*  252660 */   // Label 4867: @252660
     /*  252660 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252723), // Rule ID 5454 //
     /*  252665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  252679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252704 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252721 */     GIR_RootConstrainSelectedInstOperands,
     /*  252722 */     // GIR_Coverage, 5454,
     /*  252722 */     GIR_EraseRootFromParent_Done,
     /*  252723 */   // Label 4868: @252723
     /*  252723 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252786), // Rule ID 5455 //
     /*  252728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  252742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252767 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252784 */     GIR_RootConstrainSelectedInstOperands,
     /*  252785 */     // GIR_Coverage, 5455,
     /*  252785 */     GIR_EraseRootFromParent_Done,
     /*  252786 */   // Label 4869: @252786
     /*  252786 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(252849), // Rule ID 5456 //
     /*  252791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  252805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252847 */     GIR_RootConstrainSelectedInstOperands,
     /*  252848 */     // GIR_Coverage, 5456,
     /*  252848 */     GIR_EraseRootFromParent_Done,
     /*  252849 */   // Label 4870: @252849
     /*  252849 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(252912), // Rule ID 5457 //
     /*  252854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  252868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252893 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11408:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  252893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252910 */     GIR_RootConstrainSelectedInstOperands,
     /*  252911 */     // GIR_Coverage, 5457,
     /*  252911 */     GIR_EraseRootFromParent_Done,
     /*  252912 */   // Label 4871: @252912
     /*  252912 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(252975), // Rule ID 5458 //
     /*  252917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  252931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252956 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252973 */     GIR_RootConstrainSelectedInstOperands,
     /*  252974 */     // GIR_Coverage, 5458,
     /*  252974 */     GIR_EraseRootFromParent_Done,
     /*  252975 */   // Label 4872: @252975
     /*  252975 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(253038), // Rule ID 5459 //
     /*  252980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  252994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  253008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253019 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11408:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  253022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253036 */     GIR_RootConstrainSelectedInstOperands,
     /*  253037 */     // GIR_Coverage, 5459,
     /*  253037 */     GIR_EraseRootFromParent_Done,
     /*  253038 */   // Label 4873: @253038
     /*  253038 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(253101), // Rule ID 5460 //
     /*  253043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  253060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253082 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253099 */     GIR_RootConstrainSelectedInstOperands,
     /*  253100 */     // GIR_Coverage, 5460,
     /*  253100 */     GIR_EraseRootFromParent_Done,
     /*  253101 */   // Label 4874: @253101
     /*  253101 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(253164), // Rule ID 5461 //
     /*  253106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  253114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  253120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  253123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  253134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  253138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253145 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11408:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  253148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253162 */     GIR_RootConstrainSelectedInstOperands,
     /*  253163 */     // GIR_Coverage, 5461,
     /*  253163 */     GIR_EraseRootFromParent_Done,
     /*  253164 */   // Label 4875: @253164
     /*  253164 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(253227), // Rule ID 5682 //
     /*  253169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  253183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253208 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  253211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253225 */     GIR_RootConstrainSelectedInstOperands,
     /*  253226 */     // GIR_Coverage, 5682,
     /*  253226 */     GIR_EraseRootFromParent_Done,
     /*  253227 */   // Label 4876: @253227
     /*  253227 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(253290), // Rule ID 5683 //
     /*  253232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  253246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  253249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253271 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  253274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253288 */     GIR_RootConstrainSelectedInstOperands,
     /*  253289 */     // GIR_Coverage, 5683,
     /*  253289 */     GIR_EraseRootFromParent_Done,
     /*  253290 */   // Label 4877: @253290
     /*  253290 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(253353), // Rule ID 5684 //
     /*  253295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  253309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253334 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253351 */     GIR_RootConstrainSelectedInstOperands,
     /*  253352 */     // GIR_Coverage, 5684,
     /*  253352 */     GIR_EraseRootFromParent_Done,
     /*  253353 */   // Label 4878: @253353
     /*  253353 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(253416), // Rule ID 5685 //
     /*  253358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  253372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  253375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253397 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253414 */     GIR_RootConstrainSelectedInstOperands,
     /*  253415 */     // GIR_Coverage, 5685,
     /*  253415 */     GIR_EraseRootFromParent_Done,
     /*  253416 */   // Label 4879: @253416
     /*  253416 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(253479), // Rule ID 5686 //
     /*  253421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  253435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253477 */     GIR_RootConstrainSelectedInstOperands,
     /*  253478 */     // GIR_Coverage, 5686,
     /*  253478 */     GIR_EraseRootFromParent_Done,
     /*  253479 */   // Label 4880: @253479
     /*  253479 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(253542), // Rule ID 5687 //
     /*  253484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  253498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  253501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253523 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253540 */     GIR_RootConstrainSelectedInstOperands,
     /*  253541 */     // GIR_Coverage, 5687,
     /*  253541 */     GIR_EraseRootFromParent_Done,
     /*  253542 */   // Label 4881: @253542
     /*  253542 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(253605), // Rule ID 5688 //
     /*  253547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  253561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  253564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253586 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253603 */     GIR_RootConstrainSelectedInstOperands,
     /*  253604 */     // GIR_Coverage, 5688,
     /*  253604 */     GIR_EraseRootFromParent_Done,
     /*  253605 */   // Label 4882: @253605
     /*  253605 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(253668), // Rule ID 5689 //
     /*  253610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  253624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  253627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253649 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253666 */     GIR_RootConstrainSelectedInstOperands,
     /*  253667 */     // GIR_Coverage, 5689,
     /*  253667 */     GIR_EraseRootFromParent_Done,
     /*  253668 */   // Label 4883: @253668
     /*  253668 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(253731), // Rule ID 5690 //
     /*  253673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  253687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  253690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253712 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253729 */     GIR_RootConstrainSelectedInstOperands,
     /*  253730 */     // GIR_Coverage, 5690,
     /*  253730 */     GIR_EraseRootFromParent_Done,
     /*  253731 */   // Label 4884: @253731
     /*  253731 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(253794), // Rule ID 5691 //
     /*  253736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  253750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  253753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253775 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253792 */     GIR_RootConstrainSelectedInstOperands,
     /*  253793 */     // GIR_Coverage, 5691,
     /*  253793 */     GIR_EraseRootFromParent_Done,
     /*  253794 */   // Label 4885: @253794
     /*  253794 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253857), // Rule ID 5692 //
     /*  253799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  253813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  253816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253838 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253855 */     GIR_RootConstrainSelectedInstOperands,
     /*  253856 */     // GIR_Coverage, 5692,
     /*  253856 */     GIR_EraseRootFromParent_Done,
     /*  253857 */   // Label 4886: @253857
     /*  253857 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(253920), // Rule ID 5693 //
     /*  253862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  253876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  253879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253901 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253918 */     GIR_RootConstrainSelectedInstOperands,
     /*  253919 */     // GIR_Coverage, 5693,
     /*  253919 */     GIR_EraseRootFromParent_Done,
     /*  253920 */   // Label 4887: @253920
     /*  253920 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(253983), // Rule ID 5694 //
     /*  253925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  253939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  253942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253964 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253981 */     GIR_RootConstrainSelectedInstOperands,
     /*  253982 */     // GIR_Coverage, 5694,
     /*  253982 */     GIR_EraseRootFromParent_Done,
     /*  253983 */   // Label 4888: @253983
     /*  253983 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(254046), // Rule ID 5695 //
     /*  253988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  254002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  254005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254027 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254044 */     GIR_RootConstrainSelectedInstOperands,
     /*  254045 */     // GIR_Coverage, 5695,
     /*  254045 */     GIR_EraseRootFromParent_Done,
     /*  254046 */   // Label 4889: @254046
     /*  254046 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(254109), // Rule ID 5696 //
     /*  254051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  254065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254107 */     GIR_RootConstrainSelectedInstOperands,
     /*  254108 */     // GIR_Coverage, 5696,
     /*  254108 */     GIR_EraseRootFromParent_Done,
     /*  254109 */   // Label 4890: @254109
     /*  254109 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(254172), // Rule ID 5697 //
     /*  254114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  254128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  254131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254153 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254170 */     GIR_RootConstrainSelectedInstOperands,
     /*  254171 */     // GIR_Coverage, 5697,
     /*  254171 */     GIR_EraseRootFromParent_Done,
     /*  254172 */   // Label 4891: @254172
     /*  254172 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(254235), // Rule ID 5698 //
     /*  254177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  254194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254216 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254233 */     GIR_RootConstrainSelectedInstOperands,
     /*  254234 */     // GIR_Coverage, 5698,
     /*  254234 */     GIR_EraseRootFromParent_Done,
     /*  254235 */   // Label 4892: @254235
     /*  254235 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(254298), // Rule ID 5699 //
     /*  254240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  254251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  254254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  254257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254279 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254296 */     GIR_RootConstrainSelectedInstOperands,
     /*  254297 */     // GIR_Coverage, 5699,
     /*  254297 */     GIR_EraseRootFromParent_Done,
     /*  254298 */   // Label 4893: @254298
     /*  254298 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(254361), // Rule ID 5700 //
     /*  254303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  254306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  254317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  254320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254342 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  254342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254359 */     GIR_RootConstrainSelectedInstOperands,
     /*  254360 */     // GIR_Coverage, 5700,
     /*  254360 */     GIR_EraseRootFromParent_Done,
     /*  254361 */   // Label 4894: @254361
     /*  254361 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(254424), // Rule ID 5701 //
     /*  254366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  254369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  254377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  254380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  254383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254405 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  254405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  254408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  254422 */     GIR_RootConstrainSelectedInstOperands,
     /*  254423 */     // GIR_Coverage, 5701,
     /*  254423 */     GIR_EraseRootFromParent_Done,
     /*  254424 */   // Label 4895: @254424
     /*  254424 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(254487), // Rule ID 5702 //
     /*  254429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  254443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254468 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254485 */     GIR_RootConstrainSelectedInstOperands,
     /*  254486 */     // GIR_Coverage, 5702,
     /*  254486 */     GIR_EraseRootFromParent_Done,
     /*  254487 */   // Label 4896: @254487
     /*  254487 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(254550), // Rule ID 5703 //
     /*  254492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  254506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254531 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254548 */     GIR_RootConstrainSelectedInstOperands,
     /*  254549 */     // GIR_Coverage, 5703,
     /*  254549 */     GIR_EraseRootFromParent_Done,
     /*  254550 */   // Label 4897: @254550
     /*  254550 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(254613), // Rule ID 5704 //
     /*  254555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  254566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  254569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  254572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254594 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254611 */     GIR_RootConstrainSelectedInstOperands,
     /*  254612 */     // GIR_Coverage, 5704,
     /*  254612 */     GIR_EraseRootFromParent_Done,
     /*  254613 */   // Label 4898: @254613
     /*  254613 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(254676), // Rule ID 5705 //
     /*  254618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  254629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  254632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  254635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254657 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254674 */     GIR_RootConstrainSelectedInstOperands,
     /*  254675 */     // GIR_Coverage, 5705,
     /*  254675 */     GIR_EraseRootFromParent_Done,
     /*  254676 */   // Label 4899: @254676
     /*  254676 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(254739), // Rule ID 5706 //
     /*  254681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  254692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  254695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  254698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254720 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  254723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254737 */     GIR_RootConstrainSelectedInstOperands,
     /*  254738 */     // GIR_Coverage, 5706,
     /*  254738 */     GIR_EraseRootFromParent_Done,
     /*  254739 */   // Label 4900: @254739
     /*  254739 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(254802), // Rule ID 5707 //
     /*  254744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  254755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  254758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  254761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254783 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  254786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254800 */     GIR_RootConstrainSelectedInstOperands,
     /*  254801 */     // GIR_Coverage, 5707,
     /*  254801 */     GIR_EraseRootFromParent_Done,
     /*  254802 */   // Label 4901: @254802
     /*  254802 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(254865), // Rule ID 5708 //
     /*  254807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  254821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  254824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254846 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254863 */     GIR_RootConstrainSelectedInstOperands,
     /*  254864 */     // GIR_Coverage, 5708,
     /*  254864 */     GIR_EraseRootFromParent_Done,
     /*  254865 */   // Label 4902: @254865
     /*  254865 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(254928), // Rule ID 5709 //
     /*  254870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  254884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  254887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254909 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254926 */     GIR_RootConstrainSelectedInstOperands,
     /*  254927 */     // GIR_Coverage, 5709,
     /*  254927 */     GIR_EraseRootFromParent_Done,
     /*  254928 */   // Label 4903: @254928
     /*  254928 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(254991), // Rule ID 5710 //
     /*  254933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  254947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  254950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254989 */     GIR_RootConstrainSelectedInstOperands,
     /*  254990 */     // GIR_Coverage, 5710,
     /*  254990 */     GIR_EraseRootFromParent_Done,
     /*  254991 */   // Label 4904: @254991
     /*  254991 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(255054), // Rule ID 5711 //
     /*  254996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  255010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  255013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255035 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255052 */     GIR_RootConstrainSelectedInstOperands,
     /*  255053 */     // GIR_Coverage, 5711,
     /*  255053 */     GIR_EraseRootFromParent_Done,
     /*  255054 */   // Label 4905: @255054
     /*  255054 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(255117), // Rule ID 5712 //
     /*  255059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  255073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  255076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255098 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255115 */     GIR_RootConstrainSelectedInstOperands,
     /*  255116 */     // GIR_Coverage, 5712,
     /*  255116 */     GIR_EraseRootFromParent_Done,
     /*  255117 */   // Label 4906: @255117
     /*  255117 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(255180), // Rule ID 5713 //
     /*  255122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  255133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  255136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  255139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255161 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255178 */     GIR_RootConstrainSelectedInstOperands,
     /*  255179 */     // GIR_Coverage, 5713,
     /*  255179 */     GIR_EraseRootFromParent_Done,
     /*  255180 */   // Label 4907: @255180
     /*  255180 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(255243), // Rule ID 5714 //
     /*  255185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255224 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255241 */     GIR_RootConstrainSelectedInstOperands,
     /*  255242 */     // GIR_Coverage, 5714,
     /*  255242 */     GIR_EraseRootFromParent_Done,
     /*  255243 */   // Label 4908: @255243
     /*  255243 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(255306), // Rule ID 5715 //
     /*  255248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  255262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  255265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255287 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255304 */     GIR_RootConstrainSelectedInstOperands,
     /*  255305 */     // GIR_Coverage, 5715,
     /*  255305 */     GIR_EraseRootFromParent_Done,
     /*  255306 */   // Label 4909: @255306
     /*  255306 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(255369), // Rule ID 5716 //
     /*  255311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255350 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255367 */     GIR_RootConstrainSelectedInstOperands,
     /*  255368 */     // GIR_Coverage, 5716,
     /*  255368 */     GIR_EraseRootFromParent_Done,
     /*  255369 */   // Label 4910: @255369
     /*  255369 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(255432), // Rule ID 5717 //
     /*  255374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  255388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  255391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255413 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255430 */     GIR_RootConstrainSelectedInstOperands,
     /*  255431 */     // GIR_Coverage, 5717,
     /*  255431 */     GIR_EraseRootFromParent_Done,
     /*  255432 */   // Label 4911: @255432
     /*  255432 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(255495), // Rule ID 5718 //
     /*  255437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  255451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  255454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255476 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  255476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255493 */     GIR_RootConstrainSelectedInstOperands,
     /*  255494 */     // GIR_Coverage, 5718,
     /*  255494 */     GIR_EraseRootFromParent_Done,
     /*  255495 */   // Label 4912: @255495
     /*  255495 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(255558), // Rule ID 5719 //
     /*  255500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  255514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  255517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255539 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255556 */     GIR_RootConstrainSelectedInstOperands,
     /*  255557 */     // GIR_Coverage, 5719,
     /*  255557 */     GIR_EraseRootFromParent_Done,
     /*  255558 */   // Label 4913: @255558
     /*  255558 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(255621), // Rule ID 5720 //
     /*  255563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  255577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  255580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255602 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255619 */     GIR_RootConstrainSelectedInstOperands,
     /*  255620 */     // GIR_Coverage, 5720,
     /*  255620 */     GIR_EraseRootFromParent_Done,
     /*  255621 */   // Label 4914: @255621
     /*  255621 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(255684), // Rule ID 5721 //
     /*  255626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  255640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  255643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255665 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255682 */     GIR_RootConstrainSelectedInstOperands,
     /*  255683 */     // GIR_Coverage, 5721,
     /*  255683 */     GIR_EraseRootFromParent_Done,
     /*  255684 */   // Label 4915: @255684
     /*  255684 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(255747), // Rule ID 5722 //
     /*  255689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  255703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  255706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255728 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255745 */     GIR_RootConstrainSelectedInstOperands,
     /*  255746 */     // GIR_Coverage, 5722,
     /*  255746 */     GIR_EraseRootFromParent_Done,
     /*  255747 */   // Label 4916: @255747
     /*  255747 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(255810), // Rule ID 5723 //
     /*  255752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  255766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  255769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255791 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255808 */     GIR_RootConstrainSelectedInstOperands,
     /*  255809 */     // GIR_Coverage, 5723,
     /*  255809 */     GIR_EraseRootFromParent_Done,
     /*  255810 */   // Label 4917: @255810
     /*  255810 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(255873), // Rule ID 5724 //
     /*  255815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  255829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  255832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255854 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255871 */     GIR_RootConstrainSelectedInstOperands,
     /*  255872 */     // GIR_Coverage, 5724,
     /*  255872 */     GIR_EraseRootFromParent_Done,
     /*  255873 */   // Label 4918: @255873
     /*  255873 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(255936), // Rule ID 5725 //
     /*  255878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  255892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  255895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255917 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255934 */     GIR_RootConstrainSelectedInstOperands,
     /*  255935 */     // GIR_Coverage, 5725,
     /*  255935 */     GIR_EraseRootFromParent_Done,
     /*  255936 */   // Label 4919: @255936
     /*  255936 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(255999), // Rule ID 5726 //
     /*  255941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  255955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255980 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  255983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255997 */     GIR_RootConstrainSelectedInstOperands,
     /*  255998 */     // GIR_Coverage, 5726,
     /*  255998 */     GIR_EraseRootFromParent_Done,
     /*  255999 */   // Label 4920: @255999
     /*  255999 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(256062), // Rule ID 5727 //
     /*  256004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  256018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256043 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  256046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256060 */     GIR_RootConstrainSelectedInstOperands,
     /*  256061 */     // GIR_Coverage, 5727,
     /*  256061 */     GIR_EraseRootFromParent_Done,
     /*  256062 */   // Label 4921: @256062
     /*  256062 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(256125), // Rule ID 5728 //
     /*  256067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256106 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256123 */     GIR_RootConstrainSelectedInstOperands,
     /*  256124 */     // GIR_Coverage, 5728,
     /*  256124 */     GIR_EraseRootFromParent_Done,
     /*  256125 */   // Label 4922: @256125
     /*  256125 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(256188), // Rule ID 5729 //
     /*  256130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  256144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256169 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256186 */     GIR_RootConstrainSelectedInstOperands,
     /*  256187 */     // GIR_Coverage, 5729,
     /*  256187 */     GIR_EraseRootFromParent_Done,
     /*  256188 */   // Label 4923: @256188
     /*  256188 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(256251), // Rule ID 5730 //
     /*  256193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  256207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256249 */     GIR_RootConstrainSelectedInstOperands,
     /*  256250 */     // GIR_Coverage, 5730,
     /*  256250 */     GIR_EraseRootFromParent_Done,
     /*  256251 */   // Label 4924: @256251
     /*  256251 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(256314), // Rule ID 5731 //
     /*  256256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  256270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256295 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256312 */     GIR_RootConstrainSelectedInstOperands,
     /*  256313 */     // GIR_Coverage, 5731,
     /*  256313 */     GIR_EraseRootFromParent_Done,
     /*  256314 */   // Label 4925: @256314
     /*  256314 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(256377), // Rule ID 5732 //
     /*  256319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  256333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256375 */     GIR_RootConstrainSelectedInstOperands,
     /*  256376 */     // GIR_Coverage, 5732,
     /*  256376 */     GIR_EraseRootFromParent_Done,
     /*  256377 */   // Label 4926: @256377
     /*  256377 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(256440), // Rule ID 5733 //
     /*  256382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  256396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256421 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  256424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256438 */     GIR_RootConstrainSelectedInstOperands,
     /*  256439 */     // GIR_Coverage, 5733,
     /*  256439 */     GIR_EraseRootFromParent_Done,
     /*  256440 */   // Label 4927: @256440
     /*  256440 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(256503), // Rule ID 5734 //
     /*  256445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  256459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256501 */     GIR_RootConstrainSelectedInstOperands,
     /*  256502 */     // GIR_Coverage, 5734,
     /*  256502 */     GIR_EraseRootFromParent_Done,
     /*  256503 */   // Label 4928: @256503
     /*  256503 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(256566), // Rule ID 5735 //
     /*  256508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  256522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256564 */     GIR_RootConstrainSelectedInstOperands,
     /*  256565 */     // GIR_Coverage, 5735,
     /*  256565 */     GIR_EraseRootFromParent_Done,
     /*  256566 */   // Label 4929: @256566
     /*  256566 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(256629), // Rule ID 5736 //
     /*  256571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  256585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256610 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256627 */     GIR_RootConstrainSelectedInstOperands,
     /*  256628 */     // GIR_Coverage, 5736,
     /*  256628 */     GIR_EraseRootFromParent_Done,
     /*  256629 */   // Label 4930: @256629
     /*  256629 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(256692), // Rule ID 5737 //
     /*  256634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  256648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256673 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256690 */     GIR_RootConstrainSelectedInstOperands,
     /*  256691 */     // GIR_Coverage, 5737,
     /*  256691 */     GIR_EraseRootFromParent_Done,
     /*  256692 */   // Label 4931: @256692
     /*  256692 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(256755), // Rule ID 5738 //
     /*  256697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  256711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256753 */     GIR_RootConstrainSelectedInstOperands,
     /*  256754 */     // GIR_Coverage, 5738,
     /*  256754 */     GIR_EraseRootFromParent_Done,
     /*  256755 */   // Label 4932: @256755
     /*  256755 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(256818), // Rule ID 5739 //
     /*  256760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  256774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256799 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256816 */     GIR_RootConstrainSelectedInstOperands,
     /*  256817 */     // GIR_Coverage, 5739,
     /*  256817 */     GIR_EraseRootFromParent_Done,
     /*  256818 */   // Label 4933: @256818
     /*  256818 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(256881), // Rule ID 5740 //
     /*  256823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  256837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256879 */     GIR_RootConstrainSelectedInstOperands,
     /*  256880 */     // GIR_Coverage, 5740,
     /*  256880 */     GIR_EraseRootFromParent_Done,
     /*  256881 */   // Label 4934: @256881
     /*  256881 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(256944), // Rule ID 5741 //
     /*  256886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  256900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256925 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256942 */     GIR_RootConstrainSelectedInstOperands,
     /*  256943 */     // GIR_Coverage, 5741,
     /*  256943 */     GIR_EraseRootFromParent_Done,
     /*  256944 */   // Label 4935: @256944
     /*  256944 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(257007), // Rule ID 5742 //
     /*  256949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  256963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256988 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257005 */     GIR_RootConstrainSelectedInstOperands,
     /*  257006 */     // GIR_Coverage, 5742,
     /*  257006 */     GIR_EraseRootFromParent_Done,
     /*  257007 */   // Label 4936: @257007
     /*  257007 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(257070), // Rule ID 5743 //
     /*  257012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  257026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257051 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257068 */     GIR_RootConstrainSelectedInstOperands,
     /*  257069 */     // GIR_Coverage, 5743,
     /*  257069 */     GIR_EraseRootFromParent_Done,
     /*  257070 */   // Label 4937: @257070
     /*  257070 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(257133), // Rule ID 5744 //
     /*  257075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  257078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  257089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257114 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  257114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257131 */     GIR_RootConstrainSelectedInstOperands,
     /*  257132 */     // GIR_Coverage, 5744,
     /*  257132 */     GIR_EraseRootFromParent_Done,
     /*  257133 */   // Label 4938: @257133
     /*  257133 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(257196), // Rule ID 5745 //
     /*  257138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  257141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  257149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  257152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257177 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  257177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  257180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257194 */     GIR_RootConstrainSelectedInstOperands,
     /*  257195 */     // GIR_Coverage, 5745,
     /*  257195 */     GIR_EraseRootFromParent_Done,
     /*  257196 */   // Label 4939: @257196
     /*  257196 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(257259), // Rule ID 5746 //
     /*  257201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257257 */     GIR_RootConstrainSelectedInstOperands,
     /*  257258 */     // GIR_Coverage, 5746,
     /*  257258 */     GIR_EraseRootFromParent_Done,
     /*  257259 */   // Label 4940: @257259
     /*  257259 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(257322), // Rule ID 5747 //
     /*  257264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  257278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257303 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257320 */     GIR_RootConstrainSelectedInstOperands,
     /*  257321 */     // GIR_Coverage, 5747,
     /*  257321 */     GIR_EraseRootFromParent_Done,
     /*  257322 */   // Label 4941: @257322
     /*  257322 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(257385), // Rule ID 5748 //
     /*  257327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257366 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257383 */     GIR_RootConstrainSelectedInstOperands,
     /*  257384 */     // GIR_Coverage, 5748,
     /*  257384 */     GIR_EraseRootFromParent_Done,
     /*  257385 */   // Label 4942: @257385
     /*  257385 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(257448), // Rule ID 5749 //
     /*  257390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  257404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257429 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257446 */     GIR_RootConstrainSelectedInstOperands,
     /*  257447 */     // GIR_Coverage, 5749,
     /*  257447 */     GIR_EraseRootFromParent_Done,
     /*  257448 */   // Label 4943: @257448
     /*  257448 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(257511), // Rule ID 5750 //
     /*  257453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  257464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  257467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257492 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  257492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257509 */     GIR_RootConstrainSelectedInstOperands,
     /*  257510 */     // GIR_Coverage, 5750,
     /*  257510 */     GIR_EraseRootFromParent_Done,
     /*  257511 */   // Label 4944: @257511
     /*  257511 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(257574), // Rule ID 5751 //
     /*  257516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  257527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  257530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257555 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257572 */     GIR_RootConstrainSelectedInstOperands,
     /*  257573 */     // GIR_Coverage, 5751,
     /*  257573 */     GIR_EraseRootFromParent_Done,
     /*  257574 */   // Label 4945: @257574
     /*  257574 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(257637), // Rule ID 5752 //
     /*  257579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  257593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257635 */     GIR_RootConstrainSelectedInstOperands,
     /*  257636 */     // GIR_Coverage, 5752,
     /*  257636 */     GIR_EraseRootFromParent_Done,
     /*  257637 */   // Label 4946: @257637
     /*  257637 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(257700), // Rule ID 5753 //
     /*  257642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  257656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257681 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257698 */     GIR_RootConstrainSelectedInstOperands,
     /*  257699 */     // GIR_Coverage, 5753,
     /*  257699 */     GIR_EraseRootFromParent_Done,
     /*  257700 */   // Label 4947: @257700
     /*  257700 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(257763), // Rule ID 5754 //
     /*  257705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  257719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257761 */     GIR_RootConstrainSelectedInstOperands,
     /*  257762 */     // GIR_Coverage, 5754,
     /*  257762 */     GIR_EraseRootFromParent_Done,
     /*  257763 */   // Label 4948: @257763
     /*  257763 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(257826), // Rule ID 5755 //
     /*  257768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  257782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257824 */     GIR_RootConstrainSelectedInstOperands,
     /*  257825 */     // GIR_Coverage, 5755,
     /*  257825 */     GIR_EraseRootFromParent_Done,
     /*  257826 */   // Label 4949: @257826
     /*  257826 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(257889), // Rule ID 5756 //
     /*  257831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  257845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257870 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257887 */     GIR_RootConstrainSelectedInstOperands,
     /*  257888 */     // GIR_Coverage, 5756,
     /*  257888 */     GIR_EraseRootFromParent_Done,
     /*  257889 */   // Label 4950: @257889
     /*  257889 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(257952), // Rule ID 5757 //
     /*  257894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  257908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257933 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257950 */     GIR_RootConstrainSelectedInstOperands,
     /*  257951 */     // GIR_Coverage, 5757,
     /*  257951 */     GIR_EraseRootFromParent_Done,
     /*  257952 */   // Label 4951: @257952
     /*  257952 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(258015), // Rule ID 5758 //
     /*  257957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  257971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258013 */     GIR_RootConstrainSelectedInstOperands,
     /*  258014 */     // GIR_Coverage, 5758,
     /*  258014 */     GIR_EraseRootFromParent_Done,
     /*  258015 */   // Label 4952: @258015
     /*  258015 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(258078), // Rule ID 5759 //
     /*  258020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  258034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258059 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258076 */     GIR_RootConstrainSelectedInstOperands,
     /*  258077 */     // GIR_Coverage, 5759,
     /*  258077 */     GIR_EraseRootFromParent_Done,
     /*  258078 */   // Label 4953: @258078
     /*  258078 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(258141), // Rule ID 5760 //
     /*  258083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258122 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258139 */     GIR_RootConstrainSelectedInstOperands,
     /*  258140 */     // GIR_Coverage, 5760,
     /*  258140 */     GIR_EraseRootFromParent_Done,
     /*  258141 */   // Label 4954: @258141
     /*  258141 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(258204), // Rule ID 5761 //
     /*  258146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  258160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258185 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258202 */     GIR_RootConstrainSelectedInstOperands,
     /*  258203 */     // GIR_Coverage, 5761,
     /*  258203 */     GIR_EraseRootFromParent_Done,
     /*  258204 */   // Label 4955: @258204
     /*  258204 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(258267), // Rule ID 5762 //
     /*  258209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  258223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258248 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258265 */     GIR_RootConstrainSelectedInstOperands,
     /*  258266 */     // GIR_Coverage, 5762,
     /*  258266 */     GIR_EraseRootFromParent_Done,
     /*  258267 */   // Label 4956: @258267
     /*  258267 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(258330), // Rule ID 5763 //
     /*  258272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  258283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  258286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258311 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258328 */     GIR_RootConstrainSelectedInstOperands,
     /*  258329 */     // GIR_Coverage, 5763,
     /*  258329 */     GIR_EraseRootFromParent_Done,
     /*  258330 */   // Label 4957: @258330
     /*  258330 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(258393), // Rule ID 5764 //
     /*  258335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  258349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258374 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258391 */     GIR_RootConstrainSelectedInstOperands,
     /*  258392 */     // GIR_Coverage, 5764,
     /*  258392 */     GIR_EraseRootFromParent_Done,
     /*  258393 */   // Label 4958: @258393
     /*  258393 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(258456), // Rule ID 5765 //
     /*  258398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  258412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  258426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258437 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11440:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  258440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258454 */     GIR_RootConstrainSelectedInstOperands,
     /*  258455 */     // GIR_Coverage, 5765,
     /*  258455 */     GIR_EraseRootFromParent_Done,
     /*  258456 */   // Label 4959: @258456
     /*  258456 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(258519), // Rule ID 5766 //
     /*  258461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  258475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258517 */     GIR_RootConstrainSelectedInstOperands,
     /*  258518 */     // GIR_Coverage, 5766,
     /*  258518 */     GIR_EraseRootFromParent_Done,
     /*  258519 */   // Label 4960: @258519
     /*  258519 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(258582), // Rule ID 5767 //
     /*  258524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  258538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11440:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258580 */     GIR_RootConstrainSelectedInstOperands,
     /*  258581 */     // GIR_Coverage, 5767,
     /*  258581 */     GIR_EraseRootFromParent_Done,
     /*  258582 */   // Label 4961: @258582
     /*  258582 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(258645), // Rule ID 5768 //
     /*  258587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  258601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258626 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258643 */     GIR_RootConstrainSelectedInstOperands,
     /*  258644 */     // GIR_Coverage, 5768,
     /*  258644 */     GIR_EraseRootFromParent_Done,
     /*  258645 */   // Label 4962: @258645
     /*  258645 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(258708), // Rule ID 5769 //
     /*  258650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  258664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258689 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11440:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258706 */     GIR_RootConstrainSelectedInstOperands,
     /*  258707 */     // GIR_Coverage, 5769,
     /*  258707 */     GIR_EraseRootFromParent_Done,
     /*  258708 */   // Label 4963: @258708
     /*  258708 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(258771), // Rule ID 7802 //
     /*  258713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  258727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  258730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258752 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  258755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258769 */     GIR_RootConstrainSelectedInstOperands,
     /*  258770 */     // GIR_Coverage, 7802,
     /*  258770 */     GIR_EraseRootFromParent_Done,
     /*  258771 */   // Label 4964: @258771
     /*  258771 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(258834), // Rule ID 7803 //
     /*  258776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  258790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  258793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258815 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  258818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258832 */     GIR_RootConstrainSelectedInstOperands,
     /*  258833 */     // GIR_Coverage, 7803,
     /*  258833 */     GIR_EraseRootFromParent_Done,
     /*  258834 */   // Label 4965: @258834
     /*  258834 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(258897), // Rule ID 7806 //
     /*  258839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  258853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  258856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258878 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258895 */     GIR_RootConstrainSelectedInstOperands,
     /*  258896 */     // GIR_Coverage, 7806,
     /*  258896 */     GIR_EraseRootFromParent_Done,
     /*  258897 */   // Label 4966: @258897
     /*  258897 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(258960), // Rule ID 7807 //
     /*  258902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  258916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  258919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258941 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258958 */     GIR_RootConstrainSelectedInstOperands,
     /*  258959 */     // GIR_Coverage, 7807,
     /*  258959 */     GIR_EraseRootFromParent_Done,
     /*  258960 */   // Label 4967: @258960
     /*  258960 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(259023), // Rule ID 7810 //
     /*  258965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  258979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  258982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259004 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259021 */     GIR_RootConstrainSelectedInstOperands,
     /*  259022 */     // GIR_Coverage, 7810,
     /*  259022 */     GIR_EraseRootFromParent_Done,
     /*  259023 */   // Label 4968: @259023
     /*  259023 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(259086), // Rule ID 7811 //
     /*  259028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  259042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  259045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259067 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  259070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259084 */     GIR_RootConstrainSelectedInstOperands,
     /*  259085 */     // GIR_Coverage, 7811,
     /*  259085 */     GIR_EraseRootFromParent_Done,
     /*  259086 */   // Label 4969: @259086
     /*  259086 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(259149), // Rule ID 7814 //
     /*  259091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  259108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259130 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259147 */     GIR_RootConstrainSelectedInstOperands,
     /*  259148 */     // GIR_Coverage, 7814,
     /*  259148 */     GIR_EraseRootFromParent_Done,
     /*  259149 */   // Label 4970: @259149
     /*  259149 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(259212), // Rule ID 7815 //
     /*  259154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  259168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  259171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259193 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259210 */     GIR_RootConstrainSelectedInstOperands,
     /*  259211 */     // GIR_Coverage, 7815,
     /*  259211 */     GIR_EraseRootFromParent_Done,
     /*  259212 */   // Label 4971: @259212
     /*  259212 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(259275), // Rule ID 7818 //
     /*  259217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  259231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259256 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259273 */     GIR_RootConstrainSelectedInstOperands,
     /*  259274 */     // GIR_Coverage, 7818,
     /*  259274 */     GIR_EraseRootFromParent_Done,
     /*  259275 */   // Label 4972: @259275
     /*  259275 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(259338), // Rule ID 7819 //
     /*  259280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  259294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  259297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259319 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  259322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259336 */     GIR_RootConstrainSelectedInstOperands,
     /*  259337 */     // GIR_Coverage, 7819,
     /*  259337 */     GIR_EraseRootFromParent_Done,
     /*  259338 */   // Label 4973: @259338
     /*  259338 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(259401), // Rule ID 7822 //
     /*  259343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  259360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259382 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259399 */     GIR_RootConstrainSelectedInstOperands,
     /*  259400 */     // GIR_Coverage, 7822,
     /*  259400 */     GIR_EraseRootFromParent_Done,
     /*  259401 */   // Label 4974: @259401
     /*  259401 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(259464), // Rule ID 7823 //
     /*  259406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  259420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  259423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259445 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259462 */     GIR_RootConstrainSelectedInstOperands,
     /*  259463 */     // GIR_Coverage, 7823,
     /*  259463 */     GIR_EraseRootFromParent_Done,
     /*  259464 */   // Label 4975: @259464
     /*  259464 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(259527), // Rule ID 7826 //
     /*  259469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  259483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  259486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259508 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259525 */     GIR_RootConstrainSelectedInstOperands,
     /*  259526 */     // GIR_Coverage, 7826,
     /*  259526 */     GIR_EraseRootFromParent_Done,
     /*  259527 */   // Label 4976: @259527
     /*  259527 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(259590), // Rule ID 7827 //
     /*  259532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  259546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  259549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259571 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259588 */     GIR_RootConstrainSelectedInstOperands,
     /*  259589 */     // GIR_Coverage, 7827,
     /*  259589 */     GIR_EraseRootFromParent_Done,
     /*  259590 */   // Label 4977: @259590
     /*  259590 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(259653), // Rule ID 7830 //
     /*  259595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  259609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  259612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259651 */     GIR_RootConstrainSelectedInstOperands,
     /*  259652 */     // GIR_Coverage, 7830,
     /*  259652 */     GIR_EraseRootFromParent_Done,
     /*  259653 */   // Label 4978: @259653
     /*  259653 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(259716), // Rule ID 7831 //
     /*  259658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  259672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  259675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259697 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259714 */     GIR_RootConstrainSelectedInstOperands,
     /*  259715 */     // GIR_Coverage, 7831,
     /*  259715 */     GIR_EraseRootFromParent_Done,
     /*  259716 */   // Label 4979: @259716
     /*  259716 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(259779), // Rule ID 7834 //
     /*  259721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  259735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  259738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259777 */     GIR_RootConstrainSelectedInstOperands,
     /*  259778 */     // GIR_Coverage, 7834,
     /*  259778 */     GIR_EraseRootFromParent_Done,
     /*  259779 */   // Label 4980: @259779
     /*  259779 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(259842), // Rule ID 7835 //
     /*  259784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  259798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  259801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259823 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259840 */     GIR_RootConstrainSelectedInstOperands,
     /*  259841 */     // GIR_Coverage, 7835,
     /*  259841 */     GIR_EraseRootFromParent_Done,
     /*  259842 */   // Label 4981: @259842
     /*  259842 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(259905), // Rule ID 7838 //
     /*  259847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  259861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  259864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259886 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  259889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259903 */     GIR_RootConstrainSelectedInstOperands,
     /*  259904 */     // GIR_Coverage, 7838,
     /*  259904 */     GIR_EraseRootFromParent_Done,
     /*  259905 */   // Label 4982: @259905
     /*  259905 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(259968), // Rule ID 7839 //
     /*  259910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  259924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  259927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259949 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  259952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259966 */     GIR_RootConstrainSelectedInstOperands,
     /*  259967 */     // GIR_Coverage, 7839,
     /*  259967 */     GIR_EraseRootFromParent_Done,
     /*  259968 */   // Label 4983: @259968
     /*  259968 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(260031), // Rule ID 7842 //
     /*  259973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  259984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  259987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  259990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260012 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260029 */     GIR_RootConstrainSelectedInstOperands,
     /*  260030 */     // GIR_Coverage, 7842,
     /*  260030 */     GIR_EraseRootFromParent_Done,
     /*  260031 */   // Label 4984: @260031
     /*  260031 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(260094), // Rule ID 7843 //
     /*  260036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  260050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  260053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260075 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260092 */     GIR_RootConstrainSelectedInstOperands,
     /*  260093 */     // GIR_Coverage, 7843,
     /*  260093 */     GIR_EraseRootFromParent_Done,
     /*  260094 */   // Label 4985: @260094
     /*  260094 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(260157), // Rule ID 7846 //
     /*  260099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  260110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  260113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  260116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260138 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260155 */     GIR_RootConstrainSelectedInstOperands,
     /*  260156 */     // GIR_Coverage, 7846,
     /*  260156 */     GIR_EraseRootFromParent_Done,
     /*  260157 */   // Label 4986: @260157
     /*  260157 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(260220), // Rule ID 7847 //
     /*  260162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  260173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  260176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  260179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260201 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260218 */     GIR_RootConstrainSelectedInstOperands,
     /*  260219 */     // GIR_Coverage, 7847,
     /*  260219 */     GIR_EraseRootFromParent_Done,
     /*  260220 */   // Label 4987: @260220
     /*  260220 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(260283), // Rule ID 7850 //
     /*  260225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  260239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  260242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260264 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260281 */     GIR_RootConstrainSelectedInstOperands,
     /*  260282 */     // GIR_Coverage, 7850,
     /*  260282 */     GIR_EraseRootFromParent_Done,
     /*  260283 */   // Label 4988: @260283
     /*  260283 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(260346), // Rule ID 7851 //
     /*  260288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  260302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  260305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260327 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260344 */     GIR_RootConstrainSelectedInstOperands,
     /*  260345 */     // GIR_Coverage, 7851,
     /*  260345 */     GIR_EraseRootFromParent_Done,
     /*  260346 */   // Label 4989: @260346
     /*  260346 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(260409), // Rule ID 7854 //
     /*  260351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  260368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260390 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260407 */     GIR_RootConstrainSelectedInstOperands,
     /*  260408 */     // GIR_Coverage, 7854,
     /*  260408 */     GIR_EraseRootFromParent_Done,
     /*  260409 */   // Label 4990: @260409
     /*  260409 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(260472), // Rule ID 7855 //
     /*  260414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  260428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  260431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260453 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260470 */     GIR_RootConstrainSelectedInstOperands,
     /*  260471 */     // GIR_Coverage, 7855,
     /*  260471 */     GIR_EraseRootFromParent_Done,
     /*  260472 */   // Label 4991: @260472
     /*  260472 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(260535), // Rule ID 7858 //
     /*  260477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  260491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  260494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260516 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260533 */     GIR_RootConstrainSelectedInstOperands,
     /*  260534 */     // GIR_Coverage, 7858,
     /*  260534 */     GIR_EraseRootFromParent_Done,
     /*  260535 */   // Label 4992: @260535
     /*  260535 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(260598), // Rule ID 7859 //
     /*  260540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  260554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  260557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260579 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260596 */     GIR_RootConstrainSelectedInstOperands,
     /*  260597 */     // GIR_Coverage, 7859,
     /*  260597 */     GIR_EraseRootFromParent_Done,
     /*  260598 */   // Label 4993: @260598
     /*  260598 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(260661), // Rule ID 7862 //
     /*  260603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  260617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  260620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260642 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260659 */     GIR_RootConstrainSelectedInstOperands,
     /*  260660 */     // GIR_Coverage, 7862,
     /*  260660 */     GIR_EraseRootFromParent_Done,
     /*  260661 */   // Label 4994: @260661
     /*  260661 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(260724), // Rule ID 7863 //
     /*  260666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  260680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  260683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260705 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260722 */     GIR_RootConstrainSelectedInstOperands,
     /*  260723 */     // GIR_Coverage, 7863,
     /*  260723 */     GIR_EraseRootFromParent_Done,
     /*  260724 */   // Label 4995: @260724
     /*  260724 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(260787), // Rule ID 7866 //
     /*  260729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  260743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  260746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260768 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260785 */     GIR_RootConstrainSelectedInstOperands,
     /*  260786 */     // GIR_Coverage, 7866,
     /*  260786 */     GIR_EraseRootFromParent_Done,
     /*  260787 */   // Label 4996: @260787
     /*  260787 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(260850), // Rule ID 7867 //
     /*  260792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  260806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  260809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260831 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260848 */     GIR_RootConstrainSelectedInstOperands,
     /*  260849 */     // GIR_Coverage, 7867,
     /*  260849 */     GIR_EraseRootFromParent_Done,
     /*  260850 */   // Label 4997: @260850
     /*  260850 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(260913), // Rule ID 7870 //
     /*  260855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  260869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  260872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260894 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260911 */     GIR_RootConstrainSelectedInstOperands,
     /*  260912 */     // GIR_Coverage, 7870,
     /*  260912 */     GIR_EraseRootFromParent_Done,
     /*  260913 */   // Label 4998: @260913
     /*  260913 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(260976), // Rule ID 7871 //
     /*  260918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  260932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  260935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260957 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260974 */     GIR_RootConstrainSelectedInstOperands,
     /*  260975 */     // GIR_Coverage, 7871,
     /*  260975 */     GIR_EraseRootFromParent_Done,
     /*  260976 */   // Label 4999: @260976
     /*  260976 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(261039), // Rule ID 7874 //
     /*  260981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  260984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  260995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  260998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261020 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261037 */     GIR_RootConstrainSelectedInstOperands,
     /*  261038 */     // GIR_Coverage, 7874,
     /*  261038 */     GIR_EraseRootFromParent_Done,
     /*  261039 */   // Label 5000: @261039
     /*  261039 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(261102), // Rule ID 7875 //
     /*  261044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  261058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  261061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  261076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261083 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  261086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261100 */     GIR_RootConstrainSelectedInstOperands,
     /*  261101 */     // GIR_Coverage, 7875,
     /*  261101 */     GIR_EraseRootFromParent_Done,
     /*  261102 */   // Label 5001: @261102
     /*  261102 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(261165), // Rule ID 7878 //
     /*  261107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  261121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261146 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261163 */     GIR_RootConstrainSelectedInstOperands,
     /*  261164 */     // GIR_Coverage, 7878,
     /*  261164 */     GIR_EraseRootFromParent_Done,
     /*  261165 */   // Label 5002: @261165
     /*  261165 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(261228), // Rule ID 7879 //
     /*  261170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  261184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  261187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  261202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261209 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  261212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261226 */     GIR_RootConstrainSelectedInstOperands,
     /*  261227 */     // GIR_Coverage, 7879,
     /*  261227 */     GIR_EraseRootFromParent_Done,
     /*  261228 */   // Label 5003: @261228
     /*  261228 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(261291), // Rule ID 7882 //
     /*  261233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  261247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261272 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  261272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261289 */     GIR_RootConstrainSelectedInstOperands,
     /*  261290 */     // GIR_Coverage, 7882,
     /*  261290 */     GIR_EraseRootFromParent_Done,
     /*  261291 */   // Label 5004: @261291
     /*  261291 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(261354), // Rule ID 7883 //
     /*  261296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  261299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  261310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  261313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  261328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261335 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  261335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  261338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  261352 */     GIR_RootConstrainSelectedInstOperands,
     /*  261353 */     // GIR_Coverage, 7883,
     /*  261353 */     GIR_EraseRootFromParent_Done,
     /*  261354 */   // Label 5005: @261354
     /*  261354 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(261417), // Rule ID 7886 //
     /*  261359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  261373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261398 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  261401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261415 */     GIR_RootConstrainSelectedInstOperands,
     /*  261416 */     // GIR_Coverage, 7886,
     /*  261416 */     GIR_EraseRootFromParent_Done,
     /*  261417 */   // Label 5006: @261417
     /*  261417 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(261480), // Rule ID 7887 //
     /*  261422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  261436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261461 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  261464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261478 */     GIR_RootConstrainSelectedInstOperands,
     /*  261479 */     // GIR_Coverage, 7887,
     /*  261479 */     GIR_EraseRootFromParent_Done,
     /*  261480 */   // Label 5007: @261480
     /*  261480 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(261543), // Rule ID 7890 //
     /*  261485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  261499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261524 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261541 */     GIR_RootConstrainSelectedInstOperands,
     /*  261542 */     // GIR_Coverage, 7890,
     /*  261542 */     GIR_EraseRootFromParent_Done,
     /*  261543 */   // Label 5008: @261543
     /*  261543 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(261606), // Rule ID 7891 //
     /*  261548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  261562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261587 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261604 */     GIR_RootConstrainSelectedInstOperands,
     /*  261605 */     // GIR_Coverage, 7891,
     /*  261605 */     GIR_EraseRootFromParent_Done,
     /*  261606 */   // Label 5009: @261606
     /*  261606 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(261669), // Rule ID 7894 //
     /*  261611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  261625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261667 */     GIR_RootConstrainSelectedInstOperands,
     /*  261668 */     // GIR_Coverage, 7894,
     /*  261668 */     GIR_EraseRootFromParent_Done,
     /*  261669 */   // Label 5010: @261669
     /*  261669 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(261732), // Rule ID 7895 //
     /*  261674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  261688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261713 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261730 */     GIR_RootConstrainSelectedInstOperands,
     /*  261731 */     // GIR_Coverage, 7895,
     /*  261731 */     GIR_EraseRootFromParent_Done,
     /*  261732 */   // Label 5011: @261732
     /*  261732 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(261795), // Rule ID 7898 //
     /*  261737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  261751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261776 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261793 */     GIR_RootConstrainSelectedInstOperands,
     /*  261794 */     // GIR_Coverage, 7898,
     /*  261794 */     GIR_EraseRootFromParent_Done,
     /*  261795 */   // Label 5012: @261795
     /*  261795 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(261858), // Rule ID 7899 //
     /*  261800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  261814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261839 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261856 */     GIR_RootConstrainSelectedInstOperands,
     /*  261857 */     // GIR_Coverage, 7899,
     /*  261857 */     GIR_EraseRootFromParent_Done,
     /*  261858 */   // Label 5013: @261858
     /*  261858 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(261921), // Rule ID 7902 //
     /*  261863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  261877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261902 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261919 */     GIR_RootConstrainSelectedInstOperands,
     /*  261920 */     // GIR_Coverage, 7902,
     /*  261920 */     GIR_EraseRootFromParent_Done,
     /*  261921 */   // Label 5014: @261921
     /*  261921 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(261984), // Rule ID 7903 //
     /*  261926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  261940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261965 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261982 */     GIR_RootConstrainSelectedInstOperands,
     /*  261983 */     // GIR_Coverage, 7903,
     /*  261983 */     GIR_EraseRootFromParent_Done,
     /*  261984 */   // Label 5015: @261984
     /*  261984 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(262047), // Rule ID 7906 //
     /*  261989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  262003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262045 */     GIR_RootConstrainSelectedInstOperands,
     /*  262046 */     // GIR_Coverage, 7906,
     /*  262046 */     GIR_EraseRootFromParent_Done,
     /*  262047 */   // Label 5016: @262047
     /*  262047 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(262110), // Rule ID 7907 //
     /*  262052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  262066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262091 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  262094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262108 */     GIR_RootConstrainSelectedInstOperands,
     /*  262109 */     // GIR_Coverage, 7907,
     /*  262109 */     GIR_EraseRootFromParent_Done,
     /*  262110 */   // Label 5017: @262110
     /*  262110 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(262173), // Rule ID 7910 //
     /*  262115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  262129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262154 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262171 */     GIR_RootConstrainSelectedInstOperands,
     /*  262172 */     // GIR_Coverage, 7910,
     /*  262172 */     GIR_EraseRootFromParent_Done,
     /*  262173 */   // Label 5018: @262173
     /*  262173 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(262236), // Rule ID 7911 //
     /*  262178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  262192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262217 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262234 */     GIR_RootConstrainSelectedInstOperands,
     /*  262235 */     // GIR_Coverage, 7911,
     /*  262235 */     GIR_EraseRootFromParent_Done,
     /*  262236 */   // Label 5019: @262236
     /*  262236 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(262299), // Rule ID 7914 //
     /*  262241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  262255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262280 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262297 */     GIR_RootConstrainSelectedInstOperands,
     /*  262298 */     // GIR_Coverage, 7914,
     /*  262298 */     GIR_EraseRootFromParent_Done,
     /*  262299 */   // Label 5020: @262299
     /*  262299 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(262362), // Rule ID 7915 //
     /*  262304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  262318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262343 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262360 */     GIR_RootConstrainSelectedInstOperands,
     /*  262361 */     // GIR_Coverage, 7915,
     /*  262361 */     GIR_EraseRootFromParent_Done,
     /*  262362 */   // Label 5021: @262362
     /*  262362 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(262425), // Rule ID 7918 //
     /*  262367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  262381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262423 */     GIR_RootConstrainSelectedInstOperands,
     /*  262424 */     // GIR_Coverage, 7918,
     /*  262424 */     GIR_EraseRootFromParent_Done,
     /*  262425 */   // Label 5022: @262425
     /*  262425 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(262488), // Rule ID 7919 //
     /*  262430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  262441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  262444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262469 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262486 */     GIR_RootConstrainSelectedInstOperands,
     /*  262487 */     // GIR_Coverage, 7919,
     /*  262487 */     GIR_EraseRootFromParent_Done,
     /*  262488 */   // Label 5023: @262488
     /*  262488 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(262551), // Rule ID 7922 //
     /*  262493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  262496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  262507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262549 */     GIR_RootConstrainSelectedInstOperands,
     /*  262550 */     // GIR_Coverage, 7922,
     /*  262550 */     GIR_EraseRootFromParent_Done,
     /*  262551 */   // Label 5024: @262551
     /*  262551 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(262614), // Rule ID 7923 //
     /*  262556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  262559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  262570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262595 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  262595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262612 */     GIR_RootConstrainSelectedInstOperands,
     /*  262613 */     // GIR_Coverage, 7923,
     /*  262613 */     GIR_EraseRootFromParent_Done,
     /*  262614 */   // Label 5025: @262614
     /*  262614 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(262677), // Rule ID 7926 //
     /*  262619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  262633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262658 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262675 */     GIR_RootConstrainSelectedInstOperands,
     /*  262676 */     // GIR_Coverage, 7926,
     /*  262676 */     GIR_EraseRootFromParent_Done,
     /*  262677 */   // Label 5026: @262677
     /*  262677 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(262740), // Rule ID 7927 //
     /*  262682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  262696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262721 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262738 */     GIR_RootConstrainSelectedInstOperands,
     /*  262739 */     // GIR_Coverage, 7927,
     /*  262739 */     GIR_EraseRootFromParent_Done,
     /*  262740 */   // Label 5027: @262740
     /*  262740 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(262803), // Rule ID 7930 //
     /*  262745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  262759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262784 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  262787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262801 */     GIR_RootConstrainSelectedInstOperands,
     /*  262802 */     // GIR_Coverage, 7930,
     /*  262802 */     GIR_EraseRootFromParent_Done,
     /*  262803 */   // Label 5028: @262803
     /*  262803 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(262866), // Rule ID 7931 //
     /*  262808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  262822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262847 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  262850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262864 */     GIR_RootConstrainSelectedInstOperands,
     /*  262865 */     // GIR_Coverage, 7931,
     /*  262865 */     GIR_EraseRootFromParent_Done,
     /*  262866 */   // Label 5029: @262866
     /*  262866 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(262929), // Rule ID 7934 //
     /*  262871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  262882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  262885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262910 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  262913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262927 */     GIR_RootConstrainSelectedInstOperands,
     /*  262928 */     // GIR_Coverage, 7934,
     /*  262928 */     GIR_EraseRootFromParent_Done,
     /*  262929 */   // Label 5030: @262929
     /*  262929 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(262992), // Rule ID 7935 //
     /*  262934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  262945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  262948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262973 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  262976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262990 */     GIR_RootConstrainSelectedInstOperands,
     /*  262991 */     // GIR_Coverage, 7935,
     /*  262991 */     GIR_EraseRootFromParent_Done,
     /*  262992 */   // Label 5031: @262992
     /*  262992 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(263055), // Rule ID 7938 //
     /*  262997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  263011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263036 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263053 */     GIR_RootConstrainSelectedInstOperands,
     /*  263054 */     // GIR_Coverage, 7938,
     /*  263054 */     GIR_EraseRootFromParent_Done,
     /*  263055 */   // Label 5032: @263055
     /*  263055 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(263118), // Rule ID 7939 //
     /*  263060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  263074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263099 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263116 */     GIR_RootConstrainSelectedInstOperands,
     /*  263117 */     // GIR_Coverage, 7939,
     /*  263117 */     GIR_EraseRootFromParent_Done,
     /*  263118 */   // Label 5033: @263118
     /*  263118 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(263181), // Rule ID 7942 //
     /*  263123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  263137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263162 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263179 */     GIR_RootConstrainSelectedInstOperands,
     /*  263180 */     // GIR_Coverage, 7942,
     /*  263180 */     GIR_EraseRootFromParent_Done,
     /*  263181 */   // Label 5034: @263181
     /*  263181 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(263244), // Rule ID 7943 //
     /*  263186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  263200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263225 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263242 */     GIR_RootConstrainSelectedInstOperands,
     /*  263243 */     // GIR_Coverage, 7943,
     /*  263243 */     GIR_EraseRootFromParent_Done,
     /*  263244 */   // Label 5035: @263244
     /*  263244 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(263307), // Rule ID 7946 //
     /*  263249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  263263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263288 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  263288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263305 */     GIR_RootConstrainSelectedInstOperands,
     /*  263306 */     // GIR_Coverage, 7946,
     /*  263306 */     GIR_EraseRootFromParent_Done,
     /*  263307 */   // Label 5036: @263307
     /*  263307 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(263370), // Rule ID 7947 //
     /*  263312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  263323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  263326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263351 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  263351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  263368 */     GIR_RootConstrainSelectedInstOperands,
     /*  263369 */     // GIR_Coverage, 7947,
     /*  263369 */     GIR_EraseRootFromParent_Done,
     /*  263370 */   // Label 5037: @263370
     /*  263370 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(263433), // Rule ID 7950 //
     /*  263375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  263389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263414 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263431 */     GIR_RootConstrainSelectedInstOperands,
     /*  263432 */     // GIR_Coverage, 7950,
     /*  263432 */     GIR_EraseRootFromParent_Done,
     /*  263433 */   // Label 5038: @263433
     /*  263433 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(263496), // Rule ID 7951 //
     /*  263438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  263452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263477 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263494 */     GIR_RootConstrainSelectedInstOperands,
     /*  263495 */     // GIR_Coverage, 7951,
     /*  263495 */     GIR_EraseRootFromParent_Done,
     /*  263496 */   // Label 5039: @263496
     /*  263496 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(263559), // Rule ID 7954 //
     /*  263501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  263515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263540 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263557 */     GIR_RootConstrainSelectedInstOperands,
     /*  263558 */     // GIR_Coverage, 7954,
     /*  263558 */     GIR_EraseRootFromParent_Done,
     /*  263559 */   // Label 5040: @263559
     /*  263559 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(263622), // Rule ID 7955 //
     /*  263564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  263578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263603 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263620 */     GIR_RootConstrainSelectedInstOperands,
     /*  263621 */     // GIR_Coverage, 7955,
     /*  263621 */     GIR_EraseRootFromParent_Done,
     /*  263622 */   // Label 5041: @263622
     /*  263622 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(263685), // Rule ID 7958 //
     /*  263627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  263641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263666 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263683 */     GIR_RootConstrainSelectedInstOperands,
     /*  263684 */     // GIR_Coverage, 7958,
     /*  263684 */     GIR_EraseRootFromParent_Done,
     /*  263685 */   // Label 5042: @263685
     /*  263685 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(263748), // Rule ID 7959 //
     /*  263690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  263704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263729 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263746 */     GIR_RootConstrainSelectedInstOperands,
     /*  263747 */     // GIR_Coverage, 7959,
     /*  263747 */     GIR_EraseRootFromParent_Done,
     /*  263748 */   // Label 5043: @263748
     /*  263748 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(263811), // Rule ID 7962 //
     /*  263753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  263756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  263767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263809 */     GIR_RootConstrainSelectedInstOperands,
     /*  263810 */     // GIR_Coverage, 7962,
     /*  263810 */     GIR_EraseRootFromParent_Done,
     /*  263811 */   // Label 5044: @263811
     /*  263811 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(263874), // Rule ID 7963 //
     /*  263816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  263830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263855 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263872 */     GIR_RootConstrainSelectedInstOperands,
     /*  263873 */     // GIR_Coverage, 7963,
     /*  263873 */     GIR_EraseRootFromParent_Done,
     /*  263874 */   // Label 5045: @263874
     /*  263874 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(263937), // Rule ID 7966 //
     /*  263879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  263882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  263893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263918 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263935 */     GIR_RootConstrainSelectedInstOperands,
     /*  263936 */     // GIR_Coverage, 7966,
     /*  263936 */     GIR_EraseRootFromParent_Done,
     /*  263937 */   // Label 5046: @263937
     /*  263937 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(264000), // Rule ID 7967 //
     /*  263942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  263956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263981 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263998 */     GIR_RootConstrainSelectedInstOperands,
     /*  263999 */     // GIR_Coverage, 7967,
     /*  263999 */     GIR_EraseRootFromParent_Done,
     /*  264000 */   // Label 5047: @264000
     /*  264000 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(264063), // Rule ID 7970 //
     /*  264005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  264019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  264022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264044 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264061 */     GIR_RootConstrainSelectedInstOperands,
     /*  264062 */     // GIR_Coverage, 7970,
     /*  264062 */     GIR_EraseRootFromParent_Done,
     /*  264063 */   // Label 5048: @264063
     /*  264063 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(264126), // Rule ID 7971 //
     /*  264068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  264076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  264082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  264085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  264096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  264100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264107 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  264110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264124 */     GIR_RootConstrainSelectedInstOperands,
     /*  264125 */     // GIR_Coverage, 7971,
     /*  264125 */     GIR_EraseRootFromParent_Done,
     /*  264126 */   // Label 5049: @264126
     /*  264126 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(264189), // Rule ID 8062 //
     /*  264131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  264145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  264148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264170 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  264173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264187 */     GIR_RootConstrainSelectedInstOperands,
     /*  264188 */     // GIR_Coverage, 8062,
     /*  264188 */     GIR_EraseRootFromParent_Done,
     /*  264189 */   // Label 5050: @264189
     /*  264189 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(264252), // Rule ID 8063 //
     /*  264194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  264208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  264211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264233 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  264236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264250 */     GIR_RootConstrainSelectedInstOperands,
     /*  264251 */     // GIR_Coverage, 8063,
     /*  264251 */     GIR_EraseRootFromParent_Done,
     /*  264252 */   // Label 5051: @264252
     /*  264252 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(264315), // Rule ID 8066 //
     /*  264257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  264271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  264274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264296 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264313 */     GIR_RootConstrainSelectedInstOperands,
     /*  264314 */     // GIR_Coverage, 8066,
     /*  264314 */     GIR_EraseRootFromParent_Done,
     /*  264315 */   // Label 5052: @264315
     /*  264315 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(264378), // Rule ID 8067 //
     /*  264320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  264334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  264337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264359 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264376 */     GIR_RootConstrainSelectedInstOperands,
     /*  264377 */     // GIR_Coverage, 8067,
     /*  264377 */     GIR_EraseRootFromParent_Done,
     /*  264378 */   // Label 5053: @264378
     /*  264378 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(264441), // Rule ID 8070 //
     /*  264383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  264397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  264400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264422 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264439 */     GIR_RootConstrainSelectedInstOperands,
     /*  264440 */     // GIR_Coverage, 8070,
     /*  264440 */     GIR_EraseRootFromParent_Done,
     /*  264441 */   // Label 5054: @264441
     /*  264441 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(264504), // Rule ID 8071 //
     /*  264446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  264460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  264463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264485 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264502 */     GIR_RootConstrainSelectedInstOperands,
     /*  264503 */     // GIR_Coverage, 8071,
     /*  264503 */     GIR_EraseRootFromParent_Done,
     /*  264504 */   // Label 5055: @264504
     /*  264504 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(264567), // Rule ID 8074 //
     /*  264509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  264523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  264526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264548 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264565 */     GIR_RootConstrainSelectedInstOperands,
     /*  264566 */     // GIR_Coverage, 8074,
     /*  264566 */     GIR_EraseRootFromParent_Done,
     /*  264567 */   // Label 5056: @264567
     /*  264567 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(264630), // Rule ID 8075 //
     /*  264572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  264586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  264589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264611 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264628 */     GIR_RootConstrainSelectedInstOperands,
     /*  264629 */     // GIR_Coverage, 8075,
     /*  264629 */     GIR_EraseRootFromParent_Done,
     /*  264630 */   // Label 5057: @264630
     /*  264630 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(264693), // Rule ID 8078 //
     /*  264635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  264649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  264652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264674 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264691 */     GIR_RootConstrainSelectedInstOperands,
     /*  264692 */     // GIR_Coverage, 8078,
     /*  264692 */     GIR_EraseRootFromParent_Done,
     /*  264693 */   // Label 5058: @264693
     /*  264693 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(264756), // Rule ID 8079 //
     /*  264698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  264712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  264715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264737 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264754 */     GIR_RootConstrainSelectedInstOperands,
     /*  264755 */     // GIR_Coverage, 8079,
     /*  264755 */     GIR_EraseRootFromParent_Done,
     /*  264756 */   // Label 5059: @264756
     /*  264756 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(264819), // Rule ID 8082 //
     /*  264761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  264775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  264778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264800 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264817 */     GIR_RootConstrainSelectedInstOperands,
     /*  264818 */     // GIR_Coverage, 8082,
     /*  264818 */     GIR_EraseRootFromParent_Done,
     /*  264819 */   // Label 5060: @264819
     /*  264819 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(264882), // Rule ID 8083 //
     /*  264824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  264838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  264841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264863 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264880 */     GIR_RootConstrainSelectedInstOperands,
     /*  264881 */     // GIR_Coverage, 8083,
     /*  264881 */     GIR_EraseRootFromParent_Done,
     /*  264882 */   // Label 5061: @264882
     /*  264882 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(264945), // Rule ID 8086 //
     /*  264887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  264901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  264904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264926 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264943 */     GIR_RootConstrainSelectedInstOperands,
     /*  264944 */     // GIR_Coverage, 8086,
     /*  264944 */     GIR_EraseRootFromParent_Done,
     /*  264945 */   // Label 5062: @264945
     /*  264945 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(265008), // Rule ID 8087 //
     /*  264950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  264964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  264967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264989 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265006 */     GIR_RootConstrainSelectedInstOperands,
     /*  265007 */     // GIR_Coverage, 8087,
     /*  265007 */     GIR_EraseRootFromParent_Done,
     /*  265008 */   // Label 5063: @265008
     /*  265008 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(265071), // Rule ID 8090 //
     /*  265013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  265027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  265030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265052 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265069 */     GIR_RootConstrainSelectedInstOperands,
     /*  265070 */     // GIR_Coverage, 8090,
     /*  265070 */     GIR_EraseRootFromParent_Done,
     /*  265071 */   // Label 5064: @265071
     /*  265071 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(265134), // Rule ID 8091 //
     /*  265076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  265090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  265093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265115 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265132 */     GIR_RootConstrainSelectedInstOperands,
     /*  265133 */     // GIR_Coverage, 8091,
     /*  265133 */     GIR_EraseRootFromParent_Done,
     /*  265134 */   // Label 5065: @265134
     /*  265134 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(265197), // Rule ID 8094 //
     /*  265139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  265153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  265156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265178 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265195 */     GIR_RootConstrainSelectedInstOperands,
     /*  265196 */     // GIR_Coverage, 8094,
     /*  265196 */     GIR_EraseRootFromParent_Done,
     /*  265197 */   // Label 5066: @265197
     /*  265197 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(265260), // Rule ID 8095 //
     /*  265202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  265213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  265216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  265219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265241 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265258 */     GIR_RootConstrainSelectedInstOperands,
     /*  265259 */     // GIR_Coverage, 8095,
     /*  265259 */     GIR_EraseRootFromParent_Done,
     /*  265260 */   // Label 5067: @265260
     /*  265260 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(265323), // Rule ID 8098 //
     /*  265265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  265268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  265279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  265282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265304 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  265304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265321 */     GIR_RootConstrainSelectedInstOperands,
     /*  265322 */     // GIR_Coverage, 8098,
     /*  265322 */     GIR_EraseRootFromParent_Done,
     /*  265323 */   // Label 5068: @265323
     /*  265323 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(265386), // Rule ID 8099 //
     /*  265328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  265331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  265339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  265342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  265345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265367 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  265367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  265370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  265384 */     GIR_RootConstrainSelectedInstOperands,
     /*  265385 */     // GIR_Coverage, 8099,
     /*  265385 */     GIR_EraseRootFromParent_Done,
     /*  265386 */   // Label 5069: @265386
     /*  265386 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(265449), // Rule ID 8102 //
     /*  265391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  265405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  265408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265430 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265447 */     GIR_RootConstrainSelectedInstOperands,
     /*  265448 */     // GIR_Coverage, 8102,
     /*  265448 */     GIR_EraseRootFromParent_Done,
     /*  265449 */   // Label 5070: @265449
     /*  265449 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(265512), // Rule ID 8103 //
     /*  265454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  265468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  265471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265493 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265510 */     GIR_RootConstrainSelectedInstOperands,
     /*  265511 */     // GIR_Coverage, 8103,
     /*  265511 */     GIR_EraseRootFromParent_Done,
     /*  265512 */   // Label 5071: @265512
     /*  265512 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(265575), // Rule ID 8106 //
     /*  265517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  265531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  265534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265556 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265573 */     GIR_RootConstrainSelectedInstOperands,
     /*  265574 */     // GIR_Coverage, 8106,
     /*  265574 */     GIR_EraseRootFromParent_Done,
     /*  265575 */   // Label 5072: @265575
     /*  265575 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(265638), // Rule ID 8107 //
     /*  265580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  265594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  265597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265619 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265636 */     GIR_RootConstrainSelectedInstOperands,
     /*  265637 */     // GIR_Coverage, 8107,
     /*  265637 */     GIR_EraseRootFromParent_Done,
     /*  265638 */   // Label 5073: @265638
     /*  265638 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(265701), // Rule ID 8110 //
     /*  265643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  265654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  265657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  265660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265682 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265699 */     GIR_RootConstrainSelectedInstOperands,
     /*  265700 */     // GIR_Coverage, 8110,
     /*  265700 */     GIR_EraseRootFromParent_Done,
     /*  265701 */   // Label 5074: @265701
     /*  265701 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(265764), // Rule ID 8111 //
     /*  265706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  265717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  265720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  265723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265745 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265762 */     GIR_RootConstrainSelectedInstOperands,
     /*  265763 */     // GIR_Coverage, 8111,
     /*  265763 */     GIR_EraseRootFromParent_Done,
     /*  265764 */   // Label 5075: @265764
     /*  265764 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(265827), // Rule ID 8114 //
     /*  265769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  265783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  265786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265825 */     GIR_RootConstrainSelectedInstOperands,
     /*  265826 */     // GIR_Coverage, 8114,
     /*  265826 */     GIR_EraseRootFromParent_Done,
     /*  265827 */   // Label 5076: @265827
     /*  265827 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(265890), // Rule ID 8115 //
     /*  265832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  265846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  265849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265871 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265888 */     GIR_RootConstrainSelectedInstOperands,
     /*  265889 */     // GIR_Coverage, 8115,
     /*  265889 */     GIR_EraseRootFromParent_Done,
     /*  265890 */   // Label 5077: @265890
     /*  265890 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(265953), // Rule ID 8118 //
     /*  265895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  265909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  265912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265934 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265951 */     GIR_RootConstrainSelectedInstOperands,
     /*  265952 */     // GIR_Coverage, 8118,
     /*  265952 */     GIR_EraseRootFromParent_Done,
     /*  265953 */   // Label 5078: @265953
     /*  265953 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(266016), // Rule ID 8119 //
     /*  265958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  265972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  265975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265997 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266014 */     GIR_RootConstrainSelectedInstOperands,
     /*  266015 */     // GIR_Coverage, 8119,
     /*  266015 */     GIR_EraseRootFromParent_Done,
     /*  266016 */   // Label 5079: @266016
     /*  266016 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(266079), // Rule ID 8122 //
     /*  266021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  266035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  266038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266060 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266077 */     GIR_RootConstrainSelectedInstOperands,
     /*  266078 */     // GIR_Coverage, 8122,
     /*  266078 */     GIR_EraseRootFromParent_Done,
     /*  266079 */   // Label 5080: @266079
     /*  266079 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(266142), // Rule ID 8123 //
     /*  266084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  266095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  266098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  266101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266123 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266140 */     GIR_RootConstrainSelectedInstOperands,
     /*  266141 */     // GIR_Coverage, 8123,
     /*  266141 */     GIR_EraseRootFromParent_Done,
     /*  266142 */   // Label 5081: @266142
     /*  266142 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(266205), // Rule ID 8126 //
     /*  266147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  266161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  266164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266186 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266203 */     GIR_RootConstrainSelectedInstOperands,
     /*  266204 */     // GIR_Coverage, 8126,
     /*  266204 */     GIR_EraseRootFromParent_Done,
     /*  266205 */   // Label 5082: @266205
     /*  266205 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(266268), // Rule ID 8127 //
     /*  266210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  266224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  266227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266249 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266266 */     GIR_RootConstrainSelectedInstOperands,
     /*  266267 */     // GIR_Coverage, 8127,
     /*  266267 */     GIR_EraseRootFromParent_Done,
     /*  266268 */   // Label 5083: @266268
     /*  266268 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(266331), // Rule ID 8130 //
     /*  266273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  266287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  266290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266312 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266329 */     GIR_RootConstrainSelectedInstOperands,
     /*  266330 */     // GIR_Coverage, 8130,
     /*  266330 */     GIR_EraseRootFromParent_Done,
     /*  266331 */   // Label 5084: @266331
     /*  266331 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(266394), // Rule ID 8131 //
     /*  266336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  266350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  266353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266375 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266392 */     GIR_RootConstrainSelectedInstOperands,
     /*  266393 */     // GIR_Coverage, 8131,
     /*  266393 */     GIR_EraseRootFromParent_Done,
     /*  266394 */   // Label 5085: @266394
     /*  266394 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(266457), // Rule ID 8134 //
     /*  266399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  266413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  266416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266438 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  266438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266455 */     GIR_RootConstrainSelectedInstOperands,
     /*  266456 */     // GIR_Coverage, 8134,
     /*  266456 */     GIR_EraseRootFromParent_Done,
     /*  266457 */   // Label 5086: @266457
     /*  266457 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(266520), // Rule ID 8135 //
     /*  266462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  266473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  266476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  266479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266501 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  266501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266518 */     GIR_RootConstrainSelectedInstOperands,
     /*  266519 */     // GIR_Coverage, 8135,
     /*  266519 */     GIR_EraseRootFromParent_Done,
     /*  266520 */   // Label 5087: @266520
     /*  266520 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(266583), // Rule ID 8138 //
     /*  266525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  266539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  266542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266564 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266581 */     GIR_RootConstrainSelectedInstOperands,
     /*  266582 */     // GIR_Coverage, 8138,
     /*  266582 */     GIR_EraseRootFromParent_Done,
     /*  266583 */   // Label 5088: @266583
     /*  266583 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(266646), // Rule ID 8139 //
     /*  266588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  266602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  266605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266627 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266644 */     GIR_RootConstrainSelectedInstOperands,
     /*  266645 */     // GIR_Coverage, 8139,
     /*  266645 */     GIR_EraseRootFromParent_Done,
     /*  266646 */   // Label 5089: @266646
     /*  266646 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(266709), // Rule ID 8142 //
     /*  266651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  266665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  266668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266690 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266707 */     GIR_RootConstrainSelectedInstOperands,
     /*  266708 */     // GIR_Coverage, 8142,
     /*  266708 */     GIR_EraseRootFromParent_Done,
     /*  266709 */   // Label 5090: @266709
     /*  266709 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(266772), // Rule ID 8143 //
     /*  266714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  266728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  266731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266770 */     GIR_RootConstrainSelectedInstOperands,
     /*  266771 */     // GIR_Coverage, 8143,
     /*  266771 */     GIR_EraseRootFromParent_Done,
     /*  266772 */   // Label 5091: @266772
     /*  266772 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(266835), // Rule ID 8146 //
     /*  266777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  266791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  266794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266833 */     GIR_RootConstrainSelectedInstOperands,
     /*  266834 */     // GIR_Coverage, 8146,
     /*  266834 */     GIR_EraseRootFromParent_Done,
     /*  266835 */   // Label 5092: @266835
     /*  266835 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(266898), // Rule ID 8147 //
     /*  266840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  266854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  266857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266879 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266896 */     GIR_RootConstrainSelectedInstOperands,
     /*  266897 */     // GIR_Coverage, 8147,
     /*  266897 */     GIR_EraseRootFromParent_Done,
     /*  266898 */   // Label 5093: @266898
     /*  266898 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(266961), // Rule ID 8150 //
     /*  266903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  266917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266942 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  266945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266959 */     GIR_RootConstrainSelectedInstOperands,
     /*  266960 */     // GIR_Coverage, 8150,
     /*  266960 */     GIR_EraseRootFromParent_Done,
     /*  266961 */   // Label 5094: @266961
     /*  266961 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(267024), // Rule ID 8151 //
     /*  266966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  266980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267005 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  267008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267022 */     GIR_RootConstrainSelectedInstOperands,
     /*  267023 */     // GIR_Coverage, 8151,
     /*  267023 */     GIR_EraseRootFromParent_Done,
     /*  267024 */   // Label 5095: @267024
     /*  267024 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(267087), // Rule ID 8154 //
     /*  267029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  267043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267068 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267085 */     GIR_RootConstrainSelectedInstOperands,
     /*  267086 */     // GIR_Coverage, 8154,
     /*  267086 */     GIR_EraseRootFromParent_Done,
     /*  267087 */   // Label 5096: @267087
     /*  267087 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(267150), // Rule ID 8155 //
     /*  267092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  267106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267131 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267148 */     GIR_RootConstrainSelectedInstOperands,
     /*  267149 */     // GIR_Coverage, 8155,
     /*  267149 */     GIR_EraseRootFromParent_Done,
     /*  267150 */   // Label 5097: @267150
     /*  267150 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(267213), // Rule ID 8158 //
     /*  267155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  267169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267194 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267211 */     GIR_RootConstrainSelectedInstOperands,
     /*  267212 */     // GIR_Coverage, 8158,
     /*  267212 */     GIR_EraseRootFromParent_Done,
     /*  267213 */   // Label 5098: @267213
     /*  267213 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(267276), // Rule ID 8159 //
     /*  267218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  267232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267257 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267274 */     GIR_RootConstrainSelectedInstOperands,
     /*  267275 */     // GIR_Coverage, 8159,
     /*  267275 */     GIR_EraseRootFromParent_Done,
     /*  267276 */   // Label 5099: @267276
     /*  267276 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(267339), // Rule ID 8162 //
     /*  267281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  267295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267320 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267337 */     GIR_RootConstrainSelectedInstOperands,
     /*  267338 */     // GIR_Coverage, 8162,
     /*  267338 */     GIR_EraseRootFromParent_Done,
     /*  267339 */   // Label 5100: @267339
     /*  267339 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(267402), // Rule ID 8163 //
     /*  267344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  267358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267383 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  267386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267400 */     GIR_RootConstrainSelectedInstOperands,
     /*  267401 */     // GIR_Coverage, 8163,
     /*  267401 */     GIR_EraseRootFromParent_Done,
     /*  267402 */   // Label 5101: @267402
     /*  267402 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(267465), // Rule ID 8166 //
     /*  267407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  267421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267463 */     GIR_RootConstrainSelectedInstOperands,
     /*  267464 */     // GIR_Coverage, 8166,
     /*  267464 */     GIR_EraseRootFromParent_Done,
     /*  267465 */   // Label 5102: @267465
     /*  267465 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(267528), // Rule ID 8167 //
     /*  267470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  267484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267526 */     GIR_RootConstrainSelectedInstOperands,
     /*  267527 */     // GIR_Coverage, 8167,
     /*  267527 */     GIR_EraseRootFromParent_Done,
     /*  267528 */   // Label 5103: @267528
     /*  267528 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(267591), // Rule ID 8170 //
     /*  267533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  267547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267572 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267589 */     GIR_RootConstrainSelectedInstOperands,
     /*  267590 */     // GIR_Coverage, 8170,
     /*  267590 */     GIR_EraseRootFromParent_Done,
     /*  267591 */   // Label 5104: @267591
     /*  267591 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(267654), // Rule ID 8171 //
     /*  267596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  267610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267635 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267652 */     GIR_RootConstrainSelectedInstOperands,
     /*  267653 */     // GIR_Coverage, 8171,
     /*  267653 */     GIR_EraseRootFromParent_Done,
     /*  267654 */   // Label 5105: @267654
     /*  267654 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(267717), // Rule ID 8174 //
     /*  267659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  267673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267698 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267715 */     GIR_RootConstrainSelectedInstOperands,
     /*  267716 */     // GIR_Coverage, 8174,
     /*  267716 */     GIR_EraseRootFromParent_Done,
     /*  267717 */   // Label 5106: @267717
     /*  267717 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(267780), // Rule ID 8175 //
     /*  267722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  267736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267761 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267778 */     GIR_RootConstrainSelectedInstOperands,
     /*  267779 */     // GIR_Coverage, 8175,
     /*  267779 */     GIR_EraseRootFromParent_Done,
     /*  267780 */   // Label 5107: @267780
     /*  267780 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(267843), // Rule ID 8178 //
     /*  267785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  267799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267841 */     GIR_RootConstrainSelectedInstOperands,
     /*  267842 */     // GIR_Coverage, 8178,
     /*  267842 */     GIR_EraseRootFromParent_Done,
     /*  267843 */   // Label 5108: @267843
     /*  267843 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(267906), // Rule ID 8179 //
     /*  267848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  267862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267887 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267904 */     GIR_RootConstrainSelectedInstOperands,
     /*  267905 */     // GIR_Coverage, 8179,
     /*  267905 */     GIR_EraseRootFromParent_Done,
     /*  267906 */   // Label 5109: @267906
     /*  267906 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(267969), // Rule ID 8182 //
     /*  267911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  267925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267967 */     GIR_RootConstrainSelectedInstOperands,
     /*  267968 */     // GIR_Coverage, 8182,
     /*  267968 */     GIR_EraseRootFromParent_Done,
     /*  267969 */   // Label 5110: @267969
     /*  267969 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(268032), // Rule ID 8183 //
     /*  267974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  267988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268013 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268030 */     GIR_RootConstrainSelectedInstOperands,
     /*  268031 */     // GIR_Coverage, 8183,
     /*  268031 */     GIR_EraseRootFromParent_Done,
     /*  268032 */   // Label 5111: @268032
     /*  268032 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(268095), // Rule ID 8186 //
     /*  268037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  268040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  268051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268076 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  268076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268093 */     GIR_RootConstrainSelectedInstOperands,
     /*  268094 */     // GIR_Coverage, 8186,
     /*  268094 */     GIR_EraseRootFromParent_Done,
     /*  268095 */   // Label 5112: @268095
     /*  268095 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(268158), // Rule ID 8187 //
     /*  268100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  268103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  268111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  268114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268139 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  268139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  268142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268156 */     GIR_RootConstrainSelectedInstOperands,
     /*  268157 */     // GIR_Coverage, 8187,
     /*  268157 */     GIR_EraseRootFromParent_Done,
     /*  268158 */   // Label 5113: @268158
     /*  268158 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(268221), // Rule ID 8190 //
     /*  268163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  268177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268202 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268219 */     GIR_RootConstrainSelectedInstOperands,
     /*  268220 */     // GIR_Coverage, 8190,
     /*  268220 */     GIR_EraseRootFromParent_Done,
     /*  268221 */   // Label 5114: @268221
     /*  268221 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(268284), // Rule ID 8191 //
     /*  268226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  268240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268265 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268282 */     GIR_RootConstrainSelectedInstOperands,
     /*  268283 */     // GIR_Coverage, 8191,
     /*  268283 */     GIR_EraseRootFromParent_Done,
     /*  268284 */   // Label 5115: @268284
     /*  268284 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(268347), // Rule ID 8194 //
     /*  268289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  268303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268328 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268345 */     GIR_RootConstrainSelectedInstOperands,
     /*  268346 */     // GIR_Coverage, 8194,
     /*  268346 */     GIR_EraseRootFromParent_Done,
     /*  268347 */   // Label 5116: @268347
     /*  268347 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(268410), // Rule ID 8195 //
     /*  268352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  268366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268391 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268408 */     GIR_RootConstrainSelectedInstOperands,
     /*  268409 */     // GIR_Coverage, 8195,
     /*  268409 */     GIR_EraseRootFromParent_Done,
     /*  268410 */   // Label 5117: @268410
     /*  268410 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(268473), // Rule ID 8198 //
     /*  268415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  268429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268454 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  268454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268471 */     GIR_RootConstrainSelectedInstOperands,
     /*  268472 */     // GIR_Coverage, 8198,
     /*  268472 */     GIR_EraseRootFromParent_Done,
     /*  268473 */   // Label 5118: @268473
     /*  268473 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(268536), // Rule ID 8199 //
     /*  268478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  268489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  268492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268517 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268534 */     GIR_RootConstrainSelectedInstOperands,
     /*  268535 */     // GIR_Coverage, 8199,
     /*  268535 */     GIR_EraseRootFromParent_Done,
     /*  268536 */   // Label 5119: @268536
     /*  268536 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(268599), // Rule ID 8202 //
     /*  268541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  268555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268597 */     GIR_RootConstrainSelectedInstOperands,
     /*  268598 */     // GIR_Coverage, 8202,
     /*  268598 */     GIR_EraseRootFromParent_Done,
     /*  268599 */   // Label 5120: @268599
     /*  268599 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(268662), // Rule ID 8203 //
     /*  268604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  268618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268643 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268660 */     GIR_RootConstrainSelectedInstOperands,
     /*  268661 */     // GIR_Coverage, 8203,
     /*  268661 */     GIR_EraseRootFromParent_Done,
     /*  268662 */   // Label 5121: @268662
     /*  268662 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(268725), // Rule ID 8206 //
     /*  268667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  268681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268706 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268723 */     GIR_RootConstrainSelectedInstOperands,
     /*  268724 */     // GIR_Coverage, 8206,
     /*  268724 */     GIR_EraseRootFromParent_Done,
     /*  268725 */   // Label 5122: @268725
     /*  268725 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(268788), // Rule ID 8207 //
     /*  268730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  268744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268769 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268786 */     GIR_RootConstrainSelectedInstOperands,
     /*  268787 */     // GIR_Coverage, 8207,
     /*  268787 */     GIR_EraseRootFromParent_Done,
     /*  268788 */   // Label 5123: @268788
     /*  268788 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(268851), // Rule ID 8210 //
     /*  268793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  268807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268832 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268849 */     GIR_RootConstrainSelectedInstOperands,
     /*  268850 */     // GIR_Coverage, 8210,
     /*  268850 */     GIR_EraseRootFromParent_Done,
     /*  268851 */   // Label 5124: @268851
     /*  268851 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(268914), // Rule ID 8211 //
     /*  268856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  268870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268895 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268912 */     GIR_RootConstrainSelectedInstOperands,
     /*  268913 */     // GIR_Coverage, 8211,
     /*  268913 */     GIR_EraseRootFromParent_Done,
     /*  268914 */   // Label 5125: @268914
     /*  268914 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(268977), // Rule ID 8214 //
     /*  268919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  268933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268958 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268975 */     GIR_RootConstrainSelectedInstOperands,
     /*  268976 */     // GIR_Coverage, 8214,
     /*  268976 */     GIR_EraseRootFromParent_Done,
     /*  268977 */   // Label 5126: @268977
     /*  268977 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(269040), // Rule ID 8215 //
     /*  268982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  268996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269021 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269038 */     GIR_RootConstrainSelectedInstOperands,
     /*  269039 */     // GIR_Coverage, 8215,
     /*  269039 */     GIR_EraseRootFromParent_Done,
     /*  269040 */   // Label 5127: @269040
     /*  269040 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(269103), // Rule ID 8218 //
     /*  269045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  269059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269084 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269101 */     GIR_RootConstrainSelectedInstOperands,
     /*  269102 */     // GIR_Coverage, 8218,
     /*  269102 */     GIR_EraseRootFromParent_Done,
     /*  269103 */   // Label 5128: @269103
     /*  269103 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(269166), // Rule ID 8219 //
     /*  269108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  269122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269147 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269164 */     GIR_RootConstrainSelectedInstOperands,
     /*  269165 */     // GIR_Coverage, 8219,
     /*  269165 */     GIR_EraseRootFromParent_Done,
     /*  269166 */   // Label 5129: @269166
     /*  269166 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(269229), // Rule ID 8222 //
     /*  269171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  269185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269210 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269227 */     GIR_RootConstrainSelectedInstOperands,
     /*  269228 */     // GIR_Coverage, 8222,
     /*  269228 */     GIR_EraseRootFromParent_Done,
     /*  269229 */   // Label 5130: @269229
     /*  269229 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(269292), // Rule ID 8223 //
     /*  269234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  269245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  269248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269273 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269290 */     GIR_RootConstrainSelectedInstOperands,
     /*  269291 */     // GIR_Coverage, 8223,
     /*  269291 */     GIR_EraseRootFromParent_Done,
     /*  269292 */   // Label 5131: @269292
     /*  269292 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(269355), // Rule ID 8226 //
     /*  269297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  269311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269336 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269353 */     GIR_RootConstrainSelectedInstOperands,
     /*  269354 */     // GIR_Coverage, 8226,
     /*  269354 */     GIR_EraseRootFromParent_Done,
     /*  269355 */   // Label 5132: @269355
     /*  269355 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(269418), // Rule ID 8227 //
     /*  269360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  269374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  269388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269399 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  269402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269416 */     GIR_RootConstrainSelectedInstOperands,
     /*  269417 */     // GIR_Coverage, 8227,
     /*  269417 */     GIR_EraseRootFromParent_Done,
     /*  269418 */   // Label 5133: @269418
     /*  269418 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(269481), // Rule ID 8230 //
     /*  269423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  269437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269462 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269479 */     GIR_RootConstrainSelectedInstOperands,
     /*  269480 */     // GIR_Coverage, 8230,
     /*  269480 */     GIR_EraseRootFromParent_Done,
     /*  269481 */   // Label 5134: @269481
     /*  269481 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(269544), // Rule ID 8231 //
     /*  269486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  269500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269525 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269542 */     GIR_RootConstrainSelectedInstOperands,
     /*  269543 */     // GIR_Coverage, 8231,
     /*  269543 */     GIR_EraseRootFromParent_Done,
     /*  269544 */   // Label 5135: @269544
     /*  269544 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(269607), // Rule ID 8234 //
     /*  269549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  269563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269588 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269605 */     GIR_RootConstrainSelectedInstOperands,
     /*  269606 */     // GIR_Coverage, 8234,
     /*  269606 */     GIR_EraseRootFromParent_Done,
     /*  269607 */   // Label 5136: @269607
     /*  269607 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(269670), // Rule ID 8235 //
     /*  269612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  269626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269651 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269668 */     GIR_RootConstrainSelectedInstOperands,
     /*  269669 */     // GIR_Coverage, 8235,
     /*  269669 */     GIR_EraseRootFromParent_Done,
     /*  269670 */   // Label 5137: @269670
     /*  269670 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(269733), // Rule ID 8326 //
     /*  269675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  269689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  269692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269714 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  269717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269731 */     GIR_RootConstrainSelectedInstOperands,
     /*  269732 */     // GIR_Coverage, 8326,
     /*  269732 */     GIR_EraseRootFromParent_Done,
     /*  269733 */   // Label 5138: @269733
     /*  269733 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(269796), // Rule ID 8327 //
     /*  269738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  269752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  269755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269777 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  269780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269794 */     GIR_RootConstrainSelectedInstOperands,
     /*  269795 */     // GIR_Coverage, 8327,
     /*  269795 */     GIR_EraseRootFromParent_Done,
     /*  269796 */   // Label 5139: @269796
     /*  269796 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(269859), // Rule ID 8330 //
     /*  269801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  269815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  269818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269840 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  269843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269857 */     GIR_RootConstrainSelectedInstOperands,
     /*  269858 */     // GIR_Coverage, 8330,
     /*  269858 */     GIR_EraseRootFromParent_Done,
     /*  269859 */   // Label 5140: @269859
     /*  269859 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(269922), // Rule ID 8331 //
     /*  269864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  269878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  269881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269903 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  269906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269920 */     GIR_RootConstrainSelectedInstOperands,
     /*  269921 */     // GIR_Coverage, 8331,
     /*  269921 */     GIR_EraseRootFromParent_Done,
     /*  269922 */   // Label 5141: @269922
     /*  269922 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(269985), // Rule ID 8334 //
     /*  269927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  269941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  269944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269966 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  269969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269983 */     GIR_RootConstrainSelectedInstOperands,
     /*  269984 */     // GIR_Coverage, 8334,
     /*  269984 */     GIR_EraseRootFromParent_Done,
     /*  269985 */   // Label 5142: @269985
     /*  269985 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(270048), // Rule ID 8335 //
     /*  269990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  270004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  270007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270029 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270046 */     GIR_RootConstrainSelectedInstOperands,
     /*  270047 */     // GIR_Coverage, 8335,
     /*  270047 */     GIR_EraseRootFromParent_Done,
     /*  270048 */   // Label 5143: @270048
     /*  270048 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(270111), // Rule ID 8338 //
     /*  270053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  270070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270092 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270109 */     GIR_RootConstrainSelectedInstOperands,
     /*  270110 */     // GIR_Coverage, 8338,
     /*  270110 */     GIR_EraseRootFromParent_Done,
     /*  270111 */   // Label 5144: @270111
     /*  270111 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(270174), // Rule ID 8339 //
     /*  270116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  270130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  270133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270155 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  270158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270172 */     GIR_RootConstrainSelectedInstOperands,
     /*  270173 */     // GIR_Coverage, 8339,
     /*  270173 */     GIR_EraseRootFromParent_Done,
     /*  270174 */   // Label 5145: @270174
     /*  270174 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(270237), // Rule ID 8342 //
     /*  270179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  270196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270218 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270235 */     GIR_RootConstrainSelectedInstOperands,
     /*  270236 */     // GIR_Coverage, 8342,
     /*  270236 */     GIR_EraseRootFromParent_Done,
     /*  270237 */   // Label 5146: @270237
     /*  270237 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(270300), // Rule ID 8343 //
     /*  270242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  270256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  270259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270281 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270298 */     GIR_RootConstrainSelectedInstOperands,
     /*  270299 */     // GIR_Coverage, 8343,
     /*  270299 */     GIR_EraseRootFromParent_Done,
     /*  270300 */   // Label 5147: @270300
     /*  270300 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(270363), // Rule ID 8346 //
     /*  270305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  270319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  270322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270361 */     GIR_RootConstrainSelectedInstOperands,
     /*  270362 */     // GIR_Coverage, 8346,
     /*  270362 */     GIR_EraseRootFromParent_Done,
     /*  270363 */   // Label 5148: @270363
     /*  270363 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(270426), // Rule ID 8347 //
     /*  270368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  270382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  270385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270407 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  270410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270424 */     GIR_RootConstrainSelectedInstOperands,
     /*  270425 */     // GIR_Coverage, 8347,
     /*  270425 */     GIR_EraseRootFromParent_Done,
     /*  270426 */   // Label 5149: @270426
     /*  270426 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(270489), // Rule ID 8350 //
     /*  270431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  270445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  270448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270487 */     GIR_RootConstrainSelectedInstOperands,
     /*  270488 */     // GIR_Coverage, 8350,
     /*  270488 */     GIR_EraseRootFromParent_Done,
     /*  270489 */   // Label 5150: @270489
     /*  270489 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(270552), // Rule ID 8351 //
     /*  270494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  270508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  270511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270533 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270550 */     GIR_RootConstrainSelectedInstOperands,
     /*  270551 */     // GIR_Coverage, 8351,
     /*  270551 */     GIR_EraseRootFromParent_Done,
     /*  270552 */   // Label 5151: @270552
     /*  270552 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(270615), // Rule ID 8354 //
     /*  270557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  270571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  270574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270613 */     GIR_RootConstrainSelectedInstOperands,
     /*  270614 */     // GIR_Coverage, 8354,
     /*  270614 */     GIR_EraseRootFromParent_Done,
     /*  270615 */   // Label 5152: @270615
     /*  270615 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(270678), // Rule ID 8355 //
     /*  270620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  270634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  270637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270659 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270676 */     GIR_RootConstrainSelectedInstOperands,
     /*  270677 */     // GIR_Coverage, 8355,
     /*  270677 */     GIR_EraseRootFromParent_Done,
     /*  270678 */   // Label 5153: @270678
     /*  270678 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(270741), // Rule ID 8358 //
     /*  270683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  270697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  270700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270722 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270739 */     GIR_RootConstrainSelectedInstOperands,
     /*  270740 */     // GIR_Coverage, 8358,
     /*  270740 */     GIR_EraseRootFromParent_Done,
     /*  270741 */   // Label 5154: @270741
     /*  270741 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(270804), // Rule ID 8359 //
     /*  270746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  270760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  270763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270785 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270802 */     GIR_RootConstrainSelectedInstOperands,
     /*  270803 */     // GIR_Coverage, 8359,
     /*  270803 */     GIR_EraseRootFromParent_Done,
     /*  270804 */   // Label 5155: @270804
     /*  270804 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(270867), // Rule ID 8362 //
     /*  270809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  270823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  270826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270848 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270865 */     GIR_RootConstrainSelectedInstOperands,
     /*  270866 */     // GIR_Coverage, 8362,
     /*  270866 */     GIR_EraseRootFromParent_Done,
     /*  270867 */   // Label 5156: @270867
     /*  270867 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(270930), // Rule ID 8363 //
     /*  270872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  270886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  270889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270911 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270928 */     GIR_RootConstrainSelectedInstOperands,
     /*  270929 */     // GIR_Coverage, 8363,
     /*  270929 */     GIR_EraseRootFromParent_Done,
     /*  270930 */   // Label 5157: @270930
     /*  270930 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(270993), // Rule ID 8366 //
     /*  270935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  270946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  270949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  270952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270974 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  270977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270991 */     GIR_RootConstrainSelectedInstOperands,
     /*  270992 */     // GIR_Coverage, 8366,
     /*  270992 */     GIR_EraseRootFromParent_Done,
     /*  270993 */   // Label 5158: @270993
     /*  270993 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(271056), // Rule ID 8367 //
     /*  270998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  271012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  271015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271037 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271054 */     GIR_RootConstrainSelectedInstOperands,
     /*  271055 */     // GIR_Coverage, 8367,
     /*  271055 */     GIR_EraseRootFromParent_Done,
     /*  271056 */   // Label 5159: @271056
     /*  271056 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(271119), // Rule ID 8370 //
     /*  271061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  271078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271100 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271117 */     GIR_RootConstrainSelectedInstOperands,
     /*  271118 */     // GIR_Coverage, 8370,
     /*  271118 */     GIR_EraseRootFromParent_Done,
     /*  271119 */   // Label 5160: @271119
     /*  271119 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(271182), // Rule ID 8371 //
     /*  271124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  271138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  271141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271163 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271180 */     GIR_RootConstrainSelectedInstOperands,
     /*  271181 */     // GIR_Coverage, 8371,
     /*  271181 */     GIR_EraseRootFromParent_Done,
     /*  271182 */   // Label 5161: @271182
     /*  271182 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(271245), // Rule ID 8374 //
     /*  271187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  271198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  271204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271226 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271243 */     GIR_RootConstrainSelectedInstOperands,
     /*  271244 */     // GIR_Coverage, 8374,
     /*  271244 */     GIR_EraseRootFromParent_Done,
     /*  271245 */   // Label 5162: @271245
     /*  271245 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(271308), // Rule ID 8375 //
     /*  271250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  271261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  271264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  271267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271289 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  271289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271306 */     GIR_RootConstrainSelectedInstOperands,
     /*  271307 */     // GIR_Coverage, 8375,
     /*  271307 */     GIR_EraseRootFromParent_Done,
     /*  271308 */   // Label 5163: @271308
     /*  271308 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(271371), // Rule ID 8378 //
     /*  271313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  271327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  271330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271352 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271369 */     GIR_RootConstrainSelectedInstOperands,
     /*  271370 */     // GIR_Coverage, 8378,
     /*  271370 */     GIR_EraseRootFromParent_Done,
     /*  271371 */   // Label 5164: @271371
     /*  271371 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(271434), // Rule ID 8379 //
     /*  271376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  271390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  271393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271415 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271432 */     GIR_RootConstrainSelectedInstOperands,
     /*  271433 */     // GIR_Coverage, 8379,
     /*  271433 */     GIR_EraseRootFromParent_Done,
     /*  271434 */   // Label 5165: @271434
     /*  271434 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(271497), // Rule ID 8382 //
     /*  271439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  271453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  271456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271478 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271495 */     GIR_RootConstrainSelectedInstOperands,
     /*  271496 */     // GIR_Coverage, 8382,
     /*  271496 */     GIR_EraseRootFromParent_Done,
     /*  271497 */   // Label 5166: @271497
     /*  271497 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(271560), // Rule ID 8383 //
     /*  271502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  271516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  271519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271541 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271558 */     GIR_RootConstrainSelectedInstOperands,
     /*  271559 */     // GIR_Coverage, 8383,
     /*  271559 */     GIR_EraseRootFromParent_Done,
     /*  271560 */   // Label 5167: @271560
     /*  271560 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(271623), // Rule ID 8386 //
     /*  271565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  271579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  271582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271604 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271621 */     GIR_RootConstrainSelectedInstOperands,
     /*  271622 */     // GIR_Coverage, 8386,
     /*  271622 */     GIR_EraseRootFromParent_Done,
     /*  271623 */   // Label 5168: @271623
     /*  271623 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(271686), // Rule ID 8387 //
     /*  271628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  271642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  271645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271667 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271684 */     GIR_RootConstrainSelectedInstOperands,
     /*  271685 */     // GIR_Coverage, 8387,
     /*  271685 */     GIR_EraseRootFromParent_Done,
     /*  271686 */   // Label 5169: @271686
     /*  271686 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(271749), // Rule ID 8390 //
     /*  271691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  271705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  271708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271747 */     GIR_RootConstrainSelectedInstOperands,
     /*  271748 */     // GIR_Coverage, 8390,
     /*  271748 */     GIR_EraseRootFromParent_Done,
     /*  271749 */   // Label 5170: @271749
     /*  271749 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(271812), // Rule ID 8391 //
     /*  271754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  271768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  271771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271793 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271810 */     GIR_RootConstrainSelectedInstOperands,
     /*  271811 */     // GIR_Coverage, 8391,
     /*  271811 */     GIR_EraseRootFromParent_Done,
     /*  271812 */   // Label 5171: @271812
     /*  271812 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(271875), // Rule ID 8394 //
     /*  271817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  271831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  271834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271856 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271873 */     GIR_RootConstrainSelectedInstOperands,
     /*  271874 */     // GIR_Coverage, 8394,
     /*  271874 */     GIR_EraseRootFromParent_Done,
     /*  271875 */   // Label 5172: @271875
     /*  271875 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(271938), // Rule ID 8395 //
     /*  271880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  271894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  271897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271936 */     GIR_RootConstrainSelectedInstOperands,
     /*  271937 */     // GIR_Coverage, 8395,
     /*  271937 */     GIR_EraseRootFromParent_Done,
     /*  271938 */   // Label 5173: @271938
     /*  271938 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(272001), // Rule ID 8398 //
     /*  271943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  271957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  271960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271982 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271999 */     GIR_RootConstrainSelectedInstOperands,
     /*  272000 */     // GIR_Coverage, 8398,
     /*  272000 */     GIR_EraseRootFromParent_Done,
     /*  272001 */   // Label 5174: @272001
     /*  272001 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(272064), // Rule ID 8399 //
     /*  272006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  272017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  272020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  272023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272045 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272062 */     GIR_RootConstrainSelectedInstOperands,
     /*  272063 */     // GIR_Coverage, 8399,
     /*  272063 */     GIR_EraseRootFromParent_Done,
     /*  272064 */   // Label 5175: @272064
     /*  272064 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(272127), // Rule ID 8402 //
     /*  272069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  272086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272125 */     GIR_RootConstrainSelectedInstOperands,
     /*  272126 */     // GIR_Coverage, 8402,
     /*  272126 */     GIR_EraseRootFromParent_Done,
     /*  272127 */   // Label 5176: @272127
     /*  272127 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(272190), // Rule ID 8403 //
     /*  272132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  272146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  272149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  272164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272171 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  272174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272188 */     GIR_RootConstrainSelectedInstOperands,
     /*  272189 */     // GIR_Coverage, 8403,
     /*  272189 */     GIR_EraseRootFromParent_Done,
     /*  272190 */   // Label 5177: @272190
     /*  272190 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(272253), // Rule ID 8406 //
     /*  272195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  272209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  272212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272234 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272251 */     GIR_RootConstrainSelectedInstOperands,
     /*  272252 */     // GIR_Coverage, 8406,
     /*  272252 */     GIR_EraseRootFromParent_Done,
     /*  272253 */   // Label 5178: @272253
     /*  272253 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(272316), // Rule ID 8407 //
     /*  272258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  272272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  272275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  272290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272297 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  272300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272314 */     GIR_RootConstrainSelectedInstOperands,
     /*  272315 */     // GIR_Coverage, 8407,
     /*  272315 */     GIR_EraseRootFromParent_Done,
     /*  272316 */   // Label 5179: @272316
     /*  272316 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(272379), // Rule ID 8410 //
     /*  272321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  272324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  272335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  272338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272360 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  272360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272377 */     GIR_RootConstrainSelectedInstOperands,
     /*  272378 */     // GIR_Coverage, 8410,
     /*  272378 */     GIR_EraseRootFromParent_Done,
     /*  272379 */   // Label 5180: @272379
     /*  272379 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(272442), // Rule ID 8411 //
     /*  272384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  272387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  272398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  272401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  272416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272423 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  272423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  272426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  272440 */     GIR_RootConstrainSelectedInstOperands,
     /*  272441 */     // GIR_Coverage, 8411,
     /*  272441 */     GIR_EraseRootFromParent_Done,
     /*  272442 */   // Label 5181: @272442
     /*  272442 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(272505), // Rule ID 8414 //
     /*  272447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  272461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272486 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  272489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272503 */     GIR_RootConstrainSelectedInstOperands,
     /*  272504 */     // GIR_Coverage, 8414,
     /*  272504 */     GIR_EraseRootFromParent_Done,
     /*  272505 */   // Label 5182: @272505
     /*  272505 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(272568), // Rule ID 8415 //
     /*  272510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  272524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272549 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  272552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272566 */     GIR_RootConstrainSelectedInstOperands,
     /*  272567 */     // GIR_Coverage, 8415,
     /*  272567 */     GIR_EraseRootFromParent_Done,
     /*  272568 */   // Label 5183: @272568
     /*  272568 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(272631), // Rule ID 8418 //
     /*  272573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  272587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272612 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272629 */     GIR_RootConstrainSelectedInstOperands,
     /*  272630 */     // GIR_Coverage, 8418,
     /*  272630 */     GIR_EraseRootFromParent_Done,
     /*  272631 */   // Label 5184: @272631
     /*  272631 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(272694), // Rule ID 8419 //
     /*  272636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  272650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272675 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272692 */     GIR_RootConstrainSelectedInstOperands,
     /*  272693 */     // GIR_Coverage, 8419,
     /*  272693 */     GIR_EraseRootFromParent_Done,
     /*  272694 */   // Label 5185: @272694
     /*  272694 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(272757), // Rule ID 8422 //
     /*  272699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  272713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272738 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272755 */     GIR_RootConstrainSelectedInstOperands,
     /*  272756 */     // GIR_Coverage, 8422,
     /*  272756 */     GIR_EraseRootFromParent_Done,
     /*  272757 */   // Label 5186: @272757
     /*  272757 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(272820), // Rule ID 8423 //
     /*  272762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  272776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272801 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272818 */     GIR_RootConstrainSelectedInstOperands,
     /*  272819 */     // GIR_Coverage, 8423,
     /*  272819 */     GIR_EraseRootFromParent_Done,
     /*  272820 */   // Label 5187: @272820
     /*  272820 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(272883), // Rule ID 8426 //
     /*  272825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  272839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272881 */     GIR_RootConstrainSelectedInstOperands,
     /*  272882 */     // GIR_Coverage, 8426,
     /*  272882 */     GIR_EraseRootFromParent_Done,
     /*  272883 */   // Label 5188: @272883
     /*  272883 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(272946), // Rule ID 8427 //
     /*  272888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  272902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272927 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272944 */     GIR_RootConstrainSelectedInstOperands,
     /*  272945 */     // GIR_Coverage, 8427,
     /*  272945 */     GIR_EraseRootFromParent_Done,
     /*  272946 */   // Label 5189: @272946
     /*  272946 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(273009), // Rule ID 8430 //
     /*  272951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  272965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272990 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273007 */     GIR_RootConstrainSelectedInstOperands,
     /*  273008 */     // GIR_Coverage, 8430,
     /*  273008 */     GIR_EraseRootFromParent_Done,
     /*  273009 */   // Label 5190: @273009
     /*  273009 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(273072), // Rule ID 8431 //
     /*  273014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  273028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273053 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273070 */     GIR_RootConstrainSelectedInstOperands,
     /*  273071 */     // GIR_Coverage, 8431,
     /*  273071 */     GIR_EraseRootFromParent_Done,
     /*  273072 */   // Label 5191: @273072
     /*  273072 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(273135), // Rule ID 8434 //
     /*  273077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273116 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273133 */     GIR_RootConstrainSelectedInstOperands,
     /*  273134 */     // GIR_Coverage, 8434,
     /*  273134 */     GIR_EraseRootFromParent_Done,
     /*  273135 */   // Label 5192: @273135
     /*  273135 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(273198), // Rule ID 8435 //
     /*  273140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  273154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273179 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  273179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  273182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273196 */     GIR_RootConstrainSelectedInstOperands,
     /*  273197 */     // GIR_Coverage, 8435,
     /*  273197 */     GIR_EraseRootFromParent_Done,
     /*  273198 */   // Label 5193: @273198
     /*  273198 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(273261), // Rule ID 8438 //
     /*  273203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  273217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273242 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273259 */     GIR_RootConstrainSelectedInstOperands,
     /*  273260 */     // GIR_Coverage, 8438,
     /*  273260 */     GIR_EraseRootFromParent_Done,
     /*  273261 */   // Label 5194: @273261
     /*  273261 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(273324), // Rule ID 8439 //
     /*  273266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  273280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273305 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273322 */     GIR_RootConstrainSelectedInstOperands,
     /*  273323 */     // GIR_Coverage, 8439,
     /*  273323 */     GIR_EraseRootFromParent_Done,
     /*  273324 */   // Label 5195: @273324
     /*  273324 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(273387), // Rule ID 8442 //
     /*  273329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  273343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273368 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273385 */     GIR_RootConstrainSelectedInstOperands,
     /*  273386 */     // GIR_Coverage, 8442,
     /*  273386 */     GIR_EraseRootFromParent_Done,
     /*  273387 */   // Label 5196: @273387
     /*  273387 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(273450), // Rule ID 8443 //
     /*  273392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  273406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273431 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273448 */     GIR_RootConstrainSelectedInstOperands,
     /*  273449 */     // GIR_Coverage, 8443,
     /*  273449 */     GIR_EraseRootFromParent_Done,
     /*  273450 */   // Label 5197: @273450
     /*  273450 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(273513), // Rule ID 8446 //
     /*  273455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  273469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273494 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273511 */     GIR_RootConstrainSelectedInstOperands,
     /*  273512 */     // GIR_Coverage, 8446,
     /*  273512 */     GIR_EraseRootFromParent_Done,
     /*  273513 */   // Label 5198: @273513
     /*  273513 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(273576), // Rule ID 8447 //
     /*  273518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  273532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273557 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  273557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273574 */     GIR_RootConstrainSelectedInstOperands,
     /*  273575 */     // GIR_Coverage, 8447,
     /*  273575 */     GIR_EraseRootFromParent_Done,
     /*  273576 */   // Label 5199: @273576
     /*  273576 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(273639), // Rule ID 8450 //
     /*  273581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  273595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  273620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273637 */     GIR_RootConstrainSelectedInstOperands,
     /*  273638 */     // GIR_Coverage, 8450,
     /*  273638 */     GIR_EraseRootFromParent_Done,
     /*  273639 */   // Label 5200: @273639
     /*  273639 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(273702), // Rule ID 8451 //
     /*  273644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  273658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273683 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  273683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273700 */     GIR_RootConstrainSelectedInstOperands,
     /*  273701 */     // GIR_Coverage, 8451,
     /*  273701 */     GIR_EraseRootFromParent_Done,
     /*  273702 */   // Label 5201: @273702
     /*  273702 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(273765), // Rule ID 8454 //
     /*  273707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  273721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273746 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  273749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273763 */     GIR_RootConstrainSelectedInstOperands,
     /*  273764 */     // GIR_Coverage, 8454,
     /*  273764 */     GIR_EraseRootFromParent_Done,
     /*  273765 */   // Label 5202: @273765
     /*  273765 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(273828), // Rule ID 8455 //
     /*  273770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  273784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273809 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  273812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273826 */     GIR_RootConstrainSelectedInstOperands,
     /*  273827 */     // GIR_Coverage, 8455,
     /*  273827 */     GIR_EraseRootFromParent_Done,
     /*  273828 */   // Label 5203: @273828
     /*  273828 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(273891), // Rule ID 8458 //
     /*  273833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  273844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  273847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273872 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  273875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273889 */     GIR_RootConstrainSelectedInstOperands,
     /*  273890 */     // GIR_Coverage, 8458,
     /*  273890 */     GIR_EraseRootFromParent_Done,
     /*  273891 */   // Label 5204: @273891
     /*  273891 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(273954), // Rule ID 8459 //
     /*  273896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  273907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  273910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273935 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  273938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273952 */     GIR_RootConstrainSelectedInstOperands,
     /*  273953 */     // GIR_Coverage, 8459,
     /*  273953 */     GIR_EraseRootFromParent_Done,
     /*  273954 */   // Label 5205: @273954
     /*  273954 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(274017), // Rule ID 8462 //
     /*  273959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  273970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  273973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273998 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274015 */     GIR_RootConstrainSelectedInstOperands,
     /*  274016 */     // GIR_Coverage, 8462,
     /*  274016 */     GIR_EraseRootFromParent_Done,
     /*  274017 */   // Label 5206: @274017
     /*  274017 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(274080), // Rule ID 8463 //
     /*  274022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  274033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  274036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274061 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274078 */     GIR_RootConstrainSelectedInstOperands,
     /*  274079 */     // GIR_Coverage, 8463,
     /*  274079 */     GIR_EraseRootFromParent_Done,
     /*  274080 */   // Label 5207: @274080
     /*  274080 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(274143), // Rule ID 8466 //
     /*  274085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274141 */     GIR_RootConstrainSelectedInstOperands,
     /*  274142 */     // GIR_Coverage, 8466,
     /*  274142 */     GIR_EraseRootFromParent_Done,
     /*  274143 */   // Label 5208: @274143
     /*  274143 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(274206), // Rule ID 8467 //
     /*  274148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  274162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274187 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274204 */     GIR_RootConstrainSelectedInstOperands,
     /*  274205 */     // GIR_Coverage, 8467,
     /*  274205 */     GIR_EraseRootFromParent_Done,
     /*  274206 */   // Label 5209: @274206
     /*  274206 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(274269), // Rule ID 8470 //
     /*  274211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  274225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274250 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274267 */     GIR_RootConstrainSelectedInstOperands,
     /*  274268 */     // GIR_Coverage, 8470,
     /*  274268 */     GIR_EraseRootFromParent_Done,
     /*  274269 */   // Label 5210: @274269
     /*  274269 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(274332), // Rule ID 8471 //
     /*  274274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  274288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274313 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274330 */     GIR_RootConstrainSelectedInstOperands,
     /*  274331 */     // GIR_Coverage, 8471,
     /*  274331 */     GIR_EraseRootFromParent_Done,
     /*  274332 */   // Label 5211: @274332
     /*  274332 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(274395), // Rule ID 8474 //
     /*  274337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  274351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274376 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  274376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274393 */     GIR_RootConstrainSelectedInstOperands,
     /*  274394 */     // GIR_Coverage, 8474,
     /*  274394 */     GIR_EraseRootFromParent_Done,
     /*  274395 */   // Label 5212: @274395
     /*  274395 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(274458), // Rule ID 8475 //
     /*  274400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  274411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  274414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274439 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  274439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  274456 */     GIR_RootConstrainSelectedInstOperands,
     /*  274457 */     // GIR_Coverage, 8475,
     /*  274457 */     GIR_EraseRootFromParent_Done,
     /*  274458 */   // Label 5213: @274458
     /*  274458 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(274521), // Rule ID 8478 //
     /*  274463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  274477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274502 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274519 */     GIR_RootConstrainSelectedInstOperands,
     /*  274520 */     // GIR_Coverage, 8478,
     /*  274520 */     GIR_EraseRootFromParent_Done,
     /*  274521 */   // Label 5214: @274521
     /*  274521 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(274584), // Rule ID 8479 //
     /*  274526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  274540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274565 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274582 */     GIR_RootConstrainSelectedInstOperands,
     /*  274583 */     // GIR_Coverage, 8479,
     /*  274583 */     GIR_EraseRootFromParent_Done,
     /*  274584 */   // Label 5215: @274584
     /*  274584 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(274647), // Rule ID 8482 //
     /*  274589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  274603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274628 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274645 */     GIR_RootConstrainSelectedInstOperands,
     /*  274646 */     // GIR_Coverage, 8482,
     /*  274646 */     GIR_EraseRootFromParent_Done,
     /*  274647 */   // Label 5216: @274647
     /*  274647 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(274710), // Rule ID 8483 //
     /*  274652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  274666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274691 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274708 */     GIR_RootConstrainSelectedInstOperands,
     /*  274709 */     // GIR_Coverage, 8483,
     /*  274709 */     GIR_EraseRootFromParent_Done,
     /*  274710 */   // Label 5217: @274710
     /*  274710 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(274773), // Rule ID 8486 //
     /*  274715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  274729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274771 */     GIR_RootConstrainSelectedInstOperands,
     /*  274772 */     // GIR_Coverage, 8486,
     /*  274772 */     GIR_EraseRootFromParent_Done,
     /*  274773 */   // Label 5218: @274773
     /*  274773 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(274836), // Rule ID 8487 //
     /*  274778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  274792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274817 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274834 */     GIR_RootConstrainSelectedInstOperands,
     /*  274835 */     // GIR_Coverage, 8487,
     /*  274835 */     GIR_EraseRootFromParent_Done,
     /*  274836 */   // Label 5219: @274836
     /*  274836 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(274899), // Rule ID 8490 //
     /*  274841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  274855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  274880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274897 */     GIR_RootConstrainSelectedInstOperands,
     /*  274898 */     // GIR_Coverage, 8490,
     /*  274898 */     GIR_EraseRootFromParent_Done,
     /*  274899 */   // Label 5220: @274899
     /*  274899 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(274962), // Rule ID 8491 //
     /*  274904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  274907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  274918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274943 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  274943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274960 */     GIR_RootConstrainSelectedInstOperands,
     /*  274961 */     // GIR_Coverage, 8491,
     /*  274961 */     GIR_EraseRootFromParent_Done,
     /*  274962 */   // Label 5221: @274962
     /*  274962 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(275025), // Rule ID 8494 //
     /*  274967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  274981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275006 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275023 */     GIR_RootConstrainSelectedInstOperands,
     /*  275024 */     // GIR_Coverage, 8494,
     /*  275024 */     GIR_EraseRootFromParent_Done,
     /*  275025 */   // Label 5222: @275025
     /*  275025 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(275088), // Rule ID 8495 //
     /*  275030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  275044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  275058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275069 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  275072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275086 */     GIR_RootConstrainSelectedInstOperands,
     /*  275087 */     // GIR_Coverage, 8495,
     /*  275087 */     GIR_EraseRootFromParent_Done,
     /*  275088 */   // Label 5223: @275088
     /*  275088 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(275151), // Rule ID 8498 //
     /*  275093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  275107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  275110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275132 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275149 */     GIR_RootConstrainSelectedInstOperands,
     /*  275150 */     // GIR_Coverage, 8498,
     /*  275150 */     GIR_EraseRootFromParent_Done,
     /*  275151 */   // Label 5224: @275151
     /*  275151 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(275214), // Rule ID 8499 //
     /*  275156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  275164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  275170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  275173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  275184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  275188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275195 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  275198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275212 */     GIR_RootConstrainSelectedInstOperands,
     /*  275213 */     // GIR_Coverage, 8499,
     /*  275213 */     GIR_EraseRootFromParent_Done,
     /*  275214 */   // Label 5225: @275214
     /*  275214 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(275277), // Rule ID 8502 //
     /*  275219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  275233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  275236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275258 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  275261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275275 */     GIR_RootConstrainSelectedInstOperands,
     /*  275276 */     // GIR_Coverage, 8502,
     /*  275276 */     GIR_EraseRootFromParent_Done,
     /*  275277 */   // Label 5226: @275277
     /*  275277 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(275340), // Rule ID 8503 //
     /*  275282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  275296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  275299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275321 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  275324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275338 */     GIR_RootConstrainSelectedInstOperands,
     /*  275339 */     // GIR_Coverage, 8503,
     /*  275339 */     GIR_EraseRootFromParent_Done,
     /*  275340 */   // Label 5227: @275340
     /*  275340 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(275403), // Rule ID 8506 //
     /*  275345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  275359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  275362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275384 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275401 */     GIR_RootConstrainSelectedInstOperands,
     /*  275402 */     // GIR_Coverage, 8506,
     /*  275402 */     GIR_EraseRootFromParent_Done,
     /*  275403 */   // Label 5228: @275403
     /*  275403 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(275466), // Rule ID 8507 //
     /*  275408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  275422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  275425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275447 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275464 */     GIR_RootConstrainSelectedInstOperands,
     /*  275465 */     // GIR_Coverage, 8507,
     /*  275465 */     GIR_EraseRootFromParent_Done,
     /*  275466 */   // Label 5229: @275466
     /*  275466 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(275529), // Rule ID 8510 //
     /*  275471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  275485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  275488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275510 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275527 */     GIR_RootConstrainSelectedInstOperands,
     /*  275528 */     // GIR_Coverage, 8510,
     /*  275528 */     GIR_EraseRootFromParent_Done,
     /*  275529 */   // Label 5230: @275529
     /*  275529 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(275592), // Rule ID 8511 //
     /*  275534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  275548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  275551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275573 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275590 */     GIR_RootConstrainSelectedInstOperands,
     /*  275591 */     // GIR_Coverage, 8511,
     /*  275591 */     GIR_EraseRootFromParent_Done,
     /*  275592 */   // Label 5231: @275592
     /*  275592 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(275655), // Rule ID 8514 //
     /*  275597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  275611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  275614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275636 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275653 */     GIR_RootConstrainSelectedInstOperands,
     /*  275654 */     // GIR_Coverage, 8514,
     /*  275654 */     GIR_EraseRootFromParent_Done,
     /*  275655 */   // Label 5232: @275655
     /*  275655 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(275718), // Rule ID 8515 //
     /*  275660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  275674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  275677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275699 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275716 */     GIR_RootConstrainSelectedInstOperands,
     /*  275717 */     // GIR_Coverage, 8515,
     /*  275717 */     GIR_EraseRootFromParent_Done,
     /*  275718 */   // Label 5233: @275718
     /*  275718 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(275781), // Rule ID 8518 //
     /*  275723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  275737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  275740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275762 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275779 */     GIR_RootConstrainSelectedInstOperands,
     /*  275780 */     // GIR_Coverage, 8518,
     /*  275780 */     GIR_EraseRootFromParent_Done,
     /*  275781 */   // Label 5234: @275781
     /*  275781 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(275844), // Rule ID 8519 //
     /*  275786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  275800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  275803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275825 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275842 */     GIR_RootConstrainSelectedInstOperands,
     /*  275843 */     // GIR_Coverage, 8519,
     /*  275843 */     GIR_EraseRootFromParent_Done,
     /*  275844 */   // Label 5235: @275844
     /*  275844 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(275907), // Rule ID 8522 //
     /*  275849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  275863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  275866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275888 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275905 */     GIR_RootConstrainSelectedInstOperands,
     /*  275906 */     // GIR_Coverage, 8522,
     /*  275906 */     GIR_EraseRootFromParent_Done,
     /*  275907 */   // Label 5236: @275907
     /*  275907 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(275970), // Rule ID 8523 //
     /*  275912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  275926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  275929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275951 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275968 */     GIR_RootConstrainSelectedInstOperands,
     /*  275969 */     // GIR_Coverage, 8523,
     /*  275969 */     GIR_EraseRootFromParent_Done,
     /*  275970 */   // Label 5237: @275970
     /*  275970 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(276033), // Rule ID 8526 //
     /*  275975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  275989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  275992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276014 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276031 */     GIR_RootConstrainSelectedInstOperands,
     /*  276032 */     // GIR_Coverage, 8526,
     /*  276032 */     GIR_EraseRootFromParent_Done,
     /*  276033 */   // Label 5238: @276033
     /*  276033 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(276096), // Rule ID 8527 //
     /*  276038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  276052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  276055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276077 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276094 */     GIR_RootConstrainSelectedInstOperands,
     /*  276095 */     // GIR_Coverage, 8527,
     /*  276095 */     GIR_EraseRootFromParent_Done,
     /*  276096 */   // Label 5239: @276096
     /*  276096 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(276159), // Rule ID 8530 //
     /*  276101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  276115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  276118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276157 */     GIR_RootConstrainSelectedInstOperands,
     /*  276158 */     // GIR_Coverage, 8530,
     /*  276158 */     GIR_EraseRootFromParent_Done,
     /*  276159 */   // Label 5240: @276159
     /*  276159 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(276222), // Rule ID 8531 //
     /*  276164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  276178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  276181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276203 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276220 */     GIR_RootConstrainSelectedInstOperands,
     /*  276221 */     // GIR_Coverage, 8531,
     /*  276221 */     GIR_EraseRootFromParent_Done,
     /*  276222 */   // Label 5241: @276222
     /*  276222 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(276285), // Rule ID 8534 //
     /*  276227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  276241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  276244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276266 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276283 */     GIR_RootConstrainSelectedInstOperands,
     /*  276284 */     // GIR_Coverage, 8534,
     /*  276284 */     GIR_EraseRootFromParent_Done,
     /*  276285 */   // Label 5242: @276285
     /*  276285 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(276348), // Rule ID 8535 //
     /*  276290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  276301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  276304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  276307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276329 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  276329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276346 */     GIR_RootConstrainSelectedInstOperands,
     /*  276347 */     // GIR_Coverage, 8535,
     /*  276347 */     GIR_EraseRootFromParent_Done,
     /*  276348 */   // Label 5243: @276348
     /*  276348 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(276411), // Rule ID 8538 //
     /*  276353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  276356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  276367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  276370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  276392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276409 */     GIR_RootConstrainSelectedInstOperands,
     /*  276410 */     // GIR_Coverage, 8538,
     /*  276410 */     GIR_EraseRootFromParent_Done,
     /*  276411 */   // Label 5244: @276411
     /*  276411 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(276474), // Rule ID 8539 //
     /*  276416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  276419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  276427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  276430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  276433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276455 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  276455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  276458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  276472 */     GIR_RootConstrainSelectedInstOperands,
     /*  276473 */     // GIR_Coverage, 8539,
     /*  276473 */     GIR_EraseRootFromParent_Done,
     /*  276474 */   // Label 5245: @276474
     /*  276474 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(276537), // Rule ID 8542 //
     /*  276479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  276493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  276496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276518 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276535 */     GIR_RootConstrainSelectedInstOperands,
     /*  276536 */     // GIR_Coverage, 8542,
     /*  276536 */     GIR_EraseRootFromParent_Done,
     /*  276537 */   // Label 5246: @276537
     /*  276537 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(276600), // Rule ID 8543 //
     /*  276542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  276556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  276559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276581 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276598 */     GIR_RootConstrainSelectedInstOperands,
     /*  276599 */     // GIR_Coverage, 8543,
     /*  276599 */     GIR_EraseRootFromParent_Done,
     /*  276600 */   // Label 5247: @276600
     /*  276600 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(276663), // Rule ID 8546 //
     /*  276605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  276616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  276619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  276622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276644 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276661 */     GIR_RootConstrainSelectedInstOperands,
     /*  276662 */     // GIR_Coverage, 8546,
     /*  276662 */     GIR_EraseRootFromParent_Done,
     /*  276663 */   // Label 5248: @276663
     /*  276663 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(276726), // Rule ID 8547 //
     /*  276668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  276679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  276682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  276685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276707 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276724 */     GIR_RootConstrainSelectedInstOperands,
     /*  276725 */     // GIR_Coverage, 8547,
     /*  276725 */     GIR_EraseRootFromParent_Done,
     /*  276726 */   // Label 5249: @276726
     /*  276726 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(276789), // Rule ID 8550 //
     /*  276731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  276742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  276745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  276748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276770 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  276773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276787 */     GIR_RootConstrainSelectedInstOperands,
     /*  276788 */     // GIR_Coverage, 8550,
     /*  276788 */     GIR_EraseRootFromParent_Done,
     /*  276789 */   // Label 5250: @276789
     /*  276789 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(276852), // Rule ID 8551 //
     /*  276794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  276805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  276808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  276811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276833 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  276836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276850 */     GIR_RootConstrainSelectedInstOperands,
     /*  276851 */     // GIR_Coverage, 8551,
     /*  276851 */     GIR_EraseRootFromParent_Done,
     /*  276852 */   // Label 5251: @276852
     /*  276852 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(276915), // Rule ID 8554 //
     /*  276857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  276871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  276874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276913 */     GIR_RootConstrainSelectedInstOperands,
     /*  276914 */     // GIR_Coverage, 8554,
     /*  276914 */     GIR_EraseRootFromParent_Done,
     /*  276915 */   // Label 5252: @276915
     /*  276915 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(276978), // Rule ID 8555 //
     /*  276920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  276934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  276937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276959 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276976 */     GIR_RootConstrainSelectedInstOperands,
     /*  276977 */     // GIR_Coverage, 8555,
     /*  276977 */     GIR_EraseRootFromParent_Done,
     /*  276978 */   // Label 5253: @276978
     /*  276978 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(277041), // Rule ID 8558 //
     /*  276983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  276997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  277000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277022 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277039 */     GIR_RootConstrainSelectedInstOperands,
     /*  277040 */     // GIR_Coverage, 8558,
     /*  277040 */     GIR_EraseRootFromParent_Done,
     /*  277041 */   // Label 5254: @277041
     /*  277041 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(277104), // Rule ID 8559 //
     /*  277046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  277060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  277063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277085 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277102 */     GIR_RootConstrainSelectedInstOperands,
     /*  277103 */     // GIR_Coverage, 8559,
     /*  277103 */     GIR_EraseRootFromParent_Done,
     /*  277104 */   // Label 5255: @277104
     /*  277104 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(277167), // Rule ID 8562 //
     /*  277109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  277123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  277126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277148 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277165 */     GIR_RootConstrainSelectedInstOperands,
     /*  277166 */     // GIR_Coverage, 8562,
     /*  277166 */     GIR_EraseRootFromParent_Done,
     /*  277167 */   // Label 5256: @277167
     /*  277167 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(277230), // Rule ID 8563 //
     /*  277172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  277183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  277186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  277189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277211 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277228 */     GIR_RootConstrainSelectedInstOperands,
     /*  277229 */     // GIR_Coverage, 8563,
     /*  277229 */     GIR_EraseRootFromParent_Done,
     /*  277230 */   // Label 5257: @277230
     /*  277230 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(277293), // Rule ID 8566 //
     /*  277235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  277249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  277252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277274 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277291 */     GIR_RootConstrainSelectedInstOperands,
     /*  277292 */     // GIR_Coverage, 8566,
     /*  277292 */     GIR_EraseRootFromParent_Done,
     /*  277293 */   // Label 5258: @277293
     /*  277293 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(277356), // Rule ID 8567 //
     /*  277298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  277312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  277315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277337 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277354 */     GIR_RootConstrainSelectedInstOperands,
     /*  277355 */     // GIR_Coverage, 8567,
     /*  277355 */     GIR_EraseRootFromParent_Done,
     /*  277356 */   // Label 5259: @277356
     /*  277356 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(277419), // Rule ID 8570 //
     /*  277361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  277375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  277378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277417 */     GIR_RootConstrainSelectedInstOperands,
     /*  277418 */     // GIR_Coverage, 8570,
     /*  277418 */     GIR_EraseRootFromParent_Done,
     /*  277419 */   // Label 5260: @277419
     /*  277419 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(277482), // Rule ID 8571 //
     /*  277424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  277438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  277441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277463 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277480 */     GIR_RootConstrainSelectedInstOperands,
     /*  277481 */     // GIR_Coverage, 8571,
     /*  277481 */     GIR_EraseRootFromParent_Done,
     /*  277482 */   // Label 5261: @277482
     /*  277482 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(277545), // Rule ID 8574 //
     /*  277487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  277501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  277504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277543 */     GIR_RootConstrainSelectedInstOperands,
     /*  277544 */     // GIR_Coverage, 8574,
     /*  277544 */     GIR_EraseRootFromParent_Done,
     /*  277545 */   // Label 5262: @277545
     /*  277545 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(277608), // Rule ID 8575 //
     /*  277550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  277564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  277567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277589 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277606 */     GIR_RootConstrainSelectedInstOperands,
     /*  277607 */     // GIR_Coverage, 8575,
     /*  277607 */     GIR_EraseRootFromParent_Done,
     /*  277608 */   // Label 5263: @277608
     /*  277608 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(277671), // Rule ID 8578 //
     /*  277613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  277627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  277630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277652 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277669 */     GIR_RootConstrainSelectedInstOperands,
     /*  277670 */     // GIR_Coverage, 8578,
     /*  277670 */     GIR_EraseRootFromParent_Done,
     /*  277671 */   // Label 5264: @277671
     /*  277671 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(277734), // Rule ID 8579 //
     /*  277676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  277690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  277693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277715 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277732 */     GIR_RootConstrainSelectedInstOperands,
     /*  277733 */     // GIR_Coverage, 8579,
     /*  277733 */     GIR_EraseRootFromParent_Done,
     /*  277734 */   // Label 5265: @277734
     /*  277734 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(277797), // Rule ID 8582 //
     /*  277739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  277753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  277756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277778 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277795 */     GIR_RootConstrainSelectedInstOperands,
     /*  277796 */     // GIR_Coverage, 8582,
     /*  277796 */     GIR_EraseRootFromParent_Done,
     /*  277797 */   // Label 5266: @277797
     /*  277797 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(277860), // Rule ID 8583 //
     /*  277802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  277816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  277819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277841 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277858 */     GIR_RootConstrainSelectedInstOperands,
     /*  277859 */     // GIR_Coverage, 8583,
     /*  277859 */     GIR_EraseRootFromParent_Done,
     /*  277860 */   // Label 5267: @277860
     /*  277860 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(277923), // Rule ID 8586 //
     /*  277865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  277879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  277882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277904 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277921 */     GIR_RootConstrainSelectedInstOperands,
     /*  277922 */     // GIR_Coverage, 8586,
     /*  277922 */     GIR_EraseRootFromParent_Done,
     /*  277923 */   // Label 5268: @277923
     /*  277923 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(277986), // Rule ID 8587 //
     /*  277928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  277942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  277945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277967 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277984 */     GIR_RootConstrainSelectedInstOperands,
     /*  277985 */     // GIR_Coverage, 8587,
     /*  277985 */     GIR_EraseRootFromParent_Done,
     /*  277986 */   // Label 5269: @277986
     /*  277986 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(278049), // Rule ID 8590 //
     /*  277991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  278005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278030 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  278033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278047 */     GIR_RootConstrainSelectedInstOperands,
     /*  278048 */     // GIR_Coverage, 8590,
     /*  278048 */     GIR_EraseRootFromParent_Done,
     /*  278049 */   // Label 5270: @278049
     /*  278049 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(278112), // Rule ID 8591 //
     /*  278054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  278068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278093 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  278096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278110 */     GIR_RootConstrainSelectedInstOperands,
     /*  278111 */     // GIR_Coverage, 8591,
     /*  278111 */     GIR_EraseRootFromParent_Done,
     /*  278112 */   // Label 5271: @278112
     /*  278112 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(278175), // Rule ID 8594 //
     /*  278117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  278131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278156 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278173 */     GIR_RootConstrainSelectedInstOperands,
     /*  278174 */     // GIR_Coverage, 8594,
     /*  278174 */     GIR_EraseRootFromParent_Done,
     /*  278175 */   // Label 5272: @278175
     /*  278175 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(278238), // Rule ID 8595 //
     /*  278180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  278194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278219 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278236 */     GIR_RootConstrainSelectedInstOperands,
     /*  278237 */     // GIR_Coverage, 8595,
     /*  278237 */     GIR_EraseRootFromParent_Done,
     /*  278238 */   // Label 5273: @278238
     /*  278238 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(278301), // Rule ID 8598 //
     /*  278243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  278257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278299 */     GIR_RootConstrainSelectedInstOperands,
     /*  278300 */     // GIR_Coverage, 8598,
     /*  278300 */     GIR_EraseRootFromParent_Done,
     /*  278301 */   // Label 5274: @278301
     /*  278301 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(278364), // Rule ID 8599 //
     /*  278306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  278320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278345 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278362 */     GIR_RootConstrainSelectedInstOperands,
     /*  278363 */     // GIR_Coverage, 8599,
     /*  278363 */     GIR_EraseRootFromParent_Done,
     /*  278364 */   // Label 5275: @278364
     /*  278364 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(278427), // Rule ID 8602 //
     /*  278369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  278383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278408 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278425 */     GIR_RootConstrainSelectedInstOperands,
     /*  278426 */     // GIR_Coverage, 8602,
     /*  278426 */     GIR_EraseRootFromParent_Done,
     /*  278427 */   // Label 5276: @278427
     /*  278427 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(278490), // Rule ID 8603 //
     /*  278432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  278446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278471 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  278474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278488 */     GIR_RootConstrainSelectedInstOperands,
     /*  278489 */     // GIR_Coverage, 8603,
     /*  278489 */     GIR_EraseRootFromParent_Done,
     /*  278490 */   // Label 5277: @278490
     /*  278490 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(278553), // Rule ID 8606 //
     /*  278495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  278509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278534 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278551 */     GIR_RootConstrainSelectedInstOperands,
     /*  278552 */     // GIR_Coverage, 8606,
     /*  278552 */     GIR_EraseRootFromParent_Done,
     /*  278553 */   // Label 5278: @278553
     /*  278553 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(278616), // Rule ID 8607 //
     /*  278558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  278572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278597 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278614 */     GIR_RootConstrainSelectedInstOperands,
     /*  278615 */     // GIR_Coverage, 8607,
     /*  278615 */     GIR_EraseRootFromParent_Done,
     /*  278616 */   // Label 5279: @278616
     /*  278616 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(278679), // Rule ID 8610 //
     /*  278621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  278635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278660 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278677 */     GIR_RootConstrainSelectedInstOperands,
     /*  278678 */     // GIR_Coverage, 8610,
     /*  278678 */     GIR_EraseRootFromParent_Done,
     /*  278679 */   // Label 5280: @278679
     /*  278679 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(278742), // Rule ID 8611 //
     /*  278684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  278698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278723 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278740 */     GIR_RootConstrainSelectedInstOperands,
     /*  278741 */     // GIR_Coverage, 8611,
     /*  278741 */     GIR_EraseRootFromParent_Done,
     /*  278742 */   // Label 5281: @278742
     /*  278742 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(278805), // Rule ID 8614 //
     /*  278747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  278761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278786 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278803 */     GIR_RootConstrainSelectedInstOperands,
     /*  278804 */     // GIR_Coverage, 8614,
     /*  278804 */     GIR_EraseRootFromParent_Done,
     /*  278805 */   // Label 5282: @278805
     /*  278805 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(278868), // Rule ID 8615 //
     /*  278810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  278824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278849 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278866 */     GIR_RootConstrainSelectedInstOperands,
     /*  278867 */     // GIR_Coverage, 8615,
     /*  278867 */     GIR_EraseRootFromParent_Done,
     /*  278868 */   // Label 5283: @278868
     /*  278868 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(278931), // Rule ID 8618 //
     /*  278873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  278887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278912 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278929 */     GIR_RootConstrainSelectedInstOperands,
     /*  278930 */     // GIR_Coverage, 8618,
     /*  278930 */     GIR_EraseRootFromParent_Done,
     /*  278931 */   // Label 5284: @278931
     /*  278931 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(278994), // Rule ID 8619 //
     /*  278936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  278950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278975 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278992 */     GIR_RootConstrainSelectedInstOperands,
     /*  278993 */     // GIR_Coverage, 8619,
     /*  278993 */     GIR_EraseRootFromParent_Done,
     /*  278994 */   // Label 5285: @278994
     /*  278994 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(279057), // Rule ID 8622 //
     /*  278999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  279013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279038 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279055 */     GIR_RootConstrainSelectedInstOperands,
     /*  279056 */     // GIR_Coverage, 8622,
     /*  279056 */     GIR_EraseRootFromParent_Done,
     /*  279057 */   // Label 5286: @279057
     /*  279057 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(279120), // Rule ID 8623 //
     /*  279062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  279076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279101 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279118 */     GIR_RootConstrainSelectedInstOperands,
     /*  279119 */     // GIR_Coverage, 8623,
     /*  279119 */     GIR_EraseRootFromParent_Done,
     /*  279120 */   // Label 5287: @279120
     /*  279120 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(279183), // Rule ID 8626 //
     /*  279125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  279128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  279139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279164 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  279164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279181 */     GIR_RootConstrainSelectedInstOperands,
     /*  279182 */     // GIR_Coverage, 8626,
     /*  279182 */     GIR_EraseRootFromParent_Done,
     /*  279183 */   // Label 5288: @279183
     /*  279183 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(279246), // Rule ID 8627 //
     /*  279188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  279191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  279199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  279202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279227 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  279227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  279230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279244 */     GIR_RootConstrainSelectedInstOperands,
     /*  279245 */     // GIR_Coverage, 8627,
     /*  279245 */     GIR_EraseRootFromParent_Done,
     /*  279246 */   // Label 5289: @279246
     /*  279246 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(279309), // Rule ID 8630 //
     /*  279251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  279265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279290 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279307 */     GIR_RootConstrainSelectedInstOperands,
     /*  279308 */     // GIR_Coverage, 8630,
     /*  279308 */     GIR_EraseRootFromParent_Done,
     /*  279309 */   // Label 5290: @279309
     /*  279309 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(279372), // Rule ID 8631 //
     /*  279314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  279328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279353 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279370 */     GIR_RootConstrainSelectedInstOperands,
     /*  279371 */     // GIR_Coverage, 8631,
     /*  279371 */     GIR_EraseRootFromParent_Done,
     /*  279372 */   // Label 5291: @279372
     /*  279372 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(279435), // Rule ID 8634 //
     /*  279377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  279391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279416 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279433 */     GIR_RootConstrainSelectedInstOperands,
     /*  279434 */     // GIR_Coverage, 8634,
     /*  279434 */     GIR_EraseRootFromParent_Done,
     /*  279435 */   // Label 5292: @279435
     /*  279435 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(279498), // Rule ID 8635 //
     /*  279440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  279454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279479 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279496 */     GIR_RootConstrainSelectedInstOperands,
     /*  279497 */     // GIR_Coverage, 8635,
     /*  279497 */     GIR_EraseRootFromParent_Done,
     /*  279498 */   // Label 5293: @279498
     /*  279498 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(279561), // Rule ID 8638 //
     /*  279503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  279514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  279517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279542 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279559 */     GIR_RootConstrainSelectedInstOperands,
     /*  279560 */     // GIR_Coverage, 8638,
     /*  279560 */     GIR_EraseRootFromParent_Done,
     /*  279561 */   // Label 5294: @279561
     /*  279561 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(279624), // Rule ID 8639 //
     /*  279566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  279577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  279580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279605 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279622 */     GIR_RootConstrainSelectedInstOperands,
     /*  279623 */     // GIR_Coverage, 8639,
     /*  279623 */     GIR_EraseRootFromParent_Done,
     /*  279624 */   // Label 5295: @279624
     /*  279624 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(279687), // Rule ID 8642 //
     /*  279629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  279643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279668 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279685 */     GIR_RootConstrainSelectedInstOperands,
     /*  279686 */     // GIR_Coverage, 8642,
     /*  279686 */     GIR_EraseRootFromParent_Done,
     /*  279687 */   // Label 5296: @279687
     /*  279687 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(279750), // Rule ID 8643 //
     /*  279692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  279706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279731 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279748 */     GIR_RootConstrainSelectedInstOperands,
     /*  279749 */     // GIR_Coverage, 8643,
     /*  279749 */     GIR_EraseRootFromParent_Done,
     /*  279750 */   // Label 5297: @279750
     /*  279750 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(279813), // Rule ID 8646 //
     /*  279755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  279769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279794 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279811 */     GIR_RootConstrainSelectedInstOperands,
     /*  279812 */     // GIR_Coverage, 8646,
     /*  279812 */     GIR_EraseRootFromParent_Done,
     /*  279813 */   // Label 5298: @279813
     /*  279813 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(279876), // Rule ID 8647 //
     /*  279818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  279832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279857 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279874 */     GIR_RootConstrainSelectedInstOperands,
     /*  279875 */     // GIR_Coverage, 8647,
     /*  279875 */     GIR_EraseRootFromParent_Done,
     /*  279876 */   // Label 5299: @279876
     /*  279876 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(279939), // Rule ID 8650 //
     /*  279881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  279895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279920 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279937 */     GIR_RootConstrainSelectedInstOperands,
     /*  279938 */     // GIR_Coverage, 8650,
     /*  279938 */     GIR_EraseRootFromParent_Done,
     /*  279939 */   // Label 5300: @279939
     /*  279939 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(280002), // Rule ID 8651 //
     /*  279944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  279958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279983 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280000 */     GIR_RootConstrainSelectedInstOperands,
     /*  280001 */     // GIR_Coverage, 8651,
     /*  280001 */     GIR_EraseRootFromParent_Done,
     /*  280002 */   // Label 5301: @280002
     /*  280002 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(280065), // Rule ID 8654 //
     /*  280007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  280021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280046 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280063 */     GIR_RootConstrainSelectedInstOperands,
     /*  280064 */     // GIR_Coverage, 8654,
     /*  280064 */     GIR_EraseRootFromParent_Done,
     /*  280065 */   // Label 5302: @280065
     /*  280065 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(280128), // Rule ID 8655 //
     /*  280070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  280084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280109 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280126 */     GIR_RootConstrainSelectedInstOperands,
     /*  280127 */     // GIR_Coverage, 8655,
     /*  280127 */     GIR_EraseRootFromParent_Done,
     /*  280128 */   // Label 5303: @280128
     /*  280128 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(280191), // Rule ID 8658 //
     /*  280133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  280147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280172 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280189 */     GIR_RootConstrainSelectedInstOperands,
     /*  280190 */     // GIR_Coverage, 8658,
     /*  280190 */     GIR_EraseRootFromParent_Done,
     /*  280191 */   // Label 5304: @280191
     /*  280191 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(280254), // Rule ID 8659 //
     /*  280196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  280210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280235 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280252 */     GIR_RootConstrainSelectedInstOperands,
     /*  280253 */     // GIR_Coverage, 8659,
     /*  280253 */     GIR_EraseRootFromParent_Done,
     /*  280254 */   // Label 5305: @280254
     /*  280254 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(280317), // Rule ID 8662 //
     /*  280259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  280273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280298 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280315 */     GIR_RootConstrainSelectedInstOperands,
     /*  280316 */     // GIR_Coverage, 8662,
     /*  280316 */     GIR_EraseRootFromParent_Done,
     /*  280317 */   // Label 5306: @280317
     /*  280317 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(280380), // Rule ID 8663 //
     /*  280322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  280333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  280336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280361 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280378 */     GIR_RootConstrainSelectedInstOperands,
     /*  280379 */     // GIR_Coverage, 8663,
     /*  280379 */     GIR_EraseRootFromParent_Done,
     /*  280380 */   // Label 5307: @280380
     /*  280380 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(280443), // Rule ID 8666 //
     /*  280385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  280399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280441 */     GIR_RootConstrainSelectedInstOperands,
     /*  280442 */     // GIR_Coverage, 8666,
     /*  280442 */     GIR_EraseRootFromParent_Done,
     /*  280443 */   // Label 5308: @280443
     /*  280443 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(280506), // Rule ID 8667 //
     /*  280448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  280462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  280476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280487 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  280490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280504 */     GIR_RootConstrainSelectedInstOperands,
     /*  280505 */     // GIR_Coverage, 8667,
     /*  280505 */     GIR_EraseRootFromParent_Done,
     /*  280506 */   // Label 5309: @280506
     /*  280506 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(280569), // Rule ID 8670 //
     /*  280511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  280525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280550 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280567 */     GIR_RootConstrainSelectedInstOperands,
     /*  280568 */     // GIR_Coverage, 8670,
     /*  280568 */     GIR_EraseRootFromParent_Done,
     /*  280569 */   // Label 5310: @280569
     /*  280569 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(280632), // Rule ID 8671 //
     /*  280574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  280588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280613 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280630 */     GIR_RootConstrainSelectedInstOperands,
     /*  280631 */     // GIR_Coverage, 8671,
     /*  280631 */     GIR_EraseRootFromParent_Done,
     /*  280632 */   // Label 5311: @280632
     /*  280632 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(280695), // Rule ID 8674 //
     /*  280637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  280651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280693 */     GIR_RootConstrainSelectedInstOperands,
     /*  280694 */     // GIR_Coverage, 8674,
     /*  280694 */     GIR_EraseRootFromParent_Done,
     /*  280695 */   // Label 5312: @280695
     /*  280695 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(280758), // Rule ID 8675 //
     /*  280700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  280714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280739 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280756 */     GIR_RootConstrainSelectedInstOperands,
     /*  280757 */     // GIR_Coverage, 8675,
     /*  280757 */     GIR_EraseRootFromParent_Done,
     /*  280758 */   // Label 5313: @280758
     /*  280758 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(280821), // Rule ID 8678 //
     /*  280763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  280777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  280780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280802 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  280805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280819 */     GIR_RootConstrainSelectedInstOperands,
     /*  280820 */     // GIR_Coverage, 8678,
     /*  280820 */     GIR_EraseRootFromParent_Done,
     /*  280821 */   // Label 5314: @280821
     /*  280821 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(280884), // Rule ID 8679 //
     /*  280826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  280840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  280843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280865 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  280868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280882 */     GIR_RootConstrainSelectedInstOperands,
     /*  280883 */     // GIR_Coverage, 8679,
     /*  280883 */     GIR_EraseRootFromParent_Done,
     /*  280884 */   // Label 5315: @280884
     /*  280884 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(280947), // Rule ID 8682 //
     /*  280889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  280903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  280906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280928 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  280931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280945 */     GIR_RootConstrainSelectedInstOperands,
     /*  280946 */     // GIR_Coverage, 8682,
     /*  280946 */     GIR_EraseRootFromParent_Done,
     /*  280947 */   // Label 5316: @280947
     /*  280947 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(281010), // Rule ID 8683 //
     /*  280952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  280966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  280969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280991 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  280994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281008 */     GIR_RootConstrainSelectedInstOperands,
     /*  281009 */     // GIR_Coverage, 8683,
     /*  281009 */     GIR_EraseRootFromParent_Done,
     /*  281010 */   // Label 5317: @281010
     /*  281010 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(281073), // Rule ID 8686 //
     /*  281015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  281029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  281032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281054 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281071 */     GIR_RootConstrainSelectedInstOperands,
     /*  281072 */     // GIR_Coverage, 8686,
     /*  281072 */     GIR_EraseRootFromParent_Done,
     /*  281073 */   // Label 5318: @281073
     /*  281073 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(281136), // Rule ID 8687 //
     /*  281078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  281092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  281095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281117 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281134 */     GIR_RootConstrainSelectedInstOperands,
     /*  281135 */     // GIR_Coverage, 8687,
     /*  281135 */     GIR_EraseRootFromParent_Done,
     /*  281136 */   // Label 5319: @281136
     /*  281136 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(281199), // Rule ID 8690 //
     /*  281141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  281155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  281158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281180 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281197 */     GIR_RootConstrainSelectedInstOperands,
     /*  281198 */     // GIR_Coverage, 8690,
     /*  281198 */     GIR_EraseRootFromParent_Done,
     /*  281199 */   // Label 5320: @281199
     /*  281199 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(281262), // Rule ID 8691 //
     /*  281204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  281218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  281221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281243 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  281246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281260 */     GIR_RootConstrainSelectedInstOperands,
     /*  281261 */     // GIR_Coverage, 8691,
     /*  281261 */     GIR_EraseRootFromParent_Done,
     /*  281262 */   // Label 5321: @281262
     /*  281262 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(281325), // Rule ID 8694 //
     /*  281267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  281281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  281284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281306 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281323 */     GIR_RootConstrainSelectedInstOperands,
     /*  281324 */     // GIR_Coverage, 8694,
     /*  281324 */     GIR_EraseRootFromParent_Done,
     /*  281325 */   // Label 5322: @281325
     /*  281325 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(281388), // Rule ID 8695 //
     /*  281330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  281344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  281347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281369 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281386 */     GIR_RootConstrainSelectedInstOperands,
     /*  281387 */     // GIR_Coverage, 8695,
     /*  281387 */     GIR_EraseRootFromParent_Done,
     /*  281388 */   // Label 5323: @281388
     /*  281388 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(281451), // Rule ID 8698 //
     /*  281393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  281407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  281410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281432 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281449 */     GIR_RootConstrainSelectedInstOperands,
     /*  281450 */     // GIR_Coverage, 8698,
     /*  281450 */     GIR_EraseRootFromParent_Done,
     /*  281451 */   // Label 5324: @281451
     /*  281451 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(281514), // Rule ID 8699 //
     /*  281456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  281470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  281473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281495 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  281498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281512 */     GIR_RootConstrainSelectedInstOperands,
     /*  281513 */     // GIR_Coverage, 8699,
     /*  281513 */     GIR_EraseRootFromParent_Done,
     /*  281514 */   // Label 5325: @281514
     /*  281514 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(281577), // Rule ID 8702 //
     /*  281519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  281533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  281536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281558 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281575 */     GIR_RootConstrainSelectedInstOperands,
     /*  281576 */     // GIR_Coverage, 8702,
     /*  281576 */     GIR_EraseRootFromParent_Done,
     /*  281577 */   // Label 5326: @281577
     /*  281577 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(281640), // Rule ID 8703 //
     /*  281582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  281596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  281599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281621 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281638 */     GIR_RootConstrainSelectedInstOperands,
     /*  281639 */     // GIR_Coverage, 8703,
     /*  281639 */     GIR_EraseRootFromParent_Done,
     /*  281640 */   // Label 5327: @281640
     /*  281640 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(281703), // Rule ID 8706 //
     /*  281645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  281659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  281662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281701 */     GIR_RootConstrainSelectedInstOperands,
     /*  281702 */     // GIR_Coverage, 8706,
     /*  281702 */     GIR_EraseRootFromParent_Done,
     /*  281703 */   // Label 5328: @281703
     /*  281703 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(281766), // Rule ID 8707 //
     /*  281708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  281722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  281725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281747 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281764 */     GIR_RootConstrainSelectedInstOperands,
     /*  281765 */     // GIR_Coverage, 8707,
     /*  281765 */     GIR_EraseRootFromParent_Done,
     /*  281766 */   // Label 5329: @281766
     /*  281766 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(281829), // Rule ID 8710 //
     /*  281771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  281785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  281788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281810 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281827 */     GIR_RootConstrainSelectedInstOperands,
     /*  281828 */     // GIR_Coverage, 8710,
     /*  281828 */     GIR_EraseRootFromParent_Done,
     /*  281829 */   // Label 5330: @281829
     /*  281829 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(281892), // Rule ID 8711 //
     /*  281834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  281848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  281851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281873 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281890 */     GIR_RootConstrainSelectedInstOperands,
     /*  281891 */     // GIR_Coverage, 8711,
     /*  281891 */     GIR_EraseRootFromParent_Done,
     /*  281892 */   // Label 5331: @281892
     /*  281892 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(281955), // Rule ID 8714 //
     /*  281897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  281911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  281914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281936 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281953 */     GIR_RootConstrainSelectedInstOperands,
     /*  281954 */     // GIR_Coverage, 8714,
     /*  281954 */     GIR_EraseRootFromParent_Done,
     /*  281955 */   // Label 5332: @281955
     /*  281955 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(282018), // Rule ID 8715 //
     /*  281960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  281974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  281977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281999 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  282002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282016 */     GIR_RootConstrainSelectedInstOperands,
     /*  282017 */     // GIR_Coverage, 8715,
     /*  282017 */     GIR_EraseRootFromParent_Done,
     /*  282018 */   // Label 5333: @282018
     /*  282018 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(282081), // Rule ID 8718 //
     /*  282023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  282037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  282040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282062 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282079 */     GIR_RootConstrainSelectedInstOperands,
     /*  282080 */     // GIR_Coverage, 8718,
     /*  282080 */     GIR_EraseRootFromParent_Done,
     /*  282081 */   // Label 5334: @282081
     /*  282081 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(282144), // Rule ID 8719 //
     /*  282086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  282100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  282103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282125 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282142 */     GIR_RootConstrainSelectedInstOperands,
     /*  282143 */     // GIR_Coverage, 8719,
     /*  282143 */     GIR_EraseRootFromParent_Done,
     /*  282144 */   // Label 5335: @282144
     /*  282144 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(282207), // Rule ID 8722 //
     /*  282149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  282163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  282166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282188 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282205 */     GIR_RootConstrainSelectedInstOperands,
     /*  282206 */     // GIR_Coverage, 8722,
     /*  282206 */     GIR_EraseRootFromParent_Done,
     /*  282207 */   // Label 5336: @282207
     /*  282207 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(282270), // Rule ID 8723 //
     /*  282212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  282226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  282229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282251 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282268 */     GIR_RootConstrainSelectedInstOperands,
     /*  282269 */     // GIR_Coverage, 8723,
     /*  282269 */     GIR_EraseRootFromParent_Done,
     /*  282270 */   // Label 5337: @282270
     /*  282270 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(282333), // Rule ID 8726 //
     /*  282275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  282286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  282289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  282292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282314 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  282314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282331 */     GIR_RootConstrainSelectedInstOperands,
     /*  282332 */     // GIR_Coverage, 8726,
     /*  282332 */     GIR_EraseRootFromParent_Done,
     /*  282333 */   // Label 5338: @282333
     /*  282333 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(282396), // Rule ID 8727 //
     /*  282338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  282349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  282352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  282355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282377 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  282377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  282394 */     GIR_RootConstrainSelectedInstOperands,
     /*  282395 */     // GIR_Coverage, 8727,
     /*  282395 */     GIR_EraseRootFromParent_Done,
     /*  282396 */   // Label 5339: @282396
     /*  282396 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(282459), // Rule ID 8730 //
     /*  282401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  282415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  282418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282440 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282457 */     GIR_RootConstrainSelectedInstOperands,
     /*  282458 */     // GIR_Coverage, 8730,
     /*  282458 */     GIR_EraseRootFromParent_Done,
     /*  282459 */   // Label 5340: @282459
     /*  282459 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(282522), // Rule ID 8731 //
     /*  282464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  282478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  282481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282503 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282520 */     GIR_RootConstrainSelectedInstOperands,
     /*  282521 */     // GIR_Coverage, 8731,
     /*  282521 */     GIR_EraseRootFromParent_Done,
     /*  282522 */   // Label 5341: @282522
     /*  282522 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(282585), // Rule ID 8734 //
     /*  282527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  282541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  282544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282566 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282583 */     GIR_RootConstrainSelectedInstOperands,
     /*  282584 */     // GIR_Coverage, 8734,
     /*  282584 */     GIR_EraseRootFromParent_Done,
     /*  282585 */   // Label 5342: @282585
     /*  282585 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(282648), // Rule ID 8735 //
     /*  282590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  282604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  282607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282629 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282646 */     GIR_RootConstrainSelectedInstOperands,
     /*  282647 */     // GIR_Coverage, 8735,
     /*  282647 */     GIR_EraseRootFromParent_Done,
     /*  282648 */   // Label 5343: @282648
     /*  282648 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(282711), // Rule ID 8738 //
     /*  282653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  282667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  282670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282692 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282709 */     GIR_RootConstrainSelectedInstOperands,
     /*  282710 */     // GIR_Coverage, 8738,
     /*  282710 */     GIR_EraseRootFromParent_Done,
     /*  282711 */   // Label 5344: @282711
     /*  282711 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(282774), // Rule ID 8739 //
     /*  282716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  282730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  282733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282755 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282772 */     GIR_RootConstrainSelectedInstOperands,
     /*  282773 */     // GIR_Coverage, 8739,
     /*  282773 */     GIR_EraseRootFromParent_Done,
     /*  282774 */   // Label 5345: @282774
     /*  282774 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(282837), // Rule ID 8742 //
     /*  282779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  282793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  282796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282818 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282835 */     GIR_RootConstrainSelectedInstOperands,
     /*  282836 */     // GIR_Coverage, 8742,
     /*  282836 */     GIR_EraseRootFromParent_Done,
     /*  282837 */   // Label 5346: @282837
     /*  282837 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(282900), // Rule ID 8743 //
     /*  282842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  282856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  282859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282881 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282898 */     GIR_RootConstrainSelectedInstOperands,
     /*  282899 */     // GIR_Coverage, 8743,
     /*  282899 */     GIR_EraseRootFromParent_Done,
     /*  282900 */   // Label 5347: @282900
     /*  282900 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(282963), // Rule ID 8746 //
     /*  282905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  282919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  282922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282944 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282961 */     GIR_RootConstrainSelectedInstOperands,
     /*  282962 */     // GIR_Coverage, 8746,
     /*  282962 */     GIR_EraseRootFromParent_Done,
     /*  282963 */   // Label 5348: @282963
     /*  282963 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(283026), // Rule ID 8747 //
     /*  282968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  282982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  282985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283024 */     GIR_RootConstrainSelectedInstOperands,
     /*  283025 */     // GIR_Coverage, 8747,
     /*  283025 */     GIR_EraseRootFromParent_Done,
     /*  283026 */   // Label 5349: @283026
     /*  283026 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(283089), // Rule ID 8750 //
     /*  283031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  283045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  283048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283070 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283087 */     GIR_RootConstrainSelectedInstOperands,
     /*  283088 */     // GIR_Coverage, 8750,
     /*  283088 */     GIR_EraseRootFromParent_Done,
     /*  283089 */   // Label 5350: @283089
     /*  283089 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(283152), // Rule ID 8751 //
     /*  283094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  283105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  283108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  283111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283133 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283150 */     GIR_RootConstrainSelectedInstOperands,
     /*  283151 */     // GIR_Coverage, 8751,
     /*  283151 */     GIR_EraseRootFromParent_Done,
     /*  283152 */   // Label 5351: @283152
     /*  283152 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(283215), // Rule ID 8754 //
     /*  283157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  283171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  283174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283196 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283213 */     GIR_RootConstrainSelectedInstOperands,
     /*  283214 */     // GIR_Coverage, 8754,
     /*  283214 */     GIR_EraseRootFromParent_Done,
     /*  283215 */   // Label 5352: @283215
     /*  283215 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(283278), // Rule ID 8755 //
     /*  283220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  283234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  283237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  283252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283259 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  283262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283276 */     GIR_RootConstrainSelectedInstOperands,
     /*  283277 */     // GIR_Coverage, 8755,
     /*  283277 */     GIR_EraseRootFromParent_Done,
     /*  283278 */   // Label 5353: @283278
     /*  283278 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(283341), // Rule ID 8758 //
     /*  283283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  283297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  283300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283322 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283339 */     GIR_RootConstrainSelectedInstOperands,
     /*  283340 */     // GIR_Coverage, 8758,
     /*  283340 */     GIR_EraseRootFromParent_Done,
     /*  283341 */   // Label 5354: @283341
     /*  283341 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(283404), // Rule ID 8759 //
     /*  283346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  283360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  283363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  283378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283385 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  283388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283402 */     GIR_RootConstrainSelectedInstOperands,
     /*  283403 */     // GIR_Coverage, 8759,
     /*  283403 */     GIR_EraseRootFromParent_Done,
     /*  283404 */   // Label 5355: @283404
     /*  283404 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(283467), // Rule ID 8762 //
     /*  283409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  283412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  283423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  283426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283448 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  283448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283465 */     GIR_RootConstrainSelectedInstOperands,
     /*  283466 */     // GIR_Coverage, 8762,
     /*  283466 */     GIR_EraseRootFromParent_Done,
     /*  283467 */   // Label 5356: @283467
     /*  283467 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(283530), // Rule ID 8763 //
     /*  283472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  283475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  283486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  283489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  283504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283511 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283528 */     GIR_RootConstrainSelectedInstOperands,
     /*  283529 */     // GIR_Coverage, 8763,
     /*  283529 */     GIR_EraseRootFromParent_Done,
     /*  283530 */   // Label 5357: @283530
     /*  283530 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(283593), // Rule ID 8766 //
     /*  283535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  283549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283574 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  283577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283591 */     GIR_RootConstrainSelectedInstOperands,
     /*  283592 */     // GIR_Coverage, 8766,
     /*  283592 */     GIR_EraseRootFromParent_Done,
     /*  283593 */   // Label 5358: @283593
     /*  283593 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(283656), // Rule ID 8767 //
     /*  283598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  283612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283637 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  283640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283654 */     GIR_RootConstrainSelectedInstOperands,
     /*  283655 */     // GIR_Coverage, 8767,
     /*  283655 */     GIR_EraseRootFromParent_Done,
     /*  283656 */   // Label 5359: @283656
     /*  283656 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(283719), // Rule ID 8770 //
     /*  283661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  283675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283700 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283717 */     GIR_RootConstrainSelectedInstOperands,
     /*  283718 */     // GIR_Coverage, 8770,
     /*  283718 */     GIR_EraseRootFromParent_Done,
     /*  283719 */   // Label 5360: @283719
     /*  283719 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(283782), // Rule ID 8771 //
     /*  283724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  283738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283763 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283780 */     GIR_RootConstrainSelectedInstOperands,
     /*  283781 */     // GIR_Coverage, 8771,
     /*  283781 */     GIR_EraseRootFromParent_Done,
     /*  283782 */   // Label 5361: @283782
     /*  283782 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(283845), // Rule ID 8774 //
     /*  283787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  283801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283826 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283843 */     GIR_RootConstrainSelectedInstOperands,
     /*  283844 */     // GIR_Coverage, 8774,
     /*  283844 */     GIR_EraseRootFromParent_Done,
     /*  283845 */   // Label 5362: @283845
     /*  283845 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(283908), // Rule ID 8775 //
     /*  283850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  283864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283889 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283906 */     GIR_RootConstrainSelectedInstOperands,
     /*  283907 */     // GIR_Coverage, 8775,
     /*  283907 */     GIR_EraseRootFromParent_Done,
     /*  283908 */   // Label 5363: @283908
     /*  283908 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(283971), // Rule ID 8778 //
     /*  283913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  283927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283969 */     GIR_RootConstrainSelectedInstOperands,
     /*  283970 */     // GIR_Coverage, 8778,
     /*  283970 */     GIR_EraseRootFromParent_Done,
     /*  283971 */   // Label 5364: @283971
     /*  283971 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(284034), // Rule ID 8779 //
     /*  283976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  283990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284015 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  284018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284032 */     GIR_RootConstrainSelectedInstOperands,
     /*  284033 */     // GIR_Coverage, 8779,
     /*  284033 */     GIR_EraseRootFromParent_Done,
     /*  284034 */   // Label 5365: @284034
     /*  284034 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(284097), // Rule ID 8782 //
     /*  284039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  284053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284078 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284095 */     GIR_RootConstrainSelectedInstOperands,
     /*  284096 */     // GIR_Coverage, 8782,
     /*  284096 */     GIR_EraseRootFromParent_Done,
     /*  284097 */   // Label 5366: @284097
     /*  284097 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(284160), // Rule ID 8783 //
     /*  284102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  284116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284141 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284158 */     GIR_RootConstrainSelectedInstOperands,
     /*  284159 */     // GIR_Coverage, 8783,
     /*  284159 */     GIR_EraseRootFromParent_Done,
     /*  284160 */   // Label 5367: @284160
     /*  284160 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(284223), // Rule ID 8786 //
     /*  284165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  284179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284204 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284221 */     GIR_RootConstrainSelectedInstOperands,
     /*  284222 */     // GIR_Coverage, 8786,
     /*  284222 */     GIR_EraseRootFromParent_Done,
     /*  284223 */   // Label 5368: @284223
     /*  284223 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(284286), // Rule ID 8787 //
     /*  284228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  284242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284267 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  284270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284284 */     GIR_RootConstrainSelectedInstOperands,
     /*  284285 */     // GIR_Coverage, 8787,
     /*  284285 */     GIR_EraseRootFromParent_Done,
     /*  284286 */   // Label 5369: @284286
     /*  284286 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(284349), // Rule ID 8790 //
     /*  284291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  284305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284330 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284347 */     GIR_RootConstrainSelectedInstOperands,
     /*  284348 */     // GIR_Coverage, 8790,
     /*  284348 */     GIR_EraseRootFromParent_Done,
     /*  284349 */   // Label 5370: @284349
     /*  284349 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(284412), // Rule ID 8791 //
     /*  284354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  284368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284393 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284410 */     GIR_RootConstrainSelectedInstOperands,
     /*  284411 */     // GIR_Coverage, 8791,
     /*  284411 */     GIR_EraseRootFromParent_Done,
     /*  284412 */   // Label 5371: @284412
     /*  284412 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(284475), // Rule ID 8794 //
     /*  284417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  284431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284456 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284473 */     GIR_RootConstrainSelectedInstOperands,
     /*  284474 */     // GIR_Coverage, 8794,
     /*  284474 */     GIR_EraseRootFromParent_Done,
     /*  284475 */   // Label 5372: @284475
     /*  284475 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(284538), // Rule ID 8795 //
     /*  284480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  284491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  284494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284519 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284536 */     GIR_RootConstrainSelectedInstOperands,
     /*  284537 */     // GIR_Coverage, 8795,
     /*  284537 */     GIR_EraseRootFromParent_Done,
     /*  284538 */   // Label 5373: @284538
     /*  284538 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(284601), // Rule ID 8798 //
     /*  284543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  284557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284582 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284599 */     GIR_RootConstrainSelectedInstOperands,
     /*  284600 */     // GIR_Coverage, 8798,
     /*  284600 */     GIR_EraseRootFromParent_Done,
     /*  284601 */   // Label 5374: @284601
     /*  284601 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(284664), // Rule ID 8799 //
     /*  284606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  284620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284645 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284662 */     GIR_RootConstrainSelectedInstOperands,
     /*  284663 */     // GIR_Coverage, 8799,
     /*  284663 */     GIR_EraseRootFromParent_Done,
     /*  284664 */   // Label 5375: @284664
     /*  284664 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(284727), // Rule ID 8802 //
     /*  284669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  284672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  284683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  284708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284725 */     GIR_RootConstrainSelectedInstOperands,
     /*  284726 */     // GIR_Coverage, 8802,
     /*  284726 */     GIR_EraseRootFromParent_Done,
     /*  284727 */   // Label 5376: @284727
     /*  284727 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(284790), // Rule ID 8803 //
     /*  284732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  284735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  284746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284771 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  284771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284788 */     GIR_RootConstrainSelectedInstOperands,
     /*  284789 */     // GIR_Coverage, 8803,
     /*  284789 */     GIR_EraseRootFromParent_Done,
     /*  284790 */   // Label 5377: @284790
     /*  284790 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(284853), // Rule ID 8806 //
     /*  284795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  284809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284834 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  284837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284851 */     GIR_RootConstrainSelectedInstOperands,
     /*  284852 */     // GIR_Coverage, 8806,
     /*  284852 */     GIR_EraseRootFromParent_Done,
     /*  284853 */   // Label 5378: @284853
     /*  284853 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(284916), // Rule ID 8807 //
     /*  284858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  284872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284897 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  284900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284914 */     GIR_RootConstrainSelectedInstOperands,
     /*  284915 */     // GIR_Coverage, 8807,
     /*  284915 */     GIR_EraseRootFromParent_Done,
     /*  284916 */   // Label 5379: @284916
     /*  284916 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(284979), // Rule ID 8810 //
     /*  284921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  284932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  284935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284960 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  284963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284977 */     GIR_RootConstrainSelectedInstOperands,
     /*  284978 */     // GIR_Coverage, 8810,
     /*  284978 */     GIR_EraseRootFromParent_Done,
     /*  284979 */   // Label 5380: @284979
     /*  284979 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(285042), // Rule ID 8811 //
     /*  284984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  284995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  284998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285023 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285040 */     GIR_RootConstrainSelectedInstOperands,
     /*  285041 */     // GIR_Coverage, 8811,
     /*  285041 */     GIR_EraseRootFromParent_Done,
     /*  285042 */   // Label 5381: @285042
     /*  285042 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(285105), // Rule ID 8814 //
     /*  285047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  285058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  285061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285086 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285103 */     GIR_RootConstrainSelectedInstOperands,
     /*  285104 */     // GIR_Coverage, 8814,
     /*  285104 */     GIR_EraseRootFromParent_Done,
     /*  285105 */   // Label 5382: @285105
     /*  285105 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(285168), // Rule ID 8815 //
     /*  285110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  285121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  285124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285149 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285166 */     GIR_RootConstrainSelectedInstOperands,
     /*  285167 */     // GIR_Coverage, 8815,
     /*  285167 */     GIR_EraseRootFromParent_Done,
     /*  285168 */   // Label 5383: @285168
     /*  285168 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(285231), // Rule ID 8818 //
     /*  285173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  285187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285212 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285229 */     GIR_RootConstrainSelectedInstOperands,
     /*  285230 */     // GIR_Coverage, 8818,
     /*  285230 */     GIR_EraseRootFromParent_Done,
     /*  285231 */   // Label 5384: @285231
     /*  285231 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(285294), // Rule ID 8819 //
     /*  285236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  285250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285275 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285292 */     GIR_RootConstrainSelectedInstOperands,
     /*  285293 */     // GIR_Coverage, 8819,
     /*  285293 */     GIR_EraseRootFromParent_Done,
     /*  285294 */   // Label 5385: @285294
     /*  285294 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(285357), // Rule ID 8822 //
     /*  285299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  285313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285338 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285355 */     GIR_RootConstrainSelectedInstOperands,
     /*  285356 */     // GIR_Coverage, 8822,
     /*  285356 */     GIR_EraseRootFromParent_Done,
     /*  285357 */   // Label 5386: @285357
     /*  285357 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(285420), // Rule ID 8823 //
     /*  285362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  285376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285401 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285418 */     GIR_RootConstrainSelectedInstOperands,
     /*  285419 */     // GIR_Coverage, 8823,
     /*  285419 */     GIR_EraseRootFromParent_Done,
     /*  285420 */   // Label 5387: @285420
     /*  285420 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(285483), // Rule ID 8826 //
     /*  285425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  285439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285464 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  285464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285481 */     GIR_RootConstrainSelectedInstOperands,
     /*  285482 */     // GIR_Coverage, 8826,
     /*  285482 */     GIR_EraseRootFromParent_Done,
     /*  285483 */   // Label 5388: @285483
     /*  285483 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(285546), // Rule ID 8827 //
     /*  285488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  285499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  285502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285527 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285544 */     GIR_RootConstrainSelectedInstOperands,
     /*  285545 */     // GIR_Coverage, 8827,
     /*  285545 */     GIR_EraseRootFromParent_Done,
     /*  285546 */   // Label 5389: @285546
     /*  285546 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(285609), // Rule ID 8830 //
     /*  285551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  285565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285590 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285607 */     GIR_RootConstrainSelectedInstOperands,
     /*  285608 */     // GIR_Coverage, 8830,
     /*  285608 */     GIR_EraseRootFromParent_Done,
     /*  285609 */   // Label 5390: @285609
     /*  285609 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(285672), // Rule ID 8831 //
     /*  285614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  285628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285653 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285670 */     GIR_RootConstrainSelectedInstOperands,
     /*  285671 */     // GIR_Coverage, 8831,
     /*  285671 */     GIR_EraseRootFromParent_Done,
     /*  285672 */   // Label 5391: @285672
     /*  285672 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(285735), // Rule ID 8834 //
     /*  285677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  285691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285716 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285733 */     GIR_RootConstrainSelectedInstOperands,
     /*  285734 */     // GIR_Coverage, 8834,
     /*  285734 */     GIR_EraseRootFromParent_Done,
     /*  285735 */   // Label 5392: @285735
     /*  285735 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(285798), // Rule ID 8835 //
     /*  285740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  285754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285796 */     GIR_RootConstrainSelectedInstOperands,
     /*  285797 */     // GIR_Coverage, 8835,
     /*  285797 */     GIR_EraseRootFromParent_Done,
     /*  285798 */   // Label 5393: @285798
     /*  285798 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(285861), // Rule ID 8838 //
     /*  285803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  285817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285842 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285859 */     GIR_RootConstrainSelectedInstOperands,
     /*  285860 */     // GIR_Coverage, 8838,
     /*  285860 */     GIR_EraseRootFromParent_Done,
     /*  285861 */   // Label 5394: @285861
     /*  285861 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(285924), // Rule ID 8839 //
     /*  285866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  285880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285905 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285922 */     GIR_RootConstrainSelectedInstOperands,
     /*  285923 */     // GIR_Coverage, 8839,
     /*  285923 */     GIR_EraseRootFromParent_Done,
     /*  285924 */   // Label 5395: @285924
     /*  285924 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(285987), // Rule ID 8842 //
     /*  285929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  285932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  285943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285968 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  285968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285985 */     GIR_RootConstrainSelectedInstOperands,
     /*  285986 */     // GIR_Coverage, 8842,
     /*  285986 */     GIR_EraseRootFromParent_Done,
     /*  285987 */   // Label 5396: @285987
     /*  285987 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(286050), // Rule ID 8843 //
     /*  285992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  285995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  286006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  286020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286031 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  286034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286048 */     GIR_RootConstrainSelectedInstOperands,
     /*  286049 */     // GIR_Coverage, 8843,
     /*  286049 */     GIR_EraseRootFromParent_Done,
     /*  286050 */   // Label 5397: @286050
     /*  286050 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(286113), // Rule ID 8846 //
     /*  286055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  286069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286094 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286111 */     GIR_RootConstrainSelectedInstOperands,
     /*  286112 */     // GIR_Coverage, 8846,
     /*  286112 */     GIR_EraseRootFromParent_Done,
     /*  286113 */   // Label 5398: @286113
     /*  286113 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(286176), // Rule ID 8847 //
     /*  286118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  286132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  286146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286157 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  286160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286174 */     GIR_RootConstrainSelectedInstOperands,
     /*  286175 */     // GIR_Coverage, 8847,
     /*  286175 */     GIR_EraseRootFromParent_Done,
     /*  286176 */   // Label 5399: @286176
     /*  286176 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(286239), // Rule ID 8850 //
     /*  286181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  286195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  286198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286220 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286237 */     GIR_RootConstrainSelectedInstOperands,
     /*  286238 */     // GIR_Coverage, 8850,
     /*  286238 */     GIR_EraseRootFromParent_Done,
     /*  286239 */   // Label 5400: @286239
     /*  286239 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(286302), // Rule ID 8851 //
     /*  286244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  286252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  286258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  286261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  286272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  286276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286283 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  286283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  286286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286300 */     GIR_RootConstrainSelectedInstOperands,
     /*  286301 */     // GIR_Coverage, 8851,
     /*  286301 */     GIR_EraseRootFromParent_Done,
     /*  286302 */   // Label 5401: @286302
     /*  286302 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(286365), // Rule ID 8942 //
     /*  286307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  286321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  286324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286346 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  286349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286363 */     GIR_RootConstrainSelectedInstOperands,
     /*  286364 */     // GIR_Coverage, 8942,
     /*  286364 */     GIR_EraseRootFromParent_Done,
     /*  286365 */   // Label 5402: @286365
     /*  286365 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(286428), // Rule ID 8943 //
     /*  286370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  286384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  286387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286409 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  286412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286426 */     GIR_RootConstrainSelectedInstOperands,
     /*  286427 */     // GIR_Coverage, 8943,
     /*  286427 */     GIR_EraseRootFromParent_Done,
     /*  286428 */   // Label 5403: @286428
     /*  286428 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(286491), // Rule ID 8946 //
     /*  286433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  286447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  286450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286472 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286489 */     GIR_RootConstrainSelectedInstOperands,
     /*  286490 */     // GIR_Coverage, 8946,
     /*  286490 */     GIR_EraseRootFromParent_Done,
     /*  286491 */   // Label 5404: @286491
     /*  286491 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(286554), // Rule ID 8947 //
     /*  286496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  286510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  286513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286535 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286552 */     GIR_RootConstrainSelectedInstOperands,
     /*  286553 */     // GIR_Coverage, 8947,
     /*  286553 */     GIR_EraseRootFromParent_Done,
     /*  286554 */   // Label 5405: @286554
     /*  286554 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(286617), // Rule ID 8950 //
     /*  286559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  286573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  286576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286598 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286615 */     GIR_RootConstrainSelectedInstOperands,
     /*  286616 */     // GIR_Coverage, 8950,
     /*  286616 */     GIR_EraseRootFromParent_Done,
     /*  286617 */   // Label 5406: @286617
     /*  286617 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(286680), // Rule ID 8951 //
     /*  286622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  286636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  286639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286661 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286678 */     GIR_RootConstrainSelectedInstOperands,
     /*  286679 */     // GIR_Coverage, 8951,
     /*  286679 */     GIR_EraseRootFromParent_Done,
     /*  286680 */   // Label 5407: @286680
     /*  286680 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(286743), // Rule ID 8954 //
     /*  286685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  286699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  286702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286724 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286741 */     GIR_RootConstrainSelectedInstOperands,
     /*  286742 */     // GIR_Coverage, 8954,
     /*  286742 */     GIR_EraseRootFromParent_Done,
     /*  286743 */   // Label 5408: @286743
     /*  286743 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(286806), // Rule ID 8955 //
     /*  286748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  286762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  286765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286787 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286804 */     GIR_RootConstrainSelectedInstOperands,
     /*  286805 */     // GIR_Coverage, 8955,
     /*  286805 */     GIR_EraseRootFromParent_Done,
     /*  286806 */   // Label 5409: @286806
     /*  286806 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(286869), // Rule ID 8958 //
     /*  286811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  286825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  286828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286850 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286867 */     GIR_RootConstrainSelectedInstOperands,
     /*  286868 */     // GIR_Coverage, 8958,
     /*  286868 */     GIR_EraseRootFromParent_Done,
     /*  286869 */   // Label 5410: @286869
     /*  286869 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(286932), // Rule ID 8959 //
     /*  286874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  286888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  286891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286913 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286930 */     GIR_RootConstrainSelectedInstOperands,
     /*  286931 */     // GIR_Coverage, 8959,
     /*  286931 */     GIR_EraseRootFromParent_Done,
     /*  286932 */   // Label 5411: @286932
     /*  286932 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(286995), // Rule ID 8962 //
     /*  286937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  286951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  286954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286976 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286993 */     GIR_RootConstrainSelectedInstOperands,
     /*  286994 */     // GIR_Coverage, 8962,
     /*  286994 */     GIR_EraseRootFromParent_Done,
     /*  286995 */   // Label 5412: @286995
     /*  286995 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(287058), // Rule ID 8963 //
     /*  287000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  287014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  287017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287039 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  287039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  287042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287056 */     GIR_RootConstrainSelectedInstOperands,
     /*  287057 */     // GIR_Coverage, 8963,
     /*  287057 */     GIR_EraseRootFromParent_Done,
     /*  287058 */   // Label 5413: @287058
     /*  287058 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(287121), // Rule ID 8966 //
     /*  287063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  287077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  287080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287102 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287119 */     GIR_RootConstrainSelectedInstOperands,
     /*  287120 */     // GIR_Coverage, 8966,
     /*  287120 */     GIR_EraseRootFromParent_Done,
     /*  287121 */   // Label 5414: @287121
     /*  287121 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(287184), // Rule ID 8967 //
     /*  287126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  287140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  287143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287165 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287182 */     GIR_RootConstrainSelectedInstOperands,
     /*  287183 */     // GIR_Coverage, 8967,
     /*  287183 */     GIR_EraseRootFromParent_Done,
     /*  287184 */   // Label 5415: @287184
     /*  287184 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(287247), // Rule ID 8970 //
     /*  287189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  287203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  287206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287228 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287245 */     GIR_RootConstrainSelectedInstOperands,
     /*  287246 */     // GIR_Coverage, 8970,
     /*  287246 */     GIR_EraseRootFromParent_Done,
     /*  287247 */   // Label 5416: @287247
     /*  287247 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(287310), // Rule ID 8971 //
     /*  287252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  287266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  287269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287291 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287308 */     GIR_RootConstrainSelectedInstOperands,
     /*  287309 */     // GIR_Coverage, 8971,
     /*  287309 */     GIR_EraseRootFromParent_Done,
     /*  287310 */   // Label 5417: @287310
     /*  287310 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(287373), // Rule ID 8974 //
     /*  287315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  287329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  287332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287354 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  287354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287371 */     GIR_RootConstrainSelectedInstOperands,
     /*  287372 */     // GIR_Coverage, 8974,
     /*  287372 */     GIR_EraseRootFromParent_Done,
     /*  287373 */   // Label 5418: @287373
     /*  287373 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(287436), // Rule ID 8975 //
     /*  287378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  287389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  287392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  287395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287417 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  287417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287434 */     GIR_RootConstrainSelectedInstOperands,
     /*  287435 */     // GIR_Coverage, 8975,
     /*  287435 */     GIR_EraseRootFromParent_Done,
     /*  287436 */   // Label 5419: @287436
     /*  287436 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(287499), // Rule ID 8978 //
     /*  287441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  287444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  287455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  287458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  287480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287497 */     GIR_RootConstrainSelectedInstOperands,
     /*  287498 */     // GIR_Coverage, 8978,
     /*  287498 */     GIR_EraseRootFromParent_Done,
     /*  287499 */   // Label 5420: @287499
     /*  287499 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(287562), // Rule ID 8979 //
     /*  287504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  287507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  287518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  287521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287543 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  287543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287560 */     GIR_RootConstrainSelectedInstOperands,
     /*  287561 */     // GIR_Coverage, 8979,
     /*  287561 */     GIR_EraseRootFromParent_Done,
     /*  287562 */   // Label 5421: @287562
     /*  287562 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(287625), // Rule ID 8982 //
     /*  287567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  287578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  287581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  287584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287623 */     GIR_RootConstrainSelectedInstOperands,
     /*  287624 */     // GIR_Coverage, 8982,
     /*  287624 */     GIR_EraseRootFromParent_Done,
     /*  287625 */   // Label 5422: @287625
     /*  287625 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(287688), // Rule ID 8983 //
     /*  287630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  287641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  287644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  287647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287669 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287686 */     GIR_RootConstrainSelectedInstOperands,
     /*  287687 */     // GIR_Coverage, 8983,
     /*  287687 */     GIR_EraseRootFromParent_Done,
     /*  287688 */   // Label 5423: @287688
     /*  287688 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(287751), // Rule ID 8986 //
     /*  287693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  287704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  287707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  287710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287732 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  287735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287749 */     GIR_RootConstrainSelectedInstOperands,
     /*  287750 */     // GIR_Coverage, 8986,
     /*  287750 */     GIR_EraseRootFromParent_Done,
     /*  287751 */   // Label 5424: @287751
     /*  287751 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(287814), // Rule ID 8987 //
     /*  287756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  287767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  287770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  287773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287795 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  287798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287812 */     GIR_RootConstrainSelectedInstOperands,
     /*  287813 */     // GIR_Coverage, 8987,
     /*  287813 */     GIR_EraseRootFromParent_Done,
     /*  287814 */   // Label 5425: @287814
     /*  287814 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(287877), // Rule ID 8990 //
     /*  287819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  287830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  287833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  287836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287858 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  287861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287875 */     GIR_RootConstrainSelectedInstOperands,
     /*  287876 */     // GIR_Coverage, 8990,
     /*  287876 */     GIR_EraseRootFromParent_Done,
     /*  287877 */   // Label 5426: @287877
     /*  287877 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(287940), // Rule ID 8991 //
     /*  287882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  287893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  287896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  287899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287921 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  287924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287938 */     GIR_RootConstrainSelectedInstOperands,
     /*  287939 */     // GIR_Coverage, 8991,
     /*  287939 */     GIR_EraseRootFromParent_Done,
     /*  287940 */   // Label 5427: @287940
     /*  287940 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(288003), // Rule ID 8994 //
     /*  287945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  287959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  287962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287984 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288001 */     GIR_RootConstrainSelectedInstOperands,
     /*  288002 */     // GIR_Coverage, 8994,
     /*  288002 */     GIR_EraseRootFromParent_Done,
     /*  288003 */   // Label 5428: @288003
     /*  288003 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(288066), // Rule ID 8995 //
     /*  288008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  288022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  288025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288047 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288064 */     GIR_RootConstrainSelectedInstOperands,
     /*  288065 */     // GIR_Coverage, 8995,
     /*  288065 */     GIR_EraseRootFromParent_Done,
     /*  288066 */   // Label 5429: @288066
     /*  288066 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(288129), // Rule ID 8998 //
     /*  288071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  288085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  288088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288110 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288127 */     GIR_RootConstrainSelectedInstOperands,
     /*  288128 */     // GIR_Coverage, 8998,
     /*  288128 */     GIR_EraseRootFromParent_Done,
     /*  288129 */   // Label 5430: @288129
     /*  288129 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(288192), // Rule ID 8999 //
     /*  288134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  288148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  288151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288173 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288190 */     GIR_RootConstrainSelectedInstOperands,
     /*  288191 */     // GIR_Coverage, 8999,
     /*  288191 */     GIR_EraseRootFromParent_Done,
     /*  288192 */   // Label 5431: @288192
     /*  288192 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(288255), // Rule ID 9002 //
     /*  288197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  288211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  288214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288236 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288253 */     GIR_RootConstrainSelectedInstOperands,
     /*  288254 */     // GIR_Coverage, 9002,
     /*  288254 */     GIR_EraseRootFromParent_Done,
     /*  288255 */   // Label 5432: @288255
     /*  288255 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(288318), // Rule ID 9003 //
     /*  288260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  288271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  288274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  288277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288299 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  288299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  288316 */     GIR_RootConstrainSelectedInstOperands,
     /*  288317 */     // GIR_Coverage, 9003,
     /*  288317 */     GIR_EraseRootFromParent_Done,
     /*  288318 */   // Label 5433: @288318
     /*  288318 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(288381), // Rule ID 9006 //
     /*  288323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  288337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  288340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288362 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288379 */     GIR_RootConstrainSelectedInstOperands,
     /*  288380 */     // GIR_Coverage, 9006,
     /*  288380 */     GIR_EraseRootFromParent_Done,
     /*  288381 */   // Label 5434: @288381
     /*  288381 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(288444), // Rule ID 9007 //
     /*  288386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  288400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  288403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288425 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288442 */     GIR_RootConstrainSelectedInstOperands,
     /*  288443 */     // GIR_Coverage, 9007,
     /*  288443 */     GIR_EraseRootFromParent_Done,
     /*  288444 */   // Label 5435: @288444
     /*  288444 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(288507), // Rule ID 9010 //
     /*  288449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  288463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  288466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288488 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288505 */     GIR_RootConstrainSelectedInstOperands,
     /*  288506 */     // GIR_Coverage, 9010,
     /*  288506 */     GIR_EraseRootFromParent_Done,
     /*  288507 */   // Label 5436: @288507
     /*  288507 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(288570), // Rule ID 9011 //
     /*  288512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  288526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  288529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288551 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288568 */     GIR_RootConstrainSelectedInstOperands,
     /*  288569 */     // GIR_Coverage, 9011,
     /*  288569 */     GIR_EraseRootFromParent_Done,
     /*  288570 */   // Label 5437: @288570
     /*  288570 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(288633), // Rule ID 9014 //
     /*  288575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  288589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  288592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288614 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288631 */     GIR_RootConstrainSelectedInstOperands,
     /*  288632 */     // GIR_Coverage, 9014,
     /*  288632 */     GIR_EraseRootFromParent_Done,
     /*  288633 */   // Label 5438: @288633
     /*  288633 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(288696), // Rule ID 9015 //
     /*  288638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  288652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  288655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288677 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288694 */     GIR_RootConstrainSelectedInstOperands,
     /*  288695 */     // GIR_Coverage, 9015,
     /*  288695 */     GIR_EraseRootFromParent_Done,
     /*  288696 */   // Label 5439: @288696
     /*  288696 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(288759), // Rule ID 9018 //
     /*  288701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  288715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  288718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288740 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288757 */     GIR_RootConstrainSelectedInstOperands,
     /*  288758 */     // GIR_Coverage, 9018,
     /*  288758 */     GIR_EraseRootFromParent_Done,
     /*  288759 */   // Label 5440: @288759
     /*  288759 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(288822), // Rule ID 9019 //
     /*  288764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  288767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  288778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  288781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288803 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288820 */     GIR_RootConstrainSelectedInstOperands,
     /*  288821 */     // GIR_Coverage, 9019,
     /*  288821 */     GIR_EraseRootFromParent_Done,
     /*  288822 */   // Label 5441: @288822
     /*  288822 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(288885), // Rule ID 9022 //
     /*  288827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  288841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  288844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288866 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288883 */     GIR_RootConstrainSelectedInstOperands,
     /*  288884 */     // GIR_Coverage, 9022,
     /*  288884 */     GIR_EraseRootFromParent_Done,
     /*  288885 */   // Label 5442: @288885
     /*  288885 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(288948), // Rule ID 9023 //
     /*  288890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  288893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  288904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  288907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288929 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288946 */     GIR_RootConstrainSelectedInstOperands,
     /*  288947 */     // GIR_Coverage, 9023,
     /*  288947 */     GIR_EraseRootFromParent_Done,
     /*  288948 */   // Label 5443: @288948
     /*  288948 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(289011), // Rule ID 9026 //
     /*  288953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  288967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  288970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289009 */     GIR_RootConstrainSelectedInstOperands,
     /*  289010 */     // GIR_Coverage, 9026,
     /*  289010 */     GIR_EraseRootFromParent_Done,
     /*  289011 */   // Label 5444: @289011
     /*  289011 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(289074), // Rule ID 9027 //
     /*  289016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  289030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  289033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  289048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289055 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  289058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289072 */     GIR_RootConstrainSelectedInstOperands,
     /*  289073 */     // GIR_Coverage, 9027,
     /*  289073 */     GIR_EraseRootFromParent_Done,
     /*  289074 */   // Label 5445: @289074
     /*  289074 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(289137), // Rule ID 9030 //
     /*  289079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  289093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289118 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  289121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289135 */     GIR_RootConstrainSelectedInstOperands,
     /*  289136 */     // GIR_Coverage, 9030,
     /*  289136 */     GIR_EraseRootFromParent_Done,
     /*  289137 */   // Label 5446: @289137
     /*  289137 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(289200), // Rule ID 9031 //
     /*  289142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  289156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289181 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  289184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289198 */     GIR_RootConstrainSelectedInstOperands,
     /*  289199 */     // GIR_Coverage, 9031,
     /*  289199 */     GIR_EraseRootFromParent_Done,
     /*  289200 */   // Label 5447: @289200
     /*  289200 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(289263), // Rule ID 9034 //
     /*  289205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  289219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289244 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289261 */     GIR_RootConstrainSelectedInstOperands,
     /*  289262 */     // GIR_Coverage, 9034,
     /*  289262 */     GIR_EraseRootFromParent_Done,
     /*  289263 */   // Label 5448: @289263
     /*  289263 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(289326), // Rule ID 9035 //
     /*  289268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  289282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289307 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289324 */     GIR_RootConstrainSelectedInstOperands,
     /*  289325 */     // GIR_Coverage, 9035,
     /*  289325 */     GIR_EraseRootFromParent_Done,
     /*  289326 */   // Label 5449: @289326
     /*  289326 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(289389), // Rule ID 9038 //
     /*  289331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  289345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289387 */     GIR_RootConstrainSelectedInstOperands,
     /*  289388 */     // GIR_Coverage, 9038,
     /*  289388 */     GIR_EraseRootFromParent_Done,
     /*  289389 */   // Label 5450: @289389
     /*  289389 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(289452), // Rule ID 9039 //
     /*  289394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  289408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289433 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289450 */     GIR_RootConstrainSelectedInstOperands,
     /*  289451 */     // GIR_Coverage, 9039,
     /*  289451 */     GIR_EraseRootFromParent_Done,
     /*  289452 */   // Label 5451: @289452
     /*  289452 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(289515), // Rule ID 9042 //
     /*  289457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  289471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289496 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289513 */     GIR_RootConstrainSelectedInstOperands,
     /*  289514 */     // GIR_Coverage, 9042,
     /*  289514 */     GIR_EraseRootFromParent_Done,
     /*  289515 */   // Label 5452: @289515
     /*  289515 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(289578), // Rule ID 9043 //
     /*  289520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  289534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289559 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289576 */     GIR_RootConstrainSelectedInstOperands,
     /*  289577 */     // GIR_Coverage, 9043,
     /*  289577 */     GIR_EraseRootFromParent_Done,
     /*  289578 */   // Label 5453: @289578
     /*  289578 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(289641), // Rule ID 9046 //
     /*  289583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  289597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289622 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289639 */     GIR_RootConstrainSelectedInstOperands,
     /*  289640 */     // GIR_Coverage, 9046,
     /*  289640 */     GIR_EraseRootFromParent_Done,
     /*  289641 */   // Label 5454: @289641
     /*  289641 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(289704), // Rule ID 9047 //
     /*  289646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  289660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289685 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289702 */     GIR_RootConstrainSelectedInstOperands,
     /*  289703 */     // GIR_Coverage, 9047,
     /*  289703 */     GIR_EraseRootFromParent_Done,
     /*  289704 */   // Label 5455: @289704
     /*  289704 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(289767), // Rule ID 9050 //
     /*  289709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  289723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289765 */     GIR_RootConstrainSelectedInstOperands,
     /*  289766 */     // GIR_Coverage, 9050,
     /*  289766 */     GIR_EraseRootFromParent_Done,
     /*  289767 */   // Label 5456: @289767
     /*  289767 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(289830), // Rule ID 9051 //
     /*  289772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  289786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289811 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289828 */     GIR_RootConstrainSelectedInstOperands,
     /*  289829 */     // GIR_Coverage, 9051,
     /*  289829 */     GIR_EraseRootFromParent_Done,
     /*  289830 */   // Label 5457: @289830
     /*  289830 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(289893), // Rule ID 9054 //
     /*  289835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  289849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289874 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289891 */     GIR_RootConstrainSelectedInstOperands,
     /*  289892 */     // GIR_Coverage, 9054,
     /*  289892 */     GIR_EraseRootFromParent_Done,
     /*  289893 */   // Label 5458: @289893
     /*  289893 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(289956), // Rule ID 9055 //
     /*  289898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  289912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289937 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289954 */     GIR_RootConstrainSelectedInstOperands,
     /*  289955 */     // GIR_Coverage, 9055,
     /*  289955 */     GIR_EraseRootFromParent_Done,
     /*  289956 */   // Label 5459: @289956
     /*  289956 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(290019), // Rule ID 9058 //
     /*  289961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  289975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290000 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290017 */     GIR_RootConstrainSelectedInstOperands,
     /*  290018 */     // GIR_Coverage, 9058,
     /*  290018 */     GIR_EraseRootFromParent_Done,
     /*  290019 */   // Label 5460: @290019
     /*  290019 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(290082), // Rule ID 9059 //
     /*  290024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  290038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290063 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290080 */     GIR_RootConstrainSelectedInstOperands,
     /*  290081 */     // GIR_Coverage, 9059,
     /*  290081 */     GIR_EraseRootFromParent_Done,
     /*  290082 */   // Label 5461: @290082
     /*  290082 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(290145), // Rule ID 9062 //
     /*  290087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  290101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290126 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290143 */     GIR_RootConstrainSelectedInstOperands,
     /*  290144 */     // GIR_Coverage, 9062,
     /*  290144 */     GIR_EraseRootFromParent_Done,
     /*  290145 */   // Label 5462: @290145
     /*  290145 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(290208), // Rule ID 9063 //
     /*  290150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  290164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290189 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290206 */     GIR_RootConstrainSelectedInstOperands,
     /*  290207 */     // GIR_Coverage, 9063,
     /*  290207 */     GIR_EraseRootFromParent_Done,
     /*  290208 */   // Label 5463: @290208
     /*  290208 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(290271), // Rule ID 9066 //
     /*  290213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  290216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  290227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  290252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290269 */     GIR_RootConstrainSelectedInstOperands,
     /*  290270 */     // GIR_Coverage, 9066,
     /*  290270 */     GIR_EraseRootFromParent_Done,
     /*  290271 */   // Label 5464: @290271
     /*  290271 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(290334), // Rule ID 9067 //
     /*  290276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  290279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  290287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  290290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290315 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  290315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  290318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  290332 */     GIR_RootConstrainSelectedInstOperands,
     /*  290333 */     // GIR_Coverage, 9067,
     /*  290333 */     GIR_EraseRootFromParent_Done,
     /*  290334 */   // Label 5465: @290334
     /*  290334 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(290397), // Rule ID 9070 //
     /*  290339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  290353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290378 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290395 */     GIR_RootConstrainSelectedInstOperands,
     /*  290396 */     // GIR_Coverage, 9070,
     /*  290396 */     GIR_EraseRootFromParent_Done,
     /*  290397 */   // Label 5466: @290397
     /*  290397 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(290460), // Rule ID 9071 //
     /*  290402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  290416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290441 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290458 */     GIR_RootConstrainSelectedInstOperands,
     /*  290459 */     // GIR_Coverage, 9071,
     /*  290459 */     GIR_EraseRootFromParent_Done,
     /*  290460 */   // Label 5467: @290460
     /*  290460 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(290523), // Rule ID 9074 //
     /*  290465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  290479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290504 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290521 */     GIR_RootConstrainSelectedInstOperands,
     /*  290522 */     // GIR_Coverage, 9074,
     /*  290522 */     GIR_EraseRootFromParent_Done,
     /*  290523 */   // Label 5468: @290523
     /*  290523 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(290586), // Rule ID 9075 //
     /*  290528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  290542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290567 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290584 */     GIR_RootConstrainSelectedInstOperands,
     /*  290585 */     // GIR_Coverage, 9075,
     /*  290585 */     GIR_EraseRootFromParent_Done,
     /*  290586 */   // Label 5469: @290586
     /*  290586 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(290649), // Rule ID 9078 //
     /*  290591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  290602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  290605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290630 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290647 */     GIR_RootConstrainSelectedInstOperands,
     /*  290648 */     // GIR_Coverage, 9078,
     /*  290648 */     GIR_EraseRootFromParent_Done,
     /*  290649 */   // Label 5470: @290649
     /*  290649 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(290712), // Rule ID 9079 //
     /*  290654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  290665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  290668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290693 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290710 */     GIR_RootConstrainSelectedInstOperands,
     /*  290711 */     // GIR_Coverage, 9079,
     /*  290711 */     GIR_EraseRootFromParent_Done,
     /*  290712 */   // Label 5471: @290712
     /*  290712 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(290775), // Rule ID 9082 //
     /*  290717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  290731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290756 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290773 */     GIR_RootConstrainSelectedInstOperands,
     /*  290774 */     // GIR_Coverage, 9082,
     /*  290774 */     GIR_EraseRootFromParent_Done,
     /*  290775 */   // Label 5472: @290775
     /*  290775 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(290838), // Rule ID 9083 //
     /*  290780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  290794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290819 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290836 */     GIR_RootConstrainSelectedInstOperands,
     /*  290837 */     // GIR_Coverage, 9083,
     /*  290837 */     GIR_EraseRootFromParent_Done,
     /*  290838 */   // Label 5473: @290838
     /*  290838 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(290901), // Rule ID 9086 //
     /*  290843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  290857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290882 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290899 */     GIR_RootConstrainSelectedInstOperands,
     /*  290900 */     // GIR_Coverage, 9086,
     /*  290900 */     GIR_EraseRootFromParent_Done,
     /*  290901 */   // Label 5474: @290901
     /*  290901 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(290964), // Rule ID 9087 //
     /*  290906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  290920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290945 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290962 */     GIR_RootConstrainSelectedInstOperands,
     /*  290963 */     // GIR_Coverage, 9087,
     /*  290963 */     GIR_EraseRootFromParent_Done,
     /*  290964 */   // Label 5475: @290964
     /*  290964 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(291027), // Rule ID 9090 //
     /*  290969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  290983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291008 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291025 */     GIR_RootConstrainSelectedInstOperands,
     /*  291026 */     // GIR_Coverage, 9090,
     /*  291026 */     GIR_EraseRootFromParent_Done,
     /*  291027 */   // Label 5476: @291027
     /*  291027 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(291090), // Rule ID 9091 //
     /*  291032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  291043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  291046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291071 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291088 */     GIR_RootConstrainSelectedInstOperands,
     /*  291089 */     // GIR_Coverage, 9091,
     /*  291089 */     GIR_EraseRootFromParent_Done,
     /*  291090 */   // Label 5477: @291090
     /*  291090 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(291153), // Rule ID 9094 //
     /*  291095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  291109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291151 */     GIR_RootConstrainSelectedInstOperands,
     /*  291152 */     // GIR_Coverage, 9094,
     /*  291152 */     GIR_EraseRootFromParent_Done,
     /*  291153 */   // Label 5478: @291153
     /*  291153 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(291216), // Rule ID 9095 //
     /*  291158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  291172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291197 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291214 */     GIR_RootConstrainSelectedInstOperands,
     /*  291215 */     // GIR_Coverage, 9095,
     /*  291215 */     GIR_EraseRootFromParent_Done,
     /*  291216 */   // Label 5479: @291216
     /*  291216 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(291279), // Rule ID 9098 //
     /*  291221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  291235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291260 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291277 */     GIR_RootConstrainSelectedInstOperands,
     /*  291278 */     // GIR_Coverage, 9098,
     /*  291278 */     GIR_EraseRootFromParent_Done,
     /*  291279 */   // Label 5480: @291279
     /*  291279 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(291342), // Rule ID 9099 //
     /*  291284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  291298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291323 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291340 */     GIR_RootConstrainSelectedInstOperands,
     /*  291341 */     // GIR_Coverage, 9099,
     /*  291341 */     GIR_EraseRootFromParent_Done,
     /*  291342 */   // Label 5481: @291342
     /*  291342 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(291405), // Rule ID 9102 //
     /*  291347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  291361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291386 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  291386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291403 */     GIR_RootConstrainSelectedInstOperands,
     /*  291404 */     // GIR_Coverage, 9102,
     /*  291404 */     GIR_EraseRootFromParent_Done,
     /*  291405 */   // Label 5482: @291405
     /*  291405 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(291468), // Rule ID 9103 //
     /*  291410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  291421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  291424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291449 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  291449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  291466 */     GIR_RootConstrainSelectedInstOperands,
     /*  291467 */     // GIR_Coverage, 9103,
     /*  291467 */     GIR_EraseRootFromParent_Done,
     /*  291468 */   // Label 5483: @291468
     /*  291468 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(291531), // Rule ID 9106 //
     /*  291473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  291487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291512 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291529 */     GIR_RootConstrainSelectedInstOperands,
     /*  291530 */     // GIR_Coverage, 9106,
     /*  291530 */     GIR_EraseRootFromParent_Done,
     /*  291531 */   // Label 5484: @291531
     /*  291531 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(291594), // Rule ID 9107 //
     /*  291536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  291550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291575 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291592 */     GIR_RootConstrainSelectedInstOperands,
     /*  291593 */     // GIR_Coverage, 9107,
     /*  291593 */     GIR_EraseRootFromParent_Done,
     /*  291594 */   // Label 5485: @291594
     /*  291594 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(291657), // Rule ID 9110 //
     /*  291599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  291613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291638 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291655 */     GIR_RootConstrainSelectedInstOperands,
     /*  291656 */     // GIR_Coverage, 9110,
     /*  291656 */     GIR_EraseRootFromParent_Done,
     /*  291657 */   // Label 5486: @291657
     /*  291657 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(291720), // Rule ID 9111 //
     /*  291662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  291676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291701 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291718 */     GIR_RootConstrainSelectedInstOperands,
     /*  291719 */     // GIR_Coverage, 9111,
     /*  291719 */     GIR_EraseRootFromParent_Done,
     /*  291720 */   // Label 5487: @291720
     /*  291720 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(291783), // Rule ID 9114 //
     /*  291725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  291739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291781 */     GIR_RootConstrainSelectedInstOperands,
     /*  291782 */     // GIR_Coverage, 9114,
     /*  291782 */     GIR_EraseRootFromParent_Done,
     /*  291783 */   // Label 5488: @291783
     /*  291783 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(291846), // Rule ID 9115 //
     /*  291788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  291802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291827 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291844 */     GIR_RootConstrainSelectedInstOperands,
     /*  291845 */     // GIR_Coverage, 9115,
     /*  291845 */     GIR_EraseRootFromParent_Done,
     /*  291846 */   // Label 5489: @291846
     /*  291846 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(291909), // Rule ID 9206 //
     /*  291851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  291865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291890 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  291893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291907 */     GIR_RootConstrainSelectedInstOperands,
     /*  291908 */     // GIR_Coverage, 9206,
     /*  291908 */     GIR_EraseRootFromParent_Done,
     /*  291909 */   // Label 5490: @291909
     /*  291909 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(291972), // Rule ID 9207 //
     /*  291914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  291928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291953 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  291956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291970 */     GIR_RootConstrainSelectedInstOperands,
     /*  291971 */     // GIR_Coverage, 9207,
     /*  291971 */     GIR_EraseRootFromParent_Done,
     /*  291972 */   // Label 5491: @291972
     /*  291972 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(292035), // Rule ID 9210 //
     /*  291977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  291991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292033 */     GIR_RootConstrainSelectedInstOperands,
     /*  292034 */     // GIR_Coverage, 9210,
     /*  292034 */     GIR_EraseRootFromParent_Done,
     /*  292035 */   // Label 5492: @292035
     /*  292035 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(292098), // Rule ID 9211 //
     /*  292040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  292054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292079 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292096 */     GIR_RootConstrainSelectedInstOperands,
     /*  292097 */     // GIR_Coverage, 9211,
     /*  292097 */     GIR_EraseRootFromParent_Done,
     /*  292098 */   // Label 5493: @292098
     /*  292098 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(292161), // Rule ID 9214 //
     /*  292103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  292117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292142 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292159 */     GIR_RootConstrainSelectedInstOperands,
     /*  292160 */     // GIR_Coverage, 9214,
     /*  292160 */     GIR_EraseRootFromParent_Done,
     /*  292161 */   // Label 5494: @292161
     /*  292161 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(292224), // Rule ID 9215 //
     /*  292166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  292180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292205 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292222 */     GIR_RootConstrainSelectedInstOperands,
     /*  292223 */     // GIR_Coverage, 9215,
     /*  292223 */     GIR_EraseRootFromParent_Done,
     /*  292224 */   // Label 5495: @292224
     /*  292224 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(292287), // Rule ID 9218 //
     /*  292229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  292243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292268 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292285 */     GIR_RootConstrainSelectedInstOperands,
     /*  292286 */     // GIR_Coverage, 9218,
     /*  292286 */     GIR_EraseRootFromParent_Done,
     /*  292287 */   // Label 5496: @292287
     /*  292287 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(292350), // Rule ID 9219 //
     /*  292292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  292306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292331 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  292334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292348 */     GIR_RootConstrainSelectedInstOperands,
     /*  292349 */     // GIR_Coverage, 9219,
     /*  292349 */     GIR_EraseRootFromParent_Done,
     /*  292350 */   // Label 5497: @292350
     /*  292350 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(292413), // Rule ID 9222 //
     /*  292355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  292369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292394 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292411 */     GIR_RootConstrainSelectedInstOperands,
     /*  292412 */     // GIR_Coverage, 9222,
     /*  292412 */     GIR_EraseRootFromParent_Done,
     /*  292413 */   // Label 5498: @292413
     /*  292413 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(292476), // Rule ID 9223 //
     /*  292418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  292432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292457 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292474 */     GIR_RootConstrainSelectedInstOperands,
     /*  292475 */     // GIR_Coverage, 9223,
     /*  292475 */     GIR_EraseRootFromParent_Done,
     /*  292476 */   // Label 5499: @292476
     /*  292476 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(292539), // Rule ID 9226 //
     /*  292481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  292495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292537 */     GIR_RootConstrainSelectedInstOperands,
     /*  292538 */     // GIR_Coverage, 9226,
     /*  292538 */     GIR_EraseRootFromParent_Done,
     /*  292539 */   // Label 5500: @292539
     /*  292539 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(292602), // Rule ID 9227 //
     /*  292544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  292558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292583 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292600 */     GIR_RootConstrainSelectedInstOperands,
     /*  292601 */     // GIR_Coverage, 9227,
     /*  292601 */     GIR_EraseRootFromParent_Done,
     /*  292602 */   // Label 5501: @292602
     /*  292602 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(292665), // Rule ID 9230 //
     /*  292607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  292621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292646 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292663 */     GIR_RootConstrainSelectedInstOperands,
     /*  292664 */     // GIR_Coverage, 9230,
     /*  292664 */     GIR_EraseRootFromParent_Done,
     /*  292665 */   // Label 5502: @292665
     /*  292665 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(292728), // Rule ID 9231 //
     /*  292670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  292684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292709 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292726 */     GIR_RootConstrainSelectedInstOperands,
     /*  292727 */     // GIR_Coverage, 9231,
     /*  292727 */     GIR_EraseRootFromParent_Done,
     /*  292728 */   // Label 5503: @292728
     /*  292728 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(292791), // Rule ID 9234 //
     /*  292733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  292747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292789 */     GIR_RootConstrainSelectedInstOperands,
     /*  292790 */     // GIR_Coverage, 9234,
     /*  292790 */     GIR_EraseRootFromParent_Done,
     /*  292791 */   // Label 5504: @292791
     /*  292791 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(292854), // Rule ID 9235 //
     /*  292796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  292810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292835 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292852 */     GIR_RootConstrainSelectedInstOperands,
     /*  292853 */     // GIR_Coverage, 9235,
     /*  292853 */     GIR_EraseRootFromParent_Done,
     /*  292854 */   // Label 5505: @292854
     /*  292854 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(292917), // Rule ID 9238 //
     /*  292859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  292873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292915 */     GIR_RootConstrainSelectedInstOperands,
     /*  292916 */     // GIR_Coverage, 9238,
     /*  292916 */     GIR_EraseRootFromParent_Done,
     /*  292917 */   // Label 5506: @292917
     /*  292917 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(292980), // Rule ID 9239 //
     /*  292922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  292936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292961 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292978 */     GIR_RootConstrainSelectedInstOperands,
     /*  292979 */     // GIR_Coverage, 9239,
     /*  292979 */     GIR_EraseRootFromParent_Done,
     /*  292980 */   // Label 5507: @292980
     /*  292980 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(293043), // Rule ID 9242 //
     /*  292985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  292999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  293024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293041 */     GIR_RootConstrainSelectedInstOperands,
     /*  293042 */     // GIR_Coverage, 9242,
     /*  293042 */     GIR_EraseRootFromParent_Done,
     /*  293043 */   // Label 5508: @293043
     /*  293043 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(293106), // Rule ID 9243 //
     /*  293048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  293051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  293059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  293062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293087 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  293087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  293090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293104 */     GIR_RootConstrainSelectedInstOperands,
     /*  293105 */     // GIR_Coverage, 9243,
     /*  293105 */     GIR_EraseRootFromParent_Done,
     /*  293106 */   // Label 5509: @293106
     /*  293106 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(293169), // Rule ID 9246 //
     /*  293111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  293125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293150 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293167 */     GIR_RootConstrainSelectedInstOperands,
     /*  293168 */     // GIR_Coverage, 9246,
     /*  293168 */     GIR_EraseRootFromParent_Done,
     /*  293169 */   // Label 5510: @293169
     /*  293169 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(293232), // Rule ID 9247 //
     /*  293174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  293188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293213 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293230 */     GIR_RootConstrainSelectedInstOperands,
     /*  293231 */     // GIR_Coverage, 9247,
     /*  293231 */     GIR_EraseRootFromParent_Done,
     /*  293232 */   // Label 5511: @293232
     /*  293232 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(293295), // Rule ID 9250 //
     /*  293237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  293251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293276 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293293 */     GIR_RootConstrainSelectedInstOperands,
     /*  293294 */     // GIR_Coverage, 9250,
     /*  293294 */     GIR_EraseRootFromParent_Done,
     /*  293295 */   // Label 5512: @293295
     /*  293295 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(293358), // Rule ID 9251 //
     /*  293300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  293314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293339 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293356 */     GIR_RootConstrainSelectedInstOperands,
     /*  293357 */     // GIR_Coverage, 9251,
     /*  293357 */     GIR_EraseRootFromParent_Done,
     /*  293358 */   // Label 5513: @293358
     /*  293358 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(293421), // Rule ID 9254 //
     /*  293363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  293374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  293377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293402 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  293402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293419 */     GIR_RootConstrainSelectedInstOperands,
     /*  293420 */     // GIR_Coverage, 9254,
     /*  293420 */     GIR_EraseRootFromParent_Done,
     /*  293421 */   // Label 5514: @293421
     /*  293421 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(293484), // Rule ID 9255 //
     /*  293426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  293437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  293440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293465 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  293465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  293482 */     GIR_RootConstrainSelectedInstOperands,
     /*  293483 */     // GIR_Coverage, 9255,
     /*  293483 */     GIR_EraseRootFromParent_Done,
     /*  293484 */   // Label 5515: @293484
     /*  293484 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(293547), // Rule ID 9258 //
     /*  293489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  293503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293528 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293545 */     GIR_RootConstrainSelectedInstOperands,
     /*  293546 */     // GIR_Coverage, 9258,
     /*  293546 */     GIR_EraseRootFromParent_Done,
     /*  293547 */   // Label 5516: @293547
     /*  293547 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(293610), // Rule ID 9259 //
     /*  293552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  293566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293591 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293608 */     GIR_RootConstrainSelectedInstOperands,
     /*  293609 */     // GIR_Coverage, 9259,
     /*  293609 */     GIR_EraseRootFromParent_Done,
     /*  293610 */   // Label 5517: @293610
     /*  293610 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(293673), // Rule ID 9262 //
     /*  293615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  293629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293654 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293671 */     GIR_RootConstrainSelectedInstOperands,
     /*  293672 */     // GIR_Coverage, 9262,
     /*  293672 */     GIR_EraseRootFromParent_Done,
     /*  293673 */   // Label 5518: @293673
     /*  293673 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(293736), // Rule ID 9263 //
     /*  293678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  293692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293717 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293734 */     GIR_RootConstrainSelectedInstOperands,
     /*  293735 */     // GIR_Coverage, 9263,
     /*  293735 */     GIR_EraseRootFromParent_Done,
     /*  293736 */   // Label 5519: @293736
     /*  293736 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(293799), // Rule ID 9266 //
     /*  293741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  293755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293780 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293797 */     GIR_RootConstrainSelectedInstOperands,
     /*  293798 */     // GIR_Coverage, 9266,
     /*  293798 */     GIR_EraseRootFromParent_Done,
     /*  293799 */   // Label 5520: @293799
     /*  293799 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(293862), // Rule ID 9267 //
     /*  293804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  293818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293843 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293860 */     GIR_RootConstrainSelectedInstOperands,
     /*  293861 */     // GIR_Coverage, 9267,
     /*  293861 */     GIR_EraseRootFromParent_Done,
     /*  293862 */   // Label 5521: @293862
     /*  293862 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(293925), // Rule ID 9270 //
     /*  293867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  293881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293906 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293923 */     GIR_RootConstrainSelectedInstOperands,
     /*  293924 */     // GIR_Coverage, 9270,
     /*  293924 */     GIR_EraseRootFromParent_Done,
     /*  293925 */   // Label 5522: @293925
     /*  293925 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(293988), // Rule ID 9271 //
     /*  293930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  293944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293969 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293986 */     GIR_RootConstrainSelectedInstOperands,
     /*  293987 */     // GIR_Coverage, 9271,
     /*  293987 */     GIR_EraseRootFromParent_Done,
     /*  293988 */   // Label 5523: @293988
     /*  293988 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(294051), // Rule ID 9274 //
     /*  293993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  294007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294049 */     GIR_RootConstrainSelectedInstOperands,
     /*  294050 */     // GIR_Coverage, 9274,
     /*  294050 */     GIR_EraseRootFromParent_Done,
     /*  294051 */   // Label 5524: @294051
     /*  294051 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(294114), // Rule ID 9275 //
     /*  294056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  294070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294095 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294112 */     GIR_RootConstrainSelectedInstOperands,
     /*  294113 */     // GIR_Coverage, 9275,
     /*  294113 */     GIR_EraseRootFromParent_Done,
     /*  294114 */   // Label 5525: @294114
     /*  294114 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(294177), // Rule ID 9278 //
     /*  294119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  294133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294158 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294175 */     GIR_RootConstrainSelectedInstOperands,
     /*  294176 */     // GIR_Coverage, 9278,
     /*  294176 */     GIR_EraseRootFromParent_Done,
     /*  294177 */   // Label 5526: @294177
     /*  294177 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(294240), // Rule ID 9279 //
     /*  294182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  294193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  294196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294221 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294238 */     GIR_RootConstrainSelectedInstOperands,
     /*  294239 */     // GIR_Coverage, 9279,
     /*  294239 */     GIR_EraseRootFromParent_Done,
     /*  294240 */   // Label 5527: @294240
     /*  294240 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(294303), // Rule ID 9282 //
     /*  294245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  294259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294301 */     GIR_RootConstrainSelectedInstOperands,
     /*  294302 */     // GIR_Coverage, 9282,
     /*  294302 */     GIR_EraseRootFromParent_Done,
     /*  294303 */   // Label 5528: @294303
     /*  294303 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(294366), // Rule ID 9283 //
     /*  294308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  294322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  294336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294347 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  294350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294364 */     GIR_RootConstrainSelectedInstOperands,
     /*  294365 */     // GIR_Coverage, 9283,
     /*  294365 */     GIR_EraseRootFromParent_Done,
     /*  294366 */   // Label 5529: @294366
     /*  294366 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(294429), // Rule ID 9286 //
     /*  294371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  294385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294410 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294427 */     GIR_RootConstrainSelectedInstOperands,
     /*  294428 */     // GIR_Coverage, 9286,
     /*  294428 */     GIR_EraseRootFromParent_Done,
     /*  294429 */   // Label 5530: @294429
     /*  294429 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(294492), // Rule ID 9287 //
     /*  294434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  294448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  294462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294473 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  294476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294490 */     GIR_RootConstrainSelectedInstOperands,
     /*  294491 */     // GIR_Coverage, 9287,
     /*  294491 */     GIR_EraseRootFromParent_Done,
     /*  294492 */   // Label 5531: @294492
     /*  294492 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(294555), // Rule ID 9290 //
     /*  294497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  294500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  294511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294536 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294553 */     GIR_RootConstrainSelectedInstOperands,
     /*  294554 */     // GIR_Coverage, 9290,
     /*  294554 */     GIR_EraseRootFromParent_Done,
     /*  294555 */   // Label 5532: @294555
     /*  294555 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(294618), // Rule ID 9291 //
     /*  294560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  294574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294599 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294616 */     GIR_RootConstrainSelectedInstOperands,
     /*  294617 */     // GIR_Coverage, 9291,
     /*  294617 */     GIR_EraseRootFromParent_Done,
     /*  294618 */   // Label 5533: @294618
     /*  294618 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(294681), // Rule ID 9382 //
     /*  294623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  294637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294662 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  294665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294679 */     GIR_RootConstrainSelectedInstOperands,
     /*  294680 */     // GIR_Coverage, 9382,
     /*  294680 */     GIR_EraseRootFromParent_Done,
     /*  294681 */   // Label 5534: @294681
     /*  294681 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(294744), // Rule ID 9383 //
     /*  294686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  294700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294725 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  294728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294742 */     GIR_RootConstrainSelectedInstOperands,
     /*  294743 */     // GIR_Coverage, 9383,
     /*  294743 */     GIR_EraseRootFromParent_Done,
     /*  294744 */   // Label 5535: @294744
     /*  294744 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(294807), // Rule ID 9386 //
     /*  294749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  294763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294788 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  294791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294805 */     GIR_RootConstrainSelectedInstOperands,
     /*  294806 */     // GIR_Coverage, 9386,
     /*  294806 */     GIR_EraseRootFromParent_Done,
     /*  294807 */   // Label 5536: @294807
     /*  294807 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(294870), // Rule ID 9387 //
     /*  294812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  294826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294851 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  294854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294868 */     GIR_RootConstrainSelectedInstOperands,
     /*  294869 */     // GIR_Coverage, 9387,
     /*  294869 */     GIR_EraseRootFromParent_Done,
     /*  294870 */   // Label 5537: @294870
     /*  294870 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(294933), // Rule ID 9390 //
     /*  294875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  294889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294914 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294931 */     GIR_RootConstrainSelectedInstOperands,
     /*  294932 */     // GIR_Coverage, 9390,
     /*  294932 */     GIR_EraseRootFromParent_Done,
     /*  294933 */   // Label 5538: @294933
     /*  294933 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(294996), // Rule ID 9391 //
     /*  294938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  294952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294977 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294994 */     GIR_RootConstrainSelectedInstOperands,
     /*  294995 */     // GIR_Coverage, 9391,
     /*  294995 */     GIR_EraseRootFromParent_Done,
     /*  294996 */   // Label 5539: @294996
     /*  294996 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(295059), // Rule ID 9394 //
     /*  295001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  295015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295057 */     GIR_RootConstrainSelectedInstOperands,
     /*  295058 */     // GIR_Coverage, 9394,
     /*  295058 */     GIR_EraseRootFromParent_Done,
     /*  295059 */   // Label 5540: @295059
     /*  295059 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(295122), // Rule ID 9395 //
     /*  295064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  295078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  295106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295120 */     GIR_RootConstrainSelectedInstOperands,
     /*  295121 */     // GIR_Coverage, 9395,
     /*  295121 */     GIR_EraseRootFromParent_Done,
     /*  295122 */   // Label 5541: @295122
     /*  295122 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(295185), // Rule ID 9398 //
     /*  295127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  295141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295166 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295183 */     GIR_RootConstrainSelectedInstOperands,
     /*  295184 */     // GIR_Coverage, 9398,
     /*  295184 */     GIR_EraseRootFromParent_Done,
     /*  295185 */   // Label 5542: @295185
     /*  295185 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(295248), // Rule ID 9399 //
     /*  295190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  295204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295229 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295246 */     GIR_RootConstrainSelectedInstOperands,
     /*  295247 */     // GIR_Coverage, 9399,
     /*  295247 */     GIR_EraseRootFromParent_Done,
     /*  295248 */   // Label 5543: @295248
     /*  295248 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(295311), // Rule ID 9402 //
     /*  295253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  295267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295309 */     GIR_RootConstrainSelectedInstOperands,
     /*  295310 */     // GIR_Coverage, 9402,
     /*  295310 */     GIR_EraseRootFromParent_Done,
     /*  295311 */   // Label 5544: @295311
     /*  295311 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(295374), // Rule ID 9403 //
     /*  295316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  295330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295355 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  295358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295372 */     GIR_RootConstrainSelectedInstOperands,
     /*  295373 */     // GIR_Coverage, 9403,
     /*  295373 */     GIR_EraseRootFromParent_Done,
     /*  295374 */   // Label 5545: @295374
     /*  295374 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(295437), // Rule ID 9406 //
     /*  295379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  295393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295418 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295435 */     GIR_RootConstrainSelectedInstOperands,
     /*  295436 */     // GIR_Coverage, 9406,
     /*  295436 */     GIR_EraseRootFromParent_Done,
     /*  295437 */   // Label 5546: @295437
     /*  295437 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(295500), // Rule ID 9407 //
     /*  295442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  295456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295481 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295498 */     GIR_RootConstrainSelectedInstOperands,
     /*  295499 */     // GIR_Coverage, 9407,
     /*  295499 */     GIR_EraseRootFromParent_Done,
     /*  295500 */   // Label 5547: @295500
     /*  295500 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(295563), // Rule ID 9410 //
     /*  295505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  295519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295544 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295561 */     GIR_RootConstrainSelectedInstOperands,
     /*  295562 */     // GIR_Coverage, 9410,
     /*  295562 */     GIR_EraseRootFromParent_Done,
     /*  295563 */   // Label 5548: @295563
     /*  295563 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(295626), // Rule ID 9411 //
     /*  295568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  295582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295607 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295624 */     GIR_RootConstrainSelectedInstOperands,
     /*  295625 */     // GIR_Coverage, 9411,
     /*  295625 */     GIR_EraseRootFromParent_Done,
     /*  295626 */   // Label 5549: @295626
     /*  295626 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(295689), // Rule ID 9414 //
     /*  295631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  295645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295670 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295687 */     GIR_RootConstrainSelectedInstOperands,
     /*  295688 */     // GIR_Coverage, 9414,
     /*  295688 */     GIR_EraseRootFromParent_Done,
     /*  295689 */   // Label 5550: @295689
     /*  295689 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(295752), // Rule ID 9415 //
     /*  295694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  295708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295733 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295750 */     GIR_RootConstrainSelectedInstOperands,
     /*  295751 */     // GIR_Coverage, 9415,
     /*  295751 */     GIR_EraseRootFromParent_Done,
     /*  295752 */   // Label 5551: @295752
     /*  295752 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(295815), // Rule ID 9418 //
     /*  295757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  295760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  295771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295796 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295813 */     GIR_RootConstrainSelectedInstOperands,
     /*  295814 */     // GIR_Coverage, 9418,
     /*  295814 */     GIR_EraseRootFromParent_Done,
     /*  295815 */   // Label 5552: @295815
     /*  295815 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(295878), // Rule ID 9419 //
     /*  295820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  295834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295859 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295876 */     GIR_RootConstrainSelectedInstOperands,
     /*  295877 */     // GIR_Coverage, 9419,
     /*  295877 */     GIR_EraseRootFromParent_Done,
     /*  295878 */   // Label 5553: @295878
     /*  295878 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(295941), // Rule ID 9422 //
     /*  295883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  295897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  295925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295939 */     GIR_RootConstrainSelectedInstOperands,
     /*  295940 */     // GIR_Coverage, 9422,
     /*  295940 */     GIR_EraseRootFromParent_Done,
     /*  295941 */   // Label 5554: @295941
     /*  295941 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(296004), // Rule ID 9423 //
     /*  295946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  295960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295985 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  295988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296002 */     GIR_RootConstrainSelectedInstOperands,
     /*  296003 */     // GIR_Coverage, 9423,
     /*  296003 */     GIR_EraseRootFromParent_Done,
     /*  296004 */   // Label 5555: @296004
     /*  296004 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(296067), // Rule ID 9426 //
     /*  296009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  296023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296065 */     GIR_RootConstrainSelectedInstOperands,
     /*  296066 */     // GIR_Coverage, 9426,
     /*  296066 */     GIR_EraseRootFromParent_Done,
     /*  296067 */   // Label 5556: @296067
     /*  296067 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(296130), // Rule ID 9427 //
     /*  296072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  296086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296111 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296128 */     GIR_RootConstrainSelectedInstOperands,
     /*  296129 */     // GIR_Coverage, 9427,
     /*  296129 */     GIR_EraseRootFromParent_Done,
     /*  296130 */   // Label 5557: @296130
     /*  296130 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(296193), // Rule ID 9430 //
     /*  296135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  296146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  296149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296174 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296191 */     GIR_RootConstrainSelectedInstOperands,
     /*  296192 */     // GIR_Coverage, 9430,
     /*  296192 */     GIR_EraseRootFromParent_Done,
     /*  296193 */   // Label 5558: @296193
     /*  296193 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(296256), // Rule ID 9431 //
     /*  296198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  296209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  296212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296237 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296254 */     GIR_RootConstrainSelectedInstOperands,
     /*  296255 */     // GIR_Coverage, 9431,
     /*  296255 */     GIR_EraseRootFromParent_Done,
     /*  296256 */   // Label 5559: @296256
     /*  296256 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(296319), // Rule ID 9434 //
     /*  296261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  296275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296317 */     GIR_RootConstrainSelectedInstOperands,
     /*  296318 */     // GIR_Coverage, 9434,
     /*  296318 */     GIR_EraseRootFromParent_Done,
     /*  296319 */   // Label 5560: @296319
     /*  296319 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(296382), // Rule ID 9435 //
     /*  296324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  296338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296363 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296380 */     GIR_RootConstrainSelectedInstOperands,
     /*  296381 */     // GIR_Coverage, 9435,
     /*  296381 */     GIR_EraseRootFromParent_Done,
     /*  296382 */   // Label 5561: @296382
     /*  296382 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(296445), // Rule ID 9438 //
     /*  296387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  296401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296426 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296443 */     GIR_RootConstrainSelectedInstOperands,
     /*  296444 */     // GIR_Coverage, 9438,
     /*  296444 */     GIR_EraseRootFromParent_Done,
     /*  296445 */   // Label 5562: @296445
     /*  296445 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(296508), // Rule ID 9439 //
     /*  296450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  296464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296489 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296506 */     GIR_RootConstrainSelectedInstOperands,
     /*  296507 */     // GIR_Coverage, 9439,
     /*  296507 */     GIR_EraseRootFromParent_Done,
     /*  296508 */   // Label 5563: @296508
     /*  296508 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(296571), // Rule ID 9442 //
     /*  296513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  296527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296552 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296569 */     GIR_RootConstrainSelectedInstOperands,
     /*  296570 */     // GIR_Coverage, 9442,
     /*  296570 */     GIR_EraseRootFromParent_Done,
     /*  296571 */   // Label 5564: @296571
     /*  296571 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(296634), // Rule ID 9443 //
     /*  296576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  296590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296615 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296632 */     GIR_RootConstrainSelectedInstOperands,
     /*  296633 */     // GIR_Coverage, 9443,
     /*  296633 */     GIR_EraseRootFromParent_Done,
     /*  296634 */   // Label 5565: @296634
     /*  296634 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(296697), // Rule ID 9446 //
     /*  296639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  296653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296678 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296695 */     GIR_RootConstrainSelectedInstOperands,
     /*  296696 */     // GIR_Coverage, 9446,
     /*  296696 */     GIR_EraseRootFromParent_Done,
     /*  296697 */   // Label 5566: @296697
     /*  296697 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(296760), // Rule ID 9447 //
     /*  296702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  296716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296741 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296758 */     GIR_RootConstrainSelectedInstOperands,
     /*  296759 */     // GIR_Coverage, 9447,
     /*  296759 */     GIR_EraseRootFromParent_Done,
     /*  296760 */   // Label 5567: @296760
     /*  296760 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(296823), // Rule ID 9450 //
     /*  296765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  296779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296821 */     GIR_RootConstrainSelectedInstOperands,
     /*  296822 */     // GIR_Coverage, 9450,
     /*  296822 */     GIR_EraseRootFromParent_Done,
     /*  296823 */   // Label 5568: @296823
     /*  296823 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(296886), // Rule ID 9451 //
     /*  296828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  296842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296867 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296884 */     GIR_RootConstrainSelectedInstOperands,
     /*  296885 */     // GIR_Coverage, 9451,
     /*  296885 */     GIR_EraseRootFromParent_Done,
     /*  296886 */   // Label 5569: @296886
     /*  296886 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(296949), // Rule ID 9454 //
     /*  296891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  296905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296930 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296947 */     GIR_RootConstrainSelectedInstOperands,
     /*  296948 */     // GIR_Coverage, 9454,
     /*  296948 */     GIR_EraseRootFromParent_Done,
     /*  296949 */   // Label 5570: @296949
     /*  296949 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(297012), // Rule ID 9455 //
     /*  296954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  296968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296993 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297010 */     GIR_RootConstrainSelectedInstOperands,
     /*  297011 */     // GIR_Coverage, 9455,
     /*  297011 */     GIR_EraseRootFromParent_Done,
     /*  297012 */   // Label 5571: @297012
     /*  297012 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(297075), // Rule ID 9458 //
     /*  297017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  297031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297056 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297073 */     GIR_RootConstrainSelectedInstOperands,
     /*  297074 */     // GIR_Coverage, 9458,
     /*  297074 */     GIR_EraseRootFromParent_Done,
     /*  297075 */   // Label 5572: @297075
     /*  297075 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(297138), // Rule ID 9459 //
     /*  297080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  297094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  297108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297119 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  297122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297136 */     GIR_RootConstrainSelectedInstOperands,
     /*  297137 */     // GIR_Coverage, 9459,
     /*  297137 */     GIR_EraseRootFromParent_Done,
     /*  297138 */   // Label 5573: @297138
     /*  297138 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(297201), // Rule ID 9462 //
     /*  297143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  297157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297182 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297199 */     GIR_RootConstrainSelectedInstOperands,
     /*  297200 */     // GIR_Coverage, 9462,
     /*  297200 */     GIR_EraseRootFromParent_Done,
     /*  297201 */   // Label 5574: @297201
     /*  297201 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(297264), // Rule ID 9463 //
     /*  297206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  297220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  297234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297245 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  297248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297262 */     GIR_RootConstrainSelectedInstOperands,
     /*  297263 */     // GIR_Coverage, 9463,
     /*  297263 */     GIR_EraseRootFromParent_Done,
     /*  297264 */   // Label 5575: @297264
     /*  297264 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(297327), // Rule ID 9466 //
     /*  297269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  297283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  297286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297308 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297325 */     GIR_RootConstrainSelectedInstOperands,
     /*  297326 */     // GIR_Coverage, 9466,
     /*  297326 */     GIR_EraseRootFromParent_Done,
     /*  297327 */   // Label 5576: @297327
     /*  297327 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(297390), // Rule ID 9467 //
     /*  297332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  297340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  297346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  297349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  297360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  297364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297371 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  297374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  297378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  297380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297388 */     GIR_RootConstrainSelectedInstOperands,
     /*  297389 */     // GIR_Coverage, 9467,
     /*  297389 */     GIR_EraseRootFromParent_Done,
     /*  297390 */   // Label 5577: @297390
     /*  297390 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(297453), // Rule ID 9558 //
     /*  297395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  297409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  297412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297434 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297451 */     GIR_RootConstrainSelectedInstOperands,
     /*  297452 */     // GIR_Coverage, 9558,
     /*  297452 */     GIR_EraseRootFromParent_Done,
     /*  297453 */   // Label 5578: @297453
     /*  297453 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(297516), // Rule ID 9559 //
     /*  297458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  297472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  297475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297497 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297514 */     GIR_RootConstrainSelectedInstOperands,
     /*  297515 */     // GIR_Coverage, 9559,
     /*  297515 */     GIR_EraseRootFromParent_Done,
     /*  297516 */   // Label 5579: @297516
     /*  297516 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(297579), // Rule ID 9562 //
     /*  297521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  297535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  297538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297560 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297577 */     GIR_RootConstrainSelectedInstOperands,
     /*  297578 */     // GIR_Coverage, 9562,
     /*  297578 */     GIR_EraseRootFromParent_Done,
     /*  297579 */   // Label 5580: @297579
     /*  297579 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(297642), // Rule ID 9563 //
     /*  297584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  297598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  297601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297623 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297640 */     GIR_RootConstrainSelectedInstOperands,
     /*  297641 */     // GIR_Coverage, 9563,
     /*  297641 */     GIR_EraseRootFromParent_Done,
     /*  297642 */   // Label 5581: @297642
     /*  297642 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(297705), // Rule ID 9566 //
     /*  297647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  297661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  297664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297686 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297703 */     GIR_RootConstrainSelectedInstOperands,
     /*  297704 */     // GIR_Coverage, 9566,
     /*  297704 */     GIR_EraseRootFromParent_Done,
     /*  297705 */   // Label 5582: @297705
     /*  297705 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(297768), // Rule ID 9567 //
     /*  297710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  297724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  297727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297749 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297766 */     GIR_RootConstrainSelectedInstOperands,
     /*  297767 */     // GIR_Coverage, 9567,
     /*  297767 */     GIR_EraseRootFromParent_Done,
     /*  297768 */   // Label 5583: @297768
     /*  297768 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(297831), // Rule ID 9570 //
     /*  297773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  297787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  297790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297812 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297829 */     GIR_RootConstrainSelectedInstOperands,
     /*  297830 */     // GIR_Coverage, 9570,
     /*  297830 */     GIR_EraseRootFromParent_Done,
     /*  297831 */   // Label 5584: @297831
     /*  297831 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(297894), // Rule ID 9571 //
     /*  297836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  297850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  297853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297875 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297892 */     GIR_RootConstrainSelectedInstOperands,
     /*  297893 */     // GIR_Coverage, 9571,
     /*  297893 */     GIR_EraseRootFromParent_Done,
     /*  297894 */   // Label 5585: @297894
     /*  297894 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(297957), // Rule ID 9574 //
     /*  297899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  297913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  297916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297938 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297955 */     GIR_RootConstrainSelectedInstOperands,
     /*  297956 */     // GIR_Coverage, 9574,
     /*  297956 */     GIR_EraseRootFromParent_Done,
     /*  297957 */   // Label 5586: @297957
     /*  297957 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(298020), // Rule ID 9575 //
     /*  297962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  297976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  297979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298001 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  298004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298018 */     GIR_RootConstrainSelectedInstOperands,
     /*  298019 */     // GIR_Coverage, 9575,
     /*  298019 */     GIR_EraseRootFromParent_Done,
     /*  298020 */   // Label 5587: @298020
     /*  298020 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(298083), // Rule ID 9578 //
     /*  298025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  298039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  298042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298081 */     GIR_RootConstrainSelectedInstOperands,
     /*  298082 */     // GIR_Coverage, 9578,
     /*  298082 */     GIR_EraseRootFromParent_Done,
     /*  298083 */   // Label 5588: @298083
     /*  298083 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(298146), // Rule ID 9579 //
     /*  298088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  298102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  298105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298127 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298144 */     GIR_RootConstrainSelectedInstOperands,
     /*  298145 */     // GIR_Coverage, 9579,
     /*  298145 */     GIR_EraseRootFromParent_Done,
     /*  298146 */   // Label 5589: @298146
     /*  298146 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(298209), // Rule ID 9582 //
     /*  298151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  298165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  298168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298190 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298207 */     GIR_RootConstrainSelectedInstOperands,
     /*  298208 */     // GIR_Coverage, 9582,
     /*  298208 */     GIR_EraseRootFromParent_Done,
     /*  298209 */   // Label 5590: @298209
     /*  298209 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(298272), // Rule ID 9583 //
     /*  298214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  298228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  298231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298253 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298270 */     GIR_RootConstrainSelectedInstOperands,
     /*  298271 */     // GIR_Coverage, 9583,
     /*  298271 */     GIR_EraseRootFromParent_Done,
     /*  298272 */   // Label 5591: @298272
     /*  298272 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(298335), // Rule ID 9586 //
     /*  298277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  298291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  298294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298316 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298333 */     GIR_RootConstrainSelectedInstOperands,
     /*  298334 */     // GIR_Coverage, 9586,
     /*  298334 */     GIR_EraseRootFromParent_Done,
     /*  298335 */   // Label 5592: @298335
     /*  298335 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(298398), // Rule ID 9587 //
     /*  298340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  298351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  298354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  298357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298379 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298396 */     GIR_RootConstrainSelectedInstOperands,
     /*  298397 */     // GIR_Coverage, 9587,
     /*  298397 */     GIR_EraseRootFromParent_Done,
     /*  298398 */   // Label 5593: @298398
     /*  298398 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(298461), // Rule ID 9590 //
     /*  298403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  298406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  298417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  298420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298442 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  298442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298459 */     GIR_RootConstrainSelectedInstOperands,
     /*  298460 */     // GIR_Coverage, 9590,
     /*  298460 */     GIR_EraseRootFromParent_Done,
     /*  298461 */   // Label 5594: @298461
     /*  298461 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(298524), // Rule ID 9591 //
     /*  298466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  298469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  298477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  298480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  298483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298505 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  298505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298522 */     GIR_RootConstrainSelectedInstOperands,
     /*  298523 */     // GIR_Coverage, 9591,
     /*  298523 */     GIR_EraseRootFromParent_Done,
     /*  298524 */   // Label 5595: @298524
     /*  298524 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(298587), // Rule ID 9594 //
     /*  298529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  298543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  298546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298568 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298585 */     GIR_RootConstrainSelectedInstOperands,
     /*  298586 */     // GIR_Coverage, 9594,
     /*  298586 */     GIR_EraseRootFromParent_Done,
     /*  298587 */   // Label 5596: @298587
     /*  298587 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(298650), // Rule ID 9595 //
     /*  298592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  298606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  298609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298631 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298648 */     GIR_RootConstrainSelectedInstOperands,
     /*  298649 */     // GIR_Coverage, 9595,
     /*  298649 */     GIR_EraseRootFromParent_Done,
     /*  298650 */   // Label 5597: @298650
     /*  298650 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(298713), // Rule ID 9598 //
     /*  298655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  298666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  298669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  298672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298694 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  298697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298711 */     GIR_RootConstrainSelectedInstOperands,
     /*  298712 */     // GIR_Coverage, 9598,
     /*  298712 */     GIR_EraseRootFromParent_Done,
     /*  298713 */   // Label 5598: @298713
     /*  298713 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(298776), // Rule ID 9599 //
     /*  298718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  298729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  298732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  298735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298757 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  298760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298774 */     GIR_RootConstrainSelectedInstOperands,
     /*  298775 */     // GIR_Coverage, 9599,
     /*  298775 */     GIR_EraseRootFromParent_Done,
     /*  298776 */   // Label 5599: @298776
     /*  298776 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(298839), // Rule ID 9602 //
     /*  298781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  298792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  298795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  298798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298820 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  298823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298837 */     GIR_RootConstrainSelectedInstOperands,
     /*  298838 */     // GIR_Coverage, 9602,
     /*  298838 */     GIR_EraseRootFromParent_Done,
     /*  298839 */   // Label 5600: @298839
     /*  298839 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(298902), // Rule ID 9603 //
     /*  298844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  298855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  298858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  298861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298883 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  298886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298900 */     GIR_RootConstrainSelectedInstOperands,
     /*  298901 */     // GIR_Coverage, 9603,
     /*  298901 */     GIR_EraseRootFromParent_Done,
     /*  298902 */   // Label 5601: @298902
     /*  298902 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(298965), // Rule ID 9606 //
     /*  298907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  298921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  298924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298946 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298963 */     GIR_RootConstrainSelectedInstOperands,
     /*  298964 */     // GIR_Coverage, 9606,
     /*  298964 */     GIR_EraseRootFromParent_Done,
     /*  298965 */   // Label 5602: @298965
     /*  298965 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(299028), // Rule ID 9607 //
     /*  298970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  298984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  298987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299009 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299026 */     GIR_RootConstrainSelectedInstOperands,
     /*  299027 */     // GIR_Coverage, 9607,
     /*  299027 */     GIR_EraseRootFromParent_Done,
     /*  299028 */   // Label 5603: @299028
     /*  299028 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(299091), // Rule ID 9610 //
     /*  299033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  299047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  299050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299072 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299089 */     GIR_RootConstrainSelectedInstOperands,
     /*  299090 */     // GIR_Coverage, 9610,
     /*  299090 */     GIR_EraseRootFromParent_Done,
     /*  299091 */   // Label 5604: @299091
     /*  299091 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(299154), // Rule ID 9611 //
     /*  299096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  299110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  299113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299135 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299152 */     GIR_RootConstrainSelectedInstOperands,
     /*  299153 */     // GIR_Coverage, 9611,
     /*  299153 */     GIR_EraseRootFromParent_Done,
     /*  299154 */   // Label 5605: @299154
     /*  299154 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(299217), // Rule ID 9614 //
     /*  299159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  299173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  299176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299198 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299215 */     GIR_RootConstrainSelectedInstOperands,
     /*  299216 */     // GIR_Coverage, 9614,
     /*  299216 */     GIR_EraseRootFromParent_Done,
     /*  299217 */   // Label 5606: @299217
     /*  299217 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(299280), // Rule ID 9615 //
     /*  299222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  299233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  299236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  299239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299261 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  299261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299278 */     GIR_RootConstrainSelectedInstOperands,
     /*  299279 */     // GIR_Coverage, 9615,
     /*  299279 */     GIR_EraseRootFromParent_Done,
     /*  299280 */   // Label 5607: @299280
     /*  299280 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(299343), // Rule ID 9618 //
     /*  299285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  299299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  299302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299324 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299341 */     GIR_RootConstrainSelectedInstOperands,
     /*  299342 */     // GIR_Coverage, 9618,
     /*  299342 */     GIR_EraseRootFromParent_Done,
     /*  299343 */   // Label 5608: @299343
     /*  299343 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(299406), // Rule ID 9619 //
     /*  299348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  299362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  299365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299387 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299404 */     GIR_RootConstrainSelectedInstOperands,
     /*  299405 */     // GIR_Coverage, 9619,
     /*  299405 */     GIR_EraseRootFromParent_Done,
     /*  299406 */   // Label 5609: @299406
     /*  299406 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(299469), // Rule ID 9622 //
     /*  299411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  299425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  299428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299450 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299467 */     GIR_RootConstrainSelectedInstOperands,
     /*  299468 */     // GIR_Coverage, 9622,
     /*  299468 */     GIR_EraseRootFromParent_Done,
     /*  299469 */   // Label 5610: @299469
     /*  299469 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(299532), // Rule ID 9623 //
     /*  299474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  299488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  299491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299513 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299530 */     GIR_RootConstrainSelectedInstOperands,
     /*  299531 */     // GIR_Coverage, 9623,
     /*  299531 */     GIR_EraseRootFromParent_Done,
     /*  299532 */   // Label 5611: @299532
     /*  299532 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(299595), // Rule ID 9626 //
     /*  299537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  299551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  299554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299576 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299593 */     GIR_RootConstrainSelectedInstOperands,
     /*  299594 */     // GIR_Coverage, 9626,
     /*  299594 */     GIR_EraseRootFromParent_Done,
     /*  299595 */   // Label 5612: @299595
     /*  299595 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(299658), // Rule ID 9627 //
     /*  299600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  299614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  299617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299639 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299656 */     GIR_RootConstrainSelectedInstOperands,
     /*  299657 */     // GIR_Coverage, 9627,
     /*  299657 */     GIR_EraseRootFromParent_Done,
     /*  299658 */   // Label 5613: @299658
     /*  299658 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(299721), // Rule ID 9630 //
     /*  299663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  299677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  299680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299702 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299719 */     GIR_RootConstrainSelectedInstOperands,
     /*  299720 */     // GIR_Coverage, 9630,
     /*  299720 */     GIR_EraseRootFromParent_Done,
     /*  299721 */   // Label 5614: @299721
     /*  299721 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(299784), // Rule ID 9631 //
     /*  299726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  299740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  299743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299765 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299782 */     GIR_RootConstrainSelectedInstOperands,
     /*  299783 */     // GIR_Coverage, 9631,
     /*  299783 */     GIR_EraseRootFromParent_Done,
     /*  299784 */   // Label 5615: @299784
     /*  299784 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(299847), // Rule ID 9634 //
     /*  299789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  299803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  299806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299828 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299845 */     GIR_RootConstrainSelectedInstOperands,
     /*  299846 */     // GIR_Coverage, 9634,
     /*  299846 */     GIR_EraseRootFromParent_Done,
     /*  299847 */   // Label 5616: @299847
     /*  299847 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(299910), // Rule ID 9635 //
     /*  299852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  299866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  299869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299891 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299908 */     GIR_RootConstrainSelectedInstOperands,
     /*  299909 */     // GIR_Coverage, 9635,
     /*  299909 */     GIR_EraseRootFromParent_Done,
     /*  299910 */   // Label 5617: @299910
     /*  299910 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(299973), // Rule ID 9638 //
     /*  299915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  299929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  299932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299954 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299971 */     GIR_RootConstrainSelectedInstOperands,
     /*  299972 */     // GIR_Coverage, 9638,
     /*  299972 */     GIR_EraseRootFromParent_Done,
     /*  299973 */   // Label 5618: @299973
     /*  299973 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(300036), // Rule ID 9639 //
     /*  299978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  299992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  299995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  300010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300017 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  300020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300034 */     GIR_RootConstrainSelectedInstOperands,
     /*  300035 */     // GIR_Coverage, 9639,
     /*  300035 */     GIR_EraseRootFromParent_Done,
     /*  300036 */   // Label 5619: @300036
     /*  300036 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(300099), // Rule ID 9642 //
     /*  300041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  300055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  300058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300080 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  300083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300097 */     GIR_RootConstrainSelectedInstOperands,
     /*  300098 */     // GIR_Coverage, 9642,
     /*  300098 */     GIR_EraseRootFromParent_Done,
     /*  300099 */   // Label 5620: @300099
     /*  300099 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(300162), // Rule ID 9643 //
     /*  300104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  300118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  300121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300143 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  300146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300160 */     GIR_RootConstrainSelectedInstOperands,
     /*  300161 */     // GIR_Coverage, 9643,
     /*  300161 */     GIR_EraseRootFromParent_Done,
     /*  300162 */   // Label 5621: @300162
     /*  300162 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(300225), // Rule ID 9646 //
     /*  300167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  300181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  300184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300206 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300223 */     GIR_RootConstrainSelectedInstOperands,
     /*  300224 */     // GIR_Coverage, 9646,
     /*  300224 */     GIR_EraseRootFromParent_Done,
     /*  300225 */   // Label 5622: @300225
     /*  300225 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(300288), // Rule ID 9647 //
     /*  300230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  300244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  300247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300269 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300286 */     GIR_RootConstrainSelectedInstOperands,
     /*  300287 */     // GIR_Coverage, 9647,
     /*  300287 */     GIR_EraseRootFromParent_Done,
     /*  300288 */   // Label 5623: @300288
     /*  300288 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(300351), // Rule ID 9650 //
     /*  300293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  300307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  300310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300349 */     GIR_RootConstrainSelectedInstOperands,
     /*  300350 */     // GIR_Coverage, 9650,
     /*  300350 */     GIR_EraseRootFromParent_Done,
     /*  300351 */   // Label 5624: @300351
     /*  300351 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(300414), // Rule ID 9651 //
     /*  300356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  300370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  300373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300395 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300412 */     GIR_RootConstrainSelectedInstOperands,
     /*  300413 */     // GIR_Coverage, 9651,
     /*  300413 */     GIR_EraseRootFromParent_Done,
     /*  300414 */   // Label 5625: @300414
     /*  300414 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(300477), // Rule ID 9654 //
     /*  300419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  300433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300458 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300475 */     GIR_RootConstrainSelectedInstOperands,
     /*  300476 */     // GIR_Coverage, 9654,
     /*  300476 */     GIR_EraseRootFromParent_Done,
     /*  300477 */   // Label 5626: @300477
     /*  300477 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(300540), // Rule ID 9655 //
     /*  300482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  300496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  300499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300521 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300538 */     GIR_RootConstrainSelectedInstOperands,
     /*  300539 */     // GIR_Coverage, 9655,
     /*  300539 */     GIR_EraseRootFromParent_Done,
     /*  300540 */   // Label 5627: @300540
     /*  300540 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(300603), // Rule ID 9658 //
     /*  300545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  300559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  300562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300584 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300601 */     GIR_RootConstrainSelectedInstOperands,
     /*  300602 */     // GIR_Coverage, 9658,
     /*  300602 */     GIR_EraseRootFromParent_Done,
     /*  300603 */   // Label 5628: @300603
     /*  300603 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(300666), // Rule ID 9659 //
     /*  300608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  300622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  300625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300647 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300664 */     GIR_RootConstrainSelectedInstOperands,
     /*  300665 */     // GIR_Coverage, 9659,
     /*  300665 */     GIR_EraseRootFromParent_Done,
     /*  300666 */   // Label 5629: @300666
     /*  300666 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(300729), // Rule ID 9662 //
     /*  300671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  300685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  300688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300710 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300727 */     GIR_RootConstrainSelectedInstOperands,
     /*  300728 */     // GIR_Coverage, 9662,
     /*  300728 */     GIR_EraseRootFromParent_Done,
     /*  300729 */   // Label 5630: @300729
     /*  300729 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(300792), // Rule ID 9663 //
     /*  300734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  300748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  300751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300773 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300790 */     GIR_RootConstrainSelectedInstOperands,
     /*  300791 */     // GIR_Coverage, 9663,
     /*  300791 */     GIR_EraseRootFromParent_Done,
     /*  300792 */   // Label 5631: @300792
     /*  300792 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(300855), // Rule ID 9666 //
     /*  300797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  300811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  300814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300836 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300853 */     GIR_RootConstrainSelectedInstOperands,
     /*  300854 */     // GIR_Coverage, 9666,
     /*  300854 */     GIR_EraseRootFromParent_Done,
     /*  300855 */   // Label 5632: @300855
     /*  300855 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(300918), // Rule ID 9667 //
     /*  300860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  300874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  300877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300899 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300916 */     GIR_RootConstrainSelectedInstOperands,
     /*  300917 */     // GIR_Coverage, 9667,
     /*  300917 */     GIR_EraseRootFromParent_Done,
     /*  300918 */   // Label 5633: @300918
     /*  300918 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(300981), // Rule ID 9670 //
     /*  300923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  300937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  300940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300962 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300979 */     GIR_RootConstrainSelectedInstOperands,
     /*  300980 */     // GIR_Coverage, 9670,
     /*  300980 */     GIR_EraseRootFromParent_Done,
     /*  300981 */   // Label 5634: @300981
     /*  300981 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(301044), // Rule ID 9671 //
     /*  300986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  301000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  301003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301025 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301042 */     GIR_RootConstrainSelectedInstOperands,
     /*  301043 */     // GIR_Coverage, 9671,
     /*  301043 */     GIR_EraseRootFromParent_Done,
     /*  301044 */   // Label 5635: @301044
     /*  301044 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(301107), // Rule ID 9674 //
     /*  301049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  301063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  301066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301088 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301105 */     GIR_RootConstrainSelectedInstOperands,
     /*  301106 */     // GIR_Coverage, 9674,
     /*  301106 */     GIR_EraseRootFromParent_Done,
     /*  301107 */   // Label 5636: @301107
     /*  301107 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(301170), // Rule ID 9675 //
     /*  301112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  301126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  301129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301151 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301168 */     GIR_RootConstrainSelectedInstOperands,
     /*  301169 */     // GIR_Coverage, 9675,
     /*  301169 */     GIR_EraseRootFromParent_Done,
     /*  301170 */   // Label 5637: @301170
     /*  301170 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(301233), // Rule ID 9678 //
     /*  301175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  301178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  301189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  301192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301214 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  301214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301231 */     GIR_RootConstrainSelectedInstOperands,
     /*  301232 */     // GIR_Coverage, 9678,
     /*  301232 */     GIR_EraseRootFromParent_Done,
     /*  301233 */   // Label 5638: @301233
     /*  301233 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(301296), // Rule ID 9679 //
     /*  301238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  301241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  301249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  301252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  301255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301277 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  301277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  301280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301294 */     GIR_RootConstrainSelectedInstOperands,
     /*  301295 */     // GIR_Coverage, 9679,
     /*  301295 */     GIR_EraseRootFromParent_Done,
     /*  301296 */   // Label 5639: @301296
     /*  301296 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(301359), // Rule ID 9682 //
     /*  301301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  301315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301340 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301357 */     GIR_RootConstrainSelectedInstOperands,
     /*  301358 */     // GIR_Coverage, 9682,
     /*  301358 */     GIR_EraseRootFromParent_Done,
     /*  301359 */   // Label 5640: @301359
     /*  301359 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(301422), // Rule ID 9683 //
     /*  301364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  301378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  301381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301403 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301420 */     GIR_RootConstrainSelectedInstOperands,
     /*  301421 */     // GIR_Coverage, 9683,
     /*  301421 */     GIR_EraseRootFromParent_Done,
     /*  301422 */   // Label 5641: @301422
     /*  301422 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(301485), // Rule ID 9686 //
     /*  301427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  301441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301466 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301483 */     GIR_RootConstrainSelectedInstOperands,
     /*  301484 */     // GIR_Coverage, 9686,
     /*  301484 */     GIR_EraseRootFromParent_Done,
     /*  301485 */   // Label 5642: @301485
     /*  301485 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(301548), // Rule ID 9687 //
     /*  301490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  301504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  301507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301529 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301546 */     GIR_RootConstrainSelectedInstOperands,
     /*  301547 */     // GIR_Coverage, 9687,
     /*  301547 */     GIR_EraseRootFromParent_Done,
     /*  301548 */   // Label 5643: @301548
     /*  301548 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(301611), // Rule ID 9690 //
     /*  301553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  301564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  301567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  301570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301592 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301609 */     GIR_RootConstrainSelectedInstOperands,
     /*  301610 */     // GIR_Coverage, 9690,
     /*  301610 */     GIR_EraseRootFromParent_Done,
     /*  301611 */   // Label 5644: @301611
     /*  301611 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(301674), // Rule ID 9691 //
     /*  301616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  301627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  301630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  301633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301655 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301672 */     GIR_RootConstrainSelectedInstOperands,
     /*  301673 */     // GIR_Coverage, 9691,
     /*  301673 */     GIR_EraseRootFromParent_Done,
     /*  301674 */   // Label 5645: @301674
     /*  301674 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(301737), // Rule ID 9694 //
     /*  301679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  301693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  301696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301735 */     GIR_RootConstrainSelectedInstOperands,
     /*  301736 */     // GIR_Coverage, 9694,
     /*  301736 */     GIR_EraseRootFromParent_Done,
     /*  301737 */   // Label 5646: @301737
     /*  301737 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(301800), // Rule ID 9695 //
     /*  301742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  301756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  301759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301781 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301798 */     GIR_RootConstrainSelectedInstOperands,
     /*  301799 */     // GIR_Coverage, 9695,
     /*  301799 */     GIR_EraseRootFromParent_Done,
     /*  301800 */   // Label 5647: @301800
     /*  301800 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(301863), // Rule ID 9698 //
     /*  301805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  301819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  301822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301844 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301861 */     GIR_RootConstrainSelectedInstOperands,
     /*  301862 */     // GIR_Coverage, 9698,
     /*  301862 */     GIR_EraseRootFromParent_Done,
     /*  301863 */   // Label 5648: @301863
     /*  301863 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(301926), // Rule ID 9699 //
     /*  301868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  301882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  301885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301907 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301924 */     GIR_RootConstrainSelectedInstOperands,
     /*  301925 */     // GIR_Coverage, 9699,
     /*  301925 */     GIR_EraseRootFromParent_Done,
     /*  301926 */   // Label 5649: @301926
     /*  301926 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(301989), // Rule ID 9702 //
     /*  301931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  301945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  301948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301970 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301987 */     GIR_RootConstrainSelectedInstOperands,
     /*  301988 */     // GIR_Coverage, 9702,
     /*  301988 */     GIR_EraseRootFromParent_Done,
     /*  301989 */   // Label 5650: @301989
     /*  301989 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(302052), // Rule ID 9703 //
     /*  301994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  302005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  302008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  302011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302033 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302050 */     GIR_RootConstrainSelectedInstOperands,
     /*  302051 */     // GIR_Coverage, 9703,
     /*  302051 */     GIR_EraseRootFromParent_Done,
     /*  302052 */   // Label 5651: @302052
     /*  302052 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(302115), // Rule ID 9706 //
     /*  302057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  302071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  302074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302096 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302113 */     GIR_RootConstrainSelectedInstOperands,
     /*  302114 */     // GIR_Coverage, 9706,
     /*  302114 */     GIR_EraseRootFromParent_Done,
     /*  302115 */   // Label 5652: @302115
     /*  302115 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(302178), // Rule ID 9707 //
     /*  302120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  302134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  302137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302159 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302176 */     GIR_RootConstrainSelectedInstOperands,
     /*  302177 */     // GIR_Coverage, 9707,
     /*  302177 */     GIR_EraseRootFromParent_Done,
     /*  302178 */   // Label 5653: @302178
     /*  302178 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(302241), // Rule ID 9710 //
     /*  302183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  302197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302222 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302239 */     GIR_RootConstrainSelectedInstOperands,
     /*  302240 */     // GIR_Coverage, 9710,
     /*  302240 */     GIR_EraseRootFromParent_Done,
     /*  302241 */   // Label 5654: @302241
     /*  302241 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(302304), // Rule ID 9711 //
     /*  302246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  302260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  302263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302285 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302302 */     GIR_RootConstrainSelectedInstOperands,
     /*  302303 */     // GIR_Coverage, 9711,
     /*  302303 */     GIR_EraseRootFromParent_Done,
     /*  302304 */   // Label 5655: @302304
     /*  302304 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(302367), // Rule ID 9714 //
     /*  302309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  302323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302365 */     GIR_RootConstrainSelectedInstOperands,
     /*  302366 */     // GIR_Coverage, 9714,
     /*  302366 */     GIR_EraseRootFromParent_Done,
     /*  302367 */   // Label 5656: @302367
     /*  302367 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(302430), // Rule ID 9715 //
     /*  302372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  302383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  302386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  302389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302411 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  302411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302428 */     GIR_RootConstrainSelectedInstOperands,
     /*  302429 */     // GIR_Coverage, 9715,
     /*  302429 */     GIR_EraseRootFromParent_Done,
     /*  302430 */   // Label 5657: @302430
     /*  302430 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(302493), // Rule ID 9718 //
     /*  302435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  302449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302474 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302491 */     GIR_RootConstrainSelectedInstOperands,
     /*  302492 */     // GIR_Coverage, 9718,
     /*  302492 */     GIR_EraseRootFromParent_Done,
     /*  302493 */   // Label 5658: @302493
     /*  302493 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(302556), // Rule ID 9719 //
     /*  302498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  302512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302537 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302554 */     GIR_RootConstrainSelectedInstOperands,
     /*  302555 */     // GIR_Coverage, 9719,
     /*  302555 */     GIR_EraseRootFromParent_Done,
     /*  302556 */   // Label 5659: @302556
     /*  302556 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(302619), // Rule ID 9722 //
     /*  302561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  302575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  302578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302600 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302617 */     GIR_RootConstrainSelectedInstOperands,
     /*  302618 */     // GIR_Coverage, 9722,
     /*  302618 */     GIR_EraseRootFromParent_Done,
     /*  302619 */   // Label 5660: @302619
     /*  302619 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(302682), // Rule ID 9723 //
     /*  302624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  302638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  302641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302663 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302680 */     GIR_RootConstrainSelectedInstOperands,
     /*  302681 */     // GIR_Coverage, 9723,
     /*  302681 */     GIR_EraseRootFromParent_Done,
     /*  302682 */   // Label 5661: @302682
     /*  302682 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(302745), // Rule ID 9726 //
     /*  302687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  302701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  302704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302726 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302743 */     GIR_RootConstrainSelectedInstOperands,
     /*  302744 */     // GIR_Coverage, 9726,
     /*  302744 */     GIR_EraseRootFromParent_Done,
     /*  302745 */   // Label 5662: @302745
     /*  302745 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(302808), // Rule ID 9727 //
     /*  302750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  302764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  302767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302789 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302806 */     GIR_RootConstrainSelectedInstOperands,
     /*  302807 */     // GIR_Coverage, 9727,
     /*  302807 */     GIR_EraseRootFromParent_Done,
     /*  302808 */   // Label 5663: @302808
     /*  302808 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(302871), // Rule ID 9730 //
     /*  302813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  302827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  302830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302852 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  302855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302869 */     GIR_RootConstrainSelectedInstOperands,
     /*  302870 */     // GIR_Coverage, 9730,
     /*  302870 */     GIR_EraseRootFromParent_Done,
     /*  302871 */   // Label 5664: @302871
     /*  302871 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(302934), // Rule ID 9731 //
     /*  302876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  302890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  302893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302915 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  302918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302932 */     GIR_RootConstrainSelectedInstOperands,
     /*  302933 */     // GIR_Coverage, 9731,
     /*  302933 */     GIR_EraseRootFromParent_Done,
     /*  302934 */   // Label 5665: @302934
     /*  302934 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(302997), // Rule ID 9734 //
     /*  302939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  302953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  302956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302978 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  302981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302995 */     GIR_RootConstrainSelectedInstOperands,
     /*  302996 */     // GIR_Coverage, 9734,
     /*  302996 */     GIR_EraseRootFromParent_Done,
     /*  302997 */   // Label 5666: @302997
     /*  302997 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(303060), // Rule ID 9735 //
     /*  303002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  303016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  303019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303041 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303058 */     GIR_RootConstrainSelectedInstOperands,
     /*  303059 */     // GIR_Coverage, 9735,
     /*  303059 */     GIR_EraseRootFromParent_Done,
     /*  303060 */   // Label 5667: @303060
     /*  303060 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(303123), // Rule ID 9738 //
     /*  303065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303104 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303121 */     GIR_RootConstrainSelectedInstOperands,
     /*  303122 */     // GIR_Coverage, 9738,
     /*  303122 */     GIR_EraseRootFromParent_Done,
     /*  303123 */   // Label 5668: @303123
     /*  303123 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(303186), // Rule ID 9739 //
     /*  303128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  303142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  303145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303167 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303184 */     GIR_RootConstrainSelectedInstOperands,
     /*  303185 */     // GIR_Coverage, 9739,
     /*  303185 */     GIR_EraseRootFromParent_Done,
     /*  303186 */   // Label 5669: @303186
     /*  303186 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(303249), // Rule ID 9742 //
     /*  303191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303230 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303247 */     GIR_RootConstrainSelectedInstOperands,
     /*  303248 */     // GIR_Coverage, 9742,
     /*  303248 */     GIR_EraseRootFromParent_Done,
     /*  303249 */   // Label 5670: @303249
     /*  303249 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(303312), // Rule ID 9743 //
     /*  303254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  303268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  303271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303293 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  303296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303310 */     GIR_RootConstrainSelectedInstOperands,
     /*  303311 */     // GIR_Coverage, 9743,
     /*  303311 */     GIR_EraseRootFromParent_Done,
     /*  303312 */   // Label 5671: @303312
     /*  303312 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(303375), // Rule ID 9746 //
     /*  303317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303373 */     GIR_RootConstrainSelectedInstOperands,
     /*  303374 */     // GIR_Coverage, 9746,
     /*  303374 */     GIR_EraseRootFromParent_Done,
     /*  303375 */   // Label 5672: @303375
     /*  303375 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(303438), // Rule ID 9747 //
     /*  303380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  303394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  303397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303419 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303436 */     GIR_RootConstrainSelectedInstOperands,
     /*  303437 */     // GIR_Coverage, 9747,
     /*  303437 */     GIR_EraseRootFromParent_Done,
     /*  303438 */   // Label 5673: @303438
     /*  303438 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(303501), // Rule ID 9750 //
     /*  303443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303482 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303499 */     GIR_RootConstrainSelectedInstOperands,
     /*  303500 */     // GIR_Coverage, 9750,
     /*  303500 */     GIR_EraseRootFromParent_Done,
     /*  303501 */   // Label 5674: @303501
     /*  303501 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(303564), // Rule ID 9751 //
     /*  303506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303545 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303562 */     GIR_RootConstrainSelectedInstOperands,
     /*  303563 */     // GIR_Coverage, 9751,
     /*  303563 */     GIR_EraseRootFromParent_Done,
     /*  303564 */   // Label 5675: @303564
     /*  303564 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(303627), // Rule ID 9754 //
     /*  303569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  303583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  303586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303608 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303625 */     GIR_RootConstrainSelectedInstOperands,
     /*  303626 */     // GIR_Coverage, 9754,
     /*  303626 */     GIR_EraseRootFromParent_Done,
     /*  303627 */   // Label 5676: @303627
     /*  303627 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(303690), // Rule ID 9755 //
     /*  303632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  303646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  303649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303671 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303688 */     GIR_RootConstrainSelectedInstOperands,
     /*  303689 */     // GIR_Coverage, 9755,
     /*  303689 */     GIR_EraseRootFromParent_Done,
     /*  303690 */   // Label 5677: @303690
     /*  303690 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(303753), // Rule ID 9758 //
     /*  303695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  303709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  303712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303734 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303751 */     GIR_RootConstrainSelectedInstOperands,
     /*  303752 */     // GIR_Coverage, 9758,
     /*  303752 */     GIR_EraseRootFromParent_Done,
     /*  303753 */   // Label 5678: @303753
     /*  303753 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(303816), // Rule ID 9759 //
     /*  303758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  303772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  303775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303797 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303814 */     GIR_RootConstrainSelectedInstOperands,
     /*  303815 */     // GIR_Coverage, 9759,
     /*  303815 */     GIR_EraseRootFromParent_Done,
     /*  303816 */   // Label 5679: @303816
     /*  303816 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(303879), // Rule ID 9762 //
     /*  303821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  303835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  303838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303877 */     GIR_RootConstrainSelectedInstOperands,
     /*  303878 */     // GIR_Coverage, 9762,
     /*  303878 */     GIR_EraseRootFromParent_Done,
     /*  303879 */   // Label 5680: @303879
     /*  303879 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(303942), // Rule ID 9763 //
     /*  303884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  303898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  303901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303923 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303940 */     GIR_RootConstrainSelectedInstOperands,
     /*  303941 */     // GIR_Coverage, 9763,
     /*  303941 */     GIR_EraseRootFromParent_Done,
     /*  303942 */   // Label 5681: @303942
     /*  303942 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(304005), // Rule ID 9766 //
     /*  303947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  303961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  303964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303986 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304003 */     GIR_RootConstrainSelectedInstOperands,
     /*  304004 */     // GIR_Coverage, 9766,
     /*  304004 */     GIR_EraseRootFromParent_Done,
     /*  304005 */   // Label 5682: @304005
     /*  304005 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(304068), // Rule ID 9767 //
     /*  304010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  304013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  304021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  304024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  304027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304049 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  304049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  304052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304066 */     GIR_RootConstrainSelectedInstOperands,
     /*  304067 */     // GIR_Coverage, 9767,
     /*  304067 */     GIR_EraseRootFromParent_Done,
     /*  304068 */   // Label 5683: @304068
     /*  304068 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(304131), // Rule ID 9770 //
     /*  304073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304112 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304129 */     GIR_RootConstrainSelectedInstOperands,
     /*  304130 */     // GIR_Coverage, 9770,
     /*  304130 */     GIR_EraseRootFromParent_Done,
     /*  304131 */   // Label 5684: @304131
     /*  304131 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(304194), // Rule ID 9771 //
     /*  304136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  304150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  304153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304175 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304192 */     GIR_RootConstrainSelectedInstOperands,
     /*  304193 */     // GIR_Coverage, 9771,
     /*  304193 */     GIR_EraseRootFromParent_Done,
     /*  304194 */   // Label 5685: @304194
     /*  304194 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(304257), // Rule ID 9774 //
     /*  304199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304238 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304255 */     GIR_RootConstrainSelectedInstOperands,
     /*  304256 */     // GIR_Coverage, 9774,
     /*  304256 */     GIR_EraseRootFromParent_Done,
     /*  304257 */   // Label 5686: @304257
     /*  304257 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(304320), // Rule ID 9775 //
     /*  304262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  304276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  304279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304301 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304318 */     GIR_RootConstrainSelectedInstOperands,
     /*  304319 */     // GIR_Coverage, 9775,
     /*  304319 */     GIR_EraseRootFromParent_Done,
     /*  304320 */   // Label 5687: @304320
     /*  304320 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(304383), // Rule ID 9778 //
     /*  304325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  304336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304364 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  304364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304381 */     GIR_RootConstrainSelectedInstOperands,
     /*  304382 */     // GIR_Coverage, 9778,
     /*  304382 */     GIR_EraseRootFromParent_Done,
     /*  304383 */   // Label 5688: @304383
     /*  304383 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(304446), // Rule ID 9779 //
     /*  304388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  304399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  304402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  304405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304427 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  304427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  304444 */     GIR_RootConstrainSelectedInstOperands,
     /*  304445 */     // GIR_Coverage, 9779,
     /*  304445 */     GIR_EraseRootFromParent_Done,
     /*  304446 */   // Label 5689: @304446
     /*  304446 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(304509), // Rule ID 9782 //
     /*  304451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304490 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304507 */     GIR_RootConstrainSelectedInstOperands,
     /*  304508 */     // GIR_Coverage, 9782,
     /*  304508 */     GIR_EraseRootFromParent_Done,
     /*  304509 */   // Label 5690: @304509
     /*  304509 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(304572), // Rule ID 9783 //
     /*  304514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304553 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304570 */     GIR_RootConstrainSelectedInstOperands,
     /*  304571 */     // GIR_Coverage, 9783,
     /*  304571 */     GIR_EraseRootFromParent_Done,
     /*  304572 */   // Label 5691: @304572
     /*  304572 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(304635), // Rule ID 9786 //
     /*  304577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  304591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  304594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304616 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304633 */     GIR_RootConstrainSelectedInstOperands,
     /*  304634 */     // GIR_Coverage, 9786,
     /*  304634 */     GIR_EraseRootFromParent_Done,
     /*  304635 */   // Label 5692: @304635
     /*  304635 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(304698), // Rule ID 9787 //
     /*  304640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  304654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  304657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304679 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304696 */     GIR_RootConstrainSelectedInstOperands,
     /*  304697 */     // GIR_Coverage, 9787,
     /*  304697 */     GIR_EraseRootFromParent_Done,
     /*  304698 */   // Label 5693: @304698
     /*  304698 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(304761), // Rule ID 9790 //
     /*  304703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  304717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  304720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304742 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304759 */     GIR_RootConstrainSelectedInstOperands,
     /*  304760 */     // GIR_Coverage, 9790,
     /*  304760 */     GIR_EraseRootFromParent_Done,
     /*  304761 */   // Label 5694: @304761
     /*  304761 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(304824), // Rule ID 9791 //
     /*  304766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  304780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  304783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304805 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304822 */     GIR_RootConstrainSelectedInstOperands,
     /*  304823 */     // GIR_Coverage, 9791,
     /*  304823 */     GIR_EraseRootFromParent_Done,
     /*  304824 */   // Label 5695: @304824
     /*  304824 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(304887), // Rule ID 9794 //
     /*  304829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  304843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  304846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304868 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304885 */     GIR_RootConstrainSelectedInstOperands,
     /*  304886 */     // GIR_Coverage, 9794,
     /*  304886 */     GIR_EraseRootFromParent_Done,
     /*  304887 */   // Label 5696: @304887
     /*  304887 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(304950), // Rule ID 9795 //
     /*  304892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  304906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  304909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304931 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304948 */     GIR_RootConstrainSelectedInstOperands,
     /*  304949 */     // GIR_Coverage, 9795,
     /*  304949 */     GIR_EraseRootFromParent_Done,
     /*  304950 */   // Label 5697: @304950
     /*  304950 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(305013), // Rule ID 9798 //
     /*  304955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  304969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  304972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304994 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305011 */     GIR_RootConstrainSelectedInstOperands,
     /*  305012 */     // GIR_Coverage, 9798,
     /*  305012 */     GIR_EraseRootFromParent_Done,
     /*  305013 */   // Label 5698: @305013
     /*  305013 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(305076), // Rule ID 9799 //
     /*  305018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  305032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  305035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305057 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305074 */     GIR_RootConstrainSelectedInstOperands,
     /*  305075 */     // GIR_Coverage, 9799,
     /*  305075 */     GIR_EraseRootFromParent_Done,
     /*  305076 */   // Label 5699: @305076
     /*  305076 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(305139), // Rule ID 9802 //
     /*  305081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305120 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305137 */     GIR_RootConstrainSelectedInstOperands,
     /*  305138 */     // GIR_Coverage, 9802,
     /*  305138 */     GIR_EraseRootFromParent_Done,
     /*  305139 */   // Label 5700: @305139
     /*  305139 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(305202), // Rule ID 9803 //
     /*  305144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  305155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  305158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  305161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305183 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305200 */     GIR_RootConstrainSelectedInstOperands,
     /*  305201 */     // GIR_Coverage, 9803,
     /*  305201 */     GIR_EraseRootFromParent_Done,
     /*  305202 */   // Label 5701: @305202
     /*  305202 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(305265), // Rule ID 9806 //
     /*  305207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305246 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305263 */     GIR_RootConstrainSelectedInstOperands,
     /*  305264 */     // GIR_Coverage, 9806,
     /*  305264 */     GIR_EraseRootFromParent_Done,
     /*  305265 */   // Label 5702: @305265
     /*  305265 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(305328), // Rule ID 9807 //
     /*  305270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  305284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  305287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  305302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305309 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  305312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305326 */     GIR_RootConstrainSelectedInstOperands,
     /*  305327 */     // GIR_Coverage, 9807,
     /*  305327 */     GIR_EraseRootFromParent_Done,
     /*  305328 */   // Label 5703: @305328
     /*  305328 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(305391), // Rule ID 9810 //
     /*  305333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305372 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305389 */     GIR_RootConstrainSelectedInstOperands,
     /*  305390 */     // GIR_Coverage, 9810,
     /*  305390 */     GIR_EraseRootFromParent_Done,
     /*  305391 */   // Label 5704: @305391
     /*  305391 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(305454), // Rule ID 9811 //
     /*  305396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  305410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  305413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  305428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305435 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  305438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305452 */     GIR_RootConstrainSelectedInstOperands,
     /*  305453 */     // GIR_Coverage, 9811,
     /*  305453 */     GIR_EraseRootFromParent_Done,
     /*  305454 */   // Label 5705: @305454
     /*  305454 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(305517), // Rule ID 9814 //
     /*  305459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  305462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  305473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  305476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  305498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305515 */     GIR_RootConstrainSelectedInstOperands,
     /*  305516 */     // GIR_Coverage, 9814,
     /*  305516 */     GIR_EraseRootFromParent_Done,
     /*  305517 */   // Label 5706: @305517
     /*  305517 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(305580), // Rule ID 9815 //
     /*  305522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  305536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  305539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305561 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305578 */     GIR_RootConstrainSelectedInstOperands,
     /*  305579 */     // GIR_Coverage, 9815,
     /*  305579 */     GIR_EraseRootFromParent_Done,
     /*  305580 */   // Label 5707: @305580
     /*  305580 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(305643), // Rule ID 9818 //
     /*  305585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  305599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  305602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305624 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  305627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305641 */     GIR_RootConstrainSelectedInstOperands,
     /*  305642 */     // GIR_Coverage, 9818,
     /*  305642 */     GIR_EraseRootFromParent_Done,
     /*  305643 */   // Label 5708: @305643
     /*  305643 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(305706), // Rule ID 9819 //
     /*  305648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  305662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  305665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305687 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  305690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305704 */     GIR_RootConstrainSelectedInstOperands,
     /*  305705 */     // GIR_Coverage, 9819,
     /*  305705 */     GIR_EraseRootFromParent_Done,
     /*  305706 */   // Label 5709: @305706
     /*  305706 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(305769), // Rule ID 9822 //
     /*  305711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  305725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  305728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  305753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305767 */     GIR_RootConstrainSelectedInstOperands,
     /*  305768 */     // GIR_Coverage, 9822,
     /*  305768 */     GIR_EraseRootFromParent_Done,
     /*  305769 */   // Label 5710: @305769
     /*  305769 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(305832), // Rule ID 9823 //
     /*  305774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  305788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  305791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305813 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  305816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305830 */     GIR_RootConstrainSelectedInstOperands,
     /*  305831 */     // GIR_Coverage, 9823,
     /*  305831 */     GIR_EraseRootFromParent_Done,
     /*  305832 */   // Label 5711: @305832
     /*  305832 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(305895), // Rule ID 9826 //
     /*  305837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  305851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  305854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305893 */     GIR_RootConstrainSelectedInstOperands,
     /*  305894 */     // GIR_Coverage, 9826,
     /*  305894 */     GIR_EraseRootFromParent_Done,
     /*  305895 */   // Label 5712: @305895
     /*  305895 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(305958), // Rule ID 9827 //
     /*  305900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  305914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  305917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305939 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305956 */     GIR_RootConstrainSelectedInstOperands,
     /*  305957 */     // GIR_Coverage, 9827,
     /*  305957 */     GIR_EraseRootFromParent_Done,
     /*  305958 */   // Label 5713: @305958
     /*  305958 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(306021), // Rule ID 9830 //
     /*  305963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  305977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  305980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306002 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306019 */     GIR_RootConstrainSelectedInstOperands,
     /*  306020 */     // GIR_Coverage, 9830,
     /*  306020 */     GIR_EraseRootFromParent_Done,
     /*  306021 */   // Label 5714: @306021
     /*  306021 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(306084), // Rule ID 9831 //
     /*  306026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  306040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  306043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306065 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  306068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306082 */     GIR_RootConstrainSelectedInstOperands,
     /*  306083 */     // GIR_Coverage, 9831,
     /*  306083 */     GIR_EraseRootFromParent_Done,
     /*  306084 */   // Label 5715: @306084
     /*  306084 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(306147), // Rule ID 9834 //
     /*  306089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306145 */     GIR_RootConstrainSelectedInstOperands,
     /*  306146 */     // GIR_Coverage, 9834,
     /*  306146 */     GIR_EraseRootFromParent_Done,
     /*  306147 */   // Label 5716: @306147
     /*  306147 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(306210), // Rule ID 9835 //
     /*  306152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  306166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  306169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306191 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306208 */     GIR_RootConstrainSelectedInstOperands,
     /*  306209 */     // GIR_Coverage, 9835,
     /*  306209 */     GIR_EraseRootFromParent_Done,
     /*  306210 */   // Label 5717: @306210
     /*  306210 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(306273), // Rule ID 9838 //
     /*  306215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306254 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306271 */     GIR_RootConstrainSelectedInstOperands,
     /*  306272 */     // GIR_Coverage, 9838,
     /*  306272 */     GIR_EraseRootFromParent_Done,
     /*  306273 */   // Label 5718: @306273
     /*  306273 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(306336), // Rule ID 9839 //
     /*  306278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  306292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  306295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306317 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  306320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306334 */     GIR_RootConstrainSelectedInstOperands,
     /*  306335 */     // GIR_Coverage, 9839,
     /*  306335 */     GIR_EraseRootFromParent_Done,
     /*  306336 */   // Label 5719: @306336
     /*  306336 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(306399), // Rule ID 9842 //
     /*  306341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  306355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  306358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306380 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306397 */     GIR_RootConstrainSelectedInstOperands,
     /*  306398 */     // GIR_Coverage, 9842,
     /*  306398 */     GIR_EraseRootFromParent_Done,
     /*  306399 */   // Label 5720: @306399
     /*  306399 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(306462), // Rule ID 9843 //
     /*  306404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  306418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  306421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306443 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306460 */     GIR_RootConstrainSelectedInstOperands,
     /*  306461 */     // GIR_Coverage, 9843,
     /*  306461 */     GIR_EraseRootFromParent_Done,
     /*  306462 */   // Label 5721: @306462
     /*  306462 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(306525), // Rule ID 9846 //
     /*  306467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  306481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  306484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306506 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306523 */     GIR_RootConstrainSelectedInstOperands,
     /*  306524 */     // GIR_Coverage, 9846,
     /*  306524 */     GIR_EraseRootFromParent_Done,
     /*  306525 */   // Label 5722: @306525
     /*  306525 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(306588), // Rule ID 9847 //
     /*  306530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  306544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  306547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306569 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306586 */     GIR_RootConstrainSelectedInstOperands,
     /*  306587 */     // GIR_Coverage, 9847,
     /*  306587 */     GIR_EraseRootFromParent_Done,
     /*  306588 */   // Label 5723: @306588
     /*  306588 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(306651), // Rule ID 9850 //
     /*  306593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  306607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  306610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306632 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306649 */     GIR_RootConstrainSelectedInstOperands,
     /*  306650 */     // GIR_Coverage, 9850,
     /*  306650 */     GIR_EraseRootFromParent_Done,
     /*  306651 */   // Label 5724: @306651
     /*  306651 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(306714), // Rule ID 9851 //
     /*  306656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  306670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  306673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306695 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306712 */     GIR_RootConstrainSelectedInstOperands,
     /*  306713 */     // GIR_Coverage, 9851,
     /*  306713 */     GIR_EraseRootFromParent_Done,
     /*  306714 */   // Label 5725: @306714
     /*  306714 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(306777), // Rule ID 9854 //
     /*  306719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  306722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  306733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  306736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306758 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  306758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306775 */     GIR_RootConstrainSelectedInstOperands,
     /*  306776 */     // GIR_Coverage, 9854,
     /*  306776 */     GIR_EraseRootFromParent_Done,
     /*  306777 */   // Label 5726: @306777
     /*  306777 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(306840), // Rule ID 9855 //
     /*  306782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  306796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  306799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306821 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306838 */     GIR_RootConstrainSelectedInstOperands,
     /*  306839 */     // GIR_Coverage, 9855,
     /*  306839 */     GIR_EraseRootFromParent_Done,
     /*  306840 */   // Label 5727: @306840
     /*  306840 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(306903), // Rule ID 9858 //
     /*  306845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  306859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  306862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306884 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  306887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306901 */     GIR_RootConstrainSelectedInstOperands,
     /*  306902 */     // GIR_Coverage, 9858,
     /*  306902 */     GIR_EraseRootFromParent_Done,
     /*  306903 */   // Label 5728: @306903
     /*  306903 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(306966), // Rule ID 9859 //
     /*  306908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  306922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  306925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306947 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  306950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306964 */     GIR_RootConstrainSelectedInstOperands,
     /*  306965 */     // GIR_Coverage, 9859,
     /*  306965 */     GIR_EraseRootFromParent_Done,
     /*  306966 */   // Label 5729: @306966
     /*  306966 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(307029), // Rule ID 9862 //
     /*  306971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  306982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  306985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  306988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307010 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307027 */     GIR_RootConstrainSelectedInstOperands,
     /*  307028 */     // GIR_Coverage, 9862,
     /*  307028 */     GIR_EraseRootFromParent_Done,
     /*  307029 */   // Label 5730: @307029
     /*  307029 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(307092), // Rule ID 9863 //
     /*  307034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  307048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  307051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307073 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307090 */     GIR_RootConstrainSelectedInstOperands,
     /*  307091 */     // GIR_Coverage, 9863,
     /*  307091 */     GIR_EraseRootFromParent_Done,
     /*  307092 */   // Label 5731: @307092
     /*  307092 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(307155), // Rule ID 9866 //
     /*  307097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  307108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  307111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  307114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307136 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  307136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307153 */     GIR_RootConstrainSelectedInstOperands,
     /*  307154 */     // GIR_Coverage, 9866,
     /*  307154 */     GIR_EraseRootFromParent_Done,
     /*  307155 */   // Label 5732: @307155
     /*  307155 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(307218), // Rule ID 9867 //
     /*  307160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  307171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  307174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  307177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307199 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  307199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307216 */     GIR_RootConstrainSelectedInstOperands,
     /*  307217 */     // GIR_Coverage, 9867,
     /*  307217 */     GIR_EraseRootFromParent_Done,
     /*  307218 */   // Label 5733: @307218
     /*  307218 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(307281), // Rule ID 9870 //
     /*  307223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307279 */     GIR_RootConstrainSelectedInstOperands,
     /*  307280 */     // GIR_Coverage, 9870,
     /*  307280 */     GIR_EraseRootFromParent_Done,
     /*  307281 */   // Label 5734: @307281
     /*  307281 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(307344), // Rule ID 9871 //
     /*  307286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  307300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  307303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307325 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307342 */     GIR_RootConstrainSelectedInstOperands,
     /*  307343 */     // GIR_Coverage, 9871,
     /*  307343 */     GIR_EraseRootFromParent_Done,
     /*  307344 */   // Label 5735: @307344
     /*  307344 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(307407), // Rule ID 9874 //
     /*  307349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307388 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307405 */     GIR_RootConstrainSelectedInstOperands,
     /*  307406 */     // GIR_Coverage, 9874,
     /*  307406 */     GIR_EraseRootFromParent_Done,
     /*  307407 */   // Label 5736: @307407
     /*  307407 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(307470), // Rule ID 9875 //
     /*  307412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  307426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  307429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307451 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307468 */     GIR_RootConstrainSelectedInstOperands,
     /*  307469 */     // GIR_Coverage, 9875,
     /*  307469 */     GIR_EraseRootFromParent_Done,
     /*  307470 */   // Label 5737: @307470
     /*  307470 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(307533), // Rule ID 9878 //
     /*  307475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  307489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  307492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307514 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307531 */     GIR_RootConstrainSelectedInstOperands,
     /*  307532 */     // GIR_Coverage, 9878,
     /*  307532 */     GIR_EraseRootFromParent_Done,
     /*  307533 */   // Label 5738: @307533
     /*  307533 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(307596), // Rule ID 9879 //
     /*  307538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  307552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  307555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307577 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307594 */     GIR_RootConstrainSelectedInstOperands,
     /*  307595 */     // GIR_Coverage, 9879,
     /*  307595 */     GIR_EraseRootFromParent_Done,
     /*  307596 */   // Label 5739: @307596
     /*  307596 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(307659), // Rule ID 9882 //
     /*  307601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  307615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  307618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307640 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307657 */     GIR_RootConstrainSelectedInstOperands,
     /*  307658 */     // GIR_Coverage, 9882,
     /*  307658 */     GIR_EraseRootFromParent_Done,
     /*  307659 */   // Label 5740: @307659
     /*  307659 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(307722), // Rule ID 9883 //
     /*  307664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  307678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  307681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307703 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307720 */     GIR_RootConstrainSelectedInstOperands,
     /*  307721 */     // GIR_Coverage, 9883,
     /*  307721 */     GIR_EraseRootFromParent_Done,
     /*  307722 */   // Label 5741: @307722
     /*  307722 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(307785), // Rule ID 9886 //
     /*  307727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  307741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  307744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307766 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307783 */     GIR_RootConstrainSelectedInstOperands,
     /*  307784 */     // GIR_Coverage, 9886,
     /*  307784 */     GIR_EraseRootFromParent_Done,
     /*  307785 */   // Label 5742: @307785
     /*  307785 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(307848), // Rule ID 9887 //
     /*  307790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  307804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  307807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307829 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307846 */     GIR_RootConstrainSelectedInstOperands,
     /*  307847 */     // GIR_Coverage, 9887,
     /*  307847 */     GIR_EraseRootFromParent_Done,
     /*  307848 */   // Label 5743: @307848
     /*  307848 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(307911), // Rule ID 9890 //
     /*  307853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  307867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  307870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307892 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307909 */     GIR_RootConstrainSelectedInstOperands,
     /*  307910 */     // GIR_Coverage, 9890,
     /*  307910 */     GIR_EraseRootFromParent_Done,
     /*  307911 */   // Label 5744: @307911
     /*  307911 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(307974), // Rule ID 9891 //
     /*  307916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  307930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  307933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307955 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307972 */     GIR_RootConstrainSelectedInstOperands,
     /*  307973 */     // GIR_Coverage, 9891,
     /*  307973 */     GIR_EraseRootFromParent_Done,
     /*  307974 */   // Label 5745: @307974
     /*  307974 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(308037), // Rule ID 9894 //
     /*  307979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  307982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  307993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  307996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308018 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308035 */     GIR_RootConstrainSelectedInstOperands,
     /*  308036 */     // GIR_Coverage, 9894,
     /*  308036 */     GIR_EraseRootFromParent_Done,
     /*  308037 */   // Label 5746: @308037
     /*  308037 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(308100), // Rule ID 9895 //
     /*  308042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  308053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  308056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  308059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  308074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308081 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  308084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308098 */     GIR_RootConstrainSelectedInstOperands,
     /*  308099 */     // GIR_Coverage, 9895,
     /*  308099 */     GIR_EraseRootFromParent_Done,
     /*  308100 */   // Label 5747: @308100
     /*  308100 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(308163), // Rule ID 9898 //
     /*  308105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308144 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308161 */     GIR_RootConstrainSelectedInstOperands,
     /*  308162 */     // GIR_Coverage, 9898,
     /*  308162 */     GIR_EraseRootFromParent_Done,
     /*  308163 */   // Label 5748: @308163
     /*  308163 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(308226), // Rule ID 9899 //
     /*  308168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  308179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  308182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  308185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  308200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308207 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  308210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308224 */     GIR_RootConstrainSelectedInstOperands,
     /*  308225 */     // GIR_Coverage, 9899,
     /*  308225 */     GIR_EraseRootFromParent_Done,
     /*  308226 */   // Label 5749: @308226
     /*  308226 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(308289), // Rule ID 9902 //
     /*  308231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  308234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308270 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  308270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308287 */     GIR_RootConstrainSelectedInstOperands,
     /*  308288 */     // GIR_Coverage, 9902,
     /*  308288 */     GIR_EraseRootFromParent_Done,
     /*  308289 */   // Label 5750: @308289
     /*  308289 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(308352), // Rule ID 9903 //
     /*  308294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  308297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  308302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  308305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  308308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  308311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  308326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308333 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  308333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  308336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  308342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  308350 */     GIR_RootConstrainSelectedInstOperands,
     /*  308351 */     // GIR_Coverage, 9903,
     /*  308351 */     GIR_EraseRootFromParent_Done,
     /*  308352 */   // Label 5751: @308352
     /*  308352 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(308418), // Rule ID 13978 //
     /*  308357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  308368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  308371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  308374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308396 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  308399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308416 */     GIR_RootConstrainSelectedInstOperands,
     /*  308417 */     // GIR_Coverage, 13978,
     /*  308417 */     GIR_EraseRootFromParent_Done,
     /*  308418 */   // Label 5752: @308418
     /*  308418 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(308484), // Rule ID 13979 //
     /*  308423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  308434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  308437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  308440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308462 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  308465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308482 */     GIR_RootConstrainSelectedInstOperands,
     /*  308483 */     // GIR_Coverage, 13979,
     /*  308483 */     GIR_EraseRootFromParent_Done,
     /*  308484 */   // Label 5753: @308484
     /*  308484 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(308550), // Rule ID 13980 //
     /*  308489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  308500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  308503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  308506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308528 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308548 */     GIR_RootConstrainSelectedInstOperands,
     /*  308549 */     // GIR_Coverage, 13980,
     /*  308549 */     GIR_EraseRootFromParent_Done,
     /*  308550 */   // Label 5754: @308550
     /*  308550 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(308616), // Rule ID 13981 //
     /*  308555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  308566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  308569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  308572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308594 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308614 */     GIR_RootConstrainSelectedInstOperands,
     /*  308615 */     // GIR_Coverage, 13981,
     /*  308615 */     GIR_EraseRootFromParent_Done,
     /*  308616 */   // Label 5755: @308616
     /*  308616 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(308682), // Rule ID 13982 //
     /*  308621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  308632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  308635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  308638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308660 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308680 */     GIR_RootConstrainSelectedInstOperands,
     /*  308681 */     // GIR_Coverage, 13982,
     /*  308681 */     GIR_EraseRootFromParent_Done,
     /*  308682 */   // Label 5756: @308682
     /*  308682 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(308748), // Rule ID 13983 //
     /*  308687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  308698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  308701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  308704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308746 */     GIR_RootConstrainSelectedInstOperands,
     /*  308747 */     // GIR_Coverage, 13983,
     /*  308747 */     GIR_EraseRootFromParent_Done,
     /*  308748 */   // Label 5757: @308748
     /*  308748 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(308814), // Rule ID 13984 //
     /*  308753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  308764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  308767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  308770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308792 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308812 */     GIR_RootConstrainSelectedInstOperands,
     /*  308813 */     // GIR_Coverage, 13984,
     /*  308813 */     GIR_EraseRootFromParent_Done,
     /*  308814 */   // Label 5758: @308814
     /*  308814 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(308880), // Rule ID 13985 //
     /*  308819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  308830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  308833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  308836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308858 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  308858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308878 */     GIR_RootConstrainSelectedInstOperands,
     /*  308879 */     // GIR_Coverage, 13985,
     /*  308879 */     GIR_EraseRootFromParent_Done,
     /*  308880 */   // Label 5759: @308880
     /*  308880 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(308946), // Rule ID 13986 //
     /*  308885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  308896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  308899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  308902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308924 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308944 */     GIR_RootConstrainSelectedInstOperands,
     /*  308945 */     // GIR_Coverage, 13986,
     /*  308945 */     GIR_EraseRootFromParent_Done,
     /*  308946 */   // Label 5760: @308946
     /*  308946 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(309012), // Rule ID 13987 //
     /*  308951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  308962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  308965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  308968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308990 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  308990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309010 */     GIR_RootConstrainSelectedInstOperands,
     /*  309011 */     // GIR_Coverage, 13987,
     /*  309011 */     GIR_EraseRootFromParent_Done,
     /*  309012 */   // Label 5761: @309012
     /*  309012 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(309078), // Rule ID 13988 //
     /*  309017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  309028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  309031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  309034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309056 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309076 */     GIR_RootConstrainSelectedInstOperands,
     /*  309077 */     // GIR_Coverage, 13988,
     /*  309077 */     GIR_EraseRootFromParent_Done,
     /*  309078 */   // Label 5762: @309078
     /*  309078 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(309144), // Rule ID 13989 //
     /*  309083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  309094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  309097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  309100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  309125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309142 */     GIR_RootConstrainSelectedInstOperands,
     /*  309143 */     // GIR_Coverage, 13989,
     /*  309143 */     GIR_EraseRootFromParent_Done,
     /*  309144 */   // Label 5763: @309144
     /*  309144 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(309210), // Rule ID 13990 //
     /*  309149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  309160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  309163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  309166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309188 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309208 */     GIR_RootConstrainSelectedInstOperands,
     /*  309209 */     // GIR_Coverage, 13990,
     /*  309209 */     GIR_EraseRootFromParent_Done,
     /*  309210 */   // Label 5764: @309210
     /*  309210 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(309276), // Rule ID 13991 //
     /*  309215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  309226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  309229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  309232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309254 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309274 */     GIR_RootConstrainSelectedInstOperands,
     /*  309275 */     // GIR_Coverage, 13991,
     /*  309275 */     GIR_EraseRootFromParent_Done,
     /*  309276 */   // Label 5765: @309276
     /*  309276 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(309342), // Rule ID 13992 //
     /*  309281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  309292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  309295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  309298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309340 */     GIR_RootConstrainSelectedInstOperands,
     /*  309341 */     // GIR_Coverage, 13992,
     /*  309341 */     GIR_EraseRootFromParent_Done,
     /*  309342 */   // Label 5766: @309342
     /*  309342 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(309408), // Rule ID 13993 //
     /*  309347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  309358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  309361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  309364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309406 */     GIR_RootConstrainSelectedInstOperands,
     /*  309407 */     // GIR_Coverage, 13993,
     /*  309407 */     GIR_EraseRootFromParent_Done,
     /*  309408 */   // Label 5767: @309408
     /*  309408 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(309474), // Rule ID 13994 //
     /*  309413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  309452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309472 */     GIR_RootConstrainSelectedInstOperands,
     /*  309473 */     // GIR_Coverage, 13994,
     /*  309473 */     GIR_EraseRootFromParent_Done,
     /*  309474 */   // Label 5768: @309474
     /*  309474 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(309540), // Rule ID 13995 //
     /*  309479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  309490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  309493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  309496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309538 */     GIR_RootConstrainSelectedInstOperands,
     /*  309539 */     // GIR_Coverage, 13995,
     /*  309539 */     GIR_EraseRootFromParent_Done,
     /*  309540 */   // Label 5769: @309540
     /*  309540 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(309606), // Rule ID 13996 //
     /*  309545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  309548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  309556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  309559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  309562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  309584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309604 */     GIR_RootConstrainSelectedInstOperands,
     /*  309605 */     // GIR_Coverage, 13996,
     /*  309605 */     GIR_EraseRootFromParent_Done,
     /*  309606 */   // Label 5770: @309606
     /*  309606 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(309672), // Rule ID 13997 //
     /*  309611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  309614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  309622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  309625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  309628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  309650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309670 */     GIR_RootConstrainSelectedInstOperands,
     /*  309671 */     // GIR_Coverage, 13997,
     /*  309671 */     GIR_EraseRootFromParent_Done,
     /*  309672 */   // Label 5771: @309672
     /*  309672 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(309738), // Rule ID 13998 //
     /*  309677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  309688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  309691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  309694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309716 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  309719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309736 */     GIR_RootConstrainSelectedInstOperands,
     /*  309737 */     // GIR_Coverage, 13998,
     /*  309737 */     GIR_EraseRootFromParent_Done,
     /*  309738 */   // Label 5772: @309738
     /*  309738 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(309804), // Rule ID 13999 //
     /*  309743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  309754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  309757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  309760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  309785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309802 */     GIR_RootConstrainSelectedInstOperands,
     /*  309803 */     // GIR_Coverage, 13999,
     /*  309803 */     GIR_EraseRootFromParent_Done,
     /*  309804 */   // Label 5773: @309804
     /*  309804 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(309870), // Rule ID 14000 //
     /*  309809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  309820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  309823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  309826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309848 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  309851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309868 */     GIR_RootConstrainSelectedInstOperands,
     /*  309869 */     // GIR_Coverage, 14000,
     /*  309869 */     GIR_EraseRootFromParent_Done,
     /*  309870 */   // Label 5774: @309870
     /*  309870 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(309936), // Rule ID 14001 //
     /*  309875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  309886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  309889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  309892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309914 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  309917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309934 */     GIR_RootConstrainSelectedInstOperands,
     /*  309935 */     // GIR_Coverage, 14001,
     /*  309935 */     GIR_EraseRootFromParent_Done,
     /*  309936 */   // Label 5775: @309936
     /*  309936 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(310002), // Rule ID 14002 //
     /*  309941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  309952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  309955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  309958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309980 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  309983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310000 */     GIR_RootConstrainSelectedInstOperands,
     /*  310001 */     // GIR_Coverage, 14002,
     /*  310001 */     GIR_EraseRootFromParent_Done,
     /*  310002 */   // Label 5776: @310002
     /*  310002 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(310068), // Rule ID 14003 //
     /*  310007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  310018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  310021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  310024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310046 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  310046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  310063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310066 */     GIR_RootConstrainSelectedInstOperands,
     /*  310067 */     // GIR_Coverage, 14003,
     /*  310067 */     GIR_EraseRootFromParent_Done,
     /*  310068 */   // Label 5777: @310068
     /*  310068 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(310134), // Rule ID 14004 //
     /*  310073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  310084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  310087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  310090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310132 */     GIR_RootConstrainSelectedInstOperands,
     /*  310133 */     // GIR_Coverage, 14004,
     /*  310133 */     GIR_EraseRootFromParent_Done,
     /*  310134 */   // Label 5778: @310134
     /*  310134 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(310200), // Rule ID 14005 //
     /*  310139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  310150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  310153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  310156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310198 */     GIR_RootConstrainSelectedInstOperands,
     /*  310199 */     // GIR_Coverage, 14005,
     /*  310199 */     GIR_EraseRootFromParent_Done,
     /*  310200 */   // Label 5779: @310200
     /*  310200 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(310266), // Rule ID 14006 //
     /*  310205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  310216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  310219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  310222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310264 */     GIR_RootConstrainSelectedInstOperands,
     /*  310265 */     // GIR_Coverage, 14006,
     /*  310265 */     GIR_EraseRootFromParent_Done,
     /*  310266 */   // Label 5780: @310266
     /*  310266 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(310332), // Rule ID 14007 //
     /*  310271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  310282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  310285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  310288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310310 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310330 */     GIR_RootConstrainSelectedInstOperands,
     /*  310331 */     // GIR_Coverage, 14007,
     /*  310331 */     GIR_EraseRootFromParent_Done,
     /*  310332 */   // Label 5781: @310332
     /*  310332 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(310398), // Rule ID 14008 //
     /*  310337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  310348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  310351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  310354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310376 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310396 */     GIR_RootConstrainSelectedInstOperands,
     /*  310397 */     // GIR_Coverage, 14008,
     /*  310397 */     GIR_EraseRootFromParent_Done,
     /*  310398 */   // Label 5782: @310398
     /*  310398 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(310464), // Rule ID 14009 //
     /*  310403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  310414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  310417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  310420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310442 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310462 */     GIR_RootConstrainSelectedInstOperands,
     /*  310463 */     // GIR_Coverage, 14009,
     /*  310463 */     GIR_EraseRootFromParent_Done,
     /*  310464 */   // Label 5783: @310464
     /*  310464 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(310530), // Rule ID 14010 //
     /*  310469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  310480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  310483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  310486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310528 */     GIR_RootConstrainSelectedInstOperands,
     /*  310529 */     // GIR_Coverage, 14010,
     /*  310529 */     GIR_EraseRootFromParent_Done,
     /*  310530 */   // Label 5784: @310530
     /*  310530 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(310596), // Rule ID 14011 //
     /*  310535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  310546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  310549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  310552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310594 */     GIR_RootConstrainSelectedInstOperands,
     /*  310595 */     // GIR_Coverage, 14011,
     /*  310595 */     GIR_EraseRootFromParent_Done,
     /*  310596 */   // Label 5785: @310596
     /*  310596 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(310662), // Rule ID 14012 //
     /*  310601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  310612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  310615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  310618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310640 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310660 */     GIR_RootConstrainSelectedInstOperands,
     /*  310661 */     // GIR_Coverage, 14012,
     /*  310661 */     GIR_EraseRootFromParent_Done,
     /*  310662 */   // Label 5786: @310662
     /*  310662 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(310728), // Rule ID 14013 //
     /*  310667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  310678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  310681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  310684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310706 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310726 */     GIR_RootConstrainSelectedInstOperands,
     /*  310727 */     // GIR_Coverage, 14013,
     /*  310727 */     GIR_EraseRootFromParent_Done,
     /*  310728 */   // Label 5787: @310728
     /*  310728 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(310794), // Rule ID 14014 //
     /*  310733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  310744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  310747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  310750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310772 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310792 */     GIR_RootConstrainSelectedInstOperands,
     /*  310793 */     // GIR_Coverage, 14014,
     /*  310793 */     GIR_EraseRootFromParent_Done,
     /*  310794 */   // Label 5788: @310794
     /*  310794 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(310860), // Rule ID 14015 //
     /*  310799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  310810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  310813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  310816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310838 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310858 */     GIR_RootConstrainSelectedInstOperands,
     /*  310859 */     // GIR_Coverage, 14015,
     /*  310859 */     GIR_EraseRootFromParent_Done,
     /*  310860 */   // Label 5789: @310860
     /*  310860 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(310926), // Rule ID 14016 //
     /*  310865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  310868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  310876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  310879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  310882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310904 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310924 */     GIR_RootConstrainSelectedInstOperands,
     /*  310925 */     // GIR_Coverage, 14016,
     /*  310925 */     GIR_EraseRootFromParent_Done,
     /*  310926 */   // Label 5790: @310926
     /*  310926 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(310992), // Rule ID 14017 //
     /*  310931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  310934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  310942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  310945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  310948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310990 */     GIR_RootConstrainSelectedInstOperands,
     /*  310991 */     // GIR_Coverage, 14017,
     /*  310991 */     GIR_EraseRootFromParent_Done,
     /*  310992 */   // Label 5791: @310992
     /*  310992 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(311058), // Rule ID 14018 //
     /*  310997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311056 */     GIR_RootConstrainSelectedInstOperands,
     /*  311057 */     // GIR_Coverage, 14018,
     /*  311057 */     GIR_EraseRootFromParent_Done,
     /*  311058 */   // Label 5792: @311058
     /*  311058 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(311124), // Rule ID 14019 //
     /*  311063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  311074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  311077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  311080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311102 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311122 */     GIR_RootConstrainSelectedInstOperands,
     /*  311123 */     // GIR_Coverage, 14019,
     /*  311123 */     GIR_EraseRootFromParent_Done,
     /*  311124 */   // Label 5793: @311124
     /*  311124 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(311190), // Rule ID 14020 //
     /*  311129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  311132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  311140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  311143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  311146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311188 */     GIR_RootConstrainSelectedInstOperands,
     /*  311189 */     // GIR_Coverage, 14020,
     /*  311189 */     GIR_EraseRootFromParent_Done,
     /*  311190 */   // Label 5794: @311190
     /*  311190 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(311256), // Rule ID 14021 //
     /*  311195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  311198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  311206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  311209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  311212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311234 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311254 */     GIR_RootConstrainSelectedInstOperands,
     /*  311255 */     // GIR_Coverage, 14021,
     /*  311255 */     GIR_EraseRootFromParent_Done,
     /*  311256 */   // Label 5795: @311256
     /*  311256 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(311322), // Rule ID 14022 //
     /*  311261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  311272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  311275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  311278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311300 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  311303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311320 */     GIR_RootConstrainSelectedInstOperands,
     /*  311321 */     // GIR_Coverage, 14022,
     /*  311321 */     GIR_EraseRootFromParent_Done,
     /*  311322 */   // Label 5796: @311322
     /*  311322 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(311388), // Rule ID 14023 //
     /*  311327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  311338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  311341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  311344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311366 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  311369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311386 */     GIR_RootConstrainSelectedInstOperands,
     /*  311387 */     // GIR_Coverage, 14023,
     /*  311387 */     GIR_EraseRootFromParent_Done,
     /*  311388 */   // Label 5797: @311388
     /*  311388 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(311454), // Rule ID 14024 //
     /*  311393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  311404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  311407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  311410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311452 */     GIR_RootConstrainSelectedInstOperands,
     /*  311453 */     // GIR_Coverage, 14024,
     /*  311453 */     GIR_EraseRootFromParent_Done,
     /*  311454 */   // Label 5798: @311454
     /*  311454 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(311520), // Rule ID 14025 //
     /*  311459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  311470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  311473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  311476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311498 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311518 */     GIR_RootConstrainSelectedInstOperands,
     /*  311519 */     // GIR_Coverage, 14025,
     /*  311519 */     GIR_EraseRootFromParent_Done,
     /*  311520 */   // Label 5799: @311520
     /*  311520 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(311586), // Rule ID 14026 //
     /*  311525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  311528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  311536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  311539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  311542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311564 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311584 */     GIR_RootConstrainSelectedInstOperands,
     /*  311585 */     // GIR_Coverage, 14026,
     /*  311585 */     GIR_EraseRootFromParent_Done,
     /*  311586 */   // Label 5800: @311586
     /*  311586 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(311652), // Rule ID 14027 //
     /*  311591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  311594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  311602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  311605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  311608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311630 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311650 */     GIR_RootConstrainSelectedInstOperands,
     /*  311651 */     // GIR_Coverage, 14027,
     /*  311651 */     GIR_EraseRootFromParent_Done,
     /*  311652 */   // Label 5801: @311652
     /*  311652 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(311718), // Rule ID 14028 //
     /*  311657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  311668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  311671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  311674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311696 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311716 */     GIR_RootConstrainSelectedInstOperands,
     /*  311717 */     // GIR_Coverage, 14028,
     /*  311717 */     GIR_EraseRootFromParent_Done,
     /*  311718 */   // Label 5802: @311718
     /*  311718 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(311784), // Rule ID 14029 //
     /*  311723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  311734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  311737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  311740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311762 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311782 */     GIR_RootConstrainSelectedInstOperands,
     /*  311783 */     // GIR_Coverage, 14029,
     /*  311783 */     GIR_EraseRootFromParent_Done,
     /*  311784 */   // Label 5803: @311784
     /*  311784 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(311850), // Rule ID 14030 //
     /*  311789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  311792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  311800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  311803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  311806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311828 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311848 */     GIR_RootConstrainSelectedInstOperands,
     /*  311849 */     // GIR_Coverage, 14030,
     /*  311849 */     GIR_EraseRootFromParent_Done,
     /*  311850 */   // Label 5804: @311850
     /*  311850 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(311916), // Rule ID 14031 //
     /*  311855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  311858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  311866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  311869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  311872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311914 */     GIR_RootConstrainSelectedInstOperands,
     /*  311915 */     // GIR_Coverage, 14031,
     /*  311915 */     GIR_EraseRootFromParent_Done,
     /*  311916 */   // Label 5805: @311916
     /*  311916 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(311982), // Rule ID 14032 //
     /*  311921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  311924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  311932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  311935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  311938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311960 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311980 */     GIR_RootConstrainSelectedInstOperands,
     /*  311981 */     // GIR_Coverage, 14032,
     /*  311981 */     GIR_EraseRootFromParent_Done,
     /*  311982 */   // Label 5806: @311982
     /*  311982 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(312048), // Rule ID 14033 //
     /*  311987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  311990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  311998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  312001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  312004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312026 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  312026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  312029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312046 */     GIR_RootConstrainSelectedInstOperands,
     /*  312047 */     // GIR_Coverage, 14033,
     /*  312047 */     GIR_EraseRootFromParent_Done,
     /*  312048 */   // Label 5807: @312048
     /*  312048 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(312114), // Rule ID 14034 //
     /*  312053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  312064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  312067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312092 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312112 */     GIR_RootConstrainSelectedInstOperands,
     /*  312113 */     // GIR_Coverage, 14034,
     /*  312113 */     GIR_EraseRootFromParent_Done,
     /*  312114 */   // Label 5808: @312114
     /*  312114 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(312180), // Rule ID 14035 //
     /*  312119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  312130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  312133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  312136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312158 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312178 */     GIR_RootConstrainSelectedInstOperands,
     /*  312179 */     // GIR_Coverage, 14035,
     /*  312179 */     GIR_EraseRootFromParent_Done,
     /*  312180 */   // Label 5809: @312180
     /*  312180 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(312246), // Rule ID 14036 //
     /*  312185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  312196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  312199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312224 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312244 */     GIR_RootConstrainSelectedInstOperands,
     /*  312245 */     // GIR_Coverage, 14036,
     /*  312245 */     GIR_EraseRootFromParent_Done,
     /*  312246 */   // Label 5810: @312246
     /*  312246 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(312312), // Rule ID 14037 //
     /*  312251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  312262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  312265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  312268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312290 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312310 */     GIR_RootConstrainSelectedInstOperands,
     /*  312311 */     // GIR_Coverage, 14037,
     /*  312311 */     GIR_EraseRootFromParent_Done,
     /*  312312 */   // Label 5811: @312312
     /*  312312 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(312378), // Rule ID 14038 //
     /*  312317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  312320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  312328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  312331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  312334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312356 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312376 */     GIR_RootConstrainSelectedInstOperands,
     /*  312377 */     // GIR_Coverage, 14038,
     /*  312377 */     GIR_EraseRootFromParent_Done,
     /*  312378 */   // Label 5812: @312378
     /*  312378 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(312444), // Rule ID 14039 //
     /*  312383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  312386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  312394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  312397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  312400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312422 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312442 */     GIR_RootConstrainSelectedInstOperands,
     /*  312443 */     // GIR_Coverage, 14039,
     /*  312443 */     GIR_EraseRootFromParent_Done,
     /*  312444 */   // Label 5813: @312444
     /*  312444 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(312510), // Rule ID 14040 //
     /*  312449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  312466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312488 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312508 */     GIR_RootConstrainSelectedInstOperands,
     /*  312509 */     // GIR_Coverage, 14040,
     /*  312509 */     GIR_EraseRootFromParent_Done,
     /*  312510 */   // Label 5814: @312510
     /*  312510 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(312576), // Rule ID 14041 //
     /*  312515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  312532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312554 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312574 */     GIR_RootConstrainSelectedInstOperands,
     /*  312575 */     // GIR_Coverage, 14041,
     /*  312575 */     GIR_EraseRootFromParent_Done,
     /*  312576 */   // Label 5815: @312576
     /*  312576 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(312642), // Rule ID 14042 //
     /*  312581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  312592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  312595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  312598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312620 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312640 */     GIR_RootConstrainSelectedInstOperands,
     /*  312641 */     // GIR_Coverage, 14042,
     /*  312641 */     GIR_EraseRootFromParent_Done,
     /*  312642 */   // Label 5816: @312642
     /*  312642 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(312708), // Rule ID 14043 //
     /*  312647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  312658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  312661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  312664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312686 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312706 */     GIR_RootConstrainSelectedInstOperands,
     /*  312707 */     // GIR_Coverage, 14043,
     /*  312707 */     GIR_EraseRootFromParent_Done,
     /*  312708 */   // Label 5817: @312708
     /*  312708 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(312774), // Rule ID 14044 //
     /*  312713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  312724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  312727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  312730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312752 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312772 */     GIR_RootConstrainSelectedInstOperands,
     /*  312773 */     // GIR_Coverage, 14044,
     /*  312773 */     GIR_EraseRootFromParent_Done,
     /*  312774 */   // Label 5818: @312774
     /*  312774 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(312840), // Rule ID 14045 //
     /*  312779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  312790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  312793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  312796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312818 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312838 */     GIR_RootConstrainSelectedInstOperands,
     /*  312839 */     // GIR_Coverage, 14045,
     /*  312839 */     GIR_EraseRootFromParent_Done,
     /*  312840 */   // Label 5819: @312840
     /*  312840 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(312906), // Rule ID 14046 //
     /*  312845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  312848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  312856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  312859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  312862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312884 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  312884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312904 */     GIR_RootConstrainSelectedInstOperands,
     /*  312905 */     // GIR_Coverage, 14046,
     /*  312905 */     GIR_EraseRootFromParent_Done,
     /*  312906 */   // Label 5820: @312906
     /*  312906 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(312972), // Rule ID 14047 //
     /*  312911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  312914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  312922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  312925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  312928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312950 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  312950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312970 */     GIR_RootConstrainSelectedInstOperands,
     /*  312971 */     // GIR_Coverage, 14047,
     /*  312971 */     GIR_EraseRootFromParent_Done,
     /*  312972 */   // Label 5821: @312972
     /*  312972 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(313038), // Rule ID 14048 //
     /*  312977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  312980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  312988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  312991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  312994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313016 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313036 */     GIR_RootConstrainSelectedInstOperands,
     /*  313037 */     // GIR_Coverage, 14048,
     /*  313037 */     GIR_EraseRootFromParent_Done,
     /*  313038 */   // Label 5822: @313038
     /*  313038 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(313104), // Rule ID 14049 //
     /*  313043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  313054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  313057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  313060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313082 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  313085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313102 */     GIR_RootConstrainSelectedInstOperands,
     /*  313103 */     // GIR_Coverage, 14049,
     /*  313103 */     GIR_EraseRootFromParent_Done,
     /*  313104 */   // Label 5823: @313104
     /*  313104 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(313170), // Rule ID 14050 //
     /*  313109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  313126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313148 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313168 */     GIR_RootConstrainSelectedInstOperands,
     /*  313169 */     // GIR_Coverage, 14050,
     /*  313169 */     GIR_EraseRootFromParent_Done,
     /*  313170 */   // Label 5824: @313170
     /*  313170 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(313236), // Rule ID 14051 //
     /*  313175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  313183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  313186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  313189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  313192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313214 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  313217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  313223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313234 */     GIR_RootConstrainSelectedInstOperands,
     /*  313235 */     // GIR_Coverage, 14051,
     /*  313235 */     GIR_EraseRootFromParent_Done,
     /*  313236 */   // Label 5825: @313236
     /*  313236 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(313302), // Rule ID 19054 //
     /*  313241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  313252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  313255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313280 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  313283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313300 */     GIR_RootConstrainSelectedInstOperands,
     /*  313301 */     // GIR_Coverage, 19054,
     /*  313301 */     GIR_EraseRootFromParent_Done,
     /*  313302 */   // Label 5826: @313302
     /*  313302 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(313368), // Rule ID 19055 //
     /*  313307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  313318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  313321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  313324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313346 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  313349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313366 */     GIR_RootConstrainSelectedInstOperands,
     /*  313367 */     // GIR_Coverage, 19055,
     /*  313367 */     GIR_EraseRootFromParent_Done,
     /*  313368 */   // Label 5827: @313368
     /*  313368 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(313434), // Rule ID 19058 //
     /*  313373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  313384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  313387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  313390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313412 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  313415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313432 */     GIR_RootConstrainSelectedInstOperands,
     /*  313433 */     // GIR_Coverage, 19058,
     /*  313433 */     GIR_EraseRootFromParent_Done,
     /*  313434 */   // Label 5828: @313434
     /*  313434 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(313500), // Rule ID 19059 //
     /*  313439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  313450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  313453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  313456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313478 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  313481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313498 */     GIR_RootConstrainSelectedInstOperands,
     /*  313499 */     // GIR_Coverage, 19059,
     /*  313499 */     GIR_EraseRootFromParent_Done,
     /*  313500 */   // Label 5829: @313500
     /*  313500 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(313566), // Rule ID 19062 //
     /*  313505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313544 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  313547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313564 */     GIR_RootConstrainSelectedInstOperands,
     /*  313565 */     // GIR_Coverage, 19062,
     /*  313565 */     GIR_EraseRootFromParent_Done,
     /*  313566 */   // Label 5830: @313566
     /*  313566 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(313632), // Rule ID 19063 //
     /*  313571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313610 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11261:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  313613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313630 */     GIR_RootConstrainSelectedInstOperands,
     /*  313631 */     // GIR_Coverage, 19063,
     /*  313631 */     GIR_EraseRootFromParent_Done,
     /*  313632 */   // Label 5831: @313632
     /*  313632 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(313698), // Rule ID 19066 //
     /*  313637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313676 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  313679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313696 */     GIR_RootConstrainSelectedInstOperands,
     /*  313697 */     // GIR_Coverage, 19066,
     /*  313697 */     GIR_EraseRootFromParent_Done,
     /*  313698 */   // Label 5832: @313698
     /*  313698 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(313764), // Rule ID 19067 //
     /*  313703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313742 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11261:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  313745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313762 */     GIR_RootConstrainSelectedInstOperands,
     /*  313763 */     // GIR_Coverage, 19067,
     /*  313763 */     GIR_EraseRootFromParent_Done,
     /*  313764 */   // Label 5833: @313764
     /*  313764 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(313830), // Rule ID 19070 //
     /*  313769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313808 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  313811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313828 */     GIR_RootConstrainSelectedInstOperands,
     /*  313829 */     // GIR_Coverage, 19070,
     /*  313829 */     GIR_EraseRootFromParent_Done,
     /*  313830 */   // Label 5834: @313830
     /*  313830 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(313896), // Rule ID 19071 //
     /*  313835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313874 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11261:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  313877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313894 */     GIR_RootConstrainSelectedInstOperands,
     /*  313895 */     // GIR_Coverage, 19071,
     /*  313895 */     GIR_EraseRootFromParent_Done,
     /*  313896 */   // Label 5835: @313896
     /*  313896 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(313962), // Rule ID 19074 //
     /*  313901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  313918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313940 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  313943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313960 */     GIR_RootConstrainSelectedInstOperands,
     /*  313961 */     // GIR_Coverage, 19074,
     /*  313961 */     GIR_EraseRootFromParent_Done,
     /*  313962 */   // Label 5836: @313962
     /*  313962 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(314028), // Rule ID 19075 //
     /*  313967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  313984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314006 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  314009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314026 */     GIR_RootConstrainSelectedInstOperands,
     /*  314027 */     // GIR_Coverage, 19075,
     /*  314027 */     GIR_EraseRootFromParent_Done,
     /*  314028 */   // Label 5837: @314028
     /*  314028 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(314094), // Rule ID 19078 //
     /*  314033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314072 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  314075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314092 */     GIR_RootConstrainSelectedInstOperands,
     /*  314093 */     // GIR_Coverage, 19078,
     /*  314093 */     GIR_EraseRootFromParent_Done,
     /*  314094 */   // Label 5838: @314094
     /*  314094 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(314160), // Rule ID 19079 //
     /*  314099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  314110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  314113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  314116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314138 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  314141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314158 */     GIR_RootConstrainSelectedInstOperands,
     /*  314159 */     // GIR_Coverage, 19079,
     /*  314159 */     GIR_EraseRootFromParent_Done,
     /*  314160 */   // Label 5839: @314160
     /*  314160 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(314226), // Rule ID 19082 //
     /*  314165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314204 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  314204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  314207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314224 */     GIR_RootConstrainSelectedInstOperands,
     /*  314225 */     // GIR_Coverage, 19082,
     /*  314225 */     GIR_EraseRootFromParent_Done,
     /*  314226 */   // Label 5840: @314226
     /*  314226 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(314292), // Rule ID 19083 //
     /*  314231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  314242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  314245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  314248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314270 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  314270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  314273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314290 */     GIR_RootConstrainSelectedInstOperands,
     /*  314291 */     // GIR_Coverage, 19083,
     /*  314291 */     GIR_EraseRootFromParent_Done,
     /*  314292 */   // Label 5841: @314292
     /*  314292 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(314358), // Rule ID 19086 //
     /*  314297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314336 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  314339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314356 */     GIR_RootConstrainSelectedInstOperands,
     /*  314357 */     // GIR_Coverage, 19086,
     /*  314357 */     GIR_EraseRootFromParent_Done,
     /*  314358 */   // Label 5842: @314358
     /*  314358 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(314424), // Rule ID 19087 //
     /*  314363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  314374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  314377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  314380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314402 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  314405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314422 */     GIR_RootConstrainSelectedInstOperands,
     /*  314423 */     // GIR_Coverage, 19087,
     /*  314423 */     GIR_EraseRootFromParent_Done,
     /*  314424 */   // Label 5843: @314424
     /*  314424 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(314490), // Rule ID 19090 //
     /*  314429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314468 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  314471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314488 */     GIR_RootConstrainSelectedInstOperands,
     /*  314489 */     // GIR_Coverage, 19090,
     /*  314489 */     GIR_EraseRootFromParent_Done,
     /*  314490 */   // Label 5844: @314490
     /*  314490 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(314556), // Rule ID 19091 //
     /*  314495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  314506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314534 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  314537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314554 */     GIR_RootConstrainSelectedInstOperands,
     /*  314555 */     // GIR_Coverage, 19091,
     /*  314555 */     GIR_EraseRootFromParent_Done,
     /*  314556 */   // Label 5845: @314556
     /*  314556 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(314622), // Rule ID 19094 //
     /*  314561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314600 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  314603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314620 */     GIR_RootConstrainSelectedInstOperands,
     /*  314621 */     // GIR_Coverage, 19094,
     /*  314621 */     GIR_EraseRootFromParent_Done,
     /*  314622 */   // Label 5846: @314622
     /*  314622 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(314688), // Rule ID 19095 //
     /*  314627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314666 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  314669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314686 */     GIR_RootConstrainSelectedInstOperands,
     /*  314687 */     // GIR_Coverage, 19095,
     /*  314687 */     GIR_EraseRootFromParent_Done,
     /*  314688 */   // Label 5847: @314688
     /*  314688 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(314754), // Rule ID 19098 //
     /*  314693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314732 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  314735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314752 */     GIR_RootConstrainSelectedInstOperands,
     /*  314753 */     // GIR_Coverage, 19098,
     /*  314753 */     GIR_EraseRootFromParent_Done,
     /*  314754 */   // Label 5848: @314754
     /*  314754 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(314820), // Rule ID 19099 //
     /*  314759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  314762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314798 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11261:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  314801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314818 */     GIR_RootConstrainSelectedInstOperands,
     /*  314819 */     // GIR_Coverage, 19099,
     /*  314819 */     GIR_EraseRootFromParent_Done,
     /*  314820 */   // Label 5849: @314820
     /*  314820 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(314886), // Rule ID 19102 //
     /*  314825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314864 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  314867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314884 */     GIR_RootConstrainSelectedInstOperands,
     /*  314885 */     // GIR_Coverage, 19102,
     /*  314885 */     GIR_EraseRootFromParent_Done,
     /*  314886 */   // Label 5850: @314886
     /*  314886 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(314952), // Rule ID 19103 //
     /*  314891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  314894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314930 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11261:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  314933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314950 */     GIR_RootConstrainSelectedInstOperands,
     /*  314951 */     // GIR_Coverage, 19103,
     /*  314951 */     GIR_EraseRootFromParent_Done,
     /*  314952 */   // Label 5851: @314952
     /*  314952 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(315018), // Rule ID 19106 //
     /*  314957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  314968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  314971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  314974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314996 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  314999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315016 */     GIR_RootConstrainSelectedInstOperands,
     /*  315017 */     // GIR_Coverage, 19106,
     /*  315017 */     GIR_EraseRootFromParent_Done,
     /*  315018 */   // Label 5852: @315018
     /*  315018 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(315084), // Rule ID 19107 //
     /*  315023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  315031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  315034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  315037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  315040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315062 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11261:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  315062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  315065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  315069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  315082 */     GIR_RootConstrainSelectedInstOperands,
     /*  315083 */     // GIR_Coverage, 19107,
     /*  315083 */     GIR_EraseRootFromParent_Done,
     /*  315084 */   // Label 5853: @315084
     /*  315084 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(315147), // Rule ID 19770 //
     /*  315089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  315131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315145 */     GIR_RootConstrainSelectedInstOperands,
     /*  315146 */     // GIR_Coverage, 19770,
     /*  315146 */     GIR_EraseRootFromParent_Done,
     /*  315147 */   // Label 5854: @315147
     /*  315147 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(315210), // Rule ID 19771 //
     /*  315152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  315166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  315169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315191 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  315194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315208 */     GIR_RootConstrainSelectedInstOperands,
     /*  315209 */     // GIR_Coverage, 19771,
     /*  315209 */     GIR_EraseRootFromParent_Done,
     /*  315210 */   // Label 5855: @315210
     /*  315210 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(315273), // Rule ID 19774 //
     /*  315215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315254 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315271 */     GIR_RootConstrainSelectedInstOperands,
     /*  315272 */     // GIR_Coverage, 19774,
     /*  315272 */     GIR_EraseRootFromParent_Done,
     /*  315273 */   // Label 5856: @315273
     /*  315273 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(315336), // Rule ID 19775 //
     /*  315278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  315292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  315295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315317 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315334 */     GIR_RootConstrainSelectedInstOperands,
     /*  315335 */     // GIR_Coverage, 19775,
     /*  315335 */     GIR_EraseRootFromParent_Done,
     /*  315336 */   // Label 5857: @315336
     /*  315336 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(315399), // Rule ID 19778 //
     /*  315341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315380 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  315380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315397 */     GIR_RootConstrainSelectedInstOperands,
     /*  315398 */     // GIR_Coverage, 19778,
     /*  315398 */     GIR_EraseRootFromParent_Done,
     /*  315399 */   // Label 5858: @315399
     /*  315399 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(315462), // Rule ID 19779 //
     /*  315404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  315418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  315421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315443 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  315443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  315446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315460 */     GIR_RootConstrainSelectedInstOperands,
     /*  315461 */     // GIR_Coverage, 19779,
     /*  315461 */     GIR_EraseRootFromParent_Done,
     /*  315462 */   // Label 5859: @315462
     /*  315462 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(315525), // Rule ID 19782 //
     /*  315467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  315478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315506 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315523 */     GIR_RootConstrainSelectedInstOperands,
     /*  315524 */     // GIR_Coverage, 19782,
     /*  315524 */     GIR_EraseRootFromParent_Done,
     /*  315525 */   // Label 5860: @315525
     /*  315525 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(315588), // Rule ID 19783 //
     /*  315530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  315541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315569 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315586 */     GIR_RootConstrainSelectedInstOperands,
     /*  315587 */     // GIR_Coverage, 19783,
     /*  315587 */     GIR_EraseRootFromParent_Done,
     /*  315588 */   // Label 5861: @315588
     /*  315588 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(315651), // Rule ID 19786 //
     /*  315593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315632 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  315632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315649 */     GIR_RootConstrainSelectedInstOperands,
     /*  315650 */     // GIR_Coverage, 19786,
     /*  315650 */     GIR_EraseRootFromParent_Done,
     /*  315651 */   // Label 5862: @315651
     /*  315651 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(315714), // Rule ID 19787 //
     /*  315656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315695 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  315695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315712 */     GIR_RootConstrainSelectedInstOperands,
     /*  315713 */     // GIR_Coverage, 19787,
     /*  315713 */     GIR_EraseRootFromParent_Done,
     /*  315714 */   // Label 5863: @315714
     /*  315714 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(315777), // Rule ID 19790 //
     /*  315719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315758 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  315758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315775 */     GIR_RootConstrainSelectedInstOperands,
     /*  315776 */     // GIR_Coverage, 19790,
     /*  315776 */     GIR_EraseRootFromParent_Done,
     /*  315777 */   // Label 5864: @315777
     /*  315777 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(315840), // Rule ID 19791 //
     /*  315782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315821 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  315821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315838 */     GIR_RootConstrainSelectedInstOperands,
     /*  315839 */     // GIR_Coverage, 19791,
     /*  315839 */     GIR_EraseRootFromParent_Done,
     /*  315840 */   // Label 5865: @315840
     /*  315840 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(315903), // Rule ID 19794 //
     /*  315845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  315856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315884 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  315887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315901 */     GIR_RootConstrainSelectedInstOperands,
     /*  315902 */     // GIR_Coverage, 19794,
     /*  315902 */     GIR_EraseRootFromParent_Done,
     /*  315903 */   // Label 5866: @315903
     /*  315903 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(315966), // Rule ID 19795 //
     /*  315908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  315919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315947 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  315950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315964 */     GIR_RootConstrainSelectedInstOperands,
     /*  315965 */     // GIR_Coverage, 19795,
     /*  315965 */     GIR_EraseRootFromParent_Done,
     /*  315966 */   // Label 5867: @315966
     /*  315966 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(316029), // Rule ID 19798 //
     /*  315971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  315982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  315985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  315988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316010 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316027 */     GIR_RootConstrainSelectedInstOperands,
     /*  316028 */     // GIR_Coverage, 19798,
     /*  316028 */     GIR_EraseRootFromParent_Done,
     /*  316029 */   // Label 5868: @316029
     /*  316029 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(316092), // Rule ID 19799 //
     /*  316034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  316048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  316051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316073 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316090 */     GIR_RootConstrainSelectedInstOperands,
     /*  316091 */     // GIR_Coverage, 19799,
     /*  316091 */     GIR_EraseRootFromParent_Done,
     /*  316092 */   // Label 5869: @316092
     /*  316092 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(316155), // Rule ID 19802 //
     /*  316097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  316108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316136 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316153 */     GIR_RootConstrainSelectedInstOperands,
     /*  316154 */     // GIR_Coverage, 19802,
     /*  316154 */     GIR_EraseRootFromParent_Done,
     /*  316155 */   // Label 5870: @316155
     /*  316155 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(316218), // Rule ID 19803 //
     /*  316160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  316171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  316174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  316177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316199 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316216 */     GIR_RootConstrainSelectedInstOperands,
     /*  316217 */     // GIR_Coverage, 19803,
     /*  316217 */     GIR_EraseRootFromParent_Done,
     /*  316218 */   // Label 5871: @316218
     /*  316218 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(316281), // Rule ID 19806 //
     /*  316223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316262 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316279 */     GIR_RootConstrainSelectedInstOperands,
     /*  316280 */     // GIR_Coverage, 19806,
     /*  316280 */     GIR_EraseRootFromParent_Done,
     /*  316281 */   // Label 5872: @316281
     /*  316281 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(316344), // Rule ID 19807 //
     /*  316286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  316300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  316303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316325 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316342 */     GIR_RootConstrainSelectedInstOperands,
     /*  316343 */     // GIR_Coverage, 19807,
     /*  316343 */     GIR_EraseRootFromParent_Done,
     /*  316344 */   // Label 5873: @316344
     /*  316344 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(316407), // Rule ID 19810 //
     /*  316349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316388 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316405 */     GIR_RootConstrainSelectedInstOperands,
     /*  316406 */     // GIR_Coverage, 19810,
     /*  316406 */     GIR_EraseRootFromParent_Done,
     /*  316407 */   // Label 5874: @316407
     /*  316407 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(316470), // Rule ID 19811 //
     /*  316412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  316426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  316429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316451 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316468 */     GIR_RootConstrainSelectedInstOperands,
     /*  316469 */     // GIR_Coverage, 19811,
     /*  316469 */     GIR_EraseRootFromParent_Done,
     /*  316470 */   // Label 5875: @316470
     /*  316470 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(316533), // Rule ID 19814 //
     /*  316475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316531 */     GIR_RootConstrainSelectedInstOperands,
     /*  316532 */     // GIR_Coverage, 19814,
     /*  316532 */     GIR_EraseRootFromParent_Done,
     /*  316533 */   // Label 5876: @316533
     /*  316533 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(316596), // Rule ID 19815 //
     /*  316538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316577 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316594 */     GIR_RootConstrainSelectedInstOperands,
     /*  316595 */     // GIR_Coverage, 19815,
     /*  316595 */     GIR_EraseRootFromParent_Done,
     /*  316596 */   // Label 5877: @316596
     /*  316596 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(316659), // Rule ID 19818 //
     /*  316601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316640 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316657 */     GIR_RootConstrainSelectedInstOperands,
     /*  316658 */     // GIR_Coverage, 19818,
     /*  316658 */     GIR_EraseRootFromParent_Done,
     /*  316659 */   // Label 5878: @316659
     /*  316659 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(316722), // Rule ID 19819 //
     /*  316664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316703 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316720 */     GIR_RootConstrainSelectedInstOperands,
     /*  316721 */     // GIR_Coverage, 19819,
     /*  316721 */     GIR_EraseRootFromParent_Done,
     /*  316722 */   // Label 5879: @316722
     /*  316722 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(316785), // Rule ID 19822 //
     /*  316727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316766 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316783 */     GIR_RootConstrainSelectedInstOperands,
     /*  316784 */     // GIR_Coverage, 19822,
     /*  316784 */     GIR_EraseRootFromParent_Done,
     /*  316785 */   // Label 5880: @316785
     /*  316785 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(316848), // Rule ID 19823 //
     /*  316790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316829 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316846 */     GIR_RootConstrainSelectedInstOperands,
     /*  316847 */     // GIR_Coverage, 19823,
     /*  316847 */     GIR_EraseRootFromParent_Done,
     /*  316848 */   // Label 5881: @316848
     /*  316848 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(316911), // Rule ID 19826 //
     /*  316853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  316867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  316870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316892 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316909 */     GIR_RootConstrainSelectedInstOperands,
     /*  316910 */     // GIR_Coverage, 19826,
     /*  316910 */     GIR_EraseRootFromParent_Done,
     /*  316911 */   // Label 5882: @316911
     /*  316911 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(316974), // Rule ID 19827 //
     /*  316916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  316930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  316933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316955 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316972 */     GIR_RootConstrainSelectedInstOperands,
     /*  316973 */     // GIR_Coverage, 19827,
     /*  316973 */     GIR_EraseRootFromParent_Done,
     /*  316974 */   // Label 5883: @316974
     /*  316974 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(317037), // Rule ID 19830 //
     /*  316979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  316990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  316993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  316996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317018 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  317021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317035 */     GIR_RootConstrainSelectedInstOperands,
     /*  317036 */     // GIR_Coverage, 19830,
     /*  317036 */     GIR_EraseRootFromParent_Done,
     /*  317037 */   // Label 5884: @317037
     /*  317037 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(317100), // Rule ID 19831 //
     /*  317042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  317056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317081 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  317084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317098 */     GIR_RootConstrainSelectedInstOperands,
     /*  317099 */     // GIR_Coverage, 19831,
     /*  317099 */     GIR_EraseRootFromParent_Done,
     /*  317100 */   // Label 5885: @317100
     /*  317100 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(317163), // Rule ID 19834 //
     /*  317105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317144 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  317147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317161 */     GIR_RootConstrainSelectedInstOperands,
     /*  317162 */     // GIR_Coverage, 19834,
     /*  317162 */     GIR_EraseRootFromParent_Done,
     /*  317163 */   // Label 5886: @317163
     /*  317163 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(317226), // Rule ID 19835 //
     /*  317168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  317182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317207 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  317210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317224 */     GIR_RootConstrainSelectedInstOperands,
     /*  317225 */     // GIR_Coverage, 19835,
     /*  317225 */     GIR_EraseRootFromParent_Done,
     /*  317226 */   // Label 5887: @317226
     /*  317226 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(317289), // Rule ID 19838 //
     /*  317231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317270 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  317273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317287 */     GIR_RootConstrainSelectedInstOperands,
     /*  317288 */     // GIR_Coverage, 19838,
     /*  317288 */     GIR_EraseRootFromParent_Done,
     /*  317289 */   // Label 5888: @317289
     /*  317289 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(317352), // Rule ID 19839 //
     /*  317294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  317308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317333 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  317336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317350 */     GIR_RootConstrainSelectedInstOperands,
     /*  317351 */     // GIR_Coverage, 19839,
     /*  317351 */     GIR_EraseRootFromParent_Done,
     /*  317352 */   // Label 5889: @317352
     /*  317352 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(317415), // Rule ID 19842 //
     /*  317357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317396 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  317399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317413 */     GIR_RootConstrainSelectedInstOperands,
     /*  317414 */     // GIR_Coverage, 19842,
     /*  317414 */     GIR_EraseRootFromParent_Done,
     /*  317415 */   // Label 5890: @317415
     /*  317415 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(317478), // Rule ID 19843 //
     /*  317420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  317434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317459 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  317462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317476 */     GIR_RootConstrainSelectedInstOperands,
     /*  317477 */     // GIR_Coverage, 19843,
     /*  317477 */     GIR_EraseRootFromParent_Done,
     /*  317478 */   // Label 5891: @317478
     /*  317478 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(317541), // Rule ID 19846 //
     /*  317483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317522 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  317525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317539 */     GIR_RootConstrainSelectedInstOperands,
     /*  317540 */     // GIR_Coverage, 19846,
     /*  317540 */     GIR_EraseRootFromParent_Done,
     /*  317541 */   // Label 5892: @317541
     /*  317541 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(317604), // Rule ID 19847 //
     /*  317546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317585 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  317588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317602 */     GIR_RootConstrainSelectedInstOperands,
     /*  317603 */     // GIR_Coverage, 19847,
     /*  317603 */     GIR_EraseRootFromParent_Done,
     /*  317604 */   // Label 5893: @317604
     /*  317604 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(317667), // Rule ID 19850 //
     /*  317609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  317626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  317641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317648 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  317648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  317651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317665 */     GIR_RootConstrainSelectedInstOperands,
     /*  317666 */     // GIR_Coverage, 19850,
     /*  317666 */     GIR_EraseRootFromParent_Done,
     /*  317667 */   // Label 5894: @317667
     /*  317667 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(317730), // Rule ID 19851 //
     /*  317672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  317689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  317704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317711 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  317711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  317714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317728 */     GIR_RootConstrainSelectedInstOperands,
     /*  317729 */     // GIR_Coverage, 19851,
     /*  317729 */     GIR_EraseRootFromParent_Done,
     /*  317730 */   // Label 5895: @317730
     /*  317730 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(317793), // Rule ID 19854 //
     /*  317735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317774 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  317777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317791 */     GIR_RootConstrainSelectedInstOperands,
     /*  317792 */     // GIR_Coverage, 19854,
     /*  317792 */     GIR_EraseRootFromParent_Done,
     /*  317793 */   // Label 5896: @317793
     /*  317793 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(317856), // Rule ID 19855 //
     /*  317798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317837 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  317840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317854 */     GIR_RootConstrainSelectedInstOperands,
     /*  317855 */     // GIR_Coverage, 19855,
     /*  317855 */     GIR_EraseRootFromParent_Done,
     /*  317856 */   // Label 5897: @317856
     /*  317856 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(317919), // Rule ID 19858 //
     /*  317861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317900 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  317903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317917 */     GIR_RootConstrainSelectedInstOperands,
     /*  317918 */     // GIR_Coverage, 19858,
     /*  317918 */     GIR_EraseRootFromParent_Done,
     /*  317919 */   // Label 5898: @317919
     /*  317919 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(317982), // Rule ID 19859 //
     /*  317924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317963 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  317966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317980 */     GIR_RootConstrainSelectedInstOperands,
     /*  317981 */     // GIR_Coverage, 19859,
     /*  317981 */     GIR_EraseRootFromParent_Done,
     /*  317982 */   // Label 5899: @317982
     /*  317982 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(318045), // Rule ID 19862 //
     /*  317987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  317998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318026 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  318029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318043 */     GIR_RootConstrainSelectedInstOperands,
     /*  318044 */     // GIR_Coverage, 19862,
     /*  318044 */     GIR_EraseRootFromParent_Done,
     /*  318045 */   // Label 5900: @318045
     /*  318045 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(318108), // Rule ID 19863 //
     /*  318050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  318061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  318064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  318067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  318082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318089 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  318092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318106 */     GIR_RootConstrainSelectedInstOperands,
     /*  318107 */     // GIR_Coverage, 19863,
     /*  318107 */     GIR_EraseRootFromParent_Done,
     /*  318108 */   // Label 5901: @318108
     /*  318108 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(318171), // Rule ID 19866 //
     /*  318113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318152 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  318155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318169 */     GIR_RootConstrainSelectedInstOperands,
     /*  318170 */     // GIR_Coverage, 19866,
     /*  318170 */     GIR_EraseRootFromParent_Done,
     /*  318171 */   // Label 5902: @318171
     /*  318171 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(318234), // Rule ID 19867 //
     /*  318176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  318190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318215 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  318218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318232 */     GIR_RootConstrainSelectedInstOperands,
     /*  318233 */     // GIR_Coverage, 19867,
     /*  318233 */     GIR_EraseRootFromParent_Done,
     /*  318234 */   // Label 5903: @318234
     /*  318234 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(318297), // Rule ID 19870 //
     /*  318239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  318281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318295 */     GIR_RootConstrainSelectedInstOperands,
     /*  318296 */     // GIR_Coverage, 19870,
     /*  318296 */     GIR_EraseRootFromParent_Done,
     /*  318297 */   // Label 5904: @318297
     /*  318297 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(318360), // Rule ID 19871 //
     /*  318302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  318316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318341 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  318344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318358 */     GIR_RootConstrainSelectedInstOperands,
     /*  318359 */     // GIR_Coverage, 19871,
     /*  318359 */     GIR_EraseRootFromParent_Done,
     /*  318360 */   // Label 5905: @318360
     /*  318360 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(318423), // Rule ID 19874 //
     /*  318365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318404 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  318407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318421 */     GIR_RootConstrainSelectedInstOperands,
     /*  318422 */     // GIR_Coverage, 19874,
     /*  318422 */     GIR_EraseRootFromParent_Done,
     /*  318423 */   // Label 5906: @318423
     /*  318423 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(318486), // Rule ID 19875 //
     /*  318428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  318439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  318442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  318445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  318460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318467 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  318470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318484 */     GIR_RootConstrainSelectedInstOperands,
     /*  318485 */     // GIR_Coverage, 19875,
     /*  318485 */     GIR_EraseRootFromParent_Done,
     /*  318486 */   // Label 5907: @318486
     /*  318486 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(318549), // Rule ID 19878 //
     /*  318491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  318533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318547 */     GIR_RootConstrainSelectedInstOperands,
     /*  318548 */     // GIR_Coverage, 19878,
     /*  318548 */     GIR_EraseRootFromParent_Done,
     /*  318549 */   // Label 5908: @318549
     /*  318549 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(318612), // Rule ID 19879 //
     /*  318554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318593 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  318596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318610 */     GIR_RootConstrainSelectedInstOperands,
     /*  318611 */     // GIR_Coverage, 19879,
     /*  318611 */     GIR_EraseRootFromParent_Done,
     /*  318612 */   // Label 5909: @318612
     /*  318612 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(318675), // Rule ID 19882 //
     /*  318617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  318659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318673 */     GIR_RootConstrainSelectedInstOperands,
     /*  318674 */     // GIR_Coverage, 19882,
     /*  318674 */     GIR_EraseRootFromParent_Done,
     /*  318675 */   // Label 5910: @318675
     /*  318675 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(318738), // Rule ID 19883 //
     /*  318680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318719 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  318722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318736 */     GIR_RootConstrainSelectedInstOperands,
     /*  318737 */     // GIR_Coverage, 19883,
     /*  318737 */     GIR_EraseRootFromParent_Done,
     /*  318738 */   // Label 5911: @318738
     /*  318738 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(318801), // Rule ID 19886 //
     /*  318743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  318785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318799 */     GIR_RootConstrainSelectedInstOperands,
     /*  318800 */     // GIR_Coverage, 19886,
     /*  318800 */     GIR_EraseRootFromParent_Done,
     /*  318801 */   // Label 5912: @318801
     /*  318801 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(318864), // Rule ID 19887 //
     /*  318806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318845 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  318848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318862 */     GIR_RootConstrainSelectedInstOperands,
     /*  318863 */     // GIR_Coverage, 19887,
     /*  318863 */     GIR_EraseRootFromParent_Done,
     /*  318864 */   // Label 5913: @318864
     /*  318864 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(318927), // Rule ID 19890 //
     /*  318869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  318883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  318886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318908 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  318911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318925 */     GIR_RootConstrainSelectedInstOperands,
     /*  318926 */     // GIR_Coverage, 19890,
     /*  318926 */     GIR_EraseRootFromParent_Done,
     /*  318927 */   // Label 5914: @318927
     /*  318927 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(318990), // Rule ID 19891 //
     /*  318932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  318946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  318949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318971 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  318974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318988 */     GIR_RootConstrainSelectedInstOperands,
     /*  318989 */     // GIR_Coverage, 19891,
     /*  318989 */     GIR_EraseRootFromParent_Done,
     /*  318990 */   // Label 5915: @318990
     /*  318990 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(319053), // Rule ID 19894 //
     /*  318995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319034 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319051 */     GIR_RootConstrainSelectedInstOperands,
     /*  319052 */     // GIR_Coverage, 19894,
     /*  319052 */     GIR_EraseRootFromParent_Done,
     /*  319053 */   // Label 5916: @319053
     /*  319053 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(319116), // Rule ID 19895 //
     /*  319058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  319072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  319075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319097 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319114 */     GIR_RootConstrainSelectedInstOperands,
     /*  319115 */     // GIR_Coverage, 19895,
     /*  319115 */     GIR_EraseRootFromParent_Done,
     /*  319116 */   // Label 5917: @319116
     /*  319116 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(319179), // Rule ID 19898 //
     /*  319121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319160 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319177 */     GIR_RootConstrainSelectedInstOperands,
     /*  319178 */     // GIR_Coverage, 19898,
     /*  319178 */     GIR_EraseRootFromParent_Done,
     /*  319179 */   // Label 5918: @319179
     /*  319179 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(319242), // Rule ID 19899 //
     /*  319184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  319198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  319201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319223 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  319226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319240 */     GIR_RootConstrainSelectedInstOperands,
     /*  319241 */     // GIR_Coverage, 19899,
     /*  319241 */     GIR_EraseRootFromParent_Done,
     /*  319242 */   // Label 5919: @319242
     /*  319242 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(319305), // Rule ID 19902 //
     /*  319247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319286 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319303 */     GIR_RootConstrainSelectedInstOperands,
     /*  319304 */     // GIR_Coverage, 19902,
     /*  319304 */     GIR_EraseRootFromParent_Done,
     /*  319305 */   // Label 5920: @319305
     /*  319305 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(319368), // Rule ID 19903 //
     /*  319310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  319324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  319327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319349 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319366 */     GIR_RootConstrainSelectedInstOperands,
     /*  319367 */     // GIR_Coverage, 19903,
     /*  319367 */     GIR_EraseRootFromParent_Done,
     /*  319368 */   // Label 5921: @319368
     /*  319368 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(319431), // Rule ID 19906 //
     /*  319373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319412 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319429 */     GIR_RootConstrainSelectedInstOperands,
     /*  319430 */     // GIR_Coverage, 19906,
     /*  319430 */     GIR_EraseRootFromParent_Done,
     /*  319431 */   // Label 5922: @319431
     /*  319431 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(319494), // Rule ID 19907 //
     /*  319436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  319450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  319453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319475 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319492 */     GIR_RootConstrainSelectedInstOperands,
     /*  319493 */     // GIR_Coverage, 19907,
     /*  319493 */     GIR_EraseRootFromParent_Done,
     /*  319494 */   // Label 5923: @319494
     /*  319494 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(319557), // Rule ID 19910 //
     /*  319499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319538 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319555 */     GIR_RootConstrainSelectedInstOperands,
     /*  319556 */     // GIR_Coverage, 19910,
     /*  319556 */     GIR_EraseRootFromParent_Done,
     /*  319557 */   // Label 5924: @319557
     /*  319557 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(319620), // Rule ID 19911 //
     /*  319562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319601 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319618 */     GIR_RootConstrainSelectedInstOperands,
     /*  319619 */     // GIR_Coverage, 19911,
     /*  319619 */     GIR_EraseRootFromParent_Done,
     /*  319620 */   // Label 5925: @319620
     /*  319620 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(319683), // Rule ID 19914 //
     /*  319625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319681 */     GIR_RootConstrainSelectedInstOperands,
     /*  319682 */     // GIR_Coverage, 19914,
     /*  319682 */     GIR_EraseRootFromParent_Done,
     /*  319683 */   // Label 5926: @319683
     /*  319683 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(319746), // Rule ID 19915 //
     /*  319688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319727 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319744 */     GIR_RootConstrainSelectedInstOperands,
     /*  319745 */     // GIR_Coverage, 19915,
     /*  319745 */     GIR_EraseRootFromParent_Done,
     /*  319746 */   // Label 5927: @319746
     /*  319746 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(319809), // Rule ID 19918 //
     /*  319751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319790 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  319793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319807 */     GIR_RootConstrainSelectedInstOperands,
     /*  319808 */     // GIR_Coverage, 19918,
     /*  319808 */     GIR_EraseRootFromParent_Done,
     /*  319809 */   // Label 5928: @319809
     /*  319809 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(319872), // Rule ID 19919 //
     /*  319814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319853 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  319856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319870 */     GIR_RootConstrainSelectedInstOperands,
     /*  319871 */     // GIR_Coverage, 19919,
     /*  319871 */     GIR_EraseRootFromParent_Done,
     /*  319872 */   // Label 5929: @319872
     /*  319872 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(319935), // Rule ID 19922 //
     /*  319877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  319888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  319891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  319894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319916 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  319919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319933 */     GIR_RootConstrainSelectedInstOperands,
     /*  319934 */     // GIR_Coverage, 19922,
     /*  319934 */     GIR_EraseRootFromParent_Done,
     /*  319935 */   // Label 5930: @319935
     /*  319935 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(319998), // Rule ID 19923 //
     /*  319940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  319951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  319954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  319957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319979 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  319982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319996 */     GIR_RootConstrainSelectedInstOperands,
     /*  319997 */     // GIR_Coverage, 19923,
     /*  319997 */     GIR_EraseRootFromParent_Done,
     /*  319998 */   // Label 5931: @319998
     /*  319998 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(320061), // Rule ID 19926 //
     /*  320003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320042 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320059 */     GIR_RootConstrainSelectedInstOperands,
     /*  320060 */     // GIR_Coverage, 19926,
     /*  320060 */     GIR_EraseRootFromParent_Done,
     /*  320061 */   // Label 5932: @320061
     /*  320061 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(320124), // Rule ID 19927 //
     /*  320066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  320080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  320083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320105 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320122 */     GIR_RootConstrainSelectedInstOperands,
     /*  320123 */     // GIR_Coverage, 19927,
     /*  320123 */     GIR_EraseRootFromParent_Done,
     /*  320124 */   // Label 5933: @320124
     /*  320124 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(320187), // Rule ID 19930 //
     /*  320129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320168 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320185 */     GIR_RootConstrainSelectedInstOperands,
     /*  320186 */     // GIR_Coverage, 19930,
     /*  320186 */     GIR_EraseRootFromParent_Done,
     /*  320187 */   // Label 5934: @320187
     /*  320187 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(320250), // Rule ID 19931 //
     /*  320192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  320206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  320209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320231 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320248 */     GIR_RootConstrainSelectedInstOperands,
     /*  320249 */     // GIR_Coverage, 19931,
     /*  320249 */     GIR_EraseRootFromParent_Done,
     /*  320250 */   // Label 5935: @320250
     /*  320250 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(320313), // Rule ID 19934 //
     /*  320255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320294 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320311 */     GIR_RootConstrainSelectedInstOperands,
     /*  320312 */     // GIR_Coverage, 19934,
     /*  320312 */     GIR_EraseRootFromParent_Done,
     /*  320313 */   // Label 5936: @320313
     /*  320313 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(320376), // Rule ID 19935 //
     /*  320318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  320329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  320332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  320335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320357 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320374 */     GIR_RootConstrainSelectedInstOperands,
     /*  320375 */     // GIR_Coverage, 19935,
     /*  320375 */     GIR_EraseRootFromParent_Done,
     /*  320376 */   // Label 5937: @320376
     /*  320376 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(320439), // Rule ID 19938 //
     /*  320381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320437 */     GIR_RootConstrainSelectedInstOperands,
     /*  320438 */     // GIR_Coverage, 19938,
     /*  320438 */     GIR_EraseRootFromParent_Done,
     /*  320439 */   // Label 5938: @320439
     /*  320439 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(320502), // Rule ID 19939 //
     /*  320444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  320458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  320461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  320476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320483 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  320486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320500 */     GIR_RootConstrainSelectedInstOperands,
     /*  320501 */     // GIR_Coverage, 19939,
     /*  320501 */     GIR_EraseRootFromParent_Done,
     /*  320502 */   // Label 5939: @320502
     /*  320502 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(320565), // Rule ID 19942 //
     /*  320507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320546 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320563 */     GIR_RootConstrainSelectedInstOperands,
     /*  320564 */     // GIR_Coverage, 19942,
     /*  320564 */     GIR_EraseRootFromParent_Done,
     /*  320565 */   // Label 5940: @320565
     /*  320565 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(320628), // Rule ID 19943 //
     /*  320570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320609 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320626 */     GIR_RootConstrainSelectedInstOperands,
     /*  320627 */     // GIR_Coverage, 19943,
     /*  320627 */     GIR_EraseRootFromParent_Done,
     /*  320628 */   // Label 5941: @320628
     /*  320628 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(320691), // Rule ID 19946 //
     /*  320633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320689 */     GIR_RootConstrainSelectedInstOperands,
     /*  320690 */     // GIR_Coverage, 19946,
     /*  320690 */     GIR_EraseRootFromParent_Done,
     /*  320691 */   // Label 5942: @320691
     /*  320691 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(320754), // Rule ID 19947 //
     /*  320696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320735 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320752 */     GIR_RootConstrainSelectedInstOperands,
     /*  320753 */     // GIR_Coverage, 19947,
     /*  320753 */     GIR_EraseRootFromParent_Done,
     /*  320754 */   // Label 5943: @320754
     /*  320754 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(320817), // Rule ID 19950 //
     /*  320759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320798 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  320801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320815 */     GIR_RootConstrainSelectedInstOperands,
     /*  320816 */     // GIR_Coverage, 19950,
     /*  320816 */     GIR_EraseRootFromParent_Done,
     /*  320817 */   // Label 5944: @320817
     /*  320817 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(320880), // Rule ID 19951 //
     /*  320822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320861 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  320864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320878 */     GIR_RootConstrainSelectedInstOperands,
     /*  320879 */     // GIR_Coverage, 19951,
     /*  320879 */     GIR_EraseRootFromParent_Done,
     /*  320880 */   // Label 5945: @320880
     /*  320880 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(320943), // Rule ID 19954 //
     /*  320885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  320899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320924 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  320927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320941 */     GIR_RootConstrainSelectedInstOperands,
     /*  320942 */     // GIR_Coverage, 19954,
     /*  320942 */     GIR_EraseRootFromParent_Done,
     /*  320943 */   // Label 5946: @320943
     /*  320943 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(321006), // Rule ID 19955 //
     /*  320948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  320962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320987 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  320990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321004 */     GIR_RootConstrainSelectedInstOperands,
     /*  321005 */     // GIR_Coverage, 19955,
     /*  321005 */     GIR_EraseRootFromParent_Done,
     /*  321006 */   // Label 5947: @321006
     /*  321006 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(321069), // Rule ID 19958 //
     /*  321011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321050 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  321053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321067 */     GIR_RootConstrainSelectedInstOperands,
     /*  321068 */     // GIR_Coverage, 19958,
     /*  321068 */     GIR_EraseRootFromParent_Done,
     /*  321069 */   // Label 5948: @321069
     /*  321069 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(321132), // Rule ID 19959 //
     /*  321074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  321088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321113 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  321116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321130 */     GIR_RootConstrainSelectedInstOperands,
     /*  321131 */     // GIR_Coverage, 19959,
     /*  321131 */     GIR_EraseRootFromParent_Done,
     /*  321132 */   // Label 5949: @321132
     /*  321132 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(321195), // Rule ID 19962 //
     /*  321137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  321179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321193 */     GIR_RootConstrainSelectedInstOperands,
     /*  321194 */     // GIR_Coverage, 19962,
     /*  321194 */     GIR_EraseRootFromParent_Done,
     /*  321195 */   // Label 5950: @321195
     /*  321195 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(321258), // Rule ID 19963 //
     /*  321200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  321214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321239 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  321242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321256 */     GIR_RootConstrainSelectedInstOperands,
     /*  321257 */     // GIR_Coverage, 19963,
     /*  321257 */     GIR_EraseRootFromParent_Done,
     /*  321258 */   // Label 5951: @321258
     /*  321258 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(321321), // Rule ID 19966 //
     /*  321263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  321305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321319 */     GIR_RootConstrainSelectedInstOperands,
     /*  321320 */     // GIR_Coverage, 19966,
     /*  321320 */     GIR_EraseRootFromParent_Done,
     /*  321321 */   // Label 5952: @321321
     /*  321321 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(321384), // Rule ID 19967 //
     /*  321326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  321340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321365 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  321368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321382 */     GIR_RootConstrainSelectedInstOperands,
     /*  321383 */     // GIR_Coverage, 19967,
     /*  321383 */     GIR_EraseRootFromParent_Done,
     /*  321384 */   // Label 5953: @321384
     /*  321384 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(321447), // Rule ID 19970 //
     /*  321389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321428 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  321431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321445 */     GIR_RootConstrainSelectedInstOperands,
     /*  321446 */     // GIR_Coverage, 19970,
     /*  321446 */     GIR_EraseRootFromParent_Done,
     /*  321447 */   // Label 5954: @321447
     /*  321447 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(321510), // Rule ID 19971 //
     /*  321452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  321463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  321466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321491 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  321494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321508 */     GIR_RootConstrainSelectedInstOperands,
     /*  321509 */     // GIR_Coverage, 19971,
     /*  321509 */     GIR_EraseRootFromParent_Done,
     /*  321510 */   // Label 5955: @321510
     /*  321510 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(321573), // Rule ID 19974 //
     /*  321515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321554 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  321557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321571 */     GIR_RootConstrainSelectedInstOperands,
     /*  321572 */     // GIR_Coverage, 19974,
     /*  321572 */     GIR_EraseRootFromParent_Done,
     /*  321573 */   // Label 5956: @321573
     /*  321573 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(321636), // Rule ID 19975 //
     /*  321578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321617 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  321620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321634 */     GIR_RootConstrainSelectedInstOperands,
     /*  321635 */     // GIR_Coverage, 19975,
     /*  321635 */     GIR_EraseRootFromParent_Done,
     /*  321636 */   // Label 5957: @321636
     /*  321636 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(321699), // Rule ID 19978 //
     /*  321641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  321683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321697 */     GIR_RootConstrainSelectedInstOperands,
     /*  321698 */     // GIR_Coverage, 19978,
     /*  321698 */     GIR_EraseRootFromParent_Done,
     /*  321699 */   // Label 5958: @321699
     /*  321699 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(321762), // Rule ID 19979 //
     /*  321704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321743 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  321746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321760 */     GIR_RootConstrainSelectedInstOperands,
     /*  321761 */     // GIR_Coverage, 19979,
     /*  321761 */     GIR_EraseRootFromParent_Done,
     /*  321762 */   // Label 5959: @321762
     /*  321762 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(321825), // Rule ID 19982 //
     /*  321767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321806 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  321809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321823 */     GIR_RootConstrainSelectedInstOperands,
     /*  321824 */     // GIR_Coverage, 19982,
     /*  321824 */     GIR_EraseRootFromParent_Done,
     /*  321825 */   // Label 5960: @321825
     /*  321825 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(321888), // Rule ID 19983 //
     /*  321830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321869 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  321872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321886 */     GIR_RootConstrainSelectedInstOperands,
     /*  321887 */     // GIR_Coverage, 19983,
     /*  321887 */     GIR_EraseRootFromParent_Done,
     /*  321888 */   // Label 5961: @321888
     /*  321888 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(321951), // Rule ID 19986 //
     /*  321893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  321907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  321935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321949 */     GIR_RootConstrainSelectedInstOperands,
     /*  321950 */     // GIR_Coverage, 19986,
     /*  321950 */     GIR_EraseRootFromParent_Done,
     /*  321951 */   // Label 5962: @321951
     /*  321951 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(322014), // Rule ID 19987 //
     /*  321956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  321970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321995 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  321998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322012 */     GIR_RootConstrainSelectedInstOperands,
     /*  322013 */     // GIR_Coverage, 19987,
     /*  322013 */     GIR_EraseRootFromParent_Done,
     /*  322014 */   // Label 5963: @322014
     /*  322014 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(322077), // Rule ID 19990 //
     /*  322019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322058 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  322061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322075 */     GIR_RootConstrainSelectedInstOperands,
     /*  322076 */     // GIR_Coverage, 19990,
     /*  322076 */     GIR_EraseRootFromParent_Done,
     /*  322077 */   // Label 5964: @322077
     /*  322077 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(322140), // Rule ID 19991 //
     /*  322082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  322096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322121 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  322124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322138 */     GIR_RootConstrainSelectedInstOperands,
     /*  322139 */     // GIR_Coverage, 19991,
     /*  322139 */     GIR_EraseRootFromParent_Done,
     /*  322140 */   // Label 5965: @322140
     /*  322140 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(322203), // Rule ID 19994 //
     /*  322145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322184 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  322187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322201 */     GIR_RootConstrainSelectedInstOperands,
     /*  322202 */     // GIR_Coverage, 19994,
     /*  322202 */     GIR_EraseRootFromParent_Done,
     /*  322203 */   // Label 5966: @322203
     /*  322203 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(322266), // Rule ID 19995 //
     /*  322208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  322219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  322222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  322225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  322240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322247 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  322250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322264 */     GIR_RootConstrainSelectedInstOperands,
     /*  322265 */     // GIR_Coverage, 19995,
     /*  322265 */     GIR_EraseRootFromParent_Done,
     /*  322266 */   // Label 5967: @322266
     /*  322266 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(322329), // Rule ID 19998 //
     /*  322271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322310 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  322313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322327 */     GIR_RootConstrainSelectedInstOperands,
     /*  322328 */     // GIR_Coverage, 19998,
     /*  322328 */     GIR_EraseRootFromParent_Done,
     /*  322329 */   // Label 5968: @322329
     /*  322329 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(322392), // Rule ID 19999 //
     /*  322334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  322348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322373 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  322376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322390 */     GIR_RootConstrainSelectedInstOperands,
     /*  322391 */     // GIR_Coverage, 19999,
     /*  322391 */     GIR_EraseRootFromParent_Done,
     /*  322392 */   // Label 5969: @322392
     /*  322392 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(322455), // Rule ID 20002 //
     /*  322397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  322439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322453 */     GIR_RootConstrainSelectedInstOperands,
     /*  322454 */     // GIR_Coverage, 20002,
     /*  322454 */     GIR_EraseRootFromParent_Done,
     /*  322455 */   // Label 5970: @322455
     /*  322455 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(322518), // Rule ID 20003 //
     /*  322460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  322474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  322488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322499 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  322502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322516 */     GIR_RootConstrainSelectedInstOperands,
     /*  322517 */     // GIR_Coverage, 20003,
     /*  322517 */     GIR_EraseRootFromParent_Done,
     /*  322518 */   // Label 5971: @322518
     /*  322518 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(322581), // Rule ID 20006 //
     /*  322523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322562 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  322565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322579 */     GIR_RootConstrainSelectedInstOperands,
     /*  322580 */     // GIR_Coverage, 20006,
     /*  322580 */     GIR_EraseRootFromParent_Done,
     /*  322581 */   // Label 5972: @322581
     /*  322581 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(322644), // Rule ID 20007 //
     /*  322586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322625 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  322628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322642 */     GIR_RootConstrainSelectedInstOperands,
     /*  322643 */     // GIR_Coverage, 20007,
     /*  322643 */     GIR_EraseRootFromParent_Done,
     /*  322644 */   // Label 5973: @322644
     /*  322644 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(322707), // Rule ID 20010 //
     /*  322649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  322691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322705 */     GIR_RootConstrainSelectedInstOperands,
     /*  322706 */     // GIR_Coverage, 20010,
     /*  322706 */     GIR_EraseRootFromParent_Done,
     /*  322707 */   // Label 5974: @322707
     /*  322707 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(322770), // Rule ID 20011 //
     /*  322712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322751 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  322754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322768 */     GIR_RootConstrainSelectedInstOperands,
     /*  322769 */     // GIR_Coverage, 20011,
     /*  322769 */     GIR_EraseRootFromParent_Done,
     /*  322770 */   // Label 5975: @322770
     /*  322770 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(322833), // Rule ID 20014 //
     /*  322775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322814 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322831 */     GIR_RootConstrainSelectedInstOperands,
     /*  322832 */     // GIR_Coverage, 20014,
     /*  322832 */     GIR_EraseRootFromParent_Done,
     /*  322833 */   // Label 5976: @322833
     /*  322833 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(322896), // Rule ID 20015 //
     /*  322838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322877 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322894 */     GIR_RootConstrainSelectedInstOperands,
     /*  322895 */     // GIR_Coverage, 20015,
     /*  322895 */     GIR_EraseRootFromParent_Done,
     /*  322896 */   // Label 5977: @322896
     /*  322896 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(322959), // Rule ID 20018 //
     /*  322901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  322915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  322918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322940 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322957 */     GIR_RootConstrainSelectedInstOperands,
     /*  322958 */     // GIR_Coverage, 20018,
     /*  322958 */     GIR_EraseRootFromParent_Done,
     /*  322959 */   // Label 5978: @322959
     /*  322959 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(323022), // Rule ID 20019 //
     /*  322964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  322978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  322981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323003 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  323006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323020 */     GIR_RootConstrainSelectedInstOperands,
     /*  323021 */     // GIR_Coverage, 20019,
     /*  323021 */     GIR_EraseRootFromParent_Done,
     /*  323022 */   // Label 5979: @323022
     /*  323022 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(323085), // Rule ID 20022 //
     /*  323027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323066 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323083 */     GIR_RootConstrainSelectedInstOperands,
     /*  323084 */     // GIR_Coverage, 20022,
     /*  323084 */     GIR_EraseRootFromParent_Done,
     /*  323085 */   // Label 5980: @323085
     /*  323085 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(323148), // Rule ID 20023 //
     /*  323090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  323104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  323107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323129 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323146 */     GIR_RootConstrainSelectedInstOperands,
     /*  323147 */     // GIR_Coverage, 20023,
     /*  323147 */     GIR_EraseRootFromParent_Done,
     /*  323148 */   // Label 5981: @323148
     /*  323148 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(323211), // Rule ID 20026 //
     /*  323153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323209 */     GIR_RootConstrainSelectedInstOperands,
     /*  323210 */     // GIR_Coverage, 20026,
     /*  323210 */     GIR_EraseRootFromParent_Done,
     /*  323211 */   // Label 5982: @323211
     /*  323211 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(323274), // Rule ID 20027 //
     /*  323216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  323230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  323233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323255 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323272 */     GIR_RootConstrainSelectedInstOperands,
     /*  323273 */     // GIR_Coverage, 20027,
     /*  323273 */     GIR_EraseRootFromParent_Done,
     /*  323274 */   // Label 5983: @323274
     /*  323274 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(323337), // Rule ID 20030 //
     /*  323279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323318 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323335 */     GIR_RootConstrainSelectedInstOperands,
     /*  323336 */     // GIR_Coverage, 20030,
     /*  323336 */     GIR_EraseRootFromParent_Done,
     /*  323337 */   // Label 5984: @323337
     /*  323337 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(323400), // Rule ID 20031 //
     /*  323342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  323353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  323356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  323359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323381 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  323384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323398 */     GIR_RootConstrainSelectedInstOperands,
     /*  323399 */     // GIR_Coverage, 20031,
     /*  323399 */     GIR_EraseRootFromParent_Done,
     /*  323400 */   // Label 5985: @323400
     /*  323400 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(323463), // Rule ID 20034 //
     /*  323405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323444 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323461 */     GIR_RootConstrainSelectedInstOperands,
     /*  323462 */     // GIR_Coverage, 20034,
     /*  323462 */     GIR_EraseRootFromParent_Done,
     /*  323463 */   // Label 5986: @323463
     /*  323463 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(323526), // Rule ID 20035 //
     /*  323468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  323482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  323485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323507 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323524 */     GIR_RootConstrainSelectedInstOperands,
     /*  323525 */     // GIR_Coverage, 20035,
     /*  323525 */     GIR_EraseRootFromParent_Done,
     /*  323526 */   // Label 5987: @323526
     /*  323526 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(323589), // Rule ID 20038 //
     /*  323531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323570 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323587 */     GIR_RootConstrainSelectedInstOperands,
     /*  323588 */     // GIR_Coverage, 20038,
     /*  323588 */     GIR_EraseRootFromParent_Done,
     /*  323589 */   // Label 5988: @323589
     /*  323589 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(323652), // Rule ID 20039 //
     /*  323594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323633 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323650 */     GIR_RootConstrainSelectedInstOperands,
     /*  323651 */     // GIR_Coverage, 20039,
     /*  323651 */     GIR_EraseRootFromParent_Done,
     /*  323652 */   // Label 5989: @323652
     /*  323652 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(323715), // Rule ID 20042 //
     /*  323657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323696 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  323699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323713 */     GIR_RootConstrainSelectedInstOperands,
     /*  323714 */     // GIR_Coverage, 20042,
     /*  323714 */     GIR_EraseRootFromParent_Done,
     /*  323715 */   // Label 5990: @323715
     /*  323715 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(323778), // Rule ID 20043 //
     /*  323720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323759 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  323762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323776 */     GIR_RootConstrainSelectedInstOperands,
     /*  323777 */     // GIR_Coverage, 20043,
     /*  323777 */     GIR_EraseRootFromParent_Done,
     /*  323778 */   // Label 5991: @323778
     /*  323778 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(323841), // Rule ID 20046 //
     /*  323783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323839 */     GIR_RootConstrainSelectedInstOperands,
     /*  323840 */     // GIR_Coverage, 20046,
     /*  323840 */     GIR_EraseRootFromParent_Done,
     /*  323841 */   // Label 5992: @323841
     /*  323841 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(323904), // Rule ID 20047 //
     /*  323846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323885 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323902 */     GIR_RootConstrainSelectedInstOperands,
     /*  323903 */     // GIR_Coverage, 20047,
     /*  323903 */     GIR_EraseRootFromParent_Done,
     /*  323904 */   // Label 5993: @323904
     /*  323904 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(323967), // Rule ID 20050 //
     /*  323909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  323923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  323926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323948 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323965 */     GIR_RootConstrainSelectedInstOperands,
     /*  323966 */     // GIR_Coverage, 20050,
     /*  323966 */     GIR_EraseRootFromParent_Done,
     /*  323967 */   // Label 5994: @323967
     /*  323967 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(324030), // Rule ID 20051 //
     /*  323972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  323986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  323989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324011 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324028 */     GIR_RootConstrainSelectedInstOperands,
     /*  324029 */     // GIR_Coverage, 20051,
     /*  324029 */     GIR_EraseRootFromParent_Done,
     /*  324030 */   // Label 5995: @324030
     /*  324030 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(324093), // Rule ID 20054 //
     /*  324035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324091 */     GIR_RootConstrainSelectedInstOperands,
     /*  324092 */     // GIR_Coverage, 20054,
     /*  324092 */     GIR_EraseRootFromParent_Done,
     /*  324093 */   // Label 5996: @324093
     /*  324093 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(324156), // Rule ID 20055 //
     /*  324098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  324112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  324115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324137 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324154 */     GIR_RootConstrainSelectedInstOperands,
     /*  324155 */     // GIR_Coverage, 20055,
     /*  324155 */     GIR_EraseRootFromParent_Done,
     /*  324156 */   // Label 5997: @324156
     /*  324156 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(324219), // Rule ID 20058 //
     /*  324161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324200 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324217 */     GIR_RootConstrainSelectedInstOperands,
     /*  324218 */     // GIR_Coverage, 20058,
     /*  324218 */     GIR_EraseRootFromParent_Done,
     /*  324219 */   // Label 5998: @324219
     /*  324219 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(324282), // Rule ID 20059 //
     /*  324224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  324238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  324241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324263 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  324266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324280 */     GIR_RootConstrainSelectedInstOperands,
     /*  324281 */     // GIR_Coverage, 20059,
     /*  324281 */     GIR_EraseRootFromParent_Done,
     /*  324282 */   // Label 5999: @324282
     /*  324282 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(324345), // Rule ID 20062 //
     /*  324287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324326 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324343 */     GIR_RootConstrainSelectedInstOperands,
     /*  324344 */     // GIR_Coverage, 20062,
     /*  324344 */     GIR_EraseRootFromParent_Done,
     /*  324345 */   // Label 6000: @324345
     /*  324345 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(324408), // Rule ID 20063 //
     /*  324350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  324364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  324367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324389 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  324392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324406 */     GIR_RootConstrainSelectedInstOperands,
     /*  324407 */     // GIR_Coverage, 20063,
     /*  324407 */     GIR_EraseRootFromParent_Done,
     /*  324408 */   // Label 6001: @324408
     /*  324408 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(324471), // Rule ID 20066 //
     /*  324413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324452 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324469 */     GIR_RootConstrainSelectedInstOperands,
     /*  324470 */     // GIR_Coverage, 20066,
     /*  324470 */     GIR_EraseRootFromParent_Done,
     /*  324471 */   // Label 6002: @324471
     /*  324471 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(324534), // Rule ID 20067 //
     /*  324476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  324490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  324493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324515 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324532 */     GIR_RootConstrainSelectedInstOperands,
     /*  324533 */     // GIR_Coverage, 20067,
     /*  324533 */     GIR_EraseRootFromParent_Done,
     /*  324534 */   // Label 6003: @324534
     /*  324534 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(324597), // Rule ID 20070 //
     /*  324539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324578 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  324581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324595 */     GIR_RootConstrainSelectedInstOperands,
     /*  324596 */     // GIR_Coverage, 20070,
     /*  324596 */     GIR_EraseRootFromParent_Done,
     /*  324597 */   // Label 6004: @324597
     /*  324597 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(324660), // Rule ID 20071 //
     /*  324602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324641 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  324644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324658 */     GIR_RootConstrainSelectedInstOperands,
     /*  324659 */     // GIR_Coverage, 20071,
     /*  324659 */     GIR_EraseRootFromParent_Done,
     /*  324660 */   // Label 6005: @324660
     /*  324660 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(324723), // Rule ID 20074 //
     /*  324665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  324707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324721 */     GIR_RootConstrainSelectedInstOperands,
     /*  324722 */     // GIR_Coverage, 20074,
     /*  324722 */     GIR_EraseRootFromParent_Done,
     /*  324723 */   // Label 6006: @324723
     /*  324723 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(324786), // Rule ID 20075 //
     /*  324728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324767 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  324770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324784 */     GIR_RootConstrainSelectedInstOperands,
     /*  324785 */     // GIR_Coverage, 20075,
     /*  324785 */     GIR_EraseRootFromParent_Done,
     /*  324786 */   // Label 6007: @324786
     /*  324786 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(324849), // Rule ID 20078 //
     /*  324791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324830 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  324833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324847 */     GIR_RootConstrainSelectedInstOperands,
     /*  324848 */     // GIR_Coverage, 20078,
     /*  324848 */     GIR_EraseRootFromParent_Done,
     /*  324849 */   // Label 6008: @324849
     /*  324849 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(324912), // Rule ID 20079 //
     /*  324854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324893 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  324896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324910 */     GIR_RootConstrainSelectedInstOperands,
     /*  324911 */     // GIR_Coverage, 20079,
     /*  324911 */     GIR_EraseRootFromParent_Done,
     /*  324912 */   // Label 6009: @324912
     /*  324912 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(324975), // Rule ID 20082 //
     /*  324917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  324931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324956 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  324959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324973 */     GIR_RootConstrainSelectedInstOperands,
     /*  324974 */     // GIR_Coverage, 20082,
     /*  324974 */     GIR_EraseRootFromParent_Done,
     /*  324975 */   // Label 6010: @324975
     /*  324975 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(325038), // Rule ID 20083 //
     /*  324980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  324994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325019 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  325022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325036 */     GIR_RootConstrainSelectedInstOperands,
     /*  325037 */     // GIR_Coverage, 20083,
     /*  325037 */     GIR_EraseRootFromParent_Done,
     /*  325038 */   // Label 6011: @325038
     /*  325038 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(325101), // Rule ID 20086 //
     /*  325043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325082 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  325085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325099 */     GIR_RootConstrainSelectedInstOperands,
     /*  325100 */     // GIR_Coverage, 20086,
     /*  325100 */     GIR_EraseRootFromParent_Done,
     /*  325101 */   // Label 6012: @325101
     /*  325101 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(325164), // Rule ID 20087 //
     /*  325106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  325120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325145 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  325148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325162 */     GIR_RootConstrainSelectedInstOperands,
     /*  325163 */     // GIR_Coverage, 20087,
     /*  325163 */     GIR_EraseRootFromParent_Done,
     /*  325164 */   // Label 6013: @325164
     /*  325164 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(325227), // Rule ID 20090 //
     /*  325169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  325172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325208 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  325211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325225 */     GIR_RootConstrainSelectedInstOperands,
     /*  325226 */     // GIR_Coverage, 20090,
     /*  325226 */     GIR_EraseRootFromParent_Done,
     /*  325227 */   // Label 6014: @325227
     /*  325227 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(325290), // Rule ID 20091 //
     /*  325232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  325235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  325246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325271 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  325274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325288 */     GIR_RootConstrainSelectedInstOperands,
     /*  325289 */     // GIR_Coverage, 20091,
     /*  325289 */     GIR_EraseRootFromParent_Done,
     /*  325290 */   // Label 6015: @325290
     /*  325290 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(325353), // Rule ID 20094 //
     /*  325295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325334 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  325337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325351 */     GIR_RootConstrainSelectedInstOperands,
     /*  325352 */     // GIR_Coverage, 20094,
     /*  325352 */     GIR_EraseRootFromParent_Done,
     /*  325353 */   // Label 6016: @325353
     /*  325353 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(325416), // Rule ID 20095 //
     /*  325358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  325372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325397 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  325400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325414 */     GIR_RootConstrainSelectedInstOperands,
     /*  325415 */     // GIR_Coverage, 20095,
     /*  325415 */     GIR_EraseRootFromParent_Done,
     /*  325416 */   // Label 6017: @325416
     /*  325416 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(325479), // Rule ID 20098 //
     /*  325421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325460 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  325463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325477 */     GIR_RootConstrainSelectedInstOperands,
     /*  325478 */     // GIR_Coverage, 20098,
     /*  325478 */     GIR_EraseRootFromParent_Done,
     /*  325479 */   // Label 6018: @325479
     /*  325479 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(325542), // Rule ID 20099 //
     /*  325484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  325498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325523 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  325526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325540 */     GIR_RootConstrainSelectedInstOperands,
     /*  325541 */     // GIR_Coverage, 20099,
     /*  325541 */     GIR_EraseRootFromParent_Done,
     /*  325542 */   // Label 6019: @325542
     /*  325542 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(325605), // Rule ID 20102 //
     /*  325547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325586 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  325589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325603 */     GIR_RootConstrainSelectedInstOperands,
     /*  325604 */     // GIR_Coverage, 20102,
     /*  325604 */     GIR_EraseRootFromParent_Done,
     /*  325605 */   // Label 6020: @325605
     /*  325605 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(325668), // Rule ID 20103 //
     /*  325610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325649 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  325652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325666 */     GIR_RootConstrainSelectedInstOperands,
     /*  325667 */     // GIR_Coverage, 20103,
     /*  325667 */     GIR_EraseRootFromParent_Done,
     /*  325668 */   // Label 6021: @325668
     /*  325668 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(325731), // Rule ID 20106 //
     /*  325673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  325715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325729 */     GIR_RootConstrainSelectedInstOperands,
     /*  325730 */     // GIR_Coverage, 20106,
     /*  325730 */     GIR_EraseRootFromParent_Done,
     /*  325731 */   // Label 6022: @325731
     /*  325731 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(325794), // Rule ID 20107 //
     /*  325736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325775 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  325778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325792 */     GIR_RootConstrainSelectedInstOperands,
     /*  325793 */     // GIR_Coverage, 20107,
     /*  325793 */     GIR_EraseRootFromParent_Done,
     /*  325794 */   // Label 6023: @325794
     /*  325794 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(325857), // Rule ID 20110 //
     /*  325799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  325841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325855 */     GIR_RootConstrainSelectedInstOperands,
     /*  325856 */     // GIR_Coverage, 20110,
     /*  325856 */     GIR_EraseRootFromParent_Done,
     /*  325857 */   // Label 6024: @325857
     /*  325857 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(325920), // Rule ID 20111 //
     /*  325862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325901 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  325904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325918 */     GIR_RootConstrainSelectedInstOperands,
     /*  325919 */     // GIR_Coverage, 20111,
     /*  325919 */     GIR_EraseRootFromParent_Done,
     /*  325920 */   // Label 6025: @325920
     /*  325920 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(325983), // Rule ID 20114 //
     /*  325925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  325939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  325967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325981 */     GIR_RootConstrainSelectedInstOperands,
     /*  325982 */     // GIR_Coverage, 20114,
     /*  325982 */     GIR_EraseRootFromParent_Done,
     /*  325983 */   // Label 6026: @325983
     /*  325983 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(326046), // Rule ID 20115 //
     /*  325988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  326002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  326005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  326020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326027 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  326030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326044 */     GIR_RootConstrainSelectedInstOperands,
     /*  326045 */     // GIR_Coverage, 20115,
     /*  326045 */     GIR_EraseRootFromParent_Done,
     /*  326046 */   // Label 6027: @326046
     /*  326046 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(326109), // Rule ID 20118 //
     /*  326051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326090 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  326093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326107 */     GIR_RootConstrainSelectedInstOperands,
     /*  326108 */     // GIR_Coverage, 20118,
     /*  326108 */     GIR_EraseRootFromParent_Done,
     /*  326109 */   // Label 6028: @326109
     /*  326109 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(326172), // Rule ID 20119 //
     /*  326114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  326128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326153 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11428:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  326156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326170 */     GIR_RootConstrainSelectedInstOperands,
     /*  326171 */     // GIR_Coverage, 20119,
     /*  326171 */     GIR_EraseRootFromParent_Done,
     /*  326172 */   // Label 6029: @326172
     /*  326172 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(326235), // Rule ID 20122 //
     /*  326177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  326219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326233 */     GIR_RootConstrainSelectedInstOperands,
     /*  326234 */     // GIR_Coverage, 20122,
     /*  326234 */     GIR_EraseRootFromParent_Done,
     /*  326235 */   // Label 6030: @326235
     /*  326235 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(326298), // Rule ID 20123 //
     /*  326240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  326254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326279 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11428:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  326282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326296 */     GIR_RootConstrainSelectedInstOperands,
     /*  326297 */     // GIR_Coverage, 20123,
     /*  326297 */     GIR_EraseRootFromParent_Done,
     /*  326298 */   // Label 6031: @326298
     /*  326298 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(326361), // Rule ID 20126 //
     /*  326303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  326345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326359 */     GIR_RootConstrainSelectedInstOperands,
     /*  326360 */     // GIR_Coverage, 20126,
     /*  326360 */     GIR_EraseRootFromParent_Done,
     /*  326361 */   // Label 6032: @326361
     /*  326361 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(326424), // Rule ID 20127 //
     /*  326366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  326374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  326380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  326383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  326398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326405 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11428:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  326408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326422 */     GIR_RootConstrainSelectedInstOperands,
     /*  326423 */     // GIR_Coverage, 20127,
     /*  326423 */     GIR_EraseRootFromParent_Done,
     /*  326424 */   // Label 6033: @326424
     /*  326424 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(326487), // Rule ID 20130 //
     /*  326429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  326471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326485 */     GIR_RootConstrainSelectedInstOperands,
     /*  326486 */     // GIR_Coverage, 20130,
     /*  326486 */     GIR_EraseRootFromParent_Done,
     /*  326487 */   // Label 6034: @326487
     /*  326487 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(326550), // Rule ID 20131 //
     /*  326492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  326506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326531 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  326534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326548 */     GIR_RootConstrainSelectedInstOperands,
     /*  326549 */     // GIR_Coverage, 20131,
     /*  326549 */     GIR_EraseRootFromParent_Done,
     /*  326550 */   // Label 6035: @326550
     /*  326550 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(326613), // Rule ID 20134 //
     /*  326555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326611 */     GIR_RootConstrainSelectedInstOperands,
     /*  326612 */     // GIR_Coverage, 20134,
     /*  326612 */     GIR_EraseRootFromParent_Done,
     /*  326613 */   // Label 6036: @326613
     /*  326613 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(326676), // Rule ID 20135 //
     /*  326618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326657 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326674 */     GIR_RootConstrainSelectedInstOperands,
     /*  326675 */     // GIR_Coverage, 20135,
     /*  326675 */     GIR_EraseRootFromParent_Done,
     /*  326676 */   // Label 6037: @326676
     /*  326676 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(326739), // Rule ID 20138 //
     /*  326681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326720 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326737 */     GIR_RootConstrainSelectedInstOperands,
     /*  326738 */     // GIR_Coverage, 20138,
     /*  326738 */     GIR_EraseRootFromParent_Done,
     /*  326739 */   // Label 6038: @326739
     /*  326739 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(326802), // Rule ID 20139 //
     /*  326744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326783 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326800 */     GIR_RootConstrainSelectedInstOperands,
     /*  326801 */     // GIR_Coverage, 20139,
     /*  326801 */     GIR_EraseRootFromParent_Done,
     /*  326802 */   // Label 6039: @326802
     /*  326802 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(326865), // Rule ID 20142 //
     /*  326807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326846 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326863 */     GIR_RootConstrainSelectedInstOperands,
     /*  326864 */     // GIR_Coverage, 20142,
     /*  326864 */     GIR_EraseRootFromParent_Done,
     /*  326865 */   // Label 6040: @326865
     /*  326865 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(326928), // Rule ID 20143 //
     /*  326870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326909 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326926 */     GIR_RootConstrainSelectedInstOperands,
     /*  326927 */     // GIR_Coverage, 20143,
     /*  326927 */     GIR_EraseRootFromParent_Done,
     /*  326928 */   // Label 6041: @326928
     /*  326928 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(326991), // Rule ID 20146 //
     /*  326933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  326947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  326950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326989 */     GIR_RootConstrainSelectedInstOperands,
     /*  326990 */     // GIR_Coverage, 20146,
     /*  326990 */     GIR_EraseRootFromParent_Done,
     /*  326991 */   // Label 6042: @326991
     /*  326991 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(327054), // Rule ID 20147 //
     /*  326996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  327010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  327013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327035 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327052 */     GIR_RootConstrainSelectedInstOperands,
     /*  327053 */     // GIR_Coverage, 20147,
     /*  327053 */     GIR_EraseRootFromParent_Done,
     /*  327054 */   // Label 6043: @327054
     /*  327054 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(327117), // Rule ID 20150 //
     /*  327059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327098 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327115 */     GIR_RootConstrainSelectedInstOperands,
     /*  327116 */     // GIR_Coverage, 20150,
     /*  327116 */     GIR_EraseRootFromParent_Done,
     /*  327117 */   // Label 6044: @327117
     /*  327117 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(327180), // Rule ID 20151 //
     /*  327122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  327125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  327136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  327139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327161 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  327161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  327164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327178 */     GIR_RootConstrainSelectedInstOperands,
     /*  327179 */     // GIR_Coverage, 20151,
     /*  327179 */     GIR_EraseRootFromParent_Done,
     /*  327180 */   // Label 6045: @327180
     /*  327180 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(327243), // Rule ID 20154 //
     /*  327185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327241 */     GIR_RootConstrainSelectedInstOperands,
     /*  327242 */     // GIR_Coverage, 20154,
     /*  327242 */     GIR_EraseRootFromParent_Done,
     /*  327243 */   // Label 6046: @327243
     /*  327243 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(327306), // Rule ID 20155 //
     /*  327248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  327262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  327265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327287 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327304 */     GIR_RootConstrainSelectedInstOperands,
     /*  327305 */     // GIR_Coverage, 20155,
     /*  327305 */     GIR_EraseRootFromParent_Done,
     /*  327306 */   // Label 6047: @327306
     /*  327306 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(327369), // Rule ID 20158 //
     /*  327311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327350 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327367 */     GIR_RootConstrainSelectedInstOperands,
     /*  327368 */     // GIR_Coverage, 20158,
     /*  327368 */     GIR_EraseRootFromParent_Done,
     /*  327369 */   // Label 6048: @327369
     /*  327369 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(327432), // Rule ID 20159 //
     /*  327374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  327388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  327391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327413 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327430 */     GIR_RootConstrainSelectedInstOperands,
     /*  327431 */     // GIR_Coverage, 20159,
     /*  327431 */     GIR_EraseRootFromParent_Done,
     /*  327432 */   // Label 6049: @327432
     /*  327432 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(327495), // Rule ID 20162 //
     /*  327437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327476 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327493 */     GIR_RootConstrainSelectedInstOperands,
     /*  327494 */     // GIR_Coverage, 20162,
     /*  327494 */     GIR_EraseRootFromParent_Done,
     /*  327495 */   // Label 6050: @327495
     /*  327495 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(327558), // Rule ID 20163 //
     /*  327500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327539 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327556 */     GIR_RootConstrainSelectedInstOperands,
     /*  327557 */     // GIR_Coverage, 20163,
     /*  327557 */     GIR_EraseRootFromParent_Done,
     /*  327558 */   // Label 6051: @327558
     /*  327558 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(327621), // Rule ID 20166 //
     /*  327563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327619 */     GIR_RootConstrainSelectedInstOperands,
     /*  327620 */     // GIR_Coverage, 20166,
     /*  327620 */     GIR_EraseRootFromParent_Done,
     /*  327621 */   // Label 6052: @327621
     /*  327621 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(327684), // Rule ID 20167 //
     /*  327626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327665 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327682 */     GIR_RootConstrainSelectedInstOperands,
     /*  327683 */     // GIR_Coverage, 20167,
     /*  327683 */     GIR_EraseRootFromParent_Done,
     /*  327684 */   // Label 6053: @327684
     /*  327684 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(327747), // Rule ID 20170 //
     /*  327689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327745 */     GIR_RootConstrainSelectedInstOperands,
     /*  327746 */     // GIR_Coverage, 20170,
     /*  327746 */     GIR_EraseRootFromParent_Done,
     /*  327747 */   // Label 6054: @327747
     /*  327747 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(327810), // Rule ID 20171 //
     /*  327752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327791 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327808 */     GIR_RootConstrainSelectedInstOperands,
     /*  327809 */     // GIR_Coverage, 20171,
     /*  327809 */     GIR_EraseRootFromParent_Done,
     /*  327810 */   // Label 6055: @327810
     /*  327810 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(327873), // Rule ID 20174 //
     /*  327815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327871 */     GIR_RootConstrainSelectedInstOperands,
     /*  327872 */     // GIR_Coverage, 20174,
     /*  327872 */     GIR_EraseRootFromParent_Done,
     /*  327873 */   // Label 6056: @327873
     /*  327873 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(327936), // Rule ID 20175 //
     /*  327878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327917 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327934 */     GIR_RootConstrainSelectedInstOperands,
     /*  327935 */     // GIR_Coverage, 20175,
     /*  327935 */     GIR_EraseRootFromParent_Done,
     /*  327936 */   // Label 6057: @327936
     /*  327936 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(327999), // Rule ID 20178 //
     /*  327941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  327955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  327958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327997 */     GIR_RootConstrainSelectedInstOperands,
     /*  327998 */     // GIR_Coverage, 20178,
     /*  327998 */     GIR_EraseRootFromParent_Done,
     /*  327999 */   // Label 6058: @327999
     /*  327999 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(328062), // Rule ID 20179 //
     /*  328004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  328018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  328021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328043 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  328046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328060 */     GIR_RootConstrainSelectedInstOperands,
     /*  328061 */     // GIR_Coverage, 20179,
     /*  328061 */     GIR_EraseRootFromParent_Done,
     /*  328062 */   // Label 6059: @328062
     /*  328062 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(328125), // Rule ID 20182 //
     /*  328067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328123 */     GIR_RootConstrainSelectedInstOperands,
     /*  328124 */     // GIR_Coverage, 20182,
     /*  328124 */     GIR_EraseRootFromParent_Done,
     /*  328125 */   // Label 6060: @328125
     /*  328125 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(328188), // Rule ID 20183 //
     /*  328130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  328144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  328147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328169 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  328172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328186 */     GIR_RootConstrainSelectedInstOperands,
     /*  328187 */     // GIR_Coverage, 20183,
     /*  328187 */     GIR_EraseRootFromParent_Done,
     /*  328188 */   // Label 6061: @328188
     /*  328188 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(328251), // Rule ID 20186 //
     /*  328193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328249 */     GIR_RootConstrainSelectedInstOperands,
     /*  328250 */     // GIR_Coverage, 20186,
     /*  328250 */     GIR_EraseRootFromParent_Done,
     /*  328251 */   // Label 6062: @328251
     /*  328251 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(328314), // Rule ID 20187 //
     /*  328256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  328270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  328273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328295 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  328298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328312 */     GIR_RootConstrainSelectedInstOperands,
     /*  328313 */     // GIR_Coverage, 20187,
     /*  328313 */     GIR_EraseRootFromParent_Done,
     /*  328314 */   // Label 6063: @328314
     /*  328314 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(328377), // Rule ID 20190 //
     /*  328319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  328361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328375 */     GIR_RootConstrainSelectedInstOperands,
     /*  328376 */     // GIR_Coverage, 20190,
     /*  328376 */     GIR_EraseRootFromParent_Done,
     /*  328377 */   // Label 6064: @328377
     /*  328377 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(328440), // Rule ID 20191 //
     /*  328382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  328396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328421 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  328424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328438 */     GIR_RootConstrainSelectedInstOperands,
     /*  328439 */     // GIR_Coverage, 20191,
     /*  328439 */     GIR_EraseRootFromParent_Done,
     /*  328440 */   // Label 6065: @328440
     /*  328440 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(328503), // Rule ID 20194 //
     /*  328445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328484 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  328487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328501 */     GIR_RootConstrainSelectedInstOperands,
     /*  328502 */     // GIR_Coverage, 20194,
     /*  328502 */     GIR_EraseRootFromParent_Done,
     /*  328503 */   // Label 6066: @328503
     /*  328503 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(328566), // Rule ID 20195 //
     /*  328508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328547 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  328550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328564 */     GIR_RootConstrainSelectedInstOperands,
     /*  328565 */     // GIR_Coverage, 20195,
     /*  328565 */     GIR_EraseRootFromParent_Done,
     /*  328566 */   // Label 6067: @328566
     /*  328566 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(328629), // Rule ID 20198 //
     /*  328571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328610 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  328613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328627 */     GIR_RootConstrainSelectedInstOperands,
     /*  328628 */     // GIR_Coverage, 20198,
     /*  328628 */     GIR_EraseRootFromParent_Done,
     /*  328629 */   // Label 6068: @328629
     /*  328629 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(328692), // Rule ID 20199 //
     /*  328634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328673 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  328676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328690 */     GIR_RootConstrainSelectedInstOperands,
     /*  328691 */     // GIR_Coverage, 20199,
     /*  328691 */     GIR_EraseRootFromParent_Done,
     /*  328692 */   // Label 6069: @328692
     /*  328692 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(328755), // Rule ID 20202 //
     /*  328697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  328739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328753 */     GIR_RootConstrainSelectedInstOperands,
     /*  328754 */     // GIR_Coverage, 20202,
     /*  328754 */     GIR_EraseRootFromParent_Done,
     /*  328755 */   // Label 6070: @328755
     /*  328755 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(328818), // Rule ID 20203 //
     /*  328760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328799 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  328802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328816 */     GIR_RootConstrainSelectedInstOperands,
     /*  328817 */     // GIR_Coverage, 20203,
     /*  328817 */     GIR_EraseRootFromParent_Done,
     /*  328818 */   // Label 6071: @328818
     /*  328818 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(328881), // Rule ID 20206 //
     /*  328823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  328865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328879 */     GIR_RootConstrainSelectedInstOperands,
     /*  328880 */     // GIR_Coverage, 20206,
     /*  328880 */     GIR_EraseRootFromParent_Done,
     /*  328881 */   // Label 6072: @328881
     /*  328881 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(328944), // Rule ID 20207 //
     /*  328886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328925 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  328928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328942 */     GIR_RootConstrainSelectedInstOperands,
     /*  328943 */     // GIR_Coverage, 20207,
     /*  328943 */     GIR_EraseRootFromParent_Done,
     /*  328944 */   // Label 6073: @328944
     /*  328944 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(329007), // Rule ID 20210 //
     /*  328949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  328963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  328981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  328991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329005 */     GIR_RootConstrainSelectedInstOperands,
     /*  329006 */     // GIR_Coverage, 20210,
     /*  329006 */     GIR_EraseRootFromParent_Done,
     /*  329007 */   // Label 6074: @329007
     /*  329007 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(329070), // Rule ID 20211 //
     /*  329012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  329026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329051 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  329054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329068 */     GIR_RootConstrainSelectedInstOperands,
     /*  329069 */     // GIR_Coverage, 20211,
     /*  329069 */     GIR_EraseRootFromParent_Done,
     /*  329070 */   // Label 6075: @329070
     /*  329070 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(329133), // Rule ID 20214 //
     /*  329075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329114 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  329117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329131 */     GIR_RootConstrainSelectedInstOperands,
     /*  329132 */     // GIR_Coverage, 20214,
     /*  329132 */     GIR_EraseRootFromParent_Done,
     /*  329133 */   // Label 6076: @329133
     /*  329133 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(329196), // Rule ID 20215 //
     /*  329138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  329152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329177 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  329180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329194 */     GIR_RootConstrainSelectedInstOperands,
     /*  329195 */     // GIR_Coverage, 20215,
     /*  329195 */     GIR_EraseRootFromParent_Done,
     /*  329196 */   // Label 6077: @329196
     /*  329196 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(329259), // Rule ID 20218 //
     /*  329201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  329243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329257 */     GIR_RootConstrainSelectedInstOperands,
     /*  329258 */     // GIR_Coverage, 20218,
     /*  329258 */     GIR_EraseRootFromParent_Done,
     /*  329259 */   // Label 6078: @329259
     /*  329259 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(329322), // Rule ID 20219 //
     /*  329264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  329278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329303 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  329306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329320 */     GIR_RootConstrainSelectedInstOperands,
     /*  329321 */     // GIR_Coverage, 20219,
     /*  329321 */     GIR_EraseRootFromParent_Done,
     /*  329322 */   // Label 6079: @329322
     /*  329322 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(329385), // Rule ID 20222 //
     /*  329327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329366 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  329369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329383 */     GIR_RootConstrainSelectedInstOperands,
     /*  329384 */     // GIR_Coverage, 20222,
     /*  329384 */     GIR_EraseRootFromParent_Done,
     /*  329385 */   // Label 6080: @329385
     /*  329385 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(329448), // Rule ID 20223 //
     /*  329390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  329401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  329404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329429 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  329432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329446 */     GIR_RootConstrainSelectedInstOperands,
     /*  329447 */     // GIR_Coverage, 20223,
     /*  329447 */     GIR_EraseRootFromParent_Done,
     /*  329448 */   // Label 6081: @329448
     /*  329448 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(329511), // Rule ID 20226 //
     /*  329453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329492 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  329495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329509 */     GIR_RootConstrainSelectedInstOperands,
     /*  329510 */     // GIR_Coverage, 20226,
     /*  329510 */     GIR_EraseRootFromParent_Done,
     /*  329511 */   // Label 6082: @329511
     /*  329511 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(329574), // Rule ID 20227 //
     /*  329516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329555 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  329558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329572 */     GIR_RootConstrainSelectedInstOperands,
     /*  329573 */     // GIR_Coverage, 20227,
     /*  329573 */     GIR_EraseRootFromParent_Done,
     /*  329574 */   // Label 6083: @329574
     /*  329574 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(329637), // Rule ID 20230 //
     /*  329579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  329621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329635 */     GIR_RootConstrainSelectedInstOperands,
     /*  329636 */     // GIR_Coverage, 20230,
     /*  329636 */     GIR_EraseRootFromParent_Done,
     /*  329637 */   // Label 6084: @329637
     /*  329637 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(329700), // Rule ID 20231 //
     /*  329642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329681 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  329684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329698 */     GIR_RootConstrainSelectedInstOperands,
     /*  329699 */     // GIR_Coverage, 20231,
     /*  329699 */     GIR_EraseRootFromParent_Done,
     /*  329700 */   // Label 6085: @329700
     /*  329700 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(329763), // Rule ID 20234 //
     /*  329705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  329747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329761 */     GIR_RootConstrainSelectedInstOperands,
     /*  329762 */     // GIR_Coverage, 20234,
     /*  329762 */     GIR_EraseRootFromParent_Done,
     /*  329763 */   // Label 6086: @329763
     /*  329763 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(329826), // Rule ID 20235 //
     /*  329768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329807 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  329810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329824 */     GIR_RootConstrainSelectedInstOperands,
     /*  329825 */     // GIR_Coverage, 20235,
     /*  329825 */     GIR_EraseRootFromParent_Done,
     /*  329826 */   // Label 6087: @329826
     /*  329826 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(329889), // Rule ID 20238 //
     /*  329831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329870 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  329873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329887 */     GIR_RootConstrainSelectedInstOperands,
     /*  329888 */     // GIR_Coverage, 20238,
     /*  329888 */     GIR_EraseRootFromParent_Done,
     /*  329889 */   // Label 6088: @329889
     /*  329889 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(329952), // Rule ID 20239 //
     /*  329894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329933 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11430:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  329936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329950 */     GIR_RootConstrainSelectedInstOperands,
     /*  329951 */     // GIR_Coverage, 20239,
     /*  329951 */     GIR_EraseRootFromParent_Done,
     /*  329952 */   // Label 6089: @329952
     /*  329952 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(330015), // Rule ID 20242 //
     /*  329957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  329971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  329999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330013 */     GIR_RootConstrainSelectedInstOperands,
     /*  330014 */     // GIR_Coverage, 20242,
     /*  330014 */     GIR_EraseRootFromParent_Done,
     /*  330015 */   // Label 6090: @330015
     /*  330015 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(330078), // Rule ID 20243 //
     /*  330020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  330034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330059 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11430:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  330062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330076 */     GIR_RootConstrainSelectedInstOperands,
     /*  330077 */     // GIR_Coverage, 20243,
     /*  330077 */     GIR_EraseRootFromParent_Done,
     /*  330078 */   // Label 6091: @330078
     /*  330078 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(330141), // Rule ID 20246 //
     /*  330083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330122 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  330125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330139 */     GIR_RootConstrainSelectedInstOperands,
     /*  330140 */     // GIR_Coverage, 20246,
     /*  330140 */     GIR_EraseRootFromParent_Done,
     /*  330141 */   // Label 6092: @330141
     /*  330141 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(330204), // Rule ID 20247 //
     /*  330146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  330154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  330160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330185 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11430:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  330188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330202 */     GIR_RootConstrainSelectedInstOperands,
     /*  330203 */     // GIR_Coverage, 20247,
     /*  330203 */     GIR_EraseRootFromParent_Done,
     /*  330204 */   // Label 6093: @330204
     /*  330204 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(330267), // Rule ID 20250 //
     /*  330209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330248 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  330251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330265 */     GIR_RootConstrainSelectedInstOperands,
     /*  330266 */     // GIR_Coverage, 20250,
     /*  330266 */     GIR_EraseRootFromParent_Done,
     /*  330267 */   // Label 6094: @330267
     /*  330267 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(330330), // Rule ID 20251 //
     /*  330272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  330286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330311 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  330314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330328 */     GIR_RootConstrainSelectedInstOperands,
     /*  330329 */     // GIR_Coverage, 20251,
     /*  330329 */     GIR_EraseRootFromParent_Done,
     /*  330330 */   // Label 6095: @330330
     /*  330330 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(330393), // Rule ID 20254 //
     /*  330335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330374 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  330377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330391 */     GIR_RootConstrainSelectedInstOperands,
     /*  330392 */     // GIR_Coverage, 20254,
     /*  330392 */     GIR_EraseRootFromParent_Done,
     /*  330393 */   // Label 6096: @330393
     /*  330393 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(330456), // Rule ID 20255 //
     /*  330398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  330412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330437 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  330440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330454 */     GIR_RootConstrainSelectedInstOperands,
     /*  330455 */     // GIR_Coverage, 20255,
     /*  330455 */     GIR_EraseRootFromParent_Done,
     /*  330456 */   // Label 6097: @330456
     /*  330456 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(330519), // Rule ID 20258 //
     /*  330461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330500 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  330503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330517 */     GIR_RootConstrainSelectedInstOperands,
     /*  330518 */     // GIR_Coverage, 20258,
     /*  330518 */     GIR_EraseRootFromParent_Done,
     /*  330519 */   // Label 6098: @330519
     /*  330519 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(330582), // Rule ID 20259 //
     /*  330524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330563 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  330566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330580 */     GIR_RootConstrainSelectedInstOperands,
     /*  330581 */     // GIR_Coverage, 20259,
     /*  330581 */     GIR_EraseRootFromParent_Done,
     /*  330582 */   // Label 6099: @330582
     /*  330582 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(330645), // Rule ID 20262 //
     /*  330587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330626 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  330629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330643 */     GIR_RootConstrainSelectedInstOperands,
     /*  330644 */     // GIR_Coverage, 20262,
     /*  330644 */     GIR_EraseRootFromParent_Done,
     /*  330645 */   // Label 6100: @330645
     /*  330645 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(330708), // Rule ID 20263 //
     /*  330650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330689 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  330692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330706 */     GIR_RootConstrainSelectedInstOperands,
     /*  330707 */     // GIR_Coverage, 20263,
     /*  330707 */     GIR_EraseRootFromParent_Done,
     /*  330708 */   // Label 6101: @330708
     /*  330708 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(330771), // Rule ID 20266 //
     /*  330713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330752 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  330755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330769 */     GIR_RootConstrainSelectedInstOperands,
     /*  330770 */     // GIR_Coverage, 20266,
     /*  330770 */     GIR_EraseRootFromParent_Done,
     /*  330771 */   // Label 6102: @330771
     /*  330771 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(330834), // Rule ID 20267 //
     /*  330776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330815 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  330818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330832 */     GIR_RootConstrainSelectedInstOperands,
     /*  330833 */     // GIR_Coverage, 20267,
     /*  330833 */     GIR_EraseRootFromParent_Done,
     /*  330834 */   // Label 6103: @330834
     /*  330834 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(330897), // Rule ID 20270 //
     /*  330839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330878 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  330881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330895 */     GIR_RootConstrainSelectedInstOperands,
     /*  330896 */     // GIR_Coverage, 20270,
     /*  330896 */     GIR_EraseRootFromParent_Done,
     /*  330897 */   // Label 6104: @330897
     /*  330897 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(330960), // Rule ID 20271 //
     /*  330902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330941 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  330944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330958 */     GIR_RootConstrainSelectedInstOperands,
     /*  330959 */     // GIR_Coverage, 20271,
     /*  330959 */     GIR_EraseRootFromParent_Done,
     /*  330960 */   // Label 6105: @330960
     /*  330960 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(331023), // Rule ID 20274 //
     /*  330965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  330979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331004 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  331007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331021 */     GIR_RootConstrainSelectedInstOperands,
     /*  331022 */     // GIR_Coverage, 20274,
     /*  331022 */     GIR_EraseRootFromParent_Done,
     /*  331023 */   // Label 6106: @331023
     /*  331023 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(331086), // Rule ID 20275 //
     /*  331028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  331042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331067 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  331070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331084 */     GIR_RootConstrainSelectedInstOperands,
     /*  331085 */     // GIR_Coverage, 20275,
     /*  331085 */     GIR_EraseRootFromParent_Done,
     /*  331086 */   // Label 6107: @331086
     /*  331086 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(331149), // Rule ID 20278 //
     /*  331091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331130 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  331133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331147 */     GIR_RootConstrainSelectedInstOperands,
     /*  331148 */     // GIR_Coverage, 20278,
     /*  331148 */     GIR_EraseRootFromParent_Done,
     /*  331149 */   // Label 6108: @331149
     /*  331149 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(331212), // Rule ID 20279 //
     /*  331154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  331168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331193 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  331196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331210 */     GIR_RootConstrainSelectedInstOperands,
     /*  331211 */     // GIR_Coverage, 20279,
     /*  331211 */     GIR_EraseRootFromParent_Done,
     /*  331212 */   // Label 6109: @331212
     /*  331212 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(331275), // Rule ID 20282 //
     /*  331217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331256 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  331259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331273 */     GIR_RootConstrainSelectedInstOperands,
     /*  331274 */     // GIR_Coverage, 20282,
     /*  331274 */     GIR_EraseRootFromParent_Done,
     /*  331275 */   // Label 6110: @331275
     /*  331275 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(331338), // Rule ID 20283 //
     /*  331280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  331291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  331294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331319 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  331322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331336 */     GIR_RootConstrainSelectedInstOperands,
     /*  331337 */     // GIR_Coverage, 20283,
     /*  331337 */     GIR_EraseRootFromParent_Done,
     /*  331338 */   // Label 6111: @331338
     /*  331338 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(331401), // Rule ID 20286 //
     /*  331343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331382 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  331385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331399 */     GIR_RootConstrainSelectedInstOperands,
     /*  331400 */     // GIR_Coverage, 20286,
     /*  331400 */     GIR_EraseRootFromParent_Done,
     /*  331401 */   // Label 6112: @331401
     /*  331401 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(331464), // Rule ID 20287 //
     /*  331406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  331420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331445 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  331448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331462 */     GIR_RootConstrainSelectedInstOperands,
     /*  331463 */     // GIR_Coverage, 20287,
     /*  331463 */     GIR_EraseRootFromParent_Done,
     /*  331464 */   // Label 6113: @331464
     /*  331464 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(331527), // Rule ID 20290 //
     /*  331469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331508 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  331511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331525 */     GIR_RootConstrainSelectedInstOperands,
     /*  331526 */     // GIR_Coverage, 20290,
     /*  331526 */     GIR_EraseRootFromParent_Done,
     /*  331527 */   // Label 6114: @331527
     /*  331527 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(331590), // Rule ID 20291 //
     /*  331532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331571 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  331574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331588 */     GIR_RootConstrainSelectedInstOperands,
     /*  331589 */     // GIR_Coverage, 20291,
     /*  331589 */     GIR_EraseRootFromParent_Done,
     /*  331590 */   // Label 6115: @331590
     /*  331590 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(331653), // Rule ID 20294 //
     /*  331595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  331637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331651 */     GIR_RootConstrainSelectedInstOperands,
     /*  331652 */     // GIR_Coverage, 20294,
     /*  331652 */     GIR_EraseRootFromParent_Done,
     /*  331653 */   // Label 6116: @331653
     /*  331653 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(331716), // Rule ID 20295 //
     /*  331658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331697 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  331700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331714 */     GIR_RootConstrainSelectedInstOperands,
     /*  331715 */     // GIR_Coverage, 20295,
     /*  331715 */     GIR_EraseRootFromParent_Done,
     /*  331716 */   // Label 6117: @331716
     /*  331716 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(331779), // Rule ID 20298 //
     /*  331721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331760 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  331763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331777 */     GIR_RootConstrainSelectedInstOperands,
     /*  331778 */     // GIR_Coverage, 20298,
     /*  331778 */     GIR_EraseRootFromParent_Done,
     /*  331779 */   // Label 6118: @331779
     /*  331779 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(331842), // Rule ID 20299 //
     /*  331784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331823 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  331826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331840 */     GIR_RootConstrainSelectedInstOperands,
     /*  331841 */     // GIR_Coverage, 20299,
     /*  331841 */     GIR_EraseRootFromParent_Done,
     /*  331842 */   // Label 6119: @331842
     /*  331842 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(331905), // Rule ID 20302 //
     /*  331847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331886 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  331889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331903 */     GIR_RootConstrainSelectedInstOperands,
     /*  331904 */     // GIR_Coverage, 20302,
     /*  331904 */     GIR_EraseRootFromParent_Done,
     /*  331905 */   // Label 6120: @331905
     /*  331905 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(331968), // Rule ID 20303 //
     /*  331910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331949 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  331952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331966 */     GIR_RootConstrainSelectedInstOperands,
     /*  331967 */     // GIR_Coverage, 20303,
     /*  331967 */     GIR_EraseRootFromParent_Done,
     /*  331968 */   // Label 6121: @331968
     /*  331968 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(332031), // Rule ID 20306 //
     /*  331973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  331987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332012 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  332015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332029 */     GIR_RootConstrainSelectedInstOperands,
     /*  332030 */     // GIR_Coverage, 20306,
     /*  332030 */     GIR_EraseRootFromParent_Done,
     /*  332031 */   // Label 6122: @332031
     /*  332031 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(332094), // Rule ID 20307 //
     /*  332036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  332044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  332050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332075 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  332078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332092 */     GIR_RootConstrainSelectedInstOperands,
     /*  332093 */     // GIR_Coverage, 20307,
     /*  332093 */     GIR_EraseRootFromParent_Done,
     /*  332094 */   // Label 6123: @332094
     /*  332094 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(332157), // Rule ID 20310 //
     /*  332099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332138 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  332141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332155 */     GIR_RootConstrainSelectedInstOperands,
     /*  332156 */     // GIR_Coverage, 20310,
     /*  332156 */     GIR_EraseRootFromParent_Done,
     /*  332157 */   // Label 6124: @332157
     /*  332157 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(332220), // Rule ID 20311 //
     /*  332162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  332176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332201 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  332204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332218 */     GIR_RootConstrainSelectedInstOperands,
     /*  332219 */     // GIR_Coverage, 20311,
     /*  332219 */     GIR_EraseRootFromParent_Done,
     /*  332220 */   // Label 6125: @332220
     /*  332220 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(332283), // Rule ID 20314 //
     /*  332225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332264 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  332267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332281 */     GIR_RootConstrainSelectedInstOperands,
     /*  332282 */     // GIR_Coverage, 20314,
     /*  332282 */     GIR_EraseRootFromParent_Done,
     /*  332283 */   // Label 6126: @332283
     /*  332283 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(332346), // Rule ID 20315 //
     /*  332288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  332302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332327 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  332330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332344 */     GIR_RootConstrainSelectedInstOperands,
     /*  332345 */     // GIR_Coverage, 20315,
     /*  332345 */     GIR_EraseRootFromParent_Done,
     /*  332346 */   // Label 6127: @332346
     /*  332346 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(332409), // Rule ID 20318 //
     /*  332351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332390 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  332393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332407 */     GIR_RootConstrainSelectedInstOperands,
     /*  332408 */     // GIR_Coverage, 20318,
     /*  332408 */     GIR_EraseRootFromParent_Done,
     /*  332409 */   // Label 6128: @332409
     /*  332409 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(332472), // Rule ID 20319 //
     /*  332414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  332428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332453 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  332456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332470 */     GIR_RootConstrainSelectedInstOperands,
     /*  332471 */     // GIR_Coverage, 20319,
     /*  332471 */     GIR_EraseRootFromParent_Done,
     /*  332472 */   // Label 6129: @332472
     /*  332472 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(332535), // Rule ID 20322 //
     /*  332477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332516 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  332519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332533 */     GIR_RootConstrainSelectedInstOperands,
     /*  332534 */     // GIR_Coverage, 20322,
     /*  332534 */     GIR_EraseRootFromParent_Done,
     /*  332535 */   // Label 6130: @332535
     /*  332535 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(332598), // Rule ID 20323 //
     /*  332540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332579 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  332582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332596 */     GIR_RootConstrainSelectedInstOperands,
     /*  332597 */     // GIR_Coverage, 20323,
     /*  332597 */     GIR_EraseRootFromParent_Done,
     /*  332598 */   // Label 6131: @332598
     /*  332598 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(332661), // Rule ID 20326 //
     /*  332603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332642 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  332645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332659 */     GIR_RootConstrainSelectedInstOperands,
     /*  332660 */     // GIR_Coverage, 20326,
     /*  332660 */     GIR_EraseRootFromParent_Done,
     /*  332661 */   // Label 6132: @332661
     /*  332661 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(332724), // Rule ID 20327 //
     /*  332666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332705 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  332708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332722 */     GIR_RootConstrainSelectedInstOperands,
     /*  332723 */     // GIR_Coverage, 20327,
     /*  332723 */     GIR_EraseRootFromParent_Done,
     /*  332724 */   // Label 6133: @332724
     /*  332724 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(332787), // Rule ID 20330 //
     /*  332729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332768 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  332771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332785 */     GIR_RootConstrainSelectedInstOperands,
     /*  332786 */     // GIR_Coverage, 20330,
     /*  332786 */     GIR_EraseRootFromParent_Done,
     /*  332787 */   // Label 6134: @332787
     /*  332787 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(332850), // Rule ID 20331 //
     /*  332792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332831 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  332834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332848 */     GIR_RootConstrainSelectedInstOperands,
     /*  332849 */     // GIR_Coverage, 20331,
     /*  332849 */     GIR_EraseRootFromParent_Done,
     /*  332850 */   // Label 6135: @332850
     /*  332850 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(332913), // Rule ID 20334 //
     /*  332855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  332897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332911 */     GIR_RootConstrainSelectedInstOperands,
     /*  332912 */     // GIR_Coverage, 20334,
     /*  332912 */     GIR_EraseRootFromParent_Done,
     /*  332913 */   // Label 6136: @332913
     /*  332913 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(332976), // Rule ID 20335 //
     /*  332918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332957 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  332960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332974 */     GIR_RootConstrainSelectedInstOperands,
     /*  332975 */     // GIR_Coverage, 20335,
     /*  332975 */     GIR_EraseRootFromParent_Done,
     /*  332976 */   // Label 6137: @332976
     /*  332976 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(333039), // Rule ID 20338 //
     /*  332981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  332992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  332995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  333023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333037 */     GIR_RootConstrainSelectedInstOperands,
     /*  333038 */     // GIR_Coverage, 20338,
     /*  333038 */     GIR_EraseRootFromParent_Done,
     /*  333039 */   // Label 6138: @333039
     /*  333039 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(333102), // Rule ID 20339 //
     /*  333044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  333058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  333086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333100 */     GIR_RootConstrainSelectedInstOperands,
     /*  333101 */     // GIR_Coverage, 20339,
     /*  333101 */     GIR_EraseRootFromParent_Done,
     /*  333102 */   // Label 6139: @333102
     /*  333102 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(333165), // Rule ID 20342 //
     /*  333107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333146 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  333149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333163 */     GIR_RootConstrainSelectedInstOperands,
     /*  333164 */     // GIR_Coverage, 20342,
     /*  333164 */     GIR_EraseRootFromParent_Done,
     /*  333165 */   // Label 6140: @333165
     /*  333165 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(333228), // Rule ID 20343 //
     /*  333170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  333181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  333184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  333187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  333202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333209 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  333212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333226 */     GIR_RootConstrainSelectedInstOperands,
     /*  333227 */     // GIR_Coverage, 20343,
     /*  333227 */     GIR_EraseRootFromParent_Done,
     /*  333228 */   // Label 6141: @333228
     /*  333228 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(333291), // Rule ID 20346 //
     /*  333233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333272 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  333275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333289 */     GIR_RootConstrainSelectedInstOperands,
     /*  333290 */     // GIR_Coverage, 20346,
     /*  333290 */     GIR_EraseRootFromParent_Done,
     /*  333291 */   // Label 6142: @333291
     /*  333291 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(333354), // Rule ID 20347 //
     /*  333296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  333310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333335 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  333338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333352 */     GIR_RootConstrainSelectedInstOperands,
     /*  333353 */     // GIR_Coverage, 20347,
     /*  333353 */     GIR_EraseRootFromParent_Done,
     /*  333354 */   // Label 6143: @333354
     /*  333354 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(333417), // Rule ID 20350 //
     /*  333359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333398 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  333401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333415 */     GIR_RootConstrainSelectedInstOperands,
     /*  333416 */     // GIR_Coverage, 20350,
     /*  333416 */     GIR_EraseRootFromParent_Done,
     /*  333417 */   // Label 6144: @333417
     /*  333417 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(333480), // Rule ID 20351 //
     /*  333422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  333436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333461 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  333464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333478 */     GIR_RootConstrainSelectedInstOperands,
     /*  333479 */     // GIR_Coverage, 20351,
     /*  333479 */     GIR_EraseRootFromParent_Done,
     /*  333480 */   // Label 6145: @333480
     /*  333480 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(333543), // Rule ID 20354 //
     /*  333485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333524 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  333527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333541 */     GIR_RootConstrainSelectedInstOperands,
     /*  333542 */     // GIR_Coverage, 20354,
     /*  333542 */     GIR_EraseRootFromParent_Done,
     /*  333543 */   // Label 6146: @333543
     /*  333543 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(333606), // Rule ID 20355 //
     /*  333548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333587 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  333590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333604 */     GIR_RootConstrainSelectedInstOperands,
     /*  333605 */     // GIR_Coverage, 20355,
     /*  333605 */     GIR_EraseRootFromParent_Done,
     /*  333606 */   // Label 6147: @333606
     /*  333606 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(333669), // Rule ID 20358 //
     /*  333611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333650 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  333653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333667 */     GIR_RootConstrainSelectedInstOperands,
     /*  333668 */     // GIR_Coverage, 20358,
     /*  333668 */     GIR_EraseRootFromParent_Done,
     /*  333669 */   // Label 6148: @333669
     /*  333669 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(333732), // Rule ID 20359 //
     /*  333674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333713 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  333716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333730 */     GIR_RootConstrainSelectedInstOperands,
     /*  333731 */     // GIR_Coverage, 20359,
     /*  333731 */     GIR_EraseRootFromParent_Done,
     /*  333732 */   // Label 6149: @333732
     /*  333732 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(333795), // Rule ID 20362 //
     /*  333737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333776 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  333779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333793 */     GIR_RootConstrainSelectedInstOperands,
     /*  333794 */     // GIR_Coverage, 20362,
     /*  333794 */     GIR_EraseRootFromParent_Done,
     /*  333795 */   // Label 6150: @333795
     /*  333795 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(333858), // Rule ID 20363 //
     /*  333800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333839 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  333842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333856 */     GIR_RootConstrainSelectedInstOperands,
     /*  333857 */     // GIR_Coverage, 20363,
     /*  333857 */     GIR_EraseRootFromParent_Done,
     /*  333858 */   // Label 6151: @333858
     /*  333858 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(333921), // Rule ID 20366 //
     /*  333863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  333877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  333905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333919 */     GIR_RootConstrainSelectedInstOperands,
     /*  333920 */     // GIR_Coverage, 20366,
     /*  333920 */     GIR_EraseRootFromParent_Done,
     /*  333921 */   // Label 6152: @333921
     /*  333921 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(333984), // Rule ID 20367 //
     /*  333926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  333940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333965 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  333968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333982 */     GIR_RootConstrainSelectedInstOperands,
     /*  333983 */     // GIR_Coverage, 20367,
     /*  333983 */     GIR_EraseRootFromParent_Done,
     /*  333984 */   // Label 6153: @333984
     /*  333984 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(334047), // Rule ID 20370 //
     /*  333989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  334006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  334031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334045 */     GIR_RootConstrainSelectedInstOperands,
     /*  334046 */     // GIR_Coverage, 20370,
     /*  334046 */     GIR_EraseRootFromParent_Done,
     /*  334047 */   // Label 6154: @334047
     /*  334047 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(334110), // Rule ID 20371 //
     /*  334052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  334066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  334069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334091 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  334094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334108 */     GIR_RootConstrainSelectedInstOperands,
     /*  334109 */     // GIR_Coverage, 20371,
     /*  334109 */     GIR_EraseRootFromParent_Done,
     /*  334110 */   // Label 6155: @334110
     /*  334110 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(334173), // Rule ID 20374 //
     /*  334115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  334132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334171 */     GIR_RootConstrainSelectedInstOperands,
     /*  334172 */     // GIR_Coverage, 20374,
     /*  334172 */     GIR_EraseRootFromParent_Done,
     /*  334173 */   // Label 6156: @334173
     /*  334173 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(334236), // Rule ID 20375 //
     /*  334178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  334192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  334195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334217 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334234 */     GIR_RootConstrainSelectedInstOperands,
     /*  334235 */     // GIR_Coverage, 20375,
     /*  334235 */     GIR_EraseRootFromParent_Done,
     /*  334236 */   // Label 6157: @334236
     /*  334236 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(334299), // Rule ID 20378 //
     /*  334241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  334258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334297 */     GIR_RootConstrainSelectedInstOperands,
     /*  334298 */     // GIR_Coverage, 20378,
     /*  334298 */     GIR_EraseRootFromParent_Done,
     /*  334299 */   // Label 6158: @334299
     /*  334299 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(334362), // Rule ID 20379 //
     /*  334304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  334318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  334321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334343 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  334346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334360 */     GIR_RootConstrainSelectedInstOperands,
     /*  334361 */     // GIR_Coverage, 20379,
     /*  334361 */     GIR_EraseRootFromParent_Done,
     /*  334362 */   // Label 6159: @334362
     /*  334362 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(334425), // Rule ID 20382 //
     /*  334367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  334384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334406 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334423 */     GIR_RootConstrainSelectedInstOperands,
     /*  334424 */     // GIR_Coverage, 20382,
     /*  334424 */     GIR_EraseRootFromParent_Done,
     /*  334425 */   // Label 6160: @334425
     /*  334425 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(334488), // Rule ID 20383 //
     /*  334430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  334444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  334447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334469 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334486 */     GIR_RootConstrainSelectedInstOperands,
     /*  334487 */     // GIR_Coverage, 20383,
     /*  334487 */     GIR_EraseRootFromParent_Done,
     /*  334488 */   // Label 6161: @334488
     /*  334488 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(334551), // Rule ID 20386 //
     /*  334493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  334510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334549 */     GIR_RootConstrainSelectedInstOperands,
     /*  334550 */     // GIR_Coverage, 20386,
     /*  334550 */     GIR_EraseRootFromParent_Done,
     /*  334551 */   // Label 6162: @334551
     /*  334551 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(334614), // Rule ID 20387 //
     /*  334556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  334573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334595 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334612 */     GIR_RootConstrainSelectedInstOperands,
     /*  334613 */     // GIR_Coverage, 20387,
     /*  334613 */     GIR_EraseRootFromParent_Done,
     /*  334614 */   // Label 6163: @334614
     /*  334614 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(334677), // Rule ID 20390 //
     /*  334619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  334636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334675 */     GIR_RootConstrainSelectedInstOperands,
     /*  334676 */     // GIR_Coverage, 20390,
     /*  334676 */     GIR_EraseRootFromParent_Done,
     /*  334677 */   // Label 6164: @334677
     /*  334677 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(334740), // Rule ID 20391 //
     /*  334682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  334699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334721 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334738 */     GIR_RootConstrainSelectedInstOperands,
     /*  334739 */     // GIR_Coverage, 20391,
     /*  334739 */     GIR_EraseRootFromParent_Done,
     /*  334740 */   // Label 6165: @334740
     /*  334740 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(334803), // Rule ID 20394 //
     /*  334745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  334762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334784 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  334787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334801 */     GIR_RootConstrainSelectedInstOperands,
     /*  334802 */     // GIR_Coverage, 20394,
     /*  334802 */     GIR_EraseRootFromParent_Done,
     /*  334803 */   // Label 6166: @334803
     /*  334803 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(334866), // Rule ID 20395 //
     /*  334808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  334825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334847 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  334850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334864 */     GIR_RootConstrainSelectedInstOperands,
     /*  334865 */     // GIR_Coverage, 20395,
     /*  334865 */     GIR_EraseRootFromParent_Done,
     /*  334866 */   // Label 6167: @334866
     /*  334866 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(334929), // Rule ID 20398 //
     /*  334871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  334888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334910 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  334913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334927 */     GIR_RootConstrainSelectedInstOperands,
     /*  334928 */     // GIR_Coverage, 20398,
     /*  334928 */     GIR_EraseRootFromParent_Done,
     /*  334929 */   // Label 6168: @334929
     /*  334929 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(334992), // Rule ID 20399 //
     /*  334934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  334951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334973 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  334976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334990 */     GIR_RootConstrainSelectedInstOperands,
     /*  334991 */     // GIR_Coverage, 20399,
     /*  334991 */     GIR_EraseRootFromParent_Done,
     /*  334992 */   // Label 6169: @334992
     /*  334992 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(335055), // Rule ID 20402 //
     /*  334997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  335014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335036 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335053 */     GIR_RootConstrainSelectedInstOperands,
     /*  335054 */     // GIR_Coverage, 20402,
     /*  335054 */     GIR_EraseRootFromParent_Done,
     /*  335055 */   // Label 6170: @335055
     /*  335055 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(335118), // Rule ID 20403 //
     /*  335060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  335071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  335074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  335077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335099 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335116 */     GIR_RootConstrainSelectedInstOperands,
     /*  335117 */     // GIR_Coverage, 20403,
     /*  335117 */     GIR_EraseRootFromParent_Done,
     /*  335118 */   // Label 6171: @335118
     /*  335118 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(335181), // Rule ID 20406 //
     /*  335123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  335140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335179 */     GIR_RootConstrainSelectedInstOperands,
     /*  335180 */     // GIR_Coverage, 20406,
     /*  335180 */     GIR_EraseRootFromParent_Done,
     /*  335181 */   // Label 6172: @335181
     /*  335181 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(335244), // Rule ID 20407 //
     /*  335186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  335200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  335203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335225 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335242 */     GIR_RootConstrainSelectedInstOperands,
     /*  335243 */     // GIR_Coverage, 20407,
     /*  335243 */     GIR_EraseRootFromParent_Done,
     /*  335244 */   // Label 6173: @335244
     /*  335244 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(335307), // Rule ID 20410 //
     /*  335249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  335266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335288 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335305 */     GIR_RootConstrainSelectedInstOperands,
     /*  335306 */     // GIR_Coverage, 20410,
     /*  335306 */     GIR_EraseRootFromParent_Done,
     /*  335307 */   // Label 6174: @335307
     /*  335307 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(335370), // Rule ID 20411 //
     /*  335312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  335326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  335329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335351 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335368 */     GIR_RootConstrainSelectedInstOperands,
     /*  335369 */     // GIR_Coverage, 20411,
     /*  335369 */     GIR_EraseRootFromParent_Done,
     /*  335370 */   // Label 6175: @335370
     /*  335370 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(335433), // Rule ID 20414 //
     /*  335375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335431 */     GIR_RootConstrainSelectedInstOperands,
     /*  335432 */     // GIR_Coverage, 20414,
     /*  335432 */     GIR_EraseRootFromParent_Done,
     /*  335433 */   // Label 6176: @335433
     /*  335433 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(335496), // Rule ID 20415 //
     /*  335438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  335449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  335452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  335455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335477 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335494 */     GIR_RootConstrainSelectedInstOperands,
     /*  335495 */     // GIR_Coverage, 20415,
     /*  335495 */     GIR_EraseRootFromParent_Done,
     /*  335496 */   // Label 6177: @335496
     /*  335496 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(335559), // Rule ID 20418 //
     /*  335501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335557 */     GIR_RootConstrainSelectedInstOperands,
     /*  335558 */     // GIR_Coverage, 20418,
     /*  335558 */     GIR_EraseRootFromParent_Done,
     /*  335559 */   // Label 6178: @335559
     /*  335559 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(335622), // Rule ID 20419 //
     /*  335564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335603 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335620 */     GIR_RootConstrainSelectedInstOperands,
     /*  335621 */     // GIR_Coverage, 20419,
     /*  335621 */     GIR_EraseRootFromParent_Done,
     /*  335622 */   // Label 6179: @335622
     /*  335622 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(335685), // Rule ID 20422 //
     /*  335627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  335644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335666 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335683 */     GIR_RootConstrainSelectedInstOperands,
     /*  335684 */     // GIR_Coverage, 20422,
     /*  335684 */     GIR_EraseRootFromParent_Done,
     /*  335685 */   // Label 6180: @335685
     /*  335685 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(335748), // Rule ID 20423 //
     /*  335690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  335707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335729 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335746 */     GIR_RootConstrainSelectedInstOperands,
     /*  335747 */     // GIR_Coverage, 20423,
     /*  335747 */     GIR_EraseRootFromParent_Done,
     /*  335748 */   // Label 6181: @335748
     /*  335748 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(335811), // Rule ID 20426 //
     /*  335753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  335770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335792 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335809 */     GIR_RootConstrainSelectedInstOperands,
     /*  335810 */     // GIR_Coverage, 20426,
     /*  335810 */     GIR_EraseRootFromParent_Done,
     /*  335811 */   // Label 6182: @335811
     /*  335811 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(335874), // Rule ID 20427 //
     /*  335816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  335833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335855 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11424:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335872 */     GIR_RootConstrainSelectedInstOperands,
     /*  335873 */     // GIR_Coverage, 20427,
     /*  335873 */     GIR_EraseRootFromParent_Done,
     /*  335874 */   // Label 6183: @335874
     /*  335874 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(335937), // Rule ID 20430 //
     /*  335879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  335893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  335896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335918 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  335921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335935 */     GIR_RootConstrainSelectedInstOperands,
     /*  335936 */     // GIR_Coverage, 20430,
     /*  335936 */     GIR_EraseRootFromParent_Done,
     /*  335937 */   // Label 6184: @335937
     /*  335937 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(336000), // Rule ID 20431 //
     /*  335942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  335956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  335959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335981 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  335984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335998 */     GIR_RootConstrainSelectedInstOperands,
     /*  335999 */     // GIR_Coverage, 20431,
     /*  335999 */     GIR_EraseRootFromParent_Done,
     /*  336000 */   // Label 6185: @336000
     /*  336000 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(336063), // Rule ID 20434 //
     /*  336005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336061 */     GIR_RootConstrainSelectedInstOperands,
     /*  336062 */     // GIR_Coverage, 20434,
     /*  336062 */     GIR_EraseRootFromParent_Done,
     /*  336063 */   // Label 6186: @336063
     /*  336063 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(336126), // Rule ID 20435 //
     /*  336068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  336082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  336085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336107 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336124 */     GIR_RootConstrainSelectedInstOperands,
     /*  336125 */     // GIR_Coverage, 20435,
     /*  336125 */     GIR_EraseRootFromParent_Done,
     /*  336126 */   // Label 6187: @336126
     /*  336126 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(336189), // Rule ID 20438 //
     /*  336131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336170 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336187 */     GIR_RootConstrainSelectedInstOperands,
     /*  336188 */     // GIR_Coverage, 20438,
     /*  336188 */     GIR_EraseRootFromParent_Done,
     /*  336189 */   // Label 6188: @336189
     /*  336189 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(336252), // Rule ID 20439 //
     /*  336194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  336208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  336211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336233 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  336236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336250 */     GIR_RootConstrainSelectedInstOperands,
     /*  336251 */     // GIR_Coverage, 20439,
     /*  336251 */     GIR_EraseRootFromParent_Done,
     /*  336252 */   // Label 6189: @336252
     /*  336252 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(336315), // Rule ID 20442 //
     /*  336257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  336274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336313 */     GIR_RootConstrainSelectedInstOperands,
     /*  336314 */     // GIR_Coverage, 20442,
     /*  336314 */     GIR_EraseRootFromParent_Done,
     /*  336315 */   // Label 6190: @336315
     /*  336315 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(336378), // Rule ID 20443 //
     /*  336320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  336334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  336337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336359 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336376 */     GIR_RootConstrainSelectedInstOperands,
     /*  336377 */     // GIR_Coverage, 20443,
     /*  336377 */     GIR_EraseRootFromParent_Done,
     /*  336378 */   // Label 6191: @336378
     /*  336378 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(336441), // Rule ID 20446 //
     /*  336383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  336400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336439 */     GIR_RootConstrainSelectedInstOperands,
     /*  336440 */     // GIR_Coverage, 20446,
     /*  336440 */     GIR_EraseRootFromParent_Done,
     /*  336441 */   // Label 6192: @336441
     /*  336441 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(336504), // Rule ID 20447 //
     /*  336446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  336460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  336463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336485 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336502 */     GIR_RootConstrainSelectedInstOperands,
     /*  336503 */     // GIR_Coverage, 20447,
     /*  336503 */     GIR_EraseRootFromParent_Done,
     /*  336504 */   // Label 6193: @336504
     /*  336504 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(336567), // Rule ID 20450 //
     /*  336509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  336526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336548 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336565 */     GIR_RootConstrainSelectedInstOperands,
     /*  336566 */     // GIR_Coverage, 20450,
     /*  336566 */     GIR_EraseRootFromParent_Done,
     /*  336567 */   // Label 6194: @336567
     /*  336567 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(336630), // Rule ID 20451 //
     /*  336572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  336589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336611 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336628 */     GIR_RootConstrainSelectedInstOperands,
     /*  336629 */     // GIR_Coverage, 20451,
     /*  336629 */     GIR_EraseRootFromParent_Done,
     /*  336630 */   // Label 6195: @336630
     /*  336630 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(336693), // Rule ID 20454 //
     /*  336635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  336652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336674 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336691 */     GIR_RootConstrainSelectedInstOperands,
     /*  336692 */     // GIR_Coverage, 20454,
     /*  336692 */     GIR_EraseRootFromParent_Done,
     /*  336693 */   // Label 6196: @336693
     /*  336693 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(336756), // Rule ID 20455 //
     /*  336698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  336715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336737 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336754 */     GIR_RootConstrainSelectedInstOperands,
     /*  336755 */     // GIR_Coverage, 20455,
     /*  336755 */     GIR_EraseRootFromParent_Done,
     /*  336756 */   // Label 6197: @336756
     /*  336756 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(336819), // Rule ID 20458 //
     /*  336761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  336778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  336803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336817 */     GIR_RootConstrainSelectedInstOperands,
     /*  336818 */     // GIR_Coverage, 20458,
     /*  336818 */     GIR_EraseRootFromParent_Done,
     /*  336819 */   // Label 6198: @336819
     /*  336819 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(336882), // Rule ID 20459 //
     /*  336824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  336841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336863 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  336866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336880 */     GIR_RootConstrainSelectedInstOperands,
     /*  336881 */     // GIR_Coverage, 20459,
     /*  336881 */     GIR_EraseRootFromParent_Done,
     /*  336882 */   // Label 6199: @336882
     /*  336882 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(336945), // Rule ID 20462 //
     /*  336887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  336898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  336901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  336904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336926 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  336929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336943 */     GIR_RootConstrainSelectedInstOperands,
     /*  336944 */     // GIR_Coverage, 20462,
     /*  336944 */     GIR_EraseRootFromParent_Done,
     /*  336945 */   // Label 6200: @336945
     /*  336945 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(337008), // Rule ID 20463 //
     /*  336950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  336961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  336964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  336967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336989 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  336992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337006 */     GIR_RootConstrainSelectedInstOperands,
     /*  337007 */     // GIR_Coverage, 20463,
     /*  337007 */     GIR_EraseRootFromParent_Done,
     /*  337008 */   // Label 6201: @337008
     /*  337008 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(337071), // Rule ID 20466 //
     /*  337013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  337030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337052 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337069 */     GIR_RootConstrainSelectedInstOperands,
     /*  337070 */     // GIR_Coverage, 20466,
     /*  337070 */     GIR_EraseRootFromParent_Done,
     /*  337071 */   // Label 6202: @337071
     /*  337071 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(337134), // Rule ID 20467 //
     /*  337076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  337090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  337093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337115 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337132 */     GIR_RootConstrainSelectedInstOperands,
     /*  337133 */     // GIR_Coverage, 20467,
     /*  337133 */     GIR_EraseRootFromParent_Done,
     /*  337134 */   // Label 6203: @337134
     /*  337134 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(337197), // Rule ID 20470 //
     /*  337139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  337156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337178 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337195 */     GIR_RootConstrainSelectedInstOperands,
     /*  337196 */     // GIR_Coverage, 20470,
     /*  337196 */     GIR_EraseRootFromParent_Done,
     /*  337197 */   // Label 6204: @337197
     /*  337197 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(337260), // Rule ID 20471 //
     /*  337202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  337216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  337219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337241 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337258 */     GIR_RootConstrainSelectedInstOperands,
     /*  337259 */     // GIR_Coverage, 20471,
     /*  337259 */     GIR_EraseRootFromParent_Done,
     /*  337260 */   // Label 6205: @337260
     /*  337260 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(337323), // Rule ID 20474 //
     /*  337265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  337268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  337282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337304 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  337304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337321 */     GIR_RootConstrainSelectedInstOperands,
     /*  337322 */     // GIR_Coverage, 20474,
     /*  337322 */     GIR_EraseRootFromParent_Done,
     /*  337323 */   // Label 6206: @337323
     /*  337323 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(337386), // Rule ID 20475 //
     /*  337328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  337331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  337339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  337342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  337345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337367 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  337367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337384 */     GIR_RootConstrainSelectedInstOperands,
     /*  337385 */     // GIR_Coverage, 20475,
     /*  337385 */     GIR_EraseRootFromParent_Done,
     /*  337386 */   // Label 6207: @337386
     /*  337386 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(337449), // Rule ID 20478 //
     /*  337391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  337408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337430 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337447 */     GIR_RootConstrainSelectedInstOperands,
     /*  337448 */     // GIR_Coverage, 20478,
     /*  337448 */     GIR_EraseRootFromParent_Done,
     /*  337449 */   // Label 6208: @337449
     /*  337449 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(337512), // Rule ID 20479 //
     /*  337454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  337465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  337468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  337471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337493 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  337496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337510 */     GIR_RootConstrainSelectedInstOperands,
     /*  337511 */     // GIR_Coverage, 20479,
     /*  337511 */     GIR_EraseRootFromParent_Done,
     /*  337512 */   // Label 6209: @337512
     /*  337512 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(337575), // Rule ID 20482 //
     /*  337517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  337534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337573 */     GIR_RootConstrainSelectedInstOperands,
     /*  337574 */     // GIR_Coverage, 20482,
     /*  337574 */     GIR_EraseRootFromParent_Done,
     /*  337575 */   // Label 6210: @337575
     /*  337575 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(337638), // Rule ID 20483 //
     /*  337580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  337597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337619 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337636 */     GIR_RootConstrainSelectedInstOperands,
     /*  337637 */     // GIR_Coverage, 20483,
     /*  337637 */     GIR_EraseRootFromParent_Done,
     /*  337638 */   // Label 6211: @337638
     /*  337638 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(337701), // Rule ID 20486 //
     /*  337643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  337660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337682 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337699 */     GIR_RootConstrainSelectedInstOperands,
     /*  337700 */     // GIR_Coverage, 20486,
     /*  337700 */     GIR_EraseRootFromParent_Done,
     /*  337701 */   // Label 6212: @337701
     /*  337701 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(337764), // Rule ID 20487 //
     /*  337706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  337723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337745 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11422:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337762 */     GIR_RootConstrainSelectedInstOperands,
     /*  337763 */     // GIR_Coverage, 20487,
     /*  337763 */     GIR_EraseRootFromParent_Done,
     /*  337764 */   // Label 6213: @337764
     /*  337764 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(337830), // Rule ID 20490 //
     /*  337769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  337772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  337780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  337783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  337786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337808 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  337808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337828 */     GIR_RootConstrainSelectedInstOperands,
     /*  337829 */     // GIR_Coverage, 20490,
     /*  337829 */     GIR_EraseRootFromParent_Done,
     /*  337830 */   // Label 6214: @337830
     /*  337830 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(337896), // Rule ID 20491 //
     /*  337835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  337838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  337846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  337849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  337852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  337874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337894 */     GIR_RootConstrainSelectedInstOperands,
     /*  337895 */     // GIR_Coverage, 20491,
     /*  337895 */     GIR_EraseRootFromParent_Done,
     /*  337896 */   // Label 6215: @337896
     /*  337896 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(337962), // Rule ID 20494 //
     /*  337901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  337904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  337912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  337915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  337918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  337940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337960 */     GIR_RootConstrainSelectedInstOperands,
     /*  337961 */     // GIR_Coverage, 20494,
     /*  337961 */     GIR_EraseRootFromParent_Done,
     /*  337962 */   // Label 6216: @337962
     /*  337962 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(338028), // Rule ID 20495 //
     /*  337967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  337970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  337978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  337981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  337984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  338009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338026 */     GIR_RootConstrainSelectedInstOperands,
     /*  338027 */     // GIR_Coverage, 20495,
     /*  338027 */     GIR_EraseRootFromParent_Done,
     /*  338028 */   // Label 6217: @338028
     /*  338028 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(338094), // Rule ID 20498 //
     /*  338033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  338044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338092 */     GIR_RootConstrainSelectedInstOperands,
     /*  338093 */     // GIR_Coverage, 20498,
     /*  338093 */     GIR_EraseRootFromParent_Done,
     /*  338094 */   // Label 6218: @338094
     /*  338094 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(338160), // Rule ID 20499 //
     /*  338099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  338110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  338113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  338116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338158 */     GIR_RootConstrainSelectedInstOperands,
     /*  338159 */     // GIR_Coverage, 20499,
     /*  338159 */     GIR_EraseRootFromParent_Done,
     /*  338160 */   // Label 6219: @338160
     /*  338160 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(338226), // Rule ID 20502 //
     /*  338165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  338176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338224 */     GIR_RootConstrainSelectedInstOperands,
     /*  338225 */     // GIR_Coverage, 20502,
     /*  338225 */     GIR_EraseRootFromParent_Done,
     /*  338226 */   // Label 6220: @338226
     /*  338226 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(338292), // Rule ID 20503 //
     /*  338231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  338242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  338245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  338248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338290 */     GIR_RootConstrainSelectedInstOperands,
     /*  338291 */     // GIR_Coverage, 20503,
     /*  338291 */     GIR_EraseRootFromParent_Done,
     /*  338292 */   // Label 6221: @338292
     /*  338292 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(338358), // Rule ID 20506 //
     /*  338297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  338300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  338308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  338336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338356 */     GIR_RootConstrainSelectedInstOperands,
     /*  338357 */     // GIR_Coverage, 20506,
     /*  338357 */     GIR_EraseRootFromParent_Done,
     /*  338358 */   // Label 6222: @338358
     /*  338358 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(338424), // Rule ID 20507 //
     /*  338363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  338366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  338374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  338377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  338380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  338395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  338402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  338405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338422 */     GIR_RootConstrainSelectedInstOperands,
     /*  338423 */     // GIR_Coverage, 20507,
     /*  338423 */     GIR_EraseRootFromParent_Done,
     /*  338424 */   // Label 6223: @338424
     /*  338424 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(338490), // Rule ID 20510 //
     /*  338429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338468 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338488 */     GIR_RootConstrainSelectedInstOperands,
     /*  338489 */     // GIR_Coverage, 20510,
     /*  338489 */     GIR_EraseRootFromParent_Done,
     /*  338490 */   // Label 6224: @338490
     /*  338490 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(338556), // Rule ID 20511 //
     /*  338495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  338506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338534 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338554 */     GIR_RootConstrainSelectedInstOperands,
     /*  338555 */     // GIR_Coverage, 20511,
     /*  338555 */     GIR_EraseRootFromParent_Done,
     /*  338556 */   // Label 6225: @338556
     /*  338556 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(338622), // Rule ID 20514 //
     /*  338561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  338572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338600 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338620 */     GIR_RootConstrainSelectedInstOperands,
     /*  338621 */     // GIR_Coverage, 20514,
     /*  338621 */     GIR_EraseRootFromParent_Done,
     /*  338622 */   // Label 6226: @338622
     /*  338622 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(338688), // Rule ID 20515 //
     /*  338627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  338638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338666 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338686 */     GIR_RootConstrainSelectedInstOperands,
     /*  338687 */     // GIR_Coverage, 20515,
     /*  338687 */     GIR_EraseRootFromParent_Done,
     /*  338688 */   // Label 6227: @338688
     /*  338688 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(338754), // Rule ID 20518 //
     /*  338693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  338704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338732 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  338735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338752 */     GIR_RootConstrainSelectedInstOperands,
     /*  338753 */     // GIR_Coverage, 20518,
     /*  338753 */     GIR_EraseRootFromParent_Done,
     /*  338754 */   // Label 6228: @338754
     /*  338754 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(338820), // Rule ID 20519 //
     /*  338759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  338770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338798 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  338801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338818 */     GIR_RootConstrainSelectedInstOperands,
     /*  338819 */     // GIR_Coverage, 20519,
     /*  338819 */     GIR_EraseRootFromParent_Done,
     /*  338820 */   // Label 6229: @338820
     /*  338820 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(338886), // Rule ID 20522 //
     /*  338825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  338836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338884 */     GIR_RootConstrainSelectedInstOperands,
     /*  338885 */     // GIR_Coverage, 20522,
     /*  338885 */     GIR_EraseRootFromParent_Done,
     /*  338886 */   // Label 6230: @338886
     /*  338886 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(338952), // Rule ID 20523 //
     /*  338891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  338902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338950 */     GIR_RootConstrainSelectedInstOperands,
     /*  338951 */     // GIR_Coverage, 20523,
     /*  338951 */     GIR_EraseRootFromParent_Done,
     /*  338952 */   // Label 6231: @338952
     /*  338952 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(339018), // Rule ID 20526 //
     /*  338957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  338968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  338971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  338974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339016 */     GIR_RootConstrainSelectedInstOperands,
     /*  339017 */     // GIR_Coverage, 20526,
     /*  339017 */     GIR_EraseRootFromParent_Done,
     /*  339018 */   // Label 6232: @339018
     /*  339018 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(339084), // Rule ID 20527 //
     /*  339023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  339034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  339037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  339040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339082 */     GIR_RootConstrainSelectedInstOperands,
     /*  339083 */     // GIR_Coverage, 20527,
     /*  339083 */     GIR_EraseRootFromParent_Done,
     /*  339084 */   // Label 6233: @339084
     /*  339084 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(339150), // Rule ID 20530 //
     /*  339089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  339100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339128 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339148 */     GIR_RootConstrainSelectedInstOperands,
     /*  339149 */     // GIR_Coverage, 20530,
     /*  339149 */     GIR_EraseRootFromParent_Done,
     /*  339150 */   // Label 6234: @339150
     /*  339150 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(339216), // Rule ID 20531 //
     /*  339155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  339166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  339169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  339172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339214 */     GIR_RootConstrainSelectedInstOperands,
     /*  339215 */     // GIR_Coverage, 20531,
     /*  339215 */     GIR_EraseRootFromParent_Done,
     /*  339216 */   // Label 6235: @339216
     /*  339216 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(339282), // Rule ID 20534 //
     /*  339221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339260 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339280 */     GIR_RootConstrainSelectedInstOperands,
     /*  339281 */     // GIR_Coverage, 20534,
     /*  339281 */     GIR_EraseRootFromParent_Done,
     /*  339282 */   // Label 6236: @339282
     /*  339282 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(339348), // Rule ID 20535 //
     /*  339287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  339298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  339301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  339304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11187:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  339329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339346 */     GIR_RootConstrainSelectedInstOperands,
     /*  339347 */     // GIR_Coverage, 20535,
     /*  339347 */     GIR_EraseRootFromParent_Done,
     /*  339348 */   // Label 6237: @339348
     /*  339348 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(339414), // Rule ID 20538 //
     /*  339353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339392 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339412 */     GIR_RootConstrainSelectedInstOperands,
     /*  339413 */     // GIR_Coverage, 20538,
     /*  339413 */     GIR_EraseRootFromParent_Done,
     /*  339414 */   // Label 6238: @339414
     /*  339414 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(339480), // Rule ID 20539 //
     /*  339419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  339430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  339433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  339436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  339451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339458 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11187:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  339461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339478 */     GIR_RootConstrainSelectedInstOperands,
     /*  339479 */     // GIR_Coverage, 20539,
     /*  339479 */     GIR_EraseRootFromParent_Done,
     /*  339480 */   // Label 6239: @339480
     /*  339480 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(339546), // Rule ID 20542 //
     /*  339485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  339496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339524 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339544 */     GIR_RootConstrainSelectedInstOperands,
     /*  339545 */     // GIR_Coverage, 20542,
     /*  339545 */     GIR_EraseRootFromParent_Done,
     /*  339546 */   // Label 6240: @339546
     /*  339546 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(339612), // Rule ID 20543 //
     /*  339551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  339562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11187:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339610 */     GIR_RootConstrainSelectedInstOperands,
     /*  339611 */     // GIR_Coverage, 20543,
     /*  339611 */     GIR_EraseRootFromParent_Done,
     /*  339612 */   // Label 6241: @339612
     /*  339612 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(339678), // Rule ID 20868 //
     /*  339617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  339628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339656 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  339659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339676 */     GIR_RootConstrainSelectedInstOperands,
     /*  339677 */     // GIR_Coverage, 20868,
     /*  339677 */     GIR_EraseRootFromParent_Done,
     /*  339678 */   // Label 6242: @339678
     /*  339678 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(339744), // Rule ID 20869 //
     /*  339683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  339694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339722 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  339725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339742 */     GIR_RootConstrainSelectedInstOperands,
     /*  339743 */     // GIR_Coverage, 20869,
     /*  339743 */     GIR_EraseRootFromParent_Done,
     /*  339744 */   // Label 6243: @339744
     /*  339744 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(339810), // Rule ID 20872 //
     /*  339749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  339760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339788 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339808 */     GIR_RootConstrainSelectedInstOperands,
     /*  339809 */     // GIR_Coverage, 20872,
     /*  339809 */     GIR_EraseRootFromParent_Done,
     /*  339810 */   // Label 6244: @339810
     /*  339810 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(339876), // Rule ID 20873 //
     /*  339815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  339826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339854 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339874 */     GIR_RootConstrainSelectedInstOperands,
     /*  339875 */     // GIR_Coverage, 20873,
     /*  339875 */     GIR_EraseRootFromParent_Done,
     /*  339876 */   // Label 6245: @339876
     /*  339876 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(339942), // Rule ID 20876 //
     /*  339881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  339892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  339895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  339898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339940 */     GIR_RootConstrainSelectedInstOperands,
     /*  339941 */     // GIR_Coverage, 20876,
     /*  339941 */     GIR_EraseRootFromParent_Done,
     /*  339942 */   // Label 6246: @339942
     /*  339942 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(340008), // Rule ID 20877 //
     /*  339947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  339958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  339961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  339964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339986 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340006 */     GIR_RootConstrainSelectedInstOperands,
     /*  340007 */     // GIR_Coverage, 20877,
     /*  340007 */     GIR_EraseRootFromParent_Done,
     /*  340008 */   // Label 6247: @340008
     /*  340008 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(340074), // Rule ID 20880 //
     /*  340013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340072 */     GIR_RootConstrainSelectedInstOperands,
     /*  340073 */     // GIR_Coverage, 20880,
     /*  340073 */     GIR_EraseRootFromParent_Done,
     /*  340074 */   // Label 6248: @340074
     /*  340074 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(340140), // Rule ID 20881 //
     /*  340079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  340090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  340093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  340096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340138 */     GIR_RootConstrainSelectedInstOperands,
     /*  340139 */     // GIR_Coverage, 20881,
     /*  340139 */     GIR_EraseRootFromParent_Done,
     /*  340140 */   // Label 6249: @340140
     /*  340140 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(340206), // Rule ID 20884 //
     /*  340145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  340156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340204 */     GIR_RootConstrainSelectedInstOperands,
     /*  340205 */     // GIR_Coverage, 20884,
     /*  340205 */     GIR_EraseRootFromParent_Done,
     /*  340206 */   // Label 6250: @340206
     /*  340206 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(340272), // Rule ID 20885 //
     /*  340211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  340222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  340225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  340228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340270 */     GIR_RootConstrainSelectedInstOperands,
     /*  340271 */     // GIR_Coverage, 20885,
     /*  340271 */     GIR_EraseRootFromParent_Done,
     /*  340272 */   // Label 6251: @340272
     /*  340272 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(340338), // Rule ID 20888 //
     /*  340277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  340280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  340288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  340316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340336 */     GIR_RootConstrainSelectedInstOperands,
     /*  340337 */     // GIR_Coverage, 20888,
     /*  340337 */     GIR_EraseRootFromParent_Done,
     /*  340338 */   // Label 6252: @340338
     /*  340338 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(340404), // Rule ID 20889 //
     /*  340343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  340346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  340354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  340357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  340360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  340375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  340382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  340385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340402 */     GIR_RootConstrainSelectedInstOperands,
     /*  340403 */     // GIR_Coverage, 20889,
     /*  340403 */     GIR_EraseRootFromParent_Done,
     /*  340404 */   // Label 6253: @340404
     /*  340404 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(340470), // Rule ID 20892 //
     /*  340409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  340420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340468 */     GIR_RootConstrainSelectedInstOperands,
     /*  340469 */     // GIR_Coverage, 20892,
     /*  340469 */     GIR_EraseRootFromParent_Done,
     /*  340470 */   // Label 6254: @340470
     /*  340470 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(340536), // Rule ID 20893 //
     /*  340475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  340486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  340489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  340492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340534 */     GIR_RootConstrainSelectedInstOperands,
     /*  340535 */     // GIR_Coverage, 20893,
     /*  340535 */     GIR_EraseRootFromParent_Done,
     /*  340536 */   // Label 6255: @340536
     /*  340536 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(340602), // Rule ID 20896 //
     /*  340541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  340552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340580 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340600 */     GIR_RootConstrainSelectedInstOperands,
     /*  340601 */     // GIR_Coverage, 20896,
     /*  340601 */     GIR_EraseRootFromParent_Done,
     /*  340602 */   // Label 6256: @340602
     /*  340602 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(340668), // Rule ID 20897 //
     /*  340607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  340618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340646 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340666 */     GIR_RootConstrainSelectedInstOperands,
     /*  340667 */     // GIR_Coverage, 20897,
     /*  340667 */     GIR_EraseRootFromParent_Done,
     /*  340668 */   // Label 6257: @340668
     /*  340668 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(340734), // Rule ID 20900 //
     /*  340673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  340684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  340715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340732 */     GIR_RootConstrainSelectedInstOperands,
     /*  340733 */     // GIR_Coverage, 20900,
     /*  340733 */     GIR_EraseRootFromParent_Done,
     /*  340734 */   // Label 6258: @340734
     /*  340734 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(340800), // Rule ID 20901 //
     /*  340739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  340750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340778 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  340781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340798 */     GIR_RootConstrainSelectedInstOperands,
     /*  340799 */     // GIR_Coverage, 20901,
     /*  340799 */     GIR_EraseRootFromParent_Done,
     /*  340800 */   // Label 6259: @340800
     /*  340800 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(340866), // Rule ID 20904 //
     /*  340805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  340816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340864 */     GIR_RootConstrainSelectedInstOperands,
     /*  340865 */     // GIR_Coverage, 20904,
     /*  340865 */     GIR_EraseRootFromParent_Done,
     /*  340866 */   // Label 6260: @340866
     /*  340866 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(340932), // Rule ID 20905 //
     /*  340871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  340882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340930 */     GIR_RootConstrainSelectedInstOperands,
     /*  340931 */     // GIR_Coverage, 20905,
     /*  340931 */     GIR_EraseRootFromParent_Done,
     /*  340932 */   // Label 6261: @340932
     /*  340932 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(340998), // Rule ID 20908 //
     /*  340937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  340948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  340951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  340954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340996 */     GIR_RootConstrainSelectedInstOperands,
     /*  340997 */     // GIR_Coverage, 20908,
     /*  340997 */     GIR_EraseRootFromParent_Done,
     /*  340998 */   // Label 6262: @340998
     /*  340998 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(341064), // Rule ID 20909 //
     /*  341003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  341014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  341017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  341020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341042 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341062 */     GIR_RootConstrainSelectedInstOperands,
     /*  341063 */     // GIR_Coverage, 20909,
     /*  341063 */     GIR_EraseRootFromParent_Done,
     /*  341064 */   // Label 6263: @341064
     /*  341064 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(341130), // Rule ID 20912 //
     /*  341069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  341080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341128 */     GIR_RootConstrainSelectedInstOperands,
     /*  341129 */     // GIR_Coverage, 20912,
     /*  341129 */     GIR_EraseRootFromParent_Done,
     /*  341130 */   // Label 6264: @341130
     /*  341130 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(341196), // Rule ID 20913 //
     /*  341135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  341146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  341149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  341152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341194 */     GIR_RootConstrainSelectedInstOperands,
     /*  341195 */     // GIR_Coverage, 20913,
     /*  341195 */     GIR_EraseRootFromParent_Done,
     /*  341196 */   // Label 6265: @341196
     /*  341196 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(341262), // Rule ID 20916 //
     /*  341201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  341212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341260 */     GIR_RootConstrainSelectedInstOperands,
     /*  341261 */     // GIR_Coverage, 20916,
     /*  341261 */     GIR_EraseRootFromParent_Done,
     /*  341262 */   // Label 6266: @341262
     /*  341262 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(341328), // Rule ID 20917 //
     /*  341267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  341278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  341281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  341284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  341309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341326 */     GIR_RootConstrainSelectedInstOperands,
     /*  341327 */     // GIR_Coverage, 20917,
     /*  341327 */     GIR_EraseRootFromParent_Done,
     /*  341328 */   // Label 6267: @341328
     /*  341328 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(341394), // Rule ID 20920 //
     /*  341333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  341344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341372 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341392 */     GIR_RootConstrainSelectedInstOperands,
     /*  341393 */     // GIR_Coverage, 20920,
     /*  341393 */     GIR_EraseRootFromParent_Done,
     /*  341394 */   // Label 6268: @341394
     /*  341394 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(341460), // Rule ID 20921 //
     /*  341399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  341410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  341413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  341416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  341431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341438 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  341441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341458 */     GIR_RootConstrainSelectedInstOperands,
     /*  341459 */     // GIR_Coverage, 20921,
     /*  341459 */     GIR_EraseRootFromParent_Done,
     /*  341460 */   // Label 6269: @341460
     /*  341460 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(341526), // Rule ID 20924 //
     /*  341465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  341476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341504 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341524 */     GIR_RootConstrainSelectedInstOperands,
     /*  341525 */     // GIR_Coverage, 20924,
     /*  341525 */     GIR_EraseRootFromParent_Done,
     /*  341526 */   // Label 6270: @341526
     /*  341526 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(341592), // Rule ID 20925 //
     /*  341531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  341542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341590 */     GIR_RootConstrainSelectedInstOperands,
     /*  341591 */     // GIR_Coverage, 20925,
     /*  341591 */     GIR_EraseRootFromParent_Done,
     /*  341592 */   // Label 6271: @341592
     /*  341592 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(341658), // Rule ID 20928 //
     /*  341597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  341608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  341611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  341614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341636 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  341639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341656 */     GIR_RootConstrainSelectedInstOperands,
     /*  341657 */     // GIR_Coverage, 20928,
     /*  341657 */     GIR_EraseRootFromParent_Done,
     /*  341658 */   // Label 6272: @341658
     /*  341658 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(341724), // Rule ID 20929 //
     /*  341663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  341674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  341677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  341680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341702 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  341705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341722 */     GIR_RootConstrainSelectedInstOperands,
     /*  341723 */     // GIR_Coverage, 20929,
     /*  341723 */     GIR_EraseRootFromParent_Done,
     /*  341724 */   // Label 6273: @341724
     /*  341724 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(341790), // Rule ID 20932 //
     /*  341729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341788 */     GIR_RootConstrainSelectedInstOperands,
     /*  341789 */     // GIR_Coverage, 20932,
     /*  341789 */     GIR_EraseRootFromParent_Done,
     /*  341790 */   // Label 6274: @341790
     /*  341790 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(341856), // Rule ID 20933 //
     /*  341795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341834 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341854 */     GIR_RootConstrainSelectedInstOperands,
     /*  341855 */     // GIR_Coverage, 20933,
     /*  341855 */     GIR_EraseRootFromParent_Done,
     /*  341856 */   // Label 6275: @341856
     /*  341856 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(341922), // Rule ID 20936 //
     /*  341861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341900 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341920 */     GIR_RootConstrainSelectedInstOperands,
     /*  341921 */     // GIR_Coverage, 20936,
     /*  341921 */     GIR_EraseRootFromParent_Done,
     /*  341922 */   // Label 6276: @341922
     /*  341922 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(341988), // Rule ID 20937 //
     /*  341927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341966 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341986 */     GIR_RootConstrainSelectedInstOperands,
     /*  341987 */     // GIR_Coverage, 20937,
     /*  341987 */     GIR_EraseRootFromParent_Done,
     /*  341988 */   // Label 6277: @341988
     /*  341988 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(342054), // Rule ID 20940 //
     /*  341993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  342004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  342007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  342010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342052 */     GIR_RootConstrainSelectedInstOperands,
     /*  342053 */     // GIR_Coverage, 20940,
     /*  342053 */     GIR_EraseRootFromParent_Done,
     /*  342054 */   // Label 6278: @342054
     /*  342054 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(342120), // Rule ID 20941 //
     /*  342059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  342070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  342073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  342076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342118 */     GIR_RootConstrainSelectedInstOperands,
     /*  342119 */     // GIR_Coverage, 20941,
     /*  342119 */     GIR_EraseRootFromParent_Done,
     /*  342120 */   // Label 6279: @342120
     /*  342120 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(342186), // Rule ID 20944 //
     /*  342125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342184 */     GIR_RootConstrainSelectedInstOperands,
     /*  342185 */     // GIR_Coverage, 20944,
     /*  342185 */     GIR_EraseRootFromParent_Done,
     /*  342186 */   // Label 6280: @342186
     /*  342186 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(342252), // Rule ID 20945 //
     /*  342191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  342202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  342205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  342208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342250 */     GIR_RootConstrainSelectedInstOperands,
     /*  342251 */     // GIR_Coverage, 20945,
     /*  342251 */     GIR_EraseRootFromParent_Done,
     /*  342252 */   // Label 6281: @342252
     /*  342252 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(342318), // Rule ID 20948 //
     /*  342257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  342260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342296 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342316 */     GIR_RootConstrainSelectedInstOperands,
     /*  342317 */     // GIR_Coverage, 20948,
     /*  342317 */     GIR_EraseRootFromParent_Done,
     /*  342318 */   // Label 6282: @342318
     /*  342318 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(342384), // Rule ID 20949 //
     /*  342323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  342334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  342337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  342340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  342355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  342365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342382 */     GIR_RootConstrainSelectedInstOperands,
     /*  342383 */     // GIR_Coverage, 20949,
     /*  342383 */     GIR_EraseRootFromParent_Done,
     /*  342384 */   // Label 6283: @342384
     /*  342384 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(342450), // Rule ID 20952 //
     /*  342389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342428 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342448 */     GIR_RootConstrainSelectedInstOperands,
     /*  342449 */     // GIR_Coverage, 20952,
     /*  342449 */     GIR_EraseRootFromParent_Done,
     /*  342450 */   // Label 6284: @342450
     /*  342450 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(342516), // Rule ID 20953 //
     /*  342455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  342466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  342469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  342472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342514 */     GIR_RootConstrainSelectedInstOperands,
     /*  342515 */     // GIR_Coverage, 20953,
     /*  342515 */     GIR_EraseRootFromParent_Done,
     /*  342516 */   // Label 6285: @342516
     /*  342516 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(342582), // Rule ID 20956 //
     /*  342521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342580 */     GIR_RootConstrainSelectedInstOperands,
     /*  342581 */     // GIR_Coverage, 20956,
     /*  342581 */     GIR_EraseRootFromParent_Done,
     /*  342582 */   // Label 6286: @342582
     /*  342582 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(342648), // Rule ID 20957 //
     /*  342587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342646 */     GIR_RootConstrainSelectedInstOperands,
     /*  342647 */     // GIR_Coverage, 20957,
     /*  342647 */     GIR_EraseRootFromParent_Done,
     /*  342648 */   // Label 6287: @342648
     /*  342648 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(342714), // Rule ID 20960 //
     /*  342653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  342695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342712 */     GIR_RootConstrainSelectedInstOperands,
     /*  342713 */     // GIR_Coverage, 20960,
     /*  342713 */     GIR_EraseRootFromParent_Done,
     /*  342714 */   // Label 6288: @342714
     /*  342714 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(342780), // Rule ID 20961 //
     /*  342719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342758 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  342761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342778 */     GIR_RootConstrainSelectedInstOperands,
     /*  342779 */     // GIR_Coverage, 20961,
     /*  342779 */     GIR_EraseRootFromParent_Done,
     /*  342780 */   // Label 6289: @342780
     /*  342780 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(342846), // Rule ID 20964 //
     /*  342785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342844 */     GIR_RootConstrainSelectedInstOperands,
     /*  342845 */     // GIR_Coverage, 20964,
     /*  342845 */     GIR_EraseRootFromParent_Done,
     /*  342846 */   // Label 6290: @342846
     /*  342846 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(342912), // Rule ID 20965 //
     /*  342851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342910 */     GIR_RootConstrainSelectedInstOperands,
     /*  342911 */     // GIR_Coverage, 20965,
     /*  342911 */     GIR_EraseRootFromParent_Done,
     /*  342912 */   // Label 6291: @342912
     /*  342912 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(342978), // Rule ID 20968 //
     /*  342917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342976 */     GIR_RootConstrainSelectedInstOperands,
     /*  342977 */     // GIR_Coverage, 20968,
     /*  342977 */     GIR_EraseRootFromParent_Done,
     /*  342978 */   // Label 6292: @342978
     /*  342978 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(343044), // Rule ID 20969 //
     /*  342983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  343000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343042 */     GIR_RootConstrainSelectedInstOperands,
     /*  343043 */     // GIR_Coverage, 20969,
     /*  343043 */     GIR_EraseRootFromParent_Done,
     /*  343044 */   // Label 6293: @343044
     /*  343044 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(343110), // Rule ID 20972 //
     /*  343049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  343052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343088 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343108 */     GIR_RootConstrainSelectedInstOperands,
     /*  343109 */     // GIR_Coverage, 20972,
     /*  343109 */     GIR_EraseRootFromParent_Done,
     /*  343110 */   // Label 6294: @343110
     /*  343110 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(343176), // Rule ID 20973 //
     /*  343115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  343118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  343132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343174 */     GIR_RootConstrainSelectedInstOperands,
     /*  343175 */     // GIR_Coverage, 20973,
     /*  343175 */     GIR_EraseRootFromParent_Done,
     /*  343176 */   // Label 6295: @343176
     /*  343176 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(343242), // Rule ID 20976 //
     /*  343181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343220 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343240 */     GIR_RootConstrainSelectedInstOperands,
     /*  343241 */     // GIR_Coverage, 20976,
     /*  343241 */     GIR_EraseRootFromParent_Done,
     /*  343242 */   // Label 6296: @343242
     /*  343242 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(343308), // Rule ID 20977 //
     /*  343247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  343264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  343289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343306 */     GIR_RootConstrainSelectedInstOperands,
     /*  343307 */     // GIR_Coverage, 20977,
     /*  343307 */     GIR_EraseRootFromParent_Done,
     /*  343308 */   // Label 6297: @343308
     /*  343308 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(343374), // Rule ID 20980 //
     /*  343313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343372 */     GIR_RootConstrainSelectedInstOperands,
     /*  343373 */     // GIR_Coverage, 20980,
     /*  343373 */     GIR_EraseRootFromParent_Done,
     /*  343374 */   // Label 6298: @343374
     /*  343374 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(343440), // Rule ID 20981 //
     /*  343379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  343390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  343393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  343396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  343421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343438 */     GIR_RootConstrainSelectedInstOperands,
     /*  343439 */     // GIR_Coverage, 20981,
     /*  343439 */     GIR_EraseRootFromParent_Done,
     /*  343440 */   // Label 6299: @343440
     /*  343440 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(343506), // Rule ID 20984 //
     /*  343445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  343448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  343484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343504 */     GIR_RootConstrainSelectedInstOperands,
     /*  343505 */     // GIR_Coverage, 20984,
     /*  343505 */     GIR_EraseRootFromParent_Done,
     /*  343506 */   // Label 6300: @343506
     /*  343506 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(343572), // Rule ID 20985 //
     /*  343511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343550 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343570 */     GIR_RootConstrainSelectedInstOperands,
     /*  343571 */     // GIR_Coverage, 20985,
     /*  343571 */     GIR_EraseRootFromParent_Done,
     /*  343572 */   // Label 6301: @343572
     /*  343572 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(343638), // Rule ID 21252 //
     /*  343577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343616 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  343619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343636 */     GIR_RootConstrainSelectedInstOperands,
     /*  343637 */     // GIR_Coverage, 21252,
     /*  343637 */     GIR_EraseRootFromParent_Done,
     /*  343638 */   // Label 6302: @343638
     /*  343638 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(343704), // Rule ID 21253 //
     /*  343643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343682 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  343685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343702 */     GIR_RootConstrainSelectedInstOperands,
     /*  343703 */     // GIR_Coverage, 21253,
     /*  343703 */     GIR_EraseRootFromParent_Done,
     /*  343704 */   // Label 6303: @343704
     /*  343704 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(343770), // Rule ID 21256 //
     /*  343709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  343720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  343723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343748 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  343751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343768 */     GIR_RootConstrainSelectedInstOperands,
     /*  343769 */     // GIR_Coverage, 21256,
     /*  343769 */     GIR_EraseRootFromParent_Done,
     /*  343770 */   // Label 6304: @343770
     /*  343770 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(343836), // Rule ID 21257 //
     /*  343775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  343786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  343789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11291:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  343817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343834 */     GIR_RootConstrainSelectedInstOperands,
     /*  343835 */     // GIR_Coverage, 21257,
     /*  343835 */     GIR_EraseRootFromParent_Done,
     /*  343836 */   // Label 6305: @343836
     /*  343836 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(343902), // Rule ID 21260 //
     /*  343841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  343883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343900 */     GIR_RootConstrainSelectedInstOperands,
     /*  343901 */     // GIR_Coverage, 21260,
     /*  343901 */     GIR_EraseRootFromParent_Done,
     /*  343902 */   // Label 6306: @343902
     /*  343902 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(343968), // Rule ID 21261 //
     /*  343907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  343949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343966 */     GIR_RootConstrainSelectedInstOperands,
     /*  343967 */     // GIR_Coverage, 21261,
     /*  343967 */     GIR_EraseRootFromParent_Done,
     /*  343968 */   // Label 6307: @343968
     /*  343968 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(344034), // Rule ID 21264 //
     /*  343973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  343984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  343987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  343990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344012 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344032 */     GIR_RootConstrainSelectedInstOperands,
     /*  344033 */     // GIR_Coverage, 21264,
     /*  344033 */     GIR_EraseRootFromParent_Done,
     /*  344034 */   // Label 6308: @344034
     /*  344034 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(344100), // Rule ID 21265 //
     /*  344039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344078 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344098 */     GIR_RootConstrainSelectedInstOperands,
     /*  344099 */     // GIR_Coverage, 21265,
     /*  344099 */     GIR_EraseRootFromParent_Done,
     /*  344100 */   // Label 6309: @344100
     /*  344100 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(344166), // Rule ID 21268 //
     /*  344105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344144 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344164 */     GIR_RootConstrainSelectedInstOperands,
     /*  344165 */     // GIR_Coverage, 21268,
     /*  344165 */     GIR_EraseRootFromParent_Done,
     /*  344166 */   // Label 6310: @344166
     /*  344166 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(344232), // Rule ID 21269 //
     /*  344171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344230 */     GIR_RootConstrainSelectedInstOperands,
     /*  344231 */     // GIR_Coverage, 21269,
     /*  344231 */     GIR_EraseRootFromParent_Done,
     /*  344232 */   // Label 6311: @344232
     /*  344232 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(344298), // Rule ID 21272 //
     /*  344237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344296 */     GIR_RootConstrainSelectedInstOperands,
     /*  344297 */     // GIR_Coverage, 21272,
     /*  344297 */     GIR_EraseRootFromParent_Done,
     /*  344298 */   // Label 6312: @344298
     /*  344298 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(344364), // Rule ID 21273 //
     /*  344303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344342 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11291:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  344345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344362 */     GIR_RootConstrainSelectedInstOperands,
     /*  344363 */     // GIR_Coverage, 21273,
     /*  344363 */     GIR_EraseRootFromParent_Done,
     /*  344364 */   // Label 6313: @344364
     /*  344364 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(344430), // Rule ID 21276 //
     /*  344369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  344380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  344383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344428 */     GIR_RootConstrainSelectedInstOperands,
     /*  344429 */     // GIR_Coverage, 21276,
     /*  344429 */     GIR_EraseRootFromParent_Done,
     /*  344430 */   // Label 6314: @344430
     /*  344430 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(344496), // Rule ID 21277 //
     /*  344435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  344446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  344449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  344452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11291:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  344477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344494 */     GIR_RootConstrainSelectedInstOperands,
     /*  344495 */     // GIR_Coverage, 21277,
     /*  344495 */     GIR_EraseRootFromParent_Done,
     /*  344496 */   // Label 6315: @344496
     /*  344496 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(344562), // Rule ID 21280 //
     /*  344501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  344512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  344515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344560 */     GIR_RootConstrainSelectedInstOperands,
     /*  344561 */     // GIR_Coverage, 21280,
     /*  344561 */     GIR_EraseRootFromParent_Done,
     /*  344562 */   // Label 6316: @344562
     /*  344562 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(344628), // Rule ID 21281 //
     /*  344567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  344578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  344581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344606 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11291:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344626 */     GIR_RootConstrainSelectedInstOperands,
     /*  344627 */     // GIR_Coverage, 21281,
     /*  344627 */     GIR_EraseRootFromParent_Done,
     /*  344628 */   // Label 6317: @344628
     /*  344628 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(344694), // Rule ID 21284 //
     /*  344633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  344644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  344647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344672 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344692 */     GIR_RootConstrainSelectedInstOperands,
     /*  344693 */     // GIR_Coverage, 21284,
     /*  344693 */     GIR_EraseRootFromParent_Done,
     /*  344694 */   // Label 6318: @344694
     /*  344694 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(344760), // Rule ID 21285 //
     /*  344699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  344710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  344713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11291:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344758 */     GIR_RootConstrainSelectedInstOperands,
     /*  344759 */     // GIR_Coverage, 21285,
     /*  344759 */     GIR_EraseRootFromParent_Done,
     /*  344760 */   // Label 6319: @344760
     /*  344760 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(344826), // Rule ID 21288 //
     /*  344765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344804 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  344807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344824 */     GIR_RootConstrainSelectedInstOperands,
     /*  344825 */     // GIR_Coverage, 21288,
     /*  344825 */     GIR_EraseRootFromParent_Done,
     /*  344826 */   // Label 6320: @344826
     /*  344826 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(344892), // Rule ID 21289 //
     /*  344831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  344873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344890 */     GIR_RootConstrainSelectedInstOperands,
     /*  344891 */     // GIR_Coverage, 21289,
     /*  344891 */     GIR_EraseRootFromParent_Done,
     /*  344892 */   // Label 6321: @344892
     /*  344892 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(344958), // Rule ID 21292 //
     /*  344897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  344939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344956 */     GIR_RootConstrainSelectedInstOperands,
     /*  344957 */     // GIR_Coverage, 21292,
     /*  344957 */     GIR_EraseRootFromParent_Done,
     /*  344958 */   // Label 6322: @344958
     /*  344958 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(345024), // Rule ID 21293 //
     /*  344963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11289:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345022 */     GIR_RootConstrainSelectedInstOperands,
     /*  345023 */     // GIR_Coverage, 21293,
     /*  345023 */     GIR_EraseRootFromParent_Done,
     /*  345024 */   // Label 6323: @345024
     /*  345024 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(345090), // Rule ID 21296 //
     /*  345029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  345040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  345043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345088 */     GIR_RootConstrainSelectedInstOperands,
     /*  345089 */     // GIR_Coverage, 21296,
     /*  345089 */     GIR_EraseRootFromParent_Done,
     /*  345090 */   // Label 6324: @345090
     /*  345090 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(345156), // Rule ID 21297 //
     /*  345095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  345106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  345109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  345112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345154 */     GIR_RootConstrainSelectedInstOperands,
     /*  345155 */     // GIR_Coverage, 21297,
     /*  345155 */     GIR_EraseRootFromParent_Done,
     /*  345156 */   // Label 6325: @345156
     /*  345156 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(345222), // Rule ID 21300 //
     /*  345161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  345172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  345175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345200 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345220 */     GIR_RootConstrainSelectedInstOperands,
     /*  345221 */     // GIR_Coverage, 21300,
     /*  345221 */     GIR_EraseRootFromParent_Done,
     /*  345222 */   // Label 6326: @345222
     /*  345222 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(345288), // Rule ID 21301 //
     /*  345227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  345238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  345241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  345244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345286 */     GIR_RootConstrainSelectedInstOperands,
     /*  345287 */     // GIR_Coverage, 21301,
     /*  345287 */     GIR_EraseRootFromParent_Done,
     /*  345288 */   // Label 6327: @345288
     /*  345288 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(345354), // Rule ID 21304 //
     /*  345293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  345304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  345307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345332 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  345332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345352 */     GIR_RootConstrainSelectedInstOperands,
     /*  345353 */     // GIR_Coverage, 21304,
     /*  345353 */     GIR_EraseRootFromParent_Done,
     /*  345354 */   // Label 6328: @345354
     /*  345354 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(345420), // Rule ID 21305 //
     /*  345359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  345370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  345373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  345376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  345398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  345415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345418 */     GIR_RootConstrainSelectedInstOperands,
     /*  345419 */     // GIR_Coverage, 21305,
     /*  345419 */     GIR_EraseRootFromParent_Done,
     /*  345420 */   // Label 6329: @345420
     /*  345420 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(345486), // Rule ID 21308 //
     /*  345425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  345436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  345439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345484 */     GIR_RootConstrainSelectedInstOperands,
     /*  345485 */     // GIR_Coverage, 21308,
     /*  345485 */     GIR_EraseRootFromParent_Done,
     /*  345486 */   // Label 6330: @345486
     /*  345486 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(345552), // Rule ID 21309 //
     /*  345491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  345502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  345505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11289:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345550 */     GIR_RootConstrainSelectedInstOperands,
     /*  345551 */     // GIR_Coverage, 21309,
     /*  345551 */     GIR_EraseRootFromParent_Done,
     /*  345552 */   // Label 6331: @345552
     /*  345552 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(345618), // Rule ID 21312 //
     /*  345557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  345574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345596 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345616 */     GIR_RootConstrainSelectedInstOperands,
     /*  345617 */     // GIR_Coverage, 21312,
     /*  345617 */     GIR_EraseRootFromParent_Done,
     /*  345618 */   // Label 6332: @345618
     /*  345618 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(345684), // Rule ID 21313 //
     /*  345623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  345640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11289:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345682 */     GIR_RootConstrainSelectedInstOperands,
     /*  345683 */     // GIR_Coverage, 21313,
     /*  345683 */     GIR_EraseRootFromParent_Done,
     /*  345684 */   // Label 6333: @345684
     /*  345684 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(345750), // Rule ID 21316 //
     /*  345689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  345706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345728 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345748 */     GIR_RootConstrainSelectedInstOperands,
     /*  345749 */     // GIR_Coverage, 21316,
     /*  345749 */     GIR_EraseRootFromParent_Done,
     /*  345750 */   // Label 6334: @345750
     /*  345750 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(345816), // Rule ID 21317 //
     /*  345755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  345772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11289:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345814 */     GIR_RootConstrainSelectedInstOperands,
     /*  345815 */     // GIR_Coverage, 21317,
     /*  345815 */     GIR_EraseRootFromParent_Done,
     /*  345816 */   // Label 6335: @345816
     /*  345816 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(345882), // Rule ID 21320 //
     /*  345821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345860 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345880 */     GIR_RootConstrainSelectedInstOperands,
     /*  345881 */     // GIR_Coverage, 21320,
     /*  345881 */     GIR_EraseRootFromParent_Done,
     /*  345882 */   // Label 6336: @345882
     /*  345882 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(345948), // Rule ID 21321 //
     /*  345887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11289:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345946 */     GIR_RootConstrainSelectedInstOperands,
     /*  345947 */     // GIR_Coverage, 21321,
     /*  345947 */     GIR_EraseRootFromParent_Done,
     /*  345948 */   // Label 6337: @345948
     /*  345948 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(346014), // Rule ID 21324 //
     /*  345953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  345964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  345967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  345970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345992 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  345992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  345995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346012 */     GIR_RootConstrainSelectedInstOperands,
     /*  346013 */     // GIR_Coverage, 21324,
     /*  346013 */     GIR_EraseRootFromParent_Done,
     /*  346014 */   // Label 6338: @346014
     /*  346014 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(346080), // Rule ID 21325 //
     /*  346019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  346030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  346033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  346036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346058 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  346061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346078 */     GIR_RootConstrainSelectedInstOperands,
     /*  346079 */     // GIR_Coverage, 21325,
     /*  346079 */     GIR_EraseRootFromParent_Done,
     /*  346080 */   // Label 6339: @346080
     /*  346080 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(346146), // Rule ID 21328 //
     /*  346085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  346096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  346099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  346102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346124 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  346127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346144 */     GIR_RootConstrainSelectedInstOperands,
     /*  346145 */     // GIR_Coverage, 21328,
     /*  346145 */     GIR_EraseRootFromParent_Done,
     /*  346146 */   // Label 6340: @346146
     /*  346146 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(346212), // Rule ID 21329 //
     /*  346151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  346162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  346165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  346168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346190 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  346193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346210 */     GIR_RootConstrainSelectedInstOperands,
     /*  346211 */     // GIR_Coverage, 21329,
     /*  346211 */     GIR_EraseRootFromParent_Done,
     /*  346212 */   // Label 6341: @346212
     /*  346212 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(346278), // Rule ID 21332 //
     /*  346217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  346228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  346231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  346234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346256 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  346259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346276 */     GIR_RootConstrainSelectedInstOperands,
     /*  346277 */     // GIR_Coverage, 21332,
     /*  346277 */     GIR_EraseRootFromParent_Done,
     /*  346278 */   // Label 6342: @346278
     /*  346278 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(346344), // Rule ID 21333 //
     /*  346283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  346294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  346297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  346300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346322 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11287:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  346325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346342 */     GIR_RootConstrainSelectedInstOperands,
     /*  346343 */     // GIR_Coverage, 21333,
     /*  346343 */     GIR_EraseRootFromParent_Done,
     /*  346344 */   // Label 6343: @346344
     /*  346344 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(346410), // Rule ID 21336 //
     /*  346349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  346366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346388 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  346391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346408 */     GIR_RootConstrainSelectedInstOperands,
     /*  346409 */     // GIR_Coverage, 21336,
     /*  346409 */     GIR_EraseRootFromParent_Done,
     /*  346410 */   // Label 6344: @346410
     /*  346410 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(346476), // Rule ID 21337 //
     /*  346415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  346426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  346429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  346432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346454 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  346457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346474 */     GIR_RootConstrainSelectedInstOperands,
     /*  346475 */     // GIR_Coverage, 21337,
     /*  346475 */     GIR_EraseRootFromParent_Done,
     /*  346476 */   // Label 6345: @346476
     /*  346476 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(346542), // Rule ID 21340 //
     /*  346481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  346498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346520 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  346523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346540 */     GIR_RootConstrainSelectedInstOperands,
     /*  346541 */     // GIR_Coverage, 21340,
     /*  346541 */     GIR_EraseRootFromParent_Done,
     /*  346542 */   // Label 6346: @346542
     /*  346542 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(346608), // Rule ID 21341 //
     /*  346547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  346564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346586 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  346589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346606 */     GIR_RootConstrainSelectedInstOperands,
     /*  346607 */     // GIR_Coverage, 21341,
     /*  346607 */     GIR_EraseRootFromParent_Done,
     /*  346608 */   // Label 6347: @346608
     /*  346608 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(346674), // Rule ID 21344 //
     /*  346613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  346630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346652 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  346655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346672 */     GIR_RootConstrainSelectedInstOperands,
     /*  346673 */     // GIR_Coverage, 21344,
     /*  346673 */     GIR_EraseRootFromParent_Done,
     /*  346674 */   // Label 6348: @346674
     /*  346674 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(346740), // Rule ID 21345 //
     /*  346679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  346696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346718 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  346721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346738 */     GIR_RootConstrainSelectedInstOperands,
     /*  346739 */     // GIR_Coverage, 21345,
     /*  346739 */     GIR_EraseRootFromParent_Done,
     /*  346740 */   // Label 6349: @346740
     /*  346740 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(346806), // Rule ID 21348 //
     /*  346745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  346756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  346759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  346762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346784 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  346787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346804 */     GIR_RootConstrainSelectedInstOperands,
     /*  346805 */     // GIR_Coverage, 21348,
     /*  346805 */     GIR_EraseRootFromParent_Done,
     /*  346806 */   // Label 6350: @346806
     /*  346806 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(346872), // Rule ID 21349 //
     /*  346811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  346822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  346825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  346828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346850 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  346853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346870 */     GIR_RootConstrainSelectedInstOperands,
     /*  346871 */     // GIR_Coverage, 21349,
     /*  346871 */     GIR_EraseRootFromParent_Done,
     /*  346872 */   // Label 6351: @346872
     /*  346872 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(346938), // Rule ID 21352 //
     /*  346877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  346888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  346891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  346894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346916 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  346919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346936 */     GIR_RootConstrainSelectedInstOperands,
     /*  346937 */     // GIR_Coverage, 21352,
     /*  346937 */     GIR_EraseRootFromParent_Done,
     /*  346938 */   // Label 6352: @346938
     /*  346938 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(347004), // Rule ID 21353 //
     /*  346943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  346954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  346957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  346960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346982 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11287:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  346985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347002 */     GIR_RootConstrainSelectedInstOperands,
     /*  347003 */     // GIR_Coverage, 21353,
     /*  347003 */     GIR_EraseRootFromParent_Done,
     /*  347004 */   // Label 6353: @347004
     /*  347004 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(347070), // Rule ID 21356 //
     /*  347009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347048 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  347051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347068 */     GIR_RootConstrainSelectedInstOperands,
     /*  347069 */     // GIR_Coverage, 21356,
     /*  347069 */     GIR_EraseRootFromParent_Done,
     /*  347070 */   // Label 6354: @347070
     /*  347070 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(347136), // Rule ID 21357 //
     /*  347075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  347086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  347089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  347092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347114 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  347117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347134 */     GIR_RootConstrainSelectedInstOperands,
     /*  347135 */     // GIR_Coverage, 21357,
     /*  347135 */     GIR_EraseRootFromParent_Done,
     /*  347136 */   // Label 6355: @347136
     /*  347136 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(347202), // Rule ID 21360 //
     /*  347141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347180 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  347183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347200 */     GIR_RootConstrainSelectedInstOperands,
     /*  347201 */     // GIR_Coverage, 21360,
     /*  347201 */     GIR_EraseRootFromParent_Done,
     /*  347202 */   // Label 6356: @347202
     /*  347202 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(347268), // Rule ID 21361 //
     /*  347207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  347218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  347221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  347224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347246 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  347249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347266 */     GIR_RootConstrainSelectedInstOperands,
     /*  347267 */     // GIR_Coverage, 21361,
     /*  347267 */     GIR_EraseRootFromParent_Done,
     /*  347268 */   // Label 6357: @347268
     /*  347268 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(347334), // Rule ID 21364 //
     /*  347273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  347276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  347312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  347315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347332 */     GIR_RootConstrainSelectedInstOperands,
     /*  347333 */     // GIR_Coverage, 21364,
     /*  347333 */     GIR_EraseRootFromParent_Done,
     /*  347334 */   // Label 6358: @347334
     /*  347334 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(347400), // Rule ID 21365 //
     /*  347339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  347342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  347350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  347353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  347356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347378 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  347378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  347381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  347395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347398 */     GIR_RootConstrainSelectedInstOperands,
     /*  347399 */     // GIR_Coverage, 21365,
     /*  347399 */     GIR_EraseRootFromParent_Done,
     /*  347400 */   // Label 6359: @347400
     /*  347400 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(347466), // Rule ID 21368 //
     /*  347405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  347416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  347419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  347422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347444 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  347447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347464 */     GIR_RootConstrainSelectedInstOperands,
     /*  347465 */     // GIR_Coverage, 21368,
     /*  347465 */     GIR_EraseRootFromParent_Done,
     /*  347466 */   // Label 6360: @347466
     /*  347466 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(347532), // Rule ID 21369 //
     /*  347471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  347482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  347485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  347488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347510 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11287:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  347513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347530 */     GIR_RootConstrainSelectedInstOperands,
     /*  347531 */     // GIR_Coverage, 21369,
     /*  347531 */     GIR_EraseRootFromParent_Done,
     /*  347532 */   // Label 6361: @347532
     /*  347532 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(347598), // Rule ID 21372 //
     /*  347537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  347554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347576 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  347579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347596 */     GIR_RootConstrainSelectedInstOperands,
     /*  347597 */     // GIR_Coverage, 21372,
     /*  347597 */     GIR_EraseRootFromParent_Done,
     /*  347598 */   // Label 6362: @347598
     /*  347598 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(347664), // Rule ID 21373 //
     /*  347603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  347620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347642 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11287:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  347645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347662 */     GIR_RootConstrainSelectedInstOperands,
     /*  347663 */     // GIR_Coverage, 21373,
     /*  347663 */     GIR_EraseRootFromParent_Done,
     /*  347664 */   // Label 6363: @347664
     /*  347664 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(347730), // Rule ID 21376 //
     /*  347669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  347686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347708 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  347711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347728 */     GIR_RootConstrainSelectedInstOperands,
     /*  347729 */     // GIR_Coverage, 21376,
     /*  347729 */     GIR_EraseRootFromParent_Done,
     /*  347730 */   // Label 6364: @347730
     /*  347730 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(347796), // Rule ID 21377 //
     /*  347735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  347752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347774 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11287:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  347777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347794 */     GIR_RootConstrainSelectedInstOperands,
     /*  347795 */     // GIR_Coverage, 21377,
     /*  347795 */     GIR_EraseRootFromParent_Done,
     /*  347796 */   // Label 6365: @347796
     /*  347796 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(347862), // Rule ID 21380 //
     /*  347801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  347818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  347843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347860 */     GIR_RootConstrainSelectedInstOperands,
     /*  347861 */     // GIR_Coverage, 21380,
     /*  347861 */     GIR_EraseRootFromParent_Done,
     /*  347862 */   // Label 6366: @347862
     /*  347862 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(347928), // Rule ID 21381 //
     /*  347867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  347884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347906 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11287:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  347909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347926 */     GIR_RootConstrainSelectedInstOperands,
     /*  347927 */     // GIR_Coverage, 21381,
     /*  347927 */     GIR_EraseRootFromParent_Done,
     /*  347928 */   // Label 6367: @347928
     /*  347928 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(347994), // Rule ID 21384 //
     /*  347933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  347944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  347947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  347950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347972 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  347975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347992 */     GIR_RootConstrainSelectedInstOperands,
     /*  347993 */     // GIR_Coverage, 21384,
     /*  347993 */     GIR_EraseRootFromParent_Done,
     /*  347994 */   // Label 6368: @347994
     /*  347994 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(348060), // Rule ID 21385 //
     /*  347999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  348010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  348013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  348016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348038 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  348041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348058 */     GIR_RootConstrainSelectedInstOperands,
     /*  348059 */     // GIR_Coverage, 21385,
     /*  348059 */     GIR_EraseRootFromParent_Done,
     /*  348060 */   // Label 6369: @348060
     /*  348060 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(348126), // Rule ID 21388 //
     /*  348065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  348076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  348079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  348082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348104 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  348107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348124 */     GIR_RootConstrainSelectedInstOperands,
     /*  348125 */     // GIR_Coverage, 21388,
     /*  348125 */     GIR_EraseRootFromParent_Done,
     /*  348126 */   // Label 6370: @348126
     /*  348126 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(348192), // Rule ID 21389 //
     /*  348131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  348142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  348145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  348148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348170 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  348173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348190 */     GIR_RootConstrainSelectedInstOperands,
     /*  348191 */     // GIR_Coverage, 21389,
     /*  348191 */     GIR_EraseRootFromParent_Done,
     /*  348192 */   // Label 6371: @348192
     /*  348192 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(348258), // Rule ID 21392 //
     /*  348197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  348214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348236 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  348239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348256 */     GIR_RootConstrainSelectedInstOperands,
     /*  348257 */     // GIR_Coverage, 21392,
     /*  348257 */     GIR_EraseRootFromParent_Done,
     /*  348258 */   // Label 6372: @348258
     /*  348258 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(348324), // Rule ID 21393 //
     /*  348263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  348274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  348277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  348280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348302 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11285:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  348305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348322 */     GIR_RootConstrainSelectedInstOperands,
     /*  348323 */     // GIR_Coverage, 21393,
     /*  348323 */     GIR_EraseRootFromParent_Done,
     /*  348324 */   // Label 6373: @348324
     /*  348324 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(348390), // Rule ID 21396 //
     /*  348329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  348340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  348343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348368 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  348371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348388 */     GIR_RootConstrainSelectedInstOperands,
     /*  348389 */     // GIR_Coverage, 21396,
     /*  348389 */     GIR_EraseRootFromParent_Done,
     /*  348390 */   // Label 6374: @348390
     /*  348390 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(348456), // Rule ID 21397 //
     /*  348395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  348406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  348409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  348412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348434 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  348437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348454 */     GIR_RootConstrainSelectedInstOperands,
     /*  348455 */     // GIR_Coverage, 21397,
     /*  348455 */     GIR_EraseRootFromParent_Done,
     /*  348456 */   // Label 6375: @348456
     /*  348456 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(348522), // Rule ID 21400 //
     /*  348461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  348472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  348475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  348478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348500 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  348503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348520 */     GIR_RootConstrainSelectedInstOperands,
     /*  348521 */     // GIR_Coverage, 21400,
     /*  348521 */     GIR_EraseRootFromParent_Done,
     /*  348522 */   // Label 6376: @348522
     /*  348522 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(348588), // Rule ID 21401 //
     /*  348527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  348538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  348541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  348544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348566 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  348569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348586 */     GIR_RootConstrainSelectedInstOperands,
     /*  348587 */     // GIR_Coverage, 21401,
     /*  348587 */     GIR_EraseRootFromParent_Done,
     /*  348588 */   // Label 6377: @348588
     /*  348588 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(348654), // Rule ID 21404 //
     /*  348593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  348604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  348607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  348610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348632 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  348635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348652 */     GIR_RootConstrainSelectedInstOperands,
     /*  348653 */     // GIR_Coverage, 21404,
     /*  348653 */     GIR_EraseRootFromParent_Done,
     /*  348654 */   // Label 6378: @348654
     /*  348654 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(348720), // Rule ID 21405 //
     /*  348659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  348670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  348673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  348676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348698 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  348701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348718 */     GIR_RootConstrainSelectedInstOperands,
     /*  348719 */     // GIR_Coverage, 21405,
     /*  348719 */     GIR_EraseRootFromParent_Done,
     /*  348720 */   // Label 6379: @348720
     /*  348720 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(348786), // Rule ID 21408 //
     /*  348725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348764 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  348767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348784 */     GIR_RootConstrainSelectedInstOperands,
     /*  348785 */     // GIR_Coverage, 21408,
     /*  348785 */     GIR_EraseRootFromParent_Done,
     /*  348786 */   // Label 6380: @348786
     /*  348786 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(348852), // Rule ID 21409 //
     /*  348791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  348794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348830 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  348833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348850 */     GIR_RootConstrainSelectedInstOperands,
     /*  348851 */     // GIR_Coverage, 21409,
     /*  348851 */     GIR_EraseRootFromParent_Done,
     /*  348852 */   // Label 6381: @348852
     /*  348852 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(348918), // Rule ID 21412 //
     /*  348857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348896 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  348899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348916 */     GIR_RootConstrainSelectedInstOperands,
     /*  348917 */     // GIR_Coverage, 21412,
     /*  348917 */     GIR_EraseRootFromParent_Done,
     /*  348918 */   // Label 6382: @348918
     /*  348918 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(348984), // Rule ID 21413 //
     /*  348923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  348926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348962 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11285:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  348965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348982 */     GIR_RootConstrainSelectedInstOperands,
     /*  348983 */     // GIR_Coverage, 21413,
     /*  348983 */     GIR_EraseRootFromParent_Done,
     /*  348984 */   // Label 6383: @348984
     /*  348984 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(349050), // Rule ID 21416 //
     /*  348989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349028 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  349031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349048 */     GIR_RootConstrainSelectedInstOperands,
     /*  349049 */     // GIR_Coverage, 21416,
     /*  349049 */     GIR_EraseRootFromParent_Done,
     /*  349050 */   // Label 6384: @349050
     /*  349050 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(349116), // Rule ID 21417 //
     /*  349055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  349097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349114 */     GIR_RootConstrainSelectedInstOperands,
     /*  349115 */     // GIR_Coverage, 21417,
     /*  349115 */     GIR_EraseRootFromParent_Done,
     /*  349116 */   // Label 6385: @349116
     /*  349116 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(349182), // Rule ID 21420 //
     /*  349121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349160 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  349163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349180 */     GIR_RootConstrainSelectedInstOperands,
     /*  349181 */     // GIR_Coverage, 21420,
     /*  349181 */     GIR_EraseRootFromParent_Done,
     /*  349182 */   // Label 6386: @349182
     /*  349182 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(349248), // Rule ID 21421 //
     /*  349187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349226 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  349229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349246 */     GIR_RootConstrainSelectedInstOperands,
     /*  349247 */     // GIR_Coverage, 21421,
     /*  349247 */     GIR_EraseRootFromParent_Done,
     /*  349248 */   // Label 6387: @349248
     /*  349248 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(349314), // Rule ID 21424 //
     /*  349253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  349256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349292 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  349295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349312 */     GIR_RootConstrainSelectedInstOperands,
     /*  349313 */     // GIR_Coverage, 21424,
     /*  349313 */     GIR_EraseRootFromParent_Done,
     /*  349314 */   // Label 6388: @349314
     /*  349314 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(349380), // Rule ID 21425 //
     /*  349319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  349322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349358 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  349361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349378 */     GIR_RootConstrainSelectedInstOperands,
     /*  349379 */     // GIR_Coverage, 21425,
     /*  349379 */     GIR_EraseRootFromParent_Done,
     /*  349380 */   // Label 6389: @349380
     /*  349380 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(349446), // Rule ID 21428 //
     /*  349385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349424 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  349427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349444 */     GIR_RootConstrainSelectedInstOperands,
     /*  349445 */     // GIR_Coverage, 21428,
     /*  349445 */     GIR_EraseRootFromParent_Done,
     /*  349446 */   // Label 6390: @349446
     /*  349446 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(349512), // Rule ID 21429 //
     /*  349451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  349462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  349465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  349468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11285:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  349493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349510 */     GIR_RootConstrainSelectedInstOperands,
     /*  349511 */     // GIR_Coverage, 21429,
     /*  349511 */     GIR_EraseRootFromParent_Done,
     /*  349512 */   // Label 6391: @349512
     /*  349512 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(349578), // Rule ID 21432 //
     /*  349517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349556 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  349559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349576 */     GIR_RootConstrainSelectedInstOperands,
     /*  349577 */     // GIR_Coverage, 21432,
     /*  349577 */     GIR_EraseRootFromParent_Done,
     /*  349578 */   // Label 6392: @349578
     /*  349578 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(349644), // Rule ID 21433 //
     /*  349583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349622 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11285:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  349625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349642 */     GIR_RootConstrainSelectedInstOperands,
     /*  349643 */     // GIR_Coverage, 21433,
     /*  349643 */     GIR_EraseRootFromParent_Done,
     /*  349644 */   // Label 6393: @349644
     /*  349644 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(349710), // Rule ID 21436 //
     /*  349649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349688 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  349691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349708 */     GIR_RootConstrainSelectedInstOperands,
     /*  349709 */     // GIR_Coverage, 21436,
     /*  349709 */     GIR_EraseRootFromParent_Done,
     /*  349710 */   // Label 6394: @349710
     /*  349710 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(349776), // Rule ID 21437 //
     /*  349715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349754 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11285:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  349757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349774 */     GIR_RootConstrainSelectedInstOperands,
     /*  349775 */     // GIR_Coverage, 21437,
     /*  349775 */     GIR_EraseRootFromParent_Done,
     /*  349776 */   // Label 6395: @349776
     /*  349776 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(349842), // Rule ID 21440 //
     /*  349781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349820 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  349823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349840 */     GIR_RootConstrainSelectedInstOperands,
     /*  349841 */     // GIR_Coverage, 21440,
     /*  349841 */     GIR_EraseRootFromParent_Done,
     /*  349842 */   // Label 6396: @349842
     /*  349842 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(349908), // Rule ID 21441 //
     /*  349847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349886 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11285:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  349889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349906 */     GIR_RootConstrainSelectedInstOperands,
     /*  349907 */     // GIR_Coverage, 21441,
     /*  349907 */     GIR_EraseRootFromParent_Done,
     /*  349908 */   // Label 6397: @349908
     /*  349908 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(349974), // Rule ID 21444 //
     /*  349913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  349916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  349924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  349927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  349930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349952 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  349955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349972 */     GIR_RootConstrainSelectedInstOperands,
     /*  349973 */     // GIR_Coverage, 21444,
     /*  349973 */     GIR_EraseRootFromParent_Done,
     /*  349974 */   // Label 6398: @349974
     /*  349974 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(350040), // Rule ID 21445 //
     /*  349979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  349982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  349990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  349993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  349996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350018 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  350021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350038 */     GIR_RootConstrainSelectedInstOperands,
     /*  350039 */     // GIR_Coverage, 21445,
     /*  350039 */     GIR_EraseRootFromParent_Done,
     /*  350040 */   // Label 6399: @350040
     /*  350040 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(350106), // Rule ID 21448 //
     /*  350045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350084 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  350087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350104 */     GIR_RootConstrainSelectedInstOperands,
     /*  350105 */     // GIR_Coverage, 21448,
     /*  350105 */     GIR_EraseRootFromParent_Done,
     /*  350106 */   // Label 6400: @350106
     /*  350106 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(350172), // Rule ID 21449 //
     /*  350111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  350122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  350125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11283:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  350153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350170 */     GIR_RootConstrainSelectedInstOperands,
     /*  350171 */     // GIR_Coverage, 21449,
     /*  350171 */     GIR_EraseRootFromParent_Done,
     /*  350172 */   // Label 6401: @350172
     /*  350172 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(350238), // Rule ID 21452 //
     /*  350177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350216 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  350219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350236 */     GIR_RootConstrainSelectedInstOperands,
     /*  350237 */     // GIR_Coverage, 21452,
     /*  350237 */     GIR_EraseRootFromParent_Done,
     /*  350238 */   // Label 6402: @350238
     /*  350238 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(350304), // Rule ID 21453 //
     /*  350243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  350254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  350257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350282 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  350285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350302 */     GIR_RootConstrainSelectedInstOperands,
     /*  350303 */     // GIR_Coverage, 21453,
     /*  350303 */     GIR_EraseRootFromParent_Done,
     /*  350304 */   // Label 6403: @350304
     /*  350304 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(350370), // Rule ID 21456 //
     /*  350309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  350326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350348 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  350351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350368 */     GIR_RootConstrainSelectedInstOperands,
     /*  350369 */     // GIR_Coverage, 21456,
     /*  350369 */     GIR_EraseRootFromParent_Done,
     /*  350370 */   // Label 6404: @350370
     /*  350370 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(350436), // Rule ID 21457 //
     /*  350375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  350386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  350389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  350392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350414 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  350417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350434 */     GIR_RootConstrainSelectedInstOperands,
     /*  350435 */     // GIR_Coverage, 21457,
     /*  350435 */     GIR_EraseRootFromParent_Done,
     /*  350436 */   // Label 6405: @350436
     /*  350436 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(350502), // Rule ID 21460 //
     /*  350441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  350444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  350458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350480 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  350480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  350483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350500 */     GIR_RootConstrainSelectedInstOperands,
     /*  350501 */     // GIR_Coverage, 21460,
     /*  350501 */     GIR_EraseRootFromParent_Done,
     /*  350502 */   // Label 6406: @350502
     /*  350502 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(350568), // Rule ID 21461 //
     /*  350507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  350510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  350524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350546 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  350549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350566 */     GIR_RootConstrainSelectedInstOperands,
     /*  350567 */     // GIR_Coverage, 21461,
     /*  350567 */     GIR_EraseRootFromParent_Done,
     /*  350568 */   // Label 6407: @350568
     /*  350568 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(350634), // Rule ID 21464 //
     /*  350573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  350584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  350587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  350590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350612 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  350615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350632 */     GIR_RootConstrainSelectedInstOperands,
     /*  350633 */     // GIR_Coverage, 21464,
     /*  350633 */     GIR_EraseRootFromParent_Done,
     /*  350634 */   // Label 6408: @350634
     /*  350634 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(350700), // Rule ID 21465 //
     /*  350639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  350650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  350653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  350656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350678 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11283:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  350681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350698 */     GIR_RootConstrainSelectedInstOperands,
     /*  350699 */     // GIR_Coverage, 21465,
     /*  350699 */     GIR_EraseRootFromParent_Done,
     /*  350700 */   // Label 6409: @350700
     /*  350700 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(350766), // Rule ID 21468 //
     /*  350705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350744 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  350747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350764 */     GIR_RootConstrainSelectedInstOperands,
     /*  350765 */     // GIR_Coverage, 21468,
     /*  350765 */     GIR_EraseRootFromParent_Done,
     /*  350766 */   // Label 6410: @350766
     /*  350766 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(350832), // Rule ID 21469 //
     /*  350771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350810 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11283:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  350813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350830 */     GIR_RootConstrainSelectedInstOperands,
     /*  350831 */     // GIR_Coverage, 21469,
     /*  350831 */     GIR_EraseRootFromParent_Done,
     /*  350832 */   // Label 6411: @350832
     /*  350832 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(350898), // Rule ID 21472 //
     /*  350837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350876 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  350879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350896 */     GIR_RootConstrainSelectedInstOperands,
     /*  350897 */     // GIR_Coverage, 21472,
     /*  350897 */     GIR_EraseRootFromParent_Done,
     /*  350898 */   // Label 6412: @350898
     /*  350898 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(350964), // Rule ID 21473 //
     /*  350903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350942 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11283:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  350945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350962 */     GIR_RootConstrainSelectedInstOperands,
     /*  350963 */     // GIR_Coverage, 21473,
     /*  350963 */     GIR_EraseRootFromParent_Done,
     /*  350964 */   // Label 6413: @350964
     /*  350964 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(351030), // Rule ID 21476 //
     /*  350969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351008 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  351008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  351011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351028 */     GIR_RootConstrainSelectedInstOperands,
     /*  351029 */     // GIR_Coverage, 21476,
     /*  351029 */     GIR_EraseRootFromParent_Done,
     /*  351030 */   // Label 6414: @351030
     /*  351030 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(351096), // Rule ID 21477 //
     /*  351035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  351038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  351043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  351046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  351049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351074 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11283:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  351074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  351077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  351091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351094 */     GIR_RootConstrainSelectedInstOperands,
     /*  351095 */     // GIR_Coverage, 21477,
     /*  351095 */     GIR_EraseRootFromParent_Done,
     /*  351096 */   // Label 6415: @351096
     /*  351096 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(351162), // Rule ID 21720 //
     /*  351101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  351112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  351115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  351143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351160 */     GIR_RootConstrainSelectedInstOperands,
     /*  351161 */     // GIR_Coverage, 21720,
     /*  351161 */     GIR_EraseRootFromParent_Done,
     /*  351162 */   // Label 6416: @351162
     /*  351162 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(351228), // Rule ID 21721 //
     /*  351167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  351178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  351181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  351184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351206 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  351209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351226 */     GIR_RootConstrainSelectedInstOperands,
     /*  351227 */     // GIR_Coverage, 21721,
     /*  351227 */     GIR_EraseRootFromParent_Done,
     /*  351228 */   // Label 6417: @351228
     /*  351228 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(351294), // Rule ID 21724 //
     /*  351233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351272 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351292 */     GIR_RootConstrainSelectedInstOperands,
     /*  351293 */     // GIR_Coverage, 21724,
     /*  351293 */     GIR_EraseRootFromParent_Done,
     /*  351294 */   // Label 6418: @351294
     /*  351294 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(351360), // Rule ID 21725 //
     /*  351299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  351310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  351313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  351316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351338 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351358 */     GIR_RootConstrainSelectedInstOperands,
     /*  351359 */     // GIR_Coverage, 21725,
     /*  351359 */     GIR_EraseRootFromParent_Done,
     /*  351360 */   // Label 6419: @351360
     /*  351360 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(351426), // Rule ID 21728 //
     /*  351365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  351382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351404 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351424 */     GIR_RootConstrainSelectedInstOperands,
     /*  351425 */     // GIR_Coverage, 21728,
     /*  351425 */     GIR_EraseRootFromParent_Done,
     /*  351426 */   // Label 6420: @351426
     /*  351426 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(351492), // Rule ID 21729 //
     /*  351431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  351442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  351445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  351448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351490 */     GIR_RootConstrainSelectedInstOperands,
     /*  351491 */     // GIR_Coverage, 21729,
     /*  351491 */     GIR_EraseRootFromParent_Done,
     /*  351492 */   // Label 6421: @351492
     /*  351492 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(351558), // Rule ID 21732 //
     /*  351497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  351508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  351511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  351539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351556 */     GIR_RootConstrainSelectedInstOperands,
     /*  351557 */     // GIR_Coverage, 21732,
     /*  351557 */     GIR_EraseRootFromParent_Done,
     /*  351558 */   // Label 6422: @351558
     /*  351558 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(351624), // Rule ID 21733 //
     /*  351563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  351574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  351577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11233:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  351605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351622 */     GIR_RootConstrainSelectedInstOperands,
     /*  351623 */     // GIR_Coverage, 21733,
     /*  351623 */     GIR_EraseRootFromParent_Done,
     /*  351624 */   // Label 6423: @351624
     /*  351624 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(351690), // Rule ID 21736 //
     /*  351629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  351640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  351643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351668 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  351671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351688 */     GIR_RootConstrainSelectedInstOperands,
     /*  351689 */     // GIR_Coverage, 21736,
     /*  351689 */     GIR_EraseRootFromParent_Done,
     /*  351690 */   // Label 6424: @351690
     /*  351690 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(351756), // Rule ID 21737 //
     /*  351695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  351706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  351709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351734 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  351737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351754 */     GIR_RootConstrainSelectedInstOperands,
     /*  351755 */     // GIR_Coverage, 21737,
     /*  351755 */     GIR_EraseRootFromParent_Done,
     /*  351756 */   // Label 6425: @351756
     /*  351756 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(351822), // Rule ID 21740 //
     /*  351761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  351772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  351775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  351778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351800 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  351803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351820 */     GIR_RootConstrainSelectedInstOperands,
     /*  351821 */     // GIR_Coverage, 21740,
     /*  351821 */     GIR_EraseRootFromParent_Done,
     /*  351822 */   // Label 6426: @351822
     /*  351822 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(351888), // Rule ID 21741 //
     /*  351827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  351838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  351841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  351844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351866 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  351869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351886 */     GIR_RootConstrainSelectedInstOperands,
     /*  351887 */     // GIR_Coverage, 21741,
     /*  351887 */     GIR_EraseRootFromParent_Done,
     /*  351888 */   // Label 6427: @351888
     /*  351888 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(351954), // Rule ID 21744 //
     /*  351893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  351896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351952 */     GIR_RootConstrainSelectedInstOperands,
     /*  351953 */     // GIR_Coverage, 21744,
     /*  351953 */     GIR_EraseRootFromParent_Done,
     /*  351954 */   // Label 6428: @351954
     /*  351954 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(352020), // Rule ID 21745 //
     /*  351959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  352001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352018 */     GIR_RootConstrainSelectedInstOperands,
     /*  352019 */     // GIR_Coverage, 21745,
     /*  352019 */     GIR_EraseRootFromParent_Done,
     /*  352020 */   // Label 6429: @352020
     /*  352020 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(352086), // Rule ID 21748 //
     /*  352025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  352036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  352039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352084 */     GIR_RootConstrainSelectedInstOperands,
     /*  352085 */     // GIR_Coverage, 21748,
     /*  352085 */     GIR_EraseRootFromParent_Done,
     /*  352086 */   // Label 6430: @352086
     /*  352086 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(352152), // Rule ID 21749 //
     /*  352091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  352102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  352105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  352108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352130 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352150 */     GIR_RootConstrainSelectedInstOperands,
     /*  352151 */     // GIR_Coverage, 21749,
     /*  352151 */     GIR_EraseRootFromParent_Done,
     /*  352152 */   // Label 6431: @352152
     /*  352152 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(352218), // Rule ID 21752 //
     /*  352157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  352174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352216 */     GIR_RootConstrainSelectedInstOperands,
     /*  352217 */     // GIR_Coverage, 21752,
     /*  352217 */     GIR_EraseRootFromParent_Done,
     /*  352218 */   // Label 6432: @352218
     /*  352218 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(352284), // Rule ID 21753 //
     /*  352223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  352234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  352237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  352240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11233:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352282 */     GIR_RootConstrainSelectedInstOperands,
     /*  352283 */     // GIR_Coverage, 21753,
     /*  352283 */     GIR_EraseRootFromParent_Done,
     /*  352284 */   // Label 6433: @352284
     /*  352284 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(352350), // Rule ID 21756 //
     /*  352289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  352306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352328 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352348 */     GIR_RootConstrainSelectedInstOperands,
     /*  352349 */     // GIR_Coverage, 21756,
     /*  352349 */     GIR_EraseRootFromParent_Done,
     /*  352350 */   // Label 6434: @352350
     /*  352350 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(352416), // Rule ID 21757 //
     /*  352355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  352366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  352369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  352372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352414 */     GIR_RootConstrainSelectedInstOperands,
     /*  352415 */     // GIR_Coverage, 21757,
     /*  352415 */     GIR_EraseRootFromParent_Done,
     /*  352416 */   // Label 6435: @352416
     /*  352416 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(352482), // Rule ID 21760 //
     /*  352421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  352424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  352438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  352460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352480 */     GIR_RootConstrainSelectedInstOperands,
     /*  352481 */     // GIR_Coverage, 21760,
     /*  352481 */     GIR_EraseRootFromParent_Done,
     /*  352482 */   // Label 6436: @352482
     /*  352482 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(352548), // Rule ID 21761 //
     /*  352487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  352490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  352498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  352501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  352504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352526 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352546 */     GIR_RootConstrainSelectedInstOperands,
     /*  352547 */     // GIR_Coverage, 21761,
     /*  352547 */     GIR_EraseRootFromParent_Done,
     /*  352548 */   // Label 6437: @352548
     /*  352548 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(352614), // Rule ID 21764 //
     /*  352553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  352570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352592 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352612 */     GIR_RootConstrainSelectedInstOperands,
     /*  352613 */     // GIR_Coverage, 21764,
     /*  352613 */     GIR_EraseRootFromParent_Done,
     /*  352614 */   // Label 6438: @352614
     /*  352614 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(352680), // Rule ID 21765 //
     /*  352619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  352636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352658 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352678 */     GIR_RootConstrainSelectedInstOperands,
     /*  352679 */     // GIR_Coverage, 21765,
     /*  352679 */     GIR_EraseRootFromParent_Done,
     /*  352680 */   // Label 6439: @352680
     /*  352680 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(352746), // Rule ID 21768 //
     /*  352685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  352702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352744 */     GIR_RootConstrainSelectedInstOperands,
     /*  352745 */     // GIR_Coverage, 21768,
     /*  352745 */     GIR_EraseRootFromParent_Done,
     /*  352746 */   // Label 6440: @352746
     /*  352746 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(352812), // Rule ID 21769 //
     /*  352751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  352768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11233:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352810 */     GIR_RootConstrainSelectedInstOperands,
     /*  352811 */     // GIR_Coverage, 21769,
     /*  352811 */     GIR_EraseRootFromParent_Done,
     /*  352812 */   // Label 6441: @352812
     /*  352812 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(352878), // Rule ID 21772 //
     /*  352817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  352834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352876 */     GIR_RootConstrainSelectedInstOperands,
     /*  352877 */     // GIR_Coverage, 21772,
     /*  352877 */     GIR_EraseRootFromParent_Done,
     /*  352878 */   // Label 6442: @352878
     /*  352878 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(352944), // Rule ID 21773 //
     /*  352883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  352900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11233:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352942 */     GIR_RootConstrainSelectedInstOperands,
     /*  352943 */     // GIR_Coverage, 21773,
     /*  352943 */     GIR_EraseRootFromParent_Done,
     /*  352944 */   // Label 6443: @352944
     /*  352944 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(353010), // Rule ID 21776 //
     /*  352949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  352960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  352963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  352966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352988 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353008 */     GIR_RootConstrainSelectedInstOperands,
     /*  353009 */     // GIR_Coverage, 21776,
     /*  353009 */     GIR_EraseRootFromParent_Done,
     /*  353010 */   // Label 6444: @353010
     /*  353010 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(353076), // Rule ID 21777 //
     /*  353015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  353018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  353023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  353026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  353029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  353032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353054 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11233:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  353054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  353057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  353071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353074 */     GIR_RootConstrainSelectedInstOperands,
     /*  353075 */     // GIR_Coverage, 21777,
     /*  353075 */     GIR_EraseRootFromParent_Done,
     /*  353076 */   // Label 6445: @353076
     /*  353076 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(353142), // Rule ID 21780 //
     /*  353081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  353092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  353095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353120 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  353123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353140 */     GIR_RootConstrainSelectedInstOperands,
     /*  353141 */     // GIR_Coverage, 21780,
     /*  353141 */     GIR_EraseRootFromParent_Done,
     /*  353142 */   // Label 6446: @353142
     /*  353142 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(353208), // Rule ID 21781 //
     /*  353147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  353158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  353161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  353164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353186 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  353189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353206 */     GIR_RootConstrainSelectedInstOperands,
     /*  353207 */     // GIR_Coverage, 21781,
     /*  353207 */     GIR_EraseRootFromParent_Done,
     /*  353208 */   // Label 6447: @353208
     /*  353208 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(353274), // Rule ID 21784 //
     /*  353213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  353224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  353227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353272 */     GIR_RootConstrainSelectedInstOperands,
     /*  353273 */     // GIR_Coverage, 21784,
     /*  353273 */     GIR_EraseRootFromParent_Done,
     /*  353274 */   // Label 6448: @353274
     /*  353274 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(353340), // Rule ID 21785 //
     /*  353279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  353290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  353293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  353296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353318 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353338 */     GIR_RootConstrainSelectedInstOperands,
     /*  353339 */     // GIR_Coverage, 21785,
     /*  353339 */     GIR_EraseRootFromParent_Done,
     /*  353340 */   // Label 6449: @353340
     /*  353340 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(353406), // Rule ID 21788 //
     /*  353345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  353356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  353359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  353362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353384 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353404 */     GIR_RootConstrainSelectedInstOperands,
     /*  353405 */     // GIR_Coverage, 21788,
     /*  353405 */     GIR_EraseRootFromParent_Done,
     /*  353406 */   // Label 6450: @353406
     /*  353406 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(353472), // Rule ID 21789 //
     /*  353411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  353422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  353425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  353428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353470 */     GIR_RootConstrainSelectedInstOperands,
     /*  353471 */     // GIR_Coverage, 21789,
     /*  353471 */     GIR_EraseRootFromParent_Done,
     /*  353472 */   // Label 6451: @353472
     /*  353472 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(353538), // Rule ID 21792 //
     /*  353477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  353488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  353491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11231:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353536 */     GIR_RootConstrainSelectedInstOperands,
     /*  353537 */     // GIR_Coverage, 21792,
     /*  353537 */     GIR_EraseRootFromParent_Done,
     /*  353538 */   // Label 6452: @353538
     /*  353538 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(353604), // Rule ID 21793 //
     /*  353543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  353554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  353557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11231:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353602 */     GIR_RootConstrainSelectedInstOperands,
     /*  353603 */     // GIR_Coverage, 21793,
     /*  353603 */     GIR_EraseRootFromParent_Done,
     /*  353604 */   // Label 6453: @353604
     /*  353604 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(353670), // Rule ID 21796 //
     /*  353609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  353620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  353623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353648 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  353651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353668 */     GIR_RootConstrainSelectedInstOperands,
     /*  353669 */     // GIR_Coverage, 21796,
     /*  353669 */     GIR_EraseRootFromParent_Done,
     /*  353670 */   // Label 6454: @353670
     /*  353670 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(353736), // Rule ID 21797 //
     /*  353675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  353686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  353689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353714 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  353717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353734 */     GIR_RootConstrainSelectedInstOperands,
     /*  353735 */     // GIR_Coverage, 21797,
     /*  353735 */     GIR_EraseRootFromParent_Done,
     /*  353736 */   // Label 6455: @353736
     /*  353736 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(353802), // Rule ID 21800 //
     /*  353741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  353752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  353755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  353758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353780 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  353783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353800 */     GIR_RootConstrainSelectedInstOperands,
     /*  353801 */     // GIR_Coverage, 21800,
     /*  353801 */     GIR_EraseRootFromParent_Done,
     /*  353802 */   // Label 6456: @353802
     /*  353802 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(353868), // Rule ID 21801 //
     /*  353807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  353818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  353821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  353824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353846 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  353849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353866 */     GIR_RootConstrainSelectedInstOperands,
     /*  353867 */     // GIR_Coverage, 21801,
     /*  353867 */     GIR_EraseRootFromParent_Done,
     /*  353868 */   // Label 6457: @353868
     /*  353868 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(353934), // Rule ID 21804 //
     /*  353873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  353876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  353884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  353887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353932 */     GIR_RootConstrainSelectedInstOperands,
     /*  353933 */     // GIR_Coverage, 21804,
     /*  353933 */     GIR_EraseRootFromParent_Done,
     /*  353934 */   // Label 6458: @353934
     /*  353934 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(354000), // Rule ID 21805 //
     /*  353939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  353950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  353953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353998 */     GIR_RootConstrainSelectedInstOperands,
     /*  353999 */     // GIR_Coverage, 21805,
     /*  353999 */     GIR_EraseRootFromParent_Done,
     /*  354000 */   // Label 6459: @354000
     /*  354000 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(354066), // Rule ID 21808 //
     /*  354005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354064 */     GIR_RootConstrainSelectedInstOperands,
     /*  354065 */     // GIR_Coverage, 21808,
     /*  354065 */     GIR_EraseRootFromParent_Done,
     /*  354066 */   // Label 6460: @354066
     /*  354066 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(354132), // Rule ID 21809 //
     /*  354071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354110 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354130 */     GIR_RootConstrainSelectedInstOperands,
     /*  354131 */     // GIR_Coverage, 21809,
     /*  354131 */     GIR_EraseRootFromParent_Done,
     /*  354132 */   // Label 6461: @354132
     /*  354132 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(354198), // Rule ID 21812 //
     /*  354137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354196 */     GIR_RootConstrainSelectedInstOperands,
     /*  354197 */     // GIR_Coverage, 21812,
     /*  354197 */     GIR_EraseRootFromParent_Done,
     /*  354198 */   // Label 6462: @354198
     /*  354198 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(354264), // Rule ID 21813 //
     /*  354203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11231:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354262 */     GIR_RootConstrainSelectedInstOperands,
     /*  354263 */     // GIR_Coverage, 21813,
     /*  354263 */     GIR_EraseRootFromParent_Done,
     /*  354264 */   // Label 6463: @354264
     /*  354264 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(354330), // Rule ID 21816 //
     /*  354269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  354280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  354283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354328 */     GIR_RootConstrainSelectedInstOperands,
     /*  354329 */     // GIR_Coverage, 21816,
     /*  354329 */     GIR_EraseRootFromParent_Done,
     /*  354330 */   // Label 6464: @354330
     /*  354330 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(354396), // Rule ID 21817 //
     /*  354335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  354346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  354349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354394 */     GIR_RootConstrainSelectedInstOperands,
     /*  354395 */     // GIR_Coverage, 21817,
     /*  354395 */     GIR_EraseRootFromParent_Done,
     /*  354396 */   // Label 6465: @354396
     /*  354396 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(354462), // Rule ID 21820 //
     /*  354401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  354404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  354412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  354415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354440 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354460 */     GIR_RootConstrainSelectedInstOperands,
     /*  354461 */     // GIR_Coverage, 21820,
     /*  354461 */     GIR_EraseRootFromParent_Done,
     /*  354462 */   // Label 6466: @354462
     /*  354462 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(354528), // Rule ID 21821 //
     /*  354467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  354470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  354478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  354481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  354484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354506 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354526 */     GIR_RootConstrainSelectedInstOperands,
     /*  354527 */     // GIR_Coverage, 21821,
     /*  354527 */     GIR_EraseRootFromParent_Done,
     /*  354528 */   // Label 6467: @354528
     /*  354528 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(354594), // Rule ID 21824 //
     /*  354533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  354544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  354547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  354550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354592 */     GIR_RootConstrainSelectedInstOperands,
     /*  354593 */     // GIR_Coverage, 21824,
     /*  354593 */     GIR_EraseRootFromParent_Done,
     /*  354594 */   // Label 6468: @354594
     /*  354594 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(354660), // Rule ID 21825 //
     /*  354599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  354610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  354613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  354616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354658 */     GIR_RootConstrainSelectedInstOperands,
     /*  354659 */     // GIR_Coverage, 21825,
     /*  354659 */     GIR_EraseRootFromParent_Done,
     /*  354660 */   // Label 6469: @354660
     /*  354660 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(354726), // Rule ID 21828 //
     /*  354665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  354676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  354679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  354682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354704 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354724 */     GIR_RootConstrainSelectedInstOperands,
     /*  354725 */     // GIR_Coverage, 21828,
     /*  354725 */     GIR_EraseRootFromParent_Done,
     /*  354726 */   // Label 6470: @354726
     /*  354726 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(354792), // Rule ID 21829 //
     /*  354731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  354742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  354745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  354748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354790 */     GIR_RootConstrainSelectedInstOperands,
     /*  354791 */     // GIR_Coverage, 21829,
     /*  354791 */     GIR_EraseRootFromParent_Done,
     /*  354792 */   // Label 6471: @354792
     /*  354792 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(354858), // Rule ID 21832 //
     /*  354797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  354814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354856 */     GIR_RootConstrainSelectedInstOperands,
     /*  354857 */     // GIR_Coverage, 21832,
     /*  354857 */     GIR_EraseRootFromParent_Done,
     /*  354858 */   // Label 6472: @354858
     /*  354858 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(354924), // Rule ID 21833 //
     /*  354863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  354880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354922 */     GIR_RootConstrainSelectedInstOperands,
     /*  354923 */     // GIR_Coverage, 21833,
     /*  354923 */     GIR_EraseRootFromParent_Done,
     /*  354924 */   // Label 6473: @354924
     /*  354924 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(354990), // Rule ID 21836 //
     /*  354929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  354940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  354943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  354946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354988 */     GIR_RootConstrainSelectedInstOperands,
     /*  354989 */     // GIR_Coverage, 21836,
     /*  354989 */     GIR_EraseRootFromParent_Done,
     /*  354990 */   // Label 6474: @354990
     /*  354990 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(355056), // Rule ID 21837 //
     /*  354995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  355003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  355006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  355009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  355012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  355037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355054 */     GIR_RootConstrainSelectedInstOperands,
     /*  355055 */     // GIR_Coverage, 21837,
     /*  355055 */     GIR_EraseRootFromParent_Done,
     /*  355056 */   // Label 6475: @355056
     /*  355056 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(355122), // Rule ID 21948 //
     /*  355061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355100 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  355103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355120 */     GIR_RootConstrainSelectedInstOperands,
     /*  355121 */     // GIR_Coverage, 21948,
     /*  355121 */     GIR_EraseRootFromParent_Done,
     /*  355122 */   // Label 6476: @355122
     /*  355122 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(355188), // Rule ID 21949 //
     /*  355127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  355138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  355141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  355144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355166 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  355169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355186 */     GIR_RootConstrainSelectedInstOperands,
     /*  355187 */     // GIR_Coverage, 21949,
     /*  355187 */     GIR_EraseRootFromParent_Done,
     /*  355188 */   // Label 6477: @355188
     /*  355188 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(355254), // Rule ID 21952 //
     /*  355193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355232 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  355235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355252 */     GIR_RootConstrainSelectedInstOperands,
     /*  355253 */     // GIR_Coverage, 21952,
     /*  355253 */     GIR_EraseRootFromParent_Done,
     /*  355254 */   // Label 6478: @355254
     /*  355254 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(355320), // Rule ID 21953 //
     /*  355259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  355270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  355273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  355276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355298 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  355301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355318 */     GIR_RootConstrainSelectedInstOperands,
     /*  355319 */     // GIR_Coverage, 21953,
     /*  355319 */     GIR_EraseRootFromParent_Done,
     /*  355320 */   // Label 6479: @355320
     /*  355320 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(355386), // Rule ID 21956 //
     /*  355325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  355336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  355339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  355342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355364 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  355367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355384 */     GIR_RootConstrainSelectedInstOperands,
     /*  355385 */     // GIR_Coverage, 21956,
     /*  355385 */     GIR_EraseRootFromParent_Done,
     /*  355386 */   // Label 6480: @355386
     /*  355386 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(355452), // Rule ID 21957 //
     /*  355391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  355402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  355405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  355408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355430 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11229:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  355433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355450 */     GIR_RootConstrainSelectedInstOperands,
     /*  355451 */     // GIR_Coverage, 21957,
     /*  355451 */     GIR_EraseRootFromParent_Done,
     /*  355452 */   // Label 6481: @355452
     /*  355452 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(355518), // Rule ID 21960 //
     /*  355457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  355468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  355471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  355474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355496 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  355499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355516 */     GIR_RootConstrainSelectedInstOperands,
     /*  355517 */     // GIR_Coverage, 21960,
     /*  355517 */     GIR_EraseRootFromParent_Done,
     /*  355518 */   // Label 6482: @355518
     /*  355518 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(355584), // Rule ID 21961 //
     /*  355523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  355534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  355537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  355540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355562 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  355565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355582 */     GIR_RootConstrainSelectedInstOperands,
     /*  355583 */     // GIR_Coverage, 21961,
     /*  355583 */     GIR_EraseRootFromParent_Done,
     /*  355584 */   // Label 6483: @355584
     /*  355584 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(355650), // Rule ID 21964 //
     /*  355589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  355600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  355603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  355606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355628 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  355631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355648 */     GIR_RootConstrainSelectedInstOperands,
     /*  355649 */     // GIR_Coverage, 21964,
     /*  355649 */     GIR_EraseRootFromParent_Done,
     /*  355650 */   // Label 6484: @355650
     /*  355650 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(355716), // Rule ID 21965 //
     /*  355655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  355666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  355669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  355672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355694 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  355697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355714 */     GIR_RootConstrainSelectedInstOperands,
     /*  355715 */     // GIR_Coverage, 21965,
     /*  355715 */     GIR_EraseRootFromParent_Done,
     /*  355716 */   // Label 6485: @355716
     /*  355716 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(355782), // Rule ID 21968 //
     /*  355721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  355724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355760 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  355763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355780 */     GIR_RootConstrainSelectedInstOperands,
     /*  355781 */     // GIR_Coverage, 21968,
     /*  355781 */     GIR_EraseRootFromParent_Done,
     /*  355782 */   // Label 6486: @355782
     /*  355782 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(355848), // Rule ID 21969 //
     /*  355787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  355790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355826 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  355829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355846 */     GIR_RootConstrainSelectedInstOperands,
     /*  355847 */     // GIR_Coverage, 21969,
     /*  355847 */     GIR_EraseRootFromParent_Done,
     /*  355848 */   // Label 6487: @355848
     /*  355848 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(355914), // Rule ID 21972 //
     /*  355853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  355856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355892 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  355895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355912 */     GIR_RootConstrainSelectedInstOperands,
     /*  355913 */     // GIR_Coverage, 21972,
     /*  355913 */     GIR_EraseRootFromParent_Done,
     /*  355914 */   // Label 6488: @355914
     /*  355914 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(355980), // Rule ID 21973 //
     /*  355919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  355922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355958 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11229:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  355961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355978 */     GIR_RootConstrainSelectedInstOperands,
     /*  355979 */     // GIR_Coverage, 21973,
     /*  355979 */     GIR_EraseRootFromParent_Done,
     /*  355980 */   // Label 6489: @355980
     /*  355980 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(356046), // Rule ID 21976 //
     /*  355985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  355988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  355996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  355999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356024 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  356027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356044 */     GIR_RootConstrainSelectedInstOperands,
     /*  356045 */     // GIR_Coverage, 21976,
     /*  356045 */     GIR_EraseRootFromParent_Done,
     /*  356046 */   // Label 6490: @356046
     /*  356046 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(356112), // Rule ID 21977 //
     /*  356051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  356062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  356065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  356068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  356079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11229:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  356093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356110 */     GIR_RootConstrainSelectedInstOperands,
     /*  356111 */     // GIR_Coverage, 21977,
     /*  356111 */     GIR_EraseRootFromParent_Done,
     /*  356112 */   // Label 6491: @356112
     /*  356112 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(356178), // Rule ID 21980 //
     /*  356117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  356120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356156 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  356156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  356159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356176 */     GIR_RootConstrainSelectedInstOperands,
     /*  356177 */     // GIR_Coverage, 21980,
     /*  356177 */     GIR_EraseRootFromParent_Done,
     /*  356178 */   // Label 6492: @356178
     /*  356178 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(356244), // Rule ID 21981 //
     /*  356183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  356186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  356191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  356194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  356197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  356200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  356211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  356215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356222 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11229:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  356222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  356225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  356229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  356239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356242 */     GIR_RootConstrainSelectedInstOperands,
     /*  356243 */     // GIR_Coverage, 21981,
     /*  356243 */     GIR_EraseRootFromParent_Done,
     /*  356244 */   // Label 6493: @356244
     /*  356244 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(356307), // Rule ID 23152 //
     /*  356249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  356291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356305 */     GIR_RootConstrainSelectedInstOperands,
     /*  356306 */     // GIR_Coverage, 23152,
     /*  356306 */     GIR_EraseRootFromParent_Done,
     /*  356307 */   // Label 6494: @356307
     /*  356307 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(356370), // Rule ID 23153 //
     /*  356312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356351 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  356354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356368 */     GIR_RootConstrainSelectedInstOperands,
     /*  356369 */     // GIR_Coverage, 23153,
     /*  356369 */     GIR_EraseRootFromParent_Done,
     /*  356370 */   // Label 6495: @356370
     /*  356370 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(356433), // Rule ID 23154 //
     /*  356375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356414 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  356417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356431 */     GIR_RootConstrainSelectedInstOperands,
     /*  356432 */     // GIR_Coverage, 23154,
     /*  356432 */     GIR_EraseRootFromParent_Done,
     /*  356433 */   // Label 6496: @356433
     /*  356433 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(356496), // Rule ID 23155 //
     /*  356438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356477 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  356480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356494 */     GIR_RootConstrainSelectedInstOperands,
     /*  356495 */     // GIR_Coverage, 23155,
     /*  356495 */     GIR_EraseRootFromParent_Done,
     /*  356496 */   // Label 6497: @356496
     /*  356496 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(356559), // Rule ID 23156 //
     /*  356501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356540 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  356543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356557 */     GIR_RootConstrainSelectedInstOperands,
     /*  356558 */     // GIR_Coverage, 23156,
     /*  356558 */     GIR_EraseRootFromParent_Done,
     /*  356559 */   // Label 6498: @356559
     /*  356559 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(356622), // Rule ID 23157 //
     /*  356564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356603 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  356606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356620 */     GIR_RootConstrainSelectedInstOperands,
     /*  356621 */     // GIR_Coverage, 23157,
     /*  356621 */     GIR_EraseRootFromParent_Done,
     /*  356622 */   // Label 6499: @356622
     /*  356622 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(356685), // Rule ID 23158 //
     /*  356627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  356638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  356641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  356644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356666 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  356669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356683 */     GIR_RootConstrainSelectedInstOperands,
     /*  356684 */     // GIR_Coverage, 23158,
     /*  356684 */     GIR_EraseRootFromParent_Done,
     /*  356685 */   // Label 6500: @356685
     /*  356685 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(356748), // Rule ID 23159 //
     /*  356690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  356701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  356704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  356707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356729 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  356732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356746 */     GIR_RootConstrainSelectedInstOperands,
     /*  356747 */     // GIR_Coverage, 23159,
     /*  356747 */     GIR_EraseRootFromParent_Done,
     /*  356748 */   // Label 6501: @356748
     /*  356748 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(356811), // Rule ID 23160 //
     /*  356753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  356764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  356767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  356770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  356795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356809 */     GIR_RootConstrainSelectedInstOperands,
     /*  356810 */     // GIR_Coverage, 23160,
     /*  356810 */     GIR_EraseRootFromParent_Done,
     /*  356811 */   // Label 6502: @356811
     /*  356811 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(356874), // Rule ID 23161 //
     /*  356816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  356827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  356830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  356833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356855 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  356858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356872 */     GIR_RootConstrainSelectedInstOperands,
     /*  356873 */     // GIR_Coverage, 23161,
     /*  356873 */     GIR_EraseRootFromParent_Done,
     /*  356874 */   // Label 6503: @356874
     /*  356874 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(356937), // Rule ID 23162 //
     /*  356879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  356890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  356893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  356896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356918 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  356921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356935 */     GIR_RootConstrainSelectedInstOperands,
     /*  356936 */     // GIR_Coverage, 23162,
     /*  356936 */     GIR_EraseRootFromParent_Done,
     /*  356937 */   // Label 6504: @356937
     /*  356937 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(357000), // Rule ID 23163 //
     /*  356942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  356953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  356956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  356959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356981 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  356984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356998 */     GIR_RootConstrainSelectedInstOperands,
     /*  356999 */     // GIR_Coverage, 23163,
     /*  356999 */     GIR_EraseRootFromParent_Done,
     /*  357000 */   // Label 6505: @357000
     /*  357000 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(357063), // Rule ID 23164 //
     /*  357005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357044 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  357047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357061 */     GIR_RootConstrainSelectedInstOperands,
     /*  357062 */     // GIR_Coverage, 23164,
     /*  357062 */     GIR_EraseRootFromParent_Done,
     /*  357063 */   // Label 6506: @357063
     /*  357063 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(357126), // Rule ID 23165 //
     /*  357068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357107 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  357110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357124 */     GIR_RootConstrainSelectedInstOperands,
     /*  357125 */     // GIR_Coverage, 23165,
     /*  357125 */     GIR_EraseRootFromParent_Done,
     /*  357126 */   // Label 6507: @357126
     /*  357126 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(357189), // Rule ID 23166 //
     /*  357131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357170 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  357173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357187 */     GIR_RootConstrainSelectedInstOperands,
     /*  357188 */     // GIR_Coverage, 23166,
     /*  357188 */     GIR_EraseRootFromParent_Done,
     /*  357189 */   // Label 6508: @357189
     /*  357189 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(357252), // Rule ID 23167 //
     /*  357194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357233 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  357236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357250 */     GIR_RootConstrainSelectedInstOperands,
     /*  357251 */     // GIR_Coverage, 23167,
     /*  357251 */     GIR_EraseRootFromParent_Done,
     /*  357252 */   // Label 6509: @357252
     /*  357252 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(357315), // Rule ID 23168 //
     /*  357257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  357299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357313 */     GIR_RootConstrainSelectedInstOperands,
     /*  357314 */     // GIR_Coverage, 23168,
     /*  357314 */     GIR_EraseRootFromParent_Done,
     /*  357315 */   // Label 6510: @357315
     /*  357315 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(357378), // Rule ID 23169 //
     /*  357320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357359 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  357362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357376 */     GIR_RootConstrainSelectedInstOperands,
     /*  357377 */     // GIR_Coverage, 23169,
     /*  357377 */     GIR_EraseRootFromParent_Done,
     /*  357378 */   // Label 6511: @357378
     /*  357378 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(357441), // Rule ID 23170 //
     /*  357383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357422 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  357425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357439 */     GIR_RootConstrainSelectedInstOperands,
     /*  357440 */     // GIR_Coverage, 23170,
     /*  357440 */     GIR_EraseRootFromParent_Done,
     /*  357441 */   // Label 6512: @357441
     /*  357441 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(357504), // Rule ID 23171 //
     /*  357446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357485 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  357488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357502 */     GIR_RootConstrainSelectedInstOperands,
     /*  357503 */     // GIR_Coverage, 23171,
     /*  357503 */     GIR_EraseRootFromParent_Done,
     /*  357504 */   // Label 6513: @357504
     /*  357504 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(357567), // Rule ID 23172 //
     /*  357509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  357551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357565 */     GIR_RootConstrainSelectedInstOperands,
     /*  357566 */     // GIR_Coverage, 23172,
     /*  357566 */     GIR_EraseRootFromParent_Done,
     /*  357567 */   // Label 6514: @357567
     /*  357567 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(357630), // Rule ID 23173 //
     /*  357572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357611 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  357614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357628 */     GIR_RootConstrainSelectedInstOperands,
     /*  357629 */     // GIR_Coverage, 23173,
     /*  357629 */     GIR_EraseRootFromParent_Done,
     /*  357630 */   // Label 6515: @357630
     /*  357630 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(357693), // Rule ID 23174 //
     /*  357635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357674 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  357677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357691 */     GIR_RootConstrainSelectedInstOperands,
     /*  357692 */     // GIR_Coverage, 23174,
     /*  357692 */     GIR_EraseRootFromParent_Done,
     /*  357693 */   // Label 6516: @357693
     /*  357693 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(357756), // Rule ID 23175 //
     /*  357698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357737 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  357740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357754 */     GIR_RootConstrainSelectedInstOperands,
     /*  357755 */     // GIR_Coverage, 23175,
     /*  357755 */     GIR_EraseRootFromParent_Done,
     /*  357756 */   // Label 6517: @357756
     /*  357756 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(357819), // Rule ID 23176 //
     /*  357761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357800 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  357803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357817 */     GIR_RootConstrainSelectedInstOperands,
     /*  357818 */     // GIR_Coverage, 23176,
     /*  357818 */     GIR_EraseRootFromParent_Done,
     /*  357819 */   // Label 6518: @357819
     /*  357819 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(357882), // Rule ID 23177 //
     /*  357824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357863 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11436:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  357866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357880 */     GIR_RootConstrainSelectedInstOperands,
     /*  357881 */     // GIR_Coverage, 23177,
     /*  357881 */     GIR_EraseRootFromParent_Done,
     /*  357882 */   // Label 6519: @357882
     /*  357882 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(357945), // Rule ID 23178 //
     /*  357887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357926 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  357929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357943 */     GIR_RootConstrainSelectedInstOperands,
     /*  357944 */     // GIR_Coverage, 23178,
     /*  357944 */     GIR_EraseRootFromParent_Done,
     /*  357945 */   // Label 6520: @357945
     /*  357945 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(358008), // Rule ID 23179 //
     /*  357950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357989 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  357992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358006 */     GIR_RootConstrainSelectedInstOperands,
     /*  358007 */     // GIR_Coverage, 23179,
     /*  358007 */     GIR_EraseRootFromParent_Done,
     /*  358008 */   // Label 6521: @358008
     /*  358008 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(358071), // Rule ID 23180 //
     /*  358013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358052 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  358055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358069 */     GIR_RootConstrainSelectedInstOperands,
     /*  358070 */     // GIR_Coverage, 23180,
     /*  358070 */     GIR_EraseRootFromParent_Done,
     /*  358071 */   // Label 6522: @358071
     /*  358071 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(358134), // Rule ID 23181 //
     /*  358076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358115 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  358118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358132 */     GIR_RootConstrainSelectedInstOperands,
     /*  358133 */     // GIR_Coverage, 23181,
     /*  358133 */     GIR_EraseRootFromParent_Done,
     /*  358134 */   // Label 6523: @358134
     /*  358134 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(358197), // Rule ID 23182 //
     /*  358139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358178 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  358181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358195 */     GIR_RootConstrainSelectedInstOperands,
     /*  358196 */     // GIR_Coverage, 23182,
     /*  358196 */     GIR_EraseRootFromParent_Done,
     /*  358197 */   // Label 6524: @358197
     /*  358197 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(358260), // Rule ID 23183 //
     /*  358202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358241 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  358244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358258 */     GIR_RootConstrainSelectedInstOperands,
     /*  358259 */     // GIR_Coverage, 23183,
     /*  358259 */     GIR_EraseRootFromParent_Done,
     /*  358260 */   // Label 6525: @358260
     /*  358260 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(358323), // Rule ID 23184 //
     /*  358265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  358307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358321 */     GIR_RootConstrainSelectedInstOperands,
     /*  358322 */     // GIR_Coverage, 23184,
     /*  358322 */     GIR_EraseRootFromParent_Done,
     /*  358323 */   // Label 6526: @358323
     /*  358323 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(358386), // Rule ID 23185 //
     /*  358328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358367 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  358370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358384 */     GIR_RootConstrainSelectedInstOperands,
     /*  358385 */     // GIR_Coverage, 23185,
     /*  358385 */     GIR_EraseRootFromParent_Done,
     /*  358386 */   // Label 6527: @358386
     /*  358386 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(358449), // Rule ID 23186 //
     /*  358391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358430 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  358433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358447 */     GIR_RootConstrainSelectedInstOperands,
     /*  358448 */     // GIR_Coverage, 23186,
     /*  358448 */     GIR_EraseRootFromParent_Done,
     /*  358449 */   // Label 6528: @358449
     /*  358449 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(358512), // Rule ID 23187 //
     /*  358454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358493 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  358496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358510 */     GIR_RootConstrainSelectedInstOperands,
     /*  358511 */     // GIR_Coverage, 23187,
     /*  358511 */     GIR_EraseRootFromParent_Done,
     /*  358512 */   // Label 6529: @358512
     /*  358512 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(358575), // Rule ID 23188 //
     /*  358517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358556 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  358559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358573 */     GIR_RootConstrainSelectedInstOperands,
     /*  358574 */     // GIR_Coverage, 23188,
     /*  358574 */     GIR_EraseRootFromParent_Done,
     /*  358575 */   // Label 6530: @358575
     /*  358575 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(358638), // Rule ID 23189 //
     /*  358580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358619 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  358622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358636 */     GIR_RootConstrainSelectedInstOperands,
     /*  358637 */     // GIR_Coverage, 23189,
     /*  358637 */     GIR_EraseRootFromParent_Done,
     /*  358638 */   // Label 6531: @358638
     /*  358638 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(358701), // Rule ID 23190 //
     /*  358643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358682 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  358685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358699 */     GIR_RootConstrainSelectedInstOperands,
     /*  358700 */     // GIR_Coverage, 23190,
     /*  358700 */     GIR_EraseRootFromParent_Done,
     /*  358701 */   // Label 6532: @358701
     /*  358701 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(358764), // Rule ID 23191 //
     /*  358706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358745 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  358748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358762 */     GIR_RootConstrainSelectedInstOperands,
     /*  358763 */     // GIR_Coverage, 23191,
     /*  358763 */     GIR_EraseRootFromParent_Done,
     /*  358764 */   // Label 6533: @358764
     /*  358764 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(358827), // Rule ID 23192 //
     /*  358769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  358811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358825 */     GIR_RootConstrainSelectedInstOperands,
     /*  358826 */     // GIR_Coverage, 23192,
     /*  358826 */     GIR_EraseRootFromParent_Done,
     /*  358827 */   // Label 6534: @358827
     /*  358827 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(358890), // Rule ID 23193 //
     /*  358832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358871 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  358874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358888 */     GIR_RootConstrainSelectedInstOperands,
     /*  358889 */     // GIR_Coverage, 23193,
     /*  358889 */     GIR_EraseRootFromParent_Done,
     /*  358890 */   // Label 6535: @358890
     /*  358890 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(358953), // Rule ID 23194 //
     /*  358895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358934 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  358937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358951 */     GIR_RootConstrainSelectedInstOperands,
     /*  358952 */     // GIR_Coverage, 23194,
     /*  358952 */     GIR_EraseRootFromParent_Done,
     /*  358953 */   // Label 6536: @358953
     /*  358953 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(359016), // Rule ID 23195 //
     /*  358958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358997 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  359000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359014 */     GIR_RootConstrainSelectedInstOperands,
     /*  359015 */     // GIR_Coverage, 23195,
     /*  359015 */     GIR_EraseRootFromParent_Done,
     /*  359016 */   // Label 6537: @359016
     /*  359016 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(359079), // Rule ID 23196 //
     /*  359021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  359063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359077 */     GIR_RootConstrainSelectedInstOperands,
     /*  359078 */     // GIR_Coverage, 23196,
     /*  359078 */     GIR_EraseRootFromParent_Done,
     /*  359079 */   // Label 6538: @359079
     /*  359079 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(359142), // Rule ID 23197 //
     /*  359084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359123 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  359126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359140 */     GIR_RootConstrainSelectedInstOperands,
     /*  359141 */     // GIR_Coverage, 23197,
     /*  359141 */     GIR_EraseRootFromParent_Done,
     /*  359142 */   // Label 6539: @359142
     /*  359142 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(359205), // Rule ID 23198 //
     /*  359147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359186 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  359189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359203 */     GIR_RootConstrainSelectedInstOperands,
     /*  359204 */     // GIR_Coverage, 23198,
     /*  359204 */     GIR_EraseRootFromParent_Done,
     /*  359205 */   // Label 6540: @359205
     /*  359205 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(359268), // Rule ID 23199 //
     /*  359210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359249 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  359252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359266 */     GIR_RootConstrainSelectedInstOperands,
     /*  359267 */     // GIR_Coverage, 23199,
     /*  359267 */     GIR_EraseRootFromParent_Done,
     /*  359268 */   // Label 6541: @359268
     /*  359268 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(359331), // Rule ID 23200 //
     /*  359273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359312 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  359315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359329 */     GIR_RootConstrainSelectedInstOperands,
     /*  359330 */     // GIR_Coverage, 23200,
     /*  359330 */     GIR_EraseRootFromParent_Done,
     /*  359331 */   // Label 6542: @359331
     /*  359331 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(359394), // Rule ID 23201 //
     /*  359336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359375 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  359378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359392 */     GIR_RootConstrainSelectedInstOperands,
     /*  359393 */     // GIR_Coverage, 23201,
     /*  359393 */     GIR_EraseRootFromParent_Done,
     /*  359394 */   // Label 6543: @359394
     /*  359394 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(359457), // Rule ID 23202 //
     /*  359399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359438 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  359441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359455 */     GIR_RootConstrainSelectedInstOperands,
     /*  359456 */     // GIR_Coverage, 23202,
     /*  359456 */     GIR_EraseRootFromParent_Done,
     /*  359457 */   // Label 6544: @359457
     /*  359457 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(359520), // Rule ID 23203 //
     /*  359462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359501 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  359504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359518 */     GIR_RootConstrainSelectedInstOperands,
     /*  359519 */     // GIR_Coverage, 23203,
     /*  359519 */     GIR_EraseRootFromParent_Done,
     /*  359520 */   // Label 6545: @359520
     /*  359520 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(359583), // Rule ID 23204 //
     /*  359525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359564 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  359567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359581 */     GIR_RootConstrainSelectedInstOperands,
     /*  359582 */     // GIR_Coverage, 23204,
     /*  359582 */     GIR_EraseRootFromParent_Done,
     /*  359583 */   // Label 6546: @359583
     /*  359583 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(359646), // Rule ID 23205 //
     /*  359588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359627 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11482:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  359630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359644 */     GIR_RootConstrainSelectedInstOperands,
     /*  359645 */     // GIR_Coverage, 23205,
     /*  359645 */     GIR_EraseRootFromParent_Done,
     /*  359646 */   // Label 6547: @359646
     /*  359646 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(359709), // Rule ID 23206 //
     /*  359651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359690 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  359693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359707 */     GIR_RootConstrainSelectedInstOperands,
     /*  359708 */     // GIR_Coverage, 23206,
     /*  359708 */     GIR_EraseRootFromParent_Done,
     /*  359709 */   // Label 6548: @359709
     /*  359709 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(359772), // Rule ID 23207 //
     /*  359714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359753 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  359756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359770 */     GIR_RootConstrainSelectedInstOperands,
     /*  359771 */     // GIR_Coverage, 23207,
     /*  359771 */     GIR_EraseRootFromParent_Done,
     /*  359772 */   // Label 6549: @359772
     /*  359772 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(359835), // Rule ID 23208 //
     /*  359777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  359819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359833 */     GIR_RootConstrainSelectedInstOperands,
     /*  359834 */     // GIR_Coverage, 23208,
     /*  359834 */     GIR_EraseRootFromParent_Done,
     /*  359835 */   // Label 6550: @359835
     /*  359835 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(359898), // Rule ID 23209 //
     /*  359840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359879 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  359882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359896 */     GIR_RootConstrainSelectedInstOperands,
     /*  359897 */     // GIR_Coverage, 23209,
     /*  359897 */     GIR_EraseRootFromParent_Done,
     /*  359898 */   // Label 6551: @359898
     /*  359898 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(359961), // Rule ID 23210 //
     /*  359903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359942 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  359945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359959 */     GIR_RootConstrainSelectedInstOperands,
     /*  359960 */     // GIR_Coverage, 23210,
     /*  359960 */     GIR_EraseRootFromParent_Done,
     /*  359961 */   // Label 6552: @359961
     /*  359961 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(360024), // Rule ID 23211 //
     /*  359966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360005 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  360008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360022 */     GIR_RootConstrainSelectedInstOperands,
     /*  360023 */     // GIR_Coverage, 23211,
     /*  360023 */     GIR_EraseRootFromParent_Done,
     /*  360024 */   // Label 6553: @360024
     /*  360024 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(360087), // Rule ID 23212 //
     /*  360029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  360071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360085 */     GIR_RootConstrainSelectedInstOperands,
     /*  360086 */     // GIR_Coverage, 23212,
     /*  360086 */     GIR_EraseRootFromParent_Done,
     /*  360087 */   // Label 6554: @360087
     /*  360087 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(360150), // Rule ID 23213 //
     /*  360092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360131 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  360134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360148 */     GIR_RootConstrainSelectedInstOperands,
     /*  360149 */     // GIR_Coverage, 23213,
     /*  360149 */     GIR_EraseRootFromParent_Done,
     /*  360150 */   // Label 6555: @360150
     /*  360150 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(360213), // Rule ID 23214 //
     /*  360155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360194 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  360197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360211 */     GIR_RootConstrainSelectedInstOperands,
     /*  360212 */     // GIR_Coverage, 23214,
     /*  360212 */     GIR_EraseRootFromParent_Done,
     /*  360213 */   // Label 6556: @360213
     /*  360213 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(360276), // Rule ID 23215 //
     /*  360218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360257 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  360260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360274 */     GIR_RootConstrainSelectedInstOperands,
     /*  360275 */     // GIR_Coverage, 23215,
     /*  360275 */     GIR_EraseRootFromParent_Done,
     /*  360276 */   // Label 6557: @360276
     /*  360276 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(360339), // Rule ID 23216 //
     /*  360281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360320 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  360323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360337 */     GIR_RootConstrainSelectedInstOperands,
     /*  360338 */     // GIR_Coverage, 23216,
     /*  360338 */     GIR_EraseRootFromParent_Done,
     /*  360339 */   // Label 6558: @360339
     /*  360339 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(360402), // Rule ID 23217 //
     /*  360344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360383 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  360386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360400 */     GIR_RootConstrainSelectedInstOperands,
     /*  360401 */     // GIR_Coverage, 23217,
     /*  360401 */     GIR_EraseRootFromParent_Done,
     /*  360402 */   // Label 6559: @360402
     /*  360402 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(360465), // Rule ID 23218 //
     /*  360407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360446 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  360449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360463 */     GIR_RootConstrainSelectedInstOperands,
     /*  360464 */     // GIR_Coverage, 23218,
     /*  360464 */     GIR_EraseRootFromParent_Done,
     /*  360465 */   // Label 6560: @360465
     /*  360465 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(360528), // Rule ID 23219 //
     /*  360470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  360478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360509 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11438:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  360512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360526 */     GIR_RootConstrainSelectedInstOperands,
     /*  360527 */     // GIR_Coverage, 23219,
     /*  360527 */     GIR_EraseRootFromParent_Done,
     /*  360528 */   // Label 6561: @360528
     /*  360528 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(360591), // Rule ID 23220 //
     /*  360533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360572 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  360575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360589 */     GIR_RootConstrainSelectedInstOperands,
     /*  360590 */     // GIR_Coverage, 23220,
     /*  360590 */     GIR_EraseRootFromParent_Done,
     /*  360591 */   // Label 6562: @360591
     /*  360591 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(360654), // Rule ID 23221 //
     /*  360596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360635 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  360638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360652 */     GIR_RootConstrainSelectedInstOperands,
     /*  360653 */     // GIR_Coverage, 23221,
     /*  360653 */     GIR_EraseRootFromParent_Done,
     /*  360654 */   // Label 6563: @360654
     /*  360654 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(360717), // Rule ID 23222 //
     /*  360659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360698 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  360701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360715 */     GIR_RootConstrainSelectedInstOperands,
     /*  360716 */     // GIR_Coverage, 23222,
     /*  360716 */     GIR_EraseRootFromParent_Done,
     /*  360717 */   // Label 6564: @360717
     /*  360717 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(360780), // Rule ID 23223 //
     /*  360722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360761 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  360764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360778 */     GIR_RootConstrainSelectedInstOperands,
     /*  360779 */     // GIR_Coverage, 23223,
     /*  360779 */     GIR_EraseRootFromParent_Done,
     /*  360780 */   // Label 6565: @360780
     /*  360780 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(360843), // Rule ID 23224 //
     /*  360785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  360827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360841 */     GIR_RootConstrainSelectedInstOperands,
     /*  360842 */     // GIR_Coverage, 23224,
     /*  360842 */     GIR_EraseRootFromParent_Done,
     /*  360843 */   // Label 6566: @360843
     /*  360843 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(360906), // Rule ID 23225 //
     /*  360848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360887 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  360890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360904 */     GIR_RootConstrainSelectedInstOperands,
     /*  360905 */     // GIR_Coverage, 23225,
     /*  360905 */     GIR_EraseRootFromParent_Done,
     /*  360906 */   // Label 6567: @360906
     /*  360906 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(360969), // Rule ID 23226 //
     /*  360911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  360953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360967 */     GIR_RootConstrainSelectedInstOperands,
     /*  360968 */     // GIR_Coverage, 23226,
     /*  360968 */     GIR_EraseRootFromParent_Done,
     /*  360969 */   // Label 6568: @360969
     /*  360969 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(361032), // Rule ID 23227 //
     /*  360974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361013 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  361016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361030 */     GIR_RootConstrainSelectedInstOperands,
     /*  361031 */     // GIR_Coverage, 23227,
     /*  361031 */     GIR_EraseRootFromParent_Done,
     /*  361032 */   // Label 6569: @361032
     /*  361032 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(361095), // Rule ID 23228 //
     /*  361037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361076 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  361079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361093 */     GIR_RootConstrainSelectedInstOperands,
     /*  361094 */     // GIR_Coverage, 23228,
     /*  361094 */     GIR_EraseRootFromParent_Done,
     /*  361095 */   // Label 6570: @361095
     /*  361095 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(361158), // Rule ID 23229 //
     /*  361100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361139 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  361142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361156 */     GIR_RootConstrainSelectedInstOperands,
     /*  361157 */     // GIR_Coverage, 23229,
     /*  361157 */     GIR_EraseRootFromParent_Done,
     /*  361158 */   // Label 6571: @361158
     /*  361158 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(361221), // Rule ID 23230 //
     /*  361163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361202 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  361205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361219 */     GIR_RootConstrainSelectedInstOperands,
     /*  361220 */     // GIR_Coverage, 23230,
     /*  361220 */     GIR_EraseRootFromParent_Done,
     /*  361221 */   // Label 6572: @361221
     /*  361221 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(361284), // Rule ID 23231 //
     /*  361226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361265 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  361268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361282 */     GIR_RootConstrainSelectedInstOperands,
     /*  361283 */     // GIR_Coverage, 23231,
     /*  361283 */     GIR_EraseRootFromParent_Done,
     /*  361284 */   // Label 6573: @361284
     /*  361284 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(361347), // Rule ID 23232 //
     /*  361289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361328 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  361331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361345 */     GIR_RootConstrainSelectedInstOperands,
     /*  361346 */     // GIR_Coverage, 23232,
     /*  361346 */     GIR_EraseRootFromParent_Done,
     /*  361347 */   // Label 6574: @361347
     /*  361347 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(361410), // Rule ID 23233 //
     /*  361352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  361360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361391 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11437:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  361394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361408 */     GIR_RootConstrainSelectedInstOperands,
     /*  361409 */     // GIR_Coverage, 23233,
     /*  361409 */     GIR_EraseRootFromParent_Done,
     /*  361410 */   // Label 6575: @361410
     /*  361410 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(361473), // Rule ID 23234 //
     /*  361415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  361457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361471 */     GIR_RootConstrainSelectedInstOperands,
     /*  361472 */     // GIR_Coverage, 23234,
     /*  361472 */     GIR_EraseRootFromParent_Done,
     /*  361473 */   // Label 6576: @361473
     /*  361473 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(361536), // Rule ID 23235 //
     /*  361478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361517 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  361520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361534 */     GIR_RootConstrainSelectedInstOperands,
     /*  361535 */     // GIR_Coverage, 23235,
     /*  361535 */     GIR_EraseRootFromParent_Done,
     /*  361536 */   // Label 6577: @361536
     /*  361536 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(361599), // Rule ID 23236 //
     /*  361541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  361583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361597 */     GIR_RootConstrainSelectedInstOperands,
     /*  361598 */     // GIR_Coverage, 23236,
     /*  361598 */     GIR_EraseRootFromParent_Done,
     /*  361599 */   // Label 6578: @361599
     /*  361599 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(361662), // Rule ID 23237 //
     /*  361604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361643 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  361646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361660 */     GIR_RootConstrainSelectedInstOperands,
     /*  361661 */     // GIR_Coverage, 23237,
     /*  361661 */     GIR_EraseRootFromParent_Done,
     /*  361662 */   // Label 6579: @361662
     /*  361662 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(361725), // Rule ID 23238 //
     /*  361667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361706 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  361709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361723 */     GIR_RootConstrainSelectedInstOperands,
     /*  361724 */     // GIR_Coverage, 23238,
     /*  361724 */     GIR_EraseRootFromParent_Done,
     /*  361725 */   // Label 6580: @361725
     /*  361725 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(361788), // Rule ID 23239 //
     /*  361730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361769 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  361772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361786 */     GIR_RootConstrainSelectedInstOperands,
     /*  361787 */     // GIR_Coverage, 23239,
     /*  361787 */     GIR_EraseRootFromParent_Done,
     /*  361788 */   // Label 6581: @361788
     /*  361788 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(361851), // Rule ID 23240 //
     /*  361793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361832 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  361835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361849 */     GIR_RootConstrainSelectedInstOperands,
     /*  361850 */     // GIR_Coverage, 23240,
     /*  361850 */     GIR_EraseRootFromParent_Done,
     /*  361851 */   // Label 6582: @361851
     /*  361851 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(361914), // Rule ID 23241 //
     /*  361856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361895 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  361898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361912 */     GIR_RootConstrainSelectedInstOperands,
     /*  361913 */     // GIR_Coverage, 23241,
     /*  361913 */     GIR_EraseRootFromParent_Done,
     /*  361914 */   // Label 6583: @361914
     /*  361914 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(361977), // Rule ID 23242 //
     /*  361919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361958 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  361961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361975 */     GIR_RootConstrainSelectedInstOperands,
     /*  361976 */     // GIR_Coverage, 23242,
     /*  361976 */     GIR_EraseRootFromParent_Done,
     /*  361977 */   // Label 6584: @361977
     /*  361977 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(362040), // Rule ID 23243 //
     /*  361982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362021 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  362024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362038 */     GIR_RootConstrainSelectedInstOperands,
     /*  362039 */     // GIR_Coverage, 23243,
     /*  362039 */     GIR_EraseRootFromParent_Done,
     /*  362040 */   // Label 6585: @362040
     /*  362040 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(362103), // Rule ID 23244 //
     /*  362045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362084 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  362087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362101 */     GIR_RootConstrainSelectedInstOperands,
     /*  362102 */     // GIR_Coverage, 23244,
     /*  362102 */     GIR_EraseRootFromParent_Done,
     /*  362103 */   // Label 6586: @362103
     /*  362103 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(362166), // Rule ID 23245 //
     /*  362108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362147 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  362150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362164 */     GIR_RootConstrainSelectedInstOperands,
     /*  362165 */     // GIR_Coverage, 23245,
     /*  362165 */     GIR_EraseRootFromParent_Done,
     /*  362166 */   // Label 6587: @362166
     /*  362166 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(362229), // Rule ID 23246 //
     /*  362171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362210 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  362213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362227 */     GIR_RootConstrainSelectedInstOperands,
     /*  362228 */     // GIR_Coverage, 23246,
     /*  362228 */     GIR_EraseRootFromParent_Done,
     /*  362229 */   // Label 6588: @362229
     /*  362229 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(362292), // Rule ID 23247 //
     /*  362234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  362242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362273 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11439:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  362276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362290 */     GIR_RootConstrainSelectedInstOperands,
     /*  362291 */     // GIR_Coverage, 23247,
     /*  362291 */     GIR_EraseRootFromParent_Done,
     /*  362292 */   // Label 6589: @362292
     /*  362292 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(362355), // Rule ID 23248 //
     /*  362297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362336 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  362339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362353 */     GIR_RootConstrainSelectedInstOperands,
     /*  362354 */     // GIR_Coverage, 23248,
     /*  362354 */     GIR_EraseRootFromParent_Done,
     /*  362355 */   // Label 6590: @362355
     /*  362355 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(362418), // Rule ID 23249 //
     /*  362360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  362371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  362374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  362377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362399 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  362402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362416 */     GIR_RootConstrainSelectedInstOperands,
     /*  362417 */     // GIR_Coverage, 23249,
     /*  362417 */     GIR_EraseRootFromParent_Done,
     /*  362418 */   // Label 6591: @362418
     /*  362418 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(362481), // Rule ID 23250 //
     /*  362423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  362465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362479 */     GIR_RootConstrainSelectedInstOperands,
     /*  362480 */     // GIR_Coverage, 23250,
     /*  362480 */     GIR_EraseRootFromParent_Done,
     /*  362481 */   // Label 6592: @362481
     /*  362481 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(362544), // Rule ID 23251 //
     /*  362486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  362497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362525 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  362528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362542 */     GIR_RootConstrainSelectedInstOperands,
     /*  362543 */     // GIR_Coverage, 23251,
     /*  362543 */     GIR_EraseRootFromParent_Done,
     /*  362544 */   // Label 6593: @362544
     /*  362544 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(362607), // Rule ID 23252 //
     /*  362549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  362591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362605 */     GIR_RootConstrainSelectedInstOperands,
     /*  362606 */     // GIR_Coverage, 23252,
     /*  362606 */     GIR_EraseRootFromParent_Done,
     /*  362607 */   // Label 6594: @362607
     /*  362607 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(362670), // Rule ID 23253 //
     /*  362612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362651 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  362654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362668 */     GIR_RootConstrainSelectedInstOperands,
     /*  362669 */     // GIR_Coverage, 23253,
     /*  362669 */     GIR_EraseRootFromParent_Done,
     /*  362670 */   // Label 6595: @362670
     /*  362670 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(362733), // Rule ID 23254 //
     /*  362675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  362717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362731 */     GIR_RootConstrainSelectedInstOperands,
     /*  362732 */     // GIR_Coverage, 23254,
     /*  362732 */     GIR_EraseRootFromParent_Done,
     /*  362733 */   // Label 6596: @362733
     /*  362733 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(362796), // Rule ID 23255 //
     /*  362738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362777 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  362780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362794 */     GIR_RootConstrainSelectedInstOperands,
     /*  362795 */     // GIR_Coverage, 23255,
     /*  362795 */     GIR_EraseRootFromParent_Done,
     /*  362796 */   // Label 6597: @362796
     /*  362796 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(362859), // Rule ID 23256 //
     /*  362801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362840 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  362843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362857 */     GIR_RootConstrainSelectedInstOperands,
     /*  362858 */     // GIR_Coverage, 23256,
     /*  362858 */     GIR_EraseRootFromParent_Done,
     /*  362859 */   // Label 6598: @362859
     /*  362859 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(362922), // Rule ID 23257 //
     /*  362864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362903 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  362906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362920 */     GIR_RootConstrainSelectedInstOperands,
     /*  362921 */     // GIR_Coverage, 23257,
     /*  362921 */     GIR_EraseRootFromParent_Done,
     /*  362922 */   // Label 6599: @362922
     /*  362922 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(362985), // Rule ID 23258 //
     /*  362927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362966 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  362969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362983 */     GIR_RootConstrainSelectedInstOperands,
     /*  362984 */     // GIR_Coverage, 23258,
     /*  362984 */     GIR_EraseRootFromParent_Done,
     /*  362985 */   // Label 6600: @362985
     /*  362985 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(363048), // Rule ID 23259 //
     /*  362990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  363001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363029 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  363032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363046 */     GIR_RootConstrainSelectedInstOperands,
     /*  363047 */     // GIR_Coverage, 23259,
     /*  363047 */     GIR_EraseRootFromParent_Done,
     /*  363048 */   // Label 6601: @363048
     /*  363048 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(363111), // Rule ID 23260 //
     /*  363053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  363056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363092 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  363095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363109 */     GIR_RootConstrainSelectedInstOperands,
     /*  363110 */     // GIR_Coverage, 23260,
     /*  363110 */     GIR_EraseRootFromParent_Done,
     /*  363111 */   // Label 6602: @363111
     /*  363111 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(363174), // Rule ID 23261 //
     /*  363116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  363119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  363124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  363127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363155 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11481:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  363158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  363164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363172 */     GIR_RootConstrainSelectedInstOperands,
     /*  363173 */     // GIR_Coverage, 23261,
     /*  363173 */     GIR_EraseRootFromParent_Done,
     /*  363174 */   // Label 6603: @363174
     /*  363174 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(363237), // Rule ID 23290 //
     /*  363179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363218 */     // (intrinsic_wo_chain:{ *:[i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  363221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363225 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363235 */     GIR_RootConstrainSelectedInstOperands,
     /*  363236 */     // GIR_Coverage, 23290,
     /*  363236 */     GIR_EraseRootFromParent_Done,
     /*  363237 */   // Label 6604: @363237
     /*  363237 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(363300), // Rule ID 23291 //
     /*  363242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363281 */     // (intrinsic_wo_chain:{ *:[i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  363284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363288 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363298 */     GIR_RootConstrainSelectedInstOperands,
     /*  363299 */     // GIR_Coverage, 23291,
     /*  363299 */     GIR_EraseRootFromParent_Done,
     /*  363300 */   // Label 6605: @363300
     /*  363300 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(363363), // Rule ID 23294 //
     /*  363305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363344 */     // (intrinsic_wo_chain:{ *:[i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  363347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363351 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363361 */     GIR_RootConstrainSelectedInstOperands,
     /*  363362 */     // GIR_Coverage, 23294,
     /*  363362 */     GIR_EraseRootFromParent_Done,
     /*  363363 */   // Label 6606: @363363
     /*  363363 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(363426), // Rule ID 23295 //
     /*  363368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363407 */     // (intrinsic_wo_chain:{ *:[i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  363410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363414 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363424 */     GIR_RootConstrainSelectedInstOperands,
     /*  363425 */     // GIR_Coverage, 23295,
     /*  363425 */     GIR_EraseRootFromParent_Done,
     /*  363426 */   // Label 6607: @363426
     /*  363426 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(363489), // Rule ID 23298 //
     /*  363431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363470 */     // (intrinsic_wo_chain:{ *:[i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  363473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363477 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363487 */     GIR_RootConstrainSelectedInstOperands,
     /*  363488 */     // GIR_Coverage, 23298,
     /*  363488 */     GIR_EraseRootFromParent_Done,
     /*  363489 */   // Label 6608: @363489
     /*  363489 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(363552), // Rule ID 23299 //
     /*  363494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363533 */     // (intrinsic_wo_chain:{ *:[i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  363536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363540 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363550 */     GIR_RootConstrainSelectedInstOperands,
     /*  363551 */     // GIR_Coverage, 23299,
     /*  363551 */     GIR_EraseRootFromParent_Done,
     /*  363552 */   // Label 6609: @363552
     /*  363552 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(363615), // Rule ID 23302 //
     /*  363557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363596 */     // (intrinsic_wo_chain:{ *:[i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  363599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363603 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363613 */     GIR_RootConstrainSelectedInstOperands,
     /*  363614 */     // GIR_Coverage, 23302,
     /*  363614 */     GIR_EraseRootFromParent_Done,
     /*  363615 */   // Label 6610: @363615
     /*  363615 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(363678), // Rule ID 23303 //
     /*  363620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363659 */     // (intrinsic_wo_chain:{ *:[i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  363662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363666 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363676 */     GIR_RootConstrainSelectedInstOperands,
     /*  363677 */     // GIR_Coverage, 23303,
     /*  363677 */     GIR_EraseRootFromParent_Done,
     /*  363678 */   // Label 6611: @363678
     /*  363678 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(363741), // Rule ID 23306 //
     /*  363683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363722 */     // (intrinsic_wo_chain:{ *:[i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  363725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363729 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363739 */     GIR_RootConstrainSelectedInstOperands,
     /*  363740 */     // GIR_Coverage, 23306,
     /*  363740 */     GIR_EraseRootFromParent_Done,
     /*  363741 */   // Label 6612: @363741
     /*  363741 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(363804), // Rule ID 23307 //
     /*  363746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363785 */     // (intrinsic_wo_chain:{ *:[i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  363788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363792 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363802 */     GIR_RootConstrainSelectedInstOperands,
     /*  363803 */     // GIR_Coverage, 23307,
     /*  363803 */     GIR_EraseRootFromParent_Done,
     /*  363804 */   // Label 6613: @363804
     /*  363804 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(363867), // Rule ID 23310 //
     /*  363809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363848 */     // (intrinsic_wo_chain:{ *:[i64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  363851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363855 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363865 */     GIR_RootConstrainSelectedInstOperands,
     /*  363866 */     // GIR_Coverage, 23310,
     /*  363866 */     GIR_EraseRootFromParent_Done,
     /*  363867 */   // Label 6614: @363867
     /*  363867 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(363930), // Rule ID 23311 //
     /*  363872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363911 */     // (intrinsic_wo_chain:{ *:[i32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  363914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363918 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363928 */     GIR_RootConstrainSelectedInstOperands,
     /*  363929 */     // GIR_Coverage, 23311,
     /*  363929 */     GIR_EraseRootFromParent_Done,
     /*  363930 */   // Label 6615: @363930
     /*  363930 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(363993), // Rule ID 23314 //
     /*  363935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  363949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  363952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363974 */     // (intrinsic_wo_chain:{ *:[i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  363977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363981 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363991 */     GIR_RootConstrainSelectedInstOperands,
     /*  363992 */     // GIR_Coverage, 23314,
     /*  363992 */     GIR_EraseRootFromParent_Done,
     /*  363993 */   // Label 6616: @363993
     /*  363993 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(364056), // Rule ID 23315 //
     /*  363998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  364012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364037 */     // (intrinsic_wo_chain:{ *:[i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  364040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364044 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364054 */     GIR_RootConstrainSelectedInstOperands,
     /*  364055 */     // GIR_Coverage, 23315,
     /*  364055 */     GIR_EraseRootFromParent_Done,
     /*  364056 */   // Label 6617: @364056
     /*  364056 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(364119), // Rule ID 23318 //
     /*  364061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364100 */     // (intrinsic_wo_chain:{ *:[i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  364103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364107 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364117 */     GIR_RootConstrainSelectedInstOperands,
     /*  364118 */     // GIR_Coverage, 23318,
     /*  364118 */     GIR_EraseRootFromParent_Done,
     /*  364119 */   // Label 6618: @364119
     /*  364119 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(364182), // Rule ID 23319 //
     /*  364124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  364138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364163 */     // (intrinsic_wo_chain:{ *:[i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  364166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364170 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364180 */     GIR_RootConstrainSelectedInstOperands,
     /*  364181 */     // GIR_Coverage, 23319,
     /*  364181 */     GIR_EraseRootFromParent_Done,
     /*  364182 */   // Label 6619: @364182
     /*  364182 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(364245), // Rule ID 23322 //
     /*  364187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364226 */     // (intrinsic_wo_chain:{ *:[i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  364229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364233 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364243 */     GIR_RootConstrainSelectedInstOperands,
     /*  364244 */     // GIR_Coverage, 23322,
     /*  364244 */     GIR_EraseRootFromParent_Done,
     /*  364245 */   // Label 6620: @364245
     /*  364245 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(364308), // Rule ID 23323 //
     /*  364250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  364264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364289 */     // (intrinsic_wo_chain:{ *:[i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  364292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364296 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364306 */     GIR_RootConstrainSelectedInstOperands,
     /*  364307 */     // GIR_Coverage, 23323,
     /*  364307 */     GIR_EraseRootFromParent_Done,
     /*  364308 */   // Label 6621: @364308
     /*  364308 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(364371), // Rule ID 23326 //
     /*  364313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364352 */     // (intrinsic_wo_chain:{ *:[i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  364355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364359 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364369 */     GIR_RootConstrainSelectedInstOperands,
     /*  364370 */     // GIR_Coverage, 23326,
     /*  364370 */     GIR_EraseRootFromParent_Done,
     /*  364371 */   // Label 6622: @364371
     /*  364371 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(364434), // Rule ID 23327 //
     /*  364376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  364390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364415 */     // (intrinsic_wo_chain:{ *:[i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  364418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364422 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364432 */     GIR_RootConstrainSelectedInstOperands,
     /*  364433 */     // GIR_Coverage, 23327,
     /*  364433 */     GIR_EraseRootFromParent_Done,
     /*  364434 */   // Label 6623: @364434
     /*  364434 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(364497), // Rule ID 23330 //
     /*  364439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364478 */     // (intrinsic_wo_chain:{ *:[i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  364481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364485 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364495 */     GIR_RootConstrainSelectedInstOperands,
     /*  364496 */     // GIR_Coverage, 23330,
     /*  364496 */     GIR_EraseRootFromParent_Done,
     /*  364497 */   // Label 6624: @364497
     /*  364497 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(364560), // Rule ID 23331 //
     /*  364502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364541 */     // (intrinsic_wo_chain:{ *:[i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  364544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364548 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364558 */     GIR_RootConstrainSelectedInstOperands,
     /*  364559 */     // GIR_Coverage, 23331,
     /*  364559 */     GIR_EraseRootFromParent_Done,
     /*  364560 */   // Label 6625: @364560
     /*  364560 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(364623), // Rule ID 23334 //
     /*  364565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364604 */     // (intrinsic_wo_chain:{ *:[i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  364607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364611 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364621 */     GIR_RootConstrainSelectedInstOperands,
     /*  364622 */     // GIR_Coverage, 23334,
     /*  364622 */     GIR_EraseRootFromParent_Done,
     /*  364623 */   // Label 6626: @364623
     /*  364623 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(364686), // Rule ID 23335 //
     /*  364628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364667 */     // (intrinsic_wo_chain:{ *:[i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  364670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364674 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364684 */     GIR_RootConstrainSelectedInstOperands,
     /*  364685 */     // GIR_Coverage, 23335,
     /*  364685 */     GIR_EraseRootFromParent_Done,
     /*  364686 */   // Label 6627: @364686
     /*  364686 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(364749), // Rule ID 23338 //
     /*  364691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364730 */     // (intrinsic_wo_chain:{ *:[i64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  364733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364737 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364747 */     GIR_RootConstrainSelectedInstOperands,
     /*  364748 */     // GIR_Coverage, 23338,
     /*  364748 */     GIR_EraseRootFromParent_Done,
     /*  364749 */   // Label 6628: @364749
     /*  364749 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(364812), // Rule ID 23339 //
     /*  364754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364793 */     // (intrinsic_wo_chain:{ *:[i32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  364796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364800 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364810 */     GIR_RootConstrainSelectedInstOperands,
     /*  364811 */     // GIR_Coverage, 23339,
     /*  364811 */     GIR_EraseRootFromParent_Done,
     /*  364812 */   // Label 6629: @364812
     /*  364812 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(364878), // Rule ID 23420 //
     /*  364817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  364828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  364831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364856 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  364856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  364859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364876 */     GIR_RootConstrainSelectedInstOperands,
     /*  364877 */     // GIR_Coverage, 23420,
     /*  364877 */     GIR_EraseRootFromParent_Done,
     /*  364878 */   // Label 6630: @364878
     /*  364878 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(364944), // Rule ID 23421 //
     /*  364883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  364894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  364897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364922 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  364922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  364925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364942 */     GIR_RootConstrainSelectedInstOperands,
     /*  364943 */     // GIR_Coverage, 23421,
     /*  364943 */     GIR_EraseRootFromParent_Done,
     /*  364944 */   // Label 6631: @364944
     /*  364944 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(365010), // Rule ID 23424 //
     /*  364949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  364960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  364963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364988 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  364988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  364991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365008 */     GIR_RootConstrainSelectedInstOperands,
     /*  365009 */     // GIR_Coverage, 23424,
     /*  365009 */     GIR_EraseRootFromParent_Done,
     /*  365010 */   // Label 6632: @365010
     /*  365010 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(365076), // Rule ID 23425 //
     /*  365015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  365026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  365029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365054 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365074 */     GIR_RootConstrainSelectedInstOperands,
     /*  365075 */     // GIR_Coverage, 23425,
     /*  365075 */     GIR_EraseRootFromParent_Done,
     /*  365076 */   // Label 6633: @365076
     /*  365076 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(365142), // Rule ID 23428 //
     /*  365081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  365092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  365095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365120 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365140 */     GIR_RootConstrainSelectedInstOperands,
     /*  365141 */     // GIR_Coverage, 23428,
     /*  365141 */     GIR_EraseRootFromParent_Done,
     /*  365142 */   // Label 6634: @365142
     /*  365142 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(365208), // Rule ID 23429 //
     /*  365147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  365158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  365161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  365189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365206 */     GIR_RootConstrainSelectedInstOperands,
     /*  365207 */     // GIR_Coverage, 23429,
     /*  365207 */     GIR_EraseRootFromParent_Done,
     /*  365208 */   // Label 6635: @365208
     /*  365208 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(365274), // Rule ID 23432 //
     /*  365213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  365224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  365227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365272 */     GIR_RootConstrainSelectedInstOperands,
     /*  365273 */     // GIR_Coverage, 23432,
     /*  365273 */     GIR_EraseRootFromParent_Done,
     /*  365274 */   // Label 6636: @365274
     /*  365274 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(365340), // Rule ID 23433 //
     /*  365279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  365290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  365293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365318 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365338 */     GIR_RootConstrainSelectedInstOperands,
     /*  365339 */     // GIR_Coverage, 23433,
     /*  365339 */     GIR_EraseRootFromParent_Done,
     /*  365340 */   // Label 6637: @365340
     /*  365340 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(365406), // Rule ID 23436 //
     /*  365345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  365356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  365359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365384 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365404 */     GIR_RootConstrainSelectedInstOperands,
     /*  365405 */     // GIR_Coverage, 23436,
     /*  365405 */     GIR_EraseRootFromParent_Done,
     /*  365406 */   // Label 6638: @365406
     /*  365406 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(365472), // Rule ID 23437 //
     /*  365411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  365422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  365425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365450 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  365453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365470 */     GIR_RootConstrainSelectedInstOperands,
     /*  365471 */     // GIR_Coverage, 23437,
     /*  365471 */     GIR_EraseRootFromParent_Done,
     /*  365472 */   // Label 6639: @365472
     /*  365472 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(365538), // Rule ID 23440 //
     /*  365477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  365488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  365491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11323:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365536 */     GIR_RootConstrainSelectedInstOperands,
     /*  365537 */     // GIR_Coverage, 23440,
     /*  365537 */     GIR_EraseRootFromParent_Done,
     /*  365538 */   // Label 6640: @365538
     /*  365538 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(365604), // Rule ID 23441 //
     /*  365543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  365554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  365557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11323:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365602 */     GIR_RootConstrainSelectedInstOperands,
     /*  365603 */     // GIR_Coverage, 23441,
     /*  365603 */     GIR_EraseRootFromParent_Done,
     /*  365604 */   // Label 6641: @365604
     /*  365604 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(365670), // Rule ID 23444 //
     /*  365609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  365620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  365623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365648 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365668 */     GIR_RootConstrainSelectedInstOperands,
     /*  365669 */     // GIR_Coverage, 23444,
     /*  365669 */     GIR_EraseRootFromParent_Done,
     /*  365670 */   // Label 6642: @365670
     /*  365670 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(365736), // Rule ID 23445 //
     /*  365675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  365686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  365689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11323:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365734 */     GIR_RootConstrainSelectedInstOperands,
     /*  365735 */     // GIR_Coverage, 23445,
     /*  365735 */     GIR_EraseRootFromParent_Done,
     /*  365736 */   // Label 6643: @365736
     /*  365736 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(365802), // Rule ID 23448 //
     /*  365741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  365752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  365755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365800 */     GIR_RootConstrainSelectedInstOperands,
     /*  365801 */     // GIR_Coverage, 23448,
     /*  365801 */     GIR_EraseRootFromParent_Done,
     /*  365802 */   // Label 6644: @365802
     /*  365802 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(365868), // Rule ID 23449 //
     /*  365807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  365818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  365821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11323:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365866 */     GIR_RootConstrainSelectedInstOperands,
     /*  365867 */     // GIR_Coverage, 23449,
     /*  365867 */     GIR_EraseRootFromParent_Done,
     /*  365868 */   // Label 6645: @365868
     /*  365868 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(365934), // Rule ID 23452 //
     /*  365873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  365876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  365884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  365887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  365912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365932 */     GIR_RootConstrainSelectedInstOperands,
     /*  365933 */     // GIR_Coverage, 23452,
     /*  365933 */     GIR_EraseRootFromParent_Done,
     /*  365934 */   // Label 6646: @365934
     /*  365934 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(366000), // Rule ID 23453 //
     /*  365939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  365942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  365950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  365953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365978 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11323:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  365978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365998 */     GIR_RootConstrainSelectedInstOperands,
     /*  365999 */     // GIR_Coverage, 23453,
     /*  365999 */     GIR_EraseRootFromParent_Done,
     /*  366000 */   // Label 6647: @366000
     /*  366000 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(366066), // Rule ID 23456 //
     /*  366005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366064 */     GIR_RootConstrainSelectedInstOperands,
     /*  366065 */     // GIR_Coverage, 23456,
     /*  366065 */     GIR_EraseRootFromParent_Done,
     /*  366066 */   // Label 6648: @366066
     /*  366066 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(366132), // Rule ID 23457 //
     /*  366071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  366082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  366085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366110 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366130 */     GIR_RootConstrainSelectedInstOperands,
     /*  366131 */     // GIR_Coverage, 23457,
     /*  366131 */     GIR_EraseRootFromParent_Done,
     /*  366132 */   // Label 6649: @366132
     /*  366132 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(366198), // Rule ID 23460 //
     /*  366137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  366148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  366151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366176 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366196 */     GIR_RootConstrainSelectedInstOperands,
     /*  366197 */     // GIR_Coverage, 23460,
     /*  366197 */     GIR_EraseRootFromParent_Done,
     /*  366198 */   // Label 6650: @366198
     /*  366198 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(366264), // Rule ID 23461 //
     /*  366203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  366214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  366217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366242 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366262 */     GIR_RootConstrainSelectedInstOperands,
     /*  366263 */     // GIR_Coverage, 23461,
     /*  366263 */     GIR_EraseRootFromParent_Done,
     /*  366264 */   // Label 6651: @366264
     /*  366264 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(366330), // Rule ID 23464 //
     /*  366269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  366280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  366283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  366308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366328 */     GIR_RootConstrainSelectedInstOperands,
     /*  366329 */     // GIR_Coverage, 23464,
     /*  366329 */     GIR_EraseRootFromParent_Done,
     /*  366330 */   // Label 6652: @366330
     /*  366330 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(366396), // Rule ID 23465 //
     /*  366335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  366346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  366349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  366352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366374 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  366374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  366391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366394 */     GIR_RootConstrainSelectedInstOperands,
     /*  366395 */     // GIR_Coverage, 23465,
     /*  366395 */     GIR_EraseRootFromParent_Done,
     /*  366396 */   // Label 6653: @366396
     /*  366396 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(366462), // Rule ID 23468 //
     /*  366401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  366412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  366415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366440 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366460 */     GIR_RootConstrainSelectedInstOperands,
     /*  366461 */     // GIR_Coverage, 23468,
     /*  366461 */     GIR_EraseRootFromParent_Done,
     /*  366462 */   // Label 6654: @366462
     /*  366462 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(366528), // Rule ID 23469 //
     /*  366467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  366478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  366481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366526 */     GIR_RootConstrainSelectedInstOperands,
     /*  366527 */     // GIR_Coverage, 23469,
     /*  366527 */     GIR_EraseRootFromParent_Done,
     /*  366528 */   // Label 6655: @366528
     /*  366528 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(366594), // Rule ID 23472 //
     /*  366533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  366544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  366547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366592 */     GIR_RootConstrainSelectedInstOperands,
     /*  366593 */     // GIR_Coverage, 23472,
     /*  366593 */     GIR_EraseRootFromParent_Done,
     /*  366594 */   // Label 6656: @366594
     /*  366594 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(366660), // Rule ID 23473 //
     /*  366599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  366610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  366613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366658 */     GIR_RootConstrainSelectedInstOperands,
     /*  366659 */     // GIR_Coverage, 23473,
     /*  366659 */     GIR_EraseRootFromParent_Done,
     /*  366660 */   // Label 6657: @366660
     /*  366660 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(366726), // Rule ID 23476 //
     /*  366665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  366676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  366679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366724 */     GIR_RootConstrainSelectedInstOperands,
     /*  366725 */     // GIR_Coverage, 23476,
     /*  366725 */     GIR_EraseRootFromParent_Done,
     /*  366726 */   // Label 6658: @366726
     /*  366726 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(366792), // Rule ID 23477 //
     /*  366731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  366742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  366745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366770 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366790 */     GIR_RootConstrainSelectedInstOperands,
     /*  366791 */     // GIR_Coverage, 23477,
     /*  366791 */     GIR_EraseRootFromParent_Done,
     /*  366792 */   // Label 6659: @366792
     /*  366792 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(366858), // Rule ID 23480 //
     /*  366797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  366808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  366811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  366836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366856 */     GIR_RootConstrainSelectedInstOperands,
     /*  366857 */     // GIR_Coverage, 23480,
     /*  366857 */     GIR_EraseRootFromParent_Done,
     /*  366858 */   // Label 6660: @366858
     /*  366858 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(366924), // Rule ID 23481 //
     /*  366863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  366874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  366877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  366902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366922 */     GIR_RootConstrainSelectedInstOperands,
     /*  366923 */     // GIR_Coverage, 23481,
     /*  366923 */     GIR_EraseRootFromParent_Done,
     /*  366924 */   // Label 6661: @366924
     /*  366924 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(366990), // Rule ID 23484 //
     /*  366929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  366940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  366943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  366968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366988 */     GIR_RootConstrainSelectedInstOperands,
     /*  366989 */     // GIR_Coverage, 23484,
     /*  366989 */     GIR_EraseRootFromParent_Done,
     /*  366990 */   // Label 6662: @366990
     /*  366990 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(367056), // Rule ID 23485 //
     /*  366995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  367006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  367009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367054 */     GIR_RootConstrainSelectedInstOperands,
     /*  367055 */     // GIR_Coverage, 23485,
     /*  367055 */     GIR_EraseRootFromParent_Done,
     /*  367056 */   // Label 6663: @367056
     /*  367056 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(367122), // Rule ID 23488 //
     /*  367061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  367064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  367072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  367075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367120 */     GIR_RootConstrainSelectedInstOperands,
     /*  367121 */     // GIR_Coverage, 23488,
     /*  367121 */     GIR_EraseRootFromParent_Done,
     /*  367122 */   // Label 6664: @367122
     /*  367122 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(367188), // Rule ID 23489 //
     /*  367127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  367130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  367138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  367141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  367144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367186 */     GIR_RootConstrainSelectedInstOperands,
     /*  367187 */     // GIR_Coverage, 23489,
     /*  367187 */     GIR_EraseRootFromParent_Done,
     /*  367188 */   // Label 6665: @367188
     /*  367188 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(367254), // Rule ID 23492 //
     /*  367193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  367204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  367207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367252 */     GIR_RootConstrainSelectedInstOperands,
     /*  367253 */     // GIR_Coverage, 23492,
     /*  367253 */     GIR_EraseRootFromParent_Done,
     /*  367254 */   // Label 6666: @367254
     /*  367254 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(367320), // Rule ID 23493 //
     /*  367259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  367270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  367273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  367276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  367287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11323:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  367301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367318 */     GIR_RootConstrainSelectedInstOperands,
     /*  367319 */     // GIR_Coverage, 23493,
     /*  367319 */     GIR_EraseRootFromParent_Done,
     /*  367320 */   // Label 6667: @367320
     /*  367320 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(367386), // Rule ID 23496 //
     /*  367325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  367336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  367339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367384 */     GIR_RootConstrainSelectedInstOperands,
     /*  367385 */     // GIR_Coverage, 23496,
     /*  367385 */     GIR_EraseRootFromParent_Done,
     /*  367386 */   // Label 6668: @367386
     /*  367386 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(367452), // Rule ID 23497 //
     /*  367391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  367402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  367405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  367408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  367419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11323:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  367433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367450 */     GIR_RootConstrainSelectedInstOperands,
     /*  367451 */     // GIR_Coverage, 23497,
     /*  367451 */     GIR_EraseRootFromParent_Done,
     /*  367452 */   // Label 6669: @367452
     /*  367452 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(367518), // Rule ID 23500 //
     /*  367457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  367460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  367468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  367471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367496 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  367496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367516 */     GIR_RootConstrainSelectedInstOperands,
     /*  367517 */     // GIR_Coverage, 23500,
     /*  367517 */     GIR_EraseRootFromParent_Done,
     /*  367518 */   // Label 6670: @367518
     /*  367518 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(367584), // Rule ID 23501 //
     /*  367523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  367534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  367537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367562 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11323:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367582 */     GIR_RootConstrainSelectedInstOperands,
     /*  367583 */     // GIR_Coverage, 23501,
     /*  367583 */     GIR_EraseRootFromParent_Done,
     /*  367584 */   // Label 6671: @367584
     /*  367584 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(367650), // Rule ID 60616 //
     /*  367589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  367600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  367603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  367606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367628 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  367631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367648 */     GIR_RootConstrainSelectedInstOperands,
     /*  367649 */     // GIR_Coverage, 60616,
     /*  367649 */     GIR_EraseRootFromParent_Done,
     /*  367650 */   // Label 6672: @367650
     /*  367650 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(367716), // Rule ID 60617 //
     /*  367655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  367666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  367669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  367672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367694 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  367697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367714 */     GIR_RootConstrainSelectedInstOperands,
     /*  367715 */     // GIR_Coverage, 60617,
     /*  367715 */     GIR_EraseRootFromParent_Done,
     /*  367716 */   // Label 6673: @367716
     /*  367716 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(367782), // Rule ID 60620 //
     /*  367721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  367732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  367735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  367738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367760 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  367763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367780 */     GIR_RootConstrainSelectedInstOperands,
     /*  367781 */     // GIR_Coverage, 60620,
     /*  367781 */     GIR_EraseRootFromParent_Done,
     /*  367782 */   // Label 6674: @367782
     /*  367782 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(367848), // Rule ID 60621 //
     /*  367787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  367798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  367801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  367804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367826 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  367829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367846 */     GIR_RootConstrainSelectedInstOperands,
     /*  367847 */     // GIR_Coverage, 60621,
     /*  367847 */     GIR_EraseRootFromParent_Done,
     /*  367848 */   // Label 6675: @367848
     /*  367848 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(367914), // Rule ID 60624 //
     /*  367853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  367864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  367867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  367870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367892 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367912 */     GIR_RootConstrainSelectedInstOperands,
     /*  367913 */     // GIR_Coverage, 60624,
     /*  367913 */     GIR_EraseRootFromParent_Done,
     /*  367914 */   // Label 6676: @367914
     /*  367914 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(367980), // Rule ID 60625 //
     /*  367919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  367930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  367933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  367936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367958 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367978 */     GIR_RootConstrainSelectedInstOperands,
     /*  367979 */     // GIR_Coverage, 60625,
     /*  367979 */     GIR_EraseRootFromParent_Done,
     /*  367980 */   // Label 6677: @367980
     /*  367980 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(368046), // Rule ID 60628 //
     /*  367985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  367996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  367999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368024 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368044 */     GIR_RootConstrainSelectedInstOperands,
     /*  368045 */     // GIR_Coverage, 60628,
     /*  368045 */     GIR_EraseRootFromParent_Done,
     /*  368046 */   // Label 6678: @368046
     /*  368046 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(368112), // Rule ID 60629 //
     /*  368051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  368062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  368065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  368068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368090 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  368093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368110 */     GIR_RootConstrainSelectedInstOperands,
     /*  368111 */     // GIR_Coverage, 60629,
     /*  368111 */     GIR_EraseRootFromParent_Done,
     /*  368112 */   // Label 6679: @368112
     /*  368112 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(368178), // Rule ID 60632 //
     /*  368117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  368128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  368131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368156 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368176 */     GIR_RootConstrainSelectedInstOperands,
     /*  368177 */     // GIR_Coverage, 60632,
     /*  368177 */     GIR_EraseRootFromParent_Done,
     /*  368178 */   // Label 6680: @368178
     /*  368178 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(368244), // Rule ID 60633 //
     /*  368183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  368194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  368197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  368200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368222 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368242 */     GIR_RootConstrainSelectedInstOperands,
     /*  368243 */     // GIR_Coverage, 60633,
     /*  368243 */     GIR_EraseRootFromParent_Done,
     /*  368244 */   // Label 6681: @368244
     /*  368244 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(368310), // Rule ID 60636 //
     /*  368249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  368260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  368263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  368266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368308 */     GIR_RootConstrainSelectedInstOperands,
     /*  368309 */     // GIR_Coverage, 60636,
     /*  368309 */     GIR_EraseRootFromParent_Done,
     /*  368310 */   // Label 6682: @368310
     /*  368310 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(368376), // Rule ID 60637 //
     /*  368315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  368326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  368329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  368332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368354 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  368357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368374 */     GIR_RootConstrainSelectedInstOperands,
     /*  368375 */     // GIR_Coverage, 60637,
     /*  368375 */     GIR_EraseRootFromParent_Done,
     /*  368376 */   // Label 6683: @368376
     /*  368376 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(368442), // Rule ID 60640 //
     /*  368381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  368392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  368395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  368398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368420 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368440 */     GIR_RootConstrainSelectedInstOperands,
     /*  368441 */     // GIR_Coverage, 60640,
     /*  368441 */     GIR_EraseRootFromParent_Done,
     /*  368442 */   // Label 6684: @368442
     /*  368442 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(368508), // Rule ID 60641 //
     /*  368447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  368458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  368461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  368464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368486 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368506 */     GIR_RootConstrainSelectedInstOperands,
     /*  368507 */     // GIR_Coverage, 60641,
     /*  368507 */     GIR_EraseRootFromParent_Done,
     /*  368508 */   // Label 6685: @368508
     /*  368508 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(368574), // Rule ID 60644 //
     /*  368513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  368524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  368527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  368530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368572 */     GIR_RootConstrainSelectedInstOperands,
     /*  368573 */     // GIR_Coverage, 60644,
     /*  368573 */     GIR_EraseRootFromParent_Done,
     /*  368574 */   // Label 6686: @368574
     /*  368574 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(368640), // Rule ID 60645 //
     /*  368579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  368590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  368593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  368596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368638 */     GIR_RootConstrainSelectedInstOperands,
     /*  368639 */     // GIR_Coverage, 60645,
     /*  368639 */     GIR_EraseRootFromParent_Done,
     /*  368640 */   // Label 6687: @368640
     /*  368640 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(368706), // Rule ID 60648 //
     /*  368645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  368656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  368659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  368662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368704 */     GIR_RootConstrainSelectedInstOperands,
     /*  368705 */     // GIR_Coverage, 60648,
     /*  368705 */     GIR_EraseRootFromParent_Done,
     /*  368706 */   // Label 6688: @368706
     /*  368706 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(368772), // Rule ID 60649 //
     /*  368711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  368722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  368725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  368728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368770 */     GIR_RootConstrainSelectedInstOperands,
     /*  368771 */     // GIR_Coverage, 60649,
     /*  368771 */     GIR_EraseRootFromParent_Done,
     /*  368772 */   // Label 6689: @368772
     /*  368772 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(368838), // Rule ID 60652 //
     /*  368777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  368788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  368791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  368794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  368816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  368833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368836 */     GIR_RootConstrainSelectedInstOperands,
     /*  368837 */     // GIR_Coverage, 60652,
     /*  368837 */     GIR_EraseRootFromParent_Done,
     /*  368838 */   // Label 6690: @368838
     /*  368838 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(368904), // Rule ID 60653 //
     /*  368843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  368854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  368857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  368860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368882 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  368882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  368899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368902 */     GIR_RootConstrainSelectedInstOperands,
     /*  368903 */     // GIR_Coverage, 60653,
     /*  368903 */     GIR_EraseRootFromParent_Done,
     /*  368904 */   // Label 6691: @368904
     /*  368904 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(368970), // Rule ID 60656 //
     /*  368909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  368920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  368923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  368926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  368951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368968 */     GIR_RootConstrainSelectedInstOperands,
     /*  368969 */     // GIR_Coverage, 60656,
     /*  368969 */     GIR_EraseRootFromParent_Done,
     /*  368970 */   // Label 6692: @368970
     /*  368970 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(369036), // Rule ID 60657 //
     /*  368975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  368986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  368989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  368992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369034 */     GIR_RootConstrainSelectedInstOperands,
     /*  369035 */     // GIR_Coverage, 60657,
     /*  369035 */     GIR_EraseRootFromParent_Done,
     /*  369036 */   // Label 6693: @369036
     /*  369036 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(369102), // Rule ID 60660 //
     /*  369041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  369058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369080 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369100 */     GIR_RootConstrainSelectedInstOperands,
     /*  369101 */     // GIR_Coverage, 60660,
     /*  369101 */     GIR_EraseRootFromParent_Done,
     /*  369102 */   // Label 6694: @369102
     /*  369102 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(369168), // Rule ID 60661 //
     /*  369107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  369118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  369121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  369124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369166 */     GIR_RootConstrainSelectedInstOperands,
     /*  369167 */     // GIR_Coverage, 60661,
     /*  369167 */     GIR_EraseRootFromParent_Done,
     /*  369168 */   // Label 6695: @369168
     /*  369168 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(369234), // Rule ID 60664 //
     /*  369173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  369184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  369187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  369190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369212 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  369212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369232 */     GIR_RootConstrainSelectedInstOperands,
     /*  369233 */     // GIR_Coverage, 60664,
     /*  369233 */     GIR_EraseRootFromParent_Done,
     /*  369234 */   // Label 6696: @369234
     /*  369234 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(369300), // Rule ID 60665 //
     /*  369239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  369250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  369253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  369256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369278 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  369278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  369295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369298 */     GIR_RootConstrainSelectedInstOperands,
     /*  369299 */     // GIR_Coverage, 60665,
     /*  369299 */     GIR_EraseRootFromParent_Done,
     /*  369300 */   // Label 6697: @369300
     /*  369300 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(369366), // Rule ID 60668 //
     /*  369305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  369316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  369319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369364 */     GIR_RootConstrainSelectedInstOperands,
     /*  369365 */     // GIR_Coverage, 60668,
     /*  369365 */     GIR_EraseRootFromParent_Done,
     /*  369366 */   // Label 6698: @369366
     /*  369366 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(369432), // Rule ID 60669 //
     /*  369371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  369382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  369385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  369388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369430 */     GIR_RootConstrainSelectedInstOperands,
     /*  369431 */     // GIR_Coverage, 60669,
     /*  369431 */     GIR_EraseRootFromParent_Done,
     /*  369432 */   // Label 6699: @369432
     /*  369432 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(369498), // Rule ID 60672 //
     /*  369437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  369448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  369451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369496 */     GIR_RootConstrainSelectedInstOperands,
     /*  369497 */     // GIR_Coverage, 60672,
     /*  369497 */     GIR_EraseRootFromParent_Done,
     /*  369498 */   // Label 6700: @369498
     /*  369498 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(369564), // Rule ID 60673 //
     /*  369503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  369514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  369517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369542 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369562 */     GIR_RootConstrainSelectedInstOperands,
     /*  369563 */     // GIR_Coverage, 60673,
     /*  369563 */     GIR_EraseRootFromParent_Done,
     /*  369564 */   // Label 6701: @369564
     /*  369564 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(369630), // Rule ID 60676 //
     /*  369569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  369580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  369583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  369586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369628 */     GIR_RootConstrainSelectedInstOperands,
     /*  369629 */     // GIR_Coverage, 60676,
     /*  369629 */     GIR_EraseRootFromParent_Done,
     /*  369630 */   // Label 6702: @369630
     /*  369630 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(369696), // Rule ID 60677 //
     /*  369635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  369646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  369649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  369652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369674 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369694 */     GIR_RootConstrainSelectedInstOperands,
     /*  369695 */     // GIR_Coverage, 60677,
     /*  369695 */     GIR_EraseRootFromParent_Done,
     /*  369696 */   // Label 6703: @369696
     /*  369696 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(369762), // Rule ID 60680 //
     /*  369701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  369712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  369715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  369718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369760 */     GIR_RootConstrainSelectedInstOperands,
     /*  369761 */     // GIR_Coverage, 60680,
     /*  369761 */     GIR_EraseRootFromParent_Done,
     /*  369762 */   // Label 6704: @369762
     /*  369762 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(369828), // Rule ID 60681 //
     /*  369767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  369778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  369781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  369784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369806 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369826 */     GIR_RootConstrainSelectedInstOperands,
     /*  369827 */     // GIR_Coverage, 60681,
     /*  369827 */     GIR_EraseRootFromParent_Done,
     /*  369828 */   // Label 6705: @369828
     /*  369828 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(369894), // Rule ID 60684 //
     /*  369833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  369844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  369847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  369850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369892 */     GIR_RootConstrainSelectedInstOperands,
     /*  369893 */     // GIR_Coverage, 60684,
     /*  369893 */     GIR_EraseRootFromParent_Done,
     /*  369894 */   // Label 6706: @369894
     /*  369894 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(369960), // Rule ID 60685 //
     /*  369899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  369910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  369913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  369916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369938 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369958 */     GIR_RootConstrainSelectedInstOperands,
     /*  369959 */     // GIR_Coverage, 60685,
     /*  369959 */     GIR_EraseRootFromParent_Done,
     /*  369960 */   // Label 6707: @369960
     /*  369960 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(370026), // Rule ID 60688 //
     /*  369965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  369976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  369979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  369982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370004 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370024 */     GIR_RootConstrainSelectedInstOperands,
     /*  370025 */     // GIR_Coverage, 60688,
     /*  370025 */     GIR_EraseRootFromParent_Done,
     /*  370026 */   // Label 6708: @370026
     /*  370026 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(370092), // Rule ID 60689 //
     /*  370031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  370042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  370045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  370048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370070 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370090 */     GIR_RootConstrainSelectedInstOperands,
     /*  370091 */     // GIR_Coverage, 60689,
     /*  370091 */     GIR_EraseRootFromParent_Done,
     /*  370092 */   // Label 6709: @370092
     /*  370092 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(370158), // Rule ID 60692 //
     /*  370097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  370108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  370111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370156 */     GIR_RootConstrainSelectedInstOperands,
     /*  370157 */     // GIR_Coverage, 60692,
     /*  370157 */     GIR_EraseRootFromParent_Done,
     /*  370158 */   // Label 6710: @370158
     /*  370158 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(370224), // Rule ID 60693 //
     /*  370163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  370174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  370177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  370180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  370195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370202 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  370205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370222 */     GIR_RootConstrainSelectedInstOperands,
     /*  370223 */     // GIR_Coverage, 60693,
     /*  370223 */     GIR_EraseRootFromParent_Done,
     /*  370224 */   // Label 6711: @370224
     /*  370224 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(370290), // Rule ID 60696 //
     /*  370229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  370240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  370243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370288 */     GIR_RootConstrainSelectedInstOperands,
     /*  370289 */     // GIR_Coverage, 60696,
     /*  370289 */     GIR_EraseRootFromParent_Done,
     /*  370290 */   // Label 6712: @370290
     /*  370290 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(370356), // Rule ID 60697 //
     /*  370295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  370306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  370309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  370312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  370327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  370337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370354 */     GIR_RootConstrainSelectedInstOperands,
     /*  370355 */     // GIR_Coverage, 60697,
     /*  370355 */     GIR_EraseRootFromParent_Done,
     /*  370356 */   // Label 6713: @370356
     /*  370356 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(370422), // Rule ID 60700 //
     /*  370361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  370372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  370375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  370378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370400 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  370400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370420 */     GIR_RootConstrainSelectedInstOperands,
     /*  370421 */     // GIR_Coverage, 60700,
     /*  370421 */     GIR_EraseRootFromParent_Done,
     /*  370422 */   // Label 6714: @370422
     /*  370422 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(370488), // Rule ID 60701 //
     /*  370427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  370435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  370438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  370441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  370444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  370459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11164:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  370466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  370469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  370483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370486 */     GIR_RootConstrainSelectedInstOperands,
     /*  370487 */     // GIR_Coverage, 60701,
     /*  370487 */     GIR_EraseRootFromParent_Done,
     /*  370488 */   // Label 6715: @370488
     /*  370488 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(370554), // Rule ID 60704 //
     /*  370493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  370504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  370507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  370510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370532 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  370535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370552 */     GIR_RootConstrainSelectedInstOperands,
     /*  370553 */     // GIR_Coverage, 60704,
     /*  370553 */     GIR_EraseRootFromParent_Done,
     /*  370554 */   // Label 6716: @370554
     /*  370554 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(370620), // Rule ID 60705 //
     /*  370559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  370570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  370573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  370576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370598 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  370601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370618 */     GIR_RootConstrainSelectedInstOperands,
     /*  370619 */     // GIR_Coverage, 60705,
     /*  370619 */     GIR_EraseRootFromParent_Done,
     /*  370620 */   // Label 6717: @370620
     /*  370620 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(370686), // Rule ID 60708 //
     /*  370625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  370636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  370639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  370642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370664 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370684 */     GIR_RootConstrainSelectedInstOperands,
     /*  370685 */     // GIR_Coverage, 60708,
     /*  370685 */     GIR_EraseRootFromParent_Done,
     /*  370686 */   // Label 6718: @370686
     /*  370686 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(370752), // Rule ID 60709 //
     /*  370691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  370702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  370705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  370708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370750 */     GIR_RootConstrainSelectedInstOperands,
     /*  370751 */     // GIR_Coverage, 60709,
     /*  370751 */     GIR_EraseRootFromParent_Done,
     /*  370752 */   // Label 6719: @370752
     /*  370752 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(370818), // Rule ID 60712 //
     /*  370757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  370768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  370771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  370774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370816 */     GIR_RootConstrainSelectedInstOperands,
     /*  370817 */     // GIR_Coverage, 60712,
     /*  370817 */     GIR_EraseRootFromParent_Done,
     /*  370818 */   // Label 6720: @370818
     /*  370818 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(370884), // Rule ID 60713 //
     /*  370823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  370834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  370837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  370840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370862 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370882 */     GIR_RootConstrainSelectedInstOperands,
     /*  370883 */     // GIR_Coverage, 60713,
     /*  370883 */     GIR_EraseRootFromParent_Done,
     /*  370884 */   // Label 6721: @370884
     /*  370884 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(370950), // Rule ID 60716 //
     /*  370889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  370900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  370903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  370906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370928 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370948 */     GIR_RootConstrainSelectedInstOperands,
     /*  370949 */     // GIR_Coverage, 60716,
     /*  370949 */     GIR_EraseRootFromParent_Done,
     /*  370950 */   // Label 6722: @370950
     /*  370950 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(371016), // Rule ID 60717 //
     /*  370955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  370966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  370969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  370972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371014 */     GIR_RootConstrainSelectedInstOperands,
     /*  371015 */     // GIR_Coverage, 60717,
     /*  371015 */     GIR_EraseRootFromParent_Done,
     /*  371016 */   // Label 6723: @371016
     /*  371016 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(371082), // Rule ID 60720 //
     /*  371021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371060 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371080 */     GIR_RootConstrainSelectedInstOperands,
     /*  371081 */     // GIR_Coverage, 60720,
     /*  371081 */     GIR_EraseRootFromParent_Done,
     /*  371082 */   // Label 6724: @371082
     /*  371082 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(371148), // Rule ID 60721 //
     /*  371087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  371098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  371101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  371104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371146 */     GIR_RootConstrainSelectedInstOperands,
     /*  371147 */     // GIR_Coverage, 60721,
     /*  371147 */     GIR_EraseRootFromParent_Done,
     /*  371148 */   // Label 6725: @371148
     /*  371148 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(371214), // Rule ID 60724 //
     /*  371153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  371164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  371167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  371170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371192 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  371192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371212 */     GIR_RootConstrainSelectedInstOperands,
     /*  371213 */     // GIR_Coverage, 60724,
     /*  371213 */     GIR_EraseRootFromParent_Done,
     /*  371214 */   // Label 6726: @371214
     /*  371214 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(371280), // Rule ID 60725 //
     /*  371219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  371230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  371233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  371236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371258 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  371261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371278 */     GIR_RootConstrainSelectedInstOperands,
     /*  371279 */     // GIR_Coverage, 60725,
     /*  371279 */     GIR_EraseRootFromParent_Done,
     /*  371280 */   // Label 6727: @371280
     /*  371280 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(371346), // Rule ID 60728 //
     /*  371285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  371296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  371299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  371302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371344 */     GIR_RootConstrainSelectedInstOperands,
     /*  371345 */     // GIR_Coverage, 60728,
     /*  371345 */     GIR_EraseRootFromParent_Done,
     /*  371346 */   // Label 6728: @371346
     /*  371346 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(371412), // Rule ID 60729 //
     /*  371351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  371362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  371365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  371368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371390 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11172:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371410 */     GIR_RootConstrainSelectedInstOperands,
     /*  371411 */     // GIR_Coverage, 60729,
     /*  371411 */     GIR_EraseRootFromParent_Done,
     /*  371412 */   // Label 6729: @371412
     /*  371412 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(371478), // Rule ID 60732 //
     /*  371417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  371428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  371431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  371434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371456 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371476 */     GIR_RootConstrainSelectedInstOperands,
     /*  371477 */     // GIR_Coverage, 60732,
     /*  371477 */     GIR_EraseRootFromParent_Done,
     /*  371478 */   // Label 6730: @371478
     /*  371478 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(371544), // Rule ID 60733 //
     /*  371483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  371494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  371497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  371500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371522 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371542 */     GIR_RootConstrainSelectedInstOperands,
     /*  371543 */     // GIR_Coverage, 60733,
     /*  371543 */     GIR_EraseRootFromParent_Done,
     /*  371544 */   // Label 6731: @371544
     /*  371544 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(371610), // Rule ID 60736 //
     /*  371549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  371560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  371563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  371566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  371588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371608 */     GIR_RootConstrainSelectedInstOperands,
     /*  371609 */     // GIR_Coverage, 60736,
     /*  371609 */     GIR_EraseRootFromParent_Done,
     /*  371610 */   // Label 6732: @371610
     /*  371610 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(371676), // Rule ID 60737 //
     /*  371615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  371626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  371629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  371632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371654 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371674 */     GIR_RootConstrainSelectedInstOperands,
     /*  371675 */     // GIR_Coverage, 60737,
     /*  371675 */     GIR_EraseRootFromParent_Done,
     /*  371676 */   // Label 6733: @371676
     /*  371676 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(371742), // Rule ID 60740 //
     /*  371681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  371692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  371695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  371698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371720 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  371720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371740 */     GIR_RootConstrainSelectedInstOperands,
     /*  371741 */     // GIR_Coverage, 60740,
     /*  371741 */     GIR_EraseRootFromParent_Done,
     /*  371742 */   // Label 6734: @371742
     /*  371742 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(371808), // Rule ID 60741 //
     /*  371747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  371758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  371761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  371764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  371786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371806 */     GIR_RootConstrainSelectedInstOperands,
     /*  371807 */     // GIR_Coverage, 60741,
     /*  371807 */     GIR_EraseRootFromParent_Done,
     /*  371808 */   // Label 6735: @371808
     /*  371808 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(371874), // Rule ID 60744 //
     /*  371813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  371824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  371827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  371830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  371855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371872 */     GIR_RootConstrainSelectedInstOperands,
     /*  371873 */     // GIR_Coverage, 60744,
     /*  371873 */     GIR_EraseRootFromParent_Done,
     /*  371874 */   // Label 6736: @371874
     /*  371874 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(371940), // Rule ID 60745 //
     /*  371879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  371890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  371893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  371896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  371921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371938 */     GIR_RootConstrainSelectedInstOperands,
     /*  371939 */     // GIR_Coverage, 60745,
     /*  371939 */     GIR_EraseRootFromParent_Done,
     /*  371940 */   // Label 6737: @371940
     /*  371940 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(372006), // Rule ID 60748 //
     /*  371945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  371956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  371959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  371962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371984 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  371987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372004 */     GIR_RootConstrainSelectedInstOperands,
     /*  372005 */     // GIR_Coverage, 60748,
     /*  372005 */     GIR_EraseRootFromParent_Done,
     /*  372006 */   // Label 6738: @372006
     /*  372006 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(372072), // Rule ID 60749 //
     /*  372011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  372022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  372025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  372028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372050 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372070 */     GIR_RootConstrainSelectedInstOperands,
     /*  372071 */     // GIR_Coverage, 60749,
     /*  372071 */     GIR_EraseRootFromParent_Done,
     /*  372072 */   // Label 6739: @372072
     /*  372072 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(372138), // Rule ID 60752 //
     /*  372077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  372088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  372091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  372094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372116 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372136 */     GIR_RootConstrainSelectedInstOperands,
     /*  372137 */     // GIR_Coverage, 60752,
     /*  372137 */     GIR_EraseRootFromParent_Done,
     /*  372138 */   // Label 6740: @372138
     /*  372138 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(372204), // Rule ID 60753 //
     /*  372143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  372154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  372157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  372160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372182 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372202 */     GIR_RootConstrainSelectedInstOperands,
     /*  372203 */     // GIR_Coverage, 60753,
     /*  372203 */     GIR_EraseRootFromParent_Done,
     /*  372204 */   // Label 6741: @372204
     /*  372204 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(372270), // Rule ID 60756 //
     /*  372209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  372220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  372223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  372226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372268 */     GIR_RootConstrainSelectedInstOperands,
     /*  372269 */     // GIR_Coverage, 60756,
     /*  372269 */     GIR_EraseRootFromParent_Done,
     /*  372270 */   // Label 6742: @372270
     /*  372270 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(372336), // Rule ID 60757 //
     /*  372275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  372286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  372289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  372292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372334 */     GIR_RootConstrainSelectedInstOperands,
     /*  372335 */     // GIR_Coverage, 60757,
     /*  372335 */     GIR_EraseRootFromParent_Done,
     /*  372336 */   // Label 6743: @372336
     /*  372336 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(372402), // Rule ID 60760 //
     /*  372341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  372352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  372355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  372358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372400 */     GIR_RootConstrainSelectedInstOperands,
     /*  372401 */     // GIR_Coverage, 60760,
     /*  372401 */     GIR_EraseRootFromParent_Done,
     /*  372402 */   // Label 6744: @372402
     /*  372402 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(372468), // Rule ID 60761 //
     /*  372407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  372418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  372421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  372424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372466 */     GIR_RootConstrainSelectedInstOperands,
     /*  372467 */     // GIR_Coverage, 60761,
     /*  372467 */     GIR_EraseRootFromParent_Done,
     /*  372468 */   // Label 6745: @372468
     /*  372468 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(372534), // Rule ID 60764 //
     /*  372473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  372484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  372487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  372490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372512 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372532 */     GIR_RootConstrainSelectedInstOperands,
     /*  372533 */     // GIR_Coverage, 60764,
     /*  372533 */     GIR_EraseRootFromParent_Done,
     /*  372534 */   // Label 6746: @372534
     /*  372534 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(372600), // Rule ID 60765 //
     /*  372539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  372550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  372553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  372556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372578 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372598 */     GIR_RootConstrainSelectedInstOperands,
     /*  372599 */     // GIR_Coverage, 60765,
     /*  372599 */     GIR_EraseRootFromParent_Done,
     /*  372600 */   // Label 6747: @372600
     /*  372600 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(372666), // Rule ID 60768 //
     /*  372605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  372616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  372619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  372622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372664 */     GIR_RootConstrainSelectedInstOperands,
     /*  372665 */     // GIR_Coverage, 60768,
     /*  372665 */     GIR_EraseRootFromParent_Done,
     /*  372666 */   // Label 6748: @372666
     /*  372666 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(372732), // Rule ID 60769 //
     /*  372671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  372682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  372685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  372688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372730 */     GIR_RootConstrainSelectedInstOperands,
     /*  372731 */     // GIR_Coverage, 60769,
     /*  372731 */     GIR_EraseRootFromParent_Done,
     /*  372732 */   // Label 6749: @372732
     /*  372732 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(372798), // Rule ID 60772 //
     /*  372737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  372748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  372751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  372754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372796 */     GIR_RootConstrainSelectedInstOperands,
     /*  372797 */     // GIR_Coverage, 60772,
     /*  372797 */     GIR_EraseRootFromParent_Done,
     /*  372798 */   // Label 6750: @372798
     /*  372798 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(372864), // Rule ID 60773 //
     /*  372803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  372814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  372817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  372820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372862 */     GIR_RootConstrainSelectedInstOperands,
     /*  372863 */     // GIR_Coverage, 60773,
     /*  372863 */     GIR_EraseRootFromParent_Done,
     /*  372864 */   // Label 6751: @372864
     /*  372864 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(372930), // Rule ID 60776 //
     /*  372869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  372880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  372883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  372886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372928 */     GIR_RootConstrainSelectedInstOperands,
     /*  372929 */     // GIR_Coverage, 60776,
     /*  372929 */     GIR_EraseRootFromParent_Done,
     /*  372930 */   // Label 6752: @372930
     /*  372930 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(372996), // Rule ID 60777 //
     /*  372935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  372946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  372949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  372952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372994 */     GIR_RootConstrainSelectedInstOperands,
     /*  372995 */     // GIR_Coverage, 60777,
     /*  372995 */     GIR_EraseRootFromParent_Done,
     /*  372996 */   // Label 6753: @372996
     /*  372996 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(373062), // Rule ID 60780 //
     /*  373001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373060 */     GIR_RootConstrainSelectedInstOperands,
     /*  373061 */     // GIR_Coverage, 60780,
     /*  373061 */     GIR_EraseRootFromParent_Done,
     /*  373062 */   // Label 6754: @373062
     /*  373062 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(373128), // Rule ID 60781 //
     /*  373067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  373078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  373081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  373084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  373099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373106 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  373109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373126 */     GIR_RootConstrainSelectedInstOperands,
     /*  373127 */     // GIR_Coverage, 60781,
     /*  373127 */     GIR_EraseRootFromParent_Done,
     /*  373128 */   // Label 6755: @373128
     /*  373128 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(373194), // Rule ID 60784 //
     /*  373133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  373144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  373147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  373150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373172 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373192 */     GIR_RootConstrainSelectedInstOperands,
     /*  373193 */     // GIR_Coverage, 60784,
     /*  373193 */     GIR_EraseRootFromParent_Done,
     /*  373194 */   // Label 6756: @373194
     /*  373194 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(373260), // Rule ID 60785 //
     /*  373199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  373210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  373213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  373216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  373231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373238 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  373241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373258 */     GIR_RootConstrainSelectedInstOperands,
     /*  373259 */     // GIR_Coverage, 60785,
     /*  373259 */     GIR_EraseRootFromParent_Done,
     /*  373260 */   // Label 6757: @373260
     /*  373260 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(373326), // Rule ID 60788 //
     /*  373265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  373276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  373279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  373282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373304 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  373304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373324 */     GIR_RootConstrainSelectedInstOperands,
     /*  373325 */     // GIR_Coverage, 60788,
     /*  373325 */     GIR_EraseRootFromParent_Done,
     /*  373326 */   // Label 6758: @373326
     /*  373326 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(373392), // Rule ID 60789 //
     /*  373331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  373339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  373342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  373345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  373348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  373363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373370 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  373370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  373373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  373387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373390 */     GIR_RootConstrainSelectedInstOperands,
     /*  373391 */     // GIR_Coverage, 60789,
     /*  373391 */     GIR_EraseRootFromParent_Done,
     /*  373392 */   // Label 6759: @373392
     /*  373392 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(373458), // Rule ID 60792 //
     /*  373397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  373408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  373411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  373414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373436 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  373439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373456 */     GIR_RootConstrainSelectedInstOperands,
     /*  373457 */     // GIR_Coverage, 60792,
     /*  373457 */     GIR_EraseRootFromParent_Done,
     /*  373458 */   // Label 6760: @373458
     /*  373458 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(373524), // Rule ID 60793 //
     /*  373463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  373474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  373477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  373480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373502 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  373505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373522 */     GIR_RootConstrainSelectedInstOperands,
     /*  373523 */     // GIR_Coverage, 60793,
     /*  373523 */     GIR_EraseRootFromParent_Done,
     /*  373524 */   // Label 6761: @373524
     /*  373524 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(373590), // Rule ID 60796 //
     /*  373529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  373540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  373543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  373546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373568 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373588 */     GIR_RootConstrainSelectedInstOperands,
     /*  373589 */     // GIR_Coverage, 60796,
     /*  373589 */     GIR_EraseRootFromParent_Done,
     /*  373590 */   // Label 6762: @373590
     /*  373590 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(373656), // Rule ID 60797 //
     /*  373595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  373606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  373609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  373612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373634 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373654 */     GIR_RootConstrainSelectedInstOperands,
     /*  373655 */     // GIR_Coverage, 60797,
     /*  373655 */     GIR_EraseRootFromParent_Done,
     /*  373656 */   // Label 6763: @373656
     /*  373656 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(373722), // Rule ID 60800 //
     /*  373661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  373672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  373675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  373678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373700 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373720 */     GIR_RootConstrainSelectedInstOperands,
     /*  373721 */     // GIR_Coverage, 60800,
     /*  373721 */     GIR_EraseRootFromParent_Done,
     /*  373722 */   // Label 6764: @373722
     /*  373722 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(373788), // Rule ID 60801 //
     /*  373727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  373738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  373741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  373744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373786 */     GIR_RootConstrainSelectedInstOperands,
     /*  373787 */     // GIR_Coverage, 60801,
     /*  373787 */     GIR_EraseRootFromParent_Done,
     /*  373788 */   // Label 6765: @373788
     /*  373788 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(373854), // Rule ID 60804 //
     /*  373793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  373804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  373807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  373810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373832 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373852 */     GIR_RootConstrainSelectedInstOperands,
     /*  373853 */     // GIR_Coverage, 60804,
     /*  373853 */     GIR_EraseRootFromParent_Done,
     /*  373854 */   // Label 6766: @373854
     /*  373854 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(373920), // Rule ID 60805 //
     /*  373859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  373870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  373873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  373876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373918 */     GIR_RootConstrainSelectedInstOperands,
     /*  373919 */     // GIR_Coverage, 60805,
     /*  373919 */     GIR_EraseRootFromParent_Done,
     /*  373920 */   // Label 6767: @373920
     /*  373920 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(373986), // Rule ID 60808 //
     /*  373925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  373936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  373939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  373942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373984 */     GIR_RootConstrainSelectedInstOperands,
     /*  373985 */     // GIR_Coverage, 60808,
     /*  373985 */     GIR_EraseRootFromParent_Done,
     /*  373986 */   // Label 6768: @373986
     /*  373986 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(374052), // Rule ID 60809 //
     /*  373991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  374002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  374005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  374008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374030 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374050 */     GIR_RootConstrainSelectedInstOperands,
     /*  374051 */     // GIR_Coverage, 60809,
     /*  374051 */     GIR_EraseRootFromParent_Done,
     /*  374052 */   // Label 6769: @374052
     /*  374052 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(374118), // Rule ID 60812 //
     /*  374057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  374068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  374071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  374074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374096 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374116 */     GIR_RootConstrainSelectedInstOperands,
     /*  374117 */     // GIR_Coverage, 60812,
     /*  374117 */     GIR_EraseRootFromParent_Done,
     /*  374118 */   // Label 6770: @374118
     /*  374118 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(374184), // Rule ID 60813 //
     /*  374123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  374134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  374137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  374140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374162 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  374165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374182 */     GIR_RootConstrainSelectedInstOperands,
     /*  374183 */     // GIR_Coverage, 60813,
     /*  374183 */     GIR_EraseRootFromParent_Done,
     /*  374184 */   // Label 6771: @374184
     /*  374184 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(374250), // Rule ID 60816 //
     /*  374189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  374200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  374203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  374206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374228 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374248 */     GIR_RootConstrainSelectedInstOperands,
     /*  374249 */     // GIR_Coverage, 60816,
     /*  374249 */     GIR_EraseRootFromParent_Done,
     /*  374250 */   // Label 6772: @374250
     /*  374250 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(374316), // Rule ID 60817 //
     /*  374255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  374266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  374269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  374272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374294 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11179:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374314 */     GIR_RootConstrainSelectedInstOperands,
     /*  374315 */     // GIR_Coverage, 60817,
     /*  374315 */     GIR_EraseRootFromParent_Done,
     /*  374316 */   // Label 6773: @374316
     /*  374316 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(374382), // Rule ID 60820 //
     /*  374321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  374332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  374335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  374338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374380 */     GIR_RootConstrainSelectedInstOperands,
     /*  374381 */     // GIR_Coverage, 60820,
     /*  374381 */     GIR_EraseRootFromParent_Done,
     /*  374382 */   // Label 6774: @374382
     /*  374382 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(374448), // Rule ID 60821 //
     /*  374387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  374398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  374401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  374404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374426 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374446 */     GIR_RootConstrainSelectedInstOperands,
     /*  374447 */     // GIR_Coverage, 60821,
     /*  374447 */     GIR_EraseRootFromParent_Done,
     /*  374448 */   // Label 6775: @374448
     /*  374448 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(374514), // Rule ID 60824 //
     /*  374453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  374464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  374467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  374470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  374492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374512 */     GIR_RootConstrainSelectedInstOperands,
     /*  374513 */     // GIR_Coverage, 60824,
     /*  374513 */     GIR_EraseRootFromParent_Done,
     /*  374514 */   // Label 6776: @374514
     /*  374514 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(374580), // Rule ID 60825 //
     /*  374519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  374530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  374533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  374536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374578 */     GIR_RootConstrainSelectedInstOperands,
     /*  374579 */     // GIR_Coverage, 60825,
     /*  374579 */     GIR_EraseRootFromParent_Done,
     /*  374580 */   // Label 6777: @374580
     /*  374580 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(374646), // Rule ID 60828 //
     /*  374585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  374596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  374599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  374602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  374624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374644 */     GIR_RootConstrainSelectedInstOperands,
     /*  374645 */     // GIR_Coverage, 60828,
     /*  374645 */     GIR_EraseRootFromParent_Done,
     /*  374646 */   // Label 6778: @374646
     /*  374646 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(374712), // Rule ID 60829 //
     /*  374651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  374662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  374665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  374668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374710 */     GIR_RootConstrainSelectedInstOperands,
     /*  374711 */     // GIR_Coverage, 60829,
     /*  374711 */     GIR_EraseRootFromParent_Done,
     /*  374712 */   // Label 6779: @374712
     /*  374712 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(374778), // Rule ID 60832 //
     /*  374717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  374728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  374731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  374734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374756 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  374759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374776 */     GIR_RootConstrainSelectedInstOperands,
     /*  374777 */     // GIR_Coverage, 60832,
     /*  374777 */     GIR_EraseRootFromParent_Done,
     /*  374778 */   // Label 6780: @374778
     /*  374778 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(374844), // Rule ID 60833 //
     /*  374783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  374794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  374797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  374800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374822 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  374825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374842 */     GIR_RootConstrainSelectedInstOperands,
     /*  374843 */     // GIR_Coverage, 60833,
     /*  374843 */     GIR_EraseRootFromParent_Done,
     /*  374844 */   // Label 6781: @374844
     /*  374844 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(374910), // Rule ID 60836 //
     /*  374849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  374860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  374863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  374866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374888 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  374891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374908 */     GIR_RootConstrainSelectedInstOperands,
     /*  374909 */     // GIR_Coverage, 60836,
     /*  374909 */     GIR_EraseRootFromParent_Done,
     /*  374910 */   // Label 6782: @374910
     /*  374910 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(374976), // Rule ID 60837 //
     /*  374915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  374926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  374929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  374932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374954 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  374957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374974 */     GIR_RootConstrainSelectedInstOperands,
     /*  374975 */     // GIR_Coverage, 60837,
     /*  374975 */     GIR_EraseRootFromParent_Done,
     /*  374976 */   // Label 6783: @374976
     /*  374976 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(375042), // Rule ID 60840 //
     /*  374981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  374992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  374995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  374998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375020 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375040 */     GIR_RootConstrainSelectedInstOperands,
     /*  375041 */     // GIR_Coverage, 60840,
     /*  375041 */     GIR_EraseRootFromParent_Done,
     /*  375042 */   // Label 6784: @375042
     /*  375042 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(375108), // Rule ID 60841 //
     /*  375047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  375058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  375061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  375064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375086 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375106 */     GIR_RootConstrainSelectedInstOperands,
     /*  375107 */     // GIR_Coverage, 60841,
     /*  375107 */     GIR_EraseRootFromParent_Done,
     /*  375108 */   // Label 6785: @375108
     /*  375108 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(375174), // Rule ID 60844 //
     /*  375113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  375124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  375127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  375130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375172 */     GIR_RootConstrainSelectedInstOperands,
     /*  375173 */     // GIR_Coverage, 60844,
     /*  375173 */     GIR_EraseRootFromParent_Done,
     /*  375174 */   // Label 6786: @375174
     /*  375174 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(375240), // Rule ID 60845 //
     /*  375179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  375190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  375193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  375196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375238 */     GIR_RootConstrainSelectedInstOperands,
     /*  375239 */     // GIR_Coverage, 60845,
     /*  375239 */     GIR_EraseRootFromParent_Done,
     /*  375240 */   // Label 6787: @375240
     /*  375240 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(375306), // Rule ID 60848 //
     /*  375245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  375256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  375259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  375262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375304 */     GIR_RootConstrainSelectedInstOperands,
     /*  375305 */     // GIR_Coverage, 60848,
     /*  375305 */     GIR_EraseRootFromParent_Done,
     /*  375306 */   // Label 6788: @375306
     /*  375306 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(375372), // Rule ID 60849 //
     /*  375311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  375322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  375325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  375328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375370 */     GIR_RootConstrainSelectedInstOperands,
     /*  375371 */     // GIR_Coverage, 60849,
     /*  375371 */     GIR_EraseRootFromParent_Done,
     /*  375372 */   // Label 6789: @375372
     /*  375372 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(375438), // Rule ID 60852 //
     /*  375377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  375388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  375391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  375394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375416 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  375416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375436 */     GIR_RootConstrainSelectedInstOperands,
     /*  375437 */     // GIR_Coverage, 60852,
     /*  375437 */     GIR_EraseRootFromParent_Done,
     /*  375438 */   // Label 6790: @375438
     /*  375438 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(375504), // Rule ID 60853 //
     /*  375443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  375454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  375457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  375460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375482 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  375482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  375499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375502 */     GIR_RootConstrainSelectedInstOperands,
     /*  375503 */     // GIR_Coverage, 60853,
     /*  375503 */     GIR_EraseRootFromParent_Done,
     /*  375504 */   // Label 6791: @375504
     /*  375504 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(375570), // Rule ID 60856 //
     /*  375509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  375520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  375523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  375526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375568 */     GIR_RootConstrainSelectedInstOperands,
     /*  375569 */     // GIR_Coverage, 60856,
     /*  375569 */     GIR_EraseRootFromParent_Done,
     /*  375570 */   // Label 6792: @375570
     /*  375570 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(375636), // Rule ID 60857 //
     /*  375575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  375586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  375589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  375592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375634 */     GIR_RootConstrainSelectedInstOperands,
     /*  375635 */     // GIR_Coverage, 60857,
     /*  375635 */     GIR_EraseRootFromParent_Done,
     /*  375636 */   // Label 6793: @375636
     /*  375636 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(375702), // Rule ID 60860 //
     /*  375641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  375652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  375655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  375658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375680 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375700 */     GIR_RootConstrainSelectedInstOperands,
     /*  375701 */     // GIR_Coverage, 60860,
     /*  375701 */     GIR_EraseRootFromParent_Done,
     /*  375702 */   // Label 6794: @375702
     /*  375702 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(375768), // Rule ID 60861 //
     /*  375707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  375718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  375721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  375724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375766 */     GIR_RootConstrainSelectedInstOperands,
     /*  375767 */     // GIR_Coverage, 60861,
     /*  375767 */     GIR_EraseRootFromParent_Done,
     /*  375768 */   // Label 6795: @375768
     /*  375768 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(375834), // Rule ID 60864 //
     /*  375773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  375784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  375787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  375790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375812 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375832 */     GIR_RootConstrainSelectedInstOperands,
     /*  375833 */     // GIR_Coverage, 60864,
     /*  375833 */     GIR_EraseRootFromParent_Done,
     /*  375834 */   // Label 6796: @375834
     /*  375834 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(375900), // Rule ID 60865 //
     /*  375839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  375850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  375853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  375856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375898 */     GIR_RootConstrainSelectedInstOperands,
     /*  375899 */     // GIR_Coverage, 60865,
     /*  375899 */     GIR_EraseRootFromParent_Done,
     /*  375900 */   // Label 6797: @375900
     /*  375900 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(375966), // Rule ID 60868 //
     /*  375905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  375916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  375919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  375922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375964 */     GIR_RootConstrainSelectedInstOperands,
     /*  375965 */     // GIR_Coverage, 60868,
     /*  375965 */     GIR_EraseRootFromParent_Done,
     /*  375966 */   // Label 6798: @375966
     /*  375966 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(376032), // Rule ID 60869 //
     /*  375971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  375982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  375985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  375988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  376003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  376013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376030 */     GIR_RootConstrainSelectedInstOperands,
     /*  376031 */     // GIR_Coverage, 60869,
     /*  376031 */     GIR_EraseRootFromParent_Done,
     /*  376032 */   // Label 6799: @376032
     /*  376032 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(376098), // Rule ID 60872 //
     /*  376037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376076 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376096 */     GIR_RootConstrainSelectedInstOperands,
     /*  376097 */     // GIR_Coverage, 60872,
     /*  376097 */     GIR_EraseRootFromParent_Done,
     /*  376098 */   // Label 6800: @376098
     /*  376098 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(376164), // Rule ID 60873 //
     /*  376103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  376114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  376117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  376120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  376135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376142 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  376145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376162 */     GIR_RootConstrainSelectedInstOperands,
     /*  376163 */     // GIR_Coverage, 60873,
     /*  376163 */     GIR_EraseRootFromParent_Done,
     /*  376164 */   // Label 6801: @376164
     /*  376164 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(376230), // Rule ID 60876 //
     /*  376169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  376180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  376183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  376186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  376208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376228 */     GIR_RootConstrainSelectedInstOperands,
     /*  376229 */     // GIR_Coverage, 60876,
     /*  376229 */     GIR_EraseRootFromParent_Done,
     /*  376230 */   // Label 6802: @376230
     /*  376230 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(376296), // Rule ID 60877 //
     /*  376235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  376243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  376246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  376249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  376252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  376267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  376274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  376277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  376291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376294 */     GIR_RootConstrainSelectedInstOperands,
     /*  376295 */     // GIR_Coverage, 60877,
     /*  376295 */     GIR_EraseRootFromParent_Done,
     /*  376296 */   // Label 6803: @376296
     /*  376296 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(376362), // Rule ID 60880 //
     /*  376301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  376312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  376315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  376318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376340 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  376343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376360 */     GIR_RootConstrainSelectedInstOperands,
     /*  376361 */     // GIR_Coverage, 60880,
     /*  376361 */     GIR_EraseRootFromParent_Done,
     /*  376362 */   // Label 6804: @376362
     /*  376362 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(376428), // Rule ID 60881 //
     /*  376367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  376378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  376381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  376384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376406 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  376409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376426 */     GIR_RootConstrainSelectedInstOperands,
     /*  376427 */     // GIR_Coverage, 60881,
     /*  376427 */     GIR_EraseRootFromParent_Done,
     /*  376428 */   // Label 6805: @376428
     /*  376428 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(376494), // Rule ID 60884 //
     /*  376433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  376444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  376447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  376450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376472 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376492 */     GIR_RootConstrainSelectedInstOperands,
     /*  376493 */     // GIR_Coverage, 60884,
     /*  376493 */     GIR_EraseRootFromParent_Done,
     /*  376494 */   // Label 6806: @376494
     /*  376494 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(376560), // Rule ID 60885 //
     /*  376499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  376510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  376513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  376516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376538 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376558 */     GIR_RootConstrainSelectedInstOperands,
     /*  376559 */     // GIR_Coverage, 60885,
     /*  376559 */     GIR_EraseRootFromParent_Done,
     /*  376560 */   // Label 6807: @376560
     /*  376560 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(376626), // Rule ID 60888 //
     /*  376565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  376576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  376579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  376582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376604 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376624 */     GIR_RootConstrainSelectedInstOperands,
     /*  376625 */     // GIR_Coverage, 60888,
     /*  376625 */     GIR_EraseRootFromParent_Done,
     /*  376626 */   // Label 6808: @376626
     /*  376626 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(376692), // Rule ID 60889 //
     /*  376631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  376642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  376645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  376648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376670 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376690 */     GIR_RootConstrainSelectedInstOperands,
     /*  376691 */     // GIR_Coverage, 60889,
     /*  376691 */     GIR_EraseRootFromParent_Done,
     /*  376692 */   // Label 6809: @376692
     /*  376692 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(376758), // Rule ID 60892 //
     /*  376697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  376708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  376711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  376714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376736 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376756 */     GIR_RootConstrainSelectedInstOperands,
     /*  376757 */     // GIR_Coverage, 60892,
     /*  376757 */     GIR_EraseRootFromParent_Done,
     /*  376758 */   // Label 6810: @376758
     /*  376758 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(376824), // Rule ID 60893 //
     /*  376763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  376774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  376777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  376780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376822 */     GIR_RootConstrainSelectedInstOperands,
     /*  376823 */     // GIR_Coverage, 60893,
     /*  376823 */     GIR_EraseRootFromParent_Done,
     /*  376824 */   // Label 6811: @376824
     /*  376824 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(376890), // Rule ID 60896 //
     /*  376829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  376840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  376843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  376846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376868 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376888 */     GIR_RootConstrainSelectedInstOperands,
     /*  376889 */     // GIR_Coverage, 60896,
     /*  376889 */     GIR_EraseRootFromParent_Done,
     /*  376890 */   // Label 6812: @376890
     /*  376890 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(376956), // Rule ID 60897 //
     /*  376895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  376906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  376909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  376912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376954 */     GIR_RootConstrainSelectedInstOperands,
     /*  376955 */     // GIR_Coverage, 60897,
     /*  376955 */     GIR_EraseRootFromParent_Done,
     /*  376956 */   // Label 6813: @376956
     /*  376956 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(377022), // Rule ID 60900 //
     /*  376961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  376972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  376975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  376978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377020 */     GIR_RootConstrainSelectedInstOperands,
     /*  377021 */     // GIR_Coverage, 60900,
     /*  377021 */     GIR_EraseRootFromParent_Done,
     /*  377022 */   // Label 6814: @377022
     /*  377022 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(377088), // Rule ID 60901 //
     /*  377027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  377038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  377041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  377044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  377066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  377069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377086 */     GIR_RootConstrainSelectedInstOperands,
     /*  377087 */     // GIR_Coverage, 60901,
     /*  377087 */     GIR_EraseRootFromParent_Done,
     /*  377088 */   // Label 6815: @377088
     /*  377088 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(377154), // Rule ID 60904 //
     /*  377093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  377104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  377107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  377110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377132 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377152 */     GIR_RootConstrainSelectedInstOperands,
     /*  377153 */     // GIR_Coverage, 60904,
     /*  377153 */     GIR_EraseRootFromParent_Done,
     /*  377154 */   // Label 6816: @377154
     /*  377154 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(377220), // Rule ID 60905 //
     /*  377159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  377170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  377173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  377176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377198 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11177:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377218 */     GIR_RootConstrainSelectedInstOperands,
     /*  377219 */     // GIR_Coverage, 60905,
     /*  377219 */     GIR_EraseRootFromParent_Done,
     /*  377220 */   // Label 6817: @377220
     /*  377220 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(377286), // Rule ID 60908 //
     /*  377225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  377236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  377239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  377242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377264 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377284 */     GIR_RootConstrainSelectedInstOperands,
     /*  377285 */     // GIR_Coverage, 60908,
     /*  377285 */     GIR_EraseRootFromParent_Done,
     /*  377286 */   // Label 6818: @377286
     /*  377286 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(377352), // Rule ID 60909 //
     /*  377291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  377302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  377305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  377308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377350 */     GIR_RootConstrainSelectedInstOperands,
     /*  377351 */     // GIR_Coverage, 60909,
     /*  377351 */     GIR_EraseRootFromParent_Done,
     /*  377352 */   // Label 6819: @377352
     /*  377352 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(377418), // Rule ID 60912 //
     /*  377357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  377368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  377371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  377374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377396 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377416 */     GIR_RootConstrainSelectedInstOperands,
     /*  377417 */     // GIR_Coverage, 60912,
     /*  377417 */     GIR_EraseRootFromParent_Done,
     /*  377418 */   // Label 6820: @377418
     /*  377418 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(377484), // Rule ID 60913 //
     /*  377423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  377434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  377437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  377440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377462 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  377462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377482 */     GIR_RootConstrainSelectedInstOperands,
     /*  377483 */     // GIR_Coverage, 60913,
     /*  377483 */     GIR_EraseRootFromParent_Done,
     /*  377484 */   // Label 6821: @377484
     /*  377484 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(377550), // Rule ID 60916 //
     /*  377489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  377500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  377503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  377506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377528 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  377528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377548 */     GIR_RootConstrainSelectedInstOperands,
     /*  377549 */     // GIR_Coverage, 60916,
     /*  377549 */     GIR_EraseRootFromParent_Done,
     /*  377550 */   // Label 6822: @377550
     /*  377550 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(377616), // Rule ID 60917 //
     /*  377555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  377566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  377569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  377572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  377594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377614 */     GIR_RootConstrainSelectedInstOperands,
     /*  377615 */     // GIR_Coverage, 60917,
     /*  377615 */     GIR_EraseRootFromParent_Done,
     /*  377616 */   // Label 6823: @377616
     /*  377616 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(377682), // Rule ID 60920 //
     /*  377621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  377632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  377635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  377638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377660 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  377663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377680 */     GIR_RootConstrainSelectedInstOperands,
     /*  377681 */     // GIR_Coverage, 60920,
     /*  377681 */     GIR_EraseRootFromParent_Done,
     /*  377682 */   // Label 6824: @377682
     /*  377682 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(377748), // Rule ID 60921 //
     /*  377687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  377698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  377701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  377704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  377729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377746 */     GIR_RootConstrainSelectedInstOperands,
     /*  377747 */     // GIR_Coverage, 60921,
     /*  377747 */     GIR_EraseRootFromParent_Done,
     /*  377748 */   // Label 6825: @377748
     /*  377748 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(377814), // Rule ID 60924 //
     /*  377753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  377764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  377767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  377770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377792 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  377795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377812 */     GIR_RootConstrainSelectedInstOperands,
     /*  377813 */     // GIR_Coverage, 60924,
     /*  377813 */     GIR_EraseRootFromParent_Done,
     /*  377814 */   // Label 6826: @377814
     /*  377814 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(377880), // Rule ID 60925 //
     /*  377819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  377830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  377833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  377836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  377861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377878 */     GIR_RootConstrainSelectedInstOperands,
     /*  377879 */     // GIR_Coverage, 60925,
     /*  377879 */     GIR_EraseRootFromParent_Done,
     /*  377880 */   // Label 6827: @377880
     /*  377880 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(377946), // Rule ID 60928 //
     /*  377885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  377896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  377899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  377902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377924 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  377927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377944 */     GIR_RootConstrainSelectedInstOperands,
     /*  377945 */     // GIR_Coverage, 60928,
     /*  377945 */     GIR_EraseRootFromParent_Done,
     /*  377946 */   // Label 6828: @377946
     /*  377946 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(378012), // Rule ID 60929 //
     /*  377951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  377962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  377965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  377968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377990 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  377993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378010 */     GIR_RootConstrainSelectedInstOperands,
     /*  378011 */     // GIR_Coverage, 60929,
     /*  378011 */     GIR_EraseRootFromParent_Done,
     /*  378012 */   // Label 6829: @378012
     /*  378012 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(378078), // Rule ID 60932 //
     /*  378017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378056 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378076 */     GIR_RootConstrainSelectedInstOperands,
     /*  378077 */     // GIR_Coverage, 60932,
     /*  378077 */     GIR_EraseRootFromParent_Done,
     /*  378078 */   // Label 6830: @378078
     /*  378078 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(378144), // Rule ID 60933 //
     /*  378083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  378094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  378097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  378100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378142 */     GIR_RootConstrainSelectedInstOperands,
     /*  378143 */     // GIR_Coverage, 60933,
     /*  378143 */     GIR_EraseRootFromParent_Done,
     /*  378144 */   // Label 6831: @378144
     /*  378144 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(378210), // Rule ID 60936 //
     /*  378149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  378160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  378163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  378166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378188 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378208 */     GIR_RootConstrainSelectedInstOperands,
     /*  378209 */     // GIR_Coverage, 60936,
     /*  378209 */     GIR_EraseRootFromParent_Done,
     /*  378210 */   // Label 6832: @378210
     /*  378210 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(378276), // Rule ID 60937 //
     /*  378215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  378226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  378229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  378232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378254 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378274 */     GIR_RootConstrainSelectedInstOperands,
     /*  378275 */     // GIR_Coverage, 60937,
     /*  378275 */     GIR_EraseRootFromParent_Done,
     /*  378276 */   // Label 6833: @378276
     /*  378276 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(378342), // Rule ID 60940 //
     /*  378281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  378292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  378295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  378298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378320 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  378320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378340 */     GIR_RootConstrainSelectedInstOperands,
     /*  378341 */     // GIR_Coverage, 60940,
     /*  378341 */     GIR_EraseRootFromParent_Done,
     /*  378342 */   // Label 6834: @378342
     /*  378342 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(378408), // Rule ID 60941 //
     /*  378347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  378358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  378361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  378364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378386 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  378386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  378403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378406 */     GIR_RootConstrainSelectedInstOperands,
     /*  378407 */     // GIR_Coverage, 60941,
     /*  378407 */     GIR_EraseRootFromParent_Done,
     /*  378408 */   // Label 6835: @378408
     /*  378408 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(378474), // Rule ID 60944 //
     /*  378413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  378424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  378427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  378430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378472 */     GIR_RootConstrainSelectedInstOperands,
     /*  378473 */     // GIR_Coverage, 60944,
     /*  378473 */     GIR_EraseRootFromParent_Done,
     /*  378474 */   // Label 6836: @378474
     /*  378474 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(378540), // Rule ID 60945 //
     /*  378479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  378490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  378493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  378496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378538 */     GIR_RootConstrainSelectedInstOperands,
     /*  378539 */     // GIR_Coverage, 60945,
     /*  378539 */     GIR_EraseRootFromParent_Done,
     /*  378540 */   // Label 6837: @378540
     /*  378540 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(378606), // Rule ID 60948 //
     /*  378545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  378556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  378559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  378562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378604 */     GIR_RootConstrainSelectedInstOperands,
     /*  378605 */     // GIR_Coverage, 60948,
     /*  378605 */     GIR_EraseRootFromParent_Done,
     /*  378606 */   // Label 6838: @378606
     /*  378606 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(378672), // Rule ID 60949 //
     /*  378611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  378622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  378625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  378628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378670 */     GIR_RootConstrainSelectedInstOperands,
     /*  378671 */     // GIR_Coverage, 60949,
     /*  378671 */     GIR_EraseRootFromParent_Done,
     /*  378672 */   // Label 6839: @378672
     /*  378672 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(378738), // Rule ID 60952 //
     /*  378677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  378688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  378691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  378694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378716 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378736 */     GIR_RootConstrainSelectedInstOperands,
     /*  378737 */     // GIR_Coverage, 60952,
     /*  378737 */     GIR_EraseRootFromParent_Done,
     /*  378738 */   // Label 6840: @378738
     /*  378738 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(378804), // Rule ID 60953 //
     /*  378743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  378754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  378757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  378760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378782 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378802 */     GIR_RootConstrainSelectedInstOperands,
     /*  378803 */     // GIR_Coverage, 60953,
     /*  378803 */     GIR_EraseRootFromParent_Done,
     /*  378804 */   // Label 6841: @378804
     /*  378804 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(378870), // Rule ID 60956 //
     /*  378809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  378820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  378823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  378826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378868 */     GIR_RootConstrainSelectedInstOperands,
     /*  378869 */     // GIR_Coverage, 60956,
     /*  378869 */     GIR_EraseRootFromParent_Done,
     /*  378870 */   // Label 6842: @378870
     /*  378870 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(378936), // Rule ID 60957 //
     /*  378875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  378886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  378889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  378892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378914 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378934 */     GIR_RootConstrainSelectedInstOperands,
     /*  378935 */     // GIR_Coverage, 60957,
     /*  378935 */     GIR_EraseRootFromParent_Done,
     /*  378936 */   // Label 6843: @378936
     /*  378936 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(379002), // Rule ID 60960 //
     /*  378941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  378952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  378955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  378958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379000 */     GIR_RootConstrainSelectedInstOperands,
     /*  379001 */     // GIR_Coverage, 60960,
     /*  379001 */     GIR_EraseRootFromParent_Done,
     /*  379002 */   // Label 6844: @379002
     /*  379002 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(379068), // Rule ID 60961 //
     /*  379007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  379018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  379021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  379024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  379039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379046 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  379049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379066 */     GIR_RootConstrainSelectedInstOperands,
     /*  379067 */     // GIR_Coverage, 60961,
     /*  379067 */     GIR_EraseRootFromParent_Done,
     /*  379068 */   // Label 6845: @379068
     /*  379068 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(379134), // Rule ID 60964 //
     /*  379073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  379076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  379084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  379087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  379090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379112 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379132 */     GIR_RootConstrainSelectedInstOperands,
     /*  379133 */     // GIR_Coverage, 60964,
     /*  379133 */     GIR_EraseRootFromParent_Done,
     /*  379134 */   // Label 6846: @379134
     /*  379134 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(379200), // Rule ID 60965 //
     /*  379139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  379142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  379147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  379150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  379153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  379156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  379171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379178 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  379181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379198 */     GIR_RootConstrainSelectedInstOperands,
     /*  379199 */     // GIR_Coverage, 60965,
     /*  379199 */     GIR_EraseRootFromParent_Done,
     /*  379200 */   // Label 6847: @379200
     /*  379200 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(379266), // Rule ID 61388 //
     /*  379205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  379247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379264 */     GIR_RootConstrainSelectedInstOperands,
     /*  379265 */     // GIR_Coverage, 61388,
     /*  379265 */     GIR_EraseRootFromParent_Done,
     /*  379266 */   // Label 6848: @379266
     /*  379266 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(379332), // Rule ID 61389 //
     /*  379271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  379282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  379285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  379288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379310 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  379313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379330 */     GIR_RootConstrainSelectedInstOperands,
     /*  379331 */     // GIR_Coverage, 61389,
     /*  379331 */     GIR_EraseRootFromParent_Done,
     /*  379332 */   // Label 6849: @379332
     /*  379332 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(379398), // Rule ID 61392 //
     /*  379337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379396 */     GIR_RootConstrainSelectedInstOperands,
     /*  379397 */     // GIR_Coverage, 61392,
     /*  379397 */     GIR_EraseRootFromParent_Done,
     /*  379398 */   // Label 6850: @379398
     /*  379398 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(379464), // Rule ID 61393 //
     /*  379403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  379414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  379417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  379420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379442 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379462 */     GIR_RootConstrainSelectedInstOperands,
     /*  379463 */     // GIR_Coverage, 61393,
     /*  379463 */     GIR_EraseRootFromParent_Done,
     /*  379464 */   // Label 6851: @379464
     /*  379464 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(379530), // Rule ID 61396 //
     /*  379469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  379480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  379483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  379486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379528 */     GIR_RootConstrainSelectedInstOperands,
     /*  379529 */     // GIR_Coverage, 61396,
     /*  379529 */     GIR_EraseRootFromParent_Done,
     /*  379530 */   // Label 6852: @379530
     /*  379530 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(379596), // Rule ID 61397 //
     /*  379535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  379546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  379549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  379552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379574 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379594 */     GIR_RootConstrainSelectedInstOperands,
     /*  379595 */     // GIR_Coverage, 61397,
     /*  379595 */     GIR_EraseRootFromParent_Done,
     /*  379596 */   // Label 6853: @379596
     /*  379596 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(379662), // Rule ID 61400 //
     /*  379601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  379612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  379615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  379618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379640 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379660 */     GIR_RootConstrainSelectedInstOperands,
     /*  379661 */     // GIR_Coverage, 61400,
     /*  379661 */     GIR_EraseRootFromParent_Done,
     /*  379662 */   // Label 6854: @379662
     /*  379662 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(379728), // Rule ID 61401 //
     /*  379667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  379678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  379681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  379684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379726 */     GIR_RootConstrainSelectedInstOperands,
     /*  379727 */     // GIR_Coverage, 61401,
     /*  379727 */     GIR_EraseRootFromParent_Done,
     /*  379728 */   // Label 6855: @379728
     /*  379728 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(379794), // Rule ID 61404 //
     /*  379733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  379744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  379747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  379750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379772 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379792 */     GIR_RootConstrainSelectedInstOperands,
     /*  379793 */     // GIR_Coverage, 61404,
     /*  379793 */     GIR_EraseRootFromParent_Done,
     /*  379794 */   // Label 6856: @379794
     /*  379794 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(379860), // Rule ID 61405 //
     /*  379799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  379810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  379813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  379816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379838 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379858 */     GIR_RootConstrainSelectedInstOperands,
     /*  379859 */     // GIR_Coverage, 61405,
     /*  379859 */     GIR_EraseRootFromParent_Done,
     /*  379860 */   // Label 6857: @379860
     /*  379860 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(379926), // Rule ID 61408 //
     /*  379865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  379876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  379879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  379882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379904 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379924 */     GIR_RootConstrainSelectedInstOperands,
     /*  379925 */     // GIR_Coverage, 61408,
     /*  379925 */     GIR_EraseRootFromParent_Done,
     /*  379926 */   // Label 6858: @379926
     /*  379926 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(379992), // Rule ID 61409 //
     /*  379931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  379942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  379945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  379948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379970 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379990 */     GIR_RootConstrainSelectedInstOperands,
     /*  379991 */     // GIR_Coverage, 61409,
     /*  379991 */     GIR_EraseRootFromParent_Done,
     /*  379992 */   // Label 6859: @379992
     /*  379992 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(380058), // Rule ID 61412 //
     /*  379997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380036 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380056 */     GIR_RootConstrainSelectedInstOperands,
     /*  380057 */     // GIR_Coverage, 61412,
     /*  380057 */     GIR_EraseRootFromParent_Done,
     /*  380058 */   // Label 6860: @380058
     /*  380058 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(380124), // Rule ID 61413 //
     /*  380063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  380074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  380077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  380080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380122 */     GIR_RootConstrainSelectedInstOperands,
     /*  380123 */     // GIR_Coverage, 61413,
     /*  380123 */     GIR_EraseRootFromParent_Done,
     /*  380124 */   // Label 6861: @380124
     /*  380124 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(380190), // Rule ID 61416 //
     /*  380129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380188 */     GIR_RootConstrainSelectedInstOperands,
     /*  380189 */     // GIR_Coverage, 61416,
     /*  380189 */     GIR_EraseRootFromParent_Done,
     /*  380190 */   // Label 6862: @380190
     /*  380190 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(380256), // Rule ID 61417 //
     /*  380195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  380206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  380209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  380212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380234 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380254 */     GIR_RootConstrainSelectedInstOperands,
     /*  380255 */     // GIR_Coverage, 61417,
     /*  380255 */     GIR_EraseRootFromParent_Done,
     /*  380256 */   // Label 6863: @380256
     /*  380256 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(380322), // Rule ID 61420 //
     /*  380261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380320 */     GIR_RootConstrainSelectedInstOperands,
     /*  380321 */     // GIR_Coverage, 61420,
     /*  380321 */     GIR_EraseRootFromParent_Done,
     /*  380322 */   // Label 6864: @380322
     /*  380322 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(380388), // Rule ID 61421 //
     /*  380327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  380338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  380341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  380344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380386 */     GIR_RootConstrainSelectedInstOperands,
     /*  380387 */     // GIR_Coverage, 61421,
     /*  380387 */     GIR_EraseRootFromParent_Done,
     /*  380388 */   // Label 6865: @380388
     /*  380388 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(380454), // Rule ID 61424 //
     /*  380393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  380432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380452 */     GIR_RootConstrainSelectedInstOperands,
     /*  380453 */     // GIR_Coverage, 61424,
     /*  380453 */     GIR_EraseRootFromParent_Done,
     /*  380454 */   // Label 6866: @380454
     /*  380454 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(380520), // Rule ID 61425 //
     /*  380459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  380470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  380473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  380476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  380491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  380498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  380501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380518 */     GIR_RootConstrainSelectedInstOperands,
     /*  380519 */     // GIR_Coverage, 61425,
     /*  380519 */     GIR_EraseRootFromParent_Done,
     /*  380520 */   // Label 6867: @380520
     /*  380520 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(380586), // Rule ID 61428 //
     /*  380525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  380536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  380539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  380542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380584 */     GIR_RootConstrainSelectedInstOperands,
     /*  380585 */     // GIR_Coverage, 61428,
     /*  380585 */     GIR_EraseRootFromParent_Done,
     /*  380586 */   // Label 6868: @380586
     /*  380586 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(380652), // Rule ID 61429 //
     /*  380591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  380602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  380605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  380608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380630 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380650 */     GIR_RootConstrainSelectedInstOperands,
     /*  380651 */     // GIR_Coverage, 61429,
     /*  380651 */     GIR_EraseRootFromParent_Done,
     /*  380652 */   // Label 6869: @380652
     /*  380652 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(380718), // Rule ID 61432 //
     /*  380657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  380668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  380671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  380674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  380699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380716 */     GIR_RootConstrainSelectedInstOperands,
     /*  380717 */     // GIR_Coverage, 61432,
     /*  380717 */     GIR_EraseRootFromParent_Done,
     /*  380718 */   // Label 6870: @380718
     /*  380718 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(380784), // Rule ID 61433 //
     /*  380723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  380734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  380737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  380740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380762 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  380765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380782 */     GIR_RootConstrainSelectedInstOperands,
     /*  380783 */     // GIR_Coverage, 61433,
     /*  380783 */     GIR_EraseRootFromParent_Done,
     /*  380784 */   // Label 6871: @380784
     /*  380784 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(380850), // Rule ID 61436 //
     /*  380789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  380800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  380803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  380806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380828 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  380831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380848 */     GIR_RootConstrainSelectedInstOperands,
     /*  380849 */     // GIR_Coverage, 61436,
     /*  380849 */     GIR_EraseRootFromParent_Done,
     /*  380850 */   // Label 6872: @380850
     /*  380850 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(380916), // Rule ID 61437 //
     /*  380855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  380866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  380869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  380872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380894 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  380897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380914 */     GIR_RootConstrainSelectedInstOperands,
     /*  380915 */     // GIR_Coverage, 61437,
     /*  380915 */     GIR_EraseRootFromParent_Done,
     /*  380916 */   // Label 6873: @380916
     /*  380916 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(380982), // Rule ID 61440 //
     /*  380921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  380932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  380935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  380938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380960 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380980 */     GIR_RootConstrainSelectedInstOperands,
     /*  380981 */     // GIR_Coverage, 61440,
     /*  380981 */     GIR_EraseRootFromParent_Done,
     /*  380982 */   // Label 6874: @380982
     /*  380982 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(381048), // Rule ID 61441 //
     /*  380987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  380998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  381001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  381004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381046 */     GIR_RootConstrainSelectedInstOperands,
     /*  381047 */     // GIR_Coverage, 61441,
     /*  381047 */     GIR_EraseRootFromParent_Done,
     /*  381048 */   // Label 6875: @381048
     /*  381048 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(381114), // Rule ID 61444 //
     /*  381053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381092 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381112 */     GIR_RootConstrainSelectedInstOperands,
     /*  381113 */     // GIR_Coverage, 61444,
     /*  381113 */     GIR_EraseRootFromParent_Done,
     /*  381114 */   // Label 6876: @381114
     /*  381114 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(381180), // Rule ID 61445 //
     /*  381119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  381130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  381133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  381136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381158 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381178 */     GIR_RootConstrainSelectedInstOperands,
     /*  381179 */     // GIR_Coverage, 61445,
     /*  381179 */     GIR_EraseRootFromParent_Done,
     /*  381180 */   // Label 6877: @381180
     /*  381180 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(381246), // Rule ID 61448 //
     /*  381185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381224 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  381224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381244 */     GIR_RootConstrainSelectedInstOperands,
     /*  381245 */     // GIR_Coverage, 61448,
     /*  381245 */     GIR_EraseRootFromParent_Done,
     /*  381246 */   // Label 6878: @381246
     /*  381246 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(381312), // Rule ID 61449 //
     /*  381251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  381262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  381265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  381268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381290 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  381290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  381307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381310 */     GIR_RootConstrainSelectedInstOperands,
     /*  381311 */     // GIR_Coverage, 61449,
     /*  381311 */     GIR_EraseRootFromParent_Done,
     /*  381312 */   // Label 6879: @381312
     /*  381312 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(381378), // Rule ID 61452 //
     /*  381317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381376 */     GIR_RootConstrainSelectedInstOperands,
     /*  381377 */     // GIR_Coverage, 61452,
     /*  381377 */     GIR_EraseRootFromParent_Done,
     /*  381378 */   // Label 6880: @381378
     /*  381378 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(381444), // Rule ID 61453 //
     /*  381383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  381394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  381397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  381400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381442 */     GIR_RootConstrainSelectedInstOperands,
     /*  381443 */     // GIR_Coverage, 61453,
     /*  381443 */     GIR_EraseRootFromParent_Done,
     /*  381444 */   // Label 6881: @381444
     /*  381444 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(381510), // Rule ID 61456 //
     /*  381449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  381460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  381463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  381466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381508 */     GIR_RootConstrainSelectedInstOperands,
     /*  381509 */     // GIR_Coverage, 61456,
     /*  381509 */     GIR_EraseRootFromParent_Done,
     /*  381510 */   // Label 6882: @381510
     /*  381510 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(381576), // Rule ID 61457 //
     /*  381515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  381526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  381529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  381532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381554 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381574 */     GIR_RootConstrainSelectedInstOperands,
     /*  381575 */     // GIR_Coverage, 61457,
     /*  381575 */     GIR_EraseRootFromParent_Done,
     /*  381576 */   // Label 6883: @381576
     /*  381576 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(381642), // Rule ID 61460 //
     /*  381581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  381592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  381595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  381598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381640 */     GIR_RootConstrainSelectedInstOperands,
     /*  381641 */     // GIR_Coverage, 61460,
     /*  381641 */     GIR_EraseRootFromParent_Done,
     /*  381642 */   // Label 6884: @381642
     /*  381642 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(381708), // Rule ID 61461 //
     /*  381647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  381658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  381661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  381664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381706 */     GIR_RootConstrainSelectedInstOperands,
     /*  381707 */     // GIR_Coverage, 61461,
     /*  381707 */     GIR_EraseRootFromParent_Done,
     /*  381708 */   // Label 6885: @381708
     /*  381708 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(381774), // Rule ID 61464 //
     /*  381713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  381724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  381727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  381730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  381752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381772 */     GIR_RootConstrainSelectedInstOperands,
     /*  381773 */     // GIR_Coverage, 61464,
     /*  381773 */     GIR_EraseRootFromParent_Done,
     /*  381774 */   // Label 6886: @381774
     /*  381774 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(381840), // Rule ID 61465 //
     /*  381779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  381790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  381793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  381796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  381818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381838 */     GIR_RootConstrainSelectedInstOperands,
     /*  381839 */     // GIR_Coverage, 61465,
     /*  381839 */     GIR_EraseRootFromParent_Done,
     /*  381840 */   // Label 6887: @381840
     /*  381840 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(381906), // Rule ID 61468 //
     /*  381845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  381856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  381859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  381862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  381884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381904 */     GIR_RootConstrainSelectedInstOperands,
     /*  381905 */     // GIR_Coverage, 61468,
     /*  381905 */     GIR_EraseRootFromParent_Done,
     /*  381906 */   // Label 6888: @381906
     /*  381906 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(381972), // Rule ID 61469 //
     /*  381911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  381922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  381925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  381928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  381950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381970 */     GIR_RootConstrainSelectedInstOperands,
     /*  381971 */     // GIR_Coverage, 61469,
     /*  381971 */     GIR_EraseRootFromParent_Done,
     /*  381972 */   // Label 6889: @381972
     /*  381972 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(382038), // Rule ID 61472 //
     /*  381977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  381988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  381991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  381994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382036 */     GIR_RootConstrainSelectedInstOperands,
     /*  382037 */     // GIR_Coverage, 61472,
     /*  382037 */     GIR_EraseRootFromParent_Done,
     /*  382038 */   // Label 6890: @382038
     /*  382038 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(382104), // Rule ID 61473 //
     /*  382043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  382051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  382054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  382057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  382060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  382075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382082 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11166:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  382085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382102 */     GIR_RootConstrainSelectedInstOperands,
     /*  382103 */     // GIR_Coverage, 61473,
     /*  382103 */     GIR_EraseRootFromParent_Done,
     /*  382104 */   // Label 6891: @382104
     /*  382104 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(382170), // Rule ID 61476 //
     /*  382109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  382120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  382123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  382126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382148 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  382151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382168 */     GIR_RootConstrainSelectedInstOperands,
     /*  382169 */     // GIR_Coverage, 61476,
     /*  382169 */     GIR_EraseRootFromParent_Done,
     /*  382170 */   // Label 6892: @382170
     /*  382170 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(382236), // Rule ID 61477 //
     /*  382175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  382186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  382189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  382192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382214 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  382217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382234 */     GIR_RootConstrainSelectedInstOperands,
     /*  382235 */     // GIR_Coverage, 61477,
     /*  382235 */     GIR_EraseRootFromParent_Done,
     /*  382236 */   // Label 6893: @382236
     /*  382236 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(382302), // Rule ID 61480 //
     /*  382241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  382252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  382255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  382258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382280 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382300 */     GIR_RootConstrainSelectedInstOperands,
     /*  382301 */     // GIR_Coverage, 61480,
     /*  382301 */     GIR_EraseRootFromParent_Done,
     /*  382302 */   // Label 6894: @382302
     /*  382302 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(382368), // Rule ID 61481 //
     /*  382307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  382318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  382321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  382324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382366 */     GIR_RootConstrainSelectedInstOperands,
     /*  382367 */     // GIR_Coverage, 61481,
     /*  382367 */     GIR_EraseRootFromParent_Done,
     /*  382368 */   // Label 6895: @382368
     /*  382368 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(382434), // Rule ID 61484 //
     /*  382373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  382384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  382387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  382390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382412 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382432 */     GIR_RootConstrainSelectedInstOperands,
     /*  382433 */     // GIR_Coverage, 61484,
     /*  382433 */     GIR_EraseRootFromParent_Done,
     /*  382434 */   // Label 6896: @382434
     /*  382434 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(382500), // Rule ID 61485 //
     /*  382439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  382450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  382453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  382456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382478 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382498 */     GIR_RootConstrainSelectedInstOperands,
     /*  382499 */     // GIR_Coverage, 61485,
     /*  382499 */     GIR_EraseRootFromParent_Done,
     /*  382500 */   // Label 6897: @382500
     /*  382500 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(382566), // Rule ID 61488 //
     /*  382505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  382516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  382519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  382522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382564 */     GIR_RootConstrainSelectedInstOperands,
     /*  382565 */     // GIR_Coverage, 61488,
     /*  382565 */     GIR_EraseRootFromParent_Done,
     /*  382566 */   // Label 6898: @382566
     /*  382566 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(382632), // Rule ID 61489 //
     /*  382571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  382582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  382585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  382588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382610 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382630 */     GIR_RootConstrainSelectedInstOperands,
     /*  382631 */     // GIR_Coverage, 61489,
     /*  382631 */     GIR_EraseRootFromParent_Done,
     /*  382632 */   // Label 6899: @382632
     /*  382632 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(382698), // Rule ID 61492 //
     /*  382637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  382648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  382651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  382654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382676 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382696 */     GIR_RootConstrainSelectedInstOperands,
     /*  382697 */     // GIR_Coverage, 61492,
     /*  382697 */     GIR_EraseRootFromParent_Done,
     /*  382698 */   // Label 6900: @382698
     /*  382698 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(382764), // Rule ID 61493 //
     /*  382703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  382714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  382717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  382720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382742 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382762 */     GIR_RootConstrainSelectedInstOperands,
     /*  382763 */     // GIR_Coverage, 61493,
     /*  382763 */     GIR_EraseRootFromParent_Done,
     /*  382764 */   // Label 6901: @382764
     /*  382764 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(382830), // Rule ID 61496 //
     /*  382769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  382780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  382783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  382786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382808 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382828 */     GIR_RootConstrainSelectedInstOperands,
     /*  382829 */     // GIR_Coverage, 61496,
     /*  382829 */     GIR_EraseRootFromParent_Done,
     /*  382830 */   // Label 6902: @382830
     /*  382830 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(382896), // Rule ID 61497 //
     /*  382835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  382846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  382849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  382852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382874 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382894 */     GIR_RootConstrainSelectedInstOperands,
     /*  382895 */     // GIR_Coverage, 61497,
     /*  382895 */     GIR_EraseRootFromParent_Done,
     /*  382896 */   // Label 6903: @382896
     /*  382896 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(382962), // Rule ID 61500 //
     /*  382901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  382912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  382915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  382918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382960 */     GIR_RootConstrainSelectedInstOperands,
     /*  382961 */     // GIR_Coverage, 61500,
     /*  382961 */     GIR_EraseRootFromParent_Done,
     /*  382962 */   // Label 6904: @382962
     /*  382962 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(383028), // Rule ID 61501 //
     /*  382967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  382978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  382981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  382984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383006 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11517:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383026 */     GIR_RootConstrainSelectedInstOperands,
     /*  383027 */     // GIR_Coverage, 61501,
     /*  383027 */     GIR_EraseRootFromParent_Done,
     /*  383028 */   // Label 6905: @383028
     /*  383028 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(383094), // Rule ID 61504 //
     /*  383033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383072 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383092 */     GIR_RootConstrainSelectedInstOperands,
     /*  383093 */     // GIR_Coverage, 61504,
     /*  383093 */     GIR_EraseRootFromParent_Done,
     /*  383094 */   // Label 6906: @383094
     /*  383094 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(383160), // Rule ID 61505 //
     /*  383099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  383110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  383113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  383116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11517:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383158 */     GIR_RootConstrainSelectedInstOperands,
     /*  383159 */     // GIR_Coverage, 61505,
     /*  383159 */     GIR_EraseRootFromParent_Done,
     /*  383160 */   // Label 6907: @383160
     /*  383160 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(383226), // Rule ID 61508 //
     /*  383165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383224 */     GIR_RootConstrainSelectedInstOperands,
     /*  383225 */     // GIR_Coverage, 61508,
     /*  383225 */     GIR_EraseRootFromParent_Done,
     /*  383226 */   // Label 6908: @383226
     /*  383226 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(383292), // Rule ID 61509 //
     /*  383231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  383242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  383245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  383248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11517:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383290 */     GIR_RootConstrainSelectedInstOperands,
     /*  383291 */     // GIR_Coverage, 61509,
     /*  383291 */     GIR_EraseRootFromParent_Done,
     /*  383292 */   // Label 6909: @383292
     /*  383292 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(383358), // Rule ID 61512 //
     /*  383297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  383336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383356 */     GIR_RootConstrainSelectedInstOperands,
     /*  383357 */     // GIR_Coverage, 61512,
     /*  383357 */     GIR_EraseRootFromParent_Done,
     /*  383358 */   // Label 6910: @383358
     /*  383358 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(383424), // Rule ID 61513 //
     /*  383363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  383374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  383377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  383380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  383395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11517:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  383402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  383405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  383419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383422 */     GIR_RootConstrainSelectedInstOperands,
     /*  383423 */     // GIR_Coverage, 61513,
     /*  383423 */     GIR_EraseRootFromParent_Done,
     /*  383424 */   // Label 6911: @383424
     /*  383424 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(383490), // Rule ID 61516 //
     /*  383429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  383440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  383443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  383446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383468 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383488 */     GIR_RootConstrainSelectedInstOperands,
     /*  383489 */     // GIR_Coverage, 61516,
     /*  383489 */     GIR_EraseRootFromParent_Done,
     /*  383490 */   // Label 6912: @383490
     /*  383490 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(383556), // Rule ID 61517 //
     /*  383495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  383506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  383509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  383512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383554 */     GIR_RootConstrainSelectedInstOperands,
     /*  383555 */     // GIR_Coverage, 61517,
     /*  383555 */     GIR_EraseRootFromParent_Done,
     /*  383556 */   // Label 6913: @383556
     /*  383556 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(383622), // Rule ID 61520 //
     /*  383561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  383572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  383575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  383578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383600 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383620 */     GIR_RootConstrainSelectedInstOperands,
     /*  383621 */     // GIR_Coverage, 61520,
     /*  383621 */     GIR_EraseRootFromParent_Done,
     /*  383622 */   // Label 6914: @383622
     /*  383622 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(383688), // Rule ID 61521 //
     /*  383627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  383638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  383641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  383644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383666 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383686 */     GIR_RootConstrainSelectedInstOperands,
     /*  383687 */     // GIR_Coverage, 61521,
     /*  383687 */     GIR_EraseRootFromParent_Done,
     /*  383688 */   // Label 6915: @383688
     /*  383688 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(383754), // Rule ID 61524 //
     /*  383693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  383704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  383707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  383710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383732 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  383735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383752 */     GIR_RootConstrainSelectedInstOperands,
     /*  383753 */     // GIR_Coverage, 61524,
     /*  383753 */     GIR_EraseRootFromParent_Done,
     /*  383754 */   // Label 6916: @383754
     /*  383754 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(383820), // Rule ID 61525 //
     /*  383759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  383770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  383773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  383776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383798 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  383801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383818 */     GIR_RootConstrainSelectedInstOperands,
     /*  383819 */     // GIR_Coverage, 61525,
     /*  383819 */     GIR_EraseRootFromParent_Done,
     /*  383820 */   // Label 6917: @383820
     /*  383820 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(383886), // Rule ID 61528 //
     /*  383825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  383836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  383839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  383842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383884 */     GIR_RootConstrainSelectedInstOperands,
     /*  383885 */     // GIR_Coverage, 61528,
     /*  383885 */     GIR_EraseRootFromParent_Done,
     /*  383886 */   // Label 6918: @383886
     /*  383886 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(383952), // Rule ID 61529 //
     /*  383891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  383902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  383905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  383908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383950 */     GIR_RootConstrainSelectedInstOperands,
     /*  383951 */     // GIR_Coverage, 61529,
     /*  383951 */     GIR_EraseRootFromParent_Done,
     /*  383952 */   // Label 6919: @383952
     /*  383952 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(384018), // Rule ID 61532 //
     /*  383957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  383968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  383971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  383974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384016 */     GIR_RootConstrainSelectedInstOperands,
     /*  384017 */     // GIR_Coverage, 61532,
     /*  384017 */     GIR_EraseRootFromParent_Done,
     /*  384018 */   // Label 6920: @384018
     /*  384018 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(384084), // Rule ID 61533 //
     /*  384023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  384034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  384037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  384040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384062 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384082 */     GIR_RootConstrainSelectedInstOperands,
     /*  384083 */     // GIR_Coverage, 61533,
     /*  384083 */     GIR_EraseRootFromParent_Done,
     /*  384084 */   // Label 6921: @384084
     /*  384084 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(384150), // Rule ID 61536 //
     /*  384089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  384100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  384103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  384106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384128 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  384128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384148 */     GIR_RootConstrainSelectedInstOperands,
     /*  384149 */     // GIR_Coverage, 61536,
     /*  384149 */     GIR_EraseRootFromParent_Done,
     /*  384150 */   // Label 6922: @384150
     /*  384150 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(384216), // Rule ID 61537 //
     /*  384155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  384166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  384169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  384172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  384194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  384211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384214 */     GIR_RootConstrainSelectedInstOperands,
     /*  384215 */     // GIR_Coverage, 61537,
     /*  384215 */     GIR_EraseRootFromParent_Done,
     /*  384216 */   // Label 6923: @384216
     /*  384216 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(384282), // Rule ID 61540 //
     /*  384221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  384232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  384235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  384238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384280 */     GIR_RootConstrainSelectedInstOperands,
     /*  384281 */     // GIR_Coverage, 61540,
     /*  384281 */     GIR_EraseRootFromParent_Done,
     /*  384282 */   // Label 6924: @384282
     /*  384282 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(384348), // Rule ID 61541 //
     /*  384287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  384298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  384301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  384304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384346 */     GIR_RootConstrainSelectedInstOperands,
     /*  384347 */     // GIR_Coverage, 61541,
     /*  384347 */     GIR_EraseRootFromParent_Done,
     /*  384348 */   // Label 6925: @384348
     /*  384348 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(384414), // Rule ID 61544 //
     /*  384353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  384364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  384367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  384370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384392 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384412 */     GIR_RootConstrainSelectedInstOperands,
     /*  384413 */     // GIR_Coverage, 61544,
     /*  384413 */     GIR_EraseRootFromParent_Done,
     /*  384414 */   // Label 6926: @384414
     /*  384414 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(384480), // Rule ID 61545 //
     /*  384419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  384430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  384433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  384436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384458 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384478 */     GIR_RootConstrainSelectedInstOperands,
     /*  384479 */     // GIR_Coverage, 61545,
     /*  384479 */     GIR_EraseRootFromParent_Done,
     /*  384480 */   // Label 6927: @384480
     /*  384480 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(384546), // Rule ID 61548 //
     /*  384485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  384496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  384499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  384502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384544 */     GIR_RootConstrainSelectedInstOperands,
     /*  384545 */     // GIR_Coverage, 61548,
     /*  384545 */     GIR_EraseRootFromParent_Done,
     /*  384546 */   // Label 6928: @384546
     /*  384546 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(384612), // Rule ID 61549 //
     /*  384551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  384562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  384565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  384568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384590 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384610 */     GIR_RootConstrainSelectedInstOperands,
     /*  384611 */     // GIR_Coverage, 61549,
     /*  384611 */     GIR_EraseRootFromParent_Done,
     /*  384612 */   // Label 6929: @384612
     /*  384612 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(384678), // Rule ID 61552 //
     /*  384617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  384628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  384631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  384634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384656 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384676 */     GIR_RootConstrainSelectedInstOperands,
     /*  384677 */     // GIR_Coverage, 61552,
     /*  384677 */     GIR_EraseRootFromParent_Done,
     /*  384678 */   // Label 6930: @384678
     /*  384678 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(384744), // Rule ID 61553 //
     /*  384683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  384694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  384697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  384700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11517:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384742 */     GIR_RootConstrainSelectedInstOperands,
     /*  384743 */     // GIR_Coverage, 61553,
     /*  384743 */     GIR_EraseRootFromParent_Done,
     /*  384744 */   // Label 6931: @384744
     /*  384744 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(384810), // Rule ID 61556 //
     /*  384749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  384760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  384763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  384766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384808 */     GIR_RootConstrainSelectedInstOperands,
     /*  384809 */     // GIR_Coverage, 61556,
     /*  384809 */     GIR_EraseRootFromParent_Done,
     /*  384810 */   // Label 6932: @384810
     /*  384810 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(384876), // Rule ID 61557 //
     /*  384815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  384826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  384829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  384832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384854 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11517:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384874 */     GIR_RootConstrainSelectedInstOperands,
     /*  384875 */     // GIR_Coverage, 61557,
     /*  384875 */     GIR_EraseRootFromParent_Done,
     /*  384876 */   // Label 6933: @384876
     /*  384876 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(384942), // Rule ID 61560 //
     /*  384881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  384892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  384895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  384898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384940 */     GIR_RootConstrainSelectedInstOperands,
     /*  384941 */     // GIR_Coverage, 61560,
     /*  384941 */     GIR_EraseRootFromParent_Done,
     /*  384942 */   // Label 6934: @384942
     /*  384942 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(385008), // Rule ID 61561 //
     /*  384947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  384958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  384961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  384964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384986 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11517:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  385000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  385003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  385006 */     GIR_RootConstrainSelectedInstOperands,
     /*  385007 */     // GIR_Coverage, 61561,
     /*  385007 */     GIR_EraseRootFromParent_Done,
     /*  385008 */   // Label 6935: @385008
     /*  385008 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(385073), // Rule ID 64452 //
     /*  385013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  385021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385057 */     // MIs[1] Operand 1
     /*  385057 */     // No operand predicates
     /*  385057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385059 */     // (intrinsic_wo_chain:{ *:[i32] } 10971:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDN),
     /*  385062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385071 */     GIR_RootConstrainSelectedInstOperands,
     /*  385072 */     // GIR_Coverage, 64452,
     /*  385072 */     GIR_EraseRootFromParent_Done,
     /*  385073 */   // Label 6936: @385073
     /*  385073 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(385138), // Rule ID 64479 //
     /*  385078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  385086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385122 */     // MIs[1] Operand 1
     /*  385122 */     // No operand predicates
     /*  385122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385124 */     // (intrinsic_wo_chain:{ *:[i32] } 10973:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUN),
     /*  385127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385136 */     GIR_RootConstrainSelectedInstOperands,
     /*  385137 */     // GIR_Coverage, 64479,
     /*  385137 */     GIR_EraseRootFromParent_Done,
     /*  385138 */   // Label 6937: @385138
     /*  385138 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(385203), // Rule ID 64482 //
     /*  385143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  385151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385187 */     // MIs[1] Operand 1
     /*  385187 */     // No operand predicates
     /*  385187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385189 */     // (intrinsic_wo_chain:{ *:[i32] } 10972:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRN),
     /*  385192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385201 */     GIR_RootConstrainSelectedInstOperands,
     /*  385202 */     // GIR_Coverage, 64482,
     /*  385202 */     GIR_EraseRootFromParent_Done,
     /*  385203 */   // Label 6938: @385203
     /*  385203 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(385268), // Rule ID 64485 //
     /*  385208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  385216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385252 */     // MIs[1] Operand 1
     /*  385252 */     // No operand predicates
     /*  385252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385254 */     // (intrinsic_wo_chain:{ *:[i32] } 10974:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURN),
     /*  385257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385266 */     GIR_RootConstrainSelectedInstOperands,
     /*  385267 */     // GIR_Coverage, 64485,
     /*  385267 */     GIR_EraseRootFromParent_Done,
     /*  385268 */   // Label 6939: @385268
     /*  385268 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(385333), // Rule ID 64488 //
     /*  385273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  385281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385317 */     // MIs[1] Operand 1
     /*  385317 */     // No operand predicates
     /*  385317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385319 */     // (intrinsic_wo_chain:{ *:[i32] } 10977:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBN),
     /*  385322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385331 */     GIR_RootConstrainSelectedInstOperands,
     /*  385332 */     // GIR_Coverage, 64488,
     /*  385332 */     GIR_EraseRootFromParent_Done,
     /*  385333 */   // Label 6940: @385333
     /*  385333 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(385398), // Rule ID 64491 //
     /*  385338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  385346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385382 */     // MIs[1] Operand 1
     /*  385382 */     // No operand predicates
     /*  385382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385384 */     // (intrinsic_wo_chain:{ *:[i32] } 10979:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUN),
     /*  385387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385396 */     GIR_RootConstrainSelectedInstOperands,
     /*  385397 */     // GIR_Coverage, 64491,
     /*  385397 */     GIR_EraseRootFromParent_Done,
     /*  385398 */   // Label 6941: @385398
     /*  385398 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(385463), // Rule ID 64494 //
     /*  385403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  385411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385447 */     // MIs[1] Operand 1
     /*  385447 */     // No operand predicates
     /*  385447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385449 */     // (intrinsic_wo_chain:{ *:[i32] } 10978:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRN),
     /*  385452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385461 */     GIR_RootConstrainSelectedInstOperands,
     /*  385462 */     // GIR_Coverage, 64494,
     /*  385462 */     GIR_EraseRootFromParent_Done,
     /*  385463 */   // Label 6942: @385463
     /*  385463 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(385528), // Rule ID 64497 //
     /*  385468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  385476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  385504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385512 */     // MIs[1] Operand 1
     /*  385512 */     // No operand predicates
     /*  385512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385514 */     // (intrinsic_wo_chain:{ *:[i32] } 10980:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURN),
     /*  385517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385526 */     GIR_RootConstrainSelectedInstOperands,
     /*  385527 */     // GIR_Coverage, 64497,
     /*  385527 */     GIR_EraseRootFromParent_Done,
     /*  385528 */   // Label 6943: @385528
     /*  385528 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(385583), // Rule ID 2645 //
     /*  385533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  385536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsi),
     /*  385541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385562 */     // MIs[0] imm
     /*  385562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385570 */     // (intrinsic_wo_chain:{ *:[i32] } 10956:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSI),
     /*  385573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385579 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385581 */     GIR_RootConstrainSelectedInstOperands,
     /*  385582 */     // GIR_Coverage, 2645,
     /*  385582 */     GIR_EraseRootFromParent_Done,
     /*  385583 */   // Label 6944: @385583
     /*  385583 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(385638), // Rule ID 2646 //
     /*  385588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  385591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsmi),
     /*  385596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385617 */     // MIs[0] imm
     /*  385617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385625 */     // (intrinsic_wo_chain:{ *:[i32] } 10957:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSMI),
     /*  385628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385634 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385636 */     GIR_RootConstrainSelectedInstOperands,
     /*  385637 */     // GIR_Coverage, 2646,
     /*  385637 */     GIR_EraseRootFromParent_Done,
     /*  385638 */   // Label 6945: @385638
     /*  385638 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(385693), // Rule ID 2652 //
     /*  385643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  385646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esi),
     /*  385651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385672 */     // MIs[0] imm
     /*  385672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385680 */     // (intrinsic_wo_chain:{ *:[i32] } 10958:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESI),
     /*  385683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385689 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385691 */     GIR_RootConstrainSelectedInstOperands,
     /*  385692 */     // GIR_Coverage, 2652,
     /*  385692 */     GIR_EraseRootFromParent_Done,
     /*  385693 */   // Label 6946: @385693
     /*  385693 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(385748), // Rule ID 2653 //
     /*  385698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  385701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esmi),
     /*  385706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385727 */     // MIs[0] imm
     /*  385727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385735 */     // (intrinsic_wo_chain:{ *:[i32] } 10959:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESMI),
     /*  385738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385744 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385746 */     GIR_RootConstrainSelectedInstOperands,
     /*  385747 */     // GIR_Coverage, 2653,
     /*  385747 */     GIR_EraseRootFromParent_Done,
     /*  385748 */   // Label 6947: @385748
     /*  385748 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(385803), // Rule ID 64508 //
     /*  385753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluN),
     /*  385761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385782 */     // MIs[0] imm5
     /*  385782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385790 */     // (intrinsic_wo_chain:{ *:[i32] } 11004:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULUN),
     /*  385793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385799 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385801 */     GIR_RootConstrainSelectedInstOperands,
     /*  385802 */     // GIR_Coverage, 64508,
     /*  385802 */     GIR_EraseRootFromParent_Done,
     /*  385803 */   // Label 6948: @385803
     /*  385803 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(385858), // Rule ID 64509 //
     /*  385808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuN),
     /*  385816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385837 */     // MIs[0] imm5
     /*  385837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385845 */     // (intrinsic_wo_chain:{ *:[i32] } 11000:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHUN),
     /*  385848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385854 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385856 */     GIR_RootConstrainSelectedInstOperands,
     /*  385857 */     // GIR_Coverage, 64509,
     /*  385857 */     GIR_EraseRootFromParent_Done,
     /*  385858 */   // Label 6949: @385858
     /*  385858 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(385913), // Rule ID 64510 //
     /*  385863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsN),
     /*  385871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385892 */     // MIs[0] imm5
     /*  385892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385900 */     // (intrinsic_wo_chain:{ *:[i32] } 11002:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSN),
     /*  385903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385909 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385911 */     GIR_RootConstrainSelectedInstOperands,
     /*  385912 */     // GIR_Coverage, 64510,
     /*  385912 */     GIR_EraseRootFromParent_Done,
     /*  385913 */   // Label 6950: @385913
     /*  385913 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(385968), // Rule ID 64511 //
     /*  385918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsN),
     /*  385926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385947 */     // MIs[0] imm5
     /*  385947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385955 */     // (intrinsic_wo_chain:{ *:[i32] } 10998:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSN),
     /*  385958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385964 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385966 */     GIR_RootConstrainSelectedInstOperands,
     /*  385967 */     // GIR_Coverage, 64511,
     /*  385967 */     GIR_EraseRootFromParent_Done,
     /*  385968 */   // Label 6951: @385968
     /*  385968 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(386023), // Rule ID 64512 //
     /*  385973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluRN),
     /*  385981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386002 */     // MIs[0] imm5
     /*  386002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386010 */     // (intrinsic_wo_chain:{ *:[i32] } 11005:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULURN),
     /*  386013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386019 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386021 */     GIR_RootConstrainSelectedInstOperands,
     /*  386022 */     // GIR_Coverage, 64512,
     /*  386022 */     GIR_EraseRootFromParent_Done,
     /*  386023 */   // Label 6952: @386023
     /*  386023 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(386078), // Rule ID 64513 //
     /*  386028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuRN),
     /*  386036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386057 */     // MIs[0] imm5
     /*  386057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386065 */     // (intrinsic_wo_chain:{ *:[i32] } 11001:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHURN),
     /*  386068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386074 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386076 */     GIR_RootConstrainSelectedInstOperands,
     /*  386077 */     // GIR_Coverage, 64513,
     /*  386077 */     GIR_EraseRootFromParent_Done,
     /*  386078 */   // Label 6953: @386078
     /*  386078 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(386133), // Rule ID 64514 //
     /*  386083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsRN),
     /*  386091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386112 */     // MIs[0] imm5
     /*  386112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386120 */     // (intrinsic_wo_chain:{ *:[i32] } 11003:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSRN),
     /*  386123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386129 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386131 */     GIR_RootConstrainSelectedInstOperands,
     /*  386132 */     // GIR_Coverage, 64514,
     /*  386132 */     GIR_EraseRootFromParent_Done,
     /*  386133 */   // Label 6954: @386133
     /*  386133 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(386188), // Rule ID 64515 //
     /*  386138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsRN),
     /*  386146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386167 */     // MIs[0] imm5
     /*  386167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  386175 */     // (intrinsic_wo_chain:{ *:[i32] } 10999:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  386175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSRN),
     /*  386178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386184 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  386186 */     GIR_RootConstrainSelectedInstOperands,
     /*  386187 */     // GIR_Coverage, 64515,
     /*  386187 */     GIR_EraseRootFromParent_Done,
     /*  386188 */   // Label 6955: @386188
     /*  386188 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(386242), // Rule ID 64450 //
     /*  386193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  386201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386229 */     // (intrinsic_wo_chain:{ *:[i32] } 10971:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  386232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386240 */     GIR_RootConstrainSelectedInstOperands,
     /*  386241 */     // GIR_Coverage, 64450,
     /*  386241 */     GIR_EraseRootFromParent_Done,
     /*  386242 */   // Label 6956: @386242
     /*  386242 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(386296), // Rule ID 64451 //
     /*  386247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  386255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386283 */     // (intrinsic_wo_chain:{ *:[i32] } 10971:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  386286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386294 */     GIR_RootConstrainSelectedInstOperands,
     /*  386295 */     // GIR_Coverage, 64451,
     /*  386295 */     GIR_EraseRootFromParent_Done,
     /*  386296 */   // Label 6957: @386296
     /*  386296 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(386350), // Rule ID 64477 //
     /*  386301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  386309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386337 */     // (intrinsic_wo_chain:{ *:[i32] } 10973:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  386340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386348 */     GIR_RootConstrainSelectedInstOperands,
     /*  386349 */     // GIR_Coverage, 64477,
     /*  386349 */     GIR_EraseRootFromParent_Done,
     /*  386350 */   // Label 6958: @386350
     /*  386350 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(386404), // Rule ID 64478 //
     /*  386355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  386363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386391 */     // (intrinsic_wo_chain:{ *:[i32] } 10973:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  386394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386402 */     GIR_RootConstrainSelectedInstOperands,
     /*  386403 */     // GIR_Coverage, 64478,
     /*  386403 */     GIR_EraseRootFromParent_Done,
     /*  386404 */   // Label 6959: @386404
     /*  386404 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(386458), // Rule ID 64480 //
     /*  386409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  386417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386445 */     // (intrinsic_wo_chain:{ *:[i32] } 10972:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  386448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386456 */     GIR_RootConstrainSelectedInstOperands,
     /*  386457 */     // GIR_Coverage, 64480,
     /*  386457 */     GIR_EraseRootFromParent_Done,
     /*  386458 */   // Label 6960: @386458
     /*  386458 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(386512), // Rule ID 64481 //
     /*  386463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  386471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386499 */     // (intrinsic_wo_chain:{ *:[i32] } 10972:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  386502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386510 */     GIR_RootConstrainSelectedInstOperands,
     /*  386511 */     // GIR_Coverage, 64481,
     /*  386511 */     GIR_EraseRootFromParent_Done,
     /*  386512 */   // Label 6961: @386512
     /*  386512 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(386566), // Rule ID 64483 //
     /*  386517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  386525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386553 */     // (intrinsic_wo_chain:{ *:[i32] } 10974:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  386556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386564 */     GIR_RootConstrainSelectedInstOperands,
     /*  386565 */     // GIR_Coverage, 64483,
     /*  386565 */     GIR_EraseRootFromParent_Done,
     /*  386566 */   // Label 6962: @386566
     /*  386566 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(386620), // Rule ID 64484 //
     /*  386571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  386579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386607 */     // (intrinsic_wo_chain:{ *:[i32] } 10974:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  386610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386618 */     GIR_RootConstrainSelectedInstOperands,
     /*  386619 */     // GIR_Coverage, 64484,
     /*  386619 */     GIR_EraseRootFromParent_Done,
     /*  386620 */   // Label 6963: @386620
     /*  386620 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(386674), // Rule ID 64486 //
     /*  386625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  386633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386661 */     // (intrinsic_wo_chain:{ *:[i32] } 10977:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  386664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386672 */     GIR_RootConstrainSelectedInstOperands,
     /*  386673 */     // GIR_Coverage, 64486,
     /*  386673 */     GIR_EraseRootFromParent_Done,
     /*  386674 */   // Label 6964: @386674
     /*  386674 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(386728), // Rule ID 64487 //
     /*  386679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  386687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386715 */     // (intrinsic_wo_chain:{ *:[i32] } 10977:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  386718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386726 */     GIR_RootConstrainSelectedInstOperands,
     /*  386727 */     // GIR_Coverage, 64487,
     /*  386727 */     GIR_EraseRootFromParent_Done,
     /*  386728 */   // Label 6965: @386728
     /*  386728 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(386782), // Rule ID 64489 //
     /*  386733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  386741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386769 */     // (intrinsic_wo_chain:{ *:[i32] } 10979:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  386772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386780 */     GIR_RootConstrainSelectedInstOperands,
     /*  386781 */     // GIR_Coverage, 64489,
     /*  386781 */     GIR_EraseRootFromParent_Done,
     /*  386782 */   // Label 6966: @386782
     /*  386782 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(386836), // Rule ID 64490 //
     /*  386787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  386795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386823 */     // (intrinsic_wo_chain:{ *:[i32] } 10979:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  386826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386834 */     GIR_RootConstrainSelectedInstOperands,
     /*  386835 */     // GIR_Coverage, 64490,
     /*  386835 */     GIR_EraseRootFromParent_Done,
     /*  386836 */   // Label 6967: @386836
     /*  386836 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(386890), // Rule ID 64492 //
     /*  386841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  386849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386877 */     // (intrinsic_wo_chain:{ *:[i32] } 10978:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  386880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386888 */     GIR_RootConstrainSelectedInstOperands,
     /*  386889 */     // GIR_Coverage, 64492,
     /*  386889 */     GIR_EraseRootFromParent_Done,
     /*  386890 */   // Label 6968: @386890
     /*  386890 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(386944), // Rule ID 64493 //
     /*  386895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  386903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386931 */     // (intrinsic_wo_chain:{ *:[i32] } 10978:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  386934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386942 */     GIR_RootConstrainSelectedInstOperands,
     /*  386943 */     // GIR_Coverage, 64493,
     /*  386943 */     GIR_EraseRootFromParent_Done,
     /*  386944 */   // Label 6969: @386944
     /*  386944 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(386998), // Rule ID 64495 //
     /*  386949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  386957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386985 */     // (intrinsic_wo_chain:{ *:[i32] } 10980:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  386988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386996 */     GIR_RootConstrainSelectedInstOperands,
     /*  386997 */     // GIR_Coverage, 64495,
     /*  386997 */     GIR_EraseRootFromParent_Done,
     /*  386998 */   // Label 6970: @386998
     /*  386998 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(387052), // Rule ID 64496 //
     /*  387003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  387006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  387011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387039 */     // (intrinsic_wo_chain:{ *:[i32] } 10980:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  387039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  387042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  387050 */     GIR_RootConstrainSelectedInstOperands,
     /*  387051 */     // GIR_Coverage, 64496,
     /*  387051 */     GIR_EraseRootFromParent_Done,
     /*  387052 */   // Label 6971: @387052
     /*  387052 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(387106), // Rule ID 64433 //
     /*  387057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /*  387060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  387065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387093 */     // (intrinsic_wo_chain:{ *:[i32] } 10987:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  387096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387104 */     GIR_RootConstrainSelectedInstOperands,
     /*  387105 */     // GIR_Coverage, 64433,
     /*  387105 */     GIR_EraseRootFromParent_Done,
     /*  387106 */   // Label 6972: @387106
     /*  387106 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(387160), // Rule ID 64434 //
     /*  387111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  387114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  387119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387147 */     // (intrinsic_wo_chain:{ *:[i32] } 10987:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  387150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387158 */     GIR_RootConstrainSelectedInstOperands,
     /*  387159 */     // GIR_Coverage, 64434,
     /*  387159 */     GIR_EraseRootFromParent_Done,
     /*  387160 */   // Label 6973: @387160
     /*  387160 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(387214), // Rule ID 64504 //
     /*  387165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  387168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  387173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387201 */     // (intrinsic_wo_chain:{ *:[i32] } 10988:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  387204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387212 */     GIR_RootConstrainSelectedInstOperands,
     /*  387213 */     // GIR_Coverage, 64504,
     /*  387213 */     GIR_EraseRootFromParent_Done,
     /*  387214 */   // Label 6974: @387214
     /*  387214 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(387268), // Rule ID 64505 //
     /*  387219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  387222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  387227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387255 */     // (intrinsic_wo_chain:{ *:[i32] } 10988:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  387258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387266 */     GIR_RootConstrainSelectedInstOperands,
     /*  387267 */     // GIR_Coverage, 64505,
     /*  387267 */     GIR_EraseRootFromParent_Done,
     /*  387268 */   // Label 6975: @387268
     /*  387268 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(387322), // Rule ID 64506 //
     /*  387273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  387276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  387281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387309 */     // (intrinsic_wo_chain:{ *:[i32] } 10997:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  387312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387320 */     GIR_RootConstrainSelectedInstOperands,
     /*  387321 */     // GIR_Coverage, 64506,
     /*  387321 */     GIR_EraseRootFromParent_Done,
     /*  387322 */   // Label 6976: @387322
     /*  387322 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(387376), // Rule ID 64507 //
     /*  387327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  387330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  387335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  387338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  387341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  387344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  387347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  387363 */     // (intrinsic_wo_chain:{ *:[i32] } 10997:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  387363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  387366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  387368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  387370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  387372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  387374 */     GIR_RootConstrainSelectedInstOperands,
     /*  387375 */     // GIR_Coverage, 64507,
     /*  387375 */     GIR_EraseRootFromParent_Done,
     /*  387376 */   // Label 6977: @387376
     /*  387376 */   GIM_Reject,
     /*  387377 */ // Label 4352: @387377
     /*  387377 */ GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(906154),
     /*  387382 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  387385 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(387460), // Rule ID 62837 //
     /*  387390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  387401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387408 */     // MIs[0] op1
     /*  387408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387416 */     // MIs[0] op2
     /*  387416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387424 */     // MIs[0] op3
     /*  387424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  387442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387444 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387446 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387448 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387458 */     GIR_RootConstrainSelectedInstOperands,
     /*  387459 */     // GIR_Coverage, 62837,
     /*  387459 */     GIR_EraseRootFromParent_Done,
     /*  387460 */   // Label 6979: @387460
     /*  387460 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(387535), // Rule ID 62838 //
     /*  387465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  387476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387483 */     // MIs[0] op1
     /*  387483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387491 */     // MIs[0] op2
     /*  387491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387499 */     // MIs[0] op3
     /*  387499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387514 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  387517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387519 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387521 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387523 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387533 */     GIR_RootConstrainSelectedInstOperands,
     /*  387534 */     // GIR_Coverage, 62838,
     /*  387534 */     GIR_EraseRootFromParent_Done,
     /*  387535 */   // Label 6980: @387535
     /*  387535 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(387610), // Rule ID 62869 //
     /*  387540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  387551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387558 */     // MIs[0] op1
     /*  387558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387566 */     // MIs[0] op2
     /*  387566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387574 */     // MIs[0] op3
     /*  387574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387589 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  387592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387594 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387596 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387598 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387608 */     GIR_RootConstrainSelectedInstOperands,
     /*  387609 */     // GIR_Coverage, 62869,
     /*  387609 */     GIR_EraseRootFromParent_Done,
     /*  387610 */   // Label 6981: @387610
     /*  387610 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(387685), // Rule ID 62870 //
     /*  387615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  387626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387633 */     // MIs[0] op1
     /*  387633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387641 */     // MIs[0] op2
     /*  387641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387649 */     // MIs[0] op3
     /*  387649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387664 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  387667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387669 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387671 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387673 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387683 */     GIR_RootConstrainSelectedInstOperands,
     /*  387684 */     // GIR_Coverage, 62870,
     /*  387684 */     GIR_EraseRootFromParent_Done,
     /*  387685 */   // Label 6982: @387685
     /*  387685 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(387760), // Rule ID 62913 //
     /*  387690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  387701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387708 */     // MIs[0] op1
     /*  387708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387711 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387716 */     // MIs[0] op2
     /*  387716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387724 */     // MIs[0] op3
     /*  387724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387739 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  387742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387744 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387746 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387748 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387758 */     GIR_RootConstrainSelectedInstOperands,
     /*  387759 */     // GIR_Coverage, 62913,
     /*  387759 */     GIR_EraseRootFromParent_Done,
     /*  387760 */   // Label 6983: @387760
     /*  387760 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(387835), // Rule ID 62914 //
     /*  387765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  387776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387783 */     // MIs[0] op1
     /*  387783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387791 */     // MIs[0] op2
     /*  387791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387799 */     // MIs[0] op3
     /*  387799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387814 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  387817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387819 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387821 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387823 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387833 */     GIR_RootConstrainSelectedInstOperands,
     /*  387834 */     // GIR_Coverage, 62914,
     /*  387834 */     GIR_EraseRootFromParent_Done,
     /*  387835 */   // Label 6984: @387835
     /*  387835 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(387910), // Rule ID 62957 //
     /*  387840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  387851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387858 */     // MIs[0] op1
     /*  387858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387866 */     // MIs[0] op2
     /*  387866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387874 */     // MIs[0] op3
     /*  387874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387889 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  387889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  387892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387894 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387896 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387898 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387908 */     GIR_RootConstrainSelectedInstOperands,
     /*  387909 */     // GIR_Coverage, 62957,
     /*  387909 */     GIR_EraseRootFromParent_Done,
     /*  387910 */   // Label 6985: @387910
     /*  387910 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(387985), // Rule ID 62958 //
     /*  387915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  387926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387933 */     // MIs[0] op1
     /*  387933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387941 */     // MIs[0] op2
     /*  387941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387949 */     // MIs[0] op3
     /*  387949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  387964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  387967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387969 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387971 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387973 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387983 */     GIR_RootConstrainSelectedInstOperands,
     /*  387984 */     // GIR_Coverage, 62958,
     /*  387984 */     GIR_EraseRootFromParent_Done,
     /*  387985 */   // Label 6986: @387985
     /*  387985 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(388060), // Rule ID 63013 //
     /*  387990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388008 */     // MIs[0] op1
     /*  388008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388016 */     // MIs[0] op2
     /*  388016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388024 */     // MIs[0] op3
     /*  388024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388027 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388039 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  388042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388044 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388046 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388048 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388058 */     GIR_RootConstrainSelectedInstOperands,
     /*  388059 */     // GIR_Coverage, 63013,
     /*  388059 */     GIR_EraseRootFromParent_Done,
     /*  388060 */   // Label 6987: @388060
     /*  388060 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(388135), // Rule ID 63014 //
     /*  388065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  388076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388083 */     // MIs[0] op1
     /*  388083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388091 */     // MIs[0] op2
     /*  388091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388099 */     // MIs[0] op3
     /*  388099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388114 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  388117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388119 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388121 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388123 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388133 */     GIR_RootConstrainSelectedInstOperands,
     /*  388134 */     // GIR_Coverage, 63014,
     /*  388134 */     GIR_EraseRootFromParent_Done,
     /*  388135 */   // Label 6988: @388135
     /*  388135 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(388210), // Rule ID 63069 //
     /*  388140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388158 */     // MIs[0] op1
     /*  388158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388166 */     // MIs[0] op2
     /*  388166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388174 */     // MIs[0] op3
     /*  388174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388189 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  388189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  388192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388194 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388196 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388198 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388208 */     GIR_RootConstrainSelectedInstOperands,
     /*  388209 */     // GIR_Coverage, 63069,
     /*  388209 */     GIR_EraseRootFromParent_Done,
     /*  388210 */   // Label 6989: @388210
     /*  388210 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(388285), // Rule ID 63070 //
     /*  388215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  388226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388233 */     // MIs[0] op1
     /*  388233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388241 */     // MIs[0] op2
     /*  388241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388249 */     // MIs[0] op3
     /*  388249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  388264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  388267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388269 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388271 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388273 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388283 */     GIR_RootConstrainSelectedInstOperands,
     /*  388284 */     // GIR_Coverage, 63070,
     /*  388284 */     GIR_EraseRootFromParent_Done,
     /*  388285 */   // Label 6990: @388285
     /*  388285 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(388360), // Rule ID 63125 //
     /*  388290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  388301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388308 */     // MIs[0] op1
     /*  388308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388316 */     // MIs[0] op2
     /*  388316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388324 */     // MIs[0] op3
     /*  388324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388327 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388339 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388344 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388346 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388348 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388358 */     GIR_RootConstrainSelectedInstOperands,
     /*  388359 */     // GIR_Coverage, 63125,
     /*  388359 */     GIR_EraseRootFromParent_Done,
     /*  388360 */   // Label 6991: @388360
     /*  388360 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(388435), // Rule ID 63126 //
     /*  388365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  388376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388383 */     // MIs[0] op1
     /*  388383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388391 */     // MIs[0] op2
     /*  388391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388399 */     // MIs[0] op3
     /*  388399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388414 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388419 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388421 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388423 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388433 */     GIR_RootConstrainSelectedInstOperands,
     /*  388434 */     // GIR_Coverage, 63126,
     /*  388434 */     GIR_EraseRootFromParent_Done,
     /*  388435 */   // Label 6992: @388435
     /*  388435 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(388510), // Rule ID 63169 //
     /*  388440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  388451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388458 */     // MIs[0] op1
     /*  388458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388466 */     // MIs[0] op2
     /*  388466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388469 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388474 */     // MIs[0] op3
     /*  388474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388494 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388496 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388498 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388508 */     GIR_RootConstrainSelectedInstOperands,
     /*  388509 */     // GIR_Coverage, 63169,
     /*  388509 */     GIR_EraseRootFromParent_Done,
     /*  388510 */   // Label 6993: @388510
     /*  388510 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(388585), // Rule ID 63170 //
     /*  388515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  388526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388533 */     // MIs[0] op1
     /*  388533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388541 */     // MIs[0] op2
     /*  388541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388549 */     // MIs[0] op3
     /*  388549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388569 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388571 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388573 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388583 */     GIR_RootConstrainSelectedInstOperands,
     /*  388584 */     // GIR_Coverage, 63170,
     /*  388584 */     GIR_EraseRootFromParent_Done,
     /*  388585 */   // Label 6994: @388585
     /*  388585 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(388660), // Rule ID 63225 //
     /*  388590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  388601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388608 */     // MIs[0] op1
     /*  388608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388616 */     // MIs[0] op2
     /*  388616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388624 */     // MIs[0] op3
     /*  388624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388639 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  388639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388658 */     GIR_RootConstrainSelectedInstOperands,
     /*  388659 */     // GIR_Coverage, 63225,
     /*  388659 */     GIR_EraseRootFromParent_Done,
     /*  388660 */   // Label 6995: @388660
     /*  388660 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(388735), // Rule ID 63226 //
     /*  388665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  388676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388683 */     // MIs[0] op1
     /*  388683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388691 */     // MIs[0] op2
     /*  388691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388699 */     // MIs[0] op3
     /*  388699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388714 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  388714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388719 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388721 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388723 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388733 */     GIR_RootConstrainSelectedInstOperands,
     /*  388734 */     // GIR_Coverage, 63226,
     /*  388734 */     GIR_EraseRootFromParent_Done,
     /*  388735 */   // Label 6996: @388735
     /*  388735 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(388810), // Rule ID 63281 //
     /*  388740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  388751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388758 */     // MIs[0] op1
     /*  388758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388766 */     // MIs[0] op2
     /*  388766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388774 */     // MIs[0] op3
     /*  388774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388789 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  388789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388794 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388796 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388798 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388808 */     GIR_RootConstrainSelectedInstOperands,
     /*  388809 */     // GIR_Coverage, 63281,
     /*  388809 */     GIR_EraseRootFromParent_Done,
     /*  388810 */   // Label 6997: @388810
     /*  388810 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(388885), // Rule ID 63282 //
     /*  388815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  388826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388833 */     // MIs[0] op1
     /*  388833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388841 */     // MIs[0] op2
     /*  388841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388849 */     // MIs[0] op3
     /*  388849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  388864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388869 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388871 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388873 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388883 */     GIR_RootConstrainSelectedInstOperands,
     /*  388884 */     // GIR_Coverage, 63282,
     /*  388884 */     GIR_EraseRootFromParent_Done,
     /*  388885 */   // Label 6998: @388885
     /*  388885 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(388960), // Rule ID 63337 //
     /*  388890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  388901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388908 */     // MIs[0] op1
     /*  388908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388916 */     // MIs[0] op2
     /*  388916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388924 */     // MIs[0] op3
     /*  388924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388939 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  388942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388944 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388946 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388948 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388958 */     GIR_RootConstrainSelectedInstOperands,
     /*  388959 */     // GIR_Coverage, 63337,
     /*  388959 */     GIR_EraseRootFromParent_Done,
     /*  388960 */   // Label 6999: @388960
     /*  388960 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(389035), // Rule ID 63338 //
     /*  388965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  388976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388983 */     // MIs[0] op1
     /*  388983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388991 */     // MIs[0] op2
     /*  388991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388999 */     // MIs[0] op3
     /*  388999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  389017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389019 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389021 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389023 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389033 */     GIR_RootConstrainSelectedInstOperands,
     /*  389034 */     // GIR_Coverage, 63338,
     /*  389034 */     GIR_EraseRootFromParent_Done,
     /*  389035 */   // Label 7000: @389035
     /*  389035 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(389110), // Rule ID 63381 //
     /*  389040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389058 */     // MIs[0] op1
     /*  389058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389066 */     // MIs[0] op2
     /*  389066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389074 */     // MIs[0] op3
     /*  389074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389077 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389089 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389094 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389096 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389098 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389108 */     GIR_RootConstrainSelectedInstOperands,
     /*  389109 */     // GIR_Coverage, 63381,
     /*  389109 */     GIR_EraseRootFromParent_Done,
     /*  389110 */   // Label 7001: @389110
     /*  389110 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(389185), // Rule ID 63382 //
     /*  389115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  389126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389133 */     // MIs[0] op1
     /*  389133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389141 */     // MIs[0] op2
     /*  389141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389149 */     // MIs[0] op3
     /*  389149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389152 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389169 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389171 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389173 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389183 */     GIR_RootConstrainSelectedInstOperands,
     /*  389184 */     // GIR_Coverage, 63382,
     /*  389184 */     GIR_EraseRootFromParent_Done,
     /*  389185 */   // Label 7002: @389185
     /*  389185 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(389260), // Rule ID 63425 //
     /*  389190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  389201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389208 */     // MIs[0] op1
     /*  389208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389216 */     // MIs[0] op2
     /*  389216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389224 */     // MIs[0] op3
     /*  389224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389239 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  389239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  389242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389244 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389246 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389248 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389258 */     GIR_RootConstrainSelectedInstOperands,
     /*  389259 */     // GIR_Coverage, 63425,
     /*  389259 */     GIR_EraseRootFromParent_Done,
     /*  389260 */   // Label 7003: @389260
     /*  389260 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(389335), // Rule ID 63426 //
     /*  389265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  389276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389283 */     // MIs[0] op1
     /*  389283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389291 */     // MIs[0] op2
     /*  389291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389299 */     // MIs[0] op3
     /*  389299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389314 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  389314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  389317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389319 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389321 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389323 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  389333 */     GIR_RootConstrainSelectedInstOperands,
     /*  389334 */     // GIR_Coverage, 63426,
     /*  389334 */     GIR_EraseRootFromParent_Done,
     /*  389335 */   // Label 7004: @389335
     /*  389335 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(389410), // Rule ID 63469 //
     /*  389340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  389351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389358 */     // MIs[0] op1
     /*  389358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389366 */     // MIs[0] op2
     /*  389366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389374 */     // MIs[0] op3
     /*  389374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389377 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389389 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  389392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389394 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389396 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389398 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389408 */     GIR_RootConstrainSelectedInstOperands,
     /*  389409 */     // GIR_Coverage, 63469,
     /*  389409 */     GIR_EraseRootFromParent_Done,
     /*  389410 */   // Label 7005: @389410
     /*  389410 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(389485), // Rule ID 63470 //
     /*  389415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  389426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389433 */     // MIs[0] op1
     /*  389433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389441 */     // MIs[0] op2
     /*  389441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389449 */     // MIs[0] op3
     /*  389449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  389467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389469 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389471 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389473 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389483 */     GIR_RootConstrainSelectedInstOperands,
     /*  389484 */     // GIR_Coverage, 63470,
     /*  389484 */     GIR_EraseRootFromParent_Done,
     /*  389485 */   // Label 7006: @389485
     /*  389485 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(389560), // Rule ID 63525 //
     /*  389490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  389501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389508 */     // MIs[0] op1
     /*  389508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389516 */     // MIs[0] op2
     /*  389516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389524 */     // MIs[0] op3
     /*  389524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389539 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389544 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389546 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389548 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389558 */     GIR_RootConstrainSelectedInstOperands,
     /*  389559 */     // GIR_Coverage, 63525,
     /*  389559 */     GIR_EraseRootFromParent_Done,
     /*  389560 */   // Label 7007: @389560
     /*  389560 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(389635), // Rule ID 63526 //
     /*  389565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  389576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389583 */     // MIs[0] op1
     /*  389583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389591 */     // MIs[0] op2
     /*  389591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389599 */     // MIs[0] op3
     /*  389599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389619 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389621 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389623 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389633 */     GIR_RootConstrainSelectedInstOperands,
     /*  389634 */     // GIR_Coverage, 63526,
     /*  389634 */     GIR_EraseRootFromParent_Done,
     /*  389635 */   // Label 7008: @389635
     /*  389635 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(389710), // Rule ID 63581 //
     /*  389640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  389651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389658 */     // MIs[0] op1
     /*  389658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389666 */     // MIs[0] op2
     /*  389666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389674 */     // MIs[0] op3
     /*  389674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389689 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  389692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389694 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389696 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389698 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389708 */     GIR_RootConstrainSelectedInstOperands,
     /*  389709 */     // GIR_Coverage, 63581,
     /*  389709 */     GIR_EraseRootFromParent_Done,
     /*  389710 */   // Label 7009: @389710
     /*  389710 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(389785), // Rule ID 63582 //
     /*  389715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  389726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389733 */     // MIs[0] op1
     /*  389733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389741 */     // MIs[0] op2
     /*  389741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389749 */     // MIs[0] op3
     /*  389749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389764 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  389767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389769 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389771 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389773 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389783 */     GIR_RootConstrainSelectedInstOperands,
     /*  389784 */     // GIR_Coverage, 63582,
     /*  389784 */     GIR_EraseRootFromParent_Done,
     /*  389785 */   // Label 7010: @389785
     /*  389785 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(389860), // Rule ID 63637 //
     /*  389790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  389801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389808 */     // MIs[0] op1
     /*  389808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389816 */     // MIs[0] op2
     /*  389816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389824 */     // MIs[0] op3
     /*  389824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  389839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  389842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389844 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389846 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389848 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389858 */     GIR_RootConstrainSelectedInstOperands,
     /*  389859 */     // GIR_Coverage, 63637,
     /*  389859 */     GIR_EraseRootFromParent_Done,
     /*  389860 */   // Label 7011: @389860
     /*  389860 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(389935), // Rule ID 63638 //
     /*  389865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  389876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389883 */     // MIs[0] op1
     /*  389883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389891 */     // MIs[0] op2
     /*  389891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389899 */     // MIs[0] op3
     /*  389899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  389914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  389917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389919 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389921 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389923 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389933 */     GIR_RootConstrainSelectedInstOperands,
     /*  389934 */     // GIR_Coverage, 63638,
     /*  389934 */     GIR_EraseRootFromParent_Done,
     /*  389935 */   // Label 7012: @389935
     /*  389935 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(390010), // Rule ID 63693 //
     /*  389940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  389951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389958 */     // MIs[0] op1
     /*  389958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389966 */     // MIs[0] op2
     /*  389966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389974 */     // MIs[0] op3
     /*  389974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389989 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  389989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389994 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389996 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389998 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390008 */     GIR_RootConstrainSelectedInstOperands,
     /*  390009 */     // GIR_Coverage, 63693,
     /*  390009 */     GIR_EraseRootFromParent_Done,
     /*  390010 */   // Label 7013: @390010
     /*  390010 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(390085), // Rule ID 63694 //
     /*  390015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  390026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390033 */     // MIs[0] op1
     /*  390033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390041 */     // MIs[0] op2
     /*  390041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390049 */     // MIs[0] op3
     /*  390049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390064 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  390067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390069 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390071 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390073 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390083 */     GIR_RootConstrainSelectedInstOperands,
     /*  390084 */     // GIR_Coverage, 63694,
     /*  390084 */     GIR_EraseRootFromParent_Done,
     /*  390085 */   // Label 7014: @390085
     /*  390085 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(390160), // Rule ID 63749 //
     /*  390090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  390101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390108 */     // MIs[0] op1
     /*  390108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390111 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390116 */     // MIs[0] op2
     /*  390116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390124 */     // MIs[0] op3
     /*  390124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390139 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  390142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390144 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390146 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390148 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390158 */     GIR_RootConstrainSelectedInstOperands,
     /*  390159 */     // GIR_Coverage, 63749,
     /*  390159 */     GIR_EraseRootFromParent_Done,
     /*  390160 */   // Label 7015: @390160
     /*  390160 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(390235), // Rule ID 63750 //
     /*  390165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  390176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390183 */     // MIs[0] op1
     /*  390183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390191 */     // MIs[0] op2
     /*  390191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390199 */     // MIs[0] op3
     /*  390199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390214 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  390214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  390217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390219 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390221 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390223 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390233 */     GIR_RootConstrainSelectedInstOperands,
     /*  390234 */     // GIR_Coverage, 63750,
     /*  390234 */     GIR_EraseRootFromParent_Done,
     /*  390235 */   // Label 7016: @390235
     /*  390235 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(390310), // Rule ID 63805 //
     /*  390240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  390251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390258 */     // MIs[0] op1
     /*  390258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390266 */     // MIs[0] op2
     /*  390266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390274 */     // MIs[0] op3
     /*  390274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  390292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390294 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390296 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390298 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390308 */     GIR_RootConstrainSelectedInstOperands,
     /*  390309 */     // GIR_Coverage, 63805,
     /*  390309 */     GIR_EraseRootFromParent_Done,
     /*  390310 */   // Label 7017: @390310
     /*  390310 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(390385), // Rule ID 63806 //
     /*  390315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  390326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  390333 */     // MIs[0] op1
     /*  390333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390341 */     // MIs[0] op2
     /*  390341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390349 */     // MIs[0] op3
     /*  390349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390364 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  390367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390369 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390371 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390373 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390383 */     GIR_RootConstrainSelectedInstOperands,
     /*  390384 */     // GIR_Coverage, 63806,
     /*  390384 */     GIR_EraseRootFromParent_Done,
     /*  390385 */   // Label 7018: @390385
     /*  390385 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(390460), // Rule ID 63861 //
     /*  390390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  390401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390408 */     // MIs[0] op1
     /*  390408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390416 */     // MIs[0] op2
     /*  390416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390424 */     // MIs[0] op3
     /*  390424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390439 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  390442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390444 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390446 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390448 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390458 */     GIR_RootConstrainSelectedInstOperands,
     /*  390459 */     // GIR_Coverage, 63861,
     /*  390459 */     GIR_EraseRootFromParent_Done,
     /*  390460 */   // Label 7019: @390460
     /*  390460 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(390535), // Rule ID 63862 //
     /*  390465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  390476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  390483 */     // MIs[0] op1
     /*  390483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390491 */     // MIs[0] op2
     /*  390491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390499 */     // MIs[0] op3
     /*  390499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390514 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  390517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390519 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390521 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390523 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390533 */     GIR_RootConstrainSelectedInstOperands,
     /*  390534 */     // GIR_Coverage, 63862,
     /*  390534 */     GIR_EraseRootFromParent_Done,
     /*  390535 */   // Label 7020: @390535
     /*  390535 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(390610), // Rule ID 63917 //
     /*  390540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  390551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390558 */     // MIs[0] op1
     /*  390558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390566 */     // MIs[0] op2
     /*  390566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390574 */     // MIs[0] op3
     /*  390574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390577 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390589 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11067:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  390592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390594 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390596 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390598 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390608 */     GIR_RootConstrainSelectedInstOperands,
     /*  390609 */     // GIR_Coverage, 63917,
     /*  390609 */     GIR_EraseRootFromParent_Done,
     /*  390610 */   // Label 7021: @390610
     /*  390610 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(390685), // Rule ID 63918 //
     /*  390615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  390626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390633 */     // MIs[0] op1
     /*  390633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390641 */     // MIs[0] op2
     /*  390641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390649 */     // MIs[0] op3
     /*  390649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390664 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11067:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  390667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390669 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390671 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390673 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390683 */     GIR_RootConstrainSelectedInstOperands,
     /*  390684 */     // GIR_Coverage, 63918,
     /*  390684 */     GIR_EraseRootFromParent_Done,
     /*  390685 */   // Label 7022: @390685
     /*  390685 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(390759), // Rule ID 62819 //
     /*  390690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  390701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390711 */     // MIs[0] op1
     /*  390711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390714 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390719 */     // MIs[0] op2
     /*  390719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390738 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  390738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  390741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390743 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390745 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390747 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390757 */     GIR_RootConstrainSelectedInstOperands,
     /*  390758 */     // GIR_Coverage, 62819,
     /*  390758 */     GIR_EraseRootFromParent_Done,
     /*  390759 */   // Label 7023: @390759
     /*  390759 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(390833), // Rule ID 62820 //
     /*  390764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  390775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390785 */     // MIs[0] op1
     /*  390785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390788 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390793 */     // MIs[0] op2
     /*  390793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  390812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  390815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390817 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390819 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390821 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390831 */     GIR_RootConstrainSelectedInstOperands,
     /*  390832 */     // GIR_Coverage, 62820,
     /*  390832 */     GIR_EraseRootFromParent_Done,
     /*  390833 */   // Label 7024: @390833
     /*  390833 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(390907), // Rule ID 62865 //
     /*  390838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  390849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390859 */     // MIs[0] op1
     /*  390859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390867 */     // MIs[0] op2
     /*  390867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390886 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  390886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  390889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390891 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390893 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390895 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390905 */     GIR_RootConstrainSelectedInstOperands,
     /*  390906 */     // GIR_Coverage, 62865,
     /*  390906 */     GIR_EraseRootFromParent_Done,
     /*  390907 */   // Label 7025: @390907
     /*  390907 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(390981), // Rule ID 62866 //
     /*  390912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  390923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390933 */     // MIs[0] op1
     /*  390933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390941 */     // MIs[0] op2
     /*  390941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390960 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  390960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  390963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390965 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390967 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390969 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390979 */     GIR_RootConstrainSelectedInstOperands,
     /*  390980 */     // GIR_Coverage, 62866,
     /*  390980 */     GIR_EraseRootFromParent_Done,
     /*  390981 */   // Label 7026: @390981
     /*  390981 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(391055), // Rule ID 62909 //
     /*  390986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  390997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391007 */     // MIs[0] op1
     /*  391007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391015 */     // MIs[0] op2
     /*  391015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391034 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  391037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391039 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391041 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391043 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391053 */     GIR_RootConstrainSelectedInstOperands,
     /*  391054 */     // GIR_Coverage, 62909,
     /*  391054 */     GIR_EraseRootFromParent_Done,
     /*  391055 */   // Label 7027: @391055
     /*  391055 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(391129), // Rule ID 62910 //
     /*  391060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  391071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391081 */     // MIs[0] op1
     /*  391081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391089 */     // MIs[0] op2
     /*  391089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391092 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391108 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  391111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391113 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391115 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391117 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391127 */     GIR_RootConstrainSelectedInstOperands,
     /*  391128 */     // GIR_Coverage, 62910,
     /*  391128 */     GIR_EraseRootFromParent_Done,
     /*  391129 */   // Label 7028: @391129
     /*  391129 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(391203), // Rule ID 62953 //
     /*  391134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391155 */     // MIs[0] op1
     /*  391155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391158 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391163 */     // MIs[0] op2
     /*  391163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  391185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391187 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391189 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391191 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391201 */     GIR_RootConstrainSelectedInstOperands,
     /*  391202 */     // GIR_Coverage, 62953,
     /*  391202 */     GIR_EraseRootFromParent_Done,
     /*  391203 */   // Label 7029: @391203
     /*  391203 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(391277), // Rule ID 62954 //
     /*  391208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  391219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391229 */     // MIs[0] op1
     /*  391229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391237 */     // MIs[0] op2
     /*  391237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391256 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  391259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391261 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391263 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391265 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391275 */     GIR_RootConstrainSelectedInstOperands,
     /*  391276 */     // GIR_Coverage, 62954,
     /*  391276 */     GIR_EraseRootFromParent_Done,
     /*  391277 */   // Label 7030: @391277
     /*  391277 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(391351), // Rule ID 63009 //
     /*  391282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391303 */     // MIs[0] op1
     /*  391303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391306 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391311 */     // MIs[0] op2
     /*  391311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391330 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  391333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391335 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391337 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391339 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391349 */     GIR_RootConstrainSelectedInstOperands,
     /*  391350 */     // GIR_Coverage, 63009,
     /*  391350 */     GIR_EraseRootFromParent_Done,
     /*  391351 */   // Label 7031: @391351
     /*  391351 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(391425), // Rule ID 63010 //
     /*  391356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  391367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391377 */     // MIs[0] op1
     /*  391377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391385 */     // MIs[0] op2
     /*  391385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391404 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  391407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391409 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391411 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391413 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391423 */     GIR_RootConstrainSelectedInstOperands,
     /*  391424 */     // GIR_Coverage, 63010,
     /*  391424 */     GIR_EraseRootFromParent_Done,
     /*  391425 */   // Label 7032: @391425
     /*  391425 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(391499), // Rule ID 63065 //
     /*  391430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391451 */     // MIs[0] op1
     /*  391451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391459 */     // MIs[0] op2
     /*  391459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  391478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  391481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391483 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391485 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391487 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391497 */     GIR_RootConstrainSelectedInstOperands,
     /*  391498 */     // GIR_Coverage, 63065,
     /*  391498 */     GIR_EraseRootFromParent_Done,
     /*  391499 */   // Label 7033: @391499
     /*  391499 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(391573), // Rule ID 63066 //
     /*  391504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391525 */     // MIs[0] op1
     /*  391525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391533 */     // MIs[0] op2
     /*  391533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391552 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  391552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  391555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391557 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391559 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391561 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391571 */     GIR_RootConstrainSelectedInstOperands,
     /*  391572 */     // GIR_Coverage, 63066,
     /*  391572 */     GIR_EraseRootFromParent_Done,
     /*  391573 */   // Label 7034: @391573
     /*  391573 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(391647), // Rule ID 63121 //
     /*  391578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  391589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391599 */     // MIs[0] op1
     /*  391599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391602 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391607 */     // MIs[0] op2
     /*  391607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391631 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391633 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391635 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391645 */     GIR_RootConstrainSelectedInstOperands,
     /*  391646 */     // GIR_Coverage, 63121,
     /*  391646 */     GIR_EraseRootFromParent_Done,
     /*  391647 */   // Label 7035: @391647
     /*  391647 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(391721), // Rule ID 63122 //
     /*  391652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  391663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391673 */     // MIs[0] op1
     /*  391673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391681 */     // MIs[0] op2
     /*  391681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391705 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391707 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391709 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391719 */     GIR_RootConstrainSelectedInstOperands,
     /*  391720 */     // GIR_Coverage, 63122,
     /*  391720 */     GIR_EraseRootFromParent_Done,
     /*  391721 */   // Label 7036: @391721
     /*  391721 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(391795), // Rule ID 63165 //
     /*  391726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  391737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391747 */     // MIs[0] op1
     /*  391747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391755 */     // MIs[0] op2
     /*  391755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391779 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391781 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391783 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391793 */     GIR_RootConstrainSelectedInstOperands,
     /*  391794 */     // GIR_Coverage, 63165,
     /*  391794 */     GIR_EraseRootFromParent_Done,
     /*  391795 */   // Label 7037: @391795
     /*  391795 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(391869), // Rule ID 63166 //
     /*  391800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  391811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391821 */     // MIs[0] op1
     /*  391821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391824 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391829 */     // MIs[0] op2
     /*  391829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391848 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391853 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391855 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391857 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391867 */     GIR_RootConstrainSelectedInstOperands,
     /*  391868 */     // GIR_Coverage, 63166,
     /*  391868 */     GIR_EraseRootFromParent_Done,
     /*  391869 */   // Label 7038: @391869
     /*  391869 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(391943), // Rule ID 63221 //
     /*  391874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  391885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391895 */     // MIs[0] op1
     /*  391895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391903 */     // MIs[0] op2
     /*  391903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  391922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391927 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391929 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391931 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391941 */     GIR_RootConstrainSelectedInstOperands,
     /*  391942 */     // GIR_Coverage, 63221,
     /*  391942 */     GIR_EraseRootFromParent_Done,
     /*  391943 */   // Label 7039: @391943
     /*  391943 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(392017), // Rule ID 63222 //
     /*  391948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  391959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391969 */     // MIs[0] op1
     /*  391969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391977 */     // MIs[0] op2
     /*  391977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  391996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392001 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392003 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392005 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392015 */     GIR_RootConstrainSelectedInstOperands,
     /*  392016 */     // GIR_Coverage, 63222,
     /*  392016 */     GIR_EraseRootFromParent_Done,
     /*  392017 */   // Label 7040: @392017
     /*  392017 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(392091), // Rule ID 63277 //
     /*  392022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392043 */     // MIs[0] op1
     /*  392043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392051 */     // MIs[0] op2
     /*  392051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  392070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  392073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392075 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392077 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392079 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392089 */     GIR_RootConstrainSelectedInstOperands,
     /*  392090 */     // GIR_Coverage, 63277,
     /*  392090 */     GIR_EraseRootFromParent_Done,
     /*  392091 */   // Label 7041: @392091
     /*  392091 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(392165), // Rule ID 63278 //
     /*  392096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  392107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  392117 */     // MIs[0] op1
     /*  392117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392125 */     // MIs[0] op2
     /*  392125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  392144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  392147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392149 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392151 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392153 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  392163 */     GIR_RootConstrainSelectedInstOperands,
     /*  392164 */     // GIR_Coverage, 63278,
     /*  392164 */     GIR_EraseRootFromParent_Done,
     /*  392165 */   // Label 7042: @392165
     /*  392165 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(392239), // Rule ID 63333 //
     /*  392170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392191 */     // MIs[0] op1
     /*  392191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392199 */     // MIs[0] op2
     /*  392199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  392221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392223 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392225 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392227 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392237 */     GIR_RootConstrainSelectedInstOperands,
     /*  392238 */     // GIR_Coverage, 63333,
     /*  392238 */     GIR_EraseRootFromParent_Done,
     /*  392239 */   // Label 7043: @392239
     /*  392239 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(392313), // Rule ID 63334 //
     /*  392244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  392255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392265 */     // MIs[0] op1
     /*  392265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392273 */     // MIs[0] op2
     /*  392273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392292 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  392295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392297 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392299 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392301 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392311 */     GIR_RootConstrainSelectedInstOperands,
     /*  392312 */     // GIR_Coverage, 63334,
     /*  392312 */     GIR_EraseRootFromParent_Done,
     /*  392313 */   // Label 7044: @392313
     /*  392313 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(392387), // Rule ID 63377 //
     /*  392318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392339 */     // MIs[0] op1
     /*  392339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392347 */     // MIs[0] op2
     /*  392347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392366 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  392369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392371 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392373 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392375 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392385 */     GIR_RootConstrainSelectedInstOperands,
     /*  392386 */     // GIR_Coverage, 63377,
     /*  392386 */     GIR_EraseRootFromParent_Done,
     /*  392387 */   // Label 7045: @392387
     /*  392387 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(392461), // Rule ID 63378 //
     /*  392392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  392403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392413 */     // MIs[0] op1
     /*  392413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392421 */     // MIs[0] op2
     /*  392421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392440 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  392443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392445 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392447 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392449 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392459 */     GIR_RootConstrainSelectedInstOperands,
     /*  392460 */     // GIR_Coverage, 63378,
     /*  392460 */     GIR_EraseRootFromParent_Done,
     /*  392461 */   // Label 7046: @392461
     /*  392461 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(392535), // Rule ID 63421 //
     /*  392466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  392477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392487 */     // MIs[0] op1
     /*  392487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392495 */     // MIs[0] op2
     /*  392495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  392517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392519 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392521 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392523 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392533 */     GIR_RootConstrainSelectedInstOperands,
     /*  392534 */     // GIR_Coverage, 63421,
     /*  392534 */     GIR_EraseRootFromParent_Done,
     /*  392535 */   // Label 7047: @392535
     /*  392535 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(392609), // Rule ID 63422 //
     /*  392540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  392551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392561 */     // MIs[0] op1
     /*  392561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392564 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392569 */     // MIs[0] op2
     /*  392569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392588 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  392591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392593 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392595 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392597 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392607 */     GIR_RootConstrainSelectedInstOperands,
     /*  392608 */     // GIR_Coverage, 63422,
     /*  392608 */     GIR_EraseRootFromParent_Done,
     /*  392609 */   // Label 7048: @392609
     /*  392609 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(392683), // Rule ID 63465 //
     /*  392614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  392625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392635 */     // MIs[0] op1
     /*  392635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392638 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392643 */     // MIs[0] op2
     /*  392643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392662 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  392665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392667 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392669 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392671 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392681 */     GIR_RootConstrainSelectedInstOperands,
     /*  392682 */     // GIR_Coverage, 63465,
     /*  392682 */     GIR_EraseRootFromParent_Done,
     /*  392683 */   // Label 7049: @392683
     /*  392683 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(392757), // Rule ID 63466 //
     /*  392688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  392699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392709 */     // MIs[0] op1
     /*  392709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392717 */     // MIs[0] op2
     /*  392717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392720 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  392739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392741 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392743 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392745 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392755 */     GIR_RootConstrainSelectedInstOperands,
     /*  392756 */     // GIR_Coverage, 63466,
     /*  392756 */     GIR_EraseRootFromParent_Done,
     /*  392757 */   // Label 7050: @392757
     /*  392757 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(392831), // Rule ID 63521 //
     /*  392762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  392773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392783 */     // MIs[0] op1
     /*  392783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392791 */     // MIs[0] op2
     /*  392791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392810 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  392813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392815 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392817 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392819 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392829 */     GIR_RootConstrainSelectedInstOperands,
     /*  392830 */     // GIR_Coverage, 63521,
     /*  392830 */     GIR_EraseRootFromParent_Done,
     /*  392831 */   // Label 7051: @392831
     /*  392831 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(392905), // Rule ID 63522 //
     /*  392836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  392847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392857 */     // MIs[0] op1
     /*  392857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392865 */     // MIs[0] op2
     /*  392865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392884 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  392887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392889 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392891 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392893 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392903 */     GIR_RootConstrainSelectedInstOperands,
     /*  392904 */     // GIR_Coverage, 63522,
     /*  392904 */     GIR_EraseRootFromParent_Done,
     /*  392905 */   // Label 7052: @392905
     /*  392905 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(392979), // Rule ID 63577 //
     /*  392910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  392921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392931 */     // MIs[0] op1
     /*  392931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392934 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392939 */     // MIs[0] op2
     /*  392939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392958 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  392961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392963 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392965 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392967 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392977 */     GIR_RootConstrainSelectedInstOperands,
     /*  392978 */     // GIR_Coverage, 63577,
     /*  392978 */     GIR_EraseRootFromParent_Done,
     /*  392979 */   // Label 7053: @392979
     /*  392979 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(393053), // Rule ID 63578 //
     /*  392984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  392995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393005 */     // MIs[0] op1
     /*  393005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393013 */     // MIs[0] op2
     /*  393013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393032 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  393032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  393035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393037 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393039 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393041 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393051 */     GIR_RootConstrainSelectedInstOperands,
     /*  393052 */     // GIR_Coverage, 63578,
     /*  393052 */     GIR_EraseRootFromParent_Done,
     /*  393053 */   // Label 7054: @393053
     /*  393053 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(393127), // Rule ID 63633 //
     /*  393058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393079 */     // MIs[0] op1
     /*  393079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393087 */     // MIs[0] op2
     /*  393087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  393109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393111 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393113 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393115 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393125 */     GIR_RootConstrainSelectedInstOperands,
     /*  393126 */     // GIR_Coverage, 63633,
     /*  393126 */     GIR_EraseRootFromParent_Done,
     /*  393127 */   // Label 7055: @393127
     /*  393127 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(393201), // Rule ID 63634 //
     /*  393132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  393143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393153 */     // MIs[0] op1
     /*  393153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393161 */     // MIs[0] op2
     /*  393161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393180 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  393183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393185 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393187 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393189 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393199 */     GIR_RootConstrainSelectedInstOperands,
     /*  393200 */     // GIR_Coverage, 63634,
     /*  393200 */     GIR_EraseRootFromParent_Done,
     /*  393201 */   // Label 7056: @393201
     /*  393201 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(393275), // Rule ID 63689 //
     /*  393206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393227 */     // MIs[0] op1
     /*  393227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393230 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393235 */     // MIs[0] op2
     /*  393235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  393257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393259 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393261 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393263 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393273 */     GIR_RootConstrainSelectedInstOperands,
     /*  393274 */     // GIR_Coverage, 63689,
     /*  393274 */     GIR_EraseRootFromParent_Done,
     /*  393275 */   // Label 7057: @393275
     /*  393275 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(393349), // Rule ID 63690 //
     /*  393280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  393291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393301 */     // MIs[0] op1
     /*  393301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393309 */     // MIs[0] op2
     /*  393309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  393331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393333 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393335 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393337 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393347 */     GIR_RootConstrainSelectedInstOperands,
     /*  393348 */     // GIR_Coverage, 63690,
     /*  393348 */     GIR_EraseRootFromParent_Done,
     /*  393349 */   // Label 7058: @393349
     /*  393349 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(393423), // Rule ID 63745 //
     /*  393354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393375 */     // MIs[0] op1
     /*  393375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393383 */     // MIs[0] op2
     /*  393383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  393402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  393405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393407 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393409 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393411 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393421 */     GIR_RootConstrainSelectedInstOperands,
     /*  393422 */     // GIR_Coverage, 63745,
     /*  393422 */     GIR_EraseRootFromParent_Done,
     /*  393423 */   // Label 7059: @393423
     /*  393423 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(393497), // Rule ID 63746 //
     /*  393428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  393439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393449 */     // MIs[0] op1
     /*  393449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393457 */     // MIs[0] op2
     /*  393457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  393476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  393479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393481 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393483 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393485 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  393495 */     GIR_RootConstrainSelectedInstOperands,
     /*  393496 */     // GIR_Coverage, 63746,
     /*  393496 */     GIR_EraseRootFromParent_Done,
     /*  393497 */   // Label 7060: @393497
     /*  393497 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(393571), // Rule ID 63801 //
     /*  393502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393523 */     // MIs[0] op1
     /*  393523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393531 */     // MIs[0] op2
     /*  393531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393550 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  393550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  393553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393555 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393557 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393559 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393569 */     GIR_RootConstrainSelectedInstOperands,
     /*  393570 */     // GIR_Coverage, 63801,
     /*  393570 */     GIR_EraseRootFromParent_Done,
     /*  393571 */   // Label 7061: @393571
     /*  393571 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(393645), // Rule ID 63802 //
     /*  393576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393597 */     // MIs[0] op1
     /*  393597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393605 */     // MIs[0] op2
     /*  393605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393624 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  393624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  393627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393629 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393631 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393633 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393643 */     GIR_RootConstrainSelectedInstOperands,
     /*  393644 */     // GIR_Coverage, 63802,
     /*  393644 */     GIR_EraseRootFromParent_Done,
     /*  393645 */   // Label 7062: @393645
     /*  393645 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(393719), // Rule ID 63857 //
     /*  393650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  393661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393671 */     // MIs[0] op1
     /*  393671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393679 */     // MIs[0] op2
     /*  393679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393698 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  393698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  393701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393703 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393705 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393707 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393717 */     GIR_RootConstrainSelectedInstOperands,
     /*  393718 */     // GIR_Coverage, 63857,
     /*  393718 */     GIR_EraseRootFromParent_Done,
     /*  393719 */   // Label 7063: @393719
     /*  393719 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(393793), // Rule ID 63858 //
     /*  393724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  393735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393745 */     // MIs[0] op1
     /*  393745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393753 */     // MIs[0] op2
     /*  393753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393756 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393772 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  393772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  393775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393777 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393779 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393781 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393791 */     GIR_RootConstrainSelectedInstOperands,
     /*  393792 */     // GIR_Coverage, 63858,
     /*  393792 */     GIR_EraseRootFromParent_Done,
     /*  393793 */   // Label 7064: @393793
     /*  393793 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(393867), // Rule ID 63913 //
     /*  393798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  393809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393819 */     // MIs[0] op1
     /*  393819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393827 */     // MIs[0] op2
     /*  393827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  393846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  393849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393851 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393853 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393855 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393865 */     GIR_RootConstrainSelectedInstOperands,
     /*  393866 */     // GIR_Coverage, 63913,
     /*  393866 */     GIR_EraseRootFromParent_Done,
     /*  393867 */   // Label 7065: @393867
     /*  393867 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(393941), // Rule ID 63914 //
     /*  393872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  393883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393893 */     // MIs[0] op1
     /*  393893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393901 */     // MIs[0] op2
     /*  393901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11081:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  393920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  393923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393925 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393927 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393929 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393939 */     GIR_RootConstrainSelectedInstOperands,
     /*  393940 */     // GIR_Coverage, 63914,
     /*  393940 */     GIR_EraseRootFromParent_Done,
     /*  393941 */   // Label 7066: @393941
     /*  393941 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(394015), // Rule ID 62843 //
     /*  393946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  393957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  393960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393967 */     // MIs[0] op1
     /*  393967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393970 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393979 */     // MIs[0] op3
     /*  393979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393994 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  393994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  393997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393999 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394001 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394003 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394013 */     GIR_RootConstrainSelectedInstOperands,
     /*  394014 */     // GIR_Coverage, 62843,
     /*  394014 */     GIR_EraseRootFromParent_Done,
     /*  394015 */   // Label 7067: @394015
     /*  394015 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(394089), // Rule ID 62844 //
     /*  394020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  394031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  394034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394041 */     // MIs[0] op1
     /*  394041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394053 */     // MIs[0] op3
     /*  394053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394068 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  394071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394073 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394075 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394077 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394087 */     GIR_RootConstrainSelectedInstOperands,
     /*  394088 */     // GIR_Coverage, 62844,
     /*  394088 */     GIR_EraseRootFromParent_Done,
     /*  394089 */   // Label 7068: @394089
     /*  394089 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(394163), // Rule ID 62881 //
     /*  394094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  394108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394115 */     // MIs[0] op1
     /*  394115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394127 */     // MIs[0] op3
     /*  394127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394142 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  394145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394147 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394149 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394151 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394161 */     GIR_RootConstrainSelectedInstOperands,
     /*  394162 */     // GIR_Coverage, 62881,
     /*  394162 */     GIR_EraseRootFromParent_Done,
     /*  394163 */   // Label 7069: @394163
     /*  394163 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(394237), // Rule ID 62882 //
     /*  394168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  394179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  394182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394189 */     // MIs[0] op1
     /*  394189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394201 */     // MIs[0] op3
     /*  394201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394216 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  394219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394221 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394223 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394225 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394235 */     GIR_RootConstrainSelectedInstOperands,
     /*  394236 */     // GIR_Coverage, 62882,
     /*  394236 */     GIR_EraseRootFromParent_Done,
     /*  394237 */   // Label 7070: @394237
     /*  394237 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(394311), // Rule ID 62925 //
     /*  394242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  394256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394263 */     // MIs[0] op1
     /*  394263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394275 */     // MIs[0] op3
     /*  394275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394290 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394295 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394297 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394299 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394309 */     GIR_RootConstrainSelectedInstOperands,
     /*  394310 */     // GIR_Coverage, 62925,
     /*  394310 */     GIR_EraseRootFromParent_Done,
     /*  394311 */   // Label 7071: @394311
     /*  394311 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(394385), // Rule ID 62926 //
     /*  394316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  394327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  394330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394337 */     // MIs[0] op1
     /*  394337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394349 */     // MIs[0] op3
     /*  394349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394364 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394369 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394371 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394373 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394383 */     GIR_RootConstrainSelectedInstOperands,
     /*  394384 */     // GIR_Coverage, 62926,
     /*  394384 */     GIR_EraseRootFromParent_Done,
     /*  394385 */   // Label 7072: @394385
     /*  394385 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(394459), // Rule ID 62969 //
     /*  394390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394411 */     // MIs[0] op1
     /*  394411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394423 */     // MIs[0] op3
     /*  394423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  394438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  394441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394443 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394445 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394447 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394457 */     GIR_RootConstrainSelectedInstOperands,
     /*  394458 */     // GIR_Coverage, 62969,
     /*  394458 */     GIR_EraseRootFromParent_Done,
     /*  394459 */   // Label 7073: @394459
     /*  394459 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(394533), // Rule ID 62970 //
     /*  394464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  394475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  394478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394485 */     // MIs[0] op1
     /*  394485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394497 */     // MIs[0] op3
     /*  394497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  394512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  394515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394517 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394519 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394521 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394531 */     GIR_RootConstrainSelectedInstOperands,
     /*  394532 */     // GIR_Coverage, 62970,
     /*  394532 */     GIR_EraseRootFromParent_Done,
     /*  394533 */   // Label 7074: @394533
     /*  394533 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(394607), // Rule ID 63025 //
     /*  394538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  394549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  394552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394559 */     // MIs[0] op1
     /*  394559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394571 */     // MIs[0] op3
     /*  394571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  394586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394591 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394593 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394595 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394605 */     GIR_RootConstrainSelectedInstOperands,
     /*  394606 */     // GIR_Coverage, 63025,
     /*  394606 */     GIR_EraseRootFromParent_Done,
     /*  394607 */   // Label 7075: @394607
     /*  394607 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(394681), // Rule ID 63026 //
     /*  394612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  394623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  394626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394633 */     // MIs[0] op1
     /*  394633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394645 */     // MIs[0] op3
     /*  394645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394660 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  394660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394665 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394667 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394669 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394679 */     GIR_RootConstrainSelectedInstOperands,
     /*  394680 */     // GIR_Coverage, 63026,
     /*  394680 */     GIR_EraseRootFromParent_Done,
     /*  394681 */   // Label 7076: @394681
     /*  394681 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(394755), // Rule ID 63081 //
     /*  394686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  394697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  394700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394707 */     // MIs[0] op1
     /*  394707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394719 */     // MIs[0] op3
     /*  394719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  394734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394739 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394741 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394743 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394753 */     GIR_RootConstrainSelectedInstOperands,
     /*  394754 */     // GIR_Coverage, 63081,
     /*  394754 */     GIR_EraseRootFromParent_Done,
     /*  394755 */   // Label 7077: @394755
     /*  394755 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(394829), // Rule ID 63082 //
     /*  394760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  394771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  394774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394781 */     // MIs[0] op1
     /*  394781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394793 */     // MIs[0] op3
     /*  394793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394808 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  394808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394813 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394815 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394817 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394827 */     GIR_RootConstrainSelectedInstOperands,
     /*  394828 */     // GIR_Coverage, 63082,
     /*  394828 */     GIR_EraseRootFromParent_Done,
     /*  394829 */   // Label 7078: @394829
     /*  394829 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(394903), // Rule ID 63137 //
     /*  394834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  394845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  394848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394855 */     // MIs[0] op1
     /*  394855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394867 */     // MIs[0] op3
     /*  394867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394882 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394887 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394889 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394891 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394901 */     GIR_RootConstrainSelectedInstOperands,
     /*  394902 */     // GIR_Coverage, 63137,
     /*  394902 */     GIR_EraseRootFromParent_Done,
     /*  394903 */   // Label 7079: @394903
     /*  394903 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(394977), // Rule ID 63138 //
     /*  394908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  394919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  394922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394929 */     // MIs[0] op1
     /*  394929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394932 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394941 */     // MIs[0] op3
     /*  394941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394956 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394961 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394963 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394965 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394975 */     GIR_RootConstrainSelectedInstOperands,
     /*  394976 */     // GIR_Coverage, 63138,
     /*  394976 */     GIR_EraseRootFromParent_Done,
     /*  394977 */   // Label 7080: @394977
     /*  394977 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(395051), // Rule ID 63181 //
     /*  394982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  394993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  394996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395003 */     // MIs[0] op1
     /*  395003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395015 */     // MIs[0] op3
     /*  395015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395030 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  395033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395035 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395037 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395039 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395049 */     GIR_RootConstrainSelectedInstOperands,
     /*  395050 */     // GIR_Coverage, 63181,
     /*  395050 */     GIR_EraseRootFromParent_Done,
     /*  395051 */   // Label 7081: @395051
     /*  395051 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(395125), // Rule ID 63182 //
     /*  395056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  395067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  395070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395077 */     // MIs[0] op1
     /*  395077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395089 */     // MIs[0] op3
     /*  395089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395092 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395104 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  395107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395109 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395111 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395113 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395123 */     GIR_RootConstrainSelectedInstOperands,
     /*  395124 */     // GIR_Coverage, 63182,
     /*  395124 */     GIR_EraseRootFromParent_Done,
     /*  395125 */   // Label 7082: @395125
     /*  395125 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(395199), // Rule ID 63237 //
     /*  395130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395151 */     // MIs[0] op1
     /*  395151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395154 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395163 */     // MIs[0] op3
     /*  395163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  395181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395183 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395185 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395187 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395197 */     GIR_RootConstrainSelectedInstOperands,
     /*  395198 */     // GIR_Coverage, 63237,
     /*  395198 */     GIR_EraseRootFromParent_Done,
     /*  395199 */   // Label 7083: @395199
     /*  395199 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(395273), // Rule ID 63238 //
     /*  395204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  395215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  395218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395225 */     // MIs[0] op1
     /*  395225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395228 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395237 */     // MIs[0] op3
     /*  395237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  395255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395257 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395259 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395261 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395271 */     GIR_RootConstrainSelectedInstOperands,
     /*  395272 */     // GIR_Coverage, 63238,
     /*  395272 */     GIR_EraseRootFromParent_Done,
     /*  395273 */   // Label 7084: @395273
     /*  395273 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(395347), // Rule ID 63293 //
     /*  395278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395299 */     // MIs[0] op1
     /*  395299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395311 */     // MIs[0] op3
     /*  395311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  395326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  395329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395331 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395333 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395335 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395345 */     GIR_RootConstrainSelectedInstOperands,
     /*  395346 */     // GIR_Coverage, 63293,
     /*  395346 */     GIR_EraseRootFromParent_Done,
     /*  395347 */   // Label 7085: @395347
     /*  395347 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(395421), // Rule ID 63294 //
     /*  395352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  395363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  395366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395373 */     // MIs[0] op1
     /*  395373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  395385 */     // MIs[0] op3
     /*  395385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395400 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  395400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  395403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395405 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395407 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395409 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  395419 */     GIR_RootConstrainSelectedInstOperands,
     /*  395420 */     // GIR_Coverage, 63294,
     /*  395420 */     GIR_EraseRootFromParent_Done,
     /*  395421 */   // Label 7086: @395421
     /*  395421 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(395495), // Rule ID 63349 //
     /*  395426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  395437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  395440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395447 */     // MIs[0] op1
     /*  395447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395459 */     // MIs[0] op3
     /*  395459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  395477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395479 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395481 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395483 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395493 */     GIR_RootConstrainSelectedInstOperands,
     /*  395494 */     // GIR_Coverage, 63349,
     /*  395494 */     GIR_EraseRootFromParent_Done,
     /*  395495 */   // Label 7087: @395495
     /*  395495 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(395569), // Rule ID 63350 //
     /*  395500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  395511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  395514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395521 */     // MIs[0] op1
     /*  395521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395533 */     // MIs[0] op3
     /*  395533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395548 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  395551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395553 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395555 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395557 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395567 */     GIR_RootConstrainSelectedInstOperands,
     /*  395568 */     // GIR_Coverage, 63350,
     /*  395568 */     GIR_EraseRootFromParent_Done,
     /*  395569 */   // Label 7088: @395569
     /*  395569 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(395643), // Rule ID 63393 //
     /*  395574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  395585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  395588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395595 */     // MIs[0] op1
     /*  395595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395598 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395607 */     // MIs[0] op3
     /*  395607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395622 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  395625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395627 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395629 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395631 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395641 */     GIR_RootConstrainSelectedInstOperands,
     /*  395642 */     // GIR_Coverage, 63393,
     /*  395642 */     GIR_EraseRootFromParent_Done,
     /*  395643 */   // Label 7089: @395643
     /*  395643 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(395717), // Rule ID 63394 //
     /*  395648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  395659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  395662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395669 */     // MIs[0] op1
     /*  395669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395681 */     // MIs[0] op3
     /*  395681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  395699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395701 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395703 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395705 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395715 */     GIR_RootConstrainSelectedInstOperands,
     /*  395716 */     // GIR_Coverage, 63394,
     /*  395716 */     GIR_EraseRootFromParent_Done,
     /*  395717 */   // Label 7090: @395717
     /*  395717 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(395791), // Rule ID 63437 //
     /*  395722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  395733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  395736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395743 */     // MIs[0] op1
     /*  395743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395755 */     // MIs[0] op3
     /*  395755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395770 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  395773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395775 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395777 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395779 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395789 */     GIR_RootConstrainSelectedInstOperands,
     /*  395790 */     // GIR_Coverage, 63437,
     /*  395790 */     GIR_EraseRootFromParent_Done,
     /*  395791 */   // Label 7091: @395791
     /*  395791 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(395865), // Rule ID 63438 //
     /*  395796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  395807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  395810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395817 */     // MIs[0] op1
     /*  395817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395820 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395829 */     // MIs[0] op3
     /*  395829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  395847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395849 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395851 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395853 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395863 */     GIR_RootConstrainSelectedInstOperands,
     /*  395864 */     // GIR_Coverage, 63438,
     /*  395864 */     GIR_EraseRootFromParent_Done,
     /*  395865 */   // Label 7092: @395865
     /*  395865 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(395939), // Rule ID 63481 //
     /*  395870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  395881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  395884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395891 */     // MIs[0] op1
     /*  395891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395903 */     // MIs[0] op3
     /*  395903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  395921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395923 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395925 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395927 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395937 */     GIR_RootConstrainSelectedInstOperands,
     /*  395938 */     // GIR_Coverage, 63481,
     /*  395938 */     GIR_EraseRootFromParent_Done,
     /*  395939 */   // Label 7093: @395939
     /*  395939 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(396013), // Rule ID 63482 //
     /*  395944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  395955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  395958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395965 */     // MIs[0] op1
     /*  395965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395977 */     // MIs[0] op3
     /*  395977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395992 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  395995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395997 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395999 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396001 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396011 */     GIR_RootConstrainSelectedInstOperands,
     /*  396012 */     // GIR_Coverage, 63482,
     /*  396012 */     GIR_EraseRootFromParent_Done,
     /*  396013 */   // Label 7094: @396013
     /*  396013 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(396087), // Rule ID 63537 //
     /*  396018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  396032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396039 */     // MIs[0] op1
     /*  396039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396051 */     // MIs[0] op3
     /*  396051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396066 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  396069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396071 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396073 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396075 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396085 */     GIR_RootConstrainSelectedInstOperands,
     /*  396086 */     // GIR_Coverage, 63537,
     /*  396086 */     GIR_EraseRootFromParent_Done,
     /*  396087 */   // Label 7095: @396087
     /*  396087 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(396161), // Rule ID 63538 //
     /*  396092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  396103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  396106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396113 */     // MIs[0] op1
     /*  396113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396125 */     // MIs[0] op3
     /*  396125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  396143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396145 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396147 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396149 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396159 */     GIR_RootConstrainSelectedInstOperands,
     /*  396160 */     // GIR_Coverage, 63538,
     /*  396160 */     GIR_EraseRootFromParent_Done,
     /*  396161 */   // Label 7096: @396161
     /*  396161 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(396235), // Rule ID 63593 //
     /*  396166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  396180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396187 */     // MIs[0] op1
     /*  396187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396199 */     // MIs[0] op3
     /*  396199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396214 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  396214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  396217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396219 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396221 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396223 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396233 */     GIR_RootConstrainSelectedInstOperands,
     /*  396234 */     // GIR_Coverage, 63593,
     /*  396234 */     GIR_EraseRootFromParent_Done,
     /*  396235 */   // Label 7097: @396235
     /*  396235 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(396309), // Rule ID 63594 //
     /*  396240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  396251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  396254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396261 */     // MIs[0] op1
     /*  396261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396273 */     // MIs[0] op3
     /*  396273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396288 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  396288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  396291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396293 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396295 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396297 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  396307 */     GIR_RootConstrainSelectedInstOperands,
     /*  396308 */     // GIR_Coverage, 63594,
     /*  396308 */     GIR_EraseRootFromParent_Done,
     /*  396309 */   // Label 7098: @396309
     /*  396309 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(396383), // Rule ID 63649 //
     /*  396314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  396328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396335 */     // MIs[0] op1
     /*  396335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396347 */     // MIs[0] op3
     /*  396347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  396365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396367 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396369 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396371 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396381 */     GIR_RootConstrainSelectedInstOperands,
     /*  396382 */     // GIR_Coverage, 63649,
     /*  396382 */     GIR_EraseRootFromParent_Done,
     /*  396383 */   // Label 7099: @396383
     /*  396383 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(396457), // Rule ID 63650 //
     /*  396388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  396399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  396402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396409 */     // MIs[0] op1
     /*  396409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396412 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396421 */     // MIs[0] op3
     /*  396421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  396439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396441 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396443 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396445 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396455 */     GIR_RootConstrainSelectedInstOperands,
     /*  396456 */     // GIR_Coverage, 63650,
     /*  396456 */     GIR_EraseRootFromParent_Done,
     /*  396457 */   // Label 7100: @396457
     /*  396457 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(396531), // Rule ID 63705 //
     /*  396462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  396473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  396476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396483 */     // MIs[0] op1
     /*  396483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396495 */     // MIs[0] op3
     /*  396495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  396513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396515 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396517 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396519 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396529 */     GIR_RootConstrainSelectedInstOperands,
     /*  396530 */     // GIR_Coverage, 63705,
     /*  396530 */     GIR_EraseRootFromParent_Done,
     /*  396531 */   // Label 7101: @396531
     /*  396531 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(396605), // Rule ID 63706 //
     /*  396536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  396547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  396550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396557 */     // MIs[0] op1
     /*  396557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396560 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396569 */     // MIs[0] op3
     /*  396569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  396587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396589 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396591 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396593 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396603 */     GIR_RootConstrainSelectedInstOperands,
     /*  396604 */     // GIR_Coverage, 63706,
     /*  396604 */     GIR_EraseRootFromParent_Done,
     /*  396605 */   // Label 7102: @396605
     /*  396605 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(396679), // Rule ID 63761 //
     /*  396610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  396621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  396624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396631 */     // MIs[0] op1
     /*  396631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396634 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396643 */     // MIs[0] op3
     /*  396643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396658 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  396661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396663 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396665 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396667 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396677 */     GIR_RootConstrainSelectedInstOperands,
     /*  396678 */     // GIR_Coverage, 63761,
     /*  396678 */     GIR_EraseRootFromParent_Done,
     /*  396679 */   // Label 7103: @396679
     /*  396679 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(396753), // Rule ID 63762 //
     /*  396684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  396695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  396698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396705 */     // MIs[0] op1
     /*  396705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396717 */     // MIs[0] op3
     /*  396717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396720 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  396735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396737 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396739 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396741 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396751 */     GIR_RootConstrainSelectedInstOperands,
     /*  396752 */     // GIR_Coverage, 63762,
     /*  396752 */     GIR_EraseRootFromParent_Done,
     /*  396753 */   // Label 7104: @396753
     /*  396753 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(396827), // Rule ID 63817 //
     /*  396758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  396769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  396772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396779 */     // MIs[0] op1
     /*  396779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396782 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396791 */     // MIs[0] op3
     /*  396791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396806 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  396806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  396809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396811 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396813 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396815 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396825 */     GIR_RootConstrainSelectedInstOperands,
     /*  396826 */     // GIR_Coverage, 63817,
     /*  396826 */     GIR_EraseRootFromParent_Done,
     /*  396827 */   // Label 7105: @396827
     /*  396827 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(396901), // Rule ID 63818 //
     /*  396832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  396843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  396846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396853 */     // MIs[0] op1
     /*  396853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396865 */     // MIs[0] op3
     /*  396865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  396880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  396883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396885 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396887 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396889 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396899 */     GIR_RootConstrainSelectedInstOperands,
     /*  396900 */     // GIR_Coverage, 63818,
     /*  396900 */     GIR_EraseRootFromParent_Done,
     /*  396901 */   // Label 7106: @396901
     /*  396901 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(396975), // Rule ID 63873 //
     /*  396906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  396917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  396920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396927 */     // MIs[0] op1
     /*  396927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396930 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396939 */     // MIs[0] op3
     /*  396939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396954 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  396954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  396957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396959 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396961 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396963 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396973 */     GIR_RootConstrainSelectedInstOperands,
     /*  396974 */     // GIR_Coverage, 63873,
     /*  396974 */     GIR_EraseRootFromParent_Done,
     /*  396975 */   // Label 7107: @396975
     /*  396975 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(397049), // Rule ID 63874 //
     /*  396980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  396991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  396994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397001 */     // MIs[0] op1
     /*  397001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  397013 */     // MIs[0] op3
     /*  397013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397028 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  397031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397033 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397035 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397037 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397047 */     GIR_RootConstrainSelectedInstOperands,
     /*  397048 */     // GIR_Coverage, 63874,
     /*  397048 */     GIR_EraseRootFromParent_Done,
     /*  397049 */   // Label 7108: @397049
     /*  397049 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(397123), // Rule ID 63929 //
     /*  397054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  397057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  397068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397075 */     // MIs[0] op1
     /*  397075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397087 */     // MIs[0] op3
     /*  397087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11069:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  397102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  397105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397107 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397109 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397111 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397121 */     GIR_RootConstrainSelectedInstOperands,
     /*  397122 */     // GIR_Coverage, 63929,
     /*  397122 */     GIR_EraseRootFromParent_Done,
     /*  397123 */   // Label 7109: @397123
     /*  397123 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(397197), // Rule ID 63930 //
     /*  397128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  397131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  397136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  397139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  397142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397149 */     // MIs[0] op1
     /*  397149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  397152 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  397157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  397161 */     // MIs[0] op3
     /*  397161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  397164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  397169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11069:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  397176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  397179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397181 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  397183 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  397185 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  397187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  397195 */     GIR_RootConstrainSelectedInstOperands,
     /*  397196 */     // GIR_Coverage, 63930,
     /*  397196 */     GIR_EraseRootFromParent_Done,
     /*  397197 */   // Label 7110: @397197
     /*  397197 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(397272), // Rule ID 7354 //
     /*  397202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  397216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397248 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  397251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397270 */     GIR_RootConstrainSelectedInstOperands,
     /*  397271 */     // GIR_Coverage, 7354,
     /*  397271 */     GIR_EraseRootFromParent_Done,
     /*  397272 */   // Label 7111: @397272
     /*  397272 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(397347), // Rule ID 7355 //
     /*  397277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  397288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  397291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  397294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397323 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  397326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397345 */     GIR_RootConstrainSelectedInstOperands,
     /*  397346 */     // GIR_Coverage, 7355,
     /*  397346 */     GIR_EraseRootFromParent_Done,
     /*  397347 */   // Label 7112: @397347
     /*  397347 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(397422), // Rule ID 7358 //
     /*  397352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  397366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397398 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397420 */     GIR_RootConstrainSelectedInstOperands,
     /*  397421 */     // GIR_Coverage, 7358,
     /*  397421 */     GIR_EraseRootFromParent_Done,
     /*  397422 */   // Label 7113: @397422
     /*  397422 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(397497), // Rule ID 7359 //
     /*  397427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  397438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  397441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  397444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397473 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397495 */     GIR_RootConstrainSelectedInstOperands,
     /*  397496 */     // GIR_Coverage, 7359,
     /*  397496 */     GIR_EraseRootFromParent_Done,
     /*  397497 */   // Label 7114: @397497
     /*  397497 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(397572), // Rule ID 7362 //
     /*  397502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  397513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  397516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  397519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397548 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397570 */     GIR_RootConstrainSelectedInstOperands,
     /*  397571 */     // GIR_Coverage, 7362,
     /*  397571 */     GIR_EraseRootFromParent_Done,
     /*  397572 */   // Label 7115: @397572
     /*  397572 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(397647), // Rule ID 7363 //
     /*  397577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  397588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  397591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  397594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397612 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397623 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397645 */     GIR_RootConstrainSelectedInstOperands,
     /*  397646 */     // GIR_Coverage, 7363,
     /*  397646 */     GIR_EraseRootFromParent_Done,
     /*  397647 */   // Label 7116: @397647
     /*  397647 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(397722), // Rule ID 7366 //
     /*  397652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  397663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  397666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  397669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397698 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  397698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397720 */     GIR_RootConstrainSelectedInstOperands,
     /*  397721 */     // GIR_Coverage, 7366,
     /*  397721 */     GIR_EraseRootFromParent_Done,
     /*  397722 */   // Label 7117: @397722
     /*  397722 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(397797), // Rule ID 7367 //
     /*  397727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  397738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  397741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  397744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397762 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397773 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  397773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397795 */     GIR_RootConstrainSelectedInstOperands,
     /*  397796 */     // GIR_Coverage, 7367,
     /*  397796 */     GIR_EraseRootFromParent_Done,
     /*  397797 */   // Label 7118: @397797
     /*  397797 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(397872), // Rule ID 7370 //
     /*  397802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  397813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  397816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  397819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397848 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  397848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397870 */     GIR_RootConstrainSelectedInstOperands,
     /*  397871 */     // GIR_Coverage, 7370,
     /*  397871 */     GIR_EraseRootFromParent_Done,
     /*  397872 */   // Label 7119: @397872
     /*  397872 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(397947), // Rule ID 7371 //
     /*  397877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  397888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  397891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  397894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397923 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  397923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397945 */     GIR_RootConstrainSelectedInstOperands,
     /*  397946 */     // GIR_Coverage, 7371,
     /*  397946 */     GIR_EraseRootFromParent_Done,
     /*  397947 */   // Label 7120: @397947
     /*  397947 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(398022), // Rule ID 7374 //
     /*  397952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  397963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  397966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  397969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  397998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398020 */     GIR_RootConstrainSelectedInstOperands,
     /*  398021 */     // GIR_Coverage, 7374,
     /*  398021 */     GIR_EraseRootFromParent_Done,
     /*  398022 */   // Label 7121: @398022
     /*  398022 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(398097), // Rule ID 7375 //
     /*  398027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  398038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  398041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  398044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398073 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  398073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  398076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398095 */     GIR_RootConstrainSelectedInstOperands,
     /*  398096 */     // GIR_Coverage, 7375,
     /*  398096 */     GIR_EraseRootFromParent_Done,
     /*  398097 */   // Label 7122: @398097
     /*  398097 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(398172), // Rule ID 7378 //
     /*  398102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  398116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398148 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398170 */     GIR_RootConstrainSelectedInstOperands,
     /*  398171 */     // GIR_Coverage, 7378,
     /*  398171 */     GIR_EraseRootFromParent_Done,
     /*  398172 */   // Label 7123: @398172
     /*  398172 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(398247), // Rule ID 7379 //
     /*  398177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  398188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  398191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  398194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398212 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398223 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398245 */     GIR_RootConstrainSelectedInstOperands,
     /*  398246 */     // GIR_Coverage, 7379,
     /*  398246 */     GIR_EraseRootFromParent_Done,
     /*  398247 */   // Label 7124: @398247
     /*  398247 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(398322), // Rule ID 7382 //
     /*  398252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  398266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398298 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398320 */     GIR_RootConstrainSelectedInstOperands,
     /*  398321 */     // GIR_Coverage, 7382,
     /*  398321 */     GIR_EraseRootFromParent_Done,
     /*  398322 */   // Label 7125: @398322
     /*  398322 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(398397), // Rule ID 7383 //
     /*  398327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  398338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  398341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  398344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398362 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398373 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398395 */     GIR_RootConstrainSelectedInstOperands,
     /*  398396 */     // GIR_Coverage, 7383,
     /*  398396 */     GIR_EraseRootFromParent_Done,
     /*  398397 */   // Label 7126: @398397
     /*  398397 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(398472), // Rule ID 7386 //
     /*  398402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  398416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  398448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398470 */     GIR_RootConstrainSelectedInstOperands,
     /*  398471 */     // GIR_Coverage, 7386,
     /*  398471 */     GIR_EraseRootFromParent_Done,
     /*  398472 */   // Label 7127: @398472
     /*  398472 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(398547), // Rule ID 7387 //
     /*  398477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  398488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  398491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  398494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398523 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  398523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398545 */     GIR_RootConstrainSelectedInstOperands,
     /*  398546 */     // GIR_Coverage, 7387,
     /*  398546 */     GIR_EraseRootFromParent_Done,
     /*  398547 */   // Label 7128: @398547
     /*  398547 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(398622), // Rule ID 7390 //
     /*  398552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  398555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  398563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  398566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  398569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398598 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  398598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  398617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398620 */     GIR_RootConstrainSelectedInstOperands,
     /*  398621 */     // GIR_Coverage, 7390,
     /*  398621 */     GIR_EraseRootFromParent_Done,
     /*  398622 */   // Label 7129: @398622
     /*  398622 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(398697), // Rule ID 7391 //
     /*  398627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  398630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  398638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  398641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  398644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398673 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  398673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  398692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398695 */     GIR_RootConstrainSelectedInstOperands,
     /*  398696 */     // GIR_Coverage, 7391,
     /*  398696 */     GIR_EraseRootFromParent_Done,
     /*  398697 */   // Label 7130: @398697
     /*  398697 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(398772), // Rule ID 7394 //
     /*  398702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  398713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  398716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  398719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  398751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398770 */     GIR_RootConstrainSelectedInstOperands,
     /*  398771 */     // GIR_Coverage, 7394,
     /*  398771 */     GIR_EraseRootFromParent_Done,
     /*  398772 */   // Label 7131: @398772
     /*  398772 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(398847), // Rule ID 7395 //
     /*  398777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  398788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  398791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  398794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398823 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  398826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398845 */     GIR_RootConstrainSelectedInstOperands,
     /*  398846 */     // GIR_Coverage, 7395,
     /*  398846 */     GIR_EraseRootFromParent_Done,
     /*  398847 */   // Label 7132: @398847
     /*  398847 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(398922), // Rule ID 7398 //
     /*  398852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  398863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  398866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  398869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398887 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398898 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  398901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398920 */     GIR_RootConstrainSelectedInstOperands,
     /*  398921 */     // GIR_Coverage, 7398,
     /*  398921 */     GIR_EraseRootFromParent_Done,
     /*  398922 */   // Label 7133: @398922
     /*  398922 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(398997), // Rule ID 7399 //
     /*  398927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  398938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  398941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  398944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398973 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  398976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398995 */     GIR_RootConstrainSelectedInstOperands,
     /*  398996 */     // GIR_Coverage, 7399,
     /*  398996 */     GIR_EraseRootFromParent_Done,
     /*  398997 */   // Label 7134: @398997
     /*  398997 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(399072), // Rule ID 7402 //
     /*  399002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  399016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399048 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  399048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399070 */     GIR_RootConstrainSelectedInstOperands,
     /*  399071 */     // GIR_Coverage, 7402,
     /*  399071 */     GIR_EraseRootFromParent_Done,
     /*  399072 */   // Label 7135: @399072
     /*  399072 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(399147), // Rule ID 7403 //
     /*  399077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  399088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  399091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  399094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399123 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  399123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  399142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399145 */     GIR_RootConstrainSelectedInstOperands,
     /*  399146 */     // GIR_Coverage, 7403,
     /*  399146 */     GIR_EraseRootFromParent_Done,
     /*  399147 */   // Label 7136: @399147
     /*  399147 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(399222), // Rule ID 7406 //
     /*  399152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399220 */     GIR_RootConstrainSelectedInstOperands,
     /*  399221 */     // GIR_Coverage, 7406,
     /*  399221 */     GIR_EraseRootFromParent_Done,
     /*  399222 */   // Label 7137: @399222
     /*  399222 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(399297), // Rule ID 7407 //
     /*  399227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  399238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  399241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  399244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399273 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399295 */     GIR_RootConstrainSelectedInstOperands,
     /*  399296 */     // GIR_Coverage, 7407,
     /*  399296 */     GIR_EraseRootFromParent_Done,
     /*  399297 */   // Label 7138: @399297
     /*  399297 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(399372), // Rule ID 7410 //
     /*  399302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399370 */     GIR_RootConstrainSelectedInstOperands,
     /*  399371 */     // GIR_Coverage, 7410,
     /*  399371 */     GIR_EraseRootFromParent_Done,
     /*  399372 */   // Label 7139: @399372
     /*  399372 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(399447), // Rule ID 7411 //
     /*  399377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  399388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  399391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  399394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399423 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399445 */     GIR_RootConstrainSelectedInstOperands,
     /*  399446 */     // GIR_Coverage, 7411,
     /*  399446 */     GIR_EraseRootFromParent_Done,
     /*  399447 */   // Label 7140: @399447
     /*  399447 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(399522), // Rule ID 7414 //
     /*  399452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  399463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  399466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  399469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  399498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399520 */     GIR_RootConstrainSelectedInstOperands,
     /*  399521 */     // GIR_Coverage, 7414,
     /*  399521 */     GIR_EraseRootFromParent_Done,
     /*  399522 */   // Label 7141: @399522
     /*  399522 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(399597), // Rule ID 7415 //
     /*  399527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  399538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  399541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  399544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399573 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399595 */     GIR_RootConstrainSelectedInstOperands,
     /*  399596 */     // GIR_Coverage, 7415,
     /*  399596 */     GIR_EraseRootFromParent_Done,
     /*  399597 */   // Label 7142: @399597
     /*  399597 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(399672), // Rule ID 7418 //
     /*  399602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  399613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  399616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  399619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  399648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399670 */     GIR_RootConstrainSelectedInstOperands,
     /*  399671 */     // GIR_Coverage, 7418,
     /*  399671 */     GIR_EraseRootFromParent_Done,
     /*  399672 */   // Label 7143: @399672
     /*  399672 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(399747), // Rule ID 7419 //
     /*  399677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  399688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  399691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  399694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  399723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399745 */     GIR_RootConstrainSelectedInstOperands,
     /*  399746 */     // GIR_Coverage, 7419,
     /*  399746 */     GIR_EraseRootFromParent_Done,
     /*  399747 */   // Label 7144: @399747
     /*  399747 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(399822), // Rule ID 7422 //
     /*  399752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  399763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  399766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  399769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399798 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  399798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399820 */     GIR_RootConstrainSelectedInstOperands,
     /*  399821 */     // GIR_Coverage, 7422,
     /*  399821 */     GIR_EraseRootFromParent_Done,
     /*  399822 */   // Label 7145: @399822
     /*  399822 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(399897), // Rule ID 7423 //
     /*  399827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  399838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  399841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  399844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399873 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  399873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399895 */     GIR_RootConstrainSelectedInstOperands,
     /*  399896 */     // GIR_Coverage, 7423,
     /*  399896 */     GIR_EraseRootFromParent_Done,
     /*  399897 */   // Label 7146: @399897
     /*  399897 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(399972), // Rule ID 7426 //
     /*  399902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  399913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  399916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  399919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  399948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399970 */     GIR_RootConstrainSelectedInstOperands,
     /*  399971 */     // GIR_Coverage, 7426,
     /*  399971 */     GIR_EraseRootFromParent_Done,
     /*  399972 */   // Label 7147: @399972
     /*  399972 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(400047), // Rule ID 7427 //
     /*  399977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  399988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  399991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  399994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400023 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400045 */     GIR_RootConstrainSelectedInstOperands,
     /*  400046 */     // GIR_Coverage, 7427,
     /*  400046 */     GIR_EraseRootFromParent_Done,
     /*  400047 */   // Label 7148: @400047
     /*  400047 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(400122), // Rule ID 7430 //
     /*  400052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400120 */     GIR_RootConstrainSelectedInstOperands,
     /*  400121 */     // GIR_Coverage, 7430,
     /*  400121 */     GIR_EraseRootFromParent_Done,
     /*  400122 */   // Label 7149: @400122
     /*  400122 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(400197), // Rule ID 7431 //
     /*  400127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  400138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  400141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  400144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400173 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  400176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400195 */     GIR_RootConstrainSelectedInstOperands,
     /*  400196 */     // GIR_Coverage, 7431,
     /*  400196 */     GIR_EraseRootFromParent_Done,
     /*  400197 */   // Label 7150: @400197
     /*  400197 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(400272), // Rule ID 7434 //
     /*  400202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  400216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400248 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400270 */     GIR_RootConstrainSelectedInstOperands,
     /*  400271 */     // GIR_Coverage, 7434,
     /*  400271 */     GIR_EraseRootFromParent_Done,
     /*  400272 */   // Label 7151: @400272
     /*  400272 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(400347), // Rule ID 7435 //
     /*  400277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  400288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  400291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  400294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  400312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400323 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  400326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400345 */     GIR_RootConstrainSelectedInstOperands,
     /*  400346 */     // GIR_Coverage, 7435,
     /*  400346 */     GIR_EraseRootFromParent_Done,
     /*  400347 */   // Label 7152: @400347
     /*  400347 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(400422), // Rule ID 7438 //
     /*  400352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  400355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  400366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  400372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400398 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400420 */     GIR_RootConstrainSelectedInstOperands,
     /*  400421 */     // GIR_Coverage, 7438,
     /*  400421 */     GIR_EraseRootFromParent_Done,
     /*  400422 */   // Label 7153: @400422
     /*  400422 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(400497), // Rule ID 7439 //
     /*  400427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  400430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  400435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  400438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  400441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  400444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  400447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  400462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  400466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400473 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  400476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  400484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400495 */     GIR_RootConstrainSelectedInstOperands,
     /*  400496 */     // GIR_Coverage, 7439,
     /*  400496 */     GIR_EraseRootFromParent_Done,
     /*  400497 */   // Label 7154: @400497
     /*  400497 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(400574), // Rule ID 2744 //
     /*  400502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  400513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  400516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  400519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400534 */     // MIs[0] Operand 4
     /*  400534 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  400552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  400555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400572 */     GIR_RootConstrainSelectedInstOperands,
     /*  400573 */     // GIR_Coverage, 2744,
     /*  400573 */     GIR_EraseRootFromParent_Done,
     /*  400574 */   // Label 7155: @400574
     /*  400574 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(400651), // Rule ID 2745 //
     /*  400579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  400582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  400590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  400593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  400596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400611 */     // MIs[0] Operand 4
     /*  400611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400629 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  400629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  400632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400649 */     GIR_RootConstrainSelectedInstOperands,
     /*  400650 */     // GIR_Coverage, 2745,
     /*  400650 */     GIR_EraseRootFromParent_Done,
     /*  400651 */   // Label 7156: @400651
     /*  400651 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(400728), // Rule ID 20636 //
     /*  400656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  400667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  400670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  400673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400688 */     // MIs[0] Operand 4
     /*  400688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  400706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400726 */     GIR_RootConstrainSelectedInstOperands,
     /*  400727 */     // GIR_Coverage, 20636,
     /*  400727 */     GIR_EraseRootFromParent_Done,
     /*  400728 */   // Label 7157: @400728
     /*  400728 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(400805), // Rule ID 20637 //
     /*  400733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  400736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  400744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  400747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  400750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400765 */     // MIs[0] Operand 4
     /*  400765 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400783 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  400783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400803 */     GIR_RootConstrainSelectedInstOperands,
     /*  400804 */     // GIR_Coverage, 20637,
     /*  400804 */     GIR_EraseRootFromParent_Done,
     /*  400805 */   // Label 7158: @400805
     /*  400805 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(400882), // Rule ID 20640 //
     /*  400810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  400813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  400821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  400824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  400827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400842 */     // MIs[0] Operand 4
     /*  400842 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400880 */     GIR_RootConstrainSelectedInstOperands,
     /*  400881 */     // GIR_Coverage, 20640,
     /*  400881 */     GIR_EraseRootFromParent_Done,
     /*  400882 */   // Label 7159: @400882
     /*  400882 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(400959), // Rule ID 20641 //
     /*  400887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  400890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  400898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  400901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  400904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400919 */     // MIs[0] Operand 4
     /*  400919 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400937 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400957 */     GIR_RootConstrainSelectedInstOperands,
     /*  400958 */     // GIR_Coverage, 20641,
     /*  400958 */     GIR_EraseRootFromParent_Done,
     /*  400959 */   // Label 7160: @400959
     /*  400959 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(401036), // Rule ID 20644 //
     /*  400964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  400975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  400978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  400981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400996 */     // MIs[0] Operand 4
     /*  400996 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401034 */     GIR_RootConstrainSelectedInstOperands,
     /*  401035 */     // GIR_Coverage, 20644,
     /*  401035 */     GIR_EraseRootFromParent_Done,
     /*  401036 */   // Label 7161: @401036
     /*  401036 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(401113), // Rule ID 20645 //
     /*  401041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  401052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  401055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  401058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401073 */     // MIs[0] Operand 4
     /*  401073 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401091 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401111 */     GIR_RootConstrainSelectedInstOperands,
     /*  401112 */     // GIR_Coverage, 20645,
     /*  401112 */     GIR_EraseRootFromParent_Done,
     /*  401113 */   // Label 7162: @401113
     /*  401113 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(401190), // Rule ID 20648 //
     /*  401118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  401129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  401132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  401135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401150 */     // MIs[0] Operand 4
     /*  401150 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401168 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401188 */     GIR_RootConstrainSelectedInstOperands,
     /*  401189 */     // GIR_Coverage, 20648,
     /*  401189 */     GIR_EraseRootFromParent_Done,
     /*  401190 */   // Label 7163: @401190
     /*  401190 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(401267), // Rule ID 20649 //
     /*  401195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  401206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  401209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  401212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401227 */     // MIs[0] Operand 4
     /*  401227 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401245 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401265 */     GIR_RootConstrainSelectedInstOperands,
     /*  401266 */     // GIR_Coverage, 20649,
     /*  401266 */     GIR_EraseRootFromParent_Done,
     /*  401267 */   // Label 7164: @401267
     /*  401267 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(401344), // Rule ID 20652 //
     /*  401272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  401275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  401283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  401286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  401289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401304 */     // MIs[0] Operand 4
     /*  401304 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401322 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  401322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401342 */     GIR_RootConstrainSelectedInstOperands,
     /*  401343 */     // GIR_Coverage, 20652,
     /*  401343 */     GIR_EraseRootFromParent_Done,
     /*  401344 */   // Label 7165: @401344
     /*  401344 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(401421), // Rule ID 20653 //
     /*  401349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  401352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  401360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  401363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  401366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  401381 */     // MIs[0] Operand 4
     /*  401381 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401399 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  401399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  401402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401419 */     GIR_RootConstrainSelectedInstOperands,
     /*  401420 */     // GIR_Coverage, 20653,
     /*  401420 */     GIR_EraseRootFromParent_Done,
     /*  401421 */   // Label 7166: @401421
     /*  401421 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(401498), // Rule ID 20656 //
     /*  401426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  401437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  401440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  401443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401458 */     // MIs[0] Operand 4
     /*  401458 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401476 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401496 */     GIR_RootConstrainSelectedInstOperands,
     /*  401497 */     // GIR_Coverage, 20656,
     /*  401497 */     GIR_EraseRootFromParent_Done,
     /*  401498 */   // Label 7167: @401498
     /*  401498 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(401575), // Rule ID 20657 //
     /*  401503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  401514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  401517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  401520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401535 */     // MIs[0] Operand 4
     /*  401535 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401553 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401573 */     GIR_RootConstrainSelectedInstOperands,
     /*  401574 */     // GIR_Coverage, 20657,
     /*  401574 */     GIR_EraseRootFromParent_Done,
     /*  401575 */   // Label 7168: @401575
     /*  401575 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(401652), // Rule ID 20660 //
     /*  401580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  401591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  401594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  401597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401612 */     // MIs[0] Operand 4
     /*  401612 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401630 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  401633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401650 */     GIR_RootConstrainSelectedInstOperands,
     /*  401651 */     // GIR_Coverage, 20660,
     /*  401651 */     GIR_EraseRootFromParent_Done,
     /*  401652 */   // Label 7169: @401652
     /*  401652 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(401729), // Rule ID 20661 //
     /*  401657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  401668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  401671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  401674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401689 */     // MIs[0] Operand 4
     /*  401689 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401707 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  401710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401727 */     GIR_RootConstrainSelectedInstOperands,
     /*  401728 */     // GIR_Coverage, 20661,
     /*  401728 */     GIR_EraseRootFromParent_Done,
     /*  401729 */   // Label 7170: @401729
     /*  401729 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(401806), // Rule ID 20664 //
     /*  401734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  401745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  401748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  401751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401766 */     // MIs[0] Operand 4
     /*  401766 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401784 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  401787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401804 */     GIR_RootConstrainSelectedInstOperands,
     /*  401805 */     // GIR_Coverage, 20664,
     /*  401805 */     GIR_EraseRootFromParent_Done,
     /*  401806 */   // Label 7171: @401806
     /*  401806 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(401883), // Rule ID 20665 //
     /*  401811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  401822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  401825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  401828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401843 */     // MIs[0] Operand 4
     /*  401843 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401861 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  401864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401881 */     GIR_RootConstrainSelectedInstOperands,
     /*  401882 */     // GIR_Coverage, 20665,
     /*  401882 */     GIR_EraseRootFromParent_Done,
     /*  401883 */   // Label 7172: @401883
     /*  401883 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(401960), // Rule ID 20668 //
     /*  401888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  401899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  401902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  401905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401920 */     // MIs[0] Operand 4
     /*  401920 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401958 */     GIR_RootConstrainSelectedInstOperands,
     /*  401959 */     // GIR_Coverage, 20668,
     /*  401959 */     GIR_EraseRootFromParent_Done,
     /*  401960 */   // Label 7173: @401960
     /*  401960 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(402037), // Rule ID 20669 //
     /*  401965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  401976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  401979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  401982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401997 */     // MIs[0] Operand 4
     /*  401997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402035 */     GIR_RootConstrainSelectedInstOperands,
     /*  402036 */     // GIR_Coverage, 20669,
     /*  402036 */     GIR_EraseRootFromParent_Done,
     /*  402037 */   // Label 7174: @402037
     /*  402037 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(402114), // Rule ID 20672 //
     /*  402042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  402053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  402056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  402059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402074 */     // MIs[0] Operand 4
     /*  402074 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402092 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402112 */     GIR_RootConstrainSelectedInstOperands,
     /*  402113 */     // GIR_Coverage, 20672,
     /*  402113 */     GIR_EraseRootFromParent_Done,
     /*  402114 */   // Label 7175: @402114
     /*  402114 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(402191), // Rule ID 20673 //
     /*  402119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  402130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  402133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  402136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402151 */     // MIs[0] Operand 4
     /*  402151 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402169 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402189 */     GIR_RootConstrainSelectedInstOperands,
     /*  402190 */     // GIR_Coverage, 20673,
     /*  402190 */     GIR_EraseRootFromParent_Done,
     /*  402191 */   // Label 7176: @402191
     /*  402191 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(402268), // Rule ID 20676 //
     /*  402196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  402207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  402210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  402213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402228 */     // MIs[0] Operand 4
     /*  402228 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402246 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402266 */     GIR_RootConstrainSelectedInstOperands,
     /*  402267 */     // GIR_Coverage, 20676,
     /*  402267 */     GIR_EraseRootFromParent_Done,
     /*  402268 */   // Label 7177: @402268
     /*  402268 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(402345), // Rule ID 20677 //
     /*  402273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  402284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  402287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  402290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402305 */     // MIs[0] Operand 4
     /*  402305 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402323 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402343 */     GIR_RootConstrainSelectedInstOperands,
     /*  402344 */     // GIR_Coverage, 20677,
     /*  402344 */     GIR_EraseRootFromParent_Done,
     /*  402345 */   // Label 7178: @402345
     /*  402345 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(402422), // Rule ID 20680 //
     /*  402350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  402361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  402364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  402367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402382 */     // MIs[0] Operand 4
     /*  402382 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402420 */     GIR_RootConstrainSelectedInstOperands,
     /*  402421 */     // GIR_Coverage, 20680,
     /*  402421 */     GIR_EraseRootFromParent_Done,
     /*  402422 */   // Label 7179: @402422
     /*  402422 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(402499), // Rule ID 20681 //
     /*  402427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  402438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  402441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  402444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  402459 */     // MIs[0] Operand 4
     /*  402459 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402477 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  402480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402497 */     GIR_RootConstrainSelectedInstOperands,
     /*  402498 */     // GIR_Coverage, 20681,
     /*  402498 */     GIR_EraseRootFromParent_Done,
     /*  402499 */   // Label 7180: @402499
     /*  402499 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(402576), // Rule ID 20684 //
     /*  402504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  402515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  402518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  402521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402536 */     // MIs[0] Operand 4
     /*  402536 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402574 */     GIR_RootConstrainSelectedInstOperands,
     /*  402575 */     // GIR_Coverage, 20684,
     /*  402575 */     GIR_EraseRootFromParent_Done,
     /*  402576 */   // Label 7181: @402576
     /*  402576 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(402653), // Rule ID 20685 //
     /*  402581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  402592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  402595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  402598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402613 */     // MIs[0] Operand 4
     /*  402613 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402631 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402651 */     GIR_RootConstrainSelectedInstOperands,
     /*  402652 */     // GIR_Coverage, 20685,
     /*  402652 */     GIR_EraseRootFromParent_Done,
     /*  402653 */   // Label 7182: @402653
     /*  402653 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(402730), // Rule ID 20688 //
     /*  402658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  402669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  402672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  402675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402690 */     // MIs[0] Operand 4
     /*  402690 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402708 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402728 */     GIR_RootConstrainSelectedInstOperands,
     /*  402729 */     // GIR_Coverage, 20688,
     /*  402729 */     GIR_EraseRootFromParent_Done,
     /*  402730 */   // Label 7183: @402730
     /*  402730 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(402807), // Rule ID 20689 //
     /*  402735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  402746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  402749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  402752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402767 */     // MIs[0] Operand 4
     /*  402767 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402785 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402805 */     GIR_RootConstrainSelectedInstOperands,
     /*  402806 */     // GIR_Coverage, 20689,
     /*  402806 */     GIR_EraseRootFromParent_Done,
     /*  402807 */   // Label 7184: @402807
     /*  402807 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(402884), // Rule ID 20692 //
     /*  402812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  402823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  402826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  402829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402844 */     // MIs[0] Operand 4
     /*  402844 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402862 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  402865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402882 */     GIR_RootConstrainSelectedInstOperands,
     /*  402883 */     // GIR_Coverage, 20692,
     /*  402883 */     GIR_EraseRootFromParent_Done,
     /*  402884 */   // Label 7185: @402884
     /*  402884 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(402961), // Rule ID 20693 //
     /*  402889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  402892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  402900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  402903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  402906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402921 */     // MIs[0] Operand 4
     /*  402921 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402939 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  402942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402959 */     GIR_RootConstrainSelectedInstOperands,
     /*  402960 */     // GIR_Coverage, 20693,
     /*  402960 */     GIR_EraseRootFromParent_Done,
     /*  402961 */   // Label 7186: @402961
     /*  402961 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(403038), // Rule ID 20696 //
     /*  402966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  402977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  402980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  402983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402998 */     // MIs[0] Operand 4
     /*  402998 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403036 */     GIR_RootConstrainSelectedInstOperands,
     /*  403037 */     // GIR_Coverage, 20696,
     /*  403037 */     GIR_EraseRootFromParent_Done,
     /*  403038 */   // Label 7187: @403038
     /*  403038 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(403115), // Rule ID 20697 //
     /*  403043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  403054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  403057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  403060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403075 */     // MIs[0] Operand 4
     /*  403075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403113 */     GIR_RootConstrainSelectedInstOperands,
     /*  403114 */     // GIR_Coverage, 20697,
     /*  403114 */     GIR_EraseRootFromParent_Done,
     /*  403115 */   // Label 7188: @403115
     /*  403115 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(403192), // Rule ID 20700 //
     /*  403120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  403131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  403134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  403137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403152 */     // MIs[0] Operand 4
     /*  403152 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403170 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403190 */     GIR_RootConstrainSelectedInstOperands,
     /*  403191 */     // GIR_Coverage, 20700,
     /*  403191 */     GIR_EraseRootFromParent_Done,
     /*  403192 */   // Label 7189: @403192
     /*  403192 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(403269), // Rule ID 20701 //
     /*  403197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  403208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  403211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  403214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403229 */     // MIs[0] Operand 4
     /*  403229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403247 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  403250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403267 */     GIR_RootConstrainSelectedInstOperands,
     /*  403268 */     // GIR_Coverage, 20701,
     /*  403268 */     GIR_EraseRootFromParent_Done,
     /*  403269 */   // Label 7190: @403269
     /*  403269 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(403346), // Rule ID 20704 //
     /*  403274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  403285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  403288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  403291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403306 */     // MIs[0] Operand 4
     /*  403306 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403344 */     GIR_RootConstrainSelectedInstOperands,
     /*  403345 */     // GIR_Coverage, 20704,
     /*  403345 */     GIR_EraseRootFromParent_Done,
     /*  403346 */   // Label 7191: @403346
     /*  403346 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(403423), // Rule ID 20705 //
     /*  403351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  403362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  403365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  403368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403383 */     // MIs[0] Operand 4
     /*  403383 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403401 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403421 */     GIR_RootConstrainSelectedInstOperands,
     /*  403422 */     // GIR_Coverage, 20705,
     /*  403422 */     GIR_EraseRootFromParent_Done,
     /*  403423 */   // Label 7192: @403423
     /*  403423 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(403500), // Rule ID 20708 //
     /*  403428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  403439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  403442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  403445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403460 */     // MIs[0] Operand 4
     /*  403460 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403498 */     GIR_RootConstrainSelectedInstOperands,
     /*  403499 */     // GIR_Coverage, 20708,
     /*  403499 */     GIR_EraseRootFromParent_Done,
     /*  403500 */   // Label 7193: @403500
     /*  403500 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(403577), // Rule ID 20709 //
     /*  403505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  403516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  403519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  403522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403537 */     // MIs[0] Operand 4
     /*  403537 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403555 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403575 */     GIR_RootConstrainSelectedInstOperands,
     /*  403576 */     // GIR_Coverage, 20709,
     /*  403576 */     GIR_EraseRootFromParent_Done,
     /*  403577 */   // Label 7194: @403577
     /*  403577 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(403654), // Rule ID 20712 //
     /*  403582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  403585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  403593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  403596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  403599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403614 */     // MIs[0] Operand 4
     /*  403614 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  403632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403652 */     GIR_RootConstrainSelectedInstOperands,
     /*  403653 */     // GIR_Coverage, 20712,
     /*  403653 */     GIR_EraseRootFromParent_Done,
     /*  403654 */   // Label 7195: @403654
     /*  403654 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(403731), // Rule ID 20713 //
     /*  403659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  403662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  403670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  403673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  403676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403691 */     // MIs[0] Operand 4
     /*  403691 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403709 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  403709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403729 */     GIR_RootConstrainSelectedInstOperands,
     /*  403730 */     // GIR_Coverage, 20713,
     /*  403730 */     GIR_EraseRootFromParent_Done,
     /*  403731 */   // Label 7196: @403731
     /*  403731 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(403808), // Rule ID 20716 //
     /*  403736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403768 */     // MIs[0] Operand 4
     /*  403768 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403786 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  403789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403806 */     GIR_RootConstrainSelectedInstOperands,
     /*  403807 */     // GIR_Coverage, 20716,
     /*  403807 */     GIR_EraseRootFromParent_Done,
     /*  403808 */   // Label 7197: @403808
     /*  403808 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(403885), // Rule ID 20717 //
     /*  403813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403845 */     // MIs[0] Operand 4
     /*  403845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403863 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  403866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403883 */     GIR_RootConstrainSelectedInstOperands,
     /*  403884 */     // GIR_Coverage, 20717,
     /*  403884 */     GIR_EraseRootFromParent_Done,
     /*  403885 */   // Label 7198: @403885
     /*  403885 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(403962), // Rule ID 20720 //
     /*  403890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403922 */     // MIs[0] Operand 4
     /*  403922 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403940 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  403943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403960 */     GIR_RootConstrainSelectedInstOperands,
     /*  403961 */     // GIR_Coverage, 20720,
     /*  403961 */     GIR_EraseRootFromParent_Done,
     /*  403962 */   // Label 7199: @403962
     /*  403962 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(404039), // Rule ID 20721 //
     /*  403967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403999 */     // MIs[0] Operand 4
     /*  403999 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404017 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404037 */     GIR_RootConstrainSelectedInstOperands,
     /*  404038 */     // GIR_Coverage, 20721,
     /*  404038 */     GIR_EraseRootFromParent_Done,
     /*  404039 */   // Label 7200: @404039
     /*  404039 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(404116), // Rule ID 20724 //
     /*  404044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  404055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  404058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  404061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404076 */     // MIs[0] Operand 4
     /*  404076 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404094 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404114 */     GIR_RootConstrainSelectedInstOperands,
     /*  404115 */     // GIR_Coverage, 20724,
     /*  404115 */     GIR_EraseRootFromParent_Done,
     /*  404116 */   // Label 7201: @404116
     /*  404116 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(404193), // Rule ID 20725 //
     /*  404121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  404132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  404135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  404138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404153 */     // MIs[0] Operand 4
     /*  404153 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404171 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404191 */     GIR_RootConstrainSelectedInstOperands,
     /*  404192 */     // GIR_Coverage, 20725,
     /*  404192 */     GIR_EraseRootFromParent_Done,
     /*  404193 */   // Label 7202: @404193
     /*  404193 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(404270), // Rule ID 20728 //
     /*  404198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404230 */     // MIs[0] Operand 4
     /*  404230 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404268 */     GIR_RootConstrainSelectedInstOperands,
     /*  404269 */     // GIR_Coverage, 20728,
     /*  404269 */     GIR_EraseRootFromParent_Done,
     /*  404270 */   // Label 7203: @404270
     /*  404270 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(404347), // Rule ID 20729 //
     /*  404275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  404292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404307 */     // MIs[0] Operand 4
     /*  404307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404345 */     GIR_RootConstrainSelectedInstOperands,
     /*  404346 */     // GIR_Coverage, 20729,
     /*  404346 */     GIR_EraseRootFromParent_Done,
     /*  404347 */   // Label 7204: @404347
     /*  404347 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(404424), // Rule ID 20732 //
     /*  404352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404384 */     // MIs[0] Operand 4
     /*  404384 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404422 */     GIR_RootConstrainSelectedInstOperands,
     /*  404423 */     // GIR_Coverage, 20732,
     /*  404423 */     GIR_EraseRootFromParent_Done,
     /*  404424 */   // Label 7205: @404424
     /*  404424 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(404501), // Rule ID 20733 //
     /*  404429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  404440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  404443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  404446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404461 */     // MIs[0] Operand 4
     /*  404461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404479 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404499 */     GIR_RootConstrainSelectedInstOperands,
     /*  404500 */     // GIR_Coverage, 20733,
     /*  404500 */     GIR_EraseRootFromParent_Done,
     /*  404501 */   // Label 7206: @404501
     /*  404501 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(404578), // Rule ID 20736 //
     /*  404506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  404517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  404520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  404523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404538 */     // MIs[0] Operand 4
     /*  404538 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404556 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404576 */     GIR_RootConstrainSelectedInstOperands,
     /*  404577 */     // GIR_Coverage, 20736,
     /*  404577 */     GIR_EraseRootFromParent_Done,
     /*  404578 */   // Label 7207: @404578
     /*  404578 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(404655), // Rule ID 20737 //
     /*  404583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  404594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  404597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  404600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404615 */     // MIs[0] Operand 4
     /*  404615 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404633 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404653 */     GIR_RootConstrainSelectedInstOperands,
     /*  404654 */     // GIR_Coverage, 20737,
     /*  404654 */     GIR_EraseRootFromParent_Done,
     /*  404655 */   // Label 7208: @404655
     /*  404655 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(404732), // Rule ID 20740 //
     /*  404660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  404671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  404674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  404677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404692 */     // MIs[0] Operand 4
     /*  404692 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404730 */     GIR_RootConstrainSelectedInstOperands,
     /*  404731 */     // GIR_Coverage, 20740,
     /*  404731 */     GIR_EraseRootFromParent_Done,
     /*  404732 */   // Label 7209: @404732
     /*  404732 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(404809), // Rule ID 20741 //
     /*  404737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  404740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  404748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  404751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  404754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404769 */     // MIs[0] Operand 4
     /*  404769 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404787 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404807 */     GIR_RootConstrainSelectedInstOperands,
     /*  404808 */     // GIR_Coverage, 20741,
     /*  404808 */     GIR_EraseRootFromParent_Done,
     /*  404809 */   // Label 7210: @404809
     /*  404809 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(404886), // Rule ID 20744 //
     /*  404814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404846 */     // MIs[0] Operand 4
     /*  404846 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404864 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404884 */     GIR_RootConstrainSelectedInstOperands,
     /*  404885 */     // GIR_Coverage, 20744,
     /*  404885 */     GIR_EraseRootFromParent_Done,
     /*  404886 */   // Label 7211: @404886
     /*  404886 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(404963), // Rule ID 20745 //
     /*  404891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  404894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404923 */     // MIs[0] Operand 4
     /*  404923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404941 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404961 */     GIR_RootConstrainSelectedInstOperands,
     /*  404962 */     // GIR_Coverage, 20745,
     /*  404962 */     GIR_EraseRootFromParent_Done,
     /*  404963 */   // Label 7212: @404963
     /*  404963 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(405040), // Rule ID 20748 //
     /*  404968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  404985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405000 */     // MIs[0] Operand 4
     /*  405000 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405018 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  405018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405038 */     GIR_RootConstrainSelectedInstOperands,
     /*  405039 */     // GIR_Coverage, 20748,
     /*  405039 */     GIR_EraseRootFromParent_Done,
     /*  405040 */   // Label 7213: @405040
     /*  405040 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(405117), // Rule ID 20749 //
     /*  405045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  405048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  405053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  405056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  405059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  405062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405077 */     // MIs[0] Operand 4
     /*  405077 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405095 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  405095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  405098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  405112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405115 */     GIR_RootConstrainSelectedInstOperands,
     /*  405116 */     // GIR_Coverage, 20749,
     /*  405116 */     GIR_EraseRootFromParent_Done,
     /*  405117 */   // Label 7214: @405117
     /*  405117 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(405194), // Rule ID 21108 //
     /*  405122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  405139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405154 */     // MIs[0] Operand 4
     /*  405154 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405172 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  405175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405192 */     GIR_RootConstrainSelectedInstOperands,
     /*  405193 */     // GIR_Coverage, 21108,
     /*  405193 */     GIR_EraseRootFromParent_Done,
     /*  405194 */   // Label 7215: @405194
     /*  405194 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(405271), // Rule ID 21109 //
     /*  405199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  405210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  405213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  405216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405231 */     // MIs[0] Operand 4
     /*  405231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  405252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405269 */     GIR_RootConstrainSelectedInstOperands,
     /*  405270 */     // GIR_Coverage, 21109,
     /*  405270 */     GIR_EraseRootFromParent_Done,
     /*  405271 */   // Label 7216: @405271
     /*  405271 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(405348), // Rule ID 21112 //
     /*  405276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  405293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405308 */     // MIs[0] Operand 4
     /*  405308 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405346 */     GIR_RootConstrainSelectedInstOperands,
     /*  405347 */     // GIR_Coverage, 21112,
     /*  405347 */     GIR_EraseRootFromParent_Done,
     /*  405348 */   // Label 7217: @405348
     /*  405348 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(405425), // Rule ID 21113 //
     /*  405353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  405364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  405367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  405370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405385 */     // MIs[0] Operand 4
     /*  405385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405403 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405423 */     GIR_RootConstrainSelectedInstOperands,
     /*  405424 */     // GIR_Coverage, 21113,
     /*  405424 */     GIR_EraseRootFromParent_Done,
     /*  405425 */   // Label 7218: @405425
     /*  405425 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(405502), // Rule ID 21116 //
     /*  405430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  405447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405462 */     // MIs[0] Operand 4
     /*  405462 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405480 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  405483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405500 */     GIR_RootConstrainSelectedInstOperands,
     /*  405501 */     // GIR_Coverage, 21116,
     /*  405501 */     GIR_EraseRootFromParent_Done,
     /*  405502 */   // Label 7219: @405502
     /*  405502 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(405579), // Rule ID 21117 //
     /*  405507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  405524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405539 */     // MIs[0] Operand 4
     /*  405539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  405560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405577 */     GIR_RootConstrainSelectedInstOperands,
     /*  405578 */     // GIR_Coverage, 21117,
     /*  405578 */     GIR_EraseRootFromParent_Done,
     /*  405579 */   // Label 7220: @405579
     /*  405579 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(405656), // Rule ID 21120 //
     /*  405584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405616 */     // MIs[0] Operand 4
     /*  405616 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405634 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  405637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405654 */     GIR_RootConstrainSelectedInstOperands,
     /*  405655 */     // GIR_Coverage, 21120,
     /*  405655 */     GIR_EraseRootFromParent_Done,
     /*  405656 */   // Label 7221: @405656
     /*  405656 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(405733), // Rule ID 21121 //
     /*  405661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405693 */     // MIs[0] Operand 4
     /*  405693 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405711 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  405714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405731 */     GIR_RootConstrainSelectedInstOperands,
     /*  405732 */     // GIR_Coverage, 21121,
     /*  405732 */     GIR_EraseRootFromParent_Done,
     /*  405733 */   // Label 7222: @405733
     /*  405733 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(405810), // Rule ID 21124 //
     /*  405738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405770 */     // MIs[0] Operand 4
     /*  405770 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405788 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  405791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405808 */     GIR_RootConstrainSelectedInstOperands,
     /*  405809 */     // GIR_Coverage, 21124,
     /*  405809 */     GIR_EraseRootFromParent_Done,
     /*  405810 */   // Label 7223: @405810
     /*  405810 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(405887), // Rule ID 21125 //
     /*  405815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405847 */     // MIs[0] Operand 4
     /*  405847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405865 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  405868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405885 */     GIR_RootConstrainSelectedInstOperands,
     /*  405886 */     // GIR_Coverage, 21125,
     /*  405886 */     GIR_EraseRootFromParent_Done,
     /*  405887 */   // Label 7224: @405887
     /*  405887 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(405964), // Rule ID 21128 //
     /*  405892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  405895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405924 */     // MIs[0] Operand 4
     /*  405924 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405942 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405962 */     GIR_RootConstrainSelectedInstOperands,
     /*  405963 */     // GIR_Coverage, 21128,
     /*  405963 */     GIR_EraseRootFromParent_Done,
     /*  405964 */   // Label 7225: @405964
     /*  405964 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(406041), // Rule ID 21129 //
     /*  405969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  405972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406001 */     // MIs[0] Operand 4
     /*  406001 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406019 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  406022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406039 */     GIR_RootConstrainSelectedInstOperands,
     /*  406040 */     // GIR_Coverage, 21129,
     /*  406040 */     GIR_EraseRootFromParent_Done,
     /*  406041 */   // Label 7226: @406041
     /*  406041 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(406118), // Rule ID 21132 //
     /*  406046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406078 */     // MIs[0] Operand 4
     /*  406078 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406116 */     GIR_RootConstrainSelectedInstOperands,
     /*  406117 */     // GIR_Coverage, 21132,
     /*  406117 */     GIR_EraseRootFromParent_Done,
     /*  406118 */   // Label 7227: @406118
     /*  406118 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(406195), // Rule ID 21133 //
     /*  406123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406155 */     // MIs[0] Operand 4
     /*  406155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406173 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  406176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406193 */     GIR_RootConstrainSelectedInstOperands,
     /*  406194 */     // GIR_Coverage, 21133,
     /*  406194 */     GIR_EraseRootFromParent_Done,
     /*  406195 */   // Label 7228: @406195
     /*  406195 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(406272), // Rule ID 21136 //
     /*  406200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406232 */     // MIs[0] Operand 4
     /*  406232 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406250 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406270 */     GIR_RootConstrainSelectedInstOperands,
     /*  406271 */     // GIR_Coverage, 21136,
     /*  406271 */     GIR_EraseRootFromParent_Done,
     /*  406272 */   // Label 7229: @406272
     /*  406272 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(406349), // Rule ID 21137 //
     /*  406277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  406288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  406291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  406294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406309 */     // MIs[0] Operand 4
     /*  406309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406327 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  406330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406347 */     GIR_RootConstrainSelectedInstOperands,
     /*  406348 */     // GIR_Coverage, 21137,
     /*  406348 */     GIR_EraseRootFromParent_Done,
     /*  406349 */   // Label 7230: @406349
     /*  406349 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(406426), // Rule ID 21140 //
     /*  406354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406386 */     // MIs[0] Operand 4
     /*  406386 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406404 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406424 */     GIR_RootConstrainSelectedInstOperands,
     /*  406425 */     // GIR_Coverage, 21140,
     /*  406425 */     GIR_EraseRootFromParent_Done,
     /*  406426 */   // Label 7231: @406426
     /*  406426 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(406503), // Rule ID 21141 //
     /*  406431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  406439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  406442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  406445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  406448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406463 */     // MIs[0] Operand 4
     /*  406463 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406481 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  406484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406501 */     GIR_RootConstrainSelectedInstOperands,
     /*  406502 */     // GIR_Coverage, 21141,
     /*  406502 */     GIR_EraseRootFromParent_Done,
     /*  406503 */   // Label 7232: @406503
     /*  406503 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(406580), // Rule ID 21144 //
     /*  406508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406540 */     // MIs[0] Operand 4
     /*  406540 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406558 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  406561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406578 */     GIR_RootConstrainSelectedInstOperands,
     /*  406579 */     // GIR_Coverage, 21144,
     /*  406579 */     GIR_EraseRootFromParent_Done,
     /*  406580 */   // Label 7233: @406580
     /*  406580 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(406657), // Rule ID 21145 //
     /*  406585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406617 */     // MIs[0] Operand 4
     /*  406617 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406635 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  406638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406655 */     GIR_RootConstrainSelectedInstOperands,
     /*  406656 */     // GIR_Coverage, 21145,
     /*  406656 */     GIR_EraseRootFromParent_Done,
     /*  406657 */   // Label 7234: @406657
     /*  406657 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(406734), // Rule ID 21148 //
     /*  406662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  406673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  406676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406694 */     // MIs[0] Operand 4
     /*  406694 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406712 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  406715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406732 */     GIR_RootConstrainSelectedInstOperands,
     /*  406733 */     // GIR_Coverage, 21148,
     /*  406733 */     GIR_EraseRootFromParent_Done,
     /*  406734 */   // Label 7235: @406734
     /*  406734 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(406811), // Rule ID 21149 //
     /*  406739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  406750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  406753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406771 */     // MIs[0] Operand 4
     /*  406771 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406789 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  406792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406809 */     GIR_RootConstrainSelectedInstOperands,
     /*  406810 */     // GIR_Coverage, 21149,
     /*  406810 */     GIR_EraseRootFromParent_Done,
     /*  406811 */   // Label 7236: @406811
     /*  406811 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(406888), // Rule ID 21152 //
     /*  406816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  406833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406848 */     // MIs[0] Operand 4
     /*  406848 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  406869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406886 */     GIR_RootConstrainSelectedInstOperands,
     /*  406887 */     // GIR_Coverage, 21152,
     /*  406887 */     GIR_EraseRootFromParent_Done,
     /*  406888 */   // Label 7237: @406888
     /*  406888 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(406965), // Rule ID 21153 //
     /*  406893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  406910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406925 */     // MIs[0] Operand 4
     /*  406925 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  406946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406963 */     GIR_RootConstrainSelectedInstOperands,
     /*  406964 */     // GIR_Coverage, 21153,
     /*  406964 */     GIR_EraseRootFromParent_Done,
     /*  406965 */   // Label 7238: @406965
     /*  406965 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(407042), // Rule ID 21156 //
     /*  406970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  406987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407002 */     // MIs[0] Operand 4
     /*  407002 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407020 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407040 */     GIR_RootConstrainSelectedInstOperands,
     /*  407041 */     // GIR_Coverage, 21156,
     /*  407041 */     GIR_EraseRootFromParent_Done,
     /*  407042 */   // Label 7239: @407042
     /*  407042 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(407119), // Rule ID 21157 //
     /*  407047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  407058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  407061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407079 */     // MIs[0] Operand 4
     /*  407079 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407097 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407117 */     GIR_RootConstrainSelectedInstOperands,
     /*  407118 */     // GIR_Coverage, 21157,
     /*  407118 */     GIR_EraseRootFromParent_Done,
     /*  407119 */   // Label 7240: @407119
     /*  407119 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(407196), // Rule ID 21160 //
     /*  407124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407156 */     // MIs[0] Operand 4
     /*  407156 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  407174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407194 */     GIR_RootConstrainSelectedInstOperands,
     /*  407195 */     // GIR_Coverage, 21160,
     /*  407195 */     GIR_EraseRootFromParent_Done,
     /*  407196 */   // Label 7241: @407196
     /*  407196 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(407273), // Rule ID 21161 //
     /*  407201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  407212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  407215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  407218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407233 */     // MIs[0] Operand 4
     /*  407233 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407251 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  407251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  407268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407271 */     GIR_RootConstrainSelectedInstOperands,
     /*  407272 */     // GIR_Coverage, 21161,
     /*  407272 */     GIR_EraseRootFromParent_Done,
     /*  407273 */   // Label 7242: @407273
     /*  407273 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(407350), // Rule ID 21164 //
     /*  407278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407310 */     // MIs[0] Operand 4
     /*  407310 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407348 */     GIR_RootConstrainSelectedInstOperands,
     /*  407349 */     // GIR_Coverage, 21164,
     /*  407349 */     GIR_EraseRootFromParent_Done,
     /*  407350 */   // Label 7243: @407350
     /*  407350 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(407427), // Rule ID 21165 //
     /*  407355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  407366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  407369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  407372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407387 */     // MIs[0] Operand 4
     /*  407387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407405 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  407408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407425 */     GIR_RootConstrainSelectedInstOperands,
     /*  407426 */     // GIR_Coverage, 21165,
     /*  407426 */     GIR_EraseRootFromParent_Done,
     /*  407427 */   // Label 7244: @407427
     /*  407427 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(407504), // Rule ID 21168 //
     /*  407432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  407443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  407446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407464 */     // MIs[0] Operand 4
     /*  407464 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407482 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407502 */     GIR_RootConstrainSelectedInstOperands,
     /*  407503 */     // GIR_Coverage, 21168,
     /*  407503 */     GIR_EraseRootFromParent_Done,
     /*  407504 */   // Label 7245: @407504
     /*  407504 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(407581), // Rule ID 21169 //
     /*  407509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  407520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  407523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407541 */     // MIs[0] Operand 4
     /*  407541 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407559 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407579 */     GIR_RootConstrainSelectedInstOperands,
     /*  407580 */     // GIR_Coverage, 21169,
     /*  407580 */     GIR_EraseRootFromParent_Done,
     /*  407581 */   // Label 7246: @407581
     /*  407581 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(407658), // Rule ID 21172 //
     /*  407586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  407597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  407600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407618 */     // MIs[0] Operand 4
     /*  407618 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407656 */     GIR_RootConstrainSelectedInstOperands,
     /*  407657 */     // GIR_Coverage, 21172,
     /*  407657 */     GIR_EraseRootFromParent_Done,
     /*  407658 */   // Label 7247: @407658
     /*  407658 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(407735), // Rule ID 21173 //
     /*  407663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  407674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  407677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407695 */     // MIs[0] Operand 4
     /*  407695 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407713 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407733 */     GIR_RootConstrainSelectedInstOperands,
     /*  407734 */     // GIR_Coverage, 21173,
     /*  407734 */     GIR_EraseRootFromParent_Done,
     /*  407735 */   // Label 7248: @407735
     /*  407735 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(407812), // Rule ID 21176 //
     /*  407740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  407751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  407754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  407757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407772 */     // MIs[0] Operand 4
     /*  407772 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407790 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407810 */     GIR_RootConstrainSelectedInstOperands,
     /*  407811 */     // GIR_Coverage, 21176,
     /*  407811 */     GIR_EraseRootFromParent_Done,
     /*  407812 */   // Label 7249: @407812
     /*  407812 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(407889), // Rule ID 21177 //
     /*  407817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  407828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  407831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  407834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407849 */     // MIs[0] Operand 4
     /*  407849 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407867 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407887 */     GIR_RootConstrainSelectedInstOperands,
     /*  407888 */     // GIR_Coverage, 21177,
     /*  407888 */     GIR_EraseRootFromParent_Done,
     /*  407889 */   // Label 7250: @407889
     /*  407889 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(407966), // Rule ID 21480 //
     /*  407894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  407905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  407908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  407911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407926 */     // MIs[0] Operand 4
     /*  407926 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407944 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  407944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  407947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407964 */     GIR_RootConstrainSelectedInstOperands,
     /*  407965 */     // GIR_Coverage, 21480,
     /*  407965 */     GIR_EraseRootFromParent_Done,
     /*  407966 */   // Label 7251: @407966
     /*  407966 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(408043), // Rule ID 21481 //
     /*  407971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  407982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  407985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  407988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408003 */     // MIs[0] Operand 4
     /*  408003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408021 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  408024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408041 */     GIR_RootConstrainSelectedInstOperands,
     /*  408042 */     // GIR_Coverage, 21481,
     /*  408042 */     GIR_EraseRootFromParent_Done,
     /*  408043 */   // Label 7252: @408043
     /*  408043 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(408120), // Rule ID 21484 //
     /*  408048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  408059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  408062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  408065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408080 */     // MIs[0] Operand 4
     /*  408080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408098 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408118 */     GIR_RootConstrainSelectedInstOperands,
     /*  408119 */     // GIR_Coverage, 21484,
     /*  408119 */     GIR_EraseRootFromParent_Done,
     /*  408120 */   // Label 7253: @408120
     /*  408120 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(408197), // Rule ID 21485 //
     /*  408125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  408136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  408139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  408142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408157 */     // MIs[0] Operand 4
     /*  408157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408175 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408195 */     GIR_RootConstrainSelectedInstOperands,
     /*  408196 */     // GIR_Coverage, 21485,
     /*  408196 */     GIR_EraseRootFromParent_Done,
     /*  408197 */   // Label 7254: @408197
     /*  408197 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(408274), // Rule ID 21488 //
     /*  408202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  408213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  408216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  408219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408234 */     // MIs[0] Operand 4
     /*  408234 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408252 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408272 */     GIR_RootConstrainSelectedInstOperands,
     /*  408273 */     // GIR_Coverage, 21488,
     /*  408273 */     GIR_EraseRootFromParent_Done,
     /*  408274 */   // Label 7255: @408274
     /*  408274 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(408351), // Rule ID 21489 //
     /*  408279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  408290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  408293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  408296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408311 */     // MIs[0] Operand 4
     /*  408311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408329 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408349 */     GIR_RootConstrainSelectedInstOperands,
     /*  408350 */     // GIR_Coverage, 21489,
     /*  408350 */     GIR_EraseRootFromParent_Done,
     /*  408351 */   // Label 7256: @408351
     /*  408351 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(408428), // Rule ID 21492 //
     /*  408356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  408367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  408370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  408373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408388 */     // MIs[0] Operand 4
     /*  408388 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408406 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408426 */     GIR_RootConstrainSelectedInstOperands,
     /*  408427 */     // GIR_Coverage, 21492,
     /*  408427 */     GIR_EraseRootFromParent_Done,
     /*  408428 */   // Label 7257: @408428
     /*  408428 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(408505), // Rule ID 21493 //
     /*  408433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  408444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  408447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  408450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408465 */     // MIs[0] Operand 4
     /*  408465 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408483 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408503 */     GIR_RootConstrainSelectedInstOperands,
     /*  408504 */     // GIR_Coverage, 21493,
     /*  408504 */     GIR_EraseRootFromParent_Done,
     /*  408505 */   // Label 7258: @408505
     /*  408505 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(408582), // Rule ID 21496 //
     /*  408510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  408521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  408524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  408527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408542 */     // MIs[0] Operand 4
     /*  408542 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  408563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408580 */     GIR_RootConstrainSelectedInstOperands,
     /*  408581 */     // GIR_Coverage, 21496,
     /*  408581 */     GIR_EraseRootFromParent_Done,
     /*  408582 */   // Label 7259: @408582
     /*  408582 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(408659), // Rule ID 21497 //
     /*  408587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  408598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  408601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  408604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408619 */     // MIs[0] Operand 4
     /*  408619 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408637 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  408640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408657 */     GIR_RootConstrainSelectedInstOperands,
     /*  408658 */     // GIR_Coverage, 21497,
     /*  408658 */     GIR_EraseRootFromParent_Done,
     /*  408659 */   // Label 7260: @408659
     /*  408659 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(408736), // Rule ID 21500 //
     /*  408664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  408675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  408678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  408681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408696 */     // MIs[0] Operand 4
     /*  408696 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408714 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  408717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408734 */     GIR_RootConstrainSelectedInstOperands,
     /*  408735 */     // GIR_Coverage, 21500,
     /*  408735 */     GIR_EraseRootFromParent_Done,
     /*  408736 */   // Label 7261: @408736
     /*  408736 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(408813), // Rule ID 21501 //
     /*  408741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  408752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  408755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  408758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408773 */     // MIs[0] Operand 4
     /*  408773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408791 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  408794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408811 */     GIR_RootConstrainSelectedInstOperands,
     /*  408812 */     // GIR_Coverage, 21501,
     /*  408812 */     GIR_EraseRootFromParent_Done,
     /*  408813 */   // Label 7262: @408813
     /*  408813 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(408890), // Rule ID 21504 //
     /*  408818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  408829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  408832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408850 */     // MIs[0] Operand 4
     /*  408850 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  408868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408888 */     GIR_RootConstrainSelectedInstOperands,
     /*  408889 */     // GIR_Coverage, 21504,
     /*  408889 */     GIR_EraseRootFromParent_Done,
     /*  408890 */   // Label 7263: @408890
     /*  408890 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(408967), // Rule ID 21505 //
     /*  408895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  408906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  408909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408927 */     // MIs[0] Operand 4
     /*  408927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408945 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  408945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408965 */     GIR_RootConstrainSelectedInstOperands,
     /*  408966 */     // GIR_Coverage, 21505,
     /*  408966 */     GIR_EraseRootFromParent_Done,
     /*  408967 */   // Label 7264: @408967
     /*  408967 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(409044), // Rule ID 21508 //
     /*  408972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  408983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  408986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  408989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409004 */     // MIs[0] Operand 4
     /*  409004 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409022 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409042 */     GIR_RootConstrainSelectedInstOperands,
     /*  409043 */     // GIR_Coverage, 21508,
     /*  409043 */     GIR_EraseRootFromParent_Done,
     /*  409044 */   // Label 7265: @409044
     /*  409044 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(409121), // Rule ID 21509 //
     /*  409049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  409060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  409063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  409066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409081 */     // MIs[0] Operand 4
     /*  409081 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409099 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409119 */     GIR_RootConstrainSelectedInstOperands,
     /*  409120 */     // GIR_Coverage, 21509,
     /*  409120 */     GIR_EraseRootFromParent_Done,
     /*  409121 */   // Label 7266: @409121
     /*  409121 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(409198), // Rule ID 21512 //
     /*  409126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  409137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  409140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409158 */     // MIs[0] Operand 4
     /*  409158 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409196 */     GIR_RootConstrainSelectedInstOperands,
     /*  409197 */     // GIR_Coverage, 21512,
     /*  409197 */     GIR_EraseRootFromParent_Done,
     /*  409198 */   // Label 7267: @409198
     /*  409198 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(409275), // Rule ID 21513 //
     /*  409203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  409214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  409217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  409220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409235 */     // MIs[0] Operand 4
     /*  409235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409253 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409273 */     GIR_RootConstrainSelectedInstOperands,
     /*  409274 */     // GIR_Coverage, 21513,
     /*  409274 */     GIR_EraseRootFromParent_Done,
     /*  409275 */   // Label 7268: @409275
     /*  409275 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(409352), // Rule ID 21516 //
     /*  409280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  409291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  409294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409312 */     // MIs[0] Operand 4
     /*  409312 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409330 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409350 */     GIR_RootConstrainSelectedInstOperands,
     /*  409351 */     // GIR_Coverage, 21516,
     /*  409351 */     GIR_EraseRootFromParent_Done,
     /*  409352 */   // Label 7269: @409352
     /*  409352 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(409429), // Rule ID 21517 //
     /*  409357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  409368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  409371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  409374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409389 */     // MIs[0] Operand 4
     /*  409389 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409407 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409427 */     GIR_RootConstrainSelectedInstOperands,
     /*  409428 */     // GIR_Coverage, 21517,
     /*  409428 */     GIR_EraseRootFromParent_Done,
     /*  409429 */   // Label 7270: @409429
     /*  409429 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(409506), // Rule ID 21520 //
     /*  409434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  409437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  409445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  409448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  409451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409466 */     // MIs[0] Operand 4
     /*  409466 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  409484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409504 */     GIR_RootConstrainSelectedInstOperands,
     /*  409505 */     // GIR_Coverage, 21520,
     /*  409505 */     GIR_EraseRootFromParent_Done,
     /*  409506 */   // Label 7271: @409506
     /*  409506 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(409583), // Rule ID 21521 //
     /*  409511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  409522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  409525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  409528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409543 */     // MIs[0] Operand 4
     /*  409543 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409561 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409581 */     GIR_RootConstrainSelectedInstOperands,
     /*  409582 */     // GIR_Coverage, 21521,
     /*  409582 */     GIR_EraseRootFromParent_Done,
     /*  409583 */   // Label 7272: @409583
     /*  409583 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(409660), // Rule ID 21524 //
     /*  409588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  409599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  409602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  409605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409620 */     // MIs[0] Operand 4
     /*  409620 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409638 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409658 */     GIR_RootConstrainSelectedInstOperands,
     /*  409659 */     // GIR_Coverage, 21524,
     /*  409659 */     GIR_EraseRootFromParent_Done,
     /*  409660 */   // Label 7273: @409660
     /*  409660 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(409737), // Rule ID 21525 //
     /*  409665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  409676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  409679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  409682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409697 */     // MIs[0] Operand 4
     /*  409697 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409715 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409735 */     GIR_RootConstrainSelectedInstOperands,
     /*  409736 */     // GIR_Coverage, 21525,
     /*  409736 */     GIR_EraseRootFromParent_Done,
     /*  409737 */   // Label 7274: @409737
     /*  409737 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(409814), // Rule ID 21528 //
     /*  409742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  409759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409774 */     // MIs[0] Operand 4
     /*  409774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409812 */     GIR_RootConstrainSelectedInstOperands,
     /*  409813 */     // GIR_Coverage, 21528,
     /*  409813 */     GIR_EraseRootFromParent_Done,
     /*  409814 */   // Label 7275: @409814
     /*  409814 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(409891), // Rule ID 21529 //
     /*  409819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  409836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409851 */     // MIs[0] Operand 4
     /*  409851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409869 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409889 */     GIR_RootConstrainSelectedInstOperands,
     /*  409890 */     // GIR_Coverage, 21529,
     /*  409890 */     GIR_EraseRootFromParent_Done,
     /*  409891 */   // Label 7276: @409891
     /*  409891 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(409968), // Rule ID 21532 //
     /*  409896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  409913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409928 */     // MIs[0] Operand 4
     /*  409928 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409966 */     GIR_RootConstrainSelectedInstOperands,
     /*  409967 */     // GIR_Coverage, 21532,
     /*  409967 */     GIR_EraseRootFromParent_Done,
     /*  409968 */   // Label 7277: @409968
     /*  409968 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(410045), // Rule ID 21533 //
     /*  409973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  409990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410005 */     // MIs[0] Operand 4
     /*  410005 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  410026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410043 */     GIR_RootConstrainSelectedInstOperands,
     /*  410044 */     // GIR_Coverage, 21533,
     /*  410044 */     GIR_EraseRootFromParent_Done,
     /*  410045 */   // Label 7278: @410045
     /*  410045 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(410122), // Rule ID 21536 //
     /*  410050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  410053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  410067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410082 */     // MIs[0] Operand 4
     /*  410082 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  410100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410120 */     GIR_RootConstrainSelectedInstOperands,
     /*  410121 */     // GIR_Coverage, 21536,
     /*  410121 */     GIR_EraseRootFromParent_Done,
     /*  410122 */   // Label 7279: @410122
     /*  410122 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(410199), // Rule ID 21537 //
     /*  410127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  410130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  410135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  410138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  410141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  410144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410159 */     // MIs[0] Operand 4
     /*  410159 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  410177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  410180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  410194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410197 */     GIR_RootConstrainSelectedInstOperands,
     /*  410198 */     // GIR_Coverage, 21537,
     /*  410198 */     GIR_EraseRootFromParent_Done,
     /*  410199 */   // Label 7280: @410199
     /*  410199 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(410276), // Rule ID 21540 //
     /*  410204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  410215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  410218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410236 */     // MIs[0] Operand 4
     /*  410236 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410254 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  410257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410274 */     GIR_RootConstrainSelectedInstOperands,
     /*  410275 */     // GIR_Coverage, 21540,
     /*  410275 */     GIR_EraseRootFromParent_Done,
     /*  410276 */   // Label 7281: @410276
     /*  410276 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(410353), // Rule ID 21541 //
     /*  410281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  410292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  410295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  410298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410313 */     // MIs[0] Operand 4
     /*  410313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410331 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  410334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410351 */     GIR_RootConstrainSelectedInstOperands,
     /*  410352 */     // GIR_Coverage, 21541,
     /*  410352 */     GIR_EraseRootFromParent_Done,
     /*  410353 */   // Label 7282: @410353
     /*  410353 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(410430), // Rule ID 21544 //
     /*  410358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  410369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  410372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410390 */     // MIs[0] Operand 4
     /*  410390 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410408 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410428 */     GIR_RootConstrainSelectedInstOperands,
     /*  410429 */     // GIR_Coverage, 21544,
     /*  410429 */     GIR_EraseRootFromParent_Done,
     /*  410430 */   // Label 7283: @410430
     /*  410430 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(410507), // Rule ID 21545 //
     /*  410435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  410446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  410449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  410452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410467 */     // MIs[0] Operand 4
     /*  410467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410485 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410505 */     GIR_RootConstrainSelectedInstOperands,
     /*  410506 */     // GIR_Coverage, 21545,
     /*  410506 */     GIR_EraseRootFromParent_Done,
     /*  410507 */   // Label 7284: @410507
     /*  410507 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(410584), // Rule ID 21548 //
     /*  410512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  410523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  410526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410544 */     // MIs[0] Operand 4
     /*  410544 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410562 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  410565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410582 */     GIR_RootConstrainSelectedInstOperands,
     /*  410583 */     // GIR_Coverage, 21548,
     /*  410583 */     GIR_EraseRootFromParent_Done,
     /*  410584 */   // Label 7285: @410584
     /*  410584 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(410661), // Rule ID 21549 //
     /*  410589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  410600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  410603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410621 */     // MIs[0] Operand 4
     /*  410621 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410639 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  410642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410659 */     GIR_RootConstrainSelectedInstOperands,
     /*  410660 */     // GIR_Coverage, 21549,
     /*  410660 */     GIR_EraseRootFromParent_Done,
     /*  410661 */   // Label 7286: @410661
     /*  410661 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(410738), // Rule ID 21552 //
     /*  410666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  410677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  410680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410698 */     // MIs[0] Operand 4
     /*  410698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410716 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  410719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410736 */     GIR_RootConstrainSelectedInstOperands,
     /*  410737 */     // GIR_Coverage, 21552,
     /*  410737 */     GIR_EraseRootFromParent_Done,
     /*  410738 */   // Label 7287: @410738
     /*  410738 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(410815), // Rule ID 21553 //
     /*  410743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  410754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  410757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410775 */     // MIs[0] Operand 4
     /*  410775 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410793 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  410796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410813 */     GIR_RootConstrainSelectedInstOperands,
     /*  410814 */     // GIR_Coverage, 21553,
     /*  410814 */     GIR_EraseRootFromParent_Done,
     /*  410815 */   // Label 7288: @410815
     /*  410815 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(410892), // Rule ID 21556 //
     /*  410820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  410831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  410834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  410837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410852 */     // MIs[0] Operand 4
     /*  410852 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410870 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  410873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410890 */     GIR_RootConstrainSelectedInstOperands,
     /*  410891 */     // GIR_Coverage, 21556,
     /*  410891 */     GIR_EraseRootFromParent_Done,
     /*  410892 */   // Label 7289: @410892
     /*  410892 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(410969), // Rule ID 21557 //
     /*  410897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  410908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  410911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  410914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410929 */     // MIs[0] Operand 4
     /*  410929 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410947 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  410950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410967 */     GIR_RootConstrainSelectedInstOperands,
     /*  410968 */     // GIR_Coverage, 21557,
     /*  410968 */     GIR_EraseRootFromParent_Done,
     /*  410969 */   // Label 7290: @410969
     /*  410969 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(411046), // Rule ID 21560 //
     /*  410974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  410985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  410988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  410991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411006 */     // MIs[0] Operand 4
     /*  411006 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411024 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  411024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411044 */     GIR_RootConstrainSelectedInstOperands,
     /*  411045 */     // GIR_Coverage, 21560,
     /*  411045 */     GIR_EraseRootFromParent_Done,
     /*  411046 */   // Label 7291: @411046
     /*  411046 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(411123), // Rule ID 21561 //
     /*  411051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  411054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  411062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  411065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  411068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411083 */     // MIs[0] Operand 4
     /*  411083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411101 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  411101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  411118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411121 */     GIR_RootConstrainSelectedInstOperands,
     /*  411122 */     // GIR_Coverage, 21561,
     /*  411122 */     GIR_EraseRootFromParent_Done,
     /*  411123 */   // Label 7292: @411123
     /*  411123 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(411200), // Rule ID 21564 //
     /*  411128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  411139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  411142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411160 */     // MIs[0] Operand 4
     /*  411160 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411178 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  411181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411198 */     GIR_RootConstrainSelectedInstOperands,
     /*  411199 */     // GIR_Coverage, 21564,
     /*  411199 */     GIR_EraseRootFromParent_Done,
     /*  411200 */   // Label 7293: @411200
     /*  411200 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(411277), // Rule ID 21565 //
     /*  411205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  411216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  411219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  411222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411237 */     // MIs[0] Operand 4
     /*  411237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411255 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  411258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411275 */     GIR_RootConstrainSelectedInstOperands,
     /*  411276 */     // GIR_Coverage, 21565,
     /*  411276 */     GIR_EraseRootFromParent_Done,
     /*  411277 */   // Label 7294: @411277
     /*  411277 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(411354), // Rule ID 21568 //
     /*  411282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  411293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  411296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411314 */     // MIs[0] Operand 4
     /*  411314 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411332 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411352 */     GIR_RootConstrainSelectedInstOperands,
     /*  411353 */     // GIR_Coverage, 21568,
     /*  411353 */     GIR_EraseRootFromParent_Done,
     /*  411354 */   // Label 7295: @411354
     /*  411354 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(411431), // Rule ID 21569 //
     /*  411359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  411370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  411373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  411376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411391 */     // MIs[0] Operand 4
     /*  411391 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411409 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411429 */     GIR_RootConstrainSelectedInstOperands,
     /*  411430 */     // GIR_Coverage, 21569,
     /*  411430 */     GIR_EraseRootFromParent_Done,
     /*  411431 */   // Label 7296: @411431
     /*  411431 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(411508), // Rule ID 21572 //
     /*  411436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  411447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  411450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411468 */     // MIs[0] Operand 4
     /*  411468 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411506 */     GIR_RootConstrainSelectedInstOperands,
     /*  411507 */     // GIR_Coverage, 21572,
     /*  411507 */     GIR_EraseRootFromParent_Done,
     /*  411508 */   // Label 7297: @411508
     /*  411508 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(411585), // Rule ID 21573 //
     /*  411513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  411524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  411527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411545 */     // MIs[0] Operand 4
     /*  411545 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411563 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411583 */     GIR_RootConstrainSelectedInstOperands,
     /*  411584 */     // GIR_Coverage, 21573,
     /*  411584 */     GIR_EraseRootFromParent_Done,
     /*  411585 */   // Label 7298: @411585
     /*  411585 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(411662), // Rule ID 21576 //
     /*  411590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  411601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  411604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411622 */     // MIs[0] Operand 4
     /*  411622 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411660 */     GIR_RootConstrainSelectedInstOperands,
     /*  411661 */     // GIR_Coverage, 21576,
     /*  411661 */     GIR_EraseRootFromParent_Done,
     /*  411662 */   // Label 7299: @411662
     /*  411662 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(411739), // Rule ID 21577 //
     /*  411667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  411678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  411681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411699 */     // MIs[0] Operand 4
     /*  411699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411737 */     GIR_RootConstrainSelectedInstOperands,
     /*  411738 */     // GIR_Coverage, 21577,
     /*  411738 */     GIR_EraseRootFromParent_Done,
     /*  411739 */   // Label 7300: @411739
     /*  411739 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(411816), // Rule ID 21580 //
     /*  411744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  411755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  411758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  411761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411776 */     // MIs[0] Operand 4
     /*  411776 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411794 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411814 */     GIR_RootConstrainSelectedInstOperands,
     /*  411815 */     // GIR_Coverage, 21580,
     /*  411815 */     GIR_EraseRootFromParent_Done,
     /*  411816 */   // Label 7301: @411816
     /*  411816 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(411893), // Rule ID 21581 //
     /*  411821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  411832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  411835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  411838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411853 */     // MIs[0] Operand 4
     /*  411853 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411871 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411891 */     GIR_RootConstrainSelectedInstOperands,
     /*  411892 */     // GIR_Coverage, 21581,
     /*  411892 */     GIR_EraseRootFromParent_Done,
     /*  411893 */   // Label 7302: @411893
     /*  411893 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(411970), // Rule ID 21584 //
     /*  411898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  411901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  411909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  411912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  411915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411930 */     // MIs[0] Operand 4
     /*  411930 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411948 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411968 */     GIR_RootConstrainSelectedInstOperands,
     /*  411969 */     // GIR_Coverage, 21584,
     /*  411969 */     GIR_EraseRootFromParent_Done,
     /*  411970 */   // Label 7303: @411970
     /*  411970 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(412047), // Rule ID 21585 //
     /*  411975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  411978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  411986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  411989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  411992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412007 */     // MIs[0] Operand 4
     /*  412007 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412025 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  412028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412045 */     GIR_RootConstrainSelectedInstOperands,
     /*  412046 */     // GIR_Coverage, 21585,
     /*  412046 */     GIR_EraseRootFromParent_Done,
     /*  412047 */   // Label 7304: @412047
     /*  412047 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(412124), // Rule ID 21588 //
     /*  412052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  412069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412084 */     // MIs[0] Operand 4
     /*  412084 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412122 */     GIR_RootConstrainSelectedInstOperands,
     /*  412123 */     // GIR_Coverage, 21588,
     /*  412123 */     GIR_EraseRootFromParent_Done,
     /*  412124 */   // Label 7305: @412124
     /*  412124 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(412201), // Rule ID 21589 //
     /*  412129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  412140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  412143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  412146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412161 */     // MIs[0] Operand 4
     /*  412161 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412179 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  412182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412199 */     GIR_RootConstrainSelectedInstOperands,
     /*  412200 */     // GIR_Coverage, 21589,
     /*  412200 */     GIR_EraseRootFromParent_Done,
     /*  412201 */   // Label 7306: @412201
     /*  412201 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(412278), // Rule ID 21592 //
     /*  412206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  412217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  412220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  412223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412238 */     // MIs[0] Operand 4
     /*  412238 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412276 */     GIR_RootConstrainSelectedInstOperands,
     /*  412277 */     // GIR_Coverage, 21592,
     /*  412277 */     GIR_EraseRootFromParent_Done,
     /*  412278 */   // Label 7307: @412278
     /*  412278 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(412355), // Rule ID 21593 //
     /*  412283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  412294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  412297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  412300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  412311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412315 */     // MIs[0] Operand 4
     /*  412315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  412336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412353 */     GIR_RootConstrainSelectedInstOperands,
     /*  412354 */     // GIR_Coverage, 21593,
     /*  412354 */     GIR_EraseRootFromParent_Done,
     /*  412355 */   // Label 7308: @412355
     /*  412355 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(412432), // Rule ID 21596 //
     /*  412360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  412363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  412377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412392 */     // MIs[0] Operand 4
     /*  412392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412410 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  412410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412430 */     GIR_RootConstrainSelectedInstOperands,
     /*  412431 */     // GIR_Coverage, 21596,
     /*  412431 */     GIR_EraseRootFromParent_Done,
     /*  412432 */   // Label 7309: @412432
     /*  412432 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(412509), // Rule ID 21597 //
     /*  412437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  412440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  412445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  412448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  412451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  412454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  412465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  412469 */     // MIs[0] Operand 4
     /*  412469 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  412480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412487 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  412487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  412490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  412494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  412496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  412504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  412507 */     GIR_RootConstrainSelectedInstOperands,
     /*  412508 */     // GIR_Coverage, 21597,
     /*  412508 */     GIR_EraseRootFromParent_Done,
     /*  412509 */   // Label 7310: @412509
     /*  412509 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(412582), // Rule ID 62825 //
     /*  412514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412538 */     // MIs[0] op1
     /*  412538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412561 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  412564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412566 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412568 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412570 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412580 */     GIR_RootConstrainSelectedInstOperands,
     /*  412581 */     // GIR_Coverage, 62825,
     /*  412581 */     GIR_EraseRootFromParent_Done,
     /*  412582 */   // Label 7311: @412582
     /*  412582 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(412655), // Rule ID 62826 //
     /*  412587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412611 */     // MIs[0] op1
     /*  412611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412614 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412634 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  412637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412639 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412641 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412643 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412653 */     GIR_RootConstrainSelectedInstOperands,
     /*  412654 */     // GIR_Coverage, 62826,
     /*  412654 */     GIR_EraseRootFromParent_Done,
     /*  412655 */   // Label 7312: @412655
     /*  412655 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(412728), // Rule ID 62849 //
     /*  412660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  412677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412684 */     // MIs[0] op1
     /*  412684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412707 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  412710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412712 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412714 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412716 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412726 */     GIR_RootConstrainSelectedInstOperands,
     /*  412727 */     // GIR_Coverage, 62849,
     /*  412727 */     GIR_EraseRootFromParent_Done,
     /*  412728 */   // Label 7313: @412728
     /*  412728 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(412801), // Rule ID 62850 //
     /*  412733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  412750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412757 */     // MIs[0] op1
     /*  412757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412780 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  412783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412785 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412787 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412789 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412799 */     GIR_RootConstrainSelectedInstOperands,
     /*  412800 */     // GIR_Coverage, 62850,
     /*  412800 */     GIR_EraseRootFromParent_Done,
     /*  412801 */   // Label 7314: @412801
     /*  412801 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(412874), // Rule ID 62875 //
     /*  412806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412830 */     // MIs[0] op1
     /*  412830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412833 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412853 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  412856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412858 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412860 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412862 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412872 */     GIR_RootConstrainSelectedInstOperands,
     /*  412873 */     // GIR_Coverage, 62875,
     /*  412873 */     GIR_EraseRootFromParent_Done,
     /*  412874 */   // Label 7315: @412874
     /*  412874 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(412947), // Rule ID 62876 //
     /*  412879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412903 */     // MIs[0] op1
     /*  412903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412926 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  412929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412931 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412933 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412935 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412945 */     GIR_RootConstrainSelectedInstOperands,
     /*  412946 */     // GIR_Coverage, 62876,
     /*  412946 */     GIR_EraseRootFromParent_Done,
     /*  412947 */   // Label 7316: @412947
     /*  412947 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(413020), // Rule ID 62887 //
     /*  412952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  412969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412976 */     // MIs[0] op1
     /*  412976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412999 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  413002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413004 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413006 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413008 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413018 */     GIR_RootConstrainSelectedInstOperands,
     /*  413019 */     // GIR_Coverage, 62887,
     /*  413019 */     GIR_EraseRootFromParent_Done,
     /*  413020 */   // Label 7317: @413020
     /*  413020 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(413093), // Rule ID 62888 //
     /*  413025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  413036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  413039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  413042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413049 */     // MIs[0] op1
     /*  413049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413072 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  413075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413077 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413079 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413081 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413091 */     GIR_RootConstrainSelectedInstOperands,
     /*  413092 */     // GIR_Coverage, 62888,
     /*  413092 */     GIR_EraseRootFromParent_Done,
     /*  413093 */   // Label 7318: @413093
     /*  413093 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(413166), // Rule ID 62919 //
     /*  413098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413122 */     // MIs[0] op1
     /*  413122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413145 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  413148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413150 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413152 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413154 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413164 */     GIR_RootConstrainSelectedInstOperands,
     /*  413165 */     // GIR_Coverage, 62919,
     /*  413165 */     GIR_EraseRootFromParent_Done,
     /*  413166 */   // Label 7319: @413166
     /*  413166 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(413239), // Rule ID 62920 //
     /*  413171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413195 */     // MIs[0] op1
     /*  413195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  413221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413223 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413225 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413227 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413237 */     GIR_RootConstrainSelectedInstOperands,
     /*  413238 */     // GIR_Coverage, 62920,
     /*  413238 */     GIR_EraseRootFromParent_Done,
     /*  413239 */   // Label 7320: @413239
     /*  413239 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(413312), // Rule ID 62931 //
     /*  413244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  413261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413268 */     // MIs[0] op1
     /*  413268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413291 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  413291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  413294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413296 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413298 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413300 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413310 */     GIR_RootConstrainSelectedInstOperands,
     /*  413311 */     // GIR_Coverage, 62931,
     /*  413311 */     GIR_EraseRootFromParent_Done,
     /*  413312 */   // Label 7321: @413312
     /*  413312 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(413385), // Rule ID 62932 //
     /*  413317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  413328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  413331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  413334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413341 */     // MIs[0] op1
     /*  413341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413364 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  413364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  413367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413369 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413371 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413373 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  413383 */     GIR_RootConstrainSelectedInstOperands,
     /*  413384 */     // GIR_Coverage, 62932,
     /*  413384 */     GIR_EraseRootFromParent_Done,
     /*  413385 */   // Label 7322: @413385
     /*  413385 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(413458), // Rule ID 62963 //
     /*  413390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413414 */     // MIs[0] op1
     /*  413414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413417 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413437 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  413440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413442 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413444 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413446 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413456 */     GIR_RootConstrainSelectedInstOperands,
     /*  413457 */     // GIR_Coverage, 62963,
     /*  413457 */     GIR_EraseRootFromParent_Done,
     /*  413458 */   // Label 7323: @413458
     /*  413458 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(413531), // Rule ID 62964 //
     /*  413463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413487 */     // MIs[0] op1
     /*  413487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413510 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  413513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413515 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413517 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413519 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413529 */     GIR_RootConstrainSelectedInstOperands,
     /*  413530 */     // GIR_Coverage, 62964,
     /*  413530 */     GIR_EraseRootFromParent_Done,
     /*  413531 */   // Label 7324: @413531
     /*  413531 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(413604), // Rule ID 62975 //
     /*  413536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  413553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413560 */     // MIs[0] op1
     /*  413560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413583 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  413586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413588 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413590 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413592 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413602 */     GIR_RootConstrainSelectedInstOperands,
     /*  413603 */     // GIR_Coverage, 62975,
     /*  413603 */     GIR_EraseRootFromParent_Done,
     /*  413604 */   // Label 7325: @413604
     /*  413604 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(413677), // Rule ID 62976 //
     /*  413609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  413626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413633 */     // MIs[0] op1
     /*  413633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413656 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  413659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413661 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413663 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413665 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413675 */     GIR_RootConstrainSelectedInstOperands,
     /*  413676 */     // GIR_Coverage, 62976,
     /*  413676 */     GIR_EraseRootFromParent_Done,
     /*  413677 */   // Label 7326: @413677
     /*  413677 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(413750), // Rule ID 62999 //
     /*  413682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  413690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  413699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413706 */     // MIs[0] op1
     /*  413706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413709 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  413714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  413722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413729 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  413732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413734 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413736 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413738 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413748 */     GIR_RootConstrainSelectedInstOperands,
     /*  413749 */     // GIR_Coverage, 62999,
     /*  413749 */     GIR_EraseRootFromParent_Done,
     /*  413750 */   // Label 7327: @413750
     /*  413750 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(413823), // Rule ID 63000 //
     /*  413755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  413763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  413772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413779 */     // MIs[0] op1
     /*  413779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413782 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  413787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  413795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  413805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413807 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413809 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413811 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413821 */     GIR_RootConstrainSelectedInstOperands,
     /*  413822 */     // GIR_Coverage, 63000,
     /*  413822 */     GIR_EraseRootFromParent_Done,
     /*  413823 */   // Label 7328: @413823
     /*  413823 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(413896), // Rule ID 63019 //
     /*  413828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413852 */     // MIs[0] op1
     /*  413852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413855 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413875 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  413878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413880 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413882 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413884 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413894 */     GIR_RootConstrainSelectedInstOperands,
     /*  413895 */     // GIR_Coverage, 63019,
     /*  413895 */     GIR_EraseRootFromParent_Done,
     /*  413896 */   // Label 7329: @413896
     /*  413896 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(413969), // Rule ID 63020 //
     /*  413901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413925 */     // MIs[0] op1
     /*  413925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413948 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  413951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413953 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413955 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413957 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413967 */     GIR_RootConstrainSelectedInstOperands,
     /*  413968 */     // GIR_Coverage, 63020,
     /*  413968 */     GIR_EraseRootFromParent_Done,
     /*  413969 */   // Label 7330: @413969
     /*  413969 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(414042), // Rule ID 63031 //
     /*  413974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  413991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413998 */     // MIs[0] op1
     /*  413998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414021 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  414024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414026 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414028 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414030 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414040 */     GIR_RootConstrainSelectedInstOperands,
     /*  414041 */     // GIR_Coverage, 63031,
     /*  414041 */     GIR_EraseRootFromParent_Done,
     /*  414042 */   // Label 7331: @414042
     /*  414042 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(414115), // Rule ID 63032 //
     /*  414047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  414064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414071 */     // MIs[0] op1
     /*  414071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414094 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  414097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414099 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414101 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414103 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414113 */     GIR_RootConstrainSelectedInstOperands,
     /*  414114 */     // GIR_Coverage, 63032,
     /*  414114 */     GIR_EraseRootFromParent_Done,
     /*  414115 */   // Label 7332: @414115
     /*  414115 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(414188), // Rule ID 63055 //
     /*  414120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414144 */     // MIs[0] op1
     /*  414144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414167 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  414170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414172 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414174 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414176 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414186 */     GIR_RootConstrainSelectedInstOperands,
     /*  414187 */     // GIR_Coverage, 63055,
     /*  414187 */     GIR_EraseRootFromParent_Done,
     /*  414188 */   // Label 7333: @414188
     /*  414188 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(414261), // Rule ID 63056 //
     /*  414193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  414204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  414207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414217 */     // MIs[0] op1
     /*  414217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  414243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414245 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414247 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414249 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414259 */     GIR_RootConstrainSelectedInstOperands,
     /*  414260 */     // GIR_Coverage, 63056,
     /*  414260 */     GIR_EraseRootFromParent_Done,
     /*  414261 */   // Label 7334: @414261
     /*  414261 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(414334), // Rule ID 63075 //
     /*  414266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414290 */     // MIs[0] op1
     /*  414290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414313 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  414316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414318 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414320 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414322 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414332 */     GIR_RootConstrainSelectedInstOperands,
     /*  414333 */     // GIR_Coverage, 63075,
     /*  414333 */     GIR_EraseRootFromParent_Done,
     /*  414334 */   // Label 7335: @414334
     /*  414334 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(414407), // Rule ID 63076 //
     /*  414339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414363 */     // MIs[0] op1
     /*  414363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  414389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414391 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414393 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414395 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414405 */     GIR_RootConstrainSelectedInstOperands,
     /*  414406 */     // GIR_Coverage, 63076,
     /*  414406 */     GIR_EraseRootFromParent_Done,
     /*  414407 */   // Label 7336: @414407
     /*  414407 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(414480), // Rule ID 63087 //
     /*  414412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  414429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414436 */     // MIs[0] op1
     /*  414436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414459 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  414462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414464 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414466 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414468 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414478 */     GIR_RootConstrainSelectedInstOperands,
     /*  414479 */     // GIR_Coverage, 63087,
     /*  414479 */     GIR_EraseRootFromParent_Done,
     /*  414480 */   // Label 7337: @414480
     /*  414480 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(414553), // Rule ID 63088 //
     /*  414485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  414502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414509 */     // MIs[0] op1
     /*  414509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414532 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  414535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414537 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414539 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414541 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414551 */     GIR_RootConstrainSelectedInstOperands,
     /*  414552 */     // GIR_Coverage, 63088,
     /*  414552 */     GIR_EraseRootFromParent_Done,
     /*  414553 */   // Label 7338: @414553
     /*  414553 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(414626), // Rule ID 63111 //
     /*  414558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414582 */     // MIs[0] op1
     /*  414582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  414598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414605 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  414608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414610 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414612 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414614 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414624 */     GIR_RootConstrainSelectedInstOperands,
     /*  414625 */     // GIR_Coverage, 63111,
     /*  414625 */     GIR_EraseRootFromParent_Done,
     /*  414626 */   // Label 7339: @414626
     /*  414626 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(414699), // Rule ID 63112 //
     /*  414631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414655 */     // MIs[0] op1
     /*  414655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  414671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  414681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414683 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414685 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414687 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414697 */     GIR_RootConstrainSelectedInstOperands,
     /*  414698 */     // GIR_Coverage, 63112,
     /*  414698 */     GIR_EraseRootFromParent_Done,
     /*  414699 */   // Label 7340: @414699
     /*  414699 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(414772), // Rule ID 63131 //
     /*  414704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414728 */     // MIs[0] op1
     /*  414728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414751 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  414751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  414754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414756 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414758 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414760 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414770 */     GIR_RootConstrainSelectedInstOperands,
     /*  414771 */     // GIR_Coverage, 63131,
     /*  414771 */     GIR_EraseRootFromParent_Done,
     /*  414772 */   // Label 7341: @414772
     /*  414772 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(414845), // Rule ID 63132 //
     /*  414777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414801 */     // MIs[0] op1
     /*  414801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  414824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  414827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414829 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414831 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414833 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414843 */     GIR_RootConstrainSelectedInstOperands,
     /*  414844 */     // GIR_Coverage, 63132,
     /*  414844 */     GIR_EraseRootFromParent_Done,
     /*  414845 */   // Label 7342: @414845
     /*  414845 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(414918), // Rule ID 63143 //
     /*  414850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  414867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414874 */     // MIs[0] op1
     /*  414874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414897 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  414897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  414900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414902 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414904 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414906 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414916 */     GIR_RootConstrainSelectedInstOperands,
     /*  414917 */     // GIR_Coverage, 63143,
     /*  414917 */     GIR_EraseRootFromParent_Done,
     /*  414918 */   // Label 7343: @414918
     /*  414918 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(414991), // Rule ID 63144 //
     /*  414923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  414940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414947 */     // MIs[0] op1
     /*  414947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  414970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  414973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414975 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414977 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414979 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414989 */     GIR_RootConstrainSelectedInstOperands,
     /*  414990 */     // GIR_Coverage, 63144,
     /*  414990 */     GIR_EraseRootFromParent_Done,
     /*  414991 */   // Label 7344: @414991
     /*  414991 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(415064), // Rule ID 63175 //
     /*  414996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415020 */     // MIs[0] op1
     /*  415020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415043 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  415046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415048 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415050 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415052 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415062 */     GIR_RootConstrainSelectedInstOperands,
     /*  415063 */     // GIR_Coverage, 63175,
     /*  415063 */     GIR_EraseRootFromParent_Done,
     /*  415064 */   // Label 7345: @415064
     /*  415064 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(415137), // Rule ID 63176 //
     /*  415069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415093 */     // MIs[0] op1
     /*  415093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415096 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  415119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415121 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415123 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415125 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415135 */     GIR_RootConstrainSelectedInstOperands,
     /*  415136 */     // GIR_Coverage, 63176,
     /*  415136 */     GIR_EraseRootFromParent_Done,
     /*  415137 */   // Label 7346: @415137
     /*  415137 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(415210), // Rule ID 63187 //
     /*  415142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  415159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415166 */     // MIs[0] op1
     /*  415166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415189 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  415192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415194 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415196 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415198 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415208 */     GIR_RootConstrainSelectedInstOperands,
     /*  415209 */     // GIR_Coverage, 63187,
     /*  415209 */     GIR_EraseRootFromParent_Done,
     /*  415210 */   // Label 7347: @415210
     /*  415210 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(415283), // Rule ID 63188 //
     /*  415215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  415232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415239 */     // MIs[0] op1
     /*  415239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  415265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415267 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415269 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415271 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415281 */     GIR_RootConstrainSelectedInstOperands,
     /*  415282 */     // GIR_Coverage, 63188,
     /*  415282 */     GIR_EraseRootFromParent_Done,
     /*  415283 */   // Label 7348: @415283
     /*  415283 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(415356), // Rule ID 63211 //
     /*  415288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  415305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415312 */     // MIs[0] op1
     /*  415312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  415328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415335 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  415335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  415338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415340 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415342 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415344 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415354 */     GIR_RootConstrainSelectedInstOperands,
     /*  415355 */     // GIR_Coverage, 63211,
     /*  415355 */     GIR_EraseRootFromParent_Done,
     /*  415356 */   // Label 7349: @415356
     /*  415356 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(415429), // Rule ID 63212 //
     /*  415361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  415372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  415375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  415378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415385 */     // MIs[0] op1
     /*  415385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  415401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  415408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  415411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415413 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415415 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415417 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  415427 */     GIR_RootConstrainSelectedInstOperands,
     /*  415428 */     // GIR_Coverage, 63212,
     /*  415428 */     GIR_EraseRootFromParent_Done,
     /*  415429 */   // Label 7350: @415429
     /*  415429 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(415502), // Rule ID 63231 //
     /*  415434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415458 */     // MIs[0] op1
     /*  415458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415481 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  415484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415486 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415488 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415490 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415500 */     GIR_RootConstrainSelectedInstOperands,
     /*  415501 */     // GIR_Coverage, 63231,
     /*  415501 */     GIR_EraseRootFromParent_Done,
     /*  415502 */   // Label 7351: @415502
     /*  415502 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(415575), // Rule ID 63232 //
     /*  415507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415531 */     // MIs[0] op1
     /*  415531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415554 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  415557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415559 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415561 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415563 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415573 */     GIR_RootConstrainSelectedInstOperands,
     /*  415574 */     // GIR_Coverage, 63232,
     /*  415574 */     GIR_EraseRootFromParent_Done,
     /*  415575 */   // Label 7352: @415575
     /*  415575 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(415648), // Rule ID 63243 //
     /*  415580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  415597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415604 */     // MIs[0] op1
     /*  415604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  415630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415632 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415634 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415636 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415646 */     GIR_RootConstrainSelectedInstOperands,
     /*  415647 */     // GIR_Coverage, 63243,
     /*  415647 */     GIR_EraseRootFromParent_Done,
     /*  415648 */   // Label 7353: @415648
     /*  415648 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(415721), // Rule ID 63244 //
     /*  415653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  415670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415677 */     // MIs[0] op1
     /*  415677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  415703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415705 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415707 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415709 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415719 */     GIR_RootConstrainSelectedInstOperands,
     /*  415720 */     // GIR_Coverage, 63244,
     /*  415720 */     GIR_EraseRootFromParent_Done,
     /*  415721 */   // Label 7354: @415721
     /*  415721 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(415794), // Rule ID 63267 //
     /*  415726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415750 */     // MIs[0] op1
     /*  415750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415773 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  415776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415778 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415780 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415782 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415792 */     GIR_RootConstrainSelectedInstOperands,
     /*  415793 */     // GIR_Coverage, 63267,
     /*  415793 */     GIR_EraseRootFromParent_Done,
     /*  415794 */   // Label 7355: @415794
     /*  415794 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(415867), // Rule ID 63268 //
     /*  415799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415823 */     // MIs[0] op1
     /*  415823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415846 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  415849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415851 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415853 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415855 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415865 */     GIR_RootConstrainSelectedInstOperands,
     /*  415866 */     // GIR_Coverage, 63268,
     /*  415866 */     GIR_EraseRootFromParent_Done,
     /*  415867 */   // Label 7356: @415867
     /*  415867 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(415940), // Rule ID 63287 //
     /*  415872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415896 */     // MIs[0] op1
     /*  415896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415899 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415919 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  415919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  415922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415924 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415926 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415928 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  415938 */     GIR_RootConstrainSelectedInstOperands,
     /*  415939 */     // GIR_Coverage, 63287,
     /*  415939 */     GIR_EraseRootFromParent_Done,
     /*  415940 */   // Label 7357: @415940
     /*  415940 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(416013), // Rule ID 63288 //
     /*  415945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415969 */     // MIs[0] op1
     /*  415969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  415992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  415995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415997 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415999 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416001 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416011 */     GIR_RootConstrainSelectedInstOperands,
     /*  416012 */     // GIR_Coverage, 63288,
     /*  416012 */     GIR_EraseRootFromParent_Done,
     /*  416013 */   // Label 7358: @416013
     /*  416013 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(416086), // Rule ID 63299 //
     /*  416018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  416035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416042 */     // MIs[0] op1
     /*  416042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416045 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416065 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  416068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416070 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416072 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416074 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416084 */     GIR_RootConstrainSelectedInstOperands,
     /*  416085 */     // GIR_Coverage, 63299,
     /*  416085 */     GIR_EraseRootFromParent_Done,
     /*  416086 */   // Label 7359: @416086
     /*  416086 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(416159), // Rule ID 63300 //
     /*  416091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  416108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416115 */     // MIs[0] op1
     /*  416115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  416141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416143 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416145 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416147 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416157 */     GIR_RootConstrainSelectedInstOperands,
     /*  416158 */     // GIR_Coverage, 63300,
     /*  416158 */     GIR_EraseRootFromParent_Done,
     /*  416159 */   // Label 7360: @416159
     /*  416159 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(416232), // Rule ID 63323 //
     /*  416164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416188 */     // MIs[0] op1
     /*  416188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  416204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416211 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  416211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  416214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416216 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416218 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416220 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416230 */     GIR_RootConstrainSelectedInstOperands,
     /*  416231 */     // GIR_Coverage, 63323,
     /*  416231 */     GIR_EraseRootFromParent_Done,
     /*  416232 */   // Label 7361: @416232
     /*  416232 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(416305), // Rule ID 63324 //
     /*  416237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  416248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  416251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416261 */     // MIs[0] op1
     /*  416261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416264 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  416269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  416273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  416277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  416284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  416287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416289 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416291 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416293 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  416303 */     GIR_RootConstrainSelectedInstOperands,
     /*  416304 */     // GIR_Coverage, 63324,
     /*  416304 */     GIR_EraseRootFromParent_Done,
     /*  416305 */   // Label 7362: @416305
     /*  416305 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(416378), // Rule ID 63343 //
     /*  416310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416334 */     // MIs[0] op1
     /*  416334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416357 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  416360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416362 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416364 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416366 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416376 */     GIR_RootConstrainSelectedInstOperands,
     /*  416377 */     // GIR_Coverage, 63343,
     /*  416377 */     GIR_EraseRootFromParent_Done,
     /*  416378 */   // Label 7363: @416378
     /*  416378 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(416451), // Rule ID 63344 //
     /*  416383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416407 */     // MIs[0] op1
     /*  416407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416430 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  416433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416435 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416437 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416439 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416449 */     GIR_RootConstrainSelectedInstOperands,
     /*  416450 */     // GIR_Coverage, 63344,
     /*  416450 */     GIR_EraseRootFromParent_Done,
     /*  416451 */   // Label 7364: @416451
     /*  416451 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(416524), // Rule ID 63355 //
     /*  416456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  416473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416480 */     // MIs[0] op1
     /*  416480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416503 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  416506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416508 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416510 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416512 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416522 */     GIR_RootConstrainSelectedInstOperands,
     /*  416523 */     // GIR_Coverage, 63355,
     /*  416523 */     GIR_EraseRootFromParent_Done,
     /*  416524 */   // Label 7365: @416524
     /*  416524 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(416597), // Rule ID 63356 //
     /*  416529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  416546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416553 */     // MIs[0] op1
     /*  416553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  416579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416581 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416583 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416585 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416595 */     GIR_RootConstrainSelectedInstOperands,
     /*  416596 */     // GIR_Coverage, 63356,
     /*  416596 */     GIR_EraseRootFromParent_Done,
     /*  416597 */   // Label 7366: @416597
     /*  416597 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(416670), // Rule ID 63387 //
     /*  416602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416626 */     // MIs[0] op1
     /*  416626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416649 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  416652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416654 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416656 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416658 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416668 */     GIR_RootConstrainSelectedInstOperands,
     /*  416669 */     // GIR_Coverage, 63387,
     /*  416669 */     GIR_EraseRootFromParent_Done,
     /*  416670 */   // Label 7367: @416670
     /*  416670 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(416743), // Rule ID 63388 //
     /*  416675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416699 */     // MIs[0] op1
     /*  416699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416722 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  416725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416727 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416729 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416731 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416741 */     GIR_RootConstrainSelectedInstOperands,
     /*  416742 */     // GIR_Coverage, 63388,
     /*  416742 */     GIR_EraseRootFromParent_Done,
     /*  416743 */   // Label 7368: @416743
     /*  416743 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(416816), // Rule ID 63399 //
     /*  416748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  416765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416772 */     // MIs[0] op1
     /*  416772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416795 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  416798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416800 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416802 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416804 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416814 */     GIR_RootConstrainSelectedInstOperands,
     /*  416815 */     // GIR_Coverage, 63399,
     /*  416815 */     GIR_EraseRootFromParent_Done,
     /*  416816 */   // Label 7369: @416816
     /*  416816 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(416889), // Rule ID 63400 //
     /*  416821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  416838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416845 */     // MIs[0] op1
     /*  416845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416868 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  416871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416873 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416875 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416877 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416887 */     GIR_RootConstrainSelectedInstOperands,
     /*  416888 */     // GIR_Coverage, 63400,
     /*  416888 */     GIR_EraseRootFromParent_Done,
     /*  416889 */   // Label 7370: @416889
     /*  416889 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(416962), // Rule ID 63431 //
     /*  416894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  416905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  416908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416918 */     // MIs[0] op1
     /*  416918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416941 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  416944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416946 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416948 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416950 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416960 */     GIR_RootConstrainSelectedInstOperands,
     /*  416961 */     // GIR_Coverage, 63431,
     /*  416961 */     GIR_EraseRootFromParent_Done,
     /*  416962 */   // Label 7371: @416962
     /*  416962 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(417035), // Rule ID 63432 //
     /*  416967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  416978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  416981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416991 */     // MIs[0] op1
     /*  416991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417014 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  417017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417019 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417021 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417023 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417033 */     GIR_RootConstrainSelectedInstOperands,
     /*  417034 */     // GIR_Coverage, 63432,
     /*  417034 */     GIR_EraseRootFromParent_Done,
     /*  417035 */   // Label 7372: @417035
     /*  417035 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(417108), // Rule ID 63443 //
     /*  417040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  417057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417064 */     // MIs[0] op1
     /*  417064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417087 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  417087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  417090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417092 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417094 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417096 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417106 */     GIR_RootConstrainSelectedInstOperands,
     /*  417107 */     // GIR_Coverage, 63443,
     /*  417107 */     GIR_EraseRootFromParent_Done,
     /*  417108 */   // Label 7373: @417108
     /*  417108 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(417181), // Rule ID 63444 //
     /*  417113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  417124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  417127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  417130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417137 */     // MIs[0] op1
     /*  417137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417160 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  417160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  417163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417165 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417167 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417169 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  417179 */     GIR_RootConstrainSelectedInstOperands,
     /*  417180 */     // GIR_Coverage, 63444,
     /*  417180 */     GIR_EraseRootFromParent_Done,
     /*  417181 */   // Label 7374: @417181
     /*  417181 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(417254), // Rule ID 63475 //
     /*  417186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417210 */     // MIs[0] op1
     /*  417210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417213 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  417236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417238 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417240 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417242 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417252 */     GIR_RootConstrainSelectedInstOperands,
     /*  417253 */     // GIR_Coverage, 63475,
     /*  417253 */     GIR_EraseRootFromParent_Done,
     /*  417254 */   // Label 7375: @417254
     /*  417254 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(417327), // Rule ID 63476 //
     /*  417259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417283 */     // MIs[0] op1
     /*  417283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  417309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417311 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417313 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417315 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417325 */     GIR_RootConstrainSelectedInstOperands,
     /*  417326 */     // GIR_Coverage, 63476,
     /*  417326 */     GIR_EraseRootFromParent_Done,
     /*  417327 */   // Label 7376: @417327
     /*  417327 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(417400), // Rule ID 63487 //
     /*  417332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  417349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417356 */     // MIs[0] op1
     /*  417356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417379 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  417382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417384 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417386 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417388 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417398 */     GIR_RootConstrainSelectedInstOperands,
     /*  417399 */     // GIR_Coverage, 63487,
     /*  417399 */     GIR_EraseRootFromParent_Done,
     /*  417400 */   // Label 7377: @417400
     /*  417400 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(417473), // Rule ID 63488 //
     /*  417405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  417422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417429 */     // MIs[0] op1
     /*  417429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417432 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  417455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417457 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417459 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417461 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417471 */     GIR_RootConstrainSelectedInstOperands,
     /*  417472 */     // GIR_Coverage, 63488,
     /*  417472 */     GIR_EraseRootFromParent_Done,
     /*  417473 */   // Label 7378: @417473
     /*  417473 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(417546), // Rule ID 63511 //
     /*  417478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417502 */     // MIs[0] op1
     /*  417502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  417528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417530 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417532 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417534 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417544 */     GIR_RootConstrainSelectedInstOperands,
     /*  417545 */     // GIR_Coverage, 63511,
     /*  417545 */     GIR_EraseRootFromParent_Done,
     /*  417546 */   // Label 7379: @417546
     /*  417546 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(417619), // Rule ID 63512 //
     /*  417551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417575 */     // MIs[0] op1
     /*  417575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  417601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417603 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417605 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417607 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417617 */     GIR_RootConstrainSelectedInstOperands,
     /*  417618 */     // GIR_Coverage, 63512,
     /*  417618 */     GIR_EraseRootFromParent_Done,
     /*  417619 */   // Label 7380: @417619
     /*  417619 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(417692), // Rule ID 63531 //
     /*  417624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417648 */     // MIs[0] op1
     /*  417648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417651 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417671 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  417674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417676 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417678 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417680 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417690 */     GIR_RootConstrainSelectedInstOperands,
     /*  417691 */     // GIR_Coverage, 63531,
     /*  417691 */     GIR_EraseRootFromParent_Done,
     /*  417692 */   // Label 7381: @417692
     /*  417692 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(417765), // Rule ID 63532 //
     /*  417697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417721 */     // MIs[0] op1
     /*  417721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417744 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  417747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417749 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417751 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417753 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417763 */     GIR_RootConstrainSelectedInstOperands,
     /*  417764 */     // GIR_Coverage, 63532,
     /*  417764 */     GIR_EraseRootFromParent_Done,
     /*  417765 */   // Label 7382: @417765
     /*  417765 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(417838), // Rule ID 63543 //
     /*  417770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  417787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417794 */     // MIs[0] op1
     /*  417794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417817 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  417820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417822 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417824 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417826 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417836 */     GIR_RootConstrainSelectedInstOperands,
     /*  417837 */     // GIR_Coverage, 63543,
     /*  417837 */     GIR_EraseRootFromParent_Done,
     /*  417838 */   // Label 7383: @417838
     /*  417838 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(417911), // Rule ID 63544 //
     /*  417843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  417860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417867 */     // MIs[0] op1
     /*  417867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  417893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417895 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417897 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417899 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417909 */     GIR_RootConstrainSelectedInstOperands,
     /*  417910 */     // GIR_Coverage, 63544,
     /*  417910 */     GIR_EraseRootFromParent_Done,
     /*  417911 */   // Label 7384: @417911
     /*  417911 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(417984), // Rule ID 63567 //
     /*  417916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417940 */     // MIs[0] op1
     /*  417940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417963 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  417966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417968 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417970 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417972 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417982 */     GIR_RootConstrainSelectedInstOperands,
     /*  417983 */     // GIR_Coverage, 63567,
     /*  417983 */     GIR_EraseRootFromParent_Done,
     /*  417984 */   // Label 7385: @417984
     /*  417984 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(418057), // Rule ID 63568 //
     /*  417989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  418000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  418003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418013 */     // MIs[0] op1
     /*  418013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418036 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  418039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418041 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418043 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418045 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418055 */     GIR_RootConstrainSelectedInstOperands,
     /*  418056 */     // GIR_Coverage, 63568,
     /*  418056 */     GIR_EraseRootFromParent_Done,
     /*  418057 */   // Label 7386: @418057
     /*  418057 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(418130), // Rule ID 63587 //
     /*  418062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418086 */     // MIs[0] op1
     /*  418086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418109 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  418112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418114 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418116 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418118 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418128 */     GIR_RootConstrainSelectedInstOperands,
     /*  418129 */     // GIR_Coverage, 63587,
     /*  418129 */     GIR_EraseRootFromParent_Done,
     /*  418130 */   // Label 7387: @418130
     /*  418130 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(418203), // Rule ID 63588 //
     /*  418135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418159 */     // MIs[0] op1
     /*  418159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  418185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418187 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418189 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418191 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418201 */     GIR_RootConstrainSelectedInstOperands,
     /*  418202 */     // GIR_Coverage, 63588,
     /*  418202 */     GIR_EraseRootFromParent_Done,
     /*  418203 */   // Label 7388: @418203
     /*  418203 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(418276), // Rule ID 63599 //
     /*  418208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  418225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418232 */     // MIs[0] op1
     /*  418232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418255 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  418258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418260 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418262 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418264 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418274 */     GIR_RootConstrainSelectedInstOperands,
     /*  418275 */     // GIR_Coverage, 63599,
     /*  418275 */     GIR_EraseRootFromParent_Done,
     /*  418276 */   // Label 7389: @418276
     /*  418276 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(418349), // Rule ID 63600 //
     /*  418281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  418298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418305 */     // MIs[0] op1
     /*  418305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418308 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418328 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  418331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418333 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418335 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418337 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418347 */     GIR_RootConstrainSelectedInstOperands,
     /*  418348 */     // GIR_Coverage, 63600,
     /*  418348 */     GIR_EraseRootFromParent_Done,
     /*  418349 */   // Label 7390: @418349
     /*  418349 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(418422), // Rule ID 63623 //
     /*  418354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418378 */     // MIs[0] op1
     /*  418378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418401 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  418401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  418404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418406 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418408 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418410 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418420 */     GIR_RootConstrainSelectedInstOperands,
     /*  418421 */     // GIR_Coverage, 63623,
     /*  418421 */     GIR_EraseRootFromParent_Done,
     /*  418422 */   // Label 7391: @418422
     /*  418422 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(418495), // Rule ID 63624 //
     /*  418427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  418438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  418441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  418444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418451 */     // MIs[0] op1
     /*  418451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  418467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418474 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  418474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  418477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418479 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418481 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418483 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  418493 */     GIR_RootConstrainSelectedInstOperands,
     /*  418494 */     // GIR_Coverage, 63624,
     /*  418494 */     GIR_EraseRootFromParent_Done,
     /*  418495 */   // Label 7392: @418495
     /*  418495 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(418568), // Rule ID 63643 //
     /*  418500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418524 */     // MIs[0] op1
     /*  418524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418527 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418547 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  418550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418552 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418554 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418556 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418566 */     GIR_RootConstrainSelectedInstOperands,
     /*  418567 */     // GIR_Coverage, 63643,
     /*  418567 */     GIR_EraseRootFromParent_Done,
     /*  418568 */   // Label 7393: @418568
     /*  418568 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(418641), // Rule ID 63644 //
     /*  418573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418597 */     // MIs[0] op1
     /*  418597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418600 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  418623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418625 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418627 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418629 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418639 */     GIR_RootConstrainSelectedInstOperands,
     /*  418640 */     // GIR_Coverage, 63644,
     /*  418640 */     GIR_EraseRootFromParent_Done,
     /*  418641 */   // Label 7394: @418641
     /*  418641 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(418714), // Rule ID 63655 //
     /*  418646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  418663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418670 */     // MIs[0] op1
     /*  418670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418673 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418693 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  418696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418698 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418700 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418702 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418712 */     GIR_RootConstrainSelectedInstOperands,
     /*  418713 */     // GIR_Coverage, 63655,
     /*  418713 */     GIR_EraseRootFromParent_Done,
     /*  418714 */   // Label 7395: @418714
     /*  418714 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(418787), // Rule ID 63656 //
     /*  418719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  418736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418743 */     // MIs[0] op1
     /*  418743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  418769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418771 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418773 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418775 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418785 */     GIR_RootConstrainSelectedInstOperands,
     /*  418786 */     // GIR_Coverage, 63656,
     /*  418786 */     GIR_EraseRootFromParent_Done,
     /*  418787 */   // Label 7396: @418787
     /*  418787 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(418860), // Rule ID 63679 //
     /*  418792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418816 */     // MIs[0] op1
     /*  418816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  418842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418844 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418846 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418848 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418858 */     GIR_RootConstrainSelectedInstOperands,
     /*  418859 */     // GIR_Coverage, 63679,
     /*  418859 */     GIR_EraseRootFromParent_Done,
     /*  418860 */   // Label 7397: @418860
     /*  418860 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(418933), // Rule ID 63680 //
     /*  418865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418889 */     // MIs[0] op1
     /*  418889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418912 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  418915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418917 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418919 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418921 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418931 */     GIR_RootConstrainSelectedInstOperands,
     /*  418932 */     // GIR_Coverage, 63680,
     /*  418932 */     GIR_EraseRootFromParent_Done,
     /*  418933 */   // Label 7398: @418933
     /*  418933 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(419006), // Rule ID 63699 //
     /*  418938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  418952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418962 */     // MIs[0] op1
     /*  418962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418985 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  418988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418990 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418992 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418994 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419004 */     GIR_RootConstrainSelectedInstOperands,
     /*  419005 */     // GIR_Coverage, 63699,
     /*  419005 */     GIR_EraseRootFromParent_Done,
     /*  419006 */   // Label 7399: @419006
     /*  419006 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(419079), // Rule ID 63700 //
     /*  419011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419035 */     // MIs[0] op1
     /*  419035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419058 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  419061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419063 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419065 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419067 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419077 */     GIR_RootConstrainSelectedInstOperands,
     /*  419078 */     // GIR_Coverage, 63700,
     /*  419078 */     GIR_EraseRootFromParent_Done,
     /*  419079 */   // Label 7400: @419079
     /*  419079 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(419152), // Rule ID 63711 //
     /*  419084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  419101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419108 */     // MIs[0] op1
     /*  419108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419111 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419131 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  419134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419136 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419138 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419140 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419150 */     GIR_RootConstrainSelectedInstOperands,
     /*  419151 */     // GIR_Coverage, 63711,
     /*  419151 */     GIR_EraseRootFromParent_Done,
     /*  419152 */   // Label 7401: @419152
     /*  419152 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(419225), // Rule ID 63712 //
     /*  419157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  419174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419181 */     // MIs[0] op1
     /*  419181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  419207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419209 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419211 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419213 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419223 */     GIR_RootConstrainSelectedInstOperands,
     /*  419224 */     // GIR_Coverage, 63712,
     /*  419224 */     GIR_EraseRootFromParent_Done,
     /*  419225 */   // Label 7402: @419225
     /*  419225 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(419298), // Rule ID 63735 //
     /*  419230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419254 */     // MIs[0] op1
     /*  419254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419277 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  419280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419282 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419284 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419286 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419296 */     GIR_RootConstrainSelectedInstOperands,
     /*  419297 */     // GIR_Coverage, 63735,
     /*  419297 */     GIR_EraseRootFromParent_Done,
     /*  419298 */   // Label 7403: @419298
     /*  419298 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(419371), // Rule ID 63736 //
     /*  419303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  419314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  419317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419327 */     // MIs[0] op1
     /*  419327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  419353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419355 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419357 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419359 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419369 */     GIR_RootConstrainSelectedInstOperands,
     /*  419370 */     // GIR_Coverage, 63736,
     /*  419370 */     GIR_EraseRootFromParent_Done,
     /*  419371 */   // Label 7404: @419371
     /*  419371 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(419444), // Rule ID 63755 //
     /*  419376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419400 */     // MIs[0] op1
     /*  419400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419423 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  419426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419428 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419430 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419432 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419442 */     GIR_RootConstrainSelectedInstOperands,
     /*  419443 */     // GIR_Coverage, 63755,
     /*  419443 */     GIR_EraseRootFromParent_Done,
     /*  419444 */   // Label 7405: @419444
     /*  419444 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(419517), // Rule ID 63756 //
     /*  419449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419473 */     // MIs[0] op1
     /*  419473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419476 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  419499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419501 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419503 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419505 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419515 */     GIR_RootConstrainSelectedInstOperands,
     /*  419516 */     // GIR_Coverage, 63756,
     /*  419516 */     GIR_EraseRootFromParent_Done,
     /*  419517 */   // Label 7406: @419517
     /*  419517 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(419590), // Rule ID 63767 //
     /*  419522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  419539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419546 */     // MIs[0] op1
     /*  419546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419569 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  419572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419574 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419576 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419578 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419588 */     GIR_RootConstrainSelectedInstOperands,
     /*  419589 */     // GIR_Coverage, 63767,
     /*  419589 */     GIR_EraseRootFromParent_Done,
     /*  419590 */   // Label 7407: @419590
     /*  419590 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(419663), // Rule ID 63768 //
     /*  419595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  419612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419619 */     // MIs[0] op1
     /*  419619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  419645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419647 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419649 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419651 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419661 */     GIR_RootConstrainSelectedInstOperands,
     /*  419662 */     // GIR_Coverage, 63768,
     /*  419662 */     GIR_EraseRootFromParent_Done,
     /*  419663 */   // Label 7408: @419663
     /*  419663 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(419736), // Rule ID 63791 //
     /*  419668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419692 */     // MIs[0] op1
     /*  419692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  419718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419720 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419722 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419724 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419734 */     GIR_RootConstrainSelectedInstOperands,
     /*  419735 */     // GIR_Coverage, 63791,
     /*  419735 */     GIR_EraseRootFromParent_Done,
     /*  419736 */   // Label 7409: @419736
     /*  419736 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(419809), // Rule ID 63792 //
     /*  419741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419765 */     // MIs[0] op1
     /*  419765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419788 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  419791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419793 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419795 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419797 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419807 */     GIR_RootConstrainSelectedInstOperands,
     /*  419808 */     // GIR_Coverage, 63792,
     /*  419808 */     GIR_EraseRootFromParent_Done,
     /*  419809 */   // Label 7410: @419809
     /*  419809 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(419882), // Rule ID 63811 //
     /*  419814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419838 */     // MIs[0] op1
     /*  419838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419861 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  419864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419866 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419868 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419870 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419880 */     GIR_RootConstrainSelectedInstOperands,
     /*  419881 */     // GIR_Coverage, 63811,
     /*  419881 */     GIR_EraseRootFromParent_Done,
     /*  419882 */   // Label 7411: @419882
     /*  419882 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(419955), // Rule ID 63812 //
     /*  419887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419911 */     // MIs[0] op1
     /*  419911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419914 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  419937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419939 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419941 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419943 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419953 */     GIR_RootConstrainSelectedInstOperands,
     /*  419954 */     // GIR_Coverage, 63812,
     /*  419954 */     GIR_EraseRootFromParent_Done,
     /*  419955 */   // Label 7412: @419955
     /*  419955 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(420028), // Rule ID 63823 //
     /*  419960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  419977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419984 */     // MIs[0] op1
     /*  419984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419987 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420007 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  420010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420012 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420014 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420016 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420026 */     GIR_RootConstrainSelectedInstOperands,
     /*  420027 */     // GIR_Coverage, 63823,
     /*  420027 */     GIR_EraseRootFromParent_Done,
     /*  420028 */   // Label 7413: @420028
     /*  420028 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(420101), // Rule ID 63824 //
     /*  420033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  420050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420057 */     // MIs[0] op1
     /*  420057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420060 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  420083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420085 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420087 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420089 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420099 */     GIR_RootConstrainSelectedInstOperands,
     /*  420100 */     // GIR_Coverage, 63824,
     /*  420100 */     GIR_EraseRootFromParent_Done,
     /*  420101 */   // Label 7414: @420101
     /*  420101 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(420174), // Rule ID 63847 //
     /*  420106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420130 */     // MIs[0] op1
     /*  420130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420153 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  420156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420158 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420160 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420162 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420172 */     GIR_RootConstrainSelectedInstOperands,
     /*  420173 */     // GIR_Coverage, 63847,
     /*  420173 */     GIR_EraseRootFromParent_Done,
     /*  420174 */   // Label 7415: @420174
     /*  420174 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(420247), // Rule ID 63848 //
     /*  420179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  420190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  420193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420203 */     // MIs[0] op1
     /*  420203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  420215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  420229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420231 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420233 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420235 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420245 */     GIR_RootConstrainSelectedInstOperands,
     /*  420246 */     // GIR_Coverage, 63848,
     /*  420246 */     GIR_EraseRootFromParent_Done,
     /*  420247 */   // Label 7416: @420247
     /*  420247 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(420320), // Rule ID 63867 //
     /*  420252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420276 */     // MIs[0] op1
     /*  420276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420299 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  420302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420304 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420306 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420308 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420318 */     GIR_RootConstrainSelectedInstOperands,
     /*  420319 */     // GIR_Coverage, 63867,
     /*  420319 */     GIR_EraseRootFromParent_Done,
     /*  420320 */   // Label 7417: @420320
     /*  420320 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(420393), // Rule ID 63868 //
     /*  420325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420349 */     // MIs[0] op1
     /*  420349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420372 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  420375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420377 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420379 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420381 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420391 */     GIR_RootConstrainSelectedInstOperands,
     /*  420392 */     // GIR_Coverage, 63868,
     /*  420392 */     GIR_EraseRootFromParent_Done,
     /*  420393 */   // Label 7418: @420393
     /*  420393 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(420466), // Rule ID 63879 //
     /*  420398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  420415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420422 */     // MIs[0] op1
     /*  420422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420425 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420445 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  420448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420450 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420452 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420454 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420464 */     GIR_RootConstrainSelectedInstOperands,
     /*  420465 */     // GIR_Coverage, 63879,
     /*  420465 */     GIR_EraseRootFromParent_Done,
     /*  420466 */   // Label 7419: @420466
     /*  420466 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(420539), // Rule ID 63880 //
     /*  420471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  420488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420495 */     // MIs[0] op1
     /*  420495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  420521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420523 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420525 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420527 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420537 */     GIR_RootConstrainSelectedInstOperands,
     /*  420538 */     // GIR_Coverage, 63880,
     /*  420538 */     GIR_EraseRootFromParent_Done,
     /*  420539 */   // Label 7420: @420539
     /*  420539 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(420612), // Rule ID 63903 //
     /*  420544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420568 */     // MIs[0] op1
     /*  420568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420591 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  420594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420596 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420598 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420600 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420610 */     GIR_RootConstrainSelectedInstOperands,
     /*  420611 */     // GIR_Coverage, 63903,
     /*  420611 */     GIR_EraseRootFromParent_Done,
     /*  420612 */   // Label 7421: @420612
     /*  420612 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(420685), // Rule ID 63904 //
     /*  420617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420641 */     // MIs[0] op1
     /*  420641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  420667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420669 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420671 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420673 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420683 */     GIR_RootConstrainSelectedInstOperands,
     /*  420684 */     // GIR_Coverage, 63904,
     /*  420684 */     GIR_EraseRootFromParent_Done,
     /*  420685 */   // Label 7422: @420685
     /*  420685 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(420758), // Rule ID 63923 //
     /*  420690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420714 */     // MIs[0] op1
     /*  420714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420717 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420737 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  420740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420742 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420744 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420746 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420756 */     GIR_RootConstrainSelectedInstOperands,
     /*  420757 */     // GIR_Coverage, 63923,
     /*  420757 */     GIR_EraseRootFromParent_Done,
     /*  420758 */   // Label 7423: @420758
     /*  420758 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(420831), // Rule ID 63924 //
     /*  420763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420787 */     // MIs[0] op1
     /*  420787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420790 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420810 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11083:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  420813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420815 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420817 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420819 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420829 */     GIR_RootConstrainSelectedInstOperands,
     /*  420830 */     // GIR_Coverage, 63924,
     /*  420830 */     GIR_EraseRootFromParent_Done,
     /*  420831 */   // Label 7424: @420831
     /*  420831 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(420904), // Rule ID 63935 //
     /*  420836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  420853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420860 */     // MIs[0] op1
     /*  420860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420883 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  420886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420888 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420890 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420892 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420902 */     GIR_RootConstrainSelectedInstOperands,
     /*  420903 */     // GIR_Coverage, 63935,
     /*  420903 */     GIR_EraseRootFromParent_Done,
     /*  420904 */   // Label 7425: @420904
     /*  420904 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(420977), // Rule ID 63936 //
     /*  420909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  420926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420933 */     // MIs[0] op1
     /*  420933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  420959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420961 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420963 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420965 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420975 */     GIR_RootConstrainSelectedInstOperands,
     /*  420976 */     // GIR_Coverage, 63936,
     /*  420976 */     GIR_EraseRootFromParent_Done,
     /*  420977 */   // Label 7426: @420977
     /*  420977 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(421050), // Rule ID 63959 //
     /*  420982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421006 */     // MIs[0] op1
     /*  421006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421029 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11061:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  421029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  421032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421034 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421036 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421038 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421048 */     GIR_RootConstrainSelectedInstOperands,
     /*  421049 */     // GIR_Coverage, 63959,
     /*  421049 */     GIR_EraseRootFromParent_Done,
     /*  421050 */   // Label 7427: @421050
     /*  421050 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(421123), // Rule ID 63960 //
     /*  421055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  421058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  421063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  421066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  421069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  421072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421079 */     // MIs[0] op1
     /*  421079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  421082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  421087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  421091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  421095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11061:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  421102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  421105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421107 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  421109 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  421111 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  421113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  421121 */     GIR_RootConstrainSelectedInstOperands,
     /*  421122 */     // GIR_Coverage, 63960,
     /*  421122 */     GIR_EraseRootFromParent_Done,
     /*  421123 */   // Label 7428: @421123
     /*  421123 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(421206), // Rule ID 5332 //
     /*  421128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  421142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421171 */     // MIs[1] Operand 1
     /*  421171 */     // No operand predicates
     /*  421171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421184 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  421187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421194 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421204 */     GIR_RootConstrainSelectedInstOperands,
     /*  421205 */     // GIR_Coverage, 5332,
     /*  421205 */     GIR_EraseRootFromParent_Done,
     /*  421206 */   // Label 7429: @421206
     /*  421206 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(421289), // Rule ID 5333 //
     /*  421211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  421225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421254 */     // MIs[1] Operand 1
     /*  421254 */     // No operand predicates
     /*  421254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421267 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  421270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421287 */     GIR_RootConstrainSelectedInstOperands,
     /*  421288 */     // GIR_Coverage, 5333,
     /*  421288 */     GIR_EraseRootFromParent_Done,
     /*  421289 */   // Label 7430: @421289
     /*  421289 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(421372), // Rule ID 5334 //
     /*  421294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  421308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421337 */     // MIs[1] Operand 1
     /*  421337 */     // No operand predicates
     /*  421337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421350 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421370 */     GIR_RootConstrainSelectedInstOperands,
     /*  421371 */     // GIR_Coverage, 5334,
     /*  421371 */     GIR_EraseRootFromParent_Done,
     /*  421372 */   // Label 7431: @421372
     /*  421372 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(421455), // Rule ID 5335 //
     /*  421377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  421391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421420 */     // MIs[1] Operand 1
     /*  421420 */     // No operand predicates
     /*  421420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421433 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421453 */     GIR_RootConstrainSelectedInstOperands,
     /*  421454 */     // GIR_Coverage, 5335,
     /*  421454 */     GIR_EraseRootFromParent_Done,
     /*  421455 */   // Label 7432: @421455
     /*  421455 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(421538), // Rule ID 5336 //
     /*  421460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  421471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  421474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  421480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421503 */     // MIs[1] Operand 1
     /*  421503 */     // No operand predicates
     /*  421503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421516 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421536 */     GIR_RootConstrainSelectedInstOperands,
     /*  421537 */     // GIR_Coverage, 5336,
     /*  421537 */     GIR_EraseRootFromParent_Done,
     /*  421538 */   // Label 7433: @421538
     /*  421538 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(421621), // Rule ID 5337 //
     /*  421543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  421554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  421557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  421563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421586 */     // MIs[1] Operand 1
     /*  421586 */     // No operand predicates
     /*  421586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421599 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421619 */     GIR_RootConstrainSelectedInstOperands,
     /*  421620 */     // GIR_Coverage, 5337,
     /*  421620 */     GIR_EraseRootFromParent_Done,
     /*  421621 */   // Label 7434: @421621
     /*  421621 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(421704), // Rule ID 5338 //
     /*  421626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  421640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421669 */     // MIs[1] Operand 1
     /*  421669 */     // No operand predicates
     /*  421669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421682 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421702 */     GIR_RootConstrainSelectedInstOperands,
     /*  421703 */     // GIR_Coverage, 5338,
     /*  421703 */     GIR_EraseRootFromParent_Done,
     /*  421704 */   // Label 7435: @421704
     /*  421704 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(421787), // Rule ID 5339 //
     /*  421709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  421723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421752 */     // MIs[1] Operand 1
     /*  421752 */     // No operand predicates
     /*  421752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421765 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421785 */     GIR_RootConstrainSelectedInstOperands,
     /*  421786 */     // GIR_Coverage, 5339,
     /*  421786 */     GIR_EraseRootFromParent_Done,
     /*  421787 */   // Label 7436: @421787
     /*  421787 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(421870), // Rule ID 5340 //
     /*  421792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  421806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421835 */     // MIs[1] Operand 1
     /*  421835 */     // No operand predicates
     /*  421835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421868 */     GIR_RootConstrainSelectedInstOperands,
     /*  421869 */     // GIR_Coverage, 5340,
     /*  421869 */     GIR_EraseRootFromParent_Done,
     /*  421870 */   // Label 7437: @421870
     /*  421870 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(421953), // Rule ID 5341 //
     /*  421875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  421889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421918 */     // MIs[1] Operand 1
     /*  421918 */     // No operand predicates
     /*  421918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421931 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421951 */     GIR_RootConstrainSelectedInstOperands,
     /*  421952 */     // GIR_Coverage, 5341,
     /*  421952 */     GIR_EraseRootFromParent_Done,
     /*  421953 */   // Label 7438: @421953
     /*  421953 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(422036), // Rule ID 5342 //
     /*  421958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  421972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422001 */     // MIs[1] Operand 1
     /*  422001 */     // No operand predicates
     /*  422001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422034 */     GIR_RootConstrainSelectedInstOperands,
     /*  422035 */     // GIR_Coverage, 5342,
     /*  422035 */     GIR_EraseRootFromParent_Done,
     /*  422036 */   // Label 7439: @422036
     /*  422036 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(422119), // Rule ID 5343 //
     /*  422041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  422055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422084 */     // MIs[1] Operand 1
     /*  422084 */     // No operand predicates
     /*  422084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422097 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  422100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422117 */     GIR_RootConstrainSelectedInstOperands,
     /*  422118 */     // GIR_Coverage, 5343,
     /*  422118 */     GIR_EraseRootFromParent_Done,
     /*  422119 */   // Label 7440: @422119
     /*  422119 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(422202), // Rule ID 5344 //
     /*  422124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  422138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422167 */     // MIs[1] Operand 1
     /*  422167 */     // No operand predicates
     /*  422167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422180 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  422180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422190 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422200 */     GIR_RootConstrainSelectedInstOperands,
     /*  422201 */     // GIR_Coverage, 5344,
     /*  422201 */     GIR_EraseRootFromParent_Done,
     /*  422202 */   // Label 7441: @422202
     /*  422202 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(422285), // Rule ID 5345 //
     /*  422207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  422221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422250 */     // MIs[1] Operand 1
     /*  422250 */     // No operand predicates
     /*  422250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422263 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422283 */     GIR_RootConstrainSelectedInstOperands,
     /*  422284 */     // GIR_Coverage, 5345,
     /*  422284 */     GIR_EraseRootFromParent_Done,
     /*  422285 */   // Label 7442: @422285
     /*  422285 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(422368), // Rule ID 5346 //
     /*  422290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422333 */     // MIs[1] Operand 1
     /*  422333 */     // No operand predicates
     /*  422333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422346 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422366 */     GIR_RootConstrainSelectedInstOperands,
     /*  422367 */     // GIR_Coverage, 5346,
     /*  422367 */     GIR_EraseRootFromParent_Done,
     /*  422368 */   // Label 7443: @422368
     /*  422368 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(422451), // Rule ID 5347 //
     /*  422373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  422384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  422387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  422393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422416 */     // MIs[1] Operand 1
     /*  422416 */     // No operand predicates
     /*  422416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422429 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422449 */     GIR_RootConstrainSelectedInstOperands,
     /*  422450 */     // GIR_Coverage, 5347,
     /*  422450 */     GIR_EraseRootFromParent_Done,
     /*  422451 */   // Label 7444: @422451
     /*  422451 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(422534), // Rule ID 5348 //
     /*  422456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  422470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422499 */     // MIs[1] Operand 1
     /*  422499 */     // No operand predicates
     /*  422499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422512 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422532 */     GIR_RootConstrainSelectedInstOperands,
     /*  422533 */     // GIR_Coverage, 5348,
     /*  422533 */     GIR_EraseRootFromParent_Done,
     /*  422534 */   // Label 7445: @422534
     /*  422534 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(422617), // Rule ID 5349 //
     /*  422539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  422553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422582 */     // MIs[1] Operand 1
     /*  422582 */     // No operand predicates
     /*  422582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422595 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422615 */     GIR_RootConstrainSelectedInstOperands,
     /*  422616 */     // GIR_Coverage, 5349,
     /*  422616 */     GIR_EraseRootFromParent_Done,
     /*  422617 */   // Label 7446: @422617
     /*  422617 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(422700), // Rule ID 5350 //
     /*  422622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  422625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  422636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422665 */     // MIs[1] Operand 1
     /*  422665 */     // No operand predicates
     /*  422665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422678 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  422678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  422698 */     GIR_RootConstrainSelectedInstOperands,
     /*  422699 */     // GIR_Coverage, 5350,
     /*  422699 */     GIR_EraseRootFromParent_Done,
     /*  422700 */   // Label 7447: @422700
     /*  422700 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(422783), // Rule ID 5351 //
     /*  422705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  422708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  422719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422748 */     // MIs[1] Operand 1
     /*  422748 */     // No operand predicates
     /*  422748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422761 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  422761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  422781 */     GIR_RootConstrainSelectedInstOperands,
     /*  422782 */     // GIR_Coverage, 5351,
     /*  422782 */     GIR_EraseRootFromParent_Done,
     /*  422783 */   // Label 7448: @422783
     /*  422783 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(422866), // Rule ID 5352 //
     /*  422788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  422799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  422802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  422808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422831 */     // MIs[1] Operand 1
     /*  422831 */     // No operand predicates
     /*  422831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422844 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  422844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  422847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422864 */     GIR_RootConstrainSelectedInstOperands,
     /*  422865 */     // GIR_Coverage, 5352,
     /*  422865 */     GIR_EraseRootFromParent_Done,
     /*  422866 */   // Label 7449: @422866
     /*  422866 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(422949), // Rule ID 5353 //
     /*  422871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  422882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  422885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  422891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422914 */     // MIs[1] Operand 1
     /*  422914 */     // No operand predicates
     /*  422914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422927 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  422930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422947 */     GIR_RootConstrainSelectedInstOperands,
     /*  422948 */     // GIR_Coverage, 5353,
     /*  422948 */     GIR_EraseRootFromParent_Done,
     /*  422949 */   // Label 7450: @422949
     /*  422949 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(423032), // Rule ID 5354 //
     /*  422954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  422965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  422968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  422974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422997 */     // MIs[1] Operand 1
     /*  422997 */     // No operand predicates
     /*  422997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423010 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423030 */     GIR_RootConstrainSelectedInstOperands,
     /*  423031 */     // GIR_Coverage, 5354,
     /*  423031 */     GIR_EraseRootFromParent_Done,
     /*  423032 */   // Label 7451: @423032
     /*  423032 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(423115), // Rule ID 5355 //
     /*  423037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  423051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423080 */     // MIs[1] Operand 1
     /*  423080 */     // No operand predicates
     /*  423080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423093 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423113 */     GIR_RootConstrainSelectedInstOperands,
     /*  423114 */     // GIR_Coverage, 5355,
     /*  423114 */     GIR_EraseRootFromParent_Done,
     /*  423115 */   // Label 7452: @423115
     /*  423115 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(423198), // Rule ID 5356 //
     /*  423120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  423131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  423134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  423140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423163 */     // MIs[1] Operand 1
     /*  423163 */     // No operand predicates
     /*  423163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423176 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  423176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423196 */     GIR_RootConstrainSelectedInstOperands,
     /*  423197 */     // GIR_Coverage, 5356,
     /*  423197 */     GIR_EraseRootFromParent_Done,
     /*  423198 */   // Label 7453: @423198
     /*  423198 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(423281), // Rule ID 5357 //
     /*  423203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  423214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  423217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  423223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423246 */     // MIs[1] Operand 1
     /*  423246 */     // No operand predicates
     /*  423246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423259 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  423259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  423279 */     GIR_RootConstrainSelectedInstOperands,
     /*  423280 */     // GIR_Coverage, 5357,
     /*  423280 */     GIR_EraseRootFromParent_Done,
     /*  423281 */   // Label 7454: @423281
     /*  423281 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(423364), // Rule ID 5358 //
     /*  423286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  423300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423329 */     // MIs[1] Operand 1
     /*  423329 */     // No operand predicates
     /*  423329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423362 */     GIR_RootConstrainSelectedInstOperands,
     /*  423363 */     // GIR_Coverage, 5358,
     /*  423363 */     GIR_EraseRootFromParent_Done,
     /*  423364 */   // Label 7455: @423364
     /*  423364 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(423447), // Rule ID 5359 //
     /*  423369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  423383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423412 */     // MIs[1] Operand 1
     /*  423412 */     // No operand predicates
     /*  423412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423425 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423445 */     GIR_RootConstrainSelectedInstOperands,
     /*  423446 */     // GIR_Coverage, 5359,
     /*  423446 */     GIR_EraseRootFromParent_Done,
     /*  423447 */   // Label 7456: @423447
     /*  423447 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(423530), // Rule ID 5360 //
     /*  423452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  423466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423495 */     // MIs[1] Operand 1
     /*  423495 */     // No operand predicates
     /*  423495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423508 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423528 */     GIR_RootConstrainSelectedInstOperands,
     /*  423529 */     // GIR_Coverage, 5360,
     /*  423529 */     GIR_EraseRootFromParent_Done,
     /*  423530 */   // Label 7457: @423530
     /*  423530 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(423613), // Rule ID 5361 //
     /*  423535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  423549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423578 */     // MIs[1] Operand 1
     /*  423578 */     // No operand predicates
     /*  423578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423591 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423611 */     GIR_RootConstrainSelectedInstOperands,
     /*  423612 */     // GIR_Coverage, 5361,
     /*  423612 */     GIR_EraseRootFromParent_Done,
     /*  423613 */   // Label 7458: @423613
     /*  423613 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(423696), // Rule ID 5362 //
     /*  423618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  423632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423661 */     // MIs[1] Operand 1
     /*  423661 */     // No operand predicates
     /*  423661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423674 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423694 */     GIR_RootConstrainSelectedInstOperands,
     /*  423695 */     // GIR_Coverage, 5362,
     /*  423695 */     GIR_EraseRootFromParent_Done,
     /*  423696 */   // Label 7459: @423696
     /*  423696 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(423779), // Rule ID 5363 //
     /*  423701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  423715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423744 */     // MIs[1] Operand 1
     /*  423744 */     // No operand predicates
     /*  423744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423757 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423777 */     GIR_RootConstrainSelectedInstOperands,
     /*  423778 */     // GIR_Coverage, 5363,
     /*  423778 */     GIR_EraseRootFromParent_Done,
     /*  423779 */   // Label 7460: @423779
     /*  423779 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(423862), // Rule ID 5364 //
     /*  423784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  423795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  423798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  423804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423827 */     // MIs[1] Operand 1
     /*  423827 */     // No operand predicates
     /*  423827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423860 */     GIR_RootConstrainSelectedInstOperands,
     /*  423861 */     // GIR_Coverage, 5364,
     /*  423861 */     GIR_EraseRootFromParent_Done,
     /*  423862 */   // Label 7461: @423862
     /*  423862 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(423945), // Rule ID 5365 //
     /*  423867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  423878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  423881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  423887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423910 */     // MIs[1] Operand 1
     /*  423910 */     // No operand predicates
     /*  423910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423923 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423943 */     GIR_RootConstrainSelectedInstOperands,
     /*  423944 */     // GIR_Coverage, 5365,
     /*  423944 */     GIR_EraseRootFromParent_Done,
     /*  423945 */   // Label 7462: @423945
     /*  423945 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(424028), // Rule ID 5366 //
     /*  423950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  423964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423993 */     // MIs[1] Operand 1
     /*  423993 */     // No operand predicates
     /*  423993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424006 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424026 */     GIR_RootConstrainSelectedInstOperands,
     /*  424027 */     // GIR_Coverage, 5366,
     /*  424027 */     GIR_EraseRootFromParent_Done,
     /*  424028 */   // Label 7463: @424028
     /*  424028 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(424111), // Rule ID 5367 //
     /*  424033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  424047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424076 */     // MIs[1] Operand 1
     /*  424076 */     // No operand predicates
     /*  424076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424089 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424109 */     GIR_RootConstrainSelectedInstOperands,
     /*  424110 */     // GIR_Coverage, 5367,
     /*  424110 */     GIR_EraseRootFromParent_Done,
     /*  424111 */   // Label 7464: @424111
     /*  424111 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(424194), // Rule ID 5368 //
     /*  424116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  424119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424159 */     // MIs[1] Operand 1
     /*  424159 */     // No operand predicates
     /*  424159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424172 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  424172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424192 */     GIR_RootConstrainSelectedInstOperands,
     /*  424193 */     // GIR_Coverage, 5368,
     /*  424193 */     GIR_EraseRootFromParent_Done,
     /*  424194 */   // Label 7465: @424194
     /*  424194 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(424277), // Rule ID 5369 //
     /*  424199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  424202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  424210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  424219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424242 */     // MIs[1] Operand 1
     /*  424242 */     // No operand predicates
     /*  424242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424255 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  424255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424275 */     GIR_RootConstrainSelectedInstOperands,
     /*  424276 */     // GIR_Coverage, 5369,
     /*  424276 */     GIR_EraseRootFromParent_Done,
     /*  424277 */   // Label 7466: @424277
     /*  424277 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(424360), // Rule ID 5370 //
     /*  424282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  424293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  424296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  424302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424325 */     // MIs[1] Operand 1
     /*  424325 */     // No operand predicates
     /*  424325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424338 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424348 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424358 */     GIR_RootConstrainSelectedInstOperands,
     /*  424359 */     // GIR_Coverage, 5370,
     /*  424359 */     GIR_EraseRootFromParent_Done,
     /*  424360 */   // Label 7467: @424360
     /*  424360 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(424443), // Rule ID 5371 //
     /*  424365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  424376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  424379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  424385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424408 */     // MIs[1] Operand 1
     /*  424408 */     // No operand predicates
     /*  424408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424421 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  424424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424441 */     GIR_RootConstrainSelectedInstOperands,
     /*  424442 */     // GIR_Coverage, 5371,
     /*  424442 */     GIR_EraseRootFromParent_Done,
     /*  424443 */   // Label 7468: @424443
     /*  424443 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(424526), // Rule ID 5372 //
     /*  424448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  424462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424491 */     // MIs[1] Operand 1
     /*  424491 */     // No operand predicates
     /*  424491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424524 */     GIR_RootConstrainSelectedInstOperands,
     /*  424525 */     // GIR_Coverage, 5372,
     /*  424525 */     GIR_EraseRootFromParent_Done,
     /*  424526 */   // Label 7469: @424526
     /*  424526 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(424609), // Rule ID 5373 //
     /*  424531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  424545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424574 */     // MIs[1] Operand 1
     /*  424574 */     // No operand predicates
     /*  424574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424587 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424607 */     GIR_RootConstrainSelectedInstOperands,
     /*  424608 */     // GIR_Coverage, 5373,
     /*  424608 */     GIR_EraseRootFromParent_Done,
     /*  424609 */   // Label 7470: @424609
     /*  424609 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(424692), // Rule ID 5374 //
     /*  424614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  424628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424657 */     // MIs[1] Operand 1
     /*  424657 */     // No operand predicates
     /*  424657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424670 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424690 */     GIR_RootConstrainSelectedInstOperands,
     /*  424691 */     // GIR_Coverage, 5374,
     /*  424691 */     GIR_EraseRootFromParent_Done,
     /*  424692 */   // Label 7471: @424692
     /*  424692 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(424775), // Rule ID 5375 //
     /*  424697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  424711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424740 */     // MIs[1] Operand 1
     /*  424740 */     // No operand predicates
     /*  424740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424753 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424773 */     GIR_RootConstrainSelectedInstOperands,
     /*  424774 */     // GIR_Coverage, 5375,
     /*  424774 */     GIR_EraseRootFromParent_Done,
     /*  424775 */   // Label 7472: @424775
     /*  424775 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(424851), // Rule ID 60608 //
     /*  424780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  424783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  424791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  424794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  424797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424812 */     // MIs[0] rs2
     /*  424812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424815 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  424830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424849 */     GIR_RootConstrainSelectedInstOperands,
     /*  424850 */     // GIR_Coverage, 60608,
     /*  424850 */     GIR_EraseRootFromParent_Done,
     /*  424851 */   // Label 7473: @424851
     /*  424851 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(424927), // Rule ID 60609 //
     /*  424856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  424859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  424867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  424870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  424873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424888 */     // MIs[0] rs2
     /*  424888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424903 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  424903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  424906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424925 */     GIR_RootConstrainSelectedInstOperands,
     /*  424926 */     // GIR_Coverage, 60609,
     /*  424926 */     GIR_EraseRootFromParent_Done,
     /*  424927 */   // Label 7474: @424927
     /*  424927 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(425003), // Rule ID 62254 //
     /*  424932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  424935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  424943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  424946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  424949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424964 */     // MIs[0] rs2
     /*  424964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424979 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  424982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425001 */     GIR_RootConstrainSelectedInstOperands,
     /*  425002 */     // GIR_Coverage, 62254,
     /*  425002 */     GIR_EraseRootFromParent_Done,
     /*  425003 */   // Label 7475: @425003
     /*  425003 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(425079), // Rule ID 62255 //
     /*  425008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425040 */     // MIs[0] rs2
     /*  425040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425055 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11153:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  425058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425077 */     GIR_RootConstrainSelectedInstOperands,
     /*  425078 */     // GIR_Coverage, 62255,
     /*  425078 */     GIR_EraseRootFromParent_Done,
     /*  425079 */   // Label 7476: @425079
     /*  425079 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(425155), // Rule ID 62256 //
     /*  425084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425116 */     // MIs[0] rs2
     /*  425116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  425134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425153 */     GIR_RootConstrainSelectedInstOperands,
     /*  425154 */     // GIR_Coverage, 62256,
     /*  425154 */     GIR_EraseRootFromParent_Done,
     /*  425155 */   // Label 7477: @425155
     /*  425155 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(425231), // Rule ID 62257 //
     /*  425160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425192 */     // MIs[0] rs2
     /*  425192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425195 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11153:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  425210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425229 */     GIR_RootConstrainSelectedInstOperands,
     /*  425230 */     // GIR_Coverage, 62257,
     /*  425230 */     GIR_EraseRootFromParent_Done,
     /*  425231 */   // Label 7478: @425231
     /*  425231 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(425307), // Rule ID 62258 //
     /*  425236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425268 */     // MIs[0] rs2
     /*  425268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425283 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  425286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425305 */     GIR_RootConstrainSelectedInstOperands,
     /*  425306 */     // GIR_Coverage, 62258,
     /*  425306 */     GIR_EraseRootFromParent_Done,
     /*  425307 */   // Label 7479: @425307
     /*  425307 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(425383), // Rule ID 62259 //
     /*  425312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425344 */     // MIs[0] rs2
     /*  425344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425359 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11153:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  425362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425381 */     GIR_RootConstrainSelectedInstOperands,
     /*  425382 */     // GIR_Coverage, 62259,
     /*  425382 */     GIR_EraseRootFromParent_Done,
     /*  425383 */   // Label 7480: @425383
     /*  425383 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(425459), // Rule ID 62260 //
     /*  425388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  425391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425420 */     // MIs[0] rs2
     /*  425420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425435 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  425438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425457 */     GIR_RootConstrainSelectedInstOperands,
     /*  425458 */     // GIR_Coverage, 62260,
     /*  425458 */     GIR_EraseRootFromParent_Done,
     /*  425459 */   // Label 7481: @425459
     /*  425459 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(425535), // Rule ID 62261 //
     /*  425464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  425467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  425472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425496 */     // MIs[0] rs2
     /*  425496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425511 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11153:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  425514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425533 */     GIR_RootConstrainSelectedInstOperands,
     /*  425534 */     // GIR_Coverage, 62261,
     /*  425534 */     GIR_EraseRootFromParent_Done,
     /*  425535 */   // Label 7482: @425535
     /*  425535 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(425611), // Rule ID 62382 //
     /*  425540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425572 */     // MIs[0] rs2
     /*  425572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425587 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  425590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425609 */     GIR_RootConstrainSelectedInstOperands,
     /*  425610 */     // GIR_Coverage, 62382,
     /*  425610 */     GIR_EraseRootFromParent_Done,
     /*  425611 */   // Label 7483: @425611
     /*  425611 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(425687), // Rule ID 62383 //
     /*  425616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425648 */     // MIs[0] rs2
     /*  425648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425651 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425663 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  425666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425685 */     GIR_RootConstrainSelectedInstOperands,
     /*  425686 */     // GIR_Coverage, 62383,
     /*  425686 */     GIR_EraseRootFromParent_Done,
     /*  425687 */   // Label 7484: @425687
     /*  425687 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(425763), // Rule ID 62384 //
     /*  425692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425724 */     // MIs[0] rs2
     /*  425724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425739 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  425742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425761 */     GIR_RootConstrainSelectedInstOperands,
     /*  425762 */     // GIR_Coverage, 62384,
     /*  425762 */     GIR_EraseRootFromParent_Done,
     /*  425763 */   // Label 7485: @425763
     /*  425763 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(425839), // Rule ID 62385 //
     /*  425768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425800 */     // MIs[0] rs2
     /*  425800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425815 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11558:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  425818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425837 */     GIR_RootConstrainSelectedInstOperands,
     /*  425838 */     // GIR_Coverage, 62385,
     /*  425838 */     GIR_EraseRootFromParent_Done,
     /*  425839 */   // Label 7486: @425839
     /*  425839 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(425915), // Rule ID 62386 //
     /*  425844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425876 */     // MIs[0] rs2
     /*  425876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425879 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425891 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  425894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425913 */     GIR_RootConstrainSelectedInstOperands,
     /*  425914 */     // GIR_Coverage, 62386,
     /*  425914 */     GIR_EraseRootFromParent_Done,
     /*  425915 */   // Label 7487: @425915
     /*  425915 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(425991), // Rule ID 62387 //
     /*  425920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425952 */     // MIs[0] rs2
     /*  425952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425955 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11558:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  425970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425989 */     GIR_RootConstrainSelectedInstOperands,
     /*  425990 */     // GIR_Coverage, 62387,
     /*  425990 */     GIR_EraseRootFromParent_Done,
     /*  425991 */   // Label 7488: @425991
     /*  425991 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(426067), // Rule ID 62388 //
     /*  425996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  426007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  426010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  426013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426028 */     // MIs[0] rs2
     /*  426028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426043 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  426046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426065 */     GIR_RootConstrainSelectedInstOperands,
     /*  426066 */     // GIR_Coverage, 62388,
     /*  426066 */     GIR_EraseRootFromParent_Done,
     /*  426067 */   // Label 7489: @426067
     /*  426067 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(426143), // Rule ID 62389 //
     /*  426072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  426083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  426086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  426089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  426104 */     // MIs[0] rs2
     /*  426104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426119 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11558:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  426122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426141 */     GIR_RootConstrainSelectedInstOperands,
     /*  426142 */     // GIR_Coverage, 62389,
     /*  426142 */     GIR_EraseRootFromParent_Done,
     /*  426143 */   // Label 7490: @426143
     /*  426143 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(426219), // Rule ID 62390 //
     /*  426148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  426151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  426159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  426162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  426165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426180 */     // MIs[0] rs2
     /*  426180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426183 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426195 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  426198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426217 */     GIR_RootConstrainSelectedInstOperands,
     /*  426218 */     // GIR_Coverage, 62390,
     /*  426218 */     GIR_EraseRootFromParent_Done,
     /*  426219 */   // Label 7491: @426219
     /*  426219 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(426295), // Rule ID 62391 //
     /*  426224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  426227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  426232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  426235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  426238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  426241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  426256 */     // MIs[0] rs2
     /*  426256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  426259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  426264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426271 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11558:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  426274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  426282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426293 */     GIR_RootConstrainSelectedInstOperands,
     /*  426294 */     // GIR_Coverage, 62391,
     /*  426294 */     GIR_EraseRootFromParent_Done,
     /*  426295 */   // Label 7492: @426295
     /*  426295 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(426383), // Rule ID 2794 //
     /*  426300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  426311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  426314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  426317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426347 */     // MIs[1] Operand 1
     /*  426347 */     // No operand predicates
     /*  426347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426356 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  426359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426365 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426381 */     GIR_RootConstrainSelectedInstOperands,
     /*  426382 */     // GIR_Coverage, 2794,
     /*  426382 */     GIR_EraseRootFromParent_Done,
     /*  426383 */   // Label 7493: @426383
     /*  426383 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(426471), // Rule ID 2795 //
     /*  426388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  426399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  426402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  426405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426435 */     // MIs[1] Operand 1
     /*  426435 */     // No operand predicates
     /*  426435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426444 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  426447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426453 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426469 */     GIR_RootConstrainSelectedInstOperands,
     /*  426470 */     // GIR_Coverage, 2795,
     /*  426470 */     GIR_EraseRootFromParent_Done,
     /*  426471 */   // Label 7494: @426471
     /*  426471 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(426559), // Rule ID 2802 //
     /*  426476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  426487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  426490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  426493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426523 */     // MIs[1] Operand 1
     /*  426523 */     // No operand predicates
     /*  426523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426532 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426541 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426557 */     GIR_RootConstrainSelectedInstOperands,
     /*  426558 */     // GIR_Coverage, 2802,
     /*  426558 */     GIR_EraseRootFromParent_Done,
     /*  426559 */   // Label 7495: @426559
     /*  426559 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(426647), // Rule ID 2803 //
     /*  426564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  426575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  426578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  426581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426611 */     // MIs[1] Operand 1
     /*  426611 */     // No operand predicates
     /*  426611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426620 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426629 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426645 */     GIR_RootConstrainSelectedInstOperands,
     /*  426646 */     // GIR_Coverage, 2803,
     /*  426646 */     GIR_EraseRootFromParent_Done,
     /*  426647 */   // Label 7496: @426647
     /*  426647 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(426735), // Rule ID 2810 //
     /*  426652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  426663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  426666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  426669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426699 */     // MIs[1] Operand 1
     /*  426699 */     // No operand predicates
     /*  426699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426708 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426717 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426733 */     GIR_RootConstrainSelectedInstOperands,
     /*  426734 */     // GIR_Coverage, 2810,
     /*  426734 */     GIR_EraseRootFromParent_Done,
     /*  426735 */   // Label 7497: @426735
     /*  426735 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(426823), // Rule ID 2811 //
     /*  426740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  426751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  426754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  426757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426787 */     // MIs[1] Operand 1
     /*  426787 */     // No operand predicates
     /*  426787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426805 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426821 */     GIR_RootConstrainSelectedInstOperands,
     /*  426822 */     // GIR_Coverage, 2811,
     /*  426822 */     GIR_EraseRootFromParent_Done,
     /*  426823 */   // Label 7498: @426823
     /*  426823 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(426911), // Rule ID 2818 //
     /*  426828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  426839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  426842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  426845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426875 */     // MIs[1] Operand 1
     /*  426875 */     // No operand predicates
     /*  426875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  426884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426893 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426909 */     GIR_RootConstrainSelectedInstOperands,
     /*  426910 */     // GIR_Coverage, 2818,
     /*  426910 */     GIR_EraseRootFromParent_Done,
     /*  426911 */   // Label 7499: @426911
     /*  426911 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(426999), // Rule ID 2819 //
     /*  426916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  426927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  426930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  426933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426963 */     // MIs[1] Operand 1
     /*  426963 */     // No operand predicates
     /*  426963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426972 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  426972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426981 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426997 */     GIR_RootConstrainSelectedInstOperands,
     /*  426998 */     // GIR_Coverage, 2819,
     /*  426998 */     GIR_EraseRootFromParent_Done,
     /*  426999 */   // Label 7500: @426999
     /*  426999 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(427087), // Rule ID 2826 //
     /*  427004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  427015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  427018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  427021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427051 */     // MIs[1] Operand 1
     /*  427051 */     // No operand predicates
     /*  427051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427060 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427069 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427085 */     GIR_RootConstrainSelectedInstOperands,
     /*  427086 */     // GIR_Coverage, 2826,
     /*  427086 */     GIR_EraseRootFromParent_Done,
     /*  427087 */   // Label 7501: @427087
     /*  427087 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(427175), // Rule ID 2827 //
     /*  427092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  427103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  427106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  427109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427139 */     // MIs[1] Operand 1
     /*  427139 */     // No operand predicates
     /*  427139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427157 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427173 */     GIR_RootConstrainSelectedInstOperands,
     /*  427174 */     // GIR_Coverage, 2827,
     /*  427174 */     GIR_EraseRootFromParent_Done,
     /*  427175 */   // Label 7502: @427175
     /*  427175 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(427263), // Rule ID 2834 //
     /*  427180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  427191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  427194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  427197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427227 */     // MIs[1] Operand 1
     /*  427227 */     // No operand predicates
     /*  427227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427236 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427245 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427261 */     GIR_RootConstrainSelectedInstOperands,
     /*  427262 */     // GIR_Coverage, 2834,
     /*  427262 */     GIR_EraseRootFromParent_Done,
     /*  427263 */   // Label 7503: @427263
     /*  427263 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(427351), // Rule ID 2835 //
     /*  427268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  427279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  427282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  427285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427315 */     // MIs[1] Operand 1
     /*  427315 */     // No operand predicates
     /*  427315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  427327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427333 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427349 */     GIR_RootConstrainSelectedInstOperands,
     /*  427350 */     // GIR_Coverage, 2835,
     /*  427350 */     GIR_EraseRootFromParent_Done,
     /*  427351 */   // Label 7504: @427351
     /*  427351 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(427439), // Rule ID 2842 //
     /*  427356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  427367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  427370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  427373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427403 */     // MIs[1] Operand 1
     /*  427403 */     // No operand predicates
     /*  427403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427421 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427437 */     GIR_RootConstrainSelectedInstOperands,
     /*  427438 */     // GIR_Coverage, 2842,
     /*  427438 */     GIR_EraseRootFromParent_Done,
     /*  427439 */   // Label 7505: @427439
     /*  427439 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(427527), // Rule ID 2843 //
     /*  427444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  427455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  427458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  427461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427491 */     // MIs[1] Operand 1
     /*  427491 */     // No operand predicates
     /*  427491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427500 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427509 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427525 */     GIR_RootConstrainSelectedInstOperands,
     /*  427526 */     // GIR_Coverage, 2843,
     /*  427526 */     GIR_EraseRootFromParent_Done,
     /*  427527 */   // Label 7506: @427527
     /*  427527 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(427615), // Rule ID 2850 //
     /*  427532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  427543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  427546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  427549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427579 */     // MIs[1] Operand 1
     /*  427579 */     // No operand predicates
     /*  427579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427588 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427597 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427613 */     GIR_RootConstrainSelectedInstOperands,
     /*  427614 */     // GIR_Coverage, 2850,
     /*  427614 */     GIR_EraseRootFromParent_Done,
     /*  427615 */   // Label 7507: @427615
     /*  427615 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(427703), // Rule ID 2851 //
     /*  427620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  427631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  427634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  427637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427667 */     // MIs[1] Operand 1
     /*  427667 */     // No operand predicates
     /*  427667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427676 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427685 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427701 */     GIR_RootConstrainSelectedInstOperands,
     /*  427702 */     // GIR_Coverage, 2851,
     /*  427702 */     GIR_EraseRootFromParent_Done,
     /*  427703 */   // Label 7508: @427703
     /*  427703 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(427791), // Rule ID 2858 //
     /*  427708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  427719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  427722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  427725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427755 */     // MIs[1] Operand 1
     /*  427755 */     // No operand predicates
     /*  427755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427773 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427789 */     GIR_RootConstrainSelectedInstOperands,
     /*  427790 */     // GIR_Coverage, 2858,
     /*  427790 */     GIR_EraseRootFromParent_Done,
     /*  427791 */   // Label 7509: @427791
     /*  427791 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(427879), // Rule ID 2859 //
     /*  427796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  427807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  427810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  427813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427843 */     // MIs[1] Operand 1
     /*  427843 */     // No operand predicates
     /*  427843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427861 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427877 */     GIR_RootConstrainSelectedInstOperands,
     /*  427878 */     // GIR_Coverage, 2859,
     /*  427878 */     GIR_EraseRootFromParent_Done,
     /*  427879 */   // Label 7510: @427879
     /*  427879 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(427967), // Rule ID 2866 //
     /*  427884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  427887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  427895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  427898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  427901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427931 */     // MIs[1] Operand 1
     /*  427931 */     // No operand predicates
     /*  427931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  427940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427949 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  427962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427965 */     GIR_RootConstrainSelectedInstOperands,
     /*  427966 */     // GIR_Coverage, 2866,
     /*  427966 */     GIR_EraseRootFromParent_Done,
     /*  427967 */   // Label 7511: @427967
     /*  427967 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(428055), // Rule ID 2867 //
     /*  427972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  427975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  427983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  427986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  427989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  428007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428019 */     // MIs[1] Operand 1
     /*  428019 */     // No operand predicates
     /*  428019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  428028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  428031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428037 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  428050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428053 */     GIR_RootConstrainSelectedInstOperands,
     /*  428054 */     // GIR_Coverage, 2867,
     /*  428054 */     GIR_EraseRootFromParent_Done,
     /*  428055 */   // Label 7512: @428055
     /*  428055 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(428143), // Rule ID 2874 //
     /*  428060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  428071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  428074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  428077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428107 */     // MIs[1] Operand 1
     /*  428107 */     // No operand predicates
     /*  428107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428116 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428125 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428141 */     GIR_RootConstrainSelectedInstOperands,
     /*  428142 */     // GIR_Coverage, 2874,
     /*  428142 */     GIR_EraseRootFromParent_Done,
     /*  428143 */   // Label 7513: @428143
     /*  428143 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(428231), // Rule ID 2875 //
     /*  428148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  428159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  428162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  428165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428195 */     // MIs[1] Operand 1
     /*  428195 */     // No operand predicates
     /*  428195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428213 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428229 */     GIR_RootConstrainSelectedInstOperands,
     /*  428230 */     // GIR_Coverage, 2875,
     /*  428230 */     GIR_EraseRootFromParent_Done,
     /*  428231 */   // Label 7514: @428231
     /*  428231 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(428319), // Rule ID 2882 //
     /*  428236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  428247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  428250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  428253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428283 */     // MIs[1] Operand 1
     /*  428283 */     // No operand predicates
     /*  428283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428292 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428301 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428317 */     GIR_RootConstrainSelectedInstOperands,
     /*  428318 */     // GIR_Coverage, 2882,
     /*  428318 */     GIR_EraseRootFromParent_Done,
     /*  428319 */   // Label 7515: @428319
     /*  428319 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(428407), // Rule ID 2883 //
     /*  428324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  428335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  428338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  428341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428371 */     // MIs[1] Operand 1
     /*  428371 */     // No operand predicates
     /*  428371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428380 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428389 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428405 */     GIR_RootConstrainSelectedInstOperands,
     /*  428406 */     // GIR_Coverage, 2883,
     /*  428406 */     GIR_EraseRootFromParent_Done,
     /*  428407 */   // Label 7516: @428407
     /*  428407 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(428495), // Rule ID 2890 //
     /*  428412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  428423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  428426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  428429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428459 */     // MIs[1] Operand 1
     /*  428459 */     // No operand predicates
     /*  428459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428468 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  428468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428477 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428493 */     GIR_RootConstrainSelectedInstOperands,
     /*  428494 */     // GIR_Coverage, 2890,
     /*  428494 */     GIR_EraseRootFromParent_Done,
     /*  428495 */   // Label 7517: @428495
     /*  428495 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(428583), // Rule ID 2891 //
     /*  428500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  428511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  428514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  428517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428547 */     // MIs[1] Operand 1
     /*  428547 */     // No operand predicates
     /*  428547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428565 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428581 */     GIR_RootConstrainSelectedInstOperands,
     /*  428582 */     // GIR_Coverage, 2891,
     /*  428582 */     GIR_EraseRootFromParent_Done,
     /*  428583 */   // Label 7518: @428583
     /*  428583 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(428671), // Rule ID 2898 //
     /*  428588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  428599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  428602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  428605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428635 */     // MIs[1] Operand 1
     /*  428635 */     // No operand predicates
     /*  428635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428653 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428669 */     GIR_RootConstrainSelectedInstOperands,
     /*  428670 */     // GIR_Coverage, 2898,
     /*  428670 */     GIR_EraseRootFromParent_Done,
     /*  428671 */   // Label 7519: @428671
     /*  428671 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(428759), // Rule ID 2899 //
     /*  428676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  428687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  428690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  428693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428723 */     // MIs[1] Operand 1
     /*  428723 */     // No operand predicates
     /*  428723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428741 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428757 */     GIR_RootConstrainSelectedInstOperands,
     /*  428758 */     // GIR_Coverage, 2899,
     /*  428758 */     GIR_EraseRootFromParent_Done,
     /*  428759 */   // Label 7520: @428759
     /*  428759 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(428847), // Rule ID 2906 //
     /*  428764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  428775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  428778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  428781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428811 */     // MIs[1] Operand 1
     /*  428811 */     // No operand predicates
     /*  428811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428820 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428829 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428845 */     GIR_RootConstrainSelectedInstOperands,
     /*  428846 */     // GIR_Coverage, 2906,
     /*  428846 */     GIR_EraseRootFromParent_Done,
     /*  428847 */   // Label 7521: @428847
     /*  428847 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(428935), // Rule ID 2907 //
     /*  428852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  428863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  428866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  428869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428899 */     // MIs[1] Operand 1
     /*  428899 */     // No operand predicates
     /*  428899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428908 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428917 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428933 */     GIR_RootConstrainSelectedInstOperands,
     /*  428934 */     // GIR_Coverage, 2907,
     /*  428934 */     GIR_EraseRootFromParent_Done,
     /*  428935 */   // Label 7522: @428935
     /*  428935 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(429023), // Rule ID 2914 //
     /*  428940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  428951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  428954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  428957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428987 */     // MIs[1] Operand 1
     /*  428987 */     // No operand predicates
     /*  428987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429005 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429021 */     GIR_RootConstrainSelectedInstOperands,
     /*  429022 */     // GIR_Coverage, 2914,
     /*  429022 */     GIR_EraseRootFromParent_Done,
     /*  429023 */   // Label 7523: @429023
     /*  429023 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(429111), // Rule ID 2915 //
     /*  429028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  429039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  429042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  429045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429075 */     // MIs[1] Operand 1
     /*  429075 */     // No operand predicates
     /*  429075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  429084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429093 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  429106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429109 */     GIR_RootConstrainSelectedInstOperands,
     /*  429110 */     // GIR_Coverage, 2915,
     /*  429110 */     GIR_EraseRootFromParent_Done,
     /*  429111 */   // Label 7524: @429111
     /*  429111 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(429199), // Rule ID 2922 //
     /*  429116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429163 */     // MIs[1] Operand 1
     /*  429163 */     // No operand predicates
     /*  429163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429181 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429197 */     GIR_RootConstrainSelectedInstOperands,
     /*  429198 */     // GIR_Coverage, 2922,
     /*  429198 */     GIR_EraseRootFromParent_Done,
     /*  429199 */   // Label 7525: @429199
     /*  429199 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(429287), // Rule ID 2923 //
     /*  429204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  429215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  429218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  429221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429251 */     // MIs[1] Operand 1
     /*  429251 */     // No operand predicates
     /*  429251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429269 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429285 */     GIR_RootConstrainSelectedInstOperands,
     /*  429286 */     // GIR_Coverage, 2923,
     /*  429286 */     GIR_EraseRootFromParent_Done,
     /*  429287 */   // Label 7526: @429287
     /*  429287 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(429375), // Rule ID 2930 //
     /*  429292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429339 */     // MIs[1] Operand 1
     /*  429339 */     // No operand predicates
     /*  429339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429357 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429373 */     GIR_RootConstrainSelectedInstOperands,
     /*  429374 */     // GIR_Coverage, 2930,
     /*  429374 */     GIR_EraseRootFromParent_Done,
     /*  429375 */   // Label 7527: @429375
     /*  429375 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(429463), // Rule ID 2931 //
     /*  429380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  429391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  429394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  429397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429427 */     // MIs[1] Operand 1
     /*  429427 */     // No operand predicates
     /*  429427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429445 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429461 */     GIR_RootConstrainSelectedInstOperands,
     /*  429462 */     // GIR_Coverage, 2931,
     /*  429462 */     GIR_EraseRootFromParent_Done,
     /*  429463 */   // Label 7528: @429463
     /*  429463 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(429551), // Rule ID 2938 //
     /*  429468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429515 */     // MIs[1] Operand 1
     /*  429515 */     // No operand predicates
     /*  429515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429533 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429549 */     GIR_RootConstrainSelectedInstOperands,
     /*  429550 */     // GIR_Coverage, 2938,
     /*  429550 */     GIR_EraseRootFromParent_Done,
     /*  429551 */   // Label 7529: @429551
     /*  429551 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(429639), // Rule ID 2939 //
     /*  429556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429603 */     // MIs[1] Operand 1
     /*  429603 */     // No operand predicates
     /*  429603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429612 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429621 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429637 */     GIR_RootConstrainSelectedInstOperands,
     /*  429638 */     // GIR_Coverage, 2939,
     /*  429638 */     GIR_EraseRootFromParent_Done,
     /*  429639 */   // Label 7530: @429639
     /*  429639 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(429727), // Rule ID 2946 //
     /*  429644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  429647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  429655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  429658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  429661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429691 */     // MIs[1] Operand 1
     /*  429691 */     // No operand predicates
     /*  429691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429700 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  429700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429709 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429725 */     GIR_RootConstrainSelectedInstOperands,
     /*  429726 */     // GIR_Coverage, 2946,
     /*  429726 */     GIR_EraseRootFromParent_Done,
     /*  429727 */   // Label 7531: @429727
     /*  429727 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(429815), // Rule ID 2947 //
     /*  429732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  429735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  429743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  429746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  429749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429779 */     // MIs[1] Operand 1
     /*  429779 */     // No operand predicates
     /*  429779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  429788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429797 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429813 */     GIR_RootConstrainSelectedInstOperands,
     /*  429814 */     // GIR_Coverage, 2947,
     /*  429814 */     GIR_EraseRootFromParent_Done,
     /*  429815 */   // Label 7532: @429815
     /*  429815 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(429903), // Rule ID 2954 //
     /*  429820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  429823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  429831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  429834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  429837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429867 */     // MIs[1] Operand 1
     /*  429867 */     // No operand predicates
     /*  429867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  429876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429885 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429901 */     GIR_RootConstrainSelectedInstOperands,
     /*  429902 */     // GIR_Coverage, 2954,
     /*  429902 */     GIR_EraseRootFromParent_Done,
     /*  429903 */   // Label 7533: @429903
     /*  429903 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(429991), // Rule ID 2955 //
     /*  429908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  429911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  429919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  429922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  429925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429955 */     // MIs[1] Operand 1
     /*  429955 */     // No operand predicates
     /*  429955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  429964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429973 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429989 */     GIR_RootConstrainSelectedInstOperands,
     /*  429990 */     // GIR_Coverage, 2955,
     /*  429990 */     GIR_EraseRootFromParent_Done,
     /*  429991 */   // Label 7534: @429991
     /*  429991 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(430079), // Rule ID 2962 //
     /*  429996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  429999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430043 */     // MIs[1] Operand 1
     /*  430043 */     // No operand predicates
     /*  430043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  430052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430061 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430077 */     GIR_RootConstrainSelectedInstOperands,
     /*  430078 */     // GIR_Coverage, 2962,
     /*  430078 */     GIR_EraseRootFromParent_Done,
     /*  430079 */   // Label 7535: @430079
     /*  430079 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(430167), // Rule ID 2963 //
     /*  430084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  430087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  430092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  430095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  430098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  430101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  430119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  430131 */     // MIs[1] Operand 1
     /*  430131 */     // No operand predicates
     /*  430131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  430140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  430143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430149 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  430154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  430162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430165 */     GIR_RootConstrainSelectedInstOperands,
     /*  430166 */     // GIR_Coverage, 2963,
     /*  430166 */     GIR_EraseRootFromParent_Done,
     /*  430167 */   // Label 7536: @430167
     /*  430167 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(430253), // Rule ID 3146 //
     /*  430172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430219 */     // MIs[1] Operand 1
     /*  430219 */     // No operand predicates
     /*  430219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430228 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430251 */     GIR_RootConstrainSelectedInstOperands,
     /*  430252 */     // GIR_Coverage, 3146,
     /*  430252 */     GIR_EraseRootFromParent_Done,
     /*  430253 */   // Label 7537: @430253
     /*  430253 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(430339), // Rule ID 3147 //
     /*  430258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  430269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  430272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  430275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430305 */     // MIs[1] Operand 1
     /*  430305 */     // No operand predicates
     /*  430305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430314 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  430317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430337 */     GIR_RootConstrainSelectedInstOperands,
     /*  430338 */     // GIR_Coverage, 3147,
     /*  430338 */     GIR_EraseRootFromParent_Done,
     /*  430339 */   // Label 7538: @430339
     /*  430339 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(430425), // Rule ID 3150 //
     /*  430344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430391 */     // MIs[1] Operand 1
     /*  430391 */     // No operand predicates
     /*  430391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430400 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430423 */     GIR_RootConstrainSelectedInstOperands,
     /*  430424 */     // GIR_Coverage, 3150,
     /*  430424 */     GIR_EraseRootFromParent_Done,
     /*  430425 */   // Label 7539: @430425
     /*  430425 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(430511), // Rule ID 3151 //
     /*  430430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  430441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  430444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  430447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430477 */     // MIs[1] Operand 1
     /*  430477 */     // No operand predicates
     /*  430477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430486 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430509 */     GIR_RootConstrainSelectedInstOperands,
     /*  430510 */     // GIR_Coverage, 3151,
     /*  430510 */     GIR_EraseRootFromParent_Done,
     /*  430511 */   // Label 7540: @430511
     /*  430511 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(430597), // Rule ID 3154 //
     /*  430516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430563 */     // MIs[1] Operand 1
     /*  430563 */     // No operand predicates
     /*  430563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430572 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430595 */     GIR_RootConstrainSelectedInstOperands,
     /*  430596 */     // GIR_Coverage, 3154,
     /*  430596 */     GIR_EraseRootFromParent_Done,
     /*  430597 */   // Label 7541: @430597
     /*  430597 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(430683), // Rule ID 3155 //
     /*  430602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430649 */     // MIs[1] Operand 1
     /*  430649 */     // No operand predicates
     /*  430649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430658 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430681 */     GIR_RootConstrainSelectedInstOperands,
     /*  430682 */     // GIR_Coverage, 3155,
     /*  430682 */     GIR_EraseRootFromParent_Done,
     /*  430683 */   // Label 7542: @430683
     /*  430683 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(430769), // Rule ID 3158 //
     /*  430688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430735 */     // MIs[1] Operand 1
     /*  430735 */     // No operand predicates
     /*  430735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430767 */     GIR_RootConstrainSelectedInstOperands,
     /*  430768 */     // GIR_Coverage, 3158,
     /*  430768 */     GIR_EraseRootFromParent_Done,
     /*  430769 */   // Label 7543: @430769
     /*  430769 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(430855), // Rule ID 3159 //
     /*  430774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430821 */     // MIs[1] Operand 1
     /*  430821 */     // No operand predicates
     /*  430821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430830 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430853 */     GIR_RootConstrainSelectedInstOperands,
     /*  430854 */     // GIR_Coverage, 3159,
     /*  430854 */     GIR_EraseRootFromParent_Done,
     /*  430855 */   // Label 7544: @430855
     /*  430855 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(430941), // Rule ID 3162 //
     /*  430860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430907 */     // MIs[1] Operand 1
     /*  430907 */     // No operand predicates
     /*  430907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430916 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430939 */     GIR_RootConstrainSelectedInstOperands,
     /*  430940 */     // GIR_Coverage, 3162,
     /*  430940 */     GIR_EraseRootFromParent_Done,
     /*  430941 */   // Label 7545: @430941
     /*  430941 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(431027), // Rule ID 3163 //
     /*  430946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430993 */     // MIs[1] Operand 1
     /*  430993 */     // No operand predicates
     /*  430993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431002 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431025 */     GIR_RootConstrainSelectedInstOperands,
     /*  431026 */     // GIR_Coverage, 3163,
     /*  431026 */     GIR_EraseRootFromParent_Done,
     /*  431027 */   // Label 7546: @431027
     /*  431027 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(431113), // Rule ID 3166 //
     /*  431032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431079 */     // MIs[1] Operand 1
     /*  431079 */     // No operand predicates
     /*  431079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431088 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431111 */     GIR_RootConstrainSelectedInstOperands,
     /*  431112 */     // GIR_Coverage, 3166,
     /*  431112 */     GIR_EraseRootFromParent_Done,
     /*  431113 */   // Label 7547: @431113
     /*  431113 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(431199), // Rule ID 3167 //
     /*  431118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  431129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  431132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  431135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431165 */     // MIs[1] Operand 1
     /*  431165 */     // No operand predicates
     /*  431165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  431177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431197 */     GIR_RootConstrainSelectedInstOperands,
     /*  431198 */     // GIR_Coverage, 3167,
     /*  431198 */     GIR_EraseRootFromParent_Done,
     /*  431199 */   // Label 7548: @431199
     /*  431199 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(431285), // Rule ID 3170 //
     /*  431204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431251 */     // MIs[1] Operand 1
     /*  431251 */     // No operand predicates
     /*  431251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431260 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431283 */     GIR_RootConstrainSelectedInstOperands,
     /*  431284 */     // GIR_Coverage, 3170,
     /*  431284 */     GIR_EraseRootFromParent_Done,
     /*  431285 */   // Label 7549: @431285
     /*  431285 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(431371), // Rule ID 3171 //
     /*  431290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  431301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  431304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  431307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431337 */     // MIs[1] Operand 1
     /*  431337 */     // No operand predicates
     /*  431337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431369 */     GIR_RootConstrainSelectedInstOperands,
     /*  431370 */     // GIR_Coverage, 3171,
     /*  431370 */     GIR_EraseRootFromParent_Done,
     /*  431371 */   // Label 7550: @431371
     /*  431371 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(431457), // Rule ID 3174 //
     /*  431376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431423 */     // MIs[1] Operand 1
     /*  431423 */     // No operand predicates
     /*  431423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431432 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431455 */     GIR_RootConstrainSelectedInstOperands,
     /*  431456 */     // GIR_Coverage, 3174,
     /*  431456 */     GIR_EraseRootFromParent_Done,
     /*  431457 */   // Label 7551: @431457
     /*  431457 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(431543), // Rule ID 3175 //
     /*  431462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  431473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  431476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  431479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431509 */     // MIs[1] Operand 1
     /*  431509 */     // No operand predicates
     /*  431509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431541 */     GIR_RootConstrainSelectedInstOperands,
     /*  431542 */     // GIR_Coverage, 3175,
     /*  431542 */     GIR_EraseRootFromParent_Done,
     /*  431543 */   // Label 7552: @431543
     /*  431543 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(431629), // Rule ID 3178 //
     /*  431548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431595 */     // MIs[1] Operand 1
     /*  431595 */     // No operand predicates
     /*  431595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431627 */     GIR_RootConstrainSelectedInstOperands,
     /*  431628 */     // GIR_Coverage, 3178,
     /*  431628 */     GIR_EraseRootFromParent_Done,
     /*  431629 */   // Label 7553: @431629
     /*  431629 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(431715), // Rule ID 3179 //
     /*  431634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431681 */     // MIs[1] Operand 1
     /*  431681 */     // No operand predicates
     /*  431681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431713 */     GIR_RootConstrainSelectedInstOperands,
     /*  431714 */     // GIR_Coverage, 3179,
     /*  431714 */     GIR_EraseRootFromParent_Done,
     /*  431715 */   // Label 7554: @431715
     /*  431715 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(431801), // Rule ID 3182 //
     /*  431720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  431723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431767 */     // MIs[1] Operand 1
     /*  431767 */     // No operand predicates
     /*  431767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  431776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431799 */     GIR_RootConstrainSelectedInstOperands,
     /*  431800 */     // GIR_Coverage, 3182,
     /*  431800 */     GIR_EraseRootFromParent_Done,
     /*  431801 */   // Label 7555: @431801
     /*  431801 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(431887), // Rule ID 3183 //
     /*  431806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  431809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431853 */     // MIs[1] Operand 1
     /*  431853 */     // No operand predicates
     /*  431853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431862 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  431862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431885 */     GIR_RootConstrainSelectedInstOperands,
     /*  431886 */     // GIR_Coverage, 3183,
     /*  431886 */     GIR_EraseRootFromParent_Done,
     /*  431887 */   // Label 7556: @431887
     /*  431887 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(431973), // Rule ID 3186 //
     /*  431892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  431903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  431906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  431909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431939 */     // MIs[1] Operand 1
     /*  431939 */     // No operand predicates
     /*  431939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  431951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431971 */     GIR_RootConstrainSelectedInstOperands,
     /*  431972 */     // GIR_Coverage, 3186,
     /*  431972 */     GIR_EraseRootFromParent_Done,
     /*  431973 */   // Label 7557: @431973
     /*  431973 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(432059), // Rule ID 3187 //
     /*  431978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  431989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  431992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  431995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432025 */     // MIs[1] Operand 1
     /*  432025 */     // No operand predicates
     /*  432025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432034 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432057 */     GIR_RootConstrainSelectedInstOperands,
     /*  432058 */     // GIR_Coverage, 3187,
     /*  432058 */     GIR_EraseRootFromParent_Done,
     /*  432059 */   // Label 7558: @432059
     /*  432059 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(432145), // Rule ID 3190 //
     /*  432064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432111 */     // MIs[1] Operand 1
     /*  432111 */     // No operand predicates
     /*  432111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432120 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432143 */     GIR_RootConstrainSelectedInstOperands,
     /*  432144 */     // GIR_Coverage, 3190,
     /*  432144 */     GIR_EraseRootFromParent_Done,
     /*  432145 */   // Label 7559: @432145
     /*  432145 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(432231), // Rule ID 3191 //
     /*  432150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  432161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  432164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  432167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432197 */     // MIs[1] Operand 1
     /*  432197 */     // No operand predicates
     /*  432197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432206 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432229 */     GIR_RootConstrainSelectedInstOperands,
     /*  432230 */     // GIR_Coverage, 3191,
     /*  432230 */     GIR_EraseRootFromParent_Done,
     /*  432231 */   // Label 7560: @432231
     /*  432231 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(432317), // Rule ID 3194 //
     /*  432236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432283 */     // MIs[1] Operand 1
     /*  432283 */     // No operand predicates
     /*  432283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432292 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  432292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432315 */     GIR_RootConstrainSelectedInstOperands,
     /*  432316 */     // GIR_Coverage, 3194,
     /*  432316 */     GIR_EraseRootFromParent_Done,
     /*  432317 */   // Label 7561: @432317
     /*  432317 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(432403), // Rule ID 3195 //
     /*  432322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  432333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  432336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  432339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432369 */     // MIs[1] Operand 1
     /*  432369 */     // No operand predicates
     /*  432369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432378 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  432378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  432398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432401 */     GIR_RootConstrainSelectedInstOperands,
     /*  432402 */     // GIR_Coverage, 3195,
     /*  432402 */     GIR_EraseRootFromParent_Done,
     /*  432403 */   // Label 7562: @432403
     /*  432403 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(432489), // Rule ID 3198 //
     /*  432408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432455 */     // MIs[1] Operand 1
     /*  432455 */     // No operand predicates
     /*  432455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432487 */     GIR_RootConstrainSelectedInstOperands,
     /*  432488 */     // GIR_Coverage, 3198,
     /*  432488 */     GIR_EraseRootFromParent_Done,
     /*  432489 */   // Label 7563: @432489
     /*  432489 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(432575), // Rule ID 3199 //
     /*  432494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  432505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432541 */     // MIs[1] Operand 1
     /*  432541 */     // No operand predicates
     /*  432541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432550 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432573 */     GIR_RootConstrainSelectedInstOperands,
     /*  432574 */     // GIR_Coverage, 3199,
     /*  432574 */     GIR_EraseRootFromParent_Done,
     /*  432575 */   // Label 7564: @432575
     /*  432575 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(432661), // Rule ID 3202 //
     /*  432580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432627 */     // MIs[1] Operand 1
     /*  432627 */     // No operand predicates
     /*  432627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432636 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432659 */     GIR_RootConstrainSelectedInstOperands,
     /*  432660 */     // GIR_Coverage, 3202,
     /*  432660 */     GIR_EraseRootFromParent_Done,
     /*  432661 */   // Label 7565: @432661
     /*  432661 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(432747), // Rule ID 3203 //
     /*  432666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432713 */     // MIs[1] Operand 1
     /*  432713 */     // No operand predicates
     /*  432713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432722 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432745 */     GIR_RootConstrainSelectedInstOperands,
     /*  432746 */     // GIR_Coverage, 3203,
     /*  432746 */     GIR_EraseRootFromParent_Done,
     /*  432747 */   // Label 7566: @432747
     /*  432747 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(432833), // Rule ID 3206 //
     /*  432752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432799 */     // MIs[1] Operand 1
     /*  432799 */     // No operand predicates
     /*  432799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432808 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432831 */     GIR_RootConstrainSelectedInstOperands,
     /*  432832 */     // GIR_Coverage, 3206,
     /*  432832 */     GIR_EraseRootFromParent_Done,
     /*  432833 */   // Label 7567: @432833
     /*  432833 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(432919), // Rule ID 3207 //
     /*  432838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432885 */     // MIs[1] Operand 1
     /*  432885 */     // No operand predicates
     /*  432885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432917 */     GIR_RootConstrainSelectedInstOperands,
     /*  432918 */     // GIR_Coverage, 3207,
     /*  432918 */     GIR_EraseRootFromParent_Done,
     /*  432919 */   // Label 7568: @432919
     /*  432919 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(433005), // Rule ID 3210 //
     /*  432924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  432935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  432938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  432941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432971 */     // MIs[1] Operand 1
     /*  432971 */     // No operand predicates
     /*  432971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432980 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  432980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433003 */     GIR_RootConstrainSelectedInstOperands,
     /*  433004 */     // GIR_Coverage, 3210,
     /*  433004 */     GIR_EraseRootFromParent_Done,
     /*  433005 */   // Label 7569: @433005
     /*  433005 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(433091), // Rule ID 3211 //
     /*  433010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  433021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  433024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  433027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433057 */     // MIs[1] Operand 1
     /*  433057 */     // No operand predicates
     /*  433057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433089 */     GIR_RootConstrainSelectedInstOperands,
     /*  433090 */     // GIR_Coverage, 3211,
     /*  433090 */     GIR_EraseRootFromParent_Done,
     /*  433091 */   // Label 7570: @433091
     /*  433091 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(433177), // Rule ID 3214 //
     /*  433096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433143 */     // MIs[1] Operand 1
     /*  433143 */     // No operand predicates
     /*  433143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433175 */     GIR_RootConstrainSelectedInstOperands,
     /*  433176 */     // GIR_Coverage, 3214,
     /*  433176 */     GIR_EraseRootFromParent_Done,
     /*  433177 */   // Label 7571: @433177
     /*  433177 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(433263), // Rule ID 3215 //
     /*  433182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  433193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  433196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  433199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433229 */     // MIs[1] Operand 1
     /*  433229 */     // No operand predicates
     /*  433229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433238 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433261 */     GIR_RootConstrainSelectedInstOperands,
     /*  433262 */     // GIR_Coverage, 3215,
     /*  433262 */     GIR_EraseRootFromParent_Done,
     /*  433263 */   // Label 7572: @433263
     /*  433263 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(433349), // Rule ID 3218 //
     /*  433268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433315 */     // MIs[1] Operand 1
     /*  433315 */     // No operand predicates
     /*  433315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433324 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  433324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433347 */     GIR_RootConstrainSelectedInstOperands,
     /*  433348 */     // GIR_Coverage, 3218,
     /*  433348 */     GIR_EraseRootFromParent_Done,
     /*  433349 */   // Label 7573: @433349
     /*  433349 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(433435), // Rule ID 3219 //
     /*  433354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  433365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  433368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  433371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433401 */     // MIs[1] Operand 1
     /*  433401 */     // No operand predicates
     /*  433401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  433410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  433430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433433 */     GIR_RootConstrainSelectedInstOperands,
     /*  433434 */     // GIR_Coverage, 3219,
     /*  433434 */     GIR_EraseRootFromParent_Done,
     /*  433435 */   // Label 7574: @433435
     /*  433435 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(433521), // Rule ID 3222 //
     /*  433440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433487 */     // MIs[1] Operand 1
     /*  433487 */     // No operand predicates
     /*  433487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433519 */     GIR_RootConstrainSelectedInstOperands,
     /*  433520 */     // GIR_Coverage, 3222,
     /*  433520 */     GIR_EraseRootFromParent_Done,
     /*  433521 */   // Label 7575: @433521
     /*  433521 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(433607), // Rule ID 3223 //
     /*  433526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433569 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433573 */     // MIs[1] Operand 1
     /*  433573 */     // No operand predicates
     /*  433573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433605 */     GIR_RootConstrainSelectedInstOperands,
     /*  433606 */     // GIR_Coverage, 3223,
     /*  433606 */     GIR_EraseRootFromParent_Done,
     /*  433607 */   // Label 7576: @433607
     /*  433607 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(433693), // Rule ID 3226 //
     /*  433612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433659 */     // MIs[1] Operand 1
     /*  433659 */     // No operand predicates
     /*  433659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433668 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433691 */     GIR_RootConstrainSelectedInstOperands,
     /*  433692 */     // GIR_Coverage, 3226,
     /*  433692 */     GIR_EraseRootFromParent_Done,
     /*  433693 */   // Label 7577: @433693
     /*  433693 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(433779), // Rule ID 3227 //
     /*  433698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433745 */     // MIs[1] Operand 1
     /*  433745 */     // No operand predicates
     /*  433745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433754 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433777 */     GIR_RootConstrainSelectedInstOperands,
     /*  433778 */     // GIR_Coverage, 3227,
     /*  433778 */     GIR_EraseRootFromParent_Done,
     /*  433779 */   // Label 7578: @433779
     /*  433779 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(433865), // Rule ID 3230 //
     /*  433784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433831 */     // MIs[1] Operand 1
     /*  433831 */     // No operand predicates
     /*  433831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433840 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433863 */     GIR_RootConstrainSelectedInstOperands,
     /*  433864 */     // GIR_Coverage, 3230,
     /*  433864 */     GIR_EraseRootFromParent_Done,
     /*  433865 */   // Label 7579: @433865
     /*  433865 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(433951), // Rule ID 3231 //
     /*  433870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433917 */     // MIs[1] Operand 1
     /*  433917 */     // No operand predicates
     /*  433917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433949 */     GIR_RootConstrainSelectedInstOperands,
     /*  433950 */     // GIR_Coverage, 3231,
     /*  433950 */     GIR_EraseRootFromParent_Done,
     /*  433951 */   // Label 7580: @433951
     /*  433951 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(434037), // Rule ID 3498 //
     /*  433956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  433964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  433967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  433970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  433973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434003 */     // MIs[1] Operand 1
     /*  434003 */     // No operand predicates
     /*  434003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434012 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  434015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434035 */     GIR_RootConstrainSelectedInstOperands,
     /*  434036 */     // GIR_Coverage, 3498,
     /*  434036 */     GIR_EraseRootFromParent_Done,
     /*  434037 */   // Label 7581: @434037
     /*  434037 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(434123), // Rule ID 3499 //
     /*  434042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  434053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  434056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  434059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434089 */     // MIs[1] Operand 1
     /*  434089 */     // No operand predicates
     /*  434089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434098 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  434101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434121 */     GIR_RootConstrainSelectedInstOperands,
     /*  434122 */     // GIR_Coverage, 3499,
     /*  434122 */     GIR_EraseRootFromParent_Done,
     /*  434123 */   // Label 7582: @434123
     /*  434123 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(434209), // Rule ID 3502 //
     /*  434128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434175 */     // MIs[1] Operand 1
     /*  434175 */     // No operand predicates
     /*  434175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434184 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434207 */     GIR_RootConstrainSelectedInstOperands,
     /*  434208 */     // GIR_Coverage, 3502,
     /*  434208 */     GIR_EraseRootFromParent_Done,
     /*  434209 */   // Label 7583: @434209
     /*  434209 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(434295), // Rule ID 3503 //
     /*  434214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  434225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  434228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  434231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434261 */     // MIs[1] Operand 1
     /*  434261 */     // No operand predicates
     /*  434261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434270 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434293 */     GIR_RootConstrainSelectedInstOperands,
     /*  434294 */     // GIR_Coverage, 3503,
     /*  434294 */     GIR_EraseRootFromParent_Done,
     /*  434295 */   // Label 7584: @434295
     /*  434295 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(434381), // Rule ID 3506 //
     /*  434300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434347 */     // MIs[1] Operand 1
     /*  434347 */     // No operand predicates
     /*  434347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434356 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434379 */     GIR_RootConstrainSelectedInstOperands,
     /*  434380 */     // GIR_Coverage, 3506,
     /*  434380 */     GIR_EraseRootFromParent_Done,
     /*  434381 */   // Label 7585: @434381
     /*  434381 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(434467), // Rule ID 3507 //
     /*  434386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  434397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  434400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  434403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434433 */     // MIs[1] Operand 1
     /*  434433 */     // No operand predicates
     /*  434433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434442 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434465 */     GIR_RootConstrainSelectedInstOperands,
     /*  434466 */     // GIR_Coverage, 3507,
     /*  434466 */     GIR_EraseRootFromParent_Done,
     /*  434467 */   // Label 7586: @434467
     /*  434467 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(434553), // Rule ID 3510 //
     /*  434472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434519 */     // MIs[1] Operand 1
     /*  434519 */     // No operand predicates
     /*  434519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434528 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434551 */     GIR_RootConstrainSelectedInstOperands,
     /*  434552 */     // GIR_Coverage, 3510,
     /*  434552 */     GIR_EraseRootFromParent_Done,
     /*  434553 */   // Label 7587: @434553
     /*  434553 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(434639), // Rule ID 3511 //
     /*  434558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434605 */     // MIs[1] Operand 1
     /*  434605 */     // No operand predicates
     /*  434605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434637 */     GIR_RootConstrainSelectedInstOperands,
     /*  434638 */     // GIR_Coverage, 3511,
     /*  434638 */     GIR_EraseRootFromParent_Done,
     /*  434639 */   // Label 7588: @434639
     /*  434639 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(434725), // Rule ID 3514 //
     /*  434644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434691 */     // MIs[1] Operand 1
     /*  434691 */     // No operand predicates
     /*  434691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434700 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434723 */     GIR_RootConstrainSelectedInstOperands,
     /*  434724 */     // GIR_Coverage, 3514,
     /*  434724 */     GIR_EraseRootFromParent_Done,
     /*  434725 */   // Label 7589: @434725
     /*  434725 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(434811), // Rule ID 3515 //
     /*  434730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434777 */     // MIs[1] Operand 1
     /*  434777 */     // No operand predicates
     /*  434777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434786 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434809 */     GIR_RootConstrainSelectedInstOperands,
     /*  434810 */     // GIR_Coverage, 3515,
     /*  434810 */     GIR_EraseRootFromParent_Done,
     /*  434811 */   // Label 7590: @434811
     /*  434811 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(434897), // Rule ID 3518 //
     /*  434816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434863 */     // MIs[1] Operand 1
     /*  434863 */     // No operand predicates
     /*  434863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434872 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434895 */     GIR_RootConstrainSelectedInstOperands,
     /*  434896 */     // GIR_Coverage, 3518,
     /*  434896 */     GIR_EraseRootFromParent_Done,
     /*  434897 */   // Label 7591: @434897
     /*  434897 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(434983), // Rule ID 3519 //
     /*  434902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434949 */     // MIs[1] Operand 1
     /*  434949 */     // No operand predicates
     /*  434949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  434958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434981 */     GIR_RootConstrainSelectedInstOperands,
     /*  434982 */     // GIR_Coverage, 3519,
     /*  434982 */     GIR_EraseRootFromParent_Done,
     /*  434983 */   // Label 7592: @434983
     /*  434983 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(435069), // Rule ID 3522 //
     /*  434988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  434999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435035 */     // MIs[1] Operand 1
     /*  435035 */     // No operand predicates
     /*  435035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435067 */     GIR_RootConstrainSelectedInstOperands,
     /*  435068 */     // GIR_Coverage, 3522,
     /*  435068 */     GIR_EraseRootFromParent_Done,
     /*  435069 */   // Label 7593: @435069
     /*  435069 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(435155), // Rule ID 3523 //
     /*  435074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  435085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  435088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  435091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435121 */     // MIs[1] Operand 1
     /*  435121 */     // No operand predicates
     /*  435121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435130 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435153 */     GIR_RootConstrainSelectedInstOperands,
     /*  435154 */     // GIR_Coverage, 3523,
     /*  435154 */     GIR_EraseRootFromParent_Done,
     /*  435155 */   // Label 7594: @435155
     /*  435155 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(435241), // Rule ID 3526 //
     /*  435160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435207 */     // MIs[1] Operand 1
     /*  435207 */     // No operand predicates
     /*  435207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435216 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435239 */     GIR_RootConstrainSelectedInstOperands,
     /*  435240 */     // GIR_Coverage, 3526,
     /*  435240 */     GIR_EraseRootFromParent_Done,
     /*  435241 */   // Label 7595: @435241
     /*  435241 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(435327), // Rule ID 3527 //
     /*  435246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  435257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  435260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  435263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435293 */     // MIs[1] Operand 1
     /*  435293 */     // No operand predicates
     /*  435293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435325 */     GIR_RootConstrainSelectedInstOperands,
     /*  435326 */     // GIR_Coverage, 3527,
     /*  435326 */     GIR_EraseRootFromParent_Done,
     /*  435327 */   // Label 7596: @435327
     /*  435327 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(435413), // Rule ID 3530 //
     /*  435332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435379 */     // MIs[1] Operand 1
     /*  435379 */     // No operand predicates
     /*  435379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435388 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  435388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435411 */     GIR_RootConstrainSelectedInstOperands,
     /*  435412 */     // GIR_Coverage, 3530,
     /*  435412 */     GIR_EraseRootFromParent_Done,
     /*  435413 */   // Label 7597: @435413
     /*  435413 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(435499), // Rule ID 3531 //
     /*  435418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  435429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  435432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  435435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435465 */     // MIs[1] Operand 1
     /*  435465 */     // No operand predicates
     /*  435465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  435474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  435494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435497 */     GIR_RootConstrainSelectedInstOperands,
     /*  435498 */     // GIR_Coverage, 3531,
     /*  435498 */     GIR_EraseRootFromParent_Done,
     /*  435499 */   // Label 7598: @435499
     /*  435499 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(435585), // Rule ID 3534 //
     /*  435504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  435507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435551 */     // MIs[1] Operand 1
     /*  435551 */     // No operand predicates
     /*  435551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435560 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  435560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435583 */     GIR_RootConstrainSelectedInstOperands,
     /*  435584 */     // GIR_Coverage, 3534,
     /*  435584 */     GIR_EraseRootFromParent_Done,
     /*  435585 */   // Label 7599: @435585
     /*  435585 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(435671), // Rule ID 3535 //
     /*  435590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  435593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435637 */     // MIs[1] Operand 1
     /*  435637 */     // No operand predicates
     /*  435637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  435646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435669 */     GIR_RootConstrainSelectedInstOperands,
     /*  435670 */     // GIR_Coverage, 3535,
     /*  435670 */     GIR_EraseRootFromParent_Done,
     /*  435671 */   // Label 7600: @435671
     /*  435671 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(435757), // Rule ID 3538 //
     /*  435676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435723 */     // MIs[1] Operand 1
     /*  435723 */     // No operand predicates
     /*  435723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435732 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  435735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435755 */     GIR_RootConstrainSelectedInstOperands,
     /*  435756 */     // GIR_Coverage, 3538,
     /*  435756 */     GIR_EraseRootFromParent_Done,
     /*  435757 */   // Label 7601: @435757
     /*  435757 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(435843), // Rule ID 3539 //
     /*  435762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435809 */     // MIs[1] Operand 1
     /*  435809 */     // No operand predicates
     /*  435809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  435821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435841 */     GIR_RootConstrainSelectedInstOperands,
     /*  435842 */     // GIR_Coverage, 3539,
     /*  435842 */     GIR_EraseRootFromParent_Done,
     /*  435843 */   // Label 7602: @435843
     /*  435843 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(435929), // Rule ID 3542 //
     /*  435848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  435865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435895 */     // MIs[1] Operand 1
     /*  435895 */     // No operand predicates
     /*  435895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435904 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  435907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435927 */     GIR_RootConstrainSelectedInstOperands,
     /*  435928 */     // GIR_Coverage, 3542,
     /*  435928 */     GIR_EraseRootFromParent_Done,
     /*  435929 */   // Label 7603: @435929
     /*  435929 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(436015), // Rule ID 3543 //
     /*  435934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  435951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435981 */     // MIs[1] Operand 1
     /*  435981 */     // No operand predicates
     /*  435981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  435993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436013 */     GIR_RootConstrainSelectedInstOperands,
     /*  436014 */     // GIR_Coverage, 3543,
     /*  436014 */     GIR_EraseRootFromParent_Done,
     /*  436015 */   // Label 7604: @436015
     /*  436015 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(436101), // Rule ID 3546 //
     /*  436020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436067 */     // MIs[1] Operand 1
     /*  436067 */     // No operand predicates
     /*  436067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436076 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  436076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436099 */     GIR_RootConstrainSelectedInstOperands,
     /*  436100 */     // GIR_Coverage, 3546,
     /*  436100 */     GIR_EraseRootFromParent_Done,
     /*  436101 */   // Label 7605: @436101
     /*  436101 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(436187), // Rule ID 3547 //
     /*  436106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  436117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  436120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  436123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436153 */     // MIs[1] Operand 1
     /*  436153 */     // No operand predicates
     /*  436153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436162 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  436162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  436182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436185 */     GIR_RootConstrainSelectedInstOperands,
     /*  436186 */     // GIR_Coverage, 3547,
     /*  436186 */     GIR_EraseRootFromParent_Done,
     /*  436187 */   // Label 7606: @436187
     /*  436187 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(436273), // Rule ID 3550 //
     /*  436192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436239 */     // MIs[1] Operand 1
     /*  436239 */     // No operand predicates
     /*  436239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436271 */     GIR_RootConstrainSelectedInstOperands,
     /*  436272 */     // GIR_Coverage, 3550,
     /*  436272 */     GIR_EraseRootFromParent_Done,
     /*  436273 */   // Label 7607: @436273
     /*  436273 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(436359), // Rule ID 3551 //
     /*  436278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  436289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  436292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  436295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436325 */     // MIs[1] Operand 1
     /*  436325 */     // No operand predicates
     /*  436325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436357 */     GIR_RootConstrainSelectedInstOperands,
     /*  436358 */     // GIR_Coverage, 3551,
     /*  436358 */     GIR_EraseRootFromParent_Done,
     /*  436359 */   // Label 7608: @436359
     /*  436359 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(436445), // Rule ID 3554 //
     /*  436364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436411 */     // MIs[1] Operand 1
     /*  436411 */     // No operand predicates
     /*  436411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436420 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436443 */     GIR_RootConstrainSelectedInstOperands,
     /*  436444 */     // GIR_Coverage, 3554,
     /*  436444 */     GIR_EraseRootFromParent_Done,
     /*  436445 */   // Label 7609: @436445
     /*  436445 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(436531), // Rule ID 3555 //
     /*  436450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  436461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  436464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  436467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436497 */     // MIs[1] Operand 1
     /*  436497 */     // No operand predicates
     /*  436497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436506 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436529 */     GIR_RootConstrainSelectedInstOperands,
     /*  436530 */     // GIR_Coverage, 3555,
     /*  436530 */     GIR_EraseRootFromParent_Done,
     /*  436531 */   // Label 7610: @436531
     /*  436531 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(436617), // Rule ID 3558 //
     /*  436536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436583 */     // MIs[1] Operand 1
     /*  436583 */     // No operand predicates
     /*  436583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436592 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436615 */     GIR_RootConstrainSelectedInstOperands,
     /*  436616 */     // GIR_Coverage, 3558,
     /*  436616 */     GIR_EraseRootFromParent_Done,
     /*  436617 */   // Label 7611: @436617
     /*  436617 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(436703), // Rule ID 3559 //
     /*  436622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436669 */     // MIs[1] Operand 1
     /*  436669 */     // No operand predicates
     /*  436669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436678 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436701 */     GIR_RootConstrainSelectedInstOperands,
     /*  436702 */     // GIR_Coverage, 3559,
     /*  436702 */     GIR_EraseRootFromParent_Done,
     /*  436703 */   // Label 7612: @436703
     /*  436703 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(436789), // Rule ID 3562 //
     /*  436708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436755 */     // MIs[1] Operand 1
     /*  436755 */     // No operand predicates
     /*  436755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436787 */     GIR_RootConstrainSelectedInstOperands,
     /*  436788 */     // GIR_Coverage, 3562,
     /*  436788 */     GIR_EraseRootFromParent_Done,
     /*  436789 */   // Label 7613: @436789
     /*  436789 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(436875), // Rule ID 3563 //
     /*  436794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436841 */     // MIs[1] Operand 1
     /*  436841 */     // No operand predicates
     /*  436841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  436850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436873 */     GIR_RootConstrainSelectedInstOperands,
     /*  436874 */     // GIR_Coverage, 3563,
     /*  436874 */     GIR_EraseRootFromParent_Done,
     /*  436875 */   // Label 7614: @436875
     /*  436875 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(436961), // Rule ID 3566 //
     /*  436880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  436891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  436894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436927 */     // MIs[1] Operand 1
     /*  436927 */     // No operand predicates
     /*  436927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436959 */     GIR_RootConstrainSelectedInstOperands,
     /*  436960 */     // GIR_Coverage, 3566,
     /*  436960 */     GIR_EraseRootFromParent_Done,
     /*  436961 */   // Label 7615: @436961
     /*  436961 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(437047), // Rule ID 3567 //
     /*  436966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  436977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  436980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437013 */     // MIs[1] Operand 1
     /*  437013 */     // No operand predicates
     /*  437013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437045 */     GIR_RootConstrainSelectedInstOperands,
     /*  437046 */     // GIR_Coverage, 3567,
     /*  437046 */     GIR_EraseRootFromParent_Done,
     /*  437047 */   // Label 7616: @437047
     /*  437047 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(437133), // Rule ID 3570 //
     /*  437052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437099 */     // MIs[1] Operand 1
     /*  437099 */     // No operand predicates
     /*  437099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  437108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437131 */     GIR_RootConstrainSelectedInstOperands,
     /*  437132 */     // GIR_Coverage, 3570,
     /*  437132 */     GIR_EraseRootFromParent_Done,
     /*  437133 */   // Label 7617: @437133
     /*  437133 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(437219), // Rule ID 3571 //
     /*  437138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  437149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  437152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  437155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437185 */     // MIs[1] Operand 1
     /*  437185 */     // No operand predicates
     /*  437185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  437194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  437214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437217 */     GIR_RootConstrainSelectedInstOperands,
     /*  437218 */     // GIR_Coverage, 3571,
     /*  437218 */     GIR_EraseRootFromParent_Done,
     /*  437219 */   // Label 7618: @437219
     /*  437219 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(437305), // Rule ID 3574 //
     /*  437224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437271 */     // MIs[1] Operand 1
     /*  437271 */     // No operand predicates
     /*  437271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437280 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437303 */     GIR_RootConstrainSelectedInstOperands,
     /*  437304 */     // GIR_Coverage, 3574,
     /*  437304 */     GIR_EraseRootFromParent_Done,
     /*  437305 */   // Label 7619: @437305
     /*  437305 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(437391), // Rule ID 3575 //
     /*  437310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  437321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  437324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  437327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  437345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437357 */     // MIs[1] Operand 1
     /*  437357 */     // No operand predicates
     /*  437357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437366 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  437369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437389 */     GIR_RootConstrainSelectedInstOperands,
     /*  437390 */     // GIR_Coverage, 3575,
     /*  437390 */     GIR_EraseRootFromParent_Done,
     /*  437391 */   // Label 7620: @437391
     /*  437391 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(437477), // Rule ID 3578 //
     /*  437396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437443 */     // MIs[1] Operand 1
     /*  437443 */     // No operand predicates
     /*  437443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437452 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437475 */     GIR_RootConstrainSelectedInstOperands,
     /*  437476 */     // GIR_Coverage, 3578,
     /*  437476 */     GIR_EraseRootFromParent_Done,
     /*  437477 */   // Label 7621: @437477
     /*  437477 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(437563), // Rule ID 3579 //
     /*  437482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  437493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  437496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  437499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437529 */     // MIs[1] Operand 1
     /*  437529 */     // No operand predicates
     /*  437529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437538 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437561 */     GIR_RootConstrainSelectedInstOperands,
     /*  437562 */     // GIR_Coverage, 3579,
     /*  437562 */     GIR_EraseRootFromParent_Done,
     /*  437563 */   // Label 7622: @437563
     /*  437563 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(437649), // Rule ID 3582 //
     /*  437568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437615 */     // MIs[1] Operand 1
     /*  437615 */     // No operand predicates
     /*  437615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437624 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437647 */     GIR_RootConstrainSelectedInstOperands,
     /*  437648 */     // GIR_Coverage, 3582,
     /*  437648 */     GIR_EraseRootFromParent_Done,
     /*  437649 */   // Label 7623: @437649
     /*  437649 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(437735), // Rule ID 3583 //
     /*  437654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437701 */     // MIs[1] Operand 1
     /*  437701 */     // No operand predicates
     /*  437701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437710 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437733 */     GIR_RootConstrainSelectedInstOperands,
     /*  437734 */     // GIR_Coverage, 3583,
     /*  437734 */     GIR_EraseRootFromParent_Done,
     /*  437735 */   // Label 7624: @437735
     /*  437735 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(437821), // Rule ID 5946 //
     /*  437740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437787 */     // MIs[1] Operand 1
     /*  437787 */     // No operand predicates
     /*  437787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  437799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437819 */     GIR_RootConstrainSelectedInstOperands,
     /*  437820 */     // GIR_Coverage, 5946,
     /*  437820 */     GIR_EraseRootFromParent_Done,
     /*  437821 */   // Label 7625: @437821
     /*  437821 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(437907), // Rule ID 5947 //
     /*  437826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437873 */     // MIs[1] Operand 1
     /*  437873 */     // No operand predicates
     /*  437873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437882 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  437885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437905 */     GIR_RootConstrainSelectedInstOperands,
     /*  437906 */     // GIR_Coverage, 5947,
     /*  437906 */     GIR_EraseRootFromParent_Done,
     /*  437907 */   // Label 7626: @437907
     /*  437907 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(437993), // Rule ID 5950 //
     /*  437912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  437923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  437926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  437929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437959 */     // MIs[1] Operand 1
     /*  437959 */     // No operand predicates
     /*  437959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  437971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437991 */     GIR_RootConstrainSelectedInstOperands,
     /*  437992 */     // GIR_Coverage, 5950,
     /*  437992 */     GIR_EraseRootFromParent_Done,
     /*  437993 */   // Label 7627: @437993
     /*  437993 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(438079), // Rule ID 5951 //
     /*  437998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  438009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  438012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  438015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438045 */     // MIs[1] Operand 1
     /*  438045 */     // No operand predicates
     /*  438045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438054 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438077 */     GIR_RootConstrainSelectedInstOperands,
     /*  438078 */     // GIR_Coverage, 5951,
     /*  438078 */     GIR_EraseRootFromParent_Done,
     /*  438079 */   // Label 7628: @438079
     /*  438079 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(438165), // Rule ID 5954 //
     /*  438084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438131 */     // MIs[1] Operand 1
     /*  438131 */     // No operand predicates
     /*  438131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438140 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438163 */     GIR_RootConstrainSelectedInstOperands,
     /*  438164 */     // GIR_Coverage, 5954,
     /*  438164 */     GIR_EraseRootFromParent_Done,
     /*  438165 */   // Label 7629: @438165
     /*  438165 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(438251), // Rule ID 5955 //
     /*  438170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  438181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  438184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  438187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438217 */     // MIs[1] Operand 1
     /*  438217 */     // No operand predicates
     /*  438217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438226 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438249 */     GIR_RootConstrainSelectedInstOperands,
     /*  438250 */     // GIR_Coverage, 5955,
     /*  438250 */     GIR_EraseRootFromParent_Done,
     /*  438251 */   // Label 7630: @438251
     /*  438251 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(438337), // Rule ID 5958 //
     /*  438256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438303 */     // MIs[1] Operand 1
     /*  438303 */     // No operand predicates
     /*  438303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438312 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438335 */     GIR_RootConstrainSelectedInstOperands,
     /*  438336 */     // GIR_Coverage, 5958,
     /*  438336 */     GIR_EraseRootFromParent_Done,
     /*  438337 */   // Label 7631: @438337
     /*  438337 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(438423), // Rule ID 5959 //
     /*  438342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  438353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  438356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  438359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438389 */     // MIs[1] Operand 1
     /*  438389 */     // No operand predicates
     /*  438389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438398 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  438401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438421 */     GIR_RootConstrainSelectedInstOperands,
     /*  438422 */     // GIR_Coverage, 5959,
     /*  438422 */     GIR_EraseRootFromParent_Done,
     /*  438423 */   // Label 7632: @438423
     /*  438423 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(438509), // Rule ID 5962 //
     /*  438428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438475 */     // MIs[1] Operand 1
     /*  438475 */     // No operand predicates
     /*  438475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438484 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438507 */     GIR_RootConstrainSelectedInstOperands,
     /*  438508 */     // GIR_Coverage, 5962,
     /*  438508 */     GIR_EraseRootFromParent_Done,
     /*  438509 */   // Label 7633: @438509
     /*  438509 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(438595), // Rule ID 5963 //
     /*  438514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438561 */     // MIs[1] Operand 1
     /*  438561 */     // No operand predicates
     /*  438561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438570 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438593 */     GIR_RootConstrainSelectedInstOperands,
     /*  438594 */     // GIR_Coverage, 5963,
     /*  438594 */     GIR_EraseRootFromParent_Done,
     /*  438595 */   // Label 7634: @438595
     /*  438595 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(438681), // Rule ID 5966 //
     /*  438600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438647 */     // MIs[1] Operand 1
     /*  438647 */     // No operand predicates
     /*  438647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438656 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  438656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438679 */     GIR_RootConstrainSelectedInstOperands,
     /*  438680 */     // GIR_Coverage, 5966,
     /*  438680 */     GIR_EraseRootFromParent_Done,
     /*  438681 */   // Label 7635: @438681
     /*  438681 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(438767), // Rule ID 5967 //
     /*  438686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438733 */     // MIs[1] Operand 1
     /*  438733 */     // No operand predicates
     /*  438733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  438742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438765 */     GIR_RootConstrainSelectedInstOperands,
     /*  438766 */     // GIR_Coverage, 5967,
     /*  438766 */     GIR_EraseRootFromParent_Done,
     /*  438767 */   // Label 7636: @438767
     /*  438767 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(438853), // Rule ID 5970 //
     /*  438772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438819 */     // MIs[1] Operand 1
     /*  438819 */     // No operand predicates
     /*  438819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438828 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438851 */     GIR_RootConstrainSelectedInstOperands,
     /*  438852 */     // GIR_Coverage, 5970,
     /*  438852 */     GIR_EraseRootFromParent_Done,
     /*  438853 */   // Label 7637: @438853
     /*  438853 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(438939), // Rule ID 5971 //
     /*  438858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438905 */     // MIs[1] Operand 1
     /*  438905 */     // No operand predicates
     /*  438905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438914 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438937 */     GIR_RootConstrainSelectedInstOperands,
     /*  438938 */     // GIR_Coverage, 5971,
     /*  438938 */     GIR_EraseRootFromParent_Done,
     /*  438939 */   // Label 7638: @438939
     /*  438939 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(439025), // Rule ID 5974 //
     /*  438944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  438955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  438958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  438961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438991 */     // MIs[1] Operand 1
     /*  438991 */     // No operand predicates
     /*  438991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439000 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439023 */     GIR_RootConstrainSelectedInstOperands,
     /*  439024 */     // GIR_Coverage, 5974,
     /*  439024 */     GIR_EraseRootFromParent_Done,
     /*  439025 */   // Label 7639: @439025
     /*  439025 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(439111), // Rule ID 5975 //
     /*  439030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  439041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  439044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  439047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439077 */     // MIs[1] Operand 1
     /*  439077 */     // No operand predicates
     /*  439077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439109 */     GIR_RootConstrainSelectedInstOperands,
     /*  439110 */     // GIR_Coverage, 5975,
     /*  439110 */     GIR_EraseRootFromParent_Done,
     /*  439111 */   // Label 7640: @439111
     /*  439111 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(439197), // Rule ID 5978 //
     /*  439116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439163 */     // MIs[1] Operand 1
     /*  439163 */     // No operand predicates
     /*  439163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439172 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  439172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439195 */     GIR_RootConstrainSelectedInstOperands,
     /*  439196 */     // GIR_Coverage, 5978,
     /*  439196 */     GIR_EraseRootFromParent_Done,
     /*  439197 */   // Label 7641: @439197
     /*  439197 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(439283), // Rule ID 5979 //
     /*  439202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  439213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  439216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  439219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439249 */     // MIs[1] Operand 1
     /*  439249 */     // No operand predicates
     /*  439249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  439258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  439278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439281 */     GIR_RootConstrainSelectedInstOperands,
     /*  439282 */     // GIR_Coverage, 5979,
     /*  439282 */     GIR_EraseRootFromParent_Done,
     /*  439283 */   // Label 7642: @439283
     /*  439283 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(439369), // Rule ID 5982 //
     /*  439288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  439291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439335 */     // MIs[1] Operand 1
     /*  439335 */     // No operand predicates
     /*  439335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439344 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  439344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439367 */     GIR_RootConstrainSelectedInstOperands,
     /*  439368 */     // GIR_Coverage, 5982,
     /*  439368 */     GIR_EraseRootFromParent_Done,
     /*  439369 */   // Label 7643: @439369
     /*  439369 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(439455), // Rule ID 5983 //
     /*  439374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  439377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  439385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  439388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  439391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  439409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439421 */     // MIs[1] Operand 1
     /*  439421 */     // No operand predicates
     /*  439421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439430 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  439430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  439433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  439450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439453 */     GIR_RootConstrainSelectedInstOperands,
     /*  439454 */     // GIR_Coverage, 5983,
     /*  439454 */     GIR_EraseRootFromParent_Done,
     /*  439455 */   // Label 7644: @439455
     /*  439455 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(439541), // Rule ID 5986 //
     /*  439460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439507 */     // MIs[1] Operand 1
     /*  439507 */     // No operand predicates
     /*  439507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439516 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439539 */     GIR_RootConstrainSelectedInstOperands,
     /*  439540 */     // GIR_Coverage, 5986,
     /*  439540 */     GIR_EraseRootFromParent_Done,
     /*  439541 */   // Label 7645: @439541
     /*  439541 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(439627), // Rule ID 5987 //
     /*  439546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439593 */     // MIs[1] Operand 1
     /*  439593 */     // No operand predicates
     /*  439593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439602 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439625 */     GIR_RootConstrainSelectedInstOperands,
     /*  439626 */     // GIR_Coverage, 5987,
     /*  439626 */     GIR_EraseRootFromParent_Done,
     /*  439627 */   // Label 7646: @439627
     /*  439627 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(439713), // Rule ID 5990 //
     /*  439632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439679 */     // MIs[1] Operand 1
     /*  439679 */     // No operand predicates
     /*  439679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439688 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  439691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439711 */     GIR_RootConstrainSelectedInstOperands,
     /*  439712 */     // GIR_Coverage, 5990,
     /*  439712 */     GIR_EraseRootFromParent_Done,
     /*  439713 */   // Label 7647: @439713
     /*  439713 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(439799), // Rule ID 5991 //
     /*  439718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439765 */     // MIs[1] Operand 1
     /*  439765 */     // No operand predicates
     /*  439765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439774 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  439777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439797 */     GIR_RootConstrainSelectedInstOperands,
     /*  439798 */     // GIR_Coverage, 5991,
     /*  439798 */     GIR_EraseRootFromParent_Done,
     /*  439799 */   // Label 7648: @439799
     /*  439799 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(439885), // Rule ID 5994 //
     /*  439804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439851 */     // MIs[1] Operand 1
     /*  439851 */     // No operand predicates
     /*  439851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439860 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  439863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439883 */     GIR_RootConstrainSelectedInstOperands,
     /*  439884 */     // GIR_Coverage, 5994,
     /*  439884 */     GIR_EraseRootFromParent_Done,
     /*  439885 */   // Label 7649: @439885
     /*  439885 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(439971), // Rule ID 5995 //
     /*  439890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439937 */     // MIs[1] Operand 1
     /*  439937 */     // No operand predicates
     /*  439937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439946 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  439949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439969 */     GIR_RootConstrainSelectedInstOperands,
     /*  439970 */     // GIR_Coverage, 5995,
     /*  439970 */     GIR_EraseRootFromParent_Done,
     /*  439971 */   // Label 7650: @439971
     /*  439971 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(440057), // Rule ID 5998 //
     /*  439976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  439987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  439990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  439993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440023 */     // MIs[1] Operand 1
     /*  440023 */     // No operand predicates
     /*  440023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440055 */     GIR_RootConstrainSelectedInstOperands,
     /*  440056 */     // GIR_Coverage, 5998,
     /*  440056 */     GIR_EraseRootFromParent_Done,
     /*  440057 */   // Label 7651: @440057
     /*  440057 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(440143), // Rule ID 5999 //
     /*  440062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  440073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  440076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  440079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440109 */     // MIs[1] Operand 1
     /*  440109 */     // No operand predicates
     /*  440109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440141 */     GIR_RootConstrainSelectedInstOperands,
     /*  440142 */     // GIR_Coverage, 5999,
     /*  440142 */     GIR_EraseRootFromParent_Done,
     /*  440143 */   // Label 7652: @440143
     /*  440143 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(440229), // Rule ID 6002 //
     /*  440148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440195 */     // MIs[1] Operand 1
     /*  440195 */     // No operand predicates
     /*  440195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440204 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440227 */     GIR_RootConstrainSelectedInstOperands,
     /*  440228 */     // GIR_Coverage, 6002,
     /*  440228 */     GIR_EraseRootFromParent_Done,
     /*  440229 */   // Label 7653: @440229
     /*  440229 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(440315), // Rule ID 6003 //
     /*  440234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  440245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  440248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  440251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440281 */     // MIs[1] Operand 1
     /*  440281 */     // No operand predicates
     /*  440281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440290 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440313 */     GIR_RootConstrainSelectedInstOperands,
     /*  440314 */     // GIR_Coverage, 6003,
     /*  440314 */     GIR_EraseRootFromParent_Done,
     /*  440315 */   // Label 7654: @440315
     /*  440315 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(440401), // Rule ID 6006 //
     /*  440320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440367 */     // MIs[1] Operand 1
     /*  440367 */     // No operand predicates
     /*  440367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440376 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  440376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440399 */     GIR_RootConstrainSelectedInstOperands,
     /*  440400 */     // GIR_Coverage, 6006,
     /*  440400 */     GIR_EraseRootFromParent_Done,
     /*  440401 */   // Label 7655: @440401
     /*  440401 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(440487), // Rule ID 6007 //
     /*  440406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  440417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  440420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  440423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440453 */     // MIs[1] Operand 1
     /*  440453 */     // No operand predicates
     /*  440453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440462 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  440462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  440482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440485 */     GIR_RootConstrainSelectedInstOperands,
     /*  440486 */     // GIR_Coverage, 6007,
     /*  440486 */     GIR_EraseRootFromParent_Done,
     /*  440487 */   // Label 7656: @440487
     /*  440487 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(440573), // Rule ID 6010 //
     /*  440492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440539 */     // MIs[1] Operand 1
     /*  440539 */     // No operand predicates
     /*  440539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440548 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440571 */     GIR_RootConstrainSelectedInstOperands,
     /*  440572 */     // GIR_Coverage, 6010,
     /*  440572 */     GIR_EraseRootFromParent_Done,
     /*  440573 */   // Label 7657: @440573
     /*  440573 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(440659), // Rule ID 6011 //
     /*  440578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440625 */     // MIs[1] Operand 1
     /*  440625 */     // No operand predicates
     /*  440625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440657 */     GIR_RootConstrainSelectedInstOperands,
     /*  440658 */     // GIR_Coverage, 6011,
     /*  440658 */     GIR_EraseRootFromParent_Done,
     /*  440659 */   // Label 7658: @440659
     /*  440659 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(440745), // Rule ID 6014 //
     /*  440664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440711 */     // MIs[1] Operand 1
     /*  440711 */     // No operand predicates
     /*  440711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440720 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440743 */     GIR_RootConstrainSelectedInstOperands,
     /*  440744 */     // GIR_Coverage, 6014,
     /*  440744 */     GIR_EraseRootFromParent_Done,
     /*  440745 */   // Label 7659: @440745
     /*  440745 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(440831), // Rule ID 6015 //
     /*  440750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440797 */     // MIs[1] Operand 1
     /*  440797 */     // No operand predicates
     /*  440797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440806 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440829 */     GIR_RootConstrainSelectedInstOperands,
     /*  440830 */     // GIR_Coverage, 6015,
     /*  440830 */     GIR_EraseRootFromParent_Done,
     /*  440831 */   // Label 7660: @440831
     /*  440831 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(440917), // Rule ID 6018 //
     /*  440836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440883 */     // MIs[1] Operand 1
     /*  440883 */     // No operand predicates
     /*  440883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440892 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440915 */     GIR_RootConstrainSelectedInstOperands,
     /*  440916 */     // GIR_Coverage, 6018,
     /*  440916 */     GIR_EraseRootFromParent_Done,
     /*  440917 */   // Label 7661: @440917
     /*  440917 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(441003), // Rule ID 6019 //
     /*  440922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440969 */     // MIs[1] Operand 1
     /*  440969 */     // No operand predicates
     /*  440969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441001 */     GIR_RootConstrainSelectedInstOperands,
     /*  441002 */     // GIR_Coverage, 6019,
     /*  441002 */     GIR_EraseRootFromParent_Done,
     /*  441003 */   // Label 7662: @441003
     /*  441003 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(441089), // Rule ID 6022 //
     /*  441008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441055 */     // MIs[1] Operand 1
     /*  441055 */     // No operand predicates
     /*  441055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441087 */     GIR_RootConstrainSelectedInstOperands,
     /*  441088 */     // GIR_Coverage, 6022,
     /*  441088 */     GIR_EraseRootFromParent_Done,
     /*  441089 */   // Label 7663: @441089
     /*  441089 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(441175), // Rule ID 6023 //
     /*  441094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  441105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  441108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  441111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  441129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441141 */     // MIs[1] Operand 1
     /*  441141 */     // No operand predicates
     /*  441141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  441153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441173 */     GIR_RootConstrainSelectedInstOperands,
     /*  441174 */     // GIR_Coverage, 6023,
     /*  441174 */     GIR_EraseRootFromParent_Done,
     /*  441175 */   // Label 7664: @441175
     /*  441175 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(441261), // Rule ID 6026 //
     /*  441180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441227 */     // MIs[1] Operand 1
     /*  441227 */     // No operand predicates
     /*  441227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441236 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441259 */     GIR_RootConstrainSelectedInstOperands,
     /*  441260 */     // GIR_Coverage, 6026,
     /*  441260 */     GIR_EraseRootFromParent_Done,
     /*  441261 */   // Label 7665: @441261
     /*  441261 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(441347), // Rule ID 6027 //
     /*  441266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  441277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  441280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  441283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  441301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441313 */     // MIs[1] Operand 1
     /*  441313 */     // No operand predicates
     /*  441313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441322 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  441325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441345 */     GIR_RootConstrainSelectedInstOperands,
     /*  441346 */     // GIR_Coverage, 6027,
     /*  441346 */     GIR_EraseRootFromParent_Done,
     /*  441347 */   // Label 7666: @441347
     /*  441347 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(441433), // Rule ID 6030 //
     /*  441352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  441355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441399 */     // MIs[1] Operand 1
     /*  441399 */     // No operand predicates
     /*  441399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  441408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441431 */     GIR_RootConstrainSelectedInstOperands,
     /*  441432 */     // GIR_Coverage, 6030,
     /*  441432 */     GIR_EraseRootFromParent_Done,
     /*  441433 */   // Label 7667: @441433
     /*  441433 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(441519), // Rule ID 6031 //
     /*  441438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  441441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  441446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  441449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  441452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  441455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  441473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441485 */     // MIs[1] Operand 1
     /*  441485 */     // No operand predicates
     /*  441485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  441494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  441497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441517 */     GIR_RootConstrainSelectedInstOperands,
     /*  441518 */     // GIR_Coverage, 6031,
     /*  441518 */     GIR_EraseRootFromParent_Done,
     /*  441519 */   // Label 7668: @441519
     /*  441519 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(441605), // Rule ID 6210 //
     /*  441524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441571 */     // MIs[1] Operand 1
     /*  441571 */     // No operand predicates
     /*  441571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441580 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  441583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441603 */     GIR_RootConstrainSelectedInstOperands,
     /*  441604 */     // GIR_Coverage, 6210,
     /*  441604 */     GIR_EraseRootFromParent_Done,
     /*  441605 */   // Label 7669: @441605
     /*  441605 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(441691), // Rule ID 6211 //
     /*  441610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441657 */     // MIs[1] Operand 1
     /*  441657 */     // No operand predicates
     /*  441657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441666 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  441669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441689 */     GIR_RootConstrainSelectedInstOperands,
     /*  441690 */     // GIR_Coverage, 6211,
     /*  441690 */     GIR_EraseRootFromParent_Done,
     /*  441691 */   // Label 7670: @441691
     /*  441691 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(441777), // Rule ID 6214 //
     /*  441696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441743 */     // MIs[1] Operand 1
     /*  441743 */     // No operand predicates
     /*  441743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441752 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  441755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441775 */     GIR_RootConstrainSelectedInstOperands,
     /*  441776 */     // GIR_Coverage, 6214,
     /*  441776 */     GIR_EraseRootFromParent_Done,
     /*  441777 */   // Label 7671: @441777
     /*  441777 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(441863), // Rule ID 6215 //
     /*  441782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441829 */     // MIs[1] Operand 1
     /*  441829 */     // No operand predicates
     /*  441829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  441841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441861 */     GIR_RootConstrainSelectedInstOperands,
     /*  441862 */     // GIR_Coverage, 6215,
     /*  441862 */     GIR_EraseRootFromParent_Done,
     /*  441863 */   // Label 7672: @441863
     /*  441863 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(441949), // Rule ID 6218 //
     /*  441868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  441879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  441882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  441885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441915 */     // MIs[1] Operand 1
     /*  441915 */     // No operand predicates
     /*  441915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441924 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  441927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441947 */     GIR_RootConstrainSelectedInstOperands,
     /*  441948 */     // GIR_Coverage, 6218,
     /*  441948 */     GIR_EraseRootFromParent_Done,
     /*  441949 */   // Label 7673: @441949
     /*  441949 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(442035), // Rule ID 6219 //
     /*  441954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  441965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  441968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  441971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442001 */     // MIs[1] Operand 1
     /*  442001 */     // No operand predicates
     /*  442001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442010 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442033 */     GIR_RootConstrainSelectedInstOperands,
     /*  442034 */     // GIR_Coverage, 6219,
     /*  442034 */     GIR_EraseRootFromParent_Done,
     /*  442035 */   // Label 7674: @442035
     /*  442035 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(442121), // Rule ID 6222 //
     /*  442040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442087 */     // MIs[1] Operand 1
     /*  442087 */     // No operand predicates
     /*  442087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442119 */     GIR_RootConstrainSelectedInstOperands,
     /*  442120 */     // GIR_Coverage, 6222,
     /*  442120 */     GIR_EraseRootFromParent_Done,
     /*  442121 */   // Label 7675: @442121
     /*  442121 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(442207), // Rule ID 6223 //
     /*  442126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  442137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  442140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  442143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442173 */     // MIs[1] Operand 1
     /*  442173 */     // No operand predicates
     /*  442173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  442185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442205 */     GIR_RootConstrainSelectedInstOperands,
     /*  442206 */     // GIR_Coverage, 6223,
     /*  442206 */     GIR_EraseRootFromParent_Done,
     /*  442207 */   // Label 7676: @442207
     /*  442207 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(442293), // Rule ID 6226 //
     /*  442212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442259 */     // MIs[1] Operand 1
     /*  442259 */     // No operand predicates
     /*  442259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442268 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442291 */     GIR_RootConstrainSelectedInstOperands,
     /*  442292 */     // GIR_Coverage, 6226,
     /*  442292 */     GIR_EraseRootFromParent_Done,
     /*  442293 */   // Label 7677: @442293
     /*  442293 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(442379), // Rule ID 6227 //
     /*  442298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  442309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  442312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  442315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442345 */     // MIs[1] Operand 1
     /*  442345 */     // No operand predicates
     /*  442345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442354 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442377 */     GIR_RootConstrainSelectedInstOperands,
     /*  442378 */     // GIR_Coverage, 6227,
     /*  442378 */     GIR_EraseRootFromParent_Done,
     /*  442379 */   // Label 7678: @442379
     /*  442379 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(442465), // Rule ID 6230 //
     /*  442384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442431 */     // MIs[1] Operand 1
     /*  442431 */     // No operand predicates
     /*  442431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442463 */     GIR_RootConstrainSelectedInstOperands,
     /*  442464 */     // GIR_Coverage, 6230,
     /*  442464 */     GIR_EraseRootFromParent_Done,
     /*  442465 */   // Label 7679: @442465
     /*  442465 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(442551), // Rule ID 6231 //
     /*  442470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  442481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  442484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  442487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442517 */     // MIs[1] Operand 1
     /*  442517 */     // No operand predicates
     /*  442517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442549 */     GIR_RootConstrainSelectedInstOperands,
     /*  442550 */     // GIR_Coverage, 6231,
     /*  442550 */     GIR_EraseRootFromParent_Done,
     /*  442551 */   // Label 7680: @442551
     /*  442551 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(442637), // Rule ID 6234 //
     /*  442556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442603 */     // MIs[1] Operand 1
     /*  442603 */     // No operand predicates
     /*  442603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442612 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442635 */     GIR_RootConstrainSelectedInstOperands,
     /*  442636 */     // GIR_Coverage, 6234,
     /*  442636 */     GIR_EraseRootFromParent_Done,
     /*  442637 */   // Label 7681: @442637
     /*  442637 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(442723), // Rule ID 6235 //
     /*  442642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442689 */     // MIs[1] Operand 1
     /*  442689 */     // No operand predicates
     /*  442689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442698 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442721 */     GIR_RootConstrainSelectedInstOperands,
     /*  442722 */     // GIR_Coverage, 6235,
     /*  442722 */     GIR_EraseRootFromParent_Done,
     /*  442723 */   // Label 7682: @442723
     /*  442723 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(442809), // Rule ID 6238 //
     /*  442728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442775 */     // MIs[1] Operand 1
     /*  442775 */     // No operand predicates
     /*  442775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442807 */     GIR_RootConstrainSelectedInstOperands,
     /*  442808 */     // GIR_Coverage, 6238,
     /*  442808 */     GIR_EraseRootFromParent_Done,
     /*  442809 */   // Label 7683: @442809
     /*  442809 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(442895), // Rule ID 6239 //
     /*  442814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442861 */     // MIs[1] Operand 1
     /*  442861 */     // No operand predicates
     /*  442861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442893 */     GIR_RootConstrainSelectedInstOperands,
     /*  442894 */     // GIR_Coverage, 6239,
     /*  442894 */     GIR_EraseRootFromParent_Done,
     /*  442895 */   // Label 7684: @442895
     /*  442895 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(442981), // Rule ID 6242 //
     /*  442900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  442911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  442914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  442917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442947 */     // MIs[1] Operand 1
     /*  442947 */     // No operand predicates
     /*  442947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442956 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442979 */     GIR_RootConstrainSelectedInstOperands,
     /*  442980 */     // GIR_Coverage, 6242,
     /*  442980 */     GIR_EraseRootFromParent_Done,
     /*  442981 */   // Label 7685: @442981
     /*  442981 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(443067), // Rule ID 6243 //
     /*  442986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  442997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  443000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  443003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443033 */     // MIs[1] Operand 1
     /*  443033 */     // No operand predicates
     /*  443033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  443042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443065 */     GIR_RootConstrainSelectedInstOperands,
     /*  443066 */     // GIR_Coverage, 6243,
     /*  443066 */     GIR_EraseRootFromParent_Done,
     /*  443067 */   // Label 7686: @443067
     /*  443067 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(443153), // Rule ID 6246 //
     /*  443072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  443075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443119 */     // MIs[1] Operand 1
     /*  443119 */     // No operand predicates
     /*  443119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443128 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  443128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443151 */     GIR_RootConstrainSelectedInstOperands,
     /*  443152 */     // GIR_Coverage, 6246,
     /*  443152 */     GIR_EraseRootFromParent_Done,
     /*  443153 */   // Label 7687: @443153
     /*  443153 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(443239), // Rule ID 6247 //
     /*  443158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  443161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  443169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  443172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  443175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  443193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443205 */     // MIs[1] Operand 1
     /*  443205 */     // No operand predicates
     /*  443205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  443214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  443217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  443234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443237 */     GIR_RootConstrainSelectedInstOperands,
     /*  443238 */     // GIR_Coverage, 6247,
     /*  443238 */     GIR_EraseRootFromParent_Done,
     /*  443239 */   // Label 7688: @443239
     /*  443239 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(443325), // Rule ID 6250 //
     /*  443244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443291 */     // MIs[1] Operand 1
     /*  443291 */     // No operand predicates
     /*  443291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443300 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443323 */     GIR_RootConstrainSelectedInstOperands,
     /*  443324 */     // GIR_Coverage, 6250,
     /*  443324 */     GIR_EraseRootFromParent_Done,
     /*  443325 */   // Label 7689: @443325
     /*  443325 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(443411), // Rule ID 6251 //
     /*  443330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  443341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  443344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  443347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443377 */     // MIs[1] Operand 1
     /*  443377 */     // No operand predicates
     /*  443377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443409 */     GIR_RootConstrainSelectedInstOperands,
     /*  443410 */     // GIR_Coverage, 6251,
     /*  443410 */     GIR_EraseRootFromParent_Done,
     /*  443411 */   // Label 7690: @443411
     /*  443411 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(443497), // Rule ID 6254 //
     /*  443416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443463 */     // MIs[1] Operand 1
     /*  443463 */     // No operand predicates
     /*  443463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443472 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443495 */     GIR_RootConstrainSelectedInstOperands,
     /*  443496 */     // GIR_Coverage, 6254,
     /*  443496 */     GIR_EraseRootFromParent_Done,
     /*  443497 */   // Label 7691: @443497
     /*  443497 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(443583), // Rule ID 6255 //
     /*  443502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443549 */     // MIs[1] Operand 1
     /*  443549 */     // No operand predicates
     /*  443549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443581 */     GIR_RootConstrainSelectedInstOperands,
     /*  443582 */     // GIR_Coverage, 6255,
     /*  443582 */     GIR_EraseRootFromParent_Done,
     /*  443583 */   // Label 7692: @443583
     /*  443583 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(443669), // Rule ID 6258 //
     /*  443588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443635 */     // MIs[1] Operand 1
     /*  443635 */     // No operand predicates
     /*  443635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443644 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  443647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443667 */     GIR_RootConstrainSelectedInstOperands,
     /*  443668 */     // GIR_Coverage, 6258,
     /*  443668 */     GIR_EraseRootFromParent_Done,
     /*  443669 */   // Label 7693: @443669
     /*  443669 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(443755), // Rule ID 6259 //
     /*  443674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443721 */     // MIs[1] Operand 1
     /*  443721 */     // No operand predicates
     /*  443721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443730 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  443733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443753 */     GIR_RootConstrainSelectedInstOperands,
     /*  443754 */     // GIR_Coverage, 6259,
     /*  443754 */     GIR_EraseRootFromParent_Done,
     /*  443755 */   // Label 7694: @443755
     /*  443755 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(443841), // Rule ID 6262 //
     /*  443760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443807 */     // MIs[1] Operand 1
     /*  443807 */     // No operand predicates
     /*  443807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443839 */     GIR_RootConstrainSelectedInstOperands,
     /*  443840 */     // GIR_Coverage, 6262,
     /*  443840 */     GIR_EraseRootFromParent_Done,
     /*  443841 */   // Label 7695: @443841
     /*  443841 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(443927), // Rule ID 6263 //
     /*  443846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443893 */     // MIs[1] Operand 1
     /*  443893 */     // No operand predicates
     /*  443893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443925 */     GIR_RootConstrainSelectedInstOperands,
     /*  443926 */     // GIR_Coverage, 6263,
     /*  443926 */     GIR_EraseRootFromParent_Done,
     /*  443927 */   // Label 7696: @443927
     /*  443927 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(444013), // Rule ID 6266 //
     /*  443932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  443943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  443946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  443949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443979 */     // MIs[1] Operand 1
     /*  443979 */     // No operand predicates
     /*  443979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443988 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444011 */     GIR_RootConstrainSelectedInstOperands,
     /*  444012 */     // GIR_Coverage, 6266,
     /*  444012 */     GIR_EraseRootFromParent_Done,
     /*  444013 */   // Label 7697: @444013
     /*  444013 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(444099), // Rule ID 6267 //
     /*  444018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  444029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  444032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  444035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444065 */     // MIs[1] Operand 1
     /*  444065 */     // No operand predicates
     /*  444065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444097 */     GIR_RootConstrainSelectedInstOperands,
     /*  444098 */     // GIR_Coverage, 6267,
     /*  444098 */     GIR_EraseRootFromParent_Done,
     /*  444099 */   // Label 7698: @444099
     /*  444099 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(444185), // Rule ID 6270 //
     /*  444104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444151 */     // MIs[1] Operand 1
     /*  444151 */     // No operand predicates
     /*  444151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444160 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  444160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444183 */     GIR_RootConstrainSelectedInstOperands,
     /*  444184 */     // GIR_Coverage, 6270,
     /*  444184 */     GIR_EraseRootFromParent_Done,
     /*  444185 */   // Label 7699: @444185
     /*  444185 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(444271), // Rule ID 6271 //
     /*  444190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  444201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  444204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  444207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444237 */     // MIs[1] Operand 1
     /*  444237 */     // No operand predicates
     /*  444237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  444246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  444266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444269 */     GIR_RootConstrainSelectedInstOperands,
     /*  444270 */     // GIR_Coverage, 6271,
     /*  444270 */     GIR_EraseRootFromParent_Done,
     /*  444271 */   // Label 7700: @444271
     /*  444271 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(444357), // Rule ID 6274 //
     /*  444276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444323 */     // MIs[1] Operand 1
     /*  444323 */     // No operand predicates
     /*  444323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444355 */     GIR_RootConstrainSelectedInstOperands,
     /*  444356 */     // GIR_Coverage, 6274,
     /*  444356 */     GIR_EraseRootFromParent_Done,
     /*  444357 */   // Label 7701: @444357
     /*  444357 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(444443), // Rule ID 6275 //
     /*  444362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  444373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  444376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  444379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444409 */     // MIs[1] Operand 1
     /*  444409 */     // No operand predicates
     /*  444409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444441 */     GIR_RootConstrainSelectedInstOperands,
     /*  444442 */     // GIR_Coverage, 6275,
     /*  444442 */     GIR_EraseRootFromParent_Done,
     /*  444443 */   // Label 7702: @444443
     /*  444443 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(444529), // Rule ID 6278 //
     /*  444448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444495 */     // MIs[1] Operand 1
     /*  444495 */     // No operand predicates
     /*  444495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444504 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444527 */     GIR_RootConstrainSelectedInstOperands,
     /*  444528 */     // GIR_Coverage, 6278,
     /*  444528 */     GIR_EraseRootFromParent_Done,
     /*  444529 */   // Label 7703: @444529
     /*  444529 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(444615), // Rule ID 6279 //
     /*  444534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444581 */     // MIs[1] Operand 1
     /*  444581 */     // No operand predicates
     /*  444581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444613 */     GIR_RootConstrainSelectedInstOperands,
     /*  444614 */     // GIR_Coverage, 6279,
     /*  444614 */     GIR_EraseRootFromParent_Done,
     /*  444615 */   // Label 7704: @444615
     /*  444615 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(444701), // Rule ID 6282 //
     /*  444620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444667 */     // MIs[1] Operand 1
     /*  444667 */     // No operand predicates
     /*  444667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444676 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444699 */     GIR_RootConstrainSelectedInstOperands,
     /*  444700 */     // GIR_Coverage, 6282,
     /*  444700 */     GIR_EraseRootFromParent_Done,
     /*  444701 */   // Label 7705: @444701
     /*  444701 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(444787), // Rule ID 6283 //
     /*  444706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444753 */     // MIs[1] Operand 1
     /*  444753 */     // No operand predicates
     /*  444753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444762 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444785 */     GIR_RootConstrainSelectedInstOperands,
     /*  444786 */     // GIR_Coverage, 6283,
     /*  444786 */     GIR_EraseRootFromParent_Done,
     /*  444787 */   // Label 7706: @444787
     /*  444787 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(444873), // Rule ID 6286 //
     /*  444792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  444795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444839 */     // MIs[1] Operand 1
     /*  444839 */     // No operand predicates
     /*  444839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  444848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444871 */     GIR_RootConstrainSelectedInstOperands,
     /*  444872 */     // GIR_Coverage, 6286,
     /*  444872 */     GIR_EraseRootFromParent_Done,
     /*  444873 */   // Label 7707: @444873
     /*  444873 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(444959), // Rule ID 6287 //
     /*  444878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  444881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444925 */     // MIs[1] Operand 1
     /*  444925 */     // No operand predicates
     /*  444925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  444934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444957 */     GIR_RootConstrainSelectedInstOperands,
     /*  444958 */     // GIR_Coverage, 6287,
     /*  444958 */     GIR_EraseRootFromParent_Done,
     /*  444959 */   // Label 7708: @444959
     /*  444959 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(445045), // Rule ID 6290 //
     /*  444964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  444967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  444975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  444978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  444981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445011 */     // MIs[1] Operand 1
     /*  445011 */     // No operand predicates
     /*  445011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445020 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445043 */     GIR_RootConstrainSelectedInstOperands,
     /*  445044 */     // GIR_Coverage, 6290,
     /*  445044 */     GIR_EraseRootFromParent_Done,
     /*  445045 */   // Label 7709: @445045
     /*  445045 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(445131), // Rule ID 6291 //
     /*  445050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  445061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  445064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  445067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  445085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445097 */     // MIs[1] Operand 1
     /*  445097 */     // No operand predicates
     /*  445097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445106 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  445109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445129 */     GIR_RootConstrainSelectedInstOperands,
     /*  445130 */     // GIR_Coverage, 6291,
     /*  445130 */     GIR_EraseRootFromParent_Done,
     /*  445131 */   // Label 7710: @445131
     /*  445131 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(445217), // Rule ID 6294 //
     /*  445136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  445139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445183 */     // MIs[1] Operand 1
     /*  445183 */     // No operand predicates
     /*  445183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445192 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  445192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445215 */     GIR_RootConstrainSelectedInstOperands,
     /*  445216 */     // GIR_Coverage, 6294,
     /*  445216 */     GIR_EraseRootFromParent_Done,
     /*  445217 */   // Label 7711: @445217
     /*  445217 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(445303), // Rule ID 6295 //
     /*  445222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  445225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  445230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  445233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  445236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  445239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  445257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445269 */     // MIs[1] Operand 1
     /*  445269 */     // No operand predicates
     /*  445269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445278 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  445278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  445281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  445298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445301 */     GIR_RootConstrainSelectedInstOperands,
     /*  445302 */     // GIR_Coverage, 6295,
     /*  445302 */     GIR_EraseRootFromParent_Done,
     /*  445303 */   // Label 7712: @445303
     /*  445303 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(445389), // Rule ID 6474 //
     /*  445308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445355 */     // MIs[1] Operand 1
     /*  445355 */     // No operand predicates
     /*  445355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445364 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  445367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445387 */     GIR_RootConstrainSelectedInstOperands,
     /*  445388 */     // GIR_Coverage, 6474,
     /*  445388 */     GIR_EraseRootFromParent_Done,
     /*  445389 */   // Label 7713: @445389
     /*  445389 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(445475), // Rule ID 6475 //
     /*  445394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  445405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  445408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  445411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445441 */     // MIs[1] Operand 1
     /*  445441 */     // No operand predicates
     /*  445441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445450 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  445453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445473 */     GIR_RootConstrainSelectedInstOperands,
     /*  445474 */     // GIR_Coverage, 6475,
     /*  445474 */     GIR_EraseRootFromParent_Done,
     /*  445475 */   // Label 7714: @445475
     /*  445475 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(445561), // Rule ID 6478 //
     /*  445480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445527 */     // MIs[1] Operand 1
     /*  445527 */     // No operand predicates
     /*  445527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445536 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445559 */     GIR_RootConstrainSelectedInstOperands,
     /*  445560 */     // GIR_Coverage, 6478,
     /*  445560 */     GIR_EraseRootFromParent_Done,
     /*  445561 */   // Label 7715: @445561
     /*  445561 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(445647), // Rule ID 6479 //
     /*  445566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445613 */     // MIs[1] Operand 1
     /*  445613 */     // No operand predicates
     /*  445613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445645 */     GIR_RootConstrainSelectedInstOperands,
     /*  445646 */     // GIR_Coverage, 6479,
     /*  445646 */     GIR_EraseRootFromParent_Done,
     /*  445647 */   // Label 7716: @445647
     /*  445647 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(445733), // Rule ID 6482 //
     /*  445652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445699 */     // MIs[1] Operand 1
     /*  445699 */     // No operand predicates
     /*  445699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445708 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445731 */     GIR_RootConstrainSelectedInstOperands,
     /*  445732 */     // GIR_Coverage, 6482,
     /*  445732 */     GIR_EraseRootFromParent_Done,
     /*  445733 */   // Label 7717: @445733
     /*  445733 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(445819), // Rule ID 6483 //
     /*  445738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445785 */     // MIs[1] Operand 1
     /*  445785 */     // No operand predicates
     /*  445785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445794 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445817 */     GIR_RootConstrainSelectedInstOperands,
     /*  445818 */     // GIR_Coverage, 6483,
     /*  445818 */     GIR_EraseRootFromParent_Done,
     /*  445819 */   // Label 7718: @445819
     /*  445819 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(445905), // Rule ID 6486 //
     /*  445824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445871 */     // MIs[1] Operand 1
     /*  445871 */     // No operand predicates
     /*  445871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445880 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  445880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445903 */     GIR_RootConstrainSelectedInstOperands,
     /*  445904 */     // GIR_Coverage, 6486,
     /*  445904 */     GIR_EraseRootFromParent_Done,
     /*  445905 */   // Label 7719: @445905
     /*  445905 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(445991), // Rule ID 6487 //
     /*  445910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445957 */     // MIs[1] Operand 1
     /*  445957 */     // No operand predicates
     /*  445957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445966 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  445966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445989 */     GIR_RootConstrainSelectedInstOperands,
     /*  445990 */     // GIR_Coverage, 6487,
     /*  445990 */     GIR_EraseRootFromParent_Done,
     /*  445991 */   // Label 7720: @445991
     /*  445991 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(446077), // Rule ID 6490 //
     /*  445996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446043 */     // MIs[1] Operand 1
     /*  446043 */     // No operand predicates
     /*  446043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446075 */     GIR_RootConstrainSelectedInstOperands,
     /*  446076 */     // GIR_Coverage, 6490,
     /*  446076 */     GIR_EraseRootFromParent_Done,
     /*  446077 */   // Label 7721: @446077
     /*  446077 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(446163), // Rule ID 6491 //
     /*  446082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  446093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  446096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  446099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446129 */     // MIs[1] Operand 1
     /*  446129 */     // No operand predicates
     /*  446129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446138 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446161 */     GIR_RootConstrainSelectedInstOperands,
     /*  446162 */     // GIR_Coverage, 6491,
     /*  446162 */     GIR_EraseRootFromParent_Done,
     /*  446163 */   // Label 7722: @446163
     /*  446163 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(446249), // Rule ID 6494 //
     /*  446168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446215 */     // MIs[1] Operand 1
     /*  446215 */     // No operand predicates
     /*  446215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446224 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446247 */     GIR_RootConstrainSelectedInstOperands,
     /*  446248 */     // GIR_Coverage, 6494,
     /*  446248 */     GIR_EraseRootFromParent_Done,
     /*  446249 */   // Label 7723: @446249
     /*  446249 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(446335), // Rule ID 6495 //
     /*  446254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  446265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  446268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  446271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446301 */     // MIs[1] Operand 1
     /*  446301 */     // No operand predicates
     /*  446301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  446313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446333 */     GIR_RootConstrainSelectedInstOperands,
     /*  446334 */     // GIR_Coverage, 6495,
     /*  446334 */     GIR_EraseRootFromParent_Done,
     /*  446335 */   // Label 7724: @446335
     /*  446335 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(446421), // Rule ID 6498 //
     /*  446340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446387 */     // MIs[1] Operand 1
     /*  446387 */     // No operand predicates
     /*  446387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446419 */     GIR_RootConstrainSelectedInstOperands,
     /*  446420 */     // GIR_Coverage, 6498,
     /*  446420 */     GIR_EraseRootFromParent_Done,
     /*  446421 */   // Label 7725: @446421
     /*  446421 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(446507), // Rule ID 6499 //
     /*  446426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  446437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  446440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  446443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446473 */     // MIs[1] Operand 1
     /*  446473 */     // No operand predicates
     /*  446473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446505 */     GIR_RootConstrainSelectedInstOperands,
     /*  446506 */     // GIR_Coverage, 6499,
     /*  446506 */     GIR_EraseRootFromParent_Done,
     /*  446507 */   // Label 7726: @446507
     /*  446507 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(446593), // Rule ID 6502 //
     /*  446512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446559 */     // MIs[1] Operand 1
     /*  446559 */     // No operand predicates
     /*  446559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446591 */     GIR_RootConstrainSelectedInstOperands,
     /*  446592 */     // GIR_Coverage, 6502,
     /*  446592 */     GIR_EraseRootFromParent_Done,
     /*  446593 */   // Label 7727: @446593
     /*  446593 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(446679), // Rule ID 6503 //
     /*  446598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446645 */     // MIs[1] Operand 1
     /*  446645 */     // No operand predicates
     /*  446645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446677 */     GIR_RootConstrainSelectedInstOperands,
     /*  446678 */     // GIR_Coverage, 6503,
     /*  446678 */     GIR_EraseRootFromParent_Done,
     /*  446679 */   // Label 7728: @446679
     /*  446679 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(446765), // Rule ID 6506 //
     /*  446684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446731 */     // MIs[1] Operand 1
     /*  446731 */     // No operand predicates
     /*  446731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446763 */     GIR_RootConstrainSelectedInstOperands,
     /*  446764 */     // GIR_Coverage, 6506,
     /*  446764 */     GIR_EraseRootFromParent_Done,
     /*  446765 */   // Label 7729: @446765
     /*  446765 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(446851), // Rule ID 6507 //
     /*  446770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446817 */     // MIs[1] Operand 1
     /*  446817 */     // No operand predicates
     /*  446817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446849 */     GIR_RootConstrainSelectedInstOperands,
     /*  446850 */     // GIR_Coverage, 6507,
     /*  446850 */     GIR_EraseRootFromParent_Done,
     /*  446851 */   // Label 7730: @446851
     /*  446851 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(446937), // Rule ID 6510 //
     /*  446856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  446859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  446873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446903 */     // MIs[1] Operand 1
     /*  446903 */     // No operand predicates
     /*  446903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  446912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  446932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446935 */     GIR_RootConstrainSelectedInstOperands,
     /*  446936 */     // GIR_Coverage, 6510,
     /*  446936 */     GIR_EraseRootFromParent_Done,
     /*  446937 */   // Label 7731: @446937
     /*  446937 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(447023), // Rule ID 6511 //
     /*  446942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  446945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  446959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446989 */     // MIs[1] Operand 1
     /*  446989 */     // No operand predicates
     /*  446989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446998 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  446998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  447001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  447018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447021 */     GIR_RootConstrainSelectedInstOperands,
     /*  447022 */     // GIR_Coverage, 6511,
     /*  447022 */     GIR_EraseRootFromParent_Done,
     /*  447023 */   // Label 7732: @447023
     /*  447023 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(447109), // Rule ID 6514 //
     /*  447028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447075 */     // MIs[1] Operand 1
     /*  447075 */     // No operand predicates
     /*  447075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447084 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447107 */     GIR_RootConstrainSelectedInstOperands,
     /*  447108 */     // GIR_Coverage, 6514,
     /*  447108 */     GIR_EraseRootFromParent_Done,
     /*  447109 */   // Label 7733: @447109
     /*  447109 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(447195), // Rule ID 6515 //
     /*  447114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  447125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  447128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  447131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447161 */     // MIs[1] Operand 1
     /*  447161 */     // No operand predicates
     /*  447161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447170 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447193 */     GIR_RootConstrainSelectedInstOperands,
     /*  447194 */     // GIR_Coverage, 6515,
     /*  447194 */     GIR_EraseRootFromParent_Done,
     /*  447195 */   // Label 7734: @447195
     /*  447195 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(447281), // Rule ID 6518 //
     /*  447200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447247 */     // MIs[1] Operand 1
     /*  447247 */     // No operand predicates
     /*  447247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447256 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447279 */     GIR_RootConstrainSelectedInstOperands,
     /*  447280 */     // GIR_Coverage, 6518,
     /*  447280 */     GIR_EraseRootFromParent_Done,
     /*  447281 */   // Label 7735: @447281
     /*  447281 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(447367), // Rule ID 6519 //
     /*  447286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  447297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  447300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  447303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447333 */     // MIs[1] Operand 1
     /*  447333 */     // No operand predicates
     /*  447333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447342 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447365 */     GIR_RootConstrainSelectedInstOperands,
     /*  447366 */     // GIR_Coverage, 6519,
     /*  447366 */     GIR_EraseRootFromParent_Done,
     /*  447367 */   // Label 7736: @447367
     /*  447367 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(447453), // Rule ID 6522 //
     /*  447372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447419 */     // MIs[1] Operand 1
     /*  447419 */     // No operand predicates
     /*  447419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447428 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  447428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447451 */     GIR_RootConstrainSelectedInstOperands,
     /*  447452 */     // GIR_Coverage, 6522,
     /*  447452 */     GIR_EraseRootFromParent_Done,
     /*  447453 */   // Label 7737: @447453
     /*  447453 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(447539), // Rule ID 6523 //
     /*  447458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  447469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  447472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  447475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447505 */     // MIs[1] Operand 1
     /*  447505 */     // No operand predicates
     /*  447505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447537 */     GIR_RootConstrainSelectedInstOperands,
     /*  447538 */     // GIR_Coverage, 6523,
     /*  447538 */     GIR_EraseRootFromParent_Done,
     /*  447539 */   // Label 7738: @447539
     /*  447539 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(447625), // Rule ID 6526 //
     /*  447544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447591 */     // MIs[1] Operand 1
     /*  447591 */     // No operand predicates
     /*  447591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447623 */     GIR_RootConstrainSelectedInstOperands,
     /*  447624 */     // GIR_Coverage, 6526,
     /*  447624 */     GIR_EraseRootFromParent_Done,
     /*  447625 */   // Label 7739: @447625
     /*  447625 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(447711), // Rule ID 6527 //
     /*  447630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447677 */     // MIs[1] Operand 1
     /*  447677 */     // No operand predicates
     /*  447677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447709 */     GIR_RootConstrainSelectedInstOperands,
     /*  447710 */     // GIR_Coverage, 6527,
     /*  447710 */     GIR_EraseRootFromParent_Done,
     /*  447711 */   // Label 7740: @447711
     /*  447711 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(447797), // Rule ID 6530 //
     /*  447716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447763 */     // MIs[1] Operand 1
     /*  447763 */     // No operand predicates
     /*  447763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447772 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447795 */     GIR_RootConstrainSelectedInstOperands,
     /*  447796 */     // GIR_Coverage, 6530,
     /*  447796 */     GIR_EraseRootFromParent_Done,
     /*  447797 */   // Label 7741: @447797
     /*  447797 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(447883), // Rule ID 6531 //
     /*  447802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447849 */     // MIs[1] Operand 1
     /*  447849 */     // No operand predicates
     /*  447849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447881 */     GIR_RootConstrainSelectedInstOperands,
     /*  447882 */     // GIR_Coverage, 6531,
     /*  447882 */     GIR_EraseRootFromParent_Done,
     /*  447883 */   // Label 7742: @447883
     /*  447883 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(447969), // Rule ID 6534 //
     /*  447888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  447899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  447902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  447905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447935 */     // MIs[1] Operand 1
     /*  447935 */     // No operand predicates
     /*  447935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447944 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447967 */     GIR_RootConstrainSelectedInstOperands,
     /*  447968 */     // GIR_Coverage, 6534,
     /*  447968 */     GIR_EraseRootFromParent_Done,
     /*  447969 */   // Label 7743: @447969
     /*  447969 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(448055), // Rule ID 6535 //
     /*  447974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  447985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  447988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  447991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448021 */     // MIs[1] Operand 1
     /*  448021 */     // No operand predicates
     /*  448021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448030 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  448030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  448050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448053 */     GIR_RootConstrainSelectedInstOperands,
     /*  448054 */     // GIR_Coverage, 6535,
     /*  448054 */     GIR_EraseRootFromParent_Done,
     /*  448055 */   // Label 7744: @448055
     /*  448055 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(448141), // Rule ID 6538 //
     /*  448060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448107 */     // MIs[1] Operand 1
     /*  448107 */     // No operand predicates
     /*  448107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448139 */     GIR_RootConstrainSelectedInstOperands,
     /*  448140 */     // GIR_Coverage, 6538,
     /*  448140 */     GIR_EraseRootFromParent_Done,
     /*  448141 */   // Label 7745: @448141
     /*  448141 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(448227), // Rule ID 6539 //
     /*  448146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  448157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  448160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  448163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448193 */     // MIs[1] Operand 1
     /*  448193 */     // No operand predicates
     /*  448193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448225 */     GIR_RootConstrainSelectedInstOperands,
     /*  448226 */     // GIR_Coverage, 6539,
     /*  448226 */     GIR_EraseRootFromParent_Done,
     /*  448227 */   // Label 7746: @448227
     /*  448227 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(448313), // Rule ID 6542 //
     /*  448232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448279 */     // MIs[1] Operand 1
     /*  448279 */     // No operand predicates
     /*  448279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448288 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448311 */     GIR_RootConstrainSelectedInstOperands,
     /*  448312 */     // GIR_Coverage, 6542,
     /*  448312 */     GIR_EraseRootFromParent_Done,
     /*  448313 */   // Label 7747: @448313
     /*  448313 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(448399), // Rule ID 6543 //
     /*  448318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  448329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  448332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  448335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448365 */     // MIs[1] Operand 1
     /*  448365 */     // No operand predicates
     /*  448365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448397 */     GIR_RootConstrainSelectedInstOperands,
     /*  448398 */     // GIR_Coverage, 6543,
     /*  448398 */     GIR_EraseRootFromParent_Done,
     /*  448399 */   // Label 7748: @448399
     /*  448399 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(448485), // Rule ID 6546 //
     /*  448404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448451 */     // MIs[1] Operand 1
     /*  448451 */     // No operand predicates
     /*  448451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448460 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  448460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448483 */     GIR_RootConstrainSelectedInstOperands,
     /*  448484 */     // GIR_Coverage, 6546,
     /*  448484 */     GIR_EraseRootFromParent_Done,
     /*  448485 */   // Label 7749: @448485
     /*  448485 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(448571), // Rule ID 6547 //
     /*  448490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  448501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  448504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  448507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448537 */     // MIs[1] Operand 1
     /*  448537 */     // No operand predicates
     /*  448537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448569 */     GIR_RootConstrainSelectedInstOperands,
     /*  448570 */     // GIR_Coverage, 6547,
     /*  448570 */     GIR_EraseRootFromParent_Done,
     /*  448571 */   // Label 7750: @448571
     /*  448571 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(448657), // Rule ID 6550 //
     /*  448576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448623 */     // MIs[1] Operand 1
     /*  448623 */     // No operand predicates
     /*  448623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448632 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448655 */     GIR_RootConstrainSelectedInstOperands,
     /*  448656 */     // GIR_Coverage, 6550,
     /*  448656 */     GIR_EraseRootFromParent_Done,
     /*  448657 */   // Label 7751: @448657
     /*  448657 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(448743), // Rule ID 6551 //
     /*  448662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448709 */     // MIs[1] Operand 1
     /*  448709 */     // No operand predicates
     /*  448709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448741 */     GIR_RootConstrainSelectedInstOperands,
     /*  448742 */     // GIR_Coverage, 6551,
     /*  448742 */     GIR_EraseRootFromParent_Done,
     /*  448743 */   // Label 7752: @448743
     /*  448743 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(448829), // Rule ID 6554 //
     /*  448748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448795 */     // MIs[1] Operand 1
     /*  448795 */     // No operand predicates
     /*  448795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448804 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448827 */     GIR_RootConstrainSelectedInstOperands,
     /*  448828 */     // GIR_Coverage, 6554,
     /*  448828 */     GIR_EraseRootFromParent_Done,
     /*  448829 */   // Label 7753: @448829
     /*  448829 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(448915), // Rule ID 6555 //
     /*  448834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448881 */     // MIs[1] Operand 1
     /*  448881 */     // No operand predicates
     /*  448881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448890 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448913 */     GIR_RootConstrainSelectedInstOperands,
     /*  448914 */     // GIR_Coverage, 6555,
     /*  448914 */     GIR_EraseRootFromParent_Done,
     /*  448915 */   // Label 7754: @448915
     /*  448915 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(449001), // Rule ID 6558 //
     /*  448920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  448931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  448934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  448937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448967 */     // MIs[1] Operand 1
     /*  448967 */     // No operand predicates
     /*  448967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448976 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448999 */     GIR_RootConstrainSelectedInstOperands,
     /*  449000 */     // GIR_Coverage, 6558,
     /*  449000 */     GIR_EraseRootFromParent_Done,
     /*  449001 */   // Label 7755: @449001
     /*  449001 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(449087), // Rule ID 6559 //
     /*  449006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  449009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  449014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  449017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  449020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  449023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  449041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  449053 */     // MIs[1] Operand 1
     /*  449053 */     // No operand predicates
     /*  449053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449062 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  449062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  449065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  449082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449085 */     GIR_RootConstrainSelectedInstOperands,
     /*  449086 */     // GIR_Coverage, 6559,
     /*  449086 */     GIR_EraseRootFromParent_Done,
     /*  449087 */   // Label 7756: @449087
     /*  449087 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(449173), // Rule ID 6738 //
     /*  449092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449139 */     // MIs[1] Operand 1
     /*  449139 */     // No operand predicates
     /*  449139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449148 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  449151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449171 */     GIR_RootConstrainSelectedInstOperands,
     /*  449172 */     // GIR_Coverage, 6738,
     /*  449172 */     GIR_EraseRootFromParent_Done,
     /*  449173 */   // Label 7757: @449173
     /*  449173 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(449259), // Rule ID 6739 //
     /*  449178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  449189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  449192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  449195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449225 */     // MIs[1] Operand 1
     /*  449225 */     // No operand predicates
     /*  449225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449234 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  449237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449257 */     GIR_RootConstrainSelectedInstOperands,
     /*  449258 */     // GIR_Coverage, 6739,
     /*  449258 */     GIR_EraseRootFromParent_Done,
     /*  449259 */   // Label 7758: @449259
     /*  449259 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(449345), // Rule ID 6742 //
     /*  449264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449311 */     // MIs[1] Operand 1
     /*  449311 */     // No operand predicates
     /*  449311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449320 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449343 */     GIR_RootConstrainSelectedInstOperands,
     /*  449344 */     // GIR_Coverage, 6742,
     /*  449344 */     GIR_EraseRootFromParent_Done,
     /*  449345 */   // Label 7759: @449345
     /*  449345 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(449431), // Rule ID 6743 //
     /*  449350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  449361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  449364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  449367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449397 */     // MIs[1] Operand 1
     /*  449397 */     // No operand predicates
     /*  449397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449406 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449429 */     GIR_RootConstrainSelectedInstOperands,
     /*  449430 */     // GIR_Coverage, 6743,
     /*  449430 */     GIR_EraseRootFromParent_Done,
     /*  449431 */   // Label 7760: @449431
     /*  449431 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(449517), // Rule ID 6746 //
     /*  449436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449483 */     // MIs[1] Operand 1
     /*  449483 */     // No operand predicates
     /*  449483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449515 */     GIR_RootConstrainSelectedInstOperands,
     /*  449516 */     // GIR_Coverage, 6746,
     /*  449516 */     GIR_EraseRootFromParent_Done,
     /*  449517 */   // Label 7761: @449517
     /*  449517 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(449603), // Rule ID 6747 //
     /*  449522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449569 */     // MIs[1] Operand 1
     /*  449569 */     // No operand predicates
     /*  449569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449578 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449601 */     GIR_RootConstrainSelectedInstOperands,
     /*  449602 */     // GIR_Coverage, 6747,
     /*  449602 */     GIR_EraseRootFromParent_Done,
     /*  449603 */   // Label 7762: @449603
     /*  449603 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(449689), // Rule ID 6750 //
     /*  449608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449655 */     // MIs[1] Operand 1
     /*  449655 */     // No operand predicates
     /*  449655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449664 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449687 */     GIR_RootConstrainSelectedInstOperands,
     /*  449688 */     // GIR_Coverage, 6750,
     /*  449688 */     GIR_EraseRootFromParent_Done,
     /*  449689 */   // Label 7763: @449689
     /*  449689 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(449775), // Rule ID 6751 //
     /*  449694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449741 */     // MIs[1] Operand 1
     /*  449741 */     // No operand predicates
     /*  449741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449750 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449773 */     GIR_RootConstrainSelectedInstOperands,
     /*  449774 */     // GIR_Coverage, 6751,
     /*  449774 */     GIR_EraseRootFromParent_Done,
     /*  449775 */   // Label 7764: @449775
     /*  449775 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(449861), // Rule ID 6754 //
     /*  449780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449827 */     // MIs[1] Operand 1
     /*  449827 */     // No operand predicates
     /*  449827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449836 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449859 */     GIR_RootConstrainSelectedInstOperands,
     /*  449860 */     // GIR_Coverage, 6754,
     /*  449860 */     GIR_EraseRootFromParent_Done,
     /*  449861 */   // Label 7765: @449861
     /*  449861 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(449947), // Rule ID 6755 //
     /*  449866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449913 */     // MIs[1] Operand 1
     /*  449913 */     // No operand predicates
     /*  449913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449945 */     GIR_RootConstrainSelectedInstOperands,
     /*  449946 */     // GIR_Coverage, 6755,
     /*  449946 */     GIR_EraseRootFromParent_Done,
     /*  449947 */   // Label 7766: @449947
     /*  449947 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(450033), // Rule ID 6758 //
     /*  449952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  449963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  449966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  449969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449999 */     // MIs[1] Operand 1
     /*  449999 */     // No operand predicates
     /*  449999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450008 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450031 */     GIR_RootConstrainSelectedInstOperands,
     /*  450032 */     // GIR_Coverage, 6758,
     /*  450032 */     GIR_EraseRootFromParent_Done,
     /*  450033 */   // Label 7767: @450033
     /*  450033 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(450119), // Rule ID 6759 //
     /*  450038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  450049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  450052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  450055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450085 */     // MIs[1] Operand 1
     /*  450085 */     // No operand predicates
     /*  450085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450094 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  450097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450117 */     GIR_RootConstrainSelectedInstOperands,
     /*  450118 */     // GIR_Coverage, 6759,
     /*  450118 */     GIR_EraseRootFromParent_Done,
     /*  450119 */   // Label 7768: @450119
     /*  450119 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(450205), // Rule ID 6762 //
     /*  450124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450171 */     // MIs[1] Operand 1
     /*  450171 */     // No operand predicates
     /*  450171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450180 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450203 */     GIR_RootConstrainSelectedInstOperands,
     /*  450204 */     // GIR_Coverage, 6762,
     /*  450204 */     GIR_EraseRootFromParent_Done,
     /*  450205 */   // Label 7769: @450205
     /*  450205 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(450291), // Rule ID 6763 //
     /*  450210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  450221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  450224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  450227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450257 */     // MIs[1] Operand 1
     /*  450257 */     // No operand predicates
     /*  450257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450289 */     GIR_RootConstrainSelectedInstOperands,
     /*  450290 */     // GIR_Coverage, 6763,
     /*  450290 */     GIR_EraseRootFromParent_Done,
     /*  450291 */   // Label 7770: @450291
     /*  450291 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(450377), // Rule ID 6766 //
     /*  450296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450343 */     // MIs[1] Operand 1
     /*  450343 */     // No operand predicates
     /*  450343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450375 */     GIR_RootConstrainSelectedInstOperands,
     /*  450376 */     // GIR_Coverage, 6766,
     /*  450376 */     GIR_EraseRootFromParent_Done,
     /*  450377 */   // Label 7771: @450377
     /*  450377 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(450463), // Rule ID 6767 //
     /*  450382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  450393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  450396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  450399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450429 */     // MIs[1] Operand 1
     /*  450429 */     // No operand predicates
     /*  450429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450438 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450461 */     GIR_RootConstrainSelectedInstOperands,
     /*  450462 */     // GIR_Coverage, 6767,
     /*  450462 */     GIR_EraseRootFromParent_Done,
     /*  450463 */   // Label 7772: @450463
     /*  450463 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(450549), // Rule ID 6770 //
     /*  450468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450515 */     // MIs[1] Operand 1
     /*  450515 */     // No operand predicates
     /*  450515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450547 */     GIR_RootConstrainSelectedInstOperands,
     /*  450548 */     // GIR_Coverage, 6770,
     /*  450548 */     GIR_EraseRootFromParent_Done,
     /*  450549 */   // Label 7773: @450549
     /*  450549 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(450635), // Rule ID 6771 //
     /*  450554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450601 */     // MIs[1] Operand 1
     /*  450601 */     // No operand predicates
     /*  450601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450610 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450633 */     GIR_RootConstrainSelectedInstOperands,
     /*  450634 */     // GIR_Coverage, 6771,
     /*  450634 */     GIR_EraseRootFromParent_Done,
     /*  450635 */   // Label 7774: @450635
     /*  450635 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(450721), // Rule ID 6774 //
     /*  450640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  450643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450687 */     // MIs[1] Operand 1
     /*  450687 */     // No operand predicates
     /*  450687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450696 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  450696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450719 */     GIR_RootConstrainSelectedInstOperands,
     /*  450720 */     // GIR_Coverage, 6774,
     /*  450720 */     GIR_EraseRootFromParent_Done,
     /*  450721 */   // Label 7775: @450721
     /*  450721 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(450807), // Rule ID 6775 //
     /*  450726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  450729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450773 */     // MIs[1] Operand 1
     /*  450773 */     // No operand predicates
     /*  450773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  450782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450805 */     GIR_RootConstrainSelectedInstOperands,
     /*  450806 */     // GIR_Coverage, 6775,
     /*  450806 */     GIR_EraseRootFromParent_Done,
     /*  450807 */   // Label 7776: @450807
     /*  450807 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(450893), // Rule ID 6778 //
     /*  450812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450859 */     // MIs[1] Operand 1
     /*  450859 */     // No operand predicates
     /*  450859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450868 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  450871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450891 */     GIR_RootConstrainSelectedInstOperands,
     /*  450892 */     // GIR_Coverage, 6778,
     /*  450892 */     GIR_EraseRootFromParent_Done,
     /*  450893 */   // Label 7777: @450893
     /*  450893 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(450979), // Rule ID 6779 //
     /*  450898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450945 */     // MIs[1] Operand 1
     /*  450945 */     // No operand predicates
     /*  450945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450954 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  450957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450977 */     GIR_RootConstrainSelectedInstOperands,
     /*  450978 */     // GIR_Coverage, 6779,
     /*  450978 */     GIR_EraseRootFromParent_Done,
     /*  450979 */   // Label 7778: @450979
     /*  450979 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(451065), // Rule ID 6782 //
     /*  450984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  450995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  450998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451031 */     // MIs[1] Operand 1
     /*  451031 */     // No operand predicates
     /*  451031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451040 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451063 */     GIR_RootConstrainSelectedInstOperands,
     /*  451064 */     // GIR_Coverage, 6782,
     /*  451064 */     GIR_EraseRootFromParent_Done,
     /*  451065 */   // Label 7779: @451065
     /*  451065 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(451151), // Rule ID 6783 //
     /*  451070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  451081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  451084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  451087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451117 */     // MIs[1] Operand 1
     /*  451117 */     // No operand predicates
     /*  451117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451149 */     GIR_RootConstrainSelectedInstOperands,
     /*  451150 */     // GIR_Coverage, 6783,
     /*  451150 */     GIR_EraseRootFromParent_Done,
     /*  451151 */   // Label 7780: @451151
     /*  451151 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(451237), // Rule ID 6786 //
     /*  451156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451203 */     // MIs[1] Operand 1
     /*  451203 */     // No operand predicates
     /*  451203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451212 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  451212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451235 */     GIR_RootConstrainSelectedInstOperands,
     /*  451236 */     // GIR_Coverage, 6786,
     /*  451236 */     GIR_EraseRootFromParent_Done,
     /*  451237 */   // Label 7781: @451237
     /*  451237 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(451323), // Rule ID 6787 //
     /*  451242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  451253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  451256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  451259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451289 */     // MIs[1] Operand 1
     /*  451289 */     // No operand predicates
     /*  451289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451298 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  451298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  451318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451321 */     GIR_RootConstrainSelectedInstOperands,
     /*  451322 */     // GIR_Coverage, 6787,
     /*  451322 */     GIR_EraseRootFromParent_Done,
     /*  451323 */   // Label 7782: @451323
     /*  451323 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(451409), // Rule ID 6790 //
     /*  451328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451375 */     // MIs[1] Operand 1
     /*  451375 */     // No operand predicates
     /*  451375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451407 */     GIR_RootConstrainSelectedInstOperands,
     /*  451408 */     // GIR_Coverage, 6790,
     /*  451408 */     GIR_EraseRootFromParent_Done,
     /*  451409 */   // Label 7783: @451409
     /*  451409 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(451495), // Rule ID 6791 //
     /*  451414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  451425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  451428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  451431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451461 */     // MIs[1] Operand 1
     /*  451461 */     // No operand predicates
     /*  451461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451493 */     GIR_RootConstrainSelectedInstOperands,
     /*  451494 */     // GIR_Coverage, 6791,
     /*  451494 */     GIR_EraseRootFromParent_Done,
     /*  451495 */   // Label 7784: @451495
     /*  451495 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(451581), // Rule ID 6794 //
     /*  451500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451547 */     // MIs[1] Operand 1
     /*  451547 */     // No operand predicates
     /*  451547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451579 */     GIR_RootConstrainSelectedInstOperands,
     /*  451580 */     // GIR_Coverage, 6794,
     /*  451580 */     GIR_EraseRootFromParent_Done,
     /*  451581 */   // Label 7785: @451581
     /*  451581 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(451667), // Rule ID 6795 //
     /*  451586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451633 */     // MIs[1] Operand 1
     /*  451633 */     // No operand predicates
     /*  451633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451642 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451665 */     GIR_RootConstrainSelectedInstOperands,
     /*  451666 */     // GIR_Coverage, 6795,
     /*  451666 */     GIR_EraseRootFromParent_Done,
     /*  451667 */   // Label 7786: @451667
     /*  451667 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(451753), // Rule ID 6798 //
     /*  451672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451719 */     // MIs[1] Operand 1
     /*  451719 */     // No operand predicates
     /*  451719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451728 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451751 */     GIR_RootConstrainSelectedInstOperands,
     /*  451752 */     // GIR_Coverage, 6798,
     /*  451752 */     GIR_EraseRootFromParent_Done,
     /*  451753 */   // Label 7787: @451753
     /*  451753 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(451839), // Rule ID 6799 //
     /*  451758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451805 */     // MIs[1] Operand 1
     /*  451805 */     // No operand predicates
     /*  451805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451837 */     GIR_RootConstrainSelectedInstOperands,
     /*  451838 */     // GIR_Coverage, 6799,
     /*  451838 */     GIR_EraseRootFromParent_Done,
     /*  451839 */   // Label 7788: @451839
     /*  451839 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(451925), // Rule ID 6802 //
     /*  451844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  451855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  451858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  451861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451891 */     // MIs[1] Operand 1
     /*  451891 */     // No operand predicates
     /*  451891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451923 */     GIR_RootConstrainSelectedInstOperands,
     /*  451924 */     // GIR_Coverage, 6802,
     /*  451924 */     GIR_EraseRootFromParent_Done,
     /*  451925 */   // Label 7789: @451925
     /*  451925 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(452011), // Rule ID 6803 //
     /*  451930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  451941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  451944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  451947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451977 */     // MIs[1] Operand 1
     /*  451977 */     // No operand predicates
     /*  451977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452009 */     GIR_RootConstrainSelectedInstOperands,
     /*  452010 */     // GIR_Coverage, 6803,
     /*  452010 */     GIR_EraseRootFromParent_Done,
     /*  452011 */   // Label 7790: @452011
     /*  452011 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(452097), // Rule ID 6806 //
     /*  452016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452063 */     // MIs[1] Operand 1
     /*  452063 */     // No operand predicates
     /*  452063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452072 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452095 */     GIR_RootConstrainSelectedInstOperands,
     /*  452096 */     // GIR_Coverage, 6806,
     /*  452096 */     GIR_EraseRootFromParent_Done,
     /*  452097 */   // Label 7791: @452097
     /*  452097 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(452183), // Rule ID 6807 //
     /*  452102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  452113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  452116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  452119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452149 */     // MIs[1] Operand 1
     /*  452149 */     // No operand predicates
     /*  452149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452181 */     GIR_RootConstrainSelectedInstOperands,
     /*  452182 */     // GIR_Coverage, 6807,
     /*  452182 */     GIR_EraseRootFromParent_Done,
     /*  452183 */   // Label 7792: @452183
     /*  452183 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(452269), // Rule ID 6810 //
     /*  452188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452235 */     // MIs[1] Operand 1
     /*  452235 */     // No operand predicates
     /*  452235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  452244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452267 */     GIR_RootConstrainSelectedInstOperands,
     /*  452268 */     // GIR_Coverage, 6810,
     /*  452268 */     GIR_EraseRootFromParent_Done,
     /*  452269 */   // Label 7793: @452269
     /*  452269 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(452355), // Rule ID 6811 //
     /*  452274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  452285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  452288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  452291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452321 */     // MIs[1] Operand 1
     /*  452321 */     // No operand predicates
     /*  452321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  452330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  452350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452353 */     GIR_RootConstrainSelectedInstOperands,
     /*  452354 */     // GIR_Coverage, 6811,
     /*  452354 */     GIR_EraseRootFromParent_Done,
     /*  452355 */   // Label 7794: @452355
     /*  452355 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(452441), // Rule ID 6814 //
     /*  452360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452407 */     // MIs[1] Operand 1
     /*  452407 */     // No operand predicates
     /*  452407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452439 */     GIR_RootConstrainSelectedInstOperands,
     /*  452440 */     // GIR_Coverage, 6814,
     /*  452440 */     GIR_EraseRootFromParent_Done,
     /*  452441 */   // Label 7795: @452441
     /*  452441 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(452527), // Rule ID 6815 //
     /*  452446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  452457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  452460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  452463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  452481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452493 */     // MIs[1] Operand 1
     /*  452493 */     // No operand predicates
     /*  452493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  452505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452525 */     GIR_RootConstrainSelectedInstOperands,
     /*  452526 */     // GIR_Coverage, 6815,
     /*  452526 */     GIR_EraseRootFromParent_Done,
     /*  452527 */   // Label 7796: @452527
     /*  452527 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(452613), // Rule ID 6818 //
     /*  452532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452579 */     // MIs[1] Operand 1
     /*  452579 */     // No operand predicates
     /*  452579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452588 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452611 */     GIR_RootConstrainSelectedInstOperands,
     /*  452612 */     // GIR_Coverage, 6818,
     /*  452612 */     GIR_EraseRootFromParent_Done,
     /*  452613 */   // Label 7797: @452613
     /*  452613 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(452699), // Rule ID 6819 //
     /*  452618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452665 */     // MIs[1] Operand 1
     /*  452665 */     // No operand predicates
     /*  452665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452674 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452697 */     GIR_RootConstrainSelectedInstOperands,
     /*  452698 */     // GIR_Coverage, 6819,
     /*  452698 */     GIR_EraseRootFromParent_Done,
     /*  452699 */   // Label 7798: @452699
     /*  452699 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(452785), // Rule ID 6822 //
     /*  452704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452751 */     // MIs[1] Operand 1
     /*  452751 */     // No operand predicates
     /*  452751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452760 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452783 */     GIR_RootConstrainSelectedInstOperands,
     /*  452784 */     // GIR_Coverage, 6822,
     /*  452784 */     GIR_EraseRootFromParent_Done,
     /*  452785 */   // Label 7799: @452785
     /*  452785 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(452871), // Rule ID 6823 //
     /*  452790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452837 */     // MIs[1] Operand 1
     /*  452837 */     // No operand predicates
     /*  452837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452869 */     GIR_RootConstrainSelectedInstOperands,
     /*  452870 */     // GIR_Coverage, 6823,
     /*  452870 */     GIR_EraseRootFromParent_Done,
     /*  452871 */   // Label 7800: @452871
     /*  452871 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(452957), // Rule ID 7002 //
     /*  452876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452923 */     // MIs[1] Operand 1
     /*  452923 */     // No operand predicates
     /*  452923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452932 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  452935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452955 */     GIR_RootConstrainSelectedInstOperands,
     /*  452956 */     // GIR_Coverage, 7002,
     /*  452956 */     GIR_EraseRootFromParent_Done,
     /*  452957 */   // Label 7801: @452957
     /*  452957 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(453043), // Rule ID 7003 //
     /*  452962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453009 */     // MIs[1] Operand 1
     /*  453009 */     // No operand predicates
     /*  453009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453018 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  453021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453041 */     GIR_RootConstrainSelectedInstOperands,
     /*  453042 */     // GIR_Coverage, 7003,
     /*  453042 */     GIR_EraseRootFromParent_Done,
     /*  453043 */   // Label 7802: @453043
     /*  453043 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(453129), // Rule ID 7006 //
     /*  453048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453095 */     // MIs[1] Operand 1
     /*  453095 */     // No operand predicates
     /*  453095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453104 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453127 */     GIR_RootConstrainSelectedInstOperands,
     /*  453128 */     // GIR_Coverage, 7006,
     /*  453128 */     GIR_EraseRootFromParent_Done,
     /*  453129 */   // Label 7803: @453129
     /*  453129 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(453215), // Rule ID 7007 //
     /*  453134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  453145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  453148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  453151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453181 */     // MIs[1] Operand 1
     /*  453181 */     // No operand predicates
     /*  453181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453190 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453213 */     GIR_RootConstrainSelectedInstOperands,
     /*  453214 */     // GIR_Coverage, 7007,
     /*  453214 */     GIR_EraseRootFromParent_Done,
     /*  453215 */   // Label 7804: @453215
     /*  453215 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(453301), // Rule ID 7010 //
     /*  453220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453267 */     // MIs[1] Operand 1
     /*  453267 */     // No operand predicates
     /*  453267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453276 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453299 */     GIR_RootConstrainSelectedInstOperands,
     /*  453300 */     // GIR_Coverage, 7010,
     /*  453300 */     GIR_EraseRootFromParent_Done,
     /*  453301 */   // Label 7805: @453301
     /*  453301 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(453387), // Rule ID 7011 //
     /*  453306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  453317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  453320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  453323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453353 */     // MIs[1] Operand 1
     /*  453353 */     // No operand predicates
     /*  453353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453362 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453385 */     GIR_RootConstrainSelectedInstOperands,
     /*  453386 */     // GIR_Coverage, 7011,
     /*  453386 */     GIR_EraseRootFromParent_Done,
     /*  453387 */   // Label 7806: @453387
     /*  453387 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(453473), // Rule ID 7014 //
     /*  453392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453439 */     // MIs[1] Operand 1
     /*  453439 */     // No operand predicates
     /*  453439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453448 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453471 */     GIR_RootConstrainSelectedInstOperands,
     /*  453472 */     // GIR_Coverage, 7014,
     /*  453472 */     GIR_EraseRootFromParent_Done,
     /*  453473 */   // Label 7807: @453473
     /*  453473 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(453559), // Rule ID 7015 //
     /*  453478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  453489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  453492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  453495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453525 */     // MIs[1] Operand 1
     /*  453525 */     // No operand predicates
     /*  453525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453557 */     GIR_RootConstrainSelectedInstOperands,
     /*  453558 */     // GIR_Coverage, 7015,
     /*  453558 */     GIR_EraseRootFromParent_Done,
     /*  453559 */   // Label 7808: @453559
     /*  453559 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(453645), // Rule ID 7018 //
     /*  453564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453611 */     // MIs[1] Operand 1
     /*  453611 */     // No operand predicates
     /*  453611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453620 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453643 */     GIR_RootConstrainSelectedInstOperands,
     /*  453644 */     // GIR_Coverage, 7018,
     /*  453644 */     GIR_EraseRootFromParent_Done,
     /*  453645 */   // Label 7809: @453645
     /*  453645 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(453731), // Rule ID 7019 //
     /*  453650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453697 */     // MIs[1] Operand 1
     /*  453697 */     // No operand predicates
     /*  453697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453729 */     GIR_RootConstrainSelectedInstOperands,
     /*  453730 */     // GIR_Coverage, 7019,
     /*  453730 */     GIR_EraseRootFromParent_Done,
     /*  453731 */   // Label 7810: @453731
     /*  453731 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(453817), // Rule ID 7022 //
     /*  453736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453783 */     // MIs[1] Operand 1
     /*  453783 */     // No operand predicates
     /*  453783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453792 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  453792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453815 */     GIR_RootConstrainSelectedInstOperands,
     /*  453816 */     // GIR_Coverage, 7022,
     /*  453816 */     GIR_EraseRootFromParent_Done,
     /*  453817 */   // Label 7811: @453817
     /*  453817 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(453903), // Rule ID 7023 //
     /*  453822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453869 */     // MIs[1] Operand 1
     /*  453869 */     // No operand predicates
     /*  453869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453878 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  453878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453901 */     GIR_RootConstrainSelectedInstOperands,
     /*  453902 */     // GIR_Coverage, 7023,
     /*  453902 */     GIR_EraseRootFromParent_Done,
     /*  453903 */   // Label 7812: @453903
     /*  453903 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(453989), // Rule ID 7026 //
     /*  453908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  453919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  453922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  453925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453955 */     // MIs[1] Operand 1
     /*  453955 */     // No operand predicates
     /*  453955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453964 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  453967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453987 */     GIR_RootConstrainSelectedInstOperands,
     /*  453988 */     // GIR_Coverage, 7026,
     /*  453988 */     GIR_EraseRootFromParent_Done,
     /*  453989 */   // Label 7813: @453989
     /*  453989 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(454075), // Rule ID 7027 //
     /*  453994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  454005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  454008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  454011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454041 */     // MIs[1] Operand 1
     /*  454041 */     // No operand predicates
     /*  454041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454073 */     GIR_RootConstrainSelectedInstOperands,
     /*  454074 */     // GIR_Coverage, 7027,
     /*  454074 */     GIR_EraseRootFromParent_Done,
     /*  454075 */   // Label 7814: @454075
     /*  454075 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(454161), // Rule ID 7030 //
     /*  454080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454127 */     // MIs[1] Operand 1
     /*  454127 */     // No operand predicates
     /*  454127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454136 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454159 */     GIR_RootConstrainSelectedInstOperands,
     /*  454160 */     // GIR_Coverage, 7030,
     /*  454160 */     GIR_EraseRootFromParent_Done,
     /*  454161 */   // Label 7815: @454161
     /*  454161 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(454247), // Rule ID 7031 //
     /*  454166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  454177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  454180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  454183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454213 */     // MIs[1] Operand 1
     /*  454213 */     // No operand predicates
     /*  454213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454222 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454245 */     GIR_RootConstrainSelectedInstOperands,
     /*  454246 */     // GIR_Coverage, 7031,
     /*  454246 */     GIR_EraseRootFromParent_Done,
     /*  454247 */   // Label 7816: @454247
     /*  454247 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(454333), // Rule ID 7034 //
     /*  454252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454299 */     // MIs[1] Operand 1
     /*  454299 */     // No operand predicates
     /*  454299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  454308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454331 */     GIR_RootConstrainSelectedInstOperands,
     /*  454332 */     // GIR_Coverage, 7034,
     /*  454332 */     GIR_EraseRootFromParent_Done,
     /*  454333 */   // Label 7817: @454333
     /*  454333 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(454419), // Rule ID 7035 //
     /*  454338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  454349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  454352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  454355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454385 */     // MIs[1] Operand 1
     /*  454385 */     // No operand predicates
     /*  454385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  454394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  454414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454417 */     GIR_RootConstrainSelectedInstOperands,
     /*  454418 */     // GIR_Coverage, 7035,
     /*  454418 */     GIR_EraseRootFromParent_Done,
     /*  454419 */   // Label 7818: @454419
     /*  454419 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(454505), // Rule ID 7038 //
     /*  454424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  454427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454471 */     // MIs[1] Operand 1
     /*  454471 */     // No operand predicates
     /*  454471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454480 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  454480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454503 */     GIR_RootConstrainSelectedInstOperands,
     /*  454504 */     // GIR_Coverage, 7038,
     /*  454504 */     GIR_EraseRootFromParent_Done,
     /*  454505 */   // Label 7819: @454505
     /*  454505 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(454591), // Rule ID 7039 //
     /*  454510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  454513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454557 */     // MIs[1] Operand 1
     /*  454557 */     // No operand predicates
     /*  454557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  454566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454589 */     GIR_RootConstrainSelectedInstOperands,
     /*  454590 */     // GIR_Coverage, 7039,
     /*  454590 */     GIR_EraseRootFromParent_Done,
     /*  454591 */   // Label 7820: @454591
     /*  454591 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(454677), // Rule ID 7042 //
     /*  454596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454643 */     // MIs[1] Operand 1
     /*  454643 */     // No operand predicates
     /*  454643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  454655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454675 */     GIR_RootConstrainSelectedInstOperands,
     /*  454676 */     // GIR_Coverage, 7042,
     /*  454676 */     GIR_EraseRootFromParent_Done,
     /*  454677 */   // Label 7821: @454677
     /*  454677 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(454763), // Rule ID 7043 //
     /*  454682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454729 */     // MIs[1] Operand 1
     /*  454729 */     // No operand predicates
     /*  454729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454738 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  454741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454761 */     GIR_RootConstrainSelectedInstOperands,
     /*  454762 */     // GIR_Coverage, 7043,
     /*  454762 */     GIR_EraseRootFromParent_Done,
     /*  454763 */   // Label 7822: @454763
     /*  454763 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(454849), // Rule ID 7046 //
     /*  454768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454815 */     // MIs[1] Operand 1
     /*  454815 */     // No operand predicates
     /*  454815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454824 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  454827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454847 */     GIR_RootConstrainSelectedInstOperands,
     /*  454848 */     // GIR_Coverage, 7046,
     /*  454848 */     GIR_EraseRootFromParent_Done,
     /*  454849 */   // Label 7823: @454849
     /*  454849 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(454935), // Rule ID 7047 //
     /*  454854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454901 */     // MIs[1] Operand 1
     /*  454901 */     // No operand predicates
     /*  454901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454910 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  454913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454933 */     GIR_RootConstrainSelectedInstOperands,
     /*  454934 */     // GIR_Coverage, 7047,
     /*  454934 */     GIR_EraseRootFromParent_Done,
     /*  454935 */   // Label 7824: @454935
     /*  454935 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(455021), // Rule ID 7050 //
     /*  454940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  454951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  454954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  454957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454987 */     // MIs[1] Operand 1
     /*  454987 */     // No operand predicates
     /*  454987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454996 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  454999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455019 */     GIR_RootConstrainSelectedInstOperands,
     /*  455020 */     // GIR_Coverage, 7050,
     /*  455020 */     GIR_EraseRootFromParent_Done,
     /*  455021 */   // Label 7825: @455021
     /*  455021 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(455107), // Rule ID 7051 //
     /*  455026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  455037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  455040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  455043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455073 */     // MIs[1] Operand 1
     /*  455073 */     // No operand predicates
     /*  455073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455082 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  455082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  455102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455105 */     GIR_RootConstrainSelectedInstOperands,
     /*  455106 */     // GIR_Coverage, 7051,
     /*  455106 */     GIR_EraseRootFromParent_Done,
     /*  455107 */   // Label 7826: @455107
     /*  455107 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(455193), // Rule ID 7054 //
     /*  455112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455159 */     // MIs[1] Operand 1
     /*  455159 */     // No operand predicates
     /*  455159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455191 */     GIR_RootConstrainSelectedInstOperands,
     /*  455192 */     // GIR_Coverage, 7054,
     /*  455192 */     GIR_EraseRootFromParent_Done,
     /*  455193 */   // Label 7827: @455193
     /*  455193 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(455279), // Rule ID 7055 //
     /*  455198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  455209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  455212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  455215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455245 */     // MIs[1] Operand 1
     /*  455245 */     // No operand predicates
     /*  455245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455254 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455277 */     GIR_RootConstrainSelectedInstOperands,
     /*  455278 */     // GIR_Coverage, 7055,
     /*  455278 */     GIR_EraseRootFromParent_Done,
     /*  455279 */   // Label 7828: @455279
     /*  455279 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(455365), // Rule ID 7058 //
     /*  455284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455331 */     // MIs[1] Operand 1
     /*  455331 */     // No operand predicates
     /*  455331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455363 */     GIR_RootConstrainSelectedInstOperands,
     /*  455364 */     // GIR_Coverage, 7058,
     /*  455364 */     GIR_EraseRootFromParent_Done,
     /*  455365 */   // Label 7829: @455365
     /*  455365 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(455451), // Rule ID 7059 //
     /*  455370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  455381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  455384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  455387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455417 */     // MIs[1] Operand 1
     /*  455417 */     // No operand predicates
     /*  455417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455426 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455449 */     GIR_RootConstrainSelectedInstOperands,
     /*  455450 */     // GIR_Coverage, 7059,
     /*  455450 */     GIR_EraseRootFromParent_Done,
     /*  455451 */   // Label 7830: @455451
     /*  455451 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(455537), // Rule ID 7062 //
     /*  455456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455503 */     // MIs[1] Operand 1
     /*  455503 */     // No operand predicates
     /*  455503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455512 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455535 */     GIR_RootConstrainSelectedInstOperands,
     /*  455536 */     // GIR_Coverage, 7062,
     /*  455536 */     GIR_EraseRootFromParent_Done,
     /*  455537 */   // Label 7831: @455537
     /*  455537 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(455623), // Rule ID 7063 //
     /*  455542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455589 */     // MIs[1] Operand 1
     /*  455589 */     // No operand predicates
     /*  455589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455598 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455621 */     GIR_RootConstrainSelectedInstOperands,
     /*  455622 */     // GIR_Coverage, 7063,
     /*  455622 */     GIR_EraseRootFromParent_Done,
     /*  455623 */   // Label 7832: @455623
     /*  455623 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(455709), // Rule ID 7066 //
     /*  455628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455675 */     // MIs[1] Operand 1
     /*  455675 */     // No operand predicates
     /*  455675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455707 */     GIR_RootConstrainSelectedInstOperands,
     /*  455708 */     // GIR_Coverage, 7066,
     /*  455708 */     GIR_EraseRootFromParent_Done,
     /*  455709 */   // Label 7833: @455709
     /*  455709 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(455795), // Rule ID 7067 //
     /*  455714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455761 */     // MIs[1] Operand 1
     /*  455761 */     // No operand predicates
     /*  455761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455793 */     GIR_RootConstrainSelectedInstOperands,
     /*  455794 */     // GIR_Coverage, 7067,
     /*  455794 */     GIR_EraseRootFromParent_Done,
     /*  455795 */   // Label 7834: @455795
     /*  455795 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(455881), // Rule ID 7070 //
     /*  455800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455847 */     // MIs[1] Operand 1
     /*  455847 */     // No operand predicates
     /*  455847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455856 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455879 */     GIR_RootConstrainSelectedInstOperands,
     /*  455880 */     // GIR_Coverage, 7070,
     /*  455880 */     GIR_EraseRootFromParent_Done,
     /*  455881 */   // Label 7835: @455881
     /*  455881 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(455967), // Rule ID 7071 //
     /*  455886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455933 */     // MIs[1] Operand 1
     /*  455933 */     // No operand predicates
     /*  455933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455942 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455965 */     GIR_RootConstrainSelectedInstOperands,
     /*  455966 */     // GIR_Coverage, 7071,
     /*  455966 */     GIR_EraseRootFromParent_Done,
     /*  455967 */   // Label 7836: @455967
     /*  455967 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(456053), // Rule ID 7074 //
     /*  455972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  455983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  455986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  455989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456019 */     // MIs[1] Operand 1
     /*  456019 */     // No operand predicates
     /*  456019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456028 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  456028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456051 */     GIR_RootConstrainSelectedInstOperands,
     /*  456052 */     // GIR_Coverage, 7074,
     /*  456052 */     GIR_EraseRootFromParent_Done,
     /*  456053 */   // Label 7837: @456053
     /*  456053 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(456139), // Rule ID 7075 //
     /*  456058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  456069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  456072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  456075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456105 */     // MIs[1] Operand 1
     /*  456105 */     // No operand predicates
     /*  456105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456114 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  456114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  456134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456137 */     GIR_RootConstrainSelectedInstOperands,
     /*  456138 */     // GIR_Coverage, 7075,
     /*  456138 */     GIR_EraseRootFromParent_Done,
     /*  456139 */   // Label 7838: @456139
     /*  456139 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(456225), // Rule ID 7078 //
     /*  456144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456191 */     // MIs[1] Operand 1
     /*  456191 */     // No operand predicates
     /*  456191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456200 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456223 */     GIR_RootConstrainSelectedInstOperands,
     /*  456224 */     // GIR_Coverage, 7078,
     /*  456224 */     GIR_EraseRootFromParent_Done,
     /*  456225 */   // Label 7839: @456225
     /*  456225 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(456311), // Rule ID 7079 //
     /*  456230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  456241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  456244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  456247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  456265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456277 */     // MIs[1] Operand 1
     /*  456277 */     // No operand predicates
     /*  456277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456286 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  456289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456309 */     GIR_RootConstrainSelectedInstOperands,
     /*  456310 */     // GIR_Coverage, 7079,
     /*  456310 */     GIR_EraseRootFromParent_Done,
     /*  456311 */   // Label 7840: @456311
     /*  456311 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(456397), // Rule ID 7082 //
     /*  456316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456363 */     // MIs[1] Operand 1
     /*  456363 */     // No operand predicates
     /*  456363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456372 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456395 */     GIR_RootConstrainSelectedInstOperands,
     /*  456396 */     // GIR_Coverage, 7082,
     /*  456396 */     GIR_EraseRootFromParent_Done,
     /*  456397 */   // Label 7841: @456397
     /*  456397 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(456483), // Rule ID 7083 //
     /*  456402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  456413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  456416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  456419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  456437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456449 */     // MIs[1] Operand 1
     /*  456449 */     // No operand predicates
     /*  456449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456458 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  456461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456481 */     GIR_RootConstrainSelectedInstOperands,
     /*  456482 */     // GIR_Coverage, 7083,
     /*  456482 */     GIR_EraseRootFromParent_Done,
     /*  456483 */   // Label 7842: @456483
     /*  456483 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(456569), // Rule ID 7086 //
     /*  456488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  456491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456535 */     // MIs[1] Operand 1
     /*  456535 */     // No operand predicates
     /*  456535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456544 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456567 */     GIR_RootConstrainSelectedInstOperands,
     /*  456568 */     // GIR_Coverage, 7086,
     /*  456568 */     GIR_EraseRootFromParent_Done,
     /*  456569 */   // Label 7843: @456569
     /*  456569 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(456655), // Rule ID 7087 //
     /*  456574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456621 */     // MIs[1] Operand 1
     /*  456621 */     // No operand predicates
     /*  456621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456630 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456653 */     GIR_RootConstrainSelectedInstOperands,
     /*  456654 */     // GIR_Coverage, 7087,
     /*  456654 */     GIR_EraseRootFromParent_Done,
     /*  456655 */   // Label 7844: @456655
     /*  456655 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(456741), // Rule ID 7266 //
     /*  456660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456707 */     // MIs[1] Operand 1
     /*  456707 */     // No operand predicates
     /*  456707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456716 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  456719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456739 */     GIR_RootConstrainSelectedInstOperands,
     /*  456740 */     // GIR_Coverage, 7266,
     /*  456740 */     GIR_EraseRootFromParent_Done,
     /*  456741 */   // Label 7845: @456741
     /*  456741 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(456827), // Rule ID 7267 //
     /*  456746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456793 */     // MIs[1] Operand 1
     /*  456793 */     // No operand predicates
     /*  456793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456802 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  456805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456825 */     GIR_RootConstrainSelectedInstOperands,
     /*  456826 */     // GIR_Coverage, 7267,
     /*  456826 */     GIR_EraseRootFromParent_Done,
     /*  456827 */   // Label 7846: @456827
     /*  456827 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(456913), // Rule ID 7270 //
     /*  456832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456879 */     // MIs[1] Operand 1
     /*  456879 */     // No operand predicates
     /*  456879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456888 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  456891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456911 */     GIR_RootConstrainSelectedInstOperands,
     /*  456912 */     // GIR_Coverage, 7270,
     /*  456912 */     GIR_EraseRootFromParent_Done,
     /*  456913 */   // Label 7847: @456913
     /*  456913 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(456999), // Rule ID 7271 //
     /*  456918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456965 */     // MIs[1] Operand 1
     /*  456965 */     // No operand predicates
     /*  456965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456974 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  456977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456997 */     GIR_RootConstrainSelectedInstOperands,
     /*  456998 */     // GIR_Coverage, 7271,
     /*  456998 */     GIR_EraseRootFromParent_Done,
     /*  456999 */   // Label 7848: @456999
     /*  456999 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(457085), // Rule ID 7274 //
     /*  457004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457051 */     // MIs[1] Operand 1
     /*  457051 */     // No operand predicates
     /*  457051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457060 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457083 */     GIR_RootConstrainSelectedInstOperands,
     /*  457084 */     // GIR_Coverage, 7274,
     /*  457084 */     GIR_EraseRootFromParent_Done,
     /*  457085 */   // Label 7849: @457085
     /*  457085 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(457171), // Rule ID 7275 //
     /*  457090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  457101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  457104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  457107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457137 */     // MIs[1] Operand 1
     /*  457137 */     // No operand predicates
     /*  457137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457146 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457169 */     GIR_RootConstrainSelectedInstOperands,
     /*  457170 */     // GIR_Coverage, 7275,
     /*  457170 */     GIR_EraseRootFromParent_Done,
     /*  457171 */   // Label 7850: @457171
     /*  457171 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(457257), // Rule ID 7278 //
     /*  457176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457223 */     // MIs[1] Operand 1
     /*  457223 */     // No operand predicates
     /*  457223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457232 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457255 */     GIR_RootConstrainSelectedInstOperands,
     /*  457256 */     // GIR_Coverage, 7278,
     /*  457256 */     GIR_EraseRootFromParent_Done,
     /*  457257 */   // Label 7851: @457257
     /*  457257 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(457343), // Rule ID 7279 //
     /*  457262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  457273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  457276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  457279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457309 */     // MIs[1] Operand 1
     /*  457309 */     // No operand predicates
     /*  457309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457318 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  457321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457341 */     GIR_RootConstrainSelectedInstOperands,
     /*  457342 */     // GIR_Coverage, 7279,
     /*  457342 */     GIR_EraseRootFromParent_Done,
     /*  457343 */   // Label 7852: @457343
     /*  457343 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(457429), // Rule ID 7282 //
     /*  457348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457395 */     // MIs[1] Operand 1
     /*  457395 */     // No operand predicates
     /*  457395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457404 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457427 */     GIR_RootConstrainSelectedInstOperands,
     /*  457428 */     // GIR_Coverage, 7282,
     /*  457428 */     GIR_EraseRootFromParent_Done,
     /*  457429 */   // Label 7853: @457429
     /*  457429 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(457515), // Rule ID 7283 //
     /*  457434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  457445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  457448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  457451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457481 */     // MIs[1] Operand 1
     /*  457481 */     // No operand predicates
     /*  457481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457513 */     GIR_RootConstrainSelectedInstOperands,
     /*  457514 */     // GIR_Coverage, 7283,
     /*  457514 */     GIR_EraseRootFromParent_Done,
     /*  457515 */   // Label 7854: @457515
     /*  457515 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(457601), // Rule ID 7286 //
     /*  457520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457567 */     // MIs[1] Operand 1
     /*  457567 */     // No operand predicates
     /*  457567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  457576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457599 */     GIR_RootConstrainSelectedInstOperands,
     /*  457600 */     // GIR_Coverage, 7286,
     /*  457600 */     GIR_EraseRootFromParent_Done,
     /*  457601 */   // Label 7855: @457601
     /*  457601 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(457687), // Rule ID 7287 //
     /*  457606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457653 */     // MIs[1] Operand 1
     /*  457653 */     // No operand predicates
     /*  457653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457662 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  457662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457685 */     GIR_RootConstrainSelectedInstOperands,
     /*  457686 */     // GIR_Coverage, 7287,
     /*  457686 */     GIR_EraseRootFromParent_Done,
     /*  457687 */   // Label 7856: @457687
     /*  457687 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(457773), // Rule ID 7290 //
     /*  457692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457739 */     // MIs[1] Operand 1
     /*  457739 */     // No operand predicates
     /*  457739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457748 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457771 */     GIR_RootConstrainSelectedInstOperands,
     /*  457772 */     // GIR_Coverage, 7290,
     /*  457772 */     GIR_EraseRootFromParent_Done,
     /*  457773 */   // Label 7857: @457773
     /*  457773 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(457859), // Rule ID 7291 //
     /*  457778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457825 */     // MIs[1] Operand 1
     /*  457825 */     // No operand predicates
     /*  457825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457834 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457857 */     GIR_RootConstrainSelectedInstOperands,
     /*  457858 */     // GIR_Coverage, 7291,
     /*  457858 */     GIR_EraseRootFromParent_Done,
     /*  457859 */   // Label 7858: @457859
     /*  457859 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(457945), // Rule ID 7294 //
     /*  457864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  457875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  457878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  457881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457911 */     // MIs[1] Operand 1
     /*  457911 */     // No operand predicates
     /*  457911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457943 */     GIR_RootConstrainSelectedInstOperands,
     /*  457944 */     // GIR_Coverage, 7294,
     /*  457944 */     GIR_EraseRootFromParent_Done,
     /*  457945 */   // Label 7859: @457945
     /*  457945 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(458031), // Rule ID 7295 //
     /*  457950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  457961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  457964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  457967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457997 */     // MIs[1] Operand 1
     /*  457997 */     // No operand predicates
     /*  457997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458006 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458029 */     GIR_RootConstrainSelectedInstOperands,
     /*  458030 */     // GIR_Coverage, 7295,
     /*  458030 */     GIR_EraseRootFromParent_Done,
     /*  458031 */   // Label 7860: @458031
     /*  458031 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(458117), // Rule ID 7298 //
     /*  458036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458083 */     // MIs[1] Operand 1
     /*  458083 */     // No operand predicates
     /*  458083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458115 */     GIR_RootConstrainSelectedInstOperands,
     /*  458116 */     // GIR_Coverage, 7298,
     /*  458116 */     GIR_EraseRootFromParent_Done,
     /*  458117 */   // Label 7861: @458117
     /*  458117 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(458203), // Rule ID 7299 //
     /*  458122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  458133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  458136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  458139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458169 */     // MIs[1] Operand 1
     /*  458169 */     // No operand predicates
     /*  458169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  458178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458201 */     GIR_RootConstrainSelectedInstOperands,
     /*  458202 */     // GIR_Coverage, 7299,
     /*  458202 */     GIR_EraseRootFromParent_Done,
     /*  458203 */   // Label 7862: @458203
     /*  458203 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(458289), // Rule ID 7302 //
     /*  458208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  458211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458255 */     // MIs[1] Operand 1
     /*  458255 */     // No operand predicates
     /*  458255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458264 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  458264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458287 */     GIR_RootConstrainSelectedInstOperands,
     /*  458288 */     // GIR_Coverage, 7302,
     /*  458288 */     GIR_EraseRootFromParent_Done,
     /*  458289 */   // Label 7863: @458289
     /*  458289 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(458375), // Rule ID 7303 //
     /*  458294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  458297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  458305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  458308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  458311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  458329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458341 */     // MIs[1] Operand 1
     /*  458341 */     // No operand predicates
     /*  458341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458350 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  458350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  458353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  458370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458373 */     GIR_RootConstrainSelectedInstOperands,
     /*  458374 */     // GIR_Coverage, 7303,
     /*  458374 */     GIR_EraseRootFromParent_Done,
     /*  458375 */   // Label 7864: @458375
     /*  458375 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(458461), // Rule ID 7306 //
     /*  458380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458427 */     // MIs[1] Operand 1
     /*  458427 */     // No operand predicates
     /*  458427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458436 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458459 */     GIR_RootConstrainSelectedInstOperands,
     /*  458460 */     // GIR_Coverage, 7306,
     /*  458460 */     GIR_EraseRootFromParent_Done,
     /*  458461 */   // Label 7865: @458461
     /*  458461 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(458547), // Rule ID 7307 //
     /*  458466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  458477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  458480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  458483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458513 */     // MIs[1] Operand 1
     /*  458513 */     // No operand predicates
     /*  458513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458522 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458545 */     GIR_RootConstrainSelectedInstOperands,
     /*  458546 */     // GIR_Coverage, 7307,
     /*  458546 */     GIR_EraseRootFromParent_Done,
     /*  458547 */   // Label 7866: @458547
     /*  458547 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(458633), // Rule ID 7310 //
     /*  458552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458599 */     // MIs[1] Operand 1
     /*  458599 */     // No operand predicates
     /*  458599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458608 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  458611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458631 */     GIR_RootConstrainSelectedInstOperands,
     /*  458632 */     // GIR_Coverage, 7310,
     /*  458632 */     GIR_EraseRootFromParent_Done,
     /*  458633 */   // Label 7867: @458633
     /*  458633 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(458719), // Rule ID 7311 //
     /*  458638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458685 */     // MIs[1] Operand 1
     /*  458685 */     // No operand predicates
     /*  458685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458694 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  458697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458717 */     GIR_RootConstrainSelectedInstOperands,
     /*  458718 */     // GIR_Coverage, 7311,
     /*  458718 */     GIR_EraseRootFromParent_Done,
     /*  458719 */   // Label 7868: @458719
     /*  458719 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(458805), // Rule ID 7314 //
     /*  458724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458771 */     // MIs[1] Operand 1
     /*  458771 */     // No operand predicates
     /*  458771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458780 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  458783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458803 */     GIR_RootConstrainSelectedInstOperands,
     /*  458804 */     // GIR_Coverage, 7314,
     /*  458804 */     GIR_EraseRootFromParent_Done,
     /*  458805 */   // Label 7869: @458805
     /*  458805 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(458891), // Rule ID 7315 //
     /*  458810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458857 */     // MIs[1] Operand 1
     /*  458857 */     // No operand predicates
     /*  458857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458866 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  458869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458889 */     GIR_RootConstrainSelectedInstOperands,
     /*  458890 */     // GIR_Coverage, 7315,
     /*  458890 */     GIR_EraseRootFromParent_Done,
     /*  458891 */   // Label 7870: @458891
     /*  458891 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(458977), // Rule ID 7318 //
     /*  458896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  458907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  458910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  458913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458943 */     // MIs[1] Operand 1
     /*  458943 */     // No operand predicates
     /*  458943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  458952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458975 */     GIR_RootConstrainSelectedInstOperands,
     /*  458976 */     // GIR_Coverage, 7318,
     /*  458976 */     GIR_EraseRootFromParent_Done,
     /*  458977 */   // Label 7871: @458977
     /*  458977 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(459063), // Rule ID 7319 //
     /*  458982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  458993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  458996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  458999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459029 */     // MIs[1] Operand 1
     /*  459029 */     // No operand predicates
     /*  459029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459061 */     GIR_RootConstrainSelectedInstOperands,
     /*  459062 */     // GIR_Coverage, 7319,
     /*  459062 */     GIR_EraseRootFromParent_Done,
     /*  459063 */   // Label 7872: @459063
     /*  459063 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(459149), // Rule ID 7322 //
     /*  459068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459115 */     // MIs[1] Operand 1
     /*  459115 */     // No operand predicates
     /*  459115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459124 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459147 */     GIR_RootConstrainSelectedInstOperands,
     /*  459148 */     // GIR_Coverage, 7322,
     /*  459148 */     GIR_EraseRootFromParent_Done,
     /*  459149 */   // Label 7873: @459149
     /*  459149 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(459235), // Rule ID 7323 //
     /*  459154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  459165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  459168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  459171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459201 */     // MIs[1] Operand 1
     /*  459201 */     // No operand predicates
     /*  459201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459210 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459233 */     GIR_RootConstrainSelectedInstOperands,
     /*  459234 */     // GIR_Coverage, 7323,
     /*  459234 */     GIR_EraseRootFromParent_Done,
     /*  459235 */   // Label 7874: @459235
     /*  459235 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(459321), // Rule ID 7326 //
     /*  459240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459287 */     // MIs[1] Operand 1
     /*  459287 */     // No operand predicates
     /*  459287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  459296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459319 */     GIR_RootConstrainSelectedInstOperands,
     /*  459320 */     // GIR_Coverage, 7326,
     /*  459320 */     GIR_EraseRootFromParent_Done,
     /*  459321 */   // Label 7875: @459321
     /*  459321 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(459407), // Rule ID 7327 //
     /*  459326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  459337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  459340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  459343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459373 */     // MIs[1] Operand 1
     /*  459373 */     // No operand predicates
     /*  459373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459382 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  459382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  459402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459405 */     GIR_RootConstrainSelectedInstOperands,
     /*  459406 */     // GIR_Coverage, 7327,
     /*  459406 */     GIR_EraseRootFromParent_Done,
     /*  459407 */   // Label 7876: @459407
     /*  459407 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(459493), // Rule ID 7330 //
     /*  459412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459459 */     // MIs[1] Operand 1
     /*  459459 */     // No operand predicates
     /*  459459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459491 */     GIR_RootConstrainSelectedInstOperands,
     /*  459492 */     // GIR_Coverage, 7330,
     /*  459492 */     GIR_EraseRootFromParent_Done,
     /*  459493 */   // Label 7877: @459493
     /*  459493 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(459579), // Rule ID 7331 //
     /*  459498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459545 */     // MIs[1] Operand 1
     /*  459545 */     // No operand predicates
     /*  459545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459554 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459577 */     GIR_RootConstrainSelectedInstOperands,
     /*  459578 */     // GIR_Coverage, 7331,
     /*  459578 */     GIR_EraseRootFromParent_Done,
     /*  459579 */   // Label 7878: @459579
     /*  459579 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(459665), // Rule ID 7334 //
     /*  459584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459631 */     // MIs[1] Operand 1
     /*  459631 */     // No operand predicates
     /*  459631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459640 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459663 */     GIR_RootConstrainSelectedInstOperands,
     /*  459664 */     // GIR_Coverage, 7334,
     /*  459664 */     GIR_EraseRootFromParent_Done,
     /*  459665 */   // Label 7879: @459665
     /*  459665 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(459751), // Rule ID 7335 //
     /*  459670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459717 */     // MIs[1] Operand 1
     /*  459717 */     // No operand predicates
     /*  459717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459726 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459749 */     GIR_RootConstrainSelectedInstOperands,
     /*  459750 */     // GIR_Coverage, 7335,
     /*  459750 */     GIR_EraseRootFromParent_Done,
     /*  459751 */   // Label 7880: @459751
     /*  459751 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(459837), // Rule ID 7338 //
     /*  459756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459803 */     // MIs[1] Operand 1
     /*  459803 */     // No operand predicates
     /*  459803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459812 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459835 */     GIR_RootConstrainSelectedInstOperands,
     /*  459836 */     // GIR_Coverage, 7338,
     /*  459836 */     GIR_EraseRootFromParent_Done,
     /*  459837 */   // Label 7881: @459837
     /*  459837 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(459923), // Rule ID 7339 //
     /*  459842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459889 */     // MIs[1] Operand 1
     /*  459889 */     // No operand predicates
     /*  459889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459921 */     GIR_RootConstrainSelectedInstOperands,
     /*  459922 */     // GIR_Coverage, 7339,
     /*  459922 */     GIR_EraseRootFromParent_Done,
     /*  459923 */   // Label 7882: @459923
     /*  459923 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(460009), // Rule ID 7342 //
     /*  459928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  459931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  459939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  459942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  459945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459975 */     // MIs[1] Operand 1
     /*  459975 */     // No operand predicates
     /*  459975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459984 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  459984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460007 */     GIR_RootConstrainSelectedInstOperands,
     /*  460008 */     // GIR_Coverage, 7342,
     /*  460008 */     GIR_EraseRootFromParent_Done,
     /*  460009 */   // Label 7883: @460009
     /*  460009 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(460095), // Rule ID 7343 //
     /*  460014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  460025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  460028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  460031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460061 */     // MIs[1] Operand 1
     /*  460061 */     // No operand predicates
     /*  460061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  460073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460093 */     GIR_RootConstrainSelectedInstOperands,
     /*  460094 */     // GIR_Coverage, 7343,
     /*  460094 */     GIR_EraseRootFromParent_Done,
     /*  460095 */   // Label 7884: @460095
     /*  460095 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(460181), // Rule ID 7346 //
     /*  460100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460147 */     // MIs[1] Operand 1
     /*  460147 */     // No operand predicates
     /*  460147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460156 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460179 */     GIR_RootConstrainSelectedInstOperands,
     /*  460180 */     // GIR_Coverage, 7346,
     /*  460180 */     GIR_EraseRootFromParent_Done,
     /*  460181 */   // Label 7885: @460181
     /*  460181 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(460267), // Rule ID 7347 //
     /*  460186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  460197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  460200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  460203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460233 */     // MIs[1] Operand 1
     /*  460233 */     // No operand predicates
     /*  460233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460242 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  460245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460265 */     GIR_RootConstrainSelectedInstOperands,
     /*  460266 */     // GIR_Coverage, 7347,
     /*  460266 */     GIR_EraseRootFromParent_Done,
     /*  460267 */   // Label 7886: @460267
     /*  460267 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(460353), // Rule ID 7350 //
     /*  460272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  460275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460319 */     // MIs[1] Operand 1
     /*  460319 */     // No operand predicates
     /*  460319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460328 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  460328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460351 */     GIR_RootConstrainSelectedInstOperands,
     /*  460352 */     // GIR_Coverage, 7350,
     /*  460352 */     GIR_EraseRootFromParent_Done,
     /*  460353 */   // Label 7887: @460353
     /*  460353 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(460439), // Rule ID 7351 //
     /*  460358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  460361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  460366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  460369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  460372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  460375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460405 */     // MIs[1] Operand 1
     /*  460405 */     // No operand predicates
     /*  460405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  460414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  460417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  460434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460437 */     GIR_RootConstrainSelectedInstOperands,
     /*  460438 */     // GIR_Coverage, 7351,
     /*  460438 */     GIR_EraseRootFromParent_Done,
     /*  460439 */   // Label 7888: @460439
     /*  460439 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(460525), // Rule ID 7562 //
     /*  460444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  460461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460491 */     // MIs[1] Operand 1
     /*  460491 */     // No operand predicates
     /*  460491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460500 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  460503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460523 */     GIR_RootConstrainSelectedInstOperands,
     /*  460524 */     // GIR_Coverage, 7562,
     /*  460524 */     GIR_EraseRootFromParent_Done,
     /*  460525 */   // Label 7889: @460525
     /*  460525 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(460611), // Rule ID 7563 //
     /*  460530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  460547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460577 */     // MIs[1] Operand 1
     /*  460577 */     // No operand predicates
     /*  460577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460586 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  460589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460609 */     GIR_RootConstrainSelectedInstOperands,
     /*  460610 */     // GIR_Coverage, 7563,
     /*  460610 */     GIR_EraseRootFromParent_Done,
     /*  460611 */   // Label 7890: @460611
     /*  460611 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(460697), // Rule ID 7566 //
     /*  460616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  460633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460663 */     // MIs[1] Operand 1
     /*  460663 */     // No operand predicates
     /*  460663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460672 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  460675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460695 */     GIR_RootConstrainSelectedInstOperands,
     /*  460696 */     // GIR_Coverage, 7566,
     /*  460696 */     GIR_EraseRootFromParent_Done,
     /*  460697 */   // Label 7891: @460697
     /*  460697 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(460783), // Rule ID 7567 //
     /*  460702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  460719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460749 */     // MIs[1] Operand 1
     /*  460749 */     // No operand predicates
     /*  460749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460758 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  460761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460781 */     GIR_RootConstrainSelectedInstOperands,
     /*  460782 */     // GIR_Coverage, 7567,
     /*  460782 */     GIR_EraseRootFromParent_Done,
     /*  460783 */   // Label 7892: @460783
     /*  460783 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(460869), // Rule ID 7570 //
     /*  460788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  460805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460835 */     // MIs[1] Operand 1
     /*  460835 */     // No operand predicates
     /*  460835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  460847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460867 */     GIR_RootConstrainSelectedInstOperands,
     /*  460868 */     // GIR_Coverage, 7570,
     /*  460868 */     GIR_EraseRootFromParent_Done,
     /*  460869 */   // Label 7893: @460869
     /*  460869 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(460955), // Rule ID 7571 //
     /*  460874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  460891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460921 */     // MIs[1] Operand 1
     /*  460921 */     // No operand predicates
     /*  460921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460930 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  460933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460953 */     GIR_RootConstrainSelectedInstOperands,
     /*  460954 */     // GIR_Coverage, 7571,
     /*  460954 */     GIR_EraseRootFromParent_Done,
     /*  460955 */   // Label 7894: @460955
     /*  460955 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(461041), // Rule ID 7574 //
     /*  460960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  460971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  460974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  460977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461007 */     // MIs[1] Operand 1
     /*  461007 */     // No operand predicates
     /*  461007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461016 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461039 */     GIR_RootConstrainSelectedInstOperands,
     /*  461040 */     // GIR_Coverage, 7574,
     /*  461040 */     GIR_EraseRootFromParent_Done,
     /*  461041 */   // Label 7895: @461041
     /*  461041 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(461127), // Rule ID 7575 //
     /*  461046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  461057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  461060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  461063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461093 */     // MIs[1] Operand 1
     /*  461093 */     // No operand predicates
     /*  461093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461125 */     GIR_RootConstrainSelectedInstOperands,
     /*  461126 */     // GIR_Coverage, 7575,
     /*  461126 */     GIR_EraseRootFromParent_Done,
     /*  461127 */   // Label 7896: @461127
     /*  461127 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(461213), // Rule ID 7578 //
     /*  461132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  461143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  461146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461179 */     // MIs[1] Operand 1
     /*  461179 */     // No operand predicates
     /*  461179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461188 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461211 */     GIR_RootConstrainSelectedInstOperands,
     /*  461212 */     // GIR_Coverage, 7578,
     /*  461212 */     GIR_EraseRootFromParent_Done,
     /*  461213 */   // Label 7897: @461213
     /*  461213 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(461299), // Rule ID 7579 //
     /*  461218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  461229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  461232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  461235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461265 */     // MIs[1] Operand 1
     /*  461265 */     // No operand predicates
     /*  461265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461274 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461297 */     GIR_RootConstrainSelectedInstOperands,
     /*  461298 */     // GIR_Coverage, 7579,
     /*  461298 */     GIR_EraseRootFromParent_Done,
     /*  461299 */   // Label 7898: @461299
     /*  461299 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(461385), // Rule ID 7582 //
     /*  461304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  461315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  461318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461351 */     // MIs[1] Operand 1
     /*  461351 */     // No operand predicates
     /*  461351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461360 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  461360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461383 */     GIR_RootConstrainSelectedInstOperands,
     /*  461384 */     // GIR_Coverage, 7582,
     /*  461384 */     GIR_EraseRootFromParent_Done,
     /*  461385 */   // Label 7899: @461385
     /*  461385 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(461471), // Rule ID 7583 //
     /*  461390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  461401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  461404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  461407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461437 */     // MIs[1] Operand 1
     /*  461437 */     // No operand predicates
     /*  461437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  461446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  461466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461469 */     GIR_RootConstrainSelectedInstOperands,
     /*  461470 */     // GIR_Coverage, 7583,
     /*  461470 */     GIR_EraseRootFromParent_Done,
     /*  461471 */   // Label 7900: @461471
     /*  461471 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(461557), // Rule ID 7586 //
     /*  461476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461523 */     // MIs[1] Operand 1
     /*  461523 */     // No operand predicates
     /*  461523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461532 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461555 */     GIR_RootConstrainSelectedInstOperands,
     /*  461556 */     // GIR_Coverage, 7586,
     /*  461556 */     GIR_EraseRootFromParent_Done,
     /*  461557 */   // Label 7901: @461557
     /*  461557 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(461643), // Rule ID 7587 //
     /*  461562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461609 */     // MIs[1] Operand 1
     /*  461609 */     // No operand predicates
     /*  461609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461618 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461641 */     GIR_RootConstrainSelectedInstOperands,
     /*  461642 */     // GIR_Coverage, 7587,
     /*  461642 */     GIR_EraseRootFromParent_Done,
     /*  461643 */   // Label 7902: @461643
     /*  461643 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(461729), // Rule ID 7590 //
     /*  461648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461695 */     // MIs[1] Operand 1
     /*  461695 */     // No operand predicates
     /*  461695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461704 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461727 */     GIR_RootConstrainSelectedInstOperands,
     /*  461728 */     // GIR_Coverage, 7590,
     /*  461728 */     GIR_EraseRootFromParent_Done,
     /*  461729 */   // Label 7903: @461729
     /*  461729 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(461815), // Rule ID 7591 //
     /*  461734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461781 */     // MIs[1] Operand 1
     /*  461781 */     // No operand predicates
     /*  461781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461790 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461813 */     GIR_RootConstrainSelectedInstOperands,
     /*  461814 */     // GIR_Coverage, 7591,
     /*  461814 */     GIR_EraseRootFromParent_Done,
     /*  461815 */   // Label 7904: @461815
     /*  461815 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(461901), // Rule ID 7594 //
     /*  461820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  461837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461867 */     // MIs[1] Operand 1
     /*  461867 */     // No operand predicates
     /*  461867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461899 */     GIR_RootConstrainSelectedInstOperands,
     /*  461900 */     // GIR_Coverage, 7594,
     /*  461900 */     GIR_EraseRootFromParent_Done,
     /*  461901 */   // Label 7905: @461901
     /*  461901 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(461987), // Rule ID 7595 //
     /*  461906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  461923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461953 */     // MIs[1] Operand 1
     /*  461953 */     // No operand predicates
     /*  461953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461962 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461985 */     GIR_RootConstrainSelectedInstOperands,
     /*  461986 */     // GIR_Coverage, 7595,
     /*  461986 */     GIR_EraseRootFromParent_Done,
     /*  461987 */   // Label 7906: @461987
     /*  461987 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(462073), // Rule ID 7598 //
     /*  461992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  462009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462039 */     // MIs[1] Operand 1
     /*  462039 */     // No operand predicates
     /*  462039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462071 */     GIR_RootConstrainSelectedInstOperands,
     /*  462072 */     // GIR_Coverage, 7598,
     /*  462072 */     GIR_EraseRootFromParent_Done,
     /*  462073 */   // Label 7907: @462073
     /*  462073 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(462159), // Rule ID 7599 //
     /*  462078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  462089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  462092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  462095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462125 */     // MIs[1] Operand 1
     /*  462125 */     // No operand predicates
     /*  462125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462157 */     GIR_RootConstrainSelectedInstOperands,
     /*  462158 */     // GIR_Coverage, 7599,
     /*  462158 */     GIR_EraseRootFromParent_Done,
     /*  462159 */   // Label 7908: @462159
     /*  462159 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(462245), // Rule ID 7602 //
     /*  462164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  462181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462211 */     // MIs[1] Operand 1
     /*  462211 */     // No operand predicates
     /*  462211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462220 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  462220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462243 */     GIR_RootConstrainSelectedInstOperands,
     /*  462244 */     // GIR_Coverage, 7602,
     /*  462244 */     GIR_EraseRootFromParent_Done,
     /*  462245 */   // Label 7909: @462245
     /*  462245 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(462331), // Rule ID 7603 //
     /*  462250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  462261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  462264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  462267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462297 */     // MIs[1] Operand 1
     /*  462297 */     // No operand predicates
     /*  462297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  462306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  462326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462329 */     GIR_RootConstrainSelectedInstOperands,
     /*  462330 */     // GIR_Coverage, 7603,
     /*  462330 */     GIR_EraseRootFromParent_Done,
     /*  462331 */   // Label 7910: @462331
     /*  462331 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(462417), // Rule ID 7606 //
     /*  462336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  462347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  462350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462383 */     // MIs[1] Operand 1
     /*  462383 */     // No operand predicates
     /*  462383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462392 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462415 */     GIR_RootConstrainSelectedInstOperands,
     /*  462416 */     // GIR_Coverage, 7606,
     /*  462416 */     GIR_EraseRootFromParent_Done,
     /*  462417 */   // Label 7911: @462417
     /*  462417 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(462503), // Rule ID 7607 //
     /*  462422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  462433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  462436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  462439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462469 */     // MIs[1] Operand 1
     /*  462469 */     // No operand predicates
     /*  462469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  462481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462501 */     GIR_RootConstrainSelectedInstOperands,
     /*  462502 */     // GIR_Coverage, 7607,
     /*  462502 */     GIR_EraseRootFromParent_Done,
     /*  462503 */   // Label 7912: @462503
     /*  462503 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(462589), // Rule ID 7610 //
     /*  462508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  462519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  462522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  462525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462555 */     // MIs[1] Operand 1
     /*  462555 */     // No operand predicates
     /*  462555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462587 */     GIR_RootConstrainSelectedInstOperands,
     /*  462588 */     // GIR_Coverage, 7610,
     /*  462588 */     GIR_EraseRootFromParent_Done,
     /*  462589 */   // Label 7913: @462589
     /*  462589 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(462675), // Rule ID 7611 //
     /*  462594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  462605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  462608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  462611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462641 */     // MIs[1] Operand 1
     /*  462641 */     // No operand predicates
     /*  462641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462673 */     GIR_RootConstrainSelectedInstOperands,
     /*  462674 */     // GIR_Coverage, 7611,
     /*  462674 */     GIR_EraseRootFromParent_Done,
     /*  462675 */   // Label 7914: @462675
     /*  462675 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(462761), // Rule ID 7614 //
     /*  462680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  462691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  462694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  462697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462727 */     // MIs[1] Operand 1
     /*  462727 */     // No operand predicates
     /*  462727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462759 */     GIR_RootConstrainSelectedInstOperands,
     /*  462760 */     // GIR_Coverage, 7614,
     /*  462760 */     GIR_EraseRootFromParent_Done,
     /*  462761 */   // Label 7915: @462761
     /*  462761 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(462847), // Rule ID 7615 //
     /*  462766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  462777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  462780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  462783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462813 */     // MIs[1] Operand 1
     /*  462813 */     // No operand predicates
     /*  462813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462845 */     GIR_RootConstrainSelectedInstOperands,
     /*  462846 */     // GIR_Coverage, 7615,
     /*  462846 */     GIR_EraseRootFromParent_Done,
     /*  462847 */   // Label 7916: @462847
     /*  462847 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(462933), // Rule ID 7618 //
     /*  462852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  462863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  462866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  462869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462899 */     // MIs[1] Operand 1
     /*  462899 */     // No operand predicates
     /*  462899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462931 */     GIR_RootConstrainSelectedInstOperands,
     /*  462932 */     // GIR_Coverage, 7618,
     /*  462932 */     GIR_EraseRootFromParent_Done,
     /*  462933 */   // Label 7917: @462933
     /*  462933 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(463019), // Rule ID 7619 //
     /*  462938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  462949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  462952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  462955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462985 */     // MIs[1] Operand 1
     /*  462985 */     // No operand predicates
     /*  462985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  463014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463017 */     GIR_RootConstrainSelectedInstOperands,
     /*  463018 */     // GIR_Coverage, 7619,
     /*  463018 */     GIR_EraseRootFromParent_Done,
     /*  463019 */   // Label 7918: @463019
     /*  463019 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(463105), // Rule ID 7742 //
     /*  463024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  463035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  463038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  463041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463071 */     // MIs[1] Operand 1
     /*  463071 */     // No operand predicates
     /*  463071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  463083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463103 */     GIR_RootConstrainSelectedInstOperands,
     /*  463104 */     // GIR_Coverage, 7742,
     /*  463104 */     GIR_EraseRootFromParent_Done,
     /*  463105 */   // Label 7919: @463105
     /*  463105 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(463191), // Rule ID 7743 //
     /*  463110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  463121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  463124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  463127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463157 */     // MIs[1] Operand 1
     /*  463157 */     // No operand predicates
     /*  463157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463166 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  463169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463189 */     GIR_RootConstrainSelectedInstOperands,
     /*  463190 */     // GIR_Coverage, 7743,
     /*  463190 */     GIR_EraseRootFromParent_Done,
     /*  463191 */   // Label 7920: @463191
     /*  463191 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(463277), // Rule ID 7746 //
     /*  463196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  463207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  463210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  463213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463243 */     // MIs[1] Operand 1
     /*  463243 */     // No operand predicates
     /*  463243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463275 */     GIR_RootConstrainSelectedInstOperands,
     /*  463276 */     // GIR_Coverage, 7746,
     /*  463276 */     GIR_EraseRootFromParent_Done,
     /*  463277 */   // Label 7921: @463277
     /*  463277 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(463363), // Rule ID 7747 //
     /*  463282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  463293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  463296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  463299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463329 */     // MIs[1] Operand 1
     /*  463329 */     // No operand predicates
     /*  463329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463338 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463361 */     GIR_RootConstrainSelectedInstOperands,
     /*  463362 */     // GIR_Coverage, 7747,
     /*  463362 */     GIR_EraseRootFromParent_Done,
     /*  463363 */   // Label 7922: @463363
     /*  463363 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(463449), // Rule ID 7750 //
     /*  463368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  463379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  463382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463415 */     // MIs[1] Operand 1
     /*  463415 */     // No operand predicates
     /*  463415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463447 */     GIR_RootConstrainSelectedInstOperands,
     /*  463448 */     // GIR_Coverage, 7750,
     /*  463448 */     GIR_EraseRootFromParent_Done,
     /*  463449 */   // Label 7923: @463449
     /*  463449 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(463535), // Rule ID 7751 //
     /*  463454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  463465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  463468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  463471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463501 */     // MIs[1] Operand 1
     /*  463501 */     // No operand predicates
     /*  463501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463510 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463533 */     GIR_RootConstrainSelectedInstOperands,
     /*  463534 */     // GIR_Coverage, 7751,
     /*  463534 */     GIR_EraseRootFromParent_Done,
     /*  463535 */   // Label 7924: @463535
     /*  463535 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(463621), // Rule ID 7754 //
     /*  463540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  463551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  463554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  463557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463587 */     // MIs[1] Operand 1
     /*  463587 */     // No operand predicates
     /*  463587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  463599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463619 */     GIR_RootConstrainSelectedInstOperands,
     /*  463620 */     // GIR_Coverage, 7754,
     /*  463620 */     GIR_EraseRootFromParent_Done,
     /*  463621 */   // Label 7925: @463621
     /*  463621 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(463707), // Rule ID 7755 //
     /*  463626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  463637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  463640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  463643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463673 */     // MIs[1] Operand 1
     /*  463673 */     // No operand predicates
     /*  463673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463682 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  463685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463705 */     GIR_RootConstrainSelectedInstOperands,
     /*  463706 */     // GIR_Coverage, 7755,
     /*  463706 */     GIR_EraseRootFromParent_Done,
     /*  463707 */   // Label 7926: @463707
     /*  463707 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(463793), // Rule ID 7758 //
     /*  463712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  463723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  463726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  463729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463759 */     // MIs[1] Operand 1
     /*  463759 */     // No operand predicates
     /*  463759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463768 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  463771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463791 */     GIR_RootConstrainSelectedInstOperands,
     /*  463792 */     // GIR_Coverage, 7758,
     /*  463792 */     GIR_EraseRootFromParent_Done,
     /*  463793 */   // Label 7927: @463793
     /*  463793 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(463879), // Rule ID 7759 //
     /*  463798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  463809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  463812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  463815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463845 */     // MIs[1] Operand 1
     /*  463845 */     // No operand predicates
     /*  463845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463854 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  463857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463877 */     GIR_RootConstrainSelectedInstOperands,
     /*  463878 */     // GIR_Coverage, 7759,
     /*  463878 */     GIR_EraseRootFromParent_Done,
     /*  463879 */   // Label 7928: @463879
     /*  463879 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(463965), // Rule ID 7762 //
     /*  463884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  463895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  463898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463931 */     // MIs[1] Operand 1
     /*  463931 */     // No operand predicates
     /*  463931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463940 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  463943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463963 */     GIR_RootConstrainSelectedInstOperands,
     /*  463964 */     // GIR_Coverage, 7762,
     /*  463964 */     GIR_EraseRootFromParent_Done,
     /*  463965 */   // Label 7929: @463965
     /*  463965 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(464051), // Rule ID 7763 //
     /*  463970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  463981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  463984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464017 */     // MIs[1] Operand 1
     /*  464017 */     // No operand predicates
     /*  464017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464026 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  464026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  464046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464049 */     GIR_RootConstrainSelectedInstOperands,
     /*  464050 */     // GIR_Coverage, 7763,
     /*  464050 */     GIR_EraseRootFromParent_Done,
     /*  464051 */   // Label 7930: @464051
     /*  464051 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(464137), // Rule ID 7766 //
     /*  464056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  464067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  464070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  464073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464103 */     // MIs[1] Operand 1
     /*  464103 */     // No operand predicates
     /*  464103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464112 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  464115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464135 */     GIR_RootConstrainSelectedInstOperands,
     /*  464136 */     // GIR_Coverage, 7766,
     /*  464136 */     GIR_EraseRootFromParent_Done,
     /*  464137 */   // Label 7931: @464137
     /*  464137 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(464223), // Rule ID 7767 //
     /*  464142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  464153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  464156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  464159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464189 */     // MIs[1] Operand 1
     /*  464189 */     // No operand predicates
     /*  464189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  464201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464221 */     GIR_RootConstrainSelectedInstOperands,
     /*  464222 */     // GIR_Coverage, 7767,
     /*  464222 */     GIR_EraseRootFromParent_Done,
     /*  464223 */   // Label 7932: @464223
     /*  464223 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(464309), // Rule ID 7770 //
     /*  464228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  464239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  464242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  464245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464275 */     // MIs[1] Operand 1
     /*  464275 */     // No operand predicates
     /*  464275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464307 */     GIR_RootConstrainSelectedInstOperands,
     /*  464308 */     // GIR_Coverage, 7770,
     /*  464308 */     GIR_EraseRootFromParent_Done,
     /*  464309 */   // Label 7933: @464309
     /*  464309 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(464395), // Rule ID 7771 //
     /*  464314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  464325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  464328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  464331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464361 */     // MIs[1] Operand 1
     /*  464361 */     // No operand predicates
     /*  464361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464370 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464393 */     GIR_RootConstrainSelectedInstOperands,
     /*  464394 */     // GIR_Coverage, 7771,
     /*  464394 */     GIR_EraseRootFromParent_Done,
     /*  464395 */   // Label 7934: @464395
     /*  464395 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(464481), // Rule ID 7774 //
     /*  464400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  464411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  464414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464447 */     // MIs[1] Operand 1
     /*  464447 */     // No operand predicates
     /*  464447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464456 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464479 */     GIR_RootConstrainSelectedInstOperands,
     /*  464480 */     // GIR_Coverage, 7774,
     /*  464480 */     GIR_EraseRootFromParent_Done,
     /*  464481 */   // Label 7935: @464481
     /*  464481 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(464567), // Rule ID 7775 //
     /*  464486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  464497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  464500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  464503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464533 */     // MIs[1] Operand 1
     /*  464533 */     // No operand predicates
     /*  464533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464542 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464565 */     GIR_RootConstrainSelectedInstOperands,
     /*  464566 */     // GIR_Coverage, 7775,
     /*  464566 */     GIR_EraseRootFromParent_Done,
     /*  464567 */   // Label 7936: @464567
     /*  464567 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(464653), // Rule ID 7778 //
     /*  464572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  464583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  464586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  464589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464619 */     // MIs[1] Operand 1
     /*  464619 */     // No operand predicates
     /*  464619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464628 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464651 */     GIR_RootConstrainSelectedInstOperands,
     /*  464652 */     // GIR_Coverage, 7778,
     /*  464652 */     GIR_EraseRootFromParent_Done,
     /*  464653 */   // Label 7937: @464653
     /*  464653 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(464739), // Rule ID 7779 //
     /*  464658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  464669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  464672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  464675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464705 */     // MIs[1] Operand 1
     /*  464705 */     // No operand predicates
     /*  464705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464737 */     GIR_RootConstrainSelectedInstOperands,
     /*  464738 */     // GIR_Coverage, 7779,
     /*  464738 */     GIR_EraseRootFromParent_Done,
     /*  464739 */   // Label 7938: @464739
     /*  464739 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(464825), // Rule ID 7782 //
     /*  464744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  464755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  464758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  464761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464791 */     // MIs[1] Operand 1
     /*  464791 */     // No operand predicates
     /*  464791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464800 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464823 */     GIR_RootConstrainSelectedInstOperands,
     /*  464824 */     // GIR_Coverage, 7782,
     /*  464824 */     GIR_EraseRootFromParent_Done,
     /*  464825 */   // Label 7939: @464825
     /*  464825 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(464911), // Rule ID 7783 //
     /*  464830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  464841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  464844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  464847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464877 */     // MIs[1] Operand 1
     /*  464877 */     // No operand predicates
     /*  464877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464886 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464909 */     GIR_RootConstrainSelectedInstOperands,
     /*  464910 */     // GIR_Coverage, 7783,
     /*  464910 */     GIR_EraseRootFromParent_Done,
     /*  464911 */   // Label 7940: @464911
     /*  464911 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(464997), // Rule ID 7786 //
     /*  464916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  464919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  464927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  464930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  464933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464963 */     // MIs[1] Operand 1
     /*  464963 */     // No operand predicates
     /*  464963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  464972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464995 */     GIR_RootConstrainSelectedInstOperands,
     /*  464996 */     // GIR_Coverage, 7786,
     /*  464996 */     GIR_EraseRootFromParent_Done,
     /*  464997 */   // Label 7941: @464997
     /*  464997 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(465083), // Rule ID 7787 //
     /*  465002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  465013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  465016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  465019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465049 */     // MIs[1] Operand 1
     /*  465049 */     // No operand predicates
     /*  465049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  465061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465081 */     GIR_RootConstrainSelectedInstOperands,
     /*  465082 */     // GIR_Coverage, 7787,
     /*  465082 */     GIR_EraseRootFromParent_Done,
     /*  465083 */   // Label 7942: @465083
     /*  465083 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(465169), // Rule ID 7790 //
     /*  465088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  465099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  465102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465135 */     // MIs[1] Operand 1
     /*  465135 */     // No operand predicates
     /*  465135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465167 */     GIR_RootConstrainSelectedInstOperands,
     /*  465168 */     // GIR_Coverage, 7790,
     /*  465168 */     GIR_EraseRootFromParent_Done,
     /*  465169 */   // Label 7943: @465169
     /*  465169 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(465255), // Rule ID 7791 //
     /*  465174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  465185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  465188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  465191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465221 */     // MIs[1] Operand 1
     /*  465221 */     // No operand predicates
     /*  465221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  465233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465253 */     GIR_RootConstrainSelectedInstOperands,
     /*  465254 */     // GIR_Coverage, 7791,
     /*  465254 */     GIR_EraseRootFromParent_Done,
     /*  465255 */   // Label 7944: @465255
     /*  465255 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(465341), // Rule ID 7794 //
     /*  465260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  465271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  465274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465307 */     // MIs[1] Operand 1
     /*  465307 */     // No operand predicates
     /*  465307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465339 */     GIR_RootConstrainSelectedInstOperands,
     /*  465340 */     // GIR_Coverage, 7794,
     /*  465340 */     GIR_EraseRootFromParent_Done,
     /*  465341 */   // Label 7945: @465341
     /*  465341 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(465427), // Rule ID 7795 //
     /*  465346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  465357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  465360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  465363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  465377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465393 */     // MIs[1] Operand 1
     /*  465393 */     // No operand predicates
     /*  465393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  465405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465425 */     GIR_RootConstrainSelectedInstOperands,
     /*  465426 */     // GIR_Coverage, 7795,
     /*  465426 */     GIR_EraseRootFromParent_Done,
     /*  465427 */   // Label 7946: @465427
     /*  465427 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(465513), // Rule ID 7798 //
     /*  465432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  465435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  465443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  465446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  465449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465479 */     // MIs[1] Operand 1
     /*  465479 */     // No operand predicates
     /*  465479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  465488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465511 */     GIR_RootConstrainSelectedInstOperands,
     /*  465512 */     // GIR_Coverage, 7798,
     /*  465512 */     GIR_EraseRootFromParent_Done,
     /*  465513 */   // Label 7947: @465513
     /*  465513 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(465599), // Rule ID 7799 //
     /*  465518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  465529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  465532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  465535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465565 */     // MIs[1] Operand 1
     /*  465565 */     // No operand predicates
     /*  465565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465597 */     GIR_RootConstrainSelectedInstOperands,
     /*  465598 */     // GIR_Coverage, 7799,
     /*  465598 */     GIR_EraseRootFromParent_Done,
     /*  465599 */   // Label 7948: @465599
     /*  465599 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(465688), // Rule ID 14228 //
     /*  465604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  465615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  465618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  465621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465651 */     // MIs[1] Operand 1
     /*  465651 */     // No operand predicates
     /*  465651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465660 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  465663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465686 */     GIR_RootConstrainSelectedInstOperands,
     /*  465687 */     // GIR_Coverage, 14228,
     /*  465687 */     GIR_EraseRootFromParent_Done,
     /*  465688 */   // Label 7949: @465688
     /*  465688 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(465777), // Rule ID 14229 //
     /*  465693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  465704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  465707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  465710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465740 */     // MIs[1] Operand 1
     /*  465740 */     // No operand predicates
     /*  465740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465749 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  465752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465775 */     GIR_RootConstrainSelectedInstOperands,
     /*  465776 */     // GIR_Coverage, 14229,
     /*  465776 */     GIR_EraseRootFromParent_Done,
     /*  465777 */   // Label 7950: @465777
     /*  465777 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(465866), // Rule ID 14232 //
     /*  465782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  465793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  465796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  465799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465829 */     // MIs[1] Operand 1
     /*  465829 */     // No operand predicates
     /*  465829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  465841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465864 */     GIR_RootConstrainSelectedInstOperands,
     /*  465865 */     // GIR_Coverage, 14232,
     /*  465865 */     GIR_EraseRootFromParent_Done,
     /*  465866 */   // Label 7951: @465866
     /*  465866 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(465955), // Rule ID 14233 //
     /*  465871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  465882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  465885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  465888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465918 */     // MIs[1] Operand 1
     /*  465918 */     // No operand predicates
     /*  465918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465927 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  465930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465953 */     GIR_RootConstrainSelectedInstOperands,
     /*  465954 */     // GIR_Coverage, 14233,
     /*  465954 */     GIR_EraseRootFromParent_Done,
     /*  465955 */   // Label 7952: @465955
     /*  465955 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(466044), // Rule ID 14236 //
     /*  465960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  465971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  465974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  465977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466007 */     // MIs[1] Operand 1
     /*  466007 */     // No operand predicates
     /*  466007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466016 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466042 */     GIR_RootConstrainSelectedInstOperands,
     /*  466043 */     // GIR_Coverage, 14236,
     /*  466043 */     GIR_EraseRootFromParent_Done,
     /*  466044 */   // Label 7953: @466044
     /*  466044 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(466133), // Rule ID 14237 //
     /*  466049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  466060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  466063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  466066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466096 */     // MIs[1] Operand 1
     /*  466096 */     // No operand predicates
     /*  466096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466105 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466131 */     GIR_RootConstrainSelectedInstOperands,
     /*  466132 */     // GIR_Coverage, 14237,
     /*  466132 */     GIR_EraseRootFromParent_Done,
     /*  466133 */   // Label 7954: @466133
     /*  466133 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(466222), // Rule ID 14240 //
     /*  466138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466185 */     // MIs[1] Operand 1
     /*  466185 */     // No operand predicates
     /*  466185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466220 */     GIR_RootConstrainSelectedInstOperands,
     /*  466221 */     // GIR_Coverage, 14240,
     /*  466221 */     GIR_EraseRootFromParent_Done,
     /*  466222 */   // Label 7955: @466222
     /*  466222 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(466311), // Rule ID 14241 //
     /*  466227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  466238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  466241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  466244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466274 */     // MIs[1] Operand 1
     /*  466274 */     // No operand predicates
     /*  466274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466283 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  466286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466309 */     GIR_RootConstrainSelectedInstOperands,
     /*  466310 */     // GIR_Coverage, 14241,
     /*  466310 */     GIR_EraseRootFromParent_Done,
     /*  466311 */   // Label 7956: @466311
     /*  466311 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(466400), // Rule ID 14244 //
     /*  466316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466363 */     // MIs[1] Operand 1
     /*  466363 */     // No operand predicates
     /*  466363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466372 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466398 */     GIR_RootConstrainSelectedInstOperands,
     /*  466399 */     // GIR_Coverage, 14244,
     /*  466399 */     GIR_EraseRootFromParent_Done,
     /*  466400 */   // Label 7957: @466400
     /*  466400 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(466489), // Rule ID 14245 //
     /*  466405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  466416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  466419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  466422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466452 */     // MIs[1] Operand 1
     /*  466452 */     // No operand predicates
     /*  466452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466461 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466487 */     GIR_RootConstrainSelectedInstOperands,
     /*  466488 */     // GIR_Coverage, 14245,
     /*  466488 */     GIR_EraseRootFromParent_Done,
     /*  466489 */   // Label 7958: @466489
     /*  466489 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(466578), // Rule ID 14248 //
     /*  466494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466541 */     // MIs[1] Operand 1
     /*  466541 */     // No operand predicates
     /*  466541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466550 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466576 */     GIR_RootConstrainSelectedInstOperands,
     /*  466577 */     // GIR_Coverage, 14248,
     /*  466577 */     GIR_EraseRootFromParent_Done,
     /*  466578 */   // Label 7959: @466578
     /*  466578 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(466667), // Rule ID 14249 //
     /*  466583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466630 */     // MIs[1] Operand 1
     /*  466630 */     // No operand predicates
     /*  466630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466639 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466665 */     GIR_RootConstrainSelectedInstOperands,
     /*  466666 */     // GIR_Coverage, 14249,
     /*  466666 */     GIR_EraseRootFromParent_Done,
     /*  466667 */   // Label 7960: @466667
     /*  466667 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(466756), // Rule ID 14252 //
     /*  466672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  466683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  466686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  466689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466719 */     // MIs[1] Operand 1
     /*  466719 */     // No operand predicates
     /*  466719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466728 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466754 */     GIR_RootConstrainSelectedInstOperands,
     /*  466755 */     // GIR_Coverage, 14252,
     /*  466755 */     GIR_EraseRootFromParent_Done,
     /*  466756 */   // Label 7961: @466756
     /*  466756 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(466845), // Rule ID 14253 //
     /*  466761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  466772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  466775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  466778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466808 */     // MIs[1] Operand 1
     /*  466808 */     // No operand predicates
     /*  466808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466817 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466843 */     GIR_RootConstrainSelectedInstOperands,
     /*  466844 */     // GIR_Coverage, 14253,
     /*  466844 */     GIR_EraseRootFromParent_Done,
     /*  466845 */   // Label 7962: @466845
     /*  466845 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(466934), // Rule ID 14256 //
     /*  466850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  466861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  466864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  466867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466897 */     // MIs[1] Operand 1
     /*  466897 */     // No operand predicates
     /*  466897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466932 */     GIR_RootConstrainSelectedInstOperands,
     /*  466933 */     // GIR_Coverage, 14256,
     /*  466933 */     GIR_EraseRootFromParent_Done,
     /*  466934 */   // Label 7963: @466934
     /*  466934 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(467023), // Rule ID 14257 //
     /*  466939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  466950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  466953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  466956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466986 */     // MIs[1] Operand 1
     /*  466986 */     // No operand predicates
     /*  466986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466995 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467021 */     GIR_RootConstrainSelectedInstOperands,
     /*  467022 */     // GIR_Coverage, 14257,
     /*  467022 */     GIR_EraseRootFromParent_Done,
     /*  467023 */   // Label 7964: @467023
     /*  467023 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(467112), // Rule ID 14260 //
     /*  467028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  467039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  467042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  467045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467075 */     // MIs[1] Operand 1
     /*  467075 */     // No operand predicates
     /*  467075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  467084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467110 */     GIR_RootConstrainSelectedInstOperands,
     /*  467111 */     // GIR_Coverage, 14260,
     /*  467111 */     GIR_EraseRootFromParent_Done,
     /*  467112 */   // Label 7965: @467112
     /*  467112 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(467201), // Rule ID 14261 //
     /*  467117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  467128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  467131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  467134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467164 */     // MIs[1] Operand 1
     /*  467164 */     // No operand predicates
     /*  467164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467173 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  467173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  467193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467199 */     GIR_RootConstrainSelectedInstOperands,
     /*  467200 */     // GIR_Coverage, 14261,
     /*  467200 */     GIR_EraseRootFromParent_Done,
     /*  467201 */   // Label 7966: @467201
     /*  467201 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(467290), // Rule ID 14264 //
     /*  467206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  467209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  467217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  467220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467253 */     // MIs[1] Operand 1
     /*  467253 */     // No operand predicates
     /*  467253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467262 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  467262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467288 */     GIR_RootConstrainSelectedInstOperands,
     /*  467289 */     // GIR_Coverage, 14264,
     /*  467289 */     GIR_EraseRootFromParent_Done,
     /*  467290 */   // Label 7967: @467290
     /*  467290 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(467379), // Rule ID 14265 //
     /*  467295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  467298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  467306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  467309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  467312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  467330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467342 */     // MIs[1] Operand 1
     /*  467342 */     // No operand predicates
     /*  467342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467351 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  467351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  467354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  467371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467377 */     GIR_RootConstrainSelectedInstOperands,
     /*  467378 */     // GIR_Coverage, 14265,
     /*  467378 */     GIR_EraseRootFromParent_Done,
     /*  467379 */   // Label 7968: @467379
     /*  467379 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(467468), // Rule ID 14268 //
     /*  467384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467431 */     // MIs[1] Operand 1
     /*  467431 */     // No operand predicates
     /*  467431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467440 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467466 */     GIR_RootConstrainSelectedInstOperands,
     /*  467467 */     // GIR_Coverage, 14268,
     /*  467467 */     GIR_EraseRootFromParent_Done,
     /*  467468 */   // Label 7969: @467468
     /*  467468 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(467557), // Rule ID 14269 //
     /*  467473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  467484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  467487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  467490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467520 */     // MIs[1] Operand 1
     /*  467520 */     // No operand predicates
     /*  467520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467529 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467555 */     GIR_RootConstrainSelectedInstOperands,
     /*  467556 */     // GIR_Coverage, 14269,
     /*  467556 */     GIR_EraseRootFromParent_Done,
     /*  467557 */   // Label 7970: @467557
     /*  467557 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(467646), // Rule ID 14272 //
     /*  467562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  467579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467609 */     // MIs[1] Operand 1
     /*  467609 */     // No operand predicates
     /*  467609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  467621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467644 */     GIR_RootConstrainSelectedInstOperands,
     /*  467645 */     // GIR_Coverage, 14272,
     /*  467645 */     GIR_EraseRootFromParent_Done,
     /*  467646 */   // Label 7971: @467646
     /*  467646 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(467735), // Rule ID 14273 //
     /*  467651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  467668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467698 */     // MIs[1] Operand 1
     /*  467698 */     // No operand predicates
     /*  467698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467707 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  467710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467733 */     GIR_RootConstrainSelectedInstOperands,
     /*  467734 */     // GIR_Coverage, 14273,
     /*  467734 */     GIR_EraseRootFromParent_Done,
     /*  467735 */   // Label 7972: @467735
     /*  467735 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(467824), // Rule ID 14276 //
     /*  467740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  467751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  467754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  467757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467787 */     // MIs[1] Operand 1
     /*  467787 */     // No operand predicates
     /*  467787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  467799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467822 */     GIR_RootConstrainSelectedInstOperands,
     /*  467823 */     // GIR_Coverage, 14276,
     /*  467823 */     GIR_EraseRootFromParent_Done,
     /*  467824 */   // Label 7973: @467824
     /*  467824 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(467913), // Rule ID 14277 //
     /*  467829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  467840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  467843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  467846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467876 */     // MIs[1] Operand 1
     /*  467876 */     // No operand predicates
     /*  467876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467885 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  467888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467911 */     GIR_RootConstrainSelectedInstOperands,
     /*  467912 */     // GIR_Coverage, 14277,
     /*  467912 */     GIR_EraseRootFromParent_Done,
     /*  467913 */   // Label 7974: @467913
     /*  467913 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(468002), // Rule ID 14280 //
     /*  467918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  467929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  467932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467965 */     // MIs[1] Operand 1
     /*  467965 */     // No operand predicates
     /*  467965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468000 */     GIR_RootConstrainSelectedInstOperands,
     /*  468001 */     // GIR_Coverage, 14280,
     /*  468001 */     GIR_EraseRootFromParent_Done,
     /*  468002 */   // Label 7975: @468002
     /*  468002 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(468091), // Rule ID 14281 //
     /*  468007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  468018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  468021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  468024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468054 */     // MIs[1] Operand 1
     /*  468054 */     // No operand predicates
     /*  468054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468063 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468089 */     GIR_RootConstrainSelectedInstOperands,
     /*  468090 */     // GIR_Coverage, 14281,
     /*  468090 */     GIR_EraseRootFromParent_Done,
     /*  468091 */   // Label 7976: @468091
     /*  468091 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(468180), // Rule ID 14284 //
     /*  468096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  468113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468143 */     // MIs[1] Operand 1
     /*  468143 */     // No operand predicates
     /*  468143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468178 */     GIR_RootConstrainSelectedInstOperands,
     /*  468179 */     // GIR_Coverage, 14284,
     /*  468179 */     GIR_EraseRootFromParent_Done,
     /*  468180 */   // Label 7977: @468180
     /*  468180 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(468269), // Rule ID 14285 //
     /*  468185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  468196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  468199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  468202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468232 */     // MIs[1] Operand 1
     /*  468232 */     // No operand predicates
     /*  468232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468241 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468267 */     GIR_RootConstrainSelectedInstOperands,
     /*  468268 */     // GIR_Coverage, 14285,
     /*  468268 */     GIR_EraseRootFromParent_Done,
     /*  468269 */   // Label 7978: @468269
     /*  468269 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(468358), // Rule ID 14288 //
     /*  468274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  468285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  468288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  468291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468321 */     // MIs[1] Operand 1
     /*  468321 */     // No operand predicates
     /*  468321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468330 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  468330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468356 */     GIR_RootConstrainSelectedInstOperands,
     /*  468357 */     // GIR_Coverage, 14288,
     /*  468357 */     GIR_EraseRootFromParent_Done,
     /*  468358 */   // Label 7979: @468358
     /*  468358 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(468447), // Rule ID 14289 //
     /*  468363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  468374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  468377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  468380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468410 */     // MIs[1] Operand 1
     /*  468410 */     // No operand predicates
     /*  468410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468419 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  468419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  468439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468445 */     GIR_RootConstrainSelectedInstOperands,
     /*  468446 */     // GIR_Coverage, 14289,
     /*  468446 */     GIR_EraseRootFromParent_Done,
     /*  468447 */   // Label 7980: @468447
     /*  468447 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(468536), // Rule ID 14292 //
     /*  468452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  468463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  468466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468499 */     // MIs[1] Operand 1
     /*  468499 */     // No operand predicates
     /*  468499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468534 */     GIR_RootConstrainSelectedInstOperands,
     /*  468535 */     // GIR_Coverage, 14292,
     /*  468535 */     GIR_EraseRootFromParent_Done,
     /*  468536 */   // Label 7981: @468536
     /*  468536 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(468625), // Rule ID 14293 //
     /*  468541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  468552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  468555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468588 */     // MIs[1] Operand 1
     /*  468588 */     // No operand predicates
     /*  468588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468623 */     GIR_RootConstrainSelectedInstOperands,
     /*  468624 */     // GIR_Coverage, 14293,
     /*  468624 */     GIR_EraseRootFromParent_Done,
     /*  468625 */   // Label 7982: @468625
     /*  468625 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(468714), // Rule ID 14296 //
     /*  468630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  468641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  468644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468677 */     // MIs[1] Operand 1
     /*  468677 */     // No operand predicates
     /*  468677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468712 */     GIR_RootConstrainSelectedInstOperands,
     /*  468713 */     // GIR_Coverage, 14296,
     /*  468713 */     GIR_EraseRootFromParent_Done,
     /*  468714 */   // Label 7983: @468714
     /*  468714 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(468803), // Rule ID 14297 //
     /*  468719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  468730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  468733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468766 */     // MIs[1] Operand 1
     /*  468766 */     // No operand predicates
     /*  468766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468775 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468801 */     GIR_RootConstrainSelectedInstOperands,
     /*  468802 */     // GIR_Coverage, 14297,
     /*  468802 */     GIR_EraseRootFromParent_Done,
     /*  468803 */   // Label 7984: @468803
     /*  468803 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(468892), // Rule ID 14300 //
     /*  468808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  468819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  468822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468855 */     // MIs[1] Operand 1
     /*  468855 */     // No operand predicates
     /*  468855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468890 */     GIR_RootConstrainSelectedInstOperands,
     /*  468891 */     // GIR_Coverage, 14300,
     /*  468891 */     GIR_EraseRootFromParent_Done,
     /*  468892 */   // Label 7985: @468892
     /*  468892 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(468981), // Rule ID 14301 //
     /*  468897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  468908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  468911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468944 */     // MIs[1] Operand 1
     /*  468944 */     // No operand predicates
     /*  468944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468953 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468979 */     GIR_RootConstrainSelectedInstOperands,
     /*  468980 */     // GIR_Coverage, 14301,
     /*  468980 */     GIR_EraseRootFromParent_Done,
     /*  468981 */   // Label 7986: @468981
     /*  468981 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(469070), // Rule ID 14304 //
     /*  468986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  468989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  468997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  469000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469033 */     // MIs[1] Operand 1
     /*  469033 */     // No operand predicates
     /*  469033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469068 */     GIR_RootConstrainSelectedInstOperands,
     /*  469069 */     // GIR_Coverage, 14304,
     /*  469069 */     GIR_EraseRootFromParent_Done,
     /*  469070 */   // Label 7987: @469070
     /*  469070 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(469159), // Rule ID 14305 //
     /*  469075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  469086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  469089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  469092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  469110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469122 */     // MIs[1] Operand 1
     /*  469122 */     // No operand predicates
     /*  469122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469131 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  469134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469157 */     GIR_RootConstrainSelectedInstOperands,
     /*  469158 */     // GIR_Coverage, 14305,
     /*  469158 */     GIR_EraseRootFromParent_Done,
     /*  469159 */   // Label 7988: @469159
     /*  469159 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(469248), // Rule ID 14308 //
     /*  469164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  469175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  469178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469211 */     // MIs[1] Operand 1
     /*  469211 */     // No operand predicates
     /*  469211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469246 */     GIR_RootConstrainSelectedInstOperands,
     /*  469247 */     // GIR_Coverage, 14308,
     /*  469247 */     GIR_EraseRootFromParent_Done,
     /*  469248 */   // Label 7989: @469248
     /*  469248 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(469337), // Rule ID 14309 //
     /*  469253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  469264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  469267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  469270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  469288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469300 */     // MIs[1] Operand 1
     /*  469300 */     // No operand predicates
     /*  469300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469309 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  469312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469335 */     GIR_RootConstrainSelectedInstOperands,
     /*  469336 */     // GIR_Coverage, 14309,
     /*  469336 */     GIR_EraseRootFromParent_Done,
     /*  469337 */   // Label 7990: @469337
     /*  469337 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(469426), // Rule ID 14312 //
     /*  469342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  469345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  469353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  469356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469389 */     // MIs[1] Operand 1
     /*  469389 */     // No operand predicates
     /*  469389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469398 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  469398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469424 */     GIR_RootConstrainSelectedInstOperands,
     /*  469425 */     // GIR_Coverage, 14312,
     /*  469425 */     GIR_EraseRootFromParent_Done,
     /*  469426 */   // Label 7991: @469426
     /*  469426 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(469515), // Rule ID 14313 //
     /*  469431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  469434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  469439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  469442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  469445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  469448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  469466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469478 */     // MIs[1] Operand 1
     /*  469478 */     // No operand predicates
     /*  469478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469487 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  469487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  469490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  469507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469513 */     GIR_RootConstrainSelectedInstOperands,
     /*  469514 */     // GIR_Coverage, 14313,
     /*  469514 */     GIR_EraseRootFromParent_Done,
     /*  469515 */   // Label 7992: @469515
     /*  469515 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(469604), // Rule ID 14492 //
     /*  469520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469567 */     // MIs[1] Operand 1
     /*  469567 */     // No operand predicates
     /*  469567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469576 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  469579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469602 */     GIR_RootConstrainSelectedInstOperands,
     /*  469603 */     // GIR_Coverage, 14492,
     /*  469603 */     GIR_EraseRootFromParent_Done,
     /*  469604 */   // Label 7993: @469604
     /*  469604 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(469693), // Rule ID 14493 //
     /*  469609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469656 */     // MIs[1] Operand 1
     /*  469656 */     // No operand predicates
     /*  469656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469665 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  469668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469691 */     GIR_RootConstrainSelectedInstOperands,
     /*  469692 */     // GIR_Coverage, 14493,
     /*  469692 */     GIR_EraseRootFromParent_Done,
     /*  469693 */   // Label 7994: @469693
     /*  469693 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(469782), // Rule ID 14496 //
     /*  469698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469745 */     // MIs[1] Operand 1
     /*  469745 */     // No operand predicates
     /*  469745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469754 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  469757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469780 */     GIR_RootConstrainSelectedInstOperands,
     /*  469781 */     // GIR_Coverage, 14496,
     /*  469781 */     GIR_EraseRootFromParent_Done,
     /*  469782 */   // Label 7995: @469782
     /*  469782 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(469871), // Rule ID 14497 //
     /*  469787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469834 */     // MIs[1] Operand 1
     /*  469834 */     // No operand predicates
     /*  469834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469843 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  469846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469869 */     GIR_RootConstrainSelectedInstOperands,
     /*  469870 */     // GIR_Coverage, 14497,
     /*  469870 */     GIR_EraseRootFromParent_Done,
     /*  469871 */   // Label 7996: @469871
     /*  469871 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(469960), // Rule ID 14500 //
     /*  469876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469923 */     // MIs[1] Operand 1
     /*  469923 */     // No operand predicates
     /*  469923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469932 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  469935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469958 */     GIR_RootConstrainSelectedInstOperands,
     /*  469959 */     // GIR_Coverage, 14500,
     /*  469959 */     GIR_EraseRootFromParent_Done,
     /*  469960 */   // Label 7997: @469960
     /*  469960 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(470049), // Rule ID 14501 //
     /*  469965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470012 */     // MIs[1] Operand 1
     /*  470012 */     // No operand predicates
     /*  470012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470021 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470047 */     GIR_RootConstrainSelectedInstOperands,
     /*  470048 */     // GIR_Coverage, 14501,
     /*  470048 */     GIR_EraseRootFromParent_Done,
     /*  470049 */   // Label 7998: @470049
     /*  470049 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(470138), // Rule ID 14504 //
     /*  470054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470101 */     // MIs[1] Operand 1
     /*  470101 */     // No operand predicates
     /*  470101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470136 */     GIR_RootConstrainSelectedInstOperands,
     /*  470137 */     // GIR_Coverage, 14504,
     /*  470137 */     GIR_EraseRootFromParent_Done,
     /*  470138 */   // Label 7999: @470138
     /*  470138 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(470227), // Rule ID 14505 //
     /*  470143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  470154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  470157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  470160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470190 */     // MIs[1] Operand 1
     /*  470190 */     // No operand predicates
     /*  470190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470199 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  470202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470225 */     GIR_RootConstrainSelectedInstOperands,
     /*  470226 */     // GIR_Coverage, 14505,
     /*  470226 */     GIR_EraseRootFromParent_Done,
     /*  470227 */   // Label 8000: @470227
     /*  470227 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(470316), // Rule ID 14508 //
     /*  470232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470279 */     // MIs[1] Operand 1
     /*  470279 */     // No operand predicates
     /*  470279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470288 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470314 */     GIR_RootConstrainSelectedInstOperands,
     /*  470315 */     // GIR_Coverage, 14508,
     /*  470315 */     GIR_EraseRootFromParent_Done,
     /*  470316 */   // Label 8001: @470316
     /*  470316 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(470405), // Rule ID 14509 //
     /*  470321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  470332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  470335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  470338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470368 */     // MIs[1] Operand 1
     /*  470368 */     // No operand predicates
     /*  470368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470377 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470403 */     GIR_RootConstrainSelectedInstOperands,
     /*  470404 */     // GIR_Coverage, 14509,
     /*  470404 */     GIR_EraseRootFromParent_Done,
     /*  470405 */   // Label 8002: @470405
     /*  470405 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(470494), // Rule ID 14512 //
     /*  470410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470457 */     // MIs[1] Operand 1
     /*  470457 */     // No operand predicates
     /*  470457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470492 */     GIR_RootConstrainSelectedInstOperands,
     /*  470493 */     // GIR_Coverage, 14512,
     /*  470493 */     GIR_EraseRootFromParent_Done,
     /*  470494 */   // Label 8003: @470494
     /*  470494 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(470583), // Rule ID 14513 //
     /*  470499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470546 */     // MIs[1] Operand 1
     /*  470546 */     // No operand predicates
     /*  470546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470555 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  470555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470581 */     GIR_RootConstrainSelectedInstOperands,
     /*  470582 */     // GIR_Coverage, 14513,
     /*  470582 */     GIR_EraseRootFromParent_Done,
     /*  470583 */   // Label 8004: @470583
     /*  470583 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(470672), // Rule ID 14516 //
     /*  470588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470635 */     // MIs[1] Operand 1
     /*  470635 */     // No operand predicates
     /*  470635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470670 */     GIR_RootConstrainSelectedInstOperands,
     /*  470671 */     // GIR_Coverage, 14516,
     /*  470671 */     GIR_EraseRootFromParent_Done,
     /*  470672 */   // Label 8005: @470672
     /*  470672 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(470761), // Rule ID 14517 //
     /*  470677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470724 */     // MIs[1] Operand 1
     /*  470724 */     // No operand predicates
     /*  470724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470733 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470759 */     GIR_RootConstrainSelectedInstOperands,
     /*  470760 */     // GIR_Coverage, 14517,
     /*  470760 */     GIR_EraseRootFromParent_Done,
     /*  470761 */   // Label 8006: @470761
     /*  470761 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(470850), // Rule ID 14520 //
     /*  470766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470813 */     // MIs[1] Operand 1
     /*  470813 */     // No operand predicates
     /*  470813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470848 */     GIR_RootConstrainSelectedInstOperands,
     /*  470849 */     // GIR_Coverage, 14520,
     /*  470849 */     GIR_EraseRootFromParent_Done,
     /*  470850 */   // Label 8007: @470850
     /*  470850 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(470939), // Rule ID 14521 //
     /*  470855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470902 */     // MIs[1] Operand 1
     /*  470902 */     // No operand predicates
     /*  470902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470911 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470937 */     GIR_RootConstrainSelectedInstOperands,
     /*  470938 */     // GIR_Coverage, 14521,
     /*  470938 */     GIR_EraseRootFromParent_Done,
     /*  470939 */   // Label 8008: @470939
     /*  470939 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(471028), // Rule ID 14524 //
     /*  470944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470991 */     // MIs[1] Operand 1
     /*  470991 */     // No operand predicates
     /*  470991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  471000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471026 */     GIR_RootConstrainSelectedInstOperands,
     /*  471027 */     // GIR_Coverage, 14524,
     /*  471027 */     GIR_EraseRootFromParent_Done,
     /*  471028 */   // Label 8009: @471028
     /*  471028 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(471117), // Rule ID 14525 //
     /*  471033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  471044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  471047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  471050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471080 */     // MIs[1] Operand 1
     /*  471080 */     // No operand predicates
     /*  471080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471089 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  471089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471115 */     GIR_RootConstrainSelectedInstOperands,
     /*  471116 */     // GIR_Coverage, 14525,
     /*  471116 */     GIR_EraseRootFromParent_Done,
     /*  471117 */   // Label 8010: @471117
     /*  471117 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(471206), // Rule ID 14528 //
     /*  471122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  471125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471169 */     // MIs[1] Operand 1
     /*  471169 */     // No operand predicates
     /*  471169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471178 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  471178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471204 */     GIR_RootConstrainSelectedInstOperands,
     /*  471205 */     // GIR_Coverage, 14528,
     /*  471205 */     GIR_EraseRootFromParent_Done,
     /*  471206 */   // Label 8011: @471206
     /*  471206 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(471295), // Rule ID 14529 //
     /*  471211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  471214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  471222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  471225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  471228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  471246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471258 */     // MIs[1] Operand 1
     /*  471258 */     // No operand predicates
     /*  471258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471267 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  471267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  471270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  471287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471293 */     GIR_RootConstrainSelectedInstOperands,
     /*  471294 */     // GIR_Coverage, 14529,
     /*  471294 */     GIR_EraseRootFromParent_Done,
     /*  471295 */   // Label 8012: @471295
     /*  471295 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(471384), // Rule ID 14532 //
     /*  471300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471347 */     // MIs[1] Operand 1
     /*  471347 */     // No operand predicates
     /*  471347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471382 */     GIR_RootConstrainSelectedInstOperands,
     /*  471383 */     // GIR_Coverage, 14532,
     /*  471383 */     GIR_EraseRootFromParent_Done,
     /*  471384 */   // Label 8013: @471384
     /*  471384 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(471473), // Rule ID 14533 //
     /*  471389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  471400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  471403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  471406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471436 */     // MIs[1] Operand 1
     /*  471436 */     // No operand predicates
     /*  471436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471445 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471471 */     GIR_RootConstrainSelectedInstOperands,
     /*  471472 */     // GIR_Coverage, 14533,
     /*  471472 */     GIR_EraseRootFromParent_Done,
     /*  471473 */   // Label 8014: @471473
     /*  471473 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(471562), // Rule ID 14536 //
     /*  471478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471525 */     // MIs[1] Operand 1
     /*  471525 */     // No operand predicates
     /*  471525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471534 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  471537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471560 */     GIR_RootConstrainSelectedInstOperands,
     /*  471561 */     // GIR_Coverage, 14536,
     /*  471561 */     GIR_EraseRootFromParent_Done,
     /*  471562 */   // Label 8015: @471562
     /*  471562 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(471651), // Rule ID 14537 //
     /*  471567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471614 */     // MIs[1] Operand 1
     /*  471614 */     // No operand predicates
     /*  471614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471623 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  471626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471649 */     GIR_RootConstrainSelectedInstOperands,
     /*  471650 */     // GIR_Coverage, 14537,
     /*  471650 */     GIR_EraseRootFromParent_Done,
     /*  471651 */   // Label 8016: @471651
     /*  471651 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(471740), // Rule ID 14540 //
     /*  471656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471703 */     // MIs[1] Operand 1
     /*  471703 */     // No operand predicates
     /*  471703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471712 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  471715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471738 */     GIR_RootConstrainSelectedInstOperands,
     /*  471739 */     // GIR_Coverage, 14540,
     /*  471739 */     GIR_EraseRootFromParent_Done,
     /*  471740 */   // Label 8017: @471740
     /*  471740 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(471829), // Rule ID 14541 //
     /*  471745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471792 */     // MIs[1] Operand 1
     /*  471792 */     // No operand predicates
     /*  471792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471801 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  471804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471827 */     GIR_RootConstrainSelectedInstOperands,
     /*  471828 */     // GIR_Coverage, 14541,
     /*  471828 */     GIR_EraseRootFromParent_Done,
     /*  471829 */   // Label 8018: @471829
     /*  471829 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(471918), // Rule ID 14544 //
     /*  471834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471881 */     // MIs[1] Operand 1
     /*  471881 */     // No operand predicates
     /*  471881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471916 */     GIR_RootConstrainSelectedInstOperands,
     /*  471917 */     // GIR_Coverage, 14544,
     /*  471917 */     GIR_EraseRootFromParent_Done,
     /*  471918 */   // Label 8019: @471918
     /*  471918 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(472007), // Rule ID 14545 //
     /*  471923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471970 */     // MIs[1] Operand 1
     /*  471970 */     // No operand predicates
     /*  471970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471979 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472005 */     GIR_RootConstrainSelectedInstOperands,
     /*  472006 */     // GIR_Coverage, 14545,
     /*  472006 */     GIR_EraseRootFromParent_Done,
     /*  472007 */   // Label 8020: @472007
     /*  472007 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(472096), // Rule ID 14548 //
     /*  472012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472059 */     // MIs[1] Operand 1
     /*  472059 */     // No operand predicates
     /*  472059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472068 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472094 */     GIR_RootConstrainSelectedInstOperands,
     /*  472095 */     // GIR_Coverage, 14548,
     /*  472095 */     GIR_EraseRootFromParent_Done,
     /*  472096 */   // Label 8021: @472096
     /*  472096 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(472185), // Rule ID 14549 //
     /*  472101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  472112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  472115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  472118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472148 */     // MIs[1] Operand 1
     /*  472148 */     // No operand predicates
     /*  472148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472157 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472183 */     GIR_RootConstrainSelectedInstOperands,
     /*  472184 */     // GIR_Coverage, 14549,
     /*  472184 */     GIR_EraseRootFromParent_Done,
     /*  472185 */   // Label 8022: @472185
     /*  472185 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(472274), // Rule ID 14552 //
     /*  472190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472237 */     // MIs[1] Operand 1
     /*  472237 */     // No operand predicates
     /*  472237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  472246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472272 */     GIR_RootConstrainSelectedInstOperands,
     /*  472273 */     // GIR_Coverage, 14552,
     /*  472273 */     GIR_EraseRootFromParent_Done,
     /*  472274 */   // Label 8023: @472274
     /*  472274 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(472363), // Rule ID 14553 //
     /*  472279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  472290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  472293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  472296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472326 */     // MIs[1] Operand 1
     /*  472326 */     // No operand predicates
     /*  472326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472335 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  472335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  472355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472361 */     GIR_RootConstrainSelectedInstOperands,
     /*  472362 */     // GIR_Coverage, 14553,
     /*  472362 */     GIR_EraseRootFromParent_Done,
     /*  472363 */   // Label 8024: @472363
     /*  472363 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(472452), // Rule ID 14556 //
     /*  472368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472415 */     // MIs[1] Operand 1
     /*  472415 */     // No operand predicates
     /*  472415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472450 */     GIR_RootConstrainSelectedInstOperands,
     /*  472451 */     // GIR_Coverage, 14556,
     /*  472451 */     GIR_EraseRootFromParent_Done,
     /*  472452 */   // Label 8025: @472452
     /*  472452 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(472541), // Rule ID 14557 //
     /*  472457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  472468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  472471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  472474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472504 */     // MIs[1] Operand 1
     /*  472504 */     // No operand predicates
     /*  472504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472513 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472539 */     GIR_RootConstrainSelectedInstOperands,
     /*  472540 */     // GIR_Coverage, 14557,
     /*  472540 */     GIR_EraseRootFromParent_Done,
     /*  472541 */   // Label 8026: @472541
     /*  472541 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(472630), // Rule ID 14560 //
     /*  472546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472593 */     // MIs[1] Operand 1
     /*  472593 */     // No operand predicates
     /*  472593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472628 */     GIR_RootConstrainSelectedInstOperands,
     /*  472629 */     // GIR_Coverage, 14560,
     /*  472629 */     GIR_EraseRootFromParent_Done,
     /*  472630 */   // Label 8027: @472630
     /*  472630 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(472719), // Rule ID 14561 //
     /*  472635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472682 */     // MIs[1] Operand 1
     /*  472682 */     // No operand predicates
     /*  472682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472691 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472717 */     GIR_RootConstrainSelectedInstOperands,
     /*  472718 */     // GIR_Coverage, 14561,
     /*  472718 */     GIR_EraseRootFromParent_Done,
     /*  472719 */   // Label 8028: @472719
     /*  472719 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(472808), // Rule ID 14564 //
     /*  472724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472771 */     // MIs[1] Operand 1
     /*  472771 */     // No operand predicates
     /*  472771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472780 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472806 */     GIR_RootConstrainSelectedInstOperands,
     /*  472807 */     // GIR_Coverage, 14564,
     /*  472807 */     GIR_EraseRootFromParent_Done,
     /*  472808 */   // Label 8029: @472808
     /*  472808 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(472897), // Rule ID 14565 //
     /*  472813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472860 */     // MIs[1] Operand 1
     /*  472860 */     // No operand predicates
     /*  472860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472869 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472895 */     GIR_RootConstrainSelectedInstOperands,
     /*  472896 */     // GIR_Coverage, 14565,
     /*  472896 */     GIR_EraseRootFromParent_Done,
     /*  472897 */   // Label 8030: @472897
     /*  472897 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(472986), // Rule ID 14568 //
     /*  472902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  472905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  472913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  472916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  472919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472949 */     // MIs[1] Operand 1
     /*  472949 */     // No operand predicates
     /*  472949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472958 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  472958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472984 */     GIR_RootConstrainSelectedInstOperands,
     /*  472985 */     // GIR_Coverage, 14568,
     /*  472985 */     GIR_EraseRootFromParent_Done,
     /*  472986 */   // Label 8031: @472986
     /*  472986 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(473075), // Rule ID 14569 //
     /*  472991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  472994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  473002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  473005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  473008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  473026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473038 */     // MIs[1] Operand 1
     /*  473038 */     // No operand predicates
     /*  473038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473047 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  473050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473073 */     GIR_RootConstrainSelectedInstOperands,
     /*  473074 */     // GIR_Coverage, 14569,
     /*  473074 */     GIR_EraseRootFromParent_Done,
     /*  473075 */   // Label 8032: @473075
     /*  473075 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(473164), // Rule ID 14572 //
     /*  473080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473127 */     // MIs[1] Operand 1
     /*  473127 */     // No operand predicates
     /*  473127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473162 */     GIR_RootConstrainSelectedInstOperands,
     /*  473163 */     // GIR_Coverage, 14572,
     /*  473163 */     GIR_EraseRootFromParent_Done,
     /*  473164 */   // Label 8033: @473164
     /*  473164 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(473253), // Rule ID 14573 //
     /*  473169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  473180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  473183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  473186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  473204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473216 */     // MIs[1] Operand 1
     /*  473216 */     // No operand predicates
     /*  473216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473225 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  473228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473251 */     GIR_RootConstrainSelectedInstOperands,
     /*  473252 */     // GIR_Coverage, 14573,
     /*  473252 */     GIR_EraseRootFromParent_Done,
     /*  473253 */   // Label 8034: @473253
     /*  473253 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(473342), // Rule ID 14576 //
     /*  473258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  473261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473305 */     // MIs[1] Operand 1
     /*  473305 */     // No operand predicates
     /*  473305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  473314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473340 */     GIR_RootConstrainSelectedInstOperands,
     /*  473341 */     // GIR_Coverage, 14576,
     /*  473341 */     GIR_EraseRootFromParent_Done,
     /*  473342 */   // Label 8035: @473342
     /*  473342 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(473431), // Rule ID 14577 //
     /*  473347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  473350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  473355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  473358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  473361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  473364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  473382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  473394 */     // MIs[1] Operand 1
     /*  473394 */     // No operand predicates
     /*  473394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473403 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  473403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  473406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  473423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  473429 */     GIR_RootConstrainSelectedInstOperands,
     /*  473430 */     // GIR_Coverage, 14577,
     /*  473430 */     GIR_EraseRootFromParent_Done,
     /*  473431 */   // Label 8036: @473431
     /*  473431 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(473517), // Rule ID 24672 //
     /*  473436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473483 */     // MIs[1] Operand 1
     /*  473483 */     // No operand predicates
     /*  473483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  473495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473515 */     GIR_RootConstrainSelectedInstOperands,
     /*  473516 */     // GIR_Coverage, 24672,
     /*  473516 */     GIR_EraseRootFromParent_Done,
     /*  473517 */   // Label 8037: @473517
     /*  473517 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(473603), // Rule ID 24673 //
     /*  473522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473569 */     // MIs[1] Operand 1
     /*  473569 */     // No operand predicates
     /*  473569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473578 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  473581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473601 */     GIR_RootConstrainSelectedInstOperands,
     /*  473602 */     // GIR_Coverage, 24673,
     /*  473602 */     GIR_EraseRootFromParent_Done,
     /*  473603 */   // Label 8038: @473603
     /*  473603 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(473689), // Rule ID 24676 //
     /*  473608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473655 */     // MIs[1] Operand 1
     /*  473655 */     // No operand predicates
     /*  473655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473664 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  473667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473687 */     GIR_RootConstrainSelectedInstOperands,
     /*  473688 */     // GIR_Coverage, 24676,
     /*  473688 */     GIR_EraseRootFromParent_Done,
     /*  473689 */   // Label 8039: @473689
     /*  473689 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(473775), // Rule ID 24677 //
     /*  473694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473741 */     // MIs[1] Operand 1
     /*  473741 */     // No operand predicates
     /*  473741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473750 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  473753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473773 */     GIR_RootConstrainSelectedInstOperands,
     /*  473774 */     // GIR_Coverage, 24677,
     /*  473774 */     GIR_EraseRootFromParent_Done,
     /*  473775 */   // Label 8040: @473775
     /*  473775 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(473861), // Rule ID 24680 //
     /*  473780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473827 */     // MIs[1] Operand 1
     /*  473827 */     // No operand predicates
     /*  473827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473859 */     GIR_RootConstrainSelectedInstOperands,
     /*  473860 */     // GIR_Coverage, 24680,
     /*  473860 */     GIR_EraseRootFromParent_Done,
     /*  473861 */   // Label 8041: @473861
     /*  473861 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(473947), // Rule ID 24681 //
     /*  473866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473913 */     // MIs[1] Operand 1
     /*  473913 */     // No operand predicates
     /*  473913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473922 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473945 */     GIR_RootConstrainSelectedInstOperands,
     /*  473946 */     // GIR_Coverage, 24681,
     /*  473946 */     GIR_EraseRootFromParent_Done,
     /*  473947 */   // Label 8042: @473947
     /*  473947 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(474033), // Rule ID 24684 //
     /*  473952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  473963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  473966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  473969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473999 */     // MIs[1] Operand 1
     /*  473999 */     // No operand predicates
     /*  473999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474008 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474031 */     GIR_RootConstrainSelectedInstOperands,
     /*  474032 */     // GIR_Coverage, 24684,
     /*  474032 */     GIR_EraseRootFromParent_Done,
     /*  474033 */   // Label 8043: @474033
     /*  474033 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(474119), // Rule ID 24685 //
     /*  474038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  474049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  474052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  474055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474085 */     // MIs[1] Operand 1
     /*  474085 */     // No operand predicates
     /*  474085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  474097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474117 */     GIR_RootConstrainSelectedInstOperands,
     /*  474118 */     // GIR_Coverage, 24685,
     /*  474118 */     GIR_EraseRootFromParent_Done,
     /*  474119 */   // Label 8044: @474119
     /*  474119 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(474205), // Rule ID 24688 //
     /*  474124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474171 */     // MIs[1] Operand 1
     /*  474171 */     // No operand predicates
     /*  474171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474180 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474203 */     GIR_RootConstrainSelectedInstOperands,
     /*  474204 */     // GIR_Coverage, 24688,
     /*  474204 */     GIR_EraseRootFromParent_Done,
     /*  474205 */   // Label 8045: @474205
     /*  474205 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(474291), // Rule ID 24689 //
     /*  474210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  474221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  474224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  474227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474257 */     // MIs[1] Operand 1
     /*  474257 */     // No operand predicates
     /*  474257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474266 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474289 */     GIR_RootConstrainSelectedInstOperands,
     /*  474290 */     // GIR_Coverage, 24689,
     /*  474290 */     GIR_EraseRootFromParent_Done,
     /*  474291 */   // Label 8046: @474291
     /*  474291 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(474377), // Rule ID 24692 //
     /*  474296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474343 */     // MIs[1] Operand 1
     /*  474343 */     // No operand predicates
     /*  474343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474375 */     GIR_RootConstrainSelectedInstOperands,
     /*  474376 */     // GIR_Coverage, 24692,
     /*  474376 */     GIR_EraseRootFromParent_Done,
     /*  474377 */   // Label 8047: @474377
     /*  474377 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(474463), // Rule ID 24693 //
     /*  474382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  474393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  474396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  474399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474429 */     // MIs[1] Operand 1
     /*  474429 */     // No operand predicates
     /*  474429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  474441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474461 */     GIR_RootConstrainSelectedInstOperands,
     /*  474462 */     // GIR_Coverage, 24693,
     /*  474462 */     GIR_EraseRootFromParent_Done,
     /*  474463 */   // Label 8048: @474463
     /*  474463 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(474549), // Rule ID 24696 //
     /*  474468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474515 */     // MIs[1] Operand 1
     /*  474515 */     // No operand predicates
     /*  474515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474547 */     GIR_RootConstrainSelectedInstOperands,
     /*  474548 */     // GIR_Coverage, 24696,
     /*  474548 */     GIR_EraseRootFromParent_Done,
     /*  474549 */   // Label 8049: @474549
     /*  474549 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(474635), // Rule ID 24697 //
     /*  474554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474601 */     // MIs[1] Operand 1
     /*  474601 */     // No operand predicates
     /*  474601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474610 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474633 */     GIR_RootConstrainSelectedInstOperands,
     /*  474634 */     // GIR_Coverage, 24697,
     /*  474634 */     GIR_EraseRootFromParent_Done,
     /*  474635 */   // Label 8050: @474635
     /*  474635 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(474721), // Rule ID 24700 //
     /*  474640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474687 */     // MIs[1] Operand 1
     /*  474687 */     // No operand predicates
     /*  474687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474696 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474719 */     GIR_RootConstrainSelectedInstOperands,
     /*  474720 */     // GIR_Coverage, 24700,
     /*  474720 */     GIR_EraseRootFromParent_Done,
     /*  474721 */   // Label 8051: @474721
     /*  474721 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(474807), // Rule ID 24701 //
     /*  474726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474773 */     // MIs[1] Operand 1
     /*  474773 */     // No operand predicates
     /*  474773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474805 */     GIR_RootConstrainSelectedInstOperands,
     /*  474806 */     // GIR_Coverage, 24701,
     /*  474806 */     GIR_EraseRootFromParent_Done,
     /*  474807 */   // Label 8052: @474807
     /*  474807 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(474893), // Rule ID 24704 //
     /*  474812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474859 */     // MIs[1] Operand 1
     /*  474859 */     // No operand predicates
     /*  474859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474891 */     GIR_RootConstrainSelectedInstOperands,
     /*  474892 */     // GIR_Coverage, 24704,
     /*  474892 */     GIR_EraseRootFromParent_Done,
     /*  474893 */   // Label 8053: @474893
     /*  474893 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(474979), // Rule ID 24705 //
     /*  474898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474945 */     // MIs[1] Operand 1
     /*  474945 */     // No operand predicates
     /*  474945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474977 */     GIR_RootConstrainSelectedInstOperands,
     /*  474978 */     // GIR_Coverage, 24705,
     /*  474978 */     GIR_EraseRootFromParent_Done,
     /*  474979 */   // Label 8054: @474979
     /*  474979 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(475065), // Rule ID 24708 //
     /*  474984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  474987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  474995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  474998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475031 */     // MIs[1] Operand 1
     /*  475031 */     // No operand predicates
     /*  475031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  475040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475063 */     GIR_RootConstrainSelectedInstOperands,
     /*  475064 */     // GIR_Coverage, 24708,
     /*  475064 */     GIR_EraseRootFromParent_Done,
     /*  475065 */   // Label 8055: @475065
     /*  475065 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(475151), // Rule ID 24709 //
     /*  475070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  475073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  475081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  475084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  475087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  475105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475117 */     // MIs[1] Operand 1
     /*  475117 */     // No operand predicates
     /*  475117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  475126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  475129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  475146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475149 */     GIR_RootConstrainSelectedInstOperands,
     /*  475150 */     // GIR_Coverage, 24709,
     /*  475150 */     GIR_EraseRootFromParent_Done,
     /*  475151 */   // Label 8056: @475151
     /*  475151 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(475237), // Rule ID 24712 //
     /*  475156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475203 */     // MIs[1] Operand 1
     /*  475203 */     // No operand predicates
     /*  475203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475235 */     GIR_RootConstrainSelectedInstOperands,
     /*  475236 */     // GIR_Coverage, 24712,
     /*  475236 */     GIR_EraseRootFromParent_Done,
     /*  475237 */   // Label 8057: @475237
     /*  475237 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(475323), // Rule ID 24713 //
     /*  475242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  475253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  475256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  475259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475289 */     // MIs[1] Operand 1
     /*  475289 */     // No operand predicates
     /*  475289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475298 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475321 */     GIR_RootConstrainSelectedInstOperands,
     /*  475322 */     // GIR_Coverage, 24713,
     /*  475322 */     GIR_EraseRootFromParent_Done,
     /*  475323 */   // Label 8058: @475323
     /*  475323 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(475409), // Rule ID 24716 //
     /*  475328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475375 */     // MIs[1] Operand 1
     /*  475375 */     // No operand predicates
     /*  475375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475407 */     GIR_RootConstrainSelectedInstOperands,
     /*  475408 */     // GIR_Coverage, 24716,
     /*  475408 */     GIR_EraseRootFromParent_Done,
     /*  475409 */   // Label 8059: @475409
     /*  475409 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(475495), // Rule ID 24717 //
     /*  475414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  475425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  475428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  475431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475461 */     // MIs[1] Operand 1
     /*  475461 */     // No operand predicates
     /*  475461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475470 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475493 */     GIR_RootConstrainSelectedInstOperands,
     /*  475494 */     // GIR_Coverage, 24717,
     /*  475494 */     GIR_EraseRootFromParent_Done,
     /*  475495 */   // Label 8060: @475495
     /*  475495 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(475581), // Rule ID 24720 //
     /*  475500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475547 */     // MIs[1] Operand 1
     /*  475547 */     // No operand predicates
     /*  475547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  475559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475579 */     GIR_RootConstrainSelectedInstOperands,
     /*  475580 */     // GIR_Coverage, 24720,
     /*  475580 */     GIR_EraseRootFromParent_Done,
     /*  475581 */   // Label 8061: @475581
     /*  475581 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(475667), // Rule ID 24721 //
     /*  475586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475633 */     // MIs[1] Operand 1
     /*  475633 */     // No operand predicates
     /*  475633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475642 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  475645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475665 */     GIR_RootConstrainSelectedInstOperands,
     /*  475666 */     // GIR_Coverage, 24721,
     /*  475666 */     GIR_EraseRootFromParent_Done,
     /*  475667 */   // Label 8062: @475667
     /*  475667 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(475753), // Rule ID 24724 //
     /*  475672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475719 */     // MIs[1] Operand 1
     /*  475719 */     // No operand predicates
     /*  475719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475751 */     GIR_RootConstrainSelectedInstOperands,
     /*  475752 */     // GIR_Coverage, 24724,
     /*  475752 */     GIR_EraseRootFromParent_Done,
     /*  475753 */   // Label 8063: @475753
     /*  475753 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(475839), // Rule ID 24725 //
     /*  475758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475805 */     // MIs[1] Operand 1
     /*  475805 */     // No operand predicates
     /*  475805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475837 */     GIR_RootConstrainSelectedInstOperands,
     /*  475838 */     // GIR_Coverage, 24725,
     /*  475838 */     GIR_EraseRootFromParent_Done,
     /*  475839 */   // Label 8064: @475839
     /*  475839 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(475925), // Rule ID 24728 //
     /*  475844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475891 */     // MIs[1] Operand 1
     /*  475891 */     // No operand predicates
     /*  475891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475900 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475923 */     GIR_RootConstrainSelectedInstOperands,
     /*  475924 */     // GIR_Coverage, 24728,
     /*  475924 */     GIR_EraseRootFromParent_Done,
     /*  475925 */   // Label 8065: @475925
     /*  475925 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(476011), // Rule ID 24729 //
     /*  475930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475977 */     // MIs[1] Operand 1
     /*  475977 */     // No operand predicates
     /*  475977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475986 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476009 */     GIR_RootConstrainSelectedInstOperands,
     /*  476010 */     // GIR_Coverage, 24729,
     /*  476010 */     GIR_EraseRootFromParent_Done,
     /*  476011 */   // Label 8066: @476011
     /*  476011 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(476097), // Rule ID 24732 //
     /*  476016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476063 */     // MIs[1] Operand 1
     /*  476063 */     // No operand predicates
     /*  476063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476072 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  476072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476095 */     GIR_RootConstrainSelectedInstOperands,
     /*  476096 */     // GIR_Coverage, 24732,
     /*  476096 */     GIR_EraseRootFromParent_Done,
     /*  476097 */   // Label 8067: @476097
     /*  476097 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(476183), // Rule ID 24733 //
     /*  476102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  476113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  476116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  476119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476149 */     // MIs[1] Operand 1
     /*  476149 */     // No operand predicates
     /*  476149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  476158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  476178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476181 */     GIR_RootConstrainSelectedInstOperands,
     /*  476182 */     // GIR_Coverage, 24733,
     /*  476182 */     GIR_EraseRootFromParent_Done,
     /*  476183 */   // Label 8068: @476183
     /*  476183 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(476269), // Rule ID 24736 //
     /*  476188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476235 */     // MIs[1] Operand 1
     /*  476235 */     // No operand predicates
     /*  476235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476267 */     GIR_RootConstrainSelectedInstOperands,
     /*  476268 */     // GIR_Coverage, 24736,
     /*  476268 */     GIR_EraseRootFromParent_Done,
     /*  476269 */   // Label 8069: @476269
     /*  476269 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(476355), // Rule ID 24737 //
     /*  476274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  476285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  476288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  476291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476321 */     // MIs[1] Operand 1
     /*  476321 */     // No operand predicates
     /*  476321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476353 */     GIR_RootConstrainSelectedInstOperands,
     /*  476354 */     // GIR_Coverage, 24737,
     /*  476354 */     GIR_EraseRootFromParent_Done,
     /*  476355 */   // Label 8070: @476355
     /*  476355 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(476441), // Rule ID 24740 //
     /*  476360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476407 */     // MIs[1] Operand 1
     /*  476407 */     // No operand predicates
     /*  476407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476439 */     GIR_RootConstrainSelectedInstOperands,
     /*  476440 */     // GIR_Coverage, 24740,
     /*  476440 */     GIR_EraseRootFromParent_Done,
     /*  476441 */   // Label 8071: @476441
     /*  476441 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(476527), // Rule ID 24741 //
     /*  476446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  476457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  476460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  476463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476493 */     // MIs[1] Operand 1
     /*  476493 */     // No operand predicates
     /*  476493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476525 */     GIR_RootConstrainSelectedInstOperands,
     /*  476526 */     // GIR_Coverage, 24741,
     /*  476526 */     GIR_EraseRootFromParent_Done,
     /*  476527 */   // Label 8072: @476527
     /*  476527 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(476613), // Rule ID 24744 //
     /*  476532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476579 */     // MIs[1] Operand 1
     /*  476579 */     // No operand predicates
     /*  476579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476611 */     GIR_RootConstrainSelectedInstOperands,
     /*  476612 */     // GIR_Coverage, 24744,
     /*  476612 */     GIR_EraseRootFromParent_Done,
     /*  476613 */   // Label 8073: @476613
     /*  476613 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(476699), // Rule ID 24745 //
     /*  476618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476665 */     // MIs[1] Operand 1
     /*  476665 */     // No operand predicates
     /*  476665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476697 */     GIR_RootConstrainSelectedInstOperands,
     /*  476698 */     // GIR_Coverage, 24745,
     /*  476698 */     GIR_EraseRootFromParent_Done,
     /*  476699 */   // Label 8074: @476699
     /*  476699 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(476785), // Rule ID 24748 //
     /*  476704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476751 */     // MIs[1] Operand 1
     /*  476751 */     // No operand predicates
     /*  476751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476783 */     GIR_RootConstrainSelectedInstOperands,
     /*  476784 */     // GIR_Coverage, 24748,
     /*  476784 */     GIR_EraseRootFromParent_Done,
     /*  476785 */   // Label 8075: @476785
     /*  476785 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(476871), // Rule ID 24749 //
     /*  476790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  476793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476837 */     // MIs[1] Operand 1
     /*  476837 */     // No operand predicates
     /*  476837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  476846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476869 */     GIR_RootConstrainSelectedInstOperands,
     /*  476870 */     // GIR_Coverage, 24749,
     /*  476870 */     GIR_EraseRootFromParent_Done,
     /*  476871 */   // Label 8076: @476871
     /*  476871 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(476957), // Rule ID 24752 //
     /*  476876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  476893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476923 */     // MIs[1] Operand 1
     /*  476923 */     // No operand predicates
     /*  476923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476955 */     GIR_RootConstrainSelectedInstOperands,
     /*  476956 */     // GIR_Coverage, 24752,
     /*  476956 */     GIR_EraseRootFromParent_Done,
     /*  476957 */   // Label 8077: @476957
     /*  476957 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(477043), // Rule ID 24753 //
     /*  476962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  476965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  476979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477009 */     // MIs[1] Operand 1
     /*  477009 */     // No operand predicates
     /*  477009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  477021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477041 */     GIR_RootConstrainSelectedInstOperands,
     /*  477042 */     // GIR_Coverage, 24753,
     /*  477042 */     GIR_EraseRootFromParent_Done,
     /*  477043 */   // Label 8078: @477043
     /*  477043 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(477129), // Rule ID 24756 //
     /*  477048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  477051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477095 */     // MIs[1] Operand 1
     /*  477095 */     // No operand predicates
     /*  477095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477104 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477127 */     GIR_RootConstrainSelectedInstOperands,
     /*  477128 */     // GIR_Coverage, 24756,
     /*  477128 */     GIR_EraseRootFromParent_Done,
     /*  477129 */   // Label 8079: @477129
     /*  477129 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(477215), // Rule ID 24757 //
     /*  477134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  477137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  477145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  477148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  477151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477181 */     // MIs[1] Operand 1
     /*  477181 */     // No operand predicates
     /*  477181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477190 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477213 */     GIR_RootConstrainSelectedInstOperands,
     /*  477214 */     // GIR_Coverage, 24757,
     /*  477214 */     GIR_EraseRootFromParent_Done,
     /*  477215 */   // Label 8080: @477215
     /*  477215 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(477301), // Rule ID 24964 //
     /*  477220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  477223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477267 */     // MIs[1] Operand 1
     /*  477267 */     // No operand predicates
     /*  477267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477276 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477299 */     GIR_RootConstrainSelectedInstOperands,
     /*  477300 */     // GIR_Coverage, 24964,
     /*  477300 */     GIR_EraseRootFromParent_Done,
     /*  477301 */   // Label 8081: @477301
     /*  477301 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(477387), // Rule ID 24965 //
     /*  477306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  477309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  477317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  477320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  477323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477353 */     // MIs[1] Operand 1
     /*  477353 */     // No operand predicates
     /*  477353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477362 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  477365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477385 */     GIR_RootConstrainSelectedInstOperands,
     /*  477386 */     // GIR_Coverage, 24965,
     /*  477386 */     GIR_EraseRootFromParent_Done,
     /*  477387 */   // Label 8082: @477387
     /*  477387 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(477473), // Rule ID 24968 //
     /*  477392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  477395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477439 */     // MIs[1] Operand 1
     /*  477439 */     // No operand predicates
     /*  477439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477448 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477471 */     GIR_RootConstrainSelectedInstOperands,
     /*  477472 */     // GIR_Coverage, 24968,
     /*  477472 */     GIR_EraseRootFromParent_Done,
     /*  477473 */   // Label 8083: @477473
     /*  477473 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(477559), // Rule ID 24969 //
     /*  477478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  477481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  477489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  477492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  477495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477525 */     // MIs[1] Operand 1
     /*  477525 */     // No operand predicates
     /*  477525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477534 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477557 */     GIR_RootConstrainSelectedInstOperands,
     /*  477558 */     // GIR_Coverage, 24969,
     /*  477558 */     GIR_EraseRootFromParent_Done,
     /*  477559 */   // Label 8084: @477559
     /*  477559 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(477645), // Rule ID 24972 //
     /*  477564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  477567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  477575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  477578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  477581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477611 */     // MIs[1] Operand 1
     /*  477611 */     // No operand predicates
     /*  477611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477620 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  477620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477643 */     GIR_RootConstrainSelectedInstOperands,
     /*  477644 */     // GIR_Coverage, 24972,
     /*  477644 */     GIR_EraseRootFromParent_Done,
     /*  477645 */   // Label 8085: @477645
     /*  477645 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(477731), // Rule ID 24973 //
     /*  477650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  477653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  477661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  477664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  477667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477697 */     // MIs[1] Operand 1
     /*  477697 */     // No operand predicates
     /*  477697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477706 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  477706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  477709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477729 */     GIR_RootConstrainSelectedInstOperands,
     /*  477730 */     // GIR_Coverage, 24973,
     /*  477730 */     GIR_EraseRootFromParent_Done,
     /*  477731 */   // Label 8086: @477731
     /*  477731 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(477817), // Rule ID 24976 //
     /*  477736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  477739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  477747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  477750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  477753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477783 */     // MIs[1] Operand 1
     /*  477783 */     // No operand predicates
     /*  477783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477792 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  477792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  477795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477815 */     GIR_RootConstrainSelectedInstOperands,
     /*  477816 */     // GIR_Coverage, 24976,
     /*  477816 */     GIR_EraseRootFromParent_Done,
     /*  477817 */   // Label 8087: @477817
     /*  477817 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(477903), // Rule ID 24977 //
     /*  477822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  477825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  477833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  477836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  477839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477869 */     // MIs[1] Operand 1
     /*  477869 */     // No operand predicates
     /*  477869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477878 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  477878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  477881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  477898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477901 */     GIR_RootConstrainSelectedInstOperands,
     /*  477902 */     // GIR_Coverage, 24977,
     /*  477902 */     GIR_EraseRootFromParent_Done,
     /*  477903 */   // Label 8088: @477903
     /*  477903 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(477989), // Rule ID 24980 //
     /*  477908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  477911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  477919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  477922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  477925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477955 */     // MIs[1] Operand 1
     /*  477955 */     // No operand predicates
     /*  477955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477964 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  477964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  477967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477987 */     GIR_RootConstrainSelectedInstOperands,
     /*  477988 */     // GIR_Coverage, 24980,
     /*  477988 */     GIR_EraseRootFromParent_Done,
     /*  477989 */   // Label 8089: @477989
     /*  477989 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(478075), // Rule ID 24981 //
     /*  477994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  477997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  478005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  478008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  478011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478041 */     // MIs[1] Operand 1
     /*  478041 */     // No operand predicates
     /*  478041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478050 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478073 */     GIR_RootConstrainSelectedInstOperands,
     /*  478074 */     // GIR_Coverage, 24981,
     /*  478074 */     GIR_EraseRootFromParent_Done,
     /*  478075 */   // Label 8090: @478075
     /*  478075 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(478161), // Rule ID 24984 //
     /*  478080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  478083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478127 */     // MIs[1] Operand 1
     /*  478127 */     // No operand predicates
     /*  478127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478136 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  478136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478159 */     GIR_RootConstrainSelectedInstOperands,
     /*  478160 */     // GIR_Coverage, 24984,
     /*  478160 */     GIR_EraseRootFromParent_Done,
     /*  478161 */   // Label 8091: @478161
     /*  478161 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(478247), // Rule ID 24985 //
     /*  478166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  478169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  478177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  478180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  478183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478213 */     // MIs[1] Operand 1
     /*  478213 */     // No operand predicates
     /*  478213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478222 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  478222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478245 */     GIR_RootConstrainSelectedInstOperands,
     /*  478246 */     // GIR_Coverage, 24985,
     /*  478246 */     GIR_EraseRootFromParent_Done,
     /*  478247 */   // Label 8092: @478247
     /*  478247 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(478333), // Rule ID 24988 //
     /*  478252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  478255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478299 */     // MIs[1] Operand 1
     /*  478299 */     // No operand predicates
     /*  478299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478308 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478331 */     GIR_RootConstrainSelectedInstOperands,
     /*  478332 */     // GIR_Coverage, 24988,
     /*  478332 */     GIR_EraseRootFromParent_Done,
     /*  478333 */   // Label 8093: @478333
     /*  478333 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(478419), // Rule ID 24989 //
     /*  478338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  478341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478385 */     // MIs[1] Operand 1
     /*  478385 */     // No operand predicates
     /*  478385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478394 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478417 */     GIR_RootConstrainSelectedInstOperands,
     /*  478418 */     // GIR_Coverage, 24989,
     /*  478418 */     GIR_EraseRootFromParent_Done,
     /*  478419 */   // Label 8094: @478419
     /*  478419 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(478505), // Rule ID 24992 //
     /*  478424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  478427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  478435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  478438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478471 */     // MIs[1] Operand 1
     /*  478471 */     // No operand predicates
     /*  478471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478480 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  478483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478503 */     GIR_RootConstrainSelectedInstOperands,
     /*  478504 */     // GIR_Coverage, 24992,
     /*  478504 */     GIR_EraseRootFromParent_Done,
     /*  478505 */   // Label 8095: @478505
     /*  478505 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(478591), // Rule ID 24993 //
     /*  478510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  478513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  478521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  478524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478557 */     // MIs[1] Operand 1
     /*  478557 */     // No operand predicates
     /*  478557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478566 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  478569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478589 */     GIR_RootConstrainSelectedInstOperands,
     /*  478590 */     // GIR_Coverage, 24993,
     /*  478590 */     GIR_EraseRootFromParent_Done,
     /*  478591 */   // Label 8096: @478591
     /*  478591 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(478677), // Rule ID 24996 //
     /*  478596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  478599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  478607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  478610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  478613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478643 */     // MIs[1] Operand 1
     /*  478643 */     // No operand predicates
     /*  478643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478652 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  478655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478675 */     GIR_RootConstrainSelectedInstOperands,
     /*  478676 */     // GIR_Coverage, 24996,
     /*  478676 */     GIR_EraseRootFromParent_Done,
     /*  478677 */   // Label 8097: @478677
     /*  478677 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(478763), // Rule ID 24997 //
     /*  478682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  478685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  478693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  478696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  478699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478729 */     // MIs[1] Operand 1
     /*  478729 */     // No operand predicates
     /*  478729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478738 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  478741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478761 */     GIR_RootConstrainSelectedInstOperands,
     /*  478762 */     // GIR_Coverage, 24997,
     /*  478762 */     GIR_EraseRootFromParent_Done,
     /*  478763 */   // Label 8098: @478763
     /*  478763 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(478849), // Rule ID 25000 //
     /*  478768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  478771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  478779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  478782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  478785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478815 */     // MIs[1] Operand 1
     /*  478815 */     // No operand predicates
     /*  478815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478847 */     GIR_RootConstrainSelectedInstOperands,
     /*  478848 */     // GIR_Coverage, 25000,
     /*  478848 */     GIR_EraseRootFromParent_Done,
     /*  478849 */   // Label 8099: @478849
     /*  478849 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(478935), // Rule ID 25001 //
     /*  478854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  478857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  478865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  478868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  478871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478901 */     // MIs[1] Operand 1
     /*  478901 */     // No operand predicates
     /*  478901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478910 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  478910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  478930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478933 */     GIR_RootConstrainSelectedInstOperands,
     /*  478934 */     // GIR_Coverage, 25001,
     /*  478934 */     GIR_EraseRootFromParent_Done,
     /*  478935 */   // Label 8100: @478935
     /*  478935 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(479021), // Rule ID 25004 //
     /*  478940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  478943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  478951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  478954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  478957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478987 */     // MIs[1] Operand 1
     /*  478987 */     // No operand predicates
     /*  478987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478996 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  478996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  478999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479019 */     GIR_RootConstrainSelectedInstOperands,
     /*  479020 */     // GIR_Coverage, 25004,
     /*  479020 */     GIR_EraseRootFromParent_Done,
     /*  479021 */   // Label 8101: @479021
     /*  479021 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(479107), // Rule ID 25005 //
     /*  479026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  479029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  479037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  479040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  479043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479073 */     // MIs[1] Operand 1
     /*  479073 */     // No operand predicates
     /*  479073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479082 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479105 */     GIR_RootConstrainSelectedInstOperands,
     /*  479106 */     // GIR_Coverage, 25005,
     /*  479106 */     GIR_EraseRootFromParent_Done,
     /*  479107 */   // Label 8102: @479107
     /*  479107 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(479193), // Rule ID 25008 //
     /*  479112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  479115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  479123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  479126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  479129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479159 */     // MIs[1] Operand 1
     /*  479159 */     // No operand predicates
     /*  479159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479168 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  479168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479191 */     GIR_RootConstrainSelectedInstOperands,
     /*  479192 */     // GIR_Coverage, 25008,
     /*  479192 */     GIR_EraseRootFromParent_Done,
     /*  479193 */   // Label 8103: @479193
     /*  479193 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(479279), // Rule ID 25009 //
     /*  479198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  479201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  479209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  479212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  479215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479245 */     // MIs[1] Operand 1
     /*  479245 */     // No operand predicates
     /*  479245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479254 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  479254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  479274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479277 */     GIR_RootConstrainSelectedInstOperands,
     /*  479278 */     // GIR_Coverage, 25009,
     /*  479278 */     GIR_EraseRootFromParent_Done,
     /*  479279 */   // Label 8104: @479279
     /*  479279 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(479365), // Rule ID 25012 //
     /*  479284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  479287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  479295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  479298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  479301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479331 */     // MIs[1] Operand 1
     /*  479331 */     // No operand predicates
     /*  479331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479340 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479363 */     GIR_RootConstrainSelectedInstOperands,
     /*  479364 */     // GIR_Coverage, 25012,
     /*  479364 */     GIR_EraseRootFromParent_Done,
     /*  479365 */   // Label 8105: @479365
     /*  479365 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(479451), // Rule ID 25013 //
     /*  479370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  479373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  479381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  479384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  479387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479417 */     // MIs[1] Operand 1
     /*  479417 */     // No operand predicates
     /*  479417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479426 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  479426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  479429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479449 */     GIR_RootConstrainSelectedInstOperands,
     /*  479450 */     // GIR_Coverage, 25013,
     /*  479450 */     GIR_EraseRootFromParent_Done,
     /*  479451 */   // Label 8106: @479451
     /*  479451 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(479537), // Rule ID 25016 //
     /*  479456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  479459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  479467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  479470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  479473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479503 */     // MIs[1] Operand 1
     /*  479503 */     // No operand predicates
     /*  479503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479512 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479535 */     GIR_RootConstrainSelectedInstOperands,
     /*  479536 */     // GIR_Coverage, 25016,
     /*  479536 */     GIR_EraseRootFromParent_Done,
     /*  479537 */   // Label 8107: @479537
     /*  479537 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(479623), // Rule ID 25017 //
     /*  479542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  479545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  479553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  479556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  479559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479589 */     // MIs[1] Operand 1
     /*  479589 */     // No operand predicates
     /*  479589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479598 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  479598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479621 */     GIR_RootConstrainSelectedInstOperands,
     /*  479622 */     // GIR_Coverage, 25017,
     /*  479622 */     GIR_EraseRootFromParent_Done,
     /*  479623 */   // Label 8108: @479623
     /*  479623 */   GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(479709), // Rule ID 25020 //
     /*  479628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  479631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  479639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  479642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  479645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479675 */     // MIs[1] Operand 1
     /*  479675 */     // No operand predicates
     /*  479675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479684 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  479684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479707 */     GIR_RootConstrainSelectedInstOperands,
     /*  479708 */     // GIR_Coverage, 25020,
     /*  479708 */     GIR_EraseRootFromParent_Done,
     /*  479709 */   // Label 8109: @479709
     /*  479709 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(479795), // Rule ID 25021 //
     /*  479714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  479717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  479725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  479728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  479731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479761 */     // MIs[1] Operand 1
     /*  479761 */     // No operand predicates
     /*  479761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479770 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  479770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  479790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479793 */     GIR_RootConstrainSelectedInstOperands,
     /*  479794 */     // GIR_Coverage, 25021,
     /*  479794 */     GIR_EraseRootFromParent_Done,
     /*  479795 */   // Label 8110: @479795
     /*  479795 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(479881), // Rule ID 61032 //
     /*  479800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  479803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  479811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  479814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  479817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479847 */     // MIs[1] Operand 1
     /*  479847 */     // No operand predicates
     /*  479847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479856 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  479859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479879 */     GIR_RootConstrainSelectedInstOperands,
     /*  479880 */     // GIR_Coverage, 61032,
     /*  479880 */     GIR_EraseRootFromParent_Done,
     /*  479881 */   // Label 8111: @479881
     /*  479881 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(479967), // Rule ID 61033 //
     /*  479886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  479889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  479897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  479900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  479903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479933 */     // MIs[1] Operand 1
     /*  479933 */     // No operand predicates
     /*  479933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479942 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  479945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479965 */     GIR_RootConstrainSelectedInstOperands,
     /*  479966 */     // GIR_Coverage, 61033,
     /*  479966 */     GIR_EraseRootFromParent_Done,
     /*  479967 */   // Label 8112: @479967
     /*  479967 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(480053), // Rule ID 61040 //
     /*  479972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  479975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  479983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  479986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  479989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480019 */     // MIs[1] Operand 1
     /*  480019 */     // No operand predicates
     /*  480019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480028 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480051 */     GIR_RootConstrainSelectedInstOperands,
     /*  480052 */     // GIR_Coverage, 61040,
     /*  480052 */     GIR_EraseRootFromParent_Done,
     /*  480053 */   // Label 8113: @480053
     /*  480053 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(480139), // Rule ID 61041 //
     /*  480058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  480069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  480072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  480075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480105 */     // MIs[1] Operand 1
     /*  480105 */     // No operand predicates
     /*  480105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480114 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480137 */     GIR_RootConstrainSelectedInstOperands,
     /*  480138 */     // GIR_Coverage, 61041,
     /*  480138 */     GIR_EraseRootFromParent_Done,
     /*  480139 */   // Label 8114: @480139
     /*  480139 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(480225), // Rule ID 61048 //
     /*  480144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  480155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  480158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  480161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480191 */     // MIs[1] Operand 1
     /*  480191 */     // No operand predicates
     /*  480191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480223 */     GIR_RootConstrainSelectedInstOperands,
     /*  480224 */     // GIR_Coverage, 61048,
     /*  480224 */     GIR_EraseRootFromParent_Done,
     /*  480225 */   // Label 8115: @480225
     /*  480225 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(480311), // Rule ID 61049 //
     /*  480230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  480241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  480244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  480247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480277 */     // MIs[1] Operand 1
     /*  480277 */     // No operand predicates
     /*  480277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480286 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480309 */     GIR_RootConstrainSelectedInstOperands,
     /*  480310 */     // GIR_Coverage, 61049,
     /*  480310 */     GIR_EraseRootFromParent_Done,
     /*  480311 */   // Label 8116: @480311
     /*  480311 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(480397), // Rule ID 61056 //
     /*  480316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  480327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  480330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  480333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480363 */     // MIs[1] Operand 1
     /*  480363 */     // No operand predicates
     /*  480363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480372 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480395 */     GIR_RootConstrainSelectedInstOperands,
     /*  480396 */     // GIR_Coverage, 61056,
     /*  480396 */     GIR_EraseRootFromParent_Done,
     /*  480397 */   // Label 8117: @480397
     /*  480397 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(480483), // Rule ID 61057 //
     /*  480402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  480413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  480416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  480419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480449 */     // MIs[1] Operand 1
     /*  480449 */     // No operand predicates
     /*  480449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480481 */     GIR_RootConstrainSelectedInstOperands,
     /*  480482 */     // GIR_Coverage, 61057,
     /*  480482 */     GIR_EraseRootFromParent_Done,
     /*  480483 */   // Label 8118: @480483
     /*  480483 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(480569), // Rule ID 61064 //
     /*  480488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  480499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  480502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  480505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480535 */     // MIs[1] Operand 1
     /*  480535 */     // No operand predicates
     /*  480535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480544 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  480547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480567 */     GIR_RootConstrainSelectedInstOperands,
     /*  480568 */     // GIR_Coverage, 61064,
     /*  480568 */     GIR_EraseRootFromParent_Done,
     /*  480569 */   // Label 8119: @480569
     /*  480569 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(480655), // Rule ID 61065 //
     /*  480574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  480585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  480588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  480591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480621 */     // MIs[1] Operand 1
     /*  480621 */     // No operand predicates
     /*  480621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480630 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  480633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480653 */     GIR_RootConstrainSelectedInstOperands,
     /*  480654 */     // GIR_Coverage, 61065,
     /*  480654 */     GIR_EraseRootFromParent_Done,
     /*  480655 */   // Label 8120: @480655
     /*  480655 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(480741), // Rule ID 61072 //
     /*  480660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  480671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  480674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  480677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480707 */     // MIs[1] Operand 1
     /*  480707 */     // No operand predicates
     /*  480707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480716 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  480719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480739 */     GIR_RootConstrainSelectedInstOperands,
     /*  480740 */     // GIR_Coverage, 61072,
     /*  480740 */     GIR_EraseRootFromParent_Done,
     /*  480741 */   // Label 8121: @480741
     /*  480741 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(480827), // Rule ID 61073 //
     /*  480746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  480757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  480760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  480763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480793 */     // MIs[1] Operand 1
     /*  480793 */     // No operand predicates
     /*  480793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  480805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480825 */     GIR_RootConstrainSelectedInstOperands,
     /*  480826 */     // GIR_Coverage, 61073,
     /*  480826 */     GIR_EraseRootFromParent_Done,
     /*  480827 */   // Label 8122: @480827
     /*  480827 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(480913), // Rule ID 61080 //
     /*  480832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  480843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  480846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  480849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480879 */     // MIs[1] Operand 1
     /*  480879 */     // No operand predicates
     /*  480879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480911 */     GIR_RootConstrainSelectedInstOperands,
     /*  480912 */     // GIR_Coverage, 61080,
     /*  480912 */     GIR_EraseRootFromParent_Done,
     /*  480913 */   // Label 8123: @480913
     /*  480913 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(480999), // Rule ID 61081 //
     /*  480918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  480929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  480932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  480935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480965 */     // MIs[1] Operand 1
     /*  480965 */     // No operand predicates
     /*  480965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480997 */     GIR_RootConstrainSelectedInstOperands,
     /*  480998 */     // GIR_Coverage, 61081,
     /*  480998 */     GIR_EraseRootFromParent_Done,
     /*  480999 */   // Label 8124: @480999
     /*  480999 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(481085), // Rule ID 61088 //
     /*  481004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  481021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481051 */     // MIs[1] Operand 1
     /*  481051 */     // No operand predicates
     /*  481051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481083 */     GIR_RootConstrainSelectedInstOperands,
     /*  481084 */     // GIR_Coverage, 61088,
     /*  481084 */     GIR_EraseRootFromParent_Done,
     /*  481085 */   // Label 8125: @481085
     /*  481085 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(481171), // Rule ID 61089 //
     /*  481090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  481101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  481104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  481107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481137 */     // MIs[1] Operand 1
     /*  481137 */     // No operand predicates
     /*  481137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481169 */     GIR_RootConstrainSelectedInstOperands,
     /*  481170 */     // GIR_Coverage, 61089,
     /*  481170 */     GIR_EraseRootFromParent_Done,
     /*  481171 */   // Label 8126: @481171
     /*  481171 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(481257), // Rule ID 61096 //
     /*  481176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  481193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481223 */     // MIs[1] Operand 1
     /*  481223 */     // No operand predicates
     /*  481223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481255 */     GIR_RootConstrainSelectedInstOperands,
     /*  481256 */     // GIR_Coverage, 61096,
     /*  481256 */     GIR_EraseRootFromParent_Done,
     /*  481257 */   // Label 8127: @481257
     /*  481257 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(481343), // Rule ID 61097 //
     /*  481262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  481273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  481276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  481279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481309 */     // MIs[1] Operand 1
     /*  481309 */     // No operand predicates
     /*  481309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481341 */     GIR_RootConstrainSelectedInstOperands,
     /*  481342 */     // GIR_Coverage, 61097,
     /*  481342 */     GIR_EraseRootFromParent_Done,
     /*  481343 */   // Label 8128: @481343
     /*  481343 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(481429), // Rule ID 61104 //
     /*  481348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  481365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481395 */     // MIs[1] Operand 1
     /*  481395 */     // No operand predicates
     /*  481395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481427 */     GIR_RootConstrainSelectedInstOperands,
     /*  481428 */     // GIR_Coverage, 61104,
     /*  481428 */     GIR_EraseRootFromParent_Done,
     /*  481429 */   // Label 8129: @481429
     /*  481429 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(481515), // Rule ID 61105 //
     /*  481434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  481445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  481448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  481451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481481 */     // MIs[1] Operand 1
     /*  481481 */     // No operand predicates
     /*  481481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481513 */     GIR_RootConstrainSelectedInstOperands,
     /*  481514 */     // GIR_Coverage, 61105,
     /*  481514 */     GIR_EraseRootFromParent_Done,
     /*  481515 */   // Label 8130: @481515
     /*  481515 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(481601), // Rule ID 61112 //
     /*  481520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  481531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  481534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  481537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481567 */     // MIs[1] Operand 1
     /*  481567 */     // No operand predicates
     /*  481567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481576 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481599 */     GIR_RootConstrainSelectedInstOperands,
     /*  481600 */     // GIR_Coverage, 61112,
     /*  481600 */     GIR_EraseRootFromParent_Done,
     /*  481601 */   // Label 8131: @481601
     /*  481601 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(481687), // Rule ID 61113 //
     /*  481606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  481617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  481620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  481623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481653 */     // MIs[1] Operand 1
     /*  481653 */     // No operand predicates
     /*  481653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481662 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481685 */     GIR_RootConstrainSelectedInstOperands,
     /*  481686 */     // GIR_Coverage, 61113,
     /*  481686 */     GIR_EraseRootFromParent_Done,
     /*  481687 */   // Label 8132: @481687
     /*  481687 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(481773), // Rule ID 61120 //
     /*  481692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481739 */     // MIs[1] Operand 1
     /*  481739 */     // No operand predicates
     /*  481739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481771 */     GIR_RootConstrainSelectedInstOperands,
     /*  481772 */     // GIR_Coverage, 61120,
     /*  481772 */     GIR_EraseRootFromParent_Done,
     /*  481773 */   // Label 8133: @481773
     /*  481773 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(481859), // Rule ID 61121 //
     /*  481778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481825 */     // MIs[1] Operand 1
     /*  481825 */     // No operand predicates
     /*  481825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481834 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481857 */     GIR_RootConstrainSelectedInstOperands,
     /*  481858 */     // GIR_Coverage, 61121,
     /*  481858 */     GIR_EraseRootFromParent_Done,
     /*  481859 */   // Label 8134: @481859
     /*  481859 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(481945), // Rule ID 61128 //
     /*  481864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  481875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  481878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481911 */     // MIs[1] Operand 1
     /*  481911 */     // No operand predicates
     /*  481911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481920 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481943 */     GIR_RootConstrainSelectedInstOperands,
     /*  481944 */     // GIR_Coverage, 61128,
     /*  481944 */     GIR_EraseRootFromParent_Done,
     /*  481945 */   // Label 8135: @481945
     /*  481945 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(482031), // Rule ID 61129 //
     /*  481950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  481961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  481964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481997 */     // MIs[1] Operand 1
     /*  481997 */     // No operand predicates
     /*  481997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  482009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482029 */     GIR_RootConstrainSelectedInstOperands,
     /*  482030 */     // GIR_Coverage, 61129,
     /*  482030 */     GIR_EraseRootFromParent_Done,
     /*  482031 */   // Label 8136: @482031
     /*  482031 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(482117), // Rule ID 61136 //
     /*  482036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  482053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482083 */     // MIs[1] Operand 1
     /*  482083 */     // No operand predicates
     /*  482083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482092 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  482095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482115 */     GIR_RootConstrainSelectedInstOperands,
     /*  482116 */     // GIR_Coverage, 61136,
     /*  482116 */     GIR_EraseRootFromParent_Done,
     /*  482117 */   // Label 8137: @482117
     /*  482117 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(482203), // Rule ID 61137 //
     /*  482122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  482133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  482136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  482139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  482157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482169 */     // MIs[1] Operand 1
     /*  482169 */     // No operand predicates
     /*  482169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482178 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  482181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482201 */     GIR_RootConstrainSelectedInstOperands,
     /*  482202 */     // GIR_Coverage, 61137,
     /*  482202 */     GIR_EraseRootFromParent_Done,
     /*  482203 */   // Label 8138: @482203
     /*  482203 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(482289), // Rule ID 61144 //
     /*  482208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  482211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  482225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482255 */     // MIs[1] Operand 1
     /*  482255 */     // No operand predicates
     /*  482255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482264 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482287 */     GIR_RootConstrainSelectedInstOperands,
     /*  482288 */     // GIR_Coverage, 61144,
     /*  482288 */     GIR_EraseRootFromParent_Done,
     /*  482289 */   // Label 8139: @482289
     /*  482289 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(482375), // Rule ID 61145 //
     /*  482294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  482297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  482302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  482305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  482308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  482311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  482325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  482329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  482341 */     // MIs[1] Operand 1
     /*  482341 */     // No operand predicates
     /*  482341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482350 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  482353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482373 */     GIR_RootConstrainSelectedInstOperands,
     /*  482374 */     // GIR_Coverage, 61145,
     /*  482374 */     GIR_EraseRootFromParent_Done,
     /*  482375 */   // Label 8140: @482375
     /*  482375 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(482461), // Rule ID 62000 //
     /*  482380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  482391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  482394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  482397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482427 */     // MIs[1] Operand 1
     /*  482427 */     // No operand predicates
     /*  482427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482436 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  482439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482459 */     GIR_RootConstrainSelectedInstOperands,
     /*  482460 */     // GIR_Coverage, 62000,
     /*  482460 */     GIR_EraseRootFromParent_Done,
     /*  482461 */   // Label 8141: @482461
     /*  482461 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(482547), // Rule ID 62001 //
     /*  482466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  482477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  482480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  482483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482513 */     // MIs[1] Operand 1
     /*  482513 */     // No operand predicates
     /*  482513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482522 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  482525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482545 */     GIR_RootConstrainSelectedInstOperands,
     /*  482546 */     // GIR_Coverage, 62001,
     /*  482546 */     GIR_EraseRootFromParent_Done,
     /*  482547 */   // Label 8142: @482547
     /*  482547 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(482633), // Rule ID 62004 //
     /*  482552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  482563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  482566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  482569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482599 */     // MIs[1] Operand 1
     /*  482599 */     // No operand predicates
     /*  482599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482608 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482631 */     GIR_RootConstrainSelectedInstOperands,
     /*  482632 */     // GIR_Coverage, 62004,
     /*  482632 */     GIR_EraseRootFromParent_Done,
     /*  482633 */   // Label 8143: @482633
     /*  482633 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(482719), // Rule ID 62005 //
     /*  482638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  482649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  482652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  482655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482685 */     // MIs[1] Operand 1
     /*  482685 */     // No operand predicates
     /*  482685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482717 */     GIR_RootConstrainSelectedInstOperands,
     /*  482718 */     // GIR_Coverage, 62005,
     /*  482718 */     GIR_EraseRootFromParent_Done,
     /*  482719 */   // Label 8144: @482719
     /*  482719 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(482805), // Rule ID 62008 //
     /*  482724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  482735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  482738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  482741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482771 */     // MIs[1] Operand 1
     /*  482771 */     // No operand predicates
     /*  482771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482780 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482803 */     GIR_RootConstrainSelectedInstOperands,
     /*  482804 */     // GIR_Coverage, 62008,
     /*  482804 */     GIR_EraseRootFromParent_Done,
     /*  482805 */   // Label 8145: @482805
     /*  482805 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(482891), // Rule ID 62009 //
     /*  482810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  482821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  482824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  482827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482857 */     // MIs[1] Operand 1
     /*  482857 */     // No operand predicates
     /*  482857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482866 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482889 */     GIR_RootConstrainSelectedInstOperands,
     /*  482890 */     // GIR_Coverage, 62009,
     /*  482890 */     GIR_EraseRootFromParent_Done,
     /*  482891 */   // Label 8146: @482891
     /*  482891 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(482977), // Rule ID 62012 //
     /*  482896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  482907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  482910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482943 */     // MIs[1] Operand 1
     /*  482943 */     // No operand predicates
     /*  482943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482952 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482975 */     GIR_RootConstrainSelectedInstOperands,
     /*  482976 */     // GIR_Coverage, 62012,
     /*  482976 */     GIR_EraseRootFromParent_Done,
     /*  482977 */   // Label 8147: @482977
     /*  482977 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(483063), // Rule ID 62013 //
     /*  482982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  482993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  482996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483029 */     // MIs[1] Operand 1
     /*  483029 */     // No operand predicates
     /*  483029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  483041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483061 */     GIR_RootConstrainSelectedInstOperands,
     /*  483062 */     // GIR_Coverage, 62013,
     /*  483062 */     GIR_EraseRootFromParent_Done,
     /*  483063 */   // Label 8148: @483063
     /*  483063 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(483149), // Rule ID 62016 //
     /*  483068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  483085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483115 */     // MIs[1] Operand 1
     /*  483115 */     // No operand predicates
     /*  483115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483124 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483147 */     GIR_RootConstrainSelectedInstOperands,
     /*  483148 */     // GIR_Coverage, 62016,
     /*  483148 */     GIR_EraseRootFromParent_Done,
     /*  483149 */   // Label 8149: @483149
     /*  483149 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(483235), // Rule ID 62017 //
     /*  483154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  483165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  483168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  483171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483201 */     // MIs[1] Operand 1
     /*  483201 */     // No operand predicates
     /*  483201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483210 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483233 */     GIR_RootConstrainSelectedInstOperands,
     /*  483234 */     // GIR_Coverage, 62017,
     /*  483234 */     GIR_EraseRootFromParent_Done,
     /*  483235 */   // Label 8150: @483235
     /*  483235 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(483321), // Rule ID 62020 //
     /*  483240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  483251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  483254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  483257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483287 */     // MIs[1] Operand 1
     /*  483287 */     // No operand predicates
     /*  483287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483296 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483319 */     GIR_RootConstrainSelectedInstOperands,
     /*  483320 */     // GIR_Coverage, 62020,
     /*  483320 */     GIR_EraseRootFromParent_Done,
     /*  483321 */   // Label 8151: @483321
     /*  483321 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(483407), // Rule ID 62021 //
     /*  483326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  483337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  483340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  483343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483373 */     // MIs[1] Operand 1
     /*  483373 */     // No operand predicates
     /*  483373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483382 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  483385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483405 */     GIR_RootConstrainSelectedInstOperands,
     /*  483406 */     // GIR_Coverage, 62021,
     /*  483406 */     GIR_EraseRootFromParent_Done,
     /*  483407 */   // Label 8152: @483407
     /*  483407 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(483493), // Rule ID 62024 //
     /*  483412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  483423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  483426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483459 */     // MIs[1] Operand 1
     /*  483459 */     // No operand predicates
     /*  483459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483468 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483491 */     GIR_RootConstrainSelectedInstOperands,
     /*  483492 */     // GIR_Coverage, 62024,
     /*  483492 */     GIR_EraseRootFromParent_Done,
     /*  483493 */   // Label 8153: @483493
     /*  483493 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(483579), // Rule ID 62025 //
     /*  483498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  483509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  483512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483545 */     // MIs[1] Operand 1
     /*  483545 */     // No operand predicates
     /*  483545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483554 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483577 */     GIR_RootConstrainSelectedInstOperands,
     /*  483578 */     // GIR_Coverage, 62025,
     /*  483578 */     GIR_EraseRootFromParent_Done,
     /*  483579 */   // Label 8154: @483579
     /*  483579 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(483665), // Rule ID 62028 //
     /*  483584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  483601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483631 */     // MIs[1] Operand 1
     /*  483631 */     // No operand predicates
     /*  483631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483663 */     GIR_RootConstrainSelectedInstOperands,
     /*  483664 */     // GIR_Coverage, 62028,
     /*  483664 */     GIR_EraseRootFromParent_Done,
     /*  483665 */   // Label 8155: @483665
     /*  483665 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(483751), // Rule ID 62029 //
     /*  483670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  483687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483717 */     // MIs[1] Operand 1
     /*  483717 */     // No operand predicates
     /*  483717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483726 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483749 */     GIR_RootConstrainSelectedInstOperands,
     /*  483750 */     // GIR_Coverage, 62029,
     /*  483750 */     GIR_EraseRootFromParent_Done,
     /*  483751 */   // Label 8156: @483751
     /*  483751 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(483837), // Rule ID 62032 //
     /*  483756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  483767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  483770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  483773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483803 */     // MIs[1] Operand 1
     /*  483803 */     // No operand predicates
     /*  483803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483812 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483835 */     GIR_RootConstrainSelectedInstOperands,
     /*  483836 */     // GIR_Coverage, 62032,
     /*  483836 */     GIR_EraseRootFromParent_Done,
     /*  483837 */   // Label 8157: @483837
     /*  483837 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(483923), // Rule ID 62033 //
     /*  483842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  483853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  483856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  483859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483889 */     // MIs[1] Operand 1
     /*  483889 */     // No operand predicates
     /*  483889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483921 */     GIR_RootConstrainSelectedInstOperands,
     /*  483922 */     // GIR_Coverage, 62033,
     /*  483922 */     GIR_EraseRootFromParent_Done,
     /*  483923 */   // Label 8158: @483923
     /*  483923 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(484009), // Rule ID 62036 //
     /*  483928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  483939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  483942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  483945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483975 */     // MIs[1] Operand 1
     /*  483975 */     // No operand predicates
     /*  483975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  483984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  484004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484007 */     GIR_RootConstrainSelectedInstOperands,
     /*  484008 */     // GIR_Coverage, 62036,
     /*  484008 */     GIR_EraseRootFromParent_Done,
     /*  484009 */   // Label 8159: @484009
     /*  484009 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(484095), // Rule ID 62037 //
     /*  484014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  484025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  484028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  484031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  484049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484061 */     // MIs[1] Operand 1
     /*  484061 */     // No operand predicates
     /*  484061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  484070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  484073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  484090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484093 */     GIR_RootConstrainSelectedInstOperands,
     /*  484094 */     // GIR_Coverage, 62037,
     /*  484094 */     GIR_EraseRootFromParent_Done,
     /*  484095 */   // Label 8160: @484095
     /*  484095 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(484181), // Rule ID 62040 //
     /*  484100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  484111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  484114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484147 */     // MIs[1] Operand 1
     /*  484147 */     // No operand predicates
     /*  484147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484156 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484179 */     GIR_RootConstrainSelectedInstOperands,
     /*  484180 */     // GIR_Coverage, 62040,
     /*  484180 */     GIR_EraseRootFromParent_Done,
     /*  484181 */   // Label 8161: @484181
     /*  484181 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(484267), // Rule ID 62041 //
     /*  484186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  484197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  484200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  484203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484233 */     // MIs[1] Operand 1
     /*  484233 */     // No operand predicates
     /*  484233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484265 */     GIR_RootConstrainSelectedInstOperands,
     /*  484266 */     // GIR_Coverage, 62041,
     /*  484266 */     GIR_EraseRootFromParent_Done,
     /*  484267 */   // Label 8162: @484267
     /*  484267 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(484353), // Rule ID 62044 //
     /*  484272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  484283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  484286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484319 */     // MIs[1] Operand 1
     /*  484319 */     // No operand predicates
     /*  484319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484328 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484351 */     GIR_RootConstrainSelectedInstOperands,
     /*  484352 */     // GIR_Coverage, 62044,
     /*  484352 */     GIR_EraseRootFromParent_Done,
     /*  484353 */   // Label 8163: @484353
     /*  484353 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(484439), // Rule ID 62045 //
     /*  484358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  484369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  484372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  484375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484405 */     // MIs[1] Operand 1
     /*  484405 */     // No operand predicates
     /*  484405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484414 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484437 */     GIR_RootConstrainSelectedInstOperands,
     /*  484438 */     // GIR_Coverage, 62045,
     /*  484438 */     GIR_EraseRootFromParent_Done,
     /*  484439 */   // Label 8164: @484439
     /*  484439 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(484525), // Rule ID 62048 //
     /*  484444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  484455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  484458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  484461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484491 */     // MIs[1] Operand 1
     /*  484491 */     // No operand predicates
     /*  484491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484500 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  484500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  484503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484523 */     GIR_RootConstrainSelectedInstOperands,
     /*  484524 */     // GIR_Coverage, 62048,
     /*  484524 */     GIR_EraseRootFromParent_Done,
     /*  484525 */   // Label 8165: @484525
     /*  484525 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(484611), // Rule ID 62049 //
     /*  484530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  484541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  484544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  484547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484577 */     // MIs[1] Operand 1
     /*  484577 */     // No operand predicates
     /*  484577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484586 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  484589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484609 */     GIR_RootConstrainSelectedInstOperands,
     /*  484610 */     // GIR_Coverage, 62049,
     /*  484610 */     GIR_EraseRootFromParent_Done,
     /*  484611 */   // Label 8166: @484611
     /*  484611 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(484697), // Rule ID 62052 //
     /*  484616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  484633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484663 */     // MIs[1] Operand 1
     /*  484663 */     // No operand predicates
     /*  484663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484695 */     GIR_RootConstrainSelectedInstOperands,
     /*  484696 */     // GIR_Coverage, 62052,
     /*  484696 */     GIR_EraseRootFromParent_Done,
     /*  484697 */   // Label 8167: @484697
     /*  484697 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(484783), // Rule ID 62053 //
     /*  484702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  484719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484749 */     // MIs[1] Operand 1
     /*  484749 */     // No operand predicates
     /*  484749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484758 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484781 */     GIR_RootConstrainSelectedInstOperands,
     /*  484782 */     // GIR_Coverage, 62053,
     /*  484782 */     GIR_EraseRootFromParent_Done,
     /*  484783 */   // Label 8168: @484783
     /*  484783 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(484869), // Rule ID 62056 //
     /*  484788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  484805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484835 */     // MIs[1] Operand 1
     /*  484835 */     // No operand predicates
     /*  484835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484867 */     GIR_RootConstrainSelectedInstOperands,
     /*  484868 */     // GIR_Coverage, 62056,
     /*  484868 */     GIR_EraseRootFromParent_Done,
     /*  484869 */   // Label 8169: @484869
     /*  484869 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(484955), // Rule ID 62057 //
     /*  484874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  484891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484921 */     // MIs[1] Operand 1
     /*  484921 */     // No operand predicates
     /*  484921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484930 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484953 */     GIR_RootConstrainSelectedInstOperands,
     /*  484954 */     // GIR_Coverage, 62057,
     /*  484954 */     GIR_EraseRootFromParent_Done,
     /*  484955 */   // Label 8170: @484955
     /*  484955 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(485041), // Rule ID 62060 //
     /*  484960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  484977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485007 */     // MIs[1] Operand 1
     /*  485007 */     // No operand predicates
     /*  485007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485016 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  485016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485039 */     GIR_RootConstrainSelectedInstOperands,
     /*  485040 */     // GIR_Coverage, 62060,
     /*  485040 */     GIR_EraseRootFromParent_Done,
     /*  485041 */   // Label 8171: @485041
     /*  485041 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(485127), // Rule ID 62061 //
     /*  485046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  485057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  485060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  485063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485093 */     // MIs[1] Operand 1
     /*  485093 */     // No operand predicates
     /*  485093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485102 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  485102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  485122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485125 */     GIR_RootConstrainSelectedInstOperands,
     /*  485126 */     // GIR_Coverage, 62061,
     /*  485126 */     GIR_EraseRootFromParent_Done,
     /*  485127 */   // Label 8172: @485127
     /*  485127 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(485213), // Rule ID 62064 //
     /*  485132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485179 */     // MIs[1] Operand 1
     /*  485179 */     // No operand predicates
     /*  485179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485188 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485211 */     GIR_RootConstrainSelectedInstOperands,
     /*  485212 */     // GIR_Coverage, 62064,
     /*  485212 */     GIR_EraseRootFromParent_Done,
     /*  485213 */   // Label 8173: @485213
     /*  485213 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(485299), // Rule ID 62065 //
     /*  485218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  485229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  485232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  485235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485265 */     // MIs[1] Operand 1
     /*  485265 */     // No operand predicates
     /*  485265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485297 */     GIR_RootConstrainSelectedInstOperands,
     /*  485298 */     // GIR_Coverage, 62065,
     /*  485298 */     GIR_EraseRootFromParent_Done,
     /*  485299 */   // Label 8174: @485299
     /*  485299 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(485385), // Rule ID 62068 //
     /*  485304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485351 */     // MIs[1] Operand 1
     /*  485351 */     // No operand predicates
     /*  485351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485383 */     GIR_RootConstrainSelectedInstOperands,
     /*  485384 */     // GIR_Coverage, 62068,
     /*  485384 */     GIR_EraseRootFromParent_Done,
     /*  485385 */   // Label 8175: @485385
     /*  485385 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(485471), // Rule ID 62069 //
     /*  485390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  485401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  485404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  485407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485437 */     // MIs[1] Operand 1
     /*  485437 */     // No operand predicates
     /*  485437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485446 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485469 */     GIR_RootConstrainSelectedInstOperands,
     /*  485470 */     // GIR_Coverage, 62069,
     /*  485470 */     GIR_EraseRootFromParent_Done,
     /*  485471 */   // Label 8176: @485471
     /*  485471 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(485557), // Rule ID 62072 //
     /*  485476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  485493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485523 */     // MIs[1] Operand 1
     /*  485523 */     // No operand predicates
     /*  485523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485532 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485555 */     GIR_RootConstrainSelectedInstOperands,
     /*  485556 */     // GIR_Coverage, 62072,
     /*  485556 */     GIR_EraseRootFromParent_Done,
     /*  485557 */   // Label 8177: @485557
     /*  485557 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(485643), // Rule ID 62073 //
     /*  485562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  485579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485609 */     // MIs[1] Operand 1
     /*  485609 */     // No operand predicates
     /*  485609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485641 */     GIR_RootConstrainSelectedInstOperands,
     /*  485642 */     // GIR_Coverage, 62073,
     /*  485642 */     GIR_EraseRootFromParent_Done,
     /*  485643 */   // Label 8178: @485643
     /*  485643 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(485729), // Rule ID 62076 //
     /*  485648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  485665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485695 */     // MIs[1] Operand 1
     /*  485695 */     // No operand predicates
     /*  485695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485704 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  485704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485727 */     GIR_RootConstrainSelectedInstOperands,
     /*  485728 */     // GIR_Coverage, 62076,
     /*  485728 */     GIR_EraseRootFromParent_Done,
     /*  485729 */   // Label 8179: @485729
     /*  485729 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(485815), // Rule ID 62077 //
     /*  485734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  485751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485781 */     // MIs[1] Operand 1
     /*  485781 */     // No operand predicates
     /*  485781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  485790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485813 */     GIR_RootConstrainSelectedInstOperands,
     /*  485814 */     // GIR_Coverage, 62077,
     /*  485814 */     GIR_EraseRootFromParent_Done,
     /*  485815 */   // Label 8180: @485815
     /*  485815 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(485901), // Rule ID 62080 //
     /*  485820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  485837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485867 */     // MIs[1] Operand 1
     /*  485867 */     // No operand predicates
     /*  485867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  485876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485899 */     GIR_RootConstrainSelectedInstOperands,
     /*  485900 */     // GIR_Coverage, 62080,
     /*  485900 */     GIR_EraseRootFromParent_Done,
     /*  485901 */   // Label 8181: @485901
     /*  485901 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(485987), // Rule ID 62081 //
     /*  485906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  485923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485953 */     // MIs[1] Operand 1
     /*  485953 */     // No operand predicates
     /*  485953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485962 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  485962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485985 */     GIR_RootConstrainSelectedInstOperands,
     /*  485986 */     // GIR_Coverage, 62081,
     /*  485986 */     GIR_EraseRootFromParent_Done,
     /*  485987 */   // Label 8182: @485987
     /*  485987 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(486073), // Rule ID 62084 //
     /*  485992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  486009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  486012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486039 */     // MIs[1] Operand 1
     /*  486039 */     // No operand predicates
     /*  486039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486048 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  486048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486071 */     GIR_RootConstrainSelectedInstOperands,
     /*  486072 */     // GIR_Coverage, 62084,
     /*  486072 */     GIR_EraseRootFromParent_Done,
     /*  486073 */   // Label 8183: @486073
     /*  486073 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(486159), // Rule ID 62085 //
     /*  486078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  486081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  486086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  486089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  486092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  486095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  486098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  486117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  486121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  486125 */     // MIs[1] Operand 1
     /*  486125 */     // No operand predicates
     /*  486125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486134 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  486134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  486137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  486141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  486146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  486154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  486157 */     GIR_RootConstrainSelectedInstOperands,
     /*  486158 */     // GIR_Coverage, 62085,
     /*  486158 */     GIR_EraseRootFromParent_Done,
     /*  486159 */   // Label 8184: @486159
     /*  486159 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(486238), // Rule ID 2750 //
     /*  486164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  486184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486216 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  486219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486236 */     GIR_RootConstrainSelectedInstOperands,
     /*  486237 */     // GIR_Coverage, 2750,
     /*  486237 */     GIR_EraseRootFromParent_Done,
     /*  486238 */   // Label 8185: @486238
     /*  486238 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(486317), // Rule ID 2751 //
     /*  486243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  486254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  486257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  486260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  486263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486295 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  486298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486315 */     GIR_RootConstrainSelectedInstOperands,
     /*  486316 */     // GIR_Coverage, 2751,
     /*  486316 */     GIR_EraseRootFromParent_Done,
     /*  486317 */   // Label 8186: @486317
     /*  486317 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(486396), // Rule ID 4066 //
     /*  486322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  486342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486394 */     GIR_RootConstrainSelectedInstOperands,
     /*  486395 */     // GIR_Coverage, 4066,
     /*  486395 */     GIR_EraseRootFromParent_Done,
     /*  486396 */   // Label 8187: @486396
     /*  486396 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(486475), // Rule ID 4067 //
     /*  486401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  486412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  486415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  486418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  486421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486453 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486473 */     GIR_RootConstrainSelectedInstOperands,
     /*  486474 */     // GIR_Coverage, 4067,
     /*  486474 */     GIR_EraseRootFromParent_Done,
     /*  486475 */   // Label 8188: @486475
     /*  486475 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(486554), // Rule ID 4076 //
     /*  486480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  486491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  486494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  486497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  486500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  486535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486552 */     GIR_RootConstrainSelectedInstOperands,
     /*  486553 */     // GIR_Coverage, 4076,
     /*  486553 */     GIR_EraseRootFromParent_Done,
     /*  486554 */   // Label 8189: @486554
     /*  486554 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(486633), // Rule ID 4077 //
     /*  486559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  486570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  486573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  486576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  486579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486611 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  486614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486631 */     GIR_RootConstrainSelectedInstOperands,
     /*  486632 */     // GIR_Coverage, 4077,
     /*  486632 */     GIR_EraseRootFromParent_Done,
     /*  486633 */   // Label 8190: @486633
     /*  486633 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(486712), // Rule ID 4086 //
     /*  486638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  486649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  486652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  486655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  486658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  486693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486710 */     GIR_RootConstrainSelectedInstOperands,
     /*  486711 */     // GIR_Coverage, 4086,
     /*  486711 */     GIR_EraseRootFromParent_Done,
     /*  486712 */   // Label 8191: @486712
     /*  486712 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(486791), // Rule ID 4087 //
     /*  486717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  486728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  486731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  486734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  486737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486769 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  486772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486789 */     GIR_RootConstrainSelectedInstOperands,
     /*  486790 */     // GIR_Coverage, 4087,
     /*  486790 */     GIR_EraseRootFromParent_Done,
     /*  486791 */   // Label 8192: @486791
     /*  486791 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(486870), // Rule ID 4096 //
     /*  486796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  486807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  486810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  486813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  486816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  486851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486868 */     GIR_RootConstrainSelectedInstOperands,
     /*  486869 */     // GIR_Coverage, 4096,
     /*  486869 */     GIR_EraseRootFromParent_Done,
     /*  486870 */   // Label 8193: @486870
     /*  486870 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(486949), // Rule ID 4097 //
     /*  486875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  486886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  486889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  486892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  486895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486927 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  486930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486947 */     GIR_RootConstrainSelectedInstOperands,
     /*  486948 */     // GIR_Coverage, 4097,
     /*  486948 */     GIR_EraseRootFromParent_Done,
     /*  486949 */   // Label 8194: @486949
     /*  486949 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(487028), // Rule ID 4106 //
     /*  486954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  486965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  486968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  486971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  486974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487006 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  487006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487026 */     GIR_RootConstrainSelectedInstOperands,
     /*  487027 */     // GIR_Coverage, 4106,
     /*  487027 */     GIR_EraseRootFromParent_Done,
     /*  487028 */   // Label 8195: @487028
     /*  487028 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(487107), // Rule ID 4107 //
     /*  487033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  487044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  487047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  487050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  487053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487085 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  487085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  487102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487105 */     GIR_RootConstrainSelectedInstOperands,
     /*  487106 */     // GIR_Coverage, 4107,
     /*  487106 */     GIR_EraseRootFromParent_Done,
     /*  487107 */   // Label 8196: @487107
     /*  487107 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(487186), // Rule ID 4116 //
     /*  487112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  487132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487164 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  487167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487184 */     GIR_RootConstrainSelectedInstOperands,
     /*  487185 */     // GIR_Coverage, 4116,
     /*  487185 */     GIR_EraseRootFromParent_Done,
     /*  487186 */   // Label 8197: @487186
     /*  487186 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(487265), // Rule ID 4117 //
     /*  487191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  487202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  487205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  487208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  487211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  487246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487263 */     GIR_RootConstrainSelectedInstOperands,
     /*  487264 */     // GIR_Coverage, 4117,
     /*  487264 */     GIR_EraseRootFromParent_Done,
     /*  487265 */   // Label 8198: @487265
     /*  487265 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(487344), // Rule ID 4126 //
     /*  487270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  487290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487342 */     GIR_RootConstrainSelectedInstOperands,
     /*  487343 */     // GIR_Coverage, 4126,
     /*  487343 */     GIR_EraseRootFromParent_Done,
     /*  487344 */   // Label 8199: @487344
     /*  487344 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(487423), // Rule ID 4127 //
     /*  487349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  487360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  487363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  487366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  487369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487401 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487421 */     GIR_RootConstrainSelectedInstOperands,
     /*  487422 */     // GIR_Coverage, 4127,
     /*  487422 */     GIR_EraseRootFromParent_Done,
     /*  487423 */   // Label 8200: @487423
     /*  487423 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(487502), // Rule ID 4136 //
     /*  487428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  487448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487480 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487500 */     GIR_RootConstrainSelectedInstOperands,
     /*  487501 */     // GIR_Coverage, 4136,
     /*  487501 */     GIR_EraseRootFromParent_Done,
     /*  487502 */   // Label 8201: @487502
     /*  487502 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(487581), // Rule ID 4137 //
     /*  487507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  487527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487579 */     GIR_RootConstrainSelectedInstOperands,
     /*  487580 */     // GIR_Coverage, 4137,
     /*  487580 */     GIR_EraseRootFromParent_Done,
     /*  487581 */   // Label 8202: @487581
     /*  487581 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(487660), // Rule ID 4146 //
     /*  487586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  487597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  487600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  487603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  487606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487638 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487658 */     GIR_RootConstrainSelectedInstOperands,
     /*  487659 */     // GIR_Coverage, 4146,
     /*  487659 */     GIR_EraseRootFromParent_Done,
     /*  487660 */   // Label 8203: @487660
     /*  487660 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(487739), // Rule ID 4147 //
     /*  487665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  487676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  487679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  487682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  487685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487717 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487737 */     GIR_RootConstrainSelectedInstOperands,
     /*  487738 */     // GIR_Coverage, 4147,
     /*  487738 */     GIR_EraseRootFromParent_Done,
     /*  487739 */   // Label 8204: @487739
     /*  487739 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(487818), // Rule ID 4156 //
     /*  487744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  487755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  487758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  487761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  487764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487816 */     GIR_RootConstrainSelectedInstOperands,
     /*  487817 */     // GIR_Coverage, 4156,
     /*  487817 */     GIR_EraseRootFromParent_Done,
     /*  487818 */   // Label 8205: @487818
     /*  487818 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(487897), // Rule ID 4157 //
     /*  487823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  487834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  487837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  487840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  487843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487875 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487895 */     GIR_RootConstrainSelectedInstOperands,
     /*  487896 */     // GIR_Coverage, 4157,
     /*  487896 */     GIR_EraseRootFromParent_Done,
     /*  487897 */   // Label 8206: @487897
     /*  487897 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(487976), // Rule ID 4166 //
     /*  487902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  487919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  487922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487954 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  487954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487974 */     GIR_RootConstrainSelectedInstOperands,
     /*  487975 */     // GIR_Coverage, 4166,
     /*  487975 */     GIR_EraseRootFromParent_Done,
     /*  487976 */   // Label 8207: @487976
     /*  487976 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(488055), // Rule ID 4167 //
     /*  487981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  487998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  488001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488033 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  488036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488053 */     GIR_RootConstrainSelectedInstOperands,
     /*  488054 */     // GIR_Coverage, 4167,
     /*  488054 */     GIR_EraseRootFromParent_Done,
     /*  488055 */   // Label 8208: @488055
     /*  488055 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(488134), // Rule ID 4176 //
     /*  488060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  488071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  488074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  488077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  488080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488132 */     GIR_RootConstrainSelectedInstOperands,
     /*  488133 */     // GIR_Coverage, 4176,
     /*  488133 */     GIR_EraseRootFromParent_Done,
     /*  488134 */   // Label 8209: @488134
     /*  488134 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(488213), // Rule ID 4177 //
     /*  488139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  488150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  488153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  488156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  488159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  488194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488211 */     GIR_RootConstrainSelectedInstOperands,
     /*  488212 */     // GIR_Coverage, 4177,
     /*  488212 */     GIR_EraseRootFromParent_Done,
     /*  488213 */   // Label 8210: @488213
     /*  488213 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(488292), // Rule ID 4186 //
     /*  488218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  488229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  488232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  488235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  488238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488290 */     GIR_RootConstrainSelectedInstOperands,
     /*  488291 */     // GIR_Coverage, 4186,
     /*  488291 */     GIR_EraseRootFromParent_Done,
     /*  488292 */   // Label 8211: @488292
     /*  488292 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(488371), // Rule ID 4187 //
     /*  488297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  488308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  488311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  488314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  488317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488349 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  488352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488369 */     GIR_RootConstrainSelectedInstOperands,
     /*  488370 */     // GIR_Coverage, 4187,
     /*  488370 */     GIR_EraseRootFromParent_Done,
     /*  488371 */   // Label 8212: @488371
     /*  488371 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(488450), // Rule ID 4196 //
     /*  488376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  488379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  488387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  488390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  488393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  488396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488428 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  488428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488448 */     GIR_RootConstrainSelectedInstOperands,
     /*  488449 */     // GIR_Coverage, 4196,
     /*  488449 */     GIR_EraseRootFromParent_Done,
     /*  488450 */   // Label 8213: @488450
     /*  488450 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(488529), // Rule ID 4197 //
     /*  488455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  488458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  488463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  488466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  488469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  488472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  488475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488507 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  488507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488527 */     GIR_RootConstrainSelectedInstOperands,
     /*  488528 */     // GIR_Coverage, 4197,
     /*  488528 */     GIR_EraseRootFromParent_Done,
     /*  488529 */   // Label 8214: @488529
     /*  488529 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(488608), // Rule ID 4266 //
     /*  488534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  488545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  488548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  488551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  488554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  488589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488606 */     GIR_RootConstrainSelectedInstOperands,
     /*  488607 */     // GIR_Coverage, 4266,
     /*  488607 */     GIR_EraseRootFromParent_Done,
     /*  488608 */   // Label 8215: @488608
     /*  488608 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(488687), // Rule ID 4267 //
     /*  488613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  488624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  488627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  488630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  488633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488665 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  488668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488685 */     GIR_RootConstrainSelectedInstOperands,
     /*  488686 */     // GIR_Coverage, 4267,
     /*  488686 */     GIR_EraseRootFromParent_Done,
     /*  488687 */   // Label 8216: @488687
     /*  488687 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(488766), // Rule ID 4276 //
     /*  488692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  488703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  488706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  488709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  488712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  488747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488764 */     GIR_RootConstrainSelectedInstOperands,
     /*  488765 */     // GIR_Coverage, 4276,
     /*  488765 */     GIR_EraseRootFromParent_Done,
     /*  488766 */   // Label 8217: @488766
     /*  488766 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(488845), // Rule ID 4277 //
     /*  488771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  488782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  488785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  488788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  488791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488823 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  488826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488843 */     GIR_RootConstrainSelectedInstOperands,
     /*  488844 */     // GIR_Coverage, 4277,
     /*  488844 */     GIR_EraseRootFromParent_Done,
     /*  488845 */   // Label 8218: @488845
     /*  488845 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(488924), // Rule ID 4286 //
     /*  488850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  488861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  488864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  488867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  488870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  488905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488922 */     GIR_RootConstrainSelectedInstOperands,
     /*  488923 */     // GIR_Coverage, 4286,
     /*  488923 */     GIR_EraseRootFromParent_Done,
     /*  488924 */   // Label 8219: @488924
     /*  488924 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(489003), // Rule ID 4287 //
     /*  488929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  488940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  488943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  488946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  488949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488981 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  488984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489001 */     GIR_RootConstrainSelectedInstOperands,
     /*  489002 */     // GIR_Coverage, 4287,
     /*  489002 */     GIR_EraseRootFromParent_Done,
     /*  489003 */   // Label 8220: @489003
     /*  489003 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(489082), // Rule ID 4296 //
     /*  489008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  489019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  489022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  489028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489080 */     GIR_RootConstrainSelectedInstOperands,
     /*  489081 */     // GIR_Coverage, 4296,
     /*  489081 */     GIR_EraseRootFromParent_Done,
     /*  489082 */   // Label 8221: @489082
     /*  489082 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(489161), // Rule ID 4297 //
     /*  489087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  489098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  489101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  489104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  489107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489139 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489159 */     GIR_RootConstrainSelectedInstOperands,
     /*  489160 */     // GIR_Coverage, 4297,
     /*  489160 */     GIR_EraseRootFromParent_Done,
     /*  489161 */   // Label 8222: @489161
     /*  489161 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(489240), // Rule ID 4306 //
     /*  489166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  489177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  489180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  489186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489238 */     GIR_RootConstrainSelectedInstOperands,
     /*  489239 */     // GIR_Coverage, 4306,
     /*  489239 */     GIR_EraseRootFromParent_Done,
     /*  489240 */   // Label 8223: @489240
     /*  489240 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(489319), // Rule ID 4307 //
     /*  489245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  489256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  489259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  489262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  489265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489297 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489317 */     GIR_RootConstrainSelectedInstOperands,
     /*  489318 */     // GIR_Coverage, 4307,
     /*  489318 */     GIR_EraseRootFromParent_Done,
     /*  489319 */   // Label 8224: @489319
     /*  489319 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(489398), // Rule ID 4316 //
     /*  489324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  489335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  489338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  489341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  489344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489376 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  489376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489396 */     GIR_RootConstrainSelectedInstOperands,
     /*  489397 */     // GIR_Coverage, 4316,
     /*  489397 */     GIR_EraseRootFromParent_Done,
     /*  489398 */   // Label 8225: @489398
     /*  489398 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(489477), // Rule ID 4317 //
     /*  489403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  489414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  489417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  489420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  489423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489455 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  489455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  489472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489475 */     GIR_RootConstrainSelectedInstOperands,
     /*  489476 */     // GIR_Coverage, 4317,
     /*  489476 */     GIR_EraseRootFromParent_Done,
     /*  489477 */   // Label 8226: @489477
     /*  489477 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(489556), // Rule ID 4326 //
     /*  489482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  489493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  489496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  489499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  489502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489534 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489554 */     GIR_RootConstrainSelectedInstOperands,
     /*  489555 */     // GIR_Coverage, 4326,
     /*  489555 */     GIR_EraseRootFromParent_Done,
     /*  489556 */   // Label 8227: @489556
     /*  489556 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(489635), // Rule ID 4327 //
     /*  489561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  489572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  489575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  489578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  489581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489613 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489633 */     GIR_RootConstrainSelectedInstOperands,
     /*  489634 */     // GIR_Coverage, 4327,
     /*  489634 */     GIR_EraseRootFromParent_Done,
     /*  489635 */   // Label 8228: @489635
     /*  489635 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(489714), // Rule ID 4336 //
     /*  489640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  489651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  489654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  489657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  489660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489692 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489712 */     GIR_RootConstrainSelectedInstOperands,
     /*  489713 */     // GIR_Coverage, 4336,
     /*  489713 */     GIR_EraseRootFromParent_Done,
     /*  489714 */   // Label 8229: @489714
     /*  489714 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(489793), // Rule ID 4337 //
     /*  489719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  489730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  489733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  489736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  489739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489771 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489791 */     GIR_RootConstrainSelectedInstOperands,
     /*  489792 */     // GIR_Coverage, 4337,
     /*  489792 */     GIR_EraseRootFromParent_Done,
     /*  489793 */   // Label 8230: @489793
     /*  489793 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(489872), // Rule ID 4346 //
     /*  489798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  489815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  489818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489870 */     GIR_RootConstrainSelectedInstOperands,
     /*  489871 */     // GIR_Coverage, 4346,
     /*  489871 */     GIR_EraseRootFromParent_Done,
     /*  489872 */   // Label 8231: @489872
     /*  489872 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(489951), // Rule ID 4347 //
     /*  489877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  489894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  489897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489949 */     GIR_RootConstrainSelectedInstOperands,
     /*  489950 */     // GIR_Coverage, 4347,
     /*  489950 */     GIR_EraseRootFromParent_Done,
     /*  489951 */   // Label 8232: @489951
     /*  489951 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(490030), // Rule ID 4356 //
     /*  489956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  489973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  489976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490028 */     GIR_RootConstrainSelectedInstOperands,
     /*  490029 */     // GIR_Coverage, 4356,
     /*  490029 */     GIR_EraseRootFromParent_Done,
     /*  490030 */   // Label 8233: @490030
     /*  490030 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(490109), // Rule ID 4357 //
     /*  490035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  490046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  490049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  490052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  490055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490087 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490107 */     GIR_RootConstrainSelectedInstOperands,
     /*  490108 */     // GIR_Coverage, 4357,
     /*  490108 */     GIR_EraseRootFromParent_Done,
     /*  490109 */   // Label 8234: @490109
     /*  490109 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(490188), // Rule ID 4366 //
     /*  490114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  490125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  490128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  490131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  490134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  490166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490186 */     GIR_RootConstrainSelectedInstOperands,
     /*  490187 */     // GIR_Coverage, 4366,
     /*  490187 */     GIR_EraseRootFromParent_Done,
     /*  490188 */   // Label 8235: @490188
     /*  490188 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(490267), // Rule ID 4367 //
     /*  490193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  490204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  490207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  490210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  490213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490245 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  490245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  490262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490265 */     GIR_RootConstrainSelectedInstOperands,
     /*  490266 */     // GIR_Coverage, 4367,
     /*  490266 */     GIR_EraseRootFromParent_Done,
     /*  490267 */   // Label 8236: @490267
     /*  490267 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(490346), // Rule ID 4376 //
     /*  490272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  490283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  490286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  490289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  490292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490344 */     GIR_RootConstrainSelectedInstOperands,
     /*  490345 */     // GIR_Coverage, 4376,
     /*  490345 */     GIR_EraseRootFromParent_Done,
     /*  490346 */   // Label 8237: @490346
     /*  490346 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(490425), // Rule ID 4377 //
     /*  490351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  490362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  490365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  490368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  490371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490403 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  490406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490423 */     GIR_RootConstrainSelectedInstOperands,
     /*  490424 */     // GIR_Coverage, 4377,
     /*  490424 */     GIR_EraseRootFromParent_Done,
     /*  490425 */   // Label 8238: @490425
     /*  490425 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(490504), // Rule ID 4386 //
     /*  490430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  490441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  490444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  490447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  490450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490482 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490502 */     GIR_RootConstrainSelectedInstOperands,
     /*  490503 */     // GIR_Coverage, 4386,
     /*  490503 */     GIR_EraseRootFromParent_Done,
     /*  490504 */   // Label 8239: @490504
     /*  490504 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(490583), // Rule ID 4387 //
     /*  490509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  490520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  490523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  490526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  490529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490561 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490581 */     GIR_RootConstrainSelectedInstOperands,
     /*  490582 */     // GIR_Coverage, 4387,
     /*  490582 */     GIR_EraseRootFromParent_Done,
     /*  490583 */   // Label 8240: @490583
     /*  490583 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(490662), // Rule ID 4396 //
     /*  490588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  490599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  490602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  490605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  490608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490640 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490660 */     GIR_RootConstrainSelectedInstOperands,
     /*  490661 */     // GIR_Coverage, 4396,
     /*  490661 */     GIR_EraseRootFromParent_Done,
     /*  490662 */   // Label 8241: @490662
     /*  490662 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(490741), // Rule ID 4397 //
     /*  490667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  490678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  490681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  490684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  490687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490719 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490739 */     GIR_RootConstrainSelectedInstOperands,
     /*  490740 */     // GIR_Coverage, 4397,
     /*  490740 */     GIR_EraseRootFromParent_Done,
     /*  490741 */   // Label 8242: @490741
     /*  490741 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(490820), // Rule ID 4406 //
     /*  490746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  490757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  490760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  490763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  490766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490798 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490818 */     GIR_RootConstrainSelectedInstOperands,
     /*  490819 */     // GIR_Coverage, 4406,
     /*  490819 */     GIR_EraseRootFromParent_Done,
     /*  490820 */   // Label 8243: @490820
     /*  490820 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(490899), // Rule ID 4407 //
     /*  490825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  490836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  490839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  490842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  490845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490877 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490897 */     GIR_RootConstrainSelectedInstOperands,
     /*  490898 */     // GIR_Coverage, 4407,
     /*  490898 */     GIR_EraseRootFromParent_Done,
     /*  490899 */   // Label 8244: @490899
     /*  490899 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(490978), // Rule ID 4476 //
     /*  490904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  490915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  490918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  490921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  490924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490956 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  490959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490976 */     GIR_RootConstrainSelectedInstOperands,
     /*  490977 */     // GIR_Coverage, 4476,
     /*  490977 */     GIR_EraseRootFromParent_Done,
     /*  490978 */   // Label 8245: @490978
     /*  490978 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(491057), // Rule ID 4477 //
     /*  490983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  490994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  490997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  491000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  491003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491035 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  491038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491055 */     GIR_RootConstrainSelectedInstOperands,
     /*  491056 */     // GIR_Coverage, 4477,
     /*  491056 */     GIR_EraseRootFromParent_Done,
     /*  491057 */   // Label 8246: @491057
     /*  491057 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(491136), // Rule ID 4486 //
     /*  491062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  491073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  491076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  491079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  491082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491114 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491134 */     GIR_RootConstrainSelectedInstOperands,
     /*  491135 */     // GIR_Coverage, 4486,
     /*  491135 */     GIR_EraseRootFromParent_Done,
     /*  491136 */   // Label 8247: @491136
     /*  491136 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(491215), // Rule ID 4487 //
     /*  491141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  491152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  491155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  491158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  491161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491193 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491213 */     GIR_RootConstrainSelectedInstOperands,
     /*  491214 */     // GIR_Coverage, 4487,
     /*  491214 */     GIR_EraseRootFromParent_Done,
     /*  491215 */   // Label 8248: @491215
     /*  491215 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(491294), // Rule ID 4496 //
     /*  491220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  491231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  491234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  491237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  491240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491272 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491292 */     GIR_RootConstrainSelectedInstOperands,
     /*  491293 */     // GIR_Coverage, 4496,
     /*  491293 */     GIR_EraseRootFromParent_Done,
     /*  491294 */   // Label 8249: @491294
     /*  491294 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(491373), // Rule ID 4497 //
     /*  491299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  491310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  491313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  491316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  491319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491351 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491371 */     GIR_RootConstrainSelectedInstOperands,
     /*  491372 */     // GIR_Coverage, 4497,
     /*  491372 */     GIR_EraseRootFromParent_Done,
     /*  491373 */   // Label 8250: @491373
     /*  491373 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(491452), // Rule ID 4506 //
     /*  491378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  491389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  491392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  491395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  491398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491450 */     GIR_RootConstrainSelectedInstOperands,
     /*  491451 */     // GIR_Coverage, 4506,
     /*  491451 */     GIR_EraseRootFromParent_Done,
     /*  491452 */   // Label 8251: @491452
     /*  491452 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(491531), // Rule ID 4507 //
     /*  491457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  491468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  491471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  491474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  491477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491529 */     GIR_RootConstrainSelectedInstOperands,
     /*  491530 */     // GIR_Coverage, 4507,
     /*  491530 */     GIR_EraseRootFromParent_Done,
     /*  491531 */   // Label 8252: @491531
     /*  491531 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(491610), // Rule ID 4516 //
     /*  491536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  491547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  491550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  491553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  491556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491588 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  491591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491608 */     GIR_RootConstrainSelectedInstOperands,
     /*  491609 */     // GIR_Coverage, 4516,
     /*  491609 */     GIR_EraseRootFromParent_Done,
     /*  491610 */   // Label 8253: @491610
     /*  491610 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(491689), // Rule ID 4517 //
     /*  491615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  491626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  491629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  491632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  491635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491667 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  491670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491687 */     GIR_RootConstrainSelectedInstOperands,
     /*  491688 */     // GIR_Coverage, 4517,
     /*  491688 */     GIR_EraseRootFromParent_Done,
     /*  491689 */   // Label 8254: @491689
     /*  491689 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(491768), // Rule ID 4526 //
     /*  491694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  491705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  491708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  491711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  491714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  491749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491766 */     GIR_RootConstrainSelectedInstOperands,
     /*  491767 */     // GIR_Coverage, 4526,
     /*  491767 */     GIR_EraseRootFromParent_Done,
     /*  491768 */   // Label 8255: @491768
     /*  491768 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(491847), // Rule ID 4527 //
     /*  491773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  491784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  491787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  491790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  491793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491825 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  491828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491845 */     GIR_RootConstrainSelectedInstOperands,
     /*  491846 */     // GIR_Coverage, 4527,
     /*  491846 */     GIR_EraseRootFromParent_Done,
     /*  491847 */   // Label 8256: @491847
     /*  491847 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(491926), // Rule ID 4536 //
     /*  491852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  491863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  491866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491904 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491924 */     GIR_RootConstrainSelectedInstOperands,
     /*  491925 */     // GIR_Coverage, 4536,
     /*  491925 */     GIR_EraseRootFromParent_Done,
     /*  491926 */   // Label 8257: @491926
     /*  491926 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(492005), // Rule ID 4537 //
     /*  491931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  491942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  491945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491983 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492003 */     GIR_RootConstrainSelectedInstOperands,
     /*  492004 */     // GIR_Coverage, 4537,
     /*  492004 */     GIR_EraseRootFromParent_Done,
     /*  492005 */   // Label 8258: @492005
     /*  492005 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(492084), // Rule ID 4546 //
     /*  492010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  492021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  492024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  492027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  492030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492062 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492082 */     GIR_RootConstrainSelectedInstOperands,
     /*  492083 */     // GIR_Coverage, 4546,
     /*  492083 */     GIR_EraseRootFromParent_Done,
     /*  492084 */   // Label 8259: @492084
     /*  492084 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(492163), // Rule ID 4547 //
     /*  492089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  492100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  492103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  492106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  492109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492141 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492161 */     GIR_RootConstrainSelectedInstOperands,
     /*  492162 */     // GIR_Coverage, 4547,
     /*  492162 */     GIR_EraseRootFromParent_Done,
     /*  492163 */   // Label 8260: @492163
     /*  492163 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(492242), // Rule ID 4556 //
     /*  492168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  492179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  492182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  492185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  492188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492240 */     GIR_RootConstrainSelectedInstOperands,
     /*  492241 */     // GIR_Coverage, 4556,
     /*  492241 */     GIR_EraseRootFromParent_Done,
     /*  492242 */   // Label 8261: @492242
     /*  492242 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(492321), // Rule ID 4557 //
     /*  492247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  492258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  492261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  492264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  492267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492299 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492319 */     GIR_RootConstrainSelectedInstOperands,
     /*  492320 */     // GIR_Coverage, 4557,
     /*  492320 */     GIR_EraseRootFromParent_Done,
     /*  492321 */   // Label 8262: @492321
     /*  492321 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(492400), // Rule ID 4566 //
     /*  492326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  492337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  492340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  492343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  492346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492378 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492398 */     GIR_RootConstrainSelectedInstOperands,
     /*  492399 */     // GIR_Coverage, 4566,
     /*  492399 */     GIR_EraseRootFromParent_Done,
     /*  492400 */   // Label 8263: @492400
     /*  492400 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(492479), // Rule ID 4567 //
     /*  492405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  492416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  492419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  492422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  492425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492457 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492477 */     GIR_RootConstrainSelectedInstOperands,
     /*  492478 */     // GIR_Coverage, 4567,
     /*  492478 */     GIR_EraseRootFromParent_Done,
     /*  492479 */   // Label 8264: @492479
     /*  492479 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(492558), // Rule ID 4576 //
     /*  492484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  492495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  492498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  492501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  492504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492556 */     GIR_RootConstrainSelectedInstOperands,
     /*  492557 */     // GIR_Coverage, 4576,
     /*  492557 */     GIR_EraseRootFromParent_Done,
     /*  492558 */   // Label 8265: @492558
     /*  492558 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(492637), // Rule ID 4577 //
     /*  492563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  492574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  492577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  492580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  492583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492615 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492635 */     GIR_RootConstrainSelectedInstOperands,
     /*  492636 */     // GIR_Coverage, 4577,
     /*  492636 */     GIR_EraseRootFromParent_Done,
     /*  492637 */   // Label 8266: @492637
     /*  492637 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(492716), // Rule ID 4586 //
     /*  492642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  492653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  492656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  492659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  492662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492694 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492714 */     GIR_RootConstrainSelectedInstOperands,
     /*  492715 */     // GIR_Coverage, 4586,
     /*  492715 */     GIR_EraseRootFromParent_Done,
     /*  492716 */   // Label 8267: @492716
     /*  492716 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(492795), // Rule ID 4587 //
     /*  492721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  492732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  492735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  492738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  492741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492773 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492793 */     GIR_RootConstrainSelectedInstOperands,
     /*  492794 */     // GIR_Coverage, 4587,
     /*  492794 */     GIR_EraseRootFromParent_Done,
     /*  492795 */   // Label 8268: @492795
     /*  492795 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(492874), // Rule ID 4596 //
     /*  492800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  492811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  492814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  492817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  492820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492852 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492872 */     GIR_RootConstrainSelectedInstOperands,
     /*  492873 */     // GIR_Coverage, 4596,
     /*  492873 */     GIR_EraseRootFromParent_Done,
     /*  492874 */   // Label 8269: @492874
     /*  492874 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(492953), // Rule ID 4597 //
     /*  492879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  492890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  492893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  492896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  492899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492931 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492951 */     GIR_RootConstrainSelectedInstOperands,
     /*  492952 */     // GIR_Coverage, 4597,
     /*  492952 */     GIR_EraseRootFromParent_Done,
     /*  492953 */   // Label 8270: @492953
     /*  492953 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(493032), // Rule ID 4606 //
     /*  492958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  493013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493030 */     GIR_RootConstrainSelectedInstOperands,
     /*  493031 */     // GIR_Coverage, 4606,
     /*  493031 */     GIR_EraseRootFromParent_Done,
     /*  493032 */   // Label 8271: @493032
     /*  493032 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(493111), // Rule ID 4607 //
     /*  493037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  493048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  493051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  493054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  493057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493089 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  493092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493109 */     GIR_RootConstrainSelectedInstOperands,
     /*  493110 */     // GIR_Coverage, 4607,
     /*  493110 */     GIR_EraseRootFromParent_Done,
     /*  493111 */   // Label 8272: @493111
     /*  493111 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(493190), // Rule ID 4616 //
     /*  493116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  493119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  493127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  493130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  493133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  493136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  493168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493188 */     GIR_RootConstrainSelectedInstOperands,
     /*  493189 */     // GIR_Coverage, 4616,
     /*  493189 */     GIR_EraseRootFromParent_Done,
     /*  493190 */   // Label 8273: @493190
     /*  493190 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(493269), // Rule ID 4617 //
     /*  493195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  493198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  493203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  493206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  493209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  493212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  493215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493247 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11641:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  493247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  493250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  493264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493267 */     GIR_RootConstrainSelectedInstOperands,
     /*  493268 */     // GIR_Coverage, 4617,
     /*  493268 */     GIR_EraseRootFromParent_Done,
     /*  493269 */   // Label 8274: @493269
     /*  493269 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(493348), // Rule ID 4686 //
     /*  493274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  493285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  493288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  493291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  493294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493326 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  493329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493346 */     GIR_RootConstrainSelectedInstOperands,
     /*  493347 */     // GIR_Coverage, 4686,
     /*  493347 */     GIR_EraseRootFromParent_Done,
     /*  493348 */   // Label 8275: @493348
     /*  493348 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(493427), // Rule ID 4687 //
     /*  493353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  493364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  493367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  493370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  493373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493405 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  493408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493425 */     GIR_RootConstrainSelectedInstOperands,
     /*  493426 */     // GIR_Coverage, 4687,
     /*  493426 */     GIR_EraseRootFromParent_Done,
     /*  493427 */   // Label 8276: @493427
     /*  493427 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(493506), // Rule ID 4696 //
     /*  493432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  493443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  493446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  493449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  493452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493484 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  493487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493504 */     GIR_RootConstrainSelectedInstOperands,
     /*  493505 */     // GIR_Coverage, 4696,
     /*  493505 */     GIR_EraseRootFromParent_Done,
     /*  493506 */   // Label 8277: @493506
     /*  493506 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(493585), // Rule ID 4697 //
     /*  493511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  493522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  493525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  493528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  493531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493563 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  493566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493583 */     GIR_RootConstrainSelectedInstOperands,
     /*  493584 */     // GIR_Coverage, 4697,
     /*  493584 */     GIR_EraseRootFromParent_Done,
     /*  493585 */   // Label 8278: @493585
     /*  493585 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(493664), // Rule ID 4706 //
     /*  493590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  493601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  493604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  493607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  493610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  493645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493662 */     GIR_RootConstrainSelectedInstOperands,
     /*  493663 */     // GIR_Coverage, 4706,
     /*  493663 */     GIR_EraseRootFromParent_Done,
     /*  493664 */   // Label 8279: @493664
     /*  493664 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(493743), // Rule ID 4707 //
     /*  493669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  493680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  493683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  493686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  493689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  493724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493741 */     GIR_RootConstrainSelectedInstOperands,
     /*  493742 */     // GIR_Coverage, 4707,
     /*  493742 */     GIR_EraseRootFromParent_Done,
     /*  493743 */   // Label 8280: @493743
     /*  493743 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(493822), // Rule ID 4716 //
     /*  493748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  493759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  493762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  493765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  493768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  493803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493820 */     GIR_RootConstrainSelectedInstOperands,
     /*  493821 */     // GIR_Coverage, 4716,
     /*  493821 */     GIR_EraseRootFromParent_Done,
     /*  493822 */   // Label 8281: @493822
     /*  493822 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(493901), // Rule ID 4717 //
     /*  493827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  493838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  493841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  493844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  493847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  493882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493899 */     GIR_RootConstrainSelectedInstOperands,
     /*  493900 */     // GIR_Coverage, 4717,
     /*  493900 */     GIR_EraseRootFromParent_Done,
     /*  493901 */   // Label 8282: @493901
     /*  493901 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(493980), // Rule ID 4726 //
     /*  493906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  493923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  493926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493958 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  493961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493978 */     GIR_RootConstrainSelectedInstOperands,
     /*  493979 */     // GIR_Coverage, 4726,
     /*  493979 */     GIR_EraseRootFromParent_Done,
     /*  493980 */   // Label 8283: @493980
     /*  493980 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(494059), // Rule ID 4727 //
     /*  493985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  494002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  494005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494037 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494057 */     GIR_RootConstrainSelectedInstOperands,
     /*  494058 */     // GIR_Coverage, 4727,
     /*  494058 */     GIR_EraseRootFromParent_Done,
     /*  494059 */   // Label 8284: @494059
     /*  494059 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(494138), // Rule ID 4736 //
     /*  494064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  494075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  494078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  494081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  494084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494116 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  494116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494136 */     GIR_RootConstrainSelectedInstOperands,
     /*  494137 */     // GIR_Coverage, 4736,
     /*  494137 */     GIR_EraseRootFromParent_Done,
     /*  494138 */   // Label 8285: @494138
     /*  494138 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(494217), // Rule ID 4737 //
     /*  494143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  494154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  494157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  494160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  494163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494195 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  494195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  494212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494215 */     GIR_RootConstrainSelectedInstOperands,
     /*  494216 */     // GIR_Coverage, 4737,
     /*  494216 */     GIR_EraseRootFromParent_Done,
     /*  494217 */   // Label 8286: @494217
     /*  494217 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(494296), // Rule ID 4746 //
     /*  494222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  494233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  494236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  494239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  494242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494294 */     GIR_RootConstrainSelectedInstOperands,
     /*  494295 */     // GIR_Coverage, 4746,
     /*  494295 */     GIR_EraseRootFromParent_Done,
     /*  494296 */   // Label 8287: @494296
     /*  494296 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(494375), // Rule ID 4747 //
     /*  494301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  494312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  494315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  494318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  494321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494353 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  494356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494373 */     GIR_RootConstrainSelectedInstOperands,
     /*  494374 */     // GIR_Coverage, 4747,
     /*  494374 */     GIR_EraseRootFromParent_Done,
     /*  494375 */   // Label 8288: @494375
     /*  494375 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(494454), // Rule ID 4756 //
     /*  494380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  494391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  494394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  494397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  494400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494452 */     GIR_RootConstrainSelectedInstOperands,
     /*  494453 */     // GIR_Coverage, 4756,
     /*  494453 */     GIR_EraseRootFromParent_Done,
     /*  494454 */   // Label 8289: @494454
     /*  494454 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(494533), // Rule ID 4757 //
     /*  494459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  494470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  494473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  494476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  494479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494511 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494531 */     GIR_RootConstrainSelectedInstOperands,
     /*  494532 */     // GIR_Coverage, 4757,
     /*  494532 */     GIR_EraseRootFromParent_Done,
     /*  494533 */   // Label 8290: @494533
     /*  494533 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(494612), // Rule ID 4766 //
     /*  494538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  494549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  494552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  494555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  494558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494610 */     GIR_RootConstrainSelectedInstOperands,
     /*  494611 */     // GIR_Coverage, 4766,
     /*  494611 */     GIR_EraseRootFromParent_Done,
     /*  494612 */   // Label 8291: @494612
     /*  494612 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(494691), // Rule ID 4767 //
     /*  494617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  494628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  494631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  494634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  494637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494689 */     GIR_RootConstrainSelectedInstOperands,
     /*  494690 */     // GIR_Coverage, 4767,
     /*  494690 */     GIR_EraseRootFromParent_Done,
     /*  494691 */   // Label 8292: @494691
     /*  494691 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(494770), // Rule ID 4776 //
     /*  494696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  494707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  494710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  494713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  494716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494768 */     GIR_RootConstrainSelectedInstOperands,
     /*  494769 */     // GIR_Coverage, 4776,
     /*  494769 */     GIR_EraseRootFromParent_Done,
     /*  494770 */   // Label 8293: @494770
     /*  494770 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(494849), // Rule ID 4777 //
     /*  494775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  494786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  494789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  494792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  494795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494827 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494847 */     GIR_RootConstrainSelectedInstOperands,
     /*  494848 */     // GIR_Coverage, 4777,
     /*  494848 */     GIR_EraseRootFromParent_Done,
     /*  494849 */   // Label 8294: @494849
     /*  494849 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(494928), // Rule ID 4786 //
     /*  494854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  494865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  494868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  494871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  494874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494926 */     GIR_RootConstrainSelectedInstOperands,
     /*  494927 */     // GIR_Coverage, 4786,
     /*  494927 */     GIR_EraseRootFromParent_Done,
     /*  494928 */   // Label 8295: @494928
     /*  494928 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(495007), // Rule ID 4787 //
     /*  494933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  494944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  494947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  494950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  494953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494985 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495005 */     GIR_RootConstrainSelectedInstOperands,
     /*  495006 */     // GIR_Coverage, 4787,
     /*  495006 */     GIR_EraseRootFromParent_Done,
     /*  495007 */   // Label 8296: @495007
     /*  495007 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(495086), // Rule ID 4796 //
     /*  495012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  495023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  495026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  495029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  495032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  495067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495084 */     GIR_RootConstrainSelectedInstOperands,
     /*  495085 */     // GIR_Coverage, 4796,
     /*  495085 */     GIR_EraseRootFromParent_Done,
     /*  495086 */   // Label 8297: @495086
     /*  495086 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(495165), // Rule ID 4797 //
     /*  495091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  495102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  495105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  495108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  495111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495143 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  495146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495163 */     GIR_RootConstrainSelectedInstOperands,
     /*  495164 */     // GIR_Coverage, 4797,
     /*  495164 */     GIR_EraseRootFromParent_Done,
     /*  495165 */   // Label 8298: @495165
     /*  495165 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(495244), // Rule ID 4806 //
     /*  495170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  495181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  495184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  495187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  495190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495242 */     GIR_RootConstrainSelectedInstOperands,
     /*  495243 */     // GIR_Coverage, 4806,
     /*  495243 */     GIR_EraseRootFromParent_Done,
     /*  495244 */   // Label 8299: @495244
     /*  495244 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(495323), // Rule ID 4807 //
     /*  495249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  495260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  495263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  495266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  495269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495301 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  495304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495321 */     GIR_RootConstrainSelectedInstOperands,
     /*  495322 */     // GIR_Coverage, 4807,
     /*  495322 */     GIR_EraseRootFromParent_Done,
     /*  495323 */   // Label 8300: @495323
     /*  495323 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(495402), // Rule ID 4816 //
     /*  495328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  495339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  495342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  495345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  495348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495400 */     GIR_RootConstrainSelectedInstOperands,
     /*  495401 */     // GIR_Coverage, 4816,
     /*  495401 */     GIR_EraseRootFromParent_Done,
     /*  495402 */   // Label 8301: @495402
     /*  495402 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(495481), // Rule ID 4817 //
     /*  495407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  495418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  495421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  495424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  495427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  495450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495459 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  495462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495479 */     GIR_RootConstrainSelectedInstOperands,
     /*  495480 */     // GIR_Coverage, 4817,
     /*  495480 */     GIR_EraseRootFromParent_Done,
     /*  495481 */   // Label 8302: @495481
     /*  495481 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(495560), // Rule ID 4826 //
     /*  495486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  495489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  495497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  495500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  495503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  495506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495538 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495558 */     GIR_RootConstrainSelectedInstOperands,
     /*  495559 */     // GIR_Coverage, 4826,
     /*  495559 */     GIR_EraseRootFromParent_Done,
     /*  495560 */   // Label 8303: @495560
     /*  495560 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(495639), // Rule ID 4827 //
     /*  495565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  495576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  495579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  495582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  495585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495617 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495637 */     GIR_RootConstrainSelectedInstOperands,
     /*  495638 */     // GIR_Coverage, 4827,
     /*  495638 */     GIR_EraseRootFromParent_Done,
     /*  495639 */   // Label 8304: @495639
     /*  495639 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(495707), // Rule ID 2710 //
     /*  495644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  495655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  495658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495676 */     // MIs[0] policy
     /*  495676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495686 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  495689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495693 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495703 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495705 */     GIR_RootConstrainSelectedInstOperands,
     /*  495706 */     // GIR_Coverage, 2710,
     /*  495706 */     GIR_EraseRootFromParent_Done,
     /*  495707 */   // Label 8305: @495707
     /*  495707 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(495775), // Rule ID 2711 //
     /*  495712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  495723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  495726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495744 */     // MIs[0] policy
     /*  495744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495754 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  495757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495761 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495771 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495773 */     GIR_RootConstrainSelectedInstOperands,
     /*  495774 */     // GIR_Coverage, 2711,
     /*  495774 */     GIR_EraseRootFromParent_Done,
     /*  495775 */   // Label 8306: @495775
     /*  495775 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(495843), // Rule ID 23506 //
     /*  495780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  495791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  495794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  495797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495812 */     // MIs[0] policy
     /*  495812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495822 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  495825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495829 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495839 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495841 */     GIR_RootConstrainSelectedInstOperands,
     /*  495842 */     // GIR_Coverage, 23506,
     /*  495842 */     GIR_EraseRootFromParent_Done,
     /*  495843 */   // Label 8307: @495843
     /*  495843 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(495911), // Rule ID 23507 //
     /*  495848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  495859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  495862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  495865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495880 */     // MIs[0] policy
     /*  495880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495890 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  495893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495897 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495907 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495909 */     GIR_RootConstrainSelectedInstOperands,
     /*  495910 */     // GIR_Coverage, 23507,
     /*  495910 */     GIR_EraseRootFromParent_Done,
     /*  495911 */   // Label 8308: @495911
     /*  495911 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(495979), // Rule ID 23510 //
     /*  495916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  495927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  495930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  495933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495948 */     // MIs[0] policy
     /*  495948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495958 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  495961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495965 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495975 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495977 */     GIR_RootConstrainSelectedInstOperands,
     /*  495978 */     // GIR_Coverage, 23510,
     /*  495978 */     GIR_EraseRootFromParent_Done,
     /*  495979 */   // Label 8309: @495979
     /*  495979 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(496047), // Rule ID 23511 //
     /*  495984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  495995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  495998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496016 */     // MIs[0] policy
     /*  496016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496033 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496043 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496045 */     GIR_RootConstrainSelectedInstOperands,
     /*  496046 */     // GIR_Coverage, 23511,
     /*  496046 */     GIR_EraseRootFromParent_Done,
     /*  496047 */   // Label 8310: @496047
     /*  496047 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(496115), // Rule ID 23514 //
     /*  496052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496084 */     // MIs[0] policy
     /*  496084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496101 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496111 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496113 */     GIR_RootConstrainSelectedInstOperands,
     /*  496114 */     // GIR_Coverage, 23514,
     /*  496114 */     GIR_EraseRootFromParent_Done,
     /*  496115 */   // Label 8311: @496115
     /*  496115 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(496183), // Rule ID 23515 //
     /*  496120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  496131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  496134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496152 */     // MIs[0] policy
     /*  496152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496162 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  496165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496169 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496179 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496181 */     GIR_RootConstrainSelectedInstOperands,
     /*  496182 */     // GIR_Coverage, 23515,
     /*  496182 */     GIR_EraseRootFromParent_Done,
     /*  496183 */   // Label 8312: @496183
     /*  496183 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(496251), // Rule ID 23518 //
     /*  496188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  496199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  496202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496220 */     // MIs[0] policy
     /*  496220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496237 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496247 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496249 */     GIR_RootConstrainSelectedInstOperands,
     /*  496250 */     // GIR_Coverage, 23518,
     /*  496250 */     GIR_EraseRootFromParent_Done,
     /*  496251 */   // Label 8313: @496251
     /*  496251 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(496319), // Rule ID 23519 //
     /*  496256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  496267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  496270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496288 */     // MIs[0] policy
     /*  496288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496298 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496305 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496315 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496317 */     GIR_RootConstrainSelectedInstOperands,
     /*  496318 */     // GIR_Coverage, 23519,
     /*  496318 */     GIR_EraseRootFromParent_Done,
     /*  496319 */   // Label 8314: @496319
     /*  496319 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(496387), // Rule ID 23522 //
     /*  496324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  496335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  496338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496356 */     // MIs[0] policy
     /*  496356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496373 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496383 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496385 */     GIR_RootConstrainSelectedInstOperands,
     /*  496386 */     // GIR_Coverage, 23522,
     /*  496386 */     GIR_EraseRootFromParent_Done,
     /*  496387 */   // Label 8315: @496387
     /*  496387 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(496455), // Rule ID 23523 //
     /*  496392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  496403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  496406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496424 */     // MIs[0] policy
     /*  496424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496434 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  496437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496441 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496451 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496453 */     GIR_RootConstrainSelectedInstOperands,
     /*  496454 */     // GIR_Coverage, 23523,
     /*  496454 */     GIR_EraseRootFromParent_Done,
     /*  496455 */   // Label 8316: @496455
     /*  496455 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(496523), // Rule ID 23526 //
     /*  496460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  496471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  496474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  496477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496492 */     // MIs[0] policy
     /*  496492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496502 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11322:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496509 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496519 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496521 */     GIR_RootConstrainSelectedInstOperands,
     /*  496522 */     // GIR_Coverage, 23526,
     /*  496522 */     GIR_EraseRootFromParent_Done,
     /*  496523 */   // Label 8317: @496523
     /*  496523 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(496591), // Rule ID 23527 //
     /*  496528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  496539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  496542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  496545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496560 */     // MIs[0] policy
     /*  496560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11322:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496577 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496587 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496589 */     GIR_RootConstrainSelectedInstOperands,
     /*  496590 */     // GIR_Coverage, 23527,
     /*  496590 */     GIR_EraseRootFromParent_Done,
     /*  496591 */   // Label 8318: @496591
     /*  496591 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(496659), // Rule ID 23530 //
     /*  496596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  496607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  496610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496628 */     // MIs[0] policy
     /*  496628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496638 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496645 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496655 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496657 */     GIR_RootConstrainSelectedInstOperands,
     /*  496658 */     // GIR_Coverage, 23530,
     /*  496658 */     GIR_EraseRootFromParent_Done,
     /*  496659 */   // Label 8319: @496659
     /*  496659 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(496727), // Rule ID 23531 //
     /*  496664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  496675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  496678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496696 */     // MIs[0] policy
     /*  496696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11322:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496713 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496723 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496725 */     GIR_RootConstrainSelectedInstOperands,
     /*  496726 */     // GIR_Coverage, 23531,
     /*  496726 */     GIR_EraseRootFromParent_Done,
     /*  496727 */   // Label 8320: @496727
     /*  496727 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(496795), // Rule ID 23534 //
     /*  496732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  496743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  496746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496764 */     // MIs[0] policy
     /*  496764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496781 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496791 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496793 */     GIR_RootConstrainSelectedInstOperands,
     /*  496794 */     // GIR_Coverage, 23534,
     /*  496794 */     GIR_EraseRootFromParent_Done,
     /*  496795 */   // Label 8321: @496795
     /*  496795 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(496863), // Rule ID 23535 //
     /*  496800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  496811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  496814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496832 */     // MIs[0] policy
     /*  496832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11322:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496849 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496859 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496861 */     GIR_RootConstrainSelectedInstOperands,
     /*  496862 */     // GIR_Coverage, 23535,
     /*  496862 */     GIR_EraseRootFromParent_Done,
     /*  496863 */   // Label 8322: @496863
     /*  496863 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(496931), // Rule ID 23538 //
     /*  496868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  496871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496900 */     // MIs[0] policy
     /*  496900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496910 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496917 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  496927 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496929 */     GIR_RootConstrainSelectedInstOperands,
     /*  496930 */     // GIR_Coverage, 23538,
     /*  496930 */     GIR_EraseRootFromParent_Done,
     /*  496931 */   // Label 8323: @496931
     /*  496931 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(496999), // Rule ID 23539 //
     /*  496936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  496939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496968 */     // MIs[0] policy
     /*  496968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496978 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11322:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496985 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  496995 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496997 */     GIR_RootConstrainSelectedInstOperands,
     /*  496998 */     // GIR_Coverage, 23539,
     /*  496998 */     GIR_EraseRootFromParent_Done,
     /*  496999 */   // Label 8324: @496999
     /*  496999 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(497067), // Rule ID 23542 //
     /*  497004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  497015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  497018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497036 */     // MIs[0] policy
     /*  497036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497046 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497053 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497063 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497065 */     GIR_RootConstrainSelectedInstOperands,
     /*  497066 */     // GIR_Coverage, 23542,
     /*  497066 */     GIR_EraseRootFromParent_Done,
     /*  497067 */   // Label 8325: @497067
     /*  497067 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(497135), // Rule ID 23543 //
     /*  497072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  497083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  497086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497104 */     // MIs[0] policy
     /*  497104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497121 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497131 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497133 */     GIR_RootConstrainSelectedInstOperands,
     /*  497134 */     // GIR_Coverage, 23543,
     /*  497134 */     GIR_EraseRootFromParent_Done,
     /*  497135 */   // Label 8326: @497135
     /*  497135 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(497203), // Rule ID 23546 //
     /*  497140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  497151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  497154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497172 */     // MIs[0] policy
     /*  497172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497182 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497189 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497199 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497201 */     GIR_RootConstrainSelectedInstOperands,
     /*  497202 */     // GIR_Coverage, 23546,
     /*  497202 */     GIR_EraseRootFromParent_Done,
     /*  497203 */   // Label 8327: @497203
     /*  497203 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(497271), // Rule ID 23547 //
     /*  497208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  497219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  497222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497240 */     // MIs[0] policy
     /*  497240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497250 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497257 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497267 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497269 */     GIR_RootConstrainSelectedInstOperands,
     /*  497270 */     // GIR_Coverage, 23547,
     /*  497270 */     GIR_EraseRootFromParent_Done,
     /*  497271 */   // Label 8328: @497271
     /*  497271 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(497339), // Rule ID 23550 //
     /*  497276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  497287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  497290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  497293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497308 */     // MIs[0] policy
     /*  497308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497318 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497325 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497335 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497337 */     GIR_RootConstrainSelectedInstOperands,
     /*  497338 */     // GIR_Coverage, 23550,
     /*  497338 */     GIR_EraseRootFromParent_Done,
     /*  497339 */   // Label 8329: @497339
     /*  497339 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(497407), // Rule ID 23551 //
     /*  497344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  497355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  497358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  497361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497376 */     // MIs[0] policy
     /*  497376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497393 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  497403 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497405 */     GIR_RootConstrainSelectedInstOperands,
     /*  497406 */     // GIR_Coverage, 23551,
     /*  497406 */     GIR_EraseRootFromParent_Done,
     /*  497407 */   // Label 8330: @497407
     /*  497407 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(497475), // Rule ID 23554 //
     /*  497412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497444 */     // MIs[0] policy
     /*  497444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497454 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497461 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497471 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497473 */     GIR_RootConstrainSelectedInstOperands,
     /*  497474 */     // GIR_Coverage, 23554,
     /*  497474 */     GIR_EraseRootFromParent_Done,
     /*  497475 */   // Label 8331: @497475
     /*  497475 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(497543), // Rule ID 23555 //
     /*  497480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  497491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  497494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497512 */     // MIs[0] policy
     /*  497512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497529 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497539 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497541 */     GIR_RootConstrainSelectedInstOperands,
     /*  497542 */     // GIR_Coverage, 23555,
     /*  497542 */     GIR_EraseRootFromParent_Done,
     /*  497543 */   // Label 8332: @497543
     /*  497543 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(497611), // Rule ID 23558 //
     /*  497548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497580 */     // MIs[0] policy
     /*  497580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497597 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497607 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497609 */     GIR_RootConstrainSelectedInstOperands,
     /*  497610 */     // GIR_Coverage, 23558,
     /*  497610 */     GIR_EraseRootFromParent_Done,
     /*  497611 */   // Label 8333: @497611
     /*  497611 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(497679), // Rule ID 23559 //
     /*  497616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497648 */     // MIs[0] policy
     /*  497648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497665 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497675 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497677 */     GIR_RootConstrainSelectedInstOperands,
     /*  497678 */     // GIR_Coverage, 23559,
     /*  497678 */     GIR_EraseRootFromParent_Done,
     /*  497679 */   // Label 8334: @497679
     /*  497679 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(497747), // Rule ID 23562 //
     /*  497684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497716 */     // MIs[0] policy
     /*  497716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497726 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497733 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497743 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497745 */     GIR_RootConstrainSelectedInstOperands,
     /*  497746 */     // GIR_Coverage, 23562,
     /*  497746 */     GIR_EraseRootFromParent_Done,
     /*  497747 */   // Label 8335: @497747
     /*  497747 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(497815), // Rule ID 23563 //
     /*  497752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497784 */     // MIs[0] policy
     /*  497784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497801 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497811 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497813 */     GIR_RootConstrainSelectedInstOperands,
     /*  497814 */     // GIR_Coverage, 23563,
     /*  497814 */     GIR_EraseRootFromParent_Done,
     /*  497815 */   // Label 8336: @497815
     /*  497815 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(497883), // Rule ID 23566 //
     /*  497820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  497831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  497834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497852 */     // MIs[0] policy
     /*  497852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497869 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497879 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497881 */     GIR_RootConstrainSelectedInstOperands,
     /*  497882 */     // GIR_Coverage, 23566,
     /*  497882 */     GIR_EraseRootFromParent_Done,
     /*  497883 */   // Label 8337: @497883
     /*  497883 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(497951), // Rule ID 23567 //
     /*  497888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  497899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  497902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497920 */     // MIs[0] policy
     /*  497920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497937 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497947 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497949 */     GIR_RootConstrainSelectedInstOperands,
     /*  497950 */     // GIR_Coverage, 23567,
     /*  497950 */     GIR_EraseRootFromParent_Done,
     /*  497951 */   // Label 8338: @497951
     /*  497951 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(498019), // Rule ID 23570 //
     /*  497956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  497967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  497970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497988 */     // MIs[0] policy
     /*  497988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498005 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498015 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498017 */     GIR_RootConstrainSelectedInstOperands,
     /*  498018 */     // GIR_Coverage, 23570,
     /*  498018 */     GIR_EraseRootFromParent_Done,
     /*  498019 */   // Label 8339: @498019
     /*  498019 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(498087), // Rule ID 23571 //
     /*  498024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498056 */     // MIs[0] policy
     /*  498056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498073 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498083 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498085 */     GIR_RootConstrainSelectedInstOperands,
     /*  498086 */     // GIR_Coverage, 23571,
     /*  498086 */     GIR_EraseRootFromParent_Done,
     /*  498087 */   // Label 8340: @498087
     /*  498087 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(498155), // Rule ID 23574 //
     /*  498092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  498095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498124 */     // MIs[0] policy
     /*  498124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498141 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498151 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498153 */     GIR_RootConstrainSelectedInstOperands,
     /*  498154 */     // GIR_Coverage, 23574,
     /*  498154 */     GIR_EraseRootFromParent_Done,
     /*  498155 */   // Label 8341: @498155
     /*  498155 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(498223), // Rule ID 23575 //
     /*  498160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  498163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  498177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498192 */     // MIs[0] policy
     /*  498192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498202 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498209 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498219 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498221 */     GIR_RootConstrainSelectedInstOperands,
     /*  498222 */     // GIR_Coverage, 23575,
     /*  498222 */     GIR_EraseRootFromParent_Done,
     /*  498223 */   // Label 8342: @498223
     /*  498223 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(498291), // Rule ID 23578 //
     /*  498228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  498245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498260 */     // MIs[0] policy
     /*  498260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498277 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498287 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498289 */     GIR_RootConstrainSelectedInstOperands,
     /*  498290 */     // GIR_Coverage, 23578,
     /*  498290 */     GIR_EraseRootFromParent_Done,
     /*  498291 */   // Label 8343: @498291
     /*  498291 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(498359), // Rule ID 23579 //
     /*  498296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  498307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  498310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  498313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  498320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498328 */     // MIs[0] policy
     /*  498328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11322:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  498341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498345 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498355 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498357 */     GIR_RootConstrainSelectedInstOperands,
     /*  498358 */     // GIR_Coverage, 23579,
     /*  498358 */     GIR_EraseRootFromParent_Done,
     /*  498359 */   // Label 8344: @498359
     /*  498359 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(498427), // Rule ID 23582 //
     /*  498364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498396 */     // MIs[0] policy
     /*  498396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498413 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498423 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498425 */     GIR_RootConstrainSelectedInstOperands,
     /*  498426 */     // GIR_Coverage, 23582,
     /*  498426 */     GIR_EraseRootFromParent_Done,
     /*  498427 */   // Label 8345: @498427
     /*  498427 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(498495), // Rule ID 23583 //
     /*  498432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  498443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  498446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  498449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  498456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498464 */     // MIs[0] policy
     /*  498464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11322:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  498477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498481 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498491 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498493 */     GIR_RootConstrainSelectedInstOperands,
     /*  498494 */     // GIR_Coverage, 23583,
     /*  498494 */     GIR_EraseRootFromParent_Done,
     /*  498495 */   // Label 8346: @498495
     /*  498495 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(498563), // Rule ID 23586 //
     /*  498500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  498503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  498511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  498514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498532 */     // MIs[0] policy
     /*  498532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498549 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498559 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498561 */     GIR_RootConstrainSelectedInstOperands,
     /*  498562 */     // GIR_Coverage, 23586,
     /*  498562 */     GIR_EraseRootFromParent_Done,
     /*  498563 */   // Label 8347: @498563
     /*  498563 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(498631), // Rule ID 23587 //
     /*  498568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  498579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  498582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498600 */     // MIs[0] policy
     /*  498600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498610 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11322:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498617 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498627 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498629 */     GIR_RootConstrainSelectedInstOperands,
     /*  498630 */     // GIR_Coverage, 23587,
     /*  498630 */     GIR_EraseRootFromParent_Done,
     /*  498631 */   // Label 8348: @498631
     /*  498631 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(498699), // Rule ID 60600 //
     /*  498636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  498639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498668 */     // MIs[0] policy
     /*  498668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  498681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498695 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498697 */     GIR_RootConstrainSelectedInstOperands,
     /*  498698 */     // GIR_Coverage, 60600,
     /*  498698 */     GIR_EraseRootFromParent_Done,
     /*  498699 */   // Label 8349: @498699
     /*  498699 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(498767), // Rule ID 60601 //
     /*  498704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  498707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498736 */     // MIs[0] policy
     /*  498736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  498749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498763 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498765 */     GIR_RootConstrainSelectedInstOperands,
     /*  498766 */     // GIR_Coverage, 60601,
     /*  498766 */     GIR_EraseRootFromParent_Done,
     /*  498767 */   // Label 8350: @498767
     /*  498767 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(498835), // Rule ID 60602 //
     /*  498772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  498775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  498780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498804 */     // MIs[0] policy
     /*  498804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  498817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498831 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498833 */     GIR_RootConstrainSelectedInstOperands,
     /*  498834 */     // GIR_Coverage, 60602,
     /*  498834 */     GIR_EraseRootFromParent_Done,
     /*  498835 */   // Label 8351: @498835
     /*  498835 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(498903), // Rule ID 60603 //
     /*  498840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  498843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  498848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498872 */     // MIs[0] policy
     /*  498872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  498885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498899 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498901 */     GIR_RootConstrainSelectedInstOperands,
     /*  498902 */     // GIR_Coverage, 60603,
     /*  498902 */     GIR_EraseRootFromParent_Done,
     /*  498903 */   // Label 8352: @498903
     /*  498903 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(498971), // Rule ID 62096 //
     /*  498908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  498911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  498922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  498925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498940 */     // MIs[0] policy
     /*  498940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  498953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498967 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498969 */     GIR_RootConstrainSelectedInstOperands,
     /*  498970 */     // GIR_Coverage, 62096,
     /*  498970 */     GIR_EraseRootFromParent_Done,
     /*  498971 */   // Label 8353: @498971
     /*  498971 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(499039), // Rule ID 62097 //
     /*  498976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  498979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  498990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  498993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499008 */     // MIs[0] policy
     /*  499008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11320:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  499021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499035 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499037 */     GIR_RootConstrainSelectedInstOperands,
     /*  499038 */     // GIR_Coverage, 62097,
     /*  499038 */     GIR_EraseRootFromParent_Done,
     /*  499039 */   // Label 8354: @499039
     /*  499039 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(499107), // Rule ID 62098 //
     /*  499044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499076 */     // MIs[0] policy
     /*  499076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  499089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499103 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499105 */     GIR_RootConstrainSelectedInstOperands,
     /*  499106 */     // GIR_Coverage, 62098,
     /*  499106 */     GIR_EraseRootFromParent_Done,
     /*  499107 */   // Label 8355: @499107
     /*  499107 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(499175), // Rule ID 62099 //
     /*  499112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499144 */     // MIs[0] policy
     /*  499144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499154 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11320:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  499157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499171 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499173 */     GIR_RootConstrainSelectedInstOperands,
     /*  499174 */     // GIR_Coverage, 62099,
     /*  499174 */     GIR_EraseRootFromParent_Done,
     /*  499175 */   // Label 8356: @499175
     /*  499175 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(499243), // Rule ID 62100 //
     /*  499180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499212 */     // MIs[0] policy
     /*  499212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  499225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499239 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499241 */     GIR_RootConstrainSelectedInstOperands,
     /*  499242 */     // GIR_Coverage, 62100,
     /*  499242 */     GIR_EraseRootFromParent_Done,
     /*  499243 */   // Label 8357: @499243
     /*  499243 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(499311), // Rule ID 62101 //
     /*  499248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499280 */     // MIs[0] policy
     /*  499280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11320:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  499293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499307 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499309 */     GIR_RootConstrainSelectedInstOperands,
     /*  499310 */     // GIR_Coverage, 62101,
     /*  499310 */     GIR_EraseRootFromParent_Done,
     /*  499311 */   // Label 8358: @499311
     /*  499311 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(499379), // Rule ID 62102 //
     /*  499316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  499319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499348 */     // MIs[0] policy
     /*  499348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  499361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499375 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499377 */     GIR_RootConstrainSelectedInstOperands,
     /*  499378 */     // GIR_Coverage, 62102,
     /*  499378 */     GIR_EraseRootFromParent_Done,
     /*  499379 */   // Label 8359: @499379
     /*  499379 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(499447), // Rule ID 62103 //
     /*  499384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  499387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  499392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499416 */     // MIs[0] policy
     /*  499416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11320:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  499429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499443 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499445 */     GIR_RootConstrainSelectedInstOperands,
     /*  499446 */     // GIR_Coverage, 62103,
     /*  499446 */     GIR_EraseRootFromParent_Done,
     /*  499447 */   // Label 8360: @499447
     /*  499447 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(499515), // Rule ID 62104 //
     /*  499452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499484 */     // MIs[0] policy
     /*  499484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  499497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499511 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499513 */     GIR_RootConstrainSelectedInstOperands,
     /*  499514 */     // GIR_Coverage, 62104,
     /*  499514 */     GIR_EraseRootFromParent_Done,
     /*  499515 */   // Label 8361: @499515
     /*  499515 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(499583), // Rule ID 62105 //
     /*  499520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499552 */     // MIs[0] policy
     /*  499552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499562 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  499565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499579 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499581 */     GIR_RootConstrainSelectedInstOperands,
     /*  499582 */     // GIR_Coverage, 62105,
     /*  499582 */     GIR_EraseRootFromParent_Done,
     /*  499583 */   // Label 8362: @499583
     /*  499583 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(499651), // Rule ID 62106 //
     /*  499588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499620 */     // MIs[0] policy
     /*  499620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  499633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499647 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499649 */     GIR_RootConstrainSelectedInstOperands,
     /*  499650 */     // GIR_Coverage, 62106,
     /*  499650 */     GIR_EraseRootFromParent_Done,
     /*  499651 */   // Label 8363: @499651
     /*  499651 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(499719), // Rule ID 62107 //
     /*  499656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499688 */     // MIs[0] policy
     /*  499688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  499701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499715 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499717 */     GIR_RootConstrainSelectedInstOperands,
     /*  499718 */     // GIR_Coverage, 62107,
     /*  499718 */     GIR_EraseRootFromParent_Done,
     /*  499719 */   // Label 8364: @499719
     /*  499719 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(499787), // Rule ID 62108 //
     /*  499724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499756 */     // MIs[0] policy
     /*  499756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  499769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499783 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499785 */     GIR_RootConstrainSelectedInstOperands,
     /*  499786 */     // GIR_Coverage, 62108,
     /*  499786 */     GIR_EraseRootFromParent_Done,
     /*  499787 */   // Label 8365: @499787
     /*  499787 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(499855), // Rule ID 62109 //
     /*  499792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499824 */     // MIs[0] policy
     /*  499824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  499837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499851 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499853 */     GIR_RootConstrainSelectedInstOperands,
     /*  499854 */     // GIR_Coverage, 62109,
     /*  499854 */     GIR_EraseRootFromParent_Done,
     /*  499855 */   // Label 8366: @499855
     /*  499855 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(499923), // Rule ID 62110 //
     /*  499860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499892 */     // MIs[0] policy
     /*  499892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  499905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499919 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499921 */     GIR_RootConstrainSelectedInstOperands,
     /*  499922 */     // GIR_Coverage, 62110,
     /*  499922 */     GIR_EraseRootFromParent_Done,
     /*  499923 */   // Label 8367: @499923
     /*  499923 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(499991), // Rule ID 62111 //
     /*  499928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499960 */     // MIs[0] policy
     /*  499960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  499973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499987 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499989 */     GIR_RootConstrainSelectedInstOperands,
     /*  499990 */     // GIR_Coverage, 62111,
     /*  499990 */     GIR_EraseRootFromParent_Done,
     /*  499991 */   // Label 8368: @499991
     /*  499991 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(500059), // Rule ID 62112 //
     /*  499996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500028 */     // MIs[0] policy
     /*  500028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  500041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500055 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500057 */     GIR_RootConstrainSelectedInstOperands,
     /*  500058 */     // GIR_Coverage, 62112,
     /*  500058 */     GIR_EraseRootFromParent_Done,
     /*  500059 */   // Label 8369: @500059
     /*  500059 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(500127), // Rule ID 62113 //
     /*  500064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  500072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  500081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500096 */     // MIs[0] policy
     /*  500096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  500109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500123 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500125 */     GIR_RootConstrainSelectedInstOperands,
     /*  500126 */     // GIR_Coverage, 62113,
     /*  500126 */     GIR_EraseRootFromParent_Done,
     /*  500127 */   // Label 8370: @500127
     /*  500127 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(500195), // Rule ID 62114 //
     /*  500132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500164 */     // MIs[0] policy
     /*  500164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500174 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  500177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500191 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500193 */     GIR_RootConstrainSelectedInstOperands,
     /*  500194 */     // GIR_Coverage, 62114,
     /*  500194 */     GIR_EraseRootFromParent_Done,
     /*  500195 */   // Label 8371: @500195
     /*  500195 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(500263), // Rule ID 62115 //
     /*  500200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500232 */     // MIs[0] policy
     /*  500232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500242 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  500245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500259 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500261 */     GIR_RootConstrainSelectedInstOperands,
     /*  500262 */     // GIR_Coverage, 62115,
     /*  500262 */     GIR_EraseRootFromParent_Done,
     /*  500263 */   // Label 8372: @500263
     /*  500263 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(500331), // Rule ID 62116 //
     /*  500268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500300 */     // MIs[0] policy
     /*  500300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500310 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  500313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500327 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500329 */     GIR_RootConstrainSelectedInstOperands,
     /*  500330 */     // GIR_Coverage, 62116,
     /*  500330 */     GIR_EraseRootFromParent_Done,
     /*  500331 */   // Label 8373: @500331
     /*  500331 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(500399), // Rule ID 62117 //
     /*  500336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  500347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  500350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500368 */     // MIs[0] policy
     /*  500368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500378 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  500381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500395 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500397 */     GIR_RootConstrainSelectedInstOperands,
     /*  500398 */     // GIR_Coverage, 62117,
     /*  500398 */     GIR_EraseRootFromParent_Done,
     /*  500399 */   // Label 8374: @500399
     /*  500399 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(500467), // Rule ID 62118 //
     /*  500404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500436 */     // MIs[0] policy
     /*  500436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  500449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500463 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500465 */     GIR_RootConstrainSelectedInstOperands,
     /*  500466 */     // GIR_Coverage, 62118,
     /*  500466 */     GIR_EraseRootFromParent_Done,
     /*  500467 */   // Label 8375: @500467
     /*  500467 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(500535), // Rule ID 62119 //
     /*  500472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500504 */     // MIs[0] policy
     /*  500504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  500517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500531 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500533 */     GIR_RootConstrainSelectedInstOperands,
     /*  500534 */     // GIR_Coverage, 62119,
     /*  500534 */     GIR_EraseRootFromParent_Done,
     /*  500535 */   // Label 8376: @500535
     /*  500535 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(500603), // Rule ID 62120 //
     /*  500540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500572 */     // MIs[0] policy
     /*  500572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  500585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500599 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500601 */     GIR_RootConstrainSelectedInstOperands,
     /*  500602 */     // GIR_Coverage, 62120,
     /*  500602 */     GIR_EraseRootFromParent_Done,
     /*  500603 */   // Label 8377: @500603
     /*  500603 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(500671), // Rule ID 62121 //
     /*  500608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500640 */     // MIs[0] policy
     /*  500640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  500653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500667 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500669 */     GIR_RootConstrainSelectedInstOperands,
     /*  500670 */     // GIR_Coverage, 62121,
     /*  500670 */     GIR_EraseRootFromParent_Done,
     /*  500671 */   // Label 8378: @500671
     /*  500671 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(500739), // Rule ID 62122 //
     /*  500676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500708 */     // MIs[0] policy
     /*  500708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  500721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500735 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500737 */     GIR_RootConstrainSelectedInstOperands,
     /*  500738 */     // GIR_Coverage, 62122,
     /*  500738 */     GIR_EraseRootFromParent_Done,
     /*  500739 */   // Label 8379: @500739
     /*  500739 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(500807), // Rule ID 62123 //
     /*  500744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500776 */     // MIs[0] policy
     /*  500776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  500789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500803 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500805 */     GIR_RootConstrainSelectedInstOperands,
     /*  500806 */     // GIR_Coverage, 62123,
     /*  500806 */     GIR_EraseRootFromParent_Done,
     /*  500807 */   // Label 8380: @500807
     /*  500807 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(500875), // Rule ID 62124 //
     /*  500812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500844 */     // MIs[0] policy
     /*  500844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  500857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500871 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500873 */     GIR_RootConstrainSelectedInstOperands,
     /*  500874 */     // GIR_Coverage, 62124,
     /*  500874 */     GIR_EraseRootFromParent_Done,
     /*  500875 */   // Label 8381: @500875
     /*  500875 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(500943), // Rule ID 62125 //
     /*  500880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500912 */     // MIs[0] policy
     /*  500912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  500925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500939 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500941 */     GIR_RootConstrainSelectedInstOperands,
     /*  500942 */     // GIR_Coverage, 62125,
     /*  500942 */     GIR_EraseRootFromParent_Done,
     /*  500943 */   // Label 8382: @500943
     /*  500943 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(501011), // Rule ID 62126 //
     /*  500948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500980 */     // MIs[0] policy
     /*  500980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  500993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501007 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501009 */     GIR_RootConstrainSelectedInstOperands,
     /*  501010 */     // GIR_Coverage, 62126,
     /*  501010 */     GIR_EraseRootFromParent_Done,
     /*  501011 */   // Label 8383: @501011
     /*  501011 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(501079), // Rule ID 62127 //
     /*  501016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501048 */     // MIs[0] policy
     /*  501048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501058 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  501061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501075 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501077 */     GIR_RootConstrainSelectedInstOperands,
     /*  501078 */     // GIR_Coverage, 62127,
     /*  501078 */     GIR_EraseRootFromParent_Done,
     /*  501079 */   // Label 8384: @501079
     /*  501079 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(501147), // Rule ID 62128 //
     /*  501084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501116 */     // MIs[0] policy
     /*  501116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  501129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501143 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501145 */     GIR_RootConstrainSelectedInstOperands,
     /*  501146 */     // GIR_Coverage, 62128,
     /*  501146 */     GIR_EraseRootFromParent_Done,
     /*  501147 */   // Label 8385: @501147
     /*  501147 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(501215), // Rule ID 62129 //
     /*  501152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501184 */     // MIs[0] policy
     /*  501184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  501197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501211 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501213 */     GIR_RootConstrainSelectedInstOperands,
     /*  501214 */     // GIR_Coverage, 62129,
     /*  501214 */     GIR_EraseRootFromParent_Done,
     /*  501215 */   // Label 8386: @501215
     /*  501215 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(501283), // Rule ID 62130 //
     /*  501220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501252 */     // MIs[0] policy
     /*  501252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501262 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  501265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501279 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501281 */     GIR_RootConstrainSelectedInstOperands,
     /*  501282 */     // GIR_Coverage, 62130,
     /*  501282 */     GIR_EraseRootFromParent_Done,
     /*  501283 */   // Label 8387: @501283
     /*  501283 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(501351), // Rule ID 62131 //
     /*  501288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501320 */     // MIs[0] policy
     /*  501320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501330 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  501333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501347 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501349 */     GIR_RootConstrainSelectedInstOperands,
     /*  501350 */     // GIR_Coverage, 62131,
     /*  501350 */     GIR_EraseRootFromParent_Done,
     /*  501351 */   // Label 8388: @501351
     /*  501351 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(501419), // Rule ID 62132 //
     /*  501356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501388 */     // MIs[0] policy
     /*  501388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  501401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501415 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501417 */     GIR_RootConstrainSelectedInstOperands,
     /*  501418 */     // GIR_Coverage, 62132,
     /*  501418 */     GIR_EraseRootFromParent_Done,
     /*  501419 */   // Label 8389: @501419
     /*  501419 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(501487), // Rule ID 62133 //
     /*  501424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501456 */     // MIs[0] policy
     /*  501456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501466 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  501469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501483 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501485 */     GIR_RootConstrainSelectedInstOperands,
     /*  501486 */     // GIR_Coverage, 62133,
     /*  501486 */     GIR_EraseRootFromParent_Done,
     /*  501487 */   // Label 8390: @501487
     /*  501487 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(501555), // Rule ID 62134 //
     /*  501492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501524 */     // MIs[0] policy
     /*  501524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  501537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501551 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501553 */     GIR_RootConstrainSelectedInstOperands,
     /*  501554 */     // GIR_Coverage, 62134,
     /*  501554 */     GIR_EraseRootFromParent_Done,
     /*  501555 */   // Label 8391: @501555
     /*  501555 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(501623), // Rule ID 62135 //
     /*  501560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501592 */     // MIs[0] policy
     /*  501592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  501605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501619 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501621 */     GIR_RootConstrainSelectedInstOperands,
     /*  501622 */     // GIR_Coverage, 62135,
     /*  501622 */     GIR_EraseRootFromParent_Done,
     /*  501623 */   // Label 8392: @501623
     /*  501623 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(501691), // Rule ID 62136 //
     /*  501628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501660 */     // MIs[0] policy
     /*  501660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501670 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  501673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501687 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501689 */     GIR_RootConstrainSelectedInstOperands,
     /*  501690 */     // GIR_Coverage, 62136,
     /*  501690 */     GIR_EraseRootFromParent_Done,
     /*  501691 */   // Label 8393: @501691
     /*  501691 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(501759), // Rule ID 62137 //
     /*  501696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501728 */     // MIs[0] policy
     /*  501728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501738 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  501741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501755 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501757 */     GIR_RootConstrainSelectedInstOperands,
     /*  501758 */     // GIR_Coverage, 62137,
     /*  501758 */     GIR_EraseRootFromParent_Done,
     /*  501759 */   // Label 8394: @501759
     /*  501759 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(501827), // Rule ID 62138 //
     /*  501764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501796 */     // MIs[0] policy
     /*  501796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501806 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  501809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501823 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501825 */     GIR_RootConstrainSelectedInstOperands,
     /*  501826 */     // GIR_Coverage, 62138,
     /*  501826 */     GIR_EraseRootFromParent_Done,
     /*  501827 */   // Label 8395: @501827
     /*  501827 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(501895), // Rule ID 62139 //
     /*  501832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501864 */     // MIs[0] policy
     /*  501864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501874 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  501877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501891 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501893 */     GIR_RootConstrainSelectedInstOperands,
     /*  501894 */     // GIR_Coverage, 62139,
     /*  501894 */     GIR_EraseRootFromParent_Done,
     /*  501895 */   // Label 8396: @501895
     /*  501895 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(501963), // Rule ID 62140 //
     /*  501900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  501911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  501914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501932 */     // MIs[0] policy
     /*  501932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  501945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501959 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501961 */     GIR_RootConstrainSelectedInstOperands,
     /*  501962 */     // GIR_Coverage, 62140,
     /*  501962 */     GIR_EraseRootFromParent_Done,
     /*  501963 */   // Label 8397: @501963
     /*  501963 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(502031), // Rule ID 62141 //
     /*  501968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  501979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  501982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502000 */     // MIs[0] policy
     /*  502000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502010 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  502013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502027 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502029 */     GIR_RootConstrainSelectedInstOperands,
     /*  502030 */     // GIR_Coverage, 62141,
     /*  502030 */     GIR_EraseRootFromParent_Done,
     /*  502031 */   // Label 8398: @502031
     /*  502031 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(502099), // Rule ID 62142 //
     /*  502036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502068 */     // MIs[0] policy
     /*  502068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  502081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502095 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502097 */     GIR_RootConstrainSelectedInstOperands,
     /*  502098 */     // GIR_Coverage, 62142,
     /*  502098 */     GIR_EraseRootFromParent_Done,
     /*  502099 */   // Label 8399: @502099
     /*  502099 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(502167), // Rule ID 62143 //
     /*  502104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502136 */     // MIs[0] policy
     /*  502136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  502149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502163 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502165 */     GIR_RootConstrainSelectedInstOperands,
     /*  502166 */     // GIR_Coverage, 62143,
     /*  502166 */     GIR_EraseRootFromParent_Done,
     /*  502167 */   // Label 8400: @502167
     /*  502167 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(502235), // Rule ID 62144 //
     /*  502172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502204 */     // MIs[0] policy
     /*  502204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  502217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502231 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502233 */     GIR_RootConstrainSelectedInstOperands,
     /*  502234 */     // GIR_Coverage, 62144,
     /*  502234 */     GIR_EraseRootFromParent_Done,
     /*  502235 */   // Label 8401: @502235
     /*  502235 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(502303), // Rule ID 62145 //
     /*  502240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502272 */     // MIs[0] policy
     /*  502272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  502285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502299 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502301 */     GIR_RootConstrainSelectedInstOperands,
     /*  502302 */     // GIR_Coverage, 62145,
     /*  502302 */     GIR_EraseRootFromParent_Done,
     /*  502303 */   // Label 8402: @502303
     /*  502303 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(502371), // Rule ID 62146 //
     /*  502308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502340 */     // MIs[0] policy
     /*  502340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502350 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  502353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502367 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502369 */     GIR_RootConstrainSelectedInstOperands,
     /*  502370 */     // GIR_Coverage, 62146,
     /*  502370 */     GIR_EraseRootFromParent_Done,
     /*  502371 */   // Label 8403: @502371
     /*  502371 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(502439), // Rule ID 62147 //
     /*  502376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  502393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502408 */     // MIs[0] policy
     /*  502408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502418 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  502421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502435 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502437 */     GIR_RootConstrainSelectedInstOperands,
     /*  502438 */     // GIR_Coverage, 62147,
     /*  502438 */     GIR_EraseRootFromParent_Done,
     /*  502439 */   // Label 8404: @502439
     /*  502439 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(502507), // Rule ID 62148 //
     /*  502444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502476 */     // MIs[0] policy
     /*  502476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  502489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502503 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502505 */     GIR_RootConstrainSelectedInstOperands,
     /*  502506 */     // GIR_Coverage, 62148,
     /*  502506 */     GIR_EraseRootFromParent_Done,
     /*  502507 */   // Label 8405: @502507
     /*  502507 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(502575), // Rule ID 62149 //
     /*  502512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502544 */     // MIs[0] policy
     /*  502544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502554 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  502557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502571 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502573 */     GIR_RootConstrainSelectedInstOperands,
     /*  502574 */     // GIR_Coverage, 62149,
     /*  502574 */     GIR_EraseRootFromParent_Done,
     /*  502575 */   // Label 8406: @502575
     /*  502575 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(502643), // Rule ID 62150 //
     /*  502580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502612 */     // MIs[0] policy
     /*  502612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  502625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502639 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502641 */     GIR_RootConstrainSelectedInstOperands,
     /*  502642 */     // GIR_Coverage, 62150,
     /*  502642 */     GIR_EraseRootFromParent_Done,
     /*  502643 */   // Label 8407: @502643
     /*  502643 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(502711), // Rule ID 62151 //
     /*  502648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502680 */     // MIs[0] policy
     /*  502680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  502693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502707 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502709 */     GIR_RootConstrainSelectedInstOperands,
     /*  502710 */     // GIR_Coverage, 62151,
     /*  502710 */     GIR_EraseRootFromParent_Done,
     /*  502711 */   // Label 8408: @502711
     /*  502711 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(502779), // Rule ID 62152 //
     /*  502716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502748 */     // MIs[0] policy
     /*  502748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  502761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502775 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502777 */     GIR_RootConstrainSelectedInstOperands,
     /*  502778 */     // GIR_Coverage, 62152,
     /*  502778 */     GIR_EraseRootFromParent_Done,
     /*  502779 */   // Label 8409: @502779
     /*  502779 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(502847), // Rule ID 62153 //
     /*  502784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502816 */     // MIs[0] policy
     /*  502816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  502829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502843 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502845 */     GIR_RootConstrainSelectedInstOperands,
     /*  502846 */     // GIR_Coverage, 62153,
     /*  502846 */     GIR_EraseRootFromParent_Done,
     /*  502847 */   // Label 8410: @502847
     /*  502847 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(502915), // Rule ID 62154 //
     /*  502852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502884 */     // MIs[0] policy
     /*  502884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  502897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502911 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502913 */     GIR_RootConstrainSelectedInstOperands,
     /*  502914 */     // GIR_Coverage, 62154,
     /*  502914 */     GIR_EraseRootFromParent_Done,
     /*  502915 */   // Label 8411: @502915
     /*  502915 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(502983), // Rule ID 62155 //
     /*  502920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502952 */     // MIs[0] policy
     /*  502952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  502965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502979 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502981 */     GIR_RootConstrainSelectedInstOperands,
     /*  502982 */     // GIR_Coverage, 62155,
     /*  502982 */     GIR_EraseRootFromParent_Done,
     /*  502983 */   // Label 8412: @502983
     /*  502983 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(503051), // Rule ID 62156 //
     /*  502988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503020 */     // MIs[0] policy
     /*  503020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503030 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  503033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503047 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503049 */     GIR_RootConstrainSelectedInstOperands,
     /*  503050 */     // GIR_Coverage, 62156,
     /*  503050 */     GIR_EraseRootFromParent_Done,
     /*  503051 */   // Label 8413: @503051
     /*  503051 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(503119), // Rule ID 62157 //
     /*  503056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503088 */     // MIs[0] policy
     /*  503088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503098 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  503101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503115 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503117 */     GIR_RootConstrainSelectedInstOperands,
     /*  503118 */     // GIR_Coverage, 62157,
     /*  503118 */     GIR_EraseRootFromParent_Done,
     /*  503119 */   // Label 8414: @503119
     /*  503119 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(503187), // Rule ID 62158 //
     /*  503124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503156 */     // MIs[0] policy
     /*  503156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  503169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503183 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503185 */     GIR_RootConstrainSelectedInstOperands,
     /*  503186 */     // GIR_Coverage, 62158,
     /*  503186 */     GIR_EraseRootFromParent_Done,
     /*  503187 */   // Label 8415: @503187
     /*  503187 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(503255), // Rule ID 62159 //
     /*  503192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503224 */     // MIs[0] policy
     /*  503224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  503237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503251 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503253 */     GIR_RootConstrainSelectedInstOperands,
     /*  503254 */     // GIR_Coverage, 62159,
     /*  503254 */     GIR_EraseRootFromParent_Done,
     /*  503255 */   // Label 8416: @503255
     /*  503255 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(503323), // Rule ID 62160 //
     /*  503260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503292 */     // MIs[0] policy
     /*  503292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  503305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503319 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503321 */     GIR_RootConstrainSelectedInstOperands,
     /*  503322 */     // GIR_Coverage, 62160,
     /*  503322 */     GIR_EraseRootFromParent_Done,
     /*  503323 */   // Label 8417: @503323
     /*  503323 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(503391), // Rule ID 62161 //
     /*  503328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  503339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  503342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503360 */     // MIs[0] policy
     /*  503360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  503373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503387 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503389 */     GIR_RootConstrainSelectedInstOperands,
     /*  503390 */     // GIR_Coverage, 62161,
     /*  503390 */     GIR_EraseRootFromParent_Done,
     /*  503391 */   // Label 8418: @503391
     /*  503391 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(503459), // Rule ID 62162 //
     /*  503396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503428 */     // MIs[0] policy
     /*  503428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503438 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  503441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503455 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503457 */     GIR_RootConstrainSelectedInstOperands,
     /*  503458 */     // GIR_Coverage, 62162,
     /*  503458 */     GIR_EraseRootFromParent_Done,
     /*  503459 */   // Label 8419: @503459
     /*  503459 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(503527), // Rule ID 62163 //
     /*  503464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503496 */     // MIs[0] policy
     /*  503496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  503509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503523 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503525 */     GIR_RootConstrainSelectedInstOperands,
     /*  503526 */     // GIR_Coverage, 62163,
     /*  503526 */     GIR_EraseRootFromParent_Done,
     /*  503527 */   // Label 8420: @503527
     /*  503527 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(503595), // Rule ID 62164 //
     /*  503532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503564 */     // MIs[0] policy
     /*  503564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  503577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503591 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503593 */     GIR_RootConstrainSelectedInstOperands,
     /*  503594 */     // GIR_Coverage, 62164,
     /*  503594 */     GIR_EraseRootFromParent_Done,
     /*  503595 */   // Label 8421: @503595
     /*  503595 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(503663), // Rule ID 62165 //
     /*  503600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503632 */     // MIs[0] policy
     /*  503632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503642 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  503645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503659 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503661 */     GIR_RootConstrainSelectedInstOperands,
     /*  503662 */     // GIR_Coverage, 62165,
     /*  503662 */     GIR_EraseRootFromParent_Done,
     /*  503663 */   // Label 8422: @503663
     /*  503663 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(503731), // Rule ID 62166 //
     /*  503668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503700 */     // MIs[0] policy
     /*  503700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503710 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  503713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503727 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503729 */     GIR_RootConstrainSelectedInstOperands,
     /*  503730 */     // GIR_Coverage, 62166,
     /*  503730 */     GIR_EraseRootFromParent_Done,
     /*  503731 */   // Label 8423: @503731
     /*  503731 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(503799), // Rule ID 62167 //
     /*  503736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503768 */     // MIs[0] policy
     /*  503768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503778 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  503781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503795 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503797 */     GIR_RootConstrainSelectedInstOperands,
     /*  503798 */     // GIR_Coverage, 62167,
     /*  503798 */     GIR_EraseRootFromParent_Done,
     /*  503799 */   // Label 8424: @503799
     /*  503799 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(503867), // Rule ID 62168 //
     /*  503804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503836 */     // MIs[0] policy
     /*  503836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  503849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503863 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503865 */     GIR_RootConstrainSelectedInstOperands,
     /*  503866 */     // GIR_Coverage, 62168,
     /*  503866 */     GIR_EraseRootFromParent_Done,
     /*  503867 */   // Label 8425: @503867
     /*  503867 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(503935), // Rule ID 62169 //
     /*  503872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503904 */     // MIs[0] policy
     /*  503904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  503917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503931 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503933 */     GIR_RootConstrainSelectedInstOperands,
     /*  503934 */     // GIR_Coverage, 62169,
     /*  503934 */     GIR_EraseRootFromParent_Done,
     /*  503935 */   // Label 8426: @503935
     /*  503935 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(504003), // Rule ID 62170 //
     /*  503940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503972 */     // MIs[0] policy
     /*  503972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  503985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503999 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504001 */     GIR_RootConstrainSelectedInstOperands,
     /*  504002 */     // GIR_Coverage, 62170,
     /*  504002 */     GIR_EraseRootFromParent_Done,
     /*  504003 */   // Label 8427: @504003
     /*  504003 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(504071), // Rule ID 62171 //
     /*  504008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504040 */     // MIs[0] policy
     /*  504040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  504053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504067 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504069 */     GIR_RootConstrainSelectedInstOperands,
     /*  504070 */     // GIR_Coverage, 62171,
     /*  504070 */     GIR_EraseRootFromParent_Done,
     /*  504071 */   // Label 8428: @504071
     /*  504071 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(504139), // Rule ID 62172 //
     /*  504076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504108 */     // MIs[0] policy
     /*  504108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  504121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504135 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504137 */     GIR_RootConstrainSelectedInstOperands,
     /*  504138 */     // GIR_Coverage, 62172,
     /*  504138 */     GIR_EraseRootFromParent_Done,
     /*  504139 */   // Label 8429: @504139
     /*  504139 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(504207), // Rule ID 62173 //
     /*  504144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504176 */     // MIs[0] policy
     /*  504176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  504189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504203 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504205 */     GIR_RootConstrainSelectedInstOperands,
     /*  504206 */     // GIR_Coverage, 62173,
     /*  504206 */     GIR_EraseRootFromParent_Done,
     /*  504207 */   // Label 8430: @504207
     /*  504207 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(504275), // Rule ID 62174 //
     /*  504212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504244 */     // MIs[0] policy
     /*  504244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  504257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504271 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504273 */     GIR_RootConstrainSelectedInstOperands,
     /*  504274 */     // GIR_Coverage, 62174,
     /*  504274 */     GIR_EraseRootFromParent_Done,
     /*  504275 */   // Label 8431: @504275
     /*  504275 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(504343), // Rule ID 62175 //
     /*  504280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504312 */     // MIs[0] policy
     /*  504312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  504325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504339 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504341 */     GIR_RootConstrainSelectedInstOperands,
     /*  504342 */     // GIR_Coverage, 62175,
     /*  504342 */     GIR_EraseRootFromParent_Done,
     /*  504343 */   // Label 8432: @504343
     /*  504343 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(504411), // Rule ID 62176 //
     /*  504348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504380 */     // MIs[0] policy
     /*  504380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  504393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504407 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504409 */     GIR_RootConstrainSelectedInstOperands,
     /*  504410 */     // GIR_Coverage, 62176,
     /*  504410 */     GIR_EraseRootFromParent_Done,
     /*  504411 */   // Label 8433: @504411
     /*  504411 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(504479), // Rule ID 62177 //
     /*  504416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  504424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504448 */     // MIs[0] policy
     /*  504448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504458 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  504461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504475 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504477 */     GIR_RootConstrainSelectedInstOperands,
     /*  504478 */     // GIR_Coverage, 62177,
     /*  504478 */     GIR_EraseRootFromParent_Done,
     /*  504479 */   // Label 8434: @504479
     /*  504479 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(504547), // Rule ID 62178 //
     /*  504484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504516 */     // MIs[0] policy
     /*  504516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  504529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504543 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504545 */     GIR_RootConstrainSelectedInstOperands,
     /*  504546 */     // GIR_Coverage, 62178,
     /*  504546 */     GIR_EraseRootFromParent_Done,
     /*  504547 */   // Label 8435: @504547
     /*  504547 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(504615), // Rule ID 62179 //
     /*  504552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504584 */     // MIs[0] policy
     /*  504584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  504597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504611 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504613 */     GIR_RootConstrainSelectedInstOperands,
     /*  504614 */     // GIR_Coverage, 62179,
     /*  504614 */     GIR_EraseRootFromParent_Done,
     /*  504615 */   // Label 8436: @504615
     /*  504615 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(504683), // Rule ID 62180 //
     /*  504620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504652 */     // MIs[0] policy
     /*  504652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504662 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  504665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504679 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504681 */     GIR_RootConstrainSelectedInstOperands,
     /*  504682 */     // GIR_Coverage, 62180,
     /*  504682 */     GIR_EraseRootFromParent_Done,
     /*  504683 */   // Label 8437: @504683
     /*  504683 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(504751), // Rule ID 62181 //
     /*  504688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504720 */     // MIs[0] policy
     /*  504720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  504733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504747 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504749 */     GIR_RootConstrainSelectedInstOperands,
     /*  504750 */     // GIR_Coverage, 62181,
     /*  504750 */     GIR_EraseRootFromParent_Done,
     /*  504751 */   // Label 8438: @504751
     /*  504751 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(504819), // Rule ID 62182 //
     /*  504756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504788 */     // MIs[0] policy
     /*  504788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  504801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504815 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504817 */     GIR_RootConstrainSelectedInstOperands,
     /*  504818 */     // GIR_Coverage, 62182,
     /*  504818 */     GIR_EraseRootFromParent_Done,
     /*  504819 */   // Label 8439: @504819
     /*  504819 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(504887), // Rule ID 62183 //
     /*  504824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504856 */     // MIs[0] policy
     /*  504856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  504869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504883 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504885 */     GIR_RootConstrainSelectedInstOperands,
     /*  504886 */     // GIR_Coverage, 62183,
     /*  504886 */     GIR_EraseRootFromParent_Done,
     /*  504887 */   // Label 8440: @504887
     /*  504887 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(504955), // Rule ID 62184 //
     /*  504892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504924 */     // MIs[0] policy
     /*  504924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  504937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504951 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504953 */     GIR_RootConstrainSelectedInstOperands,
     /*  504954 */     // GIR_Coverage, 62184,
     /*  504954 */     GIR_EraseRootFromParent_Done,
     /*  504955 */   // Label 8441: @504955
     /*  504955 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(505023), // Rule ID 62185 //
     /*  504960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504992 */     // MIs[0] policy
     /*  504992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  505005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505019 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505021 */     GIR_RootConstrainSelectedInstOperands,
     /*  505022 */     // GIR_Coverage, 62185,
     /*  505022 */     GIR_EraseRootFromParent_Done,
     /*  505023 */   // Label 8442: @505023
     /*  505023 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(505091), // Rule ID 62186 //
     /*  505028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505060 */     // MIs[0] policy
     /*  505060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505070 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  505073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505087 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505089 */     GIR_RootConstrainSelectedInstOperands,
     /*  505090 */     // GIR_Coverage, 62186,
     /*  505090 */     GIR_EraseRootFromParent_Done,
     /*  505091 */   // Label 8443: @505091
     /*  505091 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(505159), // Rule ID 62187 //
     /*  505096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  505104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  505107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  505110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  505113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  505128 */     // MIs[0] policy
     /*  505128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505138 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  505141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505155 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505157 */     GIR_RootConstrainSelectedInstOperands,
     /*  505158 */     // GIR_Coverage, 62187,
     /*  505158 */     GIR_EraseRootFromParent_Done,
     /*  505159 */   // Label 8444: @505159
     /*  505159 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(505227), // Rule ID 62188 //
     /*  505164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505196 */     // MIs[0] policy
     /*  505196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505206 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  505209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505223 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505225 */     GIR_RootConstrainSelectedInstOperands,
     /*  505226 */     // GIR_Coverage, 62188,
     /*  505226 */     GIR_EraseRootFromParent_Done,
     /*  505227 */   // Label 8445: @505227
     /*  505227 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(505295), // Rule ID 62189 //
     /*  505232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  505243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  505246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505264 */     // MIs[0] policy
     /*  505264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  505277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505291 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505293 */     GIR_RootConstrainSelectedInstOperands,
     /*  505294 */     // GIR_Coverage, 62189,
     /*  505294 */     GIR_EraseRootFromParent_Done,
     /*  505295 */   // Label 8446: @505295
     /*  505295 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(505363), // Rule ID 62190 //
     /*  505300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505332 */     // MIs[0] policy
     /*  505332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  505345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505359 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505361 */     GIR_RootConstrainSelectedInstOperands,
     /*  505362 */     // GIR_Coverage, 62190,
     /*  505362 */     GIR_EraseRootFromParent_Done,
     /*  505363 */   // Label 8447: @505363
     /*  505363 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(505431), // Rule ID 62191 //
     /*  505368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505400 */     // MIs[0] policy
     /*  505400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  505413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505427 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505429 */     GIR_RootConstrainSelectedInstOperands,
     /*  505430 */     // GIR_Coverage, 62191,
     /*  505430 */     GIR_EraseRootFromParent_Done,
     /*  505431 */   // Label 8448: @505431
     /*  505431 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(505499), // Rule ID 62192 //
     /*  505436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505468 */     // MIs[0] policy
     /*  505468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  505481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505495 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505497 */     GIR_RootConstrainSelectedInstOperands,
     /*  505498 */     // GIR_Coverage, 62192,
     /*  505498 */     GIR_EraseRootFromParent_Done,
     /*  505499 */   // Label 8449: @505499
     /*  505499 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(505567), // Rule ID 62193 //
     /*  505504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505536 */     // MIs[0] policy
     /*  505536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  505549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505563 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505565 */     GIR_RootConstrainSelectedInstOperands,
     /*  505566 */     // GIR_Coverage, 62193,
     /*  505566 */     GIR_EraseRootFromParent_Done,
     /*  505567 */   // Label 8450: @505567
     /*  505567 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(505635), // Rule ID 62194 //
     /*  505572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505604 */     // MIs[0] policy
     /*  505604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  505617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505631 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505633 */     GIR_RootConstrainSelectedInstOperands,
     /*  505634 */     // GIR_Coverage, 62194,
     /*  505634 */     GIR_EraseRootFromParent_Done,
     /*  505635 */   // Label 8451: @505635
     /*  505635 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(505703), // Rule ID 62195 //
     /*  505640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505672 */     // MIs[0] policy
     /*  505672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  505685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505699 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505701 */     GIR_RootConstrainSelectedInstOperands,
     /*  505702 */     // GIR_Coverage, 62195,
     /*  505702 */     GIR_EraseRootFromParent_Done,
     /*  505703 */   // Label 8452: @505703
     /*  505703 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(505771), // Rule ID 62196 //
     /*  505708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505740 */     // MIs[0] policy
     /*  505740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  505753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505767 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505769 */     GIR_RootConstrainSelectedInstOperands,
     /*  505770 */     // GIR_Coverage, 62196,
     /*  505770 */     GIR_EraseRootFromParent_Done,
     /*  505771 */   // Label 8453: @505771
     /*  505771 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(505839), // Rule ID 62197 //
     /*  505776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505808 */     // MIs[0] policy
     /*  505808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  505821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505835 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505837 */     GIR_RootConstrainSelectedInstOperands,
     /*  505838 */     // GIR_Coverage, 62197,
     /*  505838 */     GIR_EraseRootFromParent_Done,
     /*  505839 */   // Label 8454: @505839
     /*  505839 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(505907), // Rule ID 62198 //
     /*  505844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505876 */     // MIs[0] policy
     /*  505876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  505889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505903 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505905 */     GIR_RootConstrainSelectedInstOperands,
     /*  505906 */     // GIR_Coverage, 62198,
     /*  505906 */     GIR_EraseRootFromParent_Done,
     /*  505907 */   // Label 8455: @505907
     /*  505907 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(505975), // Rule ID 62199 //
     /*  505912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505944 */     // MIs[0] policy
     /*  505944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  505957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505971 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505973 */     GIR_RootConstrainSelectedInstOperands,
     /*  505974 */     // GIR_Coverage, 62199,
     /*  505974 */     GIR_EraseRootFromParent_Done,
     /*  505975 */   // Label 8456: @505975
     /*  505975 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(506043), // Rule ID 62200 //
     /*  505980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506012 */     // MIs[0] policy
     /*  506012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  506025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506039 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506041 */     GIR_RootConstrainSelectedInstOperands,
     /*  506042 */     // GIR_Coverage, 62200,
     /*  506042 */     GIR_EraseRootFromParent_Done,
     /*  506043 */   // Label 8457: @506043
     /*  506043 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(506111), // Rule ID 62201 //
     /*  506048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506080 */     // MIs[0] policy
     /*  506080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  506093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506107 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506109 */     GIR_RootConstrainSelectedInstOperands,
     /*  506110 */     // GIR_Coverage, 62201,
     /*  506110 */     GIR_EraseRootFromParent_Done,
     /*  506111 */   // Label 8458: @506111
     /*  506111 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(506179), // Rule ID 62202 //
     /*  506116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506148 */     // MIs[0] policy
     /*  506148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  506161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506175 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506177 */     GIR_RootConstrainSelectedInstOperands,
     /*  506178 */     // GIR_Coverage, 62202,
     /*  506178 */     GIR_EraseRootFromParent_Done,
     /*  506179 */   // Label 8459: @506179
     /*  506179 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(506247), // Rule ID 62203 //
     /*  506184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506216 */     // MIs[0] policy
     /*  506216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506226 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  506229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506243 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506245 */     GIR_RootConstrainSelectedInstOperands,
     /*  506246 */     // GIR_Coverage, 62203,
     /*  506246 */     GIR_EraseRootFromParent_Done,
     /*  506247 */   // Label 8460: @506247
     /*  506247 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(506315), // Rule ID 62204 //
     /*  506252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506284 */     // MIs[0] policy
     /*  506284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  506297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506311 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506313 */     GIR_RootConstrainSelectedInstOperands,
     /*  506314 */     // GIR_Coverage, 62204,
     /*  506314 */     GIR_EraseRootFromParent_Done,
     /*  506315 */   // Label 8461: @506315
     /*  506315 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(506383), // Rule ID 62205 //
     /*  506320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506352 */     // MIs[0] policy
     /*  506352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506362 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  506365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506379 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506381 */     GIR_RootConstrainSelectedInstOperands,
     /*  506382 */     // GIR_Coverage, 62205,
     /*  506382 */     GIR_EraseRootFromParent_Done,
     /*  506383 */   // Label 8462: @506383
     /*  506383 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(506451), // Rule ID 62206 //
     /*  506388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506420 */     // MIs[0] policy
     /*  506420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  506433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506447 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506449 */     GIR_RootConstrainSelectedInstOperands,
     /*  506450 */     // GIR_Coverage, 62206,
     /*  506450 */     GIR_EraseRootFromParent_Done,
     /*  506451 */   // Label 8463: @506451
     /*  506451 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(506519), // Rule ID 62207 //
     /*  506456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506488 */     // MIs[0] policy
     /*  506488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506498 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  506501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506515 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506517 */     GIR_RootConstrainSelectedInstOperands,
     /*  506518 */     // GIR_Coverage, 62207,
     /*  506518 */     GIR_EraseRootFromParent_Done,
     /*  506519 */   // Label 8464: @506519
     /*  506519 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(506587), // Rule ID 62208 //
     /*  506524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506556 */     // MIs[0] policy
     /*  506556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  506569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506583 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506585 */     GIR_RootConstrainSelectedInstOperands,
     /*  506586 */     // GIR_Coverage, 62208,
     /*  506586 */     GIR_EraseRootFromParent_Done,
     /*  506587 */   // Label 8465: @506587
     /*  506587 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(506655), // Rule ID 62209 //
     /*  506592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506624 */     // MIs[0] policy
     /*  506624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  506637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506651 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506653 */     GIR_RootConstrainSelectedInstOperands,
     /*  506654 */     // GIR_Coverage, 62209,
     /*  506654 */     GIR_EraseRootFromParent_Done,
     /*  506655 */   // Label 8466: @506655
     /*  506655 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(506723), // Rule ID 62210 //
     /*  506660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506692 */     // MIs[0] policy
     /*  506692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506702 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  506705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506719 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506721 */     GIR_RootConstrainSelectedInstOperands,
     /*  506722 */     // GIR_Coverage, 62210,
     /*  506722 */     GIR_EraseRootFromParent_Done,
     /*  506723 */   // Label 8467: @506723
     /*  506723 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(506791), // Rule ID 62211 //
     /*  506728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506760 */     // MIs[0] policy
     /*  506760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506770 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  506773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506787 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506789 */     GIR_RootConstrainSelectedInstOperands,
     /*  506790 */     // GIR_Coverage, 62211,
     /*  506790 */     GIR_EraseRootFromParent_Done,
     /*  506791 */   // Label 8468: @506791
     /*  506791 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(506859), // Rule ID 62212 //
     /*  506796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506828 */     // MIs[0] policy
     /*  506828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506838 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  506841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506855 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506857 */     GIR_RootConstrainSelectedInstOperands,
     /*  506858 */     // GIR_Coverage, 62212,
     /*  506858 */     GIR_EraseRootFromParent_Done,
     /*  506859 */   // Label 8469: @506859
     /*  506859 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(506927), // Rule ID 62213 //
     /*  506864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506896 */     // MIs[0] policy
     /*  506896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  506909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506923 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506925 */     GIR_RootConstrainSelectedInstOperands,
     /*  506926 */     // GIR_Coverage, 62213,
     /*  506926 */     GIR_EraseRootFromParent_Done,
     /*  506927 */   // Label 8470: @506927
     /*  506927 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(506995), // Rule ID 62214 //
     /*  506932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506964 */     // MIs[0] policy
     /*  506964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  506977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506991 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506993 */     GIR_RootConstrainSelectedInstOperands,
     /*  506994 */     // GIR_Coverage, 62214,
     /*  506994 */     GIR_EraseRootFromParent_Done,
     /*  506995 */   // Label 8471: @506995
     /*  506995 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(507063), // Rule ID 62215 //
     /*  507000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  507008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507032 */     // MIs[0] policy
     /*  507032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507042 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  507045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507059 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507061 */     GIR_RootConstrainSelectedInstOperands,
     /*  507062 */     // GIR_Coverage, 62215,
     /*  507062 */     GIR_EraseRootFromParent_Done,
     /*  507063 */   // Label 8472: @507063
     /*  507063 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(507131), // Rule ID 62216 //
     /*  507068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507100 */     // MIs[0] policy
     /*  507100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507110 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  507113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507127 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507129 */     GIR_RootConstrainSelectedInstOperands,
     /*  507130 */     // GIR_Coverage, 62216,
     /*  507130 */     GIR_EraseRootFromParent_Done,
     /*  507131 */   // Label 8473: @507131
     /*  507131 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(507199), // Rule ID 62217 //
     /*  507136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507168 */     // MIs[0] policy
     /*  507168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507178 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  507181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507195 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507197 */     GIR_RootConstrainSelectedInstOperands,
     /*  507198 */     // GIR_Coverage, 62217,
     /*  507198 */     GIR_EraseRootFromParent_Done,
     /*  507199 */   // Label 8474: @507199
     /*  507199 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(507267), // Rule ID 62218 //
     /*  507204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507236 */     // MIs[0] policy
     /*  507236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507246 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  507249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507263 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507265 */     GIR_RootConstrainSelectedInstOperands,
     /*  507266 */     // GIR_Coverage, 62218,
     /*  507266 */     GIR_EraseRootFromParent_Done,
     /*  507267 */   // Label 8475: @507267
     /*  507267 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(507335), // Rule ID 62219 //
     /*  507272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507304 */     // MIs[0] policy
     /*  507304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507314 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11152:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  507317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507331 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507333 */     GIR_RootConstrainSelectedInstOperands,
     /*  507334 */     // GIR_Coverage, 62219,
     /*  507334 */     GIR_EraseRootFromParent_Done,
     /*  507335 */   // Label 8476: @507335
     /*  507335 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(507403), // Rule ID 62220 //
     /*  507340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507372 */     // MIs[0] policy
     /*  507372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  507385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507399 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507401 */     GIR_RootConstrainSelectedInstOperands,
     /*  507402 */     // GIR_Coverage, 62220,
     /*  507402 */     GIR_EraseRootFromParent_Done,
     /*  507403 */   // Label 8477: @507403
     /*  507403 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(507471), // Rule ID 62221 //
     /*  507408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507440 */     // MIs[0] policy
     /*  507440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11152:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  507453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507467 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507469 */     GIR_RootConstrainSelectedInstOperands,
     /*  507470 */     // GIR_Coverage, 62221,
     /*  507470 */     GIR_EraseRootFromParent_Done,
     /*  507471 */   // Label 8478: @507471
     /*  507471 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(507539), // Rule ID 62222 //
     /*  507476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507508 */     // MIs[0] policy
     /*  507508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  507521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507535 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507537 */     GIR_RootConstrainSelectedInstOperands,
     /*  507538 */     // GIR_Coverage, 62222,
     /*  507538 */     GIR_EraseRootFromParent_Done,
     /*  507539 */   // Label 8479: @507539
     /*  507539 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(507607), // Rule ID 62223 //
     /*  507544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507576 */     // MIs[0] policy
     /*  507576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11152:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  507589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507603 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507605 */     GIR_RootConstrainSelectedInstOperands,
     /*  507606 */     // GIR_Coverage, 62223,
     /*  507606 */     GIR_EraseRootFromParent_Done,
     /*  507607 */   // Label 8480: @507607
     /*  507607 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(507675), // Rule ID 62224 //
     /*  507612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  507629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507644 */     // MIs[0] policy
     /*  507644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  507657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507671 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507673 */     GIR_RootConstrainSelectedInstOperands,
     /*  507674 */     // GIR_Coverage, 62224,
     /*  507674 */     GIR_EraseRootFromParent_Done,
     /*  507675 */   // Label 8481: @507675
     /*  507675 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(507743), // Rule ID 62225 //
     /*  507680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  507697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507712 */     // MIs[0] policy
     /*  507712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11152:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  507725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507739 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507741 */     GIR_RootConstrainSelectedInstOperands,
     /*  507742 */     // GIR_Coverage, 62225,
     /*  507742 */     GIR_EraseRootFromParent_Done,
     /*  507743 */   // Label 8482: @507743
     /*  507743 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(507811), // Rule ID 62226 //
     /*  507748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507780 */     // MIs[0] policy
     /*  507780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  507793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507807 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507809 */     GIR_RootConstrainSelectedInstOperands,
     /*  507810 */     // GIR_Coverage, 62226,
     /*  507810 */     GIR_EraseRootFromParent_Done,
     /*  507811 */   // Label 8483: @507811
     /*  507811 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(507879), // Rule ID 62227 //
     /*  507816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507848 */     // MIs[0] policy
     /*  507848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507858 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  507861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507875 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507877 */     GIR_RootConstrainSelectedInstOperands,
     /*  507878 */     // GIR_Coverage, 62227,
     /*  507878 */     GIR_EraseRootFromParent_Done,
     /*  507879 */   // Label 8484: @507879
     /*  507879 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(507947), // Rule ID 62228 //
     /*  507884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507916 */     // MIs[0] policy
     /*  507916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  507929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507943 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507945 */     GIR_RootConstrainSelectedInstOperands,
     /*  507946 */     // GIR_Coverage, 62228,
     /*  507946 */     GIR_EraseRootFromParent_Done,
     /*  507947 */   // Label 8485: @507947
     /*  507947 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(508015), // Rule ID 62229 //
     /*  507952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507984 */     // MIs[0] policy
     /*  507984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507994 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  507997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508011 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508013 */     GIR_RootConstrainSelectedInstOperands,
     /*  508014 */     // GIR_Coverage, 62229,
     /*  508014 */     GIR_EraseRootFromParent_Done,
     /*  508015 */   // Label 8486: @508015
     /*  508015 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(508083), // Rule ID 62230 //
     /*  508020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508052 */     // MIs[0] policy
     /*  508052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508062 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  508065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508079 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508081 */     GIR_RootConstrainSelectedInstOperands,
     /*  508082 */     // GIR_Coverage, 62230,
     /*  508082 */     GIR_EraseRootFromParent_Done,
     /*  508083 */   // Label 8487: @508083
     /*  508083 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(508151), // Rule ID 62231 //
     /*  508088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  508099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  508102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508120 */     // MIs[0] policy
     /*  508120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11151:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  508133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508147 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508149 */     GIR_RootConstrainSelectedInstOperands,
     /*  508150 */     // GIR_Coverage, 62231,
     /*  508150 */     GIR_EraseRootFromParent_Done,
     /*  508151 */   // Label 8488: @508151
     /*  508151 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(508219), // Rule ID 62232 //
     /*  508156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508188 */     // MIs[0] policy
     /*  508188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  508201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508215 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508217 */     GIR_RootConstrainSelectedInstOperands,
     /*  508218 */     // GIR_Coverage, 62232,
     /*  508218 */     GIR_EraseRootFromParent_Done,
     /*  508219 */   // Label 8489: @508219
     /*  508219 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(508287), // Rule ID 62233 //
     /*  508224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508256 */     // MIs[0] policy
     /*  508256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  508269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508283 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508285 */     GIR_RootConstrainSelectedInstOperands,
     /*  508286 */     // GIR_Coverage, 62233,
     /*  508286 */     GIR_EraseRootFromParent_Done,
     /*  508287 */   // Label 8490: @508287
     /*  508287 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(508355), // Rule ID 62234 //
     /*  508292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508324 */     // MIs[0] policy
     /*  508324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  508337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508351 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508353 */     GIR_RootConstrainSelectedInstOperands,
     /*  508354 */     // GIR_Coverage, 62234,
     /*  508354 */     GIR_EraseRootFromParent_Done,
     /*  508355 */   // Label 8491: @508355
     /*  508355 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(508423), // Rule ID 62235 //
     /*  508360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508392 */     // MIs[0] policy
     /*  508392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  508405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508419 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508421 */     GIR_RootConstrainSelectedInstOperands,
     /*  508422 */     // GIR_Coverage, 62235,
     /*  508422 */     GIR_EraseRootFromParent_Done,
     /*  508423 */   // Label 8492: @508423
     /*  508423 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(508491), // Rule ID 62236 //
     /*  508428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508460 */     // MIs[0] policy
     /*  508460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508470 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  508473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508487 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508489 */     GIR_RootConstrainSelectedInstOperands,
     /*  508490 */     // GIR_Coverage, 62236,
     /*  508490 */     GIR_EraseRootFromParent_Done,
     /*  508491 */   // Label 8493: @508491
     /*  508491 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(508559), // Rule ID 62237 //
     /*  508496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  508507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508528 */     // MIs[0] policy
     /*  508528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508538 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11151:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  508541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508555 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508557 */     GIR_RootConstrainSelectedInstOperands,
     /*  508558 */     // GIR_Coverage, 62237,
     /*  508558 */     GIR_EraseRootFromParent_Done,
     /*  508559 */   // Label 8494: @508559
     /*  508559 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(508627), // Rule ID 62238 //
     /*  508564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508596 */     // MIs[0] policy
     /*  508596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  508609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508623 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508625 */     GIR_RootConstrainSelectedInstOperands,
     /*  508626 */     // GIR_Coverage, 62238,
     /*  508626 */     GIR_EraseRootFromParent_Done,
     /*  508627 */   // Label 8495: @508627
     /*  508627 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(508695), // Rule ID 62239 //
     /*  508632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508664 */     // MIs[0] policy
     /*  508664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  508677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508691 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508693 */     GIR_RootConstrainSelectedInstOperands,
     /*  508694 */     // GIR_Coverage, 62239,
     /*  508694 */     GIR_EraseRootFromParent_Done,
     /*  508695 */   // Label 8496: @508695
     /*  508695 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(508763), // Rule ID 62240 //
     /*  508700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508732 */     // MIs[0] policy
     /*  508732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  508745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508759 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508761 */     GIR_RootConstrainSelectedInstOperands,
     /*  508762 */     // GIR_Coverage, 62240,
     /*  508762 */     GIR_EraseRootFromParent_Done,
     /*  508763 */   // Label 8497: @508763
     /*  508763 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(508831), // Rule ID 62241 //
     /*  508768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508800 */     // MIs[0] policy
     /*  508800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508810 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  508813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508827 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508829 */     GIR_RootConstrainSelectedInstOperands,
     /*  508830 */     // GIR_Coverage, 62241,
     /*  508830 */     GIR_EraseRootFromParent_Done,
     /*  508831 */   // Label 8498: @508831
     /*  508831 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(508899), // Rule ID 62242 //
     /*  508836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508868 */     // MIs[0] policy
     /*  508868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508878 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  508881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508895 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508897 */     GIR_RootConstrainSelectedInstOperands,
     /*  508898 */     // GIR_Coverage, 62242,
     /*  508898 */     GIR_EraseRootFromParent_Done,
     /*  508899 */   // Label 8499: @508899
     /*  508899 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(508967), // Rule ID 62243 //
     /*  508904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508936 */     // MIs[0] policy
     /*  508936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  508949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508963 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508965 */     GIR_RootConstrainSelectedInstOperands,
     /*  508966 */     // GIR_Coverage, 62243,
     /*  508966 */     GIR_EraseRootFromParent_Done,
     /*  508967 */   // Label 8500: @508967
     /*  508967 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(509035), // Rule ID 62244 //
     /*  508972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509004 */     // MIs[0] policy
     /*  509004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  509017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509031 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509033 */     GIR_RootConstrainSelectedInstOperands,
     /*  509034 */     // GIR_Coverage, 62244,
     /*  509034 */     GIR_EraseRootFromParent_Done,
     /*  509035 */   // Label 8501: @509035
     /*  509035 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(509103), // Rule ID 62245 //
     /*  509040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509072 */     // MIs[0] policy
     /*  509072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509082 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11151:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  509085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509099 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509101 */     GIR_RootConstrainSelectedInstOperands,
     /*  509102 */     // GIR_Coverage, 62245,
     /*  509102 */     GIR_EraseRootFromParent_Done,
     /*  509103 */   // Label 8502: @509103
     /*  509103 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(509171), // Rule ID 62246 //
     /*  509108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509140 */     // MIs[0] policy
     /*  509140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509150 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  509153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509167 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509169 */     GIR_RootConstrainSelectedInstOperands,
     /*  509170 */     // GIR_Coverage, 62246,
     /*  509170 */     GIR_EraseRootFromParent_Done,
     /*  509171 */   // Label 8503: @509171
     /*  509171 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(509239), // Rule ID 62247 //
     /*  509176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509208 */     // MIs[0] policy
     /*  509208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  509221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509235 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509237 */     GIR_RootConstrainSelectedInstOperands,
     /*  509238 */     // GIR_Coverage, 62247,
     /*  509238 */     GIR_EraseRootFromParent_Done,
     /*  509239 */   // Label 8504: @509239
     /*  509239 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(509307), // Rule ID 62248 //
     /*  509244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509276 */     // MIs[0] policy
     /*  509276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509286 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  509289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509303 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509305 */     GIR_RootConstrainSelectedInstOperands,
     /*  509306 */     // GIR_Coverage, 62248,
     /*  509306 */     GIR_EraseRootFromParent_Done,
     /*  509307 */   // Label 8505: @509307
     /*  509307 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(509375), // Rule ID 62249 //
     /*  509312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509344 */     // MIs[0] policy
     /*  509344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509354 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  509357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509371 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509373 */     GIR_RootConstrainSelectedInstOperands,
     /*  509374 */     // GIR_Coverage, 62249,
     /*  509374 */     GIR_EraseRootFromParent_Done,
     /*  509375 */   // Label 8506: @509375
     /*  509375 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(509443), // Rule ID 62250 //
     /*  509380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509412 */     // MIs[0] policy
     /*  509412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  509425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509439 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509441 */     GIR_RootConstrainSelectedInstOperands,
     /*  509442 */     // GIR_Coverage, 62250,
     /*  509442 */     GIR_EraseRootFromParent_Done,
     /*  509443 */   // Label 8507: @509443
     /*  509443 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(509511), // Rule ID 62251 //
     /*  509448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509480 */     // MIs[0] policy
     /*  509480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509490 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  509493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509507 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509509 */     GIR_RootConstrainSelectedInstOperands,
     /*  509510 */     // GIR_Coverage, 62251,
     /*  509510 */     GIR_EraseRootFromParent_Done,
     /*  509511 */   // Label 8508: @509511
     /*  509511 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(509579), // Rule ID 62252 //
     /*  509516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509548 */     // MIs[0] policy
     /*  509548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  509561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509575 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509577 */     GIR_RootConstrainSelectedInstOperands,
     /*  509578 */     // GIR_Coverage, 62252,
     /*  509578 */     GIR_EraseRootFromParent_Done,
     /*  509579 */   // Label 8509: @509579
     /*  509579 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(509647), // Rule ID 62253 //
     /*  509584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509616 */     // MIs[0] policy
     /*  509616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11151:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  509629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509643 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509645 */     GIR_RootConstrainSelectedInstOperands,
     /*  509646 */     // GIR_Coverage, 62253,
     /*  509646 */     GIR_EraseRootFromParent_Done,
     /*  509647 */   // Label 8510: @509647
     /*  509647 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(509715), // Rule ID 62270 //
     /*  509652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509684 */     // MIs[0] policy
     /*  509684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  509697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509711 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509713 */     GIR_RootConstrainSelectedInstOperands,
     /*  509714 */     // GIR_Coverage, 62270,
     /*  509714 */     GIR_EraseRootFromParent_Done,
     /*  509715 */   // Label 8511: @509715
     /*  509715 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(509783), // Rule ID 62271 //
     /*  509720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509752 */     // MIs[0] policy
     /*  509752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509762 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  509765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509779 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509781 */     GIR_RootConstrainSelectedInstOperands,
     /*  509782 */     // GIR_Coverage, 62271,
     /*  509782 */     GIR_EraseRootFromParent_Done,
     /*  509783 */   // Label 8512: @509783
     /*  509783 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(509851), // Rule ID 62272 //
     /*  509788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509820 */     // MIs[0] policy
     /*  509820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  509833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509847 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509849 */     GIR_RootConstrainSelectedInstOperands,
     /*  509850 */     // GIR_Coverage, 62272,
     /*  509850 */     GIR_EraseRootFromParent_Done,
     /*  509851 */   // Label 8513: @509851
     /*  509851 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(509919), // Rule ID 62273 //
     /*  509856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509888 */     // MIs[0] policy
     /*  509888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  509901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509915 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509917 */     GIR_RootConstrainSelectedInstOperands,
     /*  509918 */     // GIR_Coverage, 62273,
     /*  509918 */     GIR_EraseRootFromParent_Done,
     /*  509919 */   // Label 8514: @509919
     /*  509919 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(509987), // Rule ID 62274 //
     /*  509924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509956 */     // MIs[0] policy
     /*  509956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  509969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509983 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509985 */     GIR_RootConstrainSelectedInstOperands,
     /*  509986 */     // GIR_Coverage, 62274,
     /*  509986 */     GIR_EraseRootFromParent_Done,
     /*  509987 */   // Label 8515: @509987
     /*  509987 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(510055), // Rule ID 62275 //
     /*  509992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  510003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  510006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510024 */     // MIs[0] policy
     /*  510024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  510037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510051 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510053 */     GIR_RootConstrainSelectedInstOperands,
     /*  510054 */     // GIR_Coverage, 62275,
     /*  510054 */     GIR_EraseRootFromParent_Done,
     /*  510055 */   // Label 8516: @510055
     /*  510055 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(510123), // Rule ID 62276 //
     /*  510060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510092 */     // MIs[0] policy
     /*  510092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  510105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510119 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510121 */     GIR_RootConstrainSelectedInstOperands,
     /*  510122 */     // GIR_Coverage, 62276,
     /*  510122 */     GIR_EraseRootFromParent_Done,
     /*  510123 */   // Label 8517: @510123
     /*  510123 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(510191), // Rule ID 62277 //
     /*  510128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510160 */     // MIs[0] policy
     /*  510160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  510173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510187 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510189 */     GIR_RootConstrainSelectedInstOperands,
     /*  510190 */     // GIR_Coverage, 62277,
     /*  510190 */     GIR_EraseRootFromParent_Done,
     /*  510191 */   // Label 8518: @510191
     /*  510191 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(510259), // Rule ID 62278 //
     /*  510196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510228 */     // MIs[0] policy
     /*  510228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  510241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510255 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510257 */     GIR_RootConstrainSelectedInstOperands,
     /*  510258 */     // GIR_Coverage, 62278,
     /*  510258 */     GIR_EraseRootFromParent_Done,
     /*  510259 */   // Label 8519: @510259
     /*  510259 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(510327), // Rule ID 62279 //
     /*  510264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510296 */     // MIs[0] policy
     /*  510296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  510309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510323 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510325 */     GIR_RootConstrainSelectedInstOperands,
     /*  510326 */     // GIR_Coverage, 62279,
     /*  510326 */     GIR_EraseRootFromParent_Done,
     /*  510327 */   // Label 8520: @510327
     /*  510327 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(510395), // Rule ID 62280 //
     /*  510332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510364 */     // MIs[0] policy
     /*  510364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  510377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510391 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510393 */     GIR_RootConstrainSelectedInstOperands,
     /*  510394 */     // GIR_Coverage, 62280,
     /*  510394 */     GIR_EraseRootFromParent_Done,
     /*  510395 */   // Label 8521: @510395
     /*  510395 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(510463), // Rule ID 62281 //
     /*  510400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  510411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  510414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510432 */     // MIs[0] policy
     /*  510432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  510445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510459 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510461 */     GIR_RootConstrainSelectedInstOperands,
     /*  510462 */     // GIR_Coverage, 62281,
     /*  510462 */     GIR_EraseRootFromParent_Done,
     /*  510463 */   // Label 8522: @510463
     /*  510463 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(510531), // Rule ID 62282 //
     /*  510468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510500 */     // MIs[0] policy
     /*  510500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  510513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510527 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510529 */     GIR_RootConstrainSelectedInstOperands,
     /*  510530 */     // GIR_Coverage, 62282,
     /*  510530 */     GIR_EraseRootFromParent_Done,
     /*  510531 */   // Label 8523: @510531
     /*  510531 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(510599), // Rule ID 62283 //
     /*  510536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510568 */     // MIs[0] policy
     /*  510568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510578 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  510581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510595 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510597 */     GIR_RootConstrainSelectedInstOperands,
     /*  510598 */     // GIR_Coverage, 62283,
     /*  510598 */     GIR_EraseRootFromParent_Done,
     /*  510599 */   // Label 8524: @510599
     /*  510599 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(510667), // Rule ID 62284 //
     /*  510604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510636 */     // MIs[0] policy
     /*  510636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  510649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510663 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510665 */     GIR_RootConstrainSelectedInstOperands,
     /*  510666 */     // GIR_Coverage, 62284,
     /*  510666 */     GIR_EraseRootFromParent_Done,
     /*  510667 */   // Label 8525: @510667
     /*  510667 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(510735), // Rule ID 62285 //
     /*  510672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510704 */     // MIs[0] policy
     /*  510704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  510717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510731 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510733 */     GIR_RootConstrainSelectedInstOperands,
     /*  510734 */     // GIR_Coverage, 62285,
     /*  510734 */     GIR_EraseRootFromParent_Done,
     /*  510735 */   // Label 8526: @510735
     /*  510735 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(510803), // Rule ID 62286 //
     /*  510740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510772 */     // MIs[0] policy
     /*  510772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510782 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  510785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510799 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510801 */     GIR_RootConstrainSelectedInstOperands,
     /*  510802 */     // GIR_Coverage, 62286,
     /*  510802 */     GIR_EraseRootFromParent_Done,
     /*  510803 */   // Label 8527: @510803
     /*  510803 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(510871), // Rule ID 62287 //
     /*  510808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510840 */     // MIs[0] policy
     /*  510840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510850 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  510853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510867 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510869 */     GIR_RootConstrainSelectedInstOperands,
     /*  510870 */     // GIR_Coverage, 62287,
     /*  510870 */     GIR_EraseRootFromParent_Done,
     /*  510871 */   // Label 8528: @510871
     /*  510871 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(510939), // Rule ID 62288 //
     /*  510876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510908 */     // MIs[0] policy
     /*  510908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510918 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  510921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510935 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510937 */     GIR_RootConstrainSelectedInstOperands,
     /*  510938 */     // GIR_Coverage, 62288,
     /*  510938 */     GIR_EraseRootFromParent_Done,
     /*  510939 */   // Label 8529: @510939
     /*  510939 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(511007), // Rule ID 62289 //
     /*  510944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510976 */     // MIs[0] policy
     /*  510976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  510989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511003 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511005 */     GIR_RootConstrainSelectedInstOperands,
     /*  511006 */     // GIR_Coverage, 62289,
     /*  511006 */     GIR_EraseRootFromParent_Done,
     /*  511007 */   // Label 8530: @511007
     /*  511007 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(511075), // Rule ID 62290 //
     /*  511012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511044 */     // MIs[0] policy
     /*  511044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  511057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511071 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511073 */     GIR_RootConstrainSelectedInstOperands,
     /*  511074 */     // GIR_Coverage, 62290,
     /*  511074 */     GIR_EraseRootFromParent_Done,
     /*  511075 */   // Label 8531: @511075
     /*  511075 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(511143), // Rule ID 62291 //
     /*  511080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511112 */     // MIs[0] policy
     /*  511112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511122 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  511125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511139 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511141 */     GIR_RootConstrainSelectedInstOperands,
     /*  511142 */     // GIR_Coverage, 62291,
     /*  511142 */     GIR_EraseRootFromParent_Done,
     /*  511143 */   // Label 8532: @511143
     /*  511143 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(511211), // Rule ID 62292 //
     /*  511148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511180 */     // MIs[0] policy
     /*  511180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511190 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  511193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511207 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511209 */     GIR_RootConstrainSelectedInstOperands,
     /*  511210 */     // GIR_Coverage, 62292,
     /*  511210 */     GIR_EraseRootFromParent_Done,
     /*  511211 */   // Label 8533: @511211
     /*  511211 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(511279), // Rule ID 62293 //
     /*  511216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511248 */     // MIs[0] policy
     /*  511248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511258 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  511261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511275 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511277 */     GIR_RootConstrainSelectedInstOperands,
     /*  511278 */     // GIR_Coverage, 62293,
     /*  511278 */     GIR_EraseRootFromParent_Done,
     /*  511279 */   // Label 8534: @511279
     /*  511279 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(511347), // Rule ID 62294 //
     /*  511284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511316 */     // MIs[0] policy
     /*  511316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511326 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  511329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511343 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511345 */     GIR_RootConstrainSelectedInstOperands,
     /*  511346 */     // GIR_Coverage, 62294,
     /*  511346 */     GIR_EraseRootFromParent_Done,
     /*  511347 */   // Label 8535: @511347
     /*  511347 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(511415), // Rule ID 62295 //
     /*  511352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511384 */     // MIs[0] policy
     /*  511384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511394 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  511397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511411 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511413 */     GIR_RootConstrainSelectedInstOperands,
     /*  511414 */     // GIR_Coverage, 62295,
     /*  511414 */     GIR_EraseRootFromParent_Done,
     /*  511415 */   // Label 8536: @511415
     /*  511415 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(511483), // Rule ID 62296 //
     /*  511420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  511423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511452 */     // MIs[0] policy
     /*  511452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511462 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  511465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511479 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511481 */     GIR_RootConstrainSelectedInstOperands,
     /*  511482 */     // GIR_Coverage, 62296,
     /*  511482 */     GIR_EraseRootFromParent_Done,
     /*  511483 */   // Label 8537: @511483
     /*  511483 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(511551), // Rule ID 62297 //
     /*  511488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  511491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  511496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511520 */     // MIs[0] policy
     /*  511520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11155:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  511533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511547 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511549 */     GIR_RootConstrainSelectedInstOperands,
     /*  511550 */     // GIR_Coverage, 62297,
     /*  511550 */     GIR_EraseRootFromParent_Done,
     /*  511551 */   // Label 8538: @511551
     /*  511551 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(511619), // Rule ID 62392 //
     /*  511556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511588 */     // MIs[0] policy
     /*  511588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511598 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  511601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511615 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511617 */     GIR_RootConstrainSelectedInstOperands,
     /*  511618 */     // GIR_Coverage, 62392,
     /*  511618 */     GIR_EraseRootFromParent_Done,
     /*  511619 */   // Label 8539: @511619
     /*  511619 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(511687), // Rule ID 62393 //
     /*  511624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511656 */     // MIs[0] policy
     /*  511656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511666 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  511669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511683 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511685 */     GIR_RootConstrainSelectedInstOperands,
     /*  511686 */     // GIR_Coverage, 62393,
     /*  511686 */     GIR_EraseRootFromParent_Done,
     /*  511687 */   // Label 8540: @511687
     /*  511687 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(511755), // Rule ID 62394 //
     /*  511692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511724 */     // MIs[0] policy
     /*  511724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511734 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  511737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511751 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511753 */     GIR_RootConstrainSelectedInstOperands,
     /*  511754 */     // GIR_Coverage, 62394,
     /*  511754 */     GIR_EraseRootFromParent_Done,
     /*  511755 */   // Label 8541: @511755
     /*  511755 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(511823), // Rule ID 62395 //
     /*  511760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511792 */     // MIs[0] policy
     /*  511792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11560:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  511805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511819 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511821 */     GIR_RootConstrainSelectedInstOperands,
     /*  511822 */     // GIR_Coverage, 62395,
     /*  511822 */     GIR_EraseRootFromParent_Done,
     /*  511823 */   // Label 8542: @511823
     /*  511823 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(511891), // Rule ID 62396 //
     /*  511828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511860 */     // MIs[0] policy
     /*  511860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  511873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511887 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511889 */     GIR_RootConstrainSelectedInstOperands,
     /*  511890 */     // GIR_Coverage, 62396,
     /*  511890 */     GIR_EraseRootFromParent_Done,
     /*  511891 */   // Label 8543: @511891
     /*  511891 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(511959), // Rule ID 62397 //
     /*  511896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511928 */     // MIs[0] policy
     /*  511928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11560:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  511941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511955 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511957 */     GIR_RootConstrainSelectedInstOperands,
     /*  511958 */     // GIR_Coverage, 62397,
     /*  511958 */     GIR_EraseRootFromParent_Done,
     /*  511959 */   // Label 8544: @511959
     /*  511959 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(512027), // Rule ID 62398 //
     /*  511964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511996 */     // MIs[0] policy
     /*  511996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512006 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  512009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512023 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512025 */     GIR_RootConstrainSelectedInstOperands,
     /*  512026 */     // GIR_Coverage, 62398,
     /*  512026 */     GIR_EraseRootFromParent_Done,
     /*  512027 */   // Label 8545: @512027
     /*  512027 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(512095), // Rule ID 62399 //
     /*  512032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512064 */     // MIs[0] policy
     /*  512064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512074 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11560:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  512077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512091 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512093 */     GIR_RootConstrainSelectedInstOperands,
     /*  512094 */     // GIR_Coverage, 62399,
     /*  512094 */     GIR_EraseRootFromParent_Done,
     /*  512095 */   // Label 8546: @512095
     /*  512095 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(512163), // Rule ID 62400 //
     /*  512100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  512117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512132 */     // MIs[0] policy
     /*  512132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  512145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512159 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512161 */     GIR_RootConstrainSelectedInstOperands,
     /*  512162 */     // GIR_Coverage, 62400,
     /*  512162 */     GIR_EraseRootFromParent_Done,
     /*  512163 */   // Label 8547: @512163
     /*  512163 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(512231), // Rule ID 62401 //
     /*  512168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  512176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  512179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  512182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  512185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  512200 */     // MIs[0] policy
     /*  512200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11560:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  512213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512227 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512229 */     GIR_RootConstrainSelectedInstOperands,
     /*  512230 */     // GIR_Coverage, 62401,
     /*  512230 */     GIR_EraseRootFromParent_Done,
     /*  512231 */   // Label 8548: @512231
     /*  512231 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(512299), // Rule ID 62402 //
     /*  512236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512268 */     // MIs[0] policy
     /*  512268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512278 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  512281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512295 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512297 */     GIR_RootConstrainSelectedInstOperands,
     /*  512298 */     // GIR_Coverage, 62402,
     /*  512298 */     GIR_EraseRootFromParent_Done,
     /*  512299 */   // Label 8549: @512299
     /*  512299 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(512367), // Rule ID 62403 //
     /*  512304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  512315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  512318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512336 */     // MIs[0] policy
     /*  512336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  512349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512363 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512365 */     GIR_RootConstrainSelectedInstOperands,
     /*  512366 */     // GIR_Coverage, 62403,
     /*  512366 */     GIR_EraseRootFromParent_Done,
     /*  512367 */   // Label 8550: @512367
     /*  512367 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(512435), // Rule ID 62404 //
     /*  512372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512404 */     // MIs[0] policy
     /*  512404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512414 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  512417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512431 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512433 */     GIR_RootConstrainSelectedInstOperands,
     /*  512434 */     // GIR_Coverage, 62404,
     /*  512434 */     GIR_EraseRootFromParent_Done,
     /*  512435 */   // Label 8551: @512435
     /*  512435 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(512503), // Rule ID 62405 //
     /*  512440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512472 */     // MIs[0] policy
     /*  512472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  512485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512499 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512501 */     GIR_RootConstrainSelectedInstOperands,
     /*  512502 */     // GIR_Coverage, 62405,
     /*  512502 */     GIR_EraseRootFromParent_Done,
     /*  512503 */   // Label 8552: @512503
     /*  512503 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(512571), // Rule ID 62406 //
     /*  512508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512540 */     // MIs[0] policy
     /*  512540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  512553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512567 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512569 */     GIR_RootConstrainSelectedInstOperands,
     /*  512570 */     // GIR_Coverage, 62406,
     /*  512570 */     GIR_EraseRootFromParent_Done,
     /*  512571 */   // Label 8553: @512571
     /*  512571 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(512639), // Rule ID 62407 //
     /*  512576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512608 */     // MIs[0] policy
     /*  512608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11559:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  512621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512635 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512637 */     GIR_RootConstrainSelectedInstOperands,
     /*  512638 */     // GIR_Coverage, 62407,
     /*  512638 */     GIR_EraseRootFromParent_Done,
     /*  512639 */   // Label 8554: @512639
     /*  512639 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(512707), // Rule ID 62408 //
     /*  512644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512676 */     // MIs[0] policy
     /*  512676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512686 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  512689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512703 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512705 */     GIR_RootConstrainSelectedInstOperands,
     /*  512706 */     // GIR_Coverage, 62408,
     /*  512706 */     GIR_EraseRootFromParent_Done,
     /*  512707 */   // Label 8555: @512707
     /*  512707 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(512775), // Rule ID 62409 //
     /*  512712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512744 */     // MIs[0] policy
     /*  512744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  512757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512771 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512773 */     GIR_RootConstrainSelectedInstOperands,
     /*  512774 */     // GIR_Coverage, 62409,
     /*  512774 */     GIR_EraseRootFromParent_Done,
     /*  512775 */   // Label 8556: @512775
     /*  512775 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(512843), // Rule ID 62410 //
     /*  512780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512812 */     // MIs[0] policy
     /*  512812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  512825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512839 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512841 */     GIR_RootConstrainSelectedInstOperands,
     /*  512842 */     // GIR_Coverage, 62410,
     /*  512842 */     GIR_EraseRootFromParent_Done,
     /*  512843 */   // Label 8557: @512843
     /*  512843 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(512911), // Rule ID 62411 //
     /*  512848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512880 */     // MIs[0] policy
     /*  512880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  512893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512907 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512909 */     GIR_RootConstrainSelectedInstOperands,
     /*  512910 */     // GIR_Coverage, 62411,
     /*  512910 */     GIR_EraseRootFromParent_Done,
     /*  512911 */   // Label 8558: @512911
     /*  512911 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(512979), // Rule ID 62412 //
     /*  512916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512948 */     // MIs[0] policy
     /*  512948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  512961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512975 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512977 */     GIR_RootConstrainSelectedInstOperands,
     /*  512978 */     // GIR_Coverage, 62412,
     /*  512978 */     GIR_EraseRootFromParent_Done,
     /*  512979 */   // Label 8559: @512979
     /*  512979 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(513047), // Rule ID 62413 //
     /*  512984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513016 */     // MIs[0] policy
     /*  513016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11559:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  513029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513043 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513045 */     GIR_RootConstrainSelectedInstOperands,
     /*  513046 */     // GIR_Coverage, 62413,
     /*  513046 */     GIR_EraseRootFromParent_Done,
     /*  513047 */   // Label 8560: @513047
     /*  513047 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(513115), // Rule ID 62414 //
     /*  513052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513084 */     // MIs[0] policy
     /*  513084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  513097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513111 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513113 */     GIR_RootConstrainSelectedInstOperands,
     /*  513114 */     // GIR_Coverage, 62414,
     /*  513114 */     GIR_EraseRootFromParent_Done,
     /*  513115 */   // Label 8561: @513115
     /*  513115 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(513183), // Rule ID 62415 //
     /*  513120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513152 */     // MIs[0] policy
     /*  513152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513162 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  513165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513179 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513181 */     GIR_RootConstrainSelectedInstOperands,
     /*  513182 */     // GIR_Coverage, 62415,
     /*  513182 */     GIR_EraseRootFromParent_Done,
     /*  513183 */   // Label 8562: @513183
     /*  513183 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(513251), // Rule ID 62416 //
     /*  513188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513220 */     // MIs[0] policy
     /*  513220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513230 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  513233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513247 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513249 */     GIR_RootConstrainSelectedInstOperands,
     /*  513250 */     // GIR_Coverage, 62416,
     /*  513250 */     GIR_EraseRootFromParent_Done,
     /*  513251 */   // Label 8563: @513251
     /*  513251 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(513319), // Rule ID 62417 //
     /*  513256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513288 */     // MIs[0] policy
     /*  513288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513298 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  513301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513315 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513317 */     GIR_RootConstrainSelectedInstOperands,
     /*  513318 */     // GIR_Coverage, 62417,
     /*  513318 */     GIR_EraseRootFromParent_Done,
     /*  513319 */   // Label 8564: @513319
     /*  513319 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(513387), // Rule ID 62418 //
     /*  513324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513356 */     // MIs[0] policy
     /*  513356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513366 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  513369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513383 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513385 */     GIR_RootConstrainSelectedInstOperands,
     /*  513386 */     // GIR_Coverage, 62418,
     /*  513386 */     GIR_EraseRootFromParent_Done,
     /*  513387 */   // Label 8565: @513387
     /*  513387 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(513455), // Rule ID 62419 //
     /*  513392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513424 */     // MIs[0] policy
     /*  513424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  513437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513451 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513453 */     GIR_RootConstrainSelectedInstOperands,
     /*  513454 */     // GIR_Coverage, 62419,
     /*  513454 */     GIR_EraseRootFromParent_Done,
     /*  513455 */   // Label 8566: @513455
     /*  513455 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(513523), // Rule ID 62420 //
     /*  513460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513492 */     // MIs[0] policy
     /*  513492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  513505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513519 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513521 */     GIR_RootConstrainSelectedInstOperands,
     /*  513522 */     // GIR_Coverage, 62420,
     /*  513522 */     GIR_EraseRootFromParent_Done,
     /*  513523 */   // Label 8567: @513523
     /*  513523 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(513591), // Rule ID 62421 //
     /*  513528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513560 */     // MIs[0] policy
     /*  513560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11559:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  513573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513587 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513589 */     GIR_RootConstrainSelectedInstOperands,
     /*  513590 */     // GIR_Coverage, 62421,
     /*  513590 */     GIR_EraseRootFromParent_Done,
     /*  513591 */   // Label 8568: @513591
     /*  513591 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(513659), // Rule ID 62422 //
     /*  513596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513628 */     // MIs[0] policy
     /*  513628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  513641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513655 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513657 */     GIR_RootConstrainSelectedInstOperands,
     /*  513658 */     // GIR_Coverage, 62422,
     /*  513658 */     GIR_EraseRootFromParent_Done,
     /*  513659 */   // Label 8569: @513659
     /*  513659 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(513727), // Rule ID 62423 //
     /*  513664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513696 */     // MIs[0] policy
     /*  513696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  513709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513723 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513725 */     GIR_RootConstrainSelectedInstOperands,
     /*  513726 */     // GIR_Coverage, 62423,
     /*  513726 */     GIR_EraseRootFromParent_Done,
     /*  513727 */   // Label 8570: @513727
     /*  513727 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(513795), // Rule ID 62424 //
     /*  513732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513764 */     // MIs[0] policy
     /*  513764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  513777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513791 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513793 */     GIR_RootConstrainSelectedInstOperands,
     /*  513794 */     // GIR_Coverage, 62424,
     /*  513794 */     GIR_EraseRootFromParent_Done,
     /*  513795 */   // Label 8571: @513795
     /*  513795 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(513863), // Rule ID 62425 //
     /*  513800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513832 */     // MIs[0] policy
     /*  513832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513842 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  513845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513859 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513861 */     GIR_RootConstrainSelectedInstOperands,
     /*  513862 */     // GIR_Coverage, 62425,
     /*  513862 */     GIR_EraseRootFromParent_Done,
     /*  513863 */   // Label 8572: @513863
     /*  513863 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(513931), // Rule ID 62426 //
     /*  513868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513900 */     // MIs[0] policy
     /*  513900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  513913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513927 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513929 */     GIR_RootConstrainSelectedInstOperands,
     /*  513930 */     // GIR_Coverage, 62426,
     /*  513930 */     GIR_EraseRootFromParent_Done,
     /*  513931 */   // Label 8573: @513931
     /*  513931 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(513999), // Rule ID 62427 //
     /*  513936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513968 */     // MIs[0] policy
     /*  513968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  513981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513995 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513997 */     GIR_RootConstrainSelectedInstOperands,
     /*  513998 */     // GIR_Coverage, 62427,
     /*  513998 */     GIR_EraseRootFromParent_Done,
     /*  513999 */   // Label 8574: @513999
     /*  513999 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(514067), // Rule ID 62428 //
     /*  514004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  514007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  514024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514036 */     // MIs[0] policy
     /*  514036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  514046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  514049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514063 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514065 */     GIR_RootConstrainSelectedInstOperands,
     /*  514066 */     // GIR_Coverage, 62428,
     /*  514066 */     GIR_EraseRootFromParent_Done,
     /*  514067 */   // Label 8575: @514067
     /*  514067 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(514135), // Rule ID 62429 //
     /*  514072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  514075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  514080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  514083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  514086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  514089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  514092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514104 */     // MIs[0] policy
     /*  514104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  514107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514114 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11559:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  514114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  514117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  514119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  514121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514131 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  514133 */     GIR_RootConstrainSelectedInstOperands,
     /*  514134 */     // GIR_Coverage, 62429,
     /*  514134 */     GIR_EraseRootFromParent_Done,
     /*  514135 */   // Label 8576: @514135
     /*  514135 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(514206), // Rule ID 2704 //
     /*  514140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514172 */     // MIs[0] round
     /*  514172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514182 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  514185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514191 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514204 */     GIR_RootConstrainSelectedInstOperands,
     /*  514205 */     // GIR_Coverage, 2704,
     /*  514205 */     GIR_EraseRootFromParent_Done,
     /*  514206 */   // Label 8577: @514206
     /*  514206 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(514277), // Rule ID 2705 //
     /*  514211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514243 */     // MIs[0] round
     /*  514243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514253 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  514256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514262 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514275 */     GIR_RootConstrainSelectedInstOperands,
     /*  514276 */     // GIR_Coverage, 2705,
     /*  514276 */     GIR_EraseRootFromParent_Done,
     /*  514277 */   // Label 8578: @514277
     /*  514277 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(514348), // Rule ID 2740 //
     /*  514282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  514285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  514290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514314 */     // MIs[0] round
     /*  514314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  514327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514333 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514346 */     GIR_RootConstrainSelectedInstOperands,
     /*  514347 */     // GIR_Coverage, 2740,
     /*  514347 */     GIR_EraseRootFromParent_Done,
     /*  514348 */   // Label 8579: @514348
     /*  514348 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(514419), // Rule ID 2741 //
     /*  514353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  514356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  514361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  514364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  514367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  514370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514385 */     // MIs[0] round
     /*  514385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514395 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  514398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514404 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514417 */     GIR_RootConstrainSelectedInstOperands,
     /*  514418 */     // GIR_Coverage, 2741,
     /*  514418 */     GIR_EraseRootFromParent_Done,
     /*  514419 */   // Label 8580: @514419
     /*  514419 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(514490), // Rule ID 18998 //
     /*  514424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  514435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514456 */     // MIs[0] round
     /*  514456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514466 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  514469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514475 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514488 */     GIR_RootConstrainSelectedInstOperands,
     /*  514489 */     // GIR_Coverage, 18998,
     /*  514489 */     GIR_EraseRootFromParent_Done,
     /*  514490 */   // Label 8581: @514490
     /*  514490 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(514561), // Rule ID 18999 //
     /*  514495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  514506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514527 */     // MIs[0] round
     /*  514527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514537 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  514540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514546 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514559 */     GIR_RootConstrainSelectedInstOperands,
     /*  514560 */     // GIR_Coverage, 18999,
     /*  514560 */     GIR_EraseRootFromParent_Done,
     /*  514561 */   // Label 8582: @514561
     /*  514561 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(514632), // Rule ID 19002 //
     /*  514566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  514569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  514577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  514580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514598 */     // MIs[0] round
     /*  514598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  514608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  514611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514617 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514630 */     GIR_RootConstrainSelectedInstOperands,
     /*  514631 */     // GIR_Coverage, 19002,
     /*  514631 */     GIR_EraseRootFromParent_Done,
     /*  514632 */   // Label 8583: @514632
     /*  514632 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(514703), // Rule ID 19003 //
     /*  514637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  514640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  514648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  514651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514669 */     // MIs[0] round
     /*  514669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514679 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  514679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  514682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514688 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514701 */     GIR_RootConstrainSelectedInstOperands,
     /*  514702 */     // GIR_Coverage, 19003,
     /*  514702 */     GIR_EraseRootFromParent_Done,
     /*  514703 */   // Label 8584: @514703
     /*  514703 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(514774), // Rule ID 19006 //
     /*  514708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  514719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  514722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  514725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514740 */     // MIs[0] round
     /*  514740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514750 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  514753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514759 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514772 */     GIR_RootConstrainSelectedInstOperands,
     /*  514773 */     // GIR_Coverage, 19006,
     /*  514773 */     GIR_EraseRootFromParent_Done,
     /*  514774 */   // Label 8585: @514774
     /*  514774 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(514845), // Rule ID 19007 //
     /*  514779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  514790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  514793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  514796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514811 */     // MIs[0] round
     /*  514811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514821 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11275:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  514824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514830 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514843 */     GIR_RootConstrainSelectedInstOperands,
     /*  514844 */     // GIR_Coverage, 19007,
     /*  514844 */     GIR_EraseRootFromParent_Done,
     /*  514845 */   // Label 8586: @514845
     /*  514845 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(514916), // Rule ID 19010 //
     /*  514850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  514853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  514861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  514864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514882 */     // MIs[0] round
     /*  514882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514892 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  514892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  514895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514901 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514914 */     GIR_RootConstrainSelectedInstOperands,
     /*  514915 */     // GIR_Coverage, 19010,
     /*  514915 */     GIR_EraseRootFromParent_Done,
     /*  514916 */   // Label 8587: @514916
     /*  514916 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(514987), // Rule ID 19011 //
     /*  514921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  514924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  514932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  514935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514953 */     // MIs[0] round
     /*  514953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514963 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11275:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  514963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  514966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514972 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514985 */     GIR_RootConstrainSelectedInstOperands,
     /*  514986 */     // GIR_Coverage, 19011,
     /*  514986 */     GIR_EraseRootFromParent_Done,
     /*  514987 */   // Label 8588: @514987
     /*  514987 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(515058), // Rule ID 19014 //
     /*  514992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  514995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  515003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515024 */     // MIs[0] round
     /*  515024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515034 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  515034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  515037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515043 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515056 */     GIR_RootConstrainSelectedInstOperands,
     /*  515057 */     // GIR_Coverage, 19014,
     /*  515057 */     GIR_EraseRootFromParent_Done,
     /*  515058 */   // Label 8589: @515058
     /*  515058 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(515129), // Rule ID 19015 //
     /*  515063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  515066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  515074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  515077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  515080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515095 */     // MIs[0] round
     /*  515095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515105 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11275:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  515105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  515108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515114 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515127 */     GIR_RootConstrainSelectedInstOperands,
     /*  515128 */     // GIR_Coverage, 19015,
     /*  515128 */     GIR_EraseRootFromParent_Done,
     /*  515129 */   // Label 8590: @515129
     /*  515129 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(515200), // Rule ID 19018 //
     /*  515134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  515145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  515148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  515151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515166 */     // MIs[0] round
     /*  515166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515176 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  515179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515185 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515198 */     GIR_RootConstrainSelectedInstOperands,
     /*  515199 */     // GIR_Coverage, 19018,
     /*  515199 */     GIR_EraseRootFromParent_Done,
     /*  515200 */   // Label 8591: @515200
     /*  515200 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(515271), // Rule ID 19019 //
     /*  515205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  515216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  515219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  515222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515237 */     // MIs[0] round
     /*  515237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515247 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  515250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515256 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515269 */     GIR_RootConstrainSelectedInstOperands,
     /*  515270 */     // GIR_Coverage, 19019,
     /*  515270 */     GIR_EraseRootFromParent_Done,
     /*  515271 */   // Label 8592: @515271
     /*  515271 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(515342), // Rule ID 19022 //
     /*  515276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  515287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  515290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  515293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515308 */     // MIs[0] round
     /*  515308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515318 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  515321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515327 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515340 */     GIR_RootConstrainSelectedInstOperands,
     /*  515341 */     // GIR_Coverage, 19022,
     /*  515341 */     GIR_EraseRootFromParent_Done,
     /*  515342 */   // Label 8593: @515342
     /*  515342 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(515413), // Rule ID 19023 //
     /*  515347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  515358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  515361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  515364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515379 */     // MIs[0] round
     /*  515379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515389 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  515392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515398 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515411 */     GIR_RootConstrainSelectedInstOperands,
     /*  515412 */     // GIR_Coverage, 19023,
     /*  515412 */     GIR_EraseRootFromParent_Done,
     /*  515413 */   // Label 8594: @515413
     /*  515413 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(515484), // Rule ID 19026 //
     /*  515418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  515429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  515432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  515435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515450 */     // MIs[0] round
     /*  515450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515460 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  515463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515469 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515482 */     GIR_RootConstrainSelectedInstOperands,
     /*  515483 */     // GIR_Coverage, 19026,
     /*  515483 */     GIR_EraseRootFromParent_Done,
     /*  515484 */   // Label 8595: @515484
     /*  515484 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(515555), // Rule ID 19027 //
     /*  515489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  515500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  515503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  515506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515521 */     // MIs[0] round
     /*  515521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515531 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  515534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515540 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515553 */     GIR_RootConstrainSelectedInstOperands,
     /*  515554 */     // GIR_Coverage, 19027,
     /*  515554 */     GIR_EraseRootFromParent_Done,
     /*  515555 */   // Label 8596: @515555
     /*  515555 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(515626), // Rule ID 19030 //
     /*  515560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515592 */     // MIs[0] round
     /*  515592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515602 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  515605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515611 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515624 */     GIR_RootConstrainSelectedInstOperands,
     /*  515625 */     // GIR_Coverage, 19030,
     /*  515625 */     GIR_EraseRootFromParent_Done,
     /*  515626 */   // Label 8597: @515626
     /*  515626 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(515697), // Rule ID 19031 //
     /*  515631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515663 */     // MIs[0] round
     /*  515663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515673 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  515676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515682 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515695 */     GIR_RootConstrainSelectedInstOperands,
     /*  515696 */     // GIR_Coverage, 19031,
     /*  515696 */     GIR_EraseRootFromParent_Done,
     /*  515697 */   // Label 8598: @515697
     /*  515697 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(515768), // Rule ID 19034 //
     /*  515702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515734 */     // MIs[0] round
     /*  515734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515744 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  515747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515753 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515766 */     GIR_RootConstrainSelectedInstOperands,
     /*  515767 */     // GIR_Coverage, 19034,
     /*  515767 */     GIR_EraseRootFromParent_Done,
     /*  515768 */   // Label 8599: @515768
     /*  515768 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(515839), // Rule ID 19035 //
     /*  515773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515805 */     // MIs[0] round
     /*  515805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515815 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  515818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515824 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515837 */     GIR_RootConstrainSelectedInstOperands,
     /*  515838 */     // GIR_Coverage, 19035,
     /*  515838 */     GIR_EraseRootFromParent_Done,
     /*  515839 */   // Label 8600: @515839
     /*  515839 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(515910), // Rule ID 19038 //
     /*  515844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  515861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515876 */     // MIs[0] round
     /*  515876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515886 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  515889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515895 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515908 */     GIR_RootConstrainSelectedInstOperands,
     /*  515909 */     // GIR_Coverage, 19038,
     /*  515909 */     GIR_EraseRootFromParent_Done,
     /*  515910 */   // Label 8601: @515910
     /*  515910 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(515981), // Rule ID 19039 //
     /*  515915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  515932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515947 */     // MIs[0] round
     /*  515947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515957 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  515960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515966 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515979 */     GIR_RootConstrainSelectedInstOperands,
     /*  515980 */     // GIR_Coverage, 19039,
     /*  515980 */     GIR_EraseRootFromParent_Done,
     /*  515981 */   // Label 8602: @515981
     /*  515981 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(516052), // Rule ID 19042 //
     /*  515986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  515989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  515997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  516000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  516003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516018 */     // MIs[0] round
     /*  516018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516028 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  516031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516037 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516050 */     GIR_RootConstrainSelectedInstOperands,
     /*  516051 */     // GIR_Coverage, 19042,
     /*  516051 */     GIR_EraseRootFromParent_Done,
     /*  516052 */   // Label 8603: @516052
     /*  516052 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(516123), // Rule ID 19043 //
     /*  516057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  516068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  516071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  516074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516089 */     // MIs[0] round
     /*  516089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516099 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11275:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  516102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516108 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516121 */     GIR_RootConstrainSelectedInstOperands,
     /*  516122 */     // GIR_Coverage, 19043,
     /*  516122 */     GIR_EraseRootFromParent_Done,
     /*  516123 */   // Label 8604: @516123
     /*  516123 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(516194), // Rule ID 19046 //
     /*  516128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  516139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  516142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  516145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516160 */     // MIs[0] round
     /*  516160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516170 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  516173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516179 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516192 */     GIR_RootConstrainSelectedInstOperands,
     /*  516193 */     // GIR_Coverage, 19046,
     /*  516193 */     GIR_EraseRootFromParent_Done,
     /*  516194 */   // Label 8605: @516194
     /*  516194 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(516265), // Rule ID 19047 //
     /*  516199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  516210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  516213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  516216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516231 */     // MIs[0] round
     /*  516231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516241 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11275:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  516244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516250 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516263 */     GIR_RootConstrainSelectedInstOperands,
     /*  516264 */     // GIR_Coverage, 19047,
     /*  516264 */     GIR_EraseRootFromParent_Done,
     /*  516265 */   // Label 8606: @516265
     /*  516265 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(516336), // Rule ID 19050 //
     /*  516270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  516281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  516284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  516287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516302 */     // MIs[0] round
     /*  516302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516312 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  516315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516321 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516334 */     GIR_RootConstrainSelectedInstOperands,
     /*  516335 */     // GIR_Coverage, 19050,
     /*  516335 */     GIR_EraseRootFromParent_Done,
     /*  516336 */   // Label 8607: @516336
     /*  516336 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(516407), // Rule ID 19051 //
     /*  516341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  516349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  516352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  516355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  516358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  516373 */     // MIs[0] round
     /*  516373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516383 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11275:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  516386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516392 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516405 */     GIR_RootConstrainSelectedInstOperands,
     /*  516406 */     // GIR_Coverage, 19051,
     /*  516406 */     GIR_EraseRootFromParent_Done,
     /*  516407 */   // Label 8608: @516407
     /*  516407 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(516478), // Rule ID 19110 //
     /*  516412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  516423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  516426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  516429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516444 */     // MIs[0] round
     /*  516444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516454 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  516457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516463 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516476 */     GIR_RootConstrainSelectedInstOperands,
     /*  516477 */     // GIR_Coverage, 19110,
     /*  516477 */     GIR_EraseRootFromParent_Done,
     /*  516478 */   // Label 8609: @516478
     /*  516478 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(516549), // Rule ID 19111 //
     /*  516483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  516494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  516497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  516500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516515 */     // MIs[0] round
     /*  516515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516525 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  516528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516534 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516547 */     GIR_RootConstrainSelectedInstOperands,
     /*  516548 */     // GIR_Coverage, 19111,
     /*  516548 */     GIR_EraseRootFromParent_Done,
     /*  516549 */   // Label 8610: @516549
     /*  516549 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(516620), // Rule ID 19114 //
     /*  516554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  516565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  516568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  516571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516586 */     // MIs[0] round
     /*  516586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516596 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  516599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516605 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516618 */     GIR_RootConstrainSelectedInstOperands,
     /*  516619 */     // GIR_Coverage, 19114,
     /*  516619 */     GIR_EraseRootFromParent_Done,
     /*  516620 */   // Label 8611: @516620
     /*  516620 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(516691), // Rule ID 19115 //
     /*  516625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  516636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  516639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  516642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516657 */     // MIs[0] round
     /*  516657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516667 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  516670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516676 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516689 */     GIR_RootConstrainSelectedInstOperands,
     /*  516690 */     // GIR_Coverage, 19115,
     /*  516690 */     GIR_EraseRootFromParent_Done,
     /*  516691 */   // Label 8612: @516691
     /*  516691 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(516762), // Rule ID 19118 //
     /*  516696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516728 */     // MIs[0] round
     /*  516728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516738 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  516741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516747 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516760 */     GIR_RootConstrainSelectedInstOperands,
     /*  516761 */     // GIR_Coverage, 19118,
     /*  516761 */     GIR_EraseRootFromParent_Done,
     /*  516762 */   // Label 8613: @516762
     /*  516762 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(516833), // Rule ID 19119 //
     /*  516767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516799 */     // MIs[0] round
     /*  516799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516809 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  516812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516818 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516831 */     GIR_RootConstrainSelectedInstOperands,
     /*  516832 */     // GIR_Coverage, 19119,
     /*  516832 */     GIR_EraseRootFromParent_Done,
     /*  516833 */   // Label 8614: @516833
     /*  516833 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(516904), // Rule ID 19122 //
     /*  516838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  516849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  516852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  516855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516870 */     // MIs[0] round
     /*  516870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516880 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  516883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516889 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516902 */     GIR_RootConstrainSelectedInstOperands,
     /*  516903 */     // GIR_Coverage, 19122,
     /*  516903 */     GIR_EraseRootFromParent_Done,
     /*  516904 */   // Label 8615: @516904
     /*  516904 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(516975), // Rule ID 19123 //
     /*  516909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  516920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  516923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  516926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516941 */     // MIs[0] round
     /*  516941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516951 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11251:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  516954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516960 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516973 */     GIR_RootConstrainSelectedInstOperands,
     /*  516974 */     // GIR_Coverage, 19123,
     /*  516974 */     GIR_EraseRootFromParent_Done,
     /*  516975 */   // Label 8616: @516975
     /*  516975 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(517046), // Rule ID 19126 //
     /*  516980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517012 */     // MIs[0] round
     /*  517012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517022 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  517025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517031 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517044 */     GIR_RootConstrainSelectedInstOperands,
     /*  517045 */     // GIR_Coverage, 19126,
     /*  517045 */     GIR_EraseRootFromParent_Done,
     /*  517046 */   // Label 8617: @517046
     /*  517046 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(517117), // Rule ID 19127 //
     /*  517051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  517062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  517065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  517068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517083 */     // MIs[0] round
     /*  517083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517093 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  517096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517102 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517115 */     GIR_RootConstrainSelectedInstOperands,
     /*  517116 */     // GIR_Coverage, 19127,
     /*  517116 */     GIR_EraseRootFromParent_Done,
     /*  517117 */   // Label 8618: @517117
     /*  517117 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(517188), // Rule ID 19130 //
     /*  517122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  517125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  517133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  517136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  517139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517154 */     // MIs[0] round
     /*  517154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517164 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  517164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  517167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517173 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517186 */     GIR_RootConstrainSelectedInstOperands,
     /*  517187 */     // GIR_Coverage, 19130,
     /*  517187 */     GIR_EraseRootFromParent_Done,
     /*  517188 */   // Label 8619: @517188
     /*  517188 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(517259), // Rule ID 19131 //
     /*  517193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  517196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  517204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  517207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  517210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  517225 */     // MIs[0] round
     /*  517225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517235 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  517235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  517238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517244 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517257 */     GIR_RootConstrainSelectedInstOperands,
     /*  517258 */     // GIR_Coverage, 19131,
     /*  517258 */     GIR_EraseRootFromParent_Done,
     /*  517259 */   // Label 8620: @517259
     /*  517259 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(517330), // Rule ID 19134 //
     /*  517264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  517275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  517278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  517281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517296 */     // MIs[0] round
     /*  517296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517306 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  517309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517315 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517328 */     GIR_RootConstrainSelectedInstOperands,
     /*  517329 */     // GIR_Coverage, 19134,
     /*  517329 */     GIR_EraseRootFromParent_Done,
     /*  517330 */   // Label 8621: @517330
     /*  517330 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(517401), // Rule ID 19135 //
     /*  517335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  517346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  517349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  517352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517367 */     // MIs[0] round
     /*  517367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517377 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  517380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517386 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517399 */     GIR_RootConstrainSelectedInstOperands,
     /*  517400 */     // GIR_Coverage, 19135,
     /*  517400 */     GIR_EraseRootFromParent_Done,
     /*  517401 */   // Label 8622: @517401
     /*  517401 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(517472), // Rule ID 19138 //
     /*  517406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  517417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  517420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  517423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517438 */     // MIs[0] round
     /*  517438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517448 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  517451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517457 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517470 */     GIR_RootConstrainSelectedInstOperands,
     /*  517471 */     // GIR_Coverage, 19138,
     /*  517471 */     GIR_EraseRootFromParent_Done,
     /*  517472 */   // Label 8623: @517472
     /*  517472 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(517543), // Rule ID 19139 //
     /*  517477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  517488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  517491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  517494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517509 */     // MIs[0] round
     /*  517509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517519 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  517522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517528 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517541 */     GIR_RootConstrainSelectedInstOperands,
     /*  517542 */     // GIR_Coverage, 19139,
     /*  517542 */     GIR_EraseRootFromParent_Done,
     /*  517543 */   // Label 8624: @517543
     /*  517543 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(517614), // Rule ID 19142 //
     /*  517548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  517559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  517562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  517565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517580 */     // MIs[0] round
     /*  517580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517590 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  517593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517599 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517612 */     GIR_RootConstrainSelectedInstOperands,
     /*  517613 */     // GIR_Coverage, 19142,
     /*  517613 */     GIR_EraseRootFromParent_Done,
     /*  517614 */   // Label 8625: @517614
     /*  517614 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(517685), // Rule ID 19143 //
     /*  517619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  517630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  517633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  517636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517651 */     // MIs[0] round
     /*  517651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517661 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  517664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517670 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517683 */     GIR_RootConstrainSelectedInstOperands,
     /*  517684 */     // GIR_Coverage, 19143,
     /*  517684 */     GIR_EraseRootFromParent_Done,
     /*  517685 */   // Label 8626: @517685
     /*  517685 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(517756), // Rule ID 19146 //
     /*  517690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  517701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  517704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517722 */     // MIs[0] round
     /*  517722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517732 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  517735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517741 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517754 */     GIR_RootConstrainSelectedInstOperands,
     /*  517755 */     // GIR_Coverage, 19146,
     /*  517755 */     GIR_EraseRootFromParent_Done,
     /*  517756 */   // Label 8627: @517756
     /*  517756 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(517827), // Rule ID 19147 //
     /*  517761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  517772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  517775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517793 */     // MIs[0] round
     /*  517793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517803 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  517806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517812 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517825 */     GIR_RootConstrainSelectedInstOperands,
     /*  517826 */     // GIR_Coverage, 19147,
     /*  517826 */     GIR_EraseRootFromParent_Done,
     /*  517827 */   // Label 8628: @517827
     /*  517827 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(517898), // Rule ID 19150 //
     /*  517832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517864 */     // MIs[0] round
     /*  517864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517874 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  517877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517883 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517896 */     GIR_RootConstrainSelectedInstOperands,
     /*  517897 */     // GIR_Coverage, 19150,
     /*  517897 */     GIR_EraseRootFromParent_Done,
     /*  517898 */   // Label 8629: @517898
     /*  517898 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(517969), // Rule ID 19151 //
     /*  517903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517935 */     // MIs[0] round
     /*  517935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517945 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  517948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517954 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517967 */     GIR_RootConstrainSelectedInstOperands,
     /*  517968 */     // GIR_Coverage, 19151,
     /*  517968 */     GIR_EraseRootFromParent_Done,
     /*  517969 */   // Label 8630: @517969
     /*  517969 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(518040), // Rule ID 19154 //
     /*  517974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  517991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518006 */     // MIs[0] round
     /*  518006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518016 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  518019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518025 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518038 */     GIR_RootConstrainSelectedInstOperands,
     /*  518039 */     // GIR_Coverage, 19154,
     /*  518039 */     GIR_EraseRootFromParent_Done,
     /*  518040 */   // Label 8631: @518040
     /*  518040 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(518111), // Rule ID 19155 //
     /*  518045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  518048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  518056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  518059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  518062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518077 */     // MIs[0] round
     /*  518077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518087 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  518090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518096 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518109 */     GIR_RootConstrainSelectedInstOperands,
     /*  518110 */     // GIR_Coverage, 19155,
     /*  518110 */     GIR_EraseRootFromParent_Done,
     /*  518111 */   // Label 8632: @518111
     /*  518111 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(518182), // Rule ID 19158 //
     /*  518116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  518127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  518130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  518133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518148 */     // MIs[0] round
     /*  518148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518158 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  518161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518167 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518180 */     GIR_RootConstrainSelectedInstOperands,
     /*  518181 */     // GIR_Coverage, 19158,
     /*  518181 */     GIR_EraseRootFromParent_Done,
     /*  518182 */   // Label 8633: @518182
     /*  518182 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(518253), // Rule ID 19159 //
     /*  518187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  518198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  518201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  518204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518219 */     // MIs[0] round
     /*  518219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518229 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  518232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518238 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518251 */     GIR_RootConstrainSelectedInstOperands,
     /*  518252 */     // GIR_Coverage, 19159,
     /*  518252 */     GIR_EraseRootFromParent_Done,
     /*  518253 */   // Label 8634: @518253
     /*  518253 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(518324), // Rule ID 19162 //
     /*  518258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  518269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  518272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  518275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518290 */     // MIs[0] round
     /*  518290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518300 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  518303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518309 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518322 */     GIR_RootConstrainSelectedInstOperands,
     /*  518323 */     // GIR_Coverage, 19162,
     /*  518323 */     GIR_EraseRootFromParent_Done,
     /*  518324 */   // Label 8635: @518324
     /*  518324 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(518395), // Rule ID 19163 //
     /*  518329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  518340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  518343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  518346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518361 */     // MIs[0] round
     /*  518361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518371 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  518374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518380 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518393 */     GIR_RootConstrainSelectedInstOperands,
     /*  518394 */     // GIR_Coverage, 19163,
     /*  518394 */     GIR_EraseRootFromParent_Done,
     /*  518395 */   // Label 8636: @518395
     /*  518395 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(518466), // Rule ID 19166 //
     /*  518400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  518403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  518411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  518414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  518417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518432 */     // MIs[0] round
     /*  518432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518442 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  518445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518451 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518464 */     GIR_RootConstrainSelectedInstOperands,
     /*  518465 */     // GIR_Coverage, 19166,
     /*  518465 */     GIR_EraseRootFromParent_Done,
     /*  518466 */   // Label 8637: @518466
     /*  518466 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(518537), // Rule ID 19167 //
     /*  518471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  518474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  518479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  518482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  518485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  518488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  518503 */     // MIs[0] round
     /*  518503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518513 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  518516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518522 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518535 */     GIR_RootConstrainSelectedInstOperands,
     /*  518536 */     // GIR_Coverage, 19167,
     /*  518536 */     GIR_EraseRootFromParent_Done,
     /*  518537 */   // Label 8638: @518537
     /*  518537 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(518608), // Rule ID 20752 //
     /*  518542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518574 */     // MIs[0] round
     /*  518574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518584 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518593 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518606 */     GIR_RootConstrainSelectedInstOperands,
     /*  518607 */     // GIR_Coverage, 20752,
     /*  518607 */     GIR_EraseRootFromParent_Done,
     /*  518608 */   // Label 8639: @518608
     /*  518608 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(518679), // Rule ID 20753 //
     /*  518613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518645 */     // MIs[0] round
     /*  518645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518655 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518664 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518677 */     GIR_RootConstrainSelectedInstOperands,
     /*  518678 */     // GIR_Coverage, 20753,
     /*  518678 */     GIR_EraseRootFromParent_Done,
     /*  518679 */   // Label 8640: @518679
     /*  518679 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(518750), // Rule ID 20756 //
     /*  518684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  518687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518716 */     // MIs[0] round
     /*  518716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518735 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518748 */     GIR_RootConstrainSelectedInstOperands,
     /*  518749 */     // GIR_Coverage, 20756,
     /*  518749 */     GIR_EraseRootFromParent_Done,
     /*  518750 */   // Label 8641: @518750
     /*  518750 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(518821), // Rule ID 20757 //
     /*  518755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  518758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518787 */     // MIs[0] round
     /*  518787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518797 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518806 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518819 */     GIR_RootConstrainSelectedInstOperands,
     /*  518820 */     // GIR_Coverage, 20757,
     /*  518820 */     GIR_EraseRootFromParent_Done,
     /*  518821 */   // Label 8642: @518821
     /*  518821 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(518892), // Rule ID 20760 //
     /*  518826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518858 */     // MIs[0] round
     /*  518858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518877 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518890 */     GIR_RootConstrainSelectedInstOperands,
     /*  518891 */     // GIR_Coverage, 20760,
     /*  518891 */     GIR_EraseRootFromParent_Done,
     /*  518892 */   // Label 8643: @518892
     /*  518892 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(518963), // Rule ID 20761 //
     /*  518897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518929 */     // MIs[0] round
     /*  518929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518939 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518948 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518961 */     GIR_RootConstrainSelectedInstOperands,
     /*  518962 */     // GIR_Coverage, 20761,
     /*  518962 */     GIR_EraseRootFromParent_Done,
     /*  518963 */   // Label 8644: @518963
     /*  518963 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(519034), // Rule ID 20764 //
     /*  518968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  518971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  518979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  518985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519000 */     // MIs[0] round
     /*  519000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519010 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519019 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519032 */     GIR_RootConstrainSelectedInstOperands,
     /*  519033 */     // GIR_Coverage, 20764,
     /*  519033 */     GIR_EraseRootFromParent_Done,
     /*  519034 */   // Label 8645: @519034
     /*  519034 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(519105), // Rule ID 20765 //
     /*  519039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  519050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  519053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  519056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519071 */     // MIs[0] round
     /*  519071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519081 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519090 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519103 */     GIR_RootConstrainSelectedInstOperands,
     /*  519104 */     // GIR_Coverage, 20765,
     /*  519104 */     GIR_EraseRootFromParent_Done,
     /*  519105 */   // Label 8646: @519105
     /*  519105 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(519176), // Rule ID 20768 //
     /*  519110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  519113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  519121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  519124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  519127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519142 */     // MIs[0] round
     /*  519142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  519152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519161 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519174 */     GIR_RootConstrainSelectedInstOperands,
     /*  519175 */     // GIR_Coverage, 20768,
     /*  519175 */     GIR_EraseRootFromParent_Done,
     /*  519176 */   // Label 8647: @519176
     /*  519176 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(519247), // Rule ID 20769 //
     /*  519181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  519184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  519192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  519195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  519198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  519213 */     // MIs[0] round
     /*  519213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519223 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  519223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  519226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519232 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519245 */     GIR_RootConstrainSelectedInstOperands,
     /*  519246 */     // GIR_Coverage, 20769,
     /*  519246 */     GIR_EraseRootFromParent_Done,
     /*  519247 */   // Label 8648: @519247
     /*  519247 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(519318), // Rule ID 20772 //
     /*  519252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519284 */     // MIs[0] round
     /*  519284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519303 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519316 */     GIR_RootConstrainSelectedInstOperands,
     /*  519317 */     // GIR_Coverage, 20772,
     /*  519317 */     GIR_EraseRootFromParent_Done,
     /*  519318 */   // Label 8649: @519318
     /*  519318 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(519389), // Rule ID 20773 //
     /*  519323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  519334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  519337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  519340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519355 */     // MIs[0] round
     /*  519355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519365 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519374 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519387 */     GIR_RootConstrainSelectedInstOperands,
     /*  519388 */     // GIR_Coverage, 20773,
     /*  519388 */     GIR_EraseRootFromParent_Done,
     /*  519389 */   // Label 8650: @519389
     /*  519389 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(519460), // Rule ID 20776 //
     /*  519394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519426 */     // MIs[0] round
     /*  519426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519445 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519458 */     GIR_RootConstrainSelectedInstOperands,
     /*  519459 */     // GIR_Coverage, 20776,
     /*  519459 */     GIR_EraseRootFromParent_Done,
     /*  519460 */   // Label 8651: @519460
     /*  519460 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(519531), // Rule ID 20777 //
     /*  519465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  519476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  519479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  519482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519497 */     // MIs[0] round
     /*  519497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519507 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519516 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519529 */     GIR_RootConstrainSelectedInstOperands,
     /*  519530 */     // GIR_Coverage, 20777,
     /*  519530 */     GIR_EraseRootFromParent_Done,
     /*  519531 */   // Label 8652: @519531
     /*  519531 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(519602), // Rule ID 20780 //
     /*  519536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519568 */     // MIs[0] round
     /*  519568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519578 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519587 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519600 */     GIR_RootConstrainSelectedInstOperands,
     /*  519601 */     // GIR_Coverage, 20780,
     /*  519601 */     GIR_EraseRootFromParent_Done,
     /*  519602 */   // Label 8653: @519602
     /*  519602 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(519673), // Rule ID 20781 //
     /*  519607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519639 */     // MIs[0] round
     /*  519639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519649 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519658 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519671 */     GIR_RootConstrainSelectedInstOperands,
     /*  519672 */     // GIR_Coverage, 20781,
     /*  519672 */     GIR_EraseRootFromParent_Done,
     /*  519673 */   // Label 8654: @519673
     /*  519673 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(519744), // Rule ID 20784 //
     /*  519678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519710 */     // MIs[0] round
     /*  519710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519720 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519729 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519742 */     GIR_RootConstrainSelectedInstOperands,
     /*  519743 */     // GIR_Coverage, 20784,
     /*  519743 */     GIR_EraseRootFromParent_Done,
     /*  519744 */   // Label 8655: @519744
     /*  519744 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(519815), // Rule ID 20785 //
     /*  519749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519781 */     // MIs[0] round
     /*  519781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519800 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519813 */     GIR_RootConstrainSelectedInstOperands,
     /*  519814 */     // GIR_Coverage, 20785,
     /*  519814 */     GIR_EraseRootFromParent_Done,
     /*  519815 */   // Label 8656: @519815
     /*  519815 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(519886), // Rule ID 20788 //
     /*  519820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519852 */     // MIs[0] round
     /*  519852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519871 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519884 */     GIR_RootConstrainSelectedInstOperands,
     /*  519885 */     // GIR_Coverage, 20788,
     /*  519885 */     GIR_EraseRootFromParent_Done,
     /*  519886 */   // Label 8657: @519886
     /*  519886 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(519957), // Rule ID 20789 //
     /*  519891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519923 */     // MIs[0] round
     /*  519923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519933 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519942 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519955 */     GIR_RootConstrainSelectedInstOperands,
     /*  519956 */     // GIR_Coverage, 20789,
     /*  519956 */     GIR_EraseRootFromParent_Done,
     /*  519957 */   // Label 8658: @519957
     /*  519957 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(520028), // Rule ID 20792 //
     /*  519962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  519973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  519976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  519979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519994 */     // MIs[0] round
     /*  519994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520004 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520013 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520026 */     GIR_RootConstrainSelectedInstOperands,
     /*  520027 */     // GIR_Coverage, 20792,
     /*  520027 */     GIR_EraseRootFromParent_Done,
     /*  520028 */   // Label 8659: @520028
     /*  520028 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(520099), // Rule ID 20793 //
     /*  520033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  520044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  520047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  520050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520065 */     // MIs[0] round
     /*  520065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520084 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520097 */     GIR_RootConstrainSelectedInstOperands,
     /*  520098 */     // GIR_Coverage, 20793,
     /*  520098 */     GIR_EraseRootFromParent_Done,
     /*  520099 */   // Label 8660: @520099
     /*  520099 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(520170), // Rule ID 20796 //
     /*  520104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  520115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  520121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520136 */     // MIs[0] round
     /*  520136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520146 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520155 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520168 */     GIR_RootConstrainSelectedInstOperands,
     /*  520169 */     // GIR_Coverage, 20796,
     /*  520169 */     GIR_EraseRootFromParent_Done,
     /*  520170 */   // Label 8661: @520170
     /*  520170 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(520241), // Rule ID 20797 //
     /*  520175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  520186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  520189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  520192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520207 */     // MIs[0] round
     /*  520207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520217 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  520220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520226 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520239 */     GIR_RootConstrainSelectedInstOperands,
     /*  520240 */     // GIR_Coverage, 20797,
     /*  520240 */     GIR_EraseRootFromParent_Done,
     /*  520241 */   // Label 8662: @520241
     /*  520241 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(520312), // Rule ID 20800 //
     /*  520246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520278 */     // MIs[0] round
     /*  520278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520288 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520297 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520310 */     GIR_RootConstrainSelectedInstOperands,
     /*  520311 */     // GIR_Coverage, 20800,
     /*  520311 */     GIR_EraseRootFromParent_Done,
     /*  520312 */   // Label 8663: @520312
     /*  520312 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(520383), // Rule ID 20801 //
     /*  520317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  520328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  520331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  520334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  520349 */     // MIs[0] round
     /*  520349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  520362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520368 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520381 */     GIR_RootConstrainSelectedInstOperands,
     /*  520382 */     // GIR_Coverage, 20801,
     /*  520382 */     GIR_EraseRootFromParent_Done,
     /*  520383 */   // Label 8664: @520383
     /*  520383 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(520454), // Rule ID 20804 //
     /*  520388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520420 */     // MIs[0] round
     /*  520420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520430 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520439 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520452 */     GIR_RootConstrainSelectedInstOperands,
     /*  520453 */     // GIR_Coverage, 20804,
     /*  520453 */     GIR_EraseRootFromParent_Done,
     /*  520454 */   // Label 8665: @520454
     /*  520454 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(520525), // Rule ID 20805 //
     /*  520459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  520467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  520470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  520473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  520476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  520491 */     // MIs[0] round
     /*  520491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520501 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  520504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520510 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520523 */     GIR_RootConstrainSelectedInstOperands,
     /*  520524 */     // GIR_Coverage, 20805,
     /*  520524 */     GIR_EraseRootFromParent_Done,
     /*  520525 */   // Label 8666: @520525
     /*  520525 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(520596), // Rule ID 20808 //
     /*  520530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520562 */     // MIs[0] round
     /*  520562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520572 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  520575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520581 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520594 */     GIR_RootConstrainSelectedInstOperands,
     /*  520595 */     // GIR_Coverage, 20808,
     /*  520595 */     GIR_EraseRootFromParent_Done,
     /*  520596 */   // Label 8667: @520596
     /*  520596 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(520667), // Rule ID 20809 //
     /*  520601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520633 */     // MIs[0] round
     /*  520633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520643 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  520646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520652 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520665 */     GIR_RootConstrainSelectedInstOperands,
     /*  520666 */     // GIR_Coverage, 20809,
     /*  520666 */     GIR_EraseRootFromParent_Done,
     /*  520667 */   // Label 8668: @520667
     /*  520667 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(520738), // Rule ID 20812 //
     /*  520672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520704 */     // MIs[0] round
     /*  520704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520714 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520723 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520736 */     GIR_RootConstrainSelectedInstOperands,
     /*  520737 */     // GIR_Coverage, 20812,
     /*  520737 */     GIR_EraseRootFromParent_Done,
     /*  520738 */   // Label 8669: @520738
     /*  520738 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(520809), // Rule ID 20813 //
     /*  520743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520775 */     // MIs[0] round
     /*  520775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520785 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520794 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520807 */     GIR_RootConstrainSelectedInstOperands,
     /*  520808 */     // GIR_Coverage, 20813,
     /*  520808 */     GIR_EraseRootFromParent_Done,
     /*  520809 */   // Label 8670: @520809
     /*  520809 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(520880), // Rule ID 20816 //
     /*  520814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520846 */     // MIs[0] round
     /*  520846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520865 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520878 */     GIR_RootConstrainSelectedInstOperands,
     /*  520879 */     // GIR_Coverage, 20816,
     /*  520879 */     GIR_EraseRootFromParent_Done,
     /*  520880 */   // Label 8671: @520880
     /*  520880 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(520951), // Rule ID 20817 //
     /*  520885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520917 */     // MIs[0] round
     /*  520917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520927 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520936 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520949 */     GIR_RootConstrainSelectedInstOperands,
     /*  520950 */     // GIR_Coverage, 20817,
     /*  520950 */     GIR_EraseRootFromParent_Done,
     /*  520951 */   // Label 8672: @520951
     /*  520951 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(521022), // Rule ID 20820 //
     /*  520956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  520967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  520970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  520973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520988 */     // MIs[0] round
     /*  520988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521007 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521020 */     GIR_RootConstrainSelectedInstOperands,
     /*  521021 */     // GIR_Coverage, 20820,
     /*  521021 */     GIR_EraseRootFromParent_Done,
     /*  521022 */   // Label 8673: @521022
     /*  521022 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(521093), // Rule ID 20821 //
     /*  521027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  521038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  521041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  521044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521059 */     // MIs[0] round
     /*  521059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521069 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521078 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521091 */     GIR_RootConstrainSelectedInstOperands,
     /*  521092 */     // GIR_Coverage, 20821,
     /*  521092 */     GIR_EraseRootFromParent_Done,
     /*  521093 */   // Label 8674: @521093
     /*  521093 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(521164), // Rule ID 20824 //
     /*  521098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521130 */     // MIs[0] round
     /*  521130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521149 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521162 */     GIR_RootConstrainSelectedInstOperands,
     /*  521163 */     // GIR_Coverage, 20824,
     /*  521163 */     GIR_EraseRootFromParent_Done,
     /*  521164 */   // Label 8675: @521164
     /*  521164 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(521235), // Rule ID 20825 //
     /*  521169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  521180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  521183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  521186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521201 */     // MIs[0] round
     /*  521201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521211 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521220 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521233 */     GIR_RootConstrainSelectedInstOperands,
     /*  521234 */     // GIR_Coverage, 20825,
     /*  521234 */     GIR_EraseRootFromParent_Done,
     /*  521235 */   // Label 8676: @521235
     /*  521235 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(521306), // Rule ID 20828 //
     /*  521240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  521243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521272 */     // MIs[0] round
     /*  521272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  521282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521291 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521304 */     GIR_RootConstrainSelectedInstOperands,
     /*  521305 */     // GIR_Coverage, 20828,
     /*  521305 */     GIR_EraseRootFromParent_Done,
     /*  521306 */   // Label 8677: @521306
     /*  521306 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(521377), // Rule ID 20829 //
     /*  521311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  521314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  521322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  521325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  521328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  521343 */     // MIs[0] round
     /*  521343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521353 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  521353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  521356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521362 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521375 */     GIR_RootConstrainSelectedInstOperands,
     /*  521376 */     // GIR_Coverage, 20829,
     /*  521376 */     GIR_EraseRootFromParent_Done,
     /*  521377 */   // Label 8678: @521377
     /*  521377 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(521448), // Rule ID 20832 //
     /*  521382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521414 */     // MIs[0] round
     /*  521414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521433 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521446 */     GIR_RootConstrainSelectedInstOperands,
     /*  521447 */     // GIR_Coverage, 20832,
     /*  521447 */     GIR_EraseRootFromParent_Done,
     /*  521448 */   // Label 8679: @521448
     /*  521448 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(521519), // Rule ID 20833 //
     /*  521453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  521464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  521467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  521470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521485 */     // MIs[0] round
     /*  521485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521495 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521504 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521517 */     GIR_RootConstrainSelectedInstOperands,
     /*  521518 */     // GIR_Coverage, 20833,
     /*  521518 */     GIR_EraseRootFromParent_Done,
     /*  521519 */   // Label 8680: @521519
     /*  521519 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(521590), // Rule ID 20836 //
     /*  521524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521556 */     // MIs[0] round
     /*  521556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521566 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521575 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521588 */     GIR_RootConstrainSelectedInstOperands,
     /*  521589 */     // GIR_Coverage, 20836,
     /*  521589 */     GIR_EraseRootFromParent_Done,
     /*  521590 */   // Label 8681: @521590
     /*  521590 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(521661), // Rule ID 20837 //
     /*  521595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521627 */     // MIs[0] round
     /*  521627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521637 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521646 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521659 */     GIR_RootConstrainSelectedInstOperands,
     /*  521660 */     // GIR_Coverage, 20837,
     /*  521660 */     GIR_EraseRootFromParent_Done,
     /*  521661 */   // Label 8682: @521661
     /*  521661 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(521732), // Rule ID 20840 //
     /*  521666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521698 */     // MIs[0] round
     /*  521698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521708 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  521711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521717 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521730 */     GIR_RootConstrainSelectedInstOperands,
     /*  521731 */     // GIR_Coverage, 20840,
     /*  521731 */     GIR_EraseRootFromParent_Done,
     /*  521732 */   // Label 8683: @521732
     /*  521732 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(521803), // Rule ID 20841 //
     /*  521737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521769 */     // MIs[0] round
     /*  521769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521779 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  521782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521788 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521801 */     GIR_RootConstrainSelectedInstOperands,
     /*  521802 */     // GIR_Coverage, 20841,
     /*  521802 */     GIR_EraseRootFromParent_Done,
     /*  521803 */   // Label 8684: @521803
     /*  521803 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(521874), // Rule ID 20844 //
     /*  521808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521840 */     // MIs[0] round
     /*  521840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521859 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521872 */     GIR_RootConstrainSelectedInstOperands,
     /*  521873 */     // GIR_Coverage, 20844,
     /*  521873 */     GIR_EraseRootFromParent_Done,
     /*  521874 */   // Label 8685: @521874
     /*  521874 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(521945), // Rule ID 20845 //
     /*  521879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521911 */     // MIs[0] round
     /*  521911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521930 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521943 */     GIR_RootConstrainSelectedInstOperands,
     /*  521944 */     // GIR_Coverage, 20845,
     /*  521944 */     GIR_EraseRootFromParent_Done,
     /*  521945 */   // Label 8686: @521945
     /*  521945 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(522016), // Rule ID 20848 //
     /*  521950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  521961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  521964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  521967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521982 */     // MIs[0] round
     /*  521982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521992 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522001 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522014 */     GIR_RootConstrainSelectedInstOperands,
     /*  522015 */     // GIR_Coverage, 20848,
     /*  522015 */     GIR_EraseRootFromParent_Done,
     /*  522016 */   // Label 8687: @522016
     /*  522016 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(522087), // Rule ID 20849 //
     /*  522021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  522032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  522035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  522038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522053 */     // MIs[0] round
     /*  522053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522063 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522072 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522085 */     GIR_RootConstrainSelectedInstOperands,
     /*  522086 */     // GIR_Coverage, 20849,
     /*  522086 */     GIR_EraseRootFromParent_Done,
     /*  522087 */   // Label 8688: @522087
     /*  522087 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(522158), // Rule ID 20852 //
     /*  522092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  522103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  522106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  522109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522124 */     // MIs[0] round
     /*  522124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522143 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522156 */     GIR_RootConstrainSelectedInstOperands,
     /*  522157 */     // GIR_Coverage, 20852,
     /*  522157 */     GIR_EraseRootFromParent_Done,
     /*  522158 */   // Label 8689: @522158
     /*  522158 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(522229), // Rule ID 20853 //
     /*  522163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  522174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  522177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  522180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522195 */     // MIs[0] round
     /*  522195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522205 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522214 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522227 */     GIR_RootConstrainSelectedInstOperands,
     /*  522228 */     // GIR_Coverage, 20853,
     /*  522228 */     GIR_EraseRootFromParent_Done,
     /*  522229 */   // Label 8690: @522229
     /*  522229 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(522300), // Rule ID 20856 //
     /*  522234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522266 */     // MIs[0] round
     /*  522266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522276 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522285 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522298 */     GIR_RootConstrainSelectedInstOperands,
     /*  522299 */     // GIR_Coverage, 20856,
     /*  522299 */     GIR_EraseRootFromParent_Done,
     /*  522300 */   // Label 8691: @522300
     /*  522300 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(522371), // Rule ID 20857 //
     /*  522305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  522316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  522319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  522322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  522337 */     // MIs[0] round
     /*  522337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522347 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  522350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522356 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522369 */     GIR_RootConstrainSelectedInstOperands,
     /*  522370 */     // GIR_Coverage, 20857,
     /*  522370 */     GIR_EraseRootFromParent_Done,
     /*  522371 */   // Label 8692: @522371
     /*  522371 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(522442), // Rule ID 20860 //
     /*  522376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522408 */     // MIs[0] round
     /*  522408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522427 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522440 */     GIR_RootConstrainSelectedInstOperands,
     /*  522441 */     // GIR_Coverage, 20860,
     /*  522441 */     GIR_EraseRootFromParent_Done,
     /*  522442 */   // Label 8693: @522442
     /*  522442 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(522513), // Rule ID 20861 //
     /*  522447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  522458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  522461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  522464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  522479 */     // MIs[0] round
     /*  522479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522489 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  522492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522498 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522511 */     GIR_RootConstrainSelectedInstOperands,
     /*  522512 */     // GIR_Coverage, 20861,
     /*  522512 */     GIR_EraseRootFromParent_Done,
     /*  522513 */   // Label 8694: @522513
     /*  522513 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(522584), // Rule ID 20864 //
     /*  522518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522550 */     // MIs[0] round
     /*  522550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522569 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522582 */     GIR_RootConstrainSelectedInstOperands,
     /*  522583 */     // GIR_Coverage, 20864,
     /*  522583 */     GIR_EraseRootFromParent_Done,
     /*  522584 */   // Label 8695: @522584
     /*  522584 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(522655), // Rule ID 20865 //
     /*  522589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522621 */     // MIs[0] round
     /*  522621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522631 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522640 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522653 */     GIR_RootConstrainSelectedInstOperands,
     /*  522654 */     // GIR_Coverage, 20865,
     /*  522654 */     GIR_EraseRootFromParent_Done,
     /*  522655 */   // Label 8696: @522655
     /*  522655 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(522726), // Rule ID 20988 //
     /*  522660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  522671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  522674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  522677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522692 */     // MIs[0] round
     /*  522692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522702 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  522705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522711 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522724 */     GIR_RootConstrainSelectedInstOperands,
     /*  522725 */     // GIR_Coverage, 20988,
     /*  522725 */     GIR_EraseRootFromParent_Done,
     /*  522726 */   // Label 8697: @522726
     /*  522726 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(522797), // Rule ID 20989 //
     /*  522731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  522742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  522745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  522748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522763 */     // MIs[0] round
     /*  522763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522773 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  522776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522782 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522795 */     GIR_RootConstrainSelectedInstOperands,
     /*  522796 */     // GIR_Coverage, 20989,
     /*  522796 */     GIR_EraseRootFromParent_Done,
     /*  522797 */   // Label 8698: @522797
     /*  522797 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(522868), // Rule ID 20992 //
     /*  522802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522834 */     // MIs[0] round
     /*  522834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522844 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  522847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522853 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522866 */     GIR_RootConstrainSelectedInstOperands,
     /*  522867 */     // GIR_Coverage, 20992,
     /*  522867 */     GIR_EraseRootFromParent_Done,
     /*  522868 */   // Label 8699: @522868
     /*  522868 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(522939), // Rule ID 20993 //
     /*  522873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522905 */     // MIs[0] round
     /*  522905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522915 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  522918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522924 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522937 */     GIR_RootConstrainSelectedInstOperands,
     /*  522938 */     // GIR_Coverage, 20993,
     /*  522938 */     GIR_EraseRootFromParent_Done,
     /*  522939 */   // Label 8700: @522939
     /*  522939 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(523010), // Rule ID 20996 //
     /*  522944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  522955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  522958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  522961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522976 */     // MIs[0] round
     /*  522976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522986 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  522989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522995 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523008 */     GIR_RootConstrainSelectedInstOperands,
     /*  523009 */     // GIR_Coverage, 20996,
     /*  523009 */     GIR_EraseRootFromParent_Done,
     /*  523010 */   // Label 8701: @523010
     /*  523010 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(523081), // Rule ID 20997 //
     /*  523015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  523026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  523029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  523032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523047 */     // MIs[0] round
     /*  523047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523057 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  523060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523066 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523079 */     GIR_RootConstrainSelectedInstOperands,
     /*  523080 */     // GIR_Coverage, 20997,
     /*  523080 */     GIR_EraseRootFromParent_Done,
     /*  523081 */   // Label 8702: @523081
     /*  523081 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(523152), // Rule ID 21000 //
     /*  523086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  523097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  523100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  523103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523118 */     // MIs[0] round
     /*  523118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523128 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  523131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523137 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523150 */     GIR_RootConstrainSelectedInstOperands,
     /*  523151 */     // GIR_Coverage, 21000,
     /*  523151 */     GIR_EraseRootFromParent_Done,
     /*  523152 */   // Label 8703: @523152
     /*  523152 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(523223), // Rule ID 21001 //
     /*  523157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  523168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  523171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  523174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523189 */     // MIs[0] round
     /*  523189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523199 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  523202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523208 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523221 */     GIR_RootConstrainSelectedInstOperands,
     /*  523222 */     // GIR_Coverage, 21001,
     /*  523222 */     GIR_EraseRootFromParent_Done,
     /*  523223 */   // Label 8704: @523223
     /*  523223 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(523294), // Rule ID 21004 //
     /*  523228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  523239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  523242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  523245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523260 */     // MIs[0] round
     /*  523260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523270 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  523273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523279 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523292 */     GIR_RootConstrainSelectedInstOperands,
     /*  523293 */     // GIR_Coverage, 21004,
     /*  523293 */     GIR_EraseRootFromParent_Done,
     /*  523294 */   // Label 8705: @523294
     /*  523294 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(523365), // Rule ID 21005 //
     /*  523299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  523310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  523313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  523316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523331 */     // MIs[0] round
     /*  523331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523341 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  523344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523350 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523363 */     GIR_RootConstrainSelectedInstOperands,
     /*  523364 */     // GIR_Coverage, 21005,
     /*  523364 */     GIR_EraseRootFromParent_Done,
     /*  523365 */   // Label 8706: @523365
     /*  523365 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(523436), // Rule ID 21008 //
     /*  523370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  523373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523402 */     // MIs[0] round
     /*  523402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523412 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  523415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523421 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523434 */     GIR_RootConstrainSelectedInstOperands,
     /*  523435 */     // GIR_Coverage, 21008,
     /*  523435 */     GIR_EraseRootFromParent_Done,
     /*  523436 */   // Label 8707: @523436
     /*  523436 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(523507), // Rule ID 21009 //
     /*  523441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  523444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  523452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  523455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  523458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  523473 */     // MIs[0] round
     /*  523473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523483 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  523486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523492 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523505 */     GIR_RootConstrainSelectedInstOperands,
     /*  523506 */     // GIR_Coverage, 21009,
     /*  523506 */     GIR_EraseRootFromParent_Done,
     /*  523507 */   // Label 8708: @523507
     /*  523507 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(523578), // Rule ID 21012 //
     /*  523512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523544 */     // MIs[0] round
     /*  523544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523554 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  523557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523563 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523576 */     GIR_RootConstrainSelectedInstOperands,
     /*  523577 */     // GIR_Coverage, 21012,
     /*  523577 */     GIR_EraseRootFromParent_Done,
     /*  523578 */   // Label 8709: @523578
     /*  523578 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(523649), // Rule ID 21013 //
     /*  523583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523615 */     // MIs[0] round
     /*  523615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523625 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  523628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523634 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523647 */     GIR_RootConstrainSelectedInstOperands,
     /*  523648 */     // GIR_Coverage, 21013,
     /*  523648 */     GIR_EraseRootFromParent_Done,
     /*  523649 */   // Label 8710: @523649
     /*  523649 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(523720), // Rule ID 21016 //
     /*  523654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523686 */     // MIs[0] round
     /*  523686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523696 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  523699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523705 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523718 */     GIR_RootConstrainSelectedInstOperands,
     /*  523719 */     // GIR_Coverage, 21016,
     /*  523719 */     GIR_EraseRootFromParent_Done,
     /*  523720 */   // Label 8711: @523720
     /*  523720 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(523791), // Rule ID 21017 //
     /*  523725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523757 */     // MIs[0] round
     /*  523757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523767 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  523770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523776 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523789 */     GIR_RootConstrainSelectedInstOperands,
     /*  523790 */     // GIR_Coverage, 21017,
     /*  523790 */     GIR_EraseRootFromParent_Done,
     /*  523791 */   // Label 8712: @523791
     /*  523791 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(523862), // Rule ID 21020 //
     /*  523796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523828 */     // MIs[0] round
     /*  523828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523838 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  523841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523847 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523860 */     GIR_RootConstrainSelectedInstOperands,
     /*  523861 */     // GIR_Coverage, 21020,
     /*  523861 */     GIR_EraseRootFromParent_Done,
     /*  523862 */   // Label 8713: @523862
     /*  523862 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(523933), // Rule ID 21021 //
     /*  523867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523899 */     // MIs[0] round
     /*  523899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523909 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  523912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523918 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523931 */     GIR_RootConstrainSelectedInstOperands,
     /*  523932 */     // GIR_Coverage, 21021,
     /*  523932 */     GIR_EraseRootFromParent_Done,
     /*  523933 */   // Label 8714: @523933
     /*  523933 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(524004), // Rule ID 21024 //
     /*  523938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523970 */     // MIs[0] round
     /*  523970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523980 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  523983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523989 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524002 */     GIR_RootConstrainSelectedInstOperands,
     /*  524003 */     // GIR_Coverage, 21024,
     /*  524003 */     GIR_EraseRootFromParent_Done,
     /*  524004 */   // Label 8715: @524004
     /*  524004 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(524075), // Rule ID 21025 //
     /*  524009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  524020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  524023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  524026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524041 */     // MIs[0] round
     /*  524041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524051 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  524054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524060 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524073 */     GIR_RootConstrainSelectedInstOperands,
     /*  524074 */     // GIR_Coverage, 21025,
     /*  524074 */     GIR_EraseRootFromParent_Done,
     /*  524075 */   // Label 8716: @524075
     /*  524075 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(524146), // Rule ID 21028 //
     /*  524080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  524091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  524094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  524097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524112 */     // MIs[0] round
     /*  524112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524122 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  524125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524131 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524144 */     GIR_RootConstrainSelectedInstOperands,
     /*  524145 */     // GIR_Coverage, 21028,
     /*  524145 */     GIR_EraseRootFromParent_Done,
     /*  524146 */   // Label 8717: @524146
     /*  524146 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(524217), // Rule ID 21029 //
     /*  524151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  524162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  524165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  524168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524183 */     // MIs[0] round
     /*  524183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524193 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  524196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524202 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524215 */     GIR_RootConstrainSelectedInstOperands,
     /*  524216 */     // GIR_Coverage, 21029,
     /*  524216 */     GIR_EraseRootFromParent_Done,
     /*  524217 */   // Label 8718: @524217
     /*  524217 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(524288), // Rule ID 21032 //
     /*  524222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  524233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  524236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  524239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524254 */     // MIs[0] round
     /*  524254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524264 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  524267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524273 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524286 */     GIR_RootConstrainSelectedInstOperands,
     /*  524287 */     // GIR_Coverage, 21032,
     /*  524287 */     GIR_EraseRootFromParent_Done,
     /*  524288 */   // Label 8719: @524288
     /*  524288 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(524359), // Rule ID 21033 //
     /*  524293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  524304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  524307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  524310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524325 */     // MIs[0] round
     /*  524325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524335 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  524338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524344 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524357 */     GIR_RootConstrainSelectedInstOperands,
     /*  524358 */     // GIR_Coverage, 21033,
     /*  524358 */     GIR_EraseRootFromParent_Done,
     /*  524359 */   // Label 8720: @524359
     /*  524359 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(524430), // Rule ID 21036 //
     /*  524364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524396 */     // MIs[0] round
     /*  524396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524406 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  524409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524415 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524428 */     GIR_RootConstrainSelectedInstOperands,
     /*  524429 */     // GIR_Coverage, 21036,
     /*  524429 */     GIR_EraseRootFromParent_Done,
     /*  524430 */   // Label 8721: @524430
     /*  524430 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(524501), // Rule ID 21037 //
     /*  524435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  524446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  524449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  524452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  524467 */     // MIs[0] round
     /*  524467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524477 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11189:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  524480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524486 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524499 */     GIR_RootConstrainSelectedInstOperands,
     /*  524500 */     // GIR_Coverage, 21037,
     /*  524500 */     GIR_EraseRootFromParent_Done,
     /*  524501 */   // Label 8722: @524501
     /*  524501 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(524572), // Rule ID 21040 //
     /*  524506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524538 */     // MIs[0] round
     /*  524538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524548 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  524551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524557 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524570 */     GIR_RootConstrainSelectedInstOperands,
     /*  524571 */     // GIR_Coverage, 21040,
     /*  524571 */     GIR_EraseRootFromParent_Done,
     /*  524572 */   // Label 8723: @524572
     /*  524572 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(524643), // Rule ID 21041 //
     /*  524577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524609 */     // MIs[0] round
     /*  524609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524619 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11189:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  524622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524628 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524641 */     GIR_RootConstrainSelectedInstOperands,
     /*  524642 */     // GIR_Coverage, 21041,
     /*  524642 */     GIR_EraseRootFromParent_Done,
     /*  524643 */   // Label 8724: @524643
     /*  524643 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(524714), // Rule ID 21044 //
     /*  524648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524680 */     // MIs[0] round
     /*  524680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524690 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  524693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524699 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524712 */     GIR_RootConstrainSelectedInstOperands,
     /*  524713 */     // GIR_Coverage, 21044,
     /*  524713 */     GIR_EraseRootFromParent_Done,
     /*  524714 */   // Label 8725: @524714
     /*  524714 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(524785), // Rule ID 21045 //
     /*  524719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524751 */     // MIs[0] round
     /*  524751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524761 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11189:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  524764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524770 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524783 */     GIR_RootConstrainSelectedInstOperands,
     /*  524784 */     // GIR_Coverage, 21045,
     /*  524784 */     GIR_EraseRootFromParent_Done,
     /*  524785 */   // Label 8726: @524785
     /*  524785 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(524856), // Rule ID 21048 //
     /*  524790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524822 */     // MIs[0] round
     /*  524822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524832 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  524835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524841 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524854 */     GIR_RootConstrainSelectedInstOperands,
     /*  524855 */     // GIR_Coverage, 21048,
     /*  524855 */     GIR_EraseRootFromParent_Done,
     /*  524856 */   // Label 8727: @524856
     /*  524856 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(524927), // Rule ID 21049 //
     /*  524861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524893 */     // MIs[0] round
     /*  524893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524903 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  524906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524912 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524925 */     GIR_RootConstrainSelectedInstOperands,
     /*  524926 */     // GIR_Coverage, 21049,
     /*  524926 */     GIR_EraseRootFromParent_Done,
     /*  524927 */   // Label 8728: @524927
     /*  524927 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(524998), // Rule ID 21052 //
     /*  524932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524964 */     // MIs[0] round
     /*  524964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524974 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  524977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524983 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524996 */     GIR_RootConstrainSelectedInstOperands,
     /*  524997 */     // GIR_Coverage, 21052,
     /*  524997 */     GIR_EraseRootFromParent_Done,
     /*  524998 */   // Label 8729: @524998
     /*  524998 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(525069), // Rule ID 21053 //
     /*  525003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  525014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  525017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  525020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525035 */     // MIs[0] round
     /*  525035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525045 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  525048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525054 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525067 */     GIR_RootConstrainSelectedInstOperands,
     /*  525068 */     // GIR_Coverage, 21053,
     /*  525068 */     GIR_EraseRootFromParent_Done,
     /*  525069 */   // Label 8730: @525069
     /*  525069 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(525140), // Rule ID 21056 //
     /*  525074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  525085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  525088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  525091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525106 */     // MIs[0] round
     /*  525106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525116 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  525119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525125 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525138 */     GIR_RootConstrainSelectedInstOperands,
     /*  525139 */     // GIR_Coverage, 21056,
     /*  525139 */     GIR_EraseRootFromParent_Done,
     /*  525140 */   // Label 8731: @525140
     /*  525140 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(525211), // Rule ID 21057 //
     /*  525145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  525156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  525159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  525162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525177 */     // MIs[0] round
     /*  525177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525187 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  525190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525196 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525209 */     GIR_RootConstrainSelectedInstOperands,
     /*  525210 */     // GIR_Coverage, 21057,
     /*  525210 */     GIR_EraseRootFromParent_Done,
     /*  525211 */   // Label 8732: @525211
     /*  525211 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(525282), // Rule ID 21060 //
     /*  525216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  525227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  525230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  525233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525248 */     // MIs[0] round
     /*  525248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525258 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  525261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525267 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525280 */     GIR_RootConstrainSelectedInstOperands,
     /*  525281 */     // GIR_Coverage, 21060,
     /*  525281 */     GIR_EraseRootFromParent_Done,
     /*  525282 */   // Label 8733: @525282
     /*  525282 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(525353), // Rule ID 21061 //
     /*  525287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  525298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  525301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  525304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525319 */     // MIs[0] round
     /*  525319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525329 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  525332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525338 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525351 */     GIR_RootConstrainSelectedInstOperands,
     /*  525352 */     // GIR_Coverage, 21061,
     /*  525352 */     GIR_EraseRootFromParent_Done,
     /*  525353 */   // Label 8734: @525353
     /*  525353 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(525424), // Rule ID 21064 //
     /*  525358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525390 */     // MIs[0] round
     /*  525390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525400 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  525403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525409 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525422 */     GIR_RootConstrainSelectedInstOperands,
     /*  525423 */     // GIR_Coverage, 21064,
     /*  525423 */     GIR_EraseRootFromParent_Done,
     /*  525424 */   // Label 8735: @525424
     /*  525424 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(525495), // Rule ID 21065 //
     /*  525429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  525440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  525443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  525446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525461 */     // MIs[0] round
     /*  525461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525471 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  525474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525480 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525493 */     GIR_RootConstrainSelectedInstOperands,
     /*  525494 */     // GIR_Coverage, 21065,
     /*  525494 */     GIR_EraseRootFromParent_Done,
     /*  525495 */   // Label 8736: @525495
     /*  525495 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(525566), // Rule ID 21068 //
     /*  525500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  525503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525532 */     // MIs[0] round
     /*  525532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525542 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  525545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525551 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525564 */     GIR_RootConstrainSelectedInstOperands,
     /*  525565 */     // GIR_Coverage, 21068,
     /*  525565 */     GIR_EraseRootFromParent_Done,
     /*  525566 */   // Label 8737: @525566
     /*  525566 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(525637), // Rule ID 21069 //
     /*  525571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  525574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525603 */     // MIs[0] round
     /*  525603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525613 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  525616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525622 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525635 */     GIR_RootConstrainSelectedInstOperands,
     /*  525636 */     // GIR_Coverage, 21069,
     /*  525636 */     GIR_EraseRootFromParent_Done,
     /*  525637 */   // Label 8738: @525637
     /*  525637 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(525708), // Rule ID 21072 //
     /*  525642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525674 */     // MIs[0] round
     /*  525674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525684 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  525687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525693 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525706 */     GIR_RootConstrainSelectedInstOperands,
     /*  525707 */     // GIR_Coverage, 21072,
     /*  525707 */     GIR_EraseRootFromParent_Done,
     /*  525708 */   // Label 8739: @525708
     /*  525708 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(525779), // Rule ID 21073 //
     /*  525713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525745 */     // MIs[0] round
     /*  525745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525755 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  525758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525764 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525777 */     GIR_RootConstrainSelectedInstOperands,
     /*  525778 */     // GIR_Coverage, 21073,
     /*  525778 */     GIR_EraseRootFromParent_Done,
     /*  525779 */   // Label 8740: @525779
     /*  525779 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(525850), // Rule ID 21076 //
     /*  525784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525816 */     // MIs[0] round
     /*  525816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525826 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  525829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525835 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525848 */     GIR_RootConstrainSelectedInstOperands,
     /*  525849 */     // GIR_Coverage, 21076,
     /*  525849 */     GIR_EraseRootFromParent_Done,
     /*  525850 */   // Label 8741: @525850
     /*  525850 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(525921), // Rule ID 21077 //
     /*  525855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525887 */     // MIs[0] round
     /*  525887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525897 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  525900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525906 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525919 */     GIR_RootConstrainSelectedInstOperands,
     /*  525920 */     // GIR_Coverage, 21077,
     /*  525920 */     GIR_EraseRootFromParent_Done,
     /*  525921 */   // Label 8742: @525921
     /*  525921 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(525992), // Rule ID 21080 //
     /*  525926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  525937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  525940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  525943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525958 */     // MIs[0] round
     /*  525958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525968 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  525971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525977 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525990 */     GIR_RootConstrainSelectedInstOperands,
     /*  525991 */     // GIR_Coverage, 21080,
     /*  525991 */     GIR_EraseRootFromParent_Done,
     /*  525992 */   // Label 8743: @525992
     /*  525992 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(526063), // Rule ID 21081 //
     /*  525997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  526008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  526011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  526014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526029 */     // MIs[0] round
     /*  526029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526039 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  526042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526048 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526061 */     GIR_RootConstrainSelectedInstOperands,
     /*  526062 */     // GIR_Coverage, 21081,
     /*  526062 */     GIR_EraseRootFromParent_Done,
     /*  526063 */   // Label 8744: @526063
     /*  526063 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(526134), // Rule ID 21084 //
     /*  526068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526100 */     // MIs[0] round
     /*  526100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526110 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  526113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526119 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526132 */     GIR_RootConstrainSelectedInstOperands,
     /*  526133 */     // GIR_Coverage, 21084,
     /*  526133 */     GIR_EraseRootFromParent_Done,
     /*  526134 */   // Label 8745: @526134
     /*  526134 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(526205), // Rule ID 21085 //
     /*  526139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  526156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526171 */     // MIs[0] round
     /*  526171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526181 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  526184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526190 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526203 */     GIR_RootConstrainSelectedInstOperands,
     /*  526204 */     // GIR_Coverage, 21085,
     /*  526204 */     GIR_EraseRootFromParent_Done,
     /*  526205 */   // Label 8746: @526205
     /*  526205 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(526276), // Rule ID 21088 //
     /*  526210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526242 */     // MIs[0] round
     /*  526242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526252 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  526255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526261 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526274 */     GIR_RootConstrainSelectedInstOperands,
     /*  526275 */     // GIR_Coverage, 21088,
     /*  526275 */     GIR_EraseRootFromParent_Done,
     /*  526276 */   // Label 8747: @526276
     /*  526276 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(526347), // Rule ID 21089 //
     /*  526281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  526298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526313 */     // MIs[0] round
     /*  526313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526323 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  526326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526332 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526345 */     GIR_RootConstrainSelectedInstOperands,
     /*  526346 */     // GIR_Coverage, 21089,
     /*  526346 */     GIR_EraseRootFromParent_Done,
     /*  526347 */   // Label 8748: @526347
     /*  526347 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(526418), // Rule ID 21092 //
     /*  526352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  526355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526384 */     // MIs[0] round
     /*  526384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526394 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  526394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  526397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526403 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526416 */     GIR_RootConstrainSelectedInstOperands,
     /*  526417 */     // GIR_Coverage, 21092,
     /*  526417 */     GIR_EraseRootFromParent_Done,
     /*  526418 */   // Label 8749: @526418
     /*  526418 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(526489), // Rule ID 21093 //
     /*  526423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  526426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  526440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526455 */     // MIs[0] round
     /*  526455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526465 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  526465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  526468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526474 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  526484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526487 */     GIR_RootConstrainSelectedInstOperands,
     /*  526488 */     // GIR_Coverage, 21093,
     /*  526488 */     GIR_EraseRootFromParent_Done,
     /*  526489 */   // Label 8750: @526489
     /*  526489 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(526560), // Rule ID 21096 //
     /*  526494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526526 */     // MIs[0] round
     /*  526526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526536 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  526539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526545 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526558 */     GIR_RootConstrainSelectedInstOperands,
     /*  526559 */     // GIR_Coverage, 21096,
     /*  526559 */     GIR_EraseRootFromParent_Done,
     /*  526560 */   // Label 8751: @526560
     /*  526560 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(526631), // Rule ID 21097 //
     /*  526565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526597 */     // MIs[0] round
     /*  526597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526607 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11191:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  526610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526616 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526629 */     GIR_RootConstrainSelectedInstOperands,
     /*  526630 */     // GIR_Coverage, 21097,
     /*  526630 */     GIR_EraseRootFromParent_Done,
     /*  526631 */   // Label 8752: @526631
     /*  526631 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(526702), // Rule ID 21100 //
     /*  526636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526668 */     // MIs[0] round
     /*  526668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526678 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  526681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526687 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526700 */     GIR_RootConstrainSelectedInstOperands,
     /*  526701 */     // GIR_Coverage, 21100,
     /*  526701 */     GIR_EraseRootFromParent_Done,
     /*  526702 */   // Label 8753: @526702
     /*  526702 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(526773), // Rule ID 21101 //
     /*  526707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526739 */     // MIs[0] round
     /*  526739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526749 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11191:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  526752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526758 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526771 */     GIR_RootConstrainSelectedInstOperands,
     /*  526772 */     // GIR_Coverage, 21101,
     /*  526772 */     GIR_EraseRootFromParent_Done,
     /*  526773 */   // Label 8754: @526773
     /*  526773 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(526844), // Rule ID 21104 //
     /*  526778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526810 */     // MIs[0] round
     /*  526810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526820 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  526823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526829 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526842 */     GIR_RootConstrainSelectedInstOperands,
     /*  526843 */     // GIR_Coverage, 21104,
     /*  526843 */     GIR_EraseRootFromParent_Done,
     /*  526844 */   // Label 8755: @526844
     /*  526844 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(526915), // Rule ID 21105 //
     /*  526849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526881 */     // MIs[0] round
     /*  526881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526891 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11191:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  526894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526900 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526913 */     GIR_RootConstrainSelectedInstOperands,
     /*  526914 */     // GIR_Coverage, 21105,
     /*  526914 */     GIR_EraseRootFromParent_Done,
     /*  526915 */   // Label 8756: @526915
     /*  526915 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(526986), // Rule ID 21180 //
     /*  526920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  526931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  526934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  526937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526952 */     // MIs[0] round
     /*  526952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526962 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  526965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526971 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526984 */     GIR_RootConstrainSelectedInstOperands,
     /*  526985 */     // GIR_Coverage, 21180,
     /*  526985 */     GIR_EraseRootFromParent_Done,
     /*  526986 */   // Label 8757: @526986
     /*  526986 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(527057), // Rule ID 21181 //
     /*  526991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  527002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  527005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527023 */     // MIs[0] round
     /*  527023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527033 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  527036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527042 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527055 */     GIR_RootConstrainSelectedInstOperands,
     /*  527056 */     // GIR_Coverage, 21181,
     /*  527056 */     GIR_EraseRootFromParent_Done,
     /*  527057 */   // Label 8758: @527057
     /*  527057 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(527128), // Rule ID 21184 //
     /*  527062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527094 */     // MIs[0] round
     /*  527094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527113 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527126 */     GIR_RootConstrainSelectedInstOperands,
     /*  527127 */     // GIR_Coverage, 21184,
     /*  527127 */     GIR_EraseRootFromParent_Done,
     /*  527128 */   // Label 8759: @527128
     /*  527128 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(527199), // Rule ID 21185 //
     /*  527133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527165 */     // MIs[0] round
     /*  527165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527175 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11295:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527184 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527197 */     GIR_RootConstrainSelectedInstOperands,
     /*  527198 */     // GIR_Coverage, 21185,
     /*  527198 */     GIR_EraseRootFromParent_Done,
     /*  527199 */   // Label 8760: @527199
     /*  527199 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(527270), // Rule ID 21188 //
     /*  527204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527236 */     // MIs[0] round
     /*  527236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527255 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527268 */     GIR_RootConstrainSelectedInstOperands,
     /*  527269 */     // GIR_Coverage, 21188,
     /*  527269 */     GIR_EraseRootFromParent_Done,
     /*  527270 */   // Label 8761: @527270
     /*  527270 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(527341), // Rule ID 21189 //
     /*  527275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527307 */     // MIs[0] round
     /*  527307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527326 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527339 */     GIR_RootConstrainSelectedInstOperands,
     /*  527340 */     // GIR_Coverage, 21189,
     /*  527340 */     GIR_EraseRootFromParent_Done,
     /*  527341 */   // Label 8762: @527341
     /*  527341 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(527412), // Rule ID 21192 //
     /*  527346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527378 */     // MIs[0] round
     /*  527378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527388 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527397 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527410 */     GIR_RootConstrainSelectedInstOperands,
     /*  527411 */     // GIR_Coverage, 21192,
     /*  527411 */     GIR_EraseRootFromParent_Done,
     /*  527412 */   // Label 8763: @527412
     /*  527412 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(527483), // Rule ID 21193 //
     /*  527417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  527428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  527431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  527434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527449 */     // MIs[0] round
     /*  527449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527459 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527468 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527481 */     GIR_RootConstrainSelectedInstOperands,
     /*  527482 */     // GIR_Coverage, 21193,
     /*  527482 */     GIR_EraseRootFromParent_Done,
     /*  527483 */   // Label 8764: @527483
     /*  527483 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(527554), // Rule ID 21196 //
     /*  527488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  527499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  527502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527520 */     // MIs[0] round
     /*  527520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  527533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527539 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527552 */     GIR_RootConstrainSelectedInstOperands,
     /*  527553 */     // GIR_Coverage, 21196,
     /*  527553 */     GIR_EraseRootFromParent_Done,
     /*  527554 */   // Label 8765: @527554
     /*  527554 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(527625), // Rule ID 21197 //
     /*  527559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  527570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  527573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527591 */     // MIs[0] round
     /*  527591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527601 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  527604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527610 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527623 */     GIR_RootConstrainSelectedInstOperands,
     /*  527624 */     // GIR_Coverage, 21197,
     /*  527624 */     GIR_EraseRootFromParent_Done,
     /*  527625 */   // Label 8766: @527625
     /*  527625 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(527696), // Rule ID 21200 //
     /*  527630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  527647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527662 */     // MIs[0] round
     /*  527662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527672 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527681 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527694 */     GIR_RootConstrainSelectedInstOperands,
     /*  527695 */     // GIR_Coverage, 21200,
     /*  527695 */     GIR_EraseRootFromParent_Done,
     /*  527696 */   // Label 8767: @527696
     /*  527696 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(527767), // Rule ID 21201 //
     /*  527701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  527704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  527718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527733 */     // MIs[0] round
     /*  527733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527743 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11295:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527752 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527765 */     GIR_RootConstrainSelectedInstOperands,
     /*  527766 */     // GIR_Coverage, 21201,
     /*  527766 */     GIR_EraseRootFromParent_Done,
     /*  527767 */   // Label 8768: @527767
     /*  527767 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(527838), // Rule ID 21204 //
     /*  527772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  527783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  527786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527804 */     // MIs[0] round
     /*  527804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527823 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527836 */     GIR_RootConstrainSelectedInstOperands,
     /*  527837 */     // GIR_Coverage, 21204,
     /*  527837 */     GIR_EraseRootFromParent_Done,
     /*  527838 */   // Label 8769: @527838
     /*  527838 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(527909), // Rule ID 21205 //
     /*  527843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  527846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  527854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  527857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527875 */     // MIs[0] round
     /*  527875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527885 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11295:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527894 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527907 */     GIR_RootConstrainSelectedInstOperands,
     /*  527908 */     // GIR_Coverage, 21205,
     /*  527908 */     GIR_EraseRootFromParent_Done,
     /*  527909 */   // Label 8770: @527909
     /*  527909 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(527980), // Rule ID 21208 //
     /*  527914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  527925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  527931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527946 */     // MIs[0] round
     /*  527946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527956 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527965 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527978 */     GIR_RootConstrainSelectedInstOperands,
     /*  527979 */     // GIR_Coverage, 21208,
     /*  527979 */     GIR_EraseRootFromParent_Done,
     /*  527980 */   // Label 8771: @527980
     /*  527980 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(528051), // Rule ID 21209 //
     /*  527985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  527988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  527996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  528002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528017 */     // MIs[0] round
     /*  528017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528027 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11295:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  528030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528036 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528049 */     GIR_RootConstrainSelectedInstOperands,
     /*  528050 */     // GIR_Coverage, 21209,
     /*  528050 */     GIR_EraseRootFromParent_Done,
     /*  528051 */   // Label 8772: @528051
     /*  528051 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(528122), // Rule ID 21212 //
     /*  528056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528088 */     // MIs[0] round
     /*  528088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528098 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528107 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528120 */     GIR_RootConstrainSelectedInstOperands,
     /*  528121 */     // GIR_Coverage, 21212,
     /*  528121 */     GIR_EraseRootFromParent_Done,
     /*  528122 */   // Label 8773: @528122
     /*  528122 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(528193), // Rule ID 21213 //
     /*  528127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  528135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528159 */     // MIs[0] round
     /*  528159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528169 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11295:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  528172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528178 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528191 */     GIR_RootConstrainSelectedInstOperands,
     /*  528192 */     // GIR_Coverage, 21213,
     /*  528192 */     GIR_EraseRootFromParent_Done,
     /*  528193 */   // Label 8774: @528193
     /*  528193 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(528264), // Rule ID 21216 //
     /*  528198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528230 */     // MIs[0] round
     /*  528230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  528243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528249 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528262 */     GIR_RootConstrainSelectedInstOperands,
     /*  528263 */     // GIR_Coverage, 21216,
     /*  528263 */     GIR_EraseRootFromParent_Done,
     /*  528264 */   // Label 8775: @528264
     /*  528264 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(528335), // Rule ID 21217 //
     /*  528269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  528280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  528283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528301 */     // MIs[0] round
     /*  528301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528311 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  528314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528320 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528333 */     GIR_RootConstrainSelectedInstOperands,
     /*  528334 */     // GIR_Coverage, 21217,
     /*  528334 */     GIR_EraseRootFromParent_Done,
     /*  528335 */   // Label 8776: @528335
     /*  528335 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(528406), // Rule ID 21220 //
     /*  528340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528372 */     // MIs[0] round
     /*  528372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528391 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528404 */     GIR_RootConstrainSelectedInstOperands,
     /*  528405 */     // GIR_Coverage, 21220,
     /*  528405 */     GIR_EraseRootFromParent_Done,
     /*  528406 */   // Label 8777: @528406
     /*  528406 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(528477), // Rule ID 21221 //
     /*  528411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  528422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  528425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  528428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528443 */     // MIs[0] round
     /*  528443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528453 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11293:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528462 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528475 */     GIR_RootConstrainSelectedInstOperands,
     /*  528476 */     // GIR_Coverage, 21221,
     /*  528476 */     GIR_EraseRootFromParent_Done,
     /*  528477 */   // Label 8778: @528477
     /*  528477 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(528548), // Rule ID 21224 //
     /*  528482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  528493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  528496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  528499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528514 */     // MIs[0] round
     /*  528514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  528527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528533 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528546 */     GIR_RootConstrainSelectedInstOperands,
     /*  528547 */     // GIR_Coverage, 21224,
     /*  528547 */     GIR_EraseRootFromParent_Done,
     /*  528548 */   // Label 8779: @528548
     /*  528548 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(528619), // Rule ID 21225 //
     /*  528553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  528564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  528567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  528570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528585 */     // MIs[0] round
     /*  528585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528595 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  528598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528604 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528617 */     GIR_RootConstrainSelectedInstOperands,
     /*  528618 */     // GIR_Coverage, 21225,
     /*  528618 */     GIR_EraseRootFromParent_Done,
     /*  528619 */   // Label 8780: @528619
     /*  528619 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(528690), // Rule ID 21228 //
     /*  528624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  528635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  528638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  528641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528656 */     // MIs[0] round
     /*  528656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  528669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528675 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528688 */     GIR_RootConstrainSelectedInstOperands,
     /*  528689 */     // GIR_Coverage, 21228,
     /*  528689 */     GIR_EraseRootFromParent_Done,
     /*  528690 */   // Label 8781: @528690
     /*  528690 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(528761), // Rule ID 21229 //
     /*  528695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  528706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  528709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  528712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528727 */     // MIs[0] round
     /*  528727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528737 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  528740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528746 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528759 */     GIR_RootConstrainSelectedInstOperands,
     /*  528760 */     // GIR_Coverage, 21229,
     /*  528760 */     GIR_EraseRootFromParent_Done,
     /*  528761 */   // Label 8782: @528761
     /*  528761 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(528832), // Rule ID 21232 //
     /*  528766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  528783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528798 */     // MIs[0] round
     /*  528798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528808 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  528811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528817 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528830 */     GIR_RootConstrainSelectedInstOperands,
     /*  528831 */     // GIR_Coverage, 21232,
     /*  528831 */     GIR_EraseRootFromParent_Done,
     /*  528832 */   // Label 8783: @528832
     /*  528832 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(528903), // Rule ID 21233 //
     /*  528837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  528854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528869 */     // MIs[0] round
     /*  528869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528879 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  528882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528888 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528901 */     GIR_RootConstrainSelectedInstOperands,
     /*  528902 */     // GIR_Coverage, 21233,
     /*  528902 */     GIR_EraseRootFromParent_Done,
     /*  528903 */   // Label 8784: @528903
     /*  528903 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(528974), // Rule ID 21236 //
     /*  528908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528940 */     // MIs[0] round
     /*  528940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528959 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528972 */     GIR_RootConstrainSelectedInstOperands,
     /*  528973 */     // GIR_Coverage, 21236,
     /*  528973 */     GIR_EraseRootFromParent_Done,
     /*  528974 */   // Label 8785: @528974
     /*  528974 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(529045), // Rule ID 21237 //
     /*  528979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529011 */     // MIs[0] round
     /*  529011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529021 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11293:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  529024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529030 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529043 */     GIR_RootConstrainSelectedInstOperands,
     /*  529044 */     // GIR_Coverage, 21237,
     /*  529044 */     GIR_EraseRootFromParent_Done,
     /*  529045 */   // Label 8786: @529045
     /*  529045 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(529116), // Rule ID 21240 //
     /*  529050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  529061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  529064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529082 */     // MIs[0] round
     /*  529082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529101 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529114 */     GIR_RootConstrainSelectedInstOperands,
     /*  529115 */     // GIR_Coverage, 21240,
     /*  529115 */     GIR_EraseRootFromParent_Done,
     /*  529116 */   // Label 8787: @529116
     /*  529116 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(529187), // Rule ID 21241 //
     /*  529121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  529132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  529135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529153 */     // MIs[0] round
     /*  529153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529163 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11293:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  529166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529172 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529185 */     GIR_RootConstrainSelectedInstOperands,
     /*  529186 */     // GIR_Coverage, 21241,
     /*  529186 */     GIR_EraseRootFromParent_Done,
     /*  529187 */   // Label 8788: @529187
     /*  529187 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(529258), // Rule ID 21244 //
     /*  529192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  529203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  529206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529224 */     // MIs[0] round
     /*  529224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529243 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529256 */     GIR_RootConstrainSelectedInstOperands,
     /*  529257 */     // GIR_Coverage, 21244,
     /*  529257 */     GIR_EraseRootFromParent_Done,
     /*  529258 */   // Label 8789: @529258
     /*  529258 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(529329), // Rule ID 21245 //
     /*  529263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  529274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  529277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  529280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529295 */     // MIs[0] round
     /*  529295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529305 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11293:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  529308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529314 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529327 */     GIR_RootConstrainSelectedInstOperands,
     /*  529328 */     // GIR_Coverage, 21245,
     /*  529328 */     GIR_EraseRootFromParent_Done,
     /*  529329 */   // Label 8790: @529329
     /*  529329 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(529400), // Rule ID 21248 //
     /*  529334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  529337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  529345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  529348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529366 */     // MIs[0] round
     /*  529366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529376 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  529376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529385 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529398 */     GIR_RootConstrainSelectedInstOperands,
     /*  529399 */     // GIR_Coverage, 21248,
     /*  529399 */     GIR_EraseRootFromParent_Done,
     /*  529400 */   // Label 8791: @529400
     /*  529400 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(529471), // Rule ID 21249 //
     /*  529405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  529408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  529413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  529416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  529419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  529422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529437 */     // MIs[0] round
     /*  529437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529447 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11293:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  529447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  529450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529456 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  529466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529469 */     GIR_RootConstrainSelectedInstOperands,
     /*  529470 */     // GIR_Coverage, 21249,
     /*  529470 */     GIR_EraseRootFromParent_Done,
     /*  529471 */   // Label 8792: @529471
     /*  529471 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(529542), // Rule ID 21600 //
     /*  529476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  529487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  529490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  529493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529508 */     // MIs[0] round
     /*  529508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529518 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  529521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529527 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529540 */     GIR_RootConstrainSelectedInstOperands,
     /*  529541 */     // GIR_Coverage, 21600,
     /*  529541 */     GIR_EraseRootFromParent_Done,
     /*  529542 */   // Label 8793: @529542
     /*  529542 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(529613), // Rule ID 21601 //
     /*  529547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  529558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  529561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  529564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529579 */     // MIs[0] round
     /*  529579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529589 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  529592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529598 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529611 */     GIR_RootConstrainSelectedInstOperands,
     /*  529612 */     // GIR_Coverage, 21601,
     /*  529612 */     GIR_EraseRootFromParent_Done,
     /*  529613 */   // Label 8794: @529613
     /*  529613 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(529684), // Rule ID 21604 //
     /*  529618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  529629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  529632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  529635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529650 */     // MIs[0] round
     /*  529650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529660 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  529663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529669 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529682 */     GIR_RootConstrainSelectedInstOperands,
     /*  529683 */     // GIR_Coverage, 21604,
     /*  529683 */     GIR_EraseRootFromParent_Done,
     /*  529684 */   // Label 8795: @529684
     /*  529684 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(529755), // Rule ID 21605 //
     /*  529689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  529700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  529703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  529706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529721 */     // MIs[0] round
     /*  529721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529731 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  529734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529740 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529753 */     GIR_RootConstrainSelectedInstOperands,
     /*  529754 */     // GIR_Coverage, 21605,
     /*  529754 */     GIR_EraseRootFromParent_Done,
     /*  529755 */   // Label 8796: @529755
     /*  529755 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(529826), // Rule ID 21608 //
     /*  529760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  529771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  529774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529792 */     // MIs[0] round
     /*  529792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529802 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  529805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529811 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529824 */     GIR_RootConstrainSelectedInstOperands,
     /*  529825 */     // GIR_Coverage, 21608,
     /*  529825 */     GIR_EraseRootFromParent_Done,
     /*  529826 */   // Label 8797: @529826
     /*  529826 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(529897), // Rule ID 21609 //
     /*  529831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  529842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  529845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529863 */     // MIs[0] round
     /*  529863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529873 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  529876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529882 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529895 */     GIR_RootConstrainSelectedInstOperands,
     /*  529896 */     // GIR_Coverage, 21609,
     /*  529896 */     GIR_EraseRootFromParent_Done,
     /*  529897 */   // Label 8798: @529897
     /*  529897 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(529968), // Rule ID 21612 //
     /*  529902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  529913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  529916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529934 */     // MIs[0] round
     /*  529934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  529947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529953 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529966 */     GIR_RootConstrainSelectedInstOperands,
     /*  529967 */     // GIR_Coverage, 21612,
     /*  529967 */     GIR_EraseRootFromParent_Done,
     /*  529968 */   // Label 8799: @529968
     /*  529968 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(530039), // Rule ID 21613 //
     /*  529973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  529984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  529987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530005 */     // MIs[0] round
     /*  530005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530015 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11237:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530024 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530037 */     GIR_RootConstrainSelectedInstOperands,
     /*  530038 */     // GIR_Coverage, 21613,
     /*  530038 */     GIR_EraseRootFromParent_Done,
     /*  530039 */   // Label 8800: @530039
     /*  530039 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(530110), // Rule ID 21616 //
     /*  530044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  530055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  530058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  530061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530076 */     // MIs[0] round
     /*  530076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530095 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530108 */     GIR_RootConstrainSelectedInstOperands,
     /*  530109 */     // GIR_Coverage, 21616,
     /*  530109 */     GIR_EraseRootFromParent_Done,
     /*  530110 */   // Label 8801: @530110
     /*  530110 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(530181), // Rule ID 21617 //
     /*  530115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  530126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  530129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  530132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530147 */     // MIs[0] round
     /*  530147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530157 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530166 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530179 */     GIR_RootConstrainSelectedInstOperands,
     /*  530180 */     // GIR_Coverage, 21617,
     /*  530180 */     GIR_EraseRootFromParent_Done,
     /*  530181 */   // Label 8802: @530181
     /*  530181 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(530252), // Rule ID 21620 //
     /*  530186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  530189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  530197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  530200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  530203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530218 */     // MIs[0] round
     /*  530218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530228 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  530228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530237 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530250 */     GIR_RootConstrainSelectedInstOperands,
     /*  530251 */     // GIR_Coverage, 21620,
     /*  530251 */     GIR_EraseRootFromParent_Done,
     /*  530252 */   // Label 8803: @530252
     /*  530252 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(530323), // Rule ID 21621 //
     /*  530257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  530260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  530268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  530271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  530274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530289 */     // MIs[0] round
     /*  530289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530299 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  530299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530308 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  530318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530321 */     GIR_RootConstrainSelectedInstOperands,
     /*  530322 */     // GIR_Coverage, 21621,
     /*  530322 */     GIR_EraseRootFromParent_Done,
     /*  530323 */   // Label 8804: @530323
     /*  530323 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(530394), // Rule ID 21624 //
     /*  530328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  530339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  530342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  530345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530360 */     // MIs[0] round
     /*  530360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530379 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530392 */     GIR_RootConstrainSelectedInstOperands,
     /*  530393 */     // GIR_Coverage, 21624,
     /*  530393 */     GIR_EraseRootFromParent_Done,
     /*  530394 */   // Label 8805: @530394
     /*  530394 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(530465), // Rule ID 21625 //
     /*  530399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  530410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  530413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  530416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530431 */     // MIs[0] round
     /*  530431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530441 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  530444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530450 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530463 */     GIR_RootConstrainSelectedInstOperands,
     /*  530464 */     // GIR_Coverage, 21625,
     /*  530464 */     GIR_EraseRootFromParent_Done,
     /*  530465 */   // Label 8806: @530465
     /*  530465 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(530536), // Rule ID 21628 //
     /*  530470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  530481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  530484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  530487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530502 */     // MIs[0] round
     /*  530502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530512 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530521 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530534 */     GIR_RootConstrainSelectedInstOperands,
     /*  530535 */     // GIR_Coverage, 21628,
     /*  530535 */     GIR_EraseRootFromParent_Done,
     /*  530536 */   // Label 8807: @530536
     /*  530536 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(530607), // Rule ID 21629 //
     /*  530541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  530552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  530555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  530558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530573 */     // MIs[0] round
     /*  530573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530583 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530592 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530605 */     GIR_RootConstrainSelectedInstOperands,
     /*  530606 */     // GIR_Coverage, 21629,
     /*  530606 */     GIR_EraseRootFromParent_Done,
     /*  530607 */   // Label 8808: @530607
     /*  530607 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(530678), // Rule ID 21632 //
     /*  530612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  530623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  530626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  530629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530644 */     // MIs[0] round
     /*  530644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530663 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530676 */     GIR_RootConstrainSelectedInstOperands,
     /*  530677 */     // GIR_Coverage, 21632,
     /*  530677 */     GIR_EraseRootFromParent_Done,
     /*  530678 */   // Label 8809: @530678
     /*  530678 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(530749), // Rule ID 21633 //
     /*  530683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  530694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  530697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  530700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530715 */     // MIs[0] round
     /*  530715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530725 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11237:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530734 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530747 */     GIR_RootConstrainSelectedInstOperands,
     /*  530748 */     // GIR_Coverage, 21633,
     /*  530748 */     GIR_EraseRootFromParent_Done,
     /*  530749 */   // Label 8810: @530749
     /*  530749 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(530820), // Rule ID 21636 //
     /*  530754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  530765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  530768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530786 */     // MIs[0] round
     /*  530786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530805 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530818 */     GIR_RootConstrainSelectedInstOperands,
     /*  530819 */     // GIR_Coverage, 21636,
     /*  530819 */     GIR_EraseRootFromParent_Done,
     /*  530820 */   // Label 8811: @530820
     /*  530820 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(530891), // Rule ID 21637 //
     /*  530825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  530836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  530839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530857 */     // MIs[0] round
     /*  530857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530867 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530876 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530889 */     GIR_RootConstrainSelectedInstOperands,
     /*  530890 */     // GIR_Coverage, 21637,
     /*  530890 */     GIR_EraseRootFromParent_Done,
     /*  530891 */   // Label 8812: @530891
     /*  530891 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(530962), // Rule ID 21640 //
     /*  530896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  530907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  530910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530928 */     // MIs[0] round
     /*  530928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530938 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530947 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530960 */     GIR_RootConstrainSelectedInstOperands,
     /*  530961 */     // GIR_Coverage, 21640,
     /*  530961 */     GIR_EraseRootFromParent_Done,
     /*  530962 */   // Label 8813: @530962
     /*  530962 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(531033), // Rule ID 21641 //
     /*  530967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  530978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  530981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530999 */     // MIs[0] round
     /*  530999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531009 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  531009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531018 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  531028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531031 */     GIR_RootConstrainSelectedInstOperands,
     /*  531032 */     // GIR_Coverage, 21641,
     /*  531032 */     GIR_EraseRootFromParent_Done,
     /*  531033 */   // Label 8814: @531033
     /*  531033 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(531104), // Rule ID 21644 //
     /*  531038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531070 */     // MIs[0] round
     /*  531070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531080 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531089 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531102 */     GIR_RootConstrainSelectedInstOperands,
     /*  531103 */     // GIR_Coverage, 21644,
     /*  531103 */     GIR_EraseRootFromParent_Done,
     /*  531104 */   // Label 8815: @531104
     /*  531104 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(531175), // Rule ID 21645 //
     /*  531109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  531120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  531123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  531126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531141 */     // MIs[0] round
     /*  531141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531151 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  531154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531160 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531173 */     GIR_RootConstrainSelectedInstOperands,
     /*  531174 */     // GIR_Coverage, 21645,
     /*  531174 */     GIR_EraseRootFromParent_Done,
     /*  531175 */   // Label 8816: @531175
     /*  531175 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(531246), // Rule ID 21648 //
     /*  531180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  531197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531212 */     // MIs[0] round
     /*  531212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531231 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531244 */     GIR_RootConstrainSelectedInstOperands,
     /*  531245 */     // GIR_Coverage, 21648,
     /*  531245 */     GIR_EraseRootFromParent_Done,
     /*  531246 */   // Label 8817: @531246
     /*  531246 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(531317), // Rule ID 21649 //
     /*  531251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  531262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  531265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  531268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531283 */     // MIs[0] round
     /*  531283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531293 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  531296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531302 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531315 */     GIR_RootConstrainSelectedInstOperands,
     /*  531316 */     // GIR_Coverage, 21649,
     /*  531316 */     GIR_EraseRootFromParent_Done,
     /*  531317 */   // Label 8818: @531317
     /*  531317 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(531388), // Rule ID 21652 //
     /*  531322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  531339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531354 */     // MIs[0] round
     /*  531354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531373 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531386 */     GIR_RootConstrainSelectedInstOperands,
     /*  531387 */     // GIR_Coverage, 21652,
     /*  531387 */     GIR_EraseRootFromParent_Done,
     /*  531388 */   // Label 8819: @531388
     /*  531388 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(531459), // Rule ID 21653 //
     /*  531393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  531404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  531407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  531410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531425 */     // MIs[0] round
     /*  531425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531435 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  531438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531444 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531457 */     GIR_RootConstrainSelectedInstOperands,
     /*  531458 */     // GIR_Coverage, 21653,
     /*  531458 */     GIR_EraseRootFromParent_Done,
     /*  531459 */   // Label 8820: @531459
     /*  531459 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(531530), // Rule ID 21656 //
     /*  531464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  531467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  531481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531496 */     // MIs[0] round
     /*  531496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  531506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531515 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531528 */     GIR_RootConstrainSelectedInstOperands,
     /*  531529 */     // GIR_Coverage, 21656,
     /*  531529 */     GIR_EraseRootFromParent_Done,
     /*  531530 */   // Label 8821: @531530
     /*  531530 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(531601), // Rule ID 21657 //
     /*  531535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  531552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531567 */     // MIs[0] round
     /*  531567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531586 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531599 */     GIR_RootConstrainSelectedInstOperands,
     /*  531600 */     // GIR_Coverage, 21657,
     /*  531600 */     GIR_EraseRootFromParent_Done,
     /*  531601 */   // Label 8822: @531601
     /*  531601 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(531672), // Rule ID 21660 //
     /*  531606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  531617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  531620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  531623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531638 */     // MIs[0] round
     /*  531638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531648 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  531651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531657 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531670 */     GIR_RootConstrainSelectedInstOperands,
     /*  531671 */     // GIR_Coverage, 21660,
     /*  531671 */     GIR_EraseRootFromParent_Done,
     /*  531672 */   // Label 8823: @531672
     /*  531672 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(531743), // Rule ID 21661 //
     /*  531677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  531688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  531691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  531694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531709 */     // MIs[0] round
     /*  531709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531719 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  531722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531728 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531741 */     GIR_RootConstrainSelectedInstOperands,
     /*  531742 */     // GIR_Coverage, 21661,
     /*  531742 */     GIR_EraseRootFromParent_Done,
     /*  531743 */   // Label 8824: @531743
     /*  531743 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(531814), // Rule ID 21664 //
     /*  531748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  531759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  531762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  531765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531780 */     // MIs[0] round
     /*  531780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531790 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  531793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531799 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531812 */     GIR_RootConstrainSelectedInstOperands,
     /*  531813 */     // GIR_Coverage, 21664,
     /*  531813 */     GIR_EraseRootFromParent_Done,
     /*  531814 */   // Label 8825: @531814
     /*  531814 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(531885), // Rule ID 21665 //
     /*  531819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  531830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  531833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  531836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531851 */     // MIs[0] round
     /*  531851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531861 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  531864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531870 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531883 */     GIR_RootConstrainSelectedInstOperands,
     /*  531884 */     // GIR_Coverage, 21665,
     /*  531884 */     GIR_EraseRootFromParent_Done,
     /*  531885 */   // Label 8826: @531885
     /*  531885 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(531956), // Rule ID 21668 //
     /*  531890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  531901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  531904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531922 */     // MIs[0] round
     /*  531922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531932 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  531935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531941 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531954 */     GIR_RootConstrainSelectedInstOperands,
     /*  531955 */     // GIR_Coverage, 21668,
     /*  531955 */     GIR_EraseRootFromParent_Done,
     /*  531956 */   // Label 8827: @531956
     /*  531956 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(532027), // Rule ID 21669 //
     /*  531961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  531972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  531975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531993 */     // MIs[0] round
     /*  531993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532003 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532012 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532025 */     GIR_RootConstrainSelectedInstOperands,
     /*  532026 */     // GIR_Coverage, 21669,
     /*  532026 */     GIR_EraseRootFromParent_Done,
     /*  532027 */   // Label 8828: @532027
     /*  532027 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(532098), // Rule ID 21672 //
     /*  532032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  532043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  532046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532064 */     // MIs[0] round
     /*  532064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532083 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532096 */     GIR_RootConstrainSelectedInstOperands,
     /*  532097 */     // GIR_Coverage, 21672,
     /*  532097 */     GIR_EraseRootFromParent_Done,
     /*  532098 */   // Label 8829: @532098
     /*  532098 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(532169), // Rule ID 21673 //
     /*  532103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  532114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  532117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  532120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532135 */     // MIs[0] round
     /*  532135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532145 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11235:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532154 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532167 */     GIR_RootConstrainSelectedInstOperands,
     /*  532168 */     // GIR_Coverage, 21673,
     /*  532168 */     GIR_EraseRootFromParent_Done,
     /*  532169 */   // Label 8830: @532169
     /*  532169 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(532240), // Rule ID 21676 //
     /*  532174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532206 */     // MIs[0] round
     /*  532206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532216 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532225 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532238 */     GIR_RootConstrainSelectedInstOperands,
     /*  532239 */     // GIR_Coverage, 21676,
     /*  532239 */     GIR_EraseRootFromParent_Done,
     /*  532240 */   // Label 8831: @532240
     /*  532240 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(532311), // Rule ID 21677 //
     /*  532245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  532256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  532259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  532262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532277 */     // MIs[0] round
     /*  532277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532287 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532296 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532309 */     GIR_RootConstrainSelectedInstOperands,
     /*  532310 */     // GIR_Coverage, 21677,
     /*  532310 */     GIR_EraseRootFromParent_Done,
     /*  532311 */   // Label 8832: @532311
     /*  532311 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(532382), // Rule ID 21680 //
     /*  532316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  532319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532348 */     // MIs[0] round
     /*  532348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532358 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  532358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532367 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532380 */     GIR_RootConstrainSelectedInstOperands,
     /*  532381 */     // GIR_Coverage, 21680,
     /*  532381 */     GIR_EraseRootFromParent_Done,
     /*  532382 */   // Label 8833: @532382
     /*  532382 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(532453), // Rule ID 21681 //
     /*  532387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  532390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  532398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  532401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  532404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532419 */     // MIs[0] round
     /*  532419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532429 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  532429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532438 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  532448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532451 */     GIR_RootConstrainSelectedInstOperands,
     /*  532452 */     // GIR_Coverage, 21681,
     /*  532452 */     GIR_EraseRootFromParent_Done,
     /*  532453 */   // Label 8834: @532453
     /*  532453 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(532524), // Rule ID 21684 //
     /*  532458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  532469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  532472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532490 */     // MIs[0] round
     /*  532490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532500 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532509 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532522 */     GIR_RootConstrainSelectedInstOperands,
     /*  532523 */     // GIR_Coverage, 21684,
     /*  532523 */     GIR_EraseRootFromParent_Done,
     /*  532524 */   // Label 8835: @532524
     /*  532524 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(532595), // Rule ID 21685 //
     /*  532529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  532540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  532543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532561 */     // MIs[0] round
     /*  532561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532571 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532580 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532593 */     GIR_RootConstrainSelectedInstOperands,
     /*  532594 */     // GIR_Coverage, 21685,
     /*  532594 */     GIR_EraseRootFromParent_Done,
     /*  532595 */   // Label 8836: @532595
     /*  532595 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(532666), // Rule ID 21688 //
     /*  532600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  532611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  532614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532632 */     // MIs[0] round
     /*  532632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532642 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532651 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532664 */     GIR_RootConstrainSelectedInstOperands,
     /*  532665 */     // GIR_Coverage, 21688,
     /*  532665 */     GIR_EraseRootFromParent_Done,
     /*  532666 */   // Label 8837: @532666
     /*  532666 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(532737), // Rule ID 21689 //
     /*  532671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  532682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  532685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532703 */     // MIs[0] round
     /*  532703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532713 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532722 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532735 */     GIR_RootConstrainSelectedInstOperands,
     /*  532736 */     // GIR_Coverage, 21689,
     /*  532736 */     GIR_EraseRootFromParent_Done,
     /*  532737 */   // Label 8838: @532737
     /*  532737 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(532808), // Rule ID 21692 //
     /*  532742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  532753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  532756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  532759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532774 */     // MIs[0] round
     /*  532774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532793 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532806 */     GIR_RootConstrainSelectedInstOperands,
     /*  532807 */     // GIR_Coverage, 21692,
     /*  532807 */     GIR_EraseRootFromParent_Done,
     /*  532808 */   // Label 8839: @532808
     /*  532808 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(532879), // Rule ID 21693 //
     /*  532813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  532824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  532827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  532830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532845 */     // MIs[0] round
     /*  532845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532855 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11235:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532864 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532877 */     GIR_RootConstrainSelectedInstOperands,
     /*  532878 */     // GIR_Coverage, 21693,
     /*  532878 */     GIR_EraseRootFromParent_Done,
     /*  532879 */   // Label 8840: @532879
     /*  532879 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(532950), // Rule ID 21696 //
     /*  532884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  532895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  532898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  532901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532916 */     // MIs[0] round
     /*  532916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532926 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532935 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532948 */     GIR_RootConstrainSelectedInstOperands,
     /*  532949 */     // GIR_Coverage, 21696,
     /*  532949 */     GIR_EraseRootFromParent_Done,
     /*  532950 */   // Label 8841: @532950
     /*  532950 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(533021), // Rule ID 21697 //
     /*  532955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  532966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  532969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  532972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532987 */     // MIs[0] round
     /*  532987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532997 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533006 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533019 */     GIR_RootConstrainSelectedInstOperands,
     /*  533020 */     // GIR_Coverage, 21697,
     /*  533020 */     GIR_EraseRootFromParent_Done,
     /*  533021 */   // Label 8842: @533021
     /*  533021 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(533092), // Rule ID 21700 //
     /*  533026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  533029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533058 */     // MIs[0] round
     /*  533058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533068 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533077 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533090 */     GIR_RootConstrainSelectedInstOperands,
     /*  533091 */     // GIR_Coverage, 21700,
     /*  533091 */     GIR_EraseRootFromParent_Done,
     /*  533092 */   // Label 8843: @533092
     /*  533092 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(533163), // Rule ID 21701 //
     /*  533097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  533100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533129 */     // MIs[0] round
     /*  533129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533139 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533148 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533161 */     GIR_RootConstrainSelectedInstOperands,
     /*  533162 */     // GIR_Coverage, 21701,
     /*  533162 */     GIR_EraseRootFromParent_Done,
     /*  533163 */   // Label 8844: @533163
     /*  533163 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(533234), // Rule ID 21704 //
     /*  533168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  533179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  533182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  533185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533200 */     // MIs[0] round
     /*  533200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533210 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533219 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533232 */     GIR_RootConstrainSelectedInstOperands,
     /*  533233 */     // GIR_Coverage, 21704,
     /*  533233 */     GIR_EraseRootFromParent_Done,
     /*  533234 */   // Label 8845: @533234
     /*  533234 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(533305), // Rule ID 21705 //
     /*  533239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  533250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  533253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  533256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533271 */     // MIs[0] round
     /*  533271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533281 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  533284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533290 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533303 */     GIR_RootConstrainSelectedInstOperands,
     /*  533304 */     // GIR_Coverage, 21705,
     /*  533304 */     GIR_EraseRootFromParent_Done,
     /*  533305 */   // Label 8846: @533305
     /*  533305 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(533376), // Rule ID 21708 //
     /*  533310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  533321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  533324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533342 */     // MIs[0] round
     /*  533342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533361 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533374 */     GIR_RootConstrainSelectedInstOperands,
     /*  533375 */     // GIR_Coverage, 21708,
     /*  533375 */     GIR_EraseRootFromParent_Done,
     /*  533376 */   // Label 8847: @533376
     /*  533376 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(533447), // Rule ID 21709 //
     /*  533381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  533392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  533395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  533398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533413 */     // MIs[0] round
     /*  533413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533423 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  533426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533432 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533445 */     GIR_RootConstrainSelectedInstOperands,
     /*  533446 */     // GIR_Coverage, 21709,
     /*  533446 */     GIR_EraseRootFromParent_Done,
     /*  533447 */   // Label 8848: @533447
     /*  533447 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(533518), // Rule ID 21712 //
     /*  533452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  533463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  533466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  533469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533484 */     // MIs[0] round
     /*  533484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533503 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533516 */     GIR_RootConstrainSelectedInstOperands,
     /*  533517 */     // GIR_Coverage, 21712,
     /*  533517 */     GIR_EraseRootFromParent_Done,
     /*  533518 */   // Label 8849: @533518
     /*  533518 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(533589), // Rule ID 21713 //
     /*  533523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  533534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  533537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  533540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533555 */     // MIs[0] round
     /*  533555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533574 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533587 */     GIR_RootConstrainSelectedInstOperands,
     /*  533588 */     // GIR_Coverage, 21713,
     /*  533588 */     GIR_EraseRootFromParent_Done,
     /*  533589 */   // Label 8850: @533589
     /*  533589 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(533660), // Rule ID 21716 //
     /*  533594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  533605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  533608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  533611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533626 */     // MIs[0] round
     /*  533626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533636 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533645 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533658 */     GIR_RootConstrainSelectedInstOperands,
     /*  533659 */     // GIR_Coverage, 21716,
     /*  533659 */     GIR_EraseRootFromParent_Done,
     /*  533660 */   // Label 8851: @533660
     /*  533660 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(533731), // Rule ID 21717 //
     /*  533665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  533676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  533679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  533682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533697 */     // MIs[0] round
     /*  533697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533707 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533716 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533729 */     GIR_RootConstrainSelectedInstOperands,
     /*  533730 */     // GIR_Coverage, 21717,
     /*  533730 */     GIR_EraseRootFromParent_Done,
     /*  533731 */   // Label 8852: @533731
     /*  533731 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(533802), // Rule ID 21840 //
     /*  533736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  533747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  533750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  533753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533768 */     // MIs[0] round
     /*  533768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533778 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  533781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533787 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533800 */     GIR_RootConstrainSelectedInstOperands,
     /*  533801 */     // GIR_Coverage, 21840,
     /*  533801 */     GIR_EraseRootFromParent_Done,
     /*  533802 */   // Label 8853: @533802
     /*  533802 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(533873), // Rule ID 21841 //
     /*  533807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  533818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  533821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  533824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533839 */     // MIs[0] round
     /*  533839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533849 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  533852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533858 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533871 */     GIR_RootConstrainSelectedInstOperands,
     /*  533872 */     // GIR_Coverage, 21841,
     /*  533872 */     GIR_EraseRootFromParent_Done,
     /*  533873 */   // Label 8854: @533873
     /*  533873 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(533944), // Rule ID 21844 //
     /*  533878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533910 */     // MIs[0] round
     /*  533910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533920 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  533923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533929 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533942 */     GIR_RootConstrainSelectedInstOperands,
     /*  533943 */     // GIR_Coverage, 21844,
     /*  533943 */     GIR_EraseRootFromParent_Done,
     /*  533944 */   // Label 8855: @533944
     /*  533944 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(534015), // Rule ID 21845 //
     /*  533949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533981 */     // MIs[0] round
     /*  533981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533991 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  533994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534000 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534013 */     GIR_RootConstrainSelectedInstOperands,
     /*  534014 */     // GIR_Coverage, 21845,
     /*  534014 */     GIR_EraseRootFromParent_Done,
     /*  534015 */   // Label 8856: @534015
     /*  534015 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(534086), // Rule ID 21848 //
     /*  534020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534052 */     // MIs[0] round
     /*  534052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534062 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  534065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534071 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534084 */     GIR_RootConstrainSelectedInstOperands,
     /*  534085 */     // GIR_Coverage, 21848,
     /*  534085 */     GIR_EraseRootFromParent_Done,
     /*  534086 */   // Label 8857: @534086
     /*  534086 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(534157), // Rule ID 21849 //
     /*  534091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534123 */     // MIs[0] round
     /*  534123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534133 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11227:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  534136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534142 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534155 */     GIR_RootConstrainSelectedInstOperands,
     /*  534156 */     // GIR_Coverage, 21849,
     /*  534156 */     GIR_EraseRootFromParent_Done,
     /*  534157 */   // Label 8858: @534157
     /*  534157 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(534228), // Rule ID 21852 //
     /*  534162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534194 */     // MIs[0] round
     /*  534194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534204 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  534207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534213 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534226 */     GIR_RootConstrainSelectedInstOperands,
     /*  534227 */     // GIR_Coverage, 21852,
     /*  534227 */     GIR_EraseRootFromParent_Done,
     /*  534228 */   // Label 8859: @534228
     /*  534228 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(534299), // Rule ID 21853 //
     /*  534233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534265 */     // MIs[0] round
     /*  534265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534275 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  534278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534284 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534297 */     GIR_RootConstrainSelectedInstOperands,
     /*  534298 */     // GIR_Coverage, 21853,
     /*  534298 */     GIR_EraseRootFromParent_Done,
     /*  534299 */   // Label 8860: @534299
     /*  534299 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(534370), // Rule ID 21856 //
     /*  534304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534336 */     // MIs[0] round
     /*  534336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534346 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  534349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534355 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534368 */     GIR_RootConstrainSelectedInstOperands,
     /*  534369 */     // GIR_Coverage, 21856,
     /*  534369 */     GIR_EraseRootFromParent_Done,
     /*  534370 */   // Label 8861: @534370
     /*  534370 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(534441), // Rule ID 21857 //
     /*  534375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  534386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  534389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  534392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534407 */     // MIs[0] round
     /*  534407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534417 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  534420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534426 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534439 */     GIR_RootConstrainSelectedInstOperands,
     /*  534440 */     // GIR_Coverage, 21857,
     /*  534440 */     GIR_EraseRootFromParent_Done,
     /*  534441 */   // Label 8862: @534441
     /*  534441 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(534512), // Rule ID 21860 //
     /*  534446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534478 */     // MIs[0] round
     /*  534478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534488 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  534491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534497 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534510 */     GIR_RootConstrainSelectedInstOperands,
     /*  534511 */     // GIR_Coverage, 21860,
     /*  534511 */     GIR_EraseRootFromParent_Done,
     /*  534512 */   // Label 8863: @534512
     /*  534512 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(534583), // Rule ID 21861 //
     /*  534517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534549 */     // MIs[0] round
     /*  534549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534559 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  534562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534568 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534581 */     GIR_RootConstrainSelectedInstOperands,
     /*  534582 */     // GIR_Coverage, 21861,
     /*  534582 */     GIR_EraseRootFromParent_Done,
     /*  534583 */   // Label 8864: @534583
     /*  534583 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(534654), // Rule ID 21864 //
     /*  534588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  534599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  534602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  534605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534620 */     // MIs[0] round
     /*  534620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534630 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  534633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534639 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534652 */     GIR_RootConstrainSelectedInstOperands,
     /*  534653 */     // GIR_Coverage, 21864,
     /*  534653 */     GIR_EraseRootFromParent_Done,
     /*  534654 */   // Label 8865: @534654
     /*  534654 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(534725), // Rule ID 21865 //
     /*  534659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  534670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  534673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  534676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534691 */     // MIs[0] round
     /*  534691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534701 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  534704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534710 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534723 */     GIR_RootConstrainSelectedInstOperands,
     /*  534724 */     // GIR_Coverage, 21865,
     /*  534724 */     GIR_EraseRootFromParent_Done,
     /*  534725 */   // Label 8866: @534725
     /*  534725 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(534796), // Rule ID 21868 //
     /*  534730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  534741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  534744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  534747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534762 */     // MIs[0] round
     /*  534762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534772 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  534775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534781 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534794 */     GIR_RootConstrainSelectedInstOperands,
     /*  534795 */     // GIR_Coverage, 21868,
     /*  534795 */     GIR_EraseRootFromParent_Done,
     /*  534796 */   // Label 8867: @534796
     /*  534796 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(534867), // Rule ID 21869 //
     /*  534801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  534812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  534815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  534818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534833 */     // MIs[0] round
     /*  534833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534843 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  534846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534852 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534865 */     GIR_RootConstrainSelectedInstOperands,
     /*  534866 */     // GIR_Coverage, 21869,
     /*  534866 */     GIR_EraseRootFromParent_Done,
     /*  534867 */   // Label 8868: @534867
     /*  534867 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(534938), // Rule ID 21872 //
     /*  534872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534904 */     // MIs[0] round
     /*  534904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534914 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  534917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534923 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534936 */     GIR_RootConstrainSelectedInstOperands,
     /*  534937 */     // GIR_Coverage, 21872,
     /*  534937 */     GIR_EraseRootFromParent_Done,
     /*  534938 */   // Label 8869: @534938
     /*  534938 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(535009), // Rule ID 21873 //
     /*  534943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534975 */     // MIs[0] round
     /*  534975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534985 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  534988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534994 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535007 */     GIR_RootConstrainSelectedInstOperands,
     /*  535008 */     // GIR_Coverage, 21873,
     /*  535008 */     GIR_EraseRootFromParent_Done,
     /*  535009 */   // Label 8870: @535009
     /*  535009 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(535080), // Rule ID 21876 //
     /*  535014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  535025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  535028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  535031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535046 */     // MIs[0] round
     /*  535046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535056 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  535059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535065 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535078 */     GIR_RootConstrainSelectedInstOperands,
     /*  535079 */     // GIR_Coverage, 21876,
     /*  535079 */     GIR_EraseRootFromParent_Done,
     /*  535080 */   // Label 8871: @535080
     /*  535080 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(535151), // Rule ID 21877 //
     /*  535085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  535096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  535099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  535102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535117 */     // MIs[0] round
     /*  535117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535127 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  535130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535136 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535149 */     GIR_RootConstrainSelectedInstOperands,
     /*  535150 */     // GIR_Coverage, 21877,
     /*  535150 */     GIR_EraseRootFromParent_Done,
     /*  535151 */   // Label 8872: @535151
     /*  535151 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(535222), // Rule ID 21880 //
     /*  535156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  535167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  535170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535188 */     // MIs[0] round
     /*  535188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535198 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  535201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535207 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535220 */     GIR_RootConstrainSelectedInstOperands,
     /*  535221 */     // GIR_Coverage, 21880,
     /*  535221 */     GIR_EraseRootFromParent_Done,
     /*  535222 */   // Label 8873: @535222
     /*  535222 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(535293), // Rule ID 21881 //
     /*  535227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  535238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  535241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  535244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535259 */     // MIs[0] round
     /*  535259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535269 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  535272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535278 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535291 */     GIR_RootConstrainSelectedInstOperands,
     /*  535292 */     // GIR_Coverage, 21881,
     /*  535292 */     GIR_EraseRootFromParent_Done,
     /*  535293 */   // Label 8874: @535293
     /*  535293 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(535364), // Rule ID 21884 //
     /*  535298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  535309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  535312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  535315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535330 */     // MIs[0] round
     /*  535330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535340 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  535343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535349 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535362 */     GIR_RootConstrainSelectedInstOperands,
     /*  535363 */     // GIR_Coverage, 21884,
     /*  535363 */     GIR_EraseRootFromParent_Done,
     /*  535364 */   // Label 8875: @535364
     /*  535364 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(535435), // Rule ID 21885 //
     /*  535369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  535380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  535383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  535386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535401 */     // MIs[0] round
     /*  535401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535411 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11225:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  535414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535420 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535433 */     GIR_RootConstrainSelectedInstOperands,
     /*  535434 */     // GIR_Coverage, 21885,
     /*  535434 */     GIR_EraseRootFromParent_Done,
     /*  535435 */   // Label 8876: @535435
     /*  535435 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(535506), // Rule ID 21888 //
     /*  535440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  535457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535472 */     // MIs[0] round
     /*  535472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535482 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  535485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535491 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535504 */     GIR_RootConstrainSelectedInstOperands,
     /*  535505 */     // GIR_Coverage, 21888,
     /*  535505 */     GIR_EraseRootFromParent_Done,
     /*  535506 */   // Label 8877: @535506
     /*  535506 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(535577), // Rule ID 21889 //
     /*  535511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  535528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535543 */     // MIs[0] round
     /*  535543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535553 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  535556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535562 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535575 */     GIR_RootConstrainSelectedInstOperands,
     /*  535576 */     // GIR_Coverage, 21889,
     /*  535576 */     GIR_EraseRootFromParent_Done,
     /*  535577 */   // Label 8878: @535577
     /*  535577 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(535648), // Rule ID 21892 //
     /*  535582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  535593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  535596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  535599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535614 */     // MIs[0] round
     /*  535614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535624 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  535627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535633 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535646 */     GIR_RootConstrainSelectedInstOperands,
     /*  535647 */     // GIR_Coverage, 21892,
     /*  535647 */     GIR_EraseRootFromParent_Done,
     /*  535648 */   // Label 8879: @535648
     /*  535648 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(535719), // Rule ID 21893 //
     /*  535653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  535664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  535667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  535670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535685 */     // MIs[0] round
     /*  535685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535695 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  535698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535704 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535717 */     GIR_RootConstrainSelectedInstOperands,
     /*  535718 */     // GIR_Coverage, 21893,
     /*  535718 */     GIR_EraseRootFromParent_Done,
     /*  535719 */   // Label 8880: @535719
     /*  535719 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(535790), // Rule ID 21896 //
     /*  535724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  535735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  535738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535756 */     // MIs[0] round
     /*  535756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535766 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  535769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535775 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535788 */     GIR_RootConstrainSelectedInstOperands,
     /*  535789 */     // GIR_Coverage, 21896,
     /*  535789 */     GIR_EraseRootFromParent_Done,
     /*  535790 */   // Label 8881: @535790
     /*  535790 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(535861), // Rule ID 21897 //
     /*  535795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  535806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  535809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535827 */     // MIs[0] round
     /*  535827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535837 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  535840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535846 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535859 */     GIR_RootConstrainSelectedInstOperands,
     /*  535860 */     // GIR_Coverage, 21897,
     /*  535860 */     GIR_EraseRootFromParent_Done,
     /*  535861 */   // Label 8882: @535861
     /*  535861 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(535932), // Rule ID 21900 //
     /*  535866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535898 */     // MIs[0] round
     /*  535898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  535911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535917 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535930 */     GIR_RootConstrainSelectedInstOperands,
     /*  535931 */     // GIR_Coverage, 21900,
     /*  535931 */     GIR_EraseRootFromParent_Done,
     /*  535932 */   // Label 8883: @535932
     /*  535932 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(536003), // Rule ID 21901 //
     /*  535937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535969 */     // MIs[0] round
     /*  535969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535979 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  535982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535988 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536001 */     GIR_RootConstrainSelectedInstOperands,
     /*  536002 */     // GIR_Coverage, 21901,
     /*  536002 */     GIR_EraseRootFromParent_Done,
     /*  536003 */   // Label 8884: @536003
     /*  536003 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(536074), // Rule ID 21904 //
     /*  536008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536040 */     // MIs[0] round
     /*  536040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  536053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536059 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536072 */     GIR_RootConstrainSelectedInstOperands,
     /*  536073 */     // GIR_Coverage, 21904,
     /*  536073 */     GIR_EraseRootFromParent_Done,
     /*  536074 */   // Label 8885: @536074
     /*  536074 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(536145), // Rule ID 21905 //
     /*  536079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536111 */     // MIs[0] round
     /*  536111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536121 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  536124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536130 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536143 */     GIR_RootConstrainSelectedInstOperands,
     /*  536144 */     // GIR_Coverage, 21905,
     /*  536144 */     GIR_EraseRootFromParent_Done,
     /*  536145 */   // Label 8886: @536145
     /*  536145 */   GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(536216), // Rule ID 21908 //
     /*  536150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  536153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536182 */     // MIs[0] round
     /*  536182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536192 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  536195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536201 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536214 */     GIR_RootConstrainSelectedInstOperands,
     /*  536215 */     // GIR_Coverage, 21908,
     /*  536215 */     GIR_EraseRootFromParent_Done,
     /*  536216 */   // Label 8887: @536216
     /*  536216 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(536287), // Rule ID 21909 //
     /*  536221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  536224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  536229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536253 */     // MIs[0] round
     /*  536253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536263 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  536266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536272 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536285 */     GIR_RootConstrainSelectedInstOperands,
     /*  536286 */     // GIR_Coverage, 21909,
     /*  536286 */     GIR_EraseRootFromParent_Done,
     /*  536287 */   // Label 8888: @536287
     /*  536287 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(536358), // Rule ID 21912 //
     /*  536292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536324 */     // MIs[0] round
     /*  536324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536334 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536343 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536356 */     GIR_RootConstrainSelectedInstOperands,
     /*  536357 */     // GIR_Coverage, 21912,
     /*  536357 */     GIR_EraseRootFromParent_Done,
     /*  536358 */   // Label 8889: @536358
     /*  536358 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(536429), // Rule ID 21913 //
     /*  536363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536395 */     // MIs[0] round
     /*  536395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536405 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536414 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536427 */     GIR_RootConstrainSelectedInstOperands,
     /*  536428 */     // GIR_Coverage, 21913,
     /*  536428 */     GIR_EraseRootFromParent_Done,
     /*  536429 */   // Label 8890: @536429
     /*  536429 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(536500), // Rule ID 21916 //
     /*  536434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536466 */     // MIs[0] round
     /*  536466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536476 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  536479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536485 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536498 */     GIR_RootConstrainSelectedInstOperands,
     /*  536499 */     // GIR_Coverage, 21916,
     /*  536499 */     GIR_EraseRootFromParent_Done,
     /*  536500 */   // Label 8891: @536500
     /*  536500 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(536571), // Rule ID 21917 //
     /*  536505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536537 */     // MIs[0] round
     /*  536537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536547 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  536550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536556 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536569 */     GIR_RootConstrainSelectedInstOperands,
     /*  536570 */     // GIR_Coverage, 21917,
     /*  536570 */     GIR_EraseRootFromParent_Done,
     /*  536571 */   // Label 8892: @536571
     /*  536571 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(536642), // Rule ID 21920 //
     /*  536576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536608 */     // MIs[0] round
     /*  536608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536618 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  536621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536627 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536640 */     GIR_RootConstrainSelectedInstOperands,
     /*  536641 */     // GIR_Coverage, 21920,
     /*  536641 */     GIR_EraseRootFromParent_Done,
     /*  536642 */   // Label 8893: @536642
     /*  536642 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(536713), // Rule ID 21921 //
     /*  536647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536679 */     // MIs[0] round
     /*  536679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536689 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11223:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  536692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536698 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536711 */     GIR_RootConstrainSelectedInstOperands,
     /*  536712 */     // GIR_Coverage, 21921,
     /*  536712 */     GIR_EraseRootFromParent_Done,
     /*  536713 */   // Label 8894: @536713
     /*  536713 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(536784), // Rule ID 21924 //
     /*  536718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536750 */     // MIs[0] round
     /*  536750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536760 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  536763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536769 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536782 */     GIR_RootConstrainSelectedInstOperands,
     /*  536783 */     // GIR_Coverage, 21924,
     /*  536783 */     GIR_EraseRootFromParent_Done,
     /*  536784 */   // Label 8895: @536784
     /*  536784 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(536855), // Rule ID 21925 //
     /*  536789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536821 */     // MIs[0] round
     /*  536821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536831 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  536834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536840 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536853 */     GIR_RootConstrainSelectedInstOperands,
     /*  536854 */     // GIR_Coverage, 21925,
     /*  536854 */     GIR_EraseRootFromParent_Done,
     /*  536855 */   // Label 8896: @536855
     /*  536855 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(536926), // Rule ID 21928 //
     /*  536860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /*  536863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536892 */     // MIs[0] round
     /*  536892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536902 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  536905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536911 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536924 */     GIR_RootConstrainSelectedInstOperands,
     /*  536925 */     // GIR_Coverage, 21928,
     /*  536925 */     GIR_EraseRootFromParent_Done,
     /*  536926 */   // Label 8897: @536926
     /*  536926 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(536997), // Rule ID 21929 //
     /*  536931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /*  536934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536963 */     // MIs[0] round
     /*  536963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536973 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  536976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536982 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536995 */     GIR_RootConstrainSelectedInstOperands,
     /*  536996 */     // GIR_Coverage, 21929,
     /*  536996 */     GIR_EraseRootFromParent_Done,
     /*  536997 */   // Label 8898: @536997
     /*  536997 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(537068), // Rule ID 21932 //
     /*  537002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537034 */     // MIs[0] round
     /*  537034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537044 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  537047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537053 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537066 */     GIR_RootConstrainSelectedInstOperands,
     /*  537067 */     // GIR_Coverage, 21932,
     /*  537067 */     GIR_EraseRootFromParent_Done,
     /*  537068 */   // Label 8899: @537068
     /*  537068 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(537139), // Rule ID 21933 //
     /*  537073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  537090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537105 */     // MIs[0] round
     /*  537105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537115 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  537118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537124 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537137 */     GIR_RootConstrainSelectedInstOperands,
     /*  537138 */     // GIR_Coverage, 21933,
     /*  537138 */     GIR_EraseRootFromParent_Done,
     /*  537139 */   // Label 8900: @537139
     /*  537139 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(537210), // Rule ID 21936 //
     /*  537144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537176 */     // MIs[0] round
     /*  537176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537186 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  537189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537195 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537208 */     GIR_RootConstrainSelectedInstOperands,
     /*  537209 */     // GIR_Coverage, 21936,
     /*  537209 */     GIR_EraseRootFromParent_Done,
     /*  537210 */   // Label 8901: @537210
     /*  537210 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(537281), // Rule ID 21937 //
     /*  537215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  537226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  537229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  537232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537247 */     // MIs[0] round
     /*  537247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537257 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  537260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537266 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537279 */     GIR_RootConstrainSelectedInstOperands,
     /*  537280 */     // GIR_Coverage, 21937,
     /*  537280 */     GIR_EraseRootFromParent_Done,
     /*  537281 */   // Label 8902: @537281
     /*  537281 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(537352), // Rule ID 21940 //
     /*  537286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537318 */     // MIs[0] round
     /*  537318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537328 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  537331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537337 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537350 */     GIR_RootConstrainSelectedInstOperands,
     /*  537351 */     // GIR_Coverage, 21940,
     /*  537351 */     GIR_EraseRootFromParent_Done,
     /*  537352 */   // Label 8903: @537352
     /*  537352 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(537423), // Rule ID 21941 //
     /*  537357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  537368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  537371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  537374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537389 */     // MIs[0] round
     /*  537389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537399 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  537402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537408 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537421 */     GIR_RootConstrainSelectedInstOperands,
     /*  537422 */     // GIR_Coverage, 21941,
     /*  537422 */     GIR_EraseRootFromParent_Done,
     /*  537423 */   // Label 8904: @537423
     /*  537423 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(537494), // Rule ID 21944 //
     /*  537428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  537431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537460 */     // MIs[0] round
     /*  537460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537470 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  537470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  537473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537479 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537492 */     GIR_RootConstrainSelectedInstOperands,
     /*  537493 */     // GIR_Coverage, 21944,
     /*  537493 */     GIR_EraseRootFromParent_Done,
     /*  537494 */   // Label 8905: @537494
     /*  537494 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(537565), // Rule ID 21945 //
     /*  537499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  537502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  537507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  537510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  537513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  537516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537531 */     // MIs[0] round
     /*  537531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537541 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  537541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  537544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537550 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  537560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537563 */     GIR_RootConstrainSelectedInstOperands,
     /*  537564 */     // GIR_Coverage, 21945,
     /*  537564 */     GIR_EraseRootFromParent_Done,
     /*  537565 */   // Label 8906: @537565
     /*  537565 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(537636), // Rule ID 2754 //
     /*  537570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  537587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537598 */     // MIs[0] passthru
     /*  537598 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  537617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537634 */     GIR_RootConstrainSelectedInstOperands,
     /*  537635 */     // GIR_Coverage, 2754,
     /*  537635 */     GIR_EraseRootFromParent_Done,
     /*  537636 */   // Label 8907: @537636
     /*  537636 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(537707), // Rule ID 2755 //
     /*  537641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  537658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537669 */     // MIs[0] passthru
     /*  537669 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537685 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  537688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537705 */     GIR_RootConstrainSelectedInstOperands,
     /*  537706 */     // GIR_Coverage, 2755,
     /*  537706 */     GIR_EraseRootFromParent_Done,
     /*  537707 */   // Label 8908: @537707
     /*  537707 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(537778), // Rule ID 4070 //
     /*  537712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  537729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537740 */     // MIs[0] passthru
     /*  537740 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  537759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537776 */     GIR_RootConstrainSelectedInstOperands,
     /*  537777 */     // GIR_Coverage, 4070,
     /*  537777 */     GIR_EraseRootFromParent_Done,
     /*  537778 */   // Label 8909: @537778
     /*  537778 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(537849), // Rule ID 4071 //
     /*  537783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  537800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537811 */     // MIs[0] passthru
     /*  537811 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537827 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  537830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537847 */     GIR_RootConstrainSelectedInstOperands,
     /*  537848 */     // GIR_Coverage, 4071,
     /*  537848 */     GIR_EraseRootFromParent_Done,
     /*  537849 */   // Label 8910: @537849
     /*  537849 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(537920), // Rule ID 4080 //
     /*  537854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  537871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537882 */     // MIs[0] passthru
     /*  537882 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  537901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537918 */     GIR_RootConstrainSelectedInstOperands,
     /*  537919 */     // GIR_Coverage, 4080,
     /*  537919 */     GIR_EraseRootFromParent_Done,
     /*  537920 */   // Label 8911: @537920
     /*  537920 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(537991), // Rule ID 4081 //
     /*  537925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  537942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537953 */     // MIs[0] passthru
     /*  537953 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537969 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  537972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537989 */     GIR_RootConstrainSelectedInstOperands,
     /*  537990 */     // GIR_Coverage, 4081,
     /*  537990 */     GIR_EraseRootFromParent_Done,
     /*  537991 */   // Label 8912: @537991
     /*  537991 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(538062), // Rule ID 4090 //
     /*  537996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  538013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538024 */     // MIs[0] passthru
     /*  538024 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538040 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538060 */     GIR_RootConstrainSelectedInstOperands,
     /*  538061 */     // GIR_Coverage, 4090,
     /*  538061 */     GIR_EraseRootFromParent_Done,
     /*  538062 */   // Label 8913: @538062
     /*  538062 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(538133), // Rule ID 4091 //
     /*  538067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  538078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  538081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  538084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538095 */     // MIs[0] passthru
     /*  538095 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538131 */     GIR_RootConstrainSelectedInstOperands,
     /*  538132 */     // GIR_Coverage, 4091,
     /*  538132 */     GIR_EraseRootFromParent_Done,
     /*  538133 */   // Label 8914: @538133
     /*  538133 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(538204), // Rule ID 4100 //
     /*  538138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  538155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538166 */     // MIs[0] passthru
     /*  538166 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538202 */     GIR_RootConstrainSelectedInstOperands,
     /*  538203 */     // GIR_Coverage, 4100,
     /*  538203 */     GIR_EraseRootFromParent_Done,
     /*  538204 */   // Label 8915: @538204
     /*  538204 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(538275), // Rule ID 4101 //
     /*  538209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  538220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  538223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  538226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538237 */     // MIs[0] passthru
     /*  538237 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538253 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538273 */     GIR_RootConstrainSelectedInstOperands,
     /*  538274 */     // GIR_Coverage, 4101,
     /*  538274 */     GIR_EraseRootFromParent_Done,
     /*  538275 */   // Label 8916: @538275
     /*  538275 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(538346), // Rule ID 4110 //
     /*  538280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  538291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  538294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  538297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538308 */     // MIs[0] passthru
     /*  538308 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538324 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  538324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538344 */     GIR_RootConstrainSelectedInstOperands,
     /*  538345 */     // GIR_Coverage, 4110,
     /*  538345 */     GIR_EraseRootFromParent_Done,
     /*  538346 */   // Label 8917: @538346
     /*  538346 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(538417), // Rule ID 4111 //
     /*  538351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  538362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  538365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  538368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538379 */     // MIs[0] passthru
     /*  538379 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538395 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  538395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  538412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538415 */     GIR_RootConstrainSelectedInstOperands,
     /*  538416 */     // GIR_Coverage, 4111,
     /*  538416 */     GIR_EraseRootFromParent_Done,
     /*  538417 */   // Label 8918: @538417
     /*  538417 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(538488), // Rule ID 4120 //
     /*  538422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  538439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538450 */     // MIs[0] passthru
     /*  538450 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538486 */     GIR_RootConstrainSelectedInstOperands,
     /*  538487 */     // GIR_Coverage, 4120,
     /*  538487 */     GIR_EraseRootFromParent_Done,
     /*  538488 */   // Label 8919: @538488
     /*  538488 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(538559), // Rule ID 4121 //
     /*  538493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  538504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  538507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  538510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538521 */     // MIs[0] passthru
     /*  538521 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538537 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538557 */     GIR_RootConstrainSelectedInstOperands,
     /*  538558 */     // GIR_Coverage, 4121,
     /*  538558 */     GIR_EraseRootFromParent_Done,
     /*  538559 */   // Label 8920: @538559
     /*  538559 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(538630), // Rule ID 4130 //
     /*  538564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  538581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538592 */     // MIs[0] passthru
     /*  538592 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538628 */     GIR_RootConstrainSelectedInstOperands,
     /*  538629 */     // GIR_Coverage, 4130,
     /*  538629 */     GIR_EraseRootFromParent_Done,
     /*  538630 */   // Label 8921: @538630
     /*  538630 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(538701), // Rule ID 4131 //
     /*  538635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  538652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538663 */     // MIs[0] passthru
     /*  538663 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538679 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538699 */     GIR_RootConstrainSelectedInstOperands,
     /*  538700 */     // GIR_Coverage, 4131,
     /*  538700 */     GIR_EraseRootFromParent_Done,
     /*  538701 */   // Label 8922: @538701
     /*  538701 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(538772), // Rule ID 4140 //
     /*  538706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  538723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538734 */     // MIs[0] passthru
     /*  538734 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538770 */     GIR_RootConstrainSelectedInstOperands,
     /*  538771 */     // GIR_Coverage, 4140,
     /*  538771 */     GIR_EraseRootFromParent_Done,
     /*  538772 */   // Label 8923: @538772
     /*  538772 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(538843), // Rule ID 4141 //
     /*  538777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  538794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538805 */     // MIs[0] passthru
     /*  538805 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538821 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538841 */     GIR_RootConstrainSelectedInstOperands,
     /*  538842 */     // GIR_Coverage, 4141,
     /*  538842 */     GIR_EraseRootFromParent_Done,
     /*  538843 */   // Label 8924: @538843
     /*  538843 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(538914), // Rule ID 4150 //
     /*  538848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  538865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538876 */     // MIs[0] passthru
     /*  538876 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538912 */     GIR_RootConstrainSelectedInstOperands,
     /*  538913 */     // GIR_Coverage, 4150,
     /*  538913 */     GIR_EraseRootFromParent_Done,
     /*  538914 */   // Label 8925: @538914
     /*  538914 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(538985), // Rule ID 4151 //
     /*  538919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  538936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538947 */     // MIs[0] passthru
     /*  538947 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538963 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538983 */     GIR_RootConstrainSelectedInstOperands,
     /*  538984 */     // GIR_Coverage, 4151,
     /*  538984 */     GIR_EraseRootFromParent_Done,
     /*  538985 */   // Label 8926: @538985
     /*  538985 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(539056), // Rule ID 4160 //
     /*  538990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  539007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539018 */     // MIs[0] passthru
     /*  539018 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  539034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539054 */     GIR_RootConstrainSelectedInstOperands,
     /*  539055 */     // GIR_Coverage, 4160,
     /*  539055 */     GIR_EraseRootFromParent_Done,
     /*  539056 */   // Label 8927: @539056
     /*  539056 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(539127), // Rule ID 4161 //
     /*  539061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  539072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  539075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  539078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539089 */     // MIs[0] passthru
     /*  539089 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539105 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  539105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  539122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539125 */     GIR_RootConstrainSelectedInstOperands,
     /*  539126 */     // GIR_Coverage, 4161,
     /*  539126 */     GIR_EraseRootFromParent_Done,
     /*  539127 */   // Label 8928: @539127
     /*  539127 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(539198), // Rule ID 4170 //
     /*  539132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  539143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  539146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  539149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539160 */     // MIs[0] passthru
     /*  539160 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539176 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539196 */     GIR_RootConstrainSelectedInstOperands,
     /*  539197 */     // GIR_Coverage, 4170,
     /*  539197 */     GIR_EraseRootFromParent_Done,
     /*  539198 */   // Label 8929: @539198
     /*  539198 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(539269), // Rule ID 4171 //
     /*  539203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  539214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  539217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  539220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539231 */     // MIs[0] passthru
     /*  539231 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539247 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  539250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539267 */     GIR_RootConstrainSelectedInstOperands,
     /*  539268 */     // GIR_Coverage, 4171,
     /*  539268 */     GIR_EraseRootFromParent_Done,
     /*  539269 */   // Label 8930: @539269
     /*  539269 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(539340), // Rule ID 4180 //
     /*  539274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  539285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  539288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  539291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539302 */     // MIs[0] passthru
     /*  539302 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539338 */     GIR_RootConstrainSelectedInstOperands,
     /*  539339 */     // GIR_Coverage, 4180,
     /*  539339 */     GIR_EraseRootFromParent_Done,
     /*  539340 */   // Label 8931: @539340
     /*  539340 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(539411), // Rule ID 4181 //
     /*  539345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  539356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  539359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  539362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539373 */     // MIs[0] passthru
     /*  539373 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539389 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  539392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539409 */     GIR_RootConstrainSelectedInstOperands,
     /*  539410 */     // GIR_Coverage, 4181,
     /*  539410 */     GIR_EraseRootFromParent_Done,
     /*  539411 */   // Label 8932: @539411
     /*  539411 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(539482), // Rule ID 4190 //
     /*  539416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  539427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  539430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  539433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539444 */     // MIs[0] passthru
     /*  539444 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539480 */     GIR_RootConstrainSelectedInstOperands,
     /*  539481 */     // GIR_Coverage, 4190,
     /*  539481 */     GIR_EraseRootFromParent_Done,
     /*  539482 */   // Label 8933: @539482
     /*  539482 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(539553), // Rule ID 4191 //
     /*  539487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  539498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  539501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  539504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539515 */     // MIs[0] passthru
     /*  539515 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539531 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539551 */     GIR_RootConstrainSelectedInstOperands,
     /*  539552 */     // GIR_Coverage, 4191,
     /*  539552 */     GIR_EraseRootFromParent_Done,
     /*  539553 */   // Label 8934: @539553
     /*  539553 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(539624), // Rule ID 4200 //
     /*  539558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  539569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  539572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  539575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539586 */     // MIs[0] passthru
     /*  539586 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539622 */     GIR_RootConstrainSelectedInstOperands,
     /*  539623 */     // GIR_Coverage, 4200,
     /*  539623 */     GIR_EraseRootFromParent_Done,
     /*  539624 */   // Label 8935: @539624
     /*  539624 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(539695), // Rule ID 4201 //
     /*  539629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  539640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  539643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  539646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539657 */     // MIs[0] passthru
     /*  539657 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539673 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539693 */     GIR_RootConstrainSelectedInstOperands,
     /*  539694 */     // GIR_Coverage, 4201,
     /*  539694 */     GIR_EraseRootFromParent_Done,
     /*  539695 */   // Label 8936: @539695
     /*  539695 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(539766), // Rule ID 4270 //
     /*  539700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  539711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  539714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  539717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539728 */     // MIs[0] passthru
     /*  539728 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  539747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539764 */     GIR_RootConstrainSelectedInstOperands,
     /*  539765 */     // GIR_Coverage, 4270,
     /*  539765 */     GIR_EraseRootFromParent_Done,
     /*  539766 */   // Label 8937: @539766
     /*  539766 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(539837), // Rule ID 4271 //
     /*  539771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  539782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  539785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  539788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539799 */     // MIs[0] passthru
     /*  539799 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539815 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  539818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539835 */     GIR_RootConstrainSelectedInstOperands,
     /*  539836 */     // GIR_Coverage, 4271,
     /*  539836 */     GIR_EraseRootFromParent_Done,
     /*  539837 */   // Label 8938: @539837
     /*  539837 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(539908), // Rule ID 4280 //
     /*  539842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  539859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539870 */     // MIs[0] passthru
     /*  539870 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539886 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  539889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539906 */     GIR_RootConstrainSelectedInstOperands,
     /*  539907 */     // GIR_Coverage, 4280,
     /*  539907 */     GIR_EraseRootFromParent_Done,
     /*  539908 */   // Label 8939: @539908
     /*  539908 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(539979), // Rule ID 4281 //
     /*  539913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  539930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539941 */     // MIs[0] passthru
     /*  539941 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539957 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  539960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539977 */     GIR_RootConstrainSelectedInstOperands,
     /*  539978 */     // GIR_Coverage, 4281,
     /*  539978 */     GIR_EraseRootFromParent_Done,
     /*  539979 */   // Label 8940: @539979
     /*  539979 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(540050), // Rule ID 4290 //
     /*  539984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  539995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  539998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540012 */     // MIs[0] passthru
     /*  540012 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540028 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540048 */     GIR_RootConstrainSelectedInstOperands,
     /*  540049 */     // GIR_Coverage, 4290,
     /*  540049 */     GIR_EraseRootFromParent_Done,
     /*  540050 */   // Label 8941: @540050
     /*  540050 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(540121), // Rule ID 4291 //
     /*  540055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  540066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  540069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  540072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540083 */     // MIs[0] passthru
     /*  540083 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540099 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540119 */     GIR_RootConstrainSelectedInstOperands,
     /*  540120 */     // GIR_Coverage, 4291,
     /*  540120 */     GIR_EraseRootFromParent_Done,
     /*  540121 */   // Label 8942: @540121
     /*  540121 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(540192), // Rule ID 4300 //
     /*  540126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  540137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  540140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  540143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540154 */     // MIs[0] passthru
     /*  540154 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540170 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540190 */     GIR_RootConstrainSelectedInstOperands,
     /*  540191 */     // GIR_Coverage, 4300,
     /*  540191 */     GIR_EraseRootFromParent_Done,
     /*  540192 */   // Label 8943: @540192
     /*  540192 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(540263), // Rule ID 4301 //
     /*  540197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  540208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  540211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  540214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540225 */     // MIs[0] passthru
     /*  540225 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540241 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540261 */     GIR_RootConstrainSelectedInstOperands,
     /*  540262 */     // GIR_Coverage, 4301,
     /*  540262 */     GIR_EraseRootFromParent_Done,
     /*  540263 */   // Label 8944: @540263
     /*  540263 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(540334), // Rule ID 4310 //
     /*  540268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  540279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  540282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  540285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540296 */     // MIs[0] passthru
     /*  540296 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540312 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540332 */     GIR_RootConstrainSelectedInstOperands,
     /*  540333 */     // GIR_Coverage, 4310,
     /*  540333 */     GIR_EraseRootFromParent_Done,
     /*  540334 */   // Label 8945: @540334
     /*  540334 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(540405), // Rule ID 4311 //
     /*  540339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  540350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  540353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  540356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540367 */     // MIs[0] passthru
     /*  540367 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540383 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540403 */     GIR_RootConstrainSelectedInstOperands,
     /*  540404 */     // GIR_Coverage, 4311,
     /*  540404 */     GIR_EraseRootFromParent_Done,
     /*  540405 */   // Label 8946: @540405
     /*  540405 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(540476), // Rule ID 4320 //
     /*  540410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  540421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  540424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  540427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540438 */     // MIs[0] passthru
     /*  540438 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  540454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540474 */     GIR_RootConstrainSelectedInstOperands,
     /*  540475 */     // GIR_Coverage, 4320,
     /*  540475 */     GIR_EraseRootFromParent_Done,
     /*  540476 */   // Label 8947: @540476
     /*  540476 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(540547), // Rule ID 4321 //
     /*  540481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  540492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  540495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  540498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540509 */     // MIs[0] passthru
     /*  540509 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540525 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540545 */     GIR_RootConstrainSelectedInstOperands,
     /*  540546 */     // GIR_Coverage, 4321,
     /*  540546 */     GIR_EraseRootFromParent_Done,
     /*  540547 */   // Label 8948: @540547
     /*  540547 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(540618), // Rule ID 4330 //
     /*  540552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  540569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540580 */     // MIs[0] passthru
     /*  540580 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540596 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540616 */     GIR_RootConstrainSelectedInstOperands,
     /*  540617 */     // GIR_Coverage, 4330,
     /*  540617 */     GIR_EraseRootFromParent_Done,
     /*  540618 */   // Label 8949: @540618
     /*  540618 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(540689), // Rule ID 4331 //
     /*  540623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  540640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540651 */     // MIs[0] passthru
     /*  540651 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540667 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540687 */     GIR_RootConstrainSelectedInstOperands,
     /*  540688 */     // GIR_Coverage, 4331,
     /*  540688 */     GIR_EraseRootFromParent_Done,
     /*  540689 */   // Label 8950: @540689
     /*  540689 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(540760), // Rule ID 4340 //
     /*  540694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  540711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540722 */     // MIs[0] passthru
     /*  540722 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540758 */     GIR_RootConstrainSelectedInstOperands,
     /*  540759 */     // GIR_Coverage, 4340,
     /*  540759 */     GIR_EraseRootFromParent_Done,
     /*  540760 */   // Label 8951: @540760
     /*  540760 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(540831), // Rule ID 4341 //
     /*  540765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  540782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540793 */     // MIs[0] passthru
     /*  540793 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540809 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540829 */     GIR_RootConstrainSelectedInstOperands,
     /*  540830 */     // GIR_Coverage, 4341,
     /*  540830 */     GIR_EraseRootFromParent_Done,
     /*  540831 */   // Label 8952: @540831
     /*  540831 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(540902), // Rule ID 4350 //
     /*  540836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  540853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540864 */     // MIs[0] passthru
     /*  540864 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540900 */     GIR_RootConstrainSelectedInstOperands,
     /*  540901 */     // GIR_Coverage, 4350,
     /*  540901 */     GIR_EraseRootFromParent_Done,
     /*  540902 */   // Label 8953: @540902
     /*  540902 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(540973), // Rule ID 4351 //
     /*  540907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  540924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540935 */     // MIs[0] passthru
     /*  540935 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540971 */     GIR_RootConstrainSelectedInstOperands,
     /*  540972 */     // GIR_Coverage, 4351,
     /*  540972 */     GIR_EraseRootFromParent_Done,
     /*  540973 */   // Label 8954: @540973
     /*  540973 */   GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(541044), // Rule ID 4360 //
     /*  540978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  540995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541006 */     // MIs[0] passthru
     /*  541006 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541042 */     GIR_RootConstrainSelectedInstOperands,
     /*  541043 */     // GIR_Coverage, 4360,
     /*  541043 */     GIR_EraseRootFromParent_Done,
     /*  541044 */   // Label 8955: @541044
     /*  541044 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(541115), // Rule ID 4361 //
     /*  541049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  541060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  541063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  541066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541077 */     // MIs[0] passthru
     /*  541077 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541093 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541113 */     GIR_RootConstrainSelectedInstOperands,
     /*  541114 */     // GIR_Coverage, 4361,
     /*  541114 */     GIR_EraseRootFromParent_Done,
     /*  541115 */   // Label 8956: @541115
     /*  541115 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(541186), // Rule ID 4370 //
     /*  541120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  541131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  541134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  541137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541148 */     // MIs[0] passthru
     /*  541148 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541164 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  541164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541184 */     GIR_RootConstrainSelectedInstOperands,
     /*  541185 */     // GIR_Coverage, 4370,
     /*  541185 */     GIR_EraseRootFromParent_Done,
     /*  541186 */   // Label 8957: @541186
     /*  541186 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(541257), // Rule ID 4371 //
     /*  541191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  541202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  541205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  541208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541219 */     // MIs[0] passthru
     /*  541219 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541235 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  541235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  541252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541255 */     GIR_RootConstrainSelectedInstOperands,
     /*  541256 */     // GIR_Coverage, 4371,
     /*  541256 */     GIR_EraseRootFromParent_Done,
     /*  541257 */   // Label 8958: @541257
     /*  541257 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(541328), // Rule ID 4380 //
     /*  541262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541290 */     // MIs[0] passthru
     /*  541290 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541306 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541326 */     GIR_RootConstrainSelectedInstOperands,
     /*  541327 */     // GIR_Coverage, 4380,
     /*  541327 */     GIR_EraseRootFromParent_Done,
     /*  541328 */   // Label 8959: @541328
     /*  541328 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(541399), // Rule ID 4381 //
     /*  541333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  541344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  541347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  541350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541361 */     // MIs[0] passthru
     /*  541361 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541377 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  541380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541397 */     GIR_RootConstrainSelectedInstOperands,
     /*  541398 */     // GIR_Coverage, 4381,
     /*  541398 */     GIR_EraseRootFromParent_Done,
     /*  541399 */   // Label 8960: @541399
     /*  541399 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(541470), // Rule ID 4390 //
     /*  541404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  541415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  541418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541432 */     // MIs[0] passthru
     /*  541432 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541468 */     GIR_RootConstrainSelectedInstOperands,
     /*  541469 */     // GIR_Coverage, 4390,
     /*  541469 */     GIR_EraseRootFromParent_Done,
     /*  541470 */   // Label 8961: @541470
     /*  541470 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(541541), // Rule ID 4391 //
     /*  541475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  541486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  541489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  541492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541503 */     // MIs[0] passthru
     /*  541503 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541519 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541539 */     GIR_RootConstrainSelectedInstOperands,
     /*  541540 */     // GIR_Coverage, 4391,
     /*  541540 */     GIR_EraseRootFromParent_Done,
     /*  541541 */   // Label 8962: @541541
     /*  541541 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(541612), // Rule ID 4400 //
     /*  541546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  541557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  541560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  541563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541574 */     // MIs[0] passthru
     /*  541574 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541590 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541610 */     GIR_RootConstrainSelectedInstOperands,
     /*  541611 */     // GIR_Coverage, 4400,
     /*  541611 */     GIR_EraseRootFromParent_Done,
     /*  541612 */   // Label 8963: @541612
     /*  541612 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(541683), // Rule ID 4401 //
     /*  541617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  541628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  541631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  541634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541645 */     // MIs[0] passthru
     /*  541645 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541661 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541681 */     GIR_RootConstrainSelectedInstOperands,
     /*  541682 */     // GIR_Coverage, 4401,
     /*  541682 */     GIR_EraseRootFromParent_Done,
     /*  541683 */   // Label 8964: @541683
     /*  541683 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(541754), // Rule ID 4410 //
     /*  541688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  541699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  541702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  541705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541716 */     // MIs[0] passthru
     /*  541716 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541732 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541752 */     GIR_RootConstrainSelectedInstOperands,
     /*  541753 */     // GIR_Coverage, 4410,
     /*  541753 */     GIR_EraseRootFromParent_Done,
     /*  541754 */   // Label 8965: @541754
     /*  541754 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(541825), // Rule ID 4411 //
     /*  541759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  541770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  541773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  541776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541787 */     // MIs[0] passthru
     /*  541787 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541803 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541823 */     GIR_RootConstrainSelectedInstOperands,
     /*  541824 */     // GIR_Coverage, 4411,
     /*  541824 */     GIR_EraseRootFromParent_Done,
     /*  541825 */   // Label 8966: @541825
     /*  541825 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(541896), // Rule ID 4480 //
     /*  541830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541858 */     // MIs[0] passthru
     /*  541858 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541874 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  541877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541894 */     GIR_RootConstrainSelectedInstOperands,
     /*  541895 */     // GIR_Coverage, 4480,
     /*  541895 */     GIR_EraseRootFromParent_Done,
     /*  541896 */   // Label 8967: @541896
     /*  541896 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(541967), // Rule ID 4481 //
     /*  541901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541929 */     // MIs[0] passthru
     /*  541929 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541945 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  541948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541965 */     GIR_RootConstrainSelectedInstOperands,
     /*  541966 */     // GIR_Coverage, 4481,
     /*  541966 */     GIR_EraseRootFromParent_Done,
     /*  541967 */   // Label 8968: @541967
     /*  541967 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(542038), // Rule ID 4490 //
     /*  541972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  541989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542000 */     // MIs[0] passthru
     /*  542000 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542036 */     GIR_RootConstrainSelectedInstOperands,
     /*  542037 */     // GIR_Coverage, 4490,
     /*  542037 */     GIR_EraseRootFromParent_Done,
     /*  542038 */   // Label 8969: @542038
     /*  542038 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(542109), // Rule ID 4491 //
     /*  542043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  542054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  542057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  542060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542071 */     // MIs[0] passthru
     /*  542071 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542087 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542107 */     GIR_RootConstrainSelectedInstOperands,
     /*  542108 */     // GIR_Coverage, 4491,
     /*  542108 */     GIR_EraseRootFromParent_Done,
     /*  542109 */   // Label 8970: @542109
     /*  542109 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(542180), // Rule ID 4500 //
     /*  542114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  542125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  542128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  542131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542142 */     // MIs[0] passthru
     /*  542142 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542178 */     GIR_RootConstrainSelectedInstOperands,
     /*  542179 */     // GIR_Coverage, 4500,
     /*  542179 */     GIR_EraseRootFromParent_Done,
     /*  542180 */   // Label 8971: @542180
     /*  542180 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(542251), // Rule ID 4501 //
     /*  542185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  542196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  542199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  542202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542213 */     // MIs[0] passthru
     /*  542213 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542229 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542249 */     GIR_RootConstrainSelectedInstOperands,
     /*  542250 */     // GIR_Coverage, 4501,
     /*  542250 */     GIR_EraseRootFromParent_Done,
     /*  542251 */   // Label 8972: @542251
     /*  542251 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(542322), // Rule ID 4510 //
     /*  542256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  542273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542284 */     // MIs[0] passthru
     /*  542284 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542300 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542320 */     GIR_RootConstrainSelectedInstOperands,
     /*  542321 */     // GIR_Coverage, 4510,
     /*  542321 */     GIR_EraseRootFromParent_Done,
     /*  542322 */   // Label 8973: @542322
     /*  542322 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(542393), // Rule ID 4511 //
     /*  542327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  542338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  542341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  542344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542355 */     // MIs[0] passthru
     /*  542355 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542371 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542391 */     GIR_RootConstrainSelectedInstOperands,
     /*  542392 */     // GIR_Coverage, 4511,
     /*  542392 */     GIR_EraseRootFromParent_Done,
     /*  542393 */   // Label 8974: @542393
     /*  542393 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(542464), // Rule ID 4520 //
     /*  542398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542426 */     // MIs[0] passthru
     /*  542426 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542442 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542462 */     GIR_RootConstrainSelectedInstOperands,
     /*  542463 */     // GIR_Coverage, 4520,
     /*  542463 */     GIR_EraseRootFromParent_Done,
     /*  542464 */   // Label 8975: @542464
     /*  542464 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(542535), // Rule ID 4521 //
     /*  542469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  542480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  542483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  542486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542497 */     // MIs[0] passthru
     /*  542497 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542513 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542533 */     GIR_RootConstrainSelectedInstOperands,
     /*  542534 */     // GIR_Coverage, 4521,
     /*  542534 */     GIR_EraseRootFromParent_Done,
     /*  542535 */   // Label 8976: @542535
     /*  542535 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(542606), // Rule ID 4530 //
     /*  542540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542568 */     // MIs[0] passthru
     /*  542568 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542584 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  542587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542604 */     GIR_RootConstrainSelectedInstOperands,
     /*  542605 */     // GIR_Coverage, 4530,
     /*  542605 */     GIR_EraseRootFromParent_Done,
     /*  542606 */   // Label 8977: @542606
     /*  542606 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(542677), // Rule ID 4531 //
     /*  542611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542639 */     // MIs[0] passthru
     /*  542639 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542655 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  542658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542675 */     GIR_RootConstrainSelectedInstOperands,
     /*  542676 */     // GIR_Coverage, 4531,
     /*  542676 */     GIR_EraseRootFromParent_Done,
     /*  542677 */   // Label 8978: @542677
     /*  542677 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(542748), // Rule ID 4540 //
     /*  542682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542710 */     // MIs[0] passthru
     /*  542710 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542746 */     GIR_RootConstrainSelectedInstOperands,
     /*  542747 */     // GIR_Coverage, 4540,
     /*  542747 */     GIR_EraseRootFromParent_Done,
     /*  542748 */   // Label 8979: @542748
     /*  542748 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(542819), // Rule ID 4541 //
     /*  542753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542781 */     // MIs[0] passthru
     /*  542781 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542797 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542817 */     GIR_RootConstrainSelectedInstOperands,
     /*  542818 */     // GIR_Coverage, 4541,
     /*  542818 */     GIR_EraseRootFromParent_Done,
     /*  542819 */   // Label 8980: @542819
     /*  542819 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(542890), // Rule ID 4550 //
     /*  542824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542852 */     // MIs[0] passthru
     /*  542852 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542888 */     GIR_RootConstrainSelectedInstOperands,
     /*  542889 */     // GIR_Coverage, 4550,
     /*  542889 */     GIR_EraseRootFromParent_Done,
     /*  542890 */   // Label 8981: @542890
     /*  542890 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(542961), // Rule ID 4551 //
     /*  542895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542923 */     // MIs[0] passthru
     /*  542923 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542939 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542959 */     GIR_RootConstrainSelectedInstOperands,
     /*  542960 */     // GIR_Coverage, 4551,
     /*  542960 */     GIR_EraseRootFromParent_Done,
     /*  542961 */   // Label 8982: @542961
     /*  542961 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(543032), // Rule ID 4560 //
     /*  542966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  542983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542994 */     // MIs[0] passthru
     /*  542994 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543010 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543030 */     GIR_RootConstrainSelectedInstOperands,
     /*  543031 */     // GIR_Coverage, 4560,
     /*  543031 */     GIR_EraseRootFromParent_Done,
     /*  543032 */   // Label 8983: @543032
     /*  543032 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(543103), // Rule ID 4561 //
     /*  543037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  543048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  543051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  543054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543065 */     // MIs[0] passthru
     /*  543065 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543081 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543101 */     GIR_RootConstrainSelectedInstOperands,
     /*  543102 */     // GIR_Coverage, 4561,
     /*  543102 */     GIR_EraseRootFromParent_Done,
     /*  543103 */   // Label 8984: @543103
     /*  543103 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(543174), // Rule ID 4570 //
     /*  543108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  543119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  543122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  543125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543136 */     // MIs[0] passthru
     /*  543136 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543172 */     GIR_RootConstrainSelectedInstOperands,
     /*  543173 */     // GIR_Coverage, 4570,
     /*  543173 */     GIR_EraseRootFromParent_Done,
     /*  543174 */   // Label 8985: @543174
     /*  543174 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(543245), // Rule ID 4571 //
     /*  543179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  543190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  543193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  543196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543207 */     // MIs[0] passthru
     /*  543207 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543223 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543243 */     GIR_RootConstrainSelectedInstOperands,
     /*  543244 */     // GIR_Coverage, 4571,
     /*  543244 */     GIR_EraseRootFromParent_Done,
     /*  543245 */   // Label 8986: @543245
     /*  543245 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(543316), // Rule ID 4580 //
     /*  543250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  543267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543278 */     // MIs[0] passthru
     /*  543278 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543294 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  543294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543314 */     GIR_RootConstrainSelectedInstOperands,
     /*  543315 */     // GIR_Coverage, 4580,
     /*  543315 */     GIR_EraseRootFromParent_Done,
     /*  543316 */   // Label 8987: @543316
     /*  543316 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(543387), // Rule ID 4581 //
     /*  543321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  543332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  543335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  543338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543349 */     // MIs[0] passthru
     /*  543349 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543365 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  543365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  543382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543385 */     GIR_RootConstrainSelectedInstOperands,
     /*  543386 */     // GIR_Coverage, 4581,
     /*  543386 */     GIR_EraseRootFromParent_Done,
     /*  543387 */   // Label 8988: @543387
     /*  543387 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(543458), // Rule ID 4590 //
     /*  543392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543420 */     // MIs[0] passthru
     /*  543420 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543436 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543456 */     GIR_RootConstrainSelectedInstOperands,
     /*  543457 */     // GIR_Coverage, 4590,
     /*  543457 */     GIR_EraseRootFromParent_Done,
     /*  543458 */   // Label 8989: @543458
     /*  543458 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(543529), // Rule ID 4591 //
     /*  543463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  543474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  543477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  543480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543491 */     // MIs[0] passthru
     /*  543491 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543507 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543527 */     GIR_RootConstrainSelectedInstOperands,
     /*  543528 */     // GIR_Coverage, 4591,
     /*  543528 */     GIR_EraseRootFromParent_Done,
     /*  543529 */   // Label 8990: @543529
     /*  543529 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(543600), // Rule ID 4600 //
     /*  543534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543562 */     // MIs[0] passthru
     /*  543562 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543598 */     GIR_RootConstrainSelectedInstOperands,
     /*  543599 */     // GIR_Coverage, 4600,
     /*  543599 */     GIR_EraseRootFromParent_Done,
     /*  543600 */   // Label 8991: @543600
     /*  543600 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(543671), // Rule ID 4601 //
     /*  543605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543633 */     // MIs[0] passthru
     /*  543633 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543669 */     GIR_RootConstrainSelectedInstOperands,
     /*  543670 */     // GIR_Coverage, 4601,
     /*  543670 */     GIR_EraseRootFromParent_Done,
     /*  543671 */   // Label 8992: @543671
     /*  543671 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(543742), // Rule ID 4610 //
     /*  543676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543704 */     // MIs[0] passthru
     /*  543704 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543740 */     GIR_RootConstrainSelectedInstOperands,
     /*  543741 */     // GIR_Coverage, 4610,
     /*  543741 */     GIR_EraseRootFromParent_Done,
     /*  543742 */   // Label 8993: @543742
     /*  543742 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(543813), // Rule ID 4611 //
     /*  543747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543775 */     // MIs[0] passthru
     /*  543775 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543791 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543811 */     GIR_RootConstrainSelectedInstOperands,
     /*  543812 */     // GIR_Coverage, 4611,
     /*  543812 */     GIR_EraseRootFromParent_Done,
     /*  543813 */   // Label 8994: @543813
     /*  543813 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(543884), // Rule ID 4620 //
     /*  543818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543846 */     // MIs[0] passthru
     /*  543846 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543882 */     GIR_RootConstrainSelectedInstOperands,
     /*  543883 */     // GIR_Coverage, 4620,
     /*  543883 */     GIR_EraseRootFromParent_Done,
     /*  543884 */   // Label 8995: @543884
     /*  543884 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(543955), // Rule ID 4621 //
     /*  543889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543917 */     // MIs[0] passthru
     /*  543917 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543933 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543953 */     GIR_RootConstrainSelectedInstOperands,
     /*  543954 */     // GIR_Coverage, 4621,
     /*  543954 */     GIR_EraseRootFromParent_Done,
     /*  543955 */   // Label 8996: @543955
     /*  543955 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(544026), // Rule ID 4690 //
     /*  543960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  543971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  543974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  543977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543988 */     // MIs[0] passthru
     /*  543988 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544004 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  544007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544024 */     GIR_RootConstrainSelectedInstOperands,
     /*  544025 */     // GIR_Coverage, 4690,
     /*  544025 */     GIR_EraseRootFromParent_Done,
     /*  544026 */   // Label 8997: @544026
     /*  544026 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(544097), // Rule ID 4691 //
     /*  544031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  544042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  544045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  544048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544059 */     // MIs[0] passthru
     /*  544059 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544075 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  544078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544095 */     GIR_RootConstrainSelectedInstOperands,
     /*  544096 */     // GIR_Coverage, 4691,
     /*  544096 */     GIR_EraseRootFromParent_Done,
     /*  544097 */   // Label 8998: @544097
     /*  544097 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(544168), // Rule ID 4700 //
     /*  544102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  544119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544130 */     // MIs[0] passthru
     /*  544130 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544146 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544166 */     GIR_RootConstrainSelectedInstOperands,
     /*  544167 */     // GIR_Coverage, 4700,
     /*  544167 */     GIR_EraseRootFromParent_Done,
     /*  544168 */   // Label 8999: @544168
     /*  544168 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(544239), // Rule ID 4701 //
     /*  544173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  544184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  544187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  544190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544201 */     // MIs[0] passthru
     /*  544201 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544217 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544237 */     GIR_RootConstrainSelectedInstOperands,
     /*  544238 */     // GIR_Coverage, 4701,
     /*  544238 */     GIR_EraseRootFromParent_Done,
     /*  544239 */   // Label 9000: @544239
     /*  544239 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(544310), // Rule ID 4710 //
     /*  544244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  544261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544272 */     // MIs[0] passthru
     /*  544272 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544288 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544308 */     GIR_RootConstrainSelectedInstOperands,
     /*  544309 */     // GIR_Coverage, 4710,
     /*  544309 */     GIR_EraseRootFromParent_Done,
     /*  544310 */   // Label 9001: @544310
     /*  544310 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(544381), // Rule ID 4711 //
     /*  544315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  544326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  544329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  544332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544343 */     // MIs[0] passthru
     /*  544343 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544359 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544379 */     GIR_RootConstrainSelectedInstOperands,
     /*  544380 */     // GIR_Coverage, 4711,
     /*  544380 */     GIR_EraseRootFromParent_Done,
     /*  544381 */   // Label 9002: @544381
     /*  544381 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(544452), // Rule ID 4720 //
     /*  544386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544414 */     // MIs[0] passthru
     /*  544414 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544450 */     GIR_RootConstrainSelectedInstOperands,
     /*  544451 */     // GIR_Coverage, 4720,
     /*  544451 */     GIR_EraseRootFromParent_Done,
     /*  544452 */   // Label 9003: @544452
     /*  544452 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(544523), // Rule ID 4721 //
     /*  544457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  544468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  544471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  544474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544485 */     // MIs[0] passthru
     /*  544485 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544501 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544521 */     GIR_RootConstrainSelectedInstOperands,
     /*  544522 */     // GIR_Coverage, 4721,
     /*  544522 */     GIR_EraseRootFromParent_Done,
     /*  544523 */   // Label 9004: @544523
     /*  544523 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(544594), // Rule ID 4730 //
     /*  544528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544556 */     // MIs[0] passthru
     /*  544556 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  544575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544592 */     GIR_RootConstrainSelectedInstOperands,
     /*  544593 */     // GIR_Coverage, 4730,
     /*  544593 */     GIR_EraseRootFromParent_Done,
     /*  544594 */   // Label 9005: @544594
     /*  544594 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(544665), // Rule ID 4731 //
     /*  544599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544627 */     // MIs[0] passthru
     /*  544627 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544643 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  544646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544663 */     GIR_RootConstrainSelectedInstOperands,
     /*  544664 */     // GIR_Coverage, 4731,
     /*  544664 */     GIR_EraseRootFromParent_Done,
     /*  544665 */   // Label 9006: @544665
     /*  544665 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(544736), // Rule ID 4740 //
     /*  544670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544698 */     // MIs[0] passthru
     /*  544698 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544714 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  544717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544734 */     GIR_RootConstrainSelectedInstOperands,
     /*  544735 */     // GIR_Coverage, 4740,
     /*  544735 */     GIR_EraseRootFromParent_Done,
     /*  544736 */   // Label 9007: @544736
     /*  544736 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(544807), // Rule ID 4741 //
     /*  544741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544769 */     // MIs[0] passthru
     /*  544769 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544785 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  544788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544805 */     GIR_RootConstrainSelectedInstOperands,
     /*  544806 */     // GIR_Coverage, 4741,
     /*  544806 */     GIR_EraseRootFromParent_Done,
     /*  544807 */   // Label 9008: @544807
     /*  544807 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(544878), // Rule ID 4750 //
     /*  544812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544840 */     // MIs[0] passthru
     /*  544840 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544876 */     GIR_RootConstrainSelectedInstOperands,
     /*  544877 */     // GIR_Coverage, 4750,
     /*  544877 */     GIR_EraseRootFromParent_Done,
     /*  544878 */   // Label 9009: @544878
     /*  544878 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(544949), // Rule ID 4751 //
     /*  544883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544911 */     // MIs[0] passthru
     /*  544911 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544927 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544947 */     GIR_RootConstrainSelectedInstOperands,
     /*  544948 */     // GIR_Coverage, 4751,
     /*  544948 */     GIR_EraseRootFromParent_Done,
     /*  544949 */   // Label 9010: @544949
     /*  544949 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(545020), // Rule ID 4760 //
     /*  544954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  544968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  544971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544982 */     // MIs[0] passthru
     /*  544982 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544998 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545018 */     GIR_RootConstrainSelectedInstOperands,
     /*  545019 */     // GIR_Coverage, 4760,
     /*  545019 */     GIR_EraseRootFromParent_Done,
     /*  545020 */   // Label 9011: @545020
     /*  545020 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(545091), // Rule ID 4761 //
     /*  545025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  545036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  545039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  545042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545053 */     // MIs[0] passthru
     /*  545053 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545069 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545089 */     GIR_RootConstrainSelectedInstOperands,
     /*  545090 */     // GIR_Coverage, 4761,
     /*  545090 */     GIR_EraseRootFromParent_Done,
     /*  545091 */   // Label 9012: @545091
     /*  545091 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(545162), // Rule ID 4770 //
     /*  545096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  545107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  545110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  545113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545124 */     // MIs[0] passthru
     /*  545124 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545160 */     GIR_RootConstrainSelectedInstOperands,
     /*  545161 */     // GIR_Coverage, 4770,
     /*  545161 */     GIR_EraseRootFromParent_Done,
     /*  545162 */   // Label 9013: @545162
     /*  545162 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(545233), // Rule ID 4771 //
     /*  545167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  545178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  545181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  545184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545195 */     // MIs[0] passthru
     /*  545195 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545231 */     GIR_RootConstrainSelectedInstOperands,
     /*  545232 */     // GIR_Coverage, 4771,
     /*  545232 */     GIR_EraseRootFromParent_Done,
     /*  545233 */   // Label 9014: @545233
     /*  545233 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(545304), // Rule ID 4780 //
     /*  545238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  545249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  545252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  545255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545266 */     // MIs[0] passthru
     /*  545266 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545302 */     GIR_RootConstrainSelectedInstOperands,
     /*  545303 */     // GIR_Coverage, 4780,
     /*  545303 */     GIR_EraseRootFromParent_Done,
     /*  545304 */   // Label 9015: @545304
     /*  545304 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(545375), // Rule ID 4781 //
     /*  545309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  545320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  545323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  545326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545337 */     // MIs[0] passthru
     /*  545337 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545353 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545373 */     GIR_RootConstrainSelectedInstOperands,
     /*  545374 */     // GIR_Coverage, 4781,
     /*  545374 */     GIR_EraseRootFromParent_Done,
     /*  545375 */   // Label 9016: @545375
     /*  545375 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(545446), // Rule ID 4790 //
     /*  545380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545408 */     // MIs[0] passthru
     /*  545408 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  545424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545444 */     GIR_RootConstrainSelectedInstOperands,
     /*  545445 */     // GIR_Coverage, 4790,
     /*  545445 */     GIR_EraseRootFromParent_Done,
     /*  545446 */   // Label 9017: @545446
     /*  545446 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(545517), // Rule ID 4791 //
     /*  545451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  545462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  545465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  545468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545479 */     // MIs[0] passthru
     /*  545479 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545495 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  545495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545515 */     GIR_RootConstrainSelectedInstOperands,
     /*  545516 */     // GIR_Coverage, 4791,
     /*  545516 */     GIR_EraseRootFromParent_Done,
     /*  545517 */   // Label 9018: @545517
     /*  545517 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(545588), // Rule ID 4800 //
     /*  545522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545550 */     // MIs[0] passthru
     /*  545550 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545586 */     GIR_RootConstrainSelectedInstOperands,
     /*  545587 */     // GIR_Coverage, 4800,
     /*  545587 */     GIR_EraseRootFromParent_Done,
     /*  545588 */   // Label 9019: @545588
     /*  545588 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(545659), // Rule ID 4801 //
     /*  545593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545621 */     // MIs[0] passthru
     /*  545621 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545637 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545657 */     GIR_RootConstrainSelectedInstOperands,
     /*  545658 */     // GIR_Coverage, 4801,
     /*  545658 */     GIR_EraseRootFromParent_Done,
     /*  545659 */   // Label 9020: @545659
     /*  545659 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(545730), // Rule ID 4810 //
     /*  545664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545692 */     // MIs[0] passthru
     /*  545692 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545728 */     GIR_RootConstrainSelectedInstOperands,
     /*  545729 */     // GIR_Coverage, 4810,
     /*  545729 */     GIR_EraseRootFromParent_Done,
     /*  545730 */   // Label 9021: @545730
     /*  545730 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(545801), // Rule ID 4811 //
     /*  545735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545763 */     // MIs[0] passthru
     /*  545763 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545779 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545799 */     GIR_RootConstrainSelectedInstOperands,
     /*  545800 */     // GIR_Coverage, 4811,
     /*  545800 */     GIR_EraseRootFromParent_Done,
     /*  545801 */   // Label 9022: @545801
     /*  545801 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(545872), // Rule ID 4820 //
     /*  545806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545834 */     // MIs[0] passthru
     /*  545834 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545870 */     GIR_RootConstrainSelectedInstOperands,
     /*  545871 */     // GIR_Coverage, 4820,
     /*  545871 */     GIR_EraseRootFromParent_Done,
     /*  545872 */   // Label 9023: @545872
     /*  545872 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(545943), // Rule ID 4821 //
     /*  545877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545905 */     // MIs[0] passthru
     /*  545905 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545921 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545941 */     GIR_RootConstrainSelectedInstOperands,
     /*  545942 */     // GIR_Coverage, 4821,
     /*  545942 */     GIR_EraseRootFromParent_Done,
     /*  545943 */   // Label 9024: @545943
     /*  545943 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(546014), // Rule ID 4830 //
     /*  545948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  545959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  545962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  545965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545976 */     // MIs[0] passthru
     /*  545976 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545992 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546012 */     GIR_RootConstrainSelectedInstOperands,
     /*  546013 */     // GIR_Coverage, 4830,
     /*  546013 */     GIR_EraseRootFromParent_Done,
     /*  546014 */   // Label 9025: @546014
     /*  546014 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(546085), // Rule ID 4831 //
     /*  546019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  546022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  546027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  546030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  546033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  546036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  546047 */     // MIs[0] passthru
     /*  546047 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  546052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  546056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546063 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  546063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  546066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  546080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546083 */     GIR_RootConstrainSelectedInstOperands,
     /*  546084 */     // GIR_Coverage, 4831,
     /*  546084 */     GIR_EraseRootFromParent_Done,
     /*  546085 */   // Label 9026: @546085
     /*  546085 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(546157), // Rule ID 2686 //
     /*  546090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  546098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546136 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  546136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  546139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546155 */     GIR_RootConstrainSelectedInstOperands,
     /*  546156 */     // GIR_Coverage, 2686,
     /*  546156 */     GIR_EraseRootFromParent_Done,
     /*  546157 */   // Label 9027: @546157
     /*  546157 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(546229), // Rule ID 2687 //
     /*  546162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  546170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546208 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  546208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  546211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546227 */     GIR_RootConstrainSelectedInstOperands,
     /*  546228 */     // GIR_Coverage, 2687,
     /*  546228 */     GIR_EraseRootFromParent_Done,
     /*  546229 */   // Label 9028: @546229
     /*  546229 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(546304), // Rule ID 2690 //
     /*  546234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  546237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  546242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  546248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  546251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  546261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  546280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  546283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  546302 */     GIR_RootConstrainSelectedInstOperands,
     /*  546303 */     // GIR_Coverage, 2690,
     /*  546303 */     GIR_EraseRootFromParent_Done,
     /*  546304 */   // Label 9029: @546304
     /*  546304 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(546379), // Rule ID 2691 //
     /*  546309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  546312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  546317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  546323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  546326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  546336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546355 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  546355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  546358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  546377 */     GIR_RootConstrainSelectedInstOperands,
     /*  546378 */     // GIR_Coverage, 2691,
     /*  546378 */     GIR_EraseRootFromParent_Done,
     /*  546379 */   // Label 9030: @546379
     /*  546379 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(546454), // Rule ID 2718 //
     /*  546384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  546392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546430 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  546433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546452 */     GIR_RootConstrainSelectedInstOperands,
     /*  546453 */     // GIR_Coverage, 2718,
     /*  546453 */     GIR_EraseRootFromParent_Done,
     /*  546454 */   // Label 9031: @546454
     /*  546454 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(546529), // Rule ID 2719 //
     /*  546459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  546467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546505 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  546508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546527 */     GIR_RootConstrainSelectedInstOperands,
     /*  546528 */     // GIR_Coverage, 2719,
     /*  546528 */     GIR_EraseRootFromParent_Done,
     /*  546529 */   // Label 9032: @546529
     /*  546529 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(546601), // Rule ID 2732 //
     /*  546534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  546542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546580 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  546580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  546583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  546587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546599 */     GIR_RootConstrainSelectedInstOperands,
     /*  546600 */     // GIR_Coverage, 2732,
     /*  546600 */     GIR_EraseRootFromParent_Done,
     /*  546601 */   // Label 9033: @546601
     /*  546601 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(546673), // Rule ID 2733 //
     /*  546606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  546614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  546652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  546655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  546659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546671 */     GIR_RootConstrainSelectedInstOperands,
     /*  546672 */     // GIR_Coverage, 2733,
     /*  546672 */     GIR_EraseRootFromParent_Done,
     /*  546673 */   // Label 9034: @546673
     /*  546673 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(546748), // Rule ID 2752 //
     /*  546678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  546686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  546689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  546692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  546695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  546727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546746 */     GIR_RootConstrainSelectedInstOperands,
     /*  546747 */     // GIR_Coverage, 2752,
     /*  546747 */     GIR_EraseRootFromParent_Done,
     /*  546748 */   // Label 9035: @546748
     /*  546748 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(546823), // Rule ID 2753 //
     /*  546753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  546761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  546764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  546767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  546770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546799 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  546802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546821 */     GIR_RootConstrainSelectedInstOperands,
     /*  546822 */     // GIR_Coverage, 2753,
     /*  546822 */     GIR_EraseRootFromParent_Done,
     /*  546823 */   // Label 9036: @546823
     /*  546823 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(546898), // Rule ID 2778 //
     /*  546828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  546836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  546839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  546842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  546877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  546881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546896 */     GIR_RootConstrainSelectedInstOperands,
     /*  546897 */     // GIR_Coverage, 2778,
     /*  546897 */     GIR_EraseRootFromParent_Done,
     /*  546898 */   // Label 9037: @546898
     /*  546898 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(546973), // Rule ID 2779 //
     /*  546903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  546911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  546914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  546917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546949 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  546952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  546956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546971 */     GIR_RootConstrainSelectedInstOperands,
     /*  546972 */     // GIR_Coverage, 2779,
     /*  546972 */     GIR_EraseRootFromParent_Done,
     /*  546973 */   // Label 9038: @546973
     /*  546973 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(547048), // Rule ID 2790 //
     /*  546978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  546986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547024 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  547027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547046 */     GIR_RootConstrainSelectedInstOperands,
     /*  547047 */     // GIR_Coverage, 2790,
     /*  547047 */     GIR_EraseRootFromParent_Done,
     /*  547048 */   // Label 9039: @547048
     /*  547048 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(547123), // Rule ID 2791 //
     /*  547053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  547064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  547067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  547070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  547073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547099 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  547102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547121 */     GIR_RootConstrainSelectedInstOperands,
     /*  547122 */     // GIR_Coverage, 2791,
     /*  547122 */     GIR_EraseRootFromParent_Done,
     /*  547123 */   // Label 9040: @547123
     /*  547123 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(547198), // Rule ID 2798 //
     /*  547128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547174 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547196 */     GIR_RootConstrainSelectedInstOperands,
     /*  547197 */     // GIR_Coverage, 2798,
     /*  547197 */     GIR_EraseRootFromParent_Done,
     /*  547198 */   // Label 9041: @547198
     /*  547198 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(547273), // Rule ID 2799 //
     /*  547203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  547214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  547217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  547220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  547223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547249 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547271 */     GIR_RootConstrainSelectedInstOperands,
     /*  547272 */     // GIR_Coverage, 2799,
     /*  547272 */     GIR_EraseRootFromParent_Done,
     /*  547273 */   // Label 9042: @547273
     /*  547273 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(547348), // Rule ID 2806 //
     /*  547278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547324 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547346 */     GIR_RootConstrainSelectedInstOperands,
     /*  547347 */     // GIR_Coverage, 2806,
     /*  547347 */     GIR_EraseRootFromParent_Done,
     /*  547348 */   // Label 9043: @547348
     /*  547348 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(547423), // Rule ID 2807 //
     /*  547353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  547364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  547367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  547370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  547373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547399 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547421 */     GIR_RootConstrainSelectedInstOperands,
     /*  547422 */     // GIR_Coverage, 2807,
     /*  547422 */     GIR_EraseRootFromParent_Done,
     /*  547423 */   // Label 9044: @547423
     /*  547423 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(547498), // Rule ID 2814 //
     /*  547428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547496 */     GIR_RootConstrainSelectedInstOperands,
     /*  547497 */     // GIR_Coverage, 2814,
     /*  547497 */     GIR_EraseRootFromParent_Done,
     /*  547498 */   // Label 9045: @547498
     /*  547498 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(547573), // Rule ID 2815 //
     /*  547503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547549 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547571 */     GIR_RootConstrainSelectedInstOperands,
     /*  547572 */     // GIR_Coverage, 2815,
     /*  547572 */     GIR_EraseRootFromParent_Done,
     /*  547573 */   // Label 9046: @547573
     /*  547573 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(547648), // Rule ID 2822 //
     /*  547578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  547595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  547598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547624 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547646 */     GIR_RootConstrainSelectedInstOperands,
     /*  547647 */     // GIR_Coverage, 2822,
     /*  547647 */     GIR_EraseRootFromParent_Done,
     /*  547648 */   // Label 9047: @547648
     /*  547648 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(547723), // Rule ID 2823 //
     /*  547653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  547670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  547673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547699 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547721 */     GIR_RootConstrainSelectedInstOperands,
     /*  547722 */     // GIR_Coverage, 2823,
     /*  547722 */     GIR_EraseRootFromParent_Done,
     /*  547723 */   // Label 9048: @547723
     /*  547723 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(547798), // Rule ID 2830 //
     /*  547728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  547739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  547742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  547745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547774 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547796 */     GIR_RootConstrainSelectedInstOperands,
     /*  547797 */     // GIR_Coverage, 2830,
     /*  547797 */     GIR_EraseRootFromParent_Done,
     /*  547798 */   // Label 9049: @547798
     /*  547798 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(547873), // Rule ID 2831 //
     /*  547803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  547814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  547817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  547820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547849 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547871 */     GIR_RootConstrainSelectedInstOperands,
     /*  547872 */     // GIR_Coverage, 2831,
     /*  547872 */     GIR_EraseRootFromParent_Done,
     /*  547873 */   // Label 9050: @547873
     /*  547873 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(547948), // Rule ID 2838 //
     /*  547878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  547895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547946 */     GIR_RootConstrainSelectedInstOperands,
     /*  547947 */     // GIR_Coverage, 2838,
     /*  547947 */     GIR_EraseRootFromParent_Done,
     /*  547948 */   // Label 9051: @547948
     /*  547948 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(548023), // Rule ID 2839 //
     /*  547953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  547970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547999 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548021 */     GIR_RootConstrainSelectedInstOperands,
     /*  548022 */     // GIR_Coverage, 2839,
     /*  548022 */     GIR_EraseRootFromParent_Done,
     /*  548023 */   // Label 9052: @548023
     /*  548023 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(548098), // Rule ID 2846 //
     /*  548028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548096 */     GIR_RootConstrainSelectedInstOperands,
     /*  548097 */     // GIR_Coverage, 2846,
     /*  548097 */     GIR_EraseRootFromParent_Done,
     /*  548098 */   // Label 9053: @548098
     /*  548098 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(548173), // Rule ID 2847 //
     /*  548103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  548114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  548117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  548120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  548123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548171 */     GIR_RootConstrainSelectedInstOperands,
     /*  548172 */     // GIR_Coverage, 2847,
     /*  548172 */     GIR_EraseRootFromParent_Done,
     /*  548173 */   // Label 9054: @548173
     /*  548173 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(548248), // Rule ID 2854 //
     /*  548178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  548224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548246 */     GIR_RootConstrainSelectedInstOperands,
     /*  548247 */     // GIR_Coverage, 2854,
     /*  548247 */     GIR_EraseRootFromParent_Done,
     /*  548248 */   // Label 9055: @548248
     /*  548248 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(548323), // Rule ID 2855 //
     /*  548253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  548264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  548267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  548270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  548273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  548299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548321 */     GIR_RootConstrainSelectedInstOperands,
     /*  548322 */     // GIR_Coverage, 2855,
     /*  548322 */     GIR_EraseRootFromParent_Done,
     /*  548323 */   // Label 9056: @548323
     /*  548323 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(548398), // Rule ID 2862 //
     /*  548328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  548331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  548374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548396 */     GIR_RootConstrainSelectedInstOperands,
     /*  548397 */     // GIR_Coverage, 2862,
     /*  548397 */     GIR_EraseRootFromParent_Done,
     /*  548398 */   // Label 9057: @548398
     /*  548398 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(548473), // Rule ID 2863 //
     /*  548403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  548406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  548414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  548417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  548420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  548423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  548442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548449 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  548449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  548452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  548468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548471 */     GIR_RootConstrainSelectedInstOperands,
     /*  548472 */     // GIR_Coverage, 2863,
     /*  548472 */     GIR_EraseRootFromParent_Done,
     /*  548473 */   // Label 9058: @548473
     /*  548473 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(548548), // Rule ID 2870 //
     /*  548478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  548489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  548492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  548495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548524 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548546 */     GIR_RootConstrainSelectedInstOperands,
     /*  548547 */     // GIR_Coverage, 2870,
     /*  548547 */     GIR_EraseRootFromParent_Done,
     /*  548548 */   // Label 9059: @548548
     /*  548548 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(548623), // Rule ID 2871 //
     /*  548553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  548564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  548567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  548570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548599 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548621 */     GIR_RootConstrainSelectedInstOperands,
     /*  548622 */     // GIR_Coverage, 2871,
     /*  548622 */     GIR_EraseRootFromParent_Done,
     /*  548623 */   // Label 9060: @548623
     /*  548623 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(548698), // Rule ID 2878 //
     /*  548628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  548639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  548642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  548645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548674 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  548677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548696 */     GIR_RootConstrainSelectedInstOperands,
     /*  548697 */     // GIR_Coverage, 2878,
     /*  548697 */     GIR_EraseRootFromParent_Done,
     /*  548698 */   // Label 9061: @548698
     /*  548698 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(548773), // Rule ID 2879 //
     /*  548703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  548714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  548717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  548720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548749 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  548752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548771 */     GIR_RootConstrainSelectedInstOperands,
     /*  548772 */     // GIR_Coverage, 2879,
     /*  548772 */     GIR_EraseRootFromParent_Done,
     /*  548773 */   // Label 9062: @548773
     /*  548773 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(548848), // Rule ID 2886 //
     /*  548778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  548789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  548792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  548795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  548798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548824 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  548827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548846 */     GIR_RootConstrainSelectedInstOperands,
     /*  548847 */     // GIR_Coverage, 2886,
     /*  548847 */     GIR_EraseRootFromParent_Done,
     /*  548848 */   // Label 9063: @548848
     /*  548848 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(548923), // Rule ID 2887 //
     /*  548853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  548864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  548867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  548870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  548873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548899 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  548902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548921 */     GIR_RootConstrainSelectedInstOperands,
     /*  548922 */     // GIR_Coverage, 2887,
     /*  548922 */     GIR_EraseRootFromParent_Done,
     /*  548923 */   // Label 9064: @548923
     /*  548923 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(548998), // Rule ID 2894 //
     /*  548928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  548939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  548942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  548945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  548948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548996 */     GIR_RootConstrainSelectedInstOperands,
     /*  548997 */     // GIR_Coverage, 2894,
     /*  548997 */     GIR_EraseRootFromParent_Done,
     /*  548998 */   // Label 9065: @548998
     /*  548998 */   GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(549073), // Rule ID 2895 //
     /*  549003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  549014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  549017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  549020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  549023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549071 */     GIR_RootConstrainSelectedInstOperands,
     /*  549072 */     // GIR_Coverage, 2895,
     /*  549072 */     GIR_EraseRootFromParent_Done,
     /*  549073 */   // Label 9066: @549073
     /*  549073 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(549148), // Rule ID 2902 //
     /*  549078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549124 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549146 */     GIR_RootConstrainSelectedInstOperands,
     /*  549147 */     // GIR_Coverage, 2902,
     /*  549147 */     GIR_EraseRootFromParent_Done,
     /*  549148 */   // Label 9067: @549148
     /*  549148 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(549223), // Rule ID 2903 //
     /*  549153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  549164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  549167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  549170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  549173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549199 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549221 */     GIR_RootConstrainSelectedInstOperands,
     /*  549222 */     // GIR_Coverage, 2903,
     /*  549222 */     GIR_EraseRootFromParent_Done,
     /*  549223 */   // Label 9068: @549223
     /*  549223 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(549298), // Rule ID 2910 //
     /*  549228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  549274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549296 */     GIR_RootConstrainSelectedInstOperands,
     /*  549297 */     // GIR_Coverage, 2910,
     /*  549297 */     GIR_EraseRootFromParent_Done,
     /*  549298 */   // Label 9069: @549298
     /*  549298 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(549373), // Rule ID 2911 //
     /*  549303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  549314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  549317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  549320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  549323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549349 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  549349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  549368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549371 */     GIR_RootConstrainSelectedInstOperands,
     /*  549372 */     // GIR_Coverage, 2911,
     /*  549372 */     GIR_EraseRootFromParent_Done,
     /*  549373 */   // Label 9070: @549373
     /*  549373 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(549448), // Rule ID 2918 //
     /*  549378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549424 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549446 */     GIR_RootConstrainSelectedInstOperands,
     /*  549447 */     // GIR_Coverage, 2918,
     /*  549447 */     GIR_EraseRootFromParent_Done,
     /*  549448 */   // Label 9071: @549448
     /*  549448 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(549523), // Rule ID 2919 //
     /*  549453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  549464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  549467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  549470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  549473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549521 */     GIR_RootConstrainSelectedInstOperands,
     /*  549522 */     // GIR_Coverage, 2919,
     /*  549522 */     GIR_EraseRootFromParent_Done,
     /*  549523 */   // Label 9072: @549523
     /*  549523 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(549598), // Rule ID 2926 //
     /*  549528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  549545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549596 */     GIR_RootConstrainSelectedInstOperands,
     /*  549597 */     // GIR_Coverage, 2926,
     /*  549597 */     GIR_EraseRootFromParent_Done,
     /*  549598 */   // Label 9073: @549598
     /*  549598 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(549673), // Rule ID 2927 //
     /*  549603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  549620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549649 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549671 */     GIR_RootConstrainSelectedInstOperands,
     /*  549672 */     // GIR_Coverage, 2927,
     /*  549672 */     GIR_EraseRootFromParent_Done,
     /*  549673 */   // Label 9074: @549673
     /*  549673 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(549748), // Rule ID 2934 //
     /*  549678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  549695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  549698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549724 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549746 */     GIR_RootConstrainSelectedInstOperands,
     /*  549747 */     // GIR_Coverage, 2934,
     /*  549747 */     GIR_EraseRootFromParent_Done,
     /*  549748 */   // Label 9075: @549748
     /*  549748 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(549823), // Rule ID 2935 //
     /*  549753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  549770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  549773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549821 */     GIR_RootConstrainSelectedInstOperands,
     /*  549822 */     // GIR_Coverage, 2935,
     /*  549822 */     GIR_EraseRootFromParent_Done,
     /*  549823 */   // Label 9076: @549823
     /*  549823 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(549898), // Rule ID 2942 //
     /*  549828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  549831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  549845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  549848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  549874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549896 */     GIR_RootConstrainSelectedInstOperands,
     /*  549897 */     // GIR_Coverage, 2942,
     /*  549897 */     GIR_EraseRootFromParent_Done,
     /*  549898 */   // Label 9077: @549898
     /*  549898 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(549973), // Rule ID 2943 //
     /*  549903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  549906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  549920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  549923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549949 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  549949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549971 */     GIR_RootConstrainSelectedInstOperands,
     /*  549972 */     // GIR_Coverage, 2943,
     /*  549972 */     GIR_EraseRootFromParent_Done,
     /*  549973 */   // Label 9078: @549973
     /*  549973 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(550048), // Rule ID 2950 //
     /*  549978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  549981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  549989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  549992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  549995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  549998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550046 */     GIR_RootConstrainSelectedInstOperands,
     /*  550047 */     // GIR_Coverage, 2950,
     /*  550047 */     GIR_EraseRootFromParent_Done,
     /*  550048 */   // Label 9079: @550048
     /*  550048 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(550123), // Rule ID 2951 //
     /*  550053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  550064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  550067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  550070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  550073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  550092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550099 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  550102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550121 */     GIR_RootConstrainSelectedInstOperands,
     /*  550122 */     // GIR_Coverage, 2951,
     /*  550122 */     GIR_EraseRootFromParent_Done,
     /*  550123 */   // Label 9080: @550123
     /*  550123 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(550198), // Rule ID 2958 //
     /*  550128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  550174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550196 */     GIR_RootConstrainSelectedInstOperands,
     /*  550197 */     // GIR_Coverage, 2958,
     /*  550197 */     GIR_EraseRootFromParent_Done,
     /*  550198 */   // Label 9081: @550198
     /*  550198 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(550273), // Rule ID 2959 //
     /*  550203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  550206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  550211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  550214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  550217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  550220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  550223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  550242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550249 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  550249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  550252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  550258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  550260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  550268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550271 */     GIR_RootConstrainSelectedInstOperands,
     /*  550272 */     // GIR_Coverage, 2959,
     /*  550272 */     GIR_EraseRootFromParent_Done,
     /*  550273 */   // Label 9082: @550273
     /*  550273 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(550348), // Rule ID 2974 //
     /*  550278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550324 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550346 */     GIR_RootConstrainSelectedInstOperands,
     /*  550347 */     // GIR_Coverage, 2974,
     /*  550347 */     GIR_EraseRootFromParent_Done,
     /*  550348 */   // Label 9083: @550348
     /*  550348 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(550423), // Rule ID 2975 //
     /*  550353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  550364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  550367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  550370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  550373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550399 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550421 */     GIR_RootConstrainSelectedInstOperands,
     /*  550422 */     // GIR_Coverage, 2975,
     /*  550422 */     GIR_EraseRootFromParent_Done,
     /*  550423 */   // Label 9084: @550423
     /*  550423 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(550498), // Rule ID 2978 //
     /*  550428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  550448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550474 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550496 */     GIR_RootConstrainSelectedInstOperands,
     /*  550497 */     // GIR_Coverage, 2978,
     /*  550497 */     GIR_EraseRootFromParent_Done,
     /*  550498 */   // Label 9085: @550498
     /*  550498 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(550573), // Rule ID 2979 //
     /*  550503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  550523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550549 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550571 */     GIR_RootConstrainSelectedInstOperands,
     /*  550572 */     // GIR_Coverage, 2979,
     /*  550572 */     GIR_EraseRootFromParent_Done,
     /*  550573 */   // Label 9086: @550573
     /*  550573 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(550648), // Rule ID 2982 //
     /*  550578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  550598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550624 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  550624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550646 */     GIR_RootConstrainSelectedInstOperands,
     /*  550647 */     // GIR_Coverage, 2982,
     /*  550647 */     GIR_EraseRootFromParent_Done,
     /*  550648 */   // Label 9087: @550648
     /*  550648 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(550723), // Rule ID 2983 //
     /*  550653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  550673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550699 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  550699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550721 */     GIR_RootConstrainSelectedInstOperands,
     /*  550722 */     // GIR_Coverage, 2983,
     /*  550722 */     GIR_EraseRootFromParent_Done,
     /*  550723 */   // Label 9088: @550723
     /*  550723 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(550798), // Rule ID 2986 //
     /*  550728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  550739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  550742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  550745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  550748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550774 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  550774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550796 */     GIR_RootConstrainSelectedInstOperands,
     /*  550797 */     // GIR_Coverage, 2986,
     /*  550797 */     GIR_EraseRootFromParent_Done,
     /*  550798 */   // Label 9089: @550798
     /*  550798 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(550873), // Rule ID 2987 //
     /*  550803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  550814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  550817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  550820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  550823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550849 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  550849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550871 */     GIR_RootConstrainSelectedInstOperands,
     /*  550872 */     // GIR_Coverage, 2987,
     /*  550872 */     GIR_EraseRootFromParent_Done,
     /*  550873 */   // Label 9090: @550873
     /*  550873 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(550948), // Rule ID 2990 //
     /*  550878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  550889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  550892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  550895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  550898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  550924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550946 */     GIR_RootConstrainSelectedInstOperands,
     /*  550947 */     // GIR_Coverage, 2990,
     /*  550947 */     GIR_EraseRootFromParent_Done,
     /*  550948 */   // Label 9091: @550948
     /*  550948 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(551023), // Rule ID 2991 //
     /*  550953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  550964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  550967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  550970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  550973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550999 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  550999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  551002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551021 */     GIR_RootConstrainSelectedInstOperands,
     /*  551022 */     // GIR_Coverage, 2991,
     /*  551022 */     GIR_EraseRootFromParent_Done,
     /*  551023 */   // Label 9092: @551023
     /*  551023 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(551098), // Rule ID 2994 //
     /*  551028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551096 */     GIR_RootConstrainSelectedInstOperands,
     /*  551097 */     // GIR_Coverage, 2994,
     /*  551097 */     GIR_EraseRootFromParent_Done,
     /*  551098 */   // Label 9093: @551098
     /*  551098 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(551173), // Rule ID 2995 //
     /*  551103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  551114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  551117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  551120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  551123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551149 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551171 */     GIR_RootConstrainSelectedInstOperands,
     /*  551172 */     // GIR_Coverage, 2995,
     /*  551172 */     GIR_EraseRootFromParent_Done,
     /*  551173 */   // Label 9094: @551173
     /*  551173 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(551248), // Rule ID 2998 //
     /*  551178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551246 */     GIR_RootConstrainSelectedInstOperands,
     /*  551247 */     // GIR_Coverage, 2998,
     /*  551247 */     GIR_EraseRootFromParent_Done,
     /*  551248 */   // Label 9095: @551248
     /*  551248 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(551323), // Rule ID 2999 //
     /*  551253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  551264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  551267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  551270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  551273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551321 */     GIR_RootConstrainSelectedInstOperands,
     /*  551322 */     // GIR_Coverage, 2999,
     /*  551322 */     GIR_EraseRootFromParent_Done,
     /*  551323 */   // Label 9096: @551323
     /*  551323 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(551398), // Rule ID 3002 //
     /*  551328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  551348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551374 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  551374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551396 */     GIR_RootConstrainSelectedInstOperands,
     /*  551397 */     // GIR_Coverage, 3002,
     /*  551397 */     GIR_EraseRootFromParent_Done,
     /*  551398 */   // Label 9097: @551398
     /*  551398 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(551473), // Rule ID 3003 //
     /*  551403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  551414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  551417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  551420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  551423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551449 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  551449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  551468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551471 */     GIR_RootConstrainSelectedInstOperands,
     /*  551472 */     // GIR_Coverage, 3003,
     /*  551472 */     GIR_EraseRootFromParent_Done,
     /*  551473 */   // Label 9098: @551473
     /*  551473 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(551548), // Rule ID 3006 //
     /*  551478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  551481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  551489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  551492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  551495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  551498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551524 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  551524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  551543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551546 */     GIR_RootConstrainSelectedInstOperands,
     /*  551547 */     // GIR_Coverage, 3006,
     /*  551547 */     GIR_EraseRootFromParent_Done,
     /*  551548 */   // Label 9099: @551548
     /*  551548 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(551623), // Rule ID 3007 //
     /*  551553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  551556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  551564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  551567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  551570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  551573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551599 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  551599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  551618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551621 */     GIR_RootConstrainSelectedInstOperands,
     /*  551622 */     // GIR_Coverage, 3007,
     /*  551622 */     GIR_EraseRootFromParent_Done,
     /*  551623 */   // Label 9100: @551623
     /*  551623 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(551698), // Rule ID 3010 //
     /*  551628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  551639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  551642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  551645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  551648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551674 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  551677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551696 */     GIR_RootConstrainSelectedInstOperands,
     /*  551697 */     // GIR_Coverage, 3010,
     /*  551697 */     GIR_EraseRootFromParent_Done,
     /*  551698 */   // Label 9101: @551698
     /*  551698 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(551773), // Rule ID 3011 //
     /*  551703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  551714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  551717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  551720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  551723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551749 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  551752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551771 */     GIR_RootConstrainSelectedInstOperands,
     /*  551772 */     // GIR_Coverage, 3011,
     /*  551772 */     GIR_EraseRootFromParent_Done,
     /*  551773 */   // Label 9102: @551773
     /*  551773 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(551848), // Rule ID 3014 //
     /*  551778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  551789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  551792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  551795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  551798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551824 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  551827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551846 */     GIR_RootConstrainSelectedInstOperands,
     /*  551847 */     // GIR_Coverage, 3014,
     /*  551847 */     GIR_EraseRootFromParent_Done,
     /*  551848 */   // Label 9103: @551848
     /*  551848 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(551923), // Rule ID 3015 //
     /*  551853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  551864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  551867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  551870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  551873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551899 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  551902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551921 */     GIR_RootConstrainSelectedInstOperands,
     /*  551922 */     // GIR_Coverage, 3015,
     /*  551922 */     GIR_EraseRootFromParent_Done,
     /*  551923 */   // Label 9104: @551923
     /*  551923 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(551998), // Rule ID 3018 //
     /*  551928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  551939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  551942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  551945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  551948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551974 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  551977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551996 */     GIR_RootConstrainSelectedInstOperands,
     /*  551997 */     // GIR_Coverage, 3018,
     /*  551997 */     GIR_EraseRootFromParent_Done,
     /*  551998 */   // Label 9105: @551998
     /*  551998 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(552073), // Rule ID 3019 //
     /*  552003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  552014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  552017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  552020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  552023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552049 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  552049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552071 */     GIR_RootConstrainSelectedInstOperands,
     /*  552072 */     // GIR_Coverage, 3019,
     /*  552072 */     GIR_EraseRootFromParent_Done,
     /*  552073 */   // Label 9106: @552073
     /*  552073 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(552148), // Rule ID 3022 //
     /*  552078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552146 */     GIR_RootConstrainSelectedInstOperands,
     /*  552147 */     // GIR_Coverage, 3022,
     /*  552147 */     GIR_EraseRootFromParent_Done,
     /*  552148 */   // Label 9107: @552148
     /*  552148 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(552223), // Rule ID 3023 //
     /*  552153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  552164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  552167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  552170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  552173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552199 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552221 */     GIR_RootConstrainSelectedInstOperands,
     /*  552222 */     // GIR_Coverage, 3023,
     /*  552222 */     GIR_EraseRootFromParent_Done,
     /*  552223 */   // Label 9108: @552223
     /*  552223 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(552298), // Rule ID 3026 //
     /*  552228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552296 */     GIR_RootConstrainSelectedInstOperands,
     /*  552297 */     // GIR_Coverage, 3026,
     /*  552297 */     GIR_EraseRootFromParent_Done,
     /*  552298 */   // Label 9109: @552298
     /*  552298 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(552373), // Rule ID 3027 //
     /*  552303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  552314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  552317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  552320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  552323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552349 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552371 */     GIR_RootConstrainSelectedInstOperands,
     /*  552372 */     // GIR_Coverage, 3027,
     /*  552372 */     GIR_EraseRootFromParent_Done,
     /*  552373 */   // Label 9110: @552373
     /*  552373 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(552448), // Rule ID 3030 //
     /*  552378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  552398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  552424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552446 */     GIR_RootConstrainSelectedInstOperands,
     /*  552447 */     // GIR_Coverage, 3030,
     /*  552447 */     GIR_EraseRootFromParent_Done,
     /*  552448 */   // Label 9111: @552448
     /*  552448 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(552523), // Rule ID 3031 //
     /*  552453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  552464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  552467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  552470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  552473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552499 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  552499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552521 */     GIR_RootConstrainSelectedInstOperands,
     /*  552522 */     // GIR_Coverage, 3031,
     /*  552522 */     GIR_EraseRootFromParent_Done,
     /*  552523 */   // Label 9112: @552523
     /*  552523 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(552598), // Rule ID 3034 //
     /*  552528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  552539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  552542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  552545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  552548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552596 */     GIR_RootConstrainSelectedInstOperands,
     /*  552597 */     // GIR_Coverage, 3034,
     /*  552597 */     GIR_EraseRootFromParent_Done,
     /*  552598 */   // Label 9113: @552598
     /*  552598 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(552673), // Rule ID 3035 //
     /*  552603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  552614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  552617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  552620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  552623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552649 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552671 */     GIR_RootConstrainSelectedInstOperands,
     /*  552672 */     // GIR_Coverage, 3035,
     /*  552672 */     GIR_EraseRootFromParent_Done,
     /*  552673 */   // Label 9114: @552673
     /*  552673 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(552748), // Rule ID 3038 //
     /*  552678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  552689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  552692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  552695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  552698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552746 */     GIR_RootConstrainSelectedInstOperands,
     /*  552747 */     // GIR_Coverage, 3038,
     /*  552747 */     GIR_EraseRootFromParent_Done,
     /*  552748 */   // Label 9115: @552748
     /*  552748 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(552823), // Rule ID 3039 //
     /*  552753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  552764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  552767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  552770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  552773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552799 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552821 */     GIR_RootConstrainSelectedInstOperands,
     /*  552822 */     // GIR_Coverage, 3039,
     /*  552822 */     GIR_EraseRootFromParent_Done,
     /*  552823 */   // Label 9116: @552823
     /*  552823 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(552898), // Rule ID 3042 //
     /*  552828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  552839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  552842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  552845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  552848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552874 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552896 */     GIR_RootConstrainSelectedInstOperands,
     /*  552897 */     // GIR_Coverage, 3042,
     /*  552897 */     GIR_EraseRootFromParent_Done,
     /*  552898 */   // Label 9117: @552898
     /*  552898 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(552973), // Rule ID 3043 //
     /*  552903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  552914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  552917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  552920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  552923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552949 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552971 */     GIR_RootConstrainSelectedInstOperands,
     /*  552972 */     // GIR_Coverage, 3043,
     /*  552972 */     GIR_EraseRootFromParent_Done,
     /*  552973 */   // Label 9118: @552973
     /*  552973 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(553048), // Rule ID 3046 //
     /*  552978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  552981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  552989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  552992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  552995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  552998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553046 */     GIR_RootConstrainSelectedInstOperands,
     /*  553047 */     // GIR_Coverage, 3046,
     /*  553047 */     GIR_EraseRootFromParent_Done,
     /*  553048 */   // Label 9119: @553048
     /*  553048 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(553123), // Rule ID 3047 //
     /*  553053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  553064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  553067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  553070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  553073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  553092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553099 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  553102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553121 */     GIR_RootConstrainSelectedInstOperands,
     /*  553122 */     // GIR_Coverage, 3047,
     /*  553122 */     GIR_EraseRootFromParent_Done,
     /*  553123 */   // Label 9120: @553123
     /*  553123 */   GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(553198), // Rule ID 3050 //
     /*  553128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553174 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553196 */     GIR_RootConstrainSelectedInstOperands,
     /*  553197 */     // GIR_Coverage, 3050,
     /*  553197 */     GIR_EraseRootFromParent_Done,
     /*  553198 */   // Label 9121: @553198
     /*  553198 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(553273), // Rule ID 3051 //
     /*  553203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  553214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  553217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  553220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  553223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  553242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553249 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  553252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553271 */     GIR_RootConstrainSelectedInstOperands,
     /*  553272 */     // GIR_Coverage, 3051,
     /*  553272 */     GIR_EraseRootFromParent_Done,
     /*  553273 */   // Label 9122: @553273
     /*  553273 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(553348), // Rule ID 3054 //
     /*  553278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  553281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553324 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  553324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553346 */     GIR_RootConstrainSelectedInstOperands,
     /*  553347 */     // GIR_Coverage, 3054,
     /*  553347 */     GIR_EraseRootFromParent_Done,
     /*  553348 */   // Label 9123: @553348
     /*  553348 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(553423), // Rule ID 3055 //
     /*  553353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  553356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  553364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  553367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  553370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  553373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  553392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553399 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  553399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  553402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  553418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553421 */     GIR_RootConstrainSelectedInstOperands,
     /*  553422 */     // GIR_Coverage, 3055,
     /*  553422 */     GIR_EraseRootFromParent_Done,
     /*  553423 */   // Label 9124: @553423
     /*  553423 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(553498), // Rule ID 3058 //
     /*  553428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553474 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  553477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553496 */     GIR_RootConstrainSelectedInstOperands,
     /*  553497 */     // GIR_Coverage, 3058,
     /*  553497 */     GIR_EraseRootFromParent_Done,
     /*  553498 */   // Label 9125: @553498
     /*  553498 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(553573), // Rule ID 3059 //
     /*  553503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553549 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  553552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553571 */     GIR_RootConstrainSelectedInstOperands,
     /*  553572 */     // GIR_Coverage, 3059,
     /*  553572 */     GIR_EraseRootFromParent_Done,
     /*  553573 */   // Label 9126: @553573
     /*  553573 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(553648), // Rule ID 3062 //
     /*  553578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  553589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  553592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  553595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553624 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553646 */     GIR_RootConstrainSelectedInstOperands,
     /*  553647 */     // GIR_Coverage, 3062,
     /*  553647 */     GIR_EraseRootFromParent_Done,
     /*  553648 */   // Label 9127: @553648
     /*  553648 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(553723), // Rule ID 3063 //
     /*  553653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  553664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  553667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  553670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553699 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553721 */     GIR_RootConstrainSelectedInstOperands,
     /*  553722 */     // GIR_Coverage, 3063,
     /*  553722 */     GIR_EraseRootFromParent_Done,
     /*  553723 */   // Label 9128: @553723
     /*  553723 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(553798), // Rule ID 3066 //
     /*  553728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  553739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  553742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  553745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553774 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553796 */     GIR_RootConstrainSelectedInstOperands,
     /*  553797 */     // GIR_Coverage, 3066,
     /*  553797 */     GIR_EraseRootFromParent_Done,
     /*  553798 */   // Label 9129: @553798
     /*  553798 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(553873), // Rule ID 3067 //
     /*  553803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  553814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  553817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  553820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553849 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553871 */     GIR_RootConstrainSelectedInstOperands,
     /*  553872 */     // GIR_Coverage, 3067,
     /*  553872 */     GIR_EraseRootFromParent_Done,
     /*  553873 */   // Label 9130: @553873
     /*  553873 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(553948), // Rule ID 3070 //
     /*  553878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  553889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  553892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  553895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553924 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  553924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553946 */     GIR_RootConstrainSelectedInstOperands,
     /*  553947 */     // GIR_Coverage, 3070,
     /*  553947 */     GIR_EraseRootFromParent_Done,
     /*  553948 */   // Label 9131: @553948
     /*  553948 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(554023), // Rule ID 3071 //
     /*  553953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  553964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  553967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  553970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553999 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  553999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  554002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554021 */     GIR_RootConstrainSelectedInstOperands,
     /*  554022 */     // GIR_Coverage, 3071,
     /*  554022 */     GIR_EraseRootFromParent_Done,
     /*  554023 */   // Label 9132: @554023
     /*  554023 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(554098), // Rule ID 3074 //
     /*  554028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554074 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554096 */     GIR_RootConstrainSelectedInstOperands,
     /*  554097 */     // GIR_Coverage, 3074,
     /*  554097 */     GIR_EraseRootFromParent_Done,
     /*  554098 */   // Label 9133: @554098
     /*  554098 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(554173), // Rule ID 3075 //
     /*  554103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  554114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  554117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  554120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554149 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554171 */     GIR_RootConstrainSelectedInstOperands,
     /*  554172 */     // GIR_Coverage, 3075,
     /*  554172 */     GIR_EraseRootFromParent_Done,
     /*  554173 */   // Label 9134: @554173
     /*  554173 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(554248), // Rule ID 3078 //
     /*  554178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554224 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554246 */     GIR_RootConstrainSelectedInstOperands,
     /*  554247 */     // GIR_Coverage, 3078,
     /*  554247 */     GIR_EraseRootFromParent_Done,
     /*  554248 */   // Label 9135: @554248
     /*  554248 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(554323), // Rule ID 3079 //
     /*  554253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  554264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  554267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  554270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554299 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  554302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554321 */     GIR_RootConstrainSelectedInstOperands,
     /*  554322 */     // GIR_Coverage, 3079,
     /*  554322 */     GIR_EraseRootFromParent_Done,
     /*  554323 */   // Label 9136: @554323
     /*  554323 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(554398), // Rule ID 3082 //
     /*  554328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554396 */     GIR_RootConstrainSelectedInstOperands,
     /*  554397 */     // GIR_Coverage, 3082,
     /*  554397 */     GIR_EraseRootFromParent_Done,
     /*  554398 */   // Label 9137: @554398
     /*  554398 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(554473), // Rule ID 3083 //
     /*  554403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  554414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  554417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  554420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554449 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11143:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554471 */     GIR_RootConstrainSelectedInstOperands,
     /*  554472 */     // GIR_Coverage, 3083,
     /*  554472 */     GIR_EraseRootFromParent_Done,
     /*  554473 */   // Label 9138: @554473
     /*  554473 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(554548), // Rule ID 3086 //
     /*  554478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  554489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  554492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  554495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554546 */     GIR_RootConstrainSelectedInstOperands,
     /*  554547 */     // GIR_Coverage, 3086,
     /*  554547 */     GIR_EraseRootFromParent_Done,
     /*  554548 */   // Label 9139: @554548
     /*  554548 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(554623), // Rule ID 3087 //
     /*  554553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  554564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  554567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  554570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554599 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554621 */     GIR_RootConstrainSelectedInstOperands,
     /*  554622 */     // GIR_Coverage, 3087,
     /*  554622 */     GIR_EraseRootFromParent_Done,
     /*  554623 */   // Label 9140: @554623
     /*  554623 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(554698), // Rule ID 3090 //
     /*  554628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  554639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  554642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  554645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554674 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554696 */     GIR_RootConstrainSelectedInstOperands,
     /*  554697 */     // GIR_Coverage, 3090,
     /*  554697 */     GIR_EraseRootFromParent_Done,
     /*  554698 */   // Label 9141: @554698
     /*  554698 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(554773), // Rule ID 3091 //
     /*  554703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  554714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  554717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  554720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554749 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554771 */     GIR_RootConstrainSelectedInstOperands,
     /*  554772 */     // GIR_Coverage, 3091,
     /*  554772 */     GIR_EraseRootFromParent_Done,
     /*  554773 */   // Label 9142: @554773
     /*  554773 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(554848), // Rule ID 3094 //
     /*  554778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  554781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  554789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  554792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  554795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  554824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554846 */     GIR_RootConstrainSelectedInstOperands,
     /*  554847 */     // GIR_Coverage, 3094,
     /*  554847 */     GIR_EraseRootFromParent_Done,
     /*  554848 */   // Label 9143: @554848
     /*  554848 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(554923), // Rule ID 3095 //
     /*  554853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  554856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  554864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  554867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  554870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554899 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  554899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554921 */     GIR_RootConstrainSelectedInstOperands,
     /*  554922 */     // GIR_Coverage, 3095,
     /*  554922 */     GIR_EraseRootFromParent_Done,
     /*  554923 */   // Label 9144: @554923
     /*  554923 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(554998), // Rule ID 3098 //
     /*  554928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  554939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  554942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  554945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554974 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  554977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554996 */     GIR_RootConstrainSelectedInstOperands,
     /*  554997 */     // GIR_Coverage, 3098,
     /*  554997 */     GIR_EraseRootFromParent_Done,
     /*  554998 */   // Label 9145: @554998
     /*  554998 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(555073), // Rule ID 3099 //
     /*  555003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  555014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  555017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  555020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555049 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555071 */     GIR_RootConstrainSelectedInstOperands,
     /*  555072 */     // GIR_Coverage, 3099,
     /*  555072 */     GIR_EraseRootFromParent_Done,
     /*  555073 */   // Label 9146: @555073
     /*  555073 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(555148), // Rule ID 3102 //
     /*  555078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555124 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555146 */     GIR_RootConstrainSelectedInstOperands,
     /*  555147 */     // GIR_Coverage, 3102,
     /*  555147 */     GIR_EraseRootFromParent_Done,
     /*  555148 */   // Label 9147: @555148
     /*  555148 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(555223), // Rule ID 3103 //
     /*  555153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  555164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  555167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  555170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555199 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555221 */     GIR_RootConstrainSelectedInstOperands,
     /*  555222 */     // GIR_Coverage, 3103,
     /*  555222 */     GIR_EraseRootFromParent_Done,
     /*  555223 */   // Label 9148: @555223
     /*  555223 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(555298), // Rule ID 3106 //
     /*  555228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555274 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  555274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555296 */     GIR_RootConstrainSelectedInstOperands,
     /*  555297 */     // GIR_Coverage, 3106,
     /*  555297 */     GIR_EraseRootFromParent_Done,
     /*  555298 */   // Label 9149: @555298
     /*  555298 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(555373), // Rule ID 3107 //
     /*  555303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  555314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  555317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  555320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555349 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  555349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  555368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555371 */     GIR_RootConstrainSelectedInstOperands,
     /*  555372 */     // GIR_Coverage, 3107,
     /*  555372 */     GIR_EraseRootFromParent_Done,
     /*  555373 */   // Label 9150: @555373
     /*  555373 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(555448), // Rule ID 3110 //
     /*  555378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555446 */     GIR_RootConstrainSelectedInstOperands,
     /*  555447 */     // GIR_Coverage, 3110,
     /*  555447 */     GIR_EraseRootFromParent_Done,
     /*  555448 */   // Label 9151: @555448
     /*  555448 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(555523), // Rule ID 3111 //
     /*  555453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  555464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  555467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  555470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555499 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555521 */     GIR_RootConstrainSelectedInstOperands,
     /*  555522 */     // GIR_Coverage, 3111,
     /*  555522 */     GIR_EraseRootFromParent_Done,
     /*  555523 */   // Label 9152: @555523
     /*  555523 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(555598), // Rule ID 3114 //
     /*  555528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  555539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  555542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  555545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555574 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555596 */     GIR_RootConstrainSelectedInstOperands,
     /*  555597 */     // GIR_Coverage, 3114,
     /*  555597 */     GIR_EraseRootFromParent_Done,
     /*  555598 */   // Label 9153: @555598
     /*  555598 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(555673), // Rule ID 3115 //
     /*  555603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  555614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  555617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  555620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555649 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555671 */     GIR_RootConstrainSelectedInstOperands,
     /*  555672 */     // GIR_Coverage, 3115,
     /*  555672 */     GIR_EraseRootFromParent_Done,
     /*  555673 */   // Label 9154: @555673
     /*  555673 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(555748), // Rule ID 3118 //
     /*  555678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  555689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  555692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  555695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555724 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555746 */     GIR_RootConstrainSelectedInstOperands,
     /*  555747 */     // GIR_Coverage, 3118,
     /*  555747 */     GIR_EraseRootFromParent_Done,
     /*  555748 */   // Label 9155: @555748
     /*  555748 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(555823), // Rule ID 3119 //
     /*  555753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  555764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  555767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  555770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555799 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555821 */     GIR_RootConstrainSelectedInstOperands,
     /*  555822 */     // GIR_Coverage, 3119,
     /*  555822 */     GIR_EraseRootFromParent_Done,
     /*  555823 */   // Label 9156: @555823
     /*  555823 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(555898), // Rule ID 3122 //
     /*  555828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  555839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  555842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  555845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  555874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555896 */     GIR_RootConstrainSelectedInstOperands,
     /*  555897 */     // GIR_Coverage, 3122,
     /*  555897 */     GIR_EraseRootFromParent_Done,
     /*  555898 */   // Label 9157: @555898
     /*  555898 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(555973), // Rule ID 3123 //
     /*  555903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  555914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  555917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  555920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555949 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  555949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555971 */     GIR_RootConstrainSelectedInstOperands,
     /*  555972 */     // GIR_Coverage, 3123,
     /*  555972 */     GIR_EraseRootFromParent_Done,
     /*  555973 */   // Label 9158: @555973
     /*  555973 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(556048), // Rule ID 3126 //
     /*  555978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  555989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  555992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  555995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556024 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556046 */     GIR_RootConstrainSelectedInstOperands,
     /*  556047 */     // GIR_Coverage, 3126,
     /*  556047 */     GIR_EraseRootFromParent_Done,
     /*  556048 */   // Label 9159: @556048
     /*  556048 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(556123), // Rule ID 3127 //
     /*  556053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  556064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  556067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  556070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556099 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556121 */     GIR_RootConstrainSelectedInstOperands,
     /*  556122 */     // GIR_Coverage, 3127,
     /*  556122 */     GIR_EraseRootFromParent_Done,
     /*  556123 */   // Label 9160: @556123
     /*  556123 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(556198), // Rule ID 3130 //
     /*  556128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  556174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556196 */     GIR_RootConstrainSelectedInstOperands,
     /*  556197 */     // GIR_Coverage, 3130,
     /*  556197 */     GIR_EraseRootFromParent_Done,
     /*  556198 */   // Label 9161: @556198
     /*  556198 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(556273), // Rule ID 3131 //
     /*  556203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  556214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  556217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  556220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  556249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  556268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556271 */     GIR_RootConstrainSelectedInstOperands,
     /*  556272 */     // GIR_Coverage, 3131,
     /*  556272 */     GIR_EraseRootFromParent_Done,
     /*  556273 */   // Label 9162: @556273
     /*  556273 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(556348), // Rule ID 3134 //
     /*  556278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556346 */     GIR_RootConstrainSelectedInstOperands,
     /*  556347 */     // GIR_Coverage, 3134,
     /*  556347 */     GIR_EraseRootFromParent_Done,
     /*  556348 */   // Label 9163: @556348
     /*  556348 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(556423), // Rule ID 3135 //
     /*  556353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  556364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  556367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  556370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  556388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556399 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  556402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556421 */     GIR_RootConstrainSelectedInstOperands,
     /*  556422 */     // GIR_Coverage, 3135,
     /*  556422 */     GIR_EraseRootFromParent_Done,
     /*  556423 */   // Label 9164: @556423
     /*  556423 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(556498), // Rule ID 3138 //
     /*  556428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556496 */     GIR_RootConstrainSelectedInstOperands,
     /*  556497 */     // GIR_Coverage, 3138,
     /*  556497 */     GIR_EraseRootFromParent_Done,
     /*  556498 */   // Label 9165: @556498
     /*  556498 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(556573), // Rule ID 3139 //
     /*  556503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556549 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556571 */     GIR_RootConstrainSelectedInstOperands,
     /*  556572 */     // GIR_Coverage, 3139,
     /*  556572 */     GIR_EraseRootFromParent_Done,
     /*  556573 */   // Label 9166: @556573
     /*  556573 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(556648), // Rule ID 3142 //
     /*  556578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  556589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  556592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  556595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556624 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556646 */     GIR_RootConstrainSelectedInstOperands,
     /*  556647 */     // GIR_Coverage, 3142,
     /*  556647 */     GIR_EraseRootFromParent_Done,
     /*  556648 */   // Label 9167: @556648
     /*  556648 */   GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(556723), // Rule ID 3143 //
     /*  556653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  556664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  556667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  556670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556699 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556721 */     GIR_RootConstrainSelectedInstOperands,
     /*  556722 */     // GIR_Coverage, 3143,
     /*  556722 */     GIR_EraseRootFromParent_Done,
     /*  556723 */   // Label 9168: @556723
     /*  556723 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(556798), // Rule ID 3234 //
     /*  556728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  556739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  556742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  556745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  556748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556774 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  556774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  556777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556796 */     GIR_RootConstrainSelectedInstOperands,
     /*  556797 */     // GIR_Coverage, 3234,
     /*  556797 */     GIR_EraseRootFromParent_Done,
     /*  556798 */   // Label 9169: @556798
     /*  556798 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(556873), // Rule ID 3235 //
     /*  556803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  556814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  556817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  556820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  556823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556849 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  556849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  556852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556871 */     GIR_RootConstrainSelectedInstOperands,
     /*  556872 */     // GIR_Coverage, 3235,
     /*  556872 */     GIR_EraseRootFromParent_Done,
     /*  556873 */   // Label 9170: @556873
     /*  556873 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(556948), // Rule ID 3238 //
     /*  556878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  556889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  556892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  556895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  556898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556924 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  556924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  556927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556946 */     GIR_RootConstrainSelectedInstOperands,
     /*  556947 */     // GIR_Coverage, 3238,
     /*  556947 */     GIR_EraseRootFromParent_Done,
     /*  556948 */   // Label 9171: @556948
     /*  556948 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(557023), // Rule ID 3239 //
     /*  556953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  556964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  556967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  556970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  556973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556999 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  556999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557021 */     GIR_RootConstrainSelectedInstOperands,
     /*  557022 */     // GIR_Coverage, 3239,
     /*  557022 */     GIR_EraseRootFromParent_Done,
     /*  557023 */   // Label 9172: @557023
     /*  557023 */   GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(557098), // Rule ID 3242 //
     /*  557028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  557048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557074 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557096 */     GIR_RootConstrainSelectedInstOperands,
     /*  557097 */     // GIR_Coverage, 3242,
     /*  557097 */     GIR_EraseRootFromParent_Done,
     /*  557098 */   // Label 9173: @557098
     /*  557098 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(557173), // Rule ID 3243 //
     /*  557103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  557114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  557117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  557120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  557123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557149 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557171 */     GIR_RootConstrainSelectedInstOperands,
     /*  557172 */     // GIR_Coverage, 3243,
     /*  557172 */     GIR_EraseRootFromParent_Done,
     /*  557173 */   // Label 9174: @557173
     /*  557173 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(557248), // Rule ID 3246 //
     /*  557178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  557198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557246 */     GIR_RootConstrainSelectedInstOperands,
     /*  557247 */     // GIR_Coverage, 3246,
     /*  557247 */     GIR_EraseRootFromParent_Done,
     /*  557248 */   // Label 9175: @557248
     /*  557248 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(557323), // Rule ID 3247 //
     /*  557253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  557264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  557267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  557270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  557273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557299 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  557302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557321 */     GIR_RootConstrainSelectedInstOperands,
     /*  557322 */     // GIR_Coverage, 3247,
     /*  557322 */     GIR_EraseRootFromParent_Done,
     /*  557323 */   // Label 9176: @557323
     /*  557323 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(557398), // Rule ID 3250 //
     /*  557328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  557348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557396 */     GIR_RootConstrainSelectedInstOperands,
     /*  557397 */     // GIR_Coverage, 3250,
     /*  557397 */     GIR_EraseRootFromParent_Done,
     /*  557398 */   // Label 9177: @557398
     /*  557398 */   GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(557473), // Rule ID 3251 //
     /*  557403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  557414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  557417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  557420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  557423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557449 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557471 */     GIR_RootConstrainSelectedInstOperands,
     /*  557472 */     // GIR_Coverage, 3251,
     /*  557472 */     GIR_EraseRootFromParent_Done,
     /*  557473 */   // Label 9178: @557473
     /*  557473 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(557548), // Rule ID 3254 //
     /*  557478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  557489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  557492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  557495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  557498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557524 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  557524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557546 */     GIR_RootConstrainSelectedInstOperands,
     /*  557547 */     // GIR_Coverage, 3254,
     /*  557547 */     GIR_EraseRootFromParent_Done,
     /*  557548 */   // Label 9179: @557548
     /*  557548 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(557623), // Rule ID 3255 //
     /*  557553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  557564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  557567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  557570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  557573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557599 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  557599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557621 */     GIR_RootConstrainSelectedInstOperands,
     /*  557622 */     // GIR_Coverage, 3255,
     /*  557622 */     GIR_EraseRootFromParent_Done,
     /*  557623 */   // Label 9180: @557623
     /*  557623 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(557698), // Rule ID 3258 //
     /*  557628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  557639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  557642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  557645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  557648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557674 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557696 */     GIR_RootConstrainSelectedInstOperands,
     /*  557697 */     // GIR_Coverage, 3258,
     /*  557697 */     GIR_EraseRootFromParent_Done,
     /*  557698 */   // Label 9181: @557698
     /*  557698 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(557773), // Rule ID 3259 //
     /*  557703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  557714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  557717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  557720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  557723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557749 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557771 */     GIR_RootConstrainSelectedInstOperands,
     /*  557772 */     // GIR_Coverage, 3259,
     /*  557772 */     GIR_EraseRootFromParent_Done,
     /*  557773 */   // Label 9182: @557773
     /*  557773 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(557848), // Rule ID 3262 //
     /*  557778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  557789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  557792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  557795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  557798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557846 */     GIR_RootConstrainSelectedInstOperands,
     /*  557847 */     // GIR_Coverage, 3262,
     /*  557847 */     GIR_EraseRootFromParent_Done,
     /*  557848 */   // Label 9183: @557848
     /*  557848 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(557923), // Rule ID 3263 //
     /*  557853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  557864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  557867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  557870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  557873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557899 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557921 */     GIR_RootConstrainSelectedInstOperands,
     /*  557922 */     // GIR_Coverage, 3263,
     /*  557922 */     GIR_EraseRootFromParent_Done,
     /*  557923 */   // Label 9184: @557923
     /*  557923 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(557998), // Rule ID 3266 //
     /*  557928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  557939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  557942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  557945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  557948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  557974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557996 */     GIR_RootConstrainSelectedInstOperands,
     /*  557997 */     // GIR_Coverage, 3266,
     /*  557997 */     GIR_EraseRootFromParent_Done,
     /*  557998 */   // Label 9185: @557998
     /*  557998 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(558073), // Rule ID 3267 //
     /*  558003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  558014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  558017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  558020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  558023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558049 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558071 */     GIR_RootConstrainSelectedInstOperands,
     /*  558072 */     // GIR_Coverage, 3267,
     /*  558072 */     GIR_EraseRootFromParent_Done,
     /*  558073 */   // Label 9186: @558073
     /*  558073 */   GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(558148), // Rule ID 3270 //
     /*  558078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  558081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  558098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  558124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558146 */     GIR_RootConstrainSelectedInstOperands,
     /*  558147 */     // GIR_Coverage, 3270,
     /*  558147 */     GIR_EraseRootFromParent_Done,
     /*  558148 */   // Label 9187: @558148
     /*  558148 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(558223), // Rule ID 3271 //
     /*  558153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  558156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  558164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  558167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  558170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  558173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  558192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558199 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  558199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  558202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  558218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558221 */     GIR_RootConstrainSelectedInstOperands,
     /*  558222 */     // GIR_Coverage, 3271,
     /*  558222 */     GIR_EraseRootFromParent_Done,
     /*  558223 */   // Label 9188: @558223
     /*  558223 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(558298), // Rule ID 3274 //
     /*  558228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  558248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558274 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558296 */     GIR_RootConstrainSelectedInstOperands,
     /*  558297 */     // GIR_Coverage, 3274,
     /*  558297 */     GIR_EraseRootFromParent_Done,
     /*  558298 */   // Label 9189: @558298
     /*  558298 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(558373), // Rule ID 3275 //
     /*  558303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  558314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  558317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  558320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  558323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558349 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558371 */     GIR_RootConstrainSelectedInstOperands,
     /*  558372 */     // GIR_Coverage, 3275,
     /*  558372 */     GIR_EraseRootFromParent_Done,
     /*  558373 */   // Label 9190: @558373
     /*  558373 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(558448), // Rule ID 3278 //
     /*  558378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  558398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558424 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558446 */     GIR_RootConstrainSelectedInstOperands,
     /*  558447 */     // GIR_Coverage, 3278,
     /*  558447 */     GIR_EraseRootFromParent_Done,
     /*  558448 */   // Label 9191: @558448
     /*  558448 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(558523), // Rule ID 3279 //
     /*  558453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  558464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  558467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  558470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  558473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558499 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558521 */     GIR_RootConstrainSelectedInstOperands,
     /*  558522 */     // GIR_Coverage, 3279,
     /*  558522 */     GIR_EraseRootFromParent_Done,
     /*  558523 */   // Label 9192: @558523
     /*  558523 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(558598), // Rule ID 3282 //
     /*  558528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  558539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  558542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  558545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  558548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558574 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  558577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558596 */     GIR_RootConstrainSelectedInstOperands,
     /*  558597 */     // GIR_Coverage, 3282,
     /*  558597 */     GIR_EraseRootFromParent_Done,
     /*  558598 */   // Label 9193: @558598
     /*  558598 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(558673), // Rule ID 3283 //
     /*  558603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  558614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  558617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  558620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  558623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558649 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  558652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558671 */     GIR_RootConstrainSelectedInstOperands,
     /*  558672 */     // GIR_Coverage, 3283,
     /*  558672 */     GIR_EraseRootFromParent_Done,
     /*  558673 */   // Label 9194: @558673
     /*  558673 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(558748), // Rule ID 3286 //
     /*  558678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  558689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  558692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  558695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  558698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558746 */     GIR_RootConstrainSelectedInstOperands,
     /*  558747 */     // GIR_Coverage, 3286,
     /*  558747 */     GIR_EraseRootFromParent_Done,
     /*  558748 */   // Label 9195: @558748
     /*  558748 */   GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(558823), // Rule ID 3287 //
     /*  558753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  558764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  558767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  558770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  558773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558821 */     GIR_RootConstrainSelectedInstOperands,
     /*  558822 */     // GIR_Coverage, 3287,
     /*  558822 */     GIR_EraseRootFromParent_Done,
     /*  558823 */   // Label 9196: @558823
     /*  558823 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(558898), // Rule ID 3290 //
     /*  558828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  558839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  558842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  558845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  558848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558896 */     GIR_RootConstrainSelectedInstOperands,
     /*  558897 */     // GIR_Coverage, 3290,
     /*  558897 */     GIR_EraseRootFromParent_Done,
     /*  558898 */   // Label 9197: @558898
     /*  558898 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(558973), // Rule ID 3291 //
     /*  558903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  558914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  558917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  558920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  558923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558949 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558971 */     GIR_RootConstrainSelectedInstOperands,
     /*  558972 */     // GIR_Coverage, 3291,
     /*  558972 */     GIR_EraseRootFromParent_Done,
     /*  558973 */   // Label 9198: @558973
     /*  558973 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(559048), // Rule ID 3294 //
     /*  558978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  558989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  558992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  558995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  558998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559024 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  559024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559046 */     GIR_RootConstrainSelectedInstOperands,
     /*  559047 */     // GIR_Coverage, 3294,
     /*  559047 */     GIR_EraseRootFromParent_Done,
     /*  559048 */   // Label 9199: @559048
     /*  559048 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(559123), // Rule ID 3295 //
     /*  559053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  559064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  559067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  559070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  559073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  559099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  559118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559121 */     GIR_RootConstrainSelectedInstOperands,
     /*  559122 */     // GIR_Coverage, 3295,
     /*  559122 */     GIR_EraseRootFromParent_Done,
     /*  559123 */   // Label 9200: @559123
     /*  559123 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(559198), // Rule ID 3298 //
     /*  559128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  559148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559196 */     GIR_RootConstrainSelectedInstOperands,
     /*  559197 */     // GIR_Coverage, 3298,
     /*  559197 */     GIR_EraseRootFromParent_Done,
     /*  559198 */   // Label 9201: @559198
     /*  559198 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(559273), // Rule ID 3299 //
     /*  559203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  559214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  559217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  559220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  559223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559249 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559271 */     GIR_RootConstrainSelectedInstOperands,
     /*  559272 */     // GIR_Coverage, 3299,
     /*  559272 */     GIR_EraseRootFromParent_Done,
     /*  559273 */   // Label 9202: @559273
     /*  559273 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(559348), // Rule ID 3302 //
     /*  559278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  559298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559324 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559346 */     GIR_RootConstrainSelectedInstOperands,
     /*  559347 */     // GIR_Coverage, 3302,
     /*  559347 */     GIR_EraseRootFromParent_Done,
     /*  559348 */   // Label 9203: @559348
     /*  559348 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(559423), // Rule ID 3303 //
     /*  559353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  559364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  559367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  559370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  559373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559399 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559421 */     GIR_RootConstrainSelectedInstOperands,
     /*  559422 */     // GIR_Coverage, 3303,
     /*  559422 */     GIR_EraseRootFromParent_Done,
     /*  559423 */   // Label 9204: @559423
     /*  559423 */   GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(559498), // Rule ID 3306 //
     /*  559428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  559448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559474 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  559474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559496 */     GIR_RootConstrainSelectedInstOperands,
     /*  559497 */     // GIR_Coverage, 3306,
     /*  559497 */     GIR_EraseRootFromParent_Done,
     /*  559498 */   // Label 9205: @559498
     /*  559498 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(559573), // Rule ID 3307 //
     /*  559503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  559523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559549 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559571 */     GIR_RootConstrainSelectedInstOperands,
     /*  559572 */     // GIR_Coverage, 3307,
     /*  559572 */     GIR_EraseRootFromParent_Done,
     /*  559573 */   // Label 9206: @559573
     /*  559573 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(559648), // Rule ID 3310 //
     /*  559578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  559589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  559592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  559595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  559598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559624 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559646 */     GIR_RootConstrainSelectedInstOperands,
     /*  559647 */     // GIR_Coverage, 3310,
     /*  559647 */     GIR_EraseRootFromParent_Done,
     /*  559648 */   // Label 9207: @559648
     /*  559648 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(559723), // Rule ID 3311 //
     /*  559653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  559664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  559667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  559670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  559673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559699 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  559699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559721 */     GIR_RootConstrainSelectedInstOperands,
     /*  559722 */     // GIR_Coverage, 3311,
     /*  559722 */     GIR_EraseRootFromParent_Done,
     /*  559723 */   // Label 9208: @559723
     /*  559723 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(559798), // Rule ID 3314 //
     /*  559728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  559739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  559742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  559745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  559748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559774 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559796 */     GIR_RootConstrainSelectedInstOperands,
     /*  559797 */     // GIR_Coverage, 3314,
     /*  559797 */     GIR_EraseRootFromParent_Done,
     /*  559798 */   // Label 9209: @559798
     /*  559798 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(559873), // Rule ID 3315 //
     /*  559803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  559814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  559817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  559820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  559823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559849 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  559849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559871 */     GIR_RootConstrainSelectedInstOperands,
     /*  559872 */     // GIR_Coverage, 3315,
     /*  559872 */     GIR_EraseRootFromParent_Done,
     /*  559873 */   // Label 9210: @559873
     /*  559873 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(559948), // Rule ID 3318 //
     /*  559878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  559889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  559892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  559895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  559898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559924 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559946 */     GIR_RootConstrainSelectedInstOperands,
     /*  559947 */     // GIR_Coverage, 3318,
     /*  559947 */     GIR_EraseRootFromParent_Done,
     /*  559948 */   // Label 9211: @559948
     /*  559948 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(560023), // Rule ID 3319 //
     /*  559953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  559964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  559967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  559970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  559973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559999 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  559999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  560002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560021 */     GIR_RootConstrainSelectedInstOperands,
     /*  560022 */     // GIR_Coverage, 3319,
     /*  560022 */     GIR_EraseRootFromParent_Done,
     /*  560023 */   // Label 9212: @560023
     /*  560023 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(560098), // Rule ID 3322 //
     /*  560028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560074 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  560077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560096 */     GIR_RootConstrainSelectedInstOperands,
     /*  560097 */     // GIR_Coverage, 3322,
     /*  560097 */     GIR_EraseRootFromParent_Done,
     /*  560098 */   // Label 9213: @560098
     /*  560098 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(560173), // Rule ID 3323 //
     /*  560103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  560114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  560117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  560120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560149 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  560152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560171 */     GIR_RootConstrainSelectedInstOperands,
     /*  560172 */     // GIR_Coverage, 3323,
     /*  560172 */     GIR_EraseRootFromParent_Done,
     /*  560173 */   // Label 9214: @560173
     /*  560173 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(560248), // Rule ID 3326 //
     /*  560178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560224 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560246 */     GIR_RootConstrainSelectedInstOperands,
     /*  560247 */     // GIR_Coverage, 3326,
     /*  560247 */     GIR_EraseRootFromParent_Done,
     /*  560248 */   // Label 9215: @560248
     /*  560248 */   GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(560323), // Rule ID 3327 //
     /*  560253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  560264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  560267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  560270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560299 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560321 */     GIR_RootConstrainSelectedInstOperands,
     /*  560322 */     // GIR_Coverage, 3327,
     /*  560322 */     GIR_EraseRootFromParent_Done,
     /*  560323 */   // Label 9216: @560323
     /*  560323 */   GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(560398), // Rule ID 3330 //
     /*  560328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560374 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560396 */     GIR_RootConstrainSelectedInstOperands,
     /*  560397 */     // GIR_Coverage, 3330,
     /*  560397 */     GIR_EraseRootFromParent_Done,
     /*  560398 */   // Label 9217: @560398
     /*  560398 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(560473), // Rule ID 3331 //
     /*  560403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  560414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  560417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  560420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560449 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560471 */     GIR_RootConstrainSelectedInstOperands,
     /*  560472 */     // GIR_Coverage, 3331,
     /*  560472 */     GIR_EraseRootFromParent_Done,
     /*  560473 */   // Label 9218: @560473
     /*  560473 */   GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(560548), // Rule ID 3334 //
     /*  560478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  560489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  560492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  560495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560524 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  560524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560546 */     GIR_RootConstrainSelectedInstOperands,
     /*  560547 */     // GIR_Coverage, 3334,
     /*  560547 */     GIR_EraseRootFromParent_Done,
     /*  560548 */   // Label 9219: @560548
     /*  560548 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(560623), // Rule ID 3335 //
     /*  560553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  560564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  560567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  560570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560599 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  560599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560621 */     GIR_RootConstrainSelectedInstOperands,
     /*  560622 */     // GIR_Coverage, 3335,
     /*  560622 */     GIR_EraseRootFromParent_Done,
     /*  560623 */   // Label 9220: @560623
     /*  560623 */   GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(560698), // Rule ID 3338 //
     /*  560628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  560639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  560642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  560645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560674 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  560674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560696 */     GIR_RootConstrainSelectedInstOperands,
     /*  560697 */     // GIR_Coverage, 3338,
     /*  560697 */     GIR_EraseRootFromParent_Done,
     /*  560698 */   // Label 9221: @560698
     /*  560698 */   GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(560773), // Rule ID 3339 //
     /*  560703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  560714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  560717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  560720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560749 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  560749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560771 */     GIR_RootConstrainSelectedInstOperands,
     /*  560772 */     // GIR_Coverage, 3339,
     /*  560772 */     GIR_EraseRootFromParent_Done,
     /*  560773 */   // Label 9222: @560773
     /*  560773 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(560848), // Rule ID 3342 //
     /*  560778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  560789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  560792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  560795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560824 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  560824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560846 */     GIR_RootConstrainSelectedInstOperands,
     /*  560847 */     // GIR_Coverage, 3342,
     /*  560847 */     GIR_EraseRootFromParent_Done,
     /*  560848 */   // Label 9223: @560848
     /*  560848 */   GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(560923), // Rule ID 3343 //
     /*  560853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  560864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  560867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  560870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560899 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  560899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560921 */     GIR_RootConstrainSelectedInstOperands,
     /*  560922 */     // GIR_Coverage, 3343,
     /*  560922 */     GIR_EraseRootFromParent_Done,
     /*  560923 */   // Label 9224: @560923
     /*  560923 */   GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(560998), // Rule ID 3346 //
     /*  560928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  560939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  560942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  560945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560996 */     GIR_RootConstrainSelectedInstOperands,
     /*  560997 */     // GIR_Coverage, 3346,
     /*  560997 */     GIR_EraseRootFromParent_Done,
     /*  560998 */   // Label 9225: @560998
     /*  560998 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(561073), // Rule ID 3347 //
     /*  561003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  561014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  561017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  561020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561049 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11621:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561071 */     GIR_RootConstrainSelectedInstOperands,
     /*  561072 */     // GIR_Coverage, 3347,
     /*  561072 */     GIR_EraseRootFromParent_Done,
     /*  561073 */   // Label 9226: @561073
     /*  561073 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(561148), // Rule ID 3350 //
     /*  561078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561124 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561146 */     GIR_RootConstrainSelectedInstOperands,
     /*  561147 */     // GIR_Coverage, 3350,
     /*  561147 */     GIR_EraseRootFromParent_Done,
     /*  561148 */   // Label 9227: @561148
     /*  561148 */   GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(561223), // Rule ID 3351 //
     /*  561153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  561164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  561167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  561170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561199 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11621:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561221 */     GIR_RootConstrainSelectedInstOperands,
     /*  561222 */     // GIR_Coverage, 3351,
     /*  561222 */     GIR_EraseRootFromParent_Done,
     /*  561223 */   // Label 9228: @561223
     /*  561223 */   GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(561298), // Rule ID 3354 //
     /*  561228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561296 */     GIR_RootConstrainSelectedInstOperands,
     /*  561297 */     // GIR_Coverage, 3354,
     /*  561297 */     GIR_EraseRootFromParent_Done,
     /*  561298 */   // Label 9229: @561298
     /*  561298 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(561373), // Rule ID 3355 //
     /*  561303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  561314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  561317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  561320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561349 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11621:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  561349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561371 */     GIR_RootConstrainSelectedInstOperands,
     /*  561372 */     // GIR_Coverage, 3355,
     /*  561372 */     GIR_EraseRootFromParent_Done,
     /*  561373 */   // Label 9230: @561373
     /*  561373 */   GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(561448), // Rule ID 3358 //
     /*  561378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  561381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  561424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561446 */     GIR_RootConstrainSelectedInstOperands,
     /*  561447 */     // GIR_Coverage, 3358,
     /*  561447 */     GIR_EraseRootFromParent_Done,
     /*  561448 */   // Label 9231: @561448
     /*  561448 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(561523), // Rule ID 3359 //
     /*  561453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  561456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  561464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  561467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  561470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  561488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561499 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11621:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  561499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  561502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561521 */     GIR_RootConstrainSelectedInstOperands,
     /*  561522 */     // GIR_Coverage, 3359,
     /*  561522 */     GIR_EraseRootFromParent_Done,
     /*  561523 */   // Label 9232: @561523
     /*  561523 */   GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(561598), // Rule ID 3362 //
     /*  561528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  561539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  561542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  561545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561574 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  561577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561596 */     GIR_RootConstrainSelectedInstOperands,
     /*  561597 */     // GIR_Coverage, 3362,
     /*  561597 */     GIR_EraseRootFromParent_Done,
     /*  561598 */   // Label 9233: @561598
     /*  561598 */   GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(561673), // Rule ID 3363 //
     /*  561603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  561614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  561617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  561620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561649 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  561652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561671 */     GIR_RootConstrainSelectedInstOperands,
     /*  561672 */     // GIR_Coverage, 3363,
     /*  561672 */     GIR_EraseRootFromParent_Done,
     /*  561673 */   // Label 9234: @561673
     /*  561673 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(561748), // Rule ID 3366 //
     /*  561678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  561689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  561692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  561695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561724 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  561727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561746 */     GIR_RootConstrainSelectedInstOperands,
     /*  561747 */     // GIR_Coverage, 3366,
     /*  561747 */     GIR_EraseRootFromParent_Done,
     /*  561748 */   // Label 9235: @561748
     /*  561748 */   GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(561823), // Rule ID 3367 //
     /*  561753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  561764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  561767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  561770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561799 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  561802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561821 */     GIR_RootConstrainSelectedInstOperands,
     /*  561822 */     // GIR_Coverage, 3367,
     /*  561822 */     GIR_EraseRootFromParent_Done,
     /*  561823 */   // Label 9236: @561823
     /*  561823 */   GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(561898), // Rule ID 3370 //
     /*  561828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  561839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  561842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  561845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561874 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  561877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561896 */     GIR_RootConstrainSelectedInstOperands,
     /*  561897 */     // GIR_Coverage, 3370,
     /*  561897 */     GIR_EraseRootFromParent_Done,
     /*  561898 */   // Label 9237: @561898
     /*  561898 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(561973), // Rule ID 3371 //
     /*  561903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  561914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  561917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  561920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561949 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  561952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561971 */     GIR_RootConstrainSelectedInstOperands,
     /*  561972 */     // GIR_Coverage, 3371,
     /*  561972 */     GIR_EraseRootFromParent_Done,
     /*  561973 */   // Label 9238: @561973
     /*  561973 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(562048), // Rule ID 3374 //
     /*  561978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  561989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  561992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  561995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562046 */     GIR_RootConstrainSelectedInstOperands,
     /*  562047 */     // GIR_Coverage, 3374,
     /*  562047 */     GIR_EraseRootFromParent_Done,
     /*  562048 */   // Label 9239: @562048
     /*  562048 */   GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(562123), // Rule ID 3375 //
     /*  562053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  562064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  562067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  562070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562099 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562121 */     GIR_RootConstrainSelectedInstOperands,
     /*  562122 */     // GIR_Coverage, 3375,
     /*  562122 */     GIR_EraseRootFromParent_Done,
     /*  562123 */   // Label 9240: @562123
     /*  562123 */   GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(562198), // Rule ID 3378 //
     /*  562128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562174 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562196 */     GIR_RootConstrainSelectedInstOperands,
     /*  562197 */     // GIR_Coverage, 3378,
     /*  562197 */     GIR_EraseRootFromParent_Done,
     /*  562198 */   // Label 9241: @562198
     /*  562198 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(562273), // Rule ID 3379 //
     /*  562203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  562214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  562217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  562220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562249 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562271 */     GIR_RootConstrainSelectedInstOperands,
     /*  562272 */     // GIR_Coverage, 3379,
     /*  562272 */     GIR_EraseRootFromParent_Done,
     /*  562273 */   // Label 9242: @562273
     /*  562273 */   GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(562348), // Rule ID 3382 //
     /*  562278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562324 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  562324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562346 */     GIR_RootConstrainSelectedInstOperands,
     /*  562347 */     // GIR_Coverage, 3382,
     /*  562347 */     GIR_EraseRootFromParent_Done,
     /*  562348 */   // Label 9243: @562348
     /*  562348 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(562423), // Rule ID 3383 //
     /*  562353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  562364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  562367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  562370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562399 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  562399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  562418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562421 */     GIR_RootConstrainSelectedInstOperands,
     /*  562422 */     // GIR_Coverage, 3383,
     /*  562422 */     GIR_EraseRootFromParent_Done,
     /*  562423 */   // Label 9244: @562423
     /*  562423 */   GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(562498), // Rule ID 3386 //
     /*  562428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562474 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562496 */     GIR_RootConstrainSelectedInstOperands,
     /*  562497 */     // GIR_Coverage, 3386,
     /*  562497 */     GIR_EraseRootFromParent_Done,
     /*  562498 */   // Label 9245: @562498
     /*  562498 */   GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(562573), // Rule ID 3387 //
     /*  562503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562571 */     GIR_RootConstrainSelectedInstOperands,
     /*  562572 */     // GIR_Coverage, 3387,
     /*  562572 */     GIR_EraseRootFromParent_Done,
     /*  562573 */   // Label 9246: @562573
     /*  562573 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(562648), // Rule ID 3390 //
     /*  562578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  562589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  562592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  562595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562646 */     GIR_RootConstrainSelectedInstOperands,
     /*  562647 */     // GIR_Coverage, 3390,
     /*  562647 */     GIR_EraseRootFromParent_Done,
     /*  562648 */   // Label 9247: @562648
     /*  562648 */   GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(562723), // Rule ID 3391 //
     /*  562653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  562664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  562667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  562670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562699 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562721 */     GIR_RootConstrainSelectedInstOperands,
     /*  562722 */     // GIR_Coverage, 3391,
     /*  562722 */     GIR_EraseRootFromParent_Done,
     /*  562723 */   // Label 9248: @562723
     /*  562723 */   GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(562798), // Rule ID 3394 //
     /*  562728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  562739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  562742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  562745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562796 */     GIR_RootConstrainSelectedInstOperands,
     /*  562797 */     // GIR_Coverage, 3394,
     /*  562797 */     GIR_EraseRootFromParent_Done,
     /*  562798 */   // Label 9249: @562798
     /*  562798 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(562873), // Rule ID 3395 //
     /*  562803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  562814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  562817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  562820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562849 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562871 */     GIR_RootConstrainSelectedInstOperands,
     /*  562872 */     // GIR_Coverage, 3395,
     /*  562872 */     GIR_EraseRootFromParent_Done,
     /*  562873 */   // Label 9250: @562873
     /*  562873 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(562948), // Rule ID 3398 //
     /*  562878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  562881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  562889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  562892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  562895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562924 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  562924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562946 */     GIR_RootConstrainSelectedInstOperands,
     /*  562947 */     // GIR_Coverage, 3398,
     /*  562947 */     GIR_EraseRootFromParent_Done,
     /*  562948 */   // Label 9251: @562948
     /*  562948 */   GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(563023), // Rule ID 3399 //
     /*  562953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  562956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  562964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  562967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  562970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562999 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11621:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  562999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  563002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563021 */     GIR_RootConstrainSelectedInstOperands,
     /*  563022 */     // GIR_Coverage, 3399,
     /*  563022 */     GIR_EraseRootFromParent_Done,
     /*  563023 */   // Label 9252: @563023
     /*  563023 */   GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(563098), // Rule ID 3402 //
     /*  563028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563074 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563096 */     GIR_RootConstrainSelectedInstOperands,
     /*  563097 */     // GIR_Coverage, 3402,
     /*  563097 */     GIR_EraseRootFromParent_Done,
     /*  563098 */   // Label 9253: @563098
     /*  563098 */   GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(563173), // Rule ID 3403 //
     /*  563103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  563114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  563117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  563120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  563138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563149 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11621:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  563152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563171 */     GIR_RootConstrainSelectedInstOperands,
     /*  563172 */     // GIR_Coverage, 3403,
     /*  563172 */     GIR_EraseRootFromParent_Done,
     /*  563173 */   // Label 9254: @563173
     /*  563173 */   GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(563248), // Rule ID 3406 //
     /*  563178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  563181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563224 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  563224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563246 */     GIR_RootConstrainSelectedInstOperands,
     /*  563247 */     // GIR_Coverage, 3406,
     /*  563247 */     GIR_EraseRootFromParent_Done,
     /*  563248 */   // Label 9255: @563248
     /*  563248 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(563323), // Rule ID 3407 //
     /*  563253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  563256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  563261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  563264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  563267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  563270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  563288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563299 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11621:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  563299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  563302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  563318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563321 */     GIR_RootConstrainSelectedInstOperands,
     /*  563322 */     // GIR_Coverage, 3407,
     /*  563322 */     GIR_EraseRootFromParent_Done,
     /*  563323 */   // Label 9256: @563323
     /*  563323 */   GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(563398), // Rule ID 3410 //
     /*  563328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563374 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  563377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563396 */     GIR_RootConstrainSelectedInstOperands,
     /*  563397 */     // GIR_Coverage, 3410,
     /*  563397 */     GIR_EraseRootFromParent_Done,
     /*  563398 */   // Label 9257: @563398
     /*  563398 */   GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(563473), // Rule ID 3411 //
     /*  563403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  563414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  563417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  563420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563449 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  563452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563471 */     GIR_RootConstrainSelectedInstOperands,
     /*  563472 */     // GIR_Coverage, 3411,
     /*  563472 */     GIR_EraseRootFromParent_Done,
     /*  563473 */   // Label 9258: @563473
     /*  563473 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(563548), // Rule ID 3414 //
     /*  563478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  563489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  563492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  563495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563524 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563546 */     GIR_RootConstrainSelectedInstOperands,
     /*  563547 */     // GIR_Coverage, 3414,
     /*  563547 */     GIR_EraseRootFromParent_Done,
     /*  563548 */   // Label 9259: @563548
     /*  563548 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(563623), // Rule ID 3415 //
     /*  563553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  563564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  563567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  563570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563599 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563621 */     GIR_RootConstrainSelectedInstOperands,
     /*  563622 */     // GIR_Coverage, 3415,
     /*  563622 */     GIR_EraseRootFromParent_Done,
     /*  563623 */   // Label 9260: @563623
     /*  563623 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(563698), // Rule ID 3418 //
     /*  563628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  563639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  563642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  563645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563674 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563696 */     GIR_RootConstrainSelectedInstOperands,
     /*  563697 */     // GIR_Coverage, 3418,
     /*  563697 */     GIR_EraseRootFromParent_Done,
     /*  563698 */   // Label 9261: @563698
     /*  563698 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(563773), // Rule ID 3419 //
     /*  563703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  563714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  563717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  563720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563749 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563771 */     GIR_RootConstrainSelectedInstOperands,
     /*  563772 */     // GIR_Coverage, 3419,
     /*  563772 */     GIR_EraseRootFromParent_Done,
     /*  563773 */   // Label 9262: @563773
     /*  563773 */   GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(563848), // Rule ID 3422 //
     /*  563778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  563789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  563792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  563795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563824 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563846 */     GIR_RootConstrainSelectedInstOperands,
     /*  563847 */     // GIR_Coverage, 3422,
     /*  563847 */     GIR_EraseRootFromParent_Done,
     /*  563848 */   // Label 9263: @563848
     /*  563848 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(563923), // Rule ID 3423 //
     /*  563853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  563864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  563867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  563870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563899 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  563899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563921 */     GIR_RootConstrainSelectedInstOperands,
     /*  563922 */     // GIR_Coverage, 3423,
     /*  563922 */     GIR_EraseRootFromParent_Done,
     /*  563923 */   // Label 9264: @563923
     /*  563923 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(563998), // Rule ID 3426 //
     /*  563928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  563939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  563942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  563945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563974 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563996 */     GIR_RootConstrainSelectedInstOperands,
     /*  563997 */     // GIR_Coverage, 3426,
     /*  563997 */     GIR_EraseRootFromParent_Done,
     /*  563998 */   // Label 9265: @563998
     /*  563998 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(564073), // Rule ID 3427 //
     /*  564003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  564014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  564017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  564020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564049 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564071 */     GIR_RootConstrainSelectedInstOperands,
     /*  564072 */     // GIR_Coverage, 3427,
     /*  564072 */     GIR_EraseRootFromParent_Done,
     /*  564073 */   // Label 9266: @564073
     /*  564073 */   GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(564148), // Rule ID 3430 //
     /*  564078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564124 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564146 */     GIR_RootConstrainSelectedInstOperands,
     /*  564147 */     // GIR_Coverage, 3430,
     /*  564147 */     GIR_EraseRootFromParent_Done,
     /*  564148 */   // Label 9267: @564148
     /*  564148 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(564223), // Rule ID 3431 //
     /*  564153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  564164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  564167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  564170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564199 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  564202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564221 */     GIR_RootConstrainSelectedInstOperands,
     /*  564222 */     // GIR_Coverage, 3431,
     /*  564222 */     GIR_EraseRootFromParent_Done,
     /*  564223 */   // Label 9268: @564223
     /*  564223 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(564298), // Rule ID 3434 //
     /*  564228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564296 */     GIR_RootConstrainSelectedInstOperands,
     /*  564297 */     // GIR_Coverage, 3434,
     /*  564297 */     GIR_EraseRootFromParent_Done,
     /*  564298 */   // Label 9269: @564298
     /*  564298 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(564373), // Rule ID 3435 //
     /*  564303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  564314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  564317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  564320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564349 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11529:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564371 */     GIR_RootConstrainSelectedInstOperands,
     /*  564372 */     // GIR_Coverage, 3435,
     /*  564372 */     GIR_EraseRootFromParent_Done,
     /*  564373 */   // Label 9270: @564373
     /*  564373 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(564448), // Rule ID 3438 //
     /*  564378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564424 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564446 */     GIR_RootConstrainSelectedInstOperands,
     /*  564447 */     // GIR_Coverage, 3438,
     /*  564447 */     GIR_EraseRootFromParent_Done,
     /*  564448 */   // Label 9271: @564448
     /*  564448 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(564523), // Rule ID 3439 //
     /*  564453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  564464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  564467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  564470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564499 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11529:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564521 */     GIR_RootConstrainSelectedInstOperands,
     /*  564522 */     // GIR_Coverage, 3439,
     /*  564522 */     GIR_EraseRootFromParent_Done,
     /*  564523 */   // Label 9272: @564523
     /*  564523 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(564598), // Rule ID 3442 //
     /*  564528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  564539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  564542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  564545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564596 */     GIR_RootConstrainSelectedInstOperands,
     /*  564597 */     // GIR_Coverage, 3442,
     /*  564597 */     GIR_EraseRootFromParent_Done,
     /*  564598 */   // Label 9273: @564598
     /*  564598 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(564673), // Rule ID 3443 //
     /*  564603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  564614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  564617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  564620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11529:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564671 */     GIR_RootConstrainSelectedInstOperands,
     /*  564672 */     // GIR_Coverage, 3443,
     /*  564672 */     GIR_EraseRootFromParent_Done,
     /*  564673 */   // Label 9274: @564673
     /*  564673 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(564748), // Rule ID 3446 //
     /*  564678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  564681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  564689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  564692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  564695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  564724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  564743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564746 */     GIR_RootConstrainSelectedInstOperands,
     /*  564747 */     // GIR_Coverage, 3446,
     /*  564747 */     GIR_EraseRootFromParent_Done,
     /*  564748 */   // Label 9275: @564748
     /*  564748 */   GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(564823), // Rule ID 3447 //
     /*  564753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  564756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  564764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  564767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  564770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564799 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11529:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  564799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  564818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564821 */     GIR_RootConstrainSelectedInstOperands,
     /*  564822 */     // GIR_Coverage, 3447,
     /*  564822 */     GIR_EraseRootFromParent_Done,
     /*  564823 */   // Label 9276: @564823
     /*  564823 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(564898), // Rule ID 3450 //
     /*  564828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  564839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  564842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  564845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564874 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  564877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564896 */     GIR_RootConstrainSelectedInstOperands,
     /*  564897 */     // GIR_Coverage, 3450,
     /*  564897 */     GIR_EraseRootFromParent_Done,
     /*  564898 */   // Label 9277: @564898
     /*  564898 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(564973), // Rule ID 3451 //
     /*  564903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  564914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  564917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  564920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564949 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  564952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564971 */     GIR_RootConstrainSelectedInstOperands,
     /*  564972 */     // GIR_Coverage, 3451,
     /*  564972 */     GIR_EraseRootFromParent_Done,
     /*  564973 */   // Label 9278: @564973
     /*  564973 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(565048), // Rule ID 3454 //
     /*  564978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  564989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  564992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  564995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565024 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565046 */     GIR_RootConstrainSelectedInstOperands,
     /*  565047 */     // GIR_Coverage, 3454,
     /*  565047 */     GIR_EraseRootFromParent_Done,
     /*  565048 */   // Label 9279: @565048
     /*  565048 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(565123), // Rule ID 3455 //
     /*  565053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  565064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  565067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  565070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565099 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565121 */     GIR_RootConstrainSelectedInstOperands,
     /*  565122 */     // GIR_Coverage, 3455,
     /*  565122 */     GIR_EraseRootFromParent_Done,
     /*  565123 */   // Label 9280: @565123
     /*  565123 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(565198), // Rule ID 3458 //
     /*  565128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565174 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  565174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565196 */     GIR_RootConstrainSelectedInstOperands,
     /*  565197 */     // GIR_Coverage, 3458,
     /*  565197 */     GIR_EraseRootFromParent_Done,
     /*  565198 */   // Label 9281: @565198
     /*  565198 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(565273), // Rule ID 3459 //
     /*  565203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  565214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  565217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  565220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565249 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  565249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  565268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565271 */     GIR_RootConstrainSelectedInstOperands,
     /*  565272 */     // GIR_Coverage, 3459,
     /*  565272 */     GIR_EraseRootFromParent_Done,
     /*  565273 */   // Label 9282: @565273
     /*  565273 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(565348), // Rule ID 3462 //
     /*  565278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565346 */     GIR_RootConstrainSelectedInstOperands,
     /*  565347 */     // GIR_Coverage, 3462,
     /*  565347 */     GIR_EraseRootFromParent_Done,
     /*  565348 */   // Label 9283: @565348
     /*  565348 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(565423), // Rule ID 3463 //
     /*  565353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  565364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  565367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  565370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565399 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565421 */     GIR_RootConstrainSelectedInstOperands,
     /*  565422 */     // GIR_Coverage, 3463,
     /*  565422 */     GIR_EraseRootFromParent_Done,
     /*  565423 */   // Label 9284: @565423
     /*  565423 */   GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(565498), // Rule ID 3466 //
     /*  565428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565496 */     GIR_RootConstrainSelectedInstOperands,
     /*  565497 */     // GIR_Coverage, 3466,
     /*  565497 */     GIR_EraseRootFromParent_Done,
     /*  565498 */   // Label 9285: @565498
     /*  565498 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(565573), // Rule ID 3467 //
     /*  565503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565549 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565571 */     GIR_RootConstrainSelectedInstOperands,
     /*  565572 */     // GIR_Coverage, 3467,
     /*  565572 */     GIR_EraseRootFromParent_Done,
     /*  565573 */   // Label 9286: @565573
     /*  565573 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(565648), // Rule ID 3470 //
     /*  565578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  565589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  565592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  565595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565624 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565646 */     GIR_RootConstrainSelectedInstOperands,
     /*  565647 */     // GIR_Coverage, 3470,
     /*  565647 */     GIR_EraseRootFromParent_Done,
     /*  565648 */   // Label 9287: @565648
     /*  565648 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(565723), // Rule ID 3471 //
     /*  565653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  565664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  565667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  565670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565699 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565721 */     GIR_RootConstrainSelectedInstOperands,
     /*  565722 */     // GIR_Coverage, 3471,
     /*  565722 */     GIR_EraseRootFromParent_Done,
     /*  565723 */   // Label 9288: @565723
     /*  565723 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(565798), // Rule ID 3474 //
     /*  565728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  565739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  565742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  565745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565796 */     GIR_RootConstrainSelectedInstOperands,
     /*  565797 */     // GIR_Coverage, 3474,
     /*  565797 */     GIR_EraseRootFromParent_Done,
     /*  565798 */   // Label 9289: @565798
     /*  565798 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(565873), // Rule ID 3475 //
     /*  565803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  565814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  565817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  565820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565849 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565871 */     GIR_RootConstrainSelectedInstOperands,
     /*  565872 */     // GIR_Coverage, 3475,
     /*  565872 */     GIR_EraseRootFromParent_Done,
     /*  565873 */   // Label 9290: @565873
     /*  565873 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(565948), // Rule ID 3478 //
     /*  565878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  565889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  565892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  565895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565946 */     GIR_RootConstrainSelectedInstOperands,
     /*  565947 */     // GIR_Coverage, 3478,
     /*  565947 */     GIR_EraseRootFromParent_Done,
     /*  565948 */   // Label 9291: @565948
     /*  565948 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(566023), // Rule ID 3479 //
     /*  565953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  565964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  565967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  565970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565999 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566021 */     GIR_RootConstrainSelectedInstOperands,
     /*  566022 */     // GIR_Coverage, 3479,
     /*  566022 */     GIR_EraseRootFromParent_Done,
     /*  566023 */   // Label 9292: @566023
     /*  566023 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(566098), // Rule ID 3482 //
     /*  566028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566074 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  566074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566096 */     GIR_RootConstrainSelectedInstOperands,
     /*  566097 */     // GIR_Coverage, 3482,
     /*  566097 */     GIR_EraseRootFromParent_Done,
     /*  566098 */   // Label 9293: @566098
     /*  566098 */   GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(566173), // Rule ID 3483 //
     /*  566103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  566114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  566117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  566120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566149 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  566149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  566168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566171 */     GIR_RootConstrainSelectedInstOperands,
     /*  566172 */     // GIR_Coverage, 3483,
     /*  566172 */     GIR_EraseRootFromParent_Done,
     /*  566173 */   // Label 9294: @566173
     /*  566173 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(566248), // Rule ID 3486 //
     /*  566178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566224 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566246 */     GIR_RootConstrainSelectedInstOperands,
     /*  566247 */     // GIR_Coverage, 3486,
     /*  566247 */     GIR_EraseRootFromParent_Done,
     /*  566248 */   // Label 9295: @566248
     /*  566248 */   GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(566323), // Rule ID 3487 //
     /*  566253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  566264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  566267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  566270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566299 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11529:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  566302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566321 */     GIR_RootConstrainSelectedInstOperands,
     /*  566322 */     // GIR_Coverage, 3487,
     /*  566322 */     GIR_EraseRootFromParent_Done,
     /*  566323 */   // Label 9296: @566323
     /*  566323 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(566398), // Rule ID 3490 //
     /*  566328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566374 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566396 */     GIR_RootConstrainSelectedInstOperands,
     /*  566397 */     // GIR_Coverage, 3490,
     /*  566397 */     GIR_EraseRootFromParent_Done,
     /*  566398 */   // Label 9297: @566398
     /*  566398 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(566473), // Rule ID 3491 //
     /*  566403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  566414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  566417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  566420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566449 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11529:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  566452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566471 */     GIR_RootConstrainSelectedInstOperands,
     /*  566472 */     // GIR_Coverage, 3491,
     /*  566472 */     GIR_EraseRootFromParent_Done,
     /*  566473 */   // Label 9298: @566473
     /*  566473 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(566548), // Rule ID 3494 //
     /*  566478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  566481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  566489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  566492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  566495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  566498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566524 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566546 */     GIR_RootConstrainSelectedInstOperands,
     /*  566547 */     // GIR_Coverage, 3494,
     /*  566547 */     GIR_EraseRootFromParent_Done,
     /*  566548 */   // Label 9299: @566548
     /*  566548 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(566623), // Rule ID 3495 //
     /*  566553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  566564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  566567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  566570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566599 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11529:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566621 */     GIR_RootConstrainSelectedInstOperands,
     /*  566622 */     // GIR_Coverage, 3495,
     /*  566622 */     GIR_EraseRootFromParent_Done,
     /*  566623 */   // Label 9300: @566623
     /*  566623 */   GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(566698), // Rule ID 3586 //
     /*  566628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  566639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  566642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  566645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  566648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  566677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566696 */     GIR_RootConstrainSelectedInstOperands,
     /*  566697 */     // GIR_Coverage, 3586,
     /*  566697 */     GIR_EraseRootFromParent_Done,
     /*  566698 */   // Label 9301: @566698
     /*  566698 */   GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(566773), // Rule ID 3587 //
     /*  566703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  566714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  566717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  566720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  566723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566749 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  566752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566771 */     GIR_RootConstrainSelectedInstOperands,
     /*  566772 */     // GIR_Coverage, 3587,
     /*  566772 */     GIR_EraseRootFromParent_Done,
     /*  566773 */   // Label 9302: @566773
     /*  566773 */   GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(566848), // Rule ID 3590 //
     /*  566778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  566789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  566792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  566795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  566798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  566827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566846 */     GIR_RootConstrainSelectedInstOperands,
     /*  566847 */     // GIR_Coverage, 3590,
     /*  566847 */     GIR_EraseRootFromParent_Done,
     /*  566848 */   // Label 9303: @566848
     /*  566848 */   GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(566923), // Rule ID 3591 //
     /*  566853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  566864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  566867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  566870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  566873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566899 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  566902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566921 */     GIR_RootConstrainSelectedInstOperands,
     /*  566922 */     // GIR_Coverage, 3591,
     /*  566922 */     GIR_EraseRootFromParent_Done,
     /*  566923 */   // Label 9304: @566923
     /*  566923 */   GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(566998), // Rule ID 3594 //
     /*  566928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  566939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  566942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  566945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  566948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  566977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566996 */     GIR_RootConstrainSelectedInstOperands,
     /*  566997 */     // GIR_Coverage, 3594,
     /*  566997 */     GIR_EraseRootFromParent_Done,
     /*  566998 */   // Label 9305: @566998
     /*  566998 */   GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(567073), // Rule ID 3595 //
     /*  567003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  567014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  567017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  567020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  567023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567049 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567071 */     GIR_RootConstrainSelectedInstOperands,
     /*  567072 */     // GIR_Coverage, 3595,
     /*  567072 */     GIR_EraseRootFromParent_Done,
     /*  567073 */   // Label 9306: @567073
     /*  567073 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(567148), // Rule ID 3598 //
     /*  567078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  567089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  567092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  567095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  567098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567146 */     GIR_RootConstrainSelectedInstOperands,
     /*  567147 */     // GIR_Coverage, 3598,
     /*  567147 */     GIR_EraseRootFromParent_Done,
     /*  567148 */   // Label 9307: @567148
     /*  567148 */   GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(567223), // Rule ID 3599 //
     /*  567153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  567164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  567167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  567170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  567173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567199 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567221 */     GIR_RootConstrainSelectedInstOperands,
     /*  567222 */     // GIR_Coverage, 3599,
     /*  567222 */     GIR_EraseRootFromParent_Done,
     /*  567223 */   // Label 9308: @567223
     /*  567223 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(567298), // Rule ID 3602 //
     /*  567228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  567239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  567242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  567245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  567248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567296 */     GIR_RootConstrainSelectedInstOperands,
     /*  567297 */     // GIR_Coverage, 3602,
     /*  567297 */     GIR_EraseRootFromParent_Done,
     /*  567298 */   // Label 9309: @567298
     /*  567298 */   GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(567373), // Rule ID 3603 //
     /*  567303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  567314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  567317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  567320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  567323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567349 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567371 */     GIR_RootConstrainSelectedInstOperands,
     /*  567372 */     // GIR_Coverage, 3603,
     /*  567372 */     GIR_EraseRootFromParent_Done,
     /*  567373 */   // Label 9310: @567373
     /*  567373 */   GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(567448), // Rule ID 3606 //
     /*  567378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  567389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  567392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  567395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  567398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  567424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567446 */     GIR_RootConstrainSelectedInstOperands,
     /*  567447 */     // GIR_Coverage, 3606,
     /*  567447 */     GIR_EraseRootFromParent_Done,
     /*  567448 */   // Label 9311: @567448
     /*  567448 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(567523), // Rule ID 3607 //
     /*  567453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  567464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  567467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  567470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  567473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567499 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  567499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567521 */     GIR_RootConstrainSelectedInstOperands,
     /*  567522 */     // GIR_Coverage, 3607,
     /*  567522 */     GIR_EraseRootFromParent_Done,
     /*  567523 */   // Label 9312: @567523
     /*  567523 */   GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(567598), // Rule ID 3610 //
     /*  567528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  567539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  567542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  567548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567574 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567596 */     GIR_RootConstrainSelectedInstOperands,
     /*  567597 */     // GIR_Coverage, 3610,
     /*  567597 */     GIR_EraseRootFromParent_Done,
     /*  567598 */   // Label 9313: @567598
     /*  567598 */   GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(567673), // Rule ID 3611 //
     /*  567603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  567614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  567617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  567623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567649 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567671 */     GIR_RootConstrainSelectedInstOperands,
     /*  567672 */     // GIR_Coverage, 3611,
     /*  567672 */     GIR_EraseRootFromParent_Done,
     /*  567673 */   // Label 9314: @567673
     /*  567673 */   GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(567748), // Rule ID 3614 //
     /*  567678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  567689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  567692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  567698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567746 */     GIR_RootConstrainSelectedInstOperands,
     /*  567747 */     // GIR_Coverage, 3614,
     /*  567747 */     GIR_EraseRootFromParent_Done,
     /*  567748 */   // Label 9315: @567748
     /*  567748 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(567823), // Rule ID 3615 //
     /*  567753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  567764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  567767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  567773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567799 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567821 */     GIR_RootConstrainSelectedInstOperands,
     /*  567822 */     // GIR_Coverage, 3615,
     /*  567822 */     GIR_EraseRootFromParent_Done,
     /*  567823 */   // Label 9316: @567823
     /*  567823 */   GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(567898), // Rule ID 3618 //
     /*  567828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  567839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  567842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  567845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  567848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567896 */     GIR_RootConstrainSelectedInstOperands,
     /*  567897 */     // GIR_Coverage, 3618,
     /*  567897 */     GIR_EraseRootFromParent_Done,
     /*  567898 */   // Label 9317: @567898
     /*  567898 */   GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(567973), // Rule ID 3619 //
     /*  567903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  567914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  567917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  567920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  567923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567949 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567971 */     GIR_RootConstrainSelectedInstOperands,
     /*  567972 */     // GIR_Coverage, 3619,
     /*  567972 */     GIR_EraseRootFromParent_Done,
     /*  567973 */   // Label 9318: @567973
     /*  567973 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(568048), // Rule ID 3622 //
     /*  567978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  567989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  567992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  567995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  567998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568024 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568046 */     GIR_RootConstrainSelectedInstOperands,
     /*  568047 */     // GIR_Coverage, 3622,
     /*  568047 */     GIR_EraseRootFromParent_Done,
     /*  568048 */   // Label 9319: @568048
     /*  568048 */   GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(568123), // Rule ID 3623 //
     /*  568053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  568064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  568067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  568070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  568073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568099 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568121 */     GIR_RootConstrainSelectedInstOperands,
     /*  568122 */     // GIR_Coverage, 3623,
     /*  568122 */     GIR_EraseRootFromParent_Done,
     /*  568123 */   // Label 9320: @568123
     /*  568123 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(568198), // Rule ID 3626 //
     /*  568128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  568139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  568142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  568145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  568148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  568174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568196 */     GIR_RootConstrainSelectedInstOperands,
     /*  568197 */     // GIR_Coverage, 3626,
     /*  568197 */     GIR_EraseRootFromParent_Done,
     /*  568198 */   // Label 9321: @568198
     /*  568198 */   GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(568273), // Rule ID 3627 //
     /*  568203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  568214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  568217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  568220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  568223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  568249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  568268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568271 */     GIR_RootConstrainSelectedInstOperands,
     /*  568272 */     // GIR_Coverage, 3627,
     /*  568272 */     GIR_EraseRootFromParent_Done,
     /*  568273 */   // Label 9322: @568273
     /*  568273 */   GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(568348), // Rule ID 3630 //
     /*  568278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  568298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568346 */     GIR_RootConstrainSelectedInstOperands,
     /*  568347 */     // GIR_Coverage, 3630,
     /*  568347 */     GIR_EraseRootFromParent_Done,
     /*  568348 */   // Label 9323: @568348
     /*  568348 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(568423), // Rule ID 3631 //
     /*  568353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  568364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  568367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  568370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  568373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568399 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  568402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568421 */     GIR_RootConstrainSelectedInstOperands,
     /*  568422 */     // GIR_Coverage, 3631,
     /*  568422 */     GIR_EraseRootFromParent_Done,
     /*  568423 */   // Label 9324: @568423
     /*  568423 */   GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(568498), // Rule ID 3634 //
     /*  568428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  568439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  568442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  568448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568496 */     GIR_RootConstrainSelectedInstOperands,
     /*  568497 */     // GIR_Coverage, 3634,
     /*  568497 */     GIR_EraseRootFromParent_Done,
     /*  568498 */   // Label 9325: @568498
     /*  568498 */   GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(568573), // Rule ID 3635 //
     /*  568503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  568514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  568517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  568523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568571 */     GIR_RootConstrainSelectedInstOperands,
     /*  568572 */     // GIR_Coverage, 3635,
     /*  568572 */     GIR_EraseRootFromParent_Done,
     /*  568573 */   // Label 9326: @568573
     /*  568573 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(568648), // Rule ID 3638 //
     /*  568578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  568589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  568592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  568595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  568598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568624 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568646 */     GIR_RootConstrainSelectedInstOperands,
     /*  568647 */     // GIR_Coverage, 3638,
     /*  568647 */     GIR_EraseRootFromParent_Done,
     /*  568648 */   // Label 9327: @568648
     /*  568648 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(568723), // Rule ID 3639 //
     /*  568653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  568664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  568667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  568670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  568673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568699 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568721 */     GIR_RootConstrainSelectedInstOperands,
     /*  568722 */     // GIR_Coverage, 3639,
     /*  568722 */     GIR_EraseRootFromParent_Done,
     /*  568723 */   // Label 9328: @568723
     /*  568723 */   GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(568798), // Rule ID 3642 //
     /*  568728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  568739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  568742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  568745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  568748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568774 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568796 */     GIR_RootConstrainSelectedInstOperands,
     /*  568797 */     // GIR_Coverage, 3642,
     /*  568797 */     GIR_EraseRootFromParent_Done,
     /*  568798 */   // Label 9329: @568798
     /*  568798 */   GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(568873), // Rule ID 3643 //
     /*  568803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  568814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  568817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  568820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  568823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568849 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568871 */     GIR_RootConstrainSelectedInstOperands,
     /*  568872 */     // GIR_Coverage, 3643,
     /*  568872 */     GIR_EraseRootFromParent_Done,
     /*  568873 */   // Label 9330: @568873
     /*  568873 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(568948), // Rule ID 3646 //
     /*  568878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  568889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  568892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  568895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568924 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  568927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568946 */     GIR_RootConstrainSelectedInstOperands,
     /*  568947 */     // GIR_Coverage, 3646,
     /*  568947 */     GIR_EraseRootFromParent_Done,
     /*  568948 */   // Label 9331: @568948
     /*  568948 */   GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(569023), // Rule ID 3647 //
     /*  568953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  568964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  568967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  568970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568999 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  569002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569021 */     GIR_RootConstrainSelectedInstOperands,
     /*  569022 */     // GIR_Coverage, 3647,
     /*  569022 */     GIR_EraseRootFromParent_Done,
     /*  569023 */   // Label 9332: @569023
     /*  569023 */   GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(569098), // Rule ID 3650 //
     /*  569028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569074 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569096 */     GIR_RootConstrainSelectedInstOperands,
     /*  569097 */     // GIR_Coverage, 3650,
     /*  569097 */     GIR_EraseRootFromParent_Done,
     /*  569098 */   // Label 9333: @569098
     /*  569098 */   GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(569173), // Rule ID 3651 //
     /*  569103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  569114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  569117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  569120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569149 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569171 */     GIR_RootConstrainSelectedInstOperands,
     /*  569172 */     // GIR_Coverage, 3651,
     /*  569172 */     GIR_EraseRootFromParent_Done,
     /*  569173 */   // Label 9334: @569173
     /*  569173 */   GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(569248), // Rule ID 3654 //
     /*  569178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  569189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  569192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569246 */     GIR_RootConstrainSelectedInstOperands,
     /*  569247 */     // GIR_Coverage, 3654,
     /*  569247 */     GIR_EraseRootFromParent_Done,
     /*  569248 */   // Label 9335: @569248
     /*  569248 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(569323), // Rule ID 3655 //
     /*  569253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  569264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  569267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  569270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11643:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569321 */     GIR_RootConstrainSelectedInstOperands,
     /*  569322 */     // GIR_Coverage, 3655,
     /*  569322 */     GIR_EraseRootFromParent_Done,
     /*  569323 */   // Label 9336: @569323
     /*  569323 */   GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(569398), // Rule ID 3658 //
     /*  569328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  569345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569396 */     GIR_RootConstrainSelectedInstOperands,
     /*  569397 */     // GIR_Coverage, 3658,
     /*  569397 */     GIR_EraseRootFromParent_Done,
     /*  569398 */   // Label 9337: @569398
     /*  569398 */   GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(569473), // Rule ID 3659 //
     /*  569403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  569414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  569417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  569420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569471 */     GIR_RootConstrainSelectedInstOperands,
     /*  569472 */     // GIR_Coverage, 3659,
     /*  569472 */     GIR_EraseRootFromParent_Done,
     /*  569473 */   // Label 9338: @569473
     /*  569473 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(569548), // Rule ID 3662 //
     /*  569478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  569495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569524 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  569527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569546 */     GIR_RootConstrainSelectedInstOperands,
     /*  569547 */     // GIR_Coverage, 3662,
     /*  569547 */     GIR_EraseRootFromParent_Done,
     /*  569548 */   // Label 9339: @569548
     /*  569548 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(569623), // Rule ID 3663 //
     /*  569553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  569570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569599 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  569602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569621 */     GIR_RootConstrainSelectedInstOperands,
     /*  569622 */     // GIR_Coverage, 3663,
     /*  569622 */     GIR_EraseRootFromParent_Done,
     /*  569623 */   // Label 9340: @569623
     /*  569623 */   GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(569698), // Rule ID 3666 //
     /*  569628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  569645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569674 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  569677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569696 */     GIR_RootConstrainSelectedInstOperands,
     /*  569697 */     // GIR_Coverage, 3666,
     /*  569697 */     GIR_EraseRootFromParent_Done,
     /*  569698 */   // Label 9341: @569698
     /*  569698 */   GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(569773), // Rule ID 3667 //
     /*  569703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  569720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569749 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  569752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569771 */     GIR_RootConstrainSelectedInstOperands,
     /*  569772 */     // GIR_Coverage, 3667,
     /*  569772 */     GIR_EraseRootFromParent_Done,
     /*  569773 */   // Label 9342: @569773
     /*  569773 */   GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(569848), // Rule ID 3670 //
     /*  569778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  569789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  569792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  569795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569824 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569846 */     GIR_RootConstrainSelectedInstOperands,
     /*  569847 */     // GIR_Coverage, 3670,
     /*  569847 */     GIR_EraseRootFromParent_Done,
     /*  569848 */   // Label 9343: @569848
     /*  569848 */   GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(569923), // Rule ID 3671 //
     /*  569853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  569864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  569867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  569870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569899 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569921 */     GIR_RootConstrainSelectedInstOperands,
     /*  569922 */     // GIR_Coverage, 3671,
     /*  569922 */     GIR_EraseRootFromParent_Done,
     /*  569923 */   // Label 9344: @569923
     /*  569923 */   GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(569998), // Rule ID 3674 //
     /*  569928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  569939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  569942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  569945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569996 */     GIR_RootConstrainSelectedInstOperands,
     /*  569997 */     // GIR_Coverage, 3674,
     /*  569997 */     GIR_EraseRootFromParent_Done,
     /*  569998 */   // Label 9345: @569998
     /*  569998 */   GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(570073), // Rule ID 3675 //
     /*  570003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  570014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  570017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  570020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570049 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11643:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570071 */     GIR_RootConstrainSelectedInstOperands,
     /*  570072 */     // GIR_Coverage, 3675,
     /*  570072 */     GIR_EraseRootFromParent_Done,
     /*  570073 */   // Label 9346: @570073
     /*  570073 */   GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(570148), // Rule ID 3678 //
     /*  570078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  570089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  570092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570146 */     GIR_RootConstrainSelectedInstOperands,
     /*  570147 */     // GIR_Coverage, 3678,
     /*  570147 */     GIR_EraseRootFromParent_Done,
     /*  570148 */   // Label 9347: @570148
     /*  570148 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(570223), // Rule ID 3679 //
     /*  570153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  570164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  570167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  570170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570221 */     GIR_RootConstrainSelectedInstOperands,
     /*  570222 */     // GIR_Coverage, 3679,
     /*  570222 */     GIR_EraseRootFromParent_Done,
     /*  570223 */   // Label 9348: @570223
     /*  570223 */   GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(570298), // Rule ID 3682 //
     /*  570228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  570239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  570242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  570245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570296 */     GIR_RootConstrainSelectedInstOperands,
     /*  570297 */     // GIR_Coverage, 3682,
     /*  570297 */     GIR_EraseRootFromParent_Done,
     /*  570298 */   // Label 9349: @570298
     /*  570298 */   GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(570373), // Rule ID 3683 //
     /*  570303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  570314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  570317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  570320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570349 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570371 */     GIR_RootConstrainSelectedInstOperands,
     /*  570372 */     // GIR_Coverage, 3683,
     /*  570372 */     GIR_EraseRootFromParent_Done,
     /*  570373 */   // Label 9350: @570373
     /*  570373 */   GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(570448), // Rule ID 3686 //
     /*  570378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  570389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  570392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  570395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  570424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570446 */     GIR_RootConstrainSelectedInstOperands,
     /*  570447 */     // GIR_Coverage, 3686,
     /*  570447 */     GIR_EraseRootFromParent_Done,
     /*  570448 */   // Label 9351: @570448
     /*  570448 */   GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(570523), // Rule ID 3687 //
     /*  570453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  570464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  570467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  570470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  570499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570521 */     GIR_RootConstrainSelectedInstOperands,
     /*  570522 */     // GIR_Coverage, 3687,
     /*  570522 */     GIR_EraseRootFromParent_Done,
     /*  570523 */   // Label 9352: @570523
     /*  570523 */   GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(570598), // Rule ID 3690 //
     /*  570528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  570539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  570542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  570545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570596 */     GIR_RootConstrainSelectedInstOperands,
     /*  570597 */     // GIR_Coverage, 3690,
     /*  570597 */     GIR_EraseRootFromParent_Done,
     /*  570598 */   // Label 9353: @570598
     /*  570598 */   GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(570673), // Rule ID 3691 //
     /*  570603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  570614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  570617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  570620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11643:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570671 */     GIR_RootConstrainSelectedInstOperands,
     /*  570672 */     // GIR_Coverage, 3691,
     /*  570672 */     GIR_EraseRootFromParent_Done,
     /*  570673 */   // Label 9354: @570673
     /*  570673 */   GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(570748), // Rule ID 3694 //
     /*  570678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  570695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570746 */     GIR_RootConstrainSelectedInstOperands,
     /*  570747 */     // GIR_Coverage, 3694,
     /*  570747 */     GIR_EraseRootFromParent_Done,
     /*  570748 */   // Label 9355: @570748
     /*  570748 */   GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(570823), // Rule ID 3695 //
     /*  570753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  570770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11643:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570821 */     GIR_RootConstrainSelectedInstOperands,
     /*  570822 */     // GIR_Coverage, 3695,
     /*  570822 */     GIR_EraseRootFromParent_Done,
     /*  570823 */   // Label 9356: @570823
     /*  570823 */   GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(570898), // Rule ID 3698 //
     /*  570828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  570845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570896 */     GIR_RootConstrainSelectedInstOperands,
     /*  570897 */     // GIR_Coverage, 3698,
     /*  570897 */     GIR_EraseRootFromParent_Done,
     /*  570898 */   // Label 9357: @570898
     /*  570898 */   GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(570973), // Rule ID 3699 //
     /*  570903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  570920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570949 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11643:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570971 */     GIR_RootConstrainSelectedInstOperands,
     /*  570972 */     // GIR_Coverage, 3699,
     /*  570972 */     GIR_EraseRootFromParent_Done,
     /*  570973 */   // Label 9358: @570973
     /*  570973 */   GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(571048), // Rule ID 3702 //
     /*  570978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  570989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  570992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  570995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  571024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  571027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571046 */     GIR_RootConstrainSelectedInstOperands,
     /*  571047 */     // GIR_Coverage, 3702,
     /*  571047 */     GIR_EraseRootFromParent_Done,
     /*  571048 */   // Label 9359: @571048
     /*  571048 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(571123), // Rule ID 3703 //
     /*  571053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  571056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  571061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  571064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  571067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  571070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  571073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  571092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571099 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11643:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  571099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  571102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  571118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571121 */     GIR_RootConstrainSelectedInstOperands,
     /*  571122 */     // GIR_Coverage, 3703,
     /*  571122 */     GIR_EraseRootFromParent_Done,
     /*  571123 */   // Label 9360: @571123
     /*  571123 */   GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(571198), // Rule ID 3706 //
     /*  571128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  571139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  571142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  571145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  571148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571174 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  571177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571196 */     GIR_RootConstrainSelectedInstOperands,
     /*  571197 */     // GIR_Coverage, 3706,
     /*  571197 */     GIR_EraseRootFromParent_Done,
     /*  571198 */   // Label 9361: @571198
     /*  571198 */   GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(571273), // Rule ID 3707 //
     /*  571203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  571214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  571217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  571220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  571223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571249 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  571252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571271 */     GIR_RootConstrainSelectedInstOperands,
     /*  571272 */     // GIR_Coverage, 3707,
     /*  571272 */     GIR_EraseRootFromParent_Done,
     /*  571273 */   // Label 9362: @571273
     /*  571273 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(571348), // Rule ID 3710 //
     /*  571278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  571289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  571292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  571295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  571298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571324 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571346 */     GIR_RootConstrainSelectedInstOperands,
     /*  571347 */     // GIR_Coverage, 3710,
     /*  571347 */     GIR_EraseRootFromParent_Done,
     /*  571348 */   // Label 9363: @571348
     /*  571348 */   GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(571423), // Rule ID 3711 //
     /*  571353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  571364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  571367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  571370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  571373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571399 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571421 */     GIR_RootConstrainSelectedInstOperands,
     /*  571422 */     // GIR_Coverage, 3711,
     /*  571422 */     GIR_EraseRootFromParent_Done,
     /*  571423 */   // Label 9364: @571423
     /*  571423 */   GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(571498), // Rule ID 3714 //
     /*  571428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  571439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  571442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  571445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  571448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  571477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571496 */     GIR_RootConstrainSelectedInstOperands,
     /*  571497 */     // GIR_Coverage, 3714,
     /*  571497 */     GIR_EraseRootFromParent_Done,
     /*  571498 */   // Label 9365: @571498
     /*  571498 */   GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(571573), // Rule ID 3715 //
     /*  571503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  571514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  571517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  571520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  571523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571549 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  571552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571571 */     GIR_RootConstrainSelectedInstOperands,
     /*  571572 */     // GIR_Coverage, 3715,
     /*  571572 */     GIR_EraseRootFromParent_Done,
     /*  571573 */   // Label 9366: @571573
     /*  571573 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(571648), // Rule ID 3718 //
     /*  571578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  571595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  571598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571624 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  571627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571646 */     GIR_RootConstrainSelectedInstOperands,
     /*  571647 */     // GIR_Coverage, 3718,
     /*  571647 */     GIR_EraseRootFromParent_Done,
     /*  571648 */   // Label 9367: @571648
     /*  571648 */   GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(571723), // Rule ID 3719 //
     /*  571653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  571670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  571673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571699 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  571702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571721 */     GIR_RootConstrainSelectedInstOperands,
     /*  571722 */     // GIR_Coverage, 3719,
     /*  571722 */     GIR_EraseRootFromParent_Done,
     /*  571723 */   // Label 9368: @571723
     /*  571723 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(571798), // Rule ID 3722 //
     /*  571728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571774 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  571777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571796 */     GIR_RootConstrainSelectedInstOperands,
     /*  571797 */     // GIR_Coverage, 3722,
     /*  571797 */     GIR_EraseRootFromParent_Done,
     /*  571798 */   // Label 9369: @571798
     /*  571798 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(571873), // Rule ID 3723 //
     /*  571803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571849 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  571852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571871 */     GIR_RootConstrainSelectedInstOperands,
     /*  571872 */     // GIR_Coverage, 3723,
     /*  571872 */     GIR_EraseRootFromParent_Done,
     /*  571873 */   // Label 9370: @571873
     /*  571873 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(571948), // Rule ID 3726 //
     /*  571878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571924 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  571927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571946 */     GIR_RootConstrainSelectedInstOperands,
     /*  571947 */     // GIR_Coverage, 3726,
     /*  571947 */     GIR_EraseRootFromParent_Done,
     /*  571948 */   // Label 9371: @571948
     /*  571948 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(572023), // Rule ID 3727 //
     /*  571953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571999 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572021 */     GIR_RootConstrainSelectedInstOperands,
     /*  572022 */     // GIR_Coverage, 3727,
     /*  572022 */     GIR_EraseRootFromParent_Done,
     /*  572023 */   // Label 9372: @572023
     /*  572023 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(572098), // Rule ID 3730 //
     /*  572028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  572039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  572042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  572045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  572048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  572077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572096 */     GIR_RootConstrainSelectedInstOperands,
     /*  572097 */     // GIR_Coverage, 3730,
     /*  572097 */     GIR_EraseRootFromParent_Done,
     /*  572098 */   // Label 9373: @572098
     /*  572098 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(572173), // Rule ID 3731 //
     /*  572103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  572114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  572117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  572120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  572123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572149 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  572152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572171 */     GIR_RootConstrainSelectedInstOperands,
     /*  572172 */     // GIR_Coverage, 3731,
     /*  572172 */     GIR_EraseRootFromParent_Done,
     /*  572173 */   // Label 9374: @572173
     /*  572173 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(572248), // Rule ID 3734 //
     /*  572178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  572189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  572192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  572195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  572198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572246 */     GIR_RootConstrainSelectedInstOperands,
     /*  572247 */     // GIR_Coverage, 3734,
     /*  572247 */     GIR_EraseRootFromParent_Done,
     /*  572248 */   // Label 9375: @572248
     /*  572248 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(572323), // Rule ID 3735 //
     /*  572253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  572264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  572267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  572270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  572273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572321 */     GIR_RootConstrainSelectedInstOperands,
     /*  572322 */     // GIR_Coverage, 3735,
     /*  572322 */     GIR_EraseRootFromParent_Done,
     /*  572323 */   // Label 9376: @572323
     /*  572323 */   GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(572398), // Rule ID 3738 //
     /*  572328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  572339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  572342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  572345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  572348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572396 */     GIR_RootConstrainSelectedInstOperands,
     /*  572397 */     // GIR_Coverage, 3738,
     /*  572397 */     GIR_EraseRootFromParent_Done,
     /*  572398 */   // Label 9377: @572398
     /*  572398 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(572473), // Rule ID 3739 //
     /*  572403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  572414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  572417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  572420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  572423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572471 */     GIR_RootConstrainSelectedInstOperands,
     /*  572472 */     // GIR_Coverage, 3739,
     /*  572472 */     GIR_EraseRootFromParent_Done,
     /*  572473 */   // Label 9378: @572473
     /*  572473 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(572548), // Rule ID 3742 //
     /*  572478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  572489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  572492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  572495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  572498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572546 */     GIR_RootConstrainSelectedInstOperands,
     /*  572547 */     // GIR_Coverage, 3742,
     /*  572547 */     GIR_EraseRootFromParent_Done,
     /*  572548 */   // Label 9379: @572548
     /*  572548 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(572623), // Rule ID 3743 //
     /*  572553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  572564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  572567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  572570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  572573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572599 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572621 */     GIR_RootConstrainSelectedInstOperands,
     /*  572622 */     // GIR_Coverage, 3743,
     /*  572622 */     GIR_EraseRootFromParent_Done,
     /*  572623 */   // Label 9380: @572623
     /*  572623 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(572698), // Rule ID 3746 //
     /*  572628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  572639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  572642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  572645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  572648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572696 */     GIR_RootConstrainSelectedInstOperands,
     /*  572697 */     // GIR_Coverage, 3746,
     /*  572697 */     GIR_EraseRootFromParent_Done,
     /*  572698 */   // Label 9381: @572698
     /*  572698 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(572773), // Rule ID 3747 //
     /*  572703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  572714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  572717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  572720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  572723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572749 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572771 */     GIR_RootConstrainSelectedInstOperands,
     /*  572772 */     // GIR_Coverage, 3747,
     /*  572772 */     GIR_EraseRootFromParent_Done,
     /*  572773 */   // Label 9382: @572773
     /*  572773 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(572848), // Rule ID 3750 //
     /*  572778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572846 */     GIR_RootConstrainSelectedInstOperands,
     /*  572847 */     // GIR_Coverage, 3750,
     /*  572847 */     GIR_EraseRootFromParent_Done,
     /*  572848 */   // Label 9383: @572848
     /*  572848 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(572923), // Rule ID 3751 //
     /*  572853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572899 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572921 */     GIR_RootConstrainSelectedInstOperands,
     /*  572922 */     // GIR_Coverage, 3751,
     /*  572922 */     GIR_EraseRootFromParent_Done,
     /*  572923 */   // Label 9384: @572923
     /*  572923 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(572998), // Rule ID 3754 //
     /*  572928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  572945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  572948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572996 */     GIR_RootConstrainSelectedInstOperands,
     /*  572997 */     // GIR_Coverage, 3754,
     /*  572997 */     GIR_EraseRootFromParent_Done,
     /*  572998 */   // Label 9385: @572998
     /*  572998 */   GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(573073), // Rule ID 3755 //
     /*  573003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  573014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  573017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  573020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  573023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  573052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573071 */     GIR_RootConstrainSelectedInstOperands,
     /*  573072 */     // GIR_Coverage, 3755,
     /*  573072 */     GIR_EraseRootFromParent_Done,
     /*  573073 */   // Label 9386: @573073
     /*  573073 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(573148), // Rule ID 3758 //
     /*  573078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  573089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  573092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  573095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  573098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573124 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573146 */     GIR_RootConstrainSelectedInstOperands,
     /*  573147 */     // GIR_Coverage, 3758,
     /*  573147 */     GIR_EraseRootFromParent_Done,
     /*  573148 */   // Label 9387: @573148
     /*  573148 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(573223), // Rule ID 3759 //
     /*  573153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  573164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  573167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  573170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  573173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573199 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  573202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573221 */     GIR_RootConstrainSelectedInstOperands,
     /*  573222 */     // GIR_Coverage, 3759,
     /*  573222 */     GIR_EraseRootFromParent_Done,
     /*  573223 */   // Label 9388: @573223
     /*  573223 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(573298), // Rule ID 3762 //
     /*  573228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  573231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  573239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  573242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  573245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  573248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  573274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573296 */     GIR_RootConstrainSelectedInstOperands,
     /*  573297 */     // GIR_Coverage, 3762,
     /*  573297 */     GIR_EraseRootFromParent_Done,
     /*  573298 */   // Label 9389: @573298
     /*  573298 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(573373), // Rule ID 3763 //
     /*  573303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  573306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  573314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  573317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  573320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  573323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573349 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  573349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  573352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  573368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573371 */     GIR_RootConstrainSelectedInstOperands,
     /*  573372 */     // GIR_Coverage, 3763,
     /*  573372 */     GIR_EraseRootFromParent_Done,
     /*  573373 */   // Label 9390: @573373
     /*  573373 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(573448), // Rule ID 3766 //
     /*  573378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  573389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  573392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  573395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  573427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573446 */     GIR_RootConstrainSelectedInstOperands,
     /*  573447 */     // GIR_Coverage, 3766,
     /*  573447 */     GIR_EraseRootFromParent_Done,
     /*  573448 */   // Label 9391: @573448
     /*  573448 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(573523), // Rule ID 3767 //
     /*  573453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  573464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  573467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  573470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573499 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  573502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573521 */     GIR_RootConstrainSelectedInstOperands,
     /*  573522 */     // GIR_Coverage, 3767,
     /*  573522 */     GIR_EraseRootFromParent_Done,
     /*  573523 */   // Label 9392: @573523
     /*  573523 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(573598), // Rule ID 3770 //
     /*  573528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  573539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  573542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  573545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573574 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  573577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573596 */     GIR_RootConstrainSelectedInstOperands,
     /*  573597 */     // GIR_Coverage, 3770,
     /*  573597 */     GIR_EraseRootFromParent_Done,
     /*  573598 */   // Label 9393: @573598
     /*  573598 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(573673), // Rule ID 3771 //
     /*  573603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  573614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  573617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  573620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573649 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  573652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573671 */     GIR_RootConstrainSelectedInstOperands,
     /*  573672 */     // GIR_Coverage, 3771,
     /*  573672 */     GIR_EraseRootFromParent_Done,
     /*  573673 */   // Label 9394: @573673
     /*  573673 */   GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(573748), // Rule ID 3774 //
     /*  573678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  573727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573746 */     GIR_RootConstrainSelectedInstOperands,
     /*  573747 */     // GIR_Coverage, 3774,
     /*  573747 */     GIR_EraseRootFromParent_Done,
     /*  573748 */   // Label 9395: @573748
     /*  573748 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(573823), // Rule ID 3775 //
     /*  573753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573799 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11671:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  573802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573821 */     GIR_RootConstrainSelectedInstOperands,
     /*  573822 */     // GIR_Coverage, 3775,
     /*  573822 */     GIR_EraseRootFromParent_Done,
     /*  573823 */   // Label 9396: @573823
     /*  573823 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(573898), // Rule ID 3778 //
     /*  573828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  573877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573896 */     GIR_RootConstrainSelectedInstOperands,
     /*  573897 */     // GIR_Coverage, 3778,
     /*  573897 */     GIR_EraseRootFromParent_Done,
     /*  573898 */   // Label 9397: @573898
     /*  573898 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(573973), // Rule ID 3779 //
     /*  573903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  573952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573971 */     GIR_RootConstrainSelectedInstOperands,
     /*  573972 */     // GIR_Coverage, 3779,
     /*  573972 */     GIR_EraseRootFromParent_Done,
     /*  573973 */   // Label 9398: @573973
     /*  573973 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(574048), // Rule ID 3782 //
     /*  573978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  573989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  573992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  573995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574024 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574046 */     GIR_RootConstrainSelectedInstOperands,
     /*  574047 */     // GIR_Coverage, 3782,
     /*  574047 */     GIR_EraseRootFromParent_Done,
     /*  574048 */   // Label 9399: @574048
     /*  574048 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(574123), // Rule ID 3783 //
     /*  574053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  574064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  574067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  574070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574099 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574121 */     GIR_RootConstrainSelectedInstOperands,
     /*  574122 */     // GIR_Coverage, 3783,
     /*  574122 */     GIR_EraseRootFromParent_Done,
     /*  574123 */   // Label 9400: @574123
     /*  574123 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(574198), // Rule ID 3786 //
     /*  574128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  574174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574196 */     GIR_RootConstrainSelectedInstOperands,
     /*  574197 */     // GIR_Coverage, 3786,
     /*  574197 */     GIR_EraseRootFromParent_Done,
     /*  574198 */   // Label 9401: @574198
     /*  574198 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(574273), // Rule ID 3787 //
     /*  574203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  574214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  574217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  574220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574249 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  574249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  574268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574271 */     GIR_RootConstrainSelectedInstOperands,
     /*  574272 */     // GIR_Coverage, 3787,
     /*  574272 */     GIR_EraseRootFromParent_Done,
     /*  574273 */   // Label 9402: @574273
     /*  574273 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(574348), // Rule ID 3790 //
     /*  574278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  574289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  574292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  574295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574346 */     GIR_RootConstrainSelectedInstOperands,
     /*  574347 */     // GIR_Coverage, 3790,
     /*  574347 */     GIR_EraseRootFromParent_Done,
     /*  574348 */   // Label 9403: @574348
     /*  574348 */   GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(574423), // Rule ID 3791 //
     /*  574353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  574364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  574367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  574370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574399 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  574402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574421 */     GIR_RootConstrainSelectedInstOperands,
     /*  574422 */     // GIR_Coverage, 3791,
     /*  574422 */     GIR_EraseRootFromParent_Done,
     /*  574423 */   // Label 9404: @574423
     /*  574423 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(574498), // Rule ID 3794 //
     /*  574428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  574439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  574442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  574445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574496 */     GIR_RootConstrainSelectedInstOperands,
     /*  574497 */     // GIR_Coverage, 3794,
     /*  574497 */     GIR_EraseRootFromParent_Done,
     /*  574498 */   // Label 9405: @574498
     /*  574498 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(574573), // Rule ID 3795 //
     /*  574503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  574514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  574517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  574520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574549 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11671:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574571 */     GIR_RootConstrainSelectedInstOperands,
     /*  574572 */     // GIR_Coverage, 3795,
     /*  574572 */     GIR_EraseRootFromParent_Done,
     /*  574573 */   // Label 9406: @574573
     /*  574573 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(574648), // Rule ID 3798 //
     /*  574578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  574592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  574595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574646 */     GIR_RootConstrainSelectedInstOperands,
     /*  574647 */     // GIR_Coverage, 3798,
     /*  574647 */     GIR_EraseRootFromParent_Done,
     /*  574648 */   // Label 9407: @574648
     /*  574648 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(574723), // Rule ID 3799 //
     /*  574653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  574667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  574670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574721 */     GIR_RootConstrainSelectedInstOperands,
     /*  574722 */     // GIR_Coverage, 3799,
     /*  574722 */     GIR_EraseRootFromParent_Done,
     /*  574723 */   // Label 9408: @574723
     /*  574723 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(574798), // Rule ID 3802 //
     /*  574728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574796 */     GIR_RootConstrainSelectedInstOperands,
     /*  574797 */     // GIR_Coverage, 3802,
     /*  574797 */     GIR_EraseRootFromParent_Done,
     /*  574798 */   // Label 9409: @574798
     /*  574798 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(574873), // Rule ID 3803 //
     /*  574803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574849 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574871 */     GIR_RootConstrainSelectedInstOperands,
     /*  574872 */     // GIR_Coverage, 3803,
     /*  574872 */     GIR_EraseRootFromParent_Done,
     /*  574873 */   // Label 9410: @574873
     /*  574873 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(574948), // Rule ID 3806 //
     /*  574878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574924 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574946 */     GIR_RootConstrainSelectedInstOperands,
     /*  574947 */     // GIR_Coverage, 3806,
     /*  574947 */     GIR_EraseRootFromParent_Done,
     /*  574948 */   // Label 9411: @574948
     /*  574948 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(575023), // Rule ID 3807 //
     /*  574953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574999 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  575018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575021 */     GIR_RootConstrainSelectedInstOperands,
     /*  575022 */     // GIR_Coverage, 3807,
     /*  575022 */     GIR_EraseRootFromParent_Done,
     /*  575023 */   // Label 9412: @575023
     /*  575023 */   GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(575098), // Rule ID 3810 //
     /*  575028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  575039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  575042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  575045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575096 */     GIR_RootConstrainSelectedInstOperands,
     /*  575097 */     // GIR_Coverage, 3810,
     /*  575097 */     GIR_EraseRootFromParent_Done,
     /*  575098 */   // Label 9413: @575098
     /*  575098 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(575173), // Rule ID 3811 //
     /*  575103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  575114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  575117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  575120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11671:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  575152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575171 */     GIR_RootConstrainSelectedInstOperands,
     /*  575172 */     // GIR_Coverage, 3811,
     /*  575172 */     GIR_EraseRootFromParent_Done,
     /*  575173 */   // Label 9414: @575173
     /*  575173 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(575248), // Rule ID 3814 //
     /*  575178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  575195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575224 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575246 */     GIR_RootConstrainSelectedInstOperands,
     /*  575247 */     // GIR_Coverage, 3814,
     /*  575247 */     GIR_EraseRootFromParent_Done,
     /*  575248 */   // Label 9415: @575248
     /*  575248 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(575323), // Rule ID 3815 //
     /*  575253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  575264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  575267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  575270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575299 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11671:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  575302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575321 */     GIR_RootConstrainSelectedInstOperands,
     /*  575322 */     // GIR_Coverage, 3815,
     /*  575322 */     GIR_EraseRootFromParent_Done,
     /*  575323 */   // Label 9416: @575323
     /*  575323 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(575398), // Rule ID 3818 //
     /*  575328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  575345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575374 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575396 */     GIR_RootConstrainSelectedInstOperands,
     /*  575397 */     // GIR_Coverage, 3818,
     /*  575397 */     GIR_EraseRootFromParent_Done,
     /*  575398 */   // Label 9417: @575398
     /*  575398 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(575473), // Rule ID 3819 //
     /*  575403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  575414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  575417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  575420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575449 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11671:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  575452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575471 */     GIR_RootConstrainSelectedInstOperands,
     /*  575472 */     // GIR_Coverage, 3819,
     /*  575472 */     GIR_EraseRootFromParent_Done,
     /*  575473 */   // Label 9418: @575473
     /*  575473 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(575548), // Rule ID 3822 //
     /*  575478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  575481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  575489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  575492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  575495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  575498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575524 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575546 */     GIR_RootConstrainSelectedInstOperands,
     /*  575547 */     // GIR_Coverage, 3822,
     /*  575547 */     GIR_EraseRootFromParent_Done,
     /*  575548 */   // Label 9419: @575548
     /*  575548 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(575623), // Rule ID 3823 //
     /*  575553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  575564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  575567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  575570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575599 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11671:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575621 */     GIR_RootConstrainSelectedInstOperands,
     /*  575622 */     // GIR_Coverage, 3823,
     /*  575622 */     GIR_EraseRootFromParent_Done,
     /*  575623 */   // Label 9420: @575623
     /*  575623 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(575698), // Rule ID 3826 //
     /*  575628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  575639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  575642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  575677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575696 */     GIR_RootConstrainSelectedInstOperands,
     /*  575697 */     // GIR_Coverage, 3826,
     /*  575697 */     GIR_EraseRootFromParent_Done,
     /*  575698 */   // Label 9421: @575698
     /*  575698 */   GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(575773), // Rule ID 3827 //
     /*  575703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  575714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  575717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575749 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  575752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575771 */     GIR_RootConstrainSelectedInstOperands,
     /*  575772 */     // GIR_Coverage, 3827,
     /*  575772 */     GIR_EraseRootFromParent_Done,
     /*  575773 */   // Label 9422: @575773
     /*  575773 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(575848), // Rule ID 3830 //
     /*  575778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  575827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575846 */     GIR_RootConstrainSelectedInstOperands,
     /*  575847 */     // GIR_Coverage, 3830,
     /*  575847 */     GIR_EraseRootFromParent_Done,
     /*  575848 */   // Label 9423: @575848
     /*  575848 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(575923), // Rule ID 3831 //
     /*  575853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575899 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  575902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575921 */     GIR_RootConstrainSelectedInstOperands,
     /*  575922 */     // GIR_Coverage, 3831,
     /*  575922 */     GIR_EraseRootFromParent_Done,
     /*  575923 */   // Label 9424: @575923
     /*  575923 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(575998), // Rule ID 3834 //
     /*  575928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  575939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  575942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  575945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  575948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575974 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  575977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575996 */     GIR_RootConstrainSelectedInstOperands,
     /*  575997 */     // GIR_Coverage, 3834,
     /*  575997 */     GIR_EraseRootFromParent_Done,
     /*  575998 */   // Label 9425: @575998
     /*  575998 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(576073), // Rule ID 3835 //
     /*  576003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  576014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  576017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  576020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  576023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576049 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576071 */     GIR_RootConstrainSelectedInstOperands,
     /*  576072 */     // GIR_Coverage, 3835,
     /*  576072 */     GIR_EraseRootFromParent_Done,
     /*  576073 */   // Label 9426: @576073
     /*  576073 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(576148), // Rule ID 3838 //
     /*  576078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  576089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  576092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576146 */     GIR_RootConstrainSelectedInstOperands,
     /*  576147 */     // GIR_Coverage, 3838,
     /*  576147 */     GIR_EraseRootFromParent_Done,
     /*  576148 */   // Label 9427: @576148
     /*  576148 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(576223), // Rule ID 3839 //
     /*  576153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  576164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  576167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  576170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  576173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576199 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576221 */     GIR_RootConstrainSelectedInstOperands,
     /*  576222 */     // GIR_Coverage, 3839,
     /*  576222 */     GIR_EraseRootFromParent_Done,
     /*  576223 */   // Label 9428: @576223
     /*  576223 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(576298), // Rule ID 3842 //
     /*  576228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  576239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  576242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  576245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  576248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576274 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576296 */     GIR_RootConstrainSelectedInstOperands,
     /*  576297 */     // GIR_Coverage, 3842,
     /*  576297 */     GIR_EraseRootFromParent_Done,
     /*  576298 */   // Label 9429: @576298
     /*  576298 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(576373), // Rule ID 3843 //
     /*  576303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  576314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  576317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  576320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  576323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576349 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576371 */     GIR_RootConstrainSelectedInstOperands,
     /*  576372 */     // GIR_Coverage, 3843,
     /*  576372 */     GIR_EraseRootFromParent_Done,
     /*  576373 */   // Label 9430: @576373
     /*  576373 */   GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(576448), // Rule ID 3846 //
     /*  576378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  576389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  576392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  576395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  576398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  576424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576446 */     GIR_RootConstrainSelectedInstOperands,
     /*  576447 */     // GIR_Coverage, 3846,
     /*  576447 */     GIR_EraseRootFromParent_Done,
     /*  576448 */   // Label 9431: @576448
     /*  576448 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(576523), // Rule ID 3847 //
     /*  576453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  576464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  576467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  576470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  576473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576499 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  576499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576521 */     GIR_RootConstrainSelectedInstOperands,
     /*  576522 */     // GIR_Coverage, 3847,
     /*  576522 */     GIR_EraseRootFromParent_Done,
     /*  576523 */   // Label 9432: @576523
     /*  576523 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(576598), // Rule ID 3850 //
     /*  576528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  576539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  576542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  576545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  576548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576574 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576596 */     GIR_RootConstrainSelectedInstOperands,
     /*  576597 */     // GIR_Coverage, 3850,
     /*  576597 */     GIR_EraseRootFromParent_Done,
     /*  576598 */   // Label 9433: @576598
     /*  576598 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(576673), // Rule ID 3851 //
     /*  576603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  576614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  576617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  576620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  576623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576649 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576671 */     GIR_RootConstrainSelectedInstOperands,
     /*  576672 */     // GIR_Coverage, 3851,
     /*  576672 */     GIR_EraseRootFromParent_Done,
     /*  576673 */   // Label 9434: @576673
     /*  576673 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(576748), // Rule ID 3854 //
     /*  576678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576746 */     GIR_RootConstrainSelectedInstOperands,
     /*  576747 */     // GIR_Coverage, 3854,
     /*  576747 */     GIR_EraseRootFromParent_Done,
     /*  576748 */   // Label 9435: @576748
     /*  576748 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(576823), // Rule ID 3855 //
     /*  576753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576799 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576821 */     GIR_RootConstrainSelectedInstOperands,
     /*  576822 */     // GIR_Coverage, 3855,
     /*  576822 */     GIR_EraseRootFromParent_Done,
     /*  576823 */   // Label 9436: @576823
     /*  576823 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(576898), // Rule ID 3858 //
     /*  576828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576896 */     GIR_RootConstrainSelectedInstOperands,
     /*  576897 */     // GIR_Coverage, 3858,
     /*  576897 */     GIR_EraseRootFromParent_Done,
     /*  576898 */   // Label 9437: @576898
     /*  576898 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(576973), // Rule ID 3859 //
     /*  576903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576949 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576971 */     GIR_RootConstrainSelectedInstOperands,
     /*  576972 */     // GIR_Coverage, 3859,
     /*  576972 */     GIR_EraseRootFromParent_Done,
     /*  576973 */   // Label 9438: @576973
     /*  576973 */   GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(577048), // Rule ID 3862 //
     /*  576978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  576989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  576992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  576995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  576998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577024 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577046 */     GIR_RootConstrainSelectedInstOperands,
     /*  577047 */     // GIR_Coverage, 3862,
     /*  577047 */     GIR_EraseRootFromParent_Done,
     /*  577048 */   // Label 9439: @577048
     /*  577048 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(577123), // Rule ID 3863 //
     /*  577053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  577064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  577067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  577070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  577073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577099 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577121 */     GIR_RootConstrainSelectedInstOperands,
     /*  577122 */     // GIR_Coverage, 3863,
     /*  577122 */     GIR_EraseRootFromParent_Done,
     /*  577123 */   // Label 9440: @577123
     /*  577123 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(577198), // Rule ID 3866 //
     /*  577128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  577139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  577142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  577145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  577148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  577174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577196 */     GIR_RootConstrainSelectedInstOperands,
     /*  577197 */     // GIR_Coverage, 3866,
     /*  577197 */     GIR_EraseRootFromParent_Done,
     /*  577198 */   // Label 9441: @577198
     /*  577198 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(577273), // Rule ID 3867 //
     /*  577203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  577214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  577217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  577220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  577223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  577249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  577268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577271 */     GIR_RootConstrainSelectedInstOperands,
     /*  577272 */     // GIR_Coverage, 3867,
     /*  577272 */     GIR_EraseRootFromParent_Done,
     /*  577273 */   // Label 9442: @577273
     /*  577273 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(577348), // Rule ID 3870 //
     /*  577278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  577295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  577298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577346 */     GIR_RootConstrainSelectedInstOperands,
     /*  577347 */     // GIR_Coverage, 3870,
     /*  577347 */     GIR_EraseRootFromParent_Done,
     /*  577348 */   // Label 9443: @577348
     /*  577348 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(577423), // Rule ID 3871 //
     /*  577353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  577364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  577367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  577370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  577373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577399 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  577402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577421 */     GIR_RootConstrainSelectedInstOperands,
     /*  577422 */     // GIR_Coverage, 3871,
     /*  577422 */     GIR_EraseRootFromParent_Done,
     /*  577423 */   // Label 9444: @577423
     /*  577423 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(577498), // Rule ID 3874 //
     /*  577428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  577439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  577442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577496 */     GIR_RootConstrainSelectedInstOperands,
     /*  577497 */     // GIR_Coverage, 3874,
     /*  577497 */     GIR_EraseRootFromParent_Done,
     /*  577498 */   // Label 9445: @577498
     /*  577498 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(577573), // Rule ID 3875 //
     /*  577503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  577514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  577517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577549 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577571 */     GIR_RootConstrainSelectedInstOperands,
     /*  577572 */     // GIR_Coverage, 3875,
     /*  577572 */     GIR_EraseRootFromParent_Done,
     /*  577573 */   // Label 9446: @577573
     /*  577573 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(577648), // Rule ID 3878 //
     /*  577578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  577589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  577592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  577595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  577598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577624 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577646 */     GIR_RootConstrainSelectedInstOperands,
     /*  577647 */     // GIR_Coverage, 3878,
     /*  577647 */     GIR_EraseRootFromParent_Done,
     /*  577648 */   // Label 9447: @577648
     /*  577648 */   GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(577723), // Rule ID 3879 //
     /*  577653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  577664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  577667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  577670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  577673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577699 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577721 */     GIR_RootConstrainSelectedInstOperands,
     /*  577722 */     // GIR_Coverage, 3879,
     /*  577722 */     GIR_EraseRootFromParent_Done,
     /*  577723 */   // Label 9448: @577723
     /*  577723 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(577798), // Rule ID 3882 //
     /*  577728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577774 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577796 */     GIR_RootConstrainSelectedInstOperands,
     /*  577797 */     // GIR_Coverage, 3882,
     /*  577797 */     GIR_EraseRootFromParent_Done,
     /*  577798 */   // Label 9449: @577798
     /*  577798 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(577873), // Rule ID 3883 //
     /*  577803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577849 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577871 */     GIR_RootConstrainSelectedInstOperands,
     /*  577872 */     // GIR_Coverage, 3883,
     /*  577872 */     GIR_EraseRootFromParent_Done,
     /*  577873 */   // Label 9450: @577873
     /*  577873 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(577948), // Rule ID 3886 //
     /*  577878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577924 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  577927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577946 */     GIR_RootConstrainSelectedInstOperands,
     /*  577947 */     // GIR_Coverage, 3886,
     /*  577947 */     GIR_EraseRootFromParent_Done,
     /*  577948 */   // Label 9451: @577948
     /*  577948 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(578023), // Rule ID 3887 //
     /*  577953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577999 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  578002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578021 */     GIR_RootConstrainSelectedInstOperands,
     /*  578022 */     // GIR_Coverage, 3887,
     /*  578022 */     GIR_EraseRootFromParent_Done,
     /*  578023 */   // Label 9452: @578023
     /*  578023 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(578098), // Rule ID 3890 //
     /*  578028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  578039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  578042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  578045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578074 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578096 */     GIR_RootConstrainSelectedInstOperands,
     /*  578097 */     // GIR_Coverage, 3890,
     /*  578097 */     GIR_EraseRootFromParent_Done,
     /*  578098 */   // Label 9453: @578098
     /*  578098 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(578173), // Rule ID 3891 //
     /*  578103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  578114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  578117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  578120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578149 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578171 */     GIR_RootConstrainSelectedInstOperands,
     /*  578172 */     // GIR_Coverage, 3891,
     /*  578172 */     GIR_EraseRootFromParent_Done,
     /*  578173 */   // Label 9454: @578173
     /*  578173 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(578248), // Rule ID 3894 //
     /*  578178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  578189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  578192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  578195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578246 */     GIR_RootConstrainSelectedInstOperands,
     /*  578247 */     // GIR_Coverage, 3894,
     /*  578247 */     GIR_EraseRootFromParent_Done,
     /*  578248 */   // Label 9455: @578248
     /*  578248 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(578323), // Rule ID 3895 //
     /*  578253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  578264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  578267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  578270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11639:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578321 */     GIR_RootConstrainSelectedInstOperands,
     /*  578322 */     // GIR_Coverage, 3895,
     /*  578322 */     GIR_EraseRootFromParent_Done,
     /*  578323 */   // Label 9456: @578323
     /*  578323 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(578398), // Rule ID 3898 //
     /*  578328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  578339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  578342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  578345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578396 */     GIR_RootConstrainSelectedInstOperands,
     /*  578397 */     // GIR_Coverage, 3898,
     /*  578397 */     GIR_EraseRootFromParent_Done,
     /*  578398 */   // Label 9457: @578398
     /*  578398 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(578473), // Rule ID 3899 //
     /*  578403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  578414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  578417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  578420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578471 */     GIR_RootConstrainSelectedInstOperands,
     /*  578472 */     // GIR_Coverage, 3899,
     /*  578472 */     GIR_EraseRootFromParent_Done,
     /*  578473 */   // Label 9458: @578473
     /*  578473 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(578548), // Rule ID 3902 //
     /*  578478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  578489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  578492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  578495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578524 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  578527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578546 */     GIR_RootConstrainSelectedInstOperands,
     /*  578547 */     // GIR_Coverage, 3902,
     /*  578547 */     GIR_EraseRootFromParent_Done,
     /*  578548 */   // Label 9459: @578548
     /*  578548 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(578623), // Rule ID 3903 //
     /*  578553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  578564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  578567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  578570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578599 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  578602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578621 */     GIR_RootConstrainSelectedInstOperands,
     /*  578622 */     // GIR_Coverage, 3903,
     /*  578622 */     GIR_EraseRootFromParent_Done,
     /*  578623 */   // Label 9460: @578623
     /*  578623 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(578698), // Rule ID 3906 //
     /*  578628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  578645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578674 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  578677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578696 */     GIR_RootConstrainSelectedInstOperands,
     /*  578697 */     // GIR_Coverage, 3906,
     /*  578697 */     GIR_EraseRootFromParent_Done,
     /*  578698 */   // Label 9461: @578698
     /*  578698 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(578773), // Rule ID 3907 //
     /*  578703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  578720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578749 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  578752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578771 */     GIR_RootConstrainSelectedInstOperands,
     /*  578772 */     // GIR_Coverage, 3907,
     /*  578772 */     GIR_EraseRootFromParent_Done,
     /*  578773 */   // Label 9462: @578773
     /*  578773 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(578848), // Rule ID 3910 //
     /*  578778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578824 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578846 */     GIR_RootConstrainSelectedInstOperands,
     /*  578847 */     // GIR_Coverage, 3910,
     /*  578847 */     GIR_EraseRootFromParent_Done,
     /*  578848 */   // Label 9463: @578848
     /*  578848 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(578923), // Rule ID 3911 //
     /*  578853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578899 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578921 */     GIR_RootConstrainSelectedInstOperands,
     /*  578922 */     // GIR_Coverage, 3911,
     /*  578922 */     GIR_EraseRootFromParent_Done,
     /*  578923 */   // Label 9464: @578923
     /*  578923 */   GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(578998), // Rule ID 3914 //
     /*  578928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  578939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  578942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  578945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578996 */     GIR_RootConstrainSelectedInstOperands,
     /*  578997 */     // GIR_Coverage, 3914,
     /*  578997 */     GIR_EraseRootFromParent_Done,
     /*  578998 */   // Label 9465: @578998
     /*  578998 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(579073), // Rule ID 3915 //
     /*  579003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  579014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  579017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  579020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579049 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11639:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579071 */     GIR_RootConstrainSelectedInstOperands,
     /*  579072 */     // GIR_Coverage, 3915,
     /*  579072 */     GIR_EraseRootFromParent_Done,
     /*  579073 */   // Label 9466: @579073
     /*  579073 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(579148), // Rule ID 3918 //
     /*  579078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  579089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  579092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  579095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579146 */     GIR_RootConstrainSelectedInstOperands,
     /*  579147 */     // GIR_Coverage, 3918,
     /*  579147 */     GIR_EraseRootFromParent_Done,
     /*  579148 */   // Label 9467: @579148
     /*  579148 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(579223), // Rule ID 3919 //
     /*  579153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  579164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  579167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  579170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579221 */     GIR_RootConstrainSelectedInstOperands,
     /*  579222 */     // GIR_Coverage, 3919,
     /*  579222 */     GIR_EraseRootFromParent_Done,
     /*  579223 */   // Label 9468: @579223
     /*  579223 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(579298), // Rule ID 3922 //
     /*  579228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  579239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  579242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  579245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579296 */     GIR_RootConstrainSelectedInstOperands,
     /*  579297 */     // GIR_Coverage, 3922,
     /*  579297 */     GIR_EraseRootFromParent_Done,
     /*  579298 */   // Label 9469: @579298
     /*  579298 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(579373), // Rule ID 3923 //
     /*  579303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  579314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  579317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  579320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579349 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579371 */     GIR_RootConstrainSelectedInstOperands,
     /*  579372 */     // GIR_Coverage, 3923,
     /*  579372 */     GIR_EraseRootFromParent_Done,
     /*  579373 */   // Label 9470: @579373
     /*  579373 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(579448), // Rule ID 3926 //
     /*  579378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  579389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  579392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  579395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  579424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579446 */     GIR_RootConstrainSelectedInstOperands,
     /*  579447 */     // GIR_Coverage, 3926,
     /*  579447 */     GIR_EraseRootFromParent_Done,
     /*  579448 */   // Label 9471: @579448
     /*  579448 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(579523), // Rule ID 3927 //
     /*  579453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  579464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  579467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  579470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  579499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579521 */     GIR_RootConstrainSelectedInstOperands,
     /*  579522 */     // GIR_Coverage, 3927,
     /*  579522 */     GIR_EraseRootFromParent_Done,
     /*  579523 */   // Label 9472: @579523
     /*  579523 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(579598), // Rule ID 3930 //
     /*  579528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  579539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  579542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  579545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579596 */     GIR_RootConstrainSelectedInstOperands,
     /*  579597 */     // GIR_Coverage, 3930,
     /*  579597 */     GIR_EraseRootFromParent_Done,
     /*  579598 */   // Label 9473: @579598
     /*  579598 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(579673), // Rule ID 3931 //
     /*  579603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  579614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  579617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  579620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579649 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11639:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579671 */     GIR_RootConstrainSelectedInstOperands,
     /*  579672 */     // GIR_Coverage, 3931,
     /*  579672 */     GIR_EraseRootFromParent_Done,
     /*  579673 */   // Label 9474: @579673
     /*  579673 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(579748), // Rule ID 3934 //
     /*  579678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579746 */     GIR_RootConstrainSelectedInstOperands,
     /*  579747 */     // GIR_Coverage, 3934,
     /*  579747 */     GIR_EraseRootFromParent_Done,
     /*  579748 */   // Label 9475: @579748
     /*  579748 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(579823), // Rule ID 3935 //
     /*  579753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11639:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579821 */     GIR_RootConstrainSelectedInstOperands,
     /*  579822 */     // GIR_Coverage, 3935,
     /*  579822 */     GIR_EraseRootFromParent_Done,
     /*  579823 */   // Label 9476: @579823
     /*  579823 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(579898), // Rule ID 3938 //
     /*  579828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579874 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579896 */     GIR_RootConstrainSelectedInstOperands,
     /*  579897 */     // GIR_Coverage, 3938,
     /*  579897 */     GIR_EraseRootFromParent_Done,
     /*  579898 */   // Label 9477: @579898
     /*  579898 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(579973), // Rule ID 3939 //
     /*  579903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579949 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11639:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579971 */     GIR_RootConstrainSelectedInstOperands,
     /*  579972 */     // GIR_Coverage, 3939,
     /*  579972 */     GIR_EraseRootFromParent_Done,
     /*  579973 */   // Label 9478: @579973
     /*  579973 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(580048), // Rule ID 3942 //
     /*  579978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  579989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  579992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  579995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580024 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  580024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  580027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580046 */     GIR_RootConstrainSelectedInstOperands,
     /*  580047 */     // GIR_Coverage, 3942,
     /*  580047 */     GIR_EraseRootFromParent_Done,
     /*  580048 */   // Label 9479: @580048
     /*  580048 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(580123), // Rule ID 3943 //
     /*  580053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  580056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  580061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  580064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  580067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  580070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  580073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  580092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580099 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11639:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  580099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  580102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  580118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580121 */     GIR_RootConstrainSelectedInstOperands,
     /*  580122 */     // GIR_Coverage, 3943,
     /*  580122 */     GIR_EraseRootFromParent_Done,
     /*  580123 */   // Label 9480: @580123
     /*  580123 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(580198), // Rule ID 3946 //
     /*  580128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  580139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  580142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  580145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  580148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580174 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  580177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580196 */     GIR_RootConstrainSelectedInstOperands,
     /*  580197 */     // GIR_Coverage, 3946,
     /*  580197 */     GIR_EraseRootFromParent_Done,
     /*  580198 */   // Label 9481: @580198
     /*  580198 */   GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(580273), // Rule ID 3947 //
     /*  580203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  580214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  580217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  580220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  580223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580249 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  580252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580271 */     GIR_RootConstrainSelectedInstOperands,
     /*  580272 */     // GIR_Coverage, 3947,
     /*  580272 */     GIR_EraseRootFromParent_Done,
     /*  580273 */   // Label 9482: @580273
     /*  580273 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(580348), // Rule ID 3950 //
     /*  580278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  580289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  580292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  580295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  580298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580324 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580346 */     GIR_RootConstrainSelectedInstOperands,
     /*  580347 */     // GIR_Coverage, 3950,
     /*  580347 */     GIR_EraseRootFromParent_Done,
     /*  580348 */   // Label 9483: @580348
     /*  580348 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(580423), // Rule ID 3951 //
     /*  580353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  580364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  580367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  580370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  580373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580399 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580421 */     GIR_RootConstrainSelectedInstOperands,
     /*  580422 */     // GIR_Coverage, 3951,
     /*  580422 */     GIR_EraseRootFromParent_Done,
     /*  580423 */   // Label 9484: @580423
     /*  580423 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(580498), // Rule ID 3954 //
     /*  580428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  580445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  580448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  580477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580496 */     GIR_RootConstrainSelectedInstOperands,
     /*  580497 */     // GIR_Coverage, 3954,
     /*  580497 */     GIR_EraseRootFromParent_Done,
     /*  580498 */   // Label 9485: @580498
     /*  580498 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(580573), // Rule ID 3955 //
     /*  580503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  580520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  580523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580549 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  580552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580571 */     GIR_RootConstrainSelectedInstOperands,
     /*  580572 */     // GIR_Coverage, 3955,
     /*  580572 */     GIR_EraseRootFromParent_Done,
     /*  580573 */   // Label 9486: @580573
     /*  580573 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(580648), // Rule ID 3958 //
     /*  580578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  580589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  580592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  580598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580624 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  580627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580646 */     GIR_RootConstrainSelectedInstOperands,
     /*  580647 */     // GIR_Coverage, 3958,
     /*  580647 */     GIR_EraseRootFromParent_Done,
     /*  580648 */   // Label 9487: @580648
     /*  580648 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(580723), // Rule ID 3959 //
     /*  580653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  580664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  580667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  580673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580699 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  580702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580721 */     GIR_RootConstrainSelectedInstOperands,
     /*  580722 */     // GIR_Coverage, 3959,
     /*  580722 */     GIR_EraseRootFromParent_Done,
     /*  580723 */   // Label 9488: @580723
     /*  580723 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(580798), // Rule ID 3962 //
     /*  580728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580774 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  580777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580796 */     GIR_RootConstrainSelectedInstOperands,
     /*  580797 */     // GIR_Coverage, 3962,
     /*  580797 */     GIR_EraseRootFromParent_Done,
     /*  580798 */   // Label 9489: @580798
     /*  580798 */   GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(580873), // Rule ID 3963 //
     /*  580803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580849 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  580852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580871 */     GIR_RootConstrainSelectedInstOperands,
     /*  580872 */     // GIR_Coverage, 3963,
     /*  580872 */     GIR_EraseRootFromParent_Done,
     /*  580873 */   // Label 9490: @580873
     /*  580873 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(580948), // Rule ID 3966 //
     /*  580878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580924 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  580927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580946 */     GIR_RootConstrainSelectedInstOperands,
     /*  580947 */     // GIR_Coverage, 3966,
     /*  580947 */     GIR_EraseRootFromParent_Done,
     /*  580948 */   // Label 9491: @580948
     /*  580948 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(581023), // Rule ID 3967 //
     /*  580953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580999 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581021 */     GIR_RootConstrainSelectedInstOperands,
     /*  581022 */     // GIR_Coverage, 3967,
     /*  581022 */     GIR_EraseRootFromParent_Done,
     /*  581023 */   // Label 9492: @581023
     /*  581023 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(581098), // Rule ID 3970 //
     /*  581028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  581039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  581042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  581045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  581048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  581077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581096 */     GIR_RootConstrainSelectedInstOperands,
     /*  581097 */     // GIR_Coverage, 3970,
     /*  581097 */     GIR_EraseRootFromParent_Done,
     /*  581098 */   // Label 9493: @581098
     /*  581098 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(581173), // Rule ID 3971 //
     /*  581103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  581114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  581117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  581120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  581123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581149 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  581152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581171 */     GIR_RootConstrainSelectedInstOperands,
     /*  581172 */     // GIR_Coverage, 3971,
     /*  581172 */     GIR_EraseRootFromParent_Done,
     /*  581173 */   // Label 9494: @581173
     /*  581173 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(581248), // Rule ID 3974 //
     /*  581178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  581189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  581192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  581195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  581198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581246 */     GIR_RootConstrainSelectedInstOperands,
     /*  581247 */     // GIR_Coverage, 3974,
     /*  581247 */     GIR_EraseRootFromParent_Done,
     /*  581248 */   // Label 9495: @581248
     /*  581248 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(581323), // Rule ID 3975 //
     /*  581253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  581264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  581267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  581270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  581273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581299 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581321 */     GIR_RootConstrainSelectedInstOperands,
     /*  581322 */     // GIR_Coverage, 3975,
     /*  581322 */     GIR_EraseRootFromParent_Done,
     /*  581323 */   // Label 9496: @581323
     /*  581323 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(581398), // Rule ID 3978 //
     /*  581328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  581345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  581348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581396 */     GIR_RootConstrainSelectedInstOperands,
     /*  581397 */     // GIR_Coverage, 3978,
     /*  581397 */     GIR_EraseRootFromParent_Done,
     /*  581398 */   // Label 9497: @581398
     /*  581398 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(581473), // Rule ID 3979 //
     /*  581403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  581414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  581417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  581420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  581423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581471 */     GIR_RootConstrainSelectedInstOperands,
     /*  581472 */     // GIR_Coverage, 3979,
     /*  581472 */     GIR_EraseRootFromParent_Done,
     /*  581473 */   // Label 9498: @581473
     /*  581473 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(581548), // Rule ID 3982 //
     /*  581478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  581489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  581492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  581495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  581498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581546 */     GIR_RootConstrainSelectedInstOperands,
     /*  581547 */     // GIR_Coverage, 3982,
     /*  581547 */     GIR_EraseRootFromParent_Done,
     /*  581548 */   // Label 9499: @581548
     /*  581548 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(581623), // Rule ID 3983 //
     /*  581553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  581564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  581567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  581570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  581573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581599 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581621 */     GIR_RootConstrainSelectedInstOperands,
     /*  581622 */     // GIR_Coverage, 3983,
     /*  581622 */     GIR_EraseRootFromParent_Done,
     /*  581623 */   // Label 9500: @581623
     /*  581623 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(581698), // Rule ID 3986 //
     /*  581628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  581648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581696 */     GIR_RootConstrainSelectedInstOperands,
     /*  581697 */     // GIR_Coverage, 3986,
     /*  581697 */     GIR_EraseRootFromParent_Done,
     /*  581698 */   // Label 9501: @581698
     /*  581698 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(581773), // Rule ID 3987 //
     /*  581703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  581723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581749 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581771 */     GIR_RootConstrainSelectedInstOperands,
     /*  581772 */     // GIR_Coverage, 3987,
     /*  581772 */     GIR_EraseRootFromParent_Done,
     /*  581773 */   // Label 9502: @581773
     /*  581773 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(581848), // Rule ID 3990 //
     /*  581778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581846 */     GIR_RootConstrainSelectedInstOperands,
     /*  581847 */     // GIR_Coverage, 3990,
     /*  581847 */     GIR_EraseRootFromParent_Done,
     /*  581848 */   // Label 9503: @581848
     /*  581848 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(581923), // Rule ID 3991 //
     /*  581853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581899 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581921 */     GIR_RootConstrainSelectedInstOperands,
     /*  581922 */     // GIR_Coverage, 3991,
     /*  581922 */     GIR_EraseRootFromParent_Done,
     /*  581923 */   // Label 9504: @581923
     /*  581923 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(581998), // Rule ID 3994 //
     /*  581928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  581939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  581942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  581945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  581948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581996 */     GIR_RootConstrainSelectedInstOperands,
     /*  581997 */     // GIR_Coverage, 3994,
     /*  581997 */     GIR_EraseRootFromParent_Done,
     /*  581998 */   // Label 9505: @581998
     /*  581998 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(582073), // Rule ID 3995 //
     /*  582003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  582014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  582017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  582020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  582023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  582052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582071 */     GIR_RootConstrainSelectedInstOperands,
     /*  582072 */     // GIR_Coverage, 3995,
     /*  582072 */     GIR_EraseRootFromParent_Done,
     /*  582073 */   // Label 9506: @582073
     /*  582073 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(582148), // Rule ID 3998 //
     /*  582078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  582095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  582098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582124 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582146 */     GIR_RootConstrainSelectedInstOperands,
     /*  582147 */     // GIR_Coverage, 3998,
     /*  582147 */     GIR_EraseRootFromParent_Done,
     /*  582148 */   // Label 9507: @582148
     /*  582148 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(582223), // Rule ID 3999 //
     /*  582153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  582164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  582167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  582170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  582173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582199 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  582202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582221 */     GIR_RootConstrainSelectedInstOperands,
     /*  582222 */     // GIR_Coverage, 3999,
     /*  582222 */     GIR_EraseRootFromParent_Done,
     /*  582223 */   // Label 9508: @582223
     /*  582223 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(582298), // Rule ID 4002 //
     /*  582228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  582231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  582245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  582248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  582274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582296 */     GIR_RootConstrainSelectedInstOperands,
     /*  582297 */     // GIR_Coverage, 4002,
     /*  582297 */     GIR_EraseRootFromParent_Done,
     /*  582298 */   // Label 9509: @582298
     /*  582298 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(582373), // Rule ID 4003 //
     /*  582303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  582306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  582314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  582317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  582320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  582323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582349 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  582349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  582352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  582368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582371 */     GIR_RootConstrainSelectedInstOperands,
     /*  582372 */     // GIR_Coverage, 4003,
     /*  582372 */     GIR_EraseRootFromParent_Done,
     /*  582373 */   // Label 9510: @582373
     /*  582373 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(582448), // Rule ID 4006 //
     /*  582378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  582427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582446 */     GIR_RootConstrainSelectedInstOperands,
     /*  582447 */     // GIR_Coverage, 4006,
     /*  582447 */     GIR_EraseRootFromParent_Done,
     /*  582448 */   // Label 9511: @582448
     /*  582448 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(582523), // Rule ID 4007 //
     /*  582453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  582464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  582467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  582470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582499 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  582502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582521 */     GIR_RootConstrainSelectedInstOperands,
     /*  582522 */     // GIR_Coverage, 4007,
     /*  582522 */     GIR_EraseRootFromParent_Done,
     /*  582523 */   // Label 9512: @582523
     /*  582523 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(582598), // Rule ID 4010 //
     /*  582528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  582539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  582542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  582545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582574 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  582577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582596 */     GIR_RootConstrainSelectedInstOperands,
     /*  582597 */     // GIR_Coverage, 4010,
     /*  582597 */     GIR_EraseRootFromParent_Done,
     /*  582598 */   // Label 9513: @582598
     /*  582598 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(582673), // Rule ID 4011 //
     /*  582603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  582614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  582617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  582620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582649 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  582652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582671 */     GIR_RootConstrainSelectedInstOperands,
     /*  582672 */     // GIR_Coverage, 4011,
     /*  582672 */     GIR_EraseRootFromParent_Done,
     /*  582673 */   // Label 9514: @582673
     /*  582673 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(582748), // Rule ID 4014 //
     /*  582678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  582727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582746 */     GIR_RootConstrainSelectedInstOperands,
     /*  582747 */     // GIR_Coverage, 4014,
     /*  582747 */     GIR_EraseRootFromParent_Done,
     /*  582748 */   // Label 9515: @582748
     /*  582748 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(582823), // Rule ID 4015 //
     /*  582753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582799 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11667:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  582802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582821 */     GIR_RootConstrainSelectedInstOperands,
     /*  582822 */     // GIR_Coverage, 4015,
     /*  582822 */     GIR_EraseRootFromParent_Done,
     /*  582823 */   // Label 9516: @582823
     /*  582823 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(582898), // Rule ID 4018 //
     /*  582828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  582877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582896 */     GIR_RootConstrainSelectedInstOperands,
     /*  582897 */     // GIR_Coverage, 4018,
     /*  582897 */     GIR_EraseRootFromParent_Done,
     /*  582898 */   // Label 9517: @582898
     /*  582898 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(582973), // Rule ID 4019 //
     /*  582903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  582952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582971 */     GIR_RootConstrainSelectedInstOperands,
     /*  582972 */     // GIR_Coverage, 4019,
     /*  582972 */     GIR_EraseRootFromParent_Done,
     /*  582973 */   // Label 9518: @582973
     /*  582973 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(583048), // Rule ID 4022 //
     /*  582978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  582989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  582992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  582995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583024 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583046 */     GIR_RootConstrainSelectedInstOperands,
     /*  583047 */     // GIR_Coverage, 4022,
     /*  583047 */     GIR_EraseRootFromParent_Done,
     /*  583048 */   // Label 9519: @583048
     /*  583048 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(583123), // Rule ID 4023 //
     /*  583053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  583064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  583067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  583070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583099 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583121 */     GIR_RootConstrainSelectedInstOperands,
     /*  583122 */     // GIR_Coverage, 4023,
     /*  583122 */     GIR_EraseRootFromParent_Done,
     /*  583123 */   // Label 9520: @583123
     /*  583123 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(583198), // Rule ID 4026 //
     /*  583128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  583139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  583142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  583145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  583174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583196 */     GIR_RootConstrainSelectedInstOperands,
     /*  583197 */     // GIR_Coverage, 4026,
     /*  583197 */     GIR_EraseRootFromParent_Done,
     /*  583198 */   // Label 9521: @583198
     /*  583198 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(583273), // Rule ID 4027 //
     /*  583203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  583214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  583217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  583220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583249 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  583249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  583268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583271 */     GIR_RootConstrainSelectedInstOperands,
     /*  583272 */     // GIR_Coverage, 4027,
     /*  583272 */     GIR_EraseRootFromParent_Done,
     /*  583273 */   // Label 9522: @583273
     /*  583273 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(583348), // Rule ID 4030 //
     /*  583278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  583295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583346 */     GIR_RootConstrainSelectedInstOperands,
     /*  583347 */     // GIR_Coverage, 4030,
     /*  583347 */     GIR_EraseRootFromParent_Done,
     /*  583348 */   // Label 9523: @583348
     /*  583348 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(583423), // Rule ID 4031 //
     /*  583353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  583364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  583367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  583370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583399 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  583402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583421 */     GIR_RootConstrainSelectedInstOperands,
     /*  583422 */     // GIR_Coverage, 4031,
     /*  583422 */     GIR_EraseRootFromParent_Done,
     /*  583423 */   // Label 9524: @583423
     /*  583423 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(583498), // Rule ID 4034 //
     /*  583428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583496 */     GIR_RootConstrainSelectedInstOperands,
     /*  583497 */     // GIR_Coverage, 4034,
     /*  583497 */     GIR_EraseRootFromParent_Done,
     /*  583498 */   // Label 9525: @583498
     /*  583498 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(583573), // Rule ID 4035 //
     /*  583503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583549 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11667:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583571 */     GIR_RootConstrainSelectedInstOperands,
     /*  583572 */     // GIR_Coverage, 4035,
     /*  583572 */     GIR_EraseRootFromParent_Done,
     /*  583573 */   // Label 9526: @583573
     /*  583573 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(583648), // Rule ID 4038 //
     /*  583578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  583589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  583592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583646 */     GIR_RootConstrainSelectedInstOperands,
     /*  583647 */     // GIR_Coverage, 4038,
     /*  583647 */     GIR_EraseRootFromParent_Done,
     /*  583648 */   // Label 9527: @583648
     /*  583648 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(583723), // Rule ID 4039 //
     /*  583653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  583664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  583667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583721 */     GIR_RootConstrainSelectedInstOperands,
     /*  583722 */     // GIR_Coverage, 4039,
     /*  583722 */     GIR_EraseRootFromParent_Done,
     /*  583723 */   // Label 9528: @583723
     /*  583723 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(583798), // Rule ID 4042 //
     /*  583728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583796 */     GIR_RootConstrainSelectedInstOperands,
     /*  583797 */     // GIR_Coverage, 4042,
     /*  583797 */     GIR_EraseRootFromParent_Done,
     /*  583798 */   // Label 9529: @583798
     /*  583798 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(583873), // Rule ID 4043 //
     /*  583803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583849 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583871 */     GIR_RootConstrainSelectedInstOperands,
     /*  583872 */     // GIR_Coverage, 4043,
     /*  583872 */     GIR_EraseRootFromParent_Done,
     /*  583873 */   // Label 9530: @583873
     /*  583873 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(583948), // Rule ID 4046 //
     /*  583878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583924 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583946 */     GIR_RootConstrainSelectedInstOperands,
     /*  583947 */     // GIR_Coverage, 4046,
     /*  583947 */     GIR_EraseRootFromParent_Done,
     /*  583948 */   // Label 9531: @583948
     /*  583948 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(584023), // Rule ID 4047 //
     /*  583953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583999 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584021 */     GIR_RootConstrainSelectedInstOperands,
     /*  584022 */     // GIR_Coverage, 4047,
     /*  584022 */     GIR_EraseRootFromParent_Done,
     /*  584023 */   // Label 9532: @584023
     /*  584023 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(584098), // Rule ID 4050 //
     /*  584028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  584039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  584042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584096 */     GIR_RootConstrainSelectedInstOperands,
     /*  584097 */     // GIR_Coverage, 4050,
     /*  584097 */     GIR_EraseRootFromParent_Done,
     /*  584098 */   // Label 9533: @584098
     /*  584098 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(584173), // Rule ID 4051 //
     /*  584103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  584114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  584117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11667:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  584152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584171 */     GIR_RootConstrainSelectedInstOperands,
     /*  584172 */     // GIR_Coverage, 4051,
     /*  584172 */     GIR_EraseRootFromParent_Done,
     /*  584173 */   // Label 9534: @584173
     /*  584173 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(584248), // Rule ID 4054 //
     /*  584178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  584189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  584192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  584195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584224 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584246 */     GIR_RootConstrainSelectedInstOperands,
     /*  584247 */     // GIR_Coverage, 4054,
     /*  584247 */     GIR_EraseRootFromParent_Done,
     /*  584248 */   // Label 9535: @584248
     /*  584248 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(584323), // Rule ID 4055 //
     /*  584253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  584264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  584267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  584270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584299 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11667:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  584302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584321 */     GIR_RootConstrainSelectedInstOperands,
     /*  584322 */     // GIR_Coverage, 4055,
     /*  584322 */     GIR_EraseRootFromParent_Done,
     /*  584323 */   // Label 9536: @584323
     /*  584323 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(584398), // Rule ID 4058 //
     /*  584328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  584339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  584342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584374 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584396 */     GIR_RootConstrainSelectedInstOperands,
     /*  584397 */     // GIR_Coverage, 4058,
     /*  584397 */     GIR_EraseRootFromParent_Done,
     /*  584398 */   // Label 9537: @584398
     /*  584398 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(584473), // Rule ID 4059 //
     /*  584403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  584414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  584417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  584420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584449 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11667:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  584452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584471 */     GIR_RootConstrainSelectedInstOperands,
     /*  584472 */     // GIR_Coverage, 4059,
     /*  584472 */     GIR_EraseRootFromParent_Done,
     /*  584473 */   // Label 9538: @584473
     /*  584473 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(584548), // Rule ID 4062 //
     /*  584478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  584481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  584489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  584492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  584495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  584498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584524 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584546 */     GIR_RootConstrainSelectedInstOperands,
     /*  584547 */     // GIR_Coverage, 4062,
     /*  584547 */     GIR_EraseRootFromParent_Done,
     /*  584548 */   // Label 9539: @584548
     /*  584548 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(584623), // Rule ID 4063 //
     /*  584553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  584564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  584567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  584570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584599 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11667:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584621 */     GIR_RootConstrainSelectedInstOperands,
     /*  584622 */     // GIR_Coverage, 4063,
     /*  584622 */     GIR_EraseRootFromParent_Done,
     /*  584623 */   // Label 9540: @584623
     /*  584623 */   GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(584698), // Rule ID 4068 //
     /*  584628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  584645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584674 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  584677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584696 */     GIR_RootConstrainSelectedInstOperands,
     /*  584697 */     // GIR_Coverage, 4068,
     /*  584697 */     GIR_EraseRootFromParent_Done,
     /*  584698 */   // Label 9541: @584698
     /*  584698 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(584773), // Rule ID 4069 //
     /*  584703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  584720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584749 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  584752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584771 */     GIR_RootConstrainSelectedInstOperands,
     /*  584772 */     // GIR_Coverage, 4069,
     /*  584772 */     GIR_EraseRootFromParent_Done,
     /*  584773 */   // Label 9542: @584773
     /*  584773 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(584848), // Rule ID 4078 //
     /*  584778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  584827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584846 */     GIR_RootConstrainSelectedInstOperands,
     /*  584847 */     // GIR_Coverage, 4078,
     /*  584847 */     GIR_EraseRootFromParent_Done,
     /*  584848 */   // Label 9543: @584848
     /*  584848 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(584923), // Rule ID 4079 //
     /*  584853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584899 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  584902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584921 */     GIR_RootConstrainSelectedInstOperands,
     /*  584922 */     // GIR_Coverage, 4079,
     /*  584922 */     GIR_EraseRootFromParent_Done,
     /*  584923 */   // Label 9544: @584923
     /*  584923 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(584998), // Rule ID 4088 //
     /*  584928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  584948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  584977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584996 */     GIR_RootConstrainSelectedInstOperands,
     /*  584997 */     // GIR_Coverage, 4088,
     /*  584997 */     GIR_EraseRootFromParent_Done,
     /*  584998 */   // Label 9545: @584998
     /*  584998 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(585073), // Rule ID 4089 //
     /*  585003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  585014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  585017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  585020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  585023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585071 */     GIR_RootConstrainSelectedInstOperands,
     /*  585072 */     // GIR_Coverage, 4089,
     /*  585072 */     GIR_EraseRootFromParent_Done,
     /*  585073 */   // Label 9546: @585073
     /*  585073 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(585148), // Rule ID 4098 //
     /*  585078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  585089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  585092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  585098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585124 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585146 */     GIR_RootConstrainSelectedInstOperands,
     /*  585147 */     // GIR_Coverage, 4098,
     /*  585147 */     GIR_EraseRootFromParent_Done,
     /*  585148 */   // Label 9547: @585148
     /*  585148 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(585223), // Rule ID 4099 //
     /*  585153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  585164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  585167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  585170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  585173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585199 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585221 */     GIR_RootConstrainSelectedInstOperands,
     /*  585222 */     // GIR_Coverage, 4099,
     /*  585222 */     GIR_EraseRootFromParent_Done,
     /*  585223 */   // Label 9548: @585223
     /*  585223 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(585298), // Rule ID 4108 //
     /*  585228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  585239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  585242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  585245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  585248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  585274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585296 */     GIR_RootConstrainSelectedInstOperands,
     /*  585297 */     // GIR_Coverage, 4108,
     /*  585297 */     GIR_EraseRootFromParent_Done,
     /*  585298 */   // Label 9549: @585298
     /*  585298 */   GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(585373), // Rule ID 4109 //
     /*  585303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  585314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  585317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  585320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  585323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585349 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  585349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  585368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585371 */     GIR_RootConstrainSelectedInstOperands,
     /*  585372 */     // GIR_Coverage, 4109,
     /*  585372 */     GIR_EraseRootFromParent_Done,
     /*  585373 */   // Label 9550: @585373
     /*  585373 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(585448), // Rule ID 4118 //
     /*  585378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  585389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  585392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  585398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585424 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585446 */     GIR_RootConstrainSelectedInstOperands,
     /*  585447 */     // GIR_Coverage, 4118,
     /*  585447 */     GIR_EraseRootFromParent_Done,
     /*  585448 */   // Label 9551: @585448
     /*  585448 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(585523), // Rule ID 4119 //
     /*  585453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  585464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  585467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  585470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  585473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  585502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585521 */     GIR_RootConstrainSelectedInstOperands,
     /*  585522 */     // GIR_Coverage, 4119,
     /*  585522 */     GIR_EraseRootFromParent_Done,
     /*  585523 */   // Label 9552: @585523
     /*  585523 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(585598), // Rule ID 4128 //
     /*  585528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585596 */     GIR_RootConstrainSelectedInstOperands,
     /*  585597 */     // GIR_Coverage, 4128,
     /*  585597 */     GIR_EraseRootFromParent_Done,
     /*  585598 */   // Label 9553: @585598
     /*  585598 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(585673), // Rule ID 4129 //
     /*  585603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585671 */     GIR_RootConstrainSelectedInstOperands,
     /*  585672 */     // GIR_Coverage, 4129,
     /*  585672 */     GIR_EraseRootFromParent_Done,
     /*  585673 */   // Label 9554: @585673
     /*  585673 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(585748), // Rule ID 4138 //
     /*  585678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  585695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585746 */     GIR_RootConstrainSelectedInstOperands,
     /*  585747 */     // GIR_Coverage, 4138,
     /*  585747 */     GIR_EraseRootFromParent_Done,
     /*  585748 */   // Label 9555: @585748
     /*  585748 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(585823), // Rule ID 4139 //
     /*  585753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  585770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585821 */     GIR_RootConstrainSelectedInstOperands,
     /*  585822 */     // GIR_Coverage, 4139,
     /*  585822 */     GIR_EraseRootFromParent_Done,
     /*  585823 */   // Label 9556: @585823
     /*  585823 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(585898), // Rule ID 4148 //
     /*  585828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  585845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585896 */     GIR_RootConstrainSelectedInstOperands,
     /*  585897 */     // GIR_Coverage, 4148,
     /*  585897 */     GIR_EraseRootFromParent_Done,
     /*  585898 */   // Label 9557: @585898
     /*  585898 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(585973), // Rule ID 4149 //
     /*  585903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  585920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585949 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585971 */     GIR_RootConstrainSelectedInstOperands,
     /*  585972 */     // GIR_Coverage, 4149,
     /*  585972 */     GIR_EraseRootFromParent_Done,
     /*  585973 */   // Label 9558: @585973
     /*  585973 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(586048), // Rule ID 4158 //
     /*  585978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  585989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  585992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  585995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  585998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  586024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586046 */     GIR_RootConstrainSelectedInstOperands,
     /*  586047 */     // GIR_Coverage, 4158,
     /*  586047 */     GIR_EraseRootFromParent_Done,
     /*  586048 */   // Label 9559: @586048
     /*  586048 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(586123), // Rule ID 4159 //
     /*  586053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  586064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  586067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  586070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  586073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586099 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  586099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  586118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586121 */     GIR_RootConstrainSelectedInstOperands,
     /*  586122 */     // GIR_Coverage, 4159,
     /*  586122 */     GIR_EraseRootFromParent_Done,
     /*  586123 */   // Label 9560: @586123
     /*  586123 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(586198), // Rule ID 4168 //
     /*  586128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  586139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  586142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  586145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  586148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586196 */     GIR_RootConstrainSelectedInstOperands,
     /*  586197 */     // GIR_Coverage, 4168,
     /*  586197 */     GIR_EraseRootFromParent_Done,
     /*  586198 */   // Label 9561: @586198
     /*  586198 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(586273), // Rule ID 4169 //
     /*  586203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  586214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  586217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  586220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  586223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586249 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  586252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586271 */     GIR_RootConstrainSelectedInstOperands,
     /*  586272 */     // GIR_Coverage, 4169,
     /*  586272 */     GIR_EraseRootFromParent_Done,
     /*  586273 */   // Label 9562: @586273
     /*  586273 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(586348), // Rule ID 4178 //
     /*  586278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  586289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  586292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  586295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  586298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586346 */     GIR_RootConstrainSelectedInstOperands,
     /*  586347 */     // GIR_Coverage, 4178,
     /*  586347 */     GIR_EraseRootFromParent_Done,
     /*  586348 */   // Label 9563: @586348
     /*  586348 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(586423), // Rule ID 4179 //
     /*  586353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  586364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  586367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  586370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  586373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586399 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  586402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586421 */     GIR_RootConstrainSelectedInstOperands,
     /*  586422 */     // GIR_Coverage, 4179,
     /*  586422 */     GIR_EraseRootFromParent_Done,
     /*  586423 */   // Label 9564: @586423
     /*  586423 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(586498), // Rule ID 4188 //
     /*  586428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  586445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586496 */     GIR_RootConstrainSelectedInstOperands,
     /*  586497 */     // GIR_Coverage, 4188,
     /*  586497 */     GIR_EraseRootFromParent_Done,
     /*  586498 */   // Label 9565: @586498
     /*  586498 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(586573), // Rule ID 4189 //
     /*  586503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  586520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586549 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586571 */     GIR_RootConstrainSelectedInstOperands,
     /*  586572 */     // GIR_Coverage, 4189,
     /*  586572 */     GIR_EraseRootFromParent_Done,
     /*  586573 */   // Label 9566: @586573
     /*  586573 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(586648), // Rule ID 4198 //
     /*  586578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  586595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586624 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586646 */     GIR_RootConstrainSelectedInstOperands,
     /*  586647 */     // GIR_Coverage, 4198,
     /*  586647 */     GIR_EraseRootFromParent_Done,
     /*  586648 */   // Label 9567: @586648
     /*  586648 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(586723), // Rule ID 4199 //
     /*  586653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  586670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586699 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586721 */     GIR_RootConstrainSelectedInstOperands,
     /*  586722 */     // GIR_Coverage, 4199,
     /*  586722 */     GIR_EraseRootFromParent_Done,
     /*  586723 */   // Label 9568: @586723
     /*  586723 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(586798), // Rule ID 4206 //
     /*  586728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  586745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586774 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  586777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586796 */     GIR_RootConstrainSelectedInstOperands,
     /*  586797 */     // GIR_Coverage, 4206,
     /*  586797 */     GIR_EraseRootFromParent_Done,
     /*  586798 */   // Label 9569: @586798
     /*  586798 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(586873), // Rule ID 4207 //
     /*  586803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  586820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586849 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  586852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586871 */     GIR_RootConstrainSelectedInstOperands,
     /*  586872 */     // GIR_Coverage, 4207,
     /*  586872 */     GIR_EraseRootFromParent_Done,
     /*  586873 */   // Label 9570: @586873
     /*  586873 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(586948), // Rule ID 4210 //
     /*  586878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  586895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586924 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  586927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586946 */     GIR_RootConstrainSelectedInstOperands,
     /*  586947 */     // GIR_Coverage, 4210,
     /*  586947 */     GIR_EraseRootFromParent_Done,
     /*  586948 */   // Label 9571: @586948
     /*  586948 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(587023), // Rule ID 4211 //
     /*  586953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  586970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586999 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587021 */     GIR_RootConstrainSelectedInstOperands,
     /*  587022 */     // GIR_Coverage, 4211,
     /*  587022 */     GIR_EraseRootFromParent_Done,
     /*  587023 */   // Label 9572: @587023
     /*  587023 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(587098), // Rule ID 4214 //
     /*  587028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  587039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  587042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587096 */     GIR_RootConstrainSelectedInstOperands,
     /*  587097 */     // GIR_Coverage, 4214,
     /*  587097 */     GIR_EraseRootFromParent_Done,
     /*  587098 */   // Label 9573: @587098
     /*  587098 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(587173), // Rule ID 4215 //
     /*  587103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  587114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  587117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  587120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11645:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587171 */     GIR_RootConstrainSelectedInstOperands,
     /*  587172 */     // GIR_Coverage, 4215,
     /*  587172 */     GIR_EraseRootFromParent_Done,
     /*  587173 */   // Label 9574: @587173
     /*  587173 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(587248), // Rule ID 4218 //
     /*  587178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587246 */     GIR_RootConstrainSelectedInstOperands,
     /*  587247 */     // GIR_Coverage, 4218,
     /*  587247 */     GIR_EraseRootFromParent_Done,
     /*  587248 */   // Label 9575: @587248
     /*  587248 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(587323), // Rule ID 4219 //
     /*  587253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  587264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  587267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  587270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587299 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587321 */     GIR_RootConstrainSelectedInstOperands,
     /*  587322 */     // GIR_Coverage, 4219,
     /*  587322 */     GIR_EraseRootFromParent_Done,
     /*  587323 */   // Label 9576: @587323
     /*  587323 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(587398), // Rule ID 4222 //
     /*  587328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587396 */     GIR_RootConstrainSelectedInstOperands,
     /*  587397 */     // GIR_Coverage, 4222,
     /*  587397 */     GIR_EraseRootFromParent_Done,
     /*  587398 */   // Label 9577: @587398
     /*  587398 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(587473), // Rule ID 4223 //
     /*  587403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  587414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  587417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  587420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587449 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587471 */     GIR_RootConstrainSelectedInstOperands,
     /*  587472 */     // GIR_Coverage, 4223,
     /*  587472 */     GIR_EraseRootFromParent_Done,
     /*  587473 */   // Label 9578: @587473
     /*  587473 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(587548), // Rule ID 4226 //
     /*  587478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  587495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  587527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587546 */     GIR_RootConstrainSelectedInstOperands,
     /*  587547 */     // GIR_Coverage, 4226,
     /*  587547 */     GIR_EraseRootFromParent_Done,
     /*  587548 */   // Label 9579: @587548
     /*  587548 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(587623), // Rule ID 4227 //
     /*  587553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  587570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587599 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  587602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587621 */     GIR_RootConstrainSelectedInstOperands,
     /*  587622 */     // GIR_Coverage, 4227,
     /*  587622 */     GIR_EraseRootFromParent_Done,
     /*  587623 */   // Label 9580: @587623
     /*  587623 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(587698), // Rule ID 4230 //
     /*  587628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587674 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587696 */     GIR_RootConstrainSelectedInstOperands,
     /*  587697 */     // GIR_Coverage, 4230,
     /*  587697 */     GIR_EraseRootFromParent_Done,
     /*  587698 */   // Label 9581: @587698
     /*  587698 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(587773), // Rule ID 4231 //
     /*  587703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587749 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587771 */     GIR_RootConstrainSelectedInstOperands,
     /*  587772 */     // GIR_Coverage, 4231,
     /*  587772 */     GIR_EraseRootFromParent_Done,
     /*  587773 */   // Label 9582: @587773
     /*  587773 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(587848), // Rule ID 4234 //
     /*  587778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  587795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587846 */     GIR_RootConstrainSelectedInstOperands,
     /*  587847 */     // GIR_Coverage, 4234,
     /*  587847 */     GIR_EraseRootFromParent_Done,
     /*  587848 */   // Label 9583: @587848
     /*  587848 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(587923), // Rule ID 4235 //
     /*  587853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  587870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11645:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587921 */     GIR_RootConstrainSelectedInstOperands,
     /*  587922 */     // GIR_Coverage, 4235,
     /*  587922 */     GIR_EraseRootFromParent_Done,
     /*  587923 */   // Label 9584: @587923
     /*  587923 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(587998), // Rule ID 4238 //
     /*  587928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  587939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  587942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  587945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587996 */     GIR_RootConstrainSelectedInstOperands,
     /*  587997 */     // GIR_Coverage, 4238,
     /*  587997 */     GIR_EraseRootFromParent_Done,
     /*  587998 */   // Label 9585: @587998
     /*  587998 */   GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(588073), // Rule ID 4239 //
     /*  588003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  588014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  588017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  588020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588071 */     GIR_RootConstrainSelectedInstOperands,
     /*  588072 */     // GIR_Coverage, 4239,
     /*  588072 */     GIR_EraseRootFromParent_Done,
     /*  588073 */   // Label 9586: @588073
     /*  588073 */   GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(588148), // Rule ID 4242 //
     /*  588078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588124 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588146 */     GIR_RootConstrainSelectedInstOperands,
     /*  588147 */     // GIR_Coverage, 4242,
     /*  588147 */     GIR_EraseRootFromParent_Done,
     /*  588148 */   // Label 9587: @588148
     /*  588148 */   GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(588223), // Rule ID 4243 //
     /*  588153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  588164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  588167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  588170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588199 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588221 */     GIR_RootConstrainSelectedInstOperands,
     /*  588222 */     // GIR_Coverage, 4243,
     /*  588222 */     GIR_EraseRootFromParent_Done,
     /*  588223 */   // Label 9588: @588223
     /*  588223 */   GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(588298), // Rule ID 4246 //
     /*  588228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  588274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588296 */     GIR_RootConstrainSelectedInstOperands,
     /*  588297 */     // GIR_Coverage, 4246,
     /*  588297 */     GIR_EraseRootFromParent_Done,
     /*  588298 */   // Label 9589: @588298
     /*  588298 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(588373), // Rule ID 4247 //
     /*  588303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  588314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  588317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  588320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588349 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  588349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  588368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588371 */     GIR_RootConstrainSelectedInstOperands,
     /*  588372 */     // GIR_Coverage, 4247,
     /*  588372 */     GIR_EraseRootFromParent_Done,
     /*  588373 */   // Label 9590: @588373
     /*  588373 */   GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(588448), // Rule ID 4250 //
     /*  588378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  588389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  588392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  588395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588446 */     GIR_RootConstrainSelectedInstOperands,
     /*  588447 */     // GIR_Coverage, 4250,
     /*  588447 */     GIR_EraseRootFromParent_Done,
     /*  588448 */   // Label 9591: @588448
     /*  588448 */   GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(588523), // Rule ID 4251 //
     /*  588453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  588464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  588467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  588470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588499 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11645:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  588502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588521 */     GIR_RootConstrainSelectedInstOperands,
     /*  588522 */     // GIR_Coverage, 4251,
     /*  588522 */     GIR_EraseRootFromParent_Done,
     /*  588523 */   // Label 9592: @588523
     /*  588523 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(588598), // Rule ID 4254 //
     /*  588528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  588545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588574 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588596 */     GIR_RootConstrainSelectedInstOperands,
     /*  588597 */     // GIR_Coverage, 4254,
     /*  588597 */     GIR_EraseRootFromParent_Done,
     /*  588598 */   // Label 9593: @588598
     /*  588598 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(588673), // Rule ID 4255 //
     /*  588603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  588620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11645:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588671 */     GIR_RootConstrainSelectedInstOperands,
     /*  588672 */     // GIR_Coverage, 4255,
     /*  588672 */     GIR_EraseRootFromParent_Done,
     /*  588673 */   // Label 9594: @588673
     /*  588673 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(588748), // Rule ID 4258 //
     /*  588678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  588695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588724 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588746 */     GIR_RootConstrainSelectedInstOperands,
     /*  588747 */     // GIR_Coverage, 4258,
     /*  588747 */     GIR_EraseRootFromParent_Done,
     /*  588748 */   // Label 9595: @588748
     /*  588748 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(588823), // Rule ID 4259 //
     /*  588753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  588770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588799 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11645:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588821 */     GIR_RootConstrainSelectedInstOperands,
     /*  588822 */     // GIR_Coverage, 4259,
     /*  588822 */     GIR_EraseRootFromParent_Done,
     /*  588823 */   // Label 9596: @588823
     /*  588823 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(588898), // Rule ID 4262 //
     /*  588828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  588845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588896 */     GIR_RootConstrainSelectedInstOperands,
     /*  588897 */     // GIR_Coverage, 4262,
     /*  588897 */     GIR_EraseRootFromParent_Done,
     /*  588898 */   // Label 9597: @588898
     /*  588898 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(588973), // Rule ID 4263 //
     /*  588903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  588920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588949 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11645:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588971 */     GIR_RootConstrainSelectedInstOperands,
     /*  588972 */     // GIR_Coverage, 4263,
     /*  588972 */     GIR_EraseRootFromParent_Done,
     /*  588973 */   // Label 9598: @588973
     /*  588973 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(589048), // Rule ID 4268 //
     /*  588978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  588986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  588989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  588992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  588995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  588998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589024 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  589027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589046 */     GIR_RootConstrainSelectedInstOperands,
     /*  589047 */     // GIR_Coverage, 4268,
     /*  589047 */     GIR_EraseRootFromParent_Done,
     /*  589048 */   // Label 9599: @589048
     /*  589048 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(589123), // Rule ID 4269 //
     /*  589053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  589064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  589067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  589070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  589073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589099 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  589102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589121 */     GIR_RootConstrainSelectedInstOperands,
     /*  589122 */     // GIR_Coverage, 4269,
     /*  589122 */     GIR_EraseRootFromParent_Done,
     /*  589123 */   // Label 9600: @589123
     /*  589123 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(589198), // Rule ID 4278 //
     /*  589128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589196 */     GIR_RootConstrainSelectedInstOperands,
     /*  589197 */     // GIR_Coverage, 4278,
     /*  589197 */     GIR_EraseRootFromParent_Done,
     /*  589198 */   // Label 9601: @589198
     /*  589198 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(589273), // Rule ID 4279 //
     /*  589203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  589214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  589217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  589220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  589223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589249 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589271 */     GIR_RootConstrainSelectedInstOperands,
     /*  589272 */     // GIR_Coverage, 4279,
     /*  589272 */     GIR_EraseRootFromParent_Done,
     /*  589273 */   // Label 9602: @589273
     /*  589273 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(589348), // Rule ID 4288 //
     /*  589278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  589289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  589292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  589295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589346 */     GIR_RootConstrainSelectedInstOperands,
     /*  589347 */     // GIR_Coverage, 4288,
     /*  589347 */     GIR_EraseRootFromParent_Done,
     /*  589348 */   // Label 9603: @589348
     /*  589348 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(589423), // Rule ID 4289 //
     /*  589353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  589364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  589367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  589370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  589373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589399 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589421 */     GIR_RootConstrainSelectedInstOperands,
     /*  589422 */     // GIR_Coverage, 4289,
     /*  589422 */     GIR_EraseRootFromParent_Done,
     /*  589423 */   // Label 9604: @589423
     /*  589423 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(589498), // Rule ID 4298 //
     /*  589428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  589439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  589442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  589445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589474 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  589477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589496 */     GIR_RootConstrainSelectedInstOperands,
     /*  589497 */     // GIR_Coverage, 4298,
     /*  589497 */     GIR_EraseRootFromParent_Done,
     /*  589498 */   // Label 9605: @589498
     /*  589498 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(589573), // Rule ID 4299 //
     /*  589503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  589514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  589517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  589520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589549 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  589552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589571 */     GIR_RootConstrainSelectedInstOperands,
     /*  589572 */     // GIR_Coverage, 4299,
     /*  589572 */     GIR_EraseRootFromParent_Done,
     /*  589573 */   // Label 9606: @589573
     /*  589573 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(589648), // Rule ID 4308 //
     /*  589578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  589589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  589592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  589595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  589598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  589627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589646 */     GIR_RootConstrainSelectedInstOperands,
     /*  589647 */     // GIR_Coverage, 4308,
     /*  589647 */     GIR_EraseRootFromParent_Done,
     /*  589648 */   // Label 9607: @589648
     /*  589648 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(589723), // Rule ID 4309 //
     /*  589653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  589664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  589667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  589670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  589673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  589702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589721 */     GIR_RootConstrainSelectedInstOperands,
     /*  589722 */     // GIR_Coverage, 4309,
     /*  589722 */     GIR_EraseRootFromParent_Done,
     /*  589723 */   // Label 9608: @589723
     /*  589723 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(589798), // Rule ID 4318 //
     /*  589728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  589777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589796 */     GIR_RootConstrainSelectedInstOperands,
     /*  589797 */     // GIR_Coverage, 4318,
     /*  589797 */     GIR_EraseRootFromParent_Done,
     /*  589798 */   // Label 9609: @589798
     /*  589798 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(589873), // Rule ID 4319 //
     /*  589803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589849 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  589852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589871 */     GIR_RootConstrainSelectedInstOperands,
     /*  589872 */     // GIR_Coverage, 4319,
     /*  589872 */     GIR_EraseRootFromParent_Done,
     /*  589873 */   // Label 9610: @589873
     /*  589873 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(589948), // Rule ID 4328 //
     /*  589878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589946 */     GIR_RootConstrainSelectedInstOperands,
     /*  589947 */     // GIR_Coverage, 4328,
     /*  589947 */     GIR_EraseRootFromParent_Done,
     /*  589948 */   // Label 9611: @589948
     /*  589948 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(590023), // Rule ID 4329 //
     /*  589953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589999 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  590002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590021 */     GIR_RootConstrainSelectedInstOperands,
     /*  590022 */     // GIR_Coverage, 4329,
     /*  590022 */     GIR_EraseRootFromParent_Done,
     /*  590023 */   // Label 9612: @590023
     /*  590023 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(590098), // Rule ID 4338 //
     /*  590028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  590048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590096 */     GIR_RootConstrainSelectedInstOperands,
     /*  590097 */     // GIR_Coverage, 4338,
     /*  590097 */     GIR_EraseRootFromParent_Done,
     /*  590098 */   // Label 9613: @590098
     /*  590098 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(590173), // Rule ID 4339 //
     /*  590103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  590114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  590117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  590120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  590123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590149 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590171 */     GIR_RootConstrainSelectedInstOperands,
     /*  590172 */     // GIR_Coverage, 4339,
     /*  590172 */     GIR_EraseRootFromParent_Done,
     /*  590173 */   // Label 9614: @590173
     /*  590173 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(590248), // Rule ID 4348 //
     /*  590178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  590189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  590192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  590195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590246 */     GIR_RootConstrainSelectedInstOperands,
     /*  590247 */     // GIR_Coverage, 4348,
     /*  590247 */     GIR_EraseRootFromParent_Done,
     /*  590248 */   // Label 9615: @590248
     /*  590248 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(590323), // Rule ID 4349 //
     /*  590253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  590264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  590267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  590270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  590273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590299 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590321 */     GIR_RootConstrainSelectedInstOperands,
     /*  590322 */     // GIR_Coverage, 4349,
     /*  590322 */     GIR_EraseRootFromParent_Done,
     /*  590323 */   // Label 9616: @590323
     /*  590323 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(590398), // Rule ID 4358 //
     /*  590328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  590339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  590342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  590345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  590348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590396 */     GIR_RootConstrainSelectedInstOperands,
     /*  590397 */     // GIR_Coverage, 4358,
     /*  590397 */     GIR_EraseRootFromParent_Done,
     /*  590398 */   // Label 9617: @590398
     /*  590398 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(590473), // Rule ID 4359 //
     /*  590403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  590414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  590417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  590420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  590423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590449 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590471 */     GIR_RootConstrainSelectedInstOperands,
     /*  590472 */     // GIR_Coverage, 4359,
     /*  590472 */     GIR_EraseRootFromParent_Done,
     /*  590473 */   // Label 9618: @590473
     /*  590473 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(590548), // Rule ID 4368 //
     /*  590478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  590489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  590492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  590495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  590498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590546 */     GIR_RootConstrainSelectedInstOperands,
     /*  590547 */     // GIR_Coverage, 4368,
     /*  590547 */     GIR_EraseRootFromParent_Done,
     /*  590548 */   // Label 9619: @590548
     /*  590548 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(590623), // Rule ID 4369 //
     /*  590553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  590564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  590567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  590570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  590573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590599 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590621 */     GIR_RootConstrainSelectedInstOperands,
     /*  590622 */     // GIR_Coverage, 4369,
     /*  590622 */     GIR_EraseRootFromParent_Done,
     /*  590623 */   // Label 9620: @590623
     /*  590623 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(590698), // Rule ID 4378 //
     /*  590628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  590648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590696 */     GIR_RootConstrainSelectedInstOperands,
     /*  590697 */     // GIR_Coverage, 4378,
     /*  590697 */     GIR_EraseRootFromParent_Done,
     /*  590698 */   // Label 9621: @590698
     /*  590698 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(590773), // Rule ID 4379 //
     /*  590703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  590723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590749 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590771 */     GIR_RootConstrainSelectedInstOperands,
     /*  590772 */     // GIR_Coverage, 4379,
     /*  590772 */     GIR_EraseRootFromParent_Done,
     /*  590773 */   // Label 9622: @590773
     /*  590773 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(590848), // Rule ID 4388 //
     /*  590778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590846 */     GIR_RootConstrainSelectedInstOperands,
     /*  590847 */     // GIR_Coverage, 4388,
     /*  590847 */     GIR_EraseRootFromParent_Done,
     /*  590848 */   // Label 9623: @590848
     /*  590848 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(590923), // Rule ID 4389 //
     /*  590853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590921 */     GIR_RootConstrainSelectedInstOperands,
     /*  590922 */     // GIR_Coverage, 4389,
     /*  590922 */     GIR_EraseRootFromParent_Done,
     /*  590923 */   // Label 9624: @590923
     /*  590923 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(590998), // Rule ID 4398 //
     /*  590928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  590939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  590942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  590945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  590948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590996 */     GIR_RootConstrainSelectedInstOperands,
     /*  590997 */     // GIR_Coverage, 4398,
     /*  590997 */     GIR_EraseRootFromParent_Done,
     /*  590998 */   // Label 9625: @590998
     /*  590998 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(591073), // Rule ID 4399 //
     /*  591003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  591014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  591017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  591020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  591023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591049 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  591052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591071 */     GIR_RootConstrainSelectedInstOperands,
     /*  591072 */     // GIR_Coverage, 4399,
     /*  591072 */     GIR_EraseRootFromParent_Done,
     /*  591073 */   // Label 9626: @591073
     /*  591073 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(591148), // Rule ID 4408 //
     /*  591078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  591081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  591089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  591092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  591095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  591124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591146 */     GIR_RootConstrainSelectedInstOperands,
     /*  591147 */     // GIR_Coverage, 4408,
     /*  591147 */     GIR_EraseRootFromParent_Done,
     /*  591148 */   // Label 9627: @591148
     /*  591148 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(591223), // Rule ID 4409 //
     /*  591153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  591156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  591164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  591167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  591170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  591173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591199 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  591199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  591202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  591218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591221 */     GIR_RootConstrainSelectedInstOperands,
     /*  591222 */     // GIR_Coverage, 4409,
     /*  591222 */     GIR_EraseRootFromParent_Done,
     /*  591223 */   // Label 9628: @591223
     /*  591223 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(591298), // Rule ID 4416 //
     /*  591228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  591239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  591242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  591245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591274 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  591277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591296 */     GIR_RootConstrainSelectedInstOperands,
     /*  591297 */     // GIR_Coverage, 4416,
     /*  591297 */     GIR_EraseRootFromParent_Done,
     /*  591298 */   // Label 9629: @591298
     /*  591298 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(591373), // Rule ID 4417 //
     /*  591303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  591314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  591317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  591320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591349 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  591352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591371 */     GIR_RootConstrainSelectedInstOperands,
     /*  591372 */     // GIR_Coverage, 4417,
     /*  591372 */     GIR_EraseRootFromParent_Done,
     /*  591373 */   // Label 9630: @591373
     /*  591373 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(591448), // Rule ID 4420 //
     /*  591378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  591389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  591392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  591395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591424 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591446 */     GIR_RootConstrainSelectedInstOperands,
     /*  591447 */     // GIR_Coverage, 4420,
     /*  591447 */     GIR_EraseRootFromParent_Done,
     /*  591448 */   // Label 9631: @591448
     /*  591448 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(591523), // Rule ID 4421 //
     /*  591453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  591464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  591467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  591470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591499 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591521 */     GIR_RootConstrainSelectedInstOperands,
     /*  591522 */     // GIR_Coverage, 4421,
     /*  591522 */     GIR_EraseRootFromParent_Done,
     /*  591523 */   // Label 9632: @591523
     /*  591523 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(591598), // Rule ID 4424 //
     /*  591528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  591539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  591542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  591545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591574 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  591577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591596 */     GIR_RootConstrainSelectedInstOperands,
     /*  591597 */     // GIR_Coverage, 4424,
     /*  591597 */     GIR_EraseRootFromParent_Done,
     /*  591598 */   // Label 9633: @591598
     /*  591598 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(591673), // Rule ID 4425 //
     /*  591603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  591614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  591617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  591620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591649 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11673:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  591652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591671 */     GIR_RootConstrainSelectedInstOperands,
     /*  591672 */     // GIR_Coverage, 4425,
     /*  591672 */     GIR_EraseRootFromParent_Done,
     /*  591673 */   // Label 9634: @591673
     /*  591673 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(591748), // Rule ID 4428 //
     /*  591678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  591727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591746 */     GIR_RootConstrainSelectedInstOperands,
     /*  591747 */     // GIR_Coverage, 4428,
     /*  591747 */     GIR_EraseRootFromParent_Done,
     /*  591748 */   // Label 9635: @591748
     /*  591748 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(591823), // Rule ID 4429 //
     /*  591753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  591802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591821 */     GIR_RootConstrainSelectedInstOperands,
     /*  591822 */     // GIR_Coverage, 4429,
     /*  591822 */     GIR_EraseRootFromParent_Done,
     /*  591823 */   // Label 9636: @591823
     /*  591823 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(591898), // Rule ID 4432 //
     /*  591828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  591877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591896 */     GIR_RootConstrainSelectedInstOperands,
     /*  591897 */     // GIR_Coverage, 4432,
     /*  591897 */     GIR_EraseRootFromParent_Done,
     /*  591898 */   // Label 9637: @591898
     /*  591898 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(591973), // Rule ID 4433 //
     /*  591903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591949 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  591952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591971 */     GIR_RootConstrainSelectedInstOperands,
     /*  591972 */     // GIR_Coverage, 4433,
     /*  591972 */     GIR_EraseRootFromParent_Done,
     /*  591973 */   // Label 9638: @591973
     /*  591973 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(592048), // Rule ID 4436 //
     /*  591978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  591989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  591992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  591995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592024 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  592024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592046 */     GIR_RootConstrainSelectedInstOperands,
     /*  592047 */     // GIR_Coverage, 4436,
     /*  592047 */     GIR_EraseRootFromParent_Done,
     /*  592048 */   // Label 9639: @592048
     /*  592048 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(592123), // Rule ID 4437 //
     /*  592053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  592064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  592067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  592070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  592099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  592118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592121 */     GIR_RootConstrainSelectedInstOperands,
     /*  592122 */     // GIR_Coverage, 4437,
     /*  592122 */     GIR_EraseRootFromParent_Done,
     /*  592123 */   // Label 9640: @592123
     /*  592123 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(592198), // Rule ID 4440 //
     /*  592128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  592139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  592142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  592145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  592177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592196 */     GIR_RootConstrainSelectedInstOperands,
     /*  592197 */     // GIR_Coverage, 4440,
     /*  592197 */     GIR_EraseRootFromParent_Done,
     /*  592198 */   // Label 9641: @592198
     /*  592198 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(592273), // Rule ID 4441 //
     /*  592203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  592214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  592217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  592220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  592252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592271 */     GIR_RootConstrainSelectedInstOperands,
     /*  592272 */     // GIR_Coverage, 4441,
     /*  592272 */     GIR_EraseRootFromParent_Done,
     /*  592273 */   // Label 9642: @592273
     /*  592273 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(592348), // Rule ID 4444 //
     /*  592278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  592289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  592292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  592295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592346 */     GIR_RootConstrainSelectedInstOperands,
     /*  592347 */     // GIR_Coverage, 4444,
     /*  592347 */     GIR_EraseRootFromParent_Done,
     /*  592348 */   // Label 9643: @592348
     /*  592348 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(592423), // Rule ID 4445 //
     /*  592353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  592364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  592367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  592370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11673:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592421 */     GIR_RootConstrainSelectedInstOperands,
     /*  592422 */     // GIR_Coverage, 4445,
     /*  592422 */     GIR_EraseRootFromParent_Done,
     /*  592423 */   // Label 9644: @592423
     /*  592423 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(592498), // Rule ID 4448 //
     /*  592428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  592439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  592442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  592445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592474 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592496 */     GIR_RootConstrainSelectedInstOperands,
     /*  592497 */     // GIR_Coverage, 4448,
     /*  592497 */     GIR_EraseRootFromParent_Done,
     /*  592498 */   // Label 9645: @592498
     /*  592498 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(592573), // Rule ID 4449 //
     /*  592503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  592514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  592517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  592520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592571 */     GIR_RootConstrainSelectedInstOperands,
     /*  592572 */     // GIR_Coverage, 4449,
     /*  592572 */     GIR_EraseRootFromParent_Done,
     /*  592573 */   // Label 9646: @592573
     /*  592573 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(592648), // Rule ID 4452 //
     /*  592578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  592589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  592592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  592595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592646 */     GIR_RootConstrainSelectedInstOperands,
     /*  592647 */     // GIR_Coverage, 4452,
     /*  592647 */     GIR_EraseRootFromParent_Done,
     /*  592648 */   // Label 9647: @592648
     /*  592648 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(592723), // Rule ID 4453 //
     /*  592653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  592664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  592667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  592670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592699 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592721 */     GIR_RootConstrainSelectedInstOperands,
     /*  592722 */     // GIR_Coverage, 4453,
     /*  592722 */     GIR_EraseRootFromParent_Done,
     /*  592723 */   // Label 9648: @592723
     /*  592723 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(592798), // Rule ID 4456 //
     /*  592728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592796 */     GIR_RootConstrainSelectedInstOperands,
     /*  592797 */     // GIR_Coverage, 4456,
     /*  592797 */     GIR_EraseRootFromParent_Done,
     /*  592798 */   // Label 9649: @592798
     /*  592798 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(592873), // Rule ID 4457 //
     /*  592803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592849 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592871 */     GIR_RootConstrainSelectedInstOperands,
     /*  592872 */     // GIR_Coverage, 4457,
     /*  592872 */     GIR_EraseRootFromParent_Done,
     /*  592873 */   // Label 9650: @592873
     /*  592873 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(592948), // Rule ID 4460 //
     /*  592878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592946 */     GIR_RootConstrainSelectedInstOperands,
     /*  592947 */     // GIR_Coverage, 4460,
     /*  592947 */     GIR_EraseRootFromParent_Done,
     /*  592948 */   // Label 9651: @592948
     /*  592948 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(593023), // Rule ID 4461 //
     /*  592953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11673:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  593002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593021 */     GIR_RootConstrainSelectedInstOperands,
     /*  593022 */     // GIR_Coverage, 4461,
     /*  593022 */     GIR_EraseRootFromParent_Done,
     /*  593023 */   // Label 9652: @593023
     /*  593023 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(593098), // Rule ID 4464 //
     /*  593028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  593039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  593042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  593045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593074 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593096 */     GIR_RootConstrainSelectedInstOperands,
     /*  593097 */     // GIR_Coverage, 4464,
     /*  593097 */     GIR_EraseRootFromParent_Done,
     /*  593098 */   // Label 9653: @593098
     /*  593098 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(593173), // Rule ID 4465 //
     /*  593103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  593114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  593117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  593120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11673:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  593152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593171 */     GIR_RootConstrainSelectedInstOperands,
     /*  593172 */     // GIR_Coverage, 4465,
     /*  593172 */     GIR_EraseRootFromParent_Done,
     /*  593173 */   // Label 9654: @593173
     /*  593173 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(593248), // Rule ID 4468 //
     /*  593178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  593189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  593192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  593195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593246 */     GIR_RootConstrainSelectedInstOperands,
     /*  593247 */     // GIR_Coverage, 4468,
     /*  593247 */     GIR_EraseRootFromParent_Done,
     /*  593248 */   // Label 9655: @593248
     /*  593248 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(593323), // Rule ID 4469 //
     /*  593253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  593264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  593267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  593270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593299 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11673:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  593302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593321 */     GIR_RootConstrainSelectedInstOperands,
     /*  593322 */     // GIR_Coverage, 4469,
     /*  593322 */     GIR_EraseRootFromParent_Done,
     /*  593323 */   // Label 9656: @593323
     /*  593323 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(593398), // Rule ID 4472 //
     /*  593328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  593331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  593339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  593342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  593345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  593348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  593374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593396 */     GIR_RootConstrainSelectedInstOperands,
     /*  593397 */     // GIR_Coverage, 4472,
     /*  593397 */     GIR_EraseRootFromParent_Done,
     /*  593398 */   // Label 9657: @593398
     /*  593398 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(593473), // Rule ID 4473 //
     /*  593403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  593406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  593411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  593414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  593417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  593420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  593423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  593442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593449 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11673:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  593449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  593452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  593468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593471 */     GIR_RootConstrainSelectedInstOperands,
     /*  593472 */     // GIR_Coverage, 4473,
     /*  593472 */     GIR_EraseRootFromParent_Done,
     /*  593473 */   // Label 9658: @593473
     /*  593473 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(593548), // Rule ID 4478 //
     /*  593478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  593489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  593492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  593495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  593498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593524 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  593527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593546 */     GIR_RootConstrainSelectedInstOperands,
     /*  593547 */     // GIR_Coverage, 4478,
     /*  593547 */     GIR_EraseRootFromParent_Done,
     /*  593548 */   // Label 9659: @593548
     /*  593548 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(593623), // Rule ID 4479 //
     /*  593553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  593564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  593567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  593570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  593573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593599 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  593602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593621 */     GIR_RootConstrainSelectedInstOperands,
     /*  593622 */     // GIR_Coverage, 4479,
     /*  593622 */     GIR_EraseRootFromParent_Done,
     /*  593623 */   // Label 9660: @593623
     /*  593623 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(593698), // Rule ID 4488 //
     /*  593628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  593639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  593642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  593645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  593648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593674 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  593677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593696 */     GIR_RootConstrainSelectedInstOperands,
     /*  593697 */     // GIR_Coverage, 4488,
     /*  593697 */     GIR_EraseRootFromParent_Done,
     /*  593698 */   // Label 9661: @593698
     /*  593698 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(593773), // Rule ID 4489 //
     /*  593703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  593714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  593717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  593720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  593723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593749 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  593752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593771 */     GIR_RootConstrainSelectedInstOperands,
     /*  593772 */     // GIR_Coverage, 4489,
     /*  593772 */     GIR_EraseRootFromParent_Done,
     /*  593773 */   // Label 9662: @593773
     /*  593773 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(593848), // Rule ID 4498 //
     /*  593778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  593827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593846 */     GIR_RootConstrainSelectedInstOperands,
     /*  593847 */     // GIR_Coverage, 4498,
     /*  593847 */     GIR_EraseRootFromParent_Done,
     /*  593848 */   // Label 9663: @593848
     /*  593848 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(593923), // Rule ID 4499 //
     /*  593853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593899 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  593902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593921 */     GIR_RootConstrainSelectedInstOperands,
     /*  593922 */     // GIR_Coverage, 4499,
     /*  593922 */     GIR_EraseRootFromParent_Done,
     /*  593923 */   // Label 9664: @593923
     /*  593923 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(593998), // Rule ID 4508 //
     /*  593928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  593939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  593942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  593945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  593948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  593977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593996 */     GIR_RootConstrainSelectedInstOperands,
     /*  593997 */     // GIR_Coverage, 4508,
     /*  593997 */     GIR_EraseRootFromParent_Done,
     /*  593998 */   // Label 9665: @593998
     /*  593998 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(594073), // Rule ID 4509 //
     /*  594003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  594014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  594017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  594020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  594023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594071 */     GIR_RootConstrainSelectedInstOperands,
     /*  594072 */     // GIR_Coverage, 4509,
     /*  594072 */     GIR_EraseRootFromParent_Done,
     /*  594073 */   // Label 9666: @594073
     /*  594073 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(594148), // Rule ID 4518 //
     /*  594078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  594098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594124 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594146 */     GIR_RootConstrainSelectedInstOperands,
     /*  594147 */     // GIR_Coverage, 4518,
     /*  594147 */     GIR_EraseRootFromParent_Done,
     /*  594148 */   // Label 9667: @594148
     /*  594148 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(594223), // Rule ID 4519 //
     /*  594153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  594164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  594167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  594170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  594173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594199 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594221 */     GIR_RootConstrainSelectedInstOperands,
     /*  594222 */     // GIR_Coverage, 4519,
     /*  594222 */     GIR_EraseRootFromParent_Done,
     /*  594223 */   // Label 9668: @594223
     /*  594223 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(594298), // Rule ID 4528 //
     /*  594228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  594248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  594274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594296 */     GIR_RootConstrainSelectedInstOperands,
     /*  594297 */     // GIR_Coverage, 4528,
     /*  594297 */     GIR_EraseRootFromParent_Done,
     /*  594298 */   // Label 9669: @594298
     /*  594298 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(594373), // Rule ID 4529 //
     /*  594303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  594314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  594317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  594320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  594323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594349 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  594349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  594368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594371 */     GIR_RootConstrainSelectedInstOperands,
     /*  594372 */     // GIR_Coverage, 4529,
     /*  594372 */     GIR_EraseRootFromParent_Done,
     /*  594373 */   // Label 9670: @594373
     /*  594373 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(594448), // Rule ID 4538 //
     /*  594378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  594389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  594392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  594395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  594398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594424 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594446 */     GIR_RootConstrainSelectedInstOperands,
     /*  594447 */     // GIR_Coverage, 4538,
     /*  594447 */     GIR_EraseRootFromParent_Done,
     /*  594448 */   // Label 9671: @594448
     /*  594448 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(594523), // Rule ID 4539 //
     /*  594453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  594464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  594467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  594470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  594473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  594502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594521 */     GIR_RootConstrainSelectedInstOperands,
     /*  594522 */     // GIR_Coverage, 4539,
     /*  594522 */     GIR_EraseRootFromParent_Done,
     /*  594523 */   // Label 9672: @594523
     /*  594523 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(594598), // Rule ID 4548 //
     /*  594528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  594539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  594542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  594545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  594548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594596 */     GIR_RootConstrainSelectedInstOperands,
     /*  594597 */     // GIR_Coverage, 4548,
     /*  594597 */     GIR_EraseRootFromParent_Done,
     /*  594598 */   // Label 9673: @594598
     /*  594598 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(594673), // Rule ID 4549 //
     /*  594603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  594614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  594617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  594620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  594623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594671 */     GIR_RootConstrainSelectedInstOperands,
     /*  594672 */     // GIR_Coverage, 4549,
     /*  594672 */     GIR_EraseRootFromParent_Done,
     /*  594673 */   // Label 9674: @594673
     /*  594673 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(594748), // Rule ID 4558 //
     /*  594678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594746 */     GIR_RootConstrainSelectedInstOperands,
     /*  594747 */     // GIR_Coverage, 4558,
     /*  594747 */     GIR_EraseRootFromParent_Done,
     /*  594748 */   // Label 9675: @594748
     /*  594748 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(594823), // Rule ID 4559 //
     /*  594753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594799 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594821 */     GIR_RootConstrainSelectedInstOperands,
     /*  594822 */     // GIR_Coverage, 4559,
     /*  594822 */     GIR_EraseRootFromParent_Done,
     /*  594823 */   // Label 9676: @594823
     /*  594823 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(594898), // Rule ID 4568 //
     /*  594828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594896 */     GIR_RootConstrainSelectedInstOperands,
     /*  594897 */     // GIR_Coverage, 4568,
     /*  594897 */     GIR_EraseRootFromParent_Done,
     /*  594898 */   // Label 9677: @594898
     /*  594898 */   GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(594973), // Rule ID 4569 //
     /*  594903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594949 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594971 */     GIR_RootConstrainSelectedInstOperands,
     /*  594972 */     // GIR_Coverage, 4569,
     /*  594972 */     GIR_EraseRootFromParent_Done,
     /*  594973 */   // Label 9678: @594973
     /*  594973 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(595048), // Rule ID 4578 //
     /*  594978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  594989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  594992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  594995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  594998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  595024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595046 */     GIR_RootConstrainSelectedInstOperands,
     /*  595047 */     // GIR_Coverage, 4578,
     /*  595047 */     GIR_EraseRootFromParent_Done,
     /*  595048 */   // Label 9679: @595048
     /*  595048 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(595123), // Rule ID 4579 //
     /*  595053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  595064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  595067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  595070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  595073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595099 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  595099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  595118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595121 */     GIR_RootConstrainSelectedInstOperands,
     /*  595122 */     // GIR_Coverage, 4579,
     /*  595122 */     GIR_EraseRootFromParent_Done,
     /*  595123 */   // Label 9680: @595123
     /*  595123 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(595198), // Rule ID 4588 //
     /*  595128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  595139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  595142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  595145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  595148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595196 */     GIR_RootConstrainSelectedInstOperands,
     /*  595197 */     // GIR_Coverage, 4588,
     /*  595197 */     GIR_EraseRootFromParent_Done,
     /*  595198 */   // Label 9681: @595198
     /*  595198 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(595273), // Rule ID 4589 //
     /*  595203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  595214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  595217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  595220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  595223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595249 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  595252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595271 */     GIR_RootConstrainSelectedInstOperands,
     /*  595272 */     // GIR_Coverage, 4589,
     /*  595272 */     GIR_EraseRootFromParent_Done,
     /*  595273 */   // Label 9682: @595273
     /*  595273 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(595348), // Rule ID 4598 //
     /*  595278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  595298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595346 */     GIR_RootConstrainSelectedInstOperands,
     /*  595347 */     // GIR_Coverage, 4598,
     /*  595347 */     GIR_EraseRootFromParent_Done,
     /*  595348 */   // Label 9683: @595348
     /*  595348 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(595423), // Rule ID 4599 //
     /*  595353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  595364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  595367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  595370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  595373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595399 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  595402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595421 */     GIR_RootConstrainSelectedInstOperands,
     /*  595422 */     // GIR_Coverage, 4599,
     /*  595422 */     GIR_EraseRootFromParent_Done,
     /*  595423 */   // Label 9684: @595423
     /*  595423 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(595498), // Rule ID 4608 //
     /*  595428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  595448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595496 */     GIR_RootConstrainSelectedInstOperands,
     /*  595497 */     // GIR_Coverage, 4608,
     /*  595497 */     GIR_EraseRootFromParent_Done,
     /*  595498 */   // Label 9685: @595498
     /*  595498 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(595573), // Rule ID 4609 //
     /*  595503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  595523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595549 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595571 */     GIR_RootConstrainSelectedInstOperands,
     /*  595572 */     // GIR_Coverage, 4609,
     /*  595572 */     GIR_EraseRootFromParent_Done,
     /*  595573 */   // Label 9686: @595573
     /*  595573 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(595648), // Rule ID 4618 //
     /*  595578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  595598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595624 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595646 */     GIR_RootConstrainSelectedInstOperands,
     /*  595647 */     // GIR_Coverage, 4618,
     /*  595647 */     GIR_EraseRootFromParent_Done,
     /*  595648 */   // Label 9687: @595648
     /*  595648 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(595723), // Rule ID 4619 //
     /*  595653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  595673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595699 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595721 */     GIR_RootConstrainSelectedInstOperands,
     /*  595722 */     // GIR_Coverage, 4619,
     /*  595722 */     GIR_EraseRootFromParent_Done,
     /*  595723 */   // Label 9688: @595723
     /*  595723 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(595798), // Rule ID 4626 //
     /*  595728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595774 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  595777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595796 */     GIR_RootConstrainSelectedInstOperands,
     /*  595797 */     // GIR_Coverage, 4626,
     /*  595797 */     GIR_EraseRootFromParent_Done,
     /*  595798 */   // Label 9689: @595798
     /*  595798 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(595873), // Rule ID 4627 //
     /*  595803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595849 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  595852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595871 */     GIR_RootConstrainSelectedInstOperands,
     /*  595872 */     // GIR_Coverage, 4627,
     /*  595872 */     GIR_EraseRootFromParent_Done,
     /*  595873 */   // Label 9690: @595873
     /*  595873 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(595948), // Rule ID 4630 //
     /*  595878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595924 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  595927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595946 */     GIR_RootConstrainSelectedInstOperands,
     /*  595947 */     // GIR_Coverage, 4630,
     /*  595947 */     GIR_EraseRootFromParent_Done,
     /*  595948 */   // Label 9691: @595948
     /*  595948 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(596023), // Rule ID 4631 //
     /*  595953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595999 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596021 */     GIR_RootConstrainSelectedInstOperands,
     /*  596022 */     // GIR_Coverage, 4631,
     /*  596022 */     GIR_EraseRootFromParent_Done,
     /*  596023 */   // Label 9692: @596023
     /*  596023 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(596098), // Rule ID 4634 //
     /*  596028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596096 */     GIR_RootConstrainSelectedInstOperands,
     /*  596097 */     // GIR_Coverage, 4634,
     /*  596097 */     GIR_EraseRootFromParent_Done,
     /*  596098 */   // Label 9693: @596098
     /*  596098 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(596173), // Rule ID 4635 //
     /*  596103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  596114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  596117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  596120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596149 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11641:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596171 */     GIR_RootConstrainSelectedInstOperands,
     /*  596172 */     // GIR_Coverage, 4635,
     /*  596172 */     GIR_EraseRootFromParent_Done,
     /*  596173 */   // Label 9694: @596173
     /*  596173 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(596248), // Rule ID 4638 //
     /*  596178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  596189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  596192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  596195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596246 */     GIR_RootConstrainSelectedInstOperands,
     /*  596247 */     // GIR_Coverage, 4638,
     /*  596247 */     GIR_EraseRootFromParent_Done,
     /*  596248 */   // Label 9695: @596248
     /*  596248 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(596323), // Rule ID 4639 //
     /*  596253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  596264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  596267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  596270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596299 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596321 */     GIR_RootConstrainSelectedInstOperands,
     /*  596322 */     // GIR_Coverage, 4639,
     /*  596322 */     GIR_EraseRootFromParent_Done,
     /*  596323 */   // Label 9696: @596323
     /*  596323 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(596398), // Rule ID 4642 //
     /*  596328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  596339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  596342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  596345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596396 */     GIR_RootConstrainSelectedInstOperands,
     /*  596397 */     // GIR_Coverage, 4642,
     /*  596397 */     GIR_EraseRootFromParent_Done,
     /*  596398 */   // Label 9697: @596398
     /*  596398 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(596473), // Rule ID 4643 //
     /*  596403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  596414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  596417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  596420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596449 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596471 */     GIR_RootConstrainSelectedInstOperands,
     /*  596472 */     // GIR_Coverage, 4643,
     /*  596472 */     GIR_EraseRootFromParent_Done,
     /*  596473 */   // Label 9698: @596473
     /*  596473 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(596548), // Rule ID 4646 //
     /*  596478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  596489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  596492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  596495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  596527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596546 */     GIR_RootConstrainSelectedInstOperands,
     /*  596547 */     // GIR_Coverage, 4646,
     /*  596547 */     GIR_EraseRootFromParent_Done,
     /*  596548 */   // Label 9699: @596548
     /*  596548 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(596623), // Rule ID 4647 //
     /*  596553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  596564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  596567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  596570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596599 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  596602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596621 */     GIR_RootConstrainSelectedInstOperands,
     /*  596622 */     // GIR_Coverage, 4647,
     /*  596622 */     GIR_EraseRootFromParent_Done,
     /*  596623 */   // Label 9700: @596623
     /*  596623 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(596698), // Rule ID 4650 //
     /*  596628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596674 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596696 */     GIR_RootConstrainSelectedInstOperands,
     /*  596697 */     // GIR_Coverage, 4650,
     /*  596697 */     GIR_EraseRootFromParent_Done,
     /*  596698 */   // Label 9701: @596698
     /*  596698 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(596773), // Rule ID 4651 //
     /*  596703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596749 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596771 */     GIR_RootConstrainSelectedInstOperands,
     /*  596772 */     // GIR_Coverage, 4651,
     /*  596772 */     GIR_EraseRootFromParent_Done,
     /*  596773 */   // Label 9702: @596773
     /*  596773 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(596848), // Rule ID 4654 //
     /*  596778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596846 */     GIR_RootConstrainSelectedInstOperands,
     /*  596847 */     // GIR_Coverage, 4654,
     /*  596847 */     GIR_EraseRootFromParent_Done,
     /*  596848 */   // Label 9703: @596848
     /*  596848 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(596923), // Rule ID 4655 //
     /*  596853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11641:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596921 */     GIR_RootConstrainSelectedInstOperands,
     /*  596922 */     // GIR_Coverage, 4655,
     /*  596922 */     GIR_EraseRootFromParent_Done,
     /*  596923 */   // Label 9704: @596923
     /*  596923 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(596998), // Rule ID 4658 //
     /*  596928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  596939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  596942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  596945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596996 */     GIR_RootConstrainSelectedInstOperands,
     /*  596997 */     // GIR_Coverage, 4658,
     /*  596997 */     GIR_EraseRootFromParent_Done,
     /*  596998 */   // Label 9705: @596998
     /*  596998 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(597073), // Rule ID 4659 //
     /*  597003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  597014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  597017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  597020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597071 */     GIR_RootConstrainSelectedInstOperands,
     /*  597072 */     // GIR_Coverage, 4659,
     /*  597072 */     GIR_EraseRootFromParent_Done,
     /*  597073 */   // Label 9706: @597073
     /*  597073 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(597148), // Rule ID 4662 //
     /*  597078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  597089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  597092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  597095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597124 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597146 */     GIR_RootConstrainSelectedInstOperands,
     /*  597147 */     // GIR_Coverage, 4662,
     /*  597147 */     GIR_EraseRootFromParent_Done,
     /*  597148 */   // Label 9707: @597148
     /*  597148 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(597223), // Rule ID 4663 //
     /*  597153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  597164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  597167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  597170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597199 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597221 */     GIR_RootConstrainSelectedInstOperands,
     /*  597222 */     // GIR_Coverage, 4663,
     /*  597222 */     GIR_EraseRootFromParent_Done,
     /*  597223 */   // Label 9708: @597223
     /*  597223 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(597298), // Rule ID 4666 //
     /*  597228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  597239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  597242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  597245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  597274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597296 */     GIR_RootConstrainSelectedInstOperands,
     /*  597297 */     // GIR_Coverage, 4666,
     /*  597297 */     GIR_EraseRootFromParent_Done,
     /*  597298 */   // Label 9709: @597298
     /*  597298 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(597373), // Rule ID 4667 //
     /*  597303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  597314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  597317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  597320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597349 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  597349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  597368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597371 */     GIR_RootConstrainSelectedInstOperands,
     /*  597372 */     // GIR_Coverage, 4667,
     /*  597372 */     GIR_EraseRootFromParent_Done,
     /*  597373 */   // Label 9710: @597373
     /*  597373 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(597448), // Rule ID 4670 //
     /*  597378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  597389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  597392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  597395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597446 */     GIR_RootConstrainSelectedInstOperands,
     /*  597447 */     // GIR_Coverage, 4670,
     /*  597447 */     GIR_EraseRootFromParent_Done,
     /*  597448 */   // Label 9711: @597448
     /*  597448 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(597523), // Rule ID 4671 //
     /*  597453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  597464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  597467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  597470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597499 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11641:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  597502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597521 */     GIR_RootConstrainSelectedInstOperands,
     /*  597522 */     // GIR_Coverage, 4671,
     /*  597522 */     GIR_EraseRootFromParent_Done,
     /*  597523 */   // Label 9712: @597523
     /*  597523 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(597598), // Rule ID 4674 //
     /*  597528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  597539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  597542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  597545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597574 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597596 */     GIR_RootConstrainSelectedInstOperands,
     /*  597597 */     // GIR_Coverage, 4674,
     /*  597597 */     GIR_EraseRootFromParent_Done,
     /*  597598 */   // Label 9713: @597598
     /*  597598 */   GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(597673), // Rule ID 4675 //
     /*  597603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  597614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  597617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  597620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11641:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597671 */     GIR_RootConstrainSelectedInstOperands,
     /*  597672 */     // GIR_Coverage, 4675,
     /*  597672 */     GIR_EraseRootFromParent_Done,
     /*  597673 */   // Label 9714: @597673
     /*  597673 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(597748), // Rule ID 4678 //
     /*  597678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597724 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597746 */     GIR_RootConstrainSelectedInstOperands,
     /*  597747 */     // GIR_Coverage, 4678,
     /*  597747 */     GIR_EraseRootFromParent_Done,
     /*  597748 */   // Label 9715: @597748
     /*  597748 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(597823), // Rule ID 4679 //
     /*  597753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597799 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11641:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597821 */     GIR_RootConstrainSelectedInstOperands,
     /*  597822 */     // GIR_Coverage, 4679,
     /*  597822 */     GIR_EraseRootFromParent_Done,
     /*  597823 */   // Label 9716: @597823
     /*  597823 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(597898), // Rule ID 4682 //
     /*  597828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597896 */     GIR_RootConstrainSelectedInstOperands,
     /*  597897 */     // GIR_Coverage, 4682,
     /*  597897 */     GIR_EraseRootFromParent_Done,
     /*  597898 */   // Label 9717: @597898
     /*  597898 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(597973), // Rule ID 4683 //
     /*  597903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597949 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11641:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597971 */     GIR_RootConstrainSelectedInstOperands,
     /*  597972 */     // GIR_Coverage, 4683,
     /*  597972 */     GIR_EraseRootFromParent_Done,
     /*  597973 */   // Label 9718: @597973
     /*  597973 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(598048), // Rule ID 4688 //
     /*  597978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  597986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  597989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  597992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  597995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  597998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598024 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  598027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598046 */     GIR_RootConstrainSelectedInstOperands,
     /*  598047 */     // GIR_Coverage, 4688,
     /*  598047 */     GIR_EraseRootFromParent_Done,
     /*  598048 */   // Label 9719: @598048
     /*  598048 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(598123), // Rule ID 4689 //
     /*  598053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  598064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  598067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  598070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  598073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598099 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  598102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598121 */     GIR_RootConstrainSelectedInstOperands,
     /*  598122 */     // GIR_Coverage, 4689,
     /*  598122 */     GIR_EraseRootFromParent_Done,
     /*  598123 */   // Label 9720: @598123
     /*  598123 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(598198), // Rule ID 4698 //
     /*  598128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  598139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  598142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  598145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  598148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598196 */     GIR_RootConstrainSelectedInstOperands,
     /*  598197 */     // GIR_Coverage, 4698,
     /*  598197 */     GIR_EraseRootFromParent_Done,
     /*  598198 */   // Label 9721: @598198
     /*  598198 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(598273), // Rule ID 4699 //
     /*  598203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  598214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  598217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  598220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  598223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598249 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598271 */     GIR_RootConstrainSelectedInstOperands,
     /*  598272 */     // GIR_Coverage, 4699,
     /*  598272 */     GIR_EraseRootFromParent_Done,
     /*  598273 */   // Label 9722: @598273
     /*  598273 */   GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(598348), // Rule ID 4708 //
     /*  598278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  598289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  598292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  598295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  598298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598324 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598346 */     GIR_RootConstrainSelectedInstOperands,
     /*  598347 */     // GIR_Coverage, 4708,
     /*  598347 */     GIR_EraseRootFromParent_Done,
     /*  598348 */   // Label 9723: @598348
     /*  598348 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(598423), // Rule ID 4709 //
     /*  598353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  598364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  598367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  598370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  598373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598399 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598421 */     GIR_RootConstrainSelectedInstOperands,
     /*  598422 */     // GIR_Coverage, 4709,
     /*  598422 */     GIR_EraseRootFromParent_Done,
     /*  598423 */   // Label 9724: @598423
     /*  598423 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(598498), // Rule ID 4718 //
     /*  598428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  598439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  598442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  598445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  598448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598474 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  598477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598496 */     GIR_RootConstrainSelectedInstOperands,
     /*  598497 */     // GIR_Coverage, 4718,
     /*  598497 */     GIR_EraseRootFromParent_Done,
     /*  598498 */   // Label 9725: @598498
     /*  598498 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(598573), // Rule ID 4719 //
     /*  598503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  598514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  598517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  598520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  598523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598549 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  598552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598571 */     GIR_RootConstrainSelectedInstOperands,
     /*  598572 */     // GIR_Coverage, 4719,
     /*  598572 */     GIR_EraseRootFromParent_Done,
     /*  598573 */   // Label 9726: @598573
     /*  598573 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(598648), // Rule ID 4728 //
     /*  598578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  598589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  598592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  598595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  598598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  598627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598646 */     GIR_RootConstrainSelectedInstOperands,
     /*  598647 */     // GIR_Coverage, 4728,
     /*  598647 */     GIR_EraseRootFromParent_Done,
     /*  598648 */   // Label 9727: @598648
     /*  598648 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(598723), // Rule ID 4729 //
     /*  598653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  598664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  598667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  598670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  598673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598699 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  598702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598721 */     GIR_RootConstrainSelectedInstOperands,
     /*  598722 */     // GIR_Coverage, 4729,
     /*  598722 */     GIR_EraseRootFromParent_Done,
     /*  598723 */   // Label 9728: @598723
     /*  598723 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(598798), // Rule ID 4738 //
     /*  598728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  598777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598796 */     GIR_RootConstrainSelectedInstOperands,
     /*  598797 */     // GIR_Coverage, 4738,
     /*  598797 */     GIR_EraseRootFromParent_Done,
     /*  598798 */   // Label 9729: @598798
     /*  598798 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(598873), // Rule ID 4739 //
     /*  598803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598849 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  598852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598871 */     GIR_RootConstrainSelectedInstOperands,
     /*  598872 */     // GIR_Coverage, 4739,
     /*  598872 */     GIR_EraseRootFromParent_Done,
     /*  598873 */   // Label 9730: @598873
     /*  598873 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(598948), // Rule ID 4748 //
     /*  598878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598946 */     GIR_RootConstrainSelectedInstOperands,
     /*  598947 */     // GIR_Coverage, 4748,
     /*  598947 */     GIR_EraseRootFromParent_Done,
     /*  598948 */   // Label 9731: @598948
     /*  598948 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(599023), // Rule ID 4749 //
     /*  598953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598999 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  599002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599021 */     GIR_RootConstrainSelectedInstOperands,
     /*  599022 */     // GIR_Coverage, 4749,
     /*  599022 */     GIR_EraseRootFromParent_Done,
     /*  599023 */   // Label 9732: @599023
     /*  599023 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(599098), // Rule ID 4758 //
     /*  599028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  599039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  599042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  599045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  599048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599096 */     GIR_RootConstrainSelectedInstOperands,
     /*  599097 */     // GIR_Coverage, 4758,
     /*  599097 */     GIR_EraseRootFromParent_Done,
     /*  599098 */   // Label 9733: @599098
     /*  599098 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(599173), // Rule ID 4759 //
     /*  599103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  599114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  599117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  599120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  599123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599149 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599171 */     GIR_RootConstrainSelectedInstOperands,
     /*  599172 */     // GIR_Coverage, 4759,
     /*  599172 */     GIR_EraseRootFromParent_Done,
     /*  599173 */   // Label 9734: @599173
     /*  599173 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(599248), // Rule ID 4768 //
     /*  599178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  599189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  599192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  599195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  599198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599246 */     GIR_RootConstrainSelectedInstOperands,
     /*  599247 */     // GIR_Coverage, 4768,
     /*  599247 */     GIR_EraseRootFromParent_Done,
     /*  599248 */   // Label 9735: @599248
     /*  599248 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(599323), // Rule ID 4769 //
     /*  599253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  599264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  599267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  599270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  599273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599299 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599321 */     GIR_RootConstrainSelectedInstOperands,
     /*  599322 */     // GIR_Coverage, 4769,
     /*  599322 */     GIR_EraseRootFromParent_Done,
     /*  599323 */   // Label 9736: @599323
     /*  599323 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(599398), // Rule ID 4778 //
     /*  599328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  599339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  599342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  599345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  599348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599396 */     GIR_RootConstrainSelectedInstOperands,
     /*  599397 */     // GIR_Coverage, 4778,
     /*  599397 */     GIR_EraseRootFromParent_Done,
     /*  599398 */   // Label 9737: @599398
     /*  599398 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(599473), // Rule ID 4779 //
     /*  599403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  599414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  599417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  599420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  599423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599449 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599471 */     GIR_RootConstrainSelectedInstOperands,
     /*  599472 */     // GIR_Coverage, 4779,
     /*  599472 */     GIR_EraseRootFromParent_Done,
     /*  599473 */   // Label 9738: @599473
     /*  599473 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(599548), // Rule ID 4788 //
     /*  599478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  599489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  599492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  599495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  599498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599546 */     GIR_RootConstrainSelectedInstOperands,
     /*  599547 */     // GIR_Coverage, 4788,
     /*  599547 */     GIR_EraseRootFromParent_Done,
     /*  599548 */   // Label 9739: @599548
     /*  599548 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(599623), // Rule ID 4789 //
     /*  599553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  599564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  599567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  599570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  599573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599599 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599621 */     GIR_RootConstrainSelectedInstOperands,
     /*  599622 */     // GIR_Coverage, 4789,
     /*  599622 */     GIR_EraseRootFromParent_Done,
     /*  599623 */   // Label 9740: @599623
     /*  599623 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(599698), // Rule ID 4798 //
     /*  599628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  599639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  599642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  599645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  599648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599696 */     GIR_RootConstrainSelectedInstOperands,
     /*  599697 */     // GIR_Coverage, 4798,
     /*  599697 */     GIR_EraseRootFromParent_Done,
     /*  599698 */   // Label 9741: @599698
     /*  599698 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(599773), // Rule ID 4799 //
     /*  599703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  599714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  599717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  599720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  599723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599749 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599771 */     GIR_RootConstrainSelectedInstOperands,
     /*  599772 */     // GIR_Coverage, 4799,
     /*  599772 */     GIR_EraseRootFromParent_Done,
     /*  599773 */   // Label 9742: @599773
     /*  599773 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(599848), // Rule ID 4808 //
     /*  599778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599846 */     GIR_RootConstrainSelectedInstOperands,
     /*  599847 */     // GIR_Coverage, 4808,
     /*  599847 */     GIR_EraseRootFromParent_Done,
     /*  599848 */   // Label 9743: @599848
     /*  599848 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(599923), // Rule ID 4809 //
     /*  599853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599921 */     GIR_RootConstrainSelectedInstOperands,
     /*  599922 */     // GIR_Coverage, 4809,
     /*  599922 */     GIR_EraseRootFromParent_Done,
     /*  599923 */   // Label 9744: @599923
     /*  599923 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(599998), // Rule ID 4818 //
     /*  599928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  599939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  599942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  599945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  599948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599996 */     GIR_RootConstrainSelectedInstOperands,
     /*  599997 */     // GIR_Coverage, 4818,
     /*  599997 */     GIR_EraseRootFromParent_Done,
     /*  599998 */   // Label 9745: @599998
     /*  599998 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(600073), // Rule ID 4819 //
     /*  600003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  600014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  600017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  600020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  600023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600049 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  600052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600071 */     GIR_RootConstrainSelectedInstOperands,
     /*  600072 */     // GIR_Coverage, 4819,
     /*  600072 */     GIR_EraseRootFromParent_Done,
     /*  600073 */   // Label 9746: @600073
     /*  600073 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(600148), // Rule ID 4828 //
     /*  600078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  600081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  600089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  600092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  600095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  600098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  600124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600146 */     GIR_RootConstrainSelectedInstOperands,
     /*  600147 */     // GIR_Coverage, 4828,
     /*  600147 */     GIR_EraseRootFromParent_Done,
     /*  600148 */   // Label 9747: @600148
     /*  600148 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(600223), // Rule ID 4829 //
     /*  600153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  600156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  600164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  600167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  600170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  600173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600199 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  600199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  600202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  600218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600221 */     GIR_RootConstrainSelectedInstOperands,
     /*  600222 */     // GIR_Coverage, 4829,
     /*  600222 */     GIR_EraseRootFromParent_Done,
     /*  600223 */   // Label 9748: @600223
     /*  600223 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(600298), // Rule ID 4836 //
     /*  600228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  600239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  600242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  600245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600274 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  600277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600296 */     GIR_RootConstrainSelectedInstOperands,
     /*  600297 */     // GIR_Coverage, 4836,
     /*  600297 */     GIR_EraseRootFromParent_Done,
     /*  600298 */   // Label 9749: @600298
     /*  600298 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(600373), // Rule ID 4837 //
     /*  600303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  600314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  600317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  600320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600349 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  600352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600371 */     GIR_RootConstrainSelectedInstOperands,
     /*  600372 */     // GIR_Coverage, 4837,
     /*  600372 */     GIR_EraseRootFromParent_Done,
     /*  600373 */   // Label 9750: @600373
     /*  600373 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(600448), // Rule ID 4840 //
     /*  600378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  600389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  600392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  600395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600424 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600446 */     GIR_RootConstrainSelectedInstOperands,
     /*  600447 */     // GIR_Coverage, 4840,
     /*  600447 */     GIR_EraseRootFromParent_Done,
     /*  600448 */   // Label 9751: @600448
     /*  600448 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(600523), // Rule ID 4841 //
     /*  600453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  600464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  600467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  600470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600499 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600521 */     GIR_RootConstrainSelectedInstOperands,
     /*  600522 */     // GIR_Coverage, 4841,
     /*  600522 */     GIR_EraseRootFromParent_Done,
     /*  600523 */   // Label 9752: @600523
     /*  600523 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(600598), // Rule ID 4844 //
     /*  600528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  600539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  600542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  600545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600574 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  600577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600596 */     GIR_RootConstrainSelectedInstOperands,
     /*  600597 */     // GIR_Coverage, 4844,
     /*  600597 */     GIR_EraseRootFromParent_Done,
     /*  600598 */   // Label 9753: @600598
     /*  600598 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(600673), // Rule ID 4845 //
     /*  600603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  600614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  600617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  600620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600649 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11669:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  600652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600671 */     GIR_RootConstrainSelectedInstOperands,
     /*  600672 */     // GIR_Coverage, 4845,
     /*  600672 */     GIR_EraseRootFromParent_Done,
     /*  600673 */   // Label 9754: @600673
     /*  600673 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(600748), // Rule ID 4848 //
     /*  600678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  600727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600746 */     GIR_RootConstrainSelectedInstOperands,
     /*  600747 */     // GIR_Coverage, 4848,
     /*  600747 */     GIR_EraseRootFromParent_Done,
     /*  600748 */   // Label 9755: @600748
     /*  600748 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(600823), // Rule ID 4849 //
     /*  600753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  600802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600821 */     GIR_RootConstrainSelectedInstOperands,
     /*  600822 */     // GIR_Coverage, 4849,
     /*  600822 */     GIR_EraseRootFromParent_Done,
     /*  600823 */   // Label 9756: @600823
     /*  600823 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(600898), // Rule ID 4852 //
     /*  600828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  600877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600896 */     GIR_RootConstrainSelectedInstOperands,
     /*  600897 */     // GIR_Coverage, 4852,
     /*  600897 */     GIR_EraseRootFromParent_Done,
     /*  600898 */   // Label 9757: @600898
     /*  600898 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(600973), // Rule ID 4853 //
     /*  600903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600949 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  600952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600971 */     GIR_RootConstrainSelectedInstOperands,
     /*  600972 */     // GIR_Coverage, 4853,
     /*  600972 */     GIR_EraseRootFromParent_Done,
     /*  600973 */   // Label 9758: @600973
     /*  600973 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(601048), // Rule ID 4856 //
     /*  600978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  600989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  600992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  600995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601024 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  601024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601046 */     GIR_RootConstrainSelectedInstOperands,
     /*  601047 */     // GIR_Coverage, 4856,
     /*  601047 */     GIR_EraseRootFromParent_Done,
     /*  601048 */   // Label 9759: @601048
     /*  601048 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(601123), // Rule ID 4857 //
     /*  601053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  601064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  601067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  601070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  601099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  601118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601121 */     GIR_RootConstrainSelectedInstOperands,
     /*  601122 */     // GIR_Coverage, 4857,
     /*  601122 */     GIR_EraseRootFromParent_Done,
     /*  601123 */   // Label 9760: @601123
     /*  601123 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(601198), // Rule ID 4860 //
     /*  601128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  601139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  601142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  601145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  601177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601196 */     GIR_RootConstrainSelectedInstOperands,
     /*  601197 */     // GIR_Coverage, 4860,
     /*  601197 */     GIR_EraseRootFromParent_Done,
     /*  601198 */   // Label 9761: @601198
     /*  601198 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(601273), // Rule ID 4861 //
     /*  601203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  601214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  601217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  601220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  601252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601271 */     GIR_RootConstrainSelectedInstOperands,
     /*  601272 */     // GIR_Coverage, 4861,
     /*  601272 */     GIR_EraseRootFromParent_Done,
     /*  601273 */   // Label 9762: @601273
     /*  601273 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(601348), // Rule ID 4864 //
     /*  601278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  601289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  601292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  601295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601346 */     GIR_RootConstrainSelectedInstOperands,
     /*  601347 */     // GIR_Coverage, 4864,
     /*  601347 */     GIR_EraseRootFromParent_Done,
     /*  601348 */   // Label 9763: @601348
     /*  601348 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(601423), // Rule ID 4865 //
     /*  601353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  601364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  601367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  601370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601399 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11669:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601421 */     GIR_RootConstrainSelectedInstOperands,
     /*  601422 */     // GIR_Coverage, 4865,
     /*  601422 */     GIR_EraseRootFromParent_Done,
     /*  601423 */   // Label 9764: @601423
     /*  601423 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(601498), // Rule ID 4868 //
     /*  601428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601474 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601496 */     GIR_RootConstrainSelectedInstOperands,
     /*  601497 */     // GIR_Coverage, 4868,
     /*  601497 */     GIR_EraseRootFromParent_Done,
     /*  601498 */   // Label 9765: @601498
     /*  601498 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(601573), // Rule ID 4869 //
     /*  601503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601571 */     GIR_RootConstrainSelectedInstOperands,
     /*  601572 */     // GIR_Coverage, 4869,
     /*  601572 */     GIR_EraseRootFromParent_Done,
     /*  601573 */   // Label 9766: @601573
     /*  601573 */   GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(601648), // Rule ID 4872 //
     /*  601578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601646 */     GIR_RootConstrainSelectedInstOperands,
     /*  601647 */     // GIR_Coverage, 4872,
     /*  601647 */     GIR_EraseRootFromParent_Done,
     /*  601648 */   // Label 9767: @601648
     /*  601648 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(601723), // Rule ID 4873 //
     /*  601653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601699 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601721 */     GIR_RootConstrainSelectedInstOperands,
     /*  601722 */     // GIR_Coverage, 4873,
     /*  601722 */     GIR_EraseRootFromParent_Done,
     /*  601723 */   // Label 9768: @601723
     /*  601723 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(601798), // Rule ID 4876 //
     /*  601728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601796 */     GIR_RootConstrainSelectedInstOperands,
     /*  601797 */     // GIR_Coverage, 4876,
     /*  601797 */     GIR_EraseRootFromParent_Done,
     /*  601798 */   // Label 9769: @601798
     /*  601798 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(601873), // Rule ID 4877 //
     /*  601803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601849 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601871 */     GIR_RootConstrainSelectedInstOperands,
     /*  601872 */     // GIR_Coverage, 4877,
     /*  601872 */     GIR_EraseRootFromParent_Done,
     /*  601873 */   // Label 9770: @601873
     /*  601873 */   GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(601948), // Rule ID 4880 //
     /*  601878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601946 */     GIR_RootConstrainSelectedInstOperands,
     /*  601947 */     // GIR_Coverage, 4880,
     /*  601947 */     GIR_EraseRootFromParent_Done,
     /*  601948 */   // Label 9771: @601948
     /*  601948 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(602023), // Rule ID 4881 //
     /*  601953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11669:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  602002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602021 */     GIR_RootConstrainSelectedInstOperands,
     /*  602022 */     // GIR_Coverage, 4881,
     /*  602022 */     GIR_EraseRootFromParent_Done,
     /*  602023 */   // Label 9772: @602023
     /*  602023 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(602098), // Rule ID 4884 //
     /*  602028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  602039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  602042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  602045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602074 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602096 */     GIR_RootConstrainSelectedInstOperands,
     /*  602097 */     // GIR_Coverage, 4884,
     /*  602097 */     GIR_EraseRootFromParent_Done,
     /*  602098 */   // Label 9773: @602098
     /*  602098 */   GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(602173), // Rule ID 4885 //
     /*  602103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  602114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  602117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  602120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  602138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11669:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  602152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602171 */     GIR_RootConstrainSelectedInstOperands,
     /*  602172 */     // GIR_Coverage, 4885,
     /*  602172 */     GIR_EraseRootFromParent_Done,
     /*  602173 */   // Label 9774: @602173
     /*  602173 */   GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(602248), // Rule ID 4888 //
     /*  602178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  602189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  602192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  602195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602246 */     GIR_RootConstrainSelectedInstOperands,
     /*  602247 */     // GIR_Coverage, 4888,
     /*  602247 */     GIR_EraseRootFromParent_Done,
     /*  602248 */   // Label 9775: @602248
     /*  602248 */   GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(602323), // Rule ID 4889 //
     /*  602253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  602264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  602267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  602270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  602288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602299 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11669:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  602302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602321 */     GIR_RootConstrainSelectedInstOperands,
     /*  602322 */     // GIR_Coverage, 4889,
     /*  602322 */     GIR_EraseRootFromParent_Done,
     /*  602323 */   // Label 9776: @602323
     /*  602323 */   GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(602398), // Rule ID 4892 //
     /*  602328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  602331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  602348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  602374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602396 */     GIR_RootConstrainSelectedInstOperands,
     /*  602397 */     // GIR_Coverage, 4892,
     /*  602397 */     GIR_EraseRootFromParent_Done,
     /*  602398 */   // Label 9777: @602398
     /*  602398 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(602473), // Rule ID 4893 //
     /*  602403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  602406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  602411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  602414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  602417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  602420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  602423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  602438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  602442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602449 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11669:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  602449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  602452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  602456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  602458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  602460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  602471 */     GIR_RootConstrainSelectedInstOperands,
     /*  602472 */     // GIR_Coverage, 4893,
     /*  602472 */     GIR_EraseRootFromParent_Done,
     /*  602473 */   // Label 9778: @602473
     /*  602473 */   GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(602545), // Rule ID 5246 //
     /*  602478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  602492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  602495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602524 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  602524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602543 */     GIR_RootConstrainSelectedInstOperands,
     /*  602544 */     // GIR_Coverage, 5246,
     /*  602544 */     GIR_EraseRootFromParent_Done,
     /*  602545 */   // Label 9779: @602545
     /*  602545 */   GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(602617), // Rule ID 5247 //
     /*  602550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  602564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  602567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602596 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  602596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602615 */     GIR_RootConstrainSelectedInstOperands,
     /*  602616 */     // GIR_Coverage, 5247,
     /*  602616 */     GIR_EraseRootFromParent_Done,
     /*  602617 */   // Label 9780: @602617
     /*  602617 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(602689), // Rule ID 5248 //
     /*  602622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  602633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  602636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  602639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  602642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  602668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602687 */     GIR_RootConstrainSelectedInstOperands,
     /*  602688 */     // GIR_Coverage, 5248,
     /*  602688 */     GIR_EraseRootFromParent_Done,
     /*  602689 */   // Label 9781: @602689
     /*  602689 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(602761), // Rule ID 5249 //
     /*  602694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  602705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  602708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  602711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  602714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602740 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  602740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602759 */     GIR_RootConstrainSelectedInstOperands,
     /*  602760 */     // GIR_Coverage, 5249,
     /*  602760 */     GIR_EraseRootFromParent_Done,
     /*  602761 */   // Label 9782: @602761
     /*  602761 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(602833), // Rule ID 5250 //
     /*  602766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  602777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  602780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  602783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  602786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602812 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  602812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602831 */     GIR_RootConstrainSelectedInstOperands,
     /*  602832 */     // GIR_Coverage, 5250,
     /*  602832 */     GIR_EraseRootFromParent_Done,
     /*  602833 */   // Label 9783: @602833
     /*  602833 */   GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(602905), // Rule ID 5251 //
     /*  602838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  602849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  602852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  602855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  602858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  602884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602903 */     GIR_RootConstrainSelectedInstOperands,
     /*  602904 */     // GIR_Coverage, 5251,
     /*  602904 */     GIR_EraseRootFromParent_Done,
     /*  602905 */   // Label 9784: @602905
     /*  602905 */   GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(602977), // Rule ID 5252 //
     /*  602910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  602924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  602927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602956 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  602956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602975 */     GIR_RootConstrainSelectedInstOperands,
     /*  602976 */     // GIR_Coverage, 5252,
     /*  602976 */     GIR_EraseRootFromParent_Done,
     /*  602977 */   // Label 9785: @602977
     /*  602977 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(603049), // Rule ID 5253 //
     /*  602982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  602996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  602999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603028 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603047 */     GIR_RootConstrainSelectedInstOperands,
     /*  603048 */     // GIR_Coverage, 5253,
     /*  603048 */     GIR_EraseRootFromParent_Done,
     /*  603049 */   // Label 9786: @603049
     /*  603049 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(603121), // Rule ID 5254 //
     /*  603054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  603068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  603071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603100 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  603100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603119 */     GIR_RootConstrainSelectedInstOperands,
     /*  603120 */     // GIR_Coverage, 5254,
     /*  603120 */     GIR_EraseRootFromParent_Done,
     /*  603121 */   // Label 9787: @603121
     /*  603121 */   GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(603193), // Rule ID 5255 //
     /*  603126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  603140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  603143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603172 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  603172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  603175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603191 */     GIR_RootConstrainSelectedInstOperands,
     /*  603192 */     // GIR_Coverage, 5255,
     /*  603192 */     GIR_EraseRootFromParent_Done,
     /*  603193 */   // Label 9788: @603193
     /*  603193 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(603265), // Rule ID 5256 //
     /*  603198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603263 */     GIR_RootConstrainSelectedInstOperands,
     /*  603264 */     // GIR_Coverage, 5256,
     /*  603264 */     GIR_EraseRootFromParent_Done,
     /*  603265 */   // Label 9789: @603265
     /*  603265 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(603337), // Rule ID 5257 //
     /*  603270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  603284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  603287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603316 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603335 */     GIR_RootConstrainSelectedInstOperands,
     /*  603336 */     // GIR_Coverage, 5257,
     /*  603336 */     GIR_EraseRootFromParent_Done,
     /*  603337 */   // Label 9790: @603337
     /*  603337 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(603409), // Rule ID 5258 //
     /*  603342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603388 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603407 */     GIR_RootConstrainSelectedInstOperands,
     /*  603408 */     // GIR_Coverage, 5258,
     /*  603408 */     GIR_EraseRootFromParent_Done,
     /*  603409 */   // Label 9791: @603409
     /*  603409 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(603481), // Rule ID 5259 //
     /*  603414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  603425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  603428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  603431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  603434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603479 */     GIR_RootConstrainSelectedInstOperands,
     /*  603480 */     // GIR_Coverage, 5259,
     /*  603480 */     GIR_EraseRootFromParent_Done,
     /*  603481 */   // Label 9792: @603481
     /*  603481 */   GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(603553), // Rule ID 5260 //
     /*  603486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  603500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  603503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  603532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603551 */     GIR_RootConstrainSelectedInstOperands,
     /*  603552 */     // GIR_Coverage, 5260,
     /*  603552 */     GIR_EraseRootFromParent_Done,
     /*  603553 */   // Label 9793: @603553
     /*  603553 */   GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(603625), // Rule ID 5261 //
     /*  603558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  603572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  603575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  603604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603623 */     GIR_RootConstrainSelectedInstOperands,
     /*  603624 */     // GIR_Coverage, 5261,
     /*  603624 */     GIR_EraseRootFromParent_Done,
     /*  603625 */   // Label 9794: @603625
     /*  603625 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(603697), // Rule ID 5262 //
     /*  603630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  603633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603676 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  603676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  603695 */     GIR_RootConstrainSelectedInstOperands,
     /*  603696 */     // GIR_Coverage, 5262,
     /*  603696 */     GIR_EraseRootFromParent_Done,
     /*  603697 */   // Label 9795: @603697
     /*  603697 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(603769), // Rule ID 5263 //
     /*  603702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  603705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  603748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  603767 */     GIR_RootConstrainSelectedInstOperands,
     /*  603768 */     // GIR_Coverage, 5263,
     /*  603768 */     GIR_EraseRootFromParent_Done,
     /*  603769 */   // Label 9796: @603769
     /*  603769 */   GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(603841), // Rule ID 5264 //
     /*  603774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  603785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  603788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  603791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  603794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603820 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  603823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603839 */     GIR_RootConstrainSelectedInstOperands,
     /*  603840 */     // GIR_Coverage, 5264,
     /*  603840 */     GIR_EraseRootFromParent_Done,
     /*  603841 */   // Label 9797: @603841
     /*  603841 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(603913), // Rule ID 5265 //
     /*  603846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  603857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  603860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  603863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  603866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603892 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  603895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603911 */     GIR_RootConstrainSelectedInstOperands,
     /*  603912 */     // GIR_Coverage, 5265,
     /*  603912 */     GIR_EraseRootFromParent_Done,
     /*  603913 */   // Label 9798: @603913
     /*  603913 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(603985), // Rule ID 5266 //
     /*  603918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  603929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  603932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  603935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  603938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603964 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  603967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603983 */     GIR_RootConstrainSelectedInstOperands,
     /*  603984 */     // GIR_Coverage, 5266,
     /*  603984 */     GIR_EraseRootFromParent_Done,
     /*  603985 */   // Label 9799: @603985
     /*  603985 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(604057), // Rule ID 5267 //
     /*  603990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  604004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  604007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604036 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604055 */     GIR_RootConstrainSelectedInstOperands,
     /*  604056 */     // GIR_Coverage, 5267,
     /*  604056 */     GIR_EraseRootFromParent_Done,
     /*  604057 */   // Label 9800: @604057
     /*  604057 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(604129), // Rule ID 5268 //
     /*  604062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  604073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  604076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  604079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  604082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604108 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  604108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604127 */     GIR_RootConstrainSelectedInstOperands,
     /*  604128 */     // GIR_Coverage, 5268,
     /*  604128 */     GIR_EraseRootFromParent_Done,
     /*  604129 */   // Label 9801: @604129
     /*  604129 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(604201), // Rule ID 5269 //
     /*  604134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  604145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  604148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  604151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  604154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604180 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  604180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  604199 */     GIR_RootConstrainSelectedInstOperands,
     /*  604200 */     // GIR_Coverage, 5269,
     /*  604200 */     GIR_EraseRootFromParent_Done,
     /*  604201 */   // Label 9802: @604201
     /*  604201 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(604273), // Rule ID 5270 //
     /*  604206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604252 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604271 */     GIR_RootConstrainSelectedInstOperands,
     /*  604272 */     // GIR_Coverage, 5270,
     /*  604272 */     GIR_EraseRootFromParent_Done,
     /*  604273 */   // Label 9803: @604273
     /*  604273 */   GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(604345), // Rule ID 5271 //
     /*  604278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  604292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  604295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604324 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604343 */     GIR_RootConstrainSelectedInstOperands,
     /*  604344 */     // GIR_Coverage, 5271,
     /*  604344 */     GIR_EraseRootFromParent_Done,
     /*  604345 */   // Label 9804: @604345
     /*  604345 */   GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(604417), // Rule ID 5272 //
     /*  604350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604415 */     GIR_RootConstrainSelectedInstOperands,
     /*  604416 */     // GIR_Coverage, 5272,
     /*  604416 */     GIR_EraseRootFromParent_Done,
     /*  604417 */   // Label 9805: @604417
     /*  604417 */   GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(604489), // Rule ID 5273 //
     /*  604422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  604436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  604439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604468 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604487 */     GIR_RootConstrainSelectedInstOperands,
     /*  604488 */     // GIR_Coverage, 5273,
     /*  604488 */     GIR_EraseRootFromParent_Done,
     /*  604489 */   // Label 9806: @604489
     /*  604489 */   GIM_Try, /*On fail goto*//*Label 9807*/ GIMT_Encode4(604561), // Rule ID 5274 //
     /*  604494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604540 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604559 */     GIR_RootConstrainSelectedInstOperands,
     /*  604560 */     // GIR_Coverage, 5274,
     /*  604560 */     GIR_EraseRootFromParent_Done,
     /*  604561 */   // Label 9807: @604561
     /*  604561 */   GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(604633), // Rule ID 5275 //
     /*  604566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604612 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604631 */     GIR_RootConstrainSelectedInstOperands,
     /*  604632 */     // GIR_Coverage, 5275,
     /*  604632 */     GIR_EraseRootFromParent_Done,
     /*  604633 */   // Label 9808: @604633
     /*  604633 */   GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(604705), // Rule ID 5276 //
     /*  604638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  604649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  604652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  604655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  604658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604703 */     GIR_RootConstrainSelectedInstOperands,
     /*  604704 */     // GIR_Coverage, 5276,
     /*  604704 */     GIR_EraseRootFromParent_Done,
     /*  604705 */   // Label 9809: @604705
     /*  604705 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(604777), // Rule ID 5277 //
     /*  604710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  604721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  604724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  604727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  604730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  604756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604775 */     GIR_RootConstrainSelectedInstOperands,
     /*  604776 */     // GIR_Coverage, 5277,
     /*  604776 */     GIR_EraseRootFromParent_Done,
     /*  604777 */   // Label 9810: @604777
     /*  604777 */   GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(604849), // Rule ID 5278 //
     /*  604782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  604796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  604799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604828 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604847 */     GIR_RootConstrainSelectedInstOperands,
     /*  604848 */     // GIR_Coverage, 5278,
     /*  604848 */     GIR_EraseRootFromParent_Done,
     /*  604849 */   // Label 9811: @604849
     /*  604849 */   GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(604921), // Rule ID 5279 //
     /*  604854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  604868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  604871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604900 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  604900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604919 */     GIR_RootConstrainSelectedInstOperands,
     /*  604920 */     // GIR_Coverage, 5279,
     /*  604920 */     GIR_EraseRootFromParent_Done,
     /*  604921 */   // Label 9812: @604921
     /*  604921 */   GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(604993), // Rule ID 5280 //
     /*  604926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  604940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  604943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604991 */     GIR_RootConstrainSelectedInstOperands,
     /*  604992 */     // GIR_Coverage, 5280,
     /*  604992 */     GIR_EraseRootFromParent_Done,
     /*  604993 */   // Label 9813: @604993
     /*  604993 */   GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(605065), // Rule ID 5281 //
     /*  604998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  605009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  605012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  605015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  605018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  605044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605063 */     GIR_RootConstrainSelectedInstOperands,
     /*  605064 */     // GIR_Coverage, 5281,
     /*  605064 */     GIR_EraseRootFromParent_Done,
     /*  605065 */   // Label 9814: @605065
     /*  605065 */   GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(605137), // Rule ID 5282 //
     /*  605070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605116 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605135 */     GIR_RootConstrainSelectedInstOperands,
     /*  605136 */     // GIR_Coverage, 5282,
     /*  605136 */     GIR_EraseRootFromParent_Done,
     /*  605137 */   // Label 9815: @605137
     /*  605137 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(605209), // Rule ID 5283 //
     /*  605142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  605156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  605159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  605177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605188 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  605191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605207 */     GIR_RootConstrainSelectedInstOperands,
     /*  605208 */     // GIR_Coverage, 5283,
     /*  605208 */     GIR_EraseRootFromParent_Done,
     /*  605209 */   // Label 9816: @605209
     /*  605209 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(605281), // Rule ID 5284 //
     /*  605214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  605228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  605231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605260 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605279 */     GIR_RootConstrainSelectedInstOperands,
     /*  605280 */     // GIR_Coverage, 5284,
     /*  605280 */     GIR_EraseRootFromParent_Done,
     /*  605281 */   // Label 9817: @605281
     /*  605281 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(605353), // Rule ID 5285 //
     /*  605286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  605300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  605303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  605321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  605335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605351 */     GIR_RootConstrainSelectedInstOperands,
     /*  605352 */     // GIR_Coverage, 5285,
     /*  605352 */     GIR_EraseRootFromParent_Done,
     /*  605353 */   // Label 9818: @605353
     /*  605353 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(605425), // Rule ID 5286 //
     /*  605358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  605361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  605372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  605375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605404 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  605404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605423 */     GIR_RootConstrainSelectedInstOperands,
     /*  605424 */     // GIR_Coverage, 5286,
     /*  605424 */     GIR_EraseRootFromParent_Done,
     /*  605425 */   // Label 9819: @605425
     /*  605425 */   GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(605497), // Rule ID 5287 //
     /*  605430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  605433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  605444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  605447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  605465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605476 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  605476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  605479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  605495 */     GIR_RootConstrainSelectedInstOperands,
     /*  605496 */     // GIR_Coverage, 5287,
     /*  605496 */     GIR_EraseRootFromParent_Done,
     /*  605497 */   // Label 9820: @605497
     /*  605497 */   GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(605569), // Rule ID 5288 //
     /*  605502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  605516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605548 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  605551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605567 */     GIR_RootConstrainSelectedInstOperands,
     /*  605568 */     // GIR_Coverage, 5288,
     /*  605568 */     GIR_EraseRootFromParent_Done,
     /*  605569 */   // Label 9821: @605569
     /*  605569 */   GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(605641), // Rule ID 5289 //
     /*  605574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  605588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  605623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605639 */     GIR_RootConstrainSelectedInstOperands,
     /*  605640 */     // GIR_Coverage, 5289,
     /*  605640 */     GIR_EraseRootFromParent_Done,
     /*  605641 */   // Label 9822: @605641
     /*  605641 */   GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(605713), // Rule ID 5290 //
     /*  605646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  605660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605711 */     GIR_RootConstrainSelectedInstOperands,
     /*  605712 */     // GIR_Coverage, 5290,
     /*  605712 */     GIR_EraseRootFromParent_Done,
     /*  605713 */   // Label 9823: @605713
     /*  605713 */   GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(605785), // Rule ID 5291 //
     /*  605718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  605732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605764 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605783 */     GIR_RootConstrainSelectedInstOperands,
     /*  605784 */     // GIR_Coverage, 5291,
     /*  605784 */     GIR_EraseRootFromParent_Done,
     /*  605785 */   // Label 9824: @605785
     /*  605785 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(605857), // Rule ID 5292 //
     /*  605790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  605804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605855 */     GIR_RootConstrainSelectedInstOperands,
     /*  605856 */     // GIR_Coverage, 5292,
     /*  605856 */     GIR_EraseRootFromParent_Done,
     /*  605857 */   // Label 9825: @605857
     /*  605857 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(605929), // Rule ID 5293 //
     /*  605862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  605876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605908 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605927 */     GIR_RootConstrainSelectedInstOperands,
     /*  605928 */     // GIR_Coverage, 5293,
     /*  605928 */     GIR_EraseRootFromParent_Done,
     /*  605929 */   // Label 9826: @605929
     /*  605929 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(606001), // Rule ID 5294 //
     /*  605934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  605948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605980 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  605980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605999 */     GIR_RootConstrainSelectedInstOperands,
     /*  606000 */     // GIR_Coverage, 5294,
     /*  606000 */     GIR_EraseRootFromParent_Done,
     /*  606001 */   // Label 9827: @606001
     /*  606001 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(606073), // Rule ID 5295 //
     /*  606006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  606020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606052 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  606055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606071 */     GIR_RootConstrainSelectedInstOperands,
     /*  606072 */     // GIR_Coverage, 5295,
     /*  606072 */     GIR_EraseRootFromParent_Done,
     /*  606073 */   // Label 9828: @606073
     /*  606073 */   GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(606145), // Rule ID 5296 //
     /*  606078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606143 */     GIR_RootConstrainSelectedInstOperands,
     /*  606144 */     // GIR_Coverage, 5296,
     /*  606144 */     GIR_EraseRootFromParent_Done,
     /*  606145 */   // Label 9829: @606145
     /*  606145 */   GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(606217), // Rule ID 5297 //
     /*  606150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  606164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606196 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606215 */     GIR_RootConstrainSelectedInstOperands,
     /*  606216 */     // GIR_Coverage, 5297,
     /*  606216 */     GIR_EraseRootFromParent_Done,
     /*  606217 */   // Label 9830: @606217
     /*  606217 */   GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(606289), // Rule ID 5298 //
     /*  606222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606268 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  606268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606287 */     GIR_RootConstrainSelectedInstOperands,
     /*  606288 */     // GIR_Coverage, 5298,
     /*  606288 */     GIR_EraseRootFromParent_Done,
     /*  606289 */   // Label 9831: @606289
     /*  606289 */   GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(606361), // Rule ID 5299 //
     /*  606294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  606308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606340 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  606340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  606343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606359 */     GIR_RootConstrainSelectedInstOperands,
     /*  606360 */     // GIR_Coverage, 5299,
     /*  606360 */     GIR_EraseRootFromParent_Done,
     /*  606361 */   // Label 9832: @606361
     /*  606361 */   GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(606433), // Rule ID 5300 //
     /*  606366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  606380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606412 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606431 */     GIR_RootConstrainSelectedInstOperands,
     /*  606432 */     // GIR_Coverage, 5300,
     /*  606432 */     GIR_EraseRootFromParent_Done,
     /*  606433 */   // Label 9833: @606433
     /*  606433 */   GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(606505), // Rule ID 5301 //
     /*  606438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  606452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606484 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606503 */     GIR_RootConstrainSelectedInstOperands,
     /*  606504 */     // GIR_Coverage, 5301,
     /*  606504 */     GIR_EraseRootFromParent_Done,
     /*  606505 */   // Label 9834: @606505
     /*  606505 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(606577), // Rule ID 5302 //
     /*  606510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  606524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606556 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606575 */     GIR_RootConstrainSelectedInstOperands,
     /*  606576 */     // GIR_Coverage, 5302,
     /*  606576 */     GIR_EraseRootFromParent_Done,
     /*  606577 */   // Label 9835: @606577
     /*  606577 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(606649), // Rule ID 5303 //
     /*  606582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  606596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606628 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606647 */     GIR_RootConstrainSelectedInstOperands,
     /*  606648 */     // GIR_Coverage, 5303,
     /*  606648 */     GIR_EraseRootFromParent_Done,
     /*  606649 */   // Label 9836: @606649
     /*  606649 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(606721), // Rule ID 5304 //
     /*  606654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  606668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606700 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  606700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606719 */     GIR_RootConstrainSelectedInstOperands,
     /*  606720 */     // GIR_Coverage, 5304,
     /*  606720 */     GIR_EraseRootFromParent_Done,
     /*  606721 */   // Label 9837: @606721
     /*  606721 */   GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(606793), // Rule ID 5305 //
     /*  606726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  606740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  606772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606791 */     GIR_RootConstrainSelectedInstOperands,
     /*  606792 */     // GIR_Coverage, 5305,
     /*  606792 */     GIR_EraseRootFromParent_Done,
     /*  606793 */   // Label 9838: @606793
     /*  606793 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(606865), // Rule ID 5306 //
     /*  606798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  606801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  606812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606844 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  606844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  606863 */     GIR_RootConstrainSelectedInstOperands,
     /*  606864 */     // GIR_Coverage, 5306,
     /*  606864 */     GIR_EraseRootFromParent_Done,
     /*  606865 */   // Label 9839: @606865
     /*  606865 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(606937), // Rule ID 5307 //
     /*  606870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  606873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  606884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606916 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  606916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  606935 */     GIR_RootConstrainSelectedInstOperands,
     /*  606936 */     // GIR_Coverage, 5307,
     /*  606936 */     GIR_EraseRootFromParent_Done,
     /*  606937 */   // Label 9840: @606937
     /*  606937 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(607009), // Rule ID 5308 //
     /*  606942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  606953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  606956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  606962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606988 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  606991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607007 */     GIR_RootConstrainSelectedInstOperands,
     /*  607008 */     // GIR_Coverage, 5308,
     /*  607008 */     GIR_EraseRootFromParent_Done,
     /*  607009 */   // Label 9841: @607009
     /*  607009 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(607081), // Rule ID 5309 //
     /*  607014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  607028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607060 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607079 */     GIR_RootConstrainSelectedInstOperands,
     /*  607080 */     // GIR_Coverage, 5309,
     /*  607080 */     GIR_EraseRootFromParent_Done,
     /*  607081 */   // Label 9842: @607081
     /*  607081 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(607153), // Rule ID 5310 //
     /*  607086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607132 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607151 */     GIR_RootConstrainSelectedInstOperands,
     /*  607152 */     // GIR_Coverage, 5310,
     /*  607152 */     GIR_EraseRootFromParent_Done,
     /*  607153 */   // Label 9843: @607153
     /*  607153 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(607225), // Rule ID 5311 //
     /*  607158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  607172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607204 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607223 */     GIR_RootConstrainSelectedInstOperands,
     /*  607224 */     // GIR_Coverage, 5311,
     /*  607224 */     GIR_EraseRootFromParent_Done,
     /*  607225 */   // Label 9844: @607225
     /*  607225 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(607297), // Rule ID 5312 //
     /*  607230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607276 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  607276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607295 */     GIR_RootConstrainSelectedInstOperands,
     /*  607296 */     // GIR_Coverage, 5312,
     /*  607296 */     GIR_EraseRootFromParent_Done,
     /*  607297 */   // Label 9845: @607297
     /*  607297 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(607369), // Rule ID 5313 //
     /*  607302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  607313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  607316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  607322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607348 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  607348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  607367 */     GIR_RootConstrainSelectedInstOperands,
     /*  607368 */     // GIR_Coverage, 5313,
     /*  607368 */     GIR_EraseRootFromParent_Done,
     /*  607369 */   // Label 9846: @607369
     /*  607369 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(607441), // Rule ID 5314 //
     /*  607374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  607388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607420 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607439 */     GIR_RootConstrainSelectedInstOperands,
     /*  607440 */     // GIR_Coverage, 5314,
     /*  607440 */     GIR_EraseRootFromParent_Done,
     /*  607441 */   // Label 9847: @607441
     /*  607441 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(607513), // Rule ID 5315 //
     /*  607446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  607460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607492 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607511 */     GIR_RootConstrainSelectedInstOperands,
     /*  607512 */     // GIR_Coverage, 5315,
     /*  607512 */     GIR_EraseRootFromParent_Done,
     /*  607513 */   // Label 9848: @607513
     /*  607513 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(607585), // Rule ID 5316 //
     /*  607518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  607532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607564 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607583 */     GIR_RootConstrainSelectedInstOperands,
     /*  607584 */     // GIR_Coverage, 5316,
     /*  607584 */     GIR_EraseRootFromParent_Done,
     /*  607585 */   // Label 9849: @607585
     /*  607585 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(607657), // Rule ID 5317 //
     /*  607590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  607604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607636 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607655 */     GIR_RootConstrainSelectedInstOperands,
     /*  607656 */     // GIR_Coverage, 5317,
     /*  607656 */     GIR_EraseRootFromParent_Done,
     /*  607657 */   // Label 9850: @607657
     /*  607657 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(607729), // Rule ID 5318 //
     /*  607662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  607676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607708 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607727 */     GIR_RootConstrainSelectedInstOperands,
     /*  607728 */     // GIR_Coverage, 5318,
     /*  607728 */     GIR_EraseRootFromParent_Done,
     /*  607729 */   // Label 9851: @607729
     /*  607729 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(607801), // Rule ID 5319 //
     /*  607734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  607748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607780 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607799 */     GIR_RootConstrainSelectedInstOperands,
     /*  607800 */     // GIR_Coverage, 5319,
     /*  607800 */     GIR_EraseRootFromParent_Done,
     /*  607801 */   // Label 9852: @607801
     /*  607801 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(607873), // Rule ID 5320 //
     /*  607806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  607820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607852 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607871 */     GIR_RootConstrainSelectedInstOperands,
     /*  607872 */     // GIR_Coverage, 5320,
     /*  607872 */     GIR_EraseRootFromParent_Done,
     /*  607873 */   // Label 9853: @607873
     /*  607873 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(607945), // Rule ID 5321 //
     /*  607878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  607892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607924 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607943 */     GIR_RootConstrainSelectedInstOperands,
     /*  607944 */     // GIR_Coverage, 5321,
     /*  607944 */     GIR_EraseRootFromParent_Done,
     /*  607945 */   // Label 9854: @607945
     /*  607945 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(608017), // Rule ID 5322 //
     /*  607950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  607964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607996 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608015 */     GIR_RootConstrainSelectedInstOperands,
     /*  608016 */     // GIR_Coverage, 5322,
     /*  608016 */     GIR_EraseRootFromParent_Done,
     /*  608017 */   // Label 9855: @608017
     /*  608017 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(608089), // Rule ID 5323 //
     /*  608022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  608036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608087 */     GIR_RootConstrainSelectedInstOperands,
     /*  608088 */     // GIR_Coverage, 5323,
     /*  608088 */     GIR_EraseRootFromParent_Done,
     /*  608089 */   // Label 9856: @608089
     /*  608089 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(608161), // Rule ID 5324 //
     /*  608094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608159 */     GIR_RootConstrainSelectedInstOperands,
     /*  608160 */     // GIR_Coverage, 5324,
     /*  608160 */     GIR_EraseRootFromParent_Done,
     /*  608161 */   // Label 9857: @608161
     /*  608161 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(608233), // Rule ID 5325 //
     /*  608166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  608177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  608180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  608186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  608212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608231 */     GIR_RootConstrainSelectedInstOperands,
     /*  608232 */     // GIR_Coverage, 5325,
     /*  608232 */     GIR_EraseRootFromParent_Done,
     /*  608233 */   // Label 9858: @608233
     /*  608233 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(608305), // Rule ID 5326 //
     /*  608238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608303 */     GIR_RootConstrainSelectedInstOperands,
     /*  608304 */     // GIR_Coverage, 5326,
     /*  608304 */     GIR_EraseRootFromParent_Done,
     /*  608305 */   // Label 9859: @608305
     /*  608305 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(608377), // Rule ID 5327 //
     /*  608310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  608324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  608341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  608359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608375 */     GIR_RootConstrainSelectedInstOperands,
     /*  608376 */     // GIR_Coverage, 5327,
     /*  608376 */     GIR_EraseRootFromParent_Done,
     /*  608377 */   // Label 9860: @608377
     /*  608377 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(608449), // Rule ID 5328 //
     /*  608382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  608396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608428 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608447 */     GIR_RootConstrainSelectedInstOperands,
     /*  608448 */     // GIR_Coverage, 5328,
     /*  608448 */     GIR_EraseRootFromParent_Done,
     /*  608449 */   // Label 9861: @608449
     /*  608449 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(608521), // Rule ID 5329 //
     /*  608454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  608468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  608485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608500 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  608503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608519 */     GIR_RootConstrainSelectedInstOperands,
     /*  608520 */     // GIR_Coverage, 5329,
     /*  608520 */     GIR_EraseRootFromParent_Done,
     /*  608521 */   // Label 9862: @608521
     /*  608521 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(608593), // Rule ID 5330 //
     /*  608526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  608540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608572 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608591 */     GIR_RootConstrainSelectedInstOperands,
     /*  608592 */     // GIR_Coverage, 5330,
     /*  608592 */     GIR_EraseRootFromParent_Done,
     /*  608593 */   // Label 9863: @608593
     /*  608593 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(608665), // Rule ID 5331 //
     /*  608598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  608612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608663 */     GIR_RootConstrainSelectedInstOperands,
     /*  608664 */     // GIR_Coverage, 5331,
     /*  608664 */     GIR_EraseRootFromParent_Done,
     /*  608665 */   // Label 9864: @608665
     /*  608665 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(608737), // Rule ID 5594 //
     /*  608670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  608684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  608687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608716 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  608716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  608719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608735 */     GIR_RootConstrainSelectedInstOperands,
     /*  608736 */     // GIR_Coverage, 5594,
     /*  608736 */     GIR_EraseRootFromParent_Done,
     /*  608737 */   // Label 9865: @608737
     /*  608737 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(608809), // Rule ID 5595 //
     /*  608742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  608756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  608759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608788 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  608788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  608791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608807 */     GIR_RootConstrainSelectedInstOperands,
     /*  608808 */     // GIR_Coverage, 5595,
     /*  608808 */     GIR_EraseRootFromParent_Done,
     /*  608809 */   // Label 9866: @608809
     /*  608809 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(608881), // Rule ID 5596 //
     /*  608814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  608828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  608831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  608860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  608863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608879 */     GIR_RootConstrainSelectedInstOperands,
     /*  608880 */     // GIR_Coverage, 5596,
     /*  608880 */     GIR_EraseRootFromParent_Done,
     /*  608881 */   // Label 9867: @608881
     /*  608881 */   GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(608953), // Rule ID 5597 //
     /*  608886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  608900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  608903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608932 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  608932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  608935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608951 */     GIR_RootConstrainSelectedInstOperands,
     /*  608952 */     // GIR_Coverage, 5597,
     /*  608952 */     GIR_EraseRootFromParent_Done,
     /*  608953 */   // Label 9868: @608953
     /*  608953 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(609025), // Rule ID 5598 //
     /*  608958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  608972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  608975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609004 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609023 */     GIR_RootConstrainSelectedInstOperands,
     /*  609024 */     // GIR_Coverage, 5598,
     /*  609024 */     GIR_EraseRootFromParent_Done,
     /*  609025 */   // Label 9869: @609025
     /*  609025 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(609097), // Rule ID 5599 //
     /*  609030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  609044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  609047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609076 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609095 */     GIR_RootConstrainSelectedInstOperands,
     /*  609096 */     // GIR_Coverage, 5599,
     /*  609096 */     GIR_EraseRootFromParent_Done,
     /*  609097 */   // Label 9870: @609097
     /*  609097 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(609169), // Rule ID 5600 //
     /*  609102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  609119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609167 */     GIR_RootConstrainSelectedInstOperands,
     /*  609168 */     // GIR_Coverage, 5600,
     /*  609168 */     GIR_EraseRootFromParent_Done,
     /*  609169 */   // Label 9871: @609169
     /*  609169 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(609241), // Rule ID 5601 //
     /*  609174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  609188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  609191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609220 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  609223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609239 */     GIR_RootConstrainSelectedInstOperands,
     /*  609240 */     // GIR_Coverage, 5601,
     /*  609240 */     GIR_EraseRootFromParent_Done,
     /*  609241 */   // Label 9872: @609241
     /*  609241 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(609313), // Rule ID 5602 //
     /*  609246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  609263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609292 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609311 */     GIR_RootConstrainSelectedInstOperands,
     /*  609312 */     // GIR_Coverage, 5602,
     /*  609312 */     GIR_EraseRootFromParent_Done,
     /*  609313 */   // Label 9873: @609313
     /*  609313 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(609385), // Rule ID 5603 //
     /*  609318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  609332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  609335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609364 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609383 */     GIR_RootConstrainSelectedInstOperands,
     /*  609384 */     // GIR_Coverage, 5603,
     /*  609384 */     GIR_EraseRootFromParent_Done,
     /*  609385 */   // Label 9874: @609385
     /*  609385 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(609457), // Rule ID 5604 //
     /*  609390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  609404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  609407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609436 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  609436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609455 */     GIR_RootConstrainSelectedInstOperands,
     /*  609456 */     // GIR_Coverage, 5604,
     /*  609456 */     GIR_EraseRootFromParent_Done,
     /*  609457 */   // Label 9875: @609457
     /*  609457 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(609529), // Rule ID 5605 //
     /*  609462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  609476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  609479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  609508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609527 */     GIR_RootConstrainSelectedInstOperands,
     /*  609528 */     // GIR_Coverage, 5605,
     /*  609528 */     GIR_EraseRootFromParent_Done,
     /*  609529 */   // Label 9876: @609529
     /*  609529 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(609601), // Rule ID 5606 //
     /*  609534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  609548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  609551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609599 */     GIR_RootConstrainSelectedInstOperands,
     /*  609600 */     // GIR_Coverage, 5606,
     /*  609600 */     GIR_EraseRootFromParent_Done,
     /*  609601 */   // Label 9877: @609601
     /*  609601 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(609673), // Rule ID 5607 //
     /*  609606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  609620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  609623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609671 */     GIR_RootConstrainSelectedInstOperands,
     /*  609672 */     // GIR_Coverage, 5607,
     /*  609672 */     GIR_EraseRootFromParent_Done,
     /*  609673 */   // Label 9878: @609673
     /*  609673 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(609745), // Rule ID 5608 //
     /*  609678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  609692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  609695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609724 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609743 */     GIR_RootConstrainSelectedInstOperands,
     /*  609744 */     // GIR_Coverage, 5608,
     /*  609744 */     GIR_EraseRootFromParent_Done,
     /*  609745 */   // Label 9879: @609745
     /*  609745 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(609817), // Rule ID 5609 //
     /*  609750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  609764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  609767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609796 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609815 */     GIR_RootConstrainSelectedInstOperands,
     /*  609816 */     // GIR_Coverage, 5609,
     /*  609816 */     GIR_EraseRootFromParent_Done,
     /*  609817 */   // Label 9880: @609817
     /*  609817 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(609889), // Rule ID 5610 //
     /*  609822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  609836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  609839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609868 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  609868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609887 */     GIR_RootConstrainSelectedInstOperands,
     /*  609888 */     // GIR_Coverage, 5610,
     /*  609888 */     GIR_EraseRootFromParent_Done,
     /*  609889 */   // Label 9881: @609889
     /*  609889 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(609961), // Rule ID 5611 //
     /*  609894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  609908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  609911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  609940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609959 */     GIR_RootConstrainSelectedInstOperands,
     /*  609960 */     // GIR_Coverage, 5611,
     /*  609960 */     GIR_EraseRootFromParent_Done,
     /*  609961 */   // Label 9882: @609961
     /*  609961 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(610033), // Rule ID 5612 //
     /*  609966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  609969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  609980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  609983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610012 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  610012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610031 */     GIR_RootConstrainSelectedInstOperands,
     /*  610032 */     // GIR_Coverage, 5612,
     /*  610032 */     GIR_EraseRootFromParent_Done,
     /*  610033 */   // Label 9883: @610033
     /*  610033 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(610105), // Rule ID 5613 //
     /*  610038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  610041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  610049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  610052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  610055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  610058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610084 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  610084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  610087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610103 */     GIR_RootConstrainSelectedInstOperands,
     /*  610104 */     // GIR_Coverage, 5613,
     /*  610104 */     GIR_EraseRootFromParent_Done,
     /*  610105 */   // Label 9884: @610105
     /*  610105 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(610177), // Rule ID 5614 //
     /*  610110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  610127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610156 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610175 */     GIR_RootConstrainSelectedInstOperands,
     /*  610176 */     // GIR_Coverage, 5614,
     /*  610176 */     GIR_EraseRootFromParent_Done,
     /*  610177 */   // Label 9885: @610177
     /*  610177 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(610249), // Rule ID 5615 //
     /*  610182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  610196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  610199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610228 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610247 */     GIR_RootConstrainSelectedInstOperands,
     /*  610248 */     // GIR_Coverage, 5615,
     /*  610248 */     GIR_EraseRootFromParent_Done,
     /*  610249 */   // Label 9886: @610249
     /*  610249 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(610321), // Rule ID 5616 //
     /*  610254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  610271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610300 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610319 */     GIR_RootConstrainSelectedInstOperands,
     /*  610320 */     // GIR_Coverage, 5616,
     /*  610320 */     GIR_EraseRootFromParent_Done,
     /*  610321 */   // Label 9887: @610321
     /*  610321 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(610393), // Rule ID 5617 //
     /*  610326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  610340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  610343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610372 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610391 */     GIR_RootConstrainSelectedInstOperands,
     /*  610392 */     // GIR_Coverage, 5617,
     /*  610392 */     GIR_EraseRootFromParent_Done,
     /*  610393 */   // Label 9888: @610393
     /*  610393 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(610465), // Rule ID 5618 //
     /*  610398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  610409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  610412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  610415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  610418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610444 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  610444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610463 */     GIR_RootConstrainSelectedInstOperands,
     /*  610464 */     // GIR_Coverage, 5618,
     /*  610464 */     GIR_EraseRootFromParent_Done,
     /*  610465 */   // Label 9889: @610465
     /*  610465 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(610537), // Rule ID 5619 //
     /*  610470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  610481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  610484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  610487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  610490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610516 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610535 */     GIR_RootConstrainSelectedInstOperands,
     /*  610536 */     // GIR_Coverage, 5619,
     /*  610536 */     GIR_EraseRootFromParent_Done,
     /*  610537 */   // Label 9890: @610537
     /*  610537 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(610609), // Rule ID 5620 //
     /*  610542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  610556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  610559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610588 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610607 */     GIR_RootConstrainSelectedInstOperands,
     /*  610608 */     // GIR_Coverage, 5620,
     /*  610608 */     GIR_EraseRootFromParent_Done,
     /*  610609 */   // Label 9891: @610609
     /*  610609 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(610681), // Rule ID 5621 //
     /*  610614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  610628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  610631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610679 */     GIR_RootConstrainSelectedInstOperands,
     /*  610680 */     // GIR_Coverage, 5621,
     /*  610680 */     GIR_EraseRootFromParent_Done,
     /*  610681 */   // Label 9892: @610681
     /*  610681 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(610753), // Rule ID 5622 //
     /*  610686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  610700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  610703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610732 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610751 */     GIR_RootConstrainSelectedInstOperands,
     /*  610752 */     // GIR_Coverage, 5622,
     /*  610752 */     GIR_EraseRootFromParent_Done,
     /*  610753 */   // Label 9893: @610753
     /*  610753 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(610825), // Rule ID 5623 //
     /*  610758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  610772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  610775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610804 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610823 */     GIR_RootConstrainSelectedInstOperands,
     /*  610824 */     // GIR_Coverage, 5623,
     /*  610824 */     GIR_EraseRootFromParent_Done,
     /*  610825 */   // Label 9894: @610825
     /*  610825 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(610897), // Rule ID 5624 //
     /*  610830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  610844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  610847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610876 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610895 */     GIR_RootConstrainSelectedInstOperands,
     /*  610896 */     // GIR_Coverage, 5624,
     /*  610896 */     GIR_EraseRootFromParent_Done,
     /*  610897 */   // Label 9895: @610897
     /*  610897 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(610969), // Rule ID 5625 //
     /*  610902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  610916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  610919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610948 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610957 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610967 */     GIR_RootConstrainSelectedInstOperands,
     /*  610968 */     // GIR_Coverage, 5625,
     /*  610968 */     GIR_EraseRootFromParent_Done,
     /*  610969 */   // Label 9896: @610969
     /*  610969 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(611041), // Rule ID 5626 //
     /*  610974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  610988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  610991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611020 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611039 */     GIR_RootConstrainSelectedInstOperands,
     /*  611040 */     // GIR_Coverage, 5626,
     /*  611040 */     GIR_EraseRootFromParent_Done,
     /*  611041 */   // Label 9897: @611041
     /*  611041 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(611113), // Rule ID 5627 //
     /*  611046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  611060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  611063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611092 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611111 */     GIR_RootConstrainSelectedInstOperands,
     /*  611112 */     // GIR_Coverage, 5627,
     /*  611112 */     GIR_EraseRootFromParent_Done,
     /*  611113 */   // Label 9898: @611113
     /*  611113 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(611185), // Rule ID 5628 //
     /*  611118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  611135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611164 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611183 */     GIR_RootConstrainSelectedInstOperands,
     /*  611184 */     // GIR_Coverage, 5628,
     /*  611184 */     GIR_EraseRootFromParent_Done,
     /*  611185 */   // Label 9899: @611185
     /*  611185 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(611257), // Rule ID 5629 //
     /*  611190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  611204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  611207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611236 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611255 */     GIR_RootConstrainSelectedInstOperands,
     /*  611256 */     // GIR_Coverage, 5629,
     /*  611256 */     GIR_EraseRootFromParent_Done,
     /*  611257 */   // Label 9900: @611257
     /*  611257 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(611329), // Rule ID 5630 //
     /*  611262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  611279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  611308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611327 */     GIR_RootConstrainSelectedInstOperands,
     /*  611328 */     // GIR_Coverage, 5630,
     /*  611328 */     GIR_EraseRootFromParent_Done,
     /*  611329 */   // Label 9901: @611329
     /*  611329 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(611401), // Rule ID 5631 //
     /*  611334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  611345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  611348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  611351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  611354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611380 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  611380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  611399 */     GIR_RootConstrainSelectedInstOperands,
     /*  611400 */     // GIR_Coverage, 5631,
     /*  611400 */     GIR_EraseRootFromParent_Done,
     /*  611401 */   // Label 9902: @611401
     /*  611401 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(611473), // Rule ID 5632 //
     /*  611406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  611420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  611423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611452 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611471 */     GIR_RootConstrainSelectedInstOperands,
     /*  611472 */     // GIR_Coverage, 5632,
     /*  611472 */     GIR_EraseRootFromParent_Done,
     /*  611473 */   // Label 9903: @611473
     /*  611473 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(611545), // Rule ID 5633 //
     /*  611478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  611492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  611495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611524 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611543 */     GIR_RootConstrainSelectedInstOperands,
     /*  611544 */     // GIR_Coverage, 5633,
     /*  611544 */     GIR_EraseRootFromParent_Done,
     /*  611545 */   // Label 9904: @611545
     /*  611545 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(611617), // Rule ID 5634 //
     /*  611550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  611564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  611567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611615 */     GIR_RootConstrainSelectedInstOperands,
     /*  611616 */     // GIR_Coverage, 5634,
     /*  611616 */     GIR_EraseRootFromParent_Done,
     /*  611617 */   // Label 9905: @611617
     /*  611617 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(611689), // Rule ID 5635 //
     /*  611622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  611636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  611639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611687 */     GIR_RootConstrainSelectedInstOperands,
     /*  611688 */     // GIR_Coverage, 5635,
     /*  611688 */     GIR_EraseRootFromParent_Done,
     /*  611689 */   // Label 9906: @611689
     /*  611689 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(611761), // Rule ID 5636 //
     /*  611694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  611708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  611711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611759 */     GIR_RootConstrainSelectedInstOperands,
     /*  611760 */     // GIR_Coverage, 5636,
     /*  611760 */     GIR_EraseRootFromParent_Done,
     /*  611761 */   // Label 9907: @611761
     /*  611761 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(611833), // Rule ID 5637 //
     /*  611766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  611780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  611783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611812 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611831 */     GIR_RootConstrainSelectedInstOperands,
     /*  611832 */     // GIR_Coverage, 5637,
     /*  611832 */     GIR_EraseRootFromParent_Done,
     /*  611833 */   // Label 9908: @611833
     /*  611833 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(611905), // Rule ID 5638 //
     /*  611838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  611849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  611852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  611858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  611884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  611887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611903 */     GIR_RootConstrainSelectedInstOperands,
     /*  611904 */     // GIR_Coverage, 5638,
     /*  611904 */     GIR_EraseRootFromParent_Done,
     /*  611905 */   // Label 9909: @611905
     /*  611905 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(611977), // Rule ID 5639 //
     /*  611910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  611921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  611924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  611930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611956 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  611956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  611959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611975 */     GIR_RootConstrainSelectedInstOperands,
     /*  611976 */     // GIR_Coverage, 5639,
     /*  611976 */     GIR_EraseRootFromParent_Done,
     /*  611977 */   // Label 9910: @611977
     /*  611977 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(612049), // Rule ID 5640 //
     /*  611982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  611996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612028 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612047 */     GIR_RootConstrainSelectedInstOperands,
     /*  612048 */     // GIR_Coverage, 5640,
     /*  612048 */     GIR_EraseRootFromParent_Done,
     /*  612049 */   // Label 9911: @612049
     /*  612049 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(612121), // Rule ID 5641 //
     /*  612054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  612068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612119 */     GIR_RootConstrainSelectedInstOperands,
     /*  612120 */     // GIR_Coverage, 5641,
     /*  612120 */     GIR_EraseRootFromParent_Done,
     /*  612121 */   // Label 9912: @612121
     /*  612121 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(612193), // Rule ID 5642 //
     /*  612126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612191 */     GIR_RootConstrainSelectedInstOperands,
     /*  612192 */     // GIR_Coverage, 5642,
     /*  612192 */     GIR_EraseRootFromParent_Done,
     /*  612193 */   // Label 9913: @612193
     /*  612193 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(612265), // Rule ID 5643 //
     /*  612198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  612212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612263 */     GIR_RootConstrainSelectedInstOperands,
     /*  612264 */     // GIR_Coverage, 5643,
     /*  612264 */     GIR_EraseRootFromParent_Done,
     /*  612265 */   // Label 9914: @612265
     /*  612265 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(612337), // Rule ID 5644 //
     /*  612270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612316 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612335 */     GIR_RootConstrainSelectedInstOperands,
     /*  612336 */     // GIR_Coverage, 5644,
     /*  612336 */     GIR_EraseRootFromParent_Done,
     /*  612337 */   // Label 9915: @612337
     /*  612337 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(612409), // Rule ID 5645 //
     /*  612342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  612356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612388 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  612391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612407 */     GIR_RootConstrainSelectedInstOperands,
     /*  612408 */     // GIR_Coverage, 5645,
     /*  612408 */     GIR_EraseRootFromParent_Done,
     /*  612409 */   // Label 9916: @612409
     /*  612409 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(612481), // Rule ID 5646 //
     /*  612414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  612428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612479 */     GIR_RootConstrainSelectedInstOperands,
     /*  612480 */     // GIR_Coverage, 5646,
     /*  612480 */     GIR_EraseRootFromParent_Done,
     /*  612481 */   // Label 9917: @612481
     /*  612481 */   GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(612553), // Rule ID 5647 //
     /*  612486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  612500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612551 */     GIR_RootConstrainSelectedInstOperands,
     /*  612552 */     // GIR_Coverage, 5647,
     /*  612552 */     GIR_EraseRootFromParent_Done,
     /*  612553 */   // Label 9918: @612553
     /*  612553 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(612625), // Rule ID 5648 //
     /*  612558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  612572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612604 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  612604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612623 */     GIR_RootConstrainSelectedInstOperands,
     /*  612624 */     // GIR_Coverage, 5648,
     /*  612624 */     GIR_EraseRootFromParent_Done,
     /*  612625 */   // Label 9919: @612625
     /*  612625 */   GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(612697), // Rule ID 5649 //
     /*  612630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  612644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612676 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  612676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612695 */     GIR_RootConstrainSelectedInstOperands,
     /*  612696 */     // GIR_Coverage, 5649,
     /*  612696 */     GIR_EraseRootFromParent_Done,
     /*  612697 */   // Label 9920: @612697
     /*  612697 */   GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(612769), // Rule ID 5650 //
     /*  612702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  612716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612748 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612767 */     GIR_RootConstrainSelectedInstOperands,
     /*  612768 */     // GIR_Coverage, 5650,
     /*  612768 */     GIR_EraseRootFromParent_Done,
     /*  612769 */   // Label 9921: @612769
     /*  612769 */   GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(612841), // Rule ID 5651 //
     /*  612774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  612788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612839 */     GIR_RootConstrainSelectedInstOperands,
     /*  612840 */     // GIR_Coverage, 5651,
     /*  612840 */     GIR_EraseRootFromParent_Done,
     /*  612841 */   // Label 9922: @612841
     /*  612841 */   GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(612913), // Rule ID 5652 //
     /*  612846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  612860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612892 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612911 */     GIR_RootConstrainSelectedInstOperands,
     /*  612912 */     // GIR_Coverage, 5652,
     /*  612912 */     GIR_EraseRootFromParent_Done,
     /*  612913 */   // Label 9923: @612913
     /*  612913 */   GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(612985), // Rule ID 5653 //
     /*  612918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  612932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612964 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612983 */     GIR_RootConstrainSelectedInstOperands,
     /*  612984 */     // GIR_Coverage, 5653,
     /*  612984 */     GIR_EraseRootFromParent_Done,
     /*  612985 */   // Label 9924: @612985
     /*  612985 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(613057), // Rule ID 5654 //
     /*  612990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613036 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613055 */     GIR_RootConstrainSelectedInstOperands,
     /*  613056 */     // GIR_Coverage, 5654,
     /*  613056 */     GIR_EraseRootFromParent_Done,
     /*  613057 */   // Label 9925: @613057
     /*  613057 */   GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(613129), // Rule ID 5655 //
     /*  613062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  613073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  613076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  613082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613127 */     GIR_RootConstrainSelectedInstOperands,
     /*  613128 */     // GIR_Coverage, 5655,
     /*  613128 */     GIR_EraseRootFromParent_Done,
     /*  613129 */   // Label 9926: @613129
     /*  613129 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(613201), // Rule ID 5656 //
     /*  613134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  613137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613180 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  613180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613199 */     GIR_RootConstrainSelectedInstOperands,
     /*  613200 */     // GIR_Coverage, 5656,
     /*  613200 */     GIR_EraseRootFromParent_Done,
     /*  613201 */   // Label 9927: @613201
     /*  613201 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(613273), // Rule ID 5657 //
     /*  613206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  613209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  613217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  613220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  613226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  613252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  613255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  613271 */     GIR_RootConstrainSelectedInstOperands,
     /*  613272 */     // GIR_Coverage, 5657,
     /*  613272 */     GIR_EraseRootFromParent_Done,
     /*  613273 */   // Label 9928: @613273
     /*  613273 */   GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(613345), // Rule ID 5658 //
     /*  613278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613324 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613343 */     GIR_RootConstrainSelectedInstOperands,
     /*  613344 */     // GIR_Coverage, 5658,
     /*  613344 */     GIR_EraseRootFromParent_Done,
     /*  613345 */   // Label 9929: @613345
     /*  613345 */   GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(613417), // Rule ID 5659 //
     /*  613350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  613364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613415 */     GIR_RootConstrainSelectedInstOperands,
     /*  613416 */     // GIR_Coverage, 5659,
     /*  613416 */     GIR_EraseRootFromParent_Done,
     /*  613417 */   // Label 9930: @613417
     /*  613417 */   GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(613489), // Rule ID 5660 //
     /*  613422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  613436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613468 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613487 */     GIR_RootConstrainSelectedInstOperands,
     /*  613488 */     // GIR_Coverage, 5660,
     /*  613488 */     GIR_EraseRootFromParent_Done,
     /*  613489 */   // Label 9931: @613489
     /*  613489 */   GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(613561), // Rule ID 5661 //
     /*  613494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  613508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613540 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613559 */     GIR_RootConstrainSelectedInstOperands,
     /*  613560 */     // GIR_Coverage, 5661,
     /*  613560 */     GIR_EraseRootFromParent_Done,
     /*  613561 */   // Label 9932: @613561
     /*  613561 */   GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(613633), // Rule ID 5662 //
     /*  613566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  613577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  613580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  613586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  613597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613612 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  613615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613631 */     GIR_RootConstrainSelectedInstOperands,
     /*  613632 */     // GIR_Coverage, 5662,
     /*  613632 */     GIR_EraseRootFromParent_Done,
     /*  613633 */   // Label 9933: @613633
     /*  613633 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(613705), // Rule ID 5663 //
     /*  613638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  613649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  613652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  613658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  613669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613684 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  613687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613703 */     GIR_RootConstrainSelectedInstOperands,
     /*  613704 */     // GIR_Coverage, 5663,
     /*  613704 */     GIR_EraseRootFromParent_Done,
     /*  613705 */   // Label 9934: @613705
     /*  613705 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(613777), // Rule ID 5664 //
     /*  613710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  613724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613756 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613775 */     GIR_RootConstrainSelectedInstOperands,
     /*  613776 */     // GIR_Coverage, 5664,
     /*  613776 */     GIR_EraseRootFromParent_Done,
     /*  613777 */   // Label 9935: @613777
     /*  613777 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(613849), // Rule ID 5665 //
     /*  613782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  613796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613828 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613847 */     GIR_RootConstrainSelectedInstOperands,
     /*  613848 */     // GIR_Coverage, 5665,
     /*  613848 */     GIR_EraseRootFromParent_Done,
     /*  613849 */   // Label 9936: @613849
     /*  613849 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(613921), // Rule ID 5666 //
     /*  613854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  613868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613900 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613919 */     GIR_RootConstrainSelectedInstOperands,
     /*  613920 */     // GIR_Coverage, 5666,
     /*  613920 */     GIR_EraseRootFromParent_Done,
     /*  613921 */   // Label 9937: @613921
     /*  613921 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(613993), // Rule ID 5667 //
     /*  613926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  613940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613972 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613991 */     GIR_RootConstrainSelectedInstOperands,
     /*  613992 */     // GIR_Coverage, 5667,
     /*  613992 */     GIR_EraseRootFromParent_Done,
     /*  613993 */   // Label 9938: @613993
     /*  613993 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(614065), // Rule ID 5668 //
     /*  613998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614044 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  614044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614063 */     GIR_RootConstrainSelectedInstOperands,
     /*  614064 */     // GIR_Coverage, 5668,
     /*  614064 */     GIR_EraseRootFromParent_Done,
     /*  614065 */   // Label 9939: @614065
     /*  614065 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(614137), // Rule ID 5669 //
     /*  614070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  614081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  614084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  614090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614116 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  614116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  614135 */     GIR_RootConstrainSelectedInstOperands,
     /*  614136 */     // GIR_Coverage, 5669,
     /*  614136 */     GIR_EraseRootFromParent_Done,
     /*  614137 */   // Label 9940: @614137
     /*  614137 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(614209), // Rule ID 5670 //
     /*  614142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614188 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614207 */     GIR_RootConstrainSelectedInstOperands,
     /*  614208 */     // GIR_Coverage, 5670,
     /*  614208 */     GIR_EraseRootFromParent_Done,
     /*  614209 */   // Label 9941: @614209
     /*  614209 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(614281), // Rule ID 5671 //
     /*  614214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  614228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614260 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614279 */     GIR_RootConstrainSelectedInstOperands,
     /*  614280 */     // GIR_Coverage, 5671,
     /*  614280 */     GIR_EraseRootFromParent_Done,
     /*  614281 */   // Label 9942: @614281
     /*  614281 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(614353), // Rule ID 5672 //
     /*  614286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614351 */     GIR_RootConstrainSelectedInstOperands,
     /*  614352 */     // GIR_Coverage, 5672,
     /*  614352 */     GIR_EraseRootFromParent_Done,
     /*  614353 */   // Label 9943: @614353
     /*  614353 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(614425), // Rule ID 5673 //
     /*  614358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  614372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614404 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614423 */     GIR_RootConstrainSelectedInstOperands,
     /*  614424 */     // GIR_Coverage, 5673,
     /*  614424 */     GIR_EraseRootFromParent_Done,
     /*  614425 */   // Label 9944: @614425
     /*  614425 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(614497), // Rule ID 5674 //
     /*  614430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  614444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614476 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  614476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614495 */     GIR_RootConstrainSelectedInstOperands,
     /*  614496 */     // GIR_Coverage, 5674,
     /*  614496 */     GIR_EraseRootFromParent_Done,
     /*  614497 */   // Label 9945: @614497
     /*  614497 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(614569), // Rule ID 5675 //
     /*  614502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  614516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614567 */     GIR_RootConstrainSelectedInstOperands,
     /*  614568 */     // GIR_Coverage, 5675,
     /*  614568 */     GIR_EraseRootFromParent_Done,
     /*  614569 */   // Label 9946: @614569
     /*  614569 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(614641), // Rule ID 5676 //
     /*  614574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  614577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  614585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  614588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  614594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614620 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  614620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614639 */     GIR_RootConstrainSelectedInstOperands,
     /*  614640 */     // GIR_Coverage, 5676,
     /*  614640 */     GIR_EraseRootFromParent_Done,
     /*  614641 */   // Label 9947: @614641
     /*  614641 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(614713), // Rule ID 5677 //
     /*  614646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  614649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  614657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  614660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  614666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11441:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  614692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614711 */     GIR_RootConstrainSelectedInstOperands,
     /*  614712 */     // GIR_Coverage, 5677,
     /*  614712 */     GIR_EraseRootFromParent_Done,
     /*  614713 */   // Label 9948: @614713
     /*  614713 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(614785), // Rule ID 5678 //
     /*  614718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  614721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  614732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614764 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  614764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614783 */     GIR_RootConstrainSelectedInstOperands,
     /*  614784 */     // GIR_Coverage, 5678,
     /*  614784 */     GIR_EraseRootFromParent_Done,
     /*  614785 */   // Label 9949: @614785
     /*  614785 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(614857), // Rule ID 5679 //
     /*  614790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  614793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  614804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11441:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  614836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614855 */     GIR_RootConstrainSelectedInstOperands,
     /*  614856 */     // GIR_Coverage, 5679,
     /*  614856 */     GIR_EraseRootFromParent_Done,
     /*  614857 */   // Label 9950: @614857
     /*  614857 */   GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(614929), // Rule ID 5680 //
     /*  614862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  614865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  614876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614908 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  614908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614927 */     GIR_RootConstrainSelectedInstOperands,
     /*  614928 */     // GIR_Coverage, 5680,
     /*  614928 */     GIR_EraseRootFromParent_Done,
     /*  614929 */   // Label 9951: @614929
     /*  614929 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(615001), // Rule ID 5681 //
     /*  614934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  614937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  614948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11441:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  614980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614999 */     GIR_RootConstrainSelectedInstOperands,
     /*  615000 */     // GIR_Coverage, 5681,
     /*  615000 */     GIR_EraseRootFromParent_Done,
     /*  615001 */   // Label 9952: @615001
     /*  615001 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(615076), // Rule ID 5770 //
     /*  615006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  615026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  615055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615074 */     GIR_RootConstrainSelectedInstOperands,
     /*  615075 */     // GIR_Coverage, 5770,
     /*  615075 */     GIR_EraseRootFromParent_Done,
     /*  615076 */   // Label 9953: @615076
     /*  615076 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(615151), // Rule ID 5771 //
     /*  615081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  615092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  615095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  615098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  615101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615127 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  615130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615149 */     GIR_RootConstrainSelectedInstOperands,
     /*  615150 */     // GIR_Coverage, 5771,
     /*  615150 */     GIR_EraseRootFromParent_Done,
     /*  615151 */   // Label 9954: @615151
     /*  615151 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(615226), // Rule ID 5774 //
     /*  615156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  615176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615202 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615224 */     GIR_RootConstrainSelectedInstOperands,
     /*  615225 */     // GIR_Coverage, 5774,
     /*  615225 */     GIR_EraseRootFromParent_Done,
     /*  615226 */   // Label 9955: @615226
     /*  615226 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(615301), // Rule ID 5775 //
     /*  615231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  615242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  615245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  615248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  615251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615277 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615299 */     GIR_RootConstrainSelectedInstOperands,
     /*  615300 */     // GIR_Coverage, 5775,
     /*  615300 */     GIR_EraseRootFromParent_Done,
     /*  615301 */   // Label 9956: @615301
     /*  615301 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(615376), // Rule ID 5778 //
     /*  615306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  615317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  615323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  615326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615374 */     GIR_RootConstrainSelectedInstOperands,
     /*  615375 */     // GIR_Coverage, 5778,
     /*  615375 */     GIR_EraseRootFromParent_Done,
     /*  615376 */   // Label 9957: @615376
     /*  615376 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(615451), // Rule ID 5779 //
     /*  615381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  615392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  615395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  615398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  615401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615427 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615449 */     GIR_RootConstrainSelectedInstOperands,
     /*  615450 */     // GIR_Coverage, 5779,
     /*  615450 */     GIR_EraseRootFromParent_Done,
     /*  615451 */   // Label 9958: @615451
     /*  615451 */   GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(615526), // Rule ID 5782 //
     /*  615456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  615467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  615470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  615473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  615476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615524 */     GIR_RootConstrainSelectedInstOperands,
     /*  615525 */     // GIR_Coverage, 5782,
     /*  615525 */     GIR_EraseRootFromParent_Done,
     /*  615526 */   // Label 9959: @615526
     /*  615526 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(615601), // Rule ID 5783 //
     /*  615531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  615542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  615545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  615548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  615551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615577 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  615577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615599 */     GIR_RootConstrainSelectedInstOperands,
     /*  615600 */     // GIR_Coverage, 5783,
     /*  615600 */     GIR_EraseRootFromParent_Done,
     /*  615601 */   // Label 9960: @615601
     /*  615601 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(615676), // Rule ID 5786 //
     /*  615606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  615617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  615620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  615623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  615626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615674 */     GIR_RootConstrainSelectedInstOperands,
     /*  615675 */     // GIR_Coverage, 5786,
     /*  615675 */     GIR_EraseRootFromParent_Done,
     /*  615676 */   // Label 9961: @615676
     /*  615676 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(615751), // Rule ID 5787 //
     /*  615681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  615692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  615695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  615698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  615701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615727 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  615727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615749 */     GIR_RootConstrainSelectedInstOperands,
     /*  615750 */     // GIR_Coverage, 5787,
     /*  615750 */     GIR_EraseRootFromParent_Done,
     /*  615751 */   // Label 9962: @615751
     /*  615751 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(615826), // Rule ID 5790 //
     /*  615756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  615767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  615770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  615773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  615776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  615802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615824 */     GIR_RootConstrainSelectedInstOperands,
     /*  615825 */     // GIR_Coverage, 5790,
     /*  615825 */     GIR_EraseRootFromParent_Done,
     /*  615826 */   // Label 9963: @615826
     /*  615826 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(615901), // Rule ID 5791 //
     /*  615831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  615842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  615845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  615848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  615851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615877 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  615877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615899 */     GIR_RootConstrainSelectedInstOperands,
     /*  615900 */     // GIR_Coverage, 5791,
     /*  615900 */     GIR_EraseRootFromParent_Done,
     /*  615901 */   // Label 9964: @615901
     /*  615901 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(615976), // Rule ID 5794 //
     /*  615906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  615917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  615920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  615923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  615926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615974 */     GIR_RootConstrainSelectedInstOperands,
     /*  615975 */     // GIR_Coverage, 5794,
     /*  615975 */     GIR_EraseRootFromParent_Done,
     /*  615976 */   // Label 9965: @615976
     /*  615976 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(616051), // Rule ID 5795 //
     /*  615981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  615992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  615995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  615998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  616001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616049 */     GIR_RootConstrainSelectedInstOperands,
     /*  616050 */     // GIR_Coverage, 5795,
     /*  616050 */     GIR_EraseRootFromParent_Done,
     /*  616051 */   // Label 9966: @616051
     /*  616051 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(616126), // Rule ID 5798 //
     /*  616056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  616076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616124 */     GIR_RootConstrainSelectedInstOperands,
     /*  616125 */     // GIR_Coverage, 5798,
     /*  616125 */     GIR_EraseRootFromParent_Done,
     /*  616126 */   // Label 9967: @616126
     /*  616126 */   GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(616201), // Rule ID 5799 //
     /*  616131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  616142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  616145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  616148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  616151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616199 */     GIR_RootConstrainSelectedInstOperands,
     /*  616200 */     // GIR_Coverage, 5799,
     /*  616200 */     GIR_EraseRootFromParent_Done,
     /*  616201 */   // Label 9968: @616201
     /*  616201 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(616276), // Rule ID 5802 //
     /*  616206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  616223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  616226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  616252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616274 */     GIR_RootConstrainSelectedInstOperands,
     /*  616275 */     // GIR_Coverage, 5802,
     /*  616275 */     GIR_EraseRootFromParent_Done,
     /*  616276 */   // Label 9969: @616276
     /*  616276 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(616351), // Rule ID 5803 //
     /*  616281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  616292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  616295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  616298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  616301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  616327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616349 */     GIR_RootConstrainSelectedInstOperands,
     /*  616350 */     // GIR_Coverage, 5803,
     /*  616350 */     GIR_EraseRootFromParent_Done,
     /*  616351 */   // Label 9970: @616351
     /*  616351 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(616426), // Rule ID 5806 //
     /*  616356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  616359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  616367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  616373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  616376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  616402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  616421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616424 */     GIR_RootConstrainSelectedInstOperands,
     /*  616425 */     // GIR_Coverage, 5806,
     /*  616425 */     GIR_EraseRootFromParent_Done,
     /*  616426 */   // Label 9971: @616426
     /*  616426 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(616501), // Rule ID 5807 //
     /*  616431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  616434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  616442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  616445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  616448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  616451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  616470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616477 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  616477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  616480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  616496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616499 */     GIR_RootConstrainSelectedInstOperands,
     /*  616500 */     // GIR_Coverage, 5807,
     /*  616500 */     GIR_EraseRootFromParent_Done,
     /*  616501 */   // Label 9972: @616501
     /*  616501 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(616576), // Rule ID 5810 //
     /*  616506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  616517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  616520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  616523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  616526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  616555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616574 */     GIR_RootConstrainSelectedInstOperands,
     /*  616575 */     // GIR_Coverage, 5810,
     /*  616575 */     GIR_EraseRootFromParent_Done,
     /*  616576 */   // Label 9973: @616576
     /*  616576 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(616651), // Rule ID 5811 //
     /*  616581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  616592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  616595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  616598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  616601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616627 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  616630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616649 */     GIR_RootConstrainSelectedInstOperands,
     /*  616650 */     // GIR_Coverage, 5811,
     /*  616650 */     GIR_EraseRootFromParent_Done,
     /*  616651 */   // Label 9974: @616651
     /*  616651 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(616726), // Rule ID 5814 //
     /*  616656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  616667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  616670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  616673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  616676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  616705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616724 */     GIR_RootConstrainSelectedInstOperands,
     /*  616725 */     // GIR_Coverage, 5814,
     /*  616725 */     GIR_EraseRootFromParent_Done,
     /*  616726 */   // Label 9975: @616726
     /*  616726 */   GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(616801), // Rule ID 5815 //
     /*  616731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  616742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  616745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  616748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  616751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616777 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  616780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616799 */     GIR_RootConstrainSelectedInstOperands,
     /*  616800 */     // GIR_Coverage, 5815,
     /*  616800 */     GIR_EraseRootFromParent_Done,
     /*  616801 */   // Label 9976: @616801
     /*  616801 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(616876), // Rule ID 5818 //
     /*  616806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  616817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  616820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  616823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  616826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616852 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  616855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616874 */     GIR_RootConstrainSelectedInstOperands,
     /*  616875 */     // GIR_Coverage, 5818,
     /*  616875 */     GIR_EraseRootFromParent_Done,
     /*  616876 */   // Label 9977: @616876
     /*  616876 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(616951), // Rule ID 5819 //
     /*  616881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  616892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  616895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  616898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  616901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616927 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  616930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616949 */     GIR_RootConstrainSelectedInstOperands,
     /*  616950 */     // GIR_Coverage, 5819,
     /*  616950 */     GIR_EraseRootFromParent_Done,
     /*  616951 */   // Label 9978: @616951
     /*  616951 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(617026), // Rule ID 5822 //
     /*  616956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  616967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  616970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  616973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  616976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617024 */     GIR_RootConstrainSelectedInstOperands,
     /*  617025 */     // GIR_Coverage, 5822,
     /*  617025 */     GIR_EraseRootFromParent_Done,
     /*  617026 */   // Label 9979: @617026
     /*  617026 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(617101), // Rule ID 5823 //
     /*  617031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  617042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  617045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  617048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  617051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617099 */     GIR_RootConstrainSelectedInstOperands,
     /*  617100 */     // GIR_Coverage, 5823,
     /*  617100 */     GIR_EraseRootFromParent_Done,
     /*  617101 */   // Label 9980: @617101
     /*  617101 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(617176), // Rule ID 5826 //
     /*  617106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  617126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617174 */     GIR_RootConstrainSelectedInstOperands,
     /*  617175 */     // GIR_Coverage, 5826,
     /*  617175 */     GIR_EraseRootFromParent_Done,
     /*  617176 */   // Label 9981: @617176
     /*  617176 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(617251), // Rule ID 5827 //
     /*  617181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  617192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  617195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  617198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  617201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617227 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617249 */     GIR_RootConstrainSelectedInstOperands,
     /*  617250 */     // GIR_Coverage, 5827,
     /*  617250 */     GIR_EraseRootFromParent_Done,
     /*  617251 */   // Label 9982: @617251
     /*  617251 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(617326), // Rule ID 5830 //
     /*  617256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  617276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617302 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  617302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617324 */     GIR_RootConstrainSelectedInstOperands,
     /*  617325 */     // GIR_Coverage, 5830,
     /*  617325 */     GIR_EraseRootFromParent_Done,
     /*  617326 */   // Label 9983: @617326
     /*  617326 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(617401), // Rule ID 5831 //
     /*  617331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  617342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  617345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  617348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  617351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  617377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  617396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617399 */     GIR_RootConstrainSelectedInstOperands,
     /*  617400 */     // GIR_Coverage, 5831,
     /*  617400 */     GIR_EraseRootFromParent_Done,
     /*  617401 */   // Label 9984: @617401
     /*  617401 */   GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(617476), // Rule ID 5834 //
     /*  617406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  617417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  617420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  617423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  617426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617474 */     GIR_RootConstrainSelectedInstOperands,
     /*  617475 */     // GIR_Coverage, 5834,
     /*  617475 */     GIR_EraseRootFromParent_Done,
     /*  617476 */   // Label 9985: @617476
     /*  617476 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(617551), // Rule ID 5835 //
     /*  617481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  617492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  617495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  617498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  617501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617549 */     GIR_RootConstrainSelectedInstOperands,
     /*  617550 */     // GIR_Coverage, 5835,
     /*  617550 */     GIR_EraseRootFromParent_Done,
     /*  617551 */   // Label 9986: @617551
     /*  617551 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(617626), // Rule ID 5838 //
     /*  617556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  617567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  617570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  617573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  617576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617624 */     GIR_RootConstrainSelectedInstOperands,
     /*  617625 */     // GIR_Coverage, 5838,
     /*  617625 */     GIR_EraseRootFromParent_Done,
     /*  617626 */   // Label 9987: @617626
     /*  617626 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(617701), // Rule ID 5839 //
     /*  617631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  617642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  617645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  617648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  617651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617677 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617699 */     GIR_RootConstrainSelectedInstOperands,
     /*  617700 */     // GIR_Coverage, 5839,
     /*  617700 */     GIR_EraseRootFromParent_Done,
     /*  617701 */   // Label 9988: @617701
     /*  617701 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(617776), // Rule ID 5842 //
     /*  617706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  617717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  617720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  617723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  617726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617774 */     GIR_RootConstrainSelectedInstOperands,
     /*  617775 */     // GIR_Coverage, 5842,
     /*  617775 */     GIR_EraseRootFromParent_Done,
     /*  617776 */   // Label 9989: @617776
     /*  617776 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(617851), // Rule ID 5843 //
     /*  617781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  617792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  617795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  617798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  617801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617827 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617849 */     GIR_RootConstrainSelectedInstOperands,
     /*  617850 */     // GIR_Coverage, 5843,
     /*  617850 */     GIR_EraseRootFromParent_Done,
     /*  617851 */   // Label 9990: @617851
     /*  617851 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(617926), // Rule ID 5846 //
     /*  617856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  617859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  617867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  617870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  617873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  617876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  617902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617924 */     GIR_RootConstrainSelectedInstOperands,
     /*  617925 */     // GIR_Coverage, 5846,
     /*  617925 */     GIR_EraseRootFromParent_Done,
     /*  617926 */   // Label 9991: @617926
     /*  617926 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(618001), // Rule ID 5847 //
     /*  617931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  617934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  617942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  617945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  617948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  617951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  617977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617999 */     GIR_RootConstrainSelectedInstOperands,
     /*  618000 */     // GIR_Coverage, 5847,
     /*  618000 */     GIR_EraseRootFromParent_Done,
     /*  618001 */   // Label 9992: @618001
     /*  618001 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(618076), // Rule ID 5850 //
     /*  618006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618074 */     GIR_RootConstrainSelectedInstOperands,
     /*  618075 */     // GIR_Coverage, 5850,
     /*  618075 */     GIR_EraseRootFromParent_Done,
     /*  618076 */   // Label 9993: @618076
     /*  618076 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(618151), // Rule ID 5851 //
     /*  618081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  618092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  618095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  618098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  618101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  618120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  618130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618149 */     GIR_RootConstrainSelectedInstOperands,
     /*  618150 */     // GIR_Coverage, 5851,
     /*  618150 */     GIR_EraseRootFromParent_Done,
     /*  618151 */   // Label 9994: @618151
     /*  618151 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(618226), // Rule ID 5854 //
     /*  618156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  618159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  618202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618224 */     GIR_RootConstrainSelectedInstOperands,
     /*  618225 */     // GIR_Coverage, 5854,
     /*  618225 */     GIR_EraseRootFromParent_Done,
     /*  618226 */   // Label 9995: @618226
     /*  618226 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(618301), // Rule ID 5855 //
     /*  618231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  618234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  618242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  618245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  618248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  618251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  618270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618277 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  618277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  618280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  618296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618299 */     GIR_RootConstrainSelectedInstOperands,
     /*  618300 */     // GIR_Coverage, 5855,
     /*  618300 */     GIR_EraseRootFromParent_Done,
     /*  618301 */   // Label 9996: @618301
     /*  618301 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(618376), // Rule ID 5858 //
     /*  618306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  618355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618374 */     GIR_RootConstrainSelectedInstOperands,
     /*  618375 */     // GIR_Coverage, 5858,
     /*  618375 */     GIR_EraseRootFromParent_Done,
     /*  618376 */   // Label 9997: @618376
     /*  618376 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(618451), // Rule ID 5859 //
     /*  618381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  618392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  618395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  618398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618427 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  618430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618449 */     GIR_RootConstrainSelectedInstOperands,
     /*  618450 */     // GIR_Coverage, 5859,
     /*  618450 */     GIR_EraseRootFromParent_Done,
     /*  618451 */   // Label 9998: @618451
     /*  618451 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(618526), // Rule ID 5862 //
     /*  618456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  618467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  618470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  618473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618524 */     GIR_RootConstrainSelectedInstOperands,
     /*  618525 */     // GIR_Coverage, 5862,
     /*  618525 */     GIR_EraseRootFromParent_Done,
     /*  618526 */   // Label 9999: @618526
     /*  618526 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(618601), // Rule ID 5863 //
     /*  618531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  618542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  618545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  618548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618577 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618599 */     GIR_RootConstrainSelectedInstOperands,
     /*  618600 */     // GIR_Coverage, 5863,
     /*  618600 */     GIR_EraseRootFromParent_Done,
     /*  618601 */   // Label 10000: @618601
     /*  618601 */   GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(618676), // Rule ID 5866 //
     /*  618606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  618617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  618620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  618623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618652 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618674 */     GIR_RootConstrainSelectedInstOperands,
     /*  618675 */     // GIR_Coverage, 5866,
     /*  618675 */     GIR_EraseRootFromParent_Done,
     /*  618676 */   // Label 10001: @618676
     /*  618676 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(618751), // Rule ID 5867 //
     /*  618681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  618692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  618695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  618698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618727 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618749 */     GIR_RootConstrainSelectedInstOperands,
     /*  618750 */     // GIR_Coverage, 5867,
     /*  618750 */     GIR_EraseRootFromParent_Done,
     /*  618751 */   // Label 10002: @618751
     /*  618751 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(618826), // Rule ID 5870 //
     /*  618756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  618767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  618770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  618773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  618802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618824 */     GIR_RootConstrainSelectedInstOperands,
     /*  618825 */     // GIR_Coverage, 5870,
     /*  618825 */     GIR_EraseRootFromParent_Done,
     /*  618826 */   // Label 10003: @618826
     /*  618826 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(618901), // Rule ID 5871 //
     /*  618831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  618842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  618845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  618848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  618877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618899 */     GIR_RootConstrainSelectedInstOperands,
     /*  618900 */     // GIR_Coverage, 5871,
     /*  618900 */     GIR_EraseRootFromParent_Done,
     /*  618901 */   // Label 10004: @618901
     /*  618901 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(618976), // Rule ID 5874 //
     /*  618906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  618917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  618920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  618923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618952 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  618952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618974 */     GIR_RootConstrainSelectedInstOperands,
     /*  618975 */     // GIR_Coverage, 5874,
     /*  618975 */     GIR_EraseRootFromParent_Done,
     /*  618976 */   // Label 10005: @618976
     /*  618976 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(619051), // Rule ID 5875 //
     /*  618981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  618992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  618995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  618998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619027 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619049 */     GIR_RootConstrainSelectedInstOperands,
     /*  619050 */     // GIR_Coverage, 5875,
     /*  619050 */     GIR_EraseRootFromParent_Done,
     /*  619051 */   // Label 10006: @619051
     /*  619051 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(619126), // Rule ID 5878 //
     /*  619056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  619102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619124 */     GIR_RootConstrainSelectedInstOperands,
     /*  619125 */     // GIR_Coverage, 5878,
     /*  619125 */     GIR_EraseRootFromParent_Done,
     /*  619126 */   // Label 10007: @619126
     /*  619126 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(619201), // Rule ID 5879 //
     /*  619131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  619142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  619145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  619148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619177 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  619177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  619180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619199 */     GIR_RootConstrainSelectedInstOperands,
     /*  619200 */     // GIR_Coverage, 5879,
     /*  619200 */     GIR_EraseRootFromParent_Done,
     /*  619201 */   // Label 10008: @619201
     /*  619201 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(619276), // Rule ID 5882 //
     /*  619206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619274 */     GIR_RootConstrainSelectedInstOperands,
     /*  619275 */     // GIR_Coverage, 5882,
     /*  619275 */     GIR_EraseRootFromParent_Done,
     /*  619276 */   // Label 10009: @619276
     /*  619276 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(619351), // Rule ID 5883 //
     /*  619281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  619292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  619295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  619298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11156:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619349 */     GIR_RootConstrainSelectedInstOperands,
     /*  619350 */     // GIR_Coverage, 5883,
     /*  619350 */     GIR_EraseRootFromParent_Done,
     /*  619351 */   // Label 10010: @619351
     /*  619351 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(619426), // Rule ID 5886 //
     /*  619356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619424 */     GIR_RootConstrainSelectedInstOperands,
     /*  619425 */     // GIR_Coverage, 5886,
     /*  619425 */     GIR_EraseRootFromParent_Done,
     /*  619426 */   // Label 10011: @619426
     /*  619426 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(619501), // Rule ID 5887 //
     /*  619431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  619442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  619445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  619448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619499 */     GIR_RootConstrainSelectedInstOperands,
     /*  619500 */     // GIR_Coverage, 5887,
     /*  619500 */     GIR_EraseRootFromParent_Done,
     /*  619501 */   // Label 10012: @619501
     /*  619501 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(619576), // Rule ID 5890 //
     /*  619506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  619517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  619520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  619523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  619552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619574 */     GIR_RootConstrainSelectedInstOperands,
     /*  619575 */     // GIR_Coverage, 5890,
     /*  619575 */     GIR_EraseRootFromParent_Done,
     /*  619576 */   // Label 10013: @619576
     /*  619576 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(619651), // Rule ID 5891 //
     /*  619581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  619592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  619595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  619598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  619627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619649 */     GIR_RootConstrainSelectedInstOperands,
     /*  619650 */     // GIR_Coverage, 5891,
     /*  619650 */     GIR_EraseRootFromParent_Done,
     /*  619651 */   // Label 10014: @619651
     /*  619651 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(619726), // Rule ID 5894 //
     /*  619656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  619659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619724 */     GIR_RootConstrainSelectedInstOperands,
     /*  619725 */     // GIR_Coverage, 5894,
     /*  619725 */     GIR_EraseRootFromParent_Done,
     /*  619726 */   // Label 10015: @619726
     /*  619726 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(619801), // Rule ID 5895 //
     /*  619731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  619734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619777 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  619777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619799 */     GIR_RootConstrainSelectedInstOperands,
     /*  619800 */     // GIR_Coverage, 5895,
     /*  619800 */     GIR_EraseRootFromParent_Done,
     /*  619801 */   // Label 10016: @619801
     /*  619801 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(619876), // Rule ID 5898 //
     /*  619806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  619817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  619820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  619823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  619855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619874 */     GIR_RootConstrainSelectedInstOperands,
     /*  619875 */     // GIR_Coverage, 5898,
     /*  619875 */     GIR_EraseRootFromParent_Done,
     /*  619876 */   // Label 10017: @619876
     /*  619876 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(619951), // Rule ID 5899 //
     /*  619881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  619892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  619895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  619898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619927 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  619930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619949 */     GIR_RootConstrainSelectedInstOperands,
     /*  619950 */     // GIR_Coverage, 5899,
     /*  619950 */     GIR_EraseRootFromParent_Done,
     /*  619951 */   // Label 10018: @619951
     /*  619951 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(620026), // Rule ID 5902 //
     /*  619956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  619967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  619970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  619973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620024 */     GIR_RootConstrainSelectedInstOperands,
     /*  620025 */     // GIR_Coverage, 5902,
     /*  620025 */     GIR_EraseRootFromParent_Done,
     /*  620026 */   // Label 10019: @620026
     /*  620026 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(620101), // Rule ID 5903 //
     /*  620031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  620042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  620045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  620048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620077 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620099 */     GIR_RootConstrainSelectedInstOperands,
     /*  620100 */     // GIR_Coverage, 5903,
     /*  620100 */     GIR_EraseRootFromParent_Done,
     /*  620101 */   // Label 10020: @620101
     /*  620101 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(620176), // Rule ID 5906 //
     /*  620106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  620152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620174 */     GIR_RootConstrainSelectedInstOperands,
     /*  620175 */     // GIR_Coverage, 5906,
     /*  620175 */     GIR_EraseRootFromParent_Done,
     /*  620176 */   // Label 10021: @620176
     /*  620176 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(620251), // Rule ID 5907 //
     /*  620181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  620192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  620195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  620198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620227 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  620227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  620246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620249 */     GIR_RootConstrainSelectedInstOperands,
     /*  620250 */     // GIR_Coverage, 5907,
     /*  620250 */     GIR_EraseRootFromParent_Done,
     /*  620251 */   // Label 10022: @620251
     /*  620251 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(620326), // Rule ID 5910 //
     /*  620256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620324 */     GIR_RootConstrainSelectedInstOperands,
     /*  620325 */     // GIR_Coverage, 5910,
     /*  620325 */     GIR_EraseRootFromParent_Done,
     /*  620326 */   // Label 10023: @620326
     /*  620326 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(620401), // Rule ID 5911 //
     /*  620331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  620342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  620345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  620348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620399 */     GIR_RootConstrainSelectedInstOperands,
     /*  620400 */     // GIR_Coverage, 5911,
     /*  620400 */     GIR_EraseRootFromParent_Done,
     /*  620401 */   // Label 10024: @620401
     /*  620401 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(620476), // Rule ID 5914 //
     /*  620406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620474 */     GIR_RootConstrainSelectedInstOperands,
     /*  620475 */     // GIR_Coverage, 5914,
     /*  620475 */     GIR_EraseRootFromParent_Done,
     /*  620476 */   // Label 10025: @620476
     /*  620476 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(620551), // Rule ID 5915 //
     /*  620481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  620492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  620495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  620498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620527 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620549 */     GIR_RootConstrainSelectedInstOperands,
     /*  620550 */     // GIR_Coverage, 5915,
     /*  620550 */     GIR_EraseRootFromParent_Done,
     /*  620551 */   // Label 10026: @620551
     /*  620551 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(620626), // Rule ID 5918 //
     /*  620556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  620567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  620570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  620573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620624 */     GIR_RootConstrainSelectedInstOperands,
     /*  620625 */     // GIR_Coverage, 5918,
     /*  620625 */     GIR_EraseRootFromParent_Done,
     /*  620626 */   // Label 10027: @620626
     /*  620626 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(620701), // Rule ID 5919 //
     /*  620631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  620642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  620645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  620648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620677 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620699 */     GIR_RootConstrainSelectedInstOperands,
     /*  620700 */     // GIR_Coverage, 5919,
     /*  620700 */     GIR_EraseRootFromParent_Done,
     /*  620701 */   // Label 10028: @620701
     /*  620701 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(620776), // Rule ID 5922 //
     /*  620706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  620717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  620720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  620723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620774 */     GIR_RootConstrainSelectedInstOperands,
     /*  620775 */     // GIR_Coverage, 5922,
     /*  620775 */     GIR_EraseRootFromParent_Done,
     /*  620776 */   // Label 10029: @620776
     /*  620776 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(620851), // Rule ID 5923 //
     /*  620781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  620792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  620795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  620798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620849 */     GIR_RootConstrainSelectedInstOperands,
     /*  620850 */     // GIR_Coverage, 5923,
     /*  620850 */     GIR_EraseRootFromParent_Done,
     /*  620851 */   // Label 10030: @620851
     /*  620851 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(620926), // Rule ID 5926 //
     /*  620856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  620867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  620870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  620873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620924 */     GIR_RootConstrainSelectedInstOperands,
     /*  620925 */     // GIR_Coverage, 5926,
     /*  620925 */     GIR_EraseRootFromParent_Done,
     /*  620926 */   // Label 10031: @620926
     /*  620926 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(621001), // Rule ID 5927 //
     /*  620931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  620942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  620945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  620948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620977 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620999 */     GIR_RootConstrainSelectedInstOperands,
     /*  621000 */     // GIR_Coverage, 5927,
     /*  621000 */     GIR_EraseRootFromParent_Done,
     /*  621001 */   // Label 10032: @621001
     /*  621001 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(621076), // Rule ID 5930 //
     /*  621006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621074 */     GIR_RootConstrainSelectedInstOperands,
     /*  621075 */     // GIR_Coverage, 5930,
     /*  621075 */     GIR_EraseRootFromParent_Done,
     /*  621076 */   // Label 10033: @621076
     /*  621076 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(621151), // Rule ID 5931 //
     /*  621081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  621092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  621095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  621098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621127 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621149 */     GIR_RootConstrainSelectedInstOperands,
     /*  621150 */     // GIR_Coverage, 5931,
     /*  621150 */     GIR_EraseRootFromParent_Done,
     /*  621151 */   // Label 10034: @621151
     /*  621151 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(621226), // Rule ID 5934 //
     /*  621156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621202 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621224 */     GIR_RootConstrainSelectedInstOperands,
     /*  621225 */     // GIR_Coverage, 5934,
     /*  621225 */     GIR_EraseRootFromParent_Done,
     /*  621226 */   // Label 10035: @621226
     /*  621226 */   GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(621301), // Rule ID 5935 //
     /*  621231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  621242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  621245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  621248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  621266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  621280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621299 */     GIR_RootConstrainSelectedInstOperands,
     /*  621300 */     // GIR_Coverage, 5935,
     /*  621300 */     GIR_EraseRootFromParent_Done,
     /*  621301 */   // Label 10036: @621301
     /*  621301 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(621376), // Rule ID 5938 //
     /*  621306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621374 */     GIR_RootConstrainSelectedInstOperands,
     /*  621375 */     // GIR_Coverage, 5938,
     /*  621375 */     GIR_EraseRootFromParent_Done,
     /*  621376 */   // Label 10037: @621376
     /*  621376 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(621451), // Rule ID 5939 //
     /*  621381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  621392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  621395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  621398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  621416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621427 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  621430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621449 */     GIR_RootConstrainSelectedInstOperands,
     /*  621450 */     // GIR_Coverage, 5939,
     /*  621450 */     GIR_EraseRootFromParent_Done,
     /*  621451 */   // Label 10038: @621451
     /*  621451 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(621526), // Rule ID 5942 //
     /*  621456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  621459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  621476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  621502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621524 */     GIR_RootConstrainSelectedInstOperands,
     /*  621525 */     // GIR_Coverage, 5942,
     /*  621525 */     GIR_EraseRootFromParent_Done,
     /*  621526 */   // Label 10039: @621526
     /*  621526 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(621601), // Rule ID 5943 //
     /*  621531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621577 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11156:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621599 */     GIR_RootConstrainSelectedInstOperands,
     /*  621600 */     // GIR_Coverage, 5943,
     /*  621600 */     GIR_EraseRootFromParent_Done,
     /*  621601 */   // Label 10040: @621601
     /*  621601 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(621676), // Rule ID 6034 //
     /*  621606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  621617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  621620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  621623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  621626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  621652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  621655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621674 */     GIR_RootConstrainSelectedInstOperands,
     /*  621675 */     // GIR_Coverage, 6034,
     /*  621675 */     GIR_EraseRootFromParent_Done,
     /*  621676 */   // Label 10041: @621676
     /*  621676 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(621751), // Rule ID 6035 //
     /*  621681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  621692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  621695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  621698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  621701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621727 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  621727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  621730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621749 */     GIR_RootConstrainSelectedInstOperands,
     /*  621750 */     // GIR_Coverage, 6035,
     /*  621750 */     GIR_EraseRootFromParent_Done,
     /*  621751 */   // Label 10042: @621751
     /*  621751 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(621826), // Rule ID 6038 //
     /*  621756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  621767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  621770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  621773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  621776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621802 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  621802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  621805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621824 */     GIR_RootConstrainSelectedInstOperands,
     /*  621825 */     // GIR_Coverage, 6038,
     /*  621825 */     GIR_EraseRootFromParent_Done,
     /*  621826 */   // Label 10043: @621826
     /*  621826 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(621901), // Rule ID 6039 //
     /*  621831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  621842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  621845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  621848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  621851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621877 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  621877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  621880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621899 */     GIR_RootConstrainSelectedInstOperands,
     /*  621900 */     // GIR_Coverage, 6039,
     /*  621900 */     GIR_EraseRootFromParent_Done,
     /*  621901 */   // Label 10044: @621901
     /*  621901 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(621976), // Rule ID 6042 //
     /*  621906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  621917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  621920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  621923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  621926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  621952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  621955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621974 */     GIR_RootConstrainSelectedInstOperands,
     /*  621975 */     // GIR_Coverage, 6042,
     /*  621975 */     GIR_EraseRootFromParent_Done,
     /*  621976 */   // Label 10045: @621976
     /*  621976 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(622051), // Rule ID 6043 //
     /*  621981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  621992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  621995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  621998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  622001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622027 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622049 */     GIR_RootConstrainSelectedInstOperands,
     /*  622050 */     // GIR_Coverage, 6043,
     /*  622050 */     GIR_EraseRootFromParent_Done,
     /*  622051 */   // Label 10046: @622051
     /*  622051 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(622126), // Rule ID 6046 //
     /*  622056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622124 */     GIR_RootConstrainSelectedInstOperands,
     /*  622125 */     // GIR_Coverage, 6046,
     /*  622125 */     GIR_EraseRootFromParent_Done,
     /*  622126 */   // Label 10047: @622126
     /*  622126 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(622201), // Rule ID 6047 //
     /*  622131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  622142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  622145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  622148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  622151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  622180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622199 */     GIR_RootConstrainSelectedInstOperands,
     /*  622200 */     // GIR_Coverage, 6047,
     /*  622200 */     GIR_EraseRootFromParent_Done,
     /*  622201 */   // Label 10048: @622201
     /*  622201 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(622276), // Rule ID 6050 //
     /*  622206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622274 */     GIR_RootConstrainSelectedInstOperands,
     /*  622275 */     // GIR_Coverage, 6050,
     /*  622275 */     GIR_EraseRootFromParent_Done,
     /*  622276 */   // Label 10049: @622276
     /*  622276 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(622351), // Rule ID 6051 //
     /*  622281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  622292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  622295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  622298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  622301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622349 */     GIR_RootConstrainSelectedInstOperands,
     /*  622350 */     // GIR_Coverage, 6051,
     /*  622350 */     GIR_EraseRootFromParent_Done,
     /*  622351 */   // Label 10050: @622351
     /*  622351 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(622426), // Rule ID 6054 //
     /*  622356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622424 */     GIR_RootConstrainSelectedInstOperands,
     /*  622425 */     // GIR_Coverage, 6054,
     /*  622425 */     GIR_EraseRootFromParent_Done,
     /*  622426 */   // Label 10051: @622426
     /*  622426 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(622501), // Rule ID 6055 //
     /*  622431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  622442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  622445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  622448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  622451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622477 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  622477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  622480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622499 */     GIR_RootConstrainSelectedInstOperands,
     /*  622500 */     // GIR_Coverage, 6055,
     /*  622500 */     GIR_EraseRootFromParent_Done,
     /*  622501 */   // Label 10052: @622501
     /*  622501 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(622576), // Rule ID 6058 //
     /*  622506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  622520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  622523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  622526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622574 */     GIR_RootConstrainSelectedInstOperands,
     /*  622575 */     // GIR_Coverage, 6058,
     /*  622575 */     GIR_EraseRootFromParent_Done,
     /*  622576 */   // Label 10053: @622576
     /*  622576 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(622651), // Rule ID 6059 //
     /*  622581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  622595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  622598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  622601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622627 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622649 */     GIR_RootConstrainSelectedInstOperands,
     /*  622650 */     // GIR_Coverage, 6059,
     /*  622650 */     GIR_EraseRootFromParent_Done,
     /*  622651 */   // Label 10054: @622651
     /*  622651 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(622726), // Rule ID 6062 //
     /*  622656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  622667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  622670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  622673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  622676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622724 */     GIR_RootConstrainSelectedInstOperands,
     /*  622725 */     // GIR_Coverage, 6062,
     /*  622725 */     GIR_EraseRootFromParent_Done,
     /*  622726 */   // Label 10055: @622726
     /*  622726 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(622801), // Rule ID 6063 //
     /*  622731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  622742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  622745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  622748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  622751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622799 */     GIR_RootConstrainSelectedInstOperands,
     /*  622800 */     // GIR_Coverage, 6063,
     /*  622800 */     GIR_EraseRootFromParent_Done,
     /*  622801 */   // Label 10056: @622801
     /*  622801 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(622876), // Rule ID 6066 //
     /*  622806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  622817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  622820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  622823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  622826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622874 */     GIR_RootConstrainSelectedInstOperands,
     /*  622875 */     // GIR_Coverage, 6066,
     /*  622875 */     GIR_EraseRootFromParent_Done,
     /*  622876 */   // Label 10057: @622876
     /*  622876 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(622951), // Rule ID 6067 //
     /*  622881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  622892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  622895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  622898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  622901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  622927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622949 */     GIR_RootConstrainSelectedInstOperands,
     /*  622950 */     // GIR_Coverage, 6067,
     /*  622950 */     GIR_EraseRootFromParent_Done,
     /*  622951 */   // Label 10058: @622951
     /*  622951 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(623026), // Rule ID 6070 //
     /*  622956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  622959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  622967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  622970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  622973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  622976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  623002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623024 */     GIR_RootConstrainSelectedInstOperands,
     /*  623025 */     // GIR_Coverage, 6070,
     /*  623025 */     GIR_EraseRootFromParent_Done,
     /*  623026 */   // Label 10059: @623026
     /*  623026 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(623101), // Rule ID 6071 //
     /*  623031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  623034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  623042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  623045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  623048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  623051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  623070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623077 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  623077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  623080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  623096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623099 */     GIR_RootConstrainSelectedInstOperands,
     /*  623100 */     // GIR_Coverage, 6071,
     /*  623100 */     GIR_EraseRootFromParent_Done,
     /*  623101 */   // Label 10060: @623101
     /*  623101 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(623176), // Rule ID 6074 //
     /*  623106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623174 */     GIR_RootConstrainSelectedInstOperands,
     /*  623175 */     // GIR_Coverage, 6074,
     /*  623175 */     GIR_EraseRootFromParent_Done,
     /*  623176 */   // Label 10061: @623176
     /*  623176 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(623251), // Rule ID 6075 //
     /*  623181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  623192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  623195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  623198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  623201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623249 */     GIR_RootConstrainSelectedInstOperands,
     /*  623250 */     // GIR_Coverage, 6075,
     /*  623250 */     GIR_EraseRootFromParent_Done,
     /*  623251 */   // Label 10062: @623251
     /*  623251 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(623326), // Rule ID 6078 //
     /*  623256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623302 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623324 */     GIR_RootConstrainSelectedInstOperands,
     /*  623325 */     // GIR_Coverage, 6078,
     /*  623325 */     GIR_EraseRootFromParent_Done,
     /*  623326 */   // Label 10063: @623326
     /*  623326 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(623401), // Rule ID 6079 //
     /*  623331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  623342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  623345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  623348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  623351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623377 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623399 */     GIR_RootConstrainSelectedInstOperands,
     /*  623400 */     // GIR_Coverage, 6079,
     /*  623400 */     GIR_EraseRootFromParent_Done,
     /*  623401 */   // Label 10064: @623401
     /*  623401 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(623476), // Rule ID 6082 //
     /*  623406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623452 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  623452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623474 */     GIR_RootConstrainSelectedInstOperands,
     /*  623475 */     // GIR_Coverage, 6082,
     /*  623475 */     GIR_EraseRootFromParent_Done,
     /*  623476 */   // Label 10065: @623476
     /*  623476 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(623551), // Rule ID 6083 //
     /*  623481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  623492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  623495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  623498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  623501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623527 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623549 */     GIR_RootConstrainSelectedInstOperands,
     /*  623550 */     // GIR_Coverage, 6083,
     /*  623550 */     GIR_EraseRootFromParent_Done,
     /*  623551 */   // Label 10066: @623551
     /*  623551 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(623626), // Rule ID 6086 //
     /*  623556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  623567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  623570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  623573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  623576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623624 */     GIR_RootConstrainSelectedInstOperands,
     /*  623625 */     // GIR_Coverage, 6086,
     /*  623625 */     GIR_EraseRootFromParent_Done,
     /*  623626 */   // Label 10067: @623626
     /*  623626 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(623701), // Rule ID 6087 //
     /*  623631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  623642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  623645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  623648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  623651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623677 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623699 */     GIR_RootConstrainSelectedInstOperands,
     /*  623700 */     // GIR_Coverage, 6087,
     /*  623700 */     GIR_EraseRootFromParent_Done,
     /*  623701 */   // Label 10068: @623701
     /*  623701 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(623776), // Rule ID 6090 //
     /*  623706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  623717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  623720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  623723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  623726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623752 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623774 */     GIR_RootConstrainSelectedInstOperands,
     /*  623775 */     // GIR_Coverage, 6090,
     /*  623775 */     GIR_EraseRootFromParent_Done,
     /*  623776 */   // Label 10069: @623776
     /*  623776 */   GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(623851), // Rule ID 6091 //
     /*  623781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  623792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  623795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  623798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  623801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623827 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623849 */     GIR_RootConstrainSelectedInstOperands,
     /*  623850 */     // GIR_Coverage, 6091,
     /*  623850 */     GIR_EraseRootFromParent_Done,
     /*  623851 */   // Label 10070: @623851
     /*  623851 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(623926), // Rule ID 6094 //
     /*  623856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  623867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  623870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  623873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  623876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623924 */     GIR_RootConstrainSelectedInstOperands,
     /*  623925 */     // GIR_Coverage, 6094,
     /*  623925 */     GIR_EraseRootFromParent_Done,
     /*  623926 */   // Label 10071: @623926
     /*  623926 */   GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(624001), // Rule ID 6095 //
     /*  623931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  623942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  623945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  623948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  623951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623977 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623999 */     GIR_RootConstrainSelectedInstOperands,
     /*  624000 */     // GIR_Coverage, 6095,
     /*  624000 */     GIR_EraseRootFromParent_Done,
     /*  624001 */   // Label 10072: @624001
     /*  624001 */   GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(624076), // Rule ID 6098 //
     /*  624006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624074 */     GIR_RootConstrainSelectedInstOperands,
     /*  624075 */     // GIR_Coverage, 6098,
     /*  624075 */     GIR_EraseRootFromParent_Done,
     /*  624076 */   // Label 10073: @624076
     /*  624076 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(624151), // Rule ID 6099 //
     /*  624081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  624092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  624095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  624098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  624101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624149 */     GIR_RootConstrainSelectedInstOperands,
     /*  624150 */     // GIR_Coverage, 6099,
     /*  624150 */     GIR_EraseRootFromParent_Done,
     /*  624151 */   // Label 10074: @624151
     /*  624151 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(624226), // Rule ID 6102 //
     /*  624156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624202 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624224 */     GIR_RootConstrainSelectedInstOperands,
     /*  624225 */     // GIR_Coverage, 6102,
     /*  624225 */     GIR_EraseRootFromParent_Done,
     /*  624226 */   // Label 10075: @624226
     /*  624226 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(624301), // Rule ID 6103 //
     /*  624231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  624242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  624245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  624248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  624251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624277 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624299 */     GIR_RootConstrainSelectedInstOperands,
     /*  624300 */     // GIR_Coverage, 6103,
     /*  624300 */     GIR_EraseRootFromParent_Done,
     /*  624301 */   // Label 10076: @624301
     /*  624301 */   GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(624376), // Rule ID 6106 //
     /*  624306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  624352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624374 */     GIR_RootConstrainSelectedInstOperands,
     /*  624375 */     // GIR_Coverage, 6106,
     /*  624375 */     GIR_EraseRootFromParent_Done,
     /*  624376 */   // Label 10077: @624376
     /*  624376 */   GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(624451), // Rule ID 6107 //
     /*  624381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  624392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  624395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  624398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  624401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624427 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  624427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  624446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624449 */     GIR_RootConstrainSelectedInstOperands,
     /*  624450 */     // GIR_Coverage, 6107,
     /*  624450 */     GIR_EraseRootFromParent_Done,
     /*  624451 */   // Label 10078: @624451
     /*  624451 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(624526), // Rule ID 6110 //
     /*  624456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  624467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  624470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  624473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  624476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624524 */     GIR_RootConstrainSelectedInstOperands,
     /*  624525 */     // GIR_Coverage, 6110,
     /*  624525 */     GIR_EraseRootFromParent_Done,
     /*  624526 */   // Label 10079: @624526
     /*  624526 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(624601), // Rule ID 6111 //
     /*  624531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  624542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  624545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  624548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  624551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624599 */     GIR_RootConstrainSelectedInstOperands,
     /*  624600 */     // GIR_Coverage, 6111,
     /*  624600 */     GIR_EraseRootFromParent_Done,
     /*  624601 */   // Label 10080: @624601
     /*  624601 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(624676), // Rule ID 6114 //
     /*  624606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  624617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  624620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  624623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  624626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624674 */     GIR_RootConstrainSelectedInstOperands,
     /*  624675 */     // GIR_Coverage, 6114,
     /*  624675 */     GIR_EraseRootFromParent_Done,
     /*  624676 */   // Label 10081: @624676
     /*  624676 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(624751), // Rule ID 6115 //
     /*  624681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  624692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  624695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  624698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  624701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624727 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624749 */     GIR_RootConstrainSelectedInstOperands,
     /*  624750 */     // GIR_Coverage, 6115,
     /*  624750 */     GIR_EraseRootFromParent_Done,
     /*  624751 */   // Label 10082: @624751
     /*  624751 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(624826), // Rule ID 6118 //
     /*  624756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  624767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  624770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  624773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  624776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624802 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624824 */     GIR_RootConstrainSelectedInstOperands,
     /*  624825 */     // GIR_Coverage, 6118,
     /*  624825 */     GIR_EraseRootFromParent_Done,
     /*  624826 */   // Label 10083: @624826
     /*  624826 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(624901), // Rule ID 6119 //
     /*  624831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  624842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  624845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  624848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  624851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624877 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624899 */     GIR_RootConstrainSelectedInstOperands,
     /*  624900 */     // GIR_Coverage, 6119,
     /*  624900 */     GIR_EraseRootFromParent_Done,
     /*  624901 */   // Label 10084: @624901
     /*  624901 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(624976), // Rule ID 6122 //
     /*  624906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  624917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  624920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  624923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  624952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  624955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624974 */     GIR_RootConstrainSelectedInstOperands,
     /*  624975 */     // GIR_Coverage, 6122,
     /*  624975 */     GIR_EraseRootFromParent_Done,
     /*  624976 */   // Label 10085: @624976
     /*  624976 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(625051), // Rule ID 6123 //
     /*  624981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  624992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  624995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  624998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625027 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  625030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625049 */     GIR_RootConstrainSelectedInstOperands,
     /*  625050 */     // GIR_Coverage, 6123,
     /*  625050 */     GIR_EraseRootFromParent_Done,
     /*  625051 */   // Label 10086: @625051
     /*  625051 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(625126), // Rule ID 6126 //
     /*  625056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625102 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625124 */     GIR_RootConstrainSelectedInstOperands,
     /*  625125 */     // GIR_Coverage, 6126,
     /*  625125 */     GIR_EraseRootFromParent_Done,
     /*  625126 */   // Label 10087: @625126
     /*  625126 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(625201), // Rule ID 6127 //
     /*  625131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  625142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  625145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  625148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625177 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625199 */     GIR_RootConstrainSelectedInstOperands,
     /*  625200 */     // GIR_Coverage, 6127,
     /*  625200 */     GIR_EraseRootFromParent_Done,
     /*  625201 */   // Label 10088: @625201
     /*  625201 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(625276), // Rule ID 6130 //
     /*  625206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625252 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625274 */     GIR_RootConstrainSelectedInstOperands,
     /*  625275 */     // GIR_Coverage, 6130,
     /*  625275 */     GIR_EraseRootFromParent_Done,
     /*  625276 */   // Label 10089: @625276
     /*  625276 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(625351), // Rule ID 6131 //
     /*  625281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  625292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  625295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  625298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625327 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625349 */     GIR_RootConstrainSelectedInstOperands,
     /*  625350 */     // GIR_Coverage, 6131,
     /*  625350 */     GIR_EraseRootFromParent_Done,
     /*  625351 */   // Label 10090: @625351
     /*  625351 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(625426), // Rule ID 6134 //
     /*  625356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625402 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625424 */     GIR_RootConstrainSelectedInstOperands,
     /*  625425 */     // GIR_Coverage, 6134,
     /*  625425 */     GIR_EraseRootFromParent_Done,
     /*  625426 */   // Label 10091: @625426
     /*  625426 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(625501), // Rule ID 6135 //
     /*  625431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  625442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  625445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  625448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625477 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  625477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  625480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625499 */     GIR_RootConstrainSelectedInstOperands,
     /*  625500 */     // GIR_Coverage, 6135,
     /*  625500 */     GIR_EraseRootFromParent_Done,
     /*  625501 */   // Label 10092: @625501
     /*  625501 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(625576), // Rule ID 6138 //
     /*  625506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  625520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  625523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625574 */     GIR_RootConstrainSelectedInstOperands,
     /*  625575 */     // GIR_Coverage, 6138,
     /*  625575 */     GIR_EraseRootFromParent_Done,
     /*  625576 */   // Label 10093: @625576
     /*  625576 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(625651), // Rule ID 6139 //
     /*  625581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  625595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  625598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625627 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  625627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625649 */     GIR_RootConstrainSelectedInstOperands,
     /*  625650 */     // GIR_Coverage, 6139,
     /*  625650 */     GIR_EraseRootFromParent_Done,
     /*  625651 */   // Label 10094: @625651
     /*  625651 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(625726), // Rule ID 6142 //
     /*  625656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  625667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  625670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  625673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  625702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  625721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625724 */     GIR_RootConstrainSelectedInstOperands,
     /*  625725 */     // GIR_Coverage, 6142,
     /*  625725 */     GIR_EraseRootFromParent_Done,
     /*  625726 */   // Label 10095: @625726
     /*  625726 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(625801), // Rule ID 6143 //
     /*  625731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  625742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  625745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  625748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625777 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  625777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  625796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625799 */     GIR_RootConstrainSelectedInstOperands,
     /*  625800 */     // GIR_Coverage, 6143,
     /*  625800 */     GIR_EraseRootFromParent_Done,
     /*  625801 */   // Label 10096: @625801
     /*  625801 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(625876), // Rule ID 6146 //
     /*  625806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  625817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  625820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  625823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625852 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625874 */     GIR_RootConstrainSelectedInstOperands,
     /*  625875 */     // GIR_Coverage, 6146,
     /*  625875 */     GIR_EraseRootFromParent_Done,
     /*  625876 */   // Label 10097: @625876
     /*  625876 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(625951), // Rule ID 6147 //
     /*  625881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  625892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  625895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  625898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625927 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11495:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625949 */     GIR_RootConstrainSelectedInstOperands,
     /*  625950 */     // GIR_Coverage, 6147,
     /*  625950 */     GIR_EraseRootFromParent_Done,
     /*  625951 */   // Label 10098: @625951
     /*  625951 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(626026), // Rule ID 6150 //
     /*  625956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  625967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  625970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  625973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626024 */     GIR_RootConstrainSelectedInstOperands,
     /*  626025 */     // GIR_Coverage, 6150,
     /*  626025 */     GIR_EraseRootFromParent_Done,
     /*  626026 */   // Label 10099: @626026
     /*  626026 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(626101), // Rule ID 6151 //
     /*  626031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  626042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  626045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  626048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626077 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11495:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626099 */     GIR_RootConstrainSelectedInstOperands,
     /*  626100 */     // GIR_Coverage, 6151,
     /*  626100 */     GIR_EraseRootFromParent_Done,
     /*  626101 */   // Label 10100: @626101
     /*  626101 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(626176), // Rule ID 6154 //
     /*  626106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626174 */     GIR_RootConstrainSelectedInstOperands,
     /*  626175 */     // GIR_Coverage, 6154,
     /*  626175 */     GIR_EraseRootFromParent_Done,
     /*  626176 */   // Label 10101: @626176
     /*  626176 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(626251), // Rule ID 6155 //
     /*  626181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  626192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  626195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  626198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11495:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626249 */     GIR_RootConstrainSelectedInstOperands,
     /*  626250 */     // GIR_Coverage, 6155,
     /*  626250 */     GIR_EraseRootFromParent_Done,
     /*  626251 */   // Label 10102: @626251
     /*  626251 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(626326), // Rule ID 6158 //
     /*  626256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  626259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  626302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626324 */     GIR_RootConstrainSelectedInstOperands,
     /*  626325 */     // GIR_Coverage, 6158,
     /*  626325 */     GIR_EraseRootFromParent_Done,
     /*  626326 */   // Label 10103: @626326
     /*  626326 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(626401), // Rule ID 6159 //
     /*  626331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  626334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  626342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  626345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  626348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  626366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626377 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11495:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  626377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  626380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  626396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626399 */     GIR_RootConstrainSelectedInstOperands,
     /*  626400 */     // GIR_Coverage, 6159,
     /*  626400 */     GIR_EraseRootFromParent_Done,
     /*  626401 */   // Label 10104: @626401
     /*  626401 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(626476), // Rule ID 6162 //
     /*  626406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626474 */     GIR_RootConstrainSelectedInstOperands,
     /*  626475 */     // GIR_Coverage, 6162,
     /*  626475 */     GIR_EraseRootFromParent_Done,
     /*  626476 */   // Label 10105: @626476
     /*  626476 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(626551), // Rule ID 6163 //
     /*  626481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  626492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  626495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  626498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626527 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626549 */     GIR_RootConstrainSelectedInstOperands,
     /*  626550 */     // GIR_Coverage, 6163,
     /*  626550 */     GIR_EraseRootFromParent_Done,
     /*  626551 */   // Label 10106: @626551
     /*  626551 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(626626), // Rule ID 6166 //
     /*  626556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  626567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  626570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  626573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626602 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  626605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626624 */     GIR_RootConstrainSelectedInstOperands,
     /*  626625 */     // GIR_Coverage, 6166,
     /*  626625 */     GIR_EraseRootFromParent_Done,
     /*  626626 */   // Label 10107: @626626
     /*  626626 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(626701), // Rule ID 6167 //
     /*  626631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  626642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  626645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  626648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626677 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  626680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626699 */     GIR_RootConstrainSelectedInstOperands,
     /*  626700 */     // GIR_Coverage, 6167,
     /*  626700 */     GIR_EraseRootFromParent_Done,
     /*  626701 */   // Label 10108: @626701
     /*  626701 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(626776), // Rule ID 6170 //
     /*  626706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  626717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  626720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  626723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626752 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  626755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626774 */     GIR_RootConstrainSelectedInstOperands,
     /*  626775 */     // GIR_Coverage, 6170,
     /*  626775 */     GIR_EraseRootFromParent_Done,
     /*  626776 */   // Label 10109: @626776
     /*  626776 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(626851), // Rule ID 6171 //
     /*  626781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  626792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  626795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  626798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626827 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  626830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626849 */     GIR_RootConstrainSelectedInstOperands,
     /*  626850 */     // GIR_Coverage, 6171,
     /*  626850 */     GIR_EraseRootFromParent_Done,
     /*  626851 */   // Label 10110: @626851
     /*  626851 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(626926), // Rule ID 6174 //
     /*  626856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  626867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  626870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  626873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626924 */     GIR_RootConstrainSelectedInstOperands,
     /*  626925 */     // GIR_Coverage, 6174,
     /*  626925 */     GIR_EraseRootFromParent_Done,
     /*  626926 */   // Label 10111: @626926
     /*  626926 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(627001), // Rule ID 6175 //
     /*  626931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  626942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  626945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  626948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626977 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626999 */     GIR_RootConstrainSelectedInstOperands,
     /*  627000 */     // GIR_Coverage, 6175,
     /*  627000 */     GIR_EraseRootFromParent_Done,
     /*  627001 */   // Label 10112: @627001
     /*  627001 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(627076), // Rule ID 6178 //
     /*  627006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627074 */     GIR_RootConstrainSelectedInstOperands,
     /*  627075 */     // GIR_Coverage, 6178,
     /*  627075 */     GIR_EraseRootFromParent_Done,
     /*  627076 */   // Label 10113: @627076
     /*  627076 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(627151), // Rule ID 6179 //
     /*  627081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  627092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  627095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  627098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627127 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627149 */     GIR_RootConstrainSelectedInstOperands,
     /*  627150 */     // GIR_Coverage, 6179,
     /*  627150 */     GIR_EraseRootFromParent_Done,
     /*  627151 */   // Label 10114: @627151
     /*  627151 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(627226), // Rule ID 6182 //
     /*  627156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  627202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627224 */     GIR_RootConstrainSelectedInstOperands,
     /*  627225 */     // GIR_Coverage, 6182,
     /*  627225 */     GIR_EraseRootFromParent_Done,
     /*  627226 */   // Label 10115: @627226
     /*  627226 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(627301), // Rule ID 6183 //
     /*  627231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  627242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  627245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  627248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627277 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  627277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  627296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627299 */     GIR_RootConstrainSelectedInstOperands,
     /*  627300 */     // GIR_Coverage, 6183,
     /*  627300 */     GIR_EraseRootFromParent_Done,
     /*  627301 */   // Label 10116: @627301
     /*  627301 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(627376), // Rule ID 6186 //
     /*  627306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627374 */     GIR_RootConstrainSelectedInstOperands,
     /*  627375 */     // GIR_Coverage, 6186,
     /*  627375 */     GIR_EraseRootFromParent_Done,
     /*  627376 */   // Label 10117: @627376
     /*  627376 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(627451), // Rule ID 6187 //
     /*  627381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  627392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  627395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  627398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627449 */     GIR_RootConstrainSelectedInstOperands,
     /*  627450 */     // GIR_Coverage, 6187,
     /*  627450 */     GIR_EraseRootFromParent_Done,
     /*  627451 */   // Label 10118: @627451
     /*  627451 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(627526), // Rule ID 6190 //
     /*  627456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  627467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  627470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  627473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627524 */     GIR_RootConstrainSelectedInstOperands,
     /*  627525 */     // GIR_Coverage, 6190,
     /*  627525 */     GIR_EraseRootFromParent_Done,
     /*  627526 */   // Label 10119: @627526
     /*  627526 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(627601), // Rule ID 6191 //
     /*  627531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  627542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  627545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  627548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627599 */     GIR_RootConstrainSelectedInstOperands,
     /*  627600 */     // GIR_Coverage, 6191,
     /*  627600 */     GIR_EraseRootFromParent_Done,
     /*  627601 */   // Label 10120: @627601
     /*  627601 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(627676), // Rule ID 6194 //
     /*  627606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  627617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  627620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  627623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627674 */     GIR_RootConstrainSelectedInstOperands,
     /*  627675 */     // GIR_Coverage, 6194,
     /*  627675 */     GIR_EraseRootFromParent_Done,
     /*  627676 */   // Label 10121: @627676
     /*  627676 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(627751), // Rule ID 6195 //
     /*  627681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  627692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  627695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  627698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627727 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627749 */     GIR_RootConstrainSelectedInstOperands,
     /*  627750 */     // GIR_Coverage, 6195,
     /*  627750 */     GIR_EraseRootFromParent_Done,
     /*  627751 */   // Label 10122: @627751
     /*  627751 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(627826), // Rule ID 6198 //
     /*  627756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  627759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  627767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  627770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  627773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  627802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627824 */     GIR_RootConstrainSelectedInstOperands,
     /*  627825 */     // GIR_Coverage, 6198,
     /*  627825 */     GIR_EraseRootFromParent_Done,
     /*  627826 */   // Label 10123: @627826
     /*  627826 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(627901), // Rule ID 6199 //
     /*  627831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  627834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  627842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  627845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  627848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627877 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11495:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  627877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627899 */     GIR_RootConstrainSelectedInstOperands,
     /*  627900 */     // GIR_Coverage, 6199,
     /*  627900 */     GIR_EraseRootFromParent_Done,
     /*  627901 */   // Label 10124: @627901
     /*  627901 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(627976), // Rule ID 6202 //
     /*  627906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  627909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  627917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  627920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  627923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  627952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627974 */     GIR_RootConstrainSelectedInstOperands,
     /*  627975 */     // GIR_Coverage, 6202,
     /*  627975 */     GIR_EraseRootFromParent_Done,
     /*  627976 */   // Label 10125: @627976
     /*  627976 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(628051), // Rule ID 6203 //
     /*  627981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  627984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  627992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  627995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  627998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  628016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628027 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11495:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  628030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628049 */     GIR_RootConstrainSelectedInstOperands,
     /*  628050 */     // GIR_Coverage, 6203,
     /*  628050 */     GIR_EraseRootFromParent_Done,
     /*  628051 */   // Label 10126: @628051
     /*  628051 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(628126), // Rule ID 6206 //
     /*  628056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  628059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  628076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  628102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628124 */     GIR_RootConstrainSelectedInstOperands,
     /*  628125 */     // GIR_Coverage, 6206,
     /*  628125 */     GIR_EraseRootFromParent_Done,
     /*  628126 */   // Label 10127: @628126
     /*  628126 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(628201), // Rule ID 6207 //
     /*  628131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  628134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  628139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  628142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  628145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  628148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  628151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  628166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  628170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628177 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11495:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  628177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  628180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  628196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628199 */     GIR_RootConstrainSelectedInstOperands,
     /*  628200 */     // GIR_Coverage, 6207,
     /*  628200 */     GIR_EraseRootFromParent_Done,
     /*  628201 */   // Label 10128: @628201
     /*  628201 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(628276), // Rule ID 6298 //
     /*  628206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628252 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  628255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628274 */     GIR_RootConstrainSelectedInstOperands,
     /*  628275 */     // GIR_Coverage, 6298,
     /*  628275 */     GIR_EraseRootFromParent_Done,
     /*  628276 */   // Label 10129: @628276
     /*  628276 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(628351), // Rule ID 6299 //
     /*  628281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  628292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  628295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  628298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  628301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628327 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  628330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628349 */     GIR_RootConstrainSelectedInstOperands,
     /*  628350 */     // GIR_Coverage, 6299,
     /*  628350 */     GIR_EraseRootFromParent_Done,
     /*  628351 */   // Label 10130: @628351
     /*  628351 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(628426), // Rule ID 6302 //
     /*  628356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628402 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628424 */     GIR_RootConstrainSelectedInstOperands,
     /*  628425 */     // GIR_Coverage, 6302,
     /*  628425 */     GIR_EraseRootFromParent_Done,
     /*  628426 */   // Label 10131: @628426
     /*  628426 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(628501), // Rule ID 6303 //
     /*  628431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  628442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  628445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  628448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  628451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628477 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628499 */     GIR_RootConstrainSelectedInstOperands,
     /*  628500 */     // GIR_Coverage, 6303,
     /*  628500 */     GIR_EraseRootFromParent_Done,
     /*  628501 */   // Label 10132: @628501
     /*  628501 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(628576), // Rule ID 6306 //
     /*  628506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  628520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  628523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  628526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628574 */     GIR_RootConstrainSelectedInstOperands,
     /*  628575 */     // GIR_Coverage, 6306,
     /*  628575 */     GIR_EraseRootFromParent_Done,
     /*  628576 */   // Label 10133: @628576
     /*  628576 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(628651), // Rule ID 6307 //
     /*  628581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  628595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  628598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  628601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628627 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628649 */     GIR_RootConstrainSelectedInstOperands,
     /*  628650 */     // GIR_Coverage, 6307,
     /*  628650 */     GIR_EraseRootFromParent_Done,
     /*  628651 */   // Label 10134: @628651
     /*  628651 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(628726), // Rule ID 6310 //
     /*  628656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  628667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  628670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  628673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  628676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628702 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  628702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628724 */     GIR_RootConstrainSelectedInstOperands,
     /*  628725 */     // GIR_Coverage, 6310,
     /*  628725 */     GIR_EraseRootFromParent_Done,
     /*  628726 */   // Label 10135: @628726
     /*  628726 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(628801), // Rule ID 6311 //
     /*  628731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  628742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  628745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  628748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  628751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628777 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  628777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628799 */     GIR_RootConstrainSelectedInstOperands,
     /*  628800 */     // GIR_Coverage, 6311,
     /*  628800 */     GIR_EraseRootFromParent_Done,
     /*  628801 */   // Label 10136: @628801
     /*  628801 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(628876), // Rule ID 6314 //
     /*  628806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  628817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  628820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  628823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  628826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  628852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628874 */     GIR_RootConstrainSelectedInstOperands,
     /*  628875 */     // GIR_Coverage, 6314,
     /*  628875 */     GIR_EraseRootFromParent_Done,
     /*  628876 */   // Label 10137: @628876
     /*  628876 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(628951), // Rule ID 6315 //
     /*  628881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  628892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  628895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  628898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  628901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628927 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  628927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628949 */     GIR_RootConstrainSelectedInstOperands,
     /*  628950 */     // GIR_Coverage, 6315,
     /*  628950 */     GIR_EraseRootFromParent_Done,
     /*  628951 */   // Label 10138: @628951
     /*  628951 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(629026), // Rule ID 6318 //
     /*  628956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  628967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  628970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  628973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  628976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629002 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629024 */     GIR_RootConstrainSelectedInstOperands,
     /*  629025 */     // GIR_Coverage, 6318,
     /*  629025 */     GIR_EraseRootFromParent_Done,
     /*  629026 */   // Label 10139: @629026
     /*  629026 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(629101), // Rule ID 6319 //
     /*  629031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  629042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  629045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  629048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  629051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629077 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  629080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629099 */     GIR_RootConstrainSelectedInstOperands,
     /*  629100 */     // GIR_Coverage, 6319,
     /*  629100 */     GIR_EraseRootFromParent_Done,
     /*  629101 */   // Label 10140: @629101
     /*  629101 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(629176), // Rule ID 6322 //
     /*  629106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629174 */     GIR_RootConstrainSelectedInstOperands,
     /*  629175 */     // GIR_Coverage, 6322,
     /*  629175 */     GIR_EraseRootFromParent_Done,
     /*  629176 */   // Label 10141: @629176
     /*  629176 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(629251), // Rule ID 6323 //
     /*  629181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  629192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  629195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  629198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  629201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629249 */     GIR_RootConstrainSelectedInstOperands,
     /*  629250 */     // GIR_Coverage, 6323,
     /*  629250 */     GIR_EraseRootFromParent_Done,
     /*  629251 */   // Label 10142: @629251
     /*  629251 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(629326), // Rule ID 6326 //
     /*  629256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629324 */     GIR_RootConstrainSelectedInstOperands,
     /*  629325 */     // GIR_Coverage, 6326,
     /*  629325 */     GIR_EraseRootFromParent_Done,
     /*  629326 */   // Label 10143: @629326
     /*  629326 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(629401), // Rule ID 6327 //
     /*  629331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  629342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  629345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  629348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  629351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629399 */     GIR_RootConstrainSelectedInstOperands,
     /*  629400 */     // GIR_Coverage, 6327,
     /*  629400 */     GIR_EraseRootFromParent_Done,
     /*  629401 */   // Label 10144: @629401
     /*  629401 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(629476), // Rule ID 6330 //
     /*  629406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  629452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629474 */     GIR_RootConstrainSelectedInstOperands,
     /*  629475 */     // GIR_Coverage, 6330,
     /*  629475 */     GIR_EraseRootFromParent_Done,
     /*  629476 */   // Label 10145: @629476
     /*  629476 */   GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(629551), // Rule ID 6331 //
     /*  629481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  629492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  629495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  629498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  629501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629549 */     GIR_RootConstrainSelectedInstOperands,
     /*  629550 */     // GIR_Coverage, 6331,
     /*  629550 */     GIR_EraseRootFromParent_Done,
     /*  629551 */   // Label 10146: @629551
     /*  629551 */   GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(629626), // Rule ID 6334 //
     /*  629556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  629559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  629567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  629570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  629573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  629576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  629602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  629621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629624 */     GIR_RootConstrainSelectedInstOperands,
     /*  629625 */     // GIR_Coverage, 6334,
     /*  629625 */     GIR_EraseRootFromParent_Done,
     /*  629626 */   // Label 10147: @629626
     /*  629626 */   GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(629701), // Rule ID 6335 //
     /*  629631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  629634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  629642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  629645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  629648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  629651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  629677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  629696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629699 */     GIR_RootConstrainSelectedInstOperands,
     /*  629700 */     // GIR_Coverage, 6335,
     /*  629700 */     GIR_EraseRootFromParent_Done,
     /*  629701 */   // Label 10148: @629701
     /*  629701 */   GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(629776), // Rule ID 6338 //
     /*  629706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  629717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  629720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  629723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  629726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  629755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629774 */     GIR_RootConstrainSelectedInstOperands,
     /*  629775 */     // GIR_Coverage, 6338,
     /*  629775 */     GIR_EraseRootFromParent_Done,
     /*  629776 */   // Label 10149: @629776
     /*  629776 */   GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(629851), // Rule ID 6339 //
     /*  629781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  629792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  629795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  629798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  629801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  629830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629849 */     GIR_RootConstrainSelectedInstOperands,
     /*  629850 */     // GIR_Coverage, 6339,
     /*  629850 */     GIR_EraseRootFromParent_Done,
     /*  629851 */   // Label 10150: @629851
     /*  629851 */   GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(629926), // Rule ID 6342 //
     /*  629856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  629867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  629870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  629873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  629876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629902 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  629905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629924 */     GIR_RootConstrainSelectedInstOperands,
     /*  629925 */     // GIR_Coverage, 6342,
     /*  629925 */     GIR_EraseRootFromParent_Done,
     /*  629926 */   // Label 10151: @629926
     /*  629926 */   GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(630001), // Rule ID 6343 //
     /*  629931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  629942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  629945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  629948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  629951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629977 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  629980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629999 */     GIR_RootConstrainSelectedInstOperands,
     /*  630000 */     // GIR_Coverage, 6343,
     /*  630000 */     GIR_EraseRootFromParent_Done,
     /*  630001 */   // Label 10152: @630001
     /*  630001 */   GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(630076), // Rule ID 6346 //
     /*  630006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  630052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630074 */     GIR_RootConstrainSelectedInstOperands,
     /*  630075 */     // GIR_Coverage, 6346,
     /*  630075 */     GIR_EraseRootFromParent_Done,
     /*  630076 */   // Label 10153: @630076
     /*  630076 */   GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(630151), // Rule ID 6347 //
     /*  630081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  630092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  630095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  630098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  630101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630127 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  630127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  630146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630149 */     GIR_RootConstrainSelectedInstOperands,
     /*  630150 */     // GIR_Coverage, 6347,
     /*  630150 */     GIR_EraseRootFromParent_Done,
     /*  630151 */   // Label 10154: @630151
     /*  630151 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(630226), // Rule ID 6350 //
     /*  630156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630224 */     GIR_RootConstrainSelectedInstOperands,
     /*  630225 */     // GIR_Coverage, 6350,
     /*  630225 */     GIR_EraseRootFromParent_Done,
     /*  630226 */   // Label 10155: @630226
     /*  630226 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(630301), // Rule ID 6351 //
     /*  630231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  630242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  630245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  630248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  630251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630299 */     GIR_RootConstrainSelectedInstOperands,
     /*  630300 */     // GIR_Coverage, 6351,
     /*  630300 */     GIR_EraseRootFromParent_Done,
     /*  630301 */   // Label 10156: @630301
     /*  630301 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(630376), // Rule ID 6354 //
     /*  630306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630374 */     GIR_RootConstrainSelectedInstOperands,
     /*  630375 */     // GIR_Coverage, 6354,
     /*  630375 */     GIR_EraseRootFromParent_Done,
     /*  630376 */   // Label 10157: @630376
     /*  630376 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(630451), // Rule ID 6355 //
     /*  630381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  630392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  630395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  630398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  630401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630427 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630449 */     GIR_RootConstrainSelectedInstOperands,
     /*  630450 */     // GIR_Coverage, 6355,
     /*  630450 */     GIR_EraseRootFromParent_Done,
     /*  630451 */   // Label 10158: @630451
     /*  630451 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(630526), // Rule ID 6358 //
     /*  630456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  630467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  630470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  630473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  630476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  630502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630524 */     GIR_RootConstrainSelectedInstOperands,
     /*  630525 */     // GIR_Coverage, 6358,
     /*  630525 */     GIR_EraseRootFromParent_Done,
     /*  630526 */   // Label 10159: @630526
     /*  630526 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(630601), // Rule ID 6359 //
     /*  630531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  630542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  630545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  630548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  630551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630577 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630599 */     GIR_RootConstrainSelectedInstOperands,
     /*  630600 */     // GIR_Coverage, 6359,
     /*  630600 */     GIR_EraseRootFromParent_Done,
     /*  630601 */   // Label 10160: @630601
     /*  630601 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(630676), // Rule ID 6362 //
     /*  630606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  630617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  630620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  630623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  630626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  630652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630674 */     GIR_RootConstrainSelectedInstOperands,
     /*  630675 */     // GIR_Coverage, 6362,
     /*  630675 */     GIR_EraseRootFromParent_Done,
     /*  630676 */   // Label 10161: @630676
     /*  630676 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(630751), // Rule ID 6363 //
     /*  630681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  630692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  630695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  630698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  630701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630727 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630749 */     GIR_RootConstrainSelectedInstOperands,
     /*  630750 */     // GIR_Coverage, 6363,
     /*  630750 */     GIR_EraseRootFromParent_Done,
     /*  630751 */   // Label 10162: @630751
     /*  630751 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(630826), // Rule ID 6366 //
     /*  630756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  630767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  630770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  630773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  630776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630802 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  630802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630824 */     GIR_RootConstrainSelectedInstOperands,
     /*  630825 */     // GIR_Coverage, 6366,
     /*  630825 */     GIR_EraseRootFromParent_Done,
     /*  630826 */   // Label 10163: @630826
     /*  630826 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(630901), // Rule ID 6367 //
     /*  630831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  630842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  630845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  630848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  630851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630877 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630899 */     GIR_RootConstrainSelectedInstOperands,
     /*  630900 */     // GIR_Coverage, 6367,
     /*  630900 */     GIR_EraseRootFromParent_Done,
     /*  630901 */   // Label 10164: @630901
     /*  630901 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(630976), // Rule ID 6370 //
     /*  630906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  630917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  630920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  630923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  630926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  630952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630974 */     GIR_RootConstrainSelectedInstOperands,
     /*  630975 */     // GIR_Coverage, 6370,
     /*  630975 */     GIR_EraseRootFromParent_Done,
     /*  630976 */   // Label 10165: @630976
     /*  630976 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(631051), // Rule ID 6371 //
     /*  630981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  630992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  630995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  630998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  631001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631027 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631049 */     GIR_RootConstrainSelectedInstOperands,
     /*  631050 */     // GIR_Coverage, 6371,
     /*  631050 */     GIR_EraseRootFromParent_Done,
     /*  631051 */   // Label 10166: @631051
     /*  631051 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(631126), // Rule ID 6374 //
     /*  631056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631124 */     GIR_RootConstrainSelectedInstOperands,
     /*  631125 */     // GIR_Coverage, 6374,
     /*  631125 */     GIR_EraseRootFromParent_Done,
     /*  631126 */   // Label 10167: @631126
     /*  631126 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(631201), // Rule ID 6375 //
     /*  631131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  631142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  631145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  631148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  631151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  631170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  631180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631199 */     GIR_RootConstrainSelectedInstOperands,
     /*  631200 */     // GIR_Coverage, 6375,
     /*  631200 */     GIR_EraseRootFromParent_Done,
     /*  631201 */   // Label 10168: @631201
     /*  631201 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(631276), // Rule ID 6378 //
     /*  631206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631274 */     GIR_RootConstrainSelectedInstOperands,
     /*  631275 */     // GIR_Coverage, 6378,
     /*  631275 */     GIR_EraseRootFromParent_Done,
     /*  631276 */   // Label 10169: @631276
     /*  631276 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(631351), // Rule ID 6379 //
     /*  631281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  631292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  631295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  631298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  631301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  631320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631327 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  631330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631349 */     GIR_RootConstrainSelectedInstOperands,
     /*  631350 */     // GIR_Coverage, 6379,
     /*  631350 */     GIR_EraseRootFromParent_Done,
     /*  631351 */   // Label 10170: @631351
     /*  631351 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(631426), // Rule ID 6382 //
     /*  631356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  631359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631402 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  631402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631424 */     GIR_RootConstrainSelectedInstOperands,
     /*  631425 */     // GIR_Coverage, 6382,
     /*  631425 */     GIR_EraseRootFromParent_Done,
     /*  631426 */   // Label 10171: @631426
     /*  631426 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(631501), // Rule ID 6383 //
     /*  631431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  631434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  631442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  631445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  631448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  631451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  631470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631477 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  631477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  631480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  631496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631499 */     GIR_RootConstrainSelectedInstOperands,
     /*  631500 */     // GIR_Coverage, 6383,
     /*  631500 */     GIR_EraseRootFromParent_Done,
     /*  631501 */   // Label 10172: @631501
     /*  631501 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(631576), // Rule ID 6386 //
     /*  631506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  631520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  631523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631552 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  631555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631574 */     GIR_RootConstrainSelectedInstOperands,
     /*  631575 */     // GIR_Coverage, 6386,
     /*  631575 */     GIR_EraseRootFromParent_Done,
     /*  631576 */   // Label 10173: @631576
     /*  631576 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(631651), // Rule ID 6387 //
     /*  631581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  631595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  631598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  631627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  631630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631649 */     GIR_RootConstrainSelectedInstOperands,
     /*  631650 */     // GIR_Coverage, 6387,
     /*  631650 */     GIR_EraseRootFromParent_Done,
     /*  631651 */   // Label 10174: @631651
     /*  631651 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(631726), // Rule ID 6390 //
     /*  631656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  631667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  631670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  631673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631702 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  631705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631724 */     GIR_RootConstrainSelectedInstOperands,
     /*  631725 */     // GIR_Coverage, 6390,
     /*  631725 */     GIR_EraseRootFromParent_Done,
     /*  631726 */   // Label 10175: @631726
     /*  631726 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(631801), // Rule ID 6391 //
     /*  631731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  631742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  631745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  631748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631777 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  631777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  631780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631799 */     GIR_RootConstrainSelectedInstOperands,
     /*  631800 */     // GIR_Coverage, 6391,
     /*  631800 */     GIR_EraseRootFromParent_Done,
     /*  631801 */   // Label 10176: @631801
     /*  631801 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(631876), // Rule ID 6394 //
     /*  631806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  631817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  631820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  631823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631852 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631874 */     GIR_RootConstrainSelectedInstOperands,
     /*  631875 */     // GIR_Coverage, 6394,
     /*  631875 */     GIR_EraseRootFromParent_Done,
     /*  631876 */   // Label 10177: @631876
     /*  631876 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(631951), // Rule ID 6395 //
     /*  631881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  631892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  631895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  631898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631927 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  631927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631949 */     GIR_RootConstrainSelectedInstOperands,
     /*  631950 */     // GIR_Coverage, 6395,
     /*  631950 */     GIR_EraseRootFromParent_Done,
     /*  631951 */   // Label 10178: @631951
     /*  631951 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(632026), // Rule ID 6398 //
     /*  631956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  631967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  631970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  631973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632002 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632024 */     GIR_RootConstrainSelectedInstOperands,
     /*  632025 */     // GIR_Coverage, 6398,
     /*  632025 */     GIR_EraseRootFromParent_Done,
     /*  632026 */   // Label 10179: @632026
     /*  632026 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(632101), // Rule ID 6399 //
     /*  632031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  632042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  632045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  632048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632077 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  632080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632099 */     GIR_RootConstrainSelectedInstOperands,
     /*  632100 */     // GIR_Coverage, 6399,
     /*  632100 */     GIR_EraseRootFromParent_Done,
     /*  632101 */   // Label 10180: @632101
     /*  632101 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(632176), // Rule ID 6402 //
     /*  632106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632152 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632174 */     GIR_RootConstrainSelectedInstOperands,
     /*  632175 */     // GIR_Coverage, 6402,
     /*  632175 */     GIR_EraseRootFromParent_Done,
     /*  632176 */   // Label 10181: @632176
     /*  632176 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(632251), // Rule ID 6403 //
     /*  632181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  632192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  632195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  632198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632227 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632249 */     GIR_RootConstrainSelectedInstOperands,
     /*  632250 */     // GIR_Coverage, 6403,
     /*  632250 */     GIR_EraseRootFromParent_Done,
     /*  632251 */   // Label 10182: @632251
     /*  632251 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(632326), // Rule ID 6406 //
     /*  632256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632324 */     GIR_RootConstrainSelectedInstOperands,
     /*  632325 */     // GIR_Coverage, 6406,
     /*  632325 */     GIR_EraseRootFromParent_Done,
     /*  632326 */   // Label 10183: @632326
     /*  632326 */   GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(632401), // Rule ID 6407 //
     /*  632331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  632342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  632345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  632348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632377 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  632380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632399 */     GIR_RootConstrainSelectedInstOperands,
     /*  632400 */     // GIR_Coverage, 6407,
     /*  632400 */     GIR_EraseRootFromParent_Done,
     /*  632401 */   // Label 10184: @632401
     /*  632401 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(632476), // Rule ID 6410 //
     /*  632406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632474 */     GIR_RootConstrainSelectedInstOperands,
     /*  632475 */     // GIR_Coverage, 6410,
     /*  632475 */     GIR_EraseRootFromParent_Done,
     /*  632476 */   // Label 10185: @632476
     /*  632476 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(632551), // Rule ID 6411 //
     /*  632481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  632492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  632495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  632498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11675:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632549 */     GIR_RootConstrainSelectedInstOperands,
     /*  632550 */     // GIR_Coverage, 6411,
     /*  632550 */     GIR_EraseRootFromParent_Done,
     /*  632551 */   // Label 10186: @632551
     /*  632551 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(632626), // Rule ID 6414 //
     /*  632556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  632567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  632570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  632573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632624 */     GIR_RootConstrainSelectedInstOperands,
     /*  632625 */     // GIR_Coverage, 6414,
     /*  632625 */     GIR_EraseRootFromParent_Done,
     /*  632626 */   // Label 10187: @632626
     /*  632626 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(632701), // Rule ID 6415 //
     /*  632631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  632642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  632645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  632648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11675:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632699 */     GIR_RootConstrainSelectedInstOperands,
     /*  632700 */     // GIR_Coverage, 6415,
     /*  632700 */     GIR_EraseRootFromParent_Done,
     /*  632701 */   // Label 10188: @632701
     /*  632701 */   GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(632776), // Rule ID 6418 //
     /*  632706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  632717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  632720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  632723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632774 */     GIR_RootConstrainSelectedInstOperands,
     /*  632775 */     // GIR_Coverage, 6418,
     /*  632775 */     GIR_EraseRootFromParent_Done,
     /*  632776 */   // Label 10189: @632776
     /*  632776 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(632851), // Rule ID 6419 //
     /*  632781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  632792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  632795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  632798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632827 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11675:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632849 */     GIR_RootConstrainSelectedInstOperands,
     /*  632850 */     // GIR_Coverage, 6419,
     /*  632850 */     GIR_EraseRootFromParent_Done,
     /*  632851 */   // Label 10190: @632851
     /*  632851 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(632926), // Rule ID 6422 //
     /*  632856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  632859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  632867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  632870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  632873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  632902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  632921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632924 */     GIR_RootConstrainSelectedInstOperands,
     /*  632925 */     // GIR_Coverage, 6422,
     /*  632925 */     GIR_EraseRootFromParent_Done,
     /*  632926 */   // Label 10191: @632926
     /*  632926 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(633001), // Rule ID 6423 //
     /*  632931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  632934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  632942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  632945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  632948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632977 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11675:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  632977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  632996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632999 */     GIR_RootConstrainSelectedInstOperands,
     /*  633000 */     // GIR_Coverage, 6423,
     /*  633000 */     GIR_EraseRootFromParent_Done,
     /*  633001 */   // Label 10192: @633001
     /*  633001 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(633076), // Rule ID 6426 //
     /*  633006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633074 */     GIR_RootConstrainSelectedInstOperands,
     /*  633075 */     // GIR_Coverage, 6426,
     /*  633075 */     GIR_EraseRootFromParent_Done,
     /*  633076 */   // Label 10193: @633076
     /*  633076 */   GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(633151), // Rule ID 6427 //
     /*  633081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  633092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  633095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  633098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633149 */     GIR_RootConstrainSelectedInstOperands,
     /*  633150 */     // GIR_Coverage, 6427,
     /*  633150 */     GIR_EraseRootFromParent_Done,
     /*  633151 */   // Label 10194: @633151
     /*  633151 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(633226), // Rule ID 6430 //
     /*  633156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633202 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633224 */     GIR_RootConstrainSelectedInstOperands,
     /*  633225 */     // GIR_Coverage, 6430,
     /*  633225 */     GIR_EraseRootFromParent_Done,
     /*  633226 */   // Label 10195: @633226
     /*  633226 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(633301), // Rule ID 6431 //
     /*  633231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  633242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  633245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  633248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633277 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633299 */     GIR_RootConstrainSelectedInstOperands,
     /*  633300 */     // GIR_Coverage, 6431,
     /*  633300 */     GIR_EraseRootFromParent_Done,
     /*  633301 */   // Label 10196: @633301
     /*  633301 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(633376), // Rule ID 6434 //
     /*  633306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633352 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  633352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633374 */     GIR_RootConstrainSelectedInstOperands,
     /*  633375 */     // GIR_Coverage, 6434,
     /*  633375 */     GIR_EraseRootFromParent_Done,
     /*  633376 */   // Label 10197: @633376
     /*  633376 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(633451), // Rule ID 6435 //
     /*  633381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  633392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  633395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  633398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633427 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  633427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  633446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633449 */     GIR_RootConstrainSelectedInstOperands,
     /*  633450 */     // GIR_Coverage, 6435,
     /*  633450 */     GIR_EraseRootFromParent_Done,
     /*  633451 */   // Label 10198: @633451
     /*  633451 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(633526), // Rule ID 6438 //
     /*  633456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  633467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  633470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  633473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633524 */     GIR_RootConstrainSelectedInstOperands,
     /*  633525 */     // GIR_Coverage, 6438,
     /*  633525 */     GIR_EraseRootFromParent_Done,
     /*  633526 */   // Label 10199: @633526
     /*  633526 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(633601), // Rule ID 6439 //
     /*  633531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  633542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  633545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  633548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633599 */     GIR_RootConstrainSelectedInstOperands,
     /*  633600 */     // GIR_Coverage, 6439,
     /*  633600 */     GIR_EraseRootFromParent_Done,
     /*  633601 */   // Label 10200: @633601
     /*  633601 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(633676), // Rule ID 6442 //
     /*  633606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  633617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  633620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  633623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633652 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633674 */     GIR_RootConstrainSelectedInstOperands,
     /*  633675 */     // GIR_Coverage, 6442,
     /*  633675 */     GIR_EraseRootFromParent_Done,
     /*  633676 */   // Label 10201: @633676
     /*  633676 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(633751), // Rule ID 6443 //
     /*  633681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  633692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  633695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  633698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633727 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633749 */     GIR_RootConstrainSelectedInstOperands,
     /*  633750 */     // GIR_Coverage, 6443,
     /*  633750 */     GIR_EraseRootFromParent_Done,
     /*  633751 */   // Label 10202: @633751
     /*  633751 */   GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(633826), // Rule ID 6446 //
     /*  633756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  633767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  633770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  633773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633824 */     GIR_RootConstrainSelectedInstOperands,
     /*  633825 */     // GIR_Coverage, 6446,
     /*  633825 */     GIR_EraseRootFromParent_Done,
     /*  633826 */   // Label 10203: @633826
     /*  633826 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(633901), // Rule ID 6447 //
     /*  633831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  633842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  633845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  633848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633877 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633899 */     GIR_RootConstrainSelectedInstOperands,
     /*  633900 */     // GIR_Coverage, 6447,
     /*  633900 */     GIR_EraseRootFromParent_Done,
     /*  633901 */   // Label 10204: @633901
     /*  633901 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(633976), // Rule ID 6450 //
     /*  633906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  633917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  633920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  633923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633974 */     GIR_RootConstrainSelectedInstOperands,
     /*  633975 */     // GIR_Coverage, 6450,
     /*  633975 */     GIR_EraseRootFromParent_Done,
     /*  633976 */   // Label 10205: @633976
     /*  633976 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(634051), // Rule ID 6451 //
     /*  633981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  633992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  633995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  633998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634027 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634049 */     GIR_RootConstrainSelectedInstOperands,
     /*  634050 */     // GIR_Coverage, 6451,
     /*  634050 */     GIR_EraseRootFromParent_Done,
     /*  634051 */   // Label 10206: @634051
     /*  634051 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(634126), // Rule ID 6454 //
     /*  634056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634124 */     GIR_RootConstrainSelectedInstOperands,
     /*  634125 */     // GIR_Coverage, 6454,
     /*  634125 */     GIR_EraseRootFromParent_Done,
     /*  634126 */   // Label 10207: @634126
     /*  634126 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(634201), // Rule ID 6455 //
     /*  634131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  634142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  634145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  634148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634199 */     GIR_RootConstrainSelectedInstOperands,
     /*  634200 */     // GIR_Coverage, 6455,
     /*  634200 */     GIR_EraseRootFromParent_Done,
     /*  634201 */   // Label 10208: @634201
     /*  634201 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(634276), // Rule ID 6458 //
     /*  634206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634252 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  634252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634274 */     GIR_RootConstrainSelectedInstOperands,
     /*  634275 */     // GIR_Coverage, 6458,
     /*  634275 */     GIR_EraseRootFromParent_Done,
     /*  634276 */   // Label 10209: @634276
     /*  634276 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(634351), // Rule ID 6459 //
     /*  634281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  634292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  634295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  634298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634327 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  634327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  634346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634349 */     GIR_RootConstrainSelectedInstOperands,
     /*  634350 */     // GIR_Coverage, 6459,
     /*  634350 */     GIR_EraseRootFromParent_Done,
     /*  634351 */   // Label 10210: @634351
     /*  634351 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(634426), // Rule ID 6462 //
     /*  634356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634424 */     GIR_RootConstrainSelectedInstOperands,
     /*  634425 */     // GIR_Coverage, 6462,
     /*  634425 */     GIR_EraseRootFromParent_Done,
     /*  634426 */   // Label 10211: @634426
     /*  634426 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(634501), // Rule ID 6463 //
     /*  634431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  634442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  634445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  634448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  634466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634477 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11675:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  634480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634499 */     GIR_RootConstrainSelectedInstOperands,
     /*  634500 */     // GIR_Coverage, 6463,
     /*  634500 */     GIR_EraseRootFromParent_Done,
     /*  634501 */   // Label 10212: @634501
     /*  634501 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(634576), // Rule ID 6466 //
     /*  634506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  634520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  634523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634574 */     GIR_RootConstrainSelectedInstOperands,
     /*  634575 */     // GIR_Coverage, 6466,
     /*  634575 */     GIR_EraseRootFromParent_Done,
     /*  634576 */   // Label 10213: @634576
     /*  634576 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(634651), // Rule ID 6467 //
     /*  634581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  634595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  634598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634627 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11675:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634649 */     GIR_RootConstrainSelectedInstOperands,
     /*  634650 */     // GIR_Coverage, 6467,
     /*  634650 */     GIR_EraseRootFromParent_Done,
     /*  634651 */   // Label 10214: @634651
     /*  634651 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(634726), // Rule ID 6470 //
     /*  634656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  634667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  634670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  634673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634724 */     GIR_RootConstrainSelectedInstOperands,
     /*  634725 */     // GIR_Coverage, 6470,
     /*  634725 */     GIR_EraseRootFromParent_Done,
     /*  634726 */   // Label 10215: @634726
     /*  634726 */   GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(634801), // Rule ID 6471 //
     /*  634731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  634742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  634745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  634748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11675:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634799 */     GIR_RootConstrainSelectedInstOperands,
     /*  634800 */     // GIR_Coverage, 6471,
     /*  634800 */     GIR_EraseRootFromParent_Done,
     /*  634801 */   // Label 10216: @634801
     /*  634801 */   GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(634876), // Rule ID 6562 //
     /*  634806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  634817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  634820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  634823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  634826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634852 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  634852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  634855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634874 */     GIR_RootConstrainSelectedInstOperands,
     /*  634875 */     // GIR_Coverage, 6562,
     /*  634875 */     GIR_EraseRootFromParent_Done,
     /*  634876 */   // Label 10217: @634876
     /*  634876 */   GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(634951), // Rule ID 6563 //
     /*  634881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  634892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  634895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  634898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  634901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634927 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  634927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  634930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634949 */     GIR_RootConstrainSelectedInstOperands,
     /*  634950 */     // GIR_Coverage, 6563,
     /*  634950 */     GIR_EraseRootFromParent_Done,
     /*  634951 */   // Label 10218: @634951
     /*  634951 */   GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(635026), // Rule ID 6566 //
     /*  634956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  634967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  634970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  634973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  634976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635024 */     GIR_RootConstrainSelectedInstOperands,
     /*  635025 */     // GIR_Coverage, 6566,
     /*  635025 */     GIR_EraseRootFromParent_Done,
     /*  635026 */   // Label 10219: @635026
     /*  635026 */   GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(635101), // Rule ID 6567 //
     /*  635031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  635042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  635045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  635048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  635051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635077 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635099 */     GIR_RootConstrainSelectedInstOperands,
     /*  635100 */     // GIR_Coverage, 6567,
     /*  635100 */     GIR_EraseRootFromParent_Done,
     /*  635101 */   // Label 10220: @635101
     /*  635101 */   GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(635176), // Rule ID 6570 //
     /*  635106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635174 */     GIR_RootConstrainSelectedInstOperands,
     /*  635175 */     // GIR_Coverage, 6570,
     /*  635175 */     GIR_EraseRootFromParent_Done,
     /*  635176 */   // Label 10221: @635176
     /*  635176 */   GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(635251), // Rule ID 6571 //
     /*  635181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  635192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  635195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  635198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  635201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635227 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635249 */     GIR_RootConstrainSelectedInstOperands,
     /*  635250 */     // GIR_Coverage, 6571,
     /*  635250 */     GIR_EraseRootFromParent_Done,
     /*  635251 */   // Label 10222: @635251
     /*  635251 */   GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(635326), // Rule ID 6574 //
     /*  635256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635302 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635324 */     GIR_RootConstrainSelectedInstOperands,
     /*  635325 */     // GIR_Coverage, 6574,
     /*  635325 */     GIR_EraseRootFromParent_Done,
     /*  635326 */   // Label 10223: @635326
     /*  635326 */   GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(635401), // Rule ID 6575 //
     /*  635331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  635342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  635345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  635348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  635351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635377 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  635380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635399 */     GIR_RootConstrainSelectedInstOperands,
     /*  635400 */     // GIR_Coverage, 6575,
     /*  635400 */     GIR_EraseRootFromParent_Done,
     /*  635401 */   // Label 10224: @635401
     /*  635401 */   GIM_Try, /*On fail goto*//*Label 10225*/ GIMT_Encode4(635476), // Rule ID 6578 //
     /*  635406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635474 */     GIR_RootConstrainSelectedInstOperands,
     /*  635475 */     // GIR_Coverage, 6578,
     /*  635475 */     GIR_EraseRootFromParent_Done,
     /*  635476 */   // Label 10225: @635476
     /*  635476 */   GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(635551), // Rule ID 6579 //
     /*  635481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  635492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  635495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  635498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  635501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635527 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635549 */     GIR_RootConstrainSelectedInstOperands,
     /*  635550 */     // GIR_Coverage, 6579,
     /*  635550 */     GIR_EraseRootFromParent_Done,
     /*  635551 */   // Label 10226: @635551
     /*  635551 */   GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(635626), // Rule ID 6582 //
     /*  635556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  635567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  635570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  635573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  635576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635602 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  635602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  635621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635624 */     GIR_RootConstrainSelectedInstOperands,
     /*  635625 */     // GIR_Coverage, 6582,
     /*  635625 */     GIR_EraseRootFromParent_Done,
     /*  635626 */   // Label 10227: @635626
     /*  635626 */   GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(635701), // Rule ID 6583 //
     /*  635631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  635642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  635645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  635648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  635651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635677 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  635677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  635696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635699 */     GIR_RootConstrainSelectedInstOperands,
     /*  635700 */     // GIR_Coverage, 6583,
     /*  635700 */     GIR_EraseRootFromParent_Done,
     /*  635701 */   // Label 10228: @635701
     /*  635701 */   GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(635776), // Rule ID 6586 //
     /*  635706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  635717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  635720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  635723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  635726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635774 */     GIR_RootConstrainSelectedInstOperands,
     /*  635775 */     // GIR_Coverage, 6586,
     /*  635775 */     GIR_EraseRootFromParent_Done,
     /*  635776 */   // Label 10229: @635776
     /*  635776 */   GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(635851), // Rule ID 6587 //
     /*  635781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  635792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  635795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  635798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  635801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635827 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635849 */     GIR_RootConstrainSelectedInstOperands,
     /*  635850 */     // GIR_Coverage, 6587,
     /*  635850 */     GIR_EraseRootFromParent_Done,
     /*  635851 */   // Label 10230: @635851
     /*  635851 */   GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(635926), // Rule ID 6590 //
     /*  635856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  635867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  635870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  635873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  635876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635924 */     GIR_RootConstrainSelectedInstOperands,
     /*  635925 */     // GIR_Coverage, 6590,
     /*  635925 */     GIR_EraseRootFromParent_Done,
     /*  635926 */   // Label 10231: @635926
     /*  635926 */   GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(636001), // Rule ID 6591 //
     /*  635931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  635942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  635945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  635948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  635951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635999 */     GIR_RootConstrainSelectedInstOperands,
     /*  636000 */     // GIR_Coverage, 6591,
     /*  636000 */     GIR_EraseRootFromParent_Done,
     /*  636001 */   // Label 10232: @636001
     /*  636001 */   GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(636076), // Rule ID 6594 //
     /*  636006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636074 */     GIR_RootConstrainSelectedInstOperands,
     /*  636075 */     // GIR_Coverage, 6594,
     /*  636075 */     GIR_EraseRootFromParent_Done,
     /*  636076 */   // Label 10233: @636076
     /*  636076 */   GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(636151), // Rule ID 6595 //
     /*  636081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  636092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  636095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  636098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  636101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636149 */     GIR_RootConstrainSelectedInstOperands,
     /*  636150 */     // GIR_Coverage, 6595,
     /*  636150 */     GIR_EraseRootFromParent_Done,
     /*  636151 */   // Label 10234: @636151
     /*  636151 */   GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(636226), // Rule ID 6598 //
     /*  636156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  636159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  636202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636224 */     GIR_RootConstrainSelectedInstOperands,
     /*  636225 */     // GIR_Coverage, 6598,
     /*  636225 */     GIR_EraseRootFromParent_Done,
     /*  636226 */   // Label 10235: @636226
     /*  636226 */   GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(636301), // Rule ID 6599 //
     /*  636231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  636234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  636242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  636245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  636248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  636251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  636270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636277 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  636277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  636280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  636296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636299 */     GIR_RootConstrainSelectedInstOperands,
     /*  636300 */     // GIR_Coverage, 6599,
     /*  636300 */     GIR_EraseRootFromParent_Done,
     /*  636301 */   // Label 10236: @636301
     /*  636301 */   GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(636376), // Rule ID 6602 //
     /*  636306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636374 */     GIR_RootConstrainSelectedInstOperands,
     /*  636375 */     // GIR_Coverage, 6602,
     /*  636375 */     GIR_EraseRootFromParent_Done,
     /*  636376 */   // Label 10237: @636376
     /*  636376 */   GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(636451), // Rule ID 6603 //
     /*  636381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  636392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  636395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  636398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  636401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636427 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636449 */     GIR_RootConstrainSelectedInstOperands,
     /*  636450 */     // GIR_Coverage, 6603,
     /*  636450 */     GIR_EraseRootFromParent_Done,
     /*  636451 */   // Label 10238: @636451
     /*  636451 */   GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(636526), // Rule ID 6606 //
     /*  636456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  636467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  636470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  636473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  636476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636502 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636524 */     GIR_RootConstrainSelectedInstOperands,
     /*  636525 */     // GIR_Coverage, 6606,
     /*  636525 */     GIR_EraseRootFromParent_Done,
     /*  636526 */   // Label 10239: @636526
     /*  636526 */   GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(636601), // Rule ID 6607 //
     /*  636531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  636542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  636545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  636548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  636551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636577 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636599 */     GIR_RootConstrainSelectedInstOperands,
     /*  636600 */     // GIR_Coverage, 6607,
     /*  636600 */     GIR_EraseRootFromParent_Done,
     /*  636601 */   // Label 10240: @636601
     /*  636601 */   GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(636676), // Rule ID 6610 //
     /*  636606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  636617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  636620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  636623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  636626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636652 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  636655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636674 */     GIR_RootConstrainSelectedInstOperands,
     /*  636675 */     // GIR_Coverage, 6610,
     /*  636675 */     GIR_EraseRootFromParent_Done,
     /*  636676 */   // Label 10241: @636676
     /*  636676 */   GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(636751), // Rule ID 6611 //
     /*  636681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  636692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  636695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  636698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  636701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636727 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  636730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636749 */     GIR_RootConstrainSelectedInstOperands,
     /*  636750 */     // GIR_Coverage, 6611,
     /*  636750 */     GIR_EraseRootFromParent_Done,
     /*  636751 */   // Label 10242: @636751
     /*  636751 */   GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(636826), // Rule ID 6614 //
     /*  636756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  636767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  636770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  636773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  636776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636824 */     GIR_RootConstrainSelectedInstOperands,
     /*  636825 */     // GIR_Coverage, 6614,
     /*  636825 */     GIR_EraseRootFromParent_Done,
     /*  636826 */   // Label 10243: @636826
     /*  636826 */   GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(636901), // Rule ID 6615 //
     /*  636831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  636842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  636845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  636848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  636851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636877 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636899 */     GIR_RootConstrainSelectedInstOperands,
     /*  636900 */     // GIR_Coverage, 6615,
     /*  636900 */     GIR_EraseRootFromParent_Done,
     /*  636901 */   // Label 10244: @636901
     /*  636901 */   GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(636976), // Rule ID 6618 //
     /*  636906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  636917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  636920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  636923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  636926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636974 */     GIR_RootConstrainSelectedInstOperands,
     /*  636975 */     // GIR_Coverage, 6618,
     /*  636975 */     GIR_EraseRootFromParent_Done,
     /*  636976 */   // Label 10245: @636976
     /*  636976 */   GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(637051), // Rule ID 6619 //
     /*  636981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  636992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  636995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  636998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  637001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637027 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637049 */     GIR_RootConstrainSelectedInstOperands,
     /*  637050 */     // GIR_Coverage, 6619,
     /*  637050 */     GIR_EraseRootFromParent_Done,
     /*  637051 */   // Label 10246: @637051
     /*  637051 */   GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(637126), // Rule ID 6622 //
     /*  637056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637102 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  637102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637124 */     GIR_RootConstrainSelectedInstOperands,
     /*  637125 */     // GIR_Coverage, 6622,
     /*  637125 */     GIR_EraseRootFromParent_Done,
     /*  637126 */   // Label 10247: @637126
     /*  637126 */   GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(637201), // Rule ID 6623 //
     /*  637131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  637142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  637145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  637148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  637151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637177 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  637177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  637196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637199 */     GIR_RootConstrainSelectedInstOperands,
     /*  637200 */     // GIR_Coverage, 6623,
     /*  637200 */     GIR_EraseRootFromParent_Done,
     /*  637201 */   // Label 10248: @637201
     /*  637201 */   GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(637276), // Rule ID 6626 //
     /*  637206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637274 */     GIR_RootConstrainSelectedInstOperands,
     /*  637275 */     // GIR_Coverage, 6626,
     /*  637275 */     GIR_EraseRootFromParent_Done,
     /*  637276 */   // Label 10249: @637276
     /*  637276 */   GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(637351), // Rule ID 6627 //
     /*  637281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  637292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  637295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  637298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  637301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637349 */     GIR_RootConstrainSelectedInstOperands,
     /*  637350 */     // GIR_Coverage, 6627,
     /*  637350 */     GIR_EraseRootFromParent_Done,
     /*  637351 */   // Label 10250: @637351
     /*  637351 */   GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(637426), // Rule ID 6630 //
     /*  637356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637424 */     GIR_RootConstrainSelectedInstOperands,
     /*  637425 */     // GIR_Coverage, 6630,
     /*  637425 */     GIR_EraseRootFromParent_Done,
     /*  637426 */   // Label 10251: @637426
     /*  637426 */   GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(637501), // Rule ID 6631 //
     /*  637431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  637442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  637445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  637448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  637451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637477 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637499 */     GIR_RootConstrainSelectedInstOperands,
     /*  637500 */     // GIR_Coverage, 6631,
     /*  637500 */     GIR_EraseRootFromParent_Done,
     /*  637501 */   // Label 10252: @637501
     /*  637501 */   GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(637576), // Rule ID 6634 //
     /*  637506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  637520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  637523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  637526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637552 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637574 */     GIR_RootConstrainSelectedInstOperands,
     /*  637575 */     // GIR_Coverage, 6634,
     /*  637575 */     GIR_EraseRootFromParent_Done,
     /*  637576 */   // Label 10253: @637576
     /*  637576 */   GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(637651), // Rule ID 6635 //
     /*  637581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  637595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  637598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  637601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637627 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637649 */     GIR_RootConstrainSelectedInstOperands,
     /*  637650 */     // GIR_Coverage, 6635,
     /*  637650 */     GIR_EraseRootFromParent_Done,
     /*  637651 */   // Label 10254: @637651
     /*  637651 */   GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(637726), // Rule ID 6638 //
     /*  637656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  637659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  637667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  637670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  637673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  637676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  637702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637724 */     GIR_RootConstrainSelectedInstOperands,
     /*  637725 */     // GIR_Coverage, 6638,
     /*  637725 */     GIR_EraseRootFromParent_Done,
     /*  637726 */   // Label 10255: @637726
     /*  637726 */   GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(637801), // Rule ID 6639 //
     /*  637731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  637734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  637742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  637745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  637748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  637751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  637777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637799 */     GIR_RootConstrainSelectedInstOperands,
     /*  637800 */     // GIR_Coverage, 6639,
     /*  637800 */     GIR_EraseRootFromParent_Done,
     /*  637801 */   // Label 10256: @637801
     /*  637801 */   GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(637876), // Rule ID 6642 //
     /*  637806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  637809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  637817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  637820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  637823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  637826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637852 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  637852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637874 */     GIR_RootConstrainSelectedInstOperands,
     /*  637875 */     // GIR_Coverage, 6642,
     /*  637875 */     GIR_EraseRootFromParent_Done,
     /*  637876 */   // Label 10257: @637876
     /*  637876 */   GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(637951), // Rule ID 6643 //
     /*  637881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  637884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  637892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  637895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  637898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  637901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637927 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  637927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637949 */     GIR_RootConstrainSelectedInstOperands,
     /*  637950 */     // GIR_Coverage, 6643,
     /*  637950 */     GIR_EraseRootFromParent_Done,
     /*  637951 */   // Label 10258: @637951
     /*  637951 */   GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(638026), // Rule ID 6646 //
     /*  637956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  637959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  637967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  637970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  637973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  637976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638002 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638024 */     GIR_RootConstrainSelectedInstOperands,
     /*  638025 */     // GIR_Coverage, 6646,
     /*  638025 */     GIR_EraseRootFromParent_Done,
     /*  638026 */   // Label 10259: @638026
     /*  638026 */   GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(638101), // Rule ID 6647 //
     /*  638031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  638034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  638042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  638045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  638048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  638051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  638070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638077 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  638077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  638080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  638096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638099 */     GIR_RootConstrainSelectedInstOperands,
     /*  638100 */     // GIR_Coverage, 6647,
     /*  638100 */     GIR_EraseRootFromParent_Done,
     /*  638101 */   // Label 10260: @638101
     /*  638101 */   GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(638176), // Rule ID 6650 //
     /*  638106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  638155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638174 */     GIR_RootConstrainSelectedInstOperands,
     /*  638175 */     // GIR_Coverage, 6650,
     /*  638175 */     GIR_EraseRootFromParent_Done,
     /*  638176 */   // Label 10261: @638176
     /*  638176 */   GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(638251), // Rule ID 6651 //
     /*  638181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  638192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  638195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  638198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638227 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  638230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638249 */     GIR_RootConstrainSelectedInstOperands,
     /*  638250 */     // GIR_Coverage, 6651,
     /*  638250 */     GIR_EraseRootFromParent_Done,
     /*  638251 */   // Label 10262: @638251
     /*  638251 */   GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(638326), // Rule ID 6654 //
     /*  638256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638302 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638324 */     GIR_RootConstrainSelectedInstOperands,
     /*  638325 */     // GIR_Coverage, 6654,
     /*  638325 */     GIR_EraseRootFromParent_Done,
     /*  638326 */   // Label 10263: @638326
     /*  638326 */   GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(638401), // Rule ID 6655 //
     /*  638331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  638342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  638345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  638348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638377 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638399 */     GIR_RootConstrainSelectedInstOperands,
     /*  638400 */     // GIR_Coverage, 6655,
     /*  638400 */     GIR_EraseRootFromParent_Done,
     /*  638401 */   // Label 10264: @638401
     /*  638401 */   GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(638476), // Rule ID 6658 //
     /*  638406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638474 */     GIR_RootConstrainSelectedInstOperands,
     /*  638475 */     // GIR_Coverage, 6658,
     /*  638475 */     GIR_EraseRootFromParent_Done,
     /*  638476 */   // Label 10265: @638476
     /*  638476 */   GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(638551), // Rule ID 6659 //
     /*  638481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  638492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  638495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  638498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638527 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638549 */     GIR_RootConstrainSelectedInstOperands,
     /*  638550 */     // GIR_Coverage, 6659,
     /*  638550 */     GIR_EraseRootFromParent_Done,
     /*  638551 */   // Label 10266: @638551
     /*  638551 */   GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(638626), // Rule ID 6662 //
     /*  638556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  638567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  638570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  638573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638602 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  638602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638624 */     GIR_RootConstrainSelectedInstOperands,
     /*  638625 */     // GIR_Coverage, 6662,
     /*  638625 */     GIR_EraseRootFromParent_Done,
     /*  638626 */   // Label 10267: @638626
     /*  638626 */   GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(638701), // Rule ID 6663 //
     /*  638631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  638642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  638645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  638648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638677 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  638677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638699 */     GIR_RootConstrainSelectedInstOperands,
     /*  638700 */     // GIR_Coverage, 6663,
     /*  638700 */     GIR_EraseRootFromParent_Done,
     /*  638701 */   // Label 10268: @638701
     /*  638701 */   GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(638776), // Rule ID 6666 //
     /*  638706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  638717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  638720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  638723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  638752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638774 */     GIR_RootConstrainSelectedInstOperands,
     /*  638775 */     // GIR_Coverage, 6666,
     /*  638775 */     GIR_EraseRootFromParent_Done,
     /*  638776 */   // Label 10269: @638776
     /*  638776 */   GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(638851), // Rule ID 6667 //
     /*  638781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  638792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  638795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  638798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638827 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  638827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638849 */     GIR_RootConstrainSelectedInstOperands,
     /*  638850 */     // GIR_Coverage, 6667,
     /*  638850 */     GIR_EraseRootFromParent_Done,
     /*  638851 */   // Label 10270: @638851
     /*  638851 */   GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(638926), // Rule ID 6670 //
     /*  638856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  638867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  638870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  638873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  638902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638924 */     GIR_RootConstrainSelectedInstOperands,
     /*  638925 */     // GIR_Coverage, 6670,
     /*  638925 */     GIR_EraseRootFromParent_Done,
     /*  638926 */   // Label 10271: @638926
     /*  638926 */   GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(639001), // Rule ID 6671 //
     /*  638931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  638942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  638945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  638948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638977 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638999 */     GIR_RootConstrainSelectedInstOperands,
     /*  639000 */     // GIR_Coverage, 6671,
     /*  639000 */     GIR_EraseRootFromParent_Done,
     /*  639001 */   // Label 10272: @639001
     /*  639001 */   GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(639076), // Rule ID 6674 //
     /*  639006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639052 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639074 */     GIR_RootConstrainSelectedInstOperands,
     /*  639075 */     // GIR_Coverage, 6674,
     /*  639075 */     GIR_EraseRootFromParent_Done,
     /*  639076 */   // Label 10273: @639076
     /*  639076 */   GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(639151), // Rule ID 6675 //
     /*  639081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  639092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  639095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  639098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639127 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639149 */     GIR_RootConstrainSelectedInstOperands,
     /*  639150 */     // GIR_Coverage, 6675,
     /*  639150 */     GIR_EraseRootFromParent_Done,
     /*  639151 */   // Label 10274: @639151
     /*  639151 */   GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(639226), // Rule ID 6678 //
     /*  639156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639224 */     GIR_RootConstrainSelectedInstOperands,
     /*  639225 */     // GIR_Coverage, 6678,
     /*  639225 */     GIR_EraseRootFromParent_Done,
     /*  639226 */   // Label 10275: @639226
     /*  639226 */   GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(639301), // Rule ID 6679 //
     /*  639231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  639242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  639245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  639248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639277 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639299 */     GIR_RootConstrainSelectedInstOperands,
     /*  639300 */     // GIR_Coverage, 6679,
     /*  639300 */     GIR_EraseRootFromParent_Done,
     /*  639301 */   // Label 10276: @639301
     /*  639301 */   GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(639376), // Rule ID 6682 //
     /*  639306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  639352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639374 */     GIR_RootConstrainSelectedInstOperands,
     /*  639375 */     // GIR_Coverage, 6682,
     /*  639375 */     GIR_EraseRootFromParent_Done,
     /*  639376 */   // Label 10277: @639376
     /*  639376 */   GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(639451), // Rule ID 6683 //
     /*  639381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  639392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  639395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  639398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  639427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  639446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639449 */     GIR_RootConstrainSelectedInstOperands,
     /*  639450 */     // GIR_Coverage, 6683,
     /*  639450 */     GIR_EraseRootFromParent_Done,
     /*  639451 */   // Label 10278: @639451
     /*  639451 */   GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(639526), // Rule ID 6686 //
     /*  639456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  639459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  639467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  639470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  639473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  639502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  639521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639524 */     GIR_RootConstrainSelectedInstOperands,
     /*  639525 */     // GIR_Coverage, 6686,
     /*  639525 */     GIR_EraseRootFromParent_Done,
     /*  639526 */   // Label 10279: @639526
     /*  639526 */   GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(639601), // Rule ID 6687 //
     /*  639531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  639534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  639542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  639545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  639548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  639577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  639596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639599 */     GIR_RootConstrainSelectedInstOperands,
     /*  639600 */     // GIR_Coverage, 6687,
     /*  639600 */     GIR_EraseRootFromParent_Done,
     /*  639601 */   // Label 10280: @639601
     /*  639601 */   GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(639676), // Rule ID 6690 //
     /*  639606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  639617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  639620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  639623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  639655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639674 */     GIR_RootConstrainSelectedInstOperands,
     /*  639675 */     // GIR_Coverage, 6690,
     /*  639675 */     GIR_EraseRootFromParent_Done,
     /*  639676 */   // Label 10281: @639676
     /*  639676 */   GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(639751), // Rule ID 6691 //
     /*  639681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  639692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  639695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  639698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639727 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  639730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639749 */     GIR_RootConstrainSelectedInstOperands,
     /*  639750 */     // GIR_Coverage, 6691,
     /*  639750 */     GIR_EraseRootFromParent_Done,
     /*  639751 */   // Label 10282: @639751
     /*  639751 */   GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(639826), // Rule ID 6694 //
     /*  639756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  639767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  639770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  639773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639802 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  639805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639824 */     GIR_RootConstrainSelectedInstOperands,
     /*  639825 */     // GIR_Coverage, 6694,
     /*  639825 */     GIR_EraseRootFromParent_Done,
     /*  639826 */   // Label 10283: @639826
     /*  639826 */   GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(639901), // Rule ID 6695 //
     /*  639831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  639842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  639845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  639848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639877 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  639880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639899 */     GIR_RootConstrainSelectedInstOperands,
     /*  639900 */     // GIR_Coverage, 6695,
     /*  639900 */     GIR_EraseRootFromParent_Done,
     /*  639901 */   // Label 10284: @639901
     /*  639901 */   GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(639976), // Rule ID 6698 //
     /*  639906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  639917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  639920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  639923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639952 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  639955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639974 */     GIR_RootConstrainSelectedInstOperands,
     /*  639975 */     // GIR_Coverage, 6698,
     /*  639975 */     GIR_EraseRootFromParent_Done,
     /*  639976 */   // Label 10285: @639976
     /*  639976 */   GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(640051), // Rule ID 6699 //
     /*  639981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  639992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  639995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  639998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640027 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  640027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640049 */     GIR_RootConstrainSelectedInstOperands,
     /*  640050 */     // GIR_Coverage, 6699,
     /*  640050 */     GIR_EraseRootFromParent_Done,
     /*  640051 */   // Label 10286: @640051
     /*  640051 */   GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(640126), // Rule ID 6702 //
     /*  640056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640124 */     GIR_RootConstrainSelectedInstOperands,
     /*  640125 */     // GIR_Coverage, 6702,
     /*  640125 */     GIR_EraseRootFromParent_Done,
     /*  640126 */   // Label 10287: @640126
     /*  640126 */   GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(640201), // Rule ID 6703 //
     /*  640131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  640142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  640145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  640148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640199 */     GIR_RootConstrainSelectedInstOperands,
     /*  640200 */     // GIR_Coverage, 6703,
     /*  640200 */     GIR_EraseRootFromParent_Done,
     /*  640201 */   // Label 10288: @640201
     /*  640201 */   GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(640276), // Rule ID 6706 //
     /*  640206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640252 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640274 */     GIR_RootConstrainSelectedInstOperands,
     /*  640275 */     // GIR_Coverage, 6706,
     /*  640275 */     GIR_EraseRootFromParent_Done,
     /*  640276 */   // Label 10289: @640276
     /*  640276 */   GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(640351), // Rule ID 6707 //
     /*  640281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  640292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  640295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  640298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640327 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640349 */     GIR_RootConstrainSelectedInstOperands,
     /*  640350 */     // GIR_Coverage, 6707,
     /*  640350 */     GIR_EraseRootFromParent_Done,
     /*  640351 */   // Label 10290: @640351
     /*  640351 */   GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(640426), // Rule ID 6710 //
     /*  640356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640402 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  640402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640424 */     GIR_RootConstrainSelectedInstOperands,
     /*  640425 */     // GIR_Coverage, 6710,
     /*  640425 */     GIR_EraseRootFromParent_Done,
     /*  640426 */   // Label 10291: @640426
     /*  640426 */   GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(640501), // Rule ID 6711 //
     /*  640431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  640442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  640445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  640448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640477 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  640477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  640496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640499 */     GIR_RootConstrainSelectedInstOperands,
     /*  640500 */     // GIR_Coverage, 6711,
     /*  640500 */     GIR_EraseRootFromParent_Done,
     /*  640501 */   // Label 10292: @640501
     /*  640501 */   GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(640576), // Rule ID 6714 //
     /*  640506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  640520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  640523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640574 */     GIR_RootConstrainSelectedInstOperands,
     /*  640575 */     // GIR_Coverage, 6714,
     /*  640575 */     GIR_EraseRootFromParent_Done,
     /*  640576 */   // Label 10293: @640576
     /*  640576 */   GIM_Try, /*On fail goto*//*Label 10294*/ GIMT_Encode4(640651), // Rule ID 6715 //
     /*  640581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  640595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  640598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  640627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640649 */     GIR_RootConstrainSelectedInstOperands,
     /*  640650 */     // GIR_Coverage, 6715,
     /*  640650 */     GIR_EraseRootFromParent_Done,
     /*  640651 */   // Label 10294: @640651
     /*  640651 */   GIM_Try, /*On fail goto*//*Label 10295*/ GIMT_Encode4(640726), // Rule ID 6718 //
     /*  640656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  640667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  640670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  640673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640702 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640724 */     GIR_RootConstrainSelectedInstOperands,
     /*  640725 */     // GIR_Coverage, 6718,
     /*  640725 */     GIR_EraseRootFromParent_Done,
     /*  640726 */   // Label 10295: @640726
     /*  640726 */   GIM_Try, /*On fail goto*//*Label 10296*/ GIMT_Encode4(640801), // Rule ID 6719 //
     /*  640731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  640742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  640745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  640748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640777 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  640777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640799 */     GIR_RootConstrainSelectedInstOperands,
     /*  640800 */     // GIR_Coverage, 6719,
     /*  640800 */     GIR_EraseRootFromParent_Done,
     /*  640801 */   // Label 10296: @640801
     /*  640801 */   GIM_Try, /*On fail goto*//*Label 10297*/ GIMT_Encode4(640876), // Rule ID 6722 //
     /*  640806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  640817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  640820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  640823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640874 */     GIR_RootConstrainSelectedInstOperands,
     /*  640875 */     // GIR_Coverage, 6722,
     /*  640875 */     GIR_EraseRootFromParent_Done,
     /*  640876 */   // Label 10297: @640876
     /*  640876 */   GIM_Try, /*On fail goto*//*Label 10298*/ GIMT_Encode4(640951), // Rule ID 6723 //
     /*  640881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  640892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  640895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  640898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640927 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  640927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640949 */     GIR_RootConstrainSelectedInstOperands,
     /*  640950 */     // GIR_Coverage, 6723,
     /*  640950 */     GIR_EraseRootFromParent_Done,
     /*  640951 */   // Label 10298: @640951
     /*  640951 */   GIM_Try, /*On fail goto*//*Label 10299*/ GIMT_Encode4(641026), // Rule ID 6726 //
     /*  640956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  640959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  640967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  640970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  640973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641002 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641024 */     GIR_RootConstrainSelectedInstOperands,
     /*  641025 */     // GIR_Coverage, 6726,
     /*  641025 */     GIR_EraseRootFromParent_Done,
     /*  641026 */   // Label 10299: @641026
     /*  641026 */   GIM_Try, /*On fail goto*//*Label 10300*/ GIMT_Encode4(641101), // Rule ID 6727 //
     /*  641031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  641042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  641045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  641048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  641066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  641080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641099 */     GIR_RootConstrainSelectedInstOperands,
     /*  641100 */     // GIR_Coverage, 6727,
     /*  641100 */     GIR_EraseRootFromParent_Done,
     /*  641101 */   // Label 10300: @641101
     /*  641101 */   GIM_Try, /*On fail goto*//*Label 10301*/ GIMT_Encode4(641176), // Rule ID 6730 //
     /*  641106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641174 */     GIR_RootConstrainSelectedInstOperands,
     /*  641175 */     // GIR_Coverage, 6730,
     /*  641175 */     GIR_EraseRootFromParent_Done,
     /*  641176 */   // Label 10301: @641176
     /*  641176 */   GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(641251), // Rule ID 6731 //
     /*  641181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  641192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  641195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  641198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  641216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641227 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  641230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641249 */     GIR_RootConstrainSelectedInstOperands,
     /*  641250 */     // GIR_Coverage, 6731,
     /*  641250 */     GIR_EraseRootFromParent_Done,
     /*  641251 */   // Label 10302: @641251
     /*  641251 */   GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(641326), // Rule ID 6734 //
     /*  641256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  641259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  641276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641302 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  641302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641324 */     GIR_RootConstrainSelectedInstOperands,
     /*  641325 */     // GIR_Coverage, 6734,
     /*  641325 */     GIR_EraseRootFromParent_Done,
     /*  641326 */   // Label 10303: @641326
     /*  641326 */   GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(641401), // Rule ID 6735 //
     /*  641331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  641334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  641339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  641342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  641345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  641348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  641351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  641366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  641370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641377 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  641377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  641380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  641396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641399 */     GIR_RootConstrainSelectedInstOperands,
     /*  641400 */     // GIR_Coverage, 6735,
     /*  641400 */     GIR_EraseRootFromParent_Done,
     /*  641401 */   // Label 10304: @641401
     /*  641401 */   GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(641476), // Rule ID 6826 //
     /*  641406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641452 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  641455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641474 */     GIR_RootConstrainSelectedInstOperands,
     /*  641475 */     // GIR_Coverage, 6826,
     /*  641475 */     GIR_EraseRootFromParent_Done,
     /*  641476 */   // Label 10305: @641476
     /*  641476 */   GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(641551), // Rule ID 6827 //
     /*  641481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  641492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  641495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  641498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  641501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641527 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  641530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641549 */     GIR_RootConstrainSelectedInstOperands,
     /*  641550 */     // GIR_Coverage, 6827,
     /*  641550 */     GIR_EraseRootFromParent_Done,
     /*  641551 */   // Label 10306: @641551
     /*  641551 */   GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(641626), // Rule ID 6830 //
     /*  641556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  641567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  641570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  641573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  641576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641602 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641624 */     GIR_RootConstrainSelectedInstOperands,
     /*  641625 */     // GIR_Coverage, 6830,
     /*  641625 */     GIR_EraseRootFromParent_Done,
     /*  641626 */   // Label 10307: @641626
     /*  641626 */   GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(641701), // Rule ID 6831 //
     /*  641631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  641642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  641645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  641648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  641651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641677 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641699 */     GIR_RootConstrainSelectedInstOperands,
     /*  641700 */     // GIR_Coverage, 6831,
     /*  641700 */     GIR_EraseRootFromParent_Done,
     /*  641701 */   // Label 10308: @641701
     /*  641701 */   GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(641776), // Rule ID 6834 //
     /*  641706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  641717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  641720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  641723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  641726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641774 */     GIR_RootConstrainSelectedInstOperands,
     /*  641775 */     // GIR_Coverage, 6834,
     /*  641775 */     GIR_EraseRootFromParent_Done,
     /*  641776 */   // Label 10309: @641776
     /*  641776 */   GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(641851), // Rule ID 6835 //
     /*  641781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  641792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  641795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  641798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  641801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641827 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641849 */     GIR_RootConstrainSelectedInstOperands,
     /*  641850 */     // GIR_Coverage, 6835,
     /*  641850 */     GIR_EraseRootFromParent_Done,
     /*  641851 */   // Label 10310: @641851
     /*  641851 */   GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(641926), // Rule ID 6838 //
     /*  641856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  641867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  641870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  641873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  641876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  641902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  641921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641924 */     GIR_RootConstrainSelectedInstOperands,
     /*  641925 */     // GIR_Coverage, 6838,
     /*  641925 */     GIR_EraseRootFromParent_Done,
     /*  641926 */   // Label 10311: @641926
     /*  641926 */   GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(642001), // Rule ID 6839 //
     /*  641931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  641942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  641945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  641948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  641951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641977 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  641977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  641996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641999 */     GIR_RootConstrainSelectedInstOperands,
     /*  642000 */     // GIR_Coverage, 6839,
     /*  642000 */     GIR_EraseRootFromParent_Done,
     /*  642001 */   // Label 10312: @642001
     /*  642001 */   GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(642076), // Rule ID 6842 //
     /*  642006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642074 */     GIR_RootConstrainSelectedInstOperands,
     /*  642075 */     // GIR_Coverage, 6842,
     /*  642075 */     GIR_EraseRootFromParent_Done,
     /*  642076 */   // Label 10313: @642076
     /*  642076 */   GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(642151), // Rule ID 6843 //
     /*  642081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  642092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  642095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  642098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  642101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642127 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642149 */     GIR_RootConstrainSelectedInstOperands,
     /*  642150 */     // GIR_Coverage, 6843,
     /*  642150 */     GIR_EraseRootFromParent_Done,
     /*  642151 */   // Label 10314: @642151
     /*  642151 */   GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(642226), // Rule ID 6846 //
     /*  642156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642224 */     GIR_RootConstrainSelectedInstOperands,
     /*  642225 */     // GIR_Coverage, 6846,
     /*  642225 */     GIR_EraseRootFromParent_Done,
     /*  642226 */   // Label 10315: @642226
     /*  642226 */   GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(642301), // Rule ID 6847 //
     /*  642231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  642242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  642245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  642248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  642251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642277 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  642280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642299 */     GIR_RootConstrainSelectedInstOperands,
     /*  642300 */     // GIR_Coverage, 6847,
     /*  642300 */     GIR_EraseRootFromParent_Done,
     /*  642301 */   // Label 10316: @642301
     /*  642301 */   GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(642376), // Rule ID 6850 //
     /*  642306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642374 */     GIR_RootConstrainSelectedInstOperands,
     /*  642375 */     // GIR_Coverage, 6850,
     /*  642375 */     GIR_EraseRootFromParent_Done,
     /*  642376 */   // Label 10317: @642376
     /*  642376 */   GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(642451), // Rule ID 6851 //
     /*  642381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  642392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  642395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  642398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  642401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642427 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642449 */     GIR_RootConstrainSelectedInstOperands,
     /*  642450 */     // GIR_Coverage, 6851,
     /*  642450 */     GIR_EraseRootFromParent_Done,
     /*  642451 */   // Label 10318: @642451
     /*  642451 */   GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(642526), // Rule ID 6854 //
     /*  642456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  642467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  642470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  642473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  642476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642502 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642524 */     GIR_RootConstrainSelectedInstOperands,
     /*  642525 */     // GIR_Coverage, 6854,
     /*  642525 */     GIR_EraseRootFromParent_Done,
     /*  642526 */   // Label 10319: @642526
     /*  642526 */   GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(642601), // Rule ID 6855 //
     /*  642531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  642542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  642545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  642548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  642551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642577 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642599 */     GIR_RootConstrainSelectedInstOperands,
     /*  642600 */     // GIR_Coverage, 6855,
     /*  642600 */     GIR_EraseRootFromParent_Done,
     /*  642601 */   // Label 10320: @642601
     /*  642601 */   GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(642676), // Rule ID 6858 //
     /*  642606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  642617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  642620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  642623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  642626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642674 */     GIR_RootConstrainSelectedInstOperands,
     /*  642675 */     // GIR_Coverage, 6858,
     /*  642675 */     GIR_EraseRootFromParent_Done,
     /*  642676 */   // Label 10321: @642676
     /*  642676 */   GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(642751), // Rule ID 6859 //
     /*  642681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  642692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  642695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  642698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  642701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642749 */     GIR_RootConstrainSelectedInstOperands,
     /*  642750 */     // GIR_Coverage, 6859,
     /*  642750 */     GIR_EraseRootFromParent_Done,
     /*  642751 */   // Label 10322: @642751
     /*  642751 */   GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(642826), // Rule ID 6862 //
     /*  642756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  642759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  642767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  642770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  642773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  642776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  642802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  642821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642824 */     GIR_RootConstrainSelectedInstOperands,
     /*  642825 */     // GIR_Coverage, 6862,
     /*  642825 */     GIR_EraseRootFromParent_Done,
     /*  642826 */   // Label 10323: @642826
     /*  642826 */   GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(642901), // Rule ID 6863 //
     /*  642831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  642834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  642842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  642845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  642848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  642851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  642877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  642896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642899 */     GIR_RootConstrainSelectedInstOperands,
     /*  642900 */     // GIR_Coverage, 6863,
     /*  642900 */     GIR_EraseRootFromParent_Done,
     /*  642901 */   // Label 10324: @642901
     /*  642901 */   GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(642976), // Rule ID 6866 //
     /*  642906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  642917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  642920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  642923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  642926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  642955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642974 */     GIR_RootConstrainSelectedInstOperands,
     /*  642975 */     // GIR_Coverage, 6866,
     /*  642975 */     GIR_EraseRootFromParent_Done,
     /*  642976 */   // Label 10325: @642976
     /*  642976 */   GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(643051), // Rule ID 6867 //
     /*  642981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  642992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  642995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  642998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  643001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643049 */     GIR_RootConstrainSelectedInstOperands,
     /*  643050 */     // GIR_Coverage, 6867,
     /*  643050 */     GIR_EraseRootFromParent_Done,
     /*  643051 */   // Label 10326: @643051
     /*  643051 */   GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(643126), // Rule ID 6870 //
     /*  643056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643102 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643124 */     GIR_RootConstrainSelectedInstOperands,
     /*  643125 */     // GIR_Coverage, 6870,
     /*  643125 */     GIR_EraseRootFromParent_Done,
     /*  643126 */   // Label 10327: @643126
     /*  643126 */   GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(643201), // Rule ID 6871 //
     /*  643131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  643142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  643145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  643148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  643151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643177 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643199 */     GIR_RootConstrainSelectedInstOperands,
     /*  643200 */     // GIR_Coverage, 6871,
     /*  643200 */     GIR_EraseRootFromParent_Done,
     /*  643201 */   // Label 10328: @643201
     /*  643201 */   GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(643276), // Rule ID 6874 //
     /*  643206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643252 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  643252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643274 */     GIR_RootConstrainSelectedInstOperands,
     /*  643275 */     // GIR_Coverage, 6874,
     /*  643275 */     GIR_EraseRootFromParent_Done,
     /*  643276 */   // Label 10329: @643276
     /*  643276 */   GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(643351), // Rule ID 6875 //
     /*  643281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  643292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  643295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  643298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  643301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643327 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  643327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  643346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643349 */     GIR_RootConstrainSelectedInstOperands,
     /*  643350 */     // GIR_Coverage, 6875,
     /*  643350 */     GIR_EraseRootFromParent_Done,
     /*  643351 */   // Label 10330: @643351
     /*  643351 */   GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(643426), // Rule ID 6878 //
     /*  643356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643424 */     GIR_RootConstrainSelectedInstOperands,
     /*  643425 */     // GIR_Coverage, 6878,
     /*  643425 */     GIR_EraseRootFromParent_Done,
     /*  643426 */   // Label 10331: @643426
     /*  643426 */   GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(643501), // Rule ID 6879 //
     /*  643431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  643442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  643445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  643448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  643451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643477 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643499 */     GIR_RootConstrainSelectedInstOperands,
     /*  643500 */     // GIR_Coverage, 6879,
     /*  643500 */     GIR_EraseRootFromParent_Done,
     /*  643501 */   // Label 10332: @643501
     /*  643501 */   GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(643576), // Rule ID 6882 //
     /*  643506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  643520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  643523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  643526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643552 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643574 */     GIR_RootConstrainSelectedInstOperands,
     /*  643575 */     // GIR_Coverage, 6882,
     /*  643575 */     GIR_EraseRootFromParent_Done,
     /*  643576 */   // Label 10333: @643576
     /*  643576 */   GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(643651), // Rule ID 6883 //
     /*  643581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  643595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  643598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  643601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643627 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643649 */     GIR_RootConstrainSelectedInstOperands,
     /*  643650 */     // GIR_Coverage, 6883,
     /*  643650 */     GIR_EraseRootFromParent_Done,
     /*  643651 */   // Label 10334: @643651
     /*  643651 */   GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(643726), // Rule ID 6886 //
     /*  643656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  643667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  643670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  643673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  643676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643702 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643724 */     GIR_RootConstrainSelectedInstOperands,
     /*  643725 */     // GIR_Coverage, 6886,
     /*  643725 */     GIR_EraseRootFromParent_Done,
     /*  643726 */   // Label 10335: @643726
     /*  643726 */   GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(643801), // Rule ID 6887 //
     /*  643731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  643742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  643745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  643748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  643751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643777 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643799 */     GIR_RootConstrainSelectedInstOperands,
     /*  643800 */     // GIR_Coverage, 6887,
     /*  643800 */     GIR_EraseRootFromParent_Done,
     /*  643801 */   // Label 10336: @643801
     /*  643801 */   GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(643876), // Rule ID 6890 //
     /*  643806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  643817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  643820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  643823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  643826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643874 */     GIR_RootConstrainSelectedInstOperands,
     /*  643875 */     // GIR_Coverage, 6890,
     /*  643875 */     GIR_EraseRootFromParent_Done,
     /*  643876 */   // Label 10337: @643876
     /*  643876 */   GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(643951), // Rule ID 6891 //
     /*  643881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  643892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  643895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  643898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  643901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643949 */     GIR_RootConstrainSelectedInstOperands,
     /*  643950 */     // GIR_Coverage, 6891,
     /*  643950 */     GIR_EraseRootFromParent_Done,
     /*  643951 */   // Label 10338: @643951
     /*  643951 */   GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(644026), // Rule ID 6894 //
     /*  643956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  643967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  643970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  643973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  643976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644024 */     GIR_RootConstrainSelectedInstOperands,
     /*  644025 */     // GIR_Coverage, 6894,
     /*  644025 */     GIR_EraseRootFromParent_Done,
     /*  644026 */   // Label 10339: @644026
     /*  644026 */   GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(644101), // Rule ID 6895 //
     /*  644031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  644042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  644045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  644048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  644051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644077 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644099 */     GIR_RootConstrainSelectedInstOperands,
     /*  644100 */     // GIR_Coverage, 6895,
     /*  644100 */     GIR_EraseRootFromParent_Done,
     /*  644101 */   // Label 10340: @644101
     /*  644101 */   GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(644176), // Rule ID 6898 //
     /*  644106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644152 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644174 */     GIR_RootConstrainSelectedInstOperands,
     /*  644175 */     // GIR_Coverage, 6898,
     /*  644175 */     GIR_EraseRootFromParent_Done,
     /*  644176 */   // Label 10341: @644176
     /*  644176 */   GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(644251), // Rule ID 6899 //
     /*  644181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  644192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  644195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  644198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  644201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644227 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  644227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  644246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644249 */     GIR_RootConstrainSelectedInstOperands,
     /*  644250 */     // GIR_Coverage, 6899,
     /*  644250 */     GIR_EraseRootFromParent_Done,
     /*  644251 */   // Label 10342: @644251
     /*  644251 */   GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(644326), // Rule ID 6902 //
     /*  644256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644324 */     GIR_RootConstrainSelectedInstOperands,
     /*  644325 */     // GIR_Coverage, 6902,
     /*  644325 */     GIR_EraseRootFromParent_Done,
     /*  644326 */   // Label 10343: @644326
     /*  644326 */   GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(644401), // Rule ID 6903 //
     /*  644331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  644342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  644345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  644348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  644351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  644370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  644380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644399 */     GIR_RootConstrainSelectedInstOperands,
     /*  644400 */     // GIR_Coverage, 6903,
     /*  644400 */     GIR_EraseRootFromParent_Done,
     /*  644401 */   // Label 10344: @644401
     /*  644401 */   GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(644476), // Rule ID 6906 //
     /*  644406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644452 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644474 */     GIR_RootConstrainSelectedInstOperands,
     /*  644475 */     // GIR_Coverage, 6906,
     /*  644475 */     GIR_EraseRootFromParent_Done,
     /*  644476 */   // Label 10345: @644476
     /*  644476 */   GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(644551), // Rule ID 6907 //
     /*  644481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  644492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  644495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  644498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  644501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644527 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644549 */     GIR_RootConstrainSelectedInstOperands,
     /*  644550 */     // GIR_Coverage, 6907,
     /*  644550 */     GIR_EraseRootFromParent_Done,
     /*  644551 */   // Label 10346: @644551
     /*  644551 */   GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(644626), // Rule ID 6910 //
     /*  644556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  644567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  644570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  644573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  644576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644624 */     GIR_RootConstrainSelectedInstOperands,
     /*  644625 */     // GIR_Coverage, 6910,
     /*  644625 */     GIR_EraseRootFromParent_Done,
     /*  644626 */   // Label 10347: @644626
     /*  644626 */   GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(644701), // Rule ID 6911 //
     /*  644631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  644642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  644645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  644648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  644651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644677 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644699 */     GIR_RootConstrainSelectedInstOperands,
     /*  644700 */     // GIR_Coverage, 6911,
     /*  644700 */     GIR_EraseRootFromParent_Done,
     /*  644701 */   // Label 10348: @644701
     /*  644701 */   GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(644776), // Rule ID 6914 //
     /*  644706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  644717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  644720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  644723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644752 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  644752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  644755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644774 */     GIR_RootConstrainSelectedInstOperands,
     /*  644775 */     // GIR_Coverage, 6914,
     /*  644775 */     GIR_EraseRootFromParent_Done,
     /*  644776 */   // Label 10349: @644776
     /*  644776 */   GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(644851), // Rule ID 6915 //
     /*  644781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  644792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  644795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  644798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644827 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  644827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  644830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644849 */     GIR_RootConstrainSelectedInstOperands,
     /*  644850 */     // GIR_Coverage, 6915,
     /*  644850 */     GIR_EraseRootFromParent_Done,
     /*  644851 */   // Label 10350: @644851
     /*  644851 */   GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(644926), // Rule ID 6918 //
     /*  644856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  644867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  644870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  644873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644902 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  644902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  644905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644924 */     GIR_RootConstrainSelectedInstOperands,
     /*  644925 */     // GIR_Coverage, 6918,
     /*  644925 */     GIR_EraseRootFromParent_Done,
     /*  644926 */   // Label 10351: @644926
     /*  644926 */   GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(645001), // Rule ID 6919 //
     /*  644931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  644942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  644945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  644948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644977 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  644977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  644980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644999 */     GIR_RootConstrainSelectedInstOperands,
     /*  645000 */     // GIR_Coverage, 6919,
     /*  645000 */     GIR_EraseRootFromParent_Done,
     /*  645001 */   // Label 10352: @645001
     /*  645001 */   GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(645076), // Rule ID 6922 //
     /*  645006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645074 */     GIR_RootConstrainSelectedInstOperands,
     /*  645075 */     // GIR_Coverage, 6922,
     /*  645075 */     GIR_EraseRootFromParent_Done,
     /*  645076 */   // Label 10353: @645076
     /*  645076 */   GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(645151), // Rule ID 6923 //
     /*  645081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  645092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  645095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  645098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645127 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645149 */     GIR_RootConstrainSelectedInstOperands,
     /*  645150 */     // GIR_Coverage, 6923,
     /*  645150 */     GIR_EraseRootFromParent_Done,
     /*  645151 */   // Label 10354: @645151
     /*  645151 */   GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(645226), // Rule ID 6926 //
     /*  645156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645202 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645224 */     GIR_RootConstrainSelectedInstOperands,
     /*  645225 */     // GIR_Coverage, 6926,
     /*  645225 */     GIR_EraseRootFromParent_Done,
     /*  645226 */   // Label 10355: @645226
     /*  645226 */   GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(645301), // Rule ID 6927 //
     /*  645231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  645242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  645245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  645248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645277 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  645280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645299 */     GIR_RootConstrainSelectedInstOperands,
     /*  645300 */     // GIR_Coverage, 6927,
     /*  645300 */     GIR_EraseRootFromParent_Done,
     /*  645301 */   // Label 10356: @645301
     /*  645301 */   GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(645376), // Rule ID 6930 //
     /*  645306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645374 */     GIR_RootConstrainSelectedInstOperands,
     /*  645375 */     // GIR_Coverage, 6930,
     /*  645375 */     GIR_EraseRootFromParent_Done,
     /*  645376 */   // Label 10357: @645376
     /*  645376 */   GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(645451), // Rule ID 6931 //
     /*  645381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  645392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  645395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  645398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645427 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645449 */     GIR_RootConstrainSelectedInstOperands,
     /*  645450 */     // GIR_Coverage, 6931,
     /*  645450 */     GIR_EraseRootFromParent_Done,
     /*  645451 */   // Label 10358: @645451
     /*  645451 */   GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(645526), // Rule ID 6934 //
     /*  645456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  645467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  645470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  645473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  645502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645524 */     GIR_RootConstrainSelectedInstOperands,
     /*  645525 */     // GIR_Coverage, 6934,
     /*  645525 */     GIR_EraseRootFromParent_Done,
     /*  645526 */   // Label 10359: @645526
     /*  645526 */   GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(645601), // Rule ID 6935 //
     /*  645531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  645542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  645545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  645548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645577 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  645577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645599 */     GIR_RootConstrainSelectedInstOperands,
     /*  645600 */     // GIR_Coverage, 6935,
     /*  645600 */     GIR_EraseRootFromParent_Done,
     /*  645601 */   // Label 10360: @645601
     /*  645601 */   GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(645676), // Rule ID 6938 //
     /*  645606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  645617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  645620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  645623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645674 */     GIR_RootConstrainSelectedInstOperands,
     /*  645675 */     // GIR_Coverage, 6938,
     /*  645675 */     GIR_EraseRootFromParent_Done,
     /*  645676 */   // Label 10361: @645676
     /*  645676 */   GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(645751), // Rule ID 6939 //
     /*  645681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  645692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  645695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  645698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11581:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645749 */     GIR_RootConstrainSelectedInstOperands,
     /*  645750 */     // GIR_Coverage, 6939,
     /*  645750 */     GIR_EraseRootFromParent_Done,
     /*  645751 */   // Label 10362: @645751
     /*  645751 */   GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(645826), // Rule ID 6942 //
     /*  645756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  645767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  645770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  645773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645824 */     GIR_RootConstrainSelectedInstOperands,
     /*  645825 */     // GIR_Coverage, 6942,
     /*  645825 */     GIR_EraseRootFromParent_Done,
     /*  645826 */   // Label 10363: @645826
     /*  645826 */   GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(645901), // Rule ID 6943 //
     /*  645831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  645842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  645845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  645848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645899 */     GIR_RootConstrainSelectedInstOperands,
     /*  645900 */     // GIR_Coverage, 6943,
     /*  645900 */     GIR_EraseRootFromParent_Done,
     /*  645901 */   // Label 10364: @645901
     /*  645901 */   GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(645976), // Rule ID 6946 //
     /*  645906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  645917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  645920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  645923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  645952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645974 */     GIR_RootConstrainSelectedInstOperands,
     /*  645975 */     // GIR_Coverage, 6946,
     /*  645975 */     GIR_EraseRootFromParent_Done,
     /*  645976 */   // Label 10365: @645976
     /*  645976 */   GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(646051), // Rule ID 6947 //
     /*  645981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  645992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  645995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  645998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646049 */     GIR_RootConstrainSelectedInstOperands,
     /*  646050 */     // GIR_Coverage, 6947,
     /*  646050 */     GIR_EraseRootFromParent_Done,
     /*  646051 */   // Label 10366: @646051
     /*  646051 */   GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(646126), // Rule ID 6950 //
     /*  646056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  646059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  646102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646124 */     GIR_RootConstrainSelectedInstOperands,
     /*  646125 */     // GIR_Coverage, 6950,
     /*  646125 */     GIR_EraseRootFromParent_Done,
     /*  646126 */   // Label 10367: @646126
     /*  646126 */   GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(646201), // Rule ID 6951 //
     /*  646131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  646134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  646142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  646145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  646148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  646166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  646177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  646180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  646196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646199 */     GIR_RootConstrainSelectedInstOperands,
     /*  646200 */     // GIR_Coverage, 6951,
     /*  646200 */     GIR_EraseRootFromParent_Done,
     /*  646201 */   // Label 10368: @646201
     /*  646201 */   GIM_Try, /*On fail goto*//*Label 10369*/ GIMT_Encode4(646276), // Rule ID 6954 //
     /*  646206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646274 */     GIR_RootConstrainSelectedInstOperands,
     /*  646275 */     // GIR_Coverage, 6954,
     /*  646275 */     GIR_EraseRootFromParent_Done,
     /*  646276 */   // Label 10369: @646276
     /*  646276 */   GIM_Try, /*On fail goto*//*Label 10370*/ GIMT_Encode4(646351), // Rule ID 6955 //
     /*  646281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  646292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  646295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  646298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646349 */     GIR_RootConstrainSelectedInstOperands,
     /*  646350 */     // GIR_Coverage, 6955,
     /*  646350 */     GIR_EraseRootFromParent_Done,
     /*  646351 */   // Label 10370: @646351
     /*  646351 */   GIM_Try, /*On fail goto*//*Label 10371*/ GIMT_Encode4(646426), // Rule ID 6958 //
     /*  646356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646424 */     GIR_RootConstrainSelectedInstOperands,
     /*  646425 */     // GIR_Coverage, 6958,
     /*  646425 */     GIR_EraseRootFromParent_Done,
     /*  646426 */   // Label 10371: @646426
     /*  646426 */   GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(646501), // Rule ID 6959 //
     /*  646431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  646442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  646445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  646448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646477 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646499 */     GIR_RootConstrainSelectedInstOperands,
     /*  646500 */     // GIR_Coverage, 6959,
     /*  646500 */     GIR_EraseRootFromParent_Done,
     /*  646501 */   // Label 10372: @646501
     /*  646501 */   GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(646576), // Rule ID 6962 //
     /*  646506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  646520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  646523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646552 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  646555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646574 */     GIR_RootConstrainSelectedInstOperands,
     /*  646575 */     // GIR_Coverage, 6962,
     /*  646575 */     GIR_EraseRootFromParent_Done,
     /*  646576 */   // Label 10373: @646576
     /*  646576 */   GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(646651), // Rule ID 6963 //
     /*  646581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  646595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  646598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646627 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  646630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646649 */     GIR_RootConstrainSelectedInstOperands,
     /*  646650 */     // GIR_Coverage, 6963,
     /*  646650 */     GIR_EraseRootFromParent_Done,
     /*  646651 */   // Label 10374: @646651
     /*  646651 */   GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(646726), // Rule ID 6966 //
     /*  646656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  646667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  646670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  646673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646724 */     GIR_RootConstrainSelectedInstOperands,
     /*  646725 */     // GIR_Coverage, 6966,
     /*  646725 */     GIR_EraseRootFromParent_Done,
     /*  646726 */   // Label 10375: @646726
     /*  646726 */   GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(646801), // Rule ID 6967 //
     /*  646731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  646742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  646745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  646748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646799 */     GIR_RootConstrainSelectedInstOperands,
     /*  646800 */     // GIR_Coverage, 6967,
     /*  646800 */     GIR_EraseRootFromParent_Done,
     /*  646801 */   // Label 10376: @646801
     /*  646801 */   GIM_Try, /*On fail goto*//*Label 10377*/ GIMT_Encode4(646876), // Rule ID 6970 //
     /*  646806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  646817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  646820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  646823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646852 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646874 */     GIR_RootConstrainSelectedInstOperands,
     /*  646875 */     // GIR_Coverage, 6970,
     /*  646875 */     GIR_EraseRootFromParent_Done,
     /*  646876 */   // Label 10377: @646876
     /*  646876 */   GIM_Try, /*On fail goto*//*Label 10378*/ GIMT_Encode4(646951), // Rule ID 6971 //
     /*  646881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  646892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  646895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  646898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646927 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646949 */     GIR_RootConstrainSelectedInstOperands,
     /*  646950 */     // GIR_Coverage, 6971,
     /*  646950 */     GIR_EraseRootFromParent_Done,
     /*  646951 */   // Label 10378: @646951
     /*  646951 */   GIM_Try, /*On fail goto*//*Label 10379*/ GIMT_Encode4(647026), // Rule ID 6974 //
     /*  646956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  646967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  646970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  646973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647024 */     GIR_RootConstrainSelectedInstOperands,
     /*  647025 */     // GIR_Coverage, 6974,
     /*  647025 */     GIR_EraseRootFromParent_Done,
     /*  647026 */   // Label 10379: @647026
     /*  647026 */   GIM_Try, /*On fail goto*//*Label 10380*/ GIMT_Encode4(647101), // Rule ID 6975 //
     /*  647031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  647042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  647045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  647048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647077 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  647077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  647096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647099 */     GIR_RootConstrainSelectedInstOperands,
     /*  647100 */     // GIR_Coverage, 6975,
     /*  647100 */     GIR_EraseRootFromParent_Done,
     /*  647101 */   // Label 10380: @647101
     /*  647101 */   GIM_Try, /*On fail goto*//*Label 10381*/ GIMT_Encode4(647176), // Rule ID 6978 //
     /*  647106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647174 */     GIR_RootConstrainSelectedInstOperands,
     /*  647175 */     // GIR_Coverage, 6978,
     /*  647175 */     GIR_EraseRootFromParent_Done,
     /*  647176 */   // Label 10381: @647176
     /*  647176 */   GIM_Try, /*On fail goto*//*Label 10382*/ GIMT_Encode4(647251), // Rule ID 6979 //
     /*  647181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  647192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  647195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  647198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647227 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647249 */     GIR_RootConstrainSelectedInstOperands,
     /*  647250 */     // GIR_Coverage, 6979,
     /*  647250 */     GIR_EraseRootFromParent_Done,
     /*  647251 */   // Label 10382: @647251
     /*  647251 */   GIM_Try, /*On fail goto*//*Label 10383*/ GIMT_Encode4(647326), // Rule ID 6982 //
     /*  647256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647324 */     GIR_RootConstrainSelectedInstOperands,
     /*  647325 */     // GIR_Coverage, 6982,
     /*  647325 */     GIR_EraseRootFromParent_Done,
     /*  647326 */   // Label 10383: @647326
     /*  647326 */   GIM_Try, /*On fail goto*//*Label 10384*/ GIMT_Encode4(647401), // Rule ID 6983 //
     /*  647331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  647342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  647345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  647348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647377 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647399 */     GIR_RootConstrainSelectedInstOperands,
     /*  647400 */     // GIR_Coverage, 6983,
     /*  647400 */     GIR_EraseRootFromParent_Done,
     /*  647401 */   // Label 10384: @647401
     /*  647401 */   GIM_Try, /*On fail goto*//*Label 10385*/ GIMT_Encode4(647476), // Rule ID 6986 //
     /*  647406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  647452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647474 */     GIR_RootConstrainSelectedInstOperands,
     /*  647475 */     // GIR_Coverage, 6986,
     /*  647475 */     GIR_EraseRootFromParent_Done,
     /*  647476 */   // Label 10385: @647476
     /*  647476 */   GIM_Try, /*On fail goto*//*Label 10386*/ GIMT_Encode4(647551), // Rule ID 6987 //
     /*  647481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  647492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  647495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  647498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647527 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647549 */     GIR_RootConstrainSelectedInstOperands,
     /*  647550 */     // GIR_Coverage, 6987,
     /*  647550 */     GIR_EraseRootFromParent_Done,
     /*  647551 */   // Label 10386: @647551
     /*  647551 */   GIM_Try, /*On fail goto*//*Label 10387*/ GIMT_Encode4(647626), // Rule ID 6990 //
     /*  647556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  647567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  647570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  647573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  647602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647624 */     GIR_RootConstrainSelectedInstOperands,
     /*  647625 */     // GIR_Coverage, 6990,
     /*  647625 */     GIR_EraseRootFromParent_Done,
     /*  647626 */   // Label 10387: @647626
     /*  647626 */   GIM_Try, /*On fail goto*//*Label 10388*/ GIMT_Encode4(647701), // Rule ID 6991 //
     /*  647631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  647634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  647642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  647645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  647648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  647677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647699 */     GIR_RootConstrainSelectedInstOperands,
     /*  647700 */     // GIR_Coverage, 6991,
     /*  647700 */     GIR_EraseRootFromParent_Done,
     /*  647701 */   // Label 10388: @647701
     /*  647701 */   GIM_Try, /*On fail goto*//*Label 10389*/ GIMT_Encode4(647776), // Rule ID 6994 //
     /*  647706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  647717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  647720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  647723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  647752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647774 */     GIR_RootConstrainSelectedInstOperands,
     /*  647775 */     // GIR_Coverage, 6994,
     /*  647775 */     GIR_EraseRootFromParent_Done,
     /*  647776 */   // Label 10389: @647776
     /*  647776 */   GIM_Try, /*On fail goto*//*Label 10390*/ GIMT_Encode4(647851), // Rule ID 6995 //
     /*  647781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  647784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  647792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  647795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  647798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647827 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  647827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647849 */     GIR_RootConstrainSelectedInstOperands,
     /*  647850 */     // GIR_Coverage, 6995,
     /*  647850 */     GIR_EraseRootFromParent_Done,
     /*  647851 */   // Label 10390: @647851
     /*  647851 */   GIM_Try, /*On fail goto*//*Label 10391*/ GIMT_Encode4(647926), // Rule ID 6998 //
     /*  647856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  647867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  647870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  647873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647902 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  647902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647924 */     GIR_RootConstrainSelectedInstOperands,
     /*  647925 */     // GIR_Coverage, 6998,
     /*  647925 */     GIR_EraseRootFromParent_Done,
     /*  647926 */   // Label 10391: @647926
     /*  647926 */   GIM_Try, /*On fail goto*//*Label 10392*/ GIMT_Encode4(648001), // Rule ID 6999 //
     /*  647931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  647934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  647942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  647945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  647948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647977 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  647977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647999 */     GIR_RootConstrainSelectedInstOperands,
     /*  648000 */     // GIR_Coverage, 6999,
     /*  648000 */     GIR_EraseRootFromParent_Done,
     /*  648001 */   // Label 10392: @648001
     /*  648001 */   GIM_Try, /*On fail goto*//*Label 10393*/ GIMT_Encode4(648076), // Rule ID 7090 //
     /*  648006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  648055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648074 */     GIR_RootConstrainSelectedInstOperands,
     /*  648075 */     // GIR_Coverage, 7090,
     /*  648075 */     GIR_EraseRootFromParent_Done,
     /*  648076 */   // Label 10393: @648076
     /*  648076 */   GIM_Try, /*On fail goto*//*Label 10394*/ GIMT_Encode4(648151), // Rule ID 7091 //
     /*  648081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  648092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  648095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  648098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  648101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648127 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  648130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648149 */     GIR_RootConstrainSelectedInstOperands,
     /*  648150 */     // GIR_Coverage, 7091,
     /*  648150 */     GIR_EraseRootFromParent_Done,
     /*  648151 */   // Label 10394: @648151
     /*  648151 */   GIM_Try, /*On fail goto*//*Label 10395*/ GIMT_Encode4(648226), // Rule ID 7094 //
     /*  648156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648202 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648224 */     GIR_RootConstrainSelectedInstOperands,
     /*  648225 */     // GIR_Coverage, 7094,
     /*  648225 */     GIR_EraseRootFromParent_Done,
     /*  648226 */   // Label 10395: @648226
     /*  648226 */   GIM_Try, /*On fail goto*//*Label 10396*/ GIMT_Encode4(648301), // Rule ID 7095 //
     /*  648231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  648242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  648245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  648248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  648251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648277 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648299 */     GIR_RootConstrainSelectedInstOperands,
     /*  648300 */     // GIR_Coverage, 7095,
     /*  648300 */     GIR_EraseRootFromParent_Done,
     /*  648301 */   // Label 10396: @648301
     /*  648301 */   GIM_Try, /*On fail goto*//*Label 10397*/ GIMT_Encode4(648376), // Rule ID 7098 //
     /*  648306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648374 */     GIR_RootConstrainSelectedInstOperands,
     /*  648375 */     // GIR_Coverage, 7098,
     /*  648375 */     GIR_EraseRootFromParent_Done,
     /*  648376 */   // Label 10397: @648376
     /*  648376 */   GIM_Try, /*On fail goto*//*Label 10398*/ GIMT_Encode4(648451), // Rule ID 7099 //
     /*  648381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  648392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  648395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  648398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  648401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648427 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648449 */     GIR_RootConstrainSelectedInstOperands,
     /*  648450 */     // GIR_Coverage, 7099,
     /*  648450 */     GIR_EraseRootFromParent_Done,
     /*  648451 */   // Label 10398: @648451
     /*  648451 */   GIM_Try, /*On fail goto*//*Label 10399*/ GIMT_Encode4(648526), // Rule ID 7102 //
     /*  648456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  648467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  648470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  648473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  648476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  648502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648524 */     GIR_RootConstrainSelectedInstOperands,
     /*  648525 */     // GIR_Coverage, 7102,
     /*  648525 */     GIR_EraseRootFromParent_Done,
     /*  648526 */   // Label 10399: @648526
     /*  648526 */   GIM_Try, /*On fail goto*//*Label 10400*/ GIMT_Encode4(648601), // Rule ID 7103 //
     /*  648531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  648542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  648545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  648548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  648551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648577 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  648577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648599 */     GIR_RootConstrainSelectedInstOperands,
     /*  648600 */     // GIR_Coverage, 7103,
     /*  648600 */     GIR_EraseRootFromParent_Done,
     /*  648601 */   // Label 10400: @648601
     /*  648601 */   GIM_Try, /*On fail goto*//*Label 10401*/ GIMT_Encode4(648676), // Rule ID 7106 //
     /*  648606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  648617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  648620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  648623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  648626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  648652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648674 */     GIR_RootConstrainSelectedInstOperands,
     /*  648675 */     // GIR_Coverage, 7106,
     /*  648675 */     GIR_EraseRootFromParent_Done,
     /*  648676 */   // Label 10401: @648676
     /*  648676 */   GIM_Try, /*On fail goto*//*Label 10402*/ GIMT_Encode4(648751), // Rule ID 7107 //
     /*  648681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  648692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  648695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  648698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  648701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648727 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  648727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648749 */     GIR_RootConstrainSelectedInstOperands,
     /*  648750 */     // GIR_Coverage, 7107,
     /*  648750 */     GIR_EraseRootFromParent_Done,
     /*  648751 */   // Label 10402: @648751
     /*  648751 */   GIM_Try, /*On fail goto*//*Label 10403*/ GIMT_Encode4(648826), // Rule ID 7110 //
     /*  648756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  648767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  648770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  648773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  648776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  648802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648824 */     GIR_RootConstrainSelectedInstOperands,
     /*  648825 */     // GIR_Coverage, 7110,
     /*  648825 */     GIR_EraseRootFromParent_Done,
     /*  648826 */   // Label 10403: @648826
     /*  648826 */   GIM_Try, /*On fail goto*//*Label 10404*/ GIMT_Encode4(648901), // Rule ID 7111 //
     /*  648831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  648842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  648845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  648848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  648851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648877 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  648877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648899 */     GIR_RootConstrainSelectedInstOperands,
     /*  648900 */     // GIR_Coverage, 7111,
     /*  648900 */     GIR_EraseRootFromParent_Done,
     /*  648901 */   // Label 10404: @648901
     /*  648901 */   GIM_Try, /*On fail goto*//*Label 10405*/ GIMT_Encode4(648976), // Rule ID 7114 //
     /*  648906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  648917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  648920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  648923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  648926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648974 */     GIR_RootConstrainSelectedInstOperands,
     /*  648975 */     // GIR_Coverage, 7114,
     /*  648975 */     GIR_EraseRootFromParent_Done,
     /*  648976 */   // Label 10405: @648976
     /*  648976 */   GIM_Try, /*On fail goto*//*Label 10406*/ GIMT_Encode4(649051), // Rule ID 7115 //
     /*  648981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  648992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  648995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  648998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  649001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649049 */     GIR_RootConstrainSelectedInstOperands,
     /*  649050 */     // GIR_Coverage, 7115,
     /*  649050 */     GIR_EraseRootFromParent_Done,
     /*  649051 */   // Label 10406: @649051
     /*  649051 */   GIM_Try, /*On fail goto*//*Label 10407*/ GIMT_Encode4(649126), // Rule ID 7118 //
     /*  649056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649124 */     GIR_RootConstrainSelectedInstOperands,
     /*  649125 */     // GIR_Coverage, 7118,
     /*  649125 */     GIR_EraseRootFromParent_Done,
     /*  649126 */   // Label 10407: @649126
     /*  649126 */   GIM_Try, /*On fail goto*//*Label 10408*/ GIMT_Encode4(649201), // Rule ID 7119 //
     /*  649131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  649142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  649145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  649148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  649151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649199 */     GIR_RootConstrainSelectedInstOperands,
     /*  649200 */     // GIR_Coverage, 7119,
     /*  649200 */     GIR_EraseRootFromParent_Done,
     /*  649201 */   // Label 10408: @649201
     /*  649201 */   GIM_Try, /*On fail goto*//*Label 10409*/ GIMT_Encode4(649276), // Rule ID 7122 //
     /*  649206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  649226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649274 */     GIR_RootConstrainSelectedInstOperands,
     /*  649275 */     // GIR_Coverage, 7122,
     /*  649275 */     GIR_EraseRootFromParent_Done,
     /*  649276 */   // Label 10409: @649276
     /*  649276 */   GIM_Try, /*On fail goto*//*Label 10410*/ GIMT_Encode4(649351), // Rule ID 7123 //
     /*  649281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  649292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  649295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  649298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  649301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  649327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649349 */     GIR_RootConstrainSelectedInstOperands,
     /*  649350 */     // GIR_Coverage, 7123,
     /*  649350 */     GIR_EraseRootFromParent_Done,
     /*  649351 */   // Label 10410: @649351
     /*  649351 */   GIM_Try, /*On fail goto*//*Label 10411*/ GIMT_Encode4(649426), // Rule ID 7126 //
     /*  649356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  649359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  649376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  649402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649424 */     GIR_RootConstrainSelectedInstOperands,
     /*  649425 */     // GIR_Coverage, 7126,
     /*  649425 */     GIR_EraseRootFromParent_Done,
     /*  649426 */   // Label 10411: @649426
     /*  649426 */   GIM_Try, /*On fail goto*//*Label 10412*/ GIMT_Encode4(649501), // Rule ID 7127 //
     /*  649431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  649434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  649442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  649445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  649448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  649451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  649470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649477 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  649477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  649480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  649496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649499 */     GIR_RootConstrainSelectedInstOperands,
     /*  649500 */     // GIR_Coverage, 7127,
     /*  649500 */     GIR_EraseRootFromParent_Done,
     /*  649501 */   // Label 10412: @649501
     /*  649501 */   GIM_Try, /*On fail goto*//*Label 10413*/ GIMT_Encode4(649576), // Rule ID 7130 //
     /*  649506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  649517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  649520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  649526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  649555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649574 */     GIR_RootConstrainSelectedInstOperands,
     /*  649575 */     // GIR_Coverage, 7130,
     /*  649575 */     GIR_EraseRootFromParent_Done,
     /*  649576 */   // Label 10413: @649576
     /*  649576 */   GIM_Try, /*On fail goto*//*Label 10414*/ GIMT_Encode4(649651), // Rule ID 7131 //
     /*  649581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  649592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  649595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  649601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649627 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  649630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649649 */     GIR_RootConstrainSelectedInstOperands,
     /*  649650 */     // GIR_Coverage, 7131,
     /*  649650 */     GIR_EraseRootFromParent_Done,
     /*  649651 */   // Label 10414: @649651
     /*  649651 */   GIM_Try, /*On fail goto*//*Label 10415*/ GIMT_Encode4(649726), // Rule ID 7134 //
     /*  649656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  649667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  649670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  649673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  649676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  649705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649724 */     GIR_RootConstrainSelectedInstOperands,
     /*  649725 */     // GIR_Coverage, 7134,
     /*  649725 */     GIR_EraseRootFromParent_Done,
     /*  649726 */   // Label 10415: @649726
     /*  649726 */   GIM_Try, /*On fail goto*//*Label 10416*/ GIMT_Encode4(649801), // Rule ID 7135 //
     /*  649731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  649742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  649745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  649748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  649751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649777 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  649780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649799 */     GIR_RootConstrainSelectedInstOperands,
     /*  649800 */     // GIR_Coverage, 7135,
     /*  649800 */     GIR_EraseRootFromParent_Done,
     /*  649801 */   // Label 10416: @649801
     /*  649801 */   GIM_Try, /*On fail goto*//*Label 10417*/ GIMT_Encode4(649876), // Rule ID 7138 //
     /*  649806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  649817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  649820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  649823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  649826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649852 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  649855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649874 */     GIR_RootConstrainSelectedInstOperands,
     /*  649875 */     // GIR_Coverage, 7138,
     /*  649875 */     GIR_EraseRootFromParent_Done,
     /*  649876 */   // Label 10417: @649876
     /*  649876 */   GIM_Try, /*On fail goto*//*Label 10418*/ GIMT_Encode4(649951), // Rule ID 7139 //
     /*  649881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  649892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  649895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  649898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  649901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649927 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  649930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649949 */     GIR_RootConstrainSelectedInstOperands,
     /*  649950 */     // GIR_Coverage, 7139,
     /*  649950 */     GIR_EraseRootFromParent_Done,
     /*  649951 */   // Label 10418: @649951
     /*  649951 */   GIM_Try, /*On fail goto*//*Label 10419*/ GIMT_Encode4(650026), // Rule ID 7142 //
     /*  649956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  649967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  649970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  649973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  649976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650024 */     GIR_RootConstrainSelectedInstOperands,
     /*  650025 */     // GIR_Coverage, 7142,
     /*  650025 */     GIR_EraseRootFromParent_Done,
     /*  650026 */   // Label 10419: @650026
     /*  650026 */   GIM_Try, /*On fail goto*//*Label 10420*/ GIMT_Encode4(650101), // Rule ID 7143 //
     /*  650031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  650042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  650045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  650048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  650051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650099 */     GIR_RootConstrainSelectedInstOperands,
     /*  650100 */     // GIR_Coverage, 7143,
     /*  650100 */     GIR_EraseRootFromParent_Done,
     /*  650101 */   // Label 10420: @650101
     /*  650101 */   GIM_Try, /*On fail goto*//*Label 10421*/ GIMT_Encode4(650176), // Rule ID 7146 //
     /*  650106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  650126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650174 */     GIR_RootConstrainSelectedInstOperands,
     /*  650175 */     // GIR_Coverage, 7146,
     /*  650175 */     GIR_EraseRootFromParent_Done,
     /*  650176 */   // Label 10421: @650176
     /*  650176 */   GIM_Try, /*On fail goto*//*Label 10422*/ GIMT_Encode4(650251), // Rule ID 7147 //
     /*  650181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  650192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  650195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  650198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  650201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650227 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650249 */     GIR_RootConstrainSelectedInstOperands,
     /*  650250 */     // GIR_Coverage, 7147,
     /*  650250 */     GIR_EraseRootFromParent_Done,
     /*  650251 */   // Label 10422: @650251
     /*  650251 */   GIM_Try, /*On fail goto*//*Label 10423*/ GIMT_Encode4(650326), // Rule ID 7150 //
     /*  650256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  650276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650302 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  650302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650324 */     GIR_RootConstrainSelectedInstOperands,
     /*  650325 */     // GIR_Coverage, 7150,
     /*  650325 */     GIR_EraseRootFromParent_Done,
     /*  650326 */   // Label 10423: @650326
     /*  650326 */   GIM_Try, /*On fail goto*//*Label 10424*/ GIMT_Encode4(650401), // Rule ID 7151 //
     /*  650331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  650342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  650345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  650348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  650351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  650377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  650396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650399 */     GIR_RootConstrainSelectedInstOperands,
     /*  650400 */     // GIR_Coverage, 7151,
     /*  650400 */     GIR_EraseRootFromParent_Done,
     /*  650401 */   // Label 10424: @650401
     /*  650401 */   GIM_Try, /*On fail goto*//*Label 10425*/ GIMT_Encode4(650476), // Rule ID 7154 //
     /*  650406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650474 */     GIR_RootConstrainSelectedInstOperands,
     /*  650475 */     // GIR_Coverage, 7154,
     /*  650475 */     GIR_EraseRootFromParent_Done,
     /*  650476 */   // Label 10425: @650476
     /*  650476 */   GIM_Try, /*On fail goto*//*Label 10426*/ GIMT_Encode4(650551), // Rule ID 7155 //
     /*  650481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  650492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  650495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  650498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  650501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650549 */     GIR_RootConstrainSelectedInstOperands,
     /*  650550 */     // GIR_Coverage, 7155,
     /*  650550 */     GIR_EraseRootFromParent_Done,
     /*  650551 */   // Label 10426: @650551
     /*  650551 */   GIM_Try, /*On fail goto*//*Label 10427*/ GIMT_Encode4(650626), // Rule ID 7158 //
     /*  650556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  650567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  650570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  650573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  650576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650624 */     GIR_RootConstrainSelectedInstOperands,
     /*  650625 */     // GIR_Coverage, 7158,
     /*  650625 */     GIR_EraseRootFromParent_Done,
     /*  650626 */   // Label 10427: @650626
     /*  650626 */   GIM_Try, /*On fail goto*//*Label 10428*/ GIMT_Encode4(650701), // Rule ID 7159 //
     /*  650631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  650642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  650645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  650648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  650651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650677 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650699 */     GIR_RootConstrainSelectedInstOperands,
     /*  650700 */     // GIR_Coverage, 7159,
     /*  650700 */     GIR_EraseRootFromParent_Done,
     /*  650701 */   // Label 10428: @650701
     /*  650701 */   GIM_Try, /*On fail goto*//*Label 10429*/ GIMT_Encode4(650776), // Rule ID 7162 //
     /*  650706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  650717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  650720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  650723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  650726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650774 */     GIR_RootConstrainSelectedInstOperands,
     /*  650775 */     // GIR_Coverage, 7162,
     /*  650775 */     GIR_EraseRootFromParent_Done,
     /*  650776 */   // Label 10429: @650776
     /*  650776 */   GIM_Try, /*On fail goto*//*Label 10430*/ GIMT_Encode4(650851), // Rule ID 7163 //
     /*  650781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  650792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  650795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  650798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  650801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650827 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650849 */     GIR_RootConstrainSelectedInstOperands,
     /*  650850 */     // GIR_Coverage, 7163,
     /*  650850 */     GIR_EraseRootFromParent_Done,
     /*  650851 */   // Label 10430: @650851
     /*  650851 */   GIM_Try, /*On fail goto*//*Label 10431*/ GIMT_Encode4(650926), // Rule ID 7166 //
     /*  650856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  650859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  650867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  650870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  650873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  650876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  650902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650924 */     GIR_RootConstrainSelectedInstOperands,
     /*  650925 */     // GIR_Coverage, 7166,
     /*  650925 */     GIR_EraseRootFromParent_Done,
     /*  650926 */   // Label 10431: @650926
     /*  650926 */   GIM_Try, /*On fail goto*//*Label 10432*/ GIMT_Encode4(651001), // Rule ID 7167 //
     /*  650931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  650934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  650942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  650945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  650948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  650951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  650977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650999 */     GIR_RootConstrainSelectedInstOperands,
     /*  651000 */     // GIR_Coverage, 7167,
     /*  651000 */     GIR_EraseRootFromParent_Done,
     /*  651001 */   // Label 10432: @651001
     /*  651001 */   GIM_Try, /*On fail goto*//*Label 10433*/ GIMT_Encode4(651076), // Rule ID 7170 //
     /*  651006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  651026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651074 */     GIR_RootConstrainSelectedInstOperands,
     /*  651075 */     // GIR_Coverage, 7170,
     /*  651075 */     GIR_EraseRootFromParent_Done,
     /*  651076 */   // Label 10433: @651076
     /*  651076 */   GIM_Try, /*On fail goto*//*Label 10434*/ GIMT_Encode4(651151), // Rule ID 7171 //
     /*  651081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  651092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  651095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  651098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  651101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  651120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  651130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651149 */     GIR_RootConstrainSelectedInstOperands,
     /*  651150 */     // GIR_Coverage, 7171,
     /*  651150 */     GIR_EraseRootFromParent_Done,
     /*  651151 */   // Label 10434: @651151
     /*  651151 */   GIM_Try, /*On fail goto*//*Label 10435*/ GIMT_Encode4(651226), // Rule ID 7174 //
     /*  651156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  651159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  651176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  651202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651224 */     GIR_RootConstrainSelectedInstOperands,
     /*  651225 */     // GIR_Coverage, 7174,
     /*  651225 */     GIR_EraseRootFromParent_Done,
     /*  651226 */   // Label 10435: @651226
     /*  651226 */   GIM_Try, /*On fail goto*//*Label 10436*/ GIMT_Encode4(651301), // Rule ID 7175 //
     /*  651231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  651234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  651242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  651245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  651248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  651251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  651270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651277 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  651277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  651280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  651296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651299 */     GIR_RootConstrainSelectedInstOperands,
     /*  651300 */     // GIR_Coverage, 7175,
     /*  651300 */     GIR_EraseRootFromParent_Done,
     /*  651301 */   // Label 10436: @651301
     /*  651301 */   GIM_Try, /*On fail goto*//*Label 10437*/ GIMT_Encode4(651376), // Rule ID 7178 //
     /*  651306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  651355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651374 */     GIR_RootConstrainSelectedInstOperands,
     /*  651375 */     // GIR_Coverage, 7178,
     /*  651375 */     GIR_EraseRootFromParent_Done,
     /*  651376 */   // Label 10437: @651376
     /*  651376 */   GIM_Try, /*On fail goto*//*Label 10438*/ GIMT_Encode4(651451), // Rule ID 7179 //
     /*  651381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  651392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  651395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  651398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651427 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  651430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651449 */     GIR_RootConstrainSelectedInstOperands,
     /*  651450 */     // GIR_Coverage, 7179,
     /*  651450 */     GIR_EraseRootFromParent_Done,
     /*  651451 */   // Label 10438: @651451
     /*  651451 */   GIM_Try, /*On fail goto*//*Label 10439*/ GIMT_Encode4(651526), // Rule ID 7182 //
     /*  651456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  651467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  651470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  651473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651524 */     GIR_RootConstrainSelectedInstOperands,
     /*  651525 */     // GIR_Coverage, 7182,
     /*  651525 */     GIR_EraseRootFromParent_Done,
     /*  651526 */   // Label 10439: @651526
     /*  651526 */   GIM_Try, /*On fail goto*//*Label 10440*/ GIMT_Encode4(651601), // Rule ID 7183 //
     /*  651531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  651542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  651545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  651548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651577 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651599 */     GIR_RootConstrainSelectedInstOperands,
     /*  651600 */     // GIR_Coverage, 7183,
     /*  651600 */     GIR_EraseRootFromParent_Done,
     /*  651601 */   // Label 10440: @651601
     /*  651601 */   GIM_Try, /*On fail goto*//*Label 10441*/ GIMT_Encode4(651676), // Rule ID 7186 //
     /*  651606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  651617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  651620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  651623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651652 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651674 */     GIR_RootConstrainSelectedInstOperands,
     /*  651675 */     // GIR_Coverage, 7186,
     /*  651675 */     GIR_EraseRootFromParent_Done,
     /*  651676 */   // Label 10441: @651676
     /*  651676 */   GIM_Try, /*On fail goto*//*Label 10442*/ GIMT_Encode4(651751), // Rule ID 7187 //
     /*  651681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  651692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  651695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  651698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651727 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651749 */     GIR_RootConstrainSelectedInstOperands,
     /*  651750 */     // GIR_Coverage, 7187,
     /*  651750 */     GIR_EraseRootFromParent_Done,
     /*  651751 */   // Label 10442: @651751
     /*  651751 */   GIM_Try, /*On fail goto*//*Label 10443*/ GIMT_Encode4(651826), // Rule ID 7190 //
     /*  651756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  651767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  651770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  651773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651824 */     GIR_RootConstrainSelectedInstOperands,
     /*  651825 */     // GIR_Coverage, 7190,
     /*  651825 */     GIR_EraseRootFromParent_Done,
     /*  651826 */   // Label 10443: @651826
     /*  651826 */   GIM_Try, /*On fail goto*//*Label 10444*/ GIMT_Encode4(651901), // Rule ID 7191 //
     /*  651831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  651842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  651845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  651848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  651877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651899 */     GIR_RootConstrainSelectedInstOperands,
     /*  651900 */     // GIR_Coverage, 7191,
     /*  651900 */     GIR_EraseRootFromParent_Done,
     /*  651901 */   // Label 10444: @651901
     /*  651901 */   GIM_Try, /*On fail goto*//*Label 10445*/ GIMT_Encode4(651976), // Rule ID 7194 //
     /*  651906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  651917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  651920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  651923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651952 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651974 */     GIR_RootConstrainSelectedInstOperands,
     /*  651975 */     // GIR_Coverage, 7194,
     /*  651975 */     GIR_EraseRootFromParent_Done,
     /*  651976 */   // Label 10445: @651976
     /*  651976 */   GIM_Try, /*On fail goto*//*Label 10446*/ GIMT_Encode4(652051), // Rule ID 7195 //
     /*  651981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  651992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  651995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  651998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652027 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652049 */     GIR_RootConstrainSelectedInstOperands,
     /*  652050 */     // GIR_Coverage, 7195,
     /*  652050 */     GIR_EraseRootFromParent_Done,
     /*  652051 */   // Label 10446: @652051
     /*  652051 */   GIM_Try, /*On fail goto*//*Label 10447*/ GIMT_Encode4(652126), // Rule ID 7198 //
     /*  652056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652124 */     GIR_RootConstrainSelectedInstOperands,
     /*  652125 */     // GIR_Coverage, 7198,
     /*  652125 */     GIR_EraseRootFromParent_Done,
     /*  652126 */   // Label 10447: @652126
     /*  652126 */   GIM_Try, /*On fail goto*//*Label 10448*/ GIMT_Encode4(652201), // Rule ID 7199 //
     /*  652131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  652142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  652145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  652148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652177 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  652180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652199 */     GIR_RootConstrainSelectedInstOperands,
     /*  652200 */     // GIR_Coverage, 7199,
     /*  652200 */     GIR_EraseRootFromParent_Done,
     /*  652201 */   // Label 10448: @652201
     /*  652201 */   GIM_Try, /*On fail goto*//*Label 10449*/ GIMT_Encode4(652276), // Rule ID 7202 //
     /*  652206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652274 */     GIR_RootConstrainSelectedInstOperands,
     /*  652275 */     // GIR_Coverage, 7202,
     /*  652275 */     GIR_EraseRootFromParent_Done,
     /*  652276 */   // Label 10449: @652276
     /*  652276 */   GIM_Try, /*On fail goto*//*Label 10450*/ GIMT_Encode4(652351), // Rule ID 7203 //
     /*  652281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  652292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  652295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  652298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11579:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652349 */     GIR_RootConstrainSelectedInstOperands,
     /*  652350 */     // GIR_Coverage, 7203,
     /*  652350 */     GIR_EraseRootFromParent_Done,
     /*  652351 */   // Label 10450: @652351
     /*  652351 */   GIM_Try, /*On fail goto*//*Label 10451*/ GIMT_Encode4(652426), // Rule ID 7206 //
     /*  652356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652424 */     GIR_RootConstrainSelectedInstOperands,
     /*  652425 */     // GIR_Coverage, 7206,
     /*  652425 */     GIR_EraseRootFromParent_Done,
     /*  652426 */   // Label 10451: @652426
     /*  652426 */   GIM_Try, /*On fail goto*//*Label 10452*/ GIMT_Encode4(652501), // Rule ID 7207 //
     /*  652431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  652442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  652445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  652448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652499 */     GIR_RootConstrainSelectedInstOperands,
     /*  652500 */     // GIR_Coverage, 7207,
     /*  652500 */     GIR_EraseRootFromParent_Done,
     /*  652501 */   // Label 10452: @652501
     /*  652501 */   GIM_Try, /*On fail goto*//*Label 10453*/ GIMT_Encode4(652576), // Rule ID 7210 //
     /*  652506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  652517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  652520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652574 */     GIR_RootConstrainSelectedInstOperands,
     /*  652575 */     // GIR_Coverage, 7210,
     /*  652575 */     GIR_EraseRootFromParent_Done,
     /*  652576 */   // Label 10453: @652576
     /*  652576 */   GIM_Try, /*On fail goto*//*Label 10454*/ GIMT_Encode4(652651), // Rule ID 7211 //
     /*  652581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  652592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  652595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652649 */     GIR_RootConstrainSelectedInstOperands,
     /*  652650 */     // GIR_Coverage, 7211,
     /*  652650 */     GIR_EraseRootFromParent_Done,
     /*  652651 */   // Label 10454: @652651
     /*  652651 */   GIM_Try, /*On fail goto*//*Label 10455*/ GIMT_Encode4(652726), // Rule ID 7214 //
     /*  652656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  652659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  652667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  652670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  652673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  652702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  652721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652724 */     GIR_RootConstrainSelectedInstOperands,
     /*  652725 */     // GIR_Coverage, 7214,
     /*  652725 */     GIR_EraseRootFromParent_Done,
     /*  652726 */   // Label 10455: @652726
     /*  652726 */   GIM_Try, /*On fail goto*//*Label 10456*/ GIMT_Encode4(652801), // Rule ID 7215 //
     /*  652731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  652734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  652742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  652745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  652748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652777 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  652777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  652796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652799 */     GIR_RootConstrainSelectedInstOperands,
     /*  652800 */     // GIR_Coverage, 7215,
     /*  652800 */     GIR_EraseRootFromParent_Done,
     /*  652801 */   // Label 10456: @652801
     /*  652801 */   GIM_Try, /*On fail goto*//*Label 10457*/ GIMT_Encode4(652876), // Rule ID 7218 //
     /*  652806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  652817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  652820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  652823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  652855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652874 */     GIR_RootConstrainSelectedInstOperands,
     /*  652875 */     // GIR_Coverage, 7218,
     /*  652875 */     GIR_EraseRootFromParent_Done,
     /*  652876 */   // Label 10457: @652876
     /*  652876 */   GIM_Try, /*On fail goto*//*Label 10458*/ GIMT_Encode4(652951), // Rule ID 7219 //
     /*  652881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  652892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  652895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  652898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652927 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  652930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652949 */     GIR_RootConstrainSelectedInstOperands,
     /*  652950 */     // GIR_Coverage, 7219,
     /*  652950 */     GIR_EraseRootFromParent_Done,
     /*  652951 */   // Label 10458: @652951
     /*  652951 */   GIM_Try, /*On fail goto*//*Label 10459*/ GIMT_Encode4(653026), // Rule ID 7222 //
     /*  652956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  652967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  652970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  652973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653024 */     GIR_RootConstrainSelectedInstOperands,
     /*  653025 */     // GIR_Coverage, 7222,
     /*  653025 */     GIR_EraseRootFromParent_Done,
     /*  653026 */   // Label 10459: @653026
     /*  653026 */   GIM_Try, /*On fail goto*//*Label 10460*/ GIMT_Encode4(653101), // Rule ID 7223 //
     /*  653031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  653042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  653045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  653048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653077 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653099 */     GIR_RootConstrainSelectedInstOperands,
     /*  653100 */     // GIR_Coverage, 7223,
     /*  653100 */     GIR_EraseRootFromParent_Done,
     /*  653101 */   // Label 10460: @653101
     /*  653101 */   GIM_Try, /*On fail goto*//*Label 10461*/ GIMT_Encode4(653176), // Rule ID 7226 //
     /*  653106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  653152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653174 */     GIR_RootConstrainSelectedInstOperands,
     /*  653175 */     // GIR_Coverage, 7226,
     /*  653175 */     GIR_EraseRootFromParent_Done,
     /*  653176 */   // Label 10461: @653176
     /*  653176 */   GIM_Try, /*On fail goto*//*Label 10462*/ GIMT_Encode4(653251), // Rule ID 7227 //
     /*  653181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  653192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  653195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  653198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653227 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  653227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  653246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653249 */     GIR_RootConstrainSelectedInstOperands,
     /*  653250 */     // GIR_Coverage, 7227,
     /*  653250 */     GIR_EraseRootFromParent_Done,
     /*  653251 */   // Label 10462: @653251
     /*  653251 */   GIM_Try, /*On fail goto*//*Label 10463*/ GIMT_Encode4(653326), // Rule ID 7230 //
     /*  653256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653324 */     GIR_RootConstrainSelectedInstOperands,
     /*  653325 */     // GIR_Coverage, 7230,
     /*  653325 */     GIR_EraseRootFromParent_Done,
     /*  653326 */   // Label 10463: @653326
     /*  653326 */   GIM_Try, /*On fail goto*//*Label 10464*/ GIMT_Encode4(653401), // Rule ID 7231 //
     /*  653331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  653342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  653345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  653348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653399 */     GIR_RootConstrainSelectedInstOperands,
     /*  653400 */     // GIR_Coverage, 7231,
     /*  653400 */     GIR_EraseRootFromParent_Done,
     /*  653401 */   // Label 10464: @653401
     /*  653401 */   GIM_Try, /*On fail goto*//*Label 10465*/ GIMT_Encode4(653476), // Rule ID 7234 //
     /*  653406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653474 */     GIR_RootConstrainSelectedInstOperands,
     /*  653475 */     // GIR_Coverage, 7234,
     /*  653475 */     GIR_EraseRootFromParent_Done,
     /*  653476 */   // Label 10465: @653476
     /*  653476 */   GIM_Try, /*On fail goto*//*Label 10466*/ GIMT_Encode4(653551), // Rule ID 7235 //
     /*  653481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  653492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  653495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  653498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653527 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653549 */     GIR_RootConstrainSelectedInstOperands,
     /*  653550 */     // GIR_Coverage, 7235,
     /*  653550 */     GIR_EraseRootFromParent_Done,
     /*  653551 */   // Label 10466: @653551
     /*  653551 */   GIM_Try, /*On fail goto*//*Label 10467*/ GIMT_Encode4(653626), // Rule ID 7238 //
     /*  653556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  653567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  653570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  653573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653624 */     GIR_RootConstrainSelectedInstOperands,
     /*  653625 */     // GIR_Coverage, 7238,
     /*  653625 */     GIR_EraseRootFromParent_Done,
     /*  653626 */   // Label 10467: @653626
     /*  653626 */   GIM_Try, /*On fail goto*//*Label 10468*/ GIMT_Encode4(653701), // Rule ID 7239 //
     /*  653631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  653642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  653645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  653648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653677 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653699 */     GIR_RootConstrainSelectedInstOperands,
     /*  653700 */     // GIR_Coverage, 7239,
     /*  653700 */     GIR_EraseRootFromParent_Done,
     /*  653701 */   // Label 10468: @653701
     /*  653701 */   GIM_Try, /*On fail goto*//*Label 10469*/ GIMT_Encode4(653776), // Rule ID 7242 //
     /*  653706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  653717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  653720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  653723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653774 */     GIR_RootConstrainSelectedInstOperands,
     /*  653775 */     // GIR_Coverage, 7242,
     /*  653775 */     GIR_EraseRootFromParent_Done,
     /*  653776 */   // Label 10469: @653776
     /*  653776 */   GIM_Try, /*On fail goto*//*Label 10470*/ GIMT_Encode4(653851), // Rule ID 7243 //
     /*  653781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  653792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  653795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  653798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653849 */     GIR_RootConstrainSelectedInstOperands,
     /*  653850 */     // GIR_Coverage, 7243,
     /*  653850 */     GIR_EraseRootFromParent_Done,
     /*  653851 */   // Label 10470: @653851
     /*  653851 */   GIM_Try, /*On fail goto*//*Label 10471*/ GIMT_Encode4(653926), // Rule ID 7246 //
     /*  653856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  653867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  653870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  653873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653924 */     GIR_RootConstrainSelectedInstOperands,
     /*  653925 */     // GIR_Coverage, 7246,
     /*  653925 */     GIR_EraseRootFromParent_Done,
     /*  653926 */   // Label 10471: @653926
     /*  653926 */   GIM_Try, /*On fail goto*//*Label 10472*/ GIMT_Encode4(654001), // Rule ID 7247 //
     /*  653931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  653942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  653945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  653948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653977 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653999 */     GIR_RootConstrainSelectedInstOperands,
     /*  654000 */     // GIR_Coverage, 7247,
     /*  654000 */     GIR_EraseRootFromParent_Done,
     /*  654001 */   // Label 10472: @654001
     /*  654001 */   GIM_Try, /*On fail goto*//*Label 10473*/ GIMT_Encode4(654076), // Rule ID 7250 //
     /*  654006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  654052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654074 */     GIR_RootConstrainSelectedInstOperands,
     /*  654075 */     // GIR_Coverage, 7250,
     /*  654075 */     GIR_EraseRootFromParent_Done,
     /*  654076 */   // Label 10473: @654076
     /*  654076 */   GIM_Try, /*On fail goto*//*Label 10474*/ GIMT_Encode4(654151), // Rule ID 7251 //
     /*  654081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  654092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  654095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  654098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654127 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  654127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  654146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654149 */     GIR_RootConstrainSelectedInstOperands,
     /*  654150 */     // GIR_Coverage, 7251,
     /*  654150 */     GIR_EraseRootFromParent_Done,
     /*  654151 */   // Label 10474: @654151
     /*  654151 */   GIM_Try, /*On fail goto*//*Label 10475*/ GIMT_Encode4(654226), // Rule ID 7254 //
     /*  654156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654202 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654224 */     GIR_RootConstrainSelectedInstOperands,
     /*  654225 */     // GIR_Coverage, 7254,
     /*  654225 */     GIR_EraseRootFromParent_Done,
     /*  654226 */   // Label 10475: @654226
     /*  654226 */   GIM_Try, /*On fail goto*//*Label 10476*/ GIMT_Encode4(654301), // Rule ID 7255 //
     /*  654231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  654242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  654245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  654248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  654280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654299 */     GIR_RootConstrainSelectedInstOperands,
     /*  654300 */     // GIR_Coverage, 7255,
     /*  654300 */     GIR_EraseRootFromParent_Done,
     /*  654301 */   // Label 10476: @654301
     /*  654301 */   GIM_Try, /*On fail goto*//*Label 10477*/ GIMT_Encode4(654376), // Rule ID 7258 //
     /*  654306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654374 */     GIR_RootConstrainSelectedInstOperands,
     /*  654375 */     // GIR_Coverage, 7258,
     /*  654375 */     GIR_EraseRootFromParent_Done,
     /*  654376 */   // Label 10477: @654376
     /*  654376 */   GIM_Try, /*On fail goto*//*Label 10478*/ GIMT_Encode4(654451), // Rule ID 7259 //
     /*  654381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  654392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  654395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  654398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654427 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  654430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654449 */     GIR_RootConstrainSelectedInstOperands,
     /*  654450 */     // GIR_Coverage, 7259,
     /*  654450 */     GIR_EraseRootFromParent_Done,
     /*  654451 */   // Label 10478: @654451
     /*  654451 */   GIM_Try, /*On fail goto*//*Label 10479*/ GIMT_Encode4(654526), // Rule ID 7262 //
     /*  654456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  654459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  654467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  654470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  654473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  654476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  654502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654524 */     GIR_RootConstrainSelectedInstOperands,
     /*  654525 */     // GIR_Coverage, 7262,
     /*  654525 */     GIR_EraseRootFromParent_Done,
     /*  654526 */   // Label 10479: @654526
     /*  654526 */   GIM_Try, /*On fail goto*//*Label 10480*/ GIMT_Encode4(654601), // Rule ID 7263 //
     /*  654531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  654542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  654545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  654548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654577 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654599 */     GIR_RootConstrainSelectedInstOperands,
     /*  654600 */     // GIR_Coverage, 7263,
     /*  654600 */     GIR_EraseRootFromParent_Done,
     /*  654601 */   // Label 10480: @654601
     /*  654601 */   GIM_Try, /*On fail goto*//*Label 10481*/ GIMT_Encode4(654676), // Rule ID 7442 //
     /*  654606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  654617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  654620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  654623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  654626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  654655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654674 */     GIR_RootConstrainSelectedInstOperands,
     /*  654675 */     // GIR_Coverage, 7442,
     /*  654675 */     GIR_EraseRootFromParent_Done,
     /*  654676 */   // Label 10481: @654676
     /*  654676 */   GIM_Try, /*On fail goto*//*Label 10482*/ GIMT_Encode4(654751), // Rule ID 7443 //
     /*  654681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  654692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  654695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  654698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  654701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654727 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  654730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654749 */     GIR_RootConstrainSelectedInstOperands,
     /*  654750 */     // GIR_Coverage, 7443,
     /*  654750 */     GIR_EraseRootFromParent_Done,
     /*  654751 */   // Label 10482: @654751
     /*  654751 */   GIM_Try, /*On fail goto*//*Label 10483*/ GIMT_Encode4(654826), // Rule ID 7446 //
     /*  654756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  654767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  654770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  654773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  654776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654802 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  654805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654824 */     GIR_RootConstrainSelectedInstOperands,
     /*  654825 */     // GIR_Coverage, 7446,
     /*  654825 */     GIR_EraseRootFromParent_Done,
     /*  654826 */   // Label 10483: @654826
     /*  654826 */   GIM_Try, /*On fail goto*//*Label 10484*/ GIMT_Encode4(654901), // Rule ID 7447 //
     /*  654831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  654842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  654845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  654848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  654851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654877 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  654880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654899 */     GIR_RootConstrainSelectedInstOperands,
     /*  654900 */     // GIR_Coverage, 7447,
     /*  654900 */     GIR_EraseRootFromParent_Done,
     /*  654901 */   // Label 10484: @654901
     /*  654901 */   GIM_Try, /*On fail goto*//*Label 10485*/ GIMT_Encode4(654976), // Rule ID 7450 //
     /*  654906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  654917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  654920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  654923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  654926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  654955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654974 */     GIR_RootConstrainSelectedInstOperands,
     /*  654975 */     // GIR_Coverage, 7450,
     /*  654975 */     GIR_EraseRootFromParent_Done,
     /*  654976 */   // Label 10485: @654976
     /*  654976 */   GIM_Try, /*On fail goto*//*Label 10486*/ GIMT_Encode4(655051), // Rule ID 7451 //
     /*  654981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  654992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  654995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  654998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  655001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655027 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655049 */     GIR_RootConstrainSelectedInstOperands,
     /*  655050 */     // GIR_Coverage, 7451,
     /*  655050 */     GIR_EraseRootFromParent_Done,
     /*  655051 */   // Label 10486: @655051
     /*  655051 */   GIM_Try, /*On fail goto*//*Label 10487*/ GIMT_Encode4(655126), // Rule ID 7454 //
     /*  655056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  655067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  655070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  655073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  655076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655124 */     GIR_RootConstrainSelectedInstOperands,
     /*  655125 */     // GIR_Coverage, 7454,
     /*  655125 */     GIR_EraseRootFromParent_Done,
     /*  655126 */   // Label 10487: @655126
     /*  655126 */   GIM_Try, /*On fail goto*//*Label 10488*/ GIMT_Encode4(655201), // Rule ID 7455 //
     /*  655131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  655142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  655145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  655148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  655151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655199 */     GIR_RootConstrainSelectedInstOperands,
     /*  655200 */     // GIR_Coverage, 7455,
     /*  655200 */     GIR_EraseRootFromParent_Done,
     /*  655201 */   // Label 10488: @655201
     /*  655201 */   GIM_Try, /*On fail goto*//*Label 10489*/ GIMT_Encode4(655276), // Rule ID 7458 //
     /*  655206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  655217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  655220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  655223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  655226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655274 */     GIR_RootConstrainSelectedInstOperands,
     /*  655275 */     // GIR_Coverage, 7458,
     /*  655275 */     GIR_EraseRootFromParent_Done,
     /*  655276 */   // Label 10489: @655276
     /*  655276 */   GIM_Try, /*On fail goto*//*Label 10490*/ GIMT_Encode4(655351), // Rule ID 7459 //
     /*  655281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  655292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  655295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  655298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  655301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655349 */     GIR_RootConstrainSelectedInstOperands,
     /*  655350 */     // GIR_Coverage, 7459,
     /*  655350 */     GIR_EraseRootFromParent_Done,
     /*  655351 */   // Label 10490: @655351
     /*  655351 */   GIM_Try, /*On fail goto*//*Label 10491*/ GIMT_Encode4(655426), // Rule ID 7462 //
     /*  655356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  655367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  655370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  655373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  655376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  655402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655424 */     GIR_RootConstrainSelectedInstOperands,
     /*  655425 */     // GIR_Coverage, 7462,
     /*  655425 */     GIR_EraseRootFromParent_Done,
     /*  655426 */   // Label 10491: @655426
     /*  655426 */   GIM_Try, /*On fail goto*//*Label 10492*/ GIMT_Encode4(655501), // Rule ID 7463 //
     /*  655431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  655442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  655445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  655448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  655451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655477 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  655477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  655496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655499 */     GIR_RootConstrainSelectedInstOperands,
     /*  655500 */     // GIR_Coverage, 7463,
     /*  655500 */     GIR_EraseRootFromParent_Done,
     /*  655501 */   // Label 10492: @655501
     /*  655501 */   GIM_Try, /*On fail goto*//*Label 10493*/ GIMT_Encode4(655576), // Rule ID 7466 //
     /*  655506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  655526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655574 */     GIR_RootConstrainSelectedInstOperands,
     /*  655575 */     // GIR_Coverage, 7466,
     /*  655575 */     GIR_EraseRootFromParent_Done,
     /*  655576 */   // Label 10493: @655576
     /*  655576 */   GIM_Try, /*On fail goto*//*Label 10494*/ GIMT_Encode4(655651), // Rule ID 7467 //
     /*  655581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  655601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655627 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655649 */     GIR_RootConstrainSelectedInstOperands,
     /*  655650 */     // GIR_Coverage, 7467,
     /*  655650 */     GIR_EraseRootFromParent_Done,
     /*  655651 */   // Label 10494: @655651
     /*  655651 */   GIM_Try, /*On fail goto*//*Label 10495*/ GIMT_Encode4(655726), // Rule ID 7470 //
     /*  655656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  655673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  655676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655702 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655724 */     GIR_RootConstrainSelectedInstOperands,
     /*  655725 */     // GIR_Coverage, 7470,
     /*  655725 */     GIR_EraseRootFromParent_Done,
     /*  655726 */   // Label 10495: @655726
     /*  655726 */   GIM_Try, /*On fail goto*//*Label 10496*/ GIMT_Encode4(655801), // Rule ID 7471 //
     /*  655731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  655748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  655751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655777 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655799 */     GIR_RootConstrainSelectedInstOperands,
     /*  655800 */     // GIR_Coverage, 7471,
     /*  655800 */     GIR_EraseRootFromParent_Done,
     /*  655801 */   // Label 10496: @655801
     /*  655801 */   GIM_Try, /*On fail goto*//*Label 10497*/ GIMT_Encode4(655876), // Rule ID 7474 //
     /*  655806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  655817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  655820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  655823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  655826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655874 */     GIR_RootConstrainSelectedInstOperands,
     /*  655875 */     // GIR_Coverage, 7474,
     /*  655875 */     GIR_EraseRootFromParent_Done,
     /*  655876 */   // Label 10497: @655876
     /*  655876 */   GIM_Try, /*On fail goto*//*Label 10498*/ GIMT_Encode4(655951), // Rule ID 7475 //
     /*  655881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  655892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  655895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  655898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  655901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655927 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655949 */     GIR_RootConstrainSelectedInstOperands,
     /*  655950 */     // GIR_Coverage, 7475,
     /*  655950 */     GIR_EraseRootFromParent_Done,
     /*  655951 */   // Label 10498: @655951
     /*  655951 */   GIM_Try, /*On fail goto*//*Label 10499*/ GIMT_Encode4(656026), // Rule ID 7478 //
     /*  655956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  655967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  655970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  655973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  655976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656024 */     GIR_RootConstrainSelectedInstOperands,
     /*  656025 */     // GIR_Coverage, 7478,
     /*  656025 */     GIR_EraseRootFromParent_Done,
     /*  656026 */   // Label 10499: @656026
     /*  656026 */   GIM_Try, /*On fail goto*//*Label 10500*/ GIMT_Encode4(656101), // Rule ID 7479 //
     /*  656031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  656042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  656045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  656048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  656051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656099 */     GIR_RootConstrainSelectedInstOperands,
     /*  656100 */     // GIR_Coverage, 7479,
     /*  656100 */     GIR_EraseRootFromParent_Done,
     /*  656101 */   // Label 10500: @656101
     /*  656101 */   GIM_Try, /*On fail goto*//*Label 10501*/ GIMT_Encode4(656176), // Rule ID 7482 //
     /*  656106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  656117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  656120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  656123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  656126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  656152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656174 */     GIR_RootConstrainSelectedInstOperands,
     /*  656175 */     // GIR_Coverage, 7482,
     /*  656175 */     GIR_EraseRootFromParent_Done,
     /*  656176 */   // Label 10501: @656176
     /*  656176 */   GIM_Try, /*On fail goto*//*Label 10502*/ GIMT_Encode4(656251), // Rule ID 7483 //
     /*  656181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  656192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  656195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  656198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  656201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656227 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  656227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  656246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656249 */     GIR_RootConstrainSelectedInstOperands,
     /*  656250 */     // GIR_Coverage, 7483,
     /*  656250 */     GIR_EraseRootFromParent_Done,
     /*  656251 */   // Label 10502: @656251
     /*  656251 */   GIM_Try, /*On fail goto*//*Label 10503*/ GIMT_Encode4(656326), // Rule ID 7486 //
     /*  656256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  656276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656324 */     GIR_RootConstrainSelectedInstOperands,
     /*  656325 */     // GIR_Coverage, 7486,
     /*  656325 */     GIR_EraseRootFromParent_Done,
     /*  656326 */   // Label 10503: @656326
     /*  656326 */   GIM_Try, /*On fail goto*//*Label 10504*/ GIMT_Encode4(656401), // Rule ID 7487 //
     /*  656331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  656342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  656345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  656348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  656351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656377 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  656380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656399 */     GIR_RootConstrainSelectedInstOperands,
     /*  656400 */     // GIR_Coverage, 7487,
     /*  656400 */     GIR_EraseRootFromParent_Done,
     /*  656401 */   // Label 10504: @656401
     /*  656401 */   GIM_Try, /*On fail goto*//*Label 10505*/ GIMT_Encode4(656476), // Rule ID 7490 //
     /*  656406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  656423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  656426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656474 */     GIR_RootConstrainSelectedInstOperands,
     /*  656475 */     // GIR_Coverage, 7490,
     /*  656475 */     GIR_EraseRootFromParent_Done,
     /*  656476 */   // Label 10505: @656476
     /*  656476 */   GIM_Try, /*On fail goto*//*Label 10506*/ GIMT_Encode4(656551), // Rule ID 7491 //
     /*  656481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  656492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  656495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  656498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  656501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656549 */     GIR_RootConstrainSelectedInstOperands,
     /*  656550 */     // GIR_Coverage, 7491,
     /*  656550 */     GIR_EraseRootFromParent_Done,
     /*  656551 */   // Label 10506: @656551
     /*  656551 */   GIM_Try, /*On fail goto*//*Label 10507*/ GIMT_Encode4(656626), // Rule ID 7494 //
     /*  656556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  656567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  656570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  656573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  656576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656602 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656624 */     GIR_RootConstrainSelectedInstOperands,
     /*  656625 */     // GIR_Coverage, 7494,
     /*  656625 */     GIR_EraseRootFromParent_Done,
     /*  656626 */   // Label 10507: @656626
     /*  656626 */   GIM_Try, /*On fail goto*//*Label 10508*/ GIMT_Encode4(656701), // Rule ID 7495 //
     /*  656631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  656642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  656645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  656648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  656651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656699 */     GIR_RootConstrainSelectedInstOperands,
     /*  656700 */     // GIR_Coverage, 7495,
     /*  656700 */     GIR_EraseRootFromParent_Done,
     /*  656701 */   // Label 10508: @656701
     /*  656701 */   GIM_Try, /*On fail goto*//*Label 10509*/ GIMT_Encode4(656776), // Rule ID 7498 //
     /*  656706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  656717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  656720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  656723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  656726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656752 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656774 */     GIR_RootConstrainSelectedInstOperands,
     /*  656775 */     // GIR_Coverage, 7498,
     /*  656775 */     GIR_EraseRootFromParent_Done,
     /*  656776 */   // Label 10509: @656776
     /*  656776 */   GIM_Try, /*On fail goto*//*Label 10510*/ GIMT_Encode4(656851), // Rule ID 7499 //
     /*  656781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  656792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  656795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  656798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  656801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656827 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656849 */     GIR_RootConstrainSelectedInstOperands,
     /*  656850 */     // GIR_Coverage, 7499,
     /*  656850 */     GIR_EraseRootFromParent_Done,
     /*  656851 */   // Label 10510: @656851
     /*  656851 */   GIM_Try, /*On fail goto*//*Label 10511*/ GIMT_Encode4(656926), // Rule ID 7502 //
     /*  656856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  656867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  656870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  656873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656902 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  656905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656924 */     GIR_RootConstrainSelectedInstOperands,
     /*  656925 */     // GIR_Coverage, 7502,
     /*  656925 */     GIR_EraseRootFromParent_Done,
     /*  656926 */   // Label 10511: @656926
     /*  656926 */   GIM_Try, /*On fail goto*//*Label 10512*/ GIMT_Encode4(657001), // Rule ID 7503 //
     /*  656931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  656942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  656945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  656948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656977 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  656980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656999 */     GIR_RootConstrainSelectedInstOperands,
     /*  657000 */     // GIR_Coverage, 7503,
     /*  657000 */     GIR_EraseRootFromParent_Done,
     /*  657001 */   // Label 10512: @657001
     /*  657001 */   GIM_Try, /*On fail goto*//*Label 10513*/ GIMT_Encode4(657076), // Rule ID 7506 //
     /*  657006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  657017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  657020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  657023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657052 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657074 */     GIR_RootConstrainSelectedInstOperands,
     /*  657075 */     // GIR_Coverage, 7506,
     /*  657075 */     GIR_EraseRootFromParent_Done,
     /*  657076 */   // Label 10513: @657076
     /*  657076 */   GIM_Try, /*On fail goto*//*Label 10514*/ GIMT_Encode4(657151), // Rule ID 7507 //
     /*  657081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  657092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  657095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  657098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657127 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657149 */     GIR_RootConstrainSelectedInstOperands,
     /*  657150 */     // GIR_Coverage, 7507,
     /*  657150 */     GIR_EraseRootFromParent_Done,
     /*  657151 */   // Label 10514: @657151
     /*  657151 */   GIM_Try, /*On fail goto*//*Label 10515*/ GIMT_Encode4(657226), // Rule ID 7510 //
     /*  657156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  657167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  657170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  657173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657202 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657224 */     GIR_RootConstrainSelectedInstOperands,
     /*  657225 */     // GIR_Coverage, 7510,
     /*  657225 */     GIR_EraseRootFromParent_Done,
     /*  657226 */   // Label 10515: @657226
     /*  657226 */   GIM_Try, /*On fail goto*//*Label 10516*/ GIMT_Encode4(657301), // Rule ID 7511 //
     /*  657231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  657242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  657245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  657248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657277 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657299 */     GIR_RootConstrainSelectedInstOperands,
     /*  657300 */     // GIR_Coverage, 7511,
     /*  657300 */     GIR_EraseRootFromParent_Done,
     /*  657301 */   // Label 10516: @657301
     /*  657301 */   GIM_Try, /*On fail goto*//*Label 10517*/ GIMT_Encode4(657376), // Rule ID 7514 //
     /*  657306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  657317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  657320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657374 */     GIR_RootConstrainSelectedInstOperands,
     /*  657375 */     // GIR_Coverage, 7514,
     /*  657375 */     GIR_EraseRootFromParent_Done,
     /*  657376 */   // Label 10517: @657376
     /*  657376 */   GIM_Try, /*On fail goto*//*Label 10518*/ GIMT_Encode4(657451), // Rule ID 7515 //
     /*  657381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  657392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  657395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  657398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657427 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657449 */     GIR_RootConstrainSelectedInstOperands,
     /*  657450 */     // GIR_Coverage, 7515,
     /*  657450 */     GIR_EraseRootFromParent_Done,
     /*  657451 */   // Label 10518: @657451
     /*  657451 */   GIM_Try, /*On fail goto*//*Label 10519*/ GIMT_Encode4(657526), // Rule ID 7518 //
     /*  657456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  657467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  657470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657502 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  657505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657524 */     GIR_RootConstrainSelectedInstOperands,
     /*  657525 */     // GIR_Coverage, 7518,
     /*  657525 */     GIR_EraseRootFromParent_Done,
     /*  657526 */   // Label 10519: @657526
     /*  657526 */   GIM_Try, /*On fail goto*//*Label 10520*/ GIMT_Encode4(657601), // Rule ID 7519 //
     /*  657531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  657542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  657545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  657580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657599 */     GIR_RootConstrainSelectedInstOperands,
     /*  657600 */     // GIR_Coverage, 7519,
     /*  657600 */     GIR_EraseRootFromParent_Done,
     /*  657601 */   // Label 10520: @657601
     /*  657601 */   GIM_Try, /*On fail goto*//*Label 10521*/ GIMT_Encode4(657676), // Rule ID 7522 //
     /*  657606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  657617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  657620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657652 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  657655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657674 */     GIR_RootConstrainSelectedInstOperands,
     /*  657675 */     // GIR_Coverage, 7522,
     /*  657675 */     GIR_EraseRootFromParent_Done,
     /*  657676 */   // Label 10521: @657676
     /*  657676 */   GIM_Try, /*On fail goto*//*Label 10522*/ GIMT_Encode4(657751), // Rule ID 7523 //
     /*  657681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  657692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  657695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657727 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  657730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657749 */     GIR_RootConstrainSelectedInstOperands,
     /*  657750 */     // GIR_Coverage, 7523,
     /*  657750 */     GIR_EraseRootFromParent_Done,
     /*  657751 */   // Label 10522: @657751
     /*  657751 */   GIM_Try, /*On fail goto*//*Label 10523*/ GIMT_Encode4(657826), // Rule ID 7526 //
     /*  657756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  657767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  657770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  657773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657824 */     GIR_RootConstrainSelectedInstOperands,
     /*  657825 */     // GIR_Coverage, 7526,
     /*  657825 */     GIR_EraseRootFromParent_Done,
     /*  657826 */   // Label 10523: @657826
     /*  657826 */   GIM_Try, /*On fail goto*//*Label 10524*/ GIMT_Encode4(657901), // Rule ID 7527 //
     /*  657831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  657842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  657845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  657848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657899 */     GIR_RootConstrainSelectedInstOperands,
     /*  657900 */     // GIR_Coverage, 7527,
     /*  657900 */     GIR_EraseRootFromParent_Done,
     /*  657901 */   // Label 10524: @657901
     /*  657901 */   GIM_Try, /*On fail goto*//*Label 10525*/ GIMT_Encode4(657976), // Rule ID 7530 //
     /*  657906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  657917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  657920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  657923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657952 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657974 */     GIR_RootConstrainSelectedInstOperands,
     /*  657975 */     // GIR_Coverage, 7530,
     /*  657975 */     GIR_EraseRootFromParent_Done,
     /*  657976 */   // Label 10525: @657976
     /*  657976 */   GIM_Try, /*On fail goto*//*Label 10526*/ GIMT_Encode4(658051), // Rule ID 7531 //
     /*  657981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  657992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  657995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  657998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658027 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658049 */     GIR_RootConstrainSelectedInstOperands,
     /*  658050 */     // GIR_Coverage, 7531,
     /*  658050 */     GIR_EraseRootFromParent_Done,
     /*  658051 */   // Label 10526: @658051
     /*  658051 */   GIM_Try, /*On fail goto*//*Label 10527*/ GIMT_Encode4(658126), // Rule ID 7534 //
     /*  658056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  658067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  658070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  658073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658124 */     GIR_RootConstrainSelectedInstOperands,
     /*  658125 */     // GIR_Coverage, 7534,
     /*  658125 */     GIR_EraseRootFromParent_Done,
     /*  658126 */   // Label 10527: @658126
     /*  658126 */   GIM_Try, /*On fail goto*//*Label 10528*/ GIMT_Encode4(658201), // Rule ID 7535 //
     /*  658131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  658142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  658145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  658148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658199 */     GIR_RootConstrainSelectedInstOperands,
     /*  658200 */     // GIR_Coverage, 7535,
     /*  658200 */     GIR_EraseRootFromParent_Done,
     /*  658201 */   // Label 10528: @658201
     /*  658201 */   GIM_Try, /*On fail goto*//*Label 10529*/ GIMT_Encode4(658276), // Rule ID 7538 //
     /*  658206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  658217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  658220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  658223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658274 */     GIR_RootConstrainSelectedInstOperands,
     /*  658275 */     // GIR_Coverage, 7538,
     /*  658275 */     GIR_EraseRootFromParent_Done,
     /*  658276 */   // Label 10529: @658276
     /*  658276 */   GIM_Try, /*On fail goto*//*Label 10530*/ GIMT_Encode4(658351), // Rule ID 7539 //
     /*  658281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  658292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  658295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  658298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658349 */     GIR_RootConstrainSelectedInstOperands,
     /*  658350 */     // GIR_Coverage, 7539,
     /*  658350 */     GIR_EraseRootFromParent_Done,
     /*  658351 */   // Label 10530: @658351
     /*  658351 */   GIM_Try, /*On fail goto*//*Label 10531*/ GIMT_Encode4(658426), // Rule ID 7542 //
     /*  658356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  658373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  658402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658424 */     GIR_RootConstrainSelectedInstOperands,
     /*  658425 */     // GIR_Coverage, 7542,
     /*  658425 */     GIR_EraseRootFromParent_Done,
     /*  658426 */   // Label 10531: @658426
     /*  658426 */   GIM_Try, /*On fail goto*//*Label 10532*/ GIMT_Encode4(658501), // Rule ID 7543 //
     /*  658431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  658442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  658445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  658448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658477 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  658477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  658496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658499 */     GIR_RootConstrainSelectedInstOperands,
     /*  658500 */     // GIR_Coverage, 7543,
     /*  658500 */     GIR_EraseRootFromParent_Done,
     /*  658501 */   // Label 10532: @658501
     /*  658501 */   GIM_Try, /*On fail goto*//*Label 10533*/ GIMT_Encode4(658576), // Rule ID 7546 //
     /*  658506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  658523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658552 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658574 */     GIR_RootConstrainSelectedInstOperands,
     /*  658575 */     // GIR_Coverage, 7546,
     /*  658575 */     GIR_EraseRootFromParent_Done,
     /*  658576 */   // Label 10533: @658576
     /*  658576 */   GIM_Try, /*On fail goto*//*Label 10534*/ GIMT_Encode4(658651), // Rule ID 7547 //
     /*  658581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  658598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658627 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658649 */     GIR_RootConstrainSelectedInstOperands,
     /*  658650 */     // GIR_Coverage, 7547,
     /*  658650 */     GIR_EraseRootFromParent_Done,
     /*  658651 */   // Label 10534: @658651
     /*  658651 */   GIM_Try, /*On fail goto*//*Label 10535*/ GIMT_Encode4(658726), // Rule ID 7550 //
     /*  658656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  658667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  658670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658724 */     GIR_RootConstrainSelectedInstOperands,
     /*  658725 */     // GIR_Coverage, 7550,
     /*  658725 */     GIR_EraseRootFromParent_Done,
     /*  658726 */   // Label 10535: @658726
     /*  658726 */   GIM_Try, /*On fail goto*//*Label 10536*/ GIMT_Encode4(658801), // Rule ID 7551 //
     /*  658731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  658742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  658745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658777 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658799 */     GIR_RootConstrainSelectedInstOperands,
     /*  658800 */     // GIR_Coverage, 7551,
     /*  658800 */     GIR_EraseRootFromParent_Done,
     /*  658801 */   // Label 10536: @658801
     /*  658801 */   GIM_Try, /*On fail goto*//*Label 10537*/ GIMT_Encode4(658876), // Rule ID 7554 //
     /*  658806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  658817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  658820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658874 */     GIR_RootConstrainSelectedInstOperands,
     /*  658875 */     // GIR_Coverage, 7554,
     /*  658875 */     GIR_EraseRootFromParent_Done,
     /*  658876 */   // Label 10537: @658876
     /*  658876 */   GIM_Try, /*On fail goto*//*Label 10538*/ GIMT_Encode4(658951), // Rule ID 7555 //
     /*  658881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  658892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  658895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658949 */     GIR_RootConstrainSelectedInstOperands,
     /*  658950 */     // GIR_Coverage, 7555,
     /*  658950 */     GIR_EraseRootFromParent_Done,
     /*  658951 */   // Label 10538: @658951
     /*  658951 */   GIM_Try, /*On fail goto*//*Label 10539*/ GIMT_Encode4(659026), // Rule ID 7558 //
     /*  658956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  658967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  658970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  658973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  659002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  659005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659024 */     GIR_RootConstrainSelectedInstOperands,
     /*  659025 */     // GIR_Coverage, 7558,
     /*  659025 */     GIR_EraseRootFromParent_Done,
     /*  659026 */   // Label 10539: @659026
     /*  659026 */   GIM_Try, /*On fail goto*//*Label 10540*/ GIMT_Encode4(659101), // Rule ID 7559 //
     /*  659031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  659034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  659039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  659042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  659045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  659048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  659051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  659070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659077 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  659077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  659080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  659096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659099 */     GIR_RootConstrainSelectedInstOperands,
     /*  659100 */     // GIR_Coverage, 7559,
     /*  659100 */     GIR_EraseRootFromParent_Done,
     /*  659101 */   // Label 10540: @659101
     /*  659101 */   GIM_Try, /*On fail goto*//*Label 10541*/ GIMT_Encode4(659176), // Rule ID 7622 //
     /*  659106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  659117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  659120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  659123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  659126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  659155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659174 */     GIR_RootConstrainSelectedInstOperands,
     /*  659175 */     // GIR_Coverage, 7622,
     /*  659175 */     GIR_EraseRootFromParent_Done,
     /*  659176 */   // Label 10541: @659176
     /*  659176 */   GIM_Try, /*On fail goto*//*Label 10542*/ GIMT_Encode4(659251), // Rule ID 7623 //
     /*  659181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  659192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  659195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  659198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  659201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659227 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  659230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659249 */     GIR_RootConstrainSelectedInstOperands,
     /*  659250 */     // GIR_Coverage, 7623,
     /*  659250 */     GIR_EraseRootFromParent_Done,
     /*  659251 */   // Label 10542: @659251
     /*  659251 */   GIM_Try, /*On fail goto*//*Label 10543*/ GIMT_Encode4(659326), // Rule ID 7626 //
     /*  659256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  659267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  659270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  659273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  659276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659302 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659324 */     GIR_RootConstrainSelectedInstOperands,
     /*  659325 */     // GIR_Coverage, 7626,
     /*  659325 */     GIR_EraseRootFromParent_Done,
     /*  659326 */   // Label 10543: @659326
     /*  659326 */   GIM_Try, /*On fail goto*//*Label 10544*/ GIMT_Encode4(659401), // Rule ID 7627 //
     /*  659331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  659342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  659345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  659348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  659351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659377 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659399 */     GIR_RootConstrainSelectedInstOperands,
     /*  659400 */     // GIR_Coverage, 7627,
     /*  659400 */     GIR_EraseRootFromParent_Done,
     /*  659401 */   // Label 10544: @659401
     /*  659401 */   GIM_Try, /*On fail goto*//*Label 10545*/ GIMT_Encode4(659476), // Rule ID 7630 //
     /*  659406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  659417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  659420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  659423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  659426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659474 */     GIR_RootConstrainSelectedInstOperands,
     /*  659475 */     // GIR_Coverage, 7630,
     /*  659475 */     GIR_EraseRootFromParent_Done,
     /*  659476 */   // Label 10545: @659476
     /*  659476 */   GIM_Try, /*On fail goto*//*Label 10546*/ GIMT_Encode4(659551), // Rule ID 7631 //
     /*  659481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  659492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  659495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  659498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  659501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659527 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659549 */     GIR_RootConstrainSelectedInstOperands,
     /*  659550 */     // GIR_Coverage, 7631,
     /*  659550 */     GIR_EraseRootFromParent_Done,
     /*  659551 */   // Label 10546: @659551
     /*  659551 */   GIM_Try, /*On fail goto*//*Label 10547*/ GIMT_Encode4(659626), // Rule ID 7634 //
     /*  659556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  659567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  659570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  659573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  659576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  659605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659624 */     GIR_RootConstrainSelectedInstOperands,
     /*  659625 */     // GIR_Coverage, 7634,
     /*  659625 */     GIR_EraseRootFromParent_Done,
     /*  659626 */   // Label 10547: @659626
     /*  659626 */   GIM_Try, /*On fail goto*//*Label 10548*/ GIMT_Encode4(659701), // Rule ID 7635 //
     /*  659631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  659642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  659645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  659648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  659651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  659680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659699 */     GIR_RootConstrainSelectedInstOperands,
     /*  659700 */     // GIR_Coverage, 7635,
     /*  659700 */     GIR_EraseRootFromParent_Done,
     /*  659701 */   // Label 10548: @659701
     /*  659701 */   GIM_Try, /*On fail goto*//*Label 10549*/ GIMT_Encode4(659776), // Rule ID 7638 //
     /*  659706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  659755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659774 */     GIR_RootConstrainSelectedInstOperands,
     /*  659775 */     // GIR_Coverage, 7638,
     /*  659775 */     GIR_EraseRootFromParent_Done,
     /*  659776 */   // Label 10549: @659776
     /*  659776 */   GIM_Try, /*On fail goto*//*Label 10550*/ GIMT_Encode4(659851), // Rule ID 7639 //
     /*  659781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  659830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659849 */     GIR_RootConstrainSelectedInstOperands,
     /*  659850 */     // GIR_Coverage, 7639,
     /*  659850 */     GIR_EraseRootFromParent_Done,
     /*  659851 */   // Label 10550: @659851
     /*  659851 */   GIM_Try, /*On fail goto*//*Label 10551*/ GIMT_Encode4(659926), // Rule ID 7642 //
     /*  659856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659902 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  659905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659924 */     GIR_RootConstrainSelectedInstOperands,
     /*  659925 */     // GIR_Coverage, 7642,
     /*  659925 */     GIR_EraseRootFromParent_Done,
     /*  659926 */   // Label 10551: @659926
     /*  659926 */   GIM_Try, /*On fail goto*//*Label 10552*/ GIMT_Encode4(660001), // Rule ID 7643 //
     /*  659931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659977 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  659980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659999 */     GIR_RootConstrainSelectedInstOperands,
     /*  660000 */     // GIR_Coverage, 7643,
     /*  660000 */     GIR_EraseRootFromParent_Done,
     /*  660001 */   // Label 10552: @660001
     /*  660001 */   GIM_Try, /*On fail goto*//*Label 10553*/ GIMT_Encode4(660076), // Rule ID 7646 //
     /*  660006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  660017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  660020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  660023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  660026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660052 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  660055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660074 */     GIR_RootConstrainSelectedInstOperands,
     /*  660075 */     // GIR_Coverage, 7646,
     /*  660075 */     GIR_EraseRootFromParent_Done,
     /*  660076 */   // Label 10553: @660076
     /*  660076 */   GIM_Try, /*On fail goto*//*Label 10554*/ GIMT_Encode4(660151), // Rule ID 7647 //
     /*  660081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  660092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  660095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  660098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  660101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660127 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  660130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660149 */     GIR_RootConstrainSelectedInstOperands,
     /*  660150 */     // GIR_Coverage, 7647,
     /*  660150 */     GIR_EraseRootFromParent_Done,
     /*  660151 */   // Label 10554: @660151
     /*  660151 */   GIM_Try, /*On fail goto*//*Label 10555*/ GIMT_Encode4(660226), // Rule ID 7650 //
     /*  660156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  660167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  660170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  660173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  660176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660202 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660224 */     GIR_RootConstrainSelectedInstOperands,
     /*  660225 */     // GIR_Coverage, 7650,
     /*  660225 */     GIR_EraseRootFromParent_Done,
     /*  660226 */   // Label 10555: @660226
     /*  660226 */   GIM_Try, /*On fail goto*//*Label 10556*/ GIMT_Encode4(660301), // Rule ID 7651 //
     /*  660231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  660242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  660245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  660248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  660251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660277 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660299 */     GIR_RootConstrainSelectedInstOperands,
     /*  660300 */     // GIR_Coverage, 7651,
     /*  660300 */     GIR_EraseRootFromParent_Done,
     /*  660301 */   // Label 10556: @660301
     /*  660301 */   GIM_Try, /*On fail goto*//*Label 10557*/ GIMT_Encode4(660376), // Rule ID 7654 //
     /*  660306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  660317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  660320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  660323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  660326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660374 */     GIR_RootConstrainSelectedInstOperands,
     /*  660375 */     // GIR_Coverage, 7654,
     /*  660375 */     GIR_EraseRootFromParent_Done,
     /*  660376 */   // Label 10557: @660376
     /*  660376 */   GIM_Try, /*On fail goto*//*Label 10558*/ GIMT_Encode4(660451), // Rule ID 7655 //
     /*  660381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  660392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  660395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  660398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  660401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660427 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660449 */     GIR_RootConstrainSelectedInstOperands,
     /*  660450 */     // GIR_Coverage, 7655,
     /*  660450 */     GIR_EraseRootFromParent_Done,
     /*  660451 */   // Label 10558: @660451
     /*  660451 */   GIM_Try, /*On fail goto*//*Label 10559*/ GIMT_Encode4(660526), // Rule ID 7658 //
     /*  660456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  660467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  660470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  660473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  660476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660524 */     GIR_RootConstrainSelectedInstOperands,
     /*  660525 */     // GIR_Coverage, 7658,
     /*  660525 */     GIR_EraseRootFromParent_Done,
     /*  660526 */   // Label 10559: @660526
     /*  660526 */   GIM_Try, /*On fail goto*//*Label 10560*/ GIMT_Encode4(660601), // Rule ID 7659 //
     /*  660531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  660542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  660545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  660548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  660551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660599 */     GIR_RootConstrainSelectedInstOperands,
     /*  660600 */     // GIR_Coverage, 7659,
     /*  660600 */     GIR_EraseRootFromParent_Done,
     /*  660601 */   // Label 10560: @660601
     /*  660601 */   GIM_Try, /*On fail goto*//*Label 10561*/ GIMT_Encode4(660676), // Rule ID 7662 //
     /*  660606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  660623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  660626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660652 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660674 */     GIR_RootConstrainSelectedInstOperands,
     /*  660675 */     // GIR_Coverage, 7662,
     /*  660675 */     GIR_EraseRootFromParent_Done,
     /*  660676 */   // Label 10561: @660676
     /*  660676 */   GIM_Try, /*On fail goto*//*Label 10562*/ GIMT_Encode4(660751), // Rule ID 7663 //
     /*  660681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  660698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  660701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660727 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660749 */     GIR_RootConstrainSelectedInstOperands,
     /*  660750 */     // GIR_Coverage, 7663,
     /*  660750 */     GIR_EraseRootFromParent_Done,
     /*  660751 */   // Label 10562: @660751
     /*  660751 */   GIM_Try, /*On fail goto*//*Label 10563*/ GIMT_Encode4(660826), // Rule ID 7666 //
     /*  660756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660824 */     GIR_RootConstrainSelectedInstOperands,
     /*  660825 */     // GIR_Coverage, 7666,
     /*  660825 */     GIR_EraseRootFromParent_Done,
     /*  660826 */   // Label 10563: @660826
     /*  660826 */   GIM_Try, /*On fail goto*//*Label 10564*/ GIMT_Encode4(660901), // Rule ID 7667 //
     /*  660831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660877 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660899 */     GIR_RootConstrainSelectedInstOperands,
     /*  660900 */     // GIR_Coverage, 7667,
     /*  660900 */     GIR_EraseRootFromParent_Done,
     /*  660901 */   // Label 10564: @660901
     /*  660901 */   GIM_Try, /*On fail goto*//*Label 10565*/ GIMT_Encode4(660976), // Rule ID 7670 //
     /*  660906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  660923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  660926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660974 */     GIR_RootConstrainSelectedInstOperands,
     /*  660975 */     // GIR_Coverage, 7670,
     /*  660975 */     GIR_EraseRootFromParent_Done,
     /*  660976 */   // Label 10565: @660976
     /*  660976 */   GIM_Try, /*On fail goto*//*Label 10566*/ GIMT_Encode4(661051), // Rule ID 7671 //
     /*  660981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  660998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  661001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  661030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661049 */     GIR_RootConstrainSelectedInstOperands,
     /*  661050 */     // GIR_Coverage, 7671,
     /*  661050 */     GIR_EraseRootFromParent_Done,
     /*  661051 */   // Label 10566: @661051
     /*  661051 */   GIM_Try, /*On fail goto*//*Label 10567*/ GIMT_Encode4(661126), // Rule ID 7674 //
     /*  661056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  661067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  661070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  661073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  661076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661124 */     GIR_RootConstrainSelectedInstOperands,
     /*  661125 */     // GIR_Coverage, 7674,
     /*  661125 */     GIR_EraseRootFromParent_Done,
     /*  661126 */   // Label 10567: @661126
     /*  661126 */   GIM_Try, /*On fail goto*//*Label 10568*/ GIMT_Encode4(661201), // Rule ID 7675 //
     /*  661131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  661142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  661145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  661148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  661151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661177 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  661180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661199 */     GIR_RootConstrainSelectedInstOperands,
     /*  661200 */     // GIR_Coverage, 7675,
     /*  661200 */     GIR_EraseRootFromParent_Done,
     /*  661201 */   // Label 10568: @661201
     /*  661201 */   GIM_Try, /*On fail goto*//*Label 10569*/ GIMT_Encode4(661276), // Rule ID 7678 //
     /*  661206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  661209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  661223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  661226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661252 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  661252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661274 */     GIR_RootConstrainSelectedInstOperands,
     /*  661275 */     // GIR_Coverage, 7678,
     /*  661275 */     GIR_EraseRootFromParent_Done,
     /*  661276 */   // Label 10569: @661276
     /*  661276 */   GIM_Try, /*On fail goto*//*Label 10570*/ GIMT_Encode4(661351), // Rule ID 7679 //
     /*  661281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  661284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  661292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  661295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  661298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  661301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661327 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  661327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  661330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  661346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661349 */     GIR_RootConstrainSelectedInstOperands,
     /*  661350 */     // GIR_Coverage, 7679,
     /*  661350 */     GIR_EraseRootFromParent_Done,
     /*  661351 */   // Label 10570: @661351
     /*  661351 */   GIM_Try, /*On fail goto*//*Label 10571*/ GIMT_Encode4(661426), // Rule ID 7682 //
     /*  661356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  661367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  661370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  661373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661402 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  661405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661424 */     GIR_RootConstrainSelectedInstOperands,
     /*  661425 */     // GIR_Coverage, 7682,
     /*  661425 */     GIR_EraseRootFromParent_Done,
     /*  661426 */   // Label 10571: @661426
     /*  661426 */   GIM_Try, /*On fail goto*//*Label 10572*/ GIMT_Encode4(661501), // Rule ID 7683 //
     /*  661431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  661442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  661445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  661448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661477 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  661480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661499 */     GIR_RootConstrainSelectedInstOperands,
     /*  661500 */     // GIR_Coverage, 7683,
     /*  661500 */     GIR_EraseRootFromParent_Done,
     /*  661501 */   // Label 10572: @661501
     /*  661501 */   GIM_Try, /*On fail goto*//*Label 10573*/ GIMT_Encode4(661576), // Rule ID 7686 //
     /*  661506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  661517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  661520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  661523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  661555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661574 */     GIR_RootConstrainSelectedInstOperands,
     /*  661575 */     // GIR_Coverage, 7686,
     /*  661575 */     GIR_EraseRootFromParent_Done,
     /*  661576 */   // Label 10573: @661576
     /*  661576 */   GIM_Try, /*On fail goto*//*Label 10574*/ GIMT_Encode4(661651), // Rule ID 7687 //
     /*  661581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  661592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  661595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  661598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661627 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  661630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661649 */     GIR_RootConstrainSelectedInstOperands,
     /*  661650 */     // GIR_Coverage, 7687,
     /*  661650 */     GIR_EraseRootFromParent_Done,
     /*  661651 */   // Label 10574: @661651
     /*  661651 */   GIM_Try, /*On fail goto*//*Label 10575*/ GIMT_Encode4(661726), // Rule ID 7690 //
     /*  661656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661702 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  661705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661724 */     GIR_RootConstrainSelectedInstOperands,
     /*  661725 */     // GIR_Coverage, 7690,
     /*  661725 */     GIR_EraseRootFromParent_Done,
     /*  661726 */   // Label 10575: @661726
     /*  661726 */   GIM_Try, /*On fail goto*//*Label 10576*/ GIMT_Encode4(661801), // Rule ID 7691 //
     /*  661731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661777 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  661780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661799 */     GIR_RootConstrainSelectedInstOperands,
     /*  661800 */     // GIR_Coverage, 7691,
     /*  661800 */     GIR_EraseRootFromParent_Done,
     /*  661801 */   // Label 10576: @661801
     /*  661801 */   GIM_Try, /*On fail goto*//*Label 10577*/ GIMT_Encode4(661876), // Rule ID 7694 //
     /*  661806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661852 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  661855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661874 */     GIR_RootConstrainSelectedInstOperands,
     /*  661875 */     // GIR_Coverage, 7694,
     /*  661875 */     GIR_EraseRootFromParent_Done,
     /*  661876 */   // Label 10577: @661876
     /*  661876 */   GIM_Try, /*On fail goto*//*Label 10578*/ GIMT_Encode4(661951), // Rule ID 7695 //
     /*  661881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661927 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11491:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  661930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661949 */     GIR_RootConstrainSelectedInstOperands,
     /*  661950 */     // GIR_Coverage, 7695,
     /*  661950 */     GIR_EraseRootFromParent_Done,
     /*  661951 */   // Label 10578: @661951
     /*  661951 */   GIM_Try, /*On fail goto*//*Label 10579*/ GIMT_Encode4(662026), // Rule ID 7698 //
     /*  661956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  661967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  661970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662002 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662024 */     GIR_RootConstrainSelectedInstOperands,
     /*  662025 */     // GIR_Coverage, 7698,
     /*  662025 */     GIR_EraseRootFromParent_Done,
     /*  662026 */   // Label 10579: @662026
     /*  662026 */   GIM_Try, /*On fail goto*//*Label 10580*/ GIMT_Encode4(662101), // Rule ID 7699 //
     /*  662031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  662042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  662045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  662048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662077 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662099 */     GIR_RootConstrainSelectedInstOperands,
     /*  662100 */     // GIR_Coverage, 7699,
     /*  662100 */     GIR_EraseRootFromParent_Done,
     /*  662101 */   // Label 10580: @662101
     /*  662101 */   GIM_Try, /*On fail goto*//*Label 10581*/ GIMT_Encode4(662176), // Rule ID 7702 //
     /*  662106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  662117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  662120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  662123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662152 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  662152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662174 */     GIR_RootConstrainSelectedInstOperands,
     /*  662175 */     // GIR_Coverage, 7702,
     /*  662175 */     GIR_EraseRootFromParent_Done,
     /*  662176 */   // Label 10581: @662176
     /*  662176 */   GIM_Try, /*On fail goto*//*Label 10582*/ GIMT_Encode4(662251), // Rule ID 7703 //
     /*  662181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  662192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  662195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  662198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662227 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  662227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  662246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662249 */     GIR_RootConstrainSelectedInstOperands,
     /*  662250 */     // GIR_Coverage, 7703,
     /*  662250 */     GIR_EraseRootFromParent_Done,
     /*  662251 */   // Label 10582: @662251
     /*  662251 */   GIM_Try, /*On fail goto*//*Label 10583*/ GIMT_Encode4(662326), // Rule ID 7706 //
     /*  662256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662302 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662324 */     GIR_RootConstrainSelectedInstOperands,
     /*  662325 */     // GIR_Coverage, 7706,
     /*  662325 */     GIR_EraseRootFromParent_Done,
     /*  662326 */   // Label 10583: @662326
     /*  662326 */   GIM_Try, /*On fail goto*//*Label 10584*/ GIMT_Encode4(662401), // Rule ID 7707 //
     /*  662331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  662342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  662345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  662348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662377 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  662380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662399 */     GIR_RootConstrainSelectedInstOperands,
     /*  662400 */     // GIR_Coverage, 7707,
     /*  662400 */     GIR_EraseRootFromParent_Done,
     /*  662401 */   // Label 10584: @662401
     /*  662401 */   GIM_Try, /*On fail goto*//*Label 10585*/ GIMT_Encode4(662476), // Rule ID 7710 //
     /*  662406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  662423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662474 */     GIR_RootConstrainSelectedInstOperands,
     /*  662475 */     // GIR_Coverage, 7710,
     /*  662475 */     GIR_EraseRootFromParent_Done,
     /*  662476 */   // Label 10585: @662476
     /*  662476 */   GIM_Try, /*On fail goto*//*Label 10586*/ GIMT_Encode4(662551), // Rule ID 7711 //
     /*  662481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  662492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  662495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  662498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662527 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662549 */     GIR_RootConstrainSelectedInstOperands,
     /*  662550 */     // GIR_Coverage, 7711,
     /*  662550 */     GIR_EraseRootFromParent_Done,
     /*  662551 */   // Label 10586: @662551
     /*  662551 */   GIM_Try, /*On fail goto*//*Label 10587*/ GIMT_Encode4(662626), // Rule ID 7714 //
     /*  662556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  662567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  662570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  662573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662624 */     GIR_RootConstrainSelectedInstOperands,
     /*  662625 */     // GIR_Coverage, 7714,
     /*  662625 */     GIR_EraseRootFromParent_Done,
     /*  662626 */   // Label 10587: @662626
     /*  662626 */   GIM_Try, /*On fail goto*//*Label 10588*/ GIMT_Encode4(662701), // Rule ID 7715 //
     /*  662631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  662642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  662645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  662648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11491:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662699 */     GIR_RootConstrainSelectedInstOperands,
     /*  662700 */     // GIR_Coverage, 7715,
     /*  662700 */     GIR_EraseRootFromParent_Done,
     /*  662701 */   // Label 10588: @662701
     /*  662701 */   GIM_Try, /*On fail goto*//*Label 10589*/ GIMT_Encode4(662776), // Rule ID 7718 //
     /*  662706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662774 */     GIR_RootConstrainSelectedInstOperands,
     /*  662775 */     // GIR_Coverage, 7718,
     /*  662775 */     GIR_EraseRootFromParent_Done,
     /*  662776 */   // Label 10589: @662776
     /*  662776 */   GIM_Try, /*On fail goto*//*Label 10590*/ GIMT_Encode4(662851), // Rule ID 7719 //
     /*  662781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662849 */     GIR_RootConstrainSelectedInstOperands,
     /*  662850 */     // GIR_Coverage, 7719,
     /*  662850 */     GIR_EraseRootFromParent_Done,
     /*  662851 */   // Label 10590: @662851
     /*  662851 */   GIM_Try, /*On fail goto*//*Label 10591*/ GIMT_Encode4(662926), // Rule ID 7722 //
     /*  662856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662924 */     GIR_RootConstrainSelectedInstOperands,
     /*  662925 */     // GIR_Coverage, 7722,
     /*  662925 */     GIR_EraseRootFromParent_Done,
     /*  662926 */   // Label 10591: @662926
     /*  662926 */   GIM_Try, /*On fail goto*//*Label 10592*/ GIMT_Encode4(663001), // Rule ID 7723 //
     /*  662931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662977 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662999 */     GIR_RootConstrainSelectedInstOperands,
     /*  663000 */     // GIR_Coverage, 7723,
     /*  663000 */     GIR_EraseRootFromParent_Done,
     /*  663001 */   // Label 10592: @663001
     /*  663001 */   GIM_Try, /*On fail goto*//*Label 10593*/ GIMT_Encode4(663076), // Rule ID 7726 //
     /*  663006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  663055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663074 */     GIR_RootConstrainSelectedInstOperands,
     /*  663075 */     // GIR_Coverage, 7726,
     /*  663075 */     GIR_EraseRootFromParent_Done,
     /*  663076 */   // Label 10593: @663076
     /*  663076 */   GIM_Try, /*On fail goto*//*Label 10594*/ GIMT_Encode4(663151), // Rule ID 7727 //
     /*  663081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  663098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663127 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  663130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663149 */     GIR_RootConstrainSelectedInstOperands,
     /*  663150 */     // GIR_Coverage, 7727,
     /*  663150 */     GIR_EraseRootFromParent_Done,
     /*  663151 */   // Label 10594: @663151
     /*  663151 */   GIM_Try, /*On fail goto*//*Label 10595*/ GIMT_Encode4(663226), // Rule ID 7730 //
     /*  663156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  663173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663224 */     GIR_RootConstrainSelectedInstOperands,
     /*  663225 */     // GIR_Coverage, 7730,
     /*  663225 */     GIR_EraseRootFromParent_Done,
     /*  663226 */   // Label 10595: @663226
     /*  663226 */   GIM_Try, /*On fail goto*//*Label 10596*/ GIMT_Encode4(663301), // Rule ID 7731 //
     /*  663231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  663242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  663245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  663248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663277 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  663280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663299 */     GIR_RootConstrainSelectedInstOperands,
     /*  663300 */     // GIR_Coverage, 7731,
     /*  663300 */     GIR_EraseRootFromParent_Done,
     /*  663301 */   // Label 10596: @663301
     /*  663301 */   GIM_Try, /*On fail goto*//*Label 10597*/ GIMT_Encode4(663376), // Rule ID 7734 //
     /*  663306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  663317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  663320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  663323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663374 */     GIR_RootConstrainSelectedInstOperands,
     /*  663375 */     // GIR_Coverage, 7734,
     /*  663375 */     GIR_EraseRootFromParent_Done,
     /*  663376 */   // Label 10597: @663376
     /*  663376 */   GIM_Try, /*On fail goto*//*Label 10598*/ GIMT_Encode4(663451), // Rule ID 7735 //
     /*  663381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  663392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  663395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  663398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  663412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  663430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663449 */     GIR_RootConstrainSelectedInstOperands,
     /*  663450 */     // GIR_Coverage, 7735,
     /*  663450 */     GIR_EraseRootFromParent_Done,
     /*  663451 */   // Label 10598: @663451
     /*  663451 */   GIM_Try, /*On fail goto*//*Label 10599*/ GIMT_Encode4(663526), // Rule ID 7738 //
     /*  663456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  663459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  663467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  663470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  663473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  663476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663524 */     GIR_RootConstrainSelectedInstOperands,
     /*  663525 */     // GIR_Coverage, 7738,
     /*  663525 */     GIR_EraseRootFromParent_Done,
     /*  663526 */   // Label 10599: @663526
     /*  663526 */   GIM_Try, /*On fail goto*//*Label 10600*/ GIMT_Encode4(663601), // Rule ID 7739 //
     /*  663531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  663542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  663545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  663548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663599 */     GIR_RootConstrainSelectedInstOperands,
     /*  663600 */     // GIR_Coverage, 7739,
     /*  663600 */     GIR_EraseRootFromParent_Done,
     /*  663601 */   // Label 10600: @663601
     /*  663601 */   GIM_Try, /*On fail goto*//*Label 10601*/ GIMT_Encode4(663676), // Rule ID 10254 //
     /*  663606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  663617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  663620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  663623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  663626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  663655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663674 */     GIR_RootConstrainSelectedInstOperands,
     /*  663675 */     // GIR_Coverage, 10254,
     /*  663675 */     GIR_EraseRootFromParent_Done,
     /*  663676 */   // Label 10601: @663676
     /*  663676 */   GIM_Try, /*On fail goto*//*Label 10602*/ GIMT_Encode4(663751), // Rule ID 10255 //
     /*  663681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  663692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  663695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  663698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  663701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663727 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  663730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663749 */     GIR_RootConstrainSelectedInstOperands,
     /*  663750 */     // GIR_Coverage, 10255,
     /*  663750 */     GIR_EraseRootFromParent_Done,
     /*  663751 */   // Label 10602: @663751
     /*  663751 */   GIM_Try, /*On fail goto*//*Label 10603*/ GIMT_Encode4(663826), // Rule ID 10258 //
     /*  663756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  663773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663802 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  663805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663824 */     GIR_RootConstrainSelectedInstOperands,
     /*  663825 */     // GIR_Coverage, 10258,
     /*  663825 */     GIR_EraseRootFromParent_Done,
     /*  663826 */   // Label 10603: @663826
     /*  663826 */   GIM_Try, /*On fail goto*//*Label 10604*/ GIMT_Encode4(663901), // Rule ID 10259 //
     /*  663831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  663848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663877 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  663880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663899 */     GIR_RootConstrainSelectedInstOperands,
     /*  663900 */     // GIR_Coverage, 10259,
     /*  663900 */     GIR_EraseRootFromParent_Done,
     /*  663901 */   // Label 10604: @663901
     /*  663901 */   GIM_Try, /*On fail goto*//*Label 10605*/ GIMT_Encode4(663976), // Rule ID 10262 //
     /*  663906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  663917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  663920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  663923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  663926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  663955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663974 */     GIR_RootConstrainSelectedInstOperands,
     /*  663975 */     // GIR_Coverage, 10262,
     /*  663975 */     GIR_EraseRootFromParent_Done,
     /*  663976 */   // Label 10605: @663976
     /*  663976 */   GIM_Try, /*On fail goto*//*Label 10606*/ GIMT_Encode4(664051), // Rule ID 10263 //
     /*  663981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  663992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  663995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  663998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  664001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664027 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664049 */     GIR_RootConstrainSelectedInstOperands,
     /*  664050 */     // GIR_Coverage, 10263,
     /*  664050 */     GIR_EraseRootFromParent_Done,
     /*  664051 */   // Label 10606: @664051
     /*  664051 */   GIM_Try, /*On fail goto*//*Label 10607*/ GIMT_Encode4(664126), // Rule ID 10266 //
     /*  664056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  664067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  664070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  664073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  664076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664124 */     GIR_RootConstrainSelectedInstOperands,
     /*  664125 */     // GIR_Coverage, 10266,
     /*  664125 */     GIR_EraseRootFromParent_Done,
     /*  664126 */   // Label 10607: @664126
     /*  664126 */   GIM_Try, /*On fail goto*//*Label 10608*/ GIMT_Encode4(664201), // Rule ID 10267 //
     /*  664131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  664142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  664145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  664148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  664151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  664180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664199 */     GIR_RootConstrainSelectedInstOperands,
     /*  664200 */     // GIR_Coverage, 10267,
     /*  664200 */     GIR_EraseRootFromParent_Done,
     /*  664201 */   // Label 10608: @664201
     /*  664201 */   GIM_Try, /*On fail goto*//*Label 10609*/ GIMT_Encode4(664276), // Rule ID 10270 //
     /*  664206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  664223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664274 */     GIR_RootConstrainSelectedInstOperands,
     /*  664275 */     // GIR_Coverage, 10270,
     /*  664275 */     GIR_EraseRootFromParent_Done,
     /*  664276 */   // Label 10609: @664276
     /*  664276 */   GIM_Try, /*On fail goto*//*Label 10610*/ GIMT_Encode4(664351), // Rule ID 10271 //
     /*  664281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  664292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  664295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  664298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  664301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664349 */     GIR_RootConstrainSelectedInstOperands,
     /*  664350 */     // GIR_Coverage, 10271,
     /*  664350 */     GIR_EraseRootFromParent_Done,
     /*  664351 */   // Label 10610: @664351
     /*  664351 */   GIM_Try, /*On fail goto*//*Label 10611*/ GIMT_Encode4(664426), // Rule ID 10274 //
     /*  664356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  664373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664424 */     GIR_RootConstrainSelectedInstOperands,
     /*  664425 */     // GIR_Coverage, 10274,
     /*  664425 */     GIR_EraseRootFromParent_Done,
     /*  664426 */   // Label 10611: @664426
     /*  664426 */   GIM_Try, /*On fail goto*//*Label 10612*/ GIMT_Encode4(664501), // Rule ID 10275 //
     /*  664431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  664442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  664445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  664448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  664451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664477 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  664480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664499 */     GIR_RootConstrainSelectedInstOperands,
     /*  664500 */     // GIR_Coverage, 10275,
     /*  664500 */     GIR_EraseRootFromParent_Done,
     /*  664501 */   // Label 10612: @664501
     /*  664501 */   GIM_Try, /*On fail goto*//*Label 10613*/ GIMT_Encode4(664576), // Rule ID 10278 //
     /*  664506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  664517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  664520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  664523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  664526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664574 */     GIR_RootConstrainSelectedInstOperands,
     /*  664575 */     // GIR_Coverage, 10278,
     /*  664575 */     GIR_EraseRootFromParent_Done,
     /*  664576 */   // Label 10613: @664576
     /*  664576 */   GIM_Try, /*On fail goto*//*Label 10614*/ GIMT_Encode4(664651), // Rule ID 10279 //
     /*  664581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  664592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  664595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  664598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  664601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664627 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664649 */     GIR_RootConstrainSelectedInstOperands,
     /*  664650 */     // GIR_Coverage, 10279,
     /*  664650 */     GIR_EraseRootFromParent_Done,
     /*  664651 */   // Label 10614: @664651
     /*  664651 */   GIM_Try, /*On fail goto*//*Label 10615*/ GIMT_Encode4(664726), // Rule ID 10282 //
     /*  664656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  664673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664724 */     GIR_RootConstrainSelectedInstOperands,
     /*  664725 */     // GIR_Coverage, 10282,
     /*  664725 */     GIR_EraseRootFromParent_Done,
     /*  664726 */   // Label 10615: @664726
     /*  664726 */   GIM_Try, /*On fail goto*//*Label 10616*/ GIMT_Encode4(664801), // Rule ID 10283 //
     /*  664731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  664748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664799 */     GIR_RootConstrainSelectedInstOperands,
     /*  664800 */     // GIR_Coverage, 10283,
     /*  664800 */     GIR_EraseRootFromParent_Done,
     /*  664801 */   // Label 10616: @664801
     /*  664801 */   GIM_Try, /*On fail goto*//*Label 10617*/ GIMT_Encode4(664876), // Rule ID 10286 //
     /*  664806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664874 */     GIR_RootConstrainSelectedInstOperands,
     /*  664875 */     // GIR_Coverage, 10286,
     /*  664875 */     GIR_EraseRootFromParent_Done,
     /*  664876 */   // Label 10617: @664876
     /*  664876 */   GIM_Try, /*On fail goto*//*Label 10618*/ GIMT_Encode4(664951), // Rule ID 10287 //
     /*  664881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664949 */     GIR_RootConstrainSelectedInstOperands,
     /*  664950 */     // GIR_Coverage, 10287,
     /*  664950 */     GIR_EraseRootFromParent_Done,
     /*  664951 */   // Label 10618: @664951
     /*  664951 */   GIM_Try, /*On fail goto*//*Label 10619*/ GIMT_Encode4(665026), // Rule ID 10290 //
     /*  664956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  664959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  664967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  664970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  664973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  664976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  665002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665024 */     GIR_RootConstrainSelectedInstOperands,
     /*  665025 */     // GIR_Coverage, 10290,
     /*  665025 */     GIR_EraseRootFromParent_Done,
     /*  665026 */   // Label 10619: @665026
     /*  665026 */   GIM_Try, /*On fail goto*//*Label 10620*/ GIMT_Encode4(665101), // Rule ID 10291 //
     /*  665031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  665034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  665042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  665045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  665048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  665051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  665070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665077 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  665077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  665080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  665096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665099 */     GIR_RootConstrainSelectedInstOperands,
     /*  665100 */     // GIR_Coverage, 10291,
     /*  665100 */     GIR_EraseRootFromParent_Done,
     /*  665101 */   // Label 10620: @665101
     /*  665101 */   GIM_Try, /*On fail goto*//*Label 10621*/ GIMT_Encode4(665176), // Rule ID 10294 //
     /*  665106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  665123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  665126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665174 */     GIR_RootConstrainSelectedInstOperands,
     /*  665175 */     // GIR_Coverage, 10294,
     /*  665175 */     GIR_EraseRootFromParent_Done,
     /*  665176 */   // Label 10621: @665176
     /*  665176 */   GIM_Try, /*On fail goto*//*Label 10622*/ GIMT_Encode4(665251), // Rule ID 10295 //
     /*  665181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  665192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  665195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  665198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  665201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665249 */     GIR_RootConstrainSelectedInstOperands,
     /*  665250 */     // GIR_Coverage, 10295,
     /*  665250 */     GIR_EraseRootFromParent_Done,
     /*  665251 */   // Label 10622: @665251
     /*  665251 */   GIM_Try, /*On fail goto*//*Label 10623*/ GIMT_Encode4(665326), // Rule ID 10298 //
     /*  665256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  665273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  665276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665302 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665324 */     GIR_RootConstrainSelectedInstOperands,
     /*  665325 */     // GIR_Coverage, 10298,
     /*  665325 */     GIR_EraseRootFromParent_Done,
     /*  665326 */   // Label 10623: @665326
     /*  665326 */   GIM_Try, /*On fail goto*//*Label 10624*/ GIMT_Encode4(665401), // Rule ID 10299 //
     /*  665331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  665342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  665345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  665348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  665351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665377 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665399 */     GIR_RootConstrainSelectedInstOperands,
     /*  665400 */     // GIR_Coverage, 10299,
     /*  665400 */     GIR_EraseRootFromParent_Done,
     /*  665401 */   // Label 10624: @665401
     /*  665401 */   GIM_Try, /*On fail goto*//*Label 10625*/ GIMT_Encode4(665476), // Rule ID 10302 //
     /*  665406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  665417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  665420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  665423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  665426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665452 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  665452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665474 */     GIR_RootConstrainSelectedInstOperands,
     /*  665475 */     // GIR_Coverage, 10302,
     /*  665475 */     GIR_EraseRootFromParent_Done,
     /*  665476 */   // Label 10625: @665476
     /*  665476 */   GIM_Try, /*On fail goto*//*Label 10626*/ GIMT_Encode4(665551), // Rule ID 10303 //
     /*  665481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  665492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  665495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  665498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  665501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665527 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665549 */     GIR_RootConstrainSelectedInstOperands,
     /*  665550 */     // GIR_Coverage, 10303,
     /*  665550 */     GIR_EraseRootFromParent_Done,
     /*  665551 */   // Label 10626: @665551
     /*  665551 */   GIM_Try, /*On fail goto*//*Label 10627*/ GIMT_Encode4(665626), // Rule ID 10306 //
     /*  665556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  665567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  665570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  665576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665624 */     GIR_RootConstrainSelectedInstOperands,
     /*  665625 */     // GIR_Coverage, 10306,
     /*  665625 */     GIR_EraseRootFromParent_Done,
     /*  665626 */   // Label 10627: @665626
     /*  665626 */   GIM_Try, /*On fail goto*//*Label 10628*/ GIMT_Encode4(665701), // Rule ID 10307 //
     /*  665631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  665642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  665645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  665651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665677 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665699 */     GIR_RootConstrainSelectedInstOperands,
     /*  665700 */     // GIR_Coverage, 10307,
     /*  665700 */     GIR_EraseRootFromParent_Done,
     /*  665701 */   // Label 10628: @665701
     /*  665701 */   GIM_Try, /*On fail goto*//*Label 10629*/ GIMT_Encode4(665776), // Rule ID 10310 //
     /*  665706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  665717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  665720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  665726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665752 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665774 */     GIR_RootConstrainSelectedInstOperands,
     /*  665775 */     // GIR_Coverage, 10310,
     /*  665775 */     GIR_EraseRootFromParent_Done,
     /*  665776 */   // Label 10629: @665776
     /*  665776 */   GIM_Try, /*On fail goto*//*Label 10630*/ GIMT_Encode4(665851), // Rule ID 10311 //
     /*  665781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  665792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  665795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  665801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665827 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665849 */     GIR_RootConstrainSelectedInstOperands,
     /*  665850 */     // GIR_Coverage, 10311,
     /*  665850 */     GIR_EraseRootFromParent_Done,
     /*  665851 */   // Label 10630: @665851
     /*  665851 */   GIM_Try, /*On fail goto*//*Label 10631*/ GIMT_Encode4(665926), // Rule ID 10314 //
     /*  665856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  665867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  665870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  665873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  665876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665924 */     GIR_RootConstrainSelectedInstOperands,
     /*  665925 */     // GIR_Coverage, 10314,
     /*  665925 */     GIR_EraseRootFromParent_Done,
     /*  665926 */   // Label 10631: @665926
     /*  665926 */   GIM_Try, /*On fail goto*//*Label 10632*/ GIMT_Encode4(666001), // Rule ID 10315 //
     /*  665931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  665942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  665945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  665948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  665951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665977 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665999 */     GIR_RootConstrainSelectedInstOperands,
     /*  666000 */     // GIR_Coverage, 10315,
     /*  666000 */     GIR_EraseRootFromParent_Done,
     /*  666001 */   // Label 10632: @666001
     /*  666001 */   GIM_Try, /*On fail goto*//*Label 10633*/ GIMT_Encode4(666076), // Rule ID 10318 //
     /*  666006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  666017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  666020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  666026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666074 */     GIR_RootConstrainSelectedInstOperands,
     /*  666075 */     // GIR_Coverage, 10318,
     /*  666075 */     GIR_EraseRootFromParent_Done,
     /*  666076 */   // Label 10633: @666076
     /*  666076 */   GIM_Try, /*On fail goto*//*Label 10634*/ GIMT_Encode4(666151), // Rule ID 10319 //
     /*  666081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  666092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  666095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  666098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  666101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666149 */     GIR_RootConstrainSelectedInstOperands,
     /*  666150 */     // GIR_Coverage, 10319,
     /*  666150 */     GIR_EraseRootFromParent_Done,
     /*  666151 */   // Label 10634: @666151
     /*  666151 */   GIM_Try, /*On fail goto*//*Label 10635*/ GIMT_Encode4(666226), // Rule ID 10322 //
     /*  666156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  666167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  666170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  666176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666202 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666224 */     GIR_RootConstrainSelectedInstOperands,
     /*  666225 */     // GIR_Coverage, 10322,
     /*  666225 */     GIR_EraseRootFromParent_Done,
     /*  666226 */   // Label 10635: @666226
     /*  666226 */   GIM_Try, /*On fail goto*//*Label 10636*/ GIMT_Encode4(666301), // Rule ID 10323 //
     /*  666231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  666242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  666245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  666248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  666251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666277 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666299 */     GIR_RootConstrainSelectedInstOperands,
     /*  666300 */     // GIR_Coverage, 10323,
     /*  666300 */     GIR_EraseRootFromParent_Done,
     /*  666301 */   // Label 10636: @666301
     /*  666301 */   GIM_Try, /*On fail goto*//*Label 10637*/ GIMT_Encode4(666376), // Rule ID 10326 //
     /*  666306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  666317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  666320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  666326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  666352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666374 */     GIR_RootConstrainSelectedInstOperands,
     /*  666375 */     // GIR_Coverage, 10326,
     /*  666375 */     GIR_EraseRootFromParent_Done,
     /*  666376 */   // Label 10637: @666376
     /*  666376 */   GIM_Try, /*On fail goto*//*Label 10638*/ GIMT_Encode4(666451), // Rule ID 10327 //
     /*  666381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  666392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  666395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  666398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  666401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666427 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  666427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  666446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666449 */     GIR_RootConstrainSelectedInstOperands,
     /*  666450 */     // GIR_Coverage, 10327,
     /*  666450 */     GIR_EraseRootFromParent_Done,
     /*  666451 */   // Label 10638: @666451
     /*  666451 */   GIM_Try, /*On fail goto*//*Label 10639*/ GIMT_Encode4(666526), // Rule ID 10330 //
     /*  666456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  666467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  666470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  666473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  666476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666524 */     GIR_RootConstrainSelectedInstOperands,
     /*  666525 */     // GIR_Coverage, 10330,
     /*  666525 */     GIR_EraseRootFromParent_Done,
     /*  666526 */   // Label 10639: @666526
     /*  666526 */   GIM_Try, /*On fail goto*//*Label 10640*/ GIMT_Encode4(666601), // Rule ID 10331 //
     /*  666531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  666542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  666545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  666548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  666551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666599 */     GIR_RootConstrainSelectedInstOperands,
     /*  666600 */     // GIR_Coverage, 10331,
     /*  666600 */     GIR_EraseRootFromParent_Done,
     /*  666601 */   // Label 10640: @666601
     /*  666601 */   GIM_Try, /*On fail goto*//*Label 10641*/ GIMT_Encode4(666676), // Rule ID 10334 //
     /*  666606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  666617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  666620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  666623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  666626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666674 */     GIR_RootConstrainSelectedInstOperands,
     /*  666675 */     // GIR_Coverage, 10334,
     /*  666675 */     GIR_EraseRootFromParent_Done,
     /*  666676 */   // Label 10641: @666676
     /*  666676 */   GIM_Try, /*On fail goto*//*Label 10642*/ GIMT_Encode4(666751), // Rule ID 10335 //
     /*  666681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  666692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  666695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  666698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  666701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666727 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666749 */     GIR_RootConstrainSelectedInstOperands,
     /*  666750 */     // GIR_Coverage, 10335,
     /*  666750 */     GIR_EraseRootFromParent_Done,
     /*  666751 */   // Label 10642: @666751
     /*  666751 */   GIM_Try, /*On fail goto*//*Label 10643*/ GIMT_Encode4(666826), // Rule ID 10338 //
     /*  666756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  666767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  666770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  666773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  666776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666802 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666824 */     GIR_RootConstrainSelectedInstOperands,
     /*  666825 */     // GIR_Coverage, 10338,
     /*  666825 */     GIR_EraseRootFromParent_Done,
     /*  666826 */   // Label 10643: @666826
     /*  666826 */   GIM_Try, /*On fail goto*//*Label 10644*/ GIMT_Encode4(666901), // Rule ID 10339 //
     /*  666831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  666842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  666845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  666848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  666851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666877 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666899 */     GIR_RootConstrainSelectedInstOperands,
     /*  666900 */     // GIR_Coverage, 10339,
     /*  666900 */     GIR_EraseRootFromParent_Done,
     /*  666901 */   // Label 10644: @666901
     /*  666901 */   GIM_Try, /*On fail goto*//*Label 10645*/ GIMT_Encode4(666976), // Rule ID 10342 //
     /*  666906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  666917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  666920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  666923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  666952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  666955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666974 */     GIR_RootConstrainSelectedInstOperands,
     /*  666975 */     // GIR_Coverage, 10342,
     /*  666975 */     GIR_EraseRootFromParent_Done,
     /*  666976 */   // Label 10645: @666976
     /*  666976 */   GIM_Try, /*On fail goto*//*Label 10646*/ GIMT_Encode4(667051), // Rule ID 10343 //
     /*  666981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  666992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  666995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  666998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667027 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  667030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667049 */     GIR_RootConstrainSelectedInstOperands,
     /*  667050 */     // GIR_Coverage, 10343,
     /*  667050 */     GIR_EraseRootFromParent_Done,
     /*  667051 */   // Label 10646: @667051
     /*  667051 */   GIM_Try, /*On fail goto*//*Label 10647*/ GIMT_Encode4(667126), // Rule ID 10346 //
     /*  667056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667102 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667124 */     GIR_RootConstrainSelectedInstOperands,
     /*  667125 */     // GIR_Coverage, 10346,
     /*  667125 */     GIR_EraseRootFromParent_Done,
     /*  667126 */   // Label 10647: @667126
     /*  667126 */   GIM_Try, /*On fail goto*//*Label 10648*/ GIMT_Encode4(667201), // Rule ID 10347 //
     /*  667131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  667142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  667145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  667148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667177 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667199 */     GIR_RootConstrainSelectedInstOperands,
     /*  667200 */     // GIR_Coverage, 10347,
     /*  667200 */     GIR_EraseRootFromParent_Done,
     /*  667201 */   // Label 10648: @667201
     /*  667201 */   GIM_Try, /*On fail goto*//*Label 10649*/ GIMT_Encode4(667276), // Rule ID 10350 //
     /*  667206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667252 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667274 */     GIR_RootConstrainSelectedInstOperands,
     /*  667275 */     // GIR_Coverage, 10350,
     /*  667275 */     GIR_EraseRootFromParent_Done,
     /*  667276 */   // Label 10649: @667276
     /*  667276 */   GIM_Try, /*On fail goto*//*Label 10650*/ GIMT_Encode4(667351), // Rule ID 10351 //
     /*  667281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  667292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  667295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  667298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667327 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667349 */     GIR_RootConstrainSelectedInstOperands,
     /*  667350 */     // GIR_Coverage, 10351,
     /*  667350 */     GIR_EraseRootFromParent_Done,
     /*  667351 */   // Label 10650: @667351
     /*  667351 */   GIM_Try, /*On fail goto*//*Label 10651*/ GIMT_Encode4(667426), // Rule ID 10354 //
     /*  667356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667402 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667424 */     GIR_RootConstrainSelectedInstOperands,
     /*  667425 */     // GIR_Coverage, 10354,
     /*  667425 */     GIR_EraseRootFromParent_Done,
     /*  667426 */   // Label 10651: @667426
     /*  667426 */   GIM_Try, /*On fail goto*//*Label 10652*/ GIMT_Encode4(667501), // Rule ID 10355 //
     /*  667431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  667442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  667445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  667448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667477 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  667480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667499 */     GIR_RootConstrainSelectedInstOperands,
     /*  667500 */     // GIR_Coverage, 10355,
     /*  667500 */     GIR_EraseRootFromParent_Done,
     /*  667501 */   // Label 10652: @667501
     /*  667501 */   GIM_Try, /*On fail goto*//*Label 10653*/ GIMT_Encode4(667576), // Rule ID 10358 //
     /*  667506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  667517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  667520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  667523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667574 */     GIR_RootConstrainSelectedInstOperands,
     /*  667575 */     // GIR_Coverage, 10358,
     /*  667575 */     GIR_EraseRootFromParent_Done,
     /*  667576 */   // Label 10653: @667576
     /*  667576 */   GIM_Try, /*On fail goto*//*Label 10654*/ GIMT_Encode4(667651), // Rule ID 10359 //
     /*  667581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  667592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  667595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  667598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667627 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667649 */     GIR_RootConstrainSelectedInstOperands,
     /*  667650 */     // GIR_Coverage, 10359,
     /*  667650 */     GIR_EraseRootFromParent_Done,
     /*  667651 */   // Label 10654: @667651
     /*  667651 */   GIM_Try, /*On fail goto*//*Label 10655*/ GIMT_Encode4(667726), // Rule ID 10362 //
     /*  667656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  667667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  667670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  667673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667724 */     GIR_RootConstrainSelectedInstOperands,
     /*  667725 */     // GIR_Coverage, 10362,
     /*  667725 */     GIR_EraseRootFromParent_Done,
     /*  667726 */   // Label 10655: @667726
     /*  667726 */   GIM_Try, /*On fail goto*//*Label 10656*/ GIMT_Encode4(667801), // Rule ID 10363 //
     /*  667731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  667742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  667745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  667748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667777 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667799 */     GIR_RootConstrainSelectedInstOperands,
     /*  667800 */     // GIR_Coverage, 10363,
     /*  667800 */     GIR_EraseRootFromParent_Done,
     /*  667801 */   // Label 10656: @667801
     /*  667801 */   GIM_Try, /*On fail goto*//*Label 10657*/ GIMT_Encode4(667876), // Rule ID 10366 //
     /*  667806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  667817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  667820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  667823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667852 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667874 */     GIR_RootConstrainSelectedInstOperands,
     /*  667875 */     // GIR_Coverage, 10366,
     /*  667875 */     GIR_EraseRootFromParent_Done,
     /*  667876 */   // Label 10657: @667876
     /*  667876 */   GIM_Try, /*On fail goto*//*Label 10658*/ GIMT_Encode4(667951), // Rule ID 10367 //
     /*  667881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  667892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  667895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  667898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667927 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667949 */     GIR_RootConstrainSelectedInstOperands,
     /*  667950 */     // GIR_Coverage, 10367,
     /*  667950 */     GIR_EraseRootFromParent_Done,
     /*  667951 */   // Label 10658: @667951
     /*  667951 */   GIM_Try, /*On fail goto*//*Label 10659*/ GIMT_Encode4(668026), // Rule ID 10370 //
     /*  667956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  667967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  667970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  667973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668024 */     GIR_RootConstrainSelectedInstOperands,
     /*  668025 */     // GIR_Coverage, 10370,
     /*  668025 */     GIR_EraseRootFromParent_Done,
     /*  668026 */   // Label 10659: @668026
     /*  668026 */   GIM_Try, /*On fail goto*//*Label 10660*/ GIMT_Encode4(668101), // Rule ID 10371 //
     /*  668031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  668042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  668045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  668048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668077 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668099 */     GIR_RootConstrainSelectedInstOperands,
     /*  668100 */     // GIR_Coverage, 10371,
     /*  668100 */     GIR_EraseRootFromParent_Done,
     /*  668101 */   // Label 10660: @668101
     /*  668101 */   GIM_Try, /*On fail goto*//*Label 10661*/ GIMT_Encode4(668176), // Rule ID 10374 //
     /*  668106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668174 */     GIR_RootConstrainSelectedInstOperands,
     /*  668175 */     // GIR_Coverage, 10374,
     /*  668175 */     GIR_EraseRootFromParent_Done,
     /*  668176 */   // Label 10661: @668176
     /*  668176 */   GIM_Try, /*On fail goto*//*Label 10662*/ GIMT_Encode4(668251), // Rule ID 10375 //
     /*  668181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  668192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  668195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  668198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668249 */     GIR_RootConstrainSelectedInstOperands,
     /*  668250 */     // GIR_Coverage, 10375,
     /*  668250 */     GIR_EraseRootFromParent_Done,
     /*  668251 */   // Label 10662: @668251
     /*  668251 */   GIM_Try, /*On fail goto*//*Label 10663*/ GIMT_Encode4(668326), // Rule ID 10378 //
     /*  668256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  668259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  668302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668324 */     GIR_RootConstrainSelectedInstOperands,
     /*  668325 */     // GIR_Coverage, 10378,
     /*  668325 */     GIR_EraseRootFromParent_Done,
     /*  668326 */   // Label 10663: @668326
     /*  668326 */   GIM_Try, /*On fail goto*//*Label 10664*/ GIMT_Encode4(668401), // Rule ID 10379 //
     /*  668331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  668334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  668342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  668345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  668348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  668366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668377 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  668377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  668380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  668396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668399 */     GIR_RootConstrainSelectedInstOperands,
     /*  668400 */     // GIR_Coverage, 10379,
     /*  668400 */     GIR_EraseRootFromParent_Done,
     /*  668401 */   // Label 10664: @668401
     /*  668401 */   GIM_Try, /*On fail goto*//*Label 10665*/ GIMT_Encode4(668476), // Rule ID 10382 //
     /*  668406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668474 */     GIR_RootConstrainSelectedInstOperands,
     /*  668475 */     // GIR_Coverage, 10382,
     /*  668475 */     GIR_EraseRootFromParent_Done,
     /*  668476 */   // Label 10665: @668476
     /*  668476 */   GIM_Try, /*On fail goto*//*Label 10666*/ GIMT_Encode4(668551), // Rule ID 10383 //
     /*  668481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  668492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  668495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  668498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668527 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668549 */     GIR_RootConstrainSelectedInstOperands,
     /*  668550 */     // GIR_Coverage, 10383,
     /*  668550 */     GIR_EraseRootFromParent_Done,
     /*  668551 */   // Label 10666: @668551
     /*  668551 */   GIM_Try, /*On fail goto*//*Label 10667*/ GIMT_Encode4(668626), // Rule ID 10386 //
     /*  668556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  668567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  668570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  668573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668602 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  668605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668624 */     GIR_RootConstrainSelectedInstOperands,
     /*  668625 */     // GIR_Coverage, 10386,
     /*  668625 */     GIR_EraseRootFromParent_Done,
     /*  668626 */   // Label 10667: @668626
     /*  668626 */   GIM_Try, /*On fail goto*//*Label 10668*/ GIMT_Encode4(668701), // Rule ID 10387 //
     /*  668631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  668642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  668645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  668648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668677 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  668680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668699 */     GIR_RootConstrainSelectedInstOperands,
     /*  668700 */     // GIR_Coverage, 10387,
     /*  668700 */     GIR_EraseRootFromParent_Done,
     /*  668701 */   // Label 10668: @668701
     /*  668701 */   GIM_Try, /*On fail goto*//*Label 10669*/ GIMT_Encode4(668776), // Rule ID 10390 //
     /*  668706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  668717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  668720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  668723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668752 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  668755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668774 */     GIR_RootConstrainSelectedInstOperands,
     /*  668775 */     // GIR_Coverage, 10390,
     /*  668775 */     GIR_EraseRootFromParent_Done,
     /*  668776 */   // Label 10669: @668776
     /*  668776 */   GIM_Try, /*On fail goto*//*Label 10670*/ GIMT_Encode4(668851), // Rule ID 10391 //
     /*  668781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  668792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  668795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  668798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668827 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  668830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668849 */     GIR_RootConstrainSelectedInstOperands,
     /*  668850 */     // GIR_Coverage, 10391,
     /*  668850 */     GIR_EraseRootFromParent_Done,
     /*  668851 */   // Label 10670: @668851
     /*  668851 */   GIM_Try, /*On fail goto*//*Label 10671*/ GIMT_Encode4(668926), // Rule ID 10394 //
     /*  668856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  668867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  668870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  668873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668924 */     GIR_RootConstrainSelectedInstOperands,
     /*  668925 */     // GIR_Coverage, 10394,
     /*  668925 */     GIR_EraseRootFromParent_Done,
     /*  668926 */   // Label 10671: @668926
     /*  668926 */   GIM_Try, /*On fail goto*//*Label 10672*/ GIMT_Encode4(669001), // Rule ID 10395 //
     /*  668931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  668942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  668945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  668948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668977 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668999 */     GIR_RootConstrainSelectedInstOperands,
     /*  669000 */     // GIR_Coverage, 10395,
     /*  669000 */     GIR_EraseRootFromParent_Done,
     /*  669001 */   // Label 10672: @669001
     /*  669001 */   GIM_Try, /*On fail goto*//*Label 10673*/ GIMT_Encode4(669076), // Rule ID 10398 //
     /*  669006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669074 */     GIR_RootConstrainSelectedInstOperands,
     /*  669075 */     // GIR_Coverage, 10398,
     /*  669075 */     GIR_EraseRootFromParent_Done,
     /*  669076 */   // Label 10673: @669076
     /*  669076 */   GIM_Try, /*On fail goto*//*Label 10674*/ GIMT_Encode4(669151), // Rule ID 10399 //
     /*  669081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  669092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  669095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  669098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669127 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669149 */     GIR_RootConstrainSelectedInstOperands,
     /*  669150 */     // GIR_Coverage, 10399,
     /*  669150 */     GIR_EraseRootFromParent_Done,
     /*  669151 */   // Label 10674: @669151
     /*  669151 */   GIM_Try, /*On fail goto*//*Label 10675*/ GIMT_Encode4(669226), // Rule ID 10402 //
     /*  669156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  669202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669224 */     GIR_RootConstrainSelectedInstOperands,
     /*  669225 */     // GIR_Coverage, 10402,
     /*  669225 */     GIR_EraseRootFromParent_Done,
     /*  669226 */   // Label 10675: @669226
     /*  669226 */   GIM_Try, /*On fail goto*//*Label 10676*/ GIMT_Encode4(669301), // Rule ID 10403 //
     /*  669231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  669242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  669245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  669248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669277 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  669277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  669296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669299 */     GIR_RootConstrainSelectedInstOperands,
     /*  669300 */     // GIR_Coverage, 10403,
     /*  669300 */     GIR_EraseRootFromParent_Done,
     /*  669301 */   // Label 10676: @669301
     /*  669301 */   GIM_Try, /*On fail goto*//*Label 10677*/ GIMT_Encode4(669376), // Rule ID 10406 //
     /*  669306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669374 */     GIR_RootConstrainSelectedInstOperands,
     /*  669375 */     // GIR_Coverage, 10406,
     /*  669375 */     GIR_EraseRootFromParent_Done,
     /*  669376 */   // Label 10677: @669376
     /*  669376 */   GIM_Try, /*On fail goto*//*Label 10678*/ GIMT_Encode4(669451), // Rule ID 10407 //
     /*  669381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  669392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  669395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  669398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669449 */     GIR_RootConstrainSelectedInstOperands,
     /*  669450 */     // GIR_Coverage, 10407,
     /*  669450 */     GIR_EraseRootFromParent_Done,
     /*  669451 */   // Label 10678: @669451
     /*  669451 */   GIM_Try, /*On fail goto*//*Label 10679*/ GIMT_Encode4(669526), // Rule ID 10410 //
     /*  669456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  669467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  669470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  669473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669524 */     GIR_RootConstrainSelectedInstOperands,
     /*  669525 */     // GIR_Coverage, 10410,
     /*  669525 */     GIR_EraseRootFromParent_Done,
     /*  669526 */   // Label 10679: @669526
     /*  669526 */   GIM_Try, /*On fail goto*//*Label 10680*/ GIMT_Encode4(669601), // Rule ID 10411 //
     /*  669531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  669542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  669545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  669548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669599 */     GIR_RootConstrainSelectedInstOperands,
     /*  669600 */     // GIR_Coverage, 10411,
     /*  669600 */     GIR_EraseRootFromParent_Done,
     /*  669601 */   // Label 10680: @669601
     /*  669601 */   GIM_Try, /*On fail goto*//*Label 10681*/ GIMT_Encode4(669676), // Rule ID 10414 //
     /*  669606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  669617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  669620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  669623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669674 */     GIR_RootConstrainSelectedInstOperands,
     /*  669675 */     // GIR_Coverage, 10414,
     /*  669675 */     GIR_EraseRootFromParent_Done,
     /*  669676 */   // Label 10681: @669676
     /*  669676 */   GIM_Try, /*On fail goto*//*Label 10682*/ GIMT_Encode4(669751), // Rule ID 10415 //
     /*  669681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  669692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  669695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  669698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669727 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669749 */     GIR_RootConstrainSelectedInstOperands,
     /*  669750 */     // GIR_Coverage, 10415,
     /*  669750 */     GIR_EraseRootFromParent_Done,
     /*  669751 */   // Label 10682: @669751
     /*  669751 */   GIM_Try, /*On fail goto*//*Label 10683*/ GIMT_Encode4(669826), // Rule ID 10418 //
     /*  669756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  669759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  669767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  669770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  669773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  669802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669824 */     GIR_RootConstrainSelectedInstOperands,
     /*  669825 */     // GIR_Coverage, 10418,
     /*  669825 */     GIR_EraseRootFromParent_Done,
     /*  669826 */   // Label 10683: @669826
     /*  669826 */   GIM_Try, /*On fail goto*//*Label 10684*/ GIMT_Encode4(669901), // Rule ID 10419 //
     /*  669831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  669834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  669842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  669845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  669848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669877 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11434:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  669877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669899 */     GIR_RootConstrainSelectedInstOperands,
     /*  669900 */     // GIR_Coverage, 10419,
     /*  669900 */     GIR_EraseRootFromParent_Done,
     /*  669901 */   // Label 10684: @669901
     /*  669901 */   GIM_Try, /*On fail goto*//*Label 10685*/ GIMT_Encode4(669976), // Rule ID 10422 //
     /*  669906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  669909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  669917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  669920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  669923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  669952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669974 */     GIR_RootConstrainSelectedInstOperands,
     /*  669975 */     // GIR_Coverage, 10422,
     /*  669975 */     GIR_EraseRootFromParent_Done,
     /*  669976 */   // Label 10685: @669976
     /*  669976 */   GIM_Try, /*On fail goto*//*Label 10686*/ GIMT_Encode4(670051), // Rule ID 10423 //
     /*  669981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  669984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  669992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  669995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  669998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  670016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670027 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11434:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  670030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670049 */     GIR_RootConstrainSelectedInstOperands,
     /*  670050 */     // GIR_Coverage, 10423,
     /*  670050 */     GIR_EraseRootFromParent_Done,
     /*  670051 */   // Label 10686: @670051
     /*  670051 */   GIM_Try, /*On fail goto*//*Label 10687*/ GIMT_Encode4(670126), // Rule ID 10426 //
     /*  670056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  670059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  670076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  670102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670124 */     GIR_RootConstrainSelectedInstOperands,
     /*  670125 */     // GIR_Coverage, 10426,
     /*  670125 */     GIR_EraseRootFromParent_Done,
     /*  670126 */   // Label 10687: @670126
     /*  670126 */   GIM_Try, /*On fail goto*//*Label 10688*/ GIMT_Encode4(670201), // Rule ID 10427 //
     /*  670131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  670134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  670139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  670142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  670145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  670148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  670151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  670166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  670170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670177 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11434:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  670177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  670180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  670196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670199 */     GIR_RootConstrainSelectedInstOperands,
     /*  670200 */     // GIR_Coverage, 10427,
     /*  670200 */     GIR_EraseRootFromParent_Done,
     /*  670201 */   // Label 10688: @670201
     /*  670201 */   GIM_Try, /*On fail goto*//*Label 10689*/ GIMT_Encode4(670276), // Rule ID 10430 //
     /*  670206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  670226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670252 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  670255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670274 */     GIR_RootConstrainSelectedInstOperands,
     /*  670275 */     // GIR_Coverage, 10430,
     /*  670275 */     GIR_EraseRootFromParent_Done,
     /*  670276 */   // Label 10689: @670276
     /*  670276 */   GIM_Try, /*On fail goto*//*Label 10690*/ GIMT_Encode4(670351), // Rule ID 10431 //
     /*  670281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  670292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  670295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  670298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  670301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670327 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  670330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670349 */     GIR_RootConstrainSelectedInstOperands,
     /*  670350 */     // GIR_Coverage, 10431,
     /*  670350 */     GIR_EraseRootFromParent_Done,
     /*  670351 */   // Label 10690: @670351
     /*  670351 */   GIM_Try, /*On fail goto*//*Label 10691*/ GIMT_Encode4(670426), // Rule ID 10434 //
     /*  670356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  670376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670402 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670424 */     GIR_RootConstrainSelectedInstOperands,
     /*  670425 */     // GIR_Coverage, 10434,
     /*  670425 */     GIR_EraseRootFromParent_Done,
     /*  670426 */   // Label 10691: @670426
     /*  670426 */   GIM_Try, /*On fail goto*//*Label 10692*/ GIMT_Encode4(670501), // Rule ID 10435 //
     /*  670431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  670442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  670445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  670448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  670451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670477 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670499 */     GIR_RootConstrainSelectedInstOperands,
     /*  670500 */     // GIR_Coverage, 10435,
     /*  670500 */     GIR_EraseRootFromParent_Done,
     /*  670501 */   // Label 10692: @670501
     /*  670501 */   GIM_Try, /*On fail goto*//*Label 10693*/ GIMT_Encode4(670576), // Rule ID 10438 //
     /*  670506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  670517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  670520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  670523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  670526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670574 */     GIR_RootConstrainSelectedInstOperands,
     /*  670575 */     // GIR_Coverage, 10438,
     /*  670575 */     GIR_EraseRootFromParent_Done,
     /*  670576 */   // Label 10693: @670576
     /*  670576 */   GIM_Try, /*On fail goto*//*Label 10694*/ GIMT_Encode4(670651), // Rule ID 10439 //
     /*  670581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  670592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  670595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  670598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  670601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670627 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670649 */     GIR_RootConstrainSelectedInstOperands,
     /*  670650 */     // GIR_Coverage, 10439,
     /*  670650 */     GIR_EraseRootFromParent_Done,
     /*  670651 */   // Label 10694: @670651
     /*  670651 */   GIM_Try, /*On fail goto*//*Label 10695*/ GIMT_Encode4(670726), // Rule ID 10442 //
     /*  670656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  670667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  670670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  670673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  670676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670702 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  670702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670724 */     GIR_RootConstrainSelectedInstOperands,
     /*  670725 */     // GIR_Coverage, 10442,
     /*  670725 */     GIR_EraseRootFromParent_Done,
     /*  670726 */   // Label 10695: @670726
     /*  670726 */   GIM_Try, /*On fail goto*//*Label 10696*/ GIMT_Encode4(670801), // Rule ID 10443 //
     /*  670731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  670742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  670745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  670748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  670751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670777 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  670777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670799 */     GIR_RootConstrainSelectedInstOperands,
     /*  670800 */     // GIR_Coverage, 10443,
     /*  670800 */     GIR_EraseRootFromParent_Done,
     /*  670801 */   // Label 10696: @670801
     /*  670801 */   GIM_Try, /*On fail goto*//*Label 10697*/ GIMT_Encode4(670876), // Rule ID 10446 //
     /*  670806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  670817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  670820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  670823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  670826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  670852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670874 */     GIR_RootConstrainSelectedInstOperands,
     /*  670875 */     // GIR_Coverage, 10446,
     /*  670875 */     GIR_EraseRootFromParent_Done,
     /*  670876 */   // Label 10697: @670876
     /*  670876 */   GIM_Try, /*On fail goto*//*Label 10698*/ GIMT_Encode4(670951), // Rule ID 10447 //
     /*  670881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  670892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  670895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  670898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  670901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670927 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  670927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670949 */     GIR_RootConstrainSelectedInstOperands,
     /*  670950 */     // GIR_Coverage, 10447,
     /*  670950 */     GIR_EraseRootFromParent_Done,
     /*  670951 */   // Label 10698: @670951
     /*  670951 */   GIM_Try, /*On fail goto*//*Label 10699*/ GIMT_Encode4(671026), // Rule ID 10450 //
     /*  670956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  670967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  670970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  670973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  670976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671002 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671024 */     GIR_RootConstrainSelectedInstOperands,
     /*  671025 */     // GIR_Coverage, 10450,
     /*  671025 */     GIR_EraseRootFromParent_Done,
     /*  671026 */   // Label 10699: @671026
     /*  671026 */   GIM_Try, /*On fail goto*//*Label 10700*/ GIMT_Encode4(671101), // Rule ID 10451 //
     /*  671031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  671042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  671045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  671048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  671051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671077 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  671080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671099 */     GIR_RootConstrainSelectedInstOperands,
     /*  671100 */     // GIR_Coverage, 10451,
     /*  671100 */     GIR_EraseRootFromParent_Done,
     /*  671101 */   // Label 10700: @671101
     /*  671101 */   GIM_Try, /*On fail goto*//*Label 10701*/ GIMT_Encode4(671176), // Rule ID 10454 //
     /*  671106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  671126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671174 */     GIR_RootConstrainSelectedInstOperands,
     /*  671175 */     // GIR_Coverage, 10454,
     /*  671175 */     GIR_EraseRootFromParent_Done,
     /*  671176 */   // Label 10701: @671176
     /*  671176 */   GIM_Try, /*On fail goto*//*Label 10702*/ GIMT_Encode4(671251), // Rule ID 10455 //
     /*  671181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  671192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  671195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  671198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  671201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671249 */     GIR_RootConstrainSelectedInstOperands,
     /*  671250 */     // GIR_Coverage, 10455,
     /*  671250 */     GIR_EraseRootFromParent_Done,
     /*  671251 */   // Label 10702: @671251
     /*  671251 */   GIM_Try, /*On fail goto*//*Label 10703*/ GIMT_Encode4(671326), // Rule ID 10458 //
     /*  671256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  671276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671324 */     GIR_RootConstrainSelectedInstOperands,
     /*  671325 */     // GIR_Coverage, 10458,
     /*  671325 */     GIR_EraseRootFromParent_Done,
     /*  671326 */   // Label 10703: @671326
     /*  671326 */   GIM_Try, /*On fail goto*//*Label 10704*/ GIMT_Encode4(671401), // Rule ID 10459 //
     /*  671331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  671342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  671345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  671348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  671351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671399 */     GIR_RootConstrainSelectedInstOperands,
     /*  671400 */     // GIR_Coverage, 10459,
     /*  671400 */     GIR_EraseRootFromParent_Done,
     /*  671401 */   // Label 10704: @671401
     /*  671401 */   GIM_Try, /*On fail goto*//*Label 10705*/ GIMT_Encode4(671476), // Rule ID 10462 //
     /*  671406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  671426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  671452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671474 */     GIR_RootConstrainSelectedInstOperands,
     /*  671475 */     // GIR_Coverage, 10462,
     /*  671475 */     GIR_EraseRootFromParent_Done,
     /*  671476 */   // Label 10705: @671476
     /*  671476 */   GIM_Try, /*On fail goto*//*Label 10706*/ GIMT_Encode4(671551), // Rule ID 10463 //
     /*  671481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  671492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  671495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  671498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  671501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671549 */     GIR_RootConstrainSelectedInstOperands,
     /*  671550 */     // GIR_Coverage, 10463,
     /*  671550 */     GIR_EraseRootFromParent_Done,
     /*  671551 */   // Label 10706: @671551
     /*  671551 */   GIM_Try, /*On fail goto*//*Label 10707*/ GIMT_Encode4(671626), // Rule ID 10466 //
     /*  671556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  671559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  671567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  671570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  671573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  671576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  671602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  671621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671624 */     GIR_RootConstrainSelectedInstOperands,
     /*  671625 */     // GIR_Coverage, 10466,
     /*  671625 */     GIR_EraseRootFromParent_Done,
     /*  671626 */   // Label 10707: @671626
     /*  671626 */   GIM_Try, /*On fail goto*//*Label 10708*/ GIMT_Encode4(671701), // Rule ID 10467 //
     /*  671631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  671634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  671642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  671645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  671648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  671651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  671677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  671696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671699 */     GIR_RootConstrainSelectedInstOperands,
     /*  671700 */     // GIR_Coverage, 10467,
     /*  671700 */     GIR_EraseRootFromParent_Done,
     /*  671701 */   // Label 10708: @671701
     /*  671701 */   GIM_Try, /*On fail goto*//*Label 10709*/ GIMT_Encode4(671776), // Rule ID 10470 //
     /*  671706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  671717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  671720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  671723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  671726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  671755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671774 */     GIR_RootConstrainSelectedInstOperands,
     /*  671775 */     // GIR_Coverage, 10470,
     /*  671775 */     GIR_EraseRootFromParent_Done,
     /*  671776 */   // Label 10709: @671776
     /*  671776 */   GIM_Try, /*On fail goto*//*Label 10710*/ GIMT_Encode4(671851), // Rule ID 10471 //
     /*  671781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  671792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  671795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  671798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  671801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  671830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671849 */     GIR_RootConstrainSelectedInstOperands,
     /*  671850 */     // GIR_Coverage, 10471,
     /*  671850 */     GIR_EraseRootFromParent_Done,
     /*  671851 */   // Label 10710: @671851
     /*  671851 */   GIM_Try, /*On fail goto*//*Label 10711*/ GIMT_Encode4(671926), // Rule ID 10474 //
     /*  671856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  671867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  671870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  671873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  671876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671902 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  671905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671924 */     GIR_RootConstrainSelectedInstOperands,
     /*  671925 */     // GIR_Coverage, 10474,
     /*  671925 */     GIR_EraseRootFromParent_Done,
     /*  671926 */   // Label 10711: @671926
     /*  671926 */   GIM_Try, /*On fail goto*//*Label 10712*/ GIMT_Encode4(672001), // Rule ID 10475 //
     /*  671931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  671942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  671945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  671948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  671951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671977 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  671980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671999 */     GIR_RootConstrainSelectedInstOperands,
     /*  672000 */     // GIR_Coverage, 10475,
     /*  672000 */     GIR_EraseRootFromParent_Done,
     /*  672001 */   // Label 10712: @672001
     /*  672001 */   GIM_Try, /*On fail goto*//*Label 10713*/ GIMT_Encode4(672076), // Rule ID 10478 //
     /*  672006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  672026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  672052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672074 */     GIR_RootConstrainSelectedInstOperands,
     /*  672075 */     // GIR_Coverage, 10478,
     /*  672075 */     GIR_EraseRootFromParent_Done,
     /*  672076 */   // Label 10713: @672076
     /*  672076 */   GIM_Try, /*On fail goto*//*Label 10714*/ GIMT_Encode4(672151), // Rule ID 10479 //
     /*  672081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  672092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  672095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  672098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  672101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672127 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  672127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  672146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672149 */     GIR_RootConstrainSelectedInstOperands,
     /*  672150 */     // GIR_Coverage, 10479,
     /*  672150 */     GIR_EraseRootFromParent_Done,
     /*  672151 */   // Label 10714: @672151
     /*  672151 */   GIM_Try, /*On fail goto*//*Label 10715*/ GIMT_Encode4(672226), // Rule ID 10482 //
     /*  672156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  672176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672224 */     GIR_RootConstrainSelectedInstOperands,
     /*  672225 */     // GIR_Coverage, 10482,
     /*  672225 */     GIR_EraseRootFromParent_Done,
     /*  672226 */   // Label 10715: @672226
     /*  672226 */   GIM_Try, /*On fail goto*//*Label 10716*/ GIMT_Encode4(672301), // Rule ID 10483 //
     /*  672231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  672242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  672245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  672248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  672251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672299 */     GIR_RootConstrainSelectedInstOperands,
     /*  672300 */     // GIR_Coverage, 10483,
     /*  672300 */     GIR_EraseRootFromParent_Done,
     /*  672301 */   // Label 10716: @672301
     /*  672301 */   GIM_Try, /*On fail goto*//*Label 10717*/ GIMT_Encode4(672376), // Rule ID 10486 //
     /*  672306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  672326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672374 */     GIR_RootConstrainSelectedInstOperands,
     /*  672375 */     // GIR_Coverage, 10486,
     /*  672375 */     GIR_EraseRootFromParent_Done,
     /*  672376 */   // Label 10717: @672376
     /*  672376 */   GIM_Try, /*On fail goto*//*Label 10718*/ GIMT_Encode4(672451), // Rule ID 10487 //
     /*  672381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  672392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  672395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  672398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  672401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672427 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672449 */     GIR_RootConstrainSelectedInstOperands,
     /*  672450 */     // GIR_Coverage, 10487,
     /*  672450 */     GIR_EraseRootFromParent_Done,
     /*  672451 */   // Label 10718: @672451
     /*  672451 */   GIM_Try, /*On fail goto*//*Label 10719*/ GIMT_Encode4(672526), // Rule ID 10490 //
     /*  672456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  672467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  672470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  672473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  672476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  672502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672524 */     GIR_RootConstrainSelectedInstOperands,
     /*  672525 */     // GIR_Coverage, 10490,
     /*  672525 */     GIR_EraseRootFromParent_Done,
     /*  672526 */   // Label 10719: @672526
     /*  672526 */   GIM_Try, /*On fail goto*//*Label 10720*/ GIMT_Encode4(672601), // Rule ID 10491 //
     /*  672531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  672542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  672545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  672548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  672551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672577 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672599 */     GIR_RootConstrainSelectedInstOperands,
     /*  672600 */     // GIR_Coverage, 10491,
     /*  672600 */     GIR_EraseRootFromParent_Done,
     /*  672601 */   // Label 10720: @672601
     /*  672601 */   GIM_Try, /*On fail goto*//*Label 10721*/ GIMT_Encode4(672676), // Rule ID 10494 //
     /*  672606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  672617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  672620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  672623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  672626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  672652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672674 */     GIR_RootConstrainSelectedInstOperands,
     /*  672675 */     // GIR_Coverage, 10494,
     /*  672675 */     GIR_EraseRootFromParent_Done,
     /*  672676 */   // Label 10721: @672676
     /*  672676 */   GIM_Try, /*On fail goto*//*Label 10722*/ GIMT_Encode4(672751), // Rule ID 10495 //
     /*  672681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  672692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  672695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  672698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  672701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672727 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672749 */     GIR_RootConstrainSelectedInstOperands,
     /*  672750 */     // GIR_Coverage, 10495,
     /*  672750 */     GIR_EraseRootFromParent_Done,
     /*  672751 */   // Label 10722: @672751
     /*  672751 */   GIM_Try, /*On fail goto*//*Label 10723*/ GIMT_Encode4(672826), // Rule ID 10498 //
     /*  672756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  672767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  672770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  672773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  672776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672802 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  672802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672824 */     GIR_RootConstrainSelectedInstOperands,
     /*  672825 */     // GIR_Coverage, 10498,
     /*  672825 */     GIR_EraseRootFromParent_Done,
     /*  672826 */   // Label 10723: @672826
     /*  672826 */   GIM_Try, /*On fail goto*//*Label 10724*/ GIMT_Encode4(672901), // Rule ID 10499 //
     /*  672831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  672842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  672845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  672848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  672851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672877 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672899 */     GIR_RootConstrainSelectedInstOperands,
     /*  672900 */     // GIR_Coverage, 10499,
     /*  672900 */     GIR_EraseRootFromParent_Done,
     /*  672901 */   // Label 10724: @672901
     /*  672901 */   GIM_Try, /*On fail goto*//*Label 10725*/ GIMT_Encode4(672976), // Rule ID 10502 //
     /*  672906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  672917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  672920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  672923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  672926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  672952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672974 */     GIR_RootConstrainSelectedInstOperands,
     /*  672975 */     // GIR_Coverage, 10502,
     /*  672975 */     GIR_EraseRootFromParent_Done,
     /*  672976 */   // Label 10725: @672976
     /*  672976 */   GIM_Try, /*On fail goto*//*Label 10726*/ GIMT_Encode4(673051), // Rule ID 10503 //
     /*  672981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  672992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  672995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  672998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  673001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673027 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673049 */     GIR_RootConstrainSelectedInstOperands,
     /*  673050 */     // GIR_Coverage, 10503,
     /*  673050 */     GIR_EraseRootFromParent_Done,
     /*  673051 */   // Label 10726: @673051
     /*  673051 */   GIM_Try, /*On fail goto*//*Label 10727*/ GIMT_Encode4(673126), // Rule ID 10506 //
     /*  673056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  673076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673124 */     GIR_RootConstrainSelectedInstOperands,
     /*  673125 */     // GIR_Coverage, 10506,
     /*  673125 */     GIR_EraseRootFromParent_Done,
     /*  673126 */   // Label 10727: @673126
     /*  673126 */   GIM_Try, /*On fail goto*//*Label 10728*/ GIMT_Encode4(673201), // Rule ID 10507 //
     /*  673131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  673142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  673145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  673148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  673151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  673170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  673180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673199 */     GIR_RootConstrainSelectedInstOperands,
     /*  673200 */     // GIR_Coverage, 10507,
     /*  673200 */     GIR_EraseRootFromParent_Done,
     /*  673201 */   // Label 10728: @673201
     /*  673201 */   GIM_Try, /*On fail goto*//*Label 10729*/ GIMT_Encode4(673276), // Rule ID 10510 //
     /*  673206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  673226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673274 */     GIR_RootConstrainSelectedInstOperands,
     /*  673275 */     // GIR_Coverage, 10510,
     /*  673275 */     GIR_EraseRootFromParent_Done,
     /*  673276 */   // Label 10729: @673276
     /*  673276 */   GIM_Try, /*On fail goto*//*Label 10730*/ GIMT_Encode4(673351), // Rule ID 10511 //
     /*  673281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  673292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  673295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  673298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  673301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  673320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673327 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  673330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673349 */     GIR_RootConstrainSelectedInstOperands,
     /*  673350 */     // GIR_Coverage, 10511,
     /*  673350 */     GIR_EraseRootFromParent_Done,
     /*  673351 */   // Label 10730: @673351
     /*  673351 */   GIM_Try, /*On fail goto*//*Label 10731*/ GIMT_Encode4(673426), // Rule ID 10514 //
     /*  673356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  673359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  673376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673402 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  673402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673424 */     GIR_RootConstrainSelectedInstOperands,
     /*  673425 */     // GIR_Coverage, 10514,
     /*  673425 */     GIR_EraseRootFromParent_Done,
     /*  673426 */   // Label 10731: @673426
     /*  673426 */   GIM_Try, /*On fail goto*//*Label 10732*/ GIMT_Encode4(673501), // Rule ID 10515 //
     /*  673431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  673434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  673442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  673445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  673448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  673451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  673470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673477 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  673477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  673480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  673496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673499 */     GIR_RootConstrainSelectedInstOperands,
     /*  673500 */     // GIR_Coverage, 10515,
     /*  673500 */     GIR_EraseRootFromParent_Done,
     /*  673501 */   // Label 10732: @673501
     /*  673501 */   GIM_Try, /*On fail goto*//*Label 10733*/ GIMT_Encode4(673576), // Rule ID 10518 //
     /*  673506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  673517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  673520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  673523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673552 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  673555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673574 */     GIR_RootConstrainSelectedInstOperands,
     /*  673575 */     // GIR_Coverage, 10518,
     /*  673575 */     GIR_EraseRootFromParent_Done,
     /*  673576 */   // Label 10733: @673576
     /*  673576 */   GIM_Try, /*On fail goto*//*Label 10734*/ GIMT_Encode4(673651), // Rule ID 10519 //
     /*  673581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  673592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  673595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  673598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  673630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673649 */     GIR_RootConstrainSelectedInstOperands,
     /*  673650 */     // GIR_Coverage, 10519,
     /*  673650 */     GIR_EraseRootFromParent_Done,
     /*  673651 */   // Label 10734: @673651
     /*  673651 */   GIM_Try, /*On fail goto*//*Label 10735*/ GIMT_Encode4(673726), // Rule ID 10522 //
     /*  673656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  673667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  673670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  673673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673702 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  673705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673724 */     GIR_RootConstrainSelectedInstOperands,
     /*  673725 */     // GIR_Coverage, 10522,
     /*  673725 */     GIR_EraseRootFromParent_Done,
     /*  673726 */   // Label 10735: @673726
     /*  673726 */   GIM_Try, /*On fail goto*//*Label 10736*/ GIMT_Encode4(673801), // Rule ID 10523 //
     /*  673731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  673742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  673745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  673748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673777 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  673780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673799 */     GIR_RootConstrainSelectedInstOperands,
     /*  673800 */     // GIR_Coverage, 10523,
     /*  673800 */     GIR_EraseRootFromParent_Done,
     /*  673801 */   // Label 10736: @673801
     /*  673801 */   GIM_Try, /*On fail goto*//*Label 10737*/ GIMT_Encode4(673876), // Rule ID 10526 //
     /*  673806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  673817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  673820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  673823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673852 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673874 */     GIR_RootConstrainSelectedInstOperands,
     /*  673875 */     // GIR_Coverage, 10526,
     /*  673875 */     GIR_EraseRootFromParent_Done,
     /*  673876 */   // Label 10737: @673876
     /*  673876 */   GIM_Try, /*On fail goto*//*Label 10738*/ GIMT_Encode4(673951), // Rule ID 10527 //
     /*  673881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  673892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  673895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  673898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673927 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673949 */     GIR_RootConstrainSelectedInstOperands,
     /*  673950 */     // GIR_Coverage, 10527,
     /*  673950 */     GIR_EraseRootFromParent_Done,
     /*  673951 */   // Label 10738: @673951
     /*  673951 */   GIM_Try, /*On fail goto*//*Label 10739*/ GIMT_Encode4(674026), // Rule ID 10530 //
     /*  673956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  673967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  673970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  673973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674002 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674024 */     GIR_RootConstrainSelectedInstOperands,
     /*  674025 */     // GIR_Coverage, 10530,
     /*  674025 */     GIR_EraseRootFromParent_Done,
     /*  674026 */   // Label 10739: @674026
     /*  674026 */   GIM_Try, /*On fail goto*//*Label 10740*/ GIMT_Encode4(674101), // Rule ID 10531 //
     /*  674031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  674042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  674045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  674048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674077 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  674080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674099 */     GIR_RootConstrainSelectedInstOperands,
     /*  674100 */     // GIR_Coverage, 10531,
     /*  674100 */     GIR_EraseRootFromParent_Done,
     /*  674101 */   // Label 10740: @674101
     /*  674101 */   GIM_Try, /*On fail goto*//*Label 10741*/ GIMT_Encode4(674176), // Rule ID 10534 //
     /*  674106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674152 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674174 */     GIR_RootConstrainSelectedInstOperands,
     /*  674175 */     // GIR_Coverage, 10534,
     /*  674175 */     GIR_EraseRootFromParent_Done,
     /*  674176 */   // Label 10741: @674176
     /*  674176 */   GIM_Try, /*On fail goto*//*Label 10742*/ GIMT_Encode4(674251), // Rule ID 10535 //
     /*  674181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  674192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  674195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  674198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674227 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674249 */     GIR_RootConstrainSelectedInstOperands,
     /*  674250 */     // GIR_Coverage, 10535,
     /*  674250 */     GIR_EraseRootFromParent_Done,
     /*  674251 */   // Label 10742: @674251
     /*  674251 */   GIM_Try, /*On fail goto*//*Label 10743*/ GIMT_Encode4(674326), // Rule ID 10538 //
     /*  674256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674324 */     GIR_RootConstrainSelectedInstOperands,
     /*  674325 */     // GIR_Coverage, 10538,
     /*  674325 */     GIR_EraseRootFromParent_Done,
     /*  674326 */   // Label 10743: @674326
     /*  674326 */   GIM_Try, /*On fail goto*//*Label 10744*/ GIMT_Encode4(674401), // Rule ID 10539 //
     /*  674331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  674342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  674345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  674348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674377 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  674380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674399 */     GIR_RootConstrainSelectedInstOperands,
     /*  674400 */     // GIR_Coverage, 10539,
     /*  674400 */     GIR_EraseRootFromParent_Done,
     /*  674401 */   // Label 10744: @674401
     /*  674401 */   GIM_Try, /*On fail goto*//*Label 10745*/ GIMT_Encode4(674476), // Rule ID 10542 //
     /*  674406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674474 */     GIR_RootConstrainSelectedInstOperands,
     /*  674475 */     // GIR_Coverage, 10542,
     /*  674475 */     GIR_EraseRootFromParent_Done,
     /*  674476 */   // Label 10745: @674476
     /*  674476 */   GIM_Try, /*On fail goto*//*Label 10746*/ GIMT_Encode4(674551), // Rule ID 10543 //
     /*  674481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  674492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  674495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  674498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674549 */     GIR_RootConstrainSelectedInstOperands,
     /*  674550 */     // GIR_Coverage, 10543,
     /*  674550 */     GIR_EraseRootFromParent_Done,
     /*  674551 */   // Label 10746: @674551
     /*  674551 */   GIM_Try, /*On fail goto*//*Label 10747*/ GIMT_Encode4(674626), // Rule ID 10546 //
     /*  674556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  674567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  674570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  674573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674624 */     GIR_RootConstrainSelectedInstOperands,
     /*  674625 */     // GIR_Coverage, 10546,
     /*  674625 */     GIR_EraseRootFromParent_Done,
     /*  674626 */   // Label 10747: @674626
     /*  674626 */   GIM_Try, /*On fail goto*//*Label 10748*/ GIMT_Encode4(674701), // Rule ID 10547 //
     /*  674631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  674642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  674645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  674648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674699 */     GIR_RootConstrainSelectedInstOperands,
     /*  674700 */     // GIR_Coverage, 10547,
     /*  674700 */     GIR_EraseRootFromParent_Done,
     /*  674701 */   // Label 10748: @674701
     /*  674701 */   GIM_Try, /*On fail goto*//*Label 10749*/ GIMT_Encode4(674776), // Rule ID 10550 //
     /*  674706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  674717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  674720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  674723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674774 */     GIR_RootConstrainSelectedInstOperands,
     /*  674775 */     // GIR_Coverage, 10550,
     /*  674775 */     GIR_EraseRootFromParent_Done,
     /*  674776 */   // Label 10749: @674776
     /*  674776 */   GIM_Try, /*On fail goto*//*Label 10750*/ GIMT_Encode4(674851), // Rule ID 10551 //
     /*  674781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  674792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  674795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  674798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674827 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674849 */     GIR_RootConstrainSelectedInstOperands,
     /*  674850 */     // GIR_Coverage, 10551,
     /*  674850 */     GIR_EraseRootFromParent_Done,
     /*  674851 */   // Label 10750: @674851
     /*  674851 */   GIM_Try, /*On fail goto*//*Label 10751*/ GIMT_Encode4(674926), // Rule ID 10554 //
     /*  674856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  674859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  674867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  674870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  674873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  674902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  674921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674924 */     GIR_RootConstrainSelectedInstOperands,
     /*  674925 */     // GIR_Coverage, 10554,
     /*  674925 */     GIR_EraseRootFromParent_Done,
     /*  674926 */   // Label 10751: @674926
     /*  674926 */   GIM_Try, /*On fail goto*//*Label 10752*/ GIMT_Encode4(675001), // Rule ID 10555 //
     /*  674931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  674934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  674942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  674945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  674948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674977 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  674977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  674996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674999 */     GIR_RootConstrainSelectedInstOperands,
     /*  675000 */     // GIR_Coverage, 10555,
     /*  675000 */     GIR_EraseRootFromParent_Done,
     /*  675001 */   // Label 10752: @675001
     /*  675001 */   GIM_Try, /*On fail goto*//*Label 10753*/ GIMT_Encode4(675076), // Rule ID 10558 //
     /*  675006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675074 */     GIR_RootConstrainSelectedInstOperands,
     /*  675075 */     // GIR_Coverage, 10558,
     /*  675075 */     GIR_EraseRootFromParent_Done,
     /*  675076 */   // Label 10753: @675076
     /*  675076 */   GIM_Try, /*On fail goto*//*Label 10754*/ GIMT_Encode4(675151), // Rule ID 10559 //
     /*  675081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  675092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  675095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  675098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675149 */     GIR_RootConstrainSelectedInstOperands,
     /*  675150 */     // GIR_Coverage, 10559,
     /*  675150 */     GIR_EraseRootFromParent_Done,
     /*  675151 */   // Label 10754: @675151
     /*  675151 */   GIM_Try, /*On fail goto*//*Label 10755*/ GIMT_Encode4(675226), // Rule ID 10562 //
     /*  675156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675202 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675224 */     GIR_RootConstrainSelectedInstOperands,
     /*  675225 */     // GIR_Coverage, 10562,
     /*  675225 */     GIR_EraseRootFromParent_Done,
     /*  675226 */   // Label 10755: @675226
     /*  675226 */   GIM_Try, /*On fail goto*//*Label 10756*/ GIMT_Encode4(675301), // Rule ID 10563 //
     /*  675231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  675242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  675245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  675248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675277 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675299 */     GIR_RootConstrainSelectedInstOperands,
     /*  675300 */     // GIR_Coverage, 10563,
     /*  675300 */     GIR_EraseRootFromParent_Done,
     /*  675301 */   // Label 10756: @675301
     /*  675301 */   GIM_Try, /*On fail goto*//*Label 10757*/ GIMT_Encode4(675376), // Rule ID 10566 //
     /*  675306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675352 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  675352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675374 */     GIR_RootConstrainSelectedInstOperands,
     /*  675375 */     // GIR_Coverage, 10566,
     /*  675375 */     GIR_EraseRootFromParent_Done,
     /*  675376 */   // Label 10757: @675376
     /*  675376 */   GIM_Try, /*On fail goto*//*Label 10758*/ GIMT_Encode4(675451), // Rule ID 10567 //
     /*  675381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  675392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  675395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  675398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675427 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  675427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  675446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675449 */     GIR_RootConstrainSelectedInstOperands,
     /*  675450 */     // GIR_Coverage, 10567,
     /*  675450 */     GIR_EraseRootFromParent_Done,
     /*  675451 */   // Label 10758: @675451
     /*  675451 */   GIM_Try, /*On fail goto*//*Label 10759*/ GIMT_Encode4(675526), // Rule ID 10570 //
     /*  675456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  675467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  675470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  675473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675524 */     GIR_RootConstrainSelectedInstOperands,
     /*  675525 */     // GIR_Coverage, 10570,
     /*  675525 */     GIR_EraseRootFromParent_Done,
     /*  675526 */   // Label 10759: @675526
     /*  675526 */   GIM_Try, /*On fail goto*//*Label 10760*/ GIMT_Encode4(675601), // Rule ID 10571 //
     /*  675531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  675542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  675545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  675548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675599 */     GIR_RootConstrainSelectedInstOperands,
     /*  675600 */     // GIR_Coverage, 10571,
     /*  675600 */     GIR_EraseRootFromParent_Done,
     /*  675601 */   // Label 10760: @675601
     /*  675601 */   GIM_Try, /*On fail goto*//*Label 10761*/ GIMT_Encode4(675676), // Rule ID 10574 //
     /*  675606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  675617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  675620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  675623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675652 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675674 */     GIR_RootConstrainSelectedInstOperands,
     /*  675675 */     // GIR_Coverage, 10574,
     /*  675675 */     GIR_EraseRootFromParent_Done,
     /*  675676 */   // Label 10761: @675676
     /*  675676 */   GIM_Try, /*On fail goto*//*Label 10762*/ GIMT_Encode4(675751), // Rule ID 10575 //
     /*  675681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  675692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  675695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  675698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675727 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675749 */     GIR_RootConstrainSelectedInstOperands,
     /*  675750 */     // GIR_Coverage, 10575,
     /*  675750 */     GIR_EraseRootFromParent_Done,
     /*  675751 */   // Label 10762: @675751
     /*  675751 */   GIM_Try, /*On fail goto*//*Label 10763*/ GIMT_Encode4(675826), // Rule ID 10578 //
     /*  675756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  675767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  675770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  675773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675824 */     GIR_RootConstrainSelectedInstOperands,
     /*  675825 */     // GIR_Coverage, 10578,
     /*  675825 */     GIR_EraseRootFromParent_Done,
     /*  675826 */   // Label 10763: @675826
     /*  675826 */   GIM_Try, /*On fail goto*//*Label 10764*/ GIMT_Encode4(675901), // Rule ID 10579 //
     /*  675831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  675842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  675845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  675848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675877 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675899 */     GIR_RootConstrainSelectedInstOperands,
     /*  675900 */     // GIR_Coverage, 10579,
     /*  675900 */     GIR_EraseRootFromParent_Done,
     /*  675901 */   // Label 10764: @675901
     /*  675901 */   GIM_Try, /*On fail goto*//*Label 10765*/ GIMT_Encode4(675976), // Rule ID 10582 //
     /*  675906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  675917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  675920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  675923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675974 */     GIR_RootConstrainSelectedInstOperands,
     /*  675975 */     // GIR_Coverage, 10582,
     /*  675975 */     GIR_EraseRootFromParent_Done,
     /*  675976 */   // Label 10765: @675976
     /*  675976 */   GIM_Try, /*On fail goto*//*Label 10766*/ GIMT_Encode4(676051), // Rule ID 10583 //
     /*  675981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  675992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  675995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  675998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676027 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676049 */     GIR_RootConstrainSelectedInstOperands,
     /*  676050 */     // GIR_Coverage, 10583,
     /*  676050 */     GIR_EraseRootFromParent_Done,
     /*  676051 */   // Label 10766: @676051
     /*  676051 */   GIM_Try, /*On fail goto*//*Label 10767*/ GIMT_Encode4(676126), // Rule ID 10586 //
     /*  676056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676124 */     GIR_RootConstrainSelectedInstOperands,
     /*  676125 */     // GIR_Coverage, 10586,
     /*  676125 */     GIR_EraseRootFromParent_Done,
     /*  676126 */   // Label 10767: @676126
     /*  676126 */   GIM_Try, /*On fail goto*//*Label 10768*/ GIMT_Encode4(676201), // Rule ID 10587 //
     /*  676131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  676142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  676145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  676148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676199 */     GIR_RootConstrainSelectedInstOperands,
     /*  676200 */     // GIR_Coverage, 10587,
     /*  676200 */     GIR_EraseRootFromParent_Done,
     /*  676201 */   // Label 10768: @676201
     /*  676201 */   GIM_Try, /*On fail goto*//*Label 10769*/ GIMT_Encode4(676276), // Rule ID 10590 //
     /*  676206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676252 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  676252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676274 */     GIR_RootConstrainSelectedInstOperands,
     /*  676275 */     // GIR_Coverage, 10590,
     /*  676275 */     GIR_EraseRootFromParent_Done,
     /*  676276 */   // Label 10769: @676276
     /*  676276 */   GIM_Try, /*On fail goto*//*Label 10770*/ GIMT_Encode4(676351), // Rule ID 10591 //
     /*  676281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  676292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  676295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  676298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676327 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  676327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  676346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676349 */     GIR_RootConstrainSelectedInstOperands,
     /*  676350 */     // GIR_Coverage, 10591,
     /*  676350 */     GIR_EraseRootFromParent_Done,
     /*  676351 */   // Label 10770: @676351
     /*  676351 */   GIM_Try, /*On fail goto*//*Label 10771*/ GIMT_Encode4(676426), // Rule ID 10594 //
     /*  676356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676424 */     GIR_RootConstrainSelectedInstOperands,
     /*  676425 */     // GIR_Coverage, 10594,
     /*  676425 */     GIR_EraseRootFromParent_Done,
     /*  676426 */   // Label 10771: @676426
     /*  676426 */   GIM_Try, /*On fail goto*//*Label 10772*/ GIMT_Encode4(676501), // Rule ID 10595 //
     /*  676431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  676442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  676445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  676448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  676466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676477 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11432:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  676480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676499 */     GIR_RootConstrainSelectedInstOperands,
     /*  676500 */     // GIR_Coverage, 10595,
     /*  676500 */     GIR_EraseRootFromParent_Done,
     /*  676501 */   // Label 10772: @676501
     /*  676501 */   GIM_Try, /*On fail goto*//*Label 10773*/ GIMT_Encode4(676576), // Rule ID 10598 //
     /*  676506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  676517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  676520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  676523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676574 */     GIR_RootConstrainSelectedInstOperands,
     /*  676575 */     // GIR_Coverage, 10598,
     /*  676575 */     GIR_EraseRootFromParent_Done,
     /*  676576 */   // Label 10773: @676576
     /*  676576 */   GIM_Try, /*On fail goto*//*Label 10774*/ GIMT_Encode4(676651), // Rule ID 10599 //
     /*  676581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  676592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  676595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  676598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676627 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11432:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676649 */     GIR_RootConstrainSelectedInstOperands,
     /*  676650 */     // GIR_Coverage, 10599,
     /*  676650 */     GIR_EraseRootFromParent_Done,
     /*  676651 */   // Label 10774: @676651
     /*  676651 */   GIM_Try, /*On fail goto*//*Label 10775*/ GIMT_Encode4(676726), // Rule ID 10602 //
     /*  676656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  676667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  676670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  676673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676724 */     GIR_RootConstrainSelectedInstOperands,
     /*  676725 */     // GIR_Coverage, 10602,
     /*  676725 */     GIR_EraseRootFromParent_Done,
     /*  676726 */   // Label 10775: @676726
     /*  676726 */   GIM_Try, /*On fail goto*//*Label 10776*/ GIMT_Encode4(676801), // Rule ID 10603 //
     /*  676731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  676742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  676745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  676748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11432:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676799 */     GIR_RootConstrainSelectedInstOperands,
     /*  676800 */     // GIR_Coverage, 10603,
     /*  676800 */     GIR_EraseRootFromParent_Done,
     /*  676801 */   // Label 10776: @676801
     /*  676801 */   GIM_Try, /*On fail goto*//*Label 10777*/ GIMT_Encode4(676876), // Rule ID 10606 //
     /*  676806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  676817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  676820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  676823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  676826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676852 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  676852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  676855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676874 */     GIR_RootConstrainSelectedInstOperands,
     /*  676875 */     // GIR_Coverage, 10606,
     /*  676875 */     GIR_EraseRootFromParent_Done,
     /*  676876 */   // Label 10777: @676876
     /*  676876 */   GIM_Try, /*On fail goto*//*Label 10778*/ GIMT_Encode4(676951), // Rule ID 10607 //
     /*  676881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  676892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  676895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  676898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  676901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676927 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  676927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  676930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676949 */     GIR_RootConstrainSelectedInstOperands,
     /*  676950 */     // GIR_Coverage, 10607,
     /*  676950 */     GIR_EraseRootFromParent_Done,
     /*  676951 */   // Label 10778: @676951
     /*  676951 */   GIM_Try, /*On fail goto*//*Label 10779*/ GIMT_Encode4(677026), // Rule ID 10610 //
     /*  676956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  676967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  676970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  676973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  676976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677024 */     GIR_RootConstrainSelectedInstOperands,
     /*  677025 */     // GIR_Coverage, 10610,
     /*  677025 */     GIR_EraseRootFromParent_Done,
     /*  677026 */   // Label 10779: @677026
     /*  677026 */   GIM_Try, /*On fail goto*//*Label 10780*/ GIMT_Encode4(677101), // Rule ID 10611 //
     /*  677031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  677042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  677045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  677048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  677051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677077 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677099 */     GIR_RootConstrainSelectedInstOperands,
     /*  677100 */     // GIR_Coverage, 10611,
     /*  677100 */     GIR_EraseRootFromParent_Done,
     /*  677101 */   // Label 10780: @677101
     /*  677101 */   GIM_Try, /*On fail goto*//*Label 10781*/ GIMT_Encode4(677176), // Rule ID 10614 //
     /*  677106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  677126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677174 */     GIR_RootConstrainSelectedInstOperands,
     /*  677175 */     // GIR_Coverage, 10614,
     /*  677175 */     GIR_EraseRootFromParent_Done,
     /*  677176 */   // Label 10781: @677176
     /*  677176 */   GIM_Try, /*On fail goto*//*Label 10782*/ GIMT_Encode4(677251), // Rule ID 10615 //
     /*  677181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  677192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  677195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  677198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  677201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677227 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677249 */     GIR_RootConstrainSelectedInstOperands,
     /*  677250 */     // GIR_Coverage, 10615,
     /*  677250 */     GIR_EraseRootFromParent_Done,
     /*  677251 */   // Label 10782: @677251
     /*  677251 */   GIM_Try, /*On fail goto*//*Label 10783*/ GIMT_Encode4(677326), // Rule ID 10618 //
     /*  677256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  677276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677302 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677324 */     GIR_RootConstrainSelectedInstOperands,
     /*  677325 */     // GIR_Coverage, 10618,
     /*  677325 */     GIR_EraseRootFromParent_Done,
     /*  677326 */   // Label 10783: @677326
     /*  677326 */   GIM_Try, /*On fail goto*//*Label 10784*/ GIMT_Encode4(677401), // Rule ID 10619 //
     /*  677331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  677342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  677345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  677348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  677351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677377 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  677380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677399 */     GIR_RootConstrainSelectedInstOperands,
     /*  677400 */     // GIR_Coverage, 10619,
     /*  677400 */     GIR_EraseRootFromParent_Done,
     /*  677401 */   // Label 10784: @677401
     /*  677401 */   GIM_Try, /*On fail goto*//*Label 10785*/ GIMT_Encode4(677476), // Rule ID 10622 //
     /*  677406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  677426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677474 */     GIR_RootConstrainSelectedInstOperands,
     /*  677475 */     // GIR_Coverage, 10622,
     /*  677475 */     GIR_EraseRootFromParent_Done,
     /*  677476 */   // Label 10785: @677476
     /*  677476 */   GIM_Try, /*On fail goto*//*Label 10786*/ GIMT_Encode4(677551), // Rule ID 10623 //
     /*  677481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  677492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  677495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  677498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  677501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677527 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677549 */     GIR_RootConstrainSelectedInstOperands,
     /*  677550 */     // GIR_Coverage, 10623,
     /*  677550 */     GIR_EraseRootFromParent_Done,
     /*  677551 */   // Label 10786: @677551
     /*  677551 */   GIM_Try, /*On fail goto*//*Label 10787*/ GIMT_Encode4(677626), // Rule ID 10626 //
     /*  677556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  677567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  677570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  677573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  677576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677602 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  677602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  677621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677624 */     GIR_RootConstrainSelectedInstOperands,
     /*  677625 */     // GIR_Coverage, 10626,
     /*  677625 */     GIR_EraseRootFromParent_Done,
     /*  677626 */   // Label 10787: @677626
     /*  677626 */   GIM_Try, /*On fail goto*//*Label 10788*/ GIMT_Encode4(677701), // Rule ID 10627 //
     /*  677631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  677642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  677645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  677648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  677651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677677 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  677677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  677696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677699 */     GIR_RootConstrainSelectedInstOperands,
     /*  677700 */     // GIR_Coverage, 10627,
     /*  677700 */     GIR_EraseRootFromParent_Done,
     /*  677701 */   // Label 10788: @677701
     /*  677701 */   GIM_Try, /*On fail goto*//*Label 10789*/ GIMT_Encode4(677776), // Rule ID 10630 //
     /*  677706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  677717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  677720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  677723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  677726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677774 */     GIR_RootConstrainSelectedInstOperands,
     /*  677775 */     // GIR_Coverage, 10630,
     /*  677775 */     GIR_EraseRootFromParent_Done,
     /*  677776 */   // Label 10789: @677776
     /*  677776 */   GIM_Try, /*On fail goto*//*Label 10790*/ GIMT_Encode4(677851), // Rule ID 10631 //
     /*  677781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  677792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  677795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  677798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  677801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677827 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677849 */     GIR_RootConstrainSelectedInstOperands,
     /*  677850 */     // GIR_Coverage, 10631,
     /*  677850 */     GIR_EraseRootFromParent_Done,
     /*  677851 */   // Label 10790: @677851
     /*  677851 */   GIM_Try, /*On fail goto*//*Label 10791*/ GIMT_Encode4(677926), // Rule ID 10634 //
     /*  677856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  677867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  677870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  677873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  677876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677924 */     GIR_RootConstrainSelectedInstOperands,
     /*  677925 */     // GIR_Coverage, 10634,
     /*  677925 */     GIR_EraseRootFromParent_Done,
     /*  677926 */   // Label 10791: @677926
     /*  677926 */   GIM_Try, /*On fail goto*//*Label 10792*/ GIMT_Encode4(678001), // Rule ID 10635 //
     /*  677931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  677942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  677945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  677948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  677951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677999 */     GIR_RootConstrainSelectedInstOperands,
     /*  678000 */     // GIR_Coverage, 10635,
     /*  678000 */     GIR_EraseRootFromParent_Done,
     /*  678001 */   // Label 10792: @678001
     /*  678001 */   GIM_Try, /*On fail goto*//*Label 10793*/ GIMT_Encode4(678076), // Rule ID 10638 //
     /*  678006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  678026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678074 */     GIR_RootConstrainSelectedInstOperands,
     /*  678075 */     // GIR_Coverage, 10638,
     /*  678075 */     GIR_EraseRootFromParent_Done,
     /*  678076 */   // Label 10793: @678076
     /*  678076 */   GIM_Try, /*On fail goto*//*Label 10794*/ GIMT_Encode4(678151), // Rule ID 10639 //
     /*  678081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  678092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  678095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  678098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  678101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678127 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678149 */     GIR_RootConstrainSelectedInstOperands,
     /*  678150 */     // GIR_Coverage, 10639,
     /*  678150 */     GIR_EraseRootFromParent_Done,
     /*  678151 */   // Label 10794: @678151
     /*  678151 */   GIM_Try, /*On fail goto*//*Label 10795*/ GIMT_Encode4(678226), // Rule ID 10642 //
     /*  678156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  678159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  678176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  678202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678224 */     GIR_RootConstrainSelectedInstOperands,
     /*  678225 */     // GIR_Coverage, 10642,
     /*  678225 */     GIR_EraseRootFromParent_Done,
     /*  678226 */   // Label 10795: @678226
     /*  678226 */   GIM_Try, /*On fail goto*//*Label 10796*/ GIMT_Encode4(678301), // Rule ID 10643 //
     /*  678231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  678234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  678242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  678245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  678248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  678251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  678270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678277 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  678277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  678280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  678296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678299 */     GIR_RootConstrainSelectedInstOperands,
     /*  678300 */     // GIR_Coverage, 10643,
     /*  678300 */     GIR_EraseRootFromParent_Done,
     /*  678301 */   // Label 10796: @678301
     /*  678301 */   GIM_Try, /*On fail goto*//*Label 10797*/ GIMT_Encode4(678376), // Rule ID 10646 //
     /*  678306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  678326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678374 */     GIR_RootConstrainSelectedInstOperands,
     /*  678375 */     // GIR_Coverage, 10646,
     /*  678375 */     GIR_EraseRootFromParent_Done,
     /*  678376 */   // Label 10797: @678376
     /*  678376 */   GIM_Try, /*On fail goto*//*Label 10798*/ GIMT_Encode4(678451), // Rule ID 10647 //
     /*  678381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  678392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  678395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  678398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  678401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678427 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678449 */     GIR_RootConstrainSelectedInstOperands,
     /*  678450 */     // GIR_Coverage, 10647,
     /*  678450 */     GIR_EraseRootFromParent_Done,
     /*  678451 */   // Label 10798: @678451
     /*  678451 */   GIM_Try, /*On fail goto*//*Label 10799*/ GIMT_Encode4(678526), // Rule ID 10650 //
     /*  678456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  678467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  678470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  678473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  678476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678502 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678524 */     GIR_RootConstrainSelectedInstOperands,
     /*  678525 */     // GIR_Coverage, 10650,
     /*  678525 */     GIR_EraseRootFromParent_Done,
     /*  678526 */   // Label 10799: @678526
     /*  678526 */   GIM_Try, /*On fail goto*//*Label 10800*/ GIMT_Encode4(678601), // Rule ID 10651 //
     /*  678531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  678542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  678545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  678548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  678551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678577 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678599 */     GIR_RootConstrainSelectedInstOperands,
     /*  678600 */     // GIR_Coverage, 10651,
     /*  678600 */     GIR_EraseRootFromParent_Done,
     /*  678601 */   // Label 10800: @678601
     /*  678601 */   GIM_Try, /*On fail goto*//*Label 10801*/ GIMT_Encode4(678676), // Rule ID 10654 //
     /*  678606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  678617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  678620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  678623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  678626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678652 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  678655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678674 */     GIR_RootConstrainSelectedInstOperands,
     /*  678675 */     // GIR_Coverage, 10654,
     /*  678675 */     GIR_EraseRootFromParent_Done,
     /*  678676 */   // Label 10801: @678676
     /*  678676 */   GIM_Try, /*On fail goto*//*Label 10802*/ GIMT_Encode4(678751), // Rule ID 10655 //
     /*  678681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  678692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  678695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  678698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  678701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678727 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  678730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678749 */     GIR_RootConstrainSelectedInstOperands,
     /*  678750 */     // GIR_Coverage, 10655,
     /*  678750 */     GIR_EraseRootFromParent_Done,
     /*  678751 */   // Label 10802: @678751
     /*  678751 */   GIM_Try, /*On fail goto*//*Label 10803*/ GIMT_Encode4(678826), // Rule ID 10658 //
     /*  678756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  678767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  678770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  678773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  678776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678824 */     GIR_RootConstrainSelectedInstOperands,
     /*  678825 */     // GIR_Coverage, 10658,
     /*  678825 */     GIR_EraseRootFromParent_Done,
     /*  678826 */   // Label 10803: @678826
     /*  678826 */   GIM_Try, /*On fail goto*//*Label 10804*/ GIMT_Encode4(678901), // Rule ID 10659 //
     /*  678831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  678842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  678845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  678848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  678851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678877 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678899 */     GIR_RootConstrainSelectedInstOperands,
     /*  678900 */     // GIR_Coverage, 10659,
     /*  678900 */     GIR_EraseRootFromParent_Done,
     /*  678901 */   // Label 10804: @678901
     /*  678901 */   GIM_Try, /*On fail goto*//*Label 10805*/ GIMT_Encode4(678976), // Rule ID 10662 //
     /*  678906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  678917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  678920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  678923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  678926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678974 */     GIR_RootConstrainSelectedInstOperands,
     /*  678975 */     // GIR_Coverage, 10662,
     /*  678975 */     GIR_EraseRootFromParent_Done,
     /*  678976 */   // Label 10805: @678976
     /*  678976 */   GIM_Try, /*On fail goto*//*Label 10806*/ GIMT_Encode4(679051), // Rule ID 10663 //
     /*  678981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  678992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  678995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  678998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  679001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679027 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679049 */     GIR_RootConstrainSelectedInstOperands,
     /*  679050 */     // GIR_Coverage, 10663,
     /*  679050 */     GIR_EraseRootFromParent_Done,
     /*  679051 */   // Label 10806: @679051
     /*  679051 */   GIM_Try, /*On fail goto*//*Label 10807*/ GIMT_Encode4(679126), // Rule ID 10666 //
     /*  679056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  679076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679102 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  679102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679124 */     GIR_RootConstrainSelectedInstOperands,
     /*  679125 */     // GIR_Coverage, 10666,
     /*  679125 */     GIR_EraseRootFromParent_Done,
     /*  679126 */   // Label 10807: @679126
     /*  679126 */   GIM_Try, /*On fail goto*//*Label 10808*/ GIMT_Encode4(679201), // Rule ID 10667 //
     /*  679131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  679142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  679145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  679148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  679151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679177 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  679177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  679196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679199 */     GIR_RootConstrainSelectedInstOperands,
     /*  679200 */     // GIR_Coverage, 10667,
     /*  679200 */     GIR_EraseRootFromParent_Done,
     /*  679201 */   // Label 10808: @679201
     /*  679201 */   GIM_Try, /*On fail goto*//*Label 10809*/ GIMT_Encode4(679276), // Rule ID 10670 //
     /*  679206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  679226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679274 */     GIR_RootConstrainSelectedInstOperands,
     /*  679275 */     // GIR_Coverage, 10670,
     /*  679275 */     GIR_EraseRootFromParent_Done,
     /*  679276 */   // Label 10809: @679276
     /*  679276 */   GIM_Try, /*On fail goto*//*Label 10810*/ GIMT_Encode4(679351), // Rule ID 10671 //
     /*  679281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  679292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  679295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  679298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  679301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679349 */     GIR_RootConstrainSelectedInstOperands,
     /*  679350 */     // GIR_Coverage, 10671,
     /*  679350 */     GIR_EraseRootFromParent_Done,
     /*  679351 */   // Label 10810: @679351
     /*  679351 */   GIM_Try, /*On fail goto*//*Label 10811*/ GIMT_Encode4(679426), // Rule ID 10674 //
     /*  679356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  679376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679424 */     GIR_RootConstrainSelectedInstOperands,
     /*  679425 */     // GIR_Coverage, 10674,
     /*  679425 */     GIR_EraseRootFromParent_Done,
     /*  679426 */   // Label 10811: @679426
     /*  679426 */   GIM_Try, /*On fail goto*//*Label 10812*/ GIMT_Encode4(679501), // Rule ID 10675 //
     /*  679431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  679442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  679445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  679448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  679451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679477 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679499 */     GIR_RootConstrainSelectedInstOperands,
     /*  679500 */     // GIR_Coverage, 10675,
     /*  679500 */     GIR_EraseRootFromParent_Done,
     /*  679501 */   // Label 10812: @679501
     /*  679501 */   GIM_Try, /*On fail goto*//*Label 10813*/ GIMT_Encode4(679576), // Rule ID 10678 //
     /*  679506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  679517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  679520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  679523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  679526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679552 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679574 */     GIR_RootConstrainSelectedInstOperands,
     /*  679575 */     // GIR_Coverage, 10678,
     /*  679575 */     GIR_EraseRootFromParent_Done,
     /*  679576 */   // Label 10813: @679576
     /*  679576 */   GIM_Try, /*On fail goto*//*Label 10814*/ GIMT_Encode4(679651), // Rule ID 10679 //
     /*  679581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  679592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  679595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  679598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  679601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679627 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679649 */     GIR_RootConstrainSelectedInstOperands,
     /*  679650 */     // GIR_Coverage, 10679,
     /*  679650 */     GIR_EraseRootFromParent_Done,
     /*  679651 */   // Label 10814: @679651
     /*  679651 */   GIM_Try, /*On fail goto*//*Label 10815*/ GIMT_Encode4(679726), // Rule ID 10682 //
     /*  679656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  679659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  679667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  679670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  679673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  679676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  679702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679724 */     GIR_RootConstrainSelectedInstOperands,
     /*  679725 */     // GIR_Coverage, 10682,
     /*  679725 */     GIR_EraseRootFromParent_Done,
     /*  679726 */   // Label 10815: @679726
     /*  679726 */   GIM_Try, /*On fail goto*//*Label 10816*/ GIMT_Encode4(679801), // Rule ID 10683 //
     /*  679731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  679734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  679742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  679745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  679748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  679751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  679777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679799 */     GIR_RootConstrainSelectedInstOperands,
     /*  679800 */     // GIR_Coverage, 10683,
     /*  679800 */     GIR_EraseRootFromParent_Done,
     /*  679801 */   // Label 10816: @679801
     /*  679801 */   GIM_Try, /*On fail goto*//*Label 10817*/ GIMT_Encode4(679876), // Rule ID 10686 //
     /*  679806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  679809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  679817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  679820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  679823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  679826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679852 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  679852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679874 */     GIR_RootConstrainSelectedInstOperands,
     /*  679875 */     // GIR_Coverage, 10686,
     /*  679875 */     GIR_EraseRootFromParent_Done,
     /*  679876 */   // Label 10817: @679876
     /*  679876 */   GIM_Try, /*On fail goto*//*Label 10818*/ GIMT_Encode4(679951), // Rule ID 10687 //
     /*  679881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  679884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  679892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  679895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  679898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  679901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679927 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  679927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679949 */     GIR_RootConstrainSelectedInstOperands,
     /*  679950 */     // GIR_Coverage, 10687,
     /*  679950 */     GIR_EraseRootFromParent_Done,
     /*  679951 */   // Label 10818: @679951
     /*  679951 */   GIM_Try, /*On fail goto*//*Label 10819*/ GIMT_Encode4(680026), // Rule ID 10690 //
     /*  679956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  679959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  679967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  679970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  679973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  679976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680002 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680024 */     GIR_RootConstrainSelectedInstOperands,
     /*  680025 */     // GIR_Coverage, 10690,
     /*  680025 */     GIR_EraseRootFromParent_Done,
     /*  680026 */   // Label 10819: @680026
     /*  680026 */   GIM_Try, /*On fail goto*//*Label 10820*/ GIMT_Encode4(680101), // Rule ID 10691 //
     /*  680031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  680034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  680042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  680045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  680048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  680051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  680070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680077 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  680077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  680080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  680096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680099 */     GIR_RootConstrainSelectedInstOperands,
     /*  680100 */     // GIR_Coverage, 10691,
     /*  680100 */     GIR_EraseRootFromParent_Done,
     /*  680101 */   // Label 10820: @680101
     /*  680101 */   GIM_Try, /*On fail goto*//*Label 10821*/ GIMT_Encode4(680176), // Rule ID 10694 //
     /*  680106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  680155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680174 */     GIR_RootConstrainSelectedInstOperands,
     /*  680175 */     // GIR_Coverage, 10694,
     /*  680175 */     GIR_EraseRootFromParent_Done,
     /*  680176 */   // Label 10821: @680176
     /*  680176 */   GIM_Try, /*On fail goto*//*Label 10822*/ GIMT_Encode4(680251), // Rule ID 10695 //
     /*  680181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  680192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  680195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  680198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680227 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  680230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680249 */     GIR_RootConstrainSelectedInstOperands,
     /*  680250 */     // GIR_Coverage, 10695,
     /*  680250 */     GIR_EraseRootFromParent_Done,
     /*  680251 */   // Label 10822: @680251
     /*  680251 */   GIM_Try, /*On fail goto*//*Label 10823*/ GIMT_Encode4(680326), // Rule ID 10698 //
     /*  680256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680302 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680324 */     GIR_RootConstrainSelectedInstOperands,
     /*  680325 */     // GIR_Coverage, 10698,
     /*  680325 */     GIR_EraseRootFromParent_Done,
     /*  680326 */   // Label 10823: @680326
     /*  680326 */   GIM_Try, /*On fail goto*//*Label 10824*/ GIMT_Encode4(680401), // Rule ID 10699 //
     /*  680331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  680342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  680345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  680348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680377 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680399 */     GIR_RootConstrainSelectedInstOperands,
     /*  680400 */     // GIR_Coverage, 10699,
     /*  680400 */     GIR_EraseRootFromParent_Done,
     /*  680401 */   // Label 10824: @680401
     /*  680401 */   GIM_Try, /*On fail goto*//*Label 10825*/ GIMT_Encode4(680476), // Rule ID 10702 //
     /*  680406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680474 */     GIR_RootConstrainSelectedInstOperands,
     /*  680475 */     // GIR_Coverage, 10702,
     /*  680475 */     GIR_EraseRootFromParent_Done,
     /*  680476 */   // Label 10825: @680476
     /*  680476 */   GIM_Try, /*On fail goto*//*Label 10826*/ GIMT_Encode4(680551), // Rule ID 10703 //
     /*  680481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  680492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  680495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  680498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680527 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680549 */     GIR_RootConstrainSelectedInstOperands,
     /*  680550 */     // GIR_Coverage, 10703,
     /*  680550 */     GIR_EraseRootFromParent_Done,
     /*  680551 */   // Label 10826: @680551
     /*  680551 */   GIM_Try, /*On fail goto*//*Label 10827*/ GIMT_Encode4(680626), // Rule ID 10706 //
     /*  680556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  680567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  680570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  680573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680602 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  680602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680624 */     GIR_RootConstrainSelectedInstOperands,
     /*  680625 */     // GIR_Coverage, 10706,
     /*  680625 */     GIR_EraseRootFromParent_Done,
     /*  680626 */   // Label 10827: @680626
     /*  680626 */   GIM_Try, /*On fail goto*//*Label 10828*/ GIMT_Encode4(680701), // Rule ID 10707 //
     /*  680631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  680642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  680645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  680648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680677 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  680677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680699 */     GIR_RootConstrainSelectedInstOperands,
     /*  680700 */     // GIR_Coverage, 10707,
     /*  680700 */     GIR_EraseRootFromParent_Done,
     /*  680701 */   // Label 10828: @680701
     /*  680701 */   GIM_Try, /*On fail goto*//*Label 10829*/ GIMT_Encode4(680776), // Rule ID 10710 //
     /*  680706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  680717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  680720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  680723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  680752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680774 */     GIR_RootConstrainSelectedInstOperands,
     /*  680775 */     // GIR_Coverage, 10710,
     /*  680775 */     GIR_EraseRootFromParent_Done,
     /*  680776 */   // Label 10829: @680776
     /*  680776 */   GIM_Try, /*On fail goto*//*Label 10830*/ GIMT_Encode4(680851), // Rule ID 10711 //
     /*  680781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  680792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  680795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  680798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680827 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  680827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680849 */     GIR_RootConstrainSelectedInstOperands,
     /*  680850 */     // GIR_Coverage, 10711,
     /*  680850 */     GIR_EraseRootFromParent_Done,
     /*  680851 */   // Label 10830: @680851
     /*  680851 */   GIM_Try, /*On fail goto*//*Label 10831*/ GIMT_Encode4(680926), // Rule ID 10714 //
     /*  680856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  680867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  680870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  680873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  680902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680924 */     GIR_RootConstrainSelectedInstOperands,
     /*  680925 */     // GIR_Coverage, 10714,
     /*  680925 */     GIR_EraseRootFromParent_Done,
     /*  680926 */   // Label 10831: @680926
     /*  680926 */   GIM_Try, /*On fail goto*//*Label 10832*/ GIMT_Encode4(681001), // Rule ID 10715 //
     /*  680931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  680942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  680945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  680948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680977 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680999 */     GIR_RootConstrainSelectedInstOperands,
     /*  681000 */     // GIR_Coverage, 10715,
     /*  681000 */     GIR_EraseRootFromParent_Done,
     /*  681001 */   // Label 10832: @681001
     /*  681001 */   GIM_Try, /*On fail goto*//*Label 10833*/ GIMT_Encode4(681076), // Rule ID 10718 //
     /*  681006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681052 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681074 */     GIR_RootConstrainSelectedInstOperands,
     /*  681075 */     // GIR_Coverage, 10718,
     /*  681075 */     GIR_EraseRootFromParent_Done,
     /*  681076 */   // Label 10833: @681076
     /*  681076 */   GIM_Try, /*On fail goto*//*Label 10834*/ GIMT_Encode4(681151), // Rule ID 10719 //
     /*  681081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  681092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  681095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  681098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681127 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681149 */     GIR_RootConstrainSelectedInstOperands,
     /*  681150 */     // GIR_Coverage, 10719,
     /*  681150 */     GIR_EraseRootFromParent_Done,
     /*  681151 */   // Label 10834: @681151
     /*  681151 */   GIM_Try, /*On fail goto*//*Label 10835*/ GIMT_Encode4(681226), // Rule ID 10722 //
     /*  681156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681224 */     GIR_RootConstrainSelectedInstOperands,
     /*  681225 */     // GIR_Coverage, 10722,
     /*  681225 */     GIR_EraseRootFromParent_Done,
     /*  681226 */   // Label 10835: @681226
     /*  681226 */   GIM_Try, /*On fail goto*//*Label 10836*/ GIMT_Encode4(681301), // Rule ID 10723 //
     /*  681231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  681242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  681245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  681248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681277 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681299 */     GIR_RootConstrainSelectedInstOperands,
     /*  681300 */     // GIR_Coverage, 10723,
     /*  681300 */     GIR_EraseRootFromParent_Done,
     /*  681301 */   // Label 10836: @681301
     /*  681301 */   GIM_Try, /*On fail goto*//*Label 10837*/ GIMT_Encode4(681376), // Rule ID 10726 //
     /*  681306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  681352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681374 */     GIR_RootConstrainSelectedInstOperands,
     /*  681375 */     // GIR_Coverage, 10726,
     /*  681375 */     GIR_EraseRootFromParent_Done,
     /*  681376 */   // Label 10837: @681376
     /*  681376 */   GIM_Try, /*On fail goto*//*Label 10838*/ GIMT_Encode4(681451), // Rule ID 10727 //
     /*  681381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  681392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  681395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  681398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  681427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  681446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681449 */     GIR_RootConstrainSelectedInstOperands,
     /*  681450 */     // GIR_Coverage, 10727,
     /*  681450 */     GIR_EraseRootFromParent_Done,
     /*  681451 */   // Label 10838: @681451
     /*  681451 */   GIM_Try, /*On fail goto*//*Label 10839*/ GIMT_Encode4(681526), // Rule ID 10730 //
     /*  681456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  681459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  681467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  681470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  681473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  681502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  681521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681524 */     GIR_RootConstrainSelectedInstOperands,
     /*  681525 */     // GIR_Coverage, 10730,
     /*  681525 */     GIR_EraseRootFromParent_Done,
     /*  681526 */   // Label 10839: @681526
     /*  681526 */   GIM_Try, /*On fail goto*//*Label 10840*/ GIMT_Encode4(681601), // Rule ID 10731 //
     /*  681531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  681534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  681542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  681545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  681548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  681577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  681596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681599 */     GIR_RootConstrainSelectedInstOperands,
     /*  681600 */     // GIR_Coverage, 10731,
     /*  681600 */     GIR_EraseRootFromParent_Done,
     /*  681601 */   // Label 10840: @681601
     /*  681601 */   GIM_Try, /*On fail goto*//*Label 10841*/ GIMT_Encode4(681676), // Rule ID 10734 //
     /*  681606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  681617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  681620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  681623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  681655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681674 */     GIR_RootConstrainSelectedInstOperands,
     /*  681675 */     // GIR_Coverage, 10734,
     /*  681675 */     GIR_EraseRootFromParent_Done,
     /*  681676 */   // Label 10841: @681676
     /*  681676 */   GIM_Try, /*On fail goto*//*Label 10842*/ GIMT_Encode4(681751), // Rule ID 10735 //
     /*  681681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  681692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  681695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  681698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681727 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  681730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681749 */     GIR_RootConstrainSelectedInstOperands,
     /*  681750 */     // GIR_Coverage, 10735,
     /*  681750 */     GIR_EraseRootFromParent_Done,
     /*  681751 */   // Label 10842: @681751
     /*  681751 */   GIM_Try, /*On fail goto*//*Label 10843*/ GIMT_Encode4(681826), // Rule ID 10738 //
     /*  681756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  681767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  681770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  681773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681802 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  681805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681824 */     GIR_RootConstrainSelectedInstOperands,
     /*  681825 */     // GIR_Coverage, 10738,
     /*  681825 */     GIR_EraseRootFromParent_Done,
     /*  681826 */   // Label 10843: @681826
     /*  681826 */   GIM_Try, /*On fail goto*//*Label 10844*/ GIMT_Encode4(681901), // Rule ID 10739 //
     /*  681831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  681842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  681845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  681848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681877 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  681880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681899 */     GIR_RootConstrainSelectedInstOperands,
     /*  681900 */     // GIR_Coverage, 10739,
     /*  681900 */     GIR_EraseRootFromParent_Done,
     /*  681901 */   // Label 10844: @681901
     /*  681901 */   GIM_Try, /*On fail goto*//*Label 10845*/ GIMT_Encode4(681976), // Rule ID 10742 //
     /*  681906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  681917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  681920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  681923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681952 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  681955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681974 */     GIR_RootConstrainSelectedInstOperands,
     /*  681975 */     // GIR_Coverage, 10742,
     /*  681975 */     GIR_EraseRootFromParent_Done,
     /*  681976 */   // Label 10845: @681976
     /*  681976 */   GIM_Try, /*On fail goto*//*Label 10846*/ GIMT_Encode4(682051), // Rule ID 10743 //
     /*  681981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  681992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  681995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  681998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682027 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  682027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682049 */     GIR_RootConstrainSelectedInstOperands,
     /*  682050 */     // GIR_Coverage, 10743,
     /*  682050 */     GIR_EraseRootFromParent_Done,
     /*  682051 */   // Label 10846: @682051
     /*  682051 */   GIM_Try, /*On fail goto*//*Label 10847*/ GIMT_Encode4(682126), // Rule ID 10746 //
     /*  682056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682102 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682124 */     GIR_RootConstrainSelectedInstOperands,
     /*  682125 */     // GIR_Coverage, 10746,
     /*  682125 */     GIR_EraseRootFromParent_Done,
     /*  682126 */   // Label 10847: @682126
     /*  682126 */   GIM_Try, /*On fail goto*//*Label 10848*/ GIMT_Encode4(682201), // Rule ID 10747 //
     /*  682131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  682142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  682145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  682148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682177 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682199 */     GIR_RootConstrainSelectedInstOperands,
     /*  682200 */     // GIR_Coverage, 10747,
     /*  682200 */     GIR_EraseRootFromParent_Done,
     /*  682201 */   // Label 10848: @682201
     /*  682201 */   GIM_Try, /*On fail goto*//*Label 10849*/ GIMT_Encode4(682276), // Rule ID 10750 //
     /*  682206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682252 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682274 */     GIR_RootConstrainSelectedInstOperands,
     /*  682275 */     // GIR_Coverage, 10750,
     /*  682275 */     GIR_EraseRootFromParent_Done,
     /*  682276 */   // Label 10849: @682276
     /*  682276 */   GIM_Try, /*On fail goto*//*Label 10850*/ GIMT_Encode4(682351), // Rule ID 10751 //
     /*  682281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  682292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  682295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  682298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682327 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682349 */     GIR_RootConstrainSelectedInstOperands,
     /*  682350 */     // GIR_Coverage, 10751,
     /*  682350 */     GIR_EraseRootFromParent_Done,
     /*  682351 */   // Label 10850: @682351
     /*  682351 */   GIM_Try, /*On fail goto*//*Label 10851*/ GIMT_Encode4(682426), // Rule ID 10754 //
     /*  682356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682402 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  682402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682424 */     GIR_RootConstrainSelectedInstOperands,
     /*  682425 */     // GIR_Coverage, 10754,
     /*  682425 */     GIR_EraseRootFromParent_Done,
     /*  682426 */   // Label 10851: @682426
     /*  682426 */   GIM_Try, /*On fail goto*//*Label 10852*/ GIMT_Encode4(682501), // Rule ID 10755 //
     /*  682431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  682442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  682445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  682448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682477 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  682477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  682496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682499 */     GIR_RootConstrainSelectedInstOperands,
     /*  682500 */     // GIR_Coverage, 10755,
     /*  682500 */     GIR_EraseRootFromParent_Done,
     /*  682501 */   // Label 10852: @682501
     /*  682501 */   GIM_Try, /*On fail goto*//*Label 10853*/ GIMT_Encode4(682576), // Rule ID 10758 //
     /*  682506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  682517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  682520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  682523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  682552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682574 */     GIR_RootConstrainSelectedInstOperands,
     /*  682575 */     // GIR_Coverage, 10758,
     /*  682575 */     GIR_EraseRootFromParent_Done,
     /*  682576 */   // Label 10853: @682576
     /*  682576 */   GIM_Try, /*On fail goto*//*Label 10854*/ GIMT_Encode4(682651), // Rule ID 10759 //
     /*  682581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  682592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  682595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  682598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682649 */     GIR_RootConstrainSelectedInstOperands,
     /*  682650 */     // GIR_Coverage, 10759,
     /*  682650 */     GIR_EraseRootFromParent_Done,
     /*  682651 */   // Label 10854: @682651
     /*  682651 */   GIM_Try, /*On fail goto*//*Label 10855*/ GIMT_Encode4(682726), // Rule ID 10762 //
     /*  682656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  682667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  682670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  682673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682702 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  682702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682724 */     GIR_RootConstrainSelectedInstOperands,
     /*  682725 */     // GIR_Coverage, 10762,
     /*  682725 */     GIR_EraseRootFromParent_Done,
     /*  682726 */   // Label 10855: @682726
     /*  682726 */   GIM_Try, /*On fail goto*//*Label 10856*/ GIMT_Encode4(682801), // Rule ID 10763 //
     /*  682731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  682742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  682745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  682748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682777 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682799 */     GIR_RootConstrainSelectedInstOperands,
     /*  682800 */     // GIR_Coverage, 10763,
     /*  682800 */     GIR_EraseRootFromParent_Done,
     /*  682801 */   // Label 10856: @682801
     /*  682801 */   GIM_Try, /*On fail goto*//*Label 10857*/ GIMT_Encode4(682876), // Rule ID 10766 //
     /*  682806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  682817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  682820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  682823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  682852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682874 */     GIR_RootConstrainSelectedInstOperands,
     /*  682875 */     // GIR_Coverage, 10766,
     /*  682875 */     GIR_EraseRootFromParent_Done,
     /*  682876 */   // Label 10857: @682876
     /*  682876 */   GIM_Try, /*On fail goto*//*Label 10858*/ GIMT_Encode4(682951), // Rule ID 10767 //
     /*  682881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  682892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  682895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  682898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682927 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682949 */     GIR_RootConstrainSelectedInstOperands,
     /*  682950 */     // GIR_Coverage, 10767,
     /*  682950 */     GIR_EraseRootFromParent_Done,
     /*  682951 */   // Label 10858: @682951
     /*  682951 */   GIM_Try, /*On fail goto*//*Label 10859*/ GIMT_Encode4(683026), // Rule ID 10770 //
     /*  682956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  682967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  682970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  682973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683002 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683024 */     GIR_RootConstrainSelectedInstOperands,
     /*  683025 */     // GIR_Coverage, 10770,
     /*  683025 */     GIR_EraseRootFromParent_Done,
     /*  683026 */   // Label 10859: @683026
     /*  683026 */   GIM_Try, /*On fail goto*//*Label 10860*/ GIMT_Encode4(683101), // Rule ID 10771 //
     /*  683031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  683042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  683045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  683048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  683066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  683080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683099 */     GIR_RootConstrainSelectedInstOperands,
     /*  683100 */     // GIR_Coverage, 10771,
     /*  683100 */     GIR_EraseRootFromParent_Done,
     /*  683101 */   // Label 10860: @683101
     /*  683101 */   GIM_Try, /*On fail goto*//*Label 10861*/ GIMT_Encode4(683176), // Rule ID 10774 //
     /*  683106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683174 */     GIR_RootConstrainSelectedInstOperands,
     /*  683175 */     // GIR_Coverage, 10774,
     /*  683175 */     GIR_EraseRootFromParent_Done,
     /*  683176 */   // Label 10861: @683176
     /*  683176 */   GIM_Try, /*On fail goto*//*Label 10862*/ GIMT_Encode4(683251), // Rule ID 10775 //
     /*  683181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  683192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  683195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  683198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  683216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683227 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  683230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683249 */     GIR_RootConstrainSelectedInstOperands,
     /*  683250 */     // GIR_Coverage, 10775,
     /*  683250 */     GIR_EraseRootFromParent_Done,
     /*  683251 */   // Label 10862: @683251
     /*  683251 */   GIM_Try, /*On fail goto*//*Label 10863*/ GIMT_Encode4(683326), // Rule ID 10778 //
     /*  683256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  683259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  683276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683302 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  683302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683324 */     GIR_RootConstrainSelectedInstOperands,
     /*  683325 */     // GIR_Coverage, 10778,
     /*  683325 */     GIR_EraseRootFromParent_Done,
     /*  683326 */   // Label 10863: @683326
     /*  683326 */   GIM_Try, /*On fail goto*//*Label 10864*/ GIMT_Encode4(683401), // Rule ID 10779 //
     /*  683331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  683334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  683339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  683342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  683345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  683348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  683351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  683366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  683370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683377 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11416:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  683377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  683380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  683396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683399 */     GIR_RootConstrainSelectedInstOperands,
     /*  683400 */     // GIR_Coverage, 10779,
     /*  683400 */     GIR_EraseRootFromParent_Done,
     /*  683401 */   // Label 10864: @683401
     /*  683401 */   GIM_Try, /*On fail goto*//*Label 10865*/ GIMT_Encode4(683476), // Rule ID 10782 //
     /*  683406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  683426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683452 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  683455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683474 */     GIR_RootConstrainSelectedInstOperands,
     /*  683475 */     // GIR_Coverage, 10782,
     /*  683475 */     GIR_EraseRootFromParent_Done,
     /*  683476 */   // Label 10865: @683476
     /*  683476 */   GIM_Try, /*On fail goto*//*Label 10866*/ GIMT_Encode4(683551), // Rule ID 10783 //
     /*  683481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  683492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  683495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  683498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  683501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683527 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  683530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683549 */     GIR_RootConstrainSelectedInstOperands,
     /*  683550 */     // GIR_Coverage, 10783,
     /*  683550 */     GIR_EraseRootFromParent_Done,
     /*  683551 */   // Label 10866: @683551
     /*  683551 */   GIM_Try, /*On fail goto*//*Label 10867*/ GIMT_Encode4(683626), // Rule ID 10786 //
     /*  683556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  683567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  683570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  683573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  683576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683602 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683624 */     GIR_RootConstrainSelectedInstOperands,
     /*  683625 */     // GIR_Coverage, 10786,
     /*  683625 */     GIR_EraseRootFromParent_Done,
     /*  683626 */   // Label 10867: @683626
     /*  683626 */   GIM_Try, /*On fail goto*//*Label 10868*/ GIMT_Encode4(683701), // Rule ID 10787 //
     /*  683631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  683642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  683645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  683648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  683651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683677 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683699 */     GIR_RootConstrainSelectedInstOperands,
     /*  683700 */     // GIR_Coverage, 10787,
     /*  683700 */     GIR_EraseRootFromParent_Done,
     /*  683701 */   // Label 10868: @683701
     /*  683701 */   GIM_Try, /*On fail goto*//*Label 10869*/ GIMT_Encode4(683776), // Rule ID 10790 //
     /*  683706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  683717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  683720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  683723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  683726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683774 */     GIR_RootConstrainSelectedInstOperands,
     /*  683775 */     // GIR_Coverage, 10790,
     /*  683775 */     GIR_EraseRootFromParent_Done,
     /*  683776 */   // Label 10869: @683776
     /*  683776 */   GIM_Try, /*On fail goto*//*Label 10870*/ GIMT_Encode4(683851), // Rule ID 10791 //
     /*  683781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  683792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  683795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  683798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  683801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683827 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683849 */     GIR_RootConstrainSelectedInstOperands,
     /*  683850 */     // GIR_Coverage, 10791,
     /*  683850 */     GIR_EraseRootFromParent_Done,
     /*  683851 */   // Label 10870: @683851
     /*  683851 */   GIM_Try, /*On fail goto*//*Label 10871*/ GIMT_Encode4(683926), // Rule ID 10794 //
     /*  683856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  683867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  683870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  683873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  683876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  683902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683924 */     GIR_RootConstrainSelectedInstOperands,
     /*  683925 */     // GIR_Coverage, 10794,
     /*  683925 */     GIR_EraseRootFromParent_Done,
     /*  683926 */   // Label 10871: @683926
     /*  683926 */   GIM_Try, /*On fail goto*//*Label 10872*/ GIMT_Encode4(684001), // Rule ID 10795 //
     /*  683931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  683942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  683945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  683948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  683951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683977 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  683977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683999 */     GIR_RootConstrainSelectedInstOperands,
     /*  684000 */     // GIR_Coverage, 10795,
     /*  684000 */     GIR_EraseRootFromParent_Done,
     /*  684001 */   // Label 10872: @684001
     /*  684001 */   GIM_Try, /*On fail goto*//*Label 10873*/ GIMT_Encode4(684076), // Rule ID 10798 //
     /*  684006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  684026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684074 */     GIR_RootConstrainSelectedInstOperands,
     /*  684075 */     // GIR_Coverage, 10798,
     /*  684075 */     GIR_EraseRootFromParent_Done,
     /*  684076 */   // Label 10873: @684076
     /*  684076 */   GIM_Try, /*On fail goto*//*Label 10874*/ GIMT_Encode4(684151), // Rule ID 10799 //
     /*  684081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  684092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  684095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  684098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  684101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684127 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684149 */     GIR_RootConstrainSelectedInstOperands,
     /*  684150 */     // GIR_Coverage, 10799,
     /*  684150 */     GIR_EraseRootFromParent_Done,
     /*  684151 */   // Label 10874: @684151
     /*  684151 */   GIM_Try, /*On fail goto*//*Label 10875*/ GIMT_Encode4(684226), // Rule ID 10802 //
     /*  684156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  684176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  684202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684224 */     GIR_RootConstrainSelectedInstOperands,
     /*  684225 */     // GIR_Coverage, 10802,
     /*  684225 */     GIR_EraseRootFromParent_Done,
     /*  684226 */   // Label 10875: @684226
     /*  684226 */   GIM_Try, /*On fail goto*//*Label 10876*/ GIMT_Encode4(684301), // Rule ID 10803 //
     /*  684231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  684242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  684245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  684248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  684251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684277 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  684277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  684280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684299 */     GIR_RootConstrainSelectedInstOperands,
     /*  684300 */     // GIR_Coverage, 10803,
     /*  684300 */     GIR_EraseRootFromParent_Done,
     /*  684301 */   // Label 10876: @684301
     /*  684301 */   GIM_Try, /*On fail goto*//*Label 10877*/ GIMT_Encode4(684376), // Rule ID 10806 //
     /*  684306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  684326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684374 */     GIR_RootConstrainSelectedInstOperands,
     /*  684375 */     // GIR_Coverage, 10806,
     /*  684375 */     GIR_EraseRootFromParent_Done,
     /*  684376 */   // Label 10877: @684376
     /*  684376 */   GIM_Try, /*On fail goto*//*Label 10878*/ GIMT_Encode4(684451), // Rule ID 10807 //
     /*  684381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  684392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  684395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  684398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  684401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684427 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684449 */     GIR_RootConstrainSelectedInstOperands,
     /*  684450 */     // GIR_Coverage, 10807,
     /*  684450 */     GIR_EraseRootFromParent_Done,
     /*  684451 */   // Label 10878: @684451
     /*  684451 */   GIM_Try, /*On fail goto*//*Label 10879*/ GIMT_Encode4(684526), // Rule ID 10810 //
     /*  684456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  684467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  684470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  684473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  684476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684502 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684524 */     GIR_RootConstrainSelectedInstOperands,
     /*  684525 */     // GIR_Coverage, 10810,
     /*  684525 */     GIR_EraseRootFromParent_Done,
     /*  684526 */   // Label 10879: @684526
     /*  684526 */   GIM_Try, /*On fail goto*//*Label 10880*/ GIMT_Encode4(684601), // Rule ID 10811 //
     /*  684531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  684542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  684545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  684548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  684551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684577 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684599 */     GIR_RootConstrainSelectedInstOperands,
     /*  684600 */     // GIR_Coverage, 10811,
     /*  684600 */     GIR_EraseRootFromParent_Done,
     /*  684601 */   // Label 10880: @684601
     /*  684601 */   GIM_Try, /*On fail goto*//*Label 10881*/ GIMT_Encode4(684676), // Rule ID 10814 //
     /*  684606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  684617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  684620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  684623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  684626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  684652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684674 */     GIR_RootConstrainSelectedInstOperands,
     /*  684675 */     // GIR_Coverage, 10814,
     /*  684675 */     GIR_EraseRootFromParent_Done,
     /*  684676 */   // Label 10881: @684676
     /*  684676 */   GIM_Try, /*On fail goto*//*Label 10882*/ GIMT_Encode4(684751), // Rule ID 10815 //
     /*  684681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  684692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  684695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  684698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  684701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  684727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684749 */     GIR_RootConstrainSelectedInstOperands,
     /*  684750 */     // GIR_Coverage, 10815,
     /*  684750 */     GIR_EraseRootFromParent_Done,
     /*  684751 */   // Label 10882: @684751
     /*  684751 */   GIM_Try, /*On fail goto*//*Label 10883*/ GIMT_Encode4(684826), // Rule ID 10818 //
     /*  684756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  684759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  684767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  684770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  684773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  684776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  684802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  684821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684824 */     GIR_RootConstrainSelectedInstOperands,
     /*  684825 */     // GIR_Coverage, 10818,
     /*  684825 */     GIR_EraseRootFromParent_Done,
     /*  684826 */   // Label 10883: @684826
     /*  684826 */   GIM_Try, /*On fail goto*//*Label 10884*/ GIMT_Encode4(684901), // Rule ID 10819 //
     /*  684831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  684834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  684842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  684845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  684848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  684851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  684877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  684896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684899 */     GIR_RootConstrainSelectedInstOperands,
     /*  684900 */     // GIR_Coverage, 10819,
     /*  684900 */     GIR_EraseRootFromParent_Done,
     /*  684901 */   // Label 10884: @684901
     /*  684901 */   GIM_Try, /*On fail goto*//*Label 10885*/ GIMT_Encode4(684976), // Rule ID 10822 //
     /*  684906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  684917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  684920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  684923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  684926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  684955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684974 */     GIR_RootConstrainSelectedInstOperands,
     /*  684975 */     // GIR_Coverage, 10822,
     /*  684975 */     GIR_EraseRootFromParent_Done,
     /*  684976 */   // Label 10885: @684976
     /*  684976 */   GIM_Try, /*On fail goto*//*Label 10886*/ GIMT_Encode4(685051), // Rule ID 10823 //
     /*  684981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  684992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  684995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  684998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  685001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685049 */     GIR_RootConstrainSelectedInstOperands,
     /*  685050 */     // GIR_Coverage, 10823,
     /*  685050 */     GIR_EraseRootFromParent_Done,
     /*  685051 */   // Label 10886: @685051
     /*  685051 */   GIM_Try, /*On fail goto*//*Label 10887*/ GIMT_Encode4(685126), // Rule ID 10826 //
     /*  685056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  685076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685102 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685124 */     GIR_RootConstrainSelectedInstOperands,
     /*  685125 */     // GIR_Coverage, 10826,
     /*  685125 */     GIR_EraseRootFromParent_Done,
     /*  685126 */   // Label 10887: @685126
     /*  685126 */   GIM_Try, /*On fail goto*//*Label 10888*/ GIMT_Encode4(685201), // Rule ID 10827 //
     /*  685131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  685142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  685145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  685148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  685151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685177 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685199 */     GIR_RootConstrainSelectedInstOperands,
     /*  685200 */     // GIR_Coverage, 10827,
     /*  685200 */     GIR_EraseRootFromParent_Done,
     /*  685201 */   // Label 10888: @685201
     /*  685201 */   GIM_Try, /*On fail goto*//*Label 10889*/ GIMT_Encode4(685276), // Rule ID 10830 //
     /*  685206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  685226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685252 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  685252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685274 */     GIR_RootConstrainSelectedInstOperands,
     /*  685275 */     // GIR_Coverage, 10830,
     /*  685275 */     GIR_EraseRootFromParent_Done,
     /*  685276 */   // Label 10889: @685276
     /*  685276 */   GIM_Try, /*On fail goto*//*Label 10890*/ GIMT_Encode4(685351), // Rule ID 10831 //
     /*  685281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  685292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  685295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  685298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  685301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685327 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  685327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  685346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685349 */     GIR_RootConstrainSelectedInstOperands,
     /*  685350 */     // GIR_Coverage, 10831,
     /*  685350 */     GIR_EraseRootFromParent_Done,
     /*  685351 */   // Label 10890: @685351
     /*  685351 */   GIM_Try, /*On fail goto*//*Label 10891*/ GIMT_Encode4(685426), // Rule ID 10834 //
     /*  685356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  685376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685424 */     GIR_RootConstrainSelectedInstOperands,
     /*  685425 */     // GIR_Coverage, 10834,
     /*  685425 */     GIR_EraseRootFromParent_Done,
     /*  685426 */   // Label 10891: @685426
     /*  685426 */   GIM_Try, /*On fail goto*//*Label 10892*/ GIMT_Encode4(685501), // Rule ID 10835 //
     /*  685431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  685442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  685445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  685448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  685451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685477 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685499 */     GIR_RootConstrainSelectedInstOperands,
     /*  685500 */     // GIR_Coverage, 10835,
     /*  685500 */     GIR_EraseRootFromParent_Done,
     /*  685501 */   // Label 10892: @685501
     /*  685501 */   GIM_Try, /*On fail goto*//*Label 10893*/ GIMT_Encode4(685576), // Rule ID 10838 //
     /*  685506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  685517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  685520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  685523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  685526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685552 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685574 */     GIR_RootConstrainSelectedInstOperands,
     /*  685575 */     // GIR_Coverage, 10838,
     /*  685575 */     GIR_EraseRootFromParent_Done,
     /*  685576 */   // Label 10893: @685576
     /*  685576 */   GIM_Try, /*On fail goto*//*Label 10894*/ GIMT_Encode4(685651), // Rule ID 10839 //
     /*  685581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  685592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  685595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  685598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  685601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685627 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685649 */     GIR_RootConstrainSelectedInstOperands,
     /*  685650 */     // GIR_Coverage, 10839,
     /*  685650 */     GIR_EraseRootFromParent_Done,
     /*  685651 */   // Label 10894: @685651
     /*  685651 */   GIM_Try, /*On fail goto*//*Label 10895*/ GIMT_Encode4(685726), // Rule ID 10842 //
     /*  685656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  685667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  685670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  685673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  685676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685702 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685724 */     GIR_RootConstrainSelectedInstOperands,
     /*  685725 */     // GIR_Coverage, 10842,
     /*  685725 */     GIR_EraseRootFromParent_Done,
     /*  685726 */   // Label 10895: @685726
     /*  685726 */   GIM_Try, /*On fail goto*//*Label 10896*/ GIMT_Encode4(685801), // Rule ID 10843 //
     /*  685731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  685742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  685745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  685748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  685751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685777 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685799 */     GIR_RootConstrainSelectedInstOperands,
     /*  685800 */     // GIR_Coverage, 10843,
     /*  685800 */     GIR_EraseRootFromParent_Done,
     /*  685801 */   // Label 10896: @685801
     /*  685801 */   GIM_Try, /*On fail goto*//*Label 10897*/ GIMT_Encode4(685876), // Rule ID 10846 //
     /*  685806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  685817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  685820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  685823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  685826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685874 */     GIR_RootConstrainSelectedInstOperands,
     /*  685875 */     // GIR_Coverage, 10846,
     /*  685875 */     GIR_EraseRootFromParent_Done,
     /*  685876 */   // Label 10897: @685876
     /*  685876 */   GIM_Try, /*On fail goto*//*Label 10898*/ GIMT_Encode4(685951), // Rule ID 10847 //
     /*  685881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  685892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  685895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  685898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  685901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685949 */     GIR_RootConstrainSelectedInstOperands,
     /*  685950 */     // GIR_Coverage, 10847,
     /*  685950 */     GIR_EraseRootFromParent_Done,
     /*  685951 */   // Label 10898: @685951
     /*  685951 */   GIM_Try, /*On fail goto*//*Label 10899*/ GIMT_Encode4(686026), // Rule ID 10850 //
     /*  685956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  685967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  685970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  685973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  685976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686024 */     GIR_RootConstrainSelectedInstOperands,
     /*  686025 */     // GIR_Coverage, 10850,
     /*  686025 */     GIR_EraseRootFromParent_Done,
     /*  686026 */   // Label 10899: @686026
     /*  686026 */   GIM_Try, /*On fail goto*//*Label 10900*/ GIMT_Encode4(686101), // Rule ID 10851 //
     /*  686031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  686042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  686045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  686048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  686051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686077 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686099 */     GIR_RootConstrainSelectedInstOperands,
     /*  686100 */     // GIR_Coverage, 10851,
     /*  686100 */     GIR_EraseRootFromParent_Done,
     /*  686101 */   // Label 10900: @686101
     /*  686101 */   GIM_Try, /*On fail goto*//*Label 10901*/ GIMT_Encode4(686176), // Rule ID 10854 //
     /*  686106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  686126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686152 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686174 */     GIR_RootConstrainSelectedInstOperands,
     /*  686175 */     // GIR_Coverage, 10854,
     /*  686175 */     GIR_EraseRootFromParent_Done,
     /*  686176 */   // Label 10901: @686176
     /*  686176 */   GIM_Try, /*On fail goto*//*Label 10902*/ GIMT_Encode4(686251), // Rule ID 10855 //
     /*  686181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  686192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  686195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  686198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  686201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686227 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  686227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  686246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686249 */     GIR_RootConstrainSelectedInstOperands,
     /*  686250 */     // GIR_Coverage, 10855,
     /*  686250 */     GIR_EraseRootFromParent_Done,
     /*  686251 */   // Label 10902: @686251
     /*  686251 */   GIM_Try, /*On fail goto*//*Label 10903*/ GIMT_Encode4(686326), // Rule ID 10858 //
     /*  686256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  686276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686324 */     GIR_RootConstrainSelectedInstOperands,
     /*  686325 */     // GIR_Coverage, 10858,
     /*  686325 */     GIR_EraseRootFromParent_Done,
     /*  686326 */   // Label 10903: @686326
     /*  686326 */   GIM_Try, /*On fail goto*//*Label 10904*/ GIMT_Encode4(686401), // Rule ID 10859 //
     /*  686331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  686342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  686345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  686348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  686351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  686370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  686380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686399 */     GIR_RootConstrainSelectedInstOperands,
     /*  686400 */     // GIR_Coverage, 10859,
     /*  686400 */     GIR_EraseRootFromParent_Done,
     /*  686401 */   // Label 10904: @686401
     /*  686401 */   GIM_Try, /*On fail goto*//*Label 10905*/ GIMT_Encode4(686476), // Rule ID 10862 //
     /*  686406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  686426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686452 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686474 */     GIR_RootConstrainSelectedInstOperands,
     /*  686475 */     // GIR_Coverage, 10862,
     /*  686475 */     GIR_EraseRootFromParent_Done,
     /*  686476 */   // Label 10905: @686476
     /*  686476 */   GIM_Try, /*On fail goto*//*Label 10906*/ GIMT_Encode4(686551), // Rule ID 10863 //
     /*  686481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  686492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  686495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  686498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  686501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686527 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686549 */     GIR_RootConstrainSelectedInstOperands,
     /*  686550 */     // GIR_Coverage, 10863,
     /*  686550 */     GIR_EraseRootFromParent_Done,
     /*  686551 */   // Label 10906: @686551
     /*  686551 */   GIM_Try, /*On fail goto*//*Label 10907*/ GIMT_Encode4(686626), // Rule ID 10866 //
     /*  686556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  686567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  686570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  686573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  686576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686624 */     GIR_RootConstrainSelectedInstOperands,
     /*  686625 */     // GIR_Coverage, 10866,
     /*  686625 */     GIR_EraseRootFromParent_Done,
     /*  686626 */   // Label 10907: @686626
     /*  686626 */   GIM_Try, /*On fail goto*//*Label 10908*/ GIMT_Encode4(686701), // Rule ID 10867 //
     /*  686631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  686642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  686645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  686648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  686651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686677 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686699 */     GIR_RootConstrainSelectedInstOperands,
     /*  686700 */     // GIR_Coverage, 10867,
     /*  686700 */     GIR_EraseRootFromParent_Done,
     /*  686701 */   // Label 10908: @686701
     /*  686701 */   GIM_Try, /*On fail goto*//*Label 10909*/ GIMT_Encode4(686776), // Rule ID 10870 //
     /*  686706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  686717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  686720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  686723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686752 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  686755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686774 */     GIR_RootConstrainSelectedInstOperands,
     /*  686775 */     // GIR_Coverage, 10870,
     /*  686775 */     GIR_EraseRootFromParent_Done,
     /*  686776 */   // Label 10909: @686776
     /*  686776 */   GIM_Try, /*On fail goto*//*Label 10910*/ GIMT_Encode4(686851), // Rule ID 10871 //
     /*  686781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  686792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  686795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  686798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686827 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  686830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686849 */     GIR_RootConstrainSelectedInstOperands,
     /*  686850 */     // GIR_Coverage, 10871,
     /*  686850 */     GIR_EraseRootFromParent_Done,
     /*  686851 */   // Label 10910: @686851
     /*  686851 */   GIM_Try, /*On fail goto*//*Label 10911*/ GIMT_Encode4(686926), // Rule ID 10874 //
     /*  686856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  686867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  686870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  686873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686902 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  686905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686924 */     GIR_RootConstrainSelectedInstOperands,
     /*  686925 */     // GIR_Coverage, 10874,
     /*  686925 */     GIR_EraseRootFromParent_Done,
     /*  686926 */   // Label 10911: @686926
     /*  686926 */   GIM_Try, /*On fail goto*//*Label 10912*/ GIMT_Encode4(687001), // Rule ID 10875 //
     /*  686931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  686942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  686945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  686948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686977 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  686980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686999 */     GIR_RootConstrainSelectedInstOperands,
     /*  687000 */     // GIR_Coverage, 10875,
     /*  687000 */     GIR_EraseRootFromParent_Done,
     /*  687001 */   // Label 10912: @687001
     /*  687001 */   GIM_Try, /*On fail goto*//*Label 10913*/ GIMT_Encode4(687076), // Rule ID 10878 //
     /*  687006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687074 */     GIR_RootConstrainSelectedInstOperands,
     /*  687075 */     // GIR_Coverage, 10878,
     /*  687075 */     GIR_EraseRootFromParent_Done,
     /*  687076 */   // Label 10913: @687076
     /*  687076 */   GIM_Try, /*On fail goto*//*Label 10914*/ GIMT_Encode4(687151), // Rule ID 10879 //
     /*  687081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  687092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  687095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  687098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687127 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687149 */     GIR_RootConstrainSelectedInstOperands,
     /*  687150 */     // GIR_Coverage, 10879,
     /*  687150 */     GIR_EraseRootFromParent_Done,
     /*  687151 */   // Label 10914: @687151
     /*  687151 */   GIM_Try, /*On fail goto*//*Label 10915*/ GIMT_Encode4(687226), // Rule ID 10882 //
     /*  687156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687202 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687224 */     GIR_RootConstrainSelectedInstOperands,
     /*  687225 */     // GIR_Coverage, 10882,
     /*  687225 */     GIR_EraseRootFromParent_Done,
     /*  687226 */   // Label 10915: @687226
     /*  687226 */   GIM_Try, /*On fail goto*//*Label 10916*/ GIMT_Encode4(687301), // Rule ID 10883 //
     /*  687231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  687242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  687245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  687248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687277 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  687280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687299 */     GIR_RootConstrainSelectedInstOperands,
     /*  687300 */     // GIR_Coverage, 10883,
     /*  687300 */     GIR_EraseRootFromParent_Done,
     /*  687301 */   // Label 10916: @687301
     /*  687301 */   GIM_Try, /*On fail goto*//*Label 10917*/ GIMT_Encode4(687376), // Rule ID 10886 //
     /*  687306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687374 */     GIR_RootConstrainSelectedInstOperands,
     /*  687375 */     // GIR_Coverage, 10886,
     /*  687375 */     GIR_EraseRootFromParent_Done,
     /*  687376 */   // Label 10917: @687376
     /*  687376 */   GIM_Try, /*On fail goto*//*Label 10918*/ GIMT_Encode4(687451), // Rule ID 10887 //
     /*  687381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  687392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  687395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  687398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687427 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687449 */     GIR_RootConstrainSelectedInstOperands,
     /*  687450 */     // GIR_Coverage, 10887,
     /*  687450 */     GIR_EraseRootFromParent_Done,
     /*  687451 */   // Label 10918: @687451
     /*  687451 */   GIM_Try, /*On fail goto*//*Label 10919*/ GIMT_Encode4(687526), // Rule ID 10890 //
     /*  687456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  687467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  687470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  687473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  687502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687524 */     GIR_RootConstrainSelectedInstOperands,
     /*  687525 */     // GIR_Coverage, 10890,
     /*  687525 */     GIR_EraseRootFromParent_Done,
     /*  687526 */   // Label 10919: @687526
     /*  687526 */   GIM_Try, /*On fail goto*//*Label 10920*/ GIMT_Encode4(687601), // Rule ID 10891 //
     /*  687531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  687542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  687545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  687548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687577 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  687577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687599 */     GIR_RootConstrainSelectedInstOperands,
     /*  687600 */     // GIR_Coverage, 10891,
     /*  687600 */     GIR_EraseRootFromParent_Done,
     /*  687601 */   // Label 10920: @687601
     /*  687601 */   GIM_Try, /*On fail goto*//*Label 10921*/ GIMT_Encode4(687676), // Rule ID 10894 //
     /*  687606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  687617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  687620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  687623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687674 */     GIR_RootConstrainSelectedInstOperands,
     /*  687675 */     // GIR_Coverage, 10894,
     /*  687675 */     GIR_EraseRootFromParent_Done,
     /*  687676 */   // Label 10921: @687676
     /*  687676 */   GIM_Try, /*On fail goto*//*Label 10922*/ GIMT_Encode4(687751), // Rule ID 10895 //
     /*  687681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  687692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  687695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  687698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687749 */     GIR_RootConstrainSelectedInstOperands,
     /*  687750 */     // GIR_Coverage, 10895,
     /*  687750 */     GIR_EraseRootFromParent_Done,
     /*  687751 */   // Label 10922: @687751
     /*  687751 */   GIM_Try, /*On fail goto*//*Label 10923*/ GIMT_Encode4(687826), // Rule ID 10898 //
     /*  687756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  687767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  687770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  687773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687824 */     GIR_RootConstrainSelectedInstOperands,
     /*  687825 */     // GIR_Coverage, 10898,
     /*  687825 */     GIR_EraseRootFromParent_Done,
     /*  687826 */   // Label 10923: @687826
     /*  687826 */   GIM_Try, /*On fail goto*//*Label 10924*/ GIMT_Encode4(687901), // Rule ID 10899 //
     /*  687831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  687842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  687845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  687848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687899 */     GIR_RootConstrainSelectedInstOperands,
     /*  687900 */     // GIR_Coverage, 10899,
     /*  687900 */     GIR_EraseRootFromParent_Done,
     /*  687901 */   // Label 10924: @687901
     /*  687901 */   GIM_Try, /*On fail goto*//*Label 10925*/ GIMT_Encode4(687976), // Rule ID 10902 //
     /*  687906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  687917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  687920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  687923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  687952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687974 */     GIR_RootConstrainSelectedInstOperands,
     /*  687975 */     // GIR_Coverage, 10902,
     /*  687975 */     GIR_EraseRootFromParent_Done,
     /*  687976 */   // Label 10925: @687976
     /*  687976 */   GIM_Try, /*On fail goto*//*Label 10926*/ GIMT_Encode4(688051), // Rule ID 10903 //
     /*  687981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  687992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  687995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  687998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688049 */     GIR_RootConstrainSelectedInstOperands,
     /*  688050 */     // GIR_Coverage, 10903,
     /*  688050 */     GIR_EraseRootFromParent_Done,
     /*  688051 */   // Label 10926: @688051
     /*  688051 */   GIM_Try, /*On fail goto*//*Label 10927*/ GIMT_Encode4(688126), // Rule ID 10906 //
     /*  688056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  688059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  688102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688124 */     GIR_RootConstrainSelectedInstOperands,
     /*  688125 */     // GIR_Coverage, 10906,
     /*  688125 */     GIR_EraseRootFromParent_Done,
     /*  688126 */   // Label 10927: @688126
     /*  688126 */   GIM_Try, /*On fail goto*//*Label 10928*/ GIMT_Encode4(688201), // Rule ID 10907 //
     /*  688131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  688134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  688142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  688145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  688148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  688166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  688177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  688180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  688196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688199 */     GIR_RootConstrainSelectedInstOperands,
     /*  688200 */     // GIR_Coverage, 10907,
     /*  688200 */     GIR_EraseRootFromParent_Done,
     /*  688201 */   // Label 10928: @688201
     /*  688201 */   GIM_Try, /*On fail goto*//*Label 10929*/ GIMT_Encode4(688276), // Rule ID 10910 //
     /*  688206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688274 */     GIR_RootConstrainSelectedInstOperands,
     /*  688275 */     // GIR_Coverage, 10910,
     /*  688275 */     GIR_EraseRootFromParent_Done,
     /*  688276 */   // Label 10929: @688276
     /*  688276 */   GIM_Try, /*On fail goto*//*Label 10930*/ GIMT_Encode4(688351), // Rule ID 10911 //
     /*  688281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  688292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  688295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  688298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688349 */     GIR_RootConstrainSelectedInstOperands,
     /*  688350 */     // GIR_Coverage, 10911,
     /*  688350 */     GIR_EraseRootFromParent_Done,
     /*  688351 */   // Label 10930: @688351
     /*  688351 */   GIM_Try, /*On fail goto*//*Label 10931*/ GIMT_Encode4(688426), // Rule ID 10914 //
     /*  688356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688424 */     GIR_RootConstrainSelectedInstOperands,
     /*  688425 */     // GIR_Coverage, 10914,
     /*  688425 */     GIR_EraseRootFromParent_Done,
     /*  688426 */   // Label 10931: @688426
     /*  688426 */   GIM_Try, /*On fail goto*//*Label 10932*/ GIMT_Encode4(688501), // Rule ID 10915 //
     /*  688431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  688442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  688445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  688448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688477 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688499 */     GIR_RootConstrainSelectedInstOperands,
     /*  688500 */     // GIR_Coverage, 10915,
     /*  688500 */     GIR_EraseRootFromParent_Done,
     /*  688501 */   // Label 10932: @688501
     /*  688501 */   GIM_Try, /*On fail goto*//*Label 10933*/ GIMT_Encode4(688576), // Rule ID 10918 //
     /*  688506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  688517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  688520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  688523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688552 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  688555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688574 */     GIR_RootConstrainSelectedInstOperands,
     /*  688575 */     // GIR_Coverage, 10918,
     /*  688575 */     GIR_EraseRootFromParent_Done,
     /*  688576 */   // Label 10933: @688576
     /*  688576 */   GIM_Try, /*On fail goto*//*Label 10934*/ GIMT_Encode4(688651), // Rule ID 10919 //
     /*  688581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  688592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  688595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  688598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688627 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  688630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688649 */     GIR_RootConstrainSelectedInstOperands,
     /*  688650 */     // GIR_Coverage, 10919,
     /*  688650 */     GIR_EraseRootFromParent_Done,
     /*  688651 */   // Label 10934: @688651
     /*  688651 */   GIM_Try, /*On fail goto*//*Label 10935*/ GIMT_Encode4(688726), // Rule ID 10922 //
     /*  688656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  688667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  688670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  688673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688724 */     GIR_RootConstrainSelectedInstOperands,
     /*  688725 */     // GIR_Coverage, 10922,
     /*  688725 */     GIR_EraseRootFromParent_Done,
     /*  688726 */   // Label 10935: @688726
     /*  688726 */   GIM_Try, /*On fail goto*//*Label 10936*/ GIMT_Encode4(688801), // Rule ID 10923 //
     /*  688731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  688742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  688745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  688748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688799 */     GIR_RootConstrainSelectedInstOperands,
     /*  688800 */     // GIR_Coverage, 10923,
     /*  688800 */     GIR_EraseRootFromParent_Done,
     /*  688801 */   // Label 10936: @688801
     /*  688801 */   GIM_Try, /*On fail goto*//*Label 10937*/ GIMT_Encode4(688876), // Rule ID 10926 //
     /*  688806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  688817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  688820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  688823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688852 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688874 */     GIR_RootConstrainSelectedInstOperands,
     /*  688875 */     // GIR_Coverage, 10926,
     /*  688875 */     GIR_EraseRootFromParent_Done,
     /*  688876 */   // Label 10937: @688876
     /*  688876 */   GIM_Try, /*On fail goto*//*Label 10938*/ GIMT_Encode4(688951), // Rule ID 10927 //
     /*  688881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  688892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  688895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  688898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688927 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688949 */     GIR_RootConstrainSelectedInstOperands,
     /*  688950 */     // GIR_Coverage, 10927,
     /*  688950 */     GIR_EraseRootFromParent_Done,
     /*  688951 */   // Label 10938: @688951
     /*  688951 */   GIM_Try, /*On fail goto*//*Label 10939*/ GIMT_Encode4(689026), // Rule ID 10930 //
     /*  688956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  688967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  688970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  688973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689024 */     GIR_RootConstrainSelectedInstOperands,
     /*  689025 */     // GIR_Coverage, 10930,
     /*  689025 */     GIR_EraseRootFromParent_Done,
     /*  689026 */   // Label 10939: @689026
     /*  689026 */   GIM_Try, /*On fail goto*//*Label 10940*/ GIMT_Encode4(689101), // Rule ID 10931 //
     /*  689031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  689042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  689045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  689048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689077 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  689077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  689096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689099 */     GIR_RootConstrainSelectedInstOperands,
     /*  689100 */     // GIR_Coverage, 10931,
     /*  689100 */     GIR_EraseRootFromParent_Done,
     /*  689101 */   // Label 10940: @689101
     /*  689101 */   GIM_Try, /*On fail goto*//*Label 10941*/ GIMT_Encode4(689176), // Rule ID 10934 //
     /*  689106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689174 */     GIR_RootConstrainSelectedInstOperands,
     /*  689175 */     // GIR_Coverage, 10934,
     /*  689175 */     GIR_EraseRootFromParent_Done,
     /*  689176 */   // Label 10941: @689176
     /*  689176 */   GIM_Try, /*On fail goto*//*Label 10942*/ GIMT_Encode4(689251), // Rule ID 10935 //
     /*  689181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  689192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  689195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  689198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689227 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689249 */     GIR_RootConstrainSelectedInstOperands,
     /*  689250 */     // GIR_Coverage, 10935,
     /*  689250 */     GIR_EraseRootFromParent_Done,
     /*  689251 */   // Label 10942: @689251
     /*  689251 */   GIM_Try, /*On fail goto*//*Label 10943*/ GIMT_Encode4(689326), // Rule ID 10938 //
     /*  689256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689324 */     GIR_RootConstrainSelectedInstOperands,
     /*  689325 */     // GIR_Coverage, 10938,
     /*  689325 */     GIR_EraseRootFromParent_Done,
     /*  689326 */   // Label 10943: @689326
     /*  689326 */   GIM_Try, /*On fail goto*//*Label 10944*/ GIMT_Encode4(689401), // Rule ID 10939 //
     /*  689331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  689342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  689345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  689348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689377 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689399 */     GIR_RootConstrainSelectedInstOperands,
     /*  689400 */     // GIR_Coverage, 10939,
     /*  689400 */     GIR_EraseRootFromParent_Done,
     /*  689401 */   // Label 10944: @689401
     /*  689401 */   GIM_Try, /*On fail goto*//*Label 10945*/ GIMT_Encode4(689476), // Rule ID 10942 //
     /*  689406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  689452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689474 */     GIR_RootConstrainSelectedInstOperands,
     /*  689475 */     // GIR_Coverage, 10942,
     /*  689475 */     GIR_EraseRootFromParent_Done,
     /*  689476 */   // Label 10945: @689476
     /*  689476 */   GIM_Try, /*On fail goto*//*Label 10946*/ GIMT_Encode4(689551), // Rule ID 10943 //
     /*  689481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  689492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  689495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  689498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689527 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689549 */     GIR_RootConstrainSelectedInstOperands,
     /*  689550 */     // GIR_Coverage, 10943,
     /*  689550 */     GIR_EraseRootFromParent_Done,
     /*  689551 */   // Label 10946: @689551
     /*  689551 */   GIM_Try, /*On fail goto*//*Label 10947*/ GIMT_Encode4(689626), // Rule ID 10946 //
     /*  689556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  689567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  689570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  689573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689624 */     GIR_RootConstrainSelectedInstOperands,
     /*  689625 */     // GIR_Coverage, 10946,
     /*  689625 */     GIR_EraseRootFromParent_Done,
     /*  689626 */   // Label 10947: @689626
     /*  689626 */   GIM_Try, /*On fail goto*//*Label 10948*/ GIMT_Encode4(689701), // Rule ID 10947 //
     /*  689631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  689642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  689645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  689648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689699 */     GIR_RootConstrainSelectedInstOperands,
     /*  689700 */     // GIR_Coverage, 10947,
     /*  689700 */     GIR_EraseRootFromParent_Done,
     /*  689701 */   // Label 10948: @689701
     /*  689701 */   GIM_Try, /*On fail goto*//*Label 10949*/ GIMT_Encode4(689776), // Rule ID 10950 //
     /*  689706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  689717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  689720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  689723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689774 */     GIR_RootConstrainSelectedInstOperands,
     /*  689775 */     // GIR_Coverage, 10950,
     /*  689775 */     GIR_EraseRootFromParent_Done,
     /*  689776 */   // Label 10949: @689776
     /*  689776 */   GIM_Try, /*On fail goto*//*Label 10950*/ GIMT_Encode4(689851), // Rule ID 10951 //
     /*  689781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  689792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  689795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  689798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689827 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689849 */     GIR_RootConstrainSelectedInstOperands,
     /*  689850 */     // GIR_Coverage, 10951,
     /*  689850 */     GIR_EraseRootFromParent_Done,
     /*  689851 */   // Label 10950: @689851
     /*  689851 */   GIM_Try, /*On fail goto*//*Label 10951*/ GIMT_Encode4(689926), // Rule ID 10954 //
     /*  689856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  689867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  689870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  689873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689902 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689924 */     GIR_RootConstrainSelectedInstOperands,
     /*  689925 */     // GIR_Coverage, 10954,
     /*  689925 */     GIR_EraseRootFromParent_Done,
     /*  689926 */   // Label 10951: @689926
     /*  689926 */   GIM_Try, /*On fail goto*//*Label 10952*/ GIMT_Encode4(690001), // Rule ID 10955 //
     /*  689931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  689942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  689945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  689948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689977 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11414:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689999 */     GIR_RootConstrainSelectedInstOperands,
     /*  690000 */     // GIR_Coverage, 10955,
     /*  690000 */     GIR_EraseRootFromParent_Done,
     /*  690001 */   // Label 10952: @690001
     /*  690001 */   GIM_Try, /*On fail goto*//*Label 10953*/ GIMT_Encode4(690076), // Rule ID 10958 //
     /*  690006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  690026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  690055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690074 */     GIR_RootConstrainSelectedInstOperands,
     /*  690075 */     // GIR_Coverage, 10958,
     /*  690075 */     GIR_EraseRootFromParent_Done,
     /*  690076 */   // Label 10953: @690076
     /*  690076 */   GIM_Try, /*On fail goto*//*Label 10954*/ GIMT_Encode4(690151), // Rule ID 10959 //
     /*  690081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  690092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  690095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  690098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  690101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690127 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  690130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690149 */     GIR_RootConstrainSelectedInstOperands,
     /*  690150 */     // GIR_Coverage, 10959,
     /*  690150 */     GIR_EraseRootFromParent_Done,
     /*  690151 */   // Label 10954: @690151
     /*  690151 */   GIM_Try, /*On fail goto*//*Label 10955*/ GIMT_Encode4(690226), // Rule ID 10962 //
     /*  690156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  690176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690202 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690224 */     GIR_RootConstrainSelectedInstOperands,
     /*  690225 */     // GIR_Coverage, 10962,
     /*  690225 */     GIR_EraseRootFromParent_Done,
     /*  690226 */   // Label 10955: @690226
     /*  690226 */   GIM_Try, /*On fail goto*//*Label 10956*/ GIMT_Encode4(690301), // Rule ID 10963 //
     /*  690231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  690242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  690245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  690248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  690251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690277 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690299 */     GIR_RootConstrainSelectedInstOperands,
     /*  690300 */     // GIR_Coverage, 10963,
     /*  690300 */     GIR_EraseRootFromParent_Done,
     /*  690301 */   // Label 10956: @690301
     /*  690301 */   GIM_Try, /*On fail goto*//*Label 10957*/ GIMT_Encode4(690376), // Rule ID 10966 //
     /*  690306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  690326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690374 */     GIR_RootConstrainSelectedInstOperands,
     /*  690375 */     // GIR_Coverage, 10966,
     /*  690375 */     GIR_EraseRootFromParent_Done,
     /*  690376 */   // Label 10957: @690376
     /*  690376 */   GIM_Try, /*On fail goto*//*Label 10958*/ GIMT_Encode4(690451), // Rule ID 10967 //
     /*  690381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  690392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  690395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  690398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  690401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690427 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690449 */     GIR_RootConstrainSelectedInstOperands,
     /*  690450 */     // GIR_Coverage, 10967,
     /*  690450 */     GIR_EraseRootFromParent_Done,
     /*  690451 */   // Label 10958: @690451
     /*  690451 */   GIM_Try, /*On fail goto*//*Label 10959*/ GIMT_Encode4(690526), // Rule ID 10970 //
     /*  690456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  690467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  690470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  690473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  690476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690524 */     GIR_RootConstrainSelectedInstOperands,
     /*  690525 */     // GIR_Coverage, 10970,
     /*  690525 */     GIR_EraseRootFromParent_Done,
     /*  690526 */   // Label 10959: @690526
     /*  690526 */   GIM_Try, /*On fail goto*//*Label 10960*/ GIMT_Encode4(690601), // Rule ID 10971 //
     /*  690531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  690542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  690545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  690548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  690551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690577 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690599 */     GIR_RootConstrainSelectedInstOperands,
     /*  690600 */     // GIR_Coverage, 10971,
     /*  690600 */     GIR_EraseRootFromParent_Done,
     /*  690601 */   // Label 10960: @690601
     /*  690601 */   GIM_Try, /*On fail goto*//*Label 10961*/ GIMT_Encode4(690676), // Rule ID 10974 //
     /*  690606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  690617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  690620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  690623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  690626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690674 */     GIR_RootConstrainSelectedInstOperands,
     /*  690675 */     // GIR_Coverage, 10974,
     /*  690675 */     GIR_EraseRootFromParent_Done,
     /*  690676 */   // Label 10961: @690676
     /*  690676 */   GIM_Try, /*On fail goto*//*Label 10962*/ GIMT_Encode4(690751), // Rule ID 10975 //
     /*  690681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  690692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  690695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  690698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  690701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690727 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690749 */     GIR_RootConstrainSelectedInstOperands,
     /*  690750 */     // GIR_Coverage, 10975,
     /*  690750 */     GIR_EraseRootFromParent_Done,
     /*  690751 */   // Label 10962: @690751
     /*  690751 */   GIM_Try, /*On fail goto*//*Label 10963*/ GIMT_Encode4(690826), // Rule ID 10978 //
     /*  690756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  690767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  690770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  690773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  690776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  690802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690824 */     GIR_RootConstrainSelectedInstOperands,
     /*  690825 */     // GIR_Coverage, 10978,
     /*  690825 */     GIR_EraseRootFromParent_Done,
     /*  690826 */   // Label 10963: @690826
     /*  690826 */   GIM_Try, /*On fail goto*//*Label 10964*/ GIMT_Encode4(690901), // Rule ID 10979 //
     /*  690831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  690842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  690845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  690848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  690851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690877 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690899 */     GIR_RootConstrainSelectedInstOperands,
     /*  690900 */     // GIR_Coverage, 10979,
     /*  690900 */     GIR_EraseRootFromParent_Done,
     /*  690901 */   // Label 10964: @690901
     /*  690901 */   GIM_Try, /*On fail goto*//*Label 10965*/ GIMT_Encode4(690976), // Rule ID 10982 //
     /*  690906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  690917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  690920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  690923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  690926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690974 */     GIR_RootConstrainSelectedInstOperands,
     /*  690975 */     // GIR_Coverage, 10982,
     /*  690975 */     GIR_EraseRootFromParent_Done,
     /*  690976 */   // Label 10965: @690976
     /*  690976 */   GIM_Try, /*On fail goto*//*Label 10966*/ GIMT_Encode4(691051), // Rule ID 10983 //
     /*  690981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  690992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  690995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  690998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  691001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691049 */     GIR_RootConstrainSelectedInstOperands,
     /*  691050 */     // GIR_Coverage, 10983,
     /*  691050 */     GIR_EraseRootFromParent_Done,
     /*  691051 */   // Label 10966: @691051
     /*  691051 */   GIM_Try, /*On fail goto*//*Label 10967*/ GIMT_Encode4(691126), // Rule ID 10986 //
     /*  691056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  691076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691124 */     GIR_RootConstrainSelectedInstOperands,
     /*  691125 */     // GIR_Coverage, 10986,
     /*  691125 */     GIR_EraseRootFromParent_Done,
     /*  691126 */   // Label 10967: @691126
     /*  691126 */   GIM_Try, /*On fail goto*//*Label 10968*/ GIMT_Encode4(691201), // Rule ID 10987 //
     /*  691131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  691142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  691145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  691148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  691151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691199 */     GIR_RootConstrainSelectedInstOperands,
     /*  691200 */     // GIR_Coverage, 10987,
     /*  691200 */     GIR_EraseRootFromParent_Done,
     /*  691201 */   // Label 10968: @691201
     /*  691201 */   GIM_Try, /*On fail goto*//*Label 10969*/ GIMT_Encode4(691276), // Rule ID 10990 //
     /*  691206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  691226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691274 */     GIR_RootConstrainSelectedInstOperands,
     /*  691275 */     // GIR_Coverage, 10990,
     /*  691275 */     GIR_EraseRootFromParent_Done,
     /*  691276 */   // Label 10969: @691276
     /*  691276 */   GIM_Try, /*On fail goto*//*Label 10970*/ GIMT_Encode4(691351), // Rule ID 10991 //
     /*  691281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  691292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  691295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  691298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  691301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  691327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691349 */     GIR_RootConstrainSelectedInstOperands,
     /*  691350 */     // GIR_Coverage, 10991,
     /*  691350 */     GIR_EraseRootFromParent_Done,
     /*  691351 */   // Label 10970: @691351
     /*  691351 */   GIM_Try, /*On fail goto*//*Label 10971*/ GIMT_Encode4(691426), // Rule ID 10994 //
     /*  691356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  691359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  691376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  691402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691424 */     GIR_RootConstrainSelectedInstOperands,
     /*  691425 */     // GIR_Coverage, 10994,
     /*  691425 */     GIR_EraseRootFromParent_Done,
     /*  691426 */   // Label 10971: @691426
     /*  691426 */   GIM_Try, /*On fail goto*//*Label 10972*/ GIMT_Encode4(691501), // Rule ID 10995 //
     /*  691431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  691434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  691442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  691445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  691448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  691451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  691470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691477 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  691477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  691480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  691496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691499 */     GIR_RootConstrainSelectedInstOperands,
     /*  691500 */     // GIR_Coverage, 10995,
     /*  691500 */     GIR_EraseRootFromParent_Done,
     /*  691501 */   // Label 10972: @691501
     /*  691501 */   GIM_Try, /*On fail goto*//*Label 10973*/ GIMT_Encode4(691576), // Rule ID 10998 //
     /*  691506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  691517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  691520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  691523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  691526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  691555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691574 */     GIR_RootConstrainSelectedInstOperands,
     /*  691575 */     // GIR_Coverage, 10998,
     /*  691575 */     GIR_EraseRootFromParent_Done,
     /*  691576 */   // Label 10973: @691576
     /*  691576 */   GIM_Try, /*On fail goto*//*Label 10974*/ GIMT_Encode4(691651), // Rule ID 10999 //
     /*  691581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  691592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  691595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  691598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  691601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691627 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  691630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691649 */     GIR_RootConstrainSelectedInstOperands,
     /*  691650 */     // GIR_Coverage, 10999,
     /*  691650 */     GIR_EraseRootFromParent_Done,
     /*  691651 */   // Label 10974: @691651
     /*  691651 */   GIM_Try, /*On fail goto*//*Label 10975*/ GIMT_Encode4(691726), // Rule ID 11002 //
     /*  691656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  691667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  691670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  691673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  691676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  691705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691724 */     GIR_RootConstrainSelectedInstOperands,
     /*  691725 */     // GIR_Coverage, 11002,
     /*  691725 */     GIR_EraseRootFromParent_Done,
     /*  691726 */   // Label 10975: @691726
     /*  691726 */   GIM_Try, /*On fail goto*//*Label 10976*/ GIMT_Encode4(691801), // Rule ID 11003 //
     /*  691731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  691742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  691745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  691748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  691751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691777 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  691780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691799 */     GIR_RootConstrainSelectedInstOperands,
     /*  691800 */     // GIR_Coverage, 11003,
     /*  691800 */     GIR_EraseRootFromParent_Done,
     /*  691801 */   // Label 10976: @691801
     /*  691801 */   GIM_Try, /*On fail goto*//*Label 10977*/ GIMT_Encode4(691876), // Rule ID 11006 //
     /*  691806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  691817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  691820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  691823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  691826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691852 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  691855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691874 */     GIR_RootConstrainSelectedInstOperands,
     /*  691875 */     // GIR_Coverage, 11006,
     /*  691875 */     GIR_EraseRootFromParent_Done,
     /*  691876 */   // Label 10977: @691876
     /*  691876 */   GIM_Try, /*On fail goto*//*Label 10978*/ GIMT_Encode4(691951), // Rule ID 11007 //
     /*  691881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  691892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  691895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  691898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  691901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691927 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  691930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691949 */     GIR_RootConstrainSelectedInstOperands,
     /*  691950 */     // GIR_Coverage, 11007,
     /*  691950 */     GIR_EraseRootFromParent_Done,
     /*  691951 */   // Label 10978: @691951
     /*  691951 */   GIM_Try, /*On fail goto*//*Label 10979*/ GIMT_Encode4(692026), // Rule ID 11010 //
     /*  691956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  691967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  691970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  691973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  691976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692024 */     GIR_RootConstrainSelectedInstOperands,
     /*  692025 */     // GIR_Coverage, 11010,
     /*  692025 */     GIR_EraseRootFromParent_Done,
     /*  692026 */   // Label 10979: @692026
     /*  692026 */   GIM_Try, /*On fail goto*//*Label 10980*/ GIMT_Encode4(692101), // Rule ID 11011 //
     /*  692031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  692042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  692045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  692048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  692051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692099 */     GIR_RootConstrainSelectedInstOperands,
     /*  692100 */     // GIR_Coverage, 11011,
     /*  692100 */     GIR_EraseRootFromParent_Done,
     /*  692101 */   // Label 10980: @692101
     /*  692101 */   GIM_Try, /*On fail goto*//*Label 10981*/ GIMT_Encode4(692176), // Rule ID 11014 //
     /*  692106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  692126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692174 */     GIR_RootConstrainSelectedInstOperands,
     /*  692175 */     // GIR_Coverage, 11014,
     /*  692175 */     GIR_EraseRootFromParent_Done,
     /*  692176 */   // Label 10981: @692176
     /*  692176 */   GIM_Try, /*On fail goto*//*Label 10982*/ GIMT_Encode4(692251), // Rule ID 11015 //
     /*  692181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  692192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  692195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  692198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  692201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692227 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692249 */     GIR_RootConstrainSelectedInstOperands,
     /*  692250 */     // GIR_Coverage, 11015,
     /*  692250 */     GIR_EraseRootFromParent_Done,
     /*  692251 */   // Label 10982: @692251
     /*  692251 */   GIM_Try, /*On fail goto*//*Label 10983*/ GIMT_Encode4(692326), // Rule ID 11018 //
     /*  692256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  692276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692302 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  692302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692324 */     GIR_RootConstrainSelectedInstOperands,
     /*  692325 */     // GIR_Coverage, 11018,
     /*  692325 */     GIR_EraseRootFromParent_Done,
     /*  692326 */   // Label 10983: @692326
     /*  692326 */   GIM_Try, /*On fail goto*//*Label 10984*/ GIMT_Encode4(692401), // Rule ID 11019 //
     /*  692331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  692342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  692345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  692348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  692351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  692377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  692396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692399 */     GIR_RootConstrainSelectedInstOperands,
     /*  692400 */     // GIR_Coverage, 11019,
     /*  692400 */     GIR_EraseRootFromParent_Done,
     /*  692401 */   // Label 10984: @692401
     /*  692401 */   GIM_Try, /*On fail goto*//*Label 10985*/ GIMT_Encode4(692476), // Rule ID 11022 //
     /*  692406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  692426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692474 */     GIR_RootConstrainSelectedInstOperands,
     /*  692475 */     // GIR_Coverage, 11022,
     /*  692475 */     GIR_EraseRootFromParent_Done,
     /*  692476 */   // Label 10985: @692476
     /*  692476 */   GIM_Try, /*On fail goto*//*Label 10986*/ GIMT_Encode4(692551), // Rule ID 11023 //
     /*  692481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  692492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  692495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  692498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  692501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692549 */     GIR_RootConstrainSelectedInstOperands,
     /*  692550 */     // GIR_Coverage, 11023,
     /*  692550 */     GIR_EraseRootFromParent_Done,
     /*  692551 */   // Label 10986: @692551
     /*  692551 */   GIM_Try, /*On fail goto*//*Label 10987*/ GIMT_Encode4(692626), // Rule ID 11026 //
     /*  692556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  692567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  692570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  692573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  692576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692624 */     GIR_RootConstrainSelectedInstOperands,
     /*  692625 */     // GIR_Coverage, 11026,
     /*  692625 */     GIR_EraseRootFromParent_Done,
     /*  692626 */   // Label 10987: @692626
     /*  692626 */   GIM_Try, /*On fail goto*//*Label 10988*/ GIMT_Encode4(692701), // Rule ID 11027 //
     /*  692631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  692642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  692645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  692648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  692651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692677 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692699 */     GIR_RootConstrainSelectedInstOperands,
     /*  692700 */     // GIR_Coverage, 11027,
     /*  692700 */     GIR_EraseRootFromParent_Done,
     /*  692701 */   // Label 10988: @692701
     /*  692701 */   GIM_Try, /*On fail goto*//*Label 10989*/ GIMT_Encode4(692776), // Rule ID 11030 //
     /*  692706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  692717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  692720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  692723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  692726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692774 */     GIR_RootConstrainSelectedInstOperands,
     /*  692775 */     // GIR_Coverage, 11030,
     /*  692775 */     GIR_EraseRootFromParent_Done,
     /*  692776 */   // Label 10989: @692776
     /*  692776 */   GIM_Try, /*On fail goto*//*Label 10990*/ GIMT_Encode4(692851), // Rule ID 11031 //
     /*  692781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  692792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  692795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  692798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  692801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692827 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692849 */     GIR_RootConstrainSelectedInstOperands,
     /*  692850 */     // GIR_Coverage, 11031,
     /*  692850 */     GIR_EraseRootFromParent_Done,
     /*  692851 */   // Label 10990: @692851
     /*  692851 */   GIM_Try, /*On fail goto*//*Label 10991*/ GIMT_Encode4(692926), // Rule ID 11034 //
     /*  692856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  692859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  692867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  692870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  692873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  692876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  692902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692924 */     GIR_RootConstrainSelectedInstOperands,
     /*  692925 */     // GIR_Coverage, 11034,
     /*  692925 */     GIR_EraseRootFromParent_Done,
     /*  692926 */   // Label 10991: @692926
     /*  692926 */   GIM_Try, /*On fail goto*//*Label 10992*/ GIMT_Encode4(693001), // Rule ID 11035 //
     /*  692931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  692934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  692942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  692945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  692948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  692951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  692977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692999 */     GIR_RootConstrainSelectedInstOperands,
     /*  693000 */     // GIR_Coverage, 11035,
     /*  693000 */     GIR_EraseRootFromParent_Done,
     /*  693001 */   // Label 10992: @693001
     /*  693001 */   GIM_Try, /*On fail goto*//*Label 10993*/ GIMT_Encode4(693076), // Rule ID 11038 //
     /*  693006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  693026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693074 */     GIR_RootConstrainSelectedInstOperands,
     /*  693075 */     // GIR_Coverage, 11038,
     /*  693075 */     GIR_EraseRootFromParent_Done,
     /*  693076 */   // Label 10993: @693076
     /*  693076 */   GIM_Try, /*On fail goto*//*Label 10994*/ GIMT_Encode4(693151), // Rule ID 11039 //
     /*  693081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  693092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  693095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  693098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  693101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  693120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  693130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693149 */     GIR_RootConstrainSelectedInstOperands,
     /*  693150 */     // GIR_Coverage, 11039,
     /*  693150 */     GIR_EraseRootFromParent_Done,
     /*  693151 */   // Label 10994: @693151
     /*  693151 */   GIM_Try, /*On fail goto*//*Label 10995*/ GIMT_Encode4(693226), // Rule ID 11042 //
     /*  693156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  693159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  693176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  693202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693224 */     GIR_RootConstrainSelectedInstOperands,
     /*  693225 */     // GIR_Coverage, 11042,
     /*  693225 */     GIR_EraseRootFromParent_Done,
     /*  693226 */   // Label 10995: @693226
     /*  693226 */   GIM_Try, /*On fail goto*//*Label 10996*/ GIMT_Encode4(693301), // Rule ID 11043 //
     /*  693231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  693234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  693242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  693245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  693248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  693251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  693270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693277 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  693277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  693280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  693296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693299 */     GIR_RootConstrainSelectedInstOperands,
     /*  693300 */     // GIR_Coverage, 11043,
     /*  693300 */     GIR_EraseRootFromParent_Done,
     /*  693301 */   // Label 10996: @693301
     /*  693301 */   GIM_Try, /*On fail goto*//*Label 10997*/ GIMT_Encode4(693376), // Rule ID 11046 //
     /*  693306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  693355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693374 */     GIR_RootConstrainSelectedInstOperands,
     /*  693375 */     // GIR_Coverage, 11046,
     /*  693375 */     GIR_EraseRootFromParent_Done,
     /*  693376 */   // Label 10997: @693376
     /*  693376 */   GIM_Try, /*On fail goto*//*Label 10998*/ GIMT_Encode4(693451), // Rule ID 11047 //
     /*  693381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  693392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  693395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  693398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693427 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  693430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693449 */     GIR_RootConstrainSelectedInstOperands,
     /*  693450 */     // GIR_Coverage, 11047,
     /*  693450 */     GIR_EraseRootFromParent_Done,
     /*  693451 */   // Label 10998: @693451
     /*  693451 */   GIM_Try, /*On fail goto*//*Label 10999*/ GIMT_Encode4(693526), // Rule ID 11050 //
     /*  693456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  693467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  693470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  693473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693524 */     GIR_RootConstrainSelectedInstOperands,
     /*  693525 */     // GIR_Coverage, 11050,
     /*  693525 */     GIR_EraseRootFromParent_Done,
     /*  693526 */   // Label 10999: @693526
     /*  693526 */   GIM_Try, /*On fail goto*//*Label 11000*/ GIMT_Encode4(693601), // Rule ID 11051 //
     /*  693531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  693542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  693545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  693548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693577 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693599 */     GIR_RootConstrainSelectedInstOperands,
     /*  693600 */     // GIR_Coverage, 11051,
     /*  693600 */     GIR_EraseRootFromParent_Done,
     /*  693601 */   // Label 11000: @693601
     /*  693601 */   GIM_Try, /*On fail goto*//*Label 11001*/ GIMT_Encode4(693676), // Rule ID 11054 //
     /*  693606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  693617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  693620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  693623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693652 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693674 */     GIR_RootConstrainSelectedInstOperands,
     /*  693675 */     // GIR_Coverage, 11054,
     /*  693675 */     GIR_EraseRootFromParent_Done,
     /*  693676 */   // Label 11001: @693676
     /*  693676 */   GIM_Try, /*On fail goto*//*Label 11002*/ GIMT_Encode4(693751), // Rule ID 11055 //
     /*  693681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  693692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  693695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  693698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693727 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693749 */     GIR_RootConstrainSelectedInstOperands,
     /*  693750 */     // GIR_Coverage, 11055,
     /*  693750 */     GIR_EraseRootFromParent_Done,
     /*  693751 */   // Label 11002: @693751
     /*  693751 */   GIM_Try, /*On fail goto*//*Label 11003*/ GIMT_Encode4(693826), // Rule ID 11058 //
     /*  693756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  693767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  693770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  693773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  693802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693824 */     GIR_RootConstrainSelectedInstOperands,
     /*  693825 */     // GIR_Coverage, 11058,
     /*  693825 */     GIR_EraseRootFromParent_Done,
     /*  693826 */   // Label 11003: @693826
     /*  693826 */   GIM_Try, /*On fail goto*//*Label 11004*/ GIMT_Encode4(693901), // Rule ID 11059 //
     /*  693831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  693842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  693845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  693848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  693877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693899 */     GIR_RootConstrainSelectedInstOperands,
     /*  693900 */     // GIR_Coverage, 11059,
     /*  693900 */     GIR_EraseRootFromParent_Done,
     /*  693901 */   // Label 11004: @693901
     /*  693901 */   GIM_Try, /*On fail goto*//*Label 11005*/ GIMT_Encode4(693976), // Rule ID 11062 //
     /*  693906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  693917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  693920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  693923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693952 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  693952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693974 */     GIR_RootConstrainSelectedInstOperands,
     /*  693975 */     // GIR_Coverage, 11062,
     /*  693975 */     GIR_EraseRootFromParent_Done,
     /*  693976 */   // Label 11005: @693976
     /*  693976 */   GIM_Try, /*On fail goto*//*Label 11006*/ GIMT_Encode4(694051), // Rule ID 11063 //
     /*  693981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  693992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  693995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  693998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694027 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694049 */     GIR_RootConstrainSelectedInstOperands,
     /*  694050 */     // GIR_Coverage, 11063,
     /*  694050 */     GIR_EraseRootFromParent_Done,
     /*  694051 */   // Label 11006: @694051
     /*  694051 */   GIM_Try, /*On fail goto*//*Label 11007*/ GIMT_Encode4(694126), // Rule ID 11066 //
     /*  694056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694124 */     GIR_RootConstrainSelectedInstOperands,
     /*  694125 */     // GIR_Coverage, 11066,
     /*  694125 */     GIR_EraseRootFromParent_Done,
     /*  694126 */   // Label 11007: @694126
     /*  694126 */   GIM_Try, /*On fail goto*//*Label 11008*/ GIMT_Encode4(694201), // Rule ID 11067 //
     /*  694131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  694142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  694145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  694148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694177 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  694180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694199 */     GIR_RootConstrainSelectedInstOperands,
     /*  694200 */     // GIR_Coverage, 11067,
     /*  694200 */     GIR_EraseRootFromParent_Done,
     /*  694201 */   // Label 11008: @694201
     /*  694201 */   GIM_Try, /*On fail goto*//*Label 11009*/ GIMT_Encode4(694276), // Rule ID 11070 //
     /*  694206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694274 */     GIR_RootConstrainSelectedInstOperands,
     /*  694275 */     // GIR_Coverage, 11070,
     /*  694275 */     GIR_EraseRootFromParent_Done,
     /*  694276 */   // Label 11009: @694276
     /*  694276 */   GIM_Try, /*On fail goto*//*Label 11010*/ GIMT_Encode4(694351), // Rule ID 11071 //
     /*  694281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  694292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  694295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  694298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11469:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694349 */     GIR_RootConstrainSelectedInstOperands,
     /*  694350 */     // GIR_Coverage, 11071,
     /*  694350 */     GIR_EraseRootFromParent_Done,
     /*  694351 */   // Label 11010: @694351
     /*  694351 */   GIM_Try, /*On fail goto*//*Label 11011*/ GIMT_Encode4(694426), // Rule ID 11074 //
     /*  694356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694424 */     GIR_RootConstrainSelectedInstOperands,
     /*  694425 */     // GIR_Coverage, 11074,
     /*  694425 */     GIR_EraseRootFromParent_Done,
     /*  694426 */   // Label 11011: @694426
     /*  694426 */   GIM_Try, /*On fail goto*//*Label 11012*/ GIMT_Encode4(694501), // Rule ID 11075 //
     /*  694431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  694442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  694445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  694448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11469:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694499 */     GIR_RootConstrainSelectedInstOperands,
     /*  694500 */     // GIR_Coverage, 11075,
     /*  694500 */     GIR_EraseRootFromParent_Done,
     /*  694501 */   // Label 11012: @694501
     /*  694501 */   GIM_Try, /*On fail goto*//*Label 11013*/ GIMT_Encode4(694576), // Rule ID 11078 //
     /*  694506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694574 */     GIR_RootConstrainSelectedInstOperands,
     /*  694575 */     // GIR_Coverage, 11078,
     /*  694575 */     GIR_EraseRootFromParent_Done,
     /*  694576 */   // Label 11013: @694576
     /*  694576 */   GIM_Try, /*On fail goto*//*Label 11014*/ GIMT_Encode4(694651), // Rule ID 11079 //
     /*  694581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11469:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694649 */     GIR_RootConstrainSelectedInstOperands,
     /*  694650 */     // GIR_Coverage, 11079,
     /*  694650 */     GIR_EraseRootFromParent_Done,
     /*  694651 */   // Label 11014: @694651
     /*  694651 */   GIM_Try, /*On fail goto*//*Label 11015*/ GIMT_Encode4(694726), // Rule ID 11082 //
     /*  694656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  694659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  694667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  694670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  694673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  694702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  694721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694724 */     GIR_RootConstrainSelectedInstOperands,
     /*  694725 */     // GIR_Coverage, 11082,
     /*  694725 */     GIR_EraseRootFromParent_Done,
     /*  694726 */   // Label 11015: @694726
     /*  694726 */   GIM_Try, /*On fail goto*//*Label 11016*/ GIMT_Encode4(694801), // Rule ID 11083 //
     /*  694731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  694734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  694742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  694745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  694748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694777 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11469:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  694777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  694796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694799 */     GIR_RootConstrainSelectedInstOperands,
     /*  694800 */     // GIR_Coverage, 11083,
     /*  694800 */     GIR_EraseRootFromParent_Done,
     /*  694801 */   // Label 11016: @694801
     /*  694801 */   GIM_Try, /*On fail goto*//*Label 11017*/ GIMT_Encode4(694876), // Rule ID 11086 //
     /*  694806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  694817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  694820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  694823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  694855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694874 */     GIR_RootConstrainSelectedInstOperands,
     /*  694875 */     // GIR_Coverage, 11086,
     /*  694875 */     GIR_EraseRootFromParent_Done,
     /*  694876 */   // Label 11017: @694876
     /*  694876 */   GIM_Try, /*On fail goto*//*Label 11018*/ GIMT_Encode4(694951), // Rule ID 11087 //
     /*  694881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  694892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  694895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  694898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694927 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  694930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694949 */     GIR_RootConstrainSelectedInstOperands,
     /*  694950 */     // GIR_Coverage, 11087,
     /*  694950 */     GIR_EraseRootFromParent_Done,
     /*  694951 */   // Label 11018: @694951
     /*  694951 */   GIM_Try, /*On fail goto*//*Label 11019*/ GIMT_Encode4(695026), // Rule ID 11090 //
     /*  694956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  694967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  694970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  694973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695024 */     GIR_RootConstrainSelectedInstOperands,
     /*  695025 */     // GIR_Coverage, 11090,
     /*  695025 */     GIR_EraseRootFromParent_Done,
     /*  695026 */   // Label 11019: @695026
     /*  695026 */   GIM_Try, /*On fail goto*//*Label 11020*/ GIMT_Encode4(695101), // Rule ID 11091 //
     /*  695031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  695042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  695045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  695048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695077 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695099 */     GIR_RootConstrainSelectedInstOperands,
     /*  695100 */     // GIR_Coverage, 11091,
     /*  695100 */     GIR_EraseRootFromParent_Done,
     /*  695101 */   // Label 11020: @695101
     /*  695101 */   GIM_Try, /*On fail goto*//*Label 11021*/ GIMT_Encode4(695176), // Rule ID 11094 //
     /*  695106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  695152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695174 */     GIR_RootConstrainSelectedInstOperands,
     /*  695175 */     // GIR_Coverage, 11094,
     /*  695175 */     GIR_EraseRootFromParent_Done,
     /*  695176 */   // Label 11021: @695176
     /*  695176 */   GIM_Try, /*On fail goto*//*Label 11022*/ GIMT_Encode4(695251), // Rule ID 11095 //
     /*  695181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  695192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  695195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  695198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695227 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  695227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  695246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695249 */     GIR_RootConstrainSelectedInstOperands,
     /*  695250 */     // GIR_Coverage, 11095,
     /*  695250 */     GIR_EraseRootFromParent_Done,
     /*  695251 */   // Label 11022: @695251
     /*  695251 */   GIM_Try, /*On fail goto*//*Label 11023*/ GIMT_Encode4(695326), // Rule ID 11098 //
     /*  695256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695324 */     GIR_RootConstrainSelectedInstOperands,
     /*  695325 */     // GIR_Coverage, 11098,
     /*  695325 */     GIR_EraseRootFromParent_Done,
     /*  695326 */   // Label 11023: @695326
     /*  695326 */   GIM_Try, /*On fail goto*//*Label 11024*/ GIMT_Encode4(695401), // Rule ID 11099 //
     /*  695331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  695342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  695345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  695348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695399 */     GIR_RootConstrainSelectedInstOperands,
     /*  695400 */     // GIR_Coverage, 11099,
     /*  695400 */     GIR_EraseRootFromParent_Done,
     /*  695401 */   // Label 11024: @695401
     /*  695401 */   GIM_Try, /*On fail goto*//*Label 11025*/ GIMT_Encode4(695476), // Rule ID 11102 //
     /*  695406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695474 */     GIR_RootConstrainSelectedInstOperands,
     /*  695475 */     // GIR_Coverage, 11102,
     /*  695475 */     GIR_EraseRootFromParent_Done,
     /*  695476 */   // Label 11025: @695476
     /*  695476 */   GIM_Try, /*On fail goto*//*Label 11026*/ GIMT_Encode4(695551), // Rule ID 11103 //
     /*  695481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  695492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  695495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  695498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695527 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695549 */     GIR_RootConstrainSelectedInstOperands,
     /*  695550 */     // GIR_Coverage, 11103,
     /*  695550 */     GIR_EraseRootFromParent_Done,
     /*  695551 */   // Label 11026: @695551
     /*  695551 */   GIM_Try, /*On fail goto*//*Label 11027*/ GIMT_Encode4(695626), // Rule ID 11106 //
     /*  695556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  695567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  695570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  695573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695624 */     GIR_RootConstrainSelectedInstOperands,
     /*  695625 */     // GIR_Coverage, 11106,
     /*  695625 */     GIR_EraseRootFromParent_Done,
     /*  695626 */   // Label 11027: @695626
     /*  695626 */   GIM_Try, /*On fail goto*//*Label 11028*/ GIMT_Encode4(695701), // Rule ID 11107 //
     /*  695631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  695642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  695645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  695648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695677 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695699 */     GIR_RootConstrainSelectedInstOperands,
     /*  695700 */     // GIR_Coverage, 11107,
     /*  695700 */     GIR_EraseRootFromParent_Done,
     /*  695701 */   // Label 11028: @695701
     /*  695701 */   GIM_Try, /*On fail goto*//*Label 11029*/ GIMT_Encode4(695776), // Rule ID 11110 //
     /*  695706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  695717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  695720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  695723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695774 */     GIR_RootConstrainSelectedInstOperands,
     /*  695775 */     // GIR_Coverage, 11110,
     /*  695775 */     GIR_EraseRootFromParent_Done,
     /*  695776 */   // Label 11029: @695776
     /*  695776 */   GIM_Try, /*On fail goto*//*Label 11030*/ GIMT_Encode4(695851), // Rule ID 11111 //
     /*  695781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  695792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  695795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  695798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695849 */     GIR_RootConstrainSelectedInstOperands,
     /*  695850 */     // GIR_Coverage, 11111,
     /*  695850 */     GIR_EraseRootFromParent_Done,
     /*  695851 */   // Label 11030: @695851
     /*  695851 */   GIM_Try, /*On fail goto*//*Label 11031*/ GIMT_Encode4(695926), // Rule ID 11114 //
     /*  695856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  695867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  695870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  695873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695924 */     GIR_RootConstrainSelectedInstOperands,
     /*  695925 */     // GIR_Coverage, 11114,
     /*  695925 */     GIR_EraseRootFromParent_Done,
     /*  695926 */   // Label 11031: @695926
     /*  695926 */   GIM_Try, /*On fail goto*//*Label 11032*/ GIMT_Encode4(696001), // Rule ID 11115 //
     /*  695931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  695942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  695945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  695948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695977 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695999 */     GIR_RootConstrainSelectedInstOperands,
     /*  696000 */     // GIR_Coverage, 11115,
     /*  696000 */     GIR_EraseRootFromParent_Done,
     /*  696001 */   // Label 11032: @696001
     /*  696001 */   GIM_Try, /*On fail goto*//*Label 11033*/ GIMT_Encode4(696076), // Rule ID 11118 //
     /*  696006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696074 */     GIR_RootConstrainSelectedInstOperands,
     /*  696075 */     // GIR_Coverage, 11118,
     /*  696075 */     GIR_EraseRootFromParent_Done,
     /*  696076 */   // Label 11033: @696076
     /*  696076 */   GIM_Try, /*On fail goto*//*Label 11034*/ GIMT_Encode4(696151), // Rule ID 11119 //
     /*  696081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  696092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  696095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  696098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696127 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696149 */     GIR_RootConstrainSelectedInstOperands,
     /*  696150 */     // GIR_Coverage, 11119,
     /*  696150 */     GIR_EraseRootFromParent_Done,
     /*  696151 */   // Label 11034: @696151
     /*  696151 */   GIM_Try, /*On fail goto*//*Label 11035*/ GIMT_Encode4(696226), // Rule ID 11122 //
     /*  696156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696202 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696224 */     GIR_RootConstrainSelectedInstOperands,
     /*  696225 */     // GIR_Coverage, 11122,
     /*  696225 */     GIR_EraseRootFromParent_Done,
     /*  696226 */   // Label 11035: @696226
     /*  696226 */   GIM_Try, /*On fail goto*//*Label 11036*/ GIMT_Encode4(696301), // Rule ID 11123 //
     /*  696231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  696242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  696245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  696248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  696266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11469:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  696280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696299 */     GIR_RootConstrainSelectedInstOperands,
     /*  696300 */     // GIR_Coverage, 11123,
     /*  696300 */     GIR_EraseRootFromParent_Done,
     /*  696301 */   // Label 11036: @696301
     /*  696301 */   GIM_Try, /*On fail goto*//*Label 11037*/ GIMT_Encode4(696376), // Rule ID 11126 //
     /*  696306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696374 */     GIR_RootConstrainSelectedInstOperands,
     /*  696375 */     // GIR_Coverage, 11126,
     /*  696375 */     GIR_EraseRootFromParent_Done,
     /*  696376 */   // Label 11037: @696376
     /*  696376 */   GIM_Try, /*On fail goto*//*Label 11038*/ GIMT_Encode4(696451), // Rule ID 11127 //
     /*  696381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  696392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  696395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  696398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  696416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696427 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11469:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  696430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696449 */     GIR_RootConstrainSelectedInstOperands,
     /*  696450 */     // GIR_Coverage, 11127,
     /*  696450 */     GIR_EraseRootFromParent_Done,
     /*  696451 */   // Label 11038: @696451
     /*  696451 */   GIM_Try, /*On fail goto*//*Label 11039*/ GIMT_Encode4(696526), // Rule ID 11130 //
     /*  696456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  696459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  696467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  696470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  696473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  696476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  696502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696524 */     GIR_RootConstrainSelectedInstOperands,
     /*  696525 */     // GIR_Coverage, 11130,
     /*  696525 */     GIR_EraseRootFromParent_Done,
     /*  696526 */   // Label 11039: @696526
     /*  696526 */   GIM_Try, /*On fail goto*//*Label 11040*/ GIMT_Encode4(696601), // Rule ID 11131 //
     /*  696531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  696542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  696545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  696548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696577 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11469:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696599 */     GIR_RootConstrainSelectedInstOperands,
     /*  696600 */     // GIR_Coverage, 11131,
     /*  696600 */     GIR_EraseRootFromParent_Done,
     /*  696601 */   // Label 11040: @696601
     /*  696601 */   GIM_Try, /*On fail goto*//*Label 11041*/ GIMT_Encode4(696676), // Rule ID 11134 //
     /*  696606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  696617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  696620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  696623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  696626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  696652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  696655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696674 */     GIR_RootConstrainSelectedInstOperands,
     /*  696675 */     // GIR_Coverage, 11134,
     /*  696675 */     GIR_EraseRootFromParent_Done,
     /*  696676 */   // Label 11041: @696676
     /*  696676 */   GIM_Try, /*On fail goto*//*Label 11042*/ GIMT_Encode4(696751), // Rule ID 11135 //
     /*  696681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  696692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  696695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  696698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  696701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696727 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  696727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  696730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696749 */     GIR_RootConstrainSelectedInstOperands,
     /*  696750 */     // GIR_Coverage, 11135,
     /*  696750 */     GIR_EraseRootFromParent_Done,
     /*  696751 */   // Label 11042: @696751
     /*  696751 */   GIM_Try, /*On fail goto*//*Label 11043*/ GIMT_Encode4(696826), // Rule ID 11138 //
     /*  696756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  696767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  696770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  696773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  696776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696802 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  696802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  696805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696824 */     GIR_RootConstrainSelectedInstOperands,
     /*  696825 */     // GIR_Coverage, 11138,
     /*  696825 */     GIR_EraseRootFromParent_Done,
     /*  696826 */   // Label 11043: @696826
     /*  696826 */   GIM_Try, /*On fail goto*//*Label 11044*/ GIMT_Encode4(696901), // Rule ID 11139 //
     /*  696831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  696842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  696845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  696848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  696851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696877 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  696877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  696880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696899 */     GIR_RootConstrainSelectedInstOperands,
     /*  696900 */     // GIR_Coverage, 11139,
     /*  696900 */     GIR_EraseRootFromParent_Done,
     /*  696901 */   // Label 11044: @696901
     /*  696901 */   GIM_Try, /*On fail goto*//*Label 11045*/ GIMT_Encode4(696976), // Rule ID 11142 //
     /*  696906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  696917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  696920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  696923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  696926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  696952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  696955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696974 */     GIR_RootConstrainSelectedInstOperands,
     /*  696975 */     // GIR_Coverage, 11142,
     /*  696975 */     GIR_EraseRootFromParent_Done,
     /*  696976 */   // Label 11045: @696976
     /*  696976 */   GIM_Try, /*On fail goto*//*Label 11046*/ GIMT_Encode4(697051), // Rule ID 11143 //
     /*  696981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  696992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  696995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  696998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  697001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697027 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697049 */     GIR_RootConstrainSelectedInstOperands,
     /*  697050 */     // GIR_Coverage, 11143,
     /*  697050 */     GIR_EraseRootFromParent_Done,
     /*  697051 */   // Label 11046: @697051
     /*  697051 */   GIM_Try, /*On fail goto*//*Label 11047*/ GIMT_Encode4(697126), // Rule ID 11146 //
     /*  697056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  697076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697124 */     GIR_RootConstrainSelectedInstOperands,
     /*  697125 */     // GIR_Coverage, 11146,
     /*  697125 */     GIR_EraseRootFromParent_Done,
     /*  697126 */   // Label 11047: @697126
     /*  697126 */   GIM_Try, /*On fail goto*//*Label 11048*/ GIMT_Encode4(697201), // Rule ID 11147 //
     /*  697131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  697142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  697145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  697148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  697151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  697180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697199 */     GIR_RootConstrainSelectedInstOperands,
     /*  697200 */     // GIR_Coverage, 11147,
     /*  697200 */     GIR_EraseRootFromParent_Done,
     /*  697201 */   // Label 11048: @697201
     /*  697201 */   GIM_Try, /*On fail goto*//*Label 11049*/ GIMT_Encode4(697276), // Rule ID 11150 //
     /*  697206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  697226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697274 */     GIR_RootConstrainSelectedInstOperands,
     /*  697275 */     // GIR_Coverage, 11150,
     /*  697275 */     GIR_EraseRootFromParent_Done,
     /*  697276 */   // Label 11049: @697276
     /*  697276 */   GIM_Try, /*On fail goto*//*Label 11050*/ GIMT_Encode4(697351), // Rule ID 11151 //
     /*  697281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  697292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  697295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  697298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  697301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697349 */     GIR_RootConstrainSelectedInstOperands,
     /*  697350 */     // GIR_Coverage, 11151,
     /*  697350 */     GIR_EraseRootFromParent_Done,
     /*  697351 */   // Label 11050: @697351
     /*  697351 */   GIM_Try, /*On fail goto*//*Label 11051*/ GIMT_Encode4(697426), // Rule ID 11154 //
     /*  697356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  697376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697424 */     GIR_RootConstrainSelectedInstOperands,
     /*  697425 */     // GIR_Coverage, 11154,
     /*  697425 */     GIR_EraseRootFromParent_Done,
     /*  697426 */   // Label 11051: @697426
     /*  697426 */   GIM_Try, /*On fail goto*//*Label 11052*/ GIMT_Encode4(697501), // Rule ID 11155 //
     /*  697431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  697442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  697445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  697448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  697451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697477 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  697480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697499 */     GIR_RootConstrainSelectedInstOperands,
     /*  697500 */     // GIR_Coverage, 11155,
     /*  697500 */     GIR_EraseRootFromParent_Done,
     /*  697501 */   // Label 11052: @697501
     /*  697501 */   GIM_Try, /*On fail goto*//*Label 11053*/ GIMT_Encode4(697576), // Rule ID 11158 //
     /*  697506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  697517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  697520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  697523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  697526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697574 */     GIR_RootConstrainSelectedInstOperands,
     /*  697575 */     // GIR_Coverage, 11158,
     /*  697575 */     GIR_EraseRootFromParent_Done,
     /*  697576 */   // Label 11053: @697576
     /*  697576 */   GIM_Try, /*On fail goto*//*Label 11054*/ GIMT_Encode4(697651), // Rule ID 11159 //
     /*  697581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  697592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  697595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  697598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  697601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697627 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697649 */     GIR_RootConstrainSelectedInstOperands,
     /*  697650 */     // GIR_Coverage, 11159,
     /*  697650 */     GIR_EraseRootFromParent_Done,
     /*  697651 */   // Label 11054: @697651
     /*  697651 */   GIM_Try, /*On fail goto*//*Label 11055*/ GIMT_Encode4(697726), // Rule ID 11162 //
     /*  697656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  697667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  697670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  697673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  697676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697724 */     GIR_RootConstrainSelectedInstOperands,
     /*  697725 */     // GIR_Coverage, 11162,
     /*  697725 */     GIR_EraseRootFromParent_Done,
     /*  697726 */   // Label 11055: @697726
     /*  697726 */   GIM_Try, /*On fail goto*//*Label 11056*/ GIMT_Encode4(697801), // Rule ID 11163 //
     /*  697731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  697742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  697745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  697748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  697751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697799 */     GIR_RootConstrainSelectedInstOperands,
     /*  697800 */     // GIR_Coverage, 11163,
     /*  697800 */     GIR_EraseRootFromParent_Done,
     /*  697801 */   // Label 11056: @697801
     /*  697801 */   GIM_Try, /*On fail goto*//*Label 11057*/ GIMT_Encode4(697876), // Rule ID 11166 //
     /*  697806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  697817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  697820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  697823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  697826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697874 */     GIR_RootConstrainSelectedInstOperands,
     /*  697875 */     // GIR_Coverage, 11166,
     /*  697875 */     GIR_EraseRootFromParent_Done,
     /*  697876 */   // Label 11057: @697876
     /*  697876 */   GIM_Try, /*On fail goto*//*Label 11058*/ GIMT_Encode4(697951), // Rule ID 11167 //
     /*  697881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  697892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  697895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  697898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  697901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697949 */     GIR_RootConstrainSelectedInstOperands,
     /*  697950 */     // GIR_Coverage, 11167,
     /*  697950 */     GIR_EraseRootFromParent_Done,
     /*  697951 */   // Label 11058: @697951
     /*  697951 */   GIM_Try, /*On fail goto*//*Label 11059*/ GIMT_Encode4(698026), // Rule ID 11170 //
     /*  697956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  697967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  697970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  697973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  697976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698002 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698024 */     GIR_RootConstrainSelectedInstOperands,
     /*  698025 */     // GIR_Coverage, 11170,
     /*  698025 */     GIR_EraseRootFromParent_Done,
     /*  698026 */   // Label 11059: @698026
     /*  698026 */   GIM_Try, /*On fail goto*//*Label 11060*/ GIMT_Encode4(698101), // Rule ID 11171 //
     /*  698031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  698042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  698045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  698048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  698051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698077 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698099 */     GIR_RootConstrainSelectedInstOperands,
     /*  698100 */     // GIR_Coverage, 11171,
     /*  698100 */     GIR_EraseRootFromParent_Done,
     /*  698101 */   // Label 11060: @698101
     /*  698101 */   GIM_Try, /*On fail goto*//*Label 11061*/ GIMT_Encode4(698176), // Rule ID 11174 //
     /*  698106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  698126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698152 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698174 */     GIR_RootConstrainSelectedInstOperands,
     /*  698175 */     // GIR_Coverage, 11174,
     /*  698175 */     GIR_EraseRootFromParent_Done,
     /*  698176 */   // Label 11061: @698176
     /*  698176 */   GIM_Try, /*On fail goto*//*Label 11062*/ GIMT_Encode4(698251), // Rule ID 11175 //
     /*  698181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  698192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  698195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  698198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  698201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698227 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698249 */     GIR_RootConstrainSelectedInstOperands,
     /*  698250 */     // GIR_Coverage, 11175,
     /*  698250 */     GIR_EraseRootFromParent_Done,
     /*  698251 */   // Label 11062: @698251
     /*  698251 */   GIM_Try, /*On fail goto*//*Label 11063*/ GIMT_Encode4(698326), // Rule ID 11178 //
     /*  698256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  698276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698302 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698324 */     GIR_RootConstrainSelectedInstOperands,
     /*  698325 */     // GIR_Coverage, 11178,
     /*  698325 */     GIR_EraseRootFromParent_Done,
     /*  698326 */   // Label 11063: @698326
     /*  698326 */   GIM_Try, /*On fail goto*//*Label 11064*/ GIMT_Encode4(698401), // Rule ID 11179 //
     /*  698331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  698342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  698345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  698348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  698351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698377 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698399 */     GIR_RootConstrainSelectedInstOperands,
     /*  698400 */     // GIR_Coverage, 11179,
     /*  698400 */     GIR_EraseRootFromParent_Done,
     /*  698401 */   // Label 11064: @698401
     /*  698401 */   GIM_Try, /*On fail goto*//*Label 11065*/ GIMT_Encode4(698476), // Rule ID 11182 //
     /*  698406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  698417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  698420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  698423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  698426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698474 */     GIR_RootConstrainSelectedInstOperands,
     /*  698475 */     // GIR_Coverage, 11182,
     /*  698475 */     GIR_EraseRootFromParent_Done,
     /*  698476 */   // Label 11065: @698476
     /*  698476 */   GIM_Try, /*On fail goto*//*Label 11066*/ GIMT_Encode4(698551), // Rule ID 11183 //
     /*  698481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  698492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  698495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  698498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  698501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698527 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698549 */     GIR_RootConstrainSelectedInstOperands,
     /*  698550 */     // GIR_Coverage, 11183,
     /*  698550 */     GIR_EraseRootFromParent_Done,
     /*  698551 */   // Label 11066: @698551
     /*  698551 */   GIM_Try, /*On fail goto*//*Label 11067*/ GIMT_Encode4(698626), // Rule ID 11186 //
     /*  698556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  698567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  698570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  698573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  698576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698624 */     GIR_RootConstrainSelectedInstOperands,
     /*  698625 */     // GIR_Coverage, 11186,
     /*  698625 */     GIR_EraseRootFromParent_Done,
     /*  698626 */   // Label 11067: @698626
     /*  698626 */   GIM_Try, /*On fail goto*//*Label 11068*/ GIMT_Encode4(698701), // Rule ID 11187 //
     /*  698631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  698642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  698645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  698648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  698651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698677 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698699 */     GIR_RootConstrainSelectedInstOperands,
     /*  698700 */     // GIR_Coverage, 11187,
     /*  698700 */     GIR_EraseRootFromParent_Done,
     /*  698701 */   // Label 11068: @698701
     /*  698701 */   GIM_Try, /*On fail goto*//*Label 11069*/ GIMT_Encode4(698776), // Rule ID 11190 //
     /*  698706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  698717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  698720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  698723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  698726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698752 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698774 */     GIR_RootConstrainSelectedInstOperands,
     /*  698775 */     // GIR_Coverage, 11190,
     /*  698775 */     GIR_EraseRootFromParent_Done,
     /*  698776 */   // Label 11069: @698776
     /*  698776 */   GIM_Try, /*On fail goto*//*Label 11070*/ GIMT_Encode4(698851), // Rule ID 11191 //
     /*  698781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  698792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  698795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  698798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  698801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698827 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698849 */     GIR_RootConstrainSelectedInstOperands,
     /*  698850 */     // GIR_Coverage, 11191,
     /*  698850 */     GIR_EraseRootFromParent_Done,
     /*  698851 */   // Label 11070: @698851
     /*  698851 */   GIM_Try, /*On fail goto*//*Label 11071*/ GIMT_Encode4(698926), // Rule ID 11194 //
     /*  698856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  698867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  698870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  698873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  698876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698924 */     GIR_RootConstrainSelectedInstOperands,
     /*  698925 */     // GIR_Coverage, 11194,
     /*  698925 */     GIR_EraseRootFromParent_Done,
     /*  698926 */   // Label 11071: @698926
     /*  698926 */   GIM_Try, /*On fail goto*//*Label 11072*/ GIMT_Encode4(699001), // Rule ID 11195 //
     /*  698931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  698942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  698945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  698948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  698951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698977 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698999 */     GIR_RootConstrainSelectedInstOperands,
     /*  699000 */     // GIR_Coverage, 11195,
     /*  699000 */     GIR_EraseRootFromParent_Done,
     /*  699001 */   // Label 11072: @699001
     /*  699001 */   GIM_Try, /*On fail goto*//*Label 11073*/ GIMT_Encode4(699076), // Rule ID 11198 //
     /*  699006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699052 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699074 */     GIR_RootConstrainSelectedInstOperands,
     /*  699075 */     // GIR_Coverage, 11198,
     /*  699075 */     GIR_EraseRootFromParent_Done,
     /*  699076 */   // Label 11073: @699076
     /*  699076 */   GIM_Try, /*On fail goto*//*Label 11074*/ GIMT_Encode4(699151), // Rule ID 11199 //
     /*  699081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  699092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  699095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  699098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  699101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  699120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699127 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  699130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699149 */     GIR_RootConstrainSelectedInstOperands,
     /*  699150 */     // GIR_Coverage, 11199,
     /*  699150 */     GIR_EraseRootFromParent_Done,
     /*  699151 */   // Label 11074: @699151
     /*  699151 */   GIM_Try, /*On fail goto*//*Label 11075*/ GIMT_Encode4(699226), // Rule ID 11202 //
     /*  699156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  699176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699202 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699224 */     GIR_RootConstrainSelectedInstOperands,
     /*  699225 */     // GIR_Coverage, 11202,
     /*  699225 */     GIR_EraseRootFromParent_Done,
     /*  699226 */   // Label 11075: @699226
     /*  699226 */   GIM_Try, /*On fail goto*//*Label 11076*/ GIMT_Encode4(699301), // Rule ID 11203 //
     /*  699231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  699242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  699245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  699248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  699251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  699270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699277 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  699280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699299 */     GIR_RootConstrainSelectedInstOperands,
     /*  699300 */     // GIR_Coverage, 11203,
     /*  699300 */     GIR_EraseRootFromParent_Done,
     /*  699301 */   // Label 11076: @699301
     /*  699301 */   GIM_Try, /*On fail goto*//*Label 11077*/ GIMT_Encode4(699376), // Rule ID 11206 //
     /*  699306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  699317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  699320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  699323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  699355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699374 */     GIR_RootConstrainSelectedInstOperands,
     /*  699375 */     // GIR_Coverage, 11206,
     /*  699375 */     GIR_EraseRootFromParent_Done,
     /*  699376 */   // Label 11077: @699376
     /*  699376 */   GIM_Try, /*On fail goto*//*Label 11078*/ GIMT_Encode4(699451), // Rule ID 11207 //
     /*  699381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  699392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  699395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  699398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699427 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  699430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699449 */     GIR_RootConstrainSelectedInstOperands,
     /*  699450 */     // GIR_Coverage, 11207,
     /*  699450 */     GIR_EraseRootFromParent_Done,
     /*  699451 */   // Label 11078: @699451
     /*  699451 */   GIM_Try, /*On fail goto*//*Label 11079*/ GIMT_Encode4(699526), // Rule ID 11210 //
     /*  699456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  699467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  699470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  699473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699524 */     GIR_RootConstrainSelectedInstOperands,
     /*  699525 */     // GIR_Coverage, 11210,
     /*  699525 */     GIR_EraseRootFromParent_Done,
     /*  699526 */   // Label 11079: @699526
     /*  699526 */   GIM_Try, /*On fail goto*//*Label 11080*/ GIMT_Encode4(699601), // Rule ID 11211 //
     /*  699531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  699542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  699545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  699548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699577 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699599 */     GIR_RootConstrainSelectedInstOperands,
     /*  699600 */     // GIR_Coverage, 11211,
     /*  699600 */     GIR_EraseRootFromParent_Done,
     /*  699601 */   // Label 11080: @699601
     /*  699601 */   GIM_Try, /*On fail goto*//*Label 11081*/ GIMT_Encode4(699676), // Rule ID 11214 //
     /*  699606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  699617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  699620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  699623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699652 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699674 */     GIR_RootConstrainSelectedInstOperands,
     /*  699675 */     // GIR_Coverage, 11214,
     /*  699675 */     GIR_EraseRootFromParent_Done,
     /*  699676 */   // Label 11081: @699676
     /*  699676 */   GIM_Try, /*On fail goto*//*Label 11082*/ GIMT_Encode4(699751), // Rule ID 11215 //
     /*  699681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  699692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  699695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  699698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699727 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699749 */     GIR_RootConstrainSelectedInstOperands,
     /*  699750 */     // GIR_Coverage, 11215,
     /*  699750 */     GIR_EraseRootFromParent_Done,
     /*  699751 */   // Label 11082: @699751
     /*  699751 */   GIM_Try, /*On fail goto*//*Label 11083*/ GIMT_Encode4(699826), // Rule ID 11218 //
     /*  699756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  699767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  699770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  699773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699824 */     GIR_RootConstrainSelectedInstOperands,
     /*  699825 */     // GIR_Coverage, 11218,
     /*  699825 */     GIR_EraseRootFromParent_Done,
     /*  699826 */   // Label 11083: @699826
     /*  699826 */   GIM_Try, /*On fail goto*//*Label 11084*/ GIMT_Encode4(699901), // Rule ID 11219 //
     /*  699831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  699842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  699845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  699848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699899 */     GIR_RootConstrainSelectedInstOperands,
     /*  699900 */     // GIR_Coverage, 11219,
     /*  699900 */     GIR_EraseRootFromParent_Done,
     /*  699901 */   // Label 11084: @699901
     /*  699901 */   GIM_Try, /*On fail goto*//*Label 11085*/ GIMT_Encode4(699976), // Rule ID 11222 //
     /*  699906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  699917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  699920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  699923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699952 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699974 */     GIR_RootConstrainSelectedInstOperands,
     /*  699975 */     // GIR_Coverage, 11222,
     /*  699975 */     GIR_EraseRootFromParent_Done,
     /*  699976 */   // Label 11085: @699976
     /*  699976 */   GIM_Try, /*On fail goto*//*Label 11086*/ GIMT_Encode4(700051), // Rule ID 11223 //
     /*  699981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  699992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  699995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  699998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700027 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700049 */     GIR_RootConstrainSelectedInstOperands,
     /*  700050 */     // GIR_Coverage, 11223,
     /*  700050 */     GIR_EraseRootFromParent_Done,
     /*  700051 */   // Label 11086: @700051
     /*  700051 */   GIM_Try, /*On fail goto*//*Label 11087*/ GIMT_Encode4(700126), // Rule ID 11226 //
     /*  700056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  700067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  700070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  700073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  700102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700124 */     GIR_RootConstrainSelectedInstOperands,
     /*  700125 */     // GIR_Coverage, 11226,
     /*  700125 */     GIR_EraseRootFromParent_Done,
     /*  700126 */   // Label 11087: @700126
     /*  700126 */   GIM_Try, /*On fail goto*//*Label 11088*/ GIMT_Encode4(700201), // Rule ID 11227 //
     /*  700131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  700142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  700145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  700148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700177 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  700177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  700180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700199 */     GIR_RootConstrainSelectedInstOperands,
     /*  700200 */     // GIR_Coverage, 11227,
     /*  700200 */     GIR_EraseRootFromParent_Done,
     /*  700201 */   // Label 11088: @700201
     /*  700201 */   GIM_Try, /*On fail goto*//*Label 11089*/ GIMT_Encode4(700276), // Rule ID 11230 //
     /*  700206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  700217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  700220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  700223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700274 */     GIR_RootConstrainSelectedInstOperands,
     /*  700275 */     // GIR_Coverage, 11230,
     /*  700275 */     GIR_EraseRootFromParent_Done,
     /*  700276 */   // Label 11089: @700276
     /*  700276 */   GIM_Try, /*On fail goto*//*Label 11090*/ GIMT_Encode4(700351), // Rule ID 11231 //
     /*  700281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  700292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  700295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  700298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11471:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700349 */     GIR_RootConstrainSelectedInstOperands,
     /*  700350 */     // GIR_Coverage, 11231,
     /*  700350 */     GIR_EraseRootFromParent_Done,
     /*  700351 */   // Label 11090: @700351
     /*  700351 */   GIM_Try, /*On fail goto*//*Label 11091*/ GIMT_Encode4(700426), // Rule ID 11234 //
     /*  700356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  700367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  700370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  700373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700424 */     GIR_RootConstrainSelectedInstOperands,
     /*  700425 */     // GIR_Coverage, 11234,
     /*  700425 */     GIR_EraseRootFromParent_Done,
     /*  700426 */   // Label 11091: @700426
     /*  700426 */   GIM_Try, /*On fail goto*//*Label 11092*/ GIMT_Encode4(700501), // Rule ID 11235 //
     /*  700431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  700442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  700445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  700448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700499 */     GIR_RootConstrainSelectedInstOperands,
     /*  700500 */     // GIR_Coverage, 11235,
     /*  700500 */     GIR_EraseRootFromParent_Done,
     /*  700501 */   // Label 11092: @700501
     /*  700501 */   GIM_Try, /*On fail goto*//*Label 11093*/ GIMT_Encode4(700576), // Rule ID 11238 //
     /*  700506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  700517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  700520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  700523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  700552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700574 */     GIR_RootConstrainSelectedInstOperands,
     /*  700575 */     // GIR_Coverage, 11238,
     /*  700575 */     GIR_EraseRootFromParent_Done,
     /*  700576 */   // Label 11093: @700576
     /*  700576 */   GIM_Try, /*On fail goto*//*Label 11094*/ GIMT_Encode4(700651), // Rule ID 11239 //
     /*  700581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  700592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  700595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  700598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  700627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700649 */     GIR_RootConstrainSelectedInstOperands,
     /*  700650 */     // GIR_Coverage, 11239,
     /*  700650 */     GIR_EraseRootFromParent_Done,
     /*  700651 */   // Label 11094: @700651
     /*  700651 */   GIM_Try, /*On fail goto*//*Label 11095*/ GIMT_Encode4(700726), // Rule ID 11242 //
     /*  700656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  700667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  700670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  700673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700702 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  700705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700724 */     GIR_RootConstrainSelectedInstOperands,
     /*  700725 */     // GIR_Coverage, 11242,
     /*  700725 */     GIR_EraseRootFromParent_Done,
     /*  700726 */   // Label 11095: @700726
     /*  700726 */   GIM_Try, /*On fail goto*//*Label 11096*/ GIMT_Encode4(700801), // Rule ID 11243 //
     /*  700731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  700742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  700745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  700748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700777 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  700780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700799 */     GIR_RootConstrainSelectedInstOperands,
     /*  700800 */     // GIR_Coverage, 11243,
     /*  700800 */     GIR_EraseRootFromParent_Done,
     /*  700801 */   // Label 11096: @700801
     /*  700801 */   GIM_Try, /*On fail goto*//*Label 11097*/ GIMT_Encode4(700876), // Rule ID 11246 //
     /*  700806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  700817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  700820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  700823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700852 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  700855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700874 */     GIR_RootConstrainSelectedInstOperands,
     /*  700875 */     // GIR_Coverage, 11246,
     /*  700875 */     GIR_EraseRootFromParent_Done,
     /*  700876 */   // Label 11097: @700876
     /*  700876 */   GIM_Try, /*On fail goto*//*Label 11098*/ GIMT_Encode4(700951), // Rule ID 11247 //
     /*  700881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  700892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  700895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  700898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700927 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  700930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700949 */     GIR_RootConstrainSelectedInstOperands,
     /*  700950 */     // GIR_Coverage, 11247,
     /*  700950 */     GIR_EraseRootFromParent_Done,
     /*  700951 */   // Label 11098: @700951
     /*  700951 */   GIM_Try, /*On fail goto*//*Label 11099*/ GIMT_Encode4(701026), // Rule ID 11250 //
     /*  700956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  700967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  700970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  700973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701002 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701024 */     GIR_RootConstrainSelectedInstOperands,
     /*  701025 */     // GIR_Coverage, 11250,
     /*  701025 */     GIR_EraseRootFromParent_Done,
     /*  701026 */   // Label 11099: @701026
     /*  701026 */   GIM_Try, /*On fail goto*//*Label 11100*/ GIMT_Encode4(701101), // Rule ID 11251 //
     /*  701031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  701042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  701045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  701048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701077 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701099 */     GIR_RootConstrainSelectedInstOperands,
     /*  701100 */     // GIR_Coverage, 11251,
     /*  701100 */     GIR_EraseRootFromParent_Done,
     /*  701101 */   // Label 11100: @701101
     /*  701101 */   GIM_Try, /*On fail goto*//*Label 11101*/ GIMT_Encode4(701176), // Rule ID 11254 //
     /*  701106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701174 */     GIR_RootConstrainSelectedInstOperands,
     /*  701175 */     // GIR_Coverage, 11254,
     /*  701175 */     GIR_EraseRootFromParent_Done,
     /*  701176 */   // Label 11101: @701176
     /*  701176 */   GIM_Try, /*On fail goto*//*Label 11102*/ GIMT_Encode4(701251), // Rule ID 11255 //
     /*  701181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  701192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  701195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  701198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701227 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701249 */     GIR_RootConstrainSelectedInstOperands,
     /*  701250 */     // GIR_Coverage, 11255,
     /*  701250 */     GIR_EraseRootFromParent_Done,
     /*  701251 */   // Label 11102: @701251
     /*  701251 */   GIM_Try, /*On fail goto*//*Label 11103*/ GIMT_Encode4(701326), // Rule ID 11258 //
     /*  701256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701302 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701324 */     GIR_RootConstrainSelectedInstOperands,
     /*  701325 */     // GIR_Coverage, 11258,
     /*  701325 */     GIR_EraseRootFromParent_Done,
     /*  701326 */   // Label 11103: @701326
     /*  701326 */   GIM_Try, /*On fail goto*//*Label 11104*/ GIMT_Encode4(701401), // Rule ID 11259 //
     /*  701331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  701342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  701345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  701348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701377 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701399 */     GIR_RootConstrainSelectedInstOperands,
     /*  701400 */     // GIR_Coverage, 11259,
     /*  701400 */     GIR_EraseRootFromParent_Done,
     /*  701401 */   // Label 11104: @701401
     /*  701401 */   GIM_Try, /*On fail goto*//*Label 11105*/ GIMT_Encode4(701476), // Rule ID 11262 //
     /*  701406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701452 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701474 */     GIR_RootConstrainSelectedInstOperands,
     /*  701475 */     // GIR_Coverage, 11262,
     /*  701475 */     GIR_EraseRootFromParent_Done,
     /*  701476 */   // Label 11105: @701476
     /*  701476 */   GIM_Try, /*On fail goto*//*Label 11106*/ GIMT_Encode4(701551), // Rule ID 11263 //
     /*  701481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  701492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  701495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  701498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701527 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701549 */     GIR_RootConstrainSelectedInstOperands,
     /*  701550 */     // GIR_Coverage, 11263,
     /*  701550 */     GIR_EraseRootFromParent_Done,
     /*  701551 */   // Label 11106: @701551
     /*  701551 */   GIM_Try, /*On fail goto*//*Label 11107*/ GIMT_Encode4(701626), // Rule ID 11266 //
     /*  701556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  701567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  701570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  701573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701602 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701624 */     GIR_RootConstrainSelectedInstOperands,
     /*  701625 */     // GIR_Coverage, 11266,
     /*  701625 */     GIR_EraseRootFromParent_Done,
     /*  701626 */   // Label 11107: @701626
     /*  701626 */   GIM_Try, /*On fail goto*//*Label 11108*/ GIMT_Encode4(701701), // Rule ID 11267 //
     /*  701631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  701642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  701645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  701648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701699 */     GIR_RootConstrainSelectedInstOperands,
     /*  701700 */     // GIR_Coverage, 11267,
     /*  701700 */     GIR_EraseRootFromParent_Done,
     /*  701701 */   // Label 11108: @701701
     /*  701701 */   GIM_Try, /*On fail goto*//*Label 11109*/ GIMT_Encode4(701776), // Rule ID 11270 //
     /*  701706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  701717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  701720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  701723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701752 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701774 */     GIR_RootConstrainSelectedInstOperands,
     /*  701775 */     // GIR_Coverage, 11270,
     /*  701775 */     GIR_EraseRootFromParent_Done,
     /*  701776 */   // Label 11109: @701776
     /*  701776 */   GIM_Try, /*On fail goto*//*Label 11110*/ GIMT_Encode4(701851), // Rule ID 11271 //
     /*  701781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  701792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  701795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  701798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701827 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701849 */     GIR_RootConstrainSelectedInstOperands,
     /*  701850 */     // GIR_Coverage, 11271,
     /*  701850 */     GIR_EraseRootFromParent_Done,
     /*  701851 */   // Label 11110: @701851
     /*  701851 */   GIM_Try, /*On fail goto*//*Label 11111*/ GIMT_Encode4(701926), // Rule ID 11274 //
     /*  701856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  701867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  701870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  701873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701902 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701924 */     GIR_RootConstrainSelectedInstOperands,
     /*  701925 */     // GIR_Coverage, 11274,
     /*  701925 */     GIR_EraseRootFromParent_Done,
     /*  701926 */   // Label 11111: @701926
     /*  701926 */   GIM_Try, /*On fail goto*//*Label 11112*/ GIMT_Encode4(702001), // Rule ID 11275 //
     /*  701931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  701942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  701945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  701948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701977 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701999 */     GIR_RootConstrainSelectedInstOperands,
     /*  702000 */     // GIR_Coverage, 11275,
     /*  702000 */     GIR_EraseRootFromParent_Done,
     /*  702001 */   // Label 11112: @702001
     /*  702001 */   GIM_Try, /*On fail goto*//*Label 11113*/ GIMT_Encode4(702076), // Rule ID 11278 //
     /*  702006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  702017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  702020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  702023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  702026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  702055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702074 */     GIR_RootConstrainSelectedInstOperands,
     /*  702075 */     // GIR_Coverage, 11278,
     /*  702075 */     GIR_EraseRootFromParent_Done,
     /*  702076 */   // Label 11113: @702076
     /*  702076 */   GIM_Try, /*On fail goto*//*Label 11114*/ GIMT_Encode4(702151), // Rule ID 11279 //
     /*  702081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  702092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  702095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  702098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  702101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702127 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  702130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702149 */     GIR_RootConstrainSelectedInstOperands,
     /*  702150 */     // GIR_Coverage, 11279,
     /*  702150 */     GIR_EraseRootFromParent_Done,
     /*  702151 */   // Label 11114: @702151
     /*  702151 */   GIM_Try, /*On fail goto*//*Label 11115*/ GIMT_Encode4(702226), // Rule ID 11282 //
     /*  702156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  702167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  702170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  702173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  702176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702202 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702224 */     GIR_RootConstrainSelectedInstOperands,
     /*  702225 */     // GIR_Coverage, 11282,
     /*  702225 */     GIR_EraseRootFromParent_Done,
     /*  702226 */   // Label 11115: @702226
     /*  702226 */   GIM_Try, /*On fail goto*//*Label 11116*/ GIMT_Encode4(702301), // Rule ID 11283 //
     /*  702231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  702242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  702245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  702248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  702251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702277 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702299 */     GIR_RootConstrainSelectedInstOperands,
     /*  702300 */     // GIR_Coverage, 11283,
     /*  702300 */     GIR_EraseRootFromParent_Done,
     /*  702301 */   // Label 11116: @702301
     /*  702301 */   GIM_Try, /*On fail goto*//*Label 11117*/ GIMT_Encode4(702376), // Rule ID 11286 //
     /*  702306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  702317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  702320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  702323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  702326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702374 */     GIR_RootConstrainSelectedInstOperands,
     /*  702375 */     // GIR_Coverage, 11286,
     /*  702375 */     GIR_EraseRootFromParent_Done,
     /*  702376 */   // Label 11117: @702376
     /*  702376 */   GIM_Try, /*On fail goto*//*Label 11118*/ GIMT_Encode4(702451), // Rule ID 11287 //
     /*  702381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  702392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  702395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  702398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  702401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702427 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702449 */     GIR_RootConstrainSelectedInstOperands,
     /*  702450 */     // GIR_Coverage, 11287,
     /*  702450 */     GIR_EraseRootFromParent_Done,
     /*  702451 */   // Label 11118: @702451
     /*  702451 */   GIM_Try, /*On fail goto*//*Label 11119*/ GIMT_Encode4(702526), // Rule ID 11290 //
     /*  702456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  702467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  702470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  702473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  702476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702524 */     GIR_RootConstrainSelectedInstOperands,
     /*  702525 */     // GIR_Coverage, 11290,
     /*  702525 */     GIR_EraseRootFromParent_Done,
     /*  702526 */   // Label 11119: @702526
     /*  702526 */   GIM_Try, /*On fail goto*//*Label 11120*/ GIMT_Encode4(702601), // Rule ID 11291 //
     /*  702531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  702542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  702545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  702548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  702551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702577 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702599 */     GIR_RootConstrainSelectedInstOperands,
     /*  702600 */     // GIR_Coverage, 11291,
     /*  702600 */     GIR_EraseRootFromParent_Done,
     /*  702601 */   // Label 11120: @702601
     /*  702601 */   GIM_Try, /*On fail goto*//*Label 11121*/ GIMT_Encode4(702676), // Rule ID 11294 //
     /*  702606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  702617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  702620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  702623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  702626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702674 */     GIR_RootConstrainSelectedInstOperands,
     /*  702675 */     // GIR_Coverage, 11294,
     /*  702675 */     GIR_EraseRootFromParent_Done,
     /*  702676 */   // Label 11121: @702676
     /*  702676 */   GIM_Try, /*On fail goto*//*Label 11122*/ GIMT_Encode4(702751), // Rule ID 11295 //
     /*  702681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  702692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  702695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  702698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  702701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702727 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702749 */     GIR_RootConstrainSelectedInstOperands,
     /*  702750 */     // GIR_Coverage, 11295,
     /*  702750 */     GIR_EraseRootFromParent_Done,
     /*  702751 */   // Label 11122: @702751
     /*  702751 */   GIM_Try, /*On fail goto*//*Label 11123*/ GIMT_Encode4(702826), // Rule ID 11298 //
     /*  702756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  702767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  702770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  702773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  702776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702824 */     GIR_RootConstrainSelectedInstOperands,
     /*  702825 */     // GIR_Coverage, 11298,
     /*  702825 */     GIR_EraseRootFromParent_Done,
     /*  702826 */   // Label 11123: @702826
     /*  702826 */   GIM_Try, /*On fail goto*//*Label 11124*/ GIMT_Encode4(702901), // Rule ID 11299 //
     /*  702831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  702842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  702845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  702848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  702851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702877 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702899 */     GIR_RootConstrainSelectedInstOperands,
     /*  702900 */     // GIR_Coverage, 11299,
     /*  702900 */     GIR_EraseRootFromParent_Done,
     /*  702901 */   // Label 11124: @702901
     /*  702901 */   GIM_Try, /*On fail goto*//*Label 11125*/ GIMT_Encode4(702976), // Rule ID 11302 //
     /*  702906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  702917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  702920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  702923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  702926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  702955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702974 */     GIR_RootConstrainSelectedInstOperands,
     /*  702975 */     // GIR_Coverage, 11302,
     /*  702975 */     GIR_EraseRootFromParent_Done,
     /*  702976 */   // Label 11125: @702976
     /*  702976 */   GIM_Try, /*On fail goto*//*Label 11126*/ GIMT_Encode4(703051), // Rule ID 11303 //
     /*  702981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  702992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  702995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  702998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  703001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703049 */     GIR_RootConstrainSelectedInstOperands,
     /*  703050 */     // GIR_Coverage, 11303,
     /*  703050 */     GIR_EraseRootFromParent_Done,
     /*  703051 */   // Label 11126: @703051
     /*  703051 */   GIM_Try, /*On fail goto*//*Label 11127*/ GIMT_Encode4(703126), // Rule ID 11306 //
     /*  703056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703124 */     GIR_RootConstrainSelectedInstOperands,
     /*  703125 */     // GIR_Coverage, 11306,
     /*  703125 */     GIR_EraseRootFromParent_Done,
     /*  703126 */   // Label 11127: @703126
     /*  703126 */   GIM_Try, /*On fail goto*//*Label 11128*/ GIMT_Encode4(703201), // Rule ID 11307 //
     /*  703131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  703142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  703145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  703148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  703151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703199 */     GIR_RootConstrainSelectedInstOperands,
     /*  703200 */     // GIR_Coverage, 11307,
     /*  703200 */     GIR_EraseRootFromParent_Done,
     /*  703201 */   // Label 11128: @703201
     /*  703201 */   GIM_Try, /*On fail goto*//*Label 11129*/ GIMT_Encode4(703276), // Rule ID 11310 //
     /*  703206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703274 */     GIR_RootConstrainSelectedInstOperands,
     /*  703275 */     // GIR_Coverage, 11310,
     /*  703275 */     GIR_EraseRootFromParent_Done,
     /*  703276 */   // Label 11129: @703276
     /*  703276 */   GIM_Try, /*On fail goto*//*Label 11130*/ GIMT_Encode4(703351), // Rule ID 11311 //
     /*  703281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  703292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  703295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  703298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  703301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  703320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  703330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703349 */     GIR_RootConstrainSelectedInstOperands,
     /*  703350 */     // GIR_Coverage, 11311,
     /*  703350 */     GIR_EraseRootFromParent_Done,
     /*  703351 */   // Label 11130: @703351
     /*  703351 */   GIM_Try, /*On fail goto*//*Label 11131*/ GIMT_Encode4(703426), // Rule ID 11314 //
     /*  703356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  703367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  703370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  703373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  703376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703424 */     GIR_RootConstrainSelectedInstOperands,
     /*  703425 */     // GIR_Coverage, 11314,
     /*  703425 */     GIR_EraseRootFromParent_Done,
     /*  703426 */   // Label 11131: @703426
     /*  703426 */   GIM_Try, /*On fail goto*//*Label 11132*/ GIMT_Encode4(703501), // Rule ID 11315 //
     /*  703431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  703442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  703445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  703448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  703451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703477 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703499 */     GIR_RootConstrainSelectedInstOperands,
     /*  703500 */     // GIR_Coverage, 11315,
     /*  703500 */     GIR_EraseRootFromParent_Done,
     /*  703501 */   // Label 11132: @703501
     /*  703501 */   GIM_Try, /*On fail goto*//*Label 11133*/ GIMT_Encode4(703576), // Rule ID 11318 //
     /*  703506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  703517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  703520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  703523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  703526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703552 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  703555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703574 */     GIR_RootConstrainSelectedInstOperands,
     /*  703575 */     // GIR_Coverage, 11318,
     /*  703575 */     GIR_EraseRootFromParent_Done,
     /*  703576 */   // Label 11133: @703576
     /*  703576 */   GIM_Try, /*On fail goto*//*Label 11134*/ GIMT_Encode4(703651), // Rule ID 11319 //
     /*  703581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  703592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  703595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  703598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  703601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703627 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  703630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703649 */     GIR_RootConstrainSelectedInstOperands,
     /*  703650 */     // GIR_Coverage, 11319,
     /*  703650 */     GIR_EraseRootFromParent_Done,
     /*  703651 */   // Label 11134: @703651
     /*  703651 */   GIM_Try, /*On fail goto*//*Label 11135*/ GIMT_Encode4(703726), // Rule ID 11322 //
     /*  703656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  703667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  703670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  703673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  703676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703702 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  703705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703724 */     GIR_RootConstrainSelectedInstOperands,
     /*  703725 */     // GIR_Coverage, 11322,
     /*  703725 */     GIR_EraseRootFromParent_Done,
     /*  703726 */   // Label 11135: @703726
     /*  703726 */   GIM_Try, /*On fail goto*//*Label 11136*/ GIMT_Encode4(703801), // Rule ID 11323 //
     /*  703731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  703742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  703745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  703748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  703751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703777 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  703780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703799 */     GIR_RootConstrainSelectedInstOperands,
     /*  703800 */     // GIR_Coverage, 11323,
     /*  703800 */     GIR_EraseRootFromParent_Done,
     /*  703801 */   // Label 11136: @703801
     /*  703801 */   GIM_Try, /*On fail goto*//*Label 11137*/ GIMT_Encode4(703876), // Rule ID 11326 //
     /*  703806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  703817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  703820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  703823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  703826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703874 */     GIR_RootConstrainSelectedInstOperands,
     /*  703875 */     // GIR_Coverage, 11326,
     /*  703875 */     GIR_EraseRootFromParent_Done,
     /*  703876 */   // Label 11137: @703876
     /*  703876 */   GIM_Try, /*On fail goto*//*Label 11138*/ GIMT_Encode4(703951), // Rule ID 11327 //
     /*  703881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  703892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  703895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  703898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  703901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703927 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703949 */     GIR_RootConstrainSelectedInstOperands,
     /*  703950 */     // GIR_Coverage, 11327,
     /*  703950 */     GIR_EraseRootFromParent_Done,
     /*  703951 */   // Label 11138: @703951
     /*  703951 */   GIM_Try, /*On fail goto*//*Label 11139*/ GIMT_Encode4(704026), // Rule ID 11330 //
     /*  703956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  703967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  703970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  703973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  703976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704024 */     GIR_RootConstrainSelectedInstOperands,
     /*  704025 */     // GIR_Coverage, 11330,
     /*  704025 */     GIR_EraseRootFromParent_Done,
     /*  704026 */   // Label 11139: @704026
     /*  704026 */   GIM_Try, /*On fail goto*//*Label 11140*/ GIMT_Encode4(704101), // Rule ID 11331 //
     /*  704031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  704042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  704045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  704048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  704051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704077 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704099 */     GIR_RootConstrainSelectedInstOperands,
     /*  704100 */     // GIR_Coverage, 11331,
     /*  704100 */     GIR_EraseRootFromParent_Done,
     /*  704101 */   // Label 11140: @704101
     /*  704101 */   GIM_Try, /*On fail goto*//*Label 11141*/ GIMT_Encode4(704176), // Rule ID 11334 //
     /*  704106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704152 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704174 */     GIR_RootConstrainSelectedInstOperands,
     /*  704175 */     // GIR_Coverage, 11334,
     /*  704175 */     GIR_EraseRootFromParent_Done,
     /*  704176 */   // Label 11141: @704176
     /*  704176 */   GIM_Try, /*On fail goto*//*Label 11142*/ GIMT_Encode4(704251), // Rule ID 11335 //
     /*  704181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  704192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  704195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  704198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  704201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704227 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704249 */     GIR_RootConstrainSelectedInstOperands,
     /*  704250 */     // GIR_Coverage, 11335,
     /*  704250 */     GIR_EraseRootFromParent_Done,
     /*  704251 */   // Label 11142: @704251
     /*  704251 */   GIM_Try, /*On fail goto*//*Label 11143*/ GIMT_Encode4(704326), // Rule ID 11338 //
     /*  704256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704324 */     GIR_RootConstrainSelectedInstOperands,
     /*  704325 */     // GIR_Coverage, 11338,
     /*  704325 */     GIR_EraseRootFromParent_Done,
     /*  704326 */   // Label 11143: @704326
     /*  704326 */   GIM_Try, /*On fail goto*//*Label 11144*/ GIMT_Encode4(704401), // Rule ID 11339 //
     /*  704331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  704342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  704345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  704348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  704351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  704370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704377 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  704380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704399 */     GIR_RootConstrainSelectedInstOperands,
     /*  704400 */     // GIR_Coverage, 11339,
     /*  704400 */     GIR_EraseRootFromParent_Done,
     /*  704401 */   // Label 11144: @704401
     /*  704401 */   GIM_Try, /*On fail goto*//*Label 11145*/ GIMT_Encode4(704476), // Rule ID 11342 //
     /*  704406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704474 */     GIR_RootConstrainSelectedInstOperands,
     /*  704475 */     // GIR_Coverage, 11342,
     /*  704475 */     GIR_EraseRootFromParent_Done,
     /*  704476 */   // Label 11145: @704476
     /*  704476 */   GIM_Try, /*On fail goto*//*Label 11146*/ GIMT_Encode4(704551), // Rule ID 11343 //
     /*  704481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  704492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  704495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  704498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  704501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704527 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704549 */     GIR_RootConstrainSelectedInstOperands,
     /*  704550 */     // GIR_Coverage, 11343,
     /*  704550 */     GIR_EraseRootFromParent_Done,
     /*  704551 */   // Label 11146: @704551
     /*  704551 */   GIM_Try, /*On fail goto*//*Label 11147*/ GIMT_Encode4(704626), // Rule ID 11346 //
     /*  704556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  704567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  704570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  704573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  704576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704624 */     GIR_RootConstrainSelectedInstOperands,
     /*  704625 */     // GIR_Coverage, 11346,
     /*  704625 */     GIR_EraseRootFromParent_Done,
     /*  704626 */   // Label 11147: @704626
     /*  704626 */   GIM_Try, /*On fail goto*//*Label 11148*/ GIMT_Encode4(704701), // Rule ID 11347 //
     /*  704631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  704642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  704645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  704648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  704651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704677 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704699 */     GIR_RootConstrainSelectedInstOperands,
     /*  704700 */     // GIR_Coverage, 11347,
     /*  704700 */     GIR_EraseRootFromParent_Done,
     /*  704701 */   // Label 11148: @704701
     /*  704701 */   GIM_Try, /*On fail goto*//*Label 11149*/ GIMT_Encode4(704776), // Rule ID 11350 //
     /*  704706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  704717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  704720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  704723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704752 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  704755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704774 */     GIR_RootConstrainSelectedInstOperands,
     /*  704775 */     // GIR_Coverage, 11350,
     /*  704775 */     GIR_EraseRootFromParent_Done,
     /*  704776 */   // Label 11149: @704776
     /*  704776 */   GIM_Try, /*On fail goto*//*Label 11150*/ GIMT_Encode4(704851), // Rule ID 11351 //
     /*  704781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  704792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  704795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  704798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704827 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  704830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704849 */     GIR_RootConstrainSelectedInstOperands,
     /*  704850 */     // GIR_Coverage, 11351,
     /*  704850 */     GIR_EraseRootFromParent_Done,
     /*  704851 */   // Label 11150: @704851
     /*  704851 */   GIM_Try, /*On fail goto*//*Label 11151*/ GIMT_Encode4(704926), // Rule ID 11354 //
     /*  704856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  704867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  704870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  704873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704902 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  704905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704924 */     GIR_RootConstrainSelectedInstOperands,
     /*  704925 */     // GIR_Coverage, 11354,
     /*  704925 */     GIR_EraseRootFromParent_Done,
     /*  704926 */   // Label 11151: @704926
     /*  704926 */   GIM_Try, /*On fail goto*//*Label 11152*/ GIMT_Encode4(705001), // Rule ID 11355 //
     /*  704931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  704942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  704945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  704948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704977 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  704980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704999 */     GIR_RootConstrainSelectedInstOperands,
     /*  705000 */     // GIR_Coverage, 11355,
     /*  705000 */     GIR_EraseRootFromParent_Done,
     /*  705001 */   // Label 11152: @705001
     /*  705001 */   GIM_Try, /*On fail goto*//*Label 11153*/ GIMT_Encode4(705076), // Rule ID 11358 //
     /*  705006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  705017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  705020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  705023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705074 */     GIR_RootConstrainSelectedInstOperands,
     /*  705075 */     // GIR_Coverage, 11358,
     /*  705075 */     GIR_EraseRootFromParent_Done,
     /*  705076 */   // Label 11153: @705076
     /*  705076 */   GIM_Try, /*On fail goto*//*Label 11154*/ GIMT_Encode4(705151), // Rule ID 11359 //
     /*  705081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  705092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  705095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  705098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705127 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705149 */     GIR_RootConstrainSelectedInstOperands,
     /*  705150 */     // GIR_Coverage, 11359,
     /*  705150 */     GIR_EraseRootFromParent_Done,
     /*  705151 */   // Label 11154: @705151
     /*  705151 */   GIM_Try, /*On fail goto*//*Label 11155*/ GIMT_Encode4(705226), // Rule ID 11362 //
     /*  705156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705202 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705224 */     GIR_RootConstrainSelectedInstOperands,
     /*  705225 */     // GIR_Coverage, 11362,
     /*  705225 */     GIR_EraseRootFromParent_Done,
     /*  705226 */   // Label 11155: @705226
     /*  705226 */   GIM_Try, /*On fail goto*//*Label 11156*/ GIMT_Encode4(705301), // Rule ID 11363 //
     /*  705231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  705242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  705245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  705248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705277 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  705280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705299 */     GIR_RootConstrainSelectedInstOperands,
     /*  705300 */     // GIR_Coverage, 11363,
     /*  705300 */     GIR_EraseRootFromParent_Done,
     /*  705301 */   // Label 11156: @705301
     /*  705301 */   GIM_Try, /*On fail goto*//*Label 11157*/ GIMT_Encode4(705376), // Rule ID 11366 //
     /*  705306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705374 */     GIR_RootConstrainSelectedInstOperands,
     /*  705375 */     // GIR_Coverage, 11366,
     /*  705375 */     GIR_EraseRootFromParent_Done,
     /*  705376 */   // Label 11157: @705376
     /*  705376 */   GIM_Try, /*On fail goto*//*Label 11158*/ GIMT_Encode4(705451), // Rule ID 11367 //
     /*  705381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  705392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  705395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  705398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705427 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705449 */     GIR_RootConstrainSelectedInstOperands,
     /*  705450 */     // GIR_Coverage, 11367,
     /*  705450 */     GIR_EraseRootFromParent_Done,
     /*  705451 */   // Label 11158: @705451
     /*  705451 */   GIM_Try, /*On fail goto*//*Label 11159*/ GIMT_Encode4(705526), // Rule ID 11370 //
     /*  705456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  705467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  705470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  705473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705524 */     GIR_RootConstrainSelectedInstOperands,
     /*  705525 */     // GIR_Coverage, 11370,
     /*  705525 */     GIR_EraseRootFromParent_Done,
     /*  705526 */   // Label 11159: @705526
     /*  705526 */   GIM_Try, /*On fail goto*//*Label 11160*/ GIMT_Encode4(705601), // Rule ID 11371 //
     /*  705531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  705542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  705545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  705548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705577 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705599 */     GIR_RootConstrainSelectedInstOperands,
     /*  705600 */     // GIR_Coverage, 11371,
     /*  705600 */     GIR_EraseRootFromParent_Done,
     /*  705601 */   // Label 11160: @705601
     /*  705601 */   GIM_Try, /*On fail goto*//*Label 11161*/ GIMT_Encode4(705676), // Rule ID 11374 //
     /*  705606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  705617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  705620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  705623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705674 */     GIR_RootConstrainSelectedInstOperands,
     /*  705675 */     // GIR_Coverage, 11374,
     /*  705675 */     GIR_EraseRootFromParent_Done,
     /*  705676 */   // Label 11161: @705676
     /*  705676 */   GIM_Try, /*On fail goto*//*Label 11162*/ GIMT_Encode4(705751), // Rule ID 11375 //
     /*  705681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  705692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  705695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  705698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11475:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705749 */     GIR_RootConstrainSelectedInstOperands,
     /*  705750 */     // GIR_Coverage, 11375,
     /*  705750 */     GIR_EraseRootFromParent_Done,
     /*  705751 */   // Label 11162: @705751
     /*  705751 */   GIM_Try, /*On fail goto*//*Label 11163*/ GIMT_Encode4(705826), // Rule ID 11378 //
     /*  705756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  705767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  705770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  705773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705824 */     GIR_RootConstrainSelectedInstOperands,
     /*  705825 */     // GIR_Coverage, 11378,
     /*  705825 */     GIR_EraseRootFromParent_Done,
     /*  705826 */   // Label 11163: @705826
     /*  705826 */   GIM_Try, /*On fail goto*//*Label 11164*/ GIMT_Encode4(705901), // Rule ID 11379 //
     /*  705831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  705842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  705845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  705848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11475:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705899 */     GIR_RootConstrainSelectedInstOperands,
     /*  705900 */     // GIR_Coverage, 11379,
     /*  705900 */     GIR_EraseRootFromParent_Done,
     /*  705901 */   // Label 11164: @705901
     /*  705901 */   GIM_Try, /*On fail goto*//*Label 11165*/ GIMT_Encode4(705976), // Rule ID 11382 //
     /*  705906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  705917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  705920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  705923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705974 */     GIR_RootConstrainSelectedInstOperands,
     /*  705975 */     // GIR_Coverage, 11382,
     /*  705975 */     GIR_EraseRootFromParent_Done,
     /*  705976 */   // Label 11165: @705976
     /*  705976 */   GIM_Try, /*On fail goto*//*Label 11166*/ GIMT_Encode4(706051), // Rule ID 11383 //
     /*  705981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  705992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  705995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  705998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  706030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706049 */     GIR_RootConstrainSelectedInstOperands,
     /*  706050 */     // GIR_Coverage, 11383,
     /*  706050 */     GIR_EraseRootFromParent_Done,
     /*  706051 */   // Label 11166: @706051
     /*  706051 */   GIM_Try, /*On fail goto*//*Label 11167*/ GIMT_Encode4(706126), // Rule ID 11386 //
     /*  706056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  706067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  706070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  706073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706124 */     GIR_RootConstrainSelectedInstOperands,
     /*  706125 */     // GIR_Coverage, 11386,
     /*  706125 */     GIR_EraseRootFromParent_Done,
     /*  706126 */   // Label 11167: @706126
     /*  706126 */   GIM_Try, /*On fail goto*//*Label 11168*/ GIMT_Encode4(706201), // Rule ID 11387 //
     /*  706131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  706142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  706145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  706148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706177 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706199 */     GIR_RootConstrainSelectedInstOperands,
     /*  706200 */     // GIR_Coverage, 11387,
     /*  706200 */     GIR_EraseRootFromParent_Done,
     /*  706201 */   // Label 11168: @706201
     /*  706201 */   GIM_Try, /*On fail goto*//*Label 11169*/ GIMT_Encode4(706276), // Rule ID 11390 //
     /*  706206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  706217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  706220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  706223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706252 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706274 */     GIR_RootConstrainSelectedInstOperands,
     /*  706275 */     // GIR_Coverage, 11390,
     /*  706275 */     GIR_EraseRootFromParent_Done,
     /*  706276 */   // Label 11169: @706276
     /*  706276 */   GIM_Try, /*On fail goto*//*Label 11170*/ GIMT_Encode4(706351), // Rule ID 11391 //
     /*  706281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  706292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  706295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  706298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706327 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706349 */     GIR_RootConstrainSelectedInstOperands,
     /*  706350 */     // GIR_Coverage, 11391,
     /*  706350 */     GIR_EraseRootFromParent_Done,
     /*  706351 */   // Label 11170: @706351
     /*  706351 */   GIM_Try, /*On fail goto*//*Label 11171*/ GIMT_Encode4(706426), // Rule ID 11394 //
     /*  706356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  706367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  706370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  706373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706402 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706424 */     GIR_RootConstrainSelectedInstOperands,
     /*  706425 */     // GIR_Coverage, 11394,
     /*  706425 */     GIR_EraseRootFromParent_Done,
     /*  706426 */   // Label 11171: @706426
     /*  706426 */   GIM_Try, /*On fail goto*//*Label 11172*/ GIMT_Encode4(706501), // Rule ID 11395 //
     /*  706431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  706442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  706445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  706448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706477 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  706477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706499 */     GIR_RootConstrainSelectedInstOperands,
     /*  706500 */     // GIR_Coverage, 11395,
     /*  706500 */     GIR_EraseRootFromParent_Done,
     /*  706501 */   // Label 11172: @706501
     /*  706501 */   GIM_Try, /*On fail goto*//*Label 11173*/ GIMT_Encode4(706576), // Rule ID 11398 //
     /*  706506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706574 */     GIR_RootConstrainSelectedInstOperands,
     /*  706575 */     // GIR_Coverage, 11398,
     /*  706575 */     GIR_EraseRootFromParent_Done,
     /*  706576 */   // Label 11173: @706576
     /*  706576 */   GIM_Try, /*On fail goto*//*Label 11174*/ GIMT_Encode4(706651), // Rule ID 11399 //
     /*  706581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706649 */     GIR_RootConstrainSelectedInstOperands,
     /*  706650 */     // GIR_Coverage, 11399,
     /*  706650 */     GIR_EraseRootFromParent_Done,
     /*  706651 */   // Label 11174: @706651
     /*  706651 */   GIM_Try, /*On fail goto*//*Label 11175*/ GIMT_Encode4(706726), // Rule ID 11402 //
     /*  706656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  706667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  706670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  706673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706724 */     GIR_RootConstrainSelectedInstOperands,
     /*  706725 */     // GIR_Coverage, 11402,
     /*  706725 */     GIR_EraseRootFromParent_Done,
     /*  706726 */   // Label 11175: @706726
     /*  706726 */   GIM_Try, /*On fail goto*//*Label 11176*/ GIMT_Encode4(706801), // Rule ID 11403 //
     /*  706731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  706742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  706745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  706748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706777 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706799 */     GIR_RootConstrainSelectedInstOperands,
     /*  706800 */     // GIR_Coverage, 11403,
     /*  706800 */     GIR_EraseRootFromParent_Done,
     /*  706801 */   // Label 11176: @706801
     /*  706801 */   GIM_Try, /*On fail goto*//*Label 11177*/ GIMT_Encode4(706876), // Rule ID 11406 //
     /*  706806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  706817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  706820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  706823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706874 */     GIR_RootConstrainSelectedInstOperands,
     /*  706875 */     // GIR_Coverage, 11406,
     /*  706875 */     GIR_EraseRootFromParent_Done,
     /*  706876 */   // Label 11177: @706876
     /*  706876 */   GIM_Try, /*On fail goto*//*Label 11178*/ GIMT_Encode4(706951), // Rule ID 11407 //
     /*  706881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  706892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  706895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  706898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706927 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706949 */     GIR_RootConstrainSelectedInstOperands,
     /*  706950 */     // GIR_Coverage, 11407,
     /*  706950 */     GIR_EraseRootFromParent_Done,
     /*  706951 */   // Label 11178: @706951
     /*  706951 */   GIM_Try, /*On fail goto*//*Label 11179*/ GIMT_Encode4(707026), // Rule ID 11410 //
     /*  706956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  706967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  706970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  706973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707024 */     GIR_RootConstrainSelectedInstOperands,
     /*  707025 */     // GIR_Coverage, 11410,
     /*  707025 */     GIR_EraseRootFromParent_Done,
     /*  707026 */   // Label 11179: @707026
     /*  707026 */   GIM_Try, /*On fail goto*//*Label 11180*/ GIMT_Encode4(707101), // Rule ID 11411 //
     /*  707031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  707042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  707045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  707048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  707066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707077 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  707080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707099 */     GIR_RootConstrainSelectedInstOperands,
     /*  707100 */     // GIR_Coverage, 11411,
     /*  707100 */     GIR_EraseRootFromParent_Done,
     /*  707101 */   // Label 11180: @707101
     /*  707101 */   GIM_Try, /*On fail goto*//*Label 11181*/ GIMT_Encode4(707176), // Rule ID 11414 //
     /*  707106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  707117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  707120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  707123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707174 */     GIR_RootConstrainSelectedInstOperands,
     /*  707175 */     // GIR_Coverage, 11414,
     /*  707175 */     GIR_EraseRootFromParent_Done,
     /*  707176 */   // Label 11181: @707176
     /*  707176 */   GIM_Try, /*On fail goto*//*Label 11182*/ GIMT_Encode4(707251), // Rule ID 11415 //
     /*  707181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  707192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  707195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  707198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  707216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707227 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  707230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707249 */     GIR_RootConstrainSelectedInstOperands,
     /*  707250 */     // GIR_Coverage, 11415,
     /*  707250 */     GIR_EraseRootFromParent_Done,
     /*  707251 */   // Label 11182: @707251
     /*  707251 */   GIM_Try, /*On fail goto*//*Label 11183*/ GIMT_Encode4(707326), // Rule ID 11418 //
     /*  707256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  707267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  707270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  707273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  707276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707324 */     GIR_RootConstrainSelectedInstOperands,
     /*  707325 */     // GIR_Coverage, 11418,
     /*  707325 */     GIR_EraseRootFromParent_Done,
     /*  707326 */   // Label 11183: @707326
     /*  707326 */   GIM_Try, /*On fail goto*//*Label 11184*/ GIMT_Encode4(707401), // Rule ID 11419 //
     /*  707331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  707339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  707342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  707345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  707348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  707351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  707366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  707370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707377 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  707380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707399 */     GIR_RootConstrainSelectedInstOperands,
     /*  707400 */     // GIR_Coverage, 11419,
     /*  707400 */     GIR_EraseRootFromParent_Done,
     /*  707401 */   // Label 11184: @707401
     /*  707401 */   GIM_Try, /*On fail goto*//*Label 11185*/ GIMT_Encode4(707476), // Rule ID 11422 //
     /*  707406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  707417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  707420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  707423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  707426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707452 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  707455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707474 */     GIR_RootConstrainSelectedInstOperands,
     /*  707475 */     // GIR_Coverage, 11422,
     /*  707475 */     GIR_EraseRootFromParent_Done,
     /*  707476 */   // Label 11185: @707476
     /*  707476 */   GIM_Try, /*On fail goto*//*Label 11186*/ GIMT_Encode4(707551), // Rule ID 11423 //
     /*  707481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  707492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  707495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  707498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  707501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707527 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  707530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707549 */     GIR_RootConstrainSelectedInstOperands,
     /*  707550 */     // GIR_Coverage, 11423,
     /*  707550 */     GIR_EraseRootFromParent_Done,
     /*  707551 */   // Label 11186: @707551
     /*  707551 */   GIM_Try, /*On fail goto*//*Label 11187*/ GIMT_Encode4(707626), // Rule ID 11426 //
     /*  707556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  707567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  707570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  707573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  707576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707602 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707624 */     GIR_RootConstrainSelectedInstOperands,
     /*  707625 */     // GIR_Coverage, 11426,
     /*  707625 */     GIR_EraseRootFromParent_Done,
     /*  707626 */   // Label 11187: @707626
     /*  707626 */   GIM_Try, /*On fail goto*//*Label 11188*/ GIMT_Encode4(707701), // Rule ID 11427 //
     /*  707631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  707642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  707645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  707648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  707651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707677 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707699 */     GIR_RootConstrainSelectedInstOperands,
     /*  707700 */     // GIR_Coverage, 11427,
     /*  707700 */     GIR_EraseRootFromParent_Done,
     /*  707701 */   // Label 11188: @707701
     /*  707701 */   GIM_Try, /*On fail goto*//*Label 11189*/ GIMT_Encode4(707776), // Rule ID 11430 //
     /*  707706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  707717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  707720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  707723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  707726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707774 */     GIR_RootConstrainSelectedInstOperands,
     /*  707775 */     // GIR_Coverage, 11430,
     /*  707775 */     GIR_EraseRootFromParent_Done,
     /*  707776 */   // Label 11189: @707776
     /*  707776 */   GIM_Try, /*On fail goto*//*Label 11190*/ GIMT_Encode4(707851), // Rule ID 11431 //
     /*  707781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  707792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  707795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  707798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  707801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707827 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707849 */     GIR_RootConstrainSelectedInstOperands,
     /*  707850 */     // GIR_Coverage, 11431,
     /*  707850 */     GIR_EraseRootFromParent_Done,
     /*  707851 */   // Label 11190: @707851
     /*  707851 */   GIM_Try, /*On fail goto*//*Label 11191*/ GIMT_Encode4(707926), // Rule ID 11434 //
     /*  707856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  707867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  707870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  707873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  707876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707924 */     GIR_RootConstrainSelectedInstOperands,
     /*  707925 */     // GIR_Coverage, 11434,
     /*  707925 */     GIR_EraseRootFromParent_Done,
     /*  707926 */   // Label 11191: @707926
     /*  707926 */   GIM_Try, /*On fail goto*//*Label 11192*/ GIMT_Encode4(708001), // Rule ID 11435 //
     /*  707931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  707942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  707945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  707948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  707951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707977 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707999 */     GIR_RootConstrainSelectedInstOperands,
     /*  708000 */     // GIR_Coverage, 11435,
     /*  708000 */     GIR_EraseRootFromParent_Done,
     /*  708001 */   // Label 11192: @708001
     /*  708001 */   GIM_Try, /*On fail goto*//*Label 11193*/ GIMT_Encode4(708076), // Rule ID 11438 //
     /*  708006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  708017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  708020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  708023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  708026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708074 */     GIR_RootConstrainSelectedInstOperands,
     /*  708075 */     // GIR_Coverage, 11438,
     /*  708075 */     GIR_EraseRootFromParent_Done,
     /*  708076 */   // Label 11193: @708076
     /*  708076 */   GIM_Try, /*On fail goto*//*Label 11194*/ GIMT_Encode4(708151), // Rule ID 11439 //
     /*  708081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  708092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  708095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  708098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  708101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708127 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708149 */     GIR_RootConstrainSelectedInstOperands,
     /*  708150 */     // GIR_Coverage, 11439,
     /*  708150 */     GIR_EraseRootFromParent_Done,
     /*  708151 */   // Label 11194: @708151
     /*  708151 */   GIM_Try, /*On fail goto*//*Label 11195*/ GIMT_Encode4(708226), // Rule ID 11442 //
     /*  708156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  708167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  708170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  708173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  708176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708224 */     GIR_RootConstrainSelectedInstOperands,
     /*  708225 */     // GIR_Coverage, 11442,
     /*  708225 */     GIR_EraseRootFromParent_Done,
     /*  708226 */   // Label 11195: @708226
     /*  708226 */   GIM_Try, /*On fail goto*//*Label 11196*/ GIMT_Encode4(708301), // Rule ID 11443 //
     /*  708231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  708242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  708245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  708248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  708251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708277 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  708280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708299 */     GIR_RootConstrainSelectedInstOperands,
     /*  708300 */     // GIR_Coverage, 11443,
     /*  708300 */     GIR_EraseRootFromParent_Done,
     /*  708301 */   // Label 11196: @708301
     /*  708301 */   GIM_Try, /*On fail goto*//*Label 11197*/ GIMT_Encode4(708376), // Rule ID 11446 //
     /*  708306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  708317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  708320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  708323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  708326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708374 */     GIR_RootConstrainSelectedInstOperands,
     /*  708375 */     // GIR_Coverage, 11446,
     /*  708375 */     GIR_EraseRootFromParent_Done,
     /*  708376 */   // Label 11197: @708376
     /*  708376 */   GIM_Try, /*On fail goto*//*Label 11198*/ GIMT_Encode4(708451), // Rule ID 11447 //
     /*  708381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  708392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  708395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  708398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  708401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708427 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708449 */     GIR_RootConstrainSelectedInstOperands,
     /*  708450 */     // GIR_Coverage, 11447,
     /*  708450 */     GIR_EraseRootFromParent_Done,
     /*  708451 */   // Label 11198: @708451
     /*  708451 */   GIM_Try, /*On fail goto*//*Label 11199*/ GIMT_Encode4(708526), // Rule ID 11450 //
     /*  708456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  708467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  708470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  708473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  708476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708502 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708524 */     GIR_RootConstrainSelectedInstOperands,
     /*  708525 */     // GIR_Coverage, 11450,
     /*  708525 */     GIR_EraseRootFromParent_Done,
     /*  708526 */   // Label 11199: @708526
     /*  708526 */   GIM_Try, /*On fail goto*//*Label 11200*/ GIMT_Encode4(708601), // Rule ID 11451 //
     /*  708531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  708542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  708545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  708548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  708551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708577 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708599 */     GIR_RootConstrainSelectedInstOperands,
     /*  708600 */     // GIR_Coverage, 11451,
     /*  708600 */     GIR_EraseRootFromParent_Done,
     /*  708601 */   // Label 11200: @708601
     /*  708601 */   GIM_Try, /*On fail goto*//*Label 11201*/ GIMT_Encode4(708676), // Rule ID 11454 //
     /*  708606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  708617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  708620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  708623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  708626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708674 */     GIR_RootConstrainSelectedInstOperands,
     /*  708675 */     // GIR_Coverage, 11454,
     /*  708675 */     GIR_EraseRootFromParent_Done,
     /*  708676 */   // Label 11201: @708676
     /*  708676 */   GIM_Try, /*On fail goto*//*Label 11202*/ GIMT_Encode4(708751), // Rule ID 11455 //
     /*  708681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  708692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  708695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  708698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  708701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708749 */     GIR_RootConstrainSelectedInstOperands,
     /*  708750 */     // GIR_Coverage, 11455,
     /*  708750 */     GIR_EraseRootFromParent_Done,
     /*  708751 */   // Label 11202: @708751
     /*  708751 */   GIM_Try, /*On fail goto*//*Label 11203*/ GIMT_Encode4(708826), // Rule ID 11458 //
     /*  708756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  708767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  708770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  708773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  708776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  708805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708824 */     GIR_RootConstrainSelectedInstOperands,
     /*  708825 */     // GIR_Coverage, 11458,
     /*  708825 */     GIR_EraseRootFromParent_Done,
     /*  708826 */   // Label 11203: @708826
     /*  708826 */   GIM_Try, /*On fail goto*//*Label 11204*/ GIMT_Encode4(708901), // Rule ID 11459 //
     /*  708831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  708842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  708845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  708848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  708851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708877 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  708880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708899 */     GIR_RootConstrainSelectedInstOperands,
     /*  708900 */     // GIR_Coverage, 11459,
     /*  708900 */     GIR_EraseRootFromParent_Done,
     /*  708901 */   // Label 11204: @708901
     /*  708901 */   GIM_Try, /*On fail goto*//*Label 11205*/ GIMT_Encode4(708976), // Rule ID 11462 //
     /*  708906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  708917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  708920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  708923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  708926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708952 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  708955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708974 */     GIR_RootConstrainSelectedInstOperands,
     /*  708975 */     // GIR_Coverage, 11462,
     /*  708975 */     GIR_EraseRootFromParent_Done,
     /*  708976 */   // Label 11205: @708976
     /*  708976 */   GIM_Try, /*On fail goto*//*Label 11206*/ GIMT_Encode4(709051), // Rule ID 11463 //
     /*  708981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  708992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  708995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  708998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  709001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709027 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709049 */     GIR_RootConstrainSelectedInstOperands,
     /*  709050 */     // GIR_Coverage, 11463,
     /*  709050 */     GIR_EraseRootFromParent_Done,
     /*  709051 */   // Label 11206: @709051
     /*  709051 */   GIM_Try, /*On fail goto*//*Label 11207*/ GIMT_Encode4(709126), // Rule ID 11466 //
     /*  709056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  709067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  709070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  709073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  709076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709102 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709124 */     GIR_RootConstrainSelectedInstOperands,
     /*  709125 */     // GIR_Coverage, 11466,
     /*  709125 */     GIR_EraseRootFromParent_Done,
     /*  709126 */   // Label 11207: @709126
     /*  709126 */   GIM_Try, /*On fail goto*//*Label 11208*/ GIMT_Encode4(709201), // Rule ID 11467 //
     /*  709131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  709142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  709145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  709148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  709151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709177 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709199 */     GIR_RootConstrainSelectedInstOperands,
     /*  709200 */     // GIR_Coverage, 11467,
     /*  709200 */     GIR_EraseRootFromParent_Done,
     /*  709201 */   // Label 11208: @709201
     /*  709201 */   GIM_Try, /*On fail goto*//*Label 11209*/ GIMT_Encode4(709276), // Rule ID 11470 //
     /*  709206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  709217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  709220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  709223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  709226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709274 */     GIR_RootConstrainSelectedInstOperands,
     /*  709275 */     // GIR_Coverage, 11470,
     /*  709275 */     GIR_EraseRootFromParent_Done,
     /*  709276 */   // Label 11209: @709276
     /*  709276 */   GIM_Try, /*On fail goto*//*Label 11210*/ GIMT_Encode4(709351), // Rule ID 11471 //
     /*  709281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  709292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  709295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  709298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  709301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709349 */     GIR_RootConstrainSelectedInstOperands,
     /*  709350 */     // GIR_Coverage, 11471,
     /*  709350 */     GIR_EraseRootFromParent_Done,
     /*  709351 */   // Label 11210: @709351
     /*  709351 */   GIM_Try, /*On fail goto*//*Label 11211*/ GIMT_Encode4(709426), // Rule ID 11474 //
     /*  709356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  709367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  709370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  709373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  709376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709424 */     GIR_RootConstrainSelectedInstOperands,
     /*  709425 */     // GIR_Coverage, 11474,
     /*  709425 */     GIR_EraseRootFromParent_Done,
     /*  709426 */   // Label 11211: @709426
     /*  709426 */   GIM_Try, /*On fail goto*//*Label 11212*/ GIMT_Encode4(709501), // Rule ID 11475 //
     /*  709431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  709442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  709445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  709448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  709451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709477 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709499 */     GIR_RootConstrainSelectedInstOperands,
     /*  709500 */     // GIR_Coverage, 11475,
     /*  709500 */     GIR_EraseRootFromParent_Done,
     /*  709501 */   // Label 11212: @709501
     /*  709501 */   GIM_Try, /*On fail goto*//*Label 11213*/ GIMT_Encode4(709576), // Rule ID 11478 //
     /*  709506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  709517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  709520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  709523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  709526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709574 */     GIR_RootConstrainSelectedInstOperands,
     /*  709575 */     // GIR_Coverage, 11478,
     /*  709575 */     GIR_EraseRootFromParent_Done,
     /*  709576 */   // Label 11213: @709576
     /*  709576 */   GIM_Try, /*On fail goto*//*Label 11214*/ GIMT_Encode4(709651), // Rule ID 11479 //
     /*  709581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  709592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  709595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  709598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  709601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709627 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709649 */     GIR_RootConstrainSelectedInstOperands,
     /*  709650 */     // GIR_Coverage, 11479,
     /*  709650 */     GIR_EraseRootFromParent_Done,
     /*  709651 */   // Label 11214: @709651
     /*  709651 */   GIM_Try, /*On fail goto*//*Label 11215*/ GIMT_Encode4(709726), // Rule ID 11482 //
     /*  709656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  709667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  709670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  709673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  709676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709724 */     GIR_RootConstrainSelectedInstOperands,
     /*  709725 */     // GIR_Coverage, 11482,
     /*  709725 */     GIR_EraseRootFromParent_Done,
     /*  709726 */   // Label 11215: @709726
     /*  709726 */   GIM_Try, /*On fail goto*//*Label 11216*/ GIMT_Encode4(709801), // Rule ID 11483 //
     /*  709731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  709742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  709745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  709748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  709751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709799 */     GIR_RootConstrainSelectedInstOperands,
     /*  709800 */     // GIR_Coverage, 11483,
     /*  709800 */     GIR_EraseRootFromParent_Done,
     /*  709801 */   // Label 11216: @709801
     /*  709801 */   GIM_Try, /*On fail goto*//*Label 11217*/ GIMT_Encode4(709876), // Rule ID 11486 //
     /*  709806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  709817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  709820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  709823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  709826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709874 */     GIR_RootConstrainSelectedInstOperands,
     /*  709875 */     // GIR_Coverage, 11486,
     /*  709875 */     GIR_EraseRootFromParent_Done,
     /*  709876 */   // Label 11217: @709876
     /*  709876 */   GIM_Try, /*On fail goto*//*Label 11218*/ GIMT_Encode4(709951), // Rule ID 11487 //
     /*  709881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  709892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  709895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  709898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  709901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709927 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709949 */     GIR_RootConstrainSelectedInstOperands,
     /*  709950 */     // GIR_Coverage, 11487,
     /*  709950 */     GIR_EraseRootFromParent_Done,
     /*  709951 */   // Label 11218: @709951
     /*  709951 */   GIM_Try, /*On fail goto*//*Label 11219*/ GIMT_Encode4(710026), // Rule ID 11490 //
     /*  709956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  709967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  709970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  709973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  709976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710002 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710024 */     GIR_RootConstrainSelectedInstOperands,
     /*  710025 */     // GIR_Coverage, 11490,
     /*  710025 */     GIR_EraseRootFromParent_Done,
     /*  710026 */   // Label 11219: @710026
     /*  710026 */   GIM_Try, /*On fail goto*//*Label 11220*/ GIMT_Encode4(710101), // Rule ID 11491 //
     /*  710031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  710042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  710045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  710048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  710051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  710070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710077 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  710080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710099 */     GIR_RootConstrainSelectedInstOperands,
     /*  710100 */     // GIR_Coverage, 11491,
     /*  710100 */     GIR_EraseRootFromParent_Done,
     /*  710101 */   // Label 11220: @710101
     /*  710101 */   GIM_Try, /*On fail goto*//*Label 11221*/ GIMT_Encode4(710176), // Rule ID 11494 //
     /*  710106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  710117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  710120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  710123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  710155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710174 */     GIR_RootConstrainSelectedInstOperands,
     /*  710175 */     // GIR_Coverage, 11494,
     /*  710175 */     GIR_EraseRootFromParent_Done,
     /*  710176 */   // Label 11221: @710176
     /*  710176 */   GIM_Try, /*On fail goto*//*Label 11222*/ GIMT_Encode4(710251), // Rule ID 11495 //
     /*  710181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  710192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  710195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  710198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710227 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  710230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710249 */     GIR_RootConstrainSelectedInstOperands,
     /*  710250 */     // GIR_Coverage, 11495,
     /*  710250 */     GIR_EraseRootFromParent_Done,
     /*  710251 */   // Label 11222: @710251
     /*  710251 */   GIM_Try, /*On fail goto*//*Label 11223*/ GIMT_Encode4(710326), // Rule ID 11498 //
     /*  710256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  710267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  710270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  710273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710302 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710324 */     GIR_RootConstrainSelectedInstOperands,
     /*  710325 */     // GIR_Coverage, 11498,
     /*  710325 */     GIR_EraseRootFromParent_Done,
     /*  710326 */   // Label 11223: @710326
     /*  710326 */   GIM_Try, /*On fail goto*//*Label 11224*/ GIMT_Encode4(710401), // Rule ID 11499 //
     /*  710331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  710342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  710345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  710348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710377 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710399 */     GIR_RootConstrainSelectedInstOperands,
     /*  710400 */     // GIR_Coverage, 11499,
     /*  710400 */     GIR_EraseRootFromParent_Done,
     /*  710401 */   // Label 11224: @710401
     /*  710401 */   GIM_Try, /*On fail goto*//*Label 11225*/ GIMT_Encode4(710476), // Rule ID 11502 //
     /*  710406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  710417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  710420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  710423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710474 */     GIR_RootConstrainSelectedInstOperands,
     /*  710475 */     // GIR_Coverage, 11502,
     /*  710475 */     GIR_EraseRootFromParent_Done,
     /*  710476 */   // Label 11225: @710476
     /*  710476 */   GIM_Try, /*On fail goto*//*Label 11226*/ GIMT_Encode4(710551), // Rule ID 11503 //
     /*  710481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  710492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  710495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  710498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710527 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710549 */     GIR_RootConstrainSelectedInstOperands,
     /*  710550 */     // GIR_Coverage, 11503,
     /*  710550 */     GIR_EraseRootFromParent_Done,
     /*  710551 */   // Label 11226: @710551
     /*  710551 */   GIM_Try, /*On fail goto*//*Label 11227*/ GIMT_Encode4(710626), // Rule ID 11506 //
     /*  710556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  710567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  710570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  710573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710602 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710624 */     GIR_RootConstrainSelectedInstOperands,
     /*  710625 */     // GIR_Coverage, 11506,
     /*  710625 */     GIR_EraseRootFromParent_Done,
     /*  710626 */   // Label 11227: @710626
     /*  710626 */   GIM_Try, /*On fail goto*//*Label 11228*/ GIMT_Encode4(710701), // Rule ID 11507 //
     /*  710631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  710642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  710645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  710648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710677 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710699 */     GIR_RootConstrainSelectedInstOperands,
     /*  710700 */     // GIR_Coverage, 11507,
     /*  710700 */     GIR_EraseRootFromParent_Done,
     /*  710701 */   // Label 11228: @710701
     /*  710701 */   GIM_Try, /*On fail goto*//*Label 11229*/ GIMT_Encode4(710776), // Rule ID 11510 //
     /*  710706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  710717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  710720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  710723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710774 */     GIR_RootConstrainSelectedInstOperands,
     /*  710775 */     // GIR_Coverage, 11510,
     /*  710775 */     GIR_EraseRootFromParent_Done,
     /*  710776 */   // Label 11229: @710776
     /*  710776 */   GIM_Try, /*On fail goto*//*Label 11230*/ GIMT_Encode4(710851), // Rule ID 11511 //
     /*  710781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  710792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  710795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  710798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710827 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710849 */     GIR_RootConstrainSelectedInstOperands,
     /*  710850 */     // GIR_Coverage, 11511,
     /*  710850 */     GIR_EraseRootFromParent_Done,
     /*  710851 */   // Label 11230: @710851
     /*  710851 */   GIM_Try, /*On fail goto*//*Label 11231*/ GIMT_Encode4(710926), // Rule ID 11514 //
     /*  710856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  710867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  710870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  710873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710924 */     GIR_RootConstrainSelectedInstOperands,
     /*  710925 */     // GIR_Coverage, 11514,
     /*  710925 */     GIR_EraseRootFromParent_Done,
     /*  710926 */   // Label 11231: @710926
     /*  710926 */   GIM_Try, /*On fail goto*//*Label 11232*/ GIMT_Encode4(711001), // Rule ID 11515 //
     /*  710931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  710942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  710945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  710948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710977 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710999 */     GIR_RootConstrainSelectedInstOperands,
     /*  711000 */     // GIR_Coverage, 11515,
     /*  711000 */     GIR_EraseRootFromParent_Done,
     /*  711001 */   // Label 11232: @711001
     /*  711001 */   GIM_Try, /*On fail goto*//*Label 11233*/ GIMT_Encode4(711076), // Rule ID 11518 //
     /*  711006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  711023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711052 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711074 */     GIR_RootConstrainSelectedInstOperands,
     /*  711075 */     // GIR_Coverage, 11518,
     /*  711075 */     GIR_EraseRootFromParent_Done,
     /*  711076 */   // Label 11233: @711076
     /*  711076 */   GIM_Try, /*On fail goto*//*Label 11234*/ GIMT_Encode4(711151), // Rule ID 11519 //
     /*  711081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  711092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  711095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  711098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711127 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11473:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711149 */     GIR_RootConstrainSelectedInstOperands,
     /*  711150 */     // GIR_Coverage, 11519,
     /*  711150 */     GIR_EraseRootFromParent_Done,
     /*  711151 */   // Label 11234: @711151
     /*  711151 */   GIM_Try, /*On fail goto*//*Label 11235*/ GIMT_Encode4(711226), // Rule ID 11522 //
     /*  711156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  711167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  711170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  711173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711202 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711224 */     GIR_RootConstrainSelectedInstOperands,
     /*  711225 */     // GIR_Coverage, 11522,
     /*  711225 */     GIR_EraseRootFromParent_Done,
     /*  711226 */   // Label 11235: @711226
     /*  711226 */   GIM_Try, /*On fail goto*//*Label 11236*/ GIMT_Encode4(711301), // Rule ID 11523 //
     /*  711231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  711242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  711245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  711248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711277 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11473:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711299 */     GIR_RootConstrainSelectedInstOperands,
     /*  711300 */     // GIR_Coverage, 11523,
     /*  711300 */     GIR_EraseRootFromParent_Done,
     /*  711301 */   // Label 11236: @711301
     /*  711301 */   GIM_Try, /*On fail goto*//*Label 11237*/ GIMT_Encode4(711376), // Rule ID 11526 //
     /*  711306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  711317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  711320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  711323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711352 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711374 */     GIR_RootConstrainSelectedInstOperands,
     /*  711375 */     // GIR_Coverage, 11526,
     /*  711375 */     GIR_EraseRootFromParent_Done,
     /*  711376 */   // Label 11237: @711376
     /*  711376 */   GIM_Try, /*On fail goto*//*Label 11238*/ GIMT_Encode4(711451), // Rule ID 11527 //
     /*  711381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  711392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  711395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  711398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  711416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711427 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  711430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711449 */     GIR_RootConstrainSelectedInstOperands,
     /*  711450 */     // GIR_Coverage, 11527,
     /*  711450 */     GIR_EraseRootFromParent_Done,
     /*  711451 */   // Label 11238: @711451
     /*  711451 */   GIM_Try, /*On fail goto*//*Label 11239*/ GIMT_Encode4(711526), // Rule ID 11530 //
     /*  711456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  711467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  711470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  711473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711502 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711524 */     GIR_RootConstrainSelectedInstOperands,
     /*  711525 */     // GIR_Coverage, 11530,
     /*  711525 */     GIR_EraseRootFromParent_Done,
     /*  711526 */   // Label 11239: @711526
     /*  711526 */   GIM_Try, /*On fail goto*//*Label 11240*/ GIMT_Encode4(711601), // Rule ID 11531 //
     /*  711531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  711542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  711545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  711548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711599 */     GIR_RootConstrainSelectedInstOperands,
     /*  711600 */     // GIR_Coverage, 11531,
     /*  711600 */     GIR_EraseRootFromParent_Done,
     /*  711601 */   // Label 11240: @711601
     /*  711601 */   GIM_Try, /*On fail goto*//*Label 11241*/ GIMT_Encode4(711676), // Rule ID 11534 //
     /*  711606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  711617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  711620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  711623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711652 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  711655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711674 */     GIR_RootConstrainSelectedInstOperands,
     /*  711675 */     // GIR_Coverage, 11534,
     /*  711675 */     GIR_EraseRootFromParent_Done,
     /*  711676 */   // Label 11241: @711676
     /*  711676 */   GIM_Try, /*On fail goto*//*Label 11242*/ GIMT_Encode4(711751), // Rule ID 11535 //
     /*  711681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  711692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  711695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  711698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711727 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  711730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711749 */     GIR_RootConstrainSelectedInstOperands,
     /*  711750 */     // GIR_Coverage, 11535,
     /*  711750 */     GIR_EraseRootFromParent_Done,
     /*  711751 */   // Label 11242: @711751
     /*  711751 */   GIM_Try, /*On fail goto*//*Label 11243*/ GIMT_Encode4(711826), // Rule ID 11538 //
     /*  711756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  711767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  711770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  711773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711802 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  711805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711824 */     GIR_RootConstrainSelectedInstOperands,
     /*  711825 */     // GIR_Coverage, 11538,
     /*  711825 */     GIR_EraseRootFromParent_Done,
     /*  711826 */   // Label 11243: @711826
     /*  711826 */   GIM_Try, /*On fail goto*//*Label 11244*/ GIMT_Encode4(711901), // Rule ID 11539 //
     /*  711831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  711842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  711845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  711848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711877 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  711880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711899 */     GIR_RootConstrainSelectedInstOperands,
     /*  711900 */     // GIR_Coverage, 11539,
     /*  711900 */     GIR_EraseRootFromParent_Done,
     /*  711901 */   // Label 11244: @711901
     /*  711901 */   GIM_Try, /*On fail goto*//*Label 11245*/ GIMT_Encode4(711976), // Rule ID 11542 //
     /*  711906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  711917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  711920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  711923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711974 */     GIR_RootConstrainSelectedInstOperands,
     /*  711975 */     // GIR_Coverage, 11542,
     /*  711975 */     GIR_EraseRootFromParent_Done,
     /*  711976 */   // Label 11245: @711976
     /*  711976 */   GIM_Try, /*On fail goto*//*Label 11246*/ GIMT_Encode4(712051), // Rule ID 11543 //
     /*  711981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  711992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  711995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  711998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712027 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712049 */     GIR_RootConstrainSelectedInstOperands,
     /*  712050 */     // GIR_Coverage, 11543,
     /*  712050 */     GIR_EraseRootFromParent_Done,
     /*  712051 */   // Label 11246: @712051
     /*  712051 */   GIM_Try, /*On fail goto*//*Label 11247*/ GIMT_Encode4(712126), // Rule ID 11546 //
     /*  712056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  712067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  712070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  712073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712102 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712124 */     GIR_RootConstrainSelectedInstOperands,
     /*  712125 */     // GIR_Coverage, 11546,
     /*  712125 */     GIR_EraseRootFromParent_Done,
     /*  712126 */   // Label 11247: @712126
     /*  712126 */   GIM_Try, /*On fail goto*//*Label 11248*/ GIMT_Encode4(712201), // Rule ID 11547 //
     /*  712131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  712142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  712145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  712148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712177 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712199 */     GIR_RootConstrainSelectedInstOperands,
     /*  712200 */     // GIR_Coverage, 11547,
     /*  712200 */     GIR_EraseRootFromParent_Done,
     /*  712201 */   // Label 11248: @712201
     /*  712201 */   GIM_Try, /*On fail goto*//*Label 11249*/ GIMT_Encode4(712276), // Rule ID 11550 //
     /*  712206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  712217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  712220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  712223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712252 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  712252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712274 */     GIR_RootConstrainSelectedInstOperands,
     /*  712275 */     // GIR_Coverage, 11550,
     /*  712275 */     GIR_EraseRootFromParent_Done,
     /*  712276 */   // Label 11249: @712276
     /*  712276 */   GIM_Try, /*On fail goto*//*Label 11250*/ GIMT_Encode4(712351), // Rule ID 11551 //
     /*  712281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  712292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  712295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  712298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712327 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  712327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  712346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712349 */     GIR_RootConstrainSelectedInstOperands,
     /*  712350 */     // GIR_Coverage, 11551,
     /*  712350 */     GIR_EraseRootFromParent_Done,
     /*  712351 */   // Label 11250: @712351
     /*  712351 */   GIM_Try, /*On fail goto*//*Label 11251*/ GIMT_Encode4(712426), // Rule ID 11554 //
     /*  712356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  712367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  712370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  712373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712424 */     GIR_RootConstrainSelectedInstOperands,
     /*  712425 */     // GIR_Coverage, 11554,
     /*  712425 */     GIR_EraseRootFromParent_Done,
     /*  712426 */   // Label 11251: @712426
     /*  712426 */   GIM_Try, /*On fail goto*//*Label 11252*/ GIMT_Encode4(712501), // Rule ID 11555 //
     /*  712431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  712442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  712445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  712448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712477 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  712480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712499 */     GIR_RootConstrainSelectedInstOperands,
     /*  712500 */     // GIR_Coverage, 11555,
     /*  712500 */     GIR_EraseRootFromParent_Done,
     /*  712501 */   // Label 11252: @712501
     /*  712501 */   GIM_Try, /*On fail goto*//*Label 11253*/ GIMT_Encode4(712576), // Rule ID 11558 //
     /*  712506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  712517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  712520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  712523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712552 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712574 */     GIR_RootConstrainSelectedInstOperands,
     /*  712575 */     // GIR_Coverage, 11558,
     /*  712575 */     GIR_EraseRootFromParent_Done,
     /*  712576 */   // Label 11253: @712576
     /*  712576 */   GIM_Try, /*On fail goto*//*Label 11254*/ GIMT_Encode4(712651), // Rule ID 11559 //
     /*  712581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  712592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  712595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  712598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712627 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712649 */     GIR_RootConstrainSelectedInstOperands,
     /*  712650 */     // GIR_Coverage, 11559,
     /*  712650 */     GIR_EraseRootFromParent_Done,
     /*  712651 */   // Label 11254: @712651
     /*  712651 */   GIM_Try, /*On fail goto*//*Label 11255*/ GIMT_Encode4(712726), // Rule ID 11562 //
     /*  712656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  712667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  712670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  712673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712702 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712724 */     GIR_RootConstrainSelectedInstOperands,
     /*  712725 */     // GIR_Coverage, 11562,
     /*  712725 */     GIR_EraseRootFromParent_Done,
     /*  712726 */   // Label 11255: @712726
     /*  712726 */   GIM_Try, /*On fail goto*//*Label 11256*/ GIMT_Encode4(712801), // Rule ID 11563 //
     /*  712731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  712742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  712745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  712748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712777 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712799 */     GIR_RootConstrainSelectedInstOperands,
     /*  712800 */     // GIR_Coverage, 11563,
     /*  712800 */     GIR_EraseRootFromParent_Done,
     /*  712801 */   // Label 11256: @712801
     /*  712801 */   GIM_Try, /*On fail goto*//*Label 11257*/ GIMT_Encode4(712876), // Rule ID 11566 //
     /*  712806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  712809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  712817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  712820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  712823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  712826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  712852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  712855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712874 */     GIR_RootConstrainSelectedInstOperands,
     /*  712875 */     // GIR_Coverage, 11566,
     /*  712875 */     GIR_EraseRootFromParent_Done,
     /*  712876 */   // Label 11257: @712876
     /*  712876 */   GIM_Try, /*On fail goto*//*Label 11258*/ GIMT_Encode4(712951), // Rule ID 11567 //
     /*  712881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  712884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  712892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  712895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  712898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  712901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  712927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  712930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712949 */     GIR_RootConstrainSelectedInstOperands,
     /*  712950 */     // GIR_Coverage, 11567,
     /*  712950 */     GIR_EraseRootFromParent_Done,
     /*  712951 */   // Label 11258: @712951
     /*  712951 */   GIM_Try, /*On fail goto*//*Label 11259*/ GIMT_Encode4(713026), // Rule ID 11570 //
     /*  712956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  712959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  712967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  712970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  712973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  712976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713002 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  713005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713024 */     GIR_RootConstrainSelectedInstOperands,
     /*  713025 */     // GIR_Coverage, 11570,
     /*  713025 */     GIR_EraseRootFromParent_Done,
     /*  713026 */   // Label 11259: @713026
     /*  713026 */   GIM_Try, /*On fail goto*//*Label 11260*/ GIMT_Encode4(713101), // Rule ID 11571 //
     /*  713031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  713051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  713080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713099 */     GIR_RootConstrainSelectedInstOperands,
     /*  713100 */     // GIR_Coverage, 11571,
     /*  713100 */     GIR_EraseRootFromParent_Done,
     /*  713101 */   // Label 11260: @713101
     /*  713101 */   GIM_Try, /*On fail goto*//*Label 11261*/ GIMT_Encode4(713176), // Rule ID 11574 //
     /*  713106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  713155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713174 */     GIR_RootConstrainSelectedInstOperands,
     /*  713175 */     // GIR_Coverage, 11574,
     /*  713175 */     GIR_EraseRootFromParent_Done,
     /*  713176 */   // Label 11261: @713176
     /*  713176 */   GIM_Try, /*On fail goto*//*Label 11262*/ GIMT_Encode4(713251), // Rule ID 11575 //
     /*  713181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713227 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  713230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713249 */     GIR_RootConstrainSelectedInstOperands,
     /*  713250 */     // GIR_Coverage, 11575,
     /*  713250 */     GIR_EraseRootFromParent_Done,
     /*  713251 */   // Label 11262: @713251
     /*  713251 */   GIM_Try, /*On fail goto*//*Label 11263*/ GIMT_Encode4(713326), // Rule ID 11578 //
     /*  713256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  713276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713302 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  713305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713324 */     GIR_RootConstrainSelectedInstOperands,
     /*  713325 */     // GIR_Coverage, 11578,
     /*  713325 */     GIR_EraseRootFromParent_Done,
     /*  713326 */   // Label 11263: @713326
     /*  713326 */   GIM_Try, /*On fail goto*//*Label 11264*/ GIMT_Encode4(713401), // Rule ID 11579 //
     /*  713331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  713351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713377 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  713380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713399 */     GIR_RootConstrainSelectedInstOperands,
     /*  713400 */     // GIR_Coverage, 11579,
     /*  713400 */     GIR_EraseRootFromParent_Done,
     /*  713401 */   // Label 11264: @713401
     /*  713401 */   GIM_Try, /*On fail goto*//*Label 11265*/ GIMT_Encode4(713476), // Rule ID 11582 //
     /*  713406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713452 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  713455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713474 */     GIR_RootConstrainSelectedInstOperands,
     /*  713475 */     // GIR_Coverage, 11582,
     /*  713475 */     GIR_EraseRootFromParent_Done,
     /*  713476 */   // Label 11265: @713476
     /*  713476 */   GIM_Try, /*On fail goto*//*Label 11266*/ GIMT_Encode4(713551), // Rule ID 11583 //
     /*  713481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  713530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713549 */     GIR_RootConstrainSelectedInstOperands,
     /*  713550 */     // GIR_Coverage, 11583,
     /*  713550 */     GIR_EraseRootFromParent_Done,
     /*  713551 */   // Label 11266: @713551
     /*  713551 */   GIM_Try, /*On fail goto*//*Label 11267*/ GIMT_Encode4(713626), // Rule ID 11586 //
     /*  713556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  713605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713624 */     GIR_RootConstrainSelectedInstOperands,
     /*  713625 */     // GIR_Coverage, 11586,
     /*  713625 */     GIR_EraseRootFromParent_Done,
     /*  713626 */   // Label 11267: @713626
     /*  713626 */   GIM_Try, /*On fail goto*//*Label 11268*/ GIMT_Encode4(713701), // Rule ID 11587 //
     /*  713631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  713680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713699 */     GIR_RootConstrainSelectedInstOperands,
     /*  713700 */     // GIR_Coverage, 11587,
     /*  713700 */     GIR_EraseRootFromParent_Done,
     /*  713701 */   // Label 11268: @713701
     /*  713701 */   GIM_Try, /*On fail goto*//*Label 11269*/ GIMT_Encode4(713776), // Rule ID 11590 //
     /*  713706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  713755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713774 */     GIR_RootConstrainSelectedInstOperands,
     /*  713775 */     // GIR_Coverage, 11590,
     /*  713775 */     GIR_EraseRootFromParent_Done,
     /*  713776 */   // Label 11269: @713776
     /*  713776 */   GIM_Try, /*On fail goto*//*Label 11270*/ GIMT_Encode4(713851), // Rule ID 11591 //
     /*  713781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713827 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  713830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713849 */     GIR_RootConstrainSelectedInstOperands,
     /*  713850 */     // GIR_Coverage, 11591,
     /*  713850 */     GIR_EraseRootFromParent_Done,
     /*  713851 */   // Label 11270: @713851
     /*  713851 */   GIM_Try, /*On fail goto*//*Label 11271*/ GIMT_Encode4(713926), // Rule ID 11594 //
     /*  713856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713902 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  713905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713924 */     GIR_RootConstrainSelectedInstOperands,
     /*  713925 */     // GIR_Coverage, 11594,
     /*  713925 */     GIR_EraseRootFromParent_Done,
     /*  713926 */   // Label 11271: @713926
     /*  713926 */   GIM_Try, /*On fail goto*//*Label 11272*/ GIMT_Encode4(714001), // Rule ID 11595 //
     /*  713931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713977 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  713980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713999 */     GIR_RootConstrainSelectedInstOperands,
     /*  714000 */     // GIR_Coverage, 11595,
     /*  714000 */     GIR_EraseRootFromParent_Done,
     /*  714001 */   // Label 11272: @714001
     /*  714001 */   GIM_Try, /*On fail goto*//*Label 11273*/ GIMT_Encode4(714076), // Rule ID 11598 //
     /*  714006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  714055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714074 */     GIR_RootConstrainSelectedInstOperands,
     /*  714075 */     // GIR_Coverage, 11598,
     /*  714075 */     GIR_EraseRootFromParent_Done,
     /*  714076 */   // Label 11273: @714076
     /*  714076 */   GIM_Try, /*On fail goto*//*Label 11274*/ GIMT_Encode4(714151), // Rule ID 11599 //
     /*  714081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714127 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  714130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714149 */     GIR_RootConstrainSelectedInstOperands,
     /*  714150 */     // GIR_Coverage, 11599,
     /*  714150 */     GIR_EraseRootFromParent_Done,
     /*  714151 */   // Label 11274: @714151
     /*  714151 */   GIM_Try, /*On fail goto*//*Label 11275*/ GIMT_Encode4(714226), // Rule ID 11602 //
     /*  714156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714202 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  714205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714224 */     GIR_RootConstrainSelectedInstOperands,
     /*  714225 */     // GIR_Coverage, 11602,
     /*  714225 */     GIR_EraseRootFromParent_Done,
     /*  714226 */   // Label 11275: @714226
     /*  714226 */   GIM_Try, /*On fail goto*//*Label 11276*/ GIMT_Encode4(714301), // Rule ID 11603 //
     /*  714231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  714280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714299 */     GIR_RootConstrainSelectedInstOperands,
     /*  714300 */     // GIR_Coverage, 11603,
     /*  714300 */     GIR_EraseRootFromParent_Done,
     /*  714301 */   // Label 11276: @714301
     /*  714301 */   GIM_Try, /*On fail goto*//*Label 11277*/ GIMT_Encode4(714376), // Rule ID 11606 //
     /*  714306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  714326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  714355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714374 */     GIR_RootConstrainSelectedInstOperands,
     /*  714375 */     // GIR_Coverage, 11606,
     /*  714375 */     GIR_EraseRootFromParent_Done,
     /*  714376 */   // Label 11277: @714376
     /*  714376 */   GIM_Try, /*On fail goto*//*Label 11278*/ GIMT_Encode4(714451), // Rule ID 11607 //
     /*  714381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  714401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714427 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  714430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714449 */     GIR_RootConstrainSelectedInstOperands,
     /*  714450 */     // GIR_Coverage, 11607,
     /*  714450 */     GIR_EraseRootFromParent_Done,
     /*  714451 */   // Label 11278: @714451
     /*  714451 */   GIM_Try, /*On fail goto*//*Label 11279*/ GIMT_Encode4(714526), // Rule ID 11610 //
     /*  714456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  714476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  714505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714524 */     GIR_RootConstrainSelectedInstOperands,
     /*  714525 */     // GIR_Coverage, 11610,
     /*  714525 */     GIR_EraseRootFromParent_Done,
     /*  714526 */   // Label 11279: @714526
     /*  714526 */   GIM_Try, /*On fail goto*//*Label 11280*/ GIMT_Encode4(714601), // Rule ID 11611 //
     /*  714531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  714551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714577 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  714580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714599 */     GIR_RootConstrainSelectedInstOperands,
     /*  714600 */     // GIR_Coverage, 11611,
     /*  714600 */     GIR_EraseRootFromParent_Done,
     /*  714601 */   // Label 11280: @714601
     /*  714601 */   GIM_Try, /*On fail goto*//*Label 11281*/ GIMT_Encode4(714676), // Rule ID 11614 //
     /*  714606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  714655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714674 */     GIR_RootConstrainSelectedInstOperands,
     /*  714675 */     // GIR_Coverage, 11614,
     /*  714675 */     GIR_EraseRootFromParent_Done,
     /*  714676 */   // Label 11281: @714676
     /*  714676 */   GIM_Try, /*On fail goto*//*Label 11282*/ GIMT_Encode4(714751), // Rule ID 11615 //
     /*  714681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714727 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  714730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714749 */     GIR_RootConstrainSelectedInstOperands,
     /*  714750 */     // GIR_Coverage, 11615,
     /*  714750 */     GIR_EraseRootFromParent_Done,
     /*  714751 */   // Label 11282: @714751
     /*  714751 */   GIM_Try, /*On fail goto*//*Label 11283*/ GIMT_Encode4(714826), // Rule ID 11618 //
     /*  714756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  714805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714824 */     GIR_RootConstrainSelectedInstOperands,
     /*  714825 */     // GIR_Coverage, 11618,
     /*  714825 */     GIR_EraseRootFromParent_Done,
     /*  714826 */   // Label 11283: @714826
     /*  714826 */   GIM_Try, /*On fail goto*//*Label 11284*/ GIMT_Encode4(714901), // Rule ID 11619 //
     /*  714831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714877 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  714880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714899 */     GIR_RootConstrainSelectedInstOperands,
     /*  714900 */     // GIR_Coverage, 11619,
     /*  714900 */     GIR_EraseRootFromParent_Done,
     /*  714901 */   // Label 11284: @714901
     /*  714901 */   GIM_Try, /*On fail goto*//*Label 11285*/ GIMT_Encode4(714976), // Rule ID 11622 //
     /*  714906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  714955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714974 */     GIR_RootConstrainSelectedInstOperands,
     /*  714975 */     // GIR_Coverage, 11622,
     /*  714975 */     GIR_EraseRootFromParent_Done,
     /*  714976 */   // Label 11285: @714976
     /*  714976 */   GIM_Try, /*On fail goto*//*Label 11286*/ GIMT_Encode4(715051), // Rule ID 11623 //
     /*  714981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715027 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  715030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715049 */     GIR_RootConstrainSelectedInstOperands,
     /*  715050 */     // GIR_Coverage, 11623,
     /*  715050 */     GIR_EraseRootFromParent_Done,
     /*  715051 */   // Label 11286: @715051
     /*  715051 */   GIM_Try, /*On fail goto*//*Label 11287*/ GIMT_Encode4(715126), // Rule ID 11626 //
     /*  715056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  715105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715124 */     GIR_RootConstrainSelectedInstOperands,
     /*  715125 */     // GIR_Coverage, 11626,
     /*  715125 */     GIR_EraseRootFromParent_Done,
     /*  715126 */   // Label 11287: @715126
     /*  715126 */   GIM_Try, /*On fail goto*//*Label 11288*/ GIMT_Encode4(715201), // Rule ID 11627 //
     /*  715131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  715139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715177 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  715180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715199 */     GIR_RootConstrainSelectedInstOperands,
     /*  715200 */     // GIR_Coverage, 11627,
     /*  715200 */     GIR_EraseRootFromParent_Done,
     /*  715201 */   // Label 11288: @715201
     /*  715201 */   GIM_Try, /*On fail goto*//*Label 11289*/ GIMT_Encode4(715276), // Rule ID 11630 //
     /*  715206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  715226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  715255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715274 */     GIR_RootConstrainSelectedInstOperands,
     /*  715275 */     // GIR_Coverage, 11630,
     /*  715275 */     GIR_EraseRootFromParent_Done,
     /*  715276 */   // Label 11289: @715276
     /*  715276 */   GIM_Try, /*On fail goto*//*Label 11290*/ GIMT_Encode4(715351), // Rule ID 11631 //
     /*  715281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  715301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  715330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715349 */     GIR_RootConstrainSelectedInstOperands,
     /*  715350 */     // GIR_Coverage, 11631,
     /*  715350 */     GIR_EraseRootFromParent_Done,
     /*  715351 */   // Label 11290: @715351
     /*  715351 */   GIM_Try, /*On fail goto*//*Label 11291*/ GIMT_Encode4(715426), // Rule ID 11634 //
     /*  715356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  715376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  715405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715424 */     GIR_RootConstrainSelectedInstOperands,
     /*  715425 */     // GIR_Coverage, 11634,
     /*  715425 */     GIR_EraseRootFromParent_Done,
     /*  715426 */   // Label 11291: @715426
     /*  715426 */   GIM_Try, /*On fail goto*//*Label 11292*/ GIMT_Encode4(715501), // Rule ID 11635 //
     /*  715431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  715451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715477 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  715480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715499 */     GIR_RootConstrainSelectedInstOperands,
     /*  715500 */     // GIR_Coverage, 11635,
     /*  715500 */     GIR_EraseRootFromParent_Done,
     /*  715501 */   // Label 11292: @715501
     /*  715501 */   GIM_Try, /*On fail goto*//*Label 11293*/ GIMT_Encode4(715576), // Rule ID 11638 //
     /*  715506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  715526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  715555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715574 */     GIR_RootConstrainSelectedInstOperands,
     /*  715575 */     // GIR_Coverage, 11638,
     /*  715575 */     GIR_EraseRootFromParent_Done,
     /*  715576 */   // Label 11293: @715576
     /*  715576 */   GIM_Try, /*On fail goto*//*Label 11294*/ GIMT_Encode4(715651), // Rule ID 11639 //
     /*  715581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  715601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715627 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  715630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715649 */     GIR_RootConstrainSelectedInstOperands,
     /*  715650 */     // GIR_Coverage, 11639,
     /*  715650 */     GIR_EraseRootFromParent_Done,
     /*  715651 */   // Label 11294: @715651
     /*  715651 */   GIM_Try, /*On fail goto*//*Label 11295*/ GIMT_Encode4(715726), // Rule ID 11642 //
     /*  715656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  715676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  715705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715724 */     GIR_RootConstrainSelectedInstOperands,
     /*  715725 */     // GIR_Coverage, 11642,
     /*  715725 */     GIR_EraseRootFromParent_Done,
     /*  715726 */   // Label 11295: @715726
     /*  715726 */   GIM_Try, /*On fail goto*//*Label 11296*/ GIMT_Encode4(715801), // Rule ID 11643 //
     /*  715731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  715751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  715780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715799 */     GIR_RootConstrainSelectedInstOperands,
     /*  715800 */     // GIR_Coverage, 11643,
     /*  715800 */     GIR_EraseRootFromParent_Done,
     /*  715801 */   // Label 11296: @715801
     /*  715801 */   GIM_Try, /*On fail goto*//*Label 11297*/ GIMT_Encode4(715876), // Rule ID 11646 //
     /*  715806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715852 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715874 */     GIR_RootConstrainSelectedInstOperands,
     /*  715875 */     // GIR_Coverage, 11646,
     /*  715875 */     GIR_EraseRootFromParent_Done,
     /*  715876 */   // Label 11297: @715876
     /*  715876 */   GIM_Try, /*On fail goto*//*Label 11298*/ GIMT_Encode4(715951), // Rule ID 11647 //
     /*  715881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715927 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715949 */     GIR_RootConstrainSelectedInstOperands,
     /*  715950 */     // GIR_Coverage, 11647,
     /*  715950 */     GIR_EraseRootFromParent_Done,
     /*  715951 */   // Label 11298: @715951
     /*  715951 */   GIM_Try, /*On fail goto*//*Label 11299*/ GIMT_Encode4(716026), // Rule ID 11650 //
     /*  715956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716002 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716024 */     GIR_RootConstrainSelectedInstOperands,
     /*  716025 */     // GIR_Coverage, 11650,
     /*  716025 */     GIR_EraseRootFromParent_Done,
     /*  716026 */   // Label 11299: @716026
     /*  716026 */   GIM_Try, /*On fail goto*//*Label 11300*/ GIMT_Encode4(716101), // Rule ID 11651 //
     /*  716031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  716042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  716045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  716048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  716066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  716080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716099 */     GIR_RootConstrainSelectedInstOperands,
     /*  716100 */     // GIR_Coverage, 11651,
     /*  716100 */     GIR_EraseRootFromParent_Done,
     /*  716101 */   // Label 11300: @716101
     /*  716101 */   GIM_Try, /*On fail goto*//*Label 11301*/ GIMT_Encode4(716176), // Rule ID 11654 //
     /*  716106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716174 */     GIR_RootConstrainSelectedInstOperands,
     /*  716175 */     // GIR_Coverage, 11654,
     /*  716175 */     GIR_EraseRootFromParent_Done,
     /*  716176 */   // Label 11301: @716176
     /*  716176 */   GIM_Try, /*On fail goto*//*Label 11302*/ GIMT_Encode4(716251), // Rule ID 11655 //
     /*  716181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  716192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  716195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  716198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  716216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716227 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  716230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716249 */     GIR_RootConstrainSelectedInstOperands,
     /*  716250 */     // GIR_Coverage, 11655,
     /*  716250 */     GIR_EraseRootFromParent_Done,
     /*  716251 */   // Label 11302: @716251
     /*  716251 */   GIM_Try, /*On fail goto*//*Label 11303*/ GIMT_Encode4(716326), // Rule ID 11658 //
     /*  716256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  716259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  716276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716302 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  716302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716324 */     GIR_RootConstrainSelectedInstOperands,
     /*  716325 */     // GIR_Coverage, 11658,
     /*  716325 */     GIR_EraseRootFromParent_Done,
     /*  716326 */   // Label 11303: @716326
     /*  716326 */   GIM_Try, /*On fail goto*//*Label 11304*/ GIMT_Encode4(716401), // Rule ID 11659 //
     /*  716331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  716334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  716339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  716342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  716345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  716348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  716351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  716366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  716370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716377 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  716377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  716380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  716396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716399 */     GIR_RootConstrainSelectedInstOperands,
     /*  716400 */     // GIR_Coverage, 11659,
     /*  716400 */     GIR_EraseRootFromParent_Done,
     /*  716401 */   // Label 11304: @716401
     /*  716401 */   GIM_Try, /*On fail goto*//*Label 11305*/ GIMT_Encode4(716476), // Rule ID 11662 //
     /*  716406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  716417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  716420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  716423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  716426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716452 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  716455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716474 */     GIR_RootConstrainSelectedInstOperands,
     /*  716475 */     // GIR_Coverage, 11662,
     /*  716475 */     GIR_EraseRootFromParent_Done,
     /*  716476 */   // Label 11305: @716476
     /*  716476 */   GIM_Try, /*On fail goto*//*Label 11306*/ GIMT_Encode4(716551), // Rule ID 11663 //
     /*  716481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  716492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  716495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  716498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  716501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716527 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  716530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716549 */     GIR_RootConstrainSelectedInstOperands,
     /*  716550 */     // GIR_Coverage, 11663,
     /*  716550 */     GIR_EraseRootFromParent_Done,
     /*  716551 */   // Label 11306: @716551
     /*  716551 */   GIM_Try, /*On fail goto*//*Label 11307*/ GIMT_Encode4(716626), // Rule ID 11666 //
     /*  716556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  716567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  716570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  716573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  716576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716602 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  716605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716624 */     GIR_RootConstrainSelectedInstOperands,
     /*  716625 */     // GIR_Coverage, 11666,
     /*  716625 */     GIR_EraseRootFromParent_Done,
     /*  716626 */   // Label 11307: @716626
     /*  716626 */   GIM_Try, /*On fail goto*//*Label 11308*/ GIMT_Encode4(716701), // Rule ID 11667 //
     /*  716631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  716642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  716645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  716648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  716651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716677 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  716680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716699 */     GIR_RootConstrainSelectedInstOperands,
     /*  716700 */     // GIR_Coverage, 11667,
     /*  716700 */     GIR_EraseRootFromParent_Done,
     /*  716701 */   // Label 11308: @716701
     /*  716701 */   GIM_Try, /*On fail goto*//*Label 11309*/ GIMT_Encode4(716776), // Rule ID 11670 //
     /*  716706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  716717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  716720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  716723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  716726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716752 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  716755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716774 */     GIR_RootConstrainSelectedInstOperands,
     /*  716775 */     // GIR_Coverage, 11670,
     /*  716775 */     GIR_EraseRootFromParent_Done,
     /*  716776 */   // Label 11309: @716776
     /*  716776 */   GIM_Try, /*On fail goto*//*Label 11310*/ GIMT_Encode4(716851), // Rule ID 11671 //
     /*  716781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  716792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  716795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  716798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  716801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716827 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  716830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716849 */     GIR_RootConstrainSelectedInstOperands,
     /*  716850 */     // GIR_Coverage, 11671,
     /*  716850 */     GIR_EraseRootFromParent_Done,
     /*  716851 */   // Label 11310: @716851
     /*  716851 */   GIM_Try, /*On fail goto*//*Label 11311*/ GIMT_Encode4(716926), // Rule ID 11674 //
     /*  716856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  716867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  716870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  716873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  716876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  716902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  716905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716924 */     GIR_RootConstrainSelectedInstOperands,
     /*  716925 */     // GIR_Coverage, 11674,
     /*  716925 */     GIR_EraseRootFromParent_Done,
     /*  716926 */   // Label 11311: @716926
     /*  716926 */   GIM_Try, /*On fail goto*//*Label 11312*/ GIMT_Encode4(717001), // Rule ID 11675 //
     /*  716931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  716942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  716945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  716948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  716951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716977 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  716977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  716980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716999 */     GIR_RootConstrainSelectedInstOperands,
     /*  717000 */     // GIR_Coverage, 11675,
     /*  717000 */     GIR_EraseRootFromParent_Done,
     /*  717001 */   // Label 11312: @717001
     /*  717001 */   GIM_Try, /*On fail goto*//*Label 11313*/ GIMT_Encode4(717076), // Rule ID 11678 //
     /*  717006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  717017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  717020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  717023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  717026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  717055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717074 */     GIR_RootConstrainSelectedInstOperands,
     /*  717075 */     // GIR_Coverage, 11678,
     /*  717075 */     GIR_EraseRootFromParent_Done,
     /*  717076 */   // Label 11313: @717076
     /*  717076 */   GIM_Try, /*On fail goto*//*Label 11314*/ GIMT_Encode4(717151), // Rule ID 11679 //
     /*  717081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  717092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  717095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  717098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  717101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717127 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  717130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717149 */     GIR_RootConstrainSelectedInstOperands,
     /*  717150 */     // GIR_Coverage, 11679,
     /*  717150 */     GIR_EraseRootFromParent_Done,
     /*  717151 */   // Label 11314: @717151
     /*  717151 */   GIM_Try, /*On fail goto*//*Label 11315*/ GIMT_Encode4(717226), // Rule ID 11682 //
     /*  717156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  717167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  717170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  717173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  717176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  717205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717224 */     GIR_RootConstrainSelectedInstOperands,
     /*  717225 */     // GIR_Coverage, 11682,
     /*  717225 */     GIR_EraseRootFromParent_Done,
     /*  717226 */   // Label 11315: @717226
     /*  717226 */   GIM_Try, /*On fail goto*//*Label 11316*/ GIMT_Encode4(717301), // Rule ID 11683 //
     /*  717231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  717242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  717245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  717248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  717251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717277 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  717280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717299 */     GIR_RootConstrainSelectedInstOperands,
     /*  717300 */     // GIR_Coverage, 11683,
     /*  717300 */     GIR_EraseRootFromParent_Done,
     /*  717301 */   // Label 11316: @717301
     /*  717301 */   GIM_Try, /*On fail goto*//*Label 11317*/ GIMT_Encode4(717376), // Rule ID 11686 //
     /*  717306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  717317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  717320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  717323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  717326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  717355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717374 */     GIR_RootConstrainSelectedInstOperands,
     /*  717375 */     // GIR_Coverage, 11686,
     /*  717375 */     GIR_EraseRootFromParent_Done,
     /*  717376 */   // Label 11317: @717376
     /*  717376 */   GIM_Try, /*On fail goto*//*Label 11318*/ GIMT_Encode4(717451), // Rule ID 11687 //
     /*  717381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  717392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  717395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  717398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  717401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717427 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  717430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717449 */     GIR_RootConstrainSelectedInstOperands,
     /*  717450 */     // GIR_Coverage, 11687,
     /*  717450 */     GIR_EraseRootFromParent_Done,
     /*  717451 */   // Label 11318: @717451
     /*  717451 */   GIM_Try, /*On fail goto*//*Label 11319*/ GIMT_Encode4(717526), // Rule ID 11690 //
     /*  717456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  717473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717502 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  717505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717524 */     GIR_RootConstrainSelectedInstOperands,
     /*  717525 */     // GIR_Coverage, 11690,
     /*  717525 */     GIR_EraseRootFromParent_Done,
     /*  717526 */   // Label 11319: @717526
     /*  717526 */   GIM_Try, /*On fail goto*//*Label 11320*/ GIMT_Encode4(717601), // Rule ID 11691 //
     /*  717531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  717548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717577 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  717580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717599 */     GIR_RootConstrainSelectedInstOperands,
     /*  717600 */     // GIR_Coverage, 11691,
     /*  717600 */     GIR_EraseRootFromParent_Done,
     /*  717601 */   // Label 11320: @717601
     /*  717601 */   GIM_Try, /*On fail goto*//*Label 11321*/ GIMT_Encode4(717676), // Rule ID 11694 //
     /*  717606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  717623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  717655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717674 */     GIR_RootConstrainSelectedInstOperands,
     /*  717675 */     // GIR_Coverage, 11694,
     /*  717675 */     GIR_EraseRootFromParent_Done,
     /*  717676 */   // Label 11321: @717676
     /*  717676 */   GIM_Try, /*On fail goto*//*Label 11322*/ GIMT_Encode4(717751), // Rule ID 11695 //
     /*  717681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  717698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  717730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717749 */     GIR_RootConstrainSelectedInstOperands,
     /*  717750 */     // GIR_Coverage, 11695,
     /*  717750 */     GIR_EraseRootFromParent_Done,
     /*  717751 */   // Label 11322: @717751
     /*  717751 */   GIM_Try, /*On fail goto*//*Label 11323*/ GIMT_Encode4(717826), // Rule ID 11698 //
     /*  717756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  717759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  717805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717824 */     GIR_RootConstrainSelectedInstOperands,
     /*  717825 */     // GIR_Coverage, 11698,
     /*  717825 */     GIR_EraseRootFromParent_Done,
     /*  717826 */   // Label 11323: @717826
     /*  717826 */   GIM_Try, /*On fail goto*//*Label 11324*/ GIMT_Encode4(717901), // Rule ID 11699 //
     /*  717831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  717834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  717880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717899 */     GIR_RootConstrainSelectedInstOperands,
     /*  717900 */     // GIR_Coverage, 11699,
     /*  717900 */     GIR_EraseRootFromParent_Done,
     /*  717901 */   // Label 11324: @717901
     /*  717901 */   GIM_Try, /*On fail goto*//*Label 11325*/ GIMT_Encode4(717976), // Rule ID 11702 //
     /*  717906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  717917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  717920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  717923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  717926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  717955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717974 */     GIR_RootConstrainSelectedInstOperands,
     /*  717975 */     // GIR_Coverage, 11702,
     /*  717975 */     GIR_EraseRootFromParent_Done,
     /*  717976 */   // Label 11325: @717976
     /*  717976 */   GIM_Try, /*On fail goto*//*Label 11326*/ GIMT_Encode4(718051), // Rule ID 11703 //
     /*  717981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  717992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  717995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  717998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  718001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  718030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718049 */     GIR_RootConstrainSelectedInstOperands,
     /*  718050 */     // GIR_Coverage, 11703,
     /*  718050 */     GIR_EraseRootFromParent_Done,
     /*  718051 */   // Label 11326: @718051
     /*  718051 */   GIM_Try, /*On fail goto*//*Label 11327*/ GIMT_Encode4(718126), // Rule ID 11706 //
     /*  718056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  718067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  718070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  718073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  718076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718102 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  718105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718124 */     GIR_RootConstrainSelectedInstOperands,
     /*  718125 */     // GIR_Coverage, 11706,
     /*  718125 */     GIR_EraseRootFromParent_Done,
     /*  718126 */   // Label 11327: @718126
     /*  718126 */   GIM_Try, /*On fail goto*//*Label 11328*/ GIMT_Encode4(718201), // Rule ID 11707 //
     /*  718131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  718142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  718145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  718148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  718151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718177 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  718180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718199 */     GIR_RootConstrainSelectedInstOperands,
     /*  718200 */     // GIR_Coverage, 11707,
     /*  718200 */     GIR_EraseRootFromParent_Done,
     /*  718201 */   // Label 11328: @718201
     /*  718201 */   GIM_Try, /*On fail goto*//*Label 11329*/ GIMT_Encode4(718276), // Rule ID 11710 //
     /*  718206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  718217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  718220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  718223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  718226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718252 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  718252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  718255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718274 */     GIR_RootConstrainSelectedInstOperands,
     /*  718275 */     // GIR_Coverage, 11710,
     /*  718275 */     GIR_EraseRootFromParent_Done,
     /*  718276 */   // Label 11329: @718276
     /*  718276 */   GIM_Try, /*On fail goto*//*Label 11330*/ GIMT_Encode4(718351), // Rule ID 11711 //
     /*  718281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  718292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  718295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  718298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  718301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718327 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  718327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  718330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  718346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718349 */     GIR_RootConstrainSelectedInstOperands,
     /*  718350 */     // GIR_Coverage, 11711,
     /*  718350 */     GIR_EraseRootFromParent_Done,
     /*  718351 */   // Label 11330: @718351
     /*  718351 */   GIM_Try, /*On fail goto*//*Label 11331*/ GIMT_Encode4(718426), // Rule ID 11714 //
     /*  718356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  718367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  718370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  718373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  718376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  718405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718424 */     GIR_RootConstrainSelectedInstOperands,
     /*  718425 */     // GIR_Coverage, 11714,
     /*  718425 */     GIR_EraseRootFromParent_Done,
     /*  718426 */   // Label 11331: @718426
     /*  718426 */   GIM_Try, /*On fail goto*//*Label 11332*/ GIMT_Encode4(718501), // Rule ID 11715 //
     /*  718431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  718442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  718445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  718448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  718451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718477 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  718480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718499 */     GIR_RootConstrainSelectedInstOperands,
     /*  718500 */     // GIR_Coverage, 11715,
     /*  718500 */     GIR_EraseRootFromParent_Done,
     /*  718501 */   // Label 11332: @718501
     /*  718501 */   GIM_Try, /*On fail goto*//*Label 11333*/ GIMT_Encode4(718576), // Rule ID 11718 //
     /*  718506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  718517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  718520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  718523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  718526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718552 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  718555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718574 */     GIR_RootConstrainSelectedInstOperands,
     /*  718575 */     // GIR_Coverage, 11718,
     /*  718575 */     GIR_EraseRootFromParent_Done,
     /*  718576 */   // Label 11333: @718576
     /*  718576 */   GIM_Try, /*On fail goto*//*Label 11334*/ GIMT_Encode4(718651), // Rule ID 11719 //
     /*  718581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  718592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  718595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  718598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  718601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718627 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  718630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718649 */     GIR_RootConstrainSelectedInstOperands,
     /*  718650 */     // GIR_Coverage, 11719,
     /*  718650 */     GIR_EraseRootFromParent_Done,
     /*  718651 */   // Label 11334: @718651
     /*  718651 */   GIM_Try, /*On fail goto*//*Label 11335*/ GIMT_Encode4(718726), // Rule ID 11722 //
     /*  718656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  718667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  718670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  718673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  718676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718702 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  718705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718724 */     GIR_RootConstrainSelectedInstOperands,
     /*  718725 */     // GIR_Coverage, 11722,
     /*  718725 */     GIR_EraseRootFromParent_Done,
     /*  718726 */   // Label 11335: @718726
     /*  718726 */   GIM_Try, /*On fail goto*//*Label 11336*/ GIMT_Encode4(718801), // Rule ID 11723 //
     /*  718731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  718742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  718745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  718748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  718751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718777 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  718780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718799 */     GIR_RootConstrainSelectedInstOperands,
     /*  718800 */     // GIR_Coverage, 11723,
     /*  718800 */     GIR_EraseRootFromParent_Done,
     /*  718801 */   // Label 11336: @718801
     /*  718801 */   GIM_Try, /*On fail goto*//*Label 11337*/ GIMT_Encode4(718876), // Rule ID 11726 //
     /*  718806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  718817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  718820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  718823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  718826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  718852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  718855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718874 */     GIR_RootConstrainSelectedInstOperands,
     /*  718875 */     // GIR_Coverage, 11726,
     /*  718875 */     GIR_EraseRootFromParent_Done,
     /*  718876 */   // Label 11337: @718876
     /*  718876 */   GIM_Try, /*On fail goto*//*Label 11338*/ GIMT_Encode4(718951), // Rule ID 11727 //
     /*  718881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  718892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  718895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  718898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  718901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  718927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  718930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718949 */     GIR_RootConstrainSelectedInstOperands,
     /*  718950 */     // GIR_Coverage, 11727,
     /*  718950 */     GIR_EraseRootFromParent_Done,
     /*  718951 */   // Label 11338: @718951
     /*  718951 */   GIM_Try, /*On fail goto*//*Label 11339*/ GIMT_Encode4(719026), // Rule ID 11730 //
     /*  718956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  718967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  718970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  718973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  718976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  719005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719024 */     GIR_RootConstrainSelectedInstOperands,
     /*  719025 */     // GIR_Coverage, 11730,
     /*  719025 */     GIR_EraseRootFromParent_Done,
     /*  719026 */   // Label 11339: @719026
     /*  719026 */   GIM_Try, /*On fail goto*//*Label 11340*/ GIMT_Encode4(719101), // Rule ID 11731 //
     /*  719031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  719042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  719045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  719048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  719051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719077 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  719080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719099 */     GIR_RootConstrainSelectedInstOperands,
     /*  719100 */     // GIR_Coverage, 11731,
     /*  719100 */     GIR_EraseRootFromParent_Done,
     /*  719101 */   // Label 11340: @719101
     /*  719101 */   GIM_Try, /*On fail goto*//*Label 11341*/ GIMT_Encode4(719176), // Rule ID 11734 //
     /*  719106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  719117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  719120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  719123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  719126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719152 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  719155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719174 */     GIR_RootConstrainSelectedInstOperands,
     /*  719175 */     // GIR_Coverage, 11734,
     /*  719175 */     GIR_EraseRootFromParent_Done,
     /*  719176 */   // Label 11341: @719176
     /*  719176 */   GIM_Try, /*On fail goto*//*Label 11342*/ GIMT_Encode4(719251), // Rule ID 11735 //
     /*  719181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  719192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  719195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  719198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  719201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719227 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  719227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  719230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  719246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719249 */     GIR_RootConstrainSelectedInstOperands,
     /*  719250 */     // GIR_Coverage, 11735,
     /*  719250 */     GIR_EraseRootFromParent_Done,
     /*  719251 */   // Label 11342: @719251
     /*  719251 */   GIM_Try, /*On fail goto*//*Label 11343*/ GIMT_Encode4(719326), // Rule ID 11738 //
     /*  719256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  719305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719324 */     GIR_RootConstrainSelectedInstOperands,
     /*  719325 */     // GIR_Coverage, 11738,
     /*  719325 */     GIR_EraseRootFromParent_Done,
     /*  719326 */   // Label 11343: @719326
     /*  719326 */   GIM_Try, /*On fail goto*//*Label 11344*/ GIMT_Encode4(719401), // Rule ID 11739 //
     /*  719331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  719342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  719345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  719348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  719351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  719370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  719380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719399 */     GIR_RootConstrainSelectedInstOperands,
     /*  719400 */     // GIR_Coverage, 11739,
     /*  719400 */     GIR_EraseRootFromParent_Done,
     /*  719401 */   // Label 11344: @719401
     /*  719401 */   GIM_Try, /*On fail goto*//*Label 11345*/ GIMT_Encode4(719476), // Rule ID 11742 //
     /*  719406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719452 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  719455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719474 */     GIR_RootConstrainSelectedInstOperands,
     /*  719475 */     // GIR_Coverage, 11742,
     /*  719475 */     GIR_EraseRootFromParent_Done,
     /*  719476 */   // Label 11345: @719476
     /*  719476 */   GIM_Try, /*On fail goto*//*Label 11346*/ GIMT_Encode4(719551), // Rule ID 11743 //
     /*  719481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  719492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  719495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  719498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  719501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719527 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  719530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719549 */     GIR_RootConstrainSelectedInstOperands,
     /*  719550 */     // GIR_Coverage, 11743,
     /*  719550 */     GIR_EraseRootFromParent_Done,
     /*  719551 */   // Label 11346: @719551
     /*  719551 */   GIM_Try, /*On fail goto*//*Label 11347*/ GIMT_Encode4(719626), // Rule ID 11746 //
     /*  719556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  719605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719624 */     GIR_RootConstrainSelectedInstOperands,
     /*  719625 */     // GIR_Coverage, 11746,
     /*  719625 */     GIR_EraseRootFromParent_Done,
     /*  719626 */   // Label 11347: @719626
     /*  719626 */   GIM_Try, /*On fail goto*//*Label 11348*/ GIMT_Encode4(719701), // Rule ID 11747 //
     /*  719631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719677 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  719680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719699 */     GIR_RootConstrainSelectedInstOperands,
     /*  719700 */     // GIR_Coverage, 11747,
     /*  719700 */     GIR_EraseRootFromParent_Done,
     /*  719701 */   // Label 11348: @719701
     /*  719701 */   GIM_Try, /*On fail goto*//*Label 11349*/ GIMT_Encode4(719776), // Rule ID 11750 //
     /*  719706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  719717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  719720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  719723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719752 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  719752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  719755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719774 */     GIR_RootConstrainSelectedInstOperands,
     /*  719775 */     // GIR_Coverage, 11750,
     /*  719775 */     GIR_EraseRootFromParent_Done,
     /*  719776 */   // Label 11349: @719776
     /*  719776 */   GIM_Try, /*On fail goto*//*Label 11350*/ GIMT_Encode4(719851), // Rule ID 11751 //
     /*  719781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  719792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  719795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  719798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719827 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  719827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  719830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719849 */     GIR_RootConstrainSelectedInstOperands,
     /*  719850 */     // GIR_Coverage, 11751,
     /*  719850 */     GIR_EraseRootFromParent_Done,
     /*  719851 */   // Label 11350: @719851
     /*  719851 */   GIM_Try, /*On fail goto*//*Label 11351*/ GIMT_Encode4(719926), // Rule ID 11754 //
     /*  719856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  719867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  719870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  719873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719902 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  719902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  719905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719924 */     GIR_RootConstrainSelectedInstOperands,
     /*  719925 */     // GIR_Coverage, 11754,
     /*  719925 */     GIR_EraseRootFromParent_Done,
     /*  719926 */   // Label 11351: @719926
     /*  719926 */   GIM_Try, /*On fail goto*//*Label 11352*/ GIMT_Encode4(720001), // Rule ID 11755 //
     /*  719931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  719942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  719945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  719948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719977 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  719977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  719980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719999 */     GIR_RootConstrainSelectedInstOperands,
     /*  720000 */     // GIR_Coverage, 11755,
     /*  720000 */     GIR_EraseRootFromParent_Done,
     /*  720001 */   // Label 11352: @720001
     /*  720001 */   GIM_Try, /*On fail goto*//*Label 11353*/ GIMT_Encode4(720076), // Rule ID 11758 //
     /*  720006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  720055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720074 */     GIR_RootConstrainSelectedInstOperands,
     /*  720075 */     // GIR_Coverage, 11758,
     /*  720075 */     GIR_EraseRootFromParent_Done,
     /*  720076 */   // Label 11353: @720076
     /*  720076 */   GIM_Try, /*On fail goto*//*Label 11354*/ GIMT_Encode4(720151), // Rule ID 11759 //
     /*  720081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  720092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  720095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  720098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720127 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  720130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720149 */     GIR_RootConstrainSelectedInstOperands,
     /*  720150 */     // GIR_Coverage, 11759,
     /*  720150 */     GIR_EraseRootFromParent_Done,
     /*  720151 */   // Label 11354: @720151
     /*  720151 */   GIM_Try, /*On fail goto*//*Label 11355*/ GIMT_Encode4(720226), // Rule ID 11762 //
     /*  720156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720202 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  720205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720224 */     GIR_RootConstrainSelectedInstOperands,
     /*  720225 */     // GIR_Coverage, 11762,
     /*  720225 */     GIR_EraseRootFromParent_Done,
     /*  720226 */   // Label 11355: @720226
     /*  720226 */   GIM_Try, /*On fail goto*//*Label 11356*/ GIMT_Encode4(720301), // Rule ID 11763 //
     /*  720231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  720242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  720245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  720248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720277 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  720280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720299 */     GIR_RootConstrainSelectedInstOperands,
     /*  720300 */     // GIR_Coverage, 11763,
     /*  720300 */     GIR_EraseRootFromParent_Done,
     /*  720301 */   // Label 11356: @720301
     /*  720301 */   GIM_Try, /*On fail goto*//*Label 11357*/ GIMT_Encode4(720376), // Rule ID 11766 //
     /*  720306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  720355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720374 */     GIR_RootConstrainSelectedInstOperands,
     /*  720375 */     // GIR_Coverage, 11766,
     /*  720375 */     GIR_EraseRootFromParent_Done,
     /*  720376 */   // Label 11357: @720376
     /*  720376 */   GIM_Try, /*On fail goto*//*Label 11358*/ GIMT_Encode4(720451), // Rule ID 11767 //
     /*  720381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  720392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  720395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  720398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720427 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  720430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720449 */     GIR_RootConstrainSelectedInstOperands,
     /*  720450 */     // GIR_Coverage, 11767,
     /*  720450 */     GIR_EraseRootFromParent_Done,
     /*  720451 */   // Label 11358: @720451
     /*  720451 */   GIM_Try, /*On fail goto*//*Label 11359*/ GIMT_Encode4(720526), // Rule ID 11770 //
     /*  720456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  720467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  720470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  720473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  720502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  720505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720524 */     GIR_RootConstrainSelectedInstOperands,
     /*  720525 */     // GIR_Coverage, 11770,
     /*  720525 */     GIR_EraseRootFromParent_Done,
     /*  720526 */   // Label 11359: @720526
     /*  720526 */   GIM_Try, /*On fail goto*//*Label 11360*/ GIMT_Encode4(720601), // Rule ID 11771 //
     /*  720531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  720542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  720545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  720548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720577 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  720577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  720580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720599 */     GIR_RootConstrainSelectedInstOperands,
     /*  720600 */     // GIR_Coverage, 11771,
     /*  720600 */     GIR_EraseRootFromParent_Done,
     /*  720601 */   // Label 11360: @720601
     /*  720601 */   GIM_Try, /*On fail goto*//*Label 11361*/ GIMT_Encode4(720676), // Rule ID 11774 //
     /*  720606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  720617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  720620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  720623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  720655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720674 */     GIR_RootConstrainSelectedInstOperands,
     /*  720675 */     // GIR_Coverage, 11774,
     /*  720675 */     GIR_EraseRootFromParent_Done,
     /*  720676 */   // Label 11361: @720676
     /*  720676 */   GIM_Try, /*On fail goto*//*Label 11362*/ GIMT_Encode4(720751), // Rule ID 11775 //
     /*  720681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  720692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  720695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  720698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11183:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  720730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720749 */     GIR_RootConstrainSelectedInstOperands,
     /*  720750 */     // GIR_Coverage, 11775,
     /*  720750 */     GIR_EraseRootFromParent_Done,
     /*  720751 */   // Label 11362: @720751
     /*  720751 */   GIM_Try, /*On fail goto*//*Label 11363*/ GIMT_Encode4(720826), // Rule ID 11778 //
     /*  720756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  720773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  720805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720824 */     GIR_RootConstrainSelectedInstOperands,
     /*  720825 */     // GIR_Coverage, 11778,
     /*  720825 */     GIR_EraseRootFromParent_Done,
     /*  720826 */   // Label 11363: @720826
     /*  720826 */   GIM_Try, /*On fail goto*//*Label 11364*/ GIMT_Encode4(720901), // Rule ID 11779 //
     /*  720831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  720848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720877 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  720880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720899 */     GIR_RootConstrainSelectedInstOperands,
     /*  720900 */     // GIR_Coverage, 11779,
     /*  720900 */     GIR_EraseRootFromParent_Done,
     /*  720901 */   // Label 11364: @720901
     /*  720901 */   GIM_Try, /*On fail goto*//*Label 11365*/ GIMT_Encode4(720976), // Rule ID 11782 //
     /*  720906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  720917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  720920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  720923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  720952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  720955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720974 */     GIR_RootConstrainSelectedInstOperands,
     /*  720975 */     // GIR_Coverage, 11782,
     /*  720975 */     GIR_EraseRootFromParent_Done,
     /*  720976 */   // Label 11365: @720976
     /*  720976 */   GIM_Try, /*On fail goto*//*Label 11366*/ GIMT_Encode4(721051), // Rule ID 11783 //
     /*  720981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  720992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  720995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  720998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721027 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  721030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721049 */     GIR_RootConstrainSelectedInstOperands,
     /*  721050 */     // GIR_Coverage, 11783,
     /*  721050 */     GIR_EraseRootFromParent_Done,
     /*  721051 */   // Label 11366: @721051
     /*  721051 */   GIM_Try, /*On fail goto*//*Label 11367*/ GIMT_Encode4(721126), // Rule ID 11786 //
     /*  721056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  721059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  721102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  721105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721124 */     GIR_RootConstrainSelectedInstOperands,
     /*  721125 */     // GIR_Coverage, 11786,
     /*  721125 */     GIR_EraseRootFromParent_Done,
     /*  721126 */   // Label 11367: @721126
     /*  721126 */   GIM_Try, /*On fail goto*//*Label 11368*/ GIMT_Encode4(721201), // Rule ID 11787 //
     /*  721131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  721134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  721142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  721145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  721148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  721166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  721177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  721180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  721196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721199 */     GIR_RootConstrainSelectedInstOperands,
     /*  721200 */     // GIR_Coverage, 11787,
     /*  721200 */     GIR_EraseRootFromParent_Done,
     /*  721201 */   // Label 11368: @721201
     /*  721201 */   GIM_Try, /*On fail goto*//*Label 11369*/ GIMT_Encode4(721276), // Rule ID 11790 //
     /*  721206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  721255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721274 */     GIR_RootConstrainSelectedInstOperands,
     /*  721275 */     // GIR_Coverage, 11790,
     /*  721275 */     GIR_EraseRootFromParent_Done,
     /*  721276 */   // Label 11369: @721276
     /*  721276 */   GIM_Try, /*On fail goto*//*Label 11370*/ GIMT_Encode4(721351), // Rule ID 11791 //
     /*  721281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  721292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  721295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  721298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721327 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  721330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721349 */     GIR_RootConstrainSelectedInstOperands,
     /*  721350 */     // GIR_Coverage, 11791,
     /*  721350 */     GIR_EraseRootFromParent_Done,
     /*  721351 */   // Label 11370: @721351
     /*  721351 */   GIM_Try, /*On fail goto*//*Label 11371*/ GIMT_Encode4(721426), // Rule ID 11794 //
     /*  721356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  721405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721424 */     GIR_RootConstrainSelectedInstOperands,
     /*  721425 */     // GIR_Coverage, 11794,
     /*  721425 */     GIR_EraseRootFromParent_Done,
     /*  721426 */   // Label 11371: @721426
     /*  721426 */   GIM_Try, /*On fail goto*//*Label 11372*/ GIMT_Encode4(721501), // Rule ID 11795 //
     /*  721431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  721442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  721445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  721448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721477 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  721480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721499 */     GIR_RootConstrainSelectedInstOperands,
     /*  721500 */     // GIR_Coverage, 11795,
     /*  721500 */     GIR_EraseRootFromParent_Done,
     /*  721501 */   // Label 11372: @721501
     /*  721501 */   GIM_Try, /*On fail goto*//*Label 11373*/ GIMT_Encode4(721576), // Rule ID 11798 //
     /*  721506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  721517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  721520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  721523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721552 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  721555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721574 */     GIR_RootConstrainSelectedInstOperands,
     /*  721575 */     // GIR_Coverage, 11798,
     /*  721575 */     GIR_EraseRootFromParent_Done,
     /*  721576 */   // Label 11373: @721576
     /*  721576 */   GIM_Try, /*On fail goto*//*Label 11374*/ GIMT_Encode4(721651), // Rule ID 11799 //
     /*  721581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  721592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  721595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  721598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721627 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  721630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721649 */     GIR_RootConstrainSelectedInstOperands,
     /*  721650 */     // GIR_Coverage, 11799,
     /*  721650 */     GIR_EraseRootFromParent_Done,
     /*  721651 */   // Label 11374: @721651
     /*  721651 */   GIM_Try, /*On fail goto*//*Label 11375*/ GIMT_Encode4(721726), // Rule ID 11802 //
     /*  721656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  721667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  721670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  721673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  721705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721724 */     GIR_RootConstrainSelectedInstOperands,
     /*  721725 */     // GIR_Coverage, 11802,
     /*  721725 */     GIR_EraseRootFromParent_Done,
     /*  721726 */   // Label 11375: @721726
     /*  721726 */   GIM_Try, /*On fail goto*//*Label 11376*/ GIMT_Encode4(721801), // Rule ID 11803 //
     /*  721731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  721742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  721745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  721748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  721780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721799 */     GIR_RootConstrainSelectedInstOperands,
     /*  721800 */     // GIR_Coverage, 11803,
     /*  721800 */     GIR_EraseRootFromParent_Done,
     /*  721801 */   // Label 11376: @721801
     /*  721801 */   GIM_Try, /*On fail goto*//*Label 11377*/ GIMT_Encode4(721876), // Rule ID 11806 //
     /*  721806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  721817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  721820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  721823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721852 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  721855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721874 */     GIR_RootConstrainSelectedInstOperands,
     /*  721875 */     // GIR_Coverage, 11806,
     /*  721875 */     GIR_EraseRootFromParent_Done,
     /*  721876 */   // Label 11377: @721876
     /*  721876 */   GIM_Try, /*On fail goto*//*Label 11378*/ GIMT_Encode4(721951), // Rule ID 11807 //
     /*  721881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  721892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  721895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  721898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721927 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  721930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721949 */     GIR_RootConstrainSelectedInstOperands,
     /*  721950 */     // GIR_Coverage, 11807,
     /*  721950 */     GIR_EraseRootFromParent_Done,
     /*  721951 */   // Label 11378: @721951
     /*  721951 */   GIM_Try, /*On fail goto*//*Label 11379*/ GIMT_Encode4(722026), // Rule ID 11810 //
     /*  721956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  721967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  721970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  721973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  722005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722024 */     GIR_RootConstrainSelectedInstOperands,
     /*  722025 */     // GIR_Coverage, 11810,
     /*  722025 */     GIR_EraseRootFromParent_Done,
     /*  722026 */   // Label 11379: @722026
     /*  722026 */   GIM_Try, /*On fail goto*//*Label 11380*/ GIMT_Encode4(722101), // Rule ID 11811 //
     /*  722031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  722042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  722045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  722048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722077 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  722077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  722080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  722096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722099 */     GIR_RootConstrainSelectedInstOperands,
     /*  722100 */     // GIR_Coverage, 11811,
     /*  722100 */     GIR_EraseRootFromParent_Done,
     /*  722101 */   // Label 11380: @722101
     /*  722101 */   GIM_Try, /*On fail goto*//*Label 11381*/ GIMT_Encode4(722176), // Rule ID 11814 //
     /*  722106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  722155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722174 */     GIR_RootConstrainSelectedInstOperands,
     /*  722175 */     // GIR_Coverage, 11814,
     /*  722175 */     GIR_EraseRootFromParent_Done,
     /*  722176 */   // Label 11381: @722176
     /*  722176 */   GIM_Try, /*On fail goto*//*Label 11382*/ GIMT_Encode4(722251), // Rule ID 11815 //
     /*  722181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  722192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  722195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  722198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722227 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  722230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722249 */     GIR_RootConstrainSelectedInstOperands,
     /*  722250 */     // GIR_Coverage, 11815,
     /*  722250 */     GIR_EraseRootFromParent_Done,
     /*  722251 */   // Label 11382: @722251
     /*  722251 */   GIM_Try, /*On fail goto*//*Label 11383*/ GIMT_Encode4(722326), // Rule ID 11818 //
     /*  722256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  722305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722324 */     GIR_RootConstrainSelectedInstOperands,
     /*  722325 */     // GIR_Coverage, 11818,
     /*  722325 */     GIR_EraseRootFromParent_Done,
     /*  722326 */   // Label 11383: @722326
     /*  722326 */   GIM_Try, /*On fail goto*//*Label 11384*/ GIMT_Encode4(722401), // Rule ID 11819 //
     /*  722331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  722342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  722345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  722348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722377 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  722380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722399 */     GIR_RootConstrainSelectedInstOperands,
     /*  722400 */     // GIR_Coverage, 11819,
     /*  722400 */     GIR_EraseRootFromParent_Done,
     /*  722401 */   // Label 11384: @722401
     /*  722401 */   GIM_Try, /*On fail goto*//*Label 11385*/ GIMT_Encode4(722476), // Rule ID 11822 //
     /*  722406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  722452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  722455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722474 */     GIR_RootConstrainSelectedInstOperands,
     /*  722475 */     // GIR_Coverage, 11822,
     /*  722475 */     GIR_EraseRootFromParent_Done,
     /*  722476 */   // Label 11385: @722476
     /*  722476 */   GIM_Try, /*On fail goto*//*Label 11386*/ GIMT_Encode4(722551), // Rule ID 11823 //
     /*  722481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  722492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  722495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  722498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722527 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  722530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722549 */     GIR_RootConstrainSelectedInstOperands,
     /*  722550 */     // GIR_Coverage, 11823,
     /*  722550 */     GIR_EraseRootFromParent_Done,
     /*  722551 */   // Label 11386: @722551
     /*  722551 */   GIM_Try, /*On fail goto*//*Label 11387*/ GIMT_Encode4(722626), // Rule ID 11826 //
     /*  722556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  722567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  722570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  722573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  722602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  722605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722624 */     GIR_RootConstrainSelectedInstOperands,
     /*  722625 */     // GIR_Coverage, 11826,
     /*  722625 */     GIR_EraseRootFromParent_Done,
     /*  722626 */   // Label 11387: @722626
     /*  722626 */   GIM_Try, /*On fail goto*//*Label 11388*/ GIMT_Encode4(722701), // Rule ID 11827 //
     /*  722631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  722634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  722642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  722645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  722648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  722677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  722680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722699 */     GIR_RootConstrainSelectedInstOperands,
     /*  722700 */     // GIR_Coverage, 11827,
     /*  722700 */     GIR_EraseRootFromParent_Done,
     /*  722701 */   // Label 11388: @722701
     /*  722701 */   GIM_Try, /*On fail goto*//*Label 11389*/ GIMT_Encode4(722776), // Rule ID 11830 //
     /*  722706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  722717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  722720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  722723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  722752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  722755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722774 */     GIR_RootConstrainSelectedInstOperands,
     /*  722775 */     // GIR_Coverage, 11830,
     /*  722775 */     GIR_EraseRootFromParent_Done,
     /*  722776 */   // Label 11389: @722776
     /*  722776 */   GIM_Try, /*On fail goto*//*Label 11390*/ GIMT_Encode4(722851), // Rule ID 11831 //
     /*  722781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  722784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  722792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  722795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  722798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722827 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  722827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  722830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722849 */     GIR_RootConstrainSelectedInstOperands,
     /*  722850 */     // GIR_Coverage, 11831,
     /*  722850 */     GIR_EraseRootFromParent_Done,
     /*  722851 */   // Label 11390: @722851
     /*  722851 */   GIM_Try, /*On fail goto*//*Label 11391*/ GIMT_Encode4(722926), // Rule ID 11834 //
     /*  722856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  722867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  722870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  722873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722902 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  722902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  722905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722924 */     GIR_RootConstrainSelectedInstOperands,
     /*  722925 */     // GIR_Coverage, 11834,
     /*  722925 */     GIR_EraseRootFromParent_Done,
     /*  722926 */   // Label 11391: @722926
     /*  722926 */   GIM_Try, /*On fail goto*//*Label 11392*/ GIMT_Encode4(723001), // Rule ID 11835 //
     /*  722931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  722934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  722942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  722945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  722948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722977 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  722977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  722980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722999 */     GIR_RootConstrainSelectedInstOperands,
     /*  723000 */     // GIR_Coverage, 11835,
     /*  723000 */     GIR_EraseRootFromParent_Done,
     /*  723001 */   // Label 11392: @723001
     /*  723001 */   GIM_Try, /*On fail goto*//*Label 11393*/ GIMT_Encode4(723076), // Rule ID 11838 //
     /*  723006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  723026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  723055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723074 */     GIR_RootConstrainSelectedInstOperands,
     /*  723075 */     // GIR_Coverage, 11838,
     /*  723075 */     GIR_EraseRootFromParent_Done,
     /*  723076 */   // Label 11393: @723076
     /*  723076 */   GIM_Try, /*On fail goto*//*Label 11394*/ GIMT_Encode4(723151), // Rule ID 11839 //
     /*  723081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  723092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  723095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  723098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  723101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723127 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  723130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723149 */     GIR_RootConstrainSelectedInstOperands,
     /*  723150 */     // GIR_Coverage, 11839,
     /*  723150 */     GIR_EraseRootFromParent_Done,
     /*  723151 */   // Label 11394: @723151
     /*  723151 */   GIM_Try, /*On fail goto*//*Label 11395*/ GIMT_Encode4(723226), // Rule ID 11842 //
     /*  723156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  723176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723202 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  723205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723224 */     GIR_RootConstrainSelectedInstOperands,
     /*  723225 */     // GIR_Coverage, 11842,
     /*  723225 */     GIR_EraseRootFromParent_Done,
     /*  723226 */   // Label 11395: @723226
     /*  723226 */   GIM_Try, /*On fail goto*//*Label 11396*/ GIMT_Encode4(723301), // Rule ID 11843 //
     /*  723231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  723242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  723245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  723248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  723251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723277 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  723280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723299 */     GIR_RootConstrainSelectedInstOperands,
     /*  723300 */     // GIR_Coverage, 11843,
     /*  723300 */     GIR_EraseRootFromParent_Done,
     /*  723301 */   // Label 11396: @723301
     /*  723301 */   GIM_Try, /*On fail goto*//*Label 11397*/ GIMT_Encode4(723376), // Rule ID 11846 //
     /*  723306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  723326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723352 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  723355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723374 */     GIR_RootConstrainSelectedInstOperands,
     /*  723375 */     // GIR_Coverage, 11846,
     /*  723375 */     GIR_EraseRootFromParent_Done,
     /*  723376 */   // Label 11397: @723376
     /*  723376 */   GIM_Try, /*On fail goto*//*Label 11398*/ GIMT_Encode4(723451), // Rule ID 11847 //
     /*  723381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  723392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  723395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  723398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  723401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723427 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  723430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723449 */     GIR_RootConstrainSelectedInstOperands,
     /*  723450 */     // GIR_Coverage, 11847,
     /*  723450 */     GIR_EraseRootFromParent_Done,
     /*  723451 */   // Label 11398: @723451
     /*  723451 */   GIM_Try, /*On fail goto*//*Label 11399*/ GIMT_Encode4(723526), // Rule ID 11850 //
     /*  723456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  723467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  723470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  723473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  723476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  723505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723524 */     GIR_RootConstrainSelectedInstOperands,
     /*  723525 */     // GIR_Coverage, 11850,
     /*  723525 */     GIR_EraseRootFromParent_Done,
     /*  723526 */   // Label 11399: @723526
     /*  723526 */   GIM_Try, /*On fail goto*//*Label 11400*/ GIMT_Encode4(723601), // Rule ID 11851 //
     /*  723531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  723542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  723545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  723548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  723551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723577 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  723580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723599 */     GIR_RootConstrainSelectedInstOperands,
     /*  723600 */     // GIR_Coverage, 11851,
     /*  723600 */     GIR_EraseRootFromParent_Done,
     /*  723601 */   // Label 11400: @723601
     /*  723601 */   GIM_Try, /*On fail goto*//*Label 11401*/ GIMT_Encode4(723676), // Rule ID 11854 //
     /*  723606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  723617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  723620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  723623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  723626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  723655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723674 */     GIR_RootConstrainSelectedInstOperands,
     /*  723675 */     // GIR_Coverage, 11854,
     /*  723675 */     GIR_EraseRootFromParent_Done,
     /*  723676 */   // Label 11401: @723676
     /*  723676 */   GIM_Try, /*On fail goto*//*Label 11402*/ GIMT_Encode4(723751), // Rule ID 11855 //
     /*  723681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  723692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  723695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  723698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  723701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723727 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  723730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723749 */     GIR_RootConstrainSelectedInstOperands,
     /*  723750 */     // GIR_Coverage, 11855,
     /*  723750 */     GIR_EraseRootFromParent_Done,
     /*  723751 */   // Label 11402: @723751
     /*  723751 */   GIM_Try, /*On fail goto*//*Label 11403*/ GIMT_Encode4(723826), // Rule ID 11858 //
     /*  723756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  723767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  723770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  723773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  723776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  723802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  723805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723824 */     GIR_RootConstrainSelectedInstOperands,
     /*  723825 */     // GIR_Coverage, 11858,
     /*  723825 */     GIR_EraseRootFromParent_Done,
     /*  723826 */   // Label 11403: @723826
     /*  723826 */   GIM_Try, /*On fail goto*//*Label 11404*/ GIMT_Encode4(723901), // Rule ID 11859 //
     /*  723831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  723842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  723845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  723848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  723851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723877 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  723877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  723880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723899 */     GIR_RootConstrainSelectedInstOperands,
     /*  723900 */     // GIR_Coverage, 11859,
     /*  723900 */     GIR_EraseRootFromParent_Done,
     /*  723901 */   // Label 11404: @723901
     /*  723901 */   GIM_Try, /*On fail goto*//*Label 11405*/ GIMT_Encode4(723976), // Rule ID 11862 //
     /*  723906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  723923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  723955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723974 */     GIR_RootConstrainSelectedInstOperands,
     /*  723975 */     // GIR_Coverage, 11862,
     /*  723975 */     GIR_EraseRootFromParent_Done,
     /*  723976 */   // Label 11405: @723976
     /*  723976 */   GIM_Try, /*On fail goto*//*Label 11406*/ GIMT_Encode4(724051), // Rule ID 11863 //
     /*  723981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  723998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  724001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724027 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  724030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724049 */     GIR_RootConstrainSelectedInstOperands,
     /*  724050 */     // GIR_Coverage, 11863,
     /*  724050 */     GIR_EraseRootFromParent_Done,
     /*  724051 */   // Label 11406: @724051
     /*  724051 */   GIM_Try, /*On fail goto*//*Label 11407*/ GIMT_Encode4(724126), // Rule ID 11866 //
     /*  724056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  724076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  724105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724124 */     GIR_RootConstrainSelectedInstOperands,
     /*  724125 */     // GIR_Coverage, 11866,
     /*  724125 */     GIR_EraseRootFromParent_Done,
     /*  724126 */   // Label 11407: @724126
     /*  724126 */   GIM_Try, /*On fail goto*//*Label 11408*/ GIMT_Encode4(724201), // Rule ID 11867 //
     /*  724131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  724142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  724145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  724148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  724151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724177 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  724180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724199 */     GIR_RootConstrainSelectedInstOperands,
     /*  724200 */     // GIR_Coverage, 11867,
     /*  724200 */     GIR_EraseRootFromParent_Done,
     /*  724201 */   // Label 11408: @724201
     /*  724201 */   GIM_Try, /*On fail goto*//*Label 11409*/ GIMT_Encode4(724276), // Rule ID 11870 //
     /*  724206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  724255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724274 */     GIR_RootConstrainSelectedInstOperands,
     /*  724275 */     // GIR_Coverage, 11870,
     /*  724275 */     GIR_EraseRootFromParent_Done,
     /*  724276 */   // Label 11409: @724276
     /*  724276 */   GIM_Try, /*On fail goto*//*Label 11410*/ GIMT_Encode4(724351), // Rule ID 11871 //
     /*  724281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  724292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  724295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  724298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  724301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724327 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  724327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  724330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724349 */     GIR_RootConstrainSelectedInstOperands,
     /*  724350 */     // GIR_Coverage, 11871,
     /*  724350 */     GIR_EraseRootFromParent_Done,
     /*  724351 */   // Label 11410: @724351
     /*  724351 */   GIM_Try, /*On fail goto*//*Label 11411*/ GIMT_Encode4(724426), // Rule ID 11874 //
     /*  724356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  724359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  724402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  724405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724424 */     GIR_RootConstrainSelectedInstOperands,
     /*  724425 */     // GIR_Coverage, 11874,
     /*  724425 */     GIR_EraseRootFromParent_Done,
     /*  724426 */   // Label 11411: @724426
     /*  724426 */   GIM_Try, /*On fail goto*//*Label 11412*/ GIMT_Encode4(724501), // Rule ID 11875 //
     /*  724431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  724434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  724442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  724445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  724448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  724451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  724470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724477 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  724477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  724480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  724496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724499 */     GIR_RootConstrainSelectedInstOperands,
     /*  724500 */     // GIR_Coverage, 11875,
     /*  724500 */     GIR_EraseRootFromParent_Done,
     /*  724501 */   // Label 11412: @724501
     /*  724501 */   GIM_Try, /*On fail goto*//*Label 11413*/ GIMT_Encode4(724576), // Rule ID 11878 //
     /*  724506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  724517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  724520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  724523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  724526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  724555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724574 */     GIR_RootConstrainSelectedInstOperands,
     /*  724575 */     // GIR_Coverage, 11878,
     /*  724575 */     GIR_EraseRootFromParent_Done,
     /*  724576 */   // Label 11413: @724576
     /*  724576 */   GIM_Try, /*On fail goto*//*Label 11414*/ GIMT_Encode4(724651), // Rule ID 11879 //
     /*  724581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  724592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  724595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  724598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  724601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724627 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  724630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724649 */     GIR_RootConstrainSelectedInstOperands,
     /*  724650 */     // GIR_Coverage, 11879,
     /*  724650 */     GIR_EraseRootFromParent_Done,
     /*  724651 */   // Label 11414: @724651
     /*  724651 */   GIM_Try, /*On fail goto*//*Label 11415*/ GIMT_Encode4(724726), // Rule ID 11882 //
     /*  724656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  724667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  724670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  724673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  724676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724702 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  724705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724724 */     GIR_RootConstrainSelectedInstOperands,
     /*  724725 */     // GIR_Coverage, 11882,
     /*  724725 */     GIR_EraseRootFromParent_Done,
     /*  724726 */   // Label 11415: @724726
     /*  724726 */   GIM_Try, /*On fail goto*//*Label 11416*/ GIMT_Encode4(724801), // Rule ID 11883 //
     /*  724731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  724742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  724745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  724748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  724751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724777 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  724780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724799 */     GIR_RootConstrainSelectedInstOperands,
     /*  724800 */     // GIR_Coverage, 11883,
     /*  724800 */     GIR_EraseRootFromParent_Done,
     /*  724801 */   // Label 11416: @724801
     /*  724801 */   GIM_Try, /*On fail goto*//*Label 11417*/ GIMT_Encode4(724876), // Rule ID 11886 //
     /*  724806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  724817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  724820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  724823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  724826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724852 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  724855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724874 */     GIR_RootConstrainSelectedInstOperands,
     /*  724875 */     // GIR_Coverage, 11886,
     /*  724875 */     GIR_EraseRootFromParent_Done,
     /*  724876 */   // Label 11417: @724876
     /*  724876 */   GIM_Try, /*On fail goto*//*Label 11418*/ GIMT_Encode4(724951), // Rule ID 11887 //
     /*  724881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  724892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  724895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  724898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  724901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724927 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  724930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724949 */     GIR_RootConstrainSelectedInstOperands,
     /*  724950 */     // GIR_Coverage, 11887,
     /*  724950 */     GIR_EraseRootFromParent_Done,
     /*  724951 */   // Label 11418: @724951
     /*  724951 */   GIM_Try, /*On fail goto*//*Label 11419*/ GIMT_Encode4(725026), // Rule ID 11890 //
     /*  724956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  724967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  724970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  724973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  724976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  725005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725024 */     GIR_RootConstrainSelectedInstOperands,
     /*  725025 */     // GIR_Coverage, 11890,
     /*  725025 */     GIR_EraseRootFromParent_Done,
     /*  725026 */   // Label 11419: @725026
     /*  725026 */   GIM_Try, /*On fail goto*//*Label 11420*/ GIMT_Encode4(725101), // Rule ID 11891 //
     /*  725031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  725042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  725045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  725048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  725051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  725080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725099 */     GIR_RootConstrainSelectedInstOperands,
     /*  725100 */     // GIR_Coverage, 11891,
     /*  725100 */     GIR_EraseRootFromParent_Done,
     /*  725101 */   // Label 11420: @725101
     /*  725101 */   GIM_Try, /*On fail goto*//*Label 11421*/ GIMT_Encode4(725176), // Rule ID 11894 //
     /*  725106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  725126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  725155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725174 */     GIR_RootConstrainSelectedInstOperands,
     /*  725175 */     // GIR_Coverage, 11894,
     /*  725175 */     GIR_EraseRootFromParent_Done,
     /*  725176 */   // Label 11421: @725176
     /*  725176 */   GIM_Try, /*On fail goto*//*Label 11422*/ GIMT_Encode4(725251), // Rule ID 11895 //
     /*  725181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  725192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  725195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  725198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  725201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725227 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  725230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725249 */     GIR_RootConstrainSelectedInstOperands,
     /*  725250 */     // GIR_Coverage, 11895,
     /*  725250 */     GIR_EraseRootFromParent_Done,
     /*  725251 */   // Label 11422: @725251
     /*  725251 */   GIM_Try, /*On fail goto*//*Label 11423*/ GIMT_Encode4(725326), // Rule ID 11898 //
     /*  725256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  725276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725302 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  725302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  725305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725324 */     GIR_RootConstrainSelectedInstOperands,
     /*  725325 */     // GIR_Coverage, 11898,
     /*  725325 */     GIR_EraseRootFromParent_Done,
     /*  725326 */   // Label 11423: @725326
     /*  725326 */   GIM_Try, /*On fail goto*//*Label 11424*/ GIMT_Encode4(725401), // Rule ID 11899 //
     /*  725331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  725342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  725345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  725348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  725351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725377 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  725377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  725380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  725396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725399 */     GIR_RootConstrainSelectedInstOperands,
     /*  725400 */     // GIR_Coverage, 11899,
     /*  725400 */     GIR_EraseRootFromParent_Done,
     /*  725401 */   // Label 11424: @725401
     /*  725401 */   GIM_Try, /*On fail goto*//*Label 11425*/ GIMT_Encode4(725476), // Rule ID 11902 //
     /*  725406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  725426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  725455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725474 */     GIR_RootConstrainSelectedInstOperands,
     /*  725475 */     // GIR_Coverage, 11902,
     /*  725475 */     GIR_EraseRootFromParent_Done,
     /*  725476 */   // Label 11425: @725476
     /*  725476 */   GIM_Try, /*On fail goto*//*Label 11426*/ GIMT_Encode4(725551), // Rule ID 11903 //
     /*  725481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  725492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  725495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  725498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  725501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  725530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725549 */     GIR_RootConstrainSelectedInstOperands,
     /*  725550 */     // GIR_Coverage, 11903,
     /*  725550 */     GIR_EraseRootFromParent_Done,
     /*  725551 */   // Label 11426: @725551
     /*  725551 */   GIM_Try, /*On fail goto*//*Label 11427*/ GIMT_Encode4(725626), // Rule ID 11906 //
     /*  725556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  725567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  725570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  725573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  725576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  725605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725624 */     GIR_RootConstrainSelectedInstOperands,
     /*  725625 */     // GIR_Coverage, 11906,
     /*  725625 */     GIR_EraseRootFromParent_Done,
     /*  725626 */   // Label 11427: @725626
     /*  725626 */   GIM_Try, /*On fail goto*//*Label 11428*/ GIMT_Encode4(725701), // Rule ID 11907 //
     /*  725631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  725642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  725645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  725648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  725651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725677 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  725680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725699 */     GIR_RootConstrainSelectedInstOperands,
     /*  725700 */     // GIR_Coverage, 11907,
     /*  725700 */     GIR_EraseRootFromParent_Done,
     /*  725701 */   // Label 11428: @725701
     /*  725701 */   GIM_Try, /*On fail goto*//*Label 11429*/ GIMT_Encode4(725776), // Rule ID 11910 //
     /*  725706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  725717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  725720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  725723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  725726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  725755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725774 */     GIR_RootConstrainSelectedInstOperands,
     /*  725775 */     // GIR_Coverage, 11910,
     /*  725775 */     GIR_EraseRootFromParent_Done,
     /*  725776 */   // Label 11429: @725776
     /*  725776 */   GIM_Try, /*On fail goto*//*Label 11430*/ GIMT_Encode4(725851), // Rule ID 11911 //
     /*  725781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  725792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  725795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  725798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  725801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725827 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  725830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725849 */     GIR_RootConstrainSelectedInstOperands,
     /*  725850 */     // GIR_Coverage, 11911,
     /*  725850 */     GIR_EraseRootFromParent_Done,
     /*  725851 */   // Label 11430: @725851
     /*  725851 */   GIM_Try, /*On fail goto*//*Label 11431*/ GIMT_Encode4(725926), // Rule ID 11914 //
     /*  725856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  725859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  725867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  725870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  725873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  725876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  725902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  725905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725924 */     GIR_RootConstrainSelectedInstOperands,
     /*  725925 */     // GIR_Coverage, 11914,
     /*  725925 */     GIR_EraseRootFromParent_Done,
     /*  725926 */   // Label 11431: @725926
     /*  725926 */   GIM_Try, /*On fail goto*//*Label 11432*/ GIMT_Encode4(726001), // Rule ID 11915 //
     /*  725931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  725934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  725942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  725945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  725948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  725951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  725977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  725980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725999 */     GIR_RootConstrainSelectedInstOperands,
     /*  726000 */     // GIR_Coverage, 11915,
     /*  726000 */     GIR_EraseRootFromParent_Done,
     /*  726001 */   // Label 11432: @726001
     /*  726001 */   GIM_Try, /*On fail goto*//*Label 11433*/ GIMT_Encode4(726076), // Rule ID 11918 //
     /*  726006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  726026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  726055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726074 */     GIR_RootConstrainSelectedInstOperands,
     /*  726075 */     // GIR_Coverage, 11918,
     /*  726075 */     GIR_EraseRootFromParent_Done,
     /*  726076 */   // Label 11433: @726076
     /*  726076 */   GIM_Try, /*On fail goto*//*Label 11434*/ GIMT_Encode4(726151), // Rule ID 11919 //
     /*  726081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  726092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  726095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  726098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  726101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  726120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  726130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726149 */     GIR_RootConstrainSelectedInstOperands,
     /*  726150 */     // GIR_Coverage, 11919,
     /*  726150 */     GIR_EraseRootFromParent_Done,
     /*  726151 */   // Label 11434: @726151
     /*  726151 */   GIM_Try, /*On fail goto*//*Label 11435*/ GIMT_Encode4(726226), // Rule ID 11922 //
     /*  726156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  726159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  726176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  726202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  726205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726224 */     GIR_RootConstrainSelectedInstOperands,
     /*  726225 */     // GIR_Coverage, 11922,
     /*  726225 */     GIR_EraseRootFromParent_Done,
     /*  726226 */   // Label 11435: @726226
     /*  726226 */   GIM_Try, /*On fail goto*//*Label 11436*/ GIMT_Encode4(726301), // Rule ID 11923 //
     /*  726231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  726234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  726242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  726245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  726248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  726251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  726270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726277 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  726277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  726280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  726296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726299 */     GIR_RootConstrainSelectedInstOperands,
     /*  726300 */     // GIR_Coverage, 11923,
     /*  726300 */     GIR_EraseRootFromParent_Done,
     /*  726301 */   // Label 11436: @726301
     /*  726301 */   GIM_Try, /*On fail goto*//*Label 11437*/ GIMT_Encode4(726376), // Rule ID 11926 //
     /*  726306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  726355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726374 */     GIR_RootConstrainSelectedInstOperands,
     /*  726375 */     // GIR_Coverage, 11926,
     /*  726375 */     GIR_EraseRootFromParent_Done,
     /*  726376 */   // Label 11437: @726376
     /*  726376 */   GIM_Try, /*On fail goto*//*Label 11438*/ GIMT_Encode4(726451), // Rule ID 11927 //
     /*  726381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  726392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  726395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  726398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726427 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  726430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726449 */     GIR_RootConstrainSelectedInstOperands,
     /*  726450 */     // GIR_Coverage, 11927,
     /*  726450 */     GIR_EraseRootFromParent_Done,
     /*  726451 */   // Label 11438: @726451
     /*  726451 */   GIM_Try, /*On fail goto*//*Label 11439*/ GIMT_Encode4(726526), // Rule ID 11930 //
     /*  726456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  726467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  726470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  726473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  726505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726524 */     GIR_RootConstrainSelectedInstOperands,
     /*  726525 */     // GIR_Coverage, 11930,
     /*  726525 */     GIR_EraseRootFromParent_Done,
     /*  726526 */   // Label 11439: @726526
     /*  726526 */   GIM_Try, /*On fail goto*//*Label 11440*/ GIMT_Encode4(726601), // Rule ID 11931 //
     /*  726531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  726542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  726545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  726548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726577 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  726580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726599 */     GIR_RootConstrainSelectedInstOperands,
     /*  726600 */     // GIR_Coverage, 11931,
     /*  726600 */     GIR_EraseRootFromParent_Done,
     /*  726601 */   // Label 11440: @726601
     /*  726601 */   GIM_Try, /*On fail goto*//*Label 11441*/ GIMT_Encode4(726676), // Rule ID 11934 //
     /*  726606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  726617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  726620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  726623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726652 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  726655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726674 */     GIR_RootConstrainSelectedInstOperands,
     /*  726675 */     // GIR_Coverage, 11934,
     /*  726675 */     GIR_EraseRootFromParent_Done,
     /*  726676 */   // Label 11441: @726676
     /*  726676 */   GIM_Try, /*On fail goto*//*Label 11442*/ GIMT_Encode4(726751), // Rule ID 11935 //
     /*  726681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  726692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  726695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  726698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726727 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  726730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726749 */     GIR_RootConstrainSelectedInstOperands,
     /*  726750 */     // GIR_Coverage, 11935,
     /*  726750 */     GIR_EraseRootFromParent_Done,
     /*  726751 */   // Label 11442: @726751
     /*  726751 */   GIM_Try, /*On fail goto*//*Label 11443*/ GIMT_Encode4(726826), // Rule ID 11938 //
     /*  726756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  726767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  726770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  726773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  726802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  726805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726824 */     GIR_RootConstrainSelectedInstOperands,
     /*  726825 */     // GIR_Coverage, 11938,
     /*  726825 */     GIR_EraseRootFromParent_Done,
     /*  726826 */   // Label 11443: @726826
     /*  726826 */   GIM_Try, /*On fail goto*//*Label 11444*/ GIMT_Encode4(726901), // Rule ID 11939 //
     /*  726831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  726842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  726845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  726848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  726877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  726880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726899 */     GIR_RootConstrainSelectedInstOperands,
     /*  726900 */     // GIR_Coverage, 11939,
     /*  726900 */     GIR_EraseRootFromParent_Done,
     /*  726901 */   // Label 11444: @726901
     /*  726901 */   GIM_Try, /*On fail goto*//*Label 11445*/ GIMT_Encode4(726976), // Rule ID 11942 //
     /*  726906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  726917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  726920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  726923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726952 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  726952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  726955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726974 */     GIR_RootConstrainSelectedInstOperands,
     /*  726975 */     // GIR_Coverage, 11942,
     /*  726975 */     GIR_EraseRootFromParent_Done,
     /*  726976 */   // Label 11445: @726976
     /*  726976 */   GIM_Try, /*On fail goto*//*Label 11446*/ GIMT_Encode4(727051), // Rule ID 11943 //
     /*  726981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  726992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  726995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  726998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727027 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  727030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727049 */     GIR_RootConstrainSelectedInstOperands,
     /*  727050 */     // GIR_Coverage, 11943,
     /*  727050 */     GIR_EraseRootFromParent_Done,
     /*  727051 */   // Label 11446: @727051
     /*  727051 */   GIM_Try, /*On fail goto*//*Label 11447*/ GIMT_Encode4(727126), // Rule ID 11946 //
     /*  727056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727102 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  727105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727124 */     GIR_RootConstrainSelectedInstOperands,
     /*  727125 */     // GIR_Coverage, 11946,
     /*  727125 */     GIR_EraseRootFromParent_Done,
     /*  727126 */   // Label 11447: @727126
     /*  727126 */   GIM_Try, /*On fail goto*//*Label 11448*/ GIMT_Encode4(727201), // Rule ID 11947 //
     /*  727131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  727142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  727145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  727148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727177 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  727180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727199 */     GIR_RootConstrainSelectedInstOperands,
     /*  727200 */     // GIR_Coverage, 11947,
     /*  727200 */     GIR_EraseRootFromParent_Done,
     /*  727201 */   // Label 11448: @727201
     /*  727201 */   GIM_Try, /*On fail goto*//*Label 11449*/ GIMT_Encode4(727276), // Rule ID 11950 //
     /*  727206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  727255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727274 */     GIR_RootConstrainSelectedInstOperands,
     /*  727275 */     // GIR_Coverage, 11950,
     /*  727275 */     GIR_EraseRootFromParent_Done,
     /*  727276 */   // Label 11449: @727276
     /*  727276 */   GIM_Try, /*On fail goto*//*Label 11450*/ GIMT_Encode4(727351), // Rule ID 11951 //
     /*  727281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  727292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  727295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  727298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11181:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  727330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727349 */     GIR_RootConstrainSelectedInstOperands,
     /*  727350 */     // GIR_Coverage, 11951,
     /*  727350 */     GIR_EraseRootFromParent_Done,
     /*  727351 */   // Label 11450: @727351
     /*  727351 */   GIM_Try, /*On fail goto*//*Label 11451*/ GIMT_Encode4(727426), // Rule ID 11954 //
     /*  727356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  727405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727424 */     GIR_RootConstrainSelectedInstOperands,
     /*  727425 */     // GIR_Coverage, 11954,
     /*  727425 */     GIR_EraseRootFromParent_Done,
     /*  727426 */   // Label 11451: @727426
     /*  727426 */   GIM_Try, /*On fail goto*//*Label 11452*/ GIMT_Encode4(727501), // Rule ID 11955 //
     /*  727431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  727442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  727445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  727448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  727480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727499 */     GIR_RootConstrainSelectedInstOperands,
     /*  727500 */     // GIR_Coverage, 11955,
     /*  727500 */     GIR_EraseRootFromParent_Done,
     /*  727501 */   // Label 11452: @727501
     /*  727501 */   GIM_Try, /*On fail goto*//*Label 11453*/ GIMT_Encode4(727576), // Rule ID 11958 //
     /*  727506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  727523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  727555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727574 */     GIR_RootConstrainSelectedInstOperands,
     /*  727575 */     // GIR_Coverage, 11958,
     /*  727575 */     GIR_EraseRootFromParent_Done,
     /*  727576 */   // Label 11453: @727576
     /*  727576 */   GIM_Try, /*On fail goto*//*Label 11454*/ GIMT_Encode4(727651), // Rule ID 11959 //
     /*  727581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  727598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727627 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  727630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727649 */     GIR_RootConstrainSelectedInstOperands,
     /*  727650 */     // GIR_Coverage, 11959,
     /*  727650 */     GIR_EraseRootFromParent_Done,
     /*  727651 */   // Label 11454: @727651
     /*  727651 */   GIM_Try, /*On fail goto*//*Label 11455*/ GIMT_Encode4(727726), // Rule ID 11962 //
     /*  727656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  727659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  727667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  727670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  727673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  727702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  727705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  727721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727724 */     GIR_RootConstrainSelectedInstOperands,
     /*  727725 */     // GIR_Coverage, 11962,
     /*  727725 */     GIR_EraseRootFromParent_Done,
     /*  727726 */   // Label 11455: @727726
     /*  727726 */   GIM_Try, /*On fail goto*//*Label 11456*/ GIMT_Encode4(727801), // Rule ID 11963 //
     /*  727731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  727734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  727742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  727745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  727748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727777 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  727777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  727780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  727796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727799 */     GIR_RootConstrainSelectedInstOperands,
     /*  727800 */     // GIR_Coverage, 11963,
     /*  727800 */     GIR_EraseRootFromParent_Done,
     /*  727801 */   // Label 11456: @727801
     /*  727801 */   GIM_Try, /*On fail goto*//*Label 11457*/ GIMT_Encode4(727876), // Rule ID 11966 //
     /*  727806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  727817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  727820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  727823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  727855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727874 */     GIR_RootConstrainSelectedInstOperands,
     /*  727875 */     // GIR_Coverage, 11966,
     /*  727875 */     GIR_EraseRootFromParent_Done,
     /*  727876 */   // Label 11457: @727876
     /*  727876 */   GIM_Try, /*On fail goto*//*Label 11458*/ GIMT_Encode4(727951), // Rule ID 11967 //
     /*  727881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  727892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  727895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  727898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727927 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  727930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727949 */     GIR_RootConstrainSelectedInstOperands,
     /*  727950 */     // GIR_Coverage, 11967,
     /*  727950 */     GIR_EraseRootFromParent_Done,
     /*  727951 */   // Label 11458: @727951
     /*  727951 */   GIM_Try, /*On fail goto*//*Label 11459*/ GIMT_Encode4(728026), // Rule ID 11970 //
     /*  727956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  727967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  727970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  727973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  728005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728024 */     GIR_RootConstrainSelectedInstOperands,
     /*  728025 */     // GIR_Coverage, 11970,
     /*  728025 */     GIR_EraseRootFromParent_Done,
     /*  728026 */   // Label 11459: @728026
     /*  728026 */   GIM_Try, /*On fail goto*//*Label 11460*/ GIMT_Encode4(728101), // Rule ID 11971 //
     /*  728031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  728042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  728045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  728048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728077 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  728080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728099 */     GIR_RootConstrainSelectedInstOperands,
     /*  728100 */     // GIR_Coverage, 11971,
     /*  728100 */     GIR_EraseRootFromParent_Done,
     /*  728101 */   // Label 11460: @728101
     /*  728101 */   GIM_Try, /*On fail goto*//*Label 11461*/ GIMT_Encode4(728176), // Rule ID 11974 //
     /*  728106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728152 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  728152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  728155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728174 */     GIR_RootConstrainSelectedInstOperands,
     /*  728175 */     // GIR_Coverage, 11974,
     /*  728175 */     GIR_EraseRootFromParent_Done,
     /*  728176 */   // Label 11461: @728176
     /*  728176 */   GIM_Try, /*On fail goto*//*Label 11462*/ GIMT_Encode4(728251), // Rule ID 11975 //
     /*  728181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  728192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  728195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  728198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728227 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  728227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  728230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  728246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728249 */     GIR_RootConstrainSelectedInstOperands,
     /*  728250 */     // GIR_Coverage, 11975,
     /*  728250 */     GIR_EraseRootFromParent_Done,
     /*  728251 */   // Label 11462: @728251
     /*  728251 */   GIM_Try, /*On fail goto*//*Label 11463*/ GIMT_Encode4(728326), // Rule ID 11978 //
     /*  728256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  728305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728324 */     GIR_RootConstrainSelectedInstOperands,
     /*  728325 */     // GIR_Coverage, 11978,
     /*  728325 */     GIR_EraseRootFromParent_Done,
     /*  728326 */   // Label 11463: @728326
     /*  728326 */   GIM_Try, /*On fail goto*//*Label 11464*/ GIMT_Encode4(728401), // Rule ID 11979 //
     /*  728331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  728342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  728345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  728348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  728380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728399 */     GIR_RootConstrainSelectedInstOperands,
     /*  728400 */     // GIR_Coverage, 11979,
     /*  728400 */     GIR_EraseRootFromParent_Done,
     /*  728401 */   // Label 11464: @728401
     /*  728401 */   GIM_Try, /*On fail goto*//*Label 11465*/ GIMT_Encode4(728476), // Rule ID 11982 //
     /*  728406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  728455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728474 */     GIR_RootConstrainSelectedInstOperands,
     /*  728475 */     // GIR_Coverage, 11982,
     /*  728475 */     GIR_EraseRootFromParent_Done,
     /*  728476 */   // Label 11465: @728476
     /*  728476 */   GIM_Try, /*On fail goto*//*Label 11466*/ GIMT_Encode4(728551), // Rule ID 11983 //
     /*  728481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  728492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  728495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  728498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728527 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  728530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728549 */     GIR_RootConstrainSelectedInstOperands,
     /*  728550 */     // GIR_Coverage, 11983,
     /*  728550 */     GIR_EraseRootFromParent_Done,
     /*  728551 */   // Label 11466: @728551
     /*  728551 */   GIM_Try, /*On fail goto*//*Label 11467*/ GIMT_Encode4(728626), // Rule ID 11986 //
     /*  728556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  728567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  728570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  728573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  728605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728624 */     GIR_RootConstrainSelectedInstOperands,
     /*  728625 */     // GIR_Coverage, 11986,
     /*  728625 */     GIR_EraseRootFromParent_Done,
     /*  728626 */   // Label 11467: @728626
     /*  728626 */   GIM_Try, /*On fail goto*//*Label 11468*/ GIMT_Encode4(728701), // Rule ID 11987 //
     /*  728631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  728642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  728645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  728648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728677 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  728680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728699 */     GIR_RootConstrainSelectedInstOperands,
     /*  728700 */     // GIR_Coverage, 11987,
     /*  728700 */     GIR_EraseRootFromParent_Done,
     /*  728701 */   // Label 11468: @728701
     /*  728701 */   GIM_Try, /*On fail goto*//*Label 11469*/ GIMT_Encode4(728776), // Rule ID 11990 //
     /*  728706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  728717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  728720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  728723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  728755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728774 */     GIR_RootConstrainSelectedInstOperands,
     /*  728775 */     // GIR_Coverage, 11990,
     /*  728775 */     GIR_EraseRootFromParent_Done,
     /*  728776 */   // Label 11469: @728776
     /*  728776 */   GIM_Try, /*On fail goto*//*Label 11470*/ GIMT_Encode4(728851), // Rule ID 11991 //
     /*  728781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  728792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  728795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  728798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  728830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728849 */     GIR_RootConstrainSelectedInstOperands,
     /*  728850 */     // GIR_Coverage, 11991,
     /*  728850 */     GIR_EraseRootFromParent_Done,
     /*  728851 */   // Label 11470: @728851
     /*  728851 */   GIM_Try, /*On fail goto*//*Label 11471*/ GIMT_Encode4(728926), // Rule ID 11994 //
     /*  728856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  728867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  728870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  728873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  728905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728924 */     GIR_RootConstrainSelectedInstOperands,
     /*  728925 */     // GIR_Coverage, 11994,
     /*  728925 */     GIR_EraseRootFromParent_Done,
     /*  728926 */   // Label 11471: @728926
     /*  728926 */   GIM_Try, /*On fail goto*//*Label 11472*/ GIMT_Encode4(729001), // Rule ID 11995 //
     /*  728931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  728942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  728945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  728948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728977 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  728980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728999 */     GIR_RootConstrainSelectedInstOperands,
     /*  729000 */     // GIR_Coverage, 11995,
     /*  729000 */     GIR_EraseRootFromParent_Done,
     /*  729001 */   // Label 11472: @729001
     /*  729001 */   GIM_Try, /*On fail goto*//*Label 11473*/ GIMT_Encode4(729076), // Rule ID 11998 //
     /*  729006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729052 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  729055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729074 */     GIR_RootConstrainSelectedInstOperands,
     /*  729075 */     // GIR_Coverage, 11998,
     /*  729075 */     GIR_EraseRootFromParent_Done,
     /*  729076 */   // Label 11473: @729076
     /*  729076 */   GIM_Try, /*On fail goto*//*Label 11474*/ GIMT_Encode4(729151), // Rule ID 11999 //
     /*  729081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  729092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  729095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  729098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729127 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  729130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729149 */     GIR_RootConstrainSelectedInstOperands,
     /*  729150 */     // GIR_Coverage, 11999,
     /*  729150 */     GIR_EraseRootFromParent_Done,
     /*  729151 */   // Label 11474: @729151
     /*  729151 */   GIM_Try, /*On fail goto*//*Label 11475*/ GIMT_Encode4(729226), // Rule ID 12002 //
     /*  729156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729202 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  729205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729224 */     GIR_RootConstrainSelectedInstOperands,
     /*  729225 */     // GIR_Coverage, 12002,
     /*  729225 */     GIR_EraseRootFromParent_Done,
     /*  729226 */   // Label 11475: @729226
     /*  729226 */   GIM_Try, /*On fail goto*//*Label 11476*/ GIMT_Encode4(729301), // Rule ID 12003 //
     /*  729231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  729242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  729245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  729248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  729266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  729280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729299 */     GIR_RootConstrainSelectedInstOperands,
     /*  729300 */     // GIR_Coverage, 12003,
     /*  729300 */     GIR_EraseRootFromParent_Done,
     /*  729301 */   // Label 11476: @729301
     /*  729301 */   GIM_Try, /*On fail goto*//*Label 11477*/ GIMT_Encode4(729376), // Rule ID 12006 //
     /*  729306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  729355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729374 */     GIR_RootConstrainSelectedInstOperands,
     /*  729375 */     // GIR_Coverage, 12006,
     /*  729375 */     GIR_EraseRootFromParent_Done,
     /*  729376 */   // Label 11477: @729376
     /*  729376 */   GIM_Try, /*On fail goto*//*Label 11478*/ GIMT_Encode4(729451), // Rule ID 12007 //
     /*  729381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  729392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  729395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  729398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  729416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729427 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  729430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729449 */     GIR_RootConstrainSelectedInstOperands,
     /*  729450 */     // GIR_Coverage, 12007,
     /*  729450 */     GIR_EraseRootFromParent_Done,
     /*  729451 */   // Label 11478: @729451
     /*  729451 */   GIM_Try, /*On fail goto*//*Label 11479*/ GIMT_Encode4(729526), // Rule ID 12010 //
     /*  729456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  729459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  729467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  729470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  729473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  729476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  729502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  729505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729524 */     GIR_RootConstrainSelectedInstOperands,
     /*  729525 */     // GIR_Coverage, 12010,
     /*  729525 */     GIR_EraseRootFromParent_Done,
     /*  729526 */   // Label 11479: @729526
     /*  729526 */   GIM_Try, /*On fail goto*//*Label 11480*/ GIMT_Encode4(729601), // Rule ID 12011 //
     /*  729531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  729542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  729545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  729548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729577 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  729580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729599 */     GIR_RootConstrainSelectedInstOperands,
     /*  729600 */     // GIR_Coverage, 12011,
     /*  729600 */     GIR_EraseRootFromParent_Done,
     /*  729601 */   // Label 11480: @729601
     /*  729601 */   GIM_Try, /*On fail goto*//*Label 11481*/ GIMT_Encode4(729676), // Rule ID 12014 //
     /*  729606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  729617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  729620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  729623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  729626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  729655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729674 */     GIR_RootConstrainSelectedInstOperands,
     /*  729675 */     // GIR_Coverage, 12014,
     /*  729675 */     GIR_EraseRootFromParent_Done,
     /*  729676 */   // Label 11481: @729676
     /*  729676 */   GIM_Try, /*On fail goto*//*Label 11482*/ GIMT_Encode4(729751), // Rule ID 12015 //
     /*  729681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  729692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  729695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  729698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  729701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729727 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  729730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729749 */     GIR_RootConstrainSelectedInstOperands,
     /*  729750 */     // GIR_Coverage, 12015,
     /*  729750 */     GIR_EraseRootFromParent_Done,
     /*  729751 */   // Label 11482: @729751
     /*  729751 */   GIM_Try, /*On fail goto*//*Label 11483*/ GIMT_Encode4(729826), // Rule ID 12018 //
     /*  729756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  729767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  729770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  729773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  729776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729802 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  729805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729824 */     GIR_RootConstrainSelectedInstOperands,
     /*  729825 */     // GIR_Coverage, 12018,
     /*  729825 */     GIR_EraseRootFromParent_Done,
     /*  729826 */   // Label 11483: @729826
     /*  729826 */   GIM_Try, /*On fail goto*//*Label 11484*/ GIMT_Encode4(729901), // Rule ID 12019 //
     /*  729831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  729842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  729845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  729848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  729851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729877 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  729880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729899 */     GIR_RootConstrainSelectedInstOperands,
     /*  729900 */     // GIR_Coverage, 12019,
     /*  729900 */     GIR_EraseRootFromParent_Done,
     /*  729901 */   // Label 11484: @729901
     /*  729901 */   GIM_Try, /*On fail goto*//*Label 11485*/ GIMT_Encode4(729976), // Rule ID 12022 //
     /*  729906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  729917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  729920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  729923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  729926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  729955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729974 */     GIR_RootConstrainSelectedInstOperands,
     /*  729975 */     // GIR_Coverage, 12022,
     /*  729975 */     GIR_EraseRootFromParent_Done,
     /*  729976 */   // Label 11485: @729976
     /*  729976 */   GIM_Try, /*On fail goto*//*Label 11486*/ GIMT_Encode4(730051), // Rule ID 12023 //
     /*  729981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  729992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  729995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  729998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  730001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730027 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  730030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730049 */     GIR_RootConstrainSelectedInstOperands,
     /*  730050 */     // GIR_Coverage, 12023,
     /*  730050 */     GIR_EraseRootFromParent_Done,
     /*  730051 */   // Label 11486: @730051
     /*  730051 */   GIM_Try, /*On fail goto*//*Label 11487*/ GIMT_Encode4(730126), // Rule ID 12026 //
     /*  730056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  730076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  730105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730124 */     GIR_RootConstrainSelectedInstOperands,
     /*  730125 */     // GIR_Coverage, 12026,
     /*  730125 */     GIR_EraseRootFromParent_Done,
     /*  730126 */   // Label 11487: @730126
     /*  730126 */   GIM_Try, /*On fail goto*//*Label 11488*/ GIMT_Encode4(730201), // Rule ID 12027 //
     /*  730131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  730142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  730145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  730148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  730151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  730180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730199 */     GIR_RootConstrainSelectedInstOperands,
     /*  730200 */     // GIR_Coverage, 12027,
     /*  730200 */     GIR_EraseRootFromParent_Done,
     /*  730201 */   // Label 11488: @730201
     /*  730201 */   GIM_Try, /*On fail goto*//*Label 11489*/ GIMT_Encode4(730276), // Rule ID 12030 //
     /*  730206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  730226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  730255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730274 */     GIR_RootConstrainSelectedInstOperands,
     /*  730275 */     // GIR_Coverage, 12030,
     /*  730275 */     GIR_EraseRootFromParent_Done,
     /*  730276 */   // Label 11489: @730276
     /*  730276 */   GIM_Try, /*On fail goto*//*Label 11490*/ GIMT_Encode4(730351), // Rule ID 12031 //
     /*  730281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  730292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  730295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  730298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  730301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  730330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730349 */     GIR_RootConstrainSelectedInstOperands,
     /*  730350 */     // GIR_Coverage, 12031,
     /*  730350 */     GIR_EraseRootFromParent_Done,
     /*  730351 */   // Label 11490: @730351
     /*  730351 */   GIM_Try, /*On fail goto*//*Label 11491*/ GIMT_Encode4(730426), // Rule ID 12034 //
     /*  730356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  730376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  730405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730424 */     GIR_RootConstrainSelectedInstOperands,
     /*  730425 */     // GIR_Coverage, 12034,
     /*  730425 */     GIR_EraseRootFromParent_Done,
     /*  730426 */   // Label 11491: @730426
     /*  730426 */   GIM_Try, /*On fail goto*//*Label 11492*/ GIMT_Encode4(730501), // Rule ID 12035 //
     /*  730431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  730442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  730445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  730448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  730451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730477 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  730477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  730480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730499 */     GIR_RootConstrainSelectedInstOperands,
     /*  730500 */     // GIR_Coverage, 12035,
     /*  730500 */     GIR_EraseRootFromParent_Done,
     /*  730501 */   // Label 11492: @730501
     /*  730501 */   GIM_Try, /*On fail goto*//*Label 11493*/ GIMT_Encode4(730576), // Rule ID 12038 //
     /*  730506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  730523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  730526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  730555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730574 */     GIR_RootConstrainSelectedInstOperands,
     /*  730575 */     // GIR_Coverage, 12038,
     /*  730575 */     GIR_EraseRootFromParent_Done,
     /*  730576 */   // Label 11493: @730576
     /*  730576 */   GIM_Try, /*On fail goto*//*Label 11494*/ GIMT_Encode4(730651), // Rule ID 12039 //
     /*  730581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  730598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  730601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730627 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  730630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730649 */     GIR_RootConstrainSelectedInstOperands,
     /*  730650 */     // GIR_Coverage, 12039,
     /*  730650 */     GIR_EraseRootFromParent_Done,
     /*  730651 */   // Label 11494: @730651
     /*  730651 */   GIM_Try, /*On fail goto*//*Label 11495*/ GIMT_Encode4(730726), // Rule ID 12042 //
     /*  730656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  730673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  730705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730724 */     GIR_RootConstrainSelectedInstOperands,
     /*  730725 */     // GIR_Coverage, 12042,
     /*  730725 */     GIR_EraseRootFromParent_Done,
     /*  730726 */   // Label 11495: @730726
     /*  730726 */   GIM_Try, /*On fail goto*//*Label 11496*/ GIMT_Encode4(730801), // Rule ID 12043 //
     /*  730731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  730748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  730780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730799 */     GIR_RootConstrainSelectedInstOperands,
     /*  730800 */     // GIR_Coverage, 12043,
     /*  730800 */     GIR_EraseRootFromParent_Done,
     /*  730801 */   // Label 11496: @730801
     /*  730801 */   GIM_Try, /*On fail goto*//*Label 11497*/ GIMT_Encode4(730876), // Rule ID 12046 //
     /*  730806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  730823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  730855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730874 */     GIR_RootConstrainSelectedInstOperands,
     /*  730875 */     // GIR_Coverage, 12046,
     /*  730875 */     GIR_EraseRootFromParent_Done,
     /*  730876 */   // Label 11497: @730876
     /*  730876 */   GIM_Try, /*On fail goto*//*Label 11498*/ GIMT_Encode4(730951), // Rule ID 12047 //
     /*  730881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  730898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730927 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  730927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  730930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730949 */     GIR_RootConstrainSelectedInstOperands,
     /*  730950 */     // GIR_Coverage, 12047,
     /*  730950 */     GIR_EraseRootFromParent_Done,
     /*  730951 */   // Label 11498: @730951
     /*  730951 */   GIM_Try, /*On fail goto*//*Label 11499*/ GIMT_Encode4(731026), // Rule ID 12050 //
     /*  730956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  730959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  730967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  730970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  730973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  730976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  731005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731024 */     GIR_RootConstrainSelectedInstOperands,
     /*  731025 */     // GIR_Coverage, 12050,
     /*  731025 */     GIR_EraseRootFromParent_Done,
     /*  731026 */   // Label 11499: @731026
     /*  731026 */   GIM_Try, /*On fail goto*//*Label 11500*/ GIMT_Encode4(731101), // Rule ID 12051 //
     /*  731031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  731034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  731042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  731045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  731048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  731051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  731070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731077 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  731077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  731080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  731096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731099 */     GIR_RootConstrainSelectedInstOperands,
     /*  731100 */     // GIR_Coverage, 12051,
     /*  731100 */     GIR_EraseRootFromParent_Done,
     /*  731101 */   // Label 11500: @731101
     /*  731101 */   GIM_Try, /*On fail goto*//*Label 11501*/ GIMT_Encode4(731176), // Rule ID 12054 //
     /*  731106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  731126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  731155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731174 */     GIR_RootConstrainSelectedInstOperands,
     /*  731175 */     // GIR_Coverage, 12054,
     /*  731175 */     GIR_EraseRootFromParent_Done,
     /*  731176 */   // Label 11501: @731176
     /*  731176 */   GIM_Try, /*On fail goto*//*Label 11502*/ GIMT_Encode4(731251), // Rule ID 12055 //
     /*  731181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  731192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  731195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  731198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  731201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  731230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731249 */     GIR_RootConstrainSelectedInstOperands,
     /*  731250 */     // GIR_Coverage, 12055,
     /*  731250 */     GIR_EraseRootFromParent_Done,
     /*  731251 */   // Label 11502: @731251
     /*  731251 */   GIM_Try, /*On fail goto*//*Label 11503*/ GIMT_Encode4(731326), // Rule ID 12058 //
     /*  731256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  731276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731302 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  731305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731324 */     GIR_RootConstrainSelectedInstOperands,
     /*  731325 */     // GIR_Coverage, 12058,
     /*  731325 */     GIR_EraseRootFromParent_Done,
     /*  731326 */   // Label 11503: @731326
     /*  731326 */   GIM_Try, /*On fail goto*//*Label 11504*/ GIMT_Encode4(731401), // Rule ID 12059 //
     /*  731331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  731342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  731345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  731348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  731351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731377 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  731380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731399 */     GIR_RootConstrainSelectedInstOperands,
     /*  731400 */     // GIR_Coverage, 12059,
     /*  731400 */     GIR_EraseRootFromParent_Done,
     /*  731401 */   // Label 11504: @731401
     /*  731401 */   GIM_Try, /*On fail goto*//*Label 11505*/ GIMT_Encode4(731476), // Rule ID 12062 //
     /*  731406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  731426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731452 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  731452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  731455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731474 */     GIR_RootConstrainSelectedInstOperands,
     /*  731475 */     // GIR_Coverage, 12062,
     /*  731475 */     GIR_EraseRootFromParent_Done,
     /*  731476 */   // Label 11505: @731476
     /*  731476 */   GIM_Try, /*On fail goto*//*Label 11506*/ GIMT_Encode4(731551), // Rule ID 12063 //
     /*  731481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  731492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  731495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  731498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  731501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731527 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  731530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731549 */     GIR_RootConstrainSelectedInstOperands,
     /*  731550 */     // GIR_Coverage, 12063,
     /*  731550 */     GIR_EraseRootFromParent_Done,
     /*  731551 */   // Label 11506: @731551
     /*  731551 */   GIM_Try, /*On fail goto*//*Label 11507*/ GIMT_Encode4(731626), // Rule ID 12066 //
     /*  731556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  731567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  731570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  731573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  731576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  731605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731624 */     GIR_RootConstrainSelectedInstOperands,
     /*  731625 */     // GIR_Coverage, 12066,
     /*  731625 */     GIR_EraseRootFromParent_Done,
     /*  731626 */   // Label 11507: @731626
     /*  731626 */   GIM_Try, /*On fail goto*//*Label 11508*/ GIMT_Encode4(731701), // Rule ID 12067 //
     /*  731631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  731642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  731645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  731648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  731651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731677 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  731680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731699 */     GIR_RootConstrainSelectedInstOperands,
     /*  731700 */     // GIR_Coverage, 12067,
     /*  731700 */     GIR_EraseRootFromParent_Done,
     /*  731701 */   // Label 11508: @731701
     /*  731701 */   GIM_Try, /*On fail goto*//*Label 11509*/ GIMT_Encode4(731776), // Rule ID 12070 //
     /*  731706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  731717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  731720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  731723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  731726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731752 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  731755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731774 */     GIR_RootConstrainSelectedInstOperands,
     /*  731775 */     // GIR_Coverage, 12070,
     /*  731775 */     GIR_EraseRootFromParent_Done,
     /*  731776 */   // Label 11509: @731776
     /*  731776 */   GIM_Try, /*On fail goto*//*Label 11510*/ GIMT_Encode4(731851), // Rule ID 12071 //
     /*  731781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  731792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  731795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  731798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  731801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731827 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  731830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731849 */     GIR_RootConstrainSelectedInstOperands,
     /*  731850 */     // GIR_Coverage, 12071,
     /*  731850 */     GIR_EraseRootFromParent_Done,
     /*  731851 */   // Label 11510: @731851
     /*  731851 */   GIM_Try, /*On fail goto*//*Label 11511*/ GIMT_Encode4(731926), // Rule ID 12074 //
     /*  731856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  731867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  731870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  731873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  731876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  731905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731924 */     GIR_RootConstrainSelectedInstOperands,
     /*  731925 */     // GIR_Coverage, 12074,
     /*  731925 */     GIR_EraseRootFromParent_Done,
     /*  731926 */   // Label 11511: @731926
     /*  731926 */   GIM_Try, /*On fail goto*//*Label 11512*/ GIMT_Encode4(732001), // Rule ID 12075 //
     /*  731931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  731942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  731945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  731948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  731951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731977 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  731980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731999 */     GIR_RootConstrainSelectedInstOperands,
     /*  732000 */     // GIR_Coverage, 12075,
     /*  732000 */     GIR_EraseRootFromParent_Done,
     /*  732001 */   // Label 11512: @732001
     /*  732001 */   GIM_Try, /*On fail goto*//*Label 11513*/ GIMT_Encode4(732076), // Rule ID 12078 //
     /*  732006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  732026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  732055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732074 */     GIR_RootConstrainSelectedInstOperands,
     /*  732075 */     // GIR_Coverage, 12078,
     /*  732075 */     GIR_EraseRootFromParent_Done,
     /*  732076 */   // Label 11513: @732076
     /*  732076 */   GIM_Try, /*On fail goto*//*Label 11514*/ GIMT_Encode4(732151), // Rule ID 12079 //
     /*  732081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  732092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  732095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  732098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  732101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  732130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732149 */     GIR_RootConstrainSelectedInstOperands,
     /*  732150 */     // GIR_Coverage, 12079,
     /*  732150 */     GIR_EraseRootFromParent_Done,
     /*  732151 */   // Label 11514: @732151
     /*  732151 */   GIM_Try, /*On fail goto*//*Label 11515*/ GIMT_Encode4(732226), // Rule ID 12082 //
     /*  732156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  732176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732202 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  732205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732224 */     GIR_RootConstrainSelectedInstOperands,
     /*  732225 */     // GIR_Coverage, 12082,
     /*  732225 */     GIR_EraseRootFromParent_Done,
     /*  732226 */   // Label 11515: @732226
     /*  732226 */   GIM_Try, /*On fail goto*//*Label 11516*/ GIMT_Encode4(732301), // Rule ID 12083 //
     /*  732231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  732242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  732245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  732248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  732251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732277 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  732280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732299 */     GIR_RootConstrainSelectedInstOperands,
     /*  732300 */     // GIR_Coverage, 12083,
     /*  732300 */     GIR_EraseRootFromParent_Done,
     /*  732301 */   // Label 11516: @732301
     /*  732301 */   GIM_Try, /*On fail goto*//*Label 11517*/ GIMT_Encode4(732376), // Rule ID 12086 //
     /*  732306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  732326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  732352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  732355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732374 */     GIR_RootConstrainSelectedInstOperands,
     /*  732375 */     // GIR_Coverage, 12086,
     /*  732375 */     GIR_EraseRootFromParent_Done,
     /*  732376 */   // Label 11517: @732376
     /*  732376 */   GIM_Try, /*On fail goto*//*Label 11518*/ GIMT_Encode4(732451), // Rule ID 12087 //
     /*  732381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  732392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  732395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  732398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  732401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732427 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  732427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  732430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  732446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732449 */     GIR_RootConstrainSelectedInstOperands,
     /*  732450 */     // GIR_Coverage, 12087,
     /*  732450 */     GIR_EraseRootFromParent_Done,
     /*  732451 */   // Label 11518: @732451
     /*  732451 */   GIM_Try, /*On fail goto*//*Label 11519*/ GIMT_Encode4(732526), // Rule ID 12090 //
     /*  732456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  732467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  732470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  732473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  732476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  732505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732524 */     GIR_RootConstrainSelectedInstOperands,
     /*  732525 */     // GIR_Coverage, 12090,
     /*  732525 */     GIR_EraseRootFromParent_Done,
     /*  732526 */   // Label 11519: @732526
     /*  732526 */   GIM_Try, /*On fail goto*//*Label 11520*/ GIMT_Encode4(732601), // Rule ID 12091 //
     /*  732531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  732542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  732545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  732548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  732551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  732580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732599 */     GIR_RootConstrainSelectedInstOperands,
     /*  732600 */     // GIR_Coverage, 12091,
     /*  732600 */     GIR_EraseRootFromParent_Done,
     /*  732601 */   // Label 11520: @732601
     /*  732601 */   GIM_Try, /*On fail goto*//*Label 11521*/ GIMT_Encode4(732676), // Rule ID 12094 //
     /*  732606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  732617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  732620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  732623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  732626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  732655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732674 */     GIR_RootConstrainSelectedInstOperands,
     /*  732675 */     // GIR_Coverage, 12094,
     /*  732675 */     GIR_EraseRootFromParent_Done,
     /*  732676 */   // Label 11521: @732676
     /*  732676 */   GIM_Try, /*On fail goto*//*Label 11522*/ GIMT_Encode4(732751), // Rule ID 12095 //
     /*  732681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  732692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  732695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  732698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  732701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732727 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  732730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732749 */     GIR_RootConstrainSelectedInstOperands,
     /*  732750 */     // GIR_Coverage, 12095,
     /*  732750 */     GIR_EraseRootFromParent_Done,
     /*  732751 */   // Label 11522: @732751
     /*  732751 */   GIM_Try, /*On fail goto*//*Label 11523*/ GIMT_Encode4(732826), // Rule ID 12098 //
     /*  732756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  732767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  732770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  732773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  732776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732802 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  732805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732824 */     GIR_RootConstrainSelectedInstOperands,
     /*  732825 */     // GIR_Coverage, 12098,
     /*  732825 */     GIR_EraseRootFromParent_Done,
     /*  732826 */   // Label 11523: @732826
     /*  732826 */   GIM_Try, /*On fail goto*//*Label 11524*/ GIMT_Encode4(732901), // Rule ID 12099 //
     /*  732831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  732842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  732845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  732848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  732851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732877 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  732880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732899 */     GIR_RootConstrainSelectedInstOperands,
     /*  732900 */     // GIR_Coverage, 12099,
     /*  732900 */     GIR_EraseRootFromParent_Done,
     /*  732901 */   // Label 11524: @732901
     /*  732901 */   GIM_Try, /*On fail goto*//*Label 11525*/ GIMT_Encode4(732976), // Rule ID 12102 //
     /*  732906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  732917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  732920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  732923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  732952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  732955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732974 */     GIR_RootConstrainSelectedInstOperands,
     /*  732975 */     // GIR_Coverage, 12102,
     /*  732975 */     GIR_EraseRootFromParent_Done,
     /*  732976 */   // Label 11525: @732976
     /*  732976 */   GIM_Try, /*On fail goto*//*Label 11526*/ GIMT_Encode4(733051), // Rule ID 12103 //
     /*  732981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  732992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  732995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  732998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733027 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  733030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733049 */     GIR_RootConstrainSelectedInstOperands,
     /*  733050 */     // GIR_Coverage, 12103,
     /*  733050 */     GIR_EraseRootFromParent_Done,
     /*  733051 */   // Label 11526: @733051
     /*  733051 */   GIM_Try, /*On fail goto*//*Label 11527*/ GIMT_Encode4(733126), // Rule ID 12106 //
     /*  733056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733102 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  733105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733124 */     GIR_RootConstrainSelectedInstOperands,
     /*  733125 */     // GIR_Coverage, 12106,
     /*  733125 */     GIR_EraseRootFromParent_Done,
     /*  733126 */   // Label 11527: @733126
     /*  733126 */   GIM_Try, /*On fail goto*//*Label 11528*/ GIMT_Encode4(733201), // Rule ID 12107 //
     /*  733131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  733142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  733145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  733148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733177 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  733180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733199 */     GIR_RootConstrainSelectedInstOperands,
     /*  733200 */     // GIR_Coverage, 12107,
     /*  733200 */     GIR_EraseRootFromParent_Done,
     /*  733201 */   // Label 11528: @733201
     /*  733201 */   GIM_Try, /*On fail goto*//*Label 11529*/ GIMT_Encode4(733276), // Rule ID 12110 //
     /*  733206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733252 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  733255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733274 */     GIR_RootConstrainSelectedInstOperands,
     /*  733275 */     // GIR_Coverage, 12110,
     /*  733275 */     GIR_EraseRootFromParent_Done,
     /*  733276 */   // Label 11529: @733276
     /*  733276 */   GIM_Try, /*On fail goto*//*Label 11530*/ GIMT_Encode4(733351), // Rule ID 12111 //
     /*  733281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  733292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  733295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  733298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733327 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  733330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733349 */     GIR_RootConstrainSelectedInstOperands,
     /*  733350 */     // GIR_Coverage, 12111,
     /*  733350 */     GIR_EraseRootFromParent_Done,
     /*  733351 */   // Label 11530: @733351
     /*  733351 */   GIM_Try, /*On fail goto*//*Label 11531*/ GIMT_Encode4(733426), // Rule ID 12114 //
     /*  733356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733402 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  733405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733424 */     GIR_RootConstrainSelectedInstOperands,
     /*  733425 */     // GIR_Coverage, 12114,
     /*  733425 */     GIR_EraseRootFromParent_Done,
     /*  733426 */   // Label 11531: @733426
     /*  733426 */   GIM_Try, /*On fail goto*//*Label 11532*/ GIMT_Encode4(733501), // Rule ID 12115 //
     /*  733431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  733442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  733445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  733448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733477 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  733480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733499 */     GIR_RootConstrainSelectedInstOperands,
     /*  733500 */     // GIR_Coverage, 12115,
     /*  733500 */     GIR_EraseRootFromParent_Done,
     /*  733501 */   // Label 11532: @733501
     /*  733501 */   GIM_Try, /*On fail goto*//*Label 11533*/ GIMT_Encode4(733576), // Rule ID 12118 //
     /*  733506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  733517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  733520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  733523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  733555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733574 */     GIR_RootConstrainSelectedInstOperands,
     /*  733575 */     // GIR_Coverage, 12118,
     /*  733575 */     GIR_EraseRootFromParent_Done,
     /*  733576 */   // Label 11533: @733576
     /*  733576 */   GIM_Try, /*On fail goto*//*Label 11534*/ GIMT_Encode4(733651), // Rule ID 12119 //
     /*  733581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  733592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  733595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  733598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733627 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  733630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733649 */     GIR_RootConstrainSelectedInstOperands,
     /*  733650 */     // GIR_Coverage, 12119,
     /*  733650 */     GIR_EraseRootFromParent_Done,
     /*  733651 */   // Label 11534: @733651
     /*  733651 */   GIM_Try, /*On fail goto*//*Label 11535*/ GIMT_Encode4(733726), // Rule ID 12122 //
     /*  733656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  733667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  733670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  733673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  733702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  733705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  733721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733724 */     GIR_RootConstrainSelectedInstOperands,
     /*  733725 */     // GIR_Coverage, 12122,
     /*  733725 */     GIR_EraseRootFromParent_Done,
     /*  733726 */   // Label 11535: @733726
     /*  733726 */   GIM_Try, /*On fail goto*//*Label 11536*/ GIMT_Encode4(733801), // Rule ID 12123 //
     /*  733731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  733742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  733745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  733748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733777 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  733777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  733780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  733796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733799 */     GIR_RootConstrainSelectedInstOperands,
     /*  733800 */     // GIR_Coverage, 12123,
     /*  733800 */     GIR_EraseRootFromParent_Done,
     /*  733801 */   // Label 11536: @733801
     /*  733801 */   GIM_Try, /*On fail goto*//*Label 11537*/ GIMT_Encode4(733876), // Rule ID 12126 //
     /*  733806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  733823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733852 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  733855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733874 */     GIR_RootConstrainSelectedInstOperands,
     /*  733875 */     // GIR_Coverage, 12126,
     /*  733875 */     GIR_EraseRootFromParent_Done,
     /*  733876 */   // Label 11537: @733876
     /*  733876 */   GIM_Try, /*On fail goto*//*Label 11538*/ GIMT_Encode4(733951), // Rule ID 12127 //
     /*  733881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  733898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733927 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11515:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  733930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733949 */     GIR_RootConstrainSelectedInstOperands,
     /*  733950 */     // GIR_Coverage, 12127,
     /*  733950 */     GIR_EraseRootFromParent_Done,
     /*  733951 */   // Label 11538: @733951
     /*  733951 */   GIM_Try, /*On fail goto*//*Label 11539*/ GIMT_Encode4(734026), // Rule ID 12130 //
     /*  733956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  733973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  734005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734024 */     GIR_RootConstrainSelectedInstOperands,
     /*  734025 */     // GIR_Coverage, 12130,
     /*  734025 */     GIR_EraseRootFromParent_Done,
     /*  734026 */   // Label 11539: @734026
     /*  734026 */   GIM_Try, /*On fail goto*//*Label 11540*/ GIMT_Encode4(734101), // Rule ID 12131 //
     /*  734031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  734042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  734045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  734048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734077 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11515:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  734080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734099 */     GIR_RootConstrainSelectedInstOperands,
     /*  734100 */     // GIR_Coverage, 12131,
     /*  734100 */     GIR_EraseRootFromParent_Done,
     /*  734101 */   // Label 11540: @734101
     /*  734101 */   GIM_Try, /*On fail goto*//*Label 11541*/ GIMT_Encode4(734176), // Rule ID 12134 //
     /*  734106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  734155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734174 */     GIR_RootConstrainSelectedInstOperands,
     /*  734175 */     // GIR_Coverage, 12134,
     /*  734175 */     GIR_EraseRootFromParent_Done,
     /*  734176 */   // Label 11541: @734176
     /*  734176 */   GIM_Try, /*On fail goto*//*Label 11542*/ GIMT_Encode4(734251), // Rule ID 12135 //
     /*  734181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  734192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  734195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  734198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11515:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  734230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734249 */     GIR_RootConstrainSelectedInstOperands,
     /*  734250 */     // GIR_Coverage, 12135,
     /*  734250 */     GIR_EraseRootFromParent_Done,
     /*  734251 */   // Label 11542: @734251
     /*  734251 */   GIM_Try, /*On fail goto*//*Label 11543*/ GIMT_Encode4(734326), // Rule ID 12138 //
     /*  734256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  734259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  734302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  734305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734324 */     GIR_RootConstrainSelectedInstOperands,
     /*  734325 */     // GIR_Coverage, 12138,
     /*  734325 */     GIR_EraseRootFromParent_Done,
     /*  734326 */   // Label 11543: @734326
     /*  734326 */   GIM_Try, /*On fail goto*//*Label 11544*/ GIMT_Encode4(734401), // Rule ID 12139 //
     /*  734331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  734334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  734342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  734345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  734348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  734366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734377 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11515:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  734377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  734380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  734396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734399 */     GIR_RootConstrainSelectedInstOperands,
     /*  734400 */     // GIR_Coverage, 12139,
     /*  734400 */     GIR_EraseRootFromParent_Done,
     /*  734401 */   // Label 11544: @734401
     /*  734401 */   GIM_Try, /*On fail goto*//*Label 11545*/ GIMT_Encode4(734476), // Rule ID 12142 //
     /*  734406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  734455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734474 */     GIR_RootConstrainSelectedInstOperands,
     /*  734475 */     // GIR_Coverage, 12142,
     /*  734475 */     GIR_EraseRootFromParent_Done,
     /*  734476 */   // Label 11545: @734476
     /*  734476 */   GIM_Try, /*On fail goto*//*Label 11546*/ GIMT_Encode4(734551), // Rule ID 12143 //
     /*  734481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  734492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  734495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  734498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734527 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  734530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734549 */     GIR_RootConstrainSelectedInstOperands,
     /*  734550 */     // GIR_Coverage, 12143,
     /*  734550 */     GIR_EraseRootFromParent_Done,
     /*  734551 */   // Label 11546: @734551
     /*  734551 */   GIM_Try, /*On fail goto*//*Label 11547*/ GIMT_Encode4(734626), // Rule ID 12146 //
     /*  734556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  734567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  734570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  734573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734602 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  734605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734624 */     GIR_RootConstrainSelectedInstOperands,
     /*  734625 */     // GIR_Coverage, 12146,
     /*  734625 */     GIR_EraseRootFromParent_Done,
     /*  734626 */   // Label 11547: @734626
     /*  734626 */   GIM_Try, /*On fail goto*//*Label 11548*/ GIMT_Encode4(734701), // Rule ID 12147 //
     /*  734631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  734642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  734645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  734648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734677 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  734680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734699 */     GIR_RootConstrainSelectedInstOperands,
     /*  734700 */     // GIR_Coverage, 12147,
     /*  734700 */     GIR_EraseRootFromParent_Done,
     /*  734701 */   // Label 11548: @734701
     /*  734701 */   GIM_Try, /*On fail goto*//*Label 11549*/ GIMT_Encode4(734776), // Rule ID 12150 //
     /*  734706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  734717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  734720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  734723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734752 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  734755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734774 */     GIR_RootConstrainSelectedInstOperands,
     /*  734775 */     // GIR_Coverage, 12150,
     /*  734775 */     GIR_EraseRootFromParent_Done,
     /*  734776 */   // Label 11549: @734776
     /*  734776 */   GIM_Try, /*On fail goto*//*Label 11550*/ GIMT_Encode4(734851), // Rule ID 12151 //
     /*  734781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  734792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  734795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  734798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734827 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  734830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734849 */     GIR_RootConstrainSelectedInstOperands,
     /*  734850 */     // GIR_Coverage, 12151,
     /*  734850 */     GIR_EraseRootFromParent_Done,
     /*  734851 */   // Label 11550: @734851
     /*  734851 */   GIM_Try, /*On fail goto*//*Label 11551*/ GIMT_Encode4(734926), // Rule ID 12154 //
     /*  734856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  734867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  734870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  734873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  734905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734924 */     GIR_RootConstrainSelectedInstOperands,
     /*  734925 */     // GIR_Coverage, 12154,
     /*  734925 */     GIR_EraseRootFromParent_Done,
     /*  734926 */   // Label 11551: @734926
     /*  734926 */   GIM_Try, /*On fail goto*//*Label 11552*/ GIMT_Encode4(735001), // Rule ID 12155 //
     /*  734931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  734942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  734945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  734948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734977 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  734980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734999 */     GIR_RootConstrainSelectedInstOperands,
     /*  735000 */     // GIR_Coverage, 12155,
     /*  735000 */     GIR_EraseRootFromParent_Done,
     /*  735001 */   // Label 11552: @735001
     /*  735001 */   GIM_Try, /*On fail goto*//*Label 11553*/ GIMT_Encode4(735076), // Rule ID 12158 //
     /*  735006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  735055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735074 */     GIR_RootConstrainSelectedInstOperands,
     /*  735075 */     // GIR_Coverage, 12158,
     /*  735075 */     GIR_EraseRootFromParent_Done,
     /*  735076 */   // Label 11553: @735076
     /*  735076 */   GIM_Try, /*On fail goto*//*Label 11554*/ GIMT_Encode4(735151), // Rule ID 12159 //
     /*  735081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  735092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  735095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  735098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735127 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  735130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735149 */     GIR_RootConstrainSelectedInstOperands,
     /*  735150 */     // GIR_Coverage, 12159,
     /*  735150 */     GIR_EraseRootFromParent_Done,
     /*  735151 */   // Label 11554: @735151
     /*  735151 */   GIM_Try, /*On fail goto*//*Label 11555*/ GIMT_Encode4(735226), // Rule ID 12162 //
     /*  735156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  735202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  735205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735224 */     GIR_RootConstrainSelectedInstOperands,
     /*  735225 */     // GIR_Coverage, 12162,
     /*  735225 */     GIR_EraseRootFromParent_Done,
     /*  735226 */   // Label 11555: @735226
     /*  735226 */   GIM_Try, /*On fail goto*//*Label 11556*/ GIMT_Encode4(735301), // Rule ID 12163 //
     /*  735231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  735242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  735245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  735248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735277 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  735277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  735280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  735296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735299 */     GIR_RootConstrainSelectedInstOperands,
     /*  735300 */     // GIR_Coverage, 12163,
     /*  735300 */     GIR_EraseRootFromParent_Done,
     /*  735301 */   // Label 11556: @735301
     /*  735301 */   GIM_Try, /*On fail goto*//*Label 11557*/ GIMT_Encode4(735376), // Rule ID 12166 //
     /*  735306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  735355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735374 */     GIR_RootConstrainSelectedInstOperands,
     /*  735375 */     // GIR_Coverage, 12166,
     /*  735375 */     GIR_EraseRootFromParent_Done,
     /*  735376 */   // Label 11557: @735376
     /*  735376 */   GIM_Try, /*On fail goto*//*Label 11558*/ GIMT_Encode4(735451), // Rule ID 12167 //
     /*  735381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  735392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  735395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  735398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  735430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735449 */     GIR_RootConstrainSelectedInstOperands,
     /*  735450 */     // GIR_Coverage, 12167,
     /*  735450 */     GIR_EraseRootFromParent_Done,
     /*  735451 */   // Label 11558: @735451
     /*  735451 */   GIM_Try, /*On fail goto*//*Label 11559*/ GIMT_Encode4(735526), // Rule ID 12170 //
     /*  735456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  735467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  735470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  735473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  735505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735524 */     GIR_RootConstrainSelectedInstOperands,
     /*  735525 */     // GIR_Coverage, 12170,
     /*  735525 */     GIR_EraseRootFromParent_Done,
     /*  735526 */   // Label 11559: @735526
     /*  735526 */   GIM_Try, /*On fail goto*//*Label 11560*/ GIMT_Encode4(735601), // Rule ID 12171 //
     /*  735531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  735542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  735545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  735548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  735580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735599 */     GIR_RootConstrainSelectedInstOperands,
     /*  735600 */     // GIR_Coverage, 12171,
     /*  735600 */     GIR_EraseRootFromParent_Done,
     /*  735601 */   // Label 11560: @735601
     /*  735601 */   GIM_Try, /*On fail goto*//*Label 11561*/ GIMT_Encode4(735676), // Rule ID 12174 //
     /*  735606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  735617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  735620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  735623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  735655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735674 */     GIR_RootConstrainSelectedInstOperands,
     /*  735675 */     // GIR_Coverage, 12174,
     /*  735675 */     GIR_EraseRootFromParent_Done,
     /*  735676 */   // Label 11561: @735676
     /*  735676 */   GIM_Try, /*On fail goto*//*Label 11562*/ GIMT_Encode4(735751), // Rule ID 12175 //
     /*  735681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  735692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  735695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  735698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735727 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  735730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735749 */     GIR_RootConstrainSelectedInstOperands,
     /*  735750 */     // GIR_Coverage, 12175,
     /*  735750 */     GIR_EraseRootFromParent_Done,
     /*  735751 */   // Label 11562: @735751
     /*  735751 */   GIM_Try, /*On fail goto*//*Label 11563*/ GIMT_Encode4(735826), // Rule ID 12178 //
     /*  735756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  735759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  735767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  735770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  735773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  735802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  735805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735824 */     GIR_RootConstrainSelectedInstOperands,
     /*  735825 */     // GIR_Coverage, 12178,
     /*  735825 */     GIR_EraseRootFromParent_Done,
     /*  735826 */   // Label 11563: @735826
     /*  735826 */   GIM_Try, /*On fail goto*//*Label 11564*/ GIMT_Encode4(735901), // Rule ID 12179 //
     /*  735831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  735834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  735842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  735845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  735848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735877 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11515:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  735877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  735880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735899 */     GIR_RootConstrainSelectedInstOperands,
     /*  735900 */     // GIR_Coverage, 12179,
     /*  735900 */     GIR_EraseRootFromParent_Done,
     /*  735901 */   // Label 11564: @735901
     /*  735901 */   GIM_Try, /*On fail goto*//*Label 11565*/ GIMT_Encode4(735976), // Rule ID 12182 //
     /*  735906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  735909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  735917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  735920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  735923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  735952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  735955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735974 */     GIR_RootConstrainSelectedInstOperands,
     /*  735975 */     // GIR_Coverage, 12182,
     /*  735975 */     GIR_EraseRootFromParent_Done,
     /*  735976 */   // Label 11565: @735976
     /*  735976 */   GIM_Try, /*On fail goto*//*Label 11566*/ GIMT_Encode4(736051), // Rule ID 12183 //
     /*  735981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  735984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  735992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  735995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  735998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  736016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736027 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11515:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  736030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736049 */     GIR_RootConstrainSelectedInstOperands,
     /*  736050 */     // GIR_Coverage, 12183,
     /*  736050 */     GIR_EraseRootFromParent_Done,
     /*  736051 */   // Label 11566: @736051
     /*  736051 */   GIM_Try, /*On fail goto*//*Label 11567*/ GIMT_Encode4(736126), // Rule ID 12186 //
     /*  736056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  736059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  736076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  736102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  736105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736124 */     GIR_RootConstrainSelectedInstOperands,
     /*  736125 */     // GIR_Coverage, 12186,
     /*  736125 */     GIR_EraseRootFromParent_Done,
     /*  736126 */   // Label 11567: @736126
     /*  736126 */   GIM_Try, /*On fail goto*//*Label 11568*/ GIMT_Encode4(736201), // Rule ID 12187 //
     /*  736131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  736134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  736139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  736142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  736145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  736148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  736151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  736166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  736170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736177 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11515:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  736177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  736180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  736196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736199 */     GIR_RootConstrainSelectedInstOperands,
     /*  736200 */     // GIR_Coverage, 12187,
     /*  736200 */     GIR_EraseRootFromParent_Done,
     /*  736201 */   // Label 11568: @736201
     /*  736201 */   GIM_Try, /*On fail goto*//*Label 11569*/ GIMT_Encode4(736276), // Rule ID 12190 //
     /*  736206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  736226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736252 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  736255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736274 */     GIR_RootConstrainSelectedInstOperands,
     /*  736275 */     // GIR_Coverage, 12190,
     /*  736275 */     GIR_EraseRootFromParent_Done,
     /*  736276 */   // Label 11569: @736276
     /*  736276 */   GIM_Try, /*On fail goto*//*Label 11570*/ GIMT_Encode4(736351), // Rule ID 12191 //
     /*  736281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  736292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  736295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  736298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  736301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736327 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  736330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736349 */     GIR_RootConstrainSelectedInstOperands,
     /*  736350 */     // GIR_Coverage, 12191,
     /*  736350 */     GIR_EraseRootFromParent_Done,
     /*  736351 */   // Label 11570: @736351
     /*  736351 */   GIM_Try, /*On fail goto*//*Label 11571*/ GIMT_Encode4(736426), // Rule ID 12194 //
     /*  736356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  736376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736402 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  736405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736424 */     GIR_RootConstrainSelectedInstOperands,
     /*  736425 */     // GIR_Coverage, 12194,
     /*  736425 */     GIR_EraseRootFromParent_Done,
     /*  736426 */   // Label 11571: @736426
     /*  736426 */   GIM_Try, /*On fail goto*//*Label 11572*/ GIMT_Encode4(736501), // Rule ID 12195 //
     /*  736431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  736442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  736445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  736448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  736451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736477 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  736480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736499 */     GIR_RootConstrainSelectedInstOperands,
     /*  736500 */     // GIR_Coverage, 12195,
     /*  736500 */     GIR_EraseRootFromParent_Done,
     /*  736501 */   // Label 11572: @736501
     /*  736501 */   GIM_Try, /*On fail goto*//*Label 11573*/ GIMT_Encode4(736576), // Rule ID 12198 //
     /*  736506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  736517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  736520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  736523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  736526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  736555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736574 */     GIR_RootConstrainSelectedInstOperands,
     /*  736575 */     // GIR_Coverage, 12198,
     /*  736575 */     GIR_EraseRootFromParent_Done,
     /*  736576 */   // Label 11573: @736576
     /*  736576 */   GIM_Try, /*On fail goto*//*Label 11574*/ GIMT_Encode4(736651), // Rule ID 12199 //
     /*  736581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  736592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  736595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  736598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  736601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736627 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  736630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736649 */     GIR_RootConstrainSelectedInstOperands,
     /*  736650 */     // GIR_Coverage, 12199,
     /*  736650 */     GIR_EraseRootFromParent_Done,
     /*  736651 */   // Label 11574: @736651
     /*  736651 */   GIM_Try, /*On fail goto*//*Label 11575*/ GIMT_Encode4(736726), // Rule ID 12202 //
     /*  736656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  736667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  736670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  736673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  736676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736702 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  736702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  736705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736724 */     GIR_RootConstrainSelectedInstOperands,
     /*  736725 */     // GIR_Coverage, 12202,
     /*  736725 */     GIR_EraseRootFromParent_Done,
     /*  736726 */   // Label 11575: @736726
     /*  736726 */   GIM_Try, /*On fail goto*//*Label 11576*/ GIMT_Encode4(736801), // Rule ID 12203 //
     /*  736731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  736742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  736745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  736748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  736751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736777 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  736777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  736780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736799 */     GIR_RootConstrainSelectedInstOperands,
     /*  736800 */     // GIR_Coverage, 12203,
     /*  736800 */     GIR_EraseRootFromParent_Done,
     /*  736801 */   // Label 11576: @736801
     /*  736801 */   GIM_Try, /*On fail goto*//*Label 11577*/ GIMT_Encode4(736876), // Rule ID 12206 //
     /*  736806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  736817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  736820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  736823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  736826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  736852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  736855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736874 */     GIR_RootConstrainSelectedInstOperands,
     /*  736875 */     // GIR_Coverage, 12206,
     /*  736875 */     GIR_EraseRootFromParent_Done,
     /*  736876 */   // Label 11577: @736876
     /*  736876 */   GIM_Try, /*On fail goto*//*Label 11578*/ GIMT_Encode4(736951), // Rule ID 12207 //
     /*  736881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  736892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  736895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  736898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  736901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736927 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  736927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  736930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736949 */     GIR_RootConstrainSelectedInstOperands,
     /*  736950 */     // GIR_Coverage, 12207,
     /*  736950 */     GIR_EraseRootFromParent_Done,
     /*  736951 */   // Label 11578: @736951
     /*  736951 */   GIM_Try, /*On fail goto*//*Label 11579*/ GIMT_Encode4(737026), // Rule ID 12210 //
     /*  736956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  736967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  736970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  736973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  736976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737002 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  737005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737024 */     GIR_RootConstrainSelectedInstOperands,
     /*  737025 */     // GIR_Coverage, 12210,
     /*  737025 */     GIR_EraseRootFromParent_Done,
     /*  737026 */   // Label 11579: @737026
     /*  737026 */   GIM_Try, /*On fail goto*//*Label 11580*/ GIMT_Encode4(737101), // Rule ID 12211 //
     /*  737031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  737042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  737045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  737048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  737051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737077 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  737080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737099 */     GIR_RootConstrainSelectedInstOperands,
     /*  737100 */     // GIR_Coverage, 12211,
     /*  737100 */     GIR_EraseRootFromParent_Done,
     /*  737101 */   // Label 11580: @737101
     /*  737101 */   GIM_Try, /*On fail goto*//*Label 11581*/ GIMT_Encode4(737176), // Rule ID 12214 //
     /*  737106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  737126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  737155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737174 */     GIR_RootConstrainSelectedInstOperands,
     /*  737175 */     // GIR_Coverage, 12214,
     /*  737175 */     GIR_EraseRootFromParent_Done,
     /*  737176 */   // Label 11581: @737176
     /*  737176 */   GIM_Try, /*On fail goto*//*Label 11582*/ GIMT_Encode4(737251), // Rule ID 12215 //
     /*  737181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  737192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  737195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  737198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  737201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  737230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737249 */     GIR_RootConstrainSelectedInstOperands,
     /*  737250 */     // GIR_Coverage, 12215,
     /*  737250 */     GIR_EraseRootFromParent_Done,
     /*  737251 */   // Label 11582: @737251
     /*  737251 */   GIM_Try, /*On fail goto*//*Label 11583*/ GIMT_Encode4(737326), // Rule ID 12218 //
     /*  737256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  737305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737324 */     GIR_RootConstrainSelectedInstOperands,
     /*  737325 */     // GIR_Coverage, 12218,
     /*  737325 */     GIR_EraseRootFromParent_Done,
     /*  737326 */   // Label 11583: @737326
     /*  737326 */   GIM_Try, /*On fail goto*//*Label 11584*/ GIMT_Encode4(737401), // Rule ID 12219 //
     /*  737331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  737342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  737345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  737348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  737351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  737380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737399 */     GIR_RootConstrainSelectedInstOperands,
     /*  737400 */     // GIR_Coverage, 12219,
     /*  737400 */     GIR_EraseRootFromParent_Done,
     /*  737401 */   // Label 11584: @737401
     /*  737401 */   GIM_Try, /*On fail goto*//*Label 11585*/ GIMT_Encode4(737476), // Rule ID 12222 //
     /*  737406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  737452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  737455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737474 */     GIR_RootConstrainSelectedInstOperands,
     /*  737475 */     // GIR_Coverage, 12222,
     /*  737475 */     GIR_EraseRootFromParent_Done,
     /*  737476 */   // Label 11585: @737476
     /*  737476 */   GIM_Try, /*On fail goto*//*Label 11586*/ GIMT_Encode4(737551), // Rule ID 12223 //
     /*  737481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  737492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  737495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  737498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  737501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737527 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  737530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737549 */     GIR_RootConstrainSelectedInstOperands,
     /*  737550 */     // GIR_Coverage, 12223,
     /*  737550 */     GIR_EraseRootFromParent_Done,
     /*  737551 */   // Label 11586: @737551
     /*  737551 */   GIM_Try, /*On fail goto*//*Label 11587*/ GIMT_Encode4(737626), // Rule ID 12226 //
     /*  737556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  737559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  737573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737602 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  737602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  737605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737624 */     GIR_RootConstrainSelectedInstOperands,
     /*  737625 */     // GIR_Coverage, 12226,
     /*  737625 */     GIR_EraseRootFromParent_Done,
     /*  737626 */   // Label 11587: @737626
     /*  737626 */   GIM_Try, /*On fail goto*//*Label 11588*/ GIMT_Encode4(737701), // Rule ID 12227 //
     /*  737631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  737634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  737648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737677 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  737677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  737680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737699 */     GIR_RootConstrainSelectedInstOperands,
     /*  737700 */     // GIR_Coverage, 12227,
     /*  737700 */     GIR_EraseRootFromParent_Done,
     /*  737701 */   // Label 11588: @737701
     /*  737701 */   GIM_Try, /*On fail goto*//*Label 11589*/ GIMT_Encode4(737776), // Rule ID 12230 //
     /*  737706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  737717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  737720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  737723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  737726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737752 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  737755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737774 */     GIR_RootConstrainSelectedInstOperands,
     /*  737775 */     // GIR_Coverage, 12230,
     /*  737775 */     GIR_EraseRootFromParent_Done,
     /*  737776 */   // Label 11589: @737776
     /*  737776 */   GIM_Try, /*On fail goto*//*Label 11590*/ GIMT_Encode4(737851), // Rule ID 12231 //
     /*  737781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  737792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  737795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  737798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  737801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737827 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  737830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737849 */     GIR_RootConstrainSelectedInstOperands,
     /*  737850 */     // GIR_Coverage, 12231,
     /*  737850 */     GIR_EraseRootFromParent_Done,
     /*  737851 */   // Label 11590: @737851
     /*  737851 */   GIM_Try, /*On fail goto*//*Label 11591*/ GIMT_Encode4(737926), // Rule ID 12234 //
     /*  737856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  737867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  737870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  737873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  737876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737902 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  737905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737924 */     GIR_RootConstrainSelectedInstOperands,
     /*  737925 */     // GIR_Coverage, 12234,
     /*  737925 */     GIR_EraseRootFromParent_Done,
     /*  737926 */   // Label 11591: @737926
     /*  737926 */   GIM_Try, /*On fail goto*//*Label 11592*/ GIMT_Encode4(738001), // Rule ID 12235 //
     /*  737931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  737942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  737945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  737948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  737951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737977 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  737980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737999 */     GIR_RootConstrainSelectedInstOperands,
     /*  738000 */     // GIR_Coverage, 12235,
     /*  738000 */     GIR_EraseRootFromParent_Done,
     /*  738001 */   // Label 11592: @738001
     /*  738001 */   GIM_Try, /*On fail goto*//*Label 11593*/ GIMT_Encode4(738076), // Rule ID 12238 //
     /*  738006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  738026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  738052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  738055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738074 */     GIR_RootConstrainSelectedInstOperands,
     /*  738075 */     // GIR_Coverage, 12238,
     /*  738075 */     GIR_EraseRootFromParent_Done,
     /*  738076 */   // Label 11593: @738076
     /*  738076 */   GIM_Try, /*On fail goto*//*Label 11594*/ GIMT_Encode4(738151), // Rule ID 12239 //
     /*  738081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  738092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  738095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  738098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  738101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738127 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  738127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  738130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  738146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738149 */     GIR_RootConstrainSelectedInstOperands,
     /*  738150 */     // GIR_Coverage, 12239,
     /*  738150 */     GIR_EraseRootFromParent_Done,
     /*  738151 */   // Label 11594: @738151
     /*  738151 */   GIM_Try, /*On fail goto*//*Label 11595*/ GIMT_Encode4(738226), // Rule ID 12242 //
     /*  738156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  738176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  738205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738224 */     GIR_RootConstrainSelectedInstOperands,
     /*  738225 */     // GIR_Coverage, 12242,
     /*  738225 */     GIR_EraseRootFromParent_Done,
     /*  738226 */   // Label 11595: @738226
     /*  738226 */   GIM_Try, /*On fail goto*//*Label 11596*/ GIMT_Encode4(738301), // Rule ID 12243 //
     /*  738231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  738242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  738245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  738248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  738251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  738280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738299 */     GIR_RootConstrainSelectedInstOperands,
     /*  738300 */     // GIR_Coverage, 12243,
     /*  738300 */     GIR_EraseRootFromParent_Done,
     /*  738301 */   // Label 11596: @738301
     /*  738301 */   GIM_Try, /*On fail goto*//*Label 11597*/ GIMT_Encode4(738376), // Rule ID 12246 //
     /*  738306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  738326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  738355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738374 */     GIR_RootConstrainSelectedInstOperands,
     /*  738375 */     // GIR_Coverage, 12246,
     /*  738375 */     GIR_EraseRootFromParent_Done,
     /*  738376 */   // Label 11597: @738376
     /*  738376 */   GIM_Try, /*On fail goto*//*Label 11598*/ GIMT_Encode4(738451), // Rule ID 12247 //
     /*  738381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  738392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  738395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  738398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  738401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738427 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  738430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738449 */     GIR_RootConstrainSelectedInstOperands,
     /*  738450 */     // GIR_Coverage, 12247,
     /*  738450 */     GIR_EraseRootFromParent_Done,
     /*  738451 */   // Label 11598: @738451
     /*  738451 */   GIM_Try, /*On fail goto*//*Label 11599*/ GIMT_Encode4(738526), // Rule ID 12250 //
     /*  738456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  738467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  738470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  738473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  738476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  738502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  738505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738524 */     GIR_RootConstrainSelectedInstOperands,
     /*  738525 */     // GIR_Coverage, 12250,
     /*  738525 */     GIR_EraseRootFromParent_Done,
     /*  738526 */   // Label 11599: @738526
     /*  738526 */   GIM_Try, /*On fail goto*//*Label 11600*/ GIMT_Encode4(738601), // Rule ID 12251 //
     /*  738531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  738542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  738545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  738548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  738551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738577 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  738580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738599 */     GIR_RootConstrainSelectedInstOperands,
     /*  738600 */     // GIR_Coverage, 12251,
     /*  738600 */     GIR_EraseRootFromParent_Done,
     /*  738601 */   // Label 11600: @738601
     /*  738601 */   GIM_Try, /*On fail goto*//*Label 11601*/ GIMT_Encode4(738676), // Rule ID 12254 //
     /*  738606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  738617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  738620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  738623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  738626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  738655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738674 */     GIR_RootConstrainSelectedInstOperands,
     /*  738675 */     // GIR_Coverage, 12254,
     /*  738675 */     GIR_EraseRootFromParent_Done,
     /*  738676 */   // Label 11601: @738676
     /*  738676 */   GIM_Try, /*On fail goto*//*Label 11602*/ GIMT_Encode4(738751), // Rule ID 12255 //
     /*  738681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  738692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  738695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  738698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  738701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738727 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  738730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738749 */     GIR_RootConstrainSelectedInstOperands,
     /*  738750 */     // GIR_Coverage, 12255,
     /*  738750 */     GIR_EraseRootFromParent_Done,
     /*  738751 */   // Label 11602: @738751
     /*  738751 */   GIM_Try, /*On fail goto*//*Label 11603*/ GIMT_Encode4(738826), // Rule ID 12258 //
     /*  738756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  738767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  738770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  738773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  738776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738802 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  738805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738824 */     GIR_RootConstrainSelectedInstOperands,
     /*  738825 */     // GIR_Coverage, 12258,
     /*  738825 */     GIR_EraseRootFromParent_Done,
     /*  738826 */   // Label 11603: @738826
     /*  738826 */   GIM_Try, /*On fail goto*//*Label 11604*/ GIMT_Encode4(738901), // Rule ID 12259 //
     /*  738831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  738842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  738845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  738848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  738851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738877 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  738880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738899 */     GIR_RootConstrainSelectedInstOperands,
     /*  738900 */     // GIR_Coverage, 12259,
     /*  738900 */     GIR_EraseRootFromParent_Done,
     /*  738901 */   // Label 11604: @738901
     /*  738901 */   GIM_Try, /*On fail goto*//*Label 11605*/ GIMT_Encode4(738976), // Rule ID 12262 //
     /*  738906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  738917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  738920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  738923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  738926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  738955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738974 */     GIR_RootConstrainSelectedInstOperands,
     /*  738975 */     // GIR_Coverage, 12262,
     /*  738975 */     GIR_EraseRootFromParent_Done,
     /*  738976 */   // Label 11605: @738976
     /*  738976 */   GIM_Try, /*On fail goto*//*Label 11606*/ GIMT_Encode4(739051), // Rule ID 12263 //
     /*  738981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  738992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  738995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  738998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  739001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739027 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  739030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739049 */     GIR_RootConstrainSelectedInstOperands,
     /*  739050 */     // GIR_Coverage, 12263,
     /*  739050 */     GIR_EraseRootFromParent_Done,
     /*  739051 */   // Label 11606: @739051
     /*  739051 */   GIM_Try, /*On fail goto*//*Label 11607*/ GIMT_Encode4(739126), // Rule ID 12266 //
     /*  739056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  739076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  739105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739124 */     GIR_RootConstrainSelectedInstOperands,
     /*  739125 */     // GIR_Coverage, 12266,
     /*  739125 */     GIR_EraseRootFromParent_Done,
     /*  739126 */   // Label 11607: @739126
     /*  739126 */   GIM_Try, /*On fail goto*//*Label 11608*/ GIMT_Encode4(739201), // Rule ID 12267 //
     /*  739131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  739142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  739145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  739148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  739151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  739170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  739180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739199 */     GIR_RootConstrainSelectedInstOperands,
     /*  739200 */     // GIR_Coverage, 12267,
     /*  739200 */     GIR_EraseRootFromParent_Done,
     /*  739201 */   // Label 11608: @739201
     /*  739201 */   GIM_Try, /*On fail goto*//*Label 11609*/ GIMT_Encode4(739276), // Rule ID 12270 //
     /*  739206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  739226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  739255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739274 */     GIR_RootConstrainSelectedInstOperands,
     /*  739275 */     // GIR_Coverage, 12270,
     /*  739275 */     GIR_EraseRootFromParent_Done,
     /*  739276 */   // Label 11609: @739276
     /*  739276 */   GIM_Try, /*On fail goto*//*Label 11610*/ GIMT_Encode4(739351), // Rule ID 12271 //
     /*  739281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  739292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  739295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  739298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  739301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  739320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739327 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  739330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739349 */     GIR_RootConstrainSelectedInstOperands,
     /*  739350 */     // GIR_Coverage, 12271,
     /*  739350 */     GIR_EraseRootFromParent_Done,
     /*  739351 */   // Label 11610: @739351
     /*  739351 */   GIM_Try, /*On fail goto*//*Label 11611*/ GIMT_Encode4(739426), // Rule ID 12274 //
     /*  739356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  739359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  739376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739402 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  739402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  739405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739424 */     GIR_RootConstrainSelectedInstOperands,
     /*  739425 */     // GIR_Coverage, 12274,
     /*  739425 */     GIR_EraseRootFromParent_Done,
     /*  739426 */   // Label 11611: @739426
     /*  739426 */   GIM_Try, /*On fail goto*//*Label 11612*/ GIMT_Encode4(739501), // Rule ID 12275 //
     /*  739431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  739434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  739442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  739445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  739448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  739451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  739470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739477 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  739477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  739480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  739496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739499 */     GIR_RootConstrainSelectedInstOperands,
     /*  739500 */     // GIR_Coverage, 12275,
     /*  739500 */     GIR_EraseRootFromParent_Done,
     /*  739501 */   // Label 11612: @739501
     /*  739501 */   GIM_Try, /*On fail goto*//*Label 11613*/ GIMT_Encode4(739576), // Rule ID 12278 //
     /*  739506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  739517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  739520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  739523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739552 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  739555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739574 */     GIR_RootConstrainSelectedInstOperands,
     /*  739575 */     // GIR_Coverage, 12278,
     /*  739575 */     GIR_EraseRootFromParent_Done,
     /*  739576 */   // Label 11613: @739576
     /*  739576 */   GIM_Try, /*On fail goto*//*Label 11614*/ GIMT_Encode4(739651), // Rule ID 12279 //
     /*  739581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  739592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  739595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  739598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  739630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739649 */     GIR_RootConstrainSelectedInstOperands,
     /*  739650 */     // GIR_Coverage, 12279,
     /*  739650 */     GIR_EraseRootFromParent_Done,
     /*  739651 */   // Label 11614: @739651
     /*  739651 */   GIM_Try, /*On fail goto*//*Label 11615*/ GIMT_Encode4(739726), // Rule ID 12282 //
     /*  739656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  739667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  739670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  739673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739702 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  739705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739724 */     GIR_RootConstrainSelectedInstOperands,
     /*  739725 */     // GIR_Coverage, 12282,
     /*  739725 */     GIR_EraseRootFromParent_Done,
     /*  739726 */   // Label 11615: @739726
     /*  739726 */   GIM_Try, /*On fail goto*//*Label 11616*/ GIMT_Encode4(739801), // Rule ID 12283 //
     /*  739731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  739742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  739745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  739748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739777 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  739780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739799 */     GIR_RootConstrainSelectedInstOperands,
     /*  739800 */     // GIR_Coverage, 12283,
     /*  739800 */     GIR_EraseRootFromParent_Done,
     /*  739801 */   // Label 11616: @739801
     /*  739801 */   GIM_Try, /*On fail goto*//*Label 11617*/ GIMT_Encode4(739876), // Rule ID 12286 //
     /*  739806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  739817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  739820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  739823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739852 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  739855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739874 */     GIR_RootConstrainSelectedInstOperands,
     /*  739875 */     // GIR_Coverage, 12286,
     /*  739875 */     GIR_EraseRootFromParent_Done,
     /*  739876 */   // Label 11617: @739876
     /*  739876 */   GIM_Try, /*On fail goto*//*Label 11618*/ GIMT_Encode4(739951), // Rule ID 12287 //
     /*  739881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  739892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  739895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  739898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739927 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  739930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739949 */     GIR_RootConstrainSelectedInstOperands,
     /*  739950 */     // GIR_Coverage, 12287,
     /*  739950 */     GIR_EraseRootFromParent_Done,
     /*  739951 */   // Label 11618: @739951
     /*  739951 */   GIM_Try, /*On fail goto*//*Label 11619*/ GIMT_Encode4(740026), // Rule ID 12290 //
     /*  739956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  739967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  739970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  739973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740002 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  740005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740024 */     GIR_RootConstrainSelectedInstOperands,
     /*  740025 */     // GIR_Coverage, 12290,
     /*  740025 */     GIR_EraseRootFromParent_Done,
     /*  740026 */   // Label 11619: @740026
     /*  740026 */   GIM_Try, /*On fail goto*//*Label 11620*/ GIMT_Encode4(740101), // Rule ID 12291 //
     /*  740031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  740042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  740045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  740048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740077 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  740080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740099 */     GIR_RootConstrainSelectedInstOperands,
     /*  740100 */     // GIR_Coverage, 12291,
     /*  740100 */     GIR_EraseRootFromParent_Done,
     /*  740101 */   // Label 11620: @740101
     /*  740101 */   GIM_Try, /*On fail goto*//*Label 11621*/ GIMT_Encode4(740176), // Rule ID 12294 //
     /*  740106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740152 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  740155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740174 */     GIR_RootConstrainSelectedInstOperands,
     /*  740175 */     // GIR_Coverage, 12294,
     /*  740175 */     GIR_EraseRootFromParent_Done,
     /*  740176 */   // Label 11621: @740176
     /*  740176 */   GIM_Try, /*On fail goto*//*Label 11622*/ GIMT_Encode4(740251), // Rule ID 12295 //
     /*  740181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  740192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  740195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  740198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740227 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  740230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740249 */     GIR_RootConstrainSelectedInstOperands,
     /*  740250 */     // GIR_Coverage, 12295,
     /*  740250 */     GIR_EraseRootFromParent_Done,
     /*  740251 */   // Label 11622: @740251
     /*  740251 */   GIM_Try, /*On fail goto*//*Label 11623*/ GIMT_Encode4(740326), // Rule ID 12298 //
     /*  740256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  740305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740324 */     GIR_RootConstrainSelectedInstOperands,
     /*  740325 */     // GIR_Coverage, 12298,
     /*  740325 */     GIR_EraseRootFromParent_Done,
     /*  740326 */   // Label 11623: @740326
     /*  740326 */   GIM_Try, /*On fail goto*//*Label 11624*/ GIMT_Encode4(740401), // Rule ID 12299 //
     /*  740331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  740342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  740345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  740348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740377 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  740380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740399 */     GIR_RootConstrainSelectedInstOperands,
     /*  740400 */     // GIR_Coverage, 12299,
     /*  740400 */     GIR_EraseRootFromParent_Done,
     /*  740401 */   // Label 11624: @740401
     /*  740401 */   GIM_Try, /*On fail goto*//*Label 11625*/ GIMT_Encode4(740476), // Rule ID 12302 //
     /*  740406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  740455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740474 */     GIR_RootConstrainSelectedInstOperands,
     /*  740475 */     // GIR_Coverage, 12302,
     /*  740475 */     GIR_EraseRootFromParent_Done,
     /*  740476 */   // Label 11625: @740476
     /*  740476 */   GIM_Try, /*On fail goto*//*Label 11626*/ GIMT_Encode4(740551), // Rule ID 12303 //
     /*  740481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  740492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  740495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  740498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740527 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  740530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740549 */     GIR_RootConstrainSelectedInstOperands,
     /*  740550 */     // GIR_Coverage, 12303,
     /*  740550 */     GIR_EraseRootFromParent_Done,
     /*  740551 */   // Label 11626: @740551
     /*  740551 */   GIM_Try, /*On fail goto*//*Label 11627*/ GIMT_Encode4(740626), // Rule ID 12306 //
     /*  740556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  740567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  740570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  740573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  740605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740624 */     GIR_RootConstrainSelectedInstOperands,
     /*  740625 */     // GIR_Coverage, 12306,
     /*  740625 */     GIR_EraseRootFromParent_Done,
     /*  740626 */   // Label 11627: @740626
     /*  740626 */   GIM_Try, /*On fail goto*//*Label 11628*/ GIMT_Encode4(740701), // Rule ID 12307 //
     /*  740631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  740642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  740645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  740648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740677 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  740680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740699 */     GIR_RootConstrainSelectedInstOperands,
     /*  740700 */     // GIR_Coverage, 12307,
     /*  740700 */     GIR_EraseRootFromParent_Done,
     /*  740701 */   // Label 11628: @740701
     /*  740701 */   GIM_Try, /*On fail goto*//*Label 11629*/ GIMT_Encode4(740776), // Rule ID 12310 //
     /*  740706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  740723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  740755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740774 */     GIR_RootConstrainSelectedInstOperands,
     /*  740775 */     // GIR_Coverage, 12310,
     /*  740775 */     GIR_EraseRootFromParent_Done,
     /*  740776 */   // Label 11629: @740776
     /*  740776 */   GIM_Try, /*On fail goto*//*Label 11630*/ GIMT_Encode4(740851), // Rule ID 12311 //
     /*  740781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  740798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740827 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  740830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740849 */     GIR_RootConstrainSelectedInstOperands,
     /*  740850 */     // GIR_Coverage, 12311,
     /*  740850 */     GIR_EraseRootFromParent_Done,
     /*  740851 */   // Label 11630: @740851
     /*  740851 */   GIM_Try, /*On fail goto*//*Label 11631*/ GIMT_Encode4(740926), // Rule ID 12314 //
     /*  740856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  740859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  740873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  740902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  740905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  740921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740924 */     GIR_RootConstrainSelectedInstOperands,
     /*  740925 */     // GIR_Coverage, 12314,
     /*  740925 */     GIR_EraseRootFromParent_Done,
     /*  740926 */   // Label 11631: @740926
     /*  740926 */   GIM_Try, /*On fail goto*//*Label 11632*/ GIMT_Encode4(741001), // Rule ID 12315 //
     /*  740931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  740934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  740948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740977 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  740977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  740980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  740996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740999 */     GIR_RootConstrainSelectedInstOperands,
     /*  741000 */     // GIR_Coverage, 12315,
     /*  741000 */     GIR_EraseRootFromParent_Done,
     /*  741001 */   // Label 11632: @741001
     /*  741001 */   GIM_Try, /*On fail goto*//*Label 11633*/ GIMT_Encode4(741076), // Rule ID 12318 //
     /*  741006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  741055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741074 */     GIR_RootConstrainSelectedInstOperands,
     /*  741075 */     // GIR_Coverage, 12318,
     /*  741075 */     GIR_EraseRootFromParent_Done,
     /*  741076 */   // Label 11633: @741076
     /*  741076 */   GIM_Try, /*On fail goto*//*Label 11634*/ GIMT_Encode4(741151), // Rule ID 12319 //
     /*  741081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  741092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  741095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  741098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741127 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  741130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741149 */     GIR_RootConstrainSelectedInstOperands,
     /*  741150 */     // GIR_Coverage, 12319,
     /*  741150 */     GIR_EraseRootFromParent_Done,
     /*  741151 */   // Label 11634: @741151
     /*  741151 */   GIM_Try, /*On fail goto*//*Label 11635*/ GIMT_Encode4(741226), // Rule ID 12322 //
     /*  741156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741202 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  741205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741224 */     GIR_RootConstrainSelectedInstOperands,
     /*  741225 */     // GIR_Coverage, 12322,
     /*  741225 */     GIR_EraseRootFromParent_Done,
     /*  741226 */   // Label 11635: @741226
     /*  741226 */   GIM_Try, /*On fail goto*//*Label 11636*/ GIMT_Encode4(741301), // Rule ID 12323 //
     /*  741231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  741242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  741245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  741248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741277 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  741280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741299 */     GIR_RootConstrainSelectedInstOperands,
     /*  741300 */     // GIR_Coverage, 12323,
     /*  741300 */     GIR_EraseRootFromParent_Done,
     /*  741301 */   // Label 11636: @741301
     /*  741301 */   GIM_Try, /*On fail goto*//*Label 11637*/ GIMT_Encode4(741376), // Rule ID 12326 //
     /*  741306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741352 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  741352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  741355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741374 */     GIR_RootConstrainSelectedInstOperands,
     /*  741375 */     // GIR_Coverage, 12326,
     /*  741375 */     GIR_EraseRootFromParent_Done,
     /*  741376 */   // Label 11637: @741376
     /*  741376 */   GIM_Try, /*On fail goto*//*Label 11638*/ GIMT_Encode4(741451), // Rule ID 12327 //
     /*  741381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  741392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  741395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  741398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741427 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  741427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  741430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  741446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741449 */     GIR_RootConstrainSelectedInstOperands,
     /*  741450 */     // GIR_Coverage, 12327,
     /*  741450 */     GIR_EraseRootFromParent_Done,
     /*  741451 */   // Label 11638: @741451
     /*  741451 */   GIM_Try, /*On fail goto*//*Label 11639*/ GIMT_Encode4(741526), // Rule ID 12330 //
     /*  741456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  741467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  741470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  741473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  741505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741524 */     GIR_RootConstrainSelectedInstOperands,
     /*  741525 */     // GIR_Coverage, 12330,
     /*  741525 */     GIR_EraseRootFromParent_Done,
     /*  741526 */   // Label 11639: @741526
     /*  741526 */   GIM_Try, /*On fail goto*//*Label 11640*/ GIMT_Encode4(741601), // Rule ID 12331 //
     /*  741531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  741542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  741545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  741548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  741580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741599 */     GIR_RootConstrainSelectedInstOperands,
     /*  741600 */     // GIR_Coverage, 12331,
     /*  741600 */     GIR_EraseRootFromParent_Done,
     /*  741601 */   // Label 11640: @741601
     /*  741601 */   GIM_Try, /*On fail goto*//*Label 11641*/ GIMT_Encode4(741676), // Rule ID 12334 //
     /*  741606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  741617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  741620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  741623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741652 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  741655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741674 */     GIR_RootConstrainSelectedInstOperands,
     /*  741675 */     // GIR_Coverage, 12334,
     /*  741675 */     GIR_EraseRootFromParent_Done,
     /*  741676 */   // Label 11641: @741676
     /*  741676 */   GIM_Try, /*On fail goto*//*Label 11642*/ GIMT_Encode4(741751), // Rule ID 12335 //
     /*  741681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  741692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  741695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  741698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741727 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  741730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741749 */     GIR_RootConstrainSelectedInstOperands,
     /*  741750 */     // GIR_Coverage, 12335,
     /*  741750 */     GIR_EraseRootFromParent_Done,
     /*  741751 */   // Label 11642: @741751
     /*  741751 */   GIM_Try, /*On fail goto*//*Label 11643*/ GIMT_Encode4(741826), // Rule ID 12338 //
     /*  741756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  741767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  741770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  741773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  741805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741824 */     GIR_RootConstrainSelectedInstOperands,
     /*  741825 */     // GIR_Coverage, 12338,
     /*  741825 */     GIR_EraseRootFromParent_Done,
     /*  741826 */   // Label 11643: @741826
     /*  741826 */   GIM_Try, /*On fail goto*//*Label 11644*/ GIMT_Encode4(741901), // Rule ID 12339 //
     /*  741831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  741842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  741845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  741848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741877 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  741880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741899 */     GIR_RootConstrainSelectedInstOperands,
     /*  741900 */     // GIR_Coverage, 12339,
     /*  741900 */     GIR_EraseRootFromParent_Done,
     /*  741901 */   // Label 11644: @741901
     /*  741901 */   GIM_Try, /*On fail goto*//*Label 11645*/ GIMT_Encode4(741976), // Rule ID 12342 //
     /*  741906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  741917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  741920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  741923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  741955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741974 */     GIR_RootConstrainSelectedInstOperands,
     /*  741975 */     // GIR_Coverage, 12342,
     /*  741975 */     GIR_EraseRootFromParent_Done,
     /*  741976 */   // Label 11645: @741976
     /*  741976 */   GIM_Try, /*On fail goto*//*Label 11646*/ GIMT_Encode4(742051), // Rule ID 12343 //
     /*  741981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  741992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  741995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  741998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742027 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  742030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742049 */     GIR_RootConstrainSelectedInstOperands,
     /*  742050 */     // GIR_Coverage, 12343,
     /*  742050 */     GIR_EraseRootFromParent_Done,
     /*  742051 */   // Label 11646: @742051
     /*  742051 */   GIM_Try, /*On fail goto*//*Label 11647*/ GIMT_Encode4(742126), // Rule ID 12346 //
     /*  742056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  742105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742124 */     GIR_RootConstrainSelectedInstOperands,
     /*  742125 */     // GIR_Coverage, 12346,
     /*  742125 */     GIR_EraseRootFromParent_Done,
     /*  742126 */   // Label 11647: @742126
     /*  742126 */   GIM_Try, /*On fail goto*//*Label 11648*/ GIMT_Encode4(742201), // Rule ID 12347 //
     /*  742131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  742142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  742145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  742148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  742180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742199 */     GIR_RootConstrainSelectedInstOperands,
     /*  742200 */     // GIR_Coverage, 12347,
     /*  742200 */     GIR_EraseRootFromParent_Done,
     /*  742201 */   // Label 11648: @742201
     /*  742201 */   GIM_Try, /*On fail goto*//*Label 11649*/ GIMT_Encode4(742276), // Rule ID 12350 //
     /*  742206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742252 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  742252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  742255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742274 */     GIR_RootConstrainSelectedInstOperands,
     /*  742275 */     // GIR_Coverage, 12350,
     /*  742275 */     GIR_EraseRootFromParent_Done,
     /*  742276 */   // Label 11649: @742276
     /*  742276 */   GIM_Try, /*On fail goto*//*Label 11650*/ GIMT_Encode4(742351), // Rule ID 12351 //
     /*  742281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  742292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  742295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  742298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742327 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  742327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  742330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  742346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742349 */     GIR_RootConstrainSelectedInstOperands,
     /*  742350 */     // GIR_Coverage, 12351,
     /*  742350 */     GIR_EraseRootFromParent_Done,
     /*  742351 */   // Label 11650: @742351
     /*  742351 */   GIM_Try, /*On fail goto*//*Label 11651*/ GIMT_Encode4(742426), // Rule ID 12354 //
     /*  742356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  742405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742424 */     GIR_RootConstrainSelectedInstOperands,
     /*  742425 */     // GIR_Coverage, 12354,
     /*  742425 */     GIR_EraseRootFromParent_Done,
     /*  742426 */   // Label 11651: @742426
     /*  742426 */   GIM_Try, /*On fail goto*//*Label 11652*/ GIMT_Encode4(742501), // Rule ID 12355 //
     /*  742431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  742442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  742445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  742448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742477 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  742480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742499 */     GIR_RootConstrainSelectedInstOperands,
     /*  742500 */     // GIR_Coverage, 12355,
     /*  742500 */     GIR_EraseRootFromParent_Done,
     /*  742501 */   // Label 11652: @742501
     /*  742501 */   GIM_Try, /*On fail goto*//*Label 11653*/ GIMT_Encode4(742576), // Rule ID 12358 //
     /*  742506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  742517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  742520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  742523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  742555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742574 */     GIR_RootConstrainSelectedInstOperands,
     /*  742575 */     // GIR_Coverage, 12358,
     /*  742575 */     GIR_EraseRootFromParent_Done,
     /*  742576 */   // Label 11653: @742576
     /*  742576 */   GIM_Try, /*On fail goto*//*Label 11654*/ GIMT_Encode4(742651), // Rule ID 12359 //
     /*  742581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  742592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  742595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  742598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742627 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  742630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742649 */     GIR_RootConstrainSelectedInstOperands,
     /*  742650 */     // GIR_Coverage, 12359,
     /*  742650 */     GIR_EraseRootFromParent_Done,
     /*  742651 */   // Label 11654: @742651
     /*  742651 */   GIM_Try, /*On fail goto*//*Label 11655*/ GIMT_Encode4(742726), // Rule ID 12362 //
     /*  742656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  742667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  742670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  742673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  742705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742724 */     GIR_RootConstrainSelectedInstOperands,
     /*  742725 */     // GIR_Coverage, 12362,
     /*  742725 */     GIR_EraseRootFromParent_Done,
     /*  742726 */   // Label 11655: @742726
     /*  742726 */   GIM_Try, /*On fail goto*//*Label 11656*/ GIMT_Encode4(742801), // Rule ID 12363 //
     /*  742731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  742742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  742745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  742748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  742780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742799 */     GIR_RootConstrainSelectedInstOperands,
     /*  742800 */     // GIR_Coverage, 12363,
     /*  742800 */     GIR_EraseRootFromParent_Done,
     /*  742801 */   // Label 11656: @742801
     /*  742801 */   GIM_Try, /*On fail goto*//*Label 11657*/ GIMT_Encode4(742876), // Rule ID 12366 //
     /*  742806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  742817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  742820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  742823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  742826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742852 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  742855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742874 */     GIR_RootConstrainSelectedInstOperands,
     /*  742875 */     // GIR_Coverage, 12366,
     /*  742875 */     GIR_EraseRootFromParent_Done,
     /*  742876 */   // Label 11657: @742876
     /*  742876 */   GIM_Try, /*On fail goto*//*Label 11658*/ GIMT_Encode4(742951), // Rule ID 12367 //
     /*  742881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  742892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  742895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  742898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  742901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742927 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  742927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  742930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742949 */     GIR_RootConstrainSelectedInstOperands,
     /*  742950 */     // GIR_Coverage, 12367,
     /*  742950 */     GIR_EraseRootFromParent_Done,
     /*  742951 */   // Label 11658: @742951
     /*  742951 */   GIM_Try, /*On fail goto*//*Label 11659*/ GIMT_Encode4(743026), // Rule ID 12370 //
     /*  742956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  742967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  742970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  742973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  742976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743002 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743024 */     GIR_RootConstrainSelectedInstOperands,
     /*  743025 */     // GIR_Coverage, 12370,
     /*  743025 */     GIR_EraseRootFromParent_Done,
     /*  743026 */   // Label 11659: @743026
     /*  743026 */   GIM_Try, /*On fail goto*//*Label 11660*/ GIMT_Encode4(743101), // Rule ID 12371 //
     /*  743031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  743042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  743045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  743048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  743051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743077 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743099 */     GIR_RootConstrainSelectedInstOperands,
     /*  743100 */     // GIR_Coverage, 12371,
     /*  743100 */     GIR_EraseRootFromParent_Done,
     /*  743101 */   // Label 11660: @743101
     /*  743101 */   GIM_Try, /*On fail goto*//*Label 11661*/ GIMT_Encode4(743176), // Rule ID 12374 //
     /*  743106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  743126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743174 */     GIR_RootConstrainSelectedInstOperands,
     /*  743175 */     // GIR_Coverage, 12374,
     /*  743175 */     GIR_EraseRootFromParent_Done,
     /*  743176 */   // Label 11661: @743176
     /*  743176 */   GIM_Try, /*On fail goto*//*Label 11662*/ GIMT_Encode4(743251), // Rule ID 12375 //
     /*  743181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  743192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  743195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  743198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  743201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743249 */     GIR_RootConstrainSelectedInstOperands,
     /*  743250 */     // GIR_Coverage, 12375,
     /*  743250 */     GIR_EraseRootFromParent_Done,
     /*  743251 */   // Label 11662: @743251
     /*  743251 */   GIM_Try, /*On fail goto*//*Label 11663*/ GIMT_Encode4(743326), // Rule ID 12378 //
     /*  743256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  743267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  743270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  743273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  743276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743324 */     GIR_RootConstrainSelectedInstOperands,
     /*  743325 */     // GIR_Coverage, 12378,
     /*  743325 */     GIR_EraseRootFromParent_Done,
     /*  743326 */   // Label 11663: @743326
     /*  743326 */   GIM_Try, /*On fail goto*//*Label 11664*/ GIMT_Encode4(743401), // Rule ID 12379 //
     /*  743331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  743342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  743345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  743348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  743351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743399 */     GIR_RootConstrainSelectedInstOperands,
     /*  743400 */     // GIR_Coverage, 12379,
     /*  743400 */     GIR_EraseRootFromParent_Done,
     /*  743401 */   // Label 11664: @743401
     /*  743401 */   GIM_Try, /*On fail goto*//*Label 11665*/ GIMT_Encode4(743476), // Rule ID 12382 //
     /*  743406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  743417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  743420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  743423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  743426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743474 */     GIR_RootConstrainSelectedInstOperands,
     /*  743475 */     // GIR_Coverage, 12382,
     /*  743475 */     GIR_EraseRootFromParent_Done,
     /*  743476 */   // Label 11665: @743476
     /*  743476 */   GIM_Try, /*On fail goto*//*Label 11666*/ GIMT_Encode4(743551), // Rule ID 12383 //
     /*  743481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  743492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  743495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  743498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  743501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743527 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743549 */     GIR_RootConstrainSelectedInstOperands,
     /*  743550 */     // GIR_Coverage, 12383,
     /*  743550 */     GIR_EraseRootFromParent_Done,
     /*  743551 */   // Label 11666: @743551
     /*  743551 */   GIM_Try, /*On fail goto*//*Label 11667*/ GIMT_Encode4(743626), // Rule ID 12386 //
     /*  743556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  743567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  743570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  743573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  743576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  743605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743624 */     GIR_RootConstrainSelectedInstOperands,
     /*  743625 */     // GIR_Coverage, 12386,
     /*  743625 */     GIR_EraseRootFromParent_Done,
     /*  743626 */   // Label 11667: @743626
     /*  743626 */   GIM_Try, /*On fail goto*//*Label 11668*/ GIMT_Encode4(743701), // Rule ID 12387 //
     /*  743631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  743642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  743645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  743648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  743651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743677 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  743680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743699 */     GIR_RootConstrainSelectedInstOperands,
     /*  743700 */     // GIR_Coverage, 12387,
     /*  743700 */     GIR_EraseRootFromParent_Done,
     /*  743701 */   // Label 11668: @743701
     /*  743701 */   GIM_Try, /*On fail goto*//*Label 11669*/ GIMT_Encode4(743776), // Rule ID 12390 //
     /*  743706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  743717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  743720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  743726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743774 */     GIR_RootConstrainSelectedInstOperands,
     /*  743775 */     // GIR_Coverage, 12390,
     /*  743775 */     GIR_EraseRootFromParent_Done,
     /*  743776 */   // Label 11669: @743776
     /*  743776 */   GIM_Try, /*On fail goto*//*Label 11670*/ GIMT_Encode4(743851), // Rule ID 12391 //
     /*  743781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  743792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  743795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  743801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743849 */     GIR_RootConstrainSelectedInstOperands,
     /*  743850 */     // GIR_Coverage, 12391,
     /*  743850 */     GIR_EraseRootFromParent_Done,
     /*  743851 */   // Label 11670: @743851
     /*  743851 */   GIM_Try, /*On fail goto*//*Label 11671*/ GIMT_Encode4(743926), // Rule ID 12394 //
     /*  743856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  743867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  743870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  743876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743924 */     GIR_RootConstrainSelectedInstOperands,
     /*  743925 */     // GIR_Coverage, 12394,
     /*  743925 */     GIR_EraseRootFromParent_Done,
     /*  743926 */   // Label 11671: @743926
     /*  743926 */   GIM_Try, /*On fail goto*//*Label 11672*/ GIMT_Encode4(744001), // Rule ID 12395 //
     /*  743931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  743942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  743945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  743951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743999 */     GIR_RootConstrainSelectedInstOperands,
     /*  744000 */     // GIR_Coverage, 12395,
     /*  744000 */     GIR_EraseRootFromParent_Done,
     /*  744001 */   // Label 11672: @744001
     /*  744001 */   GIM_Try, /*On fail goto*//*Label 11673*/ GIMT_Encode4(744076), // Rule ID 12398 //
     /*  744006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  744017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  744020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744074 */     GIR_RootConstrainSelectedInstOperands,
     /*  744075 */     // GIR_Coverage, 12398,
     /*  744075 */     GIR_EraseRootFromParent_Done,
     /*  744076 */   // Label 11673: @744076
     /*  744076 */   GIM_Try, /*On fail goto*//*Label 11674*/ GIMT_Encode4(744151), // Rule ID 12399 //
     /*  744081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  744092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  744095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  744098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  744101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744149 */     GIR_RootConstrainSelectedInstOperands,
     /*  744150 */     // GIR_Coverage, 12399,
     /*  744150 */     GIR_EraseRootFromParent_Done,
     /*  744151 */   // Label 11674: @744151
     /*  744151 */   GIM_Try, /*On fail goto*//*Label 11675*/ GIMT_Encode4(744226), // Rule ID 12402 //
     /*  744156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  744167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  744170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  744176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744202 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744224 */     GIR_RootConstrainSelectedInstOperands,
     /*  744225 */     // GIR_Coverage, 12402,
     /*  744225 */     GIR_EraseRootFromParent_Done,
     /*  744226 */   // Label 11675: @744226
     /*  744226 */   GIM_Try, /*On fail goto*//*Label 11676*/ GIMT_Encode4(744301), // Rule ID 12403 //
     /*  744231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  744242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  744245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  744248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  744251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744277 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744299 */     GIR_RootConstrainSelectedInstOperands,
     /*  744300 */     // GIR_Coverage, 12403,
     /*  744300 */     GIR_EraseRootFromParent_Done,
     /*  744301 */   // Label 11676: @744301
     /*  744301 */   GIM_Try, /*On fail goto*//*Label 11677*/ GIMT_Encode4(744376), // Rule ID 12406 //
     /*  744306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  744317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  744320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  744326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  744352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744374 */     GIR_RootConstrainSelectedInstOperands,
     /*  744375 */     // GIR_Coverage, 12406,
     /*  744375 */     GIR_EraseRootFromParent_Done,
     /*  744376 */   // Label 11677: @744376
     /*  744376 */   GIM_Try, /*On fail goto*//*Label 11678*/ GIMT_Encode4(744451), // Rule ID 12407 //
     /*  744381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  744392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  744395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  744398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  744401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744427 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  744427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  744446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744449 */     GIR_RootConstrainSelectedInstOperands,
     /*  744450 */     // GIR_Coverage, 12407,
     /*  744450 */     GIR_EraseRootFromParent_Done,
     /*  744451 */   // Label 11678: @744451
     /*  744451 */   GIM_Try, /*On fail goto*//*Label 11679*/ GIMT_Encode4(744526), // Rule ID 12410 //
     /*  744456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  744476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744524 */     GIR_RootConstrainSelectedInstOperands,
     /*  744525 */     // GIR_Coverage, 12410,
     /*  744525 */     GIR_EraseRootFromParent_Done,
     /*  744526 */   // Label 11679: @744526
     /*  744526 */   GIM_Try, /*On fail goto*//*Label 11680*/ GIMT_Encode4(744601), // Rule ID 12411 //
     /*  744531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  744551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744599 */     GIR_RootConstrainSelectedInstOperands,
     /*  744600 */     // GIR_Coverage, 12411,
     /*  744600 */     GIR_EraseRootFromParent_Done,
     /*  744601 */   // Label 11680: @744601
     /*  744601 */   GIM_Try, /*On fail goto*//*Label 11681*/ GIMT_Encode4(744676), // Rule ID 12414 //
     /*  744606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  744617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  744620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744674 */     GIR_RootConstrainSelectedInstOperands,
     /*  744675 */     // GIR_Coverage, 12414,
     /*  744675 */     GIR_EraseRootFromParent_Done,
     /*  744676 */   // Label 11681: @744676
     /*  744676 */   GIM_Try, /*On fail goto*//*Label 11682*/ GIMT_Encode4(744751), // Rule ID 12415 //
     /*  744681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  744692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  744695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744727 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744749 */     GIR_RootConstrainSelectedInstOperands,
     /*  744750 */     // GIR_Coverage, 12415,
     /*  744750 */     GIR_EraseRootFromParent_Done,
     /*  744751 */   // Label 11682: @744751
     /*  744751 */   GIM_Try, /*On fail goto*//*Label 11683*/ GIMT_Encode4(744826), // Rule ID 12418 //
     /*  744756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  744767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  744770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  744773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  744776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744824 */     GIR_RootConstrainSelectedInstOperands,
     /*  744825 */     // GIR_Coverage, 12418,
     /*  744825 */     GIR_EraseRootFromParent_Done,
     /*  744826 */   // Label 11683: @744826
     /*  744826 */   GIM_Try, /*On fail goto*//*Label 11684*/ GIMT_Encode4(744901), // Rule ID 12419 //
     /*  744831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  744842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  744845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  744848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  744851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744877 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744899 */     GIR_RootConstrainSelectedInstOperands,
     /*  744900 */     // GIR_Coverage, 12419,
     /*  744900 */     GIR_EraseRootFromParent_Done,
     /*  744901 */   // Label 11684: @744901
     /*  744901 */   GIM_Try, /*On fail goto*//*Label 11685*/ GIMT_Encode4(744976), // Rule ID 12422 //
     /*  744906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  744917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  744920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  744923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  744926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744952 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744974 */     GIR_RootConstrainSelectedInstOperands,
     /*  744975 */     // GIR_Coverage, 12422,
     /*  744975 */     GIR_EraseRootFromParent_Done,
     /*  744976 */   // Label 11685: @744976
     /*  744976 */   GIM_Try, /*On fail goto*//*Label 11686*/ GIMT_Encode4(745051), // Rule ID 12423 //
     /*  744981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  744992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  744995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  744998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  745001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745027 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  745027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  745030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  745046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745049 */     GIR_RootConstrainSelectedInstOperands,
     /*  745050 */     // GIR_Coverage, 12423,
     /*  745050 */     GIR_EraseRootFromParent_Done,
     /*  745051 */   // Label 11686: @745051
     /*  745051 */   GIM_Try, /*On fail goto*//*Label 11687*/ GIMT_Encode4(745126), // Rule ID 12426 //
     /*  745056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  745067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  745070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  745073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  745105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745124 */     GIR_RootConstrainSelectedInstOperands,
     /*  745125 */     // GIR_Coverage, 12426,
     /*  745125 */     GIR_EraseRootFromParent_Done,
     /*  745126 */   // Label 11687: @745126
     /*  745126 */   GIM_Try, /*On fail goto*//*Label 11688*/ GIMT_Encode4(745201), // Rule ID 12427 //
     /*  745131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  745142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  745145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  745148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  745180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745199 */     GIR_RootConstrainSelectedInstOperands,
     /*  745200 */     // GIR_Coverage, 12427,
     /*  745200 */     GIR_EraseRootFromParent_Done,
     /*  745201 */   // Label 11688: @745201
     /*  745201 */   GIM_Try, /*On fail goto*//*Label 11689*/ GIMT_Encode4(745276), // Rule ID 12430 //
     /*  745206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  745217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  745220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  745223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745274 */     GIR_RootConstrainSelectedInstOperands,
     /*  745275 */     // GIR_Coverage, 12430,
     /*  745275 */     GIR_EraseRootFromParent_Done,
     /*  745276 */   // Label 11689: @745276
     /*  745276 */   GIM_Try, /*On fail goto*//*Label 11690*/ GIMT_Encode4(745351), // Rule ID 12431 //
     /*  745281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  745292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  745295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  745298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745349 */     GIR_RootConstrainSelectedInstOperands,
     /*  745350 */     // GIR_Coverage, 12431,
     /*  745350 */     GIR_EraseRootFromParent_Done,
     /*  745351 */   // Label 11690: @745351
     /*  745351 */   GIM_Try, /*On fail goto*//*Label 11691*/ GIMT_Encode4(745426), // Rule ID 12434 //
     /*  745356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  745373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745424 */     GIR_RootConstrainSelectedInstOperands,
     /*  745425 */     // GIR_Coverage, 12434,
     /*  745425 */     GIR_EraseRootFromParent_Done,
     /*  745426 */   // Label 11691: @745426
     /*  745426 */   GIM_Try, /*On fail goto*//*Label 11692*/ GIMT_Encode4(745501), // Rule ID 12435 //
     /*  745431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  745442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  745445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  745448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11655:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745499 */     GIR_RootConstrainSelectedInstOperands,
     /*  745500 */     // GIR_Coverage, 12435,
     /*  745500 */     GIR_EraseRootFromParent_Done,
     /*  745501 */   // Label 11692: @745501
     /*  745501 */   GIM_Try, /*On fail goto*//*Label 11693*/ GIMT_Encode4(745576), // Rule ID 12438 //
     /*  745506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  745523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  745555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745574 */     GIR_RootConstrainSelectedInstOperands,
     /*  745575 */     // GIR_Coverage, 12438,
     /*  745575 */     GIR_EraseRootFromParent_Done,
     /*  745576 */   // Label 11693: @745576
     /*  745576 */   GIM_Try, /*On fail goto*//*Label 11694*/ GIMT_Encode4(745651), // Rule ID 12439 //
     /*  745581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  745598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  745630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745649 */     GIR_RootConstrainSelectedInstOperands,
     /*  745650 */     // GIR_Coverage, 12439,
     /*  745650 */     GIR_EraseRootFromParent_Done,
     /*  745651 */   // Label 11694: @745651
     /*  745651 */   GIM_Try, /*On fail goto*//*Label 11695*/ GIMT_Encode4(745726), // Rule ID 12442 //
     /*  745656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  745673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  745705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745724 */     GIR_RootConstrainSelectedInstOperands,
     /*  745725 */     // GIR_Coverage, 12442,
     /*  745725 */     GIR_EraseRootFromParent_Done,
     /*  745726 */   // Label 11695: @745726
     /*  745726 */   GIM_Try, /*On fail goto*//*Label 11696*/ GIMT_Encode4(745801), // Rule ID 12443 //
     /*  745731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  745748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745777 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  745780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745799 */     GIR_RootConstrainSelectedInstOperands,
     /*  745800 */     // GIR_Coverage, 12443,
     /*  745800 */     GIR_EraseRootFromParent_Done,
     /*  745801 */   // Label 11696: @745801
     /*  745801 */   GIM_Try, /*On fail goto*//*Label 11697*/ GIMT_Encode4(745876), // Rule ID 12446 //
     /*  745806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  745855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745874 */     GIR_RootConstrainSelectedInstOperands,
     /*  745875 */     // GIR_Coverage, 12446,
     /*  745875 */     GIR_EraseRootFromParent_Done,
     /*  745876 */   // Label 11697: @745876
     /*  745876 */   GIM_Try, /*On fail goto*//*Label 11698*/ GIMT_Encode4(745951), // Rule ID 12447 //
     /*  745881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745927 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  745930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745949 */     GIR_RootConstrainSelectedInstOperands,
     /*  745950 */     // GIR_Coverage, 12447,
     /*  745950 */     GIR_EraseRootFromParent_Done,
     /*  745951 */   // Label 11698: @745951
     /*  745951 */   GIM_Try, /*On fail goto*//*Label 11699*/ GIMT_Encode4(746026), // Rule ID 12450 //
     /*  745956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  745967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  745970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  745973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746002 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  746005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746024 */     GIR_RootConstrainSelectedInstOperands,
     /*  746025 */     // GIR_Coverage, 12450,
     /*  746025 */     GIR_EraseRootFromParent_Done,
     /*  746026 */   // Label 11699: @746026
     /*  746026 */   GIM_Try, /*On fail goto*//*Label 11700*/ GIMT_Encode4(746101), // Rule ID 12451 //
     /*  746031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  746042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  746045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  746048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746077 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  746080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746099 */     GIR_RootConstrainSelectedInstOperands,
     /*  746100 */     // GIR_Coverage, 12451,
     /*  746100 */     GIR_EraseRootFromParent_Done,
     /*  746101 */   // Label 11700: @746101
     /*  746101 */   GIM_Try, /*On fail goto*//*Label 11701*/ GIMT_Encode4(746176), // Rule ID 12454 //
     /*  746106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  746123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746174 */     GIR_RootConstrainSelectedInstOperands,
     /*  746175 */     // GIR_Coverage, 12454,
     /*  746175 */     GIR_EraseRootFromParent_Done,
     /*  746176 */   // Label 11701: @746176
     /*  746176 */   GIM_Try, /*On fail goto*//*Label 11702*/ GIMT_Encode4(746251), // Rule ID 12455 //
     /*  746181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  746192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  746195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  746198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11655:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746249 */     GIR_RootConstrainSelectedInstOperands,
     /*  746250 */     // GIR_Coverage, 12455,
     /*  746250 */     GIR_EraseRootFromParent_Done,
     /*  746251 */   // Label 11702: @746251
     /*  746251 */   GIM_Try, /*On fail goto*//*Label 11703*/ GIMT_Encode4(746326), // Rule ID 12458 //
     /*  746256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  746267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  746270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746324 */     GIR_RootConstrainSelectedInstOperands,
     /*  746325 */     // GIR_Coverage, 12458,
     /*  746325 */     GIR_EraseRootFromParent_Done,
     /*  746326 */   // Label 11703: @746326
     /*  746326 */   GIM_Try, /*On fail goto*//*Label 11704*/ GIMT_Encode4(746401), // Rule ID 12459 //
     /*  746331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  746342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  746345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  746348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746377 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746399 */     GIR_RootConstrainSelectedInstOperands,
     /*  746400 */     // GIR_Coverage, 12459,
     /*  746400 */     GIR_EraseRootFromParent_Done,
     /*  746401 */   // Label 11704: @746401
     /*  746401 */   GIM_Try, /*On fail goto*//*Label 11705*/ GIMT_Encode4(746476), // Rule ID 12462 //
     /*  746406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  746417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  746420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746474 */     GIR_RootConstrainSelectedInstOperands,
     /*  746475 */     // GIR_Coverage, 12462,
     /*  746475 */     GIR_EraseRootFromParent_Done,
     /*  746476 */   // Label 11705: @746476
     /*  746476 */   GIM_Try, /*On fail goto*//*Label 11706*/ GIMT_Encode4(746551), // Rule ID 12463 //
     /*  746481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  746492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  746495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  746498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746527 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746549 */     GIR_RootConstrainSelectedInstOperands,
     /*  746550 */     // GIR_Coverage, 12463,
     /*  746550 */     GIR_EraseRootFromParent_Done,
     /*  746551 */   // Label 11706: @746551
     /*  746551 */   GIM_Try, /*On fail goto*//*Label 11707*/ GIMT_Encode4(746626), // Rule ID 12466 //
     /*  746556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  746573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746624 */     GIR_RootConstrainSelectedInstOperands,
     /*  746625 */     // GIR_Coverage, 12466,
     /*  746625 */     GIR_EraseRootFromParent_Done,
     /*  746626 */   // Label 11707: @746626
     /*  746626 */   GIM_Try, /*On fail goto*//*Label 11708*/ GIMT_Encode4(746701), // Rule ID 12467 //
     /*  746631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  746648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746677 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746699 */     GIR_RootConstrainSelectedInstOperands,
     /*  746700 */     // GIR_Coverage, 12467,
     /*  746700 */     GIR_EraseRootFromParent_Done,
     /*  746701 */   // Label 11708: @746701
     /*  746701 */   GIM_Try, /*On fail goto*//*Label 11709*/ GIMT_Encode4(746776), // Rule ID 12470 //
     /*  746706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  746709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  746717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  746720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  746723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746774 */     GIR_RootConstrainSelectedInstOperands,
     /*  746775 */     // GIR_Coverage, 12470,
     /*  746775 */     GIR_EraseRootFromParent_Done,
     /*  746776 */   // Label 11709: @746776
     /*  746776 */   GIM_Try, /*On fail goto*//*Label 11710*/ GIMT_Encode4(746851), // Rule ID 12471 //
     /*  746781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  746784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  746792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  746795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  746798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11655:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746849 */     GIR_RootConstrainSelectedInstOperands,
     /*  746850 */     // GIR_Coverage, 12471,
     /*  746850 */     GIR_EraseRootFromParent_Done,
     /*  746851 */   // Label 11710: @746851
     /*  746851 */   GIM_Try, /*On fail goto*//*Label 11711*/ GIMT_Encode4(746926), // Rule ID 12474 //
     /*  746856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  746859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  746873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746924 */     GIR_RootConstrainSelectedInstOperands,
     /*  746925 */     // GIR_Coverage, 12474,
     /*  746925 */     GIR_EraseRootFromParent_Done,
     /*  746926 */   // Label 11711: @746926
     /*  746926 */   GIM_Try, /*On fail goto*//*Label 11712*/ GIMT_Encode4(747001), // Rule ID 12475 //
     /*  746931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  746934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  746948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11655:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746999 */     GIR_RootConstrainSelectedInstOperands,
     /*  747000 */     // GIR_Coverage, 12475,
     /*  747000 */     GIR_EraseRootFromParent_Done,
     /*  747001 */   // Label 11712: @747001
     /*  747001 */   GIM_Try, /*On fail goto*//*Label 11713*/ GIMT_Encode4(747076), // Rule ID 12478 //
     /*  747006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  747017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  747020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  747055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747074 */     GIR_RootConstrainSelectedInstOperands,
     /*  747075 */     // GIR_Coverage, 12478,
     /*  747075 */     GIR_EraseRootFromParent_Done,
     /*  747076 */   // Label 11713: @747076
     /*  747076 */   GIM_Try, /*On fail goto*//*Label 11714*/ GIMT_Encode4(747151), // Rule ID 12479 //
     /*  747081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  747092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  747095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  747098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11655:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  747130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747149 */     GIR_RootConstrainSelectedInstOperands,
     /*  747150 */     // GIR_Coverage, 12479,
     /*  747150 */     GIR_EraseRootFromParent_Done,
     /*  747151 */   // Label 11714: @747151
     /*  747151 */   GIM_Try, /*On fail goto*//*Label 11715*/ GIMT_Encode4(747226), // Rule ID 12482 //
     /*  747156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  747159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  747167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  747170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  747176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  747202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747224 */     GIR_RootConstrainSelectedInstOperands,
     /*  747225 */     // GIR_Coverage, 12482,
     /*  747225 */     GIR_EraseRootFromParent_Done,
     /*  747226 */   // Label 11715: @747226
     /*  747226 */   GIM_Try, /*On fail goto*//*Label 11716*/ GIMT_Encode4(747301), // Rule ID 12483 //
     /*  747231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  747234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  747239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  747242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  747245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  747248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  747251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  747270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747277 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11655:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  747277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  747280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  747296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747299 */     GIR_RootConstrainSelectedInstOperands,
     /*  747300 */     // GIR_Coverage, 12483,
     /*  747300 */     GIR_EraseRootFromParent_Done,
     /*  747301 */   // Label 11716: @747301
     /*  747301 */   GIM_Try, /*On fail goto*//*Label 11717*/ GIMT_Encode4(747376), // Rule ID 12486 //
     /*  747306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  747317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  747320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  747323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  747326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747352 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  747355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747374 */     GIR_RootConstrainSelectedInstOperands,
     /*  747375 */     // GIR_Coverage, 12486,
     /*  747375 */     GIR_EraseRootFromParent_Done,
     /*  747376 */   // Label 11717: @747376
     /*  747376 */   GIM_Try, /*On fail goto*//*Label 11718*/ GIMT_Encode4(747451), // Rule ID 12487 //
     /*  747381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  747392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  747395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  747398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  747401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747427 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  747430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747449 */     GIR_RootConstrainSelectedInstOperands,
     /*  747450 */     // GIR_Coverage, 12487,
     /*  747450 */     GIR_EraseRootFromParent_Done,
     /*  747451 */   // Label 11718: @747451
     /*  747451 */   GIM_Try, /*On fail goto*//*Label 11719*/ GIMT_Encode4(747526), // Rule ID 12490 //
     /*  747456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  747467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  747470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  747473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  747476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747502 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  747505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747524 */     GIR_RootConstrainSelectedInstOperands,
     /*  747525 */     // GIR_Coverage, 12490,
     /*  747525 */     GIR_EraseRootFromParent_Done,
     /*  747526 */   // Label 11719: @747526
     /*  747526 */   GIM_Try, /*On fail goto*//*Label 11720*/ GIMT_Encode4(747601), // Rule ID 12491 //
     /*  747531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  747542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  747545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  747548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  747551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747577 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  747580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747599 */     GIR_RootConstrainSelectedInstOperands,
     /*  747600 */     // GIR_Coverage, 12491,
     /*  747600 */     GIR_EraseRootFromParent_Done,
     /*  747601 */   // Label 11720: @747601
     /*  747601 */   GIM_Try, /*On fail goto*//*Label 11721*/ GIMT_Encode4(747676), // Rule ID 12494 //
     /*  747606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  747617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  747620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  747623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  747626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  747655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747674 */     GIR_RootConstrainSelectedInstOperands,
     /*  747675 */     // GIR_Coverage, 12494,
     /*  747675 */     GIR_EraseRootFromParent_Done,
     /*  747676 */   // Label 11721: @747676
     /*  747676 */   GIM_Try, /*On fail goto*//*Label 11722*/ GIMT_Encode4(747751), // Rule ID 12495 //
     /*  747681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  747692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  747695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  747698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  747701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  747730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747749 */     GIR_RootConstrainSelectedInstOperands,
     /*  747750 */     // GIR_Coverage, 12495,
     /*  747750 */     GIR_EraseRootFromParent_Done,
     /*  747751 */   // Label 11722: @747751
     /*  747751 */   GIM_Try, /*On fail goto*//*Label 11723*/ GIMT_Encode4(747826), // Rule ID 12498 //
     /*  747756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  747805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747824 */     GIR_RootConstrainSelectedInstOperands,
     /*  747825 */     // GIR_Coverage, 12498,
     /*  747825 */     GIR_EraseRootFromParent_Done,
     /*  747826 */   // Label 11723: @747826
     /*  747826 */   GIM_Try, /*On fail goto*//*Label 11724*/ GIMT_Encode4(747901), // Rule ID 12499 //
     /*  747831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747877 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  747880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747899 */     GIR_RootConstrainSelectedInstOperands,
     /*  747900 */     // GIR_Coverage, 12499,
     /*  747900 */     GIR_EraseRootFromParent_Done,
     /*  747901 */   // Label 11724: @747901
     /*  747901 */   GIM_Try, /*On fail goto*//*Label 11725*/ GIMT_Encode4(747976), // Rule ID 12502 //
     /*  747906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  747917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  747920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  747923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  747926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  747955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747974 */     GIR_RootConstrainSelectedInstOperands,
     /*  747975 */     // GIR_Coverage, 12502,
     /*  747975 */     GIR_EraseRootFromParent_Done,
     /*  747976 */   // Label 11725: @747976
     /*  747976 */   GIM_Try, /*On fail goto*//*Label 11726*/ GIMT_Encode4(748051), // Rule ID 12503 //
     /*  747981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  747992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  747995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  747998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  748001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748027 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748049 */     GIR_RootConstrainSelectedInstOperands,
     /*  748050 */     // GIR_Coverage, 12503,
     /*  748050 */     GIR_EraseRootFromParent_Done,
     /*  748051 */   // Label 11726: @748051
     /*  748051 */   GIM_Try, /*On fail goto*//*Label 11727*/ GIMT_Encode4(748126), // Rule ID 12506 //
     /*  748056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  748067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  748070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  748073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  748076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748102 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  748102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748124 */     GIR_RootConstrainSelectedInstOperands,
     /*  748125 */     // GIR_Coverage, 12506,
     /*  748125 */     GIR_EraseRootFromParent_Done,
     /*  748126 */   // Label 11727: @748126
     /*  748126 */   GIM_Try, /*On fail goto*//*Label 11728*/ GIMT_Encode4(748201), // Rule ID 12507 //
     /*  748131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  748142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  748145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  748148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  748151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748177 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  748177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  748196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748199 */     GIR_RootConstrainSelectedInstOperands,
     /*  748200 */     // GIR_Coverage, 12507,
     /*  748200 */     GIR_EraseRootFromParent_Done,
     /*  748201 */   // Label 11728: @748201
     /*  748201 */   GIM_Try, /*On fail goto*//*Label 11729*/ GIMT_Encode4(748276), // Rule ID 12510 //
     /*  748206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  748217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  748220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  748223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  748226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748252 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748274 */     GIR_RootConstrainSelectedInstOperands,
     /*  748275 */     // GIR_Coverage, 12510,
     /*  748275 */     GIR_EraseRootFromParent_Done,
     /*  748276 */   // Label 11729: @748276
     /*  748276 */   GIM_Try, /*On fail goto*//*Label 11730*/ GIMT_Encode4(748351), // Rule ID 12511 //
     /*  748281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  748292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  748295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  748298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  748301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748327 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  748330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748349 */     GIR_RootConstrainSelectedInstOperands,
     /*  748350 */     // GIR_Coverage, 12511,
     /*  748350 */     GIR_EraseRootFromParent_Done,
     /*  748351 */   // Label 11730: @748351
     /*  748351 */   GIM_Try, /*On fail goto*//*Label 11731*/ GIMT_Encode4(748426), // Rule ID 12514 //
     /*  748356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  748367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  748370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  748373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  748376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748402 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748424 */     GIR_RootConstrainSelectedInstOperands,
     /*  748425 */     // GIR_Coverage, 12514,
     /*  748425 */     GIR_EraseRootFromParent_Done,
     /*  748426 */   // Label 11731: @748426
     /*  748426 */   GIM_Try, /*On fail goto*//*Label 11732*/ GIMT_Encode4(748501), // Rule ID 12515 //
     /*  748431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  748442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  748445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  748448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  748451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748477 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748499 */     GIR_RootConstrainSelectedInstOperands,
     /*  748500 */     // GIR_Coverage, 12515,
     /*  748500 */     GIR_EraseRootFromParent_Done,
     /*  748501 */   // Label 11732: @748501
     /*  748501 */   GIM_Try, /*On fail goto*//*Label 11733*/ GIMT_Encode4(748576), // Rule ID 12518 //
     /*  748506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  748517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  748520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  748523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  748526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748574 */     GIR_RootConstrainSelectedInstOperands,
     /*  748575 */     // GIR_Coverage, 12518,
     /*  748575 */     GIR_EraseRootFromParent_Done,
     /*  748576 */   // Label 11733: @748576
     /*  748576 */   GIM_Try, /*On fail goto*//*Label 11734*/ GIMT_Encode4(748651), // Rule ID 12519 //
     /*  748581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  748592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  748595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  748598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  748601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748649 */     GIR_RootConstrainSelectedInstOperands,
     /*  748650 */     // GIR_Coverage, 12519,
     /*  748650 */     GIR_EraseRootFromParent_Done,
     /*  748651 */   // Label 11734: @748651
     /*  748651 */   GIM_Try, /*On fail goto*//*Label 11735*/ GIMT_Encode4(748726), // Rule ID 12522 //
     /*  748656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748702 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748724 */     GIR_RootConstrainSelectedInstOperands,
     /*  748725 */     // GIR_Coverage, 12522,
     /*  748725 */     GIR_EraseRootFromParent_Done,
     /*  748726 */   // Label 11735: @748726
     /*  748726 */   GIM_Try, /*On fail goto*//*Label 11736*/ GIMT_Encode4(748801), // Rule ID 12523 //
     /*  748731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748777 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748799 */     GIR_RootConstrainSelectedInstOperands,
     /*  748800 */     // GIR_Coverage, 12523,
     /*  748800 */     GIR_EraseRootFromParent_Done,
     /*  748801 */   // Label 11736: @748801
     /*  748801 */   GIM_Try, /*On fail goto*//*Label 11737*/ GIMT_Encode4(748876), // Rule ID 12526 //
     /*  748806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748874 */     GIR_RootConstrainSelectedInstOperands,
     /*  748875 */     // GIR_Coverage, 12526,
     /*  748875 */     GIR_EraseRootFromParent_Done,
     /*  748876 */   // Label 11737: @748876
     /*  748876 */   GIM_Try, /*On fail goto*//*Label 11738*/ GIMT_Encode4(748951), // Rule ID 12527 //
     /*  748881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748927 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748949 */     GIR_RootConstrainSelectedInstOperands,
     /*  748950 */     // GIR_Coverage, 12527,
     /*  748950 */     GIR_EraseRootFromParent_Done,
     /*  748951 */   // Label 11738: @748951
     /*  748951 */   GIM_Try, /*On fail goto*//*Label 11739*/ GIMT_Encode4(749026), // Rule ID 12530 //
     /*  748956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  748967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  748970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  748973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  748976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  749005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749024 */     GIR_RootConstrainSelectedInstOperands,
     /*  749025 */     // GIR_Coverage, 12530,
     /*  749025 */     GIR_EraseRootFromParent_Done,
     /*  749026 */   // Label 11739: @749026
     /*  749026 */   GIM_Try, /*On fail goto*//*Label 11740*/ GIMT_Encode4(749101), // Rule ID 12531 //
     /*  749031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  749042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  749045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  749048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  749051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749077 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  749080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749099 */     GIR_RootConstrainSelectedInstOperands,
     /*  749100 */     // GIR_Coverage, 12531,
     /*  749100 */     GIR_EraseRootFromParent_Done,
     /*  749101 */   // Label 11740: @749101
     /*  749101 */   GIM_Try, /*On fail goto*//*Label 11741*/ GIMT_Encode4(749176), // Rule ID 12534 //
     /*  749106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  749117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  749120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  749123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  749126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749174 */     GIR_RootConstrainSelectedInstOperands,
     /*  749175 */     // GIR_Coverage, 12534,
     /*  749175 */     GIR_EraseRootFromParent_Done,
     /*  749176 */   // Label 11741: @749176
     /*  749176 */   GIM_Try, /*On fail goto*//*Label 11742*/ GIMT_Encode4(749251), // Rule ID 12535 //
     /*  749181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  749192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  749195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  749198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  749201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749227 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  749230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749249 */     GIR_RootConstrainSelectedInstOperands,
     /*  749250 */     // GIR_Coverage, 12535,
     /*  749250 */     GIR_EraseRootFromParent_Done,
     /*  749251 */   // Label 11742: @749251
     /*  749251 */   GIM_Try, /*On fail goto*//*Label 11743*/ GIMT_Encode4(749326), // Rule ID 12538 //
     /*  749256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  749267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  749270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  749273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  749276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749324 */     GIR_RootConstrainSelectedInstOperands,
     /*  749325 */     // GIR_Coverage, 12538,
     /*  749325 */     GIR_EraseRootFromParent_Done,
     /*  749326 */   // Label 11743: @749326
     /*  749326 */   GIM_Try, /*On fail goto*//*Label 11744*/ GIMT_Encode4(749401), // Rule ID 12539 //
     /*  749331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  749342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  749345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  749348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  749351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749377 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  749380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749399 */     GIR_RootConstrainSelectedInstOperands,
     /*  749400 */     // GIR_Coverage, 12539,
     /*  749400 */     GIR_EraseRootFromParent_Done,
     /*  749401 */   // Label 11744: @749401
     /*  749401 */   GIM_Try, /*On fail goto*//*Label 11745*/ GIMT_Encode4(749476), // Rule ID 12542 //
     /*  749406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  749409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  749417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  749420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  749423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  749426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749452 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  749452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749474 */     GIR_RootConstrainSelectedInstOperands,
     /*  749475 */     // GIR_Coverage, 12542,
     /*  749475 */     GIR_EraseRootFromParent_Done,
     /*  749476 */   // Label 11745: @749476
     /*  749476 */   GIM_Try, /*On fail goto*//*Label 11746*/ GIMT_Encode4(749551), // Rule ID 12543 //
     /*  749481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  749484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  749492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  749495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  749498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  749501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749527 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749549 */     GIR_RootConstrainSelectedInstOperands,
     /*  749550 */     // GIR_Coverage, 12543,
     /*  749550 */     GIR_EraseRootFromParent_Done,
     /*  749551 */   // Label 11746: @749551
     /*  749551 */   GIM_Try, /*On fail goto*//*Label 11747*/ GIMT_Encode4(749626), // Rule ID 12546 //
     /*  749556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  749567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  749570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  749573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749602 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  749605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749624 */     GIR_RootConstrainSelectedInstOperands,
     /*  749625 */     // GIR_Coverage, 12546,
     /*  749625 */     GIR_EraseRootFromParent_Done,
     /*  749626 */   // Label 11747: @749626
     /*  749626 */   GIM_Try, /*On fail goto*//*Label 11748*/ GIMT_Encode4(749701), // Rule ID 12547 //
     /*  749631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  749642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  749645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  749648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749677 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  749680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749699 */     GIR_RootConstrainSelectedInstOperands,
     /*  749700 */     // GIR_Coverage, 12547,
     /*  749700 */     GIR_EraseRootFromParent_Done,
     /*  749701 */   // Label 11748: @749701
     /*  749701 */   GIM_Try, /*On fail goto*//*Label 11749*/ GIMT_Encode4(749776), // Rule ID 12550 //
     /*  749706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  749755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749774 */     GIR_RootConstrainSelectedInstOperands,
     /*  749775 */     // GIR_Coverage, 12550,
     /*  749775 */     GIR_EraseRootFromParent_Done,
     /*  749776 */   // Label 11749: @749776
     /*  749776 */   GIM_Try, /*On fail goto*//*Label 11750*/ GIMT_Encode4(749851), // Rule ID 12551 //
     /*  749781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749827 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  749830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749849 */     GIR_RootConstrainSelectedInstOperands,
     /*  749850 */     // GIR_Coverage, 12551,
     /*  749850 */     GIR_EraseRootFromParent_Done,
     /*  749851 */   // Label 11750: @749851
     /*  749851 */   GIM_Try, /*On fail goto*//*Label 11751*/ GIMT_Encode4(749926), // Rule ID 12554 //
     /*  749856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  749905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749924 */     GIR_RootConstrainSelectedInstOperands,
     /*  749925 */     // GIR_Coverage, 12554,
     /*  749925 */     GIR_EraseRootFromParent_Done,
     /*  749926 */   // Label 11751: @749926
     /*  749926 */   GIM_Try, /*On fail goto*//*Label 11752*/ GIMT_Encode4(750001), // Rule ID 12555 //
     /*  749931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11659:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  749980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749999 */     GIR_RootConstrainSelectedInstOperands,
     /*  750000 */     // GIR_Coverage, 12555,
     /*  750000 */     GIR_EraseRootFromParent_Done,
     /*  750001 */   // Label 11752: @750001
     /*  750001 */   GIM_Try, /*On fail goto*//*Label 11753*/ GIMT_Encode4(750076), // Rule ID 12558 //
     /*  750006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  750017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  750020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  750023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750052 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750074 */     GIR_RootConstrainSelectedInstOperands,
     /*  750075 */     // GIR_Coverage, 12558,
     /*  750075 */     GIR_EraseRootFromParent_Done,
     /*  750076 */   // Label 11753: @750076
     /*  750076 */   GIM_Try, /*On fail goto*//*Label 11754*/ GIMT_Encode4(750151), // Rule ID 12559 //
     /*  750081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  750092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  750095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  750098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750127 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750149 */     GIR_RootConstrainSelectedInstOperands,
     /*  750150 */     // GIR_Coverage, 12559,
     /*  750150 */     GIR_EraseRootFromParent_Done,
     /*  750151 */   // Label 11754: @750151
     /*  750151 */   GIM_Try, /*On fail goto*//*Label 11755*/ GIMT_Encode4(750226), // Rule ID 12562 //
     /*  750156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  750167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  750170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  750173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750202 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750224 */     GIR_RootConstrainSelectedInstOperands,
     /*  750225 */     // GIR_Coverage, 12562,
     /*  750225 */     GIR_EraseRootFromParent_Done,
     /*  750226 */   // Label 11755: @750226
     /*  750226 */   GIM_Try, /*On fail goto*//*Label 11756*/ GIMT_Encode4(750301), // Rule ID 12563 //
     /*  750231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  750242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  750245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  750248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750277 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750299 */     GIR_RootConstrainSelectedInstOperands,
     /*  750300 */     // GIR_Coverage, 12563,
     /*  750300 */     GIR_EraseRootFromParent_Done,
     /*  750301 */   // Label 11756: @750301
     /*  750301 */   GIM_Try, /*On fail goto*//*Label 11757*/ GIMT_Encode4(750376), // Rule ID 12566 //
     /*  750306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  750317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  750320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  750323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750352 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  750352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750374 */     GIR_RootConstrainSelectedInstOperands,
     /*  750375 */     // GIR_Coverage, 12566,
     /*  750375 */     GIR_EraseRootFromParent_Done,
     /*  750376 */   // Label 11757: @750376
     /*  750376 */   GIM_Try, /*On fail goto*//*Label 11758*/ GIMT_Encode4(750451), // Rule ID 12567 //
     /*  750381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  750392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  750395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  750398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750427 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  750427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  750446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750449 */     GIR_RootConstrainSelectedInstOperands,
     /*  750450 */     // GIR_Coverage, 12567,
     /*  750450 */     GIR_EraseRootFromParent_Done,
     /*  750451 */   // Label 11758: @750451
     /*  750451 */   GIM_Try, /*On fail goto*//*Label 11759*/ GIMT_Encode4(750526), // Rule ID 12570 //
     /*  750456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  750467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  750470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  750473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750524 */     GIR_RootConstrainSelectedInstOperands,
     /*  750525 */     // GIR_Coverage, 12570,
     /*  750525 */     GIR_EraseRootFromParent_Done,
     /*  750526 */   // Label 11759: @750526
     /*  750526 */   GIM_Try, /*On fail goto*//*Label 11760*/ GIMT_Encode4(750601), // Rule ID 12571 //
     /*  750531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  750542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  750545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  750548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750577 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750599 */     GIR_RootConstrainSelectedInstOperands,
     /*  750600 */     // GIR_Coverage, 12571,
     /*  750600 */     GIR_EraseRootFromParent_Done,
     /*  750601 */   // Label 11760: @750601
     /*  750601 */   GIM_Try, /*On fail goto*//*Label 11761*/ GIMT_Encode4(750676), // Rule ID 12574 //
     /*  750606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  750617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  750620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  750623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750674 */     GIR_RootConstrainSelectedInstOperands,
     /*  750675 */     // GIR_Coverage, 12574,
     /*  750675 */     GIR_EraseRootFromParent_Done,
     /*  750676 */   // Label 11761: @750676
     /*  750676 */   GIM_Try, /*On fail goto*//*Label 11762*/ GIMT_Encode4(750751), // Rule ID 12575 //
     /*  750681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  750692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  750695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  750698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750727 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11659:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750749 */     GIR_RootConstrainSelectedInstOperands,
     /*  750750 */     // GIR_Coverage, 12575,
     /*  750750 */     GIR_EraseRootFromParent_Done,
     /*  750751 */   // Label 11762: @750751
     /*  750751 */   GIM_Try, /*On fail goto*//*Label 11763*/ GIMT_Encode4(750826), // Rule ID 12578 //
     /*  750756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750824 */     GIR_RootConstrainSelectedInstOperands,
     /*  750825 */     // GIR_Coverage, 12578,
     /*  750825 */     GIR_EraseRootFromParent_Done,
     /*  750826 */   // Label 11763: @750826
     /*  750826 */   GIM_Try, /*On fail goto*//*Label 11764*/ GIMT_Encode4(750901), // Rule ID 12579 //
     /*  750831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750899 */     GIR_RootConstrainSelectedInstOperands,
     /*  750900 */     // GIR_Coverage, 12579,
     /*  750900 */     GIR_EraseRootFromParent_Done,
     /*  750901 */   // Label 11764: @750901
     /*  750901 */   GIM_Try, /*On fail goto*//*Label 11765*/ GIMT_Encode4(750976), // Rule ID 12582 //
     /*  750906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  750917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  750920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  750923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750974 */     GIR_RootConstrainSelectedInstOperands,
     /*  750975 */     // GIR_Coverage, 12582,
     /*  750975 */     GIR_EraseRootFromParent_Done,
     /*  750976 */   // Label 11765: @750976
     /*  750976 */   GIM_Try, /*On fail goto*//*Label 11766*/ GIMT_Encode4(751051), // Rule ID 12583 //
     /*  750981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  750992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  750995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  750998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751027 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751049 */     GIR_RootConstrainSelectedInstOperands,
     /*  751050 */     // GIR_Coverage, 12583,
     /*  751050 */     GIR_EraseRootFromParent_Done,
     /*  751051 */   // Label 11766: @751051
     /*  751051 */   GIM_Try, /*On fail goto*//*Label 11767*/ GIMT_Encode4(751126), // Rule ID 12586 //
     /*  751056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  751067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  751070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  751073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  751102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751124 */     GIR_RootConstrainSelectedInstOperands,
     /*  751125 */     // GIR_Coverage, 12586,
     /*  751125 */     GIR_EraseRootFromParent_Done,
     /*  751126 */   // Label 11767: @751126
     /*  751126 */   GIM_Try, /*On fail goto*//*Label 11768*/ GIMT_Encode4(751201), // Rule ID 12587 //
     /*  751131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  751142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  751145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  751148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751177 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  751177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  751196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751199 */     GIR_RootConstrainSelectedInstOperands,
     /*  751200 */     // GIR_Coverage, 12587,
     /*  751200 */     GIR_EraseRootFromParent_Done,
     /*  751201 */   // Label 11768: @751201
     /*  751201 */   GIM_Try, /*On fail goto*//*Label 11769*/ GIMT_Encode4(751276), // Rule ID 12590 //
     /*  751206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  751217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  751220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751274 */     GIR_RootConstrainSelectedInstOperands,
     /*  751275 */     // GIR_Coverage, 12590,
     /*  751275 */     GIR_EraseRootFromParent_Done,
     /*  751276 */   // Label 11769: @751276
     /*  751276 */   GIM_Try, /*On fail goto*//*Label 11770*/ GIMT_Encode4(751351), // Rule ID 12591 //
     /*  751281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  751292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  751295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  751298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751327 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11659:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  751330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751349 */     GIR_RootConstrainSelectedInstOperands,
     /*  751350 */     // GIR_Coverage, 12591,
     /*  751350 */     GIR_EraseRootFromParent_Done,
     /*  751351 */   // Label 11770: @751351
     /*  751351 */   GIM_Try, /*On fail goto*//*Label 11771*/ GIMT_Encode4(751426), // Rule ID 12594 //
     /*  751356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  751367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  751370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  751373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751424 */     GIR_RootConstrainSelectedInstOperands,
     /*  751425 */     // GIR_Coverage, 12594,
     /*  751425 */     GIR_EraseRootFromParent_Done,
     /*  751426 */   // Label 11771: @751426
     /*  751426 */   GIM_Try, /*On fail goto*//*Label 11772*/ GIMT_Encode4(751501), // Rule ID 12595 //
     /*  751431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  751442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  751445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  751448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751477 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11659:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  751480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751499 */     GIR_RootConstrainSelectedInstOperands,
     /*  751500 */     // GIR_Coverage, 12595,
     /*  751500 */     GIR_EraseRootFromParent_Done,
     /*  751501 */   // Label 11772: @751501
     /*  751501 */   GIM_Try, /*On fail goto*//*Label 11773*/ GIMT_Encode4(751576), // Rule ID 12598 //
     /*  751506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  751517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  751520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  751523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751552 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751574 */     GIR_RootConstrainSelectedInstOperands,
     /*  751575 */     // GIR_Coverage, 12598,
     /*  751575 */     GIR_EraseRootFromParent_Done,
     /*  751576 */   // Label 11773: @751576
     /*  751576 */   GIM_Try, /*On fail goto*//*Label 11774*/ GIMT_Encode4(751651), // Rule ID 12599 //
     /*  751581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  751592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  751595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  751598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751627 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11659:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751649 */     GIR_RootConstrainSelectedInstOperands,
     /*  751650 */     // GIR_Coverage, 12599,
     /*  751650 */     GIR_EraseRootFromParent_Done,
     /*  751651 */   // Label 11774: @751651
     /*  751651 */   GIM_Try, /*On fail goto*//*Label 11775*/ GIMT_Encode4(751726), // Rule ID 12602 //
     /*  751656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751724 */     GIR_RootConstrainSelectedInstOperands,
     /*  751725 */     // GIR_Coverage, 12602,
     /*  751725 */     GIR_EraseRootFromParent_Done,
     /*  751726 */   // Label 11775: @751726
     /*  751726 */   GIM_Try, /*On fail goto*//*Label 11776*/ GIMT_Encode4(751801), // Rule ID 12603 //
     /*  751731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751777 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11659:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751799 */     GIR_RootConstrainSelectedInstOperands,
     /*  751800 */     // GIR_Coverage, 12603,
     /*  751800 */     GIR_EraseRootFromParent_Done,
     /*  751801 */   // Label 11776: @751801
     /*  751801 */   GIM_Try, /*On fail goto*//*Label 11777*/ GIMT_Encode4(751876), // Rule ID 12606 //
     /*  751806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751852 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  751855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751874 */     GIR_RootConstrainSelectedInstOperands,
     /*  751875 */     // GIR_Coverage, 12606,
     /*  751875 */     GIR_EraseRootFromParent_Done,
     /*  751876 */   // Label 11777: @751876
     /*  751876 */   GIM_Try, /*On fail goto*//*Label 11778*/ GIMT_Encode4(751951), // Rule ID 12607 //
     /*  751881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751927 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  751930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751949 */     GIR_RootConstrainSelectedInstOperands,
     /*  751950 */     // GIR_Coverage, 12607,
     /*  751950 */     GIR_EraseRootFromParent_Done,
     /*  751951 */   // Label 11778: @751951
     /*  751951 */   GIM_Try, /*On fail goto*//*Label 11779*/ GIMT_Encode4(752026), // Rule ID 12610 //
     /*  751956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  751976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752002 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752024 */     GIR_RootConstrainSelectedInstOperands,
     /*  752025 */     // GIR_Coverage, 12610,
     /*  752025 */     GIR_EraseRootFromParent_Done,
     /*  752026 */   // Label 11779: @752026
     /*  752026 */   GIM_Try, /*On fail goto*//*Label 11780*/ GIMT_Encode4(752101), // Rule ID 12611 //
     /*  752031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  752042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  752045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  752048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  752051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752077 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752099 */     GIR_RootConstrainSelectedInstOperands,
     /*  752100 */     // GIR_Coverage, 12611,
     /*  752100 */     GIR_EraseRootFromParent_Done,
     /*  752101 */   // Label 11780: @752101
     /*  752101 */   GIM_Try, /*On fail goto*//*Label 11781*/ GIMT_Encode4(752176), // Rule ID 12614 //
     /*  752106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  752123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  752126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752174 */     GIR_RootConstrainSelectedInstOperands,
     /*  752175 */     // GIR_Coverage, 12614,
     /*  752175 */     GIR_EraseRootFromParent_Done,
     /*  752176 */   // Label 11781: @752176
     /*  752176 */   GIM_Try, /*On fail goto*//*Label 11782*/ GIMT_Encode4(752251), // Rule ID 12615 //
     /*  752181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  752192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  752195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  752198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  752201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752249 */     GIR_RootConstrainSelectedInstOperands,
     /*  752250 */     // GIR_Coverage, 12615,
     /*  752250 */     GIR_EraseRootFromParent_Done,
     /*  752251 */   // Label 11782: @752251
     /*  752251 */   GIM_Try, /*On fail goto*//*Label 11783*/ GIMT_Encode4(752326), // Rule ID 12618 //
     /*  752256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  752267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  752270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  752273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  752276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752324 */     GIR_RootConstrainSelectedInstOperands,
     /*  752325 */     // GIR_Coverage, 12618,
     /*  752325 */     GIR_EraseRootFromParent_Done,
     /*  752326 */   // Label 11783: @752326
     /*  752326 */   GIM_Try, /*On fail goto*//*Label 11784*/ GIMT_Encode4(752401), // Rule ID 12619 //
     /*  752331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  752342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  752345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  752348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  752351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752377 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752399 */     GIR_RootConstrainSelectedInstOperands,
     /*  752400 */     // GIR_Coverage, 12619,
     /*  752400 */     GIR_EraseRootFromParent_Done,
     /*  752401 */   // Label 11784: @752401
     /*  752401 */   GIM_Try, /*On fail goto*//*Label 11785*/ GIMT_Encode4(752476), // Rule ID 12622 //
     /*  752406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  752417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  752420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  752426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752474 */     GIR_RootConstrainSelectedInstOperands,
     /*  752475 */     // GIR_Coverage, 12622,
     /*  752475 */     GIR_EraseRootFromParent_Done,
     /*  752476 */   // Label 11785: @752476
     /*  752476 */   GIM_Try, /*On fail goto*//*Label 11786*/ GIMT_Encode4(752551), // Rule ID 12623 //
     /*  752481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  752492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  752495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  752498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  752501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752527 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752549 */     GIR_RootConstrainSelectedInstOperands,
     /*  752550 */     // GIR_Coverage, 12623,
     /*  752550 */     GIR_EraseRootFromParent_Done,
     /*  752551 */   // Label 11786: @752551
     /*  752551 */   GIM_Try, /*On fail goto*//*Label 11787*/ GIMT_Encode4(752626), // Rule ID 12626 //
     /*  752556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  752567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  752570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  752573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  752576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752602 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  752605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752624 */     GIR_RootConstrainSelectedInstOperands,
     /*  752625 */     // GIR_Coverage, 12626,
     /*  752625 */     GIR_EraseRootFromParent_Done,
     /*  752626 */   // Label 11787: @752626
     /*  752626 */   GIM_Try, /*On fail goto*//*Label 11788*/ GIMT_Encode4(752701), // Rule ID 12627 //
     /*  752631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  752642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  752645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  752648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  752651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752677 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  752680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752699 */     GIR_RootConstrainSelectedInstOperands,
     /*  752700 */     // GIR_Coverage, 12627,
     /*  752700 */     GIR_EraseRootFromParent_Done,
     /*  752701 */   // Label 11788: @752701
     /*  752701 */   GIM_Try, /*On fail goto*//*Label 11789*/ GIMT_Encode4(752776), // Rule ID 12630 //
     /*  752706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752774 */     GIR_RootConstrainSelectedInstOperands,
     /*  752775 */     // GIR_Coverage, 12630,
     /*  752775 */     GIR_EraseRootFromParent_Done,
     /*  752776 */   // Label 11789: @752776
     /*  752776 */   GIM_Try, /*On fail goto*//*Label 11790*/ GIMT_Encode4(752851), // Rule ID 12631 //
     /*  752781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752827 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752849 */     GIR_RootConstrainSelectedInstOperands,
     /*  752850 */     // GIR_Coverage, 12631,
     /*  752850 */     GIR_EraseRootFromParent_Done,
     /*  752851 */   // Label 11790: @752851
     /*  752851 */   GIM_Try, /*On fail goto*//*Label 11791*/ GIMT_Encode4(752926), // Rule ID 12634 //
     /*  752856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752924 */     GIR_RootConstrainSelectedInstOperands,
     /*  752925 */     // GIR_Coverage, 12634,
     /*  752925 */     GIR_EraseRootFromParent_Done,
     /*  752926 */   // Label 11791: @752926
     /*  752926 */   GIM_Try, /*On fail goto*//*Label 11792*/ GIMT_Encode4(753001), // Rule ID 12635 //
     /*  752931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752977 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752999 */     GIR_RootConstrainSelectedInstOperands,
     /*  753000 */     // GIR_Coverage, 12635,
     /*  753000 */     GIR_EraseRootFromParent_Done,
     /*  753001 */   // Label 11792: @753001
     /*  753001 */   GIM_Try, /*On fail goto*//*Label 11793*/ GIMT_Encode4(753076), // Rule ID 12638 //
     /*  753006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  753023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  753026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753074 */     GIR_RootConstrainSelectedInstOperands,
     /*  753075 */     // GIR_Coverage, 12638,
     /*  753075 */     GIR_EraseRootFromParent_Done,
     /*  753076 */   // Label 11793: @753076
     /*  753076 */   GIM_Try, /*On fail goto*//*Label 11794*/ GIMT_Encode4(753151), // Rule ID 12639 //
     /*  753081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  753092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  753095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  753098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  753101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753149 */     GIR_RootConstrainSelectedInstOperands,
     /*  753150 */     // GIR_Coverage, 12639,
     /*  753150 */     GIR_EraseRootFromParent_Done,
     /*  753151 */   // Label 11794: @753151
     /*  753151 */   GIM_Try, /*On fail goto*//*Label 11795*/ GIMT_Encode4(753226), // Rule ID 12642 //
     /*  753156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  753173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  753176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753202 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753224 */     GIR_RootConstrainSelectedInstOperands,
     /*  753225 */     // GIR_Coverage, 12642,
     /*  753225 */     GIR_EraseRootFromParent_Done,
     /*  753226 */   // Label 11795: @753226
     /*  753226 */   GIM_Try, /*On fail goto*//*Label 11796*/ GIMT_Encode4(753301), // Rule ID 12643 //
     /*  753231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  753242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  753245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  753248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  753251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753277 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753299 */     GIR_RootConstrainSelectedInstOperands,
     /*  753300 */     // GIR_Coverage, 12643,
     /*  753300 */     GIR_EraseRootFromParent_Done,
     /*  753301 */   // Label 11796: @753301
     /*  753301 */   GIM_Try, /*On fail goto*//*Label 11797*/ GIMT_Encode4(753376), // Rule ID 12646 //
     /*  753306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  753326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  753352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753374 */     GIR_RootConstrainSelectedInstOperands,
     /*  753375 */     // GIR_Coverage, 12646,
     /*  753375 */     GIR_EraseRootFromParent_Done,
     /*  753376 */   // Label 11797: @753376
     /*  753376 */   GIM_Try, /*On fail goto*//*Label 11798*/ GIMT_Encode4(753451), // Rule ID 12647 //
     /*  753381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  753392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  753395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  753398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  753401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753427 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  753427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  753446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753449 */     GIR_RootConstrainSelectedInstOperands,
     /*  753450 */     // GIR_Coverage, 12647,
     /*  753450 */     GIR_EraseRootFromParent_Done,
     /*  753451 */   // Label 11798: @753451
     /*  753451 */   GIM_Try, /*On fail goto*//*Label 11799*/ GIMT_Encode4(753526), // Rule ID 12650 //
     /*  753456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  753467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  753470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  753473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  753476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753524 */     GIR_RootConstrainSelectedInstOperands,
     /*  753525 */     // GIR_Coverage, 12650,
     /*  753525 */     GIR_EraseRootFromParent_Done,
     /*  753526 */   // Label 11799: @753526
     /*  753526 */   GIM_Try, /*On fail goto*//*Label 11800*/ GIMT_Encode4(753601), // Rule ID 12651 //
     /*  753531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  753542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  753545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  753548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  753551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753599 */     GIR_RootConstrainSelectedInstOperands,
     /*  753600 */     // GIR_Coverage, 12651,
     /*  753600 */     GIR_EraseRootFromParent_Done,
     /*  753601 */   // Label 11800: @753601
     /*  753601 */   GIM_Try, /*On fail goto*//*Label 11801*/ GIMT_Encode4(753676), // Rule ID 12654 //
     /*  753606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  753623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  753626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753674 */     GIR_RootConstrainSelectedInstOperands,
     /*  753675 */     // GIR_Coverage, 12654,
     /*  753675 */     GIR_EraseRootFromParent_Done,
     /*  753676 */   // Label 11801: @753676
     /*  753676 */   GIM_Try, /*On fail goto*//*Label 11802*/ GIMT_Encode4(753751), // Rule ID 12655 //
     /*  753681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  753698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  753701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753727 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753749 */     GIR_RootConstrainSelectedInstOperands,
     /*  753750 */     // GIR_Coverage, 12655,
     /*  753750 */     GIR_EraseRootFromParent_Done,
     /*  753751 */   // Label 11802: @753751
     /*  753751 */   GIM_Try, /*On fail goto*//*Label 11803*/ GIMT_Encode4(753826), // Rule ID 12658 //
     /*  753756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753824 */     GIR_RootConstrainSelectedInstOperands,
     /*  753825 */     // GIR_Coverage, 12658,
     /*  753825 */     GIR_EraseRootFromParent_Done,
     /*  753826 */   // Label 11803: @753826
     /*  753826 */   GIM_Try, /*On fail goto*//*Label 11804*/ GIMT_Encode4(753901), // Rule ID 12659 //
     /*  753831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753877 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753899 */     GIR_RootConstrainSelectedInstOperands,
     /*  753900 */     // GIR_Coverage, 12659,
     /*  753900 */     GIR_EraseRootFromParent_Done,
     /*  753901 */   // Label 11804: @753901
     /*  753901 */   GIM_Try, /*On fail goto*//*Label 11805*/ GIMT_Encode4(753976), // Rule ID 12662 //
     /*  753906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  753917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  753920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  753926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753952 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753974 */     GIR_RootConstrainSelectedInstOperands,
     /*  753975 */     // GIR_Coverage, 12662,
     /*  753975 */     GIR_EraseRootFromParent_Done,
     /*  753976 */   // Label 11805: @753976
     /*  753976 */   GIM_Try, /*On fail goto*//*Label 11806*/ GIMT_Encode4(754051), // Rule ID 12663 //
     /*  753981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  753992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  753995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  754001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754027 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  754027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  754030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  754046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754049 */     GIR_RootConstrainSelectedInstOperands,
     /*  754050 */     // GIR_Coverage, 12663,
     /*  754050 */     GIR_EraseRootFromParent_Done,
     /*  754051 */   // Label 11806: @754051
     /*  754051 */   GIM_Try, /*On fail goto*//*Label 11807*/ GIMT_Encode4(754126), // Rule ID 12666 //
     /*  754056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  754105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754124 */     GIR_RootConstrainSelectedInstOperands,
     /*  754125 */     // GIR_Coverage, 12666,
     /*  754125 */     GIR_EraseRootFromParent_Done,
     /*  754126 */   // Label 11807: @754126
     /*  754126 */   GIM_Try, /*On fail goto*//*Label 11808*/ GIMT_Encode4(754201), // Rule ID 12667 //
     /*  754131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  754142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  754145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  754148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  754180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754199 */     GIR_RootConstrainSelectedInstOperands,
     /*  754200 */     // GIR_Coverage, 12667,
     /*  754200 */     GIR_EraseRootFromParent_Done,
     /*  754201 */   // Label 11808: @754201
     /*  754201 */   GIM_Try, /*On fail goto*//*Label 11809*/ GIMT_Encode4(754276), // Rule ID 12670 //
     /*  754206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  754217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  754220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754274 */     GIR_RootConstrainSelectedInstOperands,
     /*  754275 */     // GIR_Coverage, 12670,
     /*  754275 */     GIR_EraseRootFromParent_Done,
     /*  754276 */   // Label 11809: @754276
     /*  754276 */   GIM_Try, /*On fail goto*//*Label 11810*/ GIMT_Encode4(754351), // Rule ID 12671 //
     /*  754281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  754292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  754295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  754298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754349 */     GIR_RootConstrainSelectedInstOperands,
     /*  754350 */     // GIR_Coverage, 12671,
     /*  754350 */     GIR_EraseRootFromParent_Done,
     /*  754351 */   // Label 11810: @754351
     /*  754351 */   GIM_Try, /*On fail goto*//*Label 11811*/ GIMT_Encode4(754426), // Rule ID 12674 //
     /*  754356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  754367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  754370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754424 */     GIR_RootConstrainSelectedInstOperands,
     /*  754425 */     // GIR_Coverage, 12674,
     /*  754425 */     GIR_EraseRootFromParent_Done,
     /*  754426 */   // Label 11811: @754426
     /*  754426 */   GIM_Try, /*On fail goto*//*Label 11812*/ GIMT_Encode4(754501), // Rule ID 12675 //
     /*  754431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  754442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  754445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  754448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754477 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11657:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754499 */     GIR_RootConstrainSelectedInstOperands,
     /*  754500 */     // GIR_Coverage, 12675,
     /*  754500 */     GIR_EraseRootFromParent_Done,
     /*  754501 */   // Label 11812: @754501
     /*  754501 */   GIM_Try, /*On fail goto*//*Label 11813*/ GIMT_Encode4(754576), // Rule ID 12678 //
     /*  754506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  754517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  754520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  754523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  754555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754574 */     GIR_RootConstrainSelectedInstOperands,
     /*  754575 */     // GIR_Coverage, 12678,
     /*  754575 */     GIR_EraseRootFromParent_Done,
     /*  754576 */   // Label 11813: @754576
     /*  754576 */   GIM_Try, /*On fail goto*//*Label 11814*/ GIMT_Encode4(754651), // Rule ID 12679 //
     /*  754581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  754592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  754595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  754598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  754630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754649 */     GIR_RootConstrainSelectedInstOperands,
     /*  754650 */     // GIR_Coverage, 12679,
     /*  754650 */     GIR_EraseRootFromParent_Done,
     /*  754651 */   // Label 11814: @754651
     /*  754651 */   GIM_Try, /*On fail goto*//*Label 11815*/ GIMT_Encode4(754726), // Rule ID 12682 //
     /*  754656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  754705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754724 */     GIR_RootConstrainSelectedInstOperands,
     /*  754725 */     // GIR_Coverage, 12682,
     /*  754725 */     GIR_EraseRootFromParent_Done,
     /*  754726 */   // Label 11815: @754726
     /*  754726 */   GIM_Try, /*On fail goto*//*Label 11816*/ GIMT_Encode4(754801), // Rule ID 12683 //
     /*  754731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754777 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  754780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754799 */     GIR_RootConstrainSelectedInstOperands,
     /*  754800 */     // GIR_Coverage, 12683,
     /*  754800 */     GIR_EraseRootFromParent_Done,
     /*  754801 */   // Label 11816: @754801
     /*  754801 */   GIM_Try, /*On fail goto*//*Label 11817*/ GIMT_Encode4(754876), // Rule ID 12686 //
     /*  754806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  754855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754874 */     GIR_RootConstrainSelectedInstOperands,
     /*  754875 */     // GIR_Coverage, 12686,
     /*  754875 */     GIR_EraseRootFromParent_Done,
     /*  754876 */   // Label 11817: @754876
     /*  754876 */   GIM_Try, /*On fail goto*//*Label 11818*/ GIMT_Encode4(754951), // Rule ID 12687 //
     /*  754881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754927 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  754930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754949 */     GIR_RootConstrainSelectedInstOperands,
     /*  754950 */     // GIR_Coverage, 12687,
     /*  754950 */     GIR_EraseRootFromParent_Done,
     /*  754951 */   // Label 11818: @754951
     /*  754951 */   GIM_Try, /*On fail goto*//*Label 11819*/ GIMT_Encode4(755026), // Rule ID 12690 //
     /*  754956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  754967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  754970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755002 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  755005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755024 */     GIR_RootConstrainSelectedInstOperands,
     /*  755025 */     // GIR_Coverage, 12690,
     /*  755025 */     GIR_EraseRootFromParent_Done,
     /*  755026 */   // Label 11819: @755026
     /*  755026 */   GIM_Try, /*On fail goto*//*Label 11820*/ GIMT_Encode4(755101), // Rule ID 12691 //
     /*  755031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  755042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  755045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  755048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755077 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  755080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755099 */     GIR_RootConstrainSelectedInstOperands,
     /*  755100 */     // GIR_Coverage, 12691,
     /*  755100 */     GIR_EraseRootFromParent_Done,
     /*  755101 */   // Label 11820: @755101
     /*  755101 */   GIM_Try, /*On fail goto*//*Label 11821*/ GIMT_Encode4(755176), // Rule ID 12694 //
     /*  755106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  755123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755174 */     GIR_RootConstrainSelectedInstOperands,
     /*  755175 */     // GIR_Coverage, 12694,
     /*  755175 */     GIR_EraseRootFromParent_Done,
     /*  755176 */   // Label 11821: @755176
     /*  755176 */   GIM_Try, /*On fail goto*//*Label 11822*/ GIMT_Encode4(755251), // Rule ID 12695 //
     /*  755181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  755192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  755195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  755198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11657:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755249 */     GIR_RootConstrainSelectedInstOperands,
     /*  755250 */     // GIR_Coverage, 12695,
     /*  755250 */     GIR_EraseRootFromParent_Done,
     /*  755251 */   // Label 11822: @755251
     /*  755251 */   GIM_Try, /*On fail goto*//*Label 11823*/ GIMT_Encode4(755326), // Rule ID 12698 //
     /*  755256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  755267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  755270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755302 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755324 */     GIR_RootConstrainSelectedInstOperands,
     /*  755325 */     // GIR_Coverage, 12698,
     /*  755325 */     GIR_EraseRootFromParent_Done,
     /*  755326 */   // Label 11823: @755326
     /*  755326 */   GIM_Try, /*On fail goto*//*Label 11824*/ GIMT_Encode4(755401), // Rule ID 12699 //
     /*  755331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  755342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  755345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  755348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755377 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755399 */     GIR_RootConstrainSelectedInstOperands,
     /*  755400 */     // GIR_Coverage, 12699,
     /*  755400 */     GIR_EraseRootFromParent_Done,
     /*  755401 */   // Label 11824: @755401
     /*  755401 */   GIM_Try, /*On fail goto*//*Label 11825*/ GIMT_Encode4(755476), // Rule ID 12702 //
     /*  755406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  755417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  755420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  755423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755474 */     GIR_RootConstrainSelectedInstOperands,
     /*  755475 */     // GIR_Coverage, 12702,
     /*  755475 */     GIR_EraseRootFromParent_Done,
     /*  755476 */   // Label 11825: @755476
     /*  755476 */   GIM_Try, /*On fail goto*//*Label 11826*/ GIMT_Encode4(755551), // Rule ID 12703 //
     /*  755481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  755492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  755495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  755498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755527 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755549 */     GIR_RootConstrainSelectedInstOperands,
     /*  755550 */     // GIR_Coverage, 12703,
     /*  755550 */     GIR_EraseRootFromParent_Done,
     /*  755551 */   // Label 11826: @755551
     /*  755551 */   GIM_Try, /*On fail goto*//*Label 11827*/ GIMT_Encode4(755626), // Rule ID 12706 //
     /*  755556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  755567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  755570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  755573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755624 */     GIR_RootConstrainSelectedInstOperands,
     /*  755625 */     // GIR_Coverage, 12706,
     /*  755625 */     GIR_EraseRootFromParent_Done,
     /*  755626 */   // Label 11827: @755626
     /*  755626 */   GIM_Try, /*On fail goto*//*Label 11828*/ GIMT_Encode4(755701), // Rule ID 12707 //
     /*  755631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  755642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  755645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  755648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755677 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755699 */     GIR_RootConstrainSelectedInstOperands,
     /*  755700 */     // GIR_Coverage, 12707,
     /*  755700 */     GIR_EraseRootFromParent_Done,
     /*  755701 */   // Label 11828: @755701
     /*  755701 */   GIM_Try, /*On fail goto*//*Label 11829*/ GIMT_Encode4(755776), // Rule ID 12710 //
     /*  755706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755774 */     GIR_RootConstrainSelectedInstOperands,
     /*  755775 */     // GIR_Coverage, 12710,
     /*  755775 */     GIR_EraseRootFromParent_Done,
     /*  755776 */   // Label 11829: @755776
     /*  755776 */   GIM_Try, /*On fail goto*//*Label 11830*/ GIMT_Encode4(755851), // Rule ID 12711 //
     /*  755781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755827 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11657:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755849 */     GIR_RootConstrainSelectedInstOperands,
     /*  755850 */     // GIR_Coverage, 12711,
     /*  755850 */     GIR_EraseRootFromParent_Done,
     /*  755851 */   // Label 11830: @755851
     /*  755851 */   GIM_Try, /*On fail goto*//*Label 11831*/ GIMT_Encode4(755926), // Rule ID 12714 //
     /*  755856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755924 */     GIR_RootConstrainSelectedInstOperands,
     /*  755925 */     // GIR_Coverage, 12714,
     /*  755925 */     GIR_EraseRootFromParent_Done,
     /*  755926 */   // Label 11831: @755926
     /*  755926 */   GIM_Try, /*On fail goto*//*Label 11832*/ GIMT_Encode4(756001), // Rule ID 12715 //
     /*  755931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11657:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755999 */     GIR_RootConstrainSelectedInstOperands,
     /*  756000 */     // GIR_Coverage, 12715,
     /*  756000 */     GIR_EraseRootFromParent_Done,
     /*  756001 */   // Label 11832: @756001
     /*  756001 */   GIM_Try, /*On fail goto*//*Label 11833*/ GIMT_Encode4(756076), // Rule ID 12718 //
     /*  756006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  756017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  756020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  756055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756074 */     GIR_RootConstrainSelectedInstOperands,
     /*  756075 */     // GIR_Coverage, 12718,
     /*  756075 */     GIR_EraseRootFromParent_Done,
     /*  756076 */   // Label 11833: @756076
     /*  756076 */   GIM_Try, /*On fail goto*//*Label 11834*/ GIMT_Encode4(756151), // Rule ID 12719 //
     /*  756081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  756092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  756095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  756098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  756116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756127 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11657:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  756130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756149 */     GIR_RootConstrainSelectedInstOperands,
     /*  756150 */     // GIR_Coverage, 12719,
     /*  756150 */     GIR_EraseRootFromParent_Done,
     /*  756151 */   // Label 11834: @756151
     /*  756151 */   GIM_Try, /*On fail goto*//*Label 11835*/ GIMT_Encode4(756226), // Rule ID 12722 //
     /*  756156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  756159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  756167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  756170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  756176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756224 */     GIR_RootConstrainSelectedInstOperands,
     /*  756225 */     // GIR_Coverage, 12722,
     /*  756225 */     GIR_EraseRootFromParent_Done,
     /*  756226 */   // Label 11835: @756226
     /*  756226 */   GIM_Try, /*On fail goto*//*Label 11836*/ GIMT_Encode4(756301), // Rule ID 12723 //
     /*  756231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  756234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  756239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  756242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  756245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  756248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  756251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  756262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  756266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  756270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756277 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11657:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  756280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756299 */     GIR_RootConstrainSelectedInstOperands,
     /*  756300 */     // GIR_Coverage, 12723,
     /*  756300 */     GIR_EraseRootFromParent_Done,
     /*  756301 */   // Label 11836: @756301
     /*  756301 */   GIM_Try, /*On fail goto*//*Label 11837*/ GIMT_Encode4(756379), // Rule ID 14052 //
     /*  756306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  756317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  756320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  756323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  756326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  756355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756377 */     GIR_RootConstrainSelectedInstOperands,
     /*  756378 */     // GIR_Coverage, 14052,
     /*  756378 */     GIR_EraseRootFromParent_Done,
     /*  756379 */   // Label 11837: @756379
     /*  756379 */   GIM_Try, /*On fail goto*//*Label 11838*/ GIMT_Encode4(756457), // Rule ID 14053 //
     /*  756384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  756395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  756398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  756401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  756404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756430 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  756433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756455 */     GIR_RootConstrainSelectedInstOperands,
     /*  756456 */     // GIR_Coverage, 14053,
     /*  756456 */     GIR_EraseRootFromParent_Done,
     /*  756457 */   // Label 11838: @756457
     /*  756457 */   GIM_Try, /*On fail goto*//*Label 11839*/ GIMT_Encode4(756535), // Rule ID 14056 //
     /*  756462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  756473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  756476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  756479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  756482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756508 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756533 */     GIR_RootConstrainSelectedInstOperands,
     /*  756534 */     // GIR_Coverage, 14056,
     /*  756534 */     GIR_EraseRootFromParent_Done,
     /*  756535 */   // Label 11839: @756535
     /*  756535 */   GIM_Try, /*On fail goto*//*Label 11840*/ GIMT_Encode4(756613), // Rule ID 14057 //
     /*  756540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  756551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  756554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  756557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  756560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756586 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756611 */     GIR_RootConstrainSelectedInstOperands,
     /*  756612 */     // GIR_Coverage, 14057,
     /*  756612 */     GIR_EraseRootFromParent_Done,
     /*  756613 */   // Label 11840: @756613
     /*  756613 */   GIM_Try, /*On fail goto*//*Label 11841*/ GIMT_Encode4(756691), // Rule ID 14060 //
     /*  756618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  756629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  756632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  756635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  756638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756664 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756689 */     GIR_RootConstrainSelectedInstOperands,
     /*  756690 */     // GIR_Coverage, 14060,
     /*  756690 */     GIR_EraseRootFromParent_Done,
     /*  756691 */   // Label 11841: @756691
     /*  756691 */   GIM_Try, /*On fail goto*//*Label 11842*/ GIMT_Encode4(756769), // Rule ID 14061 //
     /*  756696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  756707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  756710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  756713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  756716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756742 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756767 */     GIR_RootConstrainSelectedInstOperands,
     /*  756768 */     // GIR_Coverage, 14061,
     /*  756768 */     GIR_EraseRootFromParent_Done,
     /*  756769 */   // Label 11842: @756769
     /*  756769 */   GIM_Try, /*On fail goto*//*Label 11843*/ GIMT_Encode4(756847), // Rule ID 14064 //
     /*  756774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  756785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  756788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756845 */     GIR_RootConstrainSelectedInstOperands,
     /*  756846 */     // GIR_Coverage, 14064,
     /*  756846 */     GIR_EraseRootFromParent_Done,
     /*  756847 */   // Label 11843: @756847
     /*  756847 */   GIM_Try, /*On fail goto*//*Label 11844*/ GIMT_Encode4(756925), // Rule ID 14065 //
     /*  756852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  756863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  756866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756923 */     GIR_RootConstrainSelectedInstOperands,
     /*  756924 */     // GIR_Coverage, 14065,
     /*  756924 */     GIR_EraseRootFromParent_Done,
     /*  756925 */   // Label 11844: @756925
     /*  756925 */   GIM_Try, /*On fail goto*//*Label 11845*/ GIMT_Encode4(757003), // Rule ID 14068 //
     /*  756930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  756941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  756944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  756947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  756950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756976 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757001 */     GIR_RootConstrainSelectedInstOperands,
     /*  757002 */     // GIR_Coverage, 14068,
     /*  757002 */     GIR_EraseRootFromParent_Done,
     /*  757003 */   // Label 11845: @757003
     /*  757003 */   GIM_Try, /*On fail goto*//*Label 11846*/ GIMT_Encode4(757081), // Rule ID 14069 //
     /*  757008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  757019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  757022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  757025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  757028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757054 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757079 */     GIR_RootConstrainSelectedInstOperands,
     /*  757080 */     // GIR_Coverage, 14069,
     /*  757080 */     GIR_EraseRootFromParent_Done,
     /*  757081 */   // Label 11846: @757081
     /*  757081 */   GIM_Try, /*On fail goto*//*Label 11847*/ GIMT_Encode4(757159), // Rule ID 14072 //
     /*  757086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  757097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  757100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757157 */     GIR_RootConstrainSelectedInstOperands,
     /*  757158 */     // GIR_Coverage, 14072,
     /*  757158 */     GIR_EraseRootFromParent_Done,
     /*  757159 */   // Label 11847: @757159
     /*  757159 */   GIM_Try, /*On fail goto*//*Label 11848*/ GIMT_Encode4(757237), // Rule ID 14073 //
     /*  757164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  757175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  757178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  757181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  757184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757210 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  757213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757235 */     GIR_RootConstrainSelectedInstOperands,
     /*  757236 */     // GIR_Coverage, 14073,
     /*  757236 */     GIR_EraseRootFromParent_Done,
     /*  757237 */   // Label 11848: @757237
     /*  757237 */   GIM_Try, /*On fail goto*//*Label 11849*/ GIMT_Encode4(757315), // Rule ID 14076 //
     /*  757242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  757253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  757256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  757259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  757262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757288 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757313 */     GIR_RootConstrainSelectedInstOperands,
     /*  757314 */     // GIR_Coverage, 14076,
     /*  757314 */     GIR_EraseRootFromParent_Done,
     /*  757315 */   // Label 11849: @757315
     /*  757315 */   GIM_Try, /*On fail goto*//*Label 11850*/ GIMT_Encode4(757393), // Rule ID 14077 //
     /*  757320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  757331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  757334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  757337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  757340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757366 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757391 */     GIR_RootConstrainSelectedInstOperands,
     /*  757392 */     // GIR_Coverage, 14077,
     /*  757392 */     GIR_EraseRootFromParent_Done,
     /*  757393 */   // Label 11850: @757393
     /*  757393 */   GIM_Try, /*On fail goto*//*Label 11851*/ GIMT_Encode4(757471), // Rule ID 14080 //
     /*  757398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  757409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  757412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  757415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  757418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757444 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757469 */     GIR_RootConstrainSelectedInstOperands,
     /*  757470 */     // GIR_Coverage, 14080,
     /*  757470 */     GIR_EraseRootFromParent_Done,
     /*  757471 */   // Label 11851: @757471
     /*  757471 */   GIM_Try, /*On fail goto*//*Label 11852*/ GIMT_Encode4(757549), // Rule ID 14081 //
     /*  757476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  757487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  757490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  757493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  757496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757522 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757547 */     GIR_RootConstrainSelectedInstOperands,
     /*  757548 */     // GIR_Coverage, 14081,
     /*  757548 */     GIR_EraseRootFromParent_Done,
     /*  757549 */   // Label 11852: @757549
     /*  757549 */   GIM_Try, /*On fail goto*//*Label 11853*/ GIMT_Encode4(757627), // Rule ID 14084 //
     /*  757554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  757565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  757568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757625 */     GIR_RootConstrainSelectedInstOperands,
     /*  757626 */     // GIR_Coverage, 14084,
     /*  757626 */     GIR_EraseRootFromParent_Done,
     /*  757627 */   // Label 11853: @757627
     /*  757627 */   GIM_Try, /*On fail goto*//*Label 11854*/ GIMT_Encode4(757705), // Rule ID 14085 //
     /*  757632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  757643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  757646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757703 */     GIR_RootConstrainSelectedInstOperands,
     /*  757704 */     // GIR_Coverage, 14085,
     /*  757704 */     GIR_EraseRootFromParent_Done,
     /*  757705 */   // Label 11854: @757705
     /*  757705 */   GIM_Try, /*On fail goto*//*Label 11855*/ GIMT_Encode4(757783), // Rule ID 14088 //
     /*  757710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  757713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  757727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  757730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  757756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757781 */     GIR_RootConstrainSelectedInstOperands,
     /*  757782 */     // GIR_Coverage, 14088,
     /*  757782 */     GIR_EraseRootFromParent_Done,
     /*  757783 */   // Label 11855: @757783
     /*  757783 */   GIM_Try, /*On fail goto*//*Label 11856*/ GIMT_Encode4(757861), // Rule ID 14089 //
     /*  757788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  757791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  757805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  757808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757834 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  757834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757859 */     GIR_RootConstrainSelectedInstOperands,
     /*  757860 */     // GIR_Coverage, 14089,
     /*  757860 */     GIR_EraseRootFromParent_Done,
     /*  757861 */   // Label 11856: @757861
     /*  757861 */   GIM_Try, /*On fail goto*//*Label 11857*/ GIMT_Encode4(757939), // Rule ID 14092 //
     /*  757866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  757877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  757880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  757883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  757886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757912 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  757915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757937 */     GIR_RootConstrainSelectedInstOperands,
     /*  757938 */     // GIR_Coverage, 14092,
     /*  757938 */     GIR_EraseRootFromParent_Done,
     /*  757939 */   // Label 11857: @757939
     /*  757939 */   GIM_Try, /*On fail goto*//*Label 11858*/ GIMT_Encode4(758017), // Rule ID 14093 //
     /*  757944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  757955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  757958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  757961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  757964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757990 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  757993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758015 */     GIR_RootConstrainSelectedInstOperands,
     /*  758016 */     // GIR_Coverage, 14093,
     /*  758016 */     GIR_EraseRootFromParent_Done,
     /*  758017 */   // Label 11858: @758017
     /*  758017 */   GIM_Try, /*On fail goto*//*Label 11859*/ GIMT_Encode4(758095), // Rule ID 14096 //
     /*  758022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  758033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  758036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  758042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758068 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758093 */     GIR_RootConstrainSelectedInstOperands,
     /*  758094 */     // GIR_Coverage, 14096,
     /*  758094 */     GIR_EraseRootFromParent_Done,
     /*  758095 */   // Label 11859: @758095
     /*  758095 */   GIM_Try, /*On fail goto*//*Label 11860*/ GIMT_Encode4(758173), // Rule ID 14097 //
     /*  758100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  758111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  758114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  758117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  758120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758171 */     GIR_RootConstrainSelectedInstOperands,
     /*  758172 */     // GIR_Coverage, 14097,
     /*  758172 */     GIR_EraseRootFromParent_Done,
     /*  758173 */   // Label 11860: @758173
     /*  758173 */   GIM_Try, /*On fail goto*//*Label 11861*/ GIMT_Encode4(758251), // Rule ID 14100 //
     /*  758178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  758189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  758192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  758195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  758198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758224 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  758224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758249 */     GIR_RootConstrainSelectedInstOperands,
     /*  758250 */     // GIR_Coverage, 14100,
     /*  758250 */     GIR_EraseRootFromParent_Done,
     /*  758251 */   // Label 11861: @758251
     /*  758251 */   GIM_Try, /*On fail goto*//*Label 11862*/ GIMT_Encode4(758329), // Rule ID 14101 //
     /*  758256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  758267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  758270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  758273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  758276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758302 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  758302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  758321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758327 */     GIR_RootConstrainSelectedInstOperands,
     /*  758328 */     // GIR_Coverage, 14101,
     /*  758328 */     GIR_EraseRootFromParent_Done,
     /*  758329 */   // Label 11862: @758329
     /*  758329 */   GIM_Try, /*On fail goto*//*Label 11863*/ GIMT_Encode4(758407), // Rule ID 14104 //
     /*  758334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  758354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758380 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758405 */     GIR_RootConstrainSelectedInstOperands,
     /*  758406 */     // GIR_Coverage, 14104,
     /*  758406 */     GIR_EraseRootFromParent_Done,
     /*  758407 */   // Label 11863: @758407
     /*  758407 */   GIM_Try, /*On fail goto*//*Label 11864*/ GIMT_Encode4(758485), // Rule ID 14105 //
     /*  758412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  758423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  758426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  758429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  758432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758483 */     GIR_RootConstrainSelectedInstOperands,
     /*  758484 */     // GIR_Coverage, 14105,
     /*  758484 */     GIR_EraseRootFromParent_Done,
     /*  758485 */   // Label 11864: @758485
     /*  758485 */   GIM_Try, /*On fail goto*//*Label 11865*/ GIMT_Encode4(758563), // Rule ID 14108 //
     /*  758490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  758507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  758510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758561 */     GIR_RootConstrainSelectedInstOperands,
     /*  758562 */     // GIR_Coverage, 14108,
     /*  758562 */     GIR_EraseRootFromParent_Done,
     /*  758563 */   // Label 11865: @758563
     /*  758563 */   GIM_Try, /*On fail goto*//*Label 11866*/ GIMT_Encode4(758641), // Rule ID 14109 //
     /*  758568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  758585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  758588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758639 */     GIR_RootConstrainSelectedInstOperands,
     /*  758640 */     // GIR_Coverage, 14109,
     /*  758640 */     GIR_EraseRootFromParent_Done,
     /*  758641 */   // Label 11866: @758641
     /*  758641 */   GIM_Try, /*On fail goto*//*Label 11867*/ GIMT_Encode4(758719), // Rule ID 14112 //
     /*  758646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  758663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  758666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758717 */     GIR_RootConstrainSelectedInstOperands,
     /*  758718 */     // GIR_Coverage, 14112,
     /*  758718 */     GIR_EraseRootFromParent_Done,
     /*  758719 */   // Label 11867: @758719
     /*  758719 */   GIM_Try, /*On fail goto*//*Label 11868*/ GIMT_Encode4(758797), // Rule ID 14113 //
     /*  758724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  758741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  758744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758770 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758795 */     GIR_RootConstrainSelectedInstOperands,
     /*  758796 */     // GIR_Coverage, 14113,
     /*  758796 */     GIR_EraseRootFromParent_Done,
     /*  758797 */   // Label 11868: @758797
     /*  758797 */   GIM_Try, /*On fail goto*//*Label 11869*/ GIMT_Encode4(758875), // Rule ID 14116 //
     /*  758802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  758813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  758816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  758819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  758822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  758848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758873 */     GIR_RootConstrainSelectedInstOperands,
     /*  758874 */     // GIR_Coverage, 14116,
     /*  758874 */     GIR_EraseRootFromParent_Done,
     /*  758875 */   // Label 11869: @758875
     /*  758875 */   GIM_Try, /*On fail goto*//*Label 11870*/ GIMT_Encode4(758953), // Rule ID 14117 //
     /*  758880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  758891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  758894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  758897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  758900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  758926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758951 */     GIR_RootConstrainSelectedInstOperands,
     /*  758952 */     // GIR_Coverage, 14117,
     /*  758952 */     GIR_EraseRootFromParent_Done,
     /*  758953 */   // Label 11870: @758953
     /*  758953 */   GIM_Try, /*On fail goto*//*Label 11871*/ GIMT_Encode4(759031), // Rule ID 14120 //
     /*  758958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  758969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  758972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  758975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  758978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759004 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759029 */     GIR_RootConstrainSelectedInstOperands,
     /*  759030 */     // GIR_Coverage, 14120,
     /*  759030 */     GIR_EraseRootFromParent_Done,
     /*  759031 */   // Label 11871: @759031
     /*  759031 */   GIM_Try, /*On fail goto*//*Label 11872*/ GIMT_Encode4(759109), // Rule ID 14121 //
     /*  759036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  759047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  759050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  759053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  759056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759082 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759107 */     GIR_RootConstrainSelectedInstOperands,
     /*  759108 */     // GIR_Coverage, 14121,
     /*  759108 */     GIR_EraseRootFromParent_Done,
     /*  759109 */   // Label 11872: @759109
     /*  759109 */   GIM_Try, /*On fail goto*//*Label 11873*/ GIMT_Encode4(759187), // Rule ID 14124 //
     /*  759114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  759134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759160 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  759160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759185 */     GIR_RootConstrainSelectedInstOperands,
     /*  759186 */     // GIR_Coverage, 14124,
     /*  759186 */     GIR_EraseRootFromParent_Done,
     /*  759187 */   // Label 11873: @759187
     /*  759187 */   GIM_Try, /*On fail goto*//*Label 11874*/ GIMT_Encode4(759265), // Rule ID 14125 //
     /*  759192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  759203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  759206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  759209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  759212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759238 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  759238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  759257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759263 */     GIR_RootConstrainSelectedInstOperands,
     /*  759264 */     // GIR_Coverage, 14125,
     /*  759264 */     GIR_EraseRootFromParent_Done,
     /*  759265 */   // Label 11874: @759265
     /*  759265 */   GIM_Try, /*On fail goto*//*Label 11875*/ GIMT_Encode4(759343), // Rule ID 14128 //
     /*  759270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  759290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759341 */     GIR_RootConstrainSelectedInstOperands,
     /*  759342 */     // GIR_Coverage, 14128,
     /*  759342 */     GIR_EraseRootFromParent_Done,
     /*  759343 */   // Label 11875: @759343
     /*  759343 */   GIM_Try, /*On fail goto*//*Label 11876*/ GIMT_Encode4(759421), // Rule ID 14129 //
     /*  759348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  759359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  759362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  759365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  759368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  759387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  759397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759419 */     GIR_RootConstrainSelectedInstOperands,
     /*  759420 */     // GIR_Coverage, 14129,
     /*  759420 */     GIR_EraseRootFromParent_Done,
     /*  759421 */   // Label 11876: @759421
     /*  759421 */   GIM_Try, /*On fail goto*//*Label 11877*/ GIMT_Encode4(759499), // Rule ID 14132 //
     /*  759426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  759446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759497 */     GIR_RootConstrainSelectedInstOperands,
     /*  759498 */     // GIR_Coverage, 14132,
     /*  759498 */     GIR_EraseRootFromParent_Done,
     /*  759499 */   // Label 11877: @759499
     /*  759499 */   GIM_Try, /*On fail goto*//*Label 11878*/ GIMT_Encode4(759577), // Rule ID 14133 //
     /*  759504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  759524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759550 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759575 */     GIR_RootConstrainSelectedInstOperands,
     /*  759576 */     // GIR_Coverage, 14133,
     /*  759576 */     GIR_EraseRootFromParent_Done,
     /*  759577 */   // Label 11878: @759577
     /*  759577 */   GIM_Try, /*On fail goto*//*Label 11879*/ GIMT_Encode4(759655), // Rule ID 14136 //
     /*  759582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  759593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  759596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  759599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  759602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759628 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759653 */     GIR_RootConstrainSelectedInstOperands,
     /*  759654 */     // GIR_Coverage, 14136,
     /*  759654 */     GIR_EraseRootFromParent_Done,
     /*  759655 */   // Label 11879: @759655
     /*  759655 */   GIM_Try, /*On fail goto*//*Label 11880*/ GIMT_Encode4(759733), // Rule ID 14137 //
     /*  759660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  759671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  759674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  759677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  759680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759706 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759731 */     GIR_RootConstrainSelectedInstOperands,
     /*  759732 */     // GIR_Coverage, 14137,
     /*  759732 */     GIR_EraseRootFromParent_Done,
     /*  759733 */   // Label 11880: @759733
     /*  759733 */   GIM_Try, /*On fail goto*//*Label 11881*/ GIMT_Encode4(759811), // Rule ID 14140 //
     /*  759738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  759749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  759752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  759755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759784 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  759784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  759787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759809 */     GIR_RootConstrainSelectedInstOperands,
     /*  759810 */     // GIR_Coverage, 14140,
     /*  759810 */     GIR_EraseRootFromParent_Done,
     /*  759811 */   // Label 11881: @759811
     /*  759811 */   GIM_Try, /*On fail goto*//*Label 11882*/ GIMT_Encode4(759889), // Rule ID 14141 //
     /*  759816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  759827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  759830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  759833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759862 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  759862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  759865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759887 */     GIR_RootConstrainSelectedInstOperands,
     /*  759888 */     // GIR_Coverage, 14141,
     /*  759888 */     GIR_EraseRootFromParent_Done,
     /*  759889 */   // Label 11882: @759889
     /*  759889 */   GIM_Try, /*On fail goto*//*Label 11883*/ GIMT_Encode4(759967), // Rule ID 14144 //
     /*  759894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  759905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  759908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  759911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759940 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  759940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  759943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759965 */     GIR_RootConstrainSelectedInstOperands,
     /*  759966 */     // GIR_Coverage, 14144,
     /*  759966 */     GIR_EraseRootFromParent_Done,
     /*  759967 */   // Label 11883: @759967
     /*  759967 */   GIM_Try, /*On fail goto*//*Label 11884*/ GIMT_Encode4(760045), // Rule ID 14145 //
     /*  759972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  759983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  759986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  759989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760018 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760043 */     GIR_RootConstrainSelectedInstOperands,
     /*  760044 */     // GIR_Coverage, 14145,
     /*  760044 */     GIR_EraseRootFromParent_Done,
     /*  760045 */   // Label 11884: @760045
     /*  760045 */   GIM_Try, /*On fail goto*//*Label 11885*/ GIMT_Encode4(760123), // Rule ID 14148 //
     /*  760050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760121 */     GIR_RootConstrainSelectedInstOperands,
     /*  760122 */     // GIR_Coverage, 14148,
     /*  760122 */     GIR_EraseRootFromParent_Done,
     /*  760123 */   // Label 11885: @760123
     /*  760123 */   GIM_Try, /*On fail goto*//*Label 11886*/ GIMT_Encode4(760201), // Rule ID 14149 //
     /*  760128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  760139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  760142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  760145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760199 */     GIR_RootConstrainSelectedInstOperands,
     /*  760200 */     // GIR_Coverage, 14149,
     /*  760200 */     GIR_EraseRootFromParent_Done,
     /*  760201 */   // Label 11886: @760201
     /*  760201 */   GIM_Try, /*On fail goto*//*Label 11887*/ GIMT_Encode4(760279), // Rule ID 14152 //
     /*  760206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760277 */     GIR_RootConstrainSelectedInstOperands,
     /*  760278 */     // GIR_Coverage, 14152,
     /*  760278 */     GIR_EraseRootFromParent_Done,
     /*  760279 */   // Label 11887: @760279
     /*  760279 */   GIM_Try, /*On fail goto*//*Label 11888*/ GIMT_Encode4(760357), // Rule ID 14153 //
     /*  760284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  760295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  760298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  760301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760330 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  760333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760355 */     GIR_RootConstrainSelectedInstOperands,
     /*  760356 */     // GIR_Coverage, 14153,
     /*  760356 */     GIR_EraseRootFromParent_Done,
     /*  760357 */   // Label 11888: @760357
     /*  760357 */   GIM_Try, /*On fail goto*//*Label 11889*/ GIMT_Encode4(760435), // Rule ID 14156 //
     /*  760362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760408 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760433 */     GIR_RootConstrainSelectedInstOperands,
     /*  760434 */     // GIR_Coverage, 14156,
     /*  760434 */     GIR_EraseRootFromParent_Done,
     /*  760435 */   // Label 11889: @760435
     /*  760435 */   GIM_Try, /*On fail goto*//*Label 11890*/ GIMT_Encode4(760513), // Rule ID 14157 //
     /*  760440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  760451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  760454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  760457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760486 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760511 */     GIR_RootConstrainSelectedInstOperands,
     /*  760512 */     // GIR_Coverage, 14157,
     /*  760512 */     GIR_EraseRootFromParent_Done,
     /*  760513 */   // Label 11890: @760513
     /*  760513 */   GIM_Try, /*On fail goto*//*Label 11891*/ GIMT_Encode4(760591), // Rule ID 14160 //
     /*  760518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760589 */     GIR_RootConstrainSelectedInstOperands,
     /*  760590 */     // GIR_Coverage, 14160,
     /*  760590 */     GIR_EraseRootFromParent_Done,
     /*  760591 */   // Label 11891: @760591
     /*  760591 */   GIM_Try, /*On fail goto*//*Label 11892*/ GIMT_Encode4(760669), // Rule ID 14161 //
     /*  760596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760642 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  760642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760667 */     GIR_RootConstrainSelectedInstOperands,
     /*  760668 */     // GIR_Coverage, 14161,
     /*  760668 */     GIR_EraseRootFromParent_Done,
     /*  760669 */   // Label 11892: @760669
     /*  760669 */   GIM_Try, /*On fail goto*//*Label 11893*/ GIMT_Encode4(760747), // Rule ID 14164 //
     /*  760674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  760685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  760688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  760691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760720 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760745 */     GIR_RootConstrainSelectedInstOperands,
     /*  760746 */     // GIR_Coverage, 14164,
     /*  760746 */     GIR_EraseRootFromParent_Done,
     /*  760747 */   // Label 11893: @760747
     /*  760747 */   GIM_Try, /*On fail goto*//*Label 11894*/ GIMT_Encode4(760825), // Rule ID 14165 //
     /*  760752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  760763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  760766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  760769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760798 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760823 */     GIR_RootConstrainSelectedInstOperands,
     /*  760824 */     // GIR_Coverage, 14165,
     /*  760824 */     GIR_EraseRootFromParent_Done,
     /*  760825 */   // Label 11894: @760825
     /*  760825 */   GIM_Try, /*On fail goto*//*Label 11895*/ GIMT_Encode4(760903), // Rule ID 14168 //
     /*  760830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  760841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  760844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  760847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760901 */     GIR_RootConstrainSelectedInstOperands,
     /*  760902 */     // GIR_Coverage, 14168,
     /*  760902 */     GIR_EraseRootFromParent_Done,
     /*  760903 */   // Label 11895: @760903
     /*  760903 */   GIM_Try, /*On fail goto*//*Label 11896*/ GIMT_Encode4(760981), // Rule ID 14169 //
     /*  760908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  760919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  760922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  760925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760954 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760979 */     GIR_RootConstrainSelectedInstOperands,
     /*  760980 */     // GIR_Coverage, 14169,
     /*  760980 */     GIR_EraseRootFromParent_Done,
     /*  760981 */   // Label 11896: @760981
     /*  760981 */   GIM_Try, /*On fail goto*//*Label 11897*/ GIMT_Encode4(761059), // Rule ID 14172 //
     /*  760986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  760997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761032 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761057 */     GIR_RootConstrainSelectedInstOperands,
     /*  761058 */     // GIR_Coverage, 14172,
     /*  761058 */     GIR_EraseRootFromParent_Done,
     /*  761059 */   // Label 11897: @761059
     /*  761059 */   GIM_Try, /*On fail goto*//*Label 11898*/ GIMT_Encode4(761137), // Rule ID 14173 //
     /*  761064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  761075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  761078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  761081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761135 */     GIR_RootConstrainSelectedInstOperands,
     /*  761136 */     // GIR_Coverage, 14173,
     /*  761136 */     GIR_EraseRootFromParent_Done,
     /*  761137 */   // Label 11898: @761137
     /*  761137 */   GIM_Try, /*On fail goto*//*Label 11899*/ GIMT_Encode4(761215), // Rule ID 14176 //
     /*  761142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  761145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  761188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761213 */     GIR_RootConstrainSelectedInstOperands,
     /*  761214 */     // GIR_Coverage, 14176,
     /*  761214 */     GIR_EraseRootFromParent_Done,
     /*  761215 */   // Label 11899: @761215
     /*  761215 */   GIM_Try, /*On fail goto*//*Label 11900*/ GIMT_Encode4(761293), // Rule ID 14177 //
     /*  761220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  761223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  761231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  761234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  761237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  761255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  761266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  761269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  761285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761291 */     GIR_RootConstrainSelectedInstOperands,
     /*  761292 */     // GIR_Coverage, 14177,
     /*  761292 */     GIR_EraseRootFromParent_Done,
     /*  761293 */   // Label 11900: @761293
     /*  761293 */   GIM_Try, /*On fail goto*//*Label 11901*/ GIMT_Encode4(761371), // Rule ID 14180 //
     /*  761298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761369 */     GIR_RootConstrainSelectedInstOperands,
     /*  761370 */     // GIR_Coverage, 14180,
     /*  761370 */     GIR_EraseRootFromParent_Done,
     /*  761371 */   // Label 11901: @761371
     /*  761371 */   GIM_Try, /*On fail goto*//*Label 11902*/ GIMT_Encode4(761449), // Rule ID 14181 //
     /*  761376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  761387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  761390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  761393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761422 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761447 */     GIR_RootConstrainSelectedInstOperands,
     /*  761448 */     // GIR_Coverage, 14181,
     /*  761448 */     GIR_EraseRootFromParent_Done,
     /*  761449 */   // Label 11902: @761449
     /*  761449 */   GIM_Try, /*On fail goto*//*Label 11903*/ GIMT_Encode4(761527), // Rule ID 14184 //
     /*  761454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761500 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761525 */     GIR_RootConstrainSelectedInstOperands,
     /*  761526 */     // GIR_Coverage, 14184,
     /*  761526 */     GIR_EraseRootFromParent_Done,
     /*  761527 */   // Label 11903: @761527
     /*  761527 */   GIM_Try, /*On fail goto*//*Label 11904*/ GIMT_Encode4(761605), // Rule ID 14185 //
     /*  761532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761578 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761603 */     GIR_RootConstrainSelectedInstOperands,
     /*  761604 */     // GIR_Coverage, 14185,
     /*  761604 */     GIR_EraseRootFromParent_Done,
     /*  761605 */   // Label 11904: @761605
     /*  761605 */   GIM_Try, /*On fail goto*//*Label 11905*/ GIMT_Encode4(761683), // Rule ID 14188 //
     /*  761610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  761621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  761624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  761627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761656 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  761659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761681 */     GIR_RootConstrainSelectedInstOperands,
     /*  761682 */     // GIR_Coverage, 14188,
     /*  761682 */     GIR_EraseRootFromParent_Done,
     /*  761683 */   // Label 11905: @761683
     /*  761683 */   GIM_Try, /*On fail goto*//*Label 11906*/ GIMT_Encode4(761761), // Rule ID 14189 //
     /*  761688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  761699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  761702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  761705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761734 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  761737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761759 */     GIR_RootConstrainSelectedInstOperands,
     /*  761760 */     // GIR_Coverage, 14189,
     /*  761760 */     GIR_EraseRootFromParent_Done,
     /*  761761 */   // Label 11906: @761761
     /*  761761 */   GIM_Try, /*On fail goto*//*Label 11907*/ GIMT_Encode4(761839), // Rule ID 14192 //
     /*  761766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  761777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  761780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  761783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761812 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761837 */     GIR_RootConstrainSelectedInstOperands,
     /*  761838 */     // GIR_Coverage, 14192,
     /*  761838 */     GIR_EraseRootFromParent_Done,
     /*  761839 */   // Label 11907: @761839
     /*  761839 */   GIM_Try, /*On fail goto*//*Label 11908*/ GIMT_Encode4(761917), // Rule ID 14193 //
     /*  761844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  761855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  761858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  761861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761915 */     GIR_RootConstrainSelectedInstOperands,
     /*  761916 */     // GIR_Coverage, 14193,
     /*  761916 */     GIR_EraseRootFromParent_Done,
     /*  761917 */   // Label 11908: @761917
     /*  761917 */   GIM_Try, /*On fail goto*//*Label 11909*/ GIMT_Encode4(761995), // Rule ID 14196 //
     /*  761922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  761933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  761936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  761939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761993 */     GIR_RootConstrainSelectedInstOperands,
     /*  761994 */     // GIR_Coverage, 14196,
     /*  761994 */     GIR_EraseRootFromParent_Done,
     /*  761995 */   // Label 11909: @761995
     /*  761995 */   GIM_Try, /*On fail goto*//*Label 11910*/ GIMT_Encode4(762073), // Rule ID 14197 //
     /*  762000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  762011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  762014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  762017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762068 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762071 */     GIR_RootConstrainSelectedInstOperands,
     /*  762072 */     // GIR_Coverage, 14197,
     /*  762072 */     GIR_EraseRootFromParent_Done,
     /*  762073 */   // Label 11910: @762073
     /*  762073 */   GIM_Try, /*On fail goto*//*Label 11911*/ GIMT_Encode4(762151), // Rule ID 14200 //
     /*  762078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762124 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  762124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762149 */     GIR_RootConstrainSelectedInstOperands,
     /*  762150 */     // GIR_Coverage, 14200,
     /*  762150 */     GIR_EraseRootFromParent_Done,
     /*  762151 */   // Label 11911: @762151
     /*  762151 */   GIM_Try, /*On fail goto*//*Label 11912*/ GIMT_Encode4(762229), // Rule ID 14201 //
     /*  762156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  762167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  762170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  762173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  762202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  762221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762227 */     GIR_RootConstrainSelectedInstOperands,
     /*  762228 */     // GIR_Coverage, 14201,
     /*  762228 */     GIR_EraseRootFromParent_Done,
     /*  762229 */   // Label 11912: @762229
     /*  762229 */   GIM_Try, /*On fail goto*//*Label 11913*/ GIMT_Encode4(762307), // Rule ID 14204 //
     /*  762234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762305 */     GIR_RootConstrainSelectedInstOperands,
     /*  762306 */     // GIR_Coverage, 14204,
     /*  762306 */     GIR_EraseRootFromParent_Done,
     /*  762307 */   // Label 11913: @762307
     /*  762307 */   GIM_Try, /*On fail goto*//*Label 11914*/ GIMT_Encode4(762385), // Rule ID 14205 //
     /*  762312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  762323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  762326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  762329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762383 */     GIR_RootConstrainSelectedInstOperands,
     /*  762384 */     // GIR_Coverage, 14205,
     /*  762384 */     GIR_EraseRootFromParent_Done,
     /*  762385 */   // Label 11914: @762385
     /*  762385 */   GIM_Try, /*On fail goto*//*Label 11915*/ GIMT_Encode4(762463), // Rule ID 14208 //
     /*  762390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762461 */     GIR_RootConstrainSelectedInstOperands,
     /*  762462 */     // GIR_Coverage, 14208,
     /*  762462 */     GIR_EraseRootFromParent_Done,
     /*  762463 */   // Label 11915: @762463
     /*  762463 */   GIM_Try, /*On fail goto*//*Label 11916*/ GIMT_Encode4(762541), // Rule ID 14209 //
     /*  762468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  762479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  762482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  762485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762539 */     GIR_RootConstrainSelectedInstOperands,
     /*  762540 */     // GIR_Coverage, 14209,
     /*  762540 */     GIR_EraseRootFromParent_Done,
     /*  762541 */   // Label 11916: @762541
     /*  762541 */   GIM_Try, /*On fail goto*//*Label 11917*/ GIMT_Encode4(762619), // Rule ID 14212 //
     /*  762546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  762557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  762560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  762563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762617 */     GIR_RootConstrainSelectedInstOperands,
     /*  762618 */     // GIR_Coverage, 14212,
     /*  762618 */     GIR_EraseRootFromParent_Done,
     /*  762619 */   // Label 11917: @762619
     /*  762619 */   GIM_Try, /*On fail goto*//*Label 11918*/ GIMT_Encode4(762697), // Rule ID 14213 //
     /*  762624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  762635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  762638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  762641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762670 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762695 */     GIR_RootConstrainSelectedInstOperands,
     /*  762696 */     // GIR_Coverage, 14213,
     /*  762696 */     GIR_EraseRootFromParent_Done,
     /*  762697 */   // Label 11918: @762697
     /*  762697 */   GIM_Try, /*On fail goto*//*Label 11919*/ GIMT_Encode4(762775), // Rule ID 14216 //
     /*  762702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  762705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  762713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  762716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  762719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  762748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762773 */     GIR_RootConstrainSelectedInstOperands,
     /*  762774 */     // GIR_Coverage, 14216,
     /*  762774 */     GIR_EraseRootFromParent_Done,
     /*  762775 */   // Label 11919: @762775
     /*  762775 */   GIM_Try, /*On fail goto*//*Label 11920*/ GIMT_Encode4(762853), // Rule ID 14217 //
     /*  762780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  762783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  762791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  762794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  762797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  762826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762851 */     GIR_RootConstrainSelectedInstOperands,
     /*  762852 */     // GIR_Coverage, 14217,
     /*  762852 */     GIR_EraseRootFromParent_Done,
     /*  762853 */   // Label 11920: @762853
     /*  762853 */   GIM_Try, /*On fail goto*//*Label 11921*/ GIMT_Encode4(762931), // Rule ID 14220 //
     /*  762858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  762861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  762869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  762872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  762875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762904 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  762904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762929 */     GIR_RootConstrainSelectedInstOperands,
     /*  762930 */     // GIR_Coverage, 14220,
     /*  762930 */     GIR_EraseRootFromParent_Done,
     /*  762931 */   // Label 11921: @762931
     /*  762931 */   GIM_Try, /*On fail goto*//*Label 11922*/ GIMT_Encode4(763009), // Rule ID 14221 //
     /*  762936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  762939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  762947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  762950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  762953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762982 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  762982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763007 */     GIR_RootConstrainSelectedInstOperands,
     /*  763008 */     // GIR_Coverage, 14221,
     /*  763008 */     GIR_EraseRootFromParent_Done,
     /*  763009 */   // Label 11922: @763009
     /*  763009 */   GIM_Try, /*On fail goto*//*Label 11923*/ GIMT_Encode4(763087), // Rule ID 14224 //
     /*  763014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  763017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  763034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763060 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  763060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763085 */     GIR_RootConstrainSelectedInstOperands,
     /*  763086 */     // GIR_Coverage, 14224,
     /*  763086 */     GIR_EraseRootFromParent_Done,
     /*  763087 */   // Label 11923: @763087
     /*  763087 */   GIM_Try, /*On fail goto*//*Label 11924*/ GIMT_Encode4(763165), // Rule ID 14225 //
     /*  763092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  763095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  763100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  763103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  763106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  763109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  763112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  763127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  763131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763138 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  763138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  763141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  763157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763163 */     GIR_RootConstrainSelectedInstOperands,
     /*  763164 */     // GIR_Coverage, 14225,
     /*  763164 */     GIR_EraseRootFromParent_Done,
     /*  763165 */   // Label 11924: @763165
     /*  763165 */   GIM_Try, /*On fail goto*//*Label 11925*/ GIMT_Encode4(763243), // Rule ID 14316 //
     /*  763170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  763190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763216 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  763219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763241 */     GIR_RootConstrainSelectedInstOperands,
     /*  763242 */     // GIR_Coverage, 14316,
     /*  763242 */     GIR_EraseRootFromParent_Done,
     /*  763243 */   // Label 11925: @763243
     /*  763243 */   GIM_Try, /*On fail goto*//*Label 11926*/ GIMT_Encode4(763321), // Rule ID 14317 //
     /*  763248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  763259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  763262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  763265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  763268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  763297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763319 */     GIR_RootConstrainSelectedInstOperands,
     /*  763320 */     // GIR_Coverage, 14317,
     /*  763320 */     GIR_EraseRootFromParent_Done,
     /*  763321 */   // Label 11926: @763321
     /*  763321 */   GIM_Try, /*On fail goto*//*Label 11927*/ GIMT_Encode4(763399), // Rule ID 14320 //
     /*  763326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  763346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763372 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763397 */     GIR_RootConstrainSelectedInstOperands,
     /*  763398 */     // GIR_Coverage, 14320,
     /*  763398 */     GIR_EraseRootFromParent_Done,
     /*  763399 */   // Label 11927: @763399
     /*  763399 */   GIM_Try, /*On fail goto*//*Label 11928*/ GIMT_Encode4(763477), // Rule ID 14321 //
     /*  763404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  763415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  763418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  763421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  763424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763450 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763475 */     GIR_RootConstrainSelectedInstOperands,
     /*  763476 */     // GIR_Coverage, 14321,
     /*  763476 */     GIR_EraseRootFromParent_Done,
     /*  763477 */   // Label 11928: @763477
     /*  763477 */   GIM_Try, /*On fail goto*//*Label 11929*/ GIMT_Encode4(763555), // Rule ID 14324 //
     /*  763482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  763502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763528 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763553 */     GIR_RootConstrainSelectedInstOperands,
     /*  763554 */     // GIR_Coverage, 14324,
     /*  763554 */     GIR_EraseRootFromParent_Done,
     /*  763555 */   // Label 11929: @763555
     /*  763555 */   GIM_Try, /*On fail goto*//*Label 11930*/ GIMT_Encode4(763633), // Rule ID 14325 //
     /*  763560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  763580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763606 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763631 */     GIR_RootConstrainSelectedInstOperands,
     /*  763632 */     // GIR_Coverage, 14325,
     /*  763632 */     GIR_EraseRootFromParent_Done,
     /*  763633 */   // Label 11930: @763633
     /*  763633 */   GIM_Try, /*On fail goto*//*Label 11931*/ GIMT_Encode4(763711), // Rule ID 14328 //
     /*  763638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  763649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  763652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  763655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  763658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763684 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  763684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763709 */     GIR_RootConstrainSelectedInstOperands,
     /*  763710 */     // GIR_Coverage, 14328,
     /*  763710 */     GIR_EraseRootFromParent_Done,
     /*  763711 */   // Label 11931: @763711
     /*  763711 */   GIM_Try, /*On fail goto*//*Label 11932*/ GIMT_Encode4(763789), // Rule ID 14329 //
     /*  763716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  763727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  763730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  763733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  763736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763762 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  763762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763787 */     GIR_RootConstrainSelectedInstOperands,
     /*  763788 */     // GIR_Coverage, 14329,
     /*  763788 */     GIR_EraseRootFromParent_Done,
     /*  763789 */   // Label 11932: @763789
     /*  763789 */   GIM_Try, /*On fail goto*//*Label 11933*/ GIMT_Encode4(763867), // Rule ID 14332 //
     /*  763794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  763805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  763808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  763811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  763814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763840 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  763840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763865 */     GIR_RootConstrainSelectedInstOperands,
     /*  763866 */     // GIR_Coverage, 14332,
     /*  763866 */     GIR_EraseRootFromParent_Done,
     /*  763867 */   // Label 11933: @763867
     /*  763867 */   GIM_Try, /*On fail goto*//*Label 11934*/ GIMT_Encode4(763945), // Rule ID 14333 //
     /*  763872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  763883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  763886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  763889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  763892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763918 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  763918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763943 */     GIR_RootConstrainSelectedInstOperands,
     /*  763944 */     // GIR_Coverage, 14333,
     /*  763944 */     GIR_EraseRootFromParent_Done,
     /*  763945 */   // Label 11934: @763945
     /*  763945 */   GIM_Try, /*On fail goto*//*Label 11935*/ GIMT_Encode4(764023), // Rule ID 14336 //
     /*  763950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  763961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  763964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  763967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  763970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763996 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  763996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764021 */     GIR_RootConstrainSelectedInstOperands,
     /*  764022 */     // GIR_Coverage, 14336,
     /*  764022 */     GIR_EraseRootFromParent_Done,
     /*  764023 */   // Label 11935: @764023
     /*  764023 */   GIM_Try, /*On fail goto*//*Label 11936*/ GIMT_Encode4(764101), // Rule ID 14337 //
     /*  764028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  764039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  764042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  764045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  764048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764074 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  764077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764099 */     GIR_RootConstrainSelectedInstOperands,
     /*  764100 */     // GIR_Coverage, 14337,
     /*  764100 */     GIR_EraseRootFromParent_Done,
     /*  764101 */   // Label 11936: @764101
     /*  764101 */   GIM_Try, /*On fail goto*//*Label 11937*/ GIMT_Encode4(764179), // Rule ID 14340 //
     /*  764106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  764126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764177 */     GIR_RootConstrainSelectedInstOperands,
     /*  764178 */     // GIR_Coverage, 14340,
     /*  764178 */     GIR_EraseRootFromParent_Done,
     /*  764179 */   // Label 11937: @764179
     /*  764179 */   GIM_Try, /*On fail goto*//*Label 11938*/ GIMT_Encode4(764257), // Rule ID 14341 //
     /*  764184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  764195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  764198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  764201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  764204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764230 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764255 */     GIR_RootConstrainSelectedInstOperands,
     /*  764256 */     // GIR_Coverage, 14341,
     /*  764256 */     GIR_EraseRootFromParent_Done,
     /*  764257 */   // Label 11938: @764257
     /*  764257 */   GIM_Try, /*On fail goto*//*Label 11939*/ GIMT_Encode4(764335), // Rule ID 14344 //
     /*  764262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  764282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764333 */     GIR_RootConstrainSelectedInstOperands,
     /*  764334 */     // GIR_Coverage, 14344,
     /*  764334 */     GIR_EraseRootFromParent_Done,
     /*  764335 */   // Label 11939: @764335
     /*  764335 */   GIM_Try, /*On fail goto*//*Label 11940*/ GIMT_Encode4(764413), // Rule ID 14345 //
     /*  764340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  764351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  764354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  764357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  764360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764411 */     GIR_RootConstrainSelectedInstOperands,
     /*  764412 */     // GIR_Coverage, 14345,
     /*  764412 */     GIR_EraseRootFromParent_Done,
     /*  764413 */   // Label 11940: @764413
     /*  764413 */   GIM_Try, /*On fail goto*//*Label 11941*/ GIMT_Encode4(764491), // Rule ID 14348 //
     /*  764418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  764438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  764464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764489 */     GIR_RootConstrainSelectedInstOperands,
     /*  764490 */     // GIR_Coverage, 14348,
     /*  764490 */     GIR_EraseRootFromParent_Done,
     /*  764491 */   // Label 11941: @764491
     /*  764491 */   GIM_Try, /*On fail goto*//*Label 11942*/ GIMT_Encode4(764569), // Rule ID 14349 //
     /*  764496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  764507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  764516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764567 */     GIR_RootConstrainSelectedInstOperands,
     /*  764568 */     // GIR_Coverage, 14349,
     /*  764568 */     GIR_EraseRootFromParent_Done,
     /*  764569 */   // Label 11942: @764569
     /*  764569 */   GIM_Try, /*On fail goto*//*Label 11943*/ GIMT_Encode4(764647), // Rule ID 14352 //
     /*  764574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  764577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  764585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  764588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  764591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  764594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  764620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  764639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764645 */     GIR_RootConstrainSelectedInstOperands,
     /*  764646 */     // GIR_Coverage, 14352,
     /*  764646 */     GIR_EraseRootFromParent_Done,
     /*  764647 */   // Label 11943: @764647
     /*  764647 */   GIM_Try, /*On fail goto*//*Label 11944*/ GIMT_Encode4(764725), // Rule ID 14353 //
     /*  764652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  764655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  764663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  764666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  764669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  764672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764698 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  764698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  764717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764723 */     GIR_RootConstrainSelectedInstOperands,
     /*  764724 */     // GIR_Coverage, 14353,
     /*  764724 */     GIR_EraseRootFromParent_Done,
     /*  764725 */   // Label 11944: @764725
     /*  764725 */   GIM_Try, /*On fail goto*//*Label 11945*/ GIMT_Encode4(764803), // Rule ID 14356 //
     /*  764730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  764741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  764744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  764747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  764750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  764779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764801 */     GIR_RootConstrainSelectedInstOperands,
     /*  764802 */     // GIR_Coverage, 14356,
     /*  764802 */     GIR_EraseRootFromParent_Done,
     /*  764803 */   // Label 11945: @764803
     /*  764803 */   GIM_Try, /*On fail goto*//*Label 11946*/ GIMT_Encode4(764881), // Rule ID 14357 //
     /*  764808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  764819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  764822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  764825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  764828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764854 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  764857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764879 */     GIR_RootConstrainSelectedInstOperands,
     /*  764880 */     // GIR_Coverage, 14357,
     /*  764880 */     GIR_EraseRootFromParent_Done,
     /*  764881 */   // Label 11946: @764881
     /*  764881 */   GIM_Try, /*On fail goto*//*Label 11947*/ GIMT_Encode4(764959), // Rule ID 14360 //
     /*  764886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  764897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  764900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  764903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  764906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764932 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  764935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764957 */     GIR_RootConstrainSelectedInstOperands,
     /*  764958 */     // GIR_Coverage, 14360,
     /*  764958 */     GIR_EraseRootFromParent_Done,
     /*  764959 */   // Label 11947: @764959
     /*  764959 */   GIM_Try, /*On fail goto*//*Label 11948*/ GIMT_Encode4(765037), // Rule ID 14361 //
     /*  764964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  764975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  764978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  764981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  764984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765010 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765035 */     GIR_RootConstrainSelectedInstOperands,
     /*  765036 */     // GIR_Coverage, 14361,
     /*  765036 */     GIR_EraseRootFromParent_Done,
     /*  765037 */   // Label 11948: @765037
     /*  765037 */   GIM_Try, /*On fail goto*//*Label 11949*/ GIMT_Encode4(765115), // Rule ID 14364 //
     /*  765042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  765062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765088 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  765088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765113 */     GIR_RootConstrainSelectedInstOperands,
     /*  765114 */     // GIR_Coverage, 14364,
     /*  765114 */     GIR_EraseRootFromParent_Done,
     /*  765115 */   // Label 11949: @765115
     /*  765115 */   GIM_Try, /*On fail goto*//*Label 11950*/ GIMT_Encode4(765193), // Rule ID 14365 //
     /*  765120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  765131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  765134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  765137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  765140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765166 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  765166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  765185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765191 */     GIR_RootConstrainSelectedInstOperands,
     /*  765192 */     // GIR_Coverage, 14365,
     /*  765192 */     GIR_EraseRootFromParent_Done,
     /*  765193 */   // Label 11950: @765193
     /*  765193 */   GIM_Try, /*On fail goto*//*Label 11951*/ GIMT_Encode4(765271), // Rule ID 14368 //
     /*  765198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  765218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765269 */     GIR_RootConstrainSelectedInstOperands,
     /*  765270 */     // GIR_Coverage, 14368,
     /*  765270 */     GIR_EraseRootFromParent_Done,
     /*  765271 */   // Label 11951: @765271
     /*  765271 */   GIM_Try, /*On fail goto*//*Label 11952*/ GIMT_Encode4(765349), // Rule ID 14369 //
     /*  765276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  765287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  765290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  765293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  765296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765347 */     GIR_RootConstrainSelectedInstOperands,
     /*  765348 */     // GIR_Coverage, 14369,
     /*  765348 */     GIR_EraseRootFromParent_Done,
     /*  765349 */   // Label 11952: @765349
     /*  765349 */   GIM_Try, /*On fail goto*//*Label 11953*/ GIMT_Encode4(765427), // Rule ID 14372 //
     /*  765354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  765374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765425 */     GIR_RootConstrainSelectedInstOperands,
     /*  765426 */     // GIR_Coverage, 14372,
     /*  765426 */     GIR_EraseRootFromParent_Done,
     /*  765427 */   // Label 11953: @765427
     /*  765427 */   GIM_Try, /*On fail goto*//*Label 11954*/ GIMT_Encode4(765505), // Rule ID 14373 //
     /*  765432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  765443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  765446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  765449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  765452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765503 */     GIR_RootConstrainSelectedInstOperands,
     /*  765504 */     // GIR_Coverage, 14373,
     /*  765504 */     GIR_EraseRootFromParent_Done,
     /*  765505 */   // Label 11954: @765505
     /*  765505 */   GIM_Try, /*On fail goto*//*Label 11955*/ GIMT_Encode4(765583), // Rule ID 14376 //
     /*  765510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  765527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  765530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765581 */     GIR_RootConstrainSelectedInstOperands,
     /*  765582 */     // GIR_Coverage, 14376,
     /*  765582 */     GIR_EraseRootFromParent_Done,
     /*  765583 */   // Label 11955: @765583
     /*  765583 */   GIM_Try, /*On fail goto*//*Label 11956*/ GIMT_Encode4(765661), // Rule ID 14377 //
     /*  765588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  765605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  765608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765634 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765659 */     GIR_RootConstrainSelectedInstOperands,
     /*  765660 */     // GIR_Coverage, 14377,
     /*  765660 */     GIR_EraseRootFromParent_Done,
     /*  765661 */   // Label 11956: @765661
     /*  765661 */   GIM_Try, /*On fail goto*//*Label 11957*/ GIMT_Encode4(765739), // Rule ID 14380 //
     /*  765666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  765677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  765680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  765683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  765686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  765712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765737 */     GIR_RootConstrainSelectedInstOperands,
     /*  765738 */     // GIR_Coverage, 14380,
     /*  765738 */     GIR_EraseRootFromParent_Done,
     /*  765739 */   // Label 11957: @765739
     /*  765739 */   GIM_Try, /*On fail goto*//*Label 11958*/ GIMT_Encode4(765817), // Rule ID 14381 //
     /*  765744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  765755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  765758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  765761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  765764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  765790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765815 */     GIR_RootConstrainSelectedInstOperands,
     /*  765816 */     // GIR_Coverage, 14381,
     /*  765816 */     GIR_EraseRootFromParent_Done,
     /*  765817 */   // Label 11958: @765817
     /*  765817 */   GIM_Try, /*On fail goto*//*Label 11959*/ GIMT_Encode4(765895), // Rule ID 14384 //
     /*  765822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  765833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  765836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  765839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  765842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  765868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765893 */     GIR_RootConstrainSelectedInstOperands,
     /*  765894 */     // GIR_Coverage, 14384,
     /*  765894 */     GIR_EraseRootFromParent_Done,
     /*  765895 */   // Label 11959: @765895
     /*  765895 */   GIM_Try, /*On fail goto*//*Label 11960*/ GIMT_Encode4(765973), // Rule ID 14385 //
     /*  765900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  765911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  765914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  765917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  765920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  765946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765971 */     GIR_RootConstrainSelectedInstOperands,
     /*  765972 */     // GIR_Coverage, 14385,
     /*  765972 */     GIR_EraseRootFromParent_Done,
     /*  765973 */   // Label 11960: @765973
     /*  765973 */   GIM_Try, /*On fail goto*//*Label 11961*/ GIMT_Encode4(766051), // Rule ID 14388 //
     /*  765978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  765989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  765992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  765995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  765998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766049 */     GIR_RootConstrainSelectedInstOperands,
     /*  766050 */     // GIR_Coverage, 14388,
     /*  766050 */     GIR_EraseRootFromParent_Done,
     /*  766051 */   // Label 11961: @766051
     /*  766051 */   GIM_Try, /*On fail goto*//*Label 11962*/ GIMT_Encode4(766129), // Rule ID 14389 //
     /*  766056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  766067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  766070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  766073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  766076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766127 */     GIR_RootConstrainSelectedInstOperands,
     /*  766128 */     // GIR_Coverage, 14389,
     /*  766128 */     GIR_EraseRootFromParent_Done,
     /*  766129 */   // Label 11962: @766129
     /*  766129 */   GIM_Try, /*On fail goto*//*Label 11963*/ GIMT_Encode4(766207), // Rule ID 14392 //
     /*  766134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  766154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766180 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766205 */     GIR_RootConstrainSelectedInstOperands,
     /*  766206 */     // GIR_Coverage, 14392,
     /*  766206 */     GIR_EraseRootFromParent_Done,
     /*  766207 */   // Label 11963: @766207
     /*  766207 */   GIM_Try, /*On fail goto*//*Label 11964*/ GIMT_Encode4(766285), // Rule ID 14393 //
     /*  766212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  766223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  766226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  766229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  766232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  766251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  766261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766283 */     GIR_RootConstrainSelectedInstOperands,
     /*  766284 */     // GIR_Coverage, 14393,
     /*  766284 */     GIR_EraseRootFromParent_Done,
     /*  766285 */   // Label 11964: @766285
     /*  766285 */   GIM_Try, /*On fail goto*//*Label 11965*/ GIMT_Encode4(766363), // Rule ID 14396 //
     /*  766290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  766310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766361 */     GIR_RootConstrainSelectedInstOperands,
     /*  766362 */     // GIR_Coverage, 14396,
     /*  766362 */     GIR_EraseRootFromParent_Done,
     /*  766363 */   // Label 11965: @766363
     /*  766363 */   GIM_Try, /*On fail goto*//*Label 11966*/ GIMT_Encode4(766441), // Rule ID 14397 //
     /*  766368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  766379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  766382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  766385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  766388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  766407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766414 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  766417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766439 */     GIR_RootConstrainSelectedInstOperands,
     /*  766440 */     // GIR_Coverage, 14397,
     /*  766440 */     GIR_EraseRootFromParent_Done,
     /*  766441 */   // Label 11966: @766441
     /*  766441 */   GIM_Try, /*On fail goto*//*Label 11967*/ GIMT_Encode4(766519), // Rule ID 14400 //
     /*  766446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  766449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  766466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  766492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766517 */     GIR_RootConstrainSelectedInstOperands,
     /*  766518 */     // GIR_Coverage, 14400,
     /*  766518 */     GIR_EraseRootFromParent_Done,
     /*  766519 */   // Label 11967: @766519
     /*  766519 */   GIM_Try, /*On fail goto*//*Label 11968*/ GIMT_Encode4(766597), // Rule ID 14401 //
     /*  766524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  766544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766595 */     GIR_RootConstrainSelectedInstOperands,
     /*  766596 */     // GIR_Coverage, 14401,
     /*  766596 */     GIR_EraseRootFromParent_Done,
     /*  766597 */   // Label 11968: @766597
     /*  766597 */   GIM_Try, /*On fail goto*//*Label 11969*/ GIMT_Encode4(766675), // Rule ID 14404 //
     /*  766602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  766613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  766616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  766619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766648 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  766651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766673 */     GIR_RootConstrainSelectedInstOperands,
     /*  766674 */     // GIR_Coverage, 14404,
     /*  766674 */     GIR_EraseRootFromParent_Done,
     /*  766675 */   // Label 11969: @766675
     /*  766675 */   GIM_Try, /*On fail goto*//*Label 11970*/ GIMT_Encode4(766753), // Rule ID 14405 //
     /*  766680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  766691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  766694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  766697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  766726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  766729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766751 */     GIR_RootConstrainSelectedInstOperands,
     /*  766752 */     // GIR_Coverage, 14405,
     /*  766752 */     GIR_EraseRootFromParent_Done,
     /*  766753 */   // Label 11970: @766753
     /*  766753 */   GIM_Try, /*On fail goto*//*Label 11971*/ GIMT_Encode4(766831), // Rule ID 14408 //
     /*  766758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  766769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  766772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  766775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  766807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766829 */     GIR_RootConstrainSelectedInstOperands,
     /*  766830 */     // GIR_Coverage, 14408,
     /*  766830 */     GIR_EraseRootFromParent_Done,
     /*  766831 */   // Label 11971: @766831
     /*  766831 */   GIM_Try, /*On fail goto*//*Label 11972*/ GIMT_Encode4(766909), // Rule ID 14409 //
     /*  766836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  766847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  766850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  766853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766882 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  766882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  766885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766907 */     GIR_RootConstrainSelectedInstOperands,
     /*  766908 */     // GIR_Coverage, 14409,
     /*  766908 */     GIR_EraseRootFromParent_Done,
     /*  766909 */   // Label 11972: @766909
     /*  766909 */   GIM_Try, /*On fail goto*//*Label 11973*/ GIMT_Encode4(766987), // Rule ID 14412 //
     /*  766914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  766925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  766928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  766931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766960 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  766963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766985 */     GIR_RootConstrainSelectedInstOperands,
     /*  766986 */     // GIR_Coverage, 14412,
     /*  766986 */     GIR_EraseRootFromParent_Done,
     /*  766987 */   // Label 11973: @766987
     /*  766987 */   GIM_Try, /*On fail goto*//*Label 11974*/ GIMT_Encode4(767065), // Rule ID 14413 //
     /*  766992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  767003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  767006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  767009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767038 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767063 */     GIR_RootConstrainSelectedInstOperands,
     /*  767064 */     // GIR_Coverage, 14413,
     /*  767064 */     GIR_EraseRootFromParent_Done,
     /*  767065 */   // Label 11974: @767065
     /*  767065 */   GIM_Try, /*On fail goto*//*Label 11975*/ GIMT_Encode4(767143), // Rule ID 14416 //
     /*  767070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767141 */     GIR_RootConstrainSelectedInstOperands,
     /*  767142 */     // GIR_Coverage, 14416,
     /*  767142 */     GIR_EraseRootFromParent_Done,
     /*  767143 */   // Label 11975: @767143
     /*  767143 */   GIM_Try, /*On fail goto*//*Label 11976*/ GIMT_Encode4(767221), // Rule ID 14417 //
     /*  767148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  767159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  767162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  767165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  767197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767219 */     GIR_RootConstrainSelectedInstOperands,
     /*  767220 */     // GIR_Coverage, 14417,
     /*  767220 */     GIR_EraseRootFromParent_Done,
     /*  767221 */   // Label 11976: @767221
     /*  767221 */   GIM_Try, /*On fail goto*//*Label 11977*/ GIMT_Encode4(767299), // Rule ID 14420 //
     /*  767226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767272 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767297 */     GIR_RootConstrainSelectedInstOperands,
     /*  767298 */     // GIR_Coverage, 14420,
     /*  767298 */     GIR_EraseRootFromParent_Done,
     /*  767299 */   // Label 11977: @767299
     /*  767299 */   GIM_Try, /*On fail goto*//*Label 11978*/ GIMT_Encode4(767377), // Rule ID 14421 //
     /*  767304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  767315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  767318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  767321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767350 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767375 */     GIR_RootConstrainSelectedInstOperands,
     /*  767376 */     // GIR_Coverage, 14421,
     /*  767376 */     GIR_EraseRootFromParent_Done,
     /*  767377 */   // Label 11978: @767377
     /*  767377 */   GIM_Try, /*On fail goto*//*Label 11979*/ GIMT_Encode4(767455), // Rule ID 14424 //
     /*  767382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767428 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767453 */     GIR_RootConstrainSelectedInstOperands,
     /*  767454 */     // GIR_Coverage, 14424,
     /*  767454 */     GIR_EraseRootFromParent_Done,
     /*  767455 */   // Label 11979: @767455
     /*  767455 */   GIM_Try, /*On fail goto*//*Label 11980*/ GIMT_Encode4(767533), // Rule ID 14425 //
     /*  767460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  767471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  767474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  767477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767531 */     GIR_RootConstrainSelectedInstOperands,
     /*  767532 */     // GIR_Coverage, 14425,
     /*  767532 */     GIR_EraseRootFromParent_Done,
     /*  767533 */   // Label 11980: @767533
     /*  767533 */   GIM_Try, /*On fail goto*//*Label 11981*/ GIMT_Encode4(767611), // Rule ID 14428 //
     /*  767538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  767549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  767552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  767555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767584 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767609 */     GIR_RootConstrainSelectedInstOperands,
     /*  767610 */     // GIR_Coverage, 14428,
     /*  767610 */     GIR_EraseRootFromParent_Done,
     /*  767611 */   // Label 11981: @767611
     /*  767611 */   GIM_Try, /*On fail goto*//*Label 11982*/ GIMT_Encode4(767689), // Rule ID 14429 //
     /*  767616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  767627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  767630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  767633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767662 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767687 */     GIR_RootConstrainSelectedInstOperands,
     /*  767688 */     // GIR_Coverage, 14429,
     /*  767688 */     GIR_EraseRootFromParent_Done,
     /*  767689 */   // Label 11982: @767689
     /*  767689 */   GIM_Try, /*On fail goto*//*Label 11983*/ GIMT_Encode4(767767), // Rule ID 14432 //
     /*  767694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  767705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  767708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  767711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767765 */     GIR_RootConstrainSelectedInstOperands,
     /*  767766 */     // GIR_Coverage, 14432,
     /*  767766 */     GIR_EraseRootFromParent_Done,
     /*  767767 */   // Label 11983: @767767
     /*  767767 */   GIM_Try, /*On fail goto*//*Label 11984*/ GIMT_Encode4(767845), // Rule ID 14433 //
     /*  767772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  767783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  767786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  767789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767843 */     GIR_RootConstrainSelectedInstOperands,
     /*  767844 */     // GIR_Coverage, 14433,
     /*  767844 */     GIR_EraseRootFromParent_Done,
     /*  767845 */   // Label 11984: @767845
     /*  767845 */   GIM_Try, /*On fail goto*//*Label 11985*/ GIMT_Encode4(767923), // Rule ID 14436 //
     /*  767850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  767861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  767864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  767867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767896 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767921 */     GIR_RootConstrainSelectedInstOperands,
     /*  767922 */     // GIR_Coverage, 14436,
     /*  767922 */     GIR_EraseRootFromParent_Done,
     /*  767923 */   // Label 11985: @767923
     /*  767923 */   GIM_Try, /*On fail goto*//*Label 11986*/ GIMT_Encode4(768001), // Rule ID 14437 //
     /*  767928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  767939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  767942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  767945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767999 */     GIR_RootConstrainSelectedInstOperands,
     /*  768000 */     // GIR_Coverage, 14437,
     /*  768000 */     GIR_EraseRootFromParent_Done,
     /*  768001 */   // Label 11986: @768001
     /*  768001 */   GIM_Try, /*On fail goto*//*Label 11987*/ GIMT_Encode4(768079), // Rule ID 14440 //
     /*  768006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  768009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  768052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768077 */     GIR_RootConstrainSelectedInstOperands,
     /*  768078 */     // GIR_Coverage, 14440,
     /*  768078 */     GIR_EraseRootFromParent_Done,
     /*  768079 */   // Label 11987: @768079
     /*  768079 */   GIM_Try, /*On fail goto*//*Label 11988*/ GIMT_Encode4(768157), // Rule ID 14441 //
     /*  768084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  768087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  768095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  768098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  768101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  768119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768130 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  768130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  768133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  768149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768155 */     GIR_RootConstrainSelectedInstOperands,
     /*  768156 */     // GIR_Coverage, 14441,
     /*  768156 */     GIR_EraseRootFromParent_Done,
     /*  768157 */   // Label 11988: @768157
     /*  768157 */   GIM_Try, /*On fail goto*//*Label 11989*/ GIMT_Encode4(768235), // Rule ID 14444 //
     /*  768162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768233 */     GIR_RootConstrainSelectedInstOperands,
     /*  768234 */     // GIR_Coverage, 14444,
     /*  768234 */     GIR_EraseRootFromParent_Done,
     /*  768235 */   // Label 11989: @768235
     /*  768235 */   GIM_Try, /*On fail goto*//*Label 11990*/ GIMT_Encode4(768313), // Rule ID 14445 //
     /*  768240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  768251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  768254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  768257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768286 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768311 */     GIR_RootConstrainSelectedInstOperands,
     /*  768312 */     // GIR_Coverage, 14445,
     /*  768312 */     GIR_EraseRootFromParent_Done,
     /*  768313 */   // Label 11990: @768313
     /*  768313 */   GIM_Try, /*On fail goto*//*Label 11991*/ GIMT_Encode4(768391), // Rule ID 14448 //
     /*  768318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768364 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768389 */     GIR_RootConstrainSelectedInstOperands,
     /*  768390 */     // GIR_Coverage, 14448,
     /*  768390 */     GIR_EraseRootFromParent_Done,
     /*  768391 */   // Label 11991: @768391
     /*  768391 */   GIM_Try, /*On fail goto*//*Label 11992*/ GIMT_Encode4(768469), // Rule ID 14449 //
     /*  768396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  768407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  768410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  768413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768442 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768467 */     GIR_RootConstrainSelectedInstOperands,
     /*  768468 */     // GIR_Coverage, 14449,
     /*  768468 */     GIR_EraseRootFromParent_Done,
     /*  768469 */   // Label 11992: @768469
     /*  768469 */   GIM_Try, /*On fail goto*//*Label 11993*/ GIMT_Encode4(768547), // Rule ID 14452 //
     /*  768474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768520 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768545 */     GIR_RootConstrainSelectedInstOperands,
     /*  768546 */     // GIR_Coverage, 14452,
     /*  768546 */     GIR_EraseRootFromParent_Done,
     /*  768547 */   // Label 11993: @768547
     /*  768547 */   GIM_Try, /*On fail goto*//*Label 11994*/ GIMT_Encode4(768625), // Rule ID 14453 //
     /*  768552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768598 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768623 */     GIR_RootConstrainSelectedInstOperands,
     /*  768624 */     // GIR_Coverage, 14453,
     /*  768624 */     GIR_EraseRootFromParent_Done,
     /*  768625 */   // Label 11994: @768625
     /*  768625 */   GIM_Try, /*On fail goto*//*Label 11995*/ GIMT_Encode4(768703), // Rule ID 14456 //
     /*  768630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  768641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  768644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  768647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768701 */     GIR_RootConstrainSelectedInstOperands,
     /*  768702 */     // GIR_Coverage, 14456,
     /*  768702 */     GIR_EraseRootFromParent_Done,
     /*  768703 */   // Label 11995: @768703
     /*  768703 */   GIM_Try, /*On fail goto*//*Label 11996*/ GIMT_Encode4(768781), // Rule ID 14457 //
     /*  768708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  768719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  768722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  768725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768779 */     GIR_RootConstrainSelectedInstOperands,
     /*  768780 */     // GIR_Coverage, 14457,
     /*  768780 */     GIR_EraseRootFromParent_Done,
     /*  768781 */   // Label 11996: @768781
     /*  768781 */   GIM_Try, /*On fail goto*//*Label 11997*/ GIMT_Encode4(768859), // Rule ID 14460 //
     /*  768786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  768797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  768800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  768803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768832 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768857 */     GIR_RootConstrainSelectedInstOperands,
     /*  768858 */     // GIR_Coverage, 14460,
     /*  768858 */     GIR_EraseRootFromParent_Done,
     /*  768859 */   // Label 11997: @768859
     /*  768859 */   GIM_Try, /*On fail goto*//*Label 11998*/ GIMT_Encode4(768937), // Rule ID 14461 //
     /*  768864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  768875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  768878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  768881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768910 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768935 */     GIR_RootConstrainSelectedInstOperands,
     /*  768936 */     // GIR_Coverage, 14461,
     /*  768936 */     GIR_EraseRootFromParent_Done,
     /*  768937 */   // Label 11998: @768937
     /*  768937 */   GIM_Try, /*On fail goto*//*Label 11999*/ GIMT_Encode4(769015), // Rule ID 14464 //
     /*  768942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  768953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  768956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  768959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768988 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769013 */     GIR_RootConstrainSelectedInstOperands,
     /*  769014 */     // GIR_Coverage, 14464,
     /*  769014 */     GIR_EraseRootFromParent_Done,
     /*  769015 */   // Label 11999: @769015
     /*  769015 */   GIM_Try, /*On fail goto*//*Label 12000*/ GIMT_Encode4(769093), // Rule ID 14465 //
     /*  769020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  769031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  769034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  769037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769066 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  769066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  769085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769091 */     GIR_RootConstrainSelectedInstOperands,
     /*  769092 */     // GIR_Coverage, 14465,
     /*  769092 */     GIR_EraseRootFromParent_Done,
     /*  769093 */   // Label 12000: @769093
     /*  769093 */   GIM_Try, /*On fail goto*//*Label 12001*/ GIMT_Encode4(769171), // Rule ID 14468 //
     /*  769098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769169 */     GIR_RootConstrainSelectedInstOperands,
     /*  769170 */     // GIR_Coverage, 14468,
     /*  769170 */     GIR_EraseRootFromParent_Done,
     /*  769171 */   // Label 12001: @769171
     /*  769171 */   GIM_Try, /*On fail goto*//*Label 12002*/ GIMT_Encode4(769249), // Rule ID 14469 //
     /*  769176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  769187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  769190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  769193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769222 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769247 */     GIR_RootConstrainSelectedInstOperands,
     /*  769248 */     // GIR_Coverage, 14469,
     /*  769248 */     GIR_EraseRootFromParent_Done,
     /*  769249 */   // Label 12002: @769249
     /*  769249 */   GIM_Try, /*On fail goto*//*Label 12003*/ GIMT_Encode4(769327), // Rule ID 14472 //
     /*  769254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769300 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769325 */     GIR_RootConstrainSelectedInstOperands,
     /*  769326 */     // GIR_Coverage, 14472,
     /*  769326 */     GIR_EraseRootFromParent_Done,
     /*  769327 */   // Label 12003: @769327
     /*  769327 */   GIM_Try, /*On fail goto*//*Label 12004*/ GIMT_Encode4(769405), // Rule ID 14473 //
     /*  769332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  769343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  769346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  769349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769378 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769403 */     GIR_RootConstrainSelectedInstOperands,
     /*  769404 */     // GIR_Coverage, 14473,
     /*  769404 */     GIR_EraseRootFromParent_Done,
     /*  769405 */   // Label 12004: @769405
     /*  769405 */   GIM_Try, /*On fail goto*//*Label 12005*/ GIMT_Encode4(769483), // Rule ID 14476 //
     /*  769410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  769456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769481 */     GIR_RootConstrainSelectedInstOperands,
     /*  769482 */     // GIR_Coverage, 14476,
     /*  769482 */     GIR_EraseRootFromParent_Done,
     /*  769483 */   // Label 12005: @769483
     /*  769483 */   GIM_Try, /*On fail goto*//*Label 12006*/ GIMT_Encode4(769561), // Rule ID 14477 //
     /*  769488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  769499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  769502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  769505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769559 */     GIR_RootConstrainSelectedInstOperands,
     /*  769560 */     // GIR_Coverage, 14477,
     /*  769560 */     GIR_EraseRootFromParent_Done,
     /*  769561 */   // Label 12006: @769561
     /*  769561 */   GIM_Try, /*On fail goto*//*Label 12007*/ GIMT_Encode4(769639), // Rule ID 14480 //
     /*  769566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  769577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  769580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  769583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769612 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  769612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769637 */     GIR_RootConstrainSelectedInstOperands,
     /*  769638 */     // GIR_Coverage, 14480,
     /*  769638 */     GIR_EraseRootFromParent_Done,
     /*  769639 */   // Label 12007: @769639
     /*  769639 */   GIM_Try, /*On fail goto*//*Label 12008*/ GIMT_Encode4(769717), // Rule ID 14481 //
     /*  769644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  769647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  769655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  769658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  769661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  769690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769715 */     GIR_RootConstrainSelectedInstOperands,
     /*  769716 */     // GIR_Coverage, 14481,
     /*  769716 */     GIR_EraseRootFromParent_Done,
     /*  769717 */   // Label 12008: @769717
     /*  769717 */   GIM_Try, /*On fail goto*//*Label 12009*/ GIMT_Encode4(769795), // Rule ID 14484 //
     /*  769722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  769733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  769736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  769739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  769768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769793 */     GIR_RootConstrainSelectedInstOperands,
     /*  769794 */     // GIR_Coverage, 14484,
     /*  769794 */     GIR_EraseRootFromParent_Done,
     /*  769795 */   // Label 12009: @769795
     /*  769795 */   GIM_Try, /*On fail goto*//*Label 12010*/ GIMT_Encode4(769873), // Rule ID 14485 //
     /*  769800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  769803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  769811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  769814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  769817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  769846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769871 */     GIR_RootConstrainSelectedInstOperands,
     /*  769872 */     // GIR_Coverage, 14485,
     /*  769872 */     GIR_EraseRootFromParent_Done,
     /*  769873 */   // Label 12010: @769873
     /*  769873 */   GIM_Try, /*On fail goto*//*Label 12011*/ GIMT_Encode4(769951), // Rule ID 14488 //
     /*  769878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  769889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  769892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  769895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769924 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  769924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769949 */     GIR_RootConstrainSelectedInstOperands,
     /*  769950 */     // GIR_Coverage, 14488,
     /*  769950 */     GIR_EraseRootFromParent_Done,
     /*  769951 */   // Label 12011: @769951
     /*  769951 */   GIM_Try, /*On fail goto*//*Label 12012*/ GIMT_Encode4(770029), // Rule ID 14489 //
     /*  769956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  769959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  769967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  769970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  769973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770002 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  770002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  770005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770027 */     GIR_RootConstrainSelectedInstOperands,
     /*  770028 */     // GIR_Coverage, 14489,
     /*  770028 */     GIR_EraseRootFromParent_Done,
     /*  770029 */   // Label 12012: @770029
     /*  770029 */   GIM_Try, /*On fail goto*//*Label 12013*/ GIMT_Encode4(770107), // Rule ID 14580 //
     /*  770034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  770054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  770083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770105 */     GIR_RootConstrainSelectedInstOperands,
     /*  770106 */     // GIR_Coverage, 14580,
     /*  770106 */     GIR_EraseRootFromParent_Done,
     /*  770107 */   // Label 12013: @770107
     /*  770107 */   GIM_Try, /*On fail goto*//*Label 12014*/ GIMT_Encode4(770185), // Rule ID 14581 //
     /*  770112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  770123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  770126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  770129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  770132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770158 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  770161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770183 */     GIR_RootConstrainSelectedInstOperands,
     /*  770184 */     // GIR_Coverage, 14581,
     /*  770184 */     GIR_EraseRootFromParent_Done,
     /*  770185 */   // Label 12014: @770185
     /*  770185 */   GIM_Try, /*On fail goto*//*Label 12015*/ GIMT_Encode4(770263), // Rule ID 14584 //
     /*  770190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  770210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770236 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770258 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770261 */     GIR_RootConstrainSelectedInstOperands,
     /*  770262 */     // GIR_Coverage, 14584,
     /*  770262 */     GIR_EraseRootFromParent_Done,
     /*  770263 */   // Label 12015: @770263
     /*  770263 */   GIM_Try, /*On fail goto*//*Label 12016*/ GIMT_Encode4(770341), // Rule ID 14585 //
     /*  770268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  770279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  770282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  770285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  770288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770339 */     GIR_RootConstrainSelectedInstOperands,
     /*  770340 */     // GIR_Coverage, 14585,
     /*  770340 */     GIR_EraseRootFromParent_Done,
     /*  770341 */   // Label 12016: @770341
     /*  770341 */   GIM_Try, /*On fail goto*//*Label 12017*/ GIMT_Encode4(770419), // Rule ID 14588 //
     /*  770346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  770366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770392 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770417 */     GIR_RootConstrainSelectedInstOperands,
     /*  770418 */     // GIR_Coverage, 14588,
     /*  770418 */     GIR_EraseRootFromParent_Done,
     /*  770419 */   // Label 12017: @770419
     /*  770419 */   GIM_Try, /*On fail goto*//*Label 12018*/ GIMT_Encode4(770497), // Rule ID 14589 //
     /*  770424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  770435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  770438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  770441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  770444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770495 */     GIR_RootConstrainSelectedInstOperands,
     /*  770496 */     // GIR_Coverage, 14589,
     /*  770496 */     GIR_EraseRootFromParent_Done,
     /*  770497 */   // Label 12018: @770497
     /*  770497 */   GIM_Try, /*On fail goto*//*Label 12019*/ GIMT_Encode4(770575), // Rule ID 14592 //
     /*  770502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770548 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770573 */     GIR_RootConstrainSelectedInstOperands,
     /*  770574 */     // GIR_Coverage, 14592,
     /*  770574 */     GIR_EraseRootFromParent_Done,
     /*  770575 */   // Label 12019: @770575
     /*  770575 */   GIM_Try, /*On fail goto*//*Label 12020*/ GIMT_Encode4(770653), // Rule ID 14593 //
     /*  770580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770651 */     GIR_RootConstrainSelectedInstOperands,
     /*  770652 */     // GIR_Coverage, 14593,
     /*  770652 */     GIR_EraseRootFromParent_Done,
     /*  770653 */   // Label 12020: @770653
     /*  770653 */   GIM_Try, /*On fail goto*//*Label 12021*/ GIMT_Encode4(770731), // Rule ID 14596 //
     /*  770658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  770669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  770672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  770675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  770678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770704 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770729 */     GIR_RootConstrainSelectedInstOperands,
     /*  770730 */     // GIR_Coverage, 14596,
     /*  770730 */     GIR_EraseRootFromParent_Done,
     /*  770731 */   // Label 12021: @770731
     /*  770731 */   GIM_Try, /*On fail goto*//*Label 12022*/ GIMT_Encode4(770809), // Rule ID 14597 //
     /*  770736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  770747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  770750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  770753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  770756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770782 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770807 */     GIR_RootConstrainSelectedInstOperands,
     /*  770808 */     // GIR_Coverage, 14597,
     /*  770808 */     GIR_EraseRootFromParent_Done,
     /*  770809 */   // Label 12022: @770809
     /*  770809 */   GIM_Try, /*On fail goto*//*Label 12023*/ GIMT_Encode4(770887), // Rule ID 14600 //
     /*  770814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  770825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  770828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  770831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  770834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  770860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770885 */     GIR_RootConstrainSelectedInstOperands,
     /*  770886 */     // GIR_Coverage, 14600,
     /*  770886 */     GIR_EraseRootFromParent_Done,
     /*  770887 */   // Label 12023: @770887
     /*  770887 */   GIM_Try, /*On fail goto*//*Label 12024*/ GIMT_Encode4(770965), // Rule ID 14601 //
     /*  770892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  770903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  770906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  770909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  770912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770938 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  770938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770963 */     GIR_RootConstrainSelectedInstOperands,
     /*  770964 */     // GIR_Coverage, 14601,
     /*  770964 */     GIR_EraseRootFromParent_Done,
     /*  770965 */   // Label 12024: @770965
     /*  770965 */   GIM_Try, /*On fail goto*//*Label 12025*/ GIMT_Encode4(771043), // Rule ID 14604 //
     /*  770970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  770981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  770984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  770987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  770990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771016 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771041 */     GIR_RootConstrainSelectedInstOperands,
     /*  771042 */     // GIR_Coverage, 14604,
     /*  771042 */     GIR_EraseRootFromParent_Done,
     /*  771043 */   // Label 12025: @771043
     /*  771043 */   GIM_Try, /*On fail goto*//*Label 12026*/ GIMT_Encode4(771121), // Rule ID 14605 //
     /*  771048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  771059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  771062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  771065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  771068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771094 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771119 */     GIR_RootConstrainSelectedInstOperands,
     /*  771120 */     // GIR_Coverage, 14605,
     /*  771120 */     GIR_EraseRootFromParent_Done,
     /*  771121 */   // Label 12026: @771121
     /*  771121 */   GIM_Try, /*On fail goto*//*Label 12027*/ GIMT_Encode4(771199), // Rule ID 14608 //
     /*  771126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771197 */     GIR_RootConstrainSelectedInstOperands,
     /*  771198 */     // GIR_Coverage, 14608,
     /*  771198 */     GIR_EraseRootFromParent_Done,
     /*  771199 */   // Label 12027: @771199
     /*  771199 */   GIM_Try, /*On fail goto*//*Label 12028*/ GIMT_Encode4(771277), // Rule ID 14609 //
     /*  771204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  771215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  771218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  771221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  771224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771275 */     GIR_RootConstrainSelectedInstOperands,
     /*  771276 */     // GIR_Coverage, 14609,
     /*  771276 */     GIR_EraseRootFromParent_Done,
     /*  771277 */   // Label 12028: @771277
     /*  771277 */   GIM_Try, /*On fail goto*//*Label 12029*/ GIMT_Encode4(771355), // Rule ID 14612 //
     /*  771282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  771302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771328 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  771328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771353 */     GIR_RootConstrainSelectedInstOperands,
     /*  771354 */     // GIR_Coverage, 14612,
     /*  771354 */     GIR_EraseRootFromParent_Done,
     /*  771355 */   // Label 12029: @771355
     /*  771355 */   GIM_Try, /*On fail goto*//*Label 12030*/ GIMT_Encode4(771433), // Rule ID 14613 //
     /*  771360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  771371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  771374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  771377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  771380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  771406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  771425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771431 */     GIR_RootConstrainSelectedInstOperands,
     /*  771432 */     // GIR_Coverage, 14613,
     /*  771432 */     GIR_EraseRootFromParent_Done,
     /*  771433 */   // Label 12030: @771433
     /*  771433 */   GIM_Try, /*On fail goto*//*Label 12031*/ GIMT_Encode4(771511), // Rule ID 14616 //
     /*  771438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  771441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  771458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  771484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771509 */     GIR_RootConstrainSelectedInstOperands,
     /*  771510 */     // GIR_Coverage, 14616,
     /*  771510 */     GIR_EraseRootFromParent_Done,
     /*  771511 */   // Label 12031: @771511
     /*  771511 */   GIM_Try, /*On fail goto*//*Label 12032*/ GIMT_Encode4(771589), // Rule ID 14617 //
     /*  771516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  771519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  771536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771562 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  771562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771587 */     GIR_RootConstrainSelectedInstOperands,
     /*  771588 */     // GIR_Coverage, 14617,
     /*  771588 */     GIR_EraseRootFromParent_Done,
     /*  771589 */   // Label 12032: @771589
     /*  771589 */   GIM_Try, /*On fail goto*//*Label 12033*/ GIMT_Encode4(771667), // Rule ID 14620 //
     /*  771594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  771605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  771608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  771611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  771614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771640 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  771643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771665 */     GIR_RootConstrainSelectedInstOperands,
     /*  771666 */     // GIR_Coverage, 14620,
     /*  771666 */     GIR_EraseRootFromParent_Done,
     /*  771667 */   // Label 12033: @771667
     /*  771667 */   GIM_Try, /*On fail goto*//*Label 12034*/ GIMT_Encode4(771745), // Rule ID 14621 //
     /*  771672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  771683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  771686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  771689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  771692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  771721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771743 */     GIR_RootConstrainSelectedInstOperands,
     /*  771744 */     // GIR_Coverage, 14621,
     /*  771744 */     GIR_EraseRootFromParent_Done,
     /*  771745 */   // Label 12034: @771745
     /*  771745 */   GIM_Try, /*On fail goto*//*Label 12035*/ GIMT_Encode4(771823), // Rule ID 14624 //
     /*  771750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  771761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  771764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  771767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  771770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771796 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  771799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771821 */     GIR_RootConstrainSelectedInstOperands,
     /*  771822 */     // GIR_Coverage, 14624,
     /*  771822 */     GIR_EraseRootFromParent_Done,
     /*  771823 */   // Label 12035: @771823
     /*  771823 */   GIM_Try, /*On fail goto*//*Label 12036*/ GIMT_Encode4(771901), // Rule ID 14625 //
     /*  771828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  771839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  771842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  771845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  771848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771874 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  771877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771899 */     GIR_RootConstrainSelectedInstOperands,
     /*  771900 */     // GIR_Coverage, 14625,
     /*  771900 */     GIR_EraseRootFromParent_Done,
     /*  771901 */   // Label 12036: @771901
     /*  771901 */   GIM_Try, /*On fail goto*//*Label 12037*/ GIMT_Encode4(771979), // Rule ID 14628 //
     /*  771906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  771917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  771920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  771923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  771926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771952 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  771955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771974 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771977 */     GIR_RootConstrainSelectedInstOperands,
     /*  771978 */     // GIR_Coverage, 14628,
     /*  771978 */     GIR_EraseRootFromParent_Done,
     /*  771979 */   // Label 12037: @771979
     /*  771979 */   GIM_Try, /*On fail goto*//*Label 12038*/ GIMT_Encode4(772057), // Rule ID 14629 //
     /*  771984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  771995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  771998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  772001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  772004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772030 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  772030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  772049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772055 */     GIR_RootConstrainSelectedInstOperands,
     /*  772056 */     // GIR_Coverage, 14629,
     /*  772056 */     GIR_EraseRootFromParent_Done,
     /*  772057 */   // Label 12038: @772057
     /*  772057 */   GIM_Try, /*On fail goto*//*Label 12039*/ GIMT_Encode4(772135), // Rule ID 14632 //
     /*  772062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  772082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772108 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772133 */     GIR_RootConstrainSelectedInstOperands,
     /*  772134 */     // GIR_Coverage, 14632,
     /*  772134 */     GIR_EraseRootFromParent_Done,
     /*  772135 */   // Label 12039: @772135
     /*  772135 */   GIM_Try, /*On fail goto*//*Label 12040*/ GIMT_Encode4(772213), // Rule ID 14633 //
     /*  772140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  772151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  772154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  772157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  772160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772211 */     GIR_RootConstrainSelectedInstOperands,
     /*  772212 */     // GIR_Coverage, 14633,
     /*  772212 */     GIR_EraseRootFromParent_Done,
     /*  772213 */   // Label 12040: @772213
     /*  772213 */   GIM_Try, /*On fail goto*//*Label 12041*/ GIMT_Encode4(772291), // Rule ID 14636 //
     /*  772218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  772238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772289 */     GIR_RootConstrainSelectedInstOperands,
     /*  772290 */     // GIR_Coverage, 14636,
     /*  772290 */     GIR_EraseRootFromParent_Done,
     /*  772291 */   // Label 12041: @772291
     /*  772291 */   GIM_Try, /*On fail goto*//*Label 12042*/ GIMT_Encode4(772369), // Rule ID 14637 //
     /*  772296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  772307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  772310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  772313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  772316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772342 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772367 */     GIR_RootConstrainSelectedInstOperands,
     /*  772368 */     // GIR_Coverage, 14637,
     /*  772368 */     GIR_EraseRootFromParent_Done,
     /*  772369 */   // Label 12042: @772369
     /*  772369 */   GIM_Try, /*On fail goto*//*Label 12043*/ GIMT_Encode4(772447), // Rule ID 14640 //
     /*  772374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  772394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772420 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  772420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772445 */     GIR_RootConstrainSelectedInstOperands,
     /*  772446 */     // GIR_Coverage, 14640,
     /*  772446 */     GIR_EraseRootFromParent_Done,
     /*  772447 */   // Label 12043: @772447
     /*  772447 */   GIM_Try, /*On fail goto*//*Label 12044*/ GIMT_Encode4(772525), // Rule ID 14641 //
     /*  772452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  772463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  772466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  772469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  772472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  772498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772523 */     GIR_RootConstrainSelectedInstOperands,
     /*  772524 */     // GIR_Coverage, 14641,
     /*  772524 */     GIR_EraseRootFromParent_Done,
     /*  772525 */   // Label 12044: @772525
     /*  772525 */   GIM_Try, /*On fail goto*//*Label 12045*/ GIMT_Encode4(772603), // Rule ID 14644 //
     /*  772530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  772550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772598 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772601 */     GIR_RootConstrainSelectedInstOperands,
     /*  772602 */     // GIR_Coverage, 14644,
     /*  772602 */     GIR_EraseRootFromParent_Done,
     /*  772603 */   // Label 12045: @772603
     /*  772603 */   GIM_Try, /*On fail goto*//*Label 12046*/ GIMT_Encode4(772681), // Rule ID 14645 //
     /*  772608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  772628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772654 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772679 */     GIR_RootConstrainSelectedInstOperands,
     /*  772680 */     // GIR_Coverage, 14645,
     /*  772680 */     GIR_EraseRootFromParent_Done,
     /*  772681 */   // Label 12046: @772681
     /*  772681 */   GIM_Try, /*On fail goto*//*Label 12047*/ GIMT_Encode4(772759), // Rule ID 14648 //
     /*  772686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  772697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  772700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  772703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  772706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772732 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772757 */     GIR_RootConstrainSelectedInstOperands,
     /*  772758 */     // GIR_Coverage, 14648,
     /*  772758 */     GIR_EraseRootFromParent_Done,
     /*  772759 */   // Label 12047: @772759
     /*  772759 */   GIM_Try, /*On fail goto*//*Label 12048*/ GIMT_Encode4(772837), // Rule ID 14649 //
     /*  772764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  772775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  772778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  772781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  772784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772810 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772835 */     GIR_RootConstrainSelectedInstOperands,
     /*  772836 */     // GIR_Coverage, 14649,
     /*  772836 */     GIR_EraseRootFromParent_Done,
     /*  772837 */   // Label 12048: @772837
     /*  772837 */   GIM_Try, /*On fail goto*//*Label 12049*/ GIMT_Encode4(772915), // Rule ID 14652 //
     /*  772842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  772853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  772856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  772859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  772862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772888 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772913 */     GIR_RootConstrainSelectedInstOperands,
     /*  772914 */     // GIR_Coverage, 14652,
     /*  772914 */     GIR_EraseRootFromParent_Done,
     /*  772915 */   // Label 12049: @772915
     /*  772915 */   GIM_Try, /*On fail goto*//*Label 12050*/ GIMT_Encode4(772993), // Rule ID 14653 //
     /*  772920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  772931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  772934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  772937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  772940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772991 */     GIR_RootConstrainSelectedInstOperands,
     /*  772992 */     // GIR_Coverage, 14653,
     /*  772992 */     GIR_EraseRootFromParent_Done,
     /*  772993 */   // Label 12050: @772993
     /*  772993 */   GIM_Try, /*On fail goto*//*Label 12051*/ GIMT_Encode4(773071), // Rule ID 14656 //
     /*  772998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  773018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773069 */     GIR_RootConstrainSelectedInstOperands,
     /*  773070 */     // GIR_Coverage, 14656,
     /*  773070 */     GIR_EraseRootFromParent_Done,
     /*  773071 */   // Label 12051: @773071
     /*  773071 */   GIM_Try, /*On fail goto*//*Label 12052*/ GIMT_Encode4(773149), // Rule ID 14657 //
     /*  773076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  773087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  773090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  773093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  773096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  773115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  773125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773147 */     GIR_RootConstrainSelectedInstOperands,
     /*  773148 */     // GIR_Coverage, 14657,
     /*  773148 */     GIR_EraseRootFromParent_Done,
     /*  773149 */   // Label 12052: @773149
     /*  773149 */   GIM_Try, /*On fail goto*//*Label 12053*/ GIMT_Encode4(773227), // Rule ID 14660 //
     /*  773154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  773174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773200 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773225 */     GIR_RootConstrainSelectedInstOperands,
     /*  773226 */     // GIR_Coverage, 14660,
     /*  773226 */     GIR_EraseRootFromParent_Done,
     /*  773227 */   // Label 12053: @773227
     /*  773227 */   GIM_Try, /*On fail goto*//*Label 12054*/ GIMT_Encode4(773305), // Rule ID 14661 //
     /*  773232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  773243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  773246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  773249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  773252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  773271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773278 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  773281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773303 */     GIR_RootConstrainSelectedInstOperands,
     /*  773304 */     // GIR_Coverage, 14661,
     /*  773304 */     GIR_EraseRootFromParent_Done,
     /*  773305 */   // Label 12054: @773305
     /*  773305 */   GIM_Try, /*On fail goto*//*Label 12055*/ GIMT_Encode4(773383), // Rule ID 14664 //
     /*  773310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  773313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773356 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  773356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773381 */     GIR_RootConstrainSelectedInstOperands,
     /*  773382 */     // GIR_Coverage, 14664,
     /*  773382 */     GIR_EraseRootFromParent_Done,
     /*  773383 */   // Label 12055: @773383
     /*  773383 */   GIM_Try, /*On fail goto*//*Label 12056*/ GIMT_Encode4(773461), // Rule ID 14665 //
     /*  773388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  773391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  773399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  773402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  773405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  773408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  773427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  773434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  773437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  773453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773459 */     GIR_RootConstrainSelectedInstOperands,
     /*  773460 */     // GIR_Coverage, 14665,
     /*  773460 */     GIR_EraseRootFromParent_Done,
     /*  773461 */   // Label 12056: @773461
     /*  773461 */   GIM_Try, /*On fail goto*//*Label 12057*/ GIMT_Encode4(773539), // Rule ID 14668 //
     /*  773466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  773515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773537 */     GIR_RootConstrainSelectedInstOperands,
     /*  773538 */     // GIR_Coverage, 14668,
     /*  773538 */     GIR_EraseRootFromParent_Done,
     /*  773539 */   // Label 12057: @773539
     /*  773539 */   GIM_Try, /*On fail goto*//*Label 12058*/ GIMT_Encode4(773617), // Rule ID 14669 //
     /*  773544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773590 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  773590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  773593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773615 */     GIR_RootConstrainSelectedInstOperands,
     /*  773616 */     // GIR_Coverage, 14669,
     /*  773616 */     GIR_EraseRootFromParent_Done,
     /*  773617 */   // Label 12058: @773617
     /*  773617 */   GIM_Try, /*On fail goto*//*Label 12059*/ GIMT_Encode4(773695), // Rule ID 14672 //
     /*  773622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  773633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  773636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  773639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773668 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773693 */     GIR_RootConstrainSelectedInstOperands,
     /*  773694 */     // GIR_Coverage, 14672,
     /*  773694 */     GIR_EraseRootFromParent_Done,
     /*  773695 */   // Label 12059: @773695
     /*  773695 */   GIM_Try, /*On fail goto*//*Label 12060*/ GIMT_Encode4(773773), // Rule ID 14673 //
     /*  773700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  773711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  773714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  773717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773746 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  773746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773771 */     GIR_RootConstrainSelectedInstOperands,
     /*  773772 */     // GIR_Coverage, 14673,
     /*  773772 */     GIR_EraseRootFromParent_Done,
     /*  773773 */   // Label 12060: @773773
     /*  773773 */   GIM_Try, /*On fail goto*//*Label 12061*/ GIMT_Encode4(773851), // Rule ID 14676 //
     /*  773778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  773789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  773792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  773795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773824 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773849 */     GIR_RootConstrainSelectedInstOperands,
     /*  773850 */     // GIR_Coverage, 14676,
     /*  773850 */     GIR_EraseRootFromParent_Done,
     /*  773851 */   // Label 12061: @773851
     /*  773851 */   GIM_Try, /*On fail goto*//*Label 12062*/ GIMT_Encode4(773929), // Rule ID 14677 //
     /*  773856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  773867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  773870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  773873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773902 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  773902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773927 */     GIR_RootConstrainSelectedInstOperands,
     /*  773928 */     // GIR_Coverage, 14677,
     /*  773928 */     GIR_EraseRootFromParent_Done,
     /*  773929 */   // Label 12062: @773929
     /*  773929 */   GIM_Try, /*On fail goto*//*Label 12063*/ GIMT_Encode4(774007), // Rule ID 14680 //
     /*  773934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  773945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  773948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  773951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773980 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  773980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  773999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774005 */     GIR_RootConstrainSelectedInstOperands,
     /*  774006 */     // GIR_Coverage, 14680,
     /*  774006 */     GIR_EraseRootFromParent_Done,
     /*  774007 */   // Label 12063: @774007
     /*  774007 */   GIM_Try, /*On fail goto*//*Label 12064*/ GIMT_Encode4(774085), // Rule ID 14681 //
     /*  774012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  774023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  774026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  774029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774058 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  774061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774083 */     GIR_RootConstrainSelectedInstOperands,
     /*  774084 */     // GIR_Coverage, 14681,
     /*  774084 */     GIR_EraseRootFromParent_Done,
     /*  774085 */   // Label 12064: @774085
     /*  774085 */   GIM_Try, /*On fail goto*//*Label 12065*/ GIMT_Encode4(774163), // Rule ID 14684 //
     /*  774090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774136 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774161 */     GIR_RootConstrainSelectedInstOperands,
     /*  774162 */     // GIR_Coverage, 14684,
     /*  774162 */     GIR_EraseRootFromParent_Done,
     /*  774163 */   // Label 12065: @774163
     /*  774163 */   GIM_Try, /*On fail goto*//*Label 12066*/ GIMT_Encode4(774241), // Rule ID 14685 //
     /*  774168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  774179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  774182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  774185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774214 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774239 */     GIR_RootConstrainSelectedInstOperands,
     /*  774240 */     // GIR_Coverage, 14685,
     /*  774240 */     GIR_EraseRootFromParent_Done,
     /*  774241 */   // Label 12066: @774241
     /*  774241 */   GIM_Try, /*On fail goto*//*Label 12067*/ GIMT_Encode4(774319), // Rule ID 14688 //
     /*  774246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774292 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774314 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774317 */     GIR_RootConstrainSelectedInstOperands,
     /*  774318 */     // GIR_Coverage, 14688,
     /*  774318 */     GIR_EraseRootFromParent_Done,
     /*  774319 */   // Label 12067: @774319
     /*  774319 */   GIM_Try, /*On fail goto*//*Label 12068*/ GIMT_Encode4(774397), // Rule ID 14689 //
     /*  774324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  774335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  774338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  774341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  774373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774395 */     GIR_RootConstrainSelectedInstOperands,
     /*  774396 */     // GIR_Coverage, 14689,
     /*  774396 */     GIR_EraseRootFromParent_Done,
     /*  774397 */   // Label 12068: @774397
     /*  774397 */   GIM_Try, /*On fail goto*//*Label 12069*/ GIMT_Encode4(774475), // Rule ID 14692 //
     /*  774402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774448 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774473 */     GIR_RootConstrainSelectedInstOperands,
     /*  774474 */     // GIR_Coverage, 14692,
     /*  774474 */     GIR_EraseRootFromParent_Done,
     /*  774475 */   // Label 12069: @774475
     /*  774475 */   GIM_Try, /*On fail goto*//*Label 12070*/ GIMT_Encode4(774553), // Rule ID 14693 //
     /*  774480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  774491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  774494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  774497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774526 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11619:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774551 */     GIR_RootConstrainSelectedInstOperands,
     /*  774552 */     // GIR_Coverage, 14693,
     /*  774552 */     GIR_EraseRootFromParent_Done,
     /*  774553 */   // Label 12070: @774553
     /*  774553 */   GIM_Try, /*On fail goto*//*Label 12071*/ GIMT_Encode4(774631), // Rule ID 14696 //
     /*  774558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774629 */     GIR_RootConstrainSelectedInstOperands,
     /*  774630 */     // GIR_Coverage, 14696,
     /*  774630 */     GIR_EraseRootFromParent_Done,
     /*  774631 */   // Label 12071: @774631
     /*  774631 */   GIM_Try, /*On fail goto*//*Label 12072*/ GIMT_Encode4(774709), // Rule ID 14697 //
     /*  774636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11619:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774707 */     GIR_RootConstrainSelectedInstOperands,
     /*  774708 */     // GIR_Coverage, 14697,
     /*  774708 */     GIR_EraseRootFromParent_Done,
     /*  774709 */   // Label 12072: @774709
     /*  774709 */   GIM_Try, /*On fail goto*//*Label 12073*/ GIMT_Encode4(774787), // Rule ID 14700 //
     /*  774714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  774725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  774728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  774731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774785 */     GIR_RootConstrainSelectedInstOperands,
     /*  774786 */     // GIR_Coverage, 14700,
     /*  774786 */     GIR_EraseRootFromParent_Done,
     /*  774787 */   // Label 12073: @774787
     /*  774787 */   GIM_Try, /*On fail goto*//*Label 12074*/ GIMT_Encode4(774865), // Rule ID 14701 //
     /*  774792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  774803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  774806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  774809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11619:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774863 */     GIR_RootConstrainSelectedInstOperands,
     /*  774864 */     // GIR_Coverage, 14701,
     /*  774864 */     GIR_EraseRootFromParent_Done,
     /*  774865 */   // Label 12074: @774865
     /*  774865 */   GIM_Try, /*On fail goto*//*Label 12075*/ GIMT_Encode4(774943), // Rule ID 14704 //
     /*  774870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  774873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  774881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  774884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  774887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  774916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774938 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774941 */     GIR_RootConstrainSelectedInstOperands,
     /*  774942 */     // GIR_Coverage, 14704,
     /*  774942 */     GIR_EraseRootFromParent_Done,
     /*  774943 */   // Label 12075: @774943
     /*  774943 */   GIM_Try, /*On fail goto*//*Label 12076*/ GIMT_Encode4(775021), // Rule ID 14705 //
     /*  774948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  774951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  774959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  774962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  774965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11619:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  774994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775019 */     GIR_RootConstrainSelectedInstOperands,
     /*  775020 */     // GIR_Coverage, 14705,
     /*  775020 */     GIR_EraseRootFromParent_Done,
     /*  775021 */   // Label 12076: @775021
     /*  775021 */   GIM_Try, /*On fail goto*//*Label 12077*/ GIMT_Encode4(775099), // Rule ID 14708 //
     /*  775026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775072 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775097 */     GIR_RootConstrainSelectedInstOperands,
     /*  775098 */     // GIR_Coverage, 14708,
     /*  775098 */     GIR_EraseRootFromParent_Done,
     /*  775099 */   // Label 12077: @775099
     /*  775099 */   GIM_Try, /*On fail goto*//*Label 12078*/ GIMT_Encode4(775177), // Rule ID 14709 //
     /*  775104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  775115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  775118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  775121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775150 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775175 */     GIR_RootConstrainSelectedInstOperands,
     /*  775176 */     // GIR_Coverage, 14709,
     /*  775176 */     GIR_EraseRootFromParent_Done,
     /*  775177 */   // Label 12078: @775177
     /*  775177 */   GIM_Try, /*On fail goto*//*Label 12079*/ GIMT_Encode4(775255), // Rule ID 14712 //
     /*  775182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775228 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775253 */     GIR_RootConstrainSelectedInstOperands,
     /*  775254 */     // GIR_Coverage, 14712,
     /*  775254 */     GIR_EraseRootFromParent_Done,
     /*  775255 */   // Label 12079: @775255
     /*  775255 */   GIM_Try, /*On fail goto*//*Label 12080*/ GIMT_Encode4(775333), // Rule ID 14713 //
     /*  775260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  775271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  775274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  775277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775306 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775331 */     GIR_RootConstrainSelectedInstOperands,
     /*  775332 */     // GIR_Coverage, 14713,
     /*  775332 */     GIR_EraseRootFromParent_Done,
     /*  775333 */   // Label 12080: @775333
     /*  775333 */   GIM_Try, /*On fail goto*//*Label 12081*/ GIMT_Encode4(775411), // Rule ID 14716 //
     /*  775338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775384 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  775384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775409 */     GIR_RootConstrainSelectedInstOperands,
     /*  775410 */     // GIR_Coverage, 14716,
     /*  775410 */     GIR_EraseRootFromParent_Done,
     /*  775411 */   // Label 12081: @775411
     /*  775411 */   GIM_Try, /*On fail goto*//*Label 12082*/ GIMT_Encode4(775489), // Rule ID 14717 //
     /*  775416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  775427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  775430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  775433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775462 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  775462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  775481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775487 */     GIR_RootConstrainSelectedInstOperands,
     /*  775488 */     // GIR_Coverage, 14717,
     /*  775488 */     GIR_EraseRootFromParent_Done,
     /*  775489 */   // Label 12082: @775489
     /*  775489 */   GIM_Try, /*On fail goto*//*Label 12083*/ GIMT_Encode4(775567), // Rule ID 14720 //
     /*  775494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775565 */     GIR_RootConstrainSelectedInstOperands,
     /*  775566 */     // GIR_Coverage, 14720,
     /*  775566 */     GIR_EraseRootFromParent_Done,
     /*  775567 */   // Label 12083: @775567
     /*  775567 */   GIM_Try, /*On fail goto*//*Label 12084*/ GIMT_Encode4(775645), // Rule ID 14721 //
     /*  775572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775643 */     GIR_RootConstrainSelectedInstOperands,
     /*  775644 */     // GIR_Coverage, 14721,
     /*  775644 */     GIR_EraseRootFromParent_Done,
     /*  775645 */   // Label 12084: @775645
     /*  775645 */   GIM_Try, /*On fail goto*//*Label 12085*/ GIMT_Encode4(775723), // Rule ID 14724 //
     /*  775650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  775661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  775664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  775667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775721 */     GIR_RootConstrainSelectedInstOperands,
     /*  775722 */     // GIR_Coverage, 14724,
     /*  775722 */     GIR_EraseRootFromParent_Done,
     /*  775723 */   // Label 12085: @775723
     /*  775723 */   GIM_Try, /*On fail goto*//*Label 12086*/ GIMT_Encode4(775801), // Rule ID 14725 //
     /*  775728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  775739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  775742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  775745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775774 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775799 */     GIR_RootConstrainSelectedInstOperands,
     /*  775800 */     // GIR_Coverage, 14725,
     /*  775800 */     GIR_EraseRootFromParent_Done,
     /*  775801 */   // Label 12086: @775801
     /*  775801 */   GIM_Try, /*On fail goto*//*Label 12087*/ GIMT_Encode4(775879), // Rule ID 14728 //
     /*  775806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  775817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  775820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  775823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775877 */     GIR_RootConstrainSelectedInstOperands,
     /*  775878 */     // GIR_Coverage, 14728,
     /*  775878 */     GIR_EraseRootFromParent_Done,
     /*  775879 */   // Label 12087: @775879
     /*  775879 */   GIM_Try, /*On fail goto*//*Label 12088*/ GIMT_Encode4(775957), // Rule ID 14729 //
     /*  775884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  775895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  775898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  775901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775930 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775955 */     GIR_RootConstrainSelectedInstOperands,
     /*  775956 */     // GIR_Coverage, 14729,
     /*  775956 */     GIR_EraseRootFromParent_Done,
     /*  775957 */   // Label 12088: @775957
     /*  775957 */   GIM_Try, /*On fail goto*//*Label 12089*/ GIMT_Encode4(776035), // Rule ID 14732 //
     /*  775962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  775973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  775976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  775979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776008 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776033 */     GIR_RootConstrainSelectedInstOperands,
     /*  776034 */     // GIR_Coverage, 14732,
     /*  776034 */     GIR_EraseRootFromParent_Done,
     /*  776035 */   // Label 12089: @776035
     /*  776035 */   GIM_Try, /*On fail goto*//*Label 12090*/ GIMT_Encode4(776113), // Rule ID 14733 //
     /*  776040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  776051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  776054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  776057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776111 */     GIR_RootConstrainSelectedInstOperands,
     /*  776112 */     // GIR_Coverage, 14733,
     /*  776112 */     GIR_EraseRootFromParent_Done,
     /*  776113 */   // Label 12090: @776113
     /*  776113 */   GIM_Try, /*On fail goto*//*Label 12091*/ GIMT_Encode4(776191), // Rule ID 14736 //
     /*  776118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776164 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776189 */     GIR_RootConstrainSelectedInstOperands,
     /*  776190 */     // GIR_Coverage, 14736,
     /*  776190 */     GIR_EraseRootFromParent_Done,
     /*  776191 */   // Label 12091: @776191
     /*  776191 */   GIM_Try, /*On fail goto*//*Label 12092*/ GIMT_Encode4(776269), // Rule ID 14737 //
     /*  776196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  776207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  776210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  776213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776242 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776267 */     GIR_RootConstrainSelectedInstOperands,
     /*  776268 */     // GIR_Coverage, 14737,
     /*  776268 */     GIR_EraseRootFromParent_Done,
     /*  776269 */   // Label 12092: @776269
     /*  776269 */   GIM_Try, /*On fail goto*//*Label 12093*/ GIMT_Encode4(776347), // Rule ID 14740 //
     /*  776274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776320 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  776320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776345 */     GIR_RootConstrainSelectedInstOperands,
     /*  776346 */     // GIR_Coverage, 14740,
     /*  776346 */     GIR_EraseRootFromParent_Done,
     /*  776347 */   // Label 12093: @776347
     /*  776347 */   GIM_Try, /*On fail goto*//*Label 12094*/ GIMT_Encode4(776425), // Rule ID 14741 //
     /*  776352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  776363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  776366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  776369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  776398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  776417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776423 */     GIR_RootConstrainSelectedInstOperands,
     /*  776424 */     // GIR_Coverage, 14741,
     /*  776424 */     GIR_EraseRootFromParent_Done,
     /*  776425 */   // Label 12094: @776425
     /*  776425 */   GIM_Try, /*On fail goto*//*Label 12095*/ GIMT_Encode4(776503), // Rule ID 14744 //
     /*  776430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776501 */     GIR_RootConstrainSelectedInstOperands,
     /*  776502 */     // GIR_Coverage, 14744,
     /*  776502 */     GIR_EraseRootFromParent_Done,
     /*  776503 */   // Label 12095: @776503
     /*  776503 */   GIM_Try, /*On fail goto*//*Label 12096*/ GIMT_Encode4(776581), // Rule ID 14745 //
     /*  776508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11619:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776579 */     GIR_RootConstrainSelectedInstOperands,
     /*  776580 */     // GIR_Coverage, 14745,
     /*  776580 */     GIR_EraseRootFromParent_Done,
     /*  776581 */   // Label 12096: @776581
     /*  776581 */   GIM_Try, /*On fail goto*//*Label 12097*/ GIMT_Encode4(776659), // Rule ID 14748 //
     /*  776586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  776597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  776600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  776603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776632 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776657 */     GIR_RootConstrainSelectedInstOperands,
     /*  776658 */     // GIR_Coverage, 14748,
     /*  776658 */     GIR_EraseRootFromParent_Done,
     /*  776659 */   // Label 12097: @776659
     /*  776659 */   GIM_Try, /*On fail goto*//*Label 12098*/ GIMT_Encode4(776737), // Rule ID 14749 //
     /*  776664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  776675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  776678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  776681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776710 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11619:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776735 */     GIR_RootConstrainSelectedInstOperands,
     /*  776736 */     // GIR_Coverage, 14749,
     /*  776736 */     GIR_EraseRootFromParent_Done,
     /*  776737 */   // Label 12098: @776737
     /*  776737 */   GIM_Try, /*On fail goto*//*Label 12099*/ GIMT_Encode4(776815), // Rule ID 14752 //
     /*  776742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  776753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  776756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  776759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776813 */     GIR_RootConstrainSelectedInstOperands,
     /*  776814 */     // GIR_Coverage, 14752,
     /*  776814 */     GIR_EraseRootFromParent_Done,
     /*  776815 */   // Label 12099: @776815
     /*  776815 */   GIM_Try, /*On fail goto*//*Label 12100*/ GIMT_Encode4(776893), // Rule ID 14753 //
     /*  776820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  776831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  776834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  776837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776866 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11619:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776891 */     GIR_RootConstrainSelectedInstOperands,
     /*  776892 */     // GIR_Coverage, 14753,
     /*  776892 */     GIR_EraseRootFromParent_Done,
     /*  776893 */   // Label 12100: @776893
     /*  776893 */   GIM_Try, /*On fail goto*//*Label 12101*/ GIMT_Encode4(776971), // Rule ID 14756 //
     /*  776898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  776909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  776912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  776915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  776918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776944 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  776944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  776947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  776963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776969 */     GIR_RootConstrainSelectedInstOperands,
     /*  776970 */     // GIR_Coverage, 14756,
     /*  776970 */     GIR_EraseRootFromParent_Done,
     /*  776971 */   // Label 12101: @776971
     /*  776971 */   GIM_Try, /*On fail goto*//*Label 12102*/ GIMT_Encode4(777049), // Rule ID 14757 //
     /*  776976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  776987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  776990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  776993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  776996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777022 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  777025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777047 */     GIR_RootConstrainSelectedInstOperands,
     /*  777048 */     // GIR_Coverage, 14757,
     /*  777048 */     GIR_EraseRootFromParent_Done,
     /*  777049 */   // Label 12102: @777049
     /*  777049 */   GIM_Try, /*On fail goto*//*Label 12103*/ GIMT_Encode4(777127), // Rule ID 14760 //
     /*  777054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  777074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777100 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777125 */     GIR_RootConstrainSelectedInstOperands,
     /*  777126 */     // GIR_Coverage, 14760,
     /*  777126 */     GIR_EraseRootFromParent_Done,
     /*  777127 */   // Label 12103: @777127
     /*  777127 */   GIM_Try, /*On fail goto*//*Label 12104*/ GIMT_Encode4(777205), // Rule ID 14761 //
     /*  777132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  777143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  777146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  777149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  777152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777178 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777203 */     GIR_RootConstrainSelectedInstOperands,
     /*  777204 */     // GIR_Coverage, 14761,
     /*  777204 */     GIR_EraseRootFromParent_Done,
     /*  777205 */   // Label 12104: @777205
     /*  777205 */   GIM_Try, /*On fail goto*//*Label 12105*/ GIMT_Encode4(777283), // Rule ID 14764 //
     /*  777210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  777230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777256 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777281 */     GIR_RootConstrainSelectedInstOperands,
     /*  777282 */     // GIR_Coverage, 14764,
     /*  777282 */     GIR_EraseRootFromParent_Done,
     /*  777283 */   // Label 12105: @777283
     /*  777283 */   GIM_Try, /*On fail goto*//*Label 12106*/ GIMT_Encode4(777361), // Rule ID 14765 //
     /*  777288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  777299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  777302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  777305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  777308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777359 */     GIR_RootConstrainSelectedInstOperands,
     /*  777360 */     // GIR_Coverage, 14765,
     /*  777360 */     GIR_EraseRootFromParent_Done,
     /*  777361 */   // Label 12106: @777361
     /*  777361 */   GIM_Try, /*On fail goto*//*Label 12107*/ GIMT_Encode4(777439), // Rule ID 14768 //
     /*  777366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777412 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777437 */     GIR_RootConstrainSelectedInstOperands,
     /*  777438 */     // GIR_Coverage, 14768,
     /*  777438 */     GIR_EraseRootFromParent_Done,
     /*  777439 */   // Label 12107: @777439
     /*  777439 */   GIM_Try, /*On fail goto*//*Label 12108*/ GIMT_Encode4(777517), // Rule ID 14769 //
     /*  777444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  777455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  777458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  777461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  777464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777490 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  777493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777515 */     GIR_RootConstrainSelectedInstOperands,
     /*  777516 */     // GIR_Coverage, 14769,
     /*  777516 */     GIR_EraseRootFromParent_Done,
     /*  777517 */   // Label 12108: @777517
     /*  777517 */   GIM_Try, /*On fail goto*//*Label 12109*/ GIMT_Encode4(777595), // Rule ID 14772 //
     /*  777522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  777533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  777536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  777539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  777542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777593 */     GIR_RootConstrainSelectedInstOperands,
     /*  777594 */     // GIR_Coverage, 14772,
     /*  777594 */     GIR_EraseRootFromParent_Done,
     /*  777595 */   // Label 12109: @777595
     /*  777595 */   GIM_Try, /*On fail goto*//*Label 12110*/ GIMT_Encode4(777673), // Rule ID 14773 //
     /*  777600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  777611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  777614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  777617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  777620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777671 */     GIR_RootConstrainSelectedInstOperands,
     /*  777672 */     // GIR_Coverage, 14773,
     /*  777672 */     GIR_EraseRootFromParent_Done,
     /*  777673 */   // Label 12110: @777673
     /*  777673 */   GIM_Try, /*On fail goto*//*Label 12111*/ GIMT_Encode4(777751), // Rule ID 14776 //
     /*  777678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  777689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  777692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  777695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  777698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  777724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777749 */     GIR_RootConstrainSelectedInstOperands,
     /*  777750 */     // GIR_Coverage, 14776,
     /*  777750 */     GIR_EraseRootFromParent_Done,
     /*  777751 */   // Label 12111: @777751
     /*  777751 */   GIM_Try, /*On fail goto*//*Label 12112*/ GIMT_Encode4(777829), // Rule ID 14777 //
     /*  777756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  777767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  777770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  777773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  777776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  777802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777827 */     GIR_RootConstrainSelectedInstOperands,
     /*  777828 */     // GIR_Coverage, 14777,
     /*  777828 */     GIR_EraseRootFromParent_Done,
     /*  777829 */   // Label 12112: @777829
     /*  777829 */   GIM_Try, /*On fail goto*//*Label 12113*/ GIMT_Encode4(777907), // Rule ID 14780 //
     /*  777834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  777845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  777848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  777851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  777854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777880 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777905 */     GIR_RootConstrainSelectedInstOperands,
     /*  777906 */     // GIR_Coverage, 14780,
     /*  777906 */     GIR_EraseRootFromParent_Done,
     /*  777907 */   // Label 12113: @777907
     /*  777907 */   GIM_Try, /*On fail goto*//*Label 12114*/ GIMT_Encode4(777985), // Rule ID 14781 //
     /*  777912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  777923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  777926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  777929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  777932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777983 */     GIR_RootConstrainSelectedInstOperands,
     /*  777984 */     // GIR_Coverage, 14781,
     /*  777984 */     GIR_EraseRootFromParent_Done,
     /*  777985 */   // Label 12114: @777985
     /*  777985 */   GIM_Try, /*On fail goto*//*Label 12115*/ GIMT_Encode4(778063), // Rule ID 14784 //
     /*  777990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778036 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778061 */     GIR_RootConstrainSelectedInstOperands,
     /*  778062 */     // GIR_Coverage, 14784,
     /*  778062 */     GIR_EraseRootFromParent_Done,
     /*  778063 */   // Label 12115: @778063
     /*  778063 */   GIM_Try, /*On fail goto*//*Label 12116*/ GIMT_Encode4(778141), // Rule ID 14785 //
     /*  778068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  778079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  778082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  778085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  778088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778139 */     GIR_RootConstrainSelectedInstOperands,
     /*  778140 */     // GIR_Coverage, 14785,
     /*  778140 */     GIR_EraseRootFromParent_Done,
     /*  778141 */   // Label 12116: @778141
     /*  778141 */   GIM_Try, /*On fail goto*//*Label 12117*/ GIMT_Encode4(778219), // Rule ID 14788 //
     /*  778146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  778166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778192 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778217 */     GIR_RootConstrainSelectedInstOperands,
     /*  778218 */     // GIR_Coverage, 14788,
     /*  778218 */     GIR_EraseRootFromParent_Done,
     /*  778219 */   // Label 12117: @778219
     /*  778219 */   GIM_Try, /*On fail goto*//*Label 12118*/ GIMT_Encode4(778297), // Rule ID 14789 //
     /*  778224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  778235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  778238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  778241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  778244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  778270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778295 */     GIR_RootConstrainSelectedInstOperands,
     /*  778296 */     // GIR_Coverage, 14789,
     /*  778296 */     GIR_EraseRootFromParent_Done,
     /*  778297 */   // Label 12118: @778297
     /*  778297 */   GIM_Try, /*On fail goto*//*Label 12119*/ GIMT_Encode4(778375), // Rule ID 14792 //
     /*  778302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  778305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  778322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778348 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  778348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778373 */     GIR_RootConstrainSelectedInstOperands,
     /*  778374 */     // GIR_Coverage, 14792,
     /*  778374 */     GIR_EraseRootFromParent_Done,
     /*  778375 */   // Label 12119: @778375
     /*  778375 */   GIM_Try, /*On fail goto*//*Label 12120*/ GIMT_Encode4(778453), // Rule ID 14793 //
     /*  778380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  778383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  778391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  778394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  778397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  778400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  778419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778426 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  778426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  778429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  778445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778451 */     GIR_RootConstrainSelectedInstOperands,
     /*  778452 */     // GIR_Coverage, 14793,
     /*  778452 */     GIR_EraseRootFromParent_Done,
     /*  778453 */   // Label 12120: @778453
     /*  778453 */   GIM_Try, /*On fail goto*//*Label 12121*/ GIMT_Encode4(778531), // Rule ID 14796 //
     /*  778458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  778478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778504 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778526 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778529 */     GIR_RootConstrainSelectedInstOperands,
     /*  778530 */     // GIR_Coverage, 14796,
     /*  778530 */     GIR_EraseRootFromParent_Done,
     /*  778531 */   // Label 12121: @778531
     /*  778531 */   GIM_Try, /*On fail goto*//*Label 12122*/ GIMT_Encode4(778609), // Rule ID 14797 //
     /*  778536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  778556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778582 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778607 */     GIR_RootConstrainSelectedInstOperands,
     /*  778608 */     // GIR_Coverage, 14797,
     /*  778608 */     GIR_EraseRootFromParent_Done,
     /*  778609 */   // Label 12122: @778609
     /*  778609 */   GIM_Try, /*On fail goto*//*Label 12123*/ GIMT_Encode4(778687), // Rule ID 14800 //
     /*  778614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  778625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  778628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  778631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  778634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778660 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  778663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778685 */     GIR_RootConstrainSelectedInstOperands,
     /*  778686 */     // GIR_Coverage, 14800,
     /*  778686 */     GIR_EraseRootFromParent_Done,
     /*  778687 */   // Label 12123: @778687
     /*  778687 */   GIM_Try, /*On fail goto*//*Label 12124*/ GIMT_Encode4(778765), // Rule ID 14801 //
     /*  778692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  778703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  778706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  778709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  778712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778738 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  778741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778763 */     GIR_RootConstrainSelectedInstOperands,
     /*  778764 */     // GIR_Coverage, 14801,
     /*  778764 */     GIR_EraseRootFromParent_Done,
     /*  778765 */   // Label 12124: @778765
     /*  778765 */   GIM_Try, /*On fail goto*//*Label 12125*/ GIMT_Encode4(778843), // Rule ID 14804 //
     /*  778770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  778781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  778784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  778787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  778790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778816 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  778819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778841 */     GIR_RootConstrainSelectedInstOperands,
     /*  778842 */     // GIR_Coverage, 14804,
     /*  778842 */     GIR_EraseRootFromParent_Done,
     /*  778843 */   // Label 12125: @778843
     /*  778843 */   GIM_Try, /*On fail goto*//*Label 12126*/ GIMT_Encode4(778921), // Rule ID 14805 //
     /*  778848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  778859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  778862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  778865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  778868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778894 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  778897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778919 */     GIR_RootConstrainSelectedInstOperands,
     /*  778920 */     // GIR_Coverage, 14805,
     /*  778920 */     GIR_EraseRootFromParent_Done,
     /*  778921 */   // Label 12126: @778921
     /*  778921 */   GIM_Try, /*On fail goto*//*Label 12127*/ GIMT_Encode4(778999), // Rule ID 14808 //
     /*  778926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  778937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  778940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  778943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  778946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778972 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778997 */     GIR_RootConstrainSelectedInstOperands,
     /*  778998 */     // GIR_Coverage, 14808,
     /*  778998 */     GIR_EraseRootFromParent_Done,
     /*  778999 */   // Label 12127: @778999
     /*  778999 */   GIM_Try, /*On fail goto*//*Label 12128*/ GIMT_Encode4(779077), // Rule ID 14809 //
     /*  779004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  779015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  779018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  779021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  779024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779075 */     GIR_RootConstrainSelectedInstOperands,
     /*  779076 */     // GIR_Coverage, 14809,
     /*  779076 */     GIR_EraseRootFromParent_Done,
     /*  779077 */   // Label 12128: @779077
     /*  779077 */   GIM_Try, /*On fail goto*//*Label 12129*/ GIMT_Encode4(779155), // Rule ID 14812 //
     /*  779082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  779102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779128 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779153 */     GIR_RootConstrainSelectedInstOperands,
     /*  779154 */     // GIR_Coverage, 14812,
     /*  779154 */     GIR_EraseRootFromParent_Done,
     /*  779155 */   // Label 12129: @779155
     /*  779155 */   GIM_Try, /*On fail goto*//*Label 12130*/ GIMT_Encode4(779233), // Rule ID 14813 //
     /*  779160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  779171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  779174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  779177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  779180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779206 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779231 */     GIR_RootConstrainSelectedInstOperands,
     /*  779232 */     // GIR_Coverage, 14813,
     /*  779232 */     GIR_EraseRootFromParent_Done,
     /*  779233 */   // Label 12130: @779233
     /*  779233 */   GIM_Try, /*On fail goto*//*Label 12131*/ GIMT_Encode4(779311), // Rule ID 14816 //
     /*  779238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  779258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779284 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  779284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779306 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779309 */     GIR_RootConstrainSelectedInstOperands,
     /*  779310 */     // GIR_Coverage, 14816,
     /*  779310 */     GIR_EraseRootFromParent_Done,
     /*  779311 */   // Label 12131: @779311
     /*  779311 */   GIM_Try, /*On fail goto*//*Label 12132*/ GIMT_Encode4(779389), // Rule ID 14817 //
     /*  779316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  779327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  779330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  779333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  779336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779362 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  779362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  779381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779387 */     GIR_RootConstrainSelectedInstOperands,
     /*  779388 */     // GIR_Coverage, 14817,
     /*  779388 */     GIR_EraseRootFromParent_Done,
     /*  779389 */   // Label 12132: @779389
     /*  779389 */   GIM_Try, /*On fail goto*//*Label 12133*/ GIMT_Encode4(779467), // Rule ID 14820 //
     /*  779394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  779414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779465 */     GIR_RootConstrainSelectedInstOperands,
     /*  779466 */     // GIR_Coverage, 14820,
     /*  779466 */     GIR_EraseRootFromParent_Done,
     /*  779467 */   // Label 12133: @779467
     /*  779467 */   GIM_Try, /*On fail goto*//*Label 12134*/ GIMT_Encode4(779545), // Rule ID 14821 //
     /*  779472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  779483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  779486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  779489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  779492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779543 */     GIR_RootConstrainSelectedInstOperands,
     /*  779544 */     // GIR_Coverage, 14821,
     /*  779544 */     GIR_EraseRootFromParent_Done,
     /*  779545 */   // Label 12134: @779545
     /*  779545 */   GIM_Try, /*On fail goto*//*Label 12135*/ GIMT_Encode4(779623), // Rule ID 14824 //
     /*  779550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  779561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  779564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  779567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  779570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779621 */     GIR_RootConstrainSelectedInstOperands,
     /*  779622 */     // GIR_Coverage, 14824,
     /*  779622 */     GIR_EraseRootFromParent_Done,
     /*  779623 */   // Label 12135: @779623
     /*  779623 */   GIM_Try, /*On fail goto*//*Label 12136*/ GIMT_Encode4(779701), // Rule ID 14825 //
     /*  779628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  779639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  779642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  779645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  779648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779699 */     GIR_RootConstrainSelectedInstOperands,
     /*  779700 */     // GIR_Coverage, 14825,
     /*  779700 */     GIR_EraseRootFromParent_Done,
     /*  779701 */   // Label 12136: @779701
     /*  779701 */   GIM_Try, /*On fail goto*//*Label 12137*/ GIMT_Encode4(779779), // Rule ID 14828 //
     /*  779706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  779717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  779720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  779723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  779726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779777 */     GIR_RootConstrainSelectedInstOperands,
     /*  779778 */     // GIR_Coverage, 14828,
     /*  779778 */     GIR_EraseRootFromParent_Done,
     /*  779779 */   // Label 12137: @779779
     /*  779779 */   GIM_Try, /*On fail goto*//*Label 12138*/ GIMT_Encode4(779857), // Rule ID 14829 //
     /*  779784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  779795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  779798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  779801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  779804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779830 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779855 */     GIR_RootConstrainSelectedInstOperands,
     /*  779856 */     // GIR_Coverage, 14829,
     /*  779856 */     GIR_EraseRootFromParent_Done,
     /*  779857 */   // Label 12138: @779857
     /*  779857 */   GIM_Try, /*On fail goto*//*Label 12139*/ GIMT_Encode4(779935), // Rule ID 14832 //
     /*  779862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  779865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  779873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  779876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  779879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  779882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  779908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779933 */     GIR_RootConstrainSelectedInstOperands,
     /*  779934 */     // GIR_Coverage, 14832,
     /*  779934 */     GIR_EraseRootFromParent_Done,
     /*  779935 */   // Label 12139: @779935
     /*  779935 */   GIM_Try, /*On fail goto*//*Label 12140*/ GIMT_Encode4(780013), // Rule ID 14833 //
     /*  779940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  779943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  779951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  779954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  779957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  779960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  779986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780011 */     GIR_RootConstrainSelectedInstOperands,
     /*  780012 */     // GIR_Coverage, 14833,
     /*  780012 */     GIR_EraseRootFromParent_Done,
     /*  780013 */   // Label 12140: @780013
     /*  780013 */   GIM_Try, /*On fail goto*//*Label 12141*/ GIMT_Encode4(780091), // Rule ID 14836 //
     /*  780018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  780038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780089 */     GIR_RootConstrainSelectedInstOperands,
     /*  780090 */     // GIR_Coverage, 14836,
     /*  780090 */     GIR_EraseRootFromParent_Done,
     /*  780091 */   // Label 12141: @780091
     /*  780091 */   GIM_Try, /*On fail goto*//*Label 12142*/ GIMT_Encode4(780169), // Rule ID 14837 //
     /*  780096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  780107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  780110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  780113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  780116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  780135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780142 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  780145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780167 */     GIR_RootConstrainSelectedInstOperands,
     /*  780168 */     // GIR_Coverage, 14837,
     /*  780168 */     GIR_EraseRootFromParent_Done,
     /*  780169 */   // Label 12142: @780169
     /*  780169 */   GIM_Try, /*On fail goto*//*Label 12143*/ GIMT_Encode4(780247), // Rule ID 14840 //
     /*  780174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  780177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  780194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  780220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780245 */     GIR_RootConstrainSelectedInstOperands,
     /*  780246 */     // GIR_Coverage, 14840,
     /*  780246 */     GIR_EraseRootFromParent_Done,
     /*  780247 */   // Label 12143: @780247
     /*  780247 */   GIM_Try, /*On fail goto*//*Label 12144*/ GIMT_Encode4(780325), // Rule ID 14841 //
     /*  780252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  780255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  780263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  780266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  780269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  780272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  780291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780298 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  780298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  780301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  780317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780323 */     GIR_RootConstrainSelectedInstOperands,
     /*  780324 */     // GIR_Coverage, 14841,
     /*  780324 */     GIR_EraseRootFromParent_Done,
     /*  780325 */   // Label 12144: @780325
     /*  780325 */   GIM_Try, /*On fail goto*//*Label 12145*/ GIMT_Encode4(780403), // Rule ID 14844 //
     /*  780330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780376 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  780379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780401 */     GIR_RootConstrainSelectedInstOperands,
     /*  780402 */     // GIR_Coverage, 14844,
     /*  780402 */     GIR_EraseRootFromParent_Done,
     /*  780403 */   // Label 12145: @780403
     /*  780403 */   GIM_Try, /*On fail goto*//*Label 12146*/ GIMT_Encode4(780481), // Rule ID 14845 //
     /*  780408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  780419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  780422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  780425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780454 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  780457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780479 */     GIR_RootConstrainSelectedInstOperands,
     /*  780480 */     // GIR_Coverage, 14845,
     /*  780480 */     GIR_EraseRootFromParent_Done,
     /*  780481 */   // Label 12146: @780481
     /*  780481 */   GIM_Try, /*On fail goto*//*Label 12147*/ GIMT_Encode4(780559), // Rule ID 14848 //
     /*  780486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780532 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780557 */     GIR_RootConstrainSelectedInstOperands,
     /*  780558 */     // GIR_Coverage, 14848,
     /*  780558 */     GIR_EraseRootFromParent_Done,
     /*  780559 */   // Label 12147: @780559
     /*  780559 */   GIM_Try, /*On fail goto*//*Label 12148*/ GIMT_Encode4(780637), // Rule ID 14849 //
     /*  780564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780610 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780635 */     GIR_RootConstrainSelectedInstOperands,
     /*  780636 */     // GIR_Coverage, 14849,
     /*  780636 */     GIR_EraseRootFromParent_Done,
     /*  780637 */   // Label 12148: @780637
     /*  780637 */   GIM_Try, /*On fail goto*//*Label 12149*/ GIMT_Encode4(780715), // Rule ID 14852 //
     /*  780642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  780653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  780656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  780659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780688 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780713 */     GIR_RootConstrainSelectedInstOperands,
     /*  780714 */     // GIR_Coverage, 14852,
     /*  780714 */     GIR_EraseRootFromParent_Done,
     /*  780715 */   // Label 12149: @780715
     /*  780715 */   GIM_Try, /*On fail goto*//*Label 12150*/ GIMT_Encode4(780793), // Rule ID 14853 //
     /*  780720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  780731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  780734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  780737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780791 */     GIR_RootConstrainSelectedInstOperands,
     /*  780792 */     // GIR_Coverage, 14853,
     /*  780792 */     GIR_EraseRootFromParent_Done,
     /*  780793 */   // Label 12150: @780793
     /*  780793 */   GIM_Try, /*On fail goto*//*Label 12151*/ GIMT_Encode4(780871), // Rule ID 14856 //
     /*  780798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  780809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  780812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  780815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  780844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780869 */     GIR_RootConstrainSelectedInstOperands,
     /*  780870 */     // GIR_Coverage, 14856,
     /*  780870 */     GIR_EraseRootFromParent_Done,
     /*  780871 */   // Label 12151: @780871
     /*  780871 */   GIM_Try, /*On fail goto*//*Label 12152*/ GIMT_Encode4(780949), // Rule ID 14857 //
     /*  780876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  780887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  780890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  780893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780922 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  780922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780947 */     GIR_RootConstrainSelectedInstOperands,
     /*  780948 */     // GIR_Coverage, 14857,
     /*  780948 */     GIR_EraseRootFromParent_Done,
     /*  780949 */   // Label 12152: @780949
     /*  780949 */   GIM_Try, /*On fail goto*//*Label 12153*/ GIMT_Encode4(781027), // Rule ID 14860 //
     /*  780954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  780965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  780968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  780971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781000 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781025 */     GIR_RootConstrainSelectedInstOperands,
     /*  781026 */     // GIR_Coverage, 14860,
     /*  781026 */     GIR_EraseRootFromParent_Done,
     /*  781027 */   // Label 12153: @781027
     /*  781027 */   GIM_Try, /*On fail goto*//*Label 12154*/ GIMT_Encode4(781105), // Rule ID 14861 //
     /*  781032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  781043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  781046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  781049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781078 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781103 */     GIR_RootConstrainSelectedInstOperands,
     /*  781104 */     // GIR_Coverage, 14861,
     /*  781104 */     GIR_EraseRootFromParent_Done,
     /*  781105 */   // Label 12154: @781105
     /*  781105 */   GIM_Try, /*On fail goto*//*Label 12155*/ GIMT_Encode4(781183), // Rule ID 14864 //
     /*  781110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781156 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  781156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781181 */     GIR_RootConstrainSelectedInstOperands,
     /*  781182 */     // GIR_Coverage, 14864,
     /*  781182 */     GIR_EraseRootFromParent_Done,
     /*  781183 */   // Label 12155: @781183
     /*  781183 */   GIM_Try, /*On fail goto*//*Label 12156*/ GIMT_Encode4(781261), // Rule ID 14865 //
     /*  781188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  781199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  781202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  781205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781234 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  781234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  781237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781259 */     GIR_RootConstrainSelectedInstOperands,
     /*  781260 */     // GIR_Coverage, 14865,
     /*  781260 */     GIR_EraseRootFromParent_Done,
     /*  781261 */   // Label 12156: @781261
     /*  781261 */   GIM_Try, /*On fail goto*//*Label 12157*/ GIMT_Encode4(781339), // Rule ID 14868 //
     /*  781266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781337 */     GIR_RootConstrainSelectedInstOperands,
     /*  781338 */     // GIR_Coverage, 14868,
     /*  781338 */     GIR_EraseRootFromParent_Done,
     /*  781339 */   // Label 12157: @781339
     /*  781339 */   GIM_Try, /*On fail goto*//*Label 12158*/ GIMT_Encode4(781417), // Rule ID 14869 //
     /*  781344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  781355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  781358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  781361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781390 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11617:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781415 */     GIR_RootConstrainSelectedInstOperands,
     /*  781416 */     // GIR_Coverage, 14869,
     /*  781416 */     GIR_EraseRootFromParent_Done,
     /*  781417 */   // Label 12158: @781417
     /*  781417 */   GIM_Try, /*On fail goto*//*Label 12159*/ GIMT_Encode4(781495), // Rule ID 14872 //
     /*  781422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781493 */     GIR_RootConstrainSelectedInstOperands,
     /*  781494 */     // GIR_Coverage, 14872,
     /*  781494 */     GIR_EraseRootFromParent_Done,
     /*  781495 */   // Label 12159: @781495
     /*  781495 */   GIM_Try, /*On fail goto*//*Label 12160*/ GIMT_Encode4(781573), // Rule ID 14873 //
     /*  781500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11617:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781571 */     GIR_RootConstrainSelectedInstOperands,
     /*  781572 */     // GIR_Coverage, 14873,
     /*  781572 */     GIR_EraseRootFromParent_Done,
     /*  781573 */   // Label 12160: @781573
     /*  781573 */   GIM_Try, /*On fail goto*//*Label 12161*/ GIMT_Encode4(781651), // Rule ID 14876 //
     /*  781578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  781589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  781592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  781595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  781624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781649 */     GIR_RootConstrainSelectedInstOperands,
     /*  781650 */     // GIR_Coverage, 14876,
     /*  781650 */     GIR_EraseRootFromParent_Done,
     /*  781651 */   // Label 12161: @781651
     /*  781651 */   GIM_Try, /*On fail goto*//*Label 12162*/ GIMT_Encode4(781729), // Rule ID 14877 //
     /*  781656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  781667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  781670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  781673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11617:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  781702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781727 */     GIR_RootConstrainSelectedInstOperands,
     /*  781728 */     // GIR_Coverage, 14877,
     /*  781728 */     GIR_EraseRootFromParent_Done,
     /*  781729 */   // Label 12162: @781729
     /*  781729 */   GIM_Try, /*On fail goto*//*Label 12163*/ GIMT_Encode4(781807), // Rule ID 14880 //
     /*  781734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  781737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  781745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  781748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  781751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781780 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  781780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781805 */     GIR_RootConstrainSelectedInstOperands,
     /*  781806 */     // GIR_Coverage, 14880,
     /*  781806 */     GIR_EraseRootFromParent_Done,
     /*  781807 */   // Label 12163: @781807
     /*  781807 */   GIM_Try, /*On fail goto*//*Label 12164*/ GIMT_Encode4(781885), // Rule ID 14881 //
     /*  781812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  781815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  781823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  781826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  781829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781858 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11617:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  781858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781883 */     GIR_RootConstrainSelectedInstOperands,
     /*  781884 */     // GIR_Coverage, 14881,
     /*  781884 */     GIR_EraseRootFromParent_Done,
     /*  781885 */   // Label 12164: @781885
     /*  781885 */   GIM_Try, /*On fail goto*//*Label 12165*/ GIMT_Encode4(781963), // Rule ID 14884 //
     /*  781890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  781901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  781904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  781907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781936 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  781939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781961 */     GIR_RootConstrainSelectedInstOperands,
     /*  781962 */     // GIR_Coverage, 14884,
     /*  781962 */     GIR_EraseRootFromParent_Done,
     /*  781963 */   // Label 12165: @781963
     /*  781963 */   GIM_Try, /*On fail goto*//*Label 12166*/ GIMT_Encode4(782041), // Rule ID 14885 //
     /*  781968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  781979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  781982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  781985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782039 */     GIR_RootConstrainSelectedInstOperands,
     /*  782040 */     // GIR_Coverage, 14885,
     /*  782040 */     GIR_EraseRootFromParent_Done,
     /*  782041 */   // Label 12166: @782041
     /*  782041 */   GIM_Try, /*On fail goto*//*Label 12167*/ GIMT_Encode4(782119), // Rule ID 14888 //
     /*  782046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782117 */     GIR_RootConstrainSelectedInstOperands,
     /*  782118 */     // GIR_Coverage, 14888,
     /*  782118 */     GIR_EraseRootFromParent_Done,
     /*  782119 */   // Label 12167: @782119
     /*  782119 */   GIM_Try, /*On fail goto*//*Label 12168*/ GIMT_Encode4(782197), // Rule ID 14889 //
     /*  782124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  782135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  782138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  782141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782170 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782195 */     GIR_RootConstrainSelectedInstOperands,
     /*  782196 */     // GIR_Coverage, 14889,
     /*  782196 */     GIR_EraseRootFromParent_Done,
     /*  782197 */   // Label 12168: @782197
     /*  782197 */   GIM_Try, /*On fail goto*//*Label 12169*/ GIMT_Encode4(782275), // Rule ID 14892 //
     /*  782202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782248 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  782248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782273 */     GIR_RootConstrainSelectedInstOperands,
     /*  782274 */     // GIR_Coverage, 14892,
     /*  782274 */     GIR_EraseRootFromParent_Done,
     /*  782275 */   // Label 12169: @782275
     /*  782275 */   GIM_Try, /*On fail goto*//*Label 12170*/ GIMT_Encode4(782353), // Rule ID 14893 //
     /*  782280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  782291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  782294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  782297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  782326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  782345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782351 */     GIR_RootConstrainSelectedInstOperands,
     /*  782352 */     // GIR_Coverage, 14893,
     /*  782352 */     GIR_EraseRootFromParent_Done,
     /*  782353 */   // Label 12170: @782353
     /*  782353 */   GIM_Try, /*On fail goto*//*Label 12171*/ GIMT_Encode4(782431), // Rule ID 14896 //
     /*  782358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782404 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782429 */     GIR_RootConstrainSelectedInstOperands,
     /*  782430 */     // GIR_Coverage, 14896,
     /*  782430 */     GIR_EraseRootFromParent_Done,
     /*  782431 */   // Label 12171: @782431
     /*  782431 */   GIM_Try, /*On fail goto*//*Label 12172*/ GIMT_Encode4(782509), // Rule ID 14897 //
     /*  782436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  782447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  782450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  782453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782507 */     GIR_RootConstrainSelectedInstOperands,
     /*  782508 */     // GIR_Coverage, 14897,
     /*  782508 */     GIR_EraseRootFromParent_Done,
     /*  782509 */   // Label 12172: @782509
     /*  782509 */   GIM_Try, /*On fail goto*//*Label 12173*/ GIMT_Encode4(782587), // Rule ID 14900 //
     /*  782514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  782528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  782531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782585 */     GIR_RootConstrainSelectedInstOperands,
     /*  782586 */     // GIR_Coverage, 14900,
     /*  782586 */     GIR_EraseRootFromParent_Done,
     /*  782587 */   // Label 12173: @782587
     /*  782587 */   GIM_Try, /*On fail goto*//*Label 12174*/ GIMT_Encode4(782665), // Rule ID 14901 //
     /*  782592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  782606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  782609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782638 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782663 */     GIR_RootConstrainSelectedInstOperands,
     /*  782664 */     // GIR_Coverage, 14901,
     /*  782664 */     GIR_EraseRootFromParent_Done,
     /*  782665 */   // Label 12174: @782665
     /*  782665 */   GIM_Try, /*On fail goto*//*Label 12175*/ GIMT_Encode4(782743), // Rule ID 14904 //
     /*  782670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  782681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  782684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  782687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782716 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782741 */     GIR_RootConstrainSelectedInstOperands,
     /*  782742 */     // GIR_Coverage, 14904,
     /*  782742 */     GIR_EraseRootFromParent_Done,
     /*  782743 */   // Label 12175: @782743
     /*  782743 */   GIM_Try, /*On fail goto*//*Label 12176*/ GIMT_Encode4(782821), // Rule ID 14905 //
     /*  782748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  782759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  782762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  782765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782819 */     GIR_RootConstrainSelectedInstOperands,
     /*  782820 */     // GIR_Coverage, 14905,
     /*  782820 */     GIR_EraseRootFromParent_Done,
     /*  782821 */   // Label 12176: @782821
     /*  782821 */   GIM_Try, /*On fail goto*//*Label 12177*/ GIMT_Encode4(782899), // Rule ID 14908 //
     /*  782826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  782837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  782840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  782843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782872 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  782872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782897 */     GIR_RootConstrainSelectedInstOperands,
     /*  782898 */     // GIR_Coverage, 14908,
     /*  782898 */     GIR_EraseRootFromParent_Done,
     /*  782899 */   // Label 12177: @782899
     /*  782899 */   GIM_Try, /*On fail goto*//*Label 12178*/ GIMT_Encode4(782977), // Rule ID 14909 //
     /*  782904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  782915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  782918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  782921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  782950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782975 */     GIR_RootConstrainSelectedInstOperands,
     /*  782976 */     // GIR_Coverage, 14909,
     /*  782976 */     GIR_EraseRootFromParent_Done,
     /*  782977 */   // Label 12178: @782977
     /*  782977 */   GIM_Try, /*On fail goto*//*Label 12179*/ GIMT_Encode4(783055), // Rule ID 14912 //
     /*  782982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  782993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  782996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  782999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783053 */     GIR_RootConstrainSelectedInstOperands,
     /*  783054 */     // GIR_Coverage, 14912,
     /*  783054 */     GIR_EraseRootFromParent_Done,
     /*  783055 */   // Label 12179: @783055
     /*  783055 */   GIM_Try, /*On fail goto*//*Label 12180*/ GIMT_Encode4(783133), // Rule ID 14913 //
     /*  783060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  783071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  783074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  783077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783131 */     GIR_RootConstrainSelectedInstOperands,
     /*  783132 */     // GIR_Coverage, 14913,
     /*  783132 */     GIR_EraseRootFromParent_Done,
     /*  783133 */   // Label 12180: @783133
     /*  783133 */   GIM_Try, /*On fail goto*//*Label 12181*/ GIMT_Encode4(783211), // Rule ID 14916 //
     /*  783138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  783141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783184 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783209 */     GIR_RootConstrainSelectedInstOperands,
     /*  783210 */     // GIR_Coverage, 14916,
     /*  783210 */     GIR_EraseRootFromParent_Done,
     /*  783211 */   // Label 12181: @783211
     /*  783211 */   GIM_Try, /*On fail goto*//*Label 12182*/ GIMT_Encode4(783289), // Rule ID 14917 //
     /*  783216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  783219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  783227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  783230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  783233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783287 */     GIR_RootConstrainSelectedInstOperands,
     /*  783288 */     // GIR_Coverage, 14917,
     /*  783288 */     GIR_EraseRootFromParent_Done,
     /*  783289 */   // Label 12182: @783289
     /*  783289 */   GIM_Try, /*On fail goto*//*Label 12183*/ GIMT_Encode4(783367), // Rule ID 14920 //
     /*  783294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783365 */     GIR_RootConstrainSelectedInstOperands,
     /*  783366 */     // GIR_Coverage, 14920,
     /*  783366 */     GIR_EraseRootFromParent_Done,
     /*  783367 */   // Label 12183: @783367
     /*  783367 */   GIM_Try, /*On fail goto*//*Label 12184*/ GIMT_Encode4(783445), // Rule ID 14921 //
     /*  783372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  783383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  783386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  783389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  783407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11617:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  783421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783443 */     GIR_RootConstrainSelectedInstOperands,
     /*  783444 */     // GIR_Coverage, 14921,
     /*  783444 */     GIR_EraseRootFromParent_Done,
     /*  783445 */   // Label 12184: @783445
     /*  783445 */   GIM_Try, /*On fail goto*//*Label 12185*/ GIMT_Encode4(783523), // Rule ID 14924 //
     /*  783450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783496 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783521 */     GIR_RootConstrainSelectedInstOperands,
     /*  783522 */     // GIR_Coverage, 14924,
     /*  783522 */     GIR_EraseRootFromParent_Done,
     /*  783523 */   // Label 12185: @783523
     /*  783523 */   GIM_Try, /*On fail goto*//*Label 12186*/ GIMT_Encode4(783601), // Rule ID 14925 //
     /*  783528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783574 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11617:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783599 */     GIR_RootConstrainSelectedInstOperands,
     /*  783600 */     // GIR_Coverage, 14925,
     /*  783600 */     GIR_EraseRootFromParent_Done,
     /*  783601 */   // Label 12186: @783601
     /*  783601 */   GIM_Try, /*On fail goto*//*Label 12187*/ GIMT_Encode4(783679), // Rule ID 14928 //
     /*  783606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  783617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  783620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  783623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783652 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783677 */     GIR_RootConstrainSelectedInstOperands,
     /*  783678 */     // GIR_Coverage, 14928,
     /*  783678 */     GIR_EraseRootFromParent_Done,
     /*  783679 */   // Label 12187: @783679
     /*  783679 */   GIM_Try, /*On fail goto*//*Label 12188*/ GIMT_Encode4(783757), // Rule ID 14929 //
     /*  783684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  783695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  783698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  783701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783730 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11617:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783755 */     GIR_RootConstrainSelectedInstOperands,
     /*  783756 */     // GIR_Coverage, 14929,
     /*  783756 */     GIR_EraseRootFromParent_Done,
     /*  783757 */   // Label 12188: @783757
     /*  783757 */   GIM_Try, /*On fail goto*//*Label 12189*/ GIMT_Encode4(783832), // Rule ID 19170 //
     /*  783762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  783765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  783773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  783776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  783779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  783782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783808 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  783811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783830 */     GIR_RootConstrainSelectedInstOperands,
     /*  783831 */     // GIR_Coverage, 19170,
     /*  783831 */     GIR_EraseRootFromParent_Done,
     /*  783832 */   // Label 12189: @783832
     /*  783832 */   GIM_Try, /*On fail goto*//*Label 12190*/ GIMT_Encode4(783907), // Rule ID 19171 //
     /*  783837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  783840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  783848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  783851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  783854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  783857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783883 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  783886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783905 */     GIR_RootConstrainSelectedInstOperands,
     /*  783906 */     // GIR_Coverage, 19171,
     /*  783906 */     GIR_EraseRootFromParent_Done,
     /*  783907 */   // Label 12190: @783907
     /*  783907 */   GIM_Try, /*On fail goto*//*Label 12191*/ GIMT_Encode4(783982), // Rule ID 19174 //
     /*  783912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  783915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  783923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  783926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  783929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  783932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783958 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  783961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783980 */     GIR_RootConstrainSelectedInstOperands,
     /*  783981 */     // GIR_Coverage, 19174,
     /*  783981 */     GIR_EraseRootFromParent_Done,
     /*  783982 */   // Label 12191: @783982
     /*  783982 */   GIM_Try, /*On fail goto*//*Label 12192*/ GIMT_Encode4(784057), // Rule ID 19175 //
     /*  783987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  783990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  783998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  784001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  784004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  784007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784033 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  784036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784055 */     GIR_RootConstrainSelectedInstOperands,
     /*  784056 */     // GIR_Coverage, 19175,
     /*  784056 */     GIR_EraseRootFromParent_Done,
     /*  784057 */   // Label 12192: @784057
     /*  784057 */   GIM_Try, /*On fail goto*//*Label 12193*/ GIMT_Encode4(784132), // Rule ID 19178 //
     /*  784062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  784082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784108 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  784111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784130 */     GIR_RootConstrainSelectedInstOperands,
     /*  784131 */     // GIR_Coverage, 19178,
     /*  784131 */     GIR_EraseRootFromParent_Done,
     /*  784132 */   // Label 12193: @784132
     /*  784132 */   GIM_Try, /*On fail goto*//*Label 12194*/ GIMT_Encode4(784207), // Rule ID 19179 //
     /*  784137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  784148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  784151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  784154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  784157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784183 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  784186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784205 */     GIR_RootConstrainSelectedInstOperands,
     /*  784206 */     // GIR_Coverage, 19179,
     /*  784206 */     GIR_EraseRootFromParent_Done,
     /*  784207 */   // Label 12194: @784207
     /*  784207 */   GIM_Try, /*On fail goto*//*Label 12195*/ GIMT_Encode4(784282), // Rule ID 19182 //
     /*  784212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  784229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  784232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784258 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  784261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784280 */     GIR_RootConstrainSelectedInstOperands,
     /*  784281 */     // GIR_Coverage, 19182,
     /*  784281 */     GIR_EraseRootFromParent_Done,
     /*  784282 */   // Label 12195: @784282
     /*  784282 */   GIM_Try, /*On fail goto*//*Label 12196*/ GIMT_Encode4(784357), // Rule ID 19183 //
     /*  784287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  784298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  784301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  784304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  784307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784333 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  784336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784355 */     GIR_RootConstrainSelectedInstOperands,
     /*  784356 */     // GIR_Coverage, 19183,
     /*  784356 */     GIR_EraseRootFromParent_Done,
     /*  784357 */   // Label 12196: @784357
     /*  784357 */   GIM_Try, /*On fail goto*//*Label 12197*/ GIMT_Encode4(784432), // Rule ID 19186 //
     /*  784362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  784373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  784376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  784379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  784382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  784411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784430 */     GIR_RootConstrainSelectedInstOperands,
     /*  784431 */     // GIR_Coverage, 19186,
     /*  784431 */     GIR_EraseRootFromParent_Done,
     /*  784432 */   // Label 12197: @784432
     /*  784432 */   GIM_Try, /*On fail goto*//*Label 12198*/ GIMT_Encode4(784507), // Rule ID 19187 //
     /*  784437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  784448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  784451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  784454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  784457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784483 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  784486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784505 */     GIR_RootConstrainSelectedInstOperands,
     /*  784506 */     // GIR_Coverage, 19187,
     /*  784506 */     GIR_EraseRootFromParent_Done,
     /*  784507 */   // Label 12198: @784507
     /*  784507 */   GIM_Try, /*On fail goto*//*Label 12199*/ GIMT_Encode4(784582), // Rule ID 19190 //
     /*  784512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  784515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  784523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  784526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  784529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  784532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784558 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  784558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  784561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784580 */     GIR_RootConstrainSelectedInstOperands,
     /*  784581 */     // GIR_Coverage, 19190,
     /*  784581 */     GIR_EraseRootFromParent_Done,
     /*  784582 */   // Label 12199: @784582
     /*  784582 */   GIM_Try, /*On fail goto*//*Label 12200*/ GIMT_Encode4(784657), // Rule ID 19191 //
     /*  784587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  784590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  784598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  784601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  784604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  784607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784633 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  784633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  784636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784655 */     GIR_RootConstrainSelectedInstOperands,
     /*  784656 */     // GIR_Coverage, 19191,
     /*  784656 */     GIR_EraseRootFromParent_Done,
     /*  784657 */   // Label 12200: @784657
     /*  784657 */   GIM_Try, /*On fail goto*//*Label 12201*/ GIMT_Encode4(784732), // Rule ID 19194 //
     /*  784662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  784673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  784676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  784679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  784682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784708 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  784711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784730 */     GIR_RootConstrainSelectedInstOperands,
     /*  784731 */     // GIR_Coverage, 19194,
     /*  784731 */     GIR_EraseRootFromParent_Done,
     /*  784732 */   // Label 12201: @784732
     /*  784732 */   GIM_Try, /*On fail goto*//*Label 12202*/ GIMT_Encode4(784807), // Rule ID 19195 //
     /*  784737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  784748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  784751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  784754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  784757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784783 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  784786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784805 */     GIR_RootConstrainSelectedInstOperands,
     /*  784806 */     // GIR_Coverage, 19195,
     /*  784806 */     GIR_EraseRootFromParent_Done,
     /*  784807 */   // Label 12202: @784807
     /*  784807 */   GIM_Try, /*On fail goto*//*Label 12203*/ GIMT_Encode4(784882), // Rule ID 19198 //
     /*  784812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  784823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  784826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  784829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  784832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784858 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  784861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784880 */     GIR_RootConstrainSelectedInstOperands,
     /*  784881 */     // GIR_Coverage, 19198,
     /*  784881 */     GIR_EraseRootFromParent_Done,
     /*  784882 */   // Label 12203: @784882
     /*  784882 */   GIM_Try, /*On fail goto*//*Label 12204*/ GIMT_Encode4(784957), // Rule ID 19199 //
     /*  784887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  784898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  784901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  784904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  784907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784933 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  784936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784955 */     GIR_RootConstrainSelectedInstOperands,
     /*  784956 */     // GIR_Coverage, 19199,
     /*  784956 */     GIR_EraseRootFromParent_Done,
     /*  784957 */   // Label 12204: @784957
     /*  784957 */   GIM_Try, /*On fail goto*//*Label 12205*/ GIMT_Encode4(785032), // Rule ID 19202 //
     /*  784962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  784973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  784976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  784979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  784982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785008 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  785011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785030 */     GIR_RootConstrainSelectedInstOperands,
     /*  785031 */     // GIR_Coverage, 19202,
     /*  785031 */     GIR_EraseRootFromParent_Done,
     /*  785032 */   // Label 12205: @785032
     /*  785032 */   GIM_Try, /*On fail goto*//*Label 12206*/ GIMT_Encode4(785107), // Rule ID 19203 //
     /*  785037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  785048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  785051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  785054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  785057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785083 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  785086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785105 */     GIR_RootConstrainSelectedInstOperands,
     /*  785106 */     // GIR_Coverage, 19203,
     /*  785106 */     GIR_EraseRootFromParent_Done,
     /*  785107 */   // Label 12206: @785107
     /*  785107 */   GIM_Try, /*On fail goto*//*Label 12207*/ GIMT_Encode4(785182), // Rule ID 19206 //
     /*  785112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785158 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  785161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785180 */     GIR_RootConstrainSelectedInstOperands,
     /*  785181 */     // GIR_Coverage, 19206,
     /*  785181 */     GIR_EraseRootFromParent_Done,
     /*  785182 */   // Label 12207: @785182
     /*  785182 */   GIM_Try, /*On fail goto*//*Label 12208*/ GIMT_Encode4(785257), // Rule ID 19207 //
     /*  785187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  785198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  785201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  785204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  785207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785233 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  785236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785255 */     GIR_RootConstrainSelectedInstOperands,
     /*  785256 */     // GIR_Coverage, 19207,
     /*  785256 */     GIR_EraseRootFromParent_Done,
     /*  785257 */   // Label 12208: @785257
     /*  785257 */   GIM_Try, /*On fail goto*//*Label 12209*/ GIMT_Encode4(785332), // Rule ID 19210 //
     /*  785262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  785279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  785282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785308 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  785311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785330 */     GIR_RootConstrainSelectedInstOperands,
     /*  785331 */     // GIR_Coverage, 19210,
     /*  785331 */     GIR_EraseRootFromParent_Done,
     /*  785332 */   // Label 12209: @785332
     /*  785332 */   GIM_Try, /*On fail goto*//*Label 12210*/ GIMT_Encode4(785407), // Rule ID 19211 //
     /*  785337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  785348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  785351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  785354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  785357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785383 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  785386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785405 */     GIR_RootConstrainSelectedInstOperands,
     /*  785406 */     // GIR_Coverage, 19211,
     /*  785406 */     GIR_EraseRootFromParent_Done,
     /*  785407 */   // Label 12210: @785407
     /*  785407 */   GIM_Try, /*On fail goto*//*Label 12211*/ GIMT_Encode4(785482), // Rule ID 19214 //
     /*  785412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  785429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  785432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785458 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  785461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785480 */     GIR_RootConstrainSelectedInstOperands,
     /*  785481 */     // GIR_Coverage, 19214,
     /*  785481 */     GIR_EraseRootFromParent_Done,
     /*  785482 */   // Label 12211: @785482
     /*  785482 */   GIM_Try, /*On fail goto*//*Label 12212*/ GIMT_Encode4(785557), // Rule ID 19215 //
     /*  785487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  785498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  785501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  785504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  785507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785533 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  785536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785555 */     GIR_RootConstrainSelectedInstOperands,
     /*  785556 */     // GIR_Coverage, 19215,
     /*  785556 */     GIR_EraseRootFromParent_Done,
     /*  785557 */   // Label 12212: @785557
     /*  785557 */   GIM_Try, /*On fail goto*//*Label 12213*/ GIMT_Encode4(785632), // Rule ID 19218 //
     /*  785562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  785565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  785573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  785576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  785579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  785582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785608 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  785611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785630 */     GIR_RootConstrainSelectedInstOperands,
     /*  785631 */     // GIR_Coverage, 19218,
     /*  785631 */     GIR_EraseRootFromParent_Done,
     /*  785632 */   // Label 12213: @785632
     /*  785632 */   GIM_Try, /*On fail goto*//*Label 12214*/ GIMT_Encode4(785707), // Rule ID 19219 //
     /*  785637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  785648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  785651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  785654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  785657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785683 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  785686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785705 */     GIR_RootConstrainSelectedInstOperands,
     /*  785706 */     // GIR_Coverage, 19219,
     /*  785706 */     GIR_EraseRootFromParent_Done,
     /*  785707 */   // Label 12214: @785707
     /*  785707 */   GIM_Try, /*On fail goto*//*Label 12215*/ GIMT_Encode4(785782), // Rule ID 19222 //
     /*  785712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  785715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  785723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  785726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  785729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  785732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785758 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  785761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785780 */     GIR_RootConstrainSelectedInstOperands,
     /*  785781 */     // GIR_Coverage, 19222,
     /*  785781 */     GIR_EraseRootFromParent_Done,
     /*  785782 */   // Label 12215: @785782
     /*  785782 */   GIM_Try, /*On fail goto*//*Label 12216*/ GIMT_Encode4(785857), // Rule ID 19223 //
     /*  785787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  785798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  785801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  785804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  785807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785833 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  785836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785855 */     GIR_RootConstrainSelectedInstOperands,
     /*  785856 */     // GIR_Coverage, 19223,
     /*  785856 */     GIR_EraseRootFromParent_Done,
     /*  785857 */   // Label 12216: @785857
     /*  785857 */   GIM_Try, /*On fail goto*//*Label 12217*/ GIMT_Encode4(785932), // Rule ID 19226 //
     /*  785862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  785865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  785873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  785876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  785879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  785882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785908 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  785911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785930 */     GIR_RootConstrainSelectedInstOperands,
     /*  785931 */     // GIR_Coverage, 19226,
     /*  785931 */     GIR_EraseRootFromParent_Done,
     /*  785932 */   // Label 12217: @785932
     /*  785932 */   GIM_Try, /*On fail goto*//*Label 12218*/ GIMT_Encode4(786007), // Rule ID 19227 //
     /*  785937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  785948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  785951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  785954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  785957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785983 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  785986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786005 */     GIR_RootConstrainSelectedInstOperands,
     /*  786006 */     // GIR_Coverage, 19227,
     /*  786006 */     GIR_EraseRootFromParent_Done,
     /*  786007 */   // Label 12218: @786007
     /*  786007 */   GIM_Try, /*On fail goto*//*Label 12219*/ GIMT_Encode4(786082), // Rule ID 19230 //
     /*  786012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  786029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786058 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  786061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786080 */     GIR_RootConstrainSelectedInstOperands,
     /*  786081 */     // GIR_Coverage, 19230,
     /*  786081 */     GIR_EraseRootFromParent_Done,
     /*  786082 */   // Label 12219: @786082
     /*  786082 */   GIM_Try, /*On fail goto*//*Label 12220*/ GIMT_Encode4(786157), // Rule ID 19231 //
     /*  786087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  786098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  786101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  786104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786133 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  786136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786155 */     GIR_RootConstrainSelectedInstOperands,
     /*  786156 */     // GIR_Coverage, 19231,
     /*  786156 */     GIR_EraseRootFromParent_Done,
     /*  786157 */   // Label 12220: @786157
     /*  786157 */   GIM_Try, /*On fail goto*//*Label 12221*/ GIMT_Encode4(786232), // Rule ID 19234 //
     /*  786162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  786179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786208 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  786211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786230 */     GIR_RootConstrainSelectedInstOperands,
     /*  786231 */     // GIR_Coverage, 19234,
     /*  786231 */     GIR_EraseRootFromParent_Done,
     /*  786232 */   // Label 12221: @786232
     /*  786232 */   GIM_Try, /*On fail goto*//*Label 12222*/ GIMT_Encode4(786307), // Rule ID 19235 //
     /*  786237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  786248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  786251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  786254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786283 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  786286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786305 */     GIR_RootConstrainSelectedInstOperands,
     /*  786306 */     // GIR_Coverage, 19235,
     /*  786306 */     GIR_EraseRootFromParent_Done,
     /*  786307 */   // Label 12222: @786307
     /*  786307 */   GIM_Try, /*On fail goto*//*Label 12223*/ GIMT_Encode4(786382), // Rule ID 19238 //
     /*  786312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  786315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  786323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  786326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  786329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786358 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  786361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786380 */     GIR_RootConstrainSelectedInstOperands,
     /*  786381 */     // GIR_Coverage, 19238,
     /*  786381 */     GIR_EraseRootFromParent_Done,
     /*  786382 */   // Label 12223: @786382
     /*  786382 */   GIM_Try, /*On fail goto*//*Label 12224*/ GIMT_Encode4(786457), // Rule ID 19239 //
     /*  786387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  786390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  786398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  786401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  786404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786433 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  786436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786455 */     GIR_RootConstrainSelectedInstOperands,
     /*  786456 */     // GIR_Coverage, 19239,
     /*  786456 */     GIR_EraseRootFromParent_Done,
     /*  786457 */   // Label 12224: @786457
     /*  786457 */   GIM_Try, /*On fail goto*//*Label 12225*/ GIMT_Encode4(786532), // Rule ID 19242 //
     /*  786462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  786473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  786476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  786479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786508 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  786511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786530 */     GIR_RootConstrainSelectedInstOperands,
     /*  786531 */     // GIR_Coverage, 19242,
     /*  786531 */     GIR_EraseRootFromParent_Done,
     /*  786532 */   // Label 12225: @786532
     /*  786532 */   GIM_Try, /*On fail goto*//*Label 12226*/ GIMT_Encode4(786607), // Rule ID 19243 //
     /*  786537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  786548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  786551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  786554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786583 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11212:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  786586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786605 */     GIR_RootConstrainSelectedInstOperands,
     /*  786606 */     // GIR_Coverage, 19243,
     /*  786606 */     GIR_EraseRootFromParent_Done,
     /*  786607 */   // Label 12226: @786607
     /*  786607 */   GIM_Try, /*On fail goto*//*Label 12227*/ GIMT_Encode4(786682), // Rule ID 19246 //
     /*  786612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  786615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  786623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  786626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  786629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786658 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  786661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786680 */     GIR_RootConstrainSelectedInstOperands,
     /*  786681 */     // GIR_Coverage, 19246,
     /*  786681 */     GIR_EraseRootFromParent_Done,
     /*  786682 */   // Label 12227: @786682
     /*  786682 */   GIM_Try, /*On fail goto*//*Label 12228*/ GIMT_Encode4(786757), // Rule ID 19247 //
     /*  786687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  786690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  786698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  786701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  786704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786733 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  786736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786755 */     GIR_RootConstrainSelectedInstOperands,
     /*  786756 */     // GIR_Coverage, 19247,
     /*  786756 */     GIR_EraseRootFromParent_Done,
     /*  786757 */   // Label 12228: @786757
     /*  786757 */   GIM_Try, /*On fail goto*//*Label 12229*/ GIMT_Encode4(786832), // Rule ID 19250 //
     /*  786762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  786765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  786773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  786776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  786779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  786801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786808 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  786808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  786811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786830 */     GIR_RootConstrainSelectedInstOperands,
     /*  786831 */     // GIR_Coverage, 19250,
     /*  786831 */     GIR_EraseRootFromParent_Done,
     /*  786832 */   // Label 12229: @786832
     /*  786832 */   GIM_Try, /*On fail goto*//*Label 12230*/ GIMT_Encode4(786907), // Rule ID 19251 //
     /*  786837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  786840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  786848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  786851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  786854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  786876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786883 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  786883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  786886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786905 */     GIR_RootConstrainSelectedInstOperands,
     /*  786906 */     // GIR_Coverage, 19251,
     /*  786906 */     GIR_EraseRootFromParent_Done,
     /*  786907 */   // Label 12230: @786907
     /*  786907 */   GIM_Try, /*On fail goto*//*Label 12231*/ GIMT_Encode4(786982), // Rule ID 19254 //
     /*  786912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  786929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786958 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  786961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786980 */     GIR_RootConstrainSelectedInstOperands,
     /*  786981 */     // GIR_Coverage, 19254,
     /*  786981 */     GIR_EraseRootFromParent_Done,
     /*  786982 */   // Label 12231: @786982
     /*  786982 */   GIM_Try, /*On fail goto*//*Label 12232*/ GIMT_Encode4(787057), // Rule ID 19255 //
     /*  786987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  787001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  787004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787033 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  787036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787055 */     GIR_RootConstrainSelectedInstOperands,
     /*  787056 */     // GIR_Coverage, 19255,
     /*  787056 */     GIR_EraseRootFromParent_Done,
     /*  787057 */   // Label 12232: @787057
     /*  787057 */   GIM_Try, /*On fail goto*//*Label 12233*/ GIMT_Encode4(787132), // Rule ID 19258 //
     /*  787062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  787073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  787076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787108 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  787111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787130 */     GIR_RootConstrainSelectedInstOperands,
     /*  787131 */     // GIR_Coverage, 19258,
     /*  787131 */     GIR_EraseRootFromParent_Done,
     /*  787132 */   // Label 12233: @787132
     /*  787132 */   GIM_Try, /*On fail goto*//*Label 12234*/ GIMT_Encode4(787207), // Rule ID 19259 //
     /*  787137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  787148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  787151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  787154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787183 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  787186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787205 */     GIR_RootConstrainSelectedInstOperands,
     /*  787206 */     // GIR_Coverage, 19259,
     /*  787206 */     GIR_EraseRootFromParent_Done,
     /*  787207 */   // Label 12234: @787207
     /*  787207 */   GIM_Try, /*On fail goto*//*Label 12235*/ GIMT_Encode4(787282), // Rule ID 19262 //
     /*  787212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  787223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  787226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  787229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787258 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  787261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787280 */     GIR_RootConstrainSelectedInstOperands,
     /*  787281 */     // GIR_Coverage, 19262,
     /*  787281 */     GIR_EraseRootFromParent_Done,
     /*  787282 */   // Label 12235: @787282
     /*  787282 */   GIM_Try, /*On fail goto*//*Label 12236*/ GIMT_Encode4(787357), // Rule ID 19263 //
     /*  787287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  787298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  787301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  787304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  787307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  787326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787333 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  787336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787355 */     GIR_RootConstrainSelectedInstOperands,
     /*  787356 */     // GIR_Coverage, 19263,
     /*  787356 */     GIR_EraseRootFromParent_Done,
     /*  787357 */   // Label 12236: @787357
     /*  787357 */   GIM_Try, /*On fail goto*//*Label 12237*/ GIMT_Encode4(787432), // Rule ID 19266 //
     /*  787362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  787379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787408 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  787411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787430 */     GIR_RootConstrainSelectedInstOperands,
     /*  787431 */     // GIR_Coverage, 19266,
     /*  787431 */     GIR_EraseRootFromParent_Done,
     /*  787432 */   // Label 12237: @787432
     /*  787432 */   GIM_Try, /*On fail goto*//*Label 12238*/ GIMT_Encode4(787507), // Rule ID 19267 //
     /*  787437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  787448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  787451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  787454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787483 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  787486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787505 */     GIR_RootConstrainSelectedInstOperands,
     /*  787506 */     // GIR_Coverage, 19267,
     /*  787506 */     GIR_EraseRootFromParent_Done,
     /*  787507 */   // Label 12238: @787507
     /*  787507 */   GIM_Try, /*On fail goto*//*Label 12239*/ GIMT_Encode4(787582), // Rule ID 19270 //
     /*  787512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  787526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  787529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787558 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  787561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787580 */     GIR_RootConstrainSelectedInstOperands,
     /*  787581 */     // GIR_Coverage, 19270,
     /*  787581 */     GIR_EraseRootFromParent_Done,
     /*  787582 */   // Label 12239: @787582
     /*  787582 */   GIM_Try, /*On fail goto*//*Label 12240*/ GIMT_Encode4(787657), // Rule ID 19271 //
     /*  787587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  787601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  787604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787633 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  787636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787655 */     GIR_RootConstrainSelectedInstOperands,
     /*  787656 */     // GIR_Coverage, 19271,
     /*  787656 */     GIR_EraseRootFromParent_Done,
     /*  787657 */   // Label 12240: @787657
     /*  787657 */   GIM_Try, /*On fail goto*//*Label 12241*/ GIMT_Encode4(787732), // Rule ID 19274 //
     /*  787662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  787679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  787711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787730 */     GIR_RootConstrainSelectedInstOperands,
     /*  787731 */     // GIR_Coverage, 19274,
     /*  787731 */     GIR_EraseRootFromParent_Done,
     /*  787732 */   // Label 12241: @787732
     /*  787732 */   GIM_Try, /*On fail goto*//*Label 12242*/ GIMT_Encode4(787807), // Rule ID 19275 //
     /*  787737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  787754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787783 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  787786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787805 */     GIR_RootConstrainSelectedInstOperands,
     /*  787806 */     // GIR_Coverage, 19275,
     /*  787806 */     GIR_EraseRootFromParent_Done,
     /*  787807 */   // Label 12242: @787807
     /*  787807 */   GIM_Try, /*On fail goto*//*Label 12243*/ GIMT_Encode4(787882), // Rule ID 19278 //
     /*  787812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  787815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787858 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  787861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787880 */     GIR_RootConstrainSelectedInstOperands,
     /*  787881 */     // GIR_Coverage, 19278,
     /*  787881 */     GIR_EraseRootFromParent_Done,
     /*  787882 */   // Label 12243: @787882
     /*  787882 */   GIM_Try, /*On fail goto*//*Label 12244*/ GIMT_Encode4(787957), // Rule ID 19279 //
     /*  787887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  787890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  787936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787955 */     GIR_RootConstrainSelectedInstOperands,
     /*  787956 */     // GIR_Coverage, 19279,
     /*  787956 */     GIR_EraseRootFromParent_Done,
     /*  787957 */   // Label 12244: @787957
     /*  787957 */   GIM_Try, /*On fail goto*//*Label 12245*/ GIMT_Encode4(788032), // Rule ID 19282 //
     /*  787962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  787965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  787973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  787976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  787979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788008 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  788011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788030 */     GIR_RootConstrainSelectedInstOperands,
     /*  788031 */     // GIR_Coverage, 19282,
     /*  788031 */     GIR_EraseRootFromParent_Done,
     /*  788032 */   // Label 12245: @788032
     /*  788032 */   GIM_Try, /*On fail goto*//*Label 12246*/ GIMT_Encode4(788107), // Rule ID 19283 //
     /*  788037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  788048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  788051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  788054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788083 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  788086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788105 */     GIR_RootConstrainSelectedInstOperands,
     /*  788106 */     // GIR_Coverage, 19283,
     /*  788106 */     GIR_EraseRootFromParent_Done,
     /*  788107 */   // Label 12246: @788107
     /*  788107 */   GIM_Try, /*On fail goto*//*Label 12247*/ GIMT_Encode4(788182), // Rule ID 19286 //
     /*  788112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788158 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  788161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788180 */     GIR_RootConstrainSelectedInstOperands,
     /*  788181 */     // GIR_Coverage, 19286,
     /*  788181 */     GIR_EraseRootFromParent_Done,
     /*  788182 */   // Label 12247: @788182
     /*  788182 */   GIM_Try, /*On fail goto*//*Label 12248*/ GIMT_Encode4(788257), // Rule ID 19287 //
     /*  788187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  788195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  788198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  788201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  788204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  788207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  788226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788233 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  788236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788255 */     GIR_RootConstrainSelectedInstOperands,
     /*  788256 */     // GIR_Coverage, 19287,
     /*  788256 */     GIR_EraseRootFromParent_Done,
     /*  788257 */   // Label 12248: @788257
     /*  788257 */   GIM_Try, /*On fail goto*//*Label 12249*/ GIMT_Encode4(788332), // Rule ID 19290 //
     /*  788262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  788273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  788276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  788279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  788282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788308 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  788311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788330 */     GIR_RootConstrainSelectedInstOperands,
     /*  788331 */     // GIR_Coverage, 19290,
     /*  788331 */     GIR_EraseRootFromParent_Done,
     /*  788332 */   // Label 12249: @788332
     /*  788332 */   GIM_Try, /*On fail goto*//*Label 12250*/ GIMT_Encode4(788407), // Rule ID 19291 //
     /*  788337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  788348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  788351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  788354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  788357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788383 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  788386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788405 */     GIR_RootConstrainSelectedInstOperands,
     /*  788406 */     // GIR_Coverage, 19291,
     /*  788406 */     GIR_EraseRootFromParent_Done,
     /*  788407 */   // Label 12250: @788407
     /*  788407 */   GIM_Try, /*On fail goto*//*Label 12251*/ GIMT_Encode4(788482), // Rule ID 19294 //
     /*  788412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  788423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  788426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  788429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  788432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788458 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  788461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788480 */     GIR_RootConstrainSelectedInstOperands,
     /*  788481 */     // GIR_Coverage, 19294,
     /*  788481 */     GIR_EraseRootFromParent_Done,
     /*  788482 */   // Label 12251: @788482
     /*  788482 */   GIM_Try, /*On fail goto*//*Label 12252*/ GIMT_Encode4(788557), // Rule ID 19295 //
     /*  788487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  788498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  788501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  788504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  788507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788533 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  788536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788555 */     GIR_RootConstrainSelectedInstOperands,
     /*  788556 */     // GIR_Coverage, 19295,
     /*  788556 */     GIR_EraseRootFromParent_Done,
     /*  788557 */   // Label 12252: @788557
     /*  788557 */   GIM_Try, /*On fail goto*//*Label 12253*/ GIMT_Encode4(788632), // Rule ID 19298 //
     /*  788562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  788573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  788576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  788579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  788582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  788611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788630 */     GIR_RootConstrainSelectedInstOperands,
     /*  788631 */     // GIR_Coverage, 19298,
     /*  788631 */     GIR_EraseRootFromParent_Done,
     /*  788632 */   // Label 12253: @788632
     /*  788632 */   GIM_Try, /*On fail goto*//*Label 12254*/ GIMT_Encode4(788707), // Rule ID 19299 //
     /*  788637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  788648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  788651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  788654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  788657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788683 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  788686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788705 */     GIR_RootConstrainSelectedInstOperands,
     /*  788706 */     // GIR_Coverage, 19299,
     /*  788706 */     GIR_EraseRootFromParent_Done,
     /*  788707 */   // Label 12254: @788707
     /*  788707 */   GIM_Try, /*On fail goto*//*Label 12255*/ GIMT_Encode4(788782), // Rule ID 19302 //
     /*  788712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788758 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  788761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788780 */     GIR_RootConstrainSelectedInstOperands,
     /*  788781 */     // GIR_Coverage, 19302,
     /*  788781 */     GIR_EraseRootFromParent_Done,
     /*  788782 */   // Label 12255: @788782
     /*  788782 */   GIM_Try, /*On fail goto*//*Label 12256*/ GIMT_Encode4(788857), // Rule ID 19303 //
     /*  788787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788833 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  788836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788855 */     GIR_RootConstrainSelectedInstOperands,
     /*  788856 */     // GIR_Coverage, 19303,
     /*  788856 */     GIR_EraseRootFromParent_Done,
     /*  788857 */   // Label 12256: @788857
     /*  788857 */   GIM_Try, /*On fail goto*//*Label 12257*/ GIMT_Encode4(788932), // Rule ID 19306 //
     /*  788862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  788911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788930 */     GIR_RootConstrainSelectedInstOperands,
     /*  788931 */     // GIR_Coverage, 19306,
     /*  788931 */     GIR_EraseRootFromParent_Done,
     /*  788932 */   // Label 12257: @788932
     /*  788932 */   GIM_Try, /*On fail goto*//*Label 12258*/ GIMT_Encode4(789007), // Rule ID 19307 //
     /*  788937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788983 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  788986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789005 */     GIR_RootConstrainSelectedInstOperands,
     /*  789006 */     // GIR_Coverage, 19307,
     /*  789006 */     GIR_EraseRootFromParent_Done,
     /*  789007 */   // Label 12258: @789007
     /*  789007 */   GIM_Try, /*On fail goto*//*Label 12259*/ GIMT_Encode4(789082), // Rule ID 19310 //
     /*  789012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  789061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789080 */     GIR_RootConstrainSelectedInstOperands,
     /*  789081 */     // GIR_Coverage, 19310,
     /*  789081 */     GIR_EraseRootFromParent_Done,
     /*  789082 */   // Label 12259: @789082
     /*  789082 */   GIM_Try, /*On fail goto*//*Label 12260*/ GIMT_Encode4(789157), // Rule ID 19311 //
     /*  789087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  789098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  789101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  789104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  789107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  789126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789133 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  789136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789155 */     GIR_RootConstrainSelectedInstOperands,
     /*  789156 */     // GIR_Coverage, 19311,
     /*  789156 */     GIR_EraseRootFromParent_Done,
     /*  789157 */   // Label 12260: @789157
     /*  789157 */   GIM_Try, /*On fail goto*//*Label 12261*/ GIMT_Encode4(789232), // Rule ID 19314 //
     /*  789162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  789173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  789176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  789179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  789182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789208 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  789211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789230 */     GIR_RootConstrainSelectedInstOperands,
     /*  789231 */     // GIR_Coverage, 19314,
     /*  789231 */     GIR_EraseRootFromParent_Done,
     /*  789232 */   // Label 12261: @789232
     /*  789232 */   GIM_Try, /*On fail goto*//*Label 12262*/ GIMT_Encode4(789307), // Rule ID 19315 //
     /*  789237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  789248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  789251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  789254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  789257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789283 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  789286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789305 */     GIR_RootConstrainSelectedInstOperands,
     /*  789306 */     // GIR_Coverage, 19315,
     /*  789306 */     GIR_EraseRootFromParent_Done,
     /*  789307 */   // Label 12262: @789307
     /*  789307 */   GIM_Try, /*On fail goto*//*Label 12263*/ GIMT_Encode4(789382), // Rule ID 19318 //
     /*  789312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  789323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  789326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  789329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  789332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789358 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  789361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789380 */     GIR_RootConstrainSelectedInstOperands,
     /*  789381 */     // GIR_Coverage, 19318,
     /*  789381 */     GIR_EraseRootFromParent_Done,
     /*  789382 */   // Label 12263: @789382
     /*  789382 */   GIM_Try, /*On fail goto*//*Label 12264*/ GIMT_Encode4(789457), // Rule ID 19319 //
     /*  789387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  789398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  789401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  789404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  789407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789433 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  789436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789455 */     GIR_RootConstrainSelectedInstOperands,
     /*  789456 */     // GIR_Coverage, 19319,
     /*  789456 */     GIR_EraseRootFromParent_Done,
     /*  789457 */   // Label 12264: @789457
     /*  789457 */   GIM_Try, /*On fail goto*//*Label 12265*/ GIMT_Encode4(789532), // Rule ID 19322 //
     /*  789462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  789465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  789473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  789476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  789479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  789482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789508 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  789511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789530 */     GIR_RootConstrainSelectedInstOperands,
     /*  789531 */     // GIR_Coverage, 19322,
     /*  789531 */     GIR_EraseRootFromParent_Done,
     /*  789532 */   // Label 12265: @789532
     /*  789532 */   GIM_Try, /*On fail goto*//*Label 12266*/ GIMT_Encode4(789607), // Rule ID 19323 //
     /*  789537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  789548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  789551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  789554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  789557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789583 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  789586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789605 */     GIR_RootConstrainSelectedInstOperands,
     /*  789606 */     // GIR_Coverage, 19323,
     /*  789606 */     GIR_EraseRootFromParent_Done,
     /*  789607 */   // Label 12266: @789607
     /*  789607 */   GIM_Try, /*On fail goto*//*Label 12267*/ GIMT_Encode4(789682), // Rule ID 19326 //
     /*  789612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  789623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  789626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  789629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  789632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789658 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  789661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789680 */     GIR_RootConstrainSelectedInstOperands,
     /*  789681 */     // GIR_Coverage, 19326,
     /*  789681 */     GIR_EraseRootFromParent_Done,
     /*  789682 */   // Label 12267: @789682
     /*  789682 */   GIM_Try, /*On fail goto*//*Label 12268*/ GIMT_Encode4(789757), // Rule ID 19327 //
     /*  789687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  789698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  789701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  789704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  789707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  789736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789755 */     GIR_RootConstrainSelectedInstOperands,
     /*  789756 */     // GIR_Coverage, 19327,
     /*  789756 */     GIR_EraseRootFromParent_Done,
     /*  789757 */   // Label 12268: @789757
     /*  789757 */   GIM_Try, /*On fail goto*//*Label 12269*/ GIMT_Encode4(789832), // Rule ID 19330 //
     /*  789762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789808 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  789811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789830 */     GIR_RootConstrainSelectedInstOperands,
     /*  789831 */     // GIR_Coverage, 19330,
     /*  789831 */     GIR_EraseRootFromParent_Done,
     /*  789832 */   // Label 12269: @789832
     /*  789832 */   GIM_Try, /*On fail goto*//*Label 12270*/ GIMT_Encode4(789907), // Rule ID 19331 //
     /*  789837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789883 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  789886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789905 */     GIR_RootConstrainSelectedInstOperands,
     /*  789906 */     // GIR_Coverage, 19331,
     /*  789906 */     GIR_EraseRootFromParent_Done,
     /*  789907 */   // Label 12270: @789907
     /*  789907 */   GIM_Try, /*On fail goto*//*Label 12271*/ GIMT_Encode4(789982), // Rule ID 19334 //
     /*  789912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  789923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  789926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  789929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  789932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789958 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  789961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789980 */     GIR_RootConstrainSelectedInstOperands,
     /*  789981 */     // GIR_Coverage, 19334,
     /*  789981 */     GIR_EraseRootFromParent_Done,
     /*  789982 */   // Label 12271: @789982
     /*  789982 */   GIM_Try, /*On fail goto*//*Label 12272*/ GIMT_Encode4(790057), // Rule ID 19335 //
     /*  789987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  789998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  790001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  790004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  790007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790033 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  790036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790055 */     GIR_RootConstrainSelectedInstOperands,
     /*  790056 */     // GIR_Coverage, 19335,
     /*  790056 */     GIR_EraseRootFromParent_Done,
     /*  790057 */   // Label 12272: @790057
     /*  790057 */   GIM_Try, /*On fail goto*//*Label 12273*/ GIMT_Encode4(790132), // Rule ID 19338 //
     /*  790062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  790082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  790111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790130 */     GIR_RootConstrainSelectedInstOperands,
     /*  790131 */     // GIR_Coverage, 19338,
     /*  790131 */     GIR_EraseRootFromParent_Done,
     /*  790132 */   // Label 12273: @790132
     /*  790132 */   GIM_Try, /*On fail goto*//*Label 12274*/ GIMT_Encode4(790207), // Rule ID 19339 //
     /*  790137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  790148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  790151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  790154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  790157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790183 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  790186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790205 */     GIR_RootConstrainSelectedInstOperands,
     /*  790206 */     // GIR_Coverage, 19339,
     /*  790206 */     GIR_EraseRootFromParent_Done,
     /*  790207 */   // Label 12274: @790207
     /*  790207 */   GIM_Try, /*On fail goto*//*Label 12275*/ GIMT_Encode4(790282), // Rule ID 19342 //
     /*  790212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  790232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790258 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  790261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790280 */     GIR_RootConstrainSelectedInstOperands,
     /*  790281 */     // GIR_Coverage, 19342,
     /*  790281 */     GIR_EraseRootFromParent_Done,
     /*  790282 */   // Label 12275: @790282
     /*  790282 */   GIM_Try, /*On fail goto*//*Label 12276*/ GIMT_Encode4(790357), // Rule ID 19343 //
     /*  790287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  790298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  790301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  790304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  790307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  790326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790333 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  790336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790355 */     GIR_RootConstrainSelectedInstOperands,
     /*  790356 */     // GIR_Coverage, 19343,
     /*  790356 */     GIR_EraseRootFromParent_Done,
     /*  790357 */   // Label 12276: @790357
     /*  790357 */   GIM_Try, /*On fail goto*//*Label 12277*/ GIMT_Encode4(790432), // Rule ID 19346 //
     /*  790362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790408 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  790411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790430 */     GIR_RootConstrainSelectedInstOperands,
     /*  790431 */     // GIR_Coverage, 19346,
     /*  790431 */     GIR_EraseRootFromParent_Done,
     /*  790432 */   // Label 12277: @790432
     /*  790432 */   GIM_Try, /*On fail goto*//*Label 12278*/ GIMT_Encode4(790507), // Rule ID 19347 //
     /*  790437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  790448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  790451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  790454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  790457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  790476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790483 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  790486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790505 */     GIR_RootConstrainSelectedInstOperands,
     /*  790506 */     // GIR_Coverage, 19347,
     /*  790506 */     GIR_EraseRootFromParent_Done,
     /*  790507 */   // Label 12278: @790507
     /*  790507 */   GIM_Try, /*On fail goto*//*Label 12279*/ GIMT_Encode4(790582), // Rule ID 19350 //
     /*  790512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  790523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  790526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  790529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790558 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  790561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790580 */     GIR_RootConstrainSelectedInstOperands,
     /*  790581 */     // GIR_Coverage, 19350,
     /*  790581 */     GIR_EraseRootFromParent_Done,
     /*  790582 */   // Label 12279: @790582
     /*  790582 */   GIM_Try, /*On fail goto*//*Label 12280*/ GIMT_Encode4(790657), // Rule ID 19351 //
     /*  790587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  790598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  790601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  790604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790633 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  790636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790655 */     GIR_RootConstrainSelectedInstOperands,
     /*  790656 */     // GIR_Coverage, 19351,
     /*  790656 */     GIR_EraseRootFromParent_Done,
     /*  790657 */   // Label 12280: @790657
     /*  790657 */   GIM_Try, /*On fail goto*//*Label 12281*/ GIMT_Encode4(790732), // Rule ID 19354 //
     /*  790662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790708 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  790711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790730 */     GIR_RootConstrainSelectedInstOperands,
     /*  790731 */     // GIR_Coverage, 19354,
     /*  790731 */     GIR_EraseRootFromParent_Done,
     /*  790732 */   // Label 12281: @790732
     /*  790732 */   GIM_Try, /*On fail goto*//*Label 12282*/ GIMT_Encode4(790807), // Rule ID 19355 //
     /*  790737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790783 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  790786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790805 */     GIR_RootConstrainSelectedInstOperands,
     /*  790806 */     // GIR_Coverage, 19355,
     /*  790806 */     GIR_EraseRootFromParent_Done,
     /*  790807 */   // Label 12282: @790807
     /*  790807 */   GIM_Try, /*On fail goto*//*Label 12283*/ GIMT_Encode4(790882), // Rule ID 19358 //
     /*  790812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790858 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  790861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790880 */     GIR_RootConstrainSelectedInstOperands,
     /*  790881 */     // GIR_Coverage, 19358,
     /*  790881 */     GIR_EraseRootFromParent_Done,
     /*  790882 */   // Label 12283: @790882
     /*  790882 */   GIM_Try, /*On fail goto*//*Label 12284*/ GIMT_Encode4(790957), // Rule ID 19359 //
     /*  790887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790933 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  790936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790955 */     GIR_RootConstrainSelectedInstOperands,
     /*  790956 */     // GIR_Coverage, 19359,
     /*  790956 */     GIR_EraseRootFromParent_Done,
     /*  790957 */   // Label 12284: @790957
     /*  790957 */   GIM_Try, /*On fail goto*//*Label 12285*/ GIMT_Encode4(791032), // Rule ID 19362 //
     /*  790962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  790973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  790976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  790979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  791011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791030 */     GIR_RootConstrainSelectedInstOperands,
     /*  791031 */     // GIR_Coverage, 19362,
     /*  791031 */     GIR_EraseRootFromParent_Done,
     /*  791032 */   // Label 12285: @791032
     /*  791032 */   GIM_Try, /*On fail goto*//*Label 12286*/ GIMT_Encode4(791107), // Rule ID 19363 //
     /*  791037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  791048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  791051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  791054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791083 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  791086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791105 */     GIR_RootConstrainSelectedInstOperands,
     /*  791106 */     // GIR_Coverage, 19363,
     /*  791106 */     GIR_EraseRootFromParent_Done,
     /*  791107 */   // Label 12286: @791107
     /*  791107 */   GIM_Try, /*On fail goto*//*Label 12287*/ GIMT_Encode4(791182), // Rule ID 19366 //
     /*  791112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  791123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  791126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  791129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791158 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  791161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791180 */     GIR_RootConstrainSelectedInstOperands,
     /*  791181 */     // GIR_Coverage, 19366,
     /*  791181 */     GIR_EraseRootFromParent_Done,
     /*  791182 */   // Label 12287: @791182
     /*  791182 */   GIM_Try, /*On fail goto*//*Label 12288*/ GIMT_Encode4(791257), // Rule ID 19367 //
     /*  791187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  791198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  791201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  791204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791233 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  791236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791255 */     GIR_RootConstrainSelectedInstOperands,
     /*  791256 */     // GIR_Coverage, 19367,
     /*  791256 */     GIR_EraseRootFromParent_Done,
     /*  791257 */   // Label 12288: @791257
     /*  791257 */   GIM_Try, /*On fail goto*//*Label 12289*/ GIMT_Encode4(791332), // Rule ID 19370 //
     /*  791262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  791273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  791276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  791279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791308 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  791308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  791311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791330 */     GIR_RootConstrainSelectedInstOperands,
     /*  791331 */     // GIR_Coverage, 19370,
     /*  791331 */     GIR_EraseRootFromParent_Done,
     /*  791332 */   // Label 12289: @791332
     /*  791332 */   GIM_Try, /*On fail goto*//*Label 12290*/ GIMT_Encode4(791407), // Rule ID 19371 //
     /*  791337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  791340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  791348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  791351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  791354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  791372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791383 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  791383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  791386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791405 */     GIR_RootConstrainSelectedInstOperands,
     /*  791406 */     // GIR_Coverage, 19371,
     /*  791406 */     GIR_EraseRootFromParent_Done,
     /*  791407 */   // Label 12290: @791407
     /*  791407 */   GIM_Try, /*On fail goto*//*Label 12291*/ GIMT_Encode4(791482), // Rule ID 19374 //
     /*  791412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  791423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  791426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  791429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791458 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  791461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791480 */     GIR_RootConstrainSelectedInstOperands,
     /*  791481 */     // GIR_Coverage, 19374,
     /*  791481 */     GIR_EraseRootFromParent_Done,
     /*  791482 */   // Label 12291: @791482
     /*  791482 */   GIM_Try, /*On fail goto*//*Label 12292*/ GIMT_Encode4(791557), // Rule ID 19375 //
     /*  791487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  791498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  791501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  791504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791533 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  791536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791555 */     GIR_RootConstrainSelectedInstOperands,
     /*  791556 */     // GIR_Coverage, 19375,
     /*  791556 */     GIR_EraseRootFromParent_Done,
     /*  791557 */   // Label 12292: @791557
     /*  791557 */   GIM_Try, /*On fail goto*//*Label 12293*/ GIMT_Encode4(791632), // Rule ID 19378 //
     /*  791562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  791573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  791576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  791579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791608 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  791611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791630 */     GIR_RootConstrainSelectedInstOperands,
     /*  791631 */     // GIR_Coverage, 19378,
     /*  791631 */     GIR_EraseRootFromParent_Done,
     /*  791632 */   // Label 12293: @791632
     /*  791632 */   GIM_Try, /*On fail goto*//*Label 12294*/ GIMT_Encode4(791707), // Rule ID 19379 //
     /*  791637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  791648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  791651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  791654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791683 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  791686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791705 */     GIR_RootConstrainSelectedInstOperands,
     /*  791706 */     // GIR_Coverage, 19379,
     /*  791706 */     GIR_EraseRootFromParent_Done,
     /*  791707 */   // Label 12294: @791707
     /*  791707 */   GIM_Try, /*On fail goto*//*Label 12295*/ GIMT_Encode4(791782), // Rule ID 19382 //
     /*  791712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791758 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  791761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791780 */     GIR_RootConstrainSelectedInstOperands,
     /*  791781 */     // GIR_Coverage, 19382,
     /*  791781 */     GIR_EraseRootFromParent_Done,
     /*  791782 */   // Label 12295: @791782
     /*  791782 */   GIM_Try, /*On fail goto*//*Label 12296*/ GIMT_Encode4(791857), // Rule ID 19383 //
     /*  791787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791833 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  791836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791855 */     GIR_RootConstrainSelectedInstOperands,
     /*  791856 */     // GIR_Coverage, 19383,
     /*  791856 */     GIR_EraseRootFromParent_Done,
     /*  791857 */   // Label 12296: @791857
     /*  791857 */   GIM_Try, /*On fail goto*//*Label 12297*/ GIMT_Encode4(791932), // Rule ID 19386 //
     /*  791862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791908 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  791911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791930 */     GIR_RootConstrainSelectedInstOperands,
     /*  791931 */     // GIR_Coverage, 19386,
     /*  791931 */     GIR_EraseRootFromParent_Done,
     /*  791932 */   // Label 12297: @791932
     /*  791932 */   GIM_Try, /*On fail goto*//*Label 12298*/ GIMT_Encode4(792007), // Rule ID 19387 //
     /*  791937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791983 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  791986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792005 */     GIR_RootConstrainSelectedInstOperands,
     /*  792006 */     // GIR_Coverage, 19387,
     /*  792006 */     GIR_EraseRootFromParent_Done,
     /*  792007 */   // Label 12298: @792007
     /*  792007 */   GIM_Try, /*On fail goto*//*Label 12299*/ GIMT_Encode4(792082), // Rule ID 19390 //
     /*  792012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  792023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  792026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  792029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792058 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  792061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792080 */     GIR_RootConstrainSelectedInstOperands,
     /*  792081 */     // GIR_Coverage, 19390,
     /*  792081 */     GIR_EraseRootFromParent_Done,
     /*  792082 */   // Label 12299: @792082
     /*  792082 */   GIM_Try, /*On fail goto*//*Label 12300*/ GIMT_Encode4(792157), // Rule ID 19391 //
     /*  792087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  792098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  792101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  792104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792133 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  792136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792155 */     GIR_RootConstrainSelectedInstOperands,
     /*  792156 */     // GIR_Coverage, 19391,
     /*  792156 */     GIR_EraseRootFromParent_Done,
     /*  792157 */   // Label 12300: @792157
     /*  792157 */   GIM_Try, /*On fail goto*//*Label 12301*/ GIMT_Encode4(792232), // Rule ID 19394 //
     /*  792162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  792173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  792176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  792179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792208 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  792211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792230 */     GIR_RootConstrainSelectedInstOperands,
     /*  792231 */     // GIR_Coverage, 19394,
     /*  792231 */     GIR_EraseRootFromParent_Done,
     /*  792232 */   // Label 12301: @792232
     /*  792232 */   GIM_Try, /*On fail goto*//*Label 12302*/ GIMT_Encode4(792307), // Rule ID 19395 //
     /*  792237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  792248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  792251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  792254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  792257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  792276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792283 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  792286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792305 */     GIR_RootConstrainSelectedInstOperands,
     /*  792306 */     // GIR_Coverage, 19395,
     /*  792306 */     GIR_EraseRootFromParent_Done,
     /*  792307 */   // Label 12302: @792307
     /*  792307 */   GIM_Try, /*On fail goto*//*Label 12303*/ GIMT_Encode4(792382), // Rule ID 19398 //
     /*  792312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  792323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  792326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  792329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792358 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  792361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792380 */     GIR_RootConstrainSelectedInstOperands,
     /*  792381 */     // GIR_Coverage, 19398,
     /*  792381 */     GIR_EraseRootFromParent_Done,
     /*  792382 */   // Label 12303: @792382
     /*  792382 */   GIM_Try, /*On fail goto*//*Label 12304*/ GIMT_Encode4(792457), // Rule ID 19399 //
     /*  792387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  792398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  792401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  792404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  792422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792433 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  792436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792455 */     GIR_RootConstrainSelectedInstOperands,
     /*  792456 */     // GIR_Coverage, 19399,
     /*  792456 */     GIR_EraseRootFromParent_Done,
     /*  792457 */   // Label 12304: @792457
     /*  792457 */   GIM_Try, /*On fail goto*//*Label 12305*/ GIMT_Encode4(792532), // Rule ID 19402 //
     /*  792462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  792473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  792476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  792479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  792511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792530 */     GIR_RootConstrainSelectedInstOperands,
     /*  792531 */     // GIR_Coverage, 19402,
     /*  792531 */     GIR_EraseRootFromParent_Done,
     /*  792532 */   // Label 12305: @792532
     /*  792532 */   GIM_Try, /*On fail goto*//*Label 12306*/ GIMT_Encode4(792607), // Rule ID 19403 //
     /*  792537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  792548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  792551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  792554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792583 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  792586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792605 */     GIR_RootConstrainSelectedInstOperands,
     /*  792606 */     // GIR_Coverage, 19403,
     /*  792606 */     GIR_EraseRootFromParent_Done,
     /*  792607 */   // Label 12306: @792607
     /*  792607 */   GIM_Try, /*On fail goto*//*Label 12307*/ GIMT_Encode4(792682), // Rule ID 19406 //
     /*  792612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  792623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  792626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  792629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792658 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  792661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792680 */     GIR_RootConstrainSelectedInstOperands,
     /*  792681 */     // GIR_Coverage, 19406,
     /*  792681 */     GIR_EraseRootFromParent_Done,
     /*  792682 */   // Label 12307: @792682
     /*  792682 */   GIM_Try, /*On fail goto*//*Label 12308*/ GIMT_Encode4(792757), // Rule ID 19407 //
     /*  792687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  792698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  792701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  792704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792733 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  792736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792755 */     GIR_RootConstrainSelectedInstOperands,
     /*  792756 */     // GIR_Coverage, 19407,
     /*  792756 */     GIR_EraseRootFromParent_Done,
     /*  792757 */   // Label 12308: @792757
     /*  792757 */   GIM_Try, /*On fail goto*//*Label 12309*/ GIMT_Encode4(792832), // Rule ID 19410 //
     /*  792762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792808 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  792811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792830 */     GIR_RootConstrainSelectedInstOperands,
     /*  792831 */     // GIR_Coverage, 19410,
     /*  792831 */     GIR_EraseRootFromParent_Done,
     /*  792832 */   // Label 12309: @792832
     /*  792832 */   GIM_Try, /*On fail goto*//*Label 12310*/ GIMT_Encode4(792907), // Rule ID 19411 //
     /*  792837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792883 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  792886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792905 */     GIR_RootConstrainSelectedInstOperands,
     /*  792906 */     // GIR_Coverage, 19411,
     /*  792906 */     GIR_EraseRootFromParent_Done,
     /*  792907 */   // Label 12310: @792907
     /*  792907 */   GIM_Try, /*On fail goto*//*Label 12311*/ GIMT_Encode4(792982), // Rule ID 19414 //
     /*  792912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  792923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  792926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  792929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  792932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792958 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  792961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792980 */     GIR_RootConstrainSelectedInstOperands,
     /*  792981 */     // GIR_Coverage, 19414,
     /*  792981 */     GIR_EraseRootFromParent_Done,
     /*  792982 */   // Label 12311: @792982
     /*  792982 */   GIM_Try, /*On fail goto*//*Label 12312*/ GIMT_Encode4(793057), // Rule ID 19415 //
     /*  792987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  792998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  793001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  793004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  793007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793033 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  793036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793055 */     GIR_RootConstrainSelectedInstOperands,
     /*  793056 */     // GIR_Coverage, 19415,
     /*  793056 */     GIR_EraseRootFromParent_Done,
     /*  793057 */   // Label 12312: @793057
     /*  793057 */   GIM_Try, /*On fail goto*//*Label 12313*/ GIMT_Encode4(793132), // Rule ID 19418 //
     /*  793062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  793073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  793076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  793079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  793082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793108 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  793111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793130 */     GIR_RootConstrainSelectedInstOperands,
     /*  793131 */     // GIR_Coverage, 19418,
     /*  793131 */     GIR_EraseRootFromParent_Done,
     /*  793132 */   // Label 12313: @793132
     /*  793132 */   GIM_Try, /*On fail goto*//*Label 12314*/ GIMT_Encode4(793207), // Rule ID 19419 //
     /*  793137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  793148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  793151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  793154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  793157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793183 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  793186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793205 */     GIR_RootConstrainSelectedInstOperands,
     /*  793206 */     // GIR_Coverage, 19419,
     /*  793206 */     GIR_EraseRootFromParent_Done,
     /*  793207 */   // Label 12314: @793207
     /*  793207 */   GIM_Try, /*On fail goto*//*Label 12315*/ GIMT_Encode4(793282), // Rule ID 19422 //
     /*  793212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  793223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  793226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  793229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  793232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793258 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  793261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793280 */     GIR_RootConstrainSelectedInstOperands,
     /*  793281 */     // GIR_Coverage, 19422,
     /*  793281 */     GIR_EraseRootFromParent_Done,
     /*  793282 */   // Label 12315: @793282
     /*  793282 */   GIM_Try, /*On fail goto*//*Label 12316*/ GIMT_Encode4(793357), // Rule ID 19423 //
     /*  793287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  793298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  793301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  793304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  793307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793333 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  793336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793355 */     GIR_RootConstrainSelectedInstOperands,
     /*  793356 */     // GIR_Coverage, 19423,
     /*  793356 */     GIR_EraseRootFromParent_Done,
     /*  793357 */   // Label 12316: @793357
     /*  793357 */   GIM_Try, /*On fail goto*//*Label 12317*/ GIMT_Encode4(793432), // Rule ID 19426 //
     /*  793362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  793373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  793376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  793379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  793382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  793411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793430 */     GIR_RootConstrainSelectedInstOperands,
     /*  793431 */     // GIR_Coverage, 19426,
     /*  793431 */     GIR_EraseRootFromParent_Done,
     /*  793432 */   // Label 12317: @793432
     /*  793432 */   GIM_Try, /*On fail goto*//*Label 12318*/ GIMT_Encode4(793507), // Rule ID 19427 //
     /*  793437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  793448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  793451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  793454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  793457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793483 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  793486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793505 */     GIR_RootConstrainSelectedInstOperands,
     /*  793506 */     // GIR_Coverage, 19427,
     /*  793506 */     GIR_EraseRootFromParent_Done,
     /*  793507 */   // Label 12318: @793507
     /*  793507 */   GIM_Try, /*On fail goto*//*Label 12319*/ GIMT_Encode4(793582), // Rule ID 19430 //
     /*  793512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  793515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  793523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  793526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  793529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  793532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793558 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  793558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  793561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793580 */     GIR_RootConstrainSelectedInstOperands,
     /*  793581 */     // GIR_Coverage, 19430,
     /*  793581 */     GIR_EraseRootFromParent_Done,
     /*  793582 */   // Label 12319: @793582
     /*  793582 */   GIM_Try, /*On fail goto*//*Label 12320*/ GIMT_Encode4(793657), // Rule ID 19431 //
     /*  793587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  793590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  793598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  793601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  793604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  793607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793633 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  793633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  793636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793655 */     GIR_RootConstrainSelectedInstOperands,
     /*  793656 */     // GIR_Coverage, 19431,
     /*  793656 */     GIR_EraseRootFromParent_Done,
     /*  793657 */   // Label 12320: @793657
     /*  793657 */   GIM_Try, /*On fail goto*//*Label 12321*/ GIMT_Encode4(793732), // Rule ID 19434 //
     /*  793662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793708 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  793711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793730 */     GIR_RootConstrainSelectedInstOperands,
     /*  793731 */     // GIR_Coverage, 19434,
     /*  793731 */     GIR_EraseRootFromParent_Done,
     /*  793732 */   // Label 12321: @793732
     /*  793732 */   GIM_Try, /*On fail goto*//*Label 12322*/ GIMT_Encode4(793807), // Rule ID 19435 //
     /*  793737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793783 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  793786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793805 */     GIR_RootConstrainSelectedInstOperands,
     /*  793806 */     // GIR_Coverage, 19435,
     /*  793806 */     GIR_EraseRootFromParent_Done,
     /*  793807 */   // Label 12322: @793807
     /*  793807 */   GIM_Try, /*On fail goto*//*Label 12323*/ GIMT_Encode4(793882), // Rule ID 19438 //
     /*  793812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793858 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  793861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793880 */     GIR_RootConstrainSelectedInstOperands,
     /*  793881 */     // GIR_Coverage, 19438,
     /*  793881 */     GIR_EraseRootFromParent_Done,
     /*  793882 */   // Label 12323: @793882
     /*  793882 */   GIM_Try, /*On fail goto*//*Label 12324*/ GIMT_Encode4(793957), // Rule ID 19439 //
     /*  793887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793933 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  793936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793955 */     GIR_RootConstrainSelectedInstOperands,
     /*  793956 */     // GIR_Coverage, 19439,
     /*  793956 */     GIR_EraseRootFromParent_Done,
     /*  793957 */   // Label 12324: @793957
     /*  793957 */   GIM_Try, /*On fail goto*//*Label 12325*/ GIMT_Encode4(794032), // Rule ID 19442 //
     /*  793962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794008 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  794011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794030 */     GIR_RootConstrainSelectedInstOperands,
     /*  794031 */     // GIR_Coverage, 19442,
     /*  794031 */     GIR_EraseRootFromParent_Done,
     /*  794032 */   // Label 12325: @794032
     /*  794032 */   GIM_Try, /*On fail goto*//*Label 12326*/ GIMT_Encode4(794107), // Rule ID 19443 //
     /*  794037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  794048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  794051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  794054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  794057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794083 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  794086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794105 */     GIR_RootConstrainSelectedInstOperands,
     /*  794106 */     // GIR_Coverage, 19443,
     /*  794106 */     GIR_EraseRootFromParent_Done,
     /*  794107 */   // Label 12326: @794107
     /*  794107 */   GIM_Try, /*On fail goto*//*Label 12327*/ GIMT_Encode4(794182), // Rule ID 19446 //
     /*  794112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  794123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  794126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  794129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  794132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794158 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  794161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794180 */     GIR_RootConstrainSelectedInstOperands,
     /*  794181 */     // GIR_Coverage, 19446,
     /*  794181 */     GIR_EraseRootFromParent_Done,
     /*  794182 */   // Label 12327: @794182
     /*  794182 */   GIM_Try, /*On fail goto*//*Label 12328*/ GIMT_Encode4(794257), // Rule ID 19447 //
     /*  794187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  794198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  794201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  794204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  794207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794233 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  794236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794255 */     GIR_RootConstrainSelectedInstOperands,
     /*  794256 */     // GIR_Coverage, 19447,
     /*  794256 */     GIR_EraseRootFromParent_Done,
     /*  794257 */   // Label 12328: @794257
     /*  794257 */   GIM_Try, /*On fail goto*//*Label 12329*/ GIMT_Encode4(794332), // Rule ID 19450 //
     /*  794262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  794273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  794276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  794279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  794282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794308 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  794311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794330 */     GIR_RootConstrainSelectedInstOperands,
     /*  794331 */     // GIR_Coverage, 19450,
     /*  794331 */     GIR_EraseRootFromParent_Done,
     /*  794332 */   // Label 12329: @794332
     /*  794332 */   GIM_Try, /*On fail goto*//*Label 12330*/ GIMT_Encode4(794407), // Rule ID 19451 //
     /*  794337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  794348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  794351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  794354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  794357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794383 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  794386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794405 */     GIR_RootConstrainSelectedInstOperands,
     /*  794406 */     // GIR_Coverage, 19451,
     /*  794406 */     GIR_EraseRootFromParent_Done,
     /*  794407 */   // Label 12330: @794407
     /*  794407 */   GIM_Try, /*On fail goto*//*Label 12331*/ GIMT_Encode4(794482), // Rule ID 19454 //
     /*  794412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  794423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  794426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  794429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  794432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794458 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  794461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794480 */     GIR_RootConstrainSelectedInstOperands,
     /*  794481 */     // GIR_Coverage, 19454,
     /*  794481 */     GIR_EraseRootFromParent_Done,
     /*  794482 */   // Label 12331: @794482
     /*  794482 */   GIM_Try, /*On fail goto*//*Label 12332*/ GIMT_Encode4(794557), // Rule ID 19455 //
     /*  794487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  794498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  794501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  794504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  794507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794533 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  794536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794555 */     GIR_RootConstrainSelectedInstOperands,
     /*  794556 */     // GIR_Coverage, 19455,
     /*  794556 */     GIR_EraseRootFromParent_Done,
     /*  794557 */   // Label 12332: @794557
     /*  794557 */   GIM_Try, /*On fail goto*//*Label 12333*/ GIMT_Encode4(794632), // Rule ID 19458 //
     /*  794562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  794573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  794576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  794579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  794582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794608 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  794611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794630 */     GIR_RootConstrainSelectedInstOperands,
     /*  794631 */     // GIR_Coverage, 19458,
     /*  794631 */     GIR_EraseRootFromParent_Done,
     /*  794632 */   // Label 12333: @794632
     /*  794632 */   GIM_Try, /*On fail goto*//*Label 12334*/ GIMT_Encode4(794707), // Rule ID 19459 //
     /*  794637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  794648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  794651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  794654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  794657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794683 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  794686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794705 */     GIR_RootConstrainSelectedInstOperands,
     /*  794706 */     // GIR_Coverage, 19459,
     /*  794706 */     GIR_EraseRootFromParent_Done,
     /*  794707 */   // Label 12334: @794707
     /*  794707 */   GIM_Try, /*On fail goto*//*Label 12335*/ GIMT_Encode4(794782), // Rule ID 19462 //
     /*  794712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794758 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  794761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794780 */     GIR_RootConstrainSelectedInstOperands,
     /*  794781 */     // GIR_Coverage, 19462,
     /*  794781 */     GIR_EraseRootFromParent_Done,
     /*  794782 */   // Label 12335: @794782
     /*  794782 */   GIM_Try, /*On fail goto*//*Label 12336*/ GIMT_Encode4(794857), // Rule ID 19463 //
     /*  794787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794833 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  794836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794855 */     GIR_RootConstrainSelectedInstOperands,
     /*  794856 */     // GIR_Coverage, 19463,
     /*  794856 */     GIR_EraseRootFromParent_Done,
     /*  794857 */   // Label 12336: @794857
     /*  794857 */   GIM_Try, /*On fail goto*//*Label 12337*/ GIMT_Encode4(794932), // Rule ID 19466 //
     /*  794862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794908 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  794911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794930 */     GIR_RootConstrainSelectedInstOperands,
     /*  794931 */     // GIR_Coverage, 19466,
     /*  794931 */     GIR_EraseRootFromParent_Done,
     /*  794932 */   // Label 12337: @794932
     /*  794932 */   GIM_Try, /*On fail goto*//*Label 12338*/ GIMT_Encode4(795007), // Rule ID 19467 //
     /*  794937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794983 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  794986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795005 */     GIR_RootConstrainSelectedInstOperands,
     /*  795006 */     // GIR_Coverage, 19467,
     /*  795006 */     GIR_EraseRootFromParent_Done,
     /*  795007 */   // Label 12338: @795007
     /*  795007 */   GIM_Try, /*On fail goto*//*Label 12339*/ GIMT_Encode4(795082), // Rule ID 19470 //
     /*  795012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  795023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  795026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  795029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795058 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  795061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795080 */     GIR_RootConstrainSelectedInstOperands,
     /*  795081 */     // GIR_Coverage, 19470,
     /*  795081 */     GIR_EraseRootFromParent_Done,
     /*  795082 */   // Label 12339: @795082
     /*  795082 */   GIM_Try, /*On fail goto*//*Label 12340*/ GIMT_Encode4(795157), // Rule ID 19471 //
     /*  795087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  795098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  795101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  795104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795133 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  795136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795155 */     GIR_RootConstrainSelectedInstOperands,
     /*  795156 */     // GIR_Coverage, 19471,
     /*  795156 */     GIR_EraseRootFromParent_Done,
     /*  795157 */   // Label 12340: @795157
     /*  795157 */   GIM_Try, /*On fail goto*//*Label 12341*/ GIMT_Encode4(795232), // Rule ID 19474 //
     /*  795162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  795173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  795176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  795179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795208 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  795211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795230 */     GIR_RootConstrainSelectedInstOperands,
     /*  795231 */     // GIR_Coverage, 19474,
     /*  795231 */     GIR_EraseRootFromParent_Done,
     /*  795232 */   // Label 12341: @795232
     /*  795232 */   GIM_Try, /*On fail goto*//*Label 12342*/ GIMT_Encode4(795307), // Rule ID 19475 //
     /*  795237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  795248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  795251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  795254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795283 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  795286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795305 */     GIR_RootConstrainSelectedInstOperands,
     /*  795306 */     // GIR_Coverage, 19475,
     /*  795306 */     GIR_EraseRootFromParent_Done,
     /*  795307 */   // Label 12342: @795307
     /*  795307 */   GIM_Try, /*On fail goto*//*Label 12343*/ GIMT_Encode4(795382), // Rule ID 19478 //
     /*  795312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  795323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  795326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  795329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795358 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  795361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795380 */     GIR_RootConstrainSelectedInstOperands,
     /*  795381 */     // GIR_Coverage, 19478,
     /*  795381 */     GIR_EraseRootFromParent_Done,
     /*  795382 */   // Label 12343: @795382
     /*  795382 */   GIM_Try, /*On fail goto*//*Label 12344*/ GIMT_Encode4(795457), // Rule ID 19479 //
     /*  795387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  795398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  795401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  795404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795433 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  795436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795455 */     GIR_RootConstrainSelectedInstOperands,
     /*  795456 */     // GIR_Coverage, 19479,
     /*  795456 */     GIR_EraseRootFromParent_Done,
     /*  795457 */   // Label 12344: @795457
     /*  795457 */   GIM_Try, /*On fail goto*//*Label 12345*/ GIMT_Encode4(795532), // Rule ID 19482 //
     /*  795462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  795473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  795476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  795479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795508 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  795511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795530 */     GIR_RootConstrainSelectedInstOperands,
     /*  795531 */     // GIR_Coverage, 19482,
     /*  795531 */     GIR_EraseRootFromParent_Done,
     /*  795532 */   // Label 12345: @795532
     /*  795532 */   GIM_Try, /*On fail goto*//*Label 12346*/ GIMT_Encode4(795607), // Rule ID 19483 //
     /*  795537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  795548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  795551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  795554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795583 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11265:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  795586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795605 */     GIR_RootConstrainSelectedInstOperands,
     /*  795606 */     // GIR_Coverage, 19483,
     /*  795606 */     GIR_EraseRootFromParent_Done,
     /*  795607 */   // Label 12346: @795607
     /*  795607 */   GIM_Try, /*On fail goto*//*Label 12347*/ GIMT_Encode4(795682), // Rule ID 19486 //
     /*  795612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795658 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  795661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795680 */     GIR_RootConstrainSelectedInstOperands,
     /*  795681 */     // GIR_Coverage, 19486,
     /*  795681 */     GIR_EraseRootFromParent_Done,
     /*  795682 */   // Label 12347: @795682
     /*  795682 */   GIM_Try, /*On fail goto*//*Label 12348*/ GIMT_Encode4(795757), // Rule ID 19487 //
     /*  795687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795733 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11265:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  795736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795755 */     GIR_RootConstrainSelectedInstOperands,
     /*  795756 */     // GIR_Coverage, 19487,
     /*  795756 */     GIR_EraseRootFromParent_Done,
     /*  795757 */   // Label 12348: @795757
     /*  795757 */   GIM_Try, /*On fail goto*//*Label 12349*/ GIMT_Encode4(795832), // Rule ID 19490 //
     /*  795762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795808 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  795811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795830 */     GIR_RootConstrainSelectedInstOperands,
     /*  795831 */     // GIR_Coverage, 19490,
     /*  795831 */     GIR_EraseRootFromParent_Done,
     /*  795832 */   // Label 12349: @795832
     /*  795832 */   GIM_Try, /*On fail goto*//*Label 12350*/ GIMT_Encode4(795907), // Rule ID 19491 //
     /*  795837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795883 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11265:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  795886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795905 */     GIR_RootConstrainSelectedInstOperands,
     /*  795906 */     // GIR_Coverage, 19491,
     /*  795906 */     GIR_EraseRootFromParent_Done,
     /*  795907 */   // Label 12350: @795907
     /*  795907 */   GIM_Try, /*On fail goto*//*Label 12351*/ GIMT_Encode4(795982), // Rule ID 19494 //
     /*  795912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  795923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  795926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  795929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795958 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  795961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795980 */     GIR_RootConstrainSelectedInstOperands,
     /*  795981 */     // GIR_Coverage, 19494,
     /*  795981 */     GIR_EraseRootFromParent_Done,
     /*  795982 */   // Label 12351: @795982
     /*  795982 */   GIM_Try, /*On fail goto*//*Label 12352*/ GIMT_Encode4(796057), // Rule ID 19495 //
     /*  795987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  795998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  796001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  796004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796033 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  796036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796055 */     GIR_RootConstrainSelectedInstOperands,
     /*  796056 */     // GIR_Coverage, 19495,
     /*  796056 */     GIR_EraseRootFromParent_Done,
     /*  796057 */   // Label 12352: @796057
     /*  796057 */   GIM_Try, /*On fail goto*//*Label 12353*/ GIMT_Encode4(796132), // Rule ID 19498 //
     /*  796062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796108 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  796111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796130 */     GIR_RootConstrainSelectedInstOperands,
     /*  796131 */     // GIR_Coverage, 19498,
     /*  796131 */     GIR_EraseRootFromParent_Done,
     /*  796132 */   // Label 12353: @796132
     /*  796132 */   GIM_Try, /*On fail goto*//*Label 12354*/ GIMT_Encode4(796207), // Rule ID 19499 //
     /*  796137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  796148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  796151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  796154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796183 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  796186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796205 */     GIR_RootConstrainSelectedInstOperands,
     /*  796206 */     // GIR_Coverage, 19499,
     /*  796206 */     GIR_EraseRootFromParent_Done,
     /*  796207 */   // Label 12354: @796207
     /*  796207 */   GIM_Try, /*On fail goto*//*Label 12355*/ GIMT_Encode4(796282), // Rule ID 19502 //
     /*  796212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796258 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  796261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796280 */     GIR_RootConstrainSelectedInstOperands,
     /*  796281 */     // GIR_Coverage, 19502,
     /*  796281 */     GIR_EraseRootFromParent_Done,
     /*  796282 */   // Label 12355: @796282
     /*  796282 */   GIM_Try, /*On fail goto*//*Label 12356*/ GIMT_Encode4(796357), // Rule ID 19503 //
     /*  796287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  796298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  796301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  796304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  796307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  796326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796333 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  796336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796355 */     GIR_RootConstrainSelectedInstOperands,
     /*  796356 */     // GIR_Coverage, 19503,
     /*  796356 */     GIR_EraseRootFromParent_Done,
     /*  796357 */   // Label 12356: @796357
     /*  796357 */   GIM_Try, /*On fail goto*//*Label 12357*/ GIMT_Encode4(796432), // Rule ID 19506 //
     /*  796362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796408 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  796411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796430 */     GIR_RootConstrainSelectedInstOperands,
     /*  796431 */     // GIR_Coverage, 19506,
     /*  796431 */     GIR_EraseRootFromParent_Done,
     /*  796432 */   // Label 12357: @796432
     /*  796432 */   GIM_Try, /*On fail goto*//*Label 12358*/ GIMT_Encode4(796507), // Rule ID 19507 //
     /*  796437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  796448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  796451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  796454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796483 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  796486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796505 */     GIR_RootConstrainSelectedInstOperands,
     /*  796506 */     // GIR_Coverage, 19507,
     /*  796506 */     GIR_EraseRootFromParent_Done,
     /*  796507 */   // Label 12358: @796507
     /*  796507 */   GIM_Try, /*On fail goto*//*Label 12359*/ GIMT_Encode4(796582), // Rule ID 19510 //
     /*  796512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  796526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  796529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796558 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  796561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796580 */     GIR_RootConstrainSelectedInstOperands,
     /*  796581 */     // GIR_Coverage, 19510,
     /*  796581 */     GIR_EraseRootFromParent_Done,
     /*  796582 */   // Label 12359: @796582
     /*  796582 */   GIM_Try, /*On fail goto*//*Label 12360*/ GIMT_Encode4(796657), // Rule ID 19511 //
     /*  796587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  796601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  796604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796633 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  796636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796655 */     GIR_RootConstrainSelectedInstOperands,
     /*  796656 */     // GIR_Coverage, 19511,
     /*  796656 */     GIR_EraseRootFromParent_Done,
     /*  796657 */   // Label 12360: @796657
     /*  796657 */   GIM_Try, /*On fail goto*//*Label 12361*/ GIMT_Encode4(796732), // Rule ID 19514 //
     /*  796662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  796711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796730 */     GIR_RootConstrainSelectedInstOperands,
     /*  796731 */     // GIR_Coverage, 19514,
     /*  796731 */     GIR_EraseRootFromParent_Done,
     /*  796732 */   // Label 12361: @796732
     /*  796732 */   GIM_Try, /*On fail goto*//*Label 12362*/ GIMT_Encode4(796807), // Rule ID 19515 //
     /*  796737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796783 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  796786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796805 */     GIR_RootConstrainSelectedInstOperands,
     /*  796806 */     // GIR_Coverage, 19515,
     /*  796806 */     GIR_EraseRootFromParent_Done,
     /*  796807 */   // Label 12362: @796807
     /*  796807 */   GIM_Try, /*On fail goto*//*Label 12363*/ GIMT_Encode4(796882), // Rule ID 19518 //
     /*  796812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796858 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  796861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796880 */     GIR_RootConstrainSelectedInstOperands,
     /*  796881 */     // GIR_Coverage, 19518,
     /*  796881 */     GIR_EraseRootFromParent_Done,
     /*  796882 */   // Label 12363: @796882
     /*  796882 */   GIM_Try, /*On fail goto*//*Label 12364*/ GIMT_Encode4(796957), // Rule ID 19519 //
     /*  796887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11265:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  796936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796955 */     GIR_RootConstrainSelectedInstOperands,
     /*  796956 */     // GIR_Coverage, 19519,
     /*  796956 */     GIR_EraseRootFromParent_Done,
     /*  796957 */   // Label 12364: @796957
     /*  796957 */   GIM_Try, /*On fail goto*//*Label 12365*/ GIMT_Encode4(797032), // Rule ID 19522 //
     /*  796962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  796973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  796976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  796979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797008 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  797011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797030 */     GIR_RootConstrainSelectedInstOperands,
     /*  797031 */     // GIR_Coverage, 19522,
     /*  797031 */     GIR_EraseRootFromParent_Done,
     /*  797032 */   // Label 12365: @797032
     /*  797032 */   GIM_Try, /*On fail goto*//*Label 12366*/ GIMT_Encode4(797107), // Rule ID 19523 //
     /*  797037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  797048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  797051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  797054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797083 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11265:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  797086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797105 */     GIR_RootConstrainSelectedInstOperands,
     /*  797106 */     // GIR_Coverage, 19523,
     /*  797106 */     GIR_EraseRootFromParent_Done,
     /*  797107 */   // Label 12366: @797107
     /*  797107 */   GIM_Try, /*On fail goto*//*Label 12367*/ GIMT_Encode4(797182), // Rule ID 19526 //
     /*  797112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797158 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  797161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797180 */     GIR_RootConstrainSelectedInstOperands,
     /*  797181 */     // GIR_Coverage, 19526,
     /*  797181 */     GIR_EraseRootFromParent_Done,
     /*  797182 */   // Label 12367: @797182
     /*  797182 */   GIM_Try, /*On fail goto*//*Label 12368*/ GIMT_Encode4(797257), // Rule ID 19527 //
     /*  797187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  797195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  797198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  797201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  797204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  797207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  797226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797233 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11265:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  797236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797255 */     GIR_RootConstrainSelectedInstOperands,
     /*  797256 */     // GIR_Coverage, 19527,
     /*  797256 */     GIR_EraseRootFromParent_Done,
     /*  797257 */   // Label 12368: @797257
     /*  797257 */   GIM_Try, /*On fail goto*//*Label 12369*/ GIMT_Encode4(797332), // Rule ID 19530 //
     /*  797262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797308 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  797311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797330 */     GIR_RootConstrainSelectedInstOperands,
     /*  797331 */     // GIR_Coverage, 19530,
     /*  797331 */     GIR_EraseRootFromParent_Done,
     /*  797332 */   // Label 12369: @797332
     /*  797332 */   GIM_Try, /*On fail goto*//*Label 12370*/ GIMT_Encode4(797407), // Rule ID 19531 //
     /*  797337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  797348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  797351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  797354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  797357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797383 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  797386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797405 */     GIR_RootConstrainSelectedInstOperands,
     /*  797406 */     // GIR_Coverage, 19531,
     /*  797406 */     GIR_EraseRootFromParent_Done,
     /*  797407 */   // Label 12370: @797407
     /*  797407 */   GIM_Try, /*On fail goto*//*Label 12371*/ GIMT_Encode4(797482), // Rule ID 19534 //
     /*  797412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  797423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  797426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  797429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  797432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797458 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  797461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797480 */     GIR_RootConstrainSelectedInstOperands,
     /*  797481 */     // GIR_Coverage, 19534,
     /*  797481 */     GIR_EraseRootFromParent_Done,
     /*  797482 */   // Label 12371: @797482
     /*  797482 */   GIM_Try, /*On fail goto*//*Label 12372*/ GIMT_Encode4(797557), // Rule ID 19535 //
     /*  797487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  797498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  797501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  797504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  797507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797533 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  797536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797555 */     GIR_RootConstrainSelectedInstOperands,
     /*  797556 */     // GIR_Coverage, 19535,
     /*  797556 */     GIR_EraseRootFromParent_Done,
     /*  797557 */   // Label 12372: @797557
     /*  797557 */   GIM_Try, /*On fail goto*//*Label 12373*/ GIMT_Encode4(797632), // Rule ID 19538 //
     /*  797562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  797573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  797576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  797579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  797582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  797611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797630 */     GIR_RootConstrainSelectedInstOperands,
     /*  797631 */     // GIR_Coverage, 19538,
     /*  797631 */     GIR_EraseRootFromParent_Done,
     /*  797632 */   // Label 12373: @797632
     /*  797632 */   GIM_Try, /*On fail goto*//*Label 12374*/ GIMT_Encode4(797707), // Rule ID 19539 //
     /*  797637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  797648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  797651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  797654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  797657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797683 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  797686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797705 */     GIR_RootConstrainSelectedInstOperands,
     /*  797706 */     // GIR_Coverage, 19539,
     /*  797706 */     GIR_EraseRootFromParent_Done,
     /*  797707 */   // Label 12374: @797707
     /*  797707 */   GIM_Try, /*On fail goto*//*Label 12375*/ GIMT_Encode4(797782), // Rule ID 19542 //
     /*  797712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797758 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  797761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797780 */     GIR_RootConstrainSelectedInstOperands,
     /*  797781 */     // GIR_Coverage, 19542,
     /*  797781 */     GIR_EraseRootFromParent_Done,
     /*  797782 */   // Label 12375: @797782
     /*  797782 */   GIM_Try, /*On fail goto*//*Label 12376*/ GIMT_Encode4(797857), // Rule ID 19543 //
     /*  797787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797833 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  797836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797855 */     GIR_RootConstrainSelectedInstOperands,
     /*  797856 */     // GIR_Coverage, 19543,
     /*  797856 */     GIR_EraseRootFromParent_Done,
     /*  797857 */   // Label 12376: @797857
     /*  797857 */   GIM_Try, /*On fail goto*//*Label 12377*/ GIMT_Encode4(797932), // Rule ID 19546 //
     /*  797862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  797911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797930 */     GIR_RootConstrainSelectedInstOperands,
     /*  797931 */     // GIR_Coverage, 19546,
     /*  797931 */     GIR_EraseRootFromParent_Done,
     /*  797932 */   // Label 12377: @797932
     /*  797932 */   GIM_Try, /*On fail goto*//*Label 12378*/ GIMT_Encode4(798007), // Rule ID 19547 //
     /*  797937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797983 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  797986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798005 */     GIR_RootConstrainSelectedInstOperands,
     /*  798006 */     // GIR_Coverage, 19547,
     /*  798006 */     GIR_EraseRootFromParent_Done,
     /*  798007 */   // Label 12378: @798007
     /*  798007 */   GIM_Try, /*On fail goto*//*Label 12379*/ GIMT_Encode4(798082), // Rule ID 19550 //
     /*  798012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  798061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798080 */     GIR_RootConstrainSelectedInstOperands,
     /*  798081 */     // GIR_Coverage, 19550,
     /*  798081 */     GIR_EraseRootFromParent_Done,
     /*  798082 */   // Label 12379: @798082
     /*  798082 */   GIM_Try, /*On fail goto*//*Label 12380*/ GIMT_Encode4(798157), // Rule ID 19551 //
     /*  798087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  798098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  798101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  798104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  798107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  798126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798133 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  798136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798155 */     GIR_RootConstrainSelectedInstOperands,
     /*  798156 */     // GIR_Coverage, 19551,
     /*  798156 */     GIR_EraseRootFromParent_Done,
     /*  798157 */   // Label 12380: @798157
     /*  798157 */   GIM_Try, /*On fail goto*//*Label 12381*/ GIMT_Encode4(798232), // Rule ID 19554 //
     /*  798162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  798173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  798176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  798179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  798182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798208 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  798211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798230 */     GIR_RootConstrainSelectedInstOperands,
     /*  798231 */     // GIR_Coverage, 19554,
     /*  798231 */     GIR_EraseRootFromParent_Done,
     /*  798232 */   // Label 12381: @798232
     /*  798232 */   GIM_Try, /*On fail goto*//*Label 12382*/ GIMT_Encode4(798307), // Rule ID 19555 //
     /*  798237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  798248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  798251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  798254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  798257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798283 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  798286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798305 */     GIR_RootConstrainSelectedInstOperands,
     /*  798306 */     // GIR_Coverage, 19555,
     /*  798306 */     GIR_EraseRootFromParent_Done,
     /*  798307 */   // Label 12382: @798307
     /*  798307 */   GIM_Try, /*On fail goto*//*Label 12383*/ GIMT_Encode4(798382), // Rule ID 19558 //
     /*  798312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  798323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  798326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  798329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  798332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798358 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  798361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798380 */     GIR_RootConstrainSelectedInstOperands,
     /*  798381 */     // GIR_Coverage, 19558,
     /*  798381 */     GIR_EraseRootFromParent_Done,
     /*  798382 */   // Label 12383: @798382
     /*  798382 */   GIM_Try, /*On fail goto*//*Label 12384*/ GIMT_Encode4(798457), // Rule ID 19559 //
     /*  798387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  798398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  798401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  798404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  798407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798433 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  798436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798455 */     GIR_RootConstrainSelectedInstOperands,
     /*  798456 */     // GIR_Coverage, 19559,
     /*  798456 */     GIR_EraseRootFromParent_Done,
     /*  798457 */   // Label 12384: @798457
     /*  798457 */   GIM_Try, /*On fail goto*//*Label 12385*/ GIMT_Encode4(798532), // Rule ID 19562 //
     /*  798462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  798465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  798473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  798476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  798479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  798482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798508 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  798511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798530 */     GIR_RootConstrainSelectedInstOperands,
     /*  798531 */     // GIR_Coverage, 19562,
     /*  798531 */     GIR_EraseRootFromParent_Done,
     /*  798532 */   // Label 12385: @798532
     /*  798532 */   GIM_Try, /*On fail goto*//*Label 12386*/ GIMT_Encode4(798607), // Rule ID 19563 //
     /*  798537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  798548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  798551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  798554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  798557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798583 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  798586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798605 */     GIR_RootConstrainSelectedInstOperands,
     /*  798606 */     // GIR_Coverage, 19563,
     /*  798606 */     GIR_EraseRootFromParent_Done,
     /*  798607 */   // Label 12386: @798607
     /*  798607 */   GIM_Try, /*On fail goto*//*Label 12387*/ GIMT_Encode4(798682), // Rule ID 19566 //
     /*  798612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  798623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  798626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  798629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  798632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798658 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  798661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798680 */     GIR_RootConstrainSelectedInstOperands,
     /*  798681 */     // GIR_Coverage, 19566,
     /*  798681 */     GIR_EraseRootFromParent_Done,
     /*  798682 */   // Label 12387: @798682
     /*  798682 */   GIM_Try, /*On fail goto*//*Label 12388*/ GIMT_Encode4(798757), // Rule ID 19567 //
     /*  798687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  798698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  798701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  798704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  798707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  798736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798755 */     GIR_RootConstrainSelectedInstOperands,
     /*  798756 */     // GIR_Coverage, 19567,
     /*  798756 */     GIR_EraseRootFromParent_Done,
     /*  798757 */   // Label 12388: @798757
     /*  798757 */   GIM_Try, /*On fail goto*//*Label 12389*/ GIMT_Encode4(798832), // Rule ID 19570 //
     /*  798762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798808 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  798811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798830 */     GIR_RootConstrainSelectedInstOperands,
     /*  798831 */     // GIR_Coverage, 19570,
     /*  798831 */     GIR_EraseRootFromParent_Done,
     /*  798832 */   // Label 12389: @798832
     /*  798832 */   GIM_Try, /*On fail goto*//*Label 12390*/ GIMT_Encode4(798907), // Rule ID 19571 //
     /*  798837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798883 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  798886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798905 */     GIR_RootConstrainSelectedInstOperands,
     /*  798906 */     // GIR_Coverage, 19571,
     /*  798906 */     GIR_EraseRootFromParent_Done,
     /*  798907 */   // Label 12390: @798907
     /*  798907 */   GIM_Try, /*On fail goto*//*Label 12391*/ GIMT_Encode4(798982), // Rule ID 19574 //
     /*  798912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  798923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  798926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  798929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  798932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798958 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  798961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798980 */     GIR_RootConstrainSelectedInstOperands,
     /*  798981 */     // GIR_Coverage, 19574,
     /*  798981 */     GIR_EraseRootFromParent_Done,
     /*  798982 */   // Label 12391: @798982
     /*  798982 */   GIM_Try, /*On fail goto*//*Label 12392*/ GIMT_Encode4(799057), // Rule ID 19575 //
     /*  798987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  798998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  799001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  799004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  799007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799033 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  799036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799055 */     GIR_RootConstrainSelectedInstOperands,
     /*  799056 */     // GIR_Coverage, 19575,
     /*  799056 */     GIR_EraseRootFromParent_Done,
     /*  799057 */   // Label 12392: @799057
     /*  799057 */   GIM_Try, /*On fail goto*//*Label 12393*/ GIMT_Encode4(799132), // Rule ID 19578 //
     /*  799062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  799073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  799076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  799079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  799082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  799111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799130 */     GIR_RootConstrainSelectedInstOperands,
     /*  799131 */     // GIR_Coverage, 19578,
     /*  799131 */     GIR_EraseRootFromParent_Done,
     /*  799132 */   // Label 12393: @799132
     /*  799132 */   GIM_Try, /*On fail goto*//*Label 12394*/ GIMT_Encode4(799207), // Rule ID 19579 //
     /*  799137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  799148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  799151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  799154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  799157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799183 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  799186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799205 */     GIR_RootConstrainSelectedInstOperands,
     /*  799206 */     // GIR_Coverage, 19579,
     /*  799206 */     GIR_EraseRootFromParent_Done,
     /*  799207 */   // Label 12394: @799207
     /*  799207 */   GIM_Try, /*On fail goto*//*Label 12395*/ GIMT_Encode4(799282), // Rule ID 19582 //
     /*  799212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  799223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  799226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  799229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  799232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799258 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  799261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799280 */     GIR_RootConstrainSelectedInstOperands,
     /*  799281 */     // GIR_Coverage, 19582,
     /*  799281 */     GIR_EraseRootFromParent_Done,
     /*  799282 */   // Label 12395: @799282
     /*  799282 */   GIM_Try, /*On fail goto*//*Label 12396*/ GIMT_Encode4(799357), // Rule ID 19583 //
     /*  799287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  799298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  799301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  799304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  799307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  799326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799333 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  799336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799355 */     GIR_RootConstrainSelectedInstOperands,
     /*  799356 */     // GIR_Coverage, 19583,
     /*  799356 */     GIR_EraseRootFromParent_Done,
     /*  799357 */   // Label 12396: @799357
     /*  799357 */   GIM_Try, /*On fail goto*//*Label 12397*/ GIMT_Encode4(799432), // Rule ID 19586 //
     /*  799362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  799373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  799376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  799379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  799382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799408 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  799411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799430 */     GIR_RootConstrainSelectedInstOperands,
     /*  799431 */     // GIR_Coverage, 19586,
     /*  799431 */     GIR_EraseRootFromParent_Done,
     /*  799432 */   // Label 12397: @799432
     /*  799432 */   GIM_Try, /*On fail goto*//*Label 12398*/ GIMT_Encode4(799507), // Rule ID 19587 //
     /*  799437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  799448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  799451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  799454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  799457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  799476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799483 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  799486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799505 */     GIR_RootConstrainSelectedInstOperands,
     /*  799506 */     // GIR_Coverage, 19587,
     /*  799506 */     GIR_EraseRootFromParent_Done,
     /*  799507 */   // Label 12398: @799507
     /*  799507 */   GIM_Try, /*On fail goto*//*Label 12399*/ GIMT_Encode4(799582), // Rule ID 19590 //
     /*  799512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  799523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  799526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  799529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799558 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  799561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799580 */     GIR_RootConstrainSelectedInstOperands,
     /*  799581 */     // GIR_Coverage, 19590,
     /*  799581 */     GIR_EraseRootFromParent_Done,
     /*  799582 */   // Label 12399: @799582
     /*  799582 */   GIM_Try, /*On fail goto*//*Label 12400*/ GIMT_Encode4(799657), // Rule ID 19591 //
     /*  799587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  799598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  799601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  799604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799633 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  799636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799655 */     GIR_RootConstrainSelectedInstOperands,
     /*  799656 */     // GIR_Coverage, 19591,
     /*  799656 */     GIR_EraseRootFromParent_Done,
     /*  799657 */   // Label 12400: @799657
     /*  799657 */   GIM_Try, /*On fail goto*//*Label 12401*/ GIMT_Encode4(799732), // Rule ID 19594 //
     /*  799662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799708 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  799711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799730 */     GIR_RootConstrainSelectedInstOperands,
     /*  799731 */     // GIR_Coverage, 19594,
     /*  799731 */     GIR_EraseRootFromParent_Done,
     /*  799732 */   // Label 12401: @799732
     /*  799732 */   GIM_Try, /*On fail goto*//*Label 12402*/ GIMT_Encode4(799807), // Rule ID 19595 //
     /*  799737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799783 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  799786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799805 */     GIR_RootConstrainSelectedInstOperands,
     /*  799806 */     // GIR_Coverage, 19595,
     /*  799806 */     GIR_EraseRootFromParent_Done,
     /*  799807 */   // Label 12402: @799807
     /*  799807 */   GIM_Try, /*On fail goto*//*Label 12403*/ GIMT_Encode4(799882), // Rule ID 19598 //
     /*  799812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799858 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  799861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799880 */     GIR_RootConstrainSelectedInstOperands,
     /*  799881 */     // GIR_Coverage, 19598,
     /*  799881 */     GIR_EraseRootFromParent_Done,
     /*  799882 */   // Label 12403: @799882
     /*  799882 */   GIM_Try, /*On fail goto*//*Label 12404*/ GIMT_Encode4(799957), // Rule ID 19599 //
     /*  799887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799933 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  799936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799955 */     GIR_RootConstrainSelectedInstOperands,
     /*  799956 */     // GIR_Coverage, 19599,
     /*  799956 */     GIR_EraseRootFromParent_Done,
     /*  799957 */   // Label 12404: @799957
     /*  799957 */   GIM_Try, /*On fail goto*//*Label 12405*/ GIMT_Encode4(800032), // Rule ID 19602 //
     /*  799962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  799973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  799976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  799979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  800011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800030 */     GIR_RootConstrainSelectedInstOperands,
     /*  800031 */     // GIR_Coverage, 19602,
     /*  800031 */     GIR_EraseRootFromParent_Done,
     /*  800032 */   // Label 12405: @800032
     /*  800032 */   GIM_Try, /*On fail goto*//*Label 12406*/ GIMT_Encode4(800107), // Rule ID 19603 //
     /*  800037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  800048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  800051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  800054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800083 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11267:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  800086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800105 */     GIR_RootConstrainSelectedInstOperands,
     /*  800106 */     // GIR_Coverage, 19603,
     /*  800106 */     GIR_EraseRootFromParent_Done,
     /*  800107 */   // Label 12406: @800107
     /*  800107 */   GIM_Try, /*On fail goto*//*Label 12407*/ GIMT_Encode4(800182), // Rule ID 19606 //
     /*  800112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  800123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  800126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  800129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800158 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  800161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800180 */     GIR_RootConstrainSelectedInstOperands,
     /*  800181 */     // GIR_Coverage, 19606,
     /*  800181 */     GIR_EraseRootFromParent_Done,
     /*  800182 */   // Label 12407: @800182
     /*  800182 */   GIM_Try, /*On fail goto*//*Label 12408*/ GIMT_Encode4(800257), // Rule ID 19607 //
     /*  800187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  800198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  800201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  800204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800233 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11267:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  800236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800255 */     GIR_RootConstrainSelectedInstOperands,
     /*  800256 */     // GIR_Coverage, 19607,
     /*  800256 */     GIR_EraseRootFromParent_Done,
     /*  800257 */   // Label 12408: @800257
     /*  800257 */   GIM_Try, /*On fail goto*//*Label 12409*/ GIMT_Encode4(800332), // Rule ID 19610 //
     /*  800262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  800273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  800276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  800279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800308 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  800311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800330 */     GIR_RootConstrainSelectedInstOperands,
     /*  800331 */     // GIR_Coverage, 19610,
     /*  800331 */     GIR_EraseRootFromParent_Done,
     /*  800332 */   // Label 12409: @800332
     /*  800332 */   GIM_Try, /*On fail goto*//*Label 12410*/ GIMT_Encode4(800407), // Rule ID 19611 //
     /*  800337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  800340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  800348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  800351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  800354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  800372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800383 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11267:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  800386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800405 */     GIR_RootConstrainSelectedInstOperands,
     /*  800406 */     // GIR_Coverage, 19611,
     /*  800406 */     GIR_EraseRootFromParent_Done,
     /*  800407 */   // Label 12410: @800407
     /*  800407 */   GIM_Try, /*On fail goto*//*Label 12411*/ GIMT_Encode4(800482), // Rule ID 19614 //
     /*  800412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  800423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  800426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  800429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800458 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  800461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800480 */     GIR_RootConstrainSelectedInstOperands,
     /*  800481 */     // GIR_Coverage, 19614,
     /*  800481 */     GIR_EraseRootFromParent_Done,
     /*  800482 */   // Label 12411: @800482
     /*  800482 */   GIM_Try, /*On fail goto*//*Label 12412*/ GIMT_Encode4(800557), // Rule ID 19615 //
     /*  800487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  800498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  800501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  800504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800533 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  800536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800555 */     GIR_RootConstrainSelectedInstOperands,
     /*  800556 */     // GIR_Coverage, 19615,
     /*  800556 */     GIR_EraseRootFromParent_Done,
     /*  800557 */   // Label 12412: @800557
     /*  800557 */   GIM_Try, /*On fail goto*//*Label 12413*/ GIMT_Encode4(800632), // Rule ID 19618 //
     /*  800562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  800573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  800576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  800579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800608 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  800611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800630 */     GIR_RootConstrainSelectedInstOperands,
     /*  800631 */     // GIR_Coverage, 19618,
     /*  800631 */     GIR_EraseRootFromParent_Done,
     /*  800632 */   // Label 12413: @800632
     /*  800632 */   GIM_Try, /*On fail goto*//*Label 12414*/ GIMT_Encode4(800707), // Rule ID 19619 //
     /*  800637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  800648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  800651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  800654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800683 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  800686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800705 */     GIR_RootConstrainSelectedInstOperands,
     /*  800706 */     // GIR_Coverage, 19619,
     /*  800706 */     GIR_EraseRootFromParent_Done,
     /*  800707 */   // Label 12414: @800707
     /*  800707 */   GIM_Try, /*On fail goto*//*Label 12415*/ GIMT_Encode4(800782), // Rule ID 19622 //
     /*  800712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800758 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  800761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800780 */     GIR_RootConstrainSelectedInstOperands,
     /*  800781 */     // GIR_Coverage, 19622,
     /*  800781 */     GIR_EraseRootFromParent_Done,
     /*  800782 */   // Label 12415: @800782
     /*  800782 */   GIM_Try, /*On fail goto*//*Label 12416*/ GIMT_Encode4(800857), // Rule ID 19623 //
     /*  800787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800833 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  800836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800855 */     GIR_RootConstrainSelectedInstOperands,
     /*  800856 */     // GIR_Coverage, 19623,
     /*  800856 */     GIR_EraseRootFromParent_Done,
     /*  800857 */   // Label 12416: @800857
     /*  800857 */   GIM_Try, /*On fail goto*//*Label 12417*/ GIMT_Encode4(800932), // Rule ID 19626 //
     /*  800862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800908 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  800911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800930 */     GIR_RootConstrainSelectedInstOperands,
     /*  800931 */     // GIR_Coverage, 19626,
     /*  800931 */     GIR_EraseRootFromParent_Done,
     /*  800932 */   // Label 12417: @800932
     /*  800932 */   GIM_Try, /*On fail goto*//*Label 12418*/ GIMT_Encode4(801007), // Rule ID 19627 //
     /*  800937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800983 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  800986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801005 */     GIR_RootConstrainSelectedInstOperands,
     /*  801006 */     // GIR_Coverage, 19627,
     /*  801006 */     GIR_EraseRootFromParent_Done,
     /*  801007 */   // Label 12418: @801007
     /*  801007 */   GIM_Try, /*On fail goto*//*Label 12419*/ GIMT_Encode4(801082), // Rule ID 19630 //
     /*  801012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  801023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  801026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  801029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801058 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  801061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801080 */     GIR_RootConstrainSelectedInstOperands,
     /*  801081 */     // GIR_Coverage, 19630,
     /*  801081 */     GIR_EraseRootFromParent_Done,
     /*  801082 */   // Label 12419: @801082
     /*  801082 */   GIM_Try, /*On fail goto*//*Label 12420*/ GIMT_Encode4(801157), // Rule ID 19631 //
     /*  801087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  801098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  801101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  801104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801133 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  801136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801155 */     GIR_RootConstrainSelectedInstOperands,
     /*  801156 */     // GIR_Coverage, 19631,
     /*  801156 */     GIR_EraseRootFromParent_Done,
     /*  801157 */   // Label 12420: @801157
     /*  801157 */   GIM_Try, /*On fail goto*//*Label 12421*/ GIMT_Encode4(801232), // Rule ID 19634 //
     /*  801162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  801173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  801176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  801179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801208 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  801211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801230 */     GIR_RootConstrainSelectedInstOperands,
     /*  801231 */     // GIR_Coverage, 19634,
     /*  801231 */     GIR_EraseRootFromParent_Done,
     /*  801232 */   // Label 12421: @801232
     /*  801232 */   GIM_Try, /*On fail goto*//*Label 12422*/ GIMT_Encode4(801307), // Rule ID 19635 //
     /*  801237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  801248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  801251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  801254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  801257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  801276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801283 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  801286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801305 */     GIR_RootConstrainSelectedInstOperands,
     /*  801306 */     // GIR_Coverage, 19635,
     /*  801306 */     GIR_EraseRootFromParent_Done,
     /*  801307 */   // Label 12422: @801307
     /*  801307 */   GIM_Try, /*On fail goto*//*Label 12423*/ GIMT_Encode4(801382), // Rule ID 19638 //
     /*  801312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  801323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  801326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  801329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801358 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  801361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801380 */     GIR_RootConstrainSelectedInstOperands,
     /*  801381 */     // GIR_Coverage, 19638,
     /*  801381 */     GIR_EraseRootFromParent_Done,
     /*  801382 */   // Label 12423: @801382
     /*  801382 */   GIM_Try, /*On fail goto*//*Label 12424*/ GIMT_Encode4(801457), // Rule ID 19639 //
     /*  801387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  801398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  801401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  801404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  801422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801433 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11267:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  801436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801455 */     GIR_RootConstrainSelectedInstOperands,
     /*  801456 */     // GIR_Coverage, 19639,
     /*  801456 */     GIR_EraseRootFromParent_Done,
     /*  801457 */   // Label 12424: @801457
     /*  801457 */   GIM_Try, /*On fail goto*//*Label 12425*/ GIMT_Encode4(801532), // Rule ID 19642 //
     /*  801462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  801473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  801476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  801479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  801511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801530 */     GIR_RootConstrainSelectedInstOperands,
     /*  801531 */     // GIR_Coverage, 19642,
     /*  801531 */     GIR_EraseRootFromParent_Done,
     /*  801532 */   // Label 12425: @801532
     /*  801532 */   GIM_Try, /*On fail goto*//*Label 12426*/ GIMT_Encode4(801607), // Rule ID 19643 //
     /*  801537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  801548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  801551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  801554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801583 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11267:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  801586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801605 */     GIR_RootConstrainSelectedInstOperands,
     /*  801606 */     // GIR_Coverage, 19643,
     /*  801606 */     GIR_EraseRootFromParent_Done,
     /*  801607 */   // Label 12426: @801607
     /*  801607 */   GIM_Try, /*On fail goto*//*Label 12427*/ GIMT_Encode4(801682), // Rule ID 19646 //
     /*  801612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  801623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  801626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  801629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801658 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  801661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801680 */     GIR_RootConstrainSelectedInstOperands,
     /*  801681 */     // GIR_Coverage, 19646,
     /*  801681 */     GIR_EraseRootFromParent_Done,
     /*  801682 */   // Label 12427: @801682
     /*  801682 */   GIM_Try, /*On fail goto*//*Label 12428*/ GIMT_Encode4(801757), // Rule ID 19647 //
     /*  801687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  801698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  801701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  801704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801733 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11267:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  801736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801755 */     GIR_RootConstrainSelectedInstOperands,
     /*  801756 */     // GIR_Coverage, 19647,
     /*  801756 */     GIR_EraseRootFromParent_Done,
     /*  801757 */   // Label 12428: @801757
     /*  801757 */   GIM_Try, /*On fail goto*//*Label 12429*/ GIMT_Encode4(801832), // Rule ID 19650 //
     /*  801762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801808 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  801811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801830 */     GIR_RootConstrainSelectedInstOperands,
     /*  801831 */     // GIR_Coverage, 19650,
     /*  801831 */     GIR_EraseRootFromParent_Done,
     /*  801832 */   // Label 12429: @801832
     /*  801832 */   GIM_Try, /*On fail goto*//*Label 12430*/ GIMT_Encode4(801907), // Rule ID 19651 //
     /*  801837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801883 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  801886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801905 */     GIR_RootConstrainSelectedInstOperands,
     /*  801906 */     // GIR_Coverage, 19651,
     /*  801906 */     GIR_EraseRootFromParent_Done,
     /*  801907 */   // Label 12430: @801907
     /*  801907 */   GIM_Try, /*On fail goto*//*Label 12431*/ GIMT_Encode4(801982), // Rule ID 19654 //
     /*  801912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  801932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801958 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  801961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801980 */     GIR_RootConstrainSelectedInstOperands,
     /*  801981 */     // GIR_Coverage, 19654,
     /*  801981 */     GIR_EraseRootFromParent_Done,
     /*  801982 */   // Label 12431: @801982
     /*  801982 */   GIM_Try, /*On fail goto*//*Label 12432*/ GIMT_Encode4(802057), // Rule ID 19655 //
     /*  801987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  802001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  802004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  802007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802033 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  802036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802055 */     GIR_RootConstrainSelectedInstOperands,
     /*  802056 */     // GIR_Coverage, 19655,
     /*  802056 */     GIR_EraseRootFromParent_Done,
     /*  802057 */   // Label 12432: @802057
     /*  802057 */   GIM_Try, /*On fail goto*//*Label 12433*/ GIMT_Encode4(802132), // Rule ID 19658 //
     /*  802062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  802073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  802076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  802079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  802082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802108 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  802111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802130 */     GIR_RootConstrainSelectedInstOperands,
     /*  802131 */     // GIR_Coverage, 19658,
     /*  802131 */     GIR_EraseRootFromParent_Done,
     /*  802132 */   // Label 12433: @802132
     /*  802132 */   GIM_Try, /*On fail goto*//*Label 12434*/ GIMT_Encode4(802207), // Rule ID 19659 //
     /*  802137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  802148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  802151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  802154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  802157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802183 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  802186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802205 */     GIR_RootConstrainSelectedInstOperands,
     /*  802206 */     // GIR_Coverage, 19659,
     /*  802206 */     GIR_EraseRootFromParent_Done,
     /*  802207 */   // Label 12434: @802207
     /*  802207 */   GIM_Try, /*On fail goto*//*Label 12435*/ GIMT_Encode4(802282), // Rule ID 19662 //
     /*  802212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  802223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  802226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  802229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  802232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802258 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  802261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802280 */     GIR_RootConstrainSelectedInstOperands,
     /*  802281 */     // GIR_Coverage, 19662,
     /*  802281 */     GIR_EraseRootFromParent_Done,
     /*  802282 */   // Label 12435: @802282
     /*  802282 */   GIM_Try, /*On fail goto*//*Label 12436*/ GIMT_Encode4(802357), // Rule ID 19663 //
     /*  802287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  802298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  802301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  802304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  802307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802333 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  802336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802355 */     GIR_RootConstrainSelectedInstOperands,
     /*  802356 */     // GIR_Coverage, 19663,
     /*  802356 */     GIR_EraseRootFromParent_Done,
     /*  802357 */   // Label 12436: @802357
     /*  802357 */   GIM_Try, /*On fail goto*//*Label 12437*/ GIMT_Encode4(802432), // Rule ID 19666 //
     /*  802362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  802373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  802376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  802379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  802382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  802411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802430 */     GIR_RootConstrainSelectedInstOperands,
     /*  802431 */     // GIR_Coverage, 19666,
     /*  802431 */     GIR_EraseRootFromParent_Done,
     /*  802432 */   // Label 12437: @802432
     /*  802432 */   GIM_Try, /*On fail goto*//*Label 12438*/ GIMT_Encode4(802507), // Rule ID 19667 //
     /*  802437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  802448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  802451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  802454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  802457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802483 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  802486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802505 */     GIR_RootConstrainSelectedInstOperands,
     /*  802506 */     // GIR_Coverage, 19667,
     /*  802506 */     GIR_EraseRootFromParent_Done,
     /*  802507 */   // Label 12438: @802507
     /*  802507 */   GIM_Try, /*On fail goto*//*Label 12439*/ GIMT_Encode4(802582), // Rule ID 19670 //
     /*  802512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  802515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  802526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  802529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  802532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802558 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  802558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  802561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802580 */     GIR_RootConstrainSelectedInstOperands,
     /*  802581 */     // GIR_Coverage, 19670,
     /*  802581 */     GIR_EraseRootFromParent_Done,
     /*  802582 */   // Label 12439: @802582
     /*  802582 */   GIM_Try, /*On fail goto*//*Label 12440*/ GIMT_Encode4(802657), // Rule ID 19671 //
     /*  802587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  802590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  802601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  802604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  802607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802633 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  802633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  802636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802655 */     GIR_RootConstrainSelectedInstOperands,
     /*  802656 */     // GIR_Coverage, 19671,
     /*  802656 */     GIR_EraseRootFromParent_Done,
     /*  802657 */   // Label 12440: @802657
     /*  802657 */   GIM_Try, /*On fail goto*//*Label 12441*/ GIMT_Encode4(802732), // Rule ID 19674 //
     /*  802662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802708 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  802711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802730 */     GIR_RootConstrainSelectedInstOperands,
     /*  802731 */     // GIR_Coverage, 19674,
     /*  802731 */     GIR_EraseRootFromParent_Done,
     /*  802732 */   // Label 12441: @802732
     /*  802732 */   GIM_Try, /*On fail goto*//*Label 12442*/ GIMT_Encode4(802807), // Rule ID 19675 //
     /*  802737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802783 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  802786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802805 */     GIR_RootConstrainSelectedInstOperands,
     /*  802806 */     // GIR_Coverage, 19675,
     /*  802806 */     GIR_EraseRootFromParent_Done,
     /*  802807 */   // Label 12442: @802807
     /*  802807 */   GIM_Try, /*On fail goto*//*Label 12443*/ GIMT_Encode4(802882), // Rule ID 19678 //
     /*  802812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802858 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  802861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802880 */     GIR_RootConstrainSelectedInstOperands,
     /*  802881 */     // GIR_Coverage, 19678,
     /*  802881 */     GIR_EraseRootFromParent_Done,
     /*  802882 */   // Label 12443: @802882
     /*  802882 */   GIM_Try, /*On fail goto*//*Label 12444*/ GIMT_Encode4(802957), // Rule ID 19679 //
     /*  802887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802933 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  802936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802955 */     GIR_RootConstrainSelectedInstOperands,
     /*  802956 */     // GIR_Coverage, 19679,
     /*  802956 */     GIR_EraseRootFromParent_Done,
     /*  802957 */   // Label 12444: @802957
     /*  802957 */   GIM_Try, /*On fail goto*//*Label 12445*/ GIMT_Encode4(803032), // Rule ID 19682 //
     /*  802962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  802973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  802976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  802979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  802982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803008 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  803011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803030 */     GIR_RootConstrainSelectedInstOperands,
     /*  803031 */     // GIR_Coverage, 19682,
     /*  803031 */     GIR_EraseRootFromParent_Done,
     /*  803032 */   // Label 12445: @803032
     /*  803032 */   GIM_Try, /*On fail goto*//*Label 12446*/ GIMT_Encode4(803107), // Rule ID 19683 //
     /*  803037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  803048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  803051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  803054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  803057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803083 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  803086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803105 */     GIR_RootConstrainSelectedInstOperands,
     /*  803106 */     // GIR_Coverage, 19683,
     /*  803106 */     GIR_EraseRootFromParent_Done,
     /*  803107 */   // Label 12446: @803107
     /*  803107 */   GIM_Try, /*On fail goto*//*Label 12447*/ GIMT_Encode4(803182), // Rule ID 19686 //
     /*  803112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  803132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803158 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  803161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803180 */     GIR_RootConstrainSelectedInstOperands,
     /*  803181 */     // GIR_Coverage, 19686,
     /*  803181 */     GIR_EraseRootFromParent_Done,
     /*  803182 */   // Label 12447: @803182
     /*  803182 */   GIM_Try, /*On fail goto*//*Label 12448*/ GIMT_Encode4(803257), // Rule ID 19687 //
     /*  803187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  803198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  803201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  803204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  803207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803233 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  803236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803255 */     GIR_RootConstrainSelectedInstOperands,
     /*  803256 */     // GIR_Coverage, 19687,
     /*  803256 */     GIR_EraseRootFromParent_Done,
     /*  803257 */   // Label 12448: @803257
     /*  803257 */   GIM_Try, /*On fail goto*//*Label 12449*/ GIMT_Encode4(803332), // Rule ID 19690 //
     /*  803262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  803282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803308 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  803311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803330 */     GIR_RootConstrainSelectedInstOperands,
     /*  803331 */     // GIR_Coverage, 19690,
     /*  803331 */     GIR_EraseRootFromParent_Done,
     /*  803332 */   // Label 12449: @803332
     /*  803332 */   GIM_Try, /*On fail goto*//*Label 12450*/ GIMT_Encode4(803407), // Rule ID 19691 //
     /*  803337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  803348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  803351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  803354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  803357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803383 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  803386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803405 */     GIR_RootConstrainSelectedInstOperands,
     /*  803406 */     // GIR_Coverage, 19691,
     /*  803406 */     GIR_EraseRootFromParent_Done,
     /*  803407 */   // Label 12450: @803407
     /*  803407 */   GIM_Try, /*On fail goto*//*Label 12451*/ GIMT_Encode4(803482), // Rule ID 19694 //
     /*  803412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  803432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803458 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  803461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803480 */     GIR_RootConstrainSelectedInstOperands,
     /*  803481 */     // GIR_Coverage, 19694,
     /*  803481 */     GIR_EraseRootFromParent_Done,
     /*  803482 */   // Label 12451: @803482
     /*  803482 */   GIM_Try, /*On fail goto*//*Label 12452*/ GIMT_Encode4(803557), // Rule ID 19695 //
     /*  803487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  803498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  803501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  803504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  803507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803533 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  803536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803555 */     GIR_RootConstrainSelectedInstOperands,
     /*  803556 */     // GIR_Coverage, 19695,
     /*  803556 */     GIR_EraseRootFromParent_Done,
     /*  803557 */   // Label 12452: @803557
     /*  803557 */   GIM_Try, /*On fail goto*//*Label 12453*/ GIMT_Encode4(803632), // Rule ID 19698 //
     /*  803562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  803573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  803576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  803579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  803582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803608 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  803611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803630 */     GIR_RootConstrainSelectedInstOperands,
     /*  803631 */     // GIR_Coverage, 19698,
     /*  803631 */     GIR_EraseRootFromParent_Done,
     /*  803632 */   // Label 12453: @803632
     /*  803632 */   GIM_Try, /*On fail goto*//*Label 12454*/ GIMT_Encode4(803707), // Rule ID 19699 //
     /*  803637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  803648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  803651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  803654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  803657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803683 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  803686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803705 */     GIR_RootConstrainSelectedInstOperands,
     /*  803706 */     // GIR_Coverage, 19699,
     /*  803706 */     GIR_EraseRootFromParent_Done,
     /*  803707 */   // Label 12454: @803707
     /*  803707 */   GIM_Try, /*On fail goto*//*Label 12455*/ GIMT_Encode4(803782), // Rule ID 19702 //
     /*  803712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803758 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  803761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803780 */     GIR_RootConstrainSelectedInstOperands,
     /*  803781 */     // GIR_Coverage, 19702,
     /*  803781 */     GIR_EraseRootFromParent_Done,
     /*  803782 */   // Label 12455: @803782
     /*  803782 */   GIM_Try, /*On fail goto*//*Label 12456*/ GIMT_Encode4(803857), // Rule ID 19703 //
     /*  803787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803833 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  803836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803855 */     GIR_RootConstrainSelectedInstOperands,
     /*  803856 */     // GIR_Coverage, 19703,
     /*  803856 */     GIR_EraseRootFromParent_Done,
     /*  803857 */   // Label 12456: @803857
     /*  803857 */   GIM_Try, /*On fail goto*//*Label 12457*/ GIMT_Encode4(803932), // Rule ID 19706 //
     /*  803862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803908 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  803911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803930 */     GIR_RootConstrainSelectedInstOperands,
     /*  803931 */     // GIR_Coverage, 19706,
     /*  803931 */     GIR_EraseRootFromParent_Done,
     /*  803932 */   // Label 12457: @803932
     /*  803932 */   GIM_Try, /*On fail goto*//*Label 12458*/ GIMT_Encode4(804007), // Rule ID 19707 //
     /*  803937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803983 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  803986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804005 */     GIR_RootConstrainSelectedInstOperands,
     /*  804006 */     // GIR_Coverage, 19707,
     /*  804006 */     GIR_EraseRootFromParent_Done,
     /*  804007 */   // Label 12458: @804007
     /*  804007 */   GIM_Try, /*On fail goto*//*Label 12459*/ GIMT_Encode4(804082), // Rule ID 19710 //
     /*  804012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804058 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  804061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804080 */     GIR_RootConstrainSelectedInstOperands,
     /*  804081 */     // GIR_Coverage, 19710,
     /*  804081 */     GIR_EraseRootFromParent_Done,
     /*  804082 */   // Label 12459: @804082
     /*  804082 */   GIM_Try, /*On fail goto*//*Label 12460*/ GIMT_Encode4(804157), // Rule ID 19711 //
     /*  804087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  804098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  804101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  804104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804133 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  804136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804155 */     GIR_RootConstrainSelectedInstOperands,
     /*  804156 */     // GIR_Coverage, 19711,
     /*  804156 */     GIR_EraseRootFromParent_Done,
     /*  804157 */   // Label 12460: @804157
     /*  804157 */   GIM_Try, /*On fail goto*//*Label 12461*/ GIMT_Encode4(804232), // Rule ID 19714 //
     /*  804162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804208 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  804211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804230 */     GIR_RootConstrainSelectedInstOperands,
     /*  804231 */     // GIR_Coverage, 19714,
     /*  804231 */     GIR_EraseRootFromParent_Done,
     /*  804232 */   // Label 12461: @804232
     /*  804232 */   GIM_Try, /*On fail goto*//*Label 12462*/ GIMT_Encode4(804307), // Rule ID 19715 //
     /*  804237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  804248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  804251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  804254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804283 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  804286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804305 */     GIR_RootConstrainSelectedInstOperands,
     /*  804306 */     // GIR_Coverage, 19715,
     /*  804306 */     GIR_EraseRootFromParent_Done,
     /*  804307 */   // Label 12462: @804307
     /*  804307 */   GIM_Try, /*On fail goto*//*Label 12463*/ GIMT_Encode4(804382), // Rule ID 19718 //
     /*  804312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804358 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  804361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804380 */     GIR_RootConstrainSelectedInstOperands,
     /*  804381 */     // GIR_Coverage, 19718,
     /*  804381 */     GIR_EraseRootFromParent_Done,
     /*  804382 */   // Label 12463: @804382
     /*  804382 */   GIM_Try, /*On fail goto*//*Label 12464*/ GIMT_Encode4(804457), // Rule ID 19719 //
     /*  804387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  804398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  804401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  804404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804433 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  804436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804455 */     GIR_RootConstrainSelectedInstOperands,
     /*  804456 */     // GIR_Coverage, 19719,
     /*  804456 */     GIR_EraseRootFromParent_Done,
     /*  804457 */   // Label 12464: @804457
     /*  804457 */   GIM_Try, /*On fail goto*//*Label 12465*/ GIMT_Encode4(804532), // Rule ID 19722 //
     /*  804462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  804473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  804476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  804479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804508 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  804511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804530 */     GIR_RootConstrainSelectedInstOperands,
     /*  804531 */     // GIR_Coverage, 19722,
     /*  804531 */     GIR_EraseRootFromParent_Done,
     /*  804532 */   // Label 12465: @804532
     /*  804532 */   GIM_Try, /*On fail goto*//*Label 12466*/ GIMT_Encode4(804607), // Rule ID 19723 //
     /*  804537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  804548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  804551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  804554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804583 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11269:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  804586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804605 */     GIR_RootConstrainSelectedInstOperands,
     /*  804606 */     // GIR_Coverage, 19723,
     /*  804606 */     GIR_EraseRootFromParent_Done,
     /*  804607 */   // Label 12466: @804607
     /*  804607 */   GIM_Try, /*On fail goto*//*Label 12467*/ GIMT_Encode4(804682), // Rule ID 19726 //
     /*  804612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  804623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  804626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  804629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804658 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  804661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804680 */     GIR_RootConstrainSelectedInstOperands,
     /*  804681 */     // GIR_Coverage, 19726,
     /*  804681 */     GIR_EraseRootFromParent_Done,
     /*  804682 */   // Label 12467: @804682
     /*  804682 */   GIM_Try, /*On fail goto*//*Label 12468*/ GIMT_Encode4(804757), // Rule ID 19727 //
     /*  804687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  804698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  804701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  804704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804733 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11269:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  804736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804755 */     GIR_RootConstrainSelectedInstOperands,
     /*  804756 */     // GIR_Coverage, 19727,
     /*  804756 */     GIR_EraseRootFromParent_Done,
     /*  804757 */   // Label 12468: @804757
     /*  804757 */   GIM_Try, /*On fail goto*//*Label 12469*/ GIMT_Encode4(804832), // Rule ID 19730 //
     /*  804762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804808 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  804811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804830 */     GIR_RootConstrainSelectedInstOperands,
     /*  804831 */     // GIR_Coverage, 19730,
     /*  804831 */     GIR_EraseRootFromParent_Done,
     /*  804832 */   // Label 12469: @804832
     /*  804832 */   GIM_Try, /*On fail goto*//*Label 12470*/ GIMT_Encode4(804907), // Rule ID 19731 //
     /*  804837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804883 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11269:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  804886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804905 */     GIR_RootConstrainSelectedInstOperands,
     /*  804906 */     // GIR_Coverage, 19731,
     /*  804906 */     GIR_EraseRootFromParent_Done,
     /*  804907 */   // Label 12470: @804907
     /*  804907 */   GIM_Try, /*On fail goto*//*Label 12471*/ GIMT_Encode4(804982), // Rule ID 19734 //
     /*  804912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  804923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  804926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  804929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804958 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  804961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804980 */     GIR_RootConstrainSelectedInstOperands,
     /*  804981 */     // GIR_Coverage, 19734,
     /*  804981 */     GIR_EraseRootFromParent_Done,
     /*  804982 */   // Label 12471: @804982
     /*  804982 */   GIM_Try, /*On fail goto*//*Label 12472*/ GIMT_Encode4(805057), // Rule ID 19735 //
     /*  804987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  804998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  805001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  805004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805033 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  805036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805055 */     GIR_RootConstrainSelectedInstOperands,
     /*  805056 */     // GIR_Coverage, 19735,
     /*  805056 */     GIR_EraseRootFromParent_Done,
     /*  805057 */   // Label 12472: @805057
     /*  805057 */   GIM_Try, /*On fail goto*//*Label 12473*/ GIMT_Encode4(805132), // Rule ID 19738 //
     /*  805062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  805073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  805076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  805079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805108 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  805111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805130 */     GIR_RootConstrainSelectedInstOperands,
     /*  805131 */     // GIR_Coverage, 19738,
     /*  805131 */     GIR_EraseRootFromParent_Done,
     /*  805132 */   // Label 12473: @805132
     /*  805132 */   GIM_Try, /*On fail goto*//*Label 12474*/ GIMT_Encode4(805207), // Rule ID 19739 //
     /*  805137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  805148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  805151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  805154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805183 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  805186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805205 */     GIR_RootConstrainSelectedInstOperands,
     /*  805206 */     // GIR_Coverage, 19739,
     /*  805206 */     GIR_EraseRootFromParent_Done,
     /*  805207 */   // Label 12474: @805207
     /*  805207 */   GIM_Try, /*On fail goto*//*Label 12475*/ GIMT_Encode4(805282), // Rule ID 19742 //
     /*  805212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  805215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  805223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  805226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  805229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805258 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  805258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  805261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805280 */     GIR_RootConstrainSelectedInstOperands,
     /*  805281 */     // GIR_Coverage, 19742,
     /*  805281 */     GIR_EraseRootFromParent_Done,
     /*  805282 */   // Label 12475: @805282
     /*  805282 */   GIM_Try, /*On fail goto*//*Label 12476*/ GIMT_Encode4(805357), // Rule ID 19743 //
     /*  805287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  805290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  805298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  805301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  805304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  805307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  805326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805333 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  805333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  805336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  805352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805355 */     GIR_RootConstrainSelectedInstOperands,
     /*  805356 */     // GIR_Coverage, 19743,
     /*  805356 */     GIR_EraseRootFromParent_Done,
     /*  805357 */   // Label 12476: @805357
     /*  805357 */   GIM_Try, /*On fail goto*//*Label 12477*/ GIMT_Encode4(805432), // Rule ID 19746 //
     /*  805362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  805373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  805376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  805379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805408 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  805411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805430 */     GIR_RootConstrainSelectedInstOperands,
     /*  805431 */     // GIR_Coverage, 19746,
     /*  805431 */     GIR_EraseRootFromParent_Done,
     /*  805432 */   // Label 12477: @805432
     /*  805432 */   GIM_Try, /*On fail goto*//*Label 12478*/ GIMT_Encode4(805507), // Rule ID 19747 //
     /*  805437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  805448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  805451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  805454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805483 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  805486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805505 */     GIR_RootConstrainSelectedInstOperands,
     /*  805506 */     // GIR_Coverage, 19747,
     /*  805506 */     GIR_EraseRootFromParent_Done,
     /*  805507 */   // Label 12478: @805507
     /*  805507 */   GIM_Try, /*On fail goto*//*Label 12479*/ GIMT_Encode4(805582), // Rule ID 19750 //
     /*  805512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  805523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  805526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  805529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805558 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  805561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805580 */     GIR_RootConstrainSelectedInstOperands,
     /*  805581 */     // GIR_Coverage, 19750,
     /*  805581 */     GIR_EraseRootFromParent_Done,
     /*  805582 */   // Label 12479: @805582
     /*  805582 */   GIM_Try, /*On fail goto*//*Label 12480*/ GIMT_Encode4(805657), // Rule ID 19751 //
     /*  805587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  805598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  805601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  805604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805633 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  805636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805655 */     GIR_RootConstrainSelectedInstOperands,
     /*  805656 */     // GIR_Coverage, 19751,
     /*  805656 */     GIR_EraseRootFromParent_Done,
     /*  805657 */   // Label 12480: @805657
     /*  805657 */   GIM_Try, /*On fail goto*//*Label 12481*/ GIMT_Encode4(805732), // Rule ID 19754 //
     /*  805662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  805711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805730 */     GIR_RootConstrainSelectedInstOperands,
     /*  805731 */     // GIR_Coverage, 19754,
     /*  805731 */     GIR_EraseRootFromParent_Done,
     /*  805732 */   // Label 12481: @805732
     /*  805732 */   GIM_Try, /*On fail goto*//*Label 12482*/ GIMT_Encode4(805807), // Rule ID 19755 //
     /*  805737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805783 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  805786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805805 */     GIR_RootConstrainSelectedInstOperands,
     /*  805806 */     // GIR_Coverage, 19755,
     /*  805806 */     GIR_EraseRootFromParent_Done,
     /*  805807 */   // Label 12482: @805807
     /*  805807 */   GIM_Try, /*On fail goto*//*Label 12483*/ GIMT_Encode4(805882), // Rule ID 19758 //
     /*  805812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805858 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  805861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805880 */     GIR_RootConstrainSelectedInstOperands,
     /*  805881 */     // GIR_Coverage, 19758,
     /*  805881 */     GIR_EraseRootFromParent_Done,
     /*  805882 */   // Label 12483: @805882
     /*  805882 */   GIM_Try, /*On fail goto*//*Label 12484*/ GIMT_Encode4(805957), // Rule ID 19759 //
     /*  805887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11269:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  805936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805955 */     GIR_RootConstrainSelectedInstOperands,
     /*  805956 */     // GIR_Coverage, 19759,
     /*  805956 */     GIR_EraseRootFromParent_Done,
     /*  805957 */   // Label 12484: @805957
     /*  805957 */   GIM_Try, /*On fail goto*//*Label 12485*/ GIMT_Encode4(806032), // Rule ID 19762 //
     /*  805962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  805973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  805976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  805979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806008 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  806011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806030 */     GIR_RootConstrainSelectedInstOperands,
     /*  806031 */     // GIR_Coverage, 19762,
     /*  806031 */     GIR_EraseRootFromParent_Done,
     /*  806032 */   // Label 12485: @806032
     /*  806032 */   GIM_Try, /*On fail goto*//*Label 12486*/ GIMT_Encode4(806107), // Rule ID 19763 //
     /*  806037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  806048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  806051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  806054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  806072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806083 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11269:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  806086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806105 */     GIR_RootConstrainSelectedInstOperands,
     /*  806106 */     // GIR_Coverage, 19763,
     /*  806106 */     GIR_EraseRootFromParent_Done,
     /*  806107 */   // Label 12486: @806107
     /*  806107 */   GIM_Try, /*On fail goto*//*Label 12487*/ GIMT_Encode4(806182), // Rule ID 19766 //
     /*  806112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  806115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  806123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  806126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  806129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806158 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  806158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  806161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806180 */     GIR_RootConstrainSelectedInstOperands,
     /*  806181 */     // GIR_Coverage, 19766,
     /*  806181 */     GIR_EraseRootFromParent_Done,
     /*  806182 */   // Label 12487: @806182
     /*  806182 */   GIM_Try, /*On fail goto*//*Label 12488*/ GIMT_Encode4(806257), // Rule ID 19767 //
     /*  806187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  806190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  806195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  806198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  806201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  806204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  806207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  806222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  806226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806233 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11269:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  806233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  806236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  806240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  806252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806255 */     GIR_RootConstrainSelectedInstOperands,
     /*  806256 */     // GIR_Coverage, 19767,
     /*  806256 */     GIR_EraseRootFromParent_Done,
     /*  806257 */   // Label 12488: @806257
     /*  806257 */   GIM_Try, /*On fail goto*//*Label 12489*/ GIMT_Encode4(806332), // Rule ID 21984 //
     /*  806262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  806279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806308 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  806308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  806311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806330 */     GIR_RootConstrainSelectedInstOperands,
     /*  806331 */     // GIR_Coverage, 21984,
     /*  806331 */     GIR_EraseRootFromParent_Done,
     /*  806332 */   // Label 12489: @806332
     /*  806332 */   GIM_Try, /*On fail goto*//*Label 12490*/ GIMT_Encode4(806407), // Rule ID 21985 //
     /*  806337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  806354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806383 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  806383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  806386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806405 */     GIR_RootConstrainSelectedInstOperands,
     /*  806406 */     // GIR_Coverage, 21985,
     /*  806406 */     GIR_EraseRootFromParent_Done,
     /*  806407 */   // Label 12490: @806407
     /*  806407 */   GIM_Try, /*On fail goto*//*Label 12491*/ GIMT_Encode4(806482), // Rule ID 21988 //
     /*  806412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  806429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  806458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  806461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806480 */     GIR_RootConstrainSelectedInstOperands,
     /*  806481 */     // GIR_Coverage, 21988,
     /*  806481 */     GIR_EraseRootFromParent_Done,
     /*  806482 */   // Label 12491: @806482
     /*  806482 */   GIM_Try, /*On fail goto*//*Label 12492*/ GIMT_Encode4(806557), // Rule ID 21989 //
     /*  806487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  806504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806533 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  806533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  806536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806555 */     GIR_RootConstrainSelectedInstOperands,
     /*  806556 */     // GIR_Coverage, 21989,
     /*  806556 */     GIR_EraseRootFromParent_Done,
     /*  806557 */   // Label 12492: @806557
     /*  806557 */   GIM_Try, /*On fail goto*//*Label 12493*/ GIMT_Encode4(806632), // Rule ID 21992 //
     /*  806562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  806579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  806611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806630 */     GIR_RootConstrainSelectedInstOperands,
     /*  806631 */     // GIR_Coverage, 21992,
     /*  806631 */     GIR_EraseRootFromParent_Done,
     /*  806632 */   // Label 12493: @806632
     /*  806632 */   GIM_Try, /*On fail goto*//*Label 12494*/ GIMT_Encode4(806707), // Rule ID 21993 //
     /*  806637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  806654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  806686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806705 */     GIR_RootConstrainSelectedInstOperands,
     /*  806706 */     // GIR_Coverage, 21993,
     /*  806706 */     GIR_EraseRootFromParent_Done,
     /*  806707 */   // Label 12494: @806707
     /*  806707 */   GIM_Try, /*On fail goto*//*Label 12495*/ GIMT_Encode4(806782), // Rule ID 21996 //
     /*  806712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  806729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806758 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  806761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806780 */     GIR_RootConstrainSelectedInstOperands,
     /*  806781 */     // GIR_Coverage, 21996,
     /*  806781 */     GIR_EraseRootFromParent_Done,
     /*  806782 */   // Label 12495: @806782
     /*  806782 */   GIM_Try, /*On fail goto*//*Label 12496*/ GIMT_Encode4(806857), // Rule ID 21997 //
     /*  806787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  806804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806833 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  806836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806855 */     GIR_RootConstrainSelectedInstOperands,
     /*  806856 */     // GIR_Coverage, 21997,
     /*  806856 */     GIR_EraseRootFromParent_Done,
     /*  806857 */   // Label 12496: @806857
     /*  806857 */   GIM_Try, /*On fail goto*//*Label 12497*/ GIMT_Encode4(806932), // Rule ID 22000 //
     /*  806862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  806879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806908 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  806911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806930 */     GIR_RootConstrainSelectedInstOperands,
     /*  806931 */     // GIR_Coverage, 22000,
     /*  806931 */     GIR_EraseRootFromParent_Done,
     /*  806932 */   // Label 12497: @806932
     /*  806932 */   GIM_Try, /*On fail goto*//*Label 12498*/ GIMT_Encode4(807007), // Rule ID 22001 //
     /*  806937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  806954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806983 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  806986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807005 */     GIR_RootConstrainSelectedInstOperands,
     /*  807006 */     // GIR_Coverage, 22001,
     /*  807006 */     GIR_EraseRootFromParent_Done,
     /*  807007 */   // Label 12498: @807007
     /*  807007 */   GIM_Try, /*On fail goto*//*Label 12499*/ GIMT_Encode4(807082), // Rule ID 22004 //
     /*  807012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  807029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  807061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807080 */     GIR_RootConstrainSelectedInstOperands,
     /*  807081 */     // GIR_Coverage, 22004,
     /*  807081 */     GIR_EraseRootFromParent_Done,
     /*  807082 */   // Label 12499: @807082
     /*  807082 */   GIM_Try, /*On fail goto*//*Label 12500*/ GIMT_Encode4(807157), // Rule ID 22005 //
     /*  807087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  807104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807133 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  807136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807155 */     GIR_RootConstrainSelectedInstOperands,
     /*  807156 */     // GIR_Coverage, 22005,
     /*  807156 */     GIR_EraseRootFromParent_Done,
     /*  807157 */   // Label 12500: @807157
     /*  807157 */   GIM_Try, /*On fail goto*//*Label 12501*/ GIMT_Encode4(807232), // Rule ID 22008 //
     /*  807162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  807179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  807211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807230 */     GIR_RootConstrainSelectedInstOperands,
     /*  807231 */     // GIR_Coverage, 22008,
     /*  807231 */     GIR_EraseRootFromParent_Done,
     /*  807232 */   // Label 12501: @807232
     /*  807232 */   GIM_Try, /*On fail goto*//*Label 12502*/ GIMT_Encode4(807307), // Rule ID 22009 //
     /*  807237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  807254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  807286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807305 */     GIR_RootConstrainSelectedInstOperands,
     /*  807306 */     // GIR_Coverage, 22009,
     /*  807306 */     GIR_EraseRootFromParent_Done,
     /*  807307 */   // Label 12502: @807307
     /*  807307 */   GIM_Try, /*On fail goto*//*Label 12503*/ GIMT_Encode4(807382), // Rule ID 22012 //
     /*  807312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  807329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  807358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  807361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807380 */     GIR_RootConstrainSelectedInstOperands,
     /*  807381 */     // GIR_Coverage, 22012,
     /*  807381 */     GIR_EraseRootFromParent_Done,
     /*  807382 */   // Label 12503: @807382
     /*  807382 */   GIM_Try, /*On fail goto*//*Label 12504*/ GIMT_Encode4(807457), // Rule ID 22013 //
     /*  807387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  807398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  807401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  807404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  807407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  807433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  807436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  807452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807455 */     GIR_RootConstrainSelectedInstOperands,
     /*  807456 */     // GIR_Coverage, 22013,
     /*  807456 */     GIR_EraseRootFromParent_Done,
     /*  807457 */   // Label 12504: @807457
     /*  807457 */   GIM_Try, /*On fail goto*//*Label 12505*/ GIMT_Encode4(807532), // Rule ID 22016 //
     /*  807462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  807465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  807473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  807476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  807479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  807482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  807511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807530 */     GIR_RootConstrainSelectedInstOperands,
     /*  807531 */     // GIR_Coverage, 22016,
     /*  807531 */     GIR_EraseRootFromParent_Done,
     /*  807532 */   // Label 12505: @807532
     /*  807532 */   GIM_Try, /*On fail goto*//*Label 12506*/ GIMT_Encode4(807607), // Rule ID 22017 //
     /*  807537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  807540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  807548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  807551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  807554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  807557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807583 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  807586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807605 */     GIR_RootConstrainSelectedInstOperands,
     /*  807606 */     // GIR_Coverage, 22017,
     /*  807606 */     GIR_EraseRootFromParent_Done,
     /*  807607 */   // Label 12506: @807607
     /*  807607 */   GIM_Try, /*On fail goto*//*Label 12507*/ GIMT_Encode4(807682), // Rule ID 22020 //
     /*  807612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  807629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  807661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807680 */     GIR_RootConstrainSelectedInstOperands,
     /*  807681 */     // GIR_Coverage, 22020,
     /*  807681 */     GIR_EraseRootFromParent_Done,
     /*  807682 */   // Label 12507: @807682
     /*  807682 */   GIM_Try, /*On fail goto*//*Label 12508*/ GIMT_Encode4(807757), // Rule ID 22021 //
     /*  807687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  807704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807733 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  807736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807755 */     GIR_RootConstrainSelectedInstOperands,
     /*  807756 */     // GIR_Coverage, 22021,
     /*  807756 */     GIR_EraseRootFromParent_Done,
     /*  807757 */   // Label 12508: @807757
     /*  807757 */   GIM_Try, /*On fail goto*//*Label 12509*/ GIMT_Encode4(807832), // Rule ID 22024 //
     /*  807762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  807779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807808 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  807811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807830 */     GIR_RootConstrainSelectedInstOperands,
     /*  807831 */     // GIR_Coverage, 22024,
     /*  807831 */     GIR_EraseRootFromParent_Done,
     /*  807832 */   // Label 12509: @807832
     /*  807832 */   GIM_Try, /*On fail goto*//*Label 12510*/ GIMT_Encode4(807907), // Rule ID 22025 //
     /*  807837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  807854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807883 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  807886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807905 */     GIR_RootConstrainSelectedInstOperands,
     /*  807906 */     // GIR_Coverage, 22025,
     /*  807906 */     GIR_EraseRootFromParent_Done,
     /*  807907 */   // Label 12510: @807907
     /*  807907 */   GIM_Try, /*On fail goto*//*Label 12511*/ GIMT_Encode4(807982), // Rule ID 22028 //
     /*  807912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  807929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  807961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807980 */     GIR_RootConstrainSelectedInstOperands,
     /*  807981 */     // GIR_Coverage, 22028,
     /*  807981 */     GIR_EraseRootFromParent_Done,
     /*  807982 */   // Label 12511: @807982
     /*  807982 */   GIM_Try, /*On fail goto*//*Label 12512*/ GIMT_Encode4(808057), // Rule ID 22029 //
     /*  807987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  808004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808033 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11509:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  808033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  808036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808055 */     GIR_RootConstrainSelectedInstOperands,
     /*  808056 */     // GIR_Coverage, 22029,
     /*  808056 */     GIR_EraseRootFromParent_Done,
     /*  808057 */   // Label 12512: @808057
     /*  808057 */   GIM_Try, /*On fail goto*//*Label 12513*/ GIMT_Encode4(808132), // Rule ID 22032 //
     /*  808062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  808111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808130 */     GIR_RootConstrainSelectedInstOperands,
     /*  808131 */     // GIR_Coverage, 22032,
     /*  808131 */     GIR_EraseRootFromParent_Done,
     /*  808132 */   // Label 12513: @808132
     /*  808132 */   GIM_Try, /*On fail goto*//*Label 12514*/ GIMT_Encode4(808207), // Rule ID 22033 //
     /*  808137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  808154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808183 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  808186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808205 */     GIR_RootConstrainSelectedInstOperands,
     /*  808206 */     // GIR_Coverage, 22033,
     /*  808206 */     GIR_EraseRootFromParent_Done,
     /*  808207 */   // Label 12514: @808207
     /*  808207 */   GIM_Try, /*On fail goto*//*Label 12515*/ GIMT_Encode4(808282), // Rule ID 22036 //
     /*  808212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  808261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808280 */     GIR_RootConstrainSelectedInstOperands,
     /*  808281 */     // GIR_Coverage, 22036,
     /*  808281 */     GIR_EraseRootFromParent_Done,
     /*  808282 */   // Label 12515: @808282
     /*  808282 */   GIM_Try, /*On fail goto*//*Label 12516*/ GIMT_Encode4(808357), // Rule ID 22037 //
     /*  808287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  808304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808333 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  808336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808355 */     GIR_RootConstrainSelectedInstOperands,
     /*  808356 */     // GIR_Coverage, 22037,
     /*  808356 */     GIR_EraseRootFromParent_Done,
     /*  808357 */   // Label 12516: @808357
     /*  808357 */   GIM_Try, /*On fail goto*//*Label 12517*/ GIMT_Encode4(808432), // Rule ID 22040 //
     /*  808362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  808379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  808408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  808411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808430 */     GIR_RootConstrainSelectedInstOperands,
     /*  808431 */     // GIR_Coverage, 22040,
     /*  808431 */     GIR_EraseRootFromParent_Done,
     /*  808432 */   // Label 12517: @808432
     /*  808432 */   GIM_Try, /*On fail goto*//*Label 12518*/ GIMT_Encode4(808507), // Rule ID 22041 //
     /*  808437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  808448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  808451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  808454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  808457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11509:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  808483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  808486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  808502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808505 */     GIR_RootConstrainSelectedInstOperands,
     /*  808506 */     // GIR_Coverage, 22041,
     /*  808506 */     GIR_EraseRootFromParent_Done,
     /*  808507 */   // Label 12518: @808507
     /*  808507 */   GIM_Try, /*On fail goto*//*Label 12519*/ GIMT_Encode4(808582), // Rule ID 22044 //
     /*  808512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  808529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  808561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808580 */     GIR_RootConstrainSelectedInstOperands,
     /*  808581 */     // GIR_Coverage, 22044,
     /*  808581 */     GIR_EraseRootFromParent_Done,
     /*  808582 */   // Label 12519: @808582
     /*  808582 */   GIM_Try, /*On fail goto*//*Label 12520*/ GIMT_Encode4(808657), // Rule ID 22045 //
     /*  808587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  808604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  808636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808655 */     GIR_RootConstrainSelectedInstOperands,
     /*  808656 */     // GIR_Coverage, 22045,
     /*  808656 */     GIR_EraseRootFromParent_Done,
     /*  808657 */   // Label 12520: @808657
     /*  808657 */   GIM_Try, /*On fail goto*//*Label 12521*/ GIMT_Encode4(808732), // Rule ID 22048 //
     /*  808662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  808679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  808711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808730 */     GIR_RootConstrainSelectedInstOperands,
     /*  808731 */     // GIR_Coverage, 22048,
     /*  808731 */     GIR_EraseRootFromParent_Done,
     /*  808732 */   // Label 12521: @808732
     /*  808732 */   GIM_Try, /*On fail goto*//*Label 12522*/ GIMT_Encode4(808807), // Rule ID 22049 //
     /*  808737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  808754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808783 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  808786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808805 */     GIR_RootConstrainSelectedInstOperands,
     /*  808806 */     // GIR_Coverage, 22049,
     /*  808806 */     GIR_EraseRootFromParent_Done,
     /*  808807 */   // Label 12522: @808807
     /*  808807 */   GIM_Try, /*On fail goto*//*Label 12523*/ GIMT_Encode4(808882), // Rule ID 22052 //
     /*  808812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  808829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  808861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808880 */     GIR_RootConstrainSelectedInstOperands,
     /*  808881 */     // GIR_Coverage, 22052,
     /*  808881 */     GIR_EraseRootFromParent_Done,
     /*  808882 */   // Label 12523: @808882
     /*  808882 */   GIM_Try, /*On fail goto*//*Label 12524*/ GIMT_Encode4(808957), // Rule ID 22053 //
     /*  808887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  808904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11509:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  808936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808955 */     GIR_RootConstrainSelectedInstOperands,
     /*  808956 */     // GIR_Coverage, 22053,
     /*  808956 */     GIR_EraseRootFromParent_Done,
     /*  808957 */   // Label 12524: @808957
     /*  808957 */   GIM_Try, /*On fail goto*//*Label 12525*/ GIMT_Encode4(809032), // Rule ID 22056 //
     /*  808962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  808965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  808979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  809011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809030 */     GIR_RootConstrainSelectedInstOperands,
     /*  809031 */     // GIR_Coverage, 22056,
     /*  809031 */     GIR_EraseRootFromParent_Done,
     /*  809032 */   // Label 12525: @809032
     /*  809032 */   GIM_Try, /*On fail goto*//*Label 12526*/ GIMT_Encode4(809107), // Rule ID 22057 //
     /*  809037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  809054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  809072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809083 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  809086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809105 */     GIR_RootConstrainSelectedInstOperands,
     /*  809106 */     // GIR_Coverage, 22057,
     /*  809106 */     GIR_EraseRootFromParent_Done,
     /*  809107 */   // Label 12526: @809107
     /*  809107 */   GIM_Try, /*On fail goto*//*Label 12527*/ GIMT_Encode4(809182), // Rule ID 22060 //
     /*  809112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809158 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  809161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809180 */     GIR_RootConstrainSelectedInstOperands,
     /*  809181 */     // GIR_Coverage, 22060,
     /*  809181 */     GIR_EraseRootFromParent_Done,
     /*  809182 */   // Label 12527: @809182
     /*  809182 */   GIM_Try, /*On fail goto*//*Label 12528*/ GIMT_Encode4(809257), // Rule ID 22061 //
     /*  809187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  809204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  809222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809233 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  809236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809255 */     GIR_RootConstrainSelectedInstOperands,
     /*  809256 */     // GIR_Coverage, 22061,
     /*  809256 */     GIR_EraseRootFromParent_Done,
     /*  809257 */   // Label 12528: @809257
     /*  809257 */   GIM_Try, /*On fail goto*//*Label 12529*/ GIMT_Encode4(809332), // Rule ID 22064 //
     /*  809262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  809265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  809308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  809311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809330 */     GIR_RootConstrainSelectedInstOperands,
     /*  809331 */     // GIR_Coverage, 22064,
     /*  809331 */     GIR_EraseRootFromParent_Done,
     /*  809332 */   // Label 12529: @809332
     /*  809332 */   GIM_Try, /*On fail goto*//*Label 12530*/ GIMT_Encode4(809407), // Rule ID 22065 //
     /*  809337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  809340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  809345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  809348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  809351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  809354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  809357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  809372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11509:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  809383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  809386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  809402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809405 */     GIR_RootConstrainSelectedInstOperands,
     /*  809406 */     // GIR_Coverage, 22065,
     /*  809406 */     GIR_EraseRootFromParent_Done,
     /*  809407 */   // Label 12530: @809407
     /*  809407 */   GIM_Try, /*On fail goto*//*Label 12531*/ GIMT_Encode4(809482), // Rule ID 22068 //
     /*  809412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  809429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  809461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809480 */     GIR_RootConstrainSelectedInstOperands,
     /*  809481 */     // GIR_Coverage, 22068,
     /*  809481 */     GIR_EraseRootFromParent_Done,
     /*  809482 */   // Label 12531: @809482
     /*  809482 */   GIM_Try, /*On fail goto*//*Label 12532*/ GIMT_Encode4(809557), // Rule ID 22069 //
     /*  809487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  809504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809533 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  809536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809555 */     GIR_RootConstrainSelectedInstOperands,
     /*  809556 */     // GIR_Coverage, 22069,
     /*  809556 */     GIR_EraseRootFromParent_Done,
     /*  809557 */   // Label 12532: @809557
     /*  809557 */   GIM_Try, /*On fail goto*//*Label 12533*/ GIMT_Encode4(809632), // Rule ID 22072 //
     /*  809562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  809579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  809611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809630 */     GIR_RootConstrainSelectedInstOperands,
     /*  809631 */     // GIR_Coverage, 22072,
     /*  809631 */     GIR_EraseRootFromParent_Done,
     /*  809632 */   // Label 12533: @809632
     /*  809632 */   GIM_Try, /*On fail goto*//*Label 12534*/ GIMT_Encode4(809707), // Rule ID 22073 //
     /*  809637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  809654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809683 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  809686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809705 */     GIR_RootConstrainSelectedInstOperands,
     /*  809706 */     // GIR_Coverage, 22073,
     /*  809706 */     GIR_EraseRootFromParent_Done,
     /*  809707 */   // Label 12534: @809707
     /*  809707 */   GIM_Try, /*On fail goto*//*Label 12535*/ GIMT_Encode4(809782), // Rule ID 22076 //
     /*  809712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  809729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  809761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809780 */     GIR_RootConstrainSelectedInstOperands,
     /*  809781 */     // GIR_Coverage, 22076,
     /*  809781 */     GIR_EraseRootFromParent_Done,
     /*  809782 */   // Label 12535: @809782
     /*  809782 */   GIM_Try, /*On fail goto*//*Label 12536*/ GIMT_Encode4(809857), // Rule ID 22077 //
     /*  809787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  809804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809833 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  809836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809855 */     GIR_RootConstrainSelectedInstOperands,
     /*  809856 */     // GIR_Coverage, 22077,
     /*  809856 */     GIR_EraseRootFromParent_Done,
     /*  809857 */   // Label 12536: @809857
     /*  809857 */   GIM_Try, /*On fail goto*//*Label 12537*/ GIMT_Encode4(809932), // Rule ID 22080 //
     /*  809862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  809873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  809876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  809879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  809882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  809908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  809911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809930 */     GIR_RootConstrainSelectedInstOperands,
     /*  809931 */     // GIR_Coverage, 22080,
     /*  809931 */     GIR_EraseRootFromParent_Done,
     /*  809932 */   // Label 12537: @809932
     /*  809932 */   GIM_Try, /*On fail goto*//*Label 12538*/ GIMT_Encode4(810007), // Rule ID 22081 //
     /*  809937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  809948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  809951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  809954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  809957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809983 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  809986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810005 */     GIR_RootConstrainSelectedInstOperands,
     /*  810006 */     // GIR_Coverage, 22081,
     /*  810006 */     GIR_EraseRootFromParent_Done,
     /*  810007 */   // Label 12538: @810007
     /*  810007 */   GIM_Try, /*On fail goto*//*Label 12539*/ GIMT_Encode4(810082), // Rule ID 22084 //
     /*  810012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  810061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810080 */     GIR_RootConstrainSelectedInstOperands,
     /*  810081 */     // GIR_Coverage, 22084,
     /*  810081 */     GIR_EraseRootFromParent_Done,
     /*  810082 */   // Label 12539: @810082
     /*  810082 */   GIM_Try, /*On fail goto*//*Label 12540*/ GIMT_Encode4(810157), // Rule ID 22085 //
     /*  810087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  810104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810133 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  810136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810155 */     GIR_RootConstrainSelectedInstOperands,
     /*  810156 */     // GIR_Coverage, 22085,
     /*  810156 */     GIR_EraseRootFromParent_Done,
     /*  810157 */   // Label 12540: @810157
     /*  810157 */   GIM_Try, /*On fail goto*//*Label 12541*/ GIMT_Encode4(810232), // Rule ID 22088 //
     /*  810162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  810211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810230 */     GIR_RootConstrainSelectedInstOperands,
     /*  810231 */     // GIR_Coverage, 22088,
     /*  810231 */     GIR_EraseRootFromParent_Done,
     /*  810232 */   // Label 12541: @810232
     /*  810232 */   GIM_Try, /*On fail goto*//*Label 12542*/ GIMT_Encode4(810307), // Rule ID 22089 //
     /*  810237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  810254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810283 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  810286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810305 */     GIR_RootConstrainSelectedInstOperands,
     /*  810306 */     // GIR_Coverage, 22089,
     /*  810306 */     GIR_EraseRootFromParent_Done,
     /*  810307 */   // Label 12542: @810307
     /*  810307 */   GIM_Try, /*On fail goto*//*Label 12543*/ GIMT_Encode4(810382), // Rule ID 22092 //
     /*  810312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  810361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810380 */     GIR_RootConstrainSelectedInstOperands,
     /*  810381 */     // GIR_Coverage, 22092,
     /*  810381 */     GIR_EraseRootFromParent_Done,
     /*  810382 */   // Label 12543: @810382
     /*  810382 */   GIM_Try, /*On fail goto*//*Label 12544*/ GIMT_Encode4(810457), // Rule ID 22093 //
     /*  810387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  810404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810433 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  810436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810455 */     GIR_RootConstrainSelectedInstOperands,
     /*  810456 */     // GIR_Coverage, 22093,
     /*  810456 */     GIR_EraseRootFromParent_Done,
     /*  810457 */   // Label 12544: @810457
     /*  810457 */   GIM_Try, /*On fail goto*//*Label 12545*/ GIMT_Encode4(810532), // Rule ID 22096 //
     /*  810462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  810479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  810511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810530 */     GIR_RootConstrainSelectedInstOperands,
     /*  810531 */     // GIR_Coverage, 22096,
     /*  810531 */     GIR_EraseRootFromParent_Done,
     /*  810532 */   // Label 12545: @810532
     /*  810532 */   GIM_Try, /*On fail goto*//*Label 12546*/ GIMT_Encode4(810607), // Rule ID 22097 //
     /*  810537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  810554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810583 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  810586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810605 */     GIR_RootConstrainSelectedInstOperands,
     /*  810606 */     // GIR_Coverage, 22097,
     /*  810606 */     GIR_EraseRootFromParent_Done,
     /*  810607 */   // Label 12546: @810607
     /*  810607 */   GIM_Try, /*On fail goto*//*Label 12547*/ GIMT_Encode4(810682), // Rule ID 22100 //
     /*  810612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  810629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  810661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810680 */     GIR_RootConstrainSelectedInstOperands,
     /*  810681 */     // GIR_Coverage, 22100,
     /*  810681 */     GIR_EraseRootFromParent_Done,
     /*  810682 */   // Label 12547: @810682
     /*  810682 */   GIM_Try, /*On fail goto*//*Label 12548*/ GIMT_Encode4(810757), // Rule ID 22101 //
     /*  810687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  810704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810733 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  810736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810755 */     GIR_RootConstrainSelectedInstOperands,
     /*  810756 */     // GIR_Coverage, 22101,
     /*  810756 */     GIR_EraseRootFromParent_Done,
     /*  810757 */   // Label 12548: @810757
     /*  810757 */   GIM_Try, /*On fail goto*//*Label 12549*/ GIMT_Encode4(810832), // Rule ID 22104 //
     /*  810762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  810765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  810773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  810776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  810779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  810782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  810808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  810811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810830 */     GIR_RootConstrainSelectedInstOperands,
     /*  810831 */     // GIR_Coverage, 22104,
     /*  810831 */     GIR_EraseRootFromParent_Done,
     /*  810832 */   // Label 12549: @810832
     /*  810832 */   GIM_Try, /*On fail goto*//*Label 12550*/ GIMT_Encode4(810907), // Rule ID 22105 //
     /*  810837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  810840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  810848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  810851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  810854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  810857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810883 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  810883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  810886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810905 */     GIR_RootConstrainSelectedInstOperands,
     /*  810906 */     // GIR_Coverage, 22105,
     /*  810906 */     GIR_EraseRootFromParent_Done,
     /*  810907 */   // Label 12550: @810907
     /*  810907 */   GIM_Try, /*On fail goto*//*Label 12551*/ GIMT_Encode4(810982), // Rule ID 22108 //
     /*  810912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  810929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  810961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810980 */     GIR_RootConstrainSelectedInstOperands,
     /*  810981 */     // GIR_Coverage, 22108,
     /*  810981 */     GIR_EraseRootFromParent_Done,
     /*  810982 */   // Label 12551: @810982
     /*  810982 */   GIM_Try, /*On fail goto*//*Label 12552*/ GIMT_Encode4(811057), // Rule ID 22109 //
     /*  810987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  811004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811033 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  811036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811055 */     GIR_RootConstrainSelectedInstOperands,
     /*  811056 */     // GIR_Coverage, 22109,
     /*  811056 */     GIR_EraseRootFromParent_Done,
     /*  811057 */   // Label 12552: @811057
     /*  811057 */   GIM_Try, /*On fail goto*//*Label 12553*/ GIMT_Encode4(811132), // Rule ID 22112 //
     /*  811062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811108 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  811111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811130 */     GIR_RootConstrainSelectedInstOperands,
     /*  811131 */     // GIR_Coverage, 22112,
     /*  811131 */     GIR_EraseRootFromParent_Done,
     /*  811132 */   // Label 12553: @811132
     /*  811132 */   GIM_Try, /*On fail goto*//*Label 12554*/ GIMT_Encode4(811207), // Rule ID 22113 //
     /*  811137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  811154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811183 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  811186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811205 */     GIR_RootConstrainSelectedInstOperands,
     /*  811206 */     // GIR_Coverage, 22113,
     /*  811206 */     GIR_EraseRootFromParent_Done,
     /*  811207 */   // Label 12554: @811207
     /*  811207 */   GIM_Try, /*On fail goto*//*Label 12555*/ GIMT_Encode4(811282), // Rule ID 22116 //
     /*  811212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  811258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  811261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811280 */     GIR_RootConstrainSelectedInstOperands,
     /*  811281 */     // GIR_Coverage, 22116,
     /*  811281 */     GIR_EraseRootFromParent_Done,
     /*  811282 */   // Label 12555: @811282
     /*  811282 */   GIM_Try, /*On fail goto*//*Label 12556*/ GIMT_Encode4(811357), // Rule ID 22117 //
     /*  811287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  811298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  811301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  811304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  811307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811333 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11497:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  811333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  811336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  811352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811355 */     GIR_RootConstrainSelectedInstOperands,
     /*  811356 */     // GIR_Coverage, 22117,
     /*  811356 */     GIR_EraseRootFromParent_Done,
     /*  811357 */   // Label 12556: @811357
     /*  811357 */   GIM_Try, /*On fail goto*//*Label 12557*/ GIMT_Encode4(811432), // Rule ID 22120 //
     /*  811362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  811411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811430 */     GIR_RootConstrainSelectedInstOperands,
     /*  811431 */     // GIR_Coverage, 22120,
     /*  811431 */     GIR_EraseRootFromParent_Done,
     /*  811432 */   // Label 12557: @811432
     /*  811432 */   GIM_Try, /*On fail goto*//*Label 12558*/ GIMT_Encode4(811507), // Rule ID 22121 //
     /*  811437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  811454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  811486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811505 */     GIR_RootConstrainSelectedInstOperands,
     /*  811506 */     // GIR_Coverage, 22121,
     /*  811506 */     GIR_EraseRootFromParent_Done,
     /*  811507 */   // Label 12558: @811507
     /*  811507 */   GIM_Try, /*On fail goto*//*Label 12559*/ GIMT_Encode4(811582), // Rule ID 22124 //
     /*  811512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  811529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  811561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811580 */     GIR_RootConstrainSelectedInstOperands,
     /*  811581 */     // GIR_Coverage, 22124,
     /*  811581 */     GIR_EraseRootFromParent_Done,
     /*  811582 */   // Label 12559: @811582
     /*  811582 */   GIM_Try, /*On fail goto*//*Label 12560*/ GIMT_Encode4(811657), // Rule ID 22125 //
     /*  811587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  811604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811633 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  811636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811655 */     GIR_RootConstrainSelectedInstOperands,
     /*  811656 */     // GIR_Coverage, 22125,
     /*  811656 */     GIR_EraseRootFromParent_Done,
     /*  811657 */   // Label 12560: @811657
     /*  811657 */   GIM_Try, /*On fail goto*//*Label 12561*/ GIMT_Encode4(811732), // Rule ID 22128 //
     /*  811662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  811679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  811711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811730 */     GIR_RootConstrainSelectedInstOperands,
     /*  811731 */     // GIR_Coverage, 22128,
     /*  811731 */     GIR_EraseRootFromParent_Done,
     /*  811732 */   // Label 12561: @811732
     /*  811732 */   GIM_Try, /*On fail goto*//*Label 12562*/ GIMT_Encode4(811807), // Rule ID 22129 //
     /*  811737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  811754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11497:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  811786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811805 */     GIR_RootConstrainSelectedInstOperands,
     /*  811806 */     // GIR_Coverage, 22129,
     /*  811806 */     GIR_EraseRootFromParent_Done,
     /*  811807 */   // Label 12562: @811807
     /*  811807 */   GIM_Try, /*On fail goto*//*Label 12563*/ GIMT_Encode4(811882), // Rule ID 22132 //
     /*  811812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  811829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  811861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811880 */     GIR_RootConstrainSelectedInstOperands,
     /*  811881 */     // GIR_Coverage, 22132,
     /*  811881 */     GIR_EraseRootFromParent_Done,
     /*  811882 */   // Label 12563: @811882
     /*  811882 */   GIM_Try, /*On fail goto*//*Label 12564*/ GIMT_Encode4(811957), // Rule ID 22133 //
     /*  811887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  811904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  811936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811955 */     GIR_RootConstrainSelectedInstOperands,
     /*  811956 */     // GIR_Coverage, 22133,
     /*  811956 */     GIR_EraseRootFromParent_Done,
     /*  811957 */   // Label 12564: @811957
     /*  811957 */   GIM_Try, /*On fail goto*//*Label 12565*/ GIMT_Encode4(812032), // Rule ID 22136 //
     /*  811962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  811979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  812011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812030 */     GIR_RootConstrainSelectedInstOperands,
     /*  812031 */     // GIR_Coverage, 22136,
     /*  812031 */     GIR_EraseRootFromParent_Done,
     /*  812032 */   // Label 12565: @812032
     /*  812032 */   GIM_Try, /*On fail goto*//*Label 12566*/ GIMT_Encode4(812107), // Rule ID 22137 //
     /*  812037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  812054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812083 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  812086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812105 */     GIR_RootConstrainSelectedInstOperands,
     /*  812106 */     // GIR_Coverage, 22137,
     /*  812106 */     GIR_EraseRootFromParent_Done,
     /*  812107 */   // Label 12566: @812107
     /*  812107 */   GIM_Try, /*On fail goto*//*Label 12567*/ GIMT_Encode4(812182), // Rule ID 22140 //
     /*  812112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  812158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  812161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812180 */     GIR_RootConstrainSelectedInstOperands,
     /*  812181 */     // GIR_Coverage, 22140,
     /*  812181 */     GIR_EraseRootFromParent_Done,
     /*  812182 */   // Label 12567: @812182
     /*  812182 */   GIM_Try, /*On fail goto*//*Label 12568*/ GIMT_Encode4(812257), // Rule ID 22141 //
     /*  812187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  812204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812233 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11497:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  812233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  812236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  812252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812255 */     GIR_RootConstrainSelectedInstOperands,
     /*  812256 */     // GIR_Coverage, 22141,
     /*  812256 */     GIR_EraseRootFromParent_Done,
     /*  812257 */   // Label 12568: @812257
     /*  812257 */   GIM_Try, /*On fail goto*//*Label 12569*/ GIMT_Encode4(812332), // Rule ID 22144 //
     /*  812262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  812311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812330 */     GIR_RootConstrainSelectedInstOperands,
     /*  812331 */     // GIR_Coverage, 22144,
     /*  812331 */     GIR_EraseRootFromParent_Done,
     /*  812332 */   // Label 12569: @812332
     /*  812332 */   GIM_Try, /*On fail goto*//*Label 12570*/ GIMT_Encode4(812407), // Rule ID 22145 //
     /*  812337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  812354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  812372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  812386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812405 */     GIR_RootConstrainSelectedInstOperands,
     /*  812406 */     // GIR_Coverage, 22145,
     /*  812406 */     GIR_EraseRootFromParent_Done,
     /*  812407 */   // Label 12570: @812407
     /*  812407 */   GIM_Try, /*On fail goto*//*Label 12571*/ GIMT_Encode4(812482), // Rule ID 22148 //
     /*  812412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  812461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812480 */     GIR_RootConstrainSelectedInstOperands,
     /*  812481 */     // GIR_Coverage, 22148,
     /*  812481 */     GIR_EraseRootFromParent_Done,
     /*  812482 */   // Label 12571: @812482
     /*  812482 */   GIM_Try, /*On fail goto*//*Label 12572*/ GIMT_Encode4(812557), // Rule ID 22149 //
     /*  812487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  812504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812533 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  812536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812555 */     GIR_RootConstrainSelectedInstOperands,
     /*  812556 */     // GIR_Coverage, 22149,
     /*  812556 */     GIR_EraseRootFromParent_Done,
     /*  812557 */   // Label 12572: @812557
     /*  812557 */   GIM_Try, /*On fail goto*//*Label 12573*/ GIMT_Encode4(812632), // Rule ID 22152 //
     /*  812562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  812579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812608 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  812611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812630 */     GIR_RootConstrainSelectedInstOperands,
     /*  812631 */     // GIR_Coverage, 22152,
     /*  812631 */     GIR_EraseRootFromParent_Done,
     /*  812632 */   // Label 12573: @812632
     /*  812632 */   GIM_Try, /*On fail goto*//*Label 12574*/ GIMT_Encode4(812707), // Rule ID 22153 //
     /*  812637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  812654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812683 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11497:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  812686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812705 */     GIR_RootConstrainSelectedInstOperands,
     /*  812706 */     // GIR_Coverage, 22153,
     /*  812706 */     GIR_EraseRootFromParent_Done,
     /*  812707 */   // Label 12574: @812707
     /*  812707 */   GIM_Try, /*On fail goto*//*Label 12575*/ GIMT_Encode4(812782), // Rule ID 22156 //
     /*  812712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  812729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  812758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  812761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812780 */     GIR_RootConstrainSelectedInstOperands,
     /*  812781 */     // GIR_Coverage, 22156,
     /*  812781 */     GIR_EraseRootFromParent_Done,
     /*  812782 */   // Label 12575: @812782
     /*  812782 */   GIM_Try, /*On fail goto*//*Label 12576*/ GIMT_Encode4(812857), // Rule ID 22157 //
     /*  812787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  812804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812833 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  812833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  812836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812855 */     GIR_RootConstrainSelectedInstOperands,
     /*  812856 */     // GIR_Coverage, 22157,
     /*  812856 */     GIR_EraseRootFromParent_Done,
     /*  812857 */   // Label 12576: @812857
     /*  812857 */   GIM_Try, /*On fail goto*//*Label 12577*/ GIMT_Encode4(812932), // Rule ID 22160 //
     /*  812862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  812879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812908 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  812908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  812911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812930 */     GIR_RootConstrainSelectedInstOperands,
     /*  812931 */     // GIR_Coverage, 22160,
     /*  812931 */     GIR_EraseRootFromParent_Done,
     /*  812932 */   // Label 12577: @812932
     /*  812932 */   GIM_Try, /*On fail goto*//*Label 12578*/ GIMT_Encode4(813007), // Rule ID 22161 //
     /*  812937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  812954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812983 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  812983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  812986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813005 */     GIR_RootConstrainSelectedInstOperands,
     /*  813006 */     // GIR_Coverage, 22161,
     /*  813006 */     GIR_EraseRootFromParent_Done,
     /*  813007 */   // Label 12578: @813007
     /*  813007 */   GIM_Try, /*On fail goto*//*Label 12579*/ GIMT_Encode4(813082), // Rule ID 22164 //
     /*  813012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  813061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813080 */     GIR_RootConstrainSelectedInstOperands,
     /*  813081 */     // GIR_Coverage, 22164,
     /*  813081 */     GIR_EraseRootFromParent_Done,
     /*  813082 */   // Label 12579: @813082
     /*  813082 */   GIM_Try, /*On fail goto*//*Label 12580*/ GIMT_Encode4(813157), // Rule ID 22165 //
     /*  813087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  813104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813133 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  813136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813155 */     GIR_RootConstrainSelectedInstOperands,
     /*  813156 */     // GIR_Coverage, 22165,
     /*  813156 */     GIR_EraseRootFromParent_Done,
     /*  813157 */   // Label 12580: @813157
     /*  813157 */   GIM_Try, /*On fail goto*//*Label 12581*/ GIMT_Encode4(813232), // Rule ID 22168 //
     /*  813162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  813211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813230 */     GIR_RootConstrainSelectedInstOperands,
     /*  813231 */     // GIR_Coverage, 22168,
     /*  813231 */     GIR_EraseRootFromParent_Done,
     /*  813232 */   // Label 12581: @813232
     /*  813232 */   GIM_Try, /*On fail goto*//*Label 12582*/ GIMT_Encode4(813307), // Rule ID 22169 //
     /*  813237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  813254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  813286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813305 */     GIR_RootConstrainSelectedInstOperands,
     /*  813306 */     // GIR_Coverage, 22169,
     /*  813306 */     GIR_EraseRootFromParent_Done,
     /*  813307 */   // Label 12582: @813307
     /*  813307 */   GIM_Try, /*On fail goto*//*Label 12583*/ GIMT_Encode4(813382), // Rule ID 22172 //
     /*  813312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813358 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  813361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813380 */     GIR_RootConstrainSelectedInstOperands,
     /*  813381 */     // GIR_Coverage, 22172,
     /*  813381 */     GIR_EraseRootFromParent_Done,
     /*  813382 */   // Label 12583: @813382
     /*  813382 */   GIM_Try, /*On fail goto*//*Label 12584*/ GIMT_Encode4(813457), // Rule ID 22173 //
     /*  813387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  813404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813433 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  813436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813455 */     GIR_RootConstrainSelectedInstOperands,
     /*  813456 */     // GIR_Coverage, 22173,
     /*  813456 */     GIR_EraseRootFromParent_Done,
     /*  813457 */   // Label 12584: @813457
     /*  813457 */   GIM_Try, /*On fail goto*//*Label 12585*/ GIMT_Encode4(813532), // Rule ID 22176 //
     /*  813462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  813479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  813508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  813511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813530 */     GIR_RootConstrainSelectedInstOperands,
     /*  813531 */     // GIR_Coverage, 22176,
     /*  813531 */     GIR_EraseRootFromParent_Done,
     /*  813532 */   // Label 12585: @813532
     /*  813532 */   GIM_Try, /*On fail goto*//*Label 12586*/ GIMT_Encode4(813607), // Rule ID 22177 //
     /*  813537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  813554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813583 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  813583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  813586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813605 */     GIR_RootConstrainSelectedInstOperands,
     /*  813606 */     // GIR_Coverage, 22177,
     /*  813606 */     GIR_EraseRootFromParent_Done,
     /*  813607 */   // Label 12586: @813607
     /*  813607 */   GIM_Try, /*On fail goto*//*Label 12587*/ GIMT_Encode4(813682), // Rule ID 22180 //
     /*  813612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  813629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  813661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813680 */     GIR_RootConstrainSelectedInstOperands,
     /*  813681 */     // GIR_Coverage, 22180,
     /*  813681 */     GIR_EraseRootFromParent_Done,
     /*  813682 */   // Label 12587: @813682
     /*  813682 */   GIM_Try, /*On fail goto*//*Label 12588*/ GIMT_Encode4(813757), // Rule ID 22181 //
     /*  813687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  813704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813733 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  813736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813755 */     GIR_RootConstrainSelectedInstOperands,
     /*  813756 */     // GIR_Coverage, 22181,
     /*  813756 */     GIR_EraseRootFromParent_Done,
     /*  813757 */   // Label 12588: @813757
     /*  813757 */   GIM_Try, /*On fail goto*//*Label 12589*/ GIMT_Encode4(813832), // Rule ID 22184 //
     /*  813762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  813779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813808 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  813811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813830 */     GIR_RootConstrainSelectedInstOperands,
     /*  813831 */     // GIR_Coverage, 22184,
     /*  813831 */     GIR_EraseRootFromParent_Done,
     /*  813832 */   // Label 12589: @813832
     /*  813832 */   GIM_Try, /*On fail goto*//*Label 12590*/ GIMT_Encode4(813907), // Rule ID 22185 //
     /*  813837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  813854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813883 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  813886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813905 */     GIR_RootConstrainSelectedInstOperands,
     /*  813906 */     // GIR_Coverage, 22185,
     /*  813906 */     GIR_EraseRootFromParent_Done,
     /*  813907 */   // Label 12590: @813907
     /*  813907 */   GIM_Try, /*On fail goto*//*Label 12591*/ GIMT_Encode4(813982), // Rule ID 22188 //
     /*  813912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  813929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  813958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  813961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813980 */     GIR_RootConstrainSelectedInstOperands,
     /*  813981 */     // GIR_Coverage, 22188,
     /*  813981 */     GIR_EraseRootFromParent_Done,
     /*  813982 */   // Label 12591: @813982
     /*  813982 */   GIM_Try, /*On fail goto*//*Label 12592*/ GIMT_Encode4(814057), // Rule ID 22189 //
     /*  813987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  814004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814033 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  814036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814055 */     GIR_RootConstrainSelectedInstOperands,
     /*  814056 */     // GIR_Coverage, 22189,
     /*  814056 */     GIR_EraseRootFromParent_Done,
     /*  814057 */   // Label 12592: @814057
     /*  814057 */   GIM_Try, /*On fail goto*//*Label 12593*/ GIMT_Encode4(814132), // Rule ID 22192 //
     /*  814062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  814065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  814108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  814111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814130 */     GIR_RootConstrainSelectedInstOperands,
     /*  814131 */     // GIR_Coverage, 22192,
     /*  814131 */     GIR_EraseRootFromParent_Done,
     /*  814132 */   // Label 12593: @814132
     /*  814132 */   GIM_Try, /*On fail goto*//*Label 12594*/ GIMT_Encode4(814207), // Rule ID 22193 //
     /*  814137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  814140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  814148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  814151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  814154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  814157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814183 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  814183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  814186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  814202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814205 */     GIR_RootConstrainSelectedInstOperands,
     /*  814206 */     // GIR_Coverage, 22193,
     /*  814206 */     GIR_EraseRootFromParent_Done,
     /*  814207 */   // Label 12594: @814207
     /*  814207 */   GIM_Try, /*On fail goto*//*Label 12595*/ GIMT_Encode4(814282), // Rule ID 22196 //
     /*  814212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  814261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814280 */     GIR_RootConstrainSelectedInstOperands,
     /*  814281 */     // GIR_Coverage, 22196,
     /*  814281 */     GIR_EraseRootFromParent_Done,
     /*  814282 */   // Label 12595: @814282
     /*  814282 */   GIM_Try, /*On fail goto*//*Label 12596*/ GIMT_Encode4(814357), // Rule ID 22197 //
     /*  814287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  814304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814333 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  814336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814355 */     GIR_RootConstrainSelectedInstOperands,
     /*  814356 */     // GIR_Coverage, 22197,
     /*  814356 */     GIR_EraseRootFromParent_Done,
     /*  814357 */   // Label 12596: @814357
     /*  814357 */   GIM_Try, /*On fail goto*//*Label 12597*/ GIMT_Encode4(814432), // Rule ID 22200 //
     /*  814362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814408 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  814411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814430 */     GIR_RootConstrainSelectedInstOperands,
     /*  814431 */     // GIR_Coverage, 22200,
     /*  814431 */     GIR_EraseRootFromParent_Done,
     /*  814432 */   // Label 12597: @814432
     /*  814432 */   GIM_Try, /*On fail goto*//*Label 12598*/ GIMT_Encode4(814507), // Rule ID 22201 //
     /*  814437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  814454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814483 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  814486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814505 */     GIR_RootConstrainSelectedInstOperands,
     /*  814506 */     // GIR_Coverage, 22201,
     /*  814506 */     GIR_EraseRootFromParent_Done,
     /*  814507 */   // Label 12598: @814507
     /*  814507 */   GIM_Try, /*On fail goto*//*Label 12599*/ GIMT_Encode4(814582), // Rule ID 22204 //
     /*  814512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  814529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  814561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814580 */     GIR_RootConstrainSelectedInstOperands,
     /*  814581 */     // GIR_Coverage, 22204,
     /*  814581 */     GIR_EraseRootFromParent_Done,
     /*  814582 */   // Label 12599: @814582
     /*  814582 */   GIM_Try, /*On fail goto*//*Label 12600*/ GIMT_Encode4(814657), // Rule ID 22205 //
     /*  814587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  814604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814633 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11507:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  814636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814655 */     GIR_RootConstrainSelectedInstOperands,
     /*  814656 */     // GIR_Coverage, 22205,
     /*  814656 */     GIR_EraseRootFromParent_Done,
     /*  814657 */   // Label 12600: @814657
     /*  814657 */   GIM_Try, /*On fail goto*//*Label 12601*/ GIMT_Encode4(814732), // Rule ID 22208 //
     /*  814662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  814679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  814711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814730 */     GIR_RootConstrainSelectedInstOperands,
     /*  814731 */     // GIR_Coverage, 22208,
     /*  814731 */     GIR_EraseRootFromParent_Done,
     /*  814732 */   // Label 12601: @814732
     /*  814732 */   GIM_Try, /*On fail goto*//*Label 12602*/ GIMT_Encode4(814807), // Rule ID 22209 //
     /*  814737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  814754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  814786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814805 */     GIR_RootConstrainSelectedInstOperands,
     /*  814806 */     // GIR_Coverage, 22209,
     /*  814806 */     GIR_EraseRootFromParent_Done,
     /*  814807 */   // Label 12602: @814807
     /*  814807 */   GIM_Try, /*On fail goto*//*Label 12603*/ GIMT_Encode4(814882), // Rule ID 22212 //
     /*  814812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  814829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  814861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814880 */     GIR_RootConstrainSelectedInstOperands,
     /*  814881 */     // GIR_Coverage, 22212,
     /*  814881 */     GIR_EraseRootFromParent_Done,
     /*  814882 */   // Label 12603: @814882
     /*  814882 */   GIM_Try, /*On fail goto*//*Label 12604*/ GIMT_Encode4(814957), // Rule ID 22213 //
     /*  814887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  814904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814933 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  814936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814955 */     GIR_RootConstrainSelectedInstOperands,
     /*  814956 */     // GIR_Coverage, 22213,
     /*  814956 */     GIR_EraseRootFromParent_Done,
     /*  814957 */   // Label 12604: @814957
     /*  814957 */   GIM_Try, /*On fail goto*//*Label 12605*/ GIMT_Encode4(815032), // Rule ID 22216 //
     /*  814962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  814979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  815008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  815011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815030 */     GIR_RootConstrainSelectedInstOperands,
     /*  815031 */     // GIR_Coverage, 22216,
     /*  815031 */     GIR_EraseRootFromParent_Done,
     /*  815032 */   // Label 12605: @815032
     /*  815032 */   GIM_Try, /*On fail goto*//*Label 12606*/ GIMT_Encode4(815107), // Rule ID 22217 //
     /*  815037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  815054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815083 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11507:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  815083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  815086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  815102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815105 */     GIR_RootConstrainSelectedInstOperands,
     /*  815106 */     // GIR_Coverage, 22217,
     /*  815106 */     GIR_EraseRootFromParent_Done,
     /*  815107 */   // Label 12606: @815107
     /*  815107 */   GIM_Try, /*On fail goto*//*Label 12607*/ GIMT_Encode4(815182), // Rule ID 22220 //
     /*  815112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  815161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815180 */     GIR_RootConstrainSelectedInstOperands,
     /*  815181 */     // GIR_Coverage, 22220,
     /*  815181 */     GIR_EraseRootFromParent_Done,
     /*  815182 */   // Label 12607: @815182
     /*  815182 */   GIM_Try, /*On fail goto*//*Label 12608*/ GIMT_Encode4(815257), // Rule ID 22221 //
     /*  815187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  815204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815233 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  815236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815255 */     GIR_RootConstrainSelectedInstOperands,
     /*  815256 */     // GIR_Coverage, 22221,
     /*  815256 */     GIR_EraseRootFromParent_Done,
     /*  815257 */   // Label 12608: @815257
     /*  815257 */   GIM_Try, /*On fail goto*//*Label 12609*/ GIMT_Encode4(815332), // Rule ID 22224 //
     /*  815262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  815311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815330 */     GIR_RootConstrainSelectedInstOperands,
     /*  815331 */     // GIR_Coverage, 22224,
     /*  815331 */     GIR_EraseRootFromParent_Done,
     /*  815332 */   // Label 12609: @815332
     /*  815332 */   GIM_Try, /*On fail goto*//*Label 12610*/ GIMT_Encode4(815407), // Rule ID 22225 //
     /*  815337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  815354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815383 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  815386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815405 */     GIR_RootConstrainSelectedInstOperands,
     /*  815406 */     // GIR_Coverage, 22225,
     /*  815406 */     GIR_EraseRootFromParent_Done,
     /*  815407 */   // Label 12610: @815407
     /*  815407 */   GIM_Try, /*On fail goto*//*Label 12611*/ GIMT_Encode4(815482), // Rule ID 22228 //
     /*  815412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  815458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  815461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815480 */     GIR_RootConstrainSelectedInstOperands,
     /*  815481 */     // GIR_Coverage, 22228,
     /*  815481 */     GIR_EraseRootFromParent_Done,
     /*  815482 */   // Label 12611: @815482
     /*  815482 */   GIM_Try, /*On fail goto*//*Label 12612*/ GIMT_Encode4(815557), // Rule ID 22229 //
     /*  815487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  815498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  815501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  815504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  815507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815533 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11507:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  815536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815555 */     GIR_RootConstrainSelectedInstOperands,
     /*  815556 */     // GIR_Coverage, 22229,
     /*  815556 */     GIR_EraseRootFromParent_Done,
     /*  815557 */   // Label 12612: @815557
     /*  815557 */   GIM_Try, /*On fail goto*//*Label 12613*/ GIMT_Encode4(815632), // Rule ID 22232 //
     /*  815562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  815565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  815579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815608 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  815608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  815611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815630 */     GIR_RootConstrainSelectedInstOperands,
     /*  815631 */     // GIR_Coverage, 22232,
     /*  815631 */     GIR_EraseRootFromParent_Done,
     /*  815632 */   // Label 12613: @815632
     /*  815632 */   GIM_Try, /*On fail goto*//*Label 12614*/ GIMT_Encode4(815707), // Rule ID 22233 //
     /*  815637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  815640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  815654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815683 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  815683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  815686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815705 */     GIR_RootConstrainSelectedInstOperands,
     /*  815706 */     // GIR_Coverage, 22233,
     /*  815706 */     GIR_EraseRootFromParent_Done,
     /*  815707 */   // Label 12614: @815707
     /*  815707 */   GIM_Try, /*On fail goto*//*Label 12615*/ GIMT_Encode4(815782), // Rule ID 22236 //
     /*  815712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  815715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  815729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  815758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  815761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815780 */     GIR_RootConstrainSelectedInstOperands,
     /*  815781 */     // GIR_Coverage, 22236,
     /*  815781 */     GIR_EraseRootFromParent_Done,
     /*  815782 */   // Label 12615: @815782
     /*  815782 */   GIM_Try, /*On fail goto*//*Label 12616*/ GIMT_Encode4(815857), // Rule ID 22237 //
     /*  815787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  815790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  815804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815833 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  815833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  815836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815855 */     GIR_RootConstrainSelectedInstOperands,
     /*  815856 */     // GIR_Coverage, 22237,
     /*  815856 */     GIR_EraseRootFromParent_Done,
     /*  815857 */   // Label 12616: @815857
     /*  815857 */   GIM_Try, /*On fail goto*//*Label 12617*/ GIMT_Encode4(815932), // Rule ID 22240 //
     /*  815862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  815865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  815879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  815908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  815911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815930 */     GIR_RootConstrainSelectedInstOperands,
     /*  815931 */     // GIR_Coverage, 22240,
     /*  815931 */     GIR_EraseRootFromParent_Done,
     /*  815932 */   // Label 12617: @815932
     /*  815932 */   GIM_Try, /*On fail goto*//*Label 12618*/ GIMT_Encode4(816007), // Rule ID 22241 //
     /*  815937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  815940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  815954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815983 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11507:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  815983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  815986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816005 */     GIR_RootConstrainSelectedInstOperands,
     /*  816006 */     // GIR_Coverage, 22241,
     /*  816006 */     GIR_EraseRootFromParent_Done,
     /*  816007 */   // Label 12618: @816007
     /*  816007 */   GIM_Try, /*On fail goto*//*Label 12619*/ GIMT_Encode4(816082), // Rule ID 22244 //
     /*  816012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  816061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816080 */     GIR_RootConstrainSelectedInstOperands,
     /*  816081 */     // GIR_Coverage, 22244,
     /*  816081 */     GIR_EraseRootFromParent_Done,
     /*  816082 */   // Label 12619: @816082
     /*  816082 */   GIM_Try, /*On fail goto*//*Label 12620*/ GIMT_Encode4(816157), // Rule ID 22245 //
     /*  816087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  816104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816133 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  816136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816155 */     GIR_RootConstrainSelectedInstOperands,
     /*  816156 */     // GIR_Coverage, 22245,
     /*  816156 */     GIR_EraseRootFromParent_Done,
     /*  816157 */   // Label 12620: @816157
     /*  816157 */   GIM_Try, /*On fail goto*//*Label 12621*/ GIMT_Encode4(816232), // Rule ID 22248 //
     /*  816162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816208 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  816211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816230 */     GIR_RootConstrainSelectedInstOperands,
     /*  816231 */     // GIR_Coverage, 22248,
     /*  816231 */     GIR_EraseRootFromParent_Done,
     /*  816232 */   // Label 12621: @816232
     /*  816232 */   GIM_Try, /*On fail goto*//*Label 12622*/ GIMT_Encode4(816307), // Rule ID 22249 //
     /*  816237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  816254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816283 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  816286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816305 */     GIR_RootConstrainSelectedInstOperands,
     /*  816306 */     // GIR_Coverage, 22249,
     /*  816306 */     GIR_EraseRootFromParent_Done,
     /*  816307 */   // Label 12622: @816307
     /*  816307 */   GIM_Try, /*On fail goto*//*Label 12623*/ GIMT_Encode4(816382), // Rule ID 22252 //
     /*  816312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  816361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816380 */     GIR_RootConstrainSelectedInstOperands,
     /*  816381 */     // GIR_Coverage, 22252,
     /*  816381 */     GIR_EraseRootFromParent_Done,
     /*  816382 */   // Label 12623: @816382
     /*  816382 */   GIM_Try, /*On fail goto*//*Label 12624*/ GIMT_Encode4(816457), // Rule ID 22253 //
     /*  816387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  816404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816433 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  816436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816455 */     GIR_RootConstrainSelectedInstOperands,
     /*  816456 */     // GIR_Coverage, 22253,
     /*  816456 */     GIR_EraseRootFromParent_Done,
     /*  816457 */   // Label 12624: @816457
     /*  816457 */   GIM_Try, /*On fail goto*//*Label 12625*/ GIMT_Encode4(816532), // Rule ID 22256 //
     /*  816462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  816479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  816508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  816511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816530 */     GIR_RootConstrainSelectedInstOperands,
     /*  816531 */     // GIR_Coverage, 22256,
     /*  816531 */     GIR_EraseRootFromParent_Done,
     /*  816532 */   // Label 12625: @816532
     /*  816532 */   GIM_Try, /*On fail goto*//*Label 12626*/ GIMT_Encode4(816607), // Rule ID 22257 //
     /*  816537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  816554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816583 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  816583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  816586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816605 */     GIR_RootConstrainSelectedInstOperands,
     /*  816606 */     // GIR_Coverage, 22257,
     /*  816606 */     GIR_EraseRootFromParent_Done,
     /*  816607 */   // Label 12626: @816607
     /*  816607 */   GIM_Try, /*On fail goto*//*Label 12627*/ GIMT_Encode4(816682), // Rule ID 22260 //
     /*  816612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  816629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816658 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  816658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  816661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816680 */     GIR_RootConstrainSelectedInstOperands,
     /*  816681 */     // GIR_Coverage, 22260,
     /*  816681 */     GIR_EraseRootFromParent_Done,
     /*  816682 */   // Label 12627: @816682
     /*  816682 */   GIM_Try, /*On fail goto*//*Label 12628*/ GIMT_Encode4(816757), // Rule ID 22261 //
     /*  816687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  816704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816733 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  816733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  816736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816755 */     GIR_RootConstrainSelectedInstOperands,
     /*  816756 */     // GIR_Coverage, 22261,
     /*  816756 */     GIR_EraseRootFromParent_Done,
     /*  816757 */   // Label 12628: @816757
     /*  816757 */   GIM_Try, /*On fail goto*//*Label 12629*/ GIMT_Encode4(816832), // Rule ID 22264 //
     /*  816762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  816779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  816808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  816811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816830 */     GIR_RootConstrainSelectedInstOperands,
     /*  816831 */     // GIR_Coverage, 22264,
     /*  816831 */     GIR_EraseRootFromParent_Done,
     /*  816832 */   // Label 12629: @816832
     /*  816832 */   GIM_Try, /*On fail goto*//*Label 12630*/ GIMT_Encode4(816907), // Rule ID 22265 //
     /*  816837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  816854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816883 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  816883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  816886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816905 */     GIR_RootConstrainSelectedInstOperands,
     /*  816906 */     // GIR_Coverage, 22265,
     /*  816906 */     GIR_EraseRootFromParent_Done,
     /*  816907 */   // Label 12630: @816907
     /*  816907 */   GIM_Try, /*On fail goto*//*Label 12631*/ GIMT_Encode4(816982), // Rule ID 22268 //
     /*  816912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  816929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  816961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816980 */     GIR_RootConstrainSelectedInstOperands,
     /*  816981 */     // GIR_Coverage, 22268,
     /*  816981 */     GIR_EraseRootFromParent_Done,
     /*  816982 */   // Label 12631: @816982
     /*  816982 */   GIM_Try, /*On fail goto*//*Label 12632*/ GIMT_Encode4(817057), // Rule ID 22269 //
     /*  816987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  817004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817033 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  817036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817055 */     GIR_RootConstrainSelectedInstOperands,
     /*  817056 */     // GIR_Coverage, 22269,
     /*  817056 */     GIR_EraseRootFromParent_Done,
     /*  817057 */   // Label 12632: @817057
     /*  817057 */   GIM_Try, /*On fail goto*//*Label 12633*/ GIMT_Encode4(817132), // Rule ID 22272 //
     /*  817062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  817111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817130 */     GIR_RootConstrainSelectedInstOperands,
     /*  817131 */     // GIR_Coverage, 22272,
     /*  817131 */     GIR_EraseRootFromParent_Done,
     /*  817132 */   // Label 12633: @817132
     /*  817132 */   GIM_Try, /*On fail goto*//*Label 12634*/ GIMT_Encode4(817207), // Rule ID 22273 //
     /*  817137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  817154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817183 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  817186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817205 */     GIR_RootConstrainSelectedInstOperands,
     /*  817206 */     // GIR_Coverage, 22273,
     /*  817206 */     GIR_EraseRootFromParent_Done,
     /*  817207 */   // Label 12634: @817207
     /*  817207 */   GIM_Try, /*On fail goto*//*Label 12635*/ GIMT_Encode4(817282), // Rule ID 22276 //
     /*  817212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  817261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817280 */     GIR_RootConstrainSelectedInstOperands,
     /*  817281 */     // GIR_Coverage, 22276,
     /*  817281 */     GIR_EraseRootFromParent_Done,
     /*  817282 */   // Label 12635: @817282
     /*  817282 */   GIM_Try, /*On fail goto*//*Label 12636*/ GIMT_Encode4(817357), // Rule ID 22277 //
     /*  817287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  817304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817333 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  817333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  817336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817355 */     GIR_RootConstrainSelectedInstOperands,
     /*  817356 */     // GIR_Coverage, 22277,
     /*  817356 */     GIR_EraseRootFromParent_Done,
     /*  817357 */   // Label 12636: @817357
     /*  817357 */   GIM_Try, /*On fail goto*//*Label 12637*/ GIMT_Encode4(817432), // Rule ID 22280 //
     /*  817362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  817365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  817408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  817411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817430 */     GIR_RootConstrainSelectedInstOperands,
     /*  817431 */     // GIR_Coverage, 22280,
     /*  817431 */     GIR_EraseRootFromParent_Done,
     /*  817432 */   // Label 12637: @817432
     /*  817432 */   GIM_Try, /*On fail goto*//*Label 12638*/ GIMT_Encode4(817507), // Rule ID 22281 //
     /*  817437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  817440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  817448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  817451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  817454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  817457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817483 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  817483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  817486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  817502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817505 */     GIR_RootConstrainSelectedInstOperands,
     /*  817506 */     // GIR_Coverage, 22281,
     /*  817506 */     GIR_EraseRootFromParent_Done,
     /*  817507 */   // Label 12638: @817507
     /*  817507 */   GIM_Try, /*On fail goto*//*Label 12639*/ GIMT_Encode4(817582), // Rule ID 22284 //
     /*  817512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  817529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  817561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817580 */     GIR_RootConstrainSelectedInstOperands,
     /*  817581 */     // GIR_Coverage, 22284,
     /*  817581 */     GIR_EraseRootFromParent_Done,
     /*  817582 */   // Label 12639: @817582
     /*  817582 */   GIM_Try, /*On fail goto*//*Label 12640*/ GIMT_Encode4(817657), // Rule ID 22285 //
     /*  817587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  817604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817633 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  817636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817655 */     GIR_RootConstrainSelectedInstOperands,
     /*  817656 */     // GIR_Coverage, 22285,
     /*  817656 */     GIR_EraseRootFromParent_Done,
     /*  817657 */   // Label 12640: @817657
     /*  817657 */   GIM_Try, /*On fail goto*//*Label 12641*/ GIMT_Encode4(817732), // Rule ID 22288 //
     /*  817662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  817679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817708 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  817711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817730 */     GIR_RootConstrainSelectedInstOperands,
     /*  817731 */     // GIR_Coverage, 22288,
     /*  817731 */     GIR_EraseRootFromParent_Done,
     /*  817732 */   // Label 12641: @817732
     /*  817732 */   GIM_Try, /*On fail goto*//*Label 12642*/ GIMT_Encode4(817807), // Rule ID 22289 //
     /*  817737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  817754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817783 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  817786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817805 */     GIR_RootConstrainSelectedInstOperands,
     /*  817806 */     // GIR_Coverage, 22289,
     /*  817806 */     GIR_EraseRootFromParent_Done,
     /*  817807 */   // Label 12642: @817807
     /*  817807 */   GIM_Try, /*On fail goto*//*Label 12643*/ GIMT_Encode4(817882), // Rule ID 22292 //
     /*  817812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  817829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817858 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  817861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817880 */     GIR_RootConstrainSelectedInstOperands,
     /*  817881 */     // GIR_Coverage, 22292,
     /*  817881 */     GIR_EraseRootFromParent_Done,
     /*  817882 */   // Label 12643: @817882
     /*  817882 */   GIM_Try, /*On fail goto*//*Label 12644*/ GIMT_Encode4(817957), // Rule ID 22293 //
     /*  817887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  817904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817933 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  817936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817955 */     GIR_RootConstrainSelectedInstOperands,
     /*  817956 */     // GIR_Coverage, 22293,
     /*  817956 */     GIR_EraseRootFromParent_Done,
     /*  817957 */   // Label 12644: @817957
     /*  817957 */   GIM_Try, /*On fail goto*//*Label 12645*/ GIMT_Encode4(818032), // Rule ID 22296 //
     /*  817962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  817979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  818011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818030 */     GIR_RootConstrainSelectedInstOperands,
     /*  818031 */     // GIR_Coverage, 22296,
     /*  818031 */     GIR_EraseRootFromParent_Done,
     /*  818032 */   // Label 12645: @818032
     /*  818032 */   GIM_Try, /*On fail goto*//*Label 12646*/ GIMT_Encode4(818107), // Rule ID 22297 //
     /*  818037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  818054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818083 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  818086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818105 */     GIR_RootConstrainSelectedInstOperands,
     /*  818106 */     // GIR_Coverage, 22297,
     /*  818106 */     GIR_EraseRootFromParent_Done,
     /*  818107 */   // Label 12646: @818107
     /*  818107 */   GIM_Try, /*On fail goto*//*Label 12647*/ GIMT_Encode4(818182), // Rule ID 22300 //
     /*  818112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  818161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818180 */     GIR_RootConstrainSelectedInstOperands,
     /*  818181 */     // GIR_Coverage, 22300,
     /*  818181 */     GIR_EraseRootFromParent_Done,
     /*  818182 */   // Label 12647: @818182
     /*  818182 */   GIM_Try, /*On fail goto*//*Label 12648*/ GIMT_Encode4(818257), // Rule ID 22301 //
     /*  818187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  818204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818233 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  818236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818255 */     GIR_RootConstrainSelectedInstOperands,
     /*  818256 */     // GIR_Coverage, 22301,
     /*  818256 */     GIR_EraseRootFromParent_Done,
     /*  818257 */   // Label 12648: @818257
     /*  818257 */   GIM_Try, /*On fail goto*//*Label 12649*/ GIMT_Encode4(818332), // Rule ID 22304 //
     /*  818262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  818308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  818311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818330 */     GIR_RootConstrainSelectedInstOperands,
     /*  818331 */     // GIR_Coverage, 22304,
     /*  818331 */     GIR_EraseRootFromParent_Done,
     /*  818332 */   // Label 12649: @818332
     /*  818332 */   GIM_Try, /*On fail goto*//*Label 12650*/ GIMT_Encode4(818407), // Rule ID 22305 //
     /*  818337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  818348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  818351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  818354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  818357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818383 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  818383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  818386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  818402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818405 */     GIR_RootConstrainSelectedInstOperands,
     /*  818406 */     // GIR_Coverage, 22305,
     /*  818406 */     GIR_EraseRootFromParent_Done,
     /*  818407 */   // Label 12650: @818407
     /*  818407 */   GIM_Try, /*On fail goto*//*Label 12651*/ GIMT_Encode4(818482), // Rule ID 22308 //
     /*  818412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  818461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818480 */     GIR_RootConstrainSelectedInstOperands,
     /*  818481 */     // GIR_Coverage, 22308,
     /*  818481 */     GIR_EraseRootFromParent_Done,
     /*  818482 */   // Label 12651: @818482
     /*  818482 */   GIM_Try, /*On fail goto*//*Label 12652*/ GIMT_Encode4(818557), // Rule ID 22309 //
     /*  818487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  818504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818533 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  818536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818555 */     GIR_RootConstrainSelectedInstOperands,
     /*  818556 */     // GIR_Coverage, 22309,
     /*  818556 */     GIR_EraseRootFromParent_Done,
     /*  818557 */   // Label 12652: @818557
     /*  818557 */   GIM_Try, /*On fail goto*//*Label 12653*/ GIMT_Encode4(818632), // Rule ID 22312 //
     /*  818562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  818579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  818611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818630 */     GIR_RootConstrainSelectedInstOperands,
     /*  818631 */     // GIR_Coverage, 22312,
     /*  818631 */     GIR_EraseRootFromParent_Done,
     /*  818632 */   // Label 12653: @818632
     /*  818632 */   GIM_Try, /*On fail goto*//*Label 12654*/ GIMT_Encode4(818707), // Rule ID 22313 //
     /*  818637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  818654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818683 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  818686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818705 */     GIR_RootConstrainSelectedInstOperands,
     /*  818706 */     // GIR_Coverage, 22313,
     /*  818706 */     GIR_EraseRootFromParent_Done,
     /*  818707 */   // Label 12654: @818707
     /*  818707 */   GIM_Try, /*On fail goto*//*Label 12655*/ GIMT_Encode4(818782), // Rule ID 22316 //
     /*  818712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  818729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  818761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818780 */     GIR_RootConstrainSelectedInstOperands,
     /*  818781 */     // GIR_Coverage, 22316,
     /*  818781 */     GIR_EraseRootFromParent_Done,
     /*  818782 */   // Label 12655: @818782
     /*  818782 */   GIM_Try, /*On fail goto*//*Label 12656*/ GIMT_Encode4(818857), // Rule ID 22317 //
     /*  818787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  818804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818833 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  818836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818855 */     GIR_RootConstrainSelectedInstOperands,
     /*  818856 */     // GIR_Coverage, 22317,
     /*  818856 */     GIR_EraseRootFromParent_Done,
     /*  818857 */   // Label 12656: @818857
     /*  818857 */   GIM_Try, /*On fail goto*//*Label 12657*/ GIMT_Encode4(818932), // Rule ID 22320 //
     /*  818862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  818865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  818879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  818908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  818911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818930 */     GIR_RootConstrainSelectedInstOperands,
     /*  818931 */     // GIR_Coverage, 22320,
     /*  818931 */     GIR_EraseRootFromParent_Done,
     /*  818932 */   // Label 12657: @818932
     /*  818932 */   GIM_Try, /*On fail goto*//*Label 12658*/ GIMT_Encode4(819007), // Rule ID 22321 //
     /*  818937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  818940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  818954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818983 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  818983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  818986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819005 */     GIR_RootConstrainSelectedInstOperands,
     /*  819006 */     // GIR_Coverage, 22321,
     /*  819006 */     GIR_EraseRootFromParent_Done,
     /*  819007 */   // Label 12658: @819007
     /*  819007 */   GIM_Try, /*On fail goto*//*Label 12659*/ GIMT_Encode4(819082), // Rule ID 22324 //
     /*  819012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  819061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819080 */     GIR_RootConstrainSelectedInstOperands,
     /*  819081 */     // GIR_Coverage, 22324,
     /*  819081 */     GIR_EraseRootFromParent_Done,
     /*  819082 */   // Label 12659: @819082
     /*  819082 */   GIM_Try, /*On fail goto*//*Label 12660*/ GIMT_Encode4(819157), // Rule ID 22325 //
     /*  819087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  819104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  819122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819133 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  819136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819155 */     GIR_RootConstrainSelectedInstOperands,
     /*  819156 */     // GIR_Coverage, 22325,
     /*  819156 */     GIR_EraseRootFromParent_Done,
     /*  819157 */   // Label 12660: @819157
     /*  819157 */   GIM_Try, /*On fail goto*//*Label 12661*/ GIMT_Encode4(819232), // Rule ID 22328 //
     /*  819162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  819165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819208 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  819208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  819211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819230 */     GIR_RootConstrainSelectedInstOperands,
     /*  819231 */     // GIR_Coverage, 22328,
     /*  819231 */     GIR_EraseRootFromParent_Done,
     /*  819232 */   // Label 12661: @819232
     /*  819232 */   GIM_Try, /*On fail goto*//*Label 12662*/ GIMT_Encode4(819307), // Rule ID 22329 //
     /*  819237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  819240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  819245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  819248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  819251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  819254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  819257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  819272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819283 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  819283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  819286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  819302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819305 */     GIR_RootConstrainSelectedInstOperands,
     /*  819306 */     // GIR_Coverage, 22329,
     /*  819306 */     GIR_EraseRootFromParent_Done,
     /*  819307 */   // Label 12662: @819307
     /*  819307 */   GIM_Try, /*On fail goto*//*Label 12663*/ GIMT_Encode4(819382), // Rule ID 22332 //
     /*  819312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  819361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819380 */     GIR_RootConstrainSelectedInstOperands,
     /*  819381 */     // GIR_Coverage, 22332,
     /*  819381 */     GIR_EraseRootFromParent_Done,
     /*  819382 */   // Label 12663: @819382
     /*  819382 */   GIM_Try, /*On fail goto*//*Label 12664*/ GIMT_Encode4(819457), // Rule ID 22333 //
     /*  819387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  819404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819433 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  819436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819455 */     GIR_RootConstrainSelectedInstOperands,
     /*  819456 */     // GIR_Coverage, 22333,
     /*  819456 */     GIR_EraseRootFromParent_Done,
     /*  819457 */   // Label 12664: @819457
     /*  819457 */   GIM_Try, /*On fail goto*//*Label 12665*/ GIMT_Encode4(819532), // Rule ID 22336 //
     /*  819462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  819479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819508 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  819511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819530 */     GIR_RootConstrainSelectedInstOperands,
     /*  819531 */     // GIR_Coverage, 22336,
     /*  819531 */     GIR_EraseRootFromParent_Done,
     /*  819532 */   // Label 12665: @819532
     /*  819532 */   GIM_Try, /*On fail goto*//*Label 12666*/ GIMT_Encode4(819607), // Rule ID 22337 //
     /*  819537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  819554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819583 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  819586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819605 */     GIR_RootConstrainSelectedInstOperands,
     /*  819606 */     // GIR_Coverage, 22337,
     /*  819606 */     GIR_EraseRootFromParent_Done,
     /*  819607 */   // Label 12666: @819607
     /*  819607 */   GIM_Try, /*On fail goto*//*Label 12667*/ GIMT_Encode4(819682), // Rule ID 22340 //
     /*  819612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  819629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  819661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819680 */     GIR_RootConstrainSelectedInstOperands,
     /*  819681 */     // GIR_Coverage, 22340,
     /*  819681 */     GIR_EraseRootFromParent_Done,
     /*  819682 */   // Label 12667: @819682
     /*  819682 */   GIM_Try, /*On fail goto*//*Label 12668*/ GIMT_Encode4(819757), // Rule ID 22341 //
     /*  819687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  819704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819733 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  819736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819755 */     GIR_RootConstrainSelectedInstOperands,
     /*  819756 */     // GIR_Coverage, 22341,
     /*  819756 */     GIR_EraseRootFromParent_Done,
     /*  819757 */   // Label 12668: @819757
     /*  819757 */   GIM_Try, /*On fail goto*//*Label 12669*/ GIMT_Encode4(819832), // Rule ID 22344 //
     /*  819762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  819779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819808 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  819808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  819811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819830 */     GIR_RootConstrainSelectedInstOperands,
     /*  819831 */     // GIR_Coverage, 22344,
     /*  819831 */     GIR_EraseRootFromParent_Done,
     /*  819832 */   // Label 12669: @819832
     /*  819832 */   GIM_Try, /*On fail goto*//*Label 12670*/ GIMT_Encode4(819907), // Rule ID 22345 //
     /*  819837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  819854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819883 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  819883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  819886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819905 */     GIR_RootConstrainSelectedInstOperands,
     /*  819906 */     // GIR_Coverage, 22345,
     /*  819906 */     GIR_EraseRootFromParent_Done,
     /*  819907 */   // Label 12670: @819907
     /*  819907 */   GIM_Try, /*On fail goto*//*Label 12671*/ GIMT_Encode4(819982), // Rule ID 22348 //
     /*  819912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  819929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819958 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  819958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  819961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819980 */     GIR_RootConstrainSelectedInstOperands,
     /*  819981 */     // GIR_Coverage, 22348,
     /*  819981 */     GIR_EraseRootFromParent_Done,
     /*  819982 */   // Label 12671: @819982
     /*  819982 */   GIM_Try, /*On fail goto*//*Label 12672*/ GIMT_Encode4(820057), // Rule ID 22349 //
     /*  819987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  820004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820033 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  820036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820055 */     GIR_RootConstrainSelectedInstOperands,
     /*  820056 */     // GIR_Coverage, 22349,
     /*  820056 */     GIR_EraseRootFromParent_Done,
     /*  820057 */   // Label 12672: @820057
     /*  820057 */   GIM_Try, /*On fail goto*//*Label 12673*/ GIMT_Encode4(820132), // Rule ID 22352 //
     /*  820062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  820108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  820111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820130 */     GIR_RootConstrainSelectedInstOperands,
     /*  820131 */     // GIR_Coverage, 22352,
     /*  820131 */     GIR_EraseRootFromParent_Done,
     /*  820132 */   // Label 12673: @820132
     /*  820132 */   GIM_Try, /*On fail goto*//*Label 12674*/ GIMT_Encode4(820207), // Rule ID 22353 //
     /*  820137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  820154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820183 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  820183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  820186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820205 */     GIR_RootConstrainSelectedInstOperands,
     /*  820206 */     // GIR_Coverage, 22353,
     /*  820206 */     GIR_EraseRootFromParent_Done,
     /*  820207 */   // Label 12674: @820207
     /*  820207 */   GIM_Try, /*On fail goto*//*Label 12675*/ GIMT_Encode4(820282), // Rule ID 22356 //
     /*  820212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  820261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820280 */     GIR_RootConstrainSelectedInstOperands,
     /*  820281 */     // GIR_Coverage, 22356,
     /*  820281 */     GIR_EraseRootFromParent_Done,
     /*  820282 */   // Label 12675: @820282
     /*  820282 */   GIM_Try, /*On fail goto*//*Label 12676*/ GIMT_Encode4(820357), // Rule ID 22357 //
     /*  820287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  820304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820333 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  820336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820355 */     GIR_RootConstrainSelectedInstOperands,
     /*  820356 */     // GIR_Coverage, 22357,
     /*  820356 */     GIR_EraseRootFromParent_Done,
     /*  820357 */   // Label 12676: @820357
     /*  820357 */   GIM_Try, /*On fail goto*//*Label 12677*/ GIMT_Encode4(820432), // Rule ID 22360 //
     /*  820362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  820411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820430 */     GIR_RootConstrainSelectedInstOperands,
     /*  820431 */     // GIR_Coverage, 22360,
     /*  820431 */     GIR_EraseRootFromParent_Done,
     /*  820432 */   // Label 12677: @820432
     /*  820432 */   GIM_Try, /*On fail goto*//*Label 12678*/ GIMT_Encode4(820507), // Rule ID 22361 //
     /*  820437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  820454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  820486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820505 */     GIR_RootConstrainSelectedInstOperands,
     /*  820506 */     // GIR_Coverage, 22361,
     /*  820506 */     GIR_EraseRootFromParent_Done,
     /*  820507 */   // Label 12678: @820507
     /*  820507 */   GIM_Try, /*On fail goto*//*Label 12679*/ GIMT_Encode4(820582), // Rule ID 22364 //
     /*  820512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  820529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  820558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  820561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820580 */     GIR_RootConstrainSelectedInstOperands,
     /*  820581 */     // GIR_Coverage, 22364,
     /*  820581 */     GIR_EraseRootFromParent_Done,
     /*  820582 */   // Label 12679: @820582
     /*  820582 */   GIM_Try, /*On fail goto*//*Label 12680*/ GIMT_Encode4(820657), // Rule ID 22365 //
     /*  820587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  820604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  820633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  820636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820655 */     GIR_RootConstrainSelectedInstOperands,
     /*  820656 */     // GIR_Coverage, 22365,
     /*  820656 */     GIR_EraseRootFromParent_Done,
     /*  820657 */   // Label 12680: @820657
     /*  820657 */   GIM_Try, /*On fail goto*//*Label 12681*/ GIMT_Encode4(820732), // Rule ID 22368 //
     /*  820662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  820665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  820673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  820676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  820679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  820682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  820708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  820711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  820727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820730 */     GIR_RootConstrainSelectedInstOperands,
     /*  820731 */     // GIR_Coverage, 22368,
     /*  820731 */     GIR_EraseRootFromParent_Done,
     /*  820732 */   // Label 12681: @820732
     /*  820732 */   GIM_Try, /*On fail goto*//*Label 12682*/ GIMT_Encode4(820807), // Rule ID 22369 //
     /*  820737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  820740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  820748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  820751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  820754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  820757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820783 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  820783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  820786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  820802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820805 */     GIR_RootConstrainSelectedInstOperands,
     /*  820806 */     // GIR_Coverage, 22369,
     /*  820806 */     GIR_EraseRootFromParent_Done,
     /*  820807 */   // Label 12682: @820807
     /*  820807 */   GIM_Try, /*On fail goto*//*Label 12683*/ GIMT_Encode4(820882), // Rule ID 22372 //
     /*  820812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  820829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  820847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820858 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  820861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820880 */     GIR_RootConstrainSelectedInstOperands,
     /*  820881 */     // GIR_Coverage, 22372,
     /*  820881 */     GIR_EraseRootFromParent_Done,
     /*  820882 */   // Label 12683: @820882
     /*  820882 */   GIM_Try, /*On fail goto*//*Label 12684*/ GIMT_Encode4(820957), // Rule ID 22373 //
     /*  820887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  820904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  820922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820933 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  820936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820955 */     GIR_RootConstrainSelectedInstOperands,
     /*  820956 */     // GIR_Coverage, 22373,
     /*  820956 */     GIR_EraseRootFromParent_Done,
     /*  820957 */   // Label 12684: @820957
     /*  820957 */   GIM_Try, /*On fail goto*//*Label 12685*/ GIMT_Encode4(821032), // Rule ID 22376 //
     /*  820962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  820979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  820997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  821011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821030 */     GIR_RootConstrainSelectedInstOperands,
     /*  821031 */     // GIR_Coverage, 22376,
     /*  821031 */     GIR_EraseRootFromParent_Done,
     /*  821032 */   // Label 12685: @821032
     /*  821032 */   GIM_Try, /*On fail goto*//*Label 12686*/ GIMT_Encode4(821107), // Rule ID 22377 //
     /*  821037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  821054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821083 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  821086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821105 */     GIR_RootConstrainSelectedInstOperands,
     /*  821106 */     // GIR_Coverage, 22377,
     /*  821106 */     GIR_EraseRootFromParent_Done,
     /*  821107 */   // Label 12686: @821107
     /*  821107 */   GIM_Try, /*On fail goto*//*Label 12687*/ GIMT_Encode4(821182), // Rule ID 22380 //
     /*  821112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  821158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  821161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821180 */     GIR_RootConstrainSelectedInstOperands,
     /*  821181 */     // GIR_Coverage, 22380,
     /*  821181 */     GIR_EraseRootFromParent_Done,
     /*  821182 */   // Label 12687: @821182
     /*  821182 */   GIM_Try, /*On fail goto*//*Label 12688*/ GIMT_Encode4(821257), // Rule ID 22381 //
     /*  821187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  821198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  821201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  821204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  821207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821233 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11505:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  821233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  821236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  821252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821255 */     GIR_RootConstrainSelectedInstOperands,
     /*  821256 */     // GIR_Coverage, 22381,
     /*  821256 */     GIR_EraseRootFromParent_Done,
     /*  821257 */   // Label 12688: @821257
     /*  821257 */   GIM_Try, /*On fail goto*//*Label 12689*/ GIMT_Encode4(821332), // Rule ID 22384 //
     /*  821262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  821311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821330 */     GIR_RootConstrainSelectedInstOperands,
     /*  821331 */     // GIR_Coverage, 22384,
     /*  821331 */     GIR_EraseRootFromParent_Done,
     /*  821332 */   // Label 12689: @821332
     /*  821332 */   GIM_Try, /*On fail goto*//*Label 12690*/ GIMT_Encode4(821407), // Rule ID 22385 //
     /*  821337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  821354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821383 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  821386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821405 */     GIR_RootConstrainSelectedInstOperands,
     /*  821406 */     // GIR_Coverage, 22385,
     /*  821406 */     GIR_EraseRootFromParent_Done,
     /*  821407 */   // Label 12690: @821407
     /*  821407 */   GIM_Try, /*On fail goto*//*Label 12691*/ GIMT_Encode4(821482), // Rule ID 22388 //
     /*  821412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821458 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  821461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821480 */     GIR_RootConstrainSelectedInstOperands,
     /*  821481 */     // GIR_Coverage, 22388,
     /*  821481 */     GIR_EraseRootFromParent_Done,
     /*  821482 */   // Label 12691: @821482
     /*  821482 */   GIM_Try, /*On fail goto*//*Label 12692*/ GIMT_Encode4(821557), // Rule ID 22389 //
     /*  821487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  821504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821533 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  821536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821555 */     GIR_RootConstrainSelectedInstOperands,
     /*  821556 */     // GIR_Coverage, 22389,
     /*  821556 */     GIR_EraseRootFromParent_Done,
     /*  821557 */   // Label 12692: @821557
     /*  821557 */   GIM_Try, /*On fail goto*//*Label 12693*/ GIMT_Encode4(821632), // Rule ID 22392 //
     /*  821562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  821579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  821611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821630 */     GIR_RootConstrainSelectedInstOperands,
     /*  821631 */     // GIR_Coverage, 22392,
     /*  821631 */     GIR_EraseRootFromParent_Done,
     /*  821632 */   // Label 12693: @821632
     /*  821632 */   GIM_Try, /*On fail goto*//*Label 12694*/ GIMT_Encode4(821707), // Rule ID 22393 //
     /*  821637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  821654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11505:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  821686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821705 */     GIR_RootConstrainSelectedInstOperands,
     /*  821706 */     // GIR_Coverage, 22393,
     /*  821706 */     GIR_EraseRootFromParent_Done,
     /*  821707 */   // Label 12694: @821707
     /*  821707 */   GIM_Try, /*On fail goto*//*Label 12695*/ GIMT_Encode4(821782), // Rule ID 22396 //
     /*  821712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  821729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  821761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821780 */     GIR_RootConstrainSelectedInstOperands,
     /*  821781 */     // GIR_Coverage, 22396,
     /*  821781 */     GIR_EraseRootFromParent_Done,
     /*  821782 */   // Label 12695: @821782
     /*  821782 */   GIM_Try, /*On fail goto*//*Label 12696*/ GIMT_Encode4(821857), // Rule ID 22397 //
     /*  821787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  821804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821833 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  821836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821855 */     GIR_RootConstrainSelectedInstOperands,
     /*  821856 */     // GIR_Coverage, 22397,
     /*  821856 */     GIR_EraseRootFromParent_Done,
     /*  821857 */   // Label 12696: @821857
     /*  821857 */   GIM_Try, /*On fail goto*//*Label 12697*/ GIMT_Encode4(821932), // Rule ID 22400 //
     /*  821862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  821879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821908 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  821911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821930 */     GIR_RootConstrainSelectedInstOperands,
     /*  821931 */     // GIR_Coverage, 22400,
     /*  821931 */     GIR_EraseRootFromParent_Done,
     /*  821932 */   // Label 12697: @821932
     /*  821932 */   GIM_Try, /*On fail goto*//*Label 12698*/ GIMT_Encode4(822007), // Rule ID 22401 //
     /*  821937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  821954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821983 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  821986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822005 */     GIR_RootConstrainSelectedInstOperands,
     /*  822006 */     // GIR_Coverage, 22401,
     /*  822006 */     GIR_EraseRootFromParent_Done,
     /*  822007 */   // Label 12698: @822007
     /*  822007 */   GIM_Try, /*On fail goto*//*Label 12699*/ GIMT_Encode4(822082), // Rule ID 22404 //
     /*  822012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  822061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822080 */     GIR_RootConstrainSelectedInstOperands,
     /*  822081 */     // GIR_Coverage, 22404,
     /*  822081 */     GIR_EraseRootFromParent_Done,
     /*  822082 */   // Label 12699: @822082
     /*  822082 */   GIM_Try, /*On fail goto*//*Label 12700*/ GIMT_Encode4(822157), // Rule ID 22405 //
     /*  822087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  822104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822133 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11505:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  822136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822155 */     GIR_RootConstrainSelectedInstOperands,
     /*  822156 */     // GIR_Coverage, 22405,
     /*  822156 */     GIR_EraseRootFromParent_Done,
     /*  822157 */   // Label 12700: @822157
     /*  822157 */   GIM_Try, /*On fail goto*//*Label 12701*/ GIMT_Encode4(822232), // Rule ID 22408 //
     /*  822162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822208 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  822211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822230 */     GIR_RootConstrainSelectedInstOperands,
     /*  822231 */     // GIR_Coverage, 22408,
     /*  822231 */     GIR_EraseRootFromParent_Done,
     /*  822232 */   // Label 12701: @822232
     /*  822232 */   GIM_Try, /*On fail goto*//*Label 12702*/ GIMT_Encode4(822307), // Rule ID 22409 //
     /*  822237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  822254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  822272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822283 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  822286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822305 */     GIR_RootConstrainSelectedInstOperands,
     /*  822306 */     // GIR_Coverage, 22409,
     /*  822306 */     GIR_EraseRootFromParent_Done,
     /*  822307 */   // Label 12702: @822307
     /*  822307 */   GIM_Try, /*On fail goto*//*Label 12703*/ GIMT_Encode4(822382), // Rule ID 22412 //
     /*  822312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822358 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  822361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822380 */     GIR_RootConstrainSelectedInstOperands,
     /*  822381 */     // GIR_Coverage, 22412,
     /*  822381 */     GIR_EraseRootFromParent_Done,
     /*  822382 */   // Label 12703: @822382
     /*  822382 */   GIM_Try, /*On fail goto*//*Label 12704*/ GIMT_Encode4(822457), // Rule ID 22413 //
     /*  822387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  822404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  822422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822433 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  822436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822455 */     GIR_RootConstrainSelectedInstOperands,
     /*  822456 */     // GIR_Coverage, 22413,
     /*  822456 */     GIR_EraseRootFromParent_Done,
     /*  822457 */   // Label 12704: @822457
     /*  822457 */   GIM_Try, /*On fail goto*//*Label 12705*/ GIMT_Encode4(822532), // Rule ID 22416 //
     /*  822462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  822465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  822479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  822511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822530 */     GIR_RootConstrainSelectedInstOperands,
     /*  822531 */     // GIR_Coverage, 22416,
     /*  822531 */     GIR_EraseRootFromParent_Done,
     /*  822532 */   // Label 12705: @822532
     /*  822532 */   GIM_Try, /*On fail goto*//*Label 12706*/ GIMT_Encode4(822607), // Rule ID 22417 //
     /*  822537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  822554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822583 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11505:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  822586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822605 */     GIR_RootConstrainSelectedInstOperands,
     /*  822606 */     // GIR_Coverage, 22417,
     /*  822606 */     GIR_EraseRootFromParent_Done,
     /*  822607 */   // Label 12706: @822607
     /*  822607 */   GIM_Try, /*On fail goto*//*Label 12707*/ GIMT_Encode4(822682), // Rule ID 22420 //
     /*  822612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  822629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  822658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  822661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822680 */     GIR_RootConstrainSelectedInstOperands,
     /*  822681 */     // GIR_Coverage, 22420,
     /*  822681 */     GIR_EraseRootFromParent_Done,
     /*  822682 */   // Label 12707: @822682
     /*  822682 */   GIM_Try, /*On fail goto*//*Label 12708*/ GIMT_Encode4(822757), // Rule ID 22421 //
     /*  822687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  822704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822733 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  822733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  822736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822755 */     GIR_RootConstrainSelectedInstOperands,
     /*  822756 */     // GIR_Coverage, 22421,
     /*  822756 */     GIR_EraseRootFromParent_Done,
     /*  822757 */   // Label 12708: @822757
     /*  822757 */   GIM_Try, /*On fail goto*//*Label 12709*/ GIMT_Encode4(822832), // Rule ID 22424 //
     /*  822762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  822779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822808 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  822808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  822811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822830 */     GIR_RootConstrainSelectedInstOperands,
     /*  822831 */     // GIR_Coverage, 22424,
     /*  822831 */     GIR_EraseRootFromParent_Done,
     /*  822832 */   // Label 12709: @822832
     /*  822832 */   GIM_Try, /*On fail goto*//*Label 12710*/ GIMT_Encode4(822907), // Rule ID 22425 //
     /*  822837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  822854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822883 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  822883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  822886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822905 */     GIR_RootConstrainSelectedInstOperands,
     /*  822906 */     // GIR_Coverage, 22425,
     /*  822906 */     GIR_EraseRootFromParent_Done,
     /*  822907 */   // Label 12710: @822907
     /*  822907 */   GIM_Try, /*On fail goto*//*Label 12711*/ GIMT_Encode4(822982), // Rule ID 22428 //
     /*  822912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  822929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  822958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  822961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822980 */     GIR_RootConstrainSelectedInstOperands,
     /*  822981 */     // GIR_Coverage, 22428,
     /*  822981 */     GIR_EraseRootFromParent_Done,
     /*  822982 */   // Label 12711: @822982
     /*  822982 */   GIM_Try, /*On fail goto*//*Label 12712*/ GIMT_Encode4(823057), // Rule ID 22429 //
     /*  822987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  823004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823033 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  823036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823055 */     GIR_RootConstrainSelectedInstOperands,
     /*  823056 */     // GIR_Coverage, 22429,
     /*  823056 */     GIR_EraseRootFromParent_Done,
     /*  823057 */   // Label 12712: @823057
     /*  823057 */   GIM_Try, /*On fail goto*//*Label 12713*/ GIMT_Encode4(823132), // Rule ID 22432 //
     /*  823062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  823111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823130 */     GIR_RootConstrainSelectedInstOperands,
     /*  823131 */     // GIR_Coverage, 22432,
     /*  823131 */     GIR_EraseRootFromParent_Done,
     /*  823132 */   // Label 12713: @823132
     /*  823132 */   GIM_Try, /*On fail goto*//*Label 12714*/ GIMT_Encode4(823207), // Rule ID 22433 //
     /*  823137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  823154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823183 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  823186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823205 */     GIR_RootConstrainSelectedInstOperands,
     /*  823206 */     // GIR_Coverage, 22433,
     /*  823206 */     GIR_EraseRootFromParent_Done,
     /*  823207 */   // Label 12714: @823207
     /*  823207 */   GIM_Try, /*On fail goto*//*Label 12715*/ GIMT_Encode4(823282), // Rule ID 22436 //
     /*  823212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  823261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823280 */     GIR_RootConstrainSelectedInstOperands,
     /*  823281 */     // GIR_Coverage, 22436,
     /*  823281 */     GIR_EraseRootFromParent_Done,
     /*  823282 */   // Label 12715: @823282
     /*  823282 */   GIM_Try, /*On fail goto*//*Label 12716*/ GIMT_Encode4(823357), // Rule ID 22437 //
     /*  823287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  823304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823333 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  823336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823355 */     GIR_RootConstrainSelectedInstOperands,
     /*  823356 */     // GIR_Coverage, 22437,
     /*  823356 */     GIR_EraseRootFromParent_Done,
     /*  823357 */   // Label 12716: @823357
     /*  823357 */   GIM_Try, /*On fail goto*//*Label 12717*/ GIMT_Encode4(823432), // Rule ID 22440 //
     /*  823362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  823408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  823411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823430 */     GIR_RootConstrainSelectedInstOperands,
     /*  823431 */     // GIR_Coverage, 22440,
     /*  823431 */     GIR_EraseRootFromParent_Done,
     /*  823432 */   // Label 12717: @823432
     /*  823432 */   GIM_Try, /*On fail goto*//*Label 12718*/ GIMT_Encode4(823507), // Rule ID 22441 //
     /*  823437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  823454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823483 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  823483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  823486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823505 */     GIR_RootConstrainSelectedInstOperands,
     /*  823506 */     // GIR_Coverage, 22441,
     /*  823506 */     GIR_EraseRootFromParent_Done,
     /*  823507 */   // Label 12718: @823507
     /*  823507 */   GIM_Try, /*On fail goto*//*Label 12719*/ GIMT_Encode4(823582), // Rule ID 22444 //
     /*  823512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  823529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  823561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823580 */     GIR_RootConstrainSelectedInstOperands,
     /*  823581 */     // GIR_Coverage, 22444,
     /*  823581 */     GIR_EraseRootFromParent_Done,
     /*  823582 */   // Label 12719: @823582
     /*  823582 */   GIM_Try, /*On fail goto*//*Label 12720*/ GIMT_Encode4(823657), // Rule ID 22445 //
     /*  823587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  823604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823633 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  823636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823655 */     GIR_RootConstrainSelectedInstOperands,
     /*  823656 */     // GIR_Coverage, 22445,
     /*  823656 */     GIR_EraseRootFromParent_Done,
     /*  823657 */   // Label 12720: @823657
     /*  823657 */   GIM_Try, /*On fail goto*//*Label 12721*/ GIMT_Encode4(823732), // Rule ID 22448 //
     /*  823662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  823679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  823711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823730 */     GIR_RootConstrainSelectedInstOperands,
     /*  823731 */     // GIR_Coverage, 22448,
     /*  823731 */     GIR_EraseRootFromParent_Done,
     /*  823732 */   // Label 12721: @823732
     /*  823732 */   GIM_Try, /*On fail goto*//*Label 12722*/ GIMT_Encode4(823807), // Rule ID 22449 //
     /*  823737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  823754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  823786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823805 */     GIR_RootConstrainSelectedInstOperands,
     /*  823806 */     // GIR_Coverage, 22449,
     /*  823806 */     GIR_EraseRootFromParent_Done,
     /*  823807 */   // Label 12722: @823807
     /*  823807 */   GIM_Try, /*On fail goto*//*Label 12723*/ GIMT_Encode4(823882), // Rule ID 22452 //
     /*  823812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  823829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  823858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  823861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823880 */     GIR_RootConstrainSelectedInstOperands,
     /*  823881 */     // GIR_Coverage, 22452,
     /*  823881 */     GIR_EraseRootFromParent_Done,
     /*  823882 */   // Label 12723: @823882
     /*  823882 */   GIM_Try, /*On fail goto*//*Label 12724*/ GIMT_Encode4(823957), // Rule ID 22453 //
     /*  823887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  823904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  823933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  823936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823955 */     GIR_RootConstrainSelectedInstOperands,
     /*  823956 */     // GIR_Coverage, 22453,
     /*  823956 */     GIR_EraseRootFromParent_Done,
     /*  823957 */   // Label 12724: @823957
     /*  823957 */   GIM_Try, /*On fail goto*//*Label 12725*/ GIMT_Encode4(824032), // Rule ID 22456 //
     /*  823962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  823965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  823979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  824008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  824011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824030 */     GIR_RootConstrainSelectedInstOperands,
     /*  824031 */     // GIR_Coverage, 22456,
     /*  824031 */     GIR_EraseRootFromParent_Done,
     /*  824032 */   // Label 12725: @824032
     /*  824032 */   GIM_Try, /*On fail goto*//*Label 12726*/ GIMT_Encode4(824107), // Rule ID 22457 //
     /*  824037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  824040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  824054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824083 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  824083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  824086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  824102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824105 */     GIR_RootConstrainSelectedInstOperands,
     /*  824106 */     // GIR_Coverage, 22457,
     /*  824106 */     GIR_EraseRootFromParent_Done,
     /*  824107 */   // Label 12726: @824107
     /*  824107 */   GIM_Try, /*On fail goto*//*Label 12727*/ GIMT_Encode4(824182), // Rule ID 22460 //
     /*  824112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  824161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824180 */     GIR_RootConstrainSelectedInstOperands,
     /*  824181 */     // GIR_Coverage, 22460,
     /*  824181 */     GIR_EraseRootFromParent_Done,
     /*  824182 */   // Label 12727: @824182
     /*  824182 */   GIM_Try, /*On fail goto*//*Label 12728*/ GIMT_Encode4(824257), // Rule ID 22461 //
     /*  824187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  824204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824233 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  824236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824255 */     GIR_RootConstrainSelectedInstOperands,
     /*  824256 */     // GIR_Coverage, 22461,
     /*  824256 */     GIR_EraseRootFromParent_Done,
     /*  824257 */   // Label 12728: @824257
     /*  824257 */   GIM_Try, /*On fail goto*//*Label 12729*/ GIMT_Encode4(824332), // Rule ID 22464 //
     /*  824262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824308 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  824311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824330 */     GIR_RootConstrainSelectedInstOperands,
     /*  824331 */     // GIR_Coverage, 22464,
     /*  824331 */     GIR_EraseRootFromParent_Done,
     /*  824332 */   // Label 12729: @824332
     /*  824332 */   GIM_Try, /*On fail goto*//*Label 12730*/ GIMT_Encode4(824407), // Rule ID 22465 //
     /*  824337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  824354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824383 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  824386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824405 */     GIR_RootConstrainSelectedInstOperands,
     /*  824406 */     // GIR_Coverage, 22465,
     /*  824406 */     GIR_EraseRootFromParent_Done,
     /*  824407 */   // Label 12730: @824407
     /*  824407 */   GIM_Try, /*On fail goto*//*Label 12731*/ GIMT_Encode4(824482), // Rule ID 22468 //
     /*  824412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  824458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  824461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824480 */     GIR_RootConstrainSelectedInstOperands,
     /*  824481 */     // GIR_Coverage, 22468,
     /*  824481 */     GIR_EraseRootFromParent_Done,
     /*  824482 */   // Label 12731: @824482
     /*  824482 */   GIM_Try, /*On fail goto*//*Label 12732*/ GIMT_Encode4(824557), // Rule ID 22469 //
     /*  824487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  824498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  824501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  824504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  824507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824533 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11503:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  824536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824555 */     GIR_RootConstrainSelectedInstOperands,
     /*  824556 */     // GIR_Coverage, 22469,
     /*  824556 */     GIR_EraseRootFromParent_Done,
     /*  824557 */   // Label 12732: @824557
     /*  824557 */   GIM_Try, /*On fail goto*//*Label 12733*/ GIMT_Encode4(824632), // Rule ID 22472 //
     /*  824562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  824579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  824611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824630 */     GIR_RootConstrainSelectedInstOperands,
     /*  824631 */     // GIR_Coverage, 22472,
     /*  824631 */     GIR_EraseRootFromParent_Done,
     /*  824632 */   // Label 12733: @824632
     /*  824632 */   GIM_Try, /*On fail goto*//*Label 12734*/ GIMT_Encode4(824707), // Rule ID 22473 //
     /*  824637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  824654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  824686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824705 */     GIR_RootConstrainSelectedInstOperands,
     /*  824706 */     // GIR_Coverage, 22473,
     /*  824706 */     GIR_EraseRootFromParent_Done,
     /*  824707 */   // Label 12734: @824707
     /*  824707 */   GIM_Try, /*On fail goto*//*Label 12735*/ GIMT_Encode4(824782), // Rule ID 22476 //
     /*  824712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  824729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824758 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  824761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824780 */     GIR_RootConstrainSelectedInstOperands,
     /*  824781 */     // GIR_Coverage, 22476,
     /*  824781 */     GIR_EraseRootFromParent_Done,
     /*  824782 */   // Label 12735: @824782
     /*  824782 */   GIM_Try, /*On fail goto*//*Label 12736*/ GIMT_Encode4(824857), // Rule ID 22477 //
     /*  824787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  824804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824833 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  824836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824855 */     GIR_RootConstrainSelectedInstOperands,
     /*  824856 */     // GIR_Coverage, 22477,
     /*  824856 */     GIR_EraseRootFromParent_Done,
     /*  824857 */   // Label 12736: @824857
     /*  824857 */   GIM_Try, /*On fail goto*//*Label 12737*/ GIMT_Encode4(824932), // Rule ID 22480 //
     /*  824862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  824879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  824911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824930 */     GIR_RootConstrainSelectedInstOperands,
     /*  824931 */     // GIR_Coverage, 22480,
     /*  824931 */     GIR_EraseRootFromParent_Done,
     /*  824932 */   // Label 12737: @824932
     /*  824932 */   GIM_Try, /*On fail goto*//*Label 12738*/ GIMT_Encode4(825007), // Rule ID 22481 //
     /*  824937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  824954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824983 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11503:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  824986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825005 */     GIR_RootConstrainSelectedInstOperands,
     /*  825006 */     // GIR_Coverage, 22481,
     /*  825006 */     GIR_EraseRootFromParent_Done,
     /*  825007 */   // Label 12738: @825007
     /*  825007 */   GIM_Try, /*On fail goto*//*Label 12739*/ GIMT_Encode4(825082), // Rule ID 22484 //
     /*  825012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  825061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825080 */     GIR_RootConstrainSelectedInstOperands,
     /*  825081 */     // GIR_Coverage, 22484,
     /*  825081 */     GIR_EraseRootFromParent_Done,
     /*  825082 */   // Label 12739: @825082
     /*  825082 */   GIM_Try, /*On fail goto*//*Label 12740*/ GIMT_Encode4(825157), // Rule ID 22485 //
     /*  825087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  825104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825133 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  825136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825155 */     GIR_RootConstrainSelectedInstOperands,
     /*  825156 */     // GIR_Coverage, 22485,
     /*  825156 */     GIR_EraseRootFromParent_Done,
     /*  825157 */   // Label 12740: @825157
     /*  825157 */   GIM_Try, /*On fail goto*//*Label 12741*/ GIMT_Encode4(825232), // Rule ID 22488 //
     /*  825162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  825211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825230 */     GIR_RootConstrainSelectedInstOperands,
     /*  825231 */     // GIR_Coverage, 22488,
     /*  825231 */     GIR_EraseRootFromParent_Done,
     /*  825232 */   // Label 12741: @825232
     /*  825232 */   GIM_Try, /*On fail goto*//*Label 12742*/ GIMT_Encode4(825307), // Rule ID 22489 //
     /*  825237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  825254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825283 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  825286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825305 */     GIR_RootConstrainSelectedInstOperands,
     /*  825306 */     // GIR_Coverage, 22489,
     /*  825306 */     GIR_EraseRootFromParent_Done,
     /*  825307 */   // Label 12742: @825307
     /*  825307 */   GIM_Try, /*On fail goto*//*Label 12743*/ GIMT_Encode4(825382), // Rule ID 22492 //
     /*  825312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  825358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  825361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825380 */     GIR_RootConstrainSelectedInstOperands,
     /*  825381 */     // GIR_Coverage, 22492,
     /*  825381 */     GIR_EraseRootFromParent_Done,
     /*  825382 */   // Label 12743: @825382
     /*  825382 */   GIM_Try, /*On fail goto*//*Label 12744*/ GIMT_Encode4(825457), // Rule ID 22493 //
     /*  825387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  825398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  825401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  825404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  825407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11503:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  825433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  825436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  825452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825455 */     GIR_RootConstrainSelectedInstOperands,
     /*  825456 */     // GIR_Coverage, 22493,
     /*  825456 */     GIR_EraseRootFromParent_Done,
     /*  825457 */   // Label 12744: @825457
     /*  825457 */   GIM_Try, /*On fail goto*//*Label 12745*/ GIMT_Encode4(825532), // Rule ID 22496 //
     /*  825462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  825479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  825511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825530 */     GIR_RootConstrainSelectedInstOperands,
     /*  825531 */     // GIR_Coverage, 22496,
     /*  825531 */     GIR_EraseRootFromParent_Done,
     /*  825532 */   // Label 12745: @825532
     /*  825532 */   GIM_Try, /*On fail goto*//*Label 12746*/ GIMT_Encode4(825607), // Rule ID 22497 //
     /*  825537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  825554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825583 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  825583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  825586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825605 */     GIR_RootConstrainSelectedInstOperands,
     /*  825606 */     // GIR_Coverage, 22497,
     /*  825606 */     GIR_EraseRootFromParent_Done,
     /*  825607 */   // Label 12746: @825607
     /*  825607 */   GIM_Try, /*On fail goto*//*Label 12747*/ GIMT_Encode4(825682), // Rule ID 22500 //
     /*  825612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  825629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  825661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825680 */     GIR_RootConstrainSelectedInstOperands,
     /*  825681 */     // GIR_Coverage, 22500,
     /*  825681 */     GIR_EraseRootFromParent_Done,
     /*  825682 */   // Label 12747: @825682
     /*  825682 */   GIM_Try, /*On fail goto*//*Label 12748*/ GIMT_Encode4(825757), // Rule ID 22501 //
     /*  825687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  825704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825733 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  825733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  825736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825755 */     GIR_RootConstrainSelectedInstOperands,
     /*  825756 */     // GIR_Coverage, 22501,
     /*  825756 */     GIR_EraseRootFromParent_Done,
     /*  825757 */   // Label 12748: @825757
     /*  825757 */   GIM_Try, /*On fail goto*//*Label 12749*/ GIMT_Encode4(825832), // Rule ID 22504 //
     /*  825762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  825779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  825811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825830 */     GIR_RootConstrainSelectedInstOperands,
     /*  825831 */     // GIR_Coverage, 22504,
     /*  825831 */     GIR_EraseRootFromParent_Done,
     /*  825832 */   // Label 12749: @825832
     /*  825832 */   GIM_Try, /*On fail goto*//*Label 12750*/ GIMT_Encode4(825907), // Rule ID 22505 //
     /*  825837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  825854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825883 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11503:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  825883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  825886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825905 */     GIR_RootConstrainSelectedInstOperands,
     /*  825906 */     // GIR_Coverage, 22505,
     /*  825906 */     GIR_EraseRootFromParent_Done,
     /*  825907 */   // Label 12750: @825907
     /*  825907 */   GIM_Try, /*On fail goto*//*Label 12751*/ GIMT_Encode4(825982), // Rule ID 22508 //
     /*  825912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  825929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  825958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  825961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825980 */     GIR_RootConstrainSelectedInstOperands,
     /*  825981 */     // GIR_Coverage, 22508,
     /*  825981 */     GIR_EraseRootFromParent_Done,
     /*  825982 */   // Label 12751: @825982
     /*  825982 */   GIM_Try, /*On fail goto*//*Label 12752*/ GIMT_Encode4(826057), // Rule ID 22509 //
     /*  825987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  826004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826033 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  826036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826055 */     GIR_RootConstrainSelectedInstOperands,
     /*  826056 */     // GIR_Coverage, 22509,
     /*  826056 */     GIR_EraseRootFromParent_Done,
     /*  826057 */   // Label 12752: @826057
     /*  826057 */   GIM_Try, /*On fail goto*//*Label 12753*/ GIMT_Encode4(826132), // Rule ID 22512 //
     /*  826062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826108 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  826111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826130 */     GIR_RootConstrainSelectedInstOperands,
     /*  826131 */     // GIR_Coverage, 22512,
     /*  826131 */     GIR_EraseRootFromParent_Done,
     /*  826132 */   // Label 12753: @826132
     /*  826132 */   GIM_Try, /*On fail goto*//*Label 12754*/ GIMT_Encode4(826207), // Rule ID 22513 //
     /*  826137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  826154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826183 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  826186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826205 */     GIR_RootConstrainSelectedInstOperands,
     /*  826206 */     // GIR_Coverage, 22513,
     /*  826206 */     GIR_EraseRootFromParent_Done,
     /*  826207 */   // Label 12754: @826207
     /*  826207 */   GIM_Try, /*On fail goto*//*Label 12755*/ GIMT_Encode4(826282), // Rule ID 22516 //
     /*  826212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  826261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826280 */     GIR_RootConstrainSelectedInstOperands,
     /*  826281 */     // GIR_Coverage, 22516,
     /*  826281 */     GIR_EraseRootFromParent_Done,
     /*  826282 */   // Label 12755: @826282
     /*  826282 */   GIM_Try, /*On fail goto*//*Label 12756*/ GIMT_Encode4(826357), // Rule ID 22517 //
     /*  826287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  826304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826333 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  826336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826355 */     GIR_RootConstrainSelectedInstOperands,
     /*  826356 */     // GIR_Coverage, 22517,
     /*  826356 */     GIR_EraseRootFromParent_Done,
     /*  826357 */   // Label 12756: @826357
     /*  826357 */   GIM_Try, /*On fail goto*//*Label 12757*/ GIMT_Encode4(826432), // Rule ID 22520 //
     /*  826362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  826411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826430 */     GIR_RootConstrainSelectedInstOperands,
     /*  826431 */     // GIR_Coverage, 22520,
     /*  826431 */     GIR_EraseRootFromParent_Done,
     /*  826432 */   // Label 12757: @826432
     /*  826432 */   GIM_Try, /*On fail goto*//*Label 12758*/ GIMT_Encode4(826507), // Rule ID 22521 //
     /*  826437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  826454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  826483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  826486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826505 */     GIR_RootConstrainSelectedInstOperands,
     /*  826506 */     // GIR_Coverage, 22521,
     /*  826506 */     GIR_EraseRootFromParent_Done,
     /*  826507 */   // Label 12758: @826507
     /*  826507 */   GIM_Try, /*On fail goto*//*Label 12759*/ GIMT_Encode4(826582), // Rule ID 22524 //
     /*  826512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  826529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  826561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826580 */     GIR_RootConstrainSelectedInstOperands,
     /*  826581 */     // GIR_Coverage, 22524,
     /*  826581 */     GIR_EraseRootFromParent_Done,
     /*  826582 */   // Label 12759: @826582
     /*  826582 */   GIM_Try, /*On fail goto*//*Label 12760*/ GIMT_Encode4(826657), // Rule ID 22525 //
     /*  826587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  826604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826633 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  826633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  826636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826655 */     GIR_RootConstrainSelectedInstOperands,
     /*  826656 */     // GIR_Coverage, 22525,
     /*  826656 */     GIR_EraseRootFromParent_Done,
     /*  826657 */   // Label 12760: @826657
     /*  826657 */   GIM_Try, /*On fail goto*//*Label 12761*/ GIMT_Encode4(826732), // Rule ID 22528 //
     /*  826662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  826673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  826676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  826679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  826682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  826708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  826711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826730 */     GIR_RootConstrainSelectedInstOperands,
     /*  826731 */     // GIR_Coverage, 22528,
     /*  826731 */     GIR_EraseRootFromParent_Done,
     /*  826732 */   // Label 12761: @826732
     /*  826732 */   GIM_Try, /*On fail goto*//*Label 12762*/ GIMT_Encode4(826807), // Rule ID 22529 //
     /*  826737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  826748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  826751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  826754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  826757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826783 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  826783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  826786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826805 */     GIR_RootConstrainSelectedInstOperands,
     /*  826806 */     // GIR_Coverage, 22529,
     /*  826806 */     GIR_EraseRootFromParent_Done,
     /*  826807 */   // Label 12762: @826807
     /*  826807 */   GIM_Try, /*On fail goto*//*Label 12763*/ GIMT_Encode4(826882), // Rule ID 22532 //
     /*  826812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  826829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826858 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  826861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826880 */     GIR_RootConstrainSelectedInstOperands,
     /*  826881 */     // GIR_Coverage, 22532,
     /*  826881 */     GIR_EraseRootFromParent_Done,
     /*  826882 */   // Label 12763: @826882
     /*  826882 */   GIM_Try, /*On fail goto*//*Label 12764*/ GIMT_Encode4(826957), // Rule ID 22533 //
     /*  826887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  826904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826933 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  826936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826955 */     GIR_RootConstrainSelectedInstOperands,
     /*  826956 */     // GIR_Coverage, 22533,
     /*  826956 */     GIR_EraseRootFromParent_Done,
     /*  826957 */   // Label 12764: @826957
     /*  826957 */   GIM_Try, /*On fail goto*//*Label 12765*/ GIMT_Encode4(827032), // Rule ID 22536 //
     /*  826962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  826979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  827011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827030 */     GIR_RootConstrainSelectedInstOperands,
     /*  827031 */     // GIR_Coverage, 22536,
     /*  827031 */     GIR_EraseRootFromParent_Done,
     /*  827032 */   // Label 12765: @827032
     /*  827032 */   GIM_Try, /*On fail goto*//*Label 12766*/ GIMT_Encode4(827107), // Rule ID 22537 //
     /*  827037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  827054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827083 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  827086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827105 */     GIR_RootConstrainSelectedInstOperands,
     /*  827106 */     // GIR_Coverage, 22537,
     /*  827106 */     GIR_EraseRootFromParent_Done,
     /*  827107 */   // Label 12766: @827107
     /*  827107 */   GIM_Try, /*On fail goto*//*Label 12767*/ GIMT_Encode4(827182), // Rule ID 22540 //
     /*  827112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  827161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827180 */     GIR_RootConstrainSelectedInstOperands,
     /*  827181 */     // GIR_Coverage, 22540,
     /*  827181 */     GIR_EraseRootFromParent_Done,
     /*  827182 */   // Label 12767: @827182
     /*  827182 */   GIM_Try, /*On fail goto*//*Label 12768*/ GIMT_Encode4(827257), // Rule ID 22541 //
     /*  827187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  827204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827233 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  827236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827255 */     GIR_RootConstrainSelectedInstOperands,
     /*  827256 */     // GIR_Coverage, 22541,
     /*  827256 */     GIR_EraseRootFromParent_Done,
     /*  827257 */   // Label 12768: @827257
     /*  827257 */   GIM_Try, /*On fail goto*//*Label 12769*/ GIMT_Encode4(827332), // Rule ID 22544 //
     /*  827262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  827265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  827308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  827311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827330 */     GIR_RootConstrainSelectedInstOperands,
     /*  827331 */     // GIR_Coverage, 22544,
     /*  827331 */     GIR_EraseRootFromParent_Done,
     /*  827332 */   // Label 12769: @827332
     /*  827332 */   GIM_Try, /*On fail goto*//*Label 12770*/ GIMT_Encode4(827407), // Rule ID 22545 //
     /*  827337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  827340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  827348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  827351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  827354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  827357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  827383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  827386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  827402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827405 */     GIR_RootConstrainSelectedInstOperands,
     /*  827406 */     // GIR_Coverage, 22545,
     /*  827406 */     GIR_EraseRootFromParent_Done,
     /*  827407 */   // Label 12770: @827407
     /*  827407 */   GIM_Try, /*On fail goto*//*Label 12771*/ GIMT_Encode4(827482), // Rule ID 22548 //
     /*  827412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  827461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827480 */     GIR_RootConstrainSelectedInstOperands,
     /*  827481 */     // GIR_Coverage, 22548,
     /*  827481 */     GIR_EraseRootFromParent_Done,
     /*  827482 */   // Label 12771: @827482
     /*  827482 */   GIM_Try, /*On fail goto*//*Label 12772*/ GIMT_Encode4(827557), // Rule ID 22549 //
     /*  827487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  827504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827533 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  827536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827555 */     GIR_RootConstrainSelectedInstOperands,
     /*  827556 */     // GIR_Coverage, 22549,
     /*  827556 */     GIR_EraseRootFromParent_Done,
     /*  827557 */   // Label 12772: @827557
     /*  827557 */   GIM_Try, /*On fail goto*//*Label 12773*/ GIMT_Encode4(827632), // Rule ID 22552 //
     /*  827562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  827579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  827597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  827611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827630 */     GIR_RootConstrainSelectedInstOperands,
     /*  827631 */     // GIR_Coverage, 22552,
     /*  827631 */     GIR_EraseRootFromParent_Done,
     /*  827632 */   // Label 12773: @827632
     /*  827632 */   GIM_Try, /*On fail goto*//*Label 12774*/ GIMT_Encode4(827707), // Rule ID 22553 //
     /*  827637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  827654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  827672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827683 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  827686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827705 */     GIR_RootConstrainSelectedInstOperands,
     /*  827706 */     // GIR_Coverage, 22553,
     /*  827706 */     GIR_EraseRootFromParent_Done,
     /*  827707 */   // Label 12774: @827707
     /*  827707 */   GIM_Try, /*On fail goto*//*Label 12775*/ GIMT_Encode4(827782), // Rule ID 22556 //
     /*  827712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  827729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  827761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827780 */     GIR_RootConstrainSelectedInstOperands,
     /*  827781 */     // GIR_Coverage, 22556,
     /*  827781 */     GIR_EraseRootFromParent_Done,
     /*  827782 */   // Label 12775: @827782
     /*  827782 */   GIM_Try, /*On fail goto*//*Label 12776*/ GIMT_Encode4(827857), // Rule ID 22557 //
     /*  827787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  827804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827833 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11501:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  827836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827855 */     GIR_RootConstrainSelectedInstOperands,
     /*  827856 */     // GIR_Coverage, 22557,
     /*  827856 */     GIR_EraseRootFromParent_Done,
     /*  827857 */   // Label 12776: @827857
     /*  827857 */   GIM_Try, /*On fail goto*//*Label 12777*/ GIMT_Encode4(827932), // Rule ID 22560 //
     /*  827862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  827879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  827911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827930 */     GIR_RootConstrainSelectedInstOperands,
     /*  827931 */     // GIR_Coverage, 22560,
     /*  827931 */     GIR_EraseRootFromParent_Done,
     /*  827932 */   // Label 12777: @827932
     /*  827932 */   GIM_Try, /*On fail goto*//*Label 12778*/ GIMT_Encode4(828007), // Rule ID 22561 //
     /*  827937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  827954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827983 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  827986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828005 */     GIR_RootConstrainSelectedInstOperands,
     /*  828006 */     // GIR_Coverage, 22561,
     /*  828006 */     GIR_EraseRootFromParent_Done,
     /*  828007 */   // Label 12778: @828007
     /*  828007 */   GIM_Try, /*On fail goto*//*Label 12779*/ GIMT_Encode4(828082), // Rule ID 22564 //
     /*  828012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  828061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828080 */     GIR_RootConstrainSelectedInstOperands,
     /*  828081 */     // GIR_Coverage, 22564,
     /*  828081 */     GIR_EraseRootFromParent_Done,
     /*  828082 */   // Label 12779: @828082
     /*  828082 */   GIM_Try, /*On fail goto*//*Label 12780*/ GIMT_Encode4(828157), // Rule ID 22565 //
     /*  828087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  828104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828133 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  828136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828155 */     GIR_RootConstrainSelectedInstOperands,
     /*  828156 */     // GIR_Coverage, 22565,
     /*  828156 */     GIR_EraseRootFromParent_Done,
     /*  828157 */   // Label 12780: @828157
     /*  828157 */   GIM_Try, /*On fail goto*//*Label 12781*/ GIMT_Encode4(828232), // Rule ID 22568 //
     /*  828162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  828208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  828211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828230 */     GIR_RootConstrainSelectedInstOperands,
     /*  828231 */     // GIR_Coverage, 22568,
     /*  828231 */     GIR_EraseRootFromParent_Done,
     /*  828232 */   // Label 12781: @828232
     /*  828232 */   GIM_Try, /*On fail goto*//*Label 12782*/ GIMT_Encode4(828307), // Rule ID 22569 //
     /*  828237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  828248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  828251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  828254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  828257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11501:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  828283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  828286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  828302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828305 */     GIR_RootConstrainSelectedInstOperands,
     /*  828306 */     // GIR_Coverage, 22569,
     /*  828306 */     GIR_EraseRootFromParent_Done,
     /*  828307 */   // Label 12782: @828307
     /*  828307 */   GIM_Try, /*On fail goto*//*Label 12783*/ GIMT_Encode4(828382), // Rule ID 22572 //
     /*  828312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  828361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828380 */     GIR_RootConstrainSelectedInstOperands,
     /*  828381 */     // GIR_Coverage, 22572,
     /*  828381 */     GIR_EraseRootFromParent_Done,
     /*  828382 */   // Label 12783: @828382
     /*  828382 */   GIM_Try, /*On fail goto*//*Label 12784*/ GIMT_Encode4(828457), // Rule ID 22573 //
     /*  828387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  828404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  828436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828455 */     GIR_RootConstrainSelectedInstOperands,
     /*  828456 */     // GIR_Coverage, 22573,
     /*  828456 */     GIR_EraseRootFromParent_Done,
     /*  828457 */   // Label 12784: @828457
     /*  828457 */   GIM_Try, /*On fail goto*//*Label 12785*/ GIMT_Encode4(828532), // Rule ID 22576 //
     /*  828462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  828479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  828511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828530 */     GIR_RootConstrainSelectedInstOperands,
     /*  828531 */     // GIR_Coverage, 22576,
     /*  828531 */     GIR_EraseRootFromParent_Done,
     /*  828532 */   // Label 12785: @828532
     /*  828532 */   GIM_Try, /*On fail goto*//*Label 12786*/ GIMT_Encode4(828607), // Rule ID 22577 //
     /*  828537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  828554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828583 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  828586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828605 */     GIR_RootConstrainSelectedInstOperands,
     /*  828606 */     // GIR_Coverage, 22577,
     /*  828606 */     GIR_EraseRootFromParent_Done,
     /*  828607 */   // Label 12786: @828607
     /*  828607 */   GIM_Try, /*On fail goto*//*Label 12787*/ GIMT_Encode4(828682), // Rule ID 22580 //
     /*  828612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  828629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  828661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828680 */     GIR_RootConstrainSelectedInstOperands,
     /*  828681 */     // GIR_Coverage, 22580,
     /*  828681 */     GIR_EraseRootFromParent_Done,
     /*  828682 */   // Label 12787: @828682
     /*  828682 */   GIM_Try, /*On fail goto*//*Label 12788*/ GIMT_Encode4(828757), // Rule ID 22581 //
     /*  828687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  828704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828733 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11501:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  828736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828755 */     GIR_RootConstrainSelectedInstOperands,
     /*  828756 */     // GIR_Coverage, 22581,
     /*  828756 */     GIR_EraseRootFromParent_Done,
     /*  828757 */   // Label 12788: @828757
     /*  828757 */   GIM_Try, /*On fail goto*//*Label 12789*/ GIMT_Encode4(828832), // Rule ID 22584 //
     /*  828762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  828765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  828779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  828808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  828811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828830 */     GIR_RootConstrainSelectedInstOperands,
     /*  828831 */     // GIR_Coverage, 22584,
     /*  828831 */     GIR_EraseRootFromParent_Done,
     /*  828832 */   // Label 12789: @828832
     /*  828832 */   GIM_Try, /*On fail goto*//*Label 12790*/ GIMT_Encode4(828907), // Rule ID 22585 //
     /*  828837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  828840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  828854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828883 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  828883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  828886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828905 */     GIR_RootConstrainSelectedInstOperands,
     /*  828906 */     // GIR_Coverage, 22585,
     /*  828906 */     GIR_EraseRootFromParent_Done,
     /*  828907 */   // Label 12790: @828907
     /*  828907 */   GIM_Try, /*On fail goto*//*Label 12791*/ GIMT_Encode4(828982), // Rule ID 22588 //
     /*  828912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  828915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  828929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  828958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  828961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828980 */     GIR_RootConstrainSelectedInstOperands,
     /*  828981 */     // GIR_Coverage, 22588,
     /*  828981 */     GIR_EraseRootFromParent_Done,
     /*  828982 */   // Label 12791: @828982
     /*  828982 */   GIM_Try, /*On fail goto*//*Label 12792*/ GIMT_Encode4(829057), // Rule ID 22589 //
     /*  828987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  828990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  829004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  829022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829033 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  829036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829055 */     GIR_RootConstrainSelectedInstOperands,
     /*  829056 */     // GIR_Coverage, 22589,
     /*  829056 */     GIR_EraseRootFromParent_Done,
     /*  829057 */   // Label 12792: @829057
     /*  829057 */   GIM_Try, /*On fail goto*//*Label 12793*/ GIMT_Encode4(829132), // Rule ID 22592 //
     /*  829062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  829065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  829108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  829111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829130 */     GIR_RootConstrainSelectedInstOperands,
     /*  829131 */     // GIR_Coverage, 22592,
     /*  829131 */     GIR_EraseRootFromParent_Done,
     /*  829132 */   // Label 12793: @829132
     /*  829132 */   GIM_Try, /*On fail goto*//*Label 12794*/ GIMT_Encode4(829207), // Rule ID 22593 //
     /*  829137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  829140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  829145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  829148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  829151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  829154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  829157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  829172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829183 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11501:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  829183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  829186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  829202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829205 */     GIR_RootConstrainSelectedInstOperands,
     /*  829206 */     // GIR_Coverage, 22593,
     /*  829206 */     GIR_EraseRootFromParent_Done,
     /*  829207 */   // Label 12794: @829207
     /*  829207 */   GIM_Try, /*On fail goto*//*Label 12795*/ GIMT_Encode4(829282), // Rule ID 22596 //
     /*  829212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  829261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829280 */     GIR_RootConstrainSelectedInstOperands,
     /*  829281 */     // GIR_Coverage, 22596,
     /*  829281 */     GIR_EraseRootFromParent_Done,
     /*  829282 */   // Label 12795: @829282
     /*  829282 */   GIM_Try, /*On fail goto*//*Label 12796*/ GIMT_Encode4(829357), // Rule ID 22597 //
     /*  829287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  829304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829333 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  829336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829355 */     GIR_RootConstrainSelectedInstOperands,
     /*  829356 */     // GIR_Coverage, 22597,
     /*  829356 */     GIR_EraseRootFromParent_Done,
     /*  829357 */   // Label 12796: @829357
     /*  829357 */   GIM_Try, /*On fail goto*//*Label 12797*/ GIMT_Encode4(829432), // Rule ID 22600 //
     /*  829362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829408 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  829411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829430 */     GIR_RootConstrainSelectedInstOperands,
     /*  829431 */     // GIR_Coverage, 22600,
     /*  829431 */     GIR_EraseRootFromParent_Done,
     /*  829432 */   // Label 12797: @829432
     /*  829432 */   GIM_Try, /*On fail goto*//*Label 12798*/ GIMT_Encode4(829507), // Rule ID 22601 //
     /*  829437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  829454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829483 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  829486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829505 */     GIR_RootConstrainSelectedInstOperands,
     /*  829506 */     // GIR_Coverage, 22601,
     /*  829506 */     GIR_EraseRootFromParent_Done,
     /*  829507 */   // Label 12798: @829507
     /*  829507 */   GIM_Try, /*On fail goto*//*Label 12799*/ GIMT_Encode4(829582), // Rule ID 22604 //
     /*  829512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  829529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  829561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829580 */     GIR_RootConstrainSelectedInstOperands,
     /*  829581 */     // GIR_Coverage, 22604,
     /*  829581 */     GIR_EraseRootFromParent_Done,
     /*  829582 */   // Label 12799: @829582
     /*  829582 */   GIM_Try, /*On fail goto*//*Label 12800*/ GIMT_Encode4(829657), // Rule ID 22605 //
     /*  829587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  829604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829633 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  829636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829655 */     GIR_RootConstrainSelectedInstOperands,
     /*  829656 */     // GIR_Coverage, 22605,
     /*  829656 */     GIR_EraseRootFromParent_Done,
     /*  829657 */   // Label 12800: @829657
     /*  829657 */   GIM_Try, /*On fail goto*//*Label 12801*/ GIMT_Encode4(829732), // Rule ID 22608 //
     /*  829662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  829679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  829708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  829711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829730 */     GIR_RootConstrainSelectedInstOperands,
     /*  829731 */     // GIR_Coverage, 22608,
     /*  829731 */     GIR_EraseRootFromParent_Done,
     /*  829732 */   // Label 12801: @829732
     /*  829732 */   GIM_Try, /*On fail goto*//*Label 12802*/ GIMT_Encode4(829807), // Rule ID 22609 //
     /*  829737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  829754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  829783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  829786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829805 */     GIR_RootConstrainSelectedInstOperands,
     /*  829806 */     // GIR_Coverage, 22609,
     /*  829806 */     GIR_EraseRootFromParent_Done,
     /*  829807 */   // Label 12802: @829807
     /*  829807 */   GIM_Try, /*On fail goto*//*Label 12803*/ GIMT_Encode4(829882), // Rule ID 22612 //
     /*  829812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  829829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  829858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  829861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829880 */     GIR_RootConstrainSelectedInstOperands,
     /*  829881 */     // GIR_Coverage, 22612,
     /*  829881 */     GIR_EraseRootFromParent_Done,
     /*  829882 */   // Label 12803: @829882
     /*  829882 */   GIM_Try, /*On fail goto*//*Label 12804*/ GIMT_Encode4(829957), // Rule ID 22613 //
     /*  829887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  829904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829933 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  829933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  829936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829955 */     GIR_RootConstrainSelectedInstOperands,
     /*  829956 */     // GIR_Coverage, 22613,
     /*  829956 */     GIR_EraseRootFromParent_Done,
     /*  829957 */   // Label 12804: @829957
     /*  829957 */   GIM_Try, /*On fail goto*//*Label 12805*/ GIMT_Encode4(830032), // Rule ID 22616 //
     /*  829962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  829979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  830011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830030 */     GIR_RootConstrainSelectedInstOperands,
     /*  830031 */     // GIR_Coverage, 22616,
     /*  830031 */     GIR_EraseRootFromParent_Done,
     /*  830032 */   // Label 12805: @830032
     /*  830032 */   GIM_Try, /*On fail goto*//*Label 12806*/ GIMT_Encode4(830107), // Rule ID 22617 //
     /*  830037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  830054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830083 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  830086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830105 */     GIR_RootConstrainSelectedInstOperands,
     /*  830106 */     // GIR_Coverage, 22617,
     /*  830106 */     GIR_EraseRootFromParent_Done,
     /*  830107 */   // Label 12806: @830107
     /*  830107 */   GIM_Try, /*On fail goto*//*Label 12807*/ GIMT_Encode4(830182), // Rule ID 22620 //
     /*  830112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  830161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830180 */     GIR_RootConstrainSelectedInstOperands,
     /*  830181 */     // GIR_Coverage, 22620,
     /*  830181 */     GIR_EraseRootFromParent_Done,
     /*  830182 */   // Label 12807: @830182
     /*  830182 */   GIM_Try, /*On fail goto*//*Label 12808*/ GIMT_Encode4(830257), // Rule ID 22621 //
     /*  830187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  830204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830233 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  830236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830255 */     GIR_RootConstrainSelectedInstOperands,
     /*  830256 */     // GIR_Coverage, 22621,
     /*  830256 */     GIR_EraseRootFromParent_Done,
     /*  830257 */   // Label 12808: @830257
     /*  830257 */   GIM_Try, /*On fail goto*//*Label 12809*/ GIMT_Encode4(830332), // Rule ID 22624 //
     /*  830262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830308 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  830311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830330 */     GIR_RootConstrainSelectedInstOperands,
     /*  830331 */     // GIR_Coverage, 22624,
     /*  830331 */     GIR_EraseRootFromParent_Done,
     /*  830332 */   // Label 12809: @830332
     /*  830332 */   GIM_Try, /*On fail goto*//*Label 12810*/ GIMT_Encode4(830407), // Rule ID 22625 //
     /*  830337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  830354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830383 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  830386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830405 */     GIR_RootConstrainSelectedInstOperands,
     /*  830406 */     // GIR_Coverage, 22625,
     /*  830406 */     GIR_EraseRootFromParent_Done,
     /*  830407 */   // Label 12810: @830407
     /*  830407 */   GIM_Try, /*On fail goto*//*Label 12811*/ GIMT_Encode4(830482), // Rule ID 22628 //
     /*  830412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  830458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  830461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830480 */     GIR_RootConstrainSelectedInstOperands,
     /*  830481 */     // GIR_Coverage, 22628,
     /*  830481 */     GIR_EraseRootFromParent_Done,
     /*  830482 */   // Label 12811: @830482
     /*  830482 */   GIM_Try, /*On fail goto*//*Label 12812*/ GIMT_Encode4(830557), // Rule ID 22629 //
     /*  830487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  830498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  830501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  830504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  830507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830533 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  830536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830555 */     GIR_RootConstrainSelectedInstOperands,
     /*  830556 */     // GIR_Coverage, 22629,
     /*  830556 */     GIR_EraseRootFromParent_Done,
     /*  830557 */   // Label 12812: @830557
     /*  830557 */   GIM_Try, /*On fail goto*//*Label 12813*/ GIMT_Encode4(830632), // Rule ID 22632 //
     /*  830562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  830565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  830573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  830576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  830579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  830582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830608 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  830608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  830611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  830627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830630 */     GIR_RootConstrainSelectedInstOperands,
     /*  830631 */     // GIR_Coverage, 22632,
     /*  830631 */     GIR_EraseRootFromParent_Done,
     /*  830632 */   // Label 12813: @830632
     /*  830632 */   GIM_Try, /*On fail goto*//*Label 12814*/ GIMT_Encode4(830707), // Rule ID 22633 //
     /*  830637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  830640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  830648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  830651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  830654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  830657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830683 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  830683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  830686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  830702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830705 */     GIR_RootConstrainSelectedInstOperands,
     /*  830706 */     // GIR_Coverage, 22633,
     /*  830706 */     GIR_EraseRootFromParent_Done,
     /*  830707 */   // Label 12814: @830707
     /*  830707 */   GIM_Try, /*On fail goto*//*Label 12815*/ GIMT_Encode4(830782), // Rule ID 22636 //
     /*  830712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  830729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  830761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830780 */     GIR_RootConstrainSelectedInstOperands,
     /*  830781 */     // GIR_Coverage, 22636,
     /*  830781 */     GIR_EraseRootFromParent_Done,
     /*  830782 */   // Label 12815: @830782
     /*  830782 */   GIM_Try, /*On fail goto*//*Label 12816*/ GIMT_Encode4(830857), // Rule ID 22637 //
     /*  830787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  830804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830833 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  830836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830855 */     GIR_RootConstrainSelectedInstOperands,
     /*  830856 */     // GIR_Coverage, 22637,
     /*  830856 */     GIR_EraseRootFromParent_Done,
     /*  830857 */   // Label 12816: @830857
     /*  830857 */   GIM_Try, /*On fail goto*//*Label 12817*/ GIMT_Encode4(830932), // Rule ID 22640 //
     /*  830862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  830879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  830897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830908 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  830911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830930 */     GIR_RootConstrainSelectedInstOperands,
     /*  830931 */     // GIR_Coverage, 22640,
     /*  830931 */     GIR_EraseRootFromParent_Done,
     /*  830932 */   // Label 12817: @830932
     /*  830932 */   GIM_Try, /*On fail goto*//*Label 12818*/ GIMT_Encode4(831007), // Rule ID 22641 //
     /*  830937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  830954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  830972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830983 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  830986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831005 */     GIR_RootConstrainSelectedInstOperands,
     /*  831006 */     // GIR_Coverage, 22641,
     /*  831006 */     GIR_EraseRootFromParent_Done,
     /*  831007 */   // Label 12818: @831007
     /*  831007 */   GIM_Try, /*On fail goto*//*Label 12819*/ GIMT_Encode4(831082), // Rule ID 22644 //
     /*  831012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  831058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  831061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831080 */     GIR_RootConstrainSelectedInstOperands,
     /*  831081 */     // GIR_Coverage, 22644,
     /*  831081 */     GIR_EraseRootFromParent_Done,
     /*  831082 */   // Label 12819: @831082
     /*  831082 */   GIM_Try, /*On fail goto*//*Label 12820*/ GIMT_Encode4(831157), // Rule ID 22645 //
     /*  831087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  831098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  831101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  831104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  831107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831133 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11499:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  831133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  831136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  831152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831155 */     GIR_RootConstrainSelectedInstOperands,
     /*  831156 */     // GIR_Coverage, 22645,
     /*  831156 */     GIR_EraseRootFromParent_Done,
     /*  831157 */   // Label 12820: @831157
     /*  831157 */   GIM_Try, /*On fail goto*//*Label 12821*/ GIMT_Encode4(831232), // Rule ID 22648 //
     /*  831162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  831211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831230 */     GIR_RootConstrainSelectedInstOperands,
     /*  831231 */     // GIR_Coverage, 22648,
     /*  831231 */     GIR_EraseRootFromParent_Done,
     /*  831232 */   // Label 12821: @831232
     /*  831232 */   GIM_Try, /*On fail goto*//*Label 12822*/ GIMT_Encode4(831307), // Rule ID 22649 //
     /*  831237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  831254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  831286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831305 */     GIR_RootConstrainSelectedInstOperands,
     /*  831306 */     // GIR_Coverage, 22649,
     /*  831306 */     GIR_EraseRootFromParent_Done,
     /*  831307 */   // Label 12822: @831307
     /*  831307 */   GIM_Try, /*On fail goto*//*Label 12823*/ GIMT_Encode4(831382), // Rule ID 22652 //
     /*  831312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831358 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  831361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831380 */     GIR_RootConstrainSelectedInstOperands,
     /*  831381 */     // GIR_Coverage, 22652,
     /*  831381 */     GIR_EraseRootFromParent_Done,
     /*  831382 */   // Label 12823: @831382
     /*  831382 */   GIM_Try, /*On fail goto*//*Label 12824*/ GIMT_Encode4(831457), // Rule ID 22653 //
     /*  831387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  831404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831433 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  831436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831455 */     GIR_RootConstrainSelectedInstOperands,
     /*  831456 */     // GIR_Coverage, 22653,
     /*  831456 */     GIR_EraseRootFromParent_Done,
     /*  831457 */   // Label 12824: @831457
     /*  831457 */   GIM_Try, /*On fail goto*//*Label 12825*/ GIMT_Encode4(831532), // Rule ID 22656 //
     /*  831462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  831479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  831511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831530 */     GIR_RootConstrainSelectedInstOperands,
     /*  831531 */     // GIR_Coverage, 22656,
     /*  831531 */     GIR_EraseRootFromParent_Done,
     /*  831532 */   // Label 12825: @831532
     /*  831532 */   GIM_Try, /*On fail goto*//*Label 12826*/ GIMT_Encode4(831607), // Rule ID 22657 //
     /*  831537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  831554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831583 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11499:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  831586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831605 */     GIR_RootConstrainSelectedInstOperands,
     /*  831606 */     // GIR_Coverage, 22657,
     /*  831606 */     GIR_EraseRootFromParent_Done,
     /*  831607 */   // Label 12826: @831607
     /*  831607 */   GIM_Try, /*On fail goto*//*Label 12827*/ GIMT_Encode4(831682), // Rule ID 22660 //
     /*  831612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  831629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  831661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831680 */     GIR_RootConstrainSelectedInstOperands,
     /*  831681 */     // GIR_Coverage, 22660,
     /*  831681 */     GIR_EraseRootFromParent_Done,
     /*  831682 */   // Label 12827: @831682
     /*  831682 */   GIM_Try, /*On fail goto*//*Label 12828*/ GIMT_Encode4(831757), // Rule ID 22661 //
     /*  831687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  831704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831733 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  831736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831755 */     GIR_RootConstrainSelectedInstOperands,
     /*  831756 */     // GIR_Coverage, 22661,
     /*  831756 */     GIR_EraseRootFromParent_Done,
     /*  831757 */   // Label 12828: @831757
     /*  831757 */   GIM_Try, /*On fail goto*//*Label 12829*/ GIMT_Encode4(831832), // Rule ID 22664 //
     /*  831762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  831779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  831811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831830 */     GIR_RootConstrainSelectedInstOperands,
     /*  831831 */     // GIR_Coverage, 22664,
     /*  831831 */     GIR_EraseRootFromParent_Done,
     /*  831832 */   // Label 12829: @831832
     /*  831832 */   GIM_Try, /*On fail goto*//*Label 12830*/ GIMT_Encode4(831907), // Rule ID 22665 //
     /*  831837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  831854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831883 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  831886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831905 */     GIR_RootConstrainSelectedInstOperands,
     /*  831906 */     // GIR_Coverage, 22665,
     /*  831906 */     GIR_EraseRootFromParent_Done,
     /*  831907 */   // Label 12830: @831907
     /*  831907 */   GIM_Try, /*On fail goto*//*Label 12831*/ GIMT_Encode4(831982), // Rule ID 22668 //
     /*  831912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  831929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  831961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831980 */     GIR_RootConstrainSelectedInstOperands,
     /*  831981 */     // GIR_Coverage, 22668,
     /*  831981 */     GIR_EraseRootFromParent_Done,
     /*  831982 */   // Label 12831: @831982
     /*  831982 */   GIM_Try, /*On fail goto*//*Label 12832*/ GIMT_Encode4(832057), // Rule ID 22669 //
     /*  831987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  832004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832033 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11499:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  832036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832055 */     GIR_RootConstrainSelectedInstOperands,
     /*  832056 */     // GIR_Coverage, 22669,
     /*  832056 */     GIR_EraseRootFromParent_Done,
     /*  832057 */   // Label 12832: @832057
     /*  832057 */   GIM_Try, /*On fail goto*//*Label 12833*/ GIMT_Encode4(832132), // Rule ID 22672 //
     /*  832062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  832111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832130 */     GIR_RootConstrainSelectedInstOperands,
     /*  832131 */     // GIR_Coverage, 22672,
     /*  832131 */     GIR_EraseRootFromParent_Done,
     /*  832132 */   // Label 12833: @832132
     /*  832132 */   GIM_Try, /*On fail goto*//*Label 12834*/ GIMT_Encode4(832207), // Rule ID 22673 //
     /*  832137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  832154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  832172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832183 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  832186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832205 */     GIR_RootConstrainSelectedInstOperands,
     /*  832206 */     // GIR_Coverage, 22673,
     /*  832206 */     GIR_EraseRootFromParent_Done,
     /*  832207 */   // Label 12834: @832207
     /*  832207 */   GIM_Try, /*On fail goto*//*Label 12835*/ GIMT_Encode4(832282), // Rule ID 22676 //
     /*  832212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832258 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  832261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832280 */     GIR_RootConstrainSelectedInstOperands,
     /*  832281 */     // GIR_Coverage, 22676,
     /*  832281 */     GIR_EraseRootFromParent_Done,
     /*  832282 */   // Label 12835: @832282
     /*  832282 */   GIM_Try, /*On fail goto*//*Label 12836*/ GIMT_Encode4(832357), // Rule ID 22677 //
     /*  832287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  832304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  832322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832333 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  832336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832355 */     GIR_RootConstrainSelectedInstOperands,
     /*  832356 */     // GIR_Coverage, 22677,
     /*  832356 */     GIR_EraseRootFromParent_Done,
     /*  832357 */   // Label 12836: @832357
     /*  832357 */   GIM_Try, /*On fail goto*//*Label 12837*/ GIMT_Encode4(832432), // Rule ID 22680 //
     /*  832362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  832365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  832408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  832411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832430 */     GIR_RootConstrainSelectedInstOperands,
     /*  832431 */     // GIR_Coverage, 22680,
     /*  832431 */     GIR_EraseRootFromParent_Done,
     /*  832432 */   // Label 12837: @832432
     /*  832432 */   GIM_Try, /*On fail goto*//*Label 12838*/ GIMT_Encode4(832507), // Rule ID 22681 //
     /*  832437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  832440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  832445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  832454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  832472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832483 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11499:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  832483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  832486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  832502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832505 */     GIR_RootConstrainSelectedInstOperands,
     /*  832506 */     // GIR_Coverage, 22681,
     /*  832506 */     GIR_EraseRootFromParent_Done,
     /*  832507 */   // Label 12838: @832507
     /*  832507 */   GIM_Try, /*On fail goto*//*Label 12839*/ GIMT_Encode4(832582), // Rule ID 22684 //
     /*  832512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  832529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  832561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832580 */     GIR_RootConstrainSelectedInstOperands,
     /*  832581 */     // GIR_Coverage, 22684,
     /*  832581 */     GIR_EraseRootFromParent_Done,
     /*  832582 */   // Label 12839: @832582
     /*  832582 */   GIM_Try, /*On fail goto*//*Label 12840*/ GIMT_Encode4(832657), // Rule ID 22685 //
     /*  832587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  832604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832633 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  832636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832655 */     GIR_RootConstrainSelectedInstOperands,
     /*  832656 */     // GIR_Coverage, 22685,
     /*  832656 */     GIR_EraseRootFromParent_Done,
     /*  832657 */   // Label 12840: @832657
     /*  832657 */   GIM_Try, /*On fail goto*//*Label 12841*/ GIMT_Encode4(832732), // Rule ID 22688 //
     /*  832662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  832679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  832711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832730 */     GIR_RootConstrainSelectedInstOperands,
     /*  832731 */     // GIR_Coverage, 22688,
     /*  832731 */     GIR_EraseRootFromParent_Done,
     /*  832732 */   // Label 12841: @832732
     /*  832732 */   GIM_Try, /*On fail goto*//*Label 12842*/ GIMT_Encode4(832807), // Rule ID 22689 //
     /*  832737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  832754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832783 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  832786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832805 */     GIR_RootConstrainSelectedInstOperands,
     /*  832806 */     // GIR_Coverage, 22689,
     /*  832806 */     GIR_EraseRootFromParent_Done,
     /*  832807 */   // Label 12842: @832807
     /*  832807 */   GIM_Try, /*On fail goto*//*Label 12843*/ GIMT_Encode4(832882), // Rule ID 22692 //
     /*  832812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  832829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  832861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832880 */     GIR_RootConstrainSelectedInstOperands,
     /*  832881 */     // GIR_Coverage, 22692,
     /*  832881 */     GIR_EraseRootFromParent_Done,
     /*  832882 */   // Label 12843: @832882
     /*  832882 */   GIM_Try, /*On fail goto*//*Label 12844*/ GIMT_Encode4(832957), // Rule ID 22693 //
     /*  832887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  832904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832933 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  832936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832955 */     GIR_RootConstrainSelectedInstOperands,
     /*  832956 */     // GIR_Coverage, 22693,
     /*  832956 */     GIR_EraseRootFromParent_Done,
     /*  832957 */   // Label 12844: @832957
     /*  832957 */   GIM_Try, /*On fail goto*//*Label 12845*/ GIMT_Encode4(833032), // Rule ID 22696 //
     /*  832962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  832979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  833011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833030 */     GIR_RootConstrainSelectedInstOperands,
     /*  833031 */     // GIR_Coverage, 22696,
     /*  833031 */     GIR_EraseRootFromParent_Done,
     /*  833032 */   // Label 12845: @833032
     /*  833032 */   GIM_Try, /*On fail goto*//*Label 12846*/ GIMT_Encode4(833107), // Rule ID 22697 //
     /*  833037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  833054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833083 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  833086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833105 */     GIR_RootConstrainSelectedInstOperands,
     /*  833106 */     // GIR_Coverage, 22697,
     /*  833106 */     GIR_EraseRootFromParent_Done,
     /*  833107 */   // Label 12846: @833107
     /*  833107 */   GIM_Try, /*On fail goto*//*Label 12847*/ GIMT_Encode4(833182), // Rule ID 22700 //
     /*  833112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833158 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  833161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833180 */     GIR_RootConstrainSelectedInstOperands,
     /*  833181 */     // GIR_Coverage, 22700,
     /*  833181 */     GIR_EraseRootFromParent_Done,
     /*  833182 */   // Label 12847: @833182
     /*  833182 */   GIM_Try, /*On fail goto*//*Label 12848*/ GIMT_Encode4(833257), // Rule ID 22701 //
     /*  833187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  833204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833233 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  833236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833255 */     GIR_RootConstrainSelectedInstOperands,
     /*  833256 */     // GIR_Coverage, 22701,
     /*  833256 */     GIR_EraseRootFromParent_Done,
     /*  833257 */   // Label 12848: @833257
     /*  833257 */   GIM_Try, /*On fail goto*//*Label 12849*/ GIMT_Encode4(833332), // Rule ID 22704 //
     /*  833262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  833311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833330 */     GIR_RootConstrainSelectedInstOperands,
     /*  833331 */     // GIR_Coverage, 22704,
     /*  833331 */     GIR_EraseRootFromParent_Done,
     /*  833332 */   // Label 12849: @833332
     /*  833332 */   GIM_Try, /*On fail goto*//*Label 12850*/ GIMT_Encode4(833407), // Rule ID 22705 //
     /*  833337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  833354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  833386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833405 */     GIR_RootConstrainSelectedInstOperands,
     /*  833406 */     // GIR_Coverage, 22705,
     /*  833406 */     GIR_EraseRootFromParent_Done,
     /*  833407 */   // Label 12850: @833407
     /*  833407 */   GIM_Try, /*On fail goto*//*Label 12851*/ GIMT_Encode4(833482), // Rule ID 22708 //
     /*  833412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833458 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  833461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833480 */     GIR_RootConstrainSelectedInstOperands,
     /*  833481 */     // GIR_Coverage, 22708,
     /*  833481 */     GIR_EraseRootFromParent_Done,
     /*  833482 */   // Label 12851: @833482
     /*  833482 */   GIM_Try, /*On fail goto*//*Label 12852*/ GIMT_Encode4(833557), // Rule ID 22709 //
     /*  833487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  833504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833533 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  833536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833555 */     GIR_RootConstrainSelectedInstOperands,
     /*  833556 */     // GIR_Coverage, 22709,
     /*  833556 */     GIR_EraseRootFromParent_Done,
     /*  833557 */   // Label 12852: @833557
     /*  833557 */   GIM_Try, /*On fail goto*//*Label 12853*/ GIMT_Encode4(833632), // Rule ID 22712 //
     /*  833562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  833579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833608 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  833611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833630 */     GIR_RootConstrainSelectedInstOperands,
     /*  833631 */     // GIR_Coverage, 22712,
     /*  833631 */     GIR_EraseRootFromParent_Done,
     /*  833632 */   // Label 12853: @833632
     /*  833632 */   GIM_Try, /*On fail goto*//*Label 12854*/ GIMT_Encode4(833707), // Rule ID 22713 //
     /*  833637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  833654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833683 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  833686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833705 */     GIR_RootConstrainSelectedInstOperands,
     /*  833706 */     // GIR_Coverage, 22713,
     /*  833706 */     GIR_EraseRootFromParent_Done,
     /*  833707 */   // Label 12854: @833707
     /*  833707 */   GIM_Try, /*On fail goto*//*Label 12855*/ GIMT_Encode4(833782), // Rule ID 22716 //
     /*  833712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  833729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  833761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833780 */     GIR_RootConstrainSelectedInstOperands,
     /*  833781 */     // GIR_Coverage, 22716,
     /*  833781 */     GIR_EraseRootFromParent_Done,
     /*  833782 */   // Label 12855: @833782
     /*  833782 */   GIM_Try, /*On fail goto*//*Label 12856*/ GIMT_Encode4(833857), // Rule ID 22717 //
     /*  833787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  833804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833833 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  833836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833855 */     GIR_RootConstrainSelectedInstOperands,
     /*  833856 */     // GIR_Coverage, 22717,
     /*  833856 */     GIR_EraseRootFromParent_Done,
     /*  833857 */   // Label 12856: @833857
     /*  833857 */   GIM_Try, /*On fail goto*//*Label 12857*/ GIMT_Encode4(833932), // Rule ID 22720 //
     /*  833862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  833879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  833897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  833911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833930 */     GIR_RootConstrainSelectedInstOperands,
     /*  833931 */     // GIR_Coverage, 22720,
     /*  833931 */     GIR_EraseRootFromParent_Done,
     /*  833932 */   // Label 12857: @833932
     /*  833932 */   GIM_Try, /*On fail goto*//*Label 12858*/ GIMT_Encode4(834007), // Rule ID 22721 //
     /*  833937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  833954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  833972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833983 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  833986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834005 */     GIR_RootConstrainSelectedInstOperands,
     /*  834006 */     // GIR_Coverage, 22721,
     /*  834006 */     GIR_EraseRootFromParent_Done,
     /*  834007 */   // Label 12858: @834007
     /*  834007 */   GIM_Try, /*On fail goto*//*Label 12859*/ GIMT_Encode4(834082), // Rule ID 22724 //
     /*  834012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  834061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834080 */     GIR_RootConstrainSelectedInstOperands,
     /*  834081 */     // GIR_Coverage, 22724,
     /*  834081 */     GIR_EraseRootFromParent_Done,
     /*  834082 */   // Label 12859: @834082
     /*  834082 */   GIM_Try, /*On fail goto*//*Label 12860*/ GIMT_Encode4(834157), // Rule ID 22725 //
     /*  834087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  834104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834133 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  834136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834155 */     GIR_RootConstrainSelectedInstOperands,
     /*  834156 */     // GIR_Coverage, 22725,
     /*  834156 */     GIR_EraseRootFromParent_Done,
     /*  834157 */   // Label 12860: @834157
     /*  834157 */   GIM_Try, /*On fail goto*//*Label 12861*/ GIMT_Encode4(834232), // Rule ID 22728 //
     /*  834162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  834211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834230 */     GIR_RootConstrainSelectedInstOperands,
     /*  834231 */     // GIR_Coverage, 22728,
     /*  834231 */     GIR_EraseRootFromParent_Done,
     /*  834232 */   // Label 12861: @834232
     /*  834232 */   GIM_Try, /*On fail goto*//*Label 12862*/ GIMT_Encode4(834307), // Rule ID 22729 //
     /*  834237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  834254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11663:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  834286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834305 */     GIR_RootConstrainSelectedInstOperands,
     /*  834306 */     // GIR_Coverage, 22729,
     /*  834306 */     GIR_EraseRootFromParent_Done,
     /*  834307 */   // Label 12862: @834307
     /*  834307 */   GIM_Try, /*On fail goto*//*Label 12863*/ GIMT_Encode4(834382), // Rule ID 22732 //
     /*  834312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  834361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834380 */     GIR_RootConstrainSelectedInstOperands,
     /*  834381 */     // GIR_Coverage, 22732,
     /*  834381 */     GIR_EraseRootFromParent_Done,
     /*  834382 */   // Label 12863: @834382
     /*  834382 */   GIM_Try, /*On fail goto*//*Label 12864*/ GIMT_Encode4(834457), // Rule ID 22733 //
     /*  834387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  834404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  834436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834455 */     GIR_RootConstrainSelectedInstOperands,
     /*  834456 */     // GIR_Coverage, 22733,
     /*  834456 */     GIR_EraseRootFromParent_Done,
     /*  834457 */   // Label 12864: @834457
     /*  834457 */   GIM_Try, /*On fail goto*//*Label 12865*/ GIMT_Encode4(834532), // Rule ID 22736 //
     /*  834462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  834479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  834511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834530 */     GIR_RootConstrainSelectedInstOperands,
     /*  834531 */     // GIR_Coverage, 22736,
     /*  834531 */     GIR_EraseRootFromParent_Done,
     /*  834532 */   // Label 12865: @834532
     /*  834532 */   GIM_Try, /*On fail goto*//*Label 12866*/ GIMT_Encode4(834607), // Rule ID 22737 //
     /*  834537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  834554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834583 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  834586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834605 */     GIR_RootConstrainSelectedInstOperands,
     /*  834606 */     // GIR_Coverage, 22737,
     /*  834606 */     GIR_EraseRootFromParent_Done,
     /*  834607 */   // Label 12866: @834607
     /*  834607 */   GIM_Try, /*On fail goto*//*Label 12867*/ GIMT_Encode4(834682), // Rule ID 22740 //
     /*  834612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  834629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  834661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834680 */     GIR_RootConstrainSelectedInstOperands,
     /*  834681 */     // GIR_Coverage, 22740,
     /*  834681 */     GIR_EraseRootFromParent_Done,
     /*  834682 */   // Label 12867: @834682
     /*  834682 */   GIM_Try, /*On fail goto*//*Label 12868*/ GIMT_Encode4(834757), // Rule ID 22741 //
     /*  834687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  834704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834733 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11663:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  834736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834755 */     GIR_RootConstrainSelectedInstOperands,
     /*  834756 */     // GIR_Coverage, 22741,
     /*  834756 */     GIR_EraseRootFromParent_Done,
     /*  834757 */   // Label 12868: @834757
     /*  834757 */   GIM_Try, /*On fail goto*//*Label 12869*/ GIMT_Encode4(834832), // Rule ID 22744 //
     /*  834762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  834779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  834811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834830 */     GIR_RootConstrainSelectedInstOperands,
     /*  834831 */     // GIR_Coverage, 22744,
     /*  834831 */     GIR_EraseRootFromParent_Done,
     /*  834832 */   // Label 12869: @834832
     /*  834832 */   GIM_Try, /*On fail goto*//*Label 12870*/ GIMT_Encode4(834907), // Rule ID 22745 //
     /*  834837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  834854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834883 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  834886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834905 */     GIR_RootConstrainSelectedInstOperands,
     /*  834906 */     // GIR_Coverage, 22745,
     /*  834906 */     GIR_EraseRootFromParent_Done,
     /*  834907 */   // Label 12870: @834907
     /*  834907 */   GIM_Try, /*On fail goto*//*Label 12871*/ GIMT_Encode4(834982), // Rule ID 22748 //
     /*  834912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  834929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  834961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834980 */     GIR_RootConstrainSelectedInstOperands,
     /*  834981 */     // GIR_Coverage, 22748,
     /*  834981 */     GIR_EraseRootFromParent_Done,
     /*  834982 */   // Label 12871: @834982
     /*  834982 */   GIM_Try, /*On fail goto*//*Label 12872*/ GIMT_Encode4(835057), // Rule ID 22749 //
     /*  834987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  835004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  835022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835033 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  835036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835055 */     GIR_RootConstrainSelectedInstOperands,
     /*  835056 */     // GIR_Coverage, 22749,
     /*  835056 */     GIR_EraseRootFromParent_Done,
     /*  835057 */   // Label 12872: @835057
     /*  835057 */   GIM_Try, /*On fail goto*//*Label 12873*/ GIMT_Encode4(835132), // Rule ID 22752 //
     /*  835062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  835111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835130 */     GIR_RootConstrainSelectedInstOperands,
     /*  835131 */     // GIR_Coverage, 22752,
     /*  835131 */     GIR_EraseRootFromParent_Done,
     /*  835132 */   // Label 12873: @835132
     /*  835132 */   GIM_Try, /*On fail goto*//*Label 12874*/ GIMT_Encode4(835207), // Rule ID 22753 //
     /*  835137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  835145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  835154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  835172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835183 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11663:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  835186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835205 */     GIR_RootConstrainSelectedInstOperands,
     /*  835206 */     // GIR_Coverage, 22753,
     /*  835206 */     GIR_EraseRootFromParent_Done,
     /*  835207 */   // Label 12874: @835207
     /*  835207 */   GIM_Try, /*On fail goto*//*Label 12875*/ GIMT_Encode4(835282), // Rule ID 22756 //
     /*  835212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  835229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  835261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835280 */     GIR_RootConstrainSelectedInstOperands,
     /*  835281 */     // GIR_Coverage, 22756,
     /*  835281 */     GIR_EraseRootFromParent_Done,
     /*  835282 */   // Label 12875: @835282
     /*  835282 */   GIM_Try, /*On fail goto*//*Label 12876*/ GIMT_Encode4(835357), // Rule ID 22757 //
     /*  835287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  835304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835333 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  835336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835355 */     GIR_RootConstrainSelectedInstOperands,
     /*  835356 */     // GIR_Coverage, 22757,
     /*  835356 */     GIR_EraseRootFromParent_Done,
     /*  835357 */   // Label 12876: @835357
     /*  835357 */   GIM_Try, /*On fail goto*//*Label 12877*/ GIMT_Encode4(835432), // Rule ID 22760 //
     /*  835362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  835379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835408 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  835411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835430 */     GIR_RootConstrainSelectedInstOperands,
     /*  835431 */     // GIR_Coverage, 22760,
     /*  835431 */     GIR_EraseRootFromParent_Done,
     /*  835432 */   // Label 12877: @835432
     /*  835432 */   GIM_Try, /*On fail goto*//*Label 12878*/ GIMT_Encode4(835507), // Rule ID 22761 //
     /*  835437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  835454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  835486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835505 */     GIR_RootConstrainSelectedInstOperands,
     /*  835506 */     // GIR_Coverage, 22761,
     /*  835506 */     GIR_EraseRootFromParent_Done,
     /*  835507 */   // Label 12878: @835507
     /*  835507 */   GIM_Try, /*On fail goto*//*Label 12879*/ GIMT_Encode4(835582), // Rule ID 22764 //
     /*  835512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  835529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  835561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835580 */     GIR_RootConstrainSelectedInstOperands,
     /*  835581 */     // GIR_Coverage, 22764,
     /*  835581 */     GIR_EraseRootFromParent_Done,
     /*  835582 */   // Label 12879: @835582
     /*  835582 */   GIM_Try, /*On fail goto*//*Label 12880*/ GIMT_Encode4(835657), // Rule ID 22765 //
     /*  835587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  835604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835633 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  835636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835655 */     GIR_RootConstrainSelectedInstOperands,
     /*  835656 */     // GIR_Coverage, 22765,
     /*  835656 */     GIR_EraseRootFromParent_Done,
     /*  835657 */   // Label 12880: @835657
     /*  835657 */   GIM_Try, /*On fail goto*//*Label 12881*/ GIMT_Encode4(835732), // Rule ID 22768 //
     /*  835662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  835679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  835711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835730 */     GIR_RootConstrainSelectedInstOperands,
     /*  835731 */     // GIR_Coverage, 22768,
     /*  835731 */     GIR_EraseRootFromParent_Done,
     /*  835732 */   // Label 12881: @835732
     /*  835732 */   GIM_Try, /*On fail goto*//*Label 12882*/ GIMT_Encode4(835807), // Rule ID 22769 //
     /*  835737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  835754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835783 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  835786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835805 */     GIR_RootConstrainSelectedInstOperands,
     /*  835806 */     // GIR_Coverage, 22769,
     /*  835806 */     GIR_EraseRootFromParent_Done,
     /*  835807 */   // Label 12882: @835807
     /*  835807 */   GIM_Try, /*On fail goto*//*Label 12883*/ GIMT_Encode4(835882), // Rule ID 22772 //
     /*  835812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  835829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  835861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835880 */     GIR_RootConstrainSelectedInstOperands,
     /*  835881 */     // GIR_Coverage, 22772,
     /*  835881 */     GIR_EraseRootFromParent_Done,
     /*  835882 */   // Label 12883: @835882
     /*  835882 */   GIM_Try, /*On fail goto*//*Label 12884*/ GIMT_Encode4(835957), // Rule ID 22773 //
     /*  835887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  835904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  835936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835955 */     GIR_RootConstrainSelectedInstOperands,
     /*  835956 */     // GIR_Coverage, 22773,
     /*  835956 */     GIR_EraseRootFromParent_Done,
     /*  835957 */   // Label 12884: @835957
     /*  835957 */   GIM_Try, /*On fail goto*//*Label 12885*/ GIMT_Encode4(836032), // Rule ID 22776 //
     /*  835962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  835979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  836008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  836011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836030 */     GIR_RootConstrainSelectedInstOperands,
     /*  836031 */     // GIR_Coverage, 22776,
     /*  836031 */     GIR_EraseRootFromParent_Done,
     /*  836032 */   // Label 12885: @836032
     /*  836032 */   GIM_Try, /*On fail goto*//*Label 12886*/ GIMT_Encode4(836107), // Rule ID 22777 //
     /*  836037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  836054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836083 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  836083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  836086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836105 */     GIR_RootConstrainSelectedInstOperands,
     /*  836106 */     // GIR_Coverage, 22777,
     /*  836106 */     GIR_EraseRootFromParent_Done,
     /*  836107 */   // Label 12886: @836107
     /*  836107 */   GIM_Try, /*On fail goto*//*Label 12887*/ GIMT_Encode4(836182), // Rule ID 22780 //
     /*  836112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  836129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  836161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836180 */     GIR_RootConstrainSelectedInstOperands,
     /*  836181 */     // GIR_Coverage, 22780,
     /*  836181 */     GIR_EraseRootFromParent_Done,
     /*  836182 */   // Label 12887: @836182
     /*  836182 */   GIM_Try, /*On fail goto*//*Label 12888*/ GIMT_Encode4(836257), // Rule ID 22781 //
     /*  836187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  836204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836233 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  836236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836255 */     GIR_RootConstrainSelectedInstOperands,
     /*  836256 */     // GIR_Coverage, 22781,
     /*  836256 */     GIR_EraseRootFromParent_Done,
     /*  836257 */   // Label 12888: @836257
     /*  836257 */   GIM_Try, /*On fail goto*//*Label 12889*/ GIMT_Encode4(836332), // Rule ID 22784 //
     /*  836262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  836279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  836311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836330 */     GIR_RootConstrainSelectedInstOperands,
     /*  836331 */     // GIR_Coverage, 22784,
     /*  836331 */     GIR_EraseRootFromParent_Done,
     /*  836332 */   // Label 12889: @836332
     /*  836332 */   GIM_Try, /*On fail goto*//*Label 12890*/ GIMT_Encode4(836407), // Rule ID 22785 //
     /*  836337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  836354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836383 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  836386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836405 */     GIR_RootConstrainSelectedInstOperands,
     /*  836406 */     // GIR_Coverage, 22785,
     /*  836406 */     GIR_EraseRootFromParent_Done,
     /*  836407 */   // Label 12890: @836407
     /*  836407 */   GIM_Try, /*On fail goto*//*Label 12891*/ GIMT_Encode4(836482), // Rule ID 22788 //
     /*  836412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  836429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  836458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  836461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836480 */     GIR_RootConstrainSelectedInstOperands,
     /*  836481 */     // GIR_Coverage, 22788,
     /*  836481 */     GIR_EraseRootFromParent_Done,
     /*  836482 */   // Label 12891: @836482
     /*  836482 */   GIM_Try, /*On fail goto*//*Label 12892*/ GIMT_Encode4(836557), // Rule ID 22789 //
     /*  836487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  836504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836533 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  836533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  836536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836555 */     GIR_RootConstrainSelectedInstOperands,
     /*  836556 */     // GIR_Coverage, 22789,
     /*  836556 */     GIR_EraseRootFromParent_Done,
     /*  836557 */   // Label 12892: @836557
     /*  836557 */   GIM_Try, /*On fail goto*//*Label 12893*/ GIMT_Encode4(836632), // Rule ID 22792 //
     /*  836562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  836579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  836611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836630 */     GIR_RootConstrainSelectedInstOperands,
     /*  836631 */     // GIR_Coverage, 22792,
     /*  836631 */     GIR_EraseRootFromParent_Done,
     /*  836632 */   // Label 12893: @836632
     /*  836632 */   GIM_Try, /*On fail goto*//*Label 12894*/ GIMT_Encode4(836707), // Rule ID 22793 //
     /*  836637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  836654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  836686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836705 */     GIR_RootConstrainSelectedInstOperands,
     /*  836706 */     // GIR_Coverage, 22793,
     /*  836706 */     GIR_EraseRootFromParent_Done,
     /*  836707 */   // Label 12894: @836707
     /*  836707 */   GIM_Try, /*On fail goto*//*Label 12895*/ GIMT_Encode4(836782), // Rule ID 22796 //
     /*  836712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  836729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836758 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  836761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836780 */     GIR_RootConstrainSelectedInstOperands,
     /*  836781 */     // GIR_Coverage, 22796,
     /*  836781 */     GIR_EraseRootFromParent_Done,
     /*  836782 */   // Label 12895: @836782
     /*  836782 */   GIM_Try, /*On fail goto*//*Label 12896*/ GIMT_Encode4(836857), // Rule ID 22797 //
     /*  836787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  836804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836833 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  836836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836855 */     GIR_RootConstrainSelectedInstOperands,
     /*  836856 */     // GIR_Coverage, 22797,
     /*  836856 */     GIR_EraseRootFromParent_Done,
     /*  836857 */   // Label 12896: @836857
     /*  836857 */   GIM_Try, /*On fail goto*//*Label 12897*/ GIMT_Encode4(836932), // Rule ID 22800 //
     /*  836862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  836879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  836911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836930 */     GIR_RootConstrainSelectedInstOperands,
     /*  836931 */     // GIR_Coverage, 22800,
     /*  836931 */     GIR_EraseRootFromParent_Done,
     /*  836932 */   // Label 12897: @836932
     /*  836932 */   GIM_Try, /*On fail goto*//*Label 12898*/ GIMT_Encode4(837007), // Rule ID 22801 //
     /*  836937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  836954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836983 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11661:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  836986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  837002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837005 */     GIR_RootConstrainSelectedInstOperands,
     /*  837006 */     // GIR_Coverage, 22801,
     /*  837006 */     GIR_EraseRootFromParent_Done,
     /*  837007 */   // Label 12898: @837007
     /*  837007 */   GIM_Try, /*On fail goto*//*Label 12899*/ GIMT_Encode4(837082), // Rule ID 22804 //
     /*  837012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  837029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  837061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837080 */     GIR_RootConstrainSelectedInstOperands,
     /*  837081 */     // GIR_Coverage, 22804,
     /*  837081 */     GIR_EraseRootFromParent_Done,
     /*  837082 */   // Label 12899: @837082
     /*  837082 */   GIM_Try, /*On fail goto*//*Label 12900*/ GIMT_Encode4(837157), // Rule ID 22805 //
     /*  837087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  837104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837133 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  837136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837155 */     GIR_RootConstrainSelectedInstOperands,
     /*  837156 */     // GIR_Coverage, 22805,
     /*  837156 */     GIR_EraseRootFromParent_Done,
     /*  837157 */   // Label 12900: @837157
     /*  837157 */   GIM_Try, /*On fail goto*//*Label 12901*/ GIMT_Encode4(837232), // Rule ID 22808 //
     /*  837162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  837179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  837211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837230 */     GIR_RootConstrainSelectedInstOperands,
     /*  837231 */     // GIR_Coverage, 22808,
     /*  837231 */     GIR_EraseRootFromParent_Done,
     /*  837232 */   // Label 12901: @837232
     /*  837232 */   GIM_Try, /*On fail goto*//*Label 12902*/ GIMT_Encode4(837307), // Rule ID 22809 //
     /*  837237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  837254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837283 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  837286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837305 */     GIR_RootConstrainSelectedInstOperands,
     /*  837306 */     // GIR_Coverage, 22809,
     /*  837306 */     GIR_EraseRootFromParent_Done,
     /*  837307 */   // Label 12902: @837307
     /*  837307 */   GIM_Try, /*On fail goto*//*Label 12903*/ GIMT_Encode4(837382), // Rule ID 22812 //
     /*  837312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  837329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  837361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837380 */     GIR_RootConstrainSelectedInstOperands,
     /*  837381 */     // GIR_Coverage, 22812,
     /*  837381 */     GIR_EraseRootFromParent_Done,
     /*  837382 */   // Label 12903: @837382
     /*  837382 */   GIM_Try, /*On fail goto*//*Label 12904*/ GIMT_Encode4(837457), // Rule ID 22813 //
     /*  837387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  837404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11661:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  837436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837455 */     GIR_RootConstrainSelectedInstOperands,
     /*  837456 */     // GIR_Coverage, 22813,
     /*  837456 */     GIR_EraseRootFromParent_Done,
     /*  837457 */   // Label 12904: @837457
     /*  837457 */   GIM_Try, /*On fail goto*//*Label 12905*/ GIMT_Encode4(837532), // Rule ID 22816 //
     /*  837462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  837479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  837511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837530 */     GIR_RootConstrainSelectedInstOperands,
     /*  837531 */     // GIR_Coverage, 22816,
     /*  837531 */     GIR_EraseRootFromParent_Done,
     /*  837532 */   // Label 12905: @837532
     /*  837532 */   GIM_Try, /*On fail goto*//*Label 12906*/ GIMT_Encode4(837607), // Rule ID 22817 //
     /*  837537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  837554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837583 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  837586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837605 */     GIR_RootConstrainSelectedInstOperands,
     /*  837606 */     // GIR_Coverage, 22817,
     /*  837606 */     GIR_EraseRootFromParent_Done,
     /*  837607 */   // Label 12906: @837607
     /*  837607 */   GIM_Try, /*On fail goto*//*Label 12907*/ GIMT_Encode4(837682), // Rule ID 22820 //
     /*  837612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  837629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  837661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837680 */     GIR_RootConstrainSelectedInstOperands,
     /*  837681 */     // GIR_Coverage, 22820,
     /*  837681 */     GIR_EraseRootFromParent_Done,
     /*  837682 */   // Label 12907: @837682
     /*  837682 */   GIM_Try, /*On fail goto*//*Label 12908*/ GIMT_Encode4(837757), // Rule ID 22821 //
     /*  837687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  837704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837733 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  837736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837755 */     GIR_RootConstrainSelectedInstOperands,
     /*  837756 */     // GIR_Coverage, 22821,
     /*  837756 */     GIR_EraseRootFromParent_Done,
     /*  837757 */   // Label 12908: @837757
     /*  837757 */   GIM_Try, /*On fail goto*//*Label 12909*/ GIMT_Encode4(837832), // Rule ID 22824 //
     /*  837762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  837779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  837811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837830 */     GIR_RootConstrainSelectedInstOperands,
     /*  837831 */     // GIR_Coverage, 22824,
     /*  837831 */     GIR_EraseRootFromParent_Done,
     /*  837832 */   // Label 12909: @837832
     /*  837832 */   GIM_Try, /*On fail goto*//*Label 12910*/ GIMT_Encode4(837907), // Rule ID 22825 //
     /*  837837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  837854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837883 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11661:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  837886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837905 */     GIR_RootConstrainSelectedInstOperands,
     /*  837906 */     // GIR_Coverage, 22825,
     /*  837906 */     GIR_EraseRootFromParent_Done,
     /*  837907 */   // Label 12910: @837907
     /*  837907 */   GIM_Try, /*On fail goto*//*Label 12911*/ GIMT_Encode4(837982), // Rule ID 22944 //
     /*  837912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  837915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  837929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837958 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  837961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837980 */     GIR_RootConstrainSelectedInstOperands,
     /*  837981 */     // GIR_Coverage, 22944,
     /*  837981 */     GIR_EraseRootFromParent_Done,
     /*  837982 */   // Label 12911: @837982
     /*  837982 */   GIM_Try, /*On fail goto*//*Label 12912*/ GIMT_Encode4(838057), // Rule ID 22945 //
     /*  837987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  837990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  838004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838033 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  838036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838055 */     GIR_RootConstrainSelectedInstOperands,
     /*  838056 */     // GIR_Coverage, 22945,
     /*  838056 */     GIR_EraseRootFromParent_Done,
     /*  838057 */   // Label 12912: @838057
     /*  838057 */   GIM_Try, /*On fail goto*//*Label 12913*/ GIMT_Encode4(838132), // Rule ID 22948 //
     /*  838062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  838079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838108 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  838111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838130 */     GIR_RootConstrainSelectedInstOperands,
     /*  838131 */     // GIR_Coverage, 22948,
     /*  838131 */     GIR_EraseRootFromParent_Done,
     /*  838132 */   // Label 12913: @838132
     /*  838132 */   GIM_Try, /*On fail goto*//*Label 12914*/ GIMT_Encode4(838207), // Rule ID 22949 //
     /*  838137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  838154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838183 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  838186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838205 */     GIR_RootConstrainSelectedInstOperands,
     /*  838206 */     // GIR_Coverage, 22949,
     /*  838206 */     GIR_EraseRootFromParent_Done,
     /*  838207 */   // Label 12914: @838207
     /*  838207 */   GIM_Try, /*On fail goto*//*Label 12915*/ GIMT_Encode4(838282), // Rule ID 22952 //
     /*  838212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  838229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838258 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  838261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838280 */     GIR_RootConstrainSelectedInstOperands,
     /*  838281 */     // GIR_Coverage, 22952,
     /*  838281 */     GIR_EraseRootFromParent_Done,
     /*  838282 */   // Label 12915: @838282
     /*  838282 */   GIM_Try, /*On fail goto*//*Label 12916*/ GIMT_Encode4(838357), // Rule ID 22953 //
     /*  838287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  838290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  838304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838333 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  838336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838355 */     GIR_RootConstrainSelectedInstOperands,
     /*  838356 */     // GIR_Coverage, 22953,
     /*  838356 */     GIR_EraseRootFromParent_Done,
     /*  838357 */   // Label 12916: @838357
     /*  838357 */   GIM_Try, /*On fail goto*//*Label 12917*/ GIMT_Encode4(838432), // Rule ID 22956 //
     /*  838362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  838379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838408 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  838411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838430 */     GIR_RootConstrainSelectedInstOperands,
     /*  838431 */     // GIR_Coverage, 22956,
     /*  838431 */     GIR_EraseRootFromParent_Done,
     /*  838432 */   // Label 12917: @838432
     /*  838432 */   GIM_Try, /*On fail goto*//*Label 12918*/ GIMT_Encode4(838507), // Rule ID 22957 //
     /*  838437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  838454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838483 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  838486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838505 */     GIR_RootConstrainSelectedInstOperands,
     /*  838506 */     // GIR_Coverage, 22957,
     /*  838506 */     GIR_EraseRootFromParent_Done,
     /*  838507 */   // Label 12918: @838507
     /*  838507 */   GIM_Try, /*On fail goto*//*Label 12919*/ GIMT_Encode4(838582), // Rule ID 22960 //
     /*  838512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  838529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838558 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  838561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838580 */     GIR_RootConstrainSelectedInstOperands,
     /*  838581 */     // GIR_Coverage, 22960,
     /*  838581 */     GIR_EraseRootFromParent_Done,
     /*  838582 */   // Label 12919: @838582
     /*  838582 */   GIM_Try, /*On fail goto*//*Label 12920*/ GIMT_Encode4(838657), // Rule ID 22961 //
     /*  838587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  838590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  838604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838633 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  838636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838655 */     GIR_RootConstrainSelectedInstOperands,
     /*  838656 */     // GIR_Coverage, 22961,
     /*  838656 */     GIR_EraseRootFromParent_Done,
     /*  838657 */   // Label 12920: @838657
     /*  838657 */   GIM_Try, /*On fail goto*//*Label 12921*/ GIMT_Encode4(838732), // Rule ID 22964 //
     /*  838662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  838665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  838679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838708 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  838708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  838711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  838727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838730 */     GIR_RootConstrainSelectedInstOperands,
     /*  838731 */     // GIR_Coverage, 22964,
     /*  838731 */     GIR_EraseRootFromParent_Done,
     /*  838732 */   // Label 12921: @838732
     /*  838732 */   GIM_Try, /*On fail goto*//*Label 12922*/ GIMT_Encode4(838807), // Rule ID 22965 //
     /*  838737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  838740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  838754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838783 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  838783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  838786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  838802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838805 */     GIR_RootConstrainSelectedInstOperands,
     /*  838806 */     // GIR_Coverage, 22965,
     /*  838806 */     GIR_EraseRootFromParent_Done,
     /*  838807 */   // Label 12922: @838807
     /*  838807 */   GIM_Try, /*On fail goto*//*Label 12923*/ GIMT_Encode4(838882), // Rule ID 22968 //
     /*  838812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838858 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  838861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838880 */     GIR_RootConstrainSelectedInstOperands,
     /*  838881 */     // GIR_Coverage, 22968,
     /*  838881 */     GIR_EraseRootFromParent_Done,
     /*  838882 */   // Label 12923: @838882
     /*  838882 */   GIM_Try, /*On fail goto*//*Label 12924*/ GIMT_Encode4(838957), // Rule ID 22969 //
     /*  838887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838933 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  838936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838955 */     GIR_RootConstrainSelectedInstOperands,
     /*  838956 */     // GIR_Coverage, 22969,
     /*  838956 */     GIR_EraseRootFromParent_Done,
     /*  838957 */   // Label 12924: @838957
     /*  838957 */   GIM_Try, /*On fail goto*//*Label 12925*/ GIMT_Encode4(839032), // Rule ID 22972 //
     /*  838962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  838979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  839011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839030 */     GIR_RootConstrainSelectedInstOperands,
     /*  839031 */     // GIR_Coverage, 22972,
     /*  839031 */     GIR_EraseRootFromParent_Done,
     /*  839032 */   // Label 12925: @839032
     /*  839032 */   GIM_Try, /*On fail goto*//*Label 12926*/ GIMT_Encode4(839107), // Rule ID 22973 //
     /*  839037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  839054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839083 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  839086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839105 */     GIR_RootConstrainSelectedInstOperands,
     /*  839106 */     // GIR_Coverage, 22973,
     /*  839106 */     GIR_EraseRootFromParent_Done,
     /*  839107 */   // Label 12926: @839107
     /*  839107 */   GIM_Try, /*On fail goto*//*Label 12927*/ GIMT_Encode4(839182), // Rule ID 22976 //
     /*  839112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839158 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  839161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839180 */     GIR_RootConstrainSelectedInstOperands,
     /*  839181 */     // GIR_Coverage, 22976,
     /*  839181 */     GIR_EraseRootFromParent_Done,
     /*  839182 */   // Label 12927: @839182
     /*  839182 */   GIM_Try, /*On fail goto*//*Label 12928*/ GIMT_Encode4(839257), // Rule ID 22977 //
     /*  839187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  839204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839233 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  839236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839255 */     GIR_RootConstrainSelectedInstOperands,
     /*  839256 */     // GIR_Coverage, 22977,
     /*  839256 */     GIR_EraseRootFromParent_Done,
     /*  839257 */   // Label 12928: @839257
     /*  839257 */   GIM_Try, /*On fail goto*//*Label 12929*/ GIMT_Encode4(839332), // Rule ID 22980 //
     /*  839262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839308 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  839311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839330 */     GIR_RootConstrainSelectedInstOperands,
     /*  839331 */     // GIR_Coverage, 22980,
     /*  839331 */     GIR_EraseRootFromParent_Done,
     /*  839332 */   // Label 12929: @839332
     /*  839332 */   GIM_Try, /*On fail goto*//*Label 12930*/ GIMT_Encode4(839407), // Rule ID 22981 //
     /*  839337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  839354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839383 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  839386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839405 */     GIR_RootConstrainSelectedInstOperands,
     /*  839406 */     // GIR_Coverage, 22981,
     /*  839406 */     GIR_EraseRootFromParent_Done,
     /*  839407 */   // Label 12930: @839407
     /*  839407 */   GIM_Try, /*On fail goto*//*Label 12931*/ GIMT_Encode4(839482), // Rule ID 22984 //
     /*  839412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839458 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  839461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839480 */     GIR_RootConstrainSelectedInstOperands,
     /*  839481 */     // GIR_Coverage, 22984,
     /*  839481 */     GIR_EraseRootFromParent_Done,
     /*  839482 */   // Label 12931: @839482
     /*  839482 */   GIM_Try, /*On fail goto*//*Label 12932*/ GIMT_Encode4(839557), // Rule ID 22985 //
     /*  839487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  839504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839533 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  839536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839555 */     GIR_RootConstrainSelectedInstOperands,
     /*  839556 */     // GIR_Coverage, 22985,
     /*  839556 */     GIR_EraseRootFromParent_Done,
     /*  839557 */   // Label 12932: @839557
     /*  839557 */   GIM_Try, /*On fail goto*//*Label 12933*/ GIMT_Encode4(839632), // Rule ID 22988 //
     /*  839562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  839579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839608 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  839611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839630 */     GIR_RootConstrainSelectedInstOperands,
     /*  839631 */     // GIR_Coverage, 22988,
     /*  839631 */     GIR_EraseRootFromParent_Done,
     /*  839632 */   // Label 12933: @839632
     /*  839632 */   GIM_Try, /*On fail goto*//*Label 12934*/ GIMT_Encode4(839707), // Rule ID 22989 //
     /*  839637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  839654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839683 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  839686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839705 */     GIR_RootConstrainSelectedInstOperands,
     /*  839706 */     // GIR_Coverage, 22989,
     /*  839706 */     GIR_EraseRootFromParent_Done,
     /*  839707 */   // Label 12934: @839707
     /*  839707 */   GIM_Try, /*On fail goto*//*Label 12935*/ GIMT_Encode4(839782), // Rule ID 22992 //
     /*  839712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  839715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  839729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839758 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  839758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  839761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839780 */     GIR_RootConstrainSelectedInstOperands,
     /*  839781 */     // GIR_Coverage, 22992,
     /*  839781 */     GIR_EraseRootFromParent_Done,
     /*  839782 */   // Label 12935: @839782
     /*  839782 */   GIM_Try, /*On fail goto*//*Label 12936*/ GIMT_Encode4(839857), // Rule ID 22993 //
     /*  839787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  839790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  839804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839833 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  839833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  839836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839855 */     GIR_RootConstrainSelectedInstOperands,
     /*  839856 */     // GIR_Coverage, 22993,
     /*  839856 */     GIR_EraseRootFromParent_Done,
     /*  839857 */   // Label 12936: @839857
     /*  839857 */   GIM_Try, /*On fail goto*//*Label 12937*/ GIMT_Encode4(839932), // Rule ID 22996 //
     /*  839862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  839865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  839879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839908 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  839908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  839911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839930 */     GIR_RootConstrainSelectedInstOperands,
     /*  839931 */     // GIR_Coverage, 22996,
     /*  839931 */     GIR_EraseRootFromParent_Done,
     /*  839932 */   // Label 12937: @839932
     /*  839932 */   GIM_Try, /*On fail goto*//*Label 12938*/ GIMT_Encode4(840007), // Rule ID 22997 //
     /*  839937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  839940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  839954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839983 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  839983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  839986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840005 */     GIR_RootConstrainSelectedInstOperands,
     /*  840006 */     // GIR_Coverage, 22997,
     /*  840006 */     GIR_EraseRootFromParent_Done,
     /*  840007 */   // Label 12938: @840007
     /*  840007 */   GIM_Try, /*On fail goto*//*Label 12939*/ GIMT_Encode4(840082), // Rule ID 23000 //
     /*  840012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  840061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840080 */     GIR_RootConstrainSelectedInstOperands,
     /*  840081 */     // GIR_Coverage, 23000,
     /*  840081 */     GIR_EraseRootFromParent_Done,
     /*  840082 */   // Label 12939: @840082
     /*  840082 */   GIM_Try, /*On fail goto*//*Label 12940*/ GIMT_Encode4(840157), // Rule ID 23001 //
     /*  840087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  840095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  840104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840133 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  840136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840155 */     GIR_RootConstrainSelectedInstOperands,
     /*  840156 */     // GIR_Coverage, 23001,
     /*  840156 */     GIR_EraseRootFromParent_Done,
     /*  840157 */   // Label 12940: @840157
     /*  840157 */   GIM_Try, /*On fail goto*//*Label 12941*/ GIMT_Encode4(840232), // Rule ID 23004 //
     /*  840162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840208 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  840211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840230 */     GIR_RootConstrainSelectedInstOperands,
     /*  840231 */     // GIR_Coverage, 23004,
     /*  840231 */     GIR_EraseRootFromParent_Done,
     /*  840232 */   // Label 12941: @840232
     /*  840232 */   GIM_Try, /*On fail goto*//*Label 12942*/ GIMT_Encode4(840307), // Rule ID 23005 //
     /*  840237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  840254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840283 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  840286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840305 */     GIR_RootConstrainSelectedInstOperands,
     /*  840306 */     // GIR_Coverage, 23005,
     /*  840306 */     GIR_EraseRootFromParent_Done,
     /*  840307 */   // Label 12942: @840307
     /*  840307 */   GIM_Try, /*On fail goto*//*Label 12943*/ GIMT_Encode4(840382), // Rule ID 23008 //
     /*  840312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840358 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  840361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840380 */     GIR_RootConstrainSelectedInstOperands,
     /*  840381 */     // GIR_Coverage, 23008,
     /*  840381 */     GIR_EraseRootFromParent_Done,
     /*  840382 */   // Label 12943: @840382
     /*  840382 */   GIM_Try, /*On fail goto*//*Label 12944*/ GIMT_Encode4(840457), // Rule ID 23009 //
     /*  840387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  840404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840433 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  840436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840455 */     GIR_RootConstrainSelectedInstOperands,
     /*  840456 */     // GIR_Coverage, 23009,
     /*  840456 */     GIR_EraseRootFromParent_Done,
     /*  840457 */   // Label 12944: @840457
     /*  840457 */   GIM_Try, /*On fail goto*//*Label 12945*/ GIMT_Encode4(840532), // Rule ID 23012 //
     /*  840462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  840465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  840479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840508 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  840511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840530 */     GIR_RootConstrainSelectedInstOperands,
     /*  840531 */     // GIR_Coverage, 23012,
     /*  840531 */     GIR_EraseRootFromParent_Done,
     /*  840532 */   // Label 12945: @840532
     /*  840532 */   GIM_Try, /*On fail goto*//*Label 12946*/ GIMT_Encode4(840607), // Rule ID 23013 //
     /*  840537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  840540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  840554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840583 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  840586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840605 */     GIR_RootConstrainSelectedInstOperands,
     /*  840606 */     // GIR_Coverage, 23013,
     /*  840606 */     GIR_EraseRootFromParent_Done,
     /*  840607 */   // Label 12946: @840607
     /*  840607 */   GIM_Try, /*On fail goto*//*Label 12947*/ GIMT_Encode4(840682), // Rule ID 23016 //
     /*  840612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840658 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  840661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840680 */     GIR_RootConstrainSelectedInstOperands,
     /*  840681 */     // GIR_Coverage, 23016,
     /*  840681 */     GIR_EraseRootFromParent_Done,
     /*  840682 */   // Label 12947: @840682
     /*  840682 */   GIM_Try, /*On fail goto*//*Label 12948*/ GIMT_Encode4(840757), // Rule ID 23017 //
     /*  840687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840733 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  840736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840755 */     GIR_RootConstrainSelectedInstOperands,
     /*  840756 */     // GIR_Coverage, 23017,
     /*  840756 */     GIR_EraseRootFromParent_Done,
     /*  840757 */   // Label 12948: @840757
     /*  840757 */   GIM_Try, /*On fail goto*//*Label 12949*/ GIMT_Encode4(840832), // Rule ID 23020 //
     /*  840762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  840765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840808 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  840811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840830 */     GIR_RootConstrainSelectedInstOperands,
     /*  840831 */     // GIR_Coverage, 23020,
     /*  840831 */     GIR_EraseRootFromParent_Done,
     /*  840832 */   // Label 12949: @840832
     /*  840832 */   GIM_Try, /*On fail goto*//*Label 12950*/ GIMT_Encode4(840907), // Rule ID 23021 //
     /*  840837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  840840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840883 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  840886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840905 */     GIR_RootConstrainSelectedInstOperands,
     /*  840906 */     // GIR_Coverage, 23021,
     /*  840906 */     GIR_EraseRootFromParent_Done,
     /*  840907 */   // Label 12950: @840907
     /*  840907 */   GIM_Try, /*On fail goto*//*Label 12951*/ GIMT_Encode4(840982), // Rule ID 23024 //
     /*  840912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  840929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840958 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  840961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840980 */     GIR_RootConstrainSelectedInstOperands,
     /*  840981 */     // GIR_Coverage, 23024,
     /*  840981 */     GIR_EraseRootFromParent_Done,
     /*  840982 */   // Label 12951: @840982
     /*  840982 */   GIM_Try, /*On fail goto*//*Label 12952*/ GIMT_Encode4(841057), // Rule ID 23025 //
     /*  840987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  841004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841033 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  841033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  841036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841055 */     GIR_RootConstrainSelectedInstOperands,
     /*  841056 */     // GIR_Coverage, 23025,
     /*  841056 */     GIR_EraseRootFromParent_Done,
     /*  841057 */   // Label 12952: @841057
     /*  841057 */   GIM_Try, /*On fail goto*//*Label 12953*/ GIMT_Encode4(841132), // Rule ID 23028 //
     /*  841062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841108 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  841111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841130 */     GIR_RootConstrainSelectedInstOperands,
     /*  841131 */     // GIR_Coverage, 23028,
     /*  841131 */     GIR_EraseRootFromParent_Done,
     /*  841132 */   // Label 12953: @841132
     /*  841132 */   GIM_Try, /*On fail goto*//*Label 12954*/ GIMT_Encode4(841207), // Rule ID 23029 //
     /*  841137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  841154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841183 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  841186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841205 */     GIR_RootConstrainSelectedInstOperands,
     /*  841206 */     // GIR_Coverage, 23029,
     /*  841206 */     GIR_EraseRootFromParent_Done,
     /*  841207 */   // Label 12954: @841207
     /*  841207 */   GIM_Try, /*On fail goto*//*Label 12955*/ GIMT_Encode4(841282), // Rule ID 23032 //
     /*  841212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841258 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  841261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841280 */     GIR_RootConstrainSelectedInstOperands,
     /*  841281 */     // GIR_Coverage, 23032,
     /*  841281 */     GIR_EraseRootFromParent_Done,
     /*  841282 */   // Label 12955: @841282
     /*  841282 */   GIM_Try, /*On fail goto*//*Label 12956*/ GIMT_Encode4(841357), // Rule ID 23033 //
     /*  841287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  841304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841333 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  841336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841355 */     GIR_RootConstrainSelectedInstOperands,
     /*  841356 */     // GIR_Coverage, 23033,
     /*  841356 */     GIR_EraseRootFromParent_Done,
     /*  841357 */   // Label 12956: @841357
     /*  841357 */   GIM_Try, /*On fail goto*//*Label 12957*/ GIMT_Encode4(841432), // Rule ID 23036 //
     /*  841362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  841365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841408 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  841408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  841411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841430 */     GIR_RootConstrainSelectedInstOperands,
     /*  841431 */     // GIR_Coverage, 23036,
     /*  841431 */     GIR_EraseRootFromParent_Done,
     /*  841432 */   // Label 12957: @841432
     /*  841432 */   GIM_Try, /*On fail goto*//*Label 12958*/ GIMT_Encode4(841507), // Rule ID 23037 //
     /*  841437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  841440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  841448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  841451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  841454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  841457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841483 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  841483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  841486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  841502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841505 */     GIR_RootConstrainSelectedInstOperands,
     /*  841506 */     // GIR_Coverage, 23037,
     /*  841506 */     GIR_EraseRootFromParent_Done,
     /*  841507 */   // Label 12958: @841507
     /*  841507 */   GIM_Try, /*On fail goto*//*Label 12959*/ GIMT_Encode4(841582), // Rule ID 23040 //
     /*  841512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841558 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  841561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841580 */     GIR_RootConstrainSelectedInstOperands,
     /*  841581 */     // GIR_Coverage, 23040,
     /*  841581 */     GIR_EraseRootFromParent_Done,
     /*  841582 */   // Label 12959: @841582
     /*  841582 */   GIM_Try, /*On fail goto*//*Label 12960*/ GIMT_Encode4(841657), // Rule ID 23041 //
     /*  841587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841633 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  841636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841655 */     GIR_RootConstrainSelectedInstOperands,
     /*  841656 */     // GIR_Coverage, 23041,
     /*  841656 */     GIR_EraseRootFromParent_Done,
     /*  841657 */   // Label 12960: @841657
     /*  841657 */   GIM_Try, /*On fail goto*//*Label 12961*/ GIMT_Encode4(841732), // Rule ID 23044 //
     /*  841662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841708 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  841711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841730 */     GIR_RootConstrainSelectedInstOperands,
     /*  841731 */     // GIR_Coverage, 23044,
     /*  841731 */     GIR_EraseRootFromParent_Done,
     /*  841732 */   // Label 12961: @841732
     /*  841732 */   GIM_Try, /*On fail goto*//*Label 12962*/ GIMT_Encode4(841807), // Rule ID 23045 //
     /*  841737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841783 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  841786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841805 */     GIR_RootConstrainSelectedInstOperands,
     /*  841806 */     // GIR_Coverage, 23045,
     /*  841806 */     GIR_EraseRootFromParent_Done,
     /*  841807 */   // Label 12962: @841807
     /*  841807 */   GIM_Try, /*On fail goto*//*Label 12963*/ GIMT_Encode4(841882), // Rule ID 23048 //
     /*  841812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841858 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  841861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841880 */     GIR_RootConstrainSelectedInstOperands,
     /*  841881 */     // GIR_Coverage, 23048,
     /*  841881 */     GIR_EraseRootFromParent_Done,
     /*  841882 */   // Label 12963: @841882
     /*  841882 */   GIM_Try, /*On fail goto*//*Label 12964*/ GIMT_Encode4(841957), // Rule ID 23049 //
     /*  841887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841933 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  841936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841955 */     GIR_RootConstrainSelectedInstOperands,
     /*  841956 */     // GIR_Coverage, 23049,
     /*  841956 */     GIR_EraseRootFromParent_Done,
     /*  841957 */   // Label 12964: @841957
     /*  841957 */   GIM_Try, /*On fail goto*//*Label 12965*/ GIMT_Encode4(842032), // Rule ID 23052 //
     /*  841962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  841965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  841979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842008 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  842011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842030 */     GIR_RootConstrainSelectedInstOperands,
     /*  842031 */     // GIR_Coverage, 23052,
     /*  842031 */     GIR_EraseRootFromParent_Done,
     /*  842032 */   // Label 12965: @842032
     /*  842032 */   GIM_Try, /*On fail goto*//*Label 12966*/ GIMT_Encode4(842107), // Rule ID 23053 //
     /*  842037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  842054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  842072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842083 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  842086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842105 */     GIR_RootConstrainSelectedInstOperands,
     /*  842106 */     // GIR_Coverage, 23053,
     /*  842106 */     GIR_EraseRootFromParent_Done,
     /*  842107 */   // Label 12966: @842107
     /*  842107 */   GIM_Try, /*On fail goto*//*Label 12967*/ GIMT_Encode4(842182), // Rule ID 23056 //
     /*  842112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  842129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842158 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  842161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842180 */     GIR_RootConstrainSelectedInstOperands,
     /*  842181 */     // GIR_Coverage, 23056,
     /*  842181 */     GIR_EraseRootFromParent_Done,
     /*  842182 */   // Label 12967: @842182
     /*  842182 */   GIM_Try, /*On fail goto*//*Label 12968*/ GIMT_Encode4(842257), // Rule ID 23057 //
     /*  842187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  842204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  842222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842233 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  842236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842255 */     GIR_RootConstrainSelectedInstOperands,
     /*  842256 */     // GIR_Coverage, 23057,
     /*  842256 */     GIR_EraseRootFromParent_Done,
     /*  842257 */   // Label 12968: @842257
     /*  842257 */   GIM_Try, /*On fail goto*//*Label 12969*/ GIMT_Encode4(842332), // Rule ID 23060 //
     /*  842262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  842265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  842279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842308 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  842308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  842311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842330 */     GIR_RootConstrainSelectedInstOperands,
     /*  842331 */     // GIR_Coverage, 23060,
     /*  842331 */     GIR_EraseRootFromParent_Done,
     /*  842332 */   // Label 12969: @842332
     /*  842332 */   GIM_Try, /*On fail goto*//*Label 12970*/ GIMT_Encode4(842407), // Rule ID 23061 //
     /*  842337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  842340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  842345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  842348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  842351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  842354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  842357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  842372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842383 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  842383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  842386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  842390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  842392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  842394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  842402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842405 */     GIR_RootConstrainSelectedInstOperands,
     /*  842406 */     // GIR_Coverage, 23061,
     /*  842406 */     GIR_EraseRootFromParent_Done,
     /*  842407 */   // Label 12970: @842407
     /*  842407 */   GIM_Try, /*On fail goto*//*Label 12971*/ GIMT_Encode4(842482), // Rule ID 23342 //
     /*  842412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  842423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  842426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  842429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  842432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842458 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  842461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842480 */     GIR_RootConstrainSelectedInstOperands,
     /*  842481 */     // GIR_Coverage, 23342,
     /*  842481 */     GIR_EraseRootFromParent_Done,
     /*  842482 */   // Label 12971: @842482
     /*  842482 */   GIM_Try, /*On fail goto*//*Label 12972*/ GIMT_Encode4(842557), // Rule ID 23343 //
     /*  842487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  842498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  842501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  842504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  842507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842533 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  842536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842555 */     GIR_RootConstrainSelectedInstOperands,
     /*  842556 */     // GIR_Coverage, 23343,
     /*  842556 */     GIR_EraseRootFromParent_Done,
     /*  842557 */   // Label 12972: @842557
     /*  842557 */   GIM_Try, /*On fail goto*//*Label 12973*/ GIMT_Encode4(842632), // Rule ID 23346 //
     /*  842562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  842573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  842576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  842579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  842582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  842611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842630 */     GIR_RootConstrainSelectedInstOperands,
     /*  842631 */     // GIR_Coverage, 23346,
     /*  842631 */     GIR_EraseRootFromParent_Done,
     /*  842632 */   // Label 12973: @842632
     /*  842632 */   GIM_Try, /*On fail goto*//*Label 12974*/ GIMT_Encode4(842707), // Rule ID 23347 //
     /*  842637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  842648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  842651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  842654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  842657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842683 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  842686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842705 */     GIR_RootConstrainSelectedInstOperands,
     /*  842706 */     // GIR_Coverage, 23347,
     /*  842706 */     GIR_EraseRootFromParent_Done,
     /*  842707 */   // Label 12974: @842707
     /*  842707 */   GIM_Try, /*On fail goto*//*Label 12975*/ GIMT_Encode4(842782), // Rule ID 23350 //
     /*  842712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  842723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  842726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  842729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  842732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842758 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  842761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842780 */     GIR_RootConstrainSelectedInstOperands,
     /*  842781 */     // GIR_Coverage, 23350,
     /*  842781 */     GIR_EraseRootFromParent_Done,
     /*  842782 */   // Label 12975: @842782
     /*  842782 */   GIM_Try, /*On fail goto*//*Label 12976*/ GIMT_Encode4(842857), // Rule ID 23351 //
     /*  842787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  842798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  842801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  842804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  842807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  842836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842855 */     GIR_RootConstrainSelectedInstOperands,
     /*  842856 */     // GIR_Coverage, 23351,
     /*  842856 */     GIR_EraseRootFromParent_Done,
     /*  842857 */   // Label 12976: @842857
     /*  842857 */   GIM_Try, /*On fail goto*//*Label 12977*/ GIMT_Encode4(842932), // Rule ID 23354 //
     /*  842862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  842873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  842876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  842879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  842882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842908 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  842911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842930 */     GIR_RootConstrainSelectedInstOperands,
     /*  842931 */     // GIR_Coverage, 23354,
     /*  842931 */     GIR_EraseRootFromParent_Done,
     /*  842932 */   // Label 12977: @842932
     /*  842932 */   GIM_Try, /*On fail goto*//*Label 12978*/ GIMT_Encode4(843007), // Rule ID 23355 //
     /*  842937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  842948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  842951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  842954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  842957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842983 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  842986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843005 */     GIR_RootConstrainSelectedInstOperands,
     /*  843006 */     // GIR_Coverage, 23355,
     /*  843006 */     GIR_EraseRootFromParent_Done,
     /*  843007 */   // Label 12978: @843007
     /*  843007 */   GIM_Try, /*On fail goto*//*Label 12979*/ GIMT_Encode4(843082), // Rule ID 23358 //
     /*  843012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843058 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  843061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843080 */     GIR_RootConstrainSelectedInstOperands,
     /*  843081 */     // GIR_Coverage, 23358,
     /*  843081 */     GIR_EraseRootFromParent_Done,
     /*  843082 */   // Label 12979: @843082
     /*  843082 */   GIM_Try, /*On fail goto*//*Label 12980*/ GIMT_Encode4(843157), // Rule ID 23359 //
     /*  843087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843133 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  843136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843155 */     GIR_RootConstrainSelectedInstOperands,
     /*  843156 */     // GIR_Coverage, 23359,
     /*  843156 */     GIR_EraseRootFromParent_Done,
     /*  843157 */   // Label 12980: @843157
     /*  843157 */   GIM_Try, /*On fail goto*//*Label 12981*/ GIMT_Encode4(843232), // Rule ID 23362 //
     /*  843162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843208 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  843211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843230 */     GIR_RootConstrainSelectedInstOperands,
     /*  843231 */     // GIR_Coverage, 23362,
     /*  843231 */     GIR_EraseRootFromParent_Done,
     /*  843232 */   // Label 12981: @843232
     /*  843232 */   GIM_Try, /*On fail goto*//*Label 12982*/ GIMT_Encode4(843307), // Rule ID 23363 //
     /*  843237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  843245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843283 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11443:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  843286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843305 */     GIR_RootConstrainSelectedInstOperands,
     /*  843306 */     // GIR_Coverage, 23363,
     /*  843306 */     GIR_EraseRootFromParent_Done,
     /*  843307 */   // Label 12982: @843307
     /*  843307 */   GIM_Try, /*On fail goto*//*Label 12983*/ GIMT_Encode4(843382), // Rule ID 23366 //
     /*  843312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  843361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843380 */     GIR_RootConstrainSelectedInstOperands,
     /*  843381 */     // GIR_Coverage, 23366,
     /*  843381 */     GIR_EraseRootFromParent_Done,
     /*  843382 */   // Label 12983: @843382
     /*  843382 */   GIM_Try, /*On fail goto*//*Label 12984*/ GIMT_Encode4(843457), // Rule ID 23367 //
     /*  843387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843433 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  843436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843455 */     GIR_RootConstrainSelectedInstOperands,
     /*  843456 */     // GIR_Coverage, 23367,
     /*  843456 */     GIR_EraseRootFromParent_Done,
     /*  843457 */   // Label 12984: @843457
     /*  843457 */   GIM_Try, /*On fail goto*//*Label 12985*/ GIMT_Encode4(843532), // Rule ID 23370 //
     /*  843462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  843473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  843476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  843479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  843482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843508 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  843511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843530 */     GIR_RootConstrainSelectedInstOperands,
     /*  843531 */     // GIR_Coverage, 23370,
     /*  843531 */     GIR_EraseRootFromParent_Done,
     /*  843532 */   // Label 12985: @843532
     /*  843532 */   GIM_Try, /*On fail goto*//*Label 12986*/ GIMT_Encode4(843607), // Rule ID 23371 //
     /*  843537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  843548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  843551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  843554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  843557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843583 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  843586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843592 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843605 */     GIR_RootConstrainSelectedInstOperands,
     /*  843606 */     // GIR_Coverage, 23371,
     /*  843606 */     GIR_EraseRootFromParent_Done,
     /*  843607 */   // Label 12986: @843607
     /*  843607 */   GIM_Try, /*On fail goto*//*Label 12987*/ GIMT_Encode4(843682), // Rule ID 23374 //
     /*  843612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843658 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  843661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843680 */     GIR_RootConstrainSelectedInstOperands,
     /*  843681 */     // GIR_Coverage, 23374,
     /*  843681 */     GIR_EraseRootFromParent_Done,
     /*  843682 */   // Label 12987: @843682
     /*  843682 */   GIM_Try, /*On fail goto*//*Label 12988*/ GIMT_Encode4(843757), // Rule ID 23375 //
     /*  843687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843733 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  843736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843755 */     GIR_RootConstrainSelectedInstOperands,
     /*  843756 */     // GIR_Coverage, 23375,
     /*  843756 */     GIR_EraseRootFromParent_Done,
     /*  843757 */   // Label 12988: @843757
     /*  843757 */   GIM_Try, /*On fail goto*//*Label 12989*/ GIMT_Encode4(843832), // Rule ID 23378 //
     /*  843762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  843811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843830 */     GIR_RootConstrainSelectedInstOperands,
     /*  843831 */     // GIR_Coverage, 23378,
     /*  843831 */     GIR_EraseRootFromParent_Done,
     /*  843832 */   // Label 12989: @843832
     /*  843832 */   GIM_Try, /*On fail goto*//*Label 12990*/ GIMT_Encode4(843907), // Rule ID 23379 //
     /*  843837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843883 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  843886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843905 */     GIR_RootConstrainSelectedInstOperands,
     /*  843906 */     // GIR_Coverage, 23379,
     /*  843906 */     GIR_EraseRootFromParent_Done,
     /*  843907 */   // Label 12990: @843907
     /*  843907 */   GIM_Try, /*On fail goto*//*Label 12991*/ GIMT_Encode4(843982), // Rule ID 23382 //
     /*  843912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  843923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  843926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  843929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  843932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843958 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  843961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843980 */     GIR_RootConstrainSelectedInstOperands,
     /*  843981 */     // GIR_Coverage, 23382,
     /*  843981 */     GIR_EraseRootFromParent_Done,
     /*  843982 */   // Label 12991: @843982
     /*  843982 */   GIM_Try, /*On fail goto*//*Label 12992*/ GIMT_Encode4(844057), // Rule ID 23383 //
     /*  843987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  843998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844033 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  844036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844055 */     GIR_RootConstrainSelectedInstOperands,
     /*  844056 */     // GIR_Coverage, 23383,
     /*  844056 */     GIR_EraseRootFromParent_Done,
     /*  844057 */   // Label 12992: @844057
     /*  844057 */   GIM_Try, /*On fail goto*//*Label 12993*/ GIMT_Encode4(844132), // Rule ID 23386 //
     /*  844062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844108 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  844111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844130 */     GIR_RootConstrainSelectedInstOperands,
     /*  844131 */     // GIR_Coverage, 23386,
     /*  844131 */     GIR_EraseRootFromParent_Done,
     /*  844132 */   // Label 12993: @844132
     /*  844132 */   GIM_Try, /*On fail goto*//*Label 12994*/ GIMT_Encode4(844207), // Rule ID 23387 //
     /*  844137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844183 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  844186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844192 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844205 */     GIR_RootConstrainSelectedInstOperands,
     /*  844206 */     // GIR_Coverage, 23387,
     /*  844206 */     GIR_EraseRootFromParent_Done,
     /*  844207 */   // Label 12994: @844207
     /*  844207 */   GIM_Try, /*On fail goto*//*Label 12995*/ GIMT_Encode4(844282), // Rule ID 23390 //
     /*  844212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844258 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  844261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844280 */     GIR_RootConstrainSelectedInstOperands,
     /*  844281 */     // GIR_Coverage, 23390,
     /*  844281 */     GIR_EraseRootFromParent_Done,
     /*  844282 */   // Label 12995: @844282
     /*  844282 */   GIM_Try, /*On fail goto*//*Label 12996*/ GIMT_Encode4(844357), // Rule ID 23391 //
     /*  844287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  844295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844333 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11456:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  844336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844342 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844355 */     GIR_RootConstrainSelectedInstOperands,
     /*  844356 */     // GIR_Coverage, 23391,
     /*  844356 */     GIR_EraseRootFromParent_Done,
     /*  844357 */   // Label 12996: @844357
     /*  844357 */   GIM_Try, /*On fail goto*//*Label 12997*/ GIMT_Encode4(844432), // Rule ID 23394 //
     /*  844362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  844373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  844376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  844379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  844382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844408 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  844411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844430 */     GIR_RootConstrainSelectedInstOperands,
     /*  844431 */     // GIR_Coverage, 23394,
     /*  844431 */     GIR_EraseRootFromParent_Done,
     /*  844432 */   // Label 12997: @844432
     /*  844432 */   GIM_Try, /*On fail goto*//*Label 12998*/ GIMT_Encode4(844507), // Rule ID 23395 //
     /*  844437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  844448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  844451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  844454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  844457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844483 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  844486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844492 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844505 */     GIR_RootConstrainSelectedInstOperands,
     /*  844506 */     // GIR_Coverage, 23395,
     /*  844506 */     GIR_EraseRootFromParent_Done,
     /*  844507 */   // Label 12998: @844507
     /*  844507 */   GIM_Try, /*On fail goto*//*Label 12999*/ GIMT_Encode4(844582), // Rule ID 23398 //
     /*  844512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  844526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  844529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  844532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844558 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  844561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844580 */     GIR_RootConstrainSelectedInstOperands,
     /*  844581 */     // GIR_Coverage, 23398,
     /*  844581 */     GIR_EraseRootFromParent_Done,
     /*  844582 */   // Label 12999: @844582
     /*  844582 */   GIM_Try, /*On fail goto*//*Label 13000*/ GIMT_Encode4(844657), // Rule ID 23399 //
     /*  844587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  844601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  844604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  844607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844633 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  844636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844642 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844655 */     GIR_RootConstrainSelectedInstOperands,
     /*  844656 */     // GIR_Coverage, 23399,
     /*  844656 */     GIR_EraseRootFromParent_Done,
     /*  844657 */   // Label 13000: @844657
     /*  844657 */   GIM_Try, /*On fail goto*//*Label 13001*/ GIMT_Encode4(844732), // Rule ID 23402 //
     /*  844662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844708 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  844711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844730 */     GIR_RootConstrainSelectedInstOperands,
     /*  844731 */     // GIR_Coverage, 23402,
     /*  844731 */     GIR_EraseRootFromParent_Done,
     /*  844732 */   // Label 13001: @844732
     /*  844732 */   GIM_Try, /*On fail goto*//*Label 13002*/ GIMT_Encode4(844807), // Rule ID 23403 //
     /*  844737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844783 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  844786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844805 */     GIR_RootConstrainSelectedInstOperands,
     /*  844806 */     // GIR_Coverage, 23403,
     /*  844806 */     GIR_EraseRootFromParent_Done,
     /*  844807 */   // Label 13002: @844807
     /*  844807 */   GIM_Try, /*On fail goto*//*Label 13003*/ GIMT_Encode4(844882), // Rule ID 23406 //
     /*  844812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844858 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  844861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844880 */     GIR_RootConstrainSelectedInstOperands,
     /*  844881 */     // GIR_Coverage, 23406,
     /*  844881 */     GIR_EraseRootFromParent_Done,
     /*  844882 */   // Label 13003: @844882
     /*  844882 */   GIM_Try, /*On fail goto*//*Label 13004*/ GIMT_Encode4(844957), // Rule ID 23407 //
     /*  844887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844933 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  844936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844955 */     GIR_RootConstrainSelectedInstOperands,
     /*  844956 */     // GIR_Coverage, 23407,
     /*  844956 */     GIR_EraseRootFromParent_Done,
     /*  844957 */   // Label 13004: @844957
     /*  844957 */   GIM_Try, /*On fail goto*//*Label 13005*/ GIMT_Encode4(845032), // Rule ID 23410 //
     /*  844962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  844973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  845011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845030 */     GIR_RootConstrainSelectedInstOperands,
     /*  845031 */     // GIR_Coverage, 23410,
     /*  845031 */     GIR_EraseRootFromParent_Done,
     /*  845032 */   // Label 13005: @845032
     /*  845032 */   GIM_Try, /*On fail goto*//*Label 13006*/ GIMT_Encode4(845107), // Rule ID 23411 //
     /*  845037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  845048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  845051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  845054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  845057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  845086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845105 */     GIR_RootConstrainSelectedInstOperands,
     /*  845106 */     // GIR_Coverage, 23411,
     /*  845106 */     GIR_EraseRootFromParent_Done,
     /*  845107 */   // Label 13006: @845107
     /*  845107 */   GIM_Try, /*On fail goto*//*Label 13007*/ GIMT_Encode4(845182), // Rule ID 23414 //
     /*  845112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  845123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  845126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  845129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  845132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845158 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  845161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845180 */     GIR_RootConstrainSelectedInstOperands,
     /*  845181 */     // GIR_Coverage, 23414,
     /*  845181 */     GIR_EraseRootFromParent_Done,
     /*  845182 */   // Label 13007: @845182
     /*  845182 */   GIM_Try, /*On fail goto*//*Label 13008*/ GIMT_Encode4(845257), // Rule ID 23415 //
     /*  845187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  845198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  845201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  845204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  845207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845233 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  845236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845255 */     GIR_RootConstrainSelectedInstOperands,
     /*  845256 */     // GIR_Coverage, 23415,
     /*  845256 */     GIR_EraseRootFromParent_Done,
     /*  845257 */   // Label 13008: @845257
     /*  845257 */   GIM_Try, /*On fail goto*//*Label 13009*/ GIMT_Encode4(845332), // Rule ID 23418 //
     /*  845262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  845265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  845273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  845276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  845279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  845282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845308 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  845308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  845311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845330 */     GIR_RootConstrainSelectedInstOperands,
     /*  845331 */     // GIR_Coverage, 23418,
     /*  845331 */     GIR_EraseRootFromParent_Done,
     /*  845332 */   // Label 13009: @845332
     /*  845332 */   GIM_Try, /*On fail goto*//*Label 13010*/ GIMT_Encode4(845407), // Rule ID 23419 //
     /*  845337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  845340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  845345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  845348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  845351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  845354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  845357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  845364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  845376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845383 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11468:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  845383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  845386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  845392 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  845394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  845405 */     GIR_RootConstrainSelectedInstOperands,
     /*  845406 */     // GIR_Coverage, 23419,
     /*  845406 */     GIR_EraseRootFromParent_Done,
     /*  845407 */   // Label 13010: @845407
     /*  845407 */   GIM_Try, /*On fail goto*//*Label 13011*/ GIMT_Encode4(845482), // Rule ID 23960 //
     /*  845412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  845423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  845426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  845429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845458 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  845461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845480 */     GIR_RootConstrainSelectedInstOperands,
     /*  845481 */     // GIR_Coverage, 23960,
     /*  845481 */     GIR_EraseRootFromParent_Done,
     /*  845482 */   // Label 13011: @845482
     /*  845482 */   GIM_Try, /*On fail goto*//*Label 13012*/ GIMT_Encode4(845557), // Rule ID 23961 //
     /*  845487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  845498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  845501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  845504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845533 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  845536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845555 */     GIR_RootConstrainSelectedInstOperands,
     /*  845556 */     // GIR_Coverage, 23961,
     /*  845556 */     GIR_EraseRootFromParent_Done,
     /*  845557 */   // Label 13012: @845557
     /*  845557 */   GIM_Try, /*On fail goto*//*Label 13013*/ GIMT_Encode4(845632), // Rule ID 23964 //
     /*  845562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  845573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  845576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  845579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845608 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845630 */     GIR_RootConstrainSelectedInstOperands,
     /*  845631 */     // GIR_Coverage, 23964,
     /*  845631 */     GIR_EraseRootFromParent_Done,
     /*  845632 */   // Label 13013: @845632
     /*  845632 */   GIM_Try, /*On fail goto*//*Label 13014*/ GIMT_Encode4(845707), // Rule ID 23965 //
     /*  845637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  845648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  845651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  845654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845683 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845705 */     GIR_RootConstrainSelectedInstOperands,
     /*  845706 */     // GIR_Coverage, 23965,
     /*  845706 */     GIR_EraseRootFromParent_Done,
     /*  845707 */   // Label 13014: @845707
     /*  845707 */   GIM_Try, /*On fail goto*//*Label 13015*/ GIMT_Encode4(845782), // Rule ID 23968 //
     /*  845712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  845723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  845726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  845729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845758 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845780 */     GIR_RootConstrainSelectedInstOperands,
     /*  845781 */     // GIR_Coverage, 23968,
     /*  845781 */     GIR_EraseRootFromParent_Done,
     /*  845782 */   // Label 13015: @845782
     /*  845782 */   GIM_Try, /*On fail goto*//*Label 13016*/ GIMT_Encode4(845857), // Rule ID 23969 //
     /*  845787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  845798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  845801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  845804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845833 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845855 */     GIR_RootConstrainSelectedInstOperands,
     /*  845856 */     // GIR_Coverage, 23969,
     /*  845856 */     GIR_EraseRootFromParent_Done,
     /*  845857 */   // Label 13016: @845857
     /*  845857 */   GIM_Try, /*On fail goto*//*Label 13017*/ GIMT_Encode4(845932), // Rule ID 23972 //
     /*  845862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  845873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  845876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  845879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845930 */     GIR_RootConstrainSelectedInstOperands,
     /*  845931 */     // GIR_Coverage, 23972,
     /*  845931 */     GIR_EraseRootFromParent_Done,
     /*  845932 */   // Label 13017: @845932
     /*  845932 */   GIM_Try, /*On fail goto*//*Label 13018*/ GIMT_Encode4(846007), // Rule ID 23973 //
     /*  845937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  845948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  845951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  845954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845983 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846005 */     GIR_RootConstrainSelectedInstOperands,
     /*  846006 */     // GIR_Coverage, 23973,
     /*  846006 */     GIR_EraseRootFromParent_Done,
     /*  846007 */   // Label 13018: @846007
     /*  846007 */   GIM_Try, /*On fail goto*//*Label 13019*/ GIMT_Encode4(846082), // Rule ID 23976 //
     /*  846012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  846023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  846026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  846029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846058 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846080 */     GIR_RootConstrainSelectedInstOperands,
     /*  846081 */     // GIR_Coverage, 23976,
     /*  846081 */     GIR_EraseRootFromParent_Done,
     /*  846082 */   // Label 13019: @846082
     /*  846082 */   GIM_Try, /*On fail goto*//*Label 13020*/ GIMT_Encode4(846157), // Rule ID 23977 //
     /*  846087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  846098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  846101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  846104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846133 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846155 */     GIR_RootConstrainSelectedInstOperands,
     /*  846156 */     // GIR_Coverage, 23977,
     /*  846156 */     GIR_EraseRootFromParent_Done,
     /*  846157 */   // Label 13020: @846157
     /*  846157 */   GIM_Try, /*On fail goto*//*Label 13021*/ GIMT_Encode4(846232), // Rule ID 23980 //
     /*  846162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846208 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  846208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846230 */     GIR_RootConstrainSelectedInstOperands,
     /*  846231 */     // GIR_Coverage, 23980,
     /*  846231 */     GIR_EraseRootFromParent_Done,
     /*  846232 */   // Label 13021: @846232
     /*  846232 */   GIM_Try, /*On fail goto*//*Label 13022*/ GIMT_Encode4(846307), // Rule ID 23981 //
     /*  846237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  846248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  846251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  846254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846283 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  846283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  846286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846305 */     GIR_RootConstrainSelectedInstOperands,
     /*  846306 */     // GIR_Coverage, 23981,
     /*  846306 */     GIR_EraseRootFromParent_Done,
     /*  846307 */   // Label 13022: @846307
     /*  846307 */   GIM_Try, /*On fail goto*//*Label 13023*/ GIMT_Encode4(846382), // Rule ID 23984 //
     /*  846312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  846323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  846326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  846329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846380 */     GIR_RootConstrainSelectedInstOperands,
     /*  846381 */     // GIR_Coverage, 23984,
     /*  846381 */     GIR_EraseRootFromParent_Done,
     /*  846382 */   // Label 13023: @846382
     /*  846382 */   GIM_Try, /*On fail goto*//*Label 13024*/ GIMT_Encode4(846457), // Rule ID 23985 //
     /*  846387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  846398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  846401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  846404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846433 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11547:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846455 */     GIR_RootConstrainSelectedInstOperands,
     /*  846456 */     // GIR_Coverage, 23985,
     /*  846456 */     GIR_EraseRootFromParent_Done,
     /*  846457 */   // Label 13024: @846457
     /*  846457 */   GIM_Try, /*On fail goto*//*Label 13025*/ GIMT_Encode4(846532), // Rule ID 23988 //
     /*  846462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  846473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  846476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  846479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846530 */     GIR_RootConstrainSelectedInstOperands,
     /*  846531 */     // GIR_Coverage, 23988,
     /*  846531 */     GIR_EraseRootFromParent_Done,
     /*  846532 */   // Label 13025: @846532
     /*  846532 */   GIM_Try, /*On fail goto*//*Label 13026*/ GIMT_Encode4(846607), // Rule ID 23989 //
     /*  846537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  846548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  846551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  846554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846583 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11547:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846605 */     GIR_RootConstrainSelectedInstOperands,
     /*  846606 */     // GIR_Coverage, 23989,
     /*  846606 */     GIR_EraseRootFromParent_Done,
     /*  846607 */   // Label 13026: @846607
     /*  846607 */   GIM_Try, /*On fail goto*//*Label 13027*/ GIMT_Encode4(846682), // Rule ID 23992 //
     /*  846612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  846623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  846626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  846629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  846658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846680 */     GIR_RootConstrainSelectedInstOperands,
     /*  846681 */     // GIR_Coverage, 23992,
     /*  846681 */     GIR_EraseRootFromParent_Done,
     /*  846682 */   // Label 13027: @846682
     /*  846682 */   GIM_Try, /*On fail goto*//*Label 13028*/ GIMT_Encode4(846757), // Rule ID 23993 //
     /*  846687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  846698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  846701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  846704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846733 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11547:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  846733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846755 */     GIR_RootConstrainSelectedInstOperands,
     /*  846756 */     // GIR_Coverage, 23993,
     /*  846756 */     GIR_EraseRootFromParent_Done,
     /*  846757 */   // Label 13028: @846757
     /*  846757 */   GIM_Try, /*On fail goto*//*Label 13029*/ GIMT_Encode4(846832), // Rule ID 23996 //
     /*  846762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  846765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  846779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  846808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846830 */     GIR_RootConstrainSelectedInstOperands,
     /*  846831 */     // GIR_Coverage, 23996,
     /*  846831 */     GIR_EraseRootFromParent_Done,
     /*  846832 */   // Label 13029: @846832
     /*  846832 */   GIM_Try, /*On fail goto*//*Label 13030*/ GIMT_Encode4(846907), // Rule ID 23997 //
     /*  846837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  846840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  846854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846883 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11547:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  846883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846905 */     GIR_RootConstrainSelectedInstOperands,
     /*  846906 */     // GIR_Coverage, 23997,
     /*  846906 */     GIR_EraseRootFromParent_Done,
     /*  846907 */   // Label 13030: @846907
     /*  846907 */   GIM_Try, /*On fail goto*//*Label 13031*/ GIMT_Encode4(846982), // Rule ID 24000 //
     /*  846912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  846923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  846926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  846929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  846961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846980 */     GIR_RootConstrainSelectedInstOperands,
     /*  846981 */     // GIR_Coverage, 24000,
     /*  846981 */     GIR_EraseRootFromParent_Done,
     /*  846982 */   // Label 13031: @846982
     /*  846982 */   GIM_Try, /*On fail goto*//*Label 13032*/ GIMT_Encode4(847057), // Rule ID 24001 //
     /*  846987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  846998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  847001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  847004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847033 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847055 */     GIR_RootConstrainSelectedInstOperands,
     /*  847056 */     // GIR_Coverage, 24001,
     /*  847056 */     GIR_EraseRootFromParent_Done,
     /*  847057 */   // Label 13032: @847057
     /*  847057 */   GIM_Try, /*On fail goto*//*Label 13033*/ GIMT_Encode4(847132), // Rule ID 24004 //
     /*  847062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  847073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  847076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  847079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847108 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847130 */     GIR_RootConstrainSelectedInstOperands,
     /*  847131 */     // GIR_Coverage, 24004,
     /*  847131 */     GIR_EraseRootFromParent_Done,
     /*  847132 */   // Label 13033: @847132
     /*  847132 */   GIM_Try, /*On fail goto*//*Label 13034*/ GIMT_Encode4(847207), // Rule ID 24005 //
     /*  847137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  847148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  847151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  847154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847183 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847205 */     GIR_RootConstrainSelectedInstOperands,
     /*  847206 */     // GIR_Coverage, 24005,
     /*  847206 */     GIR_EraseRootFromParent_Done,
     /*  847207 */   // Label 13034: @847207
     /*  847207 */   GIM_Try, /*On fail goto*//*Label 13035*/ GIMT_Encode4(847282), // Rule ID 24008 //
     /*  847212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  847223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  847226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  847229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847258 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  847258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847280 */     GIR_RootConstrainSelectedInstOperands,
     /*  847281 */     // GIR_Coverage, 24008,
     /*  847281 */     GIR_EraseRootFromParent_Done,
     /*  847282 */   // Label 13035: @847282
     /*  847282 */   GIM_Try, /*On fail goto*//*Label 13036*/ GIMT_Encode4(847357), // Rule ID 24009 //
     /*  847287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  847298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  847301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  847304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847333 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  847333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  847352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847355 */     GIR_RootConstrainSelectedInstOperands,
     /*  847356 */     // GIR_Coverage, 24009,
     /*  847356 */     GIR_EraseRootFromParent_Done,
     /*  847357 */   // Label 13036: @847357
     /*  847357 */   GIM_Try, /*On fail goto*//*Label 13037*/ GIMT_Encode4(847432), // Rule ID 24012 //
     /*  847362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  847373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  847376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  847379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847408 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847430 */     GIR_RootConstrainSelectedInstOperands,
     /*  847431 */     // GIR_Coverage, 24012,
     /*  847431 */     GIR_EraseRootFromParent_Done,
     /*  847432 */   // Label 13037: @847432
     /*  847432 */   GIM_Try, /*On fail goto*//*Label 13038*/ GIMT_Encode4(847507), // Rule ID 24013 //
     /*  847437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  847448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  847451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  847454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847483 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847505 */     GIR_RootConstrainSelectedInstOperands,
     /*  847506 */     // GIR_Coverage, 24013,
     /*  847506 */     GIR_EraseRootFromParent_Done,
     /*  847507 */   // Label 13038: @847507
     /*  847507 */   GIM_Try, /*On fail goto*//*Label 13039*/ GIMT_Encode4(847582), // Rule ID 24016 //
     /*  847512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  847523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  847526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  847529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847580 */     GIR_RootConstrainSelectedInstOperands,
     /*  847581 */     // GIR_Coverage, 24016,
     /*  847581 */     GIR_EraseRootFromParent_Done,
     /*  847582 */   // Label 13039: @847582
     /*  847582 */   GIM_Try, /*On fail goto*//*Label 13040*/ GIMT_Encode4(847657), // Rule ID 24017 //
     /*  847587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  847598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  847601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  847604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847633 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847655 */     GIR_RootConstrainSelectedInstOperands,
     /*  847656 */     // GIR_Coverage, 24017,
     /*  847656 */     GIR_EraseRootFromParent_Done,
     /*  847657 */   // Label 13040: @847657
     /*  847657 */   GIM_Try, /*On fail goto*//*Label 13041*/ GIMT_Encode4(847732), // Rule ID 24020 //
     /*  847662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  847673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  847676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  847679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847708 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847730 */     GIR_RootConstrainSelectedInstOperands,
     /*  847731 */     // GIR_Coverage, 24020,
     /*  847731 */     GIR_EraseRootFromParent_Done,
     /*  847732 */   // Label 13041: @847732
     /*  847732 */   GIM_Try, /*On fail goto*//*Label 13042*/ GIMT_Encode4(847807), // Rule ID 24021 //
     /*  847737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  847748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  847751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  847754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847783 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847805 */     GIR_RootConstrainSelectedInstOperands,
     /*  847806 */     // GIR_Coverage, 24021,
     /*  847806 */     GIR_EraseRootFromParent_Done,
     /*  847807 */   // Label 13042: @847807
     /*  847807 */   GIM_Try, /*On fail goto*//*Label 13043*/ GIMT_Encode4(847882), // Rule ID 24024 //
     /*  847812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  847823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  847826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  847829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  847858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847880 */     GIR_RootConstrainSelectedInstOperands,
     /*  847881 */     // GIR_Coverage, 24024,
     /*  847881 */     GIR_EraseRootFromParent_Done,
     /*  847882 */   // Label 13043: @847882
     /*  847882 */   GIM_Try, /*On fail goto*//*Label 13044*/ GIMT_Encode4(847957), // Rule ID 24025 //
     /*  847887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  847898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  847901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  847904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847933 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  847933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847955 */     GIR_RootConstrainSelectedInstOperands,
     /*  847956 */     // GIR_Coverage, 24025,
     /*  847956 */     GIR_EraseRootFromParent_Done,
     /*  847957 */   // Label 13044: @847957
     /*  847957 */   GIM_Try, /*On fail goto*//*Label 13045*/ GIMT_Encode4(848032), // Rule ID 24028 //
     /*  847962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  847973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  847976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  847979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848030 */     GIR_RootConstrainSelectedInstOperands,
     /*  848031 */     // GIR_Coverage, 24028,
     /*  848031 */     GIR_EraseRootFromParent_Done,
     /*  848032 */   // Label 13045: @848032
     /*  848032 */   GIM_Try, /*On fail goto*//*Label 13046*/ GIMT_Encode4(848107), // Rule ID 24029 //
     /*  848037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  848048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  848051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  848054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848083 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848105 */     GIR_RootConstrainSelectedInstOperands,
     /*  848106 */     // GIR_Coverage, 24029,
     /*  848106 */     GIR_EraseRootFromParent_Done,
     /*  848107 */   // Label 13046: @848107
     /*  848107 */   GIM_Try, /*On fail goto*//*Label 13047*/ GIMT_Encode4(848182), // Rule ID 24032 //
     /*  848112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848158 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  848158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848180 */     GIR_RootConstrainSelectedInstOperands,
     /*  848181 */     // GIR_Coverage, 24032,
     /*  848181 */     GIR_EraseRootFromParent_Done,
     /*  848182 */   // Label 13047: @848182
     /*  848182 */   GIM_Try, /*On fail goto*//*Label 13048*/ GIMT_Encode4(848257), // Rule ID 24033 //
     /*  848187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  848198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  848201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  848204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848233 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  848233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  848252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848255 */     GIR_RootConstrainSelectedInstOperands,
     /*  848256 */     // GIR_Coverage, 24033,
     /*  848256 */     GIR_EraseRootFromParent_Done,
     /*  848257 */   // Label 13048: @848257
     /*  848257 */   GIM_Try, /*On fail goto*//*Label 13049*/ GIMT_Encode4(848332), // Rule ID 24036 //
     /*  848262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848308 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848330 */     GIR_RootConstrainSelectedInstOperands,
     /*  848331 */     // GIR_Coverage, 24036,
     /*  848331 */     GIR_EraseRootFromParent_Done,
     /*  848332 */   // Label 13049: @848332
     /*  848332 */   GIM_Try, /*On fail goto*//*Label 13050*/ GIMT_Encode4(848407), // Rule ID 24037 //
     /*  848337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  848348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  848351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  848354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  848372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848383 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11547:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  848386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848405 */     GIR_RootConstrainSelectedInstOperands,
     /*  848406 */     // GIR_Coverage, 24037,
     /*  848406 */     GIR_EraseRootFromParent_Done,
     /*  848407 */   // Label 13050: @848407
     /*  848407 */   GIM_Try, /*On fail goto*//*Label 13051*/ GIMT_Encode4(848482), // Rule ID 24040 //
     /*  848412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848458 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848480 */     GIR_RootConstrainSelectedInstOperands,
     /*  848481 */     // GIR_Coverage, 24040,
     /*  848481 */     GIR_EraseRootFromParent_Done,
     /*  848482 */   // Label 13051: @848482
     /*  848482 */   GIM_Try, /*On fail goto*//*Label 13052*/ GIMT_Encode4(848557), // Rule ID 24041 //
     /*  848487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  848498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  848501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  848504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848533 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11547:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848555 */     GIR_RootConstrainSelectedInstOperands,
     /*  848556 */     // GIR_Coverage, 24041,
     /*  848556 */     GIR_EraseRootFromParent_Done,
     /*  848557 */   // Label 13052: @848557
     /*  848557 */   GIM_Try, /*On fail goto*//*Label 13053*/ GIMT_Encode4(848632), // Rule ID 24044 //
     /*  848562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  848573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  848576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  848579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848608 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848630 */     GIR_RootConstrainSelectedInstOperands,
     /*  848631 */     // GIR_Coverage, 24044,
     /*  848631 */     GIR_EraseRootFromParent_Done,
     /*  848632 */   // Label 13053: @848632
     /*  848632 */   GIM_Try, /*On fail goto*//*Label 13054*/ GIMT_Encode4(848707), // Rule ID 24045 //
     /*  848637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  848648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  848651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  848654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848683 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11547:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848705 */     GIR_RootConstrainSelectedInstOperands,
     /*  848706 */     // GIR_Coverage, 24045,
     /*  848706 */     GIR_EraseRootFromParent_Done,
     /*  848707 */   // Label 13054: @848707
     /*  848707 */   GIM_Try, /*On fail goto*//*Label 13055*/ GIMT_Encode4(848782), // Rule ID 24048 //
     /*  848712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  848723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  848726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  848729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848758 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  848758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  848761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848780 */     GIR_RootConstrainSelectedInstOperands,
     /*  848781 */     // GIR_Coverage, 24048,
     /*  848781 */     GIR_EraseRootFromParent_Done,
     /*  848782 */   // Label 13055: @848782
     /*  848782 */   GIM_Try, /*On fail goto*//*Label 13056*/ GIMT_Encode4(848857), // Rule ID 24049 //
     /*  848787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  848798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  848801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  848804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848833 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  848833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  848836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848855 */     GIR_RootConstrainSelectedInstOperands,
     /*  848856 */     // GIR_Coverage, 24049,
     /*  848856 */     GIR_EraseRootFromParent_Done,
     /*  848857 */   // Label 13056: @848857
     /*  848857 */   GIM_Try, /*On fail goto*//*Label 13057*/ GIMT_Encode4(848932), // Rule ID 24052 //
     /*  848862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  848873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  848876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  848879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848908 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  848908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  848911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848930 */     GIR_RootConstrainSelectedInstOperands,
     /*  848931 */     // GIR_Coverage, 24052,
     /*  848931 */     GIR_EraseRootFromParent_Done,
     /*  848932 */   // Label 13057: @848932
     /*  848932 */   GIM_Try, /*On fail goto*//*Label 13058*/ GIMT_Encode4(849007), // Rule ID 24053 //
     /*  848937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  848948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  848951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  848954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848983 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  848983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  848986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849005 */     GIR_RootConstrainSelectedInstOperands,
     /*  849006 */     // GIR_Coverage, 24053,
     /*  849006 */     GIR_EraseRootFromParent_Done,
     /*  849007 */   // Label 13058: @849007
     /*  849007 */   GIM_Try, /*On fail goto*//*Label 13059*/ GIMT_Encode4(849082), // Rule ID 24056 //
     /*  849012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849058 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849080 */     GIR_RootConstrainSelectedInstOperands,
     /*  849081 */     // GIR_Coverage, 24056,
     /*  849081 */     GIR_EraseRootFromParent_Done,
     /*  849082 */   // Label 13059: @849082
     /*  849082 */   GIM_Try, /*On fail goto*//*Label 13060*/ GIMT_Encode4(849157), // Rule ID 24057 //
     /*  849087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  849098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  849101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  849104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849133 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849155 */     GIR_RootConstrainSelectedInstOperands,
     /*  849156 */     // GIR_Coverage, 24057,
     /*  849156 */     GIR_EraseRootFromParent_Done,
     /*  849157 */   // Label 13060: @849157
     /*  849157 */   GIM_Try, /*On fail goto*//*Label 13061*/ GIMT_Encode4(849232), // Rule ID 24060 //
     /*  849162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849208 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849230 */     GIR_RootConstrainSelectedInstOperands,
     /*  849231 */     // GIR_Coverage, 24060,
     /*  849231 */     GIR_EraseRootFromParent_Done,
     /*  849232 */   // Label 13061: @849232
     /*  849232 */   GIM_Try, /*On fail goto*//*Label 13062*/ GIMT_Encode4(849307), // Rule ID 24061 //
     /*  849237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  849248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  849251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  849254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849283 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  849286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849305 */     GIR_RootConstrainSelectedInstOperands,
     /*  849306 */     // GIR_Coverage, 24061,
     /*  849306 */     GIR_EraseRootFromParent_Done,
     /*  849307 */   // Label 13062: @849307
     /*  849307 */   GIM_Try, /*On fail goto*//*Label 13063*/ GIMT_Encode4(849382), // Rule ID 24064 //
     /*  849312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849358 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849380 */     GIR_RootConstrainSelectedInstOperands,
     /*  849381 */     // GIR_Coverage, 24064,
     /*  849381 */     GIR_EraseRootFromParent_Done,
     /*  849382 */   // Label 13063: @849382
     /*  849382 */   GIM_Try, /*On fail goto*//*Label 13064*/ GIMT_Encode4(849457), // Rule ID 24065 //
     /*  849387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  849398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  849401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  849404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849433 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849455 */     GIR_RootConstrainSelectedInstOperands,
     /*  849456 */     // GIR_Coverage, 24065,
     /*  849456 */     GIR_EraseRootFromParent_Done,
     /*  849457 */   // Label 13064: @849457
     /*  849457 */   GIM_Try, /*On fail goto*//*Label 13065*/ GIMT_Encode4(849532), // Rule ID 24068 //
     /*  849462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  849473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  849476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  849479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849508 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  849508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849530 */     GIR_RootConstrainSelectedInstOperands,
     /*  849531 */     // GIR_Coverage, 24068,
     /*  849531 */     GIR_EraseRootFromParent_Done,
     /*  849532 */   // Label 13065: @849532
     /*  849532 */   GIM_Try, /*On fail goto*//*Label 13066*/ GIMT_Encode4(849607), // Rule ID 24069 //
     /*  849537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  849548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  849551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  849554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849583 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  849583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849605 */     GIR_RootConstrainSelectedInstOperands,
     /*  849606 */     // GIR_Coverage, 24069,
     /*  849606 */     GIR_EraseRootFromParent_Done,
     /*  849607 */   // Label 13066: @849607
     /*  849607 */   GIM_Try, /*On fail goto*//*Label 13067*/ GIMT_Encode4(849682), // Rule ID 24072 //
     /*  849612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  849623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  849626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  849629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849680 */     GIR_RootConstrainSelectedInstOperands,
     /*  849681 */     // GIR_Coverage, 24072,
     /*  849681 */     GIR_EraseRootFromParent_Done,
     /*  849682 */   // Label 13067: @849682
     /*  849682 */   GIM_Try, /*On fail goto*//*Label 13068*/ GIMT_Encode4(849757), // Rule ID 24073 //
     /*  849687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  849698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  849701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  849704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849733 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11545:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849755 */     GIR_RootConstrainSelectedInstOperands,
     /*  849756 */     // GIR_Coverage, 24073,
     /*  849756 */     GIR_EraseRootFromParent_Done,
     /*  849757 */   // Label 13068: @849757
     /*  849757 */   GIM_Try, /*On fail goto*//*Label 13069*/ GIMT_Encode4(849832), // Rule ID 24076 //
     /*  849762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  849773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  849776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  849779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849808 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849830 */     GIR_RootConstrainSelectedInstOperands,
     /*  849831 */     // GIR_Coverage, 24076,
     /*  849831 */     GIR_EraseRootFromParent_Done,
     /*  849832 */   // Label 13069: @849832
     /*  849832 */   GIM_Try, /*On fail goto*//*Label 13070*/ GIMT_Encode4(849907), // Rule ID 24077 //
     /*  849837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  849848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  849851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  849854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849883 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11545:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849905 */     GIR_RootConstrainSelectedInstOperands,
     /*  849906 */     // GIR_Coverage, 24077,
     /*  849906 */     GIR_EraseRootFromParent_Done,
     /*  849907 */   // Label 13070: @849907
     /*  849907 */   GIM_Try, /*On fail goto*//*Label 13071*/ GIMT_Encode4(849982), // Rule ID 24080 //
     /*  849912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  849923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  849926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  849929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  849958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849980 */     GIR_RootConstrainSelectedInstOperands,
     /*  849981 */     // GIR_Coverage, 24080,
     /*  849981 */     GIR_EraseRootFromParent_Done,
     /*  849982 */   // Label 13071: @849982
     /*  849982 */   GIM_Try, /*On fail goto*//*Label 13072*/ GIMT_Encode4(850057), // Rule ID 24081 //
     /*  849987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  849998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  850001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  850004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850033 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11545:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850055 */     GIR_RootConstrainSelectedInstOperands,
     /*  850056 */     // GIR_Coverage, 24081,
     /*  850056 */     GIR_EraseRootFromParent_Done,
     /*  850057 */   // Label 13072: @850057
     /*  850057 */   GIM_Try, /*On fail goto*//*Label 13073*/ GIMT_Encode4(850132), // Rule ID 24084 //
     /*  850062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  850065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850108 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  850108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850130 */     GIR_RootConstrainSelectedInstOperands,
     /*  850131 */     // GIR_Coverage, 24084,
     /*  850131 */     GIR_EraseRootFromParent_Done,
     /*  850132 */   // Label 13073: @850132
     /*  850132 */   GIM_Try, /*On fail goto*//*Label 13074*/ GIMT_Encode4(850207), // Rule ID 24085 //
     /*  850137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  850140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  850148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  850151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  850154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  850172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850183 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11545:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  850183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  850186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  850202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850205 */     GIR_RootConstrainSelectedInstOperands,
     /*  850206 */     // GIR_Coverage, 24085,
     /*  850206 */     GIR_EraseRootFromParent_Done,
     /*  850207 */   // Label 13074: @850207
     /*  850207 */   GIM_Try, /*On fail goto*//*Label 13075*/ GIMT_Encode4(850282), // Rule ID 24088 //
     /*  850212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850258 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850280 */     GIR_RootConstrainSelectedInstOperands,
     /*  850281 */     // GIR_Coverage, 24088,
     /*  850281 */     GIR_EraseRootFromParent_Done,
     /*  850282 */   // Label 13075: @850282
     /*  850282 */   GIM_Try, /*On fail goto*//*Label 13076*/ GIMT_Encode4(850357), // Rule ID 24089 //
     /*  850287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  850298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  850301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  850304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850333 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850355 */     GIR_RootConstrainSelectedInstOperands,
     /*  850356 */     // GIR_Coverage, 24089,
     /*  850356 */     GIR_EraseRootFromParent_Done,
     /*  850357 */   // Label 13076: @850357
     /*  850357 */   GIM_Try, /*On fail goto*//*Label 13077*/ GIMT_Encode4(850432), // Rule ID 24092 //
     /*  850362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850408 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850430 */     GIR_RootConstrainSelectedInstOperands,
     /*  850431 */     // GIR_Coverage, 24092,
     /*  850431 */     GIR_EraseRootFromParent_Done,
     /*  850432 */   // Label 13077: @850432
     /*  850432 */   GIM_Try, /*On fail goto*//*Label 13078*/ GIMT_Encode4(850507), // Rule ID 24093 //
     /*  850437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  850448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  850451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  850454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850483 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850505 */     GIR_RootConstrainSelectedInstOperands,
     /*  850506 */     // GIR_Coverage, 24093,
     /*  850506 */     GIR_EraseRootFromParent_Done,
     /*  850507 */   // Label 13078: @850507
     /*  850507 */   GIM_Try, /*On fail goto*//*Label 13079*/ GIMT_Encode4(850582), // Rule ID 24096 //
     /*  850512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  850523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  850526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  850529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850558 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  850561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850580 */     GIR_RootConstrainSelectedInstOperands,
     /*  850581 */     // GIR_Coverage, 24096,
     /*  850581 */     GIR_EraseRootFromParent_Done,
     /*  850582 */   // Label 13079: @850582
     /*  850582 */   GIM_Try, /*On fail goto*//*Label 13080*/ GIMT_Encode4(850657), // Rule ID 24097 //
     /*  850587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  850598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  850601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  850604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850633 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  850636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850655 */     GIR_RootConstrainSelectedInstOperands,
     /*  850656 */     // GIR_Coverage, 24097,
     /*  850656 */     GIR_EraseRootFromParent_Done,
     /*  850657 */   // Label 13080: @850657
     /*  850657 */   GIM_Try, /*On fail goto*//*Label 13081*/ GIMT_Encode4(850732), // Rule ID 24100 //
     /*  850662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  850673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  850676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  850679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850730 */     GIR_RootConstrainSelectedInstOperands,
     /*  850731 */     // GIR_Coverage, 24100,
     /*  850731 */     GIR_EraseRootFromParent_Done,
     /*  850732 */   // Label 13081: @850732
     /*  850732 */   GIM_Try, /*On fail goto*//*Label 13082*/ GIMT_Encode4(850807), // Rule ID 24101 //
     /*  850737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  850748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  850751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  850754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850783 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850805 */     GIR_RootConstrainSelectedInstOperands,
     /*  850806 */     // GIR_Coverage, 24101,
     /*  850806 */     GIR_EraseRootFromParent_Done,
     /*  850807 */   // Label 13082: @850807
     /*  850807 */   GIM_Try, /*On fail goto*//*Label 13083*/ GIMT_Encode4(850882), // Rule ID 24104 //
     /*  850812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  850823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  850826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  850829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850880 */     GIR_RootConstrainSelectedInstOperands,
     /*  850881 */     // GIR_Coverage, 24104,
     /*  850881 */     GIR_EraseRootFromParent_Done,
     /*  850882 */   // Label 13083: @850882
     /*  850882 */   GIM_Try, /*On fail goto*//*Label 13084*/ GIMT_Encode4(850957), // Rule ID 24105 //
     /*  850887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  850898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  850901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  850904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850933 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850955 */     GIR_RootConstrainSelectedInstOperands,
     /*  850956 */     // GIR_Coverage, 24105,
     /*  850956 */     GIR_EraseRootFromParent_Done,
     /*  850957 */   // Label 13084: @850957
     /*  850957 */   GIM_Try, /*On fail goto*//*Label 13085*/ GIMT_Encode4(851032), // Rule ID 24108 //
     /*  850962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  850973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  850976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  850979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851030 */     GIR_RootConstrainSelectedInstOperands,
     /*  851031 */     // GIR_Coverage, 24108,
     /*  851031 */     GIR_EraseRootFromParent_Done,
     /*  851032 */   // Label 13085: @851032
     /*  851032 */   GIM_Try, /*On fail goto*//*Label 13086*/ GIMT_Encode4(851107), // Rule ID 24109 //
     /*  851037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  851048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  851051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  851054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851083 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851105 */     GIR_RootConstrainSelectedInstOperands,
     /*  851106 */     // GIR_Coverage, 24109,
     /*  851106 */     GIR_EraseRootFromParent_Done,
     /*  851107 */   // Label 13086: @851107
     /*  851107 */   GIM_Try, /*On fail goto*//*Label 13087*/ GIMT_Encode4(851182), // Rule ID 24112 //
     /*  851112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851180 */     GIR_RootConstrainSelectedInstOperands,
     /*  851181 */     // GIR_Coverage, 24112,
     /*  851181 */     GIR_EraseRootFromParent_Done,
     /*  851182 */   // Label 13087: @851182
     /*  851182 */   GIM_Try, /*On fail goto*//*Label 13088*/ GIMT_Encode4(851257), // Rule ID 24113 //
     /*  851187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  851198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  851201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  851204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851233 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851255 */     GIR_RootConstrainSelectedInstOperands,
     /*  851256 */     // GIR_Coverage, 24113,
     /*  851256 */     GIR_EraseRootFromParent_Done,
     /*  851257 */   // Label 13088: @851257
     /*  851257 */   GIM_Try, /*On fail goto*//*Label 13089*/ GIMT_Encode4(851332), // Rule ID 24116 //
     /*  851262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851308 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851330 */     GIR_RootConstrainSelectedInstOperands,
     /*  851331 */     // GIR_Coverage, 24116,
     /*  851331 */     GIR_EraseRootFromParent_Done,
     /*  851332 */   // Label 13089: @851332
     /*  851332 */   GIM_Try, /*On fail goto*//*Label 13090*/ GIMT_Encode4(851407), // Rule ID 24117 //
     /*  851337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  851348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  851351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  851354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851383 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851405 */     GIR_RootConstrainSelectedInstOperands,
     /*  851406 */     // GIR_Coverage, 24117,
     /*  851406 */     GIR_EraseRootFromParent_Done,
     /*  851407 */   // Label 13090: @851407
     /*  851407 */   GIM_Try, /*On fail goto*//*Label 13091*/ GIMT_Encode4(851482), // Rule ID 24120 //
     /*  851412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  851415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851458 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851480 */     GIR_RootConstrainSelectedInstOperands,
     /*  851481 */     // GIR_Coverage, 24120,
     /*  851481 */     GIR_EraseRootFromParent_Done,
     /*  851482 */   // Label 13091: @851482
     /*  851482 */   GIM_Try, /*On fail goto*//*Label 13092*/ GIMT_Encode4(851557), // Rule ID 24121 //
     /*  851487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  851490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  851498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  851501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  851504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851533 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851555 */     GIR_RootConstrainSelectedInstOperands,
     /*  851556 */     // GIR_Coverage, 24121,
     /*  851556 */     GIR_EraseRootFromParent_Done,
     /*  851557 */   // Label 13092: @851557
     /*  851557 */   GIM_Try, /*On fail goto*//*Label 13093*/ GIMT_Encode4(851632), // Rule ID 24124 //
     /*  851562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  851565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  851573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  851576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  851579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  851608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851630 */     GIR_RootConstrainSelectedInstOperands,
     /*  851631 */     // GIR_Coverage, 24124,
     /*  851631 */     GIR_EraseRootFromParent_Done,
     /*  851632 */   // Label 13093: @851632
     /*  851632 */   GIM_Try, /*On fail goto*//*Label 13094*/ GIMT_Encode4(851707), // Rule ID 24125 //
     /*  851637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  851640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  851648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  851651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  851654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11545:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  851683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851705 */     GIR_RootConstrainSelectedInstOperands,
     /*  851706 */     // GIR_Coverage, 24125,
     /*  851706 */     GIR_EraseRootFromParent_Done,
     /*  851707 */   // Label 13094: @851707
     /*  851707 */   GIM_Try, /*On fail goto*//*Label 13095*/ GIMT_Encode4(851782), // Rule ID 24128 //
     /*  851712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  851715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  851723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  851726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  851729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851758 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  851758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851780 */     GIR_RootConstrainSelectedInstOperands,
     /*  851781 */     // GIR_Coverage, 24128,
     /*  851781 */     GIR_EraseRootFromParent_Done,
     /*  851782 */   // Label 13095: @851782
     /*  851782 */   GIM_Try, /*On fail goto*//*Label 13096*/ GIMT_Encode4(851857), // Rule ID 24129 //
     /*  851787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  851790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  851798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  851801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  851804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851833 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11545:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  851833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851855 */     GIR_RootConstrainSelectedInstOperands,
     /*  851856 */     // GIR_Coverage, 24129,
     /*  851856 */     GIR_EraseRootFromParent_Done,
     /*  851857 */   // Label 13096: @851857
     /*  851857 */   GIM_Try, /*On fail goto*//*Label 13097*/ GIMT_Encode4(851932), // Rule ID 24132 //
     /*  851862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  851865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  851873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  851876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  851879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851908 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  851908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851930 */     GIR_RootConstrainSelectedInstOperands,
     /*  851931 */     // GIR_Coverage, 24132,
     /*  851931 */     GIR_EraseRootFromParent_Done,
     /*  851932 */   // Label 13097: @851932
     /*  851932 */   GIM_Try, /*On fail goto*//*Label 13098*/ GIMT_Encode4(852007), // Rule ID 24133 //
     /*  851937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  851940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  851948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  851951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  851954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851983 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11545:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  851983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852005 */     GIR_RootConstrainSelectedInstOperands,
     /*  852006 */     // GIR_Coverage, 24133,
     /*  852006 */     GIR_EraseRootFromParent_Done,
     /*  852007 */   // Label 13098: @852007
     /*  852007 */   GIM_Try, /*On fail goto*//*Label 13099*/ GIMT_Encode4(852082), // Rule ID 24376 //
     /*  852012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  852023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  852026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  852029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852058 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  852061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852080 */     GIR_RootConstrainSelectedInstOperands,
     /*  852081 */     // GIR_Coverage, 24376,
     /*  852081 */     GIR_EraseRootFromParent_Done,
     /*  852082 */   // Label 13099: @852082
     /*  852082 */   GIM_Try, /*On fail goto*//*Label 13100*/ GIMT_Encode4(852157), // Rule ID 24377 //
     /*  852087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  852098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  852101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  852104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852133 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  852136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852155 */     GIR_RootConstrainSelectedInstOperands,
     /*  852156 */     // GIR_Coverage, 24377,
     /*  852156 */     GIR_EraseRootFromParent_Done,
     /*  852157 */   // Label 13100: @852157
     /*  852157 */   GIM_Try, /*On fail goto*//*Label 13101*/ GIMT_Encode4(852232), // Rule ID 24380 //
     /*  852162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  852173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  852176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  852179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852208 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  852211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852230 */     GIR_RootConstrainSelectedInstOperands,
     /*  852231 */     // GIR_Coverage, 24380,
     /*  852231 */     GIR_EraseRootFromParent_Done,
     /*  852232 */   // Label 13101: @852232
     /*  852232 */   GIM_Try, /*On fail goto*//*Label 13102*/ GIMT_Encode4(852307), // Rule ID 24381 //
     /*  852237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  852248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  852251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  852254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852283 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  852286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852305 */     GIR_RootConstrainSelectedInstOperands,
     /*  852306 */     // GIR_Coverage, 24381,
     /*  852306 */     GIR_EraseRootFromParent_Done,
     /*  852307 */   // Label 13102: @852307
     /*  852307 */   GIM_Try, /*On fail goto*//*Label 13103*/ GIMT_Encode4(852382), // Rule ID 24384 //
     /*  852312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  852315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  852323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  852326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  852329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852358 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  852361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852380 */     GIR_RootConstrainSelectedInstOperands,
     /*  852381 */     // GIR_Coverage, 24384,
     /*  852381 */     GIR_EraseRootFromParent_Done,
     /*  852382 */   // Label 13103: @852382
     /*  852382 */   GIM_Try, /*On fail goto*//*Label 13104*/ GIMT_Encode4(852457), // Rule ID 24385 //
     /*  852387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  852390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  852398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  852401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  852404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852433 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  852436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852455 */     GIR_RootConstrainSelectedInstOperands,
     /*  852456 */     // GIR_Coverage, 24385,
     /*  852456 */     GIR_EraseRootFromParent_Done,
     /*  852457 */   // Label 13104: @852457
     /*  852457 */   GIM_Try, /*On fail goto*//*Label 13105*/ GIMT_Encode4(852532), // Rule ID 24388 //
     /*  852462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  852476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852508 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  852511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852530 */     GIR_RootConstrainSelectedInstOperands,
     /*  852531 */     // GIR_Coverage, 24388,
     /*  852531 */     GIR_EraseRootFromParent_Done,
     /*  852532 */   // Label 13105: @852532
     /*  852532 */   GIM_Try, /*On fail goto*//*Label 13106*/ GIMT_Encode4(852607), // Rule ID 24389 //
     /*  852537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  852551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852583 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11273:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  852586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852605 */     GIR_RootConstrainSelectedInstOperands,
     /*  852606 */     // GIR_Coverage, 24389,
     /*  852606 */     GIR_EraseRootFromParent_Done,
     /*  852607 */   // Label 13106: @852607
     /*  852607 */   GIM_Try, /*On fail goto*//*Label 13107*/ GIMT_Encode4(852682), // Rule ID 24392 //
     /*  852612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  852615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  852626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852658 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  852661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852680 */     GIR_RootConstrainSelectedInstOperands,
     /*  852681 */     // GIR_Coverage, 24392,
     /*  852681 */     GIR_EraseRootFromParent_Done,
     /*  852682 */   // Label 13107: @852682
     /*  852682 */   GIM_Try, /*On fail goto*//*Label 13108*/ GIMT_Encode4(852757), // Rule ID 24393 //
     /*  852687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  852690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  852701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852733 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11273:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  852736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852755 */     GIR_RootConstrainSelectedInstOperands,
     /*  852756 */     // GIR_Coverage, 24393,
     /*  852756 */     GIR_EraseRootFromParent_Done,
     /*  852757 */   // Label 13108: @852757
     /*  852757 */   GIM_Try, /*On fail goto*//*Label 13109*/ GIMT_Encode4(852832), // Rule ID 24396 //
     /*  852762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  852765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  852773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  852776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  852779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  852801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852808 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  852811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852830 */     GIR_RootConstrainSelectedInstOperands,
     /*  852831 */     // GIR_Coverage, 24396,
     /*  852831 */     GIR_EraseRootFromParent_Done,
     /*  852832 */   // Label 13109: @852832
     /*  852832 */   GIM_Try, /*On fail goto*//*Label 13110*/ GIMT_Encode4(852907), // Rule ID 24397 //
     /*  852837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  852840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  852848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  852851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  852854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  852876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852883 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11273:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  852886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852905 */     GIR_RootConstrainSelectedInstOperands,
     /*  852906 */     // GIR_Coverage, 24397,
     /*  852906 */     GIR_EraseRootFromParent_Done,
     /*  852907 */   // Label 13110: @852907
     /*  852907 */   GIM_Try, /*On fail goto*//*Label 13111*/ GIMT_Encode4(852982), // Rule ID 24400 //
     /*  852912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  852923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  852926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  852929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852958 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  852961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852980 */     GIR_RootConstrainSelectedInstOperands,
     /*  852981 */     // GIR_Coverage, 24400,
     /*  852981 */     GIR_EraseRootFromParent_Done,
     /*  852982 */   // Label 13111: @852982
     /*  852982 */   GIM_Try, /*On fail goto*//*Label 13112*/ GIMT_Encode4(853057), // Rule ID 24401 //
     /*  852987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  852998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  853001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  853004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853033 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  853036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853055 */     GIR_RootConstrainSelectedInstOperands,
     /*  853056 */     // GIR_Coverage, 24401,
     /*  853056 */     GIR_EraseRootFromParent_Done,
     /*  853057 */   // Label 13112: @853057
     /*  853057 */   GIM_Try, /*On fail goto*//*Label 13113*/ GIMT_Encode4(853132), // Rule ID 24404 //
     /*  853062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  853073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  853076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  853079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853108 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  853111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853130 */     GIR_RootConstrainSelectedInstOperands,
     /*  853131 */     // GIR_Coverage, 24404,
     /*  853131 */     GIR_EraseRootFromParent_Done,
     /*  853132 */   // Label 13113: @853132
     /*  853132 */   GIM_Try, /*On fail goto*//*Label 13114*/ GIMT_Encode4(853207), // Rule ID 24405 //
     /*  853137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  853148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  853151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  853154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853183 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  853186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853205 */     GIR_RootConstrainSelectedInstOperands,
     /*  853206 */     // GIR_Coverage, 24405,
     /*  853206 */     GIR_EraseRootFromParent_Done,
     /*  853207 */   // Label 13114: @853207
     /*  853207 */   GIM_Try, /*On fail goto*//*Label 13115*/ GIMT_Encode4(853282), // Rule ID 24408 //
     /*  853212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  853223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  853226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  853229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853258 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  853261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853280 */     GIR_RootConstrainSelectedInstOperands,
     /*  853281 */     // GIR_Coverage, 24408,
     /*  853281 */     GIR_EraseRootFromParent_Done,
     /*  853282 */   // Label 13115: @853282
     /*  853282 */   GIM_Try, /*On fail goto*//*Label 13116*/ GIMT_Encode4(853357), // Rule ID 24409 //
     /*  853287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  853298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  853301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  853304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853333 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  853336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853355 */     GIR_RootConstrainSelectedInstOperands,
     /*  853356 */     // GIR_Coverage, 24409,
     /*  853356 */     GIR_EraseRootFromParent_Done,
     /*  853357 */   // Label 13116: @853357
     /*  853357 */   GIM_Try, /*On fail goto*//*Label 13117*/ GIMT_Encode4(853432), // Rule ID 24412 //
     /*  853362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  853373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  853376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  853379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853408 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  853411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853430 */     GIR_RootConstrainSelectedInstOperands,
     /*  853431 */     // GIR_Coverage, 24412,
     /*  853431 */     GIR_EraseRootFromParent_Done,
     /*  853432 */   // Label 13117: @853432
     /*  853432 */   GIM_Try, /*On fail goto*//*Label 13118*/ GIMT_Encode4(853507), // Rule ID 24413 //
     /*  853437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  853448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  853451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  853454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853483 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  853486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853505 */     GIR_RootConstrainSelectedInstOperands,
     /*  853506 */     // GIR_Coverage, 24413,
     /*  853506 */     GIR_EraseRootFromParent_Done,
     /*  853507 */   // Label 13118: @853507
     /*  853507 */   GIM_Try, /*On fail goto*//*Label 13119*/ GIMT_Encode4(853582), // Rule ID 24416 //
     /*  853512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  853523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  853526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  853529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853558 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  853561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853580 */     GIR_RootConstrainSelectedInstOperands,
     /*  853581 */     // GIR_Coverage, 24416,
     /*  853581 */     GIR_EraseRootFromParent_Done,
     /*  853582 */   // Label 13119: @853582
     /*  853582 */   GIM_Try, /*On fail goto*//*Label 13120*/ GIMT_Encode4(853657), // Rule ID 24417 //
     /*  853587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  853598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  853601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  853604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853633 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  853636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853655 */     GIR_RootConstrainSelectedInstOperands,
     /*  853656 */     // GIR_Coverage, 24417,
     /*  853656 */     GIR_EraseRootFromParent_Done,
     /*  853657 */   // Label 13120: @853657
     /*  853657 */   GIM_Try, /*On fail goto*//*Label 13121*/ GIMT_Encode4(853732), // Rule ID 24420 //
     /*  853662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  853673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  853676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  853679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  853711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853730 */     GIR_RootConstrainSelectedInstOperands,
     /*  853731 */     // GIR_Coverage, 24420,
     /*  853731 */     GIR_EraseRootFromParent_Done,
     /*  853732 */   // Label 13121: @853732
     /*  853732 */   GIM_Try, /*On fail goto*//*Label 13122*/ GIMT_Encode4(853807), // Rule ID 24421 //
     /*  853737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  853748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  853751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  853754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853783 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  853786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853805 */     GIR_RootConstrainSelectedInstOperands,
     /*  853806 */     // GIR_Coverage, 24421,
     /*  853806 */     GIR_EraseRootFromParent_Done,
     /*  853807 */   // Label 13122: @853807
     /*  853807 */   GIM_Try, /*On fail goto*//*Label 13123*/ GIMT_Encode4(853882), // Rule ID 24424 //
     /*  853812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  853815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  853823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  853826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  853829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853858 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  853858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  853861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853880 */     GIR_RootConstrainSelectedInstOperands,
     /*  853881 */     // GIR_Coverage, 24424,
     /*  853881 */     GIR_EraseRootFromParent_Done,
     /*  853882 */   // Label 13123: @853882
     /*  853882 */   GIM_Try, /*On fail goto*//*Label 13124*/ GIMT_Encode4(853957), // Rule ID 24425 //
     /*  853887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  853890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  853898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  853901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  853904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853933 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11273:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  853933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  853936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853955 */     GIR_RootConstrainSelectedInstOperands,
     /*  853956 */     // GIR_Coverage, 24425,
     /*  853956 */     GIR_EraseRootFromParent_Done,
     /*  853957 */   // Label 13124: @853957
     /*  853957 */   GIM_Try, /*On fail goto*//*Label 13125*/ GIMT_Encode4(854032), // Rule ID 24428 //
     /*  853962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  853965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  853973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  853976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  853979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854008 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  854011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854030 */     GIR_RootConstrainSelectedInstOperands,
     /*  854031 */     // GIR_Coverage, 24428,
     /*  854031 */     GIR_EraseRootFromParent_Done,
     /*  854032 */   // Label 13125: @854032
     /*  854032 */   GIM_Try, /*On fail goto*//*Label 13126*/ GIMT_Encode4(854107), // Rule ID 24429 //
     /*  854037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  854048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  854051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  854054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854083 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11273:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  854086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854105 */     GIR_RootConstrainSelectedInstOperands,
     /*  854106 */     // GIR_Coverage, 24429,
     /*  854106 */     GIR_EraseRootFromParent_Done,
     /*  854107 */   // Label 13126: @854107
     /*  854107 */   GIM_Try, /*On fail goto*//*Label 13127*/ GIMT_Encode4(854182), // Rule ID 24432 //
     /*  854112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  854115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  854123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  854126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  854129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854158 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  854161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854180 */     GIR_RootConstrainSelectedInstOperands,
     /*  854181 */     // GIR_Coverage, 24432,
     /*  854181 */     GIR_EraseRootFromParent_Done,
     /*  854182 */   // Label 13127: @854182
     /*  854182 */   GIM_Try, /*On fail goto*//*Label 13128*/ GIMT_Encode4(854257), // Rule ID 24433 //
     /*  854187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  854195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  854198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  854201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  854204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854233 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11273:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  854236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854255 */     GIR_RootConstrainSelectedInstOperands,
     /*  854256 */     // GIR_Coverage, 24433,
     /*  854256 */     GIR_EraseRootFromParent_Done,
     /*  854257 */   // Label 13128: @854257
     /*  854257 */   GIM_Try, /*On fail goto*//*Label 13129*/ GIMT_Encode4(854332), // Rule ID 24436 //
     /*  854262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  854273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  854276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  854279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854308 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  854311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854330 */     GIR_RootConstrainSelectedInstOperands,
     /*  854331 */     // GIR_Coverage, 24436,
     /*  854331 */     GIR_EraseRootFromParent_Done,
     /*  854332 */   // Label 13129: @854332
     /*  854332 */   GIM_Try, /*On fail goto*//*Label 13130*/ GIMT_Encode4(854407), // Rule ID 24437 //
     /*  854337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  854348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  854351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  854354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854383 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  854386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854405 */     GIR_RootConstrainSelectedInstOperands,
     /*  854406 */     // GIR_Coverage, 24437,
     /*  854406 */     GIR_EraseRootFromParent_Done,
     /*  854407 */   // Label 13130: @854407
     /*  854407 */   GIM_Try, /*On fail goto*//*Label 13131*/ GIMT_Encode4(854482), // Rule ID 24440 //
     /*  854412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  854423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  854426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  854429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854458 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  854461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854480 */     GIR_RootConstrainSelectedInstOperands,
     /*  854481 */     // GIR_Coverage, 24440,
     /*  854481 */     GIR_EraseRootFromParent_Done,
     /*  854482 */   // Label 13131: @854482
     /*  854482 */   GIM_Try, /*On fail goto*//*Label 13132*/ GIMT_Encode4(854557), // Rule ID 24441 //
     /*  854487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  854498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  854501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  854504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854533 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  854536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854555 */     GIR_RootConstrainSelectedInstOperands,
     /*  854556 */     // GIR_Coverage, 24441,
     /*  854556 */     GIR_EraseRootFromParent_Done,
     /*  854557 */   // Label 13132: @854557
     /*  854557 */   GIM_Try, /*On fail goto*//*Label 13133*/ GIMT_Encode4(854632), // Rule ID 24444 //
     /*  854562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  854565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  854573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  854576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  854579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  854611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854630 */     GIR_RootConstrainSelectedInstOperands,
     /*  854631 */     // GIR_Coverage, 24444,
     /*  854631 */     GIR_EraseRootFromParent_Done,
     /*  854632 */   // Label 13133: @854632
     /*  854632 */   GIM_Try, /*On fail goto*//*Label 13134*/ GIMT_Encode4(854707), // Rule ID 24445 //
     /*  854637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  854648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  854651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  854654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854683 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  854686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854705 */     GIR_RootConstrainSelectedInstOperands,
     /*  854706 */     // GIR_Coverage, 24445,
     /*  854706 */     GIR_EraseRootFromParent_Done,
     /*  854707 */   // Label 13134: @854707
     /*  854707 */   GIM_Try, /*On fail goto*//*Label 13135*/ GIMT_Encode4(854782), // Rule ID 24448 //
     /*  854712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  854723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  854726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  854729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854758 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  854761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854780 */     GIR_RootConstrainSelectedInstOperands,
     /*  854781 */     // GIR_Coverage, 24448,
     /*  854781 */     GIR_EraseRootFromParent_Done,
     /*  854782 */   // Label 13135: @854782
     /*  854782 */   GIM_Try, /*On fail goto*//*Label 13136*/ GIMT_Encode4(854857), // Rule ID 24449 //
     /*  854787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  854798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  854801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  854804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854833 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11271:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  854836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854855 */     GIR_RootConstrainSelectedInstOperands,
     /*  854856 */     // GIR_Coverage, 24449,
     /*  854856 */     GIR_EraseRootFromParent_Done,
     /*  854857 */   // Label 13136: @854857
     /*  854857 */   GIM_Try, /*On fail goto*//*Label 13137*/ GIMT_Encode4(854932), // Rule ID 24452 //
     /*  854862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  854865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  854873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  854876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  854879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  854911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854930 */     GIR_RootConstrainSelectedInstOperands,
     /*  854931 */     // GIR_Coverage, 24452,
     /*  854931 */     GIR_EraseRootFromParent_Done,
     /*  854932 */   // Label 13137: @854932
     /*  854932 */   GIM_Try, /*On fail goto*//*Label 13138*/ GIMT_Encode4(855007), // Rule ID 24453 //
     /*  854937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  854948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  854951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  854954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854983 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11271:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  854986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855005 */     GIR_RootConstrainSelectedInstOperands,
     /*  855006 */     // GIR_Coverage, 24453,
     /*  855006 */     GIR_EraseRootFromParent_Done,
     /*  855007 */   // Label 13138: @855007
     /*  855007 */   GIM_Try, /*On fail goto*//*Label 13139*/ GIMT_Encode4(855082), // Rule ID 24456 //
     /*  855012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  855015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  855023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  855026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  855029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  855061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855080 */     GIR_RootConstrainSelectedInstOperands,
     /*  855081 */     // GIR_Coverage, 24456,
     /*  855081 */     GIR_EraseRootFromParent_Done,
     /*  855082 */   // Label 13139: @855082
     /*  855082 */   GIM_Try, /*On fail goto*//*Label 13140*/ GIMT_Encode4(855157), // Rule ID 24457 //
     /*  855087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  855090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  855098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  855101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  855104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  855122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855133 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11271:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  855136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855155 */     GIR_RootConstrainSelectedInstOperands,
     /*  855156 */     // GIR_Coverage, 24457,
     /*  855156 */     GIR_EraseRootFromParent_Done,
     /*  855157 */   // Label 13140: @855157
     /*  855157 */   GIM_Try, /*On fail goto*//*Label 13141*/ GIMT_Encode4(855232), // Rule ID 24460 //
     /*  855162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  855173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  855176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  855179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855208 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  855211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855230 */     GIR_RootConstrainSelectedInstOperands,
     /*  855231 */     // GIR_Coverage, 24460,
     /*  855231 */     GIR_EraseRootFromParent_Done,
     /*  855232 */   // Label 13141: @855232
     /*  855232 */   GIM_Try, /*On fail goto*//*Label 13142*/ GIMT_Encode4(855307), // Rule ID 24461 //
     /*  855237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  855248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  855251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  855254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855283 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  855286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855305 */     GIR_RootConstrainSelectedInstOperands,
     /*  855306 */     // GIR_Coverage, 24461,
     /*  855306 */     GIR_EraseRootFromParent_Done,
     /*  855307 */   // Label 13142: @855307
     /*  855307 */   GIM_Try, /*On fail goto*//*Label 13143*/ GIMT_Encode4(855382), // Rule ID 24464 //
     /*  855312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  855326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855358 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  855361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855380 */     GIR_RootConstrainSelectedInstOperands,
     /*  855381 */     // GIR_Coverage, 24464,
     /*  855381 */     GIR_EraseRootFromParent_Done,
     /*  855382 */   // Label 13143: @855382
     /*  855382 */   GIM_Try, /*On fail goto*//*Label 13144*/ GIMT_Encode4(855457), // Rule ID 24465 //
     /*  855387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  855398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  855401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  855404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855433 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  855436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855455 */     GIR_RootConstrainSelectedInstOperands,
     /*  855456 */     // GIR_Coverage, 24465,
     /*  855456 */     GIR_EraseRootFromParent_Done,
     /*  855457 */   // Label 13144: @855457
     /*  855457 */   GIM_Try, /*On fail goto*//*Label 13145*/ GIMT_Encode4(855532), // Rule ID 24468 //
     /*  855462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  855465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  855476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855508 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  855511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855530 */     GIR_RootConstrainSelectedInstOperands,
     /*  855531 */     // GIR_Coverage, 24468,
     /*  855531 */     GIR_EraseRootFromParent_Done,
     /*  855532 */   // Label 13145: @855532
     /*  855532 */   GIM_Try, /*On fail goto*//*Label 13146*/ GIMT_Encode4(855607), // Rule ID 24469 //
     /*  855537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  855551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855583 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  855586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855605 */     GIR_RootConstrainSelectedInstOperands,
     /*  855606 */     // GIR_Coverage, 24469,
     /*  855606 */     GIR_EraseRootFromParent_Done,
     /*  855607 */   // Label 13146: @855607
     /*  855607 */   GIM_Try, /*On fail goto*//*Label 13147*/ GIMT_Encode4(855682), // Rule ID 24472 //
     /*  855612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  855626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855658 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  855661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855680 */     GIR_RootConstrainSelectedInstOperands,
     /*  855681 */     // GIR_Coverage, 24472,
     /*  855681 */     GIR_EraseRootFromParent_Done,
     /*  855682 */   // Label 13147: @855682
     /*  855682 */   GIM_Try, /*On fail goto*//*Label 13148*/ GIMT_Encode4(855757), // Rule ID 24473 //
     /*  855687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  855701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  855736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855755 */     GIR_RootConstrainSelectedInstOperands,
     /*  855756 */     // GIR_Coverage, 24473,
     /*  855756 */     GIR_EraseRootFromParent_Done,
     /*  855757 */   // Label 13148: @855757
     /*  855757 */   GIM_Try, /*On fail goto*//*Label 13149*/ GIMT_Encode4(855832), // Rule ID 24476 //
     /*  855762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855808 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  855811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855830 */     GIR_RootConstrainSelectedInstOperands,
     /*  855831 */     // GIR_Coverage, 24476,
     /*  855831 */     GIR_EraseRootFromParent_Done,
     /*  855832 */   // Label 13149: @855832
     /*  855832 */   GIM_Try, /*On fail goto*//*Label 13150*/ GIMT_Encode4(855907), // Rule ID 24477 //
     /*  855837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855883 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  855886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855905 */     GIR_RootConstrainSelectedInstOperands,
     /*  855906 */     // GIR_Coverage, 24477,
     /*  855906 */     GIR_EraseRootFromParent_Done,
     /*  855907 */   // Label 13150: @855907
     /*  855907 */   GIM_Try, /*On fail goto*//*Label 13151*/ GIMT_Encode4(855982), // Rule ID 24480 //
     /*  855912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  855923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  855926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  855929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855958 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  855961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855980 */     GIR_RootConstrainSelectedInstOperands,
     /*  855981 */     // GIR_Coverage, 24480,
     /*  855981 */     GIR_EraseRootFromParent_Done,
     /*  855982 */   // Label 13151: @855982
     /*  855982 */   GIM_Try, /*On fail goto*//*Label 13152*/ GIMT_Encode4(856057), // Rule ID 24481 //
     /*  855987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  855998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  856001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  856004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  856007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  856026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856033 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  856036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856055 */     GIR_RootConstrainSelectedInstOperands,
     /*  856056 */     // GIR_Coverage, 24481,
     /*  856056 */     GIR_EraseRootFromParent_Done,
     /*  856057 */   // Label 13152: @856057
     /*  856057 */   GIM_Try, /*On fail goto*//*Label 13153*/ GIMT_Encode4(856132), // Rule ID 24484 //
     /*  856062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  856073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  856076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  856079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  856111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856130 */     GIR_RootConstrainSelectedInstOperands,
     /*  856131 */     // GIR_Coverage, 24484,
     /*  856131 */     GIR_EraseRootFromParent_Done,
     /*  856132 */   // Label 13153: @856132
     /*  856132 */   GIM_Try, /*On fail goto*//*Label 13154*/ GIMT_Encode4(856207), // Rule ID 24485 //
     /*  856137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  856148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  856151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  856154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  856172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856183 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11271:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  856186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856205 */     GIR_RootConstrainSelectedInstOperands,
     /*  856206 */     // GIR_Coverage, 24485,
     /*  856206 */     GIR_EraseRootFromParent_Done,
     /*  856207 */   // Label 13154: @856207
     /*  856207 */   GIM_Try, /*On fail goto*//*Label 13155*/ GIMT_Encode4(856282), // Rule ID 24488 //
     /*  856212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  856223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  856226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  856229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856258 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  856261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856280 */     GIR_RootConstrainSelectedInstOperands,
     /*  856281 */     // GIR_Coverage, 24488,
     /*  856281 */     GIR_EraseRootFromParent_Done,
     /*  856282 */   // Label 13155: @856282
     /*  856282 */   GIM_Try, /*On fail goto*//*Label 13156*/ GIMT_Encode4(856357), // Rule ID 24489 //
     /*  856287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  856298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  856301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  856304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  856322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856333 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11271:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  856336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856355 */     GIR_RootConstrainSelectedInstOperands,
     /*  856356 */     // GIR_Coverage, 24489,
     /*  856356 */     GIR_EraseRootFromParent_Done,
     /*  856357 */   // Label 13156: @856357
     /*  856357 */   GIM_Try, /*On fail goto*//*Label 13157*/ GIMT_Encode4(856432), // Rule ID 24492 //
     /*  856362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  856365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  856373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  856376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  856379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856408 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  856408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  856411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856430 */     GIR_RootConstrainSelectedInstOperands,
     /*  856431 */     // GIR_Coverage, 24492,
     /*  856431 */     GIR_EraseRootFromParent_Done,
     /*  856432 */   // Label 13157: @856432
     /*  856432 */   GIM_Try, /*On fail goto*//*Label 13158*/ GIMT_Encode4(856507), // Rule ID 24493 //
     /*  856437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  856440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  856445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  856448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  856451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  856454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  856457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  856472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  856476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856483 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11271:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  856483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  856486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  856502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856505 */     GIR_RootConstrainSelectedInstOperands,
     /*  856506 */     // GIR_Coverage, 24493,
     /*  856506 */     GIR_EraseRootFromParent_Done,
     /*  856507 */   // Label 13158: @856507
     /*  856507 */   GIM_Try, /*On fail goto*//*Label 13159*/ GIMT_Encode4(856582), // Rule ID 24496 //
     /*  856512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  856523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  856526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  856529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  856532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856558 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  856561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856580 */     GIR_RootConstrainSelectedInstOperands,
     /*  856581 */     // GIR_Coverage, 24496,
     /*  856581 */     GIR_EraseRootFromParent_Done,
     /*  856582 */   // Label 13159: @856582
     /*  856582 */   GIM_Try, /*On fail goto*//*Label 13160*/ GIMT_Encode4(856657), // Rule ID 24497 //
     /*  856587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  856598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  856601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  856604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  856607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856633 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  856633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  856636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856655 */     GIR_RootConstrainSelectedInstOperands,
     /*  856656 */     // GIR_Coverage, 24497,
     /*  856656 */     GIR_EraseRootFromParent_Done,
     /*  856657 */   // Label 13160: @856657
     /*  856657 */   GIM_Try, /*On fail goto*//*Label 13161*/ GIMT_Encode4(856732), // Rule ID 24500 //
     /*  856662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  856673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  856676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  856679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  856682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856708 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  856711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856730 */     GIR_RootConstrainSelectedInstOperands,
     /*  856731 */     // GIR_Coverage, 24500,
     /*  856731 */     GIR_EraseRootFromParent_Done,
     /*  856732 */   // Label 13161: @856732
     /*  856732 */   GIM_Try, /*On fail goto*//*Label 13162*/ GIMT_Encode4(856807), // Rule ID 24501 //
     /*  856737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  856748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  856751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  856754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  856757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856783 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  856783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  856786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856805 */     GIR_RootConstrainSelectedInstOperands,
     /*  856806 */     // GIR_Coverage, 24501,
     /*  856806 */     GIR_EraseRootFromParent_Done,
     /*  856807 */   // Label 13162: @856807
     /*  856807 */   GIM_Try, /*On fail goto*//*Label 13163*/ GIMT_Encode4(856882), // Rule ID 24504 //
     /*  856812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  856823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  856826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  856829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  856832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856858 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  856861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856880 */     GIR_RootConstrainSelectedInstOperands,
     /*  856881 */     // GIR_Coverage, 24504,
     /*  856881 */     GIR_EraseRootFromParent_Done,
     /*  856882 */   // Label 13163: @856882
     /*  856882 */   GIM_Try, /*On fail goto*//*Label 13164*/ GIMT_Encode4(856957), // Rule ID 24505 //
     /*  856887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  856898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  856901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  856904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  856907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856933 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  856933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  856936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856955 */     GIR_RootConstrainSelectedInstOperands,
     /*  856956 */     // GIR_Coverage, 24505,
     /*  856956 */     GIR_EraseRootFromParent_Done,
     /*  856957 */   // Label 13164: @856957
     /*  856957 */   GIM_Try, /*On fail goto*//*Label 13165*/ GIMT_Encode4(857032), // Rule ID 24508 //
     /*  856962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  856973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  856976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  856979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  856982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857008 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  857011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857030 */     GIR_RootConstrainSelectedInstOperands,
     /*  857031 */     // GIR_Coverage, 24508,
     /*  857031 */     GIR_EraseRootFromParent_Done,
     /*  857032 */   // Label 13165: @857032
     /*  857032 */   GIM_Try, /*On fail goto*//*Label 13166*/ GIMT_Encode4(857107), // Rule ID 24509 //
     /*  857037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  857048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  857051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  857054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  857057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857083 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  857086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857105 */     GIR_RootConstrainSelectedInstOperands,
     /*  857106 */     // GIR_Coverage, 24509,
     /*  857106 */     GIR_EraseRootFromParent_Done,
     /*  857107 */   // Label 13166: @857107
     /*  857107 */   GIM_Try, /*On fail goto*//*Label 13167*/ GIMT_Encode4(857182), // Rule ID 24512 //
     /*  857112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  857123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  857126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  857129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  857132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857158 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  857161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857180 */     GIR_RootConstrainSelectedInstOperands,
     /*  857181 */     // GIR_Coverage, 24512,
     /*  857181 */     GIR_EraseRootFromParent_Done,
     /*  857182 */   // Label 13167: @857182
     /*  857182 */   GIM_Try, /*On fail goto*//*Label 13168*/ GIMT_Encode4(857257), // Rule ID 24513 //
     /*  857187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  857198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  857201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  857204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  857207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857233 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  857236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857255 */     GIR_RootConstrainSelectedInstOperands,
     /*  857256 */     // GIR_Coverage, 24513,
     /*  857256 */     GIR_EraseRootFromParent_Done,
     /*  857257 */   // Label 13168: @857257
     /*  857257 */   GIM_Try, /*On fail goto*//*Label 13169*/ GIMT_Encode4(857332), // Rule ID 24516 //
     /*  857262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  857273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  857276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  857279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  857282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857308 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  857311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857330 */     GIR_RootConstrainSelectedInstOperands,
     /*  857331 */     // GIR_Coverage, 24516,
     /*  857331 */     GIR_EraseRootFromParent_Done,
     /*  857332 */   // Label 13169: @857332
     /*  857332 */   GIM_Try, /*On fail goto*//*Label 13170*/ GIMT_Encode4(857407), // Rule ID 24517 //
     /*  857337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  857348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  857351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  857354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  857357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857383 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  857386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857405 */     GIR_RootConstrainSelectedInstOperands,
     /*  857406 */     // GIR_Coverage, 24517,
     /*  857406 */     GIR_EraseRootFromParent_Done,
     /*  857407 */   // Label 13170: @857407
     /*  857407 */   GIM_Try, /*On fail goto*//*Label 13171*/ GIMT_Encode4(857482), // Rule ID 24520 //
     /*  857412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  857423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  857426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  857429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  857432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  857461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857480 */     GIR_RootConstrainSelectedInstOperands,
     /*  857481 */     // GIR_Coverage, 24520,
     /*  857481 */     GIR_EraseRootFromParent_Done,
     /*  857482 */   // Label 13171: @857482
     /*  857482 */   GIM_Try, /*On fail goto*//*Label 13172*/ GIMT_Encode4(857557), // Rule ID 24521 //
     /*  857487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  857498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  857501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  857504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  857507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857533 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11519:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  857536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857555 */     GIR_RootConstrainSelectedInstOperands,
     /*  857556 */     // GIR_Coverage, 24521,
     /*  857556 */     GIR_EraseRootFromParent_Done,
     /*  857557 */   // Label 13172: @857557
     /*  857557 */   GIM_Try, /*On fail goto*//*Label 13173*/ GIMT_Encode4(857632), // Rule ID 24524 //
     /*  857562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  857573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  857576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  857579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  857582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  857611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857630 */     GIR_RootConstrainSelectedInstOperands,
     /*  857631 */     // GIR_Coverage, 24524,
     /*  857631 */     GIR_EraseRootFromParent_Done,
     /*  857632 */   // Label 13173: @857632
     /*  857632 */   GIM_Try, /*On fail goto*//*Label 13174*/ GIMT_Encode4(857707), // Rule ID 24525 //
     /*  857637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  857648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  857651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  857654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  857657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857683 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  857686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857705 */     GIR_RootConstrainSelectedInstOperands,
     /*  857706 */     // GIR_Coverage, 24525,
     /*  857706 */     GIR_EraseRootFromParent_Done,
     /*  857707 */   // Label 13174: @857707
     /*  857707 */   GIM_Try, /*On fail goto*//*Label 13175*/ GIMT_Encode4(857782), // Rule ID 24528 //
     /*  857712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  857723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  857726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  857729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  857732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  857761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857780 */     GIR_RootConstrainSelectedInstOperands,
     /*  857781 */     // GIR_Coverage, 24528,
     /*  857781 */     GIR_EraseRootFromParent_Done,
     /*  857782 */   // Label 13175: @857782
     /*  857782 */   GIM_Try, /*On fail goto*//*Label 13176*/ GIMT_Encode4(857857), // Rule ID 24529 //
     /*  857787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  857798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  857801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  857804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  857807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857833 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  857836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857855 */     GIR_RootConstrainSelectedInstOperands,
     /*  857856 */     // GIR_Coverage, 24529,
     /*  857856 */     GIR_EraseRootFromParent_Done,
     /*  857857 */   // Label 13176: @857857
     /*  857857 */   GIM_Try, /*On fail goto*//*Label 13177*/ GIMT_Encode4(857932), // Rule ID 24532 //
     /*  857862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  857865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  857873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  857876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  857879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  857882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  857908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  857911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857930 */     GIR_RootConstrainSelectedInstOperands,
     /*  857931 */     // GIR_Coverage, 24532,
     /*  857931 */     GIR_EraseRootFromParent_Done,
     /*  857932 */   // Label 13177: @857932
     /*  857932 */   GIM_Try, /*On fail goto*//*Label 13178*/ GIMT_Encode4(858007), // Rule ID 24533 //
     /*  857937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  857940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  857948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  857951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  857954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  857957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857983 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  857983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  857986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858005 */     GIR_RootConstrainSelectedInstOperands,
     /*  858006 */     // GIR_Coverage, 24533,
     /*  858006 */     GIR_EraseRootFromParent_Done,
     /*  858007 */   // Label 13178: @858007
     /*  858007 */   GIM_Try, /*On fail goto*//*Label 13179*/ GIMT_Encode4(858082), // Rule ID 24536 //
     /*  858012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  858023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  858026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  858029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  858032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858058 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  858061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858080 */     GIR_RootConstrainSelectedInstOperands,
     /*  858081 */     // GIR_Coverage, 24536,
     /*  858081 */     GIR_EraseRootFromParent_Done,
     /*  858082 */   // Label 13179: @858082
     /*  858082 */   GIM_Try, /*On fail goto*//*Label 13180*/ GIMT_Encode4(858157), // Rule ID 24537 //
     /*  858087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  858098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  858101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  858104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  858107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858133 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  858136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858155 */     GIR_RootConstrainSelectedInstOperands,
     /*  858156 */     // GIR_Coverage, 24537,
     /*  858156 */     GIR_EraseRootFromParent_Done,
     /*  858157 */   // Label 13180: @858157
     /*  858157 */   GIM_Try, /*On fail goto*//*Label 13181*/ GIMT_Encode4(858232), // Rule ID 24540 //
     /*  858162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  858173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  858176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  858179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  858182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858208 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  858211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858230 */     GIR_RootConstrainSelectedInstOperands,
     /*  858231 */     // GIR_Coverage, 24540,
     /*  858231 */     GIR_EraseRootFromParent_Done,
     /*  858232 */   // Label 13181: @858232
     /*  858232 */   GIM_Try, /*On fail goto*//*Label 13182*/ GIMT_Encode4(858307), // Rule ID 24541 //
     /*  858237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  858248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  858251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  858254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  858257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858283 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  858286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858305 */     GIR_RootConstrainSelectedInstOperands,
     /*  858306 */     // GIR_Coverage, 24541,
     /*  858306 */     GIR_EraseRootFromParent_Done,
     /*  858307 */   // Label 13182: @858307
     /*  858307 */   GIM_Try, /*On fail goto*//*Label 13183*/ GIMT_Encode4(858382), // Rule ID 24544 //
     /*  858312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  858323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  858326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  858329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  858332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858358 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  858358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  858361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858380 */     GIR_RootConstrainSelectedInstOperands,
     /*  858381 */     // GIR_Coverage, 24544,
     /*  858381 */     GIR_EraseRootFromParent_Done,
     /*  858382 */   // Label 13183: @858382
     /*  858382 */   GIM_Try, /*On fail goto*//*Label 13184*/ GIMT_Encode4(858457), // Rule ID 24545 //
     /*  858387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  858398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  858401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  858404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  858407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858433 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  858433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  858436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  858452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858455 */     GIR_RootConstrainSelectedInstOperands,
     /*  858456 */     // GIR_Coverage, 24545,
     /*  858456 */     GIR_EraseRootFromParent_Done,
     /*  858457 */   // Label 13184: @858457
     /*  858457 */   GIM_Try, /*On fail goto*//*Label 13185*/ GIMT_Encode4(858532), // Rule ID 24548 //
     /*  858462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  858473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  858476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  858479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  858482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  858511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858530 */     GIR_RootConstrainSelectedInstOperands,
     /*  858531 */     // GIR_Coverage, 24548,
     /*  858531 */     GIR_EraseRootFromParent_Done,
     /*  858532 */   // Label 13185: @858532
     /*  858532 */   GIM_Try, /*On fail goto*//*Label 13186*/ GIMT_Encode4(858607), // Rule ID 24549 //
     /*  858537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  858548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  858551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  858554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  858557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858583 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  858586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858605 */     GIR_RootConstrainSelectedInstOperands,
     /*  858606 */     // GIR_Coverage, 24549,
     /*  858606 */     GIR_EraseRootFromParent_Done,
     /*  858607 */   // Label 13186: @858607
     /*  858607 */   GIM_Try, /*On fail goto*//*Label 13187*/ GIMT_Encode4(858682), // Rule ID 24552 //
     /*  858612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  858623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  858626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  858629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  858632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  858661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858680 */     GIR_RootConstrainSelectedInstOperands,
     /*  858681 */     // GIR_Coverage, 24552,
     /*  858681 */     GIR_EraseRootFromParent_Done,
     /*  858682 */   // Label 13187: @858682
     /*  858682 */   GIM_Try, /*On fail goto*//*Label 13188*/ GIMT_Encode4(858757), // Rule ID 24553 //
     /*  858687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  858698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  858701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  858704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  858707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858733 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  858736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858755 */     GIR_RootConstrainSelectedInstOperands,
     /*  858756 */     // GIR_Coverage, 24553,
     /*  858756 */     GIR_EraseRootFromParent_Done,
     /*  858757 */   // Label 13188: @858757
     /*  858757 */   GIM_Try, /*On fail goto*//*Label 13189*/ GIMT_Encode4(858832), // Rule ID 24556 //
     /*  858762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  858773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  858776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  858779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  858782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858808 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  858811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858830 */     GIR_RootConstrainSelectedInstOperands,
     /*  858831 */     // GIR_Coverage, 24556,
     /*  858831 */     GIR_EraseRootFromParent_Done,
     /*  858832 */   // Label 13189: @858832
     /*  858832 */   GIM_Try, /*On fail goto*//*Label 13190*/ GIMT_Encode4(858907), // Rule ID 24557 //
     /*  858837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  858848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  858851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  858854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  858857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858883 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  858886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858905 */     GIR_RootConstrainSelectedInstOperands,
     /*  858906 */     // GIR_Coverage, 24557,
     /*  858906 */     GIR_EraseRootFromParent_Done,
     /*  858907 */   // Label 13190: @858907
     /*  858907 */   GIM_Try, /*On fail goto*//*Label 13191*/ GIMT_Encode4(858982), // Rule ID 24560 //
     /*  858912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  858923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  858926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  858929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  858932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  858961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858980 */     GIR_RootConstrainSelectedInstOperands,
     /*  858981 */     // GIR_Coverage, 24560,
     /*  858981 */     GIR_EraseRootFromParent_Done,
     /*  858982 */   // Label 13191: @858982
     /*  858982 */   GIM_Try, /*On fail goto*//*Label 13192*/ GIMT_Encode4(859057), // Rule ID 24561 //
     /*  858987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  858998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  859001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  859004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  859007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859033 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  859036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859055 */     GIR_RootConstrainSelectedInstOperands,
     /*  859056 */     // GIR_Coverage, 24561,
     /*  859056 */     GIR_EraseRootFromParent_Done,
     /*  859057 */   // Label 13192: @859057
     /*  859057 */   GIM_Try, /*On fail goto*//*Label 13193*/ GIMT_Encode4(859132), // Rule ID 24564 //
     /*  859062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  859082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859108 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  859111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859130 */     GIR_RootConstrainSelectedInstOperands,
     /*  859131 */     // GIR_Coverage, 24564,
     /*  859131 */     GIR_EraseRootFromParent_Done,
     /*  859132 */   // Label 13193: @859132
     /*  859132 */   GIM_Try, /*On fail goto*//*Label 13194*/ GIMT_Encode4(859207), // Rule ID 24565 //
     /*  859137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  859148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  859151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  859154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  859157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859183 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  859186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859205 */     GIR_RootConstrainSelectedInstOperands,
     /*  859206 */     // GIR_Coverage, 24565,
     /*  859206 */     GIR_EraseRootFromParent_Done,
     /*  859207 */   // Label 13194: @859207
     /*  859207 */   GIM_Try, /*On fail goto*//*Label 13195*/ GIMT_Encode4(859282), // Rule ID 24568 //
     /*  859212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  859232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859258 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  859258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  859261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859280 */     GIR_RootConstrainSelectedInstOperands,
     /*  859281 */     // GIR_Coverage, 24568,
     /*  859281 */     GIR_EraseRootFromParent_Done,
     /*  859282 */   // Label 13195: @859282
     /*  859282 */   GIM_Try, /*On fail goto*//*Label 13196*/ GIMT_Encode4(859357), // Rule ID 24569 //
     /*  859287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  859298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  859301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  859304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  859307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859333 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  859333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  859336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  859352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859355 */     GIR_RootConstrainSelectedInstOperands,
     /*  859356 */     // GIR_Coverage, 24569,
     /*  859356 */     GIR_EraseRootFromParent_Done,
     /*  859357 */   // Label 13196: @859357
     /*  859357 */   GIM_Try, /*On fail goto*//*Label 13197*/ GIMT_Encode4(859432), // Rule ID 24572 //
     /*  859362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  859382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  859411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859430 */     GIR_RootConstrainSelectedInstOperands,
     /*  859431 */     // GIR_Coverage, 24572,
     /*  859431 */     GIR_EraseRootFromParent_Done,
     /*  859432 */   // Label 13197: @859432
     /*  859432 */   GIM_Try, /*On fail goto*//*Label 13198*/ GIMT_Encode4(859507), // Rule ID 24573 //
     /*  859437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  859448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  859451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  859454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  859457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  859476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859483 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  859486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859505 */     GIR_RootConstrainSelectedInstOperands,
     /*  859506 */     // GIR_Coverage, 24573,
     /*  859506 */     GIR_EraseRootFromParent_Done,
     /*  859507 */   // Label 13198: @859507
     /*  859507 */   GIM_Try, /*On fail goto*//*Label 13199*/ GIMT_Encode4(859582), // Rule ID 24576 //
     /*  859512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  859523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  859526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  859529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  859532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859558 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  859561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859580 */     GIR_RootConstrainSelectedInstOperands,
     /*  859581 */     // GIR_Coverage, 24576,
     /*  859581 */     GIR_EraseRootFromParent_Done,
     /*  859582 */   // Label 13199: @859582
     /*  859582 */   GIM_Try, /*On fail goto*//*Label 13200*/ GIMT_Encode4(859657), // Rule ID 24577 //
     /*  859587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  859598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  859601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  859604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  859607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859633 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  859636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859655 */     GIR_RootConstrainSelectedInstOperands,
     /*  859656 */     // GIR_Coverage, 24577,
     /*  859656 */     GIR_EraseRootFromParent_Done,
     /*  859657 */   // Label 13200: @859657
     /*  859657 */   GIM_Try, /*On fail goto*//*Label 13201*/ GIMT_Encode4(859732), // Rule ID 24580 //
     /*  859662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  859673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  859676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  859679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  859682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859708 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  859711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859730 */     GIR_RootConstrainSelectedInstOperands,
     /*  859731 */     // GIR_Coverage, 24580,
     /*  859731 */     GIR_EraseRootFromParent_Done,
     /*  859732 */   // Label 13201: @859732
     /*  859732 */   GIM_Try, /*On fail goto*//*Label 13202*/ GIMT_Encode4(859807), // Rule ID 24581 //
     /*  859737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  859748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  859751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  859754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  859757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859783 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  859786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859805 */     GIR_RootConstrainSelectedInstOperands,
     /*  859806 */     // GIR_Coverage, 24581,
     /*  859806 */     GIR_EraseRootFromParent_Done,
     /*  859807 */   // Label 13202: @859807
     /*  859807 */   GIM_Try, /*On fail goto*//*Label 13203*/ GIMT_Encode4(859882), // Rule ID 24584 //
     /*  859812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  859823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  859826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  859829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859858 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  859858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  859861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859880 */     GIR_RootConstrainSelectedInstOperands,
     /*  859881 */     // GIR_Coverage, 24584,
     /*  859881 */     GIR_EraseRootFromParent_Done,
     /*  859882 */   // Label 13203: @859882
     /*  859882 */   GIM_Try, /*On fail goto*//*Label 13204*/ GIMT_Encode4(859957), // Rule ID 24585 //
     /*  859887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  859898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  859901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  859904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859933 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  859933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  859936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859955 */     GIR_RootConstrainSelectedInstOperands,
     /*  859956 */     // GIR_Coverage, 24585,
     /*  859956 */     GIR_EraseRootFromParent_Done,
     /*  859957 */   // Label 13204: @859957
     /*  859957 */   GIM_Try, /*On fail goto*//*Label 13205*/ GIMT_Encode4(860032), // Rule ID 24588 //
     /*  859962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  859973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  859976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  859979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860008 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860030 */     GIR_RootConstrainSelectedInstOperands,
     /*  860031 */     // GIR_Coverage, 24588,
     /*  860031 */     GIR_EraseRootFromParent_Done,
     /*  860032 */   // Label 13205: @860032
     /*  860032 */   GIM_Try, /*On fail goto*//*Label 13206*/ GIMT_Encode4(860107), // Rule ID 24589 //
     /*  860037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  860048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  860051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  860054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860083 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860105 */     GIR_RootConstrainSelectedInstOperands,
     /*  860106 */     // GIR_Coverage, 24589,
     /*  860106 */     GIR_EraseRootFromParent_Done,
     /*  860107 */   // Label 13206: @860107
     /*  860107 */   GIM_Try, /*On fail goto*//*Label 13207*/ GIMT_Encode4(860182), // Rule ID 24592 //
     /*  860112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860158 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860180 */     GIR_RootConstrainSelectedInstOperands,
     /*  860181 */     // GIR_Coverage, 24592,
     /*  860181 */     GIR_EraseRootFromParent_Done,
     /*  860182 */   // Label 13207: @860182
     /*  860182 */   GIM_Try, /*On fail goto*//*Label 13208*/ GIMT_Encode4(860257), // Rule ID 24593 //
     /*  860187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  860198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  860201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  860204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860233 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860255 */     GIR_RootConstrainSelectedInstOperands,
     /*  860256 */     // GIR_Coverage, 24593,
     /*  860256 */     GIR_EraseRootFromParent_Done,
     /*  860257 */   // Label 13208: @860257
     /*  860257 */   GIM_Try, /*On fail goto*//*Label 13209*/ GIMT_Encode4(860332), // Rule ID 24596 //
     /*  860262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860308 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860330 */     GIR_RootConstrainSelectedInstOperands,
     /*  860331 */     // GIR_Coverage, 24596,
     /*  860331 */     GIR_EraseRootFromParent_Done,
     /*  860332 */   // Label 13209: @860332
     /*  860332 */   GIM_Try, /*On fail goto*//*Label 13210*/ GIMT_Encode4(860407), // Rule ID 24597 //
     /*  860337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  860348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  860351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  860354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860383 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  860386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860405 */     GIR_RootConstrainSelectedInstOperands,
     /*  860406 */     // GIR_Coverage, 24597,
     /*  860406 */     GIR_EraseRootFromParent_Done,
     /*  860407 */   // Label 13210: @860407
     /*  860407 */   GIM_Try, /*On fail goto*//*Label 13211*/ GIMT_Encode4(860482), // Rule ID 24600 //
     /*  860412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860458 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860480 */     GIR_RootConstrainSelectedInstOperands,
     /*  860481 */     // GIR_Coverage, 24600,
     /*  860481 */     GIR_EraseRootFromParent_Done,
     /*  860482 */   // Label 13211: @860482
     /*  860482 */   GIM_Try, /*On fail goto*//*Label 13212*/ GIMT_Encode4(860557), // Rule ID 24601 //
     /*  860487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  860498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  860501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  860504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860533 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860555 */     GIR_RootConstrainSelectedInstOperands,
     /*  860556 */     // GIR_Coverage, 24601,
     /*  860556 */     GIR_EraseRootFromParent_Done,
     /*  860557 */   // Label 13212: @860557
     /*  860557 */   GIM_Try, /*On fail goto*//*Label 13213*/ GIMT_Encode4(860632), // Rule ID 24604 //
     /*  860562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  860573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  860576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  860579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860608 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  860608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  860627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860630 */     GIR_RootConstrainSelectedInstOperands,
     /*  860631 */     // GIR_Coverage, 24604,
     /*  860631 */     GIR_EraseRootFromParent_Done,
     /*  860632 */   // Label 13213: @860632
     /*  860632 */   GIM_Try, /*On fail goto*//*Label 13214*/ GIMT_Encode4(860707), // Rule ID 24605 //
     /*  860637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  860648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  860651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  860654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860683 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  860683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  860702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860705 */     GIR_RootConstrainSelectedInstOperands,
     /*  860706 */     // GIR_Coverage, 24605,
     /*  860706 */     GIR_EraseRootFromParent_Done,
     /*  860707 */   // Label 13214: @860707
     /*  860707 */   GIM_Try, /*On fail goto*//*Label 13215*/ GIMT_Encode4(860782), // Rule ID 24608 //
     /*  860712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  860723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  860726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  860729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860780 */     GIR_RootConstrainSelectedInstOperands,
     /*  860781 */     // GIR_Coverage, 24608,
     /*  860781 */     GIR_EraseRootFromParent_Done,
     /*  860782 */   // Label 13215: @860782
     /*  860782 */   GIM_Try, /*On fail goto*//*Label 13216*/ GIMT_Encode4(860857), // Rule ID 24609 //
     /*  860787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  860798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  860801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  860804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860833 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11521:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860855 */     GIR_RootConstrainSelectedInstOperands,
     /*  860856 */     // GIR_Coverage, 24609,
     /*  860856 */     GIR_EraseRootFromParent_Done,
     /*  860857 */   // Label 13216: @860857
     /*  860857 */   GIM_Try, /*On fail goto*//*Label 13217*/ GIMT_Encode4(860932), // Rule ID 24612 //
     /*  860862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  860873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  860876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  860879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860930 */     GIR_RootConstrainSelectedInstOperands,
     /*  860931 */     // GIR_Coverage, 24612,
     /*  860931 */     GIR_EraseRootFromParent_Done,
     /*  860932 */   // Label 13217: @860932
     /*  860932 */   GIM_Try, /*On fail goto*//*Label 13218*/ GIMT_Encode4(861007), // Rule ID 24613 //
     /*  860937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  860948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  860951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  860954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860983 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861005 */     GIR_RootConstrainSelectedInstOperands,
     /*  861006 */     // GIR_Coverage, 24613,
     /*  861006 */     GIR_EraseRootFromParent_Done,
     /*  861007 */   // Label 13218: @861007
     /*  861007 */   GIM_Try, /*On fail goto*//*Label 13219*/ GIMT_Encode4(861082), // Rule ID 24616 //
     /*  861012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861080 */     GIR_RootConstrainSelectedInstOperands,
     /*  861081 */     // GIR_Coverage, 24616,
     /*  861081 */     GIR_EraseRootFromParent_Done,
     /*  861082 */   // Label 13219: @861082
     /*  861082 */   GIM_Try, /*On fail goto*//*Label 13220*/ GIMT_Encode4(861157), // Rule ID 24617 //
     /*  861087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  861098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  861101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  861104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861133 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861155 */     GIR_RootConstrainSelectedInstOperands,
     /*  861156 */     // GIR_Coverage, 24617,
     /*  861156 */     GIR_EraseRootFromParent_Done,
     /*  861157 */   // Label 13220: @861157
     /*  861157 */   GIM_Try, /*On fail goto*//*Label 13221*/ GIMT_Encode4(861232), // Rule ID 24620 //
     /*  861162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  861165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861208 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  861208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861230 */     GIR_RootConstrainSelectedInstOperands,
     /*  861231 */     // GIR_Coverage, 24620,
     /*  861231 */     GIR_EraseRootFromParent_Done,
     /*  861232 */   // Label 13221: @861232
     /*  861232 */   GIM_Try, /*On fail goto*//*Label 13222*/ GIMT_Encode4(861307), // Rule ID 24621 //
     /*  861237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  861240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  861248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  861251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  861254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  861272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861283 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  861283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  861286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  861302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861305 */     GIR_RootConstrainSelectedInstOperands,
     /*  861306 */     // GIR_Coverage, 24621,
     /*  861306 */     GIR_EraseRootFromParent_Done,
     /*  861307 */   // Label 13222: @861307
     /*  861307 */   GIM_Try, /*On fail goto*//*Label 13223*/ GIMT_Encode4(861382), // Rule ID 24624 //
     /*  861312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861380 */     GIR_RootConstrainSelectedInstOperands,
     /*  861381 */     // GIR_Coverage, 24624,
     /*  861381 */     GIR_EraseRootFromParent_Done,
     /*  861382 */   // Label 13223: @861382
     /*  861382 */   GIM_Try, /*On fail goto*//*Label 13224*/ GIMT_Encode4(861457), // Rule ID 24625 //
     /*  861387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  861398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  861401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  861404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861433 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861455 */     GIR_RootConstrainSelectedInstOperands,
     /*  861456 */     // GIR_Coverage, 24625,
     /*  861456 */     GIR_EraseRootFromParent_Done,
     /*  861457 */   // Label 13224: @861457
     /*  861457 */   GIM_Try, /*On fail goto*//*Label 13225*/ GIMT_Encode4(861532), // Rule ID 24628 //
     /*  861462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  861473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  861476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  861479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861508 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861530 */     GIR_RootConstrainSelectedInstOperands,
     /*  861531 */     // GIR_Coverage, 24628,
     /*  861531 */     GIR_EraseRootFromParent_Done,
     /*  861532 */   // Label 13225: @861532
     /*  861532 */   GIM_Try, /*On fail goto*//*Label 13226*/ GIMT_Encode4(861607), // Rule ID 24629 //
     /*  861537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  861548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  861551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  861554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861583 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861605 */     GIR_RootConstrainSelectedInstOperands,
     /*  861606 */     // GIR_Coverage, 24629,
     /*  861606 */     GIR_EraseRootFromParent_Done,
     /*  861607 */   // Label 13226: @861607
     /*  861607 */   GIM_Try, /*On fail goto*//*Label 13227*/ GIMT_Encode4(861682), // Rule ID 24632 //
     /*  861612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  861623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  861626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  861629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861658 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  861661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861680 */     GIR_RootConstrainSelectedInstOperands,
     /*  861681 */     // GIR_Coverage, 24632,
     /*  861681 */     GIR_EraseRootFromParent_Done,
     /*  861682 */   // Label 13227: @861682
     /*  861682 */   GIM_Try, /*On fail goto*//*Label 13228*/ GIMT_Encode4(861757), // Rule ID 24633 //
     /*  861687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  861698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  861701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  861704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861733 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  861736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861755 */     GIR_RootConstrainSelectedInstOperands,
     /*  861756 */     // GIR_Coverage, 24633,
     /*  861756 */     GIR_EraseRootFromParent_Done,
     /*  861757 */   // Label 13228: @861757
     /*  861757 */   GIM_Try, /*On fail goto*//*Label 13229*/ GIMT_Encode4(861832), // Rule ID 24636 //
     /*  861762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  861773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  861776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  861779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861830 */     GIR_RootConstrainSelectedInstOperands,
     /*  861831 */     // GIR_Coverage, 24636,
     /*  861831 */     GIR_EraseRootFromParent_Done,
     /*  861832 */   // Label 13229: @861832
     /*  861832 */   GIM_Try, /*On fail goto*//*Label 13230*/ GIMT_Encode4(861907), // Rule ID 24637 //
     /*  861837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  861848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  861851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  861854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861883 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861905 */     GIR_RootConstrainSelectedInstOperands,
     /*  861906 */     // GIR_Coverage, 24637,
     /*  861906 */     GIR_EraseRootFromParent_Done,
     /*  861907 */   // Label 13230: @861907
     /*  861907 */   GIM_Try, /*On fail goto*//*Label 13231*/ GIMT_Encode4(861982), // Rule ID 24640 //
     /*  861912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  861923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  861926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  861929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861958 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861980 */     GIR_RootConstrainSelectedInstOperands,
     /*  861981 */     // GIR_Coverage, 24640,
     /*  861981 */     GIR_EraseRootFromParent_Done,
     /*  861982 */   // Label 13231: @861982
     /*  861982 */   GIM_Try, /*On fail goto*//*Label 13232*/ GIMT_Encode4(862057), // Rule ID 24641 //
     /*  861987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  861998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  862001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  862004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862033 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862055 */     GIR_RootConstrainSelectedInstOperands,
     /*  862056 */     // GIR_Coverage, 24641,
     /*  862056 */     GIR_EraseRootFromParent_Done,
     /*  862057 */   // Label 13232: @862057
     /*  862057 */   GIM_Try, /*On fail goto*//*Label 13233*/ GIMT_Encode4(862132), // Rule ID 24644 //
     /*  862062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862108 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  862108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862130 */     GIR_RootConstrainSelectedInstOperands,
     /*  862131 */     // GIR_Coverage, 24644,
     /*  862131 */     GIR_EraseRootFromParent_Done,
     /*  862132 */   // Label 13233: @862132
     /*  862132 */   GIM_Try, /*On fail goto*//*Label 13234*/ GIMT_Encode4(862207), // Rule ID 24645 //
     /*  862137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  862148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  862151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  862154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862183 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  862183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  862202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862205 */     GIR_RootConstrainSelectedInstOperands,
     /*  862206 */     // GIR_Coverage, 24645,
     /*  862206 */     GIR_EraseRootFromParent_Done,
     /*  862207 */   // Label 13234: @862207
     /*  862207 */   GIM_Try, /*On fail goto*//*Label 13235*/ GIMT_Encode4(862282), // Rule ID 24648 //
     /*  862212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862280 */     GIR_RootConstrainSelectedInstOperands,
     /*  862281 */     // GIR_Coverage, 24648,
     /*  862281 */     GIR_EraseRootFromParent_Done,
     /*  862282 */   // Label 13235: @862282
     /*  862282 */   GIM_Try, /*On fail goto*//*Label 13236*/ GIMT_Encode4(862357), // Rule ID 24649 //
     /*  862287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  862298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  862301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  862304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862355 */     GIR_RootConstrainSelectedInstOperands,
     /*  862356 */     // GIR_Coverage, 24649,
     /*  862356 */     GIR_EraseRootFromParent_Done,
     /*  862357 */   // Label 13236: @862357
     /*  862357 */   GIM_Try, /*On fail goto*//*Label 13237*/ GIMT_Encode4(862432), // Rule ID 24652 //
     /*  862362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862430 */     GIR_RootConstrainSelectedInstOperands,
     /*  862431 */     // GIR_Coverage, 24652,
     /*  862431 */     GIR_EraseRootFromParent_Done,
     /*  862432 */   // Label 13237: @862432
     /*  862432 */   GIM_Try, /*On fail goto*//*Label 13238*/ GIMT_Encode4(862507), // Rule ID 24653 //
     /*  862437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  862448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  862451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  862454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862483 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862505 */     GIR_RootConstrainSelectedInstOperands,
     /*  862506 */     // GIR_Coverage, 24653,
     /*  862506 */     GIR_EraseRootFromParent_Done,
     /*  862507 */   // Label 13238: @862507
     /*  862507 */   GIM_Try, /*On fail goto*//*Label 13239*/ GIMT_Encode4(862582), // Rule ID 24656 //
     /*  862512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  862526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862580 */     GIR_RootConstrainSelectedInstOperands,
     /*  862581 */     // GIR_Coverage, 24656,
     /*  862581 */     GIR_EraseRootFromParent_Done,
     /*  862582 */   // Label 13239: @862582
     /*  862582 */   GIM_Try, /*On fail goto*//*Label 13240*/ GIMT_Encode4(862657), // Rule ID 24657 //
     /*  862587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  862601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862633 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862655 */     GIR_RootConstrainSelectedInstOperands,
     /*  862656 */     // GIR_Coverage, 24657,
     /*  862656 */     GIR_EraseRootFromParent_Done,
     /*  862657 */   // Label 13240: @862657
     /*  862657 */   GIM_Try, /*On fail goto*//*Label 13241*/ GIMT_Encode4(862732), // Rule ID 24660 //
     /*  862662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  862665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  862673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  862676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  862679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862708 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  862708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862730 */     GIR_RootConstrainSelectedInstOperands,
     /*  862731 */     // GIR_Coverage, 24660,
     /*  862731 */     GIR_EraseRootFromParent_Done,
     /*  862732 */   // Label 13241: @862732
     /*  862732 */   GIM_Try, /*On fail goto*//*Label 13242*/ GIMT_Encode4(862807), // Rule ID 24661 //
     /*  862737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  862740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  862748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  862751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  862754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862783 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  862783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862805 */     GIR_RootConstrainSelectedInstOperands,
     /*  862806 */     // GIR_Coverage, 24661,
     /*  862806 */     GIR_EraseRootFromParent_Done,
     /*  862807 */   // Label 13242: @862807
     /*  862807 */   GIM_Try, /*On fail goto*//*Label 13243*/ GIMT_Encode4(862882), // Rule ID 24664 //
     /*  862812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  862815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  862823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  862826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  862829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862858 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  862858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862880 */     GIR_RootConstrainSelectedInstOperands,
     /*  862881 */     // GIR_Coverage, 24664,
     /*  862881 */     GIR_EraseRootFromParent_Done,
     /*  862882 */   // Label 13243: @862882
     /*  862882 */   GIM_Try, /*On fail goto*//*Label 13244*/ GIMT_Encode4(862957), // Rule ID 24665 //
     /*  862887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  862890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  862898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  862901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  862904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862933 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  862933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862955 */     GIR_RootConstrainSelectedInstOperands,
     /*  862956 */     // GIR_Coverage, 24665,
     /*  862956 */     GIR_EraseRootFromParent_Done,
     /*  862957 */   // Label 13244: @862957
     /*  862957 */   GIM_Try, /*On fail goto*//*Label 13245*/ GIMT_Encode4(863032), // Rule ID 24668 //
     /*  862962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  862965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  862973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  862976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  862979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863008 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  863008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863030 */     GIR_RootConstrainSelectedInstOperands,
     /*  863031 */     // GIR_Coverage, 24668,
     /*  863031 */     GIR_EraseRootFromParent_Done,
     /*  863032 */   // Label 13245: @863032
     /*  863032 */   GIM_Try, /*On fail goto*//*Label 13246*/ GIMT_Encode4(863107), // Rule ID 24669 //
     /*  863037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  863040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  863045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  863048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  863051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  863054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  863057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  863072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  863076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863083 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  863083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  863086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  863102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863105 */     GIR_RootConstrainSelectedInstOperands,
     /*  863106 */     // GIR_Coverage, 24669,
     /*  863106 */     GIR_EraseRootFromParent_Done,
     /*  863107 */   // Label 13246: @863107
     /*  863107 */   GIM_Try, /*On fail goto*//*Label 13247*/ GIMT_Encode4(863182), // Rule ID 24760 //
     /*  863112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863158 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  863161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863180 */     GIR_RootConstrainSelectedInstOperands,
     /*  863181 */     // GIR_Coverage, 24760,
     /*  863181 */     GIR_EraseRootFromParent_Done,
     /*  863182 */   // Label 13247: @863182
     /*  863182 */   GIM_Try, /*On fail goto*//*Label 13248*/ GIMT_Encode4(863257), // Rule ID 24761 //
     /*  863187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  863198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  863201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  863204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863233 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  863236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863255 */     GIR_RootConstrainSelectedInstOperands,
     /*  863256 */     // GIR_Coverage, 24761,
     /*  863256 */     GIR_EraseRootFromParent_Done,
     /*  863257 */   // Label 13248: @863257
     /*  863257 */   GIM_Try, /*On fail goto*//*Label 13249*/ GIMT_Encode4(863332), // Rule ID 24764 //
     /*  863262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863308 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  863311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863330 */     GIR_RootConstrainSelectedInstOperands,
     /*  863331 */     // GIR_Coverage, 24764,
     /*  863331 */     GIR_EraseRootFromParent_Done,
     /*  863332 */   // Label 13249: @863332
     /*  863332 */   GIM_Try, /*On fail goto*//*Label 13250*/ GIMT_Encode4(863407), // Rule ID 24765 //
     /*  863337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  863348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  863351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  863354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863383 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  863386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863405 */     GIR_RootConstrainSelectedInstOperands,
     /*  863406 */     // GIR_Coverage, 24765,
     /*  863406 */     GIR_EraseRootFromParent_Done,
     /*  863407 */   // Label 13250: @863407
     /*  863407 */   GIM_Try, /*On fail goto*//*Label 13251*/ GIMT_Encode4(863482), // Rule ID 24768 //
     /*  863412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  863461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863480 */     GIR_RootConstrainSelectedInstOperands,
     /*  863481 */     // GIR_Coverage, 24768,
     /*  863481 */     GIR_EraseRootFromParent_Done,
     /*  863482 */   // Label 13251: @863482
     /*  863482 */   GIM_Try, /*On fail goto*//*Label 13252*/ GIMT_Encode4(863557), // Rule ID 24769 //
     /*  863487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  863498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  863501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  863504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863533 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  863536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863555 */     GIR_RootConstrainSelectedInstOperands,
     /*  863556 */     // GIR_Coverage, 24769,
     /*  863556 */     GIR_EraseRootFromParent_Done,
     /*  863557 */   // Label 13252: @863557
     /*  863557 */   GIM_Try, /*On fail goto*//*Label 13253*/ GIMT_Encode4(863632), // Rule ID 24772 //
     /*  863562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  863573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  863576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  863579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863608 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  863608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  863611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863630 */     GIR_RootConstrainSelectedInstOperands,
     /*  863631 */     // GIR_Coverage, 24772,
     /*  863631 */     GIR_EraseRootFromParent_Done,
     /*  863632 */   // Label 13253: @863632
     /*  863632 */   GIM_Try, /*On fail goto*//*Label 13254*/ GIMT_Encode4(863707), // Rule ID 24773 //
     /*  863637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  863648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  863651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  863654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863683 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  863683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  863686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863705 */     GIR_RootConstrainSelectedInstOperands,
     /*  863706 */     // GIR_Coverage, 24773,
     /*  863706 */     GIR_EraseRootFromParent_Done,
     /*  863707 */   // Label 13254: @863707
     /*  863707 */   GIM_Try, /*On fail goto*//*Label 13255*/ GIMT_Encode4(863782), // Rule ID 24776 //
     /*  863712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  863723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  863726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  863729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863758 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  863758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  863761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863780 */     GIR_RootConstrainSelectedInstOperands,
     /*  863781 */     // GIR_Coverage, 24776,
     /*  863781 */     GIR_EraseRootFromParent_Done,
     /*  863782 */   // Label 13255: @863782
     /*  863782 */   GIM_Try, /*On fail goto*//*Label 13256*/ GIMT_Encode4(863857), // Rule ID 24777 //
     /*  863787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  863798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  863801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  863804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863833 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  863833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  863836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863855 */     GIR_RootConstrainSelectedInstOperands,
     /*  863856 */     // GIR_Coverage, 24777,
     /*  863856 */     GIR_EraseRootFromParent_Done,
     /*  863857 */   // Label 13256: @863857
     /*  863857 */   GIM_Try, /*On fail goto*//*Label 13257*/ GIMT_Encode4(863932), // Rule ID 24780 //
     /*  863862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  863873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  863876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  863879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863908 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  863908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  863911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863930 */     GIR_RootConstrainSelectedInstOperands,
     /*  863931 */     // GIR_Coverage, 24780,
     /*  863931 */     GIR_EraseRootFromParent_Done,
     /*  863932 */   // Label 13257: @863932
     /*  863932 */   GIM_Try, /*On fail goto*//*Label 13258*/ GIMT_Encode4(864007), // Rule ID 24781 //
     /*  863937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  863948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  863951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  863954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863983 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  863986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864005 */     GIR_RootConstrainSelectedInstOperands,
     /*  864006 */     // GIR_Coverage, 24781,
     /*  864006 */     GIR_EraseRootFromParent_Done,
     /*  864007 */   // Label 13258: @864007
     /*  864007 */   GIM_Try, /*On fail goto*//*Label 13259*/ GIMT_Encode4(864082), // Rule ID 24784 //
     /*  864012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  864061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864080 */     GIR_RootConstrainSelectedInstOperands,
     /*  864081 */     // GIR_Coverage, 24784,
     /*  864081 */     GIR_EraseRootFromParent_Done,
     /*  864082 */   // Label 13259: @864082
     /*  864082 */   GIM_Try, /*On fail goto*//*Label 13260*/ GIMT_Encode4(864157), // Rule ID 24785 //
     /*  864087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  864098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  864101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  864104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864133 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11523:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  864136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864155 */     GIR_RootConstrainSelectedInstOperands,
     /*  864156 */     // GIR_Coverage, 24785,
     /*  864156 */     GIR_EraseRootFromParent_Done,
     /*  864157 */   // Label 13260: @864157
     /*  864157 */   GIM_Try, /*On fail goto*//*Label 13261*/ GIMT_Encode4(864232), // Rule ID 24788 //
     /*  864162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  864211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864230 */     GIR_RootConstrainSelectedInstOperands,
     /*  864231 */     // GIR_Coverage, 24788,
     /*  864231 */     GIR_EraseRootFromParent_Done,
     /*  864232 */   // Label 13261: @864232
     /*  864232 */   GIM_Try, /*On fail goto*//*Label 13262*/ GIMT_Encode4(864307), // Rule ID 24789 //
     /*  864237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  864248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  864251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  864254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864283 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  864286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864305 */     GIR_RootConstrainSelectedInstOperands,
     /*  864306 */     // GIR_Coverage, 24789,
     /*  864306 */     GIR_EraseRootFromParent_Done,
     /*  864307 */   // Label 13262: @864307
     /*  864307 */   GIM_Try, /*On fail goto*//*Label 13263*/ GIMT_Encode4(864382), // Rule ID 24792 //
     /*  864312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  864361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864380 */     GIR_RootConstrainSelectedInstOperands,
     /*  864381 */     // GIR_Coverage, 24792,
     /*  864381 */     GIR_EraseRootFromParent_Done,
     /*  864382 */   // Label 13263: @864382
     /*  864382 */   GIM_Try, /*On fail goto*//*Label 13264*/ GIMT_Encode4(864457), // Rule ID 24793 //
     /*  864387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  864398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  864401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  864404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  864407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864433 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  864436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864455 */     GIR_RootConstrainSelectedInstOperands,
     /*  864456 */     // GIR_Coverage, 24793,
     /*  864456 */     GIR_EraseRootFromParent_Done,
     /*  864457 */   // Label 13264: @864457
     /*  864457 */   GIM_Try, /*On fail goto*//*Label 13265*/ GIMT_Encode4(864532), // Rule ID 24796 //
     /*  864462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  864465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  864473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  864476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  864479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  864508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  864511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  864527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864530 */     GIR_RootConstrainSelectedInstOperands,
     /*  864531 */     // GIR_Coverage, 24796,
     /*  864531 */     GIR_EraseRootFromParent_Done,
     /*  864532 */   // Label 13265: @864532
     /*  864532 */   GIM_Try, /*On fail goto*//*Label 13266*/ GIMT_Encode4(864607), // Rule ID 24797 //
     /*  864537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  864540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  864548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  864551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  864554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864583 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  864583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  864586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  864602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864605 */     GIR_RootConstrainSelectedInstOperands,
     /*  864606 */     // GIR_Coverage, 24797,
     /*  864606 */     GIR_EraseRootFromParent_Done,
     /*  864607 */   // Label 13266: @864607
     /*  864607 */   GIM_Try, /*On fail goto*//*Label 13267*/ GIMT_Encode4(864682), // Rule ID 24800 //
     /*  864612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  864623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  864626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  864629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  864632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864658 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  864661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864680 */     GIR_RootConstrainSelectedInstOperands,
     /*  864681 */     // GIR_Coverage, 24800,
     /*  864681 */     GIR_EraseRootFromParent_Done,
     /*  864682 */   // Label 13267: @864682
     /*  864682 */   GIM_Try, /*On fail goto*//*Label 13268*/ GIMT_Encode4(864757), // Rule ID 24801 //
     /*  864687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  864698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  864701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  864704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  864707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864733 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  864736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864755 */     GIR_RootConstrainSelectedInstOperands,
     /*  864756 */     // GIR_Coverage, 24801,
     /*  864756 */     GIR_EraseRootFromParent_Done,
     /*  864757 */   // Label 13268: @864757
     /*  864757 */   GIM_Try, /*On fail goto*//*Label 13269*/ GIMT_Encode4(864832), // Rule ID 24804 //
     /*  864762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  864773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  864776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  864779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  864782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864808 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  864811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864830 */     GIR_RootConstrainSelectedInstOperands,
     /*  864831 */     // GIR_Coverage, 24804,
     /*  864831 */     GIR_EraseRootFromParent_Done,
     /*  864832 */   // Label 13269: @864832
     /*  864832 */   GIM_Try, /*On fail goto*//*Label 13270*/ GIMT_Encode4(864907), // Rule ID 24805 //
     /*  864837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  864848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  864851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  864854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  864857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864883 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  864886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864905 */     GIR_RootConstrainSelectedInstOperands,
     /*  864906 */     // GIR_Coverage, 24805,
     /*  864906 */     GIR_EraseRootFromParent_Done,
     /*  864907 */   // Label 13270: @864907
     /*  864907 */   GIM_Try, /*On fail goto*//*Label 13271*/ GIMT_Encode4(864982), // Rule ID 24808 //
     /*  864912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  864923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  864926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  864929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864958 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  864961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864980 */     GIR_RootConstrainSelectedInstOperands,
     /*  864981 */     // GIR_Coverage, 24808,
     /*  864981 */     GIR_EraseRootFromParent_Done,
     /*  864982 */   // Label 13271: @864982
     /*  864982 */   GIM_Try, /*On fail goto*//*Label 13272*/ GIMT_Encode4(865057), // Rule ID 24809 //
     /*  864987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  864998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  865001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  865004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865033 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  865036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865055 */     GIR_RootConstrainSelectedInstOperands,
     /*  865056 */     // GIR_Coverage, 24809,
     /*  865056 */     GIR_EraseRootFromParent_Done,
     /*  865057 */   // Label 13272: @865057
     /*  865057 */   GIM_Try, /*On fail goto*//*Label 13273*/ GIMT_Encode4(865132), // Rule ID 24812 //
     /*  865062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  865111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865130 */     GIR_RootConstrainSelectedInstOperands,
     /*  865131 */     // GIR_Coverage, 24812,
     /*  865131 */     GIR_EraseRootFromParent_Done,
     /*  865132 */   // Label 13273: @865132
     /*  865132 */   GIM_Try, /*On fail goto*//*Label 13274*/ GIMT_Encode4(865207), // Rule ID 24813 //
     /*  865137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  865148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  865151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  865154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865183 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  865186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865205 */     GIR_RootConstrainSelectedInstOperands,
     /*  865206 */     // GIR_Coverage, 24813,
     /*  865206 */     GIR_EraseRootFromParent_Done,
     /*  865207 */   // Label 13274: @865207
     /*  865207 */   GIM_Try, /*On fail goto*//*Label 13275*/ GIMT_Encode4(865282), // Rule ID 24816 //
     /*  865212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865258 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  865258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  865261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865280 */     GIR_RootConstrainSelectedInstOperands,
     /*  865281 */     // GIR_Coverage, 24816,
     /*  865281 */     GIR_EraseRootFromParent_Done,
     /*  865282 */   // Label 13275: @865282
     /*  865282 */   GIM_Try, /*On fail goto*//*Label 13276*/ GIMT_Encode4(865357), // Rule ID 24817 //
     /*  865287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  865298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  865301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  865304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  865307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865333 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  865333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  865336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  865352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865355 */     GIR_RootConstrainSelectedInstOperands,
     /*  865356 */     // GIR_Coverage, 24817,
     /*  865356 */     GIR_EraseRootFromParent_Done,
     /*  865357 */   // Label 13276: @865357
     /*  865357 */   GIM_Try, /*On fail goto*//*Label 13277*/ GIMT_Encode4(865432), // Rule ID 24820 //
     /*  865362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  865373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  865376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  865379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  865411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865430 */     GIR_RootConstrainSelectedInstOperands,
     /*  865431 */     // GIR_Coverage, 24820,
     /*  865431 */     GIR_EraseRootFromParent_Done,
     /*  865432 */   // Label 13277: @865432
     /*  865432 */   GIM_Try, /*On fail goto*//*Label 13278*/ GIMT_Encode4(865507), // Rule ID 24821 //
     /*  865437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  865448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  865451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  865454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865483 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  865486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865505 */     GIR_RootConstrainSelectedInstOperands,
     /*  865506 */     // GIR_Coverage, 24821,
     /*  865506 */     GIR_EraseRootFromParent_Done,
     /*  865507 */   // Label 13278: @865507
     /*  865507 */   GIM_Try, /*On fail goto*//*Label 13279*/ GIMT_Encode4(865582), // Rule ID 24824 //
     /*  865512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  865523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  865526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  865529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  865561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865580 */     GIR_RootConstrainSelectedInstOperands,
     /*  865581 */     // GIR_Coverage, 24824,
     /*  865581 */     GIR_EraseRootFromParent_Done,
     /*  865582 */   // Label 13279: @865582
     /*  865582 */   GIM_Try, /*On fail goto*//*Label 13280*/ GIMT_Encode4(865657), // Rule ID 24825 //
     /*  865587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  865598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  865601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  865604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865633 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  865636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865655 */     GIR_RootConstrainSelectedInstOperands,
     /*  865656 */     // GIR_Coverage, 24825,
     /*  865656 */     GIR_EraseRootFromParent_Done,
     /*  865657 */   // Label 13280: @865657
     /*  865657 */   GIM_Try, /*On fail goto*//*Label 13281*/ GIMT_Encode4(865732), // Rule ID 24828 //
     /*  865662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  865673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  865676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  865679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865708 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  865711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865730 */     GIR_RootConstrainSelectedInstOperands,
     /*  865731 */     // GIR_Coverage, 24828,
     /*  865731 */     GIR_EraseRootFromParent_Done,
     /*  865732 */   // Label 13281: @865732
     /*  865732 */   GIM_Try, /*On fail goto*//*Label 13282*/ GIMT_Encode4(865807), // Rule ID 24829 //
     /*  865737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  865748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  865751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  865754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865783 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  865786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865805 */     GIR_RootConstrainSelectedInstOperands,
     /*  865806 */     // GIR_Coverage, 24829,
     /*  865806 */     GIR_EraseRootFromParent_Done,
     /*  865807 */   // Label 13282: @865807
     /*  865807 */   GIM_Try, /*On fail goto*//*Label 13283*/ GIMT_Encode4(865882), // Rule ID 24832 //
     /*  865812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  865815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  865823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  865826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  865829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  865832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865858 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  865858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  865861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865880 */     GIR_RootConstrainSelectedInstOperands,
     /*  865881 */     // GIR_Coverage, 24832,
     /*  865881 */     GIR_EraseRootFromParent_Done,
     /*  865882 */   // Label 13283: @865882
     /*  865882 */   GIM_Try, /*On fail goto*//*Label 13284*/ GIMT_Encode4(865957), // Rule ID 24833 //
     /*  865887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  865890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  865898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  865901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  865904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  865907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865933 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  865933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  865936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865955 */     GIR_RootConstrainSelectedInstOperands,
     /*  865956 */     // GIR_Coverage, 24833,
     /*  865956 */     GIR_EraseRootFromParent_Done,
     /*  865957 */   // Label 13284: @865957
     /*  865957 */   GIM_Try, /*On fail goto*//*Label 13285*/ GIMT_Encode4(866032), // Rule ID 24836 //
     /*  865962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  865965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  865973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  865976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  865979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866008 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  866011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866030 */     GIR_RootConstrainSelectedInstOperands,
     /*  866031 */     // GIR_Coverage, 24836,
     /*  866031 */     GIR_EraseRootFromParent_Done,
     /*  866032 */   // Label 13285: @866032
     /*  866032 */   GIM_Try, /*On fail goto*//*Label 13286*/ GIMT_Encode4(866107), // Rule ID 24837 //
     /*  866037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866083 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  866086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866105 */     GIR_RootConstrainSelectedInstOperands,
     /*  866106 */     // GIR_Coverage, 24837,
     /*  866106 */     GIR_EraseRootFromParent_Done,
     /*  866107 */   // Label 13286: @866107
     /*  866107 */   GIM_Try, /*On fail goto*//*Label 13287*/ GIMT_Encode4(866182), // Rule ID 24840 //
     /*  866112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  866115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  866161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866180 */     GIR_RootConstrainSelectedInstOperands,
     /*  866181 */     // GIR_Coverage, 24840,
     /*  866181 */     GIR_EraseRootFromParent_Done,
     /*  866182 */   // Label 13287: @866182
     /*  866182 */   GIM_Try, /*On fail goto*//*Label 13288*/ GIMT_Encode4(866257), // Rule ID 24841 //
     /*  866187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  866190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  866195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  866207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866233 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  866236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866255 */     GIR_RootConstrainSelectedInstOperands,
     /*  866256 */     // GIR_Coverage, 24841,
     /*  866256 */     GIR_EraseRootFromParent_Done,
     /*  866257 */   // Label 13288: @866257
     /*  866257 */   GIM_Try, /*On fail goto*//*Label 13289*/ GIMT_Encode4(866332), // Rule ID 24844 //
     /*  866262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  866265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  866273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  866276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  866279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866308 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  866311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866330 */     GIR_RootConstrainSelectedInstOperands,
     /*  866331 */     // GIR_Coverage, 24844,
     /*  866331 */     GIR_EraseRootFromParent_Done,
     /*  866332 */   // Label 13289: @866332
     /*  866332 */   GIM_Try, /*On fail goto*//*Label 13290*/ GIMT_Encode4(866407), // Rule ID 24845 //
     /*  866337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  866340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  866348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  866351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  866354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  866357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866383 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  866386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866405 */     GIR_RootConstrainSelectedInstOperands,
     /*  866406 */     // GIR_Coverage, 24845,
     /*  866406 */     GIR_EraseRootFromParent_Done,
     /*  866407 */   // Label 13290: @866407
     /*  866407 */   GIM_Try, /*On fail goto*//*Label 13291*/ GIMT_Encode4(866482), // Rule ID 24848 //
     /*  866412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  866415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  866423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  866426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  866429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866458 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  866461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866480 */     GIR_RootConstrainSelectedInstOperands,
     /*  866481 */     // GIR_Coverage, 24848,
     /*  866481 */     GIR_EraseRootFromParent_Done,
     /*  866482 */   // Label 13291: @866482
     /*  866482 */   GIM_Try, /*On fail goto*//*Label 13292*/ GIMT_Encode4(866557), // Rule ID 24849 //
     /*  866487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  866490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  866498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  866501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  866504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  866507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866533 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  866536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866555 */     GIR_RootConstrainSelectedInstOperands,
     /*  866556 */     // GIR_Coverage, 24849,
     /*  866556 */     GIR_EraseRootFromParent_Done,
     /*  866557 */   // Label 13292: @866557
     /*  866557 */   GIM_Try, /*On fail goto*//*Label 13293*/ GIMT_Encode4(866632), // Rule ID 24852 //
     /*  866562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  866565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  866573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  866576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  866579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  866582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  866611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866630 */     GIR_RootConstrainSelectedInstOperands,
     /*  866631 */     // GIR_Coverage, 24852,
     /*  866631 */     GIR_EraseRootFromParent_Done,
     /*  866632 */   // Label 13293: @866632
     /*  866632 */   GIM_Try, /*On fail goto*//*Label 13294*/ GIMT_Encode4(866707), // Rule ID 24853 //
     /*  866637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  866640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  866648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  866651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  866654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  866657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866683 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  866686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866705 */     GIR_RootConstrainSelectedInstOperands,
     /*  866706 */     // GIR_Coverage, 24853,
     /*  866706 */     GIR_EraseRootFromParent_Done,
     /*  866707 */   // Label 13294: @866707
     /*  866707 */   GIM_Try, /*On fail goto*//*Label 13295*/ GIMT_Encode4(866782), // Rule ID 24856 //
     /*  866712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  866715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  866723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  866726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  866729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866758 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  866758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  866761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866780 */     GIR_RootConstrainSelectedInstOperands,
     /*  866781 */     // GIR_Coverage, 24856,
     /*  866781 */     GIR_EraseRootFromParent_Done,
     /*  866782 */   // Label 13295: @866782
     /*  866782 */   GIM_Try, /*On fail goto*//*Label 13296*/ GIMT_Encode4(866857), // Rule ID 24857 //
     /*  866787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  866790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  866798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  866801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  866804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  866807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866833 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11519:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  866833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  866836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  866852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866855 */     GIR_RootConstrainSelectedInstOperands,
     /*  866856 */     // GIR_Coverage, 24857,
     /*  866856 */     GIR_EraseRootFromParent_Done,
     /*  866857 */   // Label 13296: @866857
     /*  866857 */   GIM_Try, /*On fail goto*//*Label 13297*/ GIMT_Encode4(866932), // Rule ID 24860 //
     /*  866862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  866865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  866873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  866876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  866879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  866882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  866911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866930 */     GIR_RootConstrainSelectedInstOperands,
     /*  866931 */     // GIR_Coverage, 24860,
     /*  866931 */     GIR_EraseRootFromParent_Done,
     /*  866932 */   // Label 13297: @866932
     /*  866932 */   GIM_Try, /*On fail goto*//*Label 13298*/ GIMT_Encode4(867007), // Rule ID 24861 //
     /*  866937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  866940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  866948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  866951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  866954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  866957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866983 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11519:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  866986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867005 */     GIR_RootConstrainSelectedInstOperands,
     /*  867006 */     // GIR_Coverage, 24861,
     /*  867006 */     GIR_EraseRootFromParent_Done,
     /*  867007 */   // Label 13298: @867007
     /*  867007 */   GIM_Try, /*On fail goto*//*Label 13299*/ GIMT_Encode4(867082), // Rule ID 24864 //
     /*  867012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  867015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  867032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  867058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  867061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867080 */     GIR_RootConstrainSelectedInstOperands,
     /*  867081 */     // GIR_Coverage, 24864,
     /*  867081 */     GIR_EraseRootFromParent_Done,
     /*  867082 */   // Label 13299: @867082
     /*  867082 */   GIM_Try, /*On fail goto*//*Label 13300*/ GIMT_Encode4(867157), // Rule ID 24865 //
     /*  867087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  867090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  867107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867133 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11519:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  867133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  867136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867155 */     GIR_RootConstrainSelectedInstOperands,
     /*  867156 */     // GIR_Coverage, 24865,
     /*  867156 */     GIR_EraseRootFromParent_Done,
     /*  867157 */   // Label 13300: @867157
     /*  867157 */   GIM_Try, /*On fail goto*//*Label 13301*/ GIMT_Encode4(867232), // Rule ID 24868 //
     /*  867162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  867165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867208 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  867211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867230 */     GIR_RootConstrainSelectedInstOperands,
     /*  867231 */     // GIR_Coverage, 24868,
     /*  867231 */     GIR_EraseRootFromParent_Done,
     /*  867232 */   // Label 13301: @867232
     /*  867232 */   GIM_Try, /*On fail goto*//*Label 13302*/ GIMT_Encode4(867307), // Rule ID 24869 //
     /*  867237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  867240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  867248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  867251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  867254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  867257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867283 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  867286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867305 */     GIR_RootConstrainSelectedInstOperands,
     /*  867306 */     // GIR_Coverage, 24869,
     /*  867306 */     GIR_EraseRootFromParent_Done,
     /*  867307 */   // Label 13302: @867307
     /*  867307 */   GIM_Try, /*On fail goto*//*Label 13303*/ GIMT_Encode4(867382), // Rule ID 24872 //
     /*  867312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  867315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  867332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867358 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  867361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867380 */     GIR_RootConstrainSelectedInstOperands,
     /*  867381 */     // GIR_Coverage, 24872,
     /*  867381 */     GIR_EraseRootFromParent_Done,
     /*  867382 */   // Label 13303: @867382
     /*  867382 */   GIM_Try, /*On fail goto*//*Label 13304*/ GIMT_Encode4(867457), // Rule ID 24873 //
     /*  867387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  867390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  867398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  867401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  867404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  867407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867433 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  867436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867455 */     GIR_RootConstrainSelectedInstOperands,
     /*  867456 */     // GIR_Coverage, 24873,
     /*  867456 */     GIR_EraseRootFromParent_Done,
     /*  867457 */   // Label 13304: @867457
     /*  867457 */   GIM_Try, /*On fail goto*//*Label 13305*/ GIMT_Encode4(867532), // Rule ID 24876 //
     /*  867462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  867465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  867473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  867476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  867479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  867482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867508 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  867508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  867511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867530 */     GIR_RootConstrainSelectedInstOperands,
     /*  867531 */     // GIR_Coverage, 24876,
     /*  867531 */     GIR_EraseRootFromParent_Done,
     /*  867532 */   // Label 13305: @867532
     /*  867532 */   GIM_Try, /*On fail goto*//*Label 13306*/ GIMT_Encode4(867607), // Rule ID 24877 //
     /*  867537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  867540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  867548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  867551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  867554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  867557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867583 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  867583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  867586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  867602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867605 */     GIR_RootConstrainSelectedInstOperands,
     /*  867606 */     // GIR_Coverage, 24877,
     /*  867606 */     GIR_EraseRootFromParent_Done,
     /*  867607 */   // Label 13306: @867607
     /*  867607 */   GIM_Try, /*On fail goto*//*Label 13307*/ GIMT_Encode4(867682), // Rule ID 24880 //
     /*  867612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  867615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  867623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  867626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  867629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  867632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867658 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  867661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867680 */     GIR_RootConstrainSelectedInstOperands,
     /*  867681 */     // GIR_Coverage, 24880,
     /*  867681 */     GIR_EraseRootFromParent_Done,
     /*  867682 */   // Label 13307: @867682
     /*  867682 */   GIM_Try, /*On fail goto*//*Label 13308*/ GIMT_Encode4(867757), // Rule ID 24881 //
     /*  867687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  867690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  867698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  867701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  867704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  867707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  867736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867755 */     GIR_RootConstrainSelectedInstOperands,
     /*  867756 */     // GIR_Coverage, 24881,
     /*  867756 */     GIR_EraseRootFromParent_Done,
     /*  867757 */   // Label 13308: @867757
     /*  867757 */   GIM_Try, /*On fail goto*//*Label 13309*/ GIMT_Encode4(867832), // Rule ID 24884 //
     /*  867762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  867765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  867773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  867776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  867779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  867782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867808 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  867811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867830 */     GIR_RootConstrainSelectedInstOperands,
     /*  867831 */     // GIR_Coverage, 24884,
     /*  867831 */     GIR_EraseRootFromParent_Done,
     /*  867832 */   // Label 13309: @867832
     /*  867832 */   GIM_Try, /*On fail goto*//*Label 13310*/ GIMT_Encode4(867907), // Rule ID 24885 //
     /*  867837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  867840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  867848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  867851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  867854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  867857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867883 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  867886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867905 */     GIR_RootConstrainSelectedInstOperands,
     /*  867906 */     // GIR_Coverage, 24885,
     /*  867906 */     GIR_EraseRootFromParent_Done,
     /*  867907 */   // Label 13310: @867907
     /*  867907 */   GIM_Try, /*On fail goto*//*Label 13311*/ GIMT_Encode4(867982), // Rule ID 24888 //
     /*  867912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  867915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  867923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  867926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  867929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  867932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867958 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  867961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867980 */     GIR_RootConstrainSelectedInstOperands,
     /*  867981 */     // GIR_Coverage, 24888,
     /*  867981 */     GIR_EraseRootFromParent_Done,
     /*  867982 */   // Label 13311: @867982
     /*  867982 */   GIM_Try, /*On fail goto*//*Label 13312*/ GIMT_Encode4(868057), // Rule ID 24889 //
     /*  867987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  867990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  867998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  868001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  868004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  868007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868033 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  868036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868055 */     GIR_RootConstrainSelectedInstOperands,
     /*  868056 */     // GIR_Coverage, 24889,
     /*  868056 */     GIR_EraseRootFromParent_Done,
     /*  868057 */   // Label 13312: @868057
     /*  868057 */   GIM_Try, /*On fail goto*//*Label 13313*/ GIMT_Encode4(868132), // Rule ID 24892 //
     /*  868062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  868065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  868082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  868111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868130 */     GIR_RootConstrainSelectedInstOperands,
     /*  868131 */     // GIR_Coverage, 24892,
     /*  868131 */     GIR_EraseRootFromParent_Done,
     /*  868132 */   // Label 13313: @868132
     /*  868132 */   GIM_Try, /*On fail goto*//*Label 13314*/ GIMT_Encode4(868207), // Rule ID 24893 //
     /*  868137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  868140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  868157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868183 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11519:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  868186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868205 */     GIR_RootConstrainSelectedInstOperands,
     /*  868206 */     // GIR_Coverage, 24893,
     /*  868206 */     GIR_EraseRootFromParent_Done,
     /*  868207 */   // Label 13314: @868207
     /*  868207 */   GIM_Try, /*On fail goto*//*Label 13315*/ GIMT_Encode4(868282), // Rule ID 24896 //
     /*  868212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  868215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  868232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868258 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  868261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868280 */     GIR_RootConstrainSelectedInstOperands,
     /*  868281 */     // GIR_Coverage, 24896,
     /*  868281 */     GIR_EraseRootFromParent_Done,
     /*  868282 */   // Label 13315: @868282
     /*  868282 */   GIM_Try, /*On fail goto*//*Label 13316*/ GIMT_Encode4(868357), // Rule ID 24897 //
     /*  868287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  868290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  868307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868333 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11519:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  868336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868355 */     GIR_RootConstrainSelectedInstOperands,
     /*  868356 */     // GIR_Coverage, 24897,
     /*  868356 */     GIR_EraseRootFromParent_Done,
     /*  868357 */   // Label 13316: @868357
     /*  868357 */   GIM_Try, /*On fail goto*//*Label 13317*/ GIMT_Encode4(868432), // Rule ID 24900 //
     /*  868362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  868365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  868382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868408 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  868411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868430 */     GIR_RootConstrainSelectedInstOperands,
     /*  868431 */     // GIR_Coverage, 24900,
     /*  868431 */     GIR_EraseRootFromParent_Done,
     /*  868432 */   // Label 13317: @868432
     /*  868432 */   GIM_Try, /*On fail goto*//*Label 13318*/ GIMT_Encode4(868507), // Rule ID 24901 //
     /*  868437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  868440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  868457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868483 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11519:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  868486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868505 */     GIR_RootConstrainSelectedInstOperands,
     /*  868506 */     // GIR_Coverage, 24901,
     /*  868506 */     GIR_EraseRootFromParent_Done,
     /*  868507 */   // Label 13318: @868507
     /*  868507 */   GIM_Try, /*On fail goto*//*Label 13319*/ GIMT_Encode4(868582), // Rule ID 24904 //
     /*  868512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  868515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  868523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  868526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  868529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868558 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  868561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868580 */     GIR_RootConstrainSelectedInstOperands,
     /*  868581 */     // GIR_Coverage, 24904,
     /*  868581 */     GIR_EraseRootFromParent_Done,
     /*  868582 */   // Label 13319: @868582
     /*  868582 */   GIM_Try, /*On fail goto*//*Label 13320*/ GIMT_Encode4(868657), // Rule ID 24905 //
     /*  868587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  868590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  868598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  868601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  868604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868633 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  868636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868655 */     GIR_RootConstrainSelectedInstOperands,
     /*  868656 */     // GIR_Coverage, 24905,
     /*  868656 */     GIR_EraseRootFromParent_Done,
     /*  868657 */   // Label 13320: @868657
     /*  868657 */   GIM_Try, /*On fail goto*//*Label 13321*/ GIMT_Encode4(868732), // Rule ID 24908 //
     /*  868662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  868665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  868673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  868676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  868679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868708 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  868711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868730 */     GIR_RootConstrainSelectedInstOperands,
     /*  868731 */     // GIR_Coverage, 24908,
     /*  868731 */     GIR_EraseRootFromParent_Done,
     /*  868732 */   // Label 13321: @868732
     /*  868732 */   GIM_Try, /*On fail goto*//*Label 13322*/ GIMT_Encode4(868807), // Rule ID 24909 //
     /*  868737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  868740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  868748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  868751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  868754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868783 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  868786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868805 */     GIR_RootConstrainSelectedInstOperands,
     /*  868806 */     // GIR_Coverage, 24909,
     /*  868806 */     GIR_EraseRootFromParent_Done,
     /*  868807 */   // Label 13322: @868807
     /*  868807 */   GIM_Try, /*On fail goto*//*Label 13323*/ GIMT_Encode4(868882), // Rule ID 24912 //
     /*  868812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  868815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  868823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  868826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  868829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868858 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  868858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  868861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868880 */     GIR_RootConstrainSelectedInstOperands,
     /*  868881 */     // GIR_Coverage, 24912,
     /*  868881 */     GIR_EraseRootFromParent_Done,
     /*  868882 */   // Label 13323: @868882
     /*  868882 */   GIM_Try, /*On fail goto*//*Label 13324*/ GIMT_Encode4(868957), // Rule ID 24913 //
     /*  868887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  868890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  868898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  868901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  868904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868933 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  868933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  868936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  868952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868955 */     GIR_RootConstrainSelectedInstOperands,
     /*  868956 */     // GIR_Coverage, 24913,
     /*  868956 */     GIR_EraseRootFromParent_Done,
     /*  868957 */   // Label 13324: @868957
     /*  868957 */   GIM_Try, /*On fail goto*//*Label 13325*/ GIMT_Encode4(869032), // Rule ID 24916 //
     /*  868962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  868965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  868973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  868976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  868979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869008 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869030 */     GIR_RootConstrainSelectedInstOperands,
     /*  869031 */     // GIR_Coverage, 24916,
     /*  869031 */     GIR_EraseRootFromParent_Done,
     /*  869032 */   // Label 13325: @869032
     /*  869032 */   GIM_Try, /*On fail goto*//*Label 13326*/ GIMT_Encode4(869107), // Rule ID 24917 //
     /*  869037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  869048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  869051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  869054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869083 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11521:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869105 */     GIR_RootConstrainSelectedInstOperands,
     /*  869106 */     // GIR_Coverage, 24917,
     /*  869106 */     GIR_EraseRootFromParent_Done,
     /*  869107 */   // Label 13326: @869107
     /*  869107 */   GIM_Try, /*On fail goto*//*Label 13327*/ GIMT_Encode4(869182), // Rule ID 24920 //
     /*  869112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  869115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  869123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  869126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  869129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869158 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869180 */     GIR_RootConstrainSelectedInstOperands,
     /*  869181 */     // GIR_Coverage, 24920,
     /*  869181 */     GIR_EraseRootFromParent_Done,
     /*  869182 */   // Label 13327: @869182
     /*  869182 */   GIM_Try, /*On fail goto*//*Label 13328*/ GIMT_Encode4(869257), // Rule ID 24921 //
     /*  869187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  869190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  869198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  869201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  869204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869233 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11521:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869255 */     GIR_RootConstrainSelectedInstOperands,
     /*  869256 */     // GIR_Coverage, 24921,
     /*  869256 */     GIR_EraseRootFromParent_Done,
     /*  869257 */   // Label 13328: @869257
     /*  869257 */   GIM_Try, /*On fail goto*//*Label 13329*/ GIMT_Encode4(869332), // Rule ID 24924 //
     /*  869262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  869265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  869273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  869276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  869279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869308 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  869308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869330 */     GIR_RootConstrainSelectedInstOperands,
     /*  869331 */     // GIR_Coverage, 24924,
     /*  869331 */     GIR_EraseRootFromParent_Done,
     /*  869332 */   // Label 13329: @869332
     /*  869332 */   GIM_Try, /*On fail goto*//*Label 13330*/ GIMT_Encode4(869407), // Rule ID 24925 //
     /*  869337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  869340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  869348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  869351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  869354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869383 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11521:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  869383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  869402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869405 */     GIR_RootConstrainSelectedInstOperands,
     /*  869406 */     // GIR_Coverage, 24925,
     /*  869406 */     GIR_EraseRootFromParent_Done,
     /*  869407 */   // Label 13330: @869407
     /*  869407 */   GIM_Try, /*On fail goto*//*Label 13331*/ GIMT_Encode4(869482), // Rule ID 24928 //
     /*  869412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869458 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869480 */     GIR_RootConstrainSelectedInstOperands,
     /*  869481 */     // GIR_Coverage, 24928,
     /*  869481 */     GIR_EraseRootFromParent_Done,
     /*  869482 */   // Label 13331: @869482
     /*  869482 */   GIM_Try, /*On fail goto*//*Label 13332*/ GIMT_Encode4(869557), // Rule ID 24929 //
     /*  869487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869533 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869555 */     GIR_RootConstrainSelectedInstOperands,
     /*  869556 */     // GIR_Coverage, 24929,
     /*  869556 */     GIR_EraseRootFromParent_Done,
     /*  869557 */   // Label 13332: @869557
     /*  869557 */   GIM_Try, /*On fail goto*//*Label 13333*/ GIMT_Encode4(869632), // Rule ID 24932 //
     /*  869562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  869573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  869576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  869579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869608 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  869611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869630 */     GIR_RootConstrainSelectedInstOperands,
     /*  869631 */     // GIR_Coverage, 24932,
     /*  869631 */     GIR_EraseRootFromParent_Done,
     /*  869632 */   // Label 13333: @869632
     /*  869632 */   GIM_Try, /*On fail goto*//*Label 13334*/ GIMT_Encode4(869707), // Rule ID 24933 //
     /*  869637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  869648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  869651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  869654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869683 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  869686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869705 */     GIR_RootConstrainSelectedInstOperands,
     /*  869706 */     // GIR_Coverage, 24933,
     /*  869706 */     GIR_EraseRootFromParent_Done,
     /*  869707 */   // Label 13334: @869707
     /*  869707 */   GIM_Try, /*On fail goto*//*Label 13335*/ GIMT_Encode4(869782), // Rule ID 24936 //
     /*  869712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869758 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  869761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869780 */     GIR_RootConstrainSelectedInstOperands,
     /*  869781 */     // GIR_Coverage, 24936,
     /*  869781 */     GIR_EraseRootFromParent_Done,
     /*  869782 */   // Label 13335: @869782
     /*  869782 */   GIM_Try, /*On fail goto*//*Label 13336*/ GIMT_Encode4(869857), // Rule ID 24937 //
     /*  869787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869833 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  869836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869855 */     GIR_RootConstrainSelectedInstOperands,
     /*  869856 */     // GIR_Coverage, 24937,
     /*  869856 */     GIR_EraseRootFromParent_Done,
     /*  869857 */   // Label 13336: @869857
     /*  869857 */   GIM_Try, /*On fail goto*//*Label 13337*/ GIMT_Encode4(869932), // Rule ID 24940 //
     /*  869862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  869865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  869873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  869876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  869879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869908 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  869908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  869927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869930 */     GIR_RootConstrainSelectedInstOperands,
     /*  869931 */     // GIR_Coverage, 24940,
     /*  869931 */     GIR_EraseRootFromParent_Done,
     /*  869932 */   // Label 13337: @869932
     /*  869932 */   GIM_Try, /*On fail goto*//*Label 13338*/ GIMT_Encode4(870007), // Rule ID 24941 //
     /*  869937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  869940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  869948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  869951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  869954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869983 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  869983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870005 */     GIR_RootConstrainSelectedInstOperands,
     /*  870006 */     // GIR_Coverage, 24941,
     /*  870006 */     GIR_EraseRootFromParent_Done,
     /*  870007 */   // Label 13338: @870007
     /*  870007 */   GIM_Try, /*On fail goto*//*Label 13339*/ GIMT_Encode4(870082), // Rule ID 24944 //
     /*  870012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870058 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870080 */     GIR_RootConstrainSelectedInstOperands,
     /*  870081 */     // GIR_Coverage, 24944,
     /*  870081 */     GIR_EraseRootFromParent_Done,
     /*  870082 */   // Label 13339: @870082
     /*  870082 */   GIM_Try, /*On fail goto*//*Label 13340*/ GIMT_Encode4(870157), // Rule ID 24945 //
     /*  870087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  870098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  870101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  870104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870133 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870155 */     GIR_RootConstrainSelectedInstOperands,
     /*  870156 */     // GIR_Coverage, 24945,
     /*  870156 */     GIR_EraseRootFromParent_Done,
     /*  870157 */   // Label 13340: @870157
     /*  870157 */   GIM_Try, /*On fail goto*//*Label 13341*/ GIMT_Encode4(870232), // Rule ID 24948 //
     /*  870162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  870165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870208 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870230 */     GIR_RootConstrainSelectedInstOperands,
     /*  870231 */     // GIR_Coverage, 24948,
     /*  870231 */     GIR_EraseRootFromParent_Done,
     /*  870232 */   // Label 13341: @870232
     /*  870232 */   GIM_Try, /*On fail goto*//*Label 13342*/ GIMT_Encode4(870307), // Rule ID 24949 //
     /*  870237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  870240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  870248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  870251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  870254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870283 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870305 */     GIR_RootConstrainSelectedInstOperands,
     /*  870306 */     // GIR_Coverage, 24949,
     /*  870306 */     GIR_EraseRootFromParent_Done,
     /*  870307 */   // Label 13342: @870307
     /*  870307 */   GIM_Try, /*On fail goto*//*Label 13343*/ GIMT_Encode4(870382), // Rule ID 24952 //
     /*  870312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  870315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  870323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  870326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  870329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870358 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870380 */     GIR_RootConstrainSelectedInstOperands,
     /*  870381 */     // GIR_Coverage, 24952,
     /*  870381 */     GIR_EraseRootFromParent_Done,
     /*  870382 */   // Label 13343: @870382
     /*  870382 */   GIM_Try, /*On fail goto*//*Label 13344*/ GIMT_Encode4(870457), // Rule ID 24953 //
     /*  870387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  870390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  870398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  870401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  870404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  870422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870433 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11521:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  870436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870455 */     GIR_RootConstrainSelectedInstOperands,
     /*  870456 */     // GIR_Coverage, 24953,
     /*  870456 */     GIR_EraseRootFromParent_Done,
     /*  870457 */   // Label 13344: @870457
     /*  870457 */   GIM_Try, /*On fail goto*//*Label 13345*/ GIMT_Encode4(870532), // Rule ID 24956 //
     /*  870462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  870465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  870473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  870476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  870479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870530 */     GIR_RootConstrainSelectedInstOperands,
     /*  870531 */     // GIR_Coverage, 24956,
     /*  870531 */     GIR_EraseRootFromParent_Done,
     /*  870532 */   // Label 13345: @870532
     /*  870532 */   GIM_Try, /*On fail goto*//*Label 13346*/ GIMT_Encode4(870607), // Rule ID 24957 //
     /*  870537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  870540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  870548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  870551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  870554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870583 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11521:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870605 */     GIR_RootConstrainSelectedInstOperands,
     /*  870606 */     // GIR_Coverage, 24957,
     /*  870606 */     GIR_EraseRootFromParent_Done,
     /*  870607 */   // Label 13346: @870607
     /*  870607 */   GIM_Try, /*On fail goto*//*Label 13347*/ GIMT_Encode4(870682), // Rule ID 24960 //
     /*  870612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  870615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  870623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  870626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  870629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870658 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  870658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870680 */     GIR_RootConstrainSelectedInstOperands,
     /*  870681 */     // GIR_Coverage, 24960,
     /*  870681 */     GIR_EraseRootFromParent_Done,
     /*  870682 */   // Label 13347: @870682
     /*  870682 */   GIM_Try, /*On fail goto*//*Label 13348*/ GIMT_Encode4(870757), // Rule ID 24961 //
     /*  870687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  870690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  870698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  870701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  870704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870733 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11521:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  870733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  870752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870755 */     GIR_RootConstrainSelectedInstOperands,
     /*  870756 */     // GIR_Coverage, 24961,
     /*  870756 */     GIR_EraseRootFromParent_Done,
     /*  870757 */   // Label 13348: @870757
     /*  870757 */   GIM_Try, /*On fail goto*//*Label 13349*/ GIMT_Encode4(870832), // Rule ID 25024 //
     /*  870762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /*  870765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  870773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  870776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  870779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  870782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870808 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  870811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870830 */     GIR_RootConstrainSelectedInstOperands,
     /*  870831 */     // GIR_Coverage, 25024,
     /*  870831 */     GIR_EraseRootFromParent_Done,
     /*  870832 */   // Label 13349: @870832
     /*  870832 */   GIM_Try, /*On fail goto*//*Label 13350*/ GIMT_Encode4(870907), // Rule ID 25025 //
     /*  870837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /*  870840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  870848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  870851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  870854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  870857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870883 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  870886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870905 */     GIR_RootConstrainSelectedInstOperands,
     /*  870906 */     // GIR_Coverage, 25025,
     /*  870906 */     GIR_EraseRootFromParent_Done,
     /*  870907 */   // Label 13350: @870907
     /*  870907 */   GIM_Try, /*On fail goto*//*Label 13351*/ GIMT_Encode4(870982), // Rule ID 25028 //
     /*  870912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /*  870915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  870923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  870926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  870929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  870932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870958 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  870961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870980 */     GIR_RootConstrainSelectedInstOperands,
     /*  870981 */     // GIR_Coverage, 25028,
     /*  870981 */     GIR_EraseRootFromParent_Done,
     /*  870982 */   // Label 13351: @870982
     /*  870982 */   GIM_Try, /*On fail goto*//*Label 13352*/ GIMT_Encode4(871057), // Rule ID 25029 //
     /*  870987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /*  870990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  870998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  871001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  871004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871033 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  871036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871055 */     GIR_RootConstrainSelectedInstOperands,
     /*  871056 */     // GIR_Coverage, 25029,
     /*  871056 */     GIR_EraseRootFromParent_Done,
     /*  871057 */   // Label 13352: @871057
     /*  871057 */   GIM_Try, /*On fail goto*//*Label 13353*/ GIMT_Encode4(871132), // Rule ID 25032 //
     /*  871062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  871065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871108 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  871111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871130 */     GIR_RootConstrainSelectedInstOperands,
     /*  871131 */     // GIR_Coverage, 25032,
     /*  871131 */     GIR_EraseRootFromParent_Done,
     /*  871132 */   // Label 13353: @871132
     /*  871132 */   GIM_Try, /*On fail goto*//*Label 13354*/ GIMT_Encode4(871207), // Rule ID 25033 //
     /*  871137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  871140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  871148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  871151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  871154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871183 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  871186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871205 */     GIR_RootConstrainSelectedInstOperands,
     /*  871206 */     // GIR_Coverage, 25033,
     /*  871206 */     GIR_EraseRootFromParent_Done,
     /*  871207 */   // Label 13354: @871207
     /*  871207 */   GIM_Try, /*On fail goto*//*Label 13355*/ GIMT_Encode4(871282), // Rule ID 25036 //
     /*  871212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /*  871215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  871223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  871226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  871229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871258 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  871261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871280 */     GIR_RootConstrainSelectedInstOperands,
     /*  871281 */     // GIR_Coverage, 25036,
     /*  871281 */     GIR_EraseRootFromParent_Done,
     /*  871282 */   // Label 13355: @871282
     /*  871282 */   GIM_Try, /*On fail goto*//*Label 13356*/ GIMT_Encode4(871357), // Rule ID 25037 //
     /*  871287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /*  871290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  871298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  871301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  871304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871333 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11523:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  871336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871355 */     GIR_RootConstrainSelectedInstOperands,
     /*  871356 */     // GIR_Coverage, 25037,
     /*  871356 */     GIR_EraseRootFromParent_Done,
     /*  871357 */   // Label 13356: @871357
     /*  871357 */   GIM_Try, /*On fail goto*//*Label 13357*/ GIMT_Encode4(871432), // Rule ID 25040 //
     /*  871362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  871365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  871411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871430 */     GIR_RootConstrainSelectedInstOperands,
     /*  871431 */     // GIR_Coverage, 25040,
     /*  871431 */     GIR_EraseRootFromParent_Done,
     /*  871432 */   // Label 13357: @871432
     /*  871432 */   GIM_Try, /*On fail goto*//*Label 13358*/ GIMT_Encode4(871507), // Rule ID 25041 //
     /*  871437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  871440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  871448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  871451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  871454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  871457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871483 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11523:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  871486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871505 */     GIR_RootConstrainSelectedInstOperands,
     /*  871506 */     // GIR_Coverage, 25041,
     /*  871506 */     GIR_EraseRootFromParent_Done,
     /*  871507 */   // Label 13358: @871507
     /*  871507 */   GIM_Try, /*On fail goto*//*Label 13359*/ GIMT_Encode4(871582), // Rule ID 25044 //
     /*  871512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  871515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871558 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  871561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871580 */     GIR_RootConstrainSelectedInstOperands,
     /*  871581 */     // GIR_Coverage, 25044,
     /*  871581 */     GIR_EraseRootFromParent_Done,
     /*  871582 */   // Label 13359: @871582
     /*  871582 */   GIM_Try, /*On fail goto*//*Label 13360*/ GIMT_Encode4(871657), // Rule ID 25045 //
     /*  871587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  871590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871633 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11523:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  871636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871655 */     GIR_RootConstrainSelectedInstOperands,
     /*  871656 */     // GIR_Coverage, 25045,
     /*  871656 */     GIR_EraseRootFromParent_Done,
     /*  871657 */   // Label 13360: @871657
     /*  871657 */   GIM_Try, /*On fail goto*//*Label 13361*/ GIMT_Encode4(871732), // Rule ID 25048 //
     /*  871662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /*  871665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  871673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  871676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  871679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  871682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871708 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  871711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871730 */     GIR_RootConstrainSelectedInstOperands,
     /*  871731 */     // GIR_Coverage, 25048,
     /*  871731 */     GIR_EraseRootFromParent_Done,
     /*  871732 */   // Label 13361: @871732
     /*  871732 */   GIM_Try, /*On fail goto*//*Label 13362*/ GIMT_Encode4(871807), // Rule ID 25049 //
     /*  871737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /*  871740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  871748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  871751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  871754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  871757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871783 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  871786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871805 */     GIR_RootConstrainSelectedInstOperands,
     /*  871806 */     // GIR_Coverage, 25049,
     /*  871806 */     GIR_EraseRootFromParent_Done,
     /*  871807 */   // Label 13362: @871807
     /*  871807 */   GIM_Try, /*On fail goto*//*Label 13363*/ GIMT_Encode4(871882), // Rule ID 25052 //
     /*  871812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /*  871815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  871823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  871826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  871829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  871832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871858 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  871861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871880 */     GIR_RootConstrainSelectedInstOperands,
     /*  871881 */     // GIR_Coverage, 25052,
     /*  871881 */     GIR_EraseRootFromParent_Done,
     /*  871882 */   // Label 13363: @871882
     /*  871882 */   GIM_Try, /*On fail goto*//*Label 13364*/ GIMT_Encode4(871957), // Rule ID 25053 //
     /*  871887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /*  871890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  871898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  871901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  871904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  871907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871933 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  871936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871955 */     GIR_RootConstrainSelectedInstOperands,
     /*  871956 */     // GIR_Coverage, 25053,
     /*  871956 */     GIR_EraseRootFromParent_Done,
     /*  871957 */   // Label 13364: @871957
     /*  871957 */   GIM_Try, /*On fail goto*//*Label 13365*/ GIMT_Encode4(872032), // Rule ID 25056 //
     /*  871962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /*  871965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  871973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  871976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  871979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  871982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872008 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  872008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  872011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872030 */     GIR_RootConstrainSelectedInstOperands,
     /*  872031 */     // GIR_Coverage, 25056,
     /*  872031 */     GIR_EraseRootFromParent_Done,
     /*  872032 */   // Label 13365: @872032
     /*  872032 */   GIM_Try, /*On fail goto*//*Label 13366*/ GIMT_Encode4(872107), // Rule ID 25057 //
     /*  872037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /*  872040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  872048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  872051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  872054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  872057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872083 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  872083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  872086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872105 */     GIR_RootConstrainSelectedInstOperands,
     /*  872106 */     // GIR_Coverage, 25057,
     /*  872106 */     GIR_EraseRootFromParent_Done,
     /*  872107 */   // Label 13366: @872107
     /*  872107 */   GIM_Try, /*On fail goto*//*Label 13367*/ GIMT_Encode4(872182), // Rule ID 25060 //
     /*  872112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  872115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  872123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  872126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872158 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  872161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872180 */     GIR_RootConstrainSelectedInstOperands,
     /*  872181 */     // GIR_Coverage, 25060,
     /*  872181 */     GIR_EraseRootFromParent_Done,
     /*  872182 */   // Label 13367: @872182
     /*  872182 */   GIM_Try, /*On fail goto*//*Label 13368*/ GIMT_Encode4(872257), // Rule ID 25061 //
     /*  872187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  872190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  872198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  872201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  872204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872233 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  872236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872255 */     GIR_RootConstrainSelectedInstOperands,
     /*  872256 */     // GIR_Coverage, 25061,
     /*  872256 */     GIR_EraseRootFromParent_Done,
     /*  872257 */   // Label 13368: @872257
     /*  872257 */   GIM_Try, /*On fail goto*//*Label 13369*/ GIMT_Encode4(872332), // Rule ID 25064 //
     /*  872262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  872265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872308 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  872311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872330 */     GIR_RootConstrainSelectedInstOperands,
     /*  872331 */     // GIR_Coverage, 25064,
     /*  872331 */     GIR_EraseRootFromParent_Done,
     /*  872332 */   // Label 13369: @872332
     /*  872332 */   GIM_Try, /*On fail goto*//*Label 13370*/ GIMT_Encode4(872407), // Rule ID 25065 //
     /*  872337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  872340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  872348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  872351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  872354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872383 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  872386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872405 */     GIR_RootConstrainSelectedInstOperands,
     /*  872406 */     // GIR_Coverage, 25065,
     /*  872406 */     GIR_EraseRootFromParent_Done,
     /*  872407 */   // Label 13370: @872407
     /*  872407 */   GIM_Try, /*On fail goto*//*Label 13371*/ GIMT_Encode4(872482), // Rule ID 25068 //
     /*  872412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  872415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872458 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  872458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  872461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872480 */     GIR_RootConstrainSelectedInstOperands,
     /*  872481 */     // GIR_Coverage, 25068,
     /*  872481 */     GIR_EraseRootFromParent_Done,
     /*  872482 */   // Label 13371: @872482
     /*  872482 */   GIM_Try, /*On fail goto*//*Label 13372*/ GIMT_Encode4(872557), // Rule ID 25069 //
     /*  872487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  872490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  872498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  872501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  872504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  872507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872533 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  872536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872555 */     GIR_RootConstrainSelectedInstOperands,
     /*  872556 */     // GIR_Coverage, 25069,
     /*  872556 */     GIR_EraseRootFromParent_Done,
     /*  872557 */   // Label 13372: @872557
     /*  872557 */   GIM_Try, /*On fail goto*//*Label 13373*/ GIMT_Encode4(872632), // Rule ID 25072 //
     /*  872562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  872565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  872582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872608 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  872611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872630 */     GIR_RootConstrainSelectedInstOperands,
     /*  872631 */     // GIR_Coverage, 25072,
     /*  872631 */     GIR_EraseRootFromParent_Done,
     /*  872632 */   // Label 13373: @872632
     /*  872632 */   GIM_Try, /*On fail goto*//*Label 13374*/ GIMT_Encode4(872707), // Rule ID 25073 //
     /*  872637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  872640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  872657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872683 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11523:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  872686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872705 */     GIR_RootConstrainSelectedInstOperands,
     /*  872706 */     // GIR_Coverage, 25073,
     /*  872706 */     GIR_EraseRootFromParent_Done,
     /*  872707 */   // Label 13374: @872707
     /*  872707 */   GIM_Try, /*On fail goto*//*Label 13375*/ GIMT_Encode4(872782), // Rule ID 25076 //
     /*  872712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  872715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872758 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  872761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872780 */     GIR_RootConstrainSelectedInstOperands,
     /*  872781 */     // GIR_Coverage, 25076,
     /*  872781 */     GIR_EraseRootFromParent_Done,
     /*  872782 */   // Label 13375: @872782
     /*  872782 */   GIM_Try, /*On fail goto*//*Label 13376*/ GIMT_Encode4(872857), // Rule ID 25077 //
     /*  872787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  872790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872833 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11523:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  872836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872855 */     GIR_RootConstrainSelectedInstOperands,
     /*  872856 */     // GIR_Coverage, 25077,
     /*  872856 */     GIR_EraseRootFromParent_Done,
     /*  872857 */   // Label 13376: @872857
     /*  872857 */   GIM_Try, /*On fail goto*//*Label 13377*/ GIMT_Encode4(872932), // Rule ID 25080 //
     /*  872862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  872865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872908 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  872911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872930 */     GIR_RootConstrainSelectedInstOperands,
     /*  872931 */     // GIR_Coverage, 25080,
     /*  872931 */     GIR_EraseRootFromParent_Done,
     /*  872932 */   // Label 13377: @872932
     /*  872932 */   GIM_Try, /*On fail goto*//*Label 13378*/ GIMT_Encode4(873007), // Rule ID 25081 //
     /*  872937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  872940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872983 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11523:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  872986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  873005 */     GIR_RootConstrainSelectedInstOperands,
     /*  873006 */     // GIR_Coverage, 25081,
     /*  873006 */     GIR_EraseRootFromParent_Done,
     /*  873007 */   // Label 13378: @873007
     /*  873007 */   GIM_Try, /*On fail goto*//*Label 13379*/ GIMT_Encode4(873079), // Rule ID 25084 //
     /*  873012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  873023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  873026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873058 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  873061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873077 */     GIR_RootConstrainSelectedInstOperands,
     /*  873078 */     // GIR_Coverage, 25084,
     /*  873078 */     GIR_EraseRootFromParent_Done,
     /*  873079 */   // Label 13379: @873079
     /*  873079 */   GIM_Try, /*On fail goto*//*Label 13380*/ GIMT_Encode4(873151), // Rule ID 25085 //
     /*  873084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  873095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  873098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  873101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873130 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  873133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873149 */     GIR_RootConstrainSelectedInstOperands,
     /*  873150 */     // GIR_Coverage, 25085,
     /*  873150 */     GIR_EraseRootFromParent_Done,
     /*  873151 */   // Label 13380: @873151
     /*  873151 */   GIM_Try, /*On fail goto*//*Label 13381*/ GIMT_Encode4(873223), // Rule ID 25086 //
     /*  873156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  873167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  873170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873202 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  873205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873221 */     GIR_RootConstrainSelectedInstOperands,
     /*  873222 */     // GIR_Coverage, 25086,
     /*  873222 */     GIR_EraseRootFromParent_Done,
     /*  873223 */   // Label 13381: @873223
     /*  873223 */   GIM_Try, /*On fail goto*//*Label 13382*/ GIMT_Encode4(873295), // Rule ID 25087 //
     /*  873228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  873239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  873242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  873245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873274 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  873277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873293 */     GIR_RootConstrainSelectedInstOperands,
     /*  873294 */     // GIR_Coverage, 25087,
     /*  873294 */     GIR_EraseRootFromParent_Done,
     /*  873295 */   // Label 13382: @873295
     /*  873295 */   GIM_Try, /*On fail goto*//*Label 13383*/ GIMT_Encode4(873367), // Rule ID 25088 //
     /*  873300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  873349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873365 */     GIR_RootConstrainSelectedInstOperands,
     /*  873366 */     // GIR_Coverage, 25088,
     /*  873366 */     GIR_EraseRootFromParent_Done,
     /*  873367 */   // Label 13383: @873367
     /*  873367 */   GIM_Try, /*On fail goto*//*Label 13384*/ GIMT_Encode4(873439), // Rule ID 25089 //
     /*  873372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  873383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  873386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  873389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873418 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  873418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  873421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873437 */     GIR_RootConstrainSelectedInstOperands,
     /*  873438 */     // GIR_Coverage, 25089,
     /*  873438 */     GIR_EraseRootFromParent_Done,
     /*  873439 */   // Label 13384: @873439
     /*  873439 */   GIM_Try, /*On fail goto*//*Label 13385*/ GIMT_Encode4(873511), // Rule ID 25090 //
     /*  873444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  873493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873509 */     GIR_RootConstrainSelectedInstOperands,
     /*  873510 */     // GIR_Coverage, 25090,
     /*  873510 */     GIR_EraseRootFromParent_Done,
     /*  873511 */   // Label 13385: @873511
     /*  873511 */   GIM_Try, /*On fail goto*//*Label 13386*/ GIMT_Encode4(873583), // Rule ID 25091 //
     /*  873516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873562 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  873562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  873565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873581 */     GIR_RootConstrainSelectedInstOperands,
     /*  873582 */     // GIR_Coverage, 25091,
     /*  873582 */     GIR_EraseRootFromParent_Done,
     /*  873583 */   // Label 13386: @873583
     /*  873583 */   GIM_Try, /*On fail goto*//*Label 13387*/ GIMT_Encode4(873655), // Rule ID 25092 //
     /*  873588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  873599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  873602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  873605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  873634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  873637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873653 */     GIR_RootConstrainSelectedInstOperands,
     /*  873654 */     // GIR_Coverage, 25092,
     /*  873654 */     GIR_EraseRootFromParent_Done,
     /*  873655 */   // Label 13387: @873655
     /*  873655 */   GIM_Try, /*On fail goto*//*Label 13388*/ GIMT_Encode4(873727), // Rule ID 25093 //
     /*  873660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  873671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  873674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  873677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  873706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  873709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873725 */     GIR_RootConstrainSelectedInstOperands,
     /*  873726 */     // GIR_Coverage, 25093,
     /*  873726 */     GIR_EraseRootFromParent_Done,
     /*  873727 */   // Label 13388: @873727
     /*  873727 */   GIM_Try, /*On fail goto*//*Label 13389*/ GIMT_Encode4(873799), // Rule ID 25094 //
     /*  873732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  873743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  873746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  873749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  873752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873778 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  873781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873797 */     GIR_RootConstrainSelectedInstOperands,
     /*  873798 */     // GIR_Coverage, 25094,
     /*  873798 */     GIR_EraseRootFromParent_Done,
     /*  873799 */   // Label 13389: @873799
     /*  873799 */   GIM_Try, /*On fail goto*//*Label 13390*/ GIMT_Encode4(873871), // Rule ID 25095 //
     /*  873804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  873815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  873818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  873821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  873824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11174:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  873853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873869 */     GIR_RootConstrainSelectedInstOperands,
     /*  873870 */     // GIR_Coverage, 25095,
     /*  873870 */     GIR_EraseRootFromParent_Done,
     /*  873871 */   // Label 13390: @873871
     /*  873871 */   GIM_Try, /*On fail goto*//*Label 13391*/ GIMT_Encode4(873943), // Rule ID 25096 //
     /*  873876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873922 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  873925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873941 */     GIR_RootConstrainSelectedInstOperands,
     /*  873942 */     // GIR_Coverage, 25096,
     /*  873942 */     GIR_EraseRootFromParent_Done,
     /*  873943 */   // Label 13391: @873943
     /*  873943 */   GIM_Try, /*On fail goto*//*Label 13392*/ GIMT_Encode4(874015), // Rule ID 25097 //
     /*  873948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  873994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  873997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874013 */     GIR_RootConstrainSelectedInstOperands,
     /*  874014 */     // GIR_Coverage, 25097,
     /*  874014 */     GIR_EraseRootFromParent_Done,
     /*  874015 */   // Label 13392: @874015
     /*  874015 */   GIM_Try, /*On fail goto*//*Label 13393*/ GIMT_Encode4(874087), // Rule ID 25098 //
     /*  874020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  874031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  874034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  874037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  874066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  874069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874085 */     GIR_RootConstrainSelectedInstOperands,
     /*  874086 */     // GIR_Coverage, 25098,
     /*  874086 */     GIR_EraseRootFromParent_Done,
     /*  874087 */   // Label 13393: @874087
     /*  874087 */   GIM_Try, /*On fail goto*//*Label 13394*/ GIMT_Encode4(874159), // Rule ID 25099 //
     /*  874092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  874103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  874106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  874109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  874112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874138 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  874138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  874141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874157 */     GIR_RootConstrainSelectedInstOperands,
     /*  874158 */     // GIR_Coverage, 25099,
     /*  874158 */     GIR_EraseRootFromParent_Done,
     /*  874159 */   // Label 13394: @874159
     /*  874159 */   GIM_Try, /*On fail goto*//*Label 13395*/ GIMT_Encode4(874231), // Rule ID 25100 //
     /*  874164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  874167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  874175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  874178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  874181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874210 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  874210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  874213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  874229 */     GIR_RootConstrainSelectedInstOperands,
     /*  874230 */     // GIR_Coverage, 25100,
     /*  874230 */     GIR_EraseRootFromParent_Done,
     /*  874231 */   // Label 13395: @874231
     /*  874231 */   GIM_Try, /*On fail goto*//*Label 13396*/ GIMT_Encode4(874303), // Rule ID 25101 //
     /*  874236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  874239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  874247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  874250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  874253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  874256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874282 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  874282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  874285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  874301 */     GIR_RootConstrainSelectedInstOperands,
     /*  874302 */     // GIR_Coverage, 25101,
     /*  874302 */     GIR_EraseRootFromParent_Done,
     /*  874303 */   // Label 13396: @874303
     /*  874303 */   GIM_Try, /*On fail goto*//*Label 13397*/ GIMT_Encode4(874375), // Rule ID 25102 //
     /*  874308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  874319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  874322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  874325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874354 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  874357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874373 */     GIR_RootConstrainSelectedInstOperands,
     /*  874374 */     // GIR_Coverage, 25102,
     /*  874374 */     GIR_EraseRootFromParent_Done,
     /*  874375 */   // Label 13397: @874375
     /*  874375 */   GIM_Try, /*On fail goto*//*Label 13398*/ GIMT_Encode4(874447), // Rule ID 25103 //
     /*  874380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  874391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  874394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  874397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  874429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874445 */     GIR_RootConstrainSelectedInstOperands,
     /*  874446 */     // GIR_Coverage, 25103,
     /*  874446 */     GIR_EraseRootFromParent_Done,
     /*  874447 */   // Label 13398: @874447
     /*  874447 */   GIM_Try, /*On fail goto*//*Label 13399*/ GIMT_Encode4(874519), // Rule ID 25104 //
     /*  874452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  874463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  874466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  874469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  874472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874498 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  874501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874517 */     GIR_RootConstrainSelectedInstOperands,
     /*  874518 */     // GIR_Coverage, 25104,
     /*  874518 */     GIR_EraseRootFromParent_Done,
     /*  874519 */   // Label 13399: @874519
     /*  874519 */   GIM_Try, /*On fail goto*//*Label 13400*/ GIMT_Encode4(874591), // Rule ID 25105 //
     /*  874524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  874535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  874538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  874541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  874544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874570 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  874573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874589 */     GIR_RootConstrainSelectedInstOperands,
     /*  874590 */     // GIR_Coverage, 25105,
     /*  874590 */     GIR_EraseRootFromParent_Done,
     /*  874591 */   // Label 13400: @874591
     /*  874591 */   GIM_Try, /*On fail goto*//*Label 13401*/ GIMT_Encode4(874663), // Rule ID 25106 //
     /*  874596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  874607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  874610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  874613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  874616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874642 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  874645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874661 */     GIR_RootConstrainSelectedInstOperands,
     /*  874662 */     // GIR_Coverage, 25106,
     /*  874662 */     GIR_EraseRootFromParent_Done,
     /*  874663 */   // Label 13401: @874663
     /*  874663 */   GIM_Try, /*On fail goto*//*Label 13402*/ GIMT_Encode4(874735), // Rule ID 25107 //
     /*  874668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  874679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  874682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  874685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  874688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874714 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  874717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874733 */     GIR_RootConstrainSelectedInstOperands,
     /*  874734 */     // GIR_Coverage, 25107,
     /*  874734 */     GIR_EraseRootFromParent_Done,
     /*  874735 */   // Label 13402: @874735
     /*  874735 */   GIM_Try, /*On fail goto*//*Label 13403*/ GIMT_Encode4(874807), // Rule ID 25108 //
     /*  874740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874786 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  874786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  874789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874805 */     GIR_RootConstrainSelectedInstOperands,
     /*  874806 */     // GIR_Coverage, 25108,
     /*  874806 */     GIR_EraseRootFromParent_Done,
     /*  874807 */   // Label 13403: @874807
     /*  874807 */   GIM_Try, /*On fail goto*//*Label 13404*/ GIMT_Encode4(874879), // Rule ID 25109 //
     /*  874812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  874861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874877 */     GIR_RootConstrainSelectedInstOperands,
     /*  874878 */     // GIR_Coverage, 25109,
     /*  874878 */     GIR_EraseRootFromParent_Done,
     /*  874879 */   // Label 13404: @874879
     /*  874879 */   GIM_Try, /*On fail goto*//*Label 13405*/ GIMT_Encode4(874951), // Rule ID 25110 //
     /*  874884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874930 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  874930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  874933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874949 */     GIR_RootConstrainSelectedInstOperands,
     /*  874950 */     // GIR_Coverage, 25110,
     /*  874950 */     GIR_EraseRootFromParent_Done,
     /*  874951 */   // Label 13405: @874951
     /*  874951 */   GIM_Try, /*On fail goto*//*Label 13406*/ GIMT_Encode4(875023), // Rule ID 25111 //
     /*  874956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  875005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875021 */     GIR_RootConstrainSelectedInstOperands,
     /*  875022 */     // GIR_Coverage, 25111,
     /*  875022 */     GIR_EraseRootFromParent_Done,
     /*  875023 */   // Label 13406: @875023
     /*  875023 */   GIM_Try, /*On fail goto*//*Label 13407*/ GIMT_Encode4(875095), // Rule ID 25112 //
     /*  875028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875074 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  875074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  875077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875093 */     GIR_RootConstrainSelectedInstOperands,
     /*  875094 */     // GIR_Coverage, 25112,
     /*  875094 */     GIR_EraseRootFromParent_Done,
     /*  875095 */   // Label 13407: @875095
     /*  875095 */   GIM_Try, /*On fail goto*//*Label 13408*/ GIMT_Encode4(875167), // Rule ID 25113 //
     /*  875100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  875111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  875114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  875117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  875120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  875146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  875149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  875165 */     GIR_RootConstrainSelectedInstOperands,
     /*  875166 */     // GIR_Coverage, 25113,
     /*  875166 */     GIR_EraseRootFromParent_Done,
     /*  875167 */   // Label 13408: @875167
     /*  875167 */   GIM_Try, /*On fail goto*//*Label 13409*/ GIMT_Encode4(875239), // Rule ID 25114 //
     /*  875172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  875221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875237 */     GIR_RootConstrainSelectedInstOperands,
     /*  875238 */     // GIR_Coverage, 25114,
     /*  875238 */     GIR_EraseRootFromParent_Done,
     /*  875239 */   // Label 13409: @875239
     /*  875239 */   GIM_Try, /*On fail goto*//*Label 13410*/ GIMT_Encode4(875311), // Rule ID 25115 //
     /*  875244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  875293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875309 */     GIR_RootConstrainSelectedInstOperands,
     /*  875310 */     // GIR_Coverage, 25115,
     /*  875310 */     GIR_EraseRootFromParent_Done,
     /*  875311 */   // Label 13410: @875311
     /*  875311 */   GIM_Try, /*On fail goto*//*Label 13411*/ GIMT_Encode4(875383), // Rule ID 25116 //
     /*  875316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  875327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  875330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  875333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875362 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  875365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875381 */     GIR_RootConstrainSelectedInstOperands,
     /*  875382 */     // GIR_Coverage, 25116,
     /*  875382 */     GIR_EraseRootFromParent_Done,
     /*  875383 */   // Label 13411: @875383
     /*  875383 */   GIM_Try, /*On fail goto*//*Label 13412*/ GIMT_Encode4(875455), // Rule ID 25117 //
     /*  875388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  875399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  875402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  875405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  875437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875453 */     GIR_RootConstrainSelectedInstOperands,
     /*  875454 */     // GIR_Coverage, 25117,
     /*  875454 */     GIR_EraseRootFromParent_Done,
     /*  875455 */   // Label 13412: @875455
     /*  875455 */   GIM_Try, /*On fail goto*//*Label 13413*/ GIMT_Encode4(875527), // Rule ID 25118 //
     /*  875460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  875463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  875471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  875474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  875477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  875509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875525 */     GIR_RootConstrainSelectedInstOperands,
     /*  875526 */     // GIR_Coverage, 25118,
     /*  875526 */     GIR_EraseRootFromParent_Done,
     /*  875527 */   // Label 13413: @875527
     /*  875527 */   GIM_Try, /*On fail goto*//*Label 13414*/ GIMT_Encode4(875599), // Rule ID 25119 //
     /*  875532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  875543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  875546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  875549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875578 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  875581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875597 */     GIR_RootConstrainSelectedInstOperands,
     /*  875598 */     // GIR_Coverage, 25119,
     /*  875598 */     GIR_EraseRootFromParent_Done,
     /*  875599 */   // Label 13414: @875599
     /*  875599 */   GIM_Try, /*On fail goto*//*Label 13415*/ GIMT_Encode4(875671), // Rule ID 25120 //
     /*  875604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  875615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  875618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  875621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  875624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  875653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875669 */     GIR_RootConstrainSelectedInstOperands,
     /*  875670 */     // GIR_Coverage, 25120,
     /*  875670 */     GIR_EraseRootFromParent_Done,
     /*  875671 */   // Label 13415: @875671
     /*  875671 */   GIM_Try, /*On fail goto*//*Label 13416*/ GIMT_Encode4(875743), // Rule ID 25121 //
     /*  875676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  875687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  875690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  875693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  875696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  875722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  875725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875741 */     GIR_RootConstrainSelectedInstOperands,
     /*  875742 */     // GIR_Coverage, 25121,
     /*  875742 */     GIR_EraseRootFromParent_Done,
     /*  875743 */   // Label 13416: @875743
     /*  875743 */   GIM_Try, /*On fail goto*//*Label 13417*/ GIMT_Encode4(875815), // Rule ID 25122 //
     /*  875748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  875759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  875762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  875765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  875797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875813 */     GIR_RootConstrainSelectedInstOperands,
     /*  875814 */     // GIR_Coverage, 25122,
     /*  875814 */     GIR_EraseRootFromParent_Done,
     /*  875815 */   // Label 13417: @875815
     /*  875815 */   GIM_Try, /*On fail goto*//*Label 13418*/ GIMT_Encode4(875887), // Rule ID 25123 //
     /*  875820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  875831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  875834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  875837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  875866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  875869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875885 */     GIR_RootConstrainSelectedInstOperands,
     /*  875886 */     // GIR_Coverage, 25123,
     /*  875886 */     GIR_EraseRootFromParent_Done,
     /*  875887 */   // Label 13418: @875887
     /*  875887 */   GIM_Try, /*On fail goto*//*Label 13419*/ GIMT_Encode4(875959), // Rule ID 25124 //
     /*  875892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  875903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  875906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  875909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875938 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  875941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875957 */     GIR_RootConstrainSelectedInstOperands,
     /*  875958 */     // GIR_Coverage, 25124,
     /*  875958 */     GIR_EraseRootFromParent_Done,
     /*  875959 */   // Label 13419: @875959
     /*  875959 */   GIM_Try, /*On fail goto*//*Label 13420*/ GIMT_Encode4(876031), // Rule ID 25125 //
     /*  875964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  875975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  875978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  875981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  876013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876029 */     GIR_RootConstrainSelectedInstOperands,
     /*  876030 */     // GIR_Coverage, 25125,
     /*  876030 */     GIR_EraseRootFromParent_Done,
     /*  876031 */   // Label 13420: @876031
     /*  876031 */   GIM_Try, /*On fail goto*//*Label 13421*/ GIMT_Encode4(876103), // Rule ID 25126 //
     /*  876036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  876039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876082 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876101 */     GIR_RootConstrainSelectedInstOperands,
     /*  876102 */     // GIR_Coverage, 25126,
     /*  876102 */     GIR_EraseRootFromParent_Done,
     /*  876103 */   // Label 13421: @876103
     /*  876103 */   GIM_Try, /*On fail goto*//*Label 13422*/ GIMT_Encode4(876175), // Rule ID 25127 //
     /*  876108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  876111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876154 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876173 */     GIR_RootConstrainSelectedInstOperands,
     /*  876174 */     // GIR_Coverage, 25127,
     /*  876174 */     GIR_EraseRootFromParent_Done,
     /*  876175 */   // Label 13422: @876175
     /*  876175 */   GIM_Try, /*On fail goto*//*Label 13423*/ GIMT_Encode4(876247), // Rule ID 25128 //
     /*  876180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  876183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  876191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  876194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  876197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876226 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  876229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876245 */     GIR_RootConstrainSelectedInstOperands,
     /*  876246 */     // GIR_Coverage, 25128,
     /*  876246 */     GIR_EraseRootFromParent_Done,
     /*  876247 */   // Label 13423: @876247
     /*  876247 */   GIM_Try, /*On fail goto*//*Label 13424*/ GIMT_Encode4(876319), // Rule ID 25129 //
     /*  876252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  876255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  876263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  876266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  876269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876298 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  876301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876317 */     GIR_RootConstrainSelectedInstOperands,
     /*  876318 */     // GIR_Coverage, 25129,
     /*  876318 */     GIR_EraseRootFromParent_Done,
     /*  876319 */   // Label 13424: @876319
     /*  876319 */   GIM_Try, /*On fail goto*//*Label 13425*/ GIMT_Encode4(876391), // Rule ID 25130 //
     /*  876324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  876327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  876335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  876338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  876341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  876370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  876373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876389 */     GIR_RootConstrainSelectedInstOperands,
     /*  876390 */     // GIR_Coverage, 25130,
     /*  876390 */     GIR_EraseRootFromParent_Done,
     /*  876391 */   // Label 13425: @876391
     /*  876391 */   GIM_Try, /*On fail goto*//*Label 13426*/ GIMT_Encode4(876463), // Rule ID 25131 //
     /*  876396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  876399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  876407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  876410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  876413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876442 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  876445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876461 */     GIR_RootConstrainSelectedInstOperands,
     /*  876462 */     // GIR_Coverage, 25131,
     /*  876462 */     GIR_EraseRootFromParent_Done,
     /*  876463 */   // Label 13426: @876463
     /*  876463 */   GIM_Try, /*On fail goto*//*Label 13427*/ GIMT_Encode4(876535), // Rule ID 25132 //
     /*  876468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  876471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  876479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  876482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  876485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876514 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  876517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876533 */     GIR_RootConstrainSelectedInstOperands,
     /*  876534 */     // GIR_Coverage, 25132,
     /*  876534 */     GIR_EraseRootFromParent_Done,
     /*  876535 */   // Label 13427: @876535
     /*  876535 */   GIM_Try, /*On fail goto*//*Label 13428*/ GIMT_Encode4(876607), // Rule ID 25133 //
     /*  876540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  876543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  876551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  876554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  876557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876586 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  876589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876605 */     GIR_RootConstrainSelectedInstOperands,
     /*  876606 */     // GIR_Coverage, 25133,
     /*  876606 */     GIR_EraseRootFromParent_Done,
     /*  876607 */   // Label 13428: @876607
     /*  876607 */   GIM_Try, /*On fail goto*//*Label 13429*/ GIMT_Encode4(876679), // Rule ID 25134 //
     /*  876612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  876615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  876623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  876626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  876629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876658 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  876658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  876661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876677 */     GIR_RootConstrainSelectedInstOperands,
     /*  876678 */     // GIR_Coverage, 25134,
     /*  876678 */     GIR_EraseRootFromParent_Done,
     /*  876679 */   // Label 13429: @876679
     /*  876679 */   GIM_Try, /*On fail goto*//*Label 13430*/ GIMT_Encode4(876751), // Rule ID 25135 //
     /*  876684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  876687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  876695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  876698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  876701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876730 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  876733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876749 */     GIR_RootConstrainSelectedInstOperands,
     /*  876750 */     // GIR_Coverage, 25135,
     /*  876750 */     GIR_EraseRootFromParent_Done,
     /*  876751 */   // Label 13430: @876751
     /*  876751 */   GIM_Try, /*On fail goto*//*Label 13431*/ GIMT_Encode4(876823), // Rule ID 25136 //
     /*  876756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  876759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  876767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  876770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  876773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876802 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  876805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876821 */     GIR_RootConstrainSelectedInstOperands,
     /*  876822 */     // GIR_Coverage, 25136,
     /*  876822 */     GIR_EraseRootFromParent_Done,
     /*  876823 */   // Label 13431: @876823
     /*  876823 */   GIM_Try, /*On fail goto*//*Label 13432*/ GIMT_Encode4(876895), // Rule ID 25137 //
     /*  876828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  876831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  876839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  876842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  876845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876874 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  876877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876893 */     GIR_RootConstrainSelectedInstOperands,
     /*  876894 */     // GIR_Coverage, 25137,
     /*  876894 */     GIR_EraseRootFromParent_Done,
     /*  876895 */   // Label 13432: @876895
     /*  876895 */   GIM_Try, /*On fail goto*//*Label 13433*/ GIMT_Encode4(876967), // Rule ID 25138 //
     /*  876900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  876903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  876911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  876914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  876917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876946 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  876949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876965 */     GIR_RootConstrainSelectedInstOperands,
     /*  876966 */     // GIR_Coverage, 25138,
     /*  876966 */     GIR_EraseRootFromParent_Done,
     /*  876967 */   // Label 13433: @876967
     /*  876967 */   GIM_Try, /*On fail goto*//*Label 13434*/ GIMT_Encode4(877039), // Rule ID 25139 //
     /*  876972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  876975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  876983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  876986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  876989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877018 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  877021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877037 */     GIR_RootConstrainSelectedInstOperands,
     /*  877038 */     // GIR_Coverage, 25139,
     /*  877038 */     GIR_EraseRootFromParent_Done,
     /*  877039 */   // Label 13434: @877039
     /*  877039 */   GIM_Try, /*On fail goto*//*Label 13435*/ GIMT_Encode4(877111), // Rule ID 25140 //
     /*  877044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  877047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877090 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877109 */     GIR_RootConstrainSelectedInstOperands,
     /*  877110 */     // GIR_Coverage, 25140,
     /*  877110 */     GIR_EraseRootFromParent_Done,
     /*  877111 */   // Label 13435: @877111
     /*  877111 */   GIM_Try, /*On fail goto*//*Label 13436*/ GIMT_Encode4(877183), // Rule ID 25141 //
     /*  877116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  877119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877162 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877181 */     GIR_RootConstrainSelectedInstOperands,
     /*  877182 */     // GIR_Coverage, 25141,
     /*  877182 */     GIR_EraseRootFromParent_Done,
     /*  877183 */   // Label 13436: @877183
     /*  877183 */   GIM_Try, /*On fail goto*//*Label 13437*/ GIMT_Encode4(877255), // Rule ID 25142 //
     /*  877188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  877191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877234 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877253 */     GIR_RootConstrainSelectedInstOperands,
     /*  877254 */     // GIR_Coverage, 25142,
     /*  877254 */     GIR_EraseRootFromParent_Done,
     /*  877255 */   // Label 13437: @877255
     /*  877255 */   GIM_Try, /*On fail goto*//*Label 13438*/ GIMT_Encode4(877327), // Rule ID 25143 //
     /*  877260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  877263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877306 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877325 */     GIR_RootConstrainSelectedInstOperands,
     /*  877326 */     // GIR_Coverage, 25143,
     /*  877326 */     GIR_EraseRootFromParent_Done,
     /*  877327 */   // Label 13438: @877327
     /*  877327 */   GIM_Try, /*On fail goto*//*Label 13439*/ GIMT_Encode4(877399), // Rule ID 25144 //
     /*  877332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  877335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  877343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  877346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  877349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877378 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  877381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877397 */     GIR_RootConstrainSelectedInstOperands,
     /*  877398 */     // GIR_Coverage, 25144,
     /*  877398 */     GIR_EraseRootFromParent_Done,
     /*  877399 */   // Label 13439: @877399
     /*  877399 */   GIM_Try, /*On fail goto*//*Label 13440*/ GIMT_Encode4(877471), // Rule ID 25145 //
     /*  877404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  877407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  877415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  877418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  877421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877450 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  877453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877469 */     GIR_RootConstrainSelectedInstOperands,
     /*  877470 */     // GIR_Coverage, 25145,
     /*  877470 */     GIR_EraseRootFromParent_Done,
     /*  877471 */   // Label 13440: @877471
     /*  877471 */   GIM_Try, /*On fail goto*//*Label 13441*/ GIMT_Encode4(877543), // Rule ID 25146 //
     /*  877476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  877479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  877487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  877490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  877493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877522 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  877525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877541 */     GIR_RootConstrainSelectedInstOperands,
     /*  877542 */     // GIR_Coverage, 25146,
     /*  877542 */     GIR_EraseRootFromParent_Done,
     /*  877543 */   // Label 13441: @877543
     /*  877543 */   GIM_Try, /*On fail goto*//*Label 13442*/ GIMT_Encode4(877615), // Rule ID 25147 //
     /*  877548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  877551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  877559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  877562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  877565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877594 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  877597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877613 */     GIR_RootConstrainSelectedInstOperands,
     /*  877614 */     // GIR_Coverage, 25147,
     /*  877614 */     GIR_EraseRootFromParent_Done,
     /*  877615 */   // Label 13442: @877615
     /*  877615 */   GIM_Try, /*On fail goto*//*Label 13443*/ GIMT_Encode4(877687), // Rule ID 25148 //
     /*  877620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  877623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  877631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  877634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  877637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877666 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  877666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  877669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877685 */     GIR_RootConstrainSelectedInstOperands,
     /*  877686 */     // GIR_Coverage, 25148,
     /*  877686 */     GIR_EraseRootFromParent_Done,
     /*  877687 */   // Label 13443: @877687
     /*  877687 */   GIM_Try, /*On fail goto*//*Label 13444*/ GIMT_Encode4(877759), // Rule ID 25149 //
     /*  877692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  877695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  877703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  877706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  877709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877738 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  877738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  877741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877757 */     GIR_RootConstrainSelectedInstOperands,
     /*  877758 */     // GIR_Coverage, 25149,
     /*  877758 */     GIR_EraseRootFromParent_Done,
     /*  877759 */   // Label 13444: @877759
     /*  877759 */   GIM_Try, /*On fail goto*//*Label 13445*/ GIMT_Encode4(877831), // Rule ID 25150 //
     /*  877764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  877767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  877775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  877778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  877781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877810 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  877810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  877813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877829 */     GIR_RootConstrainSelectedInstOperands,
     /*  877830 */     // GIR_Coverage, 25150,
     /*  877830 */     GIR_EraseRootFromParent_Done,
     /*  877831 */   // Label 13445: @877831
     /*  877831 */   GIM_Try, /*On fail goto*//*Label 13446*/ GIMT_Encode4(877903), // Rule ID 25151 //
     /*  877836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  877839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  877847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  877850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  877853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877882 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  877882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  877885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877901 */     GIR_RootConstrainSelectedInstOperands,
     /*  877902 */     // GIR_Coverage, 25151,
     /*  877902 */     GIR_EraseRootFromParent_Done,
     /*  877903 */   // Label 13446: @877903
     /*  877903 */   GIM_Try, /*On fail goto*//*Label 13447*/ GIMT_Encode4(877975), // Rule ID 25152 //
     /*  877908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  877911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  877919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  877922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  877925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877954 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  877954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  877957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  877973 */     GIR_RootConstrainSelectedInstOperands,
     /*  877974 */     // GIR_Coverage, 25152,
     /*  877974 */     GIR_EraseRootFromParent_Done,
     /*  877975 */   // Label 13447: @877975
     /*  877975 */   GIM_Try, /*On fail goto*//*Label 13448*/ GIMT_Encode4(878047), // Rule ID 25153 //
     /*  877980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  877983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  877991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  877994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  877997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  878000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878026 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  878029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878045 */     GIR_RootConstrainSelectedInstOperands,
     /*  878046 */     // GIR_Coverage, 25153,
     /*  878046 */     GIR_EraseRootFromParent_Done,
     /*  878047 */   // Label 13448: @878047
     /*  878047 */   GIM_Try, /*On fail goto*//*Label 13449*/ GIMT_Encode4(878119), // Rule ID 25154 //
     /*  878052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  878055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  878063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  878066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  878069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878098 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  878098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  878101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878117 */     GIR_RootConstrainSelectedInstOperands,
     /*  878118 */     // GIR_Coverage, 25154,
     /*  878118 */     GIR_EraseRootFromParent_Done,
     /*  878119 */   // Label 13449: @878119
     /*  878119 */   GIM_Try, /*On fail goto*//*Label 13450*/ GIMT_Encode4(878191), // Rule ID 25155 //
     /*  878124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  878127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  878132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  878135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  878138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  878141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  878144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878170 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  878170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  878173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  878189 */     GIR_RootConstrainSelectedInstOperands,
     /*  878190 */     // GIR_Coverage, 25155,
     /*  878190 */     GIR_EraseRootFromParent_Done,
     /*  878191 */   // Label 13450: @878191
     /*  878191 */   GIM_Try, /*On fail goto*//*Label 13451*/ GIMT_Encode4(878266), // Rule ID 60610 //
     /*  878196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  878199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  878204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  878216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  878242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  878245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878264 */     GIR_RootConstrainSelectedInstOperands,
     /*  878265 */     // GIR_Coverage, 60610,
     /*  878265 */     GIR_EraseRootFromParent_Done,
     /*  878266 */   // Label 13451: @878266
     /*  878266 */   GIM_Try, /*On fail goto*//*Label 13452*/ GIMT_Encode4(878341), // Rule ID 60611 //
     /*  878271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  878274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  878279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  878288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  878291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878317 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  878317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  878320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  878336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878339 */     GIR_RootConstrainSelectedInstOperands,
     /*  878340 */     // GIR_Coverage, 60611,
     /*  878340 */     GIR_EraseRootFromParent_Done,
     /*  878341 */   // Label 13452: @878341
     /*  878341 */   GIM_Try, /*On fail goto*//*Label 13453*/ GIMT_Encode4(878416), // Rule ID 60968 //
     /*  878346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  878357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  878360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  878363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  878366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  878395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878414 */     GIR_RootConstrainSelectedInstOperands,
     /*  878415 */     // GIR_Coverage, 60968,
     /*  878415 */     GIR_EraseRootFromParent_Done,
     /*  878416 */   // Label 13453: @878416
     /*  878416 */   GIM_Try, /*On fail goto*//*Label 13454*/ GIMT_Encode4(878491), // Rule ID 60969 //
     /*  878421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  878432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  878435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  878438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  878441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878467 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  878470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878489 */     GIR_RootConstrainSelectedInstOperands,
     /*  878490 */     // GIR_Coverage, 60969,
     /*  878490 */     GIR_EraseRootFromParent_Done,
     /*  878491 */   // Label 13454: @878491
     /*  878491 */   GIM_Try, /*On fail goto*//*Label 13455*/ GIMT_Encode4(878566), // Rule ID 60972 //
     /*  878496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  878507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  878510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  878513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  878516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878542 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  878545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878564 */     GIR_RootConstrainSelectedInstOperands,
     /*  878565 */     // GIR_Coverage, 60972,
     /*  878565 */     GIR_EraseRootFromParent_Done,
     /*  878566 */   // Label 13455: @878566
     /*  878566 */   GIM_Try, /*On fail goto*//*Label 13456*/ GIMT_Encode4(878641), // Rule ID 60973 //
     /*  878571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  878582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  878585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  878588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  878591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878617 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  878620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878639 */     GIR_RootConstrainSelectedInstOperands,
     /*  878640 */     // GIR_Coverage, 60973,
     /*  878640 */     GIR_EraseRootFromParent_Done,
     /*  878641 */   // Label 13456: @878641
     /*  878641 */   GIM_Try, /*On fail goto*//*Label 13457*/ GIMT_Encode4(878716), // Rule ID 60976 //
     /*  878646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  878657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  878660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  878663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  878666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  878695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878714 */     GIR_RootConstrainSelectedInstOperands,
     /*  878715 */     // GIR_Coverage, 60976,
     /*  878715 */     GIR_EraseRootFromParent_Done,
     /*  878716 */   // Label 13457: @878716
     /*  878716 */   GIM_Try, /*On fail goto*//*Label 13458*/ GIMT_Encode4(878791), // Rule ID 60977 //
     /*  878721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  878732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  878735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  878738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  878741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878767 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  878770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878789 */     GIR_RootConstrainSelectedInstOperands,
     /*  878790 */     // GIR_Coverage, 60977,
     /*  878790 */     GIR_EraseRootFromParent_Done,
     /*  878791 */   // Label 13458: @878791
     /*  878791 */   GIM_Try, /*On fail goto*//*Label 13459*/ GIMT_Encode4(878866), // Rule ID 60980 //
     /*  878796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  878813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  878816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878842 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  878845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878864 */     GIR_RootConstrainSelectedInstOperands,
     /*  878865 */     // GIR_Coverage, 60980,
     /*  878865 */     GIR_EraseRootFromParent_Done,
     /*  878866 */   // Label 13459: @878866
     /*  878866 */   GIM_Try, /*On fail goto*//*Label 13460*/ GIMT_Encode4(878941), // Rule ID 60981 //
     /*  878871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  878888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  878891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  878920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878939 */     GIR_RootConstrainSelectedInstOperands,
     /*  878940 */     // GIR_Coverage, 60981,
     /*  878940 */     GIR_EraseRootFromParent_Done,
     /*  878941 */   // Label 13460: @878941
     /*  878941 */   GIM_Try, /*On fail goto*//*Label 13461*/ GIMT_Encode4(879016), // Rule ID 60984 //
     /*  878946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  878957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  878960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  878963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  878966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  878995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879014 */     GIR_RootConstrainSelectedInstOperands,
     /*  879015 */     // GIR_Coverage, 60984,
     /*  879015 */     GIR_EraseRootFromParent_Done,
     /*  879016 */   // Label 13461: @879016
     /*  879016 */   GIM_Try, /*On fail goto*//*Label 13462*/ GIMT_Encode4(879091), // Rule ID 60985 //
     /*  879021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  879032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  879035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  879038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  879041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879067 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879089 */     GIR_RootConstrainSelectedInstOperands,
     /*  879090 */     // GIR_Coverage, 60985,
     /*  879090 */     GIR_EraseRootFromParent_Done,
     /*  879091 */   // Label 13462: @879091
     /*  879091 */   GIM_Try, /*On fail goto*//*Label 13463*/ GIMT_Encode4(879166), // Rule ID 60988 //
     /*  879096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  879107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  879110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  879116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879142 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  879142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879164 */     GIR_RootConstrainSelectedInstOperands,
     /*  879165 */     // GIR_Coverage, 60988,
     /*  879165 */     GIR_EraseRootFromParent_Done,
     /*  879166 */   // Label 13463: @879166
     /*  879166 */   GIM_Try, /*On fail goto*//*Label 13464*/ GIMT_Encode4(879241), // Rule ID 60989 //
     /*  879171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  879182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  879185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  879188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  879191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879217 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  879217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  879236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879239 */     GIR_RootConstrainSelectedInstOperands,
     /*  879240 */     // GIR_Coverage, 60989,
     /*  879240 */     GIR_EraseRootFromParent_Done,
     /*  879241 */   // Label 13464: @879241
     /*  879241 */   GIM_Try, /*On fail goto*//*Label 13465*/ GIMT_Encode4(879316), // Rule ID 60992 //
     /*  879246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  879263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  879266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879292 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879314 */     GIR_RootConstrainSelectedInstOperands,
     /*  879315 */     // GIR_Coverage, 60992,
     /*  879315 */     GIR_EraseRootFromParent_Done,
     /*  879316 */   // Label 13465: @879316
     /*  879316 */   GIM_Try, /*On fail goto*//*Label 13466*/ GIMT_Encode4(879391), // Rule ID 60993 //
     /*  879321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  879332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  879335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  879338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  879341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879367 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  879370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879389 */     GIR_RootConstrainSelectedInstOperands,
     /*  879390 */     // GIR_Coverage, 60993,
     /*  879390 */     GIR_EraseRootFromParent_Done,
     /*  879391 */   // Label 13466: @879391
     /*  879391 */   GIM_Try, /*On fail goto*//*Label 13467*/ GIMT_Encode4(879466), // Rule ID 60996 //
     /*  879396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  879407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  879410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  879413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  879416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879442 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879464 */     GIR_RootConstrainSelectedInstOperands,
     /*  879465 */     // GIR_Coverage, 60996,
     /*  879465 */     GIR_EraseRootFromParent_Done,
     /*  879466 */   // Label 13467: @879466
     /*  879466 */   GIM_Try, /*On fail goto*//*Label 13468*/ GIMT_Encode4(879541), // Rule ID 60997 //
     /*  879471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  879482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  879485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  879488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  879491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879517 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879539 */     GIR_RootConstrainSelectedInstOperands,
     /*  879540 */     // GIR_Coverage, 60997,
     /*  879540 */     GIR_EraseRootFromParent_Done,
     /*  879541 */   // Label 13468: @879541
     /*  879541 */   GIM_Try, /*On fail goto*//*Label 13469*/ GIMT_Encode4(879616), // Rule ID 61000 //
     /*  879546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  879563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  879566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879592 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879614 */     GIR_RootConstrainSelectedInstOperands,
     /*  879615 */     // GIR_Coverage, 61000,
     /*  879615 */     GIR_EraseRootFromParent_Done,
     /*  879616 */   // Label 13469: @879616
     /*  879616 */   GIM_Try, /*On fail goto*//*Label 13470*/ GIMT_Encode4(879691), // Rule ID 61001 //
     /*  879621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  879638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  879641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879689 */     GIR_RootConstrainSelectedInstOperands,
     /*  879690 */     // GIR_Coverage, 61001,
     /*  879690 */     GIR_EraseRootFromParent_Done,
     /*  879691 */   // Label 13470: @879691
     /*  879691 */   GIM_Try, /*On fail goto*//*Label 13471*/ GIMT_Encode4(879766), // Rule ID 61004 //
     /*  879696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  879713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  879716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879764 */     GIR_RootConstrainSelectedInstOperands,
     /*  879765 */     // GIR_Coverage, 61004,
     /*  879765 */     GIR_EraseRootFromParent_Done,
     /*  879766 */   // Label 13471: @879766
     /*  879766 */   GIM_Try, /*On fail goto*//*Label 13472*/ GIMT_Encode4(879841), // Rule ID 61005 //
     /*  879771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  879788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  879791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879817 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879839 */     GIR_RootConstrainSelectedInstOperands,
     /*  879840 */     // GIR_Coverage, 61005,
     /*  879840 */     GIR_EraseRootFromParent_Done,
     /*  879841 */   // Label 13472: @879841
     /*  879841 */   GIM_Try, /*On fail goto*//*Label 13473*/ GIMT_Encode4(879916), // Rule ID 61008 //
     /*  879846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  879863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  879866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879892 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879914 */     GIR_RootConstrainSelectedInstOperands,
     /*  879915 */     // GIR_Coverage, 61008,
     /*  879915 */     GIR_EraseRootFromParent_Done,
     /*  879916 */   // Label 13473: @879916
     /*  879916 */   GIM_Try, /*On fail goto*//*Label 13474*/ GIMT_Encode4(879991), // Rule ID 61009 //
     /*  879921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  879938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  879941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879967 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879989 */     GIR_RootConstrainSelectedInstOperands,
     /*  879990 */     // GIR_Coverage, 61009,
     /*  879990 */     GIR_EraseRootFromParent_Done,
     /*  879991 */   // Label 13474: @879991
     /*  879991 */   GIM_Try, /*On fail goto*//*Label 13475*/ GIMT_Encode4(880066), // Rule ID 61012 //
     /*  879996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  880013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  880016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880042 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  880045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880064 */     GIR_RootConstrainSelectedInstOperands,
     /*  880065 */     // GIR_Coverage, 61012,
     /*  880065 */     GIR_EraseRootFromParent_Done,
     /*  880066 */   // Label 13475: @880066
     /*  880066 */   GIM_Try, /*On fail goto*//*Label 13476*/ GIMT_Encode4(880141), // Rule ID 61013 //
     /*  880071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  880082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  880085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  880088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  880091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880117 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  880120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880139 */     GIR_RootConstrainSelectedInstOperands,
     /*  880140 */     // GIR_Coverage, 61013,
     /*  880140 */     GIR_EraseRootFromParent_Done,
     /*  880141 */   // Label 13476: @880141
     /*  880141 */   GIM_Try, /*On fail goto*//*Label 13477*/ GIMT_Encode4(880216), // Rule ID 61016 //
     /*  880146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  880166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880214 */     GIR_RootConstrainSelectedInstOperands,
     /*  880215 */     // GIR_Coverage, 61016,
     /*  880215 */     GIR_EraseRootFromParent_Done,
     /*  880216 */   // Label 13477: @880216
     /*  880216 */   GIM_Try, /*On fail goto*//*Label 13478*/ GIMT_Encode4(880291), // Rule ID 61017 //
     /*  880221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  880232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  880235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  880238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  880241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880267 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  880270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880289 */     GIR_RootConstrainSelectedInstOperands,
     /*  880290 */     // GIR_Coverage, 61017,
     /*  880290 */     GIR_EraseRootFromParent_Done,
     /*  880291 */   // Label 13478: @880291
     /*  880291 */   GIM_Try, /*On fail goto*//*Label 13479*/ GIMT_Encode4(880366), // Rule ID 61020 //
     /*  880296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  880316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880364 */     GIR_RootConstrainSelectedInstOperands,
     /*  880365 */     // GIR_Coverage, 61020,
     /*  880365 */     GIR_EraseRootFromParent_Done,
     /*  880366 */   // Label 13479: @880366
     /*  880366 */   GIM_Try, /*On fail goto*//*Label 13480*/ GIMT_Encode4(880441), // Rule ID 61021 //
     /*  880371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  880382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  880385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  880388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  880391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880417 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  880420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880439 */     GIR_RootConstrainSelectedInstOperands,
     /*  880440 */     // GIR_Coverage, 61021,
     /*  880440 */     GIR_EraseRootFromParent_Done,
     /*  880441 */   // Label 13480: @880441
     /*  880441 */   GIM_Try, /*On fail goto*//*Label 13481*/ GIMT_Encode4(880516), // Rule ID 61024 //
     /*  880446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  880457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  880460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  880466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880492 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  880492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880514 */     GIR_RootConstrainSelectedInstOperands,
     /*  880515 */     // GIR_Coverage, 61024,
     /*  880515 */     GIR_EraseRootFromParent_Done,
     /*  880516 */   // Label 13481: @880516
     /*  880516 */   GIM_Try, /*On fail goto*//*Label 13482*/ GIMT_Encode4(880591), // Rule ID 61025 //
     /*  880521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  880532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  880535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  880541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880567 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880589 */     GIR_RootConstrainSelectedInstOperands,
     /*  880590 */     // GIR_Coverage, 61025,
     /*  880590 */     GIR_EraseRootFromParent_Done,
     /*  880591 */   // Label 13482: @880591
     /*  880591 */   GIM_Try, /*On fail goto*//*Label 13483*/ GIMT_Encode4(880666), // Rule ID 61028 //
     /*  880596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  880607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  880610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  880613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880642 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  880645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880664 */     GIR_RootConstrainSelectedInstOperands,
     /*  880665 */     // GIR_Coverage, 61028,
     /*  880665 */     GIR_EraseRootFromParent_Done,
     /*  880666 */   // Label 13483: @880666
     /*  880666 */   GIM_Try, /*On fail goto*//*Label 13484*/ GIMT_Encode4(880741), // Rule ID 61029 //
     /*  880671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  880682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  880685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  880688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880717 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  880720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880739 */     GIR_RootConstrainSelectedInstOperands,
     /*  880740 */     // GIR_Coverage, 61029,
     /*  880740 */     GIR_EraseRootFromParent_Done,
     /*  880741 */   // Label 13484: @880741
     /*  880741 */   GIM_Try, /*On fail goto*//*Label 13485*/ GIMT_Encode4(880816), // Rule ID 61036 //
     /*  880746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  880757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  880760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  880763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  880795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880814 */     GIR_RootConstrainSelectedInstOperands,
     /*  880815 */     // GIR_Coverage, 61036,
     /*  880815 */     GIR_EraseRootFromParent_Done,
     /*  880816 */   // Label 13485: @880816
     /*  880816 */   GIM_Try, /*On fail goto*//*Label 13486*/ GIMT_Encode4(880891), // Rule ID 61037 //
     /*  880821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  880832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  880835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  880838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880867 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  880870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880889 */     GIR_RootConstrainSelectedInstOperands,
     /*  880890 */     // GIR_Coverage, 61037,
     /*  880890 */     GIR_EraseRootFromParent_Done,
     /*  880891 */   // Label 13486: @880891
     /*  880891 */   GIM_Try, /*On fail goto*//*Label 13487*/ GIMT_Encode4(880966), // Rule ID 61044 //
     /*  880896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  880907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  880910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  880913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  880945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880964 */     GIR_RootConstrainSelectedInstOperands,
     /*  880965 */     // GIR_Coverage, 61044,
     /*  880965 */     GIR_EraseRootFromParent_Done,
     /*  880966 */   // Label 13487: @880966
     /*  880966 */   GIM_Try, /*On fail goto*//*Label 13488*/ GIMT_Encode4(881041), // Rule ID 61045 //
     /*  880971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  880982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  880985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  880988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881017 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11665:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881039 */     GIR_RootConstrainSelectedInstOperands,
     /*  881040 */     // GIR_Coverage, 61045,
     /*  881040 */     GIR_EraseRootFromParent_Done,
     /*  881041 */   // Label 13488: @881041
     /*  881041 */   GIM_Try, /*On fail goto*//*Label 13489*/ GIMT_Encode4(881116), // Rule ID 61052 //
     /*  881046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  881063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881114 */     GIR_RootConstrainSelectedInstOperands,
     /*  881115 */     // GIR_Coverage, 61052,
     /*  881115 */     GIR_EraseRootFromParent_Done,
     /*  881116 */   // Label 13489: @881116
     /*  881116 */   GIM_Try, /*On fail goto*//*Label 13490*/ GIMT_Encode4(881191), // Rule ID 61053 //
     /*  881121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  881132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  881135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  881138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881189 */     GIR_RootConstrainSelectedInstOperands,
     /*  881190 */     // GIR_Coverage, 61053,
     /*  881190 */     GIR_EraseRootFromParent_Done,
     /*  881191 */   // Label 13490: @881191
     /*  881191 */   GIM_Try, /*On fail goto*//*Label 13491*/ GIMT_Encode4(881266), // Rule ID 61060 //
     /*  881196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  881213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881242 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881264 */     GIR_RootConstrainSelectedInstOperands,
     /*  881265 */     // GIR_Coverage, 61060,
     /*  881265 */     GIR_EraseRootFromParent_Done,
     /*  881266 */   // Label 13491: @881266
     /*  881266 */   GIM_Try, /*On fail goto*//*Label 13492*/ GIMT_Encode4(881341), // Rule ID 61061 //
     /*  881271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  881282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  881285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  881288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881317 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881339 */     GIR_RootConstrainSelectedInstOperands,
     /*  881340 */     // GIR_Coverage, 61061,
     /*  881340 */     GIR_EraseRootFromParent_Done,
     /*  881341 */   // Label 13492: @881341
     /*  881341 */   GIM_Try, /*On fail goto*//*Label 13493*/ GIMT_Encode4(881416), // Rule ID 61068 //
     /*  881346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  881363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  881392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881414 */     GIR_RootConstrainSelectedInstOperands,
     /*  881415 */     // GIR_Coverage, 61068,
     /*  881415 */     GIR_EraseRootFromParent_Done,
     /*  881416 */   // Label 13493: @881416
     /*  881416 */   GIM_Try, /*On fail goto*//*Label 13494*/ GIMT_Encode4(881491), // Rule ID 61069 //
     /*  881421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  881432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  881435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  881438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881467 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  881467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  881486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881489 */     GIR_RootConstrainSelectedInstOperands,
     /*  881490 */     // GIR_Coverage, 61069,
     /*  881490 */     GIR_EraseRootFromParent_Done,
     /*  881491 */   // Label 13494: @881491
     /*  881491 */   GIM_Try, /*On fail goto*//*Label 13495*/ GIMT_Encode4(881566), // Rule ID 61076 //
     /*  881496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  881507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  881510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881542 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881564 */     GIR_RootConstrainSelectedInstOperands,
     /*  881565 */     // GIR_Coverage, 61076,
     /*  881565 */     GIR_EraseRootFromParent_Done,
     /*  881566 */   // Label 13495: @881566
     /*  881566 */   GIM_Try, /*On fail goto*//*Label 13496*/ GIMT_Encode4(881641), // Rule ID 61077 //
     /*  881571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  881582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  881585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881617 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881639 */     GIR_RootConstrainSelectedInstOperands,
     /*  881640 */     // GIR_Coverage, 61077,
     /*  881640 */     GIR_EraseRootFromParent_Done,
     /*  881641 */   // Label 13496: @881641
     /*  881641 */   GIM_Try, /*On fail goto*//*Label 13497*/ GIMT_Encode4(881716), // Rule ID 61084 //
     /*  881646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  881657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  881660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881692 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881714 */     GIR_RootConstrainSelectedInstOperands,
     /*  881715 */     // GIR_Coverage, 61084,
     /*  881715 */     GIR_EraseRootFromParent_Done,
     /*  881716 */   // Label 13497: @881716
     /*  881716 */   GIM_Try, /*On fail goto*//*Label 13498*/ GIMT_Encode4(881791), // Rule ID 61085 //
     /*  881721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  881732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  881735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881767 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11665:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881789 */     GIR_RootConstrainSelectedInstOperands,
     /*  881790 */     // GIR_Coverage, 61085,
     /*  881790 */     GIR_EraseRootFromParent_Done,
     /*  881791 */   // Label 13498: @881791
     /*  881791 */   GIM_Try, /*On fail goto*//*Label 13499*/ GIMT_Encode4(881866), // Rule ID 61092 //
     /*  881796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  881807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  881810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881842 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881864 */     GIR_RootConstrainSelectedInstOperands,
     /*  881865 */     // GIR_Coverage, 61092,
     /*  881865 */     GIR_EraseRootFromParent_Done,
     /*  881866 */   // Label 13499: @881866
     /*  881866 */   GIM_Try, /*On fail goto*//*Label 13500*/ GIMT_Encode4(881941), // Rule ID 61093 //
     /*  881871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  881882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  881885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881939 */     GIR_RootConstrainSelectedInstOperands,
     /*  881940 */     // GIR_Coverage, 61093,
     /*  881940 */     GIR_EraseRootFromParent_Done,
     /*  881941 */   // Label 13500: @881941
     /*  881941 */   GIM_Try, /*On fail goto*//*Label 13501*/ GIMT_Encode4(882016), // Rule ID 61100 //
     /*  881946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  881957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  881960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  881963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881992 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882014 */     GIR_RootConstrainSelectedInstOperands,
     /*  882015 */     // GIR_Coverage, 61100,
     /*  882015 */     GIR_EraseRootFromParent_Done,
     /*  882016 */   // Label 13501: @882016
     /*  882016 */   GIM_Try, /*On fail goto*//*Label 13502*/ GIMT_Encode4(882091), // Rule ID 61101 //
     /*  882021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  882032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  882035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  882038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882067 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882089 */     GIR_RootConstrainSelectedInstOperands,
     /*  882090 */     // GIR_Coverage, 61101,
     /*  882090 */     GIR_EraseRootFromParent_Done,
     /*  882091 */   // Label 13502: @882091
     /*  882091 */   GIM_Try, /*On fail goto*//*Label 13503*/ GIMT_Encode4(882166), // Rule ID 61108 //
     /*  882096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  882107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  882110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  882113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  882142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882164 */     GIR_RootConstrainSelectedInstOperands,
     /*  882165 */     // GIR_Coverage, 61108,
     /*  882165 */     GIR_EraseRootFromParent_Done,
     /*  882166 */   // Label 13503: @882166
     /*  882166 */   GIM_Try, /*On fail goto*//*Label 13504*/ GIMT_Encode4(882241), // Rule ID 61109 //
     /*  882171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  882182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  882185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  882188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882217 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  882217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  882236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882239 */     GIR_RootConstrainSelectedInstOperands,
     /*  882240 */     // GIR_Coverage, 61109,
     /*  882240 */     GIR_EraseRootFromParent_Done,
     /*  882241 */   // Label 13504: @882241
     /*  882241 */   GIM_Try, /*On fail goto*//*Label 13505*/ GIMT_Encode4(882316), // Rule ID 61116 //
     /*  882246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882314 */     GIR_RootConstrainSelectedInstOperands,
     /*  882315 */     // GIR_Coverage, 61116,
     /*  882315 */     GIR_EraseRootFromParent_Done,
     /*  882316 */   // Label 13505: @882316
     /*  882316 */   GIM_Try, /*On fail goto*//*Label 13506*/ GIMT_Encode4(882391), // Rule ID 61117 //
     /*  882321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  882338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882367 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11665:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  882370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882389 */     GIR_RootConstrainSelectedInstOperands,
     /*  882390 */     // GIR_Coverage, 61117,
     /*  882390 */     GIR_EraseRootFromParent_Done,
     /*  882391 */   // Label 13506: @882391
     /*  882391 */   GIM_Try, /*On fail goto*//*Label 13507*/ GIMT_Encode4(882466), // Rule ID 61124 //
     /*  882396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  882413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882464 */     GIR_RootConstrainSelectedInstOperands,
     /*  882465 */     // GIR_Coverage, 61124,
     /*  882465 */     GIR_EraseRootFromParent_Done,
     /*  882466 */   // Label 13507: @882466
     /*  882466 */   GIM_Try, /*On fail goto*//*Label 13508*/ GIMT_Encode4(882541), // Rule ID 61125 //
     /*  882471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  882488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882517 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11665:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882539 */     GIR_RootConstrainSelectedInstOperands,
     /*  882540 */     // GIR_Coverage, 61125,
     /*  882540 */     GIR_EraseRootFromParent_Done,
     /*  882541 */   // Label 13508: @882541
     /*  882541 */   GIM_Try, /*On fail goto*//*Label 13509*/ GIMT_Encode4(882616), // Rule ID 61132 //
     /*  882546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  882557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  882560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  882563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882592 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882614 */     GIR_RootConstrainSelectedInstOperands,
     /*  882615 */     // GIR_Coverage, 61132,
     /*  882615 */     GIR_EraseRootFromParent_Done,
     /*  882616 */   // Label 13509: @882616
     /*  882616 */   GIM_Try, /*On fail goto*//*Label 13510*/ GIMT_Encode4(882691), // Rule ID 61133 //
     /*  882621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  882632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  882635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  882638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882667 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11665:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882689 */     GIR_RootConstrainSelectedInstOperands,
     /*  882690 */     // GIR_Coverage, 61133,
     /*  882690 */     GIR_EraseRootFromParent_Done,
     /*  882691 */   // Label 13510: @882691
     /*  882691 */   GIM_Try, /*On fail goto*//*Label 13511*/ GIMT_Encode4(882766), // Rule ID 61140 //
     /*  882696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  882707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  882710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  882713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882742 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882764 */     GIR_RootConstrainSelectedInstOperands,
     /*  882765 */     // GIR_Coverage, 61140,
     /*  882765 */     GIR_EraseRootFromParent_Done,
     /*  882766 */   // Label 13511: @882766
     /*  882766 */   GIM_Try, /*On fail goto*//*Label 13512*/ GIMT_Encode4(882841), // Rule ID 61141 //
     /*  882771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  882782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  882785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  882788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882817 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11665:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882839 */     GIR_RootConstrainSelectedInstOperands,
     /*  882840 */     // GIR_Coverage, 61141,
     /*  882840 */     GIR_EraseRootFromParent_Done,
     /*  882841 */   // Label 13512: @882841
     /*  882841 */   GIM_Try, /*On fail goto*//*Label 13513*/ GIMT_Encode4(882916), // Rule ID 61148 //
     /*  882846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  882849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  882863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  882866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882892 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  882892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  882895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882914 */     GIR_RootConstrainSelectedInstOperands,
     /*  882915 */     // GIR_Coverage, 61148,
     /*  882915 */     GIR_EraseRootFromParent_Done,
     /*  882916 */   // Label 13513: @882916
     /*  882916 */   GIM_Try, /*On fail goto*//*Label 13514*/ GIMT_Encode4(882991), // Rule ID 61149 //
     /*  882921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  882924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  882938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  882941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882967 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  882967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  882970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882989 */     GIR_RootConstrainSelectedInstOperands,
     /*  882990 */     // GIR_Coverage, 61149,
     /*  882990 */     GIR_EraseRootFromParent_Done,
     /*  882991 */   // Label 13514: @882991
     /*  882991 */   GIM_Try, /*On fail goto*//*Label 13515*/ GIMT_Encode4(883066), // Rule ID 61152 //
     /*  882996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  882999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  883045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883064 */     GIR_RootConstrainSelectedInstOperands,
     /*  883065 */     // GIR_Coverage, 61152,
     /*  883065 */     GIR_EraseRootFromParent_Done,
     /*  883066 */   // Label 13515: @883066
     /*  883066 */   GIM_Try, /*On fail goto*//*Label 13516*/ GIMT_Encode4(883141), // Rule ID 61153 //
     /*  883071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  883120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883139 */     GIR_RootConstrainSelectedInstOperands,
     /*  883140 */     // GIR_Coverage, 61153,
     /*  883140 */     GIR_EraseRootFromParent_Done,
     /*  883141 */   // Label 13516: @883141
     /*  883141 */   GIM_Try, /*On fail goto*//*Label 13517*/ GIMT_Encode4(883216), // Rule ID 61156 //
     /*  883146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883192 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  883195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883214 */     GIR_RootConstrainSelectedInstOperands,
     /*  883215 */     // GIR_Coverage, 61156,
     /*  883215 */     GIR_EraseRootFromParent_Done,
     /*  883216 */   // Label 13517: @883216
     /*  883216 */   GIM_Try, /*On fail goto*//*Label 13518*/ GIMT_Encode4(883291), // Rule ID 61157 //
     /*  883221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883267 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  883270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883289 */     GIR_RootConstrainSelectedInstOperands,
     /*  883290 */     // GIR_Coverage, 61157,
     /*  883290 */     GIR_EraseRootFromParent_Done,
     /*  883291 */   // Label 13518: @883291
     /*  883291 */   GIM_Try, /*On fail goto*//*Label 13519*/ GIMT_Encode4(883366), // Rule ID 61160 //
     /*  883296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  883316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883342 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  883345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883364 */     GIR_RootConstrainSelectedInstOperands,
     /*  883365 */     // GIR_Coverage, 61160,
     /*  883365 */     GIR_EraseRootFromParent_Done,
     /*  883366 */   // Label 13519: @883366
     /*  883366 */   GIM_Try, /*On fail goto*//*Label 13520*/ GIMT_Encode4(883441), // Rule ID 61161 //
     /*  883371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  883391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883417 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  883420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883439 */     GIR_RootConstrainSelectedInstOperands,
     /*  883440 */     // GIR_Coverage, 61161,
     /*  883440 */     GIR_EraseRootFromParent_Done,
     /*  883441 */   // Label 13520: @883441
     /*  883441 */   GIM_Try, /*On fail goto*//*Label 13521*/ GIMT_Encode4(883516), // Rule ID 61164 //
     /*  883446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883492 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  883495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883514 */     GIR_RootConstrainSelectedInstOperands,
     /*  883515 */     // GIR_Coverage, 61164,
     /*  883515 */     GIR_EraseRootFromParent_Done,
     /*  883516 */   // Label 13521: @883516
     /*  883516 */   GIM_Try, /*On fail goto*//*Label 13522*/ GIMT_Encode4(883591), // Rule ID 61165 //
     /*  883521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883567 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  883570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883589 */     GIR_RootConstrainSelectedInstOperands,
     /*  883590 */     // GIR_Coverage, 61165,
     /*  883590 */     GIR_EraseRootFromParent_Done,
     /*  883591 */   // Label 13522: @883591
     /*  883591 */   GIM_Try, /*On fail goto*//*Label 13523*/ GIMT_Encode4(883666), // Rule ID 61168 //
     /*  883596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883642 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  883645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883664 */     GIR_RootConstrainSelectedInstOperands,
     /*  883665 */     // GIR_Coverage, 61168,
     /*  883665 */     GIR_EraseRootFromParent_Done,
     /*  883666 */   // Label 13523: @883666
     /*  883666 */   GIM_Try, /*On fail goto*//*Label 13524*/ GIMT_Encode4(883741), // Rule ID 61169 //
     /*  883671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883717 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  883720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883739 */     GIR_RootConstrainSelectedInstOperands,
     /*  883740 */     // GIR_Coverage, 61169,
     /*  883740 */     GIR_EraseRootFromParent_Done,
     /*  883741 */   // Label 13524: @883741
     /*  883741 */   GIM_Try, /*On fail goto*//*Label 13525*/ GIMT_Encode4(883816), // Rule ID 61172 //
     /*  883746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883792 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  883795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883814 */     GIR_RootConstrainSelectedInstOperands,
     /*  883815 */     // GIR_Coverage, 61172,
     /*  883815 */     GIR_EraseRootFromParent_Done,
     /*  883816 */   // Label 13525: @883816
     /*  883816 */   GIM_Try, /*On fail goto*//*Label 13526*/ GIMT_Encode4(883891), // Rule ID 61173 //
     /*  883821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  883870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883889 */     GIR_RootConstrainSelectedInstOperands,
     /*  883890 */     // GIR_Coverage, 61173,
     /*  883890 */     GIR_EraseRootFromParent_Done,
     /*  883891 */   // Label 13526: @883891
     /*  883891 */   GIM_Try, /*On fail goto*//*Label 13527*/ GIMT_Encode4(883966), // Rule ID 61176 //
     /*  883896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  883945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883964 */     GIR_RootConstrainSelectedInstOperands,
     /*  883965 */     // GIR_Coverage, 61176,
     /*  883965 */     GIR_EraseRootFromParent_Done,
     /*  883966 */   // Label 13527: @883966
     /*  883966 */   GIM_Try, /*On fail goto*//*Label 13528*/ GIMT_Encode4(884041), // Rule ID 61177 //
     /*  883971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884017 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11168:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  884020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884039 */     GIR_RootConstrainSelectedInstOperands,
     /*  884040 */     // GIR_Coverage, 61177,
     /*  884040 */     GIR_EraseRootFromParent_Done,
     /*  884041 */   // Label 13528: @884041
     /*  884041 */   GIM_Try, /*On fail goto*//*Label 13529*/ GIMT_Encode4(884116), // Rule ID 61180 //
     /*  884046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  884066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  884095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884114 */     GIR_RootConstrainSelectedInstOperands,
     /*  884115 */     // GIR_Coverage, 61180,
     /*  884115 */     GIR_EraseRootFromParent_Done,
     /*  884116 */   // Label 13529: @884116
     /*  884116 */   GIM_Try, /*On fail goto*//*Label 13530*/ GIMT_Encode4(884191), // Rule ID 61181 //
     /*  884121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  884141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884167 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  884170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884189 */     GIR_RootConstrainSelectedInstOperands,
     /*  884190 */     // GIR_Coverage, 61181,
     /*  884190 */     GIR_EraseRootFromParent_Done,
     /*  884191 */   // Label 13530: @884191
     /*  884191 */   GIM_Try, /*On fail goto*//*Label 13531*/ GIMT_Encode4(884266), // Rule ID 61184 //
     /*  884196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  884216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884242 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  884245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884264 */     GIR_RootConstrainSelectedInstOperands,
     /*  884265 */     // GIR_Coverage, 61184,
     /*  884265 */     GIR_EraseRootFromParent_Done,
     /*  884266 */   // Label 13531: @884266
     /*  884266 */   GIM_Try, /*On fail goto*//*Label 13532*/ GIMT_Encode4(884341), // Rule ID 61185 //
     /*  884271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  884291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  884320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884339 */     GIR_RootConstrainSelectedInstOperands,
     /*  884340 */     // GIR_Coverage, 61185,
     /*  884340 */     GIR_EraseRootFromParent_Done,
     /*  884341 */   // Label 13532: @884341
     /*  884341 */   GIM_Try, /*On fail goto*//*Label 13533*/ GIMT_Encode4(884416), // Rule ID 61188 //
     /*  884346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  884366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884392 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  884395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884414 */     GIR_RootConstrainSelectedInstOperands,
     /*  884415 */     // GIR_Coverage, 61188,
     /*  884415 */     GIR_EraseRootFromParent_Done,
     /*  884416 */   // Label 13533: @884416
     /*  884416 */   GIM_Try, /*On fail goto*//*Label 13534*/ GIMT_Encode4(884491), // Rule ID 61189 //
     /*  884421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  884441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884467 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  884470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884489 */     GIR_RootConstrainSelectedInstOperands,
     /*  884490 */     // GIR_Coverage, 61189,
     /*  884490 */     GIR_EraseRootFromParent_Done,
     /*  884491 */   // Label 13534: @884491
     /*  884491 */   GIM_Try, /*On fail goto*//*Label 13535*/ GIMT_Encode4(884566), // Rule ID 61192 //
     /*  884496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  884516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  884545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884564 */     GIR_RootConstrainSelectedInstOperands,
     /*  884565 */     // GIR_Coverage, 61192,
     /*  884565 */     GIR_EraseRootFromParent_Done,
     /*  884566 */   // Label 13535: @884566
     /*  884566 */   GIM_Try, /*On fail goto*//*Label 13536*/ GIMT_Encode4(884641), // Rule ID 61193 //
     /*  884571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  884591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884617 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  884620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884639 */     GIR_RootConstrainSelectedInstOperands,
     /*  884640 */     // GIR_Coverage, 61193,
     /*  884640 */     GIR_EraseRootFromParent_Done,
     /*  884641 */   // Label 13536: @884641
     /*  884641 */   GIM_Try, /*On fail goto*//*Label 13537*/ GIMT_Encode4(884716), // Rule ID 61196 //
     /*  884646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  884695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884714 */     GIR_RootConstrainSelectedInstOperands,
     /*  884715 */     // GIR_Coverage, 61196,
     /*  884715 */     GIR_EraseRootFromParent_Done,
     /*  884716 */   // Label 13537: @884716
     /*  884716 */   GIM_Try, /*On fail goto*//*Label 13538*/ GIMT_Encode4(884791), // Rule ID 61197 //
     /*  884721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884767 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11170:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  884770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884789 */     GIR_RootConstrainSelectedInstOperands,
     /*  884790 */     // GIR_Coverage, 61197,
     /*  884790 */     GIR_EraseRootFromParent_Done,
     /*  884791 */   // Label 13538: @884791
     /*  884791 */   GIM_Try, /*On fail goto*//*Label 13539*/ GIMT_Encode4(884866), // Rule ID 61200 //
     /*  884796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884842 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  884845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884864 */     GIR_RootConstrainSelectedInstOperands,
     /*  884865 */     // GIR_Coverage, 61200,
     /*  884865 */     GIR_EraseRootFromParent_Done,
     /*  884866 */   // Label 13539: @884866
     /*  884866 */   GIM_Try, /*On fail goto*//*Label 13540*/ GIMT_Encode4(884941), // Rule ID 61201 //
     /*  884871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884917 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11170:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  884920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884939 */     GIR_RootConstrainSelectedInstOperands,
     /*  884940 */     // GIR_Coverage, 61201,
     /*  884940 */     GIR_EraseRootFromParent_Done,
     /*  884941 */   // Label 13540: @884941
     /*  884941 */   GIM_Try, /*On fail goto*//*Label 13541*/ GIMT_Encode4(885016), // Rule ID 61204 //
     /*  884946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  884995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885014 */     GIR_RootConstrainSelectedInstOperands,
     /*  885015 */     // GIR_Coverage, 61204,
     /*  885015 */     GIR_EraseRootFromParent_Done,
     /*  885016 */   // Label 13541: @885016
     /*  885016 */   GIM_Try, /*On fail goto*//*Label 13542*/ GIMT_Encode4(885091), // Rule ID 61205 //
     /*  885021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  885032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  885035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  885038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  885056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885067 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11170:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  885070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885089 */     GIR_RootConstrainSelectedInstOperands,
     /*  885090 */     // GIR_Coverage, 61205,
     /*  885090 */     GIR_EraseRootFromParent_Done,
     /*  885091 */   // Label 13542: @885091
     /*  885091 */   GIM_Try, /*On fail goto*//*Label 13543*/ GIMT_Encode4(885166), // Rule ID 61208 //
     /*  885096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  885099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  885116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  885142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  885145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885164 */     GIR_RootConstrainSelectedInstOperands,
     /*  885165 */     // GIR_Coverage, 61208,
     /*  885165 */     GIR_EraseRootFromParent_Done,
     /*  885166 */   // Label 13543: @885166
     /*  885166 */   GIM_Try, /*On fail goto*//*Label 13544*/ GIMT_Encode4(885241), // Rule ID 61209 //
     /*  885171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  885174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  885179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  885182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  885185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  885188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  885191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  885206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  885210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885217 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11170:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  885217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  885220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  885236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885239 */     GIR_RootConstrainSelectedInstOperands,
     /*  885240 */     // GIR_Coverage, 61209,
     /*  885240 */     GIR_EraseRootFromParent_Done,
     /*  885241 */   // Label 13544: @885241
     /*  885241 */   GIM_Try, /*On fail goto*//*Label 13545*/ GIMT_Encode4(885316), // Rule ID 61212 //
     /*  885246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  885257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  885260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  885263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  885266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885292 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  885295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885314 */     GIR_RootConstrainSelectedInstOperands,
     /*  885315 */     // GIR_Coverage, 61212,
     /*  885315 */     GIR_EraseRootFromParent_Done,
     /*  885316 */   // Label 13545: @885316
     /*  885316 */   GIM_Try, /*On fail goto*//*Label 13546*/ GIMT_Encode4(885391), // Rule ID 61213 //
     /*  885321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  885332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  885335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  885338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  885341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885367 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  885370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885389 */     GIR_RootConstrainSelectedInstOperands,
     /*  885390 */     // GIR_Coverage, 61213,
     /*  885390 */     GIR_EraseRootFromParent_Done,
     /*  885391 */   // Label 13546: @885391
     /*  885391 */   GIM_Try, /*On fail goto*//*Label 13547*/ GIMT_Encode4(885466), // Rule ID 61216 //
     /*  885396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  885407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  885410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  885413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  885416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885442 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885464 */     GIR_RootConstrainSelectedInstOperands,
     /*  885465 */     // GIR_Coverage, 61216,
     /*  885465 */     GIR_EraseRootFromParent_Done,
     /*  885466 */   // Label 13547: @885466
     /*  885466 */   GIM_Try, /*On fail goto*//*Label 13548*/ GIMT_Encode4(885541), // Rule ID 61217 //
     /*  885471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  885482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  885485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  885488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  885491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885517 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885539 */     GIR_RootConstrainSelectedInstOperands,
     /*  885540 */     // GIR_Coverage, 61217,
     /*  885540 */     GIR_EraseRootFromParent_Done,
     /*  885541 */   // Label 13548: @885541
     /*  885541 */   GIM_Try, /*On fail goto*//*Label 13549*/ GIMT_Encode4(885616), // Rule ID 61220 //
     /*  885546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  885557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  885560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  885563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  885566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885592 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885614 */     GIR_RootConstrainSelectedInstOperands,
     /*  885615 */     // GIR_Coverage, 61220,
     /*  885615 */     GIR_EraseRootFromParent_Done,
     /*  885616 */   // Label 13549: @885616
     /*  885616 */   GIM_Try, /*On fail goto*//*Label 13550*/ GIMT_Encode4(885691), // Rule ID 61221 //
     /*  885621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  885632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  885635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  885638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  885641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885667 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885689 */     GIR_RootConstrainSelectedInstOperands,
     /*  885690 */     // GIR_Coverage, 61221,
     /*  885690 */     GIR_EraseRootFromParent_Done,
     /*  885691 */   // Label 13550: @885691
     /*  885691 */   GIM_Try, /*On fail goto*//*Label 13551*/ GIMT_Encode4(885766), // Rule ID 61224 //
     /*  885696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  885707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  885710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  885716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885764 */     GIR_RootConstrainSelectedInstOperands,
     /*  885765 */     // GIR_Coverage, 61224,
     /*  885765 */     GIR_EraseRootFromParent_Done,
     /*  885766 */   // Label 13551: @885766
     /*  885766 */   GIM_Try, /*On fail goto*//*Label 13552*/ GIMT_Encode4(885841), // Rule ID 61225 //
     /*  885771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  885782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  885785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  885791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885817 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885839 */     GIR_RootConstrainSelectedInstOperands,
     /*  885840 */     // GIR_Coverage, 61225,
     /*  885840 */     GIR_EraseRootFromParent_Done,
     /*  885841 */   // Label 13552: @885841
     /*  885841 */   GIM_Try, /*On fail goto*//*Label 13553*/ GIMT_Encode4(885916), // Rule ID 61228 //
     /*  885846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  885857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  885860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  885866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885892 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885914 */     GIR_RootConstrainSelectedInstOperands,
     /*  885915 */     // GIR_Coverage, 61228,
     /*  885915 */     GIR_EraseRootFromParent_Done,
     /*  885916 */   // Label 13553: @885916
     /*  885916 */   GIM_Try, /*On fail goto*//*Label 13554*/ GIMT_Encode4(885991), // Rule ID 61229 //
     /*  885921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  885932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  885935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  885941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885967 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885989 */     GIR_RootConstrainSelectedInstOperands,
     /*  885990 */     // GIR_Coverage, 61229,
     /*  885990 */     GIR_EraseRootFromParent_Done,
     /*  885991 */   // Label 13554: @885991
     /*  885991 */   GIM_Try, /*On fail goto*//*Label 13555*/ GIMT_Encode4(886066), // Rule ID 61232 //
     /*  885996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  886007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  886010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  886016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886064 */     GIR_RootConstrainSelectedInstOperands,
     /*  886065 */     // GIR_Coverage, 61232,
     /*  886065 */     GIR_EraseRootFromParent_Done,
     /*  886066 */   // Label 13555: @886066
     /*  886066 */   GIM_Try, /*On fail goto*//*Label 13556*/ GIMT_Encode4(886141), // Rule ID 61233 //
     /*  886071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  886082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  886085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  886088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  886091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886117 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  886120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886139 */     GIR_RootConstrainSelectedInstOperands,
     /*  886140 */     // GIR_Coverage, 61233,
     /*  886140 */     GIR_EraseRootFromParent_Done,
     /*  886141 */   // Label 13556: @886141
     /*  886141 */   GIM_Try, /*On fail goto*//*Label 13557*/ GIMT_Encode4(886216), // Rule ID 61236 //
     /*  886146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  886157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  886160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  886163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  886166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886192 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886214 */     GIR_RootConstrainSelectedInstOperands,
     /*  886215 */     // GIR_Coverage, 61236,
     /*  886215 */     GIR_EraseRootFromParent_Done,
     /*  886216 */   // Label 13557: @886216
     /*  886216 */   GIM_Try, /*On fail goto*//*Label 13558*/ GIMT_Encode4(886291), // Rule ID 61237 //
     /*  886221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  886232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  886235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  886238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  886241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886267 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886289 */     GIR_RootConstrainSelectedInstOperands,
     /*  886290 */     // GIR_Coverage, 61237,
     /*  886290 */     GIR_EraseRootFromParent_Done,
     /*  886291 */   // Label 13558: @886291
     /*  886291 */   GIM_Try, /*On fail goto*//*Label 13559*/ GIMT_Encode4(886366), // Rule ID 61240 //
     /*  886296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  886307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  886310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  886313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  886316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886364 */     GIR_RootConstrainSelectedInstOperands,
     /*  886365 */     // GIR_Coverage, 61240,
     /*  886365 */     GIR_EraseRootFromParent_Done,
     /*  886366 */   // Label 13559: @886366
     /*  886366 */   GIM_Try, /*On fail goto*//*Label 13560*/ GIMT_Encode4(886441), // Rule ID 61241 //
     /*  886371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  886382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  886385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  886388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  886391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886417 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886439 */     GIR_RootConstrainSelectedInstOperands,
     /*  886440 */     // GIR_Coverage, 61241,
     /*  886440 */     GIR_EraseRootFromParent_Done,
     /*  886441 */   // Label 13560: @886441
     /*  886441 */   GIM_Try, /*On fail goto*//*Label 13561*/ GIMT_Encode4(886516), // Rule ID 61244 //
     /*  886446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  886457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  886460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  886466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  886492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886514 */     GIR_RootConstrainSelectedInstOperands,
     /*  886515 */     // GIR_Coverage, 61244,
     /*  886515 */     GIR_EraseRootFromParent_Done,
     /*  886516 */   // Label 13561: @886516
     /*  886516 */   GIM_Try, /*On fail goto*//*Label 13562*/ GIMT_Encode4(886591), // Rule ID 61245 //
     /*  886521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  886532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  886535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  886541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886567 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886589 */     GIR_RootConstrainSelectedInstOperands,
     /*  886590 */     // GIR_Coverage, 61245,
     /*  886590 */     GIR_EraseRootFromParent_Done,
     /*  886591 */   // Label 13562: @886591
     /*  886591 */   GIM_Try, /*On fail goto*//*Label 13563*/ GIMT_Encode4(886666), // Rule ID 61248 //
     /*  886596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886642 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  886642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886664 */     GIR_RootConstrainSelectedInstOperands,
     /*  886665 */     // GIR_Coverage, 61248,
     /*  886665 */     GIR_EraseRootFromParent_Done,
     /*  886666 */   // Label 13563: @886666
     /*  886666 */   GIM_Try, /*On fail goto*//*Label 13564*/ GIMT_Encode4(886741), // Rule ID 61249 //
     /*  886671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886717 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  886717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886739 */     GIR_RootConstrainSelectedInstOperands,
     /*  886740 */     // GIR_Coverage, 61249,
     /*  886740 */     GIR_EraseRootFromParent_Done,
     /*  886741 */   // Label 13564: @886741
     /*  886741 */   GIM_Try, /*On fail goto*//*Label 13565*/ GIMT_Encode4(886816), // Rule ID 61252 //
     /*  886746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  886757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  886760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  886763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  886766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886792 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  886795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886814 */     GIR_RootConstrainSelectedInstOperands,
     /*  886815 */     // GIR_Coverage, 61252,
     /*  886815 */     GIR_EraseRootFromParent_Done,
     /*  886816 */   // Label 13565: @886816
     /*  886816 */   GIM_Try, /*On fail goto*//*Label 13566*/ GIMT_Encode4(886891), // Rule ID 61253 //
     /*  886821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  886832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  886835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  886838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  886841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886867 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  886870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886889 */     GIR_RootConstrainSelectedInstOperands,
     /*  886890 */     // GIR_Coverage, 61253,
     /*  886890 */     GIR_EraseRootFromParent_Done,
     /*  886891 */   // Label 13566: @886891
     /*  886891 */   GIM_Try, /*On fail goto*//*Label 13567*/ GIMT_Encode4(886966), // Rule ID 61256 //
     /*  886896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  886907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  886910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  886913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  886916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886942 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  886945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886964 */     GIR_RootConstrainSelectedInstOperands,
     /*  886965 */     // GIR_Coverage, 61256,
     /*  886965 */     GIR_EraseRootFromParent_Done,
     /*  886966 */   // Label 13567: @886966
     /*  886966 */   GIM_Try, /*On fail goto*//*Label 13568*/ GIMT_Encode4(887041), // Rule ID 61257 //
     /*  886971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  886982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  886985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  886988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  886991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887017 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887039 */     GIR_RootConstrainSelectedInstOperands,
     /*  887040 */     // GIR_Coverage, 61257,
     /*  887040 */     GIR_EraseRootFromParent_Done,
     /*  887041 */   // Label 13568: @887041
     /*  887041 */   GIM_Try, /*On fail goto*//*Label 13569*/ GIMT_Encode4(887116), // Rule ID 61260 //
     /*  887046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  887057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  887060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  887063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  887066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  887092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887114 */     GIR_RootConstrainSelectedInstOperands,
     /*  887115 */     // GIR_Coverage, 61260,
     /*  887115 */     GIR_EraseRootFromParent_Done,
     /*  887116 */   // Label 13569: @887116
     /*  887116 */   GIM_Try, /*On fail goto*//*Label 13570*/ GIMT_Encode4(887191), // Rule ID 61261 //
     /*  887121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  887132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  887135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  887138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  887141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887167 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  887167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  887186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887189 */     GIR_RootConstrainSelectedInstOperands,
     /*  887190 */     // GIR_Coverage, 61261,
     /*  887190 */     GIR_EraseRootFromParent_Done,
     /*  887191 */   // Label 13570: @887191
     /*  887191 */   GIM_Try, /*On fail goto*//*Label 13571*/ GIMT_Encode4(887266), // Rule ID 61264 //
     /*  887196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  887207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  887210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  887213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  887216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887264 */     GIR_RootConstrainSelectedInstOperands,
     /*  887265 */     // GIR_Coverage, 61264,
     /*  887265 */     GIR_EraseRootFromParent_Done,
     /*  887266 */   // Label 13571: @887266
     /*  887266 */   GIM_Try, /*On fail goto*//*Label 13572*/ GIMT_Encode4(887341), // Rule ID 61265 //
     /*  887271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  887282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  887285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  887288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  887291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887317 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887339 */     GIR_RootConstrainSelectedInstOperands,
     /*  887340 */     // GIR_Coverage, 61265,
     /*  887340 */     GIR_EraseRootFromParent_Done,
     /*  887341 */   // Label 13572: @887341
     /*  887341 */   GIM_Try, /*On fail goto*//*Label 13573*/ GIMT_Encode4(887416), // Rule ID 61268 //
     /*  887346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  887357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  887360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  887363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  887366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887414 */     GIR_RootConstrainSelectedInstOperands,
     /*  887415 */     // GIR_Coverage, 61268,
     /*  887415 */     GIR_EraseRootFromParent_Done,
     /*  887416 */   // Label 13573: @887416
     /*  887416 */   GIM_Try, /*On fail goto*//*Label 13574*/ GIMT_Encode4(887491), // Rule ID 61269 //
     /*  887421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  887432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  887435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  887438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  887441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887467 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887489 */     GIR_RootConstrainSelectedInstOperands,
     /*  887490 */     // GIR_Coverage, 61269,
     /*  887490 */     GIR_EraseRootFromParent_Done,
     /*  887491 */   // Label 13574: @887491
     /*  887491 */   GIM_Try, /*On fail goto*//*Label 13575*/ GIMT_Encode4(887566), // Rule ID 61272 //
     /*  887496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  887507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  887510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  887513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  887516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887542 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887564 */     GIR_RootConstrainSelectedInstOperands,
     /*  887565 */     // GIR_Coverage, 61272,
     /*  887565 */     GIR_EraseRootFromParent_Done,
     /*  887566 */   // Label 13575: @887566
     /*  887566 */   GIM_Try, /*On fail goto*//*Label 13576*/ GIMT_Encode4(887641), // Rule ID 61273 //
     /*  887571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  887582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  887585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  887588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  887591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887617 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887639 */     GIR_RootConstrainSelectedInstOperands,
     /*  887640 */     // GIR_Coverage, 61273,
     /*  887640 */     GIR_EraseRootFromParent_Done,
     /*  887641 */   // Label 13576: @887641
     /*  887641 */   GIM_Try, /*On fail goto*//*Label 13577*/ GIMT_Encode4(887716), // Rule ID 61276 //
     /*  887646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  887657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  887660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  887663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  887666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  887692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887714 */     GIR_RootConstrainSelectedInstOperands,
     /*  887715 */     // GIR_Coverage, 61276,
     /*  887715 */     GIR_EraseRootFromParent_Done,
     /*  887716 */   // Label 13577: @887716
     /*  887716 */   GIM_Try, /*On fail goto*//*Label 13578*/ GIMT_Encode4(887791), // Rule ID 61277 //
     /*  887721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  887732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  887735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  887738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  887741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  887767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887789 */     GIR_RootConstrainSelectedInstOperands,
     /*  887790 */     // GIR_Coverage, 61277,
     /*  887790 */     GIR_EraseRootFromParent_Done,
     /*  887791 */   // Label 13578: @887791
     /*  887791 */   GIM_Try, /*On fail goto*//*Label 13579*/ GIMT_Encode4(887866), // Rule ID 61280 //
     /*  887796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  887807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  887810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  887813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  887816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  887842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887864 */     GIR_RootConstrainSelectedInstOperands,
     /*  887865 */     // GIR_Coverage, 61280,
     /*  887865 */     GIR_EraseRootFromParent_Done,
     /*  887866 */   // Label 13579: @887866
     /*  887866 */   GIM_Try, /*On fail goto*//*Label 13580*/ GIMT_Encode4(887941), // Rule ID 61281 //
     /*  887871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  887882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  887885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  887888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  887891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887917 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  887917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887939 */     GIR_RootConstrainSelectedInstOperands,
     /*  887940 */     // GIR_Coverage, 61281,
     /*  887940 */     GIR_EraseRootFromParent_Done,
     /*  887941 */   // Label 13580: @887941
     /*  887941 */   GIM_Try, /*On fail goto*//*Label 13581*/ GIMT_Encode4(888016), // Rule ID 61284 //
     /*  887946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  887957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  887960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  887963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  887966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887992 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  887992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888014 */     GIR_RootConstrainSelectedInstOperands,
     /*  888015 */     // GIR_Coverage, 61284,
     /*  888015 */     GIR_EraseRootFromParent_Done,
     /*  888016 */   // Label 13581: @888016
     /*  888016 */   GIM_Try, /*On fail goto*//*Label 13582*/ GIMT_Encode4(888091), // Rule ID 61285 //
     /*  888021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  888032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  888035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  888038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  888041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888067 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  888067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888089 */     GIR_RootConstrainSelectedInstOperands,
     /*  888090 */     // GIR_Coverage, 61285,
     /*  888090 */     GIR_EraseRootFromParent_Done,
     /*  888091 */   // Label 13582: @888091
     /*  888091 */   GIM_Try, /*On fail goto*//*Label 13583*/ GIMT_Encode4(888166), // Rule ID 61288 //
     /*  888096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888164 */     GIR_RootConstrainSelectedInstOperands,
     /*  888165 */     // GIR_Coverage, 61288,
     /*  888165 */     GIR_EraseRootFromParent_Done,
     /*  888166 */   // Label 13583: @888166
     /*  888166 */   GIM_Try, /*On fail goto*//*Label 13584*/ GIMT_Encode4(888241), // Rule ID 61289 //
     /*  888171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  888182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  888185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  888188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  888191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  888210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888217 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  888220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888239 */     GIR_RootConstrainSelectedInstOperands,
     /*  888240 */     // GIR_Coverage, 61289,
     /*  888240 */     GIR_EraseRootFromParent_Done,
     /*  888241 */   // Label 13584: @888241
     /*  888241 */   GIM_Try, /*On fail goto*//*Label 13585*/ GIMT_Encode4(888316), // Rule ID 61292 //
     /*  888246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888292 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888314 */     GIR_RootConstrainSelectedInstOperands,
     /*  888315 */     // GIR_Coverage, 61292,
     /*  888315 */     GIR_EraseRootFromParent_Done,
     /*  888316 */   // Label 13585: @888316
     /*  888316 */   GIM_Try, /*On fail goto*//*Label 13586*/ GIMT_Encode4(888391), // Rule ID 61293 //
     /*  888321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  888332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  888335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  888338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  888341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  888360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888367 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  888370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888389 */     GIR_RootConstrainSelectedInstOperands,
     /*  888390 */     // GIR_Coverage, 61293,
     /*  888390 */     GIR_EraseRootFromParent_Done,
     /*  888391 */   // Label 13586: @888391
     /*  888391 */   GIM_Try, /*On fail goto*//*Label 13587*/ GIMT_Encode4(888466), // Rule ID 61296 //
     /*  888396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  888442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888464 */     GIR_RootConstrainSelectedInstOperands,
     /*  888465 */     // GIR_Coverage, 61296,
     /*  888465 */     GIR_EraseRootFromParent_Done,
     /*  888466 */   // Label 13587: @888466
     /*  888466 */   GIM_Try, /*On fail goto*//*Label 13588*/ GIMT_Encode4(888541), // Rule ID 61297 //
     /*  888471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  888482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  888485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  888488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  888491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888517 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888539 */     GIR_RootConstrainSelectedInstOperands,
     /*  888540 */     // GIR_Coverage, 61297,
     /*  888540 */     GIR_EraseRootFromParent_Done,
     /*  888541 */   // Label 13588: @888541
     /*  888541 */   GIM_Try, /*On fail goto*//*Label 13589*/ GIMT_Encode4(888616), // Rule ID 61300 //
     /*  888546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  888557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  888560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  888563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888592 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  888595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888614 */     GIR_RootConstrainSelectedInstOperands,
     /*  888615 */     // GIR_Coverage, 61300,
     /*  888615 */     GIR_EraseRootFromParent_Done,
     /*  888616 */   // Label 13589: @888616
     /*  888616 */   GIM_Try, /*On fail goto*//*Label 13590*/ GIMT_Encode4(888691), // Rule ID 61301 //
     /*  888621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  888632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  888635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  888638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888667 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  888667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  888670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888689 */     GIR_RootConstrainSelectedInstOperands,
     /*  888690 */     // GIR_Coverage, 61301,
     /*  888690 */     GIR_EraseRootFromParent_Done,
     /*  888691 */   // Label 13590: @888691
     /*  888691 */   GIM_Try, /*On fail goto*//*Label 13591*/ GIMT_Encode4(888766), // Rule ID 61304 //
     /*  888696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  888707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  888710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  888713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888742 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  888745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888764 */     GIR_RootConstrainSelectedInstOperands,
     /*  888765 */     // GIR_Coverage, 61304,
     /*  888765 */     GIR_EraseRootFromParent_Done,
     /*  888766 */   // Label 13591: @888766
     /*  888766 */   GIM_Try, /*On fail goto*//*Label 13592*/ GIMT_Encode4(888841), // Rule ID 61305 //
     /*  888771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  888782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  888785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  888788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888817 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  888817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  888820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888839 */     GIR_RootConstrainSelectedInstOperands,
     /*  888840 */     // GIR_Coverage, 61305,
     /*  888840 */     GIR_EraseRootFromParent_Done,
     /*  888841 */   // Label 13592: @888841
     /*  888841 */   GIM_Try, /*On fail goto*//*Label 13593*/ GIMT_Encode4(888916), // Rule ID 61308 //
     /*  888846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  888857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  888860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  888863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888892 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888914 */     GIR_RootConstrainSelectedInstOperands,
     /*  888915 */     // GIR_Coverage, 61308,
     /*  888915 */     GIR_EraseRootFromParent_Done,
     /*  888916 */   // Label 13593: @888916
     /*  888916 */   GIM_Try, /*On fail goto*//*Label 13594*/ GIMT_Encode4(888991), // Rule ID 61309 //
     /*  888921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  888932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  888935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  888938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888967 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  888967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888989 */     GIR_RootConstrainSelectedInstOperands,
     /*  888990 */     // GIR_Coverage, 61309,
     /*  888990 */     GIR_EraseRootFromParent_Done,
     /*  888991 */   // Label 13594: @888991
     /*  888991 */   GIM_Try, /*On fail goto*//*Label 13595*/ GIMT_Encode4(889066), // Rule ID 61312 //
     /*  888996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889042 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889064 */     GIR_RootConstrainSelectedInstOperands,
     /*  889065 */     // GIR_Coverage, 61312,
     /*  889065 */     GIR_EraseRootFromParent_Done,
     /*  889066 */   // Label 13595: @889066
     /*  889066 */   GIM_Try, /*On fail goto*//*Label 13596*/ GIMT_Encode4(889141), // Rule ID 61313 //
     /*  889071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  889082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  889085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  889088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889117 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  889120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889139 */     GIR_RootConstrainSelectedInstOperands,
     /*  889140 */     // GIR_Coverage, 61313,
     /*  889140 */     GIR_EraseRootFromParent_Done,
     /*  889141 */   // Label 13596: @889141
     /*  889141 */   GIM_Try, /*On fail goto*//*Label 13597*/ GIMT_Encode4(889216), // Rule ID 61316 //
     /*  889146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889192 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889214 */     GIR_RootConstrainSelectedInstOperands,
     /*  889215 */     // GIR_Coverage, 61316,
     /*  889215 */     GIR_EraseRootFromParent_Done,
     /*  889216 */   // Label 13597: @889216
     /*  889216 */   GIM_Try, /*On fail goto*//*Label 13598*/ GIMT_Encode4(889291), // Rule ID 61317 //
     /*  889221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  889232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  889235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  889238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889267 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889289 */     GIR_RootConstrainSelectedInstOperands,
     /*  889290 */     // GIR_Coverage, 61317,
     /*  889290 */     GIR_EraseRootFromParent_Done,
     /*  889291 */   // Label 13598: @889291
     /*  889291 */   GIM_Try, /*On fail goto*//*Label 13599*/ GIMT_Encode4(889366), // Rule ID 61320 //
     /*  889296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889342 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  889342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889364 */     GIR_RootConstrainSelectedInstOperands,
     /*  889365 */     // GIR_Coverage, 61320,
     /*  889365 */     GIR_EraseRootFromParent_Done,
     /*  889366 */   // Label 13599: @889366
     /*  889366 */   GIM_Try, /*On fail goto*//*Label 13600*/ GIMT_Encode4(889441), // Rule ID 61321 //
     /*  889371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  889382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  889385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  889388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889417 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  889417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  889420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889439 */     GIR_RootConstrainSelectedInstOperands,
     /*  889440 */     // GIR_Coverage, 61321,
     /*  889440 */     GIR_EraseRootFromParent_Done,
     /*  889441 */   // Label 13600: @889441
     /*  889441 */   GIM_Try, /*On fail goto*//*Label 13601*/ GIMT_Encode4(889516), // Rule ID 61324 //
     /*  889446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  889457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  889460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  889463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889492 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889514 */     GIR_RootConstrainSelectedInstOperands,
     /*  889515 */     // GIR_Coverage, 61324,
     /*  889515 */     GIR_EraseRootFromParent_Done,
     /*  889516 */   // Label 13601: @889516
     /*  889516 */   GIM_Try, /*On fail goto*//*Label 13602*/ GIMT_Encode4(889591), // Rule ID 61325 //
     /*  889521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  889532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  889535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  889538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889567 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11158:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889589 */     GIR_RootConstrainSelectedInstOperands,
     /*  889590 */     // GIR_Coverage, 61325,
     /*  889590 */     GIR_EraseRootFromParent_Done,
     /*  889591 */   // Label 13602: @889591
     /*  889591 */   GIM_Try, /*On fail goto*//*Label 13603*/ GIMT_Encode4(889666), // Rule ID 61328 //
     /*  889596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  889607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  889610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  889613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889664 */     GIR_RootConstrainSelectedInstOperands,
     /*  889665 */     // GIR_Coverage, 61328,
     /*  889665 */     GIR_EraseRootFromParent_Done,
     /*  889666 */   // Label 13603: @889666
     /*  889666 */   GIM_Try, /*On fail goto*//*Label 13604*/ GIMT_Encode4(889741), // Rule ID 61329 //
     /*  889671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  889682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  889685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  889688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889717 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889739 */     GIR_RootConstrainSelectedInstOperands,
     /*  889740 */     // GIR_Coverage, 61329,
     /*  889740 */     GIR_EraseRootFromParent_Done,
     /*  889741 */   // Label 13604: @889741
     /*  889741 */   GIM_Try, /*On fail goto*//*Label 13605*/ GIMT_Encode4(889816), // Rule ID 61332 //
     /*  889746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  889757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  889760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  889763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  889792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889814 */     GIR_RootConstrainSelectedInstOperands,
     /*  889815 */     // GIR_Coverage, 61332,
     /*  889815 */     GIR_EraseRootFromParent_Done,
     /*  889816 */   // Label 13605: @889816
     /*  889816 */   GIM_Try, /*On fail goto*//*Label 13606*/ GIMT_Encode4(889891), // Rule ID 61333 //
     /*  889821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  889832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  889835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  889838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889867 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  889867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889889 */     GIR_RootConstrainSelectedInstOperands,
     /*  889890 */     // GIR_Coverage, 61333,
     /*  889890 */     GIR_EraseRootFromParent_Done,
     /*  889891 */   // Label 13606: @889891
     /*  889891 */   GIM_Try, /*On fail goto*//*Label 13607*/ GIMT_Encode4(889966), // Rule ID 61336 //
     /*  889896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  889907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  889910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  889913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889942 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  889942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889964 */     GIR_RootConstrainSelectedInstOperands,
     /*  889965 */     // GIR_Coverage, 61336,
     /*  889965 */     GIR_EraseRootFromParent_Done,
     /*  889966 */   // Label 13607: @889966
     /*  889966 */   GIM_Try, /*On fail goto*//*Label 13608*/ GIMT_Encode4(890041), // Rule ID 61337 //
     /*  889971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  889982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  889985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  889988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  890006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890017 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  890017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  890020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890039 */     GIR_RootConstrainSelectedInstOperands,
     /*  890040 */     // GIR_Coverage, 61337,
     /*  890040 */     GIR_EraseRootFromParent_Done,
     /*  890041 */   // Label 13608: @890041
     /*  890041 */   GIM_Try, /*On fail goto*//*Label 13609*/ GIMT_Encode4(890116), // Rule ID 61340 //
     /*  890046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890092 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890114 */     GIR_RootConstrainSelectedInstOperands,
     /*  890115 */     // GIR_Coverage, 61340,
     /*  890115 */     GIR_EraseRootFromParent_Done,
     /*  890116 */   // Label 13609: @890116
     /*  890116 */   GIM_Try, /*On fail goto*//*Label 13610*/ GIMT_Encode4(890191), // Rule ID 61341 //
     /*  890121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  890132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  890135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  890138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890167 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890189 */     GIR_RootConstrainSelectedInstOperands,
     /*  890190 */     // GIR_Coverage, 61341,
     /*  890190 */     GIR_EraseRootFromParent_Done,
     /*  890191 */   // Label 13610: @890191
     /*  890191 */   GIM_Try, /*On fail goto*//*Label 13611*/ GIMT_Encode4(890266), // Rule ID 61344 //
     /*  890196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890242 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890264 */     GIR_RootConstrainSelectedInstOperands,
     /*  890265 */     // GIR_Coverage, 61344,
     /*  890265 */     GIR_EraseRootFromParent_Done,
     /*  890266 */   // Label 13611: @890266
     /*  890266 */   GIM_Try, /*On fail goto*//*Label 13612*/ GIMT_Encode4(890341), // Rule ID 61345 //
     /*  890271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  890282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  890285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  890288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890317 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890339 */     GIR_RootConstrainSelectedInstOperands,
     /*  890340 */     // GIR_Coverage, 61345,
     /*  890340 */     GIR_EraseRootFromParent_Done,
     /*  890341 */   // Label 13612: @890341
     /*  890341 */   GIM_Try, /*On fail goto*//*Label 13613*/ GIMT_Encode4(890416), // Rule ID 61348 //
     /*  890346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890392 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  890392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890414 */     GIR_RootConstrainSelectedInstOperands,
     /*  890415 */     // GIR_Coverage, 61348,
     /*  890415 */     GIR_EraseRootFromParent_Done,
     /*  890416 */   // Label 13613: @890416
     /*  890416 */   GIM_Try, /*On fail goto*//*Label 13614*/ GIMT_Encode4(890491), // Rule ID 61349 //
     /*  890421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  890432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  890435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  890438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890467 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  890467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  890486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890489 */     GIR_RootConstrainSelectedInstOperands,
     /*  890490 */     // GIR_Coverage, 61349,
     /*  890490 */     GIR_EraseRootFromParent_Done,
     /*  890491 */   // Label 13614: @890491
     /*  890491 */   GIM_Try, /*On fail goto*//*Label 13615*/ GIMT_Encode4(890566), // Rule ID 61352 //
     /*  890496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  890507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  890510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  890513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890542 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890564 */     GIR_RootConstrainSelectedInstOperands,
     /*  890565 */     // GIR_Coverage, 61352,
     /*  890565 */     GIR_EraseRootFromParent_Done,
     /*  890566 */   // Label 13615: @890566
     /*  890566 */   GIM_Try, /*On fail goto*//*Label 13616*/ GIMT_Encode4(890641), // Rule ID 61353 //
     /*  890571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  890582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  890585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  890588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890617 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890639 */     GIR_RootConstrainSelectedInstOperands,
     /*  890640 */     // GIR_Coverage, 61353,
     /*  890640 */     GIR_EraseRootFromParent_Done,
     /*  890641 */   // Label 13616: @890641
     /*  890641 */   GIM_Try, /*On fail goto*//*Label 13617*/ GIMT_Encode4(890716), // Rule ID 61356 //
     /*  890646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  890657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  890660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  890663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890692 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890714 */     GIR_RootConstrainSelectedInstOperands,
     /*  890715 */     // GIR_Coverage, 61356,
     /*  890715 */     GIR_EraseRootFromParent_Done,
     /*  890716 */   // Label 13617: @890716
     /*  890716 */   GIM_Try, /*On fail goto*//*Label 13618*/ GIMT_Encode4(890791), // Rule ID 61357 //
     /*  890721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  890732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  890735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  890738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890767 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890789 */     GIR_RootConstrainSelectedInstOperands,
     /*  890790 */     // GIR_Coverage, 61357,
     /*  890790 */     GIR_EraseRootFromParent_Done,
     /*  890791 */   // Label 13618: @890791
     /*  890791 */   GIM_Try, /*On fail goto*//*Label 13619*/ GIMT_Encode4(890866), // Rule ID 61360 //
     /*  890796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  890807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  890810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  890813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890864 */     GIR_RootConstrainSelectedInstOperands,
     /*  890865 */     // GIR_Coverage, 61360,
     /*  890865 */     GIR_EraseRootFromParent_Done,
     /*  890866 */   // Label 13619: @890866
     /*  890866 */   GIM_Try, /*On fail goto*//*Label 13620*/ GIMT_Encode4(890941), // Rule ID 61361 //
     /*  890871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  890882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  890885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  890888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890917 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890939 */     GIR_RootConstrainSelectedInstOperands,
     /*  890940 */     // GIR_Coverage, 61361,
     /*  890940 */     GIR_EraseRootFromParent_Done,
     /*  890941 */   // Label 13620: @890941
     /*  890941 */   GIM_Try, /*On fail goto*//*Label 13621*/ GIMT_Encode4(891016), // Rule ID 61364 //
     /*  890946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  890957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  890960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  890963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890992 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  890992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891014 */     GIR_RootConstrainSelectedInstOperands,
     /*  891015 */     // GIR_Coverage, 61364,
     /*  891015 */     GIR_EraseRootFromParent_Done,
     /*  891016 */   // Label 13621: @891016
     /*  891016 */   GIM_Try, /*On fail goto*//*Label 13622*/ GIMT_Encode4(891091), // Rule ID 61365 //
     /*  891021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  891032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  891035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  891038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891089 */     GIR_RootConstrainSelectedInstOperands,
     /*  891090 */     // GIR_Coverage, 61365,
     /*  891090 */     GIR_EraseRootFromParent_Done,
     /*  891091 */   // Label 13622: @891091
     /*  891091 */   GIM_Try, /*On fail goto*//*Label 13623*/ GIMT_Encode4(891166), // Rule ID 61368 //
     /*  891096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891142 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891164 */     GIR_RootConstrainSelectedInstOperands,
     /*  891165 */     // GIR_Coverage, 61368,
     /*  891165 */     GIR_EraseRootFromParent_Done,
     /*  891166 */   // Label 13623: @891166
     /*  891166 */   GIM_Try, /*On fail goto*//*Label 13624*/ GIMT_Encode4(891241), // Rule ID 61369 //
     /*  891171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  891182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  891185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  891188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891217 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891239 */     GIR_RootConstrainSelectedInstOperands,
     /*  891240 */     // GIR_Coverage, 61369,
     /*  891240 */     GIR_EraseRootFromParent_Done,
     /*  891241 */   // Label 13624: @891241
     /*  891241 */   GIM_Try, /*On fail goto*//*Label 13625*/ GIMT_Encode4(891316), // Rule ID 61372 //
     /*  891246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891292 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  891292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891314 */     GIR_RootConstrainSelectedInstOperands,
     /*  891315 */     // GIR_Coverage, 61372,
     /*  891315 */     GIR_EraseRootFromParent_Done,
     /*  891316 */   // Label 13625: @891316
     /*  891316 */   GIM_Try, /*On fail goto*//*Label 13626*/ GIMT_Encode4(891391), // Rule ID 61373 //
     /*  891321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  891332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  891335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  891338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891367 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  891367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  891386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891389 */     GIR_RootConstrainSelectedInstOperands,
     /*  891390 */     // GIR_Coverage, 61373,
     /*  891390 */     GIR_EraseRootFromParent_Done,
     /*  891391 */   // Label 13626: @891391
     /*  891391 */   GIM_Try, /*On fail goto*//*Label 13627*/ GIMT_Encode4(891466), // Rule ID 61376 //
     /*  891396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891442 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891464 */     GIR_RootConstrainSelectedInstOperands,
     /*  891465 */     // GIR_Coverage, 61376,
     /*  891465 */     GIR_EraseRootFromParent_Done,
     /*  891466 */   // Label 13627: @891466
     /*  891466 */   GIM_Try, /*On fail goto*//*Label 13628*/ GIMT_Encode4(891541), // Rule ID 61377 //
     /*  891471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  891482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  891485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  891488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  891506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891517 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891539 */     GIR_RootConstrainSelectedInstOperands,
     /*  891540 */     // GIR_Coverage, 61377,
     /*  891540 */     GIR_EraseRootFromParent_Done,
     /*  891541 */   // Label 13628: @891541
     /*  891541 */   GIM_Try, /*On fail goto*//*Label 13629*/ GIMT_Encode4(891616), // Rule ID 61380 //
     /*  891546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  891557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  891560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  891563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891592 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891614 */     GIR_RootConstrainSelectedInstOperands,
     /*  891615 */     // GIR_Coverage, 61380,
     /*  891615 */     GIR_EraseRootFromParent_Done,
     /*  891616 */   // Label 13629: @891616
     /*  891616 */   GIM_Try, /*On fail goto*//*Label 13630*/ GIMT_Encode4(891691), // Rule ID 61381 //
     /*  891621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  891632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  891635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  891638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891667 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891689 */     GIR_RootConstrainSelectedInstOperands,
     /*  891690 */     // GIR_Coverage, 61381,
     /*  891690 */     GIR_EraseRootFromParent_Done,
     /*  891691 */   // Label 13630: @891691
     /*  891691 */   GIM_Try, /*On fail goto*//*Label 13631*/ GIMT_Encode4(891766), // Rule ID 61384 //
     /*  891696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  891707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  891710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  891713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891742 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891764 */     GIR_RootConstrainSelectedInstOperands,
     /*  891765 */     // GIR_Coverage, 61384,
     /*  891765 */     GIR_EraseRootFromParent_Done,
     /*  891766 */   // Label 13631: @891766
     /*  891766 */   GIM_Try, /*On fail goto*//*Label 13632*/ GIMT_Encode4(891841), // Rule ID 61385 //
     /*  891771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  891782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  891785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  891788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891817 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11158:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891839 */     GIR_RootConstrainSelectedInstOperands,
     /*  891840 */     // GIR_Coverage, 61385,
     /*  891840 */     GIR_EraseRootFromParent_Done,
     /*  891841 */   // Label 13632: @891841
     /*  891841 */   GIM_Try, /*On fail goto*//*Label 13633*/ GIMT_Encode4(891916), // Rule ID 61564 //
     /*  891846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  891857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  891860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  891863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  891866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891892 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  891892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  891895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891914 */     GIR_RootConstrainSelectedInstOperands,
     /*  891915 */     // GIR_Coverage, 61564,
     /*  891915 */     GIR_EraseRootFromParent_Done,
     /*  891916 */   // Label 13633: @891916
     /*  891916 */   GIM_Try, /*On fail goto*//*Label 13634*/ GIMT_Encode4(891991), // Rule ID 61565 //
     /*  891921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  891932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  891935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  891938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  891941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891967 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  891967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  891970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891989 */     GIR_RootConstrainSelectedInstOperands,
     /*  891990 */     // GIR_Coverage, 61565,
     /*  891990 */     GIR_EraseRootFromParent_Done,
     /*  891991 */   // Label 13634: @891991
     /*  891991 */   GIM_Try, /*On fail goto*//*Label 13635*/ GIMT_Encode4(892066), // Rule ID 61568 //
     /*  891996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  892016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892042 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892064 */     GIR_RootConstrainSelectedInstOperands,
     /*  892065 */     // GIR_Coverage, 61568,
     /*  892065 */     GIR_EraseRootFromParent_Done,
     /*  892066 */   // Label 13635: @892066
     /*  892066 */   GIM_Try, /*On fail goto*//*Label 13636*/ GIMT_Encode4(892141), // Rule ID 61569 //
     /*  892071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  892082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  892085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  892088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  892091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892117 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892139 */     GIR_RootConstrainSelectedInstOperands,
     /*  892140 */     // GIR_Coverage, 61569,
     /*  892140 */     GIR_EraseRootFromParent_Done,
     /*  892141 */   // Label 13636: @892141
     /*  892141 */   GIM_Try, /*On fail goto*//*Label 13637*/ GIMT_Encode4(892216), // Rule ID 61572 //
     /*  892146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  892166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892192 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892214 */     GIR_RootConstrainSelectedInstOperands,
     /*  892215 */     // GIR_Coverage, 61572,
     /*  892215 */     GIR_EraseRootFromParent_Done,
     /*  892216 */   // Label 13637: @892216
     /*  892216 */   GIM_Try, /*On fail goto*//*Label 13638*/ GIMT_Encode4(892291), // Rule ID 61573 //
     /*  892221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  892232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  892235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  892238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  892241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892267 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892289 */     GIR_RootConstrainSelectedInstOperands,
     /*  892290 */     // GIR_Coverage, 61573,
     /*  892290 */     GIR_EraseRootFromParent_Done,
     /*  892291 */   // Label 13638: @892291
     /*  892291 */   GIM_Try, /*On fail goto*//*Label 13639*/ GIMT_Encode4(892366), // Rule ID 61576 //
     /*  892296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  892316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892342 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892364 */     GIR_RootConstrainSelectedInstOperands,
     /*  892365 */     // GIR_Coverage, 61576,
     /*  892365 */     GIR_EraseRootFromParent_Done,
     /*  892366 */   // Label 13639: @892366
     /*  892366 */   GIM_Try, /*On fail goto*//*Label 13640*/ GIMT_Encode4(892441), // Rule ID 61577 //
     /*  892371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  892382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  892385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  892388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  892391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892417 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  892420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892439 */     GIR_RootConstrainSelectedInstOperands,
     /*  892440 */     // GIR_Coverage, 61577,
     /*  892440 */     GIR_EraseRootFromParent_Done,
     /*  892441 */   // Label 13640: @892441
     /*  892441 */   GIM_Try, /*On fail goto*//*Label 13641*/ GIMT_Encode4(892516), // Rule ID 61580 //
     /*  892446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  892457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  892460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  892463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  892466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892492 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892514 */     GIR_RootConstrainSelectedInstOperands,
     /*  892515 */     // GIR_Coverage, 61580,
     /*  892515 */     GIR_EraseRootFromParent_Done,
     /*  892516 */   // Label 13641: @892516
     /*  892516 */   GIM_Try, /*On fail goto*//*Label 13642*/ GIMT_Encode4(892591), // Rule ID 61581 //
     /*  892521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  892532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  892535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  892538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  892541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892567 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892589 */     GIR_RootConstrainSelectedInstOperands,
     /*  892590 */     // GIR_Coverage, 61581,
     /*  892590 */     GIR_EraseRootFromParent_Done,
     /*  892591 */   // Label 13642: @892591
     /*  892591 */   GIM_Try, /*On fail goto*//*Label 13643*/ GIMT_Encode4(892666), // Rule ID 61584 //
     /*  892596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  892607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  892610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  892613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  892616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892642 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  892642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  892661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892664 */     GIR_RootConstrainSelectedInstOperands,
     /*  892665 */     // GIR_Coverage, 61584,
     /*  892665 */     GIR_EraseRootFromParent_Done,
     /*  892666 */   // Label 13643: @892666
     /*  892666 */   GIM_Try, /*On fail goto*//*Label 13644*/ GIMT_Encode4(892741), // Rule ID 61585 //
     /*  892671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  892682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  892685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  892688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  892691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892717 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  892717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  892736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892739 */     GIR_RootConstrainSelectedInstOperands,
     /*  892740 */     // GIR_Coverage, 61585,
     /*  892740 */     GIR_EraseRootFromParent_Done,
     /*  892741 */   // Label 13644: @892741
     /*  892741 */   GIM_Try, /*On fail goto*//*Label 13645*/ GIMT_Encode4(892816), // Rule ID 61588 //
     /*  892746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  892757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  892760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  892763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  892766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892792 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892814 */     GIR_RootConstrainSelectedInstOperands,
     /*  892815 */     // GIR_Coverage, 61588,
     /*  892815 */     GIR_EraseRootFromParent_Done,
     /*  892816 */   // Label 13645: @892816
     /*  892816 */   GIM_Try, /*On fail goto*//*Label 13646*/ GIMT_Encode4(892891), // Rule ID 61589 //
     /*  892821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  892832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  892835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  892838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  892841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892867 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892889 */     GIR_RootConstrainSelectedInstOperands,
     /*  892890 */     // GIR_Coverage, 61589,
     /*  892890 */     GIR_EraseRootFromParent_Done,
     /*  892891 */   // Label 13646: @892891
     /*  892891 */   GIM_Try, /*On fail goto*//*Label 13647*/ GIMT_Encode4(892966), // Rule ID 61592 //
     /*  892896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  892907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  892910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  892913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  892916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892942 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892964 */     GIR_RootConstrainSelectedInstOperands,
     /*  892965 */     // GIR_Coverage, 61592,
     /*  892965 */     GIR_EraseRootFromParent_Done,
     /*  892966 */   // Label 13647: @892966
     /*  892966 */   GIM_Try, /*On fail goto*//*Label 13648*/ GIMT_Encode4(893041), // Rule ID 61593 //
     /*  892971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  892982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  892985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  892988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  892991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893017 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893039 */     GIR_RootConstrainSelectedInstOperands,
     /*  893040 */     // GIR_Coverage, 61593,
     /*  893040 */     GIR_EraseRootFromParent_Done,
     /*  893041 */   // Label 13648: @893041
     /*  893041 */   GIM_Try, /*On fail goto*//*Label 13649*/ GIMT_Encode4(893116), // Rule ID 61596 //
     /*  893046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  893066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893114 */     GIR_RootConstrainSelectedInstOperands,
     /*  893115 */     // GIR_Coverage, 61596,
     /*  893115 */     GIR_EraseRootFromParent_Done,
     /*  893116 */   // Label 13649: @893116
     /*  893116 */   GIM_Try, /*On fail goto*//*Label 13650*/ GIMT_Encode4(893191), // Rule ID 61597 //
     /*  893121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  893132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  893135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  893138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  893141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893167 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893189 */     GIR_RootConstrainSelectedInstOperands,
     /*  893190 */     // GIR_Coverage, 61597,
     /*  893190 */     GIR_EraseRootFromParent_Done,
     /*  893191 */   // Label 13650: @893191
     /*  893191 */   GIM_Try, /*On fail goto*//*Label 13651*/ GIMT_Encode4(893266), // Rule ID 61600 //
     /*  893196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  893216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  893242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893264 */     GIR_RootConstrainSelectedInstOperands,
     /*  893265 */     // GIR_Coverage, 61600,
     /*  893265 */     GIR_EraseRootFromParent_Done,
     /*  893266 */   // Label 13651: @893266
     /*  893266 */   GIM_Try, /*On fail goto*//*Label 13652*/ GIMT_Encode4(893341), // Rule ID 61601 //
     /*  893271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  893282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  893285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  893288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  893291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  893310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893317 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  893317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  893320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  893336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893339 */     GIR_RootConstrainSelectedInstOperands,
     /*  893340 */     // GIR_Coverage, 61601,
     /*  893340 */     GIR_EraseRootFromParent_Done,
     /*  893341 */   // Label 13652: @893341
     /*  893341 */   GIM_Try, /*On fail goto*//*Label 13653*/ GIMT_Encode4(893416), // Rule ID 61604 //
     /*  893346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  893366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893392 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893414 */     GIR_RootConstrainSelectedInstOperands,
     /*  893415 */     // GIR_Coverage, 61604,
     /*  893415 */     GIR_EraseRootFromParent_Done,
     /*  893416 */   // Label 13653: @893416
     /*  893416 */   GIM_Try, /*On fail goto*//*Label 13654*/ GIMT_Encode4(893491), // Rule ID 61605 //
     /*  893421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  893432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  893435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  893438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  893441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893467 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893489 */     GIR_RootConstrainSelectedInstOperands,
     /*  893490 */     // GIR_Coverage, 61605,
     /*  893490 */     GIR_EraseRootFromParent_Done,
     /*  893491 */   // Label 13654: @893491
     /*  893491 */   GIM_Try, /*On fail goto*//*Label 13655*/ GIMT_Encode4(893566), // Rule ID 61608 //
     /*  893496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  893507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  893510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  893513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  893516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893542 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893564 */     GIR_RootConstrainSelectedInstOperands,
     /*  893565 */     // GIR_Coverage, 61608,
     /*  893565 */     GIR_EraseRootFromParent_Done,
     /*  893566 */   // Label 13655: @893566
     /*  893566 */   GIM_Try, /*On fail goto*//*Label 13656*/ GIMT_Encode4(893641), // Rule ID 61609 //
     /*  893571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  893582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  893585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  893588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  893591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893617 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893639 */     GIR_RootConstrainSelectedInstOperands,
     /*  893640 */     // GIR_Coverage, 61609,
     /*  893640 */     GIR_EraseRootFromParent_Done,
     /*  893641 */   // Label 13656: @893641
     /*  893641 */   GIM_Try, /*On fail goto*//*Label 13657*/ GIMT_Encode4(893716), // Rule ID 61612 //
     /*  893646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  893657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  893660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  893663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  893666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893692 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  893695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893714 */     GIR_RootConstrainSelectedInstOperands,
     /*  893715 */     // GIR_Coverage, 61612,
     /*  893715 */     GIR_EraseRootFromParent_Done,
     /*  893716 */   // Label 13657: @893716
     /*  893716 */   GIM_Try, /*On fail goto*//*Label 13658*/ GIMT_Encode4(893791), // Rule ID 61613 //
     /*  893721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  893732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  893735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  893738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  893741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893767 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  893770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893789 */     GIR_RootConstrainSelectedInstOperands,
     /*  893790 */     // GIR_Coverage, 61613,
     /*  893790 */     GIR_EraseRootFromParent_Done,
     /*  893791 */   // Label 13658: @893791
     /*  893791 */   GIM_Try, /*On fail goto*//*Label 13659*/ GIMT_Encode4(893866), // Rule ID 61616 //
     /*  893796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  893807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  893810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  893813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  893816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893842 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893864 */     GIR_RootConstrainSelectedInstOperands,
     /*  893865 */     // GIR_Coverage, 61616,
     /*  893865 */     GIR_EraseRootFromParent_Done,
     /*  893866 */   // Label 13659: @893866
     /*  893866 */   GIM_Try, /*On fail goto*//*Label 13660*/ GIMT_Encode4(893941), // Rule ID 61617 //
     /*  893871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  893882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  893885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  893888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  893891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893917 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893939 */     GIR_RootConstrainSelectedInstOperands,
     /*  893940 */     // GIR_Coverage, 61617,
     /*  893940 */     GIR_EraseRootFromParent_Done,
     /*  893941 */   // Label 13660: @893941
     /*  893941 */   GIM_Try, /*On fail goto*//*Label 13661*/ GIMT_Encode4(894016), // Rule ID 61620 //
     /*  893946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  893957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  893960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  893963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  893966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894014 */     GIR_RootConstrainSelectedInstOperands,
     /*  894015 */     // GIR_Coverage, 61620,
     /*  894015 */     GIR_EraseRootFromParent_Done,
     /*  894016 */   // Label 13661: @894016
     /*  894016 */   GIM_Try, /*On fail goto*//*Label 13662*/ GIMT_Encode4(894091), // Rule ID 61621 //
     /*  894021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  894032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  894035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  894038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  894041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894067 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894089 */     GIR_RootConstrainSelectedInstOperands,
     /*  894090 */     // GIR_Coverage, 61621,
     /*  894090 */     GIR_EraseRootFromParent_Done,
     /*  894091 */   // Label 13662: @894091
     /*  894091 */   GIM_Try, /*On fail goto*//*Label 13663*/ GIMT_Encode4(894166), // Rule ID 61624 //
     /*  894096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  894116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894142 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  894142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894164 */     GIR_RootConstrainSelectedInstOperands,
     /*  894165 */     // GIR_Coverage, 61624,
     /*  894165 */     GIR_EraseRootFromParent_Done,
     /*  894166 */   // Label 13663: @894166
     /*  894166 */   GIM_Try, /*On fail goto*//*Label 13664*/ GIMT_Encode4(894241), // Rule ID 61625 //
     /*  894171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  894182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  894185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  894188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  894191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894217 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  894217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  894236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894239 */     GIR_RootConstrainSelectedInstOperands,
     /*  894240 */     // GIR_Coverage, 61625,
     /*  894240 */     GIR_EraseRootFromParent_Done,
     /*  894241 */   // Label 13664: @894241
     /*  894241 */   GIM_Try, /*On fail goto*//*Label 13665*/ GIMT_Encode4(894316), // Rule ID 61628 //
     /*  894246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  894266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894314 */     GIR_RootConstrainSelectedInstOperands,
     /*  894315 */     // GIR_Coverage, 61628,
     /*  894315 */     GIR_EraseRootFromParent_Done,
     /*  894316 */   // Label 13665: @894316
     /*  894316 */   GIM_Try, /*On fail goto*//*Label 13666*/ GIMT_Encode4(894391), // Rule ID 61629 //
     /*  894321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  894332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  894335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  894338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  894341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894367 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894389 */     GIR_RootConstrainSelectedInstOperands,
     /*  894390 */     // GIR_Coverage, 61629,
     /*  894390 */     GIR_EraseRootFromParent_Done,
     /*  894391 */   // Label 13666: @894391
     /*  894391 */   GIM_Try, /*On fail goto*//*Label 13667*/ GIMT_Encode4(894466), // Rule ID 61632 //
     /*  894396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  894416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894464 */     GIR_RootConstrainSelectedInstOperands,
     /*  894465 */     // GIR_Coverage, 61632,
     /*  894465 */     GIR_EraseRootFromParent_Done,
     /*  894466 */   // Label 13667: @894466
     /*  894466 */   GIM_Try, /*On fail goto*//*Label 13668*/ GIMT_Encode4(894541), // Rule ID 61633 //
     /*  894471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  894482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  894485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  894488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  894491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894517 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894539 */     GIR_RootConstrainSelectedInstOperands,
     /*  894540 */     // GIR_Coverage, 61633,
     /*  894540 */     GIR_EraseRootFromParent_Done,
     /*  894541 */   // Label 13668: @894541
     /*  894541 */   GIM_Try, /*On fail goto*//*Label 13669*/ GIMT_Encode4(894616), // Rule ID 61636 //
     /*  894546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  894557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  894560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  894563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  894566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894614 */     GIR_RootConstrainSelectedInstOperands,
     /*  894615 */     // GIR_Coverage, 61636,
     /*  894615 */     GIR_EraseRootFromParent_Done,
     /*  894616 */   // Label 13669: @894616
     /*  894616 */   GIM_Try, /*On fail goto*//*Label 13670*/ GIMT_Encode4(894691), // Rule ID 61637 //
     /*  894621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  894632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  894635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  894638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  894641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894667 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894689 */     GIR_RootConstrainSelectedInstOperands,
     /*  894690 */     // GIR_Coverage, 61637,
     /*  894690 */     GIR_EraseRootFromParent_Done,
     /*  894691 */   // Label 13670: @894691
     /*  894691 */   GIM_Try, /*On fail goto*//*Label 13671*/ GIMT_Encode4(894766), // Rule ID 61640 //
     /*  894696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  894707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  894710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  894713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  894716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  894742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894764 */     GIR_RootConstrainSelectedInstOperands,
     /*  894765 */     // GIR_Coverage, 61640,
     /*  894765 */     GIR_EraseRootFromParent_Done,
     /*  894766 */   // Label 13671: @894766
     /*  894766 */   GIM_Try, /*On fail goto*//*Label 13672*/ GIMT_Encode4(894841), // Rule ID 61641 //
     /*  894771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  894782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  894785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  894788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  894791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894817 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  894817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894839 */     GIR_RootConstrainSelectedInstOperands,
     /*  894840 */     // GIR_Coverage, 61641,
     /*  894840 */     GIR_EraseRootFromParent_Done,
     /*  894841 */   // Label 13672: @894841
     /*  894841 */   GIM_Try, /*On fail goto*//*Label 13673*/ GIMT_Encode4(894916), // Rule ID 61644 //
     /*  894846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  894857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  894860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  894863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  894866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894892 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  894892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894914 */     GIR_RootConstrainSelectedInstOperands,
     /*  894915 */     // GIR_Coverage, 61644,
     /*  894915 */     GIR_EraseRootFromParent_Done,
     /*  894916 */   // Label 13673: @894916
     /*  894916 */   GIM_Try, /*On fail goto*//*Label 13674*/ GIMT_Encode4(894991), // Rule ID 61645 //
     /*  894921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  894932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  894935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  894938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  894941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894967 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  894967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894989 */     GIR_RootConstrainSelectedInstOperands,
     /*  894990 */     // GIR_Coverage, 61645,
     /*  894990 */     GIR_EraseRootFromParent_Done,
     /*  894991 */   // Label 13674: @894991
     /*  894991 */   GIM_Try, /*On fail goto*//*Label 13675*/ GIMT_Encode4(895066), // Rule ID 61648 //
     /*  894996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  895016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895042 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  895042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895064 */     GIR_RootConstrainSelectedInstOperands,
     /*  895065 */     // GIR_Coverage, 61648,
     /*  895065 */     GIR_EraseRootFromParent_Done,
     /*  895066 */   // Label 13675: @895066
     /*  895066 */   GIM_Try, /*On fail goto*//*Label 13676*/ GIMT_Encode4(895141), // Rule ID 61649 //
     /*  895071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  895082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  895085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  895088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  895091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  895110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895117 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  895117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  895120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  895136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895139 */     GIR_RootConstrainSelectedInstOperands,
     /*  895140 */     // GIR_Coverage, 61649,
     /*  895140 */     GIR_EraseRootFromParent_Done,
     /*  895141 */   // Label 13676: @895141
     /*  895141 */   GIM_Try, /*On fail goto*//*Label 13677*/ GIMT_Encode4(895216), // Rule ID 61652 //
     /*  895146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895192 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  895195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895214 */     GIR_RootConstrainSelectedInstOperands,
     /*  895215 */     // GIR_Coverage, 61652,
     /*  895215 */     GIR_EraseRootFromParent_Done,
     /*  895216 */   // Label 13677: @895216
     /*  895216 */   GIM_Try, /*On fail goto*//*Label 13678*/ GIMT_Encode4(895291), // Rule ID 61653 //
     /*  895221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  895232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  895235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  895238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895267 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  895270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895289 */     GIR_RootConstrainSelectedInstOperands,
     /*  895290 */     // GIR_Coverage, 61653,
     /*  895290 */     GIR_EraseRootFromParent_Done,
     /*  895291 */   // Label 13678: @895291
     /*  895291 */   GIM_Try, /*On fail goto*//*Label 13679*/ GIMT_Encode4(895366), // Rule ID 61656 //
     /*  895296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895342 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895364 */     GIR_RootConstrainSelectedInstOperands,
     /*  895365 */     // GIR_Coverage, 61656,
     /*  895365 */     GIR_EraseRootFromParent_Done,
     /*  895366 */   // Label 13679: @895366
     /*  895366 */   GIM_Try, /*On fail goto*//*Label 13680*/ GIMT_Encode4(895441), // Rule ID 61657 //
     /*  895371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  895382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  895385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  895388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895417 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895439 */     GIR_RootConstrainSelectedInstOperands,
     /*  895440 */     // GIR_Coverage, 61657,
     /*  895440 */     GIR_EraseRootFromParent_Done,
     /*  895441 */   // Label 13680: @895441
     /*  895441 */   GIM_Try, /*On fail goto*//*Label 13681*/ GIMT_Encode4(895516), // Rule ID 61660 //
     /*  895446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  895457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  895460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  895463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895514 */     GIR_RootConstrainSelectedInstOperands,
     /*  895515 */     // GIR_Coverage, 61660,
     /*  895515 */     GIR_EraseRootFromParent_Done,
     /*  895516 */   // Label 13681: @895516
     /*  895516 */   GIM_Try, /*On fail goto*//*Label 13682*/ GIMT_Encode4(895591), // Rule ID 61661 //
     /*  895521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  895532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  895535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  895538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895567 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895589 */     GIR_RootConstrainSelectedInstOperands,
     /*  895590 */     // GIR_Coverage, 61661,
     /*  895590 */     GIR_EraseRootFromParent_Done,
     /*  895591 */   // Label 13682: @895591
     /*  895591 */   GIM_Try, /*On fail goto*//*Label 13683*/ GIMT_Encode4(895666), // Rule ID 61664 //
     /*  895596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  895607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  895610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  895613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895642 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  895642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895664 */     GIR_RootConstrainSelectedInstOperands,
     /*  895665 */     // GIR_Coverage, 61664,
     /*  895665 */     GIR_EraseRootFromParent_Done,
     /*  895666 */   // Label 13683: @895666
     /*  895666 */   GIM_Try, /*On fail goto*//*Label 13684*/ GIMT_Encode4(895741), // Rule ID 61665 //
     /*  895671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  895682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  895685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  895688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895717 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  895717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895739 */     GIR_RootConstrainSelectedInstOperands,
     /*  895740 */     // GIR_Coverage, 61665,
     /*  895740 */     GIR_EraseRootFromParent_Done,
     /*  895741 */   // Label 13684: @895741
     /*  895741 */   GIM_Try, /*On fail goto*//*Label 13685*/ GIMT_Encode4(895816), // Rule ID 61668 //
     /*  895746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  895757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  895760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  895763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  895792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895814 */     GIR_RootConstrainSelectedInstOperands,
     /*  895815 */     // GIR_Coverage, 61668,
     /*  895815 */     GIR_EraseRootFromParent_Done,
     /*  895816 */   // Label 13685: @895816
     /*  895816 */   GIM_Try, /*On fail goto*//*Label 13686*/ GIMT_Encode4(895891), // Rule ID 61669 //
     /*  895821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  895832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  895835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  895838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895867 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  895867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895889 */     GIR_RootConstrainSelectedInstOperands,
     /*  895890 */     // GIR_Coverage, 61669,
     /*  895890 */     GIR_EraseRootFromParent_Done,
     /*  895891 */   // Label 13686: @895891
     /*  895891 */   GIM_Try, /*On fail goto*//*Label 13687*/ GIMT_Encode4(895966), // Rule ID 61672 //
     /*  895896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  895907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  895910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  895913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  895942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895964 */     GIR_RootConstrainSelectedInstOperands,
     /*  895965 */     // GIR_Coverage, 61672,
     /*  895965 */     GIR_EraseRootFromParent_Done,
     /*  895966 */   // Label 13687: @895966
     /*  895966 */   GIM_Try, /*On fail goto*//*Label 13688*/ GIMT_Encode4(896041), // Rule ID 61673 //
     /*  895971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  895982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  895985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  895988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896017 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  896020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896039 */     GIR_RootConstrainSelectedInstOperands,
     /*  896040 */     // GIR_Coverage, 61673,
     /*  896040 */     GIR_EraseRootFromParent_Done,
     /*  896041 */   // Label 13688: @896041
     /*  896041 */   GIM_Try, /*On fail goto*//*Label 13689*/ GIMT_Encode4(896116), // Rule ID 61676 //
     /*  896046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896114 */     GIR_RootConstrainSelectedInstOperands,
     /*  896115 */     // GIR_Coverage, 61676,
     /*  896115 */     GIR_EraseRootFromParent_Done,
     /*  896116 */   // Label 13689: @896116
     /*  896116 */   GIM_Try, /*On fail goto*//*Label 13690*/ GIMT_Encode4(896191), // Rule ID 61677 //
     /*  896121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  896132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  896135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  896138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896167 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11525:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896189 */     GIR_RootConstrainSelectedInstOperands,
     /*  896190 */     // GIR_Coverage, 61677,
     /*  896190 */     GIR_EraseRootFromParent_Done,
     /*  896191 */   // Label 13690: @896191
     /*  896191 */   GIM_Try, /*On fail goto*//*Label 13691*/ GIMT_Encode4(896266), // Rule ID 61680 //
     /*  896196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896264 */     GIR_RootConstrainSelectedInstOperands,
     /*  896265 */     // GIR_Coverage, 61680,
     /*  896265 */     GIR_EraseRootFromParent_Done,
     /*  896266 */   // Label 13691: @896266
     /*  896266 */   GIM_Try, /*On fail goto*//*Label 13692*/ GIMT_Encode4(896341), // Rule ID 61681 //
     /*  896271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  896282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  896285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  896288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896317 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11525:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896339 */     GIR_RootConstrainSelectedInstOperands,
     /*  896340 */     // GIR_Coverage, 61681,
     /*  896340 */     GIR_EraseRootFromParent_Done,
     /*  896341 */   // Label 13692: @896341
     /*  896341 */   GIM_Try, /*On fail goto*//*Label 13693*/ GIMT_Encode4(896416), // Rule ID 61684 //
     /*  896346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  896392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896414 */     GIR_RootConstrainSelectedInstOperands,
     /*  896415 */     // GIR_Coverage, 61684,
     /*  896415 */     GIR_EraseRootFromParent_Done,
     /*  896416 */   // Label 13693: @896416
     /*  896416 */   GIM_Try, /*On fail goto*//*Label 13694*/ GIMT_Encode4(896491), // Rule ID 61685 //
     /*  896421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  896432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  896435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  896438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896467 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11525:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  896467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  896486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896489 */     GIR_RootConstrainSelectedInstOperands,
     /*  896490 */     // GIR_Coverage, 61685,
     /*  896490 */     GIR_EraseRootFromParent_Done,
     /*  896491 */   // Label 13694: @896491
     /*  896491 */   GIM_Try, /*On fail goto*//*Label 13695*/ GIMT_Encode4(896566), // Rule ID 61688 //
     /*  896496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  896507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896542 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  896542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  896561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896564 */     GIR_RootConstrainSelectedInstOperands,
     /*  896565 */     // GIR_Coverage, 61688,
     /*  896565 */     GIR_EraseRootFromParent_Done,
     /*  896566 */   // Label 13695: @896566
     /*  896566 */   GIM_Try, /*On fail goto*//*Label 13696*/ GIMT_Encode4(896641), // Rule ID 61689 //
     /*  896571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  896582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896617 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11525:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  896617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  896636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896639 */     GIR_RootConstrainSelectedInstOperands,
     /*  896640 */     // GIR_Coverage, 61689,
     /*  896640 */     GIR_EraseRootFromParent_Done,
     /*  896641 */   // Label 13696: @896641
     /*  896641 */   GIM_Try, /*On fail goto*//*Label 13697*/ GIMT_Encode4(896716), // Rule ID 61692 //
     /*  896646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  896657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  896660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  896663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896692 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  896695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896714 */     GIR_RootConstrainSelectedInstOperands,
     /*  896715 */     // GIR_Coverage, 61692,
     /*  896715 */     GIR_EraseRootFromParent_Done,
     /*  896716 */   // Label 13697: @896716
     /*  896716 */   GIM_Try, /*On fail goto*//*Label 13698*/ GIMT_Encode4(896791), // Rule ID 61693 //
     /*  896721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  896732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  896735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  896738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896767 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  896770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896789 */     GIR_RootConstrainSelectedInstOperands,
     /*  896790 */     // GIR_Coverage, 61693,
     /*  896790 */     GIR_EraseRootFromParent_Done,
     /*  896791 */   // Label 13698: @896791
     /*  896791 */   GIM_Try, /*On fail goto*//*Label 13699*/ GIMT_Encode4(896866), // Rule ID 61696 //
     /*  896796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  896807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  896810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  896813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896842 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  896845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896864 */     GIR_RootConstrainSelectedInstOperands,
     /*  896865 */     // GIR_Coverage, 61696,
     /*  896865 */     GIR_EraseRootFromParent_Done,
     /*  896866 */   // Label 13699: @896866
     /*  896866 */   GIM_Try, /*On fail goto*//*Label 13700*/ GIMT_Encode4(896941), // Rule ID 61697 //
     /*  896871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  896882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  896885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  896888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896917 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  896920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896939 */     GIR_RootConstrainSelectedInstOperands,
     /*  896940 */     // GIR_Coverage, 61697,
     /*  896940 */     GIR_EraseRootFromParent_Done,
     /*  896941 */   // Label 13700: @896941
     /*  896941 */   GIM_Try, /*On fail goto*//*Label 13701*/ GIMT_Encode4(897016), // Rule ID 61700 //
     /*  896946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  896957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  896960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  896963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896992 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  896995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897014 */     GIR_RootConstrainSelectedInstOperands,
     /*  897015 */     // GIR_Coverage, 61700,
     /*  897015 */     GIR_EraseRootFromParent_Done,
     /*  897016 */   // Label 13701: @897016
     /*  897016 */   GIM_Try, /*On fail goto*//*Label 13702*/ GIMT_Encode4(897091), // Rule ID 61701 //
     /*  897021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  897032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  897035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  897038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897067 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  897067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  897086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897089 */     GIR_RootConstrainSelectedInstOperands,
     /*  897090 */     // GIR_Coverage, 61701,
     /*  897090 */     GIR_EraseRootFromParent_Done,
     /*  897091 */   // Label 13702: @897091
     /*  897091 */   GIM_Try, /*On fail goto*//*Label 13703*/ GIMT_Encode4(897166), // Rule ID 61704 //
     /*  897096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897164 */     GIR_RootConstrainSelectedInstOperands,
     /*  897165 */     // GIR_Coverage, 61704,
     /*  897165 */     GIR_EraseRootFromParent_Done,
     /*  897166 */   // Label 13703: @897166
     /*  897166 */   GIM_Try, /*On fail goto*//*Label 13704*/ GIMT_Encode4(897241), // Rule ID 61705 //
     /*  897171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  897182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  897185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  897188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897217 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897239 */     GIR_RootConstrainSelectedInstOperands,
     /*  897240 */     // GIR_Coverage, 61705,
     /*  897240 */     GIR_EraseRootFromParent_Done,
     /*  897241 */   // Label 13704: @897241
     /*  897241 */   GIM_Try, /*On fail goto*//*Label 13705*/ GIMT_Encode4(897316), // Rule ID 61708 //
     /*  897246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897292 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897314 */     GIR_RootConstrainSelectedInstOperands,
     /*  897315 */     // GIR_Coverage, 61708,
     /*  897315 */     GIR_EraseRootFromParent_Done,
     /*  897316 */   // Label 13705: @897316
     /*  897316 */   GIM_Try, /*On fail goto*//*Label 13706*/ GIMT_Encode4(897391), // Rule ID 61709 //
     /*  897321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  897332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  897335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  897338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897367 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897389 */     GIR_RootConstrainSelectedInstOperands,
     /*  897390 */     // GIR_Coverage, 61709,
     /*  897390 */     GIR_EraseRootFromParent_Done,
     /*  897391 */   // Label 13706: @897391
     /*  897391 */   GIM_Try, /*On fail goto*//*Label 13707*/ GIMT_Encode4(897466), // Rule ID 61712 //
     /*  897396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897442 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  897442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897464 */     GIR_RootConstrainSelectedInstOperands,
     /*  897465 */     // GIR_Coverage, 61712,
     /*  897465 */     GIR_EraseRootFromParent_Done,
     /*  897466 */   // Label 13707: @897466
     /*  897466 */   GIM_Try, /*On fail goto*//*Label 13708*/ GIMT_Encode4(897541), // Rule ID 61713 //
     /*  897471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  897482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  897485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  897488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897517 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897539 */     GIR_RootConstrainSelectedInstOperands,
     /*  897540 */     // GIR_Coverage, 61713,
     /*  897540 */     GIR_EraseRootFromParent_Done,
     /*  897541 */   // Label 13708: @897541
     /*  897541 */   GIM_Try, /*On fail goto*//*Label 13709*/ GIMT_Encode4(897616), // Rule ID 61716 //
     /*  897546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  897557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  897560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  897563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897592 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  897592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897614 */     GIR_RootConstrainSelectedInstOperands,
     /*  897615 */     // GIR_Coverage, 61716,
     /*  897615 */     GIR_EraseRootFromParent_Done,
     /*  897616 */   // Label 13709: @897616
     /*  897616 */   GIM_Try, /*On fail goto*//*Label 13710*/ GIMT_Encode4(897691), // Rule ID 61717 //
     /*  897621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  897632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  897635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  897638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897667 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897689 */     GIR_RootConstrainSelectedInstOperands,
     /*  897690 */     // GIR_Coverage, 61717,
     /*  897690 */     GIR_EraseRootFromParent_Done,
     /*  897691 */   // Label 13710: @897691
     /*  897691 */   GIM_Try, /*On fail goto*//*Label 13711*/ GIMT_Encode4(897766), // Rule ID 61720 //
     /*  897696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  897707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  897710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  897713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  897742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897764 */     GIR_RootConstrainSelectedInstOperands,
     /*  897765 */     // GIR_Coverage, 61720,
     /*  897765 */     GIR_EraseRootFromParent_Done,
     /*  897766 */   // Label 13711: @897766
     /*  897766 */   GIM_Try, /*On fail goto*//*Label 13712*/ GIMT_Encode4(897841), // Rule ID 61721 //
     /*  897771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  897782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  897785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  897788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897817 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897839 */     GIR_RootConstrainSelectedInstOperands,
     /*  897840 */     // GIR_Coverage, 61721,
     /*  897840 */     GIR_EraseRootFromParent_Done,
     /*  897841 */   // Label 13712: @897841
     /*  897841 */   GIM_Try, /*On fail goto*//*Label 13713*/ GIMT_Encode4(897916), // Rule ID 61724 //
     /*  897846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  897857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  897860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  897863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897892 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  897892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897914 */     GIR_RootConstrainSelectedInstOperands,
     /*  897915 */     // GIR_Coverage, 61724,
     /*  897915 */     GIR_EraseRootFromParent_Done,
     /*  897916 */   // Label 13713: @897916
     /*  897916 */   GIM_Try, /*On fail goto*//*Label 13714*/ GIMT_Encode4(897991), // Rule ID 61725 //
     /*  897921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  897932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  897935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  897938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897967 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897989 */     GIR_RootConstrainSelectedInstOperands,
     /*  897990 */     // GIR_Coverage, 61725,
     /*  897990 */     GIR_EraseRootFromParent_Done,
     /*  897991 */   // Label 13714: @897991
     /*  897991 */   GIM_Try, /*On fail goto*//*Label 13715*/ GIMT_Encode4(898066), // Rule ID 61728 //
     /*  897996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898064 */     GIR_RootConstrainSelectedInstOperands,
     /*  898065 */     // GIR_Coverage, 61728,
     /*  898065 */     GIR_EraseRootFromParent_Done,
     /*  898066 */   // Label 13715: @898066
     /*  898066 */   GIM_Try, /*On fail goto*//*Label 13716*/ GIMT_Encode4(898141), // Rule ID 61729 //
     /*  898071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  898082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  898085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  898088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  898106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11525:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  898120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898139 */     GIR_RootConstrainSelectedInstOperands,
     /*  898140 */     // GIR_Coverage, 61729,
     /*  898140 */     GIR_EraseRootFromParent_Done,
     /*  898141 */   // Label 13716: @898141
     /*  898141 */   GIM_Try, /*On fail goto*//*Label 13717*/ GIMT_Encode4(898216), // Rule ID 61732 //
     /*  898146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898192 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898214 */     GIR_RootConstrainSelectedInstOperands,
     /*  898215 */     // GIR_Coverage, 61732,
     /*  898215 */     GIR_EraseRootFromParent_Done,
     /*  898216 */   // Label 13717: @898216
     /*  898216 */   GIM_Try, /*On fail goto*//*Label 13718*/ GIMT_Encode4(898291), // Rule ID 61733 //
     /*  898221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  898232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  898235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  898238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  898256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898267 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11525:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  898270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898289 */     GIR_RootConstrainSelectedInstOperands,
     /*  898290 */     // GIR_Coverage, 61733,
     /*  898290 */     GIR_EraseRootFromParent_Done,
     /*  898291 */   // Label 13718: @898291
     /*  898291 */   GIM_Try, /*On fail goto*//*Label 13719*/ GIMT_Encode4(898366), // Rule ID 61736 //
     /*  898296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  898316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898342 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  898342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898364 */     GIR_RootConstrainSelectedInstOperands,
     /*  898365 */     // GIR_Coverage, 61736,
     /*  898365 */     GIR_EraseRootFromParent_Done,
     /*  898366 */   // Label 13719: @898366
     /*  898366 */   GIM_Try, /*On fail goto*//*Label 13720*/ GIMT_Encode4(898441), // Rule ID 61737 //
     /*  898371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  898379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  898382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  898385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  898388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  898391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  898406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  898410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898417 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11525:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  898417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  898420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  898436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898439 */     GIR_RootConstrainSelectedInstOperands,
     /*  898440 */     // GIR_Coverage, 61737,
     /*  898440 */     GIR_EraseRootFromParent_Done,
     /*  898441 */   // Label 13720: @898441
     /*  898441 */   GIM_Try, /*On fail goto*//*Label 13721*/ GIMT_Encode4(898516), // Rule ID 61824 //
     /*  898446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  898457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  898460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  898463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  898466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  898495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898514 */     GIR_RootConstrainSelectedInstOperands,
     /*  898515 */     // GIR_Coverage, 61824,
     /*  898515 */     GIR_EraseRootFromParent_Done,
     /*  898516 */   // Label 13721: @898516
     /*  898516 */   GIM_Try, /*On fail goto*//*Label 13722*/ GIMT_Encode4(898591), // Rule ID 61825 //
     /*  898521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  898532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  898535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  898538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  898541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898567 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  898570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898589 */     GIR_RootConstrainSelectedInstOperands,
     /*  898590 */     // GIR_Coverage, 61825,
     /*  898590 */     GIR_EraseRootFromParent_Done,
     /*  898591 */   // Label 13722: @898591
     /*  898591 */   GIM_Try, /*On fail goto*//*Label 13723*/ GIMT_Encode4(898666), // Rule ID 61828 //
     /*  898596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  898607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  898610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  898613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  898616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898642 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898664 */     GIR_RootConstrainSelectedInstOperands,
     /*  898665 */     // GIR_Coverage, 61828,
     /*  898665 */     GIR_EraseRootFromParent_Done,
     /*  898666 */   // Label 13723: @898666
     /*  898666 */   GIM_Try, /*On fail goto*//*Label 13724*/ GIMT_Encode4(898741), // Rule ID 61829 //
     /*  898671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  898682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  898685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  898688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  898691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898717 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898739 */     GIR_RootConstrainSelectedInstOperands,
     /*  898740 */     // GIR_Coverage, 61829,
     /*  898740 */     GIR_EraseRootFromParent_Done,
     /*  898741 */   // Label 13724: @898741
     /*  898741 */   GIM_Try, /*On fail goto*//*Label 13725*/ GIMT_Encode4(898816), // Rule ID 61832 //
     /*  898746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  898757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  898760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  898763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  898766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898792 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898814 */     GIR_RootConstrainSelectedInstOperands,
     /*  898815 */     // GIR_Coverage, 61832,
     /*  898815 */     GIR_EraseRootFromParent_Done,
     /*  898816 */   // Label 13725: @898816
     /*  898816 */   GIM_Try, /*On fail goto*//*Label 13726*/ GIMT_Encode4(898891), // Rule ID 61833 //
     /*  898821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  898832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  898835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  898838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  898841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898867 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898889 */     GIR_RootConstrainSelectedInstOperands,
     /*  898890 */     // GIR_Coverage, 61833,
     /*  898890 */     GIR_EraseRootFromParent_Done,
     /*  898891 */   // Label 13726: @898891
     /*  898891 */   GIM_Try, /*On fail goto*//*Label 13727*/ GIMT_Encode4(898966), // Rule ID 61836 //
     /*  898896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  898907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  898910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  898913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  898916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898942 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  898942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898964 */     GIR_RootConstrainSelectedInstOperands,
     /*  898965 */     // GIR_Coverage, 61836,
     /*  898965 */     GIR_EraseRootFromParent_Done,
     /*  898966 */   // Label 13727: @898966
     /*  898966 */   GIM_Try, /*On fail goto*//*Label 13728*/ GIMT_Encode4(899041), // Rule ID 61837 //
     /*  898971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  898982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  898985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  898988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  898991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899017 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  899020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899039 */     GIR_RootConstrainSelectedInstOperands,
     /*  899040 */     // GIR_Coverage, 61837,
     /*  899040 */     GIR_EraseRootFromParent_Done,
     /*  899041 */   // Label 13728: @899041
     /*  899041 */   GIM_Try, /*On fail goto*//*Label 13729*/ GIMT_Encode4(899116), // Rule ID 61840 //
     /*  899046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  899066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899092 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899114 */     GIR_RootConstrainSelectedInstOperands,
     /*  899115 */     // GIR_Coverage, 61840,
     /*  899115 */     GIR_EraseRootFromParent_Done,
     /*  899116 */   // Label 13729: @899116
     /*  899116 */   GIM_Try, /*On fail goto*//*Label 13730*/ GIMT_Encode4(899191), // Rule ID 61841 //
     /*  899121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  899132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  899135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  899138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  899141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899167 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899189 */     GIR_RootConstrainSelectedInstOperands,
     /*  899190 */     // GIR_Coverage, 61841,
     /*  899190 */     GIR_EraseRootFromParent_Done,
     /*  899191 */   // Label 13730: @899191
     /*  899191 */   GIM_Try, /*On fail goto*//*Label 13731*/ GIMT_Encode4(899266), // Rule ID 61844 //
     /*  899196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899264 */     GIR_RootConstrainSelectedInstOperands,
     /*  899265 */     // GIR_Coverage, 61844,
     /*  899265 */     GIR_EraseRootFromParent_Done,
     /*  899266 */   // Label 13731: @899266
     /*  899266 */   GIM_Try, /*On fail goto*//*Label 13732*/ GIMT_Encode4(899341), // Rule ID 61845 //
     /*  899271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  899282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  899285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  899288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  899291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899317 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  899320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899339 */     GIR_RootConstrainSelectedInstOperands,
     /*  899340 */     // GIR_Coverage, 61845,
     /*  899340 */     GIR_EraseRootFromParent_Done,
     /*  899341 */   // Label 13732: @899341
     /*  899341 */   GIM_Try, /*On fail goto*//*Label 13733*/ GIMT_Encode4(899416), // Rule ID 61848 //
     /*  899346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  899366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899414 */     GIR_RootConstrainSelectedInstOperands,
     /*  899415 */     // GIR_Coverage, 61848,
     /*  899415 */     GIR_EraseRootFromParent_Done,
     /*  899416 */   // Label 13733: @899416
     /*  899416 */   GIM_Try, /*On fail goto*//*Label 13734*/ GIMT_Encode4(899491), // Rule ID 61849 //
     /*  899421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  899432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  899435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  899438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  899441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899467 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899489 */     GIR_RootConstrainSelectedInstOperands,
     /*  899490 */     // GIR_Coverage, 61849,
     /*  899490 */     GIR_EraseRootFromParent_Done,
     /*  899491 */   // Label 13734: @899491
     /*  899491 */   GIM_Try, /*On fail goto*//*Label 13735*/ GIMT_Encode4(899566), // Rule ID 61852 //
     /*  899496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  899507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  899510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  899513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  899516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899542 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899564 */     GIR_RootConstrainSelectedInstOperands,
     /*  899565 */     // GIR_Coverage, 61852,
     /*  899565 */     GIR_EraseRootFromParent_Done,
     /*  899566 */   // Label 13735: @899566
     /*  899566 */   GIM_Try, /*On fail goto*//*Label 13736*/ GIMT_Encode4(899641), // Rule ID 61853 //
     /*  899571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  899582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  899585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  899588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  899591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899617 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899639 */     GIR_RootConstrainSelectedInstOperands,
     /*  899640 */     // GIR_Coverage, 61853,
     /*  899640 */     GIR_EraseRootFromParent_Done,
     /*  899641 */   // Label 13736: @899641
     /*  899641 */   GIM_Try, /*On fail goto*//*Label 13737*/ GIMT_Encode4(899716), // Rule ID 61856 //
     /*  899646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  899657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  899660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  899663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  899666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899692 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899714 */     GIR_RootConstrainSelectedInstOperands,
     /*  899715 */     // GIR_Coverage, 61856,
     /*  899715 */     GIR_EraseRootFromParent_Done,
     /*  899716 */   // Label 13737: @899716
     /*  899716 */   GIM_Try, /*On fail goto*//*Label 13738*/ GIMT_Encode4(899791), // Rule ID 61857 //
     /*  899721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  899732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  899735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  899738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  899741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899767 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899789 */     GIR_RootConstrainSelectedInstOperands,
     /*  899790 */     // GIR_Coverage, 61857,
     /*  899790 */     GIR_EraseRootFromParent_Done,
     /*  899791 */   // Label 13738: @899791
     /*  899791 */   GIM_Try, /*On fail goto*//*Label 13739*/ GIMT_Encode4(899866), // Rule ID 61860 //
     /*  899796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  899807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  899810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  899813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  899816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899842 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  899842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  899861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899864 */     GIR_RootConstrainSelectedInstOperands,
     /*  899865 */     // GIR_Coverage, 61860,
     /*  899865 */     GIR_EraseRootFromParent_Done,
     /*  899866 */   // Label 13739: @899866
     /*  899866 */   GIM_Try, /*On fail goto*//*Label 13740*/ GIMT_Encode4(899941), // Rule ID 61861 //
     /*  899871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  899882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  899885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  899888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  899891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899917 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  899917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  899936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899939 */     GIR_RootConstrainSelectedInstOperands,
     /*  899940 */     // GIR_Coverage, 61861,
     /*  899940 */     GIR_EraseRootFromParent_Done,
     /*  899941 */   // Label 13740: @899941
     /*  899941 */   GIM_Try, /*On fail goto*//*Label 13741*/ GIMT_Encode4(900016), // Rule ID 61864 //
     /*  899946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  899957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  899960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  899963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  899966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899992 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  899995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900014 */     GIR_RootConstrainSelectedInstOperands,
     /*  900015 */     // GIR_Coverage, 61864,
     /*  900015 */     GIR_EraseRootFromParent_Done,
     /*  900016 */   // Label 13741: @900016
     /*  900016 */   GIM_Try, /*On fail goto*//*Label 13742*/ GIMT_Encode4(900091), // Rule ID 61865 //
     /*  900021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  900032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  900035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  900038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  900041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900067 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900089 */     GIR_RootConstrainSelectedInstOperands,
     /*  900090 */     // GIR_Coverage, 61865,
     /*  900090 */     GIR_EraseRootFromParent_Done,
     /*  900091 */   // Label 13742: @900091
     /*  900091 */   GIM_Try, /*On fail goto*//*Label 13743*/ GIMT_Encode4(900166), // Rule ID 61868 //
     /*  900096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  900116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900142 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900164 */     GIR_RootConstrainSelectedInstOperands,
     /*  900165 */     // GIR_Coverage, 61868,
     /*  900165 */     GIR_EraseRootFromParent_Done,
     /*  900166 */   // Label 13743: @900166
     /*  900166 */   GIM_Try, /*On fail goto*//*Label 13744*/ GIMT_Encode4(900241), // Rule ID 61869 //
     /*  900171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  900182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  900185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  900188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  900191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900217 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900239 */     GIR_RootConstrainSelectedInstOperands,
     /*  900240 */     // GIR_Coverage, 61869,
     /*  900240 */     GIR_EraseRootFromParent_Done,
     /*  900241 */   // Label 13744: @900241
     /*  900241 */   GIM_Try, /*On fail goto*//*Label 13745*/ GIMT_Encode4(900316), // Rule ID 61872 //
     /*  900246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  900266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900292 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  900292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900314 */     GIR_RootConstrainSelectedInstOperands,
     /*  900315 */     // GIR_Coverage, 61872,
     /*  900315 */     GIR_EraseRootFromParent_Done,
     /*  900316 */   // Label 13745: @900316
     /*  900316 */   GIM_Try, /*On fail goto*//*Label 13746*/ GIMT_Encode4(900391), // Rule ID 61873 //
     /*  900321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  900332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  900335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  900338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  900341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900367 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  900367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  900386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900389 */     GIR_RootConstrainSelectedInstOperands,
     /*  900390 */     // GIR_Coverage, 61873,
     /*  900390 */     GIR_EraseRootFromParent_Done,
     /*  900391 */   // Label 13746: @900391
     /*  900391 */   GIM_Try, /*On fail goto*//*Label 13747*/ GIMT_Encode4(900466), // Rule ID 61876 //
     /*  900396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900464 */     GIR_RootConstrainSelectedInstOperands,
     /*  900465 */     // GIR_Coverage, 61876,
     /*  900465 */     GIR_EraseRootFromParent_Done,
     /*  900466 */   // Label 13747: @900466
     /*  900466 */   GIM_Try, /*On fail goto*//*Label 13748*/ GIMT_Encode4(900541), // Rule ID 61877 //
     /*  900471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  900482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  900485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  900488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  900491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900517 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900539 */     GIR_RootConstrainSelectedInstOperands,
     /*  900540 */     // GIR_Coverage, 61877,
     /*  900540 */     GIR_EraseRootFromParent_Done,
     /*  900541 */   // Label 13748: @900541
     /*  900541 */   GIM_Try, /*On fail goto*//*Label 13749*/ GIMT_Encode4(900616), // Rule ID 61880 //
     /*  900546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  900557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  900560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  900563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  900566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900592 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900614 */     GIR_RootConstrainSelectedInstOperands,
     /*  900615 */     // GIR_Coverage, 61880,
     /*  900615 */     GIR_EraseRootFromParent_Done,
     /*  900616 */   // Label 13749: @900616
     /*  900616 */   GIM_Try, /*On fail goto*//*Label 13750*/ GIMT_Encode4(900691), // Rule ID 61881 //
     /*  900621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  900632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  900635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  900638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  900641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900667 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900689 */     GIR_RootConstrainSelectedInstOperands,
     /*  900690 */     // GIR_Coverage, 61881,
     /*  900690 */     GIR_EraseRootFromParent_Done,
     /*  900691 */   // Label 13750: @900691
     /*  900691 */   GIM_Try, /*On fail goto*//*Label 13751*/ GIMT_Encode4(900766), // Rule ID 61884 //
     /*  900696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  900707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  900710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  900713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  900716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900742 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900764 */     GIR_RootConstrainSelectedInstOperands,
     /*  900765 */     // GIR_Coverage, 61884,
     /*  900765 */     GIR_EraseRootFromParent_Done,
     /*  900766 */   // Label 13751: @900766
     /*  900766 */   GIM_Try, /*On fail goto*//*Label 13752*/ GIMT_Encode4(900841), // Rule ID 61885 //
     /*  900771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  900782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  900785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  900788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  900791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900817 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900839 */     GIR_RootConstrainSelectedInstOperands,
     /*  900840 */     // GIR_Coverage, 61885,
     /*  900840 */     GIR_EraseRootFromParent_Done,
     /*  900841 */   // Label 13752: @900841
     /*  900841 */   GIM_Try, /*On fail goto*//*Label 13753*/ GIMT_Encode4(900916), // Rule ID 61888 //
     /*  900846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  900857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  900860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  900863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  900866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900914 */     GIR_RootConstrainSelectedInstOperands,
     /*  900915 */     // GIR_Coverage, 61888,
     /*  900915 */     GIR_EraseRootFromParent_Done,
     /*  900916 */   // Label 13753: @900916
     /*  900916 */   GIM_Try, /*On fail goto*//*Label 13754*/ GIMT_Encode4(900991), // Rule ID 61889 //
     /*  900921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  900932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  900935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  900938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  900941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900989 */     GIR_RootConstrainSelectedInstOperands,
     /*  900990 */     // GIR_Coverage, 61889,
     /*  900990 */     GIR_EraseRootFromParent_Done,
     /*  900991 */   // Label 13754: @900991
     /*  900991 */   GIM_Try, /*On fail goto*//*Label 13755*/ GIMT_Encode4(901066), // Rule ID 61892 //
     /*  900996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901042 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901064 */     GIR_RootConstrainSelectedInstOperands,
     /*  901065 */     // GIR_Coverage, 61892,
     /*  901065 */     GIR_EraseRootFromParent_Done,
     /*  901066 */   // Label 13755: @901066
     /*  901066 */   GIM_Try, /*On fail goto*//*Label 13756*/ GIMT_Encode4(901141), // Rule ID 61893 //
     /*  901071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  901082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  901085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  901088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  901091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901117 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901139 */     GIR_RootConstrainSelectedInstOperands,
     /*  901140 */     // GIR_Coverage, 61893,
     /*  901140 */     GIR_EraseRootFromParent_Done,
     /*  901141 */   // Label 13756: @901141
     /*  901141 */   GIM_Try, /*On fail goto*//*Label 13757*/ GIMT_Encode4(901216), // Rule ID 61896 //
     /*  901146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  901166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901192 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  901192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901214 */     GIR_RootConstrainSelectedInstOperands,
     /*  901215 */     // GIR_Coverage, 61896,
     /*  901215 */     GIR_EraseRootFromParent_Done,
     /*  901216 */   // Label 13757: @901216
     /*  901216 */   GIM_Try, /*On fail goto*//*Label 13758*/ GIMT_Encode4(901291), // Rule ID 61897 //
     /*  901221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  901232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  901235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  901238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  901241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901267 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  901267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  901286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901289 */     GIR_RootConstrainSelectedInstOperands,
     /*  901290 */     // GIR_Coverage, 61897,
     /*  901290 */     GIR_EraseRootFromParent_Done,
     /*  901291 */   // Label 13758: @901291
     /*  901291 */   GIM_Try, /*On fail goto*//*Label 13759*/ GIMT_Encode4(901366), // Rule ID 61900 //
     /*  901296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  901316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901342 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901364 */     GIR_RootConstrainSelectedInstOperands,
     /*  901365 */     // GIR_Coverage, 61900,
     /*  901365 */     GIR_EraseRootFromParent_Done,
     /*  901366 */   // Label 13759: @901366
     /*  901366 */   GIM_Try, /*On fail goto*//*Label 13760*/ GIMT_Encode4(901441), // Rule ID 61901 //
     /*  901371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  901382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  901385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  901388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  901391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  901410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  901420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901439 */     GIR_RootConstrainSelectedInstOperands,
     /*  901440 */     // GIR_Coverage, 61901,
     /*  901440 */     GIR_EraseRootFromParent_Done,
     /*  901441 */   // Label 13760: @901441
     /*  901441 */   GIM_Try, /*On fail goto*//*Label 13761*/ GIMT_Encode4(901516), // Rule ID 61904 //
     /*  901446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  901457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  901460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  901463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  901466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901492 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901514 */     GIR_RootConstrainSelectedInstOperands,
     /*  901515 */     // GIR_Coverage, 61904,
     /*  901515 */     GIR_EraseRootFromParent_Done,
     /*  901516 */   // Label 13761: @901516
     /*  901516 */   GIM_Try, /*On fail goto*//*Label 13762*/ GIMT_Encode4(901591), // Rule ID 61905 //
     /*  901521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  901532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  901535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  901538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  901541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901567 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901589 */     GIR_RootConstrainSelectedInstOperands,
     /*  901590 */     // GIR_Coverage, 61905,
     /*  901590 */     GIR_EraseRootFromParent_Done,
     /*  901591 */   // Label 13762: @901591
     /*  901591 */   GIM_Try, /*On fail goto*//*Label 13763*/ GIMT_Encode4(901666), // Rule ID 61908 //
     /*  901596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  901607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  901610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  901613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  901616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901664 */     GIR_RootConstrainSelectedInstOperands,
     /*  901665 */     // GIR_Coverage, 61908,
     /*  901665 */     GIR_EraseRootFromParent_Done,
     /*  901666 */   // Label 13763: @901666
     /*  901666 */   GIM_Try, /*On fail goto*//*Label 13764*/ GIMT_Encode4(901741), // Rule ID 61909 //
     /*  901671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  901682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  901685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  901688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  901691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901717 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901739 */     GIR_RootConstrainSelectedInstOperands,
     /*  901740 */     // GIR_Coverage, 61909,
     /*  901740 */     GIR_EraseRootFromParent_Done,
     /*  901741 */   // Label 13764: @901741
     /*  901741 */   GIM_Try, /*On fail goto*//*Label 13765*/ GIMT_Encode4(901816), // Rule ID 61912 //
     /*  901746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901792 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  901792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  901795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901814 */     GIR_RootConstrainSelectedInstOperands,
     /*  901815 */     // GIR_Coverage, 61912,
     /*  901815 */     GIR_EraseRootFromParent_Done,
     /*  901816 */   // Label 13765: @901816
     /*  901816 */   GIM_Try, /*On fail goto*//*Label 13766*/ GIMT_Encode4(901891), // Rule ID 61913 //
     /*  901821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901867 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  901867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  901870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901889 */     GIR_RootConstrainSelectedInstOperands,
     /*  901890 */     // GIR_Coverage, 61913,
     /*  901890 */     GIR_EraseRootFromParent_Done,
     /*  901891 */   // Label 13766: @901891
     /*  901891 */   GIM_Try, /*On fail goto*//*Label 13767*/ GIMT_Encode4(901966), // Rule ID 61916 //
     /*  901896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  901907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  901910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  901913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901942 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  901942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  901945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901964 */     GIR_RootConstrainSelectedInstOperands,
     /*  901965 */     // GIR_Coverage, 61916,
     /*  901965 */     GIR_EraseRootFromParent_Done,
     /*  901966 */   // Label 13767: @901966
     /*  901966 */   GIM_Try, /*On fail goto*//*Label 13768*/ GIMT_Encode4(902041), // Rule ID 61917 //
     /*  901971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  901982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  901985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  901988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902017 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902039 */     GIR_RootConstrainSelectedInstOperands,
     /*  902040 */     // GIR_Coverage, 61917,
     /*  902040 */     GIR_EraseRootFromParent_Done,
     /*  902041 */   // Label 13768: @902041
     /*  902041 */   GIM_Try, /*On fail goto*//*Label 13769*/ GIMT_Encode4(902116), // Rule ID 61920 //
     /*  902046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902092 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902114 */     GIR_RootConstrainSelectedInstOperands,
     /*  902115 */     // GIR_Coverage, 61920,
     /*  902115 */     GIR_EraseRootFromParent_Done,
     /*  902116 */   // Label 13769: @902116
     /*  902116 */   GIM_Try, /*On fail goto*//*Label 13770*/ GIMT_Encode4(902191), // Rule ID 61921 //
     /*  902121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  902132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  902135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  902138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902167 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902189 */     GIR_RootConstrainSelectedInstOperands,
     /*  902190 */     // GIR_Coverage, 61921,
     /*  902190 */     GIR_EraseRootFromParent_Done,
     /*  902191 */   // Label 13770: @902191
     /*  902191 */   GIM_Try, /*On fail goto*//*Label 13771*/ GIMT_Encode4(902266), // Rule ID 61924 //
     /*  902196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902242 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902264 */     GIR_RootConstrainSelectedInstOperands,
     /*  902265 */     // GIR_Coverage, 61924,
     /*  902265 */     GIR_EraseRootFromParent_Done,
     /*  902266 */   // Label 13771: @902266
     /*  902266 */   GIM_Try, /*On fail goto*//*Label 13772*/ GIMT_Encode4(902341), // Rule ID 61925 //
     /*  902271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  902282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  902285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  902288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902317 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  902320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902339 */     GIR_RootConstrainSelectedInstOperands,
     /*  902340 */     // GIR_Coverage, 61925,
     /*  902340 */     GIR_EraseRootFromParent_Done,
     /*  902341 */   // Label 13772: @902341
     /*  902341 */   GIM_Try, /*On fail goto*//*Label 13773*/ GIMT_Encode4(902416), // Rule ID 61928 //
     /*  902346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902392 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902414 */     GIR_RootConstrainSelectedInstOperands,
     /*  902415 */     // GIR_Coverage, 61928,
     /*  902415 */     GIR_EraseRootFromParent_Done,
     /*  902416 */   // Label 13773: @902416
     /*  902416 */   GIM_Try, /*On fail goto*//*Label 13774*/ GIMT_Encode4(902491), // Rule ID 61929 //
     /*  902421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  902432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  902435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  902438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902467 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902489 */     GIR_RootConstrainSelectedInstOperands,
     /*  902490 */     // GIR_Coverage, 61929,
     /*  902490 */     GIR_EraseRootFromParent_Done,
     /*  902491 */   // Label 13774: @902491
     /*  902491 */   GIM_Try, /*On fail goto*//*Label 13775*/ GIMT_Encode4(902566), // Rule ID 61932 //
     /*  902496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  902507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  902513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902542 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  902542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902564 */     GIR_RootConstrainSelectedInstOperands,
     /*  902565 */     // GIR_Coverage, 61932,
     /*  902565 */     GIR_EraseRootFromParent_Done,
     /*  902566 */   // Label 13775: @902566
     /*  902566 */   GIM_Try, /*On fail goto*//*Label 13776*/ GIMT_Encode4(902641), // Rule ID 61933 //
     /*  902571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  902582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  902588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902617 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  902617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902639 */     GIR_RootConstrainSelectedInstOperands,
     /*  902640 */     // GIR_Coverage, 61933,
     /*  902640 */     GIR_EraseRootFromParent_Done,
     /*  902641 */   // Label 13776: @902641
     /*  902641 */   GIM_Try, /*On fail goto*//*Label 13777*/ GIMT_Encode4(902716), // Rule ID 61936 //
     /*  902646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  902657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  902660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  902663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902714 */     GIR_RootConstrainSelectedInstOperands,
     /*  902715 */     // GIR_Coverage, 61936,
     /*  902715 */     GIR_EraseRootFromParent_Done,
     /*  902716 */   // Label 13777: @902716
     /*  902716 */   GIM_Try, /*On fail goto*//*Label 13778*/ GIMT_Encode4(902791), // Rule ID 61937 //
     /*  902721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  902732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  902735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  902738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902767 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11527:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902789 */     GIR_RootConstrainSelectedInstOperands,
     /*  902790 */     // GIR_Coverage, 61937,
     /*  902790 */     GIR_EraseRootFromParent_Done,
     /*  902791 */   // Label 13778: @902791
     /*  902791 */   GIM_Try, /*On fail goto*//*Label 13779*/ GIMT_Encode4(902866), // Rule ID 61940 //
     /*  902796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  902807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  902810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  902813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902842 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902864 */     GIR_RootConstrainSelectedInstOperands,
     /*  902865 */     // GIR_Coverage, 61940,
     /*  902865 */     GIR_EraseRootFromParent_Done,
     /*  902866 */   // Label 13779: @902866
     /*  902866 */   GIM_Try, /*On fail goto*//*Label 13780*/ GIMT_Encode4(902941), // Rule ID 61941 //
     /*  902871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  902882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  902885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  902888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902917 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11527:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902939 */     GIR_RootConstrainSelectedInstOperands,
     /*  902940 */     // GIR_Coverage, 61941,
     /*  902940 */     GIR_EraseRootFromParent_Done,
     /*  902941 */   // Label 13780: @902941
     /*  902941 */   GIM_Try, /*On fail goto*//*Label 13781*/ GIMT_Encode4(903016), // Rule ID 61944 //
     /*  902946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  902957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  902960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  902963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902992 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  902992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903014 */     GIR_RootConstrainSelectedInstOperands,
     /*  903015 */     // GIR_Coverage, 61944,
     /*  903015 */     GIR_EraseRootFromParent_Done,
     /*  903016 */   // Label 13781: @903016
     /*  903016 */   GIM_Try, /*On fail goto*//*Label 13782*/ GIMT_Encode4(903091), // Rule ID 61945 //
     /*  903021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  903032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  903035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  903038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903067 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11527:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903089 */     GIR_RootConstrainSelectedInstOperands,
     /*  903090 */     // GIR_Coverage, 61945,
     /*  903090 */     GIR_EraseRootFromParent_Done,
     /*  903091 */   // Label 13782: @903091
     /*  903091 */   GIM_Try, /*On fail goto*//*Label 13783*/ GIMT_Encode4(903166), // Rule ID 61948 //
     /*  903096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903142 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  903142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903164 */     GIR_RootConstrainSelectedInstOperands,
     /*  903165 */     // GIR_Coverage, 61948,
     /*  903165 */     GIR_EraseRootFromParent_Done,
     /*  903166 */   // Label 13783: @903166
     /*  903166 */   GIM_Try, /*On fail goto*//*Label 13784*/ GIMT_Encode4(903241), // Rule ID 61949 //
     /*  903171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  903182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  903185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  903188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  903206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903217 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11527:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  903217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  903220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  903236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903239 */     GIR_RootConstrainSelectedInstOperands,
     /*  903240 */     // GIR_Coverage, 61949,
     /*  903240 */     GIR_EraseRootFromParent_Done,
     /*  903241 */   // Label 13784: @903241
     /*  903241 */   GIM_Try, /*On fail goto*//*Label 13785*/ GIMT_Encode4(903316), // Rule ID 61952 //
     /*  903246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903292 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903314 */     GIR_RootConstrainSelectedInstOperands,
     /*  903315 */     // GIR_Coverage, 61952,
     /*  903315 */     GIR_EraseRootFromParent_Done,
     /*  903316 */   // Label 13785: @903316
     /*  903316 */   GIM_Try, /*On fail goto*//*Label 13786*/ GIMT_Encode4(903391), // Rule ID 61953 //
     /*  903321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  903332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  903335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  903338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903367 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903389 */     GIR_RootConstrainSelectedInstOperands,
     /*  903390 */     // GIR_Coverage, 61953,
     /*  903390 */     GIR_EraseRootFromParent_Done,
     /*  903391 */   // Label 13786: @903391
     /*  903391 */   GIM_Try, /*On fail goto*//*Label 13787*/ GIMT_Encode4(903466), // Rule ID 61956 //
     /*  903396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903442 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903464 */     GIR_RootConstrainSelectedInstOperands,
     /*  903465 */     // GIR_Coverage, 61956,
     /*  903465 */     GIR_EraseRootFromParent_Done,
     /*  903466 */   // Label 13787: @903466
     /*  903466 */   GIM_Try, /*On fail goto*//*Label 13788*/ GIMT_Encode4(903541), // Rule ID 61957 //
     /*  903471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  903482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  903485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  903488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903517 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903539 */     GIR_RootConstrainSelectedInstOperands,
     /*  903540 */     // GIR_Coverage, 61957,
     /*  903540 */     GIR_EraseRootFromParent_Done,
     /*  903541 */   // Label 13788: @903541
     /*  903541 */   GIM_Try, /*On fail goto*//*Label 13789*/ GIMT_Encode4(903616), // Rule ID 61960 //
     /*  903546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  903557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  903560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  903563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903592 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  903595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903614 */     GIR_RootConstrainSelectedInstOperands,
     /*  903615 */     // GIR_Coverage, 61960,
     /*  903615 */     GIR_EraseRootFromParent_Done,
     /*  903616 */   // Label 13789: @903616
     /*  903616 */   GIM_Try, /*On fail goto*//*Label 13790*/ GIMT_Encode4(903691), // Rule ID 61961 //
     /*  903621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  903632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  903635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  903638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903667 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  903670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903689 */     GIR_RootConstrainSelectedInstOperands,
     /*  903690 */     // GIR_Coverage, 61961,
     /*  903690 */     GIR_EraseRootFromParent_Done,
     /*  903691 */   // Label 13790: @903691
     /*  903691 */   GIM_Try, /*On fail goto*//*Label 13791*/ GIMT_Encode4(903766), // Rule ID 61964 //
     /*  903696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  903707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  903710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  903713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903764 */     GIR_RootConstrainSelectedInstOperands,
     /*  903765 */     // GIR_Coverage, 61964,
     /*  903765 */     GIR_EraseRootFromParent_Done,
     /*  903766 */   // Label 13791: @903766
     /*  903766 */   GIM_Try, /*On fail goto*//*Label 13792*/ GIMT_Encode4(903841), // Rule ID 61965 //
     /*  903771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  903782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  903785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  903788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903817 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903839 */     GIR_RootConstrainSelectedInstOperands,
     /*  903840 */     // GIR_Coverage, 61965,
     /*  903840 */     GIR_EraseRootFromParent_Done,
     /*  903841 */   // Label 13792: @903841
     /*  903841 */   GIM_Try, /*On fail goto*//*Label 13793*/ GIMT_Encode4(903916), // Rule ID 61968 //
     /*  903846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  903857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  903860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  903863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903914 */     GIR_RootConstrainSelectedInstOperands,
     /*  903915 */     // GIR_Coverage, 61968,
     /*  903915 */     GIR_EraseRootFromParent_Done,
     /*  903916 */   // Label 13793: @903916
     /*  903916 */   GIM_Try, /*On fail goto*//*Label 13794*/ GIMT_Encode4(903991), // Rule ID 61969 //
     /*  903921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  903932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  903935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  903938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903967 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903989 */     GIR_RootConstrainSelectedInstOperands,
     /*  903990 */     // GIR_Coverage, 61969,
     /*  903990 */     GIR_EraseRootFromParent_Done,
     /*  903991 */   // Label 13794: @903991
     /*  903991 */   GIM_Try, /*On fail goto*//*Label 13795*/ GIMT_Encode4(904066), // Rule ID 61972 //
     /*  903996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904042 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  904042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904064 */     GIR_RootConstrainSelectedInstOperands,
     /*  904065 */     // GIR_Coverage, 61972,
     /*  904065 */     GIR_EraseRootFromParent_Done,
     /*  904066 */   // Label 13795: @904066
     /*  904066 */   GIM_Try, /*On fail goto*//*Label 13796*/ GIMT_Encode4(904141), // Rule ID 61973 //
     /*  904071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  904082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  904085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  904088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904117 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  904117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  904136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904139 */     GIR_RootConstrainSelectedInstOperands,
     /*  904140 */     // GIR_Coverage, 61973,
     /*  904140 */     GIR_EraseRootFromParent_Done,
     /*  904141 */   // Label 13796: @904141
     /*  904141 */   GIM_Try, /*On fail goto*//*Label 13797*/ GIMT_Encode4(904216), // Rule ID 61976 //
     /*  904146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904214 */     GIR_RootConstrainSelectedInstOperands,
     /*  904215 */     // GIR_Coverage, 61976,
     /*  904215 */     GIR_EraseRootFromParent_Done,
     /*  904216 */   // Label 13797: @904216
     /*  904216 */   GIM_Try, /*On fail goto*//*Label 13798*/ GIMT_Encode4(904291), // Rule ID 61977 //
     /*  904221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904289 */     GIR_RootConstrainSelectedInstOperands,
     /*  904290 */     // GIR_Coverage, 61977,
     /*  904290 */     GIR_EraseRootFromParent_Done,
     /*  904291 */   // Label 13798: @904291
     /*  904291 */   GIM_Try, /*On fail goto*//*Label 13799*/ GIMT_Encode4(904366), // Rule ID 61980 //
     /*  904296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904342 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904364 */     GIR_RootConstrainSelectedInstOperands,
     /*  904365 */     // GIR_Coverage, 61980,
     /*  904365 */     GIR_EraseRootFromParent_Done,
     /*  904366 */   // Label 13799: @904366
     /*  904366 */   GIM_Try, /*On fail goto*//*Label 13800*/ GIMT_Encode4(904441), // Rule ID 61981 //
     /*  904371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904417 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904439 */     GIR_RootConstrainSelectedInstOperands,
     /*  904440 */     // GIR_Coverage, 61981,
     /*  904440 */     GIR_EraseRootFromParent_Done,
     /*  904441 */   // Label 13800: @904441
     /*  904441 */   GIM_Try, /*On fail goto*//*Label 13801*/ GIMT_Encode4(904516), // Rule ID 61984 //
     /*  904446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  904460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  904463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904492 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904514 */     GIR_RootConstrainSelectedInstOperands,
     /*  904515 */     // GIR_Coverage, 61984,
     /*  904515 */     GIR_EraseRootFromParent_Done,
     /*  904516 */   // Label 13801: @904516
     /*  904516 */   GIM_Try, /*On fail goto*//*Label 13802*/ GIMT_Encode4(904591), // Rule ID 61985 //
     /*  904521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  904535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  904538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904567 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904589 */     GIR_RootConstrainSelectedInstOperands,
     /*  904590 */     // GIR_Coverage, 61985,
     /*  904590 */     GIR_EraseRootFromParent_Done,
     /*  904591 */   // Label 13802: @904591
     /*  904591 */   GIM_Try, /*On fail goto*//*Label 13803*/ GIMT_Encode4(904666), // Rule ID 61988 //
     /*  904596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  904607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  904610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  904613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904642 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  904642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904664 */     GIR_RootConstrainSelectedInstOperands,
     /*  904665 */     // GIR_Coverage, 61988,
     /*  904665 */     GIR_EraseRootFromParent_Done,
     /*  904666 */   // Label 13803: @904666
     /*  904666 */   GIM_Try, /*On fail goto*//*Label 13804*/ GIMT_Encode4(904741), // Rule ID 61989 //
     /*  904671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  904682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  904685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  904688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904717 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11527:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  904717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904739 */     GIR_RootConstrainSelectedInstOperands,
     /*  904740 */     // GIR_Coverage, 61989,
     /*  904740 */     GIR_EraseRootFromParent_Done,
     /*  904741 */   // Label 13804: @904741
     /*  904741 */   GIM_Try, /*On fail goto*//*Label 13805*/ GIMT_Encode4(904816), // Rule ID 61992 //
     /*  904746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  904757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  904760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  904763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904792 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  904792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904814 */     GIR_RootConstrainSelectedInstOperands,
     /*  904815 */     // GIR_Coverage, 61992,
     /*  904815 */     GIR_EraseRootFromParent_Done,
     /*  904816 */   // Label 13805: @904816
     /*  904816 */   GIM_Try, /*On fail goto*//*Label 13806*/ GIMT_Encode4(904891), // Rule ID 61993 //
     /*  904821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  904832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  904835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  904838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11527:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  904867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904889 */     GIR_RootConstrainSelectedInstOperands,
     /*  904890 */     // GIR_Coverage, 61993,
     /*  904890 */     GIR_EraseRootFromParent_Done,
     /*  904891 */   // Label 13806: @904891
     /*  904891 */   GIM_Try, /*On fail goto*//*Label 13807*/ GIMT_Encode4(904966), // Rule ID 61996 //
     /*  904896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  904907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  904910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  904913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  904942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904964 */     GIR_RootConstrainSelectedInstOperands,
     /*  904965 */     // GIR_Coverage, 61996,
     /*  904965 */     GIR_EraseRootFromParent_Done,
     /*  904966 */   // Label 13807: @904966
     /*  904966 */   GIM_Try, /*On fail goto*//*Label 13808*/ GIMT_Encode4(905041), // Rule ID 61997 //
     /*  904971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  904982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  904985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  904988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905017 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11527:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  905017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  905020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  905036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905039 */     GIR_RootConstrainSelectedInstOperands,
     /*  905040 */     // GIR_Coverage, 61997,
     /*  905040 */     GIR_EraseRootFromParent_Done,
     /*  905041 */   // Label 13808: @905041
     /*  905041 */   GIM_Try, /*On fail goto*//*Label 13809*/ GIMT_Encode4(905116), // Rule ID 62440 //
     /*  905046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  905057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  905060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  905063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  905066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  905095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905114 */     GIR_RootConstrainSelectedInstOperands,
     /*  905115 */     // GIR_Coverage, 62440,
     /*  905115 */     GIR_EraseRootFromParent_Done,
     /*  905116 */   // Label 13809: @905116
     /*  905116 */   GIM_Try, /*On fail goto*//*Label 13810*/ GIMT_Encode4(905191), // Rule ID 62441 //
     /*  905121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  905132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  905135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  905138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  905141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905167 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11557:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  905170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905189 */     GIR_RootConstrainSelectedInstOperands,
     /*  905190 */     // GIR_Coverage, 62441,
     /*  905190 */     GIR_EraseRootFromParent_Done,
     /*  905191 */   // Label 13810: @905191
     /*  905191 */   GIM_Try, /*On fail goto*//*Label 13811*/ GIMT_Encode4(905266), // Rule ID 62442 //
     /*  905196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  905207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  905210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  905213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  905216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  905245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905264 */     GIR_RootConstrainSelectedInstOperands,
     /*  905265 */     // GIR_Coverage, 62442,
     /*  905265 */     GIR_EraseRootFromParent_Done,
     /*  905266 */   // Label 13811: @905266
     /*  905266 */   GIM_Try, /*On fail goto*//*Label 13812*/ GIMT_Encode4(905341), // Rule ID 62443 //
     /*  905271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  905282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  905285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  905288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  905291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  905310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905317 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11557:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  905320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905339 */     GIR_RootConstrainSelectedInstOperands,
     /*  905340 */     // GIR_Coverage, 62443,
     /*  905340 */     GIR_EraseRootFromParent_Done,
     /*  905341 */   // Label 13812: @905341
     /*  905341 */   GIM_Try, /*On fail goto*//*Label 13813*/ GIMT_Encode4(905416), // Rule ID 62444 //
     /*  905346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  905357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  905360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  905363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  905366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905392 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  905395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905414 */     GIR_RootConstrainSelectedInstOperands,
     /*  905415 */     // GIR_Coverage, 62444,
     /*  905415 */     GIR_EraseRootFromParent_Done,
     /*  905416 */   // Label 13813: @905416
     /*  905416 */   GIM_Try, /*On fail goto*//*Label 13814*/ GIMT_Encode4(905491), // Rule ID 62445 //
     /*  905421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  905432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  905435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  905438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  905441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  905460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905467 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11557:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  905470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905489 */     GIR_RootConstrainSelectedInstOperands,
     /*  905490 */     // GIR_Coverage, 62445,
     /*  905490 */     GIR_EraseRootFromParent_Done,
     /*  905491 */   // Label 13814: @905491
     /*  905491 */   GIM_Try, /*On fail goto*//*Label 13815*/ GIMT_Encode4(905566), // Rule ID 62446 //
     /*  905496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  905499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905542 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  905545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905564 */     GIR_RootConstrainSelectedInstOperands,
     /*  905565 */     // GIR_Coverage, 62446,
     /*  905565 */     GIR_EraseRootFromParent_Done,
     /*  905566 */   // Label 13815: @905566
     /*  905566 */   GIM_Try, /*On fail goto*//*Label 13816*/ GIMT_Encode4(905641), // Rule ID 62447 //
     /*  905571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905617 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11557:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  905620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905639 */     GIR_RootConstrainSelectedInstOperands,
     /*  905640 */     // GIR_Coverage, 62447,
     /*  905640 */     GIR_EraseRootFromParent_Done,
     /*  905641 */   // Label 13816: @905641
     /*  905641 */   GIM_Try, /*On fail goto*//*Label 13817*/ GIMT_Encode4(905705), // Rule ID 64516 //
     /*  905646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuN),
     /*  905654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905682 */     // MIs[0] imm5
     /*  905682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905690 */     // (intrinsic_wo_chain:{ *:[i32] } 10995:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACUN),
     /*  905693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905701 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905703 */     GIR_RootConstrainSelectedInstOperands,
     /*  905704 */     // GIR_Coverage, 64516,
     /*  905704 */     GIR_EraseRootFromParent_Done,
     /*  905705 */   // Label 13817: @905705
     /*  905705 */   GIM_Try, /*On fail goto*//*Label 13818*/ GIMT_Encode4(905769), // Rule ID 64517 //
     /*  905710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuN),
     /*  905718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905746 */     // MIs[0] imm5
     /*  905746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905754 */     // (intrinsic_wo_chain:{ *:[i32] } 10991:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHUN),
     /*  905757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905765 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905767 */     GIR_RootConstrainSelectedInstOperands,
     /*  905768 */     // GIR_Coverage, 64517,
     /*  905768 */     GIR_EraseRootFromParent_Done,
     /*  905769 */   // Label 13818: @905769
     /*  905769 */   GIM_Try, /*On fail goto*//*Label 13819*/ GIMT_Encode4(905833), // Rule ID 64518 //
     /*  905774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsN),
     /*  905782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905810 */     // MIs[0] imm5
     /*  905810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905818 */     // (intrinsic_wo_chain:{ *:[i32] } 10993:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSN),
     /*  905821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905829 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905831 */     GIR_RootConstrainSelectedInstOperands,
     /*  905832 */     // GIR_Coverage, 64518,
     /*  905832 */     GIR_EraseRootFromParent_Done,
     /*  905833 */   // Label 13819: @905833
     /*  905833 */   GIM_Try, /*On fail goto*//*Label 13820*/ GIMT_Encode4(905897), // Rule ID 64519 //
     /*  905838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsN),
     /*  905846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905874 */     // MIs[0] imm5
     /*  905874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905882 */     // (intrinsic_wo_chain:{ *:[i32] } 10989:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSN),
     /*  905885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905893 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905895 */     GIR_RootConstrainSelectedInstOperands,
     /*  905896 */     // GIR_Coverage, 64519,
     /*  905896 */     GIR_EraseRootFromParent_Done,
     /*  905897 */   // Label 13820: @905897
     /*  905897 */   GIM_Try, /*On fail goto*//*Label 13821*/ GIMT_Encode4(905961), // Rule ID 64520 //
     /*  905902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuRN),
     /*  905910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905938 */     // MIs[0] imm5
     /*  905938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905946 */     // (intrinsic_wo_chain:{ *:[i32] } 10996:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACURN),
     /*  905949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905957 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905959 */     GIR_RootConstrainSelectedInstOperands,
     /*  905960 */     // GIR_Coverage, 64520,
     /*  905960 */     GIR_EraseRootFromParent_Done,
     /*  905961 */   // Label 13821: @905961
     /*  905961 */   GIM_Try, /*On fail goto*//*Label 13822*/ GIMT_Encode4(906025), // Rule ID 64521 //
     /*  905966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuRN),
     /*  905974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906002 */     // MIs[0] imm5
     /*  906002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906010 */     // (intrinsic_wo_chain:{ *:[i32] } 10992:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHURN),
     /*  906013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906021 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906023 */     GIR_RootConstrainSelectedInstOperands,
     /*  906024 */     // GIR_Coverage, 64521,
     /*  906024 */     GIR_EraseRootFromParent_Done,
     /*  906025 */   // Label 13822: @906025
     /*  906025 */   GIM_Try, /*On fail goto*//*Label 13823*/ GIMT_Encode4(906089), // Rule ID 64522 //
     /*  906030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsRN),
     /*  906038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906066 */     // MIs[0] imm5
     /*  906066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906074 */     // (intrinsic_wo_chain:{ *:[i32] } 10994:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSRN),
     /*  906077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906085 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906087 */     GIR_RootConstrainSelectedInstOperands,
     /*  906088 */     // GIR_Coverage, 64522,
     /*  906088 */     GIR_EraseRootFromParent_Done,
     /*  906089 */   // Label 13823: @906089
     /*  906089 */   GIM_Try, /*On fail goto*//*Label 13824*/ GIMT_Encode4(906153), // Rule ID 64523 //
     /*  906094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  906097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsRN),
     /*  906102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  906105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  906108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  906111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  906114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  906130 */     // MIs[0] imm5
     /*  906130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  906138 */     // (intrinsic_wo_chain:{ *:[i32] } 10990:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  906138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSRN),
     /*  906141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  906143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  906145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  906147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  906149 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  906151 */     GIR_RootConstrainSelectedInstOperands,
     /*  906152 */     // GIR_Coverage, 64523,
     /*  906152 */     GIR_EraseRootFromParent_Done,
     /*  906153 */   // Label 13824: @906153
     /*  906153 */   GIM_Reject,
     /*  906154 */ // Label 6978: @906154
     /*  906154 */ GIM_Try, /*On fail goto*//*Label 13825*/ GIMT_Encode4(1401705),
     /*  906159 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  906162 */   GIM_Try, /*On fail goto*//*Label 13826*/ GIMT_Encode4(906245), // Rule ID 62855 //
     /*  906167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  906178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  906184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906191 */     // MIs[0] op1
     /*  906191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906207 */     // MIs[0] op4
     /*  906207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906210 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906222 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  906225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906227 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906229 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906231 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906233 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906243 */     GIR_RootConstrainSelectedInstOperands,
     /*  906244 */     // GIR_Coverage, 62855,
     /*  906244 */     GIR_EraseRootFromParent_Done,
     /*  906245 */   // Label 13826: @906245
     /*  906245 */   GIM_Try, /*On fail goto*//*Label 13827*/ GIMT_Encode4(906328), // Rule ID 62856 //
     /*  906250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  906261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  906264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  906267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906274 */     // MIs[0] op1
     /*  906274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906290 */     // MIs[0] op4
     /*  906290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906293 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906305 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  906308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906310 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906312 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906314 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906316 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906326 */     GIR_RootConstrainSelectedInstOperands,
     /*  906327 */     // GIR_Coverage, 62856,
     /*  906327 */     GIR_EraseRootFromParent_Done,
     /*  906328 */   // Label 13827: @906328
     /*  906328 */   GIM_Try, /*On fail goto*//*Label 13828*/ GIMT_Encode4(906411), // Rule ID 62899 //
     /*  906333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  906344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  906350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906357 */     // MIs[0] op1
     /*  906357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906373 */     // MIs[0] op4
     /*  906373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  906391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906393 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906395 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906397 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906399 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906409 */     GIR_RootConstrainSelectedInstOperands,
     /*  906410 */     // GIR_Coverage, 62899,
     /*  906410 */     GIR_EraseRootFromParent_Done,
     /*  906411 */   // Label 13828: @906411
     /*  906411 */   GIM_Try, /*On fail goto*//*Label 13829*/ GIMT_Encode4(906494), // Rule ID 62900 //
     /*  906416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  906427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  906430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  906433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906440 */     // MIs[0] op1
     /*  906440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906456 */     // MIs[0] op4
     /*  906456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906471 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  906474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906476 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906478 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906480 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906482 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906492 */     GIR_RootConstrainSelectedInstOperands,
     /*  906493 */     // GIR_Coverage, 62900,
     /*  906493 */     GIR_EraseRootFromParent_Done,
     /*  906494 */   // Label 13829: @906494
     /*  906494 */   GIM_Try, /*On fail goto*//*Label 13830*/ GIMT_Encode4(906577), // Rule ID 62943 //
     /*  906499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  906510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  906516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906523 */     // MIs[0] op1
     /*  906523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906539 */     // MIs[0] op4
     /*  906539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906554 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906559 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906561 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906563 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906565 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906575 */     GIR_RootConstrainSelectedInstOperands,
     /*  906576 */     // GIR_Coverage, 62943,
     /*  906576 */     GIR_EraseRootFromParent_Done,
     /*  906577 */   // Label 13830: @906577
     /*  906577 */   GIM_Try, /*On fail goto*//*Label 13831*/ GIMT_Encode4(906660), // Rule ID 62944 //
     /*  906582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  906593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  906599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906606 */     // MIs[0] op1
     /*  906606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906622 */     // MIs[0] op4
     /*  906622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906637 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906642 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906644 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906646 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906648 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906658 */     GIR_RootConstrainSelectedInstOperands,
     /*  906659 */     // GIR_Coverage, 62944,
     /*  906659 */     GIR_EraseRootFromParent_Done,
     /*  906660 */   // Label 13831: @906660
     /*  906660 */   GIM_Try, /*On fail goto*//*Label 13832*/ GIMT_Encode4(906743), // Rule ID 62987 //
     /*  906665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  906682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906689 */     // MIs[0] op1
     /*  906689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906705 */     // MIs[0] op4
     /*  906705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906720 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  906720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  906723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906725 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906727 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906729 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906731 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906741 */     GIR_RootConstrainSelectedInstOperands,
     /*  906742 */     // GIR_Coverage, 62987,
     /*  906742 */     GIR_EraseRootFromParent_Done,
     /*  906743 */   // Label 13832: @906743
     /*  906743 */   GIM_Try, /*On fail goto*//*Label 13833*/ GIMT_Encode4(906826), // Rule ID 62988 //
     /*  906748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  906765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906772 */     // MIs[0] op1
     /*  906772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906788 */     // MIs[0] op4
     /*  906788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906791 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906803 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  906803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  906806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906808 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906810 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906812 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906814 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906824 */     GIR_RootConstrainSelectedInstOperands,
     /*  906825 */     // GIR_Coverage, 62988,
     /*  906825 */     GIR_EraseRootFromParent_Done,
     /*  906826 */   // Label 13833: @906826
     /*  906826 */   GIM_Try, /*On fail goto*//*Label 13834*/ GIMT_Encode4(906909), // Rule ID 63043 //
     /*  906831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  906848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906855 */     // MIs[0] op1
     /*  906855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906871 */     // MIs[0] op4
     /*  906871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906874 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906886 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  906886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906891 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906893 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906895 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906897 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906907 */     GIR_RootConstrainSelectedInstOperands,
     /*  906908 */     // GIR_Coverage, 63043,
     /*  906908 */     GIR_EraseRootFromParent_Done,
     /*  906909 */   // Label 13834: @906909
     /*  906909 */   GIM_Try, /*On fail goto*//*Label 13835*/ GIMT_Encode4(906992), // Rule ID 63044 //
     /*  906914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  906931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906938 */     // MIs[0] op1
     /*  906938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906954 */     // MIs[0] op4
     /*  906954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906969 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  906969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906974 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906976 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906978 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906980 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906990 */     GIR_RootConstrainSelectedInstOperands,
     /*  906991 */     // GIR_Coverage, 63044,
     /*  906991 */     GIR_EraseRootFromParent_Done,
     /*  906992 */   // Label 13835: @906992
     /*  906992 */   GIM_Try, /*On fail goto*//*Label 13836*/ GIMT_Encode4(907075), // Rule ID 63099 //
     /*  906997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  907014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907021 */     // MIs[0] op1
     /*  907021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907037 */     // MIs[0] op4
     /*  907037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907040 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907052 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  907052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  907055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907057 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907059 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907061 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907063 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907073 */     GIR_RootConstrainSelectedInstOperands,
     /*  907074 */     // GIR_Coverage, 63099,
     /*  907074 */     GIR_EraseRootFromParent_Done,
     /*  907075 */   // Label 13836: @907075
     /*  907075 */   GIM_Try, /*On fail goto*//*Label 13837*/ GIMT_Encode4(907158), // Rule ID 63100 //
     /*  907080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  907091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  907094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  907097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907104 */     // MIs[0] op1
     /*  907104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907120 */     // MIs[0] op4
     /*  907120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907135 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  907135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  907138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907140 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907142 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907144 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907146 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907156 */     GIR_RootConstrainSelectedInstOperands,
     /*  907157 */     // GIR_Coverage, 63100,
     /*  907157 */     GIR_EraseRootFromParent_Done,
     /*  907158 */   // Label 13837: @907158
     /*  907158 */   GIM_Try, /*On fail goto*//*Label 13838*/ GIMT_Encode4(907241), // Rule ID 63155 //
     /*  907163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  907174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  907177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  907180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907187 */     // MIs[0] op1
     /*  907187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907203 */     // MIs[0] op4
     /*  907203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907218 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907223 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907225 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907227 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907229 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907239 */     GIR_RootConstrainSelectedInstOperands,
     /*  907240 */     // GIR_Coverage, 63155,
     /*  907240 */     GIR_EraseRootFromParent_Done,
     /*  907241 */   // Label 13838: @907241
     /*  907241 */   GIM_Try, /*On fail goto*//*Label 13839*/ GIMT_Encode4(907324), // Rule ID 63156 //
     /*  907246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  907257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  907260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  907263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907270 */     // MIs[0] op1
     /*  907270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907286 */     // MIs[0] op4
     /*  907286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907301 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907306 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907308 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907310 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907312 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907322 */     GIR_RootConstrainSelectedInstOperands,
     /*  907323 */     // GIR_Coverage, 63156,
     /*  907323 */     GIR_EraseRootFromParent_Done,
     /*  907324 */   // Label 13839: @907324
     /*  907324 */   GIM_Try, /*On fail goto*//*Label 13840*/ GIMT_Encode4(907407), // Rule ID 63199 //
     /*  907329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  907340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  907346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907353 */     // MIs[0] op1
     /*  907353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907369 */     // MIs[0] op4
     /*  907369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  907384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907389 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907391 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907393 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907395 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907405 */     GIR_RootConstrainSelectedInstOperands,
     /*  907406 */     // GIR_Coverage, 63199,
     /*  907406 */     GIR_EraseRootFromParent_Done,
     /*  907407 */   // Label 13840: @907407
     /*  907407 */   GIM_Try, /*On fail goto*//*Label 13841*/ GIMT_Encode4(907490), // Rule ID 63200 //
     /*  907412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  907423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  907426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  907429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907436 */     // MIs[0] op1
     /*  907436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907452 */     // MIs[0] op4
     /*  907452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907455 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907467 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  907467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907472 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907474 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907476 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907478 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907488 */     GIR_RootConstrainSelectedInstOperands,
     /*  907489 */     // GIR_Coverage, 63200,
     /*  907489 */     GIR_EraseRootFromParent_Done,
     /*  907490 */   // Label 13841: @907490
     /*  907490 */   GIM_Try, /*On fail goto*//*Label 13842*/ GIMT_Encode4(907573), // Rule ID 63255 //
     /*  907495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  907506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  907509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  907512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907519 */     // MIs[0] op1
     /*  907519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907535 */     // MIs[0] op4
     /*  907535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  907550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907555 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907557 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907559 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907561 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907571 */     GIR_RootConstrainSelectedInstOperands,
     /*  907572 */     // GIR_Coverage, 63255,
     /*  907572 */     GIR_EraseRootFromParent_Done,
     /*  907573 */   // Label 13842: @907573
     /*  907573 */   GIM_Try, /*On fail goto*//*Label 13843*/ GIMT_Encode4(907656), // Rule ID 63256 //
     /*  907578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  907589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  907592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  907595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907602 */     // MIs[0] op1
     /*  907602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907618 */     // MIs[0] op4
     /*  907618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  907633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907638 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907640 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907642 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907644 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907654 */     GIR_RootConstrainSelectedInstOperands,
     /*  907655 */     // GIR_Coverage, 63256,
     /*  907655 */     GIR_EraseRootFromParent_Done,
     /*  907656 */   // Label 13843: @907656
     /*  907656 */   GIM_Try, /*On fail goto*//*Label 13844*/ GIMT_Encode4(907739), // Rule ID 63311 //
     /*  907661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  907675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  907678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907685 */     // MIs[0] op1
     /*  907685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907701 */     // MIs[0] op4
     /*  907701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907716 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  907716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907721 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907723 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907725 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907727 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907737 */     GIR_RootConstrainSelectedInstOperands,
     /*  907738 */     // GIR_Coverage, 63311,
     /*  907738 */     GIR_EraseRootFromParent_Done,
     /*  907739 */   // Label 13844: @907739
     /*  907739 */   GIM_Try, /*On fail goto*//*Label 13845*/ GIMT_Encode4(907822), // Rule ID 63312 //
     /*  907744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  907758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  907761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907768 */     // MIs[0] op1
     /*  907768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907784 */     // MIs[0] op4
     /*  907784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907787 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907799 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  907799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907804 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907806 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907808 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907810 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907820 */     GIR_RootConstrainSelectedInstOperands,
     /*  907821 */     // GIR_Coverage, 63312,
     /*  907821 */     GIR_EraseRootFromParent_Done,
     /*  907822 */   // Label 13845: @907822
     /*  907822 */   GIM_Try, /*On fail goto*//*Label 13846*/ GIMT_Encode4(907905), // Rule ID 63367 //
     /*  907827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  907844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907851 */     // MIs[0] op1
     /*  907851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907867 */     // MIs[0] op4
     /*  907867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907882 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  907885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907887 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907889 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907891 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907893 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907903 */     GIR_RootConstrainSelectedInstOperands,
     /*  907904 */     // GIR_Coverage, 63367,
     /*  907904 */     GIR_EraseRootFromParent_Done,
     /*  907905 */   // Label 13846: @907905
     /*  907905 */   GIM_Try, /*On fail goto*//*Label 13847*/ GIMT_Encode4(907988), // Rule ID 63368 //
     /*  907910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  907927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907934 */     // MIs[0] op1
     /*  907934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907950 */     // MIs[0] op4
     /*  907950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907965 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  907968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907970 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907972 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907974 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907976 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907986 */     GIR_RootConstrainSelectedInstOperands,
     /*  907987 */     // GIR_Coverage, 63368,
     /*  907987 */     GIR_EraseRootFromParent_Done,
     /*  907988 */   // Label 13847: @907988
     /*  907988 */   GIM_Try, /*On fail goto*//*Label 13848*/ GIMT_Encode4(908071), // Rule ID 63411 //
     /*  907993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  908004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  908007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  908010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908017 */     // MIs[0] op1
     /*  908017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908033 */     // MIs[0] op4
     /*  908033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908048 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  908051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908053 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908055 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908057 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908059 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908069 */     GIR_RootConstrainSelectedInstOperands,
     /*  908070 */     // GIR_Coverage, 63411,
     /*  908070 */     GIR_EraseRootFromParent_Done,
     /*  908071 */   // Label 13848: @908071
     /*  908071 */   GIM_Try, /*On fail goto*//*Label 13849*/ GIMT_Encode4(908154), // Rule ID 63412 //
     /*  908076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  908087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  908090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  908093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908100 */     // MIs[0] op1
     /*  908100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908116 */     // MIs[0] op4
     /*  908116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908131 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  908134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908136 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908138 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908140 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908142 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908152 */     GIR_RootConstrainSelectedInstOperands,
     /*  908153 */     // GIR_Coverage, 63412,
     /*  908153 */     GIR_EraseRootFromParent_Done,
     /*  908154 */   // Label 13849: @908154
     /*  908154 */   GIM_Try, /*On fail goto*//*Label 13850*/ GIMT_Encode4(908237), // Rule ID 63455 //
     /*  908159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  908170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  908173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  908176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908183 */     // MIs[0] op1
     /*  908183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908199 */     // MIs[0] op4
     /*  908199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908214 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  908214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  908217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908219 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908221 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908223 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908225 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908235 */     GIR_RootConstrainSelectedInstOperands,
     /*  908236 */     // GIR_Coverage, 63455,
     /*  908236 */     GIR_EraseRootFromParent_Done,
     /*  908237 */   // Label 13850: @908237
     /*  908237 */   GIM_Try, /*On fail goto*//*Label 13851*/ GIMT_Encode4(908320), // Rule ID 63456 //
     /*  908242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  908253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  908256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  908259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908266 */     // MIs[0] op1
     /*  908266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908282 */     // MIs[0] op4
     /*  908282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908297 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  908297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  908300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908302 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908304 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908306 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908308 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  908318 */     GIR_RootConstrainSelectedInstOperands,
     /*  908319 */     // GIR_Coverage, 63456,
     /*  908319 */     GIR_EraseRootFromParent_Done,
     /*  908320 */   // Label 13851: @908320
     /*  908320 */   GIM_Try, /*On fail goto*//*Label 13852*/ GIMT_Encode4(908403), // Rule ID 63499 //
     /*  908325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  908336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  908339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  908342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908349 */     // MIs[0] op1
     /*  908349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908365 */     // MIs[0] op4
     /*  908365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908380 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  908383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908385 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908387 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908389 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908391 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908401 */     GIR_RootConstrainSelectedInstOperands,
     /*  908402 */     // GIR_Coverage, 63499,
     /*  908402 */     GIR_EraseRootFromParent_Done,
     /*  908403 */   // Label 13852: @908403
     /*  908403 */   GIM_Try, /*On fail goto*//*Label 13853*/ GIMT_Encode4(908486), // Rule ID 63500 //
     /*  908408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  908419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  908422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  908425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908432 */     // MIs[0] op1
     /*  908432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908448 */     // MIs[0] op4
     /*  908448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  908466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908468 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908470 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908472 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908474 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908484 */     GIR_RootConstrainSelectedInstOperands,
     /*  908485 */     // GIR_Coverage, 63500,
     /*  908485 */     GIR_EraseRootFromParent_Done,
     /*  908486 */   // Label 13853: @908486
     /*  908486 */   GIM_Try, /*On fail goto*//*Label 13854*/ GIMT_Encode4(908569), // Rule ID 63555 //
     /*  908491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  908502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  908505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  908508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908515 */     // MIs[0] op1
     /*  908515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908518 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908531 */     // MIs[0] op4
     /*  908531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  908549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908551 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908553 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908555 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908557 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908567 */     GIR_RootConstrainSelectedInstOperands,
     /*  908568 */     // GIR_Coverage, 63555,
     /*  908568 */     GIR_EraseRootFromParent_Done,
     /*  908569 */   // Label 13854: @908569
     /*  908569 */   GIM_Try, /*On fail goto*//*Label 13855*/ GIMT_Encode4(908652), // Rule ID 63556 //
     /*  908574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  908585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  908588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  908591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908598 */     // MIs[0] op1
     /*  908598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908614 */     // MIs[0] op4
     /*  908614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908629 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  908632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908634 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908636 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908638 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908640 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908650 */     GIR_RootConstrainSelectedInstOperands,
     /*  908651 */     // GIR_Coverage, 63556,
     /*  908651 */     GIR_EraseRootFromParent_Done,
     /*  908652 */   // Label 13855: @908652
     /*  908652 */   GIM_Try, /*On fail goto*//*Label 13856*/ GIMT_Encode4(908735), // Rule ID 63611 //
     /*  908657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  908668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  908671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  908674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908681 */     // MIs[0] op1
     /*  908681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908697 */     // MIs[0] op4
     /*  908697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  908715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908717 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908719 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908721 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908723 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908733 */     GIR_RootConstrainSelectedInstOperands,
     /*  908734 */     // GIR_Coverage, 63611,
     /*  908734 */     GIR_EraseRootFromParent_Done,
     /*  908735 */   // Label 13856: @908735
     /*  908735 */   GIM_Try, /*On fail goto*//*Label 13857*/ GIMT_Encode4(908818), // Rule ID 63612 //
     /*  908740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  908751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  908754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  908757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908764 */     // MIs[0] op1
     /*  908764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908767 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908780 */     // MIs[0] op4
     /*  908780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908795 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  908798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908800 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908802 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908804 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908806 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908816 */     GIR_RootConstrainSelectedInstOperands,
     /*  908817 */     // GIR_Coverage, 63612,
     /*  908817 */     GIR_EraseRootFromParent_Done,
     /*  908818 */   // Label 13857: @908818
     /*  908818 */   GIM_Try, /*On fail goto*//*Label 13858*/ GIMT_Encode4(908901), // Rule ID 63667 //
     /*  908823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  908840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908847 */     // MIs[0] op1
     /*  908847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908863 */     // MIs[0] op4
     /*  908863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  908878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  908881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908883 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908885 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908887 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908889 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908899 */     GIR_RootConstrainSelectedInstOperands,
     /*  908900 */     // GIR_Coverage, 63667,
     /*  908900 */     GIR_EraseRootFromParent_Done,
     /*  908901 */   // Label 13858: @908901
     /*  908901 */   GIM_Try, /*On fail goto*//*Label 13859*/ GIMT_Encode4(908984), // Rule ID 63668 //
     /*  908906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  908923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908930 */     // MIs[0] op1
     /*  908930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908933 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908946 */     // MIs[0] op4
     /*  908946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908961 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  908961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  908964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908966 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908968 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908970 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908972 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908982 */     GIR_RootConstrainSelectedInstOperands,
     /*  908983 */     // GIR_Coverage, 63668,
     /*  908983 */     GIR_EraseRootFromParent_Done,
     /*  908984 */   // Label 13859: @908984
     /*  908984 */   GIM_Try, /*On fail goto*//*Label 13860*/ GIMT_Encode4(909067), // Rule ID 63723 //
     /*  908989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909013 */     // MIs[0] op1
     /*  909013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909029 */     // MIs[0] op4
     /*  909029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909032 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  909047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909049 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909051 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909053 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909055 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909065 */     GIR_RootConstrainSelectedInstOperands,
     /*  909066 */     // GIR_Coverage, 63723,
     /*  909066 */     GIR_EraseRootFromParent_Done,
     /*  909067 */   // Label 13860: @909067
     /*  909067 */   GIM_Try, /*On fail goto*//*Label 13861*/ GIMT_Encode4(909150), // Rule ID 63724 //
     /*  909072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  909083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  909086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  909089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909096 */     // MIs[0] op1
     /*  909096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909112 */     // MIs[0] op4
     /*  909112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909115 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909127 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  909130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909132 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909134 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909136 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909138 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909148 */     GIR_RootConstrainSelectedInstOperands,
     /*  909149 */     // GIR_Coverage, 63724,
     /*  909149 */     GIR_EraseRootFromParent_Done,
     /*  909150 */   // Label 13861: @909150
     /*  909150 */   GIM_Try, /*On fail goto*//*Label 13862*/ GIMT_Encode4(909233), // Rule ID 63779 //
     /*  909155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909179 */     // MIs[0] op1
     /*  909179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909195 */     // MIs[0] op4
     /*  909195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  909210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  909213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909215 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909217 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909219 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909221 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909231 */     GIR_RootConstrainSelectedInstOperands,
     /*  909232 */     // GIR_Coverage, 63779,
     /*  909232 */     GIR_EraseRootFromParent_Done,
     /*  909233 */   // Label 13862: @909233
     /*  909233 */   GIM_Try, /*On fail goto*//*Label 13863*/ GIMT_Encode4(909316), // Rule ID 63780 //
     /*  909238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  909249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  909252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  909255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909262 */     // MIs[0] op1
     /*  909262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909278 */     // MIs[0] op4
     /*  909278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909293 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  909293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  909296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909298 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909300 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909302 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909304 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  909314 */     GIR_RootConstrainSelectedInstOperands,
     /*  909315 */     // GIR_Coverage, 63780,
     /*  909315 */     GIR_EraseRootFromParent_Done,
     /*  909316 */   // Label 13863: @909316
     /*  909316 */   GIM_Try, /*On fail goto*//*Label 13864*/ GIMT_Encode4(909399), // Rule ID 63835 //
     /*  909321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  909335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  909338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909345 */     // MIs[0] op1
     /*  909345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909361 */     // MIs[0] op4
     /*  909361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  909379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909381 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909383 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909385 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909387 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909397 */     GIR_RootConstrainSelectedInstOperands,
     /*  909398 */     // GIR_Coverage, 63835,
     /*  909398 */     GIR_EraseRootFromParent_Done,
     /*  909399 */   // Label 13864: @909399
     /*  909399 */   GIM_Try, /*On fail goto*//*Label 13865*/ GIMT_Encode4(909482), // Rule ID 63836 //
     /*  909404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  909415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  909418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  909421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909428 */     // MIs[0] op1
     /*  909428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909431 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909444 */     // MIs[0] op4
     /*  909444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909459 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  909462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909464 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909466 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909468 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909470 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909480 */     GIR_RootConstrainSelectedInstOperands,
     /*  909481 */     // GIR_Coverage, 63836,
     /*  909481 */     GIR_EraseRootFromParent_Done,
     /*  909482 */   // Label 13865: @909482
     /*  909482 */   GIM_Try, /*On fail goto*//*Label 13866*/ GIMT_Encode4(909565), // Rule ID 63891 //
     /*  909487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  909498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  909501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  909504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909511 */     // MIs[0] op1
     /*  909511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909527 */     // MIs[0] op4
     /*  909527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909542 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  909545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909547 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909549 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909551 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909553 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909563 */     GIR_RootConstrainSelectedInstOperands,
     /*  909564 */     // GIR_Coverage, 63891,
     /*  909564 */     GIR_EraseRootFromParent_Done,
     /*  909565 */   // Label 13866: @909565
     /*  909565 */   GIM_Try, /*On fail goto*//*Label 13867*/ GIMT_Encode4(909648), // Rule ID 63892 //
     /*  909570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  909581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  909584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  909587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909594 */     // MIs[0] op1
     /*  909594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909610 */     // MIs[0] op4
     /*  909610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909625 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  909628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909630 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909632 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909634 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909636 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909646 */     GIR_RootConstrainSelectedInstOperands,
     /*  909647 */     // GIR_Coverage, 63892,
     /*  909647 */     GIR_EraseRootFromParent_Done,
     /*  909648 */   // Label 13867: @909648
     /*  909648 */   GIM_Try, /*On fail goto*//*Label 13868*/ GIMT_Encode4(909731), // Rule ID 63947 //
     /*  909653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  909664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  909667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  909670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909677 */     // MIs[0] op1
     /*  909677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909680 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909693 */     // MIs[0] op4
     /*  909693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909708 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11071:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  909711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909713 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909715 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909717 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909719 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909729 */     GIR_RootConstrainSelectedInstOperands,
     /*  909730 */     // GIR_Coverage, 63947,
     /*  909730 */     GIR_EraseRootFromParent_Done,
     /*  909731 */   // Label 13868: @909731
     /*  909731 */   GIM_Try, /*On fail goto*//*Label 13869*/ GIMT_Encode4(909814), // Rule ID 63948 //
     /*  909736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  909747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  909750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  909753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909760 */     // MIs[0] op1
     /*  909760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909776 */     // MIs[0] op4
     /*  909776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909791 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11071:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  909794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909796 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909798 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909800 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909802 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909812 */     GIR_RootConstrainSelectedInstOperands,
     /*  909813 */     // GIR_Coverage, 63948,
     /*  909813 */     GIR_EraseRootFromParent_Done,
     /*  909814 */   // Label 13869: @909814
     /*  909814 */   GIM_Try, /*On fail goto*//*Label 13870*/ GIMT_Encode4(909897), // Rule ID 63977 //
     /*  909819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  909830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  909833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  909836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909843 */     // MIs[0] op1
     /*  909843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909846 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909859 */     // MIs[0] op4
     /*  909859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909874 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  909874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  909877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909879 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909881 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909883 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909885 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909895 */     GIR_RootConstrainSelectedInstOperands,
     /*  909896 */     // GIR_Coverage, 63977,
     /*  909896 */     GIR_EraseRootFromParent_Done,
     /*  909897 */   // Label 13870: @909897
     /*  909897 */   GIM_Try, /*On fail goto*//*Label 13871*/ GIMT_Encode4(909980), // Rule ID 63978 //
     /*  909902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  909913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  909916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  909919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909926 */     // MIs[0] op1
     /*  909926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909942 */     // MIs[0] op4
     /*  909942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909957 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  909957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  909960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909962 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909964 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909966 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909968 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909978 */     GIR_RootConstrainSelectedInstOperands,
     /*  909979 */     // GIR_Coverage, 63978,
     /*  909979 */     GIR_EraseRootFromParent_Done,
     /*  909980 */   // Label 13871: @909980
     /*  909980 */   GIM_Try, /*On fail goto*//*Label 13872*/ GIMT_Encode4(910063), // Rule ID 63995 //
     /*  909985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  909996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  909999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910009 */     // MIs[0] op1
     /*  910009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910025 */     // MIs[0] op4
     /*  910025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910040 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  910043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910045 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910047 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910049 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910051 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910061 */     GIR_RootConstrainSelectedInstOperands,
     /*  910062 */     // GIR_Coverage, 63995,
     /*  910062 */     GIR_EraseRootFromParent_Done,
     /*  910063 */   // Label 13872: @910063
     /*  910063 */   GIM_Try, /*On fail goto*//*Label 13873*/ GIMT_Encode4(910146), // Rule ID 63996 //
     /*  910068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  910079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  910082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  910085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910092 */     // MIs[0] op1
     /*  910092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910108 */     // MIs[0] op4
     /*  910108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910111 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910123 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  910126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910128 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910130 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910132 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910134 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910144 */     GIR_RootConstrainSelectedInstOperands,
     /*  910145 */     // GIR_Coverage, 63996,
     /*  910145 */     GIR_EraseRootFromParent_Done,
     /*  910146 */   // Label 13873: @910146
     /*  910146 */   GIM_Try, /*On fail goto*//*Label 13874*/ GIMT_Encode4(910229), // Rule ID 64013 //
     /*  910151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  910162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  910165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910175 */     // MIs[0] op1
     /*  910175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910191 */     // MIs[0] op4
     /*  910191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  910209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910211 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910213 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910215 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910217 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910227 */     GIR_RootConstrainSelectedInstOperands,
     /*  910228 */     // GIR_Coverage, 64013,
     /*  910228 */     GIR_EraseRootFromParent_Done,
     /*  910229 */   // Label 13874: @910229
     /*  910229 */   GIM_Try, /*On fail goto*//*Label 13875*/ GIMT_Encode4(910312), // Rule ID 64014 //
     /*  910234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  910245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  910248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  910251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910258 */     // MIs[0] op1
     /*  910258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910274 */     // MIs[0] op4
     /*  910274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910289 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  910292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910294 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910296 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910298 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910300 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910310 */     GIR_RootConstrainSelectedInstOperands,
     /*  910311 */     // GIR_Coverage, 64014,
     /*  910311 */     GIR_EraseRootFromParent_Done,
     /*  910312 */   // Label 13875: @910312
     /*  910312 */   GIM_Try, /*On fail goto*//*Label 13876*/ GIMT_Encode4(910395), // Rule ID 64031 //
     /*  910317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  910328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  910331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  910334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910341 */     // MIs[0] op1
     /*  910341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910357 */     // MIs[0] op4
     /*  910357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910372 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  910375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910377 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910379 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910381 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910383 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910393 */     GIR_RootConstrainSelectedInstOperands,
     /*  910394 */     // GIR_Coverage, 64031,
     /*  910394 */     GIR_EraseRootFromParent_Done,
     /*  910395 */   // Label 13876: @910395
     /*  910395 */   GIM_Try, /*On fail goto*//*Label 13877*/ GIMT_Encode4(910478), // Rule ID 64032 //
     /*  910400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  910411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  910414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  910417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910424 */     // MIs[0] op1
     /*  910424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910440 */     // MIs[0] op4
     /*  910440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910455 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  910458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910460 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910462 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910464 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910466 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910476 */     GIR_RootConstrainSelectedInstOperands,
     /*  910477 */     // GIR_Coverage, 64032,
     /*  910477 */     GIR_EraseRootFromParent_Done,
     /*  910478 */   // Label 13877: @910478
     /*  910478 */   GIM_Try, /*On fail goto*//*Label 13878*/ GIMT_Encode4(910561), // Rule ID 64049 //
     /*  910483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  910494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  910497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  910500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910507 */     // MIs[0] op1
     /*  910507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910523 */     // MIs[0] op4
     /*  910523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910538 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  910541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910543 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910545 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910547 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910549 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910559 */     GIR_RootConstrainSelectedInstOperands,
     /*  910560 */     // GIR_Coverage, 64049,
     /*  910560 */     GIR_EraseRootFromParent_Done,
     /*  910561 */   // Label 13878: @910561
     /*  910561 */   GIM_Try, /*On fail goto*//*Label 13879*/ GIMT_Encode4(910644), // Rule ID 64050 //
     /*  910566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  910577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  910580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  910583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910590 */     // MIs[0] op1
     /*  910590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910593 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910606 */     // MIs[0] op4
     /*  910606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910609 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910621 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  910624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910626 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910628 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910630 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910632 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910642 */     GIR_RootConstrainSelectedInstOperands,
     /*  910643 */     // GIR_Coverage, 64050,
     /*  910643 */     GIR_EraseRootFromParent_Done,
     /*  910644 */   // Label 13879: @910644
     /*  910644 */   GIM_Try, /*On fail goto*//*Label 13880*/ GIMT_Encode4(910727), // Rule ID 64067 //
     /*  910649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  910660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  910663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  910666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910673 */     // MIs[0] op1
     /*  910673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910689 */     // MIs[0] op4
     /*  910689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910692 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910704 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  910707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910709 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910711 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910713 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910715 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910725 */     GIR_RootConstrainSelectedInstOperands,
     /*  910726 */     // GIR_Coverage, 64067,
     /*  910726 */     GIR_EraseRootFromParent_Done,
     /*  910727 */   // Label 13880: @910727
     /*  910727 */   GIM_Try, /*On fail goto*//*Label 13881*/ GIMT_Encode4(910810), // Rule ID 64068 //
     /*  910732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  910743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  910746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  910749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910756 */     // MIs[0] op1
     /*  910756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910772 */     // MIs[0] op4
     /*  910772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910775 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910787 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  910790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910792 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910794 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910796 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910798 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910808 */     GIR_RootConstrainSelectedInstOperands,
     /*  910809 */     // GIR_Coverage, 64068,
     /*  910809 */     GIR_EraseRootFromParent_Done,
     /*  910810 */   // Label 13881: @910810
     /*  910810 */   GIM_Try, /*On fail goto*//*Label 13882*/ GIMT_Encode4(910893), // Rule ID 64085 //
     /*  910815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910839 */     // MIs[0] op1
     /*  910839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910855 */     // MIs[0] op4
     /*  910855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  910873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910875 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910877 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910879 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910881 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910891 */     GIR_RootConstrainSelectedInstOperands,
     /*  910892 */     // GIR_Coverage, 64085,
     /*  910892 */     GIR_EraseRootFromParent_Done,
     /*  910893 */   // Label 13882: @910893
     /*  910893 */   GIM_Try, /*On fail goto*//*Label 13883*/ GIMT_Encode4(910976), // Rule ID 64086 //
     /*  910898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910922 */     // MIs[0] op1
     /*  910922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910938 */     // MIs[0] op4
     /*  910938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910953 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  910956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910958 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910960 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910962 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910964 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910974 */     GIR_RootConstrainSelectedInstOperands,
     /*  910975 */     // GIR_Coverage, 64086,
     /*  910975 */     GIR_EraseRootFromParent_Done,
     /*  910976 */   // Label 13883: @910976
     /*  910976 */   GIM_Try, /*On fail goto*//*Label 13884*/ GIMT_Encode4(911059), // Rule ID 64109 //
     /*  910981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  910992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  910995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  910998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911005 */     // MIs[0] op1
     /*  911005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911008 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911021 */     // MIs[0] op4
     /*  911021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  911039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911041 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911043 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911045 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911047 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911057 */     GIR_RootConstrainSelectedInstOperands,
     /*  911058 */     // GIR_Coverage, 64109,
     /*  911058 */     GIR_EraseRootFromParent_Done,
     /*  911059 */   // Label 13884: @911059
     /*  911059 */   GIM_Try, /*On fail goto*//*Label 13885*/ GIMT_Encode4(911142), // Rule ID 64110 //
     /*  911064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  911081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911088 */     // MIs[0] op1
     /*  911088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911104 */     // MIs[0] op4
     /*  911104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911119 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  911122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911124 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911126 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911128 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911130 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911140 */     GIR_RootConstrainSelectedInstOperands,
     /*  911141 */     // GIR_Coverage, 64110,
     /*  911141 */     GIR_EraseRootFromParent_Done,
     /*  911142 */   // Label 13885: @911142
     /*  911142 */   GIM_Try, /*On fail goto*//*Label 13886*/ GIMT_Encode4(911225), // Rule ID 64133 //
     /*  911147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  911158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  911161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911171 */     // MIs[0] op1
     /*  911171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911187 */     // MIs[0] op4
     /*  911187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911190 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  911205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911207 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911209 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911211 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911213 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911223 */     GIR_RootConstrainSelectedInstOperands,
     /*  911224 */     // GIR_Coverage, 64133,
     /*  911224 */     GIR_EraseRootFromParent_Done,
     /*  911225 */   // Label 13886: @911225
     /*  911225 */   GIM_Try, /*On fail goto*//*Label 13887*/ GIMT_Encode4(911308), // Rule ID 64134 //
     /*  911230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  911241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  911244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  911247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911254 */     // MIs[0] op1
     /*  911254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911270 */     // MIs[0] op4
     /*  911270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911285 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  911288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911290 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911292 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911294 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911296 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911306 */     GIR_RootConstrainSelectedInstOperands,
     /*  911307 */     // GIR_Coverage, 64134,
     /*  911307 */     GIR_EraseRootFromParent_Done,
     /*  911308 */   // Label 13887: @911308
     /*  911308 */   GIM_Try, /*On fail goto*//*Label 13888*/ GIMT_Encode4(911391), // Rule ID 64157 //
     /*  911313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  911324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  911327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  911330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911337 */     // MIs[0] op1
     /*  911337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911353 */     // MIs[0] op4
     /*  911353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911356 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  911371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911373 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911375 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911377 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911379 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911389 */     GIR_RootConstrainSelectedInstOperands,
     /*  911390 */     // GIR_Coverage, 64157,
     /*  911390 */     GIR_EraseRootFromParent_Done,
     /*  911391 */   // Label 13888: @911391
     /*  911391 */   GIM_Try, /*On fail goto*//*Label 13889*/ GIMT_Encode4(911474), // Rule ID 64158 //
     /*  911396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  911407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  911410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  911413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911420 */     // MIs[0] op1
     /*  911420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911423 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911436 */     // MIs[0] op4
     /*  911436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911439 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911451 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  911454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911456 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911458 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911460 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911462 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911472 */     GIR_RootConstrainSelectedInstOperands,
     /*  911473 */     // GIR_Coverage, 64158,
     /*  911473 */     GIR_EraseRootFromParent_Done,
     /*  911474 */   // Label 13889: @911474
     /*  911474 */   GIM_Try, /*On fail goto*//*Label 13890*/ GIMT_Encode4(911557), // Rule ID 64181 //
     /*  911479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  911490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  911493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  911496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911503 */     // MIs[0] op1
     /*  911503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911519 */     // MIs[0] op4
     /*  911519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  911537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911539 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911541 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911543 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911545 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911555 */     GIR_RootConstrainSelectedInstOperands,
     /*  911556 */     // GIR_Coverage, 64181,
     /*  911556 */     GIR_EraseRootFromParent_Done,
     /*  911557 */   // Label 13890: @911557
     /*  911557 */   GIM_Try, /*On fail goto*//*Label 13891*/ GIMT_Encode4(911640), // Rule ID 64182 //
     /*  911562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  911573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  911576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  911579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911586 */     // MIs[0] op1
     /*  911586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911589 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911602 */     // MIs[0] op4
     /*  911602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911617 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  911620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911622 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911624 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911626 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911628 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911638 */     GIR_RootConstrainSelectedInstOperands,
     /*  911639 */     // GIR_Coverage, 64182,
     /*  911639 */     GIR_EraseRootFromParent_Done,
     /*  911640 */   // Label 13891: @911640
     /*  911640 */   GIM_Try, /*On fail goto*//*Label 13892*/ GIMT_Encode4(911723), // Rule ID 64205 //
     /*  911645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  911662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911669 */     // MIs[0] op1
     /*  911669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911685 */     // MIs[0] op4
     /*  911685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  911703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911705 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911707 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911709 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911711 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911721 */     GIR_RootConstrainSelectedInstOperands,
     /*  911722 */     // GIR_Coverage, 64205,
     /*  911722 */     GIR_EraseRootFromParent_Done,
     /*  911723 */   // Label 13892: @911723
     /*  911723 */   GIM_Try, /*On fail goto*//*Label 13893*/ GIMT_Encode4(911806), // Rule ID 64206 //
     /*  911728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  911745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911752 */     // MIs[0] op1
     /*  911752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911755 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911768 */     // MIs[0] op4
     /*  911768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911783 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  911786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911788 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911790 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911792 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911794 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911804 */     GIR_RootConstrainSelectedInstOperands,
     /*  911805 */     // GIR_Coverage, 64206,
     /*  911805 */     GIR_EraseRootFromParent_Done,
     /*  911806 */   // Label 13893: @911806
     /*  911806 */   GIM_Try, /*On fail goto*//*Label 13894*/ GIMT_Encode4(911889), // Rule ID 64229 //
     /*  911811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  911822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  911825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911835 */     // MIs[0] op1
     /*  911835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911838 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911851 */     // MIs[0] op4
     /*  911851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911854 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  911869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911871 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911873 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911875 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911877 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911887 */     GIR_RootConstrainSelectedInstOperands,
     /*  911888 */     // GIR_Coverage, 64229,
     /*  911888 */     GIR_EraseRootFromParent_Done,
     /*  911889 */   // Label 13894: @911889
     /*  911889 */   GIM_Try, /*On fail goto*//*Label 13895*/ GIMT_Encode4(911972), // Rule ID 64230 //
     /*  911894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  911905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  911908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911918 */     // MIs[0] op1
     /*  911918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911934 */     // MIs[0] op4
     /*  911934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911949 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  911952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911954 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911956 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911958 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911960 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911970 */     GIR_RootConstrainSelectedInstOperands,
     /*  911971 */     // GIR_Coverage, 64230,
     /*  911971 */     GIR_EraseRootFromParent_Done,
     /*  911972 */   // Label 13895: @911972
     /*  911972 */   GIM_Try, /*On fail goto*//*Label 13896*/ GIMT_Encode4(912055), // Rule ID 64253 //
     /*  911977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  911988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  911991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  911994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912001 */     // MIs[0] op1
     /*  912001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912017 */     // MIs[0] op4
     /*  912017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  912035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912037 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912039 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912041 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912043 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912053 */     GIR_RootConstrainSelectedInstOperands,
     /*  912054 */     // GIR_Coverage, 64253,
     /*  912054 */     GIR_EraseRootFromParent_Done,
     /*  912055 */   // Label 13896: @912055
     /*  912055 */   GIM_Try, /*On fail goto*//*Label 13897*/ GIMT_Encode4(912138), // Rule ID 64254 //
     /*  912060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  912071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  912074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  912077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912084 */     // MIs[0] op1
     /*  912084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912087 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912100 */     // MIs[0] op4
     /*  912100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912115 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  912118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912120 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912122 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912124 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912126 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912136 */     GIR_RootConstrainSelectedInstOperands,
     /*  912137 */     // GIR_Coverage, 64254,
     /*  912137 */     GIR_EraseRootFromParent_Done,
     /*  912138 */   // Label 13897: @912138
     /*  912138 */   GIM_Try, /*On fail goto*//*Label 13898*/ GIMT_Encode4(912221), // Rule ID 64277 //
     /*  912143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  912146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  912154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  912157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  912163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912167 */     // MIs[0] op1
     /*  912167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912183 */     // MIs[0] op4
     /*  912183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912198 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11073:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  912198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  912201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912203 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912205 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912207 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912209 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912219 */     GIR_RootConstrainSelectedInstOperands,
     /*  912220 */     // GIR_Coverage, 64277,
     /*  912220 */     GIR_EraseRootFromParent_Done,
     /*  912221 */   // Label 13898: @912221
     /*  912221 */   GIM_Try, /*On fail goto*//*Label 13899*/ GIMT_Encode4(912304), // Rule ID 64278 //
     /*  912226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  912229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  912234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  912237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  912240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  912243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  912246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912250 */     // MIs[0] op1
     /*  912250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  912253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  912258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912266 */     // MIs[0] op4
     /*  912266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  912269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  912274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912281 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  912281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  912284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  912286 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  912288 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  912290 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  912292 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  912294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912302 */     GIR_RootConstrainSelectedInstOperands,
     /*  912303 */     // GIR_Coverage, 64278,
     /*  912303 */     GIR_EraseRootFromParent_Done,
     /*  912304 */   // Label 13899: @912304
     /*  912304 */   GIM_Try, /*On fail goto*//*Label 13900*/ GIMT_Encode4(912382), // Rule ID 60606 //
     /*  912309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912341 */     // MIs[0] rs2
     /*  912341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912349 */     // MIs[0] policy
     /*  912349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912359 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  912362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912380 */     GIR_RootConstrainSelectedInstOperands,
     /*  912381 */     // GIR_Coverage, 60606,
     /*  912381 */     GIR_EraseRootFromParent_Done,
     /*  912382 */   // Label 13900: @912382
     /*  912382 */   GIM_Try, /*On fail goto*//*Label 13901*/ GIMT_Encode4(912460), // Rule ID 60607 //
     /*  912387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912419 */     // MIs[0] rs2
     /*  912419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912427 */     // MIs[0] policy
     /*  912427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912437 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  912440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912458 */     GIR_RootConstrainSelectedInstOperands,
     /*  912459 */     // GIR_Coverage, 60607,
     /*  912459 */     GIR_EraseRootFromParent_Done,
     /*  912460 */   // Label 13901: @912460
     /*  912460 */   GIM_Try, /*On fail goto*//*Label 13902*/ GIMT_Encode4(912538), // Rule ID 62262 //
     /*  912465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  912476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  912479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  912482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912497 */     // MIs[0] rs2
     /*  912497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912505 */     // MIs[0] policy
     /*  912505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912515 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  912518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912536 */     GIR_RootConstrainSelectedInstOperands,
     /*  912537 */     // GIR_Coverage, 62262,
     /*  912537 */     GIR_EraseRootFromParent_Done,
     /*  912538 */   // Label 13902: @912538
     /*  912538 */   GIM_Try, /*On fail goto*//*Label 13903*/ GIMT_Encode4(912616), // Rule ID 62263 //
     /*  912543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  912554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  912557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  912560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912575 */     // MIs[0] rs2
     /*  912575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912583 */     // MIs[0] policy
     /*  912583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  912596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912614 */     GIR_RootConstrainSelectedInstOperands,
     /*  912615 */     // GIR_Coverage, 62263,
     /*  912615 */     GIR_EraseRootFromParent_Done,
     /*  912616 */   // Label 13903: @912616
     /*  912616 */   GIM_Try, /*On fail goto*//*Label 13904*/ GIMT_Encode4(912694), // Rule ID 62264 //
     /*  912621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912653 */     // MIs[0] rs2
     /*  912653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912661 */     // MIs[0] policy
     /*  912661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  912674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912692 */     GIR_RootConstrainSelectedInstOperands,
     /*  912693 */     // GIR_Coverage, 62264,
     /*  912693 */     GIR_EraseRootFromParent_Done,
     /*  912694 */   // Label 13904: @912694
     /*  912694 */   GIM_Try, /*On fail goto*//*Label 13905*/ GIMT_Encode4(912772), // Rule ID 62265 //
     /*  912699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912731 */     // MIs[0] rs2
     /*  912731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912739 */     // MIs[0] policy
     /*  912739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  912752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912770 */     GIR_RootConstrainSelectedInstOperands,
     /*  912771 */     // GIR_Coverage, 62265,
     /*  912771 */     GIR_EraseRootFromParent_Done,
     /*  912772 */   // Label 13905: @912772
     /*  912772 */   GIM_Try, /*On fail goto*//*Label 13906*/ GIMT_Encode4(912850), // Rule ID 62266 //
     /*  912777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  912791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912809 */     // MIs[0] rs2
     /*  912809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912817 */     // MIs[0] policy
     /*  912817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912827 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  912830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912848 */     GIR_RootConstrainSelectedInstOperands,
     /*  912849 */     // GIR_Coverage, 62266,
     /*  912849 */     GIR_EraseRootFromParent_Done,
     /*  912850 */   // Label 13906: @912850
     /*  912850 */   GIM_Try, /*On fail goto*//*Label 13907*/ GIMT_Encode4(912928), // Rule ID 62267 //
     /*  912855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  912869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912887 */     // MIs[0] rs2
     /*  912887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912895 */     // MIs[0] policy
     /*  912895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912905 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  912908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912926 */     GIR_RootConstrainSelectedInstOperands,
     /*  912927 */     // GIR_Coverage, 62267,
     /*  912927 */     GIR_EraseRootFromParent_Done,
     /*  912928 */   // Label 13907: @912928
     /*  912928 */   GIM_Try, /*On fail goto*//*Label 13908*/ GIMT_Encode4(913006), // Rule ID 62268 //
     /*  912933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  912944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  912947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  912950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912965 */     // MIs[0] rs2
     /*  912965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912973 */     // MIs[0] policy
     /*  912973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912983 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  912986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913004 */     GIR_RootConstrainSelectedInstOperands,
     /*  913005 */     // GIR_Coverage, 62268,
     /*  913005 */     GIR_EraseRootFromParent_Done,
     /*  913006 */   // Label 13908: @913006
     /*  913006 */   GIM_Try, /*On fail goto*//*Label 13909*/ GIMT_Encode4(913084), // Rule ID 62269 //
     /*  913011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  913014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  913019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913043 */     // MIs[0] rs2
     /*  913043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913046 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913051 */     // MIs[0] policy
     /*  913051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913061 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11154:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  913064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913082 */     GIR_RootConstrainSelectedInstOperands,
     /*  913083 */     // GIR_Coverage, 62269,
     /*  913083 */     GIR_EraseRootFromParent_Done,
     /*  913084 */   // Label 13909: @913084
     /*  913084 */   GIM_Try, /*On fail goto*//*Label 13910*/ GIMT_Encode4(913162), // Rule ID 62430 //
     /*  913089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  913100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  913103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  913106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913121 */     // MIs[0] rs2
     /*  913121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913129 */     // MIs[0] policy
     /*  913129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913139 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  913142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913160 */     GIR_RootConstrainSelectedInstOperands,
     /*  913161 */     // GIR_Coverage, 62430,
     /*  913161 */     GIR_EraseRootFromParent_Done,
     /*  913162 */   // Label 13910: @913162
     /*  913162 */   GIM_Try, /*On fail goto*//*Label 13911*/ GIMT_Encode4(913240), // Rule ID 62431 //
     /*  913167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  913178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  913181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  913184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913199 */     // MIs[0] rs2
     /*  913199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913207 */     // MIs[0] policy
     /*  913207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913217 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  913220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913238 */     GIR_RootConstrainSelectedInstOperands,
     /*  913239 */     // GIR_Coverage, 62431,
     /*  913239 */     GIR_EraseRootFromParent_Done,
     /*  913240 */   // Label 13911: @913240
     /*  913240 */   GIM_Try, /*On fail goto*//*Label 13912*/ GIMT_Encode4(913318), // Rule ID 62432 //
     /*  913245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913277 */     // MIs[0] rs2
     /*  913277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913285 */     // MIs[0] policy
     /*  913285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913295 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  913298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913316 */     GIR_RootConstrainSelectedInstOperands,
     /*  913317 */     // GIR_Coverage, 62432,
     /*  913317 */     GIR_EraseRootFromParent_Done,
     /*  913318 */   // Label 13912: @913318
     /*  913318 */   GIM_Try, /*On fail goto*//*Label 13913*/ GIMT_Encode4(913396), // Rule ID 62433 //
     /*  913323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  913334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  913337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  913340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913355 */     // MIs[0] rs2
     /*  913355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913363 */     // MIs[0] policy
     /*  913363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913373 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11556:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  913376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913394 */     GIR_RootConstrainSelectedInstOperands,
     /*  913395 */     // GIR_Coverage, 62433,
     /*  913395 */     GIR_EraseRootFromParent_Done,
     /*  913396 */   // Label 13913: @913396
     /*  913396 */   GIM_Try, /*On fail goto*//*Label 13914*/ GIMT_Encode4(913474), // Rule ID 62434 //
     /*  913401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913433 */     // MIs[0] rs2
     /*  913433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913441 */     // MIs[0] policy
     /*  913441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913451 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  913454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913472 */     GIR_RootConstrainSelectedInstOperands,
     /*  913473 */     // GIR_Coverage, 62434,
     /*  913473 */     GIR_EraseRootFromParent_Done,
     /*  913474 */   // Label 13914: @913474
     /*  913474 */   GIM_Try, /*On fail goto*//*Label 13915*/ GIMT_Encode4(913552), // Rule ID 62435 //
     /*  913479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  913490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  913493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  913496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913511 */     // MIs[0] rs2
     /*  913511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913519 */     // MIs[0] policy
     /*  913519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913529 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11556:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  913532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913550 */     GIR_RootConstrainSelectedInstOperands,
     /*  913551 */     // GIR_Coverage, 62435,
     /*  913551 */     GIR_EraseRootFromParent_Done,
     /*  913552 */   // Label 13915: @913552
     /*  913552 */   GIM_Try, /*On fail goto*//*Label 13916*/ GIMT_Encode4(913630), // Rule ID 62436 //
     /*  913557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913589 */     // MIs[0] rs2
     /*  913589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913592 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913597 */     // MIs[0] policy
     /*  913597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913607 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  913610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913628 */     GIR_RootConstrainSelectedInstOperands,
     /*  913629 */     // GIR_Coverage, 62436,
     /*  913629 */     GIR_EraseRootFromParent_Done,
     /*  913630 */   // Label 13916: @913630
     /*  913630 */   GIM_Try, /*On fail goto*//*Label 13917*/ GIMT_Encode4(913708), // Rule ID 62437 //
     /*  913635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913667 */     // MIs[0] rs2
     /*  913667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913675 */     // MIs[0] policy
     /*  913675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913685 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11556:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  913688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913706 */     GIR_RootConstrainSelectedInstOperands,
     /*  913707 */     // GIR_Coverage, 62437,
     /*  913707 */     GIR_EraseRootFromParent_Done,
     /*  913708 */   // Label 13917: @913708
     /*  913708 */   GIM_Try, /*On fail goto*//*Label 13918*/ GIMT_Encode4(913786), // Rule ID 62438 //
     /*  913713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913745 */     // MIs[0] rs2
     /*  913745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913748 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913753 */     // MIs[0] policy
     /*  913753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913763 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  913766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913784 */     GIR_RootConstrainSelectedInstOperands,
     /*  913785 */     // GIR_Coverage, 62438,
     /*  913785 */     GIR_EraseRootFromParent_Done,
     /*  913786 */   // Label 13918: @913786
     /*  913786 */   GIM_Try, /*On fail goto*//*Label 13919*/ GIMT_Encode4(913864), // Rule ID 62439 //
     /*  913791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913823 */     // MIs[0] rs2
     /*  913823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913831 */     // MIs[0] policy
     /*  913831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913841 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11556:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  913844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913862 */     GIR_RootConstrainSelectedInstOperands,
     /*  913863 */     // GIR_Coverage, 62439,
     /*  913863 */     GIR_EraseRootFromParent_Done,
     /*  913864 */   // Label 13919: @913864
     /*  913864 */   GIM_Try, /*On fail goto*//*Label 13920*/ GIMT_Encode4(913952), // Rule ID 23696 //
     /*  913869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  913880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  913883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  913886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  913889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  913912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  913916 */     // MIs[1] Operand 1
     /*  913916 */     // No operand predicates
     /*  913916 */     // MIs[0] policy
     /*  913916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  913921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913928 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  913931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  913940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913950 */     GIR_RootConstrainSelectedInstOperands,
     /*  913951 */     // GIR_Coverage, 23696,
     /*  913951 */     GIR_EraseRootFromParent_Done,
     /*  913952 */   // Label 13920: @913952
     /*  913952 */   GIM_Try, /*On fail goto*//*Label 13921*/ GIMT_Encode4(914040), // Rule ID 23697 //
     /*  913957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  913960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  913968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  913971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  913974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  913977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914004 */     // MIs[1] Operand 1
     /*  914004 */     // No operand predicates
     /*  914004 */     // MIs[0] policy
     /*  914004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914016 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  914019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914038 */     GIR_RootConstrainSelectedInstOperands,
     /*  914039 */     // GIR_Coverage, 23697,
     /*  914039 */     GIR_EraseRootFromParent_Done,
     /*  914040 */   // Label 13921: @914040
     /*  914040 */   GIM_Try, /*On fail goto*//*Label 13922*/ GIMT_Encode4(914128), // Rule ID 23700 //
     /*  914045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  914056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  914059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  914062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914092 */     // MIs[1] Operand 1
     /*  914092 */     // No operand predicates
     /*  914092 */     // MIs[0] policy
     /*  914092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914104 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914126 */     GIR_RootConstrainSelectedInstOperands,
     /*  914127 */     // GIR_Coverage, 23700,
     /*  914127 */     GIR_EraseRootFromParent_Done,
     /*  914128 */   // Label 13922: @914128
     /*  914128 */   GIM_Try, /*On fail goto*//*Label 13923*/ GIMT_Encode4(914216), // Rule ID 23701 //
     /*  914133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  914144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  914147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  914150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914180 */     // MIs[1] Operand 1
     /*  914180 */     // No operand predicates
     /*  914180 */     // MIs[0] policy
     /*  914180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914192 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914214 */     GIR_RootConstrainSelectedInstOperands,
     /*  914215 */     // GIR_Coverage, 23701,
     /*  914215 */     GIR_EraseRootFromParent_Done,
     /*  914216 */   // Label 13923: @914216
     /*  914216 */   GIM_Try, /*On fail goto*//*Label 13924*/ GIMT_Encode4(914304), // Rule ID 23704 //
     /*  914221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  914232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  914235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  914238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914268 */     // MIs[1] Operand 1
     /*  914268 */     // No operand predicates
     /*  914268 */     // MIs[0] policy
     /*  914268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914280 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914302 */     GIR_RootConstrainSelectedInstOperands,
     /*  914303 */     // GIR_Coverage, 23704,
     /*  914303 */     GIR_EraseRootFromParent_Done,
     /*  914304 */   // Label 13924: @914304
     /*  914304 */   GIM_Try, /*On fail goto*//*Label 13925*/ GIMT_Encode4(914392), // Rule ID 23705 //
     /*  914309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  914320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  914323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  914326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914356 */     // MIs[1] Operand 1
     /*  914356 */     // No operand predicates
     /*  914356 */     // MIs[0] policy
     /*  914356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914368 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914390 */     GIR_RootConstrainSelectedInstOperands,
     /*  914391 */     // GIR_Coverage, 23705,
     /*  914391 */     GIR_EraseRootFromParent_Done,
     /*  914392 */   // Label 13925: @914392
     /*  914392 */   GIM_Try, /*On fail goto*//*Label 13926*/ GIMT_Encode4(914480), // Rule ID 23708 //
     /*  914397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  914414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914444 */     // MIs[1] Operand 1
     /*  914444 */     // No operand predicates
     /*  914444 */     // MIs[0] policy
     /*  914444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914456 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914478 */     GIR_RootConstrainSelectedInstOperands,
     /*  914479 */     // GIR_Coverage, 23708,
     /*  914479 */     GIR_EraseRootFromParent_Done,
     /*  914480 */   // Label 13926: @914480
     /*  914480 */   GIM_Try, /*On fail goto*//*Label 13927*/ GIMT_Encode4(914568), // Rule ID 23709 //
     /*  914485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  914496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  914499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  914502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914532 */     // MIs[1] Operand 1
     /*  914532 */     // No operand predicates
     /*  914532 */     // MIs[0] policy
     /*  914532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914566 */     GIR_RootConstrainSelectedInstOperands,
     /*  914567 */     // GIR_Coverage, 23709,
     /*  914567 */     GIR_EraseRootFromParent_Done,
     /*  914568 */   // Label 13927: @914568
     /*  914568 */   GIM_Try, /*On fail goto*//*Label 13928*/ GIMT_Encode4(914656), // Rule ID 23712 //
     /*  914573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  914584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  914587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  914590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914620 */     // MIs[1] Operand 1
     /*  914620 */     // No operand predicates
     /*  914620 */     // MIs[0] policy
     /*  914620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914654 */     GIR_RootConstrainSelectedInstOperands,
     /*  914655 */     // GIR_Coverage, 23712,
     /*  914655 */     GIR_EraseRootFromParent_Done,
     /*  914656 */   // Label 13928: @914656
     /*  914656 */   GIM_Try, /*On fail goto*//*Label 13929*/ GIMT_Encode4(914744), // Rule ID 23713 //
     /*  914661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  914672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  914675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  914678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914708 */     // MIs[1] Operand 1
     /*  914708 */     // No operand predicates
     /*  914708 */     // MIs[0] policy
     /*  914708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914742 */     GIR_RootConstrainSelectedInstOperands,
     /*  914743 */     // GIR_Coverage, 23713,
     /*  914743 */     GIR_EraseRootFromParent_Done,
     /*  914744 */   // Label 13929: @914744
     /*  914744 */   GIM_Try, /*On fail goto*//*Label 13930*/ GIMT_Encode4(914832), // Rule ID 23716 //
     /*  914749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  914763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914796 */     // MIs[1] Operand 1
     /*  914796 */     // No operand predicates
     /*  914796 */     // MIs[0] policy
     /*  914796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914808 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914830 */     GIR_RootConstrainSelectedInstOperands,
     /*  914831 */     // GIR_Coverage, 23716,
     /*  914831 */     GIR_EraseRootFromParent_Done,
     /*  914832 */   // Label 13930: @914832
     /*  914832 */   GIM_Try, /*On fail goto*//*Label 13931*/ GIMT_Encode4(914920), // Rule ID 23717 //
     /*  914837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  914851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914884 */     // MIs[1] Operand 1
     /*  914884 */     // No operand predicates
     /*  914884 */     // MIs[0] policy
     /*  914884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914896 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914918 */     GIR_RootConstrainSelectedInstOperands,
     /*  914919 */     // GIR_Coverage, 23717,
     /*  914919 */     GIR_EraseRootFromParent_Done,
     /*  914920 */   // Label 13931: @914920
     /*  914920 */   GIM_Try, /*On fail goto*//*Label 13932*/ GIMT_Encode4(915008), // Rule ID 23720 //
     /*  914925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  914936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  914939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  914942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914972 */     // MIs[1] Operand 1
     /*  914972 */     // No operand predicates
     /*  914972 */     // MIs[0] policy
     /*  914972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  914987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915006 */     GIR_RootConstrainSelectedInstOperands,
     /*  915007 */     // GIR_Coverage, 23720,
     /*  915007 */     GIR_EraseRootFromParent_Done,
     /*  915008 */   // Label 13932: @915008
     /*  915008 */   GIM_Try, /*On fail goto*//*Label 13933*/ GIMT_Encode4(915096), // Rule ID 23721 //
     /*  915013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  915024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  915027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  915030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915060 */     // MIs[1] Operand 1
     /*  915060 */     // No operand predicates
     /*  915060 */     // MIs[0] policy
     /*  915060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915072 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915094 */     GIR_RootConstrainSelectedInstOperands,
     /*  915095 */     // GIR_Coverage, 23721,
     /*  915095 */     GIR_EraseRootFromParent_Done,
     /*  915096 */   // Label 13933: @915096
     /*  915096 */   GIM_Try, /*On fail goto*//*Label 13934*/ GIMT_Encode4(915184), // Rule ID 23724 //
     /*  915101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  915112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  915115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  915118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915148 */     // MIs[1] Operand 1
     /*  915148 */     // No operand predicates
     /*  915148 */     // MIs[0] policy
     /*  915148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915160 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915182 */     GIR_RootConstrainSelectedInstOperands,
     /*  915183 */     // GIR_Coverage, 23724,
     /*  915183 */     GIR_EraseRootFromParent_Done,
     /*  915184 */   // Label 13934: @915184
     /*  915184 */   GIM_Try, /*On fail goto*//*Label 13935*/ GIMT_Encode4(915272), // Rule ID 23725 //
     /*  915189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  915200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  915203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  915206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915236 */     // MIs[1] Operand 1
     /*  915236 */     // No operand predicates
     /*  915236 */     // MIs[0] policy
     /*  915236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915248 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915270 */     GIR_RootConstrainSelectedInstOperands,
     /*  915271 */     // GIR_Coverage, 23725,
     /*  915271 */     GIR_EraseRootFromParent_Done,
     /*  915272 */   // Label 13935: @915272
     /*  915272 */   GIM_Try, /*On fail goto*//*Label 13936*/ GIMT_Encode4(915360), // Rule ID 23728 //
     /*  915277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  915288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  915291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  915294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915324 */     // MIs[1] Operand 1
     /*  915324 */     // No operand predicates
     /*  915324 */     // MIs[0] policy
     /*  915324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915358 */     GIR_RootConstrainSelectedInstOperands,
     /*  915359 */     // GIR_Coverage, 23728,
     /*  915359 */     GIR_EraseRootFromParent_Done,
     /*  915360 */   // Label 13936: @915360
     /*  915360 */   GIM_Try, /*On fail goto*//*Label 13937*/ GIMT_Encode4(915448), // Rule ID 23729 //
     /*  915365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  915376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  915379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  915382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915412 */     // MIs[1] Operand 1
     /*  915412 */     // No operand predicates
     /*  915412 */     // MIs[0] policy
     /*  915412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  915444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915446 */     GIR_RootConstrainSelectedInstOperands,
     /*  915447 */     // GIR_Coverage, 23729,
     /*  915447 */     GIR_EraseRootFromParent_Done,
     /*  915448 */   // Label 13937: @915448
     /*  915448 */   GIM_Try, /*On fail goto*//*Label 13938*/ GIMT_Encode4(915536), // Rule ID 23732 //
     /*  915453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  915456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  915467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915500 */     // MIs[1] Operand 1
     /*  915500 */     // No operand predicates
     /*  915500 */     // MIs[0] policy
     /*  915500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915512 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  915532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915534 */     GIR_RootConstrainSelectedInstOperands,
     /*  915535 */     // GIR_Coverage, 23732,
     /*  915535 */     GIR_EraseRootFromParent_Done,
     /*  915536 */   // Label 13938: @915536
     /*  915536 */   GIM_Try, /*On fail goto*//*Label 13939*/ GIMT_Encode4(915624), // Rule ID 23733 //
     /*  915541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  915544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  915555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915588 */     // MIs[1] Operand 1
     /*  915588 */     // No operand predicates
     /*  915588 */     // MIs[0] policy
     /*  915588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  915620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915622 */     GIR_RootConstrainSelectedInstOperands,
     /*  915623 */     // GIR_Coverage, 23733,
     /*  915623 */     GIR_EraseRootFromParent_Done,
     /*  915624 */   // Label 13939: @915624
     /*  915624 */   GIM_Try, /*On fail goto*//*Label 13940*/ GIMT_Encode4(915712), // Rule ID 23736 //
     /*  915629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  915640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  915643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  915646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915676 */     // MIs[1] Operand 1
     /*  915676 */     // No operand predicates
     /*  915676 */     // MIs[0] policy
     /*  915676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  915691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915710 */     GIR_RootConstrainSelectedInstOperands,
     /*  915711 */     // GIR_Coverage, 23736,
     /*  915711 */     GIR_EraseRootFromParent_Done,
     /*  915712 */   // Label 13940: @915712
     /*  915712 */   GIM_Try, /*On fail goto*//*Label 13941*/ GIMT_Encode4(915800), // Rule ID 23737 //
     /*  915717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  915728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  915731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  915734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915764 */     // MIs[1] Operand 1
     /*  915764 */     // No operand predicates
     /*  915764 */     // MIs[0] policy
     /*  915764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  915779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915798 */     GIR_RootConstrainSelectedInstOperands,
     /*  915799 */     // GIR_Coverage, 23737,
     /*  915799 */     GIR_EraseRootFromParent_Done,
     /*  915800 */   // Label 13941: @915800
     /*  915800 */   GIM_Try, /*On fail goto*//*Label 13942*/ GIMT_Encode4(915888), // Rule ID 23740 //
     /*  915805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  915816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  915819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  915822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915852 */     // MIs[1] Operand 1
     /*  915852 */     // No operand predicates
     /*  915852 */     // MIs[0] policy
     /*  915852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915864 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  915867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915886 */     GIR_RootConstrainSelectedInstOperands,
     /*  915887 */     // GIR_Coverage, 23740,
     /*  915887 */     GIR_EraseRootFromParent_Done,
     /*  915888 */   // Label 13942: @915888
     /*  915888 */   GIM_Try, /*On fail goto*//*Label 13943*/ GIMT_Encode4(915976), // Rule ID 23741 //
     /*  915893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  915904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  915907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  915910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915940 */     // MIs[1] Operand 1
     /*  915940 */     // No operand predicates
     /*  915940 */     // MIs[0] policy
     /*  915940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915952 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  915955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915974 */     GIR_RootConstrainSelectedInstOperands,
     /*  915975 */     // GIR_Coverage, 23741,
     /*  915975 */     GIR_EraseRootFromParent_Done,
     /*  915976 */   // Label 13943: @915976
     /*  915976 */   GIM_Try, /*On fail goto*//*Label 13944*/ GIMT_Encode4(916064), // Rule ID 23744 //
     /*  915981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  915992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  915995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  915998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916028 */     // MIs[1] Operand 1
     /*  916028 */     // No operand predicates
     /*  916028 */     // MIs[0] policy
     /*  916028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916040 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916062 */     GIR_RootConstrainSelectedInstOperands,
     /*  916063 */     // GIR_Coverage, 23744,
     /*  916063 */     GIR_EraseRootFromParent_Done,
     /*  916064 */   // Label 13944: @916064
     /*  916064 */   GIM_Try, /*On fail goto*//*Label 13945*/ GIMT_Encode4(916152), // Rule ID 23745 //
     /*  916069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  916080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  916083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  916086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916116 */     // MIs[1] Operand 1
     /*  916116 */     // No operand predicates
     /*  916116 */     // MIs[0] policy
     /*  916116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916128 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  916148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916150 */     GIR_RootConstrainSelectedInstOperands,
     /*  916151 */     // GIR_Coverage, 23745,
     /*  916151 */     GIR_EraseRootFromParent_Done,
     /*  916152 */   // Label 13945: @916152
     /*  916152 */   GIM_Try, /*On fail goto*//*Label 13946*/ GIMT_Encode4(916240), // Rule ID 23748 //
     /*  916157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  916168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  916171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  916174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916204 */     // MIs[1] Operand 1
     /*  916204 */     // No operand predicates
     /*  916204 */     // MIs[0] policy
     /*  916204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916238 */     GIR_RootConstrainSelectedInstOperands,
     /*  916239 */     // GIR_Coverage, 23748,
     /*  916239 */     GIR_EraseRootFromParent_Done,
     /*  916240 */   // Label 13946: @916240
     /*  916240 */   GIM_Try, /*On fail goto*//*Label 13947*/ GIMT_Encode4(916328), // Rule ID 23749 //
     /*  916245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  916256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  916259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  916262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916292 */     // MIs[1] Operand 1
     /*  916292 */     // No operand predicates
     /*  916292 */     // MIs[0] policy
     /*  916292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916326 */     GIR_RootConstrainSelectedInstOperands,
     /*  916327 */     // GIR_Coverage, 23749,
     /*  916327 */     GIR_EraseRootFromParent_Done,
     /*  916328 */   // Label 13947: @916328
     /*  916328 */   GIM_Try, /*On fail goto*//*Label 13948*/ GIMT_Encode4(916416), // Rule ID 23752 //
     /*  916333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  916344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  916347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  916350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916380 */     // MIs[1] Operand 1
     /*  916380 */     // No operand predicates
     /*  916380 */     // MIs[0] policy
     /*  916380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916414 */     GIR_RootConstrainSelectedInstOperands,
     /*  916415 */     // GIR_Coverage, 23752,
     /*  916415 */     GIR_EraseRootFromParent_Done,
     /*  916416 */   // Label 13948: @916416
     /*  916416 */   GIM_Try, /*On fail goto*//*Label 13949*/ GIMT_Encode4(916504), // Rule ID 23753 //
     /*  916421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  916432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  916435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  916438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916468 */     // MIs[1] Operand 1
     /*  916468 */     // No operand predicates
     /*  916468 */     // MIs[0] policy
     /*  916468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916480 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916502 */     GIR_RootConstrainSelectedInstOperands,
     /*  916503 */     // GIR_Coverage, 23753,
     /*  916503 */     GIR_EraseRootFromParent_Done,
     /*  916504 */   // Label 13949: @916504
     /*  916504 */   GIM_Try, /*On fail goto*//*Label 13950*/ GIMT_Encode4(916592), // Rule ID 23756 //
     /*  916509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  916520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  916523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  916526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916556 */     // MIs[1] Operand 1
     /*  916556 */     // No operand predicates
     /*  916556 */     // MIs[0] policy
     /*  916556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916590 */     GIR_RootConstrainSelectedInstOperands,
     /*  916591 */     // GIR_Coverage, 23756,
     /*  916591 */     GIR_EraseRootFromParent_Done,
     /*  916592 */   // Label 13950: @916592
     /*  916592 */   GIM_Try, /*On fail goto*//*Label 13951*/ GIMT_Encode4(916680), // Rule ID 23757 //
     /*  916597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  916608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  916611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  916614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916644 */     // MIs[1] Operand 1
     /*  916644 */     // No operand predicates
     /*  916644 */     // MIs[0] policy
     /*  916644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916656 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916678 */     GIR_RootConstrainSelectedInstOperands,
     /*  916679 */     // GIR_Coverage, 23757,
     /*  916679 */     GIR_EraseRootFromParent_Done,
     /*  916680 */   // Label 13951: @916680
     /*  916680 */   GIM_Try, /*On fail goto*//*Label 13952*/ GIMT_Encode4(916768), // Rule ID 23760 //
     /*  916685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916732 */     // MIs[1] Operand 1
     /*  916732 */     // No operand predicates
     /*  916732 */     // MIs[0] policy
     /*  916732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916766 */     GIR_RootConstrainSelectedInstOperands,
     /*  916767 */     // GIR_Coverage, 23760,
     /*  916767 */     GIR_EraseRootFromParent_Done,
     /*  916768 */   // Label 13952: @916768
     /*  916768 */   GIM_Try, /*On fail goto*//*Label 13953*/ GIMT_Encode4(916856), // Rule ID 23761 //
     /*  916773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916820 */     // MIs[1] Operand 1
     /*  916820 */     // No operand predicates
     /*  916820 */     // MIs[0] policy
     /*  916820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916854 */     GIR_RootConstrainSelectedInstOperands,
     /*  916855 */     // GIR_Coverage, 23761,
     /*  916855 */     GIR_EraseRootFromParent_Done,
     /*  916856 */   // Label 13953: @916856
     /*  916856 */   GIM_Try, /*On fail goto*//*Label 13954*/ GIMT_Encode4(916944), // Rule ID 23764 //
     /*  916861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916908 */     // MIs[1] Operand 1
     /*  916908 */     // No operand predicates
     /*  916908 */     // MIs[0] policy
     /*  916908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916942 */     GIR_RootConstrainSelectedInstOperands,
     /*  916943 */     // GIR_Coverage, 23764,
     /*  916943 */     GIR_EraseRootFromParent_Done,
     /*  916944 */   // Label 13954: @916944
     /*  916944 */   GIM_Try, /*On fail goto*//*Label 13955*/ GIMT_Encode4(917032), // Rule ID 23765 //
     /*  916949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916996 */     // MIs[1] Operand 1
     /*  916996 */     // No operand predicates
     /*  916996 */     // MIs[0] policy
     /*  916996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917030 */     GIR_RootConstrainSelectedInstOperands,
     /*  917031 */     // GIR_Coverage, 23765,
     /*  917031 */     GIR_EraseRootFromParent_Done,
     /*  917032 */   // Label 13955: @917032
     /*  917032 */   GIM_Try, /*On fail goto*//*Label 13956*/ GIMT_Encode4(917120), // Rule ID 23768 //
     /*  917037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917084 */     // MIs[1] Operand 1
     /*  917084 */     // No operand predicates
     /*  917084 */     // MIs[0] policy
     /*  917084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917096 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917118 */     GIR_RootConstrainSelectedInstOperands,
     /*  917119 */     // GIR_Coverage, 23768,
     /*  917119 */     GIR_EraseRootFromParent_Done,
     /*  917120 */   // Label 13956: @917120
     /*  917120 */   GIM_Try, /*On fail goto*//*Label 13957*/ GIMT_Encode4(917208), // Rule ID 23769 //
     /*  917125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  917136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  917139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  917142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917172 */     // MIs[1] Operand 1
     /*  917172 */     // No operand predicates
     /*  917172 */     // MIs[0] policy
     /*  917172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917184 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  917204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917206 */     GIR_RootConstrainSelectedInstOperands,
     /*  917207 */     // GIR_Coverage, 23769,
     /*  917207 */     GIR_EraseRootFromParent_Done,
     /*  917208 */   // Label 13957: @917208
     /*  917208 */   GIM_Try, /*On fail goto*//*Label 13958*/ GIMT_Encode4(917296), // Rule ID 23772 //
     /*  917213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  917224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  917227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  917230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917260 */     // MIs[1] Operand 1
     /*  917260 */     // No operand predicates
     /*  917260 */     // MIs[0] policy
     /*  917260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917272 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917294 */     GIR_RootConstrainSelectedInstOperands,
     /*  917295 */     // GIR_Coverage, 23772,
     /*  917295 */     GIR_EraseRootFromParent_Done,
     /*  917296 */   // Label 13958: @917296
     /*  917296 */   GIM_Try, /*On fail goto*//*Label 13959*/ GIMT_Encode4(917384), // Rule ID 23773 //
     /*  917301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  917312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  917315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  917318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  917336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917348 */     // MIs[1] Operand 1
     /*  917348 */     // No operand predicates
     /*  917348 */     // MIs[0] policy
     /*  917348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  917363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917382 */     GIR_RootConstrainSelectedInstOperands,
     /*  917383 */     // GIR_Coverage, 23773,
     /*  917383 */     GIR_EraseRootFromParent_Done,
     /*  917384 */   // Label 13959: @917384
     /*  917384 */   GIM_Try, /*On fail goto*//*Label 13960*/ GIMT_Encode4(917472), // Rule ID 23776 //
     /*  917389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  917400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  917403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  917406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917436 */     // MIs[1] Operand 1
     /*  917436 */     // No operand predicates
     /*  917436 */     // MIs[0] policy
     /*  917436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917470 */     GIR_RootConstrainSelectedInstOperands,
     /*  917471 */     // GIR_Coverage, 23776,
     /*  917471 */     GIR_EraseRootFromParent_Done,
     /*  917472 */   // Label 13960: @917472
     /*  917472 */   GIM_Try, /*On fail goto*//*Label 13961*/ GIMT_Encode4(917560), // Rule ID 23777 //
     /*  917477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  917488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  917491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  917494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917524 */     // MIs[1] Operand 1
     /*  917524 */     // No operand predicates
     /*  917524 */     // MIs[0] policy
     /*  917524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917536 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917558 */     GIR_RootConstrainSelectedInstOperands,
     /*  917559 */     // GIR_Coverage, 23777,
     /*  917559 */     GIR_EraseRootFromParent_Done,
     /*  917560 */   // Label 13961: @917560
     /*  917560 */   GIM_Try, /*On fail goto*//*Label 13962*/ GIMT_Encode4(917648), // Rule ID 23780 //
     /*  917565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  917576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  917579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  917582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917612 */     // MIs[1] Operand 1
     /*  917612 */     // No operand predicates
     /*  917612 */     // MIs[0] policy
     /*  917612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917624 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917646 */     GIR_RootConstrainSelectedInstOperands,
     /*  917647 */     // GIR_Coverage, 23780,
     /*  917647 */     GIR_EraseRootFromParent_Done,
     /*  917648 */   // Label 13962: @917648
     /*  917648 */   GIM_Try, /*On fail goto*//*Label 13963*/ GIMT_Encode4(917736), // Rule ID 23781 //
     /*  917653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  917664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  917667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  917670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917700 */     // MIs[1] Operand 1
     /*  917700 */     // No operand predicates
     /*  917700 */     // MIs[0] policy
     /*  917700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917712 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917734 */     GIR_RootConstrainSelectedInstOperands,
     /*  917735 */     // GIR_Coverage, 23781,
     /*  917735 */     GIR_EraseRootFromParent_Done,
     /*  917736 */   // Label 13963: @917736
     /*  917736 */   GIM_Try, /*On fail goto*//*Label 13964*/ GIMT_Encode4(917824), // Rule ID 23872 //
     /*  917741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917788 */     // MIs[1] Operand 1
     /*  917788 */     // No operand predicates
     /*  917788 */     // MIs[0] policy
     /*  917788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917800 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  917803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917822 */     GIR_RootConstrainSelectedInstOperands,
     /*  917823 */     // GIR_Coverage, 23872,
     /*  917823 */     GIR_EraseRootFromParent_Done,
     /*  917824 */   // Label 13964: @917824
     /*  917824 */   GIM_Try, /*On fail goto*//*Label 13965*/ GIMT_Encode4(917912), // Rule ID 23873 //
     /*  917829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917876 */     // MIs[1] Operand 1
     /*  917876 */     // No operand predicates
     /*  917876 */     // MIs[0] policy
     /*  917876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917888 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  917891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917910 */     GIR_RootConstrainSelectedInstOperands,
     /*  917911 */     // GIR_Coverage, 23873,
     /*  917911 */     GIR_EraseRootFromParent_Done,
     /*  917912 */   // Label 13965: @917912
     /*  917912 */   GIM_Try, /*On fail goto*//*Label 13966*/ GIMT_Encode4(918000), // Rule ID 23876 //
     /*  917917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917964 */     // MIs[1] Operand 1
     /*  917964 */     // No operand predicates
     /*  917964 */     // MIs[0] policy
     /*  917964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  917979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917998 */     GIR_RootConstrainSelectedInstOperands,
     /*  917999 */     // GIR_Coverage, 23876,
     /*  917999 */     GIR_EraseRootFromParent_Done,
     /*  918000 */   // Label 13966: @918000
     /*  918000 */   GIM_Try, /*On fail goto*//*Label 13967*/ GIMT_Encode4(918088), // Rule ID 23877 //
     /*  918005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  918016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  918019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  918022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918052 */     // MIs[1] Operand 1
     /*  918052 */     // No operand predicates
     /*  918052 */     // MIs[0] policy
     /*  918052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918064 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918086 */     GIR_RootConstrainSelectedInstOperands,
     /*  918087 */     // GIR_Coverage, 23877,
     /*  918087 */     GIR_EraseRootFromParent_Done,
     /*  918088 */   // Label 13967: @918088
     /*  918088 */   GIM_Try, /*On fail goto*//*Label 13968*/ GIMT_Encode4(918176), // Rule ID 23880 //
     /*  918093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918140 */     // MIs[1] Operand 1
     /*  918140 */     // No operand predicates
     /*  918140 */     // MIs[0] policy
     /*  918140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918174 */     GIR_RootConstrainSelectedInstOperands,
     /*  918175 */     // GIR_Coverage, 23880,
     /*  918175 */     GIR_EraseRootFromParent_Done,
     /*  918176 */   // Label 13968: @918176
     /*  918176 */   GIM_Try, /*On fail goto*//*Label 13969*/ GIMT_Encode4(918264), // Rule ID 23881 //
     /*  918181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  918192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  918195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  918198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918228 */     // MIs[1] Operand 1
     /*  918228 */     // No operand predicates
     /*  918228 */     // MIs[0] policy
     /*  918228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918240 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918262 */     GIR_RootConstrainSelectedInstOperands,
     /*  918263 */     // GIR_Coverage, 23881,
     /*  918263 */     GIR_EraseRootFromParent_Done,
     /*  918264 */   // Label 13969: @918264
     /*  918264 */   GIM_Try, /*On fail goto*//*Label 13970*/ GIMT_Encode4(918352), // Rule ID 23884 //
     /*  918269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918316 */     // MIs[1] Operand 1
     /*  918316 */     // No operand predicates
     /*  918316 */     // MIs[0] policy
     /*  918316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918350 */     GIR_RootConstrainSelectedInstOperands,
     /*  918351 */     // GIR_Coverage, 23884,
     /*  918351 */     GIR_EraseRootFromParent_Done,
     /*  918352 */   // Label 13970: @918352
     /*  918352 */   GIM_Try, /*On fail goto*//*Label 13971*/ GIMT_Encode4(918440), // Rule ID 23885 //
     /*  918357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  918368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  918371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  918374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918404 */     // MIs[1] Operand 1
     /*  918404 */     // No operand predicates
     /*  918404 */     // MIs[0] policy
     /*  918404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  918419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918438 */     GIR_RootConstrainSelectedInstOperands,
     /*  918439 */     // GIR_Coverage, 23885,
     /*  918439 */     GIR_EraseRootFromParent_Done,
     /*  918440 */   // Label 13971: @918440
     /*  918440 */   GIM_Try, /*On fail goto*//*Label 13972*/ GIMT_Encode4(918528), // Rule ID 23888 //
     /*  918445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918492 */     // MIs[1] Operand 1
     /*  918492 */     // No operand predicates
     /*  918492 */     // MIs[0] policy
     /*  918492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918504 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918526 */     GIR_RootConstrainSelectedInstOperands,
     /*  918527 */     // GIR_Coverage, 23888,
     /*  918527 */     GIR_EraseRootFromParent_Done,
     /*  918528 */   // Label 13972: @918528
     /*  918528 */   GIM_Try, /*On fail goto*//*Label 13973*/ GIMT_Encode4(918616), // Rule ID 23889 //
     /*  918533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918580 */     // MIs[1] Operand 1
     /*  918580 */     // No operand predicates
     /*  918580 */     // MIs[0] policy
     /*  918580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918592 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918614 */     GIR_RootConstrainSelectedInstOperands,
     /*  918615 */     // GIR_Coverage, 23889,
     /*  918615 */     GIR_EraseRootFromParent_Done,
     /*  918616 */   // Label 13973: @918616
     /*  918616 */   GIM_Try, /*On fail goto*//*Label 13974*/ GIMT_Encode4(918704), // Rule ID 23892 //
     /*  918621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918668 */     // MIs[1] Operand 1
     /*  918668 */     // No operand predicates
     /*  918668 */     // MIs[0] policy
     /*  918668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918702 */     GIR_RootConstrainSelectedInstOperands,
     /*  918703 */     // GIR_Coverage, 23892,
     /*  918703 */     GIR_EraseRootFromParent_Done,
     /*  918704 */   // Label 13974: @918704
     /*  918704 */   GIM_Try, /*On fail goto*//*Label 13975*/ GIMT_Encode4(918792), // Rule ID 23893 //
     /*  918709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918756 */     // MIs[1] Operand 1
     /*  918756 */     // No operand predicates
     /*  918756 */     // MIs[0] policy
     /*  918756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918790 */     GIR_RootConstrainSelectedInstOperands,
     /*  918791 */     // GIR_Coverage, 23893,
     /*  918791 */     GIR_EraseRootFromParent_Done,
     /*  918792 */   // Label 13975: @918792
     /*  918792 */   GIM_Try, /*On fail goto*//*Label 13976*/ GIMT_Encode4(918880), // Rule ID 23896 //
     /*  918797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918844 */     // MIs[1] Operand 1
     /*  918844 */     // No operand predicates
     /*  918844 */     // MIs[0] policy
     /*  918844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918878 */     GIR_RootConstrainSelectedInstOperands,
     /*  918879 */     // GIR_Coverage, 23896,
     /*  918879 */     GIR_EraseRootFromParent_Done,
     /*  918880 */   // Label 13976: @918880
     /*  918880 */   GIM_Try, /*On fail goto*//*Label 13977*/ GIMT_Encode4(918968), // Rule ID 23897 //
     /*  918885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918932 */     // MIs[1] Operand 1
     /*  918932 */     // No operand predicates
     /*  918932 */     // MIs[0] policy
     /*  918932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918966 */     GIR_RootConstrainSelectedInstOperands,
     /*  918967 */     // GIR_Coverage, 23897,
     /*  918967 */     GIR_EraseRootFromParent_Done,
     /*  918968 */   // Label 13977: @918968
     /*  918968 */   GIM_Try, /*On fail goto*//*Label 13978*/ GIMT_Encode4(919056), // Rule ID 23900 //
     /*  918973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  918984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  918987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  918990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919020 */     // MIs[1] Operand 1
     /*  919020 */     // No operand predicates
     /*  919020 */     // MIs[0] policy
     /*  919020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919054 */     GIR_RootConstrainSelectedInstOperands,
     /*  919055 */     // GIR_Coverage, 23900,
     /*  919055 */     GIR_EraseRootFromParent_Done,
     /*  919056 */   // Label 13978: @919056
     /*  919056 */   GIM_Try, /*On fail goto*//*Label 13979*/ GIMT_Encode4(919144), // Rule ID 23901 //
     /*  919061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  919072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  919075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  919078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919108 */     // MIs[1] Operand 1
     /*  919108 */     // No operand predicates
     /*  919108 */     // MIs[0] policy
     /*  919108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919142 */     GIR_RootConstrainSelectedInstOperands,
     /*  919143 */     // GIR_Coverage, 23901,
     /*  919143 */     GIR_EraseRootFromParent_Done,
     /*  919144 */   // Label 13979: @919144
     /*  919144 */   GIM_Try, /*On fail goto*//*Label 13980*/ GIMT_Encode4(919232), // Rule ID 23904 //
     /*  919149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919196 */     // MIs[1] Operand 1
     /*  919196 */     // No operand predicates
     /*  919196 */     // MIs[0] policy
     /*  919196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919230 */     GIR_RootConstrainSelectedInstOperands,
     /*  919231 */     // GIR_Coverage, 23904,
     /*  919231 */     GIR_EraseRootFromParent_Done,
     /*  919232 */   // Label 13980: @919232
     /*  919232 */   GIM_Try, /*On fail goto*//*Label 13981*/ GIMT_Encode4(919320), // Rule ID 23905 //
     /*  919237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  919248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  919251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  919254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919284 */     // MIs[1] Operand 1
     /*  919284 */     // No operand predicates
     /*  919284 */     // MIs[0] policy
     /*  919284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  919316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919318 */     GIR_RootConstrainSelectedInstOperands,
     /*  919319 */     // GIR_Coverage, 23905,
     /*  919319 */     GIR_EraseRootFromParent_Done,
     /*  919320 */   // Label 13981: @919320
     /*  919320 */   GIM_Try, /*On fail goto*//*Label 13982*/ GIMT_Encode4(919408), // Rule ID 23908 //
     /*  919325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  919328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919372 */     // MIs[1] Operand 1
     /*  919372 */     // No operand predicates
     /*  919372 */     // MIs[0] policy
     /*  919372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919406 */     GIR_RootConstrainSelectedInstOperands,
     /*  919407 */     // GIR_Coverage, 23908,
     /*  919407 */     GIR_EraseRootFromParent_Done,
     /*  919408 */   // Label 13982: @919408
     /*  919408 */   GIM_Try, /*On fail goto*//*Label 13983*/ GIMT_Encode4(919496), // Rule ID 23909 //
     /*  919413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  919416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  919424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  919427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  919430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  919448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919460 */     // MIs[1] Operand 1
     /*  919460 */     // No operand predicates
     /*  919460 */     // MIs[0] policy
     /*  919460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919472 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  919475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  919492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919494 */     GIR_RootConstrainSelectedInstOperands,
     /*  919495 */     // GIR_Coverage, 23909,
     /*  919495 */     GIR_EraseRootFromParent_Done,
     /*  919496 */   // Label 13983: @919496
     /*  919496 */   GIM_Try, /*On fail goto*//*Label 13984*/ GIMT_Encode4(919584), // Rule ID 23912 //
     /*  919501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919548 */     // MIs[1] Operand 1
     /*  919548 */     // No operand predicates
     /*  919548 */     // MIs[0] policy
     /*  919548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919560 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  919563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919582 */     GIR_RootConstrainSelectedInstOperands,
     /*  919583 */     // GIR_Coverage, 23912,
     /*  919583 */     GIR_EraseRootFromParent_Done,
     /*  919584 */   // Label 13984: @919584
     /*  919584 */   GIM_Try, /*On fail goto*//*Label 13985*/ GIMT_Encode4(919672), // Rule ID 23913 //
     /*  919589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919636 */     // MIs[1] Operand 1
     /*  919636 */     // No operand predicates
     /*  919636 */     // MIs[0] policy
     /*  919636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919648 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  919651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919670 */     GIR_RootConstrainSelectedInstOperands,
     /*  919671 */     // GIR_Coverage, 23913,
     /*  919671 */     GIR_EraseRootFromParent_Done,
     /*  919672 */   // Label 13985: @919672
     /*  919672 */   GIM_Try, /*On fail goto*//*Label 13986*/ GIMT_Encode4(919760), // Rule ID 23916 //
     /*  919677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919724 */     // MIs[1] Operand 1
     /*  919724 */     // No operand predicates
     /*  919724 */     // MIs[0] policy
     /*  919724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919736 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  919739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919758 */     GIR_RootConstrainSelectedInstOperands,
     /*  919759 */     // GIR_Coverage, 23916,
     /*  919759 */     GIR_EraseRootFromParent_Done,
     /*  919760 */   // Label 13986: @919760
     /*  919760 */   GIM_Try, /*On fail goto*//*Label 13987*/ GIMT_Encode4(919848), // Rule ID 23917 //
     /*  919765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919812 */     // MIs[1] Operand 1
     /*  919812 */     // No operand predicates
     /*  919812 */     // MIs[0] policy
     /*  919812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919824 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  919827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919846 */     GIR_RootConstrainSelectedInstOperands,
     /*  919847 */     // GIR_Coverage, 23917,
     /*  919847 */     GIR_EraseRootFromParent_Done,
     /*  919848 */   // Label 13987: @919848
     /*  919848 */   GIM_Try, /*On fail goto*//*Label 13988*/ GIMT_Encode4(919936), // Rule ID 23920 //
     /*  919853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919900 */     // MIs[1] Operand 1
     /*  919900 */     // No operand predicates
     /*  919900 */     // MIs[0] policy
     /*  919900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919912 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  919915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919934 */     GIR_RootConstrainSelectedInstOperands,
     /*  919935 */     // GIR_Coverage, 23920,
     /*  919935 */     GIR_EraseRootFromParent_Done,
     /*  919936 */   // Label 13988: @919936
     /*  919936 */   GIM_Try, /*On fail goto*//*Label 13989*/ GIMT_Encode4(920024), // Rule ID 23921 //
     /*  919941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919988 */     // MIs[1] Operand 1
     /*  919988 */     // No operand predicates
     /*  919988 */     // MIs[0] policy
     /*  919988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920000 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  920020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920022 */     GIR_RootConstrainSelectedInstOperands,
     /*  920023 */     // GIR_Coverage, 23921,
     /*  920023 */     GIR_EraseRootFromParent_Done,
     /*  920024 */   // Label 13989: @920024
     /*  920024 */   GIM_Try, /*On fail goto*//*Label 13990*/ GIMT_Encode4(920112), // Rule ID 23924 //
     /*  920029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920076 */     // MIs[1] Operand 1
     /*  920076 */     // No operand predicates
     /*  920076 */     // MIs[0] policy
     /*  920076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920088 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920110 */     GIR_RootConstrainSelectedInstOperands,
     /*  920111 */     // GIR_Coverage, 23924,
     /*  920111 */     GIR_EraseRootFromParent_Done,
     /*  920112 */   // Label 13990: @920112
     /*  920112 */   GIM_Try, /*On fail goto*//*Label 13991*/ GIMT_Encode4(920200), // Rule ID 23925 //
     /*  920117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  920128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  920131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  920134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920164 */     // MIs[1] Operand 1
     /*  920164 */     // No operand predicates
     /*  920164 */     // MIs[0] policy
     /*  920164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920176 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920198 */     GIR_RootConstrainSelectedInstOperands,
     /*  920199 */     // GIR_Coverage, 23925,
     /*  920199 */     GIR_EraseRootFromParent_Done,
     /*  920200 */   // Label 13991: @920200
     /*  920200 */   GIM_Try, /*On fail goto*//*Label 13992*/ GIMT_Encode4(920288), // Rule ID 23928 //
     /*  920205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920252 */     // MIs[1] Operand 1
     /*  920252 */     // No operand predicates
     /*  920252 */     // MIs[0] policy
     /*  920252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920286 */     GIR_RootConstrainSelectedInstOperands,
     /*  920287 */     // GIR_Coverage, 23928,
     /*  920287 */     GIR_EraseRootFromParent_Done,
     /*  920288 */   // Label 13992: @920288
     /*  920288 */   GIM_Try, /*On fail goto*//*Label 13993*/ GIMT_Encode4(920376), // Rule ID 23929 //
     /*  920293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  920304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  920307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  920310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920340 */     // MIs[1] Operand 1
     /*  920340 */     // No operand predicates
     /*  920340 */     // MIs[0] policy
     /*  920340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920352 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920374 */     GIR_RootConstrainSelectedInstOperands,
     /*  920375 */     // GIR_Coverage, 23929,
     /*  920375 */     GIR_EraseRootFromParent_Done,
     /*  920376 */   // Label 13993: @920376
     /*  920376 */   GIM_Try, /*On fail goto*//*Label 13994*/ GIMT_Encode4(920464), // Rule ID 23932 //
     /*  920381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920428 */     // MIs[1] Operand 1
     /*  920428 */     // No operand predicates
     /*  920428 */     // MIs[0] policy
     /*  920428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920440 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920462 */     GIR_RootConstrainSelectedInstOperands,
     /*  920463 */     // GIR_Coverage, 23932,
     /*  920463 */     GIR_EraseRootFromParent_Done,
     /*  920464 */   // Label 13994: @920464
     /*  920464 */   GIM_Try, /*On fail goto*//*Label 13995*/ GIMT_Encode4(920552), // Rule ID 23933 //
     /*  920469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  920480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  920483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  920486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920516 */     // MIs[1] Operand 1
     /*  920516 */     // No operand predicates
     /*  920516 */     // MIs[0] policy
     /*  920516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920528 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920550 */     GIR_RootConstrainSelectedInstOperands,
     /*  920551 */     // GIR_Coverage, 23933,
     /*  920551 */     GIR_EraseRootFromParent_Done,
     /*  920552 */   // Label 13995: @920552
     /*  920552 */   GIM_Try, /*On fail goto*//*Label 13996*/ GIMT_Encode4(920640), // Rule ID 23936 //
     /*  920557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920604 */     // MIs[1] Operand 1
     /*  920604 */     // No operand predicates
     /*  920604 */     // MIs[0] policy
     /*  920604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920638 */     GIR_RootConstrainSelectedInstOperands,
     /*  920639 */     // GIR_Coverage, 23936,
     /*  920639 */     GIR_EraseRootFromParent_Done,
     /*  920640 */   // Label 13996: @920640
     /*  920640 */   GIM_Try, /*On fail goto*//*Label 13997*/ GIMT_Encode4(920728), // Rule ID 23937 //
     /*  920645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920692 */     // MIs[1] Operand 1
     /*  920692 */     // No operand predicates
     /*  920692 */     // MIs[0] policy
     /*  920692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920726 */     GIR_RootConstrainSelectedInstOperands,
     /*  920727 */     // GIR_Coverage, 23937,
     /*  920727 */     GIR_EraseRootFromParent_Done,
     /*  920728 */   // Label 13997: @920728
     /*  920728 */   GIM_Try, /*On fail goto*//*Label 13998*/ GIMT_Encode4(920816), // Rule ID 23940 //
     /*  920733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920780 */     // MIs[1] Operand 1
     /*  920780 */     // No operand predicates
     /*  920780 */     // MIs[0] policy
     /*  920780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920792 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920814 */     GIR_RootConstrainSelectedInstOperands,
     /*  920815 */     // GIR_Coverage, 23940,
     /*  920815 */     GIR_EraseRootFromParent_Done,
     /*  920816 */   // Label 13998: @920816
     /*  920816 */   GIM_Try, /*On fail goto*//*Label 13999*/ GIMT_Encode4(920904), // Rule ID 23941 //
     /*  920821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920868 */     // MIs[1] Operand 1
     /*  920868 */     // No operand predicates
     /*  920868 */     // MIs[0] policy
     /*  920868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920902 */     GIR_RootConstrainSelectedInstOperands,
     /*  920903 */     // GIR_Coverage, 23941,
     /*  920903 */     GIR_EraseRootFromParent_Done,
     /*  920904 */   // Label 13999: @920904
     /*  920904 */   GIM_Try, /*On fail goto*//*Label 14000*/ GIMT_Encode4(920992), // Rule ID 23944 //
     /*  920909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  920920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  920923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  920926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920956 */     // MIs[1] Operand 1
     /*  920956 */     // No operand predicates
     /*  920956 */     // MIs[0] policy
     /*  920956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920968 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920990 */     GIR_RootConstrainSelectedInstOperands,
     /*  920991 */     // GIR_Coverage, 23944,
     /*  920991 */     GIR_EraseRootFromParent_Done,
     /*  920992 */   // Label 14000: @920992
     /*  920992 */   GIM_Try, /*On fail goto*//*Label 14001*/ GIMT_Encode4(921080), // Rule ID 23945 //
     /*  920997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  921000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  921008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  921011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  921014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921044 */     // MIs[1] Operand 1
     /*  921044 */     // No operand predicates
     /*  921044 */     // MIs[0] policy
     /*  921044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921056 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921078 */     GIR_RootConstrainSelectedInstOperands,
     /*  921079 */     // GIR_Coverage, 23945,
     /*  921079 */     GIR_EraseRootFromParent_Done,
     /*  921080 */   // Label 14001: @921080
     /*  921080 */   GIM_Try, /*On fail goto*//*Label 14002*/ GIMT_Encode4(921168), // Rule ID 23948 //
     /*  921085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921132 */     // MIs[1] Operand 1
     /*  921132 */     // No operand predicates
     /*  921132 */     // MIs[0] policy
     /*  921132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921166 */     GIR_RootConstrainSelectedInstOperands,
     /*  921167 */     // GIR_Coverage, 23948,
     /*  921167 */     GIR_EraseRootFromParent_Done,
     /*  921168 */   // Label 14002: @921168
     /*  921168 */   GIM_Try, /*On fail goto*//*Label 14003*/ GIMT_Encode4(921256), // Rule ID 23949 //
     /*  921173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  921184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  921187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  921190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  921208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921220 */     // MIs[1] Operand 1
     /*  921220 */     // No operand predicates
     /*  921220 */     // MIs[0] policy
     /*  921220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  921235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921254 */     GIR_RootConstrainSelectedInstOperands,
     /*  921255 */     // GIR_Coverage, 23949,
     /*  921255 */     GIR_EraseRootFromParent_Done,
     /*  921256 */   // Label 14003: @921256
     /*  921256 */   GIM_Try, /*On fail goto*//*Label 14004*/ GIMT_Encode4(921344), // Rule ID 23952 //
     /*  921261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921308 */     // MIs[1] Operand 1
     /*  921308 */     // No operand predicates
     /*  921308 */     // MIs[0] policy
     /*  921308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921342 */     GIR_RootConstrainSelectedInstOperands,
     /*  921343 */     // GIR_Coverage, 23952,
     /*  921343 */     GIR_EraseRootFromParent_Done,
     /*  921344 */   // Label 14004: @921344
     /*  921344 */   GIM_Try, /*On fail goto*//*Label 14005*/ GIMT_Encode4(921432), // Rule ID 23953 //
     /*  921349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  921360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  921363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  921366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  921384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921396 */     // MIs[1] Operand 1
     /*  921396 */     // No operand predicates
     /*  921396 */     // MIs[0] policy
     /*  921396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921408 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  921411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921430 */     GIR_RootConstrainSelectedInstOperands,
     /*  921431 */     // GIR_Coverage, 23953,
     /*  921431 */     GIR_EraseRootFromParent_Done,
     /*  921432 */   // Label 14005: @921432
     /*  921432 */   GIM_Try, /*On fail goto*//*Label 14006*/ GIMT_Encode4(921520), // Rule ID 23956 //
     /*  921437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  921440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921484 */     // MIs[1] Operand 1
     /*  921484 */     // No operand predicates
     /*  921484 */     // MIs[0] policy
     /*  921484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921496 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921518 */     GIR_RootConstrainSelectedInstOperands,
     /*  921519 */     // GIR_Coverage, 23956,
     /*  921519 */     GIR_EraseRootFromParent_Done,
     /*  921520 */   // Label 14006: @921520
     /*  921520 */   GIM_Try, /*On fail goto*//*Label 14007*/ GIMT_Encode4(921608), // Rule ID 23957 //
     /*  921525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921572 */     // MIs[1] Operand 1
     /*  921572 */     // No operand predicates
     /*  921572 */     // MIs[0] policy
     /*  921572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921606 */     GIR_RootConstrainSelectedInstOperands,
     /*  921607 */     // GIR_Coverage, 23957,
     /*  921607 */     GIR_EraseRootFromParent_Done,
     /*  921608 */   // Label 14007: @921608
     /*  921608 */   GIM_Try, /*On fail goto*//*Label 14008*/ GIMT_Encode4(921696), // Rule ID 24196 //
     /*  921613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  921616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  921624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  921627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  921630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921660 */     // MIs[1] Operand 1
     /*  921660 */     // No operand predicates
     /*  921660 */     // MIs[0] policy
     /*  921660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921672 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  921675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921694 */     GIR_RootConstrainSelectedInstOperands,
     /*  921695 */     // GIR_Coverage, 24196,
     /*  921695 */     GIR_EraseRootFromParent_Done,
     /*  921696 */   // Label 14008: @921696
     /*  921696 */   GIM_Try, /*On fail goto*//*Label 14009*/ GIMT_Encode4(921784), // Rule ID 24197 //
     /*  921701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  921704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  921712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  921715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  921718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921748 */     // MIs[1] Operand 1
     /*  921748 */     // No operand predicates
     /*  921748 */     // MIs[0] policy
     /*  921748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921760 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  921763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921782 */     GIR_RootConstrainSelectedInstOperands,
     /*  921783 */     // GIR_Coverage, 24197,
     /*  921783 */     GIR_EraseRootFromParent_Done,
     /*  921784 */   // Label 14009: @921784
     /*  921784 */   GIM_Try, /*On fail goto*//*Label 14010*/ GIMT_Encode4(921872), // Rule ID 24200 //
     /*  921789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  921792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  921800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  921803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  921806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921836 */     // MIs[1] Operand 1
     /*  921836 */     // No operand predicates
     /*  921836 */     // MIs[0] policy
     /*  921836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921848 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  921851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921870 */     GIR_RootConstrainSelectedInstOperands,
     /*  921871 */     // GIR_Coverage, 24200,
     /*  921871 */     GIR_EraseRootFromParent_Done,
     /*  921872 */   // Label 14010: @921872
     /*  921872 */   GIM_Try, /*On fail goto*//*Label 14011*/ GIMT_Encode4(921960), // Rule ID 24201 //
     /*  921877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  921880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  921888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  921891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  921894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921924 */     // MIs[1] Operand 1
     /*  921924 */     // No operand predicates
     /*  921924 */     // MIs[0] policy
     /*  921924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921936 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  921939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921958 */     GIR_RootConstrainSelectedInstOperands,
     /*  921959 */     // GIR_Coverage, 24201,
     /*  921959 */     GIR_EraseRootFromParent_Done,
     /*  921960 */   // Label 14011: @921960
     /*  921960 */   GIM_Try, /*On fail goto*//*Label 14012*/ GIMT_Encode4(922048), // Rule ID 24204 //
     /*  921965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  921968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  921976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  921979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  921982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922012 */     // MIs[1] Operand 1
     /*  922012 */     // No operand predicates
     /*  922012 */     // MIs[0] policy
     /*  922012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922024 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922046 */     GIR_RootConstrainSelectedInstOperands,
     /*  922047 */     // GIR_Coverage, 24204,
     /*  922047 */     GIR_EraseRootFromParent_Done,
     /*  922048 */   // Label 14012: @922048
     /*  922048 */   GIM_Try, /*On fail goto*//*Label 14013*/ GIMT_Encode4(922136), // Rule ID 24205 //
     /*  922053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  922056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  922064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  922067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  922070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922100 */     // MIs[1] Operand 1
     /*  922100 */     // No operand predicates
     /*  922100 */     // MIs[0] policy
     /*  922100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922112 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  922115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922134 */     GIR_RootConstrainSelectedInstOperands,
     /*  922135 */     // GIR_Coverage, 24205,
     /*  922135 */     GIR_EraseRootFromParent_Done,
     /*  922136 */   // Label 14013: @922136
     /*  922136 */   GIM_Try, /*On fail goto*//*Label 14014*/ GIMT_Encode4(922224), // Rule ID 24208 //
     /*  922141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  922144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922188 */     // MIs[1] Operand 1
     /*  922188 */     // No operand predicates
     /*  922188 */     // MIs[0] policy
     /*  922188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922200 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922222 */     GIR_RootConstrainSelectedInstOperands,
     /*  922223 */     // GIR_Coverage, 24208,
     /*  922223 */     GIR_EraseRootFromParent_Done,
     /*  922224 */   // Label 14014: @922224
     /*  922224 */   GIM_Try, /*On fail goto*//*Label 14015*/ GIMT_Encode4(922312), // Rule ID 24209 //
     /*  922229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  922232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  922240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  922243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  922246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922276 */     // MIs[1] Operand 1
     /*  922276 */     // No operand predicates
     /*  922276 */     // MIs[0] policy
     /*  922276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922288 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922310 */     GIR_RootConstrainSelectedInstOperands,
     /*  922311 */     // GIR_Coverage, 24209,
     /*  922311 */     GIR_EraseRootFromParent_Done,
     /*  922312 */   // Label 14015: @922312
     /*  922312 */   GIM_Try, /*On fail goto*//*Label 14016*/ GIMT_Encode4(922400), // Rule ID 24212 //
     /*  922317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  922320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  922328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  922331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  922334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922364 */     // MIs[1] Operand 1
     /*  922364 */     // No operand predicates
     /*  922364 */     // MIs[0] policy
     /*  922364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922376 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922398 */     GIR_RootConstrainSelectedInstOperands,
     /*  922399 */     // GIR_Coverage, 24212,
     /*  922399 */     GIR_EraseRootFromParent_Done,
     /*  922400 */   // Label 14016: @922400
     /*  922400 */   GIM_Try, /*On fail goto*//*Label 14017*/ GIMT_Encode4(922488), // Rule ID 24213 //
     /*  922405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  922408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  922416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  922419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  922422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922452 */     // MIs[1] Operand 1
     /*  922452 */     // No operand predicates
     /*  922452 */     // MIs[0] policy
     /*  922452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922464 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922486 */     GIR_RootConstrainSelectedInstOperands,
     /*  922487 */     // GIR_Coverage, 24213,
     /*  922487 */     GIR_EraseRootFromParent_Done,
     /*  922488 */   // Label 14017: @922488
     /*  922488 */   GIM_Try, /*On fail goto*//*Label 14018*/ GIMT_Encode4(922576), // Rule ID 24216 //
     /*  922493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  922496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  922504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  922507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  922510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922540 */     // MIs[1] Operand 1
     /*  922540 */     // No operand predicates
     /*  922540 */     // MIs[0] policy
     /*  922540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922552 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  922572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922574 */     GIR_RootConstrainSelectedInstOperands,
     /*  922575 */     // GIR_Coverage, 24216,
     /*  922575 */     GIR_EraseRootFromParent_Done,
     /*  922576 */   // Label 14018: @922576
     /*  922576 */   GIM_Try, /*On fail goto*//*Label 14019*/ GIMT_Encode4(922664), // Rule ID 24217 //
     /*  922581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  922584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  922592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  922595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  922598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922628 */     // MIs[1] Operand 1
     /*  922628 */     // No operand predicates
     /*  922628 */     // MIs[0] policy
     /*  922628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922640 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  922660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922662 */     GIR_RootConstrainSelectedInstOperands,
     /*  922663 */     // GIR_Coverage, 24217,
     /*  922663 */     GIR_EraseRootFromParent_Done,
     /*  922664 */   // Label 14019: @922664
     /*  922664 */   GIM_Try, /*On fail goto*//*Label 14020*/ GIMT_Encode4(922752), // Rule ID 24220 //
     /*  922669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  922672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  922680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  922683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  922686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922716 */     // MIs[1] Operand 1
     /*  922716 */     // No operand predicates
     /*  922716 */     // MIs[0] policy
     /*  922716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922728 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  922731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922750 */     GIR_RootConstrainSelectedInstOperands,
     /*  922751 */     // GIR_Coverage, 24220,
     /*  922751 */     GIR_EraseRootFromParent_Done,
     /*  922752 */   // Label 14020: @922752
     /*  922752 */   GIM_Try, /*On fail goto*//*Label 14021*/ GIMT_Encode4(922840), // Rule ID 24221 //
     /*  922757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  922760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  922768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  922771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  922774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922804 */     // MIs[1] Operand 1
     /*  922804 */     // No operand predicates
     /*  922804 */     // MIs[0] policy
     /*  922804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922816 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  922819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922838 */     GIR_RootConstrainSelectedInstOperands,
     /*  922839 */     // GIR_Coverage, 24221,
     /*  922839 */     GIR_EraseRootFromParent_Done,
     /*  922840 */   // Label 14021: @922840
     /*  922840 */   GIM_Try, /*On fail goto*//*Label 14022*/ GIMT_Encode4(922928), // Rule ID 24224 //
     /*  922845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  922848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  922856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  922859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  922862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922892 */     // MIs[1] Operand 1
     /*  922892 */     // No operand predicates
     /*  922892 */     // MIs[0] policy
     /*  922892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922904 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  922907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922926 */     GIR_RootConstrainSelectedInstOperands,
     /*  922927 */     // GIR_Coverage, 24224,
     /*  922927 */     GIR_EraseRootFromParent_Done,
     /*  922928 */   // Label 14022: @922928
     /*  922928 */   GIM_Try, /*On fail goto*//*Label 14023*/ GIMT_Encode4(923016), // Rule ID 24225 //
     /*  922933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  922936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  922944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  922947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  922950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922980 */     // MIs[1] Operand 1
     /*  922980 */     // No operand predicates
     /*  922980 */     // MIs[0] policy
     /*  922980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922992 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  922995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923014 */     GIR_RootConstrainSelectedInstOperands,
     /*  923015 */     // GIR_Coverage, 24225,
     /*  923015 */     GIR_EraseRootFromParent_Done,
     /*  923016 */   // Label 14023: @923016
     /*  923016 */   GIM_Try, /*On fail goto*//*Label 14024*/ GIMT_Encode4(923104), // Rule ID 24228 //
     /*  923021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  923024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  923032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  923035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  923038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923068 */     // MIs[1] Operand 1
     /*  923068 */     // No operand predicates
     /*  923068 */     // MIs[0] policy
     /*  923068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923080 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923102 */     GIR_RootConstrainSelectedInstOperands,
     /*  923103 */     // GIR_Coverage, 24228,
     /*  923103 */     GIR_EraseRootFromParent_Done,
     /*  923104 */   // Label 14024: @923104
     /*  923104 */   GIM_Try, /*On fail goto*//*Label 14025*/ GIMT_Encode4(923192), // Rule ID 24229 //
     /*  923109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  923112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  923120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  923123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  923126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923156 */     // MIs[1] Operand 1
     /*  923156 */     // No operand predicates
     /*  923156 */     // MIs[0] policy
     /*  923156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923168 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923190 */     GIR_RootConstrainSelectedInstOperands,
     /*  923191 */     // GIR_Coverage, 24229,
     /*  923191 */     GIR_EraseRootFromParent_Done,
     /*  923192 */   // Label 14025: @923192
     /*  923192 */   GIM_Try, /*On fail goto*//*Label 14026*/ GIMT_Encode4(923280), // Rule ID 24232 //
     /*  923197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  923200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  923208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  923211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  923214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923244 */     // MIs[1] Operand 1
     /*  923244 */     // No operand predicates
     /*  923244 */     // MIs[0] policy
     /*  923244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923256 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923278 */     GIR_RootConstrainSelectedInstOperands,
     /*  923279 */     // GIR_Coverage, 24232,
     /*  923279 */     GIR_EraseRootFromParent_Done,
     /*  923280 */   // Label 14026: @923280
     /*  923280 */   GIM_Try, /*On fail goto*//*Label 14027*/ GIMT_Encode4(923368), // Rule ID 24233 //
     /*  923285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  923288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  923296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  923299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  923302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923332 */     // MIs[1] Operand 1
     /*  923332 */     // No operand predicates
     /*  923332 */     // MIs[0] policy
     /*  923332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923344 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923366 */     GIR_RootConstrainSelectedInstOperands,
     /*  923367 */     // GIR_Coverage, 24233,
     /*  923367 */     GIR_EraseRootFromParent_Done,
     /*  923368 */   // Label 14027: @923368
     /*  923368 */   GIM_Try, /*On fail goto*//*Label 14028*/ GIMT_Encode4(923456), // Rule ID 24236 //
     /*  923373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  923376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  923390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923420 */     // MIs[1] Operand 1
     /*  923420 */     // No operand predicates
     /*  923420 */     // MIs[0] policy
     /*  923420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923432 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923454 */     GIR_RootConstrainSelectedInstOperands,
     /*  923455 */     // GIR_Coverage, 24236,
     /*  923455 */     GIR_EraseRootFromParent_Done,
     /*  923456 */   // Label 14028: @923456
     /*  923456 */   GIM_Try, /*On fail goto*//*Label 14029*/ GIMT_Encode4(923544), // Rule ID 24237 //
     /*  923461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  923464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  923472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  923475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  923478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923508 */     // MIs[1] Operand 1
     /*  923508 */     // No operand predicates
     /*  923508 */     // MIs[0] policy
     /*  923508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923520 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923542 */     GIR_RootConstrainSelectedInstOperands,
     /*  923543 */     // GIR_Coverage, 24237,
     /*  923543 */     GIR_EraseRootFromParent_Done,
     /*  923544 */   // Label 14029: @923544
     /*  923544 */   GIM_Try, /*On fail goto*//*Label 14030*/ GIMT_Encode4(923632), // Rule ID 24240 //
     /*  923549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  923552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  923560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  923563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  923566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923596 */     // MIs[1] Operand 1
     /*  923596 */     // No operand predicates
     /*  923596 */     // MIs[0] policy
     /*  923596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923608 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923630 */     GIR_RootConstrainSelectedInstOperands,
     /*  923631 */     // GIR_Coverage, 24240,
     /*  923631 */     GIR_EraseRootFromParent_Done,
     /*  923632 */   // Label 14030: @923632
     /*  923632 */   GIM_Try, /*On fail goto*//*Label 14031*/ GIMT_Encode4(923720), // Rule ID 24241 //
     /*  923637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  923640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  923648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  923651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  923654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923684 */     // MIs[1] Operand 1
     /*  923684 */     // No operand predicates
     /*  923684 */     // MIs[0] policy
     /*  923684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923696 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923718 */     GIR_RootConstrainSelectedInstOperands,
     /*  923719 */     // GIR_Coverage, 24241,
     /*  923719 */     GIR_EraseRootFromParent_Done,
     /*  923720 */   // Label 14031: @923720
     /*  923720 */   GIM_Try, /*On fail goto*//*Label 14032*/ GIMT_Encode4(923808), // Rule ID 24244 //
     /*  923725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  923728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  923736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  923739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  923742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923772 */     // MIs[1] Operand 1
     /*  923772 */     // No operand predicates
     /*  923772 */     // MIs[0] policy
     /*  923772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923806 */     GIR_RootConstrainSelectedInstOperands,
     /*  923807 */     // GIR_Coverage, 24244,
     /*  923807 */     GIR_EraseRootFromParent_Done,
     /*  923808 */   // Label 14032: @923808
     /*  923808 */   GIM_Try, /*On fail goto*//*Label 14033*/ GIMT_Encode4(923896), // Rule ID 24245 //
     /*  923813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  923816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  923824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  923827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  923830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923860 */     // MIs[1] Operand 1
     /*  923860 */     // No operand predicates
     /*  923860 */     // MIs[0] policy
     /*  923860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923894 */     GIR_RootConstrainSelectedInstOperands,
     /*  923895 */     // GIR_Coverage, 24245,
     /*  923895 */     GIR_EraseRootFromParent_Done,
     /*  923896 */   // Label 14033: @923896
     /*  923896 */   GIM_Try, /*On fail goto*//*Label 14034*/ GIMT_Encode4(923984), // Rule ID 24248 //
     /*  923901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  923904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  923912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  923915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  923918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923948 */     // MIs[1] Operand 1
     /*  923948 */     // No operand predicates
     /*  923948 */     // MIs[0] policy
     /*  923948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923960 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923982 */     GIR_RootConstrainSelectedInstOperands,
     /*  923983 */     // GIR_Coverage, 24248,
     /*  923983 */     GIR_EraseRootFromParent_Done,
     /*  923984 */   // Label 14034: @923984
     /*  923984 */   GIM_Try, /*On fail goto*//*Label 14035*/ GIMT_Encode4(924072), // Rule ID 24249 //
     /*  923989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  923992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  924000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  924003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  924006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  924024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924036 */     // MIs[1] Operand 1
     /*  924036 */     // No operand predicates
     /*  924036 */     // MIs[0] policy
     /*  924036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924048 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  924051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924070 */     GIR_RootConstrainSelectedInstOperands,
     /*  924071 */     // GIR_Coverage, 24249,
     /*  924071 */     GIR_EraseRootFromParent_Done,
     /*  924072 */   // Label 14035: @924072
     /*  924072 */   GIM_Try, /*On fail goto*//*Label 14036*/ GIMT_Encode4(924160), // Rule ID 24252 //
     /*  924077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  924080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  924088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  924091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  924094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924124 */     // MIs[1] Operand 1
     /*  924124 */     // No operand predicates
     /*  924124 */     // MIs[0] policy
     /*  924124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924136 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924158 */     GIR_RootConstrainSelectedInstOperands,
     /*  924159 */     // GIR_Coverage, 24252,
     /*  924159 */     GIR_EraseRootFromParent_Done,
     /*  924160 */   // Label 14036: @924160
     /*  924160 */   GIM_Try, /*On fail goto*//*Label 14037*/ GIMT_Encode4(924248), // Rule ID 24253 //
     /*  924165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  924168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  924173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  924176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  924179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  924182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  924200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924212 */     // MIs[1] Operand 1
     /*  924212 */     // No operand predicates
     /*  924212 */     // MIs[0] policy
     /*  924212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924224 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  924227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924246 */     GIR_RootConstrainSelectedInstOperands,
     /*  924247 */     // GIR_Coverage, 24253,
     /*  924247 */     GIR_EraseRootFromParent_Done,
     /*  924248 */   // Label 14037: @924248
     /*  924248 */   GIM_Try, /*On fail goto*//*Label 14038*/ GIMT_Encode4(924336), // Rule ID 24316 //
     /*  924253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  924256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924300 */     // MIs[1] Operand 1
     /*  924300 */     // No operand predicates
     /*  924300 */     // MIs[0] policy
     /*  924300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924312 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  924315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924334 */     GIR_RootConstrainSelectedInstOperands,
     /*  924335 */     // GIR_Coverage, 24316,
     /*  924335 */     GIR_EraseRootFromParent_Done,
     /*  924336 */   // Label 14038: @924336
     /*  924336 */   GIM_Try, /*On fail goto*//*Label 14039*/ GIMT_Encode4(924424), // Rule ID 24317 //
     /*  924341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  924344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  924352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  924355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  924358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924388 */     // MIs[1] Operand 1
     /*  924388 */     // No operand predicates
     /*  924388 */     // MIs[0] policy
     /*  924388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924400 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  924403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924422 */     GIR_RootConstrainSelectedInstOperands,
     /*  924423 */     // GIR_Coverage, 24317,
     /*  924423 */     GIR_EraseRootFromParent_Done,
     /*  924424 */   // Label 14039: @924424
     /*  924424 */   GIM_Try, /*On fail goto*//*Label 14040*/ GIMT_Encode4(924512), // Rule ID 24320 //
     /*  924429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  924432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  924446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924476 */     // MIs[1] Operand 1
     /*  924476 */     // No operand predicates
     /*  924476 */     // MIs[0] policy
     /*  924476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924488 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924510 */     GIR_RootConstrainSelectedInstOperands,
     /*  924511 */     // GIR_Coverage, 24320,
     /*  924511 */     GIR_EraseRootFromParent_Done,
     /*  924512 */   // Label 14040: @924512
     /*  924512 */   GIM_Try, /*On fail goto*//*Label 14041*/ GIMT_Encode4(924600), // Rule ID 24321 //
     /*  924517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  924520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  924534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924564 */     // MIs[1] Operand 1
     /*  924564 */     // No operand predicates
     /*  924564 */     // MIs[0] policy
     /*  924564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924576 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924598 */     GIR_RootConstrainSelectedInstOperands,
     /*  924599 */     // GIR_Coverage, 24321,
     /*  924599 */     GIR_EraseRootFromParent_Done,
     /*  924600 */   // Label 14041: @924600
     /*  924600 */   GIM_Try, /*On fail goto*//*Label 14042*/ GIMT_Encode4(924688), // Rule ID 24324 //
     /*  924605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  924608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  924616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  924619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  924622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924652 */     // MIs[1] Operand 1
     /*  924652 */     // No operand predicates
     /*  924652 */     // MIs[0] policy
     /*  924652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924664 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924686 */     GIR_RootConstrainSelectedInstOperands,
     /*  924687 */     // GIR_Coverage, 24324,
     /*  924687 */     GIR_EraseRootFromParent_Done,
     /*  924688 */   // Label 14042: @924688
     /*  924688 */   GIM_Try, /*On fail goto*//*Label 14043*/ GIMT_Encode4(924776), // Rule ID 24325 //
     /*  924693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  924696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  924704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  924707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  924710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924740 */     // MIs[1] Operand 1
     /*  924740 */     // No operand predicates
     /*  924740 */     // MIs[0] policy
     /*  924740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924752 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924774 */     GIR_RootConstrainSelectedInstOperands,
     /*  924775 */     // GIR_Coverage, 24325,
     /*  924775 */     GIR_EraseRootFromParent_Done,
     /*  924776 */   // Label 14043: @924776
     /*  924776 */   GIM_Try, /*On fail goto*//*Label 14044*/ GIMT_Encode4(924864), // Rule ID 24328 //
     /*  924781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  924784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  924792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  924795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  924798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924828 */     // MIs[1] Operand 1
     /*  924828 */     // No operand predicates
     /*  924828 */     // MIs[0] policy
     /*  924828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924840 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924862 */     GIR_RootConstrainSelectedInstOperands,
     /*  924863 */     // GIR_Coverage, 24328,
     /*  924863 */     GIR_EraseRootFromParent_Done,
     /*  924864 */   // Label 14044: @924864
     /*  924864 */   GIM_Try, /*On fail goto*//*Label 14045*/ GIMT_Encode4(924952), // Rule ID 24329 //
     /*  924869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  924872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  924880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  924883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  924886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924916 */     // MIs[1] Operand 1
     /*  924916 */     // No operand predicates
     /*  924916 */     // MIs[0] policy
     /*  924916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924928 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924950 */     GIR_RootConstrainSelectedInstOperands,
     /*  924951 */     // GIR_Coverage, 24329,
     /*  924951 */     GIR_EraseRootFromParent_Done,
     /*  924952 */   // Label 14045: @924952
     /*  924952 */   GIM_Try, /*On fail goto*//*Label 14046*/ GIMT_Encode4(925040), // Rule ID 24332 //
     /*  924957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  924960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  924968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  924971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  924974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925004 */     // MIs[1] Operand 1
     /*  925004 */     // No operand predicates
     /*  925004 */     // MIs[0] policy
     /*  925004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925016 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925038 */     GIR_RootConstrainSelectedInstOperands,
     /*  925039 */     // GIR_Coverage, 24332,
     /*  925039 */     GIR_EraseRootFromParent_Done,
     /*  925040 */   // Label 14046: @925040
     /*  925040 */   GIM_Try, /*On fail goto*//*Label 14047*/ GIMT_Encode4(925128), // Rule ID 24333 //
     /*  925045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  925048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  925056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  925059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  925062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925092 */     // MIs[1] Operand 1
     /*  925092 */     // No operand predicates
     /*  925092 */     // MIs[0] policy
     /*  925092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925126 */     GIR_RootConstrainSelectedInstOperands,
     /*  925127 */     // GIR_Coverage, 24333,
     /*  925127 */     GIR_EraseRootFromParent_Done,
     /*  925128 */   // Label 14047: @925128
     /*  925128 */   GIM_Try, /*On fail goto*//*Label 14048*/ GIMT_Encode4(925216), // Rule ID 24336 //
     /*  925133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  925136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925180 */     // MIs[1] Operand 1
     /*  925180 */     // No operand predicates
     /*  925180 */     // MIs[0] policy
     /*  925180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925192 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925214 */     GIR_RootConstrainSelectedInstOperands,
     /*  925215 */     // GIR_Coverage, 24336,
     /*  925215 */     GIR_EraseRootFromParent_Done,
     /*  925216 */   // Label 14048: @925216
     /*  925216 */   GIM_Try, /*On fail goto*//*Label 14049*/ GIMT_Encode4(925304), // Rule ID 24337 //
     /*  925221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  925224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  925232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  925235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  925238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  925256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925268 */     // MIs[1] Operand 1
     /*  925268 */     // No operand predicates
     /*  925268 */     // MIs[0] policy
     /*  925268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925280 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  925283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925302 */     GIR_RootConstrainSelectedInstOperands,
     /*  925303 */     // GIR_Coverage, 24337,
     /*  925303 */     GIR_EraseRootFromParent_Done,
     /*  925304 */   // Label 14049: @925304
     /*  925304 */   GIM_Try, /*On fail goto*//*Label 14050*/ GIMT_Encode4(925392), // Rule ID 24340 //
     /*  925309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  925312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925356 */     // MIs[1] Operand 1
     /*  925356 */     // No operand predicates
     /*  925356 */     // MIs[0] policy
     /*  925356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925368 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925390 */     GIR_RootConstrainSelectedInstOperands,
     /*  925391 */     // GIR_Coverage, 24340,
     /*  925391 */     GIR_EraseRootFromParent_Done,
     /*  925392 */   // Label 14050: @925392
     /*  925392 */   GIM_Try, /*On fail goto*//*Label 14051*/ GIMT_Encode4(925480), // Rule ID 24341 //
     /*  925397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  925400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  925408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  925411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  925414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925444 */     // MIs[1] Operand 1
     /*  925444 */     // No operand predicates
     /*  925444 */     // MIs[0] policy
     /*  925444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925456 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925478 */     GIR_RootConstrainSelectedInstOperands,
     /*  925479 */     // GIR_Coverage, 24341,
     /*  925479 */     GIR_EraseRootFromParent_Done,
     /*  925480 */   // Label 14051: @925480
     /*  925480 */   GIM_Try, /*On fail goto*//*Label 14052*/ GIMT_Encode4(925568), // Rule ID 24344 //
     /*  925485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  925488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  925496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  925499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  925502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925532 */     // MIs[1] Operand 1
     /*  925532 */     // No operand predicates
     /*  925532 */     // MIs[0] policy
     /*  925532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925544 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925566 */     GIR_RootConstrainSelectedInstOperands,
     /*  925567 */     // GIR_Coverage, 24344,
     /*  925567 */     GIR_EraseRootFromParent_Done,
     /*  925568 */   // Label 14052: @925568
     /*  925568 */   GIM_Try, /*On fail goto*//*Label 14053*/ GIMT_Encode4(925656), // Rule ID 24345 //
     /*  925573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  925576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  925584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  925587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  925590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925620 */     // MIs[1] Operand 1
     /*  925620 */     // No operand predicates
     /*  925620 */     // MIs[0] policy
     /*  925620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925632 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925654 */     GIR_RootConstrainSelectedInstOperands,
     /*  925655 */     // GIR_Coverage, 24345,
     /*  925655 */     GIR_EraseRootFromParent_Done,
     /*  925656 */   // Label 14053: @925656
     /*  925656 */   GIM_Try, /*On fail goto*//*Label 14054*/ GIMT_Encode4(925744), // Rule ID 24348 //
     /*  925661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  925664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  925672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  925675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  925678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925708 */     // MIs[1] Operand 1
     /*  925708 */     // No operand predicates
     /*  925708 */     // MIs[0] policy
     /*  925708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925720 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925742 */     GIR_RootConstrainSelectedInstOperands,
     /*  925743 */     // GIR_Coverage, 24348,
     /*  925743 */     GIR_EraseRootFromParent_Done,
     /*  925744 */   // Label 14054: @925744
     /*  925744 */   GIM_Try, /*On fail goto*//*Label 14055*/ GIMT_Encode4(925832), // Rule ID 24349 //
     /*  925749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  925752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  925760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  925763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  925766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925796 */     // MIs[1] Operand 1
     /*  925796 */     // No operand predicates
     /*  925796 */     // MIs[0] policy
     /*  925796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925808 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925830 */     GIR_RootConstrainSelectedInstOperands,
     /*  925831 */     // GIR_Coverage, 24349,
     /*  925831 */     GIR_EraseRootFromParent_Done,
     /*  925832 */   // Label 14055: @925832
     /*  925832 */   GIM_Try, /*On fail goto*//*Label 14056*/ GIMT_Encode4(925920), // Rule ID 24352 //
     /*  925837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  925840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  925848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  925851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  925854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925884 */     // MIs[1] Operand 1
     /*  925884 */     // No operand predicates
     /*  925884 */     // MIs[0] policy
     /*  925884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925896 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925918 */     GIR_RootConstrainSelectedInstOperands,
     /*  925919 */     // GIR_Coverage, 24352,
     /*  925919 */     GIR_EraseRootFromParent_Done,
     /*  925920 */   // Label 14056: @925920
     /*  925920 */   GIM_Try, /*On fail goto*//*Label 14057*/ GIMT_Encode4(926008), // Rule ID 24353 //
     /*  925925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  925928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  925936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  925939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  925942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925972 */     // MIs[1] Operand 1
     /*  925972 */     // No operand predicates
     /*  925972 */     // MIs[0] policy
     /*  925972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926006 */     GIR_RootConstrainSelectedInstOperands,
     /*  926007 */     // GIR_Coverage, 24353,
     /*  926007 */     GIR_EraseRootFromParent_Done,
     /*  926008 */   // Label 14057: @926008
     /*  926008 */   GIM_Try, /*On fail goto*//*Label 14058*/ GIMT_Encode4(926096), // Rule ID 24356 //
     /*  926013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  926016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926060 */     // MIs[1] Operand 1
     /*  926060 */     // No operand predicates
     /*  926060 */     // MIs[0] policy
     /*  926060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926072 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926094 */     GIR_RootConstrainSelectedInstOperands,
     /*  926095 */     // GIR_Coverage, 24356,
     /*  926095 */     GIR_EraseRootFromParent_Done,
     /*  926096 */   // Label 14058: @926096
     /*  926096 */   GIM_Try, /*On fail goto*//*Label 14059*/ GIMT_Encode4(926184), // Rule ID 24357 //
     /*  926101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  926104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  926112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  926115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  926118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926148 */     // MIs[1] Operand 1
     /*  926148 */     // No operand predicates
     /*  926148 */     // MIs[0] policy
     /*  926148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926160 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926182 */     GIR_RootConstrainSelectedInstOperands,
     /*  926183 */     // GIR_Coverage, 24357,
     /*  926183 */     GIR_EraseRootFromParent_Done,
     /*  926184 */   // Label 14059: @926184
     /*  926184 */   GIM_Try, /*On fail goto*//*Label 14060*/ GIMT_Encode4(926272), // Rule ID 24360 //
     /*  926189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  926192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926236 */     // MIs[1] Operand 1
     /*  926236 */     // No operand predicates
     /*  926236 */     // MIs[0] policy
     /*  926236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926248 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926270 */     GIR_RootConstrainSelectedInstOperands,
     /*  926271 */     // GIR_Coverage, 24360,
     /*  926271 */     GIR_EraseRootFromParent_Done,
     /*  926272 */   // Label 14060: @926272
     /*  926272 */   GIM_Try, /*On fail goto*//*Label 14061*/ GIMT_Encode4(926360), // Rule ID 24361 //
     /*  926277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  926280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  926288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  926291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  926294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926324 */     // MIs[1] Operand 1
     /*  926324 */     // No operand predicates
     /*  926324 */     // MIs[0] policy
     /*  926324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926336 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  926356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926358 */     GIR_RootConstrainSelectedInstOperands,
     /*  926359 */     // GIR_Coverage, 24361,
     /*  926359 */     GIR_EraseRootFromParent_Done,
     /*  926360 */   // Label 14061: @926360
     /*  926360 */   GIM_Try, /*On fail goto*//*Label 14062*/ GIMT_Encode4(926448), // Rule ID 24364 //
     /*  926365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  926368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926412 */     // MIs[1] Operand 1
     /*  926412 */     // No operand predicates
     /*  926412 */     // MIs[0] policy
     /*  926412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926424 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926446 */     GIR_RootConstrainSelectedInstOperands,
     /*  926447 */     // GIR_Coverage, 24364,
     /*  926447 */     GIR_EraseRootFromParent_Done,
     /*  926448 */   // Label 14062: @926448
     /*  926448 */   GIM_Try, /*On fail goto*//*Label 14063*/ GIMT_Encode4(926536), // Rule ID 24365 //
     /*  926453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  926456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  926464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  926467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  926470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  926488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926500 */     // MIs[1] Operand 1
     /*  926500 */     // No operand predicates
     /*  926500 */     // MIs[0] policy
     /*  926500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926512 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926534 */     GIR_RootConstrainSelectedInstOperands,
     /*  926535 */     // GIR_Coverage, 24365,
     /*  926535 */     GIR_EraseRootFromParent_Done,
     /*  926536 */   // Label 14063: @926536
     /*  926536 */   GIM_Try, /*On fail goto*//*Label 14064*/ GIMT_Encode4(926624), // Rule ID 24368 //
     /*  926541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  926544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  926552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  926555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  926558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926588 */     // MIs[1] Operand 1
     /*  926588 */     // No operand predicates
     /*  926588 */     // MIs[0] policy
     /*  926588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926600 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926622 */     GIR_RootConstrainSelectedInstOperands,
     /*  926623 */     // GIR_Coverage, 24368,
     /*  926623 */     GIR_EraseRootFromParent_Done,
     /*  926624 */   // Label 14064: @926624
     /*  926624 */   GIM_Try, /*On fail goto*//*Label 14065*/ GIMT_Encode4(926712), // Rule ID 24369 //
     /*  926629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  926632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  926640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  926643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  926646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926676 */     // MIs[1] Operand 1
     /*  926676 */     // No operand predicates
     /*  926676 */     // MIs[0] policy
     /*  926676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926688 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926710 */     GIR_RootConstrainSelectedInstOperands,
     /*  926711 */     // GIR_Coverage, 24369,
     /*  926711 */     GIR_EraseRootFromParent_Done,
     /*  926712 */   // Label 14065: @926712
     /*  926712 */   GIM_Try, /*On fail goto*//*Label 14066*/ GIMT_Encode4(926800), // Rule ID 24372 //
     /*  926717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  926720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  926728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  926731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  926734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926764 */     // MIs[1] Operand 1
     /*  926764 */     // No operand predicates
     /*  926764 */     // MIs[0] policy
     /*  926764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926776 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926798 */     GIR_RootConstrainSelectedInstOperands,
     /*  926799 */     // GIR_Coverage, 24372,
     /*  926799 */     GIR_EraseRootFromParent_Done,
     /*  926800 */   // Label 14066: @926800
     /*  926800 */   GIM_Try, /*On fail goto*//*Label 14067*/ GIMT_Encode4(926888), // Rule ID 24373 //
     /*  926805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  926808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  926816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  926819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  926822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926852 */     // MIs[1] Operand 1
     /*  926852 */     // No operand predicates
     /*  926852 */     // MIs[0] policy
     /*  926852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926864 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926886 */     GIR_RootConstrainSelectedInstOperands,
     /*  926887 */     // GIR_Coverage, 24373,
     /*  926887 */     GIR_EraseRootFromParent_Done,
     /*  926888 */   // Label 14067: @926888
     /*  926888 */   GIM_Try, /*On fail goto*//*Label 14068*/ GIMT_Encode4(926979), // Rule ID 15984 //
     /*  926893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  926904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  926907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  926910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  926916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926940 */     // MIs[1] Operand 1
     /*  926940 */     // No operand predicates
     /*  926940 */     // MIs[0] round
     /*  926940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  926943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  926952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  926955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  926959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926964 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  926966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  926974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  926977 */     GIR_RootConstrainSelectedInstOperands,
     /*  926978 */     // GIR_Coverage, 15984,
     /*  926978 */     GIR_EraseRootFromParent_Done,
     /*  926979 */   // Label 14068: @926979
     /*  926979 */   GIM_Try, /*On fail goto*//*Label 14069*/ GIMT_Encode4(927070), // Rule ID 15985 //
     /*  926984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  926995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  926998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  927001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927031 */     // MIs[1] Operand 1
     /*  927031 */     // No operand predicates
     /*  927031 */     // MIs[0] round
     /*  927031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927043 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  927046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927068 */     GIR_RootConstrainSelectedInstOperands,
     /*  927069 */     // GIR_Coverage, 15985,
     /*  927069 */     GIR_EraseRootFromParent_Done,
     /*  927070 */   // Label 14069: @927070
     /*  927070 */   GIM_Try, /*On fail goto*//*Label 14070*/ GIMT_Encode4(927161), // Rule ID 15988 //
     /*  927075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  927092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927122 */     // MIs[1] Operand 1
     /*  927122 */     // No operand predicates
     /*  927122 */     // MIs[0] round
     /*  927122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927134 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927146 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927159 */     GIR_RootConstrainSelectedInstOperands,
     /*  927160 */     // GIR_Coverage, 15988,
     /*  927160 */     GIR_EraseRootFromParent_Done,
     /*  927161 */   // Label 14070: @927161
     /*  927161 */   GIM_Try, /*On fail goto*//*Label 14071*/ GIMT_Encode4(927252), // Rule ID 15989 //
     /*  927166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  927177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  927180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  927183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927213 */     // MIs[1] Operand 1
     /*  927213 */     // No operand predicates
     /*  927213 */     // MIs[0] round
     /*  927213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927225 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927250 */     GIR_RootConstrainSelectedInstOperands,
     /*  927251 */     // GIR_Coverage, 15989,
     /*  927251 */     GIR_EraseRootFromParent_Done,
     /*  927252 */   // Label 14071: @927252
     /*  927252 */   GIM_Try, /*On fail goto*//*Label 14072*/ GIMT_Encode4(927343), // Rule ID 15992 //
     /*  927257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  927274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927304 */     // MIs[1] Operand 1
     /*  927304 */     // No operand predicates
     /*  927304 */     // MIs[0] round
     /*  927304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927316 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927328 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927341 */     GIR_RootConstrainSelectedInstOperands,
     /*  927342 */     // GIR_Coverage, 15992,
     /*  927342 */     GIR_EraseRootFromParent_Done,
     /*  927343 */   // Label 14072: @927343
     /*  927343 */   GIM_Try, /*On fail goto*//*Label 14073*/ GIMT_Encode4(927434), // Rule ID 15993 //
     /*  927348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  927359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  927362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  927365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927395 */     // MIs[1] Operand 1
     /*  927395 */     // No operand predicates
     /*  927395 */     // MIs[0] round
     /*  927395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927407 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927432 */     GIR_RootConstrainSelectedInstOperands,
     /*  927433 */     // GIR_Coverage, 15993,
     /*  927433 */     GIR_EraseRootFromParent_Done,
     /*  927434 */   // Label 14073: @927434
     /*  927434 */   GIM_Try, /*On fail goto*//*Label 14074*/ GIMT_Encode4(927525), // Rule ID 15996 //
     /*  927439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  927450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  927453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  927456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927486 */     // MIs[1] Operand 1
     /*  927486 */     // No operand predicates
     /*  927486 */     // MIs[0] round
     /*  927486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927498 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  927498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927523 */     GIR_RootConstrainSelectedInstOperands,
     /*  927524 */     // GIR_Coverage, 15996,
     /*  927524 */     GIR_EraseRootFromParent_Done,
     /*  927525 */   // Label 14074: @927525
     /*  927525 */   GIM_Try, /*On fail goto*//*Label 14075*/ GIMT_Encode4(927616), // Rule ID 15997 //
     /*  927530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  927541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  927544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  927547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927577 */     // MIs[1] Operand 1
     /*  927577 */     // No operand predicates
     /*  927577 */     // MIs[0] round
     /*  927577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927589 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  927589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927614 */     GIR_RootConstrainSelectedInstOperands,
     /*  927615 */     // GIR_Coverage, 15997,
     /*  927615 */     GIR_EraseRootFromParent_Done,
     /*  927616 */   // Label 14075: @927616
     /*  927616 */   GIM_Try, /*On fail goto*//*Label 14076*/ GIMT_Encode4(927707), // Rule ID 16000 //
     /*  927621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  927632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  927635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  927638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927668 */     // MIs[1] Operand 1
     /*  927668 */     // No operand predicates
     /*  927668 */     // MIs[0] round
     /*  927668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927680 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  927680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927692 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927705 */     GIR_RootConstrainSelectedInstOperands,
     /*  927706 */     // GIR_Coverage, 16000,
     /*  927706 */     GIR_EraseRootFromParent_Done,
     /*  927707 */   // Label 14076: @927707
     /*  927707 */   GIM_Try, /*On fail goto*//*Label 14077*/ GIMT_Encode4(927798), // Rule ID 16001 //
     /*  927712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  927723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  927726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  927729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927759 */     // MIs[1] Operand 1
     /*  927759 */     // No operand predicates
     /*  927759 */     // MIs[0] round
     /*  927759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927771 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  927771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927796 */     GIR_RootConstrainSelectedInstOperands,
     /*  927797 */     // GIR_Coverage, 16001,
     /*  927797 */     GIR_EraseRootFromParent_Done,
     /*  927798 */   // Label 14077: @927798
     /*  927798 */   GIM_Try, /*On fail goto*//*Label 14078*/ GIMT_Encode4(927889), // Rule ID 16004 //
     /*  927803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  927814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  927817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  927820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927850 */     // MIs[1] Operand 1
     /*  927850 */     // No operand predicates
     /*  927850 */     // MIs[0] round
     /*  927850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927862 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  927862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927874 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927887 */     GIR_RootConstrainSelectedInstOperands,
     /*  927888 */     // GIR_Coverage, 16004,
     /*  927888 */     GIR_EraseRootFromParent_Done,
     /*  927889 */   // Label 14078: @927889
     /*  927889 */   GIM_Try, /*On fail goto*//*Label 14079*/ GIMT_Encode4(927980), // Rule ID 16005 //
     /*  927894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  927905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  927908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  927911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927941 */     // MIs[1] Operand 1
     /*  927941 */     // No operand predicates
     /*  927941 */     // MIs[0] round
     /*  927941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927953 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  927953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927978 */     GIR_RootConstrainSelectedInstOperands,
     /*  927979 */     // GIR_Coverage, 16005,
     /*  927979 */     GIR_EraseRootFromParent_Done,
     /*  927980 */   // Label 14079: @927980
     /*  927980 */   GIM_Try, /*On fail goto*//*Label 14080*/ GIMT_Encode4(928071), // Rule ID 16008 //
     /*  927985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  927996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  927999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  928002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928032 */     // MIs[1] Operand 1
     /*  928032 */     // No operand predicates
     /*  928032 */     // MIs[0] round
     /*  928032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928056 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928069 */     GIR_RootConstrainSelectedInstOperands,
     /*  928070 */     // GIR_Coverage, 16008,
     /*  928070 */     GIR_EraseRootFromParent_Done,
     /*  928071 */   // Label 14080: @928071
     /*  928071 */   GIM_Try, /*On fail goto*//*Label 14081*/ GIMT_Encode4(928162), // Rule ID 16009 //
     /*  928076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  928087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  928090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  928093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928123 */     // MIs[1] Operand 1
     /*  928123 */     // No operand predicates
     /*  928123 */     // MIs[0] round
     /*  928123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928135 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  928135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928160 */     GIR_RootConstrainSelectedInstOperands,
     /*  928161 */     // GIR_Coverage, 16009,
     /*  928161 */     GIR_EraseRootFromParent_Done,
     /*  928162 */   // Label 14081: @928162
     /*  928162 */   GIM_Try, /*On fail goto*//*Label 14082*/ GIMT_Encode4(928253), // Rule ID 16012 //
     /*  928167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928214 */     // MIs[1] Operand 1
     /*  928214 */     // No operand predicates
     /*  928214 */     // MIs[0] round
     /*  928214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928226 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  928226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928238 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928251 */     GIR_RootConstrainSelectedInstOperands,
     /*  928252 */     // GIR_Coverage, 16012,
     /*  928252 */     GIR_EraseRootFromParent_Done,
     /*  928253 */   // Label 14082: @928253
     /*  928253 */   GIM_Try, /*On fail goto*//*Label 14083*/ GIMT_Encode4(928344), // Rule ID 16013 //
     /*  928258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  928269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  928272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  928275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928305 */     // MIs[1] Operand 1
     /*  928305 */     // No operand predicates
     /*  928305 */     // MIs[0] round
     /*  928305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928317 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  928317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928342 */     GIR_RootConstrainSelectedInstOperands,
     /*  928343 */     // GIR_Coverage, 16013,
     /*  928343 */     GIR_EraseRootFromParent_Done,
     /*  928344 */   // Label 14083: @928344
     /*  928344 */   GIM_Try, /*On fail goto*//*Label 14084*/ GIMT_Encode4(928435), // Rule ID 16016 //
     /*  928349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928396 */     // MIs[1] Operand 1
     /*  928396 */     // No operand predicates
     /*  928396 */     // MIs[0] round
     /*  928396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  928408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928420 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928433 */     GIR_RootConstrainSelectedInstOperands,
     /*  928434 */     // GIR_Coverage, 16016,
     /*  928434 */     GIR_EraseRootFromParent_Done,
     /*  928435 */   // Label 14084: @928435
     /*  928435 */   GIM_Try, /*On fail goto*//*Label 14085*/ GIMT_Encode4(928526), // Rule ID 16017 //
     /*  928440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  928451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  928454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  928457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928487 */     // MIs[1] Operand 1
     /*  928487 */     // No operand predicates
     /*  928487 */     // MIs[0] round
     /*  928487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928499 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  928499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928524 */     GIR_RootConstrainSelectedInstOperands,
     /*  928525 */     // GIR_Coverage, 16017,
     /*  928525 */     GIR_EraseRootFromParent_Done,
     /*  928526 */   // Label 14085: @928526
     /*  928526 */   GIM_Try, /*On fail goto*//*Label 14086*/ GIMT_Encode4(928617), // Rule ID 16020 //
     /*  928531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  928534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  928548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928578 */     // MIs[1] Operand 1
     /*  928578 */     // No operand predicates
     /*  928578 */     // MIs[0] round
     /*  928578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928590 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  928590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928602 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928615 */     GIR_RootConstrainSelectedInstOperands,
     /*  928616 */     // GIR_Coverage, 16020,
     /*  928616 */     GIR_EraseRootFromParent_Done,
     /*  928617 */   // Label 14086: @928617
     /*  928617 */   GIM_Try, /*On fail goto*//*Label 14087*/ GIMT_Encode4(928708), // Rule ID 16021 //
     /*  928622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  928625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  928639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928669 */     // MIs[1] Operand 1
     /*  928669 */     // No operand predicates
     /*  928669 */     // MIs[0] round
     /*  928669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928681 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  928681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928706 */     GIR_RootConstrainSelectedInstOperands,
     /*  928707 */     // GIR_Coverage, 16021,
     /*  928707 */     GIR_EraseRootFromParent_Done,
     /*  928708 */   // Label 14087: @928708
     /*  928708 */   GIM_Try, /*On fail goto*//*Label 14088*/ GIMT_Encode4(928799), // Rule ID 16024 //
     /*  928713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  928724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  928727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  928730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928760 */     // MIs[1] Operand 1
     /*  928760 */     // No operand predicates
     /*  928760 */     // MIs[0] round
     /*  928760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  928775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928784 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928797 */     GIR_RootConstrainSelectedInstOperands,
     /*  928798 */     // GIR_Coverage, 16024,
     /*  928798 */     GIR_EraseRootFromParent_Done,
     /*  928799 */   // Label 14088: @928799
     /*  928799 */   GIM_Try, /*On fail goto*//*Label 14089*/ GIMT_Encode4(928890), // Rule ID 16025 //
     /*  928804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  928815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  928818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  928821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928851 */     // MIs[1] Operand 1
     /*  928851 */     // No operand predicates
     /*  928851 */     // MIs[0] round
     /*  928851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928863 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  928863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  928866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928888 */     GIR_RootConstrainSelectedInstOperands,
     /*  928889 */     // GIR_Coverage, 16025,
     /*  928889 */     GIR_EraseRootFromParent_Done,
     /*  928890 */   // Label 14089: @928890
     /*  928890 */   GIM_Try, /*On fail goto*//*Label 14090*/ GIMT_Encode4(928981), // Rule ID 16028 //
     /*  928895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  928906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  928909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  928912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928942 */     // MIs[1] Operand 1
     /*  928942 */     // No operand predicates
     /*  928942 */     // MIs[0] round
     /*  928942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928954 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  928957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928979 */     GIR_RootConstrainSelectedInstOperands,
     /*  928980 */     // GIR_Coverage, 16028,
     /*  928980 */     GIR_EraseRootFromParent_Done,
     /*  928981 */   // Label 14090: @928981
     /*  928981 */   GIM_Try, /*On fail goto*//*Label 14091*/ GIMT_Encode4(929072), // Rule ID 16029 //
     /*  928986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  928997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  929000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  929003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929033 */     // MIs[1] Operand 1
     /*  929033 */     // No operand predicates
     /*  929033 */     // MIs[0] round
     /*  929033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929045 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929070 */     GIR_RootConstrainSelectedInstOperands,
     /*  929071 */     // GIR_Coverage, 16029,
     /*  929071 */     GIR_EraseRootFromParent_Done,
     /*  929072 */   // Label 14091: @929072
     /*  929072 */   GIM_Try, /*On fail goto*//*Label 14092*/ GIMT_Encode4(929163), // Rule ID 16032 //
     /*  929077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  929094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929124 */     // MIs[1] Operand 1
     /*  929124 */     // No operand predicates
     /*  929124 */     // MIs[0] round
     /*  929124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929136 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  929136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929148 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929161 */     GIR_RootConstrainSelectedInstOperands,
     /*  929162 */     // GIR_Coverage, 16032,
     /*  929162 */     GIR_EraseRootFromParent_Done,
     /*  929163 */   // Label 14092: @929163
     /*  929163 */   GIM_Try, /*On fail goto*//*Label 14093*/ GIMT_Encode4(929254), // Rule ID 16033 //
     /*  929168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  929179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  929182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  929185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929215 */     // MIs[1] Operand 1
     /*  929215 */     // No operand predicates
     /*  929215 */     // MIs[0] round
     /*  929215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929227 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  929227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  929249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929252 */     GIR_RootConstrainSelectedInstOperands,
     /*  929253 */     // GIR_Coverage, 16033,
     /*  929253 */     GIR_EraseRootFromParent_Done,
     /*  929254 */   // Label 14093: @929254
     /*  929254 */   GIM_Try, /*On fail goto*//*Label 14094*/ GIMT_Encode4(929345), // Rule ID 16036 //
     /*  929259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929306 */     // MIs[1] Operand 1
     /*  929306 */     // No operand predicates
     /*  929306 */     // MIs[0] round
     /*  929306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929330 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929343 */     GIR_RootConstrainSelectedInstOperands,
     /*  929344 */     // GIR_Coverage, 16036,
     /*  929344 */     GIR_EraseRootFromParent_Done,
     /*  929345 */   // Label 14094: @929345
     /*  929345 */   GIM_Try, /*On fail goto*//*Label 14095*/ GIMT_Encode4(929436), // Rule ID 16037 //
     /*  929350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  929361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  929364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  929367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929397 */     // MIs[1] Operand 1
     /*  929397 */     // No operand predicates
     /*  929397 */     // MIs[0] round
     /*  929397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929434 */     GIR_RootConstrainSelectedInstOperands,
     /*  929435 */     // GIR_Coverage, 16037,
     /*  929435 */     GIR_EraseRootFromParent_Done,
     /*  929436 */   // Label 14095: @929436
     /*  929436 */   GIM_Try, /*On fail goto*//*Label 14096*/ GIMT_Encode4(929527), // Rule ID 16040 //
     /*  929441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929488 */     // MIs[1] Operand 1
     /*  929488 */     // No operand predicates
     /*  929488 */     // MIs[0] round
     /*  929488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929500 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929512 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929525 */     GIR_RootConstrainSelectedInstOperands,
     /*  929526 */     // GIR_Coverage, 16040,
     /*  929526 */     GIR_EraseRootFromParent_Done,
     /*  929527 */   // Label 14096: @929527
     /*  929527 */   GIM_Try, /*On fail goto*//*Label 14097*/ GIMT_Encode4(929618), // Rule ID 16041 //
     /*  929532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929579 */     // MIs[1] Operand 1
     /*  929579 */     // No operand predicates
     /*  929579 */     // MIs[0] round
     /*  929579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929591 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929616 */     GIR_RootConstrainSelectedInstOperands,
     /*  929617 */     // GIR_Coverage, 16041,
     /*  929617 */     GIR_EraseRootFromParent_Done,
     /*  929618 */   // Label 14097: @929618
     /*  929618 */   GIM_Try, /*On fail goto*//*Label 14098*/ GIMT_Encode4(929709), // Rule ID 16044 //
     /*  929623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929670 */     // MIs[1] Operand 1
     /*  929670 */     // No operand predicates
     /*  929670 */     // MIs[0] round
     /*  929670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929682 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929694 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929707 */     GIR_RootConstrainSelectedInstOperands,
     /*  929708 */     // GIR_Coverage, 16044,
     /*  929708 */     GIR_EraseRootFromParent_Done,
     /*  929709 */   // Label 14098: @929709
     /*  929709 */   GIM_Try, /*On fail goto*//*Label 14099*/ GIMT_Encode4(929800), // Rule ID 16045 //
     /*  929714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929761 */     // MIs[1] Operand 1
     /*  929761 */     // No operand predicates
     /*  929761 */     // MIs[0] round
     /*  929761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929773 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929798 */     GIR_RootConstrainSelectedInstOperands,
     /*  929799 */     // GIR_Coverage, 16045,
     /*  929799 */     GIR_EraseRootFromParent_Done,
     /*  929800 */   // Label 14099: @929800
     /*  929800 */   GIM_Try, /*On fail goto*//*Label 14100*/ GIMT_Encode4(929891), // Rule ID 16048 //
     /*  929805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929852 */     // MIs[1] Operand 1
     /*  929852 */     // No operand predicates
     /*  929852 */     // MIs[0] round
     /*  929852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  929864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929876 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929889 */     GIR_RootConstrainSelectedInstOperands,
     /*  929890 */     // GIR_Coverage, 16048,
     /*  929890 */     GIR_EraseRootFromParent_Done,
     /*  929891 */   // Label 14100: @929891
     /*  929891 */   GIM_Try, /*On fail goto*//*Label 14101*/ GIMT_Encode4(929982), // Rule ID 16049 //
     /*  929896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929943 */     // MIs[1] Operand 1
     /*  929943 */     // No operand predicates
     /*  929943 */     // MIs[0] round
     /*  929943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929955 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  929955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929980 */     GIR_RootConstrainSelectedInstOperands,
     /*  929981 */     // GIR_Coverage, 16049,
     /*  929981 */     GIR_EraseRootFromParent_Done,
     /*  929982 */   // Label 14101: @929982
     /*  929982 */   GIM_Try, /*On fail goto*//*Label 14102*/ GIMT_Encode4(930073), // Rule ID 16052 //
     /*  929987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  929998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  930001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  930004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930034 */     // MIs[1] Operand 1
     /*  930034 */     // No operand predicates
     /*  930034 */     // MIs[0] round
     /*  930034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930058 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930071 */     GIR_RootConstrainSelectedInstOperands,
     /*  930072 */     // GIR_Coverage, 16052,
     /*  930072 */     GIR_EraseRootFromParent_Done,
     /*  930073 */   // Label 14102: @930073
     /*  930073 */   GIM_Try, /*On fail goto*//*Label 14103*/ GIMT_Encode4(930164), // Rule ID 16053 //
     /*  930078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  930089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  930092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  930095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930125 */     // MIs[1] Operand 1
     /*  930125 */     // No operand predicates
     /*  930125 */     // MIs[0] round
     /*  930125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930137 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930162 */     GIR_RootConstrainSelectedInstOperands,
     /*  930163 */     // GIR_Coverage, 16053,
     /*  930163 */     GIR_EraseRootFromParent_Done,
     /*  930164 */   // Label 14103: @930164
     /*  930164 */   GIM_Try, /*On fail goto*//*Label 14104*/ GIMT_Encode4(930255), // Rule ID 16056 //
     /*  930169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930216 */     // MIs[1] Operand 1
     /*  930216 */     // No operand predicates
     /*  930216 */     // MIs[0] round
     /*  930216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930228 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  930228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930240 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930253 */     GIR_RootConstrainSelectedInstOperands,
     /*  930254 */     // GIR_Coverage, 16056,
     /*  930254 */     GIR_EraseRootFromParent_Done,
     /*  930255 */   // Label 14104: @930255
     /*  930255 */   GIM_Try, /*On fail goto*//*Label 14105*/ GIMT_Encode4(930346), // Rule ID 16057 //
     /*  930260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  930271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  930274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  930277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930307 */     // MIs[1] Operand 1
     /*  930307 */     // No operand predicates
     /*  930307 */     // MIs[0] round
     /*  930307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930319 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  930319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  930341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930344 */     GIR_RootConstrainSelectedInstOperands,
     /*  930345 */     // GIR_Coverage, 16057,
     /*  930345 */     GIR_EraseRootFromParent_Done,
     /*  930346 */   // Label 14105: @930346
     /*  930346 */   GIM_Try, /*On fail goto*//*Label 14106*/ GIMT_Encode4(930437), // Rule ID 16060 //
     /*  930351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930398 */     // MIs[1] Operand 1
     /*  930398 */     // No operand predicates
     /*  930398 */     // MIs[0] round
     /*  930398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930422 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930435 */     GIR_RootConstrainSelectedInstOperands,
     /*  930436 */     // GIR_Coverage, 16060,
     /*  930436 */     GIR_EraseRootFromParent_Done,
     /*  930437 */   // Label 14106: @930437
     /*  930437 */   GIM_Try, /*On fail goto*//*Label 14107*/ GIMT_Encode4(930528), // Rule ID 16061 //
     /*  930442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  930453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  930456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  930459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  930477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930489 */     // MIs[1] Operand 1
     /*  930489 */     // No operand predicates
     /*  930489 */     // MIs[0] round
     /*  930489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930501 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  930504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930526 */     GIR_RootConstrainSelectedInstOperands,
     /*  930527 */     // GIR_Coverage, 16061,
     /*  930527 */     GIR_EraseRootFromParent_Done,
     /*  930528 */   // Label 14107: @930528
     /*  930528 */   GIM_Try, /*On fail goto*//*Label 14108*/ GIMT_Encode4(930619), // Rule ID 16064 //
     /*  930533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930580 */     // MIs[1] Operand 1
     /*  930580 */     // No operand predicates
     /*  930580 */     // MIs[0] round
     /*  930580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930592 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930604 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930617 */     GIR_RootConstrainSelectedInstOperands,
     /*  930618 */     // GIR_Coverage, 16064,
     /*  930618 */     GIR_EraseRootFromParent_Done,
     /*  930619 */   // Label 14108: @930619
     /*  930619 */   GIM_Try, /*On fail goto*//*Label 14109*/ GIMT_Encode4(930710), // Rule ID 16065 //
     /*  930624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930671 */     // MIs[1] Operand 1
     /*  930671 */     // No operand predicates
     /*  930671 */     // MIs[0] round
     /*  930671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930683 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930708 */     GIR_RootConstrainSelectedInstOperands,
     /*  930709 */     // GIR_Coverage, 16065,
     /*  930709 */     GIR_EraseRootFromParent_Done,
     /*  930710 */   // Label 14109: @930710
     /*  930710 */   GIM_Try, /*On fail goto*//*Label 14110*/ GIMT_Encode4(930801), // Rule ID 16068 //
     /*  930715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930762 */     // MIs[1] Operand 1
     /*  930762 */     // No operand predicates
     /*  930762 */     // MIs[0] round
     /*  930762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930774 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930786 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930799 */     GIR_RootConstrainSelectedInstOperands,
     /*  930800 */     // GIR_Coverage, 16068,
     /*  930800 */     GIR_EraseRootFromParent_Done,
     /*  930801 */   // Label 14110: @930801
     /*  930801 */   GIM_Try, /*On fail goto*//*Label 14111*/ GIMT_Encode4(930892), // Rule ID 16069 //
     /*  930806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930853 */     // MIs[1] Operand 1
     /*  930853 */     // No operand predicates
     /*  930853 */     // MIs[0] round
     /*  930853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930865 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930890 */     GIR_RootConstrainSelectedInstOperands,
     /*  930891 */     // GIR_Coverage, 16069,
     /*  930891 */     GIR_EraseRootFromParent_Done,
     /*  930892 */   // Label 14111: @930892
     /*  930892 */   GIM_Try, /*On fail goto*//*Label 14112*/ GIMT_Encode4(930983), // Rule ID 16248 //
     /*  930897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930944 */     // MIs[1] Operand 1
     /*  930944 */     // No operand predicates
     /*  930944 */     // MIs[0] round
     /*  930944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930956 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  930956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  930959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930968 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930981 */     GIR_RootConstrainSelectedInstOperands,
     /*  930982 */     // GIR_Coverage, 16248,
     /*  930982 */     GIR_EraseRootFromParent_Done,
     /*  930983 */   // Label 14112: @930983
     /*  930983 */   GIM_Try, /*On fail goto*//*Label 14113*/ GIMT_Encode4(931074), // Rule ID 16249 //
     /*  930988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  931002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  931005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931035 */     // MIs[1] Operand 1
     /*  931035 */     // No operand predicates
     /*  931035 */     // MIs[0] round
     /*  931035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931047 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  931050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931072 */     GIR_RootConstrainSelectedInstOperands,
     /*  931073 */     // GIR_Coverage, 16249,
     /*  931073 */     GIR_EraseRootFromParent_Done,
     /*  931074 */   // Label 14113: @931074
     /*  931074 */   GIM_Try, /*On fail goto*//*Label 14114*/ GIMT_Encode4(931165), // Rule ID 16252 //
     /*  931079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931126 */     // MIs[1] Operand 1
     /*  931126 */     // No operand predicates
     /*  931126 */     // MIs[0] round
     /*  931126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931138 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931150 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931163 */     GIR_RootConstrainSelectedInstOperands,
     /*  931164 */     // GIR_Coverage, 16252,
     /*  931164 */     GIR_EraseRootFromParent_Done,
     /*  931165 */   // Label 14114: @931165
     /*  931165 */   GIM_Try, /*On fail goto*//*Label 14115*/ GIMT_Encode4(931256), // Rule ID 16253 //
     /*  931170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  931181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  931184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  931187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931217 */     // MIs[1] Operand 1
     /*  931217 */     // No operand predicates
     /*  931217 */     // MIs[0] round
     /*  931217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931229 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931254 */     GIR_RootConstrainSelectedInstOperands,
     /*  931255 */     // GIR_Coverage, 16253,
     /*  931255 */     GIR_EraseRootFromParent_Done,
     /*  931256 */   // Label 14115: @931256
     /*  931256 */   GIM_Try, /*On fail goto*//*Label 14116*/ GIMT_Encode4(931347), // Rule ID 16256 //
     /*  931261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931308 */     // MIs[1] Operand 1
     /*  931308 */     // No operand predicates
     /*  931308 */     // MIs[0] round
     /*  931308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931320 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931332 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931345 */     GIR_RootConstrainSelectedInstOperands,
     /*  931346 */     // GIR_Coverage, 16256,
     /*  931346 */     GIR_EraseRootFromParent_Done,
     /*  931347 */   // Label 14116: @931347
     /*  931347 */   GIM_Try, /*On fail goto*//*Label 14117*/ GIMT_Encode4(931438), // Rule ID 16257 //
     /*  931352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  931363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  931366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  931369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931399 */     // MIs[1] Operand 1
     /*  931399 */     // No operand predicates
     /*  931399 */     // MIs[0] round
     /*  931399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931411 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931436 */     GIR_RootConstrainSelectedInstOperands,
     /*  931437 */     // GIR_Coverage, 16257,
     /*  931437 */     GIR_EraseRootFromParent_Done,
     /*  931438 */   // Label 14117: @931438
     /*  931438 */   GIM_Try, /*On fail goto*//*Label 14118*/ GIMT_Encode4(931529), // Rule ID 16260 //
     /*  931443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931490 */     // MIs[1] Operand 1
     /*  931490 */     // No operand predicates
     /*  931490 */     // MIs[0] round
     /*  931490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931514 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931527 */     GIR_RootConstrainSelectedInstOperands,
     /*  931528 */     // GIR_Coverage, 16260,
     /*  931528 */     GIR_EraseRootFromParent_Done,
     /*  931529 */   // Label 14118: @931529
     /*  931529 */   GIM_Try, /*On fail goto*//*Label 14119*/ GIMT_Encode4(931620), // Rule ID 16261 //
     /*  931534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931581 */     // MIs[1] Operand 1
     /*  931581 */     // No operand predicates
     /*  931581 */     // MIs[0] round
     /*  931581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931593 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931618 */     GIR_RootConstrainSelectedInstOperands,
     /*  931619 */     // GIR_Coverage, 16261,
     /*  931619 */     GIR_EraseRootFromParent_Done,
     /*  931620 */   // Label 14119: @931620
     /*  931620 */   GIM_Try, /*On fail goto*//*Label 14120*/ GIMT_Encode4(931711), // Rule ID 16264 //
     /*  931625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931672 */     // MIs[1] Operand 1
     /*  931672 */     // No operand predicates
     /*  931672 */     // MIs[0] round
     /*  931672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931696 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931709 */     GIR_RootConstrainSelectedInstOperands,
     /*  931710 */     // GIR_Coverage, 16264,
     /*  931710 */     GIR_EraseRootFromParent_Done,
     /*  931711 */   // Label 14120: @931711
     /*  931711 */   GIM_Try, /*On fail goto*//*Label 14121*/ GIMT_Encode4(931802), // Rule ID 16265 //
     /*  931716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931763 */     // MIs[1] Operand 1
     /*  931763 */     // No operand predicates
     /*  931763 */     // MIs[0] round
     /*  931763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931775 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931800 */     GIR_RootConstrainSelectedInstOperands,
     /*  931801 */     // GIR_Coverage, 16265,
     /*  931801 */     GIR_EraseRootFromParent_Done,
     /*  931802 */   // Label 14121: @931802
     /*  931802 */   GIM_Try, /*On fail goto*//*Label 14122*/ GIMT_Encode4(931893), // Rule ID 16268 //
     /*  931807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931854 */     // MIs[1] Operand 1
     /*  931854 */     // No operand predicates
     /*  931854 */     // MIs[0] round
     /*  931854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  931866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931878 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931891 */     GIR_RootConstrainSelectedInstOperands,
     /*  931892 */     // GIR_Coverage, 16268,
     /*  931892 */     GIR_EraseRootFromParent_Done,
     /*  931893 */   // Label 14122: @931893
     /*  931893 */   GIM_Try, /*On fail goto*//*Label 14123*/ GIMT_Encode4(931984), // Rule ID 16269 //
     /*  931898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931945 */     // MIs[1] Operand 1
     /*  931945 */     // No operand predicates
     /*  931945 */     // MIs[0] round
     /*  931945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931957 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  931957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931982 */     GIR_RootConstrainSelectedInstOperands,
     /*  931983 */     // GIR_Coverage, 16269,
     /*  931983 */     GIR_EraseRootFromParent_Done,
     /*  931984 */   // Label 14123: @931984
     /*  931984 */   GIM_Try, /*On fail goto*//*Label 14124*/ GIMT_Encode4(932075), // Rule ID 16272 //
     /*  931989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  932000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  932003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  932006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932036 */     // MIs[1] Operand 1
     /*  932036 */     // No operand predicates
     /*  932036 */     // MIs[0] round
     /*  932036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932048 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932060 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932073 */     GIR_RootConstrainSelectedInstOperands,
     /*  932074 */     // GIR_Coverage, 16272,
     /*  932074 */     GIR_EraseRootFromParent_Done,
     /*  932075 */   // Label 14124: @932075
     /*  932075 */   GIM_Try, /*On fail goto*//*Label 14125*/ GIMT_Encode4(932166), // Rule ID 16273 //
     /*  932080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  932091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  932094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  932097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932127 */     // MIs[1] Operand 1
     /*  932127 */     // No operand predicates
     /*  932127 */     // MIs[0] round
     /*  932127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932139 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932164 */     GIR_RootConstrainSelectedInstOperands,
     /*  932165 */     // GIR_Coverage, 16273,
     /*  932165 */     GIR_EraseRootFromParent_Done,
     /*  932166 */   // Label 14125: @932166
     /*  932166 */   GIM_Try, /*On fail goto*//*Label 14126*/ GIMT_Encode4(932257), // Rule ID 16276 //
     /*  932171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932218 */     // MIs[1] Operand 1
     /*  932218 */     // No operand predicates
     /*  932218 */     // MIs[0] round
     /*  932218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932242 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932255 */     GIR_RootConstrainSelectedInstOperands,
     /*  932256 */     // GIR_Coverage, 16276,
     /*  932256 */     GIR_EraseRootFromParent_Done,
     /*  932257 */   // Label 14126: @932257
     /*  932257 */   GIM_Try, /*On fail goto*//*Label 14127*/ GIMT_Encode4(932348), // Rule ID 16277 //
     /*  932262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  932273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  932276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  932279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932309 */     // MIs[1] Operand 1
     /*  932309 */     // No operand predicates
     /*  932309 */     // MIs[0] round
     /*  932309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932321 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932346 */     GIR_RootConstrainSelectedInstOperands,
     /*  932347 */     // GIR_Coverage, 16277,
     /*  932347 */     GIR_EraseRootFromParent_Done,
     /*  932348 */   // Label 14127: @932348
     /*  932348 */   GIM_Try, /*On fail goto*//*Label 14128*/ GIMT_Encode4(932439), // Rule ID 16280 //
     /*  932353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932400 */     // MIs[1] Operand 1
     /*  932400 */     // No operand predicates
     /*  932400 */     // MIs[0] round
     /*  932400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932412 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  932412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932424 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932437 */     GIR_RootConstrainSelectedInstOperands,
     /*  932438 */     // GIR_Coverage, 16280,
     /*  932438 */     GIR_EraseRootFromParent_Done,
     /*  932439 */   // Label 14128: @932439
     /*  932439 */   GIM_Try, /*On fail goto*//*Label 14129*/ GIMT_Encode4(932530), // Rule ID 16281 //
     /*  932444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  932455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  932458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  932461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932491 */     // MIs[1] Operand 1
     /*  932491 */     // No operand predicates
     /*  932491 */     // MIs[0] round
     /*  932491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932503 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  932503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932528 */     GIR_RootConstrainSelectedInstOperands,
     /*  932529 */     // GIR_Coverage, 16281,
     /*  932529 */     GIR_EraseRootFromParent_Done,
     /*  932530 */   // Label 14129: @932530
     /*  932530 */   GIM_Try, /*On fail goto*//*Label 14130*/ GIMT_Encode4(932621), // Rule ID 16284 //
     /*  932535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  932538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932582 */     // MIs[1] Operand 1
     /*  932582 */     // No operand predicates
     /*  932582 */     // MIs[0] round
     /*  932582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  932594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932619 */     GIR_RootConstrainSelectedInstOperands,
     /*  932620 */     // GIR_Coverage, 16284,
     /*  932620 */     GIR_EraseRootFromParent_Done,
     /*  932621 */   // Label 14130: @932621
     /*  932621 */   GIM_Try, /*On fail goto*//*Label 14131*/ GIMT_Encode4(932712), // Rule ID 16285 //
     /*  932626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  932629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932673 */     // MIs[1] Operand 1
     /*  932673 */     // No operand predicates
     /*  932673 */     // MIs[0] round
     /*  932673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932685 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  932685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932710 */     GIR_RootConstrainSelectedInstOperands,
     /*  932711 */     // GIR_Coverage, 16285,
     /*  932711 */     GIR_EraseRootFromParent_Done,
     /*  932712 */   // Label 14131: @932712
     /*  932712 */   GIM_Try, /*On fail goto*//*Label 14132*/ GIMT_Encode4(932803), // Rule ID 16288 //
     /*  932717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932764 */     // MIs[1] Operand 1
     /*  932764 */     // No operand predicates
     /*  932764 */     // MIs[0] round
     /*  932764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  932779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932788 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932801 */     GIR_RootConstrainSelectedInstOperands,
     /*  932802 */     // GIR_Coverage, 16288,
     /*  932802 */     GIR_EraseRootFromParent_Done,
     /*  932803 */   // Label 14132: @932803
     /*  932803 */   GIM_Try, /*On fail goto*//*Label 14133*/ GIMT_Encode4(932894), // Rule ID 16289 //
     /*  932808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932855 */     // MIs[1] Operand 1
     /*  932855 */     // No operand predicates
     /*  932855 */     // MIs[0] round
     /*  932855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932867 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  932870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932892 */     GIR_RootConstrainSelectedInstOperands,
     /*  932893 */     // GIR_Coverage, 16289,
     /*  932893 */     GIR_EraseRootFromParent_Done,
     /*  932894 */   // Label 14133: @932894
     /*  932894 */   GIM_Try, /*On fail goto*//*Label 14134*/ GIMT_Encode4(932985), // Rule ID 16292 //
     /*  932899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932946 */     // MIs[1] Operand 1
     /*  932946 */     // No operand predicates
     /*  932946 */     // MIs[0] round
     /*  932946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932958 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  932961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932970 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932983 */     GIR_RootConstrainSelectedInstOperands,
     /*  932984 */     // GIR_Coverage, 16292,
     /*  932984 */     GIR_EraseRootFromParent_Done,
     /*  932985 */   // Label 14134: @932985
     /*  932985 */   GIM_Try, /*On fail goto*//*Label 14135*/ GIMT_Encode4(933076), // Rule ID 16293 //
     /*  932990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  933001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  933004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  933007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933037 */     // MIs[1] Operand 1
     /*  933037 */     // No operand predicates
     /*  933037 */     // MIs[0] round
     /*  933037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933049 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933074 */     GIR_RootConstrainSelectedInstOperands,
     /*  933075 */     // GIR_Coverage, 16293,
     /*  933075 */     GIR_EraseRootFromParent_Done,
     /*  933076 */   // Label 14135: @933076
     /*  933076 */   GIM_Try, /*On fail goto*//*Label 14136*/ GIMT_Encode4(933167), // Rule ID 16296 //
     /*  933081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933128 */     // MIs[1] Operand 1
     /*  933128 */     // No operand predicates
     /*  933128 */     // MIs[0] round
     /*  933128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933140 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  933140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933152 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933165 */     GIR_RootConstrainSelectedInstOperands,
     /*  933166 */     // GIR_Coverage, 16296,
     /*  933166 */     GIR_EraseRootFromParent_Done,
     /*  933167 */   // Label 14136: @933167
     /*  933167 */   GIM_Try, /*On fail goto*//*Label 14137*/ GIMT_Encode4(933258), // Rule ID 16297 //
     /*  933172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  933183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  933186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  933189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933219 */     // MIs[1] Operand 1
     /*  933219 */     // No operand predicates
     /*  933219 */     // MIs[0] round
     /*  933219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933231 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  933231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  933253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933256 */     GIR_RootConstrainSelectedInstOperands,
     /*  933257 */     // GIR_Coverage, 16297,
     /*  933257 */     GIR_EraseRootFromParent_Done,
     /*  933258 */   // Label 14137: @933258
     /*  933258 */   GIM_Try, /*On fail goto*//*Label 14138*/ GIMT_Encode4(933349), // Rule ID 16300 //
     /*  933263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933310 */     // MIs[1] Operand 1
     /*  933310 */     // No operand predicates
     /*  933310 */     // MIs[0] round
     /*  933310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933334 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933347 */     GIR_RootConstrainSelectedInstOperands,
     /*  933348 */     // GIR_Coverage, 16300,
     /*  933348 */     GIR_EraseRootFromParent_Done,
     /*  933349 */   // Label 14138: @933349
     /*  933349 */   GIM_Try, /*On fail goto*//*Label 14139*/ GIMT_Encode4(933440), // Rule ID 16301 //
     /*  933354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  933365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  933368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  933371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933401 */     // MIs[1] Operand 1
     /*  933401 */     // No operand predicates
     /*  933401 */     // MIs[0] round
     /*  933401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933413 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933438 */     GIR_RootConstrainSelectedInstOperands,
     /*  933439 */     // GIR_Coverage, 16301,
     /*  933439 */     GIR_EraseRootFromParent_Done,
     /*  933440 */   // Label 14139: @933440
     /*  933440 */   GIM_Try, /*On fail goto*//*Label 14140*/ GIMT_Encode4(933531), // Rule ID 16304 //
     /*  933445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933492 */     // MIs[1] Operand 1
     /*  933492 */     // No operand predicates
     /*  933492 */     // MIs[0] round
     /*  933492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933504 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933516 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933529 */     GIR_RootConstrainSelectedInstOperands,
     /*  933530 */     // GIR_Coverage, 16304,
     /*  933530 */     GIR_EraseRootFromParent_Done,
     /*  933531 */   // Label 14140: @933531
     /*  933531 */   GIM_Try, /*On fail goto*//*Label 14141*/ GIMT_Encode4(933622), // Rule ID 16305 //
     /*  933536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933583 */     // MIs[1] Operand 1
     /*  933583 */     // No operand predicates
     /*  933583 */     // MIs[0] round
     /*  933583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933595 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933620 */     GIR_RootConstrainSelectedInstOperands,
     /*  933621 */     // GIR_Coverage, 16305,
     /*  933621 */     GIR_EraseRootFromParent_Done,
     /*  933622 */   // Label 14141: @933622
     /*  933622 */   GIM_Try, /*On fail goto*//*Label 14142*/ GIMT_Encode4(933713), // Rule ID 16308 //
     /*  933627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933674 */     // MIs[1] Operand 1
     /*  933674 */     // No operand predicates
     /*  933674 */     // MIs[0] round
     /*  933674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933698 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933711 */     GIR_RootConstrainSelectedInstOperands,
     /*  933712 */     // GIR_Coverage, 16308,
     /*  933712 */     GIR_EraseRootFromParent_Done,
     /*  933713 */   // Label 14142: @933713
     /*  933713 */   GIM_Try, /*On fail goto*//*Label 14143*/ GIMT_Encode4(933804), // Rule ID 16309 //
     /*  933718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933765 */     // MIs[1] Operand 1
     /*  933765 */     // No operand predicates
     /*  933765 */     // MIs[0] round
     /*  933765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933777 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933802 */     GIR_RootConstrainSelectedInstOperands,
     /*  933803 */     // GIR_Coverage, 16309,
     /*  933803 */     GIR_EraseRootFromParent_Done,
     /*  933804 */   // Label 14143: @933804
     /*  933804 */   GIM_Try, /*On fail goto*//*Label 14144*/ GIMT_Encode4(933895), // Rule ID 16312 //
     /*  933809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933856 */     // MIs[1] Operand 1
     /*  933856 */     // No operand predicates
     /*  933856 */     // MIs[0] round
     /*  933856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  933868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933880 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933893 */     GIR_RootConstrainSelectedInstOperands,
     /*  933894 */     // GIR_Coverage, 16312,
     /*  933894 */     GIR_EraseRootFromParent_Done,
     /*  933895 */   // Label 14144: @933895
     /*  933895 */   GIM_Try, /*On fail goto*//*Label 14145*/ GIMT_Encode4(933986), // Rule ID 16313 //
     /*  933900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933947 */     // MIs[1] Operand 1
     /*  933947 */     // No operand predicates
     /*  933947 */     // MIs[0] round
     /*  933947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  933959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933984 */     GIR_RootConstrainSelectedInstOperands,
     /*  933985 */     // GIR_Coverage, 16313,
     /*  933985 */     GIR_EraseRootFromParent_Done,
     /*  933986 */   // Label 14145: @933986
     /*  933986 */   GIM_Try, /*On fail goto*//*Label 14146*/ GIMT_Encode4(934077), // Rule ID 16316 //
     /*  933991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  934002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  934005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  934008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934038 */     // MIs[1] Operand 1
     /*  934038 */     // No operand predicates
     /*  934038 */     // MIs[0] round
     /*  934038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934050 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934062 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934075 */     GIR_RootConstrainSelectedInstOperands,
     /*  934076 */     // GIR_Coverage, 16316,
     /*  934076 */     GIR_EraseRootFromParent_Done,
     /*  934077 */   // Label 14146: @934077
     /*  934077 */   GIM_Try, /*On fail goto*//*Label 14147*/ GIMT_Encode4(934168), // Rule ID 16317 //
     /*  934082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  934093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  934096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  934099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934129 */     // MIs[1] Operand 1
     /*  934129 */     // No operand predicates
     /*  934129 */     // MIs[0] round
     /*  934129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934141 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934166 */     GIR_RootConstrainSelectedInstOperands,
     /*  934167 */     // GIR_Coverage, 16317,
     /*  934167 */     GIR_EraseRootFromParent_Done,
     /*  934168 */   // Label 14147: @934168
     /*  934168 */   GIM_Try, /*On fail goto*//*Label 14148*/ GIMT_Encode4(934259), // Rule ID 16320 //
     /*  934173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934220 */     // MIs[1] Operand 1
     /*  934220 */     // No operand predicates
     /*  934220 */     // MIs[0] round
     /*  934220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934232 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  934232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934244 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934257 */     GIR_RootConstrainSelectedInstOperands,
     /*  934258 */     // GIR_Coverage, 16320,
     /*  934258 */     GIR_EraseRootFromParent_Done,
     /*  934259 */   // Label 14148: @934259
     /*  934259 */   GIM_Try, /*On fail goto*//*Label 14149*/ GIMT_Encode4(934350), // Rule ID 16321 //
     /*  934264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  934275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  934278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  934281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934311 */     // MIs[1] Operand 1
     /*  934311 */     // No operand predicates
     /*  934311 */     // MIs[0] round
     /*  934311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934323 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  934323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  934345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934348 */     GIR_RootConstrainSelectedInstOperands,
     /*  934349 */     // GIR_Coverage, 16321,
     /*  934349 */     GIR_EraseRootFromParent_Done,
     /*  934350 */   // Label 14149: @934350
     /*  934350 */   GIM_Try, /*On fail goto*//*Label 14150*/ GIMT_Encode4(934441), // Rule ID 16324 //
     /*  934355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934402 */     // MIs[1] Operand 1
     /*  934402 */     // No operand predicates
     /*  934402 */     // MIs[0] round
     /*  934402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934426 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934439 */     GIR_RootConstrainSelectedInstOperands,
     /*  934440 */     // GIR_Coverage, 16324,
     /*  934440 */     GIR_EraseRootFromParent_Done,
     /*  934441 */   // Label 14150: @934441
     /*  934441 */   GIM_Try, /*On fail goto*//*Label 14151*/ GIMT_Encode4(934532), // Rule ID 16325 //
     /*  934446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  934457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  934460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  934463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934493 */     // MIs[1] Operand 1
     /*  934493 */     // No operand predicates
     /*  934493 */     // MIs[0] round
     /*  934493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934530 */     GIR_RootConstrainSelectedInstOperands,
     /*  934531 */     // GIR_Coverage, 16325,
     /*  934531 */     GIR_EraseRootFromParent_Done,
     /*  934532 */   // Label 14151: @934532
     /*  934532 */   GIM_Try, /*On fail goto*//*Label 14152*/ GIMT_Encode4(934623), // Rule ID 16328 //
     /*  934537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934584 */     // MIs[1] Operand 1
     /*  934584 */     // No operand predicates
     /*  934584 */     // MIs[0] round
     /*  934584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934608 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934621 */     GIR_RootConstrainSelectedInstOperands,
     /*  934622 */     // GIR_Coverage, 16328,
     /*  934622 */     GIR_EraseRootFromParent_Done,
     /*  934623 */   // Label 14152: @934623
     /*  934623 */   GIM_Try, /*On fail goto*//*Label 14153*/ GIMT_Encode4(934714), // Rule ID 16329 //
     /*  934628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934675 */     // MIs[1] Operand 1
     /*  934675 */     // No operand predicates
     /*  934675 */     // MIs[0] round
     /*  934675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934687 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934712 */     GIR_RootConstrainSelectedInstOperands,
     /*  934713 */     // GIR_Coverage, 16329,
     /*  934713 */     GIR_EraseRootFromParent_Done,
     /*  934714 */   // Label 14153: @934714
     /*  934714 */   GIM_Try, /*On fail goto*//*Label 14154*/ GIMT_Encode4(934805), // Rule ID 16332 //
     /*  934719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934766 */     // MIs[1] Operand 1
     /*  934766 */     // No operand predicates
     /*  934766 */     // MIs[0] round
     /*  934766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934803 */     GIR_RootConstrainSelectedInstOperands,
     /*  934804 */     // GIR_Coverage, 16332,
     /*  934804 */     GIR_EraseRootFromParent_Done,
     /*  934805 */   // Label 14154: @934805
     /*  934805 */   GIM_Try, /*On fail goto*//*Label 14155*/ GIMT_Encode4(934896), // Rule ID 16333 //
     /*  934810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934857 */     // MIs[1] Operand 1
     /*  934857 */     // No operand predicates
     /*  934857 */     // MIs[0] round
     /*  934857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934869 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934894 */     GIR_RootConstrainSelectedInstOperands,
     /*  934895 */     // GIR_Coverage, 16333,
     /*  934895 */     GIR_EraseRootFromParent_Done,
     /*  934896 */   // Label 14155: @934896
     /*  934896 */   GIM_Try, /*On fail goto*//*Label 14156*/ GIMT_Encode4(934990), // Rule ID 16456 //
     /*  934901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  934909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  934912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  934915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  934918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934948 */     // MIs[1] Operand 1
     /*  934948 */     // No operand predicates
     /*  934948 */     // MIs[0] round
     /*  934948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934960 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  934960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  934963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934972 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  934988 */     GIR_RootConstrainSelectedInstOperands,
     /*  934989 */     // GIR_Coverage, 16456,
     /*  934989 */     GIR_EraseRootFromParent_Done,
     /*  934990 */   // Label 14156: @934990
     /*  934990 */   GIM_Try, /*On fail goto*//*Label 14157*/ GIMT_Encode4(935084), // Rule ID 16457 //
     /*  934995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  935006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  935009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  935012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935042 */     // MIs[1] Operand 1
     /*  935042 */     // No operand predicates
     /*  935042 */     // MIs[0] round
     /*  935042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935054 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  935057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935066 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935082 */     GIR_RootConstrainSelectedInstOperands,
     /*  935083 */     // GIR_Coverage, 16457,
     /*  935083 */     GIR_EraseRootFromParent_Done,
     /*  935084 */   // Label 14157: @935084
     /*  935084 */   GIM_Try, /*On fail goto*//*Label 14158*/ GIMT_Encode4(935178), // Rule ID 16460 //
     /*  935089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935136 */     // MIs[1] Operand 1
     /*  935136 */     // No operand predicates
     /*  935136 */     // MIs[0] round
     /*  935136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935148 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935160 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935176 */     GIR_RootConstrainSelectedInstOperands,
     /*  935177 */     // GIR_Coverage, 16460,
     /*  935177 */     GIR_EraseRootFromParent_Done,
     /*  935178 */   // Label 14158: @935178
     /*  935178 */   GIM_Try, /*On fail goto*//*Label 14159*/ GIMT_Encode4(935272), // Rule ID 16461 //
     /*  935183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  935194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  935197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  935200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935230 */     // MIs[1] Operand 1
     /*  935230 */     // No operand predicates
     /*  935230 */     // MIs[0] round
     /*  935230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935242 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935254 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935270 */     GIR_RootConstrainSelectedInstOperands,
     /*  935271 */     // GIR_Coverage, 16461,
     /*  935271 */     GIR_EraseRootFromParent_Done,
     /*  935272 */   // Label 14159: @935272
     /*  935272 */   GIM_Try, /*On fail goto*//*Label 14160*/ GIMT_Encode4(935366), // Rule ID 16464 //
     /*  935277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  935294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935324 */     // MIs[1] Operand 1
     /*  935324 */     // No operand predicates
     /*  935324 */     // MIs[0] round
     /*  935324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935348 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935364 */     GIR_RootConstrainSelectedInstOperands,
     /*  935365 */     // GIR_Coverage, 16464,
     /*  935365 */     GIR_EraseRootFromParent_Done,
     /*  935366 */   // Label 14160: @935366
     /*  935366 */   GIM_Try, /*On fail goto*//*Label 14161*/ GIMT_Encode4(935460), // Rule ID 16465 //
     /*  935371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  935382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  935385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  935388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935418 */     // MIs[1] Operand 1
     /*  935418 */     // No operand predicates
     /*  935418 */     // MIs[0] round
     /*  935418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935430 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935442 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935458 */     GIR_RootConstrainSelectedInstOperands,
     /*  935459 */     // GIR_Coverage, 16465,
     /*  935459 */     GIR_EraseRootFromParent_Done,
     /*  935460 */   // Label 14161: @935460
     /*  935460 */   GIM_Try, /*On fail goto*//*Label 14162*/ GIMT_Encode4(935554), // Rule ID 16468 //
     /*  935465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  935482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935512 */     // MIs[1] Operand 1
     /*  935512 */     // No operand predicates
     /*  935512 */     // MIs[0] round
     /*  935512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  935527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935536 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935552 */     GIR_RootConstrainSelectedInstOperands,
     /*  935553 */     // GIR_Coverage, 16468,
     /*  935553 */     GIR_EraseRootFromParent_Done,
     /*  935554 */   // Label 14162: @935554
     /*  935554 */   GIM_Try, /*On fail goto*//*Label 14163*/ GIMT_Encode4(935648), // Rule ID 16469 //
     /*  935559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  935576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935606 */     // MIs[1] Operand 1
     /*  935606 */     // No operand predicates
     /*  935606 */     // MIs[0] round
     /*  935606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935618 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  935621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935646 */     GIR_RootConstrainSelectedInstOperands,
     /*  935647 */     // GIR_Coverage, 16469,
     /*  935647 */     GIR_EraseRootFromParent_Done,
     /*  935648 */   // Label 14163: @935648
     /*  935648 */   GIM_Try, /*On fail goto*//*Label 14164*/ GIMT_Encode4(935742), // Rule ID 16472 //
     /*  935653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  935664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  935667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  935670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935700 */     // MIs[1] Operand 1
     /*  935700 */     // No operand predicates
     /*  935700 */     // MIs[0] round
     /*  935700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935712 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  935715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935724 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935740 */     GIR_RootConstrainSelectedInstOperands,
     /*  935741 */     // GIR_Coverage, 16472,
     /*  935741 */     GIR_EraseRootFromParent_Done,
     /*  935742 */   // Label 14164: @935742
     /*  935742 */   GIM_Try, /*On fail goto*//*Label 14165*/ GIMT_Encode4(935836), // Rule ID 16473 //
     /*  935747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  935758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  935761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  935764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935794 */     // MIs[1] Operand 1
     /*  935794 */     // No operand predicates
     /*  935794 */     // MIs[0] round
     /*  935794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935806 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  935809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935818 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935834 */     GIR_RootConstrainSelectedInstOperands,
     /*  935835 */     // GIR_Coverage, 16473,
     /*  935835 */     GIR_EraseRootFromParent_Done,
     /*  935836 */   // Label 14165: @935836
     /*  935836 */   GIM_Try, /*On fail goto*//*Label 14166*/ GIMT_Encode4(935930), // Rule ID 16476 //
     /*  935841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  935852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  935855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  935858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935888 */     // MIs[1] Operand 1
     /*  935888 */     // No operand predicates
     /*  935888 */     // MIs[0] round
     /*  935888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935900 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  935903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935912 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935928 */     GIR_RootConstrainSelectedInstOperands,
     /*  935929 */     // GIR_Coverage, 16476,
     /*  935929 */     GIR_EraseRootFromParent_Done,
     /*  935930 */   // Label 14166: @935930
     /*  935930 */   GIM_Try, /*On fail goto*//*Label 14167*/ GIMT_Encode4(936024), // Rule ID 16477 //
     /*  935935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  935946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  935949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  935952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935982 */     // MIs[1] Operand 1
     /*  935982 */     // No operand predicates
     /*  935982 */     // MIs[0] round
     /*  935982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935994 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  935997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  936016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936022 */     GIR_RootConstrainSelectedInstOperands,
     /*  936023 */     // GIR_Coverage, 16477,
     /*  936023 */     GIR_EraseRootFromParent_Done,
     /*  936024 */   // Label 14167: @936024
     /*  936024 */   GIM_Try, /*On fail goto*//*Label 14168*/ GIMT_Encode4(936118), // Rule ID 16480 //
     /*  936029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  936040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  936043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  936046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936076 */     // MIs[1] Operand 1
     /*  936076 */     // No operand predicates
     /*  936076 */     // MIs[0] round
     /*  936076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936088 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  936091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936100 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936116 */     GIR_RootConstrainSelectedInstOperands,
     /*  936117 */     // GIR_Coverage, 16480,
     /*  936117 */     GIR_EraseRootFromParent_Done,
     /*  936118 */   // Label 14168: @936118
     /*  936118 */   GIM_Try, /*On fail goto*//*Label 14169*/ GIMT_Encode4(936212), // Rule ID 16481 //
     /*  936123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  936134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  936137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  936140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936170 */     // MIs[1] Operand 1
     /*  936170 */     // No operand predicates
     /*  936170 */     // MIs[0] round
     /*  936170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  936185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936194 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936210 */     GIR_RootConstrainSelectedInstOperands,
     /*  936211 */     // GIR_Coverage, 16481,
     /*  936211 */     GIR_EraseRootFromParent_Done,
     /*  936212 */   // Label 14169: @936212
     /*  936212 */   GIM_Try, /*On fail goto*//*Label 14170*/ GIMT_Encode4(936306), // Rule ID 16484 //
     /*  936217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  936228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  936231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936264 */     // MIs[1] Operand 1
     /*  936264 */     // No operand predicates
     /*  936264 */     // MIs[0] round
     /*  936264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936276 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936288 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936304 */     GIR_RootConstrainSelectedInstOperands,
     /*  936305 */     // GIR_Coverage, 16484,
     /*  936305 */     GIR_EraseRootFromParent_Done,
     /*  936306 */   // Label 14170: @936306
     /*  936306 */   GIM_Try, /*On fail goto*//*Label 14171*/ GIMT_Encode4(936400), // Rule ID 16485 //
     /*  936311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  936322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  936325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  936328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936358 */     // MIs[1] Operand 1
     /*  936358 */     // No operand predicates
     /*  936358 */     // MIs[0] round
     /*  936358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936370 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936382 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936398 */     GIR_RootConstrainSelectedInstOperands,
     /*  936399 */     // GIR_Coverage, 16485,
     /*  936399 */     GIR_EraseRootFromParent_Done,
     /*  936400 */   // Label 14171: @936400
     /*  936400 */   GIM_Try, /*On fail goto*//*Label 14172*/ GIMT_Encode4(936494), // Rule ID 16488 //
     /*  936405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  936422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936452 */     // MIs[1] Operand 1
     /*  936452 */     // No operand predicates
     /*  936452 */     // MIs[0] round
     /*  936452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936464 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936476 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936492 */     GIR_RootConstrainSelectedInstOperands,
     /*  936493 */     // GIR_Coverage, 16488,
     /*  936493 */     GIR_EraseRootFromParent_Done,
     /*  936494 */   // Label 14172: @936494
     /*  936494 */   GIM_Try, /*On fail goto*//*Label 14173*/ GIMT_Encode4(936588), // Rule ID 16489 //
     /*  936499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  936516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936546 */     // MIs[1] Operand 1
     /*  936546 */     // No operand predicates
     /*  936546 */     // MIs[0] round
     /*  936546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936570 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936586 */     GIR_RootConstrainSelectedInstOperands,
     /*  936587 */     // GIR_Coverage, 16489,
     /*  936587 */     GIR_EraseRootFromParent_Done,
     /*  936588 */   // Label 14173: @936588
     /*  936588 */   GIM_Try, /*On fail goto*//*Label 14174*/ GIMT_Encode4(936682), // Rule ID 16492 //
     /*  936593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  936604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  936607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  936610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936640 */     // MIs[1] Operand 1
     /*  936640 */     // No operand predicates
     /*  936640 */     // MIs[0] round
     /*  936640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936664 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936680 */     GIR_RootConstrainSelectedInstOperands,
     /*  936681 */     // GIR_Coverage, 16492,
     /*  936681 */     GIR_EraseRootFromParent_Done,
     /*  936682 */   // Label 14174: @936682
     /*  936682 */   GIM_Try, /*On fail goto*//*Label 14175*/ GIMT_Encode4(936776), // Rule ID 16493 //
     /*  936687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  936698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  936701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  936704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936734 */     // MIs[1] Operand 1
     /*  936734 */     // No operand predicates
     /*  936734 */     // MIs[0] round
     /*  936734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936758 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936774 */     GIR_RootConstrainSelectedInstOperands,
     /*  936775 */     // GIR_Coverage, 16493,
     /*  936775 */     GIR_EraseRootFromParent_Done,
     /*  936776 */   // Label 14175: @936776
     /*  936776 */   GIM_Try, /*On fail goto*//*Label 14176*/ GIMT_Encode4(936870), // Rule ID 16496 //
     /*  936781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  936792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  936795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  936798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936828 */     // MIs[1] Operand 1
     /*  936828 */     // No operand predicates
     /*  936828 */     // MIs[0] round
     /*  936828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936852 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936868 */     GIR_RootConstrainSelectedInstOperands,
     /*  936869 */     // GIR_Coverage, 16496,
     /*  936869 */     GIR_EraseRootFromParent_Done,
     /*  936870 */   // Label 14176: @936870
     /*  936870 */   GIM_Try, /*On fail goto*//*Label 14177*/ GIMT_Encode4(936964), // Rule ID 16497 //
     /*  936875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  936886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  936889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  936892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936922 */     // MIs[1] Operand 1
     /*  936922 */     // No operand predicates
     /*  936922 */     // MIs[0] round
     /*  936922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936946 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936962 */     GIR_RootConstrainSelectedInstOperands,
     /*  936963 */     // GIR_Coverage, 16497,
     /*  936963 */     GIR_EraseRootFromParent_Done,
     /*  936964 */   // Label 14177: @936964
     /*  936964 */   GIM_Try, /*On fail goto*//*Label 14178*/ GIMT_Encode4(937058), // Rule ID 16500 //
     /*  936969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  936972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  936980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  936983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  936986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937016 */     // MIs[1] Operand 1
     /*  937016 */     // No operand predicates
     /*  937016 */     // MIs[0] round
     /*  937016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937028 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  937031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937040 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937056 */     GIR_RootConstrainSelectedInstOperands,
     /*  937057 */     // GIR_Coverage, 16500,
     /*  937057 */     GIR_EraseRootFromParent_Done,
     /*  937058 */   // Label 14178: @937058
     /*  937058 */   GIM_Try, /*On fail goto*//*Label 14179*/ GIMT_Encode4(937152), // Rule ID 16501 //
     /*  937063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  937074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  937077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  937080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937110 */     // MIs[1] Operand 1
     /*  937110 */     // No operand predicates
     /*  937110 */     // MIs[0] round
     /*  937110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  937125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937134 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937150 */     GIR_RootConstrainSelectedInstOperands,
     /*  937151 */     // GIR_Coverage, 16501,
     /*  937151 */     GIR_EraseRootFromParent_Done,
     /*  937152 */   // Label 14179: @937152
     /*  937152 */   GIM_Try, /*On fail goto*//*Label 14180*/ GIMT_Encode4(937246), // Rule ID 16504 //
     /*  937157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  937168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  937171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  937174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937204 */     // MIs[1] Operand 1
     /*  937204 */     // No operand predicates
     /*  937204 */     // MIs[0] round
     /*  937204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937228 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937244 */     GIR_RootConstrainSelectedInstOperands,
     /*  937245 */     // GIR_Coverage, 16504,
     /*  937245 */     GIR_EraseRootFromParent_Done,
     /*  937246 */   // Label 14180: @937246
     /*  937246 */   GIM_Try, /*On fail goto*//*Label 14181*/ GIMT_Encode4(937340), // Rule ID 16505 //
     /*  937251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  937262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  937265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  937268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937298 */     // MIs[1] Operand 1
     /*  937298 */     // No operand predicates
     /*  937298 */     // MIs[0] round
     /*  937298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937310 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  937313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937322 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937338 */     GIR_RootConstrainSelectedInstOperands,
     /*  937339 */     // GIR_Coverage, 16505,
     /*  937339 */     GIR_EraseRootFromParent_Done,
     /*  937340 */   // Label 14181: @937340
     /*  937340 */   GIM_Try, /*On fail goto*//*Label 14182*/ GIMT_Encode4(937434), // Rule ID 16508 //
     /*  937345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  937362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937392 */     // MIs[1] Operand 1
     /*  937392 */     // No operand predicates
     /*  937392 */     // MIs[0] round
     /*  937392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937416 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937432 */     GIR_RootConstrainSelectedInstOperands,
     /*  937433 */     // GIR_Coverage, 16508,
     /*  937433 */     GIR_EraseRootFromParent_Done,
     /*  937434 */   // Label 14182: @937434
     /*  937434 */   GIM_Try, /*On fail goto*//*Label 14183*/ GIMT_Encode4(937528), // Rule ID 16509 //
     /*  937439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  937450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  937453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  937456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937486 */     // MIs[1] Operand 1
     /*  937486 */     // No operand predicates
     /*  937486 */     // MIs[0] round
     /*  937486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937498 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  937501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937510 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937526 */     GIR_RootConstrainSelectedInstOperands,
     /*  937527 */     // GIR_Coverage, 16509,
     /*  937527 */     GIR_EraseRootFromParent_Done,
     /*  937528 */   // Label 14183: @937528
     /*  937528 */   GIM_Try, /*On fail goto*//*Label 14184*/ GIMT_Encode4(937622), // Rule ID 16512 //
     /*  937533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  937550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937580 */     // MIs[1] Operand 1
     /*  937580 */     // No operand predicates
     /*  937580 */     // MIs[0] round
     /*  937580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937604 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937620 */     GIR_RootConstrainSelectedInstOperands,
     /*  937621 */     // GIR_Coverage, 16512,
     /*  937621 */     GIR_EraseRootFromParent_Done,
     /*  937622 */   // Label 14184: @937622
     /*  937622 */   GIM_Try, /*On fail goto*//*Label 14185*/ GIMT_Encode4(937716), // Rule ID 16513 //
     /*  937627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  937644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937674 */     // MIs[1] Operand 1
     /*  937674 */     // No operand predicates
     /*  937674 */     // MIs[0] round
     /*  937674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937698 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937714 */     GIR_RootConstrainSelectedInstOperands,
     /*  937715 */     // GIR_Coverage, 16513,
     /*  937715 */     GIR_EraseRootFromParent_Done,
     /*  937716 */   // Label 14185: @937716
     /*  937716 */   GIM_Try, /*On fail goto*//*Label 14186*/ GIMT_Encode4(937810), // Rule ID 16636 //
     /*  937721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  937732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  937735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  937738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937768 */     // MIs[1] Operand 1
     /*  937768 */     // No operand predicates
     /*  937768 */     // MIs[0] round
     /*  937768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937780 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  937780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  937783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937792 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937808 */     GIR_RootConstrainSelectedInstOperands,
     /*  937809 */     // GIR_Coverage, 16636,
     /*  937809 */     GIR_EraseRootFromParent_Done,
     /*  937810 */   // Label 14186: @937810
     /*  937810 */   GIM_Try, /*On fail goto*//*Label 14187*/ GIMT_Encode4(937904), // Rule ID 16637 //
     /*  937815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  937826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  937829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  937832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937862 */     // MIs[1] Operand 1
     /*  937862 */     // No operand predicates
     /*  937862 */     // MIs[0] round
     /*  937862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937874 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  937874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  937877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937886 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937902 */     GIR_RootConstrainSelectedInstOperands,
     /*  937903 */     // GIR_Coverage, 16637,
     /*  937903 */     GIR_EraseRootFromParent_Done,
     /*  937904 */   // Label 14187: @937904
     /*  937904 */   GIM_Try, /*On fail goto*//*Label 14188*/ GIMT_Encode4(937998), // Rule ID 16640 //
     /*  937909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  937920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  937923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  937926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937956 */     // MIs[1] Operand 1
     /*  937956 */     // No operand predicates
     /*  937956 */     // MIs[0] round
     /*  937956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937968 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  937968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  937971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937980 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937996 */     GIR_RootConstrainSelectedInstOperands,
     /*  937997 */     // GIR_Coverage, 16640,
     /*  937997 */     GIR_EraseRootFromParent_Done,
     /*  937998 */   // Label 14188: @937998
     /*  937998 */   GIM_Try, /*On fail goto*//*Label 14189*/ GIMT_Encode4(938092), // Rule ID 16641 //
     /*  938003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  938014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  938017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  938020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938050 */     // MIs[1] Operand 1
     /*  938050 */     // No operand predicates
     /*  938050 */     // MIs[0] round
     /*  938050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938062 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938074 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938090 */     GIR_RootConstrainSelectedInstOperands,
     /*  938091 */     // GIR_Coverage, 16641,
     /*  938091 */     GIR_EraseRootFromParent_Done,
     /*  938092 */   // Label 14189: @938092
     /*  938092 */   GIM_Try, /*On fail goto*//*Label 14190*/ GIMT_Encode4(938186), // Rule ID 16644 //
     /*  938097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  938108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  938111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938144 */     // MIs[1] Operand 1
     /*  938144 */     // No operand predicates
     /*  938144 */     // MIs[0] round
     /*  938144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938168 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938184 */     GIR_RootConstrainSelectedInstOperands,
     /*  938185 */     // GIR_Coverage, 16644,
     /*  938185 */     GIR_EraseRootFromParent_Done,
     /*  938186 */   // Label 14190: @938186
     /*  938186 */   GIM_Try, /*On fail goto*//*Label 14191*/ GIMT_Encode4(938280), // Rule ID 16645 //
     /*  938191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  938202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  938205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  938208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938238 */     // MIs[1] Operand 1
     /*  938238 */     // No operand predicates
     /*  938238 */     // MIs[0] round
     /*  938238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938250 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938262 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938278 */     GIR_RootConstrainSelectedInstOperands,
     /*  938279 */     // GIR_Coverage, 16645,
     /*  938279 */     GIR_EraseRootFromParent_Done,
     /*  938280 */   // Label 14191: @938280
     /*  938280 */   GIM_Try, /*On fail goto*//*Label 14192*/ GIMT_Encode4(938374), // Rule ID 16648 //
     /*  938285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  938296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  938299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938332 */     // MIs[1] Operand 1
     /*  938332 */     // No operand predicates
     /*  938332 */     // MIs[0] round
     /*  938332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938356 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938372 */     GIR_RootConstrainSelectedInstOperands,
     /*  938373 */     // GIR_Coverage, 16648,
     /*  938373 */     GIR_EraseRootFromParent_Done,
     /*  938374 */   // Label 14192: @938374
     /*  938374 */   GIM_Try, /*On fail goto*//*Label 14193*/ GIMT_Encode4(938468), // Rule ID 16649 //
     /*  938379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  938390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  938393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  938396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938426 */     // MIs[1] Operand 1
     /*  938426 */     // No operand predicates
     /*  938426 */     // MIs[0] round
     /*  938426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938438 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938450 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938466 */     GIR_RootConstrainSelectedInstOperands,
     /*  938467 */     // GIR_Coverage, 16649,
     /*  938467 */     GIR_EraseRootFromParent_Done,
     /*  938468 */   // Label 14193: @938468
     /*  938468 */   GIM_Try, /*On fail goto*//*Label 14194*/ GIMT_Encode4(938562), // Rule ID 16652 //
     /*  938473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  938484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  938487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  938490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938520 */     // MIs[1] Operand 1
     /*  938520 */     // No operand predicates
     /*  938520 */     // MIs[0] round
     /*  938520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  938535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938544 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938560 */     GIR_RootConstrainSelectedInstOperands,
     /*  938561 */     // GIR_Coverage, 16652,
     /*  938561 */     GIR_EraseRootFromParent_Done,
     /*  938562 */   // Label 14194: @938562
     /*  938562 */   GIM_Try, /*On fail goto*//*Label 14195*/ GIMT_Encode4(938656), // Rule ID 16653 //
     /*  938567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  938578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  938581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  938584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938614 */     // MIs[1] Operand 1
     /*  938614 */     // No operand predicates
     /*  938614 */     // MIs[0] round
     /*  938614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938626 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  938629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938638 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938654 */     GIR_RootConstrainSelectedInstOperands,
     /*  938655 */     // GIR_Coverage, 16653,
     /*  938655 */     GIR_EraseRootFromParent_Done,
     /*  938656 */   // Label 14195: @938656
     /*  938656 */   GIM_Try, /*On fail goto*//*Label 14196*/ GIMT_Encode4(938750), // Rule ID 16656 //
     /*  938661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  938672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  938675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  938678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938708 */     // MIs[1] Operand 1
     /*  938708 */     // No operand predicates
     /*  938708 */     // MIs[0] round
     /*  938708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938720 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  938723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938732 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938748 */     GIR_RootConstrainSelectedInstOperands,
     /*  938749 */     // GIR_Coverage, 16656,
     /*  938749 */     GIR_EraseRootFromParent_Done,
     /*  938750 */   // Label 14196: @938750
     /*  938750 */   GIM_Try, /*On fail goto*//*Label 14197*/ GIMT_Encode4(938844), // Rule ID 16657 //
     /*  938755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  938766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  938769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  938772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938802 */     // MIs[1] Operand 1
     /*  938802 */     // No operand predicates
     /*  938802 */     // MIs[0] round
     /*  938802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  938817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938826 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938842 */     GIR_RootConstrainSelectedInstOperands,
     /*  938843 */     // GIR_Coverage, 16657,
     /*  938843 */     GIR_EraseRootFromParent_Done,
     /*  938844 */   // Label 14197: @938844
     /*  938844 */   GIM_Try, /*On fail goto*//*Label 14198*/ GIMT_Encode4(938938), // Rule ID 16660 //
     /*  938849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  938860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  938863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  938866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938896 */     // MIs[1] Operand 1
     /*  938896 */     // No operand predicates
     /*  938896 */     // MIs[0] round
     /*  938896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  938908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938920 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938936 */     GIR_RootConstrainSelectedInstOperands,
     /*  938937 */     // GIR_Coverage, 16660,
     /*  938937 */     GIR_EraseRootFromParent_Done,
     /*  938938 */   // Label 14198: @938938
     /*  938938 */   GIM_Try, /*On fail goto*//*Label 14199*/ GIMT_Encode4(939032), // Rule ID 16661 //
     /*  938943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  938954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  938957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  938960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938990 */     // MIs[1] Operand 1
     /*  938990 */     // No operand predicates
     /*  938990 */     // MIs[0] round
     /*  938990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939002 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  939005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939014 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939030 */     GIR_RootConstrainSelectedInstOperands,
     /*  939031 */     // GIR_Coverage, 16661,
     /*  939031 */     GIR_EraseRootFromParent_Done,
     /*  939032 */   // Label 14199: @939032
     /*  939032 */   GIM_Try, /*On fail goto*//*Label 14200*/ GIMT_Encode4(939126), // Rule ID 16664 //
     /*  939037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939084 */     // MIs[1] Operand 1
     /*  939084 */     // No operand predicates
     /*  939084 */     // MIs[0] round
     /*  939084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939096 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939108 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939124 */     GIR_RootConstrainSelectedInstOperands,
     /*  939125 */     // GIR_Coverage, 16664,
     /*  939125 */     GIR_EraseRootFromParent_Done,
     /*  939126 */   // Label 14200: @939126
     /*  939126 */   GIM_Try, /*On fail goto*//*Label 14201*/ GIMT_Encode4(939220), // Rule ID 16665 //
     /*  939131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  939142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  939145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  939148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939174 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939178 */     // MIs[1] Operand 1
     /*  939178 */     // No operand predicates
     /*  939178 */     // MIs[0] round
     /*  939178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939190 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939202 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939218 */     GIR_RootConstrainSelectedInstOperands,
     /*  939219 */     // GIR_Coverage, 16665,
     /*  939219 */     GIR_EraseRootFromParent_Done,
     /*  939220 */   // Label 14201: @939220
     /*  939220 */   GIM_Try, /*On fail goto*//*Label 14202*/ GIMT_Encode4(939314), // Rule ID 16668 //
     /*  939225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  939236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  939239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939272 */     // MIs[1] Operand 1
     /*  939272 */     // No operand predicates
     /*  939272 */     // MIs[0] round
     /*  939272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939296 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939312 */     GIR_RootConstrainSelectedInstOperands,
     /*  939313 */     // GIR_Coverage, 16668,
     /*  939313 */     GIR_EraseRootFromParent_Done,
     /*  939314 */   // Label 14202: @939314
     /*  939314 */   GIM_Try, /*On fail goto*//*Label 14203*/ GIMT_Encode4(939408), // Rule ID 16669 //
     /*  939319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  939330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  939333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  939336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939366 */     // MIs[1] Operand 1
     /*  939366 */     // No operand predicates
     /*  939366 */     // MIs[0] round
     /*  939366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939378 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939390 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939406 */     GIR_RootConstrainSelectedInstOperands,
     /*  939407 */     // GIR_Coverage, 16669,
     /*  939407 */     GIR_EraseRootFromParent_Done,
     /*  939408 */   // Label 14203: @939408
     /*  939408 */   GIM_Try, /*On fail goto*//*Label 14204*/ GIMT_Encode4(939502), // Rule ID 16672 //
     /*  939413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  939424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  939427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939460 */     // MIs[1] Operand 1
     /*  939460 */     // No operand predicates
     /*  939460 */     // MIs[0] round
     /*  939460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939484 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939500 */     GIR_RootConstrainSelectedInstOperands,
     /*  939501 */     // GIR_Coverage, 16672,
     /*  939501 */     GIR_EraseRootFromParent_Done,
     /*  939502 */   // Label 14204: @939502
     /*  939502 */   GIM_Try, /*On fail goto*//*Label 14205*/ GIMT_Encode4(939596), // Rule ID 16673 //
     /*  939507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  939518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  939521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939554 */     // MIs[1] Operand 1
     /*  939554 */     // No operand predicates
     /*  939554 */     // MIs[0] round
     /*  939554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939578 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939594 */     GIR_RootConstrainSelectedInstOperands,
     /*  939595 */     // GIR_Coverage, 16673,
     /*  939595 */     GIR_EraseRootFromParent_Done,
     /*  939596 */   // Label 14205: @939596
     /*  939596 */   GIM_Try, /*On fail goto*//*Label 14206*/ GIMT_Encode4(939690), // Rule ID 16676 //
     /*  939601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  939612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  939615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  939618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939648 */     // MIs[1] Operand 1
     /*  939648 */     // No operand predicates
     /*  939648 */     // MIs[0] round
     /*  939648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939660 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939672 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939688 */     GIR_RootConstrainSelectedInstOperands,
     /*  939689 */     // GIR_Coverage, 16676,
     /*  939689 */     GIR_EraseRootFromParent_Done,
     /*  939690 */   // Label 14206: @939690
     /*  939690 */   GIM_Try, /*On fail goto*//*Label 14207*/ GIMT_Encode4(939784), // Rule ID 16677 //
     /*  939695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  939706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  939709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  939712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939742 */     // MIs[1] Operand 1
     /*  939742 */     // No operand predicates
     /*  939742 */     // MIs[0] round
     /*  939742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939754 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939782 */     GIR_RootConstrainSelectedInstOperands,
     /*  939783 */     // GIR_Coverage, 16677,
     /*  939783 */     GIR_EraseRootFromParent_Done,
     /*  939784 */   // Label 14207: @939784
     /*  939784 */   GIM_Try, /*On fail goto*//*Label 14208*/ GIMT_Encode4(939878), // Rule ID 16680 //
     /*  939789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  939800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  939803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  939806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939836 */     // MIs[1] Operand 1
     /*  939836 */     // No operand predicates
     /*  939836 */     // MIs[0] round
     /*  939836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939848 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  939848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939860 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939876 */     GIR_RootConstrainSelectedInstOperands,
     /*  939877 */     // GIR_Coverage, 16680,
     /*  939877 */     GIR_EraseRootFromParent_Done,
     /*  939878 */   // Label 14208: @939878
     /*  939878 */   GIM_Try, /*On fail goto*//*Label 14209*/ GIMT_Encode4(939972), // Rule ID 16681 //
     /*  939883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  939894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  939897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  939900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939930 */     // MIs[1] Operand 1
     /*  939930 */     // No operand predicates
     /*  939930 */     // MIs[0] round
     /*  939930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  939942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939954 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939970 */     GIR_RootConstrainSelectedInstOperands,
     /*  939971 */     // GIR_Coverage, 16681,
     /*  939971 */     GIR_EraseRootFromParent_Done,
     /*  939972 */   // Label 14209: @939972
     /*  939972 */   GIM_Try, /*On fail goto*//*Label 14210*/ GIMT_Encode4(940066), // Rule ID 16684 //
     /*  939977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  939988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  939991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  939994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940024 */     // MIs[1] Operand 1
     /*  940024 */     // No operand predicates
     /*  940024 */     // MIs[0] round
     /*  940024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  940039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940048 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940064 */     GIR_RootConstrainSelectedInstOperands,
     /*  940065 */     // GIR_Coverage, 16684,
     /*  940065 */     GIR_EraseRootFromParent_Done,
     /*  940066 */   // Label 14210: @940066
     /*  940066 */   GIM_Try, /*On fail goto*//*Label 14211*/ GIMT_Encode4(940160), // Rule ID 16685 //
     /*  940071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  940088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940114 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940118 */     // MIs[1] Operand 1
     /*  940118 */     // No operand predicates
     /*  940118 */     // MIs[0] round
     /*  940118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  940133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940142 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940158 */     GIR_RootConstrainSelectedInstOperands,
     /*  940159 */     // GIR_Coverage, 16685,
     /*  940159 */     GIR_EraseRootFromParent_Done,
     /*  940160 */   // Label 14211: @940160
     /*  940160 */   GIM_Try, /*On fail goto*//*Label 14212*/ GIMT_Encode4(940254), // Rule ID 16688 //
     /*  940165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  940182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940212 */     // MIs[1] Operand 1
     /*  940212 */     // No operand predicates
     /*  940212 */     // MIs[0] round
     /*  940212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940236 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940252 */     GIR_RootConstrainSelectedInstOperands,
     /*  940253 */     // GIR_Coverage, 16688,
     /*  940253 */     GIR_EraseRootFromParent_Done,
     /*  940254 */   // Label 14212: @940254
     /*  940254 */   GIM_Try, /*On fail goto*//*Label 14213*/ GIMT_Encode4(940348), // Rule ID 16689 //
     /*  940259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  940276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940306 */     // MIs[1] Operand 1
     /*  940306 */     // No operand predicates
     /*  940306 */     // MIs[0] round
     /*  940306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  940321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940330 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940346 */     GIR_RootConstrainSelectedInstOperands,
     /*  940347 */     // GIR_Coverage, 16689,
     /*  940347 */     GIR_EraseRootFromParent_Done,
     /*  940348 */   // Label 14213: @940348
     /*  940348 */   GIM_Try, /*On fail goto*//*Label 14214*/ GIMT_Encode4(940442), // Rule ID 16692 //
     /*  940353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  940356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  940370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  940373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940400 */     // MIs[1] Operand 1
     /*  940400 */     // No operand predicates
     /*  940400 */     // MIs[0] round
     /*  940400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  940412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940424 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940440 */     GIR_RootConstrainSelectedInstOperands,
     /*  940441 */     // GIR_Coverage, 16692,
     /*  940441 */     GIR_EraseRootFromParent_Done,
     /*  940442 */   // Label 14214: @940442
     /*  940442 */   GIM_Try, /*On fail goto*//*Label 14215*/ GIMT_Encode4(940536), // Rule ID 16693 //
     /*  940447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  940450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  940455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  940464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  940467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  940486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  940490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  940494 */     // MIs[1] Operand 1
     /*  940494 */     // No operand predicates
     /*  940494 */     // MIs[0] round
     /*  940494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  940506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940518 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940534 */     GIR_RootConstrainSelectedInstOperands,
     /*  940535 */     // GIR_Coverage, 16693,
     /*  940535 */     GIR_EraseRootFromParent_Done,
     /*  940536 */   // Label 14215: @940536
     /*  940536 */   GIM_Try, /*On fail goto*//*Label 14216*/ GIMT_Encode4(940620), // Rule ID 2760 //
     /*  940541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  940558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  940561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940584 */     // MIs[0] round
     /*  940584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940596 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  940599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940618 */     GIR_RootConstrainSelectedInstOperands,
     /*  940619 */     // GIR_Coverage, 2760,
     /*  940619 */     GIR_EraseRootFromParent_Done,
     /*  940620 */   // Label 14216: @940620
     /*  940620 */   GIM_Try, /*On fail goto*//*Label 14217*/ GIMT_Encode4(940704), // Rule ID 2761 //
     /*  940625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  940642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  940645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940668 */     // MIs[0] round
     /*  940668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940680 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  940680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  940683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940702 */     GIR_RootConstrainSelectedInstOperands,
     /*  940703 */     // GIR_Coverage, 2761,
     /*  940703 */     GIR_EraseRootFromParent_Done,
     /*  940704 */   // Label 14217: @940704
     /*  940704 */   GIM_Try, /*On fail goto*//*Label 14218*/ GIMT_Encode4(940788), // Rule ID 17140 //
     /*  940709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  940729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940752 */     // MIs[0] round
     /*  940752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  940767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940786 */     GIR_RootConstrainSelectedInstOperands,
     /*  940787 */     // GIR_Coverage, 17140,
     /*  940787 */     GIR_EraseRootFromParent_Done,
     /*  940788 */   // Label 14218: @940788
     /*  940788 */   GIM_Try, /*On fail goto*//*Label 14219*/ GIMT_Encode4(940872), // Rule ID 17141 //
     /*  940793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  940813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940836 */     // MIs[0] round
     /*  940836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940848 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  940848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  940851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940870 */     GIR_RootConstrainSelectedInstOperands,
     /*  940871 */     // GIR_Coverage, 17141,
     /*  940871 */     GIR_EraseRootFromParent_Done,
     /*  940872 */   // Label 14219: @940872
     /*  940872 */   GIM_Try, /*On fail goto*//*Label 14220*/ GIMT_Encode4(940956), // Rule ID 17150 //
     /*  940877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  940897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940920 */     // MIs[0] round
     /*  940920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940932 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  940935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940954 */     GIR_RootConstrainSelectedInstOperands,
     /*  940955 */     // GIR_Coverage, 17150,
     /*  940955 */     GIR_EraseRootFromParent_Done,
     /*  940956 */   // Label 14220: @940956
     /*  940956 */   GIM_Try, /*On fail goto*//*Label 14221*/ GIMT_Encode4(941040), // Rule ID 17151 //
     /*  940961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  940981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941004 */     // MIs[0] round
     /*  941004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941016 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  941019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941038 */     GIR_RootConstrainSelectedInstOperands,
     /*  941039 */     // GIR_Coverage, 17151,
     /*  941039 */     GIR_EraseRootFromParent_Done,
     /*  941040 */   // Label 14221: @941040
     /*  941040 */   GIM_Try, /*On fail goto*//*Label 14222*/ GIMT_Encode4(941124), // Rule ID 17160 //
     /*  941045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  941062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941088 */     // MIs[0] round
     /*  941088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941100 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  941103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941122 */     GIR_RootConstrainSelectedInstOperands,
     /*  941123 */     // GIR_Coverage, 17160,
     /*  941123 */     GIR_EraseRootFromParent_Done,
     /*  941124 */   // Label 14222: @941124
     /*  941124 */   GIM_Try, /*On fail goto*//*Label 14223*/ GIMT_Encode4(941208), // Rule ID 17161 //
     /*  941129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  941140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  941143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  941146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  941149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941172 */     // MIs[0] round
     /*  941172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941184 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  941187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941206 */     GIR_RootConstrainSelectedInstOperands,
     /*  941207 */     // GIR_Coverage, 17161,
     /*  941207 */     GIR_EraseRootFromParent_Done,
     /*  941208 */   // Label 14223: @941208
     /*  941208 */   GIM_Try, /*On fail goto*//*Label 14224*/ GIMT_Encode4(941292), // Rule ID 17170 //
     /*  941213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  941230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941256 */     // MIs[0] round
     /*  941256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941268 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  941271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941290 */     GIR_RootConstrainSelectedInstOperands,
     /*  941291 */     // GIR_Coverage, 17170,
     /*  941291 */     GIR_EraseRootFromParent_Done,
     /*  941292 */   // Label 14224: @941292
     /*  941292 */   GIM_Try, /*On fail goto*//*Label 14225*/ GIMT_Encode4(941376), // Rule ID 17171 //
     /*  941297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  941308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  941311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  941314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  941317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941340 */     // MIs[0] round
     /*  941340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941352 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  941355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941374 */     GIR_RootConstrainSelectedInstOperands,
     /*  941375 */     // GIR_Coverage, 17171,
     /*  941375 */     GIR_EraseRootFromParent_Done,
     /*  941376 */   // Label 14225: @941376
     /*  941376 */   GIM_Try, /*On fail goto*//*Label 14226*/ GIMT_Encode4(941460), // Rule ID 17180 //
     /*  941381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  941398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941424 */     // MIs[0] round
     /*  941424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941436 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  941439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941458 */     GIR_RootConstrainSelectedInstOperands,
     /*  941459 */     // GIR_Coverage, 17180,
     /*  941459 */     GIR_EraseRootFromParent_Done,
     /*  941460 */   // Label 14226: @941460
     /*  941460 */   GIM_Try, /*On fail goto*//*Label 14227*/ GIMT_Encode4(941544), // Rule ID 17181 //
     /*  941465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  941476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  941479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  941482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  941485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941508 */     // MIs[0] round
     /*  941508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941520 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  941523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941542 */     GIR_RootConstrainSelectedInstOperands,
     /*  941543 */     // GIR_Coverage, 17181,
     /*  941543 */     GIR_EraseRootFromParent_Done,
     /*  941544 */   // Label 14227: @941544
     /*  941544 */   GIM_Try, /*On fail goto*//*Label 14228*/ GIMT_Encode4(941628), // Rule ID 17190 //
     /*  941549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  941560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  941563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  941569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941592 */     // MIs[0] round
     /*  941592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941604 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  941607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941626 */     GIR_RootConstrainSelectedInstOperands,
     /*  941627 */     // GIR_Coverage, 17190,
     /*  941627 */     GIR_EraseRootFromParent_Done,
     /*  941628 */   // Label 14228: @941628
     /*  941628 */   GIM_Try, /*On fail goto*//*Label 14229*/ GIMT_Encode4(941712), // Rule ID 17191 //
     /*  941633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  941644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  941647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  941653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941676 */     // MIs[0] round
     /*  941676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941688 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  941691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941710 */     GIR_RootConstrainSelectedInstOperands,
     /*  941711 */     // GIR_Coverage, 17191,
     /*  941711 */     GIR_EraseRootFromParent_Done,
     /*  941712 */   // Label 14229: @941712
     /*  941712 */   GIM_Try, /*On fail goto*//*Label 14230*/ GIMT_Encode4(941796), // Rule ID 17200 //
     /*  941717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  941728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  941731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  941737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941760 */     // MIs[0] round
     /*  941760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941772 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  941775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941794 */     GIR_RootConstrainSelectedInstOperands,
     /*  941795 */     // GIR_Coverage, 17200,
     /*  941795 */     GIR_EraseRootFromParent_Done,
     /*  941796 */   // Label 14230: @941796
     /*  941796 */   GIM_Try, /*On fail goto*//*Label 14231*/ GIMT_Encode4(941880), // Rule ID 17201 //
     /*  941801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  941812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  941815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  941821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941844 */     // MIs[0] round
     /*  941844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941856 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  941859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941878 */     GIR_RootConstrainSelectedInstOperands,
     /*  941879 */     // GIR_Coverage, 17201,
     /*  941879 */     GIR_EraseRootFromParent_Done,
     /*  941880 */   // Label 14231: @941880
     /*  941880 */   GIM_Try, /*On fail goto*//*Label 14232*/ GIMT_Encode4(941964), // Rule ID 17210 //
     /*  941885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  941896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  941899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  941905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941928 */     // MIs[0] round
     /*  941928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941940 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  941943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941962 */     GIR_RootConstrainSelectedInstOperands,
     /*  941963 */     // GIR_Coverage, 17210,
     /*  941963 */     GIR_EraseRootFromParent_Done,
     /*  941964 */   // Label 14232: @941964
     /*  941964 */   GIM_Try, /*On fail goto*//*Label 14233*/ GIMT_Encode4(942048), // Rule ID 17211 //
     /*  941969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  941980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  941983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  941989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942012 */     // MIs[0] round
     /*  942012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942024 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  942027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942046 */     GIR_RootConstrainSelectedInstOperands,
     /*  942047 */     // GIR_Coverage, 17211,
     /*  942047 */     GIR_EraseRootFromParent_Done,
     /*  942048 */   // Label 14233: @942048
     /*  942048 */   GIM_Try, /*On fail goto*//*Label 14234*/ GIMT_Encode4(942132), // Rule ID 17256 //
     /*  942053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942096 */     // MIs[0] round
     /*  942096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942108 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  942111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942130 */     GIR_RootConstrainSelectedInstOperands,
     /*  942131 */     // GIR_Coverage, 17256,
     /*  942131 */     GIR_EraseRootFromParent_Done,
     /*  942132 */   // Label 14234: @942132
     /*  942132 */   GIM_Try, /*On fail goto*//*Label 14235*/ GIMT_Encode4(942216), // Rule ID 17257 //
     /*  942137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  942148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  942151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  942154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  942157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942180 */     // MIs[0] round
     /*  942180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942192 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  942195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942214 */     GIR_RootConstrainSelectedInstOperands,
     /*  942215 */     // GIR_Coverage, 17257,
     /*  942215 */     GIR_EraseRootFromParent_Done,
     /*  942216 */   // Label 14235: @942216
     /*  942216 */   GIM_Try, /*On fail goto*//*Label 14236*/ GIMT_Encode4(942300), // Rule ID 17266 //
     /*  942221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  942232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  942235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  942241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942264 */     // MIs[0] round
     /*  942264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942276 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  942279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942298 */     GIR_RootConstrainSelectedInstOperands,
     /*  942299 */     // GIR_Coverage, 17266,
     /*  942299 */     GIR_EraseRootFromParent_Done,
     /*  942300 */   // Label 14236: @942300
     /*  942300 */   GIM_Try, /*On fail goto*//*Label 14237*/ GIMT_Encode4(942384), // Rule ID 17267 //
     /*  942305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  942316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  942319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  942322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  942325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942348 */     // MIs[0] round
     /*  942348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942360 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  942363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942382 */     GIR_RootConstrainSelectedInstOperands,
     /*  942383 */     // GIR_Coverage, 17267,
     /*  942383 */     GIR_EraseRootFromParent_Done,
     /*  942384 */   // Label 14237: @942384
     /*  942384 */   GIM_Try, /*On fail goto*//*Label 14238*/ GIMT_Encode4(942468), // Rule ID 17276 //
     /*  942389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  942400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  942403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  942406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  942409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942432 */     // MIs[0] round
     /*  942432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942444 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  942447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942466 */     GIR_RootConstrainSelectedInstOperands,
     /*  942467 */     // GIR_Coverage, 17276,
     /*  942467 */     GIR_EraseRootFromParent_Done,
     /*  942468 */   // Label 14238: @942468
     /*  942468 */   GIM_Try, /*On fail goto*//*Label 14239*/ GIMT_Encode4(942552), // Rule ID 17277 //
     /*  942473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  942484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  942487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  942490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  942493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942516 */     // MIs[0] round
     /*  942516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942528 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  942531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942550 */     GIR_RootConstrainSelectedInstOperands,
     /*  942551 */     // GIR_Coverage, 17277,
     /*  942551 */     GIR_EraseRootFromParent_Done,
     /*  942552 */   // Label 14239: @942552
     /*  942552 */   GIM_Try, /*On fail goto*//*Label 14240*/ GIMT_Encode4(942636), // Rule ID 17286 //
     /*  942557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  942568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  942571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  942574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  942577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942600 */     // MIs[0] round
     /*  942600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942612 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  942615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942634 */     GIR_RootConstrainSelectedInstOperands,
     /*  942635 */     // GIR_Coverage, 17286,
     /*  942635 */     GIR_EraseRootFromParent_Done,
     /*  942636 */   // Label 14240: @942636
     /*  942636 */   GIM_Try, /*On fail goto*//*Label 14241*/ GIMT_Encode4(942720), // Rule ID 17287 //
     /*  942641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  942652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  942655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  942658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  942661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942684 */     // MIs[0] round
     /*  942684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  942699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942718 */     GIR_RootConstrainSelectedInstOperands,
     /*  942719 */     // GIR_Coverage, 17287,
     /*  942719 */     GIR_EraseRootFromParent_Done,
     /*  942720 */   // Label 14241: @942720
     /*  942720 */   GIM_Try, /*On fail goto*//*Label 14242*/ GIMT_Encode4(942804), // Rule ID 17296 //
     /*  942725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  942736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  942739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  942742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  942745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942768 */     // MIs[0] round
     /*  942768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942780 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  942783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942802 */     GIR_RootConstrainSelectedInstOperands,
     /*  942803 */     // GIR_Coverage, 17296,
     /*  942803 */     GIR_EraseRootFromParent_Done,
     /*  942804 */   // Label 14242: @942804
     /*  942804 */   GIM_Try, /*On fail goto*//*Label 14243*/ GIMT_Encode4(942888), // Rule ID 17297 //
     /*  942809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  942820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  942823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  942826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  942829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942852 */     // MIs[0] round
     /*  942852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942864 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  942867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942886 */     GIR_RootConstrainSelectedInstOperands,
     /*  942887 */     // GIR_Coverage, 17297,
     /*  942887 */     GIR_EraseRootFromParent_Done,
     /*  942888 */   // Label 14243: @942888
     /*  942888 */   GIM_Try, /*On fail goto*//*Label 14244*/ GIMT_Encode4(942972), // Rule ID 17306 //
     /*  942893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  942904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  942907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  942910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  942913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942936 */     // MIs[0] round
     /*  942936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942948 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  942951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942970 */     GIR_RootConstrainSelectedInstOperands,
     /*  942971 */     // GIR_Coverage, 17306,
     /*  942971 */     GIR_EraseRootFromParent_Done,
     /*  942972 */   // Label 14244: @942972
     /*  942972 */   GIM_Try, /*On fail goto*//*Label 14245*/ GIMT_Encode4(943056), // Rule ID 17307 //
     /*  942977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  942988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  942991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  942994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  942997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943020 */     // MIs[0] round
     /*  943020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943032 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  943035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943054 */     GIR_RootConstrainSelectedInstOperands,
     /*  943055 */     // GIR_Coverage, 17307,
     /*  943055 */     GIR_EraseRootFromParent_Done,
     /*  943056 */   // Label 14245: @943056
     /*  943056 */   GIM_Try, /*On fail goto*//*Label 14246*/ GIMT_Encode4(943140), // Rule ID 17316 //
     /*  943061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943104 */     // MIs[0] round
     /*  943104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943116 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  943119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943138 */     GIR_RootConstrainSelectedInstOperands,
     /*  943139 */     // GIR_Coverage, 17316,
     /*  943139 */     GIR_EraseRootFromParent_Done,
     /*  943140 */   // Label 14246: @943140
     /*  943140 */   GIM_Try, /*On fail goto*//*Label 14247*/ GIMT_Encode4(943224), // Rule ID 17317 //
     /*  943145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  943156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  943159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  943162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  943165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943188 */     // MIs[0] round
     /*  943188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943200 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  943203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943222 */     GIR_RootConstrainSelectedInstOperands,
     /*  943223 */     // GIR_Coverage, 17317,
     /*  943223 */     GIR_EraseRootFromParent_Done,
     /*  943224 */   // Label 14247: @943224
     /*  943224 */   GIM_Try, /*On fail goto*//*Label 14248*/ GIMT_Encode4(943308), // Rule ID 17326 //
     /*  943229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  943240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  943243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  943246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  943249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943272 */     // MIs[0] round
     /*  943272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943284 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  943287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943306 */     GIR_RootConstrainSelectedInstOperands,
     /*  943307 */     // GIR_Coverage, 17326,
     /*  943307 */     GIR_EraseRootFromParent_Done,
     /*  943308 */   // Label 14248: @943308
     /*  943308 */   GIM_Try, /*On fail goto*//*Label 14249*/ GIMT_Encode4(943392), // Rule ID 17327 //
     /*  943313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  943324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  943327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  943330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  943333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  943356 */     // MIs[0] round
     /*  943356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943368 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  943371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943390 */     GIR_RootConstrainSelectedInstOperands,
     /*  943391 */     // GIR_Coverage, 17327,
     /*  943391 */     GIR_EraseRootFromParent_Done,
     /*  943392 */   // Label 14249: @943392
     /*  943392 */   GIM_Try, /*On fail goto*//*Label 14250*/ GIMT_Encode4(943476), // Rule ID 17336 //
     /*  943397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  943400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  943408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  943411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  943414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  943417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943440 */     // MIs[0] round
     /*  943440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943452 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  943452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  943455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943474 */     GIR_RootConstrainSelectedInstOperands,
     /*  943475 */     // GIR_Coverage, 17336,
     /*  943475 */     GIR_EraseRootFromParent_Done,
     /*  943476 */   // Label 14250: @943476
     /*  943476 */   GIM_Try, /*On fail goto*//*Label 14251*/ GIMT_Encode4(943560), // Rule ID 17337 //
     /*  943481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  943484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  943489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  943492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  943495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  943498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  943501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943524 */     // MIs[0] round
     /*  943524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943536 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  943539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943558 */     GIR_RootConstrainSelectedInstOperands,
     /*  943559 */     // GIR_Coverage, 17337,
     /*  943559 */     GIR_EraseRootFromParent_Done,
     /*  943560 */   // Label 14251: @943560
     /*  943560 */   GIM_Try, /*On fail goto*//*Label 14252*/ GIMT_Encode4(943642), // Rule ID 62831 //
     /*  943565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943592 */     // MIs[0] op1
     /*  943592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943619 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  943622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943624 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943626 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943628 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943630 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943640 */     GIR_RootConstrainSelectedInstOperands,
     /*  943641 */     // GIR_Coverage, 62831,
     /*  943641 */     GIR_EraseRootFromParent_Done,
     /*  943642 */   // Label 14252: @943642
     /*  943642 */   GIM_Try, /*On fail goto*//*Label 14253*/ GIMT_Encode4(943724), // Rule ID 62832 //
     /*  943647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943674 */     // MIs[0] op1
     /*  943674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943701 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  943701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  943704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943706 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943708 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943710 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943712 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943722 */     GIR_RootConstrainSelectedInstOperands,
     /*  943723 */     // GIR_Coverage, 62832,
     /*  943723 */     GIR_EraseRootFromParent_Done,
     /*  943724 */   // Label 14253: @943724
     /*  943724 */   GIM_Try, /*On fail goto*//*Label 14254*/ GIMT_Encode4(943806), // Rule ID 62861 //
     /*  943729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  943749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943756 */     // MIs[0] op1
     /*  943756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943783 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  943786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943788 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943790 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943792 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943794 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943804 */     GIR_RootConstrainSelectedInstOperands,
     /*  943805 */     // GIR_Coverage, 62861,
     /*  943805 */     GIR_EraseRootFromParent_Done,
     /*  943806 */   // Label 14254: @943806
     /*  943806 */   GIM_Try, /*On fail goto*//*Label 14255*/ GIMT_Encode4(943888), // Rule ID 62862 //
     /*  943811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  943831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943838 */     // MIs[0] op1
     /*  943838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943865 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  943865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  943868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943870 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943872 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943874 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943876 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943886 */     GIR_RootConstrainSelectedInstOperands,
     /*  943887 */     // GIR_Coverage, 62862,
     /*  943887 */     GIR_EraseRootFromParent_Done,
     /*  943888 */   // Label 14255: @943888
     /*  943888 */   GIM_Try, /*On fail goto*//*Label 14256*/ GIMT_Encode4(943970), // Rule ID 62893 //
     /*  943893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  943904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  943907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  943910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943920 */     // MIs[0] op1
     /*  943920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943947 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  943950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943952 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943954 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943956 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943958 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943968 */     GIR_RootConstrainSelectedInstOperands,
     /*  943969 */     // GIR_Coverage, 62893,
     /*  943969 */     GIR_EraseRootFromParent_Done,
     /*  943970 */   // Label 14256: @943970
     /*  943970 */   GIM_Try, /*On fail goto*//*Label 14257*/ GIMT_Encode4(944052), // Rule ID 62894 //
     /*  943975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  943986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  943989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  943992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944002 */     // MIs[0] op1
     /*  944002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944029 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  944032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944034 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944036 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944038 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944040 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944050 */     GIR_RootConstrainSelectedInstOperands,
     /*  944051 */     // GIR_Coverage, 62894,
     /*  944051 */     GIR_EraseRootFromParent_Done,
     /*  944052 */   // Label 14257: @944052
     /*  944052 */   GIM_Try, /*On fail goto*//*Label 14258*/ GIMT_Encode4(944134), // Rule ID 62905 //
     /*  944057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  944077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944084 */     // MIs[0] op1
     /*  944084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944087 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944111 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  944114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944116 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944118 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944120 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944122 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944132 */     GIR_RootConstrainSelectedInstOperands,
     /*  944133 */     // GIR_Coverage, 62905,
     /*  944133 */     GIR_EraseRootFromParent_Done,
     /*  944134 */   // Label 14258: @944134
     /*  944134 */   GIM_Try, /*On fail goto*//*Label 14259*/ GIMT_Encode4(944216), // Rule ID 62906 //
     /*  944139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  944150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  944153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  944156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  944159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944166 */     // MIs[0] op1
     /*  944166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944193 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  944196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944198 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944200 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944202 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944204 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944214 */     GIR_RootConstrainSelectedInstOperands,
     /*  944215 */     // GIR_Coverage, 62906,
     /*  944215 */     GIR_EraseRootFromParent_Done,
     /*  944216 */   // Label 14259: @944216
     /*  944216 */   GIM_Try, /*On fail goto*//*Label 14260*/ GIMT_Encode4(944298), // Rule ID 62937 //
     /*  944221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944248 */     // MIs[0] op1
     /*  944248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944275 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  944278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944280 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944282 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944284 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944286 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944296 */     GIR_RootConstrainSelectedInstOperands,
     /*  944297 */     // GIR_Coverage, 62937,
     /*  944297 */     GIR_EraseRootFromParent_Done,
     /*  944298 */   // Label 14260: @944298
     /*  944298 */   GIM_Try, /*On fail goto*//*Label 14261*/ GIMT_Encode4(944380), // Rule ID 62938 //
     /*  944303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944330 */     // MIs[0] op1
     /*  944330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944333 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944357 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  944360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944362 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944364 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944366 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944368 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944378 */     GIR_RootConstrainSelectedInstOperands,
     /*  944379 */     // GIR_Coverage, 62938,
     /*  944379 */     GIR_EraseRootFromParent_Done,
     /*  944380 */   // Label 14261: @944380
     /*  944380 */   GIM_Try, /*On fail goto*//*Label 14262*/ GIMT_Encode4(944462), // Rule ID 62949 //
     /*  944385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  944405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944412 */     // MIs[0] op1
     /*  944412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944439 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  944439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  944442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944444 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944446 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944448 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944450 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944460 */     GIR_RootConstrainSelectedInstOperands,
     /*  944461 */     // GIR_Coverage, 62949,
     /*  944461 */     GIR_EraseRootFromParent_Done,
     /*  944462 */   // Label 14262: @944462
     /*  944462 */   GIM_Try, /*On fail goto*//*Label 14263*/ GIMT_Encode4(944544), // Rule ID 62950 //
     /*  944467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  944478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  944481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  944484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  944487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944494 */     // MIs[0] op1
     /*  944494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944521 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  944524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944526 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944528 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944530 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944532 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944542 */     GIR_RootConstrainSelectedInstOperands,
     /*  944543 */     // GIR_Coverage, 62950,
     /*  944543 */     GIR_EraseRootFromParent_Done,
     /*  944544 */   // Label 14263: @944544
     /*  944544 */   GIM_Try, /*On fail goto*//*Label 14264*/ GIMT_Encode4(944626), // Rule ID 62981 //
     /*  944549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944576 */     // MIs[0] op1
     /*  944576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944603 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  944606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944608 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944610 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944612 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944614 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944624 */     GIR_RootConstrainSelectedInstOperands,
     /*  944625 */     // GIR_Coverage, 62981,
     /*  944625 */     GIR_EraseRootFromParent_Done,
     /*  944626 */   // Label 14264: @944626
     /*  944626 */   GIM_Try, /*On fail goto*//*Label 14265*/ GIMT_Encode4(944708), // Rule ID 62982 //
     /*  944631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944658 */     // MIs[0] op1
     /*  944658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944685 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  944688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944690 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944692 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944694 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944696 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944706 */     GIR_RootConstrainSelectedInstOperands,
     /*  944707 */     // GIR_Coverage, 62982,
     /*  944707 */     GIR_EraseRootFromParent_Done,
     /*  944708 */   // Label 14265: @944708
     /*  944708 */   GIM_Try, /*On fail goto*//*Label 14266*/ GIMT_Encode4(944790), // Rule ID 62993 //
     /*  944713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  944733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944740 */     // MIs[0] op1
     /*  944740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944767 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  944770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944772 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944774 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944776 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944778 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944788 */     GIR_RootConstrainSelectedInstOperands,
     /*  944789 */     // GIR_Coverage, 62993,
     /*  944789 */     GIR_EraseRootFromParent_Done,
     /*  944790 */   // Label 14266: @944790
     /*  944790 */   GIM_Try, /*On fail goto*//*Label 14267*/ GIMT_Encode4(944872), // Rule ID 62994 //
     /*  944795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  944815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944822 */     // MIs[0] op1
     /*  944822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944849 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  944852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944854 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944856 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944858 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944860 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944870 */     GIR_RootConstrainSelectedInstOperands,
     /*  944871 */     // GIR_Coverage, 62994,
     /*  944871 */     GIR_EraseRootFromParent_Done,
     /*  944872 */   // Label 14267: @944872
     /*  944872 */   GIM_Try, /*On fail goto*//*Label 14268*/ GIMT_Encode4(944954), // Rule ID 63005 //
     /*  944877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  944885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  944897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944904 */     // MIs[0] op1
     /*  944904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  944912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  944924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944931 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  944934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944936 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944938 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944940 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944942 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944952 */     GIR_RootConstrainSelectedInstOperands,
     /*  944953 */     // GIR_Coverage, 63005,
     /*  944953 */     GIR_EraseRootFromParent_Done,
     /*  944954 */   // Label 14268: @944954
     /*  944954 */   GIM_Try, /*On fail goto*//*Label 14269*/ GIMT_Encode4(945036), // Rule ID 63006 //
     /*  944959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  944967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  944979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944986 */     // MIs[0] op1
     /*  944986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944989 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  944994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945013 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  945016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945018 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945020 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945022 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945024 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945034 */     GIR_RootConstrainSelectedInstOperands,
     /*  945035 */     // GIR_Coverage, 63006,
     /*  945035 */     GIR_EraseRootFromParent_Done,
     /*  945036 */   // Label 14269: @945036
     /*  945036 */   GIM_Try, /*On fail goto*//*Label 14270*/ GIMT_Encode4(945118), // Rule ID 63037 //
     /*  945041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945068 */     // MIs[0] op1
     /*  945068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945095 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  945098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945100 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945102 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945104 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945106 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945116 */     GIR_RootConstrainSelectedInstOperands,
     /*  945117 */     // GIR_Coverage, 63037,
     /*  945117 */     GIR_EraseRootFromParent_Done,
     /*  945118 */   // Label 14270: @945118
     /*  945118 */   GIM_Try, /*On fail goto*//*Label 14271*/ GIMT_Encode4(945200), // Rule ID 63038 //
     /*  945123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945150 */     // MIs[0] op1
     /*  945150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945153 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945177 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  945180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945182 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945184 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945186 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945188 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945198 */     GIR_RootConstrainSelectedInstOperands,
     /*  945199 */     // GIR_Coverage, 63038,
     /*  945199 */     GIR_EraseRootFromParent_Done,
     /*  945200 */   // Label 14271: @945200
     /*  945200 */   GIM_Try, /*On fail goto*//*Label 14272*/ GIMT_Encode4(945282), // Rule ID 63049 //
     /*  945205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  945225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945232 */     // MIs[0] op1
     /*  945232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  945262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945264 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945266 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945268 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945270 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945280 */     GIR_RootConstrainSelectedInstOperands,
     /*  945281 */     // GIR_Coverage, 63049,
     /*  945281 */     GIR_EraseRootFromParent_Done,
     /*  945282 */   // Label 14272: @945282
     /*  945282 */   GIM_Try, /*On fail goto*//*Label 14273*/ GIMT_Encode4(945364), // Rule ID 63050 //
     /*  945287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  945307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945314 */     // MIs[0] op1
     /*  945314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945341 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  945344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945346 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945348 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945350 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945352 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945362 */     GIR_RootConstrainSelectedInstOperands,
     /*  945363 */     // GIR_Coverage, 63050,
     /*  945363 */     GIR_EraseRootFromParent_Done,
     /*  945364 */   // Label 14273: @945364
     /*  945364 */   GIM_Try, /*On fail goto*//*Label 14274*/ GIMT_Encode4(945446), // Rule ID 63061 //
     /*  945369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945396 */     // MIs[0] op1
     /*  945396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945423 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  945426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945428 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945430 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945432 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945434 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945444 */     GIR_RootConstrainSelectedInstOperands,
     /*  945445 */     // GIR_Coverage, 63061,
     /*  945445 */     GIR_EraseRootFromParent_Done,
     /*  945446 */   // Label 14274: @945446
     /*  945446 */   GIM_Try, /*On fail goto*//*Label 14275*/ GIMT_Encode4(945528), // Rule ID 63062 //
     /*  945451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  945462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  945465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  945468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  945471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945478 */     // MIs[0] op1
     /*  945478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  945498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945505 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  945508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945510 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945512 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945514 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945516 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945526 */     GIR_RootConstrainSelectedInstOperands,
     /*  945527 */     // GIR_Coverage, 63062,
     /*  945527 */     GIR_EraseRootFromParent_Done,
     /*  945528 */   // Label 14275: @945528
     /*  945528 */   GIM_Try, /*On fail goto*//*Label 14276*/ GIMT_Encode4(945610), // Rule ID 63093 //
     /*  945533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945560 */     // MIs[0] op1
     /*  945560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945587 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  945587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  945590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945592 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945594 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945596 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945598 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945608 */     GIR_RootConstrainSelectedInstOperands,
     /*  945609 */     // GIR_Coverage, 63093,
     /*  945609 */     GIR_EraseRootFromParent_Done,
     /*  945610 */   // Label 14276: @945610
     /*  945610 */   GIM_Try, /*On fail goto*//*Label 14277*/ GIMT_Encode4(945692), // Rule ID 63094 //
     /*  945615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945642 */     // MIs[0] op1
     /*  945642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945669 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  945669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  945672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945674 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945676 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945678 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945680 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945690 */     GIR_RootConstrainSelectedInstOperands,
     /*  945691 */     // GIR_Coverage, 63094,
     /*  945691 */     GIR_EraseRootFromParent_Done,
     /*  945692 */   // Label 14277: @945692
     /*  945692 */   GIM_Try, /*On fail goto*//*Label 14278*/ GIMT_Encode4(945774), // Rule ID 63105 //
     /*  945697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  945717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945724 */     // MIs[0] op1
     /*  945724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945751 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  945751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  945754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945756 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945758 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945760 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945762 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945772 */     GIR_RootConstrainSelectedInstOperands,
     /*  945773 */     // GIR_Coverage, 63105,
     /*  945773 */     GIR_EraseRootFromParent_Done,
     /*  945774 */   // Label 14278: @945774
     /*  945774 */   GIM_Try, /*On fail goto*//*Label 14279*/ GIMT_Encode4(945856), // Rule ID 63106 //
     /*  945779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  945799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945806 */     // MIs[0] op1
     /*  945806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945833 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  945833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  945836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945838 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945840 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945842 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945844 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945854 */     GIR_RootConstrainSelectedInstOperands,
     /*  945855 */     // GIR_Coverage, 63106,
     /*  945855 */     GIR_EraseRootFromParent_Done,
     /*  945856 */   // Label 14279: @945856
     /*  945856 */   GIM_Try, /*On fail goto*//*Label 14280*/ GIMT_Encode4(945938), // Rule ID 63117 //
     /*  945861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945888 */     // MIs[0] op1
     /*  945888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  945908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945915 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  945915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  945918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945920 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945922 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945924 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945926 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945936 */     GIR_RootConstrainSelectedInstOperands,
     /*  945937 */     // GIR_Coverage, 63117,
     /*  945937 */     GIR_EraseRootFromParent_Done,
     /*  945938 */   // Label 14280: @945938
     /*  945938 */   GIM_Try, /*On fail goto*//*Label 14281*/ GIMT_Encode4(946020), // Rule ID 63118 //
     /*  945943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945970 */     // MIs[0] op1
     /*  945970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  945990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945997 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  945997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  946000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946002 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946004 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946006 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946008 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946018 */     GIR_RootConstrainSelectedInstOperands,
     /*  946019 */     // GIR_Coverage, 63118,
     /*  946019 */     GIR_EraseRootFromParent_Done,
     /*  946020 */   // Label 14281: @946020
     /*  946020 */   GIM_Try, /*On fail goto*//*Label 14282*/ GIMT_Encode4(946102), // Rule ID 63149 //
     /*  946025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946052 */     // MIs[0] op1
     /*  946052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946079 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  946079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946084 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946086 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946088 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946090 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946100 */     GIR_RootConstrainSelectedInstOperands,
     /*  946101 */     // GIR_Coverage, 63149,
     /*  946101 */     GIR_EraseRootFromParent_Done,
     /*  946102 */   // Label 14282: @946102
     /*  946102 */   GIM_Try, /*On fail goto*//*Label 14283*/ GIMT_Encode4(946184), // Rule ID 63150 //
     /*  946107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946134 */     // MIs[0] op1
     /*  946134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946161 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  946161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946166 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946168 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946170 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946172 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946182 */     GIR_RootConstrainSelectedInstOperands,
     /*  946183 */     // GIR_Coverage, 63150,
     /*  946183 */     GIR_EraseRootFromParent_Done,
     /*  946184 */   // Label 14283: @946184
     /*  946184 */   GIM_Try, /*On fail goto*//*Label 14284*/ GIMT_Encode4(946266), // Rule ID 63161 //
     /*  946189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  946209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946216 */     // MIs[0] op1
     /*  946216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946243 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  946243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  946246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946248 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946250 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946252 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946254 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946264 */     GIR_RootConstrainSelectedInstOperands,
     /*  946265 */     // GIR_Coverage, 63161,
     /*  946265 */     GIR_EraseRootFromParent_Done,
     /*  946266 */   // Label 14284: @946266
     /*  946266 */   GIM_Try, /*On fail goto*//*Label 14285*/ GIMT_Encode4(946348), // Rule ID 63162 //
     /*  946271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  946282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  946285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  946288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  946291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946298 */     // MIs[0] op1
     /*  946298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946325 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  946325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  946328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946330 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946332 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946334 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946336 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  946346 */     GIR_RootConstrainSelectedInstOperands,
     /*  946347 */     // GIR_Coverage, 63162,
     /*  946347 */     GIR_EraseRootFromParent_Done,
     /*  946348 */   // Label 14285: @946348
     /*  946348 */   GIM_Try, /*On fail goto*//*Label 14286*/ GIMT_Encode4(946430), // Rule ID 63193 //
     /*  946353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946380 */     // MIs[0] op1
     /*  946380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946407 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946412 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946414 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946416 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946418 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946428 */     GIR_RootConstrainSelectedInstOperands,
     /*  946429 */     // GIR_Coverage, 63193,
     /*  946429 */     GIR_EraseRootFromParent_Done,
     /*  946430 */   // Label 14286: @946430
     /*  946430 */   GIM_Try, /*On fail goto*//*Label 14287*/ GIMT_Encode4(946512), // Rule ID 63194 //
     /*  946435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946462 */     // MIs[0] op1
     /*  946462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946494 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946496 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946498 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946500 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946510 */     GIR_RootConstrainSelectedInstOperands,
     /*  946511 */     // GIR_Coverage, 63194,
     /*  946511 */     GIR_EraseRootFromParent_Done,
     /*  946512 */   // Label 14287: @946512
     /*  946512 */   GIM_Try, /*On fail goto*//*Label 14288*/ GIMT_Encode4(946594), // Rule ID 63205 //
     /*  946517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  946537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946544 */     // MIs[0] op1
     /*  946544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946547 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946571 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  946574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946576 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946578 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946580 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946582 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946592 */     GIR_RootConstrainSelectedInstOperands,
     /*  946593 */     // GIR_Coverage, 63205,
     /*  946593 */     GIR_EraseRootFromParent_Done,
     /*  946594 */   // Label 14288: @946594
     /*  946594 */   GIM_Try, /*On fail goto*//*Label 14289*/ GIMT_Encode4(946676), // Rule ID 63206 //
     /*  946599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  946619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946626 */     // MIs[0] op1
     /*  946626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946653 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  946656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946658 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946660 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946662 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946664 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946674 */     GIR_RootConstrainSelectedInstOperands,
     /*  946675 */     // GIR_Coverage, 63206,
     /*  946675 */     GIR_EraseRootFromParent_Done,
     /*  946676 */   // Label 14289: @946676
     /*  946676 */   GIM_Try, /*On fail goto*//*Label 14290*/ GIMT_Encode4(946758), // Rule ID 63217 //
     /*  946681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  946701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946708 */     // MIs[0] op1
     /*  946708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946711 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  946728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946735 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  946738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946740 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946742 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946744 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946746 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946756 */     GIR_RootConstrainSelectedInstOperands,
     /*  946757 */     // GIR_Coverage, 63217,
     /*  946757 */     GIR_EraseRootFromParent_Done,
     /*  946758 */   // Label 14290: @946758
     /*  946758 */   GIM_Try, /*On fail goto*//*Label 14291*/ GIMT_Encode4(946840), // Rule ID 63218 //
     /*  946763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  946783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946790 */     // MIs[0] op1
     /*  946790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  946810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946817 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  946820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946822 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946824 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946826 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946828 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946838 */     GIR_RootConstrainSelectedInstOperands,
     /*  946839 */     // GIR_Coverage, 63218,
     /*  946839 */     GIR_EraseRootFromParent_Done,
     /*  946840 */   // Label 14291: @946840
     /*  946840 */   GIM_Try, /*On fail goto*//*Label 14292*/ GIMT_Encode4(946922), // Rule ID 63249 //
     /*  946845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946872 */     // MIs[0] op1
     /*  946872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946899 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946904 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946906 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946908 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946910 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946920 */     GIR_RootConstrainSelectedInstOperands,
     /*  946921 */     // GIR_Coverage, 63249,
     /*  946921 */     GIR_EraseRootFromParent_Done,
     /*  946922 */   // Label 14292: @946922
     /*  946922 */   GIM_Try, /*On fail goto*//*Label 14293*/ GIMT_Encode4(947004), // Rule ID 63250 //
     /*  946927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946954 */     // MIs[0] op1
     /*  946954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946981 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946986 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946988 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946990 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946992 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947002 */     GIR_RootConstrainSelectedInstOperands,
     /*  947003 */     // GIR_Coverage, 63250,
     /*  947003 */     GIR_EraseRootFromParent_Done,
     /*  947004 */   // Label 14293: @947004
     /*  947004 */   GIM_Try, /*On fail goto*//*Label 14294*/ GIMT_Encode4(947086), // Rule ID 63261 //
     /*  947009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  947029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947036 */     // MIs[0] op1
     /*  947036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947063 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  947066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947068 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947070 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947072 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947074 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947084 */     GIR_RootConstrainSelectedInstOperands,
     /*  947085 */     // GIR_Coverage, 63261,
     /*  947085 */     GIR_EraseRootFromParent_Done,
     /*  947086 */   // Label 14294: @947086
     /*  947086 */   GIM_Try, /*On fail goto*//*Label 14295*/ GIMT_Encode4(947168), // Rule ID 63262 //
     /*  947091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  947111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947118 */     // MIs[0] op1
     /*  947118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947145 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  947148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947150 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947152 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947154 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947156 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947166 */     GIR_RootConstrainSelectedInstOperands,
     /*  947167 */     // GIR_Coverage, 63262,
     /*  947167 */     GIR_EraseRootFromParent_Done,
     /*  947168 */   // Label 14295: @947168
     /*  947168 */   GIM_Try, /*On fail goto*//*Label 14296*/ GIMT_Encode4(947250), // Rule ID 63273 //
     /*  947173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947200 */     // MIs[0] op1
     /*  947200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  947220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947227 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  947227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  947230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947232 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947234 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947236 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947238 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947248 */     GIR_RootConstrainSelectedInstOperands,
     /*  947249 */     // GIR_Coverage, 63273,
     /*  947249 */     GIR_EraseRootFromParent_Done,
     /*  947250 */   // Label 14296: @947250
     /*  947250 */   GIM_Try, /*On fail goto*//*Label 14297*/ GIMT_Encode4(947332), // Rule ID 63274 //
     /*  947255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  947266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  947269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  947272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947282 */     // MIs[0] op1
     /*  947282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  947302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947309 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  947309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  947312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947314 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947316 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947318 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947320 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  947330 */     GIR_RootConstrainSelectedInstOperands,
     /*  947331 */     // GIR_Coverage, 63274,
     /*  947331 */     GIR_EraseRootFromParent_Done,
     /*  947332 */   // Label 14297: @947332
     /*  947332 */   GIM_Try, /*On fail goto*//*Label 14298*/ GIMT_Encode4(947414), // Rule ID 63305 //
     /*  947337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947364 */     // MIs[0] op1
     /*  947364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  947394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947396 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947398 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947400 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947402 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947412 */     GIR_RootConstrainSelectedInstOperands,
     /*  947413 */     // GIR_Coverage, 63305,
     /*  947413 */     GIR_EraseRootFromParent_Done,
     /*  947414 */   // Label 14298: @947414
     /*  947414 */   GIM_Try, /*On fail goto*//*Label 14299*/ GIMT_Encode4(947496), // Rule ID 63306 //
     /*  947419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947446 */     // MIs[0] op1
     /*  947446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947473 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  947476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947478 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947480 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947482 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947484 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947494 */     GIR_RootConstrainSelectedInstOperands,
     /*  947495 */     // GIR_Coverage, 63306,
     /*  947495 */     GIR_EraseRootFromParent_Done,
     /*  947496 */   // Label 14299: @947496
     /*  947496 */   GIM_Try, /*On fail goto*//*Label 14300*/ GIMT_Encode4(947578), // Rule ID 63317 //
     /*  947501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  947521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947528 */     // MIs[0] op1
     /*  947528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947555 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  947558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947560 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947562 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947564 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947566 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947576 */     GIR_RootConstrainSelectedInstOperands,
     /*  947577 */     // GIR_Coverage, 63317,
     /*  947577 */     GIR_EraseRootFromParent_Done,
     /*  947578 */   // Label 14300: @947578
     /*  947578 */   GIM_Try, /*On fail goto*//*Label 14301*/ GIMT_Encode4(947660), // Rule ID 63318 //
     /*  947583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  947603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947610 */     // MIs[0] op1
     /*  947610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947637 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  947640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947642 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947644 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947646 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947648 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947658 */     GIR_RootConstrainSelectedInstOperands,
     /*  947659 */     // GIR_Coverage, 63318,
     /*  947659 */     GIR_EraseRootFromParent_Done,
     /*  947660 */   // Label 14301: @947660
     /*  947660 */   GIM_Try, /*On fail goto*//*Label 14302*/ GIMT_Encode4(947742), // Rule ID 63329 //
     /*  947665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947692 */     // MIs[0] op1
     /*  947692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  947712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947719 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  947722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947724 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947726 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947728 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947730 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947740 */     GIR_RootConstrainSelectedInstOperands,
     /*  947741 */     // GIR_Coverage, 63329,
     /*  947741 */     GIR_EraseRootFromParent_Done,
     /*  947742 */   // Label 14302: @947742
     /*  947742 */   GIM_Try, /*On fail goto*//*Label 14303*/ GIMT_Encode4(947824), // Rule ID 63330 //
     /*  947747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947774 */     // MIs[0] op1
     /*  947774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  947794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947801 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  947804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947806 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947808 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947810 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947812 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947822 */     GIR_RootConstrainSelectedInstOperands,
     /*  947823 */     // GIR_Coverage, 63330,
     /*  947823 */     GIR_EraseRootFromParent_Done,
     /*  947824 */   // Label 14303: @947824
     /*  947824 */   GIM_Try, /*On fail goto*//*Label 14304*/ GIMT_Encode4(947906), // Rule ID 63361 //
     /*  947829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  947840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947856 */     // MIs[0] op1
     /*  947856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947859 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947883 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  947886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947888 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947890 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947892 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947894 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947904 */     GIR_RootConstrainSelectedInstOperands,
     /*  947905 */     // GIR_Coverage, 63361,
     /*  947905 */     GIR_EraseRootFromParent_Done,
     /*  947906 */   // Label 14304: @947906
     /*  947906 */   GIM_Try, /*On fail goto*//*Label 14305*/ GIMT_Encode4(947988), // Rule ID 63362 //
     /*  947911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  947922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947938 */     // MIs[0] op1
     /*  947938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947965 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  947968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947970 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947972 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947974 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947976 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947986 */     GIR_RootConstrainSelectedInstOperands,
     /*  947987 */     // GIR_Coverage, 63362,
     /*  947987 */     GIR_EraseRootFromParent_Done,
     /*  947988 */   // Label 14305: @947988
     /*  947988 */   GIM_Try, /*On fail goto*//*Label 14306*/ GIMT_Encode4(948070), // Rule ID 63373 //
     /*  947993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  948013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948020 */     // MIs[0] op1
     /*  948020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948047 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  948050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948052 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948054 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948056 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948058 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948068 */     GIR_RootConstrainSelectedInstOperands,
     /*  948069 */     // GIR_Coverage, 63373,
     /*  948069 */     GIR_EraseRootFromParent_Done,
     /*  948070 */   // Label 14306: @948070
     /*  948070 */   GIM_Try, /*On fail goto*//*Label 14307*/ GIMT_Encode4(948152), // Rule ID 63374 //
     /*  948075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  948086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  948089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  948092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  948095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948102 */     // MIs[0] op1
     /*  948102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948129 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  948132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948134 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948136 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948138 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948140 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948150 */     GIR_RootConstrainSelectedInstOperands,
     /*  948151 */     // GIR_Coverage, 63374,
     /*  948151 */     GIR_EraseRootFromParent_Done,
     /*  948152 */   // Label 14307: @948152
     /*  948152 */   GIM_Try, /*On fail goto*//*Label 14308*/ GIMT_Encode4(948234), // Rule ID 63405 //
     /*  948157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948184 */     // MIs[0] op1
     /*  948184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948211 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  948214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948216 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948218 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948220 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948222 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948232 */     GIR_RootConstrainSelectedInstOperands,
     /*  948233 */     // GIR_Coverage, 63405,
     /*  948233 */     GIR_EraseRootFromParent_Done,
     /*  948234 */   // Label 14308: @948234
     /*  948234 */   GIM_Try, /*On fail goto*//*Label 14309*/ GIMT_Encode4(948316), // Rule ID 63406 //
     /*  948239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948266 */     // MIs[0] op1
     /*  948266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948293 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  948296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948298 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948300 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948302 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948304 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948314 */     GIR_RootConstrainSelectedInstOperands,
     /*  948315 */     // GIR_Coverage, 63406,
     /*  948315 */     GIR_EraseRootFromParent_Done,
     /*  948316 */   // Label 14309: @948316
     /*  948316 */   GIM_Try, /*On fail goto*//*Label 14310*/ GIMT_Encode4(948398), // Rule ID 63417 //
     /*  948321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  948341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948348 */     // MIs[0] op1
     /*  948348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948375 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  948378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948380 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948382 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948384 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948386 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948396 */     GIR_RootConstrainSelectedInstOperands,
     /*  948397 */     // GIR_Coverage, 63417,
     /*  948397 */     GIR_EraseRootFromParent_Done,
     /*  948398 */   // Label 14310: @948398
     /*  948398 */   GIM_Try, /*On fail goto*//*Label 14311*/ GIMT_Encode4(948480), // Rule ID 63418 //
     /*  948403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  948414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  948417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  948420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  948423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948430 */     // MIs[0] op1
     /*  948430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948457 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  948460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948462 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948464 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948466 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948468 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948478 */     GIR_RootConstrainSelectedInstOperands,
     /*  948479 */     // GIR_Coverage, 63418,
     /*  948479 */     GIR_EraseRootFromParent_Done,
     /*  948480 */   // Label 14311: @948480
     /*  948480 */   GIM_Try, /*On fail goto*//*Label 14312*/ GIMT_Encode4(948562), // Rule ID 63449 //
     /*  948485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948512 */     // MIs[0] op1
     /*  948512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948539 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  948542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948544 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948546 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948548 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948550 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948560 */     GIR_RootConstrainSelectedInstOperands,
     /*  948561 */     // GIR_Coverage, 63449,
     /*  948561 */     GIR_EraseRootFromParent_Done,
     /*  948562 */   // Label 14312: @948562
     /*  948562 */   GIM_Try, /*On fail goto*//*Label 14313*/ GIMT_Encode4(948644), // Rule ID 63450 //
     /*  948567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948594 */     // MIs[0] op1
     /*  948594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948621 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  948624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948626 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948628 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948630 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948632 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948642 */     GIR_RootConstrainSelectedInstOperands,
     /*  948643 */     // GIR_Coverage, 63450,
     /*  948643 */     GIR_EraseRootFromParent_Done,
     /*  948644 */   // Label 14313: @948644
     /*  948644 */   GIM_Try, /*On fail goto*//*Label 14314*/ GIMT_Encode4(948726), // Rule ID 63461 //
     /*  948649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  948669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948676 */     // MIs[0] op1
     /*  948676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948703 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  948706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948708 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948710 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948712 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948714 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948724 */     GIR_RootConstrainSelectedInstOperands,
     /*  948725 */     // GIR_Coverage, 63461,
     /*  948725 */     GIR_EraseRootFromParent_Done,
     /*  948726 */   // Label 14314: @948726
     /*  948726 */   GIM_Try, /*On fail goto*//*Label 14315*/ GIMT_Encode4(948808), // Rule ID 63462 //
     /*  948731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  948751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948758 */     // MIs[0] op1
     /*  948758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948785 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  948788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948790 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948792 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948794 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948796 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948806 */     GIR_RootConstrainSelectedInstOperands,
     /*  948807 */     // GIR_Coverage, 63462,
     /*  948807 */     GIR_EraseRootFromParent_Done,
     /*  948808 */   // Label 14315: @948808
     /*  948808 */   GIM_Try, /*On fail goto*//*Label 14316*/ GIMT_Encode4(948890), // Rule ID 63493 //
     /*  948813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948840 */     // MIs[0] op1
     /*  948840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948867 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  948870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948872 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948874 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948876 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948878 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948888 */     GIR_RootConstrainSelectedInstOperands,
     /*  948889 */     // GIR_Coverage, 63493,
     /*  948889 */     GIR_EraseRootFromParent_Done,
     /*  948890 */   // Label 14316: @948890
     /*  948890 */   GIM_Try, /*On fail goto*//*Label 14317*/ GIMT_Encode4(948972), // Rule ID 63494 //
     /*  948895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948922 */     // MIs[0] op1
     /*  948922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  948952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948954 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948956 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948958 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948960 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948970 */     GIR_RootConstrainSelectedInstOperands,
     /*  948971 */     // GIR_Coverage, 63494,
     /*  948971 */     GIR_EraseRootFromParent_Done,
     /*  948972 */   // Label 14317: @948972
     /*  948972 */   GIM_Try, /*On fail goto*//*Label 14318*/ GIMT_Encode4(949054), // Rule ID 63505 //
     /*  948977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  948997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949004 */     // MIs[0] op1
     /*  949004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949007 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949031 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  949034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949036 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949038 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949040 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949042 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949052 */     GIR_RootConstrainSelectedInstOperands,
     /*  949053 */     // GIR_Coverage, 63505,
     /*  949053 */     GIR_EraseRootFromParent_Done,
     /*  949054 */   // Label 14318: @949054
     /*  949054 */   GIM_Try, /*On fail goto*//*Label 14319*/ GIMT_Encode4(949136), // Rule ID 63506 //
     /*  949059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  949079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949086 */     // MIs[0] op1
     /*  949086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949113 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  949116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949118 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949120 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949122 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949124 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949134 */     GIR_RootConstrainSelectedInstOperands,
     /*  949135 */     // GIR_Coverage, 63506,
     /*  949135 */     GIR_EraseRootFromParent_Done,
     /*  949136 */   // Label 14319: @949136
     /*  949136 */   GIM_Try, /*On fail goto*//*Label 14320*/ GIMT_Encode4(949218), // Rule ID 63517 //
     /*  949141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949168 */     // MIs[0] op1
     /*  949168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949195 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  949198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949200 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949202 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949204 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949206 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949216 */     GIR_RootConstrainSelectedInstOperands,
     /*  949217 */     // GIR_Coverage, 63517,
     /*  949217 */     GIR_EraseRootFromParent_Done,
     /*  949218 */   // Label 14320: @949218
     /*  949218 */   GIM_Try, /*On fail goto*//*Label 14321*/ GIMT_Encode4(949300), // Rule ID 63518 //
     /*  949223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  949234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  949237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  949240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949250 */     // MIs[0] op1
     /*  949250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  949280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949282 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949284 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949286 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949288 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949298 */     GIR_RootConstrainSelectedInstOperands,
     /*  949299 */     // GIR_Coverage, 63518,
     /*  949299 */     GIR_EraseRootFromParent_Done,
     /*  949300 */   // Label 14321: @949300
     /*  949300 */   GIM_Try, /*On fail goto*//*Label 14322*/ GIMT_Encode4(949382), // Rule ID 63549 //
     /*  949305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949332 */     // MIs[0] op1
     /*  949332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949359 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  949362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949364 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949366 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949368 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949370 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949380 */     GIR_RootConstrainSelectedInstOperands,
     /*  949381 */     // GIR_Coverage, 63549,
     /*  949381 */     GIR_EraseRootFromParent_Done,
     /*  949382 */   // Label 14322: @949382
     /*  949382 */   GIM_Try, /*On fail goto*//*Label 14323*/ GIMT_Encode4(949464), // Rule ID 63550 //
     /*  949387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949414 */     // MIs[0] op1
     /*  949414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949417 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949441 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  949444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949446 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949448 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949450 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949452 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949462 */     GIR_RootConstrainSelectedInstOperands,
     /*  949463 */     // GIR_Coverage, 63550,
     /*  949463 */     GIR_EraseRootFromParent_Done,
     /*  949464 */   // Label 14323: @949464
     /*  949464 */   GIM_Try, /*On fail goto*//*Label 14324*/ GIMT_Encode4(949546), // Rule ID 63561 //
     /*  949469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  949489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949496 */     // MIs[0] op1
     /*  949496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949523 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  949526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949528 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949530 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949532 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949534 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949544 */     GIR_RootConstrainSelectedInstOperands,
     /*  949545 */     // GIR_Coverage, 63561,
     /*  949545 */     GIR_EraseRootFromParent_Done,
     /*  949546 */   // Label 14324: @949546
     /*  949546 */   GIM_Try, /*On fail goto*//*Label 14325*/ GIMT_Encode4(949628), // Rule ID 63562 //
     /*  949551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  949571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949578 */     // MIs[0] op1
     /*  949578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949605 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  949608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949610 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949612 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949614 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949616 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949626 */     GIR_RootConstrainSelectedInstOperands,
     /*  949627 */     // GIR_Coverage, 63562,
     /*  949627 */     GIR_EraseRootFromParent_Done,
     /*  949628 */   // Label 14325: @949628
     /*  949628 */   GIM_Try, /*On fail goto*//*Label 14326*/ GIMT_Encode4(949710), // Rule ID 63573 //
     /*  949633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949660 */     // MIs[0] op1
     /*  949660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949687 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  949690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949692 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949694 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949696 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949698 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949708 */     GIR_RootConstrainSelectedInstOperands,
     /*  949709 */     // GIR_Coverage, 63573,
     /*  949709 */     GIR_EraseRootFromParent_Done,
     /*  949710 */   // Label 14326: @949710
     /*  949710 */   GIM_Try, /*On fail goto*//*Label 14327*/ GIMT_Encode4(949792), // Rule ID 63574 //
     /*  949715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949742 */     // MIs[0] op1
     /*  949742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949769 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  949772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949774 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949776 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949778 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949780 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949790 */     GIR_RootConstrainSelectedInstOperands,
     /*  949791 */     // GIR_Coverage, 63574,
     /*  949791 */     GIR_EraseRootFromParent_Done,
     /*  949792 */   // Label 14327: @949792
     /*  949792 */   GIM_Try, /*On fail goto*//*Label 14328*/ GIMT_Encode4(949874), // Rule ID 63605 //
     /*  949797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949824 */     // MIs[0] op1
     /*  949824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949851 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  949854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949856 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949858 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949860 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949862 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949872 */     GIR_RootConstrainSelectedInstOperands,
     /*  949873 */     // GIR_Coverage, 63605,
     /*  949873 */     GIR_EraseRootFromParent_Done,
     /*  949874 */   // Label 14328: @949874
     /*  949874 */   GIM_Try, /*On fail goto*//*Label 14329*/ GIMT_Encode4(949956), // Rule ID 63606 //
     /*  949879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949906 */     // MIs[0] op1
     /*  949906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949933 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  949936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949938 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949940 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949942 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949944 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949954 */     GIR_RootConstrainSelectedInstOperands,
     /*  949955 */     // GIR_Coverage, 63606,
     /*  949955 */     GIR_EraseRootFromParent_Done,
     /*  949956 */   // Label 14329: @949956
     /*  949956 */   GIM_Try, /*On fail goto*//*Label 14330*/ GIMT_Encode4(950038), // Rule ID 63617 //
     /*  949961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  949981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949988 */     // MIs[0] op1
     /*  949988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950015 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  950018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950020 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950022 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950024 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950026 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950036 */     GIR_RootConstrainSelectedInstOperands,
     /*  950037 */     // GIR_Coverage, 63617,
     /*  950037 */     GIR_EraseRootFromParent_Done,
     /*  950038 */   // Label 14330: @950038
     /*  950038 */   GIM_Try, /*On fail goto*//*Label 14331*/ GIMT_Encode4(950120), // Rule ID 63618 //
     /*  950043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  950063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950070 */     // MIs[0] op1
     /*  950070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950097 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  950100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950102 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950104 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950106 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950108 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950118 */     GIR_RootConstrainSelectedInstOperands,
     /*  950119 */     // GIR_Coverage, 63618,
     /*  950119 */     GIR_EraseRootFromParent_Done,
     /*  950120 */   // Label 14331: @950120
     /*  950120 */   GIM_Try, /*On fail goto*//*Label 14332*/ GIMT_Encode4(950202), // Rule ID 63629 //
     /*  950125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950152 */     // MIs[0] op1
     /*  950152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950179 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  950179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  950182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950184 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950186 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950188 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950190 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950200 */     GIR_RootConstrainSelectedInstOperands,
     /*  950201 */     // GIR_Coverage, 63629,
     /*  950201 */     GIR_EraseRootFromParent_Done,
     /*  950202 */   // Label 14332: @950202
     /*  950202 */   GIM_Try, /*On fail goto*//*Label 14333*/ GIMT_Encode4(950284), // Rule ID 63630 //
     /*  950207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  950218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  950221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  950224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  950227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950234 */     // MIs[0] op1
     /*  950234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  950254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950261 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  950261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  950264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950266 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950268 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950270 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950272 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  950282 */     GIR_RootConstrainSelectedInstOperands,
     /*  950283 */     // GIR_Coverage, 63630,
     /*  950283 */     GIR_EraseRootFromParent_Done,
     /*  950284 */   // Label 14333: @950284
     /*  950284 */   GIM_Try, /*On fail goto*//*Label 14334*/ GIMT_Encode4(950366), // Rule ID 63661 //
     /*  950289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950316 */     // MIs[0] op1
     /*  950316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  950346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950348 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950350 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950352 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950354 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950364 */     GIR_RootConstrainSelectedInstOperands,
     /*  950365 */     // GIR_Coverage, 63661,
     /*  950365 */     GIR_EraseRootFromParent_Done,
     /*  950366 */   // Label 14334: @950366
     /*  950366 */   GIM_Try, /*On fail goto*//*Label 14335*/ GIMT_Encode4(950448), // Rule ID 63662 //
     /*  950371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950398 */     // MIs[0] op1
     /*  950398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  950428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950430 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950432 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950434 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950436 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950446 */     GIR_RootConstrainSelectedInstOperands,
     /*  950447 */     // GIR_Coverage, 63662,
     /*  950447 */     GIR_EraseRootFromParent_Done,
     /*  950448 */   // Label 14335: @950448
     /*  950448 */   GIM_Try, /*On fail goto*//*Label 14336*/ GIMT_Encode4(950530), // Rule ID 63673 //
     /*  950453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  950473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950480 */     // MIs[0] op1
     /*  950480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  950510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950512 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950514 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950516 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950518 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950528 */     GIR_RootConstrainSelectedInstOperands,
     /*  950529 */     // GIR_Coverage, 63673,
     /*  950529 */     GIR_EraseRootFromParent_Done,
     /*  950530 */   // Label 14336: @950530
     /*  950530 */   GIM_Try, /*On fail goto*//*Label 14337*/ GIMT_Encode4(950612), // Rule ID 63674 //
     /*  950535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  950555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950562 */     // MIs[0] op1
     /*  950562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  950592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950594 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950596 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950598 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950600 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950610 */     GIR_RootConstrainSelectedInstOperands,
     /*  950611 */     // GIR_Coverage, 63674,
     /*  950611 */     GIR_EraseRootFromParent_Done,
     /*  950612 */   // Label 14337: @950612
     /*  950612 */   GIM_Try, /*On fail goto*//*Label 14338*/ GIMT_Encode4(950694), // Rule ID 63685 //
     /*  950617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950644 */     // MIs[0] op1
     /*  950644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  950664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950671 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  950674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950676 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950678 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950680 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950682 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950692 */     GIR_RootConstrainSelectedInstOperands,
     /*  950693 */     // GIR_Coverage, 63685,
     /*  950693 */     GIR_EraseRootFromParent_Done,
     /*  950694 */   // Label 14338: @950694
     /*  950694 */   GIM_Try, /*On fail goto*//*Label 14339*/ GIMT_Encode4(950776), // Rule ID 63686 //
     /*  950699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950726 */     // MIs[0] op1
     /*  950726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  950746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950753 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  950756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950758 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950760 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950762 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950764 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950774 */     GIR_RootConstrainSelectedInstOperands,
     /*  950775 */     // GIR_Coverage, 63686,
     /*  950775 */     GIR_EraseRootFromParent_Done,
     /*  950776 */   // Label 14339: @950776
     /*  950776 */   GIM_Try, /*On fail goto*//*Label 14340*/ GIMT_Encode4(950858), // Rule ID 63717 //
     /*  950781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950808 */     // MIs[0] op1
     /*  950808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950835 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  950838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950840 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950842 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950844 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950846 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950856 */     GIR_RootConstrainSelectedInstOperands,
     /*  950857 */     // GIR_Coverage, 63717,
     /*  950857 */     GIR_EraseRootFromParent_Done,
     /*  950858 */   // Label 14340: @950858
     /*  950858 */   GIM_Try, /*On fail goto*//*Label 14341*/ GIMT_Encode4(950940), // Rule ID 63718 //
     /*  950863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950890 */     // MIs[0] op1
     /*  950890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950917 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  950920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950922 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950924 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950926 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950928 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950938 */     GIR_RootConstrainSelectedInstOperands,
     /*  950939 */     // GIR_Coverage, 63718,
     /*  950939 */     GIR_EraseRootFromParent_Done,
     /*  950940 */   // Label 14341: @950940
     /*  950940 */   GIM_Try, /*On fail goto*//*Label 14342*/ GIMT_Encode4(951022), // Rule ID 63729 //
     /*  950945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  950965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950972 */     // MIs[0] op1
     /*  950972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950999 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  951002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951004 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951006 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951008 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951010 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951020 */     GIR_RootConstrainSelectedInstOperands,
     /*  951021 */     // GIR_Coverage, 63729,
     /*  951021 */     GIR_EraseRootFromParent_Done,
     /*  951022 */   // Label 14342: @951022
     /*  951022 */   GIM_Try, /*On fail goto*//*Label 14343*/ GIMT_Encode4(951104), // Rule ID 63730 //
     /*  951027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  951047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951054 */     // MIs[0] op1
     /*  951054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951081 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  951084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951086 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951088 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951090 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951092 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951102 */     GIR_RootConstrainSelectedInstOperands,
     /*  951103 */     // GIR_Coverage, 63730,
     /*  951103 */     GIR_EraseRootFromParent_Done,
     /*  951104 */   // Label 14343: @951104
     /*  951104 */   GIM_Try, /*On fail goto*//*Label 14344*/ GIMT_Encode4(951186), // Rule ID 63741 //
     /*  951109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951136 */     // MIs[0] op1
     /*  951136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951139 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951163 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  951166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951168 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951170 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951172 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951174 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951184 */     GIR_RootConstrainSelectedInstOperands,
     /*  951185 */     // GIR_Coverage, 63741,
     /*  951185 */     GIR_EraseRootFromParent_Done,
     /*  951186 */   // Label 14344: @951186
     /*  951186 */   GIM_Try, /*On fail goto*//*Label 14345*/ GIMT_Encode4(951268), // Rule ID 63742 //
     /*  951191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  951202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  951205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  951208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951218 */     // MIs[0] op1
     /*  951218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951245 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  951248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951250 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951252 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951254 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951256 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951266 */     GIR_RootConstrainSelectedInstOperands,
     /*  951267 */     // GIR_Coverage, 63742,
     /*  951267 */     GIR_EraseRootFromParent_Done,
     /*  951268 */   // Label 14345: @951268
     /*  951268 */   GIM_Try, /*On fail goto*//*Label 14346*/ GIMT_Encode4(951350), // Rule ID 63773 //
     /*  951273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951300 */     // MIs[0] op1
     /*  951300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951327 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  951330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951332 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951334 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951336 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951338 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951348 */     GIR_RootConstrainSelectedInstOperands,
     /*  951349 */     // GIR_Coverage, 63773,
     /*  951349 */     GIR_EraseRootFromParent_Done,
     /*  951350 */   // Label 14346: @951350
     /*  951350 */   GIM_Try, /*On fail goto*//*Label 14347*/ GIMT_Encode4(951432), // Rule ID 63774 //
     /*  951355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951382 */     // MIs[0] op1
     /*  951382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951409 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  951412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951414 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951416 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951418 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951420 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951430 */     GIR_RootConstrainSelectedInstOperands,
     /*  951431 */     // GIR_Coverage, 63774,
     /*  951431 */     GIR_EraseRootFromParent_Done,
     /*  951432 */   // Label 14347: @951432
     /*  951432 */   GIM_Try, /*On fail goto*//*Label 14348*/ GIMT_Encode4(951514), // Rule ID 63785 //
     /*  951437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  951457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951464 */     // MIs[0] op1
     /*  951464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951491 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  951494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951496 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951498 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951500 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951502 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951512 */     GIR_RootConstrainSelectedInstOperands,
     /*  951513 */     // GIR_Coverage, 63785,
     /*  951513 */     GIR_EraseRootFromParent_Done,
     /*  951514 */   // Label 14348: @951514
     /*  951514 */   GIM_Try, /*On fail goto*//*Label 14349*/ GIMT_Encode4(951596), // Rule ID 63786 //
     /*  951519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  951539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951546 */     // MIs[0] op1
     /*  951546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951573 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  951576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951578 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951580 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951582 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951584 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951594 */     GIR_RootConstrainSelectedInstOperands,
     /*  951595 */     // GIR_Coverage, 63786,
     /*  951595 */     GIR_EraseRootFromParent_Done,
     /*  951596 */   // Label 14349: @951596
     /*  951596 */   GIM_Try, /*On fail goto*//*Label 14350*/ GIMT_Encode4(951678), // Rule ID 63797 //
     /*  951601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951628 */     // MIs[0] op1
     /*  951628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951655 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  951658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951660 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951662 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951664 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951666 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951676 */     GIR_RootConstrainSelectedInstOperands,
     /*  951677 */     // GIR_Coverage, 63797,
     /*  951677 */     GIR_EraseRootFromParent_Done,
     /*  951678 */   // Label 14350: @951678
     /*  951678 */   GIM_Try, /*On fail goto*//*Label 14351*/ GIMT_Encode4(951760), // Rule ID 63798 //
     /*  951683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951710 */     // MIs[0] op1
     /*  951710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951737 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  951740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951742 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951744 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951746 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951748 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951758 */     GIR_RootConstrainSelectedInstOperands,
     /*  951759 */     // GIR_Coverage, 63798,
     /*  951759 */     GIR_EraseRootFromParent_Done,
     /*  951760 */   // Label 14351: @951760
     /*  951760 */   GIM_Try, /*On fail goto*//*Label 14352*/ GIMT_Encode4(951842), // Rule ID 63829 //
     /*  951765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951792 */     // MIs[0] op1
     /*  951792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951819 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  951822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951824 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951826 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951828 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951830 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951840 */     GIR_RootConstrainSelectedInstOperands,
     /*  951841 */     // GIR_Coverage, 63829,
     /*  951841 */     GIR_EraseRootFromParent_Done,
     /*  951842 */   // Label 14352: @951842
     /*  951842 */   GIM_Try, /*On fail goto*//*Label 14353*/ GIMT_Encode4(951924), // Rule ID 63830 //
     /*  951847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951874 */     // MIs[0] op1
     /*  951874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951901 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  951904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951906 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951908 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951910 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951912 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951922 */     GIR_RootConstrainSelectedInstOperands,
     /*  951923 */     // GIR_Coverage, 63830,
     /*  951923 */     GIR_EraseRootFromParent_Done,
     /*  951924 */   // Label 14353: @951924
     /*  951924 */   GIM_Try, /*On fail goto*//*Label 14354*/ GIMT_Encode4(952006), // Rule ID 63841 //
     /*  951929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  951949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951956 */     // MIs[0] op1
     /*  951956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  951986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951988 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951990 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951992 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951994 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952004 */     GIR_RootConstrainSelectedInstOperands,
     /*  952005 */     // GIR_Coverage, 63841,
     /*  952005 */     GIR_EraseRootFromParent_Done,
     /*  952006 */   // Label 14354: @952006
     /*  952006 */   GIM_Try, /*On fail goto*//*Label 14355*/ GIMT_Encode4(952088), // Rule ID 63842 //
     /*  952011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  952031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952038 */     // MIs[0] op1
     /*  952038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952041 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952065 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  952068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952070 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952072 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952074 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952076 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952086 */     GIR_RootConstrainSelectedInstOperands,
     /*  952087 */     // GIR_Coverage, 63842,
     /*  952087 */     GIR_EraseRootFromParent_Done,
     /*  952088 */   // Label 14355: @952088
     /*  952088 */   GIM_Try, /*On fail goto*//*Label 14356*/ GIMT_Encode4(952170), // Rule ID 63853 //
     /*  952093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952120 */     // MIs[0] op1
     /*  952120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952147 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  952150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952152 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952154 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952156 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952158 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952168 */     GIR_RootConstrainSelectedInstOperands,
     /*  952169 */     // GIR_Coverage, 63853,
     /*  952169 */     GIR_EraseRootFromParent_Done,
     /*  952170 */   // Label 14356: @952170
     /*  952170 */   GIM_Try, /*On fail goto*//*Label 14357*/ GIMT_Encode4(952252), // Rule ID 63854 //
     /*  952175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  952186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  952189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  952192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952202 */     // MIs[0] op1
     /*  952202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  952218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952229 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  952232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952234 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952236 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952238 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952240 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952250 */     GIR_RootConstrainSelectedInstOperands,
     /*  952251 */     // GIR_Coverage, 63854,
     /*  952251 */     GIR_EraseRootFromParent_Done,
     /*  952252 */   // Label 14357: @952252
     /*  952252 */   GIM_Try, /*On fail goto*//*Label 14358*/ GIMT_Encode4(952334), // Rule ID 63885 //
     /*  952257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952284 */     // MIs[0] op1
     /*  952284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  952314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952316 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952318 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952320 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952322 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952332 */     GIR_RootConstrainSelectedInstOperands,
     /*  952333 */     // GIR_Coverage, 63885,
     /*  952333 */     GIR_EraseRootFromParent_Done,
     /*  952334 */   // Label 14358: @952334
     /*  952334 */   GIM_Try, /*On fail goto*//*Label 14359*/ GIMT_Encode4(952416), // Rule ID 63886 //
     /*  952339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952366 */     // MIs[0] op1
     /*  952366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  952396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952398 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952400 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952402 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952404 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952414 */     GIR_RootConstrainSelectedInstOperands,
     /*  952415 */     // GIR_Coverage, 63886,
     /*  952415 */     GIR_EraseRootFromParent_Done,
     /*  952416 */   // Label 14359: @952416
     /*  952416 */   GIM_Try, /*On fail goto*//*Label 14360*/ GIMT_Encode4(952498), // Rule ID 63897 //
     /*  952421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  952441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952448 */     // MIs[0] op1
     /*  952448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952475 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  952478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952480 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952482 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952484 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952486 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952496 */     GIR_RootConstrainSelectedInstOperands,
     /*  952497 */     // GIR_Coverage, 63897,
     /*  952497 */     GIR_EraseRootFromParent_Done,
     /*  952498 */   // Label 14360: @952498
     /*  952498 */   GIM_Try, /*On fail goto*//*Label 14361*/ GIMT_Encode4(952580), // Rule ID 63898 //
     /*  952503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  952523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952530 */     // MIs[0] op1
     /*  952530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952533 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952557 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  952560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952562 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952564 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952566 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952568 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952578 */     GIR_RootConstrainSelectedInstOperands,
     /*  952579 */     // GIR_Coverage, 63898,
     /*  952579 */     GIR_EraseRootFromParent_Done,
     /*  952580 */   // Label 14361: @952580
     /*  952580 */   GIM_Try, /*On fail goto*//*Label 14362*/ GIMT_Encode4(952662), // Rule ID 63909 //
     /*  952585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952612 */     // MIs[0] op1
     /*  952612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952639 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  952642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952650 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952660 */     GIR_RootConstrainSelectedInstOperands,
     /*  952661 */     // GIR_Coverage, 63909,
     /*  952661 */     GIR_EraseRootFromParent_Done,
     /*  952662 */   // Label 14362: @952662
     /*  952662 */   GIM_Try, /*On fail goto*//*Label 14363*/ GIMT_Encode4(952744), // Rule ID 63910 //
     /*  952667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952694 */     // MIs[0] op1
     /*  952694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952721 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  952724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952726 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952728 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952730 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952732 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952742 */     GIR_RootConstrainSelectedInstOperands,
     /*  952743 */     // GIR_Coverage, 63910,
     /*  952743 */     GIR_EraseRootFromParent_Done,
     /*  952744 */   // Label 14363: @952744
     /*  952744 */   GIM_Try, /*On fail goto*//*Label 14364*/ GIMT_Encode4(952826), // Rule ID 63941 //
     /*  952749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952776 */     // MIs[0] op1
     /*  952776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952803 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  952806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952808 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952810 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952812 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952814 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952824 */     GIR_RootConstrainSelectedInstOperands,
     /*  952825 */     // GIR_Coverage, 63941,
     /*  952825 */     GIR_EraseRootFromParent_Done,
     /*  952826 */   // Label 14364: @952826
     /*  952826 */   GIM_Try, /*On fail goto*//*Label 14365*/ GIMT_Encode4(952908), // Rule ID 63942 //
     /*  952831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952858 */     // MIs[0] op1
     /*  952858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952885 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11085:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  952888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952890 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952892 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952894 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952896 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952906 */     GIR_RootConstrainSelectedInstOperands,
     /*  952907 */     // GIR_Coverage, 63942,
     /*  952907 */     GIR_EraseRootFromParent_Done,
     /*  952908 */   // Label 14365: @952908
     /*  952908 */   GIM_Try, /*On fail goto*//*Label 14366*/ GIMT_Encode4(952990), // Rule ID 63953 //
     /*  952913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  952933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952940 */     // MIs[0] op1
     /*  952940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952967 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  952970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952972 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952974 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952976 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952978 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952988 */     GIR_RootConstrainSelectedInstOperands,
     /*  952989 */     // GIR_Coverage, 63953,
     /*  952989 */     GIR_EraseRootFromParent_Done,
     /*  952990 */   // Label 14366: @952990
     /*  952990 */   GIM_Try, /*On fail goto*//*Label 14367*/ GIMT_Encode4(953072), // Rule ID 63954 //
     /*  952995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  953003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  953015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953022 */     // MIs[0] op1
     /*  953022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953025 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953049 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11077:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  953052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953054 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953056 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953058 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953060 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953070 */     GIR_RootConstrainSelectedInstOperands,
     /*  953071 */     // GIR_Coverage, 63954,
     /*  953071 */     GIR_EraseRootFromParent_Done,
     /*  953072 */   // Label 14367: @953072
     /*  953072 */   GIM_Try, /*On fail goto*//*Label 14368*/ GIMT_Encode4(953154), // Rule ID 63965 //
     /*  953077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953104 */     // MIs[0] op1
     /*  953104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953131 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11063:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  953131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  953134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953136 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953138 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953140 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953142 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953152 */     GIR_RootConstrainSelectedInstOperands,
     /*  953153 */     // GIR_Coverage, 63965,
     /*  953153 */     GIR_EraseRootFromParent_Done,
     /*  953154 */   // Label 14368: @953154
     /*  953154 */   GIM_Try, /*On fail goto*//*Label 14369*/ GIMT_Encode4(953236), // Rule ID 63966 //
     /*  953159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  953167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  953170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  953173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  953176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953186 */     // MIs[0] op1
     /*  953186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  953194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  953202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  953206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953213 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11063:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  953213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  953216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953218 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953220 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953222 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953224 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  953234 */     GIR_RootConstrainSelectedInstOperands,
     /*  953235 */     // GIR_Coverage, 63966,
     /*  953235 */     GIR_EraseRootFromParent_Done,
     /*  953236 */   // Label 14369: @953236
     /*  953236 */   GIM_Try, /*On fail goto*//*Label 14370*/ GIMT_Encode4(953318), // Rule ID 63971 //
     /*  953241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953268 */     // MIs[0] op1
     /*  953268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953295 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  953298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953300 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953302 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953304 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953306 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953316 */     GIR_RootConstrainSelectedInstOperands,
     /*  953317 */     // GIR_Coverage, 63971,
     /*  953317 */     GIR_EraseRootFromParent_Done,
     /*  953318 */   // Label 14370: @953318
     /*  953318 */   GIM_Try, /*On fail goto*//*Label 14371*/ GIMT_Encode4(953400), // Rule ID 63972 //
     /*  953323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953350 */     // MIs[0] op1
     /*  953350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953377 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  953380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953382 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953384 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953386 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953388 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953398 */     GIR_RootConstrainSelectedInstOperands,
     /*  953399 */     // GIR_Coverage, 63972,
     /*  953399 */     GIR_EraseRootFromParent_Done,
     /*  953400 */   // Label 14371: @953400
     /*  953400 */   GIM_Try, /*On fail goto*//*Label 14372*/ GIMT_Encode4(953482), // Rule ID 63983 //
     /*  953405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  953425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953432 */     // MIs[0] op1
     /*  953432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953459 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  953462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953464 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953466 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953468 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953470 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953480 */     GIR_RootConstrainSelectedInstOperands,
     /*  953481 */     // GIR_Coverage, 63983,
     /*  953481 */     GIR_EraseRootFromParent_Done,
     /*  953482 */   // Label 14372: @953482
     /*  953482 */   GIM_Try, /*On fail goto*//*Label 14373*/ GIMT_Encode4(953564), // Rule ID 63984 //
     /*  953487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  953498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  953501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  953504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  953507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953514 */     // MIs[0] op1
     /*  953514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953541 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  953544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953546 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953548 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953550 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953552 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953562 */     GIR_RootConstrainSelectedInstOperands,
     /*  953563 */     // GIR_Coverage, 63984,
     /*  953563 */     GIR_EraseRootFromParent_Done,
     /*  953564 */   // Label 14373: @953564
     /*  953564 */   GIM_Try, /*On fail goto*//*Label 14374*/ GIMT_Encode4(953646), // Rule ID 63989 //
     /*  953569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953596 */     // MIs[0] op1
     /*  953596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953623 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  953626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953628 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953630 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953632 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953634 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953644 */     GIR_RootConstrainSelectedInstOperands,
     /*  953645 */     // GIR_Coverage, 63989,
     /*  953645 */     GIR_EraseRootFromParent_Done,
     /*  953646 */   // Label 14374: @953646
     /*  953646 */   GIM_Try, /*On fail goto*//*Label 14375*/ GIMT_Encode4(953728), // Rule ID 63990 //
     /*  953651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953678 */     // MIs[0] op1
     /*  953678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953705 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  953708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953710 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953712 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953714 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953716 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953726 */     GIR_RootConstrainSelectedInstOperands,
     /*  953727 */     // GIR_Coverage, 63990,
     /*  953727 */     GIR_EraseRootFromParent_Done,
     /*  953728 */   // Label 14375: @953728
     /*  953728 */   GIM_Try, /*On fail goto*//*Label 14376*/ GIMT_Encode4(953810), // Rule ID 64001 //
     /*  953733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  953753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953760 */     // MIs[0] op1
     /*  953760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953787 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  953790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953792 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953794 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953796 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953798 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953808 */     GIR_RootConstrainSelectedInstOperands,
     /*  953809 */     // GIR_Coverage, 64001,
     /*  953809 */     GIR_EraseRootFromParent_Done,
     /*  953810 */   // Label 14376: @953810
     /*  953810 */   GIM_Try, /*On fail goto*//*Label 14377*/ GIMT_Encode4(953892), // Rule ID 64002 //
     /*  953815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  953835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953842 */     // MIs[0] op1
     /*  953842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953869 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  953872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953874 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953876 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953878 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953880 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953890 */     GIR_RootConstrainSelectedInstOperands,
     /*  953891 */     // GIR_Coverage, 64002,
     /*  953891 */     GIR_EraseRootFromParent_Done,
     /*  953892 */   // Label 14377: @953892
     /*  953892 */   GIM_Try, /*On fail goto*//*Label 14378*/ GIMT_Encode4(953974), // Rule ID 64007 //
     /*  953897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  953908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  953911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  953914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953924 */     // MIs[0] op1
     /*  953924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953951 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  953954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953956 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953958 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953960 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953962 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953972 */     GIR_RootConstrainSelectedInstOperands,
     /*  953973 */     // GIR_Coverage, 64007,
     /*  953973 */     GIR_EraseRootFromParent_Done,
     /*  953974 */   // Label 14378: @953974
     /*  953974 */   GIM_Try, /*On fail goto*//*Label 14379*/ GIMT_Encode4(954056), // Rule ID 64008 //
     /*  953979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  953990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  953993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  953996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954006 */     // MIs[0] op1
     /*  954006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954033 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  954036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954038 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954040 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954042 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954044 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954054 */     GIR_RootConstrainSelectedInstOperands,
     /*  954055 */     // GIR_Coverage, 64008,
     /*  954055 */     GIR_EraseRootFromParent_Done,
     /*  954056 */   // Label 14379: @954056
     /*  954056 */   GIM_Try, /*On fail goto*//*Label 14380*/ GIMT_Encode4(954138), // Rule ID 64019 //
     /*  954061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  954081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954088 */     // MIs[0] op1
     /*  954088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954115 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  954118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954120 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954122 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954124 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954126 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954136 */     GIR_RootConstrainSelectedInstOperands,
     /*  954137 */     // GIR_Coverage, 64019,
     /*  954137 */     GIR_EraseRootFromParent_Done,
     /*  954138 */   // Label 14380: @954138
     /*  954138 */   GIM_Try, /*On fail goto*//*Label 14381*/ GIMT_Encode4(954220), // Rule ID 64020 //
     /*  954143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  954154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  954157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  954160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  954163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954170 */     // MIs[0] op1
     /*  954170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954173 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954197 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  954200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954202 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954204 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954206 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954208 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954218 */     GIR_RootConstrainSelectedInstOperands,
     /*  954219 */     // GIR_Coverage, 64020,
     /*  954219 */     GIR_EraseRootFromParent_Done,
     /*  954220 */   // Label 14381: @954220
     /*  954220 */   GIM_Try, /*On fail goto*//*Label 14382*/ GIMT_Encode4(954302), // Rule ID 64025 //
     /*  954225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954252 */     // MIs[0] op1
     /*  954252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954279 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  954282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954284 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954286 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954288 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954290 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954300 */     GIR_RootConstrainSelectedInstOperands,
     /*  954301 */     // GIR_Coverage, 64025,
     /*  954301 */     GIR_EraseRootFromParent_Done,
     /*  954302 */   // Label 14382: @954302
     /*  954302 */   GIM_Try, /*On fail goto*//*Label 14383*/ GIMT_Encode4(954384), // Rule ID 64026 //
     /*  954307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954334 */     // MIs[0] op1
     /*  954334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954361 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  954364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954366 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954368 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954370 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954372 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954382 */     GIR_RootConstrainSelectedInstOperands,
     /*  954383 */     // GIR_Coverage, 64026,
     /*  954383 */     GIR_EraseRootFromParent_Done,
     /*  954384 */   // Label 14383: @954384
     /*  954384 */   GIM_Try, /*On fail goto*//*Label 14384*/ GIMT_Encode4(954466), // Rule ID 64037 //
     /*  954389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  954409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954416 */     // MIs[0] op1
     /*  954416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954443 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  954446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954448 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954450 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954452 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954454 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954464 */     GIR_RootConstrainSelectedInstOperands,
     /*  954465 */     // GIR_Coverage, 64037,
     /*  954465 */     GIR_EraseRootFromParent_Done,
     /*  954466 */   // Label 14384: @954466
     /*  954466 */   GIM_Try, /*On fail goto*//*Label 14385*/ GIMT_Encode4(954548), // Rule ID 64038 //
     /*  954471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  954482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  954485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  954488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  954491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954498 */     // MIs[0] op1
     /*  954498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  954528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954530 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954532 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954534 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954536 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954546 */     GIR_RootConstrainSelectedInstOperands,
     /*  954547 */     // GIR_Coverage, 64038,
     /*  954547 */     GIR_EraseRootFromParent_Done,
     /*  954548 */   // Label 14385: @954548
     /*  954548 */   GIM_Try, /*On fail goto*//*Label 14386*/ GIMT_Encode4(954630), // Rule ID 64043 //
     /*  954553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954580 */     // MIs[0] op1
     /*  954580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954607 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  954610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954612 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954614 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954616 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954618 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954628 */     GIR_RootConstrainSelectedInstOperands,
     /*  954629 */     // GIR_Coverage, 64043,
     /*  954629 */     GIR_EraseRootFromParent_Done,
     /*  954630 */   // Label 14386: @954630
     /*  954630 */   GIM_Try, /*On fail goto*//*Label 14387*/ GIMT_Encode4(954712), // Rule ID 64044 //
     /*  954635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954662 */     // MIs[0] op1
     /*  954662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954689 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  954692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954694 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954696 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954698 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954700 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954710 */     GIR_RootConstrainSelectedInstOperands,
     /*  954711 */     // GIR_Coverage, 64044,
     /*  954711 */     GIR_EraseRootFromParent_Done,
     /*  954712 */   // Label 14387: @954712
     /*  954712 */   GIM_Try, /*On fail goto*//*Label 14388*/ GIMT_Encode4(954794), // Rule ID 64055 //
     /*  954717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  954737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954744 */     // MIs[0] op1
     /*  954744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  954774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954776 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954778 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954780 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954782 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954792 */     GIR_RootConstrainSelectedInstOperands,
     /*  954793 */     // GIR_Coverage, 64055,
     /*  954793 */     GIR_EraseRootFromParent_Done,
     /*  954794 */   // Label 14388: @954794
     /*  954794 */   GIM_Try, /*On fail goto*//*Label 14389*/ GIMT_Encode4(954876), // Rule ID 64056 //
     /*  954799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  954819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954826 */     // MIs[0] op1
     /*  954826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954829 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954853 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  954856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954858 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954860 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954862 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954864 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954874 */     GIR_RootConstrainSelectedInstOperands,
     /*  954875 */     // GIR_Coverage, 64056,
     /*  954875 */     GIR_EraseRootFromParent_Done,
     /*  954876 */   // Label 14389: @954876
     /*  954876 */   GIM_Try, /*On fail goto*//*Label 14390*/ GIMT_Encode4(954958), // Rule ID 64061 //
     /*  954881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  954898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954908 */     // MIs[0] op1
     /*  954908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954935 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  954938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954940 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954942 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954944 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954946 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954956 */     GIR_RootConstrainSelectedInstOperands,
     /*  954957 */     // GIR_Coverage, 64061,
     /*  954957 */     GIR_EraseRootFromParent_Done,
     /*  954958 */   // Label 14390: @954958
     /*  954958 */   GIM_Try, /*On fail goto*//*Label 14391*/ GIMT_Encode4(955040), // Rule ID 64062 //
     /*  954963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  954980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954990 */     // MIs[0] op1
     /*  954990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955017 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  955020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955022 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955024 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955026 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955028 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955038 */     GIR_RootConstrainSelectedInstOperands,
     /*  955039 */     // GIR_Coverage, 64062,
     /*  955039 */     GIR_EraseRootFromParent_Done,
     /*  955040 */   // Label 14391: @955040
     /*  955040 */   GIM_Try, /*On fail goto*//*Label 14392*/ GIMT_Encode4(955122), // Rule ID 64073 //
     /*  955045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  955065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955072 */     // MIs[0] op1
     /*  955072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955099 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  955099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  955102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955104 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955106 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955108 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955110 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955120 */     GIR_RootConstrainSelectedInstOperands,
     /*  955121 */     // GIR_Coverage, 64073,
     /*  955121 */     GIR_EraseRootFromParent_Done,
     /*  955122 */   // Label 14392: @955122
     /*  955122 */   GIM_Try, /*On fail goto*//*Label 14393*/ GIMT_Encode4(955204), // Rule ID 64074 //
     /*  955127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  955138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  955141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  955144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  955147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955154 */     // MIs[0] op1
     /*  955154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  955166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  955174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955181 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  955181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  955184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955186 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955188 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955190 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955192 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  955202 */     GIR_RootConstrainSelectedInstOperands,
     /*  955203 */     // GIR_Coverage, 64074,
     /*  955203 */     GIR_EraseRootFromParent_Done,
     /*  955204 */   // Label 14393: @955204
     /*  955204 */   GIM_Try, /*On fail goto*//*Label 14394*/ GIMT_Encode4(955286), // Rule ID 64079 //
     /*  955209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955236 */     // MIs[0] op1
     /*  955236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955263 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  955266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955268 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955270 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955272 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955274 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955284 */     GIR_RootConstrainSelectedInstOperands,
     /*  955285 */     // GIR_Coverage, 64079,
     /*  955285 */     GIR_EraseRootFromParent_Done,
     /*  955286 */   // Label 14394: @955286
     /*  955286 */   GIM_Try, /*On fail goto*//*Label 14395*/ GIMT_Encode4(955368), // Rule ID 64080 //
     /*  955291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955318 */     // MIs[0] op1
     /*  955318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955345 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  955348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955350 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955352 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955354 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955356 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955366 */     GIR_RootConstrainSelectedInstOperands,
     /*  955367 */     // GIR_Coverage, 64080,
     /*  955367 */     GIR_EraseRootFromParent_Done,
     /*  955368 */   // Label 14395: @955368
     /*  955368 */   GIM_Try, /*On fail goto*//*Label 14396*/ GIMT_Encode4(955450), // Rule ID 64091 //
     /*  955373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  955393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955400 */     // MIs[0] op1
     /*  955400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955427 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  955430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955432 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955434 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955436 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955438 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955448 */     GIR_RootConstrainSelectedInstOperands,
     /*  955449 */     // GIR_Coverage, 64091,
     /*  955449 */     GIR_EraseRootFromParent_Done,
     /*  955450 */   // Label 14396: @955450
     /*  955450 */   GIM_Try, /*On fail goto*//*Label 14397*/ GIMT_Encode4(955532), // Rule ID 64092 //
     /*  955455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  955475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955482 */     // MIs[0] op1
     /*  955482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955509 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  955512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955514 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955516 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955518 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955520 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955530 */     GIR_RootConstrainSelectedInstOperands,
     /*  955531 */     // GIR_Coverage, 64092,
     /*  955531 */     GIR_EraseRootFromParent_Done,
     /*  955532 */   // Label 14397: @955532
     /*  955532 */   GIM_Try, /*On fail goto*//*Label 14398*/ GIMT_Encode4(955614), // Rule ID 64097 //
     /*  955537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  955545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  955557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955564 */     // MIs[0] op1
     /*  955564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  955584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955591 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  955594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955596 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955598 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955600 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955602 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955612 */     GIR_RootConstrainSelectedInstOperands,
     /*  955613 */     // GIR_Coverage, 64097,
     /*  955613 */     GIR_EraseRootFromParent_Done,
     /*  955614 */   // Label 14398: @955614
     /*  955614 */   GIM_Try, /*On fail goto*//*Label 14399*/ GIMT_Encode4(955696), // Rule ID 64098 //
     /*  955619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  955627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  955639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955646 */     // MIs[0] op1
     /*  955646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955649 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  955666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955673 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  955676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955678 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955680 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955682 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955684 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955694 */     GIR_RootConstrainSelectedInstOperands,
     /*  955695 */     // GIR_Coverage, 64098,
     /*  955695 */     GIR_EraseRootFromParent_Done,
     /*  955696 */   // Label 14399: @955696
     /*  955696 */   GIM_Try, /*On fail goto*//*Label 14400*/ GIMT_Encode4(955778), // Rule ID 64103 //
     /*  955701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955728 */     // MIs[0] op1
     /*  955728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955755 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  955758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955760 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955762 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955764 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955766 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955776 */     GIR_RootConstrainSelectedInstOperands,
     /*  955777 */     // GIR_Coverage, 64103,
     /*  955777 */     GIR_EraseRootFromParent_Done,
     /*  955778 */   // Label 14400: @955778
     /*  955778 */   GIM_Try, /*On fail goto*//*Label 14401*/ GIMT_Encode4(955860), // Rule ID 64104 //
     /*  955783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955810 */     // MIs[0] op1
     /*  955810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955837 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  955840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955842 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955844 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955846 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955848 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955858 */     GIR_RootConstrainSelectedInstOperands,
     /*  955859 */     // GIR_Coverage, 64104,
     /*  955859 */     GIR_EraseRootFromParent_Done,
     /*  955860 */   // Label 14401: @955860
     /*  955860 */   GIM_Try, /*On fail goto*//*Label 14402*/ GIMT_Encode4(955942), // Rule ID 64115 //
     /*  955865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  955885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955892 */     // MIs[0] op1
     /*  955892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955919 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  955922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955924 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955926 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955928 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955930 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955940 */     GIR_RootConstrainSelectedInstOperands,
     /*  955941 */     // GIR_Coverage, 64115,
     /*  955941 */     GIR_EraseRootFromParent_Done,
     /*  955942 */   // Label 14402: @955942
     /*  955942 */   GIM_Try, /*On fail goto*//*Label 14403*/ GIMT_Encode4(956024), // Rule ID 64116 //
     /*  955947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  955967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955974 */     // MIs[0] op1
     /*  955974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956001 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  956004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956006 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956008 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956010 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956012 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956022 */     GIR_RootConstrainSelectedInstOperands,
     /*  956023 */     // GIR_Coverage, 64116,
     /*  956023 */     GIR_EraseRootFromParent_Done,
     /*  956024 */   // Label 14403: @956024
     /*  956024 */   GIM_Try, /*On fail goto*//*Label 14404*/ GIMT_Encode4(956106), // Rule ID 64121 //
     /*  956029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956056 */     // MIs[0] op1
     /*  956056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956083 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  956086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956088 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956090 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956092 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956094 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956104 */     GIR_RootConstrainSelectedInstOperands,
     /*  956105 */     // GIR_Coverage, 64121,
     /*  956105 */     GIR_EraseRootFromParent_Done,
     /*  956106 */   // Label 14404: @956106
     /*  956106 */   GIM_Try, /*On fail goto*//*Label 14405*/ GIMT_Encode4(956188), // Rule ID 64122 //
     /*  956111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  956122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  956125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  956128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956138 */     // MIs[0] op1
     /*  956138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956165 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  956168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956170 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956172 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956174 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956176 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956186 */     GIR_RootConstrainSelectedInstOperands,
     /*  956187 */     // GIR_Coverage, 64122,
     /*  956187 */     GIR_EraseRootFromParent_Done,
     /*  956188 */   // Label 14405: @956188
     /*  956188 */   GIM_Try, /*On fail goto*//*Label 14406*/ GIMT_Encode4(956270), // Rule ID 64127 //
     /*  956193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956220 */     // MIs[0] op1
     /*  956220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956247 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  956250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956252 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956254 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956256 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956258 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956268 */     GIR_RootConstrainSelectedInstOperands,
     /*  956269 */     // GIR_Coverage, 64127,
     /*  956269 */     GIR_EraseRootFromParent_Done,
     /*  956270 */   // Label 14406: @956270
     /*  956270 */   GIM_Try, /*On fail goto*//*Label 14407*/ GIMT_Encode4(956352), // Rule ID 64128 //
     /*  956275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956302 */     // MIs[0] op1
     /*  956302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  956332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956334 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956336 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956338 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956340 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956350 */     GIR_RootConstrainSelectedInstOperands,
     /*  956351 */     // GIR_Coverage, 64128,
     /*  956351 */     GIR_EraseRootFromParent_Done,
     /*  956352 */   // Label 14407: @956352
     /*  956352 */   GIM_Try, /*On fail goto*//*Label 14408*/ GIMT_Encode4(956434), // Rule ID 64139 //
     /*  956357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  956377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956384 */     // MIs[0] op1
     /*  956384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956411 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  956414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956416 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956418 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956420 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956422 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956432 */     GIR_RootConstrainSelectedInstOperands,
     /*  956433 */     // GIR_Coverage, 64139,
     /*  956433 */     GIR_EraseRootFromParent_Done,
     /*  956434 */   // Label 14408: @956434
     /*  956434 */   GIM_Try, /*On fail goto*//*Label 14409*/ GIMT_Encode4(956516), // Rule ID 64140 //
     /*  956439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  956459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956466 */     // MIs[0] op1
     /*  956466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956469 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  956496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956498 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956500 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956502 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956504 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956514 */     GIR_RootConstrainSelectedInstOperands,
     /*  956515 */     // GIR_Coverage, 64140,
     /*  956515 */     GIR_EraseRootFromParent_Done,
     /*  956516 */   // Label 14409: @956516
     /*  956516 */   GIM_Try, /*On fail goto*//*Label 14410*/ GIMT_Encode4(956598), // Rule ID 64145 //
     /*  956521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956548 */     // MIs[0] op1
     /*  956548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956575 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  956578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956580 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956582 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956584 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956586 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956596 */     GIR_RootConstrainSelectedInstOperands,
     /*  956597 */     // GIR_Coverage, 64145,
     /*  956597 */     GIR_EraseRootFromParent_Done,
     /*  956598 */   // Label 14410: @956598
     /*  956598 */   GIM_Try, /*On fail goto*//*Label 14411*/ GIMT_Encode4(956680), // Rule ID 64146 //
     /*  956603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956630 */     // MIs[0] op1
     /*  956630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956633 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  956660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956662 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956664 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956666 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956668 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956678 */     GIR_RootConstrainSelectedInstOperands,
     /*  956679 */     // GIR_Coverage, 64146,
     /*  956679 */     GIR_EraseRootFromParent_Done,
     /*  956680 */   // Label 14411: @956680
     /*  956680 */   GIM_Try, /*On fail goto*//*Label 14412*/ GIMT_Encode4(956762), // Rule ID 64151 //
     /*  956685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956712 */     // MIs[0] op1
     /*  956712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956739 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  956742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956744 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956746 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956748 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956750 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956760 */     GIR_RootConstrainSelectedInstOperands,
     /*  956761 */     // GIR_Coverage, 64151,
     /*  956761 */     GIR_EraseRootFromParent_Done,
     /*  956762 */   // Label 14412: @956762
     /*  956762 */   GIM_Try, /*On fail goto*//*Label 14413*/ GIMT_Encode4(956844), // Rule ID 64152 //
     /*  956767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956794 */     // MIs[0] op1
     /*  956794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956821 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  956824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956826 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956828 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956830 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956832 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956842 */     GIR_RootConstrainSelectedInstOperands,
     /*  956843 */     // GIR_Coverage, 64152,
     /*  956843 */     GIR_EraseRootFromParent_Done,
     /*  956844 */   // Label 14413: @956844
     /*  956844 */   GIM_Try, /*On fail goto*//*Label 14414*/ GIMT_Encode4(956926), // Rule ID 64163 //
     /*  956849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  956869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956876 */     // MIs[0] op1
     /*  956876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956879 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956903 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  956906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956908 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956910 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956912 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956914 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956924 */     GIR_RootConstrainSelectedInstOperands,
     /*  956925 */     // GIR_Coverage, 64163,
     /*  956925 */     GIR_EraseRootFromParent_Done,
     /*  956926 */   // Label 14414: @956926
     /*  956926 */   GIM_Try, /*On fail goto*//*Label 14415*/ GIMT_Encode4(957008), // Rule ID 64164 //
     /*  956931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  956951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956958 */     // MIs[0] op1
     /*  956958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956985 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  956988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956990 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956992 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956994 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956996 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957006 */     GIR_RootConstrainSelectedInstOperands,
     /*  957007 */     // GIR_Coverage, 64164,
     /*  957007 */     GIR_EraseRootFromParent_Done,
     /*  957008 */   // Label 14415: @957008
     /*  957008 */   GIM_Try, /*On fail goto*//*Label 14416*/ GIMT_Encode4(957090), // Rule ID 64169 //
     /*  957013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957040 */     // MIs[0] op1
     /*  957040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957067 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  957070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957072 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957074 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957076 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957078 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957088 */     GIR_RootConstrainSelectedInstOperands,
     /*  957089 */     // GIR_Coverage, 64169,
     /*  957089 */     GIR_EraseRootFromParent_Done,
     /*  957090 */   // Label 14416: @957090
     /*  957090 */   GIM_Try, /*On fail goto*//*Label 14417*/ GIMT_Encode4(957172), // Rule ID 64170 //
     /*  957095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  957106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  957109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  957112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957122 */     // MIs[0] op1
     /*  957122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957149 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  957152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957154 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957156 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957158 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957160 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957170 */     GIR_RootConstrainSelectedInstOperands,
     /*  957171 */     // GIR_Coverage, 64170,
     /*  957171 */     GIR_EraseRootFromParent_Done,
     /*  957172 */   // Label 14417: @957172
     /*  957172 */   GIM_Try, /*On fail goto*//*Label 14418*/ GIMT_Encode4(957254), // Rule ID 64175 //
     /*  957177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957204 */     // MIs[0] op1
     /*  957204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957231 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  957234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957236 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957238 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957240 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957242 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957252 */     GIR_RootConstrainSelectedInstOperands,
     /*  957253 */     // GIR_Coverage, 64175,
     /*  957253 */     GIR_EraseRootFromParent_Done,
     /*  957254 */   // Label 14418: @957254
     /*  957254 */   GIM_Try, /*On fail goto*//*Label 14419*/ GIMT_Encode4(957336), // Rule ID 64176 //
     /*  957259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957286 */     // MIs[0] op1
     /*  957286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957313 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  957316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957318 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957320 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957322 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957324 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957334 */     GIR_RootConstrainSelectedInstOperands,
     /*  957335 */     // GIR_Coverage, 64176,
     /*  957335 */     GIR_EraseRootFromParent_Done,
     /*  957336 */   // Label 14419: @957336
     /*  957336 */   GIM_Try, /*On fail goto*//*Label 14420*/ GIMT_Encode4(957418), // Rule ID 64187 //
     /*  957341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  957361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957368 */     // MIs[0] op1
     /*  957368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957395 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  957398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957400 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957402 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957404 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957406 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957416 */     GIR_RootConstrainSelectedInstOperands,
     /*  957417 */     // GIR_Coverage, 64187,
     /*  957417 */     GIR_EraseRootFromParent_Done,
     /*  957418 */   // Label 14420: @957418
     /*  957418 */   GIM_Try, /*On fail goto*//*Label 14421*/ GIMT_Encode4(957500), // Rule ID 64188 //
     /*  957423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  957443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957450 */     // MIs[0] op1
     /*  957450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957477 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  957480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957482 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957484 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957486 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957488 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957498 */     GIR_RootConstrainSelectedInstOperands,
     /*  957499 */     // GIR_Coverage, 64188,
     /*  957499 */     GIR_EraseRootFromParent_Done,
     /*  957500 */   // Label 14421: @957500
     /*  957500 */   GIM_Try, /*On fail goto*//*Label 14422*/ GIMT_Encode4(957582), // Rule ID 64193 //
     /*  957505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957532 */     // MIs[0] op1
     /*  957532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  957562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957564 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957566 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957568 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957570 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957580 */     GIR_RootConstrainSelectedInstOperands,
     /*  957581 */     // GIR_Coverage, 64193,
     /*  957581 */     GIR_EraseRootFromParent_Done,
     /*  957582 */   // Label 14422: @957582
     /*  957582 */   GIM_Try, /*On fail goto*//*Label 14423*/ GIMT_Encode4(957664), // Rule ID 64194 //
     /*  957587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957614 */     // MIs[0] op1
     /*  957614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957641 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  957644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957646 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957648 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957650 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957652 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957662 */     GIR_RootConstrainSelectedInstOperands,
     /*  957663 */     // GIR_Coverage, 64194,
     /*  957663 */     GIR_EraseRootFromParent_Done,
     /*  957664 */   // Label 14423: @957664
     /*  957664 */   GIM_Try, /*On fail goto*//*Label 14424*/ GIMT_Encode4(957746), // Rule ID 64199 //
     /*  957669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957696 */     // MIs[0] op1
     /*  957696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957723 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  957723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  957726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957728 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957730 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957732 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957734 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957744 */     GIR_RootConstrainSelectedInstOperands,
     /*  957745 */     // GIR_Coverage, 64199,
     /*  957745 */     GIR_EraseRootFromParent_Done,
     /*  957746 */   // Label 14424: @957746
     /*  957746 */   GIM_Try, /*On fail goto*//*Label 14425*/ GIMT_Encode4(957828), // Rule ID 64200 //
     /*  957751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957778 */     // MIs[0] op1
     /*  957778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957805 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  957805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  957808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957810 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957812 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957814 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957816 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957826 */     GIR_RootConstrainSelectedInstOperands,
     /*  957827 */     // GIR_Coverage, 64200,
     /*  957827 */     GIR_EraseRootFromParent_Done,
     /*  957828 */   // Label 14425: @957828
     /*  957828 */   GIM_Try, /*On fail goto*//*Label 14426*/ GIMT_Encode4(957910), // Rule ID 64211 //
     /*  957833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  957853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957860 */     // MIs[0] op1
     /*  957860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957887 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  957887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  957890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957892 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957894 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957896 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957898 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957908 */     GIR_RootConstrainSelectedInstOperands,
     /*  957909 */     // GIR_Coverage, 64211,
     /*  957909 */     GIR_EraseRootFromParent_Done,
     /*  957910 */   // Label 14426: @957910
     /*  957910 */   GIM_Try, /*On fail goto*//*Label 14427*/ GIMT_Encode4(957992), // Rule ID 64212 //
     /*  957915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  957935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957942 */     // MIs[0] op1
     /*  957942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957969 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  957969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  957972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957974 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957976 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957978 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957980 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957990 */     GIR_RootConstrainSelectedInstOperands,
     /*  957991 */     // GIR_Coverage, 64212,
     /*  957991 */     GIR_EraseRootFromParent_Done,
     /*  957992 */   // Label 14427: @957992
     /*  957992 */   GIM_Try, /*On fail goto*//*Label 14428*/ GIMT_Encode4(958074), // Rule ID 64217 //
     /*  957997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958024 */     // MIs[0] op1
     /*  958024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958027 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958051 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11065:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  958054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958056 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958058 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958060 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958062 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958072 */     GIR_RootConstrainSelectedInstOperands,
     /*  958073 */     // GIR_Coverage, 64217,
     /*  958073 */     GIR_EraseRootFromParent_Done,
     /*  958074 */   // Label 14428: @958074
     /*  958074 */   GIM_Try, /*On fail goto*//*Label 14429*/ GIMT_Encode4(958156), // Rule ID 64218 //
     /*  958079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  958090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  958093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  958096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958106 */     // MIs[0] op1
     /*  958106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958133 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  958136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958138 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958140 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958142 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958144 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958154 */     GIR_RootConstrainSelectedInstOperands,
     /*  958155 */     // GIR_Coverage, 64218,
     /*  958155 */     GIR_EraseRootFromParent_Done,
     /*  958156 */   // Label 14429: @958156
     /*  958156 */   GIM_Try, /*On fail goto*//*Label 14430*/ GIMT_Encode4(958238), // Rule ID 64223 //
     /*  958161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958188 */     // MIs[0] op1
     /*  958188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958215 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  958218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958220 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958222 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958224 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958226 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958236 */     GIR_RootConstrainSelectedInstOperands,
     /*  958237 */     // GIR_Coverage, 64223,
     /*  958237 */     GIR_EraseRootFromParent_Done,
     /*  958238 */   // Label 14430: @958238
     /*  958238 */   GIM_Try, /*On fail goto*//*Label 14431*/ GIMT_Encode4(958320), // Rule ID 64224 //
     /*  958243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958270 */     // MIs[0] op1
     /*  958270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958297 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  958300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958302 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958304 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958306 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958308 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958318 */     GIR_RootConstrainSelectedInstOperands,
     /*  958319 */     // GIR_Coverage, 64224,
     /*  958319 */     GIR_EraseRootFromParent_Done,
     /*  958320 */   // Label 14431: @958320
     /*  958320 */   GIM_Try, /*On fail goto*//*Label 14432*/ GIMT_Encode4(958402), // Rule ID 64235 //
     /*  958325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  958345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958352 */     // MIs[0] op1
     /*  958352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958379 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  958382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958384 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958386 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958388 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958390 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958400 */     GIR_RootConstrainSelectedInstOperands,
     /*  958401 */     // GIR_Coverage, 64235,
     /*  958401 */     GIR_EraseRootFromParent_Done,
     /*  958402 */   // Label 14432: @958402
     /*  958402 */   GIM_Try, /*On fail goto*//*Label 14433*/ GIMT_Encode4(958484), // Rule ID 64236 //
     /*  958407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  958427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958434 */     // MIs[0] op1
     /*  958434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958461 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  958464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958466 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958468 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958470 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958472 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958482 */     GIR_RootConstrainSelectedInstOperands,
     /*  958483 */     // GIR_Coverage, 64236,
     /*  958483 */     GIR_EraseRootFromParent_Done,
     /*  958484 */   // Label 14433: @958484
     /*  958484 */   GIM_Try, /*On fail goto*//*Label 14434*/ GIMT_Encode4(958566), // Rule ID 64241 //
     /*  958489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958516 */     // MIs[0] op1
     /*  958516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11065:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  958546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958548 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958550 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958552 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958554 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958564 */     GIR_RootConstrainSelectedInstOperands,
     /*  958565 */     // GIR_Coverage, 64241,
     /*  958565 */     GIR_EraseRootFromParent_Done,
     /*  958566 */   // Label 14434: @958566
     /*  958566 */   GIM_Try, /*On fail goto*//*Label 14435*/ GIMT_Encode4(958648), // Rule ID 64242 //
     /*  958571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958598 */     // MIs[0] op1
     /*  958598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958625 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  958628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958630 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958632 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958634 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958636 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958646 */     GIR_RootConstrainSelectedInstOperands,
     /*  958647 */     // GIR_Coverage, 64242,
     /*  958647 */     GIR_EraseRootFromParent_Done,
     /*  958648 */   // Label 14435: @958648
     /*  958648 */   GIM_Try, /*On fail goto*//*Label 14436*/ GIMT_Encode4(958730), // Rule ID 64247 //
     /*  958653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958680 */     // MIs[0] op1
     /*  958680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958683 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958707 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  958710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958712 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958714 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958716 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958718 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958728 */     GIR_RootConstrainSelectedInstOperands,
     /*  958729 */     // GIR_Coverage, 64247,
     /*  958729 */     GIR_EraseRootFromParent_Done,
     /*  958730 */   // Label 14436: @958730
     /*  958730 */   GIM_Try, /*On fail goto*//*Label 14437*/ GIMT_Encode4(958812), // Rule ID 64248 //
     /*  958735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958762 */     // MIs[0] op1
     /*  958762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958789 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  958792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958794 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958796 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958798 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958800 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958810 */     GIR_RootConstrainSelectedInstOperands,
     /*  958811 */     // GIR_Coverage, 64248,
     /*  958811 */     GIR_EraseRootFromParent_Done,
     /*  958812 */   // Label 14437: @958812
     /*  958812 */   GIM_Try, /*On fail goto*//*Label 14438*/ GIMT_Encode4(958894), // Rule ID 64259 //
     /*  958817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  958837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958844 */     // MIs[0] op1
     /*  958844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  958874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958876 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958878 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958880 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958882 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958892 */     GIR_RootConstrainSelectedInstOperands,
     /*  958893 */     // GIR_Coverage, 64259,
     /*  958893 */     GIR_EraseRootFromParent_Done,
     /*  958894 */   // Label 14438: @958894
     /*  958894 */   GIM_Try, /*On fail goto*//*Label 14439*/ GIMT_Encode4(958976), // Rule ID 64260 //
     /*  958899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  958919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958926 */     // MIs[0] op1
     /*  958926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958953 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  958956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958958 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958960 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958962 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958964 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958974 */     GIR_RootConstrainSelectedInstOperands,
     /*  958975 */     // GIR_Coverage, 64260,
     /*  958975 */     GIR_EraseRootFromParent_Done,
     /*  958976 */   // Label 14439: @958976
     /*  958976 */   GIM_Try, /*On fail goto*//*Label 14440*/ GIMT_Encode4(959058), // Rule ID 64265 //
     /*  958981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959008 */     // MIs[0] op1
     /*  959008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959035 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11065:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  959038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959040 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959042 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959044 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959046 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959056 */     GIR_RootConstrainSelectedInstOperands,
     /*  959057 */     // GIR_Coverage, 64265,
     /*  959057 */     GIR_EraseRootFromParent_Done,
     /*  959058 */   // Label 14440: @959058
     /*  959058 */   GIM_Try, /*On fail goto*//*Label 14441*/ GIMT_Encode4(959140), // Rule ID 64266 //
     /*  959063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  959074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  959077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  959080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959090 */     // MIs[0] op1
     /*  959090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  959106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959117 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  959120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959122 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959124 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959126 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959128 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959138 */     GIR_RootConstrainSelectedInstOperands,
     /*  959139 */     // GIR_Coverage, 64266,
     /*  959139 */     GIR_EraseRootFromParent_Done,
     /*  959140 */   // Label 14441: @959140
     /*  959140 */   GIM_Try, /*On fail goto*//*Label 14442*/ GIMT_Encode4(959222), // Rule ID 64271 //
     /*  959145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  959165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959172 */     // MIs[0] op1
     /*  959172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959199 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  959202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959204 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959206 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959208 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959210 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959220 */     GIR_RootConstrainSelectedInstOperands,
     /*  959221 */     // GIR_Coverage, 64271,
     /*  959221 */     GIR_EraseRootFromParent_Done,
     /*  959222 */   // Label 14442: @959222
     /*  959222 */   GIM_Try, /*On fail goto*//*Label 14443*/ GIMT_Encode4(959304), // Rule ID 64272 //
     /*  959227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  959235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959254 */     // MIs[0] op1
     /*  959254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  959274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959281 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  959284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959286 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959288 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959290 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959292 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959302 */     GIR_RootConstrainSelectedInstOperands,
     /*  959303 */     // GIR_Coverage, 64272,
     /*  959303 */     GIR_EraseRootFromParent_Done,
     /*  959304 */   // Label 14443: @959304
     /*  959304 */   GIM_Try, /*On fail goto*//*Label 14444*/ GIMT_Encode4(959386), // Rule ID 64283 //
     /*  959309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  959329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959336 */     // MIs[0] op1
     /*  959336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959363 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  959366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959368 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959370 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959372 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959374 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959384 */     GIR_RootConstrainSelectedInstOperands,
     /*  959385 */     // GIR_Coverage, 64283,
     /*  959385 */     GIR_EraseRootFromParent_Done,
     /*  959386 */   // Label 14444: @959386
     /*  959386 */   GIM_Try, /*On fail goto*//*Label 14445*/ GIMT_Encode4(959468), // Rule ID 64284 //
     /*  959391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  959399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  959411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959418 */     // MIs[0] op1
     /*  959418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  959426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959445 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11079:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  959448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959450 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959452 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959454 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959456 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959466 */     GIR_RootConstrainSelectedInstOperands,
     /*  959467 */     // GIR_Coverage, 64284,
     /*  959467 */     GIR_EraseRootFromParent_Done,
     /*  959468 */   // Label 14445: @959468
     /*  959468 */   GIM_Try, /*On fail goto*//*Label 14446*/ GIMT_Encode4(959550), // Rule ID 64289 //
     /*  959473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  959476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959500 */     // MIs[0] op1
     /*  959500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959503 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959527 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11065:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  959530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959532 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959534 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959536 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959538 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959548 */     GIR_RootConstrainSelectedInstOperands,
     /*  959549 */     // GIR_Coverage, 64289,
     /*  959549 */     GIR_EraseRootFromParent_Done,
     /*  959550 */   // Label 14446: @959550
     /*  959550 */   GIM_Try, /*On fail goto*//*Label 14447*/ GIMT_Encode4(959632), // Rule ID 64290 //
     /*  959555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959582 */     // MIs[0] op1
     /*  959582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959609 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11065:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  959612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959614 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959616 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959618 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959620 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959630 */     GIR_RootConstrainSelectedInstOperands,
     /*  959631 */     // GIR_Coverage, 64290,
     /*  959631 */     GIR_EraseRootFromParent_Done,
     /*  959632 */   // Label 14447: @959632
     /*  959632 */   GIM_Try, /*On fail goto*//*Label 14448*/ GIMT_Encode4(959724), // Rule ID 5202 //
     /*  959637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  959640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  959648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  959651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  959654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  959657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  959660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959687 */     // MIs[1] Operand 1
     /*  959687 */     // No operand predicates
     /*  959687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959700 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  959700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  959703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959722 */     GIR_RootConstrainSelectedInstOperands,
     /*  959723 */     // GIR_Coverage, 5202,
     /*  959723 */     GIR_EraseRootFromParent_Done,
     /*  959724 */   // Label 14448: @959724
     /*  959724 */   GIM_Try, /*On fail goto*//*Label 14449*/ GIMT_Encode4(959816), // Rule ID 5203 //
     /*  959729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  959732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  959740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  959743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  959746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  959749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  959752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959779 */     // MIs[1] Operand 1
     /*  959779 */     // No operand predicates
     /*  959779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959792 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  959792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  959795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959814 */     GIR_RootConstrainSelectedInstOperands,
     /*  959815 */     // GIR_Coverage, 5203,
     /*  959815 */     GIR_EraseRootFromParent_Done,
     /*  959816 */   // Label 14449: @959816
     /*  959816 */   GIM_Try, /*On fail goto*//*Label 14450*/ GIMT_Encode4(959908), // Rule ID 5204 //
     /*  959821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  959824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  959832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  959835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  959838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  959841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  959844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959871 */     // MIs[1] Operand 1
     /*  959871 */     // No operand predicates
     /*  959871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959884 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  959884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  959887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959906 */     GIR_RootConstrainSelectedInstOperands,
     /*  959907 */     // GIR_Coverage, 5204,
     /*  959907 */     GIR_EraseRootFromParent_Done,
     /*  959908 */   // Label 14450: @959908
     /*  959908 */   GIM_Try, /*On fail goto*//*Label 14451*/ GIMT_Encode4(960000), // Rule ID 5205 //
     /*  959913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  959916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  959924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  959927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  959930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  959933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  959936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959963 */     // MIs[1] Operand 1
     /*  959963 */     // No operand predicates
     /*  959963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  959976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  959979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959998 */     GIR_RootConstrainSelectedInstOperands,
     /*  959999 */     // GIR_Coverage, 5205,
     /*  959999 */     GIR_EraseRootFromParent_Done,
     /*  960000 */   // Label 14451: @960000
     /*  960000 */   GIM_Try, /*On fail goto*//*Label 14452*/ GIMT_Encode4(960092), // Rule ID 5206 //
     /*  960005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  960016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  960019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  960022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960055 */     // MIs[1] Operand 1
     /*  960055 */     // No operand predicates
     /*  960055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960068 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960090 */     GIR_RootConstrainSelectedInstOperands,
     /*  960091 */     // GIR_Coverage, 5206,
     /*  960091 */     GIR_EraseRootFromParent_Done,
     /*  960092 */   // Label 14452: @960092
     /*  960092 */   GIM_Try, /*On fail goto*//*Label 14453*/ GIMT_Encode4(960184), // Rule ID 5207 //
     /*  960097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  960108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  960111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  960114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960147 */     // MIs[1] Operand 1
     /*  960147 */     // No operand predicates
     /*  960147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960160 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960182 */     GIR_RootConstrainSelectedInstOperands,
     /*  960183 */     // GIR_Coverage, 5207,
     /*  960183 */     GIR_EraseRootFromParent_Done,
     /*  960184 */   // Label 14453: @960184
     /*  960184 */   GIM_Try, /*On fail goto*//*Label 14454*/ GIMT_Encode4(960276), // Rule ID 5208 //
     /*  960189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960239 */     // MIs[1] Operand 1
     /*  960239 */     // No operand predicates
     /*  960239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960252 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960274 */     GIR_RootConstrainSelectedInstOperands,
     /*  960275 */     // GIR_Coverage, 5208,
     /*  960275 */     GIR_EraseRootFromParent_Done,
     /*  960276 */   // Label 14454: @960276
     /*  960276 */   GIM_Try, /*On fail goto*//*Label 14455*/ GIMT_Encode4(960368), // Rule ID 5209 //
     /*  960281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  960292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  960295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  960298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960331 */     // MIs[1] Operand 1
     /*  960331 */     // No operand predicates
     /*  960331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960344 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  960347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960366 */     GIR_RootConstrainSelectedInstOperands,
     /*  960367 */     // GIR_Coverage, 5209,
     /*  960367 */     GIR_EraseRootFromParent_Done,
     /*  960368 */   // Label 14455: @960368
     /*  960368 */   GIM_Try, /*On fail goto*//*Label 14456*/ GIMT_Encode4(960460), // Rule ID 5210 //
     /*  960373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960423 */     // MIs[1] Operand 1
     /*  960423 */     // No operand predicates
     /*  960423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960436 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960458 */     GIR_RootConstrainSelectedInstOperands,
     /*  960459 */     // GIR_Coverage, 5210,
     /*  960459 */     GIR_EraseRootFromParent_Done,
     /*  960460 */   // Label 14456: @960460
     /*  960460 */   GIM_Try, /*On fail goto*//*Label 14457*/ GIMT_Encode4(960552), // Rule ID 5211 //
     /*  960465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  960476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  960479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  960482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960515 */     // MIs[1] Operand 1
     /*  960515 */     // No operand predicates
     /*  960515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960550 */     GIR_RootConstrainSelectedInstOperands,
     /*  960551 */     // GIR_Coverage, 5211,
     /*  960551 */     GIR_EraseRootFromParent_Done,
     /*  960552 */   // Label 14457: @960552
     /*  960552 */   GIM_Try, /*On fail goto*//*Label 14458*/ GIMT_Encode4(960644), // Rule ID 5212 //
     /*  960557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  960568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  960571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  960574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960607 */     // MIs[1] Operand 1
     /*  960607 */     // No operand predicates
     /*  960607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960620 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  960620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960642 */     GIR_RootConstrainSelectedInstOperands,
     /*  960643 */     // GIR_Coverage, 5212,
     /*  960643 */     GIR_EraseRootFromParent_Done,
     /*  960644 */   // Label 14458: @960644
     /*  960644 */   GIM_Try, /*On fail goto*//*Label 14459*/ GIMT_Encode4(960736), // Rule ID 5213 //
     /*  960649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  960660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  960663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  960666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960699 */     // MIs[1] Operand 1
     /*  960699 */     // No operand predicates
     /*  960699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960712 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  960712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960734 */     GIR_RootConstrainSelectedInstOperands,
     /*  960735 */     // GIR_Coverage, 5213,
     /*  960735 */     GIR_EraseRootFromParent_Done,
     /*  960736 */   // Label 14459: @960736
     /*  960736 */   GIM_Try, /*On fail goto*//*Label 14460*/ GIMT_Encode4(960828), // Rule ID 5214 //
     /*  960741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  960752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  960755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  960758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  960764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960791 */     // MIs[1] Operand 1
     /*  960791 */     // No operand predicates
     /*  960791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960804 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960826 */     GIR_RootConstrainSelectedInstOperands,
     /*  960827 */     // GIR_Coverage, 5214,
     /*  960827 */     GIR_EraseRootFromParent_Done,
     /*  960828 */   // Label 14460: @960828
     /*  960828 */   GIM_Try, /*On fail goto*//*Label 14461*/ GIMT_Encode4(960920), // Rule ID 5215 //
     /*  960833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  960844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  960847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  960850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  960856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960883 */     // MIs[1] Operand 1
     /*  960883 */     // No operand predicates
     /*  960883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960918 */     GIR_RootConstrainSelectedInstOperands,
     /*  960919 */     // GIR_Coverage, 5215,
     /*  960919 */     GIR_EraseRootFromParent_Done,
     /*  960920 */   // Label 14461: @960920
     /*  960920 */   GIM_Try, /*On fail goto*//*Label 14462*/ GIMT_Encode4(961012), // Rule ID 5216 //
     /*  960925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  960936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  960939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  960942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960975 */     // MIs[1] Operand 1
     /*  960975 */     // No operand predicates
     /*  960975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961010 */     GIR_RootConstrainSelectedInstOperands,
     /*  961011 */     // GIR_Coverage, 5216,
     /*  961011 */     GIR_EraseRootFromParent_Done,
     /*  961012 */   // Label 14462: @961012
     /*  961012 */   GIM_Try, /*On fail goto*//*Label 14463*/ GIMT_Encode4(961104), // Rule ID 5217 //
     /*  961017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  961028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  961031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  961034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  961040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961067 */     // MIs[1] Operand 1
     /*  961067 */     // No operand predicates
     /*  961067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961080 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961102 */     GIR_RootConstrainSelectedInstOperands,
     /*  961103 */     // GIR_Coverage, 5217,
     /*  961103 */     GIR_EraseRootFromParent_Done,
     /*  961104 */   // Label 14463: @961104
     /*  961104 */   GIM_Try, /*On fail goto*//*Label 14464*/ GIMT_Encode4(961196), // Rule ID 5218 //
     /*  961109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  961120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  961123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  961126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  961132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961159 */     // MIs[1] Operand 1
     /*  961159 */     // No operand predicates
     /*  961159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961172 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  961172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961194 */     GIR_RootConstrainSelectedInstOperands,
     /*  961195 */     // GIR_Coverage, 5218,
     /*  961195 */     GIR_EraseRootFromParent_Done,
     /*  961196 */   // Label 14464: @961196
     /*  961196 */   GIM_Try, /*On fail goto*//*Label 14465*/ GIMT_Encode4(961288), // Rule ID 5219 //
     /*  961201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  961212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  961215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  961218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  961224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961251 */     // MIs[1] Operand 1
     /*  961251 */     // No operand predicates
     /*  961251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  961264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  961286 */     GIR_RootConstrainSelectedInstOperands,
     /*  961287 */     // GIR_Coverage, 5219,
     /*  961287 */     GIR_EraseRootFromParent_Done,
     /*  961288 */   // Label 14465: @961288
     /*  961288 */   GIM_Try, /*On fail goto*//*Label 14466*/ GIMT_Encode4(961380), // Rule ID 5220 //
     /*  961293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  961296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  961307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961343 */     // MIs[1] Operand 1
     /*  961343 */     // No operand predicates
     /*  961343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  961356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  961378 */     GIR_RootConstrainSelectedInstOperands,
     /*  961379 */     // GIR_Coverage, 5220,
     /*  961379 */     GIR_EraseRootFromParent_Done,
     /*  961380 */   // Label 14466: @961380
     /*  961380 */   GIM_Try, /*On fail goto*//*Label 14467*/ GIMT_Encode4(961472), // Rule ID 5221 //
     /*  961385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  961388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  961396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  961399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  961402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  961408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  961415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  961423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961435 */     // MIs[1] Operand 1
     /*  961435 */     // No operand predicates
     /*  961435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961448 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  961448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  961451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  961470 */     GIR_RootConstrainSelectedInstOperands,
     /*  961471 */     // GIR_Coverage, 5221,
     /*  961471 */     GIR_EraseRootFromParent_Done,
     /*  961472 */   // Label 14467: @961472
     /*  961472 */   GIM_Try, /*On fail goto*//*Label 14468*/ GIMT_Encode4(961564), // Rule ID 5222 //
     /*  961477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  961488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  961491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  961494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  961500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961527 */     // MIs[1] Operand 1
     /*  961527 */     // No operand predicates
     /*  961527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961540 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  961543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961562 */     GIR_RootConstrainSelectedInstOperands,
     /*  961563 */     // GIR_Coverage, 5222,
     /*  961563 */     GIR_EraseRootFromParent_Done,
     /*  961564 */   // Label 14468: @961564
     /*  961564 */   GIM_Try, /*On fail goto*//*Label 14469*/ GIMT_Encode4(961656), // Rule ID 5223 //
     /*  961569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  961580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  961583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  961586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  961592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961619 */     // MIs[1] Operand 1
     /*  961619 */     // No operand predicates
     /*  961619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961632 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  961632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  961635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961654 */     GIR_RootConstrainSelectedInstOperands,
     /*  961655 */     // GIR_Coverage, 5223,
     /*  961655 */     GIR_EraseRootFromParent_Done,
     /*  961656 */   // Label 14469: @961656
     /*  961656 */   GIM_Try, /*On fail goto*//*Label 14470*/ GIMT_Encode4(961748), // Rule ID 5224 //
     /*  961661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  961672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  961675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  961678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  961684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961711 */     // MIs[1] Operand 1
     /*  961711 */     // No operand predicates
     /*  961711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961724 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  961727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961746 */     GIR_RootConstrainSelectedInstOperands,
     /*  961747 */     // GIR_Coverage, 5224,
     /*  961747 */     GIR_EraseRootFromParent_Done,
     /*  961748 */   // Label 14470: @961748
     /*  961748 */   GIM_Try, /*On fail goto*//*Label 14471*/ GIMT_Encode4(961840), // Rule ID 5225 //
     /*  961753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  961764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  961767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  961770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  961776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961803 */     // MIs[1] Operand 1
     /*  961803 */     // No operand predicates
     /*  961803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961816 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  961816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  961819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961838 */     GIR_RootConstrainSelectedInstOperands,
     /*  961839 */     // GIR_Coverage, 5225,
     /*  961839 */     GIR_EraseRootFromParent_Done,
     /*  961840 */   // Label 14471: @961840
     /*  961840 */   GIM_Try, /*On fail goto*//*Label 14472*/ GIMT_Encode4(961932), // Rule ID 5226 //
     /*  961845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  961856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  961859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  961862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  961868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961895 */     // MIs[1] Operand 1
     /*  961895 */     // No operand predicates
     /*  961895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961908 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  961911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961930 */     GIR_RootConstrainSelectedInstOperands,
     /*  961931 */     // GIR_Coverage, 5226,
     /*  961931 */     GIR_EraseRootFromParent_Done,
     /*  961932 */   // Label 14472: @961932
     /*  961932 */   GIM_Try, /*On fail goto*//*Label 14473*/ GIMT_Encode4(962024), // Rule ID 5227 //
     /*  961937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  961948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  961951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  961954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  961960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961987 */     // MIs[1] Operand 1
     /*  961987 */     // No operand predicates
     /*  961987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962000 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  962000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  962022 */     GIR_RootConstrainSelectedInstOperands,
     /*  962023 */     // GIR_Coverage, 5227,
     /*  962023 */     GIR_EraseRootFromParent_Done,
     /*  962024 */   // Label 14473: @962024
     /*  962024 */   GIM_Try, /*On fail goto*//*Label 14474*/ GIMT_Encode4(962116), // Rule ID 5228 //
     /*  962029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  962040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  962043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  962046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962079 */     // MIs[1] Operand 1
     /*  962079 */     // No operand predicates
     /*  962079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962114 */     GIR_RootConstrainSelectedInstOperands,
     /*  962115 */     // GIR_Coverage, 5228,
     /*  962115 */     GIR_EraseRootFromParent_Done,
     /*  962116 */   // Label 14474: @962116
     /*  962116 */   GIM_Try, /*On fail goto*//*Label 14475*/ GIMT_Encode4(962208), // Rule ID 5229 //
     /*  962121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  962132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  962135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  962138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962171 */     // MIs[1] Operand 1
     /*  962171 */     // No operand predicates
     /*  962171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962206 */     GIR_RootConstrainSelectedInstOperands,
     /*  962207 */     // GIR_Coverage, 5229,
     /*  962207 */     GIR_EraseRootFromParent_Done,
     /*  962208 */   // Label 14475: @962208
     /*  962208 */   GIM_Try, /*On fail goto*//*Label 14476*/ GIMT_Encode4(962300), // Rule ID 5230 //
     /*  962213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  962224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  962227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  962230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962263 */     // MIs[1] Operand 1
     /*  962263 */     // No operand predicates
     /*  962263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962276 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962298 */     GIR_RootConstrainSelectedInstOperands,
     /*  962299 */     // GIR_Coverage, 5230,
     /*  962299 */     GIR_EraseRootFromParent_Done,
     /*  962300 */   // Label 14476: @962300
     /*  962300 */   GIM_Try, /*On fail goto*//*Label 14477*/ GIMT_Encode4(962392), // Rule ID 5231 //
     /*  962305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  962316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  962319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  962322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962355 */     // MIs[1] Operand 1
     /*  962355 */     // No operand predicates
     /*  962355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962390 */     GIR_RootConstrainSelectedInstOperands,
     /*  962391 */     // GIR_Coverage, 5231,
     /*  962391 */     GIR_EraseRootFromParent_Done,
     /*  962392 */   // Label 14477: @962392
     /*  962392 */   GIM_Try, /*On fail goto*//*Label 14478*/ GIMT_Encode4(962484), // Rule ID 5232 //
     /*  962397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  962408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  962411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  962414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962447 */     // MIs[1] Operand 1
     /*  962447 */     // No operand predicates
     /*  962447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962460 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  962460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962482 */     GIR_RootConstrainSelectedInstOperands,
     /*  962483 */     // GIR_Coverage, 5232,
     /*  962483 */     GIR_EraseRootFromParent_Done,
     /*  962484 */   // Label 14478: @962484
     /*  962484 */   GIM_Try, /*On fail goto*//*Label 14479*/ GIMT_Encode4(962576), // Rule ID 5233 //
     /*  962489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  962500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  962503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  962506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962539 */     // MIs[1] Operand 1
     /*  962539 */     // No operand predicates
     /*  962539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962574 */     GIR_RootConstrainSelectedInstOperands,
     /*  962575 */     // GIR_Coverage, 5233,
     /*  962575 */     GIR_EraseRootFromParent_Done,
     /*  962576 */   // Label 14479: @962576
     /*  962576 */   GIM_Try, /*On fail goto*//*Label 14480*/ GIMT_Encode4(962668), // Rule ID 5234 //
     /*  962581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  962592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  962595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  962598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  962604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962631 */     // MIs[1] Operand 1
     /*  962631 */     // No operand predicates
     /*  962631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962666 */     GIR_RootConstrainSelectedInstOperands,
     /*  962667 */     // GIR_Coverage, 5234,
     /*  962667 */     GIR_EraseRootFromParent_Done,
     /*  962668 */   // Label 14480: @962668
     /*  962668 */   GIM_Try, /*On fail goto*//*Label 14481*/ GIMT_Encode4(962760), // Rule ID 5235 //
     /*  962673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  962684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  962687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  962690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  962696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962723 */     // MIs[1] Operand 1
     /*  962723 */     // No operand predicates
     /*  962723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962758 */     GIR_RootConstrainSelectedInstOperands,
     /*  962759 */     // GIR_Coverage, 5235,
     /*  962759 */     GIR_EraseRootFromParent_Done,
     /*  962760 */   // Label 14481: @962760
     /*  962760 */   GIM_Try, /*On fail goto*//*Label 14482*/ GIMT_Encode4(962852), // Rule ID 5236 //
     /*  962765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  962776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  962779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  962782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962815 */     // MIs[1] Operand 1
     /*  962815 */     // No operand predicates
     /*  962815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962850 */     GIR_RootConstrainSelectedInstOperands,
     /*  962851 */     // GIR_Coverage, 5236,
     /*  962851 */     GIR_EraseRootFromParent_Done,
     /*  962852 */   // Label 14482: @962852
     /*  962852 */   GIM_Try, /*On fail goto*//*Label 14483*/ GIMT_Encode4(962944), // Rule ID 5237 //
     /*  962857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  962868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  962871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  962874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962907 */     // MIs[1] Operand 1
     /*  962907 */     // No operand predicates
     /*  962907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962942 */     GIR_RootConstrainSelectedInstOperands,
     /*  962943 */     // GIR_Coverage, 5237,
     /*  962943 */     GIR_EraseRootFromParent_Done,
     /*  962944 */   // Label 14483: @962944
     /*  962944 */   GIM_Try, /*On fail goto*//*Label 14484*/ GIMT_Encode4(963036), // Rule ID 5238 //
     /*  962949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  962960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  962963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  962966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962999 */     // MIs[1] Operand 1
     /*  962999 */     // No operand predicates
     /*  962999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  963012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963034 */     GIR_RootConstrainSelectedInstOperands,
     /*  963035 */     // GIR_Coverage, 5238,
     /*  963035 */     GIR_EraseRootFromParent_Done,
     /*  963036 */   // Label 14484: @963036
     /*  963036 */   GIM_Try, /*On fail goto*//*Label 14485*/ GIMT_Encode4(963128), // Rule ID 5239 //
     /*  963041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  963052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  963055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  963058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  963064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963091 */     // MIs[1] Operand 1
     /*  963091 */     // No operand predicates
     /*  963091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  963104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  963126 */     GIR_RootConstrainSelectedInstOperands,
     /*  963127 */     // GIR_Coverage, 5239,
     /*  963127 */     GIR_EraseRootFromParent_Done,
     /*  963128 */   // Label 14485: @963128
     /*  963128 */   GIM_Try, /*On fail goto*//*Label 14486*/ GIMT_Encode4(963220), // Rule ID 5240 //
     /*  963133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  963150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963183 */     // MIs[1] Operand 1
     /*  963183 */     // No operand predicates
     /*  963183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963218 */     GIR_RootConstrainSelectedInstOperands,
     /*  963219 */     // GIR_Coverage, 5240,
     /*  963219 */     GIR_EraseRootFromParent_Done,
     /*  963220 */   // Label 14486: @963220
     /*  963220 */   GIM_Try, /*On fail goto*//*Label 14487*/ GIMT_Encode4(963312), // Rule ID 5241 //
     /*  963225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  963236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  963239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  963242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  963255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  963263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963275 */     // MIs[1] Operand 1
     /*  963275 */     // No operand predicates
     /*  963275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963288 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  963291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963310 */     GIR_RootConstrainSelectedInstOperands,
     /*  963311 */     // GIR_Coverage, 5241,
     /*  963311 */     GIR_EraseRootFromParent_Done,
     /*  963312 */   // Label 14487: @963312
     /*  963312 */   GIM_Try, /*On fail goto*//*Label 14488*/ GIMT_Encode4(963404), // Rule ID 5242 //
     /*  963317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  963334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963367 */     // MIs[1] Operand 1
     /*  963367 */     // No operand predicates
     /*  963367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963402 */     GIR_RootConstrainSelectedInstOperands,
     /*  963403 */     // GIR_Coverage, 5242,
     /*  963403 */     GIR_EraseRootFromParent_Done,
     /*  963404 */   // Label 14488: @963404
     /*  963404 */   GIM_Try, /*On fail goto*//*Label 14489*/ GIMT_Encode4(963496), // Rule ID 5243 //
     /*  963409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  963420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  963423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  963426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  963439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  963447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963459 */     // MIs[1] Operand 1
     /*  963459 */     // No operand predicates
     /*  963459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  963475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963494 */     GIR_RootConstrainSelectedInstOperands,
     /*  963495 */     // GIR_Coverage, 5243,
     /*  963495 */     GIR_EraseRootFromParent_Done,
     /*  963496 */   // Label 14489: @963496
     /*  963496 */   GIM_Try, /*On fail goto*//*Label 14490*/ GIMT_Encode4(963588), // Rule ID 5244 //
     /*  963501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  963504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963551 */     // MIs[1] Operand 1
     /*  963551 */     // No operand predicates
     /*  963551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963564 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963586 */     GIR_RootConstrainSelectedInstOperands,
     /*  963587 */     // GIR_Coverage, 5244,
     /*  963587 */     GIR_EraseRootFromParent_Done,
     /*  963588 */   // Label 14490: @963588
     /*  963588 */   GIM_Try, /*On fail goto*//*Label 14491*/ GIMT_Encode4(963680), // Rule ID 5245 //
     /*  963593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963643 */     // MIs[1] Operand 1
     /*  963643 */     // No operand predicates
     /*  963643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963656 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963678 */     GIR_RootConstrainSelectedInstOperands,
     /*  963679 */     // GIR_Coverage, 5245,
     /*  963679 */     GIR_EraseRootFromParent_Done,
     /*  963680 */   // Label 14491: @963680
     /*  963680 */   GIM_Try, /*On fail goto*//*Label 14492*/ GIMT_Encode4(963775), // Rule ID 7976 //
     /*  963685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  963696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  963699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963735 */     // MIs[1] Operand 1
     /*  963735 */     // No operand predicates
     /*  963735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  963748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  963751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963773 */     GIR_RootConstrainSelectedInstOperands,
     /*  963774 */     // GIR_Coverage, 7976,
     /*  963774 */     GIR_EraseRootFromParent_Done,
     /*  963775 */   // Label 14492: @963775
     /*  963775 */   GIM_Try, /*On fail goto*//*Label 14493*/ GIMT_Encode4(963870), // Rule ID 7977 //
     /*  963780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  963791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  963794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963830 */     // MIs[1] Operand 1
     /*  963830 */     // No operand predicates
     /*  963830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963843 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  963843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  963846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963868 */     GIR_RootConstrainSelectedInstOperands,
     /*  963869 */     // GIR_Coverage, 7977,
     /*  963869 */     GIR_EraseRootFromParent_Done,
     /*  963870 */   // Label 14493: @963870
     /*  963870 */   GIM_Try, /*On fail goto*//*Label 14494*/ GIMT_Encode4(963965), // Rule ID 7980 //
     /*  963875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  963886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  963889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963925 */     // MIs[1] Operand 1
     /*  963925 */     // No operand predicates
     /*  963925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963938 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  963938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  963941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963963 */     GIR_RootConstrainSelectedInstOperands,
     /*  963964 */     // GIR_Coverage, 7980,
     /*  963964 */     GIR_EraseRootFromParent_Done,
     /*  963965 */   // Label 14494: @963965
     /*  963965 */   GIM_Try, /*On fail goto*//*Label 14495*/ GIMT_Encode4(964060), // Rule ID 7981 //
     /*  963970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  963981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  963984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964020 */     // MIs[1] Operand 1
     /*  964020 */     // No operand predicates
     /*  964020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964033 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964058 */     GIR_RootConstrainSelectedInstOperands,
     /*  964059 */     // GIR_Coverage, 7981,
     /*  964059 */     GIR_EraseRootFromParent_Done,
     /*  964060 */   // Label 14495: @964060
     /*  964060 */   GIM_Try, /*On fail goto*//*Label 14496*/ GIMT_Encode4(964155), // Rule ID 7984 //
     /*  964065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  964082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964115 */     // MIs[1] Operand 1
     /*  964115 */     // No operand predicates
     /*  964115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964128 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964153 */     GIR_RootConstrainSelectedInstOperands,
     /*  964154 */     // GIR_Coverage, 7984,
     /*  964154 */     GIR_EraseRootFromParent_Done,
     /*  964155 */   // Label 14496: @964155
     /*  964155 */   GIM_Try, /*On fail goto*//*Label 14497*/ GIMT_Encode4(964250), // Rule ID 7985 //
     /*  964160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  964177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964210 */     // MIs[1] Operand 1
     /*  964210 */     // No operand predicates
     /*  964210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964223 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964248 */     GIR_RootConstrainSelectedInstOperands,
     /*  964249 */     // GIR_Coverage, 7985,
     /*  964249 */     GIR_EraseRootFromParent_Done,
     /*  964250 */   // Label 14497: @964250
     /*  964250 */   GIM_Try, /*On fail goto*//*Label 14498*/ GIMT_Encode4(964345), // Rule ID 7988 //
     /*  964255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964305 */     // MIs[1] Operand 1
     /*  964305 */     // No operand predicates
     /*  964305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964318 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964343 */     GIR_RootConstrainSelectedInstOperands,
     /*  964344 */     // GIR_Coverage, 7988,
     /*  964344 */     GIR_EraseRootFromParent_Done,
     /*  964345 */   // Label 14498: @964345
     /*  964345 */   GIM_Try, /*On fail goto*//*Label 14499*/ GIMT_Encode4(964440), // Rule ID 7989 //
     /*  964350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  964367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964400 */     // MIs[1] Operand 1
     /*  964400 */     // No operand predicates
     /*  964400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964413 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  964413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  964416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964438 */     GIR_RootConstrainSelectedInstOperands,
     /*  964439 */     // GIR_Coverage, 7989,
     /*  964439 */     GIR_EraseRootFromParent_Done,
     /*  964440 */   // Label 14499: @964440
     /*  964440 */   GIM_Try, /*On fail goto*//*Label 14500*/ GIMT_Encode4(964535), // Rule ID 7992 //
     /*  964445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964495 */     // MIs[1] Operand 1
     /*  964495 */     // No operand predicates
     /*  964495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964508 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964533 */     GIR_RootConstrainSelectedInstOperands,
     /*  964534 */     // GIR_Coverage, 7992,
     /*  964534 */     GIR_EraseRootFromParent_Done,
     /*  964535 */   // Label 14500: @964535
     /*  964535 */   GIM_Try, /*On fail goto*//*Label 14501*/ GIMT_Encode4(964630), // Rule ID 7993 //
     /*  964540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964590 */     // MIs[1] Operand 1
     /*  964590 */     // No operand predicates
     /*  964590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964603 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  964603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964628 */     GIR_RootConstrainSelectedInstOperands,
     /*  964629 */     // GIR_Coverage, 7993,
     /*  964629 */     GIR_EraseRootFromParent_Done,
     /*  964630 */   // Label 14501: @964630
     /*  964630 */   GIM_Try, /*On fail goto*//*Label 14502*/ GIMT_Encode4(964725), // Rule ID 7996 //
     /*  964635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964685 */     // MIs[1] Operand 1
     /*  964685 */     // No operand predicates
     /*  964685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  964698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964723 */     GIR_RootConstrainSelectedInstOperands,
     /*  964724 */     // GIR_Coverage, 7996,
     /*  964724 */     GIR_EraseRootFromParent_Done,
     /*  964725 */   // Label 14502: @964725
     /*  964725 */   GIM_Try, /*On fail goto*//*Label 14503*/ GIMT_Encode4(964820), // Rule ID 7997 //
     /*  964730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964780 */     // MIs[1] Operand 1
     /*  964780 */     // No operand predicates
     /*  964780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964793 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  964793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964818 */     GIR_RootConstrainSelectedInstOperands,
     /*  964819 */     // GIR_Coverage, 7997,
     /*  964819 */     GIR_EraseRootFromParent_Done,
     /*  964820 */   // Label 14503: @964820
     /*  964820 */   GIM_Try, /*On fail goto*//*Label 14504*/ GIMT_Encode4(964915), // Rule ID 8000 //
     /*  964825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  964836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  964839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964875 */     // MIs[1] Operand 1
     /*  964875 */     // No operand predicates
     /*  964875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964913 */     GIR_RootConstrainSelectedInstOperands,
     /*  964914 */     // GIR_Coverage, 8000,
     /*  964914 */     GIR_EraseRootFromParent_Done,
     /*  964915 */   // Label 14504: @964915
     /*  964915 */   GIM_Try, /*On fail goto*//*Label 14505*/ GIMT_Encode4(965010), // Rule ID 8001 //
     /*  964920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  964931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  964934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964970 */     // MIs[1] Operand 1
     /*  964970 */     // No operand predicates
     /*  964970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964983 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965008 */     GIR_RootConstrainSelectedInstOperands,
     /*  965009 */     // GIR_Coverage, 8001,
     /*  965009 */     GIR_EraseRootFromParent_Done,
     /*  965010 */   // Label 14505: @965010
     /*  965010 */   GIM_Try, /*On fail goto*//*Label 14506*/ GIMT_Encode4(965105), // Rule ID 8004 //
     /*  965015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  965026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  965029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  965032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  965038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965065 */     // MIs[1] Operand 1
     /*  965065 */     // No operand predicates
     /*  965065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965078 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  965078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965103 */     GIR_RootConstrainSelectedInstOperands,
     /*  965104 */     // GIR_Coverage, 8004,
     /*  965104 */     GIR_EraseRootFromParent_Done,
     /*  965105 */   // Label 14506: @965105
     /*  965105 */   GIM_Try, /*On fail goto*//*Label 14507*/ GIMT_Encode4(965200), // Rule ID 8005 //
     /*  965110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  965121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  965124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  965127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  965133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965160 */     // MIs[1] Operand 1
     /*  965160 */     // No operand predicates
     /*  965160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965173 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  965173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965198 */     GIR_RootConstrainSelectedInstOperands,
     /*  965199 */     // GIR_Coverage, 8005,
     /*  965199 */     GIR_EraseRootFromParent_Done,
     /*  965200 */   // Label 14507: @965200
     /*  965200 */   GIM_Try, /*On fail goto*//*Label 14508*/ GIMT_Encode4(965295), // Rule ID 8008 //
     /*  965205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965255 */     // MIs[1] Operand 1
     /*  965255 */     // No operand predicates
     /*  965255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965268 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  965268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965293 */     GIR_RootConstrainSelectedInstOperands,
     /*  965294 */     // GIR_Coverage, 8008,
     /*  965294 */     GIR_EraseRootFromParent_Done,
     /*  965295 */   // Label 14508: @965295
     /*  965295 */   GIM_Try, /*On fail goto*//*Label 14509*/ GIMT_Encode4(965390), // Rule ID 8009 //
     /*  965300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  965311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  965314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  965317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  965323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965350 */     // MIs[1] Operand 1
     /*  965350 */     // No operand predicates
     /*  965350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965363 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  965363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  965385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965388 */     GIR_RootConstrainSelectedInstOperands,
     /*  965389 */     // GIR_Coverage, 8009,
     /*  965389 */     GIR_EraseRootFromParent_Done,
     /*  965390 */   // Label 14509: @965390
     /*  965390 */   GIM_Try, /*On fail goto*//*Label 14510*/ GIMT_Encode4(965485), // Rule ID 8012 //
     /*  965395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  965398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965445 */     // MIs[1] Operand 1
     /*  965445 */     // No operand predicates
     /*  965445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965458 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  965458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965483 */     GIR_RootConstrainSelectedInstOperands,
     /*  965484 */     // GIR_Coverage, 8012,
     /*  965484 */     GIR_EraseRootFromParent_Done,
     /*  965485 */   // Label 14510: @965485
     /*  965485 */   GIM_Try, /*On fail goto*//*Label 14511*/ GIMT_Encode4(965580), // Rule ID 8013 //
     /*  965490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  965493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  965501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  965504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  965507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965540 */     // MIs[1] Operand 1
     /*  965540 */     // No operand predicates
     /*  965540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965553 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  965553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965578 */     GIR_RootConstrainSelectedInstOperands,
     /*  965579 */     // GIR_Coverage, 8013,
     /*  965579 */     GIR_EraseRootFromParent_Done,
     /*  965580 */   // Label 14511: @965580
     /*  965580 */   GIM_Try, /*On fail goto*//*Label 14512*/ GIMT_Encode4(965675), // Rule ID 8016 //
     /*  965585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  965596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  965599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965635 */     // MIs[1] Operand 1
     /*  965635 */     // No operand predicates
     /*  965635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965648 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  965648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  965651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965673 */     GIR_RootConstrainSelectedInstOperands,
     /*  965674 */     // GIR_Coverage, 8016,
     /*  965674 */     GIR_EraseRootFromParent_Done,
     /*  965675 */   // Label 14512: @965675
     /*  965675 */   GIM_Try, /*On fail goto*//*Label 14513*/ GIMT_Encode4(965770), // Rule ID 8017 //
     /*  965680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  965691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  965694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965730 */     // MIs[1] Operand 1
     /*  965730 */     // No operand predicates
     /*  965730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965743 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  965743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  965746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965768 */     GIR_RootConstrainSelectedInstOperands,
     /*  965769 */     // GIR_Coverage, 8017,
     /*  965769 */     GIR_EraseRootFromParent_Done,
     /*  965770 */   // Label 14513: @965770
     /*  965770 */   GIM_Try, /*On fail goto*//*Label 14514*/ GIMT_Encode4(965865), // Rule ID 8020 //
     /*  965775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  965786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  965789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965825 */     // MIs[1] Operand 1
     /*  965825 */     // No operand predicates
     /*  965825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965838 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  965838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  965841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965863 */     GIR_RootConstrainSelectedInstOperands,
     /*  965864 */     // GIR_Coverage, 8020,
     /*  965864 */     GIR_EraseRootFromParent_Done,
     /*  965865 */   // Label 14514: @965865
     /*  965865 */   GIM_Try, /*On fail goto*//*Label 14515*/ GIMT_Encode4(965960), // Rule ID 8021 //
     /*  965870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  965881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  965884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965920 */     // MIs[1] Operand 1
     /*  965920 */     // No operand predicates
     /*  965920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965933 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  965933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  965936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965958 */     GIR_RootConstrainSelectedInstOperands,
     /*  965959 */     // GIR_Coverage, 8021,
     /*  965959 */     GIR_EraseRootFromParent_Done,
     /*  965960 */   // Label 14515: @965960
     /*  965960 */   GIM_Try, /*On fail goto*//*Label 14516*/ GIMT_Encode4(966055), // Rule ID 8024 //
     /*  965965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  965976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  965979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  965982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  965988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966015 */     // MIs[1] Operand 1
     /*  966015 */     // No operand predicates
     /*  966015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966028 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  966028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966053 */     GIR_RootConstrainSelectedInstOperands,
     /*  966054 */     // GIR_Coverage, 8024,
     /*  966054 */     GIR_EraseRootFromParent_Done,
     /*  966055 */   // Label 14516: @966055
     /*  966055 */   GIM_Try, /*On fail goto*//*Label 14517*/ GIMT_Encode4(966150), // Rule ID 8025 //
     /*  966060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  966071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  966074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  966077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  966083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966110 */     // MIs[1] Operand 1
     /*  966110 */     // No operand predicates
     /*  966110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966123 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  966123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  966145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966148 */     GIR_RootConstrainSelectedInstOperands,
     /*  966149 */     // GIR_Coverage, 8025,
     /*  966149 */     GIR_EraseRootFromParent_Done,
     /*  966150 */   // Label 14517: @966150
     /*  966150 */   GIM_Try, /*On fail goto*//*Label 14518*/ GIMT_Encode4(966245), // Rule ID 8028 //
     /*  966155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966205 */     // MIs[1] Operand 1
     /*  966205 */     // No operand predicates
     /*  966205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966218 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966243 */     GIR_RootConstrainSelectedInstOperands,
     /*  966244 */     // GIR_Coverage, 8028,
     /*  966244 */     GIR_EraseRootFromParent_Done,
     /*  966245 */   // Label 14518: @966245
     /*  966245 */   GIM_Try, /*On fail goto*//*Label 14519*/ GIMT_Encode4(966340), // Rule ID 8029 //
     /*  966250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  966267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966300 */     // MIs[1] Operand 1
     /*  966300 */     // No operand predicates
     /*  966300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966313 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966338 */     GIR_RootConstrainSelectedInstOperands,
     /*  966339 */     // GIR_Coverage, 8029,
     /*  966339 */     GIR_EraseRootFromParent_Done,
     /*  966340 */   // Label 14519: @966340
     /*  966340 */   GIM_Try, /*On fail goto*//*Label 14520*/ GIMT_Encode4(966435), // Rule ID 8032 //
     /*  966345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966395 */     // MIs[1] Operand 1
     /*  966395 */     // No operand predicates
     /*  966395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966433 */     GIR_RootConstrainSelectedInstOperands,
     /*  966434 */     // GIR_Coverage, 8032,
     /*  966434 */     GIR_EraseRootFromParent_Done,
     /*  966435 */   // Label 14520: @966435
     /*  966435 */   GIM_Try, /*On fail goto*//*Label 14521*/ GIMT_Encode4(966530), // Rule ID 8033 //
     /*  966440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  966457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966490 */     // MIs[1] Operand 1
     /*  966490 */     // No operand predicates
     /*  966490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966503 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966528 */     GIR_RootConstrainSelectedInstOperands,
     /*  966529 */     // GIR_Coverage, 8033,
     /*  966529 */     GIR_EraseRootFromParent_Done,
     /*  966530 */   // Label 14521: @966530
     /*  966530 */   GIM_Try, /*On fail goto*//*Label 14522*/ GIMT_Encode4(966625), // Rule ID 8036 //
     /*  966535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966585 */     // MIs[1] Operand 1
     /*  966585 */     // No operand predicates
     /*  966585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966598 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966623 */     GIR_RootConstrainSelectedInstOperands,
     /*  966624 */     // GIR_Coverage, 8036,
     /*  966624 */     GIR_EraseRootFromParent_Done,
     /*  966625 */   // Label 14522: @966625
     /*  966625 */   GIM_Try, /*On fail goto*//*Label 14523*/ GIMT_Encode4(966720), // Rule ID 8037 //
     /*  966630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966680 */     // MIs[1] Operand 1
     /*  966680 */     // No operand predicates
     /*  966680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966693 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966718 */     GIR_RootConstrainSelectedInstOperands,
     /*  966719 */     // GIR_Coverage, 8037,
     /*  966719 */     GIR_EraseRootFromParent_Done,
     /*  966720 */   // Label 14523: @966720
     /*  966720 */   GIM_Try, /*On fail goto*//*Label 14524*/ GIMT_Encode4(966815), // Rule ID 8040 //
     /*  966725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  966736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  966739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966775 */     // MIs[1] Operand 1
     /*  966775 */     // No operand predicates
     /*  966775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  966788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966813 */     GIR_RootConstrainSelectedInstOperands,
     /*  966814 */     // GIR_Coverage, 8040,
     /*  966814 */     GIR_EraseRootFromParent_Done,
     /*  966815 */   // Label 14524: @966815
     /*  966815 */   GIM_Try, /*On fail goto*//*Label 14525*/ GIMT_Encode4(966910), // Rule ID 8041 //
     /*  966820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  966831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  966834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966870 */     // MIs[1] Operand 1
     /*  966870 */     // No operand predicates
     /*  966870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966883 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  966883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966908 */     GIR_RootConstrainSelectedInstOperands,
     /*  966909 */     // GIR_Coverage, 8041,
     /*  966909 */     GIR_EraseRootFromParent_Done,
     /*  966910 */   // Label 14525: @966910
     /*  966910 */   GIM_Try, /*On fail goto*//*Label 14526*/ GIMT_Encode4(967005), // Rule ID 8044 //
     /*  966915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  966932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966965 */     // MIs[1] Operand 1
     /*  966965 */     // No operand predicates
     /*  966965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966978 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  966978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967003 */     GIR_RootConstrainSelectedInstOperands,
     /*  967004 */     // GIR_Coverage, 8044,
     /*  967004 */     GIR_EraseRootFromParent_Done,
     /*  967005 */   // Label 14526: @967005
     /*  967005 */   GIM_Try, /*On fail goto*//*Label 14527*/ GIMT_Encode4(967100), // Rule ID 8045 //
     /*  967010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  967027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967060 */     // MIs[1] Operand 1
     /*  967060 */     // No operand predicates
     /*  967060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967073 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967098 */     GIR_RootConstrainSelectedInstOperands,
     /*  967099 */     // GIR_Coverage, 8045,
     /*  967099 */     GIR_EraseRootFromParent_Done,
     /*  967100 */   // Label 14527: @967100
     /*  967100 */   GIM_Try, /*On fail goto*//*Label 14528*/ GIMT_Encode4(967195), // Rule ID 8048 //
     /*  967105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  967116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  967119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  967122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  967128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967155 */     // MIs[1] Operand 1
     /*  967155 */     // No operand predicates
     /*  967155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  967168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967193 */     GIR_RootConstrainSelectedInstOperands,
     /*  967194 */     // GIR_Coverage, 8048,
     /*  967194 */     GIR_EraseRootFromParent_Done,
     /*  967195 */   // Label 14528: @967195
     /*  967195 */   GIM_Try, /*On fail goto*//*Label 14529*/ GIMT_Encode4(967290), // Rule ID 8049 //
     /*  967200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  967211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  967214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  967217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  967223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967250 */     // MIs[1] Operand 1
     /*  967250 */     // No operand predicates
     /*  967250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967263 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  967263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  967285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967288 */     GIR_RootConstrainSelectedInstOperands,
     /*  967289 */     // GIR_Coverage, 8049,
     /*  967289 */     GIR_EraseRootFromParent_Done,
     /*  967290 */   // Label 14529: @967290
     /*  967290 */   GIM_Try, /*On fail goto*//*Label 14530*/ GIMT_Encode4(967385), // Rule ID 8052 //
     /*  967295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967345 */     // MIs[1] Operand 1
     /*  967345 */     // No operand predicates
     /*  967345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967358 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967383 */     GIR_RootConstrainSelectedInstOperands,
     /*  967384 */     // GIR_Coverage, 8052,
     /*  967384 */     GIR_EraseRootFromParent_Done,
     /*  967385 */   // Label 14530: @967385
     /*  967385 */   GIM_Try, /*On fail goto*//*Label 14531*/ GIMT_Encode4(967480), // Rule ID 8053 //
     /*  967390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  967407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  967428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967440 */     // MIs[1] Operand 1
     /*  967440 */     // No operand predicates
     /*  967440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967453 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  967456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967478 */     GIR_RootConstrainSelectedInstOperands,
     /*  967479 */     // GIR_Coverage, 8053,
     /*  967479 */     GIR_EraseRootFromParent_Done,
     /*  967480 */   // Label 14531: @967480
     /*  967480 */   GIM_Try, /*On fail goto*//*Label 14532*/ GIMT_Encode4(967575), // Rule ID 8056 //
     /*  967485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967535 */     // MIs[1] Operand 1
     /*  967535 */     // No operand predicates
     /*  967535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967573 */     GIR_RootConstrainSelectedInstOperands,
     /*  967574 */     // GIR_Coverage, 8056,
     /*  967574 */     GIR_EraseRootFromParent_Done,
     /*  967575 */   // Label 14532: @967575
     /*  967575 */   GIM_Try, /*On fail goto*//*Label 14533*/ GIMT_Encode4(967670), // Rule ID 8057 //
     /*  967580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967630 */     // MIs[1] Operand 1
     /*  967630 */     // No operand predicates
     /*  967630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967643 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967668 */     GIR_RootConstrainSelectedInstOperands,
     /*  967669 */     // GIR_Coverage, 8057,
     /*  967669 */     GIR_EraseRootFromParent_Done,
     /*  967670 */   // Label 14533: @967670
     /*  967670 */   GIM_Try, /*On fail goto*//*Label 14534*/ GIMT_Encode4(967765), // Rule ID 8060 //
     /*  967675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967725 */     // MIs[1] Operand 1
     /*  967725 */     // No operand predicates
     /*  967725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967763 */     GIR_RootConstrainSelectedInstOperands,
     /*  967764 */     // GIR_Coverage, 8060,
     /*  967764 */     GIR_EraseRootFromParent_Done,
     /*  967765 */   // Label 14534: @967765
     /*  967765 */   GIM_Try, /*On fail goto*//*Label 14535*/ GIMT_Encode4(967860), // Rule ID 8061 //
     /*  967770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967820 */     // MIs[1] Operand 1
     /*  967820 */     // No operand predicates
     /*  967820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967858 */     GIR_RootConstrainSelectedInstOperands,
     /*  967859 */     // GIR_Coverage, 8061,
     /*  967859 */     GIR_EraseRootFromParent_Done,
     /*  967860 */   // Label 14535: @967860
     /*  967860 */   GIM_Try, /*On fail goto*//*Label 14536*/ GIMT_Encode4(967955), // Rule ID 8240 //
     /*  967865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967915 */     // MIs[1] Operand 1
     /*  967915 */     // No operand predicates
     /*  967915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  967931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967953 */     GIR_RootConstrainSelectedInstOperands,
     /*  967954 */     // GIR_Coverage, 8240,
     /*  967954 */     GIR_EraseRootFromParent_Done,
     /*  967955 */   // Label 14536: @967955
     /*  967955 */   GIM_Try, /*On fail goto*//*Label 14537*/ GIMT_Encode4(968050), // Rule ID 8241 //
     /*  967960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968010 */     // MIs[1] Operand 1
     /*  968010 */     // No operand predicates
     /*  968010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968023 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  968026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968048 */     GIR_RootConstrainSelectedInstOperands,
     /*  968049 */     // GIR_Coverage, 8241,
     /*  968049 */     GIR_EraseRootFromParent_Done,
     /*  968050 */   // Label 14537: @968050
     /*  968050 */   GIM_Try, /*On fail goto*//*Label 14538*/ GIMT_Encode4(968145), // Rule ID 8244 //
     /*  968055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  968072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968105 */     // MIs[1] Operand 1
     /*  968105 */     // No operand predicates
     /*  968105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968118 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968143 */     GIR_RootConstrainSelectedInstOperands,
     /*  968144 */     // GIR_Coverage, 8244,
     /*  968144 */     GIR_EraseRootFromParent_Done,
     /*  968145 */   // Label 14538: @968145
     /*  968145 */   GIM_Try, /*On fail goto*//*Label 14539*/ GIMT_Encode4(968240), // Rule ID 8245 //
     /*  968150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  968167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968200 */     // MIs[1] Operand 1
     /*  968200 */     // No operand predicates
     /*  968200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968213 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968238 */     GIR_RootConstrainSelectedInstOperands,
     /*  968239 */     // GIR_Coverage, 8245,
     /*  968239 */     GIR_EraseRootFromParent_Done,
     /*  968240 */   // Label 14539: @968240
     /*  968240 */   GIM_Try, /*On fail goto*//*Label 14540*/ GIMT_Encode4(968335), // Rule ID 8248 //
     /*  968245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968295 */     // MIs[1] Operand 1
     /*  968295 */     // No operand predicates
     /*  968295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968308 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968333 */     GIR_RootConstrainSelectedInstOperands,
     /*  968334 */     // GIR_Coverage, 8248,
     /*  968334 */     GIR_EraseRootFromParent_Done,
     /*  968335 */   // Label 14540: @968335
     /*  968335 */   GIM_Try, /*On fail goto*//*Label 14541*/ GIMT_Encode4(968430), // Rule ID 8249 //
     /*  968340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  968357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968390 */     // MIs[1] Operand 1
     /*  968390 */     // No operand predicates
     /*  968390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968403 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968428 */     GIR_RootConstrainSelectedInstOperands,
     /*  968429 */     // GIR_Coverage, 8249,
     /*  968429 */     GIR_EraseRootFromParent_Done,
     /*  968430 */   // Label 14541: @968430
     /*  968430 */   GIM_Try, /*On fail goto*//*Label 14542*/ GIMT_Encode4(968525), // Rule ID 8252 //
     /*  968435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968485 */     // MIs[1] Operand 1
     /*  968485 */     // No operand predicates
     /*  968485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968498 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968523 */     GIR_RootConstrainSelectedInstOperands,
     /*  968524 */     // GIR_Coverage, 8252,
     /*  968524 */     GIR_EraseRootFromParent_Done,
     /*  968525 */   // Label 14542: @968525
     /*  968525 */   GIM_Try, /*On fail goto*//*Label 14543*/ GIMT_Encode4(968620), // Rule ID 8253 //
     /*  968530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968580 */     // MIs[1] Operand 1
     /*  968580 */     // No operand predicates
     /*  968580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968593 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968618 */     GIR_RootConstrainSelectedInstOperands,
     /*  968619 */     // GIR_Coverage, 8253,
     /*  968619 */     GIR_EraseRootFromParent_Done,
     /*  968620 */   // Label 14543: @968620
     /*  968620 */   GIM_Try, /*On fail goto*//*Label 14544*/ GIMT_Encode4(968715), // Rule ID 8256 //
     /*  968625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968675 */     // MIs[1] Operand 1
     /*  968675 */     // No operand predicates
     /*  968675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968688 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968713 */     GIR_RootConstrainSelectedInstOperands,
     /*  968714 */     // GIR_Coverage, 8256,
     /*  968714 */     GIR_EraseRootFromParent_Done,
     /*  968715 */   // Label 14544: @968715
     /*  968715 */   GIM_Try, /*On fail goto*//*Label 14545*/ GIMT_Encode4(968810), // Rule ID 8257 //
     /*  968720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968770 */     // MIs[1] Operand 1
     /*  968770 */     // No operand predicates
     /*  968770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968783 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968808 */     GIR_RootConstrainSelectedInstOperands,
     /*  968809 */     // GIR_Coverage, 8257,
     /*  968809 */     GIR_EraseRootFromParent_Done,
     /*  968810 */   // Label 14545: @968810
     /*  968810 */   GIM_Try, /*On fail goto*//*Label 14546*/ GIMT_Encode4(968905), // Rule ID 8260 //
     /*  968815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968865 */     // MIs[1] Operand 1
     /*  968865 */     // No operand predicates
     /*  968865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968878 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  968878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968903 */     GIR_RootConstrainSelectedInstOperands,
     /*  968904 */     // GIR_Coverage, 8260,
     /*  968904 */     GIR_EraseRootFromParent_Done,
     /*  968905 */   // Label 14546: @968905
     /*  968905 */   GIM_Try, /*On fail goto*//*Label 14547*/ GIMT_Encode4(969000), // Rule ID 8261 //
     /*  968910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968960 */     // MIs[1] Operand 1
     /*  968960 */     // No operand predicates
     /*  968960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968973 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  968973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968998 */     GIR_RootConstrainSelectedInstOperands,
     /*  968999 */     // GIR_Coverage, 8261,
     /*  968999 */     GIR_EraseRootFromParent_Done,
     /*  969000 */   // Label 14547: @969000
     /*  969000 */   GIM_Try, /*On fail goto*//*Label 14548*/ GIMT_Encode4(969095), // Rule ID 8264 //
     /*  969005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  969022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969055 */     // MIs[1] Operand 1
     /*  969055 */     // No operand predicates
     /*  969055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969093 */     GIR_RootConstrainSelectedInstOperands,
     /*  969094 */     // GIR_Coverage, 8264,
     /*  969094 */     GIR_EraseRootFromParent_Done,
     /*  969095 */   // Label 14548: @969095
     /*  969095 */   GIM_Try, /*On fail goto*//*Label 14549*/ GIMT_Encode4(969190), // Rule ID 8265 //
     /*  969100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  969117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969150 */     // MIs[1] Operand 1
     /*  969150 */     // No operand predicates
     /*  969150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969163 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969188 */     GIR_RootConstrainSelectedInstOperands,
     /*  969189 */     // GIR_Coverage, 8265,
     /*  969189 */     GIR_EraseRootFromParent_Done,
     /*  969190 */   // Label 14549: @969190
     /*  969190 */   GIM_Try, /*On fail goto*//*Label 14550*/ GIMT_Encode4(969285), // Rule ID 8268 //
     /*  969195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  969206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  969209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  969212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  969218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969245 */     // MIs[1] Operand 1
     /*  969245 */     // No operand predicates
     /*  969245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  969258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969283 */     GIR_RootConstrainSelectedInstOperands,
     /*  969284 */     // GIR_Coverage, 8268,
     /*  969284 */     GIR_EraseRootFromParent_Done,
     /*  969285 */   // Label 14550: @969285
     /*  969285 */   GIM_Try, /*On fail goto*//*Label 14551*/ GIMT_Encode4(969380), // Rule ID 8269 //
     /*  969290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  969301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  969304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  969307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  969313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969340 */     // MIs[1] Operand 1
     /*  969340 */     // No operand predicates
     /*  969340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969353 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969378 */     GIR_RootConstrainSelectedInstOperands,
     /*  969379 */     // GIR_Coverage, 8269,
     /*  969379 */     GIR_EraseRootFromParent_Done,
     /*  969380 */   // Label 14551: @969380
     /*  969380 */   GIM_Try, /*On fail goto*//*Label 14552*/ GIMT_Encode4(969475), // Rule ID 8272 //
     /*  969385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969435 */     // MIs[1] Operand 1
     /*  969435 */     // No operand predicates
     /*  969435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969448 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  969448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969473 */     GIR_RootConstrainSelectedInstOperands,
     /*  969474 */     // GIR_Coverage, 8272,
     /*  969474 */     GIR_EraseRootFromParent_Done,
     /*  969475 */   // Label 14552: @969475
     /*  969475 */   GIM_Try, /*On fail goto*//*Label 14553*/ GIMT_Encode4(969570), // Rule ID 8273 //
     /*  969480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  969491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  969494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  969497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  969503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969530 */     // MIs[1] Operand 1
     /*  969530 */     // No operand predicates
     /*  969530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969543 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  969543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969568 */     GIR_RootConstrainSelectedInstOperands,
     /*  969569 */     // GIR_Coverage, 8273,
     /*  969569 */     GIR_EraseRootFromParent_Done,
     /*  969570 */   // Label 14553: @969570
     /*  969570 */   GIM_Try, /*On fail goto*//*Label 14554*/ GIMT_Encode4(969665), // Rule ID 8276 //
     /*  969575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  969578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969625 */     // MIs[1] Operand 1
     /*  969625 */     // No operand predicates
     /*  969625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969638 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  969638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969663 */     GIR_RootConstrainSelectedInstOperands,
     /*  969664 */     // GIR_Coverage, 8276,
     /*  969664 */     GIR_EraseRootFromParent_Done,
     /*  969665 */   // Label 14554: @969665
     /*  969665 */   GIM_Try, /*On fail goto*//*Label 14555*/ GIMT_Encode4(969760), // Rule ID 8277 //
     /*  969670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  969673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969720 */     // MIs[1] Operand 1
     /*  969720 */     // No operand predicates
     /*  969720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969733 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  969733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969758 */     GIR_RootConstrainSelectedInstOperands,
     /*  969759 */     // GIR_Coverage, 8277,
     /*  969759 */     GIR_EraseRootFromParent_Done,
     /*  969760 */   // Label 14555: @969760
     /*  969760 */   GIM_Try, /*On fail goto*//*Label 14556*/ GIMT_Encode4(969855), // Rule ID 8280 //
     /*  969765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969815 */     // MIs[1] Operand 1
     /*  969815 */     // No operand predicates
     /*  969815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  969831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969853 */     GIR_RootConstrainSelectedInstOperands,
     /*  969854 */     // GIR_Coverage, 8280,
     /*  969854 */     GIR_EraseRootFromParent_Done,
     /*  969855 */   // Label 14556: @969855
     /*  969855 */   GIM_Try, /*On fail goto*//*Label 14557*/ GIMT_Encode4(969950), // Rule ID 8281 //
     /*  969860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969910 */     // MIs[1] Operand 1
     /*  969910 */     // No operand predicates
     /*  969910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969923 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  969926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969948 */     GIR_RootConstrainSelectedInstOperands,
     /*  969949 */     // GIR_Coverage, 8281,
     /*  969949 */     GIR_EraseRootFromParent_Done,
     /*  969950 */   // Label 14557: @969950
     /*  969950 */   GIM_Try, /*On fail goto*//*Label 14558*/ GIMT_Encode4(970045), // Rule ID 8284 //
     /*  969955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  969966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  969969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  969972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  969978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970005 */     // MIs[1] Operand 1
     /*  970005 */     // No operand predicates
     /*  970005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970018 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970043 */     GIR_RootConstrainSelectedInstOperands,
     /*  970044 */     // GIR_Coverage, 8284,
     /*  970044 */     GIR_EraseRootFromParent_Done,
     /*  970045 */   // Label 14558: @970045
     /*  970045 */   GIM_Try, /*On fail goto*//*Label 14559*/ GIMT_Encode4(970140), // Rule ID 8285 //
     /*  970050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  970067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970100 */     // MIs[1] Operand 1
     /*  970100 */     // No operand predicates
     /*  970100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970113 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970138 */     GIR_RootConstrainSelectedInstOperands,
     /*  970139 */     // GIR_Coverage, 8285,
     /*  970139 */     GIR_EraseRootFromParent_Done,
     /*  970140 */   // Label 14559: @970140
     /*  970140 */   GIM_Try, /*On fail goto*//*Label 14560*/ GIMT_Encode4(970235), // Rule ID 8288 //
     /*  970145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  970156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  970159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  970162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  970168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970195 */     // MIs[1] Operand 1
     /*  970195 */     // No operand predicates
     /*  970195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970208 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  970208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970233 */     GIR_RootConstrainSelectedInstOperands,
     /*  970234 */     // GIR_Coverage, 8288,
     /*  970234 */     GIR_EraseRootFromParent_Done,
     /*  970235 */   // Label 14560: @970235
     /*  970235 */   GIM_Try, /*On fail goto*//*Label 14561*/ GIMT_Encode4(970330), // Rule ID 8289 //
     /*  970240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  970251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  970254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  970257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  970263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970290 */     // MIs[1] Operand 1
     /*  970290 */     // No operand predicates
     /*  970290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970303 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  970303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  970325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970328 */     GIR_RootConstrainSelectedInstOperands,
     /*  970329 */     // GIR_Coverage, 8289,
     /*  970329 */     GIR_EraseRootFromParent_Done,
     /*  970330 */   // Label 14561: @970330
     /*  970330 */   GIM_Try, /*On fail goto*//*Label 14562*/ GIMT_Encode4(970425), // Rule ID 8292 //
     /*  970335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970385 */     // MIs[1] Operand 1
     /*  970385 */     // No operand predicates
     /*  970385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970398 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970423 */     GIR_RootConstrainSelectedInstOperands,
     /*  970424 */     // GIR_Coverage, 8292,
     /*  970424 */     GIR_EraseRootFromParent_Done,
     /*  970425 */   // Label 14562: @970425
     /*  970425 */   GIM_Try, /*On fail goto*//*Label 14563*/ GIMT_Encode4(970520), // Rule ID 8293 //
     /*  970430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  970447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970480 */     // MIs[1] Operand 1
     /*  970480 */     // No operand predicates
     /*  970480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970493 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970518 */     GIR_RootConstrainSelectedInstOperands,
     /*  970519 */     // GIR_Coverage, 8293,
     /*  970519 */     GIR_EraseRootFromParent_Done,
     /*  970520 */   // Label 14563: @970520
     /*  970520 */   GIM_Try, /*On fail goto*//*Label 14564*/ GIMT_Encode4(970615), // Rule ID 8296 //
     /*  970525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970575 */     // MIs[1] Operand 1
     /*  970575 */     // No operand predicates
     /*  970575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970588 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970613 */     GIR_RootConstrainSelectedInstOperands,
     /*  970614 */     // GIR_Coverage, 8296,
     /*  970614 */     GIR_EraseRootFromParent_Done,
     /*  970615 */   // Label 14564: @970615
     /*  970615 */   GIM_Try, /*On fail goto*//*Label 14565*/ GIMT_Encode4(970710), // Rule ID 8297 //
     /*  970620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970670 */     // MIs[1] Operand 1
     /*  970670 */     // No operand predicates
     /*  970670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970683 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970708 */     GIR_RootConstrainSelectedInstOperands,
     /*  970709 */     // GIR_Coverage, 8297,
     /*  970709 */     GIR_EraseRootFromParent_Done,
     /*  970710 */   // Label 14565: @970710
     /*  970710 */   GIM_Try, /*On fail goto*//*Label 14566*/ GIMT_Encode4(970805), // Rule ID 8300 //
     /*  970715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970765 */     // MIs[1] Operand 1
     /*  970765 */     // No operand predicates
     /*  970765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970778 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970803 */     GIR_RootConstrainSelectedInstOperands,
     /*  970804 */     // GIR_Coverage, 8300,
     /*  970804 */     GIR_EraseRootFromParent_Done,
     /*  970805 */   // Label 14566: @970805
     /*  970805 */   GIM_Try, /*On fail goto*//*Label 14567*/ GIMT_Encode4(970900), // Rule ID 8301 //
     /*  970810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970860 */     // MIs[1] Operand 1
     /*  970860 */     // No operand predicates
     /*  970860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970873 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970898 */     GIR_RootConstrainSelectedInstOperands,
     /*  970899 */     // GIR_Coverage, 8301,
     /*  970899 */     GIR_EraseRootFromParent_Done,
     /*  970900 */   // Label 14567: @970900
     /*  970900 */   GIM_Try, /*On fail goto*//*Label 14568*/ GIMT_Encode4(970995), // Rule ID 8304 //
     /*  970905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  970916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  970919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  970922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  970928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970955 */     // MIs[1] Operand 1
     /*  970955 */     // No operand predicates
     /*  970955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970968 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  970968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970993 */     GIR_RootConstrainSelectedInstOperands,
     /*  970994 */     // GIR_Coverage, 8304,
     /*  970994 */     GIR_EraseRootFromParent_Done,
     /*  970995 */   // Label 14568: @970995
     /*  970995 */   GIM_Try, /*On fail goto*//*Label 14569*/ GIMT_Encode4(971090), // Rule ID 8305 //
     /*  971000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  971017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971050 */     // MIs[1] Operand 1
     /*  971050 */     // No operand predicates
     /*  971050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971063 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971088 */     GIR_RootConstrainSelectedInstOperands,
     /*  971089 */     // GIR_Coverage, 8305,
     /*  971089 */     GIR_EraseRootFromParent_Done,
     /*  971090 */   // Label 14569: @971090
     /*  971090 */   GIM_Try, /*On fail goto*//*Label 14570*/ GIMT_Encode4(971185), // Rule ID 8308 //
     /*  971095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971145 */     // MIs[1] Operand 1
     /*  971145 */     // No operand predicates
     /*  971145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971158 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971183 */     GIR_RootConstrainSelectedInstOperands,
     /*  971184 */     // GIR_Coverage, 8308,
     /*  971184 */     GIR_EraseRootFromParent_Done,
     /*  971185 */   // Label 14570: @971185
     /*  971185 */   GIM_Try, /*On fail goto*//*Label 14571*/ GIMT_Encode4(971280), // Rule ID 8309 //
     /*  971190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  971207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971240 */     // MIs[1] Operand 1
     /*  971240 */     // No operand predicates
     /*  971240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971253 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971278 */     GIR_RootConstrainSelectedInstOperands,
     /*  971279 */     // GIR_Coverage, 8309,
     /*  971279 */     GIR_EraseRootFromParent_Done,
     /*  971280 */   // Label 14571: @971280
     /*  971280 */   GIM_Try, /*On fail goto*//*Label 14572*/ GIMT_Encode4(971375), // Rule ID 8312 //
     /*  971285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971335 */     // MIs[1] Operand 1
     /*  971335 */     // No operand predicates
     /*  971335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  971348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971373 */     GIR_RootConstrainSelectedInstOperands,
     /*  971374 */     // GIR_Coverage, 8312,
     /*  971374 */     GIR_EraseRootFromParent_Done,
     /*  971375 */   // Label 14572: @971375
     /*  971375 */   GIM_Try, /*On fail goto*//*Label 14573*/ GIMT_Encode4(971470), // Rule ID 8313 //
     /*  971380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  971391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  971394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  971397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  971403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971430 */     // MIs[1] Operand 1
     /*  971430 */     // No operand predicates
     /*  971430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971443 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  971443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  971465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971468 */     GIR_RootConstrainSelectedInstOperands,
     /*  971469 */     // GIR_Coverage, 8313,
     /*  971469 */     GIR_EraseRootFromParent_Done,
     /*  971470 */   // Label 14573: @971470
     /*  971470 */   GIM_Try, /*On fail goto*//*Label 14574*/ GIMT_Encode4(971565), // Rule ID 8316 //
     /*  971475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971525 */     // MIs[1] Operand 1
     /*  971525 */     // No operand predicates
     /*  971525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971538 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971563 */     GIR_RootConstrainSelectedInstOperands,
     /*  971564 */     // GIR_Coverage, 8316,
     /*  971564 */     GIR_EraseRootFromParent_Done,
     /*  971565 */   // Label 14574: @971565
     /*  971565 */   GIM_Try, /*On fail goto*//*Label 14575*/ GIMT_Encode4(971660), // Rule ID 8317 //
     /*  971570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971620 */     // MIs[1] Operand 1
     /*  971620 */     // No operand predicates
     /*  971620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971633 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971658 */     GIR_RootConstrainSelectedInstOperands,
     /*  971659 */     // GIR_Coverage, 8317,
     /*  971659 */     GIR_EraseRootFromParent_Done,
     /*  971660 */   // Label 14575: @971660
     /*  971660 */   GIM_Try, /*On fail goto*//*Label 14576*/ GIMT_Encode4(971755), // Rule ID 8320 //
     /*  971665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971715 */     // MIs[1] Operand 1
     /*  971715 */     // No operand predicates
     /*  971715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971728 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971753 */     GIR_RootConstrainSelectedInstOperands,
     /*  971754 */     // GIR_Coverage, 8320,
     /*  971754 */     GIR_EraseRootFromParent_Done,
     /*  971755 */   // Label 14576: @971755
     /*  971755 */   GIM_Try, /*On fail goto*//*Label 14577*/ GIMT_Encode4(971850), // Rule ID 8321 //
     /*  971760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971810 */     // MIs[1] Operand 1
     /*  971810 */     // No operand predicates
     /*  971810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971823 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971848 */     GIR_RootConstrainSelectedInstOperands,
     /*  971849 */     // GIR_Coverage, 8321,
     /*  971849 */     GIR_EraseRootFromParent_Done,
     /*  971850 */   // Label 14577: @971850
     /*  971850 */   GIM_Try, /*On fail goto*//*Label 14578*/ GIMT_Encode4(971945), // Rule ID 8324 //
     /*  971855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971905 */     // MIs[1] Operand 1
     /*  971905 */     // No operand predicates
     /*  971905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971943 */     GIR_RootConstrainSelectedInstOperands,
     /*  971944 */     // GIR_Coverage, 8324,
     /*  971944 */     GIR_EraseRootFromParent_Done,
     /*  971945 */   // Label 14578: @971945
     /*  971945 */   GIM_Try, /*On fail goto*//*Label 14579*/ GIMT_Encode4(972040), // Rule ID 8325 //
     /*  971950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972000 */     // MIs[1] Operand 1
     /*  972000 */     // No operand predicates
     /*  972000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972013 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  972013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  972016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  972035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972038 */     GIR_RootConstrainSelectedInstOperands,
     /*  972039 */     // GIR_Coverage, 8325,
     /*  972039 */     GIR_EraseRootFromParent_Done,
     /*  972040 */   // Label 14579: @972040
     /*  972040 */   GIM_Try, /*On fail goto*//*Label 14580*/ GIMT_Encode4(972135), // Rule ID 8856 //
     /*  972045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  972062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972095 */     // MIs[1] Operand 1
     /*  972095 */     // No operand predicates
     /*  972095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972108 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  972111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972133 */     GIR_RootConstrainSelectedInstOperands,
     /*  972134 */     // GIR_Coverage, 8856,
     /*  972134 */     GIR_EraseRootFromParent_Done,
     /*  972135 */   // Label 14580: @972135
     /*  972135 */   GIM_Try, /*On fail goto*//*Label 14581*/ GIMT_Encode4(972230), // Rule ID 8857 //
     /*  972140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  972157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972190 */     // MIs[1] Operand 1
     /*  972190 */     // No operand predicates
     /*  972190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972203 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  972206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972228 */     GIR_RootConstrainSelectedInstOperands,
     /*  972229 */     // GIR_Coverage, 8857,
     /*  972229 */     GIR_EraseRootFromParent_Done,
     /*  972230 */   // Label 14581: @972230
     /*  972230 */   GIM_Try, /*On fail goto*//*Label 14582*/ GIMT_Encode4(972325), // Rule ID 8860 //
     /*  972235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972285 */     // MIs[1] Operand 1
     /*  972285 */     // No operand predicates
     /*  972285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972298 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972323 */     GIR_RootConstrainSelectedInstOperands,
     /*  972324 */     // GIR_Coverage, 8860,
     /*  972324 */     GIR_EraseRootFromParent_Done,
     /*  972325 */   // Label 14582: @972325
     /*  972325 */   GIM_Try, /*On fail goto*//*Label 14583*/ GIMT_Encode4(972420), // Rule ID 8861 //
     /*  972330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  972347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972380 */     // MIs[1] Operand 1
     /*  972380 */     // No operand predicates
     /*  972380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972393 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972418 */     GIR_RootConstrainSelectedInstOperands,
     /*  972419 */     // GIR_Coverage, 8861,
     /*  972419 */     GIR_EraseRootFromParent_Done,
     /*  972420 */   // Label 14583: @972420
     /*  972420 */   GIM_Try, /*On fail goto*//*Label 14584*/ GIMT_Encode4(972515), // Rule ID 8864 //
     /*  972425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972475 */     // MIs[1] Operand 1
     /*  972475 */     // No operand predicates
     /*  972475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972513 */     GIR_RootConstrainSelectedInstOperands,
     /*  972514 */     // GIR_Coverage, 8864,
     /*  972514 */     GIR_EraseRootFromParent_Done,
     /*  972515 */   // Label 14584: @972515
     /*  972515 */   GIM_Try, /*On fail goto*//*Label 14585*/ GIMT_Encode4(972610), // Rule ID 8865 //
     /*  972520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972570 */     // MIs[1] Operand 1
     /*  972570 */     // No operand predicates
     /*  972570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972583 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972608 */     GIR_RootConstrainSelectedInstOperands,
     /*  972609 */     // GIR_Coverage, 8865,
     /*  972609 */     GIR_EraseRootFromParent_Done,
     /*  972610 */   // Label 14585: @972610
     /*  972610 */   GIM_Try, /*On fail goto*//*Label 14586*/ GIMT_Encode4(972705), // Rule ID 8868 //
     /*  972615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972665 */     // MIs[1] Operand 1
     /*  972665 */     // No operand predicates
     /*  972665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972678 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972703 */     GIR_RootConstrainSelectedInstOperands,
     /*  972704 */     // GIR_Coverage, 8868,
     /*  972704 */     GIR_EraseRootFromParent_Done,
     /*  972705 */   // Label 14586: @972705
     /*  972705 */   GIM_Try, /*On fail goto*//*Label 14587*/ GIMT_Encode4(972800), // Rule ID 8869 //
     /*  972710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972760 */     // MIs[1] Operand 1
     /*  972760 */     // No operand predicates
     /*  972760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972773 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972798 */     GIR_RootConstrainSelectedInstOperands,
     /*  972799 */     // GIR_Coverage, 8869,
     /*  972799 */     GIR_EraseRootFromParent_Done,
     /*  972800 */   // Label 14587: @972800
     /*  972800 */   GIM_Try, /*On fail goto*//*Label 14588*/ GIMT_Encode4(972895), // Rule ID 8872 //
     /*  972805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972855 */     // MIs[1] Operand 1
     /*  972855 */     // No operand predicates
     /*  972855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972868 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972893 */     GIR_RootConstrainSelectedInstOperands,
     /*  972894 */     // GIR_Coverage, 8872,
     /*  972894 */     GIR_EraseRootFromParent_Done,
     /*  972895 */   // Label 14588: @972895
     /*  972895 */   GIM_Try, /*On fail goto*//*Label 14589*/ GIMT_Encode4(972990), // Rule ID 8873 //
     /*  972900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972950 */     // MIs[1] Operand 1
     /*  972950 */     // No operand predicates
     /*  972950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972963 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972988 */     GIR_RootConstrainSelectedInstOperands,
     /*  972989 */     // GIR_Coverage, 8873,
     /*  972989 */     GIR_EraseRootFromParent_Done,
     /*  972990 */   // Label 14589: @972990
     /*  972990 */   GIM_Try, /*On fail goto*//*Label 14590*/ GIMT_Encode4(973085), // Rule ID 8876 //
     /*  972995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  973012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973045 */     // MIs[1] Operand 1
     /*  973045 */     // No operand predicates
     /*  973045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973058 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  973058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973083 */     GIR_RootConstrainSelectedInstOperands,
     /*  973084 */     // GIR_Coverage, 8876,
     /*  973084 */     GIR_EraseRootFromParent_Done,
     /*  973085 */   // Label 14590: @973085
     /*  973085 */   GIM_Try, /*On fail goto*//*Label 14591*/ GIMT_Encode4(973180), // Rule ID 8877 //
     /*  973090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  973107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973140 */     // MIs[1] Operand 1
     /*  973140 */     // No operand predicates
     /*  973140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973153 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  973153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  973156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973178 */     GIR_RootConstrainSelectedInstOperands,
     /*  973179 */     // GIR_Coverage, 8877,
     /*  973179 */     GIR_EraseRootFromParent_Done,
     /*  973180 */   // Label 14591: @973180
     /*  973180 */   GIM_Try, /*On fail goto*//*Label 14592*/ GIMT_Encode4(973275), // Rule ID 8880 //
     /*  973185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  973196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  973199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  973202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  973208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973235 */     // MIs[1] Operand 1
     /*  973235 */     // No operand predicates
     /*  973235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973273 */     GIR_RootConstrainSelectedInstOperands,
     /*  973274 */     // GIR_Coverage, 8880,
     /*  973274 */     GIR_EraseRootFromParent_Done,
     /*  973275 */   // Label 14592: @973275
     /*  973275 */   GIM_Try, /*On fail goto*//*Label 14593*/ GIMT_Encode4(973370), // Rule ID 8881 //
     /*  973280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  973291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  973294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  973297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  973303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973330 */     // MIs[1] Operand 1
     /*  973330 */     // No operand predicates
     /*  973330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973343 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973368 */     GIR_RootConstrainSelectedInstOperands,
     /*  973369 */     // GIR_Coverage, 8881,
     /*  973369 */     GIR_EraseRootFromParent_Done,
     /*  973370 */   // Label 14593: @973370
     /*  973370 */   GIM_Try, /*On fail goto*//*Label 14594*/ GIMT_Encode4(973465), // Rule ID 8884 //
     /*  973375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973425 */     // MIs[1] Operand 1
     /*  973425 */     // No operand predicates
     /*  973425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  973438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973463 */     GIR_RootConstrainSelectedInstOperands,
     /*  973464 */     // GIR_Coverage, 8884,
     /*  973464 */     GIR_EraseRootFromParent_Done,
     /*  973465 */   // Label 14594: @973465
     /*  973465 */   GIM_Try, /*On fail goto*//*Label 14595*/ GIMT_Encode4(973560), // Rule ID 8885 //
     /*  973470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  973481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  973484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  973487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  973493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973520 */     // MIs[1] Operand 1
     /*  973520 */     // No operand predicates
     /*  973520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973533 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973558 */     GIR_RootConstrainSelectedInstOperands,
     /*  973559 */     // GIR_Coverage, 8885,
     /*  973559 */     GIR_EraseRootFromParent_Done,
     /*  973560 */   // Label 14595: @973560
     /*  973560 */   GIM_Try, /*On fail goto*//*Label 14596*/ GIMT_Encode4(973655), // Rule ID 8888 //
     /*  973565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973615 */     // MIs[1] Operand 1
     /*  973615 */     // No operand predicates
     /*  973615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973628 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  973628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973653 */     GIR_RootConstrainSelectedInstOperands,
     /*  973654 */     // GIR_Coverage, 8888,
     /*  973654 */     GIR_EraseRootFromParent_Done,
     /*  973655 */   // Label 14596: @973655
     /*  973655 */   GIM_Try, /*On fail goto*//*Label 14597*/ GIMT_Encode4(973750), // Rule ID 8889 //
     /*  973660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973710 */     // MIs[1] Operand 1
     /*  973710 */     // No operand predicates
     /*  973710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973723 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  973723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973748 */     GIR_RootConstrainSelectedInstOperands,
     /*  973749 */     // GIR_Coverage, 8889,
     /*  973749 */     GIR_EraseRootFromParent_Done,
     /*  973750 */   // Label 14597: @973750
     /*  973750 */   GIM_Try, /*On fail goto*//*Label 14598*/ GIMT_Encode4(973845), // Rule ID 8892 //
     /*  973755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  973758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973805 */     // MIs[1] Operand 1
     /*  973805 */     // No operand predicates
     /*  973805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973818 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  973818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973843 */     GIR_RootConstrainSelectedInstOperands,
     /*  973844 */     // GIR_Coverage, 8892,
     /*  973844 */     GIR_EraseRootFromParent_Done,
     /*  973845 */   // Label 14598: @973845
     /*  973845 */   GIM_Try, /*On fail goto*//*Label 14599*/ GIMT_Encode4(973940), // Rule ID 8893 //
     /*  973850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  973853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973900 */     // MIs[1] Operand 1
     /*  973900 */     // No operand predicates
     /*  973900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973913 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  973913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973938 */     GIR_RootConstrainSelectedInstOperands,
     /*  973939 */     // GIR_Coverage, 8893,
     /*  973939 */     GIR_EraseRootFromParent_Done,
     /*  973940 */   // Label 14599: @973940
     /*  973940 */   GIM_Try, /*On fail goto*//*Label 14600*/ GIMT_Encode4(974035), // Rule ID 8896 //
     /*  973945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  973956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  973959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  973962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  973968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973995 */     // MIs[1] Operand 1
     /*  973995 */     // No operand predicates
     /*  973995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974033 */     GIR_RootConstrainSelectedInstOperands,
     /*  974034 */     // GIR_Coverage, 8896,
     /*  974034 */     GIR_EraseRootFromParent_Done,
     /*  974035 */   // Label 14600: @974035
     /*  974035 */   GIM_Try, /*On fail goto*//*Label 14601*/ GIMT_Encode4(974130), // Rule ID 8897 //
     /*  974040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  974057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974090 */     // MIs[1] Operand 1
     /*  974090 */     // No operand predicates
     /*  974090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974103 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974128 */     GIR_RootConstrainSelectedInstOperands,
     /*  974129 */     // GIR_Coverage, 8897,
     /*  974129 */     GIR_EraseRootFromParent_Done,
     /*  974130 */   // Label 14601: @974130
     /*  974130 */   GIM_Try, /*On fail goto*//*Label 14602*/ GIMT_Encode4(974225), // Rule ID 8900 //
     /*  974135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  974152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974185 */     // MIs[1] Operand 1
     /*  974185 */     // No operand predicates
     /*  974185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974198 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974223 */     GIR_RootConstrainSelectedInstOperands,
     /*  974224 */     // GIR_Coverage, 8900,
     /*  974224 */     GIR_EraseRootFromParent_Done,
     /*  974225 */   // Label 14602: @974225
     /*  974225 */   GIM_Try, /*On fail goto*//*Label 14603*/ GIMT_Encode4(974320), // Rule ID 8901 //
     /*  974230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  974247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974280 */     // MIs[1] Operand 1
     /*  974280 */     // No operand predicates
     /*  974280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974293 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974318 */     GIR_RootConstrainSelectedInstOperands,
     /*  974319 */     // GIR_Coverage, 8901,
     /*  974319 */     GIR_EraseRootFromParent_Done,
     /*  974320 */   // Label 14603: @974320
     /*  974320 */   GIM_Try, /*On fail goto*//*Label 14604*/ GIMT_Encode4(974415), // Rule ID 8904 //
     /*  974325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974375 */     // MIs[1] Operand 1
     /*  974375 */     // No operand predicates
     /*  974375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974388 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  974388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974413 */     GIR_RootConstrainSelectedInstOperands,
     /*  974414 */     // GIR_Coverage, 8904,
     /*  974414 */     GIR_EraseRootFromParent_Done,
     /*  974415 */   // Label 14604: @974415
     /*  974415 */   GIM_Try, /*On fail goto*//*Label 14605*/ GIMT_Encode4(974510), // Rule ID 8905 //
     /*  974420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  974431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  974434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  974437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  974443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974470 */     // MIs[1] Operand 1
     /*  974470 */     // No operand predicates
     /*  974470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974483 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  974483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  974505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974508 */     GIR_RootConstrainSelectedInstOperands,
     /*  974509 */     // GIR_Coverage, 8905,
     /*  974509 */     GIR_EraseRootFromParent_Done,
     /*  974510 */   // Label 14605: @974510
     /*  974510 */   GIM_Try, /*On fail goto*//*Label 14606*/ GIMT_Encode4(974605), // Rule ID 8908 //
     /*  974515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974565 */     // MIs[1] Operand 1
     /*  974565 */     // No operand predicates
     /*  974565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974578 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974603 */     GIR_RootConstrainSelectedInstOperands,
     /*  974604 */     // GIR_Coverage, 8908,
     /*  974604 */     GIR_EraseRootFromParent_Done,
     /*  974605 */   // Label 14606: @974605
     /*  974605 */   GIM_Try, /*On fail goto*//*Label 14607*/ GIMT_Encode4(974700), // Rule ID 8909 //
     /*  974610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974660 */     // MIs[1] Operand 1
     /*  974660 */     // No operand predicates
     /*  974660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974673 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974698 */     GIR_RootConstrainSelectedInstOperands,
     /*  974699 */     // GIR_Coverage, 8909,
     /*  974699 */     GIR_EraseRootFromParent_Done,
     /*  974700 */   // Label 14607: @974700
     /*  974700 */   GIM_Try, /*On fail goto*//*Label 14608*/ GIMT_Encode4(974795), // Rule ID 8912 //
     /*  974705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974755 */     // MIs[1] Operand 1
     /*  974755 */     // No operand predicates
     /*  974755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974768 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974793 */     GIR_RootConstrainSelectedInstOperands,
     /*  974794 */     // GIR_Coverage, 8912,
     /*  974794 */     GIR_EraseRootFromParent_Done,
     /*  974795 */   // Label 14608: @974795
     /*  974795 */   GIM_Try, /*On fail goto*//*Label 14609*/ GIMT_Encode4(974890), // Rule ID 8913 //
     /*  974800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974850 */     // MIs[1] Operand 1
     /*  974850 */     // No operand predicates
     /*  974850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974863 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974888 */     GIR_RootConstrainSelectedInstOperands,
     /*  974889 */     // GIR_Coverage, 8913,
     /*  974889 */     GIR_EraseRootFromParent_Done,
     /*  974890 */   // Label 14609: @974890
     /*  974890 */   GIM_Try, /*On fail goto*//*Label 14610*/ GIMT_Encode4(974985), // Rule ID 8916 //
     /*  974895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974945 */     // MIs[1] Operand 1
     /*  974945 */     // No operand predicates
     /*  974945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974958 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974983 */     GIR_RootConstrainSelectedInstOperands,
     /*  974984 */     // GIR_Coverage, 8916,
     /*  974984 */     GIR_EraseRootFromParent_Done,
     /*  974985 */   // Label 14610: @974985
     /*  974985 */   GIM_Try, /*On fail goto*//*Label 14611*/ GIMT_Encode4(975080), // Rule ID 8917 //
     /*  974990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  975001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  975004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  975007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  975013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975040 */     // MIs[1] Operand 1
     /*  975040 */     // No operand predicates
     /*  975040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975053 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  975053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  975075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975078 */     GIR_RootConstrainSelectedInstOperands,
     /*  975079 */     // GIR_Coverage, 8917,
     /*  975079 */     GIR_EraseRootFromParent_Done,
     /*  975080 */   // Label 14611: @975080
     /*  975080 */   GIM_Try, /*On fail goto*//*Label 14612*/ GIMT_Encode4(975175), // Rule ID 8920 //
     /*  975085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  975102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975135 */     // MIs[1] Operand 1
     /*  975135 */     // No operand predicates
     /*  975135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975148 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975173 */     GIR_RootConstrainSelectedInstOperands,
     /*  975174 */     // GIR_Coverage, 8920,
     /*  975174 */     GIR_EraseRootFromParent_Done,
     /*  975175 */   // Label 14612: @975175
     /*  975175 */   GIM_Try, /*On fail goto*//*Label 14613*/ GIMT_Encode4(975270), // Rule ID 8921 //
     /*  975180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  975197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975230 */     // MIs[1] Operand 1
     /*  975230 */     // No operand predicates
     /*  975230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975243 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975268 */     GIR_RootConstrainSelectedInstOperands,
     /*  975269 */     // GIR_Coverage, 8921,
     /*  975269 */     GIR_EraseRootFromParent_Done,
     /*  975270 */   // Label 14613: @975270
     /*  975270 */   GIM_Try, /*On fail goto*//*Label 14614*/ GIMT_Encode4(975365), // Rule ID 8924 //
     /*  975275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975325 */     // MIs[1] Operand 1
     /*  975325 */     // No operand predicates
     /*  975325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975338 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975363 */     GIR_RootConstrainSelectedInstOperands,
     /*  975364 */     // GIR_Coverage, 8924,
     /*  975364 */     GIR_EraseRootFromParent_Done,
     /*  975365 */   // Label 14614: @975365
     /*  975365 */   GIM_Try, /*On fail goto*//*Label 14615*/ GIMT_Encode4(975460), // Rule ID 8925 //
     /*  975370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  975387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975420 */     // MIs[1] Operand 1
     /*  975420 */     // No operand predicates
     /*  975420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975433 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975458 */     GIR_RootConstrainSelectedInstOperands,
     /*  975459 */     // GIR_Coverage, 8925,
     /*  975459 */     GIR_EraseRootFromParent_Done,
     /*  975460 */   // Label 14615: @975460
     /*  975460 */   GIM_Try, /*On fail goto*//*Label 14616*/ GIMT_Encode4(975555), // Rule ID 8928 //
     /*  975465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975515 */     // MIs[1] Operand 1
     /*  975515 */     // No operand predicates
     /*  975515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975553 */     GIR_RootConstrainSelectedInstOperands,
     /*  975554 */     // GIR_Coverage, 8928,
     /*  975554 */     GIR_EraseRootFromParent_Done,
     /*  975555 */   // Label 14616: @975555
     /*  975555 */   GIM_Try, /*On fail goto*//*Label 14617*/ GIMT_Encode4(975650), // Rule ID 8929 //
     /*  975560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975610 */     // MIs[1] Operand 1
     /*  975610 */     // No operand predicates
     /*  975610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975623 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975648 */     GIR_RootConstrainSelectedInstOperands,
     /*  975649 */     // GIR_Coverage, 8929,
     /*  975649 */     GIR_EraseRootFromParent_Done,
     /*  975650 */   // Label 14617: @975650
     /*  975650 */   GIM_Try, /*On fail goto*//*Label 14618*/ GIMT_Encode4(975745), // Rule ID 8932 //
     /*  975655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975705 */     // MIs[1] Operand 1
     /*  975705 */     // No operand predicates
     /*  975705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975718 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975743 */     GIR_RootConstrainSelectedInstOperands,
     /*  975744 */     // GIR_Coverage, 8932,
     /*  975744 */     GIR_EraseRootFromParent_Done,
     /*  975745 */   // Label 14618: @975745
     /*  975745 */   GIM_Try, /*On fail goto*//*Label 14619*/ GIMT_Encode4(975840), // Rule ID 8933 //
     /*  975750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975800 */     // MIs[1] Operand 1
     /*  975800 */     // No operand predicates
     /*  975800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975813 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975838 */     GIR_RootConstrainSelectedInstOperands,
     /*  975839 */     // GIR_Coverage, 8933,
     /*  975839 */     GIR_EraseRootFromParent_Done,
     /*  975840 */   // Label 14619: @975840
     /*  975840 */   GIM_Try, /*On fail goto*//*Label 14620*/ GIMT_Encode4(975935), // Rule ID 8936 //
     /*  975845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975895 */     // MIs[1] Operand 1
     /*  975895 */     // No operand predicates
     /*  975895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975908 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975933 */     GIR_RootConstrainSelectedInstOperands,
     /*  975934 */     // GIR_Coverage, 8936,
     /*  975934 */     GIR_EraseRootFromParent_Done,
     /*  975935 */   // Label 14620: @975935
     /*  975935 */   GIM_Try, /*On fail goto*//*Label 14621*/ GIMT_Encode4(976030), // Rule ID 8937 //
     /*  975940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975990 */     // MIs[1] Operand 1
     /*  975990 */     // No operand predicates
     /*  975990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976003 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  976006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976028 */     GIR_RootConstrainSelectedInstOperands,
     /*  976029 */     // GIR_Coverage, 8937,
     /*  976029 */     GIR_EraseRootFromParent_Done,
     /*  976030 */   // Label 14621: @976030
     /*  976030 */   GIM_Try, /*On fail goto*//*Label 14622*/ GIMT_Encode4(976125), // Rule ID 8940 //
     /*  976035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  976038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  976052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976085 */     // MIs[1] Operand 1
     /*  976085 */     // No operand predicates
     /*  976085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976098 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  976098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976123 */     GIR_RootConstrainSelectedInstOperands,
     /*  976124 */     // GIR_Coverage, 8940,
     /*  976124 */     GIR_EraseRootFromParent_Done,
     /*  976125 */   // Label 14622: @976125
     /*  976125 */   GIM_Try, /*On fail goto*//*Label 14623*/ GIMT_Encode4(976220), // Rule ID 8941 //
     /*  976130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  976133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  976138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  976147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  976168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976180 */     // MIs[1] Operand 1
     /*  976180 */     // No operand predicates
     /*  976180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976193 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  976193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  976196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  976215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976218 */     GIR_RootConstrainSelectedInstOperands,
     /*  976219 */     // GIR_Coverage, 8941,
     /*  976219 */     GIR_EraseRootFromParent_Done,
     /*  976220 */   // Label 14623: @976220
     /*  976220 */   GIM_Try, /*On fail goto*//*Label 14624*/ GIMT_Encode4(976315), // Rule ID 9120 //
     /*  976225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976275 */     // MIs[1] Operand 1
     /*  976275 */     // No operand predicates
     /*  976275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976288 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  976291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976313 */     GIR_RootConstrainSelectedInstOperands,
     /*  976314 */     // GIR_Coverage, 9120,
     /*  976314 */     GIR_EraseRootFromParent_Done,
     /*  976315 */   // Label 14624: @976315
     /*  976315 */   GIM_Try, /*On fail goto*//*Label 14625*/ GIMT_Encode4(976410), // Rule ID 9121 //
     /*  976320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  976337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976370 */     // MIs[1] Operand 1
     /*  976370 */     // No operand predicates
     /*  976370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976383 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  976386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976408 */     GIR_RootConstrainSelectedInstOperands,
     /*  976409 */     // GIR_Coverage, 9121,
     /*  976409 */     GIR_EraseRootFromParent_Done,
     /*  976410 */   // Label 14625: @976410
     /*  976410 */   GIM_Try, /*On fail goto*//*Label 14626*/ GIMT_Encode4(976505), // Rule ID 9124 //
     /*  976415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976465 */     // MIs[1] Operand 1
     /*  976465 */     // No operand predicates
     /*  976465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976478 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976503 */     GIR_RootConstrainSelectedInstOperands,
     /*  976504 */     // GIR_Coverage, 9124,
     /*  976504 */     GIR_EraseRootFromParent_Done,
     /*  976505 */   // Label 14626: @976505
     /*  976505 */   GIM_Try, /*On fail goto*//*Label 14627*/ GIMT_Encode4(976600), // Rule ID 9125 //
     /*  976510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976560 */     // MIs[1] Operand 1
     /*  976560 */     // No operand predicates
     /*  976560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976573 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976582 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976598 */     GIR_RootConstrainSelectedInstOperands,
     /*  976599 */     // GIR_Coverage, 9125,
     /*  976599 */     GIR_EraseRootFromParent_Done,
     /*  976600 */   // Label 14627: @976600
     /*  976600 */   GIM_Try, /*On fail goto*//*Label 14628*/ GIMT_Encode4(976695), // Rule ID 9128 //
     /*  976605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976655 */     // MIs[1] Operand 1
     /*  976655 */     // No operand predicates
     /*  976655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976693 */     GIR_RootConstrainSelectedInstOperands,
     /*  976694 */     // GIR_Coverage, 9128,
     /*  976694 */     GIR_EraseRootFromParent_Done,
     /*  976695 */   // Label 14628: @976695
     /*  976695 */   GIM_Try, /*On fail goto*//*Label 14629*/ GIMT_Encode4(976790), // Rule ID 9129 //
     /*  976700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976750 */     // MIs[1] Operand 1
     /*  976750 */     // No operand predicates
     /*  976750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976763 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976788 */     GIR_RootConstrainSelectedInstOperands,
     /*  976789 */     // GIR_Coverage, 9129,
     /*  976789 */     GIR_EraseRootFromParent_Done,
     /*  976790 */   // Label 14629: @976790
     /*  976790 */   GIM_Try, /*On fail goto*//*Label 14630*/ GIMT_Encode4(976885), // Rule ID 9132 //
     /*  976795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976845 */     // MIs[1] Operand 1
     /*  976845 */     // No operand predicates
     /*  976845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976858 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  976858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976883 */     GIR_RootConstrainSelectedInstOperands,
     /*  976884 */     // GIR_Coverage, 9132,
     /*  976884 */     GIR_EraseRootFromParent_Done,
     /*  976885 */   // Label 14630: @976885
     /*  976885 */   GIM_Try, /*On fail goto*//*Label 14631*/ GIMT_Encode4(976980), // Rule ID 9133 //
     /*  976890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976940 */     // MIs[1] Operand 1
     /*  976940 */     // No operand predicates
     /*  976940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976953 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  976953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976978 */     GIR_RootConstrainSelectedInstOperands,
     /*  976979 */     // GIR_Coverage, 9133,
     /*  976979 */     GIR_EraseRootFromParent_Done,
     /*  976980 */   // Label 14631: @976980
     /*  976980 */   GIM_Try, /*On fail goto*//*Label 14632*/ GIMT_Encode4(977075), // Rule ID 9136 //
     /*  976985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  977002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977035 */     // MIs[1] Operand 1
     /*  977035 */     // No operand predicates
     /*  977035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977048 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977073 */     GIR_RootConstrainSelectedInstOperands,
     /*  977074 */     // GIR_Coverage, 9136,
     /*  977074 */     GIR_EraseRootFromParent_Done,
     /*  977075 */   // Label 14632: @977075
     /*  977075 */   GIM_Try, /*On fail goto*//*Label 14633*/ GIMT_Encode4(977170), // Rule ID 9137 //
     /*  977080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  977097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977130 */     // MIs[1] Operand 1
     /*  977130 */     // No operand predicates
     /*  977130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977143 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977168 */     GIR_RootConstrainSelectedInstOperands,
     /*  977169 */     // GIR_Coverage, 9137,
     /*  977169 */     GIR_EraseRootFromParent_Done,
     /*  977170 */   // Label 14633: @977170
     /*  977170 */   GIM_Try, /*On fail goto*//*Label 14634*/ GIMT_Encode4(977265), // Rule ID 9140 //
     /*  977175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  977192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977225 */     // MIs[1] Operand 1
     /*  977225 */     // No operand predicates
     /*  977225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977238 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  977238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977263 */     GIR_RootConstrainSelectedInstOperands,
     /*  977264 */     // GIR_Coverage, 9140,
     /*  977264 */     GIR_EraseRootFromParent_Done,
     /*  977265 */   // Label 14634: @977265
     /*  977265 */   GIM_Try, /*On fail goto*//*Label 14635*/ GIMT_Encode4(977360), // Rule ID 9141 //
     /*  977270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  977287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977320 */     // MIs[1] Operand 1
     /*  977320 */     // No operand predicates
     /*  977320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977333 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  977333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  977336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977358 */     GIR_RootConstrainSelectedInstOperands,
     /*  977359 */     // GIR_Coverage, 9141,
     /*  977359 */     GIR_EraseRootFromParent_Done,
     /*  977360 */   // Label 14635: @977360
     /*  977360 */   GIM_Try, /*On fail goto*//*Label 14636*/ GIMT_Encode4(977455), // Rule ID 9144 //
     /*  977365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977415 */     // MIs[1] Operand 1
     /*  977415 */     // No operand predicates
     /*  977415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977428 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977453 */     GIR_RootConstrainSelectedInstOperands,
     /*  977454 */     // GIR_Coverage, 9144,
     /*  977454 */     GIR_EraseRootFromParent_Done,
     /*  977455 */   // Label 14636: @977455
     /*  977455 */   GIM_Try, /*On fail goto*//*Label 14637*/ GIMT_Encode4(977550), // Rule ID 9145 //
     /*  977460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  977471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  977474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  977477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  977483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977510 */     // MIs[1] Operand 1
     /*  977510 */     // No operand predicates
     /*  977510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977523 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977548 */     GIR_RootConstrainSelectedInstOperands,
     /*  977549 */     // GIR_Coverage, 9145,
     /*  977549 */     GIR_EraseRootFromParent_Done,
     /*  977550 */   // Label 14637: @977550
     /*  977550 */   GIM_Try, /*On fail goto*//*Label 14638*/ GIMT_Encode4(977645), // Rule ID 9148 //
     /*  977555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977605 */     // MIs[1] Operand 1
     /*  977605 */     // No operand predicates
     /*  977605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977618 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977643 */     GIR_RootConstrainSelectedInstOperands,
     /*  977644 */     // GIR_Coverage, 9148,
     /*  977644 */     GIR_EraseRootFromParent_Done,
     /*  977645 */   // Label 14638: @977645
     /*  977645 */   GIM_Try, /*On fail goto*//*Label 14639*/ GIMT_Encode4(977740), // Rule ID 9149 //
     /*  977650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977700 */     // MIs[1] Operand 1
     /*  977700 */     // No operand predicates
     /*  977700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977713 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977738 */     GIR_RootConstrainSelectedInstOperands,
     /*  977739 */     // GIR_Coverage, 9149,
     /*  977739 */     GIR_EraseRootFromParent_Done,
     /*  977740 */   // Label 14639: @977740
     /*  977740 */   GIM_Try, /*On fail goto*//*Label 14640*/ GIMT_Encode4(977835), // Rule ID 9152 //
     /*  977745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977795 */     // MIs[1] Operand 1
     /*  977795 */     // No operand predicates
     /*  977795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977808 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  977808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977833 */     GIR_RootConstrainSelectedInstOperands,
     /*  977834 */     // GIR_Coverage, 9152,
     /*  977834 */     GIR_EraseRootFromParent_Done,
     /*  977835 */   // Label 14640: @977835
     /*  977835 */   GIM_Try, /*On fail goto*//*Label 14641*/ GIMT_Encode4(977930), // Rule ID 9153 //
     /*  977840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977890 */     // MIs[1] Operand 1
     /*  977890 */     // No operand predicates
     /*  977890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977903 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  977903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977928 */     GIR_RootConstrainSelectedInstOperands,
     /*  977929 */     // GIR_Coverage, 9153,
     /*  977929 */     GIR_EraseRootFromParent_Done,
     /*  977930 */   // Label 14641: @977930
     /*  977930 */   GIM_Try, /*On fail goto*//*Label 14642*/ GIMT_Encode4(978025), // Rule ID 9156 //
     /*  977935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  977938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  977952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977985 */     // MIs[1] Operand 1
     /*  977985 */     // No operand predicates
     /*  977985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977998 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  977998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978023 */     GIR_RootConstrainSelectedInstOperands,
     /*  978024 */     // GIR_Coverage, 9156,
     /*  978024 */     GIR_EraseRootFromParent_Done,
     /*  978025 */   // Label 14642: @978025
     /*  978025 */   GIM_Try, /*On fail goto*//*Label 14643*/ GIMT_Encode4(978120), // Rule ID 9157 //
     /*  978030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  978033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  978041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  978044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  978047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  978053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978080 */     // MIs[1] Operand 1
     /*  978080 */     // No operand predicates
     /*  978080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978093 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  978093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  978096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  978115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978118 */     GIR_RootConstrainSelectedInstOperands,
     /*  978119 */     // GIR_Coverage, 9157,
     /*  978119 */     GIR_EraseRootFromParent_Done,
     /*  978120 */   // Label 14643: @978120
     /*  978120 */   GIM_Try, /*On fail goto*//*Label 14644*/ GIMT_Encode4(978215), // Rule ID 9160 //
     /*  978125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  978142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978175 */     // MIs[1] Operand 1
     /*  978175 */     // No operand predicates
     /*  978175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978188 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978213 */     GIR_RootConstrainSelectedInstOperands,
     /*  978214 */     // GIR_Coverage, 9160,
     /*  978214 */     GIR_EraseRootFromParent_Done,
     /*  978215 */   // Label 14644: @978215
     /*  978215 */   GIM_Try, /*On fail goto*//*Label 14645*/ GIMT_Encode4(978310), // Rule ID 9161 //
     /*  978220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  978237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978270 */     // MIs[1] Operand 1
     /*  978270 */     // No operand predicates
     /*  978270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978283 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978308 */     GIR_RootConstrainSelectedInstOperands,
     /*  978309 */     // GIR_Coverage, 9161,
     /*  978309 */     GIR_EraseRootFromParent_Done,
     /*  978310 */   // Label 14645: @978310
     /*  978310 */   GIM_Try, /*On fail goto*//*Label 14646*/ GIMT_Encode4(978405), // Rule ID 9164 //
     /*  978315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978365 */     // MIs[1] Operand 1
     /*  978365 */     // No operand predicates
     /*  978365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978378 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978403 */     GIR_RootConstrainSelectedInstOperands,
     /*  978404 */     // GIR_Coverage, 9164,
     /*  978404 */     GIR_EraseRootFromParent_Done,
     /*  978405 */   // Label 14646: @978405
     /*  978405 */   GIM_Try, /*On fail goto*//*Label 14647*/ GIMT_Encode4(978500), // Rule ID 9165 //
     /*  978410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  978427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978460 */     // MIs[1] Operand 1
     /*  978460 */     // No operand predicates
     /*  978460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978473 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978498 */     GIR_RootConstrainSelectedInstOperands,
     /*  978499 */     // GIR_Coverage, 9165,
     /*  978499 */     GIR_EraseRootFromParent_Done,
     /*  978500 */   // Label 14647: @978500
     /*  978500 */   GIM_Try, /*On fail goto*//*Label 14648*/ GIMT_Encode4(978595), // Rule ID 9168 //
     /*  978505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978555 */     // MIs[1] Operand 1
     /*  978555 */     // No operand predicates
     /*  978555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978568 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  978571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978593 */     GIR_RootConstrainSelectedInstOperands,
     /*  978594 */     // GIR_Coverage, 9168,
     /*  978594 */     GIR_EraseRootFromParent_Done,
     /*  978595 */   // Label 14648: @978595
     /*  978595 */   GIM_Try, /*On fail goto*//*Label 14649*/ GIMT_Encode4(978690), // Rule ID 9169 //
     /*  978600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978650 */     // MIs[1] Operand 1
     /*  978650 */     // No operand predicates
     /*  978650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978663 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  978666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978688 */     GIR_RootConstrainSelectedInstOperands,
     /*  978689 */     // GIR_Coverage, 9169,
     /*  978689 */     GIR_EraseRootFromParent_Done,
     /*  978690 */   // Label 14649: @978690
     /*  978690 */   GIM_Try, /*On fail goto*//*Label 14650*/ GIMT_Encode4(978785), // Rule ID 9172 //
     /*  978695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978745 */     // MIs[1] Operand 1
     /*  978745 */     // No operand predicates
     /*  978745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978758 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978783 */     GIR_RootConstrainSelectedInstOperands,
     /*  978784 */     // GIR_Coverage, 9172,
     /*  978784 */     GIR_EraseRootFromParent_Done,
     /*  978785 */   // Label 14650: @978785
     /*  978785 */   GIM_Try, /*On fail goto*//*Label 14651*/ GIMT_Encode4(978880), // Rule ID 9173 //
     /*  978790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978840 */     // MIs[1] Operand 1
     /*  978840 */     // No operand predicates
     /*  978840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978853 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978878 */     GIR_RootConstrainSelectedInstOperands,
     /*  978879 */     // GIR_Coverage, 9173,
     /*  978879 */     GIR_EraseRootFromParent_Done,
     /*  978880 */   // Label 14651: @978880
     /*  978880 */   GIM_Try, /*On fail goto*//*Label 14652*/ GIMT_Encode4(978975), // Rule ID 9176 //
     /*  978885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  978902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978935 */     // MIs[1] Operand 1
     /*  978935 */     // No operand predicates
     /*  978935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978948 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978973 */     GIR_RootConstrainSelectedInstOperands,
     /*  978974 */     // GIR_Coverage, 9176,
     /*  978974 */     GIR_EraseRootFromParent_Done,
     /*  978975 */   // Label 14652: @978975
     /*  978975 */   GIM_Try, /*On fail goto*//*Label 14653*/ GIMT_Encode4(979070), // Rule ID 9177 //
     /*  978980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  978997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979030 */     // MIs[1] Operand 1
     /*  979030 */     // No operand predicates
     /*  979030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979043 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979068 */     GIR_RootConstrainSelectedInstOperands,
     /*  979069 */     // GIR_Coverage, 9177,
     /*  979069 */     GIR_EraseRootFromParent_Done,
     /*  979070 */   // Label 14653: @979070
     /*  979070 */   GIM_Try, /*On fail goto*//*Label 14654*/ GIMT_Encode4(979165), // Rule ID 9180 //
     /*  979075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  979086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  979089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  979092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  979098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979125 */     // MIs[1] Operand 1
     /*  979125 */     // No operand predicates
     /*  979125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979138 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  979138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979163 */     GIR_RootConstrainSelectedInstOperands,
     /*  979164 */     // GIR_Coverage, 9180,
     /*  979164 */     GIR_EraseRootFromParent_Done,
     /*  979165 */   // Label 14654: @979165
     /*  979165 */   GIM_Try, /*On fail goto*//*Label 14655*/ GIMT_Encode4(979260), // Rule ID 9181 //
     /*  979170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  979181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  979184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  979187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  979193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979220 */     // MIs[1] Operand 1
     /*  979220 */     // No operand predicates
     /*  979220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979233 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  979233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  979255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979258 */     GIR_RootConstrainSelectedInstOperands,
     /*  979259 */     // GIR_Coverage, 9181,
     /*  979259 */     GIR_EraseRootFromParent_Done,
     /*  979260 */   // Label 14655: @979260
     /*  979260 */   GIM_Try, /*On fail goto*//*Label 14656*/ GIMT_Encode4(979355), // Rule ID 9184 //
     /*  979265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979315 */     // MIs[1] Operand 1
     /*  979315 */     // No operand predicates
     /*  979315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979353 */     GIR_RootConstrainSelectedInstOperands,
     /*  979354 */     // GIR_Coverage, 9184,
     /*  979354 */     GIR_EraseRootFromParent_Done,
     /*  979355 */   // Label 14656: @979355
     /*  979355 */   GIM_Try, /*On fail goto*//*Label 14657*/ GIMT_Encode4(979450), // Rule ID 9185 //
     /*  979360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  979377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979410 */     // MIs[1] Operand 1
     /*  979410 */     // No operand predicates
     /*  979410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979423 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979448 */     GIR_RootConstrainSelectedInstOperands,
     /*  979449 */     // GIR_Coverage, 9185,
     /*  979449 */     GIR_EraseRootFromParent_Done,
     /*  979450 */   // Label 14657: @979450
     /*  979450 */   GIM_Try, /*On fail goto*//*Label 14658*/ GIMT_Encode4(979545), // Rule ID 9188 //
     /*  979455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979505 */     // MIs[1] Operand 1
     /*  979505 */     // No operand predicates
     /*  979505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979518 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979543 */     GIR_RootConstrainSelectedInstOperands,
     /*  979544 */     // GIR_Coverage, 9188,
     /*  979544 */     GIR_EraseRootFromParent_Done,
     /*  979545 */   // Label 14658: @979545
     /*  979545 */   GIM_Try, /*On fail goto*//*Label 14659*/ GIMT_Encode4(979640), // Rule ID 9189 //
     /*  979550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979600 */     // MIs[1] Operand 1
     /*  979600 */     // No operand predicates
     /*  979600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979613 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979638 */     GIR_RootConstrainSelectedInstOperands,
     /*  979639 */     // GIR_Coverage, 9189,
     /*  979639 */     GIR_EraseRootFromParent_Done,
     /*  979640 */   // Label 14659: @979640
     /*  979640 */   GIM_Try, /*On fail goto*//*Label 14660*/ GIMT_Encode4(979735), // Rule ID 9192 //
     /*  979645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979695 */     // MIs[1] Operand 1
     /*  979695 */     // No operand predicates
     /*  979695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979708 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979733 */     GIR_RootConstrainSelectedInstOperands,
     /*  979734 */     // GIR_Coverage, 9192,
     /*  979734 */     GIR_EraseRootFromParent_Done,
     /*  979735 */   // Label 14660: @979735
     /*  979735 */   GIM_Try, /*On fail goto*//*Label 14661*/ GIMT_Encode4(979830), // Rule ID 9193 //
     /*  979740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979790 */     // MIs[1] Operand 1
     /*  979790 */     // No operand predicates
     /*  979790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979803 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979828 */     GIR_RootConstrainSelectedInstOperands,
     /*  979829 */     // GIR_Coverage, 9193,
     /*  979829 */     GIR_EraseRootFromParent_Done,
     /*  979830 */   // Label 14661: @979830
     /*  979830 */   GIM_Try, /*On fail goto*//*Label 14662*/ GIMT_Encode4(979925), // Rule ID 9196 //
     /*  979835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979885 */     // MIs[1] Operand 1
     /*  979885 */     // No operand predicates
     /*  979885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979923 */     GIR_RootConstrainSelectedInstOperands,
     /*  979924 */     // GIR_Coverage, 9196,
     /*  979924 */     GIR_EraseRootFromParent_Done,
     /*  979925 */   // Label 14662: @979925
     /*  979925 */   GIM_Try, /*On fail goto*//*Label 14663*/ GIMT_Encode4(980020), // Rule ID 9197 //
     /*  979930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979980 */     // MIs[1] Operand 1
     /*  979980 */     // No operand predicates
     /*  979980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979993 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  979993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980018 */     GIR_RootConstrainSelectedInstOperands,
     /*  980019 */     // GIR_Coverage, 9197,
     /*  980019 */     GIR_EraseRootFromParent_Done,
     /*  980020 */   // Label 14663: @980020
     /*  980020 */   GIM_Try, /*On fail goto*//*Label 14664*/ GIMT_Encode4(980115), // Rule ID 9200 //
     /*  980025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  980042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980075 */     // MIs[1] Operand 1
     /*  980075 */     // No operand predicates
     /*  980075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980113 */     GIR_RootConstrainSelectedInstOperands,
     /*  980114 */     // GIR_Coverage, 9200,
     /*  980114 */     GIR_EraseRootFromParent_Done,
     /*  980115 */   // Label 14664: @980115
     /*  980115 */   GIM_Try, /*On fail goto*//*Label 14665*/ GIMT_Encode4(980210), // Rule ID 9201 //
     /*  980120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  980137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  980158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980170 */     // MIs[1] Operand 1
     /*  980170 */     // No operand predicates
     /*  980170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980183 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  980186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980208 */     GIR_RootConstrainSelectedInstOperands,
     /*  980209 */     // GIR_Coverage, 9201,
     /*  980209 */     GIR_EraseRootFromParent_Done,
     /*  980210 */   // Label 14665: @980210
     /*  980210 */   GIM_Try, /*On fail goto*//*Label 14666*/ GIMT_Encode4(980305), // Rule ID 9204 //
     /*  980215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  980218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  980232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980265 */     // MIs[1] Operand 1
     /*  980265 */     // No operand predicates
     /*  980265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  980278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980303 */     GIR_RootConstrainSelectedInstOperands,
     /*  980304 */     // GIR_Coverage, 9204,
     /*  980304 */     GIR_EraseRootFromParent_Done,
     /*  980305 */   // Label 14666: @980305
     /*  980305 */   GIM_Try, /*On fail goto*//*Label 14667*/ GIMT_Encode4(980400), // Rule ID 9205 //
     /*  980310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  980313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  980318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  980321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  980324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  980327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  980333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  980348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980360 */     // MIs[1] Operand 1
     /*  980360 */     // No operand predicates
     /*  980360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980373 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  980373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  980376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  980395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980398 */     GIR_RootConstrainSelectedInstOperands,
     /*  980399 */     // GIR_Coverage, 9205,
     /*  980399 */     GIR_EraseRootFromParent_Done,
     /*  980400 */   // Label 14667: @980400
     /*  980400 */   GIM_Try, /*On fail goto*//*Label 14668*/ GIMT_Encode4(980495), // Rule ID 9296 //
     /*  980405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980455 */     // MIs[1] Operand 1
     /*  980455 */     // No operand predicates
     /*  980455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  980471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980493 */     GIR_RootConstrainSelectedInstOperands,
     /*  980494 */     // GIR_Coverage, 9296,
     /*  980494 */     GIR_EraseRootFromParent_Done,
     /*  980495 */   // Label 14668: @980495
     /*  980495 */   GIM_Try, /*On fail goto*//*Label 14669*/ GIMT_Encode4(980590), // Rule ID 9297 //
     /*  980500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980546 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980550 */     // MIs[1] Operand 1
     /*  980550 */     // No operand predicates
     /*  980550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980563 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  980566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980588 */     GIR_RootConstrainSelectedInstOperands,
     /*  980589 */     // GIR_Coverage, 9297,
     /*  980589 */     GIR_EraseRootFromParent_Done,
     /*  980590 */   // Label 14669: @980590
     /*  980590 */   GIM_Try, /*On fail goto*//*Label 14670*/ GIMT_Encode4(980685), // Rule ID 9300 //
     /*  980595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980645 */     // MIs[1] Operand 1
     /*  980645 */     // No operand predicates
     /*  980645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  980661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980683 */     GIR_RootConstrainSelectedInstOperands,
     /*  980684 */     // GIR_Coverage, 9300,
     /*  980684 */     GIR_EraseRootFromParent_Done,
     /*  980685 */   // Label 14670: @980685
     /*  980685 */   GIM_Try, /*On fail goto*//*Label 14671*/ GIMT_Encode4(980780), // Rule ID 9301 //
     /*  980690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980740 */     // MIs[1] Operand 1
     /*  980740 */     // No operand predicates
     /*  980740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980753 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  980756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980778 */     GIR_RootConstrainSelectedInstOperands,
     /*  980779 */     // GIR_Coverage, 9301,
     /*  980779 */     GIR_EraseRootFromParent_Done,
     /*  980780 */   // Label 14671: @980780
     /*  980780 */   GIM_Try, /*On fail goto*//*Label 14672*/ GIMT_Encode4(980875), // Rule ID 9304 //
     /*  980785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980835 */     // MIs[1] Operand 1
     /*  980835 */     // No operand predicates
     /*  980835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980848 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  980851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980873 */     GIR_RootConstrainSelectedInstOperands,
     /*  980874 */     // GIR_Coverage, 9304,
     /*  980874 */     GIR_EraseRootFromParent_Done,
     /*  980875 */   // Label 14672: @980875
     /*  980875 */   GIM_Try, /*On fail goto*//*Label 14673*/ GIMT_Encode4(980970), // Rule ID 9305 //
     /*  980880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980930 */     // MIs[1] Operand 1
     /*  980930 */     // No operand predicates
     /*  980930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980943 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  980946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980968 */     GIR_RootConstrainSelectedInstOperands,
     /*  980969 */     // GIR_Coverage, 9305,
     /*  980969 */     GIR_EraseRootFromParent_Done,
     /*  980970 */   // Label 14673: @980970
     /*  980970 */   GIM_Try, /*On fail goto*//*Label 14674*/ GIMT_Encode4(981065), // Rule ID 9308 //
     /*  980975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  980992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981025 */     // MIs[1] Operand 1
     /*  981025 */     // No operand predicates
     /*  981025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981038 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981063 */     GIR_RootConstrainSelectedInstOperands,
     /*  981064 */     // GIR_Coverage, 9308,
     /*  981064 */     GIR_EraseRootFromParent_Done,
     /*  981065 */   // Label 14674: @981065
     /*  981065 */   GIM_Try, /*On fail goto*//*Label 14675*/ GIMT_Encode4(981160), // Rule ID 9309 //
     /*  981070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  981087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981120 */     // MIs[1] Operand 1
     /*  981120 */     // No operand predicates
     /*  981120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981133 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  981136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981158 */     GIR_RootConstrainSelectedInstOperands,
     /*  981159 */     // GIR_Coverage, 9309,
     /*  981159 */     GIR_EraseRootFromParent_Done,
     /*  981160 */   // Label 14675: @981160
     /*  981160 */   GIM_Try, /*On fail goto*//*Label 14676*/ GIMT_Encode4(981255), // Rule ID 9312 //
     /*  981165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981215 */     // MIs[1] Operand 1
     /*  981215 */     // No operand predicates
     /*  981215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981253 */     GIR_RootConstrainSelectedInstOperands,
     /*  981254 */     // GIR_Coverage, 9312,
     /*  981254 */     GIR_EraseRootFromParent_Done,
     /*  981255 */   // Label 14676: @981255
     /*  981255 */   GIM_Try, /*On fail goto*//*Label 14677*/ GIMT_Encode4(981350), // Rule ID 9313 //
     /*  981260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  981277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981310 */     // MIs[1] Operand 1
     /*  981310 */     // No operand predicates
     /*  981310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981323 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981348 */     GIR_RootConstrainSelectedInstOperands,
     /*  981349 */     // GIR_Coverage, 9313,
     /*  981349 */     GIR_EraseRootFromParent_Done,
     /*  981350 */   // Label 14677: @981350
     /*  981350 */   GIM_Try, /*On fail goto*//*Label 14678*/ GIMT_Encode4(981445), // Rule ID 9316 //
     /*  981355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981405 */     // MIs[1] Operand 1
     /*  981405 */     // No operand predicates
     /*  981405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981418 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981443 */     GIR_RootConstrainSelectedInstOperands,
     /*  981444 */     // GIR_Coverage, 9316,
     /*  981444 */     GIR_EraseRootFromParent_Done,
     /*  981445 */   // Label 14678: @981445
     /*  981445 */   GIM_Try, /*On fail goto*//*Label 14679*/ GIMT_Encode4(981540), // Rule ID 9317 //
     /*  981450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  981467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981500 */     // MIs[1] Operand 1
     /*  981500 */     // No operand predicates
     /*  981500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981513 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981538 */     GIR_RootConstrainSelectedInstOperands,
     /*  981539 */     // GIR_Coverage, 9317,
     /*  981539 */     GIR_EraseRootFromParent_Done,
     /*  981540 */   // Label 14679: @981540
     /*  981540 */   GIM_Try, /*On fail goto*//*Label 14680*/ GIMT_Encode4(981635), // Rule ID 9320 //
     /*  981545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981595 */     // MIs[1] Operand 1
     /*  981595 */     // No operand predicates
     /*  981595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981608 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981633 */     GIR_RootConstrainSelectedInstOperands,
     /*  981634 */     // GIR_Coverage, 9320,
     /*  981634 */     GIR_EraseRootFromParent_Done,
     /*  981635 */   // Label 14680: @981635
     /*  981635 */   GIM_Try, /*On fail goto*//*Label 14681*/ GIMT_Encode4(981730), // Rule ID 9321 //
     /*  981640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981690 */     // MIs[1] Operand 1
     /*  981690 */     // No operand predicates
     /*  981690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981703 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981728 */     GIR_RootConstrainSelectedInstOperands,
     /*  981729 */     // GIR_Coverage, 9321,
     /*  981729 */     GIR_EraseRootFromParent_Done,
     /*  981730 */   // Label 14681: @981730
     /*  981730 */   GIM_Try, /*On fail goto*//*Label 14682*/ GIMT_Encode4(981825), // Rule ID 9324 //
     /*  981735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981785 */     // MIs[1] Operand 1
     /*  981785 */     // No operand predicates
     /*  981785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981798 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981823 */     GIR_RootConstrainSelectedInstOperands,
     /*  981824 */     // GIR_Coverage, 9324,
     /*  981824 */     GIR_EraseRootFromParent_Done,
     /*  981825 */   // Label 14682: @981825
     /*  981825 */   GIM_Try, /*On fail goto*//*Label 14683*/ GIMT_Encode4(981920), // Rule ID 9325 //
     /*  981830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981880 */     // MIs[1] Operand 1
     /*  981880 */     // No operand predicates
     /*  981880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981893 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981918 */     GIR_RootConstrainSelectedInstOperands,
     /*  981919 */     // GIR_Coverage, 9325,
     /*  981919 */     GIR_EraseRootFromParent_Done,
     /*  981920 */   // Label 14683: @981920
     /*  981920 */   GIM_Try, /*On fail goto*//*Label 14684*/ GIMT_Encode4(982015), // Rule ID 9328 //
     /*  981925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981975 */     // MIs[1] Operand 1
     /*  981975 */     // No operand predicates
     /*  981975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981988 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982013 */     GIR_RootConstrainSelectedInstOperands,
     /*  982014 */     // GIR_Coverage, 9328,
     /*  982014 */     GIR_EraseRootFromParent_Done,
     /*  982015 */   // Label 14684: @982015
     /*  982015 */   GIM_Try, /*On fail goto*//*Label 14685*/ GIMT_Encode4(982110), // Rule ID 9329 //
     /*  982020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  982031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  982034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  982037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  982043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982070 */     // MIs[1] Operand 1
     /*  982070 */     // No operand predicates
     /*  982070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982083 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  982083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  982105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982108 */     GIR_RootConstrainSelectedInstOperands,
     /*  982109 */     // GIR_Coverage, 9329,
     /*  982109 */     GIR_EraseRootFromParent_Done,
     /*  982110 */   // Label 14685: @982110
     /*  982110 */   GIM_Try, /*On fail goto*//*Label 14686*/ GIMT_Encode4(982205), // Rule ID 9332 //
     /*  982115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  982118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  982126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  982129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  982132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  982138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982165 */     // MIs[1] Operand 1
     /*  982165 */     // No operand predicates
     /*  982165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982178 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  982178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  982200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982203 */     GIR_RootConstrainSelectedInstOperands,
     /*  982204 */     // GIR_Coverage, 9332,
     /*  982204 */     GIR_EraseRootFromParent_Done,
     /*  982205 */   // Label 14686: @982205
     /*  982205 */   GIM_Try, /*On fail goto*//*Label 14687*/ GIMT_Encode4(982300), // Rule ID 9333 //
     /*  982210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  982213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  982221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  982224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  982227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  982233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982260 */     // MIs[1] Operand 1
     /*  982260 */     // No operand predicates
     /*  982260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982273 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  982273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  982276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  982295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982298 */     GIR_RootConstrainSelectedInstOperands,
     /*  982299 */     // GIR_Coverage, 9333,
     /*  982299 */     GIR_EraseRootFromParent_Done,
     /*  982300 */   // Label 14687: @982300
     /*  982300 */   GIM_Try, /*On fail goto*//*Label 14688*/ GIMT_Encode4(982395), // Rule ID 9336 //
     /*  982305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982355 */     // MIs[1] Operand 1
     /*  982355 */     // No operand predicates
     /*  982355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982368 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982393 */     GIR_RootConstrainSelectedInstOperands,
     /*  982394 */     // GIR_Coverage, 9336,
     /*  982394 */     GIR_EraseRootFromParent_Done,
     /*  982395 */   // Label 14688: @982395
     /*  982395 */   GIM_Try, /*On fail goto*//*Label 14689*/ GIMT_Encode4(982490), // Rule ID 9337 //
     /*  982400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  982417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982450 */     // MIs[1] Operand 1
     /*  982450 */     // No operand predicates
     /*  982450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982463 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982488 */     GIR_RootConstrainSelectedInstOperands,
     /*  982489 */     // GIR_Coverage, 9337,
     /*  982489 */     GIR_EraseRootFromParent_Done,
     /*  982490 */   // Label 14689: @982490
     /*  982490 */   GIM_Try, /*On fail goto*//*Label 14690*/ GIMT_Encode4(982585), // Rule ID 9340 //
     /*  982495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982545 */     // MIs[1] Operand 1
     /*  982545 */     // No operand predicates
     /*  982545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982558 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  982561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982583 */     GIR_RootConstrainSelectedInstOperands,
     /*  982584 */     // GIR_Coverage, 9340,
     /*  982584 */     GIR_EraseRootFromParent_Done,
     /*  982585 */   // Label 14690: @982585
     /*  982585 */   GIM_Try, /*On fail goto*//*Label 14691*/ GIMT_Encode4(982680), // Rule ID 9341 //
     /*  982590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982640 */     // MIs[1] Operand 1
     /*  982640 */     // No operand predicates
     /*  982640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982653 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  982656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982678 */     GIR_RootConstrainSelectedInstOperands,
     /*  982679 */     // GIR_Coverage, 9341,
     /*  982679 */     GIR_EraseRootFromParent_Done,
     /*  982680 */   // Label 14691: @982680
     /*  982680 */   GIM_Try, /*On fail goto*//*Label 14692*/ GIMT_Encode4(982775), // Rule ID 9344 //
     /*  982685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982735 */     // MIs[1] Operand 1
     /*  982735 */     // No operand predicates
     /*  982735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982748 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  982751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982773 */     GIR_RootConstrainSelectedInstOperands,
     /*  982774 */     // GIR_Coverage, 9344,
     /*  982774 */     GIR_EraseRootFromParent_Done,
     /*  982775 */   // Label 14692: @982775
     /*  982775 */   GIM_Try, /*On fail goto*//*Label 14693*/ GIMT_Encode4(982870), // Rule ID 9345 //
     /*  982780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982830 */     // MIs[1] Operand 1
     /*  982830 */     // No operand predicates
     /*  982830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982843 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  982846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982868 */     GIR_RootConstrainSelectedInstOperands,
     /*  982869 */     // GIR_Coverage, 9345,
     /*  982869 */     GIR_EraseRootFromParent_Done,
     /*  982870 */   // Label 14693: @982870
     /*  982870 */   GIM_Try, /*On fail goto*//*Label 14694*/ GIMT_Encode4(982965), // Rule ID 9348 //
     /*  982875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982925 */     // MIs[1] Operand 1
     /*  982925 */     // No operand predicates
     /*  982925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982938 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982963 */     GIR_RootConstrainSelectedInstOperands,
     /*  982964 */     // GIR_Coverage, 9348,
     /*  982964 */     GIR_EraseRootFromParent_Done,
     /*  982965 */   // Label 14694: @982965
     /*  982965 */   GIM_Try, /*On fail goto*//*Label 14695*/ GIMT_Encode4(983060), // Rule ID 9349 //
     /*  982970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983020 */     // MIs[1] Operand 1
     /*  983020 */     // No operand predicates
     /*  983020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983033 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983058 */     GIR_RootConstrainSelectedInstOperands,
     /*  983059 */     // GIR_Coverage, 9349,
     /*  983059 */     GIR_EraseRootFromParent_Done,
     /*  983060 */   // Label 14695: @983060
     /*  983060 */   GIM_Try, /*On fail goto*//*Label 14696*/ GIMT_Encode4(983155), // Rule ID 9352 //
     /*  983065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  983082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983115 */     // MIs[1] Operand 1
     /*  983115 */     // No operand predicates
     /*  983115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983128 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983153 */     GIR_RootConstrainSelectedInstOperands,
     /*  983154 */     // GIR_Coverage, 9352,
     /*  983154 */     GIR_EraseRootFromParent_Done,
     /*  983155 */   // Label 14696: @983155
     /*  983155 */   GIM_Try, /*On fail goto*//*Label 14697*/ GIMT_Encode4(983250), // Rule ID 9353 //
     /*  983160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  983177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983210 */     // MIs[1] Operand 1
     /*  983210 */     // No operand predicates
     /*  983210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983223 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983248 */     GIR_RootConstrainSelectedInstOperands,
     /*  983249 */     // GIR_Coverage, 9353,
     /*  983249 */     GIR_EraseRootFromParent_Done,
     /*  983250 */   // Label 14697: @983250
     /*  983250 */   GIM_Try, /*On fail goto*//*Label 14698*/ GIMT_Encode4(983345), // Rule ID 9356 //
     /*  983255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983305 */     // MIs[1] Operand 1
     /*  983305 */     // No operand predicates
     /*  983305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983318 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  983318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983343 */     GIR_RootConstrainSelectedInstOperands,
     /*  983344 */     // GIR_Coverage, 9356,
     /*  983344 */     GIR_EraseRootFromParent_Done,
     /*  983345 */   // Label 14698: @983345
     /*  983345 */   GIM_Try, /*On fail goto*//*Label 14699*/ GIMT_Encode4(983440), // Rule ID 9357 //
     /*  983350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  983361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  983364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  983367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  983373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983400 */     // MIs[1] Operand 1
     /*  983400 */     // No operand predicates
     /*  983400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983413 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  983413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  983435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983438 */     GIR_RootConstrainSelectedInstOperands,
     /*  983439 */     // GIR_Coverage, 9357,
     /*  983439 */     GIR_EraseRootFromParent_Done,
     /*  983440 */   // Label 14699: @983440
     /*  983440 */   GIM_Try, /*On fail goto*//*Label 14700*/ GIMT_Encode4(983535), // Rule ID 9360 //
     /*  983445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983495 */     // MIs[1] Operand 1
     /*  983495 */     // No operand predicates
     /*  983495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983508 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983533 */     GIR_RootConstrainSelectedInstOperands,
     /*  983534 */     // GIR_Coverage, 9360,
     /*  983534 */     GIR_EraseRootFromParent_Done,
     /*  983535 */   // Label 14700: @983535
     /*  983535 */   GIM_Try, /*On fail goto*//*Label 14701*/ GIMT_Encode4(983630), // Rule ID 9361 //
     /*  983540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983590 */     // MIs[1] Operand 1
     /*  983590 */     // No operand predicates
     /*  983590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983603 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983628 */     GIR_RootConstrainSelectedInstOperands,
     /*  983629 */     // GIR_Coverage, 9361,
     /*  983629 */     GIR_EraseRootFromParent_Done,
     /*  983630 */   // Label 14701: @983630
     /*  983630 */   GIM_Try, /*On fail goto*//*Label 14702*/ GIMT_Encode4(983725), // Rule ID 9364 //
     /*  983635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983685 */     // MIs[1] Operand 1
     /*  983685 */     // No operand predicates
     /*  983685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983698 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983723 */     GIR_RootConstrainSelectedInstOperands,
     /*  983724 */     // GIR_Coverage, 9364,
     /*  983724 */     GIR_EraseRootFromParent_Done,
     /*  983725 */   // Label 14702: @983725
     /*  983725 */   GIM_Try, /*On fail goto*//*Label 14703*/ GIMT_Encode4(983820), // Rule ID 9365 //
     /*  983730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983780 */     // MIs[1] Operand 1
     /*  983780 */     // No operand predicates
     /*  983780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983793 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983818 */     GIR_RootConstrainSelectedInstOperands,
     /*  983819 */     // GIR_Coverage, 9365,
     /*  983819 */     GIR_EraseRootFromParent_Done,
     /*  983820 */   // Label 14703: @983820
     /*  983820 */   GIM_Try, /*On fail goto*//*Label 14704*/ GIMT_Encode4(983915), // Rule ID 9368 //
     /*  983825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983875 */     // MIs[1] Operand 1
     /*  983875 */     // No operand predicates
     /*  983875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983913 */     GIR_RootConstrainSelectedInstOperands,
     /*  983914 */     // GIR_Coverage, 9368,
     /*  983914 */     GIR_EraseRootFromParent_Done,
     /*  983915 */   // Label 14704: @983915
     /*  983915 */   GIM_Try, /*On fail goto*//*Label 14705*/ GIMT_Encode4(984010), // Rule ID 9369 //
     /*  983920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983970 */     // MIs[1] Operand 1
     /*  983970 */     // No operand predicates
     /*  983970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983983 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  984005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984008 */     GIR_RootConstrainSelectedInstOperands,
     /*  984009 */     // GIR_Coverage, 9369,
     /*  984009 */     GIR_EraseRootFromParent_Done,
     /*  984010 */   // Label 14705: @984010
     /*  984010 */   GIM_Try, /*On fail goto*//*Label 14706*/ GIMT_Encode4(984105), // Rule ID 9372 //
     /*  984015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  984032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984065 */     // MIs[1] Operand 1
     /*  984065 */     // No operand predicates
     /*  984065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984078 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984103 */     GIR_RootConstrainSelectedInstOperands,
     /*  984104 */     // GIR_Coverage, 9372,
     /*  984104 */     GIR_EraseRootFromParent_Done,
     /*  984105 */   // Label 14706: @984105
     /*  984105 */   GIM_Try, /*On fail goto*//*Label 14707*/ GIMT_Encode4(984200), // Rule ID 9373 //
     /*  984110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  984127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  984148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984160 */     // MIs[1] Operand 1
     /*  984160 */     // No operand predicates
     /*  984160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984173 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  984176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984198 */     GIR_RootConstrainSelectedInstOperands,
     /*  984199 */     // GIR_Coverage, 9373,
     /*  984199 */     GIR_EraseRootFromParent_Done,
     /*  984200 */   // Label 14707: @984200
     /*  984200 */   GIM_Try, /*On fail goto*//*Label 14708*/ GIMT_Encode4(984295), // Rule ID 9376 //
     /*  984205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  984222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984255 */     // MIs[1] Operand 1
     /*  984255 */     // No operand predicates
     /*  984255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984293 */     GIR_RootConstrainSelectedInstOperands,
     /*  984294 */     // GIR_Coverage, 9376,
     /*  984294 */     GIR_EraseRootFromParent_Done,
     /*  984295 */   // Label 14708: @984295
     /*  984295 */   GIM_Try, /*On fail goto*//*Label 14709*/ GIMT_Encode4(984390), // Rule ID 9377 //
     /*  984300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  984317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  984338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984350 */     // MIs[1] Operand 1
     /*  984350 */     // No operand predicates
     /*  984350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984363 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  984366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984388 */     GIR_RootConstrainSelectedInstOperands,
     /*  984389 */     // GIR_Coverage, 9377,
     /*  984389 */     GIR_EraseRootFromParent_Done,
     /*  984390 */   // Label 14709: @984390
     /*  984390 */   GIM_Try, /*On fail goto*//*Label 14710*/ GIMT_Encode4(984485), // Rule ID 9380 //
     /*  984395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  984398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984445 */     // MIs[1] Operand 1
     /*  984445 */     // No operand predicates
     /*  984445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984458 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  984458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984483 */     GIR_RootConstrainSelectedInstOperands,
     /*  984484 */     // GIR_Coverage, 9380,
     /*  984484 */     GIR_EraseRootFromParent_Done,
     /*  984485 */   // Label 14710: @984485
     /*  984485 */   GIM_Try, /*On fail goto*//*Label 14711*/ GIMT_Encode4(984580), // Rule ID 9381 //
     /*  984490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  984493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  984498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  984501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  984504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  984507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984540 */     // MIs[1] Operand 1
     /*  984540 */     // No operand predicates
     /*  984540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984553 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984578 */     GIR_RootConstrainSelectedInstOperands,
     /*  984579 */     // GIR_Coverage, 9381,
     /*  984579 */     GIR_EraseRootFromParent_Done,
     /*  984580 */   // Label 14711: @984580
     /*  984580 */   GIM_Try, /*On fail goto*//*Label 14712*/ GIMT_Encode4(984675), // Rule ID 9472 //
     /*  984585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984635 */     // MIs[1] Operand 1
     /*  984635 */     // No operand predicates
     /*  984635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984648 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  984651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984673 */     GIR_RootConstrainSelectedInstOperands,
     /*  984674 */     // GIR_Coverage, 9472,
     /*  984674 */     GIR_EraseRootFromParent_Done,
     /*  984675 */   // Label 14712: @984675
     /*  984675 */   GIM_Try, /*On fail goto*//*Label 14713*/ GIMT_Encode4(984770), // Rule ID 9473 //
     /*  984680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984730 */     // MIs[1] Operand 1
     /*  984730 */     // No operand predicates
     /*  984730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984743 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  984746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984768 */     GIR_RootConstrainSelectedInstOperands,
     /*  984769 */     // GIR_Coverage, 9473,
     /*  984769 */     GIR_EraseRootFromParent_Done,
     /*  984770 */   // Label 14713: @984770
     /*  984770 */   GIM_Try, /*On fail goto*//*Label 14714*/ GIMT_Encode4(984865), // Rule ID 9476 //
     /*  984775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984825 */     // MIs[1] Operand 1
     /*  984825 */     // No operand predicates
     /*  984825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984838 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  984841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984863 */     GIR_RootConstrainSelectedInstOperands,
     /*  984864 */     // GIR_Coverage, 9476,
     /*  984864 */     GIR_EraseRootFromParent_Done,
     /*  984865 */   // Label 14714: @984865
     /*  984865 */   GIM_Try, /*On fail goto*//*Label 14715*/ GIMT_Encode4(984960), // Rule ID 9477 //
     /*  984870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984920 */     // MIs[1] Operand 1
     /*  984920 */     // No operand predicates
     /*  984920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984933 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  984936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984958 */     GIR_RootConstrainSelectedInstOperands,
     /*  984959 */     // GIR_Coverage, 9477,
     /*  984959 */     GIR_EraseRootFromParent_Done,
     /*  984960 */   // Label 14715: @984960
     /*  984960 */   GIM_Try, /*On fail goto*//*Label 14716*/ GIMT_Encode4(985055), // Rule ID 9480 //
     /*  984965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985015 */     // MIs[1] Operand 1
     /*  985015 */     // No operand predicates
     /*  985015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985028 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985053 */     GIR_RootConstrainSelectedInstOperands,
     /*  985054 */     // GIR_Coverage, 9480,
     /*  985054 */     GIR_EraseRootFromParent_Done,
     /*  985055 */   // Label 14716: @985055
     /*  985055 */   GIM_Try, /*On fail goto*//*Label 14717*/ GIMT_Encode4(985150), // Rule ID 9481 //
     /*  985060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  985077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985110 */     // MIs[1] Operand 1
     /*  985110 */     // No operand predicates
     /*  985110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985123 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985148 */     GIR_RootConstrainSelectedInstOperands,
     /*  985149 */     // GIR_Coverage, 9481,
     /*  985149 */     GIR_EraseRootFromParent_Done,
     /*  985150 */   // Label 14717: @985150
     /*  985150 */   GIM_Try, /*On fail goto*//*Label 14718*/ GIMT_Encode4(985245), // Rule ID 9484 //
     /*  985155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  985172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985205 */     // MIs[1] Operand 1
     /*  985205 */     // No operand predicates
     /*  985205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985218 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985243 */     GIR_RootConstrainSelectedInstOperands,
     /*  985244 */     // GIR_Coverage, 9484,
     /*  985244 */     GIR_EraseRootFromParent_Done,
     /*  985245 */   // Label 14718: @985245
     /*  985245 */   GIM_Try, /*On fail goto*//*Label 14719*/ GIMT_Encode4(985340), // Rule ID 9485 //
     /*  985250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  985267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985300 */     // MIs[1] Operand 1
     /*  985300 */     // No operand predicates
     /*  985300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985313 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  985316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985338 */     GIR_RootConstrainSelectedInstOperands,
     /*  985339 */     // GIR_Coverage, 9485,
     /*  985339 */     GIR_EraseRootFromParent_Done,
     /*  985340 */   // Label 14719: @985340
     /*  985340 */   GIM_Try, /*On fail goto*//*Label 14720*/ GIMT_Encode4(985435), // Rule ID 9488 //
     /*  985345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985395 */     // MIs[1] Operand 1
     /*  985395 */     // No operand predicates
     /*  985395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985408 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985433 */     GIR_RootConstrainSelectedInstOperands,
     /*  985434 */     // GIR_Coverage, 9488,
     /*  985434 */     GIR_EraseRootFromParent_Done,
     /*  985435 */   // Label 14720: @985435
     /*  985435 */   GIM_Try, /*On fail goto*//*Label 14721*/ GIMT_Encode4(985530), // Rule ID 9489 //
     /*  985440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  985457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985490 */     // MIs[1] Operand 1
     /*  985490 */     // No operand predicates
     /*  985490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985503 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985528 */     GIR_RootConstrainSelectedInstOperands,
     /*  985529 */     // GIR_Coverage, 9489,
     /*  985529 */     GIR_EraseRootFromParent_Done,
     /*  985530 */   // Label 14721: @985530
     /*  985530 */   GIM_Try, /*On fail goto*//*Label 14722*/ GIMT_Encode4(985625), // Rule ID 9492 //
     /*  985535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985585 */     // MIs[1] Operand 1
     /*  985585 */     // No operand predicates
     /*  985585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985598 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  985598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985623 */     GIR_RootConstrainSelectedInstOperands,
     /*  985624 */     // GIR_Coverage, 9492,
     /*  985624 */     GIR_EraseRootFromParent_Done,
     /*  985625 */   // Label 14722: @985625
     /*  985625 */   GIM_Try, /*On fail goto*//*Label 14723*/ GIMT_Encode4(985720), // Rule ID 9493 //
     /*  985630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985680 */     // MIs[1] Operand 1
     /*  985680 */     // No operand predicates
     /*  985680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985693 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  985693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985718 */     GIR_RootConstrainSelectedInstOperands,
     /*  985719 */     // GIR_Coverage, 9493,
     /*  985719 */     GIR_EraseRootFromParent_Done,
     /*  985720 */   // Label 14723: @985720
     /*  985720 */   GIM_Try, /*On fail goto*//*Label 14724*/ GIMT_Encode4(985815), // Rule ID 9496 //
     /*  985725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985775 */     // MIs[1] Operand 1
     /*  985775 */     // No operand predicates
     /*  985775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985813 */     GIR_RootConstrainSelectedInstOperands,
     /*  985814 */     // GIR_Coverage, 9496,
     /*  985814 */     GIR_EraseRootFromParent_Done,
     /*  985815 */   // Label 14724: @985815
     /*  985815 */   GIM_Try, /*On fail goto*//*Label 14725*/ GIMT_Encode4(985910), // Rule ID 9497 //
     /*  985820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985870 */     // MIs[1] Operand 1
     /*  985870 */     // No operand predicates
     /*  985870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985883 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985908 */     GIR_RootConstrainSelectedInstOperands,
     /*  985909 */     // GIR_Coverage, 9497,
     /*  985909 */     GIR_EraseRootFromParent_Done,
     /*  985910 */   // Label 14725: @985910
     /*  985910 */   GIM_Try, /*On fail goto*//*Label 14726*/ GIMT_Encode4(986005), // Rule ID 9500 //
     /*  985915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  985932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985965 */     // MIs[1] Operand 1
     /*  985965 */     // No operand predicates
     /*  985965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986003 */     GIR_RootConstrainSelectedInstOperands,
     /*  986004 */     // GIR_Coverage, 9500,
     /*  986004 */     GIR_EraseRootFromParent_Done,
     /*  986005 */   // Label 14726: @986005
     /*  986005 */   GIM_Try, /*On fail goto*//*Label 14727*/ GIMT_Encode4(986100), // Rule ID 9501 //
     /*  986010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  986021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  986024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  986027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  986033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986060 */     // MIs[1] Operand 1
     /*  986060 */     // No operand predicates
     /*  986060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986073 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  986073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986098 */     GIR_RootConstrainSelectedInstOperands,
     /*  986099 */     // GIR_Coverage, 9501,
     /*  986099 */     GIR_EraseRootFromParent_Done,
     /*  986100 */   // Label 14727: @986100
     /*  986100 */   GIM_Try, /*On fail goto*//*Label 14728*/ GIMT_Encode4(986195), // Rule ID 9504 //
     /*  986105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  986116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  986119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  986122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  986128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986155 */     // MIs[1] Operand 1
     /*  986155 */     // No operand predicates
     /*  986155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986168 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  986168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986193 */     GIR_RootConstrainSelectedInstOperands,
     /*  986194 */     // GIR_Coverage, 9504,
     /*  986194 */     GIR_EraseRootFromParent_Done,
     /*  986195 */   // Label 14728: @986195
     /*  986195 */   GIM_Try, /*On fail goto*//*Label 14729*/ GIMT_Encode4(986290), // Rule ID 9505 //
     /*  986200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  986211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  986214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  986217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  986223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986250 */     // MIs[1] Operand 1
     /*  986250 */     // No operand predicates
     /*  986250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986263 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  986263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  986285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986288 */     GIR_RootConstrainSelectedInstOperands,
     /*  986289 */     // GIR_Coverage, 9505,
     /*  986289 */     GIR_EraseRootFromParent_Done,
     /*  986290 */   // Label 14729: @986290
     /*  986290 */   GIM_Try, /*On fail goto*//*Label 14730*/ GIMT_Encode4(986385), // Rule ID 9508 //
     /*  986295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  986298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986345 */     // MIs[1] Operand 1
     /*  986345 */     // No operand predicates
     /*  986345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  986358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986383 */     GIR_RootConstrainSelectedInstOperands,
     /*  986384 */     // GIR_Coverage, 9508,
     /*  986384 */     GIR_EraseRootFromParent_Done,
     /*  986385 */   // Label 14730: @986385
     /*  986385 */   GIM_Try, /*On fail goto*//*Label 14731*/ GIMT_Encode4(986480), // Rule ID 9509 //
     /*  986390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  986393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  986401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  986404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  986407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  986413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986440 */     // MIs[1] Operand 1
     /*  986440 */     // No operand predicates
     /*  986440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986453 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  986453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  986456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  986475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986478 */     GIR_RootConstrainSelectedInstOperands,
     /*  986479 */     // GIR_Coverage, 9509,
     /*  986479 */     GIR_EraseRootFromParent_Done,
     /*  986480 */   // Label 14731: @986480
     /*  986480 */   GIM_Try, /*On fail goto*//*Label 14732*/ GIMT_Encode4(986575), // Rule ID 9512 //
     /*  986485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986535 */     // MIs[1] Operand 1
     /*  986535 */     // No operand predicates
     /*  986535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986548 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  986551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986573 */     GIR_RootConstrainSelectedInstOperands,
     /*  986574 */     // GIR_Coverage, 9512,
     /*  986574 */     GIR_EraseRootFromParent_Done,
     /*  986575 */   // Label 14732: @986575
     /*  986575 */   GIM_Try, /*On fail goto*//*Label 14733*/ GIMT_Encode4(986670), // Rule ID 9513 //
     /*  986580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986630 */     // MIs[1] Operand 1
     /*  986630 */     // No operand predicates
     /*  986630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  986646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986668 */     GIR_RootConstrainSelectedInstOperands,
     /*  986669 */     // GIR_Coverage, 9513,
     /*  986669 */     GIR_EraseRootFromParent_Done,
     /*  986670 */   // Label 14733: @986670
     /*  986670 */   GIM_Try, /*On fail goto*//*Label 14734*/ GIMT_Encode4(986765), // Rule ID 9516 //
     /*  986675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986725 */     // MIs[1] Operand 1
     /*  986725 */     // No operand predicates
     /*  986725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986738 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  986741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986763 */     GIR_RootConstrainSelectedInstOperands,
     /*  986764 */     // GIR_Coverage, 9516,
     /*  986764 */     GIR_EraseRootFromParent_Done,
     /*  986765 */   // Label 14734: @986765
     /*  986765 */   GIM_Try, /*On fail goto*//*Label 14735*/ GIMT_Encode4(986860), // Rule ID 9517 //
     /*  986770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986820 */     // MIs[1] Operand 1
     /*  986820 */     // No operand predicates
     /*  986820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986833 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  986836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986858 */     GIR_RootConstrainSelectedInstOperands,
     /*  986859 */     // GIR_Coverage, 9517,
     /*  986859 */     GIR_EraseRootFromParent_Done,
     /*  986860 */   // Label 14735: @986860
     /*  986860 */   GIM_Try, /*On fail goto*//*Label 14736*/ GIMT_Encode4(986955), // Rule ID 9520 //
     /*  986865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986915 */     // MIs[1] Operand 1
     /*  986915 */     // No operand predicates
     /*  986915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986928 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  986931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986953 */     GIR_RootConstrainSelectedInstOperands,
     /*  986954 */     // GIR_Coverage, 9520,
     /*  986954 */     GIR_EraseRootFromParent_Done,
     /*  986955 */   // Label 14736: @986955
     /*  986955 */   GIM_Try, /*On fail goto*//*Label 14737*/ GIMT_Encode4(987050), // Rule ID 9521 //
     /*  986960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987010 */     // MIs[1] Operand 1
     /*  987010 */     // No operand predicates
     /*  987010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987023 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  987023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  987045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987048 */     GIR_RootConstrainSelectedInstOperands,
     /*  987049 */     // GIR_Coverage, 9521,
     /*  987049 */     GIR_EraseRootFromParent_Done,
     /*  987050 */   // Label 14737: @987050
     /*  987050 */   GIM_Try, /*On fail goto*//*Label 14738*/ GIMT_Encode4(987145), // Rule ID 9524 //
     /*  987055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  987072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987105 */     // MIs[1] Operand 1
     /*  987105 */     // No operand predicates
     /*  987105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987118 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987143 */     GIR_RootConstrainSelectedInstOperands,
     /*  987144 */     // GIR_Coverage, 9524,
     /*  987144 */     GIR_EraseRootFromParent_Done,
     /*  987145 */   // Label 14738: @987145
     /*  987145 */   GIM_Try, /*On fail goto*//*Label 14739*/ GIMT_Encode4(987240), // Rule ID 9525 //
     /*  987150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  987167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987200 */     // MIs[1] Operand 1
     /*  987200 */     // No operand predicates
     /*  987200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987213 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987238 */     GIR_RootConstrainSelectedInstOperands,
     /*  987239 */     // GIR_Coverage, 9525,
     /*  987239 */     GIR_EraseRootFromParent_Done,
     /*  987240 */   // Label 14739: @987240
     /*  987240 */   GIM_Try, /*On fail goto*//*Label 14740*/ GIMT_Encode4(987335), // Rule ID 9528 //
     /*  987245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987295 */     // MIs[1] Operand 1
     /*  987295 */     // No operand predicates
     /*  987295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987308 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987333 */     GIR_RootConstrainSelectedInstOperands,
     /*  987334 */     // GIR_Coverage, 9528,
     /*  987334 */     GIR_EraseRootFromParent_Done,
     /*  987335 */   // Label 14740: @987335
     /*  987335 */   GIM_Try, /*On fail goto*//*Label 14741*/ GIMT_Encode4(987430), // Rule ID 9529 //
     /*  987340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  987357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987390 */     // MIs[1] Operand 1
     /*  987390 */     // No operand predicates
     /*  987390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987403 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987428 */     GIR_RootConstrainSelectedInstOperands,
     /*  987429 */     // GIR_Coverage, 9529,
     /*  987429 */     GIR_EraseRootFromParent_Done,
     /*  987430 */   // Label 14741: @987430
     /*  987430 */   GIM_Try, /*On fail goto*//*Label 14742*/ GIMT_Encode4(987525), // Rule ID 9532 //
     /*  987435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987485 */     // MIs[1] Operand 1
     /*  987485 */     // No operand predicates
     /*  987485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987498 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  987498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987523 */     GIR_RootConstrainSelectedInstOperands,
     /*  987524 */     // GIR_Coverage, 9532,
     /*  987524 */     GIR_EraseRootFromParent_Done,
     /*  987525 */   // Label 14742: @987525
     /*  987525 */   GIM_Try, /*On fail goto*//*Label 14743*/ GIMT_Encode4(987620), // Rule ID 9533 //
     /*  987530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987576 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987580 */     // MIs[1] Operand 1
     /*  987580 */     // No operand predicates
     /*  987580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987593 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987618 */     GIR_RootConstrainSelectedInstOperands,
     /*  987619 */     // GIR_Coverage, 9533,
     /*  987619 */     GIR_EraseRootFromParent_Done,
     /*  987620 */   // Label 14743: @987620
     /*  987620 */   GIM_Try, /*On fail goto*//*Label 14744*/ GIMT_Encode4(987715), // Rule ID 9536 //
     /*  987625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987675 */     // MIs[1] Operand 1
     /*  987675 */     // No operand predicates
     /*  987675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987688 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987713 */     GIR_RootConstrainSelectedInstOperands,
     /*  987714 */     // GIR_Coverage, 9536,
     /*  987714 */     GIR_EraseRootFromParent_Done,
     /*  987715 */   // Label 14744: @987715
     /*  987715 */   GIM_Try, /*On fail goto*//*Label 14745*/ GIMT_Encode4(987810), // Rule ID 9537 //
     /*  987720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987770 */     // MIs[1] Operand 1
     /*  987770 */     // No operand predicates
     /*  987770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987783 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987808 */     GIR_RootConstrainSelectedInstOperands,
     /*  987809 */     // GIR_Coverage, 9537,
     /*  987809 */     GIR_EraseRootFromParent_Done,
     /*  987810 */   // Label 14745: @987810
     /*  987810 */   GIM_Try, /*On fail goto*//*Label 14746*/ GIMT_Encode4(987905), // Rule ID 9540 //
     /*  987815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987865 */     // MIs[1] Operand 1
     /*  987865 */     // No operand predicates
     /*  987865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987878 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987903 */     GIR_RootConstrainSelectedInstOperands,
     /*  987904 */     // GIR_Coverage, 9540,
     /*  987904 */     GIR_EraseRootFromParent_Done,
     /*  987905 */   // Label 14746: @987905
     /*  987905 */   GIM_Try, /*On fail goto*//*Label 14747*/ GIMT_Encode4(988000), // Rule ID 9541 //
     /*  987910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987960 */     // MIs[1] Operand 1
     /*  987960 */     // No operand predicates
     /*  987960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987973 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987998 */     GIR_RootConstrainSelectedInstOperands,
     /*  987999 */     // GIR_Coverage, 9541,
     /*  987999 */     GIR_EraseRootFromParent_Done,
     /*  988000 */   // Label 14747: @988000
     /*  988000 */   GIM_Try, /*On fail goto*//*Label 14748*/ GIMT_Encode4(988095), // Rule ID 9544 //
     /*  988005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  988016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  988019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  988022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  988028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988055 */     // MIs[1] Operand 1
     /*  988055 */     // No operand predicates
     /*  988055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988068 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  988068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988093 */     GIR_RootConstrainSelectedInstOperands,
     /*  988094 */     // GIR_Coverage, 9544,
     /*  988094 */     GIR_EraseRootFromParent_Done,
     /*  988095 */   // Label 14748: @988095
     /*  988095 */   GIM_Try, /*On fail goto*//*Label 14749*/ GIMT_Encode4(988190), // Rule ID 9545 //
     /*  988100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  988111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  988114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  988117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  988123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988150 */     // MIs[1] Operand 1
     /*  988150 */     // No operand predicates
     /*  988150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988163 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  988163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  988185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988188 */     GIR_RootConstrainSelectedInstOperands,
     /*  988189 */     // GIR_Coverage, 9545,
     /*  988189 */     GIR_EraseRootFromParent_Done,
     /*  988190 */   // Label 14749: @988190
     /*  988190 */   GIM_Try, /*On fail goto*//*Label 14750*/ GIMT_Encode4(988285), // Rule ID 9548 //
     /*  988195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  988212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988245 */     // MIs[1] Operand 1
     /*  988245 */     // No operand predicates
     /*  988245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988258 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988283 */     GIR_RootConstrainSelectedInstOperands,
     /*  988284 */     // GIR_Coverage, 9548,
     /*  988284 */     GIR_EraseRootFromParent_Done,
     /*  988285 */   // Label 14750: @988285
     /*  988285 */   GIM_Try, /*On fail goto*//*Label 14751*/ GIMT_Encode4(988380), // Rule ID 9549 //
     /*  988290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  988301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  988304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  988307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  988328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988340 */     // MIs[1] Operand 1
     /*  988340 */     // No operand predicates
     /*  988340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988353 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  988356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988378 */     GIR_RootConstrainSelectedInstOperands,
     /*  988379 */     // GIR_Coverage, 9549,
     /*  988379 */     GIR_EraseRootFromParent_Done,
     /*  988380 */   // Label 14751: @988380
     /*  988380 */   GIM_Try, /*On fail goto*//*Label 14752*/ GIMT_Encode4(988475), // Rule ID 9552 //
     /*  988385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988435 */     // MIs[1] Operand 1
     /*  988435 */     // No operand predicates
     /*  988435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988473 */     GIR_RootConstrainSelectedInstOperands,
     /*  988474 */     // GIR_Coverage, 9552,
     /*  988474 */     GIR_EraseRootFromParent_Done,
     /*  988475 */   // Label 14752: @988475
     /*  988475 */   GIM_Try, /*On fail goto*//*Label 14753*/ GIMT_Encode4(988570), // Rule ID 9553 //
     /*  988480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  988491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  988494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  988497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988530 */     // MIs[1] Operand 1
     /*  988530 */     // No operand predicates
     /*  988530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988543 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988568 */     GIR_RootConstrainSelectedInstOperands,
     /*  988569 */     // GIR_Coverage, 9553,
     /*  988569 */     GIR_EraseRootFromParent_Done,
     /*  988570 */   // Label 14753: @988570
     /*  988570 */   GIM_Try, /*On fail goto*//*Label 14754*/ GIMT_Encode4(988665), // Rule ID 9556 //
     /*  988575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988625 */     // MIs[1] Operand 1
     /*  988625 */     // No operand predicates
     /*  988625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988638 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988663 */     GIR_RootConstrainSelectedInstOperands,
     /*  988664 */     // GIR_Coverage, 9556,
     /*  988664 */     GIR_EraseRootFromParent_Done,
     /*  988665 */   // Label 14754: @988665
     /*  988665 */   GIM_Try, /*On fail goto*//*Label 14755*/ GIMT_Encode4(988760), // Rule ID 9557 //
     /*  988670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988720 */     // MIs[1] Operand 1
     /*  988720 */     // No operand predicates
     /*  988720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988733 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988758 */     GIR_RootConstrainSelectedInstOperands,
     /*  988759 */     // GIR_Coverage, 9557,
     /*  988759 */     GIR_EraseRootFromParent_Done,
     /*  988760 */   // Label 14755: @988760
     /*  988760 */   GIM_Try, /*On fail goto*//*Label 14756*/ GIMT_Encode4(988852), // Rule ID 13934 //
     /*  988765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  988776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  988779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988815 */     // MIs[1] Operand 1
     /*  988815 */     // No operand predicates
     /*  988815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988828 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  988828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  988831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988850 */     GIR_RootConstrainSelectedInstOperands,
     /*  988851 */     // GIR_Coverage, 13934,
     /*  988851 */     GIR_EraseRootFromParent_Done,
     /*  988852 */   // Label 14756: @988852
     /*  988852 */   GIM_Try, /*On fail goto*//*Label 14757*/ GIMT_Encode4(988944), // Rule ID 13935 //
     /*  988857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  988868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  988871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988907 */     // MIs[1] Operand 1
     /*  988907 */     // No operand predicates
     /*  988907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988920 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  988920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  988923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988942 */     GIR_RootConstrainSelectedInstOperands,
     /*  988943 */     // GIR_Coverage, 13935,
     /*  988943 */     GIR_EraseRootFromParent_Done,
     /*  988944 */   // Label 14757: @988944
     /*  988944 */   GIM_Try, /*On fail goto*//*Label 14758*/ GIMT_Encode4(989036), // Rule ID 13936 //
     /*  988949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  988960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  988963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  988966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988999 */     // MIs[1] Operand 1
     /*  988999 */     // No operand predicates
     /*  988999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989012 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989034 */     GIR_RootConstrainSelectedInstOperands,
     /*  989035 */     // GIR_Coverage, 13936,
     /*  989035 */     GIR_EraseRootFromParent_Done,
     /*  989036 */   // Label 14758: @989036
     /*  989036 */   GIM_Try, /*On fail goto*//*Label 14759*/ GIMT_Encode4(989128), // Rule ID 13937 //
     /*  989041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  989052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  989055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  989058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989091 */     // MIs[1] Operand 1
     /*  989091 */     // No operand predicates
     /*  989091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989104 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989126 */     GIR_RootConstrainSelectedInstOperands,
     /*  989127 */     // GIR_Coverage, 13937,
     /*  989127 */     GIR_EraseRootFromParent_Done,
     /*  989128 */   // Label 14759: @989128
     /*  989128 */   GIM_Try, /*On fail goto*//*Label 14760*/ GIMT_Encode4(989220), // Rule ID 13938 //
     /*  989133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  989144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  989147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  989150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989183 */     // MIs[1] Operand 1
     /*  989183 */     // No operand predicates
     /*  989183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989218 */     GIR_RootConstrainSelectedInstOperands,
     /*  989219 */     // GIR_Coverage, 13938,
     /*  989219 */     GIR_EraseRootFromParent_Done,
     /*  989220 */   // Label 14760: @989220
     /*  989220 */   GIM_Try, /*On fail goto*//*Label 14761*/ GIMT_Encode4(989312), // Rule ID 13939 //
     /*  989225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  989236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  989239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  989242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989275 */     // MIs[1] Operand 1
     /*  989275 */     // No operand predicates
     /*  989275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989288 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989310 */     GIR_RootConstrainSelectedInstOperands,
     /*  989311 */     // GIR_Coverage, 13939,
     /*  989311 */     GIR_EraseRootFromParent_Done,
     /*  989312 */   // Label 14761: @989312
     /*  989312 */   GIM_Try, /*On fail goto*//*Label 14762*/ GIMT_Encode4(989404), // Rule ID 13940 //
     /*  989317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989367 */     // MIs[1] Operand 1
     /*  989367 */     // No operand predicates
     /*  989367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  989380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989402 */     GIR_RootConstrainSelectedInstOperands,
     /*  989403 */     // GIR_Coverage, 13940,
     /*  989403 */     GIR_EraseRootFromParent_Done,
     /*  989404 */   // Label 14762: @989404
     /*  989404 */   GIM_Try, /*On fail goto*//*Label 14763*/ GIMT_Encode4(989496), // Rule ID 13941 //
     /*  989409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  989420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  989423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  989426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989459 */     // MIs[1] Operand 1
     /*  989459 */     // No operand predicates
     /*  989459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  989472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  989475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989494 */     GIR_RootConstrainSelectedInstOperands,
     /*  989495 */     // GIR_Coverage, 13941,
     /*  989495 */     GIR_EraseRootFromParent_Done,
     /*  989496 */   // Label 14763: @989496
     /*  989496 */   GIM_Try, /*On fail goto*//*Label 14764*/ GIMT_Encode4(989588), // Rule ID 13942 //
     /*  989501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989551 */     // MIs[1] Operand 1
     /*  989551 */     // No operand predicates
     /*  989551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989564 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  989564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989586 */     GIR_RootConstrainSelectedInstOperands,
     /*  989587 */     // GIR_Coverage, 13942,
     /*  989587 */     GIR_EraseRootFromParent_Done,
     /*  989588 */   // Label 14764: @989588
     /*  989588 */   GIM_Try, /*On fail goto*//*Label 14765*/ GIMT_Encode4(989680), // Rule ID 13943 //
     /*  989593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989643 */     // MIs[1] Operand 1
     /*  989643 */     // No operand predicates
     /*  989643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989656 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  989656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989678 */     GIR_RootConstrainSelectedInstOperands,
     /*  989679 */     // GIR_Coverage, 13943,
     /*  989679 */     GIR_EraseRootFromParent_Done,
     /*  989680 */   // Label 14765: @989680
     /*  989680 */   GIM_Try, /*On fail goto*//*Label 14766*/ GIMT_Encode4(989772), // Rule ID 13944 //
     /*  989685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  989696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  989699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989735 */     // MIs[1] Operand 1
     /*  989735 */     // No operand predicates
     /*  989735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  989748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989770 */     GIR_RootConstrainSelectedInstOperands,
     /*  989771 */     // GIR_Coverage, 13944,
     /*  989771 */     GIR_EraseRootFromParent_Done,
     /*  989772 */   // Label 14766: @989772
     /*  989772 */   GIM_Try, /*On fail goto*//*Label 14767*/ GIMT_Encode4(989864), // Rule ID 13945 //
     /*  989777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  989788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  989791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989827 */     // MIs[1] Operand 1
     /*  989827 */     // No operand predicates
     /*  989827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  989840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989862 */     GIR_RootConstrainSelectedInstOperands,
     /*  989863 */     // GIR_Coverage, 13945,
     /*  989863 */     GIR_EraseRootFromParent_Done,
     /*  989864 */   // Label 14767: @989864
     /*  989864 */   GIM_Try, /*On fail goto*//*Label 14768*/ GIMT_Encode4(989956), // Rule ID 13946 //
     /*  989869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  989880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  989883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989919 */     // MIs[1] Operand 1
     /*  989919 */     // No operand predicates
     /*  989919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  989935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989954 */     GIR_RootConstrainSelectedInstOperands,
     /*  989955 */     // GIR_Coverage, 13946,
     /*  989955 */     GIR_EraseRootFromParent_Done,
     /*  989956 */   // Label 14768: @989956
     /*  989956 */   GIM_Try, /*On fail goto*//*Label 14769*/ GIMT_Encode4(990048), // Rule ID 13947 //
     /*  989961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  989972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  989975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990011 */     // MIs[1] Operand 1
     /*  990011 */     // No operand predicates
     /*  990011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990046 */     GIR_RootConstrainSelectedInstOperands,
     /*  990047 */     // GIR_Coverage, 13947,
     /*  990047 */     GIR_EraseRootFromParent_Done,
     /*  990048 */   // Label 14769: @990048
     /*  990048 */   GIM_Try, /*On fail goto*//*Label 14770*/ GIMT_Encode4(990140), // Rule ID 13948 //
     /*  990053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  990076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990103 */     // MIs[1] Operand 1
     /*  990103 */     // No operand predicates
     /*  990103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  990116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990138 */     GIR_RootConstrainSelectedInstOperands,
     /*  990139 */     // GIR_Coverage, 13948,
     /*  990139 */     GIR_EraseRootFromParent_Done,
     /*  990140 */   // Label 14770: @990140
     /*  990140 */   GIM_Try, /*On fail goto*//*Label 14771*/ GIMT_Encode4(990232), // Rule ID 13949 //
     /*  990145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  990156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  990159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  990162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  990168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990195 */     // MIs[1] Operand 1
     /*  990195 */     // No operand predicates
     /*  990195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  990208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990230 */     GIR_RootConstrainSelectedInstOperands,
     /*  990231 */     // GIR_Coverage, 13949,
     /*  990231 */     GIR_EraseRootFromParent_Done,
     /*  990232 */   // Label 14771: @990232
     /*  990232 */   GIM_Try, /*On fail goto*//*Label 14772*/ GIMT_Encode4(990324), // Rule ID 13950 //
     /*  990237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990287 */     // MIs[1] Operand 1
     /*  990287 */     // No operand predicates
     /*  990287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  990300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990322 */     GIR_RootConstrainSelectedInstOperands,
     /*  990323 */     // GIR_Coverage, 13950,
     /*  990323 */     GIR_EraseRootFromParent_Done,
     /*  990324 */   // Label 14772: @990324
     /*  990324 */   GIM_Try, /*On fail goto*//*Label 14773*/ GIMT_Encode4(990416), // Rule ID 13951 //
     /*  990329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  990340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  990343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  990346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  990352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990379 */     // MIs[1] Operand 1
     /*  990379 */     // No operand predicates
     /*  990379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  990392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  990414 */     GIR_RootConstrainSelectedInstOperands,
     /*  990415 */     // GIR_Coverage, 13951,
     /*  990415 */     GIR_EraseRootFromParent_Done,
     /*  990416 */   // Label 14773: @990416
     /*  990416 */   GIM_Try, /*On fail goto*//*Label 14774*/ GIMT_Encode4(990508), // Rule ID 13952 //
     /*  990421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  990424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990471 */     // MIs[1] Operand 1
     /*  990471 */     // No operand predicates
     /*  990471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  990484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990506 */     GIR_RootConstrainSelectedInstOperands,
     /*  990507 */     // GIR_Coverage, 13952,
     /*  990507 */     GIR_EraseRootFromParent_Done,
     /*  990508 */   // Label 14774: @990508
     /*  990508 */   GIM_Try, /*On fail goto*//*Label 14775*/ GIMT_Encode4(990600), // Rule ID 13953 //
     /*  990513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  990516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990563 */     // MIs[1] Operand 1
     /*  990563 */     // No operand predicates
     /*  990563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  990576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990598 */     GIR_RootConstrainSelectedInstOperands,
     /*  990599 */     // GIR_Coverage, 13953,
     /*  990599 */     GIR_EraseRootFromParent_Done,
     /*  990600 */   // Label 14775: @990600
     /*  990600 */   GIM_Try, /*On fail goto*//*Label 14776*/ GIMT_Encode4(990692), // Rule ID 13954 //
     /*  990605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  990616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  990619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  990635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990655 */     // MIs[1] Operand 1
     /*  990655 */     // No operand predicates
     /*  990655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990668 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  990668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  990671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990690 */     GIR_RootConstrainSelectedInstOperands,
     /*  990691 */     // GIR_Coverage, 13954,
     /*  990691 */     GIR_EraseRootFromParent_Done,
     /*  990692 */   // Label 14776: @990692
     /*  990692 */   GIM_Try, /*On fail goto*//*Label 14777*/ GIMT_Encode4(990784), // Rule ID 13955 //
     /*  990697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  990708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  990711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  990727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990747 */     // MIs[1] Operand 1
     /*  990747 */     // No operand predicates
     /*  990747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990760 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  990763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990782 */     GIR_RootConstrainSelectedInstOperands,
     /*  990783 */     // GIR_Coverage, 13955,
     /*  990783 */     GIR_EraseRootFromParent_Done,
     /*  990784 */   // Label 14777: @990784
     /*  990784 */   GIM_Try, /*On fail goto*//*Label 14778*/ GIMT_Encode4(990876), // Rule ID 13956 //
     /*  990789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  990800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  990803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  990819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990839 */     // MIs[1] Operand 1
     /*  990839 */     // No operand predicates
     /*  990839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990852 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  990852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  990855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990874 */     GIR_RootConstrainSelectedInstOperands,
     /*  990875 */     // GIR_Coverage, 13956,
     /*  990875 */     GIR_EraseRootFromParent_Done,
     /*  990876 */   // Label 14778: @990876
     /*  990876 */   GIM_Try, /*On fail goto*//*Label 14779*/ GIMT_Encode4(990968), // Rule ID 13957 //
     /*  990881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  990892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  990895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  990911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990931 */     // MIs[1] Operand 1
     /*  990931 */     // No operand predicates
     /*  990931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990944 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  990947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990966 */     GIR_RootConstrainSelectedInstOperands,
     /*  990967 */     // GIR_Coverage, 13957,
     /*  990967 */     GIR_EraseRootFromParent_Done,
     /*  990968 */   // Label 14779: @990968
     /*  990968 */   GIM_Try, /*On fail goto*//*Label 14780*/ GIMT_Encode4(991060), // Rule ID 13958 //
     /*  990973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  990984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  990987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  990990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  990996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991023 */     // MIs[1] Operand 1
     /*  991023 */     // No operand predicates
     /*  991023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991036 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  991036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991058 */     GIR_RootConstrainSelectedInstOperands,
     /*  991059 */     // GIR_Coverage, 13958,
     /*  991059 */     GIR_EraseRootFromParent_Done,
     /*  991060 */   // Label 14780: @991060
     /*  991060 */   GIM_Try, /*On fail goto*//*Label 14781*/ GIMT_Encode4(991152), // Rule ID 13959 //
     /*  991065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  991076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  991079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  991082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  991088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991115 */     // MIs[1] Operand 1
     /*  991115 */     // No operand predicates
     /*  991115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991128 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  991128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  991150 */     GIR_RootConstrainSelectedInstOperands,
     /*  991151 */     // GIR_Coverage, 13959,
     /*  991151 */     GIR_EraseRootFromParent_Done,
     /*  991152 */   // Label 14781: @991152
     /*  991152 */   GIM_Try, /*On fail goto*//*Label 14782*/ GIMT_Encode4(991244), // Rule ID 13960 //
     /*  991157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  991168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  991171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991207 */     // MIs[1] Operand 1
     /*  991207 */     // No operand predicates
     /*  991207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991242 */     GIR_RootConstrainSelectedInstOperands,
     /*  991243 */     // GIR_Coverage, 13960,
     /*  991243 */     GIR_EraseRootFromParent_Done,
     /*  991244 */   // Label 14782: @991244
     /*  991244 */   GIM_Try, /*On fail goto*//*Label 14783*/ GIMT_Encode4(991336), // Rule ID 13961 //
     /*  991249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  991260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  991263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  991266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991299 */     // MIs[1] Operand 1
     /*  991299 */     // No operand predicates
     /*  991299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991334 */     GIR_RootConstrainSelectedInstOperands,
     /*  991335 */     // GIR_Coverage, 13961,
     /*  991335 */     GIR_EraseRootFromParent_Done,
     /*  991336 */   // Label 14783: @991336
     /*  991336 */   GIM_Try, /*On fail goto*//*Label 14784*/ GIMT_Encode4(991428), // Rule ID 13962 //
     /*  991341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  991352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  991355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991391 */     // MIs[1] Operand 1
     /*  991391 */     // No operand predicates
     /*  991391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991426 */     GIR_RootConstrainSelectedInstOperands,
     /*  991427 */     // GIR_Coverage, 13962,
     /*  991427 */     GIR_EraseRootFromParent_Done,
     /*  991428 */   // Label 14784: @991428
     /*  991428 */   GIM_Try, /*On fail goto*//*Label 14785*/ GIMT_Encode4(991520), // Rule ID 13963 //
     /*  991433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  991444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  991447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  991450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991483 */     // MIs[1] Operand 1
     /*  991483 */     // No operand predicates
     /*  991483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991518 */     GIR_RootConstrainSelectedInstOperands,
     /*  991519 */     // GIR_Coverage, 13963,
     /*  991519 */     GIR_EraseRootFromParent_Done,
     /*  991520 */   // Label 14785: @991520
     /*  991520 */   GIM_Try, /*On fail goto*//*Label 14786*/ GIMT_Encode4(991612), // Rule ID 13964 //
     /*  991525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  991536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  991539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991575 */     // MIs[1] Operand 1
     /*  991575 */     // No operand predicates
     /*  991575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991588 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991610 */     GIR_RootConstrainSelectedInstOperands,
     /*  991611 */     // GIR_Coverage, 13964,
     /*  991611 */     GIR_EraseRootFromParent_Done,
     /*  991612 */   // Label 14786: @991612
     /*  991612 */   GIM_Try, /*On fail goto*//*Label 14787*/ GIMT_Encode4(991704), // Rule ID 13965 //
     /*  991617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  991628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  991631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991667 */     // MIs[1] Operand 1
     /*  991667 */     // No operand predicates
     /*  991667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991680 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991702 */     GIR_RootConstrainSelectedInstOperands,
     /*  991703 */     // GIR_Coverage, 13965,
     /*  991703 */     GIR_EraseRootFromParent_Done,
     /*  991704 */   // Label 14787: @991704
     /*  991704 */   GIM_Try, /*On fail goto*//*Label 14788*/ GIMT_Encode4(991796), // Rule ID 13966 //
     /*  991709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  991720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  991723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991759 */     // MIs[1] Operand 1
     /*  991759 */     // No operand predicates
     /*  991759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  991772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991794 */     GIR_RootConstrainSelectedInstOperands,
     /*  991795 */     // GIR_Coverage, 13966,
     /*  991795 */     GIR_EraseRootFromParent_Done,
     /*  991796 */   // Label 14788: @991796
     /*  991796 */   GIM_Try, /*On fail goto*//*Label 14789*/ GIMT_Encode4(991888), // Rule ID 13967 //
     /*  991801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  991812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  991815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991851 */     // MIs[1] Operand 1
     /*  991851 */     // No operand predicates
     /*  991851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  991864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991886 */     GIR_RootConstrainSelectedInstOperands,
     /*  991887 */     // GIR_Coverage, 13967,
     /*  991887 */     GIR_EraseRootFromParent_Done,
     /*  991888 */   // Label 14789: @991888
     /*  991888 */   GIM_Try, /*On fail goto*//*Label 14790*/ GIMT_Encode4(991980), // Rule ID 13968 //
     /*  991893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  991904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  991907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991943 */     // MIs[1] Operand 1
     /*  991943 */     // No operand predicates
     /*  991943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  991956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991978 */     GIR_RootConstrainSelectedInstOperands,
     /*  991979 */     // GIR_Coverage, 13968,
     /*  991979 */     GIR_EraseRootFromParent_Done,
     /*  991980 */   // Label 14790: @991980
     /*  991980 */   GIM_Try, /*On fail goto*//*Label 14791*/ GIMT_Encode4(992072), // Rule ID 13969 //
     /*  991985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  991996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  991999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  992002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992035 */     // MIs[1] Operand 1
     /*  992035 */     // No operand predicates
     /*  992035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992070 */     GIR_RootConstrainSelectedInstOperands,
     /*  992071 */     // GIR_Coverage, 13969,
     /*  992071 */     GIR_EraseRootFromParent_Done,
     /*  992072 */   // Label 14791: @992072
     /*  992072 */   GIM_Try, /*On fail goto*//*Label 14792*/ GIMT_Encode4(992164), // Rule ID 13970 //
     /*  992077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  992080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  992088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  992091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  992094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  992100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992127 */     // MIs[1] Operand 1
     /*  992127 */     // No operand predicates
     /*  992127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  992140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992162 */     GIR_RootConstrainSelectedInstOperands,
     /*  992163 */     // GIR_Coverage, 13970,
     /*  992163 */     GIR_EraseRootFromParent_Done,
     /*  992164 */   // Label 14792: @992164
     /*  992164 */   GIM_Try, /*On fail goto*//*Label 14793*/ GIMT_Encode4(992256), // Rule ID 13971 //
     /*  992169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  992172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  992180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  992183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  992186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  992192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992219 */     // MIs[1] Operand 1
     /*  992219 */     // No operand predicates
     /*  992219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992232 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  992232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  992254 */     GIR_RootConstrainSelectedInstOperands,
     /*  992255 */     // GIR_Coverage, 13971,
     /*  992255 */     GIR_EraseRootFromParent_Done,
     /*  992256 */   // Label 14793: @992256
     /*  992256 */   GIM_Try, /*On fail goto*//*Label 14794*/ GIMT_Encode4(992348), // Rule ID 13972 //
     /*  992261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  992272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  992275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992311 */     // MIs[1] Operand 1
     /*  992311 */     // No operand predicates
     /*  992311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992346 */     GIR_RootConstrainSelectedInstOperands,
     /*  992347 */     // GIR_Coverage, 13972,
     /*  992347 */     GIR_EraseRootFromParent_Done,
     /*  992348 */   // Label 14794: @992348
     /*  992348 */   GIM_Try, /*On fail goto*//*Label 14795*/ GIMT_Encode4(992440), // Rule ID 13973 //
     /*  992353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  992364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  992367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  992370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  992376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  992383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992403 */     // MIs[1] Operand 1
     /*  992403 */     // No operand predicates
     /*  992403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  992419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992438 */     GIR_RootConstrainSelectedInstOperands,
     /*  992439 */     // GIR_Coverage, 13973,
     /*  992439 */     GIR_EraseRootFromParent_Done,
     /*  992440 */   // Label 14795: @992440
     /*  992440 */   GIM_Try, /*On fail goto*//*Label 14796*/ GIMT_Encode4(992532), // Rule ID 13974 //
     /*  992445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  992456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  992459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992495 */     // MIs[1] Operand 1
     /*  992495 */     // No operand predicates
     /*  992495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992508 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992530 */     GIR_RootConstrainSelectedInstOperands,
     /*  992531 */     // GIR_Coverage, 13974,
     /*  992531 */     GIR_EraseRootFromParent_Done,
     /*  992532 */   // Label 14796: @992532
     /*  992532 */   GIM_Try, /*On fail goto*//*Label 14797*/ GIMT_Encode4(992624), // Rule ID 13975 //
     /*  992537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  992548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  992551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992587 */     // MIs[1] Operand 1
     /*  992587 */     // No operand predicates
     /*  992587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992600 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992622 */     GIR_RootConstrainSelectedInstOperands,
     /*  992623 */     // GIR_Coverage, 13975,
     /*  992623 */     GIR_EraseRootFromParent_Done,
     /*  992624 */   // Label 14797: @992624
     /*  992624 */   GIM_Try, /*On fail goto*//*Label 14798*/ GIMT_Encode4(992716), // Rule ID 13976 //
     /*  992629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  992640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  992643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992679 */     // MIs[1] Operand 1
     /*  992679 */     // No operand predicates
     /*  992679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992692 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992714 */     GIR_RootConstrainSelectedInstOperands,
     /*  992715 */     // GIR_Coverage, 13976,
     /*  992715 */     GIR_EraseRootFromParent_Done,
     /*  992716 */   // Label 14798: @992716
     /*  992716 */   GIM_Try, /*On fail goto*//*Label 14799*/ GIMT_Encode4(992808), // Rule ID 13977 //
     /*  992721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  992732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  992735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992771 */     // MIs[1] Operand 1
     /*  992771 */     // No operand predicates
     /*  992771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992784 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992806 */     GIR_RootConstrainSelectedInstOperands,
     /*  992807 */     // GIR_Coverage, 13977,
     /*  992807 */     GIR_EraseRootFromParent_Done,
     /*  992808 */   // Label 14799: @992808
     /*  992808 */   GIM_Try, /*On fail goto*//*Label 14800*/ GIMT_Encode4(992884), // Rule ID 2764 //
     /*  992813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  992816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  992824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  992827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  992830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992841 */     // MIs[0] passthru
     /*  992841 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992850 */     // MIs[0] round
     /*  992850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992860 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  992860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  992863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992882 */     GIR_RootConstrainSelectedInstOperands,
     /*  992883 */     // GIR_Coverage, 2764,
     /*  992883 */     GIR_EraseRootFromParent_Done,
     /*  992884 */   // Label 14800: @992884
     /*  992884 */   GIM_Try, /*On fail goto*//*Label 14801*/ GIMT_Encode4(992960), // Rule ID 2765 //
     /*  992889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  992892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  992900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  992903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  992906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992917 */     // MIs[0] passthru
     /*  992917 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992926 */     // MIs[0] round
     /*  992926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992936 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  992936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  992939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992958 */     GIR_RootConstrainSelectedInstOperands,
     /*  992959 */     // GIR_Coverage, 2765,
     /*  992959 */     GIR_EraseRootFromParent_Done,
     /*  992960 */   // Label 14801: @992960
     /*  992960 */   GIM_Try, /*On fail goto*//*Label 14802*/ GIMT_Encode4(993036), // Rule ID 17144 //
     /*  992965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  992968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  992976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  992979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  992982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992993 */     // MIs[0] passthru
     /*  992993 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993002 */     // MIs[0] round
     /*  993002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993012 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  993015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993034 */     GIR_RootConstrainSelectedInstOperands,
     /*  993035 */     // GIR_Coverage, 17144,
     /*  993035 */     GIR_EraseRootFromParent_Done,
     /*  993036 */   // Label 14802: @993036
     /*  993036 */   GIM_Try, /*On fail goto*//*Label 14803*/ GIMT_Encode4(993112), // Rule ID 17145 //
     /*  993041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  993058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993069 */     // MIs[0] passthru
     /*  993069 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993078 */     // MIs[0] round
     /*  993078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993088 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  993091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993110 */     GIR_RootConstrainSelectedInstOperands,
     /*  993111 */     // GIR_Coverage, 17145,
     /*  993111 */     GIR_EraseRootFromParent_Done,
     /*  993112 */   // Label 14803: @993112
     /*  993112 */   GIM_Try, /*On fail goto*//*Label 14804*/ GIMT_Encode4(993188), // Rule ID 17154 //
     /*  993117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  993128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  993131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  993134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993145 */     // MIs[0] passthru
     /*  993145 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993154 */     // MIs[0] round
     /*  993154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993164 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  993167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993186 */     GIR_RootConstrainSelectedInstOperands,
     /*  993187 */     // GIR_Coverage, 17154,
     /*  993187 */     GIR_EraseRootFromParent_Done,
     /*  993188 */   // Label 14804: @993188
     /*  993188 */   GIM_Try, /*On fail goto*//*Label 14805*/ GIMT_Encode4(993264), // Rule ID 17155 //
     /*  993193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  993204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  993207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  993210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993221 */     // MIs[0] passthru
     /*  993221 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993230 */     // MIs[0] round
     /*  993230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993240 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  993243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993262 */     GIR_RootConstrainSelectedInstOperands,
     /*  993263 */     // GIR_Coverage, 17155,
     /*  993263 */     GIR_EraseRootFromParent_Done,
     /*  993264 */   // Label 14805: @993264
     /*  993264 */   GIM_Try, /*On fail goto*//*Label 14806*/ GIMT_Encode4(993340), // Rule ID 17164 //
     /*  993269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  993280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  993283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  993286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993297 */     // MIs[0] passthru
     /*  993297 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993306 */     // MIs[0] round
     /*  993306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993316 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  993319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993338 */     GIR_RootConstrainSelectedInstOperands,
     /*  993339 */     // GIR_Coverage, 17164,
     /*  993339 */     GIR_EraseRootFromParent_Done,
     /*  993340 */   // Label 14806: @993340
     /*  993340 */   GIM_Try, /*On fail goto*//*Label 14807*/ GIMT_Encode4(993416), // Rule ID 17165 //
     /*  993345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  993356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  993359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  993362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993373 */     // MIs[0] passthru
     /*  993373 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993382 */     // MIs[0] round
     /*  993382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993392 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  993395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993414 */     GIR_RootConstrainSelectedInstOperands,
     /*  993415 */     // GIR_Coverage, 17165,
     /*  993415 */     GIR_EraseRootFromParent_Done,
     /*  993416 */   // Label 14807: @993416
     /*  993416 */   GIM_Try, /*On fail goto*//*Label 14808*/ GIMT_Encode4(993492), // Rule ID 17174 //
     /*  993421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  993432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  993435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  993438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993449 */     // MIs[0] passthru
     /*  993449 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993458 */     // MIs[0] round
     /*  993458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993468 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  993471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993490 */     GIR_RootConstrainSelectedInstOperands,
     /*  993491 */     // GIR_Coverage, 17174,
     /*  993491 */     GIR_EraseRootFromParent_Done,
     /*  993492 */   // Label 14808: @993492
     /*  993492 */   GIM_Try, /*On fail goto*//*Label 14809*/ GIMT_Encode4(993568), // Rule ID 17175 //
     /*  993497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  993508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  993511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  993514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993525 */     // MIs[0] passthru
     /*  993525 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993534 */     // MIs[0] round
     /*  993534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993544 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  993547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993566 */     GIR_RootConstrainSelectedInstOperands,
     /*  993567 */     // GIR_Coverage, 17175,
     /*  993567 */     GIR_EraseRootFromParent_Done,
     /*  993568 */   // Label 14809: @993568
     /*  993568 */   GIM_Try, /*On fail goto*//*Label 14810*/ GIMT_Encode4(993644), // Rule ID 17184 //
     /*  993573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  993584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  993587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  993590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993601 */     // MIs[0] passthru
     /*  993601 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993610 */     // MIs[0] round
     /*  993610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993620 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  993623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993642 */     GIR_RootConstrainSelectedInstOperands,
     /*  993643 */     // GIR_Coverage, 17184,
     /*  993643 */     GIR_EraseRootFromParent_Done,
     /*  993644 */   // Label 14810: @993644
     /*  993644 */   GIM_Try, /*On fail goto*//*Label 14811*/ GIMT_Encode4(993720), // Rule ID 17185 //
     /*  993649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  993660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  993663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  993666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993677 */     // MIs[0] passthru
     /*  993677 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993686 */     // MIs[0] round
     /*  993686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993696 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  993696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  993699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993718 */     GIR_RootConstrainSelectedInstOperands,
     /*  993719 */     // GIR_Coverage, 17185,
     /*  993719 */     GIR_EraseRootFromParent_Done,
     /*  993720 */   // Label 14811: @993720
     /*  993720 */   GIM_Try, /*On fail goto*//*Label 14812*/ GIMT_Encode4(993796), // Rule ID 17194 //
     /*  993725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  993736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  993739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  993742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993753 */     // MIs[0] passthru
     /*  993753 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993762 */     // MIs[0] round
     /*  993762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993772 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  993775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993794 */     GIR_RootConstrainSelectedInstOperands,
     /*  993795 */     // GIR_Coverage, 17194,
     /*  993795 */     GIR_EraseRootFromParent_Done,
     /*  993796 */   // Label 14812: @993796
     /*  993796 */   GIM_Try, /*On fail goto*//*Label 14813*/ GIMT_Encode4(993872), // Rule ID 17195 //
     /*  993801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  993812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  993815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  993818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993829 */     // MIs[0] passthru
     /*  993829 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993838 */     // MIs[0] round
     /*  993838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993848 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  993848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  993851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993870 */     GIR_RootConstrainSelectedInstOperands,
     /*  993871 */     // GIR_Coverage, 17195,
     /*  993871 */     GIR_EraseRootFromParent_Done,
     /*  993872 */   // Label 14813: @993872
     /*  993872 */   GIM_Try, /*On fail goto*//*Label 14814*/ GIMT_Encode4(993948), // Rule ID 17204 //
     /*  993877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  993888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  993891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  993894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993905 */     // MIs[0] passthru
     /*  993905 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993914 */     // MIs[0] round
     /*  993914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993924 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  993927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993946 */     GIR_RootConstrainSelectedInstOperands,
     /*  993947 */     // GIR_Coverage, 17204,
     /*  993947 */     GIR_EraseRootFromParent_Done,
     /*  993948 */   // Label 14814: @993948
     /*  993948 */   GIM_Try, /*On fail goto*//*Label 14815*/ GIMT_Encode4(994024), // Rule ID 17205 //
     /*  993953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  993964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  993967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  993970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993981 */     // MIs[0] passthru
     /*  993981 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993990 */     // MIs[0] round
     /*  993990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994000 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  994003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994022 */     GIR_RootConstrainSelectedInstOperands,
     /*  994023 */     // GIR_Coverage, 17205,
     /*  994023 */     GIR_EraseRootFromParent_Done,
     /*  994024 */   // Label 14815: @994024
     /*  994024 */   GIM_Try, /*On fail goto*//*Label 14816*/ GIMT_Encode4(994100), // Rule ID 17214 //
     /*  994029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994057 */     // MIs[0] passthru
     /*  994057 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994066 */     // MIs[0] round
     /*  994066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994076 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  994079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994098 */     GIR_RootConstrainSelectedInstOperands,
     /*  994099 */     // GIR_Coverage, 17214,
     /*  994099 */     GIR_EraseRootFromParent_Done,
     /*  994100 */   // Label 14816: @994100
     /*  994100 */   GIM_Try, /*On fail goto*//*Label 14817*/ GIMT_Encode4(994176), // Rule ID 17215 //
     /*  994105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  994113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994133 */     // MIs[0] passthru
     /*  994133 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994142 */     // MIs[0] round
     /*  994142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994152 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  994155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994174 */     GIR_RootConstrainSelectedInstOperands,
     /*  994175 */     // GIR_Coverage, 17215,
     /*  994175 */     GIR_EraseRootFromParent_Done,
     /*  994176 */   // Label 14817: @994176
     /*  994176 */   GIM_Try, /*On fail goto*//*Label 14818*/ GIMT_Encode4(994252), // Rule ID 17260 //
     /*  994181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  994192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  994195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  994198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994209 */     // MIs[0] passthru
     /*  994209 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994218 */     // MIs[0] round
     /*  994218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994228 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  994231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994250 */     GIR_RootConstrainSelectedInstOperands,
     /*  994251 */     // GIR_Coverage, 17260,
     /*  994251 */     GIR_EraseRootFromParent_Done,
     /*  994252 */   // Label 14818: @994252
     /*  994252 */   GIM_Try, /*On fail goto*//*Label 14819*/ GIMT_Encode4(994328), // Rule ID 17261 //
     /*  994257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  994268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  994271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  994274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994285 */     // MIs[0] passthru
     /*  994285 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994294 */     // MIs[0] round
     /*  994294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994304 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  994307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994326 */     GIR_RootConstrainSelectedInstOperands,
     /*  994327 */     // GIR_Coverage, 17261,
     /*  994327 */     GIR_EraseRootFromParent_Done,
     /*  994328 */   // Label 14819: @994328
     /*  994328 */   GIM_Try, /*On fail goto*//*Label 14820*/ GIMT_Encode4(994404), // Rule ID 17270 //
     /*  994333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  994350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994361 */     // MIs[0] passthru
     /*  994361 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994370 */     // MIs[0] round
     /*  994370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994380 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  994383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994402 */     GIR_RootConstrainSelectedInstOperands,
     /*  994403 */     // GIR_Coverage, 17270,
     /*  994403 */     GIR_EraseRootFromParent_Done,
     /*  994404 */   // Label 14820: @994404
     /*  994404 */   GIM_Try, /*On fail goto*//*Label 14821*/ GIMT_Encode4(994480), // Rule ID 17271 //
     /*  994409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  994420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  994423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  994426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994437 */     // MIs[0] passthru
     /*  994437 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994446 */     // MIs[0] round
     /*  994446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994456 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  994459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994478 */     GIR_RootConstrainSelectedInstOperands,
     /*  994479 */     // GIR_Coverage, 17271,
     /*  994479 */     GIR_EraseRootFromParent_Done,
     /*  994480 */   // Label 14821: @994480
     /*  994480 */   GIM_Try, /*On fail goto*//*Label 14822*/ GIMT_Encode4(994556), // Rule ID 17280 //
     /*  994485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  994496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  994499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  994502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994513 */     // MIs[0] passthru
     /*  994513 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994522 */     // MIs[0] round
     /*  994522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994532 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  994535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994554 */     GIR_RootConstrainSelectedInstOperands,
     /*  994555 */     // GIR_Coverage, 17280,
     /*  994555 */     GIR_EraseRootFromParent_Done,
     /*  994556 */   // Label 14822: @994556
     /*  994556 */   GIM_Try, /*On fail goto*//*Label 14823*/ GIMT_Encode4(994632), // Rule ID 17281 //
     /*  994561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  994572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  994575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  994578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994589 */     // MIs[0] passthru
     /*  994589 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994598 */     // MIs[0] round
     /*  994598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994608 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  994611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994630 */     GIR_RootConstrainSelectedInstOperands,
     /*  994631 */     // GIR_Coverage, 17281,
     /*  994631 */     GIR_EraseRootFromParent_Done,
     /*  994632 */   // Label 14823: @994632
     /*  994632 */   GIM_Try, /*On fail goto*//*Label 14824*/ GIMT_Encode4(994708), // Rule ID 17290 //
     /*  994637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  994648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  994651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  994654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994665 */     // MIs[0] passthru
     /*  994665 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994674 */     // MIs[0] round
     /*  994674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994684 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  994687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994706 */     GIR_RootConstrainSelectedInstOperands,
     /*  994707 */     // GIR_Coverage, 17290,
     /*  994707 */     GIR_EraseRootFromParent_Done,
     /*  994708 */   // Label 14824: @994708
     /*  994708 */   GIM_Try, /*On fail goto*//*Label 14825*/ GIMT_Encode4(994784), // Rule ID 17291 //
     /*  994713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  994724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  994727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  994730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994741 */     // MIs[0] passthru
     /*  994741 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994750 */     // MIs[0] round
     /*  994750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994760 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  994763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994782 */     GIR_RootConstrainSelectedInstOperands,
     /*  994783 */     // GIR_Coverage, 17291,
     /*  994783 */     GIR_EraseRootFromParent_Done,
     /*  994784 */   // Label 14825: @994784
     /*  994784 */   GIM_Try, /*On fail goto*//*Label 14826*/ GIMT_Encode4(994860), // Rule ID 17300 //
     /*  994789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  994800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  994803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  994806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994817 */     // MIs[0] passthru
     /*  994817 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994826 */     // MIs[0] round
     /*  994826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994836 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  994839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994858 */     GIR_RootConstrainSelectedInstOperands,
     /*  994859 */     // GIR_Coverage, 17300,
     /*  994859 */     GIR_EraseRootFromParent_Done,
     /*  994860 */   // Label 14826: @994860
     /*  994860 */   GIM_Try, /*On fail goto*//*Label 14827*/ GIMT_Encode4(994936), // Rule ID 17301 //
     /*  994865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  994876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  994879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  994882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994893 */     // MIs[0] passthru
     /*  994893 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994902 */     // MIs[0] round
     /*  994902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994912 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  994915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994934 */     GIR_RootConstrainSelectedInstOperands,
     /*  994935 */     // GIR_Coverage, 17301,
     /*  994935 */     GIR_EraseRootFromParent_Done,
     /*  994936 */   // Label 14827: @994936
     /*  994936 */   GIM_Try, /*On fail goto*//*Label 14828*/ GIMT_Encode4(995012), // Rule ID 17310 //
     /*  994941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  994958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994969 */     // MIs[0] passthru
     /*  994969 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994978 */     // MIs[0] round
     /*  994978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994988 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  994991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995010 */     GIR_RootConstrainSelectedInstOperands,
     /*  995011 */     // GIR_Coverage, 17310,
     /*  995011 */     GIR_EraseRootFromParent_Done,
     /*  995012 */   // Label 14828: @995012
     /*  995012 */   GIM_Try, /*On fail goto*//*Label 14829*/ GIMT_Encode4(995088), // Rule ID 17311 //
     /*  995017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  995028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  995031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  995034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995045 */     // MIs[0] passthru
     /*  995045 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995054 */     // MIs[0] round
     /*  995054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995064 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  995067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995086 */     GIR_RootConstrainSelectedInstOperands,
     /*  995087 */     // GIR_Coverage, 17311,
     /*  995087 */     GIR_EraseRootFromParent_Done,
     /*  995088 */   // Label 14829: @995088
     /*  995088 */   GIM_Try, /*On fail goto*//*Label 14830*/ GIMT_Encode4(995164), // Rule ID 17320 //
     /*  995093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  995104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  995107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  995110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995121 */     // MIs[0] passthru
     /*  995121 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995130 */     // MIs[0] round
     /*  995130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995140 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  995143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995162 */     GIR_RootConstrainSelectedInstOperands,
     /*  995163 */     // GIR_Coverage, 17320,
     /*  995163 */     GIR_EraseRootFromParent_Done,
     /*  995164 */   // Label 14830: @995164
     /*  995164 */   GIM_Try, /*On fail goto*//*Label 14831*/ GIMT_Encode4(995240), // Rule ID 17321 //
     /*  995169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  995180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  995183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  995186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995197 */     // MIs[0] passthru
     /*  995197 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995206 */     // MIs[0] round
     /*  995206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995216 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  995219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995238 */     GIR_RootConstrainSelectedInstOperands,
     /*  995239 */     // GIR_Coverage, 17321,
     /*  995239 */     GIR_EraseRootFromParent_Done,
     /*  995240 */   // Label 14831: @995240
     /*  995240 */   GIM_Try, /*On fail goto*//*Label 14832*/ GIMT_Encode4(995316), // Rule ID 17330 //
     /*  995245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  995262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995273 */     // MIs[0] passthru
     /*  995273 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995282 */     // MIs[0] round
     /*  995282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995292 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  995295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995314 */     GIR_RootConstrainSelectedInstOperands,
     /*  995315 */     // GIR_Coverage, 17330,
     /*  995315 */     GIR_EraseRootFromParent_Done,
     /*  995316 */   // Label 14832: @995316
     /*  995316 */   GIM_Try, /*On fail goto*//*Label 14833*/ GIMT_Encode4(995392), // Rule ID 17331 //
     /*  995321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  995332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  995335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  995338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995349 */     // MIs[0] passthru
     /*  995349 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  995358 */     // MIs[0] round
     /*  995358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995368 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  995371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995390 */     GIR_RootConstrainSelectedInstOperands,
     /*  995391 */     // GIR_Coverage, 17331,
     /*  995391 */     GIR_EraseRootFromParent_Done,
     /*  995392 */   // Label 14833: @995392
     /*  995392 */   GIM_Try, /*On fail goto*//*Label 14834*/ GIMT_Encode4(995468), // Rule ID 17340 //
     /*  995397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  995400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  995414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  995417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995425 */     // MIs[0] passthru
     /*  995425 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995434 */     // MIs[0] round
     /*  995434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995444 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  995444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  995447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995466 */     GIR_RootConstrainSelectedInstOperands,
     /*  995467 */     // GIR_Coverage, 17340,
     /*  995467 */     GIR_EraseRootFromParent_Done,
     /*  995468 */   // Label 14834: @995468
     /*  995468 */   GIM_Try, /*On fail goto*//*Label 14835*/ GIMT_Encode4(995544), // Rule ID 17341 //
     /*  995473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  995476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  995481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  995484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  995487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  995490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  995493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  995501 */     // MIs[0] passthru
     /*  995501 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  995506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995510 */     // MIs[0] round
     /*  995510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995520 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  995523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995542 */     GIR_RootConstrainSelectedInstOperands,
     /*  995543 */     // GIR_Coverage, 17341,
     /*  995543 */     GIR_EraseRootFromParent_Done,
     /*  995544 */   // Label 14835: @995544
     /*  995544 */   GIM_Try, /*On fail goto*//*Label 14836*/ GIMT_Encode4(995621), // Rule ID 2694 //
     /*  995549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  995557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  995566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995588 */     // MIs[0] policy
     /*  995588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995598 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  995601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995619 */     GIR_RootConstrainSelectedInstOperands,
     /*  995620 */     // GIR_Coverage, 2694,
     /*  995620 */     GIR_EraseRootFromParent_Done,
     /*  995621 */   // Label 14836: @995621
     /*  995621 */   GIM_Try, /*On fail goto*//*Label 14837*/ GIMT_Encode4(995698), // Rule ID 2695 //
     /*  995626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  995634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  995643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995665 */     // MIs[0] policy
     /*  995665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995675 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  995678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995696 */     GIR_RootConstrainSelectedInstOperands,
     /*  995697 */     // GIR_Coverage, 2695,
     /*  995697 */     GIR_EraseRootFromParent_Done,
     /*  995698 */   // Label 14837: @995698
     /*  995698 */   GIM_Try, /*On fail goto*//*Label 14838*/ GIMT_Encode4(995775), // Rule ID 2698 //
     /*  995703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  995711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995742 */     // MIs[0] policy
     /*  995742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995752 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  995755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995773 */     GIR_RootConstrainSelectedInstOperands,
     /*  995774 */     // GIR_Coverage, 2698,
     /*  995774 */     GIR_EraseRootFromParent_Done,
     /*  995775 */   // Label 14838: @995775
     /*  995775 */   GIM_Try, /*On fail goto*//*Label 14839*/ GIMT_Encode4(995852), // Rule ID 2699 //
     /*  995780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  995788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995819 */     // MIs[0] policy
     /*  995819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995829 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  995832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995850 */     GIR_RootConstrainSelectedInstOperands,
     /*  995851 */     // GIR_Coverage, 2699,
     /*  995851 */     GIR_EraseRootFromParent_Done,
     /*  995852 */   // Label 14839: @995852
     /*  995852 */   GIM_Try, /*On fail goto*//*Label 14840*/ GIMT_Encode4(995929), // Rule ID 2702 //
     /*  995857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  995860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  995865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995896 */     // MIs[0] policy
     /*  995896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995906 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  995909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995927 */     GIR_RootConstrainSelectedInstOperands,
     /*  995928 */     // GIR_Coverage, 2702,
     /*  995928 */     GIR_EraseRootFromParent_Done,
     /*  995929 */   // Label 14840: @995929
     /*  995929 */   GIM_Try, /*On fail goto*//*Label 14841*/ GIMT_Encode4(996006), // Rule ID 2703 //
     /*  995934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  995937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  995942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995973 */     // MIs[0] policy
     /*  995973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995983 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  995986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996004 */     GIR_RootConstrainSelectedInstOperands,
     /*  996005 */     // GIR_Coverage, 2703,
     /*  996005 */     GIR_EraseRootFromParent_Done,
     /*  996006 */   // Label 14841: @996006
     /*  996006 */   GIM_Try, /*On fail goto*//*Label 14842*/ GIMT_Encode4(996083), // Rule ID 2738 //
     /*  996011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  996014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  996019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996050 */     // MIs[0] policy
     /*  996050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  996063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996081 */     GIR_RootConstrainSelectedInstOperands,
     /*  996082 */     // GIR_Coverage, 2738,
     /*  996082 */     GIR_EraseRootFromParent_Done,
     /*  996083 */   // Label 14842: @996083
     /*  996083 */   GIM_Try, /*On fail goto*//*Label 14843*/ GIMT_Encode4(996160), // Rule ID 2739 //
     /*  996088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  996091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  996096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  996099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  996102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996127 */     // MIs[0] policy
     /*  996127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996137 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  996140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996158 */     GIR_RootConstrainSelectedInstOperands,
     /*  996159 */     // GIR_Coverage, 2739,
     /*  996159 */     GIR_EraseRootFromParent_Done,
     /*  996160 */   // Label 14843: @996160
     /*  996160 */   GIM_Try, /*On fail goto*//*Label 14844*/ GIMT_Encode4(996237), // Rule ID 2770 //
     /*  996165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  996173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  996185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996204 */     // MIs[0] policy
     /*  996204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996214 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  996217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  996221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996235 */     GIR_RootConstrainSelectedInstOperands,
     /*  996236 */     // GIR_Coverage, 2770,
     /*  996236 */     GIR_EraseRootFromParent_Done,
     /*  996237 */   // Label 14844: @996237
     /*  996237 */   GIM_Try, /*On fail goto*//*Label 14845*/ GIMT_Encode4(996314), // Rule ID 2771 //
     /*  996242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  996250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  996253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  996256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  996259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  996262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996281 */     // MIs[0] policy
     /*  996281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996291 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  996294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  996298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  996300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  996302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  996310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996312 */     GIR_RootConstrainSelectedInstOperands,
     /*  996313 */     // GIR_Coverage, 2771,
     /*  996313 */     GIR_EraseRootFromParent_Done,
     /*  996314 */   // Label 14845: @996314
     /*  996314 */   GIM_Try, /*On fail goto*//*Label 14846*/ GIMT_Encode4(996391), // Rule ID 4898 //
     /*  996319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  996336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996358 */     // MIs[0] policy
     /*  996358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996368 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996389 */     GIR_RootConstrainSelectedInstOperands,
     /*  996390 */     // GIR_Coverage, 4898,
     /*  996390 */     GIR_EraseRootFromParent_Done,
     /*  996391 */   // Label 14846: @996391
     /*  996391 */   GIM_Try, /*On fail goto*//*Label 14847*/ GIMT_Encode4(996468), // Rule ID 4899 //
     /*  996396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  996407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  996410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  996413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996435 */     // MIs[0] policy
     /*  996435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996445 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996466 */     GIR_RootConstrainSelectedInstOperands,
     /*  996467 */     // GIR_Coverage, 4899,
     /*  996467 */     GIR_EraseRootFromParent_Done,
     /*  996468 */   // Label 14847: @996468
     /*  996468 */   GIM_Try, /*On fail goto*//*Label 14848*/ GIMT_Encode4(996545), // Rule ID 4902 //
     /*  996473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  996484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  996487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  996490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996512 */     // MIs[0] policy
     /*  996512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996522 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996543 */     GIR_RootConstrainSelectedInstOperands,
     /*  996544 */     // GIR_Coverage, 4902,
     /*  996544 */     GIR_EraseRootFromParent_Done,
     /*  996545 */   // Label 14848: @996545
     /*  996545 */   GIM_Try, /*On fail goto*//*Label 14849*/ GIMT_Encode4(996622), // Rule ID 4903 //
     /*  996550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  996561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  996564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  996567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996589 */     // MIs[0] policy
     /*  996589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996599 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11678:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996620 */     GIR_RootConstrainSelectedInstOperands,
     /*  996621 */     // GIR_Coverage, 4903,
     /*  996621 */     GIR_EraseRootFromParent_Done,
     /*  996622 */   // Label 14849: @996622
     /*  996622 */   GIM_Try, /*On fail goto*//*Label 14850*/ GIMT_Encode4(996699), // Rule ID 4906 //
     /*  996627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  996638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  996641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  996644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  996647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996666 */     // MIs[0] policy
     /*  996666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  996679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996697 */     GIR_RootConstrainSelectedInstOperands,
     /*  996698 */     // GIR_Coverage, 4906,
     /*  996698 */     GIR_EraseRootFromParent_Done,
     /*  996699 */   // Label 14850: @996699
     /*  996699 */   GIM_Try, /*On fail goto*//*Label 14851*/ GIMT_Encode4(996776), // Rule ID 4907 //
     /*  996704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  996715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  996718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  996721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  996724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996743 */     // MIs[0] policy
     /*  996743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996753 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  996756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996774 */     GIR_RootConstrainSelectedInstOperands,
     /*  996775 */     // GIR_Coverage, 4907,
     /*  996775 */     GIR_EraseRootFromParent_Done,
     /*  996776 */   // Label 14851: @996776
     /*  996776 */   GIM_Try, /*On fail goto*//*Label 14852*/ GIMT_Encode4(996853), // Rule ID 4910 //
     /*  996781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  996792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  996795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  996798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  996801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996820 */     // MIs[0] policy
     /*  996820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996830 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  996833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996851 */     GIR_RootConstrainSelectedInstOperands,
     /*  996852 */     // GIR_Coverage, 4910,
     /*  996852 */     GIR_EraseRootFromParent_Done,
     /*  996853 */   // Label 14852: @996853
     /*  996853 */   GIM_Try, /*On fail goto*//*Label 14853*/ GIMT_Encode4(996930), // Rule ID 4911 //
     /*  996858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  996869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  996872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  996875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  996878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996897 */     // MIs[0] policy
     /*  996897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996907 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  996910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996928 */     GIR_RootConstrainSelectedInstOperands,
     /*  996929 */     // GIR_Coverage, 4911,
     /*  996929 */     GIR_EraseRootFromParent_Done,
     /*  996930 */   // Label 14853: @996930
     /*  996930 */   GIM_Try, /*On fail goto*//*Label 14854*/ GIMT_Encode4(997007), // Rule ID 4914 //
     /*  996935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  996946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  996949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  996952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  996955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996974 */     // MIs[0] policy
     /*  996974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  996987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997005 */     GIR_RootConstrainSelectedInstOperands,
     /*  997006 */     // GIR_Coverage, 4914,
     /*  997006 */     GIR_EraseRootFromParent_Done,
     /*  997007 */   // Label 14854: @997007
     /*  997007 */   GIM_Try, /*On fail goto*//*Label 14855*/ GIMT_Encode4(997084), // Rule ID 4915 //
     /*  997012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  997023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  997026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  997029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  997032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997051 */     // MIs[0] policy
     /*  997051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997061 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  997080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997082 */     GIR_RootConstrainSelectedInstOperands,
     /*  997083 */     // GIR_Coverage, 4915,
     /*  997083 */     GIR_EraseRootFromParent_Done,
     /*  997084 */   // Label 14855: @997084
     /*  997084 */   GIM_Try, /*On fail goto*//*Label 14856*/ GIMT_Encode4(997161), // Rule ID 4918 //
     /*  997089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  997100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  997103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  997106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997128 */     // MIs[0] policy
     /*  997128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997138 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  997141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997159 */     GIR_RootConstrainSelectedInstOperands,
     /*  997160 */     // GIR_Coverage, 4918,
     /*  997160 */     GIR_EraseRootFromParent_Done,
     /*  997161 */   // Label 14856: @997161
     /*  997161 */   GIM_Try, /*On fail goto*//*Label 14857*/ GIMT_Encode4(997238), // Rule ID 4919 //
     /*  997166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  997177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  997180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  997183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997205 */     // MIs[0] policy
     /*  997205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997215 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  997218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997236 */     GIR_RootConstrainSelectedInstOperands,
     /*  997237 */     // GIR_Coverage, 4919,
     /*  997237 */     GIR_EraseRootFromParent_Done,
     /*  997238 */   // Label 14857: @997238
     /*  997238 */   GIM_Try, /*On fail goto*//*Label 14858*/ GIMT_Encode4(997315), // Rule ID 4922 //
     /*  997243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  997254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  997257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  997260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997282 */     // MIs[0] policy
     /*  997282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997313 */     GIR_RootConstrainSelectedInstOperands,
     /*  997314 */     // GIR_Coverage, 4922,
     /*  997314 */     GIR_EraseRootFromParent_Done,
     /*  997315 */   // Label 14858: @997315
     /*  997315 */   GIM_Try, /*On fail goto*//*Label 14859*/ GIMT_Encode4(997392), // Rule ID 4923 //
     /*  997320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  997331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  997334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  997337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997359 */     // MIs[0] policy
     /*  997359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997369 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997390 */     GIR_RootConstrainSelectedInstOperands,
     /*  997391 */     // GIR_Coverage, 4923,
     /*  997391 */     GIR_EraseRootFromParent_Done,
     /*  997392 */   // Label 14859: @997392
     /*  997392 */   GIM_Try, /*On fail goto*//*Label 14860*/ GIMT_Encode4(997469), // Rule ID 4926 //
     /*  997397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  997414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997436 */     // MIs[0] policy
     /*  997436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997467 */     GIR_RootConstrainSelectedInstOperands,
     /*  997468 */     // GIR_Coverage, 4926,
     /*  997468 */     GIR_EraseRootFromParent_Done,
     /*  997469 */   // Label 14860: @997469
     /*  997469 */   GIM_Try, /*On fail goto*//*Label 14861*/ GIMT_Encode4(997546), // Rule ID 4927 //
     /*  997474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  997485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  997488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  997491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997513 */     // MIs[0] policy
     /*  997513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997523 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997544 */     GIR_RootConstrainSelectedInstOperands,
     /*  997545 */     // GIR_Coverage, 4927,
     /*  997545 */     GIR_EraseRootFromParent_Done,
     /*  997546 */   // Label 14861: @997546
     /*  997546 */   GIM_Try, /*On fail goto*//*Label 14862*/ GIMT_Encode4(997623), // Rule ID 4930 //
     /*  997551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  997568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997590 */     // MIs[0] policy
     /*  997590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997600 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997621 */     GIR_RootConstrainSelectedInstOperands,
     /*  997622 */     // GIR_Coverage, 4930,
     /*  997622 */     GIR_EraseRootFromParent_Done,
     /*  997623 */   // Label 14862: @997623
     /*  997623 */   GIM_Try, /*On fail goto*//*Label 14863*/ GIMT_Encode4(997700), // Rule ID 4931 //
     /*  997628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  997645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997667 */     // MIs[0] policy
     /*  997667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997677 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997698 */     GIR_RootConstrainSelectedInstOperands,
     /*  997699 */     // GIR_Coverage, 4931,
     /*  997699 */     GIR_EraseRootFromParent_Done,
     /*  997700 */   // Label 14863: @997700
     /*  997700 */   GIM_Try, /*On fail goto*//*Label 14864*/ GIMT_Encode4(997777), // Rule ID 4934 //
     /*  997705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  997722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997744 */     // MIs[0] policy
     /*  997744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997754 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997775 */     GIR_RootConstrainSelectedInstOperands,
     /*  997776 */     // GIR_Coverage, 4934,
     /*  997776 */     GIR_EraseRootFromParent_Done,
     /*  997777 */   // Label 14864: @997777
     /*  997777 */   GIM_Try, /*On fail goto*//*Label 14865*/ GIMT_Encode4(997854), // Rule ID 4935 //
     /*  997782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  997799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997821 */     // MIs[0] policy
     /*  997821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997831 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997852 */     GIR_RootConstrainSelectedInstOperands,
     /*  997853 */     // GIR_Coverage, 4935,
     /*  997853 */     GIR_EraseRootFromParent_Done,
     /*  997854 */   // Label 14865: @997854
     /*  997854 */   GIM_Try, /*On fail goto*//*Label 14866*/ GIMT_Encode4(997931), // Rule ID 4938 //
     /*  997859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  997862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  997876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997898 */     // MIs[0] policy
     /*  997898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997929 */     GIR_RootConstrainSelectedInstOperands,
     /*  997930 */     // GIR_Coverage, 4938,
     /*  997930 */     GIR_EraseRootFromParent_Done,
     /*  997931 */   // Label 14866: @997931
     /*  997931 */   GIM_Try, /*On fail goto*//*Label 14867*/ GIMT_Encode4(998008), // Rule ID 4939 //
     /*  997936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  997939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  997953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997975 */     // MIs[0] policy
     /*  997975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997985 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998006 */     GIR_RootConstrainSelectedInstOperands,
     /*  998007 */     // GIR_Coverage, 4939,
     /*  998007 */     GIR_EraseRootFromParent_Done,
     /*  998008 */   // Label 14867: @998008
     /*  998008 */   GIM_Try, /*On fail goto*//*Label 14868*/ GIMT_Encode4(998085), // Rule ID 4942 //
     /*  998013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  998030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998052 */     // MIs[0] policy
     /*  998052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  998065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998083 */     GIR_RootConstrainSelectedInstOperands,
     /*  998084 */     // GIR_Coverage, 4942,
     /*  998084 */     GIR_EraseRootFromParent_Done,
     /*  998085 */   // Label 14868: @998085
     /*  998085 */   GIM_Try, /*On fail goto*//*Label 14869*/ GIMT_Encode4(998162), // Rule ID 4943 //
     /*  998090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  998107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998129 */     // MIs[0] policy
     /*  998129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998139 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  998142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998148 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998160 */     GIR_RootConstrainSelectedInstOperands,
     /*  998161 */     // GIR_Coverage, 4943,
     /*  998161 */     GIR_EraseRootFromParent_Done,
     /*  998162 */   // Label 14869: @998162
     /*  998162 */   GIM_Try, /*On fail goto*//*Label 14870*/ GIMT_Encode4(998239), // Rule ID 4946 //
     /*  998167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  998184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998206 */     // MIs[0] policy
     /*  998206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998237 */     GIR_RootConstrainSelectedInstOperands,
     /*  998238 */     // GIR_Coverage, 4946,
     /*  998238 */     GIR_EraseRootFromParent_Done,
     /*  998239 */   // Label 14870: @998239
     /*  998239 */   GIM_Try, /*On fail goto*//*Label 14871*/ GIMT_Encode4(998316), // Rule ID 4947 //
     /*  998244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  998255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  998258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  998261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998283 */     // MIs[0] policy
     /*  998283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998293 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  998296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998314 */     GIR_RootConstrainSelectedInstOperands,
     /*  998315 */     // GIR_Coverage, 4947,
     /*  998315 */     GIR_EraseRootFromParent_Done,
     /*  998316 */   // Label 14871: @998316
     /*  998316 */   GIM_Try, /*On fail goto*//*Label 14872*/ GIMT_Encode4(998393), // Rule ID 4950 //
     /*  998321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998360 */     // MIs[0] policy
     /*  998360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998370 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998391 */     GIR_RootConstrainSelectedInstOperands,
     /*  998392 */     // GIR_Coverage, 4950,
     /*  998392 */     GIR_EraseRootFromParent_Done,
     /*  998393 */   // Label 14872: @998393
     /*  998393 */   GIM_Try, /*On fail goto*//*Label 14873*/ GIMT_Encode4(998470), // Rule ID 4951 //
     /*  998398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  998409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  998412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  998415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998437 */     // MIs[0] policy
     /*  998437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998447 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  998450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998456 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998468 */     GIR_RootConstrainSelectedInstOperands,
     /*  998469 */     // GIR_Coverage, 4951,
     /*  998469 */     GIR_EraseRootFromParent_Done,
     /*  998470 */   // Label 14873: @998470
     /*  998470 */   GIM_Try, /*On fail goto*//*Label 14874*/ GIMT_Encode4(998547), // Rule ID 4954 //
     /*  998475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  998492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998514 */     // MIs[0] policy
     /*  998514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998524 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  998527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998545 */     GIR_RootConstrainSelectedInstOperands,
     /*  998546 */     // GIR_Coverage, 4954,
     /*  998546 */     GIR_EraseRootFromParent_Done,
     /*  998547 */   // Label 14874: @998547
     /*  998547 */   GIM_Try, /*On fail goto*//*Label 14875*/ GIMT_Encode4(998624), // Rule ID 4955 //
     /*  998552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  998569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998591 */     // MIs[0] policy
     /*  998591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998601 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  998604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998610 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998622 */     GIR_RootConstrainSelectedInstOperands,
     /*  998623 */     // GIR_Coverage, 4955,
     /*  998623 */     GIR_EraseRootFromParent_Done,
     /*  998624 */   // Label 14875: @998624
     /*  998624 */   GIM_Try, /*On fail goto*//*Label 14876*/ GIMT_Encode4(998701), // Rule ID 4958 //
     /*  998629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  998646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998668 */     // MIs[0] policy
     /*  998668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  998681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998699 */     GIR_RootConstrainSelectedInstOperands,
     /*  998700 */     // GIR_Coverage, 4958,
     /*  998700 */     GIR_EraseRootFromParent_Done,
     /*  998701 */   // Label 14876: @998701
     /*  998701 */   GIM_Try, /*On fail goto*//*Label 14877*/ GIMT_Encode4(998778), // Rule ID 4959 //
     /*  998706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  998723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998745 */     // MIs[0] policy
     /*  998745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998755 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11678:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  998758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998764 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998776 */     GIR_RootConstrainSelectedInstOperands,
     /*  998777 */     // GIR_Coverage, 4959,
     /*  998777 */     GIR_EraseRootFromParent_Done,
     /*  998778 */   // Label 14877: @998778
     /*  998778 */   GIM_Try, /*On fail goto*//*Label 14878*/ GIMT_Encode4(998855), // Rule ID 4962 //
     /*  998783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  998800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998822 */     // MIs[0] policy
     /*  998822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  998835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998853 */     GIR_RootConstrainSelectedInstOperands,
     /*  998854 */     // GIR_Coverage, 4962,
     /*  998854 */     GIR_EraseRootFromParent_Done,
     /*  998855 */   // Label 14878: @998855
     /*  998855 */   GIM_Try, /*On fail goto*//*Label 14879*/ GIMT_Encode4(998932), // Rule ID 4963 //
     /*  998860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  998877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998899 */     // MIs[0] policy
     /*  998899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998909 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  998912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998918 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998930 */     GIR_RootConstrainSelectedInstOperands,
     /*  998931 */     // GIR_Coverage, 4963,
     /*  998931 */     GIR_EraseRootFromParent_Done,
     /*  998932 */   // Label 14879: @998932
     /*  998932 */   GIM_Try, /*On fail goto*//*Label 14880*/ GIMT_Encode4(999009), // Rule ID 4966 //
     /*  998937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  998954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998976 */     // MIs[0] policy
     /*  998976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  998989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999007 */     GIR_RootConstrainSelectedInstOperands,
     /*  999008 */     // GIR_Coverage, 4966,
     /*  999008 */     GIR_EraseRootFromParent_Done,
     /*  999009 */   // Label 14880: @999009
     /*  999009 */   GIM_Try, /*On fail goto*//*Label 14881*/ GIMT_Encode4(999086), // Rule ID 4967 //
     /*  999014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  999025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  999028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999053 */     // MIs[0] policy
     /*  999053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999063 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999084 */     GIR_RootConstrainSelectedInstOperands,
     /*  999085 */     // GIR_Coverage, 4967,
     /*  999085 */     GIR_EraseRootFromParent_Done,
     /*  999086 */   // Label 14881: @999086
     /*  999086 */   GIM_Try, /*On fail goto*//*Label 14882*/ GIMT_Encode4(999163), // Rule ID 4970 //
     /*  999091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  999102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  999105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  999108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  999111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999130 */     // MIs[0] policy
     /*  999130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999161 */     GIR_RootConstrainSelectedInstOperands,
     /*  999162 */     // GIR_Coverage, 4970,
     /*  999162 */     GIR_EraseRootFromParent_Done,
     /*  999163 */   // Label 14882: @999163
     /*  999163 */   GIM_Try, /*On fail goto*//*Label 14883*/ GIMT_Encode4(999240), // Rule ID 4971 //
     /*  999168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  999171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  999179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  999182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  999185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  999188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999207 */     // MIs[0] policy
     /*  999207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999217 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999226 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  999236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999238 */     GIR_RootConstrainSelectedInstOperands,
     /*  999239 */     // GIR_Coverage, 4971,
     /*  999239 */     GIR_EraseRootFromParent_Done,
     /*  999240 */   // Label 14883: @999240
     /*  999240 */   GIM_Try, /*On fail goto*//*Label 14884*/ GIMT_Encode4(999317), // Rule ID 4974 //
     /*  999245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999284 */     // MIs[0] policy
     /*  999284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999315 */     GIR_RootConstrainSelectedInstOperands,
     /*  999316 */     // GIR_Coverage, 4974,
     /*  999316 */     GIR_EraseRootFromParent_Done,
     /*  999317 */   // Label 14884: @999317
     /*  999317 */   GIM_Try, /*On fail goto*//*Label 14885*/ GIMT_Encode4(999394), // Rule ID 4975 //
     /*  999322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  999339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999361 */     // MIs[0] policy
     /*  999361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999371 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  999374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999392 */     GIR_RootConstrainSelectedInstOperands,
     /*  999393 */     // GIR_Coverage, 4975,
     /*  999393 */     GIR_EraseRootFromParent_Done,
     /*  999394 */   // Label 14885: @999394
     /*  999394 */   GIM_Try, /*On fail goto*//*Label 14886*/ GIMT_Encode4(999471), // Rule ID 4978 //
     /*  999399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999438 */     // MIs[0] policy
     /*  999438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999469 */     GIR_RootConstrainSelectedInstOperands,
     /*  999470 */     // GIR_Coverage, 4978,
     /*  999470 */     GIR_EraseRootFromParent_Done,
     /*  999471 */   // Label 14886: @999471
     /*  999471 */   GIM_Try, /*On fail goto*//*Label 14887*/ GIMT_Encode4(999548), // Rule ID 4979 //
     /*  999476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  999493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999515 */     // MIs[0] policy
     /*  999515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999525 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999546 */     GIR_RootConstrainSelectedInstOperands,
     /*  999547 */     // GIR_Coverage, 4979,
     /*  999547 */     GIR_EraseRootFromParent_Done,
     /*  999548 */   // Label 14887: @999548
     /*  999548 */   GIM_Try, /*On fail goto*//*Label 14888*/ GIMT_Encode4(999625), // Rule ID 4982 //
     /*  999553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  999570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999592 */     // MIs[0] policy
     /*  999592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999602 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999623 */     GIR_RootConstrainSelectedInstOperands,
     /*  999624 */     // GIR_Coverage, 4982,
     /*  999624 */     GIR_EraseRootFromParent_Done,
     /*  999625 */   // Label 14888: @999625
     /*  999625 */   GIM_Try, /*On fail goto*//*Label 14889*/ GIMT_Encode4(999702), // Rule ID 4983 //
     /*  999630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  999647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999669 */     // MIs[0] policy
     /*  999669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999679 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999688 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999700 */     GIR_RootConstrainSelectedInstOperands,
     /*  999701 */     // GIR_Coverage, 4983,
     /*  999701 */     GIR_EraseRootFromParent_Done,
     /*  999702 */   // Label 14889: @999702
     /*  999702 */   GIM_Try, /*On fail goto*//*Label 14890*/ GIMT_Encode4(999779), // Rule ID 4986 //
     /*  999707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  999724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999746 */     // MIs[0] policy
     /*  999746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999756 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999777 */     GIR_RootConstrainSelectedInstOperands,
     /*  999778 */     // GIR_Coverage, 4986,
     /*  999778 */     GIR_EraseRootFromParent_Done,
     /*  999779 */   // Label 14890: @999779
     /*  999779 */   GIM_Try, /*On fail goto*//*Label 14891*/ GIMT_Encode4(999856), // Rule ID 4987 //
     /*  999784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  999801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999823 */     // MIs[0] policy
     /*  999823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999833 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999854 */     GIR_RootConstrainSelectedInstOperands,
     /*  999855 */     // GIR_Coverage, 4987,
     /*  999855 */     GIR_EraseRootFromParent_Done,
     /*  999856 */   // Label 14891: @999856
     /*  999856 */   GIM_Try, /*On fail goto*//*Label 14892*/ GIMT_Encode4(999933), // Rule ID 4990 //
     /*  999861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999900 */     // MIs[0] policy
     /*  999900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999910 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /*  999913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999931 */     GIR_RootConstrainSelectedInstOperands,
     /*  999932 */     // GIR_Coverage, 4990,
     /*  999932 */     GIR_EraseRootFromParent_Done,
     /*  999933 */   // Label 14892: @999933
     /*  999933 */   GIM_Try, /*On fail goto*//*Label 14893*/ GIMT_Encode4(1000010), // Rule ID 4991 //
     /*  999938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999977 */     // MIs[0] policy
     /*  999977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999987 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11678:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /*  999990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999996 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000009 */     // GIR_Coverage, 4991,
     /* 1000009 */     GIR_EraseRootFromParent_Done,
     /* 1000010 */   // Label 14893: @1000010
     /* 1000010 */   GIM_Try, /*On fail goto*//*Label 14894*/ GIMT_Encode4(1000087), // Rule ID 4994 //
     /* 1000015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1000026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1000029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000054 */     // MIs[0] policy
     /* 1000054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1000067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000086 */     // GIR_Coverage, 4994,
     /* 1000086 */     GIR_EraseRootFromParent_Done,
     /* 1000087 */   // Label 14894: @1000087
     /* 1000087 */   GIM_Try, /*On fail goto*//*Label 14895*/ GIMT_Encode4(1000164), // Rule ID 4995 //
     /* 1000092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1000103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1000106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000131 */     // MIs[0] policy
     /* 1000131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11678:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /* 1000144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000150 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000163 */     // GIR_Coverage, 4995,
     /* 1000163 */     GIR_EraseRootFromParent_Done,
     /* 1000164 */   // Label 14895: @1000164
     /* 1000164 */   GIM_Try, /*On fail goto*//*Label 14896*/ GIMT_Encode4(1000241), // Rule ID 4998 //
     /* 1000169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000208 */     // MIs[0] policy
     /* 1000208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000218 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1000221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000240 */     // GIR_Coverage, 4998,
     /* 1000240 */     GIR_EraseRootFromParent_Done,
     /* 1000241 */   // Label 14896: @1000241
     /* 1000241 */   GIM_Try, /*On fail goto*//*Label 14897*/ GIMT_Encode4(1000318), // Rule ID 4999 //
     /* 1000246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1000257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1000260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000285 */     // MIs[0] policy
     /* 1000285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000295 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11678:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /* 1000298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000317 */     // GIR_Coverage, 4999,
     /* 1000317 */     GIR_EraseRootFromParent_Done,
     /* 1000318 */   // Label 14897: @1000318
     /* 1000318 */   GIM_Try, /*On fail goto*//*Label 14898*/ GIMT_Encode4(1000395), // Rule ID 5002 //
     /* 1000323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1000326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000362 */     // MIs[0] policy
     /* 1000362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000372 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1000375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000394 */     // GIR_Coverage, 5002,
     /* 1000394 */     GIR_EraseRootFromParent_Done,
     /* 1000395 */   // Label 14898: @1000395
     /* 1000395 */   GIM_Try, /*On fail goto*//*Label 14899*/ GIMT_Encode4(1000472), // Rule ID 5003 //
     /* 1000400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1000403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /* 1000408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1000411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1000414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000439 */     // MIs[0] policy
     /* 1000439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000449 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11678:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /* 1000452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1000468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000471 */     // GIR_Coverage, 5003,
     /* 1000471 */     GIR_EraseRootFromParent_Done,
     /* 1000472 */   // Label 14899: @1000472
     /* 1000472 */   GIM_Try, /*On fail goto*//*Label 14900*/ GIMT_Encode4(1000549), // Rule ID 5006 //
     /* 1000477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1000488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1000491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000516 */     // MIs[0] policy
     /* 1000516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000526 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1000529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000548 */     // GIR_Coverage, 5006,
     /* 1000548 */     GIR_EraseRootFromParent_Done,
     /* 1000549 */   // Label 14900: @1000549
     /* 1000549 */   GIM_Try, /*On fail goto*//*Label 14901*/ GIMT_Encode4(1000626), // Rule ID 5007 //
     /* 1000554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1000565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1000568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000593 */     // MIs[0] policy
     /* 1000593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000603 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1000606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000625 */     // GIR_Coverage, 5007,
     /* 1000625 */     GIR_EraseRootFromParent_Done,
     /* 1000626 */   // Label 14901: @1000626
     /* 1000626 */   GIM_Try, /*On fail goto*//*Label 14902*/ GIMT_Encode4(1000703), // Rule ID 5010 //
     /* 1000631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000670 */     // MIs[0] policy
     /* 1000670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000680 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1000683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000702 */     // GIR_Coverage, 5010,
     /* 1000702 */     GIR_EraseRootFromParent_Done,
     /* 1000703 */   // Label 14902: @1000703
     /* 1000703 */   GIM_Try, /*On fail goto*//*Label 14903*/ GIMT_Encode4(1000780), // Rule ID 5011 //
     /* 1000708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000747 */     // MIs[0] policy
     /* 1000747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000757 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1000760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000766 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000779 */     // GIR_Coverage, 5011,
     /* 1000779 */     GIR_EraseRootFromParent_Done,
     /* 1000780 */   // Label 14903: @1000780
     /* 1000780 */   GIM_Try, /*On fail goto*//*Label 14904*/ GIMT_Encode4(1000857), // Rule ID 5014 //
     /* 1000785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000824 */     // MIs[0] policy
     /* 1000824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000834 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1000837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000856 */     // GIR_Coverage, 5014,
     /* 1000856 */     GIR_EraseRootFromParent_Done,
     /* 1000857 */   // Label 14904: @1000857
     /* 1000857 */   GIM_Try, /*On fail goto*//*Label 14905*/ GIMT_Encode4(1000934), // Rule ID 5015 //
     /* 1000862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000901 */     // MIs[0] policy
     /* 1000901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000911 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11541:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1000914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000920 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000933 */     // GIR_Coverage, 5015,
     /* 1000933 */     GIR_EraseRootFromParent_Done,
     /* 1000934 */   // Label 14905: @1000934
     /* 1000934 */   GIM_Try, /*On fail goto*//*Label 14906*/ GIMT_Encode4(1001011), // Rule ID 5018 //
     /* 1000939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000978 */     // MIs[0] policy
     /* 1000978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1000991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001010 */     // GIR_Coverage, 5018,
     /* 1001010 */     GIR_EraseRootFromParent_Done,
     /* 1001011 */   // Label 14906: @1001011
     /* 1001011 */   GIM_Try, /*On fail goto*//*Label 14907*/ GIMT_Encode4(1001088), // Rule ID 5019 //
     /* 1001016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1001027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1001030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1001033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001055 */     // MIs[0] policy
     /* 1001055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001065 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001087 */     // GIR_Coverage, 5019,
     /* 1001087 */     GIR_EraseRootFromParent_Done,
     /* 1001088 */   // Label 14907: @1001088
     /* 1001088 */   GIM_Try, /*On fail goto*//*Label 14908*/ GIMT_Encode4(1001165), // Rule ID 5022 //
     /* 1001093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1001104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1001107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1001110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001132 */     // MIs[0] policy
     /* 1001132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001142 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001164 */     // GIR_Coverage, 5022,
     /* 1001164 */     GIR_EraseRootFromParent_Done,
     /* 1001165 */   // Label 14908: @1001165
     /* 1001165 */   GIM_Try, /*On fail goto*//*Label 14909*/ GIMT_Encode4(1001242), // Rule ID 5023 //
     /* 1001170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1001181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1001184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1001187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001209 */     // MIs[0] policy
     /* 1001209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001219 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001228 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001241 */     // GIR_Coverage, 5023,
     /* 1001241 */     GIR_EraseRootFromParent_Done,
     /* 1001242 */   // Label 14909: @1001242
     /* 1001242 */   GIM_Try, /*On fail goto*//*Label 14910*/ GIMT_Encode4(1001319), // Rule ID 5026 //
     /* 1001247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1001264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001286 */     // MIs[0] policy
     /* 1001286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001318 */     // GIR_Coverage, 5026,
     /* 1001318 */     GIR_EraseRootFromParent_Done,
     /* 1001319 */   // Label 14910: @1001319
     /* 1001319 */   GIM_Try, /*On fail goto*//*Label 14911*/ GIMT_Encode4(1001396), // Rule ID 5027 //
     /* 1001324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1001335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1001338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1001341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1001344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001363 */     // MIs[0] policy
     /* 1001363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001373 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1001392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001395 */     // GIR_Coverage, 5027,
     /* 1001395 */     GIR_EraseRootFromParent_Done,
     /* 1001396 */   // Label 14911: @1001396
     /* 1001396 */   GIM_Try, /*On fail goto*//*Label 14912*/ GIMT_Encode4(1001473), // Rule ID 5030 //
     /* 1001401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001440 */     // MIs[0] policy
     /* 1001440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001450 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001472 */     // GIR_Coverage, 5030,
     /* 1001472 */     GIR_EraseRootFromParent_Done,
     /* 1001473 */   // Label 14912: @1001473
     /* 1001473 */   GIM_Try, /*On fail goto*//*Label 14913*/ GIMT_Encode4(1001550), // Rule ID 5031 //
     /* 1001478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1001489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1001492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1001495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001517 */     // MIs[0] policy
     /* 1001517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001527 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001549 */     // GIR_Coverage, 5031,
     /* 1001549 */     GIR_EraseRootFromParent_Done,
     /* 1001550 */   // Label 14913: @1001550
     /* 1001550 */   GIM_Try, /*On fail goto*//*Label 14914*/ GIMT_Encode4(1001627), // Rule ID 5034 //
     /* 1001555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001594 */     // MIs[0] policy
     /* 1001594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001626 */     // GIR_Coverage, 5034,
     /* 1001626 */     GIR_EraseRootFromParent_Done,
     /* 1001627 */   // Label 14914: @1001627
     /* 1001627 */   GIM_Try, /*On fail goto*//*Label 14915*/ GIMT_Encode4(1001704), // Rule ID 5035 //
     /* 1001632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001671 */     // MIs[0] policy
     /* 1001671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001681 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001703 */     // GIR_Coverage, 5035,
     /* 1001703 */     GIR_EraseRootFromParent_Done,
     /* 1001704 */   // Label 14915: @1001704
     /* 1001704 */   GIM_Try, /*On fail goto*//*Label 14916*/ GIMT_Encode4(1001781), // Rule ID 5038 //
     /* 1001709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001748 */     // MIs[0] policy
     /* 1001748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001780 */     // GIR_Coverage, 5038,
     /* 1001780 */     GIR_EraseRootFromParent_Done,
     /* 1001781 */   // Label 14916: @1001781
     /* 1001781 */   GIM_Try, /*On fail goto*//*Label 14917*/ GIMT_Encode4(1001858), // Rule ID 5039 //
     /* 1001786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001825 */     // MIs[0] policy
     /* 1001825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001857 */     // GIR_Coverage, 5039,
     /* 1001857 */     GIR_EraseRootFromParent_Done,
     /* 1001858 */   // Label 14917: @1001858
     /* 1001858 */   GIM_Try, /*On fail goto*//*Label 14918*/ GIMT_Encode4(1001935), // Rule ID 5042 //
     /* 1001863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001902 */     // MIs[0] policy
     /* 1001902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001912 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001934 */     // GIR_Coverage, 5042,
     /* 1001934 */     GIR_EraseRootFromParent_Done,
     /* 1001935 */   // Label 14918: @1001935
     /* 1001935 */   GIM_Try, /*On fail goto*//*Label 14919*/ GIMT_Encode4(1002012), // Rule ID 5043 //
     /* 1001940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001979 */     // MIs[0] policy
     /* 1001979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001989 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002011 */     // GIR_Coverage, 5043,
     /* 1002011 */     GIR_EraseRootFromParent_Done,
     /* 1002012 */   // Label 14919: @1002012
     /* 1002012 */   GIM_Try, /*On fail goto*//*Label 14920*/ GIMT_Encode4(1002089), // Rule ID 5046 //
     /* 1002017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1002034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002056 */     // MIs[0] policy
     /* 1002056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002088 */     // GIR_Coverage, 5046,
     /* 1002088 */     GIR_EraseRootFromParent_Done,
     /* 1002089 */   // Label 14920: @1002089
     /* 1002089 */   GIM_Try, /*On fail goto*//*Label 14921*/ GIMT_Encode4(1002166), // Rule ID 5047 //
     /* 1002094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1002111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002133 */     // MIs[0] policy
     /* 1002133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002143 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002165 */     // GIR_Coverage, 5047,
     /* 1002165 */     GIR_EraseRootFromParent_Done,
     /* 1002166 */   // Label 14921: @1002166
     /* 1002166 */   GIM_Try, /*On fail goto*//*Label 14922*/ GIMT_Encode4(1002243), // Rule ID 5050 //
     /* 1002171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1002182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1002185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1002188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002210 */     // MIs[0] policy
     /* 1002210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002220 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002242 */     // GIR_Coverage, 5050,
     /* 1002242 */     GIR_EraseRootFromParent_Done,
     /* 1002243 */   // Label 14922: @1002243
     /* 1002243 */   GIM_Try, /*On fail goto*//*Label 14923*/ GIMT_Encode4(1002320), // Rule ID 5051 //
     /* 1002248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1002259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1002262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1002265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002287 */     // MIs[0] policy
     /* 1002287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002297 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1002300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002319 */     // GIR_Coverage, 5051,
     /* 1002319 */     GIR_EraseRootFromParent_Done,
     /* 1002320 */   // Label 14923: @1002320
     /* 1002320 */   GIM_Try, /*On fail goto*//*Label 14924*/ GIMT_Encode4(1002397), // Rule ID 5054 //
     /* 1002325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1002336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1002339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1002342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002364 */     // MIs[0] policy
     /* 1002364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002396 */     // GIR_Coverage, 5054,
     /* 1002396 */     GIR_EraseRootFromParent_Done,
     /* 1002397 */   // Label 14924: @1002397
     /* 1002397 */   GIM_Try, /*On fail goto*//*Label 14925*/ GIMT_Encode4(1002474), // Rule ID 5055 //
     /* 1002402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1002413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1002416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1002419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002441 */     // MIs[0] policy
     /* 1002441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1002454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002473 */     // GIR_Coverage, 5055,
     /* 1002473 */     GIR_EraseRootFromParent_Done,
     /* 1002474 */   // Label 14925: @1002474
     /* 1002474 */   GIM_Try, /*On fail goto*//*Label 14926*/ GIMT_Encode4(1002551), // Rule ID 5058 //
     /* 1002479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002518 */     // MIs[0] policy
     /* 1002518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002528 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002550 */     // GIR_Coverage, 5058,
     /* 1002550 */     GIR_EraseRootFromParent_Done,
     /* 1002551 */   // Label 14926: @1002551
     /* 1002551 */   GIM_Try, /*On fail goto*//*Label 14927*/ GIMT_Encode4(1002628), // Rule ID 5059 //
     /* 1002556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002595 */     // MIs[0] policy
     /* 1002595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002605 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002627 */     // GIR_Coverage, 5059,
     /* 1002627 */     GIR_EraseRootFromParent_Done,
     /* 1002628 */   // Label 14927: @1002628
     /* 1002628 */   GIM_Try, /*On fail goto*//*Label 14928*/ GIMT_Encode4(1002705), // Rule ID 5062 //
     /* 1002633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002672 */     // MIs[0] policy
     /* 1002672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002682 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002704 */     // GIR_Coverage, 5062,
     /* 1002704 */     GIR_EraseRootFromParent_Done,
     /* 1002705 */   // Label 14928: @1002705
     /* 1002705 */   GIM_Try, /*On fail goto*//*Label 14929*/ GIMT_Encode4(1002782), // Rule ID 5063 //
     /* 1002710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002749 */     // MIs[0] policy
     /* 1002749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002759 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002768 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002781 */     // GIR_Coverage, 5063,
     /* 1002781 */     GIR_EraseRootFromParent_Done,
     /* 1002782 */   // Label 14929: @1002782
     /* 1002782 */   GIM_Try, /*On fail goto*//*Label 14930*/ GIMT_Encode4(1002859), // Rule ID 5066 //
     /* 1002787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002826 */     // MIs[0] policy
     /* 1002826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002836 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1002839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002858 */     // GIR_Coverage, 5066,
     /* 1002858 */     GIR_EraseRootFromParent_Done,
     /* 1002859 */   // Label 14930: @1002859
     /* 1002859 */   GIM_Try, /*On fail goto*//*Label 14931*/ GIMT_Encode4(1002936), // Rule ID 5067 //
     /* 1002864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002903 */     // MIs[0] policy
     /* 1002903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002913 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1002916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002922 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002935 */     // GIR_Coverage, 5067,
     /* 1002935 */     GIR_EraseRootFromParent_Done,
     /* 1002936 */   // Label 14931: @1002936
     /* 1002936 */   GIM_Try, /*On fail goto*//*Label 14932*/ GIMT_Encode4(1003013), // Rule ID 5070 //
     /* 1002941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002980 */     // MIs[0] policy
     /* 1002980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1002993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003012 */     // GIR_Coverage, 5070,
     /* 1003012 */     GIR_EraseRootFromParent_Done,
     /* 1003013 */   // Label 14932: @1003013
     /* 1003013 */   GIM_Try, /*On fail goto*//*Label 14933*/ GIMT_Encode4(1003090), // Rule ID 5071 //
     /* 1003018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1003029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1003032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003057 */     // MIs[0] policy
     /* 1003057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003067 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11541:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003089 */     // GIR_Coverage, 5071,
     /* 1003089 */     GIR_EraseRootFromParent_Done,
     /* 1003090 */   // Label 14933: @1003090
     /* 1003090 */   GIM_Try, /*On fail goto*//*Label 14934*/ GIMT_Encode4(1003167), // Rule ID 5074 //
     /* 1003095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1003106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1003109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1003112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003134 */     // MIs[0] policy
     /* 1003134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003166 */     // GIR_Coverage, 5074,
     /* 1003166 */     GIR_EraseRootFromParent_Done,
     /* 1003167 */   // Label 14934: @1003167
     /* 1003167 */   GIM_Try, /*On fail goto*//*Label 14935*/ GIMT_Encode4(1003244), // Rule ID 5075 //
     /* 1003172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1003183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1003186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1003189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003211 */     // MIs[0] policy
     /* 1003211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003221 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003243 */     // GIR_Coverage, 5075,
     /* 1003243 */     GIR_EraseRootFromParent_Done,
     /* 1003244 */   // Label 14935: @1003244
     /* 1003244 */   GIM_Try, /*On fail goto*//*Label 14936*/ GIMT_Encode4(1003321), // Rule ID 5078 //
     /* 1003249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1003260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1003263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003288 */     // MIs[0] policy
     /* 1003288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003298 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003320 */     // GIR_Coverage, 5078,
     /* 1003320 */     GIR_EraseRootFromParent_Done,
     /* 1003321 */   // Label 14936: @1003321
     /* 1003321 */   GIM_Try, /*On fail goto*//*Label 14937*/ GIMT_Encode4(1003398), // Rule ID 5079 //
     /* 1003326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1003337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1003340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1003343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003365 */     // MIs[0] policy
     /* 1003365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003375 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003397 */     // GIR_Coverage, 5079,
     /* 1003397 */     GIR_EraseRootFromParent_Done,
     /* 1003398 */   // Label 14937: @1003398
     /* 1003398 */   GIM_Try, /*On fail goto*//*Label 14938*/ GIMT_Encode4(1003475), // Rule ID 5082 //
     /* 1003403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1003406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003442 */     // MIs[0] policy
     /* 1003442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003474 */     // GIR_Coverage, 5082,
     /* 1003474 */     GIR_EraseRootFromParent_Done,
     /* 1003475 */   // Label 14938: @1003475
     /* 1003475 */   GIM_Try, /*On fail goto*//*Label 14939*/ GIMT_Encode4(1003552), // Rule ID 5083 //
     /* 1003480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1003483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1003491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1003494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1003497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1003500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003519 */     // MIs[0] policy
     /* 1003519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003529 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003538 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003551 */     // GIR_Coverage, 5083,
     /* 1003551 */     GIR_EraseRootFromParent_Done,
     /* 1003552 */   // Label 14939: @1003552
     /* 1003552 */   GIM_Try, /*On fail goto*//*Label 14940*/ GIMT_Encode4(1003629), // Rule ID 5086 //
     /* 1003557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003596 */     // MIs[0] policy
     /* 1003596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003628 */     // GIR_Coverage, 5086,
     /* 1003628 */     GIR_EraseRootFromParent_Done,
     /* 1003629 */   // Label 14940: @1003629
     /* 1003629 */   GIM_Try, /*On fail goto*//*Label 14941*/ GIMT_Encode4(1003706), // Rule ID 5087 //
     /* 1003634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003673 */     // MIs[0] policy
     /* 1003673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003683 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003705 */     // GIR_Coverage, 5087,
     /* 1003705 */     GIR_EraseRootFromParent_Done,
     /* 1003706 */   // Label 14941: @1003706
     /* 1003706 */   GIM_Try, /*On fail goto*//*Label 14942*/ GIMT_Encode4(1003783), // Rule ID 5090 //
     /* 1003711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003750 */     // MIs[0] policy
     /* 1003750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003782 */     // GIR_Coverage, 5090,
     /* 1003782 */     GIR_EraseRootFromParent_Done,
     /* 1003783 */   // Label 14942: @1003783
     /* 1003783 */   GIM_Try, /*On fail goto*//*Label 14943*/ GIMT_Encode4(1003860), // Rule ID 5091 //
     /* 1003788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003827 */     // MIs[0] policy
     /* 1003827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003837 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003846 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003859 */     // GIR_Coverage, 5091,
     /* 1003859 */     GIR_EraseRootFromParent_Done,
     /* 1003860 */   // Label 14943: @1003860
     /* 1003860 */   GIM_Try, /*On fail goto*//*Label 14944*/ GIMT_Encode4(1003937), // Rule ID 5094 //
     /* 1003865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003904 */     // MIs[0] policy
     /* 1003904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003914 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003936 */     // GIR_Coverage, 5094,
     /* 1003936 */     GIR_EraseRootFromParent_Done,
     /* 1003937 */   // Label 14944: @1003937
     /* 1003937 */   GIM_Try, /*On fail goto*//*Label 14945*/ GIMT_Encode4(1004014), // Rule ID 5095 //
     /* 1003942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003981 */     // MIs[0] policy
     /* 1003981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003991 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004013 */     // GIR_Coverage, 5095,
     /* 1004013 */     GIR_EraseRootFromParent_Done,
     /* 1004014 */   // Label 14945: @1004014
     /* 1004014 */   GIM_Try, /*On fail goto*//*Label 14946*/ GIMT_Encode4(1004091), // Rule ID 5098 //
     /* 1004019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004058 */     // MIs[0] policy
     /* 1004058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004068 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1004071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004090 */     // GIR_Coverage, 5098,
     /* 1004090 */     GIR_EraseRootFromParent_Done,
     /* 1004091 */   // Label 14946: @1004091
     /* 1004091 */   GIM_Try, /*On fail goto*//*Label 14947*/ GIMT_Encode4(1004168), // Rule ID 5099 //
     /* 1004096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1004113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004135 */     // MIs[0] policy
     /* 1004135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004145 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1004148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004167 */     // GIR_Coverage, 5099,
     /* 1004167 */     GIR_EraseRootFromParent_Done,
     /* 1004168 */   // Label 14947: @1004168
     /* 1004168 */   GIM_Try, /*On fail goto*//*Label 14948*/ GIMT_Encode4(1004245), // Rule ID 5102 //
     /* 1004173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004212 */     // MIs[0] policy
     /* 1004212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004222 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1004225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004244 */     // GIR_Coverage, 5102,
     /* 1004244 */     GIR_EraseRootFromParent_Done,
     /* 1004245 */   // Label 14948: @1004245
     /* 1004245 */   GIM_Try, /*On fail goto*//*Label 14949*/ GIMT_Encode4(1004322), // Rule ID 5103 //
     /* 1004250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1004261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1004264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1004267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1004270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1004277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004289 */     // MIs[0] policy
     /* 1004289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004299 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11541:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1004302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004321 */     // GIR_Coverage, 5103,
     /* 1004321 */     GIR_EraseRootFromParent_Done,
     /* 1004322 */   // Label 14949: @1004322
     /* 1004322 */   GIM_Try, /*On fail goto*//*Label 14950*/ GIMT_Encode4(1004399), // Rule ID 5106 //
     /* 1004327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004366 */     // MIs[0] policy
     /* 1004366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1004379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004398 */     // GIR_Coverage, 5106,
     /* 1004398 */     GIR_EraseRootFromParent_Done,
     /* 1004399 */   // Label 14950: @1004399
     /* 1004399 */   GIM_Try, /*On fail goto*//*Label 14951*/ GIMT_Encode4(1004476), // Rule ID 5107 //
     /* 1004404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1004415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1004418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1004424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1004431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1004435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004443 */     // MIs[0] policy
     /* 1004443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004453 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11541:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1004456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004462 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004475 */     // GIR_Coverage, 5107,
     /* 1004475 */     GIR_EraseRootFromParent_Done,
     /* 1004476 */   // Label 14951: @1004476
     /* 1004476 */   GIM_Try, /*On fail goto*//*Label 14952*/ GIMT_Encode4(1004553), // Rule ID 5110 //
     /* 1004481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004520 */     // MIs[0] policy
     /* 1004520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1004533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004552 */     // GIR_Coverage, 5110,
     /* 1004552 */     GIR_EraseRootFromParent_Done,
     /* 1004553 */   // Label 14952: @1004553
     /* 1004553 */   GIM_Try, /*On fail goto*//*Label 14953*/ GIMT_Encode4(1004630), // Rule ID 5111 //
     /* 1004558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004597 */     // MIs[0] policy
     /* 1004597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004607 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11541:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1004610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004629 */     // GIR_Coverage, 5111,
     /* 1004629 */     GIR_EraseRootFromParent_Done,
     /* 1004630 */   // Label 14953: @1004630
     /* 1004630 */   GIM_Try, /*On fail goto*//*Label 14954*/ GIMT_Encode4(1004707), // Rule ID 5114 //
     /* 1004635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004674 */     // MIs[0] policy
     /* 1004674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004684 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1004687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004706 */     // GIR_Coverage, 5114,
     /* 1004706 */     GIR_EraseRootFromParent_Done,
     /* 1004707 */   // Label 14954: @1004707
     /* 1004707 */   GIM_Try, /*On fail goto*//*Label 14955*/ GIMT_Encode4(1004784), // Rule ID 5115 //
     /* 1004712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004751 */     // MIs[0] policy
     /* 1004751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004761 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11541:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1004764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004770 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004783 */     // GIR_Coverage, 5115,
     /* 1004783 */     GIR_EraseRootFromParent_Done,
     /* 1004784 */   // Label 14955: @1004784
     /* 1004784 */   GIM_Try, /*On fail goto*//*Label 14956*/ GIMT_Encode4(1004861), // Rule ID 12726 //
     /* 1004789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1004800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1004803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1004809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004828 */     // MIs[0] policy
     /* 1004828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1004841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004860 */     // GIR_Coverage, 12726,
     /* 1004860 */     GIR_EraseRootFromParent_Done,
     /* 1004861 */   // Label 14956: @1004861
     /* 1004861 */   GIM_Try, /*On fail goto*//*Label 14957*/ GIMT_Encode4(1004938), // Rule ID 12727 //
     /* 1004866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1004877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1004880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1004886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004905 */     // MIs[0] policy
     /* 1004905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004915 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1004918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004937 */     // GIR_Coverage, 12727,
     /* 1004937 */     GIR_EraseRootFromParent_Done,
     /* 1004938 */   // Label 14957: @1004938
     /* 1004938 */   GIM_Try, /*On fail goto*//*Label 14958*/ GIMT_Encode4(1005015), // Rule ID 12730 //
     /* 1004943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1004954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1004957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1004963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004982 */     // MIs[0] policy
     /* 1004982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004992 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1004995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005014 */     // GIR_Coverage, 12730,
     /* 1005014 */     GIR_EraseRootFromParent_Done,
     /* 1005015 */   // Label 14958: @1005015
     /* 1005015 */   GIM_Try, /*On fail goto*//*Label 14959*/ GIMT_Encode4(1005092), // Rule ID 12731 //
     /* 1005020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1005031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1005034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1005037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1005040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005059 */     // MIs[0] policy
     /* 1005059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005069 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005091 */     // GIR_Coverage, 12731,
     /* 1005091 */     GIR_EraseRootFromParent_Done,
     /* 1005092 */   // Label 14959: @1005092
     /* 1005092 */   GIM_Try, /*On fail goto*//*Label 14960*/ GIMT_Encode4(1005169), // Rule ID 12734 //
     /* 1005097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1005108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1005111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1005117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005136 */     // MIs[0] policy
     /* 1005136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005168 */     // GIR_Coverage, 12734,
     /* 1005168 */     GIR_EraseRootFromParent_Done,
     /* 1005169 */   // Label 14960: @1005169
     /* 1005169 */   GIM_Try, /*On fail goto*//*Label 14961*/ GIMT_Encode4(1005246), // Rule ID 12735 //
     /* 1005174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1005185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1005188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1005191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1005194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005213 */     // MIs[0] policy
     /* 1005213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005223 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1005226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005245 */     // GIR_Coverage, 12735,
     /* 1005245 */     GIR_EraseRootFromParent_Done,
     /* 1005246 */   // Label 14961: @1005246
     /* 1005246 */   GIM_Try, /*On fail goto*//*Label 14962*/ GIMT_Encode4(1005323), // Rule ID 12738 //
     /* 1005251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1005262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1005265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1005271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005290 */     // MIs[0] policy
     /* 1005290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005322 */     // GIR_Coverage, 12738,
     /* 1005322 */     GIR_EraseRootFromParent_Done,
     /* 1005323 */   // Label 14962: @1005323
     /* 1005323 */   GIM_Try, /*On fail goto*//*Label 14963*/ GIMT_Encode4(1005400), // Rule ID 12739 //
     /* 1005328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1005339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1005342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1005345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1005348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005367 */     // MIs[0] policy
     /* 1005367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005377 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005399 */     // GIR_Coverage, 12739,
     /* 1005399 */     GIR_EraseRootFromParent_Done,
     /* 1005400 */   // Label 14963: @1005400
     /* 1005400 */   GIM_Try, /*On fail goto*//*Label 14964*/ GIMT_Encode4(1005477), // Rule ID 12742 //
     /* 1005405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1005422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1005425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005444 */     // MIs[0] policy
     /* 1005444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005454 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005476 */     // GIR_Coverage, 12742,
     /* 1005476 */     GIR_EraseRootFromParent_Done,
     /* 1005477 */   // Label 14964: @1005477
     /* 1005477 */   GIM_Try, /*On fail goto*//*Label 14965*/ GIMT_Encode4(1005554), // Rule ID 12743 //
     /* 1005482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1005493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1005496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1005499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1005502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005521 */     // MIs[0] policy
     /* 1005521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005531 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005553 */     // GIR_Coverage, 12743,
     /* 1005553 */     GIR_EraseRootFromParent_Done,
     /* 1005554 */   // Label 14965: @1005554
     /* 1005554 */   GIM_Try, /*On fail goto*//*Label 14966*/ GIMT_Encode4(1005631), // Rule ID 12746 //
     /* 1005559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1005570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1005573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1005579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005598 */     // MIs[0] policy
     /* 1005598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005630 */     // GIR_Coverage, 12746,
     /* 1005630 */     GIR_EraseRootFromParent_Done,
     /* 1005631 */   // Label 14966: @1005631
     /* 1005631 */   GIM_Try, /*On fail goto*//*Label 14967*/ GIMT_Encode4(1005708), // Rule ID 12747 //
     /* 1005636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1005647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1005650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1005656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005675 */     // MIs[0] policy
     /* 1005675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005685 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005707 */     // GIR_Coverage, 12747,
     /* 1005707 */     GIR_EraseRootFromParent_Done,
     /* 1005708 */   // Label 14967: @1005708
     /* 1005708 */   GIM_Try, /*On fail goto*//*Label 14968*/ GIMT_Encode4(1005785), // Rule ID 12750 //
     /* 1005713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1005724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1005727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1005733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005752 */     // MIs[0] policy
     /* 1005752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005784 */     // GIR_Coverage, 12750,
     /* 1005784 */     GIR_EraseRootFromParent_Done,
     /* 1005785 */   // Label 14968: @1005785
     /* 1005785 */   GIM_Try, /*On fail goto*//*Label 14969*/ GIMT_Encode4(1005862), // Rule ID 12751 //
     /* 1005790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1005801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1005804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1005810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005829 */     // MIs[0] policy
     /* 1005829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005839 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005861 */     // GIR_Coverage, 12751,
     /* 1005861 */     GIR_EraseRootFromParent_Done,
     /* 1005862 */   // Label 14969: @1005862
     /* 1005862 */   GIM_Try, /*On fail goto*//*Label 14970*/ GIMT_Encode4(1005939), // Rule ID 12754 //
     /* 1005867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1005884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1005887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005906 */     // MIs[0] policy
     /* 1005906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005938 */     // GIR_Coverage, 12754,
     /* 1005938 */     GIR_EraseRootFromParent_Done,
     /* 1005939 */   // Label 14970: @1005939
     /* 1005939 */   GIM_Try, /*On fail goto*//*Label 14971*/ GIMT_Encode4(1006016), // Rule ID 12755 //
     /* 1005944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1005961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1005964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005983 */     // MIs[0] policy
     /* 1005983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005993 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006015 */     // GIR_Coverage, 12755,
     /* 1006015 */     GIR_EraseRootFromParent_Done,
     /* 1006016 */   // Label 14971: @1006016
     /* 1006016 */   GIM_Try, /*On fail goto*//*Label 14972*/ GIMT_Encode4(1006093), // Rule ID 12758 //
     /* 1006021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1006024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1006038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1006041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006060 */     // MIs[0] policy
     /* 1006060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006092 */     // GIR_Coverage, 12758,
     /* 1006092 */     GIR_EraseRootFromParent_Done,
     /* 1006093 */   // Label 14972: @1006093
     /* 1006093 */   GIM_Try, /*On fail goto*//*Label 14973*/ GIMT_Encode4(1006170), // Rule ID 12759 //
     /* 1006098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1006101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1006109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1006112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1006115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1006118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1006137 */     // MIs[0] policy
     /* 1006137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006147 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1006150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1006166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006169 */     // GIR_Coverage, 12759,
     /* 1006169 */     GIR_EraseRootFromParent_Done,
     /* 1006170 */   // Label 14973: @1006170
     /* 1006170 */   GIM_Try, /*On fail goto*//*Label 14974*/ GIMT_Encode4(1006247), // Rule ID 12762 //
     /* 1006175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1006186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1006189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1006192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1006195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006214 */     // MIs[0] policy
     /* 1006214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006224 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006246 */     // GIR_Coverage, 12762,
     /* 1006246 */     GIR_EraseRootFromParent_Done,
     /* 1006247 */   // Label 14974: @1006247
     /* 1006247 */   GIM_Try, /*On fail goto*//*Label 14975*/ GIMT_Encode4(1006324), // Rule ID 12763 //
     /* 1006252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1006263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1006266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1006269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1006272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006291 */     // MIs[0] policy
     /* 1006291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006301 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006323 */     // GIR_Coverage, 12763,
     /* 1006323 */     GIR_EraseRootFromParent_Done,
     /* 1006324 */   // Label 14975: @1006324
     /* 1006324 */   GIM_Try, /*On fail goto*//*Label 14976*/ GIMT_Encode4(1006401), // Rule ID 12766 //
     /* 1006329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1006340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1006343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1006346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1006349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006368 */     // MIs[0] policy
     /* 1006368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006378 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006400 */     // GIR_Coverage, 12766,
     /* 1006400 */     GIR_EraseRootFromParent_Done,
     /* 1006401 */   // Label 14976: @1006401
     /* 1006401 */   GIM_Try, /*On fail goto*//*Label 14977*/ GIMT_Encode4(1006478), // Rule ID 12767 //
     /* 1006406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1006417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1006420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1006423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1006426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006445 */     // MIs[0] policy
     /* 1006445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006455 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006477 */     // GIR_Coverage, 12767,
     /* 1006477 */     GIR_EraseRootFromParent_Done,
     /* 1006478 */   // Label 14977: @1006478
     /* 1006478 */   GIM_Try, /*On fail goto*//*Label 14978*/ GIMT_Encode4(1006555), // Rule ID 12770 //
     /* 1006483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1006494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1006497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1006500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1006503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006522 */     // MIs[0] policy
     /* 1006522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006532 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006554 */     // GIR_Coverage, 12770,
     /* 1006554 */     GIR_EraseRootFromParent_Done,
     /* 1006555 */   // Label 14978: @1006555
     /* 1006555 */   GIM_Try, /*On fail goto*//*Label 14979*/ GIMT_Encode4(1006632), // Rule ID 12771 //
     /* 1006560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1006571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1006574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1006577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1006580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006599 */     // MIs[0] policy
     /* 1006599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006609 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006631 */     // GIR_Coverage, 12771,
     /* 1006631 */     GIR_EraseRootFromParent_Done,
     /* 1006632 */   // Label 14979: @1006632
     /* 1006632 */   GIM_Try, /*On fail goto*//*Label 14980*/ GIMT_Encode4(1006709), // Rule ID 12774 //
     /* 1006637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1006648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1006651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1006654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1006657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006676 */     // MIs[0] policy
     /* 1006676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006708 */     // GIR_Coverage, 12774,
     /* 1006708 */     GIR_EraseRootFromParent_Done,
     /* 1006709 */   // Label 14980: @1006709
     /* 1006709 */   GIM_Try, /*On fail goto*//*Label 14981*/ GIMT_Encode4(1006786), // Rule ID 12775 //
     /* 1006714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1006725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1006728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1006731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1006734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006753 */     // MIs[0] policy
     /* 1006753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006763 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006785 */     // GIR_Coverage, 12775,
     /* 1006785 */     GIR_EraseRootFromParent_Done,
     /* 1006786 */   // Label 14981: @1006786
     /* 1006786 */   GIM_Try, /*On fail goto*//*Label 14982*/ GIMT_Encode4(1006863), // Rule ID 12778 //
     /* 1006791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1006802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1006805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1006808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1006811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006830 */     // MIs[0] policy
     /* 1006830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006862 */     // GIR_Coverage, 12778,
     /* 1006862 */     GIR_EraseRootFromParent_Done,
     /* 1006863 */   // Label 14982: @1006863
     /* 1006863 */   GIM_Try, /*On fail goto*//*Label 14983*/ GIMT_Encode4(1006940), // Rule ID 12779 //
     /* 1006868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1006879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1006882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1006885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1006888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006907 */     // MIs[0] policy
     /* 1006907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006917 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006939 */     // GIR_Coverage, 12779,
     /* 1006939 */     GIR_EraseRootFromParent_Done,
     /* 1006940 */   // Label 14983: @1006940
     /* 1006940 */   GIM_Try, /*On fail goto*//*Label 14984*/ GIMT_Encode4(1007017), // Rule ID 12782 //
     /* 1006945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1006956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1006959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1006962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1006965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006984 */     // MIs[0] policy
     /* 1006984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007016 */     // GIR_Coverage, 12782,
     /* 1007016 */     GIR_EraseRootFromParent_Done,
     /* 1007017 */   // Label 14984: @1007017
     /* 1007017 */   GIM_Try, /*On fail goto*//*Label 14985*/ GIMT_Encode4(1007094), // Rule ID 12783 //
     /* 1007022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1007033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1007036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1007039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1007042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007061 */     // MIs[0] policy
     /* 1007061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007071 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1007090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007093 */     // GIR_Coverage, 12783,
     /* 1007093 */     GIR_EraseRootFromParent_Done,
     /* 1007094 */   // Label 14985: @1007094
     /* 1007094 */   GIM_Try, /*On fail goto*//*Label 14986*/ GIMT_Encode4(1007171), // Rule ID 12786 //
     /* 1007099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1007116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1007119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007138 */     // MIs[0] policy
     /* 1007138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007148 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007170 */     // GIR_Coverage, 12786,
     /* 1007170 */     GIR_EraseRootFromParent_Done,
     /* 1007171 */   // Label 14986: @1007171
     /* 1007171 */   GIM_Try, /*On fail goto*//*Label 14987*/ GIMT_Encode4(1007248), // Rule ID 12787 //
     /* 1007176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1007187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1007190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1007193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1007196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007215 */     // MIs[0] policy
     /* 1007215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007225 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007247 */     // GIR_Coverage, 12787,
     /* 1007247 */     GIR_EraseRootFromParent_Done,
     /* 1007248 */   // Label 14987: @1007248
     /* 1007248 */   GIM_Try, /*On fail goto*//*Label 14988*/ GIMT_Encode4(1007325), // Rule ID 12790 //
     /* 1007253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1007270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1007273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007292 */     // MIs[0] policy
     /* 1007292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007324 */     // GIR_Coverage, 12790,
     /* 1007324 */     GIR_EraseRootFromParent_Done,
     /* 1007325 */   // Label 14988: @1007325
     /* 1007325 */   GIM_Try, /*On fail goto*//*Label 14989*/ GIMT_Encode4(1007402), // Rule ID 12791 //
     /* 1007330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1007341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1007344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1007347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1007350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007369 */     // MIs[0] policy
     /* 1007369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007379 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007401 */     // GIR_Coverage, 12791,
     /* 1007401 */     GIR_EraseRootFromParent_Done,
     /* 1007402 */   // Label 14989: @1007402
     /* 1007402 */   GIM_Try, /*On fail goto*//*Label 14990*/ GIMT_Encode4(1007479), // Rule ID 12794 //
     /* 1007407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1007424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1007427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007446 */     // MIs[0] policy
     /* 1007446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007478 */     // GIR_Coverage, 12794,
     /* 1007478 */     GIR_EraseRootFromParent_Done,
     /* 1007479 */   // Label 14990: @1007479
     /* 1007479 */   GIM_Try, /*On fail goto*//*Label 14991*/ GIMT_Encode4(1007556), // Rule ID 12795 //
     /* 1007484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1007495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1007498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1007501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1007504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007523 */     // MIs[0] policy
     /* 1007523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007533 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007555 */     // GIR_Coverage, 12795,
     /* 1007555 */     GIR_EraseRootFromParent_Done,
     /* 1007556 */   // Label 14991: @1007556
     /* 1007556 */   GIM_Try, /*On fail goto*//*Label 14992*/ GIMT_Encode4(1007633), // Rule ID 12798 //
     /* 1007561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1007564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1007578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1007581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007600 */     // MIs[0] policy
     /* 1007600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007632 */     // GIR_Coverage, 12798,
     /* 1007632 */     GIR_EraseRootFromParent_Done,
     /* 1007633 */   // Label 14992: @1007633
     /* 1007633 */   GIM_Try, /*On fail goto*//*Label 14993*/ GIMT_Encode4(1007710), // Rule ID 12799 //
     /* 1007638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1007641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1007655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1007658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007677 */     // MIs[0] policy
     /* 1007677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007687 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007709 */     // GIR_Coverage, 12799,
     /* 1007709 */     GIR_EraseRootFromParent_Done,
     /* 1007710 */   // Label 14993: @1007710
     /* 1007710 */   GIM_Try, /*On fail goto*//*Label 14994*/ GIMT_Encode4(1007787), // Rule ID 12802 //
     /* 1007715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1007718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1007732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1007735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007754 */     // MIs[0] policy
     /* 1007754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007786 */     // GIR_Coverage, 12802,
     /* 1007786 */     GIR_EraseRootFromParent_Done,
     /* 1007787 */   // Label 14994: @1007787
     /* 1007787 */   GIM_Try, /*On fail goto*//*Label 14995*/ GIMT_Encode4(1007864), // Rule ID 12803 //
     /* 1007792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1007795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1007809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1007812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007831 */     // MIs[0] policy
     /* 1007831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007841 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007863 */     // GIR_Coverage, 12803,
     /* 1007863 */     GIR_EraseRootFromParent_Done,
     /* 1007864 */   // Label 14995: @1007864
     /* 1007864 */   GIM_Try, /*On fail goto*//*Label 14996*/ GIMT_Encode4(1007941), // Rule ID 12806 //
     /* 1007869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1007872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1007886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1007889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007908 */     // MIs[0] policy
     /* 1007908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007918 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007940 */     // GIR_Coverage, 12806,
     /* 1007940 */     GIR_EraseRootFromParent_Done,
     /* 1007941 */   // Label 14996: @1007941
     /* 1007941 */   GIM_Try, /*On fail goto*//*Label 14997*/ GIMT_Encode4(1008018), // Rule ID 12807 //
     /* 1007946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1007949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1007963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1007966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007985 */     // MIs[0] policy
     /* 1007985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007995 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008017 */     // GIR_Coverage, 12807,
     /* 1008017 */     GIR_EraseRootFromParent_Done,
     /* 1008018 */   // Label 14997: @1008018
     /* 1008018 */   GIM_Try, /*On fail goto*//*Label 14998*/ GIMT_Encode4(1008095), // Rule ID 12810 //
     /* 1008023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1008034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1008037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1008043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008062 */     // MIs[0] policy
     /* 1008062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008072 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1008075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008094 */     // GIR_Coverage, 12810,
     /* 1008094 */     GIR_EraseRootFromParent_Done,
     /* 1008095 */   // Label 14998: @1008095
     /* 1008095 */   GIM_Try, /*On fail goto*//*Label 14999*/ GIMT_Encode4(1008172), // Rule ID 12811 //
     /* 1008100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1008111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1008114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1008120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008139 */     // MIs[0] policy
     /* 1008139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008149 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1008152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008171 */     // GIR_Coverage, 12811,
     /* 1008171 */     GIR_EraseRootFromParent_Done,
     /* 1008172 */   // Label 14999: @1008172
     /* 1008172 */   GIM_Try, /*On fail goto*//*Label 15000*/ GIMT_Encode4(1008249), // Rule ID 12814 //
     /* 1008177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008216 */     // MIs[0] policy
     /* 1008216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008226 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008248 */     // GIR_Coverage, 12814,
     /* 1008248 */     GIR_EraseRootFromParent_Done,
     /* 1008249 */   // Label 15000: @1008249
     /* 1008249 */   GIM_Try, /*On fail goto*//*Label 15001*/ GIMT_Encode4(1008326), // Rule ID 12815 //
     /* 1008254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1008265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1008268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1008274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008293 */     // MIs[0] policy
     /* 1008293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008303 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008325 */     // GIR_Coverage, 12815,
     /* 1008325 */     GIR_EraseRootFromParent_Done,
     /* 1008326 */   // Label 15001: @1008326
     /* 1008326 */   GIM_Try, /*On fail goto*//*Label 15002*/ GIMT_Encode4(1008403), // Rule ID 12818 //
     /* 1008331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008370 */     // MIs[0] policy
     /* 1008370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008380 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008402 */     // GIR_Coverage, 12818,
     /* 1008402 */     GIR_EraseRootFromParent_Done,
     /* 1008403 */   // Label 15002: @1008403
     /* 1008403 */   GIM_Try, /*On fail goto*//*Label 15003*/ GIMT_Encode4(1008480), // Rule ID 12819 //
     /* 1008408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1008419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1008422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1008428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008447 */     // MIs[0] policy
     /* 1008447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008457 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008479 */     // GIR_Coverage, 12819,
     /* 1008479 */     GIR_EraseRootFromParent_Done,
     /* 1008480 */   // Label 15003: @1008480
     /* 1008480 */   GIM_Try, /*On fail goto*//*Label 15004*/ GIMT_Encode4(1008557), // Rule ID 12822 //
     /* 1008485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1008496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1008499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1008505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008524 */     // MIs[0] policy
     /* 1008524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008556 */     // GIR_Coverage, 12822,
     /* 1008556 */     GIR_EraseRootFromParent_Done,
     /* 1008557 */   // Label 15004: @1008557
     /* 1008557 */   GIM_Try, /*On fail goto*//*Label 15005*/ GIMT_Encode4(1008634), // Rule ID 12823 //
     /* 1008562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1008573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1008576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1008582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008601 */     // MIs[0] policy
     /* 1008601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008611 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008633 */     // GIR_Coverage, 12823,
     /* 1008633 */     GIR_EraseRootFromParent_Done,
     /* 1008634 */   // Label 15005: @1008634
     /* 1008634 */   GIM_Try, /*On fail goto*//*Label 15006*/ GIMT_Encode4(1008711), // Rule ID 12826 //
     /* 1008639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1008650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1008653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1008659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008678 */     // MIs[0] policy
     /* 1008678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008688 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008710 */     // GIR_Coverage, 12826,
     /* 1008710 */     GIR_EraseRootFromParent_Done,
     /* 1008711 */   // Label 15006: @1008711
     /* 1008711 */   GIM_Try, /*On fail goto*//*Label 15007*/ GIMT_Encode4(1008788), // Rule ID 12827 //
     /* 1008716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1008727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1008730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1008736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008755 */     // MIs[0] policy
     /* 1008755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008765 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008787 */     // GIR_Coverage, 12827,
     /* 1008787 */     GIR_EraseRootFromParent_Done,
     /* 1008788 */   // Label 15007: @1008788
     /* 1008788 */   GIM_Try, /*On fail goto*//*Label 15008*/ GIMT_Encode4(1008865), // Rule ID 12830 //
     /* 1008793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1008804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1008807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1008813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008832 */     // MIs[0] policy
     /* 1008832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008842 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008864 */     // GIR_Coverage, 12830,
     /* 1008864 */     GIR_EraseRootFromParent_Done,
     /* 1008865 */   // Label 15008: @1008865
     /* 1008865 */   GIM_Try, /*On fail goto*//*Label 15009*/ GIMT_Encode4(1008942), // Rule ID 12831 //
     /* 1008870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1008881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1008884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1008890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008909 */     // MIs[0] policy
     /* 1008909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008919 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008941 */     // GIR_Coverage, 12831,
     /* 1008941 */     GIR_EraseRootFromParent_Done,
     /* 1008942 */   // Label 15009: @1008942
     /* 1008942 */   GIM_Try, /*On fail goto*//*Label 15010*/ GIMT_Encode4(1009019), // Rule ID 12834 //
     /* 1008947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1008958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1008961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1008967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008986 */     // MIs[0] policy
     /* 1008986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1008999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009018 */     // GIR_Coverage, 12834,
     /* 1009018 */     GIR_EraseRootFromParent_Done,
     /* 1009019 */   // Label 15010: @1009019
     /* 1009019 */   GIM_Try, /*On fail goto*//*Label 15011*/ GIMT_Encode4(1009096), // Rule ID 12835 //
     /* 1009024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1009035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1009038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1009044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009063 */     // MIs[0] policy
     /* 1009063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009073 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11410:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009095 */     // GIR_Coverage, 12835,
     /* 1009095 */     GIR_EraseRootFromParent_Done,
     /* 1009096 */   // Label 15011: @1009096
     /* 1009096 */   GIM_Try, /*On fail goto*//*Label 15012*/ GIMT_Encode4(1009173), // Rule ID 12838 //
     /* 1009101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009140 */     // MIs[0] policy
     /* 1009140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009172 */     // GIR_Coverage, 12838,
     /* 1009172 */     GIR_EraseRootFromParent_Done,
     /* 1009173 */   // Label 15012: @1009173
     /* 1009173 */   GIM_Try, /*On fail goto*//*Label 15013*/ GIMT_Encode4(1009250), // Rule ID 12839 //
     /* 1009178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1009189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1009192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1009198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009217 */     // MIs[0] policy
     /* 1009217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11410:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009249 */     // GIR_Coverage, 12839,
     /* 1009249 */     GIR_EraseRootFromParent_Done,
     /* 1009250 */   // Label 15013: @1009250
     /* 1009250 */   GIM_Try, /*On fail goto*//*Label 15014*/ GIMT_Encode4(1009327), // Rule ID 12842 //
     /* 1009255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009294 */     // MIs[0] policy
     /* 1009294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009326 */     // GIR_Coverage, 12842,
     /* 1009326 */     GIR_EraseRootFromParent_Done,
     /* 1009327 */   // Label 15014: @1009327
     /* 1009327 */   GIM_Try, /*On fail goto*//*Label 15015*/ GIMT_Encode4(1009404), // Rule ID 12843 //
     /* 1009332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1009343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1009346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1009352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009371 */     // MIs[0] policy
     /* 1009371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009381 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11410:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1009400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009403 */     // GIR_Coverage, 12843,
     /* 1009403 */     GIR_EraseRootFromParent_Done,
     /* 1009404 */   // Label 15015: @1009404
     /* 1009404 */   GIM_Try, /*On fail goto*//*Label 15016*/ GIMT_Encode4(1009481), // Rule ID 12846 //
     /* 1009409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1009412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009448 */     // MIs[0] policy
     /* 1009448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1009477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009480 */     // GIR_Coverage, 12846,
     /* 1009480 */     GIR_EraseRootFromParent_Done,
     /* 1009481 */   // Label 15016: @1009481
     /* 1009481 */   GIM_Try, /*On fail goto*//*Label 15017*/ GIMT_Encode4(1009558), // Rule ID 12847 //
     /* 1009486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1009489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1009497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1009500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1009506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009525 */     // MIs[0] policy
     /* 1009525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009535 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11410:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1009554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009557 */     // GIR_Coverage, 12847,
     /* 1009557 */     GIR_EraseRootFromParent_Done,
     /* 1009558 */   // Label 15017: @1009558
     /* 1009558 */   GIM_Try, /*On fail goto*//*Label 15018*/ GIMT_Encode4(1009635), // Rule ID 12850 //
     /* 1009563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1009574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1009577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1009583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009602 */     // MIs[0] policy
     /* 1009602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1009615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009634 */     // GIR_Coverage, 12850,
     /* 1009634 */     GIR_EraseRootFromParent_Done,
     /* 1009635 */   // Label 15018: @1009635
     /* 1009635 */   GIM_Try, /*On fail goto*//*Label 15019*/ GIMT_Encode4(1009712), // Rule ID 12851 //
     /* 1009640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1009651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1009654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1009660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009679 */     // MIs[0] policy
     /* 1009679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009689 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1009692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009711 */     // GIR_Coverage, 12851,
     /* 1009711 */     GIR_EraseRootFromParent_Done,
     /* 1009712 */   // Label 15019: @1009712
     /* 1009712 */   GIM_Try, /*On fail goto*//*Label 15020*/ GIMT_Encode4(1009789), // Rule ID 12854 //
     /* 1009717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1009728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1009731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1009737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009756 */     // MIs[0] policy
     /* 1009756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009766 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1009769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009788 */     // GIR_Coverage, 12854,
     /* 1009788 */     GIR_EraseRootFromParent_Done,
     /* 1009789 */   // Label 15020: @1009789
     /* 1009789 */   GIM_Try, /*On fail goto*//*Label 15021*/ GIMT_Encode4(1009866), // Rule ID 12855 //
     /* 1009794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1009805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1009808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1009814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009833 */     // MIs[0] policy
     /* 1009833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009843 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1009846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009865 */     // GIR_Coverage, 12855,
     /* 1009865 */     GIR_EraseRootFromParent_Done,
     /* 1009866 */   // Label 15021: @1009866
     /* 1009866 */   GIM_Try, /*On fail goto*//*Label 15022*/ GIMT_Encode4(1009943), // Rule ID 12858 //
     /* 1009871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1009882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1009885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1009891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009910 */     // MIs[0] policy
     /* 1009910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009920 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1009923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009942 */     // GIR_Coverage, 12858,
     /* 1009942 */     GIR_EraseRootFromParent_Done,
     /* 1009943 */   // Label 15022: @1009943
     /* 1009943 */   GIM_Try, /*On fail goto*//*Label 15023*/ GIMT_Encode4(1010020), // Rule ID 12859 //
     /* 1009948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1009959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1009962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1009968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009987 */     // MIs[0] policy
     /* 1009987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009997 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010019 */     // GIR_Coverage, 12859,
     /* 1010019 */     GIR_EraseRootFromParent_Done,
     /* 1010020 */   // Label 15023: @1010020
     /* 1010020 */   GIM_Try, /*On fail goto*//*Label 15024*/ GIMT_Encode4(1010097), // Rule ID 12862 //
     /* 1010025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010064 */     // MIs[0] policy
     /* 1010064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010074 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010096 */     // GIR_Coverage, 12862,
     /* 1010096 */     GIR_EraseRootFromParent_Done,
     /* 1010097 */   // Label 15024: @1010097
     /* 1010097 */   GIM_Try, /*On fail goto*//*Label 15025*/ GIMT_Encode4(1010174), // Rule ID 12863 //
     /* 1010102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1010113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1010116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1010122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010141 */     // MIs[0] policy
     /* 1010141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010151 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010173 */     // GIR_Coverage, 12863,
     /* 1010173 */     GIR_EraseRootFromParent_Done,
     /* 1010174 */   // Label 15025: @1010174
     /* 1010174 */   GIM_Try, /*On fail goto*//*Label 15026*/ GIMT_Encode4(1010251), // Rule ID 12866 //
     /* 1010179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010218 */     // MIs[0] policy
     /* 1010218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010228 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010250 */     // GIR_Coverage, 12866,
     /* 1010250 */     GIR_EraseRootFromParent_Done,
     /* 1010251 */   // Label 15026: @1010251
     /* 1010251 */   GIM_Try, /*On fail goto*//*Label 15027*/ GIMT_Encode4(1010328), // Rule ID 12867 //
     /* 1010256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1010267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1010270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1010276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010295 */     // MIs[0] policy
     /* 1010295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010305 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010327 */     // GIR_Coverage, 12867,
     /* 1010327 */     GIR_EraseRootFromParent_Done,
     /* 1010328 */   // Label 15027: @1010328
     /* 1010328 */   GIM_Try, /*On fail goto*//*Label 15028*/ GIMT_Encode4(1010405), // Rule ID 12870 //
     /* 1010333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010372 */     // MIs[0] policy
     /* 1010372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010382 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010404 */     // GIR_Coverage, 12870,
     /* 1010404 */     GIR_EraseRootFromParent_Done,
     /* 1010405 */   // Label 15028: @1010405
     /* 1010405 */   GIM_Try, /*On fail goto*//*Label 15029*/ GIMT_Encode4(1010482), // Rule ID 12871 //
     /* 1010410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1010421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1010424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1010430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010449 */     // MIs[0] policy
     /* 1010449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010459 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1010478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010481 */     // GIR_Coverage, 12871,
     /* 1010481 */     GIR_EraseRootFromParent_Done,
     /* 1010482 */   // Label 15029: @1010482
     /* 1010482 */   GIM_Try, /*On fail goto*//*Label 15030*/ GIMT_Encode4(1010559), // Rule ID 12874 //
     /* 1010487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1010498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1010501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1010507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010526 */     // MIs[0] policy
     /* 1010526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010558 */     // GIR_Coverage, 12874,
     /* 1010558 */     GIR_EraseRootFromParent_Done,
     /* 1010559 */   // Label 15030: @1010559
     /* 1010559 */   GIM_Try, /*On fail goto*//*Label 15031*/ GIMT_Encode4(1010636), // Rule ID 12875 //
     /* 1010564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1010575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1010578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1010584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010603 */     // MIs[0] policy
     /* 1010603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010613 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010635 */     // GIR_Coverage, 12875,
     /* 1010635 */     GIR_EraseRootFromParent_Done,
     /* 1010636 */   // Label 15031: @1010636
     /* 1010636 */   GIM_Try, /*On fail goto*//*Label 15032*/ GIMT_Encode4(1010713), // Rule ID 12878 //
     /* 1010641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1010652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1010655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1010661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010680 */     // MIs[0] policy
     /* 1010680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010690 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010712 */     // GIR_Coverage, 12878,
     /* 1010712 */     GIR_EraseRootFromParent_Done,
     /* 1010713 */   // Label 15032: @1010713
     /* 1010713 */   GIM_Try, /*On fail goto*//*Label 15033*/ GIMT_Encode4(1010790), // Rule ID 12879 //
     /* 1010718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1010729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1010732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1010738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010757 */     // MIs[0] policy
     /* 1010757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010767 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010789 */     // GIR_Coverage, 12879,
     /* 1010789 */     GIR_EraseRootFromParent_Done,
     /* 1010790 */   // Label 15033: @1010790
     /* 1010790 */   GIM_Try, /*On fail goto*//*Label 15034*/ GIMT_Encode4(1010867), // Rule ID 12882 //
     /* 1010795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1010806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1010809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1010815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010834 */     // MIs[0] policy
     /* 1010834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010844 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010866 */     // GIR_Coverage, 12882,
     /* 1010866 */     GIR_EraseRootFromParent_Done,
     /* 1010867 */   // Label 15034: @1010867
     /* 1010867 */   GIM_Try, /*On fail goto*//*Label 15035*/ GIMT_Encode4(1010944), // Rule ID 12883 //
     /* 1010872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1010883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1010886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1010892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010911 */     // MIs[0] policy
     /* 1010911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010921 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010943 */     // GIR_Coverage, 12883,
     /* 1010943 */     GIR_EraseRootFromParent_Done,
     /* 1010944 */   // Label 15035: @1010944
     /* 1010944 */   GIM_Try, /*On fail goto*//*Label 15036*/ GIMT_Encode4(1011021), // Rule ID 12886 //
     /* 1010949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1010952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1010960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1010963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1010969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010988 */     // MIs[0] policy
     /* 1010988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010998 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011020 */     // GIR_Coverage, 12886,
     /* 1011020 */     GIR_EraseRootFromParent_Done,
     /* 1011021 */   // Label 15036: @1011021
     /* 1011021 */   GIM_Try, /*On fail goto*//*Label 15037*/ GIMT_Encode4(1011098), // Rule ID 12887 //
     /* 1011026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1011037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1011040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1011046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1011065 */     // MIs[0] policy
     /* 1011065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011075 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11410:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1011078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011097 */     // GIR_Coverage, 12887,
     /* 1011097 */     GIR_EraseRootFromParent_Done,
     /* 1011098 */   // Label 15037: @1011098
     /* 1011098 */   GIM_Try, /*On fail goto*//*Label 15038*/ GIMT_Encode4(1011175), // Rule ID 12890 //
     /* 1011103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011142 */     // MIs[0] policy
     /* 1011142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011152 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011174 */     // GIR_Coverage, 12890,
     /* 1011174 */     GIR_EraseRootFromParent_Done,
     /* 1011175 */   // Label 15038: @1011175
     /* 1011175 */   GIM_Try, /*On fail goto*//*Label 15039*/ GIMT_Encode4(1011252), // Rule ID 12891 //
     /* 1011180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1011191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1011194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1011200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1011219 */     // MIs[0] policy
     /* 1011219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011229 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11410:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1011232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011251 */     // GIR_Coverage, 12891,
     /* 1011251 */     GIR_EraseRootFromParent_Done,
     /* 1011252 */   // Label 15039: @1011252
     /* 1011252 */   GIM_Try, /*On fail goto*//*Label 15040*/ GIMT_Encode4(1011329), // Rule ID 12894 //
     /* 1011257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1011260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1011274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011296 */     // MIs[0] policy
     /* 1011296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011328 */     // GIR_Coverage, 12894,
     /* 1011328 */     GIR_EraseRootFromParent_Done,
     /* 1011329 */   // Label 15040: @1011329
     /* 1011329 */   GIM_Try, /*On fail goto*//*Label 15041*/ GIMT_Encode4(1011406), // Rule ID 12895 //
     /* 1011334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1011337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1011342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1011345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1011348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1011351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1011354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1011369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1011373 */     // MIs[0] policy
     /* 1011373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011383 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11410:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1011386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1011402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011405 */     // GIR_Coverage, 12895,
     /* 1011405 */     GIR_EraseRootFromParent_Done,
     /* 1011406 */   // Label 15041: @1011406
     /* 1011406 */   GIM_Try, /*On fail goto*//*Label 15042*/ GIMT_Encode4(1011483), // Rule ID 12898 //
     /* 1011411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1011428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011450 */     // MIs[0] policy
     /* 1011450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1011463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011482 */     // GIR_Coverage, 12898,
     /* 1011482 */     GIR_EraseRootFromParent_Done,
     /* 1011483 */   // Label 15042: @1011483
     /* 1011483 */   GIM_Try, /*On fail goto*//*Label 15043*/ GIMT_Encode4(1011560), // Rule ID 12899 //
     /* 1011488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1011499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1011502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1011505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011527 */     // MIs[0] policy
     /* 1011527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011537 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1011540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011559 */     // GIR_Coverage, 12899,
     /* 1011559 */     GIR_EraseRootFromParent_Done,
     /* 1011560 */   // Label 15043: @1011560
     /* 1011560 */   GIM_Try, /*On fail goto*//*Label 15044*/ GIMT_Encode4(1011637), // Rule ID 12902 //
     /* 1011565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1011576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1011579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1011582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1011585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011604 */     // MIs[0] policy
     /* 1011604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011636 */     // GIR_Coverage, 12902,
     /* 1011636 */     GIR_EraseRootFromParent_Done,
     /* 1011637 */   // Label 15044: @1011637
     /* 1011637 */   GIM_Try, /*On fail goto*//*Label 15045*/ GIMT_Encode4(1011714), // Rule ID 12903 //
     /* 1011642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1011653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1011656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1011659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1011662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011681 */     // MIs[0] policy
     /* 1011681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011691 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011713 */     // GIR_Coverage, 12903,
     /* 1011713 */     GIR_EraseRootFromParent_Done,
     /* 1011714 */   // Label 15045: @1011714
     /* 1011714 */   GIM_Try, /*On fail goto*//*Label 15046*/ GIMT_Encode4(1011791), // Rule ID 12906 //
     /* 1011719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1011730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1011733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1011736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1011739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011758 */     // MIs[0] policy
     /* 1011758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011768 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011790 */     // GIR_Coverage, 12906,
     /* 1011790 */     GIR_EraseRootFromParent_Done,
     /* 1011791 */   // Label 15046: @1011791
     /* 1011791 */   GIM_Try, /*On fail goto*//*Label 15047*/ GIMT_Encode4(1011868), // Rule ID 12907 //
     /* 1011796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1011807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1011810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1011813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1011816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011835 */     // MIs[0] policy
     /* 1011835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011845 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011867 */     // GIR_Coverage, 12907,
     /* 1011867 */     GIR_EraseRootFromParent_Done,
     /* 1011868 */   // Label 15047: @1011868
     /* 1011868 */   GIM_Try, /*On fail goto*//*Label 15048*/ GIMT_Encode4(1011945), // Rule ID 12910 //
     /* 1011873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1011884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1011887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1011890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1011893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011912 */     // MIs[0] policy
     /* 1011912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011922 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011944 */     // GIR_Coverage, 12910,
     /* 1011944 */     GIR_EraseRootFromParent_Done,
     /* 1011945 */   // Label 15048: @1011945
     /* 1011945 */   GIM_Try, /*On fail goto*//*Label 15049*/ GIMT_Encode4(1012022), // Rule ID 12911 //
     /* 1011950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1011961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1011964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1011967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1011970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011989 */     // MIs[0] policy
     /* 1011989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011999 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1012002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012021 */     // GIR_Coverage, 12911,
     /* 1012021 */     GIR_EraseRootFromParent_Done,
     /* 1012022 */   // Label 15049: @1012022
     /* 1012022 */   GIM_Try, /*On fail goto*//*Label 15050*/ GIMT_Encode4(1012099), // Rule ID 12914 //
     /* 1012027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1012044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012066 */     // MIs[0] policy
     /* 1012066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012076 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012098 */     // GIR_Coverage, 12914,
     /* 1012098 */     GIR_EraseRootFromParent_Done,
     /* 1012099 */   // Label 15050: @1012099
     /* 1012099 */   GIM_Try, /*On fail goto*//*Label 15051*/ GIMT_Encode4(1012176), // Rule ID 12915 //
     /* 1012104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1012115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1012118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1012121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1012124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012143 */     // MIs[0] policy
     /* 1012143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012153 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012175 */     // GIR_Coverage, 12915,
     /* 1012175 */     GIR_EraseRootFromParent_Done,
     /* 1012176 */   // Label 15051: @1012176
     /* 1012176 */   GIM_Try, /*On fail goto*//*Label 15052*/ GIMT_Encode4(1012253), // Rule ID 12918 //
     /* 1012181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1012198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012220 */     // MIs[0] policy
     /* 1012220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012230 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012252 */     // GIR_Coverage, 12918,
     /* 1012252 */     GIR_EraseRootFromParent_Done,
     /* 1012253 */   // Label 15052: @1012253
     /* 1012253 */   GIM_Try, /*On fail goto*//*Label 15053*/ GIMT_Encode4(1012330), // Rule ID 12919 //
     /* 1012258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1012269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1012272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1012275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1012278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012297 */     // MIs[0] policy
     /* 1012297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012307 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1012310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012329 */     // GIR_Coverage, 12919,
     /* 1012329 */     GIR_EraseRootFromParent_Done,
     /* 1012330 */   // Label 15053: @1012330
     /* 1012330 */   GIM_Try, /*On fail goto*//*Label 15054*/ GIMT_Encode4(1012407), // Rule ID 12922 //
     /* 1012335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1012352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012374 */     // MIs[0] policy
     /* 1012374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012384 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012406 */     // GIR_Coverage, 12922,
     /* 1012406 */     GIR_EraseRootFromParent_Done,
     /* 1012407 */   // Label 15054: @1012407
     /* 1012407 */   GIM_Try, /*On fail goto*//*Label 15055*/ GIMT_Encode4(1012484), // Rule ID 12923 //
     /* 1012412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1012423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1012426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1012429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1012432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012451 */     // MIs[0] policy
     /* 1012451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012461 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012483 */     // GIR_Coverage, 12923,
     /* 1012483 */     GIR_EraseRootFromParent_Done,
     /* 1012484 */   // Label 15055: @1012484
     /* 1012484 */   GIM_Try, /*On fail goto*//*Label 15056*/ GIMT_Encode4(1012561), // Rule ID 12926 //
     /* 1012489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1012500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1012503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1012506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012528 */     // MIs[0] policy
     /* 1012528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012560 */     // GIR_Coverage, 12926,
     /* 1012560 */     GIR_EraseRootFromParent_Done,
     /* 1012561 */   // Label 15056: @1012561
     /* 1012561 */   GIM_Try, /*On fail goto*//*Label 15057*/ GIMT_Encode4(1012638), // Rule ID 12927 //
     /* 1012566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1012577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1012580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1012583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012605 */     // MIs[0] policy
     /* 1012605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012615 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012637 */     // GIR_Coverage, 12927,
     /* 1012637 */     GIR_EraseRootFromParent_Done,
     /* 1012638 */   // Label 15057: @1012638
     /* 1012638 */   GIM_Try, /*On fail goto*//*Label 15058*/ GIMT_Encode4(1012715), // Rule ID 12930 //
     /* 1012643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1012654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1012657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1012660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1012663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012682 */     // MIs[0] policy
     /* 1012682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012692 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012714 */     // GIR_Coverage, 12930,
     /* 1012714 */     GIR_EraseRootFromParent_Done,
     /* 1012715 */   // Label 15058: @1012715
     /* 1012715 */   GIM_Try, /*On fail goto*//*Label 15059*/ GIMT_Encode4(1012792), // Rule ID 12931 //
     /* 1012720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1012731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1012734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1012737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1012740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012759 */     // MIs[0] policy
     /* 1012759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012769 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012791 */     // GIR_Coverage, 12931,
     /* 1012791 */     GIR_EraseRootFromParent_Done,
     /* 1012792 */   // Label 15059: @1012792
     /* 1012792 */   GIM_Try, /*On fail goto*//*Label 15060*/ GIMT_Encode4(1012869), // Rule ID 12934 //
     /* 1012797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1012800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1012808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1012811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1012814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1012817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012836 */     // MIs[0] policy
     /* 1012836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012846 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012868 */     // GIR_Coverage, 12934,
     /* 1012868 */     GIR_EraseRootFromParent_Done,
     /* 1012869 */   // Label 15060: @1012869
     /* 1012869 */   GIM_Try, /*On fail goto*//*Label 15061*/ GIMT_Encode4(1012946), // Rule ID 12935 //
     /* 1012874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1012877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1012885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1012888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1012891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1012894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012913 */     // MIs[0] policy
     /* 1012913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012923 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012945 */     // GIR_Coverage, 12935,
     /* 1012945 */     GIR_EraseRootFromParent_Done,
     /* 1012946 */   // Label 15061: @1012946
     /* 1012946 */   GIM_Try, /*On fail goto*//*Label 15062*/ GIMT_Encode4(1013023), // Rule ID 12938 //
     /* 1012951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1012962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1012965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1012968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1012971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012990 */     // MIs[0] policy
     /* 1012990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013000 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013022 */     // GIR_Coverage, 12938,
     /* 1013022 */     GIR_EraseRootFromParent_Done,
     /* 1013023 */   // Label 15062: @1013023
     /* 1013023 */   GIM_Try, /*On fail goto*//*Label 15063*/ GIMT_Encode4(1013100), // Rule ID 12939 //
     /* 1013028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1013039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1013042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1013045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1013048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013067 */     // MIs[0] policy
     /* 1013067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013077 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013099 */     // GIR_Coverage, 12939,
     /* 1013099 */     GIR_EraseRootFromParent_Done,
     /* 1013100 */   // Label 15063: @1013100
     /* 1013100 */   GIM_Try, /*On fail goto*//*Label 15064*/ GIMT_Encode4(1013177), // Rule ID 12942 //
     /* 1013105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1013122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013144 */     // MIs[0] policy
     /* 1013144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013154 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013176 */     // GIR_Coverage, 12942,
     /* 1013176 */     GIR_EraseRootFromParent_Done,
     /* 1013177 */   // Label 15064: @1013177
     /* 1013177 */   GIM_Try, /*On fail goto*//*Label 15065*/ GIMT_Encode4(1013254), // Rule ID 12943 //
     /* 1013182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1013193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1013196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1013199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1013202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013221 */     // MIs[0] policy
     /* 1013221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013231 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013253 */     // GIR_Coverage, 12943,
     /* 1013253 */     GIR_EraseRootFromParent_Done,
     /* 1013254 */   // Label 15065: @1013254
     /* 1013254 */   GIM_Try, /*On fail goto*//*Label 15066*/ GIMT_Encode4(1013331), // Rule ID 12946 //
     /* 1013259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1013276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013298 */     // MIs[0] policy
     /* 1013298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013330 */     // GIR_Coverage, 12946,
     /* 1013330 */     GIR_EraseRootFromParent_Done,
     /* 1013331 */   // Label 15066: @1013331
     /* 1013331 */   GIM_Try, /*On fail goto*//*Label 15067*/ GIMT_Encode4(1013408), // Rule ID 12947 //
     /* 1013336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1013347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1013350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1013353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1013356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013375 */     // MIs[0] policy
     /* 1013375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013385 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1013404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013407 */     // GIR_Coverage, 12947,
     /* 1013407 */     GIR_EraseRootFromParent_Done,
     /* 1013408 */   // Label 15067: @1013408
     /* 1013408 */   GIM_Try, /*On fail goto*//*Label 15068*/ GIMT_Encode4(1013485), // Rule ID 12950 //
     /* 1013413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1013430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013452 */     // MIs[0] policy
     /* 1013452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013484 */     // GIR_Coverage, 12950,
     /* 1013484 */     GIR_EraseRootFromParent_Done,
     /* 1013485 */   // Label 15068: @1013485
     /* 1013485 */   GIM_Try, /*On fail goto*//*Label 15069*/ GIMT_Encode4(1013562), // Rule ID 12951 //
     /* 1013490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1013501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1013504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1013507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013529 */     // MIs[0] policy
     /* 1013529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013561 */     // GIR_Coverage, 12951,
     /* 1013561 */     GIR_EraseRootFromParent_Done,
     /* 1013562 */   // Label 15069: @1013562
     /* 1013562 */   GIM_Try, /*On fail goto*//*Label 15070*/ GIMT_Encode4(1013639), // Rule ID 12954 //
     /* 1013567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1013578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1013581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1013584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1013587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013606 */     // MIs[0] policy
     /* 1013606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013638 */     // GIR_Coverage, 12954,
     /* 1013638 */     GIR_EraseRootFromParent_Done,
     /* 1013639 */   // Label 15070: @1013639
     /* 1013639 */   GIM_Try, /*On fail goto*//*Label 15071*/ GIMT_Encode4(1013716), // Rule ID 12955 //
     /* 1013644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1013655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1013658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1013661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1013664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013683 */     // MIs[0] policy
     /* 1013683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013693 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013715 */     // GIR_Coverage, 12955,
     /* 1013715 */     GIR_EraseRootFromParent_Done,
     /* 1013716 */   // Label 15071: @1013716
     /* 1013716 */   GIM_Try, /*On fail goto*//*Label 15072*/ GIMT_Encode4(1013793), // Rule ID 12958 //
     /* 1013721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1013732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1013735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1013738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1013741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013760 */     // MIs[0] policy
     /* 1013760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013770 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013792 */     // GIR_Coverage, 12958,
     /* 1013792 */     GIR_EraseRootFromParent_Done,
     /* 1013793 */   // Label 15072: @1013793
     /* 1013793 */   GIM_Try, /*On fail goto*//*Label 15073*/ GIMT_Encode4(1013870), // Rule ID 12959 //
     /* 1013798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1013809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1013812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1013815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1013818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013837 */     // MIs[0] policy
     /* 1013837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013847 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013869 */     // GIR_Coverage, 12959,
     /* 1013869 */     GIR_EraseRootFromParent_Done,
     /* 1013870 */   // Label 15073: @1013870
     /* 1013870 */   GIM_Try, /*On fail goto*//*Label 15074*/ GIMT_Encode4(1013947), // Rule ID 12962 //
     /* 1013875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1013886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1013889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1013892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1013895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013914 */     // MIs[0] policy
     /* 1013914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013946 */     // GIR_Coverage, 12962,
     /* 1013946 */     GIR_EraseRootFromParent_Done,
     /* 1013947 */   // Label 15074: @1013947
     /* 1013947 */   GIM_Try, /*On fail goto*//*Label 15075*/ GIMT_Encode4(1014024), // Rule ID 12963 //
     /* 1013952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1013963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1013966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1013969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1013972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013991 */     // MIs[0] policy
     /* 1013991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014023 */     // GIR_Coverage, 12963,
     /* 1014023 */     GIR_EraseRootFromParent_Done,
     /* 1014024 */   // Label 15075: @1014024
     /* 1014024 */   GIM_Try, /*On fail goto*//*Label 15076*/ GIMT_Encode4(1014101), // Rule ID 12966 //
     /* 1014029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014068 */     // MIs[0] policy
     /* 1014068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014078 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014100 */     // GIR_Coverage, 12966,
     /* 1014100 */     GIR_EraseRootFromParent_Done,
     /* 1014101 */   // Label 15076: @1014101
     /* 1014101 */   GIM_Try, /*On fail goto*//*Label 15077*/ GIMT_Encode4(1014178), // Rule ID 12967 //
     /* 1014106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1014117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1014120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1014123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1014126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014145 */     // MIs[0] policy
     /* 1014145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014155 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014177 */     // GIR_Coverage, 12967,
     /* 1014177 */     GIR_EraseRootFromParent_Done,
     /* 1014178 */   // Label 15077: @1014178
     /* 1014178 */   GIM_Try, /*On fail goto*//*Label 15078*/ GIMT_Encode4(1014255), // Rule ID 12970 //
     /* 1014183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014222 */     // MIs[0] policy
     /* 1014222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014232 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014254 */     // GIR_Coverage, 12970,
     /* 1014254 */     GIR_EraseRootFromParent_Done,
     /* 1014255 */   // Label 15078: @1014255
     /* 1014255 */   GIM_Try, /*On fail goto*//*Label 15079*/ GIMT_Encode4(1014332), // Rule ID 12971 //
     /* 1014260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1014271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1014274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1014277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1014280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014299 */     // MIs[0] policy
     /* 1014299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014309 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1014328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014331 */     // GIR_Coverage, 12971,
     /* 1014331 */     GIR_EraseRootFromParent_Done,
     /* 1014332 */   // Label 15079: @1014332
     /* 1014332 */   GIM_Try, /*On fail goto*//*Label 15080*/ GIMT_Encode4(1014409), // Rule ID 12974 //
     /* 1014337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1014354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014376 */     // MIs[0] policy
     /* 1014376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014408 */     // GIR_Coverage, 12974,
     /* 1014408 */     GIR_EraseRootFromParent_Done,
     /* 1014409 */   // Label 15080: @1014409
     /* 1014409 */   GIM_Try, /*On fail goto*//*Label 15081*/ GIMT_Encode4(1014486), // Rule ID 12975 //
     /* 1014414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1014425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1014428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1014431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1014434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1014453 */     // MIs[0] policy
     /* 1014453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014463 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1014466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014485 */     // GIR_Coverage, 12975,
     /* 1014485 */     GIR_EraseRootFromParent_Done,
     /* 1014486 */   // Label 15081: @1014486
     /* 1014486 */   GIM_Try, /*On fail goto*//*Label 15082*/ GIMT_Encode4(1014563), // Rule ID 12978 //
     /* 1014491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1014502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1014505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1014508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014530 */     // MIs[0] policy
     /* 1014530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014562 */     // GIR_Coverage, 12978,
     /* 1014562 */     GIR_EraseRootFromParent_Done,
     /* 1014563 */   // Label 15082: @1014563
     /* 1014563 */   GIM_Try, /*On fail goto*//*Label 15083*/ GIMT_Encode4(1014640), // Rule ID 12979 //
     /* 1014568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1014579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1014582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1014585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014607 */     // MIs[0] policy
     /* 1014607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014617 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014639 */     // GIR_Coverage, 12979,
     /* 1014639 */     GIR_EraseRootFromParent_Done,
     /* 1014640 */   // Label 15083: @1014640
     /* 1014640 */   GIM_Try, /*On fail goto*//*Label 15084*/ GIMT_Encode4(1014717), // Rule ID 12982 //
     /* 1014645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1014656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1014659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1014662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1014665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014684 */     // MIs[0] policy
     /* 1014684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014716 */     // GIR_Coverage, 12982,
     /* 1014716 */     GIR_EraseRootFromParent_Done,
     /* 1014717 */   // Label 15084: @1014717
     /* 1014717 */   GIM_Try, /*On fail goto*//*Label 15085*/ GIMT_Encode4(1014794), // Rule ID 12983 //
     /* 1014722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1014733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1014736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1014739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1014742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014761 */     // MIs[0] policy
     /* 1014761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014771 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014793 */     // GIR_Coverage, 12983,
     /* 1014793 */     GIR_EraseRootFromParent_Done,
     /* 1014794 */   // Label 15085: @1014794
     /* 1014794 */   GIM_Try, /*On fail goto*//*Label 15086*/ GIMT_Encode4(1014871), // Rule ID 12986 //
     /* 1014799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1014810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1014813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1014819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014838 */     // MIs[0] policy
     /* 1014838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014848 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1014851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014870 */     // GIR_Coverage, 12986,
     /* 1014870 */     GIR_EraseRootFromParent_Done,
     /* 1014871 */   // Label 15086: @1014871
     /* 1014871 */   GIM_Try, /*On fail goto*//*Label 15087*/ GIMT_Encode4(1014948), // Rule ID 12987 //
     /* 1014876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1014887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1014890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1014896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014915 */     // MIs[0] policy
     /* 1014915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014925 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1014928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014947 */     // GIR_Coverage, 12987,
     /* 1014947 */     GIR_EraseRootFromParent_Done,
     /* 1014948 */   // Label 15087: @1014948
     /* 1014948 */   GIM_Try, /*On fail goto*//*Label 15088*/ GIMT_Encode4(1015025), // Rule ID 12990 //
     /* 1014953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1014964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1014967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1014973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014992 */     // MIs[0] policy
     /* 1014992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015024 */     // GIR_Coverage, 12990,
     /* 1015024 */     GIR_EraseRootFromParent_Done,
     /* 1015025 */   // Label 15088: @1015025
     /* 1015025 */   GIM_Try, /*On fail goto*//*Label 15089*/ GIMT_Encode4(1015102), // Rule ID 12991 //
     /* 1015030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1015041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1015044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1015050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015069 */     // MIs[0] policy
     /* 1015069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015079 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015101 */     // GIR_Coverage, 12991,
     /* 1015101 */     GIR_EraseRootFromParent_Done,
     /* 1015102 */   // Label 15089: @1015102
     /* 1015102 */   GIM_Try, /*On fail goto*//*Label 15090*/ GIMT_Encode4(1015179), // Rule ID 12994 //
     /* 1015107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015146 */     // MIs[0] policy
     /* 1015146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015178 */     // GIR_Coverage, 12994,
     /* 1015178 */     GIR_EraseRootFromParent_Done,
     /* 1015179 */   // Label 15090: @1015179
     /* 1015179 */   GIM_Try, /*On fail goto*//*Label 15091*/ GIMT_Encode4(1015256), // Rule ID 12995 //
     /* 1015184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1015195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1015198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1015204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015223 */     // MIs[0] policy
     /* 1015223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015233 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015255 */     // GIR_Coverage, 12995,
     /* 1015255 */     GIR_EraseRootFromParent_Done,
     /* 1015256 */   // Label 15091: @1015256
     /* 1015256 */   GIM_Try, /*On fail goto*//*Label 15092*/ GIMT_Encode4(1015333), // Rule ID 12998 //
     /* 1015261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015300 */     // MIs[0] policy
     /* 1015300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015310 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015332 */     // GIR_Coverage, 12998,
     /* 1015332 */     GIR_EraseRootFromParent_Done,
     /* 1015333 */   // Label 15092: @1015333
     /* 1015333 */   GIM_Try, /*On fail goto*//*Label 15093*/ GIMT_Encode4(1015410), // Rule ID 12999 //
     /* 1015338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1015349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1015352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1015358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015377 */     // MIs[0] policy
     /* 1015377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015387 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1015390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015409 */     // GIR_Coverage, 12999,
     /* 1015409 */     GIR_EraseRootFromParent_Done,
     /* 1015410 */   // Label 15093: @1015410
     /* 1015410 */   GIM_Try, /*On fail goto*//*Label 15094*/ GIMT_Encode4(1015487), // Rule ID 13002 //
     /* 1015415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015454 */     // MIs[0] policy
     /* 1015454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015486 */     // GIR_Coverage, 13002,
     /* 1015486 */     GIR_EraseRootFromParent_Done,
     /* 1015487 */   // Label 15094: @1015487
     /* 1015487 */   GIM_Try, /*On fail goto*//*Label 15095*/ GIMT_Encode4(1015564), // Rule ID 13003 //
     /* 1015492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1015503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1015506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015531 */     // MIs[0] policy
     /* 1015531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015541 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015563 */     // GIR_Coverage, 13003,
     /* 1015563 */     GIR_EraseRootFromParent_Done,
     /* 1015564 */   // Label 15095: @1015564
     /* 1015564 */   GIM_Try, /*On fail goto*//*Label 15096*/ GIMT_Encode4(1015641), // Rule ID 13006 //
     /* 1015569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1015580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1015583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1015589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015608 */     // MIs[0] policy
     /* 1015608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015618 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015640 */     // GIR_Coverage, 13006,
     /* 1015640 */     GIR_EraseRootFromParent_Done,
     /* 1015641 */   // Label 15096: @1015641
     /* 1015641 */   GIM_Try, /*On fail goto*//*Label 15097*/ GIMT_Encode4(1015718), // Rule ID 13007 //
     /* 1015646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1015657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1015660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1015666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015685 */     // MIs[0] policy
     /* 1015685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015695 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015717 */     // GIR_Coverage, 13007,
     /* 1015717 */     GIR_EraseRootFromParent_Done,
     /* 1015718 */   // Label 15097: @1015718
     /* 1015718 */   GIM_Try, /*On fail goto*//*Label 15098*/ GIMT_Encode4(1015795), // Rule ID 13010 //
     /* 1015723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1015734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1015737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1015743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015762 */     // MIs[0] policy
     /* 1015762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015772 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015794 */     // GIR_Coverage, 13010,
     /* 1015794 */     GIR_EraseRootFromParent_Done,
     /* 1015795 */   // Label 15098: @1015795
     /* 1015795 */   GIM_Try, /*On fail goto*//*Label 15099*/ GIMT_Encode4(1015872), // Rule ID 13011 //
     /* 1015800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1015811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1015814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1015820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015839 */     // MIs[0] policy
     /* 1015839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015849 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11489:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015871 */     // GIR_Coverage, 13011,
     /* 1015871 */     GIR_EraseRootFromParent_Done,
     /* 1015872 */   // Label 15099: @1015872
     /* 1015872 */   GIM_Try, /*On fail goto*//*Label 15100*/ GIMT_Encode4(1015949), // Rule ID 13014 //
     /* 1015877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1015888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1015891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1015897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015916 */     // MIs[0] policy
     /* 1015916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015926 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015948 */     // GIR_Coverage, 13014,
     /* 1015948 */     GIR_EraseRootFromParent_Done,
     /* 1015949 */   // Label 15100: @1015949
     /* 1015949 */   GIM_Try, /*On fail goto*//*Label 15101*/ GIMT_Encode4(1016026), // Rule ID 13015 //
     /* 1015954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1015965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1015968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1015974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015993 */     // MIs[0] policy
     /* 1015993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016003 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11489:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016025 */     // GIR_Coverage, 13015,
     /* 1016025 */     GIR_EraseRootFromParent_Done,
     /* 1016026 */   // Label 15101: @1016026
     /* 1016026 */   GIM_Try, /*On fail goto*//*Label 15102*/ GIMT_Encode4(1016103), // Rule ID 13018 //
     /* 1016031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016070 */     // MIs[0] policy
     /* 1016070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016102 */     // GIR_Coverage, 13018,
     /* 1016102 */     GIR_EraseRootFromParent_Done,
     /* 1016103 */   // Label 15102: @1016103
     /* 1016103 */   GIM_Try, /*On fail goto*//*Label 15103*/ GIMT_Encode4(1016180), // Rule ID 13019 //
     /* 1016108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1016119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1016122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1016128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016147 */     // MIs[0] policy
     /* 1016147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016157 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016179 */     // GIR_Coverage, 13019,
     /* 1016179 */     GIR_EraseRootFromParent_Done,
     /* 1016180 */   // Label 15103: @1016180
     /* 1016180 */   GIM_Try, /*On fail goto*//*Label 15104*/ GIMT_Encode4(1016257), // Rule ID 13022 //
     /* 1016185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1016188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016224 */     // MIs[0] policy
     /* 1016224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016234 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016256 */     // GIR_Coverage, 13022,
     /* 1016256 */     GIR_EraseRootFromParent_Done,
     /* 1016257 */   // Label 15104: @1016257
     /* 1016257 */   GIM_Try, /*On fail goto*//*Label 15105*/ GIMT_Encode4(1016334), // Rule ID 13023 //
     /* 1016262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1016265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1016273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1016276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1016282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1016301 */     // MIs[0] policy
     /* 1016301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016311 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1016314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1016330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016333 */     // GIR_Coverage, 13023,
     /* 1016333 */     GIR_EraseRootFromParent_Done,
     /* 1016334 */   // Label 15105: @1016334
     /* 1016334 */   GIM_Try, /*On fail goto*//*Label 15106*/ GIMT_Encode4(1016411), // Rule ID 13026 //
     /* 1016339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016378 */     // MIs[0] policy
     /* 1016378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016388 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016410 */     // GIR_Coverage, 13026,
     /* 1016410 */     GIR_EraseRootFromParent_Done,
     /* 1016411 */   // Label 15106: @1016411
     /* 1016411 */   GIM_Try, /*On fail goto*//*Label 15107*/ GIMT_Encode4(1016488), // Rule ID 13027 //
     /* 1016416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1016427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1016430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1016436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016455 */     // MIs[0] policy
     /* 1016455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016465 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016487 */     // GIR_Coverage, 13027,
     /* 1016487 */     GIR_EraseRootFromParent_Done,
     /* 1016488 */   // Label 15107: @1016488
     /* 1016488 */   GIM_Try, /*On fail goto*//*Label 15108*/ GIMT_Encode4(1016565), // Rule ID 13030 //
     /* 1016493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1016504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1016507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016532 */     // MIs[0] policy
     /* 1016532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016542 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1016545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016564 */     // GIR_Coverage, 13030,
     /* 1016564 */     GIR_EraseRootFromParent_Done,
     /* 1016565 */   // Label 15108: @1016565
     /* 1016565 */   GIM_Try, /*On fail goto*//*Label 15109*/ GIMT_Encode4(1016642), // Rule ID 13031 //
     /* 1016570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1016581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1016584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016609 */     // MIs[0] policy
     /* 1016609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016619 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1016622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016641 */     // GIR_Coverage, 13031,
     /* 1016641 */     GIR_EraseRootFromParent_Done,
     /* 1016642 */   // Label 15109: @1016642
     /* 1016642 */   GIM_Try, /*On fail goto*//*Label 15110*/ GIMT_Encode4(1016719), // Rule ID 13034 //
     /* 1016647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1016658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1016661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1016667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016686 */     // MIs[0] policy
     /* 1016686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1016699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016718 */     // GIR_Coverage, 13034,
     /* 1016718 */     GIR_EraseRootFromParent_Done,
     /* 1016719 */   // Label 15110: @1016719
     /* 1016719 */   GIM_Try, /*On fail goto*//*Label 15111*/ GIMT_Encode4(1016796), // Rule ID 13035 //
     /* 1016724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1016735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1016738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1016744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016763 */     // MIs[0] policy
     /* 1016763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016773 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1016776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016795 */     // GIR_Coverage, 13035,
     /* 1016795 */     GIR_EraseRootFromParent_Done,
     /* 1016796 */   // Label 15111: @1016796
     /* 1016796 */   GIM_Try, /*On fail goto*//*Label 15112*/ GIMT_Encode4(1016873), // Rule ID 13038 //
     /* 1016801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1016812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1016815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1016821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016840 */     // MIs[0] policy
     /* 1016840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016872 */     // GIR_Coverage, 13038,
     /* 1016872 */     GIR_EraseRootFromParent_Done,
     /* 1016873 */   // Label 15112: @1016873
     /* 1016873 */   GIM_Try, /*On fail goto*//*Label 15113*/ GIMT_Encode4(1016950), // Rule ID 13039 //
     /* 1016878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1016889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1016892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1016898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016917 */     // MIs[0] policy
     /* 1016917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016927 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016949 */     // GIR_Coverage, 13039,
     /* 1016949 */     GIR_EraseRootFromParent_Done,
     /* 1016950 */   // Label 15113: @1016950
     /* 1016950 */   GIM_Try, /*On fail goto*//*Label 15114*/ GIMT_Encode4(1017027), // Rule ID 13042 //
     /* 1016955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1016966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1016969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1016975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016994 */     // MIs[0] policy
     /* 1016994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017026 */     // GIR_Coverage, 13042,
     /* 1017026 */     GIR_EraseRootFromParent_Done,
     /* 1017027 */   // Label 15114: @1017027
     /* 1017027 */   GIM_Try, /*On fail goto*//*Label 15115*/ GIMT_Encode4(1017104), // Rule ID 13043 //
     /* 1017032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1017043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1017046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1017052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017071 */     // MIs[0] policy
     /* 1017071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017081 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017103 */     // GIR_Coverage, 13043,
     /* 1017103 */     GIR_EraseRootFromParent_Done,
     /* 1017104 */   // Label 15115: @1017104
     /* 1017104 */   GIM_Try, /*On fail goto*//*Label 15116*/ GIMT_Encode4(1017181), // Rule ID 13046 //
     /* 1017109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017148 */     // MIs[0] policy
     /* 1017148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017180 */     // GIR_Coverage, 13046,
     /* 1017180 */     GIR_EraseRootFromParent_Done,
     /* 1017181 */   // Label 15116: @1017181
     /* 1017181 */   GIM_Try, /*On fail goto*//*Label 15117*/ GIMT_Encode4(1017258), // Rule ID 13047 //
     /* 1017186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1017197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1017200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1017206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017225 */     // MIs[0] policy
     /* 1017225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017235 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1017254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017257 */     // GIR_Coverage, 13047,
     /* 1017257 */     GIR_EraseRootFromParent_Done,
     /* 1017258 */   // Label 15117: @1017258
     /* 1017258 */   GIM_Try, /*On fail goto*//*Label 15118*/ GIMT_Encode4(1017335), // Rule ID 13050 //
     /* 1017263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017302 */     // MIs[0] policy
     /* 1017302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017334 */     // GIR_Coverage, 13050,
     /* 1017334 */     GIR_EraseRootFromParent_Done,
     /* 1017335 */   // Label 15118: @1017335
     /* 1017335 */   GIM_Try, /*On fail goto*//*Label 15119*/ GIMT_Encode4(1017412), // Rule ID 13051 //
     /* 1017340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1017351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1017354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1017360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017379 */     // MIs[0] policy
     /* 1017379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017411 */     // GIR_Coverage, 13051,
     /* 1017411 */     GIR_EraseRootFromParent_Done,
     /* 1017412 */   // Label 15119: @1017412
     /* 1017412 */   GIM_Try, /*On fail goto*//*Label 15120*/ GIMT_Encode4(1017489), // Rule ID 13054 //
     /* 1017417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017456 */     // MIs[0] policy
     /* 1017456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017466 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017488 */     // GIR_Coverage, 13054,
     /* 1017488 */     GIR_EraseRootFromParent_Done,
     /* 1017489 */   // Label 15120: @1017489
     /* 1017489 */   GIM_Try, /*On fail goto*//*Label 15121*/ GIMT_Encode4(1017566), // Rule ID 13055 //
     /* 1017494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1017505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017533 */     // MIs[0] policy
     /* 1017533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017565 */     // GIR_Coverage, 13055,
     /* 1017565 */     GIR_EraseRootFromParent_Done,
     /* 1017566 */   // Label 15121: @1017566
     /* 1017566 */   GIM_Try, /*On fail goto*//*Label 15122*/ GIMT_Encode4(1017643), // Rule ID 13058 //
     /* 1017571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1017582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1017585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1017591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017610 */     // MIs[0] policy
     /* 1017610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017642 */     // GIR_Coverage, 13058,
     /* 1017642 */     GIR_EraseRootFromParent_Done,
     /* 1017643 */   // Label 15122: @1017643
     /* 1017643 */   GIM_Try, /*On fail goto*//*Label 15123*/ GIMT_Encode4(1017720), // Rule ID 13059 //
     /* 1017648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1017659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1017662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1017668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017687 */     // MIs[0] policy
     /* 1017687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017697 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017719 */     // GIR_Coverage, 13059,
     /* 1017719 */     GIR_EraseRootFromParent_Done,
     /* 1017720 */   // Label 15123: @1017720
     /* 1017720 */   GIM_Try, /*On fail goto*//*Label 15124*/ GIMT_Encode4(1017797), // Rule ID 13062 //
     /* 1017725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1017728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1017736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1017739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1017745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017764 */     // MIs[0] policy
     /* 1017764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017774 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017796 */     // GIR_Coverage, 13062,
     /* 1017796 */     GIR_EraseRootFromParent_Done,
     /* 1017797 */   // Label 15124: @1017797
     /* 1017797 */   GIM_Try, /*On fail goto*//*Label 15125*/ GIMT_Encode4(1017874), // Rule ID 13063 //
     /* 1017802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1017805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1017813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1017816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1017822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017841 */     // MIs[0] policy
     /* 1017841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017851 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017873 */     // GIR_Coverage, 13063,
     /* 1017873 */     GIR_EraseRootFromParent_Done,
     /* 1017874 */   // Label 15125: @1017874
     /* 1017874 */   GIM_Try, /*On fail goto*//*Label 15126*/ GIMT_Encode4(1017951), // Rule ID 13066 //
     /* 1017879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1017882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1017890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1017893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1017899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017918 */     // MIs[0] policy
     /* 1017918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017928 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017950 */     // GIR_Coverage, 13066,
     /* 1017950 */     GIR_EraseRootFromParent_Done,
     /* 1017951 */   // Label 15126: @1017951
     /* 1017951 */   GIM_Try, /*On fail goto*//*Label 15127*/ GIMT_Encode4(1018028), // Rule ID 13067 //
     /* 1017956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1017959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1017967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1017970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1017976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017995 */     // MIs[0] policy
     /* 1017995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018005 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1018008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018027 */     // GIR_Coverage, 13067,
     /* 1018027 */     GIR_EraseRootFromParent_Done,
     /* 1018028 */   // Label 15127: @1018028
     /* 1018028 */   GIM_Try, /*On fail goto*//*Label 15128*/ GIMT_Encode4(1018105), // Rule ID 13070 //
     /* 1018033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1018036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1018050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018072 */     // MIs[0] policy
     /* 1018072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018082 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018104 */     // GIR_Coverage, 13070,
     /* 1018104 */     GIR_EraseRootFromParent_Done,
     /* 1018105 */   // Label 15128: @1018105
     /* 1018105 */   GIM_Try, /*On fail goto*//*Label 15129*/ GIMT_Encode4(1018182), // Rule ID 13071 //
     /* 1018110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1018113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1018118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1018121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1018124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1018127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1018130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1018145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1018149 */     // MIs[0] policy
     /* 1018149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018159 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1018162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1018178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018181 */     // GIR_Coverage, 13071,
     /* 1018181 */     GIR_EraseRootFromParent_Done,
     /* 1018182 */   // Label 15129: @1018182
     /* 1018182 */   GIM_Try, /*On fail goto*//*Label 15130*/ GIMT_Encode4(1018259), // Rule ID 13074 //
     /* 1018187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1018204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018226 */     // MIs[0] policy
     /* 1018226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018236 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1018239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018258 */     // GIR_Coverage, 13074,
     /* 1018258 */     GIR_EraseRootFromParent_Done,
     /* 1018259 */   // Label 15130: @1018259
     /* 1018259 */   GIM_Try, /*On fail goto*//*Label 15131*/ GIMT_Encode4(1018336), // Rule ID 13075 //
     /* 1018264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1018275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1018278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1018281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1018284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018303 */     // MIs[0] policy
     /* 1018303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018313 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1018316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018335 */     // GIR_Coverage, 13075,
     /* 1018335 */     GIR_EraseRootFromParent_Done,
     /* 1018336 */   // Label 15131: @1018336
     /* 1018336 */   GIM_Try, /*On fail goto*//*Label 15132*/ GIMT_Encode4(1018413), // Rule ID 13078 //
     /* 1018341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1018358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018380 */     // MIs[0] policy
     /* 1018380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018390 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018412 */     // GIR_Coverage, 13078,
     /* 1018412 */     GIR_EraseRootFromParent_Done,
     /* 1018413 */   // Label 15132: @1018413
     /* 1018413 */   GIM_Try, /*On fail goto*//*Label 15133*/ GIMT_Encode4(1018490), // Rule ID 13079 //
     /* 1018418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1018429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1018432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1018435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1018438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018457 */     // MIs[0] policy
     /* 1018457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018467 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018489 */     // GIR_Coverage, 13079,
     /* 1018489 */     GIR_EraseRootFromParent_Done,
     /* 1018490 */   // Label 15133: @1018490
     /* 1018490 */   GIM_Try, /*On fail goto*//*Label 15134*/ GIMT_Encode4(1018567), // Rule ID 13082 //
     /* 1018495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1018506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1018512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018534 */     // MIs[0] policy
     /* 1018534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018566 */     // GIR_Coverage, 13082,
     /* 1018566 */     GIR_EraseRootFromParent_Done,
     /* 1018567 */   // Label 15134: @1018567
     /* 1018567 */   GIM_Try, /*On fail goto*//*Label 15135*/ GIMT_Encode4(1018644), // Rule ID 13083 //
     /* 1018572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1018583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1018589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018611 */     // MIs[0] policy
     /* 1018611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018621 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018643 */     // GIR_Coverage, 13083,
     /* 1018643 */     GIR_EraseRootFromParent_Done,
     /* 1018644 */   // Label 15135: @1018644
     /* 1018644 */   GIM_Try, /*On fail goto*//*Label 15136*/ GIMT_Encode4(1018721), // Rule ID 13086 //
     /* 1018649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1018660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1018663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1018666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1018669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018688 */     // MIs[0] policy
     /* 1018688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018698 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018720 */     // GIR_Coverage, 13086,
     /* 1018720 */     GIR_EraseRootFromParent_Done,
     /* 1018721 */   // Label 15136: @1018721
     /* 1018721 */   GIM_Try, /*On fail goto*//*Label 15137*/ GIMT_Encode4(1018798), // Rule ID 13087 //
     /* 1018726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1018737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1018740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1018743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1018746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018765 */     // MIs[0] policy
     /* 1018765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018775 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018797 */     // GIR_Coverage, 13087,
     /* 1018797 */     GIR_EraseRootFromParent_Done,
     /* 1018798 */   // Label 15137: @1018798
     /* 1018798 */   GIM_Try, /*On fail goto*//*Label 15138*/ GIMT_Encode4(1018875), // Rule ID 13090 //
     /* 1018803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1018814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1018817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1018820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1018823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018842 */     // MIs[0] policy
     /* 1018842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018874 */     // GIR_Coverage, 13090,
     /* 1018874 */     GIR_EraseRootFromParent_Done,
     /* 1018875 */   // Label 15138: @1018875
     /* 1018875 */   GIM_Try, /*On fail goto*//*Label 15139*/ GIMT_Encode4(1018952), // Rule ID 13091 //
     /* 1018880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1018891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1018894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1018897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1018900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018919 */     // MIs[0] policy
     /* 1018919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018929 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018951 */     // GIR_Coverage, 13091,
     /* 1018951 */     GIR_EraseRootFromParent_Done,
     /* 1018952 */   // Label 15139: @1018952
     /* 1018952 */   GIM_Try, /*On fail goto*//*Label 15140*/ GIMT_Encode4(1019029), // Rule ID 13094 //
     /* 1018957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1018968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1018971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1018974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1018977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018996 */     // MIs[0] policy
     /* 1018996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019028 */     // GIR_Coverage, 13094,
     /* 1019028 */     GIR_EraseRootFromParent_Done,
     /* 1019029 */   // Label 15140: @1019029
     /* 1019029 */   GIM_Try, /*On fail goto*//*Label 15141*/ GIMT_Encode4(1019106), // Rule ID 13095 //
     /* 1019034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1019045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1019048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1019051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1019054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019073 */     // MIs[0] policy
     /* 1019073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1019086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019105 */     // GIR_Coverage, 13095,
     /* 1019105 */     GIR_EraseRootFromParent_Done,
     /* 1019106 */   // Label 15141: @1019106
     /* 1019106 */   GIM_Try, /*On fail goto*//*Label 15142*/ GIMT_Encode4(1019183), // Rule ID 13098 //
     /* 1019111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019150 */     // MIs[0] policy
     /* 1019150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019160 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019182 */     // GIR_Coverage, 13098,
     /* 1019182 */     GIR_EraseRootFromParent_Done,
     /* 1019183 */   // Label 15142: @1019183
     /* 1019183 */   GIM_Try, /*On fail goto*//*Label 15143*/ GIMT_Encode4(1019260), // Rule ID 13099 //
     /* 1019188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1019199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1019202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1019205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1019208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019227 */     // MIs[0] policy
     /* 1019227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019237 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019259 */     // GIR_Coverage, 13099,
     /* 1019259 */     GIR_EraseRootFromParent_Done,
     /* 1019260 */   // Label 15143: @1019260
     /* 1019260 */   GIM_Try, /*On fail goto*//*Label 15144*/ GIMT_Encode4(1019337), // Rule ID 13102 //
     /* 1019265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1019282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019304 */     // MIs[0] policy
     /* 1019304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019336 */     // GIR_Coverage, 13102,
     /* 1019336 */     GIR_EraseRootFromParent_Done,
     /* 1019337 */   // Label 15144: @1019337
     /* 1019337 */   GIM_Try, /*On fail goto*//*Label 15145*/ GIMT_Encode4(1019414), // Rule ID 13103 //
     /* 1019342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1019353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1019356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1019359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1019362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019381 */     // MIs[0] policy
     /* 1019381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019391 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019413 */     // GIR_Coverage, 13103,
     /* 1019413 */     GIR_EraseRootFromParent_Done,
     /* 1019414 */   // Label 15145: @1019414
     /* 1019414 */   GIM_Try, /*On fail goto*//*Label 15146*/ GIMT_Encode4(1019491), // Rule ID 13106 //
     /* 1019419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1019436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019458 */     // MIs[0] policy
     /* 1019458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019490 */     // GIR_Coverage, 13106,
     /* 1019490 */     GIR_EraseRootFromParent_Done,
     /* 1019491 */   // Label 15146: @1019491
     /* 1019491 */   GIM_Try, /*On fail goto*//*Label 15147*/ GIMT_Encode4(1019568), // Rule ID 13107 //
     /* 1019496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1019507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1019513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019535 */     // MIs[0] policy
     /* 1019535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019545 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019567 */     // GIR_Coverage, 13107,
     /* 1019567 */     GIR_EraseRootFromParent_Done,
     /* 1019568 */   // Label 15147: @1019568
     /* 1019568 */   GIM_Try, /*On fail goto*//*Label 15148*/ GIMT_Encode4(1019645), // Rule ID 13110 //
     /* 1019573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1019576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1019584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1019587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1019590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1019593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019612 */     // MIs[0] policy
     /* 1019612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019644 */     // GIR_Coverage, 13110,
     /* 1019644 */     GIR_EraseRootFromParent_Done,
     /* 1019645 */   // Label 15148: @1019645
     /* 1019645 */   GIM_Try, /*On fail goto*//*Label 15149*/ GIMT_Encode4(1019722), // Rule ID 13111 //
     /* 1019650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1019653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1019661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1019664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1019667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1019670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019689 */     // MIs[0] policy
     /* 1019689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019699 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019721 */     // GIR_Coverage, 13111,
     /* 1019721 */     GIR_EraseRootFromParent_Done,
     /* 1019722 */   // Label 15149: @1019722
     /* 1019722 */   GIM_Try, /*On fail goto*//*Label 15150*/ GIMT_Encode4(1019799), // Rule ID 13114 //
     /* 1019727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1019738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1019741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1019744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1019747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019766 */     // MIs[0] policy
     /* 1019766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1019779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019798 */     // GIR_Coverage, 13114,
     /* 1019798 */     GIR_EraseRootFromParent_Done,
     /* 1019799 */   // Label 15150: @1019799
     /* 1019799 */   GIM_Try, /*On fail goto*//*Label 15151*/ GIMT_Encode4(1019876), // Rule ID 13115 //
     /* 1019804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1019815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1019818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1019821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1019824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019843 */     // MIs[0] policy
     /* 1019843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019853 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1019856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019875 */     // GIR_Coverage, 13115,
     /* 1019875 */     GIR_EraseRootFromParent_Done,
     /* 1019876 */   // Label 15151: @1019876
     /* 1019876 */   GIM_Try, /*On fail goto*//*Label 15152*/ GIMT_Encode4(1019953), // Rule ID 13118 //
     /* 1019881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1019892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1019895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1019898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1019901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019920 */     // MIs[0] policy
     /* 1019920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019930 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1019933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019952 */     // GIR_Coverage, 13118,
     /* 1019952 */     GIR_EraseRootFromParent_Done,
     /* 1019953 */   // Label 15152: @1019953
     /* 1019953 */   GIM_Try, /*On fail goto*//*Label 15153*/ GIMT_Encode4(1020030), // Rule ID 13119 //
     /* 1019958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1019969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1019972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1019975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1019978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019997 */     // MIs[0] policy
     /* 1019997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020007 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020029 */     // GIR_Coverage, 13119,
     /* 1020029 */     GIR_EraseRootFromParent_Done,
     /* 1020030 */   // Label 15153: @1020030
     /* 1020030 */   GIM_Try, /*On fail goto*//*Label 15154*/ GIMT_Encode4(1020107), // Rule ID 13122 //
     /* 1020035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020074 */     // MIs[0] policy
     /* 1020074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020084 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020106 */     // GIR_Coverage, 13122,
     /* 1020106 */     GIR_EraseRootFromParent_Done,
     /* 1020107 */   // Label 15154: @1020107
     /* 1020107 */   GIM_Try, /*On fail goto*//*Label 15155*/ GIMT_Encode4(1020184), // Rule ID 13123 //
     /* 1020112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1020123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1020126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1020129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1020132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020151 */     // MIs[0] policy
     /* 1020151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020161 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1020180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020183 */     // GIR_Coverage, 13123,
     /* 1020183 */     GIR_EraseRootFromParent_Done,
     /* 1020184 */   // Label 15155: @1020184
     /* 1020184 */   GIM_Try, /*On fail goto*//*Label 15156*/ GIMT_Encode4(1020261), // Rule ID 13126 //
     /* 1020189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1020206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020228 */     // MIs[0] policy
     /* 1020228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020238 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020260 */     // GIR_Coverage, 13126,
     /* 1020260 */     GIR_EraseRootFromParent_Done,
     /* 1020261 */   // Label 15156: @1020261
     /* 1020261 */   GIM_Try, /*On fail goto*//*Label 15157*/ GIMT_Encode4(1020338), // Rule ID 13127 //
     /* 1020266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1020277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1020280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1020283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1020286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020305 */     // MIs[0] policy
     /* 1020305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020315 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020337 */     // GIR_Coverage, 13127,
     /* 1020337 */     GIR_EraseRootFromParent_Done,
     /* 1020338 */   // Label 15157: @1020338
     /* 1020338 */   GIM_Try, /*On fail goto*//*Label 15158*/ GIMT_Encode4(1020415), // Rule ID 13130 //
     /* 1020343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1020360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020382 */     // MIs[0] policy
     /* 1020382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020414 */     // GIR_Coverage, 13130,
     /* 1020414 */     GIR_EraseRootFromParent_Done,
     /* 1020415 */   // Label 15158: @1020415
     /* 1020415 */   GIM_Try, /*On fail goto*//*Label 15159*/ GIMT_Encode4(1020492), // Rule ID 13131 //
     /* 1020420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1020431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1020434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1020437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1020440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020459 */     // MIs[0] policy
     /* 1020459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020469 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020491 */     // GIR_Coverage, 13131,
     /* 1020491 */     GIR_EraseRootFromParent_Done,
     /* 1020492 */   // Label 15159: @1020492
     /* 1020492 */   GIM_Try, /*On fail goto*//*Label 15160*/ GIMT_Encode4(1020569), // Rule ID 13134 //
     /* 1020497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1020514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020536 */     // MIs[0] policy
     /* 1020536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020568 */     // GIR_Coverage, 13134,
     /* 1020568 */     GIR_EraseRootFromParent_Done,
     /* 1020569 */   // Label 15160: @1020569
     /* 1020569 */   GIM_Try, /*On fail goto*//*Label 15161*/ GIMT_Encode4(1020646), // Rule ID 13135 //
     /* 1020574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1020591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020613 */     // MIs[0] policy
     /* 1020613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020623 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020645 */     // GIR_Coverage, 13135,
     /* 1020645 */     GIR_EraseRootFromParent_Done,
     /* 1020646 */   // Label 15161: @1020646
     /* 1020646 */   GIM_Try, /*On fail goto*//*Label 15162*/ GIMT_Encode4(1020723), // Rule ID 13138 //
     /* 1020651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1020662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1020665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1020668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1020671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020690 */     // MIs[0] policy
     /* 1020690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020722 */     // GIR_Coverage, 13138,
     /* 1020722 */     GIR_EraseRootFromParent_Done,
     /* 1020723 */   // Label 15162: @1020723
     /* 1020723 */   GIM_Try, /*On fail goto*//*Label 15163*/ GIMT_Encode4(1020800), // Rule ID 13139 //
     /* 1020728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1020739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1020742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1020745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1020748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020767 */     // MIs[0] policy
     /* 1020767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020799 */     // GIR_Coverage, 13139,
     /* 1020799 */     GIR_EraseRootFromParent_Done,
     /* 1020800 */   // Label 15163: @1020800
     /* 1020800 */   GIM_Try, /*On fail goto*//*Label 15164*/ GIMT_Encode4(1020877), // Rule ID 13142 //
     /* 1020805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1020816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1020819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1020822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1020825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020844 */     // MIs[0] policy
     /* 1020844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020876 */     // GIR_Coverage, 13142,
     /* 1020876 */     GIR_EraseRootFromParent_Done,
     /* 1020877 */   // Label 15164: @1020877
     /* 1020877 */   GIM_Try, /*On fail goto*//*Label 15165*/ GIMT_Encode4(1020954), // Rule ID 13143 //
     /* 1020882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1020893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1020896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1020899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1020902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020921 */     // MIs[0] policy
     /* 1020921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020931 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020953 */     // GIR_Coverage, 13143,
     /* 1020953 */     GIR_EraseRootFromParent_Done,
     /* 1020954 */   // Label 15165: @1020954
     /* 1020954 */   GIM_Try, /*On fail goto*//*Label 15166*/ GIMT_Encode4(1021031), // Rule ID 13146 //
     /* 1020959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1020970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1020973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1020976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1020979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020998 */     // MIs[0] policy
     /* 1020998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021008 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021030 */     // GIR_Coverage, 13146,
     /* 1021030 */     GIR_EraseRootFromParent_Done,
     /* 1021031 */   // Label 15166: @1021031
     /* 1021031 */   GIM_Try, /*On fail goto*//*Label 15167*/ GIMT_Encode4(1021108), // Rule ID 13147 //
     /* 1021036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1021047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1021050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1021053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1021056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021075 */     // MIs[0] policy
     /* 1021075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021085 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021107 */     // GIR_Coverage, 13147,
     /* 1021107 */     GIR_EraseRootFromParent_Done,
     /* 1021108 */   // Label 15167: @1021108
     /* 1021108 */   GIM_Try, /*On fail goto*//*Label 15168*/ GIMT_Encode4(1021185), // Rule ID 13150 //
     /* 1021113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1021130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021152 */     // MIs[0] policy
     /* 1021152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021184 */     // GIR_Coverage, 13150,
     /* 1021184 */     GIR_EraseRootFromParent_Done,
     /* 1021185 */   // Label 15168: @1021185
     /* 1021185 */   GIM_Try, /*On fail goto*//*Label 15169*/ GIMT_Encode4(1021262), // Rule ID 13151 //
     /* 1021190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1021201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1021204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1021207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1021210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1021229 */     // MIs[0] policy
     /* 1021229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021239 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1021242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021261 */     // GIR_Coverage, 13151,
     /* 1021261 */     GIR_EraseRootFromParent_Done,
     /* 1021262 */   // Label 15169: @1021262
     /* 1021262 */   GIM_Try, /*On fail goto*//*Label 15170*/ GIMT_Encode4(1021339), // Rule ID 13154 //
     /* 1021267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1021284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021306 */     // MIs[0] policy
     /* 1021306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021316 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021338 */     // GIR_Coverage, 13154,
     /* 1021338 */     GIR_EraseRootFromParent_Done,
     /* 1021339 */   // Label 15170: @1021339
     /* 1021339 */   GIM_Try, /*On fail goto*//*Label 15171*/ GIMT_Encode4(1021416), // Rule ID 13155 //
     /* 1021344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1021355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1021358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1021361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1021364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1021383 */     // MIs[0] policy
     /* 1021383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1021396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021415 */     // GIR_Coverage, 13155,
     /* 1021415 */     GIR_EraseRootFromParent_Done,
     /* 1021416 */   // Label 15171: @1021416
     /* 1021416 */   GIM_Try, /*On fail goto*//*Label 15172*/ GIMT_Encode4(1021493), // Rule ID 13158 //
     /* 1021421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1021424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1021438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021460 */     // MIs[0] policy
     /* 1021460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021470 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021492 */     // GIR_Coverage, 13158,
     /* 1021492 */     GIR_EraseRootFromParent_Done,
     /* 1021493 */   // Label 15172: @1021493
     /* 1021493 */   GIM_Try, /*On fail goto*//*Label 15173*/ GIMT_Encode4(1021570), // Rule ID 13159 //
     /* 1021498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1021501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1021515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021537 */     // MIs[0] policy
     /* 1021537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021547 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021569 */     // GIR_Coverage, 13159,
     /* 1021569 */     GIR_EraseRootFromParent_Done,
     /* 1021570 */   // Label 15173: @1021570
     /* 1021570 */   GIM_Try, /*On fail goto*//*Label 15174*/ GIMT_Encode4(1021647), // Rule ID 13162 //
     /* 1021575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1021586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1021589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1021595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021614 */     // MIs[0] policy
     /* 1021614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021624 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1021627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021646 */     // GIR_Coverage, 13162,
     /* 1021646 */     GIR_EraseRootFromParent_Done,
     /* 1021647 */   // Label 15174: @1021647
     /* 1021647 */   GIM_Try, /*On fail goto*//*Label 15175*/ GIMT_Encode4(1021724), // Rule ID 13163 //
     /* 1021652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1021663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1021666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1021672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021691 */     // MIs[0] policy
     /* 1021691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021701 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1021704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021723 */     // GIR_Coverage, 13163,
     /* 1021723 */     GIR_EraseRootFromParent_Done,
     /* 1021724 */   // Label 15175: @1021724
     /* 1021724 */   GIM_Try, /*On fail goto*//*Label 15176*/ GIMT_Encode4(1021801), // Rule ID 13166 //
     /* 1021729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1021740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1021743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1021749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021768 */     // MIs[0] policy
     /* 1021768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021778 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1021781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021800 */     // GIR_Coverage, 13166,
     /* 1021800 */     GIR_EraseRootFromParent_Done,
     /* 1021801 */   // Label 15176: @1021801
     /* 1021801 */   GIM_Try, /*On fail goto*//*Label 15177*/ GIMT_Encode4(1021878), // Rule ID 13167 //
     /* 1021806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1021817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1021820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1021826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021845 */     // MIs[0] policy
     /* 1021845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021855 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1021858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021877 */     // GIR_Coverage, 13167,
     /* 1021877 */     GIR_EraseRootFromParent_Done,
     /* 1021878 */   // Label 15177: @1021878
     /* 1021878 */   GIM_Try, /*On fail goto*//*Label 15178*/ GIMT_Encode4(1021955), // Rule ID 13170 //
     /* 1021883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1021894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1021897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1021903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021922 */     // MIs[0] policy
     /* 1021922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021932 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1021935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021954 */     // GIR_Coverage, 13170,
     /* 1021954 */     GIR_EraseRootFromParent_Done,
     /* 1021955 */   // Label 15178: @1021955
     /* 1021955 */   GIM_Try, /*On fail goto*//*Label 15179*/ GIMT_Encode4(1022032), // Rule ID 13171 //
     /* 1021960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1021971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1021974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1021980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021999 */     // MIs[0] policy
     /* 1021999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022009 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022031 */     // GIR_Coverage, 13171,
     /* 1022031 */     GIR_EraseRootFromParent_Done,
     /* 1022032 */   // Label 15179: @1022032
     /* 1022032 */   GIM_Try, /*On fail goto*//*Label 15180*/ GIMT_Encode4(1022109), // Rule ID 13174 //
     /* 1022037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022076 */     // MIs[0] policy
     /* 1022076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022086 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022108 */     // GIR_Coverage, 13174,
     /* 1022108 */     GIR_EraseRootFromParent_Done,
     /* 1022109 */   // Label 15180: @1022109
     /* 1022109 */   GIM_Try, /*On fail goto*//*Label 15181*/ GIMT_Encode4(1022186), // Rule ID 13175 //
     /* 1022114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1022125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1022128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1022134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022153 */     // MIs[0] policy
     /* 1022153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022163 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1022166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022185 */     // GIR_Coverage, 13175,
     /* 1022185 */     GIR_EraseRootFromParent_Done,
     /* 1022186 */   // Label 15181: @1022186
     /* 1022186 */   GIM_Try, /*On fail goto*//*Label 15182*/ GIMT_Encode4(1022263), // Rule ID 13178 //
     /* 1022191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022230 */     // MIs[0] policy
     /* 1022230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022262 */     // GIR_Coverage, 13178,
     /* 1022262 */     GIR_EraseRootFromParent_Done,
     /* 1022263 */   // Label 15182: @1022263
     /* 1022263 */   GIM_Try, /*On fail goto*//*Label 15183*/ GIMT_Encode4(1022340), // Rule ID 13179 //
     /* 1022268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1022279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1022282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1022288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022307 */     // MIs[0] policy
     /* 1022307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022317 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022339 */     // GIR_Coverage, 13179,
     /* 1022339 */     GIR_EraseRootFromParent_Done,
     /* 1022340 */   // Label 15183: @1022340
     /* 1022340 */   GIM_Try, /*On fail goto*//*Label 15184*/ GIMT_Encode4(1022417), // Rule ID 13182 //
     /* 1022345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022384 */     // MIs[0] policy
     /* 1022384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022416 */     // GIR_Coverage, 13182,
     /* 1022416 */     GIR_EraseRootFromParent_Done,
     /* 1022417 */   // Label 15184: @1022417
     /* 1022417 */   GIM_Try, /*On fail goto*//*Label 15185*/ GIMT_Encode4(1022494), // Rule ID 13183 //
     /* 1022422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1022433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1022436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1022442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022461 */     // MIs[0] policy
     /* 1022461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022471 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1022474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022493 */     // GIR_Coverage, 13183,
     /* 1022493 */     GIR_EraseRootFromParent_Done,
     /* 1022494 */   // Label 15185: @1022494
     /* 1022494 */   GIM_Try, /*On fail goto*//*Label 15186*/ GIMT_Encode4(1022571), // Rule ID 13186 //
     /* 1022499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022538 */     // MIs[0] policy
     /* 1022538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022548 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022570 */     // GIR_Coverage, 13186,
     /* 1022570 */     GIR_EraseRootFromParent_Done,
     /* 1022571 */   // Label 15186: @1022571
     /* 1022571 */   GIM_Try, /*On fail goto*//*Label 15187*/ GIMT_Encode4(1022648), // Rule ID 13187 //
     /* 1022576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022615 */     // MIs[0] policy
     /* 1022615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022625 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022647 */     // GIR_Coverage, 13187,
     /* 1022647 */     GIR_EraseRootFromParent_Done,
     /* 1022648 */   // Label 15187: @1022648
     /* 1022648 */   GIM_Try, /*On fail goto*//*Label 15188*/ GIMT_Encode4(1022725), // Rule ID 13190 //
     /* 1022653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1022664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1022667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1022673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022692 */     // MIs[0] policy
     /* 1022692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022724 */     // GIR_Coverage, 13190,
     /* 1022724 */     GIR_EraseRootFromParent_Done,
     /* 1022725 */   // Label 15188: @1022725
     /* 1022725 */   GIM_Try, /*On fail goto*//*Label 15189*/ GIMT_Encode4(1022802), // Rule ID 13191 //
     /* 1022730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1022741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1022744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1022750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022769 */     // MIs[0] policy
     /* 1022769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022779 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022801 */     // GIR_Coverage, 13191,
     /* 1022801 */     GIR_EraseRootFromParent_Done,
     /* 1022802 */   // Label 15189: @1022802
     /* 1022802 */   GIM_Try, /*On fail goto*//*Label 15190*/ GIMT_Encode4(1022879), // Rule ID 13194 //
     /* 1022807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1022818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1022821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1022827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022846 */     // MIs[0] policy
     /* 1022846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022856 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022878 */     // GIR_Coverage, 13194,
     /* 1022878 */     GIR_EraseRootFromParent_Done,
     /* 1022879 */   // Label 15190: @1022879
     /* 1022879 */   GIM_Try, /*On fail goto*//*Label 15191*/ GIMT_Encode4(1022956), // Rule ID 13195 //
     /* 1022884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1022895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1022898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1022904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022923 */     // MIs[0] policy
     /* 1022923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022933 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022955 */     // GIR_Coverage, 13195,
     /* 1022955 */     GIR_EraseRootFromParent_Done,
     /* 1022956 */   // Label 15191: @1022956
     /* 1022956 */   GIM_Try, /*On fail goto*//*Label 15192*/ GIMT_Encode4(1023033), // Rule ID 13198 //
     /* 1022961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1022964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1022972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1022975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1022981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023000 */     // MIs[0] policy
     /* 1023000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023010 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023032 */     // GIR_Coverage, 13198,
     /* 1023032 */     GIR_EraseRootFromParent_Done,
     /* 1023033 */   // Label 15192: @1023033
     /* 1023033 */   GIM_Try, /*On fail goto*//*Label 15193*/ GIMT_Encode4(1023110), // Rule ID 13199 //
     /* 1023038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1023041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1023049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1023052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1023058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1023077 */     // MIs[0] policy
     /* 1023077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023087 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1023090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1023106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023109 */     // GIR_Coverage, 13199,
     /* 1023109 */     GIR_EraseRootFromParent_Done,
     /* 1023110 */   // Label 15193: @1023110
     /* 1023110 */   GIM_Try, /*On fail goto*//*Label 15194*/ GIMT_Encode4(1023187), // Rule ID 13202 //
     /* 1023115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023154 */     // MIs[0] policy
     /* 1023154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023164 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023186 */     // GIR_Coverage, 13202,
     /* 1023186 */     GIR_EraseRootFromParent_Done,
     /* 1023187 */   // Label 15194: @1023187
     /* 1023187 */   GIM_Try, /*On fail goto*//*Label 15195*/ GIMT_Encode4(1023264), // Rule ID 13203 //
     /* 1023192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1023203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1023206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1023212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023231 */     // MIs[0] policy
     /* 1023231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023241 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023263 */     // GIR_Coverage, 13203,
     /* 1023263 */     GIR_EraseRootFromParent_Done,
     /* 1023264 */   // Label 15195: @1023264
     /* 1023264 */   GIM_Try, /*On fail goto*//*Label 15196*/ GIMT_Encode4(1023341), // Rule ID 13206 //
     /* 1023269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023308 */     // MIs[0] policy
     /* 1023308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023318 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023340 */     // GIR_Coverage, 13206,
     /* 1023340 */     GIR_EraseRootFromParent_Done,
     /* 1023341 */   // Label 15196: @1023341
     /* 1023341 */   GIM_Try, /*On fail goto*//*Label 15197*/ GIMT_Encode4(1023418), // Rule ID 13207 //
     /* 1023346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1023357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1023360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1023366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023385 */     // MIs[0] policy
     /* 1023385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023395 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023417 */     // GIR_Coverage, 13207,
     /* 1023417 */     GIR_EraseRootFromParent_Done,
     /* 1023418 */   // Label 15197: @1023418
     /* 1023418 */   GIM_Try, /*On fail goto*//*Label 15198*/ GIMT_Encode4(1023495), // Rule ID 13210 //
     /* 1023423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023462 */     // MIs[0] policy
     /* 1023462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023472 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023494 */     // GIR_Coverage, 13210,
     /* 1023494 */     GIR_EraseRootFromParent_Done,
     /* 1023495 */   // Label 15198: @1023495
     /* 1023495 */   GIM_Try, /*On fail goto*//*Label 15199*/ GIMT_Encode4(1023572), // Rule ID 13211 //
     /* 1023500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023539 */     // MIs[0] policy
     /* 1023539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023549 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023571 */     // GIR_Coverage, 13211,
     /* 1023571 */     GIR_EraseRootFromParent_Done,
     /* 1023572 */   // Label 15199: @1023572
     /* 1023572 */   GIM_Try, /*On fail goto*//*Label 15200*/ GIMT_Encode4(1023649), // Rule ID 13214 //
     /* 1023577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1023588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1023591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1023597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023616 */     // MIs[0] policy
     /* 1023616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023648 */     // GIR_Coverage, 13214,
     /* 1023648 */     GIR_EraseRootFromParent_Done,
     /* 1023649 */   // Label 15200: @1023649
     /* 1023649 */   GIM_Try, /*On fail goto*//*Label 15201*/ GIMT_Encode4(1023726), // Rule ID 13215 //
     /* 1023654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1023665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1023668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1023674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023693 */     // MIs[0] policy
     /* 1023693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023703 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023725 */     // GIR_Coverage, 13215,
     /* 1023725 */     GIR_EraseRootFromParent_Done,
     /* 1023726 */   // Label 15201: @1023726
     /* 1023726 */   GIM_Try, /*On fail goto*//*Label 15202*/ GIMT_Encode4(1023803), // Rule ID 13218 //
     /* 1023731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1023742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1023745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1023751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023770 */     // MIs[0] policy
     /* 1023770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023780 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023802 */     // GIR_Coverage, 13218,
     /* 1023802 */     GIR_EraseRootFromParent_Done,
     /* 1023803 */   // Label 15202: @1023803
     /* 1023803 */   GIM_Try, /*On fail goto*//*Label 15203*/ GIMT_Encode4(1023880), // Rule ID 13219 //
     /* 1023808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1023819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1023822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1023828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023847 */     // MIs[0] policy
     /* 1023847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023857 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023879 */     // GIR_Coverage, 13219,
     /* 1023879 */     GIR_EraseRootFromParent_Done,
     /* 1023880 */   // Label 15203: @1023880
     /* 1023880 */   GIM_Try, /*On fail goto*//*Label 15204*/ GIMT_Encode4(1023957), // Rule ID 13222 //
     /* 1023885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1023896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1023899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1023905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023924 */     // MIs[0] policy
     /* 1023924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023956 */     // GIR_Coverage, 13222,
     /* 1023956 */     GIR_EraseRootFromParent_Done,
     /* 1023957 */   // Label 15204: @1023957
     /* 1023957 */   GIM_Try, /*On fail goto*//*Label 15205*/ GIMT_Encode4(1024034), // Rule ID 13223 //
     /* 1023962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1023973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1023976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1023982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024001 */     // MIs[0] policy
     /* 1024001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024011 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024033 */     // GIR_Coverage, 13223,
     /* 1024033 */     GIR_EraseRootFromParent_Done,
     /* 1024034 */   // Label 15205: @1024034
     /* 1024034 */   GIM_Try, /*On fail goto*//*Label 15206*/ GIMT_Encode4(1024111), // Rule ID 13226 //
     /* 1024039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024078 */     // MIs[0] policy
     /* 1024078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024110 */     // GIR_Coverage, 13226,
     /* 1024110 */     GIR_EraseRootFromParent_Done,
     /* 1024111 */   // Label 15206: @1024111
     /* 1024111 */   GIM_Try, /*On fail goto*//*Label 15207*/ GIMT_Encode4(1024188), // Rule ID 13227 //
     /* 1024116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1024127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1024130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1024136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024155 */     // MIs[0] policy
     /* 1024155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024165 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024187 */     // GIR_Coverage, 13227,
     /* 1024187 */     GIR_EraseRootFromParent_Done,
     /* 1024188 */   // Label 15207: @1024188
     /* 1024188 */   GIM_Try, /*On fail goto*//*Label 15208*/ GIMT_Encode4(1024265), // Rule ID 13230 //
     /* 1024193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024232 */     // MIs[0] policy
     /* 1024232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024242 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024264 */     // GIR_Coverage, 13230,
     /* 1024264 */     GIR_EraseRootFromParent_Done,
     /* 1024265 */   // Label 15208: @1024265
     /* 1024265 */   GIM_Try, /*On fail goto*//*Label 15209*/ GIMT_Encode4(1024342), // Rule ID 13231 //
     /* 1024270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1024281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1024284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1024290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024309 */     // MIs[0] policy
     /* 1024309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024319 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024341 */     // GIR_Coverage, 13231,
     /* 1024341 */     GIR_EraseRootFromParent_Done,
     /* 1024342 */   // Label 15209: @1024342
     /* 1024342 */   GIM_Try, /*On fail goto*//*Label 15210*/ GIMT_Encode4(1024419), // Rule ID 13234 //
     /* 1024347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024386 */     // MIs[0] policy
     /* 1024386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024396 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024418 */     // GIR_Coverage, 13234,
     /* 1024418 */     GIR_EraseRootFromParent_Done,
     /* 1024419 */   // Label 15210: @1024419
     /* 1024419 */   GIM_Try, /*On fail goto*//*Label 15211*/ GIMT_Encode4(1024496), // Rule ID 13235 //
     /* 1024424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1024435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1024438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1024444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024463 */     // MIs[0] policy
     /* 1024463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024473 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1024492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024495 */     // GIR_Coverage, 13235,
     /* 1024495 */     GIR_EraseRootFromParent_Done,
     /* 1024496 */   // Label 15211: @1024496
     /* 1024496 */   GIM_Try, /*On fail goto*//*Label 15212*/ GIMT_Encode4(1024573), // Rule ID 13238 //
     /* 1024501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024540 */     // MIs[0] policy
     /* 1024540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024550 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024572 */     // GIR_Coverage, 13238,
     /* 1024572 */     GIR_EraseRootFromParent_Done,
     /* 1024573 */   // Label 15212: @1024573
     /* 1024573 */   GIM_Try, /*On fail goto*//*Label 15213*/ GIMT_Encode4(1024650), // Rule ID 13239 //
     /* 1024578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1024581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024617 */     // MIs[0] policy
     /* 1024617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024627 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024649 */     // GIR_Coverage, 13239,
     /* 1024649 */     GIR_EraseRootFromParent_Done,
     /* 1024650 */   // Label 15213: @1024650
     /* 1024650 */   GIM_Try, /*On fail goto*//*Label 15214*/ GIMT_Encode4(1024727), // Rule ID 13242 //
     /* 1024655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1024666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1024669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1024675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024694 */     // MIs[0] policy
     /* 1024694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024704 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024726 */     // GIR_Coverage, 13242,
     /* 1024726 */     GIR_EraseRootFromParent_Done,
     /* 1024727 */   // Label 15214: @1024727
     /* 1024727 */   GIM_Try, /*On fail goto*//*Label 15215*/ GIMT_Encode4(1024804), // Rule ID 13243 //
     /* 1024732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1024735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1024743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1024746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1024752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024771 */     // MIs[0] policy
     /* 1024771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024781 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024803 */     // GIR_Coverage, 13243,
     /* 1024803 */     GIR_EraseRootFromParent_Done,
     /* 1024804 */   // Label 15215: @1024804
     /* 1024804 */   GIM_Try, /*On fail goto*//*Label 15216*/ GIMT_Encode4(1024881), // Rule ID 13246 //
     /* 1024809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1024820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1024823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1024829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024848 */     // MIs[0] policy
     /* 1024848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024858 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024880 */     // GIR_Coverage, 13246,
     /* 1024880 */     GIR_EraseRootFromParent_Done,
     /* 1024881 */   // Label 15216: @1024881
     /* 1024881 */   GIM_Try, /*On fail goto*//*Label 15217*/ GIMT_Encode4(1024958), // Rule ID 13247 //
     /* 1024886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1024889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1024897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1024900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1024906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024925 */     // MIs[0] policy
     /* 1024925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024935 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024957 */     // GIR_Coverage, 13247,
     /* 1024957 */     GIR_EraseRootFromParent_Done,
     /* 1024958 */   // Label 15217: @1024958
     /* 1024958 */   GIM_Try, /*On fail goto*//*Label 15218*/ GIMT_Encode4(1025035), // Rule ID 13250 //
     /* 1024963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1024971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1024974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1024977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1024980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1024983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025002 */     // MIs[0] policy
     /* 1025002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025012 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1025015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025034 */     // GIR_Coverage, 13250,
     /* 1025034 */     GIR_EraseRootFromParent_Done,
     /* 1025035 */   // Label 15218: @1025035
     /* 1025035 */   GIM_Try, /*On fail goto*//*Label 15219*/ GIMT_Encode4(1025112), // Rule ID 13251 //
     /* 1025040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1025051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1025054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1025057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1025060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025079 */     // MIs[0] policy
     /* 1025079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025089 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1025092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025111 */     // GIR_Coverage, 13251,
     /* 1025111 */     GIR_EraseRootFromParent_Done,
     /* 1025112 */   // Label 15219: @1025112
     /* 1025112 */   GIM_Try, /*On fail goto*//*Label 15220*/ GIMT_Encode4(1025189), // Rule ID 13254 //
     /* 1025117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1025134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025156 */     // MIs[0] policy
     /* 1025156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025166 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025188 */     // GIR_Coverage, 13254,
     /* 1025188 */     GIR_EraseRootFromParent_Done,
     /* 1025189 */   // Label 15220: @1025189
     /* 1025189 */   GIM_Try, /*On fail goto*//*Label 15221*/ GIMT_Encode4(1025266), // Rule ID 13255 //
     /* 1025194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1025205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1025208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1025211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1025214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025233 */     // MIs[0] policy
     /* 1025233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025243 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025265 */     // GIR_Coverage, 13255,
     /* 1025265 */     GIR_EraseRootFromParent_Done,
     /* 1025266 */   // Label 15221: @1025266
     /* 1025266 */   GIM_Try, /*On fail goto*//*Label 15222*/ GIMT_Encode4(1025343), // Rule ID 13258 //
     /* 1025271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1025288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025310 */     // MIs[0] policy
     /* 1025310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025320 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025342 */     // GIR_Coverage, 13258,
     /* 1025342 */     GIR_EraseRootFromParent_Done,
     /* 1025343 */   // Label 15222: @1025343
     /* 1025343 */   GIM_Try, /*On fail goto*//*Label 15223*/ GIMT_Encode4(1025420), // Rule ID 13259 //
     /* 1025348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1025359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1025362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1025365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1025368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025387 */     // MIs[0] policy
     /* 1025387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025397 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025419 */     // GIR_Coverage, 13259,
     /* 1025419 */     GIR_EraseRootFromParent_Done,
     /* 1025420 */   // Label 15223: @1025420
     /* 1025420 */   GIM_Try, /*On fail goto*//*Label 15224*/ GIMT_Encode4(1025497), // Rule ID 13262 //
     /* 1025425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1025442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025464 */     // MIs[0] policy
     /* 1025464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025496 */     // GIR_Coverage, 13262,
     /* 1025496 */     GIR_EraseRootFromParent_Done,
     /* 1025497 */   // Label 15224: @1025497
     /* 1025497 */   GIM_Try, /*On fail goto*//*Label 15225*/ GIMT_Encode4(1025574), // Rule ID 13263 //
     /* 1025502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1025519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025541 */     // MIs[0] policy
     /* 1025541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025551 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025573 */     // GIR_Coverage, 13263,
     /* 1025573 */     GIR_EraseRootFromParent_Done,
     /* 1025574 */   // Label 15225: @1025574
     /* 1025574 */   GIM_Try, /*On fail goto*//*Label 15226*/ GIMT_Encode4(1025651), // Rule ID 13266 //
     /* 1025579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1025590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1025593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1025596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1025599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025618 */     // MIs[0] policy
     /* 1025618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025628 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025650 */     // GIR_Coverage, 13266,
     /* 1025650 */     GIR_EraseRootFromParent_Done,
     /* 1025651 */   // Label 15226: @1025651
     /* 1025651 */   GIM_Try, /*On fail goto*//*Label 15227*/ GIMT_Encode4(1025728), // Rule ID 13267 //
     /* 1025656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1025667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1025670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1025673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1025676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025695 */     // MIs[0] policy
     /* 1025695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025705 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025727 */     // GIR_Coverage, 13267,
     /* 1025727 */     GIR_EraseRootFromParent_Done,
     /* 1025728 */   // Label 15227: @1025728
     /* 1025728 */   GIM_Try, /*On fail goto*//*Label 15228*/ GIMT_Encode4(1025805), // Rule ID 13270 //
     /* 1025733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1025744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1025747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1025750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1025753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025772 */     // MIs[0] policy
     /* 1025772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1025801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025804 */     // GIR_Coverage, 13270,
     /* 1025804 */     GIR_EraseRootFromParent_Done,
     /* 1025805 */   // Label 15228: @1025805
     /* 1025805 */   GIM_Try, /*On fail goto*//*Label 15229*/ GIMT_Encode4(1025882), // Rule ID 13271 //
     /* 1025810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1025821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1025824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1025827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1025830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025849 */     // MIs[0] policy
     /* 1025849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025859 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1025878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025881 */     // GIR_Coverage, 13271,
     /* 1025881 */     GIR_EraseRootFromParent_Done,
     /* 1025882 */   // Label 15229: @1025882
     /* 1025882 */   GIM_Try, /*On fail goto*//*Label 15230*/ GIMT_Encode4(1025959), // Rule ID 13274 //
     /* 1025887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1025898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1025901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1025907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025926 */     // MIs[0] policy
     /* 1025926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025958 */     // GIR_Coverage, 13274,
     /* 1025958 */     GIR_EraseRootFromParent_Done,
     /* 1025959 */   // Label 15230: @1025959
     /* 1025959 */   GIM_Try, /*On fail goto*//*Label 15231*/ GIMT_Encode4(1026036), // Rule ID 13275 //
     /* 1025964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1025975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1025978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1025984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026003 */     // MIs[0] policy
     /* 1026003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026013 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026035 */     // GIR_Coverage, 13275,
     /* 1026035 */     GIR_EraseRootFromParent_Done,
     /* 1026036 */   // Label 15231: @1026036
     /* 1026036 */   GIM_Try, /*On fail goto*//*Label 15232*/ GIMT_Encode4(1026113), // Rule ID 13278 //
     /* 1026041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1026058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026080 */     // MIs[0] policy
     /* 1026080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026112 */     // GIR_Coverage, 13278,
     /* 1026112 */     GIR_EraseRootFromParent_Done,
     /* 1026113 */   // Label 15232: @1026113
     /* 1026113 */   GIM_Try, /*On fail goto*//*Label 15233*/ GIMT_Encode4(1026190), // Rule ID 13279 //
     /* 1026118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1026129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1026132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1026135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1026138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026157 */     // MIs[0] policy
     /* 1026157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026167 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026189 */     // GIR_Coverage, 13279,
     /* 1026189 */     GIR_EraseRootFromParent_Done,
     /* 1026190 */   // Label 15233: @1026190
     /* 1026190 */   GIM_Try, /*On fail goto*//*Label 15234*/ GIMT_Encode4(1026267), // Rule ID 13282 //
     /* 1026195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1026212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026234 */     // MIs[0] policy
     /* 1026234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026266 */     // GIR_Coverage, 13282,
     /* 1026266 */     GIR_EraseRootFromParent_Done,
     /* 1026267 */   // Label 15234: @1026267
     /* 1026267 */   GIM_Try, /*On fail goto*//*Label 15235*/ GIMT_Encode4(1026344), // Rule ID 13283 //
     /* 1026272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1026283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1026286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1026289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1026292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026311 */     // MIs[0] policy
     /* 1026311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026321 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026343 */     // GIR_Coverage, 13283,
     /* 1026343 */     GIR_EraseRootFromParent_Done,
     /* 1026344 */   // Label 15235: @1026344
     /* 1026344 */   GIM_Try, /*On fail goto*//*Label 15236*/ GIMT_Encode4(1026421), // Rule ID 13286 //
     /* 1026349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1026352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1026366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026388 */     // MIs[0] policy
     /* 1026388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026420 */     // GIR_Coverage, 13286,
     /* 1026420 */     GIR_EraseRootFromParent_Done,
     /* 1026421 */   // Label 15236: @1026421
     /* 1026421 */   GIM_Try, /*On fail goto*//*Label 15237*/ GIMT_Encode4(1026498), // Rule ID 13287 //
     /* 1026426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1026429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1026437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1026440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1026443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1026446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1026465 */     // MIs[0] policy
     /* 1026465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026475 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1026478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1026494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026497 */     // GIR_Coverage, 13287,
     /* 1026497 */     GIR_EraseRootFromParent_Done,
     /* 1026498 */   // Label 15237: @1026498
     /* 1026498 */   GIM_Try, /*On fail goto*//*Label 15238*/ GIMT_Encode4(1026575), // Rule ID 13290 //
     /* 1026503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1026520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026542 */     // MIs[0] policy
     /* 1026542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1026555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026574 */     // GIR_Coverage, 13290,
     /* 1026574 */     GIR_EraseRootFromParent_Done,
     /* 1026575 */   // Label 15238: @1026575
     /* 1026575 */   GIM_Try, /*On fail goto*//*Label 15239*/ GIMT_Encode4(1026652), // Rule ID 13291 //
     /* 1026580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1026597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026619 */     // MIs[0] policy
     /* 1026619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026629 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1026632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026651 */     // GIR_Coverage, 13291,
     /* 1026651 */     GIR_EraseRootFromParent_Done,
     /* 1026652 */   // Label 15239: @1026652
     /* 1026652 */   GIM_Try, /*On fail goto*//*Label 15240*/ GIMT_Encode4(1026729), // Rule ID 13294 //
     /* 1026657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1026668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1026671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1026674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1026677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026696 */     // MIs[0] policy
     /* 1026696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026706 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1026709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026728 */     // GIR_Coverage, 13294,
     /* 1026728 */     GIR_EraseRootFromParent_Done,
     /* 1026729 */   // Label 15240: @1026729
     /* 1026729 */   GIM_Try, /*On fail goto*//*Label 15241*/ GIMT_Encode4(1026806), // Rule ID 13295 //
     /* 1026734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1026745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1026748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1026751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1026754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026773 */     // MIs[0] policy
     /* 1026773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026783 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1026786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026805 */     // GIR_Coverage, 13295,
     /* 1026805 */     GIR_EraseRootFromParent_Done,
     /* 1026806 */   // Label 15241: @1026806
     /* 1026806 */   GIM_Try, /*On fail goto*//*Label 15242*/ GIMT_Encode4(1026883), // Rule ID 13298 //
     /* 1026811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1026822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1026825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1026828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1026831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026850 */     // MIs[0] policy
     /* 1026850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026860 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1026863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026882 */     // GIR_Coverage, 13298,
     /* 1026882 */     GIR_EraseRootFromParent_Done,
     /* 1026883 */   // Label 15242: @1026883
     /* 1026883 */   GIM_Try, /*On fail goto*//*Label 15243*/ GIMT_Encode4(1026960), // Rule ID 13299 //
     /* 1026888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1026899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1026902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1026905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1026908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026927 */     // MIs[0] policy
     /* 1026927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026937 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1026940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026959 */     // GIR_Coverage, 13299,
     /* 1026959 */     GIR_EraseRootFromParent_Done,
     /* 1026960 */   // Label 15243: @1026960
     /* 1026960 */   GIM_Try, /*On fail goto*//*Label 15244*/ GIMT_Encode4(1027037), // Rule ID 13302 //
     /* 1026965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1026976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1026979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1026982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1026985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027004 */     // MIs[0] policy
     /* 1027004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027036 */     // GIR_Coverage, 13302,
     /* 1027036 */     GIR_EraseRootFromParent_Done,
     /* 1027037 */   // Label 15244: @1027037
     /* 1027037 */   GIM_Try, /*On fail goto*//*Label 15245*/ GIMT_Encode4(1027114), // Rule ID 13303 //
     /* 1027042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1027053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1027056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1027059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1027062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027081 */     // MIs[0] policy
     /* 1027081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027113 */     // GIR_Coverage, 13303,
     /* 1027113 */     GIR_EraseRootFromParent_Done,
     /* 1027114 */   // Label 15245: @1027114
     /* 1027114 */   GIM_Try, /*On fail goto*//*Label 15246*/ GIMT_Encode4(1027191), // Rule ID 13306 //
     /* 1027119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1027136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027158 */     // MIs[0] policy
     /* 1027158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027190 */     // GIR_Coverage, 13306,
     /* 1027190 */     GIR_EraseRootFromParent_Done,
     /* 1027191 */   // Label 15246: @1027191
     /* 1027191 */   GIM_Try, /*On fail goto*//*Label 15247*/ GIMT_Encode4(1027268), // Rule ID 13307 //
     /* 1027196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1027207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1027210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1027213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1027216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027235 */     // MIs[0] policy
     /* 1027235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027245 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027267 */     // GIR_Coverage, 13307,
     /* 1027267 */     GIR_EraseRootFromParent_Done,
     /* 1027268 */   // Label 15247: @1027268
     /* 1027268 */   GIM_Try, /*On fail goto*//*Label 15248*/ GIMT_Encode4(1027345), // Rule ID 13310 //
     /* 1027273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1027290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027312 */     // MIs[0] policy
     /* 1027312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027322 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027344 */     // GIR_Coverage, 13310,
     /* 1027344 */     GIR_EraseRootFromParent_Done,
     /* 1027345 */   // Label 15248: @1027345
     /* 1027345 */   GIM_Try, /*On fail goto*//*Label 15249*/ GIMT_Encode4(1027422), // Rule ID 13311 //
     /* 1027350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1027361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1027364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1027367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1027370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027389 */     // MIs[0] policy
     /* 1027389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027399 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1027418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027421 */     // GIR_Coverage, 13311,
     /* 1027421 */     GIR_EraseRootFromParent_Done,
     /* 1027422 */   // Label 15249: @1027422
     /* 1027422 */   GIM_Try, /*On fail goto*//*Label 15250*/ GIMT_Encode4(1027499), // Rule ID 13314 //
     /* 1027427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1027444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027466 */     // MIs[0] policy
     /* 1027466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027498 */     // GIR_Coverage, 13314,
     /* 1027498 */     GIR_EraseRootFromParent_Done,
     /* 1027499 */   // Label 15250: @1027499
     /* 1027499 */   GIM_Try, /*On fail goto*//*Label 15251*/ GIMT_Encode4(1027576), // Rule ID 13315 //
     /* 1027504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1027521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027543 */     // MIs[0] policy
     /* 1027543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027575 */     // GIR_Coverage, 13315,
     /* 1027575 */     GIR_EraseRootFromParent_Done,
     /* 1027576 */   // Label 15251: @1027576
     /* 1027576 */   GIM_Try, /*On fail goto*//*Label 15252*/ GIMT_Encode4(1027653), // Rule ID 13318 //
     /* 1027581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1027592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1027595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1027598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1027601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027620 */     // MIs[0] policy
     /* 1027620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027630 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027652 */     // GIR_Coverage, 13318,
     /* 1027652 */     GIR_EraseRootFromParent_Done,
     /* 1027653 */   // Label 15252: @1027653
     /* 1027653 */   GIM_Try, /*On fail goto*//*Label 15253*/ GIMT_Encode4(1027730), // Rule ID 13319 //
     /* 1027658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1027669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1027672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1027675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1027678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027697 */     // MIs[0] policy
     /* 1027697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027707 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027729 */     // GIR_Coverage, 13319,
     /* 1027729 */     GIR_EraseRootFromParent_Done,
     /* 1027730 */   // Label 15253: @1027730
     /* 1027730 */   GIM_Try, /*On fail goto*//*Label 15254*/ GIMT_Encode4(1027807), // Rule ID 13322 //
     /* 1027735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1027752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1027755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027774 */     // MIs[0] policy
     /* 1027774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027784 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027806 */     // GIR_Coverage, 13322,
     /* 1027806 */     GIR_EraseRootFromParent_Done,
     /* 1027807 */   // Label 15254: @1027807
     /* 1027807 */   GIM_Try, /*On fail goto*//*Label 15255*/ GIMT_Encode4(1027884), // Rule ID 13323 //
     /* 1027812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1027829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1027832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027851 */     // MIs[0] policy
     /* 1027851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027861 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027883 */     // GIR_Coverage, 13323,
     /* 1027883 */     GIR_EraseRootFromParent_Done,
     /* 1027884 */   // Label 15255: @1027884
     /* 1027884 */   GIM_Try, /*On fail goto*//*Label 15256*/ GIMT_Encode4(1027961), // Rule ID 13326 //
     /* 1027889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1027892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1027900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1027903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1027906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1027909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027928 */     // MIs[0] policy
     /* 1027928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1027957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027960 */     // GIR_Coverage, 13326,
     /* 1027960 */     GIR_EraseRootFromParent_Done,
     /* 1027961 */   // Label 15256: @1027961
     /* 1027961 */   GIM_Try, /*On fail goto*//*Label 15257*/ GIMT_Encode4(1028038), // Rule ID 13327 //
     /* 1027966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1027969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1027977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1027980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1027983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1027986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1028005 */     // MIs[0] policy
     /* 1028005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1028018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028037 */     // GIR_Coverage, 13327,
     /* 1028037 */     GIR_EraseRootFromParent_Done,
     /* 1028038 */   // Label 15257: @1028038
     /* 1028038 */   GIM_Try, /*On fail goto*//*Label 15258*/ GIMT_Encode4(1028115), // Rule ID 13330 //
     /* 1028043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1028060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028082 */     // MIs[0] policy
     /* 1028082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028092 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028114 */     // GIR_Coverage, 13330,
     /* 1028114 */     GIR_EraseRootFromParent_Done,
     /* 1028115 */   // Label 15258: @1028115
     /* 1028115 */   GIM_Try, /*On fail goto*//*Label 15259*/ GIMT_Encode4(1028192), // Rule ID 13331 //
     /* 1028120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1028131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1028134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1028137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1028140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1028159 */     // MIs[0] policy
     /* 1028159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028169 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1028172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028191 */     // GIR_Coverage, 13331,
     /* 1028191 */     GIR_EraseRootFromParent_Done,
     /* 1028192 */   // Label 15259: @1028192
     /* 1028192 */   GIM_Try, /*On fail goto*//*Label 15260*/ GIMT_Encode4(1028269), // Rule ID 13334 //
     /* 1028197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1028200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1028214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028236 */     // MIs[0] policy
     /* 1028236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028268 */     // GIR_Coverage, 13334,
     /* 1028268 */     GIR_EraseRootFromParent_Done,
     /* 1028269 */   // Label 15260: @1028269
     /* 1028269 */   GIM_Try, /*On fail goto*//*Label 15261*/ GIMT_Encode4(1028346), // Rule ID 13335 //
     /* 1028274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1028277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1028285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1028288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1028291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1028294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1028313 */     // MIs[0] policy
     /* 1028313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028323 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1028326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1028342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028345 */     // GIR_Coverage, 13335,
     /* 1028345 */     GIR_EraseRootFromParent_Done,
     /* 1028346 */   // Label 15261: @1028346
     /* 1028346 */   GIM_Try, /*On fail goto*//*Label 15262*/ GIMT_Encode4(1028423), // Rule ID 13338 //
     /* 1028351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028390 */     // MIs[0] policy
     /* 1028390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028400 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1028403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028422 */     // GIR_Coverage, 13338,
     /* 1028422 */     GIR_EraseRootFromParent_Done,
     /* 1028423 */   // Label 15262: @1028423
     /* 1028423 */   GIM_Try, /*On fail goto*//*Label 15263*/ GIMT_Encode4(1028500), // Rule ID 13339 //
     /* 1028428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1028439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1028442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1028448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028467 */     // MIs[0] policy
     /* 1028467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028477 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1028480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028499 */     // GIR_Coverage, 13339,
     /* 1028499 */     GIR_EraseRootFromParent_Done,
     /* 1028500 */   // Label 15263: @1028500
     /* 1028500 */   GIM_Try, /*On fail goto*//*Label 15264*/ GIMT_Encode4(1028577), // Rule ID 13342 //
     /* 1028505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028544 */     // MIs[0] policy
     /* 1028544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028554 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028576 */     // GIR_Coverage, 13342,
     /* 1028576 */     GIR_EraseRootFromParent_Done,
     /* 1028577 */   // Label 15264: @1028577
     /* 1028577 */   GIM_Try, /*On fail goto*//*Label 15265*/ GIMT_Encode4(1028654), // Rule ID 13343 //
     /* 1028582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028621 */     // MIs[0] policy
     /* 1028621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028631 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028653 */     // GIR_Coverage, 13343,
     /* 1028653 */     GIR_EraseRootFromParent_Done,
     /* 1028654 */   // Label 15265: @1028654
     /* 1028654 */   GIM_Try, /*On fail goto*//*Label 15266*/ GIMT_Encode4(1028731), // Rule ID 13346 //
     /* 1028659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1028670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1028673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1028679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028698 */     // MIs[0] policy
     /* 1028698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028708 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028730 */     // GIR_Coverage, 13346,
     /* 1028730 */     GIR_EraseRootFromParent_Done,
     /* 1028731 */   // Label 15266: @1028731
     /* 1028731 */   GIM_Try, /*On fail goto*//*Label 15267*/ GIMT_Encode4(1028808), // Rule ID 13347 //
     /* 1028736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1028747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1028750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1028756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028775 */     // MIs[0] policy
     /* 1028775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028785 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028807 */     // GIR_Coverage, 13347,
     /* 1028807 */     GIR_EraseRootFromParent_Done,
     /* 1028808 */   // Label 15267: @1028808
     /* 1028808 */   GIM_Try, /*On fail goto*//*Label 15268*/ GIMT_Encode4(1028885), // Rule ID 13350 //
     /* 1028813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1028824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1028827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1028833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028852 */     // MIs[0] policy
     /* 1028852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028862 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1028881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028884 */     // GIR_Coverage, 13350,
     /* 1028884 */     GIR_EraseRootFromParent_Done,
     /* 1028885 */   // Label 15268: @1028885
     /* 1028885 */   GIM_Try, /*On fail goto*//*Label 15269*/ GIMT_Encode4(1028962), // Rule ID 13351 //
     /* 1028890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1028901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1028904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1028910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028929 */     // MIs[0] policy
     /* 1028929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028939 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1028958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028961 */     // GIR_Coverage, 13351,
     /* 1028961 */     GIR_EraseRootFromParent_Done,
     /* 1028962 */   // Label 15269: @1028962
     /* 1028962 */   GIM_Try, /*On fail goto*//*Label 15270*/ GIMT_Encode4(1029039), // Rule ID 13354 //
     /* 1028967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1028978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1028981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1028987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029006 */     // MIs[0] policy
     /* 1029006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029038 */     // GIR_Coverage, 13354,
     /* 1029038 */     GIR_EraseRootFromParent_Done,
     /* 1029039 */   // Label 15270: @1029039
     /* 1029039 */   GIM_Try, /*On fail goto*//*Label 15271*/ GIMT_Encode4(1029116), // Rule ID 13355 //
     /* 1029044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1029055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1029058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1029064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029083 */     // MIs[0] policy
     /* 1029083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029115 */     // GIR_Coverage, 13355,
     /* 1029115 */     GIR_EraseRootFromParent_Done,
     /* 1029116 */   // Label 15271: @1029116
     /* 1029116 */   GIM_Try, /*On fail goto*//*Label 15272*/ GIMT_Encode4(1029193), // Rule ID 13358 //
     /* 1029121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029160 */     // MIs[0] policy
     /* 1029160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029170 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029192 */     // GIR_Coverage, 13358,
     /* 1029192 */     GIR_EraseRootFromParent_Done,
     /* 1029193 */   // Label 15272: @1029193
     /* 1029193 */   GIM_Try, /*On fail goto*//*Label 15273*/ GIMT_Encode4(1029270), // Rule ID 13359 //
     /* 1029198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1029209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1029212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1029218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029237 */     // MIs[0] policy
     /* 1029237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029247 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1029250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029269 */     // GIR_Coverage, 13359,
     /* 1029269 */     GIR_EraseRootFromParent_Done,
     /* 1029270 */   // Label 15273: @1029270
     /* 1029270 */   GIM_Try, /*On fail goto*//*Label 15274*/ GIMT_Encode4(1029347), // Rule ID 13362 //
     /* 1029275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029314 */     // MIs[0] policy
     /* 1029314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029346 */     // GIR_Coverage, 13362,
     /* 1029346 */     GIR_EraseRootFromParent_Done,
     /* 1029347 */   // Label 15274: @1029347
     /* 1029347 */   GIM_Try, /*On fail goto*//*Label 15275*/ GIMT_Encode4(1029424), // Rule ID 13363 //
     /* 1029352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1029363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1029366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1029372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029391 */     // MIs[0] policy
     /* 1029391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029401 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11487:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029423 */     // GIR_Coverage, 13363,
     /* 1029423 */     GIR_EraseRootFromParent_Done,
     /* 1029424 */   // Label 15275: @1029424
     /* 1029424 */   GIM_Try, /*On fail goto*//*Label 15276*/ GIMT_Encode4(1029501), // Rule ID 13366 //
     /* 1029429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029468 */     // MIs[0] policy
     /* 1029468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029500 */     // GIR_Coverage, 13366,
     /* 1029500 */     GIR_EraseRootFromParent_Done,
     /* 1029501 */   // Label 15276: @1029501
     /* 1029501 */   GIM_Try, /*On fail goto*//*Label 15277*/ GIMT_Encode4(1029578), // Rule ID 13367 //
     /* 1029506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029545 */     // MIs[0] policy
     /* 1029545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029555 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11487:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029577 */     // GIR_Coverage, 13367,
     /* 1029577 */     GIR_EraseRootFromParent_Done,
     /* 1029578 */   // Label 15277: @1029578
     /* 1029578 */   GIM_Try, /*On fail goto*//*Label 15278*/ GIMT_Encode4(1029655), // Rule ID 13370 //
     /* 1029583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1029594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1029597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1029603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029622 */     // MIs[0] policy
     /* 1029622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029654 */     // GIR_Coverage, 13370,
     /* 1029654 */     GIR_EraseRootFromParent_Done,
     /* 1029655 */   // Label 15278: @1029655
     /* 1029655 */   GIM_Try, /*On fail goto*//*Label 15279*/ GIMT_Encode4(1029732), // Rule ID 13371 //
     /* 1029660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1029671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1029674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1029680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029699 */     // MIs[0] policy
     /* 1029699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029709 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029731 */     // GIR_Coverage, 13371,
     /* 1029731 */     GIR_EraseRootFromParent_Done,
     /* 1029732 */   // Label 15279: @1029732
     /* 1029732 */   GIM_Try, /*On fail goto*//*Label 15280*/ GIMT_Encode4(1029809), // Rule ID 13374 //
     /* 1029737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1029740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1029748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1029751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1029757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029776 */     // MIs[0] policy
     /* 1029776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1029805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029808 */     // GIR_Coverage, 13374,
     /* 1029808 */     GIR_EraseRootFromParent_Done,
     /* 1029809 */   // Label 15280: @1029809
     /* 1029809 */   GIM_Try, /*On fail goto*//*Label 15281*/ GIMT_Encode4(1029886), // Rule ID 13375 //
     /* 1029814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1029817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1029825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1029828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1029834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029853 */     // MIs[0] policy
     /* 1029853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029863 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1029882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029885 */     // GIR_Coverage, 13375,
     /* 1029885 */     GIR_EraseRootFromParent_Done,
     /* 1029886 */   // Label 15281: @1029886
     /* 1029886 */   GIM_Try, /*On fail goto*//*Label 15282*/ GIMT_Encode4(1029963), // Rule ID 13378 //
     /* 1029891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1029902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1029905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1029911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029930 */     // MIs[0] policy
     /* 1029930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029940 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1029943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029962 */     // GIR_Coverage, 13378,
     /* 1029962 */     GIR_EraseRootFromParent_Done,
     /* 1029963 */   // Label 15282: @1029963
     /* 1029963 */   GIM_Try, /*On fail goto*//*Label 15283*/ GIMT_Encode4(1030040), // Rule ID 13379 //
     /* 1029968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1029979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1029982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1029988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030007 */     // MIs[0] policy
     /* 1030007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030017 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030039 */     // GIR_Coverage, 13379,
     /* 1030039 */     GIR_EraseRootFromParent_Done,
     /* 1030040 */   // Label 15283: @1030040
     /* 1030040 */   GIM_Try, /*On fail goto*//*Label 15284*/ GIMT_Encode4(1030117), // Rule ID 13382 //
     /* 1030045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030084 */     // MIs[0] policy
     /* 1030084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030094 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030116 */     // GIR_Coverage, 13382,
     /* 1030116 */     GIR_EraseRootFromParent_Done,
     /* 1030117 */   // Label 15284: @1030117
     /* 1030117 */   GIM_Try, /*On fail goto*//*Label 15285*/ GIMT_Encode4(1030194), // Rule ID 13383 //
     /* 1030122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1030133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1030136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1030142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030161 */     // MIs[0] policy
     /* 1030161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030171 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030193 */     // GIR_Coverage, 13383,
     /* 1030193 */     GIR_EraseRootFromParent_Done,
     /* 1030194 */   // Label 15285: @1030194
     /* 1030194 */   GIM_Try, /*On fail goto*//*Label 15286*/ GIMT_Encode4(1030271), // Rule ID 13386 //
     /* 1030199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030238 */     // MIs[0] policy
     /* 1030238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030248 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030270 */     // GIR_Coverage, 13386,
     /* 1030270 */     GIR_EraseRootFromParent_Done,
     /* 1030271 */   // Label 15286: @1030271
     /* 1030271 */   GIM_Try, /*On fail goto*//*Label 15287*/ GIMT_Encode4(1030348), // Rule ID 13387 //
     /* 1030276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1030287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1030290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1030296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030315 */     // MIs[0] policy
     /* 1030315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030325 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1030344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030347 */     // GIR_Coverage, 13387,
     /* 1030347 */     GIR_EraseRootFromParent_Done,
     /* 1030348 */   // Label 15287: @1030348
     /* 1030348 */   GIM_Try, /*On fail goto*//*Label 15288*/ GIMT_Encode4(1030425), // Rule ID 13390 //
     /* 1030353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030392 */     // MIs[0] policy
     /* 1030392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030424 */     // GIR_Coverage, 13390,
     /* 1030424 */     GIR_EraseRootFromParent_Done,
     /* 1030425 */   // Label 15288: @1030425
     /* 1030425 */   GIM_Try, /*On fail goto*//*Label 15289*/ GIMT_Encode4(1030502), // Rule ID 13391 //
     /* 1030430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1030441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1030444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1030450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030469 */     // MIs[0] policy
     /* 1030469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030501 */     // GIR_Coverage, 13391,
     /* 1030501 */     GIR_EraseRootFromParent_Done,
     /* 1030502 */   // Label 15289: @1030502
     /* 1030502 */   GIM_Try, /*On fail goto*//*Label 15290*/ GIMT_Encode4(1030579), // Rule ID 13394 //
     /* 1030507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1030527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030546 */     // MIs[0] policy
     /* 1030546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030578 */     // GIR_Coverage, 13394,
     /* 1030578 */     GIR_EraseRootFromParent_Done,
     /* 1030579 */   // Label 15290: @1030579
     /* 1030579 */   GIM_Try, /*On fail goto*//*Label 15291*/ GIMT_Encode4(1030656), // Rule ID 13395 //
     /* 1030584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1030604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030623 */     // MIs[0] policy
     /* 1030623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030633 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030655 */     // GIR_Coverage, 13395,
     /* 1030655 */     GIR_EraseRootFromParent_Done,
     /* 1030656 */   // Label 15291: @1030656
     /* 1030656 */   GIM_Try, /*On fail goto*//*Label 15292*/ GIMT_Encode4(1030733), // Rule ID 13398 //
     /* 1030661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1030672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1030675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1030681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030700 */     // MIs[0] policy
     /* 1030700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030710 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030732 */     // GIR_Coverage, 13398,
     /* 1030732 */     GIR_EraseRootFromParent_Done,
     /* 1030733 */   // Label 15292: @1030733
     /* 1030733 */   GIM_Try, /*On fail goto*//*Label 15293*/ GIMT_Encode4(1030810), // Rule ID 13399 //
     /* 1030738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1030749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1030752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1030758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030777 */     // MIs[0] policy
     /* 1030777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030787 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030809 */     // GIR_Coverage, 13399,
     /* 1030809 */     GIR_EraseRootFromParent_Done,
     /* 1030810 */   // Label 15293: @1030810
     /* 1030810 */   GIM_Try, /*On fail goto*//*Label 15294*/ GIMT_Encode4(1030887), // Rule ID 13402 //
     /* 1030815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1030826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1030829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1030835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030854 */     // MIs[0] policy
     /* 1030854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030886 */     // GIR_Coverage, 13402,
     /* 1030886 */     GIR_EraseRootFromParent_Done,
     /* 1030887 */   // Label 15294: @1030887
     /* 1030887 */   GIM_Try, /*On fail goto*//*Label 15295*/ GIMT_Encode4(1030964), // Rule ID 13403 //
     /* 1030892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1030903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1030906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1030912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030931 */     // MIs[0] policy
     /* 1030931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030963 */     // GIR_Coverage, 13403,
     /* 1030963 */     GIR_EraseRootFromParent_Done,
     /* 1030964 */   // Label 15295: @1030964
     /* 1030964 */   GIM_Try, /*On fail goto*//*Label 15296*/ GIMT_Encode4(1031041), // Rule ID 13406 //
     /* 1030969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1030980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1030983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1030989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031008 */     // MIs[0] policy
     /* 1031008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031040 */     // GIR_Coverage, 13406,
     /* 1031040 */     GIR_EraseRootFromParent_Done,
     /* 1031041 */   // Label 15296: @1031041
     /* 1031041 */   GIM_Try, /*On fail goto*//*Label 15297*/ GIMT_Encode4(1031118), // Rule ID 13407 //
     /* 1031046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1031057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1031060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1031066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031085 */     // MIs[0] policy
     /* 1031085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031095 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031117 */     // GIR_Coverage, 13407,
     /* 1031117 */     GIR_EraseRootFromParent_Done,
     /* 1031118 */   // Label 15297: @1031118
     /* 1031118 */   GIM_Try, /*On fail goto*//*Label 15298*/ GIMT_Encode4(1031195), // Rule ID 13410 //
     /* 1031123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031162 */     // MIs[0] policy
     /* 1031162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031194 */     // GIR_Coverage, 13410,
     /* 1031194 */     GIR_EraseRootFromParent_Done,
     /* 1031195 */   // Label 15298: @1031195
     /* 1031195 */   GIM_Try, /*On fail goto*//*Label 15299*/ GIMT_Encode4(1031272), // Rule ID 13411 //
     /* 1031200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1031211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1031214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1031220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031239 */     // MIs[0] policy
     /* 1031239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1031268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031271 */     // GIR_Coverage, 13411,
     /* 1031271 */     GIR_EraseRootFromParent_Done,
     /* 1031272 */   // Label 15299: @1031272
     /* 1031272 */   GIM_Try, /*On fail goto*//*Label 15300*/ GIMT_Encode4(1031349), // Rule ID 13414 //
     /* 1031277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031316 */     // MIs[0] policy
     /* 1031316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031348 */     // GIR_Coverage, 13414,
     /* 1031348 */     GIR_EraseRootFromParent_Done,
     /* 1031349 */   // Label 15300: @1031349
     /* 1031349 */   GIM_Try, /*On fail goto*//*Label 15301*/ GIMT_Encode4(1031426), // Rule ID 13415 //
     /* 1031354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1031365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1031368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1031374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031393 */     // MIs[0] policy
     /* 1031393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1031406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031425 */     // GIR_Coverage, 13415,
     /* 1031425 */     GIR_EraseRootFromParent_Done,
     /* 1031426 */   // Label 15301: @1031426
     /* 1031426 */   GIM_Try, /*On fail goto*//*Label 15302*/ GIMT_Encode4(1031503), // Rule ID 13418 //
     /* 1031431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031470 */     // MIs[0] policy
     /* 1031470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031480 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031502 */     // GIR_Coverage, 13418,
     /* 1031502 */     GIR_EraseRootFromParent_Done,
     /* 1031503 */   // Label 15302: @1031503
     /* 1031503 */   GIM_Try, /*On fail goto*//*Label 15303*/ GIMT_Encode4(1031580), // Rule ID 13419 //
     /* 1031508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031547 */     // MIs[0] policy
     /* 1031547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031557 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031579 */     // GIR_Coverage, 13419,
     /* 1031579 */     GIR_EraseRootFromParent_Done,
     /* 1031580 */   // Label 15303: @1031580
     /* 1031580 */   GIM_Try, /*On fail goto*//*Label 15304*/ GIMT_Encode4(1031657), // Rule ID 13422 //
     /* 1031585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1031596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1031599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1031605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031624 */     // MIs[0] policy
     /* 1031624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031656 */     // GIR_Coverage, 13422,
     /* 1031656 */     GIR_EraseRootFromParent_Done,
     /* 1031657 */   // Label 15304: @1031657
     /* 1031657 */   GIM_Try, /*On fail goto*//*Label 15305*/ GIMT_Encode4(1031734), // Rule ID 13423 //
     /* 1031662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1031673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1031676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1031682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031701 */     // MIs[0] policy
     /* 1031701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031733 */     // GIR_Coverage, 13423,
     /* 1031733 */     GIR_EraseRootFromParent_Done,
     /* 1031734 */   // Label 15305: @1031734
     /* 1031734 */   GIM_Try, /*On fail goto*//*Label 15306*/ GIMT_Encode4(1031811), // Rule ID 13426 //
     /* 1031739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1031750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1031753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1031756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1031759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031778 */     // MIs[0] policy
     /* 1031778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031788 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1031791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031810 */     // GIR_Coverage, 13426,
     /* 1031810 */     GIR_EraseRootFromParent_Done,
     /* 1031811 */   // Label 15306: @1031811
     /* 1031811 */   GIM_Try, /*On fail goto*//*Label 15307*/ GIMT_Encode4(1031888), // Rule ID 13427 //
     /* 1031816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1031827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1031830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1031833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1031836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031855 */     // MIs[0] policy
     /* 1031855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031865 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1031868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031887 */     // GIR_Coverage, 13427,
     /* 1031887 */     GIR_EraseRootFromParent_Done,
     /* 1031888 */   // Label 15307: @1031888
     /* 1031888 */   GIM_Try, /*On fail goto*//*Label 15308*/ GIMT_Encode4(1031965), // Rule ID 13430 //
     /* 1031893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1031904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1031907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1031910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1031913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031932 */     // MIs[0] policy
     /* 1031932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031942 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1031945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031964 */     // GIR_Coverage, 13430,
     /* 1031964 */     GIR_EraseRootFromParent_Done,
     /* 1031965 */   // Label 15308: @1031965
     /* 1031965 */   GIM_Try, /*On fail goto*//*Label 15309*/ GIMT_Encode4(1032042), // Rule ID 13431 //
     /* 1031970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1031981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1031984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1031987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1031990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032009 */     // MIs[0] policy
     /* 1032009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032019 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032041 */     // GIR_Coverage, 13431,
     /* 1032041 */     GIR_EraseRootFromParent_Done,
     /* 1032042 */   // Label 15309: @1032042
     /* 1032042 */   GIM_Try, /*On fail goto*//*Label 15310*/ GIMT_Encode4(1032119), // Rule ID 13434 //
     /* 1032047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1032058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1032061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1032064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032086 */     // MIs[0] policy
     /* 1032086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032118 */     // GIR_Coverage, 13434,
     /* 1032118 */     GIR_EraseRootFromParent_Done,
     /* 1032119 */   // Label 15310: @1032119
     /* 1032119 */   GIM_Try, /*On fail goto*//*Label 15311*/ GIMT_Encode4(1032196), // Rule ID 13435 //
     /* 1032124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1032135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1032138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1032141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1032144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032163 */     // MIs[0] policy
     /* 1032163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032173 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032195 */     // GIR_Coverage, 13435,
     /* 1032195 */     GIR_EraseRootFromParent_Done,
     /* 1032196 */   // Label 15311: @1032196
     /* 1032196 */   GIM_Try, /*On fail goto*//*Label 15312*/ GIMT_Encode4(1032273), // Rule ID 13438 //
     /* 1032201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1032218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1032221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032240 */     // MIs[0] policy
     /* 1032240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032272 */     // GIR_Coverage, 13438,
     /* 1032272 */     GIR_EraseRootFromParent_Done,
     /* 1032273 */   // Label 15312: @1032273
     /* 1032273 */   GIM_Try, /*On fail goto*//*Label 15313*/ GIMT_Encode4(1032350), // Rule ID 13439 //
     /* 1032278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1032289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1032292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1032295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1032298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032317 */     // MIs[0] policy
     /* 1032317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032349 */     // GIR_Coverage, 13439,
     /* 1032349 */     GIR_EraseRootFromParent_Done,
     /* 1032350 */   // Label 15313: @1032350
     /* 1032350 */   GIM_Try, /*On fail goto*//*Label 15314*/ GIMT_Encode4(1032427), // Rule ID 13442 //
     /* 1032355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1032372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1032375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032394 */     // MIs[0] policy
     /* 1032394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032426 */     // GIR_Coverage, 13442,
     /* 1032426 */     GIR_EraseRootFromParent_Done,
     /* 1032427 */   // Label 15314: @1032427
     /* 1032427 */   GIM_Try, /*On fail goto*//*Label 15315*/ GIMT_Encode4(1032504), // Rule ID 13443 //
     /* 1032432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1032443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1032446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1032449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1032452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032471 */     // MIs[0] policy
     /* 1032471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032481 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032503 */     // GIR_Coverage, 13443,
     /* 1032503 */     GIR_EraseRootFromParent_Done,
     /* 1032504 */   // Label 15315: @1032504
     /* 1032504 */   GIM_Try, /*On fail goto*//*Label 15316*/ GIMT_Encode4(1032581), // Rule ID 13446 //
     /* 1032509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1032526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1032529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032548 */     // MIs[0] policy
     /* 1032548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1032561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032580 */     // GIR_Coverage, 13446,
     /* 1032580 */     GIR_EraseRootFromParent_Done,
     /* 1032581 */   // Label 15316: @1032581
     /* 1032581 */   GIM_Try, /*On fail goto*//*Label 15317*/ GIMT_Encode4(1032658), // Rule ID 13447 //
     /* 1032586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1032603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1032606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032625 */     // MIs[0] policy
     /* 1032625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032635 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1032638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032657 */     // GIR_Coverage, 13447,
     /* 1032657 */     GIR_EraseRootFromParent_Done,
     /* 1032658 */   // Label 15317: @1032658
     /* 1032658 */   GIM_Try, /*On fail goto*//*Label 15318*/ GIMT_Encode4(1032735), // Rule ID 13450 //
     /* 1032663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1032674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1032677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1032680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032702 */     // MIs[0] policy
     /* 1032702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032712 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032734 */     // GIR_Coverage, 13450,
     /* 1032734 */     GIR_EraseRootFromParent_Done,
     /* 1032735 */   // Label 15318: @1032735
     /* 1032735 */   GIM_Try, /*On fail goto*//*Label 15319*/ GIMT_Encode4(1032812), // Rule ID 13451 //
     /* 1032740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1032751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1032754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1032757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032779 */     // MIs[0] policy
     /* 1032779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032789 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032811 */     // GIR_Coverage, 13451,
     /* 1032811 */     GIR_EraseRootFromParent_Done,
     /* 1032812 */   // Label 15319: @1032812
     /* 1032812 */   GIM_Try, /*On fail goto*//*Label 15320*/ GIMT_Encode4(1032889), // Rule ID 13454 //
     /* 1032817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1032828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1032831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1032834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032856 */     // MIs[0] policy
     /* 1032856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032888 */     // GIR_Coverage, 13454,
     /* 1032888 */     GIR_EraseRootFromParent_Done,
     /* 1032889 */   // Label 15320: @1032889
     /* 1032889 */   GIM_Try, /*On fail goto*//*Label 15321*/ GIMT_Encode4(1032966), // Rule ID 13455 //
     /* 1032894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1032905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1032908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1032911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032933 */     // MIs[0] policy
     /* 1032933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032943 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032965 */     // GIR_Coverage, 13455,
     /* 1032965 */     GIR_EraseRootFromParent_Done,
     /* 1032966 */   // Label 15321: @1032966
     /* 1032966 */   GIM_Try, /*On fail goto*//*Label 15322*/ GIMT_Encode4(1033043), // Rule ID 13458 //
     /* 1032971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1032982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1032985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1032988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1032991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033010 */     // MIs[0] policy
     /* 1033010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033042 */     // GIR_Coverage, 13458,
     /* 1033042 */     GIR_EraseRootFromParent_Done,
     /* 1033043 */   // Label 15322: @1033043
     /* 1033043 */   GIM_Try, /*On fail goto*//*Label 15323*/ GIMT_Encode4(1033120), // Rule ID 13459 //
     /* 1033048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1033059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1033062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1033065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1033068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033087 */     // MIs[0] policy
     /* 1033087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033097 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033119 */     // GIR_Coverage, 13459,
     /* 1033119 */     GIR_EraseRootFromParent_Done,
     /* 1033120 */   // Label 15323: @1033120
     /* 1033120 */   GIM_Try, /*On fail goto*//*Label 15324*/ GIMT_Encode4(1033197), // Rule ID 13462 //
     /* 1033125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1033136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1033139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1033142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1033145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033164 */     // MIs[0] policy
     /* 1033164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033196 */     // GIR_Coverage, 13462,
     /* 1033196 */     GIR_EraseRootFromParent_Done,
     /* 1033197 */   // Label 15324: @1033197
     /* 1033197 */   GIM_Try, /*On fail goto*//*Label 15325*/ GIMT_Encode4(1033274), // Rule ID 13463 //
     /* 1033202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1033213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1033216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1033219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1033222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033241 */     // MIs[0] policy
     /* 1033241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033251 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033273 */     // GIR_Coverage, 13463,
     /* 1033273 */     GIR_EraseRootFromParent_Done,
     /* 1033274 */   // Label 15325: @1033274
     /* 1033274 */   GIM_Try, /*On fail goto*//*Label 15326*/ GIMT_Encode4(1033351), // Rule ID 13466 //
     /* 1033279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1033290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1033293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1033296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1033299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033318 */     // MIs[0] policy
     /* 1033318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033328 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033350 */     // GIR_Coverage, 13466,
     /* 1033350 */     GIR_EraseRootFromParent_Done,
     /* 1033351 */   // Label 15326: @1033351
     /* 1033351 */   GIM_Try, /*On fail goto*//*Label 15327*/ GIMT_Encode4(1033428), // Rule ID 13467 //
     /* 1033356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1033367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1033370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1033373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1033376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033395 */     // MIs[0] policy
     /* 1033395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033405 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1033424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033427 */     // GIR_Coverage, 13467,
     /* 1033427 */     GIR_EraseRootFromParent_Done,
     /* 1033428 */   // Label 15327: @1033428
     /* 1033428 */   GIM_Try, /*On fail goto*//*Label 15328*/ GIMT_Encode4(1033505), // Rule ID 13470 //
     /* 1033433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1033450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033472 */     // MIs[0] policy
     /* 1033472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033504 */     // GIR_Coverage, 13470,
     /* 1033504 */     GIR_EraseRootFromParent_Done,
     /* 1033505 */   // Label 15328: @1033505
     /* 1033505 */   GIM_Try, /*On fail goto*//*Label 15329*/ GIMT_Encode4(1033582), // Rule ID 13471 //
     /* 1033510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1033527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033549 */     // MIs[0] policy
     /* 1033549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033559 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033581 */     // GIR_Coverage, 13471,
     /* 1033581 */     GIR_EraseRootFromParent_Done,
     /* 1033582 */   // Label 15329: @1033582
     /* 1033582 */   GIM_Try, /*On fail goto*//*Label 15330*/ GIMT_Encode4(1033659), // Rule ID 13474 //
     /* 1033587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1033598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1033601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1033604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033626 */     // MIs[0] policy
     /* 1033626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033658 */     // GIR_Coverage, 13474,
     /* 1033658 */     GIR_EraseRootFromParent_Done,
     /* 1033659 */   // Label 15330: @1033659
     /* 1033659 */   GIM_Try, /*On fail goto*//*Label 15331*/ GIMT_Encode4(1033736), // Rule ID 13475 //
     /* 1033664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1033675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1033678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1033681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033703 */     // MIs[0] policy
     /* 1033703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033735 */     // GIR_Coverage, 13475,
     /* 1033735 */     GIR_EraseRootFromParent_Done,
     /* 1033736 */   // Label 15331: @1033736
     /* 1033736 */   GIM_Try, /*On fail goto*//*Label 15332*/ GIMT_Encode4(1033813), // Rule ID 13478 //
     /* 1033741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1033752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1033755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1033758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1033761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033780 */     // MIs[0] policy
     /* 1033780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033790 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033812 */     // GIR_Coverage, 13478,
     /* 1033812 */     GIR_EraseRootFromParent_Done,
     /* 1033813 */   // Label 15332: @1033813
     /* 1033813 */   GIM_Try, /*On fail goto*//*Label 15333*/ GIMT_Encode4(1033890), // Rule ID 13479 //
     /* 1033818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1033829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1033832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1033835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1033838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033857 */     // MIs[0] policy
     /* 1033857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033889 */     // GIR_Coverage, 13479,
     /* 1033889 */     GIR_EraseRootFromParent_Done,
     /* 1033890 */   // Label 15333: @1033890
     /* 1033890 */   GIM_Try, /*On fail goto*//*Label 15334*/ GIMT_Encode4(1033967), // Rule ID 13482 //
     /* 1033895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1033906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1033909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1033912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1033915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033934 */     // MIs[0] policy
     /* 1033934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033944 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033966 */     // GIR_Coverage, 13482,
     /* 1033966 */     GIR_EraseRootFromParent_Done,
     /* 1033967 */   // Label 15334: @1033967
     /* 1033967 */   GIM_Try, /*On fail goto*//*Label 15335*/ GIMT_Encode4(1034044), // Rule ID 13483 //
     /* 1033972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1033983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1033986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1033989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1033992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034011 */     // MIs[0] policy
     /* 1034011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1034024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1034040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034043 */     // GIR_Coverage, 13483,
     /* 1034043 */     GIR_EraseRootFromParent_Done,
     /* 1034044 */   // Label 15335: @1034044
     /* 1034044 */   GIM_Try, /*On fail goto*//*Label 15336*/ GIMT_Encode4(1034121), // Rule ID 13486 //
     /* 1034049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1034069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034088 */     // MIs[0] policy
     /* 1034088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034098 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1034101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034120 */     // GIR_Coverage, 13486,
     /* 1034120 */     GIR_EraseRootFromParent_Done,
     /* 1034121 */   // Label 15336: @1034121
     /* 1034121 */   GIM_Try, /*On fail goto*//*Label 15337*/ GIMT_Encode4(1034198), // Rule ID 13487 //
     /* 1034126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1034137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1034140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1034146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034165 */     // MIs[0] policy
     /* 1034165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034175 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1034178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034197 */     // GIR_Coverage, 13487,
     /* 1034197 */     GIR_EraseRootFromParent_Done,
     /* 1034198 */   // Label 15337: @1034198
     /* 1034198 */   GIM_Try, /*On fail goto*//*Label 15338*/ GIMT_Encode4(1034275), // Rule ID 13490 //
     /* 1034203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1034223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034242 */     // MIs[0] policy
     /* 1034242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034274 */     // GIR_Coverage, 13490,
     /* 1034274 */     GIR_EraseRootFromParent_Done,
     /* 1034275 */   // Label 15338: @1034275
     /* 1034275 */   GIM_Try, /*On fail goto*//*Label 15339*/ GIMT_Encode4(1034352), // Rule ID 13491 //
     /* 1034280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1034291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1034294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1034300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034319 */     // MIs[0] policy
     /* 1034319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034329 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034351 */     // GIR_Coverage, 13491,
     /* 1034351 */     GIR_EraseRootFromParent_Done,
     /* 1034352 */   // Label 15339: @1034352
     /* 1034352 */   GIM_Try, /*On fail goto*//*Label 15340*/ GIMT_Encode4(1034429), // Rule ID 13494 //
     /* 1034357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1034377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034396 */     // MIs[0] policy
     /* 1034396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034428 */     // GIR_Coverage, 13494,
     /* 1034428 */     GIR_EraseRootFromParent_Done,
     /* 1034429 */   // Label 15340: @1034429
     /* 1034429 */   GIM_Try, /*On fail goto*//*Label 15341*/ GIMT_Encode4(1034506), // Rule ID 13495 //
     /* 1034434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1034445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1034448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1034454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034473 */     // MIs[0] policy
     /* 1034473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034483 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11651:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034505 */     // GIR_Coverage, 13495,
     /* 1034505 */     GIR_EraseRootFromParent_Done,
     /* 1034506 */   // Label 15341: @1034506
     /* 1034506 */   GIM_Try, /*On fail goto*//*Label 15342*/ GIMT_Encode4(1034583), // Rule ID 13498 //
     /* 1034511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1034531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034550 */     // MIs[0] policy
     /* 1034550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1034563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034582 */     // GIR_Coverage, 13498,
     /* 1034582 */     GIR_EraseRootFromParent_Done,
     /* 1034583 */   // Label 15342: @1034583
     /* 1034583 */   GIM_Try, /*On fail goto*//*Label 15343*/ GIMT_Encode4(1034660), // Rule ID 13499 //
     /* 1034588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1034608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034627 */     // MIs[0] policy
     /* 1034627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034637 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1034640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034659 */     // GIR_Coverage, 13499,
     /* 1034659 */     GIR_EraseRootFromParent_Done,
     /* 1034660 */   // Label 15343: @1034660
     /* 1034660 */   GIM_Try, /*On fail goto*//*Label 15344*/ GIMT_Encode4(1034737), // Rule ID 13502 //
     /* 1034665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1034685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034704 */     // MIs[0] policy
     /* 1034704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034714 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1034717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034736 */     // GIR_Coverage, 13502,
     /* 1034736 */     GIR_EraseRootFromParent_Done,
     /* 1034737 */   // Label 15344: @1034737
     /* 1034737 */   GIM_Try, /*On fail goto*//*Label 15345*/ GIMT_Encode4(1034814), // Rule ID 13503 //
     /* 1034742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1034762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034781 */     // MIs[0] policy
     /* 1034781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034791 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1034794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034813 */     // GIR_Coverage, 13503,
     /* 1034813 */     GIR_EraseRootFromParent_Done,
     /* 1034814 */   // Label 15345: @1034814
     /* 1034814 */   GIM_Try, /*On fail goto*//*Label 15346*/ GIMT_Encode4(1034891), // Rule ID 13506 //
     /* 1034819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1034839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034858 */     // MIs[0] policy
     /* 1034858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1034871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034890 */     // GIR_Coverage, 13506,
     /* 1034890 */     GIR_EraseRootFromParent_Done,
     /* 1034891 */   // Label 15346: @1034891
     /* 1034891 */   GIM_Try, /*On fail goto*//*Label 15347*/ GIMT_Encode4(1034968), // Rule ID 13507 //
     /* 1034896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1034916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034935 */     // MIs[0] policy
     /* 1034935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034945 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1034948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034967 */     // GIR_Coverage, 13507,
     /* 1034967 */     GIR_EraseRootFromParent_Done,
     /* 1034968 */   // Label 15347: @1034968
     /* 1034968 */   GIM_Try, /*On fail goto*//*Label 15348*/ GIMT_Encode4(1035045), // Rule ID 13510 //
     /* 1034973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1034984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1034987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1034993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035012 */     // MIs[0] policy
     /* 1035012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035022 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1035025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035044 */     // GIR_Coverage, 13510,
     /* 1035044 */     GIR_EraseRootFromParent_Done,
     /* 1035045 */   // Label 15348: @1035045
     /* 1035045 */   GIM_Try, /*On fail goto*//*Label 15349*/ GIMT_Encode4(1035122), // Rule ID 13511 //
     /* 1035050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1035061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1035064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1035070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035089 */     // MIs[0] policy
     /* 1035089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035099 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1035102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035121 */     // GIR_Coverage, 13511,
     /* 1035121 */     GIR_EraseRootFromParent_Done,
     /* 1035122 */   // Label 15349: @1035122
     /* 1035122 */   GIM_Try, /*On fail goto*//*Label 15350*/ GIMT_Encode4(1035199), // Rule ID 13514 //
     /* 1035127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1035138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1035141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1035147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035166 */     // MIs[0] policy
     /* 1035166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035198 */     // GIR_Coverage, 13514,
     /* 1035198 */     GIR_EraseRootFromParent_Done,
     /* 1035199 */   // Label 15350: @1035199
     /* 1035199 */   GIM_Try, /*On fail goto*//*Label 15351*/ GIMT_Encode4(1035276), // Rule ID 13515 //
     /* 1035204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1035215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1035218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1035224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035243 */     // MIs[0] policy
     /* 1035243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035253 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11651:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035275 */     // GIR_Coverage, 13515,
     /* 1035275 */     GIR_EraseRootFromParent_Done,
     /* 1035276 */   // Label 15351: @1035276
     /* 1035276 */   GIM_Try, /*On fail goto*//*Label 15352*/ GIMT_Encode4(1035353), // Rule ID 13518 //
     /* 1035281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1035292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1035295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1035301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035320 */     // MIs[0] policy
     /* 1035320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035352 */     // GIR_Coverage, 13518,
     /* 1035352 */     GIR_EraseRootFromParent_Done,
     /* 1035353 */   // Label 15352: @1035353
     /* 1035353 */   GIM_Try, /*On fail goto*//*Label 15353*/ GIMT_Encode4(1035430), // Rule ID 13519 //
     /* 1035358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1035369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1035372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1035378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035397 */     // MIs[0] policy
     /* 1035397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035429 */     // GIR_Coverage, 13519,
     /* 1035429 */     GIR_EraseRootFromParent_Done,
     /* 1035430 */   // Label 15353: @1035430
     /* 1035430 */   GIM_Try, /*On fail goto*//*Label 15354*/ GIMT_Encode4(1035507), // Rule ID 13522 //
     /* 1035435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1035446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1035449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1035455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035474 */     // MIs[0] policy
     /* 1035474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035506 */     // GIR_Coverage, 13522,
     /* 1035506 */     GIR_EraseRootFromParent_Done,
     /* 1035507 */   // Label 15354: @1035507
     /* 1035507 */   GIM_Try, /*On fail goto*//*Label 15355*/ GIMT_Encode4(1035584), // Rule ID 13523 //
     /* 1035512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1035523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1035526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1035532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035551 */     // MIs[0] policy
     /* 1035551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035561 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035583 */     // GIR_Coverage, 13523,
     /* 1035583 */     GIR_EraseRootFromParent_Done,
     /* 1035584 */   // Label 15355: @1035584
     /* 1035584 */   GIM_Try, /*On fail goto*//*Label 15356*/ GIMT_Encode4(1035661), // Rule ID 13526 //
     /* 1035589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1035600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1035603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1035609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035628 */     // MIs[0] policy
     /* 1035628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035660 */     // GIR_Coverage, 13526,
     /* 1035660 */     GIR_EraseRootFromParent_Done,
     /* 1035661 */   // Label 15356: @1035661
     /* 1035661 */   GIM_Try, /*On fail goto*//*Label 15357*/ GIMT_Encode4(1035738), // Rule ID 13527 //
     /* 1035666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1035677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1035680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1035686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035705 */     // MIs[0] policy
     /* 1035705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035715 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035737 */     // GIR_Coverage, 13527,
     /* 1035737 */     GIR_EraseRootFromParent_Done,
     /* 1035738 */   // Label 15357: @1035738
     /* 1035738 */   GIM_Try, /*On fail goto*//*Label 15358*/ GIMT_Encode4(1035815), // Rule ID 13530 //
     /* 1035743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1035746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1035754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1035757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1035763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035782 */     // MIs[0] policy
     /* 1035782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035814 */     // GIR_Coverage, 13530,
     /* 1035814 */     GIR_EraseRootFromParent_Done,
     /* 1035815 */   // Label 15358: @1035815
     /* 1035815 */   GIM_Try, /*On fail goto*//*Label 15359*/ GIMT_Encode4(1035892), // Rule ID 13531 //
     /* 1035820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1035823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1035831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1035834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1035840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035859 */     // MIs[0] policy
     /* 1035859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11651:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035891 */     // GIR_Coverage, 13531,
     /* 1035891 */     GIR_EraseRootFromParent_Done,
     /* 1035892 */   // Label 15359: @1035892
     /* 1035892 */   GIM_Try, /*On fail goto*//*Label 15360*/ GIMT_Encode4(1035969), // Rule ID 13534 //
     /* 1035897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1035900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1035911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1035917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035936 */     // MIs[0] policy
     /* 1035936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035968 */     // GIR_Coverage, 13534,
     /* 1035968 */     GIR_EraseRootFromParent_Done,
     /* 1035969 */   // Label 15360: @1035969
     /* 1035969 */   GIM_Try, /*On fail goto*//*Label 15361*/ GIMT_Encode4(1036046), // Rule ID 13535 //
     /* 1035974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1035977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1035988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1035994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036013 */     // MIs[0] policy
     /* 1036013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036023 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11651:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1036026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036045 */     // GIR_Coverage, 13535,
     /* 1036045 */     GIR_EraseRootFromParent_Done,
     /* 1036046 */   // Label 15361: @1036046
     /* 1036046 */   GIM_Try, /*On fail goto*//*Label 15362*/ GIMT_Encode4(1036123), // Rule ID 13538 //
     /* 1036051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1036071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036090 */     // MIs[0] policy
     /* 1036090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036100 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036122 */     // GIR_Coverage, 13538,
     /* 1036122 */     GIR_EraseRootFromParent_Done,
     /* 1036123 */   // Label 15362: @1036123
     /* 1036123 */   GIM_Try, /*On fail goto*//*Label 15363*/ GIMT_Encode4(1036200), // Rule ID 13539 //
     /* 1036128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1036139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1036142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1036148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036167 */     // MIs[0] policy
     /* 1036167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036177 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11651:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1036180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036199 */     // GIR_Coverage, 13539,
     /* 1036199 */     GIR_EraseRootFromParent_Done,
     /* 1036200 */   // Label 15363: @1036200
     /* 1036200 */   GIM_Try, /*On fail goto*//*Label 15364*/ GIMT_Encode4(1036277), // Rule ID 13542 //
     /* 1036205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1036208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1036216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1036219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1036222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1036225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036244 */     // MIs[0] policy
     /* 1036244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036254 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036276 */     // GIR_Coverage, 13542,
     /* 1036276 */     GIR_EraseRootFromParent_Done,
     /* 1036277 */   // Label 15364: @1036277
     /* 1036277 */   GIM_Try, /*On fail goto*//*Label 15365*/ GIMT_Encode4(1036354), // Rule ID 13543 //
     /* 1036282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1036285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1036290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1036293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1036296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1036299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1036302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1036317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036321 */     // MIs[0] policy
     /* 1036321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036331 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11651:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1036334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1036350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036353 */     // GIR_Coverage, 13543,
     /* 1036353 */     GIR_EraseRootFromParent_Done,
     /* 1036354 */   // Label 15365: @1036354
     /* 1036354 */   GIM_Try, /*On fail goto*//*Label 15366*/ GIMT_Encode4(1036431), // Rule ID 13546 //
     /* 1036359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1036370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1036373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1036376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1036379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036398 */     // MIs[0] policy
     /* 1036398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036408 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1036411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036430 */     // GIR_Coverage, 13546,
     /* 1036430 */     GIR_EraseRootFromParent_Done,
     /* 1036431 */   // Label 15366: @1036431
     /* 1036431 */   GIM_Try, /*On fail goto*//*Label 15367*/ GIMT_Encode4(1036508), // Rule ID 13547 //
     /* 1036436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1036447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1036450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1036453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1036456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036475 */     // MIs[0] policy
     /* 1036475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036485 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1036488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036507 */     // GIR_Coverage, 13547,
     /* 1036507 */     GIR_EraseRootFromParent_Done,
     /* 1036508 */   // Label 15367: @1036508
     /* 1036508 */   GIM_Try, /*On fail goto*//*Label 15368*/ GIMT_Encode4(1036585), // Rule ID 13550 //
     /* 1036513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1036524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1036527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1036530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1036533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036552 */     // MIs[0] policy
     /* 1036552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036562 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1036565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036584 */     // GIR_Coverage, 13550,
     /* 1036584 */     GIR_EraseRootFromParent_Done,
     /* 1036585 */   // Label 15368: @1036585
     /* 1036585 */   GIM_Try, /*On fail goto*//*Label 15369*/ GIMT_Encode4(1036662), // Rule ID 13551 //
     /* 1036590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1036601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1036604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1036607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1036610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036629 */     // MIs[0] policy
     /* 1036629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036639 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1036642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036661 */     // GIR_Coverage, 13551,
     /* 1036661 */     GIR_EraseRootFromParent_Done,
     /* 1036662 */   // Label 15369: @1036662
     /* 1036662 */   GIM_Try, /*On fail goto*//*Label 15370*/ GIMT_Encode4(1036739), // Rule ID 13554 //
     /* 1036667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1036678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1036681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1036684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1036687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036706 */     // MIs[0] policy
     /* 1036706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1036719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036738 */     // GIR_Coverage, 13554,
     /* 1036738 */     GIR_EraseRootFromParent_Done,
     /* 1036739 */   // Label 15370: @1036739
     /* 1036739 */   GIM_Try, /*On fail goto*//*Label 15371*/ GIMT_Encode4(1036816), // Rule ID 13555 //
     /* 1036744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1036755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1036758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1036761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1036764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036783 */     // MIs[0] policy
     /* 1036783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036793 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1036796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036815 */     // GIR_Coverage, 13555,
     /* 1036815 */     GIR_EraseRootFromParent_Done,
     /* 1036816 */   // Label 15371: @1036816
     /* 1036816 */   GIM_Try, /*On fail goto*//*Label 15372*/ GIMT_Encode4(1036893), // Rule ID 13558 //
     /* 1036821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036860 */     // MIs[0] policy
     /* 1036860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1036873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036892 */     // GIR_Coverage, 13558,
     /* 1036892 */     GIR_EraseRootFromParent_Done,
     /* 1036893 */   // Label 15372: @1036893
     /* 1036893 */   GIM_Try, /*On fail goto*//*Label 15373*/ GIMT_Encode4(1036970), // Rule ID 13559 //
     /* 1036898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036937 */     // MIs[0] policy
     /* 1036937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036947 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1036950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036969 */     // GIR_Coverage, 13559,
     /* 1036969 */     GIR_EraseRootFromParent_Done,
     /* 1036970 */   // Label 15373: @1036970
     /* 1036970 */   GIM_Try, /*On fail goto*//*Label 15374*/ GIMT_Encode4(1037047), // Rule ID 13562 //
     /* 1036975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1036986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1036989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1036992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1036995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037014 */     // MIs[0] policy
     /* 1037014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037024 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037046 */     // GIR_Coverage, 13562,
     /* 1037046 */     GIR_EraseRootFromParent_Done,
     /* 1037047 */   // Label 15374: @1037047
     /* 1037047 */   GIM_Try, /*On fail goto*//*Label 15375*/ GIMT_Encode4(1037124), // Rule ID 13563 //
     /* 1037052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1037063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1037066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1037069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1037072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037091 */     // MIs[0] policy
     /* 1037091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037101 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037123 */     // GIR_Coverage, 13563,
     /* 1037123 */     GIR_EraseRootFromParent_Done,
     /* 1037124 */   // Label 15375: @1037124
     /* 1037124 */   GIM_Try, /*On fail goto*//*Label 15376*/ GIMT_Encode4(1037201), // Rule ID 13566 //
     /* 1037129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1037140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1037143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1037146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1037149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037168 */     // MIs[0] policy
     /* 1037168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037200 */     // GIR_Coverage, 13566,
     /* 1037200 */     GIR_EraseRootFromParent_Done,
     /* 1037201 */   // Label 15376: @1037201
     /* 1037201 */   GIM_Try, /*On fail goto*//*Label 15377*/ GIMT_Encode4(1037278), // Rule ID 13567 //
     /* 1037206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1037217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1037220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1037223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1037226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037245 */     // MIs[0] policy
     /* 1037245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037255 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1037274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037277 */     // GIR_Coverage, 13567,
     /* 1037277 */     GIR_EraseRootFromParent_Done,
     /* 1037278 */   // Label 15377: @1037278
     /* 1037278 */   GIM_Try, /*On fail goto*//*Label 15378*/ GIMT_Encode4(1037355), // Rule ID 13570 //
     /* 1037283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1037297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037322 */     // MIs[0] policy
     /* 1037322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037332 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037354 */     // GIR_Coverage, 13570,
     /* 1037354 */     GIR_EraseRootFromParent_Done,
     /* 1037355 */   // Label 15378: @1037355
     /* 1037355 */   GIM_Try, /*On fail goto*//*Label 15379*/ GIMT_Encode4(1037432), // Rule ID 13571 //
     /* 1037360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1037371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1037374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1037377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1037380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037399 */     // MIs[0] policy
     /* 1037399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037409 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1037412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037431 */     // GIR_Coverage, 13571,
     /* 1037431 */     GIR_EraseRootFromParent_Done,
     /* 1037432 */   // Label 15379: @1037432
     /* 1037432 */   GIM_Try, /*On fail goto*//*Label 15380*/ GIMT_Encode4(1037509), // Rule ID 13574 //
     /* 1037437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1037448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1037451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1037457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037476 */     // MIs[0] policy
     /* 1037476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037508 */     // GIR_Coverage, 13574,
     /* 1037508 */     GIR_EraseRootFromParent_Done,
     /* 1037509 */   // Label 15380: @1037509
     /* 1037509 */   GIM_Try, /*On fail goto*//*Label 15381*/ GIMT_Encode4(1037586), // Rule ID 13575 //
     /* 1037514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1037525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1037528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1037534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037553 */     // MIs[0] policy
     /* 1037553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037563 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037585 */     // GIR_Coverage, 13575,
     /* 1037585 */     GIR_EraseRootFromParent_Done,
     /* 1037586 */   // Label 15381: @1037586
     /* 1037586 */   GIM_Try, /*On fail goto*//*Label 15382*/ GIMT_Encode4(1037663), // Rule ID 13578 //
     /* 1037591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1037602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1037605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1037608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1037611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037630 */     // MIs[0] policy
     /* 1037630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037662 */     // GIR_Coverage, 13578,
     /* 1037662 */     GIR_EraseRootFromParent_Done,
     /* 1037663 */   // Label 15382: @1037663
     /* 1037663 */   GIM_Try, /*On fail goto*//*Label 15383*/ GIMT_Encode4(1037740), // Rule ID 13579 //
     /* 1037668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1037679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1037682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1037685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1037688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037707 */     // MIs[0] policy
     /* 1037707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037717 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037739 */     // GIR_Coverage, 13579,
     /* 1037739 */     GIR_EraseRootFromParent_Done,
     /* 1037740 */   // Label 15383: @1037740
     /* 1037740 */   GIM_Try, /*On fail goto*//*Label 15384*/ GIMT_Encode4(1037817), // Rule ID 13582 //
     /* 1037745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1037756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1037759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1037762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1037765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037784 */     // MIs[0] policy
     /* 1037784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037816 */     // GIR_Coverage, 13582,
     /* 1037816 */     GIR_EraseRootFromParent_Done,
     /* 1037817 */   // Label 15384: @1037817
     /* 1037817 */   GIM_Try, /*On fail goto*//*Label 15385*/ GIMT_Encode4(1037894), // Rule ID 13583 //
     /* 1037822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1037833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1037836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1037839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1037842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037861 */     // MIs[0] policy
     /* 1037861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037871 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037893 */     // GIR_Coverage, 13583,
     /* 1037893 */     GIR_EraseRootFromParent_Done,
     /* 1037894 */   // Label 15385: @1037894
     /* 1037894 */   GIM_Try, /*On fail goto*//*Label 15386*/ GIMT_Encode4(1037971), // Rule ID 13586 //
     /* 1037899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1037913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1037916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1037919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037938 */     // MIs[0] policy
     /* 1037938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037970 */     // GIR_Coverage, 13586,
     /* 1037970 */     GIR_EraseRootFromParent_Done,
     /* 1037971 */   // Label 15386: @1037971
     /* 1037971 */   GIM_Try, /*On fail goto*//*Label 15387*/ GIMT_Encode4(1038048), // Rule ID 13587 //
     /* 1037976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1037990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1037993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1037996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038015 */     // MIs[0] policy
     /* 1038015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038025 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1038044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038047 */     // GIR_Coverage, 13587,
     /* 1038047 */     GIR_EraseRootFromParent_Done,
     /* 1038048 */   // Label 15387: @1038048
     /* 1038048 */   GIM_Try, /*On fail goto*//*Label 15388*/ GIMT_Encode4(1038125), // Rule ID 13590 //
     /* 1038053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1038070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1038073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038092 */     // MIs[0] policy
     /* 1038092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038124 */     // GIR_Coverage, 13590,
     /* 1038124 */     GIR_EraseRootFromParent_Done,
     /* 1038125 */   // Label 15388: @1038125
     /* 1038125 */   GIM_Try, /*On fail goto*//*Label 15389*/ GIMT_Encode4(1038202), // Rule ID 13591 //
     /* 1038130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1038141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1038144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1038147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1038150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038169 */     // MIs[0] policy
     /* 1038169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038179 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1038182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038201 */     // GIR_Coverage, 13591,
     /* 1038201 */     GIR_EraseRootFromParent_Done,
     /* 1038202 */   // Label 15389: @1038202
     /* 1038202 */   GIM_Try, /*On fail goto*//*Label 15390*/ GIMT_Encode4(1038279), // Rule ID 13594 //
     /* 1038207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1038218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1038221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038246 */     // MIs[0] policy
     /* 1038246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038278 */     // GIR_Coverage, 13594,
     /* 1038278 */     GIR_EraseRootFromParent_Done,
     /* 1038279 */   // Label 15390: @1038279
     /* 1038279 */   GIM_Try, /*On fail goto*//*Label 15391*/ GIMT_Encode4(1038356), // Rule ID 13595 //
     /* 1038284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1038295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1038298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1038301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1038304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038323 */     // MIs[0] policy
     /* 1038323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1038336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038355 */     // GIR_Coverage, 13595,
     /* 1038355 */     GIR_EraseRootFromParent_Done,
     /* 1038356 */   // Label 15391: @1038356
     /* 1038356 */   GIM_Try, /*On fail goto*//*Label 15392*/ GIMT_Encode4(1038433), // Rule ID 13598 //
     /* 1038361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1038372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1038375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1038378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1038381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038400 */     // MIs[0] policy
     /* 1038400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038410 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038432 */     // GIR_Coverage, 13598,
     /* 1038432 */     GIR_EraseRootFromParent_Done,
     /* 1038433 */   // Label 15392: @1038433
     /* 1038433 */   GIM_Try, /*On fail goto*//*Label 15393*/ GIMT_Encode4(1038510), // Rule ID 13599 //
     /* 1038438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1038449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1038452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1038455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1038458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038477 */     // MIs[0] policy
     /* 1038477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038487 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1038490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038509 */     // GIR_Coverage, 13599,
     /* 1038509 */     GIR_EraseRootFromParent_Done,
     /* 1038510 */   // Label 15393: @1038510
     /* 1038510 */   GIM_Try, /*On fail goto*//*Label 15394*/ GIMT_Encode4(1038587), // Rule ID 13602 //
     /* 1038515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1038526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1038529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1038532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1038535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038554 */     // MIs[0] policy
     /* 1038554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038564 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038586 */     // GIR_Coverage, 13602,
     /* 1038586 */     GIR_EraseRootFromParent_Done,
     /* 1038587 */   // Label 15394: @1038587
     /* 1038587 */   GIM_Try, /*On fail goto*//*Label 15395*/ GIMT_Encode4(1038664), // Rule ID 13603 //
     /* 1038592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1038603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1038606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1038609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1038612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038631 */     // MIs[0] policy
     /* 1038631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038641 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038663 */     // GIR_Coverage, 13603,
     /* 1038663 */     GIR_EraseRootFromParent_Done,
     /* 1038664 */   // Label 15395: @1038664
     /* 1038664 */   GIM_Try, /*On fail goto*//*Label 15396*/ GIMT_Encode4(1038741), // Rule ID 13606 //
     /* 1038669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1038680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1038683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1038689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038708 */     // MIs[0] policy
     /* 1038708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1038721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038740 */     // GIR_Coverage, 13606,
     /* 1038740 */     GIR_EraseRootFromParent_Done,
     /* 1038741 */   // Label 15396: @1038741
     /* 1038741 */   GIM_Try, /*On fail goto*//*Label 15397*/ GIMT_Encode4(1038818), // Rule ID 13607 //
     /* 1038746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1038757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1038760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1038766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038785 */     // MIs[0] policy
     /* 1038785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038795 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1038798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038817 */     // GIR_Coverage, 13607,
     /* 1038817 */     GIR_EraseRootFromParent_Done,
     /* 1038818 */   // Label 15397: @1038818
     /* 1038818 */   GIM_Try, /*On fail goto*//*Label 15398*/ GIMT_Encode4(1038895), // Rule ID 13610 //
     /* 1038823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038862 */     // MIs[0] policy
     /* 1038862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038872 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1038875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038894 */     // GIR_Coverage, 13610,
     /* 1038894 */     GIR_EraseRootFromParent_Done,
     /* 1038895 */   // Label 15398: @1038895
     /* 1038895 */   GIM_Try, /*On fail goto*//*Label 15399*/ GIMT_Encode4(1038972), // Rule ID 13611 //
     /* 1038900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038939 */     // MIs[0] policy
     /* 1038939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038949 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1038952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038971 */     // GIR_Coverage, 13611,
     /* 1038971 */     GIR_EraseRootFromParent_Done,
     /* 1038972 */   // Label 15399: @1038972
     /* 1038972 */   GIM_Try, /*On fail goto*//*Label 15400*/ GIMT_Encode4(1039049), // Rule ID 13614 //
     /* 1038977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1038988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1038991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1038997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039016 */     // MIs[0] policy
     /* 1039016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039026 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039048 */     // GIR_Coverage, 13614,
     /* 1039048 */     GIR_EraseRootFromParent_Done,
     /* 1039049 */   // Label 15400: @1039049
     /* 1039049 */   GIM_Try, /*On fail goto*//*Label 15401*/ GIMT_Encode4(1039126), // Rule ID 13615 //
     /* 1039054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1039065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1039068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1039074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039093 */     // MIs[0] policy
     /* 1039093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039103 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11647:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039125 */     // GIR_Coverage, 13615,
     /* 1039125 */     GIR_EraseRootFromParent_Done,
     /* 1039126 */   // Label 15401: @1039126
     /* 1039126 */   GIM_Try, /*On fail goto*//*Label 15402*/ GIMT_Encode4(1039203), // Rule ID 13618 //
     /* 1039131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1039151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039170 */     // MIs[0] policy
     /* 1039170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039180 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039202 */     // GIR_Coverage, 13618,
     /* 1039202 */     GIR_EraseRootFromParent_Done,
     /* 1039203 */   // Label 15402: @1039203
     /* 1039203 */   GIM_Try, /*On fail goto*//*Label 15403*/ GIMT_Encode4(1039280), // Rule ID 13619 //
     /* 1039208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1039219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1039222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1039228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039247 */     // MIs[0] policy
     /* 1039247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039279 */     // GIR_Coverage, 13619,
     /* 1039279 */     GIR_EraseRootFromParent_Done,
     /* 1039280 */   // Label 15403: @1039280
     /* 1039280 */   GIM_Try, /*On fail goto*//*Label 15404*/ GIMT_Encode4(1039357), // Rule ID 13622 //
     /* 1039285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1039305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039324 */     // MIs[0] policy
     /* 1039324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039334 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039356 */     // GIR_Coverage, 13622,
     /* 1039356 */     GIR_EraseRootFromParent_Done,
     /* 1039357 */   // Label 15404: @1039357
     /* 1039357 */   GIM_Try, /*On fail goto*//*Label 15405*/ GIMT_Encode4(1039434), // Rule ID 13623 //
     /* 1039362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1039373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1039376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1039382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039401 */     // MIs[0] policy
     /* 1039401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039411 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039433 */     // GIR_Coverage, 13623,
     /* 1039433 */     GIR_EraseRootFromParent_Done,
     /* 1039434 */   // Label 15405: @1039434
     /* 1039434 */   GIM_Try, /*On fail goto*//*Label 15406*/ GIMT_Encode4(1039511), // Rule ID 13626 //
     /* 1039439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1039459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039478 */     // MIs[0] policy
     /* 1039478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039488 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1039491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039510 */     // GIR_Coverage, 13626,
     /* 1039510 */     GIR_EraseRootFromParent_Done,
     /* 1039511 */   // Label 15406: @1039511
     /* 1039511 */   GIM_Try, /*On fail goto*//*Label 15407*/ GIMT_Encode4(1039588), // Rule ID 13627 //
     /* 1039516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1039536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039555 */     // MIs[0] policy
     /* 1039555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039565 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1039568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039587 */     // GIR_Coverage, 13627,
     /* 1039587 */     GIR_EraseRootFromParent_Done,
     /* 1039588 */   // Label 15407: @1039588
     /* 1039588 */   GIM_Try, /*On fail goto*//*Label 15408*/ GIMT_Encode4(1039665), // Rule ID 13630 //
     /* 1039593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1039604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1039607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1039613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039632 */     // MIs[0] policy
     /* 1039632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039642 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039664 */     // GIR_Coverage, 13630,
     /* 1039664 */     GIR_EraseRootFromParent_Done,
     /* 1039665 */   // Label 15408: @1039665
     /* 1039665 */   GIM_Try, /*On fail goto*//*Label 15409*/ GIMT_Encode4(1039742), // Rule ID 13631 //
     /* 1039670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1039681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1039684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1039690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039709 */     // MIs[0] policy
     /* 1039709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039719 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039741 */     // GIR_Coverage, 13631,
     /* 1039741 */     GIR_EraseRootFromParent_Done,
     /* 1039742 */   // Label 15409: @1039742
     /* 1039742 */   GIM_Try, /*On fail goto*//*Label 15410*/ GIMT_Encode4(1039819), // Rule ID 13634 //
     /* 1039747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1039758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1039761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1039767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039786 */     // MIs[0] policy
     /* 1039786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039818 */     // GIR_Coverage, 13634,
     /* 1039818 */     GIR_EraseRootFromParent_Done,
     /* 1039819 */   // Label 15410: @1039819
     /* 1039819 */   GIM_Try, /*On fail goto*//*Label 15411*/ GIMT_Encode4(1039896), // Rule ID 13635 //
     /* 1039824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1039835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1039838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1039844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039863 */     // MIs[0] policy
     /* 1039863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039873 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11647:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039895 */     // GIR_Coverage, 13635,
     /* 1039895 */     GIR_EraseRootFromParent_Done,
     /* 1039896 */   // Label 15411: @1039896
     /* 1039896 */   GIM_Try, /*On fail goto*//*Label 15412*/ GIMT_Encode4(1039973), // Rule ID 13638 //
     /* 1039901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1039921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039940 */     // MIs[0] policy
     /* 1039940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039972 */     // GIR_Coverage, 13638,
     /* 1039972 */     GIR_EraseRootFromParent_Done,
     /* 1039973 */   // Label 15412: @1039973
     /* 1039973 */   GIM_Try, /*On fail goto*//*Label 15413*/ GIMT_Encode4(1040050), // Rule ID 13639 //
     /* 1039978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1039998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040017 */     // MIs[0] policy
     /* 1040017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040027 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040049 */     // GIR_Coverage, 13639,
     /* 1040049 */     GIR_EraseRootFromParent_Done,
     /* 1040050 */   // Label 15413: @1040050
     /* 1040050 */   GIM_Try, /*On fail goto*//*Label 15414*/ GIMT_Encode4(1040127), // Rule ID 13642 //
     /* 1040055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1040066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1040069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1040075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040094 */     // MIs[0] policy
     /* 1040094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040104 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040126 */     // GIR_Coverage, 13642,
     /* 1040126 */     GIR_EraseRootFromParent_Done,
     /* 1040127 */   // Label 15414: @1040127
     /* 1040127 */   GIM_Try, /*On fail goto*//*Label 15415*/ GIMT_Encode4(1040204), // Rule ID 13643 //
     /* 1040132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1040143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1040146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1040152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040171 */     // MIs[0] policy
     /* 1040171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040181 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040203 */     // GIR_Coverage, 13643,
     /* 1040203 */     GIR_EraseRootFromParent_Done,
     /* 1040204 */   // Label 15415: @1040204
     /* 1040204 */   GIM_Try, /*On fail goto*//*Label 15416*/ GIMT_Encode4(1040281), // Rule ID 13646 //
     /* 1040209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1040220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1040229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040248 */     // MIs[0] policy
     /* 1040248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040258 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040280 */     // GIR_Coverage, 13646,
     /* 1040280 */     GIR_EraseRootFromParent_Done,
     /* 1040281 */   // Label 15416: @1040281
     /* 1040281 */   GIM_Try, /*On fail goto*//*Label 15417*/ GIMT_Encode4(1040358), // Rule ID 13647 //
     /* 1040286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1040297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1040300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1040306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040325 */     // MIs[0] policy
     /* 1040325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040335 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1040354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040357 */     // GIR_Coverage, 13647,
     /* 1040357 */     GIR_EraseRootFromParent_Done,
     /* 1040358 */   // Label 15417: @1040358
     /* 1040358 */   GIM_Try, /*On fail goto*//*Label 15418*/ GIMT_Encode4(1040435), // Rule ID 13650 //
     /* 1040363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1040374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1040377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1040383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040402 */     // MIs[0] policy
     /* 1040402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040434 */     // GIR_Coverage, 13650,
     /* 1040434 */     GIR_EraseRootFromParent_Done,
     /* 1040435 */   // Label 15418: @1040435
     /* 1040435 */   GIM_Try, /*On fail goto*//*Label 15419*/ GIMT_Encode4(1040512), // Rule ID 13651 //
     /* 1040440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1040451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1040454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1040460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040479 */     // MIs[0] policy
     /* 1040479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040489 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11647:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1040492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040511 */     // GIR_Coverage, 13651,
     /* 1040511 */     GIR_EraseRootFromParent_Done,
     /* 1040512 */   // Label 15419: @1040512
     /* 1040512 */   GIM_Try, /*On fail goto*//*Label 15420*/ GIMT_Encode4(1040589), // Rule ID 13654 //
     /* 1040517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1040528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1040531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1040537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040556 */     // MIs[0] policy
     /* 1040556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040588 */     // GIR_Coverage, 13654,
     /* 1040588 */     GIR_EraseRootFromParent_Done,
     /* 1040589 */   // Label 15420: @1040589
     /* 1040589 */   GIM_Try, /*On fail goto*//*Label 15421*/ GIMT_Encode4(1040666), // Rule ID 13655 //
     /* 1040594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1040605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1040608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1040614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040633 */     // MIs[0] policy
     /* 1040633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11647:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040665 */     // GIR_Coverage, 13655,
     /* 1040665 */     GIR_EraseRootFromParent_Done,
     /* 1040666 */   // Label 15421: @1040666
     /* 1040666 */   GIM_Try, /*On fail goto*//*Label 15422*/ GIMT_Encode4(1040743), // Rule ID 13658 //
     /* 1040671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1040682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1040685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1040691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040710 */     // MIs[0] policy
     /* 1040710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040742 */     // GIR_Coverage, 13658,
     /* 1040742 */     GIR_EraseRootFromParent_Done,
     /* 1040743 */   // Label 15422: @1040743
     /* 1040743 */   GIM_Try, /*On fail goto*//*Label 15423*/ GIMT_Encode4(1040820), // Rule ID 13659 //
     /* 1040748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1040759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1040762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1040768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040787 */     // MIs[0] policy
     /* 1040787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040797 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11647:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040819 */     // GIR_Coverage, 13659,
     /* 1040819 */     GIR_EraseRootFromParent_Done,
     /* 1040820 */   // Label 15423: @1040820
     /* 1040820 */   GIM_Try, /*On fail goto*//*Label 15424*/ GIMT_Encode4(1040897), // Rule ID 13662 //
     /* 1040825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040864 */     // MIs[0] policy
     /* 1040864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040896 */     // GIR_Coverage, 13662,
     /* 1040896 */     GIR_EraseRootFromParent_Done,
     /* 1040897 */   // Label 15424: @1040897
     /* 1040897 */   GIM_Try, /*On fail goto*//*Label 15425*/ GIMT_Encode4(1040974), // Rule ID 13663 //
     /* 1040902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040941 */     // MIs[0] policy
     /* 1040941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040951 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11647:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040973 */     // GIR_Coverage, 13663,
     /* 1040973 */     GIR_EraseRootFromParent_Done,
     /* 1040974 */   // Label 15425: @1040974
     /* 1040974 */   GIM_Try, /*On fail goto*//*Label 15426*/ GIMT_Encode4(1041051), // Rule ID 13666 //
     /* 1040979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1040987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1040990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1040993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1040996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1040999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041018 */     // MIs[0] policy
     /* 1041018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041028 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1041031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041050 */     // GIR_Coverage, 13666,
     /* 1041050 */     GIR_EraseRootFromParent_Done,
     /* 1041051 */   // Label 15426: @1041051
     /* 1041051 */   GIM_Try, /*On fail goto*//*Label 15427*/ GIMT_Encode4(1041128), // Rule ID 13667 //
     /* 1041056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1041067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1041070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1041073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1041076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041095 */     // MIs[0] policy
     /* 1041095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041105 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1041108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041127 */     // GIR_Coverage, 13667,
     /* 1041127 */     GIR_EraseRootFromParent_Done,
     /* 1041128 */   // Label 15427: @1041128
     /* 1041128 */   GIM_Try, /*On fail goto*//*Label 15428*/ GIMT_Encode4(1041205), // Rule ID 13670 //
     /* 1041133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1041150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1041153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041172 */     // MIs[0] policy
     /* 1041172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041182 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041204 */     // GIR_Coverage, 13670,
     /* 1041204 */     GIR_EraseRootFromParent_Done,
     /* 1041205 */   // Label 15428: @1041205
     /* 1041205 */   GIM_Try, /*On fail goto*//*Label 15429*/ GIMT_Encode4(1041282), // Rule ID 13671 //
     /* 1041210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1041221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1041224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1041227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1041230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041249 */     // MIs[0] policy
     /* 1041249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041281 */     // GIR_Coverage, 13671,
     /* 1041281 */     GIR_EraseRootFromParent_Done,
     /* 1041282 */   // Label 15429: @1041282
     /* 1041282 */   GIM_Try, /*On fail goto*//*Label 15430*/ GIMT_Encode4(1041359), // Rule ID 13674 //
     /* 1041287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1041304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1041307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041326 */     // MIs[0] policy
     /* 1041326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041336 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041358 */     // GIR_Coverage, 13674,
     /* 1041358 */     GIR_EraseRootFromParent_Done,
     /* 1041359 */   // Label 15430: @1041359
     /* 1041359 */   GIM_Try, /*On fail goto*//*Label 15431*/ GIMT_Encode4(1041436), // Rule ID 13675 //
     /* 1041364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1041375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1041378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1041381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1041384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041403 */     // MIs[0] policy
     /* 1041403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041413 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041435 */     // GIR_Coverage, 13675,
     /* 1041435 */     GIR_EraseRootFromParent_Done,
     /* 1041436 */   // Label 15431: @1041436
     /* 1041436 */   GIM_Try, /*On fail goto*//*Label 15432*/ GIMT_Encode4(1041513), // Rule ID 13678 //
     /* 1041441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1041452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1041455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1041458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1041461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041480 */     // MIs[0] policy
     /* 1041480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1041493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041512 */     // GIR_Coverage, 13678,
     /* 1041512 */     GIR_EraseRootFromParent_Done,
     /* 1041513 */   // Label 15432: @1041513
     /* 1041513 */   GIM_Try, /*On fail goto*//*Label 15433*/ GIMT_Encode4(1041590), // Rule ID 13679 //
     /* 1041518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1041529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1041532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1041535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1041538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041557 */     // MIs[0] policy
     /* 1041557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041567 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1041570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041589 */     // GIR_Coverage, 13679,
     /* 1041589 */     GIR_EraseRootFromParent_Done,
     /* 1041590 */   // Label 15433: @1041590
     /* 1041590 */   GIM_Try, /*On fail goto*//*Label 15434*/ GIMT_Encode4(1041667), // Rule ID 13682 //
     /* 1041595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1041606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1041609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1041612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1041615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041634 */     // MIs[0] policy
     /* 1041634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1041647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041666 */     // GIR_Coverage, 13682,
     /* 1041666 */     GIR_EraseRootFromParent_Done,
     /* 1041667 */   // Label 15434: @1041667
     /* 1041667 */   GIM_Try, /*On fail goto*//*Label 15435*/ GIMT_Encode4(1041744), // Rule ID 13683 //
     /* 1041672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1041683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1041686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1041689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1041692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041711 */     // MIs[0] policy
     /* 1041711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041721 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1041724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041743 */     // GIR_Coverage, 13683,
     /* 1041743 */     GIR_EraseRootFromParent_Done,
     /* 1041744 */   // Label 15435: @1041744
     /* 1041744 */   GIM_Try, /*On fail goto*//*Label 15436*/ GIMT_Encode4(1041821), // Rule ID 13686 //
     /* 1041749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1041760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1041763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1041766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1041769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041788 */     // MIs[0] policy
     /* 1041788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041798 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1041801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041820 */     // GIR_Coverage, 13686,
     /* 1041820 */     GIR_EraseRootFromParent_Done,
     /* 1041821 */   // Label 15436: @1041821
     /* 1041821 */   GIM_Try, /*On fail goto*//*Label 15437*/ GIMT_Encode4(1041898), // Rule ID 13687 //
     /* 1041826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1041837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1041840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1041843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1041846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041865 */     // MIs[0] policy
     /* 1041865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041875 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1041878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041897 */     // GIR_Coverage, 13687,
     /* 1041897 */     GIR_EraseRootFromParent_Done,
     /* 1041898 */   // Label 15437: @1041898
     /* 1041898 */   GIM_Try, /*On fail goto*//*Label 15438*/ GIMT_Encode4(1041975), // Rule ID 13690 //
     /* 1041903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1041923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041942 */     // MIs[0] policy
     /* 1041942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041974 */     // GIR_Coverage, 13690,
     /* 1041974 */     GIR_EraseRootFromParent_Done,
     /* 1041975 */   // Label 15438: @1041975
     /* 1041975 */   GIM_Try, /*On fail goto*//*Label 15439*/ GIMT_Encode4(1042052), // Rule ID 13691 //
     /* 1041980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1042000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042019 */     // MIs[0] policy
     /* 1042019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042029 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1042032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042051 */     // GIR_Coverage, 13691,
     /* 1042051 */     GIR_EraseRootFromParent_Done,
     /* 1042052 */   // Label 15439: @1042052
     /* 1042052 */   GIM_Try, /*On fail goto*//*Label 15440*/ GIMT_Encode4(1042129), // Rule ID 13694 //
     /* 1042057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1042068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1042071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1042074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1042077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042096 */     // MIs[0] policy
     /* 1042096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042106 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042128 */     // GIR_Coverage, 13694,
     /* 1042128 */     GIR_EraseRootFromParent_Done,
     /* 1042129 */   // Label 15440: @1042129
     /* 1042129 */   GIM_Try, /*On fail goto*//*Label 15441*/ GIMT_Encode4(1042206), // Rule ID 13695 //
     /* 1042134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1042145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1042148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1042151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1042154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042173 */     // MIs[0] policy
     /* 1042173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042183 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042205 */     // GIR_Coverage, 13695,
     /* 1042205 */     GIR_EraseRootFromParent_Done,
     /* 1042206 */   // Label 15441: @1042206
     /* 1042206 */   GIM_Try, /*On fail goto*//*Label 15442*/ GIMT_Encode4(1042283), // Rule ID 13698 //
     /* 1042211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1042222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1042225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1042228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1042231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042250 */     // MIs[0] policy
     /* 1042250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042282 */     // GIR_Coverage, 13698,
     /* 1042282 */     GIR_EraseRootFromParent_Done,
     /* 1042283 */   // Label 15442: @1042283
     /* 1042283 */   GIM_Try, /*On fail goto*//*Label 15443*/ GIMT_Encode4(1042360), // Rule ID 13699 //
     /* 1042288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1042299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1042302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1042305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1042308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042327 */     // MIs[0] policy
     /* 1042327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042337 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042359 */     // GIR_Coverage, 13699,
     /* 1042359 */     GIR_EraseRootFromParent_Done,
     /* 1042360 */   // Label 15443: @1042360
     /* 1042360 */   GIM_Try, /*On fail goto*//*Label 15444*/ GIMT_Encode4(1042437), // Rule ID 13702 //
     /* 1042365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1042376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1042379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1042385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042404 */     // MIs[0] policy
     /* 1042404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042436 */     // GIR_Coverage, 13702,
     /* 1042436 */     GIR_EraseRootFromParent_Done,
     /* 1042437 */   // Label 15444: @1042437
     /* 1042437 */   GIM_Try, /*On fail goto*//*Label 15445*/ GIMT_Encode4(1042514), // Rule ID 13703 //
     /* 1042442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1042453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1042456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1042459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1042462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042481 */     // MIs[0] policy
     /* 1042481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042491 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042513 */     // GIR_Coverage, 13703,
     /* 1042513 */     GIR_EraseRootFromParent_Done,
     /* 1042514 */   // Label 15445: @1042514
     /* 1042514 */   GIM_Try, /*On fail goto*//*Label 15446*/ GIMT_Encode4(1042591), // Rule ID 13706 //
     /* 1042519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1042530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1042533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1042536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1042539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042558 */     // MIs[0] policy
     /* 1042558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042568 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042590 */     // GIR_Coverage, 13706,
     /* 1042590 */     GIR_EraseRootFromParent_Done,
     /* 1042591 */   // Label 15446: @1042591
     /* 1042591 */   GIM_Try, /*On fail goto*//*Label 15447*/ GIMT_Encode4(1042668), // Rule ID 13707 //
     /* 1042596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1042607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1042610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1042613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1042616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042635 */     // MIs[0] policy
     /* 1042635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042645 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042667 */     // GIR_Coverage, 13707,
     /* 1042667 */     GIR_EraseRootFromParent_Done,
     /* 1042668 */   // Label 15447: @1042668
     /* 1042668 */   GIM_Try, /*On fail goto*//*Label 15448*/ GIMT_Encode4(1042745), // Rule ID 13710 //
     /* 1042673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1042684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1042687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1042690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1042693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042712 */     // MIs[0] policy
     /* 1042712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042722 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042744 */     // GIR_Coverage, 13710,
     /* 1042744 */     GIR_EraseRootFromParent_Done,
     /* 1042745 */   // Label 15448: @1042745
     /* 1042745 */   GIM_Try, /*On fail goto*//*Label 15449*/ GIMT_Encode4(1042822), // Rule ID 13711 //
     /* 1042750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1042761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1042764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1042767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1042770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042789 */     // MIs[0] policy
     /* 1042789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042799 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042821 */     // GIR_Coverage, 13711,
     /* 1042821 */     GIR_EraseRootFromParent_Done,
     /* 1042822 */   // Label 15449: @1042822
     /* 1042822 */   GIM_Try, /*On fail goto*//*Label 15450*/ GIMT_Encode4(1042899), // Rule ID 13714 //
     /* 1042827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042866 */     // MIs[0] policy
     /* 1042866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042898 */     // GIR_Coverage, 13714,
     /* 1042898 */     GIR_EraseRootFromParent_Done,
     /* 1042899 */   // Label 15450: @1042899
     /* 1042899 */   GIM_Try, /*On fail goto*//*Label 15451*/ GIMT_Encode4(1042976), // Rule ID 13715 //
     /* 1042904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042943 */     // MIs[0] policy
     /* 1042943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042975 */     // GIR_Coverage, 13715,
     /* 1042975 */     GIR_EraseRootFromParent_Done,
     /* 1042976 */   // Label 15451: @1042976
     /* 1042976 */   GIM_Try, /*On fail goto*//*Label 15452*/ GIMT_Encode4(1043053), // Rule ID 13718 //
     /* 1042981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1042992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1042995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1042998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1043001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043020 */     // MIs[0] policy
     /* 1043020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1043033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043052 */     // GIR_Coverage, 13718,
     /* 1043052 */     GIR_EraseRootFromParent_Done,
     /* 1043053 */   // Label 15452: @1043053
     /* 1043053 */   GIM_Try, /*On fail goto*//*Label 15453*/ GIMT_Encode4(1043130), // Rule ID 13719 //
     /* 1043058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1043069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1043072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1043075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1043078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043097 */     // MIs[0] policy
     /* 1043097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043107 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1043110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043129 */     // GIR_Coverage, 13719,
     /* 1043129 */     GIR_EraseRootFromParent_Done,
     /* 1043130 */   // Label 15453: @1043130
     /* 1043130 */   GIM_Try, /*On fail goto*//*Label 15454*/ GIMT_Encode4(1043207), // Rule ID 13722 //
     /* 1043135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1043138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1043146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1043149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1043155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043174 */     // MIs[0] policy
     /* 1043174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043206 */     // GIR_Coverage, 13722,
     /* 1043206 */     GIR_EraseRootFromParent_Done,
     /* 1043207 */   // Label 15454: @1043207
     /* 1043207 */   GIM_Try, /*On fail goto*//*Label 15455*/ GIMT_Encode4(1043284), // Rule ID 13723 //
     /* 1043212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1043215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1043223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1043226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1043229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1043232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043251 */     // MIs[0] policy
     /* 1043251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043261 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1043264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1043280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043283 */     // GIR_Coverage, 13723,
     /* 1043283 */     GIR_EraseRootFromParent_Done,
     /* 1043284 */   // Label 15455: @1043284
     /* 1043284 */   GIM_Try, /*On fail goto*//*Label 15456*/ GIMT_Encode4(1043361), // Rule ID 13726 //
     /* 1043289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1043300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1043303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1043309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043328 */     // MIs[0] policy
     /* 1043328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043338 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1043341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043360 */     // GIR_Coverage, 13726,
     /* 1043360 */     GIR_EraseRootFromParent_Done,
     /* 1043361 */   // Label 15456: @1043361
     /* 1043361 */   GIM_Try, /*On fail goto*//*Label 15457*/ GIMT_Encode4(1043438), // Rule ID 13727 //
     /* 1043366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1043377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1043380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1043386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043405 */     // MIs[0] policy
     /* 1043405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043415 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1043418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043437 */     // GIR_Coverage, 13727,
     /* 1043437 */     GIR_EraseRootFromParent_Done,
     /* 1043438 */   // Label 15457: @1043438
     /* 1043438 */   GIM_Try, /*On fail goto*//*Label 15458*/ GIMT_Encode4(1043515), // Rule ID 13730 //
     /* 1043443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1043454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1043457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1043463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043482 */     // MIs[0] policy
     /* 1043482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043492 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1043495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043514 */     // GIR_Coverage, 13730,
     /* 1043514 */     GIR_EraseRootFromParent_Done,
     /* 1043515 */   // Label 15458: @1043515
     /* 1043515 */   GIM_Try, /*On fail goto*//*Label 15459*/ GIMT_Encode4(1043592), // Rule ID 13731 //
     /* 1043520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1043531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1043534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1043540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043559 */     // MIs[0] policy
     /* 1043559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043569 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1043572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043591 */     // GIR_Coverage, 13731,
     /* 1043591 */     GIR_EraseRootFromParent_Done,
     /* 1043592 */   // Label 15459: @1043592
     /* 1043592 */   GIM_Try, /*On fail goto*//*Label 15460*/ GIMT_Encode4(1043669), // Rule ID 13734 //
     /* 1043597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1043608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1043611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1043617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043636 */     // MIs[0] policy
     /* 1043636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1043649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043668 */     // GIR_Coverage, 13734,
     /* 1043668 */     GIR_EraseRootFromParent_Done,
     /* 1043669 */   // Label 15460: @1043669
     /* 1043669 */   GIM_Try, /*On fail goto*//*Label 15461*/ GIMT_Encode4(1043746), // Rule ID 13735 //
     /* 1043674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1043685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1043688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1043694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043713 */     // MIs[0] policy
     /* 1043713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043723 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11649:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1043726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043745 */     // GIR_Coverage, 13735,
     /* 1043745 */     GIR_EraseRootFromParent_Done,
     /* 1043746 */   // Label 15461: @1043746
     /* 1043746 */   GIM_Try, /*On fail goto*//*Label 15462*/ GIMT_Encode4(1043823), // Rule ID 13738 //
     /* 1043751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1043762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1043765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1043771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043790 */     // MIs[0] policy
     /* 1043790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1043803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043822 */     // GIR_Coverage, 13738,
     /* 1043822 */     GIR_EraseRootFromParent_Done,
     /* 1043823 */   // Label 15462: @1043823
     /* 1043823 */   GIM_Try, /*On fail goto*//*Label 15463*/ GIMT_Encode4(1043900), // Rule ID 13739 //
     /* 1043828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1043839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1043842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1043848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043867 */     // MIs[0] policy
     /* 1043867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043877 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1043880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043899 */     // GIR_Coverage, 13739,
     /* 1043899 */     GIR_EraseRootFromParent_Done,
     /* 1043900 */   // Label 15463: @1043900
     /* 1043900 */   GIM_Try, /*On fail goto*//*Label 15464*/ GIMT_Encode4(1043977), // Rule ID 13742 //
     /* 1043905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1043916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1043919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1043925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043944 */     // MIs[0] policy
     /* 1043944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043954 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1043957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043976 */     // GIR_Coverage, 13742,
     /* 1043976 */     GIR_EraseRootFromParent_Done,
     /* 1043977 */   // Label 15464: @1043977
     /* 1043977 */   GIM_Try, /*On fail goto*//*Label 15465*/ GIMT_Encode4(1044054), // Rule ID 13743 //
     /* 1043982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1043993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1043996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1044002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044021 */     // MIs[0] policy
     /* 1044021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044031 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044053 */     // GIR_Coverage, 13743,
     /* 1044053 */     GIR_EraseRootFromParent_Done,
     /* 1044054 */   // Label 15465: @1044054
     /* 1044054 */   GIM_Try, /*On fail goto*//*Label 15466*/ GIMT_Encode4(1044131), // Rule ID 13746 //
     /* 1044059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1044070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1044073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1044079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044098 */     // MIs[0] policy
     /* 1044098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044108 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044130 */     // GIR_Coverage, 13746,
     /* 1044130 */     GIR_EraseRootFromParent_Done,
     /* 1044131 */   // Label 15466: @1044131
     /* 1044131 */   GIM_Try, /*On fail goto*//*Label 15467*/ GIMT_Encode4(1044208), // Rule ID 13747 //
     /* 1044136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1044147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1044150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1044156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044175 */     // MIs[0] policy
     /* 1044175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044185 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1044204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044207 */     // GIR_Coverage, 13747,
     /* 1044207 */     GIR_EraseRootFromParent_Done,
     /* 1044208 */   // Label 15467: @1044208
     /* 1044208 */   GIM_Try, /*On fail goto*//*Label 15468*/ GIMT_Encode4(1044285), // Rule ID 13750 //
     /* 1044213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1044224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1044227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044252 */     // MIs[0] policy
     /* 1044252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044262 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044284 */     // GIR_Coverage, 13750,
     /* 1044284 */     GIR_EraseRootFromParent_Done,
     /* 1044285 */   // Label 15468: @1044285
     /* 1044285 */   GIM_Try, /*On fail goto*//*Label 15469*/ GIMT_Encode4(1044362), // Rule ID 13751 //
     /* 1044290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1044301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1044304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1044310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044329 */     // MIs[0] policy
     /* 1044329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044339 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1044342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044361 */     // GIR_Coverage, 13751,
     /* 1044361 */     GIR_EraseRootFromParent_Done,
     /* 1044362 */   // Label 15469: @1044362
     /* 1044362 */   GIM_Try, /*On fail goto*//*Label 15470*/ GIMT_Encode4(1044439), // Rule ID 13754 //
     /* 1044367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1044378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1044381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044406 */     // MIs[0] policy
     /* 1044406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044438 */     // GIR_Coverage, 13754,
     /* 1044438 */     GIR_EraseRootFromParent_Done,
     /* 1044439 */   // Label 15470: @1044439
     /* 1044439 */   GIM_Try, /*On fail goto*//*Label 15471*/ GIMT_Encode4(1044516), // Rule ID 13755 //
     /* 1044444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1044455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1044458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1044464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044483 */     // MIs[0] policy
     /* 1044483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11649:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044515 */     // GIR_Coverage, 13755,
     /* 1044515 */     GIR_EraseRootFromParent_Done,
     /* 1044516 */   // Label 15471: @1044516
     /* 1044516 */   GIM_Try, /*On fail goto*//*Label 15472*/ GIMT_Encode4(1044593), // Rule ID 13758 //
     /* 1044521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1044532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1044535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1044541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044560 */     // MIs[0] policy
     /* 1044560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044592 */     // GIR_Coverage, 13758,
     /* 1044592 */     GIR_EraseRootFromParent_Done,
     /* 1044593 */   // Label 15472: @1044593
     /* 1044593 */   GIM_Try, /*On fail goto*//*Label 15473*/ GIMT_Encode4(1044670), // Rule ID 13759 //
     /* 1044598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1044609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1044612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1044618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044637 */     // MIs[0] policy
     /* 1044637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044647 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044669 */     // GIR_Coverage, 13759,
     /* 1044669 */     GIR_EraseRootFromParent_Done,
     /* 1044670 */   // Label 15473: @1044670
     /* 1044670 */   GIM_Try, /*On fail goto*//*Label 15474*/ GIMT_Encode4(1044747), // Rule ID 13762 //
     /* 1044675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1044686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1044689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1044695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044714 */     // MIs[0] policy
     /* 1044714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044746 */     // GIR_Coverage, 13762,
     /* 1044746 */     GIR_EraseRootFromParent_Done,
     /* 1044747 */   // Label 15474: @1044747
     /* 1044747 */   GIM_Try, /*On fail goto*//*Label 15475*/ GIMT_Encode4(1044824), // Rule ID 13763 //
     /* 1044752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1044763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1044766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1044772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044791 */     // MIs[0] policy
     /* 1044791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044801 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044823 */     // GIR_Coverage, 13763,
     /* 1044823 */     GIR_EraseRootFromParent_Done,
     /* 1044824 */   // Label 15475: @1044824
     /* 1044824 */   GIM_Try, /*On fail goto*//*Label 15476*/ GIMT_Encode4(1044901), // Rule ID 13766 //
     /* 1044829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044868 */     // MIs[0] policy
     /* 1044868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044878 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044900 */     // GIR_Coverage, 13766,
     /* 1044900 */     GIR_EraseRootFromParent_Done,
     /* 1044901 */   // Label 15476: @1044901
     /* 1044901 */   GIM_Try, /*On fail goto*//*Label 15477*/ GIMT_Encode4(1044978), // Rule ID 13767 //
     /* 1044906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044945 */     // MIs[0] policy
     /* 1044945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044955 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044977 */     // GIR_Coverage, 13767,
     /* 1044977 */     GIR_EraseRootFromParent_Done,
     /* 1044978 */   // Label 15477: @1044978
     /* 1044978 */   GIM_Try, /*On fail goto*//*Label 15478*/ GIMT_Encode4(1045055), // Rule ID 13770 //
     /* 1044983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1044994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1044997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1045003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045022 */     // MIs[0] policy
     /* 1045022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1045035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045054 */     // GIR_Coverage, 13770,
     /* 1045054 */     GIR_EraseRootFromParent_Done,
     /* 1045055 */   // Label 15478: @1045055
     /* 1045055 */   GIM_Try, /*On fail goto*//*Label 15479*/ GIMT_Encode4(1045132), // Rule ID 13771 //
     /* 1045060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1045071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1045074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1045080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045099 */     // MIs[0] policy
     /* 1045099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045109 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11649:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1045112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045131 */     // GIR_Coverage, 13771,
     /* 1045131 */     GIR_EraseRootFromParent_Done,
     /* 1045132 */   // Label 15479: @1045132
     /* 1045132 */   GIM_Try, /*On fail goto*//*Label 15480*/ GIMT_Encode4(1045209), // Rule ID 13774 //
     /* 1045137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1045148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1045151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045176 */     // MIs[0] policy
     /* 1045176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045186 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045208 */     // GIR_Coverage, 13774,
     /* 1045208 */     GIR_EraseRootFromParent_Done,
     /* 1045209 */   // Label 15480: @1045209
     /* 1045209 */   GIM_Try, /*On fail goto*//*Label 15481*/ GIMT_Encode4(1045286), // Rule ID 13775 //
     /* 1045214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1045225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1045228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1045234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045253 */     // MIs[0] policy
     /* 1045253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045263 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11649:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1045266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045285 */     // GIR_Coverage, 13775,
     /* 1045285 */     GIR_EraseRootFromParent_Done,
     /* 1045286 */   // Label 15481: @1045286
     /* 1045286 */   GIM_Try, /*On fail goto*//*Label 15482*/ GIMT_Encode4(1045363), // Rule ID 13778 //
     /* 1045291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1045302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1045305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1045311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045330 */     // MIs[0] policy
     /* 1045330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045340 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045362 */     // GIR_Coverage, 13778,
     /* 1045362 */     GIR_EraseRootFromParent_Done,
     /* 1045363 */   // Label 15482: @1045363
     /* 1045363 */   GIM_Try, /*On fail goto*//*Label 15483*/ GIMT_Encode4(1045440), // Rule ID 13779 //
     /* 1045368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1045379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1045382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1045388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045407 */     // MIs[0] policy
     /* 1045407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045417 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11649:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1045420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045439 */     // GIR_Coverage, 13779,
     /* 1045439 */     GIR_EraseRootFromParent_Done,
     /* 1045440 */   // Label 15483: @1045440
     /* 1045440 */   GIM_Try, /*On fail goto*//*Label 15484*/ GIMT_Encode4(1045517), // Rule ID 13782 //
     /* 1045445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1045448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1045456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1045459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1045465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045484 */     // MIs[0] policy
     /* 1045484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045516 */     // GIR_Coverage, 13782,
     /* 1045516 */     GIR_EraseRootFromParent_Done,
     /* 1045517 */   // Label 15484: @1045517
     /* 1045517 */   GIM_Try, /*On fail goto*//*Label 15485*/ GIMT_Encode4(1045594), // Rule ID 13783 //
     /* 1045522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1045533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1045536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1045542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045561 */     // MIs[0] policy
     /* 1045561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045571 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11649:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045593 */     // GIR_Coverage, 13783,
     /* 1045593 */     GIR_EraseRootFromParent_Done,
     /* 1045594 */   // Label 15485: @1045594
     /* 1045594 */   GIM_Try, /*On fail goto*//*Label 15486*/ GIMT_Encode4(1045671), // Rule ID 13786 //
     /* 1045599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1045610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1045613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1045619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045638 */     // MIs[0] policy
     /* 1045638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1045651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045670 */     // GIR_Coverage, 13786,
     /* 1045670 */     GIR_EraseRootFromParent_Done,
     /* 1045671 */   // Label 15486: @1045671
     /* 1045671 */   GIM_Try, /*On fail goto*//*Label 15487*/ GIMT_Encode4(1045748), // Rule ID 13787 //
     /* 1045676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1045687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1045690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1045696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045715 */     // MIs[0] policy
     /* 1045715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045725 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1045728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045747 */     // GIR_Coverage, 13787,
     /* 1045747 */     GIR_EraseRootFromParent_Done,
     /* 1045748 */   // Label 15487: @1045748
     /* 1045748 */   GIM_Try, /*On fail goto*//*Label 15488*/ GIMT_Encode4(1045825), // Rule ID 13790 //
     /* 1045753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1045764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1045767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1045773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045792 */     // MIs[0] policy
     /* 1045792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1045805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045824 */     // GIR_Coverage, 13790,
     /* 1045824 */     GIR_EraseRootFromParent_Done,
     /* 1045825 */   // Label 15488: @1045825
     /* 1045825 */   GIM_Try, /*On fail goto*//*Label 15489*/ GIMT_Encode4(1045902), // Rule ID 13791 //
     /* 1045830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1045841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1045844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1045850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045869 */     // MIs[0] policy
     /* 1045869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045879 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1045882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045901 */     // GIR_Coverage, 13791,
     /* 1045901 */     GIR_EraseRootFromParent_Done,
     /* 1045902 */   // Label 15489: @1045902
     /* 1045902 */   GIM_Try, /*On fail goto*//*Label 15490*/ GIMT_Encode4(1045979), // Rule ID 13794 //
     /* 1045907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1045927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045946 */     // MIs[0] policy
     /* 1045946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045956 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1045959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045978 */     // GIR_Coverage, 13794,
     /* 1045978 */     GIR_EraseRootFromParent_Done,
     /* 1045979 */   // Label 15490: @1045979
     /* 1045979 */   GIM_Try, /*On fail goto*//*Label 15491*/ GIMT_Encode4(1046056), // Rule ID 13795 //
     /* 1045984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1046004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046023 */     // MIs[0] policy
     /* 1046023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046033 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11653:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046055 */     // GIR_Coverage, 13795,
     /* 1046055 */     GIR_EraseRootFromParent_Done,
     /* 1046056 */   // Label 15491: @1046056
     /* 1046056 */   GIM_Try, /*On fail goto*//*Label 15492*/ GIMT_Encode4(1046133), // Rule ID 13798 //
     /* 1046061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1046081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046100 */     // MIs[0] policy
     /* 1046100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046110 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046132 */     // GIR_Coverage, 13798,
     /* 1046132 */     GIR_EraseRootFromParent_Done,
     /* 1046133 */   // Label 15492: @1046133
     /* 1046133 */   GIM_Try, /*On fail goto*//*Label 15493*/ GIMT_Encode4(1046210), // Rule ID 13799 //
     /* 1046138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1046149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1046152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1046158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046177 */     // MIs[0] policy
     /* 1046177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046187 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046209 */     // GIR_Coverage, 13799,
     /* 1046209 */     GIR_EraseRootFromParent_Done,
     /* 1046210 */   // Label 15493: @1046210
     /* 1046210 */   GIM_Try, /*On fail goto*//*Label 15494*/ GIMT_Encode4(1046287), // Rule ID 13802 //
     /* 1046215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1046235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046254 */     // MIs[0] policy
     /* 1046254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046286 */     // GIR_Coverage, 13802,
     /* 1046286 */     GIR_EraseRootFromParent_Done,
     /* 1046287 */   // Label 15494: @1046287
     /* 1046287 */   GIM_Try, /*On fail goto*//*Label 15495*/ GIMT_Encode4(1046364), // Rule ID 13803 //
     /* 1046292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1046303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1046306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1046312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046331 */     // MIs[0] policy
     /* 1046331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046341 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046363 */     // GIR_Coverage, 13803,
     /* 1046363 */     GIR_EraseRootFromParent_Done,
     /* 1046364 */   // Label 15495: @1046364
     /* 1046364 */   GIM_Try, /*On fail goto*//*Label 15496*/ GIMT_Encode4(1046441), // Rule ID 13806 //
     /* 1046369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1046389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046408 */     // MIs[0] policy
     /* 1046408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046418 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046440 */     // GIR_Coverage, 13806,
     /* 1046440 */     GIR_EraseRootFromParent_Done,
     /* 1046441 */   // Label 15496: @1046441
     /* 1046441 */   GIM_Try, /*On fail goto*//*Label 15497*/ GIMT_Encode4(1046518), // Rule ID 13807 //
     /* 1046446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1046457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1046460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1046466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046485 */     // MIs[0] policy
     /* 1046485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046495 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046517 */     // GIR_Coverage, 13807,
     /* 1046517 */     GIR_EraseRootFromParent_Done,
     /* 1046518 */   // Label 15497: @1046518
     /* 1046518 */   GIM_Try, /*On fail goto*//*Label 15498*/ GIMT_Encode4(1046595), // Rule ID 13810 //
     /* 1046523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1046534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1046537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1046543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046562 */     // MIs[0] policy
     /* 1046562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046594 */     // GIR_Coverage, 13810,
     /* 1046594 */     GIR_EraseRootFromParent_Done,
     /* 1046595 */   // Label 15498: @1046595
     /* 1046595 */   GIM_Try, /*On fail goto*//*Label 15499*/ GIMT_Encode4(1046672), // Rule ID 13811 //
     /* 1046600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1046611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1046614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1046620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046639 */     // MIs[0] policy
     /* 1046639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046649 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046671 */     // GIR_Coverage, 13811,
     /* 1046671 */     GIR_EraseRootFromParent_Done,
     /* 1046672 */   // Label 15499: @1046672
     /* 1046672 */   GIM_Try, /*On fail goto*//*Label 15500*/ GIMT_Encode4(1046749), // Rule ID 13814 //
     /* 1046677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1046688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1046691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1046697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046716 */     // MIs[0] policy
     /* 1046716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046748 */     // GIR_Coverage, 13814,
     /* 1046748 */     GIR_EraseRootFromParent_Done,
     /* 1046749 */   // Label 15500: @1046749
     /* 1046749 */   GIM_Try, /*On fail goto*//*Label 15501*/ GIMT_Encode4(1046826), // Rule ID 13815 //
     /* 1046754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1046765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1046768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1046774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046793 */     // MIs[0] policy
     /* 1046793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046803 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11653:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046825 */     // GIR_Coverage, 13815,
     /* 1046825 */     GIR_EraseRootFromParent_Done,
     /* 1046826 */   // Label 15501: @1046826
     /* 1046826 */   GIM_Try, /*On fail goto*//*Label 15502*/ GIMT_Encode4(1046903), // Rule ID 13818 //
     /* 1046831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046870 */     // MIs[0] policy
     /* 1046870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046902 */     // GIR_Coverage, 13818,
     /* 1046902 */     GIR_EraseRootFromParent_Done,
     /* 1046903 */   // Label 15502: @1046903
     /* 1046903 */   GIM_Try, /*On fail goto*//*Label 15503*/ GIMT_Encode4(1046980), // Rule ID 13819 //
     /* 1046908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046947 */     // MIs[0] policy
     /* 1046947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046957 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046979 */     // GIR_Coverage, 13819,
     /* 1046979 */     GIR_EraseRootFromParent_Done,
     /* 1046980 */   // Label 15503: @1046980
     /* 1046980 */   GIM_Try, /*On fail goto*//*Label 15504*/ GIMT_Encode4(1047057), // Rule ID 13822 //
     /* 1046985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1046996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1046999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1047005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047024 */     // MIs[0] policy
     /* 1047024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047056 */     // GIR_Coverage, 13822,
     /* 1047056 */     GIR_EraseRootFromParent_Done,
     /* 1047057 */   // Label 15504: @1047057
     /* 1047057 */   GIM_Try, /*On fail goto*//*Label 15505*/ GIMT_Encode4(1047134), // Rule ID 13823 //
     /* 1047062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1047073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1047076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1047082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047101 */     // MIs[0] policy
     /* 1047101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047111 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047133 */     // GIR_Coverage, 13823,
     /* 1047133 */     GIR_EraseRootFromParent_Done,
     /* 1047134 */   // Label 15505: @1047134
     /* 1047134 */   GIM_Try, /*On fail goto*//*Label 15506*/ GIMT_Encode4(1047211), // Rule ID 13826 //
     /* 1047139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1047142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1047159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047178 */     // MIs[0] policy
     /* 1047178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047188 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047210 */     // GIR_Coverage, 13826,
     /* 1047210 */     GIR_EraseRootFromParent_Done,
     /* 1047211 */   // Label 15506: @1047211
     /* 1047211 */   GIM_Try, /*On fail goto*//*Label 15507*/ GIMT_Encode4(1047288), // Rule ID 13827 //
     /* 1047216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1047219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1047227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1047230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1047236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047255 */     // MIs[0] policy
     /* 1047255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047265 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047287 */     // GIR_Coverage, 13827,
     /* 1047287 */     GIR_EraseRootFromParent_Done,
     /* 1047288 */   // Label 15507: @1047288
     /* 1047288 */   GIM_Try, /*On fail goto*//*Label 15508*/ GIMT_Encode4(1047365), // Rule ID 13830 //
     /* 1047293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1047304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1047307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1047313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047332 */     // MIs[0] policy
     /* 1047332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047342 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047364 */     // GIR_Coverage, 13830,
     /* 1047364 */     GIR_EraseRootFromParent_Done,
     /* 1047365 */   // Label 15508: @1047365
     /* 1047365 */   GIM_Try, /*On fail goto*//*Label 15509*/ GIMT_Encode4(1047442), // Rule ID 13831 //
     /* 1047370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1047381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1047384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1047390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047409 */     // MIs[0] policy
     /* 1047409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047419 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11653:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1047422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047441 */     // GIR_Coverage, 13831,
     /* 1047441 */     GIR_EraseRootFromParent_Done,
     /* 1047442 */   // Label 15509: @1047442
     /* 1047442 */   GIM_Try, /*On fail goto*//*Label 15510*/ GIMT_Encode4(1047519), // Rule ID 13834 //
     /* 1047447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1047458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1047461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1047467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047486 */     // MIs[0] policy
     /* 1047486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047518 */     // GIR_Coverage, 13834,
     /* 1047518 */     GIR_EraseRootFromParent_Done,
     /* 1047519 */   // Label 15510: @1047519
     /* 1047519 */   GIM_Try, /*On fail goto*//*Label 15511*/ GIMT_Encode4(1047596), // Rule ID 13835 //
     /* 1047524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1047535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1047538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1047544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047563 */     // MIs[0] policy
     /* 1047563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047573 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11653:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047595 */     // GIR_Coverage, 13835,
     /* 1047595 */     GIR_EraseRootFromParent_Done,
     /* 1047596 */   // Label 15511: @1047596
     /* 1047596 */   GIM_Try, /*On fail goto*//*Label 15512*/ GIMT_Encode4(1047673), // Rule ID 13838 //
     /* 1047601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1047612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1047615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1047621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047640 */     // MIs[0] policy
     /* 1047640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047650 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047672 */     // GIR_Coverage, 13838,
     /* 1047672 */     GIR_EraseRootFromParent_Done,
     /* 1047673 */   // Label 15512: @1047673
     /* 1047673 */   GIM_Try, /*On fail goto*//*Label 15513*/ GIMT_Encode4(1047750), // Rule ID 13839 //
     /* 1047678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1047689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1047692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1047698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047717 */     // MIs[0] policy
     /* 1047717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047727 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11653:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047749 */     // GIR_Coverage, 13839,
     /* 1047749 */     GIR_EraseRootFromParent_Done,
     /* 1047750 */   // Label 15513: @1047750
     /* 1047750 */   GIM_Try, /*On fail goto*//*Label 15514*/ GIMT_Encode4(1047827), // Rule ID 13842 //
     /* 1047755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1047775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047794 */     // MIs[0] policy
     /* 1047794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047804 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047826 */     // GIR_Coverage, 13842,
     /* 1047826 */     GIR_EraseRootFromParent_Done,
     /* 1047827 */   // Label 15514: @1047827
     /* 1047827 */   GIM_Try, /*On fail goto*//*Label 15515*/ GIMT_Encode4(1047904), // Rule ID 13843 //
     /* 1047832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1047852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047871 */     // MIs[0] policy
     /* 1047871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047881 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11653:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047903 */     // GIR_Coverage, 13843,
     /* 1047903 */     GIR_EraseRootFromParent_Done,
     /* 1047904 */   // Label 15515: @1047904
     /* 1047904 */   GIM_Try, /*On fail goto*//*Label 15516*/ GIMT_Encode4(1047981), // Rule ID 19056 //
     /* 1047909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1047912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1047920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1047923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1047926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1047929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047948 */     // MIs[0] policy
     /* 1047948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047958 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1047961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1047969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047980 */     // GIR_Coverage, 19056,
     /* 1047980 */     GIR_EraseRootFromParent_Done,
     /* 1047981 */   // Label 15516: @1047981
     /* 1047981 */   GIM_Try, /*On fail goto*//*Label 15517*/ GIMT_Encode4(1048058), // Rule ID 19057 //
     /* 1047986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1047989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1047997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1048000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1048003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048025 */     // MIs[0] policy
     /* 1048025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048035 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1048038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048057 */     // GIR_Coverage, 19057,
     /* 1048057 */     GIR_EraseRootFromParent_Done,
     /* 1048058 */   // Label 15517: @1048058
     /* 1048058 */   GIM_Try, /*On fail goto*//*Label 15518*/ GIMT_Encode4(1048135), // Rule ID 19060 //
     /* 1048063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048102 */     // MIs[0] policy
     /* 1048102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048112 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1048115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048134 */     // GIR_Coverage, 19060,
     /* 1048134 */     GIR_EraseRootFromParent_Done,
     /* 1048135 */   // Label 15518: @1048135
     /* 1048135 */   GIM_Try, /*On fail goto*//*Label 15519*/ GIMT_Encode4(1048212), // Rule ID 19061 //
     /* 1048140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1048151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1048154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1048157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048179 */     // MIs[0] policy
     /* 1048179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048189 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1048192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048198 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048211 */     // GIR_Coverage, 19061,
     /* 1048211 */     GIR_EraseRootFromParent_Done,
     /* 1048212 */   // Label 15519: @1048212
     /* 1048212 */   GIM_Try, /*On fail goto*//*Label 15520*/ GIMT_Encode4(1048289), // Rule ID 19064 //
     /* 1048217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048256 */     // MIs[0] policy
     /* 1048256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048266 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1048269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048288 */     // GIR_Coverage, 19064,
     /* 1048288 */     GIR_EraseRootFromParent_Done,
     /* 1048289 */   // Label 15520: @1048289
     /* 1048289 */   GIM_Try, /*On fail goto*//*Label 15521*/ GIMT_Encode4(1048366), // Rule ID 19065 //
     /* 1048294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1048305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1048308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1048311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048333 */     // MIs[0] policy
     /* 1048333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048343 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11262:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1048346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048365 */     // GIR_Coverage, 19065,
     /* 1048365 */     GIR_EraseRootFromParent_Done,
     /* 1048366 */   // Label 15521: @1048366
     /* 1048366 */   GIM_Try, /*On fail goto*//*Label 15522*/ GIMT_Encode4(1048443), // Rule ID 19068 //
     /* 1048371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1048388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048410 */     // MIs[0] policy
     /* 1048410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1048423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048442 */     // GIR_Coverage, 19068,
     /* 1048442 */     GIR_EraseRootFromParent_Done,
     /* 1048443 */   // Label 15522: @1048443
     /* 1048443 */   GIM_Try, /*On fail goto*//*Label 15523*/ GIMT_Encode4(1048520), // Rule ID 19069 //
     /* 1048448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1048459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1048462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1048465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1048468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048487 */     // MIs[0] policy
     /* 1048487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048497 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11262:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1048500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048506 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048519 */     // GIR_Coverage, 19069,
     /* 1048519 */     GIR_EraseRootFromParent_Done,
     /* 1048520 */   // Label 15523: @1048520
     /* 1048520 */   GIM_Try, /*On fail goto*//*Label 15524*/ GIMT_Encode4(1048597), // Rule ID 19072 //
     /* 1048525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1048528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1048542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048564 */     // MIs[0] policy
     /* 1048564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048574 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1048577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1048593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048596 */     // GIR_Coverage, 19072,
     /* 1048596 */     GIR_EraseRootFromParent_Done,
     /* 1048597 */   // Label 15524: @1048597
     /* 1048597 */   GIM_Try, /*On fail goto*//*Label 15525*/ GIMT_Encode4(1048674), // Rule ID 19073 //
     /* 1048602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1048605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1048619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048641 */     // MIs[0] policy
     /* 1048641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048651 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11262:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1048654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1048670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048673 */     // GIR_Coverage, 19073,
     /* 1048673 */     GIR_EraseRootFromParent_Done,
     /* 1048674 */   // Label 15525: @1048674
     /* 1048674 */   GIM_Try, /*On fail goto*//*Label 15526*/ GIMT_Encode4(1048751), // Rule ID 19076 //
     /* 1048679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1048690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1048693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1048696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1048699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1048706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048718 */     // MIs[0] policy
     /* 1048718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048728 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1048731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048750 */     // GIR_Coverage, 19076,
     /* 1048750 */     GIR_EraseRootFromParent_Done,
     /* 1048751 */   // Label 15526: @1048751
     /* 1048751 */   GIM_Try, /*On fail goto*//*Label 15527*/ GIMT_Encode4(1048828), // Rule ID 19077 //
     /* 1048756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1048767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1048770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1048773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1048776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1048783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048795 */     // MIs[0] policy
     /* 1048795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048805 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1048808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048814 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048827 */     // GIR_Coverage, 19077,
     /* 1048827 */     GIR_EraseRootFromParent_Done,
     /* 1048828 */   // Label 15527: @1048828
     /* 1048828 */   GIM_Try, /*On fail goto*//*Label 15528*/ GIMT_Encode4(1048905), // Rule ID 19080 //
     /* 1048833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1048844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1048847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1048850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1048853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1048860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048872 */     // MIs[0] policy
     /* 1048872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048882 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1048885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048904 */     // GIR_Coverage, 19080,
     /* 1048904 */     GIR_EraseRootFromParent_Done,
     /* 1048905 */   // Label 15528: @1048905
     /* 1048905 */   GIM_Try, /*On fail goto*//*Label 15529*/ GIMT_Encode4(1048982), // Rule ID 19081 //
     /* 1048910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1048921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1048924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1048927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1048930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1048937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048949 */     // MIs[0] policy
     /* 1048949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048959 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1048962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048981 */     // GIR_Coverage, 19081,
     /* 1048981 */     GIR_EraseRootFromParent_Done,
     /* 1048982 */   // Label 15529: @1048982
     /* 1048982 */   GIM_Try, /*On fail goto*//*Label 15530*/ GIMT_Encode4(1049059), // Rule ID 19084 //
     /* 1048987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1048998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1049001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1049004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1049007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049026 */     // MIs[0] policy
     /* 1049026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049036 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1049039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049058 */     // GIR_Coverage, 19084,
     /* 1049058 */     GIR_EraseRootFromParent_Done,
     /* 1049059 */   // Label 15530: @1049059
     /* 1049059 */   GIM_Try, /*On fail goto*//*Label 15531*/ GIMT_Encode4(1049136), // Rule ID 19085 //
     /* 1049064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1049067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1049075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1049078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1049081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1049084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049103 */     // MIs[0] policy
     /* 1049103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049113 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1049116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049122 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049135 */     // GIR_Coverage, 19085,
     /* 1049135 */     GIR_EraseRootFromParent_Done,
     /* 1049136 */   // Label 15531: @1049136
     /* 1049136 */   GIM_Try, /*On fail goto*//*Label 15532*/ GIMT_Encode4(1049213), // Rule ID 19088 //
     /* 1049141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1049152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1049155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1049158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049180 */     // MIs[0] policy
     /* 1049180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049190 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1049193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049212 */     // GIR_Coverage, 19088,
     /* 1049212 */     GIR_EraseRootFromParent_Done,
     /* 1049213 */   // Label 15532: @1049213
     /* 1049213 */   GIM_Try, /*On fail goto*//*Label 15533*/ GIMT_Encode4(1049290), // Rule ID 19089 //
     /* 1049218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1049229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1049232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1049235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049257 */     // MIs[0] policy
     /* 1049257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049267 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1049270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049276 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049289 */     // GIR_Coverage, 19089,
     /* 1049289 */     GIR_EraseRootFromParent_Done,
     /* 1049290 */   // Label 15533: @1049290
     /* 1049290 */   GIM_Try, /*On fail goto*//*Label 15534*/ GIMT_Encode4(1049367), // Rule ID 19092 //
     /* 1049295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1049306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1049309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1049312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049334 */     // MIs[0] policy
     /* 1049334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049344 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1049347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049366 */     // GIR_Coverage, 19092,
     /* 1049366 */     GIR_EraseRootFromParent_Done,
     /* 1049367 */   // Label 15534: @1049367
     /* 1049367 */   GIM_Try, /*On fail goto*//*Label 15535*/ GIMT_Encode4(1049444), // Rule ID 19093 //
     /* 1049372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1049383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1049386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1049389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049411 */     // MIs[0] policy
     /* 1049411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049421 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1049424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049430 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049443 */     // GIR_Coverage, 19093,
     /* 1049443 */     GIR_EraseRootFromParent_Done,
     /* 1049444 */   // Label 15535: @1049444
     /* 1049444 */   GIM_Try, /*On fail goto*//*Label 15536*/ GIMT_Encode4(1049521), // Rule ID 19096 //
     /* 1049449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1049452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1049460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1049463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1049466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049488 */     // MIs[0] policy
     /* 1049488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049498 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1049501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049520 */     // GIR_Coverage, 19096,
     /* 1049520 */     GIR_EraseRootFromParent_Done,
     /* 1049521 */   // Label 15536: @1049521
     /* 1049521 */   GIM_Try, /*On fail goto*//*Label 15537*/ GIMT_Encode4(1049598), // Rule ID 19097 //
     /* 1049526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1049537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1049540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1049543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049565 */     // MIs[0] policy
     /* 1049565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049575 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1049578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049597 */     // GIR_Coverage, 19097,
     /* 1049597 */     GIR_EraseRootFromParent_Done,
     /* 1049598 */   // Label 15537: @1049598
     /* 1049598 */   GIM_Try, /*On fail goto*//*Label 15538*/ GIMT_Encode4(1049675), // Rule ID 19100 //
     /* 1049603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1049614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1049617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1049620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1049623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049642 */     // MIs[0] policy
     /* 1049642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049652 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1049655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049674 */     // GIR_Coverage, 19100,
     /* 1049674 */     GIR_EraseRootFromParent_Done,
     /* 1049675 */   // Label 15538: @1049675
     /* 1049675 */   GIM_Try, /*On fail goto*//*Label 15539*/ GIMT_Encode4(1049752), // Rule ID 19101 //
     /* 1049680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1049691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1049694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1049697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1049700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049719 */     // MIs[0] policy
     /* 1049719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049729 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11262:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1049732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049738 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049751 */     // GIR_Coverage, 19101,
     /* 1049751 */     GIR_EraseRootFromParent_Done,
     /* 1049752 */   // Label 15539: @1049752
     /* 1049752 */   GIM_Try, /*On fail goto*//*Label 15540*/ GIMT_Encode4(1049829), // Rule ID 19104 //
     /* 1049757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1049774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049796 */     // MIs[0] policy
     /* 1049796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049806 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1049809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049828 */     // GIR_Coverage, 19104,
     /* 1049828 */     GIR_EraseRootFromParent_Done,
     /* 1049829 */   // Label 15540: @1049829
     /* 1049829 */   GIM_Try, /*On fail goto*//*Label 15541*/ GIMT_Encode4(1049906), // Rule ID 19105 //
     /* 1049834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1049851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049873 */     // MIs[0] policy
     /* 1049873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049883 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11262:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1049886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049905 */     // GIR_Coverage, 19105,
     /* 1049905 */     GIR_EraseRootFromParent_Done,
     /* 1049906 */   // Label 15541: @1049906
     /* 1049906 */   GIM_Try, /*On fail goto*//*Label 15542*/ GIMT_Encode4(1049983), // Rule ID 19108 //
     /* 1049911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1049922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1049925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1049928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049950 */     // MIs[0] policy
     /* 1049950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049960 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1049963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049982 */     // GIR_Coverage, 19108,
     /* 1049982 */     GIR_EraseRootFromParent_Done,
     /* 1049983 */   // Label 15542: @1049983
     /* 1049983 */   GIM_Try, /*On fail goto*//*Label 15543*/ GIMT_Encode4(1050060), // Rule ID 19109 //
     /* 1049988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1049999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1050002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1050005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050027 */     // MIs[0] policy
     /* 1050027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050037 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11262:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1050040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050059 */     // GIR_Coverage, 19109,
     /* 1050059 */     GIR_EraseRootFromParent_Done,
     /* 1050060 */   // Label 15543: @1050060
     /* 1050060 */   GIM_Try, /*On fail goto*//*Label 15544*/ GIMT_Encode4(1050137), // Rule ID 20492 //
     /* 1050065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1050076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1050079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1050082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050104 */     // MIs[0] policy
     /* 1050104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050114 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050136 */     // GIR_Coverage, 20492,
     /* 1050136 */     GIR_EraseRootFromParent_Done,
     /* 1050137 */   // Label 15544: @1050137
     /* 1050137 */   GIM_Try, /*On fail goto*//*Label 15545*/ GIMT_Encode4(1050214), // Rule ID 20493 //
     /* 1050142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1050153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1050156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1050159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050181 */     // MIs[0] policy
     /* 1050181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050191 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050213 */     // GIR_Coverage, 20493,
     /* 1050213 */     GIR_EraseRootFromParent_Done,
     /* 1050214 */   // Label 15545: @1050214
     /* 1050214 */   GIM_Try, /*On fail goto*//*Label 15546*/ GIMT_Encode4(1050291), // Rule ID 20496 //
     /* 1050219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1050236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050258 */     // MIs[0] policy
     /* 1050258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050290 */     // GIR_Coverage, 20496,
     /* 1050290 */     GIR_EraseRootFromParent_Done,
     /* 1050291 */   // Label 15546: @1050291
     /* 1050291 */   GIM_Try, /*On fail goto*//*Label 15547*/ GIMT_Encode4(1050368), // Rule ID 20497 //
     /* 1050296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1050299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1050307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1050310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1050313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050335 */     // MIs[0] policy
     /* 1050335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050345 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1050348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050367 */     // GIR_Coverage, 20497,
     /* 1050367 */     GIR_EraseRootFromParent_Done,
     /* 1050368 */   // Label 15547: @1050368
     /* 1050368 */   GIM_Try, /*On fail goto*//*Label 15548*/ GIMT_Encode4(1050445), // Rule ID 20500 //
     /* 1050373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1050384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1050387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1050390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050412 */     // MIs[0] policy
     /* 1050412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050422 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050444 */     // GIR_Coverage, 20500,
     /* 1050444 */     GIR_EraseRootFromParent_Done,
     /* 1050445 */   // Label 15548: @1050445
     /* 1050445 */   GIM_Try, /*On fail goto*//*Label 15549*/ GIMT_Encode4(1050522), // Rule ID 20501 //
     /* 1050450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1050461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1050464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1050467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050489 */     // MIs[0] policy
     /* 1050489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050499 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050521 */     // GIR_Coverage, 20501,
     /* 1050521 */     GIR_EraseRootFromParent_Done,
     /* 1050522 */   // Label 15549: @1050522
     /* 1050522 */   GIM_Try, /*On fail goto*//*Label 15550*/ GIMT_Encode4(1050599), // Rule ID 20504 //
     /* 1050527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1050544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050566 */     // MIs[0] policy
     /* 1050566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050598 */     // GIR_Coverage, 20504,
     /* 1050598 */     GIR_EraseRootFromParent_Done,
     /* 1050599 */   // Label 15550: @1050599
     /* 1050599 */   GIM_Try, /*On fail goto*//*Label 15551*/ GIMT_Encode4(1050676), // Rule ID 20505 //
     /* 1050604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1050607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1050621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050643 */     // MIs[0] policy
     /* 1050643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050653 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050662 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050675 */     // GIR_Coverage, 20505,
     /* 1050675 */     GIR_EraseRootFromParent_Done,
     /* 1050676 */   // Label 15551: @1050676
     /* 1050676 */   GIM_Try, /*On fail goto*//*Label 15552*/ GIMT_Encode4(1050753), // Rule ID 20508 //
     /* 1050681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1050684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1050692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1050695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1050698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050720 */     // MIs[0] policy
     /* 1050720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050752 */     // GIR_Coverage, 20508,
     /* 1050752 */     GIR_EraseRootFromParent_Done,
     /* 1050753 */   // Label 15552: @1050753
     /* 1050753 */   GIM_Try, /*On fail goto*//*Label 15553*/ GIMT_Encode4(1050830), // Rule ID 20509 //
     /* 1050758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1050761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1050769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1050772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1050775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050797 */     // MIs[0] policy
     /* 1050797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050807 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050816 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050829 */     // GIR_Coverage, 20509,
     /* 1050829 */     GIR_EraseRootFromParent_Done,
     /* 1050830 */   // Label 15553: @1050830
     /* 1050830 */   GIM_Try, /*On fail goto*//*Label 15554*/ GIMT_Encode4(1050907), // Rule ID 20512 //
     /* 1050835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1050846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1050849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1050852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050874 */     // MIs[0] policy
     /* 1050874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1050887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050906 */     // GIR_Coverage, 20512,
     /* 1050906 */     GIR_EraseRootFromParent_Done,
     /* 1050907 */   // Label 15554: @1050907
     /* 1050907 */   GIM_Try, /*On fail goto*//*Label 15555*/ GIMT_Encode4(1050984), // Rule ID 20513 //
     /* 1050912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1050923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1050926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1050929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050951 */     // MIs[0] policy
     /* 1050951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050961 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1050964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050970 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050983 */     // GIR_Coverage, 20513,
     /* 1050983 */     GIR_EraseRootFromParent_Done,
     /* 1050984 */   // Label 15555: @1050984
     /* 1050984 */   GIM_Try, /*On fail goto*//*Label 15556*/ GIMT_Encode4(1051061), // Rule ID 20516 //
     /* 1050989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1051000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1051003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1051006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051028 */     // MIs[0] policy
     /* 1051028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051038 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051060 */     // GIR_Coverage, 20516,
     /* 1051060 */     GIR_EraseRootFromParent_Done,
     /* 1051061 */   // Label 15556: @1051061
     /* 1051061 */   GIM_Try, /*On fail goto*//*Label 15557*/ GIMT_Encode4(1051138), // Rule ID 20517 //
     /* 1051066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1051077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1051080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1051083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051105 */     // MIs[0] policy
     /* 1051105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051115 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051137 */     // GIR_Coverage, 20517,
     /* 1051137 */     GIR_EraseRootFromParent_Done,
     /* 1051138 */   // Label 15557: @1051138
     /* 1051138 */   GIM_Try, /*On fail goto*//*Label 15558*/ GIMT_Encode4(1051215), // Rule ID 20520 //
     /* 1051143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1051154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1051157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1051160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1051163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051182 */     // MIs[0] policy
     /* 1051182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051192 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051214 */     // GIR_Coverage, 20520,
     /* 1051214 */     GIR_EraseRootFromParent_Done,
     /* 1051215 */   // Label 15558: @1051215
     /* 1051215 */   GIM_Try, /*On fail goto*//*Label 15559*/ GIMT_Encode4(1051292), // Rule ID 20521 //
     /* 1051220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1051231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1051234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1051237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1051240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051259 */     // MIs[0] policy
     /* 1051259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051269 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051278 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051291 */     // GIR_Coverage, 20521,
     /* 1051291 */     GIR_EraseRootFromParent_Done,
     /* 1051292 */   // Label 15559: @1051292
     /* 1051292 */   GIM_Try, /*On fail goto*//*Label 15560*/ GIMT_Encode4(1051369), // Rule ID 20524 //
     /* 1051297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1051308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1051311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1051314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051336 */     // MIs[0] policy
     /* 1051336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051368 */     // GIR_Coverage, 20524,
     /* 1051368 */     GIR_EraseRootFromParent_Done,
     /* 1051369 */   // Label 15560: @1051369
     /* 1051369 */   GIM_Try, /*On fail goto*//*Label 15561*/ GIMT_Encode4(1051446), // Rule ID 20525 //
     /* 1051374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1051385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1051388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1051391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051413 */     // MIs[0] policy
     /* 1051413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051423 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051432 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051445 */     // GIR_Coverage, 20525,
     /* 1051445 */     GIR_EraseRootFromParent_Done,
     /* 1051446 */   // Label 15561: @1051446
     /* 1051446 */   GIM_Try, /*On fail goto*//*Label 15562*/ GIMT_Encode4(1051523), // Rule ID 20528 //
     /* 1051451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1051462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1051465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1051468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051490 */     // MIs[0] policy
     /* 1051490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051522 */     // GIR_Coverage, 20528,
     /* 1051522 */     GIR_EraseRootFromParent_Done,
     /* 1051523 */   // Label 15562: @1051523
     /* 1051523 */   GIM_Try, /*On fail goto*//*Label 15563*/ GIMT_Encode4(1051600), // Rule ID 20529 //
     /* 1051528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1051539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1051542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1051545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051567 */     // MIs[0] policy
     /* 1051567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051577 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051586 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051599 */     // GIR_Coverage, 20529,
     /* 1051599 */     GIR_EraseRootFromParent_Done,
     /* 1051600 */   // Label 15563: @1051600
     /* 1051600 */   GIM_Try, /*On fail goto*//*Label 15564*/ GIMT_Encode4(1051677), // Rule ID 20532 //
     /* 1051605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1051616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1051619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1051622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051644 */     // MIs[0] policy
     /* 1051644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051676 */     // GIR_Coverage, 20532,
     /* 1051676 */     GIR_EraseRootFromParent_Done,
     /* 1051677 */   // Label 15564: @1051677
     /* 1051677 */   GIM_Try, /*On fail goto*//*Label 15565*/ GIMT_Encode4(1051754), // Rule ID 20533 //
     /* 1051682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1051693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1051696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1051699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051721 */     // MIs[0] policy
     /* 1051721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051731 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051753 */     // GIR_Coverage, 20533,
     /* 1051753 */     GIR_EraseRootFromParent_Done,
     /* 1051754 */   // Label 15565: @1051754
     /* 1051754 */   GIM_Try, /*On fail goto*//*Label 15566*/ GIMT_Encode4(1051831), // Rule ID 20536 //
     /* 1051759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1051762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1051776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051798 */     // MIs[0] policy
     /* 1051798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051830 */     // GIR_Coverage, 20536,
     /* 1051830 */     GIR_EraseRootFromParent_Done,
     /* 1051831 */   // Label 15566: @1051831
     /* 1051831 */   GIM_Try, /*On fail goto*//*Label 15567*/ GIMT_Encode4(1051908), // Rule ID 20537 //
     /* 1051836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1051839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1051853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051875 */     // MIs[0] policy
     /* 1051875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051885 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11188:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051894 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051907 */     // GIR_Coverage, 20537,
     /* 1051907 */     GIR_EraseRootFromParent_Done,
     /* 1051908 */   // Label 15567: @1051908
     /* 1051908 */   GIM_Try, /*On fail goto*//*Label 15568*/ GIMT_Encode4(1051985), // Rule ID 20540 //
     /* 1051913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1051916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1051924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1051927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1051930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051952 */     // MIs[0] policy
     /* 1051952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051962 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051984 */     // GIR_Coverage, 20540,
     /* 1051984 */     GIR_EraseRootFromParent_Done,
     /* 1051985 */   // Label 15568: @1051985
     /* 1051985 */   GIM_Try, /*On fail goto*//*Label 15569*/ GIMT_Encode4(1052062), // Rule ID 20541 //
     /* 1051990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1051993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1052001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1052004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1052007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052029 */     // MIs[0] policy
     /* 1052029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052039 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11188:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1052042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052048 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052061 */     // GIR_Coverage, 20541,
     /* 1052061 */     GIR_EraseRootFromParent_Done,
     /* 1052062 */   // Label 15569: @1052062
     /* 1052062 */   GIM_Try, /*On fail goto*//*Label 15570*/ GIMT_Encode4(1052139), // Rule ID 20544 //
     /* 1052067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1052078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1052081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1052084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052106 */     // MIs[0] policy
     /* 1052106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052138 */     // GIR_Coverage, 20544,
     /* 1052138 */     GIR_EraseRootFromParent_Done,
     /* 1052139 */   // Label 15570: @1052139
     /* 1052139 */   GIM_Try, /*On fail goto*//*Label 15571*/ GIMT_Encode4(1052216), // Rule ID 20545 //
     /* 1052144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1052152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1052155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1052158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1052161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052183 */     // MIs[0] policy
     /* 1052183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052193 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11188:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1052196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052215 */     // GIR_Coverage, 20545,
     /* 1052215 */     GIR_EraseRootFromParent_Done,
     /* 1052216 */   // Label 15571: @1052216
     /* 1052216 */   GIM_Try, /*On fail goto*//*Label 15572*/ GIMT_Encode4(1052293), // Rule ID 20870 //
     /* 1052221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1052232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1052235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1052238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052260 */     // MIs[0] policy
     /* 1052260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052270 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1052273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052292 */     // GIR_Coverage, 20870,
     /* 1052292 */     GIR_EraseRootFromParent_Done,
     /* 1052293 */   // Label 15572: @1052293
     /* 1052293 */   GIM_Try, /*On fail goto*//*Label 15573*/ GIMT_Encode4(1052370), // Rule ID 20871 //
     /* 1052298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1052309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1052312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1052315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052337 */     // MIs[0] policy
     /* 1052337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052347 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1052350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052369 */     // GIR_Coverage, 20871,
     /* 1052369 */     GIR_EraseRootFromParent_Done,
     /* 1052370 */   // Label 15573: @1052370
     /* 1052370 */   GIM_Try, /*On fail goto*//*Label 15574*/ GIMT_Encode4(1052447), // Rule ID 20874 //
     /* 1052375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1052386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1052389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1052392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052414 */     // MIs[0] policy
     /* 1052414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052424 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052446 */     // GIR_Coverage, 20874,
     /* 1052446 */     GIR_EraseRootFromParent_Done,
     /* 1052447 */   // Label 15574: @1052447
     /* 1052447 */   GIM_Try, /*On fail goto*//*Label 15575*/ GIMT_Encode4(1052524), // Rule ID 20875 //
     /* 1052452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1052463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1052466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1052469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052491 */     // MIs[0] policy
     /* 1052491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052501 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052523 */     // GIR_Coverage, 20875,
     /* 1052523 */     GIR_EraseRootFromParent_Done,
     /* 1052524 */   // Label 15575: @1052524
     /* 1052524 */   GIM_Try, /*On fail goto*//*Label 15576*/ GIMT_Encode4(1052601), // Rule ID 20878 //
     /* 1052529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1052532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1052540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1052543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052568 */     // MIs[0] policy
     /* 1052568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052578 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052600 */     // GIR_Coverage, 20878,
     /* 1052600 */     GIR_EraseRootFromParent_Done,
     /* 1052601 */   // Label 15576: @1052601
     /* 1052601 */   GIM_Try, /*On fail goto*//*Label 15577*/ GIMT_Encode4(1052678), // Rule ID 20879 //
     /* 1052606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1052609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1052617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1052620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052645 */     // MIs[0] policy
     /* 1052645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052655 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052664 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052677 */     // GIR_Coverage, 20879,
     /* 1052677 */     GIR_EraseRootFromParent_Done,
     /* 1052678 */   // Label 15577: @1052678
     /* 1052678 */   GIM_Try, /*On fail goto*//*Label 15578*/ GIMT_Encode4(1052755), // Rule ID 20882 //
     /* 1052683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052722 */     // MIs[0] policy
     /* 1052722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052754 */     // GIR_Coverage, 20882,
     /* 1052754 */     GIR_EraseRootFromParent_Done,
     /* 1052755 */   // Label 15578: @1052755
     /* 1052755 */   GIM_Try, /*On fail goto*//*Label 15579*/ GIMT_Encode4(1052832), // Rule ID 20883 //
     /* 1052760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052799 */     // MIs[0] policy
     /* 1052799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052809 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052818 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052831 */     // GIR_Coverage, 20883,
     /* 1052831 */     GIR_EraseRootFromParent_Done,
     /* 1052832 */   // Label 15579: @1052832
     /* 1052832 */   GIM_Try, /*On fail goto*//*Label 15580*/ GIMT_Encode4(1052909), // Rule ID 20886 //
     /* 1052837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1052840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052876 */     // MIs[0] policy
     /* 1052876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052908 */     // GIR_Coverage, 20886,
     /* 1052908 */     GIR_EraseRootFromParent_Done,
     /* 1052909 */   // Label 15580: @1052909
     /* 1052909 */   GIM_Try, /*On fail goto*//*Label 15581*/ GIMT_Encode4(1052986), // Rule ID 20887 //
     /* 1052914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1052917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052953 */     // MIs[0] policy
     /* 1052953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052963 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052985 */     // GIR_Coverage, 20887,
     /* 1052985 */     GIR_EraseRootFromParent_Done,
     /* 1052986 */   // Label 15581: @1052986
     /* 1052986 */   GIM_Try, /*On fail goto*//*Label 15582*/ GIMT_Encode4(1053063), // Rule ID 20890 //
     /* 1052991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1053002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1053005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1053008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053030 */     // MIs[0] policy
     /* 1053030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053062 */     // GIR_Coverage, 20890,
     /* 1053062 */     GIR_EraseRootFromParent_Done,
     /* 1053063 */   // Label 15582: @1053063
     /* 1053063 */   GIM_Try, /*On fail goto*//*Label 15583*/ GIMT_Encode4(1053140), // Rule ID 20891 //
     /* 1053068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1053071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1053079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1053082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1053085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1053088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1053095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1053103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053107 */     // MIs[0] policy
     /* 1053107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053117 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1053120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053126 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053139 */     // GIR_Coverage, 20891,
     /* 1053139 */     GIR_EraseRootFromParent_Done,
     /* 1053140 */   // Label 15583: @1053140
     /* 1053140 */   GIM_Try, /*On fail goto*//*Label 15584*/ GIMT_Encode4(1053217), // Rule ID 20894 //
     /* 1053145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053184 */     // MIs[0] policy
     /* 1053184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053216 */     // GIR_Coverage, 20894,
     /* 1053216 */     GIR_EraseRootFromParent_Done,
     /* 1053217 */   // Label 15584: @1053217
     /* 1053217 */   GIM_Try, /*On fail goto*//*Label 15585*/ GIMT_Encode4(1053294), // Rule ID 20895 //
     /* 1053222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1053233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1053236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1053239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053261 */     // MIs[0] policy
     /* 1053261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053271 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053280 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053293 */     // GIR_Coverage, 20895,
     /* 1053293 */     GIR_EraseRootFromParent_Done,
     /* 1053294 */   // Label 15585: @1053294
     /* 1053294 */   GIM_Try, /*On fail goto*//*Label 15586*/ GIMT_Encode4(1053371), // Rule ID 20898 //
     /* 1053299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053338 */     // MIs[0] policy
     /* 1053338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053370 */     // GIR_Coverage, 20898,
     /* 1053370 */     GIR_EraseRootFromParent_Done,
     /* 1053371 */   // Label 15586: @1053371
     /* 1053371 */   GIM_Try, /*On fail goto*//*Label 15587*/ GIMT_Encode4(1053448), // Rule ID 20899 //
     /* 1053376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1053387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1053390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1053393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053415 */     // MIs[0] policy
     /* 1053415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053425 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053447 */     // GIR_Coverage, 20899,
     /* 1053447 */     GIR_EraseRootFromParent_Done,
     /* 1053448 */   // Label 15587: @1053448
     /* 1053448 */   GIM_Try, /*On fail goto*//*Label 15588*/ GIMT_Encode4(1053525), // Rule ID 20902 //
     /* 1053453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1053456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1053464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1053467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1053470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1053473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053492 */     // MIs[0] policy
     /* 1053492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053524 */     // GIR_Coverage, 20902,
     /* 1053524 */     GIR_EraseRootFromParent_Done,
     /* 1053525 */   // Label 15588: @1053525
     /* 1053525 */   GIM_Try, /*On fail goto*//*Label 15589*/ GIMT_Encode4(1053602), // Rule ID 20903 //
     /* 1053530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1053541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1053544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1053547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1053550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053569 */     // MIs[0] policy
     /* 1053569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053579 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053601 */     // GIR_Coverage, 20903,
     /* 1053601 */     GIR_EraseRootFromParent_Done,
     /* 1053602 */   // Label 15589: @1053602
     /* 1053602 */   GIM_Try, /*On fail goto*//*Label 15590*/ GIMT_Encode4(1053679), // Rule ID 20906 //
     /* 1053607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053646 */     // MIs[0] policy
     /* 1053646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053678 */     // GIR_Coverage, 20906,
     /* 1053678 */     GIR_EraseRootFromParent_Done,
     /* 1053679 */   // Label 15590: @1053679
     /* 1053679 */   GIM_Try, /*On fail goto*//*Label 15591*/ GIMT_Encode4(1053756), // Rule ID 20907 //
     /* 1053684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053723 */     // MIs[0] policy
     /* 1053723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053733 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053755 */     // GIR_Coverage, 20907,
     /* 1053755 */     GIR_EraseRootFromParent_Done,
     /* 1053756 */   // Label 15591: @1053756
     /* 1053756 */   GIM_Try, /*On fail goto*//*Label 15592*/ GIMT_Encode4(1053833), // Rule ID 20910 //
     /* 1053761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053800 */     // MIs[0] policy
     /* 1053800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053810 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053832 */     // GIR_Coverage, 20910,
     /* 1053832 */     GIR_EraseRootFromParent_Done,
     /* 1053833 */   // Label 15592: @1053833
     /* 1053833 */   GIM_Try, /*On fail goto*//*Label 15593*/ GIMT_Encode4(1053910), // Rule ID 20911 //
     /* 1053838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053877 */     // MIs[0] policy
     /* 1053877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053887 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053909 */     // GIR_Coverage, 20911,
     /* 1053909 */     GIR_EraseRootFromParent_Done,
     /* 1053910 */   // Label 15593: @1053910
     /* 1053910 */   GIM_Try, /*On fail goto*//*Label 15594*/ GIMT_Encode4(1053987), // Rule ID 20914 //
     /* 1053915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1053926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1053929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1053932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053954 */     // MIs[0] policy
     /* 1053954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053964 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053986 */     // GIR_Coverage, 20914,
     /* 1053986 */     GIR_EraseRootFromParent_Done,
     /* 1053987 */   // Label 15594: @1053987
     /* 1053987 */   GIM_Try, /*On fail goto*//*Label 15595*/ GIMT_Encode4(1054064), // Rule ID 20915 //
     /* 1053992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1054003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1054006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1054009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1054012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054031 */     // MIs[0] policy
     /* 1054031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054041 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054050 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054063 */     // GIR_Coverage, 20915,
     /* 1054063 */     GIR_EraseRootFromParent_Done,
     /* 1054064 */   // Label 15595: @1054064
     /* 1054064 */   GIM_Try, /*On fail goto*//*Label 15596*/ GIMT_Encode4(1054141), // Rule ID 20918 //
     /* 1054069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054108 */     // MIs[0] policy
     /* 1054108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054140 */     // GIR_Coverage, 20918,
     /* 1054140 */     GIR_EraseRootFromParent_Done,
     /* 1054141 */   // Label 15596: @1054141
     /* 1054141 */   GIM_Try, /*On fail goto*//*Label 15597*/ GIMT_Encode4(1054218), // Rule ID 20919 //
     /* 1054146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1054157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1054160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1054163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054185 */     // MIs[0] policy
     /* 1054185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054195 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1054198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054217 */     // GIR_Coverage, 20919,
     /* 1054217 */     GIR_EraseRootFromParent_Done,
     /* 1054218 */   // Label 15597: @1054218
     /* 1054218 */   GIM_Try, /*On fail goto*//*Label 15598*/ GIMT_Encode4(1054295), // Rule ID 20922 //
     /* 1054223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054262 */     // MIs[0] policy
     /* 1054262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054272 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054294 */     // GIR_Coverage, 20922,
     /* 1054294 */     GIR_EraseRootFromParent_Done,
     /* 1054295 */   // Label 15598: @1054295
     /* 1054295 */   GIM_Try, /*On fail goto*//*Label 15599*/ GIMT_Encode4(1054372), // Rule ID 20923 //
     /* 1054300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1054311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1054314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1054317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1054327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1054335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054339 */     // MIs[0] policy
     /* 1054339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054349 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1054352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054371 */     // GIR_Coverage, 20923,
     /* 1054371 */     GIR_EraseRootFromParent_Done,
     /* 1054372 */   // Label 15599: @1054372
     /* 1054372 */   GIM_Try, /*On fail goto*//*Label 15600*/ GIMT_Encode4(1054449), // Rule ID 20926 //
     /* 1054377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054416 */     // MIs[0] policy
     /* 1054416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054448 */     // GIR_Coverage, 20926,
     /* 1054448 */     GIR_EraseRootFromParent_Done,
     /* 1054449 */   // Label 15600: @1054449
     /* 1054449 */   GIM_Try, /*On fail goto*//*Label 15601*/ GIMT_Encode4(1054526), // Rule ID 20927 //
     /* 1054454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1054462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1054465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1054468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1054471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1054481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1054489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054493 */     // MIs[0] policy
     /* 1054493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054503 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1054506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054525 */     // GIR_Coverage, 20927,
     /* 1054525 */     GIR_EraseRootFromParent_Done,
     /* 1054526 */   // Label 15601: @1054526
     /* 1054526 */   GIM_Try, /*On fail goto*//*Label 15602*/ GIMT_Encode4(1054603), // Rule ID 20930 //
     /* 1054531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1054542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1054545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1054548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054570 */     // MIs[0] policy
     /* 1054570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054580 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1054583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054602 */     // GIR_Coverage, 20930,
     /* 1054602 */     GIR_EraseRootFromParent_Done,
     /* 1054603 */   // Label 15602: @1054603
     /* 1054603 */   GIM_Try, /*On fail goto*//*Label 15603*/ GIMT_Encode4(1054680), // Rule ID 20931 //
     /* 1054608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1054619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1054622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1054625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054647 */     // MIs[0] policy
     /* 1054647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054657 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1054660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054679 */     // GIR_Coverage, 20931,
     /* 1054679 */     GIR_EraseRootFromParent_Done,
     /* 1054680 */   // Label 15603: @1054680
     /* 1054680 */   GIM_Try, /*On fail goto*//*Label 15604*/ GIMT_Encode4(1054757), // Rule ID 20934 //
     /* 1054685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1054696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1054699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1054702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054724 */     // MIs[0] policy
     /* 1054724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054756 */     // GIR_Coverage, 20934,
     /* 1054756 */     GIR_EraseRootFromParent_Done,
     /* 1054757 */   // Label 15604: @1054757
     /* 1054757 */   GIM_Try, /*On fail goto*//*Label 15605*/ GIMT_Encode4(1054834), // Rule ID 20935 //
     /* 1054762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1054773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1054776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1054779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054801 */     // MIs[0] policy
     /* 1054801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054811 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054833 */     // GIR_Coverage, 20935,
     /* 1054833 */     GIR_EraseRootFromParent_Done,
     /* 1054834 */   // Label 15605: @1054834
     /* 1054834 */   GIM_Try, /*On fail goto*//*Label 15606*/ GIMT_Encode4(1054911), // Rule ID 20938 //
     /* 1054839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054878 */     // MIs[0] policy
     /* 1054878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054910 */     // GIR_Coverage, 20938,
     /* 1054910 */     GIR_EraseRootFromParent_Done,
     /* 1054911 */   // Label 15606: @1054911
     /* 1054911 */   GIM_Try, /*On fail goto*//*Label 15607*/ GIMT_Encode4(1054988), // Rule ID 20939 //
     /* 1054916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054955 */     // MIs[0] policy
     /* 1054955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054965 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054987 */     // GIR_Coverage, 20939,
     /* 1054987 */     GIR_EraseRootFromParent_Done,
     /* 1054988 */   // Label 15607: @1054988
     /* 1054988 */   GIM_Try, /*On fail goto*//*Label 15608*/ GIMT_Encode4(1055065), // Rule ID 20942 //
     /* 1054993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055032 */     // MIs[0] policy
     /* 1055032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055042 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055064 */     // GIR_Coverage, 20942,
     /* 1055064 */     GIR_EraseRootFromParent_Done,
     /* 1055065 */   // Label 15608: @1055065
     /* 1055065 */   GIM_Try, /*On fail goto*//*Label 15609*/ GIMT_Encode4(1055142), // Rule ID 20943 //
     /* 1055070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1055081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1055084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1055087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055109 */     // MIs[0] policy
     /* 1055109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055119 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055128 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055141 */     // GIR_Coverage, 20943,
     /* 1055141 */     GIR_EraseRootFromParent_Done,
     /* 1055142 */   // Label 15609: @1055142
     /* 1055142 */   GIM_Try, /*On fail goto*//*Label 15610*/ GIMT_Encode4(1055219), // Rule ID 20946 //
     /* 1055147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1055158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1055161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1055164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055186 */     // MIs[0] policy
     /* 1055186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055218 */     // GIR_Coverage, 20946,
     /* 1055218 */     GIR_EraseRootFromParent_Done,
     /* 1055219 */   // Label 15610: @1055219
     /* 1055219 */   GIM_Try, /*On fail goto*//*Label 15611*/ GIMT_Encode4(1055296), // Rule ID 20947 //
     /* 1055224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1055235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1055238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1055241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055263 */     // MIs[0] policy
     /* 1055263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055273 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055295 */     // GIR_Coverage, 20947,
     /* 1055295 */     GIR_EraseRootFromParent_Done,
     /* 1055296 */   // Label 15611: @1055296
     /* 1055296 */   GIM_Try, /*On fail goto*//*Label 15612*/ GIMT_Encode4(1055373), // Rule ID 20950 //
     /* 1055301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1055312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1055315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1055318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055340 */     // MIs[0] policy
     /* 1055340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055350 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055372 */     // GIR_Coverage, 20950,
     /* 1055372 */     GIR_EraseRootFromParent_Done,
     /* 1055373 */   // Label 15612: @1055373
     /* 1055373 */   GIM_Try, /*On fail goto*//*Label 15613*/ GIMT_Encode4(1055450), // Rule ID 20951 //
     /* 1055378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1055389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1055392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1055395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1055398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1055405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1055413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055417 */     // MIs[0] policy
     /* 1055417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055427 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1055430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055449 */     // GIR_Coverage, 20951,
     /* 1055449 */     GIR_EraseRootFromParent_Done,
     /* 1055450 */   // Label 15613: @1055450
     /* 1055450 */   GIM_Try, /*On fail goto*//*Label 15614*/ GIMT_Encode4(1055527), // Rule ID 20954 //
     /* 1055455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1055466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1055469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1055472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055494 */     // MIs[0] policy
     /* 1055494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055526 */     // GIR_Coverage, 20954,
     /* 1055526 */     GIR_EraseRootFromParent_Done,
     /* 1055527 */   // Label 15614: @1055527
     /* 1055527 */   GIM_Try, /*On fail goto*//*Label 15615*/ GIMT_Encode4(1055604), // Rule ID 20955 //
     /* 1055532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1055543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1055546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1055549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055571 */     // MIs[0] policy
     /* 1055571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055590 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055603 */     // GIR_Coverage, 20955,
     /* 1055603 */     GIR_EraseRootFromParent_Done,
     /* 1055604 */   // Label 15615: @1055604
     /* 1055604 */   GIM_Try, /*On fail goto*//*Label 15616*/ GIMT_Encode4(1055681), // Rule ID 20958 //
     /* 1055609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1055620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1055623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1055626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055648 */     // MIs[0] policy
     /* 1055648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1055661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055680 */     // GIR_Coverage, 20958,
     /* 1055680 */     GIR_EraseRootFromParent_Done,
     /* 1055681 */   // Label 15616: @1055681
     /* 1055681 */   GIM_Try, /*On fail goto*//*Label 15617*/ GIMT_Encode4(1055758), // Rule ID 20959 //
     /* 1055686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1055697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1055700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1055703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055725 */     // MIs[0] policy
     /* 1055725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055735 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1055738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055757 */     // GIR_Coverage, 20959,
     /* 1055757 */     GIR_EraseRootFromParent_Done,
     /* 1055758 */   // Label 15617: @1055758
     /* 1055758 */   GIM_Try, /*On fail goto*//*Label 15618*/ GIMT_Encode4(1055835), // Rule ID 20962 //
     /* 1055763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1055774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055802 */     // MIs[0] policy
     /* 1055802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055812 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1055815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055834 */     // GIR_Coverage, 20962,
     /* 1055834 */     GIR_EraseRootFromParent_Done,
     /* 1055835 */   // Label 15618: @1055835
     /* 1055835 */   GIM_Try, /*On fail goto*//*Label 15619*/ GIMT_Encode4(1055912), // Rule ID 20963 //
     /* 1055840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1055851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055879 */     // MIs[0] policy
     /* 1055879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055889 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1055892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055898 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055911 */     // GIR_Coverage, 20963,
     /* 1055911 */     GIR_EraseRootFromParent_Done,
     /* 1055912 */   // Label 15619: @1055912
     /* 1055912 */   GIM_Try, /*On fail goto*//*Label 15620*/ GIMT_Encode4(1055989), // Rule ID 20966 //
     /* 1055917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1055928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1055931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1055934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055956 */     // MIs[0] policy
     /* 1055956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055988 */     // GIR_Coverage, 20966,
     /* 1055988 */     GIR_EraseRootFromParent_Done,
     /* 1055989 */   // Label 15620: @1055989
     /* 1055989 */   GIM_Try, /*On fail goto*//*Label 15621*/ GIMT_Encode4(1056066), // Rule ID 20967 //
     /* 1055994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1056005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1056008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1056011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056033 */     // MIs[0] policy
     /* 1056033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056065 */     // GIR_Coverage, 20967,
     /* 1056065 */     GIR_EraseRootFromParent_Done,
     /* 1056066 */   // Label 15621: @1056066
     /* 1056066 */   GIM_Try, /*On fail goto*//*Label 15622*/ GIMT_Encode4(1056143), // Rule ID 20970 //
     /* 1056071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1056088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056110 */     // MIs[0] policy
     /* 1056110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056120 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056142 */     // GIR_Coverage, 20970,
     /* 1056142 */     GIR_EraseRootFromParent_Done,
     /* 1056143 */   // Label 15622: @1056143
     /* 1056143 */   GIM_Try, /*On fail goto*//*Label 15623*/ GIMT_Encode4(1056220), // Rule ID 20971 //
     /* 1056148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1056165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056187 */     // MIs[0] policy
     /* 1056187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056197 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056219 */     // GIR_Coverage, 20971,
     /* 1056219 */     GIR_EraseRootFromParent_Done,
     /* 1056220 */   // Label 15623: @1056220
     /* 1056220 */   GIM_Try, /*On fail goto*//*Label 15624*/ GIMT_Encode4(1056297), // Rule ID 20974 //
     /* 1056225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1056228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1056236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1056239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1056242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056264 */     // MIs[0] policy
     /* 1056264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056296 */     // GIR_Coverage, 20974,
     /* 1056296 */     GIR_EraseRootFromParent_Done,
     /* 1056297 */   // Label 15624: @1056297
     /* 1056297 */   GIM_Try, /*On fail goto*//*Label 15625*/ GIMT_Encode4(1056374), // Rule ID 20975 //
     /* 1056302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1056305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1056313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1056316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1056319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056341 */     // MIs[0] policy
     /* 1056341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056351 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1056370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056373 */     // GIR_Coverage, 20975,
     /* 1056373 */     GIR_EraseRootFromParent_Done,
     /* 1056374 */   // Label 15625: @1056374
     /* 1056374 */   GIM_Try, /*On fail goto*//*Label 15626*/ GIMT_Encode4(1056451), // Rule ID 20978 //
     /* 1056379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1056390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1056393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1056396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056418 */     // MIs[0] policy
     /* 1056418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056450 */     // GIR_Coverage, 20978,
     /* 1056450 */     GIR_EraseRootFromParent_Done,
     /* 1056451 */   // Label 15626: @1056451
     /* 1056451 */   GIM_Try, /*On fail goto*//*Label 15627*/ GIMT_Encode4(1056528), // Rule ID 20979 //
     /* 1056456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1056467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1056470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1056473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056495 */     // MIs[0] policy
     /* 1056495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056527 */     // GIR_Coverage, 20979,
     /* 1056527 */     GIR_EraseRootFromParent_Done,
     /* 1056528 */   // Label 15627: @1056528
     /* 1056528 */   GIM_Try, /*On fail goto*//*Label 15628*/ GIMT_Encode4(1056605), // Rule ID 20982 //
     /* 1056533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1056544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1056547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1056550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056572 */     // MIs[0] policy
     /* 1056572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056582 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056604 */     // GIR_Coverage, 20982,
     /* 1056604 */     GIR_EraseRootFromParent_Done,
     /* 1056605 */   // Label 15628: @1056605
     /* 1056605 */   GIM_Try, /*On fail goto*//*Label 15629*/ GIMT_Encode4(1056682), // Rule ID 20983 //
     /* 1056610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1056621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1056624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1056627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056649 */     // MIs[0] policy
     /* 1056649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056659 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056681 */     // GIR_Coverage, 20983,
     /* 1056681 */     GIR_EraseRootFromParent_Done,
     /* 1056682 */   // Label 15629: @1056682
     /* 1056682 */   GIM_Try, /*On fail goto*//*Label 15630*/ GIMT_Encode4(1056759), // Rule ID 20986 //
     /* 1056687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1056698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1056701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1056704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056726 */     // MIs[0] policy
     /* 1056726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056736 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056758 */     // GIR_Coverage, 20986,
     /* 1056758 */     GIR_EraseRootFromParent_Done,
     /* 1056759 */   // Label 15630: @1056759
     /* 1056759 */   GIM_Try, /*On fail goto*//*Label 15631*/ GIMT_Encode4(1056836), // Rule ID 20987 //
     /* 1056764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1056775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1056778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1056781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056803 */     // MIs[0] policy
     /* 1056803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056813 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056835 */     // GIR_Coverage, 20987,
     /* 1056835 */     GIR_EraseRootFromParent_Done,
     /* 1056836 */   // Label 15631: @1056836
     /* 1056836 */   GIM_Try, /*On fail goto*//*Label 15632*/ GIMT_Encode4(1056913), // Rule ID 21254 //
     /* 1056841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056880 */     // MIs[0] policy
     /* 1056880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056912 */     // GIR_Coverage, 21254,
     /* 1056912 */     GIR_EraseRootFromParent_Done,
     /* 1056913 */   // Label 15632: @1056913
     /* 1056913 */   GIM_Try, /*On fail goto*//*Label 15633*/ GIMT_Encode4(1056990), // Rule ID 21255 //
     /* 1056918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056957 */     // MIs[0] policy
     /* 1056957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056967 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056976 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056989 */     // GIR_Coverage, 21255,
     /* 1056989 */     GIR_EraseRootFromParent_Done,
     /* 1056990 */   // Label 15633: @1056990
     /* 1056990 */   GIM_Try, /*On fail goto*//*Label 15634*/ GIMT_Encode4(1057067), // Rule ID 21258 //
     /* 1056995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057034 */     // MIs[0] policy
     /* 1057034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057066 */     // GIR_Coverage, 21258,
     /* 1057066 */     GIR_EraseRootFromParent_Done,
     /* 1057067 */   // Label 15634: @1057067
     /* 1057067 */   GIM_Try, /*On fail goto*//*Label 15635*/ GIMT_Encode4(1057144), // Rule ID 21259 //
     /* 1057072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057111 */     // MIs[0] policy
     /* 1057111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057121 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11292:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057130 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057143 */     // GIR_Coverage, 21259,
     /* 1057143 */     GIR_EraseRootFromParent_Done,
     /* 1057144 */   // Label 15635: @1057144
     /* 1057144 */   GIM_Try, /*On fail goto*//*Label 15636*/ GIMT_Encode4(1057221), // Rule ID 21262 //
     /* 1057149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1057166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057188 */     // MIs[0] policy
     /* 1057188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057220 */     // GIR_Coverage, 21262,
     /* 1057220 */     GIR_EraseRootFromParent_Done,
     /* 1057221 */   // Label 15636: @1057221
     /* 1057221 */   GIM_Try, /*On fail goto*//*Label 15637*/ GIMT_Encode4(1057298), // Rule ID 21263 //
     /* 1057226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1057237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1057240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1057243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057265 */     // MIs[0] policy
     /* 1057265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057297 */     // GIR_Coverage, 21263,
     /* 1057297 */     GIR_EraseRootFromParent_Done,
     /* 1057298 */   // Label 15637: @1057298
     /* 1057298 */   GIM_Try, /*On fail goto*//*Label 15638*/ GIMT_Encode4(1057375), // Rule ID 21266 //
     /* 1057303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057342 */     // MIs[0] policy
     /* 1057342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057352 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057374 */     // GIR_Coverage, 21266,
     /* 1057374 */     GIR_EraseRootFromParent_Done,
     /* 1057375 */   // Label 15638: @1057375
     /* 1057375 */   GIM_Try, /*On fail goto*//*Label 15639*/ GIMT_Encode4(1057452), // Rule ID 21267 //
     /* 1057380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1057391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1057394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1057397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057419 */     // MIs[0] policy
     /* 1057419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057429 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057451 */     // GIR_Coverage, 21267,
     /* 1057451 */     GIR_EraseRootFromParent_Done,
     /* 1057452 */   // Label 15639: @1057452
     /* 1057452 */   GIM_Try, /*On fail goto*//*Label 15640*/ GIMT_Encode4(1057529), // Rule ID 21270 //
     /* 1057457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057496 */     // MIs[0] policy
     /* 1057496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057528 */     // GIR_Coverage, 21270,
     /* 1057528 */     GIR_EraseRootFromParent_Done,
     /* 1057529 */   // Label 15640: @1057529
     /* 1057529 */   GIM_Try, /*On fail goto*//*Label 15641*/ GIMT_Encode4(1057606), // Rule ID 21271 //
     /* 1057534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057573 */     // MIs[0] policy
     /* 1057573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057583 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057592 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057605 */     // GIR_Coverage, 21271,
     /* 1057605 */     GIR_EraseRootFromParent_Done,
     /* 1057606 */   // Label 15641: @1057606
     /* 1057606 */   GIM_Try, /*On fail goto*//*Label 15642*/ GIMT_Encode4(1057683), // Rule ID 21274 //
     /* 1057611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1057622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1057625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1057628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057650 */     // MIs[0] policy
     /* 1057650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057682 */     // GIR_Coverage, 21274,
     /* 1057682 */     GIR_EraseRootFromParent_Done,
     /* 1057683 */   // Label 15642: @1057683
     /* 1057683 */   GIM_Try, /*On fail goto*//*Label 15643*/ GIMT_Encode4(1057760), // Rule ID 21275 //
     /* 1057688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1057691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1057699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1057702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1057705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057727 */     // MIs[0] policy
     /* 1057727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057737 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11292:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057759 */     // GIR_Coverage, 21275,
     /* 1057759 */     GIR_EraseRootFromParent_Done,
     /* 1057760 */   // Label 15643: @1057760
     /* 1057760 */   GIM_Try, /*On fail goto*//*Label 15644*/ GIMT_Encode4(1057837), // Rule ID 21278 //
     /* 1057765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1057782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057804 */     // MIs[0] policy
     /* 1057804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057836 */     // GIR_Coverage, 21278,
     /* 1057836 */     GIR_EraseRootFromParent_Done,
     /* 1057837 */   // Label 15644: @1057837
     /* 1057837 */   GIM_Try, /*On fail goto*//*Label 15645*/ GIMT_Encode4(1057914), // Rule ID 21279 //
     /* 1057842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1057845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1057859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057881 */     // MIs[0] policy
     /* 1057881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11292:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057913 */     // GIR_Coverage, 21279,
     /* 1057913 */     GIR_EraseRootFromParent_Done,
     /* 1057914 */   // Label 15645: @1057914
     /* 1057914 */   GIM_Try, /*On fail goto*//*Label 15646*/ GIMT_Encode4(1057991), // Rule ID 21282 //
     /* 1057919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1057933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057958 */     // MIs[0] policy
     /* 1057958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057968 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057990 */     // GIR_Coverage, 21282,
     /* 1057990 */     GIR_EraseRootFromParent_Done,
     /* 1057991 */   // Label 15646: @1057991
     /* 1057991 */   GIM_Try, /*On fail goto*//*Label 15647*/ GIMT_Encode4(1058068), // Rule ID 21283 //
     /* 1057996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1057999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1058013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058035 */     // MIs[0] policy
     /* 1058035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058045 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11292:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1058048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058054 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058067 */     // GIR_Coverage, 21283,
     /* 1058067 */     GIR_EraseRootFromParent_Done,
     /* 1058068 */   // Label 15647: @1058068
     /* 1058068 */   GIM_Try, /*On fail goto*//*Label 15648*/ GIMT_Encode4(1058145), // Rule ID 21286 //
     /* 1058073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1058090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058112 */     // MIs[0] policy
     /* 1058112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058144 */     // GIR_Coverage, 21286,
     /* 1058144 */     GIR_EraseRootFromParent_Done,
     /* 1058145 */   // Label 15648: @1058145
     /* 1058145 */   GIM_Try, /*On fail goto*//*Label 15649*/ GIMT_Encode4(1058222), // Rule ID 21287 //
     /* 1058150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1058158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1058167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058189 */     // MIs[0] policy
     /* 1058189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058199 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11292:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1058202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058221 */     // GIR_Coverage, 21287,
     /* 1058221 */     GIR_EraseRootFromParent_Done,
     /* 1058222 */   // Label 15649: @1058222
     /* 1058222 */   GIM_Try, /*On fail goto*//*Label 15650*/ GIMT_Encode4(1058299), // Rule ID 21290 //
     /* 1058227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058266 */     // MIs[0] policy
     /* 1058266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058298 */     // GIR_Coverage, 21290,
     /* 1058298 */     GIR_EraseRootFromParent_Done,
     /* 1058299 */   // Label 15650: @1058299
     /* 1058299 */   GIM_Try, /*On fail goto*//*Label 15651*/ GIMT_Encode4(1058376), // Rule ID 21291 //
     /* 1058304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1058315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1058318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1058321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058343 */     // MIs[0] policy
     /* 1058343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058353 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1058356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058375 */     // GIR_Coverage, 21291,
     /* 1058375 */     GIR_EraseRootFromParent_Done,
     /* 1058376 */   // Label 15651: @1058376
     /* 1058376 */   GIM_Try, /*On fail goto*//*Label 15652*/ GIMT_Encode4(1058453), // Rule ID 21294 //
     /* 1058381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1058392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1058395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058420 */     // MIs[0] policy
     /* 1058420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058430 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058452 */     // GIR_Coverage, 21294,
     /* 1058452 */     GIR_EraseRootFromParent_Done,
     /* 1058453 */   // Label 15652: @1058453
     /* 1058453 */   GIM_Try, /*On fail goto*//*Label 15653*/ GIMT_Encode4(1058530), // Rule ID 21295 //
     /* 1058458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1058469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1058472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1058475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058497 */     // MIs[0] policy
     /* 1058497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058507 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11290:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058529 */     // GIR_Coverage, 21295,
     /* 1058529 */     GIR_EraseRootFromParent_Done,
     /* 1058530 */   // Label 15653: @1058530
     /* 1058530 */   GIM_Try, /*On fail goto*//*Label 15654*/ GIMT_Encode4(1058607), // Rule ID 21298 //
     /* 1058535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1058546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1058549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058574 */     // MIs[0] policy
     /* 1058574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058584 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1058587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058606 */     // GIR_Coverage, 21298,
     /* 1058606 */     GIR_EraseRootFromParent_Done,
     /* 1058607 */   // Label 15654: @1058607
     /* 1058607 */   GIM_Try, /*On fail goto*//*Label 15655*/ GIMT_Encode4(1058684), // Rule ID 21299 //
     /* 1058612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1058623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1058626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058651 */     // MIs[0] policy
     /* 1058651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1058664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058683 */     // GIR_Coverage, 21299,
     /* 1058683 */     GIR_EraseRootFromParent_Done,
     /* 1058684 */   // Label 15655: @1058684
     /* 1058684 */   GIM_Try, /*On fail goto*//*Label 15656*/ GIMT_Encode4(1058761), // Rule ID 21302 //
     /* 1058689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1058700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1058703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1058706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058728 */     // MIs[0] policy
     /* 1058728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058738 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1058741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058760 */     // GIR_Coverage, 21302,
     /* 1058760 */     GIR_EraseRootFromParent_Done,
     /* 1058761 */   // Label 15656: @1058761
     /* 1058761 */   GIM_Try, /*On fail goto*//*Label 15657*/ GIMT_Encode4(1058838), // Rule ID 21303 //
     /* 1058766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1058777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1058780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1058783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058805 */     // MIs[0] policy
     /* 1058805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058815 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1058818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058837 */     // GIR_Coverage, 21303,
     /* 1058837 */     GIR_EraseRootFromParent_Done,
     /* 1058838 */   // Label 15657: @1058838
     /* 1058838 */   GIM_Try, /*On fail goto*//*Label 15658*/ GIMT_Encode4(1058915), // Rule ID 21306 //
     /* 1058843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1058854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1058857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1058860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1058863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058882 */     // MIs[0] policy
     /* 1058882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058892 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1058895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058914 */     // GIR_Coverage, 21306,
     /* 1058914 */     GIR_EraseRootFromParent_Done,
     /* 1058915 */   // Label 15658: @1058915
     /* 1058915 */   GIM_Try, /*On fail goto*//*Label 15659*/ GIMT_Encode4(1058992), // Rule ID 21307 //
     /* 1058920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1058931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1058934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1058937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1058940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058959 */     // MIs[0] policy
     /* 1058959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058969 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1058972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058978 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058991 */     // GIR_Coverage, 21307,
     /* 1058991 */     GIR_EraseRootFromParent_Done,
     /* 1058992 */   // Label 15659: @1058992
     /* 1058992 */   GIM_Try, /*On fail goto*//*Label 15660*/ GIMT_Encode4(1059069), // Rule ID 21310 //
     /* 1058997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059036 */     // MIs[0] policy
     /* 1059036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059046 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1059049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059068 */     // GIR_Coverage, 21310,
     /* 1059068 */     GIR_EraseRootFromParent_Done,
     /* 1059069 */   // Label 15660: @1059069
     /* 1059069 */   GIM_Try, /*On fail goto*//*Label 15661*/ GIMT_Encode4(1059146), // Rule ID 21311 //
     /* 1059074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1059085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1059088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1059091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059113 */     // MIs[0] policy
     /* 1059113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059123 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11290:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1059126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059145 */     // GIR_Coverage, 21311,
     /* 1059145 */     GIR_EraseRootFromParent_Done,
     /* 1059146 */   // Label 15661: @1059146
     /* 1059146 */   GIM_Try, /*On fail goto*//*Label 15662*/ GIMT_Encode4(1059223), // Rule ID 21314 //
     /* 1059151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1059162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1059165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059190 */     // MIs[0] policy
     /* 1059190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059200 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059222 */     // GIR_Coverage, 21314,
     /* 1059222 */     GIR_EraseRootFromParent_Done,
     /* 1059223 */   // Label 15662: @1059223
     /* 1059223 */   GIM_Try, /*On fail goto*//*Label 15663*/ GIMT_Encode4(1059300), // Rule ID 21315 //
     /* 1059228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1059239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1059242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1059245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059267 */     // MIs[0] policy
     /* 1059267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059277 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11290:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1059280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059299 */     // GIR_Coverage, 21315,
     /* 1059299 */     GIR_EraseRootFromParent_Done,
     /* 1059300 */   // Label 15663: @1059300
     /* 1059300 */   GIM_Try, /*On fail goto*//*Label 15664*/ GIMT_Encode4(1059377), // Rule ID 21318 //
     /* 1059305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1059316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1059319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059344 */     // MIs[0] policy
     /* 1059344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059354 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059376 */     // GIR_Coverage, 21318,
     /* 1059376 */     GIR_EraseRootFromParent_Done,
     /* 1059377 */   // Label 15664: @1059377
     /* 1059377 */   GIM_Try, /*On fail goto*//*Label 15665*/ GIMT_Encode4(1059454), // Rule ID 21319 //
     /* 1059382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1059393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1059396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1059399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059421 */     // MIs[0] policy
     /* 1059421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059431 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11290:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1059434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059440 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059453 */     // GIR_Coverage, 21319,
     /* 1059453 */     GIR_EraseRootFromParent_Done,
     /* 1059454 */   // Label 15665: @1059454
     /* 1059454 */   GIM_Try, /*On fail goto*//*Label 15666*/ GIMT_Encode4(1059531), // Rule ID 21322 //
     /* 1059459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1059462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1059470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1059473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1059476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059498 */     // MIs[0] policy
     /* 1059498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059530 */     // GIR_Coverage, 21322,
     /* 1059530 */     GIR_EraseRootFromParent_Done,
     /* 1059531 */   // Label 15666: @1059531
     /* 1059531 */   GIM_Try, /*On fail goto*//*Label 15667*/ GIMT_Encode4(1059608), // Rule ID 21323 //
     /* 1059536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1059547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1059550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1059553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059575 */     // MIs[0] policy
     /* 1059575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059585 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11290:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059594 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059607 */     // GIR_Coverage, 21323,
     /* 1059607 */     GIR_EraseRootFromParent_Done,
     /* 1059608 */   // Label 15667: @1059608
     /* 1059608 */   GIM_Try, /*On fail goto*//*Label 15668*/ GIMT_Encode4(1059685), // Rule ID 21326 //
     /* 1059613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1059624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1059627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1059630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059652 */     // MIs[0] policy
     /* 1059652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059662 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1059665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059684 */     // GIR_Coverage, 21326,
     /* 1059684 */     GIR_EraseRootFromParent_Done,
     /* 1059685 */   // Label 15668: @1059685
     /* 1059685 */   GIM_Try, /*On fail goto*//*Label 15669*/ GIMT_Encode4(1059762), // Rule ID 21327 //
     /* 1059690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1059701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1059704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1059707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059729 */     // MIs[0] policy
     /* 1059729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059739 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1059742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059761 */     // GIR_Coverage, 21327,
     /* 1059761 */     GIR_EraseRootFromParent_Done,
     /* 1059762 */   // Label 15669: @1059762
     /* 1059762 */   GIM_Try, /*On fail goto*//*Label 15670*/ GIMT_Encode4(1059839), // Rule ID 21330 //
     /* 1059767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1059778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1059781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1059784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059806 */     // MIs[0] policy
     /* 1059806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059816 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1059819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059838 */     // GIR_Coverage, 21330,
     /* 1059838 */     GIR_EraseRootFromParent_Done,
     /* 1059839 */   // Label 15670: @1059839
     /* 1059839 */   GIM_Try, /*On fail goto*//*Label 15671*/ GIMT_Encode4(1059916), // Rule ID 21331 //
     /* 1059844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1059855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1059858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1059861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059883 */     // MIs[0] policy
     /* 1059883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059893 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1059896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059902 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059915 */     // GIR_Coverage, 21331,
     /* 1059915 */     GIR_EraseRootFromParent_Done,
     /* 1059916 */   // Label 15671: @1059916
     /* 1059916 */   GIM_Try, /*On fail goto*//*Label 15672*/ GIMT_Encode4(1059993), // Rule ID 21334 //
     /* 1059921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1059932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1059935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1059938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059960 */     // MIs[0] policy
     /* 1059960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059970 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1059973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059992 */     // GIR_Coverage, 21334,
     /* 1059992 */     GIR_EraseRootFromParent_Done,
     /* 1059993 */   // Label 15672: @1059993
     /* 1059993 */   GIM_Try, /*On fail goto*//*Label 15673*/ GIMT_Encode4(1060070), // Rule ID 21335 //
     /* 1059998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1060009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1060012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1060015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060037 */     // MIs[0] policy
     /* 1060037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060047 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11288:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1060050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060069 */     // GIR_Coverage, 21335,
     /* 1060069 */     GIR_EraseRootFromParent_Done,
     /* 1060070 */   // Label 15673: @1060070
     /* 1060070 */   GIM_Try, /*On fail goto*//*Label 15674*/ GIMT_Encode4(1060147), // Rule ID 21338 //
     /* 1060075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1060092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060114 */     // MIs[0] policy
     /* 1060114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060124 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1060127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060146 */     // GIR_Coverage, 21338,
     /* 1060146 */     GIR_EraseRootFromParent_Done,
     /* 1060147 */   // Label 15674: @1060147
     /* 1060147 */   GIM_Try, /*On fail goto*//*Label 15675*/ GIMT_Encode4(1060224), // Rule ID 21339 //
     /* 1060152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1060163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1060166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1060169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060191 */     // MIs[0] policy
     /* 1060191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060201 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1060204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060223 */     // GIR_Coverage, 21339,
     /* 1060223 */     GIR_EraseRootFromParent_Done,
     /* 1060224 */   // Label 15675: @1060224
     /* 1060224 */   GIM_Try, /*On fail goto*//*Label 15676*/ GIMT_Encode4(1060301), // Rule ID 21342 //
     /* 1060229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1060246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060268 */     // MIs[0] policy
     /* 1060268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060278 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1060281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060300 */     // GIR_Coverage, 21342,
     /* 1060300 */     GIR_EraseRootFromParent_Done,
     /* 1060301 */   // Label 15676: @1060301
     /* 1060301 */   GIM_Try, /*On fail goto*//*Label 15677*/ GIMT_Encode4(1060378), // Rule ID 21343 //
     /* 1060306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1060317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1060320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1060323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060345 */     // MIs[0] policy
     /* 1060345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060355 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1060358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060364 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060377 */     // GIR_Coverage, 21343,
     /* 1060377 */     GIR_EraseRootFromParent_Done,
     /* 1060378 */   // Label 15677: @1060378
     /* 1060378 */   GIM_Try, /*On fail goto*//*Label 15678*/ GIMT_Encode4(1060455), // Rule ID 21346 //
     /* 1060383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1060386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1060400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1060403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060422 */     // MIs[0] policy
     /* 1060422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060432 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1060435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060454 */     // GIR_Coverage, 21346,
     /* 1060454 */     GIR_EraseRootFromParent_Done,
     /* 1060455 */   // Label 15678: @1060455
     /* 1060455 */   GIM_Try, /*On fail goto*//*Label 15679*/ GIMT_Encode4(1060532), // Rule ID 21347 //
     /* 1060460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1060463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1060471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1060474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1060477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1060480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060499 */     // MIs[0] policy
     /* 1060499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060509 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1060512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060518 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060531 */     // GIR_Coverage, 21347,
     /* 1060531 */     GIR_EraseRootFromParent_Done,
     /* 1060532 */   // Label 15679: @1060532
     /* 1060532 */   GIM_Try, /*On fail goto*//*Label 15680*/ GIMT_Encode4(1060609), // Rule ID 21350 //
     /* 1060537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060576 */     // MIs[0] policy
     /* 1060576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060586 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1060589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060608 */     // GIR_Coverage, 21350,
     /* 1060608 */     GIR_EraseRootFromParent_Done,
     /* 1060609 */   // Label 15680: @1060609
     /* 1060609 */   GIM_Try, /*On fail goto*//*Label 15681*/ GIMT_Encode4(1060686), // Rule ID 21351 //
     /* 1060614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060653 */     // MIs[0] policy
     /* 1060653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060663 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1060666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060672 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060685 */     // GIR_Coverage, 21351,
     /* 1060685 */     GIR_EraseRootFromParent_Done,
     /* 1060686 */   // Label 15681: @1060686
     /* 1060686 */   GIM_Try, /*On fail goto*//*Label 15682*/ GIMT_Encode4(1060763), // Rule ID 21354 //
     /* 1060691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060730 */     // MIs[0] policy
     /* 1060730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060740 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1060743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060762 */     // GIR_Coverage, 21354,
     /* 1060762 */     GIR_EraseRootFromParent_Done,
     /* 1060763 */   // Label 15682: @1060763
     /* 1060763 */   GIM_Try, /*On fail goto*//*Label 15683*/ GIMT_Encode4(1060840), // Rule ID 21355 //
     /* 1060768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060807 */     // MIs[0] policy
     /* 1060807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060817 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11288:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1060820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060839 */     // GIR_Coverage, 21355,
     /* 1060839 */     GIR_EraseRootFromParent_Done,
     /* 1060840 */   // Label 15683: @1060840
     /* 1060840 */   GIM_Try, /*On fail goto*//*Label 15684*/ GIMT_Encode4(1060917), // Rule ID 21358 //
     /* 1060845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1060856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1060859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1060862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060884 */     // MIs[0] policy
     /* 1060884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1060897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060916 */     // GIR_Coverage, 21358,
     /* 1060916 */     GIR_EraseRootFromParent_Done,
     /* 1060917 */   // Label 15684: @1060917
     /* 1060917 */   GIM_Try, /*On fail goto*//*Label 15685*/ GIMT_Encode4(1060994), // Rule ID 21359 //
     /* 1060922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1060933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1060936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1060939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060961 */     // MIs[0] policy
     /* 1060961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060971 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1060974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060980 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060993 */     // GIR_Coverage, 21359,
     /* 1060993 */     GIR_EraseRootFromParent_Done,
     /* 1060994 */   // Label 15685: @1060994
     /* 1060994 */   GIM_Try, /*On fail goto*//*Label 15686*/ GIMT_Encode4(1061071), // Rule ID 21362 //
     /* 1060999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061038 */     // MIs[0] policy
     /* 1061038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061048 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1061051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061070 */     // GIR_Coverage, 21362,
     /* 1061070 */     GIR_EraseRootFromParent_Done,
     /* 1061071 */   // Label 15686: @1061071
     /* 1061071 */   GIM_Try, /*On fail goto*//*Label 15687*/ GIMT_Encode4(1061148), // Rule ID 21363 //
     /* 1061076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1061087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1061090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1061093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061115 */     // MIs[0] policy
     /* 1061115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061125 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1061128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061147 */     // GIR_Coverage, 21363,
     /* 1061147 */     GIR_EraseRootFromParent_Done,
     /* 1061148 */   // Label 15687: @1061148
     /* 1061148 */   GIM_Try, /*On fail goto*//*Label 15688*/ GIMT_Encode4(1061225), // Rule ID 21366 //
     /* 1061153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1061156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061192 */     // MIs[0] policy
     /* 1061192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061202 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1061205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061224 */     // GIR_Coverage, 21366,
     /* 1061224 */     GIR_EraseRootFromParent_Done,
     /* 1061225 */   // Label 15688: @1061225
     /* 1061225 */   GIM_Try, /*On fail goto*//*Label 15689*/ GIMT_Encode4(1061302), // Rule ID 21367 //
     /* 1061230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1061233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1061241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1061244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1061247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1061250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061269 */     // MIs[0] policy
     /* 1061269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061279 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1061282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1061298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061301 */     // GIR_Coverage, 21367,
     /* 1061301 */     GIR_EraseRootFromParent_Done,
     /* 1061302 */   // Label 15689: @1061302
     /* 1061302 */   GIM_Try, /*On fail goto*//*Label 15690*/ GIMT_Encode4(1061379), // Rule ID 21370 //
     /* 1061307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061346 */     // MIs[0] policy
     /* 1061346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061356 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1061359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061378 */     // GIR_Coverage, 21370,
     /* 1061378 */     GIR_EraseRootFromParent_Done,
     /* 1061379 */   // Label 15690: @1061379
     /* 1061379 */   GIM_Try, /*On fail goto*//*Label 15691*/ GIMT_Encode4(1061456), // Rule ID 21371 //
     /* 1061384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1061395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1061398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1061401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061423 */     // MIs[0] policy
     /* 1061423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061433 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11288:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1061436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061455 */     // GIR_Coverage, 21371,
     /* 1061455 */     GIR_EraseRootFromParent_Done,
     /* 1061456 */   // Label 15691: @1061456
     /* 1061456 */   GIM_Try, /*On fail goto*//*Label 15692*/ GIMT_Encode4(1061533), // Rule ID 21374 //
     /* 1061461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061500 */     // MIs[0] policy
     /* 1061500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061510 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1061513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061532 */     // GIR_Coverage, 21374,
     /* 1061532 */     GIR_EraseRootFromParent_Done,
     /* 1061533 */   // Label 15692: @1061533
     /* 1061533 */   GIM_Try, /*On fail goto*//*Label 15693*/ GIMT_Encode4(1061610), // Rule ID 21375 //
     /* 1061538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061577 */     // MIs[0] policy
     /* 1061577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061587 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11288:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1061590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061596 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061609 */     // GIR_Coverage, 21375,
     /* 1061609 */     GIR_EraseRootFromParent_Done,
     /* 1061610 */   // Label 15693: @1061610
     /* 1061610 */   GIM_Try, /*On fail goto*//*Label 15694*/ GIMT_Encode4(1061687), // Rule ID 21378 //
     /* 1061615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061654 */     // MIs[0] policy
     /* 1061654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061664 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1061667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061686 */     // GIR_Coverage, 21378,
     /* 1061686 */     GIR_EraseRootFromParent_Done,
     /* 1061687 */   // Label 15694: @1061687
     /* 1061687 */   GIM_Try, /*On fail goto*//*Label 15695*/ GIMT_Encode4(1061764), // Rule ID 21379 //
     /* 1061692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061731 */     // MIs[0] policy
     /* 1061731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061741 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11288:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1061744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061750 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061763 */     // GIR_Coverage, 21379,
     /* 1061763 */     GIR_EraseRootFromParent_Done,
     /* 1061764 */   // Label 15695: @1061764
     /* 1061764 */   GIM_Try, /*On fail goto*//*Label 15696*/ GIMT_Encode4(1061841), // Rule ID 21382 //
     /* 1061769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1061780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1061783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1061786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061808 */     // MIs[0] policy
     /* 1061808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061818 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1061821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061840 */     // GIR_Coverage, 21382,
     /* 1061840 */     GIR_EraseRootFromParent_Done,
     /* 1061841 */   // Label 15696: @1061841
     /* 1061841 */   GIM_Try, /*On fail goto*//*Label 15697*/ GIMT_Encode4(1061918), // Rule ID 21383 //
     /* 1061846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1061857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1061860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1061863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061885 */     // MIs[0] policy
     /* 1061885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061895 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11288:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1061898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061904 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061917 */     // GIR_Coverage, 21383,
     /* 1061917 */     GIR_EraseRootFromParent_Done,
     /* 1061918 */   // Label 15697: @1061918
     /* 1061918 */   GIM_Try, /*On fail goto*//*Label 15698*/ GIMT_Encode4(1061995), // Rule ID 21386 //
     /* 1061923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1061934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1061937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1061940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061962 */     // MIs[0] policy
     /* 1061962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061972 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1061975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061994 */     // GIR_Coverage, 21386,
     /* 1061994 */     GIR_EraseRootFromParent_Done,
     /* 1061995 */   // Label 15698: @1061995
     /* 1061995 */   GIM_Try, /*On fail goto*//*Label 15699*/ GIMT_Encode4(1062072), // Rule ID 21387 //
     /* 1062000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1062011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1062014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1062017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062039 */     // MIs[0] policy
     /* 1062039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062049 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1062052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062058 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062071 */     // GIR_Coverage, 21387,
     /* 1062071 */     GIR_EraseRootFromParent_Done,
     /* 1062072 */   // Label 15699: @1062072
     /* 1062072 */   GIM_Try, /*On fail goto*//*Label 15700*/ GIMT_Encode4(1062149), // Rule ID 21390 //
     /* 1062077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1062088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1062091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1062094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062116 */     // MIs[0] policy
     /* 1062116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062126 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1062129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062148 */     // GIR_Coverage, 21390,
     /* 1062148 */     GIR_EraseRootFromParent_Done,
     /* 1062149 */   // Label 15700: @1062149
     /* 1062149 */   GIM_Try, /*On fail goto*//*Label 15701*/ GIMT_Encode4(1062226), // Rule ID 21391 //
     /* 1062154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1062165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1062168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1062171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062193 */     // MIs[0] policy
     /* 1062193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062203 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1062206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062212 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062225 */     // GIR_Coverage, 21391,
     /* 1062225 */     GIR_EraseRootFromParent_Done,
     /* 1062226 */   // Label 15701: @1062226
     /* 1062226 */   GIM_Try, /*On fail goto*//*Label 15702*/ GIMT_Encode4(1062303), // Rule ID 21394 //
     /* 1062231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1062248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062270 */     // MIs[0] policy
     /* 1062270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062280 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1062283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062302 */     // GIR_Coverage, 21394,
     /* 1062302 */     GIR_EraseRootFromParent_Done,
     /* 1062303 */   // Label 15702: @1062303
     /* 1062303 */   GIM_Try, /*On fail goto*//*Label 15703*/ GIMT_Encode4(1062380), // Rule ID 21395 //
     /* 1062308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1062319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1062322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1062325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062347 */     // MIs[0] policy
     /* 1062347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062357 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11286:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1062360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062379 */     // GIR_Coverage, 21395,
     /* 1062379 */     GIR_EraseRootFromParent_Done,
     /* 1062380 */   // Label 15703: @1062380
     /* 1062380 */   GIM_Try, /*On fail goto*//*Label 15704*/ GIMT_Encode4(1062457), // Rule ID 21398 //
     /* 1062385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1062396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1062399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062424 */     // MIs[0] policy
     /* 1062424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062434 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1062437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062456 */     // GIR_Coverage, 21398,
     /* 1062456 */     GIR_EraseRootFromParent_Done,
     /* 1062457 */   // Label 15704: @1062457
     /* 1062457 */   GIM_Try, /*On fail goto*//*Label 15705*/ GIMT_Encode4(1062534), // Rule ID 21399 //
     /* 1062462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1062473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1062476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1062479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062501 */     // MIs[0] policy
     /* 1062501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062511 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1062514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062520 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062533 */     // GIR_Coverage, 21399,
     /* 1062533 */     GIR_EraseRootFromParent_Done,
     /* 1062534 */   // Label 15705: @1062534
     /* 1062534 */   GIM_Try, /*On fail goto*//*Label 15706*/ GIMT_Encode4(1062611), // Rule ID 21402 //
     /* 1062539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1062550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1062553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1062556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062578 */     // MIs[0] policy
     /* 1062578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062588 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1062591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062610 */     // GIR_Coverage, 21402,
     /* 1062610 */     GIR_EraseRootFromParent_Done,
     /* 1062611 */   // Label 15706: @1062611
     /* 1062611 */   GIM_Try, /*On fail goto*//*Label 15707*/ GIMT_Encode4(1062688), // Rule ID 21403 //
     /* 1062616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1062627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1062630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1062633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062655 */     // MIs[0] policy
     /* 1062655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062665 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1062668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062687 */     // GIR_Coverage, 21403,
     /* 1062687 */     GIR_EraseRootFromParent_Done,
     /* 1062688 */   // Label 15707: @1062688
     /* 1062688 */   GIM_Try, /*On fail goto*//*Label 15708*/ GIMT_Encode4(1062765), // Rule ID 21406 //
     /* 1062693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1062704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1062707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1062710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1062713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062732 */     // MIs[0] policy
     /* 1062732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062742 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1062745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062764 */     // GIR_Coverage, 21406,
     /* 1062764 */     GIR_EraseRootFromParent_Done,
     /* 1062765 */   // Label 15708: @1062765
     /* 1062765 */   GIM_Try, /*On fail goto*//*Label 15709*/ GIMT_Encode4(1062842), // Rule ID 21407 //
     /* 1062770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1062781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1062784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1062787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1062790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062809 */     // MIs[0] policy
     /* 1062809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062819 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1062822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062828 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062841 */     // GIR_Coverage, 21407,
     /* 1062841 */     GIR_EraseRootFromParent_Done,
     /* 1062842 */   // Label 15709: @1062842
     /* 1062842 */   GIM_Try, /*On fail goto*//*Label 15710*/ GIMT_Encode4(1062919), // Rule ID 21410 //
     /* 1062847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1062850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062886 */     // MIs[0] policy
     /* 1062886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062896 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1062899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062918 */     // GIR_Coverage, 21410,
     /* 1062918 */     GIR_EraseRootFromParent_Done,
     /* 1062919 */   // Label 15710: @1062919
     /* 1062919 */   GIM_Try, /*On fail goto*//*Label 15711*/ GIMT_Encode4(1062996), // Rule ID 21411 //
     /* 1062924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1062927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062963 */     // MIs[0] policy
     /* 1062963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062973 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1062976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062982 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062995 */     // GIR_Coverage, 21411,
     /* 1062995 */     GIR_EraseRootFromParent_Done,
     /* 1062996 */   // Label 15711: @1062996
     /* 1062996 */   GIM_Try, /*On fail goto*//*Label 15712*/ GIMT_Encode4(1063073), // Rule ID 21414 //
     /* 1063001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063040 */     // MIs[0] policy
     /* 1063040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063050 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1063053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063072 */     // GIR_Coverage, 21414,
     /* 1063072 */     GIR_EraseRootFromParent_Done,
     /* 1063073 */   // Label 15712: @1063073
     /* 1063073 */   GIM_Try, /*On fail goto*//*Label 15713*/ GIMT_Encode4(1063150), // Rule ID 21415 //
     /* 1063078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063117 */     // MIs[0] policy
     /* 1063117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063127 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11286:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1063130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063136 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063149 */     // GIR_Coverage, 21415,
     /* 1063149 */     GIR_EraseRootFromParent_Done,
     /* 1063150 */   // Label 15713: @1063150
     /* 1063150 */   GIM_Try, /*On fail goto*//*Label 15714*/ GIMT_Encode4(1063227), // Rule ID 21418 //
     /* 1063155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1063172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063194 */     // MIs[0] policy
     /* 1063194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063204 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1063207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063226 */     // GIR_Coverage, 21418,
     /* 1063226 */     GIR_EraseRootFromParent_Done,
     /* 1063227 */   // Label 15714: @1063227
     /* 1063227 */   GIM_Try, /*On fail goto*//*Label 15715*/ GIMT_Encode4(1063304), // Rule ID 21419 //
     /* 1063232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1063243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1063246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1063249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063271 */     // MIs[0] policy
     /* 1063271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063281 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1063284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063290 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063303 */     // GIR_Coverage, 21419,
     /* 1063303 */     GIR_EraseRootFromParent_Done,
     /* 1063304 */   // Label 15715: @1063304
     /* 1063304 */   GIM_Try, /*On fail goto*//*Label 15716*/ GIMT_Encode4(1063381), // Rule ID 21422 //
     /* 1063309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063348 */     // MIs[0] policy
     /* 1063348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063358 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1063361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063380 */     // GIR_Coverage, 21422,
     /* 1063380 */     GIR_EraseRootFromParent_Done,
     /* 1063381 */   // Label 15716: @1063381
     /* 1063381 */   GIM_Try, /*On fail goto*//*Label 15717*/ GIMT_Encode4(1063458), // Rule ID 21423 //
     /* 1063386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1063397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1063400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1063403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063425 */     // MIs[0] policy
     /* 1063425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063435 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1063438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063457 */     // GIR_Coverage, 21423,
     /* 1063457 */     GIR_EraseRootFromParent_Done,
     /* 1063458 */   // Label 15717: @1063458
     /* 1063458 */   GIM_Try, /*On fail goto*//*Label 15718*/ GIMT_Encode4(1063535), // Rule ID 21426 //
     /* 1063463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1063466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1063474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1063477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1063480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063502 */     // MIs[0] policy
     /* 1063502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063512 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1063515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063534 */     // GIR_Coverage, 21426,
     /* 1063534 */     GIR_EraseRootFromParent_Done,
     /* 1063535 */   // Label 15718: @1063535
     /* 1063535 */   GIM_Try, /*On fail goto*//*Label 15719*/ GIMT_Encode4(1063612), // Rule ID 21427 //
     /* 1063540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1063551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1063554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1063557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063579 */     // MIs[0] policy
     /* 1063579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063589 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1063592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063611 */     // GIR_Coverage, 21427,
     /* 1063611 */     GIR_EraseRootFromParent_Done,
     /* 1063612 */   // Label 15719: @1063612
     /* 1063612 */   GIM_Try, /*On fail goto*//*Label 15720*/ GIMT_Encode4(1063689), // Rule ID 21430 //
     /* 1063617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1063628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1063631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1063634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063656 */     // MIs[0] policy
     /* 1063656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063666 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1063669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063688 */     // GIR_Coverage, 21430,
     /* 1063688 */     GIR_EraseRootFromParent_Done,
     /* 1063689 */   // Label 15720: @1063689
     /* 1063689 */   GIM_Try, /*On fail goto*//*Label 15721*/ GIMT_Encode4(1063766), // Rule ID 21431 //
     /* 1063694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1063697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1063705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1063708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1063711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063733 */     // MIs[0] policy
     /* 1063733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063743 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11286:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1063746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063765 */     // GIR_Coverage, 21431,
     /* 1063765 */     GIR_EraseRootFromParent_Done,
     /* 1063766 */   // Label 15721: @1063766
     /* 1063766 */   GIM_Try, /*On fail goto*//*Label 15722*/ GIMT_Encode4(1063843), // Rule ID 21434 //
     /* 1063771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063810 */     // MIs[0] policy
     /* 1063810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063820 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1063823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063842 */     // GIR_Coverage, 21434,
     /* 1063842 */     GIR_EraseRootFromParent_Done,
     /* 1063843 */   // Label 15722: @1063843
     /* 1063843 */   GIM_Try, /*On fail goto*//*Label 15723*/ GIMT_Encode4(1063920), // Rule ID 21435 //
     /* 1063848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1063851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063887 */     // MIs[0] policy
     /* 1063887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063897 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11286:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1063900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063906 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063919 */     // GIR_Coverage, 21435,
     /* 1063919 */     GIR_EraseRootFromParent_Done,
     /* 1063920 */   // Label 15723: @1063920
     /* 1063920 */   GIM_Try, /*On fail goto*//*Label 15724*/ GIMT_Encode4(1063997), // Rule ID 21438 //
     /* 1063925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1063936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1063939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063964 */     // MIs[0] policy
     /* 1063964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063974 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1063977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063996 */     // GIR_Coverage, 21438,
     /* 1063996 */     GIR_EraseRootFromParent_Done,
     /* 1063997 */   // Label 15724: @1063997
     /* 1063997 */   GIM_Try, /*On fail goto*//*Label 15725*/ GIMT_Encode4(1064074), // Rule ID 21439 //
     /* 1064002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1064019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064041 */     // MIs[0] policy
     /* 1064041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064051 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11286:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1064054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064073 */     // GIR_Coverage, 21439,
     /* 1064073 */     GIR_EraseRootFromParent_Done,
     /* 1064074 */   // Label 15725: @1064074
     /* 1064074 */   GIM_Try, /*On fail goto*//*Label 15726*/ GIMT_Encode4(1064151), // Rule ID 21442 //
     /* 1064079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1064082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1064096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064118 */     // MIs[0] policy
     /* 1064118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064128 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1064131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064150 */     // GIR_Coverage, 21442,
     /* 1064150 */     GIR_EraseRootFromParent_Done,
     /* 1064151 */   // Label 15726: @1064151
     /* 1064151 */   GIM_Try, /*On fail goto*//*Label 15727*/ GIMT_Encode4(1064228), // Rule ID 21443 //
     /* 1064156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1064159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1064164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1064173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064195 */     // MIs[0] policy
     /* 1064195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064205 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11286:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1064208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064214 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064227 */     // GIR_Coverage, 21443,
     /* 1064227 */     GIR_EraseRootFromParent_Done,
     /* 1064228 */   // Label 15727: @1064228
     /* 1064228 */   GIM_Try, /*On fail goto*//*Label 15728*/ GIMT_Encode4(1064305), // Rule ID 21446 //
     /* 1064233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064272 */     // MIs[0] policy
     /* 1064272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064282 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1064285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064304 */     // GIR_Coverage, 21446,
     /* 1064304 */     GIR_EraseRootFromParent_Done,
     /* 1064305 */   // Label 15728: @1064305
     /* 1064305 */   GIM_Try, /*On fail goto*//*Label 15729*/ GIMT_Encode4(1064382), // Rule ID 21447 //
     /* 1064310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1064321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1064324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1064327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064349 */     // MIs[0] policy
     /* 1064349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064359 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1064362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064368 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064381 */     // GIR_Coverage, 21447,
     /* 1064381 */     GIR_EraseRootFromParent_Done,
     /* 1064382 */   // Label 15729: @1064382
     /* 1064382 */   GIM_Try, /*On fail goto*//*Label 15730*/ GIMT_Encode4(1064459), // Rule ID 21450 //
     /* 1064387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064426 */     // MIs[0] policy
     /* 1064426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064436 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1064439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064458 */     // GIR_Coverage, 21450,
     /* 1064458 */     GIR_EraseRootFromParent_Done,
     /* 1064459 */   // Label 15730: @1064459
     /* 1064459 */   GIM_Try, /*On fail goto*//*Label 15731*/ GIMT_Encode4(1064536), // Rule ID 21451 //
     /* 1064464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1064475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1064478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1064481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064503 */     // MIs[0] policy
     /* 1064503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064513 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11284:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1064516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064522 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064535 */     // GIR_Coverage, 21451,
     /* 1064535 */     GIR_EraseRootFromParent_Done,
     /* 1064536 */   // Label 15731: @1064536
     /* 1064536 */   GIM_Try, /*On fail goto*//*Label 15732*/ GIMT_Encode4(1064613), // Rule ID 21454 //
     /* 1064541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064580 */     // MIs[0] policy
     /* 1064580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064590 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1064593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064612 */     // GIR_Coverage, 21454,
     /* 1064612 */     GIR_EraseRootFromParent_Done,
     /* 1064613 */   // Label 15732: @1064613
     /* 1064613 */   GIM_Try, /*On fail goto*//*Label 15733*/ GIMT_Encode4(1064690), // Rule ID 21455 //
     /* 1064618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064657 */     // MIs[0] policy
     /* 1064657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064667 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1064670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064689 */     // GIR_Coverage, 21455,
     /* 1064689 */     GIR_EraseRootFromParent_Done,
     /* 1064690 */   // Label 15733: @1064690
     /* 1064690 */   GIM_Try, /*On fail goto*//*Label 15734*/ GIMT_Encode4(1064767), // Rule ID 21458 //
     /* 1064695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064734 */     // MIs[0] policy
     /* 1064734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064744 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1064747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064766 */     // GIR_Coverage, 21458,
     /* 1064766 */     GIR_EraseRootFromParent_Done,
     /* 1064767 */   // Label 15734: @1064767
     /* 1064767 */   GIM_Try, /*On fail goto*//*Label 15735*/ GIMT_Encode4(1064844), // Rule ID 21459 //
     /* 1064772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064811 */     // MIs[0] policy
     /* 1064811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064821 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1064824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064830 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064843 */     // GIR_Coverage, 21459,
     /* 1064843 */     GIR_EraseRootFromParent_Done,
     /* 1064844 */   // Label 15735: @1064844
     /* 1064844 */   GIM_Try, /*On fail goto*//*Label 15736*/ GIMT_Encode4(1064921), // Rule ID 21462 //
     /* 1064849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1064852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1064866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064888 */     // MIs[0] policy
     /* 1064888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064898 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1064901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064920 */     // GIR_Coverage, 21462,
     /* 1064920 */     GIR_EraseRootFromParent_Done,
     /* 1064921 */   // Label 15736: @1064921
     /* 1064921 */   GIM_Try, /*On fail goto*//*Label 15737*/ GIMT_Encode4(1064998), // Rule ID 21463 //
     /* 1064926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1064929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1064943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064965 */     // MIs[0] policy
     /* 1064965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064975 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1064978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064997 */     // GIR_Coverage, 21463,
     /* 1064997 */     GIR_EraseRootFromParent_Done,
     /* 1064998 */   // Label 15737: @1064998
     /* 1064998 */   GIM_Try, /*On fail goto*//*Label 15738*/ GIMT_Encode4(1065075), // Rule ID 21466 //
     /* 1065003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065042 */     // MIs[0] policy
     /* 1065042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065052 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1065055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065061 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065074 */     // GIR_Coverage, 21466,
     /* 1065074 */     GIR_EraseRootFromParent_Done,
     /* 1065075 */   // Label 15738: @1065075
     /* 1065075 */   GIM_Try, /*On fail goto*//*Label 15739*/ GIMT_Encode4(1065152), // Rule ID 21467 //
     /* 1065080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1065091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1065094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1065097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065119 */     // MIs[0] policy
     /* 1065119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065129 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11284:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1065132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065138 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065151 */     // GIR_Coverage, 21467,
     /* 1065151 */     GIR_EraseRootFromParent_Done,
     /* 1065152 */   // Label 15739: @1065152
     /* 1065152 */   GIM_Try, /*On fail goto*//*Label 15740*/ GIMT_Encode4(1065229), // Rule ID 21470 //
     /* 1065157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065196 */     // MIs[0] policy
     /* 1065196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065206 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1065209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065228 */     // GIR_Coverage, 21470,
     /* 1065228 */     GIR_EraseRootFromParent_Done,
     /* 1065229 */   // Label 15740: @1065229
     /* 1065229 */   GIM_Try, /*On fail goto*//*Label 15741*/ GIMT_Encode4(1065306), // Rule ID 21471 //
     /* 1065234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1065245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1065248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1065251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065273 */     // MIs[0] policy
     /* 1065273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065283 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11284:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1065286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065305 */     // GIR_Coverage, 21471,
     /* 1065305 */     GIR_EraseRootFromParent_Done,
     /* 1065306 */   // Label 15741: @1065306
     /* 1065306 */   GIM_Try, /*On fail goto*//*Label 15742*/ GIMT_Encode4(1065383), // Rule ID 21474 //
     /* 1065311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065350 */     // MIs[0] policy
     /* 1065350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065360 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1065363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065382 */     // GIR_Coverage, 21474,
     /* 1065382 */     GIR_EraseRootFromParent_Done,
     /* 1065383 */   // Label 15742: @1065383
     /* 1065383 */   GIM_Try, /*On fail goto*//*Label 15743*/ GIMT_Encode4(1065460), // Rule ID 21475 //
     /* 1065388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1065399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1065402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1065405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065427 */     // MIs[0] policy
     /* 1065427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065437 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11284:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1065440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065446 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065459 */     // GIR_Coverage, 21475,
     /* 1065459 */     GIR_EraseRootFromParent_Done,
     /* 1065460 */   // Label 15743: @1065460
     /* 1065460 */   GIM_Try, /*On fail goto*//*Label 15744*/ GIMT_Encode4(1065537), // Rule ID 21478 //
     /* 1065465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1065468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065504 */     // MIs[0] policy
     /* 1065504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065514 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1065517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065536 */     // GIR_Coverage, 21478,
     /* 1065536 */     GIR_EraseRootFromParent_Done,
     /* 1065537 */   // Label 15744: @1065537
     /* 1065537 */   GIM_Try, /*On fail goto*//*Label 15745*/ GIMT_Encode4(1065614), // Rule ID 21479 //
     /* 1065542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065581 */     // MIs[0] policy
     /* 1065581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065591 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11284:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1065594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065613 */     // GIR_Coverage, 21479,
     /* 1065613 */     GIR_EraseRootFromParent_Done,
     /* 1065614 */   // Label 15745: @1065614
     /* 1065614 */   GIM_Try, /*On fail goto*//*Label 15746*/ GIMT_Encode4(1065691), // Rule ID 21722 //
     /* 1065619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1065630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1065633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1065636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065658 */     // MIs[0] policy
     /* 1065658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065668 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1065671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065690 */     // GIR_Coverage, 21722,
     /* 1065690 */     GIR_EraseRootFromParent_Done,
     /* 1065691 */   // Label 15746: @1065691
     /* 1065691 */   GIM_Try, /*On fail goto*//*Label 15747*/ GIMT_Encode4(1065768), // Rule ID 21723 //
     /* 1065696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1065707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1065710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1065713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065735 */     // MIs[0] policy
     /* 1065735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065745 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1065748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065754 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065767 */     // GIR_Coverage, 21723,
     /* 1065767 */     GIR_EraseRootFromParent_Done,
     /* 1065768 */   // Label 15747: @1065768
     /* 1065768 */   GIM_Try, /*On fail goto*//*Label 15748*/ GIMT_Encode4(1065845), // Rule ID 21726 //
     /* 1065773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1065784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1065787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1065790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065812 */     // MIs[0] policy
     /* 1065812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065822 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1065825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065831 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065844 */     // GIR_Coverage, 21726,
     /* 1065844 */     GIR_EraseRootFromParent_Done,
     /* 1065845 */   // Label 15748: @1065845
     /* 1065845 */   GIM_Try, /*On fail goto*//*Label 15749*/ GIMT_Encode4(1065922), // Rule ID 21727 //
     /* 1065850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1065861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1065864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1065867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065889 */     // MIs[0] policy
     /* 1065889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065899 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1065902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065908 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065921 */     // GIR_Coverage, 21727,
     /* 1065921 */     GIR_EraseRootFromParent_Done,
     /* 1065922 */   // Label 15749: @1065922
     /* 1065922 */   GIM_Try, /*On fail goto*//*Label 15750*/ GIMT_Encode4(1065999), // Rule ID 21730 //
     /* 1065927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1065938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1065941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1065944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065966 */     // MIs[0] policy
     /* 1065966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065976 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1065979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065998 */     // GIR_Coverage, 21730,
     /* 1065998 */     GIR_EraseRootFromParent_Done,
     /* 1065999 */   // Label 15750: @1065999
     /* 1065999 */   GIM_Try, /*On fail goto*//*Label 15751*/ GIMT_Encode4(1066076), // Rule ID 21731 //
     /* 1066004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1066015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1066018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1066021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066043 */     // MIs[0] policy
     /* 1066043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066053 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066062 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066075 */     // GIR_Coverage, 21731,
     /* 1066075 */     GIR_EraseRootFromParent_Done,
     /* 1066076 */   // Label 15751: @1066076
     /* 1066076 */   GIM_Try, /*On fail goto*//*Label 15752*/ GIMT_Encode4(1066153), // Rule ID 21734 //
     /* 1066081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1066098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066120 */     // MIs[0] policy
     /* 1066120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066130 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066152 */     // GIR_Coverage, 21734,
     /* 1066152 */     GIR_EraseRootFromParent_Done,
     /* 1066153 */   // Label 15752: @1066153
     /* 1066153 */   GIM_Try, /*On fail goto*//*Label 15753*/ GIMT_Encode4(1066230), // Rule ID 21735 //
     /* 1066158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1066169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1066172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1066175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066197 */     // MIs[0] policy
     /* 1066197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066207 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11234:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066229 */     // GIR_Coverage, 21735,
     /* 1066229 */     GIR_EraseRootFromParent_Done,
     /* 1066230 */   // Label 15753: @1066230
     /* 1066230 */   GIM_Try, /*On fail goto*//*Label 15754*/ GIMT_Encode4(1066307), // Rule ID 21738 //
     /* 1066235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1066246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1066249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1066252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066274 */     // MIs[0] policy
     /* 1066274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066306 */     // GIR_Coverage, 21738,
     /* 1066306 */     GIR_EraseRootFromParent_Done,
     /* 1066307 */   // Label 15754: @1066307
     /* 1066307 */   GIM_Try, /*On fail goto*//*Label 15755*/ GIMT_Encode4(1066384), // Rule ID 21739 //
     /* 1066312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1066323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1066326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1066329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066351 */     // MIs[0] policy
     /* 1066351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066361 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066370 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066383 */     // GIR_Coverage, 21739,
     /* 1066383 */     GIR_EraseRootFromParent_Done,
     /* 1066384 */   // Label 15755: @1066384
     /* 1066384 */   GIM_Try, /*On fail goto*//*Label 15756*/ GIMT_Encode4(1066461), // Rule ID 21742 //
     /* 1066389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1066392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1066400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1066403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1066406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066428 */     // MIs[0] policy
     /* 1066428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066438 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066460 */     // GIR_Coverage, 21742,
     /* 1066460 */     GIR_EraseRootFromParent_Done,
     /* 1066461 */   // Label 15756: @1066461
     /* 1066461 */   GIM_Try, /*On fail goto*//*Label 15757*/ GIMT_Encode4(1066538), // Rule ID 21743 //
     /* 1066466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1066469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1066477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1066480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1066483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1066486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066505 */     // MIs[0] policy
     /* 1066505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066515 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066537 */     // GIR_Coverage, 21743,
     /* 1066537 */     GIR_EraseRootFromParent_Done,
     /* 1066538 */   // Label 15757: @1066538
     /* 1066538 */   GIM_Try, /*On fail goto*//*Label 15758*/ GIMT_Encode4(1066615), // Rule ID 21746 //
     /* 1066543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1066554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1066557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1066560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066582 */     // MIs[0] policy
     /* 1066582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066592 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066614 */     // GIR_Coverage, 21746,
     /* 1066614 */     GIR_EraseRootFromParent_Done,
     /* 1066615 */   // Label 15758: @1066615
     /* 1066615 */   GIM_Try, /*On fail goto*//*Label 15759*/ GIMT_Encode4(1066692), // Rule ID 21747 //
     /* 1066620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1066631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1066634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1066637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066659 */     // MIs[0] policy
     /* 1066659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066669 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066691 */     // GIR_Coverage, 21747,
     /* 1066691 */     GIR_EraseRootFromParent_Done,
     /* 1066692 */   // Label 15759: @1066692
     /* 1066692 */   GIM_Try, /*On fail goto*//*Label 15760*/ GIMT_Encode4(1066769), // Rule ID 21750 //
     /* 1066697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1066714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066736 */     // MIs[0] policy
     /* 1066736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066746 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066768 */     // GIR_Coverage, 21750,
     /* 1066768 */     GIR_EraseRootFromParent_Done,
     /* 1066769 */   // Label 15760: @1066769
     /* 1066769 */   GIM_Try, /*On fail goto*//*Label 15761*/ GIMT_Encode4(1066846), // Rule ID 21751 //
     /* 1066774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1066791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066813 */     // MIs[0] policy
     /* 1066813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066823 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066832 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066845 */     // GIR_Coverage, 21751,
     /* 1066845 */     GIR_EraseRootFromParent_Done,
     /* 1066846 */   // Label 15761: @1066846
     /* 1066846 */   GIM_Try, /*On fail goto*//*Label 15762*/ GIMT_Encode4(1066923), // Rule ID 21754 //
     /* 1066851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1066868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066890 */     // MIs[0] policy
     /* 1066890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066922 */     // GIR_Coverage, 21754,
     /* 1066922 */     GIR_EraseRootFromParent_Done,
     /* 1066923 */   // Label 15762: @1066923
     /* 1066923 */   GIM_Try, /*On fail goto*//*Label 15763*/ GIMT_Encode4(1067000), // Rule ID 21755 //
     /* 1066928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1066945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066967 */     // MIs[0] policy
     /* 1066967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066977 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11234:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066986 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066999 */     // GIR_Coverage, 21755,
     /* 1066999 */     GIR_EraseRootFromParent_Done,
     /* 1067000 */   // Label 15763: @1067000
     /* 1067000 */   GIM_Try, /*On fail goto*//*Label 15764*/ GIMT_Encode4(1067077), // Rule ID 21758 //
     /* 1067005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067044 */     // MIs[0] policy
     /* 1067044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067076 */     // GIR_Coverage, 21758,
     /* 1067076 */     GIR_EraseRootFromParent_Done,
     /* 1067077 */   // Label 15764: @1067077
     /* 1067077 */   GIM_Try, /*On fail goto*//*Label 15765*/ GIMT_Encode4(1067154), // Rule ID 21759 //
     /* 1067082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1067093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1067096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1067099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067121 */     // MIs[0] policy
     /* 1067121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067131 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067140 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067153 */     // GIR_Coverage, 21759,
     /* 1067153 */     GIR_EraseRootFromParent_Done,
     /* 1067154 */   // Label 15765: @1067154
     /* 1067154 */   GIM_Try, /*On fail goto*//*Label 15766*/ GIMT_Encode4(1067231), // Rule ID 21762 //
     /* 1067159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1067162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1067176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067198 */     // MIs[0] policy
     /* 1067198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067208 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067230 */     // GIR_Coverage, 21762,
     /* 1067230 */     GIR_EraseRootFromParent_Done,
     /* 1067231 */   // Label 15766: @1067231
     /* 1067231 */   GIM_Try, /*On fail goto*//*Label 15767*/ GIMT_Encode4(1067308), // Rule ID 21763 //
     /* 1067236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1067239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1067247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1067250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1067253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1067256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067275 */     // MIs[0] policy
     /* 1067275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067285 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067294 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1067304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067307 */     // GIR_Coverage, 21763,
     /* 1067307 */     GIR_EraseRootFromParent_Done,
     /* 1067308 */   // Label 15767: @1067308
     /* 1067308 */   GIM_Try, /*On fail goto*//*Label 15768*/ GIMT_Encode4(1067385), // Rule ID 21766 //
     /* 1067313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1067324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1067327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1067330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067352 */     // MIs[0] policy
     /* 1067352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067384 */     // GIR_Coverage, 21766,
     /* 1067384 */     GIR_EraseRootFromParent_Done,
     /* 1067385 */   // Label 15768: @1067385
     /* 1067385 */   GIM_Try, /*On fail goto*//*Label 15769*/ GIMT_Encode4(1067462), // Rule ID 21767 //
     /* 1067390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1067401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1067404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1067407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067429 */     // MIs[0] policy
     /* 1067429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067439 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1067442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067461 */     // GIR_Coverage, 21767,
     /* 1067461 */     GIR_EraseRootFromParent_Done,
     /* 1067462 */   // Label 15769: @1067462
     /* 1067462 */   GIM_Try, /*On fail goto*//*Label 15770*/ GIMT_Encode4(1067539), // Rule ID 21770 //
     /* 1067467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1067478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1067481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1067484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067506 */     // MIs[0] policy
     /* 1067506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067538 */     // GIR_Coverage, 21770,
     /* 1067538 */     GIR_EraseRootFromParent_Done,
     /* 1067539 */   // Label 15770: @1067539
     /* 1067539 */   GIM_Try, /*On fail goto*//*Label 15771*/ GIMT_Encode4(1067616), // Rule ID 21771 //
     /* 1067544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1067555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1067558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1067561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067583 */     // MIs[0] policy
     /* 1067583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067615 */     // GIR_Coverage, 21771,
     /* 1067615 */     GIR_EraseRootFromParent_Done,
     /* 1067616 */   // Label 15771: @1067616
     /* 1067616 */   GIM_Try, /*On fail goto*//*Label 15772*/ GIMT_Encode4(1067693), // Rule ID 21774 //
     /* 1067621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1067638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067660 */     // MIs[0] policy
     /* 1067660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067692 */     // GIR_Coverage, 21774,
     /* 1067692 */     GIR_EraseRootFromParent_Done,
     /* 1067693 */   // Label 15772: @1067693
     /* 1067693 */   GIM_Try, /*On fail goto*//*Label 15773*/ GIMT_Encode4(1067770), // Rule ID 21775 //
     /* 1067698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1067715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067737 */     // MIs[0] policy
     /* 1067737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067747 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067756 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067769 */     // GIR_Coverage, 21775,
     /* 1067769 */     GIR_EraseRootFromParent_Done,
     /* 1067770 */   // Label 15773: @1067770
     /* 1067770 */   GIM_Try, /*On fail goto*//*Label 15774*/ GIMT_Encode4(1067847), // Rule ID 21778 //
     /* 1067775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1067792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067814 */     // MIs[0] policy
     /* 1067814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067824 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067846 */     // GIR_Coverage, 21778,
     /* 1067846 */     GIR_EraseRootFromParent_Done,
     /* 1067847 */   // Label 15774: @1067847
     /* 1067847 */   GIM_Try, /*On fail goto*//*Label 15775*/ GIMT_Encode4(1067924), // Rule ID 21779 //
     /* 1067852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1067869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067891 */     // MIs[0] policy
     /* 1067891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067901 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067923 */     // GIR_Coverage, 21779,
     /* 1067923 */     GIR_EraseRootFromParent_Done,
     /* 1067924 */   // Label 15775: @1067924
     /* 1067924 */   GIM_Try, /*On fail goto*//*Label 15776*/ GIMT_Encode4(1068001), // Rule ID 21782 //
     /* 1067929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1067932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1067940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1067943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1067946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067968 */     // MIs[0] policy
     /* 1067968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067978 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1067981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068000 */     // GIR_Coverage, 21782,
     /* 1068000 */     GIR_EraseRootFromParent_Done,
     /* 1068001 */   // Label 15776: @1068001
     /* 1068001 */   GIM_Try, /*On fail goto*//*Label 15777*/ GIMT_Encode4(1068078), // Rule ID 21783 //
     /* 1068006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1068017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1068020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1068023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068045 */     // MIs[0] policy
     /* 1068045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068055 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1068058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068077 */     // GIR_Coverage, 21783,
     /* 1068077 */     GIR_EraseRootFromParent_Done,
     /* 1068078 */   // Label 15777: @1068078
     /* 1068078 */   GIM_Try, /*On fail goto*//*Label 15778*/ GIMT_Encode4(1068155), // Rule ID 21786 //
     /* 1068083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1068094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1068097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068122 */     // MIs[0] policy
     /* 1068122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068132 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068154 */     // GIR_Coverage, 21786,
     /* 1068154 */     GIR_EraseRootFromParent_Done,
     /* 1068155 */   // Label 15778: @1068155
     /* 1068155 */   GIM_Try, /*On fail goto*//*Label 15779*/ GIMT_Encode4(1068232), // Rule ID 21787 //
     /* 1068160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1068171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1068174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1068177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068199 */     // MIs[0] policy
     /* 1068199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068209 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068218 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068231 */     // GIR_Coverage, 21787,
     /* 1068231 */     GIR_EraseRootFromParent_Done,
     /* 1068232 */   // Label 15779: @1068232
     /* 1068232 */   GIM_Try, /*On fail goto*//*Label 15780*/ GIMT_Encode4(1068309), // Rule ID 21790 //
     /* 1068237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1068248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1068251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068276 */     // MIs[0] policy
     /* 1068276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068286 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068308 */     // GIR_Coverage, 21790,
     /* 1068308 */     GIR_EraseRootFromParent_Done,
     /* 1068309 */   // Label 15780: @1068309
     /* 1068309 */   GIM_Try, /*On fail goto*//*Label 15781*/ GIMT_Encode4(1068386), // Rule ID 21791 //
     /* 1068314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1068325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1068328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1068331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068353 */     // MIs[0] policy
     /* 1068353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068363 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068372 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068385 */     // GIR_Coverage, 21791,
     /* 1068385 */     GIR_EraseRootFromParent_Done,
     /* 1068386 */   // Label 15781: @1068386
     /* 1068386 */   GIM_Try, /*On fail goto*//*Label 15782*/ GIMT_Encode4(1068463), // Rule ID 21794 //
     /* 1068391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1068402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1068405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068430 */     // MIs[0] policy
     /* 1068430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068440 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068462 */     // GIR_Coverage, 21794,
     /* 1068462 */     GIR_EraseRootFromParent_Done,
     /* 1068463 */   // Label 15782: @1068463
     /* 1068463 */   GIM_Try, /*On fail goto*//*Label 15783*/ GIMT_Encode4(1068540), // Rule ID 21795 //
     /* 1068468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1068479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1068482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1068485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068507 */     // MIs[0] policy
     /* 1068507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068517 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11232:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068539 */     // GIR_Coverage, 21795,
     /* 1068539 */     GIR_EraseRootFromParent_Done,
     /* 1068540 */   // Label 15783: @1068540
     /* 1068540 */   GIM_Try, /*On fail goto*//*Label 15784*/ GIMT_Encode4(1068617), // Rule ID 21798 //
     /* 1068545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1068556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1068559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068584 */     // MIs[0] policy
     /* 1068584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068594 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1068597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068616 */     // GIR_Coverage, 21798,
     /* 1068616 */     GIR_EraseRootFromParent_Done,
     /* 1068617 */   // Label 15784: @1068617
     /* 1068617 */   GIM_Try, /*On fail goto*//*Label 15785*/ GIMT_Encode4(1068694), // Rule ID 21799 //
     /* 1068622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1068633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1068636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068661 */     // MIs[0] policy
     /* 1068661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068671 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1068674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068693 */     // GIR_Coverage, 21799,
     /* 1068693 */     GIR_EraseRootFromParent_Done,
     /* 1068694 */   // Label 15785: @1068694
     /* 1068694 */   GIM_Try, /*On fail goto*//*Label 15786*/ GIMT_Encode4(1068771), // Rule ID 21802 //
     /* 1068699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1068710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1068713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1068716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1068719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068738 */     // MIs[0] policy
     /* 1068738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068748 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1068751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068770 */     // GIR_Coverage, 21802,
     /* 1068770 */     GIR_EraseRootFromParent_Done,
     /* 1068771 */   // Label 15786: @1068771
     /* 1068771 */   GIM_Try, /*On fail goto*//*Label 15787*/ GIMT_Encode4(1068848), // Rule ID 21803 //
     /* 1068776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1068787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1068790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1068793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1068796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068815 */     // MIs[0] policy
     /* 1068815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068825 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1068828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068847 */     // GIR_Coverage, 21803,
     /* 1068847 */     GIR_EraseRootFromParent_Done,
     /* 1068848 */   // Label 15787: @1068848
     /* 1068848 */   GIM_Try, /*On fail goto*//*Label 15788*/ GIMT_Encode4(1068925), // Rule ID 21806 //
     /* 1068853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1068856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1068864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1068867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068892 */     // MIs[0] policy
     /* 1068892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068902 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068924 */     // GIR_Coverage, 21806,
     /* 1068924 */     GIR_EraseRootFromParent_Done,
     /* 1068925 */   // Label 15788: @1068925
     /* 1068925 */   GIM_Try, /*On fail goto*//*Label 15789*/ GIMT_Encode4(1069002), // Rule ID 21807 //
     /* 1068930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1068933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1068941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1068944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068969 */     // MIs[0] policy
     /* 1068969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068979 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069001 */     // GIR_Coverage, 21807,
     /* 1069001 */     GIR_EraseRootFromParent_Done,
     /* 1069002 */   // Label 15789: @1069002
     /* 1069002 */   GIM_Try, /*On fail goto*//*Label 15790*/ GIMT_Encode4(1069079), // Rule ID 21810 //
     /* 1069007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069046 */     // MIs[0] policy
     /* 1069046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069078 */     // GIR_Coverage, 21810,
     /* 1069078 */     GIR_EraseRootFromParent_Done,
     /* 1069079 */   // Label 15790: @1069079
     /* 1069079 */   GIM_Try, /*On fail goto*//*Label 15791*/ GIMT_Encode4(1069156), // Rule ID 21811 //
     /* 1069084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069123 */     // MIs[0] policy
     /* 1069123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069133 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069142 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069155 */     // GIR_Coverage, 21811,
     /* 1069155 */     GIR_EraseRootFromParent_Done,
     /* 1069156 */   // Label 15791: @1069156
     /* 1069156 */   GIM_Try, /*On fail goto*//*Label 15792*/ GIMT_Encode4(1069233), // Rule ID 21814 //
     /* 1069161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1069172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1069175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069200 */     // MIs[0] policy
     /* 1069200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069210 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069232 */     // GIR_Coverage, 21814,
     /* 1069232 */     GIR_EraseRootFromParent_Done,
     /* 1069233 */   // Label 15792: @1069233
     /* 1069233 */   GIM_Try, /*On fail goto*//*Label 15793*/ GIMT_Encode4(1069310), // Rule ID 21815 //
     /* 1069238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1069249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1069252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1069255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069277 */     // MIs[0] policy
     /* 1069277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069287 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11232:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069296 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069309 */     // GIR_Coverage, 21815,
     /* 1069309 */     GIR_EraseRootFromParent_Done,
     /* 1069310 */   // Label 15793: @1069310
     /* 1069310 */   GIM_Try, /*On fail goto*//*Label 15794*/ GIMT_Encode4(1069387), // Rule ID 21818 //
     /* 1069315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1069326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1069329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069354 */     // MIs[0] policy
     /* 1069354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069364 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069373 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069386 */     // GIR_Coverage, 21818,
     /* 1069386 */     GIR_EraseRootFromParent_Done,
     /* 1069387 */   // Label 15794: @1069387
     /* 1069387 */   GIM_Try, /*On fail goto*//*Label 15795*/ GIMT_Encode4(1069464), // Rule ID 21819 //
     /* 1069392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1069403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1069406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1069409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069431 */     // MIs[0] policy
     /* 1069431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069441 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069450 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069463 */     // GIR_Coverage, 21819,
     /* 1069463 */     GIR_EraseRootFromParent_Done,
     /* 1069464 */   // Label 15795: @1069464
     /* 1069464 */   GIM_Try, /*On fail goto*//*Label 15796*/ GIMT_Encode4(1069541), // Rule ID 21822 //
     /* 1069469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1069472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1069480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1069483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1069486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069508 */     // MIs[0] policy
     /* 1069508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069540 */     // GIR_Coverage, 21822,
     /* 1069540 */     GIR_EraseRootFromParent_Done,
     /* 1069541 */   // Label 15796: @1069541
     /* 1069541 */   GIM_Try, /*On fail goto*//*Label 15797*/ GIMT_Encode4(1069618), // Rule ID 21823 //
     /* 1069546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1069557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1069560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1069563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069585 */     // MIs[0] policy
     /* 1069585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069595 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069617 */     // GIR_Coverage, 21823,
     /* 1069617 */     GIR_EraseRootFromParent_Done,
     /* 1069618 */   // Label 15797: @1069618
     /* 1069618 */   GIM_Try, /*On fail goto*//*Label 15798*/ GIMT_Encode4(1069695), // Rule ID 21826 //
     /* 1069623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1069634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1069637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1069640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069662 */     // MIs[0] policy
     /* 1069662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069694 */     // GIR_Coverage, 21826,
     /* 1069694 */     GIR_EraseRootFromParent_Done,
     /* 1069695 */   // Label 15798: @1069695
     /* 1069695 */   GIM_Try, /*On fail goto*//*Label 15799*/ GIMT_Encode4(1069772), // Rule ID 21827 //
     /* 1069700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1069703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1069711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1069714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1069717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069739 */     // MIs[0] policy
     /* 1069739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069749 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069758 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069771 */     // GIR_Coverage, 21827,
     /* 1069771 */     GIR_EraseRootFromParent_Done,
     /* 1069772 */   // Label 15799: @1069772
     /* 1069772 */   GIM_Try, /*On fail goto*//*Label 15800*/ GIMT_Encode4(1069849), // Rule ID 21830 //
     /* 1069777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1069788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1069791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1069794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069816 */     // MIs[0] policy
     /* 1069816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069848 */     // GIR_Coverage, 21830,
     /* 1069848 */     GIR_EraseRootFromParent_Done,
     /* 1069849 */   // Label 15800: @1069849
     /* 1069849 */   GIM_Try, /*On fail goto*//*Label 15801*/ GIMT_Encode4(1069926), // Rule ID 21831 //
     /* 1069854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1069857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1069865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1069868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1069871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069893 */     // MIs[0] policy
     /* 1069893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069903 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11232:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069912 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069925 */     // GIR_Coverage, 21831,
     /* 1069925 */     GIR_EraseRootFromParent_Done,
     /* 1069926 */   // Label 15801: @1069926
     /* 1069926 */   GIM_Try, /*On fail goto*//*Label 15802*/ GIMT_Encode4(1070003), // Rule ID 21834 //
     /* 1069931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1069942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1069945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1069948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069970 */     // MIs[0] policy
     /* 1069970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069980 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070002 */     // GIR_Coverage, 21834,
     /* 1070002 */     GIR_EraseRootFromParent_Done,
     /* 1070003 */   // Label 15802: @1070003
     /* 1070003 */   GIM_Try, /*On fail goto*//*Label 15803*/ GIMT_Encode4(1070080), // Rule ID 21835 //
     /* 1070008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1070019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1070022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1070025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070047 */     // MIs[0] policy
     /* 1070047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11232:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1070060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070079 */     // GIR_Coverage, 21835,
     /* 1070079 */     GIR_EraseRootFromParent_Done,
     /* 1070080 */   // Label 15803: @1070080
     /* 1070080 */   GIM_Try, /*On fail goto*//*Label 15804*/ GIMT_Encode4(1070157), // Rule ID 21838 //
     /* 1070085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1070088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1070096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1070099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1070102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070124 */     // MIs[0] policy
     /* 1070124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070156 */     // GIR_Coverage, 21838,
     /* 1070156 */     GIR_EraseRootFromParent_Done,
     /* 1070157 */   // Label 15804: @1070157
     /* 1070157 */   GIM_Try, /*On fail goto*//*Label 15805*/ GIMT_Encode4(1070234), // Rule ID 21839 //
     /* 1070162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1070165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1070170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1070173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1070176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1070179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070201 */     // MIs[0] policy
     /* 1070201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070211 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11232:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1070214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070233 */     // GIR_Coverage, 21839,
     /* 1070233 */     GIR_EraseRootFromParent_Done,
     /* 1070234 */   // Label 15805: @1070234
     /* 1070234 */   GIM_Try, /*On fail goto*//*Label 15806*/ GIMT_Encode4(1070311), // Rule ID 21950 //
     /* 1070239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070278 */     // MIs[0] policy
     /* 1070278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070288 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1070291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070310 */     // GIR_Coverage, 21950,
     /* 1070310 */     GIR_EraseRootFromParent_Done,
     /* 1070311 */   // Label 15806: @1070311
     /* 1070311 */   GIM_Try, /*On fail goto*//*Label 15807*/ GIMT_Encode4(1070388), // Rule ID 21951 //
     /* 1070316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1070327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1070330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1070333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070355 */     // MIs[0] policy
     /* 1070355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070365 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1070368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070374 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070387 */     // GIR_Coverage, 21951,
     /* 1070387 */     GIR_EraseRootFromParent_Done,
     /* 1070388 */   // Label 15807: @1070388
     /* 1070388 */   GIM_Try, /*On fail goto*//*Label 15808*/ GIMT_Encode4(1070465), // Rule ID 21954 //
     /* 1070393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070432 */     // MIs[0] policy
     /* 1070432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070442 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1070445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070464 */     // GIR_Coverage, 21954,
     /* 1070464 */     GIR_EraseRootFromParent_Done,
     /* 1070465 */   // Label 15808: @1070465
     /* 1070465 */   GIM_Try, /*On fail goto*//*Label 15809*/ GIMT_Encode4(1070542), // Rule ID 21955 //
     /* 1070470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1070481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1070484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1070487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070509 */     // MIs[0] policy
     /* 1070509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070519 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1070522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070528 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070541 */     // GIR_Coverage, 21955,
     /* 1070541 */     GIR_EraseRootFromParent_Done,
     /* 1070542 */   // Label 15809: @1070542
     /* 1070542 */   GIM_Try, /*On fail goto*//*Label 15810*/ GIMT_Encode4(1070619), // Rule ID 21958 //
     /* 1070547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070586 */     // MIs[0] policy
     /* 1070586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070596 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1070599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070618 */     // GIR_Coverage, 21958,
     /* 1070618 */     GIR_EraseRootFromParent_Done,
     /* 1070619 */   // Label 15810: @1070619
     /* 1070619 */   GIM_Try, /*On fail goto*//*Label 15811*/ GIMT_Encode4(1070696), // Rule ID 21959 //
     /* 1070624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070663 */     // MIs[0] policy
     /* 1070663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070673 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11230:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1070676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070695 */     // GIR_Coverage, 21959,
     /* 1070695 */     GIR_EraseRootFromParent_Done,
     /* 1070696 */   // Label 15811: @1070696
     /* 1070696 */   GIM_Try, /*On fail goto*//*Label 15812*/ GIMT_Encode4(1070773), // Rule ID 21962 //
     /* 1070701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070740 */     // MIs[0] policy
     /* 1070740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070750 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1070753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070772 */     // GIR_Coverage, 21962,
     /* 1070772 */     GIR_EraseRootFromParent_Done,
     /* 1070773 */   // Label 15812: @1070773
     /* 1070773 */   GIM_Try, /*On fail goto*//*Label 15813*/ GIMT_Encode4(1070850), // Rule ID 21963 //
     /* 1070778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070817 */     // MIs[0] policy
     /* 1070817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070827 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1070830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070836 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070849 */     // GIR_Coverage, 21963,
     /* 1070849 */     GIR_EraseRootFromParent_Done,
     /* 1070850 */   // Label 15813: @1070850
     /* 1070850 */   GIM_Try, /*On fail goto*//*Label 15814*/ GIMT_Encode4(1070927), // Rule ID 21966 //
     /* 1070855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1070866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1070869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1070872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070894 */     // MIs[0] policy
     /* 1070894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070904 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1070907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070926 */     // GIR_Coverage, 21966,
     /* 1070926 */     GIR_EraseRootFromParent_Done,
     /* 1070927 */   // Label 15814: @1070927
     /* 1070927 */   GIM_Try, /*On fail goto*//*Label 15815*/ GIMT_Encode4(1071004), // Rule ID 21967 //
     /* 1070932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1070943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1070946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1070949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070971 */     // MIs[0] policy
     /* 1070971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070981 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1070984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070990 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071003 */     // GIR_Coverage, 21967,
     /* 1071003 */     GIR_EraseRootFromParent_Done,
     /* 1071004 */   // Label 15815: @1071004
     /* 1071004 */   GIM_Try, /*On fail goto*//*Label 15816*/ GIMT_Encode4(1071081), // Rule ID 21970 //
     /* 1071009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071048 */     // MIs[0] policy
     /* 1071048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071058 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1071061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071080 */     // GIR_Coverage, 21970,
     /* 1071080 */     GIR_EraseRootFromParent_Done,
     /* 1071081 */   // Label 15816: @1071081
     /* 1071081 */   GIM_Try, /*On fail goto*//*Label 15817*/ GIMT_Encode4(1071158), // Rule ID 21971 //
     /* 1071086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1071103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071125 */     // MIs[0] policy
     /* 1071125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071135 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1071138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071144 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071157 */     // GIR_Coverage, 21971,
     /* 1071157 */     GIR_EraseRootFromParent_Done,
     /* 1071158 */   // Label 15817: @1071158
     /* 1071158 */   GIM_Try, /*On fail goto*//*Label 15818*/ GIMT_Encode4(1071235), // Rule ID 21974 //
     /* 1071163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071202 */     // MIs[0] policy
     /* 1071202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071212 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1071215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071234 */     // GIR_Coverage, 21974,
     /* 1071234 */     GIR_EraseRootFromParent_Done,
     /* 1071235 */   // Label 15818: @1071235
     /* 1071235 */   GIM_Try, /*On fail goto*//*Label 15819*/ GIMT_Encode4(1071312), // Rule ID 21975 //
     /* 1071240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1071251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1071254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1071257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071279 */     // MIs[0] policy
     /* 1071279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071289 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1071292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071298 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071311 */     // GIR_Coverage, 21975,
     /* 1071311 */     GIR_EraseRootFromParent_Done,
     /* 1071312 */   // Label 15819: @1071312
     /* 1071312 */   GIM_Try, /*On fail goto*//*Label 15820*/ GIMT_Encode4(1071389), // Rule ID 21978 //
     /* 1071317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071356 */     // MIs[0] policy
     /* 1071356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071366 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1071369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071388 */     // GIR_Coverage, 21978,
     /* 1071388 */     GIR_EraseRootFromParent_Done,
     /* 1071389 */   // Label 15820: @1071389
     /* 1071389 */   GIM_Try, /*On fail goto*//*Label 15821*/ GIMT_Encode4(1071466), // Rule ID 21979 //
     /* 1071394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1071405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1071408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1071411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1071421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1071425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071433 */     // MIs[0] policy
     /* 1071433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071443 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1071446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071465 */     // GIR_Coverage, 21979,
     /* 1071465 */     GIR_EraseRootFromParent_Done,
     /* 1071466 */   // Label 15821: @1071466
     /* 1071466 */   GIM_Try, /*On fail goto*//*Label 15822*/ GIMT_Encode4(1071543), // Rule ID 21982 //
     /* 1071471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1071474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071510 */     // MIs[0] policy
     /* 1071510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071520 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1071523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071542 */     // GIR_Coverage, 21982,
     /* 1071542 */     GIR_EraseRootFromParent_Done,
     /* 1071543 */   // Label 15822: @1071543
     /* 1071543 */   GIM_Try, /*On fail goto*//*Label 15823*/ GIMT_Encode4(1071620), // Rule ID 21983 //
     /* 1071548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071587 */     // MIs[0] policy
     /* 1071587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071597 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1071600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071619 */     // GIR_Coverage, 21983,
     /* 1071619 */     GIR_EraseRootFromParent_Done,
     /* 1071620 */   // Label 15823: @1071620
     /* 1071620 */   GIM_Try, /*On fail goto*//*Label 15824*/ GIMT_Encode4(1071697), // Rule ID 23422 //
     /* 1071625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1071636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1071639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1071642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071664 */     // MIs[0] policy
     /* 1071664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071674 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071696 */     // GIR_Coverage, 23422,
     /* 1071696 */     GIR_EraseRootFromParent_Done,
     /* 1071697 */   // Label 15824: @1071697
     /* 1071697 */   GIM_Try, /*On fail goto*//*Label 15825*/ GIMT_Encode4(1071774), // Rule ID 23423 //
     /* 1071702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1071713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1071716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1071719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071741 */     // MIs[0] policy
     /* 1071741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071751 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071760 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071773 */     // GIR_Coverage, 23423,
     /* 1071773 */     GIR_EraseRootFromParent_Done,
     /* 1071774 */   // Label 15825: @1071774
     /* 1071774 */   GIM_Try, /*On fail goto*//*Label 15826*/ GIMT_Encode4(1071851), // Rule ID 23426 //
     /* 1071779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1071790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1071793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1071796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071818 */     // MIs[0] policy
     /* 1071818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071828 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071850 */     // GIR_Coverage, 23426,
     /* 1071850 */     GIR_EraseRootFromParent_Done,
     /* 1071851 */   // Label 15826: @1071851
     /* 1071851 */   GIM_Try, /*On fail goto*//*Label 15827*/ GIMT_Encode4(1071928), // Rule ID 23427 //
     /* 1071856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1071867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1071870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1071873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071895 */     // MIs[0] policy
     /* 1071895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071905 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071914 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071927 */     // GIR_Coverage, 23427,
     /* 1071927 */     GIR_EraseRootFromParent_Done,
     /* 1071928 */   // Label 15827: @1071928
     /* 1071928 */   GIM_Try, /*On fail goto*//*Label 15828*/ GIMT_Encode4(1072005), // Rule ID 23430 //
     /* 1071933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1071944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1071947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1071950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071972 */     // MIs[0] policy
     /* 1071972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071982 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072004 */     // GIR_Coverage, 23430,
     /* 1072004 */     GIR_EraseRootFromParent_Done,
     /* 1072005 */   // Label 15828: @1072005
     /* 1072005 */   GIM_Try, /*On fail goto*//*Label 15829*/ GIMT_Encode4(1072082), // Rule ID 23431 //
     /* 1072010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1072021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1072024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072049 */     // MIs[0] policy
     /* 1072049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072059 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1072062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072068 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072081 */     // GIR_Coverage, 23431,
     /* 1072081 */     GIR_EraseRootFromParent_Done,
     /* 1072082 */   // Label 15829: @1072082
     /* 1072082 */   GIM_Try, /*On fail goto*//*Label 15830*/ GIMT_Encode4(1072159), // Rule ID 23434 //
     /* 1072087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072126 */     // MIs[0] policy
     /* 1072126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072136 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072158 */     // GIR_Coverage, 23434,
     /* 1072158 */     GIR_EraseRootFromParent_Done,
     /* 1072159 */   // Label 15830: @1072159
     /* 1072159 */   GIM_Try, /*On fail goto*//*Label 15831*/ GIMT_Encode4(1072236), // Rule ID 23435 //
     /* 1072164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1072175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1072178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072203 */     // MIs[0] policy
     /* 1072203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072213 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072235 */     // GIR_Coverage, 23435,
     /* 1072235 */     GIR_EraseRootFromParent_Done,
     /* 1072236 */   // Label 15831: @1072236
     /* 1072236 */   GIM_Try, /*On fail goto*//*Label 15832*/ GIMT_Encode4(1072313), // Rule ID 23438 //
     /* 1072241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1072252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1072255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072280 */     // MIs[0] policy
     /* 1072280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072290 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072312 */     // GIR_Coverage, 23438,
     /* 1072312 */     GIR_EraseRootFromParent_Done,
     /* 1072313 */   // Label 15832: @1072313
     /* 1072313 */   GIM_Try, /*On fail goto*//*Label 15833*/ GIMT_Encode4(1072390), // Rule ID 23439 //
     /* 1072318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1072329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1072332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072357 */     // MIs[0] policy
     /* 1072357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072367 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1072370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072389 */     // GIR_Coverage, 23439,
     /* 1072389 */     GIR_EraseRootFromParent_Done,
     /* 1072390 */   // Label 15833: @1072390
     /* 1072390 */   GIM_Try, /*On fail goto*//*Label 15834*/ GIMT_Encode4(1072467), // Rule ID 23442 //
     /* 1072395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1072412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072434 */     // MIs[0] policy
     /* 1072434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11324:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072466 */     // GIR_Coverage, 23442,
     /* 1072466 */     GIR_EraseRootFromParent_Done,
     /* 1072467 */   // Label 15834: @1072467
     /* 1072467 */   GIM_Try, /*On fail goto*//*Label 15835*/ GIMT_Encode4(1072544), // Rule ID 23443 //
     /* 1072472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1072483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1072486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1072489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072511 */     // MIs[0] policy
     /* 1072511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072521 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11324:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072543 */     // GIR_Coverage, 23443,
     /* 1072543 */     GIR_EraseRootFromParent_Done,
     /* 1072544 */   // Label 15835: @1072544
     /* 1072544 */   GIM_Try, /*On fail goto*//*Label 15836*/ GIMT_Encode4(1072621), // Rule ID 23446 //
     /* 1072549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1072560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1072563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072588 */     // MIs[0] policy
     /* 1072588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072598 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072620 */     // GIR_Coverage, 23446,
     /* 1072620 */     GIR_EraseRootFromParent_Done,
     /* 1072621 */   // Label 15836: @1072621
     /* 1072621 */   GIM_Try, /*On fail goto*//*Label 15837*/ GIMT_Encode4(1072698), // Rule ID 23447 //
     /* 1072626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1072637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1072640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072665 */     // MIs[0] policy
     /* 1072665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072675 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11324:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072697 */     // GIR_Coverage, 23447,
     /* 1072697 */     GIR_EraseRootFromParent_Done,
     /* 1072698 */   // Label 15837: @1072698
     /* 1072698 */   GIM_Try, /*On fail goto*//*Label 15838*/ GIMT_Encode4(1072775), // Rule ID 23450 //
     /* 1072703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1072714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1072717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072742 */     // MIs[0] policy
     /* 1072742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072774 */     // GIR_Coverage, 23450,
     /* 1072774 */     GIR_EraseRootFromParent_Done,
     /* 1072775 */   // Label 15838: @1072775
     /* 1072775 */   GIM_Try, /*On fail goto*//*Label 15839*/ GIMT_Encode4(1072852), // Rule ID 23451 //
     /* 1072780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1072791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1072794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072819 */     // MIs[0] policy
     /* 1072819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072829 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11324:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072851 */     // GIR_Coverage, 23451,
     /* 1072851 */     GIR_EraseRootFromParent_Done,
     /* 1072852 */   // Label 15839: @1072852
     /* 1072852 */   GIM_Try, /*On fail goto*//*Label 15840*/ GIMT_Encode4(1072929), // Rule ID 23454 //
     /* 1072857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1072860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1072868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1072871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072896 */     // MIs[0] policy
     /* 1072896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072906 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072928 */     // GIR_Coverage, 23454,
     /* 1072928 */     GIR_EraseRootFromParent_Done,
     /* 1072929 */   // Label 15840: @1072929
     /* 1072929 */   GIM_Try, /*On fail goto*//*Label 15841*/ GIMT_Encode4(1073006), // Rule ID 23455 //
     /* 1072934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1072937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1072945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1072948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072973 */     // MIs[0] policy
     /* 1072973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072983 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11324:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072992 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1073002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073005 */     // GIR_Coverage, 23455,
     /* 1073005 */     GIR_EraseRootFromParent_Done,
     /* 1073006 */   // Label 15841: @1073006
     /* 1073006 */   GIM_Try, /*On fail goto*//*Label 15842*/ GIMT_Encode4(1073083), // Rule ID 23458 //
     /* 1073011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1073022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1073025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073050 */     // MIs[0] policy
     /* 1073050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073060 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073082 */     // GIR_Coverage, 23458,
     /* 1073082 */     GIR_EraseRootFromParent_Done,
     /* 1073083 */   // Label 15842: @1073083
     /* 1073083 */   GIM_Try, /*On fail goto*//*Label 15843*/ GIMT_Encode4(1073160), // Rule ID 23459 //
     /* 1073088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1073099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1073102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073127 */     // MIs[0] policy
     /* 1073127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073137 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073159 */     // GIR_Coverage, 23459,
     /* 1073159 */     GIR_EraseRootFromParent_Done,
     /* 1073160 */   // Label 15843: @1073160
     /* 1073160 */   GIM_Try, /*On fail goto*//*Label 15844*/ GIMT_Encode4(1073237), // Rule ID 23462 //
     /* 1073165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1073176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1073179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073204 */     // MIs[0] policy
     /* 1073204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073214 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073236 */     // GIR_Coverage, 23462,
     /* 1073236 */     GIR_EraseRootFromParent_Done,
     /* 1073237 */   // Label 15844: @1073237
     /* 1073237 */   GIM_Try, /*On fail goto*//*Label 15845*/ GIMT_Encode4(1073314), // Rule ID 23463 //
     /* 1073242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1073253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1073256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073281 */     // MIs[0] policy
     /* 1073281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073291 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073300 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073313 */     // GIR_Coverage, 23463,
     /* 1073313 */     GIR_EraseRootFromParent_Done,
     /* 1073314 */   // Label 15845: @1073314
     /* 1073314 */   GIM_Try, /*On fail goto*//*Label 15846*/ GIMT_Encode4(1073391), // Rule ID 23466 //
     /* 1073319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1073330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1073333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1073336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1073339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073358 */     // MIs[0] policy
     /* 1073358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073368 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073390 */     // GIR_Coverage, 23466,
     /* 1073390 */     GIR_EraseRootFromParent_Done,
     /* 1073391 */   // Label 15846: @1073391
     /* 1073391 */   GIM_Try, /*On fail goto*//*Label 15847*/ GIMT_Encode4(1073468), // Rule ID 23467 //
     /* 1073396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1073407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1073410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1073413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1073416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073435 */     // MIs[0] policy
     /* 1073435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073445 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1073464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073467 */     // GIR_Coverage, 23467,
     /* 1073467 */     GIR_EraseRootFromParent_Done,
     /* 1073468 */   // Label 15847: @1073468
     /* 1073468 */   GIM_Try, /*On fail goto*//*Label 15848*/ GIMT_Encode4(1073545), // Rule ID 23470 //
     /* 1073473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1073490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073512 */     // MIs[0] policy
     /* 1073512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073544 */     // GIR_Coverage, 23470,
     /* 1073544 */     GIR_EraseRootFromParent_Done,
     /* 1073545 */   // Label 15848: @1073545
     /* 1073545 */   GIM_Try, /*On fail goto*//*Label 15849*/ GIMT_Encode4(1073622), // Rule ID 23471 //
     /* 1073550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1073567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073589 */     // MIs[0] policy
     /* 1073589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073599 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073608 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073621 */     // GIR_Coverage, 23471,
     /* 1073621 */     GIR_EraseRootFromParent_Done,
     /* 1073622 */   // Label 15849: @1073622
     /* 1073622 */   GIM_Try, /*On fail goto*//*Label 15850*/ GIMT_Encode4(1073699), // Rule ID 23474 //
     /* 1073627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073666 */     // MIs[0] policy
     /* 1073666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073698 */     // GIR_Coverage, 23474,
     /* 1073698 */     GIR_EraseRootFromParent_Done,
     /* 1073699 */   // Label 15850: @1073699
     /* 1073699 */   GIM_Try, /*On fail goto*//*Label 15851*/ GIMT_Encode4(1073776), // Rule ID 23475 //
     /* 1073704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073743 */     // MIs[0] policy
     /* 1073743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073753 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073775 */     // GIR_Coverage, 23475,
     /* 1073775 */     GIR_EraseRootFromParent_Done,
     /* 1073776 */   // Label 15851: @1073776
     /* 1073776 */   GIM_Try, /*On fail goto*//*Label 15852*/ GIMT_Encode4(1073853), // Rule ID 23478 //
     /* 1073781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1073792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1073795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073820 */     // MIs[0] policy
     /* 1073820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073830 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073852 */     // GIR_Coverage, 23478,
     /* 1073852 */     GIR_EraseRootFromParent_Done,
     /* 1073853 */   // Label 15852: @1073853
     /* 1073853 */   GIM_Try, /*On fail goto*//*Label 15853*/ GIMT_Encode4(1073930), // Rule ID 23479 //
     /* 1073858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1073869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1073872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073897 */     // MIs[0] policy
     /* 1073897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073907 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073916 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073929 */     // GIR_Coverage, 23479,
     /* 1073929 */     GIR_EraseRootFromParent_Done,
     /* 1073930 */   // Label 15853: @1073930
     /* 1073930 */   GIM_Try, /*On fail goto*//*Label 15854*/ GIMT_Encode4(1074007), // Rule ID 23482 //
     /* 1073935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1073946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1073949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1073952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073974 */     // MIs[0] policy
     /* 1073974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074006 */     // GIR_Coverage, 23482,
     /* 1074006 */     GIR_EraseRootFromParent_Done,
     /* 1074007 */   // Label 15854: @1074007
     /* 1074007 */   GIM_Try, /*On fail goto*//*Label 15855*/ GIMT_Encode4(1074084), // Rule ID 23483 //
     /* 1074012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1074023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1074026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074051 */     // MIs[0] policy
     /* 1074051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074083 */     // GIR_Coverage, 23483,
     /* 1074083 */     GIR_EraseRootFromParent_Done,
     /* 1074084 */   // Label 15855: @1074084
     /* 1074084 */   GIM_Try, /*On fail goto*//*Label 15856*/ GIMT_Encode4(1074161), // Rule ID 23486 //
     /* 1074089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074128 */     // MIs[0] policy
     /* 1074128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074138 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074160 */     // GIR_Coverage, 23486,
     /* 1074160 */     GIR_EraseRootFromParent_Done,
     /* 1074161 */   // Label 15856: @1074161
     /* 1074161 */   GIM_Try, /*On fail goto*//*Label 15857*/ GIMT_Encode4(1074238), // Rule ID 23487 //
     /* 1074166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1074177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1074180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074205 */     // MIs[0] policy
     /* 1074205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074215 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074224 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074237 */     // GIR_Coverage, 23487,
     /* 1074237 */     GIR_EraseRootFromParent_Done,
     /* 1074238 */   // Label 15857: @1074238
     /* 1074238 */   GIM_Try, /*On fail goto*//*Label 15858*/ GIMT_Encode4(1074315), // Rule ID 23490 //
     /* 1074243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1074254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1074257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074282 */     // MIs[0] policy
     /* 1074282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074292 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074314 */     // GIR_Coverage, 23490,
     /* 1074314 */     GIR_EraseRootFromParent_Done,
     /* 1074315 */   // Label 15858: @1074315
     /* 1074315 */   GIM_Try, /*On fail goto*//*Label 15859*/ GIMT_Encode4(1074392), // Rule ID 23491 //
     /* 1074320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1074331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1074334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1074337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1074340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074359 */     // MIs[0] policy
     /* 1074359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074369 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074378 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1074388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074391 */     // GIR_Coverage, 23491,
     /* 1074391 */     GIR_EraseRootFromParent_Done,
     /* 1074392 */   // Label 15859: @1074392
     /* 1074392 */   GIM_Try, /*On fail goto*//*Label 15860*/ GIMT_Encode4(1074469), // Rule ID 23494 //
     /* 1074397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1074408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1074411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1074414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074436 */     // MIs[0] policy
     /* 1074436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074455 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074468 */     // GIR_Coverage, 23494,
     /* 1074468 */     GIR_EraseRootFromParent_Done,
     /* 1074469 */   // Label 15860: @1074469
     /* 1074469 */   GIM_Try, /*On fail goto*//*Label 15861*/ GIMT_Encode4(1074546), // Rule ID 23495 //
     /* 1074474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1074485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1074488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1074491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1074494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1074501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1074505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074513 */     // MIs[0] policy
     /* 1074513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074523 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11324:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074532 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074545 */     // GIR_Coverage, 23495,
     /* 1074545 */     GIR_EraseRootFromParent_Done,
     /* 1074546 */   // Label 15861: @1074546
     /* 1074546 */   GIM_Try, /*On fail goto*//*Label 15862*/ GIMT_Encode4(1074623), // Rule ID 23498 //
     /* 1074551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1074562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1074565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074590 */     // MIs[0] policy
     /* 1074590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074600 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074622 */     // GIR_Coverage, 23498,
     /* 1074622 */     GIR_EraseRootFromParent_Done,
     /* 1074623 */   // Label 15862: @1074623
     /* 1074623 */   GIM_Try, /*On fail goto*//*Label 15863*/ GIMT_Encode4(1074700), // Rule ID 23499 //
     /* 1074628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1074639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1074642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074667 */     // MIs[0] policy
     /* 1074667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074677 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11324:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074699 */     // GIR_Coverage, 23499,
     /* 1074699 */     GIR_EraseRootFromParent_Done,
     /* 1074700 */   // Label 15863: @1074700
     /* 1074700 */   GIM_Try, /*On fail goto*//*Label 15864*/ GIMT_Encode4(1074777), // Rule ID 23502 //
     /* 1074705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1074716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1074719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074744 */     // MIs[0] policy
     /* 1074744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074754 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074776 */     // GIR_Coverage, 23502,
     /* 1074776 */     GIR_EraseRootFromParent_Done,
     /* 1074777 */   // Label 15864: @1074777
     /* 1074777 */   GIM_Try, /*On fail goto*//*Label 15865*/ GIMT_Encode4(1074854), // Rule ID 23503 //
     /* 1074782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1074793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1074796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074821 */     // MIs[0] policy
     /* 1074821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074831 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11324:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074853 */     // GIR_Coverage, 23503,
     /* 1074853 */     GIR_EraseRootFromParent_Done,
     /* 1074854 */   // Label 15865: @1074854
     /* 1074854 */   GIM_Try, /*On fail goto*//*Label 15866*/ GIMT_Encode4(1074931), // Rule ID 23608 //
     /* 1074859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1074870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1074873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1074876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1074879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074898 */     // MIs[0] policy
     /* 1074898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074908 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1074911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074930 */     // GIR_Coverage, 23608,
     /* 1074930 */     GIR_EraseRootFromParent_Done,
     /* 1074931 */   // Label 15866: @1074931
     /* 1074931 */   GIM_Try, /*On fail goto*//*Label 15867*/ GIMT_Encode4(1075008), // Rule ID 23609 //
     /* 1074936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1074947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1074950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1074953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1074956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074975 */     // MIs[0] policy
     /* 1074975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074985 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1074988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075007 */     // GIR_Coverage, 23609,
     /* 1075007 */     GIR_EraseRootFromParent_Done,
     /* 1075008 */   // Label 15867: @1075008
     /* 1075008 */   GIM_Try, /*On fail goto*//*Label 15868*/ GIMT_Encode4(1075085), // Rule ID 23612 //
     /* 1075013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1075030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075052 */     // MIs[0] policy
     /* 1075052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075062 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075084 */     // GIR_Coverage, 23612,
     /* 1075084 */     GIR_EraseRootFromParent_Done,
     /* 1075085 */   // Label 15868: @1075085
     /* 1075085 */   GIM_Try, /*On fail goto*//*Label 15869*/ GIMT_Encode4(1075162), // Rule ID 23613 //
     /* 1075090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1075101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1075104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1075107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075129 */     // MIs[0] policy
     /* 1075129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075139 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075161 */     // GIR_Coverage, 23613,
     /* 1075161 */     GIR_EraseRootFromParent_Done,
     /* 1075162 */   // Label 15869: @1075162
     /* 1075162 */   GIM_Try, /*On fail goto*//*Label 15870*/ GIMT_Encode4(1075239), // Rule ID 23616 //
     /* 1075167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1075184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075206 */     // MIs[0] policy
     /* 1075206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075216 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075238 */     // GIR_Coverage, 23616,
     /* 1075238 */     GIR_EraseRootFromParent_Done,
     /* 1075239 */   // Label 15870: @1075239
     /* 1075239 */   GIM_Try, /*On fail goto*//*Label 15871*/ GIMT_Encode4(1075316), // Rule ID 23617 //
     /* 1075244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1075255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1075258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1075261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075283 */     // MIs[0] policy
     /* 1075283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075293 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075315 */     // GIR_Coverage, 23617,
     /* 1075315 */     GIR_EraseRootFromParent_Done,
     /* 1075316 */   // Label 15871: @1075316
     /* 1075316 */   GIM_Try, /*On fail goto*//*Label 15872*/ GIMT_Encode4(1075393), // Rule ID 23620 //
     /* 1075321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1075338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075360 */     // MIs[0] policy
     /* 1075360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075392 */     // GIR_Coverage, 23620,
     /* 1075392 */     GIR_EraseRootFromParent_Done,
     /* 1075393 */   // Label 15872: @1075393
     /* 1075393 */   GIM_Try, /*On fail goto*//*Label 15873*/ GIMT_Encode4(1075470), // Rule ID 23621 //
     /* 1075398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1075409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1075412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1075415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075437 */     // MIs[0] policy
     /* 1075437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075447 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1075450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075469 */     // GIR_Coverage, 23621,
     /* 1075469 */     GIR_EraseRootFromParent_Done,
     /* 1075470 */   // Label 15873: @1075470
     /* 1075470 */   GIM_Try, /*On fail goto*//*Label 15874*/ GIMT_Encode4(1075547), // Rule ID 23624 //
     /* 1075475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1075486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1075489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1075492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075514 */     // MIs[0] policy
     /* 1075514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075546 */     // GIR_Coverage, 23624,
     /* 1075546 */     GIR_EraseRootFromParent_Done,
     /* 1075547 */   // Label 15874: @1075547
     /* 1075547 */   GIM_Try, /*On fail goto*//*Label 15875*/ GIMT_Encode4(1075624), // Rule ID 23625 //
     /* 1075552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1075563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1075566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1075569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075591 */     // MIs[0] policy
     /* 1075591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075601 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075623 */     // GIR_Coverage, 23625,
     /* 1075623 */     GIR_EraseRootFromParent_Done,
     /* 1075624 */   // Label 15875: @1075624
     /* 1075624 */   GIM_Try, /*On fail goto*//*Label 15876*/ GIMT_Encode4(1075701), // Rule ID 23628 //
     /* 1075629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1075640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1075643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1075646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075668 */     // MIs[0] policy
     /* 1075668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075700 */     // GIR_Coverage, 23628,
     /* 1075700 */     GIR_EraseRootFromParent_Done,
     /* 1075701 */   // Label 15876: @1075701
     /* 1075701 */   GIM_Try, /*On fail goto*//*Label 15877*/ GIMT_Encode4(1075778), // Rule ID 23629 //
     /* 1075706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1075717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1075720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1075723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075745 */     // MIs[0] policy
     /* 1075745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075755 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075777 */     // GIR_Coverage, 23629,
     /* 1075777 */     GIR_EraseRootFromParent_Done,
     /* 1075778 */   // Label 15877: @1075778
     /* 1075778 */   GIM_Try, /*On fail goto*//*Label 15878*/ GIMT_Encode4(1075855), // Rule ID 23632 //
     /* 1075783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1075794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1075797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1075800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075822 */     // MIs[0] policy
     /* 1075822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075832 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075854 */     // GIR_Coverage, 23632,
     /* 1075854 */     GIR_EraseRootFromParent_Done,
     /* 1075855 */   // Label 15878: @1075855
     /* 1075855 */   GIM_Try, /*On fail goto*//*Label 15879*/ GIMT_Encode4(1075932), // Rule ID 23633 //
     /* 1075860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1075871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1075874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1075877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075899 */     // MIs[0] policy
     /* 1075899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075909 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075931 */     // GIR_Coverage, 23633,
     /* 1075931 */     GIR_EraseRootFromParent_Done,
     /* 1075932 */   // Label 15879: @1075932
     /* 1075932 */   GIM_Try, /*On fail goto*//*Label 15880*/ GIMT_Encode4(1076009), // Rule ID 23636 //
     /* 1075937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1075948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1075951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1075954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075976 */     // MIs[0] policy
     /* 1075976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075986 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076008 */     // GIR_Coverage, 23636,
     /* 1076008 */     GIR_EraseRootFromParent_Done,
     /* 1076009 */   // Label 15880: @1076009
     /* 1076009 */   GIM_Try, /*On fail goto*//*Label 15881*/ GIMT_Encode4(1076086), // Rule ID 23637 //
     /* 1076014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1076025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1076028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1076031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076053 */     // MIs[0] policy
     /* 1076053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076063 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076085 */     // GIR_Coverage, 23637,
     /* 1076085 */     GIR_EraseRootFromParent_Done,
     /* 1076086 */   // Label 15881: @1076086
     /* 1076086 */   GIM_Try, /*On fail goto*//*Label 15882*/ GIMT_Encode4(1076163), // Rule ID 23640 //
     /* 1076091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1076108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076130 */     // MIs[0] policy
     /* 1076130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076162 */     // GIR_Coverage, 23640,
     /* 1076162 */     GIR_EraseRootFromParent_Done,
     /* 1076163 */   // Label 15882: @1076163
     /* 1076163 */   GIM_Try, /*On fail goto*//*Label 15883*/ GIMT_Encode4(1076240), // Rule ID 23641 //
     /* 1076168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1076179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1076182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1076185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076207 */     // MIs[0] policy
     /* 1076207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076217 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076239 */     // GIR_Coverage, 23641,
     /* 1076239 */     GIR_EraseRootFromParent_Done,
     /* 1076240 */   // Label 15883: @1076240
     /* 1076240 */   GIM_Try, /*On fail goto*//*Label 15884*/ GIMT_Encode4(1076317), // Rule ID 23644 //
     /* 1076245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1076248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1076262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076284 */     // MIs[0] policy
     /* 1076284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076316 */     // GIR_Coverage, 23644,
     /* 1076316 */     GIR_EraseRootFromParent_Done,
     /* 1076317 */   // Label 15884: @1076317
     /* 1076317 */   GIM_Try, /*On fail goto*//*Label 15885*/ GIMT_Encode4(1076394), // Rule ID 23645 //
     /* 1076322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1076325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1076333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1076336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1076339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1076357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076361 */     // MIs[0] policy
     /* 1076361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076371 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1076374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1076390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076393 */     // GIR_Coverage, 23645,
     /* 1076393 */     GIR_EraseRootFromParent_Done,
     /* 1076394 */   // Label 15885: @1076394
     /* 1076394 */   GIM_Try, /*On fail goto*//*Label 15886*/ GIMT_Encode4(1076471), // Rule ID 23648 //
     /* 1076399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1076416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076438 */     // MIs[0] policy
     /* 1076438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076448 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076470 */     // GIR_Coverage, 23648,
     /* 1076470 */     GIR_EraseRootFromParent_Done,
     /* 1076471 */   // Label 15886: @1076471
     /* 1076471 */   GIM_Try, /*On fail goto*//*Label 15887*/ GIMT_Encode4(1076548), // Rule ID 23649 //
     /* 1076476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1076487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1076490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1076493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076515 */     // MIs[0] policy
     /* 1076515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076525 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076547 */     // GIR_Coverage, 23649,
     /* 1076547 */     GIR_EraseRootFromParent_Done,
     /* 1076548 */   // Label 15887: @1076548
     /* 1076548 */   GIM_Try, /*On fail goto*//*Label 15888*/ GIMT_Encode4(1076625), // Rule ID 23652 //
     /* 1076553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1076564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1076567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1076570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076592 */     // MIs[0] policy
     /* 1076592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076602 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1076605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076624 */     // GIR_Coverage, 23652,
     /* 1076624 */     GIR_EraseRootFromParent_Done,
     /* 1076625 */   // Label 15888: @1076625
     /* 1076625 */   GIM_Try, /*On fail goto*//*Label 15889*/ GIMT_Encode4(1076702), // Rule ID 23653 //
     /* 1076630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1076641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1076644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1076647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076669 */     // MIs[0] policy
     /* 1076669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076679 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1076682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076701 */     // GIR_Coverage, 23653,
     /* 1076701 */     GIR_EraseRootFromParent_Done,
     /* 1076702 */   // Label 15889: @1076702
     /* 1076702 */   GIM_Try, /*On fail goto*//*Label 15890*/ GIMT_Encode4(1076779), // Rule ID 23656 //
     /* 1076707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1076718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1076721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1076724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076746 */     // MIs[0] policy
     /* 1076746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076756 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1076759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076778 */     // GIR_Coverage, 23656,
     /* 1076778 */     GIR_EraseRootFromParent_Done,
     /* 1076779 */   // Label 15890: @1076779
     /* 1076779 */   GIM_Try, /*On fail goto*//*Label 15891*/ GIMT_Encode4(1076856), // Rule ID 23657 //
     /* 1076784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1076795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1076798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1076801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076823 */     // MIs[0] policy
     /* 1076823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076833 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1076836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076855 */     // GIR_Coverage, 23657,
     /* 1076855 */     GIR_EraseRootFromParent_Done,
     /* 1076856 */   // Label 15891: @1076856
     /* 1076856 */   GIM_Try, /*On fail goto*//*Label 15892*/ GIMT_Encode4(1076933), // Rule ID 23660 //
     /* 1076861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1076872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1076875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1076878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076900 */     // MIs[0] policy
     /* 1076900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076932 */     // GIR_Coverage, 23660,
     /* 1076932 */     GIR_EraseRootFromParent_Done,
     /* 1076933 */   // Label 15892: @1076933
     /* 1076933 */   GIM_Try, /*On fail goto*//*Label 15893*/ GIMT_Encode4(1077010), // Rule ID 23661 //
     /* 1076938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1076949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1076952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1076955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076977 */     // MIs[0] policy
     /* 1076977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077009 */     // GIR_Coverage, 23661,
     /* 1077009 */     GIR_EraseRootFromParent_Done,
     /* 1077010 */   // Label 15893: @1077010
     /* 1077010 */   GIM_Try, /*On fail goto*//*Label 15894*/ GIMT_Encode4(1077087), // Rule ID 23664 //
     /* 1077015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1077032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077054 */     // MIs[0] policy
     /* 1077054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077086 */     // GIR_Coverage, 23664,
     /* 1077086 */     GIR_EraseRootFromParent_Done,
     /* 1077087 */   // Label 15894: @1077087
     /* 1077087 */   GIM_Try, /*On fail goto*//*Label 15895*/ GIMT_Encode4(1077164), // Rule ID 23665 //
     /* 1077092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1077103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1077106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1077109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077131 */     // MIs[0] policy
     /* 1077131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077141 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077163 */     // GIR_Coverage, 23665,
     /* 1077163 */     GIR_EraseRootFromParent_Done,
     /* 1077164 */   // Label 15895: @1077164
     /* 1077164 */   GIM_Try, /*On fail goto*//*Label 15896*/ GIMT_Encode4(1077241), // Rule ID 23668 //
     /* 1077169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1077186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077208 */     // MIs[0] policy
     /* 1077208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077218 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077240 */     // GIR_Coverage, 23668,
     /* 1077240 */     GIR_EraseRootFromParent_Done,
     /* 1077241 */   // Label 15896: @1077241
     /* 1077241 */   GIM_Try, /*On fail goto*//*Label 15897*/ GIMT_Encode4(1077318), // Rule ID 23669 //
     /* 1077246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1077257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1077260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1077263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077285 */     // MIs[0] policy
     /* 1077285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077295 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1077314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077317 */     // GIR_Coverage, 23669,
     /* 1077317 */     GIR_EraseRootFromParent_Done,
     /* 1077318 */   // Label 15897: @1077318
     /* 1077318 */   GIM_Try, /*On fail goto*//*Label 15898*/ GIMT_Encode4(1077395), // Rule ID 23672 //
     /* 1077323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1077340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077362 */     // MIs[0] policy
     /* 1077362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077394 */     // GIR_Coverage, 23672,
     /* 1077394 */     GIR_EraseRootFromParent_Done,
     /* 1077395 */   // Label 15898: @1077395
     /* 1077395 */   GIM_Try, /*On fail goto*//*Label 15899*/ GIMT_Encode4(1077472), // Rule ID 23673 //
     /* 1077400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1077411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1077414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1077417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077439 */     // MIs[0] policy
     /* 1077439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077471 */     // GIR_Coverage, 23673,
     /* 1077471 */     GIR_EraseRootFromParent_Done,
     /* 1077472 */   // Label 15899: @1077472
     /* 1077472 */   GIM_Try, /*On fail goto*//*Label 15900*/ GIMT_Encode4(1077549), // Rule ID 23676 //
     /* 1077477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1077488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1077491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1077494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077516 */     // MIs[0] policy
     /* 1077516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077548 */     // GIR_Coverage, 23676,
     /* 1077548 */     GIR_EraseRootFromParent_Done,
     /* 1077549 */   // Label 15900: @1077549
     /* 1077549 */   GIM_Try, /*On fail goto*//*Label 15901*/ GIMT_Encode4(1077626), // Rule ID 23677 //
     /* 1077554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1077565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1077568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1077571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077593 */     // MIs[0] policy
     /* 1077593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077603 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077625 */     // GIR_Coverage, 23677,
     /* 1077625 */     GIR_EraseRootFromParent_Done,
     /* 1077626 */   // Label 15901: @1077626
     /* 1077626 */   GIM_Try, /*On fail goto*//*Label 15902*/ GIMT_Encode4(1077703), // Rule ID 23680 //
     /* 1077631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1077642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1077645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1077648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077670 */     // MIs[0] policy
     /* 1077670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077702 */     // GIR_Coverage, 23680,
     /* 1077702 */     GIR_EraseRootFromParent_Done,
     /* 1077703 */   // Label 15902: @1077703
     /* 1077703 */   GIM_Try, /*On fail goto*//*Label 15903*/ GIMT_Encode4(1077780), // Rule ID 23681 //
     /* 1077708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1077719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1077722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1077725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077747 */     // MIs[0] policy
     /* 1077747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077757 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077779 */     // GIR_Coverage, 23681,
     /* 1077779 */     GIR_EraseRootFromParent_Done,
     /* 1077780 */   // Label 15903: @1077780
     /* 1077780 */   GIM_Try, /*On fail goto*//*Label 15904*/ GIMT_Encode4(1077857), // Rule ID 23684 //
     /* 1077785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1077788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1077796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1077799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1077802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077824 */     // MIs[0] policy
     /* 1077824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077834 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077856 */     // GIR_Coverage, 23684,
     /* 1077856 */     GIR_EraseRootFromParent_Done,
     /* 1077857 */   // Label 15904: @1077857
     /* 1077857 */   GIM_Try, /*On fail goto*//*Label 15905*/ GIMT_Encode4(1077934), // Rule ID 23685 //
     /* 1077862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1077865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1077873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1077876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1077879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077901 */     // MIs[0] policy
     /* 1077901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077933 */     // GIR_Coverage, 23685,
     /* 1077933 */     GIR_EraseRootFromParent_Done,
     /* 1077934 */   // Label 15905: @1077934
     /* 1077934 */   GIM_Try, /*On fail goto*//*Label 15906*/ GIMT_Encode4(1078011), // Rule ID 23688 //
     /* 1077939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1077942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1077950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1077953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1077956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077978 */     // MIs[0] policy
     /* 1077978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077988 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078010 */     // GIR_Coverage, 23688,
     /* 1078010 */     GIR_EraseRootFromParent_Done,
     /* 1078011 */   // Label 15906: @1078011
     /* 1078011 */   GIM_Try, /*On fail goto*//*Label 15907*/ GIMT_Encode4(1078088), // Rule ID 23689 //
     /* 1078016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1078027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1078030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1078033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1078051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078055 */     // MIs[0] policy
     /* 1078055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078065 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1078068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078087 */     // GIR_Coverage, 23689,
     /* 1078087 */     GIR_EraseRootFromParent_Done,
     /* 1078088 */   // Label 15907: @1078088
     /* 1078088 */   GIM_Try, /*On fail goto*//*Label 15908*/ GIMT_Encode4(1078165), // Rule ID 23692 //
     /* 1078093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1078096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1078110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078132 */     // MIs[0] policy
     /* 1078132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078164 */     // GIR_Coverage, 23692,
     /* 1078164 */     GIR_EraseRootFromParent_Done,
     /* 1078165 */   // Label 15908: @1078165
     /* 1078165 */   GIM_Try, /*On fail goto*//*Label 15909*/ GIMT_Encode4(1078242), // Rule ID 23693 //
     /* 1078170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1078173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1078178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1078181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1078184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1078187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1078205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078209 */     // MIs[0] policy
     /* 1078209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078219 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1078222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1078238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078241 */     // GIR_Coverage, 23693,
     /* 1078241 */     GIR_EraseRootFromParent_Done,
     /* 1078242 */   // Label 15909: @1078242
     /* 1078242 */   GIM_Try, /*On fail goto*//*Label 15910*/ GIMT_Encode4(1078319), // Rule ID 23784 //
     /* 1078247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078286 */     // MIs[0] policy
     /* 1078286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1078299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078318 */     // GIR_Coverage, 23784,
     /* 1078318 */     GIR_EraseRootFromParent_Done,
     /* 1078319 */   // Label 15910: @1078319
     /* 1078319 */   GIM_Try, /*On fail goto*//*Label 15911*/ GIMT_Encode4(1078396), // Rule ID 23785 //
     /* 1078324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1078335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1078338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1078341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078363 */     // MIs[0] policy
     /* 1078363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078373 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1078376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078395 */     // GIR_Coverage, 23785,
     /* 1078395 */     GIR_EraseRootFromParent_Done,
     /* 1078396 */   // Label 15911: @1078396
     /* 1078396 */   GIM_Try, /*On fail goto*//*Label 15912*/ GIMT_Encode4(1078473), // Rule ID 23788 //
     /* 1078401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078440 */     // MIs[0] policy
     /* 1078440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078450 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078472 */     // GIR_Coverage, 23788,
     /* 1078472 */     GIR_EraseRootFromParent_Done,
     /* 1078473 */   // Label 15912: @1078473
     /* 1078473 */   GIM_Try, /*On fail goto*//*Label 15913*/ GIMT_Encode4(1078550), // Rule ID 23789 //
     /* 1078478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1078489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1078492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1078495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078517 */     // MIs[0] policy
     /* 1078517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078527 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078549 */     // GIR_Coverage, 23789,
     /* 1078549 */     GIR_EraseRootFromParent_Done,
     /* 1078550 */   // Label 15913: @1078550
     /* 1078550 */   GIM_Try, /*On fail goto*//*Label 15914*/ GIMT_Encode4(1078627), // Rule ID 23792 //
     /* 1078555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1078566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1078569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1078572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078594 */     // MIs[0] policy
     /* 1078594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078604 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078626 */     // GIR_Coverage, 23792,
     /* 1078626 */     GIR_EraseRootFromParent_Done,
     /* 1078627 */   // Label 15914: @1078627
     /* 1078627 */   GIM_Try, /*On fail goto*//*Label 15915*/ GIMT_Encode4(1078704), // Rule ID 23793 //
     /* 1078632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1078643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1078646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1078649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078671 */     // MIs[0] policy
     /* 1078671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078681 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078703 */     // GIR_Coverage, 23793,
     /* 1078703 */     GIR_EraseRootFromParent_Done,
     /* 1078704 */   // Label 15915: @1078704
     /* 1078704 */   GIM_Try, /*On fail goto*//*Label 15916*/ GIMT_Encode4(1078781), // Rule ID 23796 //
     /* 1078709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1078720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1078723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1078726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078748 */     // MIs[0] policy
     /* 1078748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078780 */     // GIR_Coverage, 23796,
     /* 1078780 */     GIR_EraseRootFromParent_Done,
     /* 1078781 */   // Label 15916: @1078781
     /* 1078781 */   GIM_Try, /*On fail goto*//*Label 15917*/ GIMT_Encode4(1078858), // Rule ID 23797 //
     /* 1078786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1078797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1078800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1078803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078825 */     // MIs[0] policy
     /* 1078825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078835 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078857 */     // GIR_Coverage, 23797,
     /* 1078857 */     GIR_EraseRootFromParent_Done,
     /* 1078858 */   // Label 15917: @1078858
     /* 1078858 */   GIM_Try, /*On fail goto*//*Label 15918*/ GIMT_Encode4(1078935), // Rule ID 23800 //
     /* 1078863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1078874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1078877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1078880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078902 */     // MIs[0] policy
     /* 1078902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078912 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078934 */     // GIR_Coverage, 23800,
     /* 1078934 */     GIR_EraseRootFromParent_Done,
     /* 1078935 */   // Label 15918: @1078935
     /* 1078935 */   GIM_Try, /*On fail goto*//*Label 15919*/ GIMT_Encode4(1079012), // Rule ID 23801 //
     /* 1078940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1078951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1078954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1078957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078979 */     // MIs[0] policy
     /* 1078979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078989 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079011 */     // GIR_Coverage, 23801,
     /* 1079011 */     GIR_EraseRootFromParent_Done,
     /* 1079012 */   // Label 15919: @1079012
     /* 1079012 */   GIM_Try, /*On fail goto*//*Label 15920*/ GIMT_Encode4(1079089), // Rule ID 23804 //
     /* 1079017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079056 */     // MIs[0] policy
     /* 1079056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079088 */     // GIR_Coverage, 23804,
     /* 1079088 */     GIR_EraseRootFromParent_Done,
     /* 1079089 */   // Label 15920: @1079089
     /* 1079089 */   GIM_Try, /*On fail goto*//*Label 15921*/ GIMT_Encode4(1079166), // Rule ID 23805 //
     /* 1079094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1079105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1079108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1079111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079133 */     // MIs[0] policy
     /* 1079133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079143 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1079146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079165 */     // GIR_Coverage, 23805,
     /* 1079165 */     GIR_EraseRootFromParent_Done,
     /* 1079166 */   // Label 15921: @1079166
     /* 1079166 */   GIM_Try, /*On fail goto*//*Label 15922*/ GIMT_Encode4(1079243), // Rule ID 23808 //
     /* 1079171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079210 */     // MIs[0] policy
     /* 1079210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079242 */     // GIR_Coverage, 23808,
     /* 1079242 */     GIR_EraseRootFromParent_Done,
     /* 1079243 */   // Label 15922: @1079243
     /* 1079243 */   GIM_Try, /*On fail goto*//*Label 15923*/ GIMT_Encode4(1079320), // Rule ID 23809 //
     /* 1079248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1079259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1079262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1079265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079287 */     // MIs[0] policy
     /* 1079287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079297 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079319 */     // GIR_Coverage, 23809,
     /* 1079319 */     GIR_EraseRootFromParent_Done,
     /* 1079320 */   // Label 15923: @1079320
     /* 1079320 */   GIM_Try, /*On fail goto*//*Label 15924*/ GIMT_Encode4(1079397), // Rule ID 23812 //
     /* 1079325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079364 */     // MIs[0] policy
     /* 1079364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079396 */     // GIR_Coverage, 23812,
     /* 1079396 */     GIR_EraseRootFromParent_Done,
     /* 1079397 */   // Label 15924: @1079397
     /* 1079397 */   GIM_Try, /*On fail goto*//*Label 15925*/ GIMT_Encode4(1079474), // Rule ID 23813 //
     /* 1079402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1079413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1079416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1079419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079441 */     // MIs[0] policy
     /* 1079441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079451 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079473 */     // GIR_Coverage, 23813,
     /* 1079473 */     GIR_EraseRootFromParent_Done,
     /* 1079474 */   // Label 15925: @1079474
     /* 1079474 */   GIM_Try, /*On fail goto*//*Label 15926*/ GIMT_Encode4(1079551), // Rule ID 23816 //
     /* 1079479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1079490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1079493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1079496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079518 */     // MIs[0] policy
     /* 1079518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079550 */     // GIR_Coverage, 23816,
     /* 1079550 */     GIR_EraseRootFromParent_Done,
     /* 1079551 */   // Label 15926: @1079551
     /* 1079551 */   GIM_Try, /*On fail goto*//*Label 15927*/ GIMT_Encode4(1079628), // Rule ID 23817 //
     /* 1079556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1079567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1079570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1079573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079595 */     // MIs[0] policy
     /* 1079595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079605 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079627 */     // GIR_Coverage, 23817,
     /* 1079627 */     GIR_EraseRootFromParent_Done,
     /* 1079628 */   // Label 15927: @1079628
     /* 1079628 */   GIM_Try, /*On fail goto*//*Label 15928*/ GIMT_Encode4(1079705), // Rule ID 23820 //
     /* 1079633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1079636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1079644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1079647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1079650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079672 */     // MIs[0] policy
     /* 1079672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079682 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079704 */     // GIR_Coverage, 23820,
     /* 1079704 */     GIR_EraseRootFromParent_Done,
     /* 1079705 */   // Label 15928: @1079705
     /* 1079705 */   GIM_Try, /*On fail goto*//*Label 15929*/ GIMT_Encode4(1079782), // Rule ID 23821 //
     /* 1079710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1079713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1079721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1079724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1079727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079749 */     // MIs[0] policy
     /* 1079749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079759 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079781 */     // GIR_Coverage, 23821,
     /* 1079781 */     GIR_EraseRootFromParent_Done,
     /* 1079782 */   // Label 15929: @1079782
     /* 1079782 */   GIM_Try, /*On fail goto*//*Label 15930*/ GIMT_Encode4(1079859), // Rule ID 23824 //
     /* 1079787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1079798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1079801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1079804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079826 */     // MIs[0] policy
     /* 1079826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1079839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079858 */     // GIR_Coverage, 23824,
     /* 1079858 */     GIR_EraseRootFromParent_Done,
     /* 1079859 */   // Label 15930: @1079859
     /* 1079859 */   GIM_Try, /*On fail goto*//*Label 15931*/ GIMT_Encode4(1079936), // Rule ID 23825 //
     /* 1079864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1079875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1079878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1079881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079903 */     // MIs[0] policy
     /* 1079903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079913 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1079916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079935 */     // GIR_Coverage, 23825,
     /* 1079935 */     GIR_EraseRootFromParent_Done,
     /* 1079936 */   // Label 15931: @1079936
     /* 1079936 */   GIM_Try, /*On fail goto*//*Label 15932*/ GIMT_Encode4(1080013), // Rule ID 23828 //
     /* 1079941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1079952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1079955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1079958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079980 */     // MIs[0] policy
     /* 1079980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1079993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080012 */     // GIR_Coverage, 23828,
     /* 1080012 */     GIR_EraseRootFromParent_Done,
     /* 1080013 */   // Label 15932: @1080013
     /* 1080013 */   GIM_Try, /*On fail goto*//*Label 15933*/ GIMT_Encode4(1080090), // Rule ID 23829 //
     /* 1080018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1080029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1080032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1080035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080057 */     // MIs[0] policy
     /* 1080057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080067 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080089 */     // GIR_Coverage, 23829,
     /* 1080089 */     GIR_EraseRootFromParent_Done,
     /* 1080090 */   // Label 15933: @1080090
     /* 1080090 */   GIM_Try, /*On fail goto*//*Label 15934*/ GIMT_Encode4(1080167), // Rule ID 23832 //
     /* 1080095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080134 */     // MIs[0] policy
     /* 1080134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080144 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080166 */     // GIR_Coverage, 23832,
     /* 1080166 */     GIR_EraseRootFromParent_Done,
     /* 1080167 */   // Label 15934: @1080167
     /* 1080167 */   GIM_Try, /*On fail goto*//*Label 15935*/ GIMT_Encode4(1080244), // Rule ID 23833 //
     /* 1080172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1080183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1080186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1080189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080211 */     // MIs[0] policy
     /* 1080211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080221 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1080240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080243 */     // GIR_Coverage, 23833,
     /* 1080243 */     GIR_EraseRootFromParent_Done,
     /* 1080244 */   // Label 15935: @1080244
     /* 1080244 */   GIM_Try, /*On fail goto*//*Label 15936*/ GIMT_Encode4(1080321), // Rule ID 23836 //
     /* 1080249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080288 */     // MIs[0] policy
     /* 1080288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080320 */     // GIR_Coverage, 23836,
     /* 1080320 */     GIR_EraseRootFromParent_Done,
     /* 1080321 */   // Label 15936: @1080321
     /* 1080321 */   GIM_Try, /*On fail goto*//*Label 15937*/ GIMT_Encode4(1080398), // Rule ID 23837 //
     /* 1080326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1080337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1080340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1080343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080365 */     // MIs[0] policy
     /* 1080365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080375 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080397 */     // GIR_Coverage, 23837,
     /* 1080397 */     GIR_EraseRootFromParent_Done,
     /* 1080398 */   // Label 15937: @1080398
     /* 1080398 */   GIM_Try, /*On fail goto*//*Label 15938*/ GIMT_Encode4(1080475), // Rule ID 23840 //
     /* 1080403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080442 */     // MIs[0] policy
     /* 1080442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080452 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080474 */     // GIR_Coverage, 23840,
     /* 1080474 */     GIR_EraseRootFromParent_Done,
     /* 1080475 */   // Label 15938: @1080475
     /* 1080475 */   GIM_Try, /*On fail goto*//*Label 15939*/ GIMT_Encode4(1080552), // Rule ID 23841 //
     /* 1080480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1080491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1080494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1080497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080519 */     // MIs[0] policy
     /* 1080519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080529 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080551 */     // GIR_Coverage, 23841,
     /* 1080551 */     GIR_EraseRootFromParent_Done,
     /* 1080552 */   // Label 15939: @1080552
     /* 1080552 */   GIM_Try, /*On fail goto*//*Label 15940*/ GIMT_Encode4(1080629), // Rule ID 23844 //
     /* 1080557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1080568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1080571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1080574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080596 */     // MIs[0] policy
     /* 1080596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080606 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080628 */     // GIR_Coverage, 23844,
     /* 1080628 */     GIR_EraseRootFromParent_Done,
     /* 1080629 */   // Label 15940: @1080629
     /* 1080629 */   GIM_Try, /*On fail goto*//*Label 15941*/ GIMT_Encode4(1080706), // Rule ID 23845 //
     /* 1080634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1080645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1080648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1080651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080673 */     // MIs[0] policy
     /* 1080673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080683 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080705 */     // GIR_Coverage, 23845,
     /* 1080705 */     GIR_EraseRootFromParent_Done,
     /* 1080706 */   // Label 15941: @1080706
     /* 1080706 */   GIM_Try, /*On fail goto*//*Label 15942*/ GIMT_Encode4(1080783), // Rule ID 23848 //
     /* 1080711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1080722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1080725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1080728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080750 */     // MIs[0] policy
     /* 1080750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080782 */     // GIR_Coverage, 23848,
     /* 1080782 */     GIR_EraseRootFromParent_Done,
     /* 1080783 */   // Label 15942: @1080783
     /* 1080783 */   GIM_Try, /*On fail goto*//*Label 15943*/ GIMT_Encode4(1080860), // Rule ID 23849 //
     /* 1080788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1080799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1080802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1080805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080827 */     // MIs[0] policy
     /* 1080827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080837 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080859 */     // GIR_Coverage, 23849,
     /* 1080859 */     GIR_EraseRootFromParent_Done,
     /* 1080860 */   // Label 15943: @1080860
     /* 1080860 */   GIM_Try, /*On fail goto*//*Label 15944*/ GIMT_Encode4(1080937), // Rule ID 23852 //
     /* 1080865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1080876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1080879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1080882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080904 */     // MIs[0] policy
     /* 1080904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080936 */     // GIR_Coverage, 23852,
     /* 1080936 */     GIR_EraseRootFromParent_Done,
     /* 1080937 */   // Label 15944: @1080937
     /* 1080937 */   GIM_Try, /*On fail goto*//*Label 15945*/ GIMT_Encode4(1081014), // Rule ID 23853 //
     /* 1080942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1080953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1080956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1080959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080981 */     // MIs[0] policy
     /* 1080981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080991 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081013 */     // GIR_Coverage, 23853,
     /* 1081013 */     GIR_EraseRootFromParent_Done,
     /* 1081014 */   // Label 15945: @1081014
     /* 1081014 */   GIM_Try, /*On fail goto*//*Label 15946*/ GIMT_Encode4(1081091), // Rule ID 23856 //
     /* 1081019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1081022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081058 */     // MIs[0] policy
     /* 1081058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081090 */     // GIR_Coverage, 23856,
     /* 1081090 */     GIR_EraseRootFromParent_Done,
     /* 1081091 */   // Label 15946: @1081091
     /* 1081091 */   GIM_Try, /*On fail goto*//*Label 15947*/ GIMT_Encode4(1081168), // Rule ID 23857 //
     /* 1081096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1081099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1081107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1081110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1081113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081135 */     // MIs[0] policy
     /* 1081135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081145 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081167 */     // GIR_Coverage, 23857,
     /* 1081167 */     GIR_EraseRootFromParent_Done,
     /* 1081168 */   // Label 15947: @1081168
     /* 1081168 */   GIM_Try, /*On fail goto*//*Label 15948*/ GIMT_Encode4(1081245), // Rule ID 23860 //
     /* 1081173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081212 */     // MIs[0] policy
     /* 1081212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081244 */     // GIR_Coverage, 23860,
     /* 1081244 */     GIR_EraseRootFromParent_Done,
     /* 1081245 */   // Label 15948: @1081245
     /* 1081245 */   GIM_Try, /*On fail goto*//*Label 15949*/ GIMT_Encode4(1081322), // Rule ID 23861 //
     /* 1081250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1081261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1081264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1081267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1081285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081289 */     // MIs[0] policy
     /* 1081289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081299 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1081302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081321 */     // GIR_Coverage, 23861,
     /* 1081321 */     GIR_EraseRootFromParent_Done,
     /* 1081322 */   // Label 15949: @1081322
     /* 1081322 */   GIM_Try, /*On fail goto*//*Label 15950*/ GIMT_Encode4(1081399), // Rule ID 23864 //
     /* 1081327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081366 */     // MIs[0] policy
     /* 1081366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081376 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081398 */     // GIR_Coverage, 23864,
     /* 1081398 */     GIR_EraseRootFromParent_Done,
     /* 1081399 */   // Label 15950: @1081399
     /* 1081399 */   GIM_Try, /*On fail goto*//*Label 15951*/ GIMT_Encode4(1081476), // Rule ID 23865 //
     /* 1081404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1081415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1081418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1081421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1081439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081443 */     // MIs[0] policy
     /* 1081443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081453 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1081456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081475 */     // GIR_Coverage, 23865,
     /* 1081475 */     GIR_EraseRootFromParent_Done,
     /* 1081476 */   // Label 15951: @1081476
     /* 1081476 */   GIM_Try, /*On fail goto*//*Label 15952*/ GIMT_Encode4(1081553), // Rule ID 23868 //
     /* 1081481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1081484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1081492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1081495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081520 */     // MIs[0] policy
     /* 1081520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081530 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081552 */     // GIR_Coverage, 23868,
     /* 1081552 */     GIR_EraseRootFromParent_Done,
     /* 1081553 */   // Label 15952: @1081553
     /* 1081553 */   GIM_Try, /*On fail goto*//*Label 15953*/ GIMT_Encode4(1081630), // Rule ID 23869 //
     /* 1081558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1081569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1081572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081597 */     // MIs[0] policy
     /* 1081597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081607 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081629 */     // GIR_Coverage, 23869,
     /* 1081629 */     GIR_EraseRootFromParent_Done,
     /* 1081630 */   // Label 15953: @1081630
     /* 1081630 */   GIM_Try, /*On fail goto*//*Label 15954*/ GIMT_Encode4(1081707), // Rule ID 24136 //
     /* 1081635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1081638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1081646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1081649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1081652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081674 */     // MIs[0] policy
     /* 1081674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081684 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1081687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081706 */     // GIR_Coverage, 24136,
     /* 1081706 */     GIR_EraseRootFromParent_Done,
     /* 1081707 */   // Label 15954: @1081707
     /* 1081707 */   GIM_Try, /*On fail goto*//*Label 15955*/ GIMT_Encode4(1081784), // Rule ID 24137 //
     /* 1081712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1081715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1081723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1081726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1081729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081751 */     // MIs[0] policy
     /* 1081751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081761 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1081764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081783 */     // GIR_Coverage, 24137,
     /* 1081783 */     GIR_EraseRootFromParent_Done,
     /* 1081784 */   // Label 15955: @1081784
     /* 1081784 */   GIM_Try, /*On fail goto*//*Label 15956*/ GIMT_Encode4(1081861), // Rule ID 24140 //
     /* 1081789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1081792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1081800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1081803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1081806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081828 */     // MIs[0] policy
     /* 1081828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081838 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1081841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081860 */     // GIR_Coverage, 24140,
     /* 1081860 */     GIR_EraseRootFromParent_Done,
     /* 1081861 */   // Label 15956: @1081861
     /* 1081861 */   GIM_Try, /*On fail goto*//*Label 15957*/ GIMT_Encode4(1081938), // Rule ID 24141 //
     /* 1081866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1081869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1081877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1081880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1081883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081905 */     // MIs[0] policy
     /* 1081905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081915 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1081918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081937 */     // GIR_Coverage, 24141,
     /* 1081937 */     GIR_EraseRootFromParent_Done,
     /* 1081938 */   // Label 15957: @1081938
     /* 1081938 */   GIM_Try, /*On fail goto*//*Label 15958*/ GIMT_Encode4(1082015), // Rule ID 24144 //
     /* 1081943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1081946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1081954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1081957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1081960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081982 */     // MIs[0] policy
     /* 1081982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081992 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1081995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082014 */     // GIR_Coverage, 24144,
     /* 1082014 */     GIR_EraseRootFromParent_Done,
     /* 1082015 */   // Label 15958: @1082015
     /* 1082015 */   GIM_Try, /*On fail goto*//*Label 15959*/ GIMT_Encode4(1082092), // Rule ID 24145 //
     /* 1082020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1082023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1082031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1082034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1082037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082059 */     // MIs[0] policy
     /* 1082059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082069 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1082072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082091 */     // GIR_Coverage, 24145,
     /* 1082091 */     GIR_EraseRootFromParent_Done,
     /* 1082092 */   // Label 15959: @1082092
     /* 1082092 */   GIM_Try, /*On fail goto*//*Label 15960*/ GIMT_Encode4(1082169), // Rule ID 24148 //
     /* 1082097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1082100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1082108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1082111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082136 */     // MIs[0] policy
     /* 1082136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082146 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082168 */     // GIR_Coverage, 24148,
     /* 1082168 */     GIR_EraseRootFromParent_Done,
     /* 1082169 */   // Label 15960: @1082169
     /* 1082169 */   GIM_Try, /*On fail goto*//*Label 15961*/ GIMT_Encode4(1082246), // Rule ID 24149 //
     /* 1082174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1082177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1082185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1082188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1082191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082213 */     // MIs[0] policy
     /* 1082213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082223 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082245 */     // GIR_Coverage, 24149,
     /* 1082245 */     GIR_EraseRootFromParent_Done,
     /* 1082246 */   // Label 15961: @1082246
     /* 1082246 */   GIM_Try, /*On fail goto*//*Label 15962*/ GIMT_Encode4(1082323), // Rule ID 24152 //
     /* 1082251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1082254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1082262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1082265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1082268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082290 */     // MIs[0] policy
     /* 1082290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082300 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082322 */     // GIR_Coverage, 24152,
     /* 1082322 */     GIR_EraseRootFromParent_Done,
     /* 1082323 */   // Label 15962: @1082323
     /* 1082323 */   GIM_Try, /*On fail goto*//*Label 15963*/ GIMT_Encode4(1082400), // Rule ID 24153 //
     /* 1082328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1082331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1082339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1082342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1082345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082367 */     // MIs[0] policy
     /* 1082367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082377 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082399 */     // GIR_Coverage, 24153,
     /* 1082399 */     GIR_EraseRootFromParent_Done,
     /* 1082400 */   // Label 15963: @1082400
     /* 1082400 */   GIM_Try, /*On fail goto*//*Label 15964*/ GIMT_Encode4(1082477), // Rule ID 24156 //
     /* 1082405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1082408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1082416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1082419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1082422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082444 */     // MIs[0] policy
     /* 1082444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082454 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082476 */     // GIR_Coverage, 24156,
     /* 1082476 */     GIR_EraseRootFromParent_Done,
     /* 1082477 */   // Label 15964: @1082477
     /* 1082477 */   GIM_Try, /*On fail goto*//*Label 15965*/ GIMT_Encode4(1082554), // Rule ID 24157 //
     /* 1082482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1082485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1082493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1082496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1082499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082521 */     // MIs[0] policy
     /* 1082521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082531 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082553 */     // GIR_Coverage, 24157,
     /* 1082553 */     GIR_EraseRootFromParent_Done,
     /* 1082554 */   // Label 15965: @1082554
     /* 1082554 */   GIM_Try, /*On fail goto*//*Label 15966*/ GIMT_Encode4(1082631), // Rule ID 24160 //
     /* 1082559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1082562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1082570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1082573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1082576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082598 */     // MIs[0] policy
     /* 1082598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082608 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1082611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082630 */     // GIR_Coverage, 24160,
     /* 1082630 */     GIR_EraseRootFromParent_Done,
     /* 1082631 */   // Label 15966: @1082631
     /* 1082631 */   GIM_Try, /*On fail goto*//*Label 15967*/ GIMT_Encode4(1082708), // Rule ID 24161 //
     /* 1082636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1082639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1082647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1082650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1082653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082675 */     // MIs[0] policy
     /* 1082675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082685 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1082688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082707 */     // GIR_Coverage, 24161,
     /* 1082707 */     GIR_EraseRootFromParent_Done,
     /* 1082708 */   // Label 15967: @1082708
     /* 1082708 */   GIM_Try, /*On fail goto*//*Label 15968*/ GIMT_Encode4(1082785), // Rule ID 24164 //
     /* 1082713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1082716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1082724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1082727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1082730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082752 */     // MIs[0] policy
     /* 1082752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082762 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1082765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082784 */     // GIR_Coverage, 24164,
     /* 1082784 */     GIR_EraseRootFromParent_Done,
     /* 1082785 */   // Label 15968: @1082785
     /* 1082785 */   GIM_Try, /*On fail goto*//*Label 15969*/ GIMT_Encode4(1082862), // Rule ID 24165 //
     /* 1082790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1082793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1082801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1082804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1082807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082829 */     // MIs[0] policy
     /* 1082829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082839 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1082842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082861 */     // GIR_Coverage, 24165,
     /* 1082861 */     GIR_EraseRootFromParent_Done,
     /* 1082862 */   // Label 15969: @1082862
     /* 1082862 */   GIM_Try, /*On fail goto*//*Label 15970*/ GIMT_Encode4(1082939), // Rule ID 24168 //
     /* 1082867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1082870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1082878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1082881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1082884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082906 */     // MIs[0] policy
     /* 1082906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082916 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1082919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082938 */     // GIR_Coverage, 24168,
     /* 1082938 */     GIR_EraseRootFromParent_Done,
     /* 1082939 */   // Label 15970: @1082939
     /* 1082939 */   GIM_Try, /*On fail goto*//*Label 15971*/ GIMT_Encode4(1083016), // Rule ID 24169 //
     /* 1082944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1082947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1082955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1082958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1082961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082983 */     // MIs[0] policy
     /* 1082983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082993 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1082996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083015 */     // GIR_Coverage, 24169,
     /* 1083015 */     GIR_EraseRootFromParent_Done,
     /* 1083016 */   // Label 15971: @1083016
     /* 1083016 */   GIM_Try, /*On fail goto*//*Label 15972*/ GIMT_Encode4(1083093), // Rule ID 24172 //
     /* 1083021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1083024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1083032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1083035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083060 */     // MIs[0] policy
     /* 1083060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083070 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083092 */     // GIR_Coverage, 24172,
     /* 1083092 */     GIR_EraseRootFromParent_Done,
     /* 1083093 */   // Label 15972: @1083093
     /* 1083093 */   GIM_Try, /*On fail goto*//*Label 15973*/ GIMT_Encode4(1083170), // Rule ID 24173 //
     /* 1083098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1083101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1083109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1083112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1083115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083137 */     // MIs[0] policy
     /* 1083137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083147 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083169 */     // GIR_Coverage, 24173,
     /* 1083169 */     GIR_EraseRootFromParent_Done,
     /* 1083170 */   // Label 15973: @1083170
     /* 1083170 */   GIM_Try, /*On fail goto*//*Label 15974*/ GIMT_Encode4(1083247), // Rule ID 24176 //
     /* 1083175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1083178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1083186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1083189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083214 */     // MIs[0] policy
     /* 1083214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083224 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083246 */     // GIR_Coverage, 24176,
     /* 1083246 */     GIR_EraseRootFromParent_Done,
     /* 1083247 */   // Label 15974: @1083247
     /* 1083247 */   GIM_Try, /*On fail goto*//*Label 15975*/ GIMT_Encode4(1083324), // Rule ID 24177 //
     /* 1083252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1083255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1083263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1083266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1083269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083291 */     // MIs[0] policy
     /* 1083291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083301 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083323 */     // GIR_Coverage, 24177,
     /* 1083323 */     GIR_EraseRootFromParent_Done,
     /* 1083324 */   // Label 15975: @1083324
     /* 1083324 */   GIM_Try, /*On fail goto*//*Label 15976*/ GIMT_Encode4(1083401), // Rule ID 24180 //
     /* 1083329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1083332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1083340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1083343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083368 */     // MIs[0] policy
     /* 1083368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083378 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083400 */     // GIR_Coverage, 24180,
     /* 1083400 */     GIR_EraseRootFromParent_Done,
     /* 1083401 */   // Label 15976: @1083401
     /* 1083401 */   GIM_Try, /*On fail goto*//*Label 15977*/ GIMT_Encode4(1083478), // Rule ID 24181 //
     /* 1083406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1083409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1083417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1083420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1083423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083445 */     // MIs[0] policy
     /* 1083445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083455 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083477 */     // GIR_Coverage, 24181,
     /* 1083477 */     GIR_EraseRootFromParent_Done,
     /* 1083478 */   // Label 15977: @1083478
     /* 1083478 */   GIM_Try, /*On fail goto*//*Label 15978*/ GIMT_Encode4(1083555), // Rule ID 24184 //
     /* 1083483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1083486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1083494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1083497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1083500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083522 */     // MIs[0] policy
     /* 1083522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083532 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083554 */     // GIR_Coverage, 24184,
     /* 1083554 */     GIR_EraseRootFromParent_Done,
     /* 1083555 */   // Label 15978: @1083555
     /* 1083555 */   GIM_Try, /*On fail goto*//*Label 15979*/ GIMT_Encode4(1083632), // Rule ID 24185 //
     /* 1083560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1083563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1083571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1083574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1083577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083599 */     // MIs[0] policy
     /* 1083599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083609 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083631 */     // GIR_Coverage, 24185,
     /* 1083631 */     GIR_EraseRootFromParent_Done,
     /* 1083632 */   // Label 15979: @1083632
     /* 1083632 */   GIM_Try, /*On fail goto*//*Label 15980*/ GIMT_Encode4(1083709), // Rule ID 24188 //
     /* 1083637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1083640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1083648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1083651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1083654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083676 */     // MIs[0] policy
     /* 1083676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083686 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083708 */     // GIR_Coverage, 24188,
     /* 1083708 */     GIR_EraseRootFromParent_Done,
     /* 1083709 */   // Label 15980: @1083709
     /* 1083709 */   GIM_Try, /*On fail goto*//*Label 15981*/ GIMT_Encode4(1083786), // Rule ID 24189 //
     /* 1083714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1083717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1083725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1083728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1083731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083753 */     // MIs[0] policy
     /* 1083753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083763 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083785 */     // GIR_Coverage, 24189,
     /* 1083785 */     GIR_EraseRootFromParent_Done,
     /* 1083786 */   // Label 15981: @1083786
     /* 1083786 */   GIM_Try, /*On fail goto*//*Label 15982*/ GIMT_Encode4(1083863), // Rule ID 24192 //
     /* 1083791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1083794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1083802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1083805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1083808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083830 */     // MIs[0] policy
     /* 1083830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083862 */     // GIR_Coverage, 24192,
     /* 1083862 */     GIR_EraseRootFromParent_Done,
     /* 1083863 */   // Label 15982: @1083863
     /* 1083863 */   GIM_Try, /*On fail goto*//*Label 15983*/ GIMT_Encode4(1083940), // Rule ID 24193 //
     /* 1083868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1083871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1083879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1083882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1083885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083907 */     // MIs[0] policy
     /* 1083907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083917 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083939 */     // GIR_Coverage, 24193,
     /* 1083939 */     GIR_EraseRootFromParent_Done,
     /* 1083940 */   // Label 15983: @1083940
     /* 1083940 */   GIM_Try, /*On fail goto*//*Label 15984*/ GIMT_Encode4(1084017), // Rule ID 24256 //
     /* 1083945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1083948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1083956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1083959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1083962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083984 */     // MIs[0] policy
     /* 1083984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083994 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1083997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084016 */     // GIR_Coverage, 24256,
     /* 1084016 */     GIR_EraseRootFromParent_Done,
     /* 1084017 */   // Label 15984: @1084017
     /* 1084017 */   GIM_Try, /*On fail goto*//*Label 15985*/ GIMT_Encode4(1084094), // Rule ID 24257 //
     /* 1084022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1084025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1084033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1084036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1084039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084061 */     // MIs[0] policy
     /* 1084061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084071 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1084074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084093 */     // GIR_Coverage, 24257,
     /* 1084093 */     GIR_EraseRootFromParent_Done,
     /* 1084094 */   // Label 15985: @1084094
     /* 1084094 */   GIM_Try, /*On fail goto*//*Label 15986*/ GIMT_Encode4(1084171), // Rule ID 24260 //
     /* 1084099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1084102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1084110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1084113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084138 */     // MIs[0] policy
     /* 1084138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084148 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084170 */     // GIR_Coverage, 24260,
     /* 1084170 */     GIR_EraseRootFromParent_Done,
     /* 1084171 */   // Label 15986: @1084171
     /* 1084171 */   GIM_Try, /*On fail goto*//*Label 15987*/ GIMT_Encode4(1084248), // Rule ID 24261 //
     /* 1084176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1084179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1084187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1084190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1084193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084215 */     // MIs[0] policy
     /* 1084215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084225 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084247 */     // GIR_Coverage, 24261,
     /* 1084247 */     GIR_EraseRootFromParent_Done,
     /* 1084248 */   // Label 15987: @1084248
     /* 1084248 */   GIM_Try, /*On fail goto*//*Label 15988*/ GIMT_Encode4(1084325), // Rule ID 24264 //
     /* 1084253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1084256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1084264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1084267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1084270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084292 */     // MIs[0] policy
     /* 1084292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084302 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084324 */     // GIR_Coverage, 24264,
     /* 1084324 */     GIR_EraseRootFromParent_Done,
     /* 1084325 */   // Label 15988: @1084325
     /* 1084325 */   GIM_Try, /*On fail goto*//*Label 15989*/ GIMT_Encode4(1084402), // Rule ID 24265 //
     /* 1084330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1084333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1084341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1084344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1084347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084369 */     // MIs[0] policy
     /* 1084369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084379 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1084382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084401 */     // GIR_Coverage, 24265,
     /* 1084401 */     GIR_EraseRootFromParent_Done,
     /* 1084402 */   // Label 15989: @1084402
     /* 1084402 */   GIM_Try, /*On fail goto*//*Label 15990*/ GIMT_Encode4(1084479), // Rule ID 24268 //
     /* 1084407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1084410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1084418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1084421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1084424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084446 */     // MIs[0] policy
     /* 1084446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084456 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084478 */     // GIR_Coverage, 24268,
     /* 1084478 */     GIR_EraseRootFromParent_Done,
     /* 1084479 */   // Label 15990: @1084479
     /* 1084479 */   GIM_Try, /*On fail goto*//*Label 15991*/ GIMT_Encode4(1084556), // Rule ID 24269 //
     /* 1084484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1084487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1084495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1084498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1084501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084523 */     // MIs[0] policy
     /* 1084523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084533 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084555 */     // GIR_Coverage, 24269,
     /* 1084555 */     GIR_EraseRootFromParent_Done,
     /* 1084556 */   // Label 15991: @1084556
     /* 1084556 */   GIM_Try, /*On fail goto*//*Label 15992*/ GIMT_Encode4(1084633), // Rule ID 24272 //
     /* 1084561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1084564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1084572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1084575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1084578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084600 */     // MIs[0] policy
     /* 1084600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084610 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084632 */     // GIR_Coverage, 24272,
     /* 1084632 */     GIR_EraseRootFromParent_Done,
     /* 1084633 */   // Label 15992: @1084633
     /* 1084633 */   GIM_Try, /*On fail goto*//*Label 15993*/ GIMT_Encode4(1084710), // Rule ID 24273 //
     /* 1084638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1084641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1084649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1084652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1084655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084677 */     // MIs[0] policy
     /* 1084677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084687 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084709 */     // GIR_Coverage, 24273,
     /* 1084709 */     GIR_EraseRootFromParent_Done,
     /* 1084710 */   // Label 15993: @1084710
     /* 1084710 */   GIM_Try, /*On fail goto*//*Label 15994*/ GIMT_Encode4(1084787), // Rule ID 24276 //
     /* 1084715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1084718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1084726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1084729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1084732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084754 */     // MIs[0] policy
     /* 1084754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084764 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084786 */     // GIR_Coverage, 24276,
     /* 1084786 */     GIR_EraseRootFromParent_Done,
     /* 1084787 */   // Label 15994: @1084787
     /* 1084787 */   GIM_Try, /*On fail goto*//*Label 15995*/ GIMT_Encode4(1084864), // Rule ID 24277 //
     /* 1084792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1084795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1084803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1084806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1084809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084831 */     // MIs[0] policy
     /* 1084831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084841 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084863 */     // GIR_Coverage, 24277,
     /* 1084863 */     GIR_EraseRootFromParent_Done,
     /* 1084864 */   // Label 15995: @1084864
     /* 1084864 */   GIM_Try, /*On fail goto*//*Label 15996*/ GIMT_Encode4(1084941), // Rule ID 24280 //
     /* 1084869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1084872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084908 */     // MIs[0] policy
     /* 1084908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084918 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084940 */     // GIR_Coverage, 24280,
     /* 1084940 */     GIR_EraseRootFromParent_Done,
     /* 1084941 */   // Label 15996: @1084941
     /* 1084941 */   GIM_Try, /*On fail goto*//*Label 15997*/ GIMT_Encode4(1085018), // Rule ID 24281 //
     /* 1084946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1084949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084985 */     // MIs[0] policy
     /* 1084985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084995 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085017 */     // GIR_Coverage, 24281,
     /* 1085017 */     GIR_EraseRootFromParent_Done,
     /* 1085018 */   // Label 15997: @1085018
     /* 1085018 */   GIM_Try, /*On fail goto*//*Label 15998*/ GIMT_Encode4(1085095), // Rule ID 24284 //
     /* 1085023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1085026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1085034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1085037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085062 */     // MIs[0] policy
     /* 1085062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085072 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085094 */     // GIR_Coverage, 24284,
     /* 1085094 */     GIR_EraseRootFromParent_Done,
     /* 1085095 */   // Label 15998: @1085095
     /* 1085095 */   GIM_Try, /*On fail goto*//*Label 15999*/ GIMT_Encode4(1085172), // Rule ID 24285 //
     /* 1085100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1085103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1085111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1085114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1085117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085139 */     // MIs[0] policy
     /* 1085139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085149 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085171 */     // GIR_Coverage, 24285,
     /* 1085171 */     GIR_EraseRootFromParent_Done,
     /* 1085172 */   // Label 15999: @1085172
     /* 1085172 */   GIM_Try, /*On fail goto*//*Label 16000*/ GIMT_Encode4(1085249), // Rule ID 24288 //
     /* 1085177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1085180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1085188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1085191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085216 */     // MIs[0] policy
     /* 1085216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085226 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085248 */     // GIR_Coverage, 24288,
     /* 1085248 */     GIR_EraseRootFromParent_Done,
     /* 1085249 */   // Label 16000: @1085249
     /* 1085249 */   GIM_Try, /*On fail goto*//*Label 16001*/ GIMT_Encode4(1085326), // Rule ID 24289 //
     /* 1085254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1085257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1085265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1085268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1085271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085293 */     // MIs[0] policy
     /* 1085293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085303 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1085322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085325 */     // GIR_Coverage, 24289,
     /* 1085325 */     GIR_EraseRootFromParent_Done,
     /* 1085326 */   // Label 16001: @1085326
     /* 1085326 */   GIM_Try, /*On fail goto*//*Label 16002*/ GIMT_Encode4(1085403), // Rule ID 24292 //
     /* 1085331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1085334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1085342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1085345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1085348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085370 */     // MIs[0] policy
     /* 1085370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085380 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085402 */     // GIR_Coverage, 24292,
     /* 1085402 */     GIR_EraseRootFromParent_Done,
     /* 1085403 */   // Label 16002: @1085403
     /* 1085403 */   GIM_Try, /*On fail goto*//*Label 16003*/ GIMT_Encode4(1085480), // Rule ID 24293 //
     /* 1085408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1085411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1085419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1085422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1085425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085447 */     // MIs[0] policy
     /* 1085447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085457 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085479 */     // GIR_Coverage, 24293,
     /* 1085479 */     GIR_EraseRootFromParent_Done,
     /* 1085480 */   // Label 16003: @1085480
     /* 1085480 */   GIM_Try, /*On fail goto*//*Label 16004*/ GIMT_Encode4(1085557), // Rule ID 24296 //
     /* 1085485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1085488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1085496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1085499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1085502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085524 */     // MIs[0] policy
     /* 1085524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085534 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085556 */     // GIR_Coverage, 24296,
     /* 1085556 */     GIR_EraseRootFromParent_Done,
     /* 1085557 */   // Label 16004: @1085557
     /* 1085557 */   GIM_Try, /*On fail goto*//*Label 16005*/ GIMT_Encode4(1085634), // Rule ID 24297 //
     /* 1085562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1085565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1085573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1085576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1085579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085601 */     // MIs[0] policy
     /* 1085601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085611 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085633 */     // GIR_Coverage, 24297,
     /* 1085633 */     GIR_EraseRootFromParent_Done,
     /* 1085634 */   // Label 16005: @1085634
     /* 1085634 */   GIM_Try, /*On fail goto*//*Label 16006*/ GIMT_Encode4(1085711), // Rule ID 24300 //
     /* 1085639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1085642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1085650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1085653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1085656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085678 */     // MIs[0] policy
     /* 1085678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085688 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085710 */     // GIR_Coverage, 24300,
     /* 1085710 */     GIR_EraseRootFromParent_Done,
     /* 1085711 */   // Label 16006: @1085711
     /* 1085711 */   GIM_Try, /*On fail goto*//*Label 16007*/ GIMT_Encode4(1085788), // Rule ID 24301 //
     /* 1085716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1085719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1085727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1085730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1085733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085755 */     // MIs[0] policy
     /* 1085755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085765 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085787 */     // GIR_Coverage, 24301,
     /* 1085787 */     GIR_EraseRootFromParent_Done,
     /* 1085788 */   // Label 16007: @1085788
     /* 1085788 */   GIM_Try, /*On fail goto*//*Label 16008*/ GIMT_Encode4(1085865), // Rule ID 24304 //
     /* 1085793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1085796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085832 */     // MIs[0] policy
     /* 1085832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085842 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085864 */     // GIR_Coverage, 24304,
     /* 1085864 */     GIR_EraseRootFromParent_Done,
     /* 1085865 */   // Label 16008: @1085865
     /* 1085865 */   GIM_Try, /*On fail goto*//*Label 16009*/ GIMT_Encode4(1085942), // Rule ID 24305 //
     /* 1085870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1085873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085909 */     // MIs[0] policy
     /* 1085909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085919 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085941 */     // GIR_Coverage, 24305,
     /* 1085941 */     GIR_EraseRootFromParent_Done,
     /* 1085942 */   // Label 16009: @1085942
     /* 1085942 */   GIM_Try, /*On fail goto*//*Label 16010*/ GIMT_Encode4(1086019), // Rule ID 24308 //
     /* 1085947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1085950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1085958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1085961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1085964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085986 */     // MIs[0] policy
     /* 1085986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085996 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086018 */     // GIR_Coverage, 24308,
     /* 1086018 */     GIR_EraseRootFromParent_Done,
     /* 1086019 */   // Label 16010: @1086019
     /* 1086019 */   GIM_Try, /*On fail goto*//*Label 16011*/ GIMT_Encode4(1086096), // Rule ID 24309 //
     /* 1086024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1086027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1086035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1086038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1086041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1086059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086063 */     // MIs[0] policy
     /* 1086063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086073 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1086076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086095 */     // GIR_Coverage, 24309,
     /* 1086095 */     GIR_EraseRootFromParent_Done,
     /* 1086096 */   // Label 16011: @1086096
     /* 1086096 */   GIM_Try, /*On fail goto*//*Label 16012*/ GIMT_Encode4(1086173), // Rule ID 24312 //
     /* 1086101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1086104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1086112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1086115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1086118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1086121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086140 */     // MIs[0] policy
     /* 1086140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086150 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086172 */     // GIR_Coverage, 24312,
     /* 1086172 */     GIR_EraseRootFromParent_Done,
     /* 1086173 */   // Label 16012: @1086173
     /* 1086173 */   GIM_Try, /*On fail goto*//*Label 16013*/ GIMT_Encode4(1086250), // Rule ID 24313 //
     /* 1086178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1086181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1086186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1086189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1086192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1086195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1086198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1086213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1086217 */     // MIs[0] policy
     /* 1086217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086227 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1086230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1086246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086249 */     // GIR_Coverage, 24313,
     /* 1086249 */     GIR_EraseRootFromParent_Done,
     /* 1086250 */   // Label 16013: @1086250
     /* 1086250 */   GIM_Try, /*On fail goto*//*Label 16014*/ GIMT_Encode4(1086327), // Rule ID 60604 //
     /* 1086255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1086258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1086263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086294 */     // MIs[0] policy
     /* 1086294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086304 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1086307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1086309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086326 */     // GIR_Coverage, 60604,
     /* 1086326 */     GIR_EraseRootFromParent_Done,
     /* 1086327 */   // Label 16014: @1086327
     /* 1086327 */   GIM_Try, /*On fail goto*//*Label 16015*/ GIMT_Encode4(1086404), // Rule ID 60605 //
     /* 1086332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1086335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1086340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1086352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086371 */     // MIs[0] policy
     /* 1086371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086381 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1086384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1086386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1086388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1086390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1086392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086403 */     // GIR_Coverage, 60605,
     /* 1086403 */     GIR_EraseRootFromParent_Done,
     /* 1086404 */   // Label 16015: @1086404
     /* 1086404 */   GIM_Try, /*On fail goto*//*Label 16016*/ GIMT_Encode4(1086481), // Rule ID 60618 //
     /* 1086409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1086420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1086423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1086426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086448 */     // MIs[0] policy
     /* 1086448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086458 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1086461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086480 */     // GIR_Coverage, 60618,
     /* 1086480 */     GIR_EraseRootFromParent_Done,
     /* 1086481 */   // Label 16016: @1086481
     /* 1086481 */   GIM_Try, /*On fail goto*//*Label 16017*/ GIMT_Encode4(1086558), // Rule ID 60619 //
     /* 1086486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1086497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1086500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1086503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086525 */     // MIs[0] policy
     /* 1086525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086535 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1086538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086557 */     // GIR_Coverage, 60619,
     /* 1086557 */     GIR_EraseRootFromParent_Done,
     /* 1086558 */   // Label 16017: @1086558
     /* 1086558 */   GIM_Try, /*On fail goto*//*Label 16018*/ GIMT_Encode4(1086635), // Rule ID 60622 //
     /* 1086563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1086574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1086577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1086580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1086583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086602 */     // MIs[0] policy
     /* 1086602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086612 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086634 */     // GIR_Coverage, 60622,
     /* 1086634 */     GIR_EraseRootFromParent_Done,
     /* 1086635 */   // Label 16018: @1086635
     /* 1086635 */   GIM_Try, /*On fail goto*//*Label 16019*/ GIMT_Encode4(1086712), // Rule ID 60623 //
     /* 1086640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1086651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1086654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1086657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1086660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086679 */     // MIs[0] policy
     /* 1086679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086689 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086711 */     // GIR_Coverage, 60623,
     /* 1086711 */     GIR_EraseRootFromParent_Done,
     /* 1086712 */   // Label 16019: @1086712
     /* 1086712 */   GIM_Try, /*On fail goto*//*Label 16020*/ GIMT_Encode4(1086789), // Rule ID 60626 //
     /* 1086717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1086728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1086731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1086734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1086737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086756 */     // MIs[0] policy
     /* 1086756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086788 */     // GIR_Coverage, 60626,
     /* 1086788 */     GIR_EraseRootFromParent_Done,
     /* 1086789 */   // Label 16020: @1086789
     /* 1086789 */   GIM_Try, /*On fail goto*//*Label 16021*/ GIMT_Encode4(1086866), // Rule ID 60627 //
     /* 1086794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1086805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1086808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1086811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1086814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086833 */     // MIs[0] policy
     /* 1086833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086843 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086865 */     // GIR_Coverage, 60627,
     /* 1086865 */     GIR_EraseRootFromParent_Done,
     /* 1086866 */   // Label 16021: @1086866
     /* 1086866 */   GIM_Try, /*On fail goto*//*Label 16022*/ GIMT_Encode4(1086943), // Rule ID 60630 //
     /* 1086871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1086882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1086885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1086888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086910 */     // MIs[0] policy
     /* 1086910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086942 */     // GIR_Coverage, 60630,
     /* 1086942 */     GIR_EraseRootFromParent_Done,
     /* 1086943 */   // Label 16022: @1086943
     /* 1086943 */   GIM_Try, /*On fail goto*//*Label 16023*/ GIMT_Encode4(1087020), // Rule ID 60631 //
     /* 1086948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1086959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1086962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1086965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086987 */     // MIs[0] policy
     /* 1086987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086997 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1087000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087019 */     // GIR_Coverage, 60631,
     /* 1087019 */     GIR_EraseRootFromParent_Done,
     /* 1087020 */   // Label 16023: @1087020
     /* 1087020 */   GIM_Try, /*On fail goto*//*Label 16024*/ GIMT_Encode4(1087097), // Rule ID 60634 //
     /* 1087025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087064 */     // MIs[0] policy
     /* 1087064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087074 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087096 */     // GIR_Coverage, 60634,
     /* 1087096 */     GIR_EraseRootFromParent_Done,
     /* 1087097 */   // Label 16024: @1087097
     /* 1087097 */   GIM_Try, /*On fail goto*//*Label 16025*/ GIMT_Encode4(1087174), // Rule ID 60635 //
     /* 1087102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1087113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1087116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1087119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087141 */     // MIs[0] policy
     /* 1087141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087151 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087160 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087173 */     // GIR_Coverage, 60635,
     /* 1087173 */     GIR_EraseRootFromParent_Done,
     /* 1087174 */   // Label 16025: @1087174
     /* 1087174 */   GIM_Try, /*On fail goto*//*Label 16026*/ GIMT_Encode4(1087251), // Rule ID 60638 //
     /* 1087179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1087190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1087193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1087196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087218 */     // MIs[0] policy
     /* 1087218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087228 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087250 */     // GIR_Coverage, 60638,
     /* 1087250 */     GIR_EraseRootFromParent_Done,
     /* 1087251 */   // Label 16026: @1087251
     /* 1087251 */   GIM_Try, /*On fail goto*//*Label 16027*/ GIMT_Encode4(1087328), // Rule ID 60639 //
     /* 1087256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1087267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1087270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1087273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087295 */     // MIs[0] policy
     /* 1087295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087305 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1087308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087327 */     // GIR_Coverage, 60639,
     /* 1087327 */     GIR_EraseRootFromParent_Done,
     /* 1087328 */   // Label 16027: @1087328
     /* 1087328 */   GIM_Try, /*On fail goto*//*Label 16028*/ GIMT_Encode4(1087405), // Rule ID 60642 //
     /* 1087333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1087350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1087353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087372 */     // MIs[0] policy
     /* 1087372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087382 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087404 */     // GIR_Coverage, 60642,
     /* 1087404 */     GIR_EraseRootFromParent_Done,
     /* 1087405 */   // Label 16028: @1087405
     /* 1087405 */   GIM_Try, /*On fail goto*//*Label 16029*/ GIMT_Encode4(1087482), // Rule ID 60643 //
     /* 1087410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1087421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1087424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1087427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1087430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087449 */     // MIs[0] policy
     /* 1087449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087459 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087481 */     // GIR_Coverage, 60643,
     /* 1087481 */     GIR_EraseRootFromParent_Done,
     /* 1087482 */   // Label 16029: @1087482
     /* 1087482 */   GIM_Try, /*On fail goto*//*Label 16030*/ GIMT_Encode4(1087559), // Rule ID 60646 //
     /* 1087487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1087498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1087501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1087504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087526 */     // MIs[0] policy
     /* 1087526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087536 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087558 */     // GIR_Coverage, 60646,
     /* 1087558 */     GIR_EraseRootFromParent_Done,
     /* 1087559 */   // Label 16030: @1087559
     /* 1087559 */   GIM_Try, /*On fail goto*//*Label 16031*/ GIMT_Encode4(1087636), // Rule ID 60647 //
     /* 1087564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1087575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1087578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1087581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087603 */     // MIs[0] policy
     /* 1087603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087613 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087635 */     // GIR_Coverage, 60647,
     /* 1087635 */     GIR_EraseRootFromParent_Done,
     /* 1087636 */   // Label 16031: @1087636
     /* 1087636 */   GIM_Try, /*On fail goto*//*Label 16032*/ GIMT_Encode4(1087713), // Rule ID 60650 //
     /* 1087641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1087652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1087655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1087658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087680 */     // MIs[0] policy
     /* 1087680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087712 */     // GIR_Coverage, 60650,
     /* 1087712 */     GIR_EraseRootFromParent_Done,
     /* 1087713 */   // Label 16032: @1087713
     /* 1087713 */   GIM_Try, /*On fail goto*//*Label 16033*/ GIMT_Encode4(1087790), // Rule ID 60651 //
     /* 1087718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1087729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1087732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1087735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087757 */     // MIs[0] policy
     /* 1087757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087767 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087789 */     // GIR_Coverage, 60651,
     /* 1087789 */     GIR_EraseRootFromParent_Done,
     /* 1087790 */   // Label 16033: @1087790
     /* 1087790 */   GIM_Try, /*On fail goto*//*Label 16034*/ GIMT_Encode4(1087867), // Rule ID 60654 //
     /* 1087795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1087806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1087809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1087812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087834 */     // MIs[0] policy
     /* 1087834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087844 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087866 */     // GIR_Coverage, 60654,
     /* 1087866 */     GIR_EraseRootFromParent_Done,
     /* 1087867 */   // Label 16034: @1087867
     /* 1087867 */   GIM_Try, /*On fail goto*//*Label 16035*/ GIMT_Encode4(1087944), // Rule ID 60655 //
     /* 1087872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1087883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1087886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1087889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087911 */     // MIs[0] policy
     /* 1087911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087921 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087930 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087943 */     // GIR_Coverage, 60655,
     /* 1087943 */     GIR_EraseRootFromParent_Done,
     /* 1087944 */   // Label 16035: @1087944
     /* 1087944 */   GIM_Try, /*On fail goto*//*Label 16036*/ GIMT_Encode4(1088021), // Rule ID 60658 //
     /* 1087949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1087960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1087963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1087966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1087969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1087976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087988 */     // MIs[0] policy
     /* 1087988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087998 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088020 */     // GIR_Coverage, 60658,
     /* 1088020 */     GIR_EraseRootFromParent_Done,
     /* 1088021 */   // Label 16036: @1088021
     /* 1088021 */   GIM_Try, /*On fail goto*//*Label 16037*/ GIMT_Encode4(1088098), // Rule ID 60659 //
     /* 1088026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1088037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1088040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1088043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088065 */     // MIs[0] policy
     /* 1088065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088075 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088097 */     // GIR_Coverage, 60659,
     /* 1088097 */     GIR_EraseRootFromParent_Done,
     /* 1088098 */   // Label 16037: @1088098
     /* 1088098 */   GIM_Try, /*On fail goto*//*Label 16038*/ GIMT_Encode4(1088175), // Rule ID 60662 //
     /* 1088103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1088114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1088117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1088120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088142 */     // MIs[0] policy
     /* 1088142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088152 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088174 */     // GIR_Coverage, 60662,
     /* 1088174 */     GIR_EraseRootFromParent_Done,
     /* 1088175 */   // Label 16038: @1088175
     /* 1088175 */   GIM_Try, /*On fail goto*//*Label 16039*/ GIMT_Encode4(1088252), // Rule ID 60663 //
     /* 1088180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1088191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1088194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1088197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088219 */     // MIs[0] policy
     /* 1088219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088229 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088251 */     // GIR_Coverage, 60663,
     /* 1088251 */     GIR_EraseRootFromParent_Done,
     /* 1088252 */   // Label 16039: @1088252
     /* 1088252 */   GIM_Try, /*On fail goto*//*Label 16040*/ GIMT_Encode4(1088329), // Rule ID 60666 //
     /* 1088257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1088268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1088271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1088274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1088277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088296 */     // MIs[0] policy
     /* 1088296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088306 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088328 */     // GIR_Coverage, 60666,
     /* 1088328 */     GIR_EraseRootFromParent_Done,
     /* 1088329 */   // Label 16040: @1088329
     /* 1088329 */   GIM_Try, /*On fail goto*//*Label 16041*/ GIMT_Encode4(1088406), // Rule ID 60667 //
     /* 1088334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1088345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1088348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1088351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1088354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088373 */     // MIs[0] policy
     /* 1088373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088383 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088392 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1088402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088405 */     // GIR_Coverage, 60667,
     /* 1088405 */     GIR_EraseRootFromParent_Done,
     /* 1088406 */   // Label 16041: @1088406
     /* 1088406 */   GIM_Try, /*On fail goto*//*Label 16042*/ GIMT_Encode4(1088483), // Rule ID 60670 //
     /* 1088411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088450 */     // MIs[0] policy
     /* 1088450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088482 */     // GIR_Coverage, 60670,
     /* 1088482 */     GIR_EraseRootFromParent_Done,
     /* 1088483 */   // Label 16042: @1088483
     /* 1088483 */   GIM_Try, /*On fail goto*//*Label 16043*/ GIMT_Encode4(1088560), // Rule ID 60671 //
     /* 1088488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1088499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1088502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1088505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088527 */     // MIs[0] policy
     /* 1088527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088537 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088546 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088559 */     // GIR_Coverage, 60671,
     /* 1088559 */     GIR_EraseRootFromParent_Done,
     /* 1088560 */   // Label 16043: @1088560
     /* 1088560 */   GIM_Try, /*On fail goto*//*Label 16044*/ GIMT_Encode4(1088637), // Rule ID 60674 //
     /* 1088565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088604 */     // MIs[0] policy
     /* 1088604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088636 */     // GIR_Coverage, 60674,
     /* 1088636 */     GIR_EraseRootFromParent_Done,
     /* 1088637 */   // Label 16044: @1088637
     /* 1088637 */   GIM_Try, /*On fail goto*//*Label 16045*/ GIMT_Encode4(1088714), // Rule ID 60675 //
     /* 1088642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088681 */     // MIs[0] policy
     /* 1088681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088691 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088713 */     // GIR_Coverage, 60675,
     /* 1088713 */     GIR_EraseRootFromParent_Done,
     /* 1088714 */   // Label 16045: @1088714
     /* 1088714 */   GIM_Try, /*On fail goto*//*Label 16046*/ GIMT_Encode4(1088791), // Rule ID 60678 //
     /* 1088719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1088730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1088733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1088736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088758 */     // MIs[0] policy
     /* 1088758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088790 */     // GIR_Coverage, 60678,
     /* 1088790 */     GIR_EraseRootFromParent_Done,
     /* 1088791 */   // Label 16046: @1088791
     /* 1088791 */   GIM_Try, /*On fail goto*//*Label 16047*/ GIMT_Encode4(1088868), // Rule ID 60679 //
     /* 1088796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1088807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1088810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1088813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088835 */     // MIs[0] policy
     /* 1088835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088845 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088867 */     // GIR_Coverage, 60679,
     /* 1088867 */     GIR_EraseRootFromParent_Done,
     /* 1088868 */   // Label 16047: @1088868
     /* 1088868 */   GIM_Try, /*On fail goto*//*Label 16048*/ GIMT_Encode4(1088945), // Rule ID 60682 //
     /* 1088873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1088884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1088887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1088890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1088893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088912 */     // MIs[0] policy
     /* 1088912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088944 */     // GIR_Coverage, 60682,
     /* 1088944 */     GIR_EraseRootFromParent_Done,
     /* 1088945 */   // Label 16048: @1088945
     /* 1088945 */   GIM_Try, /*On fail goto*//*Label 16049*/ GIMT_Encode4(1089022), // Rule ID 60683 //
     /* 1088950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1088961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1088964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1088967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1088970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088989 */     // MIs[0] policy
     /* 1088989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088999 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089021 */     // GIR_Coverage, 60683,
     /* 1089021 */     GIR_EraseRootFromParent_Done,
     /* 1089022 */   // Label 16049: @1089022
     /* 1089022 */   GIM_Try, /*On fail goto*//*Label 16050*/ GIMT_Encode4(1089099), // Rule ID 60686 //
     /* 1089027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089066 */     // MIs[0] policy
     /* 1089066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089098 */     // GIR_Coverage, 60686,
     /* 1089098 */     GIR_EraseRootFromParent_Done,
     /* 1089099 */   // Label 16050: @1089099
     /* 1089099 */   GIM_Try, /*On fail goto*//*Label 16051*/ GIMT_Encode4(1089176), // Rule ID 60687 //
     /* 1089104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1089115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1089118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1089121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089143 */     // MIs[0] policy
     /* 1089143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089153 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089175 */     // GIR_Coverage, 60687,
     /* 1089175 */     GIR_EraseRootFromParent_Done,
     /* 1089176 */   // Label 16051: @1089176
     /* 1089176 */   GIM_Try, /*On fail goto*//*Label 16052*/ GIMT_Encode4(1089253), // Rule ID 60690 //
     /* 1089181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089220 */     // MIs[0] policy
     /* 1089220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089230 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089252 */     // GIR_Coverage, 60690,
     /* 1089252 */     GIR_EraseRootFromParent_Done,
     /* 1089253 */   // Label 16052: @1089253
     /* 1089253 */   GIM_Try, /*On fail goto*//*Label 16053*/ GIMT_Encode4(1089330), // Rule ID 60691 //
     /* 1089258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1089269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1089272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1089275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1089278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089297 */     // MIs[0] policy
     /* 1089297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089307 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1089326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089329 */     // GIR_Coverage, 60691,
     /* 1089329 */     GIR_EraseRootFromParent_Done,
     /* 1089330 */   // Label 16053: @1089330
     /* 1089330 */   GIM_Try, /*On fail goto*//*Label 16054*/ GIMT_Encode4(1089407), // Rule ID 60694 //
     /* 1089335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089374 */     // MIs[0] policy
     /* 1089374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089384 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089406 */     // GIR_Coverage, 60694,
     /* 1089406 */     GIR_EraseRootFromParent_Done,
     /* 1089407 */   // Label 16054: @1089407
     /* 1089407 */   GIM_Try, /*On fail goto*//*Label 16055*/ GIMT_Encode4(1089484), // Rule ID 60695 //
     /* 1089412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1089423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1089426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1089429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1089439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1089447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089451 */     // MIs[0] policy
     /* 1089451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089461 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1089464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089483 */     // GIR_Coverage, 60695,
     /* 1089483 */     GIR_EraseRootFromParent_Done,
     /* 1089484 */   // Label 16055: @1089484
     /* 1089484 */   GIM_Try, /*On fail goto*//*Label 16056*/ GIMT_Encode4(1089561), // Rule ID 60698 //
     /* 1089489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089528 */     // MIs[0] policy
     /* 1089528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089538 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089560 */     // GIR_Coverage, 60698,
     /* 1089560 */     GIR_EraseRootFromParent_Done,
     /* 1089561 */   // Label 16056: @1089561
     /* 1089561 */   GIM_Try, /*On fail goto*//*Label 16057*/ GIMT_Encode4(1089638), // Rule ID 60699 //
     /* 1089566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089605 */     // MIs[0] policy
     /* 1089605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089615 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089637 */     // GIR_Coverage, 60699,
     /* 1089637 */     GIR_EraseRootFromParent_Done,
     /* 1089638 */   // Label 16057: @1089638
     /* 1089638 */   GIM_Try, /*On fail goto*//*Label 16058*/ GIMT_Encode4(1089715), // Rule ID 60702 //
     /* 1089643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1089654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1089657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089682 */     // MIs[0] policy
     /* 1089682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089692 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089714 */     // GIR_Coverage, 60702,
     /* 1089714 */     GIR_EraseRootFromParent_Done,
     /* 1089715 */   // Label 16058: @1089715
     /* 1089715 */   GIM_Try, /*On fail goto*//*Label 16059*/ GIMT_Encode4(1089792), // Rule ID 60703 //
     /* 1089720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1089731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1089734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089759 */     // MIs[0] policy
     /* 1089759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089769 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11165:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089791 */     // GIR_Coverage, 60703,
     /* 1089791 */     GIR_EraseRootFromParent_Done,
     /* 1089792 */   // Label 16059: @1089792
     /* 1089792 */   GIM_Try, /*On fail goto*//*Label 16060*/ GIMT_Encode4(1089869), // Rule ID 60706 //
     /* 1089797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1089808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1089811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1089814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1089817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089836 */     // MIs[0] policy
     /* 1089836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089846 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1089849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089868 */     // GIR_Coverage, 60706,
     /* 1089868 */     GIR_EraseRootFromParent_Done,
     /* 1089869 */   // Label 16060: @1089869
     /* 1089869 */   GIM_Try, /*On fail goto*//*Label 16061*/ GIMT_Encode4(1089946), // Rule ID 60707 //
     /* 1089874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1089885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1089888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1089891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1089894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089913 */     // MIs[0] policy
     /* 1089913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089923 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1089926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089945 */     // GIR_Coverage, 60707,
     /* 1089945 */     GIR_EraseRootFromParent_Done,
     /* 1089946 */   // Label 16061: @1089946
     /* 1089946 */   GIM_Try, /*On fail goto*//*Label 16062*/ GIMT_Encode4(1090023), // Rule ID 60710 //
     /* 1089951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1089962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1089965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1089968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089990 */     // MIs[0] policy
     /* 1089990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090000 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090022 */     // GIR_Coverage, 60710,
     /* 1090022 */     GIR_EraseRootFromParent_Done,
     /* 1090023 */   // Label 16062: @1090023
     /* 1090023 */   GIM_Try, /*On fail goto*//*Label 16063*/ GIMT_Encode4(1090100), // Rule ID 60711 //
     /* 1090028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1090039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1090042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1090045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090067 */     // MIs[0] policy
     /* 1090067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090077 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090099 */     // GIR_Coverage, 60711,
     /* 1090099 */     GIR_EraseRootFromParent_Done,
     /* 1090100 */   // Label 16063: @1090100
     /* 1090100 */   GIM_Try, /*On fail goto*//*Label 16064*/ GIMT_Encode4(1090177), // Rule ID 60714 //
     /* 1090105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090144 */     // MIs[0] policy
     /* 1090144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090154 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090176 */     // GIR_Coverage, 60714,
     /* 1090176 */     GIR_EraseRootFromParent_Done,
     /* 1090177 */   // Label 16064: @1090177
     /* 1090177 */   GIM_Try, /*On fail goto*//*Label 16065*/ GIMT_Encode4(1090254), // Rule ID 60715 //
     /* 1090182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1090193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1090196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1090199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090221 */     // MIs[0] policy
     /* 1090221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090231 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090253 */     // GIR_Coverage, 60715,
     /* 1090253 */     GIR_EraseRootFromParent_Done,
     /* 1090254 */   // Label 16065: @1090254
     /* 1090254 */   GIM_Try, /*On fail goto*//*Label 16066*/ GIMT_Encode4(1090331), // Rule ID 60718 //
     /* 1090259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090298 */     // MIs[0] policy
     /* 1090298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090308 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090330 */     // GIR_Coverage, 60718,
     /* 1090330 */     GIR_EraseRootFromParent_Done,
     /* 1090331 */   // Label 16066: @1090331
     /* 1090331 */   GIM_Try, /*On fail goto*//*Label 16067*/ GIMT_Encode4(1090408), // Rule ID 60719 //
     /* 1090336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1090347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1090350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1090353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090375 */     // MIs[0] policy
     /* 1090375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090385 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1090388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090407 */     // GIR_Coverage, 60719,
     /* 1090407 */     GIR_EraseRootFromParent_Done,
     /* 1090408 */   // Label 16067: @1090408
     /* 1090408 */   GIM_Try, /*On fail goto*//*Label 16068*/ GIMT_Encode4(1090485), // Rule ID 60722 //
     /* 1090413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090452 */     // MIs[0] policy
     /* 1090452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090462 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090484 */     // GIR_Coverage, 60722,
     /* 1090484 */     GIR_EraseRootFromParent_Done,
     /* 1090485 */   // Label 16068: @1090485
     /* 1090485 */   GIM_Try, /*On fail goto*//*Label 16069*/ GIMT_Encode4(1090562), // Rule ID 60723 //
     /* 1090490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1090501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1090504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1090507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090529 */     // MIs[0] policy
     /* 1090529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090539 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090561 */     // GIR_Coverage, 60723,
     /* 1090561 */     GIR_EraseRootFromParent_Done,
     /* 1090562 */   // Label 16069: @1090562
     /* 1090562 */   GIM_Try, /*On fail goto*//*Label 16070*/ GIMT_Encode4(1090639), // Rule ID 60726 //
     /* 1090567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090606 */     // MIs[0] policy
     /* 1090606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090616 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090638 */     // GIR_Coverage, 60726,
     /* 1090638 */     GIR_EraseRootFromParent_Done,
     /* 1090639 */   // Label 16070: @1090639
     /* 1090639 */   GIM_Try, /*On fail goto*//*Label 16071*/ GIMT_Encode4(1090716), // Rule ID 60727 //
     /* 1090644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090683 */     // MIs[0] policy
     /* 1090683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090693 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090715 */     // GIR_Coverage, 60727,
     /* 1090715 */     GIR_EraseRootFromParent_Done,
     /* 1090716 */   // Label 16071: @1090716
     /* 1090716 */   GIM_Try, /*On fail goto*//*Label 16072*/ GIMT_Encode4(1090793), // Rule ID 60730 //
     /* 1090721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1090732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1090735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1090738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090760 */     // MIs[0] policy
     /* 1090760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090770 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090792 */     // GIR_Coverage, 60730,
     /* 1090792 */     GIR_EraseRootFromParent_Done,
     /* 1090793 */   // Label 16072: @1090793
     /* 1090793 */   GIM_Try, /*On fail goto*//*Label 16073*/ GIMT_Encode4(1090870), // Rule ID 60731 //
     /* 1090798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1090809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1090812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1090815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090837 */     // MIs[0] policy
     /* 1090837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090847 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11173:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090869 */     // GIR_Coverage, 60731,
     /* 1090869 */     GIR_EraseRootFromParent_Done,
     /* 1090870 */   // Label 16073: @1090870
     /* 1090870 */   GIM_Try, /*On fail goto*//*Label 16074*/ GIMT_Encode4(1090947), // Rule ID 60734 //
     /* 1090875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1090886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1090889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1090892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090914 */     // MIs[0] policy
     /* 1090914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090946 */     // GIR_Coverage, 60734,
     /* 1090946 */     GIR_EraseRootFromParent_Done,
     /* 1090947 */   // Label 16074: @1090947
     /* 1090947 */   GIM_Try, /*On fail goto*//*Label 16075*/ GIMT_Encode4(1091024), // Rule ID 60735 //
     /* 1090952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1090963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1090966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1090969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090991 */     // MIs[0] policy
     /* 1090991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091001 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091023 */     // GIR_Coverage, 60735,
     /* 1091023 */     GIR_EraseRootFromParent_Done,
     /* 1091024 */   // Label 16075: @1091024
     /* 1091024 */   GIM_Try, /*On fail goto*//*Label 16076*/ GIMT_Encode4(1091101), // Rule ID 60738 //
     /* 1091029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091068 */     // MIs[0] policy
     /* 1091068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091100 */     // GIR_Coverage, 60738,
     /* 1091100 */     GIR_EraseRootFromParent_Done,
     /* 1091101 */   // Label 16076: @1091101
     /* 1091101 */   GIM_Try, /*On fail goto*//*Label 16077*/ GIMT_Encode4(1091178), // Rule ID 60739 //
     /* 1091106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1091117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1091120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1091123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1091126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091145 */     // MIs[0] policy
     /* 1091145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091155 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091177 */     // GIR_Coverage, 60739,
     /* 1091177 */     GIR_EraseRootFromParent_Done,
     /* 1091178 */   // Label 16077: @1091178
     /* 1091178 */   GIM_Try, /*On fail goto*//*Label 16078*/ GIMT_Encode4(1091255), // Rule ID 60742 //
     /* 1091183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091222 */     // MIs[0] policy
     /* 1091222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091232 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091254 */     // GIR_Coverage, 60742,
     /* 1091254 */     GIR_EraseRootFromParent_Done,
     /* 1091255 */   // Label 16078: @1091255
     /* 1091255 */   GIM_Try, /*On fail goto*//*Label 16079*/ GIMT_Encode4(1091332), // Rule ID 60743 //
     /* 1091260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1091271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1091274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1091277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1091280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1091287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1091295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091299 */     // MIs[0] policy
     /* 1091299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091309 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1091312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1091328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091331 */     // GIR_Coverage, 60743,
     /* 1091331 */     GIR_EraseRootFromParent_Done,
     /* 1091332 */   // Label 16079: @1091332
     /* 1091332 */   GIM_Try, /*On fail goto*//*Label 16080*/ GIMT_Encode4(1091409), // Rule ID 60746 //
     /* 1091337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091376 */     // MIs[0] policy
     /* 1091376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091408 */     // GIR_Coverage, 60746,
     /* 1091408 */     GIR_EraseRootFromParent_Done,
     /* 1091409 */   // Label 16080: @1091409
     /* 1091409 */   GIM_Try, /*On fail goto*//*Label 16081*/ GIMT_Encode4(1091486), // Rule ID 60747 //
     /* 1091414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1091425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1091428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1091431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091453 */     // MIs[0] policy
     /* 1091453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091463 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091485 */     // GIR_Coverage, 60747,
     /* 1091485 */     GIR_EraseRootFromParent_Done,
     /* 1091486 */   // Label 16081: @1091486
     /* 1091486 */   GIM_Try, /*On fail goto*//*Label 16082*/ GIMT_Encode4(1091563), // Rule ID 60750 //
     /* 1091491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1091502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1091505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091530 */     // MIs[0] policy
     /* 1091530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1091543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091562 */     // GIR_Coverage, 60750,
     /* 1091562 */     GIR_EraseRootFromParent_Done,
     /* 1091563 */   // Label 16082: @1091563
     /* 1091563 */   GIM_Try, /*On fail goto*//*Label 16083*/ GIMT_Encode4(1091640), // Rule ID 60751 //
     /* 1091568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1091579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1091582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091607 */     // MIs[0] policy
     /* 1091607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091617 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1091620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091639 */     // GIR_Coverage, 60751,
     /* 1091639 */     GIR_EraseRootFromParent_Done,
     /* 1091640 */   // Label 16083: @1091640
     /* 1091640 */   GIM_Try, /*On fail goto*//*Label 16084*/ GIMT_Encode4(1091717), // Rule ID 60754 //
     /* 1091645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1091656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1091659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1091662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1091665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1091672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091684 */     // MIs[0] policy
     /* 1091684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091694 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1091697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091716 */     // GIR_Coverage, 60754,
     /* 1091716 */     GIR_EraseRootFromParent_Done,
     /* 1091717 */   // Label 16084: @1091717
     /* 1091717 */   GIM_Try, /*On fail goto*//*Label 16085*/ GIMT_Encode4(1091794), // Rule ID 60755 //
     /* 1091722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1091733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1091736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1091739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1091742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1091749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091761 */     // MIs[0] policy
     /* 1091761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1091774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091793 */     // GIR_Coverage, 60755,
     /* 1091793 */     GIR_EraseRootFromParent_Done,
     /* 1091794 */   // Label 16085: @1091794
     /* 1091794 */   GIM_Try, /*On fail goto*//*Label 16086*/ GIMT_Encode4(1091871), // Rule ID 60758 //
     /* 1091799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1091810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1091813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1091816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091838 */     // MIs[0] policy
     /* 1091838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091848 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091870 */     // GIR_Coverage, 60758,
     /* 1091870 */     GIR_EraseRootFromParent_Done,
     /* 1091871 */   // Label 16086: @1091871
     /* 1091871 */   GIM_Try, /*On fail goto*//*Label 16087*/ GIMT_Encode4(1091948), // Rule ID 60759 //
     /* 1091876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1091887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1091890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1091893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091915 */     // MIs[0] policy
     /* 1091915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091925 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091934 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091947 */     // GIR_Coverage, 60759,
     /* 1091947 */     GIR_EraseRootFromParent_Done,
     /* 1091948 */   // Label 16087: @1091948
     /* 1091948 */   GIM_Try, /*On fail goto*//*Label 16088*/ GIMT_Encode4(1092025), // Rule ID 60762 //
     /* 1091953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1091964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1091967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1091970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091992 */     // MIs[0] policy
     /* 1091992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092024 */     // GIR_Coverage, 60762,
     /* 1092024 */     GIR_EraseRootFromParent_Done,
     /* 1092025 */   // Label 16088: @1092025
     /* 1092025 */   GIM_Try, /*On fail goto*//*Label 16089*/ GIMT_Encode4(1092102), // Rule ID 60763 //
     /* 1092030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1092041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1092044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1092047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092069 */     // MIs[0] policy
     /* 1092069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092079 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092101 */     // GIR_Coverage, 60763,
     /* 1092101 */     GIR_EraseRootFromParent_Done,
     /* 1092102 */   // Label 16089: @1092102
     /* 1092102 */   GIM_Try, /*On fail goto*//*Label 16090*/ GIMT_Encode4(1092179), // Rule ID 60766 //
     /* 1092107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092146 */     // MIs[0] policy
     /* 1092146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092156 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092178 */     // GIR_Coverage, 60766,
     /* 1092178 */     GIR_EraseRootFromParent_Done,
     /* 1092179 */   // Label 16090: @1092179
     /* 1092179 */   GIM_Try, /*On fail goto*//*Label 16091*/ GIMT_Encode4(1092256), // Rule ID 60767 //
     /* 1092184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1092195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1092198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1092201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1092204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092223 */     // MIs[0] policy
     /* 1092223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092233 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1092252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092255 */     // GIR_Coverage, 60767,
     /* 1092255 */     GIR_EraseRootFromParent_Done,
     /* 1092256 */   // Label 16091: @1092256
     /* 1092256 */   GIM_Try, /*On fail goto*//*Label 16092*/ GIMT_Encode4(1092333), // Rule ID 60770 //
     /* 1092261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092300 */     // MIs[0] policy
     /* 1092300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092332 */     // GIR_Coverage, 60770,
     /* 1092332 */     GIR_EraseRootFromParent_Done,
     /* 1092333 */   // Label 16092: @1092333
     /* 1092333 */   GIM_Try, /*On fail goto*//*Label 16093*/ GIMT_Encode4(1092410), // Rule ID 60771 //
     /* 1092338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1092349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1092352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1092355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092377 */     // MIs[0] policy
     /* 1092377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092409 */     // GIR_Coverage, 60771,
     /* 1092409 */     GIR_EraseRootFromParent_Done,
     /* 1092410 */   // Label 16093: @1092410
     /* 1092410 */   GIM_Try, /*On fail goto*//*Label 16094*/ GIMT_Encode4(1092487), // Rule ID 60774 //
     /* 1092415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092454 */     // MIs[0] policy
     /* 1092454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092486 */     // GIR_Coverage, 60774,
     /* 1092486 */     GIR_EraseRootFromParent_Done,
     /* 1092487 */   // Label 16094: @1092487
     /* 1092487 */   GIM_Try, /*On fail goto*//*Label 16095*/ GIMT_Encode4(1092564), // Rule ID 60775 //
     /* 1092492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1092503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1092506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092531 */     // MIs[0] policy
     /* 1092531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092541 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092563 */     // GIR_Coverage, 60775,
     /* 1092563 */     GIR_EraseRootFromParent_Done,
     /* 1092564 */   // Label 16095: @1092564
     /* 1092564 */   GIM_Try, /*On fail goto*//*Label 16096*/ GIMT_Encode4(1092641), // Rule ID 60778 //
     /* 1092569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1092580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1092583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1092586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092608 */     // MIs[0] policy
     /* 1092608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092618 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092640 */     // GIR_Coverage, 60778,
     /* 1092640 */     GIR_EraseRootFromParent_Done,
     /* 1092641 */   // Label 16096: @1092641
     /* 1092641 */   GIM_Try, /*On fail goto*//*Label 16097*/ GIMT_Encode4(1092718), // Rule ID 60779 //
     /* 1092646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1092657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1092660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1092663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092685 */     // MIs[0] policy
     /* 1092685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092695 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092717 */     // GIR_Coverage, 60779,
     /* 1092717 */     GIR_EraseRootFromParent_Done,
     /* 1092718 */   // Label 16097: @1092718
     /* 1092718 */   GIM_Try, /*On fail goto*//*Label 16098*/ GIMT_Encode4(1092795), // Rule ID 60782 //
     /* 1092723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1092734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1092737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1092740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1092743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092762 */     // MIs[0] policy
     /* 1092762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092794 */     // GIR_Coverage, 60782,
     /* 1092794 */     GIR_EraseRootFromParent_Done,
     /* 1092795 */   // Label 16098: @1092795
     /* 1092795 */   GIM_Try, /*On fail goto*//*Label 16099*/ GIMT_Encode4(1092872), // Rule ID 60783 //
     /* 1092800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1092811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1092814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1092817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1092820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092839 */     // MIs[0] policy
     /* 1092839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092871 */     // GIR_Coverage, 60783,
     /* 1092871 */     GIR_EraseRootFromParent_Done,
     /* 1092872 */   // Label 16099: @1092872
     /* 1092872 */   GIM_Try, /*On fail goto*//*Label 16100*/ GIMT_Encode4(1092949), // Rule ID 60786 //
     /* 1092877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1092888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1092891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1092894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092916 */     // MIs[0] policy
     /* 1092916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092926 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092948 */     // GIR_Coverage, 60786,
     /* 1092948 */     GIR_EraseRootFromParent_Done,
     /* 1092949 */   // Label 16100: @1092949
     /* 1092949 */   GIM_Try, /*On fail goto*//*Label 16101*/ GIMT_Encode4(1093026), // Rule ID 60787 //
     /* 1092954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1092965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1092968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1092971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092993 */     // MIs[0] policy
     /* 1092993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093003 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1093006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093025 */     // GIR_Coverage, 60787,
     /* 1093025 */     GIR_EraseRootFromParent_Done,
     /* 1093026 */   // Label 16101: @1093026
     /* 1093026 */   GIM_Try, /*On fail goto*//*Label 16102*/ GIMT_Encode4(1093103), // Rule ID 60790 //
     /* 1093031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093070 */     // MIs[0] policy
     /* 1093070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093080 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093102 */     // GIR_Coverage, 60790,
     /* 1093102 */     GIR_EraseRootFromParent_Done,
     /* 1093103 */   // Label 16102: @1093103
     /* 1093103 */   GIM_Try, /*On fail goto*//*Label 16103*/ GIMT_Encode4(1093180), // Rule ID 60791 //
     /* 1093108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1093116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1093119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1093122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1093125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1093135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1093143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093147 */     // MIs[0] policy
     /* 1093147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093157 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1093160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1093176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093179 */     // GIR_Coverage, 60791,
     /* 1093179 */     GIR_EraseRootFromParent_Done,
     /* 1093180 */   // Label 16103: @1093180
     /* 1093180 */   GIM_Try, /*On fail goto*//*Label 16104*/ GIMT_Encode4(1093257), // Rule ID 60794 //
     /* 1093185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093224 */     // MIs[0] policy
     /* 1093224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093234 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1093237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093256 */     // GIR_Coverage, 60794,
     /* 1093256 */     GIR_EraseRootFromParent_Done,
     /* 1093257 */   // Label 16104: @1093257
     /* 1093257 */   GIM_Try, /*On fail goto*//*Label 16105*/ GIMT_Encode4(1093334), // Rule ID 60795 //
     /* 1093262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1093273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1093276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1093279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093301 */     // MIs[0] policy
     /* 1093301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093311 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1093314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093333 */     // GIR_Coverage, 60795,
     /* 1093333 */     GIR_EraseRootFromParent_Done,
     /* 1093334 */   // Label 16105: @1093334
     /* 1093334 */   GIM_Try, /*On fail goto*//*Label 16106*/ GIMT_Encode4(1093411), // Rule ID 60798 //
     /* 1093339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093378 */     // MIs[0] policy
     /* 1093378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093388 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093410 */     // GIR_Coverage, 60798,
     /* 1093410 */     GIR_EraseRootFromParent_Done,
     /* 1093411 */   // Label 16106: @1093411
     /* 1093411 */   GIM_Try, /*On fail goto*//*Label 16107*/ GIMT_Encode4(1093488), // Rule ID 60799 //
     /* 1093416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1093427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1093430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1093433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093455 */     // MIs[0] policy
     /* 1093455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093465 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093487 */     // GIR_Coverage, 60799,
     /* 1093487 */     GIR_EraseRootFromParent_Done,
     /* 1093488 */   // Label 16107: @1093488
     /* 1093488 */   GIM_Try, /*On fail goto*//*Label 16108*/ GIMT_Encode4(1093565), // Rule ID 60802 //
     /* 1093493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1093504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1093507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093532 */     // MIs[0] policy
     /* 1093532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093542 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093564 */     // GIR_Coverage, 60802,
     /* 1093564 */     GIR_EraseRootFromParent_Done,
     /* 1093565 */   // Label 16108: @1093565
     /* 1093565 */   GIM_Try, /*On fail goto*//*Label 16109*/ GIMT_Encode4(1093642), // Rule ID 60803 //
     /* 1093570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1093581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1093584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093609 */     // MIs[0] policy
     /* 1093609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093619 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093641 */     // GIR_Coverage, 60803,
     /* 1093641 */     GIR_EraseRootFromParent_Done,
     /* 1093642 */   // Label 16109: @1093642
     /* 1093642 */   GIM_Try, /*On fail goto*//*Label 16110*/ GIMT_Encode4(1093719), // Rule ID 60806 //
     /* 1093647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1093658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1093661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1093664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093686 */     // MIs[0] policy
     /* 1093686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093718 */     // GIR_Coverage, 60806,
     /* 1093718 */     GIR_EraseRootFromParent_Done,
     /* 1093719 */   // Label 16110: @1093719
     /* 1093719 */   GIM_Try, /*On fail goto*//*Label 16111*/ GIMT_Encode4(1093796), // Rule ID 60807 //
     /* 1093724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1093735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1093738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1093741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093763 */     // MIs[0] policy
     /* 1093763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093773 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093782 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093795 */     // GIR_Coverage, 60807,
     /* 1093795 */     GIR_EraseRootFromParent_Done,
     /* 1093796 */   // Label 16111: @1093796
     /* 1093796 */   GIM_Try, /*On fail goto*//*Label 16112*/ GIMT_Encode4(1093873), // Rule ID 60810 //
     /* 1093801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1093812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1093815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1093818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093840 */     // MIs[0] policy
     /* 1093840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093850 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093872 */     // GIR_Coverage, 60810,
     /* 1093872 */     GIR_EraseRootFromParent_Done,
     /* 1093873 */   // Label 16112: @1093873
     /* 1093873 */   GIM_Try, /*On fail goto*//*Label 16113*/ GIMT_Encode4(1093950), // Rule ID 60811 //
     /* 1093878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1093889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1093892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1093895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093917 */     // MIs[0] policy
     /* 1093917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093927 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093949 */     // GIR_Coverage, 60811,
     /* 1093949 */     GIR_EraseRootFromParent_Done,
     /* 1093950 */   // Label 16113: @1093950
     /* 1093950 */   GIM_Try, /*On fail goto*//*Label 16114*/ GIMT_Encode4(1094027), // Rule ID 60814 //
     /* 1093955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1093966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1093969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1093972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093994 */     // MIs[0] policy
     /* 1093994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094004 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094026 */     // GIR_Coverage, 60814,
     /* 1094026 */     GIR_EraseRootFromParent_Done,
     /* 1094027 */   // Label 16114: @1094027
     /* 1094027 */   GIM_Try, /*On fail goto*//*Label 16115*/ GIMT_Encode4(1094104), // Rule ID 60815 //
     /* 1094032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1094043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1094046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1094049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094071 */     // MIs[0] policy
     /* 1094071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094081 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1094084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094103 */     // GIR_Coverage, 60815,
     /* 1094103 */     GIR_EraseRootFromParent_Done,
     /* 1094104 */   // Label 16115: @1094104
     /* 1094104 */   GIM_Try, /*On fail goto*//*Label 16116*/ GIMT_Encode4(1094181), // Rule ID 60818 //
     /* 1094109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094148 */     // MIs[0] policy
     /* 1094148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094180 */     // GIR_Coverage, 60818,
     /* 1094180 */     GIR_EraseRootFromParent_Done,
     /* 1094181 */   // Label 16116: @1094181
     /* 1094181 */   GIM_Try, /*On fail goto*//*Label 16117*/ GIMT_Encode4(1094258), // Rule ID 60819 //
     /* 1094186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1094197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1094200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1094203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094225 */     // MIs[0] policy
     /* 1094225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094235 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11180:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094257 */     // GIR_Coverage, 60819,
     /* 1094257 */     GIR_EraseRootFromParent_Done,
     /* 1094258 */   // Label 16117: @1094258
     /* 1094258 */   GIM_Try, /*On fail goto*//*Label 16118*/ GIMT_Encode4(1094335), // Rule ID 60822 //
     /* 1094263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094302 */     // MIs[0] policy
     /* 1094302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094334 */     // GIR_Coverage, 60822,
     /* 1094334 */     GIR_EraseRootFromParent_Done,
     /* 1094335 */   // Label 16118: @1094335
     /* 1094335 */   GIM_Try, /*On fail goto*//*Label 16119*/ GIMT_Encode4(1094412), // Rule ID 60823 //
     /* 1094340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1094351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1094354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1094357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1094360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094379 */     // MIs[0] policy
     /* 1094379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094389 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094411 */     // GIR_Coverage, 60823,
     /* 1094411 */     GIR_EraseRootFromParent_Done,
     /* 1094412 */   // Label 16119: @1094412
     /* 1094412 */   GIM_Try, /*On fail goto*//*Label 16120*/ GIMT_Encode4(1094489), // Rule ID 60826 //
     /* 1094417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094456 */     // MIs[0] policy
     /* 1094456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094488 */     // GIR_Coverage, 60826,
     /* 1094488 */     GIR_EraseRootFromParent_Done,
     /* 1094489 */   // Label 16120: @1094489
     /* 1094489 */   GIM_Try, /*On fail goto*//*Label 16121*/ GIMT_Encode4(1094566), // Rule ID 60827 //
     /* 1094494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1094505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094533 */     // MIs[0] policy
     /* 1094533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094543 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094552 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094565 */     // GIR_Coverage, 60827,
     /* 1094565 */     GIR_EraseRootFromParent_Done,
     /* 1094566 */   // Label 16121: @1094566
     /* 1094566 */   GIM_Try, /*On fail goto*//*Label 16122*/ GIMT_Encode4(1094643), // Rule ID 60830 //
     /* 1094571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1094582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1094585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1094588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094610 */     // MIs[0] policy
     /* 1094610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094642 */     // GIR_Coverage, 60830,
     /* 1094642 */     GIR_EraseRootFromParent_Done,
     /* 1094643 */   // Label 16122: @1094643
     /* 1094643 */   GIM_Try, /*On fail goto*//*Label 16123*/ GIMT_Encode4(1094720), // Rule ID 60831 //
     /* 1094648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1094659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1094662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1094665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094687 */     // MIs[0] policy
     /* 1094687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094697 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094706 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094719 */     // GIR_Coverage, 60831,
     /* 1094719 */     GIR_EraseRootFromParent_Done,
     /* 1094720 */   // Label 16123: @1094720
     /* 1094720 */   GIM_Try, /*On fail goto*//*Label 16124*/ GIMT_Encode4(1094797), // Rule ID 60834 //
     /* 1094725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1094736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1094739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1094742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1094745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1094752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094764 */     // MIs[0] policy
     /* 1094764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094774 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1094777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094796 */     // GIR_Coverage, 60834,
     /* 1094796 */     GIR_EraseRootFromParent_Done,
     /* 1094797 */   // Label 16124: @1094797
     /* 1094797 */   GIM_Try, /*On fail goto*//*Label 16125*/ GIMT_Encode4(1094874), // Rule ID 60835 //
     /* 1094802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1094813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1094816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1094819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1094822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1094829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094841 */     // MIs[0] policy
     /* 1094841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094851 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1094854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094873 */     // GIR_Coverage, 60835,
     /* 1094873 */     GIR_EraseRootFromParent_Done,
     /* 1094874 */   // Label 16125: @1094874
     /* 1094874 */   GIM_Try, /*On fail goto*//*Label 16126*/ GIMT_Encode4(1094951), // Rule ID 60838 //
     /* 1094879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1094890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1094893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1094896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1094899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1094906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094918 */     // MIs[0] policy
     /* 1094918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094928 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1094931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094950 */     // GIR_Coverage, 60838,
     /* 1094950 */     GIR_EraseRootFromParent_Done,
     /* 1094951 */   // Label 16126: @1094951
     /* 1094951 */   GIM_Try, /*On fail goto*//*Label 16127*/ GIMT_Encode4(1095028), // Rule ID 60839 //
     /* 1094956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1094967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1094970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1094973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1094976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1094983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094995 */     // MIs[0] policy
     /* 1094995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095005 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095027 */     // GIR_Coverage, 60839,
     /* 1095027 */     GIR_EraseRootFromParent_Done,
     /* 1095028 */   // Label 16127: @1095028
     /* 1095028 */   GIM_Try, /*On fail goto*//*Label 16128*/ GIMT_Encode4(1095105), // Rule ID 60842 //
     /* 1095033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095072 */     // MIs[0] policy
     /* 1095072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095082 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095104 */     // GIR_Coverage, 60842,
     /* 1095104 */     GIR_EraseRootFromParent_Done,
     /* 1095105 */   // Label 16128: @1095105
     /* 1095105 */   GIM_Try, /*On fail goto*//*Label 16129*/ GIMT_Encode4(1095182), // Rule ID 60843 //
     /* 1095110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1095121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1095124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1095127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1095130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095149 */     // MIs[0] policy
     /* 1095149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095159 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1095178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095181 */     // GIR_Coverage, 60843,
     /* 1095181 */     GIR_EraseRootFromParent_Done,
     /* 1095182 */   // Label 16129: @1095182
     /* 1095182 */   GIM_Try, /*On fail goto*//*Label 16130*/ GIMT_Encode4(1095259), // Rule ID 60846 //
     /* 1095187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095226 */     // MIs[0] policy
     /* 1095226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095258 */     // GIR_Coverage, 60846,
     /* 1095258 */     GIR_EraseRootFromParent_Done,
     /* 1095259 */   // Label 16130: @1095259
     /* 1095259 */   GIM_Try, /*On fail goto*//*Label 16131*/ GIMT_Encode4(1095336), // Rule ID 60847 //
     /* 1095264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1095275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1095278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1095281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095303 */     // MIs[0] policy
     /* 1095303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095313 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095335 */     // GIR_Coverage, 60847,
     /* 1095335 */     GIR_EraseRootFromParent_Done,
     /* 1095336 */   // Label 16131: @1095336
     /* 1095336 */   GIM_Try, /*On fail goto*//*Label 16132*/ GIMT_Encode4(1095413), // Rule ID 60850 //
     /* 1095341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095380 */     // MIs[0] policy
     /* 1095380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095412 */     // GIR_Coverage, 60850,
     /* 1095412 */     GIR_EraseRootFromParent_Done,
     /* 1095413 */   // Label 16132: @1095413
     /* 1095413 */   GIM_Try, /*On fail goto*//*Label 16133*/ GIMT_Encode4(1095490), // Rule ID 60851 //
     /* 1095418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1095429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1095432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1095435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095457 */     // MIs[0] policy
     /* 1095457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095467 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095489 */     // GIR_Coverage, 60851,
     /* 1095489 */     GIR_EraseRootFromParent_Done,
     /* 1095490 */   // Label 16133: @1095490
     /* 1095490 */   GIM_Try, /*On fail goto*//*Label 16134*/ GIMT_Encode4(1095567), // Rule ID 60854 //
     /* 1095495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095534 */     // MIs[0] policy
     /* 1095534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095544 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095566 */     // GIR_Coverage, 60854,
     /* 1095566 */     GIR_EraseRootFromParent_Done,
     /* 1095567 */   // Label 16134: @1095567
     /* 1095567 */   GIM_Try, /*On fail goto*//*Label 16135*/ GIMT_Encode4(1095644), // Rule ID 60855 //
     /* 1095572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095611 */     // MIs[0] policy
     /* 1095611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095621 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095643 */     // GIR_Coverage, 60855,
     /* 1095643 */     GIR_EraseRootFromParent_Done,
     /* 1095644 */   // Label 16135: @1095644
     /* 1095644 */   GIM_Try, /*On fail goto*//*Label 16136*/ GIMT_Encode4(1095721), // Rule ID 60858 //
     /* 1095649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1095660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1095663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1095666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1095669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095688 */     // MIs[0] policy
     /* 1095688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095698 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095720 */     // GIR_Coverage, 60858,
     /* 1095720 */     GIR_EraseRootFromParent_Done,
     /* 1095721 */   // Label 16136: @1095721
     /* 1095721 */   GIM_Try, /*On fail goto*//*Label 16137*/ GIMT_Encode4(1095798), // Rule ID 60859 //
     /* 1095726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1095737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1095740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1095743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1095746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095765 */     // MIs[0] policy
     /* 1095765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095775 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095784 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095797 */     // GIR_Coverage, 60859,
     /* 1095797 */     GIR_EraseRootFromParent_Done,
     /* 1095798 */   // Label 16137: @1095798
     /* 1095798 */   GIM_Try, /*On fail goto*//*Label 16138*/ GIMT_Encode4(1095875), // Rule ID 60862 //
     /* 1095803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1095814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1095817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1095820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095842 */     // MIs[0] policy
     /* 1095842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095874 */     // GIR_Coverage, 60862,
     /* 1095874 */     GIR_EraseRootFromParent_Done,
     /* 1095875 */   // Label 16138: @1095875
     /* 1095875 */   GIM_Try, /*On fail goto*//*Label 16139*/ GIMT_Encode4(1095952), // Rule ID 60863 //
     /* 1095880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1095891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1095894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1095897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095919 */     // MIs[0] policy
     /* 1095919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095929 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095938 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095951 */     // GIR_Coverage, 60863,
     /* 1095951 */     GIR_EraseRootFromParent_Done,
     /* 1095952 */   // Label 16139: @1095952
     /* 1095952 */   GIM_Try, /*On fail goto*//*Label 16140*/ GIMT_Encode4(1096029), // Rule ID 60866 //
     /* 1095957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1095968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1095971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1095974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095996 */     // MIs[0] policy
     /* 1095996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096006 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096028 */     // GIR_Coverage, 60866,
     /* 1096028 */     GIR_EraseRootFromParent_Done,
     /* 1096029 */   // Label 16140: @1096029
     /* 1096029 */   GIM_Try, /*On fail goto*//*Label 16141*/ GIMT_Encode4(1096106), // Rule ID 60867 //
     /* 1096034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1096045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1096048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1096051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1096054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096073 */     // MIs[0] policy
     /* 1096073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096083 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096105 */     // GIR_Coverage, 60867,
     /* 1096105 */     GIR_EraseRootFromParent_Done,
     /* 1096106 */   // Label 16141: @1096106
     /* 1096106 */   GIM_Try, /*On fail goto*//*Label 16142*/ GIMT_Encode4(1096183), // Rule ID 60870 //
     /* 1096111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096150 */     // MIs[0] policy
     /* 1096150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096182 */     // GIR_Coverage, 60870,
     /* 1096182 */     GIR_EraseRootFromParent_Done,
     /* 1096183 */   // Label 16142: @1096183
     /* 1096183 */   GIM_Try, /*On fail goto*//*Label 16143*/ GIMT_Encode4(1096260), // Rule ID 60871 //
     /* 1096188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1096199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1096202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1096205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1096215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1096223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096227 */     // MIs[0] policy
     /* 1096227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096237 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1096240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096246 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096259 */     // GIR_Coverage, 60871,
     /* 1096259 */     GIR_EraseRootFromParent_Done,
     /* 1096260 */   // Label 16143: @1096260
     /* 1096260 */   GIM_Try, /*On fail goto*//*Label 16144*/ GIMT_Encode4(1096337), // Rule ID 60874 //
     /* 1096265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096304 */     // MIs[0] policy
     /* 1096304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096314 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096336 */     // GIR_Coverage, 60874,
     /* 1096336 */     GIR_EraseRootFromParent_Done,
     /* 1096337 */   // Label 16144: @1096337
     /* 1096337 */   GIM_Try, /*On fail goto*//*Label 16145*/ GIMT_Encode4(1096414), // Rule ID 60875 //
     /* 1096342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1096353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1096356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1096359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1096369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1096377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096381 */     // MIs[0] policy
     /* 1096381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096391 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1096394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096400 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096413 */     // GIR_Coverage, 60875,
     /* 1096413 */     GIR_EraseRootFromParent_Done,
     /* 1096414 */   // Label 16145: @1096414
     /* 1096414 */   GIM_Try, /*On fail goto*//*Label 16146*/ GIMT_Encode4(1096491), // Rule ID 60878 //
     /* 1096419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096458 */     // MIs[0] policy
     /* 1096458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096490 */     // GIR_Coverage, 60878,
     /* 1096490 */     GIR_EraseRootFromParent_Done,
     /* 1096491 */   // Label 16146: @1096491
     /* 1096491 */   GIM_Try, /*On fail goto*//*Label 16147*/ GIMT_Encode4(1096568), // Rule ID 60879 //
     /* 1096496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1096504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1096507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096535 */     // MIs[0] policy
     /* 1096535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096545 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096567 */     // GIR_Coverage, 60879,
     /* 1096567 */     GIR_EraseRootFromParent_Done,
     /* 1096568 */   // Label 16147: @1096568
     /* 1096568 */   GIM_Try, /*On fail goto*//*Label 16148*/ GIMT_Encode4(1096645), // Rule ID 60882 //
     /* 1096573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1096584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1096587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1096590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096612 */     // MIs[0] policy
     /* 1096612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096622 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1096625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096644 */     // GIR_Coverage, 60882,
     /* 1096644 */     GIR_EraseRootFromParent_Done,
     /* 1096645 */   // Label 16148: @1096645
     /* 1096645 */   GIM_Try, /*On fail goto*//*Label 16149*/ GIMT_Encode4(1096722), // Rule ID 60883 //
     /* 1096650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1096661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1096664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1096667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096689 */     // MIs[0] policy
     /* 1096689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096699 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1096702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096721 */     // GIR_Coverage, 60883,
     /* 1096721 */     GIR_EraseRootFromParent_Done,
     /* 1096722 */   // Label 16149: @1096722
     /* 1096722 */   GIM_Try, /*On fail goto*//*Label 16150*/ GIMT_Encode4(1096799), // Rule ID 60886 //
     /* 1096727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1096738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1096741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1096744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096766 */     // MIs[0] policy
     /* 1096766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096776 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1096779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096798 */     // GIR_Coverage, 60886,
     /* 1096798 */     GIR_EraseRootFromParent_Done,
     /* 1096799 */   // Label 16150: @1096799
     /* 1096799 */   GIM_Try, /*On fail goto*//*Label 16151*/ GIMT_Encode4(1096876), // Rule ID 60887 //
     /* 1096804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1096815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1096818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1096821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096843 */     // MIs[0] policy
     /* 1096843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096853 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1096856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096862 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096875 */     // GIR_Coverage, 60887,
     /* 1096875 */     GIR_EraseRootFromParent_Done,
     /* 1096876 */   // Label 16151: @1096876
     /* 1096876 */   GIM_Try, /*On fail goto*//*Label 16152*/ GIMT_Encode4(1096953), // Rule ID 60890 //
     /* 1096881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1096892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1096895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1096898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096920 */     // MIs[0] policy
     /* 1096920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096930 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1096933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096952 */     // GIR_Coverage, 60890,
     /* 1096952 */     GIR_EraseRootFromParent_Done,
     /* 1096953 */   // Label 16152: @1096953
     /* 1096953 */   GIM_Try, /*On fail goto*//*Label 16153*/ GIMT_Encode4(1097030), // Rule ID 60891 //
     /* 1096958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1096969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1096972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1096975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096997 */     // MIs[0] policy
     /* 1096997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097007 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097029 */     // GIR_Coverage, 60891,
     /* 1097029 */     GIR_EraseRootFromParent_Done,
     /* 1097030 */   // Label 16153: @1097030
     /* 1097030 */   GIM_Try, /*On fail goto*//*Label 16154*/ GIMT_Encode4(1097107), // Rule ID 60894 //
     /* 1097035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097074 */     // MIs[0] policy
     /* 1097074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097106 */     // GIR_Coverage, 60894,
     /* 1097106 */     GIR_EraseRootFromParent_Done,
     /* 1097107 */   // Label 16154: @1097107
     /* 1097107 */   GIM_Try, /*On fail goto*//*Label 16155*/ GIMT_Encode4(1097184), // Rule ID 60895 //
     /* 1097112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1097123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1097126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1097129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097151 */     // MIs[0] policy
     /* 1097151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097161 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1097164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097170 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097183 */     // GIR_Coverage, 60895,
     /* 1097183 */     GIR_EraseRootFromParent_Done,
     /* 1097184 */   // Label 16155: @1097184
     /* 1097184 */   GIM_Try, /*On fail goto*//*Label 16156*/ GIMT_Encode4(1097261), // Rule ID 60898 //
     /* 1097189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097228 */     // MIs[0] policy
     /* 1097228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097238 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097260 */     // GIR_Coverage, 60898,
     /* 1097260 */     GIR_EraseRootFromParent_Done,
     /* 1097261 */   // Label 16156: @1097261
     /* 1097261 */   GIM_Try, /*On fail goto*//*Label 16157*/ GIMT_Encode4(1097338), // Rule ID 60899 //
     /* 1097266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1097277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1097280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1097283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097305 */     // MIs[0] policy
     /* 1097305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097315 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097337 */     // GIR_Coverage, 60899,
     /* 1097337 */     GIR_EraseRootFromParent_Done,
     /* 1097338 */   // Label 16157: @1097338
     /* 1097338 */   GIM_Try, /*On fail goto*//*Label 16158*/ GIMT_Encode4(1097415), // Rule ID 60902 //
     /* 1097343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097382 */     // MIs[0] policy
     /* 1097382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097392 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097414 */     // GIR_Coverage, 60902,
     /* 1097414 */     GIR_EraseRootFromParent_Done,
     /* 1097415 */   // Label 16158: @1097415
     /* 1097415 */   GIM_Try, /*On fail goto*//*Label 16159*/ GIMT_Encode4(1097492), // Rule ID 60903 //
     /* 1097420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1097431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1097434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1097437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097459 */     // MIs[0] policy
     /* 1097459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097469 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1097472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097491 */     // GIR_Coverage, 60903,
     /* 1097491 */     GIR_EraseRootFromParent_Done,
     /* 1097492 */   // Label 16159: @1097492
     /* 1097492 */   GIM_Try, /*On fail goto*//*Label 16160*/ GIMT_Encode4(1097569), // Rule ID 60906 //
     /* 1097497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097536 */     // MIs[0] policy
     /* 1097536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097546 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097568 */     // GIR_Coverage, 60906,
     /* 1097568 */     GIR_EraseRootFromParent_Done,
     /* 1097569 */   // Label 16160: @1097569
     /* 1097569 */   GIM_Try, /*On fail goto*//*Label 16161*/ GIMT_Encode4(1097646), // Rule ID 60907 //
     /* 1097574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097613 */     // MIs[0] policy
     /* 1097613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097623 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11178:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097645 */     // GIR_Coverage, 60907,
     /* 1097645 */     GIR_EraseRootFromParent_Done,
     /* 1097646 */   // Label 16161: @1097646
     /* 1097646 */   GIM_Try, /*On fail goto*//*Label 16162*/ GIMT_Encode4(1097723), // Rule ID 60910 //
     /* 1097651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1097662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1097665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1097668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097690 */     // MIs[0] policy
     /* 1097690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097722 */     // GIR_Coverage, 60910,
     /* 1097722 */     GIR_EraseRootFromParent_Done,
     /* 1097723 */   // Label 16162: @1097723
     /* 1097723 */   GIM_Try, /*On fail goto*//*Label 16163*/ GIMT_Encode4(1097800), // Rule ID 60911 //
     /* 1097728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1097739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1097742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1097745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097767 */     // MIs[0] policy
     /* 1097767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097799 */     // GIR_Coverage, 60911,
     /* 1097799 */     GIR_EraseRootFromParent_Done,
     /* 1097800 */   // Label 16163: @1097800
     /* 1097800 */   GIM_Try, /*On fail goto*//*Label 16164*/ GIMT_Encode4(1097877), // Rule ID 60914 //
     /* 1097805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1097816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1097819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1097822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097844 */     // MIs[0] policy
     /* 1097844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097876 */     // GIR_Coverage, 60914,
     /* 1097876 */     GIR_EraseRootFromParent_Done,
     /* 1097877 */   // Label 16164: @1097877
     /* 1097877 */   GIM_Try, /*On fail goto*//*Label 16165*/ GIMT_Encode4(1097954), // Rule ID 60915 //
     /* 1097882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1097893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1097896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1097899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097921 */     // MIs[0] policy
     /* 1097921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097931 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097953 */     // GIR_Coverage, 60915,
     /* 1097953 */     GIR_EraseRootFromParent_Done,
     /* 1097954 */   // Label 16165: @1097954
     /* 1097954 */   GIM_Try, /*On fail goto*//*Label 16166*/ GIMT_Encode4(1098031), // Rule ID 60918 //
     /* 1097959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1097970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1097973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1097976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097998 */     // MIs[0] policy
     /* 1097998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098030 */     // GIR_Coverage, 60918,
     /* 1098030 */     GIR_EraseRootFromParent_Done,
     /* 1098031 */   // Label 16166: @1098031
     /* 1098031 */   GIM_Try, /*On fail goto*//*Label 16167*/ GIMT_Encode4(1098108), // Rule ID 60919 //
     /* 1098036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1098047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1098050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1098053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1098056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1098063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1098071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098075 */     // MIs[0] policy
     /* 1098075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098085 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1098088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098094 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1098104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098107 */     // GIR_Coverage, 60919,
     /* 1098107 */     GIR_EraseRootFromParent_Done,
     /* 1098108 */   // Label 16167: @1098108
     /* 1098108 */   GIM_Try, /*On fail goto*//*Label 16168*/ GIMT_Encode4(1098185), // Rule ID 60922 //
     /* 1098113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098152 */     // MIs[0] policy
     /* 1098152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098162 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098184 */     // GIR_Coverage, 60922,
     /* 1098184 */     GIR_EraseRootFromParent_Done,
     /* 1098185 */   // Label 16168: @1098185
     /* 1098185 */   GIM_Try, /*On fail goto*//*Label 16169*/ GIMT_Encode4(1098262), // Rule ID 60923 //
     /* 1098190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1098201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1098204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1098207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098229 */     // MIs[0] policy
     /* 1098229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098239 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098248 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098261 */     // GIR_Coverage, 60923,
     /* 1098261 */     GIR_EraseRootFromParent_Done,
     /* 1098262 */   // Label 16169: @1098262
     /* 1098262 */   GIM_Try, /*On fail goto*//*Label 16170*/ GIMT_Encode4(1098339), // Rule ID 60926 //
     /* 1098267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098306 */     // MIs[0] policy
     /* 1098306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098338 */     // GIR_Coverage, 60926,
     /* 1098338 */     GIR_EraseRootFromParent_Done,
     /* 1098339 */   // Label 16170: @1098339
     /* 1098339 */   GIM_Try, /*On fail goto*//*Label 16171*/ GIMT_Encode4(1098416), // Rule ID 60927 //
     /* 1098344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1098355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1098358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1098361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098383 */     // MIs[0] policy
     /* 1098383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098393 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098402 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098415 */     // GIR_Coverage, 60927,
     /* 1098415 */     GIR_EraseRootFromParent_Done,
     /* 1098416 */   // Label 16171: @1098416
     /* 1098416 */   GIM_Try, /*On fail goto*//*Label 16172*/ GIMT_Encode4(1098493), // Rule ID 60930 //
     /* 1098421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098460 */     // MIs[0] policy
     /* 1098460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098470 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098492 */     // GIR_Coverage, 60930,
     /* 1098492 */     GIR_EraseRootFromParent_Done,
     /* 1098493 */   // Label 16172: @1098493
     /* 1098493 */   GIM_Try, /*On fail goto*//*Label 16173*/ GIMT_Encode4(1098570), // Rule ID 60931 //
     /* 1098498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098537 */     // MIs[0] policy
     /* 1098537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098547 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098556 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098569 */     // GIR_Coverage, 60931,
     /* 1098569 */     GIR_EraseRootFromParent_Done,
     /* 1098570 */   // Label 16173: @1098570
     /* 1098570 */   GIM_Try, /*On fail goto*//*Label 16174*/ GIMT_Encode4(1098647), // Rule ID 60934 //
     /* 1098575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1098586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1098589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1098592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098614 */     // MIs[0] policy
     /* 1098614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098624 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098646 */     // GIR_Coverage, 60934,
     /* 1098646 */     GIR_EraseRootFromParent_Done,
     /* 1098647 */   // Label 16174: @1098647
     /* 1098647 */   GIM_Try, /*On fail goto*//*Label 16175*/ GIMT_Encode4(1098724), // Rule ID 60935 //
     /* 1098652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1098663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1098666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1098669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098691 */     // MIs[0] policy
     /* 1098691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098701 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098710 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098723 */     // GIR_Coverage, 60935,
     /* 1098723 */     GIR_EraseRootFromParent_Done,
     /* 1098724 */   // Label 16175: @1098724
     /* 1098724 */   GIM_Try, /*On fail goto*//*Label 16176*/ GIMT_Encode4(1098801), // Rule ID 60938 //
     /* 1098729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1098740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1098743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1098746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098768 */     // MIs[0] policy
     /* 1098768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098778 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098800 */     // GIR_Coverage, 60938,
     /* 1098800 */     GIR_EraseRootFromParent_Done,
     /* 1098801 */   // Label 16176: @1098801
     /* 1098801 */   GIM_Try, /*On fail goto*//*Label 16177*/ GIMT_Encode4(1098878), // Rule ID 60939 //
     /* 1098806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1098817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1098820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1098823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098845 */     // MIs[0] policy
     /* 1098845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098855 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098877 */     // GIR_Coverage, 60939,
     /* 1098877 */     GIR_EraseRootFromParent_Done,
     /* 1098878 */   // Label 16177: @1098878
     /* 1098878 */   GIM_Try, /*On fail goto*//*Label 16178*/ GIMT_Encode4(1098955), // Rule ID 60942 //
     /* 1098883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1098894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1098897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1098900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098922 */     // MIs[0] policy
     /* 1098922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098932 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098954 */     // GIR_Coverage, 60942,
     /* 1098954 */     GIR_EraseRootFromParent_Done,
     /* 1098955 */   // Label 16178: @1098955
     /* 1098955 */   GIM_Try, /*On fail goto*//*Label 16179*/ GIMT_Encode4(1099032), // Rule ID 60943 //
     /* 1098960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1098971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1098974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1098977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098999 */     // MIs[0] policy
     /* 1098999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099009 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099031 */     // GIR_Coverage, 60943,
     /* 1099031 */     GIR_EraseRootFromParent_Done,
     /* 1099032 */   // Label 16179: @1099032
     /* 1099032 */   GIM_Try, /*On fail goto*//*Label 16180*/ GIMT_Encode4(1099109), // Rule ID 60946 //
     /* 1099037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099076 */     // MIs[0] policy
     /* 1099076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099108 */     // GIR_Coverage, 60946,
     /* 1099108 */     GIR_EraseRootFromParent_Done,
     /* 1099109 */   // Label 16180: @1099109
     /* 1099109 */   GIM_Try, /*On fail goto*//*Label 16181*/ GIMT_Encode4(1099186), // Rule ID 60947 //
     /* 1099114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1099125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1099128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1099131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099153 */     // MIs[0] policy
     /* 1099153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099163 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099185 */     // GIR_Coverage, 60947,
     /* 1099185 */     GIR_EraseRootFromParent_Done,
     /* 1099186 */   // Label 16181: @1099186
     /* 1099186 */   GIM_Try, /*On fail goto*//*Label 16182*/ GIMT_Encode4(1099263), // Rule ID 60950 //
     /* 1099191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099230 */     // MIs[0] policy
     /* 1099230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099262 */     // GIR_Coverage, 60950,
     /* 1099262 */     GIR_EraseRootFromParent_Done,
     /* 1099263 */   // Label 16182: @1099263
     /* 1099263 */   GIM_Try, /*On fail goto*//*Label 16183*/ GIMT_Encode4(1099340), // Rule ID 60951 //
     /* 1099268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1099279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1099282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1099285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099307 */     // MIs[0] policy
     /* 1099307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099317 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099326 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099339 */     // GIR_Coverage, 60951,
     /* 1099339 */     GIR_EraseRootFromParent_Done,
     /* 1099340 */   // Label 16183: @1099340
     /* 1099340 */   GIM_Try, /*On fail goto*//*Label 16184*/ GIMT_Encode4(1099417), // Rule ID 60954 //
     /* 1099345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099384 */     // MIs[0] policy
     /* 1099384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099394 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099416 */     // GIR_Coverage, 60954,
     /* 1099416 */     GIR_EraseRootFromParent_Done,
     /* 1099417 */   // Label 16184: @1099417
     /* 1099417 */   GIM_Try, /*On fail goto*//*Label 16185*/ GIMT_Encode4(1099494), // Rule ID 60955 //
     /* 1099422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1099433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1099436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1099439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1099442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099461 */     // MIs[0] policy
     /* 1099461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099471 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1099490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099493 */     // GIR_Coverage, 60955,
     /* 1099493 */     GIR_EraseRootFromParent_Done,
     /* 1099494 */   // Label 16185: @1099494
     /* 1099494 */   GIM_Try, /*On fail goto*//*Label 16186*/ GIMT_Encode4(1099571), // Rule ID 60958 //
     /* 1099499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099538 */     // MIs[0] policy
     /* 1099538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099570 */     // GIR_Coverage, 60958,
     /* 1099570 */     GIR_EraseRootFromParent_Done,
     /* 1099571 */   // Label 16186: @1099571
     /* 1099571 */   GIM_Try, /*On fail goto*//*Label 16187*/ GIMT_Encode4(1099648), // Rule ID 60959 //
     /* 1099576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099615 */     // MIs[0] policy
     /* 1099615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099625 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099647 */     // GIR_Coverage, 60959,
     /* 1099647 */     GIR_EraseRootFromParent_Done,
     /* 1099648 */   // Label 16187: @1099648
     /* 1099648 */   GIM_Try, /*On fail goto*//*Label 16188*/ GIMT_Encode4(1099725), // Rule ID 60962 //
     /* 1099653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1099664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1099667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1099670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099692 */     // MIs[0] policy
     /* 1099692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099724 */     // GIR_Coverage, 60962,
     /* 1099724 */     GIR_EraseRootFromParent_Done,
     /* 1099725 */   // Label 16188: @1099725
     /* 1099725 */   GIM_Try, /*On fail goto*//*Label 16189*/ GIMT_Encode4(1099802), // Rule ID 60963 //
     /* 1099730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1099741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1099744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1099747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099769 */     // MIs[0] policy
     /* 1099769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099779 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099801 */     // GIR_Coverage, 60963,
     /* 1099801 */     GIR_EraseRootFromParent_Done,
     /* 1099802 */   // Label 16189: @1099802
     /* 1099802 */   GIM_Try, /*On fail goto*//*Label 16190*/ GIMT_Encode4(1099879), // Rule ID 60966 //
     /* 1099807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1099818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1099821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1099824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099846 */     // MIs[0] policy
     /* 1099846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099878 */     // GIR_Coverage, 60966,
     /* 1099878 */     GIR_EraseRootFromParent_Done,
     /* 1099879 */   // Label 16190: @1099879
     /* 1099879 */   GIM_Try, /*On fail goto*//*Label 16191*/ GIMT_Encode4(1099956), // Rule ID 60967 //
     /* 1099884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1099895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1099898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1099901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099923 */     // MIs[0] policy
     /* 1099923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099933 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099955 */     // GIR_Coverage, 60967,
     /* 1099955 */     GIR_EraseRootFromParent_Done,
     /* 1099956 */   // Label 16191: @1099956
     /* 1099956 */   GIM_Try, /*On fail goto*//*Label 16192*/ GIMT_Encode4(1100033), // Rule ID 61390 //
     /* 1099961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1099964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1099969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1099972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1099975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1099978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1099981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1099988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100000 */     // MIs[0] policy
     /* 1100000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100010 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1100013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100032 */     // GIR_Coverage, 61390,
     /* 1100032 */     GIR_EraseRootFromParent_Done,
     /* 1100033 */   // Label 16192: @1100033
     /* 1100033 */   GIM_Try, /*On fail goto*//*Label 16193*/ GIMT_Encode4(1100110), // Rule ID 61391 //
     /* 1100038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1100049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1100052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1100055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100077 */     // MIs[0] policy
     /* 1100077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100087 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1100090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100096 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100109 */     // GIR_Coverage, 61391,
     /* 1100109 */     GIR_EraseRootFromParent_Done,
     /* 1100110 */   // Label 16193: @1100110
     /* 1100110 */   GIM_Try, /*On fail goto*//*Label 16194*/ GIMT_Encode4(1100187), // Rule ID 61394 //
     /* 1100115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100154 */     // MIs[0] policy
     /* 1100154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100164 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100186 */     // GIR_Coverage, 61394,
     /* 1100186 */     GIR_EraseRootFromParent_Done,
     /* 1100187 */   // Label 16194: @1100187
     /* 1100187 */   GIM_Try, /*On fail goto*//*Label 16195*/ GIMT_Encode4(1100264), // Rule ID 61395 //
     /* 1100192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1100203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1100206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1100209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100231 */     // MIs[0] policy
     /* 1100231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100241 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100250 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100263 */     // GIR_Coverage, 61395,
     /* 1100263 */     GIR_EraseRootFromParent_Done,
     /* 1100264 */   // Label 16195: @1100264
     /* 1100264 */   GIM_Try, /*On fail goto*//*Label 16196*/ GIMT_Encode4(1100341), // Rule ID 61398 //
     /* 1100269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100308 */     // MIs[0] policy
     /* 1100308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100318 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100340 */     // GIR_Coverage, 61398,
     /* 1100340 */     GIR_EraseRootFromParent_Done,
     /* 1100341 */   // Label 16196: @1100341
     /* 1100341 */   GIM_Try, /*On fail goto*//*Label 16197*/ GIMT_Encode4(1100418), // Rule ID 61399 //
     /* 1100346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1100357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1100360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1100363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100385 */     // MIs[0] policy
     /* 1100385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100395 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100417 */     // GIR_Coverage, 61399,
     /* 1100417 */     GIR_EraseRootFromParent_Done,
     /* 1100418 */   // Label 16197: @1100418
     /* 1100418 */   GIM_Try, /*On fail goto*//*Label 16198*/ GIMT_Encode4(1100495), // Rule ID 61402 //
     /* 1100423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100462 */     // MIs[0] policy
     /* 1100462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100494 */     // GIR_Coverage, 61402,
     /* 1100494 */     GIR_EraseRootFromParent_Done,
     /* 1100495 */   // Label 16198: @1100495
     /* 1100495 */   GIM_Try, /*On fail goto*//*Label 16199*/ GIMT_Encode4(1100572), // Rule ID 61403 //
     /* 1100500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100539 */     // MIs[0] policy
     /* 1100539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100549 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100571 */     // GIR_Coverage, 61403,
     /* 1100571 */     GIR_EraseRootFromParent_Done,
     /* 1100572 */   // Label 16199: @1100572
     /* 1100572 */   GIM_Try, /*On fail goto*//*Label 16200*/ GIMT_Encode4(1100649), // Rule ID 61406 //
     /* 1100577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1100588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1100591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1100594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100616 */     // MIs[0] policy
     /* 1100616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100648 */     // GIR_Coverage, 61406,
     /* 1100648 */     GIR_EraseRootFromParent_Done,
     /* 1100649 */   // Label 16200: @1100649
     /* 1100649 */   GIM_Try, /*On fail goto*//*Label 16201*/ GIMT_Encode4(1100726), // Rule ID 61407 //
     /* 1100654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1100665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1100668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1100671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100693 */     // MIs[0] policy
     /* 1100693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100703 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100725 */     // GIR_Coverage, 61407,
     /* 1100725 */     GIR_EraseRootFromParent_Done,
     /* 1100726 */   // Label 16201: @1100726
     /* 1100726 */   GIM_Try, /*On fail goto*//*Label 16202*/ GIMT_Encode4(1100803), // Rule ID 61410 //
     /* 1100731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1100742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1100745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1100748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100770 */     // MIs[0] policy
     /* 1100770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100780 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100802 */     // GIR_Coverage, 61410,
     /* 1100802 */     GIR_EraseRootFromParent_Done,
     /* 1100803 */   // Label 16202: @1100803
     /* 1100803 */   GIM_Try, /*On fail goto*//*Label 16203*/ GIMT_Encode4(1100880), // Rule ID 61411 //
     /* 1100808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1100819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1100822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1100825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100847 */     // MIs[0] policy
     /* 1100847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100857 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100879 */     // GIR_Coverage, 61411,
     /* 1100879 */     GIR_EraseRootFromParent_Done,
     /* 1100880 */   // Label 16203: @1100880
     /* 1100880 */   GIM_Try, /*On fail goto*//*Label 16204*/ GIMT_Encode4(1100957), // Rule ID 61414 //
     /* 1100885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1100896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1100899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1100902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100924 */     // MIs[0] policy
     /* 1100924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100934 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100956 */     // GIR_Coverage, 61414,
     /* 1100956 */     GIR_EraseRootFromParent_Done,
     /* 1100957 */   // Label 16204: @1100957
     /* 1100957 */   GIM_Try, /*On fail goto*//*Label 16205*/ GIMT_Encode4(1101034), // Rule ID 61415 //
     /* 1100962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1100973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1100976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1100979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101001 */     // MIs[0] policy
     /* 1101001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101011 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101033 */     // GIR_Coverage, 61415,
     /* 1101033 */     GIR_EraseRootFromParent_Done,
     /* 1101034 */   // Label 16205: @1101034
     /* 1101034 */   GIM_Try, /*On fail goto*//*Label 16206*/ GIMT_Encode4(1101111), // Rule ID 61418 //
     /* 1101039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101078 */     // MIs[0] policy
     /* 1101078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101088 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101110 */     // GIR_Coverage, 61418,
     /* 1101110 */     GIR_EraseRootFromParent_Done,
     /* 1101111 */   // Label 16206: @1101111
     /* 1101111 */   GIM_Try, /*On fail goto*//*Label 16207*/ GIMT_Encode4(1101188), // Rule ID 61419 //
     /* 1101116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1101127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1101130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1101133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101155 */     // MIs[0] policy
     /* 1101155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101165 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101187 */     // GIR_Coverage, 61419,
     /* 1101187 */     GIR_EraseRootFromParent_Done,
     /* 1101188 */   // Label 16207: @1101188
     /* 1101188 */   GIM_Try, /*On fail goto*//*Label 16208*/ GIMT_Encode4(1101265), // Rule ID 61422 //
     /* 1101193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101232 */     // MIs[0] policy
     /* 1101232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101242 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101264 */     // GIR_Coverage, 61422,
     /* 1101264 */     GIR_EraseRootFromParent_Done,
     /* 1101265 */   // Label 16208: @1101265
     /* 1101265 */   GIM_Try, /*On fail goto*//*Label 16209*/ GIMT_Encode4(1101342), // Rule ID 61423 //
     /* 1101270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1101281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1101284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1101287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1101290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101309 */     // MIs[0] policy
     /* 1101309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101319 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101341 */     // GIR_Coverage, 61423,
     /* 1101341 */     GIR_EraseRootFromParent_Done,
     /* 1101342 */   // Label 16209: @1101342
     /* 1101342 */   GIM_Try, /*On fail goto*//*Label 16210*/ GIMT_Encode4(1101419), // Rule ID 61426 //
     /* 1101347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101386 */     // MIs[0] policy
     /* 1101386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101396 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101418 */     // GIR_Coverage, 61426,
     /* 1101418 */     GIR_EraseRootFromParent_Done,
     /* 1101419 */   // Label 16210: @1101419
     /* 1101419 */   GIM_Try, /*On fail goto*//*Label 16211*/ GIMT_Encode4(1101496), // Rule ID 61427 //
     /* 1101424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1101435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1101438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1101441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1101444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1101451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1101459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101463 */     // MIs[0] policy
     /* 1101463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101473 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1101476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1101492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101495 */     // GIR_Coverage, 61427,
     /* 1101495 */     GIR_EraseRootFromParent_Done,
     /* 1101496 */   // Label 16211: @1101496
     /* 1101496 */   GIM_Try, /*On fail goto*//*Label 16212*/ GIMT_Encode4(1101573), // Rule ID 61430 //
     /* 1101501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101540 */     // MIs[0] policy
     /* 1101540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101550 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1101553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101572 */     // GIR_Coverage, 61430,
     /* 1101572 */     GIR_EraseRootFromParent_Done,
     /* 1101573 */   // Label 16212: @1101573
     /* 1101573 */   GIM_Try, /*On fail goto*//*Label 16213*/ GIMT_Encode4(1101650), // Rule ID 61431 //
     /* 1101578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101617 */     // MIs[0] policy
     /* 1101617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101627 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1101630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101649 */     // GIR_Coverage, 61431,
     /* 1101649 */     GIR_EraseRootFromParent_Done,
     /* 1101650 */   // Label 16213: @1101650
     /* 1101650 */   GIM_Try, /*On fail goto*//*Label 16214*/ GIMT_Encode4(1101727), // Rule ID 61434 //
     /* 1101655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1101666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1101669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1101672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1101675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1101682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101694 */     // MIs[0] policy
     /* 1101694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101704 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1101707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101726 */     // GIR_Coverage, 61434,
     /* 1101726 */     GIR_EraseRootFromParent_Done,
     /* 1101727 */   // Label 16214: @1101727
     /* 1101727 */   GIM_Try, /*On fail goto*//*Label 16215*/ GIMT_Encode4(1101804), // Rule ID 61435 //
     /* 1101732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1101743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1101746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1101749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1101752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1101759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101771 */     // MIs[0] policy
     /* 1101771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101781 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1101784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101803 */     // GIR_Coverage, 61435,
     /* 1101803 */     GIR_EraseRootFromParent_Done,
     /* 1101804 */   // Label 16215: @1101804
     /* 1101804 */   GIM_Try, /*On fail goto*//*Label 16216*/ GIMT_Encode4(1101881), // Rule ID 61438 //
     /* 1101809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1101820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1101823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1101826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1101829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1101836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101848 */     // MIs[0] policy
     /* 1101848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101858 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1101861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101880 */     // GIR_Coverage, 61438,
     /* 1101880 */     GIR_EraseRootFromParent_Done,
     /* 1101881 */   // Label 16216: @1101881
     /* 1101881 */   GIM_Try, /*On fail goto*//*Label 16217*/ GIMT_Encode4(1101958), // Rule ID 61439 //
     /* 1101886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1101897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1101900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1101903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1101906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1101913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101925 */     // MIs[0] policy
     /* 1101925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101935 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1101938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101957 */     // GIR_Coverage, 61439,
     /* 1101957 */     GIR_EraseRootFromParent_Done,
     /* 1101958 */   // Label 16217: @1101958
     /* 1101958 */   GIM_Try, /*On fail goto*//*Label 16218*/ GIMT_Encode4(1102035), // Rule ID 61442 //
     /* 1101963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1101974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1101977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1101980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102002 */     // MIs[0] policy
     /* 1102002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102034 */     // GIR_Coverage, 61442,
     /* 1102034 */     GIR_EraseRootFromParent_Done,
     /* 1102035 */   // Label 16218: @1102035
     /* 1102035 */   GIM_Try, /*On fail goto*//*Label 16219*/ GIMT_Encode4(1102112), // Rule ID 61443 //
     /* 1102040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1102051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1102054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1102057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102079 */     // MIs[0] policy
     /* 1102079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102098 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102111 */     // GIR_Coverage, 61443,
     /* 1102111 */     GIR_EraseRootFromParent_Done,
     /* 1102112 */   // Label 16219: @1102112
     /* 1102112 */   GIM_Try, /*On fail goto*//*Label 16220*/ GIMT_Encode4(1102189), // Rule ID 61446 //
     /* 1102117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102156 */     // MIs[0] policy
     /* 1102156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102166 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102188 */     // GIR_Coverage, 61446,
     /* 1102188 */     GIR_EraseRootFromParent_Done,
     /* 1102189 */   // Label 16220: @1102189
     /* 1102189 */   GIM_Try, /*On fail goto*//*Label 16221*/ GIMT_Encode4(1102266), // Rule ID 61447 //
     /* 1102194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1102205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1102208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1102211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102233 */     // MIs[0] policy
     /* 1102233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102243 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102265 */     // GIR_Coverage, 61447,
     /* 1102265 */     GIR_EraseRootFromParent_Done,
     /* 1102266 */   // Label 16221: @1102266
     /* 1102266 */   GIM_Try, /*On fail goto*//*Label 16222*/ GIMT_Encode4(1102343), // Rule ID 61450 //
     /* 1102271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102310 */     // MIs[0] policy
     /* 1102310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102320 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102342 */     // GIR_Coverage, 61450,
     /* 1102342 */     GIR_EraseRootFromParent_Done,
     /* 1102343 */   // Label 16222: @1102343
     /* 1102343 */   GIM_Try, /*On fail goto*//*Label 16223*/ GIMT_Encode4(1102420), // Rule ID 61451 //
     /* 1102348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1102359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1102362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1102365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1102368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102387 */     // MIs[0] policy
     /* 1102387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102397 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1102416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102419 */     // GIR_Coverage, 61451,
     /* 1102419 */     GIR_EraseRootFromParent_Done,
     /* 1102420 */   // Label 16223: @1102420
     /* 1102420 */   GIM_Try, /*On fail goto*//*Label 16224*/ GIMT_Encode4(1102497), // Rule ID 61454 //
     /* 1102425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102464 */     // MIs[0] policy
     /* 1102464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102474 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102496 */     // GIR_Coverage, 61454,
     /* 1102496 */     GIR_EraseRootFromParent_Done,
     /* 1102497 */   // Label 16224: @1102497
     /* 1102497 */   GIM_Try, /*On fail goto*//*Label 16225*/ GIMT_Encode4(1102574), // Rule ID 61455 //
     /* 1102502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102541 */     // MIs[0] policy
     /* 1102541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102551 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102573 */     // GIR_Coverage, 61455,
     /* 1102573 */     GIR_EraseRootFromParent_Done,
     /* 1102574 */   // Label 16225: @1102574
     /* 1102574 */   GIM_Try, /*On fail goto*//*Label 16226*/ GIMT_Encode4(1102651), // Rule ID 61458 //
     /* 1102579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1102590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1102593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1102596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102618 */     // MIs[0] policy
     /* 1102618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102628 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102650 */     // GIR_Coverage, 61458,
     /* 1102650 */     GIR_EraseRootFromParent_Done,
     /* 1102651 */   // Label 16226: @1102651
     /* 1102651 */   GIM_Try, /*On fail goto*//*Label 16227*/ GIMT_Encode4(1102728), // Rule ID 61459 //
     /* 1102656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1102667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1102670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1102673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102695 */     // MIs[0] policy
     /* 1102695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102705 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102727 */     // GIR_Coverage, 61459,
     /* 1102727 */     GIR_EraseRootFromParent_Done,
     /* 1102728 */   // Label 16227: @1102728
     /* 1102728 */   GIM_Try, /*On fail goto*//*Label 16228*/ GIMT_Encode4(1102805), // Rule ID 61462 //
     /* 1102733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1102744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1102747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1102750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102772 */     // MIs[0] policy
     /* 1102772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102782 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102804 */     // GIR_Coverage, 61462,
     /* 1102804 */     GIR_EraseRootFromParent_Done,
     /* 1102805 */   // Label 16228: @1102805
     /* 1102805 */   GIM_Try, /*On fail goto*//*Label 16229*/ GIMT_Encode4(1102882), // Rule ID 61463 //
     /* 1102810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1102821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1102824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1102827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102849 */     // MIs[0] policy
     /* 1102849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102859 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102881 */     // GIR_Coverage, 61463,
     /* 1102881 */     GIR_EraseRootFromParent_Done,
     /* 1102882 */   // Label 16229: @1102882
     /* 1102882 */   GIM_Try, /*On fail goto*//*Label 16230*/ GIMT_Encode4(1102959), // Rule ID 61466 //
     /* 1102887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1102898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1102901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1102904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1102907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102926 */     // MIs[0] policy
     /* 1102926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1102955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102958 */     // GIR_Coverage, 61466,
     /* 1102958 */     GIR_EraseRootFromParent_Done,
     /* 1102959 */   // Label 16230: @1102959
     /* 1102959 */   GIM_Try, /*On fail goto*//*Label 16231*/ GIMT_Encode4(1103036), // Rule ID 61467 //
     /* 1102964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1102975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1102978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1102981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1102984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103003 */     // MIs[0] policy
     /* 1103003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103013 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1103016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103035 */     // GIR_Coverage, 61467,
     /* 1103035 */     GIR_EraseRootFromParent_Done,
     /* 1103036 */   // Label 16231: @1103036
     /* 1103036 */   GIM_Try, /*On fail goto*//*Label 16232*/ GIMT_Encode4(1103113), // Rule ID 61470 //
     /* 1103041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103080 */     // MIs[0] policy
     /* 1103080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103090 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103112 */     // GIR_Coverage, 61470,
     /* 1103112 */     GIR_EraseRootFromParent_Done,
     /* 1103113 */   // Label 16232: @1103113
     /* 1103113 */   GIM_Try, /*On fail goto*//*Label 16233*/ GIMT_Encode4(1103190), // Rule ID 61471 //
     /* 1103118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1103129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1103132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1103135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1103145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1103153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103157 */     // MIs[0] policy
     /* 1103157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103167 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1103170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103189 */     // GIR_Coverage, 61471,
     /* 1103189 */     GIR_EraseRootFromParent_Done,
     /* 1103190 */   // Label 16233: @1103190
     /* 1103190 */   GIM_Try, /*On fail goto*//*Label 16234*/ GIMT_Encode4(1103267), // Rule ID 61474 //
     /* 1103195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103234 */     // MIs[0] policy
     /* 1103234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103244 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103266 */     // GIR_Coverage, 61474,
     /* 1103266 */     GIR_EraseRootFromParent_Done,
     /* 1103267 */   // Label 16234: @1103267
     /* 1103267 */   GIM_Try, /*On fail goto*//*Label 16235*/ GIMT_Encode4(1103344), // Rule ID 61475 //
     /* 1103272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1103280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1103283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1103286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1103289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1103299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1103307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103311 */     // MIs[0] policy
     /* 1103311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103321 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11167:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1103324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1103340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103343 */     // GIR_Coverage, 61475,
     /* 1103343 */     GIR_EraseRootFromParent_Done,
     /* 1103344 */   // Label 16235: @1103344
     /* 1103344 */   GIM_Try, /*On fail goto*//*Label 16236*/ GIMT_Encode4(1103421), // Rule ID 61478 //
     /* 1103349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103388 */     // MIs[0] policy
     /* 1103388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103398 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1103401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103420 */     // GIR_Coverage, 61478,
     /* 1103420 */     GIR_EraseRootFromParent_Done,
     /* 1103421 */   // Label 16236: @1103421
     /* 1103421 */   GIM_Try, /*On fail goto*//*Label 16237*/ GIMT_Encode4(1103498), // Rule ID 61479 //
     /* 1103426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1103437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1103440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1103443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103465 */     // MIs[0] policy
     /* 1103465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103475 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1103478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103497 */     // GIR_Coverage, 61479,
     /* 1103497 */     GIR_EraseRootFromParent_Done,
     /* 1103498 */   // Label 16237: @1103498
     /* 1103498 */   GIM_Try, /*On fail goto*//*Label 16238*/ GIMT_Encode4(1103575), // Rule ID 61482 //
     /* 1103503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103542 */     // MIs[0] policy
     /* 1103542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103574 */     // GIR_Coverage, 61482,
     /* 1103574 */     GIR_EraseRootFromParent_Done,
     /* 1103575 */   // Label 16238: @1103575
     /* 1103575 */   GIM_Try, /*On fail goto*//*Label 16239*/ GIMT_Encode4(1103652), // Rule ID 61483 //
     /* 1103580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103619 */     // MIs[0] policy
     /* 1103619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103629 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103651 */     // GIR_Coverage, 61483,
     /* 1103651 */     GIR_EraseRootFromParent_Done,
     /* 1103652 */   // Label 16239: @1103652
     /* 1103652 */   GIM_Try, /*On fail goto*//*Label 16240*/ GIMT_Encode4(1103729), // Rule ID 61486 //
     /* 1103657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1103668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1103671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1103674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103696 */     // MIs[0] policy
     /* 1103696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103706 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103728 */     // GIR_Coverage, 61486,
     /* 1103728 */     GIR_EraseRootFromParent_Done,
     /* 1103729 */   // Label 16240: @1103729
     /* 1103729 */   GIM_Try, /*On fail goto*//*Label 16241*/ GIMT_Encode4(1103806), // Rule ID 61487 //
     /* 1103734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1103745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1103748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1103751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103773 */     // MIs[0] policy
     /* 1103773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103783 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103805 */     // GIR_Coverage, 61487,
     /* 1103805 */     GIR_EraseRootFromParent_Done,
     /* 1103806 */   // Label 16241: @1103806
     /* 1103806 */   GIM_Try, /*On fail goto*//*Label 16242*/ GIMT_Encode4(1103883), // Rule ID 61490 //
     /* 1103811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1103822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1103825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1103828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103850 */     // MIs[0] policy
     /* 1103850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103860 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103882 */     // GIR_Coverage, 61490,
     /* 1103882 */     GIR_EraseRootFromParent_Done,
     /* 1103883 */   // Label 16242: @1103883
     /* 1103883 */   GIM_Try, /*On fail goto*//*Label 16243*/ GIMT_Encode4(1103960), // Rule ID 61491 //
     /* 1103888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1103899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1103902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1103905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103927 */     // MIs[0] policy
     /* 1103927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103937 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103959 */     // GIR_Coverage, 61491,
     /* 1103959 */     GIR_EraseRootFromParent_Done,
     /* 1103960 */   // Label 16243: @1103960
     /* 1103960 */   GIM_Try, /*On fail goto*//*Label 16244*/ GIMT_Encode4(1104037), // Rule ID 61494 //
     /* 1103965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1103976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1103979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1103982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104004 */     // MIs[0] policy
     /* 1104004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104036 */     // GIR_Coverage, 61494,
     /* 1104036 */     GIR_EraseRootFromParent_Done,
     /* 1104037 */   // Label 16244: @1104037
     /* 1104037 */   GIM_Try, /*On fail goto*//*Label 16245*/ GIMT_Encode4(1104114), // Rule ID 61495 //
     /* 1104042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1104053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1104056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1104059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104081 */     // MIs[0] policy
     /* 1104081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104091 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104113 */     // GIR_Coverage, 61495,
     /* 1104113 */     GIR_EraseRootFromParent_Done,
     /* 1104114 */   // Label 16245: @1104114
     /* 1104114 */   GIM_Try, /*On fail goto*//*Label 16246*/ GIMT_Encode4(1104191), // Rule ID 61498 //
     /* 1104119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104158 */     // MIs[0] policy
     /* 1104158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104190 */     // GIR_Coverage, 61498,
     /* 1104190 */     GIR_EraseRootFromParent_Done,
     /* 1104191 */   // Label 16246: @1104191
     /* 1104191 */   GIM_Try, /*On fail goto*//*Label 16247*/ GIMT_Encode4(1104268), // Rule ID 61499 //
     /* 1104196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1104207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1104210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1104213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104235 */     // MIs[0] policy
     /* 1104235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104245 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1104248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104267 */     // GIR_Coverage, 61499,
     /* 1104267 */     GIR_EraseRootFromParent_Done,
     /* 1104268 */   // Label 16247: @1104268
     /* 1104268 */   GIM_Try, /*On fail goto*//*Label 16248*/ GIMT_Encode4(1104345), // Rule ID 61502 //
     /* 1104273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104312 */     // MIs[0] policy
     /* 1104312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104322 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104344 */     // GIR_Coverage, 61502,
     /* 1104344 */     GIR_EraseRootFromParent_Done,
     /* 1104345 */   // Label 16248: @1104345
     /* 1104345 */   GIM_Try, /*On fail goto*//*Label 16249*/ GIMT_Encode4(1104422), // Rule ID 61503 //
     /* 1104350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1104361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1104364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1104367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104389 */     // MIs[0] policy
     /* 1104389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104399 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11518:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104421 */     // GIR_Coverage, 61503,
     /* 1104421 */     GIR_EraseRootFromParent_Done,
     /* 1104422 */   // Label 16249: @1104422
     /* 1104422 */   GIM_Try, /*On fail goto*//*Label 16250*/ GIMT_Encode4(1104499), // Rule ID 61506 //
     /* 1104427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104466 */     // MIs[0] policy
     /* 1104466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104498 */     // GIR_Coverage, 61506,
     /* 1104498 */     GIR_EraseRootFromParent_Done,
     /* 1104499 */   // Label 16250: @1104499
     /* 1104499 */   GIM_Try, /*On fail goto*//*Label 16251*/ GIMT_Encode4(1104576), // Rule ID 61507 //
     /* 1104504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104543 */     // MIs[0] policy
     /* 1104543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104553 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11518:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104575 */     // GIR_Coverage, 61507,
     /* 1104575 */     GIR_EraseRootFromParent_Done,
     /* 1104576 */   // Label 16251: @1104576
     /* 1104576 */   GIM_Try, /*On fail goto*//*Label 16252*/ GIMT_Encode4(1104653), // Rule ID 61510 //
     /* 1104581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1104592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1104595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1104598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104620 */     // MIs[0] policy
     /* 1104620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104652 */     // GIR_Coverage, 61510,
     /* 1104652 */     GIR_EraseRootFromParent_Done,
     /* 1104653 */   // Label 16252: @1104653
     /* 1104653 */   GIM_Try, /*On fail goto*//*Label 16253*/ GIMT_Encode4(1104730), // Rule ID 61511 //
     /* 1104658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1104669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1104672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1104675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104697 */     // MIs[0] policy
     /* 1104697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104707 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11518:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104729 */     // GIR_Coverage, 61511,
     /* 1104729 */     GIR_EraseRootFromParent_Done,
     /* 1104730 */   // Label 16253: @1104730
     /* 1104730 */   GIM_Try, /*On fail goto*//*Label 16254*/ GIMT_Encode4(1104807), // Rule ID 61514 //
     /* 1104735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1104746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1104749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1104752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104774 */     // MIs[0] policy
     /* 1104774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1104803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104806 */     // GIR_Coverage, 61514,
     /* 1104806 */     GIR_EraseRootFromParent_Done,
     /* 1104807 */   // Label 16254: @1104807
     /* 1104807 */   GIM_Try, /*On fail goto*//*Label 16255*/ GIMT_Encode4(1104884), // Rule ID 61515 //
     /* 1104812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1104823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1104826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1104829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104851 */     // MIs[0] policy
     /* 1104851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104861 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11518:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1104880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104883 */     // GIR_Coverage, 61515,
     /* 1104883 */     GIR_EraseRootFromParent_Done,
     /* 1104884 */   // Label 16255: @1104884
     /* 1104884 */   GIM_Try, /*On fail goto*//*Label 16256*/ GIMT_Encode4(1104961), // Rule ID 61518 //
     /* 1104889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1104900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1104903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1104906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1104909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1104916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104928 */     // MIs[0] policy
     /* 1104928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104938 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1104941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104960 */     // GIR_Coverage, 61518,
     /* 1104960 */     GIR_EraseRootFromParent_Done,
     /* 1104961 */   // Label 16256: @1104961
     /* 1104961 */   GIM_Try, /*On fail goto*//*Label 16257*/ GIMT_Encode4(1105038), // Rule ID 61519 //
     /* 1104966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1104977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1104980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1104983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1104986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1104993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105005 */     // MIs[0] policy
     /* 1105005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105015 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105037 */     // GIR_Coverage, 61519,
     /* 1105037 */     GIR_EraseRootFromParent_Done,
     /* 1105038 */   // Label 16257: @1105038
     /* 1105038 */   GIM_Try, /*On fail goto*//*Label 16258*/ GIMT_Encode4(1105115), // Rule ID 61522 //
     /* 1105043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105082 */     // MIs[0] policy
     /* 1105082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105114 */     // GIR_Coverage, 61522,
     /* 1105114 */     GIR_EraseRootFromParent_Done,
     /* 1105115 */   // Label 16258: @1105115
     /* 1105115 */   GIM_Try, /*On fail goto*//*Label 16259*/ GIMT_Encode4(1105192), // Rule ID 61523 //
     /* 1105120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1105131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1105134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1105137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105159 */     // MIs[0] policy
     /* 1105159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105169 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105178 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105191 */     // GIR_Coverage, 61523,
     /* 1105191 */     GIR_EraseRootFromParent_Done,
     /* 1105192 */   // Label 16259: @1105192
     /* 1105192 */   GIM_Try, /*On fail goto*//*Label 16260*/ GIMT_Encode4(1105269), // Rule ID 61526 //
     /* 1105197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105236 */     // MIs[0] policy
     /* 1105236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105246 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105268 */     // GIR_Coverage, 61526,
     /* 1105268 */     GIR_EraseRootFromParent_Done,
     /* 1105269 */   // Label 16260: @1105269
     /* 1105269 */   GIM_Try, /*On fail goto*//*Label 16261*/ GIMT_Encode4(1105346), // Rule ID 61527 //
     /* 1105274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1105285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1105288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1105291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1105294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105313 */     // MIs[0] policy
     /* 1105313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105323 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1105342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105345 */     // GIR_Coverage, 61527,
     /* 1105345 */     GIR_EraseRootFromParent_Done,
     /* 1105346 */   // Label 16261: @1105346
     /* 1105346 */   GIM_Try, /*On fail goto*//*Label 16262*/ GIMT_Encode4(1105423), // Rule ID 61530 //
     /* 1105351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105390 */     // MIs[0] policy
     /* 1105390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105422 */     // GIR_Coverage, 61530,
     /* 1105422 */     GIR_EraseRootFromParent_Done,
     /* 1105423 */   // Label 16262: @1105423
     /* 1105423 */   GIM_Try, /*On fail goto*//*Label 16263*/ GIMT_Encode4(1105500), // Rule ID 61531 //
     /* 1105428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1105439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1105442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1105445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105467 */     // MIs[0] policy
     /* 1105467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105477 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105499 */     // GIR_Coverage, 61531,
     /* 1105499 */     GIR_EraseRootFromParent_Done,
     /* 1105500 */   // Label 16263: @1105500
     /* 1105500 */   GIM_Try, /*On fail goto*//*Label 16264*/ GIMT_Encode4(1105577), // Rule ID 61534 //
     /* 1105505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105544 */     // MIs[0] policy
     /* 1105544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105554 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105576 */     // GIR_Coverage, 61534,
     /* 1105576 */     GIR_EraseRootFromParent_Done,
     /* 1105577 */   // Label 16264: @1105577
     /* 1105577 */   GIM_Try, /*On fail goto*//*Label 16265*/ GIMT_Encode4(1105654), // Rule ID 61535 //
     /* 1105582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105621 */     // MIs[0] policy
     /* 1105621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105631 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105640 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105653 */     // GIR_Coverage, 61535,
     /* 1105653 */     GIR_EraseRootFromParent_Done,
     /* 1105654 */   // Label 16265: @1105654
     /* 1105654 */   GIM_Try, /*On fail goto*//*Label 16266*/ GIMT_Encode4(1105731), // Rule ID 61538 //
     /* 1105659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1105670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1105673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1105676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105698 */     // MIs[0] policy
     /* 1105698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105708 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105730 */     // GIR_Coverage, 61538,
     /* 1105730 */     GIR_EraseRootFromParent_Done,
     /* 1105731 */   // Label 16266: @1105731
     /* 1105731 */   GIM_Try, /*On fail goto*//*Label 16267*/ GIMT_Encode4(1105808), // Rule ID 61539 //
     /* 1105736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1105747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1105750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1105753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105775 */     // MIs[0] policy
     /* 1105775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105785 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105794 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105807 */     // GIR_Coverage, 61539,
     /* 1105807 */     GIR_EraseRootFromParent_Done,
     /* 1105808 */   // Label 16267: @1105808
     /* 1105808 */   GIM_Try, /*On fail goto*//*Label 16268*/ GIMT_Encode4(1105885), // Rule ID 61542 //
     /* 1105813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1105824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1105827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1105830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1105833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105852 */     // MIs[0] policy
     /* 1105852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105884 */     // GIR_Coverage, 61542,
     /* 1105884 */     GIR_EraseRootFromParent_Done,
     /* 1105885 */   // Label 16268: @1105885
     /* 1105885 */   GIM_Try, /*On fail goto*//*Label 16269*/ GIMT_Encode4(1105962), // Rule ID 61543 //
     /* 1105890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1105901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1105904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1105907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1105910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105929 */     // MIs[0] policy
     /* 1105929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105939 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105961 */     // GIR_Coverage, 61543,
     /* 1105961 */     GIR_EraseRootFromParent_Done,
     /* 1105962 */   // Label 16269: @1105962
     /* 1105962 */   GIM_Try, /*On fail goto*//*Label 16270*/ GIMT_Encode4(1106039), // Rule ID 61546 //
     /* 1105967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1105978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1105981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1105984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106006 */     // MIs[0] policy
     /* 1106006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106038 */     // GIR_Coverage, 61546,
     /* 1106038 */     GIR_EraseRootFromParent_Done,
     /* 1106039 */   // Label 16270: @1106039
     /* 1106039 */   GIM_Try, /*On fail goto*//*Label 16271*/ GIMT_Encode4(1106116), // Rule ID 61547 //
     /* 1106044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106083 */     // MIs[0] policy
     /* 1106083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106093 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106102 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106115 */     // GIR_Coverage, 61547,
     /* 1106115 */     GIR_EraseRootFromParent_Done,
     /* 1106116 */   // Label 16271: @1106116
     /* 1106116 */   GIM_Try, /*On fail goto*//*Label 16272*/ GIMT_Encode4(1106193), // Rule ID 61550 //
     /* 1106121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106160 */     // MIs[0] policy
     /* 1106160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106170 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106192 */     // GIR_Coverage, 61550,
     /* 1106192 */     GIR_EraseRootFromParent_Done,
     /* 1106193 */   // Label 16272: @1106193
     /* 1106193 */   GIM_Try, /*On fail goto*//*Label 16273*/ GIMT_Encode4(1106270), // Rule ID 61551 //
     /* 1106198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1106218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106237 */     // MIs[0] policy
     /* 1106237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106247 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106256 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106269 */     // GIR_Coverage, 61551,
     /* 1106269 */     GIR_EraseRootFromParent_Done,
     /* 1106270 */   // Label 16273: @1106270
     /* 1106270 */   GIM_Try, /*On fail goto*//*Label 16274*/ GIMT_Encode4(1106347), // Rule ID 61554 //
     /* 1106275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106314 */     // MIs[0] policy
     /* 1106314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106324 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106346 */     // GIR_Coverage, 61554,
     /* 1106346 */     GIR_EraseRootFromParent_Done,
     /* 1106347 */   // Label 16274: @1106347
     /* 1106347 */   GIM_Try, /*On fail goto*//*Label 16275*/ GIMT_Encode4(1106424), // Rule ID 61555 //
     /* 1106352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1106363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1106366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1106369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1106372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1106379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106391 */     // MIs[0] policy
     /* 1106391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106401 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11518:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1106404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106423 */     // GIR_Coverage, 61555,
     /* 1106423 */     GIR_EraseRootFromParent_Done,
     /* 1106424 */   // Label 16275: @1106424
     /* 1106424 */   GIM_Try, /*On fail goto*//*Label 16276*/ GIMT_Encode4(1106501), // Rule ID 61558 //
     /* 1106429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106468 */     // MIs[0] policy
     /* 1106468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106478 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106500 */     // GIR_Coverage, 61558,
     /* 1106500 */     GIR_EraseRootFromParent_Done,
     /* 1106501 */   // Label 16276: @1106501
     /* 1106501 */   GIM_Try, /*On fail goto*//*Label 16277*/ GIMT_Encode4(1106578), // Rule ID 61559 //
     /* 1106506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106545 */     // MIs[0] policy
     /* 1106545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106555 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11518:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106577 */     // GIR_Coverage, 61559,
     /* 1106577 */     GIR_EraseRootFromParent_Done,
     /* 1106578 */   // Label 16277: @1106578
     /* 1106578 */   GIM_Try, /*On fail goto*//*Label 16278*/ GIMT_Encode4(1106655), // Rule ID 61562 //
     /* 1106583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1106594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1106597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1106600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106622 */     // MIs[0] policy
     /* 1106622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106632 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106654 */     // GIR_Coverage, 61562,
     /* 1106654 */     GIR_EraseRootFromParent_Done,
     /* 1106655 */   // Label 16278: @1106655
     /* 1106655 */   GIM_Try, /*On fail goto*//*Label 16279*/ GIMT_Encode4(1106732), // Rule ID 61563 //
     /* 1106660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1106671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1106674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1106677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106699 */     // MIs[0] policy
     /* 1106699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11518:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106718 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106731 */     // GIR_Coverage, 61563,
     /* 1106731 */     GIR_EraseRootFromParent_Done,
     /* 1106732 */   // Label 16279: @1106732
     /* 1106732 */   GIM_Try, /*On fail goto*//*Label 16280*/ GIMT_Encode4(1106809), // Rule ID 62088 //
     /* 1106737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1106740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1106748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1106751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1106754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1106757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106776 */     // MIs[0] policy
     /* 1106776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1106789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106808 */     // GIR_Coverage, 62088,
     /* 1106808 */     GIR_EraseRootFromParent_Done,
     /* 1106809 */   // Label 16280: @1106809
     /* 1106809 */   GIM_Try, /*On fail goto*//*Label 16281*/ GIMT_Encode4(1106886), // Rule ID 62089 //
     /* 1106814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1106817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1106825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1106828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1106831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1106834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106853 */     // MIs[0] policy
     /* 1106853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106863 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11319:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1106866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106885 */     // GIR_Coverage, 62089,
     /* 1106885 */     GIR_EraseRootFromParent_Done,
     /* 1106886 */   // Label 16281: @1106886
     /* 1106886 */   GIM_Try, /*On fail goto*//*Label 16282*/ GIMT_Encode4(1106963), // Rule ID 62090 //
     /* 1106891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1106894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1106911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106930 */     // MIs[0] policy
     /* 1106930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1106943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106962 */     // GIR_Coverage, 62090,
     /* 1106962 */     GIR_EraseRootFromParent_Done,
     /* 1106963 */   // Label 16282: @1106963
     /* 1106963 */   GIM_Try, /*On fail goto*//*Label 16283*/ GIMT_Encode4(1107040), // Rule ID 62091 //
     /* 1106968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1106971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1106988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107007 */     // MIs[0] policy
     /* 1107007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107017 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11319:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1107020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107039 */     // GIR_Coverage, 62091,
     /* 1107039 */     GIR_EraseRootFromParent_Done,
     /* 1107040 */   // Label 16283: @1107040
     /* 1107040 */   GIM_Try, /*On fail goto*//*Label 16284*/ GIMT_Encode4(1107117), // Rule ID 62092 //
     /* 1107045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107084 */     // MIs[0] policy
     /* 1107084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1107097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107116 */     // GIR_Coverage, 62092,
     /* 1107116 */     GIR_EraseRootFromParent_Done,
     /* 1107117 */   // Label 16284: @1107117
     /* 1107117 */   GIM_Try, /*On fail goto*//*Label 16285*/ GIMT_Encode4(1107194), // Rule ID 62093 //
     /* 1107122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107161 */     // MIs[0] policy
     /* 1107161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107171 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11319:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1107174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107193 */     // GIR_Coverage, 62093,
     /* 1107193 */     GIR_EraseRootFromParent_Done,
     /* 1107194 */   // Label 16285: @1107194
     /* 1107194 */   GIM_Try, /*On fail goto*//*Label 16286*/ GIMT_Encode4(1107271), // Rule ID 62094 //
     /* 1107199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1107202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107238 */     // MIs[0] policy
     /* 1107238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1107251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107270 */     // GIR_Coverage, 62094,
     /* 1107270 */     GIR_EraseRootFromParent_Done,
     /* 1107271 */   // Label 16286: @1107271
     /* 1107271 */   GIM_Try, /*On fail goto*//*Label 16287*/ GIMT_Encode4(1107348), // Rule ID 62095 //
     /* 1107276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1107279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1107284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107315 */     // MIs[0] policy
     /* 1107315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107325 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11319:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1107328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107347 */     // GIR_Coverage, 62095,
     /* 1107347 */     GIR_EraseRootFromParent_Done,
     /* 1107348 */   // Label 16287: @1107348
     /* 1107348 */   GIM_Try, /*On fail goto*//*Label 16288*/ GIMT_Encode4(1107425), // Rule ID 62298 //
     /* 1107353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107392 */     // MIs[0] policy
     /* 1107392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107402 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107424 */     // GIR_Coverage, 62298,
     /* 1107424 */     GIR_EraseRootFromParent_Done,
     /* 1107425 */   // Label 16288: @1107425
     /* 1107425 */   GIM_Try, /*On fail goto*//*Label 16289*/ GIMT_Encode4(1107502), // Rule ID 62299 //
     /* 1107430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107469 */     // MIs[0] policy
     /* 1107469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107479 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107501 */     // GIR_Coverage, 62299,
     /* 1107501 */     GIR_EraseRootFromParent_Done,
     /* 1107502 */   // Label 16289: @1107502
     /* 1107502 */   GIM_Try, /*On fail goto*//*Label 16290*/ GIMT_Encode4(1107579), // Rule ID 62300 //
     /* 1107507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107546 */     // MIs[0] policy
     /* 1107546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107556 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1107559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107578 */     // GIR_Coverage, 62300,
     /* 1107578 */     GIR_EraseRootFromParent_Done,
     /* 1107579 */   // Label 16290: @1107579
     /* 1107579 */   GIM_Try, /*On fail goto*//*Label 16291*/ GIMT_Encode4(1107656), // Rule ID 62301 //
     /* 1107584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107623 */     // MIs[0] policy
     /* 1107623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1107636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107655 */     // GIR_Coverage, 62301,
     /* 1107655 */     GIR_EraseRootFromParent_Done,
     /* 1107656 */   // Label 16291: @1107656
     /* 1107656 */   GIM_Try, /*On fail goto*//*Label 16292*/ GIMT_Encode4(1107733), // Rule ID 62302 //
     /* 1107661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107700 */     // MIs[0] policy
     /* 1107700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1107713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107732 */     // GIR_Coverage, 62302,
     /* 1107732 */     GIR_EraseRootFromParent_Done,
     /* 1107733 */   // Label 16292: @1107733
     /* 1107733 */   GIM_Try, /*On fail goto*//*Label 16293*/ GIMT_Encode4(1107810), // Rule ID 62303 //
     /* 1107738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107777 */     // MIs[0] policy
     /* 1107777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107787 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1107790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107809 */     // GIR_Coverage, 62303,
     /* 1107809 */     GIR_EraseRootFromParent_Done,
     /* 1107810 */   // Label 16293: @1107810
     /* 1107810 */   GIM_Try, /*On fail goto*//*Label 16294*/ GIMT_Encode4(1107887), // Rule ID 62304 //
     /* 1107815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107854 */     // MIs[0] policy
     /* 1107854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107864 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1107867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107886 */     // GIR_Coverage, 62304,
     /* 1107886 */     GIR_EraseRootFromParent_Done,
     /* 1107887 */   // Label 16294: @1107887
     /* 1107887 */   GIM_Try, /*On fail goto*//*Label 16295*/ GIMT_Encode4(1107964), // Rule ID 62305 //
     /* 1107892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107931 */     // MIs[0] policy
     /* 1107931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107941 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1107944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107963 */     // GIR_Coverage, 62305,
     /* 1107963 */     GIR_EraseRootFromParent_Done,
     /* 1107964 */   // Label 16295: @1107964
     /* 1107964 */   GIM_Try, /*On fail goto*//*Label 16296*/ GIMT_Encode4(1108041), // Rule ID 62306 //
     /* 1107969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108008 */     // MIs[0] policy
     /* 1108008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108040 */     // GIR_Coverage, 62306,
     /* 1108040 */     GIR_EraseRootFromParent_Done,
     /* 1108041 */   // Label 16296: @1108041
     /* 1108041 */   GIM_Try, /*On fail goto*//*Label 16297*/ GIMT_Encode4(1108118), // Rule ID 62307 //
     /* 1108046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1108054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108085 */     // MIs[0] policy
     /* 1108085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108095 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108117 */     // GIR_Coverage, 62307,
     /* 1108117 */     GIR_EraseRootFromParent_Done,
     /* 1108118 */   // Label 16297: @1108118
     /* 1108118 */   GIM_Try, /*On fail goto*//*Label 16298*/ GIMT_Encode4(1108195), // Rule ID 62308 //
     /* 1108123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108162 */     // MIs[0] policy
     /* 1108162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108172 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1108175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108194 */     // GIR_Coverage, 62308,
     /* 1108194 */     GIR_EraseRootFromParent_Done,
     /* 1108195 */   // Label 16298: @1108195
     /* 1108195 */   GIM_Try, /*On fail goto*//*Label 16299*/ GIMT_Encode4(1108272), // Rule ID 62309 //
     /* 1108200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108239 */     // MIs[0] policy
     /* 1108239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108249 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1108252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108271 */     // GIR_Coverage, 62309,
     /* 1108271 */     GIR_EraseRootFromParent_Done,
     /* 1108272 */   // Label 16299: @1108272
     /* 1108272 */   GIM_Try, /*On fail goto*//*Label 16300*/ GIMT_Encode4(1108349), // Rule ID 62310 //
     /* 1108277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108316 */     // MIs[0] policy
     /* 1108316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108348 */     // GIR_Coverage, 62310,
     /* 1108348 */     GIR_EraseRootFromParent_Done,
     /* 1108349 */   // Label 16300: @1108349
     /* 1108349 */   GIM_Try, /*On fail goto*//*Label 16301*/ GIMT_Encode4(1108426), // Rule ID 62311 //
     /* 1108354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108393 */     // MIs[0] policy
     /* 1108393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108403 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1108406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108425 */     // GIR_Coverage, 62311,
     /* 1108425 */     GIR_EraseRootFromParent_Done,
     /* 1108426 */   // Label 16301: @1108426
     /* 1108426 */   GIM_Try, /*On fail goto*//*Label 16302*/ GIMT_Encode4(1108503), // Rule ID 62312 //
     /* 1108431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108470 */     // MIs[0] policy
     /* 1108470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108480 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108502 */     // GIR_Coverage, 62312,
     /* 1108502 */     GIR_EraseRootFromParent_Done,
     /* 1108503 */   // Label 16302: @1108503
     /* 1108503 */   GIM_Try, /*On fail goto*//*Label 16303*/ GIMT_Encode4(1108580), // Rule ID 62313 //
     /* 1108508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108547 */     // MIs[0] policy
     /* 1108547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108579 */     // GIR_Coverage, 62313,
     /* 1108579 */     GIR_EraseRootFromParent_Done,
     /* 1108580 */   // Label 16303: @1108580
     /* 1108580 */   GIM_Try, /*On fail goto*//*Label 16304*/ GIMT_Encode4(1108657), // Rule ID 62314 //
     /* 1108585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108624 */     // MIs[0] policy
     /* 1108624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108634 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108656 */     // GIR_Coverage, 62314,
     /* 1108656 */     GIR_EraseRootFromParent_Done,
     /* 1108657 */   // Label 16304: @1108657
     /* 1108657 */   GIM_Try, /*On fail goto*//*Label 16305*/ GIMT_Encode4(1108734), // Rule ID 62315 //
     /* 1108662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108701 */     // MIs[0] policy
     /* 1108701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108711 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108733 */     // GIR_Coverage, 62315,
     /* 1108733 */     GIR_EraseRootFromParent_Done,
     /* 1108734 */   // Label 16305: @1108734
     /* 1108734 */   GIM_Try, /*On fail goto*//*Label 16306*/ GIMT_Encode4(1108811), // Rule ID 62316 //
     /* 1108739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108778 */     // MIs[0] policy
     /* 1108778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108788 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108810 */     // GIR_Coverage, 62316,
     /* 1108810 */     GIR_EraseRootFromParent_Done,
     /* 1108811 */   // Label 16306: @1108811
     /* 1108811 */   GIM_Try, /*On fail goto*//*Label 16307*/ GIMT_Encode4(1108888), // Rule ID 62317 //
     /* 1108816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108855 */     // MIs[0] policy
     /* 1108855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108865 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108887 */     // GIR_Coverage, 62317,
     /* 1108887 */     GIR_EraseRootFromParent_Done,
     /* 1108888 */   // Label 16307: @1108888
     /* 1108888 */   GIM_Try, /*On fail goto*//*Label 16308*/ GIMT_Encode4(1108965), // Rule ID 62318 //
     /* 1108893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108932 */     // MIs[0] policy
     /* 1108932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1108945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108964 */     // GIR_Coverage, 62318,
     /* 1108964 */     GIR_EraseRootFromParent_Done,
     /* 1108965 */   // Label 16308: @1108965
     /* 1108965 */   GIM_Try, /*On fail goto*//*Label 16309*/ GIMT_Encode4(1109042), // Rule ID 62319 //
     /* 1108970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109009 */     // MIs[0] policy
     /* 1109009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109019 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1109022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109041 */     // GIR_Coverage, 62319,
     /* 1109041 */     GIR_EraseRootFromParent_Done,
     /* 1109042 */   // Label 16309: @1109042
     /* 1109042 */   GIM_Try, /*On fail goto*//*Label 16310*/ GIMT_Encode4(1109119), // Rule ID 62320 //
     /* 1109047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109086 */     // MIs[0] policy
     /* 1109086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1109099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109118 */     // GIR_Coverage, 62320,
     /* 1109118 */     GIR_EraseRootFromParent_Done,
     /* 1109119 */   // Label 16310: @1109119
     /* 1109119 */   GIM_Try, /*On fail goto*//*Label 16311*/ GIMT_Encode4(1109196), // Rule ID 62321 //
     /* 1109124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109163 */     // MIs[0] policy
     /* 1109163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109173 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1109176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109195 */     // GIR_Coverage, 62321,
     /* 1109195 */     GIR_EraseRootFromParent_Done,
     /* 1109196 */   // Label 16311: @1109196
     /* 1109196 */   GIM_Try, /*On fail goto*//*Label 16312*/ GIMT_Encode4(1109273), // Rule ID 62322 //
     /* 1109201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109240 */     // MIs[0] policy
     /* 1109240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1109253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109272 */     // GIR_Coverage, 62322,
     /* 1109272 */     GIR_EraseRootFromParent_Done,
     /* 1109273 */   // Label 16312: @1109273
     /* 1109273 */   GIM_Try, /*On fail goto*//*Label 16313*/ GIMT_Encode4(1109350), // Rule ID 62323 //
     /* 1109278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109317 */     // MIs[0] policy
     /* 1109317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1109330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109349 */     // GIR_Coverage, 62323,
     /* 1109349 */     GIR_EraseRootFromParent_Done,
     /* 1109350 */   // Label 16313: @1109350
     /* 1109350 */   GIM_Try, /*On fail goto*//*Label 16314*/ GIMT_Encode4(1109427), // Rule ID 62324 //
     /* 1109355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109394 */     // MIs[0] policy
     /* 1109394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1109407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109426 */     // GIR_Coverage, 62324,
     /* 1109426 */     GIR_EraseRootFromParent_Done,
     /* 1109427 */   // Label 16314: @1109427
     /* 1109427 */   GIM_Try, /*On fail goto*//*Label 16315*/ GIMT_Encode4(1109504), // Rule ID 62325 //
     /* 1109432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109471 */     // MIs[0] policy
     /* 1109471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109481 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1109484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109503 */     // GIR_Coverage, 62325,
     /* 1109503 */     GIR_EraseRootFromParent_Done,
     /* 1109504 */   // Label 16315: @1109504
     /* 1109504 */   GIM_Try, /*On fail goto*//*Label 16316*/ GIMT_Encode4(1109581), // Rule ID 62326 //
     /* 1109509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109548 */     // MIs[0] policy
     /* 1109548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1109561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109580 */     // GIR_Coverage, 62326,
     /* 1109580 */     GIR_EraseRootFromParent_Done,
     /* 1109581 */   // Label 16316: @1109581
     /* 1109581 */   GIM_Try, /*On fail goto*//*Label 16317*/ GIMT_Encode4(1109658), // Rule ID 62327 //
     /* 1109586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109625 */     // MIs[0] policy
     /* 1109625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109635 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1109638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109657 */     // GIR_Coverage, 62327,
     /* 1109657 */     GIR_EraseRootFromParent_Done,
     /* 1109658 */   // Label 16317: @1109658
     /* 1109658 */   GIM_Try, /*On fail goto*//*Label 16318*/ GIMT_Encode4(1109735), // Rule ID 62328 //
     /* 1109663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109702 */     // MIs[0] policy
     /* 1109702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109712 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1109715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109734 */     // GIR_Coverage, 62328,
     /* 1109734 */     GIR_EraseRootFromParent_Done,
     /* 1109735 */   // Label 16318: @1109735
     /* 1109735 */   GIM_Try, /*On fail goto*//*Label 16319*/ GIMT_Encode4(1109812), // Rule ID 62329 //
     /* 1109740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1109743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109779 */     // MIs[0] policy
     /* 1109779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109789 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1109792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109811 */     // GIR_Coverage, 62329,
     /* 1109811 */     GIR_EraseRootFromParent_Done,
     /* 1109812 */   // Label 16319: @1109812
     /* 1109812 */   GIM_Try, /*On fail goto*//*Label 16320*/ GIMT_Encode4(1109889), // Rule ID 62330 //
     /* 1109817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109856 */     // MIs[0] policy
     /* 1109856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1109869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109888 */     // GIR_Coverage, 62330,
     /* 1109888 */     GIR_EraseRootFromParent_Done,
     /* 1109889 */   // Label 16320: @1109889
     /* 1109889 */   GIM_Try, /*On fail goto*//*Label 16321*/ GIMT_Encode4(1109966), // Rule ID 62331 //
     /* 1109894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1109897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109933 */     // MIs[0] policy
     /* 1109933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109943 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11542:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1109946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109965 */     // GIR_Coverage, 62331,
     /* 1109965 */     GIR_EraseRootFromParent_Done,
     /* 1109966 */   // Label 16321: @1109966
     /* 1109966 */   GIM_Try, /*On fail goto*//*Label 16322*/ GIMT_Encode4(1110043), // Rule ID 62332 //
     /* 1109971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1109982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1109985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1109988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1109991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110010 */     // MIs[0] policy
     /* 1110010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110042 */     // GIR_Coverage, 62332,
     /* 1110042 */     GIR_EraseRootFromParent_Done,
     /* 1110043 */   // Label 16322: @1110043
     /* 1110043 */   GIM_Try, /*On fail goto*//*Label 16323*/ GIMT_Encode4(1110120), // Rule ID 62333 //
     /* 1110048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1110068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110087 */     // MIs[0] policy
     /* 1110087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110097 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11542:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110119 */     // GIR_Coverage, 62333,
     /* 1110119 */     GIR_EraseRootFromParent_Done,
     /* 1110120 */   // Label 16323: @1110120
     /* 1110120 */   GIM_Try, /*On fail goto*//*Label 16324*/ GIMT_Encode4(1110197), // Rule ID 62334 //
     /* 1110125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110164 */     // MIs[0] policy
     /* 1110164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110196 */     // GIR_Coverage, 62334,
     /* 1110196 */     GIR_EraseRootFromParent_Done,
     /* 1110197 */   // Label 16324: @1110197
     /* 1110197 */   GIM_Try, /*On fail goto*//*Label 16325*/ GIMT_Encode4(1110274), // Rule ID 62335 //
     /* 1110202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1110213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1110216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1110219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1110222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110241 */     // MIs[0] policy
     /* 1110241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110251 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110273 */     // GIR_Coverage, 62335,
     /* 1110273 */     GIR_EraseRootFromParent_Done,
     /* 1110274 */   // Label 16325: @1110274
     /* 1110274 */   GIM_Try, /*On fail goto*//*Label 16326*/ GIMT_Encode4(1110351), // Rule ID 62336 //
     /* 1110279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110318 */     // MIs[0] policy
     /* 1110318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110350 */     // GIR_Coverage, 62336,
     /* 1110350 */     GIR_EraseRootFromParent_Done,
     /* 1110351 */   // Label 16326: @1110351
     /* 1110351 */   GIM_Try, /*On fail goto*//*Label 16327*/ GIMT_Encode4(1110428), // Rule ID 62337 //
     /* 1110356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1110367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1110370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1110373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1110376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110395 */     // MIs[0] policy
     /* 1110395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110405 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110427 */     // GIR_Coverage, 62337,
     /* 1110427 */     GIR_EraseRootFromParent_Done,
     /* 1110428 */   // Label 16327: @1110428
     /* 1110428 */   GIM_Try, /*On fail goto*//*Label 16328*/ GIMT_Encode4(1110505), // Rule ID 62338 //
     /* 1110433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110472 */     // MIs[0] policy
     /* 1110472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110504 */     // GIR_Coverage, 62338,
     /* 1110504 */     GIR_EraseRootFromParent_Done,
     /* 1110505 */   // Label 16328: @1110505
     /* 1110505 */   GIM_Try, /*On fail goto*//*Label 16329*/ GIMT_Encode4(1110582), // Rule ID 62339 //
     /* 1110510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110549 */     // MIs[0] policy
     /* 1110549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110581 */     // GIR_Coverage, 62339,
     /* 1110581 */     GIR_EraseRootFromParent_Done,
     /* 1110582 */   // Label 16329: @1110582
     /* 1110582 */   GIM_Try, /*On fail goto*//*Label 16330*/ GIMT_Encode4(1110659), // Rule ID 62340 //
     /* 1110587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1110607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110626 */     // MIs[0] policy
     /* 1110626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110658 */     // GIR_Coverage, 62340,
     /* 1110658 */     GIR_EraseRootFromParent_Done,
     /* 1110659 */   // Label 16330: @1110659
     /* 1110659 */   GIM_Try, /*On fail goto*//*Label 16331*/ GIMT_Encode4(1110736), // Rule ID 62341 //
     /* 1110664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1110684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110703 */     // MIs[0] policy
     /* 1110703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110713 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11542:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110735 */     // GIR_Coverage, 62341,
     /* 1110735 */     GIR_EraseRootFromParent_Done,
     /* 1110736 */   // Label 16331: @1110736
     /* 1110736 */   GIM_Try, /*On fail goto*//*Label 16332*/ GIMT_Encode4(1110813), // Rule ID 62342 //
     /* 1110741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1110761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110780 */     // MIs[0] policy
     /* 1110780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110790 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110812 */     // GIR_Coverage, 62342,
     /* 1110812 */     GIR_EraseRootFromParent_Done,
     /* 1110813 */   // Label 16332: @1110813
     /* 1110813 */   GIM_Try, /*On fail goto*//*Label 16333*/ GIMT_Encode4(1110890), // Rule ID 62343 //
     /* 1110818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1110838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110857 */     // MIs[0] policy
     /* 1110857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11542:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110889 */     // GIR_Coverage, 62343,
     /* 1110889 */     GIR_EraseRootFromParent_Done,
     /* 1110890 */   // Label 16333: @1110890
     /* 1110890 */   GIM_Try, /*On fail goto*//*Label 16334*/ GIMT_Encode4(1110967), // Rule ID 62344 //
     /* 1110895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1110912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1110915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110934 */     // MIs[0] policy
     /* 1110934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110944 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110966 */     // GIR_Coverage, 62344,
     /* 1110966 */     GIR_EraseRootFromParent_Done,
     /* 1110967 */   // Label 16334: @1110967
     /* 1110967 */   GIM_Try, /*On fail goto*//*Label 16335*/ GIMT_Encode4(1111044), // Rule ID 62345 //
     /* 1110972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1110989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1110992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111011 */     // MIs[0] policy
     /* 1111011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111021 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11542:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111043 */     // GIR_Coverage, 62345,
     /* 1111043 */     GIR_EraseRootFromParent_Done,
     /* 1111044 */   // Label 16335: @1111044
     /* 1111044 */   GIM_Try, /*On fail goto*//*Label 16336*/ GIMT_Encode4(1111121), // Rule ID 62346 //
     /* 1111049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111088 */     // MIs[0] policy
     /* 1111088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111098 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111120 */     // GIR_Coverage, 62346,
     /* 1111120 */     GIR_EraseRootFromParent_Done,
     /* 1111121 */   // Label 16336: @1111121
     /* 1111121 */   GIM_Try, /*On fail goto*//*Label 16337*/ GIMT_Encode4(1111198), // Rule ID 62347 //
     /* 1111126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111165 */     // MIs[0] policy
     /* 1111165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111175 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1111178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111197 */     // GIR_Coverage, 62347,
     /* 1111197 */     GIR_EraseRootFromParent_Done,
     /* 1111198 */   // Label 16337: @1111198
     /* 1111198 */   GIM_Try, /*On fail goto*//*Label 16338*/ GIMT_Encode4(1111275), // Rule ID 62348 //
     /* 1111203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111242 */     // MIs[0] policy
     /* 1111242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111274 */     // GIR_Coverage, 62348,
     /* 1111274 */     GIR_EraseRootFromParent_Done,
     /* 1111275 */   // Label 16338: @1111275
     /* 1111275 */   GIM_Try, /*On fail goto*//*Label 16339*/ GIMT_Encode4(1111352), // Rule ID 62349 //
     /* 1111280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1111291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1111294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1111297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1111300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111319 */     // MIs[0] policy
     /* 1111319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111329 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11543:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111351 */     // GIR_Coverage, 62349,
     /* 1111351 */     GIR_EraseRootFromParent_Done,
     /* 1111352 */   // Label 16339: @1111352
     /* 1111352 */   GIM_Try, /*On fail goto*//*Label 16340*/ GIMT_Encode4(1111429), // Rule ID 62350 //
     /* 1111357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1111368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1111371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1111374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1111377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111396 */     // MIs[0] policy
     /* 1111396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111406 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111428 */     // GIR_Coverage, 62350,
     /* 1111428 */     GIR_EraseRootFromParent_Done,
     /* 1111429 */   // Label 16340: @1111429
     /* 1111429 */   GIM_Try, /*On fail goto*//*Label 16341*/ GIMT_Encode4(1111506), // Rule ID 62351 //
     /* 1111434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1111445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1111448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1111451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1111454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111473 */     // MIs[0] policy
     /* 1111473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111483 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11543:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1111486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111505 */     // GIR_Coverage, 62351,
     /* 1111505 */     GIR_EraseRootFromParent_Done,
     /* 1111506 */   // Label 16341: @1111506
     /* 1111506 */   GIM_Try, /*On fail goto*//*Label 16342*/ GIMT_Encode4(1111583), // Rule ID 62352 //
     /* 1111511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111550 */     // MIs[0] policy
     /* 1111550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111582 */     // GIR_Coverage, 62352,
     /* 1111582 */     GIR_EraseRootFromParent_Done,
     /* 1111583 */   // Label 16342: @1111583
     /* 1111583 */   GIM_Try, /*On fail goto*//*Label 16343*/ GIMT_Encode4(1111660), // Rule ID 62353 //
     /* 1111588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111627 */     // MIs[0] policy
     /* 1111627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111637 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111659 */     // GIR_Coverage, 62353,
     /* 1111659 */     GIR_EraseRootFromParent_Done,
     /* 1111660 */   // Label 16343: @1111660
     /* 1111660 */   GIM_Try, /*On fail goto*//*Label 16344*/ GIMT_Encode4(1111737), // Rule ID 62354 //
     /* 1111665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111704 */     // MIs[0] policy
     /* 1111704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111736 */     // GIR_Coverage, 62354,
     /* 1111736 */     GIR_EraseRootFromParent_Done,
     /* 1111737 */   // Label 16344: @1111737
     /* 1111737 */   GIM_Try, /*On fail goto*//*Label 16345*/ GIMT_Encode4(1111814), // Rule ID 62355 //
     /* 1111742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111781 */     // MIs[0] policy
     /* 1111781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111791 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111813 */     // GIR_Coverage, 62355,
     /* 1111813 */     GIR_EraseRootFromParent_Done,
     /* 1111814 */   // Label 16345: @1111814
     /* 1111814 */   GIM_Try, /*On fail goto*//*Label 16346*/ GIMT_Encode4(1111891), // Rule ID 62356 //
     /* 1111819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111858 */     // MIs[0] policy
     /* 1111858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111868 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111890 */     // GIR_Coverage, 62356,
     /* 1111890 */     GIR_EraseRootFromParent_Done,
     /* 1111891 */   // Label 16346: @1111891
     /* 1111891 */   GIM_Try, /*On fail goto*//*Label 16347*/ GIMT_Encode4(1111968), // Rule ID 62357 //
     /* 1111896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111935 */     // MIs[0] policy
     /* 1111935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111945 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111967 */     // GIR_Coverage, 62357,
     /* 1111967 */     GIR_EraseRootFromParent_Done,
     /* 1111968 */   // Label 16347: @1111968
     /* 1111968 */   GIM_Try, /*On fail goto*//*Label 16348*/ GIMT_Encode4(1112045), // Rule ID 62358 //
     /* 1111973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1111990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1111993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112012 */     // MIs[0] policy
     /* 1112012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112022 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112044 */     // GIR_Coverage, 62358,
     /* 1112044 */     GIR_EraseRootFromParent_Done,
     /* 1112045 */   // Label 16348: @1112045
     /* 1112045 */   GIM_Try, /*On fail goto*//*Label 16349*/ GIMT_Encode4(1112122), // Rule ID 62359 //
     /* 1112050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1112070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112089 */     // MIs[0] policy
     /* 1112089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112099 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11543:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1112102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112121 */     // GIR_Coverage, 62359,
     /* 1112121 */     GIR_EraseRootFromParent_Done,
     /* 1112122 */   // Label 16349: @1112122
     /* 1112122 */   GIM_Try, /*On fail goto*//*Label 16350*/ GIMT_Encode4(1112199), // Rule ID 62360 //
     /* 1112127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1112147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112166 */     // MIs[0] policy
     /* 1112166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112176 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112198 */     // GIR_Coverage, 62360,
     /* 1112198 */     GIR_EraseRootFromParent_Done,
     /* 1112199 */   // Label 16350: @1112199
     /* 1112199 */   GIM_Try, /*On fail goto*//*Label 16351*/ GIMT_Encode4(1112276), // Rule ID 62361 //
     /* 1112204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1112215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1112218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1112221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1112224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112243 */     // MIs[0] policy
     /* 1112243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112253 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11543:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1112256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112275 */     // GIR_Coverage, 62361,
     /* 1112275 */     GIR_EraseRootFromParent_Done,
     /* 1112276 */   // Label 16351: @1112276
     /* 1112276 */   GIM_Try, /*On fail goto*//*Label 16352*/ GIMT_Encode4(1112353), // Rule ID 62362 //
     /* 1112281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1112301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112320 */     // MIs[0] policy
     /* 1112320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112330 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112352 */     // GIR_Coverage, 62362,
     /* 1112352 */     GIR_EraseRootFromParent_Done,
     /* 1112353 */   // Label 16352: @1112353
     /* 1112353 */   GIM_Try, /*On fail goto*//*Label 16353*/ GIMT_Encode4(1112430), // Rule ID 62363 //
     /* 1112358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1112366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1112369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1112372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1112375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1112378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112397 */     // MIs[0] policy
     /* 1112397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112407 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11543:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1112410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112429 */     // GIR_Coverage, 62363,
     /* 1112429 */     GIR_EraseRootFromParent_Done,
     /* 1112430 */   // Label 16353: @1112430
     /* 1112430 */   GIM_Try, /*On fail goto*//*Label 16354*/ GIMT_Encode4(1112507), // Rule ID 62364 //
     /* 1112435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112474 */     // MIs[0] policy
     /* 1112474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112506 */     // GIR_Coverage, 62364,
     /* 1112506 */     GIR_EraseRootFromParent_Done,
     /* 1112507 */   // Label 16354: @1112507
     /* 1112507 */   GIM_Try, /*On fail goto*//*Label 16355*/ GIMT_Encode4(1112584), // Rule ID 62365 //
     /* 1112512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112551 */     // MIs[0] policy
     /* 1112551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112561 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112583 */     // GIR_Coverage, 62365,
     /* 1112583 */     GIR_EraseRootFromParent_Done,
     /* 1112584 */   // Label 16355: @1112584
     /* 1112584 */   GIM_Try, /*On fail goto*//*Label 16356*/ GIMT_Encode4(1112661), // Rule ID 62366 //
     /* 1112589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112628 */     // MIs[0] policy
     /* 1112628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1112641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112660 */     // GIR_Coverage, 62366,
     /* 1112660 */     GIR_EraseRootFromParent_Done,
     /* 1112661 */   // Label 16356: @1112661
     /* 1112661 */   GIM_Try, /*On fail goto*//*Label 16357*/ GIMT_Encode4(1112738), // Rule ID 62367 //
     /* 1112666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112705 */     // MIs[0] policy
     /* 1112705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11544:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1112718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112737 */     // GIR_Coverage, 62367,
     /* 1112737 */     GIR_EraseRootFromParent_Done,
     /* 1112738 */   // Label 16357: @1112738
     /* 1112738 */   GIM_Try, /*On fail goto*//*Label 16358*/ GIMT_Encode4(1112815), // Rule ID 62368 //
     /* 1112743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1112754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1112757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1112760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1112763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112782 */     // MIs[0] policy
     /* 1112782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1112795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112814 */     // GIR_Coverage, 62368,
     /* 1112814 */     GIR_EraseRootFromParent_Done,
     /* 1112815 */   // Label 16358: @1112815
     /* 1112815 */   GIM_Try, /*On fail goto*//*Label 16359*/ GIMT_Encode4(1112892), // Rule ID 62369 //
     /* 1112820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1112831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1112834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1112837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1112840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112859 */     // MIs[0] policy
     /* 1112859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11544:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1112872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112891 */     // GIR_Coverage, 62369,
     /* 1112891 */     GIR_EraseRootFromParent_Done,
     /* 1112892 */   // Label 16359: @1112892
     /* 1112892 */   GIM_Try, /*On fail goto*//*Label 16360*/ GIMT_Encode4(1112969), // Rule ID 62370 //
     /* 1112897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112936 */     // MIs[0] policy
     /* 1112936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1112949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112968 */     // GIR_Coverage, 62370,
     /* 1112968 */     GIR_EraseRootFromParent_Done,
     /* 1112969 */   // Label 16360: @1112969
     /* 1112969 */   GIM_Try, /*On fail goto*//*Label 16361*/ GIMT_Encode4(1113046), // Rule ID 62371 //
     /* 1112974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113013 */     // MIs[0] policy
     /* 1113013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1113026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113045 */     // GIR_Coverage, 62371,
     /* 1113045 */     GIR_EraseRootFromParent_Done,
     /* 1113046 */   // Label 16361: @1113046
     /* 1113046 */   GIM_Try, /*On fail goto*//*Label 16362*/ GIMT_Encode4(1113123), // Rule ID 62372 //
     /* 1113051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113090 */     // MIs[0] policy
     /* 1113090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113122 */     // GIR_Coverage, 62372,
     /* 1113122 */     GIR_EraseRootFromParent_Done,
     /* 1113123 */   // Label 16362: @1113123
     /* 1113123 */   GIM_Try, /*On fail goto*//*Label 16363*/ GIMT_Encode4(1113200), // Rule ID 62373 //
     /* 1113128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1113145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1113148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113167 */     // MIs[0] policy
     /* 1113167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1113180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113199 */     // GIR_Coverage, 62373,
     /* 1113199 */     GIR_EraseRootFromParent_Done,
     /* 1113200 */   // Label 16363: @1113200
     /* 1113200 */   GIM_Try, /*On fail goto*//*Label 16364*/ GIMT_Encode4(1113277), // Rule ID 62374 //
     /* 1113205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113244 */     // MIs[0] policy
     /* 1113244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113276 */     // GIR_Coverage, 62374,
     /* 1113276 */     GIR_EraseRootFromParent_Done,
     /* 1113277 */   // Label 16364: @1113277
     /* 1113277 */   GIM_Try, /*On fail goto*//*Label 16365*/ GIMT_Encode4(1113354), // Rule ID 62375 //
     /* 1113282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1113299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1113302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113321 */     // MIs[0] policy
     /* 1113321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113331 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1113334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113353 */     // GIR_Coverage, 62375,
     /* 1113353 */     GIR_EraseRootFromParent_Done,
     /* 1113354 */   // Label 16365: @1113354
     /* 1113354 */   GIM_Try, /*On fail goto*//*Label 16366*/ GIMT_Encode4(1113431), // Rule ID 62376 //
     /* 1113359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1113370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1113373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1113376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1113379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113398 */     // MIs[0] policy
     /* 1113398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1113411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113430 */     // GIR_Coverage, 62376,
     /* 1113430 */     GIR_EraseRootFromParent_Done,
     /* 1113431 */   // Label 16366: @1113431
     /* 1113431 */   GIM_Try, /*On fail goto*//*Label 16367*/ GIMT_Encode4(1113508), // Rule ID 62377 //
     /* 1113436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1113447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1113450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1113453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1113456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113475 */     // MIs[0] policy
     /* 1113475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113485 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11544:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1113488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113507 */     // GIR_Coverage, 62377,
     /* 1113507 */     GIR_EraseRootFromParent_Done,
     /* 1113508 */   // Label 16367: @1113508
     /* 1113508 */   GIM_Try, /*On fail goto*//*Label 16368*/ GIMT_Encode4(1113585), // Rule ID 62378 //
     /* 1113513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1113524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1113527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1113530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1113533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113552 */     // MIs[0] policy
     /* 1113552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113562 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1113565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113584 */     // GIR_Coverage, 62378,
     /* 1113584 */     GIR_EraseRootFromParent_Done,
     /* 1113585 */   // Label 16368: @1113585
     /* 1113585 */   GIM_Try, /*On fail goto*//*Label 16369*/ GIMT_Encode4(1113662), // Rule ID 62379 //
     /* 1113590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1113601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1113604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1113607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1113610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113629 */     // MIs[0] policy
     /* 1113629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113639 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11544:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1113642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113661 */     // GIR_Coverage, 62379,
     /* 1113661 */     GIR_EraseRootFromParent_Done,
     /* 1113662 */   // Label 16369: @1113662
     /* 1113662 */   GIM_Try, /*On fail goto*//*Label 16370*/ GIMT_Encode4(1113739), // Rule ID 62380 //
     /* 1113667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1113678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1113681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1113684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1113687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113706 */     // MIs[0] policy
     /* 1113706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113716 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1113719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113738 */     // GIR_Coverage, 62380,
     /* 1113738 */     GIR_EraseRootFromParent_Done,
     /* 1113739 */   // Label 16370: @1113739
     /* 1113739 */   GIM_Try, /*On fail goto*//*Label 16371*/ GIMT_Encode4(1113816), // Rule ID 62381 //
     /* 1113744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1113755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1113758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1113761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1113764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113783 */     // MIs[0] policy
     /* 1113783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113793 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11544:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1113796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113815 */     // GIR_Coverage, 62381,
     /* 1113815 */     GIR_EraseRootFromParent_Done,
     /* 1113816 */   // Label 16371: @1113816
     /* 1113816 */   GIM_Try, /*On fail goto*//*Label 16372*/ GIMT_Encode4(1113893), // Rule ID 62602 //
     /* 1113821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1113824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1113838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1113841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113860 */     // MIs[0] policy
     /* 1113860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1113873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113892 */     // GIR_Coverage, 62602,
     /* 1113892 */     GIR_EraseRootFromParent_Done,
     /* 1113893 */   // Label 16372: @1113893
     /* 1113893 */   GIM_Try, /*On fail goto*//*Label 16373*/ GIMT_Encode4(1113970), // Rule ID 62603 //
     /* 1113898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1113901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1113915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1113918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113937 */     // MIs[0] policy
     /* 1113937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113947 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1113950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113969 */     // GIR_Coverage, 62603,
     /* 1113969 */     GIR_EraseRootFromParent_Done,
     /* 1113970 */   // Label 16373: @1113970
     /* 1113970 */   GIM_Try, /*On fail goto*//*Label 16374*/ GIMT_Encode4(1114047), // Rule ID 62606 //
     /* 1113975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1113978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1113992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1113995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114014 */     // MIs[0] policy
     /* 1114014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1114027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114046 */     // GIR_Coverage, 62606,
     /* 1114046 */     GIR_EraseRootFromParent_Done,
     /* 1114047 */   // Label 16374: @1114047
     /* 1114047 */   GIM_Try, /*On fail goto*//*Label 16375*/ GIMT_Encode4(1114124), // Rule ID 62607 //
     /* 1114052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1114069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114091 */     // MIs[0] policy
     /* 1114091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114101 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1114104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114123 */     // GIR_Coverage, 62607,
     /* 1114123 */     GIR_EraseRootFromParent_Done,
     /* 1114124 */   // Label 16375: @1114124
     /* 1114124 */   GIM_Try, /*On fail goto*//*Label 16376*/ GIMT_Encode4(1114201), // Rule ID 62610 //
     /* 1114129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1114146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114168 */     // MIs[0] policy
     /* 1114168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1114181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114200 */     // GIR_Coverage, 62610,
     /* 1114200 */     GIR_EraseRootFromParent_Done,
     /* 1114201 */   // Label 16376: @1114201
     /* 1114201 */   GIM_Try, /*On fail goto*//*Label 16377*/ GIMT_Encode4(1114278), // Rule ID 62611 //
     /* 1114206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1114223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114245 */     // MIs[0] policy
     /* 1114245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1114258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114277 */     // GIR_Coverage, 62611,
     /* 1114277 */     GIR_EraseRootFromParent_Done,
     /* 1114278 */   // Label 16377: @1114278
     /* 1114278 */   GIM_Try, /*On fail goto*//*Label 16378*/ GIMT_Encode4(1114355), // Rule ID 62614 //
     /* 1114283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1114300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114322 */     // MIs[0] policy
     /* 1114322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114332 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1114335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114354 */     // GIR_Coverage, 62614,
     /* 1114354 */     GIR_EraseRootFromParent_Done,
     /* 1114355 */   // Label 16378: @1114355
     /* 1114355 */   GIM_Try, /*On fail goto*//*Label 16379*/ GIMT_Encode4(1114432), // Rule ID 62615 //
     /* 1114360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1114377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114399 */     // MIs[0] policy
     /* 1114399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114409 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1114412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114431 */     // GIR_Coverage, 62615,
     /* 1114431 */     GIR_EraseRootFromParent_Done,
     /* 1114432 */   // Label 16379: @1114432
     /* 1114432 */   GIM_Try, /*On fail goto*//*Label 16380*/ GIMT_Encode4(1114509), // Rule ID 62618 //
     /* 1114437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1114454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1114457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114476 */     // MIs[0] policy
     /* 1114476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114486 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1114489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114508 */     // GIR_Coverage, 62618,
     /* 1114508 */     GIR_EraseRootFromParent_Done,
     /* 1114509 */   // Label 16380: @1114509
     /* 1114509 */   GIM_Try, /*On fail goto*//*Label 16381*/ GIMT_Encode4(1114586), // Rule ID 62619 //
     /* 1114514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1114531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1114534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114553 */     // MIs[0] policy
     /* 1114553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114563 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1114566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114585 */     // GIR_Coverage, 62619,
     /* 1114585 */     GIR_EraseRootFromParent_Done,
     /* 1114586 */   // Label 16381: @1114586
     /* 1114586 */   GIM_Try, /*On fail goto*//*Label 16382*/ GIMT_Encode4(1114663), // Rule ID 62622 //
     /* 1114591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114630 */     // MIs[0] policy
     /* 1114630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1114643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114662 */     // GIR_Coverage, 62622,
     /* 1114662 */     GIR_EraseRootFromParent_Done,
     /* 1114663 */   // Label 16382: @1114663
     /* 1114663 */   GIM_Try, /*On fail goto*//*Label 16383*/ GIMT_Encode4(1114740), // Rule ID 62623 //
     /* 1114668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114707 */     // MIs[0] policy
     /* 1114707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114717 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1114720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114739 */     // GIR_Coverage, 62623,
     /* 1114739 */     GIR_EraseRootFromParent_Done,
     /* 1114740 */   // Label 16383: @1114740
     /* 1114740 */   GIM_Try, /*On fail goto*//*Label 16384*/ GIMT_Encode4(1114817), // Rule ID 62626 //
     /* 1114745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114784 */     // MIs[0] policy
     /* 1114784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114794 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1114797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114816 */     // GIR_Coverage, 62626,
     /* 1114816 */     GIR_EraseRootFromParent_Done,
     /* 1114817 */   // Label 16384: @1114817
     /* 1114817 */   GIM_Try, /*On fail goto*//*Label 16385*/ GIMT_Encode4(1114894), // Rule ID 62627 //
     /* 1114822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114861 */     // MIs[0] policy
     /* 1114861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1114874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114893 */     // GIR_Coverage, 62627,
     /* 1114893 */     GIR_EraseRootFromParent_Done,
     /* 1114894 */   // Label 16385: @1114894
     /* 1114894 */   GIM_Try, /*On fail goto*//*Label 16386*/ GIMT_Encode4(1114971), // Rule ID 62630 //
     /* 1114899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114938 */     // MIs[0] policy
     /* 1114938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1114951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114970 */     // GIR_Coverage, 62630,
     /* 1114970 */     GIR_EraseRootFromParent_Done,
     /* 1114971 */   // Label 16386: @1114971
     /* 1114971 */   GIM_Try, /*On fail goto*//*Label 16387*/ GIMT_Encode4(1115048), // Rule ID 62631 //
     /* 1114976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115015 */     // MIs[0] policy
     /* 1115015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1115028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115047 */     // GIR_Coverage, 62631,
     /* 1115047 */     GIR_EraseRootFromParent_Done,
     /* 1115048 */   // Label 16387: @1115048
     /* 1115048 */   GIM_Try, /*On fail goto*//*Label 16388*/ GIMT_Encode4(1115125), // Rule ID 62634 //
     /* 1115053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115092 */     // MIs[0] policy
     /* 1115092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1115105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115124 */     // GIR_Coverage, 62634,
     /* 1115124 */     GIR_EraseRootFromParent_Done,
     /* 1115125 */   // Label 16388: @1115125
     /* 1115125 */   GIM_Try, /*On fail goto*//*Label 16389*/ GIMT_Encode4(1115202), // Rule ID 62635 //
     /* 1115130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115169 */     // MIs[0] policy
     /* 1115169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115179 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1115182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115201 */     // GIR_Coverage, 62635,
     /* 1115201 */     GIR_EraseRootFromParent_Done,
     /* 1115202 */   // Label 16389: @1115202
     /* 1115202 */   GIM_Try, /*On fail goto*//*Label 16390*/ GIMT_Encode4(1115279), // Rule ID 62638 //
     /* 1115207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115246 */     // MIs[0] policy
     /* 1115246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115256 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1115259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115278 */     // GIR_Coverage, 62638,
     /* 1115278 */     GIR_EraseRootFromParent_Done,
     /* 1115279 */   // Label 16390: @1115279
     /* 1115279 */   GIM_Try, /*On fail goto*//*Label 16391*/ GIMT_Encode4(1115356), // Rule ID 62639 //
     /* 1115284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1115292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115323 */     // MIs[0] policy
     /* 1115323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115333 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1115336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115355 */     // GIR_Coverage, 62639,
     /* 1115355 */     GIR_EraseRootFromParent_Done,
     /* 1115356 */   // Label 16391: @1115356
     /* 1115356 */   GIM_Try, /*On fail goto*//*Label 16392*/ GIMT_Encode4(1115433), // Rule ID 62642 //
     /* 1115361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1115378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115400 */     // MIs[0] policy
     /* 1115400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115410 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1115413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115432 */     // GIR_Coverage, 62642,
     /* 1115432 */     GIR_EraseRootFromParent_Done,
     /* 1115433 */   // Label 16392: @1115433
     /* 1115433 */   GIM_Try, /*On fail goto*//*Label 16393*/ GIMT_Encode4(1115510), // Rule ID 62643 //
     /* 1115438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1115455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115477 */     // MIs[0] policy
     /* 1115477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115487 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1115490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115509 */     // GIR_Coverage, 62643,
     /* 1115509 */     GIR_EraseRootFromParent_Done,
     /* 1115510 */   // Label 16393: @1115510
     /* 1115510 */   GIM_Try, /*On fail goto*//*Label 16394*/ GIMT_Encode4(1115587), // Rule ID 62646 //
     /* 1115515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1115532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115554 */     // MIs[0] policy
     /* 1115554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1115567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115586 */     // GIR_Coverage, 62646,
     /* 1115586 */     GIR_EraseRootFromParent_Done,
     /* 1115587 */   // Label 16394: @1115587
     /* 1115587 */   GIM_Try, /*On fail goto*//*Label 16395*/ GIMT_Encode4(1115664), // Rule ID 62647 //
     /* 1115592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1115609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115631 */     // MIs[0] policy
     /* 1115631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115641 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1115644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115663 */     // GIR_Coverage, 62647,
     /* 1115663 */     GIR_EraseRootFromParent_Done,
     /* 1115664 */   // Label 16395: @1115664
     /* 1115664 */   GIM_Try, /*On fail goto*//*Label 16396*/ GIMT_Encode4(1115741), // Rule ID 62650 //
     /* 1115669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1115686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115708 */     // MIs[0] policy
     /* 1115708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1115721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115740 */     // GIR_Coverage, 62650,
     /* 1115740 */     GIR_EraseRootFromParent_Done,
     /* 1115741 */   // Label 16396: @1115741
     /* 1115741 */   GIM_Try, /*On fail goto*//*Label 16397*/ GIMT_Encode4(1115818), // Rule ID 62651 //
     /* 1115746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1115763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115785 */     // MIs[0] policy
     /* 1115785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1115798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115817 */     // GIR_Coverage, 62651,
     /* 1115817 */     GIR_EraseRootFromParent_Done,
     /* 1115818 */   // Label 16397: @1115818
     /* 1115818 */   GIM_Try, /*On fail goto*//*Label 16398*/ GIMT_Encode4(1115895), // Rule ID 62654 //
     /* 1115823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1115840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115862 */     // MIs[0] policy
     /* 1115862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1115875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115894 */     // GIR_Coverage, 62654,
     /* 1115894 */     GIR_EraseRootFromParent_Done,
     /* 1115895 */   // Label 16398: @1115895
     /* 1115895 */   GIM_Try, /*On fail goto*//*Label 16399*/ GIMT_Encode4(1115972), // Rule ID 62655 //
     /* 1115900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1115917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115939 */     // MIs[0] policy
     /* 1115939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115949 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1115952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115971 */     // GIR_Coverage, 62655,
     /* 1115971 */     GIR_EraseRootFromParent_Done,
     /* 1115972 */   // Label 16399: @1115972
     /* 1115972 */   GIM_Try, /*On fail goto*//*Label 16400*/ GIMT_Encode4(1116049), // Rule ID 62658 //
     /* 1115977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1115994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116016 */     // MIs[0] policy
     /* 1116016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116026 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1116029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116048 */     // GIR_Coverage, 62658,
     /* 1116048 */     GIR_EraseRootFromParent_Done,
     /* 1116049 */   // Label 16400: @1116049
     /* 1116049 */   GIM_Try, /*On fail goto*//*Label 16401*/ GIMT_Encode4(1116126), // Rule ID 62659 //
     /* 1116054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1116071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116093 */     // MIs[0] policy
     /* 1116093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116103 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1116106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116125 */     // GIR_Coverage, 62659,
     /* 1116125 */     GIR_EraseRootFromParent_Done,
     /* 1116126 */   // Label 16401: @1116126
     /* 1116126 */   GIM_Try, /*On fail goto*//*Label 16402*/ GIMT_Encode4(1116203), // Rule ID 62662 //
     /* 1116131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116170 */     // MIs[0] policy
     /* 1116170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116180 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1116183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116202 */     // GIR_Coverage, 62662,
     /* 1116202 */     GIR_EraseRootFromParent_Done,
     /* 1116203 */   // Label 16402: @1116203
     /* 1116203 */   GIM_Try, /*On fail goto*//*Label 16403*/ GIMT_Encode4(1116280), // Rule ID 62663 //
     /* 1116208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116247 */     // MIs[0] policy
     /* 1116247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116257 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1116260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116279 */     // GIR_Coverage, 62663,
     /* 1116279 */     GIR_EraseRootFromParent_Done,
     /* 1116280 */   // Label 16403: @1116280
     /* 1116280 */   GIM_Try, /*On fail goto*//*Label 16404*/ GIMT_Encode4(1116357), // Rule ID 62666 //
     /* 1116285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116324 */     // MIs[0] policy
     /* 1116324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1116337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116356 */     // GIR_Coverage, 62666,
     /* 1116356 */     GIR_EraseRootFromParent_Done,
     /* 1116357 */   // Label 16404: @1116357
     /* 1116357 */   GIM_Try, /*On fail goto*//*Label 16405*/ GIMT_Encode4(1116434), // Rule ID 62667 //
     /* 1116362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116401 */     // MIs[0] policy
     /* 1116401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116411 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1116414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116433 */     // GIR_Coverage, 62667,
     /* 1116433 */     GIR_EraseRootFromParent_Done,
     /* 1116434 */   // Label 16405: @1116434
     /* 1116434 */   GIM_Try, /*On fail goto*//*Label 16406*/ GIMT_Encode4(1116511), // Rule ID 62670 //
     /* 1116439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116478 */     // MIs[0] policy
     /* 1116478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116488 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1116491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116510 */     // GIR_Coverage, 62670,
     /* 1116510 */     GIR_EraseRootFromParent_Done,
     /* 1116511 */   // Label 16406: @1116511
     /* 1116511 */   GIM_Try, /*On fail goto*//*Label 16407*/ GIMT_Encode4(1116588), // Rule ID 62671 //
     /* 1116516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116555 */     // MIs[0] policy
     /* 1116555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116565 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1116568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116587 */     // GIR_Coverage, 62671,
     /* 1116587 */     GIR_EraseRootFromParent_Done,
     /* 1116588 */   // Label 16407: @1116588
     /* 1116588 */   GIM_Try, /*On fail goto*//*Label 16408*/ GIMT_Encode4(1116665), // Rule ID 62674 //
     /* 1116593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116632 */     // MIs[0] policy
     /* 1116632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116642 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1116645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116664 */     // GIR_Coverage, 62674,
     /* 1116664 */     GIR_EraseRootFromParent_Done,
     /* 1116665 */   // Label 16408: @1116665
     /* 1116665 */   GIM_Try, /*On fail goto*//*Label 16409*/ GIMT_Encode4(1116742), // Rule ID 62675 //
     /* 1116670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116709 */     // MIs[0] policy
     /* 1116709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116719 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1116722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116741 */     // GIR_Coverage, 62675,
     /* 1116741 */     GIR_EraseRootFromParent_Done,
     /* 1116742 */   // Label 16409: @1116742
     /* 1116742 */   GIM_Try, /*On fail goto*//*Label 16410*/ GIMT_Encode4(1116819), // Rule ID 62678 //
     /* 1116747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116786 */     // MIs[0] policy
     /* 1116786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1116799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116818 */     // GIR_Coverage, 62678,
     /* 1116818 */     GIR_EraseRootFromParent_Done,
     /* 1116819 */   // Label 16410: @1116819
     /* 1116819 */   GIM_Try, /*On fail goto*//*Label 16411*/ GIMT_Encode4(1116896), // Rule ID 62679 //
     /* 1116824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116863 */     // MIs[0] policy
     /* 1116863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116873 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1116876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116895 */     // GIR_Coverage, 62679,
     /* 1116895 */     GIR_EraseRootFromParent_Done,
     /* 1116896 */   // Label 16411: @1116896
     /* 1116896 */   GIM_Try, /*On fail goto*//*Label 16412*/ GIMT_Encode4(1116973), // Rule ID 62682 //
     /* 1116901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1116918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116940 */     // MIs[0] policy
     /* 1116940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116950 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1116953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116972 */     // GIR_Coverage, 62682,
     /* 1116972 */     GIR_EraseRootFromParent_Done,
     /* 1116973 */   // Label 16412: @1116973
     /* 1116973 */   GIM_Try, /*On fail goto*//*Label 16413*/ GIMT_Encode4(1117050), // Rule ID 62683 //
     /* 1116978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1116995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117017 */     // MIs[0] policy
     /* 1117017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117027 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1117030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117049 */     // GIR_Coverage, 62683,
     /* 1117049 */     GIR_EraseRootFromParent_Done,
     /* 1117050 */   // Label 16413: @1117050
     /* 1117050 */   GIM_Try, /*On fail goto*//*Label 16414*/ GIMT_Encode4(1117127), // Rule ID 62686 //
     /* 1117055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117094 */     // MIs[0] policy
     /* 1117094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1117107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117126 */     // GIR_Coverage, 62686,
     /* 1117126 */     GIR_EraseRootFromParent_Done,
     /* 1117127 */   // Label 16414: @1117127
     /* 1117127 */   GIM_Try, /*On fail goto*//*Label 16415*/ GIMT_Encode4(1117204), // Rule ID 62687 //
     /* 1117132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1117149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117171 */     // MIs[0] policy
     /* 1117171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117181 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1117184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117203 */     // GIR_Coverage, 62687,
     /* 1117203 */     GIR_EraseRootFromParent_Done,
     /* 1117204 */   // Label 16415: @1117204
     /* 1117204 */   GIM_Try, /*On fail goto*//*Label 16416*/ GIMT_Encode4(1117281), // Rule ID 62690 //
     /* 1117209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117248 */     // MIs[0] policy
     /* 1117248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1117261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117280 */     // GIR_Coverage, 62690,
     /* 1117280 */     GIR_EraseRootFromParent_Done,
     /* 1117281 */   // Label 16416: @1117281
     /* 1117281 */   GIM_Try, /*On fail goto*//*Label 16417*/ GIMT_Encode4(1117358), // Rule ID 62691 //
     /* 1117286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1117303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117325 */     // MIs[0] policy
     /* 1117325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117335 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1117338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117357 */     // GIR_Coverage, 62691,
     /* 1117357 */     GIR_EraseRootFromParent_Done,
     /* 1117358 */   // Label 16417: @1117358
     /* 1117358 */   GIM_Try, /*On fail goto*//*Label 16418*/ GIMT_Encode4(1117435), // Rule ID 62694 //
     /* 1117363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1117380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117402 */     // MIs[0] policy
     /* 1117402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1117415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117434 */     // GIR_Coverage, 62694,
     /* 1117434 */     GIR_EraseRootFromParent_Done,
     /* 1117435 */   // Label 16418: @1117435
     /* 1117435 */   GIM_Try, /*On fail goto*//*Label 16419*/ GIMT_Encode4(1117512), // Rule ID 62695 //
     /* 1117440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1117457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117479 */     // MIs[0] policy
     /* 1117479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117489 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1117492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117511 */     // GIR_Coverage, 62695,
     /* 1117511 */     GIR_EraseRootFromParent_Done,
     /* 1117512 */   // Label 16419: @1117512
     /* 1117512 */   GIM_Try, /*On fail goto*//*Label 16420*/ GIMT_Encode4(1117589), // Rule ID 62698 //
     /* 1117517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1117534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117556 */     // MIs[0] policy
     /* 1117556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1117569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117588 */     // GIR_Coverage, 62698,
     /* 1117588 */     GIR_EraseRootFromParent_Done,
     /* 1117589 */   // Label 16420: @1117589
     /* 1117589 */   GIM_Try, /*On fail goto*//*Label 16421*/ GIMT_Encode4(1117666), // Rule ID 62699 //
     /* 1117594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1117611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117633 */     // MIs[0] policy
     /* 1117633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117643 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1117646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117665 */     // GIR_Coverage, 62699,
     /* 1117665 */     GIR_EraseRootFromParent_Done,
     /* 1117666 */   // Label 16421: @1117666
     /* 1117666 */   GIM_Try, /*On fail goto*//*Label 16422*/ GIMT_Encode4(1117743), // Rule ID 62702 //
     /* 1117671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117710 */     // MIs[0] policy
     /* 1117710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117720 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1117723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117742 */     // GIR_Coverage, 62702,
     /* 1117742 */     GIR_EraseRootFromParent_Done,
     /* 1117743 */   // Label 16422: @1117743
     /* 1117743 */   GIM_Try, /*On fail goto*//*Label 16423*/ GIMT_Encode4(1117820), // Rule ID 62703 //
     /* 1117748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117787 */     // MIs[0] policy
     /* 1117787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117797 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1117800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117819 */     // GIR_Coverage, 62703,
     /* 1117819 */     GIR_EraseRootFromParent_Done,
     /* 1117820 */   // Label 16423: @1117820
     /* 1117820 */   GIM_Try, /*On fail goto*//*Label 16424*/ GIMT_Encode4(1117897), // Rule ID 62706 //
     /* 1117825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117864 */     // MIs[0] policy
     /* 1117864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117874 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1117877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117896 */     // GIR_Coverage, 62706,
     /* 1117896 */     GIR_EraseRootFromParent_Done,
     /* 1117897 */   // Label 16424: @1117897
     /* 1117897 */   GIM_Try, /*On fail goto*//*Label 16425*/ GIMT_Encode4(1117974), // Rule ID 62707 //
     /* 1117902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117941 */     // MIs[0] policy
     /* 1117941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117951 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1117954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117973 */     // GIR_Coverage, 62707,
     /* 1117973 */     GIR_EraseRootFromParent_Done,
     /* 1117974 */   // Label 16425: @1117974
     /* 1117974 */   GIM_Try, /*On fail goto*//*Label 16426*/ GIMT_Encode4(1118051), // Rule ID 62710 //
     /* 1117979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118018 */     // MIs[0] policy
     /* 1118018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1118031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118050 */     // GIR_Coverage, 62710,
     /* 1118050 */     GIR_EraseRootFromParent_Done,
     /* 1118051 */   // Label 16426: @1118051
     /* 1118051 */   GIM_Try, /*On fail goto*//*Label 16427*/ GIMT_Encode4(1118128), // Rule ID 62711 //
     /* 1118056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118095 */     // MIs[0] policy
     /* 1118095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1118108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118127 */     // GIR_Coverage, 62711,
     /* 1118127 */     GIR_EraseRootFromParent_Done,
     /* 1118128 */   // Label 16427: @1118128
     /* 1118128 */   GIM_Try, /*On fail goto*//*Label 16428*/ GIMT_Encode4(1118205), // Rule ID 62714 //
     /* 1118133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118172 */     // MIs[0] policy
     /* 1118172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118182 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1118185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118204 */     // GIR_Coverage, 62714,
     /* 1118204 */     GIR_EraseRootFromParent_Done,
     /* 1118205 */   // Label 16428: @1118205
     /* 1118205 */   GIM_Try, /*On fail goto*//*Label 16429*/ GIMT_Encode4(1118282), // Rule ID 62715 //
     /* 1118210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118249 */     // MIs[0] policy
     /* 1118249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118259 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1118262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118281 */     // GIR_Coverage, 62715,
     /* 1118281 */     GIR_EraseRootFromParent_Done,
     /* 1118282 */   // Label 16429: @1118282
     /* 1118282 */   GIM_Try, /*On fail goto*//*Label 16430*/ GIMT_Encode4(1118359), // Rule ID 62718 //
     /* 1118287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118326 */     // MIs[0] policy
     /* 1118326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118336 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1118339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118358 */     // GIR_Coverage, 62718,
     /* 1118358 */     GIR_EraseRootFromParent_Done,
     /* 1118359 */   // Label 16430: @1118359
     /* 1118359 */   GIM_Try, /*On fail goto*//*Label 16431*/ GIMT_Encode4(1118436), // Rule ID 62719 //
     /* 1118364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1118372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118403 */     // MIs[0] policy
     /* 1118403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118413 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1118416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118435 */     // GIR_Coverage, 62719,
     /* 1118435 */     GIR_EraseRootFromParent_Done,
     /* 1118436 */   // Label 16431: @1118436
     /* 1118436 */   GIM_Try, /*On fail goto*//*Label 16432*/ GIMT_Encode4(1118513), // Rule ID 62722 //
     /* 1118441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118480 */     // MIs[0] policy
     /* 1118480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1118493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118512 */     // GIR_Coverage, 62722,
     /* 1118512 */     GIR_EraseRootFromParent_Done,
     /* 1118513 */   // Label 16432: @1118513
     /* 1118513 */   GIM_Try, /*On fail goto*//*Label 16433*/ GIMT_Encode4(1118590), // Rule ID 62723 //
     /* 1118518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118557 */     // MIs[0] policy
     /* 1118557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118567 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1118570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118589 */     // GIR_Coverage, 62723,
     /* 1118589 */     GIR_EraseRootFromParent_Done,
     /* 1118590 */   // Label 16433: @1118590
     /* 1118590 */   GIM_Try, /*On fail goto*//*Label 16434*/ GIMT_Encode4(1118667), // Rule ID 62726 //
     /* 1118595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118634 */     // MIs[0] policy
     /* 1118634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1118647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118666 */     // GIR_Coverage, 62726,
     /* 1118666 */     GIR_EraseRootFromParent_Done,
     /* 1118667 */   // Label 16434: @1118667
     /* 1118667 */   GIM_Try, /*On fail goto*//*Label 16435*/ GIMT_Encode4(1118744), // Rule ID 62727 //
     /* 1118672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118711 */     // MIs[0] policy
     /* 1118711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118721 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1118724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118743 */     // GIR_Coverage, 62727,
     /* 1118743 */     GIR_EraseRootFromParent_Done,
     /* 1118744 */   // Label 16435: @1118744
     /* 1118744 */   GIM_Try, /*On fail goto*//*Label 16436*/ GIMT_Encode4(1118821), // Rule ID 62730 //
     /* 1118749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118788 */     // MIs[0] policy
     /* 1118788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1118801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118820 */     // GIR_Coverage, 62730,
     /* 1118820 */     GIR_EraseRootFromParent_Done,
     /* 1118821 */   // Label 16436: @1118821
     /* 1118821 */   GIM_Try, /*On fail goto*//*Label 16437*/ GIMT_Encode4(1118898), // Rule ID 62731 //
     /* 1118826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118865 */     // MIs[0] policy
     /* 1118865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1118878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118897 */     // GIR_Coverage, 62731,
     /* 1118897 */     GIR_EraseRootFromParent_Done,
     /* 1118898 */   // Label 16437: @1118898
     /* 1118898 */   GIM_Try, /*On fail goto*//*Label 16438*/ GIMT_Encode4(1118975), // Rule ID 62734 //
     /* 1118903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118942 */     // MIs[0] policy
     /* 1118942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1118955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118974 */     // GIR_Coverage, 62734,
     /* 1118974 */     GIR_EraseRootFromParent_Done,
     /* 1118975 */   // Label 16438: @1118975
     /* 1118975 */   GIM_Try, /*On fail goto*//*Label 16439*/ GIMT_Encode4(1119052), // Rule ID 62735 //
     /* 1118980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119019 */     // MIs[0] policy
     /* 1119019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119029 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1119032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119051 */     // GIR_Coverage, 62735,
     /* 1119051 */     GIR_EraseRootFromParent_Done,
     /* 1119052 */   // Label 16439: @1119052
     /* 1119052 */   GIM_Try, /*On fail goto*//*Label 16440*/ GIMT_Encode4(1119129), // Rule ID 62738 //
     /* 1119057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1119060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1119074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119096 */     // MIs[0] policy
     /* 1119096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1119109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119128 */     // GIR_Coverage, 62738,
     /* 1119128 */     GIR_EraseRootFromParent_Done,
     /* 1119129 */   // Label 16440: @1119129
     /* 1119129 */   GIM_Try, /*On fail goto*//*Label 16441*/ GIMT_Encode4(1119206), // Rule ID 62739 //
     /* 1119134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1119137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1119142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1119151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1119169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119173 */     // MIs[0] policy
     /* 1119173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119183 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1119186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1119202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119205 */     // GIR_Coverage, 62739,
     /* 1119205 */     GIR_EraseRootFromParent_Done,
     /* 1119206 */   // Label 16441: @1119206
     /* 1119206 */   GIM_Try, /*On fail goto*//*Label 16442*/ GIMT_Encode4(1119283), // Rule ID 62833 //
     /* 1119211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119250 */     // MIs[0] policy
     /* 1119250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119260 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1119263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119282 */     // GIR_Coverage, 62833,
     /* 1119282 */     GIR_EraseRootFromParent_Done,
     /* 1119283 */   // Label 16442: @1119283
     /* 1119283 */   GIM_Try, /*On fail goto*//*Label 16443*/ GIMT_Encode4(1119360), // Rule ID 62834 //
     /* 1119288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119327 */     // MIs[0] policy
     /* 1119327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119337 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1119340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119359 */     // GIR_Coverage, 62834,
     /* 1119359 */     GIR_EraseRootFromParent_Done,
     /* 1119360 */   // Label 16443: @1119360
     /* 1119360 */   GIM_Try, /*On fail goto*//*Label 16444*/ GIMT_Encode4(1119437), // Rule ID 64291 //
     /* 1119365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119404 */     // MIs[0] policy
     /* 1119404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1119417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119436 */     // GIR_Coverage, 64291,
     /* 1119436 */     GIR_EraseRootFromParent_Done,
     /* 1119437 */   // Label 16444: @1119437
     /* 1119437 */   GIM_Try, /*On fail goto*//*Label 16445*/ GIMT_Encode4(1119514), // Rule ID 64292 //
     /* 1119442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119481 */     // MIs[0] policy
     /* 1119481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1119494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119513 */     // GIR_Coverage, 64292,
     /* 1119513 */     GIR_EraseRootFromParent_Done,
     /* 1119514 */   // Label 16445: @1119514
     /* 1119514 */   GIM_Try, /*On fail goto*//*Label 16446*/ GIMT_Encode4(1119591), // Rule ID 64293 //
     /* 1119519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119558 */     // MIs[0] policy
     /* 1119558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1119571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119590 */     // GIR_Coverage, 64293,
     /* 1119590 */     GIR_EraseRootFromParent_Done,
     /* 1119591 */   // Label 16446: @1119591
     /* 1119591 */   GIM_Try, /*On fail goto*//*Label 16447*/ GIMT_Encode4(1119668), // Rule ID 64294 //
     /* 1119596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119635 */     // MIs[0] policy
     /* 1119635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119645 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1119648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119667 */     // GIR_Coverage, 64294,
     /* 1119667 */     GIR_EraseRootFromParent_Done,
     /* 1119668 */   // Label 16447: @1119668
     /* 1119668 */   GIM_Try, /*On fail goto*//*Label 16448*/ GIMT_Encode4(1119745), // Rule ID 64295 //
     /* 1119673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119712 */     // MIs[0] policy
     /* 1119712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1119725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119744 */     // GIR_Coverage, 64295,
     /* 1119744 */     GIR_EraseRootFromParent_Done,
     /* 1119745 */   // Label 16448: @1119745
     /* 1119745 */   GIM_Try, /*On fail goto*//*Label 16449*/ GIMT_Encode4(1119822), // Rule ID 64296 //
     /* 1119750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119789 */     // MIs[0] policy
     /* 1119789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1119802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119821 */     // GIR_Coverage, 64296,
     /* 1119821 */     GIR_EraseRootFromParent_Done,
     /* 1119822 */   // Label 16449: @1119822
     /* 1119822 */   GIM_Try, /*On fail goto*//*Label 16450*/ GIMT_Encode4(1119899), // Rule ID 64297 //
     /* 1119827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119866 */     // MIs[0] policy
     /* 1119866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119876 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1119879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119898 */     // GIR_Coverage, 64297,
     /* 1119898 */     GIR_EraseRootFromParent_Done,
     /* 1119899 */   // Label 16450: @1119899
     /* 1119899 */   GIM_Try, /*On fail goto*//*Label 16451*/ GIMT_Encode4(1119976), // Rule ID 64298 //
     /* 1119904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119943 */     // MIs[0] policy
     /* 1119943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119953 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11101:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1119956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119975 */     // GIR_Coverage, 64298,
     /* 1119975 */     GIR_EraseRootFromParent_Done,
     /* 1119976 */   // Label 16451: @1119976
     /* 1119976 */   GIM_Try, /*On fail goto*//*Label 16452*/ GIMT_Encode4(1120053), // Rule ID 64299 //
     /* 1119981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120020 */     // MIs[0] policy
     /* 1120020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120030 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1120033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120052 */     // GIR_Coverage, 64299,
     /* 1120052 */     GIR_EraseRootFromParent_Done,
     /* 1120053 */   // Label 16452: @1120053
     /* 1120053 */   GIM_Try, /*On fail goto*//*Label 16453*/ GIMT_Encode4(1120130), // Rule ID 64300 //
     /* 1120058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120097 */     // MIs[0] policy
     /* 1120097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120107 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1120110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120129 */     // GIR_Coverage, 64300,
     /* 1120129 */     GIR_EraseRootFromParent_Done,
     /* 1120130 */   // Label 16453: @1120130
     /* 1120130 */   GIM_Try, /*On fail goto*//*Label 16454*/ GIMT_Encode4(1120207), // Rule ID 64301 //
     /* 1120135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120174 */     // MIs[0] policy
     /* 1120174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1120187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120206 */     // GIR_Coverage, 64301,
     /* 1120206 */     GIR_EraseRootFromParent_Done,
     /* 1120207 */   // Label 16454: @1120207
     /* 1120207 */   GIM_Try, /*On fail goto*//*Label 16455*/ GIMT_Encode4(1120284), // Rule ID 64302 //
     /* 1120212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120251 */     // MIs[0] policy
     /* 1120251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120261 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1120264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120283 */     // GIR_Coverage, 64302,
     /* 1120283 */     GIR_EraseRootFromParent_Done,
     /* 1120284 */   // Label 16455: @1120284
     /* 1120284 */   GIM_Try, /*On fail goto*//*Label 16456*/ GIMT_Encode4(1120361), // Rule ID 64303 //
     /* 1120289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120328 */     // MIs[0] policy
     /* 1120328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120338 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1120341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120360 */     // GIR_Coverage, 64303,
     /* 1120360 */     GIR_EraseRootFromParent_Done,
     /* 1120361 */   // Label 16456: @1120361
     /* 1120361 */   GIM_Try, /*On fail goto*//*Label 16457*/ GIMT_Encode4(1120438), // Rule ID 64304 //
     /* 1120366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1120374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120405 */     // MIs[0] policy
     /* 1120405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120415 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1120418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120437 */     // GIR_Coverage, 64304,
     /* 1120437 */     GIR_EraseRootFromParent_Done,
     /* 1120438 */   // Label 16457: @1120438
     /* 1120438 */   GIM_Try, /*On fail goto*//*Label 16458*/ GIMT_Encode4(1120515), // Rule ID 64305 //
     /* 1120443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120482 */     // MIs[0] policy
     /* 1120482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1120495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120514 */     // GIR_Coverage, 64305,
     /* 1120514 */     GIR_EraseRootFromParent_Done,
     /* 1120515 */   // Label 16458: @1120515
     /* 1120515 */   GIM_Try, /*On fail goto*//*Label 16459*/ GIMT_Encode4(1120592), // Rule ID 64306 //
     /* 1120520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120559 */     // MIs[0] policy
     /* 1120559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120569 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1120572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120591 */     // GIR_Coverage, 64306,
     /* 1120591 */     GIR_EraseRootFromParent_Done,
     /* 1120592 */   // Label 16459: @1120592
     /* 1120592 */   GIM_Try, /*On fail goto*//*Label 16460*/ GIMT_Encode4(1120669), // Rule ID 64307 //
     /* 1120597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120636 */     // MIs[0] policy
     /* 1120636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1120649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120668 */     // GIR_Coverage, 64307,
     /* 1120668 */     GIR_EraseRootFromParent_Done,
     /* 1120669 */   // Label 16460: @1120669
     /* 1120669 */   GIM_Try, /*On fail goto*//*Label 16461*/ GIMT_Encode4(1120746), // Rule ID 64308 //
     /* 1120674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120713 */     // MIs[0] policy
     /* 1120713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11107:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1120726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120745 */     // GIR_Coverage, 64308,
     /* 1120745 */     GIR_EraseRootFromParent_Done,
     /* 1120746 */   // Label 16461: @1120746
     /* 1120746 */   GIM_Try, /*On fail goto*//*Label 16462*/ GIMT_Encode4(1120823), // Rule ID 64309 //
     /* 1120751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120790 */     // MIs[0] policy
     /* 1120790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1120803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120822 */     // GIR_Coverage, 64309,
     /* 1120822 */     GIR_EraseRootFromParent_Done,
     /* 1120823 */   // Label 16462: @1120823
     /* 1120823 */   GIM_Try, /*On fail goto*//*Label 16463*/ GIMT_Encode4(1120900), // Rule ID 64310 //
     /* 1120828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120867 */     // MIs[0] policy
     /* 1120867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120877 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11107:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1120880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120899 */     // GIR_Coverage, 64310,
     /* 1120899 */     GIR_EraseRootFromParent_Done,
     /* 1120900 */   // Label 16463: @1120900
     /* 1120900 */   GIM_Try, /*On fail goto*//*Label 16464*/ GIMT_Encode4(1120977), // Rule ID 64311 //
     /* 1120905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120944 */     // MIs[0] policy
     /* 1120944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120954 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1120957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120976 */     // GIR_Coverage, 64311,
     /* 1120976 */     GIR_EraseRootFromParent_Done,
     /* 1120977 */   // Label 16464: @1120977
     /* 1120977 */   GIM_Try, /*On fail goto*//*Label 16465*/ GIMT_Encode4(1121054), // Rule ID 64312 //
     /* 1120982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121021 */     // MIs[0] policy
     /* 1121021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121031 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11107:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1121034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121053 */     // GIR_Coverage, 64312,
     /* 1121053 */     GIR_EraseRootFromParent_Done,
     /* 1121054 */   // Label 16465: @1121054
     /* 1121054 */   GIM_Try, /*On fail goto*//*Label 16466*/ GIMT_Encode4(1121131), // Rule ID 64313 //
     /* 1121059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121098 */     // MIs[0] policy
     /* 1121098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1121111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121130 */     // GIR_Coverage, 64313,
     /* 1121130 */     GIR_EraseRootFromParent_Done,
     /* 1121131 */   // Label 16466: @1121131
     /* 1121131 */   GIM_Try, /*On fail goto*//*Label 16467*/ GIMT_Encode4(1121208), // Rule ID 64314 //
     /* 1121136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121175 */     // MIs[0] policy
     /* 1121175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121185 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1121188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121207 */     // GIR_Coverage, 64314,
     /* 1121207 */     GIR_EraseRootFromParent_Done,
     /* 1121208 */   // Label 16467: @1121208
     /* 1121208 */   GIM_Try, /*On fail goto*//*Label 16468*/ GIMT_Encode4(1121285), // Rule ID 64315 //
     /* 1121213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121252 */     // MIs[0] policy
     /* 1121252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1121265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121284 */     // GIR_Coverage, 64315,
     /* 1121284 */     GIR_EraseRootFromParent_Done,
     /* 1121285 */   // Label 16468: @1121285
     /* 1121285 */   GIM_Try, /*On fail goto*//*Label 16469*/ GIMT_Encode4(1121362), // Rule ID 64316 //
     /* 1121290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121329 */     // MIs[0] policy
     /* 1121329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1121342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121361 */     // GIR_Coverage, 64316,
     /* 1121361 */     GIR_EraseRootFromParent_Done,
     /* 1121362 */   // Label 16469: @1121362
     /* 1121362 */   GIM_Try, /*On fail goto*//*Label 16470*/ GIMT_Encode4(1121439), // Rule ID 64317 //
     /* 1121367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121406 */     // MIs[0] policy
     /* 1121406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1121419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121438 */     // GIR_Coverage, 64317,
     /* 1121438 */     GIR_EraseRootFromParent_Done,
     /* 1121439 */   // Label 16470: @1121439
     /* 1121439 */   GIM_Try, /*On fail goto*//*Label 16471*/ GIMT_Encode4(1121516), // Rule ID 64318 //
     /* 1121444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121483 */     // MIs[0] policy
     /* 1121483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121493 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1121496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121515 */     // GIR_Coverage, 64318,
     /* 1121515 */     GIR_EraseRootFromParent_Done,
     /* 1121516 */   // Label 16471: @1121516
     /* 1121516 */   GIM_Try, /*On fail goto*//*Label 16472*/ GIMT_Encode4(1121593), // Rule ID 64319 //
     /* 1121521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121560 */     // MIs[0] policy
     /* 1121560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121570 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1121573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121592 */     // GIR_Coverage, 64319,
     /* 1121592 */     GIR_EraseRootFromParent_Done,
     /* 1121593 */   // Label 16472: @1121593
     /* 1121593 */   GIM_Try, /*On fail goto*//*Label 16473*/ GIMT_Encode4(1121670), // Rule ID 64320 //
     /* 1121598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121637 */     // MIs[0] policy
     /* 1121637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121647 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1121650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121669 */     // GIR_Coverage, 64320,
     /* 1121669 */     GIR_EraseRootFromParent_Done,
     /* 1121670 */   // Label 16473: @1121670
     /* 1121670 */   GIM_Try, /*On fail goto*//*Label 16474*/ GIMT_Encode4(1121747), // Rule ID 64321 //
     /* 1121675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121714 */     // MIs[0] policy
     /* 1121714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1121727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121746 */     // GIR_Coverage, 64321,
     /* 1121746 */     GIR_EraseRootFromParent_Done,
     /* 1121747 */   // Label 16474: @1121747
     /* 1121747 */   GIM_Try, /*On fail goto*//*Label 16475*/ GIMT_Encode4(1121824), // Rule ID 64322 //
     /* 1121752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1121755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121791 */     // MIs[0] policy
     /* 1121791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121801 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1121804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121823 */     // GIR_Coverage, 64322,
     /* 1121823 */     GIR_EraseRootFromParent_Done,
     /* 1121824 */   // Label 16475: @1121824
     /* 1121824 */   GIM_Try, /*On fail goto*//*Label 16476*/ GIMT_Encode4(1121901), // Rule ID 64323 //
     /* 1121829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121868 */     // MIs[0] policy
     /* 1121868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1121881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121900 */     // GIR_Coverage, 64323,
     /* 1121900 */     GIR_EraseRootFromParent_Done,
     /* 1121901 */   // Label 16476: @1121901
     /* 1121901 */   GIM_Try, /*On fail goto*//*Label 16477*/ GIMT_Encode4(1121978), // Rule ID 64324 //
     /* 1121906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1121909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121945 */     // MIs[0] policy
     /* 1121945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121955 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11106:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1121958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121977 */     // GIR_Coverage, 64324,
     /* 1121977 */     GIR_EraseRootFromParent_Done,
     /* 1121978 */   // Label 16477: @1121978
     /* 1121978 */   GIM_Try, /*On fail goto*//*Label 16478*/ GIMT_Encode4(1122055), // Rule ID 64325 //
     /* 1121983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122022 */     // MIs[0] policy
     /* 1122022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122032 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1122035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122054 */     // GIR_Coverage, 64325,
     /* 1122054 */     GIR_EraseRootFromParent_Done,
     /* 1122055 */   // Label 16478: @1122055
     /* 1122055 */   GIM_Try, /*On fail goto*//*Label 16479*/ GIMT_Encode4(1122132), // Rule ID 64326 //
     /* 1122060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122099 */     // MIs[0] policy
     /* 1122099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122109 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11106:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1122112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122131 */     // GIR_Coverage, 64326,
     /* 1122131 */     GIR_EraseRootFromParent_Done,
     /* 1122132 */   // Label 16479: @1122132
     /* 1122132 */   GIM_Try, /*On fail goto*//*Label 16480*/ GIMT_Encode4(1122209), // Rule ID 64327 //
     /* 1122137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122176 */     // MIs[0] policy
     /* 1122176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1122189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122208 */     // GIR_Coverage, 64327,
     /* 1122208 */     GIR_EraseRootFromParent_Done,
     /* 1122209 */   // Label 16480: @1122209
     /* 1122209 */   GIM_Try, /*On fail goto*//*Label 16481*/ GIMT_Encode4(1122286), // Rule ID 64328 //
     /* 1122214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1122222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122253 */     // MIs[0] policy
     /* 1122253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122263 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11106:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1122266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122285 */     // GIR_Coverage, 64328,
     /* 1122285 */     GIR_EraseRootFromParent_Done,
     /* 1122286 */   // Label 16481: @1122286
     /* 1122286 */   GIM_Try, /*On fail goto*//*Label 16482*/ GIMT_Encode4(1122363), // Rule ID 64329 //
     /* 1122291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122330 */     // MIs[0] policy
     /* 1122330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1122343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122362 */     // GIR_Coverage, 64329,
     /* 1122362 */     GIR_EraseRootFromParent_Done,
     /* 1122363 */   // Label 16482: @1122363
     /* 1122363 */   GIM_Try, /*On fail goto*//*Label 16483*/ GIMT_Encode4(1122440), // Rule ID 64330 //
     /* 1122368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122407 */     // MIs[0] policy
     /* 1122407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122417 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11102:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1122420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122439 */     // GIR_Coverage, 64330,
     /* 1122439 */     GIR_EraseRootFromParent_Done,
     /* 1122440 */   // Label 16483: @1122440
     /* 1122440 */   GIM_Try, /*On fail goto*//*Label 16484*/ GIMT_Encode4(1122517), // Rule ID 64331 //
     /* 1122445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122484 */     // MIs[0] policy
     /* 1122484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1122497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122516 */     // GIR_Coverage, 64331,
     /* 1122516 */     GIR_EraseRootFromParent_Done,
     /* 1122517 */   // Label 16484: @1122517
     /* 1122517 */   GIM_Try, /*On fail goto*//*Label 16485*/ GIMT_Encode4(1122594), // Rule ID 64332 //
     /* 1122522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122561 */     // MIs[0] policy
     /* 1122561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1122574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122593 */     // GIR_Coverage, 64332,
     /* 1122593 */     GIR_EraseRootFromParent_Done,
     /* 1122594 */   // Label 16485: @1122594
     /* 1122594 */   GIM_Try, /*On fail goto*//*Label 16486*/ GIMT_Encode4(1122671), // Rule ID 64333 //
     /* 1122599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122638 */     // MIs[0] policy
     /* 1122638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1122651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122670 */     // GIR_Coverage, 64333,
     /* 1122670 */     GIR_EraseRootFromParent_Done,
     /* 1122671 */   // Label 16486: @1122671
     /* 1122671 */   GIM_Try, /*On fail goto*//*Label 16487*/ GIMT_Encode4(1122748), // Rule ID 64334 //
     /* 1122676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122715 */     // MIs[0] policy
     /* 1122715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122725 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1122728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122747 */     // GIR_Coverage, 64334,
     /* 1122747 */     GIR_EraseRootFromParent_Done,
     /* 1122748 */   // Label 16487: @1122748
     /* 1122748 */   GIM_Try, /*On fail goto*//*Label 16488*/ GIMT_Encode4(1122825), // Rule ID 64335 //
     /* 1122753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122792 */     // MIs[0] policy
     /* 1122792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122802 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1122805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122824 */     // GIR_Coverage, 64335,
     /* 1122824 */     GIR_EraseRootFromParent_Done,
     /* 1122825 */   // Label 16488: @1122825
     /* 1122825 */   GIM_Try, /*On fail goto*//*Label 16489*/ GIMT_Encode4(1122902), // Rule ID 64336 //
     /* 1122830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122869 */     // MIs[0] policy
     /* 1122869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122879 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1122882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122901 */     // GIR_Coverage, 64336,
     /* 1122901 */     GIR_EraseRootFromParent_Done,
     /* 1122902 */   // Label 16489: @1122902
     /* 1122902 */   GIM_Try, /*On fail goto*//*Label 16490*/ GIMT_Encode4(1122979), // Rule ID 64337 //
     /* 1122907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122946 */     // MIs[0] policy
     /* 1122946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122956 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1122959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122978 */     // GIR_Coverage, 64337,
     /* 1122978 */     GIR_EraseRootFromParent_Done,
     /* 1122979 */   // Label 16490: @1122979
     /* 1122979 */   GIM_Try, /*On fail goto*//*Label 16491*/ GIMT_Encode4(1123056), // Rule ID 64338 //
     /* 1122984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123023 */     // MIs[0] policy
     /* 1123023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123033 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1123036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123055 */     // GIR_Coverage, 64338,
     /* 1123055 */     GIR_EraseRootFromParent_Done,
     /* 1123056 */   // Label 16491: @1123056
     /* 1123056 */   GIM_Try, /*On fail goto*//*Label 16492*/ GIMT_Encode4(1123133), // Rule ID 64339 //
     /* 1123061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123100 */     // MIs[0] policy
     /* 1123100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1123113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123132 */     // GIR_Coverage, 64339,
     /* 1123132 */     GIR_EraseRootFromParent_Done,
     /* 1123133 */   // Label 16492: @1123133
     /* 1123133 */   GIM_Try, /*On fail goto*//*Label 16493*/ GIMT_Encode4(1123210), // Rule ID 64340 //
     /* 1123138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123177 */     // MIs[0] policy
     /* 1123177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123187 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1123190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123209 */     // GIR_Coverage, 64340,
     /* 1123209 */     GIR_EraseRootFromParent_Done,
     /* 1123210 */   // Label 16493: @1123210
     /* 1123210 */   GIM_Try, /*On fail goto*//*Label 16494*/ GIMT_Encode4(1123287), // Rule ID 64341 //
     /* 1123215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123254 */     // MIs[0] policy
     /* 1123254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123264 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1123267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123286 */     // GIR_Coverage, 64341,
     /* 1123286 */     GIR_EraseRootFromParent_Done,
     /* 1123287 */   // Label 16494: @1123287
     /* 1123287 */   GIM_Try, /*On fail goto*//*Label 16495*/ GIMT_Encode4(1123364), // Rule ID 64342 //
     /* 1123292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123331 */     // MIs[0] policy
     /* 1123331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123341 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1123344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123363 */     // GIR_Coverage, 64342,
     /* 1123363 */     GIR_EraseRootFromParent_Done,
     /* 1123364 */   // Label 16495: @1123364
     /* 1123364 */   GIM_Try, /*On fail goto*//*Label 16496*/ GIMT_Encode4(1123441), // Rule ID 64343 //
     /* 1123369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123408 */     // MIs[0] policy
     /* 1123408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123418 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1123421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123440 */     // GIR_Coverage, 64343,
     /* 1123440 */     GIR_EraseRootFromParent_Done,
     /* 1123441 */   // Label 16496: @1123441
     /* 1123441 */   GIM_Try, /*On fail goto*//*Label 16497*/ GIMT_Encode4(1123518), // Rule ID 64344 //
     /* 1123446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1123454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123485 */     // MIs[0] policy
     /* 1123485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123495 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1123498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123517 */     // GIR_Coverage, 64344,
     /* 1123517 */     GIR_EraseRootFromParent_Done,
     /* 1123518 */   // Label 16497: @1123518
     /* 1123518 */   GIM_Try, /*On fail goto*//*Label 16498*/ GIMT_Encode4(1123595), // Rule ID 64345 //
     /* 1123523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123562 */     // MIs[0] policy
     /* 1123562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1123575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123594 */     // GIR_Coverage, 64345,
     /* 1123594 */     GIR_EraseRootFromParent_Done,
     /* 1123595 */   // Label 16498: @1123595
     /* 1123595 */   GIM_Try, /*On fail goto*//*Label 16499*/ GIMT_Encode4(1123672), // Rule ID 64346 //
     /* 1123600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123639 */     // MIs[0] policy
     /* 1123639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1123652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123671 */     // GIR_Coverage, 64346,
     /* 1123671 */     GIR_EraseRootFromParent_Done,
     /* 1123672 */   // Label 16499: @1123672
     /* 1123672 */   GIM_Try, /*On fail goto*//*Label 16500*/ GIMT_Encode4(1123749), // Rule ID 64347 //
     /* 1123677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123716 */     // MIs[0] policy
     /* 1123716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1123729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123748 */     // GIR_Coverage, 64347,
     /* 1123748 */     GIR_EraseRootFromParent_Done,
     /* 1123749 */   // Label 16500: @1123749
     /* 1123749 */   GIM_Try, /*On fail goto*//*Label 16501*/ GIMT_Encode4(1123826), // Rule ID 64348 //
     /* 1123754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123793 */     // MIs[0] policy
     /* 1123793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1123806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123825 */     // GIR_Coverage, 64348,
     /* 1123825 */     GIR_EraseRootFromParent_Done,
     /* 1123826 */   // Label 16501: @1123826
     /* 1123826 */   GIM_Try, /*On fail goto*//*Label 16502*/ GIMT_Encode4(1123903), // Rule ID 64349 //
     /* 1123831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123870 */     // MIs[0] policy
     /* 1123870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1123883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123902 */     // GIR_Coverage, 64349,
     /* 1123902 */     GIR_EraseRootFromParent_Done,
     /* 1123903 */   // Label 16502: @1123903
     /* 1123903 */   GIM_Try, /*On fail goto*//*Label 16503*/ GIMT_Encode4(1123980), // Rule ID 64350 //
     /* 1123908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123947 */     // MIs[0] policy
     /* 1123947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123957 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1123960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123979 */     // GIR_Coverage, 64350,
     /* 1123979 */     GIR_EraseRootFromParent_Done,
     /* 1123980 */   // Label 16503: @1123980
     /* 1123980 */   GIM_Try, /*On fail goto*//*Label 16504*/ GIMT_Encode4(1124057), // Rule ID 64351 //
     /* 1123985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124024 */     // MIs[0] policy
     /* 1124024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1124037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124056 */     // GIR_Coverage, 64351,
     /* 1124056 */     GIR_EraseRootFromParent_Done,
     /* 1124057 */   // Label 16504: @1124057
     /* 1124057 */   GIM_Try, /*On fail goto*//*Label 16505*/ GIMT_Encode4(1124134), // Rule ID 64352 //
     /* 1124062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1124065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1124070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124101 */     // MIs[0] policy
     /* 1124101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124111 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1124114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124133 */     // GIR_Coverage, 64352,
     /* 1124133 */     GIR_EraseRootFromParent_Done,
     /* 1124134 */   // Label 16505: @1124134
     /* 1124134 */   GIM_Try, /*On fail goto*//*Label 16506*/ GIMT_Encode4(1124211), // Rule ID 65151 //
     /* 1124139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124178 */     // MIs[0] policy
     /* 1124178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124188 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1124191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124210 */     // GIR_Coverage, 65151,
     /* 1124210 */     GIR_EraseRootFromParent_Done,
     /* 1124211 */   // Label 16506: @1124211
     /* 1124211 */   GIM_Try, /*On fail goto*//*Label 16507*/ GIMT_Encode4(1124288), // Rule ID 65152 //
     /* 1124216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124255 */     // MIs[0] policy
     /* 1124255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124265 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2),
     /* 1124268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124287 */     // GIR_Coverage, 65152,
     /* 1124287 */     GIR_EraseRootFromParent_Done,
     /* 1124288 */   // Label 16507: @1124288
     /* 1124288 */   GIM_Try, /*On fail goto*//*Label 16508*/ GIMT_Encode4(1124365), // Rule ID 65155 //
     /* 1124293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124332 */     // MIs[0] policy
     /* 1124332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124364 */     // GIR_Coverage, 65155,
     /* 1124364 */     GIR_EraseRootFromParent_Done,
     /* 1124365 */   // Label 16508: @1124365
     /* 1124365 */   GIM_Try, /*On fail goto*//*Label 16509*/ GIMT_Encode4(1124442), // Rule ID 65156 //
     /* 1124370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1124381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1124384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124409 */     // MIs[0] policy
     /* 1124409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124419 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11026:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124441 */     // GIR_Coverage, 65156,
     /* 1124441 */     GIR_EraseRootFromParent_Done,
     /* 1124442 */   // Label 16509: @1124442
     /* 1124442 */   GIM_Try, /*On fail goto*//*Label 16510*/ GIMT_Encode4(1124519), // Rule ID 65159 //
     /* 1124447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1124464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124486 */     // MIs[0] policy
     /* 1124486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1124499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124518 */     // GIR_Coverage, 65159,
     /* 1124518 */     GIR_EraseRootFromParent_Done,
     /* 1124519 */   // Label 16510: @1124519
     /* 1124519 */   GIM_Try, /*On fail goto*//*Label 16511*/ GIMT_Encode4(1124596), // Rule ID 65160 //
     /* 1124524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1124535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1124538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1124541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1124544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1124563 */     // MIs[0] policy
     /* 1124563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124573 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1124576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124595 */     // GIR_Coverage, 65160,
     /* 1124595 */     GIR_EraseRootFromParent_Done,
     /* 1124596 */   // Label 16511: @1124596
     /* 1124596 */   GIM_Try, /*On fail goto*//*Label 16512*/ GIMT_Encode4(1124673), // Rule ID 65163 //
     /* 1124601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1124618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124640 */     // MIs[0] policy
     /* 1124640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1124653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124672 */     // GIR_Coverage, 65163,
     /* 1124672 */     GIR_EraseRootFromParent_Done,
     /* 1124673 */   // Label 16512: @1124673
     /* 1124673 */   GIM_Try, /*On fail goto*//*Label 16513*/ GIMT_Encode4(1124750), // Rule ID 65164 //
     /* 1124678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1124689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1124692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1124695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1124698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1124717 */     // MIs[0] policy
     /* 1124717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124727 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1124730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124749 */     // GIR_Coverage, 65164,
     /* 1124749 */     GIR_EraseRootFromParent_Done,
     /* 1124750 */   // Label 16513: @1124750
     /* 1124750 */   GIM_Try, /*On fail goto*//*Label 16514*/ GIMT_Encode4(1124827), // Rule ID 65167 //
     /* 1124755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1124772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124794 */     // MIs[0] policy
     /* 1124794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124804 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1124807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124826 */     // GIR_Coverage, 65167,
     /* 1124826 */     GIR_EraseRootFromParent_Done,
     /* 1124827 */   // Label 16514: @1124827
     /* 1124827 */   GIM_Try, /*On fail goto*//*Label 16515*/ GIMT_Encode4(1124904), // Rule ID 65168 //
     /* 1124832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1124843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1124846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1124849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1124852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1124855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1124871 */     // MIs[0] policy
     /* 1124871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124881 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1124881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1124884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124903 */     // GIR_Coverage, 65168,
     /* 1124903 */     GIR_EraseRootFromParent_Done,
     /* 1124904 */   // Label 16515: @1124904
     /* 1124904 */   GIM_Try, /*On fail goto*//*Label 16516*/ GIMT_Encode4(1124981), // Rule ID 65171 //
     /* 1124909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1124912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1124920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1124923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1124926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1124929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1124932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124948 */     // MIs[0] policy
     /* 1124948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1124951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1124958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1124961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1124977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1124979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124980 */     // GIR_Coverage, 65171,
     /* 1124980 */     GIR_EraseRootFromParent_Done,
     /* 1124981 */   // Label 16516: @1124981
     /* 1124981 */   GIM_Try, /*On fail goto*//*Label 16517*/ GIMT_Encode4(1125058), // Rule ID 65172 //
     /* 1124986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1124989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1124994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1124997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125025 */     // MIs[0] policy
     /* 1125025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125035 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11026:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1),
     /* 1125038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125057 */     // GIR_Coverage, 65172,
     /* 1125057 */     GIR_EraseRootFromParent_Done,
     /* 1125058 */   // Label 16517: @1125058
     /* 1125058 */   GIM_Try, /*On fail goto*//*Label 16518*/ GIMT_Encode4(1125135), // Rule ID 65175 //
     /* 1125063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125102 */     // MIs[0] policy
     /* 1125102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125134 */     // GIR_Coverage, 65175,
     /* 1125134 */     GIR_EraseRootFromParent_Done,
     /* 1125135 */   // Label 16518: @1125135
     /* 1125135 */   GIM_Try, /*On fail goto*//*Label 16519*/ GIMT_Encode4(1125212), // Rule ID 65176 //
     /* 1125140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1125151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1125154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1125157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1125160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125179 */     // MIs[0] policy
     /* 1125179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11026:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2),
     /* 1125192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125211 */     // GIR_Coverage, 65176,
     /* 1125211 */     GIR_EraseRootFromParent_Done,
     /* 1125212 */   // Label 16519: @1125212
     /* 1125212 */   GIM_Try, /*On fail goto*//*Label 16520*/ GIMT_Encode4(1125289), // Rule ID 65179 //
     /* 1125217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1125228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1125231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125256 */     // MIs[0] policy
     /* 1125256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125266 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125288 */     // GIR_Coverage, 65179,
     /* 1125288 */     GIR_EraseRootFromParent_Done,
     /* 1125289 */   // Label 16520: @1125289
     /* 1125289 */   GIM_Try, /*On fail goto*//*Label 16521*/ GIMT_Encode4(1125366), // Rule ID 65180 //
     /* 1125294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1125305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1125308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1125311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1125314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125333 */     // MIs[0] policy
     /* 1125333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125343 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11026:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4),
     /* 1125346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125365 */     // GIR_Coverage, 65180,
     /* 1125365 */     GIR_EraseRootFromParent_Done,
     /* 1125366 */   // Label 16521: @1125366
     /* 1125366 */   GIM_Try, /*On fail goto*//*Label 16522*/ GIMT_Encode4(1125443), // Rule ID 65183 //
     /* 1125371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1125382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1125385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1125388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1125391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125410 */     // MIs[0] policy
     /* 1125410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125420 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125442 */     // GIR_Coverage, 65183,
     /* 1125442 */     GIR_EraseRootFromParent_Done,
     /* 1125443 */   // Label 16522: @1125443
     /* 1125443 */   GIM_Try, /*On fail goto*//*Label 16523*/ GIMT_Encode4(1125520), // Rule ID 65184 //
     /* 1125448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots),
     /* 1125456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1125459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1125462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1125465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1125468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125487 */     // MIs[0] policy
     /* 1125487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125497 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11026:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8),
     /* 1125500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125519 */     // GIR_Coverage, 65184,
     /* 1125519 */     GIR_EraseRootFromParent_Done,
     /* 1125520 */   // Label 16523: @1125520
     /* 1125520 */   GIM_Try, /*On fail goto*//*Label 16524*/ GIMT_Encode4(1125597), // Rule ID 65187 //
     /* 1125525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1125536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1125539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1125542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1125545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125564 */     // MIs[0] policy
     /* 1125564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125574 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1125577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125596 */     // GIR_Coverage, 65187,
     /* 1125596 */     GIR_EraseRootFromParent_Done,
     /* 1125597 */   // Label 16524: @1125597
     /* 1125597 */   GIM_Try, /*On fail goto*//*Label 16525*/ GIMT_Encode4(1125674), // Rule ID 65188 //
     /* 1125602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1125613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1125616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1125619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1125622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125641 */     // MIs[0] policy
     /* 1125641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125651 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2),
     /* 1125654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125673 */     // GIR_Coverage, 65188,
     /* 1125673 */     GIR_EraseRootFromParent_Done,
     /* 1125674 */   // Label 16525: @1125674
     /* 1125674 */   GIM_Try, /*On fail goto*//*Label 16526*/ GIMT_Encode4(1125751), // Rule ID 65191 //
     /* 1125679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125718 */     // MIs[0] policy
     /* 1125718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125728 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1125731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125750 */     // GIR_Coverage, 65191,
     /* 1125750 */     GIR_EraseRootFromParent_Done,
     /* 1125751 */   // Label 16526: @1125751
     /* 1125751 */   GIM_Try, /*On fail goto*//*Label 16527*/ GIMT_Encode4(1125828), // Rule ID 65192 //
     /* 1125756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125795 */     // MIs[0] policy
     /* 1125795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125805 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1125808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125827 */     // GIR_Coverage, 65192,
     /* 1125827 */     GIR_EraseRootFromParent_Done,
     /* 1125828 */   // Label 16527: @1125828
     /* 1125828 */   GIM_Try, /*On fail goto*//*Label 16528*/ GIMT_Encode4(1125905), // Rule ID 65195 //
     /* 1125833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1125850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1125856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125872 */     // MIs[0] policy
     /* 1125872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11030:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1125882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1125885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125904 */     // GIR_Coverage, 65195,
     /* 1125904 */     GIR_EraseRootFromParent_Done,
     /* 1125905 */   // Label 16528: @1125905
     /* 1125905 */   GIM_Try, /*On fail goto*//*Label 16529*/ GIMT_Encode4(1125982), // Rule ID 65196 //
     /* 1125910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1125921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1125924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1125927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1125933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125949 */     // MIs[0] policy
     /* 1125949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1125952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11030:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1125959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1125962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1125966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1125980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125981 */     // GIR_Coverage, 65196,
     /* 1125981 */     GIR_EraseRootFromParent_Done,
     /* 1125982 */   // Label 16529: @1125982
     /* 1125982 */   GIM_Try, /*On fail goto*//*Label 16530*/ GIMT_Encode4(1126059), // Rule ID 65199 //
     /* 1125987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1125995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1125998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1126004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126026 */     // MIs[0] policy
     /* 1126026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11030:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126058 */     // GIR_Coverage, 65199,
     /* 1126058 */     GIR_EraseRootFromParent_Done,
     /* 1126059 */   // Label 16530: @1126059
     /* 1126059 */   GIM_Try, /*On fail goto*//*Label 16531*/ GIMT_Encode4(1126136), // Rule ID 65200 //
     /* 1126064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1126081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1126084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126103 */     // MIs[0] policy
     /* 1126103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126113 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11030:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126135 */     // GIR_Coverage, 65200,
     /* 1126135 */     GIR_EraseRootFromParent_Done,
     /* 1126136 */   // Label 16531: @1126136
     /* 1126136 */   GIM_Try, /*On fail goto*//*Label 16532*/ GIMT_Encode4(1126213), // Rule ID 65203 //
     /* 1126141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1126158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1126161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126180 */     // MIs[0] policy
     /* 1126180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126190 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11030:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126212 */     // GIR_Coverage, 65203,
     /* 1126212 */     GIR_EraseRootFromParent_Done,
     /* 1126213 */   // Label 16532: @1126213
     /* 1126213 */   GIM_Try, /*On fail goto*//*Label 16533*/ GIMT_Encode4(1126290), // Rule ID 65204 //
     /* 1126218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1126235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1126238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126257 */     // MIs[0] policy
     /* 1126257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126267 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11030:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126289 */     // GIR_Coverage, 65204,
     /* 1126289 */     GIR_EraseRootFromParent_Done,
     /* 1126290 */   // Label 16533: @1126290
     /* 1126290 */   GIM_Try, /*On fail goto*//*Label 16534*/ GIMT_Encode4(1126367), // Rule ID 65207 //
     /* 1126295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1126306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1126309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1126315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126334 */     // MIs[0] policy
     /* 1126334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126344 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126366 */     // GIR_Coverage, 65207,
     /* 1126366 */     GIR_EraseRootFromParent_Done,
     /* 1126367 */   // Label 16534: @1126367
     /* 1126367 */   GIM_Try, /*On fail goto*//*Label 16535*/ GIMT_Encode4(1126444), // Rule ID 65208 //
     /* 1126372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1126383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1126386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1126389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1126392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126411 */     // MIs[0] policy
     /* 1126411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126421 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1),
     /* 1126424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126443 */     // GIR_Coverage, 65208,
     /* 1126443 */     GIR_EraseRootFromParent_Done,
     /* 1126444 */   // Label 16535: @1126444
     /* 1126444 */   GIM_Try, /*On fail goto*//*Label 16536*/ GIMT_Encode4(1126521), // Rule ID 65211 //
     /* 1126449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1126460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1126463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1126469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126488 */     // MIs[0] policy
     /* 1126488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126498 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11030:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126520 */     // GIR_Coverage, 65211,
     /* 1126520 */     GIR_EraseRootFromParent_Done,
     /* 1126521 */   // Label 16536: @1126521
     /* 1126521 */   GIM_Try, /*On fail goto*//*Label 16537*/ GIMT_Encode4(1126598), // Rule ID 65212 //
     /* 1126526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1126537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1126540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1126546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126565 */     // MIs[0] policy
     /* 1126565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126575 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11030:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2),
     /* 1126578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126597 */     // GIR_Coverage, 65212,
     /* 1126597 */     GIR_EraseRootFromParent_Done,
     /* 1126598 */   // Label 16537: @1126598
     /* 1126598 */   GIM_Try, /*On fail goto*//*Label 16538*/ GIMT_Encode4(1126675), // Rule ID 65215 //
     /* 1126603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1126614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1126617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1126620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1126623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126642 */     // MIs[0] policy
     /* 1126642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11030:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126674 */     // GIR_Coverage, 65215,
     /* 1126674 */     GIR_EraseRootFromParent_Done,
     /* 1126675 */   // Label 16538: @1126675
     /* 1126675 */   GIM_Try, /*On fail goto*//*Label 16539*/ GIMT_Encode4(1126752), // Rule ID 65216 //
     /* 1126680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1126691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1126694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1126697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1126700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126719 */     // MIs[0] policy
     /* 1126719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126729 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11030:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4),
     /* 1126732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126751 */     // GIR_Coverage, 65216,
     /* 1126751 */     GIR_EraseRootFromParent_Done,
     /* 1126752 */   // Label 16539: @1126752
     /* 1126752 */   GIM_Try, /*On fail goto*//*Label 16540*/ GIMT_Encode4(1126829), // Rule ID 65219 //
     /* 1126757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1126768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1126771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1126774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1126777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126796 */     // MIs[0] policy
     /* 1126796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11030:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126828 */     // GIR_Coverage, 65219,
     /* 1126828 */     GIR_EraseRootFromParent_Done,
     /* 1126829 */   // Label 16540: @1126829
     /* 1126829 */   GIM_Try, /*On fail goto*//*Label 16541*/ GIMT_Encode4(1126906), // Rule ID 65220 //
     /* 1126834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1126837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu),
     /* 1126842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1126845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1126848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1126851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1126854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1126857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126873 */     // MIs[0] policy
     /* 1126873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126883 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11030:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1126883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8),
     /* 1126886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1126902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126905 */     // GIR_Coverage, 65220,
     /* 1126905 */     GIR_EraseRootFromParent_Done,
     /* 1126906 */   // Label 16541: @1126906
     /* 1126906 */   GIM_Try, /*On fail goto*//*Label 16542*/ GIMT_Encode4(1126983), // Rule ID 65223 //
     /* 1126911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1126919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1126922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1126925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1126928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1126931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1126934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1126950 */     // MIs[0] policy
     /* 1126950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1126953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126960 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1126960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1126963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1126967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1126981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126982 */     // GIR_Coverage, 65223,
     /* 1126982 */     GIR_EraseRootFromParent_Done,
     /* 1126983 */   // Label 16542: @1126983
     /* 1126983 */   GIM_Try, /*On fail goto*//*Label 16543*/ GIMT_Encode4(1127060), // Rule ID 65224 //
     /* 1126988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1126996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1126999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1127002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1127005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1127008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127027 */     // MIs[0] policy
     /* 1127027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127037 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2),
     /* 1127040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127059 */     // GIR_Coverage, 65224,
     /* 1127059 */     GIR_EraseRootFromParent_Done,
     /* 1127060 */   // Label 16543: @1127060
     /* 1127060 */   GIM_Try, /*On fail goto*//*Label 16544*/ GIMT_Encode4(1127137), // Rule ID 65227 //
     /* 1127065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127104 */     // MIs[0] policy
     /* 1127104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127136 */     // GIR_Coverage, 65227,
     /* 1127136 */     GIR_EraseRootFromParent_Done,
     /* 1127137 */   // Label 16544: @1127137
     /* 1127137 */   GIM_Try, /*On fail goto*//*Label 16545*/ GIMT_Encode4(1127214), // Rule ID 65228 //
     /* 1127142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1127153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1127156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1127159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1127162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127181 */     // MIs[0] policy
     /* 1127181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127191 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127213 */     // GIR_Coverage, 65228,
     /* 1127213 */     GIR_EraseRootFromParent_Done,
     /* 1127214 */   // Label 16545: @1127214
     /* 1127214 */   GIM_Try, /*On fail goto*//*Label 16546*/ GIMT_Encode4(1127291), // Rule ID 65231 //
     /* 1127219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1127236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127258 */     // MIs[0] policy
     /* 1127258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11028:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127290 */     // GIR_Coverage, 65231,
     /* 1127290 */     GIR_EraseRootFromParent_Done,
     /* 1127291 */   // Label 16546: @1127291
     /* 1127291 */   GIM_Try, /*On fail goto*//*Label 16547*/ GIMT_Encode4(1127368), // Rule ID 65232 //
     /* 1127296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1127307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1127310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1127313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1127316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127335 */     // MIs[0] policy
     /* 1127335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11028:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127367 */     // GIR_Coverage, 65232,
     /* 1127367 */     GIR_EraseRootFromParent_Done,
     /* 1127368 */   // Label 16547: @1127368
     /* 1127368 */   GIM_Try, /*On fail goto*//*Label 16548*/ GIMT_Encode4(1127445), // Rule ID 65235 //
     /* 1127373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1127390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127412 */     // MIs[0] policy
     /* 1127412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11028:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1127425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127444 */     // GIR_Coverage, 65235,
     /* 1127444 */     GIR_EraseRootFromParent_Done,
     /* 1127445 */   // Label 16548: @1127445
     /* 1127445 */   GIM_Try, /*On fail goto*//*Label 16549*/ GIMT_Encode4(1127522), // Rule ID 65236 //
     /* 1127450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1127461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1127464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1127467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1127470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127489 */     // MIs[0] policy
     /* 1127489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127499 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11028:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1127502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127521 */     // GIR_Coverage, 65236,
     /* 1127521 */     GIR_EraseRootFromParent_Done,
     /* 1127522 */   // Label 16549: @1127522
     /* 1127522 */   GIM_Try, /*On fail goto*//*Label 16550*/ GIMT_Encode4(1127599), // Rule ID 65239 //
     /* 1127527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1127544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1127547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127566 */     // MIs[0] policy
     /* 1127566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127576 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11028:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1127579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127598 */     // GIR_Coverage, 65239,
     /* 1127598 */     GIR_EraseRootFromParent_Done,
     /* 1127599 */   // Label 16550: @1127599
     /* 1127599 */   GIM_Try, /*On fail goto*//*Label 16551*/ GIMT_Encode4(1127676), // Rule ID 65240 //
     /* 1127604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1127615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1127618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1127621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1127624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127643 */     // MIs[0] policy
     /* 1127643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127653 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11028:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1127656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1127672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127675 */     // GIR_Coverage, 65240,
     /* 1127675 */     GIR_EraseRootFromParent_Done,
     /* 1127676 */   // Label 16551: @1127676
     /* 1127676 */   GIM_Try, /*On fail goto*//*Label 16552*/ GIMT_Encode4(1127753), // Rule ID 65243 //
     /* 1127681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1127692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1127695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1127698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1127701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127720 */     // MIs[0] policy
     /* 1127720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127752 */     // GIR_Coverage, 65243,
     /* 1127752 */     GIR_EraseRootFromParent_Done,
     /* 1127753 */   // Label 16552: @1127753
     /* 1127753 */   GIM_Try, /*On fail goto*//*Label 16553*/ GIMT_Encode4(1127830), // Rule ID 65244 //
     /* 1127758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1127769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1127772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1127775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1127778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127797 */     // MIs[0] policy
     /* 1127797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127807 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1),
     /* 1127810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127829 */     // GIR_Coverage, 65244,
     /* 1127829 */     GIR_EraseRootFromParent_Done,
     /* 1127830 */   // Label 16553: @1127830
     /* 1127830 */   GIM_Try, /*On fail goto*//*Label 16554*/ GIMT_Encode4(1127907), // Rule ID 65247 //
     /* 1127835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1127852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1127855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1127858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127874 */     // MIs[0] policy
     /* 1127874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127884 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11028:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1127884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127906 */     // GIR_Coverage, 65247,
     /* 1127906 */     GIR_EraseRootFromParent_Done,
     /* 1127907 */   // Label 16554: @1127907
     /* 1127907 */   GIM_Try, /*On fail goto*//*Label 16555*/ GIMT_Encode4(1127984), // Rule ID 65248 //
     /* 1127912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1127929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1127932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1127935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127951 */     // MIs[0] policy
     /* 1127951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1127954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11028:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1127961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2),
     /* 1127964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1127968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1127982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127983 */     // GIR_Coverage, 65248,
     /* 1127983 */     GIR_EraseRootFromParent_Done,
     /* 1127984 */   // Label 16555: @1127984
     /* 1127984 */   GIM_Try, /*On fail goto*//*Label 16556*/ GIMT_Encode4(1128061), // Rule ID 65251 //
     /* 1127989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1127997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1128000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1128003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1128009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128028 */     // MIs[0] policy
     /* 1128028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128038 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11028:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1128041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128060 */     // GIR_Coverage, 65251,
     /* 1128060 */     GIR_EraseRootFromParent_Done,
     /* 1128061 */   // Label 16556: @1128061
     /* 1128061 */   GIM_Try, /*On fail goto*//*Label 16557*/ GIMT_Encode4(1128138), // Rule ID 65252 //
     /* 1128066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1128077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1128080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1128083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1128086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1128105 */     // MIs[0] policy
     /* 1128105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128115 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11028:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4),
     /* 1128118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128137 */     // GIR_Coverage, 65252,
     /* 1128137 */     GIR_EraseRootFromParent_Done,
     /* 1128138 */   // Label 16557: @1128138
     /* 1128138 */   GIM_Try, /*On fail goto*//*Label 16558*/ GIMT_Encode4(1128215), // Rule ID 65255 //
     /* 1128143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1128154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1128157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1128160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1128163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1128166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128182 */     // MIs[0] policy
     /* 1128182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128192 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11028:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1128192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128214 */     // GIR_Coverage, 65255,
     /* 1128214 */     GIR_EraseRootFromParent_Done,
     /* 1128215 */   // Label 16558: @1128215
     /* 1128215 */   GIM_Try, /*On fail goto*//*Label 16559*/ GIMT_Encode4(1128292), // Rule ID 65256 //
     /* 1128220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu),
     /* 1128228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1128231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1128234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1128237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1128240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1128243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1128259 */     // MIs[0] policy
     /* 1128259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1128262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11028:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1128269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8),
     /* 1128272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1128290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128291 */     // GIR_Coverage, 65256,
     /* 1128291 */     GIR_EraseRootFromParent_Done,
     /* 1128292 */   // Label 16559: @1128292
     /* 1128292 */   GIM_Try, /*On fail goto*//*Label 16560*/ GIMT_Encode4(1128372), // Rule ID 2722 //
     /* 1128297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1128308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1128311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128336 */     // MIs[0] round
     /* 1128336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128346 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128371 */     // GIR_Coverage, 2722,
     /* 1128371 */     GIR_EraseRootFromParent_Done,
     /* 1128372 */   // Label 16560: @1128372
     /* 1128372 */   GIM_Try, /*On fail goto*//*Label 16561*/ GIMT_Encode4(1128452), // Rule ID 2723 //
     /* 1128377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1128388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1128391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1128394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1128397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128416 */     // MIs[0] round
     /* 1128416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128426 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1128429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128451 */     // GIR_Coverage, 2723,
     /* 1128451 */     GIR_EraseRootFromParent_Done,
     /* 1128452 */   // Label 16561: @1128452
     /* 1128452 */   GIM_Try, /*On fail goto*//*Label 16562*/ GIMT_Encode4(1128532), // Rule ID 2762 //
     /* 1128457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1128460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1128465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128496 */     // MIs[0] round
     /* 1128496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128506 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1128509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128531 */     // GIR_Coverage, 2762,
     /* 1128531 */     GIR_EraseRootFromParent_Done,
     /* 1128532 */   // Label 16562: @1128532
     /* 1128532 */   GIM_Try, /*On fail goto*//*Label 16563*/ GIMT_Encode4(1128612), // Rule ID 2763 //
     /* 1128537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1128540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1128545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1128557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128576 */     // MIs[0] round
     /* 1128576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128586 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1128589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128611 */     // GIR_Coverage, 2763,
     /* 1128611 */     GIR_EraseRootFromParent_Done,
     /* 1128612 */   // Label 16563: @1128612
     /* 1128612 */   GIM_Try, /*On fail goto*//*Label 16564*/ GIMT_Encode4(1128692), // Rule ID 2782 //
     /* 1128617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1128620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1128634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128656 */     // MIs[0] round
     /* 1128656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128666 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1128669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128691 */     // GIR_Coverage, 2782,
     /* 1128691 */     GIR_EraseRootFromParent_Done,
     /* 1128692 */   // Label 16564: @1128692
     /* 1128692 */   GIM_Try, /*On fail goto*//*Label 16565*/ GIMT_Encode4(1128772), // Rule ID 2783 //
     /* 1128697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1128700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1128705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1128714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1128717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128736 */     // MIs[0] round
     /* 1128736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128746 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1128749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1128753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128771 */     // GIR_Coverage, 2783,
     /* 1128771 */     GIR_EraseRootFromParent_Done,
     /* 1128772 */   // Label 16565: @1128772
     /* 1128772 */   GIM_Try, /*On fail goto*//*Label 16566*/ GIMT_Encode4(1128852), // Rule ID 14932 //
     /* 1128777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1128788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1128791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1128794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1128797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128816 */     // MIs[0] round
     /* 1128816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128826 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1128829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128851 */     // GIR_Coverage, 14932,
     /* 1128851 */     GIR_EraseRootFromParent_Done,
     /* 1128852 */   // Label 16566: @1128852
     /* 1128852 */   GIM_Try, /*On fail goto*//*Label 16567*/ GIMT_Encode4(1128932), // Rule ID 14933 //
     /* 1128857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1128868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1128871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1128874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1128877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128896 */     // MIs[0] round
     /* 1128896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1128909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128931 */     // GIR_Coverage, 14933,
     /* 1128931 */     GIR_EraseRootFromParent_Done,
     /* 1128932 */   // Label 16567: @1128932
     /* 1128932 */   GIM_Try, /*On fail goto*//*Label 16568*/ GIMT_Encode4(1129012), // Rule ID 14936 //
     /* 1128937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1128948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1128951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1128954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1128957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128976 */     // MIs[0] round
     /* 1128976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128986 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1128989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129011 */     // GIR_Coverage, 14936,
     /* 1129011 */     GIR_EraseRootFromParent_Done,
     /* 1129012 */   // Label 16568: @1129012
     /* 1129012 */   GIM_Try, /*On fail goto*//*Label 16569*/ GIMT_Encode4(1129092), // Rule ID 14937 //
     /* 1129017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1129028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1129031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1129034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1129037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129056 */     // MIs[0] round
     /* 1129056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129066 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129091 */     // GIR_Coverage, 14937,
     /* 1129091 */     GIR_EraseRootFromParent_Done,
     /* 1129092 */   // Label 16569: @1129092
     /* 1129092 */   GIM_Try, /*On fail goto*//*Label 16570*/ GIMT_Encode4(1129172), // Rule ID 14940 //
     /* 1129097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1129108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1129111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129136 */     // MIs[0] round
     /* 1129136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129146 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129171 */     // GIR_Coverage, 14940,
     /* 1129171 */     GIR_EraseRootFromParent_Done,
     /* 1129172 */   // Label 16570: @1129172
     /* 1129172 */   GIM_Try, /*On fail goto*//*Label 16571*/ GIMT_Encode4(1129252), // Rule ID 14941 //
     /* 1129177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1129188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1129191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1129194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1129197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129216 */     // MIs[0] round
     /* 1129216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129226 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1129229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129251 */     // GIR_Coverage, 14941,
     /* 1129251 */     GIR_EraseRootFromParent_Done,
     /* 1129252 */   // Label 16571: @1129252
     /* 1129252 */   GIM_Try, /*On fail goto*//*Label 16572*/ GIMT_Encode4(1129332), // Rule ID 14944 //
     /* 1129257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1129268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1129271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1129274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1129277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129296 */     // MIs[0] round
     /* 1129296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129331 */     // GIR_Coverage, 14944,
     /* 1129331 */     GIR_EraseRootFromParent_Done,
     /* 1129332 */   // Label 16572: @1129332
     /* 1129332 */   GIM_Try, /*On fail goto*//*Label 16573*/ GIMT_Encode4(1129412), // Rule ID 14945 //
     /* 1129337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1129348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1129351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1129354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1129357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129376 */     // MIs[0] round
     /* 1129376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129411 */     // GIR_Coverage, 14945,
     /* 1129411 */     GIR_EraseRootFromParent_Done,
     /* 1129412 */   // Label 16573: @1129412
     /* 1129412 */   GIM_Try, /*On fail goto*//*Label 16574*/ GIMT_Encode4(1129492), // Rule ID 14948 //
     /* 1129417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129456 */     // MIs[0] round
     /* 1129456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129491 */     // GIR_Coverage, 14948,
     /* 1129491 */     GIR_EraseRootFromParent_Done,
     /* 1129492 */   // Label 16574: @1129492
     /* 1129492 */   GIM_Try, /*On fail goto*//*Label 16575*/ GIMT_Encode4(1129572), // Rule ID 14949 //
     /* 1129497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1129508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1129511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1129514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1129517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129536 */     // MIs[0] round
     /* 1129536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1129549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129571 */     // GIR_Coverage, 14949,
     /* 1129571 */     GIR_EraseRootFromParent_Done,
     /* 1129572 */   // Label 16575: @1129572
     /* 1129572 */   GIM_Try, /*On fail goto*//*Label 16576*/ GIMT_Encode4(1129652), // Rule ID 14952 //
     /* 1129577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1129588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1129591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1129594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1129597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129616 */     // MIs[0] round
     /* 1129616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129651 */     // GIR_Coverage, 14952,
     /* 1129651 */     GIR_EraseRootFromParent_Done,
     /* 1129652 */   // Label 16576: @1129652
     /* 1129652 */   GIM_Try, /*On fail goto*//*Label 16577*/ GIMT_Encode4(1129732), // Rule ID 14953 //
     /* 1129657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1129668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1129671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1129674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1129677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129696 */     // MIs[0] round
     /* 1129696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129706 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129731 */     // GIR_Coverage, 14953,
     /* 1129731 */     GIR_EraseRootFromParent_Done,
     /* 1129732 */   // Label 16577: @1129732
     /* 1129732 */   GIM_Try, /*On fail goto*//*Label 16578*/ GIMT_Encode4(1129812), // Rule ID 14956 //
     /* 1129737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1129754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129776 */     // MIs[0] round
     /* 1129776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129811 */     // GIR_Coverage, 14956,
     /* 1129811 */     GIR_EraseRootFromParent_Done,
     /* 1129812 */   // Label 16578: @1129812
     /* 1129812 */   GIM_Try, /*On fail goto*//*Label 16579*/ GIMT_Encode4(1129892), // Rule ID 14957 //
     /* 1129817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1129828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1129831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1129834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1129837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129856 */     // MIs[0] round
     /* 1129856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129891 */     // GIR_Coverage, 14957,
     /* 1129891 */     GIR_EraseRootFromParent_Done,
     /* 1129892 */   // Label 16579: @1129892
     /* 1129892 */   GIM_Try, /*On fail goto*//*Label 16580*/ GIMT_Encode4(1129972), // Rule ID 14960 //
     /* 1129897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1129914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129936 */     // MIs[0] round
     /* 1129936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1129949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1129967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129971 */     // GIR_Coverage, 14960,
     /* 1129971 */     GIR_EraseRootFromParent_Done,
     /* 1129972 */   // Label 16580: @1129972
     /* 1129972 */   GIM_Try, /*On fail goto*//*Label 16581*/ GIMT_Encode4(1130052), // Rule ID 14961 //
     /* 1129977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1129988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1129991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1129994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1129997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130016 */     // MIs[0] round
     /* 1130016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130051 */     // GIR_Coverage, 14961,
     /* 1130051 */     GIR_EraseRootFromParent_Done,
     /* 1130052 */   // Label 16581: @1130052
     /* 1130052 */   GIM_Try, /*On fail goto*//*Label 16582*/ GIMT_Encode4(1130132), // Rule ID 14964 //
     /* 1130057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130096 */     // MIs[0] round
     /* 1130096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130131 */     // GIR_Coverage, 14964,
     /* 1130131 */     GIR_EraseRootFromParent_Done,
     /* 1130132 */   // Label 16582: @1130132
     /* 1130132 */   GIM_Try, /*On fail goto*//*Label 16583*/ GIMT_Encode4(1130212), // Rule ID 14965 //
     /* 1130137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1130148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1130151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1130154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1130157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1130176 */     // MIs[0] round
     /* 1130176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1130189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130211 */     // GIR_Coverage, 14965,
     /* 1130211 */     GIR_EraseRootFromParent_Done,
     /* 1130212 */   // Label 16583: @1130212
     /* 1130212 */   GIM_Try, /*On fail goto*//*Label 16584*/ GIMT_Encode4(1130292), // Rule ID 14968 //
     /* 1130217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1130228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1130231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1130234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1130237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130256 */     // MIs[0] round
     /* 1130256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130291 */     // GIR_Coverage, 14968,
     /* 1130291 */     GIR_EraseRootFromParent_Done,
     /* 1130292 */   // Label 16584: @1130292
     /* 1130292 */   GIM_Try, /*On fail goto*//*Label 16585*/ GIMT_Encode4(1130372), // Rule ID 14969 //
     /* 1130297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1130308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1130311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1130314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1130317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130336 */     // MIs[0] round
     /* 1130336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130371 */     // GIR_Coverage, 14969,
     /* 1130371 */     GIR_EraseRootFromParent_Done,
     /* 1130372 */   // Label 16585: @1130372
     /* 1130372 */   GIM_Try, /*On fail goto*//*Label 16586*/ GIMT_Encode4(1130452), // Rule ID 14972 //
     /* 1130377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130416 */     // MIs[0] round
     /* 1130416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130426 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130451 */     // GIR_Coverage, 14972,
     /* 1130451 */     GIR_EraseRootFromParent_Done,
     /* 1130452 */   // Label 16586: @1130452
     /* 1130452 */   GIM_Try, /*On fail goto*//*Label 16587*/ GIMT_Encode4(1130532), // Rule ID 14973 //
     /* 1130457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1130468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1130471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1130474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1130477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130496 */     // MIs[0] round
     /* 1130496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130531 */     // GIR_Coverage, 14973,
     /* 1130531 */     GIR_EraseRootFromParent_Done,
     /* 1130532 */   // Label 16587: @1130532
     /* 1130532 */   GIM_Try, /*On fail goto*//*Label 16588*/ GIMT_Encode4(1130612), // Rule ID 14976 //
     /* 1130537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1130548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1130551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1130554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1130557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130576 */     // MIs[0] round
     /* 1130576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130586 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1130589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130611 */     // GIR_Coverage, 14976,
     /* 1130611 */     GIR_EraseRootFromParent_Done,
     /* 1130612 */   // Label 16588: @1130612
     /* 1130612 */   GIM_Try, /*On fail goto*//*Label 16589*/ GIMT_Encode4(1130692), // Rule ID 14977 //
     /* 1130617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1130628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1130631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1130634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1130637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130656 */     // MIs[0] round
     /* 1130656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130666 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1130669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1130687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130691 */     // GIR_Coverage, 14977,
     /* 1130691 */     GIR_EraseRootFromParent_Done,
     /* 1130692 */   // Label 16589: @1130692
     /* 1130692 */   GIM_Try, /*On fail goto*//*Label 16590*/ GIMT_Encode4(1130772), // Rule ID 14980 //
     /* 1130697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1130708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1130711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1130714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1130717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130736 */     // MIs[0] round
     /* 1130736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130771 */     // GIR_Coverage, 14980,
     /* 1130771 */     GIR_EraseRootFromParent_Done,
     /* 1130772 */   // Label 16590: @1130772
     /* 1130772 */   GIM_Try, /*On fail goto*//*Label 16591*/ GIMT_Encode4(1130852), // Rule ID 14981 //
     /* 1130777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1130788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1130791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1130794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1130797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130816 */     // MIs[0] round
     /* 1130816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1130829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130851 */     // GIR_Coverage, 14981,
     /* 1130851 */     GIR_EraseRootFromParent_Done,
     /* 1130852 */   // Label 16591: @1130852
     /* 1130852 */   GIM_Try, /*On fail goto*//*Label 16592*/ GIMT_Encode4(1130932), // Rule ID 14984 //
     /* 1130857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1130868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1130871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1130874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1130877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130896 */     // MIs[0] round
     /* 1130896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130931 */     // GIR_Coverage, 14984,
     /* 1130931 */     GIR_EraseRootFromParent_Done,
     /* 1130932 */   // Label 16592: @1130932
     /* 1130932 */   GIM_Try, /*On fail goto*//*Label 16593*/ GIMT_Encode4(1131012), // Rule ID 14985 //
     /* 1130937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1130948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1130951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1130954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1130957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130976 */     // MIs[0] round
     /* 1130976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130986 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1130989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131011 */     // GIR_Coverage, 14985,
     /* 1131011 */     GIR_EraseRootFromParent_Done,
     /* 1131012 */   // Label 16593: @1131012
     /* 1131012 */   GIM_Try, /*On fail goto*//*Label 16594*/ GIMT_Encode4(1131092), // Rule ID 14988 //
     /* 1131017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1131028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1131031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1131037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131056 */     // MIs[0] round
     /* 1131056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131066 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131091 */     // GIR_Coverage, 14988,
     /* 1131091 */     GIR_EraseRootFromParent_Done,
     /* 1131092 */   // Label 16594: @1131092
     /* 1131092 */   GIM_Try, /*On fail goto*//*Label 16595*/ GIMT_Encode4(1131172), // Rule ID 14989 //
     /* 1131097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1131108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1131111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1131114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1131117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131136 */     // MIs[0] round
     /* 1131136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131171 */     // GIR_Coverage, 14989,
     /* 1131171 */     GIR_EraseRootFromParent_Done,
     /* 1131172 */   // Label 16595: @1131172
     /* 1131172 */   GIM_Try, /*On fail goto*//*Label 16596*/ GIMT_Encode4(1131252), // Rule ID 14992 //
     /* 1131177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1131197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131216 */     // MIs[0] round
     /* 1131216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131251 */     // GIR_Coverage, 14992,
     /* 1131251 */     GIR_EraseRootFromParent_Done,
     /* 1131252 */   // Label 16596: @1131252
     /* 1131252 */   GIM_Try, /*On fail goto*//*Label 16597*/ GIMT_Encode4(1131332), // Rule ID 14993 //
     /* 1131257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1131268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1131271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1131274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1131277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131296 */     // MIs[0] round
     /* 1131296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131331 */     // GIR_Coverage, 14993,
     /* 1131331 */     GIR_EraseRootFromParent_Done,
     /* 1131332 */   // Label 16597: @1131332
     /* 1131332 */   GIM_Try, /*On fail goto*//*Label 16598*/ GIMT_Encode4(1131412), // Rule ID 14996 //
     /* 1131337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131376 */     // MIs[0] round
     /* 1131376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131386 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131411 */     // GIR_Coverage, 14996,
     /* 1131411 */     GIR_EraseRootFromParent_Done,
     /* 1131412 */   // Label 16598: @1131412
     /* 1131412 */   GIM_Try, /*On fail goto*//*Label 16599*/ GIMT_Encode4(1131492), // Rule ID 14997 //
     /* 1131417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1131428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1131431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1131434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1131437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131456 */     // MIs[0] round
     /* 1131456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131466 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131491 */     // GIR_Coverage, 14997,
     /* 1131491 */     GIR_EraseRootFromParent_Done,
     /* 1131492 */   // Label 16599: @1131492
     /* 1131492 */   GIM_Try, /*On fail goto*//*Label 16600*/ GIMT_Encode4(1131572), // Rule ID 15000 //
     /* 1131497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1131517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131536 */     // MIs[0] round
     /* 1131536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131571 */     // GIR_Coverage, 15000,
     /* 1131571 */     GIR_EraseRootFromParent_Done,
     /* 1131572 */   // Label 16600: @1131572
     /* 1131572 */   GIM_Try, /*On fail goto*//*Label 16601*/ GIMT_Encode4(1131652), // Rule ID 15001 //
     /* 1131577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1131588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1131591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1131594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1131597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1131616 */     // MIs[0] round
     /* 1131616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1131629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131651 */     // GIR_Coverage, 15001,
     /* 1131651 */     GIR_EraseRootFromParent_Done,
     /* 1131652 */   // Label 16601: @1131652
     /* 1131652 */   GIM_Try, /*On fail goto*//*Label 16602*/ GIMT_Encode4(1131732), // Rule ID 15004 //
     /* 1131657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1131668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1131671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1131674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1131677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131696 */     // MIs[0] round
     /* 1131696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131731 */     // GIR_Coverage, 15004,
     /* 1131731 */     GIR_EraseRootFromParent_Done,
     /* 1131732 */   // Label 16602: @1131732
     /* 1131732 */   GIM_Try, /*On fail goto*//*Label 16603*/ GIMT_Encode4(1131812), // Rule ID 15005 //
     /* 1131737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1131748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1131751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1131754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1131757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1131776 */     // MIs[0] round
     /* 1131776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1131789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131811 */     // GIR_Coverage, 15005,
     /* 1131811 */     GIR_EraseRootFromParent_Done,
     /* 1131812 */   // Label 16603: @1131812
     /* 1131812 */   GIM_Try, /*On fail goto*//*Label 16604*/ GIMT_Encode4(1131892), // Rule ID 15008 //
     /* 1131817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1131828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1131831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1131834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1131837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131856 */     // MIs[0] round
     /* 1131856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131891 */     // GIR_Coverage, 15008,
     /* 1131891 */     GIR_EraseRootFromParent_Done,
     /* 1131892 */   // Label 16604: @1131892
     /* 1131892 */   GIM_Try, /*On fail goto*//*Label 16605*/ GIMT_Encode4(1131972), // Rule ID 15009 //
     /* 1131897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1131900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1131908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1131911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1131914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1131917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1131936 */     // MIs[0] round
     /* 1131936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1131949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1131967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131971 */     // GIR_Coverage, 15009,
     /* 1131971 */     GIR_EraseRootFromParent_Done,
     /* 1131972 */   // Label 16605: @1131972
     /* 1131972 */   GIM_Try, /*On fail goto*//*Label 16606*/ GIMT_Encode4(1132052), // Rule ID 15012 //
     /* 1131977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1131980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1131985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1131988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1131991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1131994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1131997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132016 */     // MIs[0] round
     /* 1132016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132026 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132051 */     // GIR_Coverage, 15012,
     /* 1132051 */     GIR_EraseRootFromParent_Done,
     /* 1132052 */   // Label 16606: @1132052
     /* 1132052 */   GIM_Try, /*On fail goto*//*Label 16607*/ GIMT_Encode4(1132132), // Rule ID 15013 //
     /* 1132057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1132068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1132071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1132074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1132077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132096 */     // MIs[0] round
     /* 1132096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132106 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1132109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132131 */     // GIR_Coverage, 15013,
     /* 1132131 */     GIR_EraseRootFromParent_Done,
     /* 1132132 */   // Label 16607: @1132132
     /* 1132132 */   GIM_Try, /*On fail goto*//*Label 16608*/ GIMT_Encode4(1132212), // Rule ID 15016 //
     /* 1132137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132176 */     // MIs[0] round
     /* 1132176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132186 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1132189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132211 */     // GIR_Coverage, 15016,
     /* 1132211 */     GIR_EraseRootFromParent_Done,
     /* 1132212 */   // Label 16608: @1132212
     /* 1132212 */   GIM_Try, /*On fail goto*//*Label 16609*/ GIMT_Encode4(1132292), // Rule ID 15017 //
     /* 1132217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1132228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1132231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1132234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132256 */     // MIs[0] round
     /* 1132256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132266 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1132269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132291 */     // GIR_Coverage, 15017,
     /* 1132291 */     GIR_EraseRootFromParent_Done,
     /* 1132292 */   // Label 16609: @1132292
     /* 1132292 */   GIM_Try, /*On fail goto*//*Label 16610*/ GIMT_Encode4(1132372), // Rule ID 15020 //
     /* 1132297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132336 */     // MIs[0] round
     /* 1132336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132346 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132371 */     // GIR_Coverage, 15020,
     /* 1132371 */     GIR_EraseRootFromParent_Done,
     /* 1132372 */   // Label 16610: @1132372
     /* 1132372 */   GIM_Try, /*On fail goto*//*Label 16611*/ GIMT_Encode4(1132452), // Rule ID 15021 //
     /* 1132377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1132388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1132391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1132394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132416 */     // MIs[0] round
     /* 1132416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132426 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132451 */     // GIR_Coverage, 15021,
     /* 1132451 */     GIR_EraseRootFromParent_Done,
     /* 1132452 */   // Label 16611: @1132452
     /* 1132452 */   GIM_Try, /*On fail goto*//*Label 16612*/ GIMT_Encode4(1132532), // Rule ID 15024 //
     /* 1132457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132496 */     // MIs[0] round
     /* 1132496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132506 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132531 */     // GIR_Coverage, 15024,
     /* 1132531 */     GIR_EraseRootFromParent_Done,
     /* 1132532 */   // Label 16612: @1132532
     /* 1132532 */   GIM_Try, /*On fail goto*//*Label 16613*/ GIMT_Encode4(1132612), // Rule ID 15025 //
     /* 1132537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1132548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1132551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1132554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132576 */     // MIs[0] round
     /* 1132576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132611 */     // GIR_Coverage, 15025,
     /* 1132611 */     GIR_EraseRootFromParent_Done,
     /* 1132612 */   // Label 16613: @1132612
     /* 1132612 */   GIM_Try, /*On fail goto*//*Label 16614*/ GIMT_Encode4(1132692), // Rule ID 15028 //
     /* 1132617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1132628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1132631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132656 */     // MIs[0] round
     /* 1132656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132666 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132691 */     // GIR_Coverage, 15028,
     /* 1132691 */     GIR_EraseRootFromParent_Done,
     /* 1132692 */   // Label 16614: @1132692
     /* 1132692 */   GIM_Try, /*On fail goto*//*Label 16615*/ GIMT_Encode4(1132772), // Rule ID 15029 //
     /* 1132697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1132708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1132711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1132714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132736 */     // MIs[0] round
     /* 1132736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1132749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132771 */     // GIR_Coverage, 15029,
     /* 1132771 */     GIR_EraseRootFromParent_Done,
     /* 1132772 */   // Label 16615: @1132772
     /* 1132772 */   GIM_Try, /*On fail goto*//*Label 16616*/ GIMT_Encode4(1132852), // Rule ID 15032 //
     /* 1132777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1132788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1132791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1132794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132816 */     // MIs[0] round
     /* 1132816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132851 */     // GIR_Coverage, 15032,
     /* 1132851 */     GIR_EraseRootFromParent_Done,
     /* 1132852 */   // Label 16616: @1132852
     /* 1132852 */   GIM_Try, /*On fail goto*//*Label 16617*/ GIMT_Encode4(1132932), // Rule ID 15033 //
     /* 1132857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1132868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1132871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1132874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1132877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132896 */     // MIs[0] round
     /* 1132896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132906 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132931 */     // GIR_Coverage, 15033,
     /* 1132931 */     GIR_EraseRootFromParent_Done,
     /* 1132932 */   // Label 16617: @1132932
     /* 1132932 */   GIM_Try, /*On fail goto*//*Label 16618*/ GIMT_Encode4(1133012), // Rule ID 15036 //
     /* 1132937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1132945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1132948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1132951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1132954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1132957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1132976 */     // MIs[0] round
     /* 1132976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132986 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1132989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133011 */     // GIR_Coverage, 15036,
     /* 1133011 */     GIR_EraseRootFromParent_Done,
     /* 1133012 */   // Label 16618: @1133012
     /* 1133012 */   GIM_Try, /*On fail goto*//*Label 16619*/ GIMT_Encode4(1133092), // Rule ID 15037 //
     /* 1133017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1133028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1133031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1133034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133056 */     // MIs[0] round
     /* 1133056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1133069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133091 */     // GIR_Coverage, 15037,
     /* 1133091 */     GIR_EraseRootFromParent_Done,
     /* 1133092 */   // Label 16619: @1133092
     /* 1133092 */   GIM_Try, /*On fail goto*//*Label 16620*/ GIMT_Encode4(1133172), // Rule ID 15040 //
     /* 1133097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133136 */     // MIs[0] round
     /* 1133136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133146 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133171 */     // GIR_Coverage, 15040,
     /* 1133171 */     GIR_EraseRootFromParent_Done,
     /* 1133172 */   // Label 16620: @1133172
     /* 1133172 */   GIM_Try, /*On fail goto*//*Label 16621*/ GIMT_Encode4(1133252), // Rule ID 15041 //
     /* 1133177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1133188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1133191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1133194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133216 */     // MIs[0] round
     /* 1133216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11140:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133251 */     // GIR_Coverage, 15041,
     /* 1133251 */     GIR_EraseRootFromParent_Done,
     /* 1133252 */   // Label 16621: @1133252
     /* 1133252 */   GIM_Try, /*On fail goto*//*Label 16622*/ GIMT_Encode4(1133332), // Rule ID 15044 //
     /* 1133257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133296 */     // MIs[0] round
     /* 1133296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133306 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133331 */     // GIR_Coverage, 15044,
     /* 1133331 */     GIR_EraseRootFromParent_Done,
     /* 1133332 */   // Label 16622: @1133332
     /* 1133332 */   GIM_Try, /*On fail goto*//*Label 16623*/ GIMT_Encode4(1133412), // Rule ID 15045 //
     /* 1133337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1133348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1133351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1133354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133376 */     // MIs[0] round
     /* 1133376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133411 */     // GIR_Coverage, 15045,
     /* 1133411 */     GIR_EraseRootFromParent_Done,
     /* 1133412 */   // Label 16623: @1133412
     /* 1133412 */   GIM_Try, /*On fail goto*//*Label 16624*/ GIMT_Encode4(1133492), // Rule ID 15048 //
     /* 1133417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133456 */     // MIs[0] round
     /* 1133456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133491 */     // GIR_Coverage, 15048,
     /* 1133491 */     GIR_EraseRootFromParent_Done,
     /* 1133492 */   // Label 16624: @1133492
     /* 1133492 */   GIM_Try, /*On fail goto*//*Label 16625*/ GIMT_Encode4(1133572), // Rule ID 15049 //
     /* 1133497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1133508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1133511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1133514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133536 */     // MIs[0] round
     /* 1133536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133571 */     // GIR_Coverage, 15049,
     /* 1133571 */     GIR_EraseRootFromParent_Done,
     /* 1133572 */   // Label 16625: @1133572
     /* 1133572 */   GIM_Try, /*On fail goto*//*Label 16626*/ GIMT_Encode4(1133652), // Rule ID 15052 //
     /* 1133577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1133580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1133594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133616 */     // MIs[0] round
     /* 1133616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1133647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133651 */     // GIR_Coverage, 15052,
     /* 1133651 */     GIR_EraseRootFromParent_Done,
     /* 1133652 */   // Label 16626: @1133652
     /* 1133652 */   GIM_Try, /*On fail goto*//*Label 16627*/ GIMT_Encode4(1133732), // Rule ID 15053 //
     /* 1133657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1133660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1133668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1133671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1133674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1133692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133696 */     // MIs[0] round
     /* 1133696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1133709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1133727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133731 */     // GIR_Coverage, 15053,
     /* 1133731 */     GIR_EraseRootFromParent_Done,
     /* 1133732 */   // Label 16627: @1133732
     /* 1133732 */   GIM_Try, /*On fail goto*//*Label 16628*/ GIMT_Encode4(1133812), // Rule ID 15056 //
     /* 1133737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1133748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1133751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1133754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133776 */     // MIs[0] round
     /* 1133776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133786 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1133789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133811 */     // GIR_Coverage, 15056,
     /* 1133811 */     GIR_EraseRootFromParent_Done,
     /* 1133812 */   // Label 16628: @1133812
     /* 1133812 */   GIM_Try, /*On fail goto*//*Label 16629*/ GIMT_Encode4(1133892), // Rule ID 15057 //
     /* 1133817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1133828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1133831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1133834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133856 */     // MIs[0] round
     /* 1133856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133866 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1133869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133891 */     // GIR_Coverage, 15057,
     /* 1133891 */     GIR_EraseRootFromParent_Done,
     /* 1133892 */   // Label 16629: @1133892
     /* 1133892 */   GIM_Try, /*On fail goto*//*Label 16630*/ GIMT_Encode4(1133972), // Rule ID 15060 //
     /* 1133897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1133908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1133911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1133914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1133917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1133936 */     // MIs[0] round
     /* 1133936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133946 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1133949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133971 */     // GIR_Coverage, 15060,
     /* 1133971 */     GIR_EraseRootFromParent_Done,
     /* 1133972 */   // Label 16630: @1133972
     /* 1133972 */   GIM_Try, /*On fail goto*//*Label 16631*/ GIMT_Encode4(1134052), // Rule ID 15061 //
     /* 1133977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1133985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1133988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1133991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1133994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1133997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134016 */     // MIs[0] round
     /* 1134016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134026 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134051 */     // GIR_Coverage, 15061,
     /* 1134051 */     GIR_EraseRootFromParent_Done,
     /* 1134052 */   // Label 16631: @1134052
     /* 1134052 */   GIM_Try, /*On fail goto*//*Label 16632*/ GIMT_Encode4(1134132), // Rule ID 15064 //
     /* 1134057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134096 */     // MIs[0] round
     /* 1134096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134106 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134131 */     // GIR_Coverage, 15064,
     /* 1134131 */     GIR_EraseRootFromParent_Done,
     /* 1134132 */   // Label 16632: @1134132
     /* 1134132 */   GIM_Try, /*On fail goto*//*Label 16633*/ GIMT_Encode4(1134212), // Rule ID 15065 //
     /* 1134137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1134148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1134151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1134154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134176 */     // MIs[0] round
     /* 1134176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134186 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134211 */     // GIR_Coverage, 15065,
     /* 1134211 */     GIR_EraseRootFromParent_Done,
     /* 1134212 */   // Label 16633: @1134212
     /* 1134212 */   GIM_Try, /*On fail goto*//*Label 16634*/ GIMT_Encode4(1134292), // Rule ID 15068 //
     /* 1134217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134256 */     // MIs[0] round
     /* 1134256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134266 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134291 */     // GIR_Coverage, 15068,
     /* 1134291 */     GIR_EraseRootFromParent_Done,
     /* 1134292 */   // Label 16634: @1134292
     /* 1134292 */   GIM_Try, /*On fail goto*//*Label 16635*/ GIMT_Encode4(1134372), // Rule ID 15069 //
     /* 1134297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1134308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1134311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1134314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134336 */     // MIs[0] round
     /* 1134336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134371 */     // GIR_Coverage, 15069,
     /* 1134371 */     GIR_EraseRootFromParent_Done,
     /* 1134372 */   // Label 16635: @1134372
     /* 1134372 */   GIM_Try, /*On fail goto*//*Label 16636*/ GIMT_Encode4(1134452), // Rule ID 15072 //
     /* 1134377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134416 */     // MIs[0] round
     /* 1134416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134426 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134451 */     // GIR_Coverage, 15072,
     /* 1134451 */     GIR_EraseRootFromParent_Done,
     /* 1134452 */   // Label 16636: @1134452
     /* 1134452 */   GIM_Try, /*On fail goto*//*Label 16637*/ GIMT_Encode4(1134532), // Rule ID 15073 //
     /* 1134457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1134468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1134471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1134474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134496 */     // MIs[0] round
     /* 1134496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134506 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134531 */     // GIR_Coverage, 15073,
     /* 1134531 */     GIR_EraseRootFromParent_Done,
     /* 1134532 */   // Label 16637: @1134532
     /* 1134532 */   GIM_Try, /*On fail goto*//*Label 16638*/ GIMT_Encode4(1134612), // Rule ID 15076 //
     /* 1134537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1134548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1134551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1134554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134576 */     // MIs[0] round
     /* 1134576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134586 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134611 */     // GIR_Coverage, 15076,
     /* 1134611 */     GIR_EraseRootFromParent_Done,
     /* 1134612 */   // Label 16638: @1134612
     /* 1134612 */   GIM_Try, /*On fail goto*//*Label 16639*/ GIMT_Encode4(1134692), // Rule ID 15077 //
     /* 1134617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1134628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1134631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1134634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134656 */     // MIs[0] round
     /* 1134656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134666 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1134669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1134687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134691 */     // GIR_Coverage, 15077,
     /* 1134691 */     GIR_EraseRootFromParent_Done,
     /* 1134692 */   // Label 16639: @1134692
     /* 1134692 */   GIM_Try, /*On fail goto*//*Label 16640*/ GIMT_Encode4(1134772), // Rule ID 15080 //
     /* 1134697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1134708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1134711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1134714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134736 */     // MIs[0] round
     /* 1134736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134746 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134771 */     // GIR_Coverage, 15080,
     /* 1134771 */     GIR_EraseRootFromParent_Done,
     /* 1134772 */   // Label 16640: @1134772
     /* 1134772 */   GIM_Try, /*On fail goto*//*Label 16641*/ GIMT_Encode4(1134852), // Rule ID 15081 //
     /* 1134777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1134788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1134791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1134794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134816 */     // MIs[0] round
     /* 1134816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1134829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134851 */     // GIR_Coverage, 15081,
     /* 1134851 */     GIR_EraseRootFromParent_Done,
     /* 1134852 */   // Label 16641: @1134852
     /* 1134852 */   GIM_Try, /*On fail goto*//*Label 16642*/ GIMT_Encode4(1134932), // Rule ID 15084 //
     /* 1134857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1134868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1134871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1134874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134896 */     // MIs[0] round
     /* 1134896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134906 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134931 */     // GIR_Coverage, 15084,
     /* 1134931 */     GIR_EraseRootFromParent_Done,
     /* 1134932 */   // Label 16642: @1134932
     /* 1134932 */   GIM_Try, /*On fail goto*//*Label 16643*/ GIMT_Encode4(1135012), // Rule ID 15085 //
     /* 1134937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1134945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1134948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1134951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1134954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134976 */     // MIs[0] round
     /* 1134976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1134989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135011 */     // GIR_Coverage, 15085,
     /* 1135011 */     GIR_EraseRootFromParent_Done,
     /* 1135012 */   // Label 16643: @1135012
     /* 1135012 */   GIM_Try, /*On fail goto*//*Label 16644*/ GIMT_Encode4(1135092), // Rule ID 15088 //
     /* 1135017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135056 */     // MIs[0] round
     /* 1135056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135091 */     // GIR_Coverage, 15088,
     /* 1135091 */     GIR_EraseRootFromParent_Done,
     /* 1135092 */   // Label 16644: @1135092
     /* 1135092 */   GIM_Try, /*On fail goto*//*Label 16645*/ GIMT_Encode4(1135172), // Rule ID 15089 //
     /* 1135097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1135108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1135111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1135114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135136 */     // MIs[0] round
     /* 1135136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135171 */     // GIR_Coverage, 15089,
     /* 1135171 */     GIR_EraseRootFromParent_Done,
     /* 1135172 */   // Label 16645: @1135172
     /* 1135172 */   GIM_Try, /*On fail goto*//*Label 16646*/ GIMT_Encode4(1135252), // Rule ID 15092 //
     /* 1135177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135216 */     // MIs[0] round
     /* 1135216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135226 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135251 */     // GIR_Coverage, 15092,
     /* 1135251 */     GIR_EraseRootFromParent_Done,
     /* 1135252 */   // Label 16646: @1135252
     /* 1135252 */   GIM_Try, /*On fail goto*//*Label 16647*/ GIMT_Encode4(1135332), // Rule ID 15093 //
     /* 1135257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1135268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1135271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1135274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1135292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135296 */     // MIs[0] round
     /* 1135296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1135309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135331 */     // GIR_Coverage, 15093,
     /* 1135331 */     GIR_EraseRootFromParent_Done,
     /* 1135332 */   // Label 16647: @1135332
     /* 1135332 */   GIM_Try, /*On fail goto*//*Label 16648*/ GIMT_Encode4(1135412), // Rule ID 15096 //
     /* 1135337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135376 */     // MIs[0] round
     /* 1135376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135386 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135411 */     // GIR_Coverage, 15096,
     /* 1135411 */     GIR_EraseRootFromParent_Done,
     /* 1135412 */   // Label 16648: @1135412
     /* 1135412 */   GIM_Try, /*On fail goto*//*Label 16649*/ GIMT_Encode4(1135492), // Rule ID 15097 //
     /* 1135417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1135428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1135431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1135434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1135452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135456 */     // MIs[0] round
     /* 1135456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135466 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1135469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135491 */     // GIR_Coverage, 15097,
     /* 1135491 */     GIR_EraseRootFromParent_Done,
     /* 1135492 */   // Label 16649: @1135492
     /* 1135492 */   GIM_Try, /*On fail goto*//*Label 16650*/ GIMT_Encode4(1135572), // Rule ID 15100 //
     /* 1135497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135536 */     // MIs[0] round
     /* 1135536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135546 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135571 */     // GIR_Coverage, 15100,
     /* 1135571 */     GIR_EraseRootFromParent_Done,
     /* 1135572 */   // Label 16650: @1135572
     /* 1135572 */   GIM_Try, /*On fail goto*//*Label 16651*/ GIMT_Encode4(1135652), // Rule ID 15101 //
     /* 1135577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1135580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1135585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1135588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1135591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1135594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1135612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135616 */     // MIs[0] round
     /* 1135616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135626 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1135629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1135647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135651 */     // GIR_Coverage, 15101,
     /* 1135651 */     GIR_EraseRootFromParent_Done,
     /* 1135652 */   // Label 16651: @1135652
     /* 1135652 */   GIM_Try, /*On fail goto*//*Label 16652*/ GIMT_Encode4(1135732), // Rule ID 15104 //
     /* 1135657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1135668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1135671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1135674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1135677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135696 */     // MIs[0] round
     /* 1135696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1135709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135731 */     // GIR_Coverage, 15104,
     /* 1135731 */     GIR_EraseRootFromParent_Done,
     /* 1135732 */   // Label 16652: @1135732
     /* 1135732 */   GIM_Try, /*On fail goto*//*Label 16653*/ GIMT_Encode4(1135812), // Rule ID 15105 //
     /* 1135737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1135748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1135751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1135754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1135757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135776 */     // MIs[0] round
     /* 1135776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135786 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1135789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135811 */     // GIR_Coverage, 15105,
     /* 1135811 */     GIR_EraseRootFromParent_Done,
     /* 1135812 */   // Label 16653: @1135812
     /* 1135812 */   GIM_Try, /*On fail goto*//*Label 16654*/ GIMT_Encode4(1135892), // Rule ID 15108 //
     /* 1135817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1135828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1135831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1135834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1135837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135856 */     // MIs[0] round
     /* 1135856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135866 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1135869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135891 */     // GIR_Coverage, 15108,
     /* 1135891 */     GIR_EraseRootFromParent_Done,
     /* 1135892 */   // Label 16654: @1135892
     /* 1135892 */   GIM_Try, /*On fail goto*//*Label 16655*/ GIMT_Encode4(1135972), // Rule ID 15109 //
     /* 1135897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1135908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1135911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1135914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1135917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135936 */     // MIs[0] round
     /* 1135936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1135949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135971 */     // GIR_Coverage, 15109,
     /* 1135971 */     GIR_EraseRootFromParent_Done,
     /* 1135972 */   // Label 16655: @1135972
     /* 1135972 */   GIM_Try, /*On fail goto*//*Label 16656*/ GIMT_Encode4(1136052), // Rule ID 15112 //
     /* 1135977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1135988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1135991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1135994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1135997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136016 */     // MIs[0] round
     /* 1136016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136051 */     // GIR_Coverage, 15112,
     /* 1136051 */     GIR_EraseRootFromParent_Done,
     /* 1136052 */   // Label 16656: @1136052
     /* 1136052 */   GIM_Try, /*On fail goto*//*Label 16657*/ GIMT_Encode4(1136132), // Rule ID 15113 //
     /* 1136057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1136068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1136071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1136074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1136077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136096 */     // MIs[0] round
     /* 1136096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136131 */     // GIR_Coverage, 15113,
     /* 1136131 */     GIR_EraseRootFromParent_Done,
     /* 1136132 */   // Label 16657: @1136132
     /* 1136132 */   GIM_Try, /*On fail goto*//*Label 16658*/ GIMT_Encode4(1136212), // Rule ID 15116 //
     /* 1136137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1136157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136176 */     // MIs[0] round
     /* 1136176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136211 */     // GIR_Coverage, 15116,
     /* 1136211 */     GIR_EraseRootFromParent_Done,
     /* 1136212 */   // Label 16658: @1136212
     /* 1136212 */   GIM_Try, /*On fail goto*//*Label 16659*/ GIMT_Encode4(1136292), // Rule ID 15117 //
     /* 1136217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1136228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1136231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1136234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1136237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136256 */     // MIs[0] round
     /* 1136256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1136269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136291 */     // GIR_Coverage, 15117,
     /* 1136291 */     GIR_EraseRootFromParent_Done,
     /* 1136292 */   // Label 16659: @1136292
     /* 1136292 */   GIM_Try, /*On fail goto*//*Label 16660*/ GIMT_Encode4(1136372), // Rule ID 15120 //
     /* 1136297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136336 */     // MIs[0] round
     /* 1136336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136346 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136371 */     // GIR_Coverage, 15120,
     /* 1136371 */     GIR_EraseRootFromParent_Done,
     /* 1136372 */   // Label 16660: @1136372
     /* 1136372 */   GIM_Try, /*On fail goto*//*Label 16661*/ GIMT_Encode4(1136452), // Rule ID 15121 //
     /* 1136377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1136388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1136391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1136394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1136397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136416 */     // MIs[0] round
     /* 1136416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136451 */     // GIR_Coverage, 15121,
     /* 1136451 */     GIR_EraseRootFromParent_Done,
     /* 1136452 */   // Label 16661: @1136452
     /* 1136452 */   GIM_Try, /*On fail goto*//*Label 16662*/ GIMT_Encode4(1136532), // Rule ID 15124 //
     /* 1136457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1136477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136496 */     // MIs[0] round
     /* 1136496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136531 */     // GIR_Coverage, 15124,
     /* 1136531 */     GIR_EraseRootFromParent_Done,
     /* 1136532 */   // Label 16662: @1136532
     /* 1136532 */   GIM_Try, /*On fail goto*//*Label 16663*/ GIMT_Encode4(1136612), // Rule ID 15125 //
     /* 1136537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1136548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1136551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1136554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1136557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136576 */     // MIs[0] round
     /* 1136576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1136589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1136607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136611 */     // GIR_Coverage, 15125,
     /* 1136611 */     GIR_EraseRootFromParent_Done,
     /* 1136612 */   // Label 16663: @1136612
     /* 1136612 */   GIM_Try, /*On fail goto*//*Label 16664*/ GIMT_Encode4(1136692), // Rule ID 15128 //
     /* 1136617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1136628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1136631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1136634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1136637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136656 */     // MIs[0] round
     /* 1136656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136666 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136691 */     // GIR_Coverage, 15128,
     /* 1136691 */     GIR_EraseRootFromParent_Done,
     /* 1136692 */   // Label 16664: @1136692
     /* 1136692 */   GIM_Try, /*On fail goto*//*Label 16665*/ GIMT_Encode4(1136772), // Rule ID 15129 //
     /* 1136697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1136708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1136711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1136714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1136717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136736 */     // MIs[0] round
     /* 1136736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136746 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136771 */     // GIR_Coverage, 15129,
     /* 1136771 */     GIR_EraseRootFromParent_Done,
     /* 1136772 */   // Label 16665: @1136772
     /* 1136772 */   GIM_Try, /*On fail goto*//*Label 16666*/ GIMT_Encode4(1136852), // Rule ID 15132 //
     /* 1136777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1136788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1136791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1136794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1136797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136816 */     // MIs[0] round
     /* 1136816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136826 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136851 */     // GIR_Coverage, 15132,
     /* 1136851 */     GIR_EraseRootFromParent_Done,
     /* 1136852 */   // Label 16666: @1136852
     /* 1136852 */   GIM_Try, /*On fail goto*//*Label 16667*/ GIMT_Encode4(1136932), // Rule ID 15133 //
     /* 1136857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1136868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1136871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1136874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1136877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136896 */     // MIs[0] round
     /* 1136896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136931 */     // GIR_Coverage, 15133,
     /* 1136931 */     GIR_EraseRootFromParent_Done,
     /* 1136932 */   // Label 16667: @1136932
     /* 1136932 */   GIM_Try, /*On fail goto*//*Label 16668*/ GIMT_Encode4(1137012), // Rule ID 15136 //
     /* 1136937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1136948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1136951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1136954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1136957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136976 */     // MIs[0] round
     /* 1136976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136986 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1136989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137011 */     // GIR_Coverage, 15136,
     /* 1137011 */     GIR_EraseRootFromParent_Done,
     /* 1137012 */   // Label 16668: @1137012
     /* 1137012 */   GIM_Try, /*On fail goto*//*Label 16669*/ GIMT_Encode4(1137092), // Rule ID 15137 //
     /* 1137017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1137028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1137031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1137034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1137037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137056 */     // MIs[0] round
     /* 1137056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137091 */     // GIR_Coverage, 15137,
     /* 1137091 */     GIR_EraseRootFromParent_Done,
     /* 1137092 */   // Label 16669: @1137092
     /* 1137092 */   GIM_Try, /*On fail goto*//*Label 16670*/ GIMT_Encode4(1137172), // Rule ID 15140 //
     /* 1137097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1137100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1137117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137136 */     // MIs[0] round
     /* 1137136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137171 */     // GIR_Coverage, 15140,
     /* 1137171 */     GIR_EraseRootFromParent_Done,
     /* 1137172 */   // Label 16670: @1137172
     /* 1137172 */   GIM_Try, /*On fail goto*//*Label 16671*/ GIMT_Encode4(1137252), // Rule ID 15141 //
     /* 1137177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1137180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1137188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1137191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1137194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1137197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1137216 */     // MIs[0] round
     /* 1137216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1137229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137251 */     // GIR_Coverage, 15141,
     /* 1137251 */     GIR_EraseRootFromParent_Done,
     /* 1137252 */   // Label 16671: @1137252
     /* 1137252 */   GIM_Try, /*On fail goto*//*Label 16672*/ GIMT_Encode4(1137332), // Rule ID 15144 //
     /* 1137257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1137277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137296 */     // MIs[0] round
     /* 1137296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137306 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137331 */     // GIR_Coverage, 15144,
     /* 1137331 */     GIR_EraseRootFromParent_Done,
     /* 1137332 */   // Label 16672: @1137332
     /* 1137332 */   GIM_Try, /*On fail goto*//*Label 16673*/ GIMT_Encode4(1137412), // Rule ID 15145 //
     /* 1137337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1137348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1137351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1137354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1137357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137376 */     // MIs[0] round
     /* 1137376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137411 */     // GIR_Coverage, 15145,
     /* 1137411 */     GIR_EraseRootFromParent_Done,
     /* 1137412 */   // Label 16673: @1137412
     /* 1137412 */   GIM_Try, /*On fail goto*//*Label 16674*/ GIMT_Encode4(1137492), // Rule ID 15148 //
     /* 1137417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137456 */     // MIs[0] round
     /* 1137456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137466 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137491 */     // GIR_Coverage, 15148,
     /* 1137491 */     GIR_EraseRootFromParent_Done,
     /* 1137492 */   // Label 16674: @1137492
     /* 1137492 */   GIM_Try, /*On fail goto*//*Label 16675*/ GIMT_Encode4(1137572), // Rule ID 15149 //
     /* 1137497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1137508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1137511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1137514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1137517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137536 */     // MIs[0] round
     /* 1137536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137571 */     // GIR_Coverage, 15149,
     /* 1137571 */     GIR_EraseRootFromParent_Done,
     /* 1137572 */   // Label 16675: @1137572
     /* 1137572 */   GIM_Try, /*On fail goto*//*Label 16676*/ GIMT_Encode4(1137652), // Rule ID 15152 //
     /* 1137577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1137588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1137591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1137594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1137597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137616 */     // MIs[0] round
     /* 1137616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137626 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1137629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137651 */     // GIR_Coverage, 15152,
     /* 1137651 */     GIR_EraseRootFromParent_Done,
     /* 1137652 */   // Label 16676: @1137652
     /* 1137652 */   GIM_Try, /*On fail goto*//*Label 16677*/ GIMT_Encode4(1137732), // Rule ID 15153 //
     /* 1137657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1137668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1137671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1137674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1137677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137696 */     // MIs[0] round
     /* 1137696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137706 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1137709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1137727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137731 */     // GIR_Coverage, 15153,
     /* 1137731 */     GIR_EraseRootFromParent_Done,
     /* 1137732 */   // Label 16677: @1137732
     /* 1137732 */   GIM_Try, /*On fail goto*//*Label 16678*/ GIMT_Encode4(1137812), // Rule ID 15156 //
     /* 1137737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1137748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1137751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1137754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1137757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137776 */     // MIs[0] round
     /* 1137776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137786 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137811 */     // GIR_Coverage, 15156,
     /* 1137811 */     GIR_EraseRootFromParent_Done,
     /* 1137812 */   // Label 16678: @1137812
     /* 1137812 */   GIM_Try, /*On fail goto*//*Label 16679*/ GIMT_Encode4(1137892), // Rule ID 15157 //
     /* 1137817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1137828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1137831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1137834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1137837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137856 */     // MIs[0] round
     /* 1137856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1137869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137891 */     // GIR_Coverage, 15157,
     /* 1137891 */     GIR_EraseRootFromParent_Done,
     /* 1137892 */   // Label 16679: @1137892
     /* 1137892 */   GIM_Try, /*On fail goto*//*Label 16680*/ GIMT_Encode4(1137972), // Rule ID 15160 //
     /* 1137897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1137908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1137911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1137914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1137917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137936 */     // MIs[0] round
     /* 1137936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137946 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1137949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137971 */     // GIR_Coverage, 15160,
     /* 1137971 */     GIR_EraseRootFromParent_Done,
     /* 1137972 */   // Label 16680: @1137972
     /* 1137972 */   GIM_Try, /*On fail goto*//*Label 16681*/ GIMT_Encode4(1138052), // Rule ID 15161 //
     /* 1137977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1137988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1137991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1137994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1137997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138016 */     // MIs[0] round
     /* 1138016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138051 */     // GIR_Coverage, 15161,
     /* 1138051 */     GIR_EraseRootFromParent_Done,
     /* 1138052 */   // Label 16681: @1138052
     /* 1138052 */   GIM_Try, /*On fail goto*//*Label 16682*/ GIMT_Encode4(1138132), // Rule ID 15164 //
     /* 1138057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1138077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138096 */     // MIs[0] round
     /* 1138096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138131 */     // GIR_Coverage, 15164,
     /* 1138131 */     GIR_EraseRootFromParent_Done,
     /* 1138132 */   // Label 16682: @1138132
     /* 1138132 */   GIM_Try, /*On fail goto*//*Label 16683*/ GIMT_Encode4(1138212), // Rule ID 15165 //
     /* 1138137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1138148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1138151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1138154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1138157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138176 */     // MIs[0] round
     /* 1138176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138211 */     // GIR_Coverage, 15165,
     /* 1138211 */     GIR_EraseRootFromParent_Done,
     /* 1138212 */   // Label 16683: @1138212
     /* 1138212 */   GIM_Try, /*On fail goto*//*Label 16684*/ GIMT_Encode4(1138292), // Rule ID 15168 //
     /* 1138217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1138237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138256 */     // MIs[0] round
     /* 1138256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138291 */     // GIR_Coverage, 15168,
     /* 1138291 */     GIR_EraseRootFromParent_Done,
     /* 1138292 */   // Label 16684: @1138292
     /* 1138292 */   GIM_Try, /*On fail goto*//*Label 16685*/ GIMT_Encode4(1138372), // Rule ID 15169 //
     /* 1138297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1138308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1138311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1138314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1138317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138336 */     // MIs[0] round
     /* 1138336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138371 */     // GIR_Coverage, 15169,
     /* 1138371 */     GIR_EraseRootFromParent_Done,
     /* 1138372 */   // Label 16685: @1138372
     /* 1138372 */   GIM_Try, /*On fail goto*//*Label 16686*/ GIMT_Encode4(1138452), // Rule ID 15172 //
     /* 1138377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138416 */     // MIs[0] round
     /* 1138416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138426 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138451 */     // GIR_Coverage, 15172,
     /* 1138451 */     GIR_EraseRootFromParent_Done,
     /* 1138452 */   // Label 16686: @1138452
     /* 1138452 */   GIM_Try, /*On fail goto*//*Label 16687*/ GIMT_Encode4(1138532), // Rule ID 15173 //
     /* 1138457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1138468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1138471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1138474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1138477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138496 */     // MIs[0] round
     /* 1138496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138531 */     // GIR_Coverage, 15173,
     /* 1138531 */     GIR_EraseRootFromParent_Done,
     /* 1138532 */   // Label 16687: @1138532
     /* 1138532 */   GIM_Try, /*On fail goto*//*Label 16688*/ GIMT_Encode4(1138612), // Rule ID 15176 //
     /* 1138537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1138548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1138551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1138554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1138557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138576 */     // MIs[0] round
     /* 1138576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138586 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138611 */     // GIR_Coverage, 15176,
     /* 1138611 */     GIR_EraseRootFromParent_Done,
     /* 1138612 */   // Label 16688: @1138612
     /* 1138612 */   GIM_Try, /*On fail goto*//*Label 16689*/ GIMT_Encode4(1138692), // Rule ID 15177 //
     /* 1138617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1138628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1138631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1138634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1138637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1138656 */     // MIs[0] round
     /* 1138656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1138669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138691 */     // GIR_Coverage, 15177,
     /* 1138691 */     GIR_EraseRootFromParent_Done,
     /* 1138692 */   // Label 16689: @1138692
     /* 1138692 */   GIM_Try, /*On fail goto*//*Label 16690*/ GIMT_Encode4(1138772), // Rule ID 15180 //
     /* 1138697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1138700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1138708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1138711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1138714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1138717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138736 */     // MIs[0] round
     /* 1138736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138771 */     // GIR_Coverage, 15180,
     /* 1138771 */     GIR_EraseRootFromParent_Done,
     /* 1138772 */   // Label 16690: @1138772
     /* 1138772 */   GIM_Try, /*On fail goto*//*Label 16691*/ GIMT_Encode4(1138852), // Rule ID 15181 //
     /* 1138777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1138780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1138788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1138791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1138794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1138797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1138816 */     // MIs[0] round
     /* 1138816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1138829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138851 */     // GIR_Coverage, 15181,
     /* 1138851 */     GIR_EraseRootFromParent_Done,
     /* 1138852 */   // Label 16691: @1138852
     /* 1138852 */   GIM_Try, /*On fail goto*//*Label 16692*/ GIMT_Encode4(1138932), // Rule ID 15184 //
     /* 1138857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1138860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1138868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1138871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1138874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1138877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138896 */     // MIs[0] round
     /* 1138896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138931 */     // GIR_Coverage, 15184,
     /* 1138931 */     GIR_EraseRootFromParent_Done,
     /* 1138932 */   // Label 16692: @1138932
     /* 1138932 */   GIM_Try, /*On fail goto*//*Label 16693*/ GIMT_Encode4(1139012), // Rule ID 15185 //
     /* 1138937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1138940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1138945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1138948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1138951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1138954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1138957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1138976 */     // MIs[0] round
     /* 1138976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1138989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139011 */     // GIR_Coverage, 15185,
     /* 1139011 */     GIR_EraseRootFromParent_Done,
     /* 1139012 */   // Label 16693: @1139012
     /* 1139012 */   GIM_Try, /*On fail goto*//*Label 16694*/ GIMT_Encode4(1139092), // Rule ID 15188 //
     /* 1139017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1139037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139056 */     // MIs[0] round
     /* 1139056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139066 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139091 */     // GIR_Coverage, 15188,
     /* 1139091 */     GIR_EraseRootFromParent_Done,
     /* 1139092 */   // Label 16694: @1139092
     /* 1139092 */   GIM_Try, /*On fail goto*//*Label 16695*/ GIMT_Encode4(1139172), // Rule ID 15189 //
     /* 1139097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1139108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1139111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1139114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1139117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139136 */     // MIs[0] round
     /* 1139136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1139149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139171 */     // GIR_Coverage, 15189,
     /* 1139171 */     GIR_EraseRootFromParent_Done,
     /* 1139172 */   // Label 16695: @1139172
     /* 1139172 */   GIM_Try, /*On fail goto*//*Label 16696*/ GIMT_Encode4(1139252), // Rule ID 15192 //
     /* 1139177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139216 */     // MIs[0] round
     /* 1139216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1139229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139251 */     // GIR_Coverage, 15192,
     /* 1139251 */     GIR_EraseRootFromParent_Done,
     /* 1139252 */   // Label 16696: @1139252
     /* 1139252 */   GIM_Try, /*On fail goto*//*Label 16697*/ GIMT_Encode4(1139332), // Rule ID 15193 //
     /* 1139257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1139268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1139271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1139274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139296 */     // MIs[0] round
     /* 1139296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139306 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1139309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139331 */     // GIR_Coverage, 15193,
     /* 1139331 */     GIR_EraseRootFromParent_Done,
     /* 1139332 */   // Label 16697: @1139332
     /* 1139332 */   GIM_Try, /*On fail goto*//*Label 16698*/ GIMT_Encode4(1139412), // Rule ID 15196 //
     /* 1139337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139376 */     // MIs[0] round
     /* 1139376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139386 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139411 */     // GIR_Coverage, 15196,
     /* 1139411 */     GIR_EraseRootFromParent_Done,
     /* 1139412 */   // Label 16698: @1139412
     /* 1139412 */   GIM_Try, /*On fail goto*//*Label 16699*/ GIMT_Encode4(1139492), // Rule ID 15197 //
     /* 1139417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1139428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1139431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1139434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139456 */     // MIs[0] round
     /* 1139456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139491 */     // GIR_Coverage, 15197,
     /* 1139491 */     GIR_EraseRootFromParent_Done,
     /* 1139492 */   // Label 16699: @1139492
     /* 1139492 */   GIM_Try, /*On fail goto*//*Label 16700*/ GIMT_Encode4(1139572), // Rule ID 15200 //
     /* 1139497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139536 */     // MIs[0] round
     /* 1139536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139546 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139571 */     // GIR_Coverage, 15200,
     /* 1139571 */     GIR_EraseRootFromParent_Done,
     /* 1139572 */   // Label 16700: @1139572
     /* 1139572 */   GIM_Try, /*On fail goto*//*Label 16701*/ GIMT_Encode4(1139652), // Rule ID 15201 //
     /* 1139577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1139588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1139591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1139594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139616 */     // MIs[0] round
     /* 1139616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139651 */     // GIR_Coverage, 15201,
     /* 1139651 */     GIR_EraseRootFromParent_Done,
     /* 1139652 */   // Label 16701: @1139652
     /* 1139652 */   GIM_Try, /*On fail goto*//*Label 16702*/ GIMT_Encode4(1139732), // Rule ID 15204 //
     /* 1139657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1139668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1139671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1139674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139696 */     // MIs[0] round
     /* 1139696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139731 */     // GIR_Coverage, 15204,
     /* 1139731 */     GIR_EraseRootFromParent_Done,
     /* 1139732 */   // Label 16702: @1139732
     /* 1139732 */   GIM_Try, /*On fail goto*//*Label 16703*/ GIMT_Encode4(1139812), // Rule ID 15205 //
     /* 1139737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1139748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1139751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1139754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139776 */     // MIs[0] round
     /* 1139776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1139789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139811 */     // GIR_Coverage, 15205,
     /* 1139811 */     GIR_EraseRootFromParent_Done,
     /* 1139812 */   // Label 16703: @1139812
     /* 1139812 */   GIM_Try, /*On fail goto*//*Label 16704*/ GIMT_Encode4(1139892), // Rule ID 15208 //
     /* 1139817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1139828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1139831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1139834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139856 */     // MIs[0] round
     /* 1139856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139891 */     // GIR_Coverage, 15208,
     /* 1139891 */     GIR_EraseRootFromParent_Done,
     /* 1139892 */   // Label 16704: @1139892
     /* 1139892 */   GIM_Try, /*On fail goto*//*Label 16705*/ GIMT_Encode4(1139972), // Rule ID 15209 //
     /* 1139897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1139908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1139911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1139914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1139917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1139936 */     // MIs[0] round
     /* 1139936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139946 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1139949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139971 */     // GIR_Coverage, 15209,
     /* 1139971 */     GIR_EraseRootFromParent_Done,
     /* 1139972 */   // Label 16705: @1139972
     /* 1139972 */   GIM_Try, /*On fail goto*//*Label 16706*/ GIMT_Encode4(1140052), // Rule ID 15212 //
     /* 1139977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1139985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1139988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1139991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1139994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1139997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140016 */     // MIs[0] round
     /* 1140016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140051 */     // GIR_Coverage, 15212,
     /* 1140051 */     GIR_EraseRootFromParent_Done,
     /* 1140052 */   // Label 16706: @1140052
     /* 1140052 */   GIM_Try, /*On fail goto*//*Label 16707*/ GIMT_Encode4(1140132), // Rule ID 15213 //
     /* 1140057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1140068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1140071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1140074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140096 */     // MIs[0] round
     /* 1140096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1140109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140131 */     // GIR_Coverage, 15213,
     /* 1140131 */     GIR_EraseRootFromParent_Done,
     /* 1140132 */   // Label 16707: @1140132
     /* 1140132 */   GIM_Try, /*On fail goto*//*Label 16708*/ GIMT_Encode4(1140212), // Rule ID 15216 //
     /* 1140137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140176 */     // MIs[0] round
     /* 1140176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140186 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140211 */     // GIR_Coverage, 15216,
     /* 1140211 */     GIR_EraseRootFromParent_Done,
     /* 1140212 */   // Label 16708: @1140212
     /* 1140212 */   GIM_Try, /*On fail goto*//*Label 16709*/ GIMT_Encode4(1140292), // Rule ID 15217 //
     /* 1140217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1140228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1140231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1140234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140256 */     // MIs[0] round
     /* 1140256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140291 */     // GIR_Coverage, 15217,
     /* 1140291 */     GIR_EraseRootFromParent_Done,
     /* 1140292 */   // Label 16709: @1140292
     /* 1140292 */   GIM_Try, /*On fail goto*//*Label 16710*/ GIMT_Encode4(1140372), // Rule ID 15220 //
     /* 1140297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140336 */     // MIs[0] round
     /* 1140336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140346 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140371 */     // GIR_Coverage, 15220,
     /* 1140371 */     GIR_EraseRootFromParent_Done,
     /* 1140372 */   // Label 16710: @1140372
     /* 1140372 */   GIM_Try, /*On fail goto*//*Label 16711*/ GIMT_Encode4(1140452), // Rule ID 15221 //
     /* 1140377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1140388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1140391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1140394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140416 */     // MIs[0] round
     /* 1140416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140426 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140451 */     // GIR_Coverage, 15221,
     /* 1140451 */     GIR_EraseRootFromParent_Done,
     /* 1140452 */   // Label 16711: @1140452
     /* 1140452 */   GIM_Try, /*On fail goto*//*Label 16712*/ GIMT_Encode4(1140532), // Rule ID 15224 //
     /* 1140457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140496 */     // MIs[0] round
     /* 1140496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140506 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140531 */     // GIR_Coverage, 15224,
     /* 1140531 */     GIR_EraseRootFromParent_Done,
     /* 1140532 */   // Label 16712: @1140532
     /* 1140532 */   GIM_Try, /*On fail goto*//*Label 16713*/ GIMT_Encode4(1140612), // Rule ID 15225 //
     /* 1140537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1140548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1140551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1140554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140576 */     // MIs[0] round
     /* 1140576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140611 */     // GIR_Coverage, 15225,
     /* 1140611 */     GIR_EraseRootFromParent_Done,
     /* 1140612 */   // Label 16713: @1140612
     /* 1140612 */   GIM_Try, /*On fail goto*//*Label 16714*/ GIMT_Encode4(1140692), // Rule ID 15228 //
     /* 1140617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1140620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1140628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1140631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1140634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140656 */     // MIs[0] round
     /* 1140656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140666 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1140687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140691 */     // GIR_Coverage, 15228,
     /* 1140691 */     GIR_EraseRootFromParent_Done,
     /* 1140692 */   // Label 16714: @1140692
     /* 1140692 */   GIM_Try, /*On fail goto*//*Label 16715*/ GIMT_Encode4(1140772), // Rule ID 15229 //
     /* 1140697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1140700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1140708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1140711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1140714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1140732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140736 */     // MIs[0] round
     /* 1140736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1140749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1140767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140771 */     // GIR_Coverage, 15229,
     /* 1140771 */     GIR_EraseRootFromParent_Done,
     /* 1140772 */   // Label 16715: @1140772
     /* 1140772 */   GIM_Try, /*On fail goto*//*Label 16716*/ GIMT_Encode4(1140852), // Rule ID 15232 //
     /* 1140777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1140788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1140791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1140794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140816 */     // MIs[0] round
     /* 1140816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1140829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140851 */     // GIR_Coverage, 15232,
     /* 1140851 */     GIR_EraseRootFromParent_Done,
     /* 1140852 */   // Label 16716: @1140852
     /* 1140852 */   GIM_Try, /*On fail goto*//*Label 16717*/ GIMT_Encode4(1140932), // Rule ID 15233 //
     /* 1140857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1140868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1140871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1140874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1140877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140896 */     // MIs[0] round
     /* 1140896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140906 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1140909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140931 */     // GIR_Coverage, 15233,
     /* 1140931 */     GIR_EraseRootFromParent_Done,
     /* 1140932 */   // Label 16717: @1140932
     /* 1140932 */   GIM_Try, /*On fail goto*//*Label 16718*/ GIMT_Encode4(1141012), // Rule ID 15236 //
     /* 1140937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1140945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1140948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1140951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1140954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1140957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1140976 */     // MIs[0] round
     /* 1140976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140986 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1140989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141011 */     // GIR_Coverage, 15236,
     /* 1141011 */     GIR_EraseRootFromParent_Done,
     /* 1141012 */   // Label 16718: @1141012
     /* 1141012 */   GIM_Try, /*On fail goto*//*Label 16719*/ GIMT_Encode4(1141092), // Rule ID 15237 //
     /* 1141017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1141028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1141031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1141034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141056 */     // MIs[0] round
     /* 1141056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141066 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141091 */     // GIR_Coverage, 15237,
     /* 1141091 */     GIR_EraseRootFromParent_Done,
     /* 1141092 */   // Label 16719: @1141092
     /* 1141092 */   GIM_Try, /*On fail goto*//*Label 16720*/ GIMT_Encode4(1141172), // Rule ID 15240 //
     /* 1141097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141136 */     // MIs[0] round
     /* 1141136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141146 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141171 */     // GIR_Coverage, 15240,
     /* 1141171 */     GIR_EraseRootFromParent_Done,
     /* 1141172 */   // Label 16720: @1141172
     /* 1141172 */   GIM_Try, /*On fail goto*//*Label 16721*/ GIMT_Encode4(1141252), // Rule ID 15241 //
     /* 1141177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1141188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1141191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1141194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141216 */     // MIs[0] round
     /* 1141216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141226 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141251 */     // GIR_Coverage, 15241,
     /* 1141251 */     GIR_EraseRootFromParent_Done,
     /* 1141252 */   // Label 16721: @1141252
     /* 1141252 */   GIM_Try, /*On fail goto*//*Label 16722*/ GIMT_Encode4(1141332), // Rule ID 15244 //
     /* 1141257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141296 */     // MIs[0] round
     /* 1141296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141331 */     // GIR_Coverage, 15244,
     /* 1141331 */     GIR_EraseRootFromParent_Done,
     /* 1141332 */   // Label 16722: @1141332
     /* 1141332 */   GIM_Try, /*On fail goto*//*Label 16723*/ GIMT_Encode4(1141412), // Rule ID 15245 //
     /* 1141337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1141348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1141351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1141354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141376 */     // MIs[0] round
     /* 1141376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141411 */     // GIR_Coverage, 15245,
     /* 1141411 */     GIR_EraseRootFromParent_Done,
     /* 1141412 */   // Label 16723: @1141412
     /* 1141412 */   GIM_Try, /*On fail goto*//*Label 16724*/ GIMT_Encode4(1141492), // Rule ID 15248 //
     /* 1141417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141456 */     // MIs[0] round
     /* 1141456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141491 */     // GIR_Coverage, 15248,
     /* 1141491 */     GIR_EraseRootFromParent_Done,
     /* 1141492 */   // Label 16724: @1141492
     /* 1141492 */   GIM_Try, /*On fail goto*//*Label 16725*/ GIMT_Encode4(1141572), // Rule ID 15249 //
     /* 1141497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1141508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1141511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1141514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141536 */     // MIs[0] round
     /* 1141536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141571 */     // GIR_Coverage, 15249,
     /* 1141571 */     GIR_EraseRootFromParent_Done,
     /* 1141572 */   // Label 16725: @1141572
     /* 1141572 */   GIM_Try, /*On fail goto*//*Label 16726*/ GIMT_Encode4(1141652), // Rule ID 15252 //
     /* 1141577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1141588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1141591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1141594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141616 */     // MIs[0] round
     /* 1141616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141651 */     // GIR_Coverage, 15252,
     /* 1141651 */     GIR_EraseRootFromParent_Done,
     /* 1141652 */   // Label 16726: @1141652
     /* 1141652 */   GIM_Try, /*On fail goto*//*Label 16727*/ GIMT_Encode4(1141732), // Rule ID 15253 //
     /* 1141657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1141668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1141671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1141674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141696 */     // MIs[0] round
     /* 1141696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1141709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1141727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141731 */     // GIR_Coverage, 15253,
     /* 1141731 */     GIR_EraseRootFromParent_Done,
     /* 1141732 */   // Label 16727: @1141732
     /* 1141732 */   GIM_Try, /*On fail goto*//*Label 16728*/ GIMT_Encode4(1141812), // Rule ID 15256 //
     /* 1141737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1141748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1141751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1141754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141776 */     // MIs[0] round
     /* 1141776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141811 */     // GIR_Coverage, 15256,
     /* 1141811 */     GIR_EraseRootFromParent_Done,
     /* 1141812 */   // Label 16728: @1141812
     /* 1141812 */   GIM_Try, /*On fail goto*//*Label 16729*/ GIMT_Encode4(1141892), // Rule ID 15257 //
     /* 1141817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1141828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1141831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1141834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141856 */     // MIs[0] round
     /* 1141856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1141869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141891 */     // GIR_Coverage, 15257,
     /* 1141891 */     GIR_EraseRootFromParent_Done,
     /* 1141892 */   // Label 16729: @1141892
     /* 1141892 */   GIM_Try, /*On fail goto*//*Label 16730*/ GIMT_Encode4(1141972), // Rule ID 15260 //
     /* 1141897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1141908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1141911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1141914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141936 */     // MIs[0] round
     /* 1141936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141946 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1141949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141971 */     // GIR_Coverage, 15260,
     /* 1141971 */     GIR_EraseRootFromParent_Done,
     /* 1141972 */   // Label 16730: @1141972
     /* 1141972 */   GIM_Try, /*On fail goto*//*Label 16731*/ GIMT_Encode4(1142052), // Rule ID 15261 //
     /* 1141977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1141985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1141988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1141991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1141994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142016 */     // MIs[0] round
     /* 1142016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142051 */     // GIR_Coverage, 15261,
     /* 1142051 */     GIR_EraseRootFromParent_Done,
     /* 1142052 */   // Label 16731: @1142052
     /* 1142052 */   GIM_Try, /*On fail goto*//*Label 16732*/ GIMT_Encode4(1142132), // Rule ID 15264 //
     /* 1142057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142096 */     // MIs[0] round
     /* 1142096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142131 */     // GIR_Coverage, 15264,
     /* 1142131 */     GIR_EraseRootFromParent_Done,
     /* 1142132 */   // Label 16732: @1142132
     /* 1142132 */   GIM_Try, /*On fail goto*//*Label 16733*/ GIMT_Encode4(1142212), // Rule ID 15265 //
     /* 1142137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1142148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1142151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1142154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142176 */     // MIs[0] round
     /* 1142176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142211 */     // GIR_Coverage, 15265,
     /* 1142211 */     GIR_EraseRootFromParent_Done,
     /* 1142212 */   // Label 16733: @1142212
     /* 1142212 */   GIM_Try, /*On fail goto*//*Label 16734*/ GIMT_Encode4(1142292), // Rule ID 15268 //
     /* 1142217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142256 */     // MIs[0] round
     /* 1142256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142266 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142291 */     // GIR_Coverage, 15268,
     /* 1142291 */     GIR_EraseRootFromParent_Done,
     /* 1142292 */   // Label 16734: @1142292
     /* 1142292 */   GIM_Try, /*On fail goto*//*Label 16735*/ GIMT_Encode4(1142372), // Rule ID 15269 //
     /* 1142297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1142308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1142311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1142314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1142332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142336 */     // MIs[0] round
     /* 1142336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1142349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142371 */     // GIR_Coverage, 15269,
     /* 1142371 */     GIR_EraseRootFromParent_Done,
     /* 1142372 */   // Label 16735: @1142372
     /* 1142372 */   GIM_Try, /*On fail goto*//*Label 16736*/ GIMT_Encode4(1142452), // Rule ID 15272 //
     /* 1142377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142416 */     // MIs[0] round
     /* 1142416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142426 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142451 */     // GIR_Coverage, 15272,
     /* 1142451 */     GIR_EraseRootFromParent_Done,
     /* 1142452 */   // Label 16736: @1142452
     /* 1142452 */   GIM_Try, /*On fail goto*//*Label 16737*/ GIMT_Encode4(1142532), // Rule ID 15273 //
     /* 1142457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1142468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1142471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1142474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1142492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142496 */     // MIs[0] round
     /* 1142496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142506 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1142509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142531 */     // GIR_Coverage, 15273,
     /* 1142531 */     GIR_EraseRootFromParent_Done,
     /* 1142532 */   // Label 16737: @1142532
     /* 1142532 */   GIM_Try, /*On fail goto*//*Label 16738*/ GIMT_Encode4(1142612), // Rule ID 15276 //
     /* 1142537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1142548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1142551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1142554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142576 */     // MIs[0] round
     /* 1142576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142586 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142611 */     // GIR_Coverage, 15276,
     /* 1142611 */     GIR_EraseRootFromParent_Done,
     /* 1142612 */   // Label 16738: @1142612
     /* 1142612 */   GIM_Try, /*On fail goto*//*Label 16739*/ GIMT_Encode4(1142692), // Rule ID 15277 //
     /* 1142617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1142620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1142625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1142628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1142631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1142634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1142652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142656 */     // MIs[0] round
     /* 1142656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142666 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11162:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1142669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1142687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142691 */     // GIR_Coverage, 15277,
     /* 1142691 */     GIR_EraseRootFromParent_Done,
     /* 1142692 */   // Label 16739: @1142692
     /* 1142692 */   GIM_Try, /*On fail goto*//*Label 16740*/ GIMT_Encode4(1142772), // Rule ID 15280 //
     /* 1142697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1142708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1142711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1142714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1142717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142736 */     // MIs[0] round
     /* 1142736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142746 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1142749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142771 */     // GIR_Coverage, 15280,
     /* 1142771 */     GIR_EraseRootFromParent_Done,
     /* 1142772 */   // Label 16740: @1142772
     /* 1142772 */   GIM_Try, /*On fail goto*//*Label 16741*/ GIMT_Encode4(1142852), // Rule ID 15281 //
     /* 1142777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1142788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1142791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1142794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1142797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142816 */     // MIs[0] round
     /* 1142816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142826 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1142829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142851 */     // GIR_Coverage, 15281,
     /* 1142851 */     GIR_EraseRootFromParent_Done,
     /* 1142852 */   // Label 16741: @1142852
     /* 1142852 */   GIM_Try, /*On fail goto*//*Label 16742*/ GIMT_Encode4(1142932), // Rule ID 15284 //
     /* 1142857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1142868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1142871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1142874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1142877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142896 */     // MIs[0] round
     /* 1142896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142906 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1142909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142931 */     // GIR_Coverage, 15284,
     /* 1142931 */     GIR_EraseRootFromParent_Done,
     /* 1142932 */   // Label 16742: @1142932
     /* 1142932 */   GIM_Try, /*On fail goto*//*Label 16743*/ GIMT_Encode4(1143012), // Rule ID 15285 //
     /* 1142937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1142948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1142951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1142954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1142957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142976 */     // MIs[0] round
     /* 1142976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142986 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1142989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143011 */     // GIR_Coverage, 15285,
     /* 1143011 */     GIR_EraseRootFromParent_Done,
     /* 1143012 */   // Label 16743: @1143012
     /* 1143012 */   GIM_Try, /*On fail goto*//*Label 16744*/ GIMT_Encode4(1143092), // Rule ID 15288 //
     /* 1143017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1143037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143056 */     // MIs[0] round
     /* 1143056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143066 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143091 */     // GIR_Coverage, 15288,
     /* 1143091 */     GIR_EraseRootFromParent_Done,
     /* 1143092 */   // Label 16744: @1143092
     /* 1143092 */   GIM_Try, /*On fail goto*//*Label 16745*/ GIMT_Encode4(1143172), // Rule ID 15289 //
     /* 1143097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1143108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1143111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1143114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1143117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143136 */     // MIs[0] round
     /* 1143136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143146 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143171 */     // GIR_Coverage, 15289,
     /* 1143171 */     GIR_EraseRootFromParent_Done,
     /* 1143172 */   // Label 16745: @1143172
     /* 1143172 */   GIM_Try, /*On fail goto*//*Label 16746*/ GIMT_Encode4(1143252), // Rule ID 15292 //
     /* 1143177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1143197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143216 */     // MIs[0] round
     /* 1143216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143226 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143251 */     // GIR_Coverage, 15292,
     /* 1143251 */     GIR_EraseRootFromParent_Done,
     /* 1143252 */   // Label 16746: @1143252
     /* 1143252 */   GIM_Try, /*On fail goto*//*Label 16747*/ GIMT_Encode4(1143332), // Rule ID 15293 //
     /* 1143257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1143268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1143271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1143274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1143277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143296 */     // MIs[0] round
     /* 1143296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143306 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1143309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143331 */     // GIR_Coverage, 15293,
     /* 1143331 */     GIR_EraseRootFromParent_Done,
     /* 1143332 */   // Label 16747: @1143332
     /* 1143332 */   GIM_Try, /*On fail goto*//*Label 16748*/ GIMT_Encode4(1143412), // Rule ID 15296 //
     /* 1143337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143376 */     // MIs[0] round
     /* 1143376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143411 */     // GIR_Coverage, 15296,
     /* 1143411 */     GIR_EraseRootFromParent_Done,
     /* 1143412 */   // Label 16748: @1143412
     /* 1143412 */   GIM_Try, /*On fail goto*//*Label 16749*/ GIMT_Encode4(1143492), // Rule ID 15297 //
     /* 1143417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1143428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1143431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1143434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1143437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143456 */     // MIs[0] round
     /* 1143456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143466 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143491 */     // GIR_Coverage, 15297,
     /* 1143491 */     GIR_EraseRootFromParent_Done,
     /* 1143492 */   // Label 16749: @1143492
     /* 1143492 */   GIM_Try, /*On fail goto*//*Label 16750*/ GIMT_Encode4(1143572), // Rule ID 15300 //
     /* 1143497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1143517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143536 */     // MIs[0] round
     /* 1143536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143546 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143571 */     // GIR_Coverage, 15300,
     /* 1143571 */     GIR_EraseRootFromParent_Done,
     /* 1143572 */   // Label 16750: @1143572
     /* 1143572 */   GIM_Try, /*On fail goto*//*Label 16751*/ GIMT_Encode4(1143652), // Rule ID 15301 //
     /* 1143577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1143588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1143591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1143594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1143597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143616 */     // MIs[0] round
     /* 1143616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143626 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1143629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1143647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143651 */     // GIR_Coverage, 15301,
     /* 1143651 */     GIR_EraseRootFromParent_Done,
     /* 1143652 */   // Label 16751: @1143652
     /* 1143652 */   GIM_Try, /*On fail goto*//*Label 16752*/ GIMT_Encode4(1143732), // Rule ID 15304 //
     /* 1143657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1143668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1143671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1143674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1143677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143696 */     // MIs[0] round
     /* 1143696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143706 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143731 */     // GIR_Coverage, 15304,
     /* 1143731 */     GIR_EraseRootFromParent_Done,
     /* 1143732 */   // Label 16752: @1143732
     /* 1143732 */   GIM_Try, /*On fail goto*//*Label 16753*/ GIMT_Encode4(1143812), // Rule ID 15305 //
     /* 1143737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1143748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1143751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1143754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1143757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143776 */     // MIs[0] round
     /* 1143776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143786 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143811 */     // GIR_Coverage, 15305,
     /* 1143811 */     GIR_EraseRootFromParent_Done,
     /* 1143812 */   // Label 16753: @1143812
     /* 1143812 */   GIM_Try, /*On fail goto*//*Label 16754*/ GIMT_Encode4(1143892), // Rule ID 15308 //
     /* 1143817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1143828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1143831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1143834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1143837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143856 */     // MIs[0] round
     /* 1143856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143891 */     // GIR_Coverage, 15308,
     /* 1143891 */     GIR_EraseRootFromParent_Done,
     /* 1143892 */   // Label 16754: @1143892
     /* 1143892 */   GIM_Try, /*On fail goto*//*Label 16755*/ GIMT_Encode4(1143972), // Rule ID 15309 //
     /* 1143897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1143908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1143911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1143914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1143917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143936 */     // MIs[0] round
     /* 1143936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1143949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143971 */     // GIR_Coverage, 15309,
     /* 1143971 */     GIR_EraseRootFromParent_Done,
     /* 1143972 */   // Label 16755: @1143972
     /* 1143972 */   GIM_Try, /*On fail goto*//*Label 16756*/ GIMT_Encode4(1144052), // Rule ID 15312 //
     /* 1143977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1143988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1143991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1143994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1143997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144016 */     // MIs[0] round
     /* 1144016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144051 */     // GIR_Coverage, 15312,
     /* 1144051 */     GIR_EraseRootFromParent_Done,
     /* 1144052 */   // Label 16756: @1144052
     /* 1144052 */   GIM_Try, /*On fail goto*//*Label 16757*/ GIMT_Encode4(1144132), // Rule ID 15313 //
     /* 1144057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1144068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1144071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1144074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1144077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144096 */     // MIs[0] round
     /* 1144096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144106 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144131 */     // GIR_Coverage, 15313,
     /* 1144131 */     GIR_EraseRootFromParent_Done,
     /* 1144132 */   // Label 16757: @1144132
     /* 1144132 */   GIM_Try, /*On fail goto*//*Label 16758*/ GIMT_Encode4(1144212), // Rule ID 15316 //
     /* 1144137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1144157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144176 */     // MIs[0] round
     /* 1144176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144211 */     // GIR_Coverage, 15316,
     /* 1144211 */     GIR_EraseRootFromParent_Done,
     /* 1144212 */   // Label 16758: @1144212
     /* 1144212 */   GIM_Try, /*On fail goto*//*Label 16759*/ GIMT_Encode4(1144292), // Rule ID 15317 //
     /* 1144217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1144228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1144231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1144234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1144237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1144256 */     // MIs[0] round
     /* 1144256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144266 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1144269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144291 */     // GIR_Coverage, 15317,
     /* 1144291 */     GIR_EraseRootFromParent_Done,
     /* 1144292 */   // Label 16759: @1144292
     /* 1144292 */   GIM_Try, /*On fail goto*//*Label 16760*/ GIMT_Encode4(1144372), // Rule ID 15320 //
     /* 1144297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144336 */     // MIs[0] round
     /* 1144336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144371 */     // GIR_Coverage, 15320,
     /* 1144371 */     GIR_EraseRootFromParent_Done,
     /* 1144372 */   // Label 16760: @1144372
     /* 1144372 */   GIM_Try, /*On fail goto*//*Label 16761*/ GIMT_Encode4(1144452), // Rule ID 15321 //
     /* 1144377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1144388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1144391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1144394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1144397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144416 */     // MIs[0] round
     /* 1144416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144451 */     // GIR_Coverage, 15321,
     /* 1144451 */     GIR_EraseRootFromParent_Done,
     /* 1144452 */   // Label 16761: @1144452
     /* 1144452 */   GIM_Try, /*On fail goto*//*Label 16762*/ GIMT_Encode4(1144532), // Rule ID 15324 //
     /* 1144457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1144477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144496 */     // MIs[0] round
     /* 1144496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144531 */     // GIR_Coverage, 15324,
     /* 1144531 */     GIR_EraseRootFromParent_Done,
     /* 1144532 */   // Label 16762: @1144532
     /* 1144532 */   GIM_Try, /*On fail goto*//*Label 16763*/ GIMT_Encode4(1144612), // Rule ID 15325 //
     /* 1144537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1144548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1144551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1144554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1144557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144576 */     // MIs[0] round
     /* 1144576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144586 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144611 */     // GIR_Coverage, 15325,
     /* 1144611 */     GIR_EraseRootFromParent_Done,
     /* 1144612 */   // Label 16763: @1144612
     /* 1144612 */   GIM_Try, /*On fail goto*//*Label 16764*/ GIMT_Encode4(1144692), // Rule ID 15328 //
     /* 1144617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1144628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1144631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1144634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1144637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144656 */     // MIs[0] round
     /* 1144656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144666 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1144669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144691 */     // GIR_Coverage, 15328,
     /* 1144691 */     GIR_EraseRootFromParent_Done,
     /* 1144692 */   // Label 16764: @1144692
     /* 1144692 */   GIM_Try, /*On fail goto*//*Label 16765*/ GIMT_Encode4(1144772), // Rule ID 15329 //
     /* 1144697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1144708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1144711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1144714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1144717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144736 */     // MIs[0] round
     /* 1144736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144746 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1144749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1144767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144771 */     // GIR_Coverage, 15329,
     /* 1144771 */     GIR_EraseRootFromParent_Done,
     /* 1144772 */   // Label 16765: @1144772
     /* 1144772 */   GIM_Try, /*On fail goto*//*Label 16766*/ GIMT_Encode4(1144852), // Rule ID 15332 //
     /* 1144777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1144788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1144791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1144794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1144797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144816 */     // MIs[0] round
     /* 1144816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144851 */     // GIR_Coverage, 15332,
     /* 1144851 */     GIR_EraseRootFromParent_Done,
     /* 1144852 */   // Label 16766: @1144852
     /* 1144852 */   GIM_Try, /*On fail goto*//*Label 16767*/ GIMT_Encode4(1144932), // Rule ID 15333 //
     /* 1144857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1144868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1144871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1144874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1144877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144896 */     // MIs[0] round
     /* 1144896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1144909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144931 */     // GIR_Coverage, 15333,
     /* 1144931 */     GIR_EraseRootFromParent_Done,
     /* 1144932 */   // Label 16767: @1144932
     /* 1144932 */   GIM_Try, /*On fail goto*//*Label 16768*/ GIMT_Encode4(1145012), // Rule ID 15336 //
     /* 1144937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1144948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1144951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1144954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1144957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144976 */     // MIs[0] round
     /* 1144976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144986 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1144989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145011 */     // GIR_Coverage, 15336,
     /* 1145011 */     GIR_EraseRootFromParent_Done,
     /* 1145012 */   // Label 16768: @1145012
     /* 1145012 */   GIM_Try, /*On fail goto*//*Label 16769*/ GIMT_Encode4(1145092), // Rule ID 15337 //
     /* 1145017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1145028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1145031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1145034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1145037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145056 */     // MIs[0] round
     /* 1145056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145066 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145091 */     // GIR_Coverage, 15337,
     /* 1145091 */     GIR_EraseRootFromParent_Done,
     /* 1145092 */   // Label 16769: @1145092
     /* 1145092 */   GIM_Try, /*On fail goto*//*Label 16770*/ GIMT_Encode4(1145172), // Rule ID 15340 //
     /* 1145097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1145117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145136 */     // MIs[0] round
     /* 1145136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145171 */     // GIR_Coverage, 15340,
     /* 1145171 */     GIR_EraseRootFromParent_Done,
     /* 1145172 */   // Label 16770: @1145172
     /* 1145172 */   GIM_Try, /*On fail goto*//*Label 16771*/ GIMT_Encode4(1145252), // Rule ID 15341 //
     /* 1145177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1145188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1145191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1145194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1145197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145216 */     // MIs[0] round
     /* 1145216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145251 */     // GIR_Coverage, 15341,
     /* 1145251 */     GIR_EraseRootFromParent_Done,
     /* 1145252 */   // Label 16771: @1145252
     /* 1145252 */   GIM_Try, /*On fail goto*//*Label 16772*/ GIMT_Encode4(1145332), // Rule ID 15344 //
     /* 1145257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1145277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145296 */     // MIs[0] round
     /* 1145296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145306 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145331 */     // GIR_Coverage, 15344,
     /* 1145331 */     GIR_EraseRootFromParent_Done,
     /* 1145332 */   // Label 16772: @1145332
     /* 1145332 */   GIM_Try, /*On fail goto*//*Label 16773*/ GIMT_Encode4(1145412), // Rule ID 15345 //
     /* 1145337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1145348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1145351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1145354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1145357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145376 */     // MIs[0] round
     /* 1145376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145411 */     // GIR_Coverage, 15345,
     /* 1145411 */     GIR_EraseRootFromParent_Done,
     /* 1145412 */   // Label 16773: @1145412
     /* 1145412 */   GIM_Try, /*On fail goto*//*Label 16774*/ GIMT_Encode4(1145492), // Rule ID 15348 //
     /* 1145417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145456 */     // MIs[0] round
     /* 1145456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145466 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145491 */     // GIR_Coverage, 15348,
     /* 1145491 */     GIR_EraseRootFromParent_Done,
     /* 1145492 */   // Label 16774: @1145492
     /* 1145492 */   GIM_Try, /*On fail goto*//*Label 16775*/ GIMT_Encode4(1145572), // Rule ID 15349 //
     /* 1145497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1145508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1145511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1145514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1145517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145536 */     // MIs[0] round
     /* 1145536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145571 */     // GIR_Coverage, 15349,
     /* 1145571 */     GIR_EraseRootFromParent_Done,
     /* 1145572 */   // Label 16775: @1145572
     /* 1145572 */   GIM_Try, /*On fail goto*//*Label 16776*/ GIMT_Encode4(1145652), // Rule ID 15352 //
     /* 1145577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1145588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1145591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1145594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1145597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145616 */     // MIs[0] round
     /* 1145616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145651 */     // GIR_Coverage, 15352,
     /* 1145651 */     GIR_EraseRootFromParent_Done,
     /* 1145652 */   // Label 16776: @1145652
     /* 1145652 */   GIM_Try, /*On fail goto*//*Label 16777*/ GIMT_Encode4(1145732), // Rule ID 15353 //
     /* 1145657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1145668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1145671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1145674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1145677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145696 */     // MIs[0] round
     /* 1145696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1145709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145731 */     // GIR_Coverage, 15353,
     /* 1145731 */     GIR_EraseRootFromParent_Done,
     /* 1145732 */   // Label 16777: @1145732
     /* 1145732 */   GIM_Try, /*On fail goto*//*Label 16778*/ GIMT_Encode4(1145812), // Rule ID 15356 //
     /* 1145737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1145740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1145748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1145751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1145754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1145757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145776 */     // MIs[0] round
     /* 1145776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145786 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145811 */     // GIR_Coverage, 15356,
     /* 1145811 */     GIR_EraseRootFromParent_Done,
     /* 1145812 */   // Label 16778: @1145812
     /* 1145812 */   GIM_Try, /*On fail goto*//*Label 16779*/ GIMT_Encode4(1145892), // Rule ID 15357 //
     /* 1145817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1145820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1145828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1145831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1145834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1145837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1145856 */     // MIs[0] round
     /* 1145856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1145869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145891 */     // GIR_Coverage, 15357,
     /* 1145891 */     GIR_EraseRootFromParent_Done,
     /* 1145892 */   // Label 16779: @1145892
     /* 1145892 */   GIM_Try, /*On fail goto*//*Label 16780*/ GIMT_Encode4(1145972), // Rule ID 15360 //
     /* 1145897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1145900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1145908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1145911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1145914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1145917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1145936 */     // MIs[0] round
     /* 1145936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1145949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145971 */     // GIR_Coverage, 15360,
     /* 1145971 */     GIR_EraseRootFromParent_Done,
     /* 1145972 */   // Label 16780: @1145972
     /* 1145972 */   GIM_Try, /*On fail goto*//*Label 16781*/ GIMT_Encode4(1146052), // Rule ID 15361 //
     /* 1145977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1145980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1145985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1145988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1145991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1145994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1145997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146016 */     // MIs[0] round
     /* 1146016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146026 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1146029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146051 */     // GIR_Coverage, 15361,
     /* 1146051 */     GIR_EraseRootFromParent_Done,
     /* 1146052 */   // Label 16781: @1146052
     /* 1146052 */   GIM_Try, /*On fail goto*//*Label 16782*/ GIMT_Encode4(1146132), // Rule ID 15364 //
     /* 1146057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1146077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146096 */     // MIs[0] round
     /* 1146096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146106 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146131 */     // GIR_Coverage, 15364,
     /* 1146131 */     GIR_EraseRootFromParent_Done,
     /* 1146132 */   // Label 16782: @1146132
     /* 1146132 */   GIM_Try, /*On fail goto*//*Label 16783*/ GIMT_Encode4(1146212), // Rule ID 15365 //
     /* 1146137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1146148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1146151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1146154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1146157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1146176 */     // MIs[0] round
     /* 1146176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146186 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1146189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146211 */     // GIR_Coverage, 15365,
     /* 1146211 */     GIR_EraseRootFromParent_Done,
     /* 1146212 */   // Label 16783: @1146212
     /* 1146212 */   GIM_Try, /*On fail goto*//*Label 16784*/ GIMT_Encode4(1146292), // Rule ID 15368 //
     /* 1146217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146256 */     // MIs[0] round
     /* 1146256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146266 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1146269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146291 */     // GIR_Coverage, 15368,
     /* 1146291 */     GIR_EraseRootFromParent_Done,
     /* 1146292 */   // Label 16784: @1146292
     /* 1146292 */   GIM_Try, /*On fail goto*//*Label 16785*/ GIMT_Encode4(1146372), // Rule ID 15369 //
     /* 1146297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1146308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1146311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1146314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146336 */     // MIs[0] round
     /* 1146336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146346 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1146349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146371 */     // GIR_Coverage, 15369,
     /* 1146371 */     GIR_EraseRootFromParent_Done,
     /* 1146372 */   // Label 16785: @1146372
     /* 1146372 */   GIM_Try, /*On fail goto*//*Label 16786*/ GIMT_Encode4(1146452), // Rule ID 15372 //
     /* 1146377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146416 */     // MIs[0] round
     /* 1146416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146426 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146451 */     // GIR_Coverage, 15372,
     /* 1146451 */     GIR_EraseRootFromParent_Done,
     /* 1146452 */   // Label 16786: @1146452
     /* 1146452 */   GIM_Try, /*On fail goto*//*Label 16787*/ GIMT_Encode4(1146532), // Rule ID 15373 //
     /* 1146457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1146468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1146471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1146474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146496 */     // MIs[0] round
     /* 1146496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146506 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146531 */     // GIR_Coverage, 15373,
     /* 1146531 */     GIR_EraseRootFromParent_Done,
     /* 1146532 */   // Label 16787: @1146532
     /* 1146532 */   GIM_Try, /*On fail goto*//*Label 16788*/ GIMT_Encode4(1146612), // Rule ID 15376 //
     /* 1146537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1146548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1146551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1146554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146576 */     // MIs[0] round
     /* 1146576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146611 */     // GIR_Coverage, 15376,
     /* 1146611 */     GIR_EraseRootFromParent_Done,
     /* 1146612 */   // Label 16788: @1146612
     /* 1146612 */   GIM_Try, /*On fail goto*//*Label 16789*/ GIMT_Encode4(1146692), // Rule ID 15377 //
     /* 1146617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1146628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1146631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1146634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146656 */     // MIs[0] round
     /* 1146656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146666 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146691 */     // GIR_Coverage, 15377,
     /* 1146691 */     GIR_EraseRootFromParent_Done,
     /* 1146692 */   // Label 16789: @1146692
     /* 1146692 */   GIM_Try, /*On fail goto*//*Label 16790*/ GIMT_Encode4(1146772), // Rule ID 15380 //
     /* 1146697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1146708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1146711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1146714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146736 */     // MIs[0] round
     /* 1146736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146746 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146771 */     // GIR_Coverage, 15380,
     /* 1146771 */     GIR_EraseRootFromParent_Done,
     /* 1146772 */   // Label 16790: @1146772
     /* 1146772 */   GIM_Try, /*On fail goto*//*Label 16791*/ GIMT_Encode4(1146852), // Rule ID 15381 //
     /* 1146777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1146788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1146791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1146794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146816 */     // MIs[0] round
     /* 1146816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146826 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1146829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146851 */     // GIR_Coverage, 15381,
     /* 1146851 */     GIR_EraseRootFromParent_Done,
     /* 1146852 */   // Label 16791: @1146852
     /* 1146852 */   GIM_Try, /*On fail goto*//*Label 16792*/ GIMT_Encode4(1146932), // Rule ID 15384 //
     /* 1146857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1146868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1146871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1146874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1146877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146896 */     // MIs[0] round
     /* 1146896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146906 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146931 */     // GIR_Coverage, 15384,
     /* 1146931 */     GIR_EraseRootFromParent_Done,
     /* 1146932 */   // Label 16792: @1146932
     /* 1146932 */   GIM_Try, /*On fail goto*//*Label 16793*/ GIMT_Encode4(1147012), // Rule ID 15385 //
     /* 1146937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1146945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1146948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1146951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1146954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1146957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1146976 */     // MIs[0] round
     /* 1146976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146986 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1146989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147011 */     // GIR_Coverage, 15385,
     /* 1147011 */     GIR_EraseRootFromParent_Done,
     /* 1147012 */   // Label 16793: @1147012
     /* 1147012 */   GIM_Try, /*On fail goto*//*Label 16794*/ GIMT_Encode4(1147092), // Rule ID 15388 //
     /* 1147017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147056 */     // MIs[0] round
     /* 1147056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147091 */     // GIR_Coverage, 15388,
     /* 1147091 */     GIR_EraseRootFromParent_Done,
     /* 1147092 */   // Label 16794: @1147092
     /* 1147092 */   GIM_Try, /*On fail goto*//*Label 16795*/ GIMT_Encode4(1147172), // Rule ID 15389 //
     /* 1147097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1147108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1147111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1147114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147136 */     // MIs[0] round
     /* 1147136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1147149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147171 */     // GIR_Coverage, 15389,
     /* 1147171 */     GIR_EraseRootFromParent_Done,
     /* 1147172 */   // Label 16795: @1147172
     /* 1147172 */   GIM_Try, /*On fail goto*//*Label 16796*/ GIMT_Encode4(1147252), // Rule ID 15392 //
     /* 1147177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147216 */     // MIs[0] round
     /* 1147216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147251 */     // GIR_Coverage, 15392,
     /* 1147251 */     GIR_EraseRootFromParent_Done,
     /* 1147252 */   // Label 16796: @1147252
     /* 1147252 */   GIM_Try, /*On fail goto*//*Label 16797*/ GIMT_Encode4(1147332), // Rule ID 15393 //
     /* 1147257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1147268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1147271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1147274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147296 */     // MIs[0] round
     /* 1147296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147306 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11160:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147331 */     // GIR_Coverage, 15393,
     /* 1147331 */     GIR_EraseRootFromParent_Done,
     /* 1147332 */   // Label 16797: @1147332
     /* 1147332 */   GIM_Try, /*On fail goto*//*Label 16798*/ GIMT_Encode4(1147412), // Rule ID 15396 //
     /* 1147337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147376 */     // MIs[0] round
     /* 1147376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147411 */     // GIR_Coverage, 15396,
     /* 1147411 */     GIR_EraseRootFromParent_Done,
     /* 1147412 */   // Label 16798: @1147412
     /* 1147412 */   GIM_Try, /*On fail goto*//*Label 16799*/ GIMT_Encode4(1147492), // Rule ID 15397 //
     /* 1147417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1147428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1147431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1147434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147456 */     // MIs[0] round
     /* 1147456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147491 */     // GIR_Coverage, 15397,
     /* 1147491 */     GIR_EraseRootFromParent_Done,
     /* 1147492 */   // Label 16799: @1147492
     /* 1147492 */   GIM_Try, /*On fail goto*//*Label 16800*/ GIMT_Encode4(1147572), // Rule ID 15400 //
     /* 1147497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147536 */     // MIs[0] round
     /* 1147536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147546 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147571 */     // GIR_Coverage, 15400,
     /* 1147571 */     GIR_EraseRootFromParent_Done,
     /* 1147572 */   // Label 16800: @1147572
     /* 1147572 */   GIM_Try, /*On fail goto*//*Label 16801*/ GIMT_Encode4(1147652), // Rule ID 15401 //
     /* 1147577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1147588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1147591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1147594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147616 */     // MIs[0] round
     /* 1147616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147651 */     // GIR_Coverage, 15401,
     /* 1147651 */     GIR_EraseRootFromParent_Done,
     /* 1147652 */   // Label 16801: @1147652
     /* 1147652 */   GIM_Try, /*On fail goto*//*Label 16802*/ GIMT_Encode4(1147732), // Rule ID 15404 //
     /* 1147657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1147660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1147668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1147671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1147674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147696 */     // MIs[0] round
     /* 1147696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1147727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147731 */     // GIR_Coverage, 15404,
     /* 1147731 */     GIR_EraseRootFromParent_Done,
     /* 1147732 */   // Label 16802: @1147732
     /* 1147732 */   GIM_Try, /*On fail goto*//*Label 16803*/ GIMT_Encode4(1147812), // Rule ID 15405 //
     /* 1147737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1147740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1147748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1147751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1147754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1147772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147776 */     // MIs[0] round
     /* 1147776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1147789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1147807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147811 */     // GIR_Coverage, 15405,
     /* 1147811 */     GIR_EraseRootFromParent_Done,
     /* 1147812 */   // Label 16803: @1147812
     /* 1147812 */   GIM_Try, /*On fail goto*//*Label 16804*/ GIMT_Encode4(1147892), // Rule ID 15408 //
     /* 1147817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1147828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1147831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1147834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147856 */     // MIs[0] round
     /* 1147856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147866 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1147869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147891 */     // GIR_Coverage, 15408,
     /* 1147891 */     GIR_EraseRootFromParent_Done,
     /* 1147892 */   // Label 16804: @1147892
     /* 1147892 */   GIM_Try, /*On fail goto*//*Label 16805*/ GIMT_Encode4(1147972), // Rule ID 15409 //
     /* 1147897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1147908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1147911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1147914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1147917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1147936 */     // MIs[0] round
     /* 1147936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147946 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1147949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147971 */     // GIR_Coverage, 15409,
     /* 1147971 */     GIR_EraseRootFromParent_Done,
     /* 1147972 */   // Label 16805: @1147972
     /* 1147972 */   GIM_Try, /*On fail goto*//*Label 16806*/ GIMT_Encode4(1148052), // Rule ID 15412 //
     /* 1147977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1147985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1147988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1147991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1147994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1147997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148016 */     // MIs[0] round
     /* 1148016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148026 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148051 */     // GIR_Coverage, 15412,
     /* 1148051 */     GIR_EraseRootFromParent_Done,
     /* 1148052 */   // Label 16806: @1148052
     /* 1148052 */   GIM_Try, /*On fail goto*//*Label 16807*/ GIMT_Encode4(1148132), // Rule ID 15413 //
     /* 1148057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1148068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1148071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1148074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148096 */     // MIs[0] round
     /* 1148096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148106 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148131 */     // GIR_Coverage, 15413,
     /* 1148131 */     GIR_EraseRootFromParent_Done,
     /* 1148132 */   // Label 16807: @1148132
     /* 1148132 */   GIM_Try, /*On fail goto*//*Label 16808*/ GIMT_Encode4(1148212), // Rule ID 15416 //
     /* 1148137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148176 */     // MIs[0] round
     /* 1148176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148186 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148211 */     // GIR_Coverage, 15416,
     /* 1148211 */     GIR_EraseRootFromParent_Done,
     /* 1148212 */   // Label 16808: @1148212
     /* 1148212 */   GIM_Try, /*On fail goto*//*Label 16809*/ GIMT_Encode4(1148292), // Rule ID 15417 //
     /* 1148217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1148228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1148231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1148234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148256 */     // MIs[0] round
     /* 1148256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148266 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148291 */     // GIR_Coverage, 15417,
     /* 1148291 */     GIR_EraseRootFromParent_Done,
     /* 1148292 */   // Label 16809: @1148292
     /* 1148292 */   GIM_Try, /*On fail goto*//*Label 16810*/ GIMT_Encode4(1148372), // Rule ID 15420 //
     /* 1148297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148336 */     // MIs[0] round
     /* 1148336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148371 */     // GIR_Coverage, 15420,
     /* 1148371 */     GIR_EraseRootFromParent_Done,
     /* 1148372 */   // Label 16810: @1148372
     /* 1148372 */   GIM_Try, /*On fail goto*//*Label 16811*/ GIMT_Encode4(1148452), // Rule ID 15421 //
     /* 1148377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1148388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1148391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1148394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148416 */     // MIs[0] round
     /* 1148416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148426 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148451 */     // GIR_Coverage, 15421,
     /* 1148451 */     GIR_EraseRootFromParent_Done,
     /* 1148452 */   // Label 16811: @1148452
     /* 1148452 */   GIM_Try, /*On fail goto*//*Label 16812*/ GIMT_Encode4(1148532), // Rule ID 15424 //
     /* 1148457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148496 */     // MIs[0] round
     /* 1148496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148506 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148531 */     // GIR_Coverage, 15424,
     /* 1148531 */     GIR_EraseRootFromParent_Done,
     /* 1148532 */   // Label 16812: @1148532
     /* 1148532 */   GIM_Try, /*On fail goto*//*Label 16813*/ GIMT_Encode4(1148612), // Rule ID 15425 //
     /* 1148537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1148548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1148551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1148554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148576 */     // MIs[0] round
     /* 1148576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148586 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148611 */     // GIR_Coverage, 15425,
     /* 1148611 */     GIR_EraseRootFromParent_Done,
     /* 1148612 */   // Label 16813: @1148612
     /* 1148612 */   GIM_Try, /*On fail goto*//*Label 16814*/ GIMT_Encode4(1148692), // Rule ID 15428 //
     /* 1148617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1148628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1148631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1148634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148656 */     // MIs[0] round
     /* 1148656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148666 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148691 */     // GIR_Coverage, 15428,
     /* 1148691 */     GIR_EraseRootFromParent_Done,
     /* 1148692 */   // Label 16814: @1148692
     /* 1148692 */   GIM_Try, /*On fail goto*//*Label 16815*/ GIMT_Encode4(1148772), // Rule ID 15429 //
     /* 1148697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1148708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1148711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1148714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148736 */     // MIs[0] round
     /* 1148736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1148749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1148767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148771 */     // GIR_Coverage, 15429,
     /* 1148771 */     GIR_EraseRootFromParent_Done,
     /* 1148772 */   // Label 16815: @1148772
     /* 1148772 */   GIM_Try, /*On fail goto*//*Label 16816*/ GIMT_Encode4(1148852), // Rule ID 15432 //
     /* 1148777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1148788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1148791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1148794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148816 */     // MIs[0] round
     /* 1148816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148851 */     // GIR_Coverage, 15432,
     /* 1148851 */     GIR_EraseRootFromParent_Done,
     /* 1148852 */   // Label 16816: @1148852
     /* 1148852 */   GIM_Try, /*On fail goto*//*Label 16817*/ GIMT_Encode4(1148932), // Rule ID 15433 //
     /* 1148857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1148868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1148871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1148874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148896 */     // MIs[0] round
     /* 1148896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1148909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148931 */     // GIR_Coverage, 15433,
     /* 1148931 */     GIR_EraseRootFromParent_Done,
     /* 1148932 */   // Label 16817: @1148932
     /* 1148932 */   GIM_Try, /*On fail goto*//*Label 16818*/ GIMT_Encode4(1149012), // Rule ID 15436 //
     /* 1148937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1148945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1148948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1148951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1148954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148976 */     // MIs[0] round
     /* 1148976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1148989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149011 */     // GIR_Coverage, 15436,
     /* 1149011 */     GIR_EraseRootFromParent_Done,
     /* 1149012 */   // Label 16818: @1149012
     /* 1149012 */   GIM_Try, /*On fail goto*//*Label 16819*/ GIMT_Encode4(1149092), // Rule ID 15437 //
     /* 1149017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1149028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1149031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1149034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149056 */     // MIs[0] round
     /* 1149056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149091 */     // GIR_Coverage, 15437,
     /* 1149091 */     GIR_EraseRootFromParent_Done,
     /* 1149092 */   // Label 16819: @1149092
     /* 1149092 */   GIM_Try, /*On fail goto*//*Label 16820*/ GIMT_Encode4(1149172), // Rule ID 15440 //
     /* 1149097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149136 */     // MIs[0] round
     /* 1149136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149171 */     // GIR_Coverage, 15440,
     /* 1149171 */     GIR_EraseRootFromParent_Done,
     /* 1149172 */   // Label 16820: @1149172
     /* 1149172 */   GIM_Try, /*On fail goto*//*Label 16821*/ GIMT_Encode4(1149252), // Rule ID 15441 //
     /* 1149177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1149188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1149191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1149194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149216 */     // MIs[0] round
     /* 1149216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149251 */     // GIR_Coverage, 15441,
     /* 1149251 */     GIR_EraseRootFromParent_Done,
     /* 1149252 */   // Label 16821: @1149252
     /* 1149252 */   GIM_Try, /*On fail goto*//*Label 16822*/ GIMT_Encode4(1149332), // Rule ID 15444 //
     /* 1149257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149296 */     // MIs[0] round
     /* 1149296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149331 */     // GIR_Coverage, 15444,
     /* 1149331 */     GIR_EraseRootFromParent_Done,
     /* 1149332 */   // Label 16822: @1149332
     /* 1149332 */   GIM_Try, /*On fail goto*//*Label 16823*/ GIMT_Encode4(1149412), // Rule ID 15445 //
     /* 1149337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1149348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1149351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1149354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1149372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149376 */     // MIs[0] round
     /* 1149376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1149389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149411 */     // GIR_Coverage, 15445,
     /* 1149411 */     GIR_EraseRootFromParent_Done,
     /* 1149412 */   // Label 16823: @1149412
     /* 1149412 */   GIM_Try, /*On fail goto*//*Label 16824*/ GIMT_Encode4(1149492), // Rule ID 15448 //
     /* 1149417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149456 */     // MIs[0] round
     /* 1149456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149466 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149491 */     // GIR_Coverage, 15448,
     /* 1149491 */     GIR_EraseRootFromParent_Done,
     /* 1149492 */   // Label 16824: @1149492
     /* 1149492 */   GIM_Try, /*On fail goto*//*Label 16825*/ GIMT_Encode4(1149572), // Rule ID 15449 //
     /* 1149497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1149508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1149511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1149514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1149532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149536 */     // MIs[0] round
     /* 1149536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149546 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1149549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149571 */     // GIR_Coverage, 15449,
     /* 1149571 */     GIR_EraseRootFromParent_Done,
     /* 1149572 */   // Label 16825: @1149572
     /* 1149572 */   GIM_Try, /*On fail goto*//*Label 16826*/ GIMT_Encode4(1149652), // Rule ID 15452 //
     /* 1149577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1149580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1149588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1149591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1149594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149616 */     // MIs[0] round
     /* 1149616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149626 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149651 */     // GIR_Coverage, 15452,
     /* 1149651 */     GIR_EraseRootFromParent_Done,
     /* 1149652 */   // Label 16826: @1149652
     /* 1149652 */   GIM_Try, /*On fail goto*//*Label 16827*/ GIMT_Encode4(1149732), // Rule ID 15453 //
     /* 1149657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1149660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1149665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1149668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1149671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1149674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1149692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149696 */     // MIs[0] round
     /* 1149696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149706 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11160:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1149709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1149727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149731 */     // GIR_Coverage, 15453,
     /* 1149731 */     GIR_EraseRootFromParent_Done,
     /* 1149732 */   // Label 16827: @1149732
     /* 1149732 */   GIM_Try, /*On fail goto*//*Label 16828*/ GIMT_Encode4(1149812), // Rule ID 15456 //
     /* 1149737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1149748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1149751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1149754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1149757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149776 */     // MIs[0] round
     /* 1149776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149786 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1149789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149811 */     // GIR_Coverage, 15456,
     /* 1149811 */     GIR_EraseRootFromParent_Done,
     /* 1149812 */   // Label 16828: @1149812
     /* 1149812 */   GIM_Try, /*On fail goto*//*Label 16829*/ GIMT_Encode4(1149892), // Rule ID 15457 //
     /* 1149817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1149828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1149831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1149834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1149837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149856 */     // MIs[0] round
     /* 1149856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149866 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1149869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149891 */     // GIR_Coverage, 15457,
     /* 1149891 */     GIR_EraseRootFromParent_Done,
     /* 1149892 */   // Label 16829: @1149892
     /* 1149892 */   GIM_Try, /*On fail goto*//*Label 16830*/ GIMT_Encode4(1149972), // Rule ID 15460 //
     /* 1149897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1149908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1149911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1149914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1149917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149936 */     // MIs[0] round
     /* 1149936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1149949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149971 */     // GIR_Coverage, 15460,
     /* 1149971 */     GIR_EraseRootFromParent_Done,
     /* 1149972 */   // Label 16830: @1149972
     /* 1149972 */   GIM_Try, /*On fail goto*//*Label 16831*/ GIMT_Encode4(1150052), // Rule ID 15461 //
     /* 1149977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1149988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1149991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1149994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1149997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150016 */     // MIs[0] round
     /* 1150016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150026 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150051 */     // GIR_Coverage, 15461,
     /* 1150051 */     GIR_EraseRootFromParent_Done,
     /* 1150052 */   // Label 16831: @1150052
     /* 1150052 */   GIM_Try, /*On fail goto*//*Label 16832*/ GIMT_Encode4(1150132), // Rule ID 15464 //
     /* 1150057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1150077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150096 */     // MIs[0] round
     /* 1150096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150131 */     // GIR_Coverage, 15464,
     /* 1150131 */     GIR_EraseRootFromParent_Done,
     /* 1150132 */   // Label 16832: @1150132
     /* 1150132 */   GIM_Try, /*On fail goto*//*Label 16833*/ GIMT_Encode4(1150212), // Rule ID 15465 //
     /* 1150137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1150148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1150151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1150154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1150157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150176 */     // MIs[0] round
     /* 1150176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150186 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150211 */     // GIR_Coverage, 15465,
     /* 1150211 */     GIR_EraseRootFromParent_Done,
     /* 1150212 */   // Label 16833: @1150212
     /* 1150212 */   GIM_Try, /*On fail goto*//*Label 16834*/ GIMT_Encode4(1150292), // Rule ID 15468 //
     /* 1150217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1150237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150256 */     // MIs[0] round
     /* 1150256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150291 */     // GIR_Coverage, 15468,
     /* 1150291 */     GIR_EraseRootFromParent_Done,
     /* 1150292 */   // Label 16834: @1150292
     /* 1150292 */   GIM_Try, /*On fail goto*//*Label 16835*/ GIMT_Encode4(1150372), // Rule ID 15469 //
     /* 1150297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1150308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1150311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1150314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1150317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150336 */     // MIs[0] round
     /* 1150336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1150349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150371 */     // GIR_Coverage, 15469,
     /* 1150371 */     GIR_EraseRootFromParent_Done,
     /* 1150372 */   // Label 16835: @1150372
     /* 1150372 */   GIM_Try, /*On fail goto*//*Label 16836*/ GIMT_Encode4(1150452), // Rule ID 15472 //
     /* 1150377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150416 */     // MIs[0] round
     /* 1150416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150451 */     // GIR_Coverage, 15472,
     /* 1150451 */     GIR_EraseRootFromParent_Done,
     /* 1150452 */   // Label 16836: @1150452
     /* 1150452 */   GIM_Try, /*On fail goto*//*Label 16837*/ GIMT_Encode4(1150532), // Rule ID 15473 //
     /* 1150457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1150468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1150471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1150474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1150477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150496 */     // MIs[0] round
     /* 1150496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150531 */     // GIR_Coverage, 15473,
     /* 1150531 */     GIR_EraseRootFromParent_Done,
     /* 1150532 */   // Label 16837: @1150532
     /* 1150532 */   GIM_Try, /*On fail goto*//*Label 16838*/ GIMT_Encode4(1150612), // Rule ID 15476 //
     /* 1150537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1150548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1150551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1150554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1150557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150576 */     // MIs[0] round
     /* 1150576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150611 */     // GIR_Coverage, 15476,
     /* 1150611 */     GIR_EraseRootFromParent_Done,
     /* 1150612 */   // Label 16838: @1150612
     /* 1150612 */   GIM_Try, /*On fail goto*//*Label 16839*/ GIMT_Encode4(1150692), // Rule ID 15477 //
     /* 1150617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1150628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1150631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1150634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1150637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150656 */     // MIs[0] round
     /* 1150656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150666 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1150669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150691 */     // GIR_Coverage, 15477,
     /* 1150691 */     GIR_EraseRootFromParent_Done,
     /* 1150692 */   // Label 16839: @1150692
     /* 1150692 */   GIM_Try, /*On fail goto*//*Label 16840*/ GIMT_Encode4(1150772), // Rule ID 15480 //
     /* 1150697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1150708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1150711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1150714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1150717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150736 */     // MIs[0] round
     /* 1150736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150746 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150771 */     // GIR_Coverage, 15480,
     /* 1150771 */     GIR_EraseRootFromParent_Done,
     /* 1150772 */   // Label 16840: @1150772
     /* 1150772 */   GIM_Try, /*On fail goto*//*Label 16841*/ GIMT_Encode4(1150852), // Rule ID 15481 //
     /* 1150777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1150788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1150791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1150794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1150797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150816 */     // MIs[0] round
     /* 1150816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150851 */     // GIR_Coverage, 15481,
     /* 1150851 */     GIR_EraseRootFromParent_Done,
     /* 1150852 */   // Label 16841: @1150852
     /* 1150852 */   GIM_Try, /*On fail goto*//*Label 16842*/ GIMT_Encode4(1150932), // Rule ID 15484 //
     /* 1150857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1150868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1150871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1150874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1150877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150896 */     // MIs[0] round
     /* 1150896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150931 */     // GIR_Coverage, 15484,
     /* 1150931 */     GIR_EraseRootFromParent_Done,
     /* 1150932 */   // Label 16842: @1150932
     /* 1150932 */   GIM_Try, /*On fail goto*//*Label 16843*/ GIMT_Encode4(1151012), // Rule ID 15485 //
     /* 1150937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1150948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1150951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1150954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1150957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150976 */     // MIs[0] round
     /* 1150976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150986 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1150989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151011 */     // GIR_Coverage, 15485,
     /* 1151011 */     GIR_EraseRootFromParent_Done,
     /* 1151012 */   // Label 16843: @1151012
     /* 1151012 */   GIM_Try, /*On fail goto*//*Label 16844*/ GIMT_Encode4(1151092), // Rule ID 15488 //
     /* 1151017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1151037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151056 */     // MIs[0] round
     /* 1151056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151091 */     // GIR_Coverage, 15488,
     /* 1151091 */     GIR_EraseRootFromParent_Done,
     /* 1151092 */   // Label 16844: @1151092
     /* 1151092 */   GIM_Try, /*On fail goto*//*Label 16845*/ GIMT_Encode4(1151172), // Rule ID 15489 //
     /* 1151097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1151108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1151111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1151114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1151117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151136 */     // MIs[0] round
     /* 1151136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151171 */     // GIR_Coverage, 15489,
     /* 1151171 */     GIR_EraseRootFromParent_Done,
     /* 1151172 */   // Label 16845: @1151172
     /* 1151172 */   GIM_Try, /*On fail goto*//*Label 16846*/ GIMT_Encode4(1151252), // Rule ID 15492 //
     /* 1151177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1151180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1151197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151216 */     // MIs[0] round
     /* 1151216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151251 */     // GIR_Coverage, 15492,
     /* 1151251 */     GIR_EraseRootFromParent_Done,
     /* 1151252 */   // Label 16846: @1151252
     /* 1151252 */   GIM_Try, /*On fail goto*//*Label 16847*/ GIMT_Encode4(1151332), // Rule ID 15493 //
     /* 1151257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1151260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1151268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1151271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1151274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1151277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1151296 */     // MIs[0] round
     /* 1151296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151306 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1151309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151331 */     // GIR_Coverage, 15493,
     /* 1151331 */     GIR_EraseRootFromParent_Done,
     /* 1151332 */   // Label 16847: @1151332
     /* 1151332 */   GIM_Try, /*On fail goto*//*Label 16848*/ GIMT_Encode4(1151412), // Rule ID 15496 //
     /* 1151337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151376 */     // MIs[0] round
     /* 1151376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151411 */     // GIR_Coverage, 15496,
     /* 1151411 */     GIR_EraseRootFromParent_Done,
     /* 1151412 */   // Label 16848: @1151412
     /* 1151412 */   GIM_Try, /*On fail goto*//*Label 16849*/ GIMT_Encode4(1151492), // Rule ID 15497 //
     /* 1151417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1151428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1151431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1151434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1151437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151456 */     // MIs[0] round
     /* 1151456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151466 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151491 */     // GIR_Coverage, 15497,
     /* 1151491 */     GIR_EraseRootFromParent_Done,
     /* 1151492 */   // Label 16849: @1151492
     /* 1151492 */   GIM_Try, /*On fail goto*//*Label 16850*/ GIMT_Encode4(1151572), // Rule ID 15500 //
     /* 1151497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1151517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151536 */     // MIs[0] round
     /* 1151536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1151549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151571 */     // GIR_Coverage, 15500,
     /* 1151571 */     GIR_EraseRootFromParent_Done,
     /* 1151572 */   // Label 16850: @1151572
     /* 1151572 */   GIM_Try, /*On fail goto*//*Label 16851*/ GIMT_Encode4(1151652), // Rule ID 15501 //
     /* 1151577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1151588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1151591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1151594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1151597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151616 */     // MIs[0] round
     /* 1151616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151626 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1151629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151651 */     // GIR_Coverage, 15501,
     /* 1151651 */     GIR_EraseRootFromParent_Done,
     /* 1151652 */   // Label 16851: @1151652
     /* 1151652 */   GIM_Try, /*On fail goto*//*Label 16852*/ GIMT_Encode4(1151732), // Rule ID 15504 //
     /* 1151657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1151668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1151671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1151674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1151677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151696 */     // MIs[0] round
     /* 1151696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151706 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1151709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151731 */     // GIR_Coverage, 15504,
     /* 1151731 */     GIR_EraseRootFromParent_Done,
     /* 1151732 */   // Label 16852: @1151732
     /* 1151732 */   GIM_Try, /*On fail goto*//*Label 16853*/ GIMT_Encode4(1151812), // Rule ID 15505 //
     /* 1151737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1151748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1151751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1151754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1151757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151776 */     // MIs[0] round
     /* 1151776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151786 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1151789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1151807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151811 */     // GIR_Coverage, 15505,
     /* 1151811 */     GIR_EraseRootFromParent_Done,
     /* 1151812 */   // Label 16853: @1151812
     /* 1151812 */   GIM_Try, /*On fail goto*//*Label 16854*/ GIMT_Encode4(1151892), // Rule ID 15508 //
     /* 1151817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1151828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1151831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1151834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1151837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151856 */     // MIs[0] round
     /* 1151856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151891 */     // GIR_Coverage, 15508,
     /* 1151891 */     GIR_EraseRootFromParent_Done,
     /* 1151892 */   // Label 16854: @1151892
     /* 1151892 */   GIM_Try, /*On fail goto*//*Label 16855*/ GIMT_Encode4(1151972), // Rule ID 15509 //
     /* 1151897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1151908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1151911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1151914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1151917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151936 */     // MIs[0] round
     /* 1151936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1151949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151971 */     // GIR_Coverage, 15509,
     /* 1151971 */     GIR_EraseRootFromParent_Done,
     /* 1151972 */   // Label 16855: @1151972
     /* 1151972 */   GIM_Try, /*On fail goto*//*Label 16856*/ GIMT_Encode4(1152052), // Rule ID 15512 //
     /* 1151977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1151988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1151991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1151994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1151997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152016 */     // MIs[0] round
     /* 1152016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152026 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152051 */     // GIR_Coverage, 15512,
     /* 1152051 */     GIR_EraseRootFromParent_Done,
     /* 1152052 */   // Label 16856: @1152052
     /* 1152052 */   GIM_Try, /*On fail goto*//*Label 16857*/ GIMT_Encode4(1152132), // Rule ID 15513 //
     /* 1152057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1152068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1152071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1152074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1152077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152096 */     // MIs[0] round
     /* 1152096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152106 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152131 */     // GIR_Coverage, 15513,
     /* 1152131 */     GIR_EraseRootFromParent_Done,
     /* 1152132 */   // Label 16857: @1152132
     /* 1152132 */   GIM_Try, /*On fail goto*//*Label 16858*/ GIMT_Encode4(1152212), // Rule ID 15516 //
     /* 1152137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1152157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152176 */     // MIs[0] round
     /* 1152176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152186 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152211 */     // GIR_Coverage, 15516,
     /* 1152211 */     GIR_EraseRootFromParent_Done,
     /* 1152212 */   // Label 16858: @1152212
     /* 1152212 */   GIM_Try, /*On fail goto*//*Label 16859*/ GIMT_Encode4(1152292), // Rule ID 15517 //
     /* 1152217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1152228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1152231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1152234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1152237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152256 */     // MIs[0] round
     /* 1152256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152266 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152291 */     // GIR_Coverage, 15517,
     /* 1152291 */     GIR_EraseRootFromParent_Done,
     /* 1152292 */   // Label 16859: @1152292
     /* 1152292 */   GIM_Try, /*On fail goto*//*Label 16860*/ GIMT_Encode4(1152372), // Rule ID 15520 //
     /* 1152297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152336 */     // MIs[0] round
     /* 1152336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152371 */     // GIR_Coverage, 15520,
     /* 1152371 */     GIR_EraseRootFromParent_Done,
     /* 1152372 */   // Label 16860: @1152372
     /* 1152372 */   GIM_Try, /*On fail goto*//*Label 16861*/ GIMT_Encode4(1152452), // Rule ID 15521 //
     /* 1152377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1152388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1152391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1152394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1152397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152416 */     // MIs[0] round
     /* 1152416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152426 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152451 */     // GIR_Coverage, 15521,
     /* 1152451 */     GIR_EraseRootFromParent_Done,
     /* 1152452 */   // Label 16861: @1152452
     /* 1152452 */   GIM_Try, /*On fail goto*//*Label 16862*/ GIMT_Encode4(1152532), // Rule ID 15524 //
     /* 1152457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1152477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152496 */     // MIs[0] round
     /* 1152496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152531 */     // GIR_Coverage, 15524,
     /* 1152531 */     GIR_EraseRootFromParent_Done,
     /* 1152532 */   // Label 16862: @1152532
     /* 1152532 */   GIM_Try, /*On fail goto*//*Label 16863*/ GIMT_Encode4(1152612), // Rule ID 15525 //
     /* 1152537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1152548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1152551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1152554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1152557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152576 */     // MIs[0] round
     /* 1152576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152611 */     // GIR_Coverage, 15525,
     /* 1152611 */     GIR_EraseRootFromParent_Done,
     /* 1152612 */   // Label 16863: @1152612
     /* 1152612 */   GIM_Try, /*On fail goto*//*Label 16864*/ GIMT_Encode4(1152692), // Rule ID 15528 //
     /* 1152617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1152628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1152631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1152634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1152637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152656 */     // MIs[0] round
     /* 1152656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152691 */     // GIR_Coverage, 15528,
     /* 1152691 */     GIR_EraseRootFromParent_Done,
     /* 1152692 */   // Label 16864: @1152692
     /* 1152692 */   GIM_Try, /*On fail goto*//*Label 16865*/ GIMT_Encode4(1152772), // Rule ID 15529 //
     /* 1152697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1152708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1152711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1152714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1152717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152736 */     // MIs[0] round
     /* 1152736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1152749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1152767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152771 */     // GIR_Coverage, 15529,
     /* 1152771 */     GIR_EraseRootFromParent_Done,
     /* 1152772 */   // Label 16865: @1152772
     /* 1152772 */   GIM_Try, /*On fail goto*//*Label 16866*/ GIMT_Encode4(1152852), // Rule ID 15532 //
     /* 1152777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1152780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1152788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1152791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1152794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1152797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152816 */     // MIs[0] round
     /* 1152816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152851 */     // GIR_Coverage, 15532,
     /* 1152851 */     GIR_EraseRootFromParent_Done,
     /* 1152852 */   // Label 16866: @1152852
     /* 1152852 */   GIM_Try, /*On fail goto*//*Label 16867*/ GIMT_Encode4(1152932), // Rule ID 15533 //
     /* 1152857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1152860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1152868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1152871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1152874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1152877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1152896 */     // MIs[0] round
     /* 1152896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1152909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152931 */     // GIR_Coverage, 15533,
     /* 1152931 */     GIR_EraseRootFromParent_Done,
     /* 1152932 */   // Label 16867: @1152932
     /* 1152932 */   GIM_Try, /*On fail goto*//*Label 16868*/ GIMT_Encode4(1153012), // Rule ID 15536 //
     /* 1152937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1152940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1152948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1152951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1152954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1152957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1152976 */     // MIs[0] round
     /* 1152976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1152989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153011 */     // GIR_Coverage, 15536,
     /* 1153011 */     GIR_EraseRootFromParent_Done,
     /* 1153012 */   // Label 16868: @1153012
     /* 1153012 */   GIM_Try, /*On fail goto*//*Label 16869*/ GIMT_Encode4(1153092), // Rule ID 15537 //
     /* 1153017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1153028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1153031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1153034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1153037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153056 */     // MIs[0] round
     /* 1153056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1153069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153091 */     // GIR_Coverage, 15537,
     /* 1153091 */     GIR_EraseRootFromParent_Done,
     /* 1153092 */   // Label 16869: @1153092
     /* 1153092 */   GIM_Try, /*On fail goto*//*Label 16870*/ GIMT_Encode4(1153172), // Rule ID 15540 //
     /* 1153097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1153100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1153117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153136 */     // MIs[0] round
     /* 1153136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153171 */     // GIR_Coverage, 15540,
     /* 1153171 */     GIR_EraseRootFromParent_Done,
     /* 1153172 */   // Label 16870: @1153172
     /* 1153172 */   GIM_Try, /*On fail goto*//*Label 16871*/ GIMT_Encode4(1153252), // Rule ID 15541 //
     /* 1153177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1153180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1153188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1153191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1153194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1153197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153216 */     // MIs[0] round
     /* 1153216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153226 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1153229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1153247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153251 */     // GIR_Coverage, 15541,
     /* 1153251 */     GIR_EraseRootFromParent_Done,
     /* 1153252 */   // Label 16871: @1153252
     /* 1153252 */   GIM_Try, /*On fail goto*//*Label 16872*/ GIMT_Encode4(1153332), // Rule ID 15544 //
     /* 1153257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153296 */     // MIs[0] round
     /* 1153296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153306 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1153309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153331 */     // GIR_Coverage, 15544,
     /* 1153331 */     GIR_EraseRootFromParent_Done,
     /* 1153332 */   // Label 16872: @1153332
     /* 1153332 */   GIM_Try, /*On fail goto*//*Label 16873*/ GIMT_Encode4(1153412), // Rule ID 15545 //
     /* 1153337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1153348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1153351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1153354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153376 */     // MIs[0] round
     /* 1153376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153386 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1153389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153411 */     // GIR_Coverage, 15545,
     /* 1153411 */     GIR_EraseRootFromParent_Done,
     /* 1153412 */   // Label 16873: @1153412
     /* 1153412 */   GIM_Try, /*On fail goto*//*Label 16874*/ GIMT_Encode4(1153492), // Rule ID 15548 //
     /* 1153417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153456 */     // MIs[0] round
     /* 1153456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153491 */     // GIR_Coverage, 15548,
     /* 1153491 */     GIR_EraseRootFromParent_Done,
     /* 1153492 */   // Label 16874: @1153492
     /* 1153492 */   GIM_Try, /*On fail goto*//*Label 16875*/ GIMT_Encode4(1153572), // Rule ID 15549 //
     /* 1153497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1153508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1153511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1153514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153536 */     // MIs[0] round
     /* 1153536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153546 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153571 */     // GIR_Coverage, 15549,
     /* 1153571 */     GIR_EraseRootFromParent_Done,
     /* 1153572 */   // Label 16875: @1153572
     /* 1153572 */   GIM_Try, /*On fail goto*//*Label 16876*/ GIMT_Encode4(1153652), // Rule ID 15552 //
     /* 1153577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1153588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1153591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1153594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153616 */     // MIs[0] round
     /* 1153616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153626 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153651 */     // GIR_Coverage, 15552,
     /* 1153651 */     GIR_EraseRootFromParent_Done,
     /* 1153652 */   // Label 16876: @1153652
     /* 1153652 */   GIM_Try, /*On fail goto*//*Label 16877*/ GIMT_Encode4(1153732), // Rule ID 15553 //
     /* 1153657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1153668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1153671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1153674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153696 */     // MIs[0] round
     /* 1153696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153706 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153731 */     // GIR_Coverage, 15553,
     /* 1153731 */     GIR_EraseRootFromParent_Done,
     /* 1153732 */   // Label 16877: @1153732
     /* 1153732 */   GIM_Try, /*On fail goto*//*Label 16878*/ GIMT_Encode4(1153812), // Rule ID 15556 //
     /* 1153737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1153748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1153751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1153754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153776 */     // MIs[0] round
     /* 1153776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153811 */     // GIR_Coverage, 15556,
     /* 1153811 */     GIR_EraseRootFromParent_Done,
     /* 1153812 */   // Label 16878: @1153812
     /* 1153812 */   GIM_Try, /*On fail goto*//*Label 16879*/ GIMT_Encode4(1153892), // Rule ID 15557 //
     /* 1153817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1153828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1153831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1153834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153856 */     // MIs[0] round
     /* 1153856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153866 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1153869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153891 */     // GIR_Coverage, 15557,
     /* 1153891 */     GIR_EraseRootFromParent_Done,
     /* 1153892 */   // Label 16879: @1153892
     /* 1153892 */   GIM_Try, /*On fail goto*//*Label 16880*/ GIMT_Encode4(1153972), // Rule ID 15560 //
     /* 1153897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1153908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1153911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1153914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1153917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1153936 */     // MIs[0] round
     /* 1153936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153946 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1153949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153971 */     // GIR_Coverage, 15560,
     /* 1153971 */     GIR_EraseRootFromParent_Done,
     /* 1153972 */   // Label 16880: @1153972
     /* 1153972 */   GIM_Try, /*On fail goto*//*Label 16881*/ GIMT_Encode4(1154052), // Rule ID 15561 //
     /* 1153977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1153985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1153988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1153991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1153994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1153997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154016 */     // MIs[0] round
     /* 1154016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154026 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154051 */     // GIR_Coverage, 15561,
     /* 1154051 */     GIR_EraseRootFromParent_Done,
     /* 1154052 */   // Label 16881: @1154052
     /* 1154052 */   GIM_Try, /*On fail goto*//*Label 16882*/ GIMT_Encode4(1154132), // Rule ID 15564 //
     /* 1154057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154096 */     // MIs[0] round
     /* 1154096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154106 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154131 */     // GIR_Coverage, 15564,
     /* 1154131 */     GIR_EraseRootFromParent_Done,
     /* 1154132 */   // Label 16882: @1154132
     /* 1154132 */   GIM_Try, /*On fail goto*//*Label 16883*/ GIMT_Encode4(1154212), // Rule ID 15565 //
     /* 1154137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1154148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1154151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1154154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154176 */     // MIs[0] round
     /* 1154176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1154189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154211 */     // GIR_Coverage, 15565,
     /* 1154211 */     GIR_EraseRootFromParent_Done,
     /* 1154212 */   // Label 16883: @1154212
     /* 1154212 */   GIM_Try, /*On fail goto*//*Label 16884*/ GIMT_Encode4(1154292), // Rule ID 15568 //
     /* 1154217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154256 */     // MIs[0] round
     /* 1154256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154291 */     // GIR_Coverage, 15568,
     /* 1154291 */     GIR_EraseRootFromParent_Done,
     /* 1154292 */   // Label 16884: @1154292
     /* 1154292 */   GIM_Try, /*On fail goto*//*Label 16885*/ GIMT_Encode4(1154372), // Rule ID 15569 //
     /* 1154297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1154308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1154311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1154314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154336 */     // MIs[0] round
     /* 1154336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11138:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154371 */     // GIR_Coverage, 15569,
     /* 1154371 */     GIR_EraseRootFromParent_Done,
     /* 1154372 */   // Label 16885: @1154372
     /* 1154372 */   GIM_Try, /*On fail goto*//*Label 16886*/ GIMT_Encode4(1154452), // Rule ID 15572 //
     /* 1154377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154416 */     // MIs[0] round
     /* 1154416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154426 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154451 */     // GIR_Coverage, 15572,
     /* 1154451 */     GIR_EraseRootFromParent_Done,
     /* 1154452 */   // Label 16886: @1154452
     /* 1154452 */   GIM_Try, /*On fail goto*//*Label 16887*/ GIMT_Encode4(1154532), // Rule ID 15573 //
     /* 1154457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1154468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1154471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1154474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154496 */     // MIs[0] round
     /* 1154496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154531 */     // GIR_Coverage, 15573,
     /* 1154531 */     GIR_EraseRootFromParent_Done,
     /* 1154532 */   // Label 16887: @1154532
     /* 1154532 */   GIM_Try, /*On fail goto*//*Label 16888*/ GIMT_Encode4(1154612), // Rule ID 15576 //
     /* 1154537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1154548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1154551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1154554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154576 */     // MIs[0] round
     /* 1154576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154611 */     // GIR_Coverage, 15576,
     /* 1154611 */     GIR_EraseRootFromParent_Done,
     /* 1154612 */   // Label 16888: @1154612
     /* 1154612 */   GIM_Try, /*On fail goto*//*Label 16889*/ GIMT_Encode4(1154692), // Rule ID 15577 //
     /* 1154617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1154628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1154631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1154634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154656 */     // MIs[0] round
     /* 1154656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154666 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154691 */     // GIR_Coverage, 15577,
     /* 1154691 */     GIR_EraseRootFromParent_Done,
     /* 1154692 */   // Label 16889: @1154692
     /* 1154692 */   GIM_Try, /*On fail goto*//*Label 16890*/ GIMT_Encode4(1154772), // Rule ID 15580 //
     /* 1154697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1154700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1154708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1154711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1154714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154736 */     // MIs[0] round
     /* 1154736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154746 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1154767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154771 */     // GIR_Coverage, 15580,
     /* 1154771 */     GIR_EraseRootFromParent_Done,
     /* 1154772 */   // Label 16890: @1154772
     /* 1154772 */   GIM_Try, /*On fail goto*//*Label 16891*/ GIMT_Encode4(1154852), // Rule ID 15581 //
     /* 1154777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1154780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1154788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1154791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1154794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1154812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154816 */     // MIs[0] round
     /* 1154816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154826 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1154829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1154847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154851 */     // GIR_Coverage, 15581,
     /* 1154851 */     GIR_EraseRootFromParent_Done,
     /* 1154852 */   // Label 16891: @1154852
     /* 1154852 */   GIM_Try, /*On fail goto*//*Label 16892*/ GIMT_Encode4(1154932), // Rule ID 15584 //
     /* 1154857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1154868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1154871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1154874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1154877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154896 */     // MIs[0] round
     /* 1154896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154906 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1154909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154931 */     // GIR_Coverage, 15584,
     /* 1154931 */     GIR_EraseRootFromParent_Done,
     /* 1154932 */   // Label 16892: @1154932
     /* 1154932 */   GIM_Try, /*On fail goto*//*Label 16893*/ GIMT_Encode4(1155012), // Rule ID 15585 //
     /* 1154937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1154945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1154948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1154951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1154954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1154957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1154976 */     // MIs[0] round
     /* 1154976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154986 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1154989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155011 */     // GIR_Coverage, 15585,
     /* 1155011 */     GIR_EraseRootFromParent_Done,
     /* 1155012 */   // Label 16893: @1155012
     /* 1155012 */   GIM_Try, /*On fail goto*//*Label 16894*/ GIMT_Encode4(1155092), // Rule ID 15588 //
     /* 1155017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155056 */     // MIs[0] round
     /* 1155056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155066 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155091 */     // GIR_Coverage, 15588,
     /* 1155091 */     GIR_EraseRootFromParent_Done,
     /* 1155092 */   // Label 16894: @1155092
     /* 1155092 */   GIM_Try, /*On fail goto*//*Label 16895*/ GIMT_Encode4(1155172), // Rule ID 15589 //
     /* 1155097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1155108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1155111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1155114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155136 */     // MIs[0] round
     /* 1155136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155171 */     // GIR_Coverage, 15589,
     /* 1155171 */     GIR_EraseRootFromParent_Done,
     /* 1155172 */   // Label 16895: @1155172
     /* 1155172 */   GIM_Try, /*On fail goto*//*Label 16896*/ GIMT_Encode4(1155252), // Rule ID 15592 //
     /* 1155177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155216 */     // MIs[0] round
     /* 1155216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155226 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155251 */     // GIR_Coverage, 15592,
     /* 1155251 */     GIR_EraseRootFromParent_Done,
     /* 1155252 */   // Label 16896: @1155252
     /* 1155252 */   GIM_Try, /*On fail goto*//*Label 16897*/ GIMT_Encode4(1155332), // Rule ID 15593 //
     /* 1155257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1155268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1155271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1155274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155296 */     // MIs[0] round
     /* 1155296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155306 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155331 */     // GIR_Coverage, 15593,
     /* 1155331 */     GIR_EraseRootFromParent_Done,
     /* 1155332 */   // Label 16897: @1155332
     /* 1155332 */   GIM_Try, /*On fail goto*//*Label 16898*/ GIMT_Encode4(1155412), // Rule ID 15596 //
     /* 1155337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155376 */     // MIs[0] round
     /* 1155376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155386 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155411 */     // GIR_Coverage, 15596,
     /* 1155411 */     GIR_EraseRootFromParent_Done,
     /* 1155412 */   // Label 16898: @1155412
     /* 1155412 */   GIM_Try, /*On fail goto*//*Label 16899*/ GIMT_Encode4(1155492), // Rule ID 15597 //
     /* 1155417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1155428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1155431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1155434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155456 */     // MIs[0] round
     /* 1155456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155491 */     // GIR_Coverage, 15597,
     /* 1155491 */     GIR_EraseRootFromParent_Done,
     /* 1155492 */   // Label 16899: @1155492
     /* 1155492 */   GIM_Try, /*On fail goto*//*Label 16900*/ GIMT_Encode4(1155572), // Rule ID 15600 //
     /* 1155497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155536 */     // MIs[0] round
     /* 1155536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155571 */     // GIR_Coverage, 15600,
     /* 1155571 */     GIR_EraseRootFromParent_Done,
     /* 1155572 */   // Label 16900: @1155572
     /* 1155572 */   GIM_Try, /*On fail goto*//*Label 16901*/ GIMT_Encode4(1155652), // Rule ID 15601 //
     /* 1155577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1155588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1155591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1155594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1155612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155616 */     // MIs[0] round
     /* 1155616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1155629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155651 */     // GIR_Coverage, 15601,
     /* 1155651 */     GIR_EraseRootFromParent_Done,
     /* 1155652 */   // Label 16901: @1155652
     /* 1155652 */   GIM_Try, /*On fail goto*//*Label 16902*/ GIMT_Encode4(1155732), // Rule ID 15604 //
     /* 1155657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1155668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1155671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1155674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155696 */     // MIs[0] round
     /* 1155696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155731 */     // GIR_Coverage, 15604,
     /* 1155731 */     GIR_EraseRootFromParent_Done,
     /* 1155732 */   // Label 16902: @1155732
     /* 1155732 */   GIM_Try, /*On fail goto*//*Label 16903*/ GIMT_Encode4(1155812), // Rule ID 15605 //
     /* 1155737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1155748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1155751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1155754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155776 */     // MIs[0] round
     /* 1155776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1155789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155811 */     // GIR_Coverage, 15605,
     /* 1155811 */     GIR_EraseRootFromParent_Done,
     /* 1155812 */   // Label 16903: @1155812
     /* 1155812 */   GIM_Try, /*On fail goto*//*Label 16904*/ GIMT_Encode4(1155892), // Rule ID 15608 //
     /* 1155817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1155828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1155831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1155834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155856 */     // MIs[0] round
     /* 1155856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155891 */     // GIR_Coverage, 15608,
     /* 1155891 */     GIR_EraseRootFromParent_Done,
     /* 1155892 */   // Label 16904: @1155892
     /* 1155892 */   GIM_Try, /*On fail goto*//*Label 16905*/ GIMT_Encode4(1155972), // Rule ID 15609 //
     /* 1155897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1155908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1155911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1155914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1155932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155936 */     // MIs[0] round
     /* 1155936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1155949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155971 */     // GIR_Coverage, 15609,
     /* 1155971 */     GIR_EraseRootFromParent_Done,
     /* 1155972 */   // Label 16905: @1155972
     /* 1155972 */   GIM_Try, /*On fail goto*//*Label 16906*/ GIMT_Encode4(1156052), // Rule ID 15612 //
     /* 1155977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1155985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1155988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1155991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1155994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156016 */     // MIs[0] round
     /* 1156016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156051 */     // GIR_Coverage, 15612,
     /* 1156051 */     GIR_EraseRootFromParent_Done,
     /* 1156052 */   // Label 16906: @1156052
     /* 1156052 */   GIM_Try, /*On fail goto*//*Label 16907*/ GIMT_Encode4(1156132), // Rule ID 15613 //
     /* 1156057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1156068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1156071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1156074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156096 */     // MIs[0] round
     /* 1156096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156131 */     // GIR_Coverage, 15613,
     /* 1156131 */     GIR_EraseRootFromParent_Done,
     /* 1156132 */   // Label 16907: @1156132
     /* 1156132 */   GIM_Try, /*On fail goto*//*Label 16908*/ GIMT_Encode4(1156212), // Rule ID 15616 //
     /* 1156137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156176 */     // MIs[0] round
     /* 1156176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156211 */     // GIR_Coverage, 15616,
     /* 1156211 */     GIR_EraseRootFromParent_Done,
     /* 1156212 */   // Label 16908: @1156212
     /* 1156212 */   GIM_Try, /*On fail goto*//*Label 16909*/ GIMT_Encode4(1156292), // Rule ID 15617 //
     /* 1156217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1156228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1156231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1156234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156256 */     // MIs[0] round
     /* 1156256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156291 */     // GIR_Coverage, 15617,
     /* 1156291 */     GIR_EraseRootFromParent_Done,
     /* 1156292 */   // Label 16909: @1156292
     /* 1156292 */   GIM_Try, /*On fail goto*//*Label 16910*/ GIMT_Encode4(1156372), // Rule ID 15620 //
     /* 1156297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156336 */     // MIs[0] round
     /* 1156336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156371 */     // GIR_Coverage, 15620,
     /* 1156371 */     GIR_EraseRootFromParent_Done,
     /* 1156372 */   // Label 16910: @1156372
     /* 1156372 */   GIM_Try, /*On fail goto*//*Label 16911*/ GIMT_Encode4(1156452), // Rule ID 15621 //
     /* 1156377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1156388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1156391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1156394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156416 */     // MIs[0] round
     /* 1156416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1156429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156451 */     // GIR_Coverage, 15621,
     /* 1156451 */     GIR_EraseRootFromParent_Done,
     /* 1156452 */   // Label 16911: @1156452
     /* 1156452 */   GIM_Try, /*On fail goto*//*Label 16912*/ GIMT_Encode4(1156532), // Rule ID 15624 //
     /* 1156457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156496 */     // MIs[0] round
     /* 1156496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156506 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156531 */     // GIR_Coverage, 15624,
     /* 1156531 */     GIR_EraseRootFromParent_Done,
     /* 1156532 */   // Label 16912: @1156532
     /* 1156532 */   GIM_Try, /*On fail goto*//*Label 16913*/ GIMT_Encode4(1156612), // Rule ID 15625 //
     /* 1156537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1156548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1156551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1156554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156576 */     // MIs[0] round
     /* 1156576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156586 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1156589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156611 */     // GIR_Coverage, 15625,
     /* 1156611 */     GIR_EraseRootFromParent_Done,
     /* 1156612 */   // Label 16913: @1156612
     /* 1156612 */   GIM_Try, /*On fail goto*//*Label 16914*/ GIMT_Encode4(1156692), // Rule ID 15628 //
     /* 1156617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1156620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1156628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1156631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1156634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156656 */     // MIs[0] round
     /* 1156656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156666 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156691 */     // GIR_Coverage, 15628,
     /* 1156691 */     GIR_EraseRootFromParent_Done,
     /* 1156692 */   // Label 16914: @1156692
     /* 1156692 */   GIM_Try, /*On fail goto*//*Label 16915*/ GIMT_Encode4(1156772), // Rule ID 15629 //
     /* 1156697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1156700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1156705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1156708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1156711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1156714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156736 */     // MIs[0] round
     /* 1156736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1156749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1156767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156771 */     // GIR_Coverage, 15629,
     /* 1156771 */     GIR_EraseRootFromParent_Done,
     /* 1156772 */   // Label 16915: @1156772
     /* 1156772 */   GIM_Try, /*On fail goto*//*Label 16916*/ GIMT_Encode4(1156855), // Rule ID 15632 //
     /* 1156777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1156788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1156791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1156794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1156797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156816 */     // MIs[0] round
     /* 1156816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156826 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1156829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156854 */     // GIR_Coverage, 15632,
     /* 1156854 */     GIR_EraseRootFromParent_Done,
     /* 1156855 */   // Label 16916: @1156855
     /* 1156855 */   GIM_Try, /*On fail goto*//*Label 16917*/ GIMT_Encode4(1156938), // Rule ID 15633 //
     /* 1156860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1156871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1156874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1156877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1156880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156899 */     // MIs[0] round
     /* 1156899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156909 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1156912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156920 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156937 */     // GIR_Coverage, 15633,
     /* 1156937 */     GIR_EraseRootFromParent_Done,
     /* 1156938 */   // Label 16917: @1156938
     /* 1156938 */   GIM_Try, /*On fail goto*//*Label 16918*/ GIMT_Encode4(1157021), // Rule ID 15636 //
     /* 1156943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1156954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1156957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1156960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1156963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156982 */     // MIs[0] round
     /* 1156982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156992 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1156995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157020 */     // GIR_Coverage, 15636,
     /* 1157020 */     GIR_EraseRootFromParent_Done,
     /* 1157021 */   // Label 16918: @1157021
     /* 1157021 */   GIM_Try, /*On fail goto*//*Label 16919*/ GIMT_Encode4(1157104), // Rule ID 15637 //
     /* 1157026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1157037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1157040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1157043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1157046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157065 */     // MIs[0] round
     /* 1157065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157075 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157086 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157103 */     // GIR_Coverage, 15637,
     /* 1157103 */     GIR_EraseRootFromParent_Done,
     /* 1157104 */   // Label 16919: @1157104
     /* 1157104 */   GIM_Try, /*On fail goto*//*Label 16920*/ GIMT_Encode4(1157187), // Rule ID 15640 //
     /* 1157109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1157129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157148 */     // MIs[0] round
     /* 1157148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157158 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157186 */     // GIR_Coverage, 15640,
     /* 1157186 */     GIR_EraseRootFromParent_Done,
     /* 1157187 */   // Label 16920: @1157187
     /* 1157187 */   GIM_Try, /*On fail goto*//*Label 16921*/ GIMT_Encode4(1157270), // Rule ID 15641 //
     /* 1157192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1157203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1157206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1157209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1157212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157231 */     // MIs[0] round
     /* 1157231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157241 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157252 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157269 */     // GIR_Coverage, 15641,
     /* 1157269 */     GIR_EraseRootFromParent_Done,
     /* 1157270 */   // Label 16921: @1157270
     /* 1157270 */   GIM_Try, /*On fail goto*//*Label 16922*/ GIMT_Encode4(1157353), // Rule ID 15644 //
     /* 1157275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1157295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157314 */     // MIs[0] round
     /* 1157314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157352 */     // GIR_Coverage, 15644,
     /* 1157352 */     GIR_EraseRootFromParent_Done,
     /* 1157353 */   // Label 16922: @1157353
     /* 1157353 */   GIM_Try, /*On fail goto*//*Label 16923*/ GIMT_Encode4(1157436), // Rule ID 15645 //
     /* 1157358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1157369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1157372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1157375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1157378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157397 */     // MIs[0] round
     /* 1157397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157407 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1157410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157418 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157431 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157435 */     // GIR_Coverage, 15645,
     /* 1157435 */     GIR_EraseRootFromParent_Done,
     /* 1157436 */   // Label 16923: @1157436
     /* 1157436 */   GIM_Try, /*On fail goto*//*Label 16924*/ GIMT_Encode4(1157519), // Rule ID 15648 //
     /* 1157441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1157461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157480 */     // MIs[0] round
     /* 1157480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157518 */     // GIR_Coverage, 15648,
     /* 1157518 */     GIR_EraseRootFromParent_Done,
     /* 1157519 */   // Label 16924: @1157519
     /* 1157519 */   GIM_Try, /*On fail goto*//*Label 16925*/ GIMT_Encode4(1157602), // Rule ID 15649 //
     /* 1157524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1157535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1157538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1157541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1157544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157563 */     // MIs[0] round
     /* 1157563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157573 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157584 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157601 */     // GIR_Coverage, 15649,
     /* 1157601 */     GIR_EraseRootFromParent_Done,
     /* 1157602 */   // Label 16925: @1157602
     /* 1157602 */   GIM_Try, /*On fail goto*//*Label 16926*/ GIMT_Encode4(1157685), // Rule ID 15652 //
     /* 1157607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1157618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1157621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1157624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1157627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157646 */     // MIs[0] round
     /* 1157646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157656 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157684 */     // GIR_Coverage, 15652,
     /* 1157684 */     GIR_EraseRootFromParent_Done,
     /* 1157685 */   // Label 16926: @1157685
     /* 1157685 */   GIM_Try, /*On fail goto*//*Label 16927*/ GIMT_Encode4(1157768), // Rule ID 15653 //
     /* 1157690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1157701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1157704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1157707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1157710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157729 */     // MIs[0] round
     /* 1157729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157739 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1157742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157750 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157767 */     // GIR_Coverage, 15653,
     /* 1157767 */     GIR_EraseRootFromParent_Done,
     /* 1157768 */   // Label 16927: @1157768
     /* 1157768 */   GIM_Try, /*On fail goto*//*Label 16928*/ GIMT_Encode4(1157851), // Rule ID 15656 //
     /* 1157773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1157784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1157787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1157790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1157793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157812 */     // MIs[0] round
     /* 1157812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157822 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157850 */     // GIR_Coverage, 15656,
     /* 1157850 */     GIR_EraseRootFromParent_Done,
     /* 1157851 */   // Label 16928: @1157851
     /* 1157851 */   GIM_Try, /*On fail goto*//*Label 16929*/ GIMT_Encode4(1157934), // Rule ID 15657 //
     /* 1157856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1157867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1157870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1157873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1157876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157895 */     // MIs[0] round
     /* 1157895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157905 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157916 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157933 */     // GIR_Coverage, 15657,
     /* 1157933 */     GIR_EraseRootFromParent_Done,
     /* 1157934 */   // Label 16929: @1157934
     /* 1157934 */   GIM_Try, /*On fail goto*//*Label 16930*/ GIMT_Encode4(1158017), // Rule ID 15660 //
     /* 1157939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1157950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1157953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1157956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1157959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1157978 */     // MIs[0] round
     /* 1157978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157988 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1157991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158016 */     // GIR_Coverage, 15660,
     /* 1158016 */     GIR_EraseRootFromParent_Done,
     /* 1158017 */   // Label 16930: @1158017
     /* 1158017 */   GIM_Try, /*On fail goto*//*Label 16931*/ GIMT_Encode4(1158100), // Rule ID 15661 //
     /* 1158022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1158033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1158036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1158039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1158042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158061 */     // MIs[0] round
     /* 1158061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158071 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158082 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158099 */     // GIR_Coverage, 15661,
     /* 1158099 */     GIR_EraseRootFromParent_Done,
     /* 1158100 */   // Label 16931: @1158100
     /* 1158100 */   GIM_Try, /*On fail goto*//*Label 16932*/ GIMT_Encode4(1158183), // Rule ID 15664 //
     /* 1158105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1158125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158144 */     // MIs[0] round
     /* 1158144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158154 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158182 */     // GIR_Coverage, 15664,
     /* 1158182 */     GIR_EraseRootFromParent_Done,
     /* 1158183 */   // Label 16932: @1158183
     /* 1158183 */   GIM_Try, /*On fail goto*//*Label 16933*/ GIMT_Encode4(1158266), // Rule ID 15665 //
     /* 1158188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1158199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1158202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1158205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1158208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158227 */     // MIs[0] round
     /* 1158227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158237 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158248 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158265 */     // GIR_Coverage, 15665,
     /* 1158265 */     GIR_EraseRootFromParent_Done,
     /* 1158266 */   // Label 16933: @1158266
     /* 1158266 */   GIM_Try, /*On fail goto*//*Label 16934*/ GIMT_Encode4(1158349), // Rule ID 15668 //
     /* 1158271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1158291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158310 */     // MIs[0] round
     /* 1158310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158348 */     // GIR_Coverage, 15668,
     /* 1158348 */     GIR_EraseRootFromParent_Done,
     /* 1158349 */   // Label 16934: @1158349
     /* 1158349 */   GIM_Try, /*On fail goto*//*Label 16935*/ GIMT_Encode4(1158432), // Rule ID 15669 //
     /* 1158354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1158365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1158368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1158371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1158374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158393 */     // MIs[0] round
     /* 1158393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158403 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158414 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158431 */     // GIR_Coverage, 15669,
     /* 1158431 */     GIR_EraseRootFromParent_Done,
     /* 1158432 */   // Label 16935: @1158432
     /* 1158432 */   GIM_Try, /*On fail goto*//*Label 16936*/ GIMT_Encode4(1158515), // Rule ID 15672 //
     /* 1158437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1158457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158476 */     // MIs[0] round
     /* 1158476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158486 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158514 */     // GIR_Coverage, 15672,
     /* 1158514 */     GIR_EraseRootFromParent_Done,
     /* 1158515 */   // Label 16936: @1158515
     /* 1158515 */   GIM_Try, /*On fail goto*//*Label 16937*/ GIMT_Encode4(1158598), // Rule ID 15673 //
     /* 1158520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1158531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1158534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1158537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1158540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158559 */     // MIs[0] round
     /* 1158559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158569 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158580 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158597 */     // GIR_Coverage, 15673,
     /* 1158597 */     GIR_EraseRootFromParent_Done,
     /* 1158598 */   // Label 16937: @1158598
     /* 1158598 */   GIM_Try, /*On fail goto*//*Label 16938*/ GIMT_Encode4(1158681), // Rule ID 15676 //
     /* 1158603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1158614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1158617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1158620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1158623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158642 */     // MIs[0] round
     /* 1158642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158652 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158676 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158680 */     // GIR_Coverage, 15676,
     /* 1158680 */     GIR_EraseRootFromParent_Done,
     /* 1158681 */   // Label 16938: @1158681
     /* 1158681 */   GIM_Try, /*On fail goto*//*Label 16939*/ GIMT_Encode4(1158764), // Rule ID 15677 //
     /* 1158686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1158697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1158700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1158703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1158706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158725 */     // MIs[0] round
     /* 1158725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158735 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158746 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1158756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158763 */     // GIR_Coverage, 15677,
     /* 1158763 */     GIR_EraseRootFromParent_Done,
     /* 1158764 */   // Label 16939: @1158764
     /* 1158764 */   GIM_Try, /*On fail goto*//*Label 16940*/ GIMT_Encode4(1158847), // Rule ID 15680 //
     /* 1158769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1158780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1158783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1158786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1158789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158808 */     // MIs[0] round
     /* 1158808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158818 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158846 */     // GIR_Coverage, 15680,
     /* 1158846 */     GIR_EraseRootFromParent_Done,
     /* 1158847 */   // Label 16940: @1158847
     /* 1158847 */   GIM_Try, /*On fail goto*//*Label 16941*/ GIMT_Encode4(1158930), // Rule ID 15681 //
     /* 1158852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1158863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1158866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1158869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1158872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158891 */     // MIs[0] round
     /* 1158891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158912 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1158922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158929 */     // GIR_Coverage, 15681,
     /* 1158929 */     GIR_EraseRootFromParent_Done,
     /* 1158930 */   // Label 16941: @1158930
     /* 1158930 */   GIM_Try, /*On fail goto*//*Label 16942*/ GIMT_Encode4(1159013), // Rule ID 15684 //
     /* 1158935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1158938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1158946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1158949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1158952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1158955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158974 */     // MIs[0] round
     /* 1158974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159012 */     // GIR_Coverage, 15684,
     /* 1159012 */     GIR_EraseRootFromParent_Done,
     /* 1159013 */   // Label 16942: @1159013
     /* 1159013 */   GIM_Try, /*On fail goto*//*Label 16943*/ GIMT_Encode4(1159096), // Rule ID 15685 //
     /* 1159018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1159029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1159032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1159035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1159038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159057 */     // MIs[0] round
     /* 1159057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159067 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159078 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159095 */     // GIR_Coverage, 15685,
     /* 1159095 */     GIR_EraseRootFromParent_Done,
     /* 1159096 */   // Label 16943: @1159096
     /* 1159096 */   GIM_Try, /*On fail goto*//*Label 16944*/ GIMT_Encode4(1159179), // Rule ID 15688 //
     /* 1159101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1159121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159140 */     // MIs[0] round
     /* 1159140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159150 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159178 */     // GIR_Coverage, 15688,
     /* 1159178 */     GIR_EraseRootFromParent_Done,
     /* 1159179 */   // Label 16944: @1159179
     /* 1159179 */   GIM_Try, /*On fail goto*//*Label 16945*/ GIMT_Encode4(1159262), // Rule ID 15689 //
     /* 1159184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1159195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1159198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1159201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1159204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159223 */     // MIs[0] round
     /* 1159223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159233 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159244 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159261 */     // GIR_Coverage, 15689,
     /* 1159261 */     GIR_EraseRootFromParent_Done,
     /* 1159262 */   // Label 16945: @1159262
     /* 1159262 */   GIM_Try, /*On fail goto*//*Label 16946*/ GIMT_Encode4(1159345), // Rule ID 15692 //
     /* 1159267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1159287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159306 */     // MIs[0] round
     /* 1159306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159344 */     // GIR_Coverage, 15692,
     /* 1159344 */     GIR_EraseRootFromParent_Done,
     /* 1159345 */   // Label 16946: @1159345
     /* 1159345 */   GIM_Try, /*On fail goto*//*Label 16947*/ GIMT_Encode4(1159428), // Rule ID 15693 //
     /* 1159350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1159361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1159364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1159367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1159370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159389 */     // MIs[0] round
     /* 1159389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1159402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159410 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159427 */     // GIR_Coverage, 15693,
     /* 1159427 */     GIR_EraseRootFromParent_Done,
     /* 1159428 */   // Label 16947: @1159428
     /* 1159428 */   GIM_Try, /*On fail goto*//*Label 16948*/ GIMT_Encode4(1159511), // Rule ID 15696 //
     /* 1159433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1159453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159472 */     // MIs[0] round
     /* 1159472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159510 */     // GIR_Coverage, 15696,
     /* 1159510 */     GIR_EraseRootFromParent_Done,
     /* 1159511 */   // Label 16948: @1159511
     /* 1159511 */   GIM_Try, /*On fail goto*//*Label 16949*/ GIMT_Encode4(1159594), // Rule ID 15697 //
     /* 1159516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1159527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1159530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1159533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1159536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159555 */     // MIs[0] round
     /* 1159555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159565 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1159568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159576 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159593 */     // GIR_Coverage, 15697,
     /* 1159593 */     GIR_EraseRootFromParent_Done,
     /* 1159594 */   // Label 16949: @1159594
     /* 1159594 */   GIM_Try, /*On fail goto*//*Label 16950*/ GIMT_Encode4(1159677), // Rule ID 15700 //
     /* 1159599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1159610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1159613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1159616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1159619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159638 */     // MIs[0] round
     /* 1159638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159648 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159676 */     // GIR_Coverage, 15700,
     /* 1159676 */     GIR_EraseRootFromParent_Done,
     /* 1159677 */   // Label 16950: @1159677
     /* 1159677 */   GIM_Try, /*On fail goto*//*Label 16951*/ GIMT_Encode4(1159760), // Rule ID 15701 //
     /* 1159682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1159693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1159696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1159699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1159702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159721 */     // MIs[0] round
     /* 1159721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159731 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1159734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159742 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1159752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159759 */     // GIR_Coverage, 15701,
     /* 1159759 */     GIR_EraseRootFromParent_Done,
     /* 1159760 */   // Label 16951: @1159760
     /* 1159760 */   GIM_Try, /*On fail goto*//*Label 16952*/ GIMT_Encode4(1159843), // Rule ID 15704 //
     /* 1159765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1159776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1159779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159804 */     // MIs[0] round
     /* 1159804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159814 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1159817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159838 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159842 */     // GIR_Coverage, 15704,
     /* 1159842 */     GIR_EraseRootFromParent_Done,
     /* 1159843 */   // Label 16952: @1159843
     /* 1159843 */   GIM_Try, /*On fail goto*//*Label 16953*/ GIMT_Encode4(1159926), // Rule ID 15705 //
     /* 1159848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1159859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1159862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159887 */     // MIs[0] round
     /* 1159887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159897 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1159900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159908 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159925 */     // GIR_Coverage, 15705,
     /* 1159925 */     GIR_EraseRootFromParent_Done,
     /* 1159926 */   // Label 16953: @1159926
     /* 1159926 */   GIM_Try, /*On fail goto*//*Label 16954*/ GIMT_Encode4(1160009), // Rule ID 15708 //
     /* 1159931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1159942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1159945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1159948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159970 */     // MIs[0] round
     /* 1159970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159980 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1159983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160008 */     // GIR_Coverage, 15708,
     /* 1160008 */     GIR_EraseRootFromParent_Done,
     /* 1160009 */   // Label 16954: @1160009
     /* 1160009 */   GIM_Try, /*On fail goto*//*Label 16955*/ GIMT_Encode4(1160092), // Rule ID 15709 //
     /* 1160014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1160025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1160028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1160031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160053 */     // MIs[0] round
     /* 1160053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160063 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160074 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160091 */     // GIR_Coverage, 15709,
     /* 1160091 */     GIR_EraseRootFromParent_Done,
     /* 1160092 */   // Label 16955: @1160092
     /* 1160092 */   GIM_Try, /*On fail goto*//*Label 16956*/ GIMT_Encode4(1160175), // Rule ID 15712 //
     /* 1160097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1160108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1160111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1160114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160136 */     // MIs[0] round
     /* 1160136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160146 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160174 */     // GIR_Coverage, 15712,
     /* 1160174 */     GIR_EraseRootFromParent_Done,
     /* 1160175 */   // Label 16956: @1160175
     /* 1160175 */   GIM_Try, /*On fail goto*//*Label 16957*/ GIMT_Encode4(1160258), // Rule ID 15713 //
     /* 1160180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1160191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1160194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1160197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160219 */     // MIs[0] round
     /* 1160219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160229 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160240 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160257 */     // GIR_Coverage, 15713,
     /* 1160257 */     GIR_EraseRootFromParent_Done,
     /* 1160258 */   // Label 16957: @1160258
     /* 1160258 */   GIM_Try, /*On fail goto*//*Label 16958*/ GIMT_Encode4(1160341), // Rule ID 15716 //
     /* 1160263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1160274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1160277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160302 */     // MIs[0] round
     /* 1160302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160312 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160340 */     // GIR_Coverage, 15716,
     /* 1160340 */     GIR_EraseRootFromParent_Done,
     /* 1160341 */   // Label 16958: @1160341
     /* 1160341 */   GIM_Try, /*On fail goto*//*Label 16959*/ GIMT_Encode4(1160424), // Rule ID 15717 //
     /* 1160346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1160357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1160360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1160363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160385 */     // MIs[0] round
     /* 1160385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160395 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1160398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160406 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160419 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160423 */     // GIR_Coverage, 15717,
     /* 1160423 */     GIR_EraseRootFromParent_Done,
     /* 1160424 */   // Label 16959: @1160424
     /* 1160424 */   GIM_Try, /*On fail goto*//*Label 16960*/ GIMT_Encode4(1160507), // Rule ID 15720 //
     /* 1160429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160468 */     // MIs[0] round
     /* 1160468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160478 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160506 */     // GIR_Coverage, 15720,
     /* 1160506 */     GIR_EraseRootFromParent_Done,
     /* 1160507 */   // Label 16960: @1160507
     /* 1160507 */   GIM_Try, /*On fail goto*//*Label 16961*/ GIMT_Encode4(1160590), // Rule ID 15721 //
     /* 1160512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160551 */     // MIs[0] round
     /* 1160551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160561 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160572 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160589 */     // GIR_Coverage, 15721,
     /* 1160589 */     GIR_EraseRootFromParent_Done,
     /* 1160590 */   // Label 16961: @1160590
     /* 1160590 */   GIM_Try, /*On fail goto*//*Label 16962*/ GIMT_Encode4(1160673), // Rule ID 15724 //
     /* 1160595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1160606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1160609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160634 */     // MIs[0] round
     /* 1160634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160644 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160672 */     // GIR_Coverage, 15724,
     /* 1160672 */     GIR_EraseRootFromParent_Done,
     /* 1160673 */   // Label 16962: @1160673
     /* 1160673 */   GIM_Try, /*On fail goto*//*Label 16963*/ GIMT_Encode4(1160756), // Rule ID 15725 //
     /* 1160678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1160689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1160692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160717 */     // MIs[0] round
     /* 1160717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160727 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1160730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160738 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160755 */     // GIR_Coverage, 15725,
     /* 1160755 */     GIR_EraseRootFromParent_Done,
     /* 1160756 */   // Label 16963: @1160756
     /* 1160756 */   GIM_Try, /*On fail goto*//*Label 16964*/ GIMT_Encode4(1160839), // Rule ID 15728 //
     /* 1160761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1160772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1160775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160800 */     // MIs[0] round
     /* 1160800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160810 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160838 */     // GIR_Coverage, 15728,
     /* 1160838 */     GIR_EraseRootFromParent_Done,
     /* 1160839 */   // Label 16964: @1160839
     /* 1160839 */   GIM_Try, /*On fail goto*//*Label 16965*/ GIMT_Encode4(1160922), // Rule ID 15729 //
     /* 1160844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1160855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1160858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1160864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160883 */     // MIs[0] round
     /* 1160883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160893 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11561:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160904 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1160920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160921 */     // GIR_Coverage, 15729,
     /* 1160921 */     GIR_EraseRootFromParent_Done,
     /* 1160922 */   // Label 16965: @1160922
     /* 1160922 */   GIM_Try, /*On fail goto*//*Label 16966*/ GIMT_Encode4(1161005), // Rule ID 15732 //
     /* 1160927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1160935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1160938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1160941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1160944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1160947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1160966 */     // MIs[0] round
     /* 1160966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1160979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161004 */     // GIR_Coverage, 15732,
     /* 1161004 */     GIR_EraseRootFromParent_Done,
     /* 1161005 */   // Label 16966: @1161005
     /* 1161005 */   GIM_Try, /*On fail goto*//*Label 16967*/ GIMT_Encode4(1161088), // Rule ID 15733 //
     /* 1161010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1161021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1161024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1161027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161049 */     // MIs[0] round
     /* 1161049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161059 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11561:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161087 */     // GIR_Coverage, 15733,
     /* 1161087 */     GIR_EraseRootFromParent_Done,
     /* 1161088 */   // Label 16967: @1161088
     /* 1161088 */   GIM_Try, /*On fail goto*//*Label 16968*/ GIMT_Encode4(1161171), // Rule ID 15736 //
     /* 1161093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1161104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1161107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1161110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161132 */     // MIs[0] round
     /* 1161132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161142 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161170 */     // GIR_Coverage, 15736,
     /* 1161170 */     GIR_EraseRootFromParent_Done,
     /* 1161171 */   // Label 16968: @1161171
     /* 1161171 */   GIM_Try, /*On fail goto*//*Label 16969*/ GIMT_Encode4(1161254), // Rule ID 15737 //
     /* 1161176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1161187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1161190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1161193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1161211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161215 */     // MIs[0] round
     /* 1161215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11561:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1161228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161236 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1161246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161253 */     // GIR_Coverage, 15737,
     /* 1161253 */     GIR_EraseRootFromParent_Done,
     /* 1161254 */   // Label 16969: @1161254
     /* 1161254 */   GIM_Try, /*On fail goto*//*Label 16970*/ GIMT_Encode4(1161337), // Rule ID 15740 //
     /* 1161259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161298 */     // MIs[0] round
     /* 1161298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161308 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161336 */     // GIR_Coverage, 15740,
     /* 1161336 */     GIR_EraseRootFromParent_Done,
     /* 1161337 */   // Label 16970: @1161337
     /* 1161337 */   GIM_Try, /*On fail goto*//*Label 16971*/ GIMT_Encode4(1161420), // Rule ID 15741 //
     /* 1161342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161381 */     // MIs[0] round
     /* 1161381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161391 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161402 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161419 */     // GIR_Coverage, 15741,
     /* 1161419 */     GIR_EraseRootFromParent_Done,
     /* 1161420 */   // Label 16971: @1161420
     /* 1161420 */   GIM_Try, /*On fail goto*//*Label 16972*/ GIMT_Encode4(1161503), // Rule ID 15744 //
     /* 1161425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161464 */     // MIs[0] round
     /* 1161464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161474 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161502 */     // GIR_Coverage, 15744,
     /* 1161502 */     GIR_EraseRootFromParent_Done,
     /* 1161503 */   // Label 16972: @1161503
     /* 1161503 */   GIM_Try, /*On fail goto*//*Label 16973*/ GIMT_Encode4(1161586), // Rule ID 15745 //
     /* 1161508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161547 */     // MIs[0] round
     /* 1161547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161557 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161568 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161581 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161585 */     // GIR_Coverage, 15745,
     /* 1161585 */     GIR_EraseRootFromParent_Done,
     /* 1161586 */   // Label 16973: @1161586
     /* 1161586 */   GIM_Try, /*On fail goto*//*Label 16974*/ GIMT_Encode4(1161669), // Rule ID 15748 //
     /* 1161591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1161602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1161605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161630 */     // MIs[0] round
     /* 1161630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161640 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1161643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161668 */     // GIR_Coverage, 15748,
     /* 1161668 */     GIR_EraseRootFromParent_Done,
     /* 1161669 */   // Label 16974: @1161669
     /* 1161669 */   GIM_Try, /*On fail goto*//*Label 16975*/ GIMT_Encode4(1161752), // Rule ID 15749 //
     /* 1161674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1161685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1161688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161713 */     // MIs[0] round
     /* 1161713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161723 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1161726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161734 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161751 */     // GIR_Coverage, 15749,
     /* 1161751 */     GIR_EraseRootFromParent_Done,
     /* 1161752 */   // Label 16975: @1161752
     /* 1161752 */   GIM_Try, /*On fail goto*//*Label 16976*/ GIMT_Encode4(1161835), // Rule ID 15752 //
     /* 1161757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1161768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1161771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161796 */     // MIs[0] round
     /* 1161796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161834 */     // GIR_Coverage, 15752,
     /* 1161834 */     GIR_EraseRootFromParent_Done,
     /* 1161835 */   // Label 16976: @1161835
     /* 1161835 */   GIM_Try, /*On fail goto*//*Label 16977*/ GIMT_Encode4(1161918), // Rule ID 15753 //
     /* 1161840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1161851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1161854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1161860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161879 */     // MIs[0] round
     /* 1161879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161889 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1161892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161900 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161917 */     // GIR_Coverage, 15753,
     /* 1161917 */     GIR_EraseRootFromParent_Done,
     /* 1161918 */   // Label 16977: @1161918
     /* 1161918 */   GIM_Try, /*On fail goto*//*Label 16978*/ GIMT_Encode4(1162001), // Rule ID 15756 //
     /* 1161923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1161931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1161934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1161937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1161940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1161943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1161962 */     // MIs[0] round
     /* 1161962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1161975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1161999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162000 */     // GIR_Coverage, 15756,
     /* 1162000 */     GIR_EraseRootFromParent_Done,
     /* 1162001 */   // Label 16978: @1162001
     /* 1162001 */   GIM_Try, /*On fail goto*//*Label 16979*/ GIMT_Encode4(1162084), // Rule ID 15757 //
     /* 1162006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1162017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1162020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1162023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162045 */     // MIs[0] round
     /* 1162045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162055 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162066 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162083 */     // GIR_Coverage, 15757,
     /* 1162083 */     GIR_EraseRootFromParent_Done,
     /* 1162084 */   // Label 16979: @1162084
     /* 1162084 */   GIM_Try, /*On fail goto*//*Label 16980*/ GIMT_Encode4(1162167), // Rule ID 15760 //
     /* 1162089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1162100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1162103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162128 */     // MIs[0] round
     /* 1162128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162138 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162166 */     // GIR_Coverage, 15760,
     /* 1162166 */     GIR_EraseRootFromParent_Done,
     /* 1162167 */   // Label 16980: @1162167
     /* 1162167 */   GIM_Try, /*On fail goto*//*Label 16981*/ GIMT_Encode4(1162250), // Rule ID 15761 //
     /* 1162172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1162183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1162186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1162189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162211 */     // MIs[0] round
     /* 1162211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162221 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162232 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1162242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162249 */     // GIR_Coverage, 15761,
     /* 1162249 */     GIR_EraseRootFromParent_Done,
     /* 1162250 */   // Label 16981: @1162250
     /* 1162250 */   GIM_Try, /*On fail goto*//*Label 16982*/ GIMT_Encode4(1162333), // Rule ID 15764 //
     /* 1162255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162294 */     // MIs[0] round
     /* 1162294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162304 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162332 */     // GIR_Coverage, 15764,
     /* 1162332 */     GIR_EraseRootFromParent_Done,
     /* 1162333 */   // Label 16982: @1162333
     /* 1162333 */   GIM_Try, /*On fail goto*//*Label 16983*/ GIMT_Encode4(1162416), // Rule ID 15765 //
     /* 1162338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162377 */     // MIs[0] round
     /* 1162377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1162390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162398 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162415 */     // GIR_Coverage, 15765,
     /* 1162415 */     GIR_EraseRootFromParent_Done,
     /* 1162416 */   // Label 16983: @1162416
     /* 1162416 */   GIM_Try, /*On fail goto*//*Label 16984*/ GIMT_Encode4(1162499), // Rule ID 15768 //
     /* 1162421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162460 */     // MIs[0] round
     /* 1162460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162498 */     // GIR_Coverage, 15768,
     /* 1162498 */     GIR_EraseRootFromParent_Done,
     /* 1162499 */   // Label 16984: @1162499
     /* 1162499 */   GIM_Try, /*On fail goto*//*Label 16985*/ GIMT_Encode4(1162582), // Rule ID 15769 //
     /* 1162504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162543 */     // MIs[0] round
     /* 1162543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162553 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1162556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162564 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162581 */     // GIR_Coverage, 15769,
     /* 1162581 */     GIR_EraseRootFromParent_Done,
     /* 1162582 */   // Label 16985: @1162582
     /* 1162582 */   GIM_Try, /*On fail goto*//*Label 16986*/ GIMT_Encode4(1162665), // Rule ID 15772 //
     /* 1162587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1162598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1162601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162626 */     // MIs[0] round
     /* 1162626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162636 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162664 */     // GIR_Coverage, 15772,
     /* 1162664 */     GIR_EraseRootFromParent_Done,
     /* 1162665 */   // Label 16986: @1162665
     /* 1162665 */   GIM_Try, /*On fail goto*//*Label 16987*/ GIMT_Encode4(1162748), // Rule ID 15773 //
     /* 1162670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1162681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1162684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1162690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162709 */     // MIs[0] round
     /* 1162709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162719 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1162722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162730 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162747 */     // GIR_Coverage, 15773,
     /* 1162747 */     GIR_EraseRootFromParent_Done,
     /* 1162748 */   // Label 16987: @1162748
     /* 1162748 */   GIM_Try, /*On fail goto*//*Label 16988*/ GIMT_Encode4(1162831), // Rule ID 15776 //
     /* 1162753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1162756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1162764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1162767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1162770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1162773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162792 */     // MIs[0] round
     /* 1162792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162802 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1162805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162830 */     // GIR_Coverage, 15776,
     /* 1162830 */     GIR_EraseRootFromParent_Done,
     /* 1162831 */   // Label 16988: @1162831
     /* 1162831 */   GIM_Try, /*On fail goto*//*Label 16989*/ GIMT_Encode4(1162914), // Rule ID 15777 //
     /* 1162836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1162839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1162847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1162850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1162853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1162856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162875 */     // MIs[0] round
     /* 1162875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162885 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1162888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162896 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162913 */     // GIR_Coverage, 15777,
     /* 1162913 */     GIR_EraseRootFromParent_Done,
     /* 1162914 */   // Label 16989: @1162914
     /* 1162914 */   GIM_Try, /*On fail goto*//*Label 16990*/ GIMT_Encode4(1162997), // Rule ID 15780 //
     /* 1162919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1162922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1162927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1162930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1162933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1162936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1162939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162958 */     // MIs[0] round
     /* 1162958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1162971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1162995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162996 */     // GIR_Coverage, 15780,
     /* 1162996 */     GIR_EraseRootFromParent_Done,
     /* 1162997 */   // Label 16990: @1162997
     /* 1162997 */   GIM_Try, /*On fail goto*//*Label 16991*/ GIMT_Encode4(1163080), // Rule ID 15781 //
     /* 1163002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1163022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163041 */     // MIs[0] round
     /* 1163041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1163054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163062 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163079 */     // GIR_Coverage, 15781,
     /* 1163079 */     GIR_EraseRootFromParent_Done,
     /* 1163080 */   // Label 16991: @1163080
     /* 1163080 */   GIM_Try, /*On fail goto*//*Label 16992*/ GIMT_Encode4(1163163), // Rule ID 15784 //
     /* 1163085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1163105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163124 */     // MIs[0] round
     /* 1163124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163162 */     // GIR_Coverage, 15784,
     /* 1163162 */     GIR_EraseRootFromParent_Done,
     /* 1163163 */   // Label 16992: @1163163
     /* 1163163 */   GIM_Try, /*On fail goto*//*Label 16993*/ GIMT_Encode4(1163246), // Rule ID 15785 //
     /* 1163168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1163188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163207 */     // MIs[0] round
     /* 1163207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163217 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1163220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163228 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163245 */     // GIR_Coverage, 15785,
     /* 1163245 */     GIR_EraseRootFromParent_Done,
     /* 1163246 */   // Label 16993: @1163246
     /* 1163246 */   GIM_Try, /*On fail goto*//*Label 16994*/ GIMT_Encode4(1163329), // Rule ID 15788 //
     /* 1163251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163290 */     // MIs[0] round
     /* 1163290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163300 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163328 */     // GIR_Coverage, 15788,
     /* 1163328 */     GIR_EraseRootFromParent_Done,
     /* 1163329 */   // Label 16994: @1163329
     /* 1163329 */   GIM_Try, /*On fail goto*//*Label 16995*/ GIMT_Encode4(1163412), // Rule ID 15789 //
     /* 1163334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1163354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163373 */     // MIs[0] round
     /* 1163373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163383 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1163386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163394 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163411 */     // GIR_Coverage, 15789,
     /* 1163411 */     GIR_EraseRootFromParent_Done,
     /* 1163412 */   // Label 16995: @1163412
     /* 1163412 */   GIM_Try, /*On fail goto*//*Label 16996*/ GIMT_Encode4(1163495), // Rule ID 15792 //
     /* 1163417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163456 */     // MIs[0] round
     /* 1163456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1163469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163494 */     // GIR_Coverage, 15792,
     /* 1163494 */     GIR_EraseRootFromParent_Done,
     /* 1163495 */   // Label 16996: @1163495
     /* 1163495 */   GIM_Try, /*On fail goto*//*Label 16997*/ GIMT_Encode4(1163578), // Rule ID 15793 //
     /* 1163500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1163511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1163514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1163517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163539 */     // MIs[0] round
     /* 1163539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163549 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11561:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1163552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163560 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163577 */     // GIR_Coverage, 15793,
     /* 1163577 */     GIR_EraseRootFromParent_Done,
     /* 1163578 */   // Label 16997: @1163578
     /* 1163578 */   GIM_Try, /*On fail goto*//*Label 16998*/ GIMT_Encode4(1163661), // Rule ID 15796 //
     /* 1163583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163622 */     // MIs[0] round
     /* 1163622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163632 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1163635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163660 */     // GIR_Coverage, 15796,
     /* 1163660 */     GIR_EraseRootFromParent_Done,
     /* 1163661 */   // Label 16998: @1163661
     /* 1163661 */   GIM_Try, /*On fail goto*//*Label 16999*/ GIMT_Encode4(1163744), // Rule ID 15797 //
     /* 1163666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1163677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1163680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1163683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1163701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163705 */     // MIs[0] round
     /* 1163705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163715 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11561:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1163718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163726 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163743 */     // GIR_Coverage, 15797,
     /* 1163743 */     GIR_EraseRootFromParent_Done,
     /* 1163744 */   // Label 16999: @1163744
     /* 1163744 */   GIM_Try, /*On fail goto*//*Label 17000*/ GIMT_Encode4(1163827), // Rule ID 15800 //
     /* 1163749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163788 */     // MIs[0] round
     /* 1163788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163798 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1163801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163826 */     // GIR_Coverage, 15800,
     /* 1163826 */     GIR_EraseRootFromParent_Done,
     /* 1163827 */   // Label 17000: @1163827
     /* 1163827 */   GIM_Try, /*On fail goto*//*Label 17001*/ GIMT_Encode4(1163910), // Rule ID 15801 //
     /* 1163832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1163835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1163843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1163846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1163849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1163867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163871 */     // MIs[0] round
     /* 1163871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163881 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11561:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1163884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163892 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163909 */     // GIR_Coverage, 15801,
     /* 1163909 */     GIR_EraseRootFromParent_Done,
     /* 1163910 */   // Label 17001: @1163910
     /* 1163910 */   GIM_Try, /*On fail goto*//*Label 17002*/ GIMT_Encode4(1163993), // Rule ID 15804 //
     /* 1163915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1163918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1163923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1163926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1163929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1163932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1163950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163954 */     // MIs[0] round
     /* 1163954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163964 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1163967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1163985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1163991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163992 */     // GIR_Coverage, 15804,
     /* 1163992 */     GIR_EraseRootFromParent_Done,
     /* 1163993 */   // Label 17002: @1163993
     /* 1163993 */   GIM_Try, /*On fail goto*//*Label 17003*/ GIMT_Encode4(1164076), // Rule ID 15805 //
     /* 1163998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1164001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1164006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1164009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1164012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1164015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164037 */     // MIs[0] round
     /* 1164037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164047 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11561:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1164050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164058 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1164074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164075 */     // GIR_Coverage, 15805,
     /* 1164075 */     GIR_EraseRootFromParent_Done,
     /* 1164076 */   // Label 17003: @1164076
     /* 1164076 */   GIM_Try, /*On fail goto*//*Label 17004*/ GIMT_Encode4(1164156), // Rule ID 15808 //
     /* 1164081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1164092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1164095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1164098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1164101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164120 */     // MIs[0] round
     /* 1164120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164130 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1164133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164155 */     // GIR_Coverage, 15808,
     /* 1164155 */     GIR_EraseRootFromParent_Done,
     /* 1164156 */   // Label 17004: @1164156
     /* 1164156 */   GIM_Try, /*On fail goto*//*Label 17005*/ GIMT_Encode4(1164236), // Rule ID 15809 //
     /* 1164161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1164172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1164175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1164178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1164181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164200 */     // MIs[0] round
     /* 1164200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164210 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1164213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164235 */     // GIR_Coverage, 15809,
     /* 1164235 */     GIR_EraseRootFromParent_Done,
     /* 1164236 */   // Label 17005: @1164236
     /* 1164236 */   GIM_Try, /*On fail goto*//*Label 17006*/ GIMT_Encode4(1164316), // Rule ID 15812 //
     /* 1164241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1164252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1164255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1164258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1164261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164280 */     // MIs[0] round
     /* 1164280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164290 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164315 */     // GIR_Coverage, 15812,
     /* 1164315 */     GIR_EraseRootFromParent_Done,
     /* 1164316 */   // Label 17006: @1164316
     /* 1164316 */   GIM_Try, /*On fail goto*//*Label 17007*/ GIMT_Encode4(1164396), // Rule ID 15813 //
     /* 1164321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1164332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1164335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1164338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1164341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164360 */     // MIs[0] round
     /* 1164360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164370 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164395 */     // GIR_Coverage, 15813,
     /* 1164395 */     GIR_EraseRootFromParent_Done,
     /* 1164396 */   // Label 17007: @1164396
     /* 1164396 */   GIM_Try, /*On fail goto*//*Label 17008*/ GIMT_Encode4(1164476), // Rule ID 15816 //
     /* 1164401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164440 */     // MIs[0] round
     /* 1164440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164475 */     // GIR_Coverage, 15816,
     /* 1164475 */     GIR_EraseRootFromParent_Done,
     /* 1164476 */   // Label 17008: @1164476
     /* 1164476 */   GIM_Try, /*On fail goto*//*Label 17009*/ GIMT_Encode4(1164556), // Rule ID 15817 //
     /* 1164481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1164492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1164495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1164498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1164501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164520 */     // MIs[0] round
     /* 1164520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164530 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164555 */     // GIR_Coverage, 15817,
     /* 1164555 */     GIR_EraseRootFromParent_Done,
     /* 1164556 */   // Label 17009: @1164556
     /* 1164556 */   GIM_Try, /*On fail goto*//*Label 17010*/ GIMT_Encode4(1164636), // Rule ID 15820 //
     /* 1164561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1164572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1164575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1164578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1164581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164600 */     // MIs[0] round
     /* 1164600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164610 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164635 */     // GIR_Coverage, 15820,
     /* 1164635 */     GIR_EraseRootFromParent_Done,
     /* 1164636 */   // Label 17010: @1164636
     /* 1164636 */   GIM_Try, /*On fail goto*//*Label 17011*/ GIMT_Encode4(1164716), // Rule ID 15821 //
     /* 1164641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1164652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1164655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1164658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1164661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164680 */     // MIs[0] round
     /* 1164680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1164693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164715 */     // GIR_Coverage, 15821,
     /* 1164715 */     GIR_EraseRootFromParent_Done,
     /* 1164716 */   // Label 17011: @1164716
     /* 1164716 */   GIM_Try, /*On fail goto*//*Label 17012*/ GIMT_Encode4(1164796), // Rule ID 15824 //
     /* 1164721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1164732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1164735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1164738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1164741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164760 */     // MIs[0] round
     /* 1164760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164770 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164795 */     // GIR_Coverage, 15824,
     /* 1164795 */     GIR_EraseRootFromParent_Done,
     /* 1164796 */   // Label 17012: @1164796
     /* 1164796 */   GIM_Try, /*On fail goto*//*Label 17013*/ GIMT_Encode4(1164876), // Rule ID 15825 //
     /* 1164801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1164812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1164815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1164818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1164821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164840 */     // MIs[0] round
     /* 1164840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164850 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164875 */     // GIR_Coverage, 15825,
     /* 1164875 */     GIR_EraseRootFromParent_Done,
     /* 1164876 */   // Label 17013: @1164876
     /* 1164876 */   GIM_Try, /*On fail goto*//*Label 17014*/ GIMT_Encode4(1164956), // Rule ID 15828 //
     /* 1164881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1164892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1164895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1164901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164920 */     // MIs[0] round
     /* 1164920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1164933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164955 */     // GIR_Coverage, 15828,
     /* 1164955 */     GIR_EraseRootFromParent_Done,
     /* 1164956 */   // Label 17014: @1164956
     /* 1164956 */   GIM_Try, /*On fail goto*//*Label 17015*/ GIMT_Encode4(1165036), // Rule ID 15829 //
     /* 1164961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1164972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1164975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1164978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1164981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165000 */     // MIs[0] round
     /* 1165000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165010 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1165013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165035 */     // GIR_Coverage, 15829,
     /* 1165035 */     GIR_EraseRootFromParent_Done,
     /* 1165036 */   // Label 17015: @1165036
     /* 1165036 */   GIM_Try, /*On fail goto*//*Label 17016*/ GIMT_Encode4(1165116), // Rule ID 15832 //
     /* 1165041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1165052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1165055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1165058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1165061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165080 */     // MIs[0] round
     /* 1165080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165115 */     // GIR_Coverage, 15832,
     /* 1165115 */     GIR_EraseRootFromParent_Done,
     /* 1165116 */   // Label 17016: @1165116
     /* 1165116 */   GIM_Try, /*On fail goto*//*Label 17017*/ GIMT_Encode4(1165196), // Rule ID 15833 //
     /* 1165121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1165132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1165135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1165138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1165141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165160 */     // MIs[0] round
     /* 1165160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165195 */     // GIR_Coverage, 15833,
     /* 1165195 */     GIR_EraseRootFromParent_Done,
     /* 1165196 */   // Label 17017: @1165196
     /* 1165196 */   GIM_Try, /*On fail goto*//*Label 17018*/ GIMT_Encode4(1165276), // Rule ID 15836 //
     /* 1165201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1165212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1165215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1165218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1165221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165240 */     // MIs[0] round
     /* 1165240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165275 */     // GIR_Coverage, 15836,
     /* 1165275 */     GIR_EraseRootFromParent_Done,
     /* 1165276 */   // Label 17018: @1165276
     /* 1165276 */   GIM_Try, /*On fail goto*//*Label 17019*/ GIMT_Encode4(1165356), // Rule ID 15837 //
     /* 1165281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1165292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1165295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1165298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1165301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165320 */     // MIs[0] round
     /* 1165320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165355 */     // GIR_Coverage, 15837,
     /* 1165355 */     GIR_EraseRootFromParent_Done,
     /* 1165356 */   // Label 17019: @1165356
     /* 1165356 */   GIM_Try, /*On fail goto*//*Label 17020*/ GIMT_Encode4(1165436), // Rule ID 15840 //
     /* 1165361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165400 */     // MIs[0] round
     /* 1165400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165435 */     // GIR_Coverage, 15840,
     /* 1165435 */     GIR_EraseRootFromParent_Done,
     /* 1165436 */   // Label 17020: @1165436
     /* 1165436 */   GIM_Try, /*On fail goto*//*Label 17021*/ GIMT_Encode4(1165516), // Rule ID 15841 //
     /* 1165441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1165452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1165455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1165458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1165461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165480 */     // MIs[0] round
     /* 1165480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165515 */     // GIR_Coverage, 15841,
     /* 1165515 */     GIR_EraseRootFromParent_Done,
     /* 1165516 */   // Label 17021: @1165516
     /* 1165516 */   GIM_Try, /*On fail goto*//*Label 17022*/ GIMT_Encode4(1165596), // Rule ID 15844 //
     /* 1165521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1165524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1165532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1165535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1165538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1165541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165560 */     // MIs[0] round
     /* 1165560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165570 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1165591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165595 */     // GIR_Coverage, 15844,
     /* 1165595 */     GIR_EraseRootFromParent_Done,
     /* 1165596 */   // Label 17022: @1165596
     /* 1165596 */   GIM_Try, /*On fail goto*//*Label 17023*/ GIMT_Encode4(1165676), // Rule ID 15845 //
     /* 1165601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1165604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1165612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1165615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1165618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1165621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1165640 */     // MIs[0] round
     /* 1165640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1165653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1165671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165675 */     // GIR_Coverage, 15845,
     /* 1165675 */     GIR_EraseRootFromParent_Done,
     /* 1165676 */   // Label 17023: @1165676
     /* 1165676 */   GIM_Try, /*On fail goto*//*Label 17024*/ GIMT_Encode4(1165756), // Rule ID 15848 //
     /* 1165681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1165692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1165695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1165698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1165701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165720 */     // MIs[0] round
     /* 1165720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1165733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165755 */     // GIR_Coverage, 15848,
     /* 1165755 */     GIR_EraseRootFromParent_Done,
     /* 1165756 */   // Label 17024: @1165756
     /* 1165756 */   GIM_Try, /*On fail goto*//*Label 17025*/ GIMT_Encode4(1165836), // Rule ID 15849 //
     /* 1165761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1165772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1165775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1165778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1165781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165800 */     // MIs[0] round
     /* 1165800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1165813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165835 */     // GIR_Coverage, 15849,
     /* 1165835 */     GIR_EraseRootFromParent_Done,
     /* 1165836 */   // Label 17025: @1165836
     /* 1165836 */   GIM_Try, /*On fail goto*//*Label 17026*/ GIMT_Encode4(1165916), // Rule ID 15852 //
     /* 1165841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1165852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1165855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1165861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165880 */     // MIs[0] round
     /* 1165880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165890 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1165893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165915 */     // GIR_Coverage, 15852,
     /* 1165915 */     GIR_EraseRootFromParent_Done,
     /* 1165916 */   // Label 17026: @1165916
     /* 1165916 */   GIM_Try, /*On fail goto*//*Label 17027*/ GIMT_Encode4(1165996), // Rule ID 15853 //
     /* 1165921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1165932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1165935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1165938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1165941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165960 */     // MIs[0] round
     /* 1165960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165970 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1165973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165995 */     // GIR_Coverage, 15853,
     /* 1165995 */     GIR_EraseRootFromParent_Done,
     /* 1165996 */   // Label 17027: @1165996
     /* 1165996 */   GIM_Try, /*On fail goto*//*Label 17028*/ GIMT_Encode4(1166076), // Rule ID 15856 //
     /* 1166001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1166012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1166015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1166018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1166021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166040 */     // MIs[0] round
     /* 1166040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166050 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166075 */     // GIR_Coverage, 15856,
     /* 1166075 */     GIR_EraseRootFromParent_Done,
     /* 1166076 */   // Label 17028: @1166076
     /* 1166076 */   GIM_Try, /*On fail goto*//*Label 17029*/ GIMT_Encode4(1166156), // Rule ID 15857 //
     /* 1166081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1166092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1166095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1166098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1166101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166120 */     // MIs[0] round
     /* 1166120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166130 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166155 */     // GIR_Coverage, 15857,
     /* 1166155 */     GIR_EraseRootFromParent_Done,
     /* 1166156 */   // Label 17029: @1166156
     /* 1166156 */   GIM_Try, /*On fail goto*//*Label 17030*/ GIMT_Encode4(1166236), // Rule ID 15860 //
     /* 1166161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1166172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1166175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1166178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1166181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166200 */     // MIs[0] round
     /* 1166200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166210 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166235 */     // GIR_Coverage, 15860,
     /* 1166235 */     GIR_EraseRootFromParent_Done,
     /* 1166236 */   // Label 17030: @1166236
     /* 1166236 */   GIM_Try, /*On fail goto*//*Label 17031*/ GIMT_Encode4(1166316), // Rule ID 15861 //
     /* 1166241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1166252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1166255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1166258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1166261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166280 */     // MIs[0] round
     /* 1166280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166290 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166315 */     // GIR_Coverage, 15861,
     /* 1166315 */     GIR_EraseRootFromParent_Done,
     /* 1166316 */   // Label 17031: @1166316
     /* 1166316 */   GIM_Try, /*On fail goto*//*Label 17032*/ GIMT_Encode4(1166396), // Rule ID 15864 //
     /* 1166321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166360 */     // MIs[0] round
     /* 1166360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166370 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166395 */     // GIR_Coverage, 15864,
     /* 1166395 */     GIR_EraseRootFromParent_Done,
     /* 1166396 */   // Label 17032: @1166396
     /* 1166396 */   GIM_Try, /*On fail goto*//*Label 17033*/ GIMT_Encode4(1166476), // Rule ID 15865 //
     /* 1166401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1166412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1166415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1166418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1166421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166440 */     // MIs[0] round
     /* 1166440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166450 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166475 */     // GIR_Coverage, 15865,
     /* 1166475 */     GIR_EraseRootFromParent_Done,
     /* 1166476 */   // Label 17033: @1166476
     /* 1166476 */   GIM_Try, /*On fail goto*//*Label 17034*/ GIMT_Encode4(1166556), // Rule ID 15868 //
     /* 1166481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1166492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1166495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1166498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1166501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166520 */     // MIs[0] round
     /* 1166520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166530 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166555 */     // GIR_Coverage, 15868,
     /* 1166555 */     GIR_EraseRootFromParent_Done,
     /* 1166556 */   // Label 17034: @1166556
     /* 1166556 */   GIM_Try, /*On fail goto*//*Label 17035*/ GIMT_Encode4(1166636), // Rule ID 15869 //
     /* 1166561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1166572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1166575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1166578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1166581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166600 */     // MIs[0] round
     /* 1166600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166610 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1166613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1166631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166635 */     // GIR_Coverage, 15869,
     /* 1166635 */     GIR_EraseRootFromParent_Done,
     /* 1166636 */   // Label 17035: @1166636
     /* 1166636 */   GIM_Try, /*On fail goto*//*Label 17036*/ GIMT_Encode4(1166716), // Rule ID 15872 //
     /* 1166641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1166652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1166655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1166658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1166661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166680 */     // MIs[0] round
     /* 1166680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166715 */     // GIR_Coverage, 15872,
     /* 1166715 */     GIR_EraseRootFromParent_Done,
     /* 1166716 */   // Label 17036: @1166716
     /* 1166716 */   GIM_Try, /*On fail goto*//*Label 17037*/ GIMT_Encode4(1166796), // Rule ID 15873 //
     /* 1166721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1166732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1166735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1166738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1166741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166760 */     // MIs[0] round
     /* 1166760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1166773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166795 */     // GIR_Coverage, 15873,
     /* 1166795 */     GIR_EraseRootFromParent_Done,
     /* 1166796 */   // Label 17037: @1166796
     /* 1166796 */   GIM_Try, /*On fail goto*//*Label 17038*/ GIMT_Encode4(1166876), // Rule ID 15876 //
     /* 1166801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1166812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1166815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1166821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166840 */     // MIs[0] round
     /* 1166840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166850 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166875 */     // GIR_Coverage, 15876,
     /* 1166875 */     GIR_EraseRootFromParent_Done,
     /* 1166876 */   // Label 17038: @1166876
     /* 1166876 */   GIM_Try, /*On fail goto*//*Label 17039*/ GIMT_Encode4(1166956), // Rule ID 15877 //
     /* 1166881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1166892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1166895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1166898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1166901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166920 */     // MIs[0] round
     /* 1166920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166930 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1166933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1166951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166955 */     // GIR_Coverage, 15877,
     /* 1166955 */     GIR_EraseRootFromParent_Done,
     /* 1166956 */   // Label 17039: @1166956
     /* 1166956 */   GIM_Try, /*On fail goto*//*Label 17040*/ GIMT_Encode4(1167036), // Rule ID 15880 //
     /* 1166961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1166972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1166975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1166978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1166981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167000 */     // MIs[0] round
     /* 1167000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167010 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167035 */     // GIR_Coverage, 15880,
     /* 1167035 */     GIR_EraseRootFromParent_Done,
     /* 1167036 */   // Label 17040: @1167036
     /* 1167036 */   GIM_Try, /*On fail goto*//*Label 17041*/ GIMT_Encode4(1167116), // Rule ID 15881 //
     /* 1167041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1167052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1167055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1167058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1167061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167080 */     // MIs[0] round
     /* 1167080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167090 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167115 */     // GIR_Coverage, 15881,
     /* 1167115 */     GIR_EraseRootFromParent_Done,
     /* 1167116 */   // Label 17041: @1167116
     /* 1167116 */   GIM_Try, /*On fail goto*//*Label 17042*/ GIMT_Encode4(1167196), // Rule ID 15884 //
     /* 1167121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1167141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167160 */     // MIs[0] round
     /* 1167160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167195 */     // GIR_Coverage, 15884,
     /* 1167195 */     GIR_EraseRootFromParent_Done,
     /* 1167196 */   // Label 17042: @1167196
     /* 1167196 */   GIM_Try, /*On fail goto*//*Label 17043*/ GIMT_Encode4(1167276), // Rule ID 15885 //
     /* 1167201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1167212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1167215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1167218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1167221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1167240 */     // MIs[0] round
     /* 1167240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167250 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1167253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167275 */     // GIR_Coverage, 15885,
     /* 1167275 */     GIR_EraseRootFromParent_Done,
     /* 1167276 */   // Label 17043: @1167276
     /* 1167276 */   GIM_Try, /*On fail goto*//*Label 17044*/ GIMT_Encode4(1167356), // Rule ID 15888 //
     /* 1167281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167320 */     // MIs[0] round
     /* 1167320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167330 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167355 */     // GIR_Coverage, 15888,
     /* 1167355 */     GIR_EraseRootFromParent_Done,
     /* 1167356 */   // Label 17044: @1167356
     /* 1167356 */   GIM_Try, /*On fail goto*//*Label 17045*/ GIMT_Encode4(1167436), // Rule ID 15889 //
     /* 1167361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1167372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1167375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1167378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1167381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1167400 */     // MIs[0] round
     /* 1167400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167410 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1167413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167435 */     // GIR_Coverage, 15889,
     /* 1167435 */     GIR_EraseRootFromParent_Done,
     /* 1167436 */   // Label 17045: @1167436
     /* 1167436 */   GIM_Try, /*On fail goto*//*Label 17046*/ GIMT_Encode4(1167516), // Rule ID 15892 //
     /* 1167441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167480 */     // MIs[0] round
     /* 1167480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167490 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167515 */     // GIR_Coverage, 15892,
     /* 1167515 */     GIR_EraseRootFromParent_Done,
     /* 1167516 */   // Label 17046: @1167516
     /* 1167516 */   GIM_Try, /*On fail goto*//*Label 17047*/ GIMT_Encode4(1167596), // Rule ID 15893 //
     /* 1167521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1167532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1167535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1167538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1167541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1167560 */     // MIs[0] round
     /* 1167560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167570 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1167573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167595 */     // GIR_Coverage, 15893,
     /* 1167595 */     GIR_EraseRootFromParent_Done,
     /* 1167596 */   // Label 17047: @1167596
     /* 1167596 */   GIM_Try, /*On fail goto*//*Label 17048*/ GIMT_Encode4(1167676), // Rule ID 15896 //
     /* 1167601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1167612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1167615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1167618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167640 */     // MIs[0] round
     /* 1167640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167650 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1167653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167675 */     // GIR_Coverage, 15896,
     /* 1167675 */     GIR_EraseRootFromParent_Done,
     /* 1167676 */   // Label 17048: @1167676
     /* 1167676 */   GIM_Try, /*On fail goto*//*Label 17049*/ GIMT_Encode4(1167756), // Rule ID 15897 //
     /* 1167681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1167692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1167695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1167698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167720 */     // MIs[0] round
     /* 1167720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167730 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1167733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167755 */     // GIR_Coverage, 15897,
     /* 1167755 */     GIR_EraseRootFromParent_Done,
     /* 1167756 */   // Label 17049: @1167756
     /* 1167756 */   GIM_Try, /*On fail goto*//*Label 17050*/ GIMT_Encode4(1167836), // Rule ID 15900 //
     /* 1167761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1167772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1167775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1167778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167800 */     // MIs[0] round
     /* 1167800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167810 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1167813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167835 */     // GIR_Coverage, 15900,
     /* 1167835 */     GIR_EraseRootFromParent_Done,
     /* 1167836 */   // Label 17050: @1167836
     /* 1167836 */   GIM_Try, /*On fail goto*//*Label 17051*/ GIMT_Encode4(1167916), // Rule ID 15901 //
     /* 1167841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1167852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1167855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1167858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1167861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167880 */     // MIs[0] round
     /* 1167880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167890 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1167893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167915 */     // GIR_Coverage, 15901,
     /* 1167915 */     GIR_EraseRootFromParent_Done,
     /* 1167916 */   // Label 17051: @1167916
     /* 1167916 */   GIM_Try, /*On fail goto*//*Label 17052*/ GIMT_Encode4(1167996), // Rule ID 15904 //
     /* 1167921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1167929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1167932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1167935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1167938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1167941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1167960 */     // MIs[0] round
     /* 1167960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1167973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167995 */     // GIR_Coverage, 15904,
     /* 1167995 */     GIR_EraseRootFromParent_Done,
     /* 1167996 */   // Label 17052: @1167996
     /* 1167996 */   GIM_Try, /*On fail goto*//*Label 17053*/ GIMT_Encode4(1168076), // Rule ID 15905 //
     /* 1168001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1168012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1168015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1168018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168040 */     // MIs[0] round
     /* 1168040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168050 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168075 */     // GIR_Coverage, 15905,
     /* 1168075 */     GIR_EraseRootFromParent_Done,
     /* 1168076 */   // Label 17053: @1168076
     /* 1168076 */   GIM_Try, /*On fail goto*//*Label 17054*/ GIMT_Encode4(1168156), // Rule ID 15908 //
     /* 1168081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168120 */     // MIs[0] round
     /* 1168120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168130 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168155 */     // GIR_Coverage, 15908,
     /* 1168155 */     GIR_EraseRootFromParent_Done,
     /* 1168156 */   // Label 17054: @1168156
     /* 1168156 */   GIM_Try, /*On fail goto*//*Label 17055*/ GIMT_Encode4(1168236), // Rule ID 15909 //
     /* 1168161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1168172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1168175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1168178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168200 */     // MIs[0] round
     /* 1168200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1168213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168235 */     // GIR_Coverage, 15909,
     /* 1168235 */     GIR_EraseRootFromParent_Done,
     /* 1168236 */   // Label 17055: @1168236
     /* 1168236 */   GIM_Try, /*On fail goto*//*Label 17056*/ GIMT_Encode4(1168316), // Rule ID 15912 //
     /* 1168241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168280 */     // MIs[0] round
     /* 1168280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168290 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168315 */     // GIR_Coverage, 15912,
     /* 1168315 */     GIR_EraseRootFromParent_Done,
     /* 1168316 */   // Label 17056: @1168316
     /* 1168316 */   GIM_Try, /*On fail goto*//*Label 17057*/ GIMT_Encode4(1168396), // Rule ID 15913 //
     /* 1168321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1168332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1168335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1168338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168360 */     // MIs[0] round
     /* 1168360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168370 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168395 */     // GIR_Coverage, 15913,
     /* 1168395 */     GIR_EraseRootFromParent_Done,
     /* 1168396 */   // Label 17057: @1168396
     /* 1168396 */   GIM_Try, /*On fail goto*//*Label 17058*/ GIMT_Encode4(1168476), // Rule ID 15916 //
     /* 1168401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168440 */     // MIs[0] round
     /* 1168440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168450 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168475 */     // GIR_Coverage, 15916,
     /* 1168475 */     GIR_EraseRootFromParent_Done,
     /* 1168476 */   // Label 17058: @1168476
     /* 1168476 */   GIM_Try, /*On fail goto*//*Label 17059*/ GIMT_Encode4(1168556), // Rule ID 15917 //
     /* 1168481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1168492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1168495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1168498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168520 */     // MIs[0] round
     /* 1168520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168530 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1168533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168555 */     // GIR_Coverage, 15917,
     /* 1168555 */     GIR_EraseRootFromParent_Done,
     /* 1168556 */   // Label 17059: @1168556
     /* 1168556 */   GIM_Try, /*On fail goto*//*Label 17060*/ GIMT_Encode4(1168636), // Rule ID 15920 //
     /* 1168561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1168572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1168575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1168578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168600 */     // MIs[0] round
     /* 1168600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168610 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168635 */     // GIR_Coverage, 15920,
     /* 1168635 */     GIR_EraseRootFromParent_Done,
     /* 1168636 */   // Label 17060: @1168636
     /* 1168636 */   GIM_Try, /*On fail goto*//*Label 17061*/ GIMT_Encode4(1168716), // Rule ID 15921 //
     /* 1168641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1168652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1168655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1168658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168680 */     // MIs[0] round
     /* 1168680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168690 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11601:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168715 */     // GIR_Coverage, 15921,
     /* 1168715 */     GIR_EraseRootFromParent_Done,
     /* 1168716 */   // Label 17061: @1168716
     /* 1168716 */   GIM_Try, /*On fail goto*//*Label 17062*/ GIMT_Encode4(1168796), // Rule ID 15924 //
     /* 1168721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1168732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1168735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1168738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168760 */     // MIs[0] round
     /* 1168760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168795 */     // GIR_Coverage, 15924,
     /* 1168795 */     GIR_EraseRootFromParent_Done,
     /* 1168796 */   // Label 17062: @1168796
     /* 1168796 */   GIM_Try, /*On fail goto*//*Label 17063*/ GIMT_Encode4(1168876), // Rule ID 15925 //
     /* 1168801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1168812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1168815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1168818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168840 */     // MIs[0] round
     /* 1168840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168875 */     // GIR_Coverage, 15925,
     /* 1168875 */     GIR_EraseRootFromParent_Done,
     /* 1168876 */   // Label 17063: @1168876
     /* 1168876 */   GIM_Try, /*On fail goto*//*Label 17064*/ GIMT_Encode4(1168956), // Rule ID 15928 //
     /* 1168881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1168892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1168895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1168898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1168901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1168920 */     // MIs[0] round
     /* 1168920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168930 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1168933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1168951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168955 */     // GIR_Coverage, 15928,
     /* 1168955 */     GIR_EraseRootFromParent_Done,
     /* 1168956 */   // Label 17064: @1168956
     /* 1168956 */   GIM_Try, /*On fail goto*//*Label 17065*/ GIMT_Encode4(1169036), // Rule ID 15929 //
     /* 1168961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1168969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1168972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1168975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1168978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1168981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169000 */     // MIs[0] round
     /* 1169000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169010 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169035 */     // GIR_Coverage, 15929,
     /* 1169035 */     GIR_EraseRootFromParent_Done,
     /* 1169036 */   // Label 17065: @1169036
     /* 1169036 */   GIM_Try, /*On fail goto*//*Label 17066*/ GIMT_Encode4(1169116), // Rule ID 15932 //
     /* 1169041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1169044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169080 */     // MIs[0] round
     /* 1169080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169115 */     // GIR_Coverage, 15932,
     /* 1169115 */     GIR_EraseRootFromParent_Done,
     /* 1169116 */   // Label 17066: @1169116
     /* 1169116 */   GIM_Try, /*On fail goto*//*Label 17067*/ GIMT_Encode4(1169196), // Rule ID 15933 //
     /* 1169121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1169124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1169132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1169135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1169138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1169156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169160 */     // MIs[0] round
     /* 1169160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169170 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1169173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169195 */     // GIR_Coverage, 15933,
     /* 1169195 */     GIR_EraseRootFromParent_Done,
     /* 1169196 */   // Label 17067: @1169196
     /* 1169196 */   GIM_Try, /*On fail goto*//*Label 17068*/ GIMT_Encode4(1169276), // Rule ID 15936 //
     /* 1169201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169240 */     // MIs[0] round
     /* 1169240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169250 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169275 */     // GIR_Coverage, 15936,
     /* 1169275 */     GIR_EraseRootFromParent_Done,
     /* 1169276 */   // Label 17068: @1169276
     /* 1169276 */   GIM_Try, /*On fail goto*//*Label 17069*/ GIMT_Encode4(1169356), // Rule ID 15937 //
     /* 1169281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1169292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1169295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1169298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169320 */     // MIs[0] round
     /* 1169320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169330 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169355 */     // GIR_Coverage, 15937,
     /* 1169355 */     GIR_EraseRootFromParent_Done,
     /* 1169356 */   // Label 17069: @1169356
     /* 1169356 */   GIM_Try, /*On fail goto*//*Label 17070*/ GIMT_Encode4(1169436), // Rule ID 15940 //
     /* 1169361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169400 */     // MIs[0] round
     /* 1169400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169410 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169435 */     // GIR_Coverage, 15940,
     /* 1169435 */     GIR_EraseRootFromParent_Done,
     /* 1169436 */   // Label 17070: @1169436
     /* 1169436 */   GIM_Try, /*On fail goto*//*Label 17071*/ GIMT_Encode4(1169516), // Rule ID 15941 //
     /* 1169441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1169452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1169455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1169458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169480 */     // MIs[0] round
     /* 1169480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169490 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169515 */     // GIR_Coverage, 15941,
     /* 1169515 */     GIR_EraseRootFromParent_Done,
     /* 1169516 */   // Label 17071: @1169516
     /* 1169516 */   GIM_Try, /*On fail goto*//*Label 17072*/ GIMT_Encode4(1169596), // Rule ID 15944 //
     /* 1169521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1169532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1169535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1169538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169560 */     // MIs[0] round
     /* 1169560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169570 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1169573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169595 */     // GIR_Coverage, 15944,
     /* 1169595 */     GIR_EraseRootFromParent_Done,
     /* 1169596 */   // Label 17072: @1169596
     /* 1169596 */   GIM_Try, /*On fail goto*//*Label 17073*/ GIMT_Encode4(1169676), // Rule ID 15945 //
     /* 1169601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1169612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1169615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1169618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169640 */     // MIs[0] round
     /* 1169640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169650 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1169653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1169671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169675 */     // GIR_Coverage, 15945,
     /* 1169675 */     GIR_EraseRootFromParent_Done,
     /* 1169676 */   // Label 17073: @1169676
     /* 1169676 */   GIM_Try, /*On fail goto*//*Label 17074*/ GIMT_Encode4(1169756), // Rule ID 15948 //
     /* 1169681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1169692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1169695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1169698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169720 */     // MIs[0] round
     /* 1169720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169755 */     // GIR_Coverage, 15948,
     /* 1169755 */     GIR_EraseRootFromParent_Done,
     /* 1169756 */   // Label 17074: @1169756
     /* 1169756 */   GIM_Try, /*On fail goto*//*Label 17075*/ GIMT_Encode4(1169836), // Rule ID 15949 //
     /* 1169761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1169772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1169775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1169778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169800 */     // MIs[0] round
     /* 1169800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1169813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169835 */     // GIR_Coverage, 15949,
     /* 1169835 */     GIR_EraseRootFromParent_Done,
     /* 1169836 */   // Label 17075: @1169836
     /* 1169836 */   GIM_Try, /*On fail goto*//*Label 17076*/ GIMT_Encode4(1169916), // Rule ID 15952 //
     /* 1169841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1169852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1169855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1169858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169880 */     // MIs[0] round
     /* 1169880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169915 */     // GIR_Coverage, 15952,
     /* 1169915 */     GIR_EraseRootFromParent_Done,
     /* 1169916 */   // Label 17076: @1169916
     /* 1169916 */   GIM_Try, /*On fail goto*//*Label 17077*/ GIMT_Encode4(1169996), // Rule ID 15953 //
     /* 1169921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1169929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1169932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1169935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1169938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1169941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1169960 */     // MIs[0] round
     /* 1169960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169970 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1169973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169995 */     // GIR_Coverage, 15953,
     /* 1169995 */     GIR_EraseRootFromParent_Done,
     /* 1169996 */   // Label 17077: @1169996
     /* 1169996 */   GIM_Try, /*On fail goto*//*Label 17078*/ GIMT_Encode4(1170076), // Rule ID 15956 //
     /* 1170001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170040 */     // MIs[0] round
     /* 1170040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170050 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170075 */     // GIR_Coverage, 15956,
     /* 1170075 */     GIR_EraseRootFromParent_Done,
     /* 1170076 */   // Label 17078: @1170076
     /* 1170076 */   GIM_Try, /*On fail goto*//*Label 17079*/ GIMT_Encode4(1170156), // Rule ID 15957 //
     /* 1170081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1170092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1170095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1170098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170120 */     // MIs[0] round
     /* 1170120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170130 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170155 */     // GIR_Coverage, 15957,
     /* 1170155 */     GIR_EraseRootFromParent_Done,
     /* 1170156 */   // Label 17079: @1170156
     /* 1170156 */   GIM_Try, /*On fail goto*//*Label 17080*/ GIMT_Encode4(1170236), // Rule ID 15960 //
     /* 1170161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170200 */     // MIs[0] round
     /* 1170200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170235 */     // GIR_Coverage, 15960,
     /* 1170235 */     GIR_EraseRootFromParent_Done,
     /* 1170236 */   // Label 17080: @1170236
     /* 1170236 */   GIM_Try, /*On fail goto*//*Label 17081*/ GIMT_Encode4(1170316), // Rule ID 15961 //
     /* 1170241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1170252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1170255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1170258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170280 */     // MIs[0] round
     /* 1170280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170315 */     // GIR_Coverage, 15961,
     /* 1170315 */     GIR_EraseRootFromParent_Done,
     /* 1170316 */   // Label 17081: @1170316
     /* 1170316 */   GIM_Try, /*On fail goto*//*Label 17082*/ GIMT_Encode4(1170396), // Rule ID 15964 //
     /* 1170321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170360 */     // MIs[0] round
     /* 1170360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170370 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170395 */     // GIR_Coverage, 15964,
     /* 1170395 */     GIR_EraseRootFromParent_Done,
     /* 1170396 */   // Label 17082: @1170396
     /* 1170396 */   GIM_Try, /*On fail goto*//*Label 17083*/ GIMT_Encode4(1170476), // Rule ID 15965 //
     /* 1170401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1170412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1170415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1170418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170440 */     // MIs[0] round
     /* 1170440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170475 */     // GIR_Coverage, 15965,
     /* 1170475 */     GIR_EraseRootFromParent_Done,
     /* 1170476 */   // Label 17083: @1170476
     /* 1170476 */   GIM_Try, /*On fail goto*//*Label 17084*/ GIMT_Encode4(1170556), // Rule ID 15968 //
     /* 1170481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170520 */     // MIs[0] round
     /* 1170520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170555 */     // GIR_Coverage, 15968,
     /* 1170555 */     GIR_EraseRootFromParent_Done,
     /* 1170556 */   // Label 17084: @1170556
     /* 1170556 */   GIM_Try, /*On fail goto*//*Label 17085*/ GIMT_Encode4(1170636), // Rule ID 15969 //
     /* 1170561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1170572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1170575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1170578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170600 */     // MIs[0] round
     /* 1170600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170610 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1170613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170635 */     // GIR_Coverage, 15969,
     /* 1170635 */     GIR_EraseRootFromParent_Done,
     /* 1170636 */   // Label 17085: @1170636
     /* 1170636 */   GIM_Try, /*On fail goto*//*Label 17086*/ GIMT_Encode4(1170716), // Rule ID 15972 //
     /* 1170641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1170652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1170655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1170658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170680 */     // MIs[0] round
     /* 1170680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170715 */     // GIR_Coverage, 15972,
     /* 1170715 */     GIR_EraseRootFromParent_Done,
     /* 1170716 */   // Label 17086: @1170716
     /* 1170716 */   GIM_Try, /*On fail goto*//*Label 17087*/ GIMT_Encode4(1170796), // Rule ID 15973 //
     /* 1170721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1170732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1170735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1170738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1170756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170760 */     // MIs[0] round
     /* 1170760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1170773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170795 */     // GIR_Coverage, 15973,
     /* 1170795 */     GIR_EraseRootFromParent_Done,
     /* 1170796 */   // Label 17087: @1170796
     /* 1170796 */   GIM_Try, /*On fail goto*//*Label 17088*/ GIMT_Encode4(1170876), // Rule ID 15976 //
     /* 1170801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1170812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1170815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1170818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170840 */     // MIs[0] round
     /* 1170840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170875 */     // GIR_Coverage, 15976,
     /* 1170875 */     GIR_EraseRootFromParent_Done,
     /* 1170876 */   // Label 17088: @1170876
     /* 1170876 */   GIM_Try, /*On fail goto*//*Label 17089*/ GIMT_Encode4(1170956), // Rule ID 15977 //
     /* 1170881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1170884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1170892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1170895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1170898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1170916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170920 */     // MIs[0] round
     /* 1170920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170930 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1170933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1170951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170955 */     // GIR_Coverage, 15977,
     /* 1170955 */     GIR_EraseRootFromParent_Done,
     /* 1170956 */   // Label 17089: @1170956
     /* 1170956 */   GIM_Try, /*On fail goto*//*Label 17090*/ GIMT_Encode4(1171036), // Rule ID 15980 //
     /* 1170961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1170964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1170969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1170972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1170975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1170978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1170996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171000 */     // MIs[0] round
     /* 1171000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171035 */     // GIR_Coverage, 15980,
     /* 1171035 */     GIR_EraseRootFromParent_Done,
     /* 1171036 */   // Label 17090: @1171036
     /* 1171036 */   GIM_Try, /*On fail goto*//*Label 17091*/ GIMT_Encode4(1171116), // Rule ID 15981 //
     /* 1171041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1171049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1171052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1171055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1171058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171080 */     // MIs[0] round
     /* 1171080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1171093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171115 */     // GIR_Coverage, 15981,
     /* 1171115 */     GIR_EraseRootFromParent_Done,
     /* 1171116 */   // Label 17091: @1171116
     /* 1171116 */   GIM_Try, /*On fail goto*//*Label 17092*/ GIMT_Encode4(1171196), // Rule ID 16072 //
     /* 1171121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1171141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171160 */     // MIs[0] round
     /* 1171160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171170 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1171173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171195 */     // GIR_Coverage, 16072,
     /* 1171195 */     GIR_EraseRootFromParent_Done,
     /* 1171196 */   // Label 17092: @1171196
     /* 1171196 */   GIM_Try, /*On fail goto*//*Label 17093*/ GIMT_Encode4(1171276), // Rule ID 16073 //
     /* 1171201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1171212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1171215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1171218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1171221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171240 */     // MIs[0] round
     /* 1171240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171250 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1171253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171275 */     // GIR_Coverage, 16073,
     /* 1171275 */     GIR_EraseRootFromParent_Done,
     /* 1171276 */   // Label 17093: @1171276
     /* 1171276 */   GIM_Try, /*On fail goto*//*Label 17094*/ GIMT_Encode4(1171356), // Rule ID 16076 //
     /* 1171281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1171301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171320 */     // MIs[0] round
     /* 1171320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171355 */     // GIR_Coverage, 16076,
     /* 1171355 */     GIR_EraseRootFromParent_Done,
     /* 1171356 */   // Label 17094: @1171356
     /* 1171356 */   GIM_Try, /*On fail goto*//*Label 17095*/ GIMT_Encode4(1171436), // Rule ID 16077 //
     /* 1171361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1171372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1171375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1171378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1171381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171400 */     // MIs[0] round
     /* 1171400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171410 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171435 */     // GIR_Coverage, 16077,
     /* 1171435 */     GIR_EraseRootFromParent_Done,
     /* 1171436 */   // Label 17095: @1171436
     /* 1171436 */   GIM_Try, /*On fail goto*//*Label 17096*/ GIMT_Encode4(1171516), // Rule ID 16080 //
     /* 1171441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1171461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171480 */     // MIs[0] round
     /* 1171480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171490 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171515 */     // GIR_Coverage, 16080,
     /* 1171515 */     GIR_EraseRootFromParent_Done,
     /* 1171516 */   // Label 17096: @1171516
     /* 1171516 */   GIM_Try, /*On fail goto*//*Label 17097*/ GIMT_Encode4(1171596), // Rule ID 16081 //
     /* 1171521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1171532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1171535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1171538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1171541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171560 */     // MIs[0] round
     /* 1171560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171570 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171595 */     // GIR_Coverage, 16081,
     /* 1171595 */     GIR_EraseRootFromParent_Done,
     /* 1171596 */   // Label 17097: @1171596
     /* 1171596 */   GIM_Try, /*On fail goto*//*Label 17098*/ GIMT_Encode4(1171676), // Rule ID 16084 //
     /* 1171601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1171612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1171615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1171618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1171621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171640 */     // MIs[0] round
     /* 1171640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171650 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171675 */     // GIR_Coverage, 16084,
     /* 1171675 */     GIR_EraseRootFromParent_Done,
     /* 1171676 */   // Label 17098: @1171676
     /* 1171676 */   GIM_Try, /*On fail goto*//*Label 17099*/ GIMT_Encode4(1171756), // Rule ID 16085 //
     /* 1171681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1171692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1171695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1171698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1171701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171720 */     // MIs[0] round
     /* 1171720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171730 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1171733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171755 */     // GIR_Coverage, 16085,
     /* 1171755 */     GIR_EraseRootFromParent_Done,
     /* 1171756 */   // Label 17099: @1171756
     /* 1171756 */   GIM_Try, /*On fail goto*//*Label 17100*/ GIMT_Encode4(1171836), // Rule ID 16088 //
     /* 1171761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1171772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1171775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1171778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1171781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171800 */     // MIs[0] round
     /* 1171800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171810 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171835 */     // GIR_Coverage, 16088,
     /* 1171835 */     GIR_EraseRootFromParent_Done,
     /* 1171836 */   // Label 17100: @1171836
     /* 1171836 */   GIM_Try, /*On fail goto*//*Label 17101*/ GIMT_Encode4(1171916), // Rule ID 16089 //
     /* 1171841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1171852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1171855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1171858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1171861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171880 */     // MIs[0] round
     /* 1171880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171890 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171915 */     // GIR_Coverage, 16089,
     /* 1171915 */     GIR_EraseRootFromParent_Done,
     /* 1171916 */   // Label 17101: @1171916
     /* 1171916 */   GIM_Try, /*On fail goto*//*Label 17102*/ GIMT_Encode4(1171996), // Rule ID 16092 //
     /* 1171921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1171932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1171935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1171938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1171941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171960 */     // MIs[0] round
     /* 1171960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171970 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1171973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171995 */     // GIR_Coverage, 16092,
     /* 1171995 */     GIR_EraseRootFromParent_Done,
     /* 1171996 */   // Label 17102: @1171996
     /* 1171996 */   GIM_Try, /*On fail goto*//*Label 17103*/ GIMT_Encode4(1172076), // Rule ID 16093 //
     /* 1172001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1172012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1172015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1172018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1172021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172040 */     // MIs[0] round
     /* 1172040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1172053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172075 */     // GIR_Coverage, 16093,
     /* 1172075 */     GIR_EraseRootFromParent_Done,
     /* 1172076 */   // Label 17103: @1172076
     /* 1172076 */   GIM_Try, /*On fail goto*//*Label 17104*/ GIMT_Encode4(1172156), // Rule ID 16096 //
     /* 1172081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1172101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172120 */     // MIs[0] round
     /* 1172120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172130 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172155 */     // GIR_Coverage, 16096,
     /* 1172155 */     GIR_EraseRootFromParent_Done,
     /* 1172156 */   // Label 17104: @1172156
     /* 1172156 */   GIM_Try, /*On fail goto*//*Label 17105*/ GIMT_Encode4(1172236), // Rule ID 16097 //
     /* 1172161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1172172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1172175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1172178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1172181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172200 */     // MIs[0] round
     /* 1172200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172210 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172235 */     // GIR_Coverage, 16097,
     /* 1172235 */     GIR_EraseRootFromParent_Done,
     /* 1172236 */   // Label 17105: @1172236
     /* 1172236 */   GIM_Try, /*On fail goto*//*Label 17106*/ GIMT_Encode4(1172316), // Rule ID 16100 //
     /* 1172241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1172261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172280 */     // MIs[0] round
     /* 1172280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172315 */     // GIR_Coverage, 16100,
     /* 1172315 */     GIR_EraseRootFromParent_Done,
     /* 1172316 */   // Label 17106: @1172316
     /* 1172316 */   GIM_Try, /*On fail goto*//*Label 17107*/ GIMT_Encode4(1172396), // Rule ID 16101 //
     /* 1172321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1172332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1172335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1172338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1172341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172360 */     // MIs[0] round
     /* 1172360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172395 */     // GIR_Coverage, 16101,
     /* 1172395 */     GIR_EraseRootFromParent_Done,
     /* 1172396 */   // Label 17107: @1172396
     /* 1172396 */   GIM_Try, /*On fail goto*//*Label 17108*/ GIMT_Encode4(1172476), // Rule ID 16104 //
     /* 1172401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172440 */     // MIs[0] round
     /* 1172440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172475 */     // GIR_Coverage, 16104,
     /* 1172475 */     GIR_EraseRootFromParent_Done,
     /* 1172476 */   // Label 17108: @1172476
     /* 1172476 */   GIM_Try, /*On fail goto*//*Label 17109*/ GIMT_Encode4(1172556), // Rule ID 16105 //
     /* 1172481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1172492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1172495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1172498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1172501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172520 */     // MIs[0] round
     /* 1172520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172530 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172555 */     // GIR_Coverage, 16105,
     /* 1172555 */     GIR_EraseRootFromParent_Done,
     /* 1172556 */   // Label 17109: @1172556
     /* 1172556 */   GIM_Try, /*On fail goto*//*Label 17110*/ GIMT_Encode4(1172636), // Rule ID 16108 //
     /* 1172561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1172564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1172572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1172575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1172581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172600 */     // MIs[0] round
     /* 1172600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172610 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1172631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172635 */     // GIR_Coverage, 16108,
     /* 1172635 */     GIR_EraseRootFromParent_Done,
     /* 1172636 */   // Label 17110: @1172636
     /* 1172636 */   GIM_Try, /*On fail goto*//*Label 17111*/ GIMT_Encode4(1172716), // Rule ID 16109 //
     /* 1172641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1172644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1172652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1172655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1172658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1172661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1172680 */     // MIs[0] round
     /* 1172680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1172693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1172711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172715 */     // GIR_Coverage, 16109,
     /* 1172715 */     GIR_EraseRootFromParent_Done,
     /* 1172716 */   // Label 17111: @1172716
     /* 1172716 */   GIM_Try, /*On fail goto*//*Label 17112*/ GIMT_Encode4(1172796), // Rule ID 16112 //
     /* 1172721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1172732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1172735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1172738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1172741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172760 */     // MIs[0] round
     /* 1172760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172770 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1172773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172795 */     // GIR_Coverage, 16112,
     /* 1172795 */     GIR_EraseRootFromParent_Done,
     /* 1172796 */   // Label 17112: @1172796
     /* 1172796 */   GIM_Try, /*On fail goto*//*Label 17113*/ GIMT_Encode4(1172876), // Rule ID 16113 //
     /* 1172801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1172812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1172815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1172818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1172821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172840 */     // MIs[0] round
     /* 1172840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172850 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1172853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172875 */     // GIR_Coverage, 16113,
     /* 1172875 */     GIR_EraseRootFromParent_Done,
     /* 1172876 */   // Label 17113: @1172876
     /* 1172876 */   GIM_Try, /*On fail goto*//*Label 17114*/ GIMT_Encode4(1172956), // Rule ID 16116 //
     /* 1172881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1172892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1172895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1172898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1172901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172920 */     // MIs[0] round
     /* 1172920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172930 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1172933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172955 */     // GIR_Coverage, 16116,
     /* 1172955 */     GIR_EraseRootFromParent_Done,
     /* 1172956 */   // Label 17114: @1172956
     /* 1172956 */   GIM_Try, /*On fail goto*//*Label 17115*/ GIMT_Encode4(1173036), // Rule ID 16117 //
     /* 1172961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1172972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1172975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1172978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1172981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173000 */     // MIs[0] round
     /* 1173000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173010 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173035 */     // GIR_Coverage, 16117,
     /* 1173035 */     GIR_EraseRootFromParent_Done,
     /* 1173036 */   // Label 17115: @1173036
     /* 1173036 */   GIM_Try, /*On fail goto*//*Label 17116*/ GIMT_Encode4(1173116), // Rule ID 16120 //
     /* 1173041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1173061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173080 */     // MIs[0] round
     /* 1173080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173090 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173115 */     // GIR_Coverage, 16120,
     /* 1173115 */     GIR_EraseRootFromParent_Done,
     /* 1173116 */   // Label 17116: @1173116
     /* 1173116 */   GIM_Try, /*On fail goto*//*Label 17117*/ GIMT_Encode4(1173196), // Rule ID 16121 //
     /* 1173121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1173132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1173135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1173138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1173141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173160 */     // MIs[0] round
     /* 1173160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173170 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173195 */     // GIR_Coverage, 16121,
     /* 1173195 */     GIR_EraseRootFromParent_Done,
     /* 1173196 */   // Label 17117: @1173196
     /* 1173196 */   GIM_Try, /*On fail goto*//*Label 17118*/ GIMT_Encode4(1173276), // Rule ID 16124 //
     /* 1173201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1173221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173240 */     // MIs[0] round
     /* 1173240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173275 */     // GIR_Coverage, 16124,
     /* 1173275 */     GIR_EraseRootFromParent_Done,
     /* 1173276 */   // Label 17118: @1173276
     /* 1173276 */   GIM_Try, /*On fail goto*//*Label 17119*/ GIMT_Encode4(1173356), // Rule ID 16125 //
     /* 1173281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1173292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1173295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1173298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1173301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173320 */     // MIs[0] round
     /* 1173320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173330 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173355 */     // GIR_Coverage, 16125,
     /* 1173355 */     GIR_EraseRootFromParent_Done,
     /* 1173356 */   // Label 17119: @1173356
     /* 1173356 */   GIM_Try, /*On fail goto*//*Label 17120*/ GIMT_Encode4(1173436), // Rule ID 16128 //
     /* 1173361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173400 */     // MIs[0] round
     /* 1173400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173410 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173435 */     // GIR_Coverage, 16128,
     /* 1173435 */     GIR_EraseRootFromParent_Done,
     /* 1173436 */   // Label 17120: @1173436
     /* 1173436 */   GIM_Try, /*On fail goto*//*Label 17121*/ GIMT_Encode4(1173516), // Rule ID 16129 //
     /* 1173441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1173452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1173455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1173458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1173461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173480 */     // MIs[0] round
     /* 1173480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173490 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173515 */     // GIR_Coverage, 16129,
     /* 1173515 */     GIR_EraseRootFromParent_Done,
     /* 1173516 */   // Label 17121: @1173516
     /* 1173516 */   GIM_Try, /*On fail goto*//*Label 17122*/ GIMT_Encode4(1173596), // Rule ID 16132 //
     /* 1173521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1173532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1173535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1173541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173560 */     // MIs[0] round
     /* 1173560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173595 */     // GIR_Coverage, 16132,
     /* 1173595 */     GIR_EraseRootFromParent_Done,
     /* 1173596 */   // Label 17122: @1173596
     /* 1173596 */   GIM_Try, /*On fail goto*//*Label 17123*/ GIMT_Encode4(1173676), // Rule ID 16133 //
     /* 1173601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1173612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1173615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1173618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1173621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173640 */     // MIs[0] round
     /* 1173640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173650 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1173653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1173671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173675 */     // GIR_Coverage, 16133,
     /* 1173675 */     GIR_EraseRootFromParent_Done,
     /* 1173676 */   // Label 17123: @1173676
     /* 1173676 */   GIM_Try, /*On fail goto*//*Label 17124*/ GIMT_Encode4(1173756), // Rule ID 16136 //
     /* 1173681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1173692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1173695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1173698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1173701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173720 */     // MIs[0] round
     /* 1173720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173755 */     // GIR_Coverage, 16136,
     /* 1173755 */     GIR_EraseRootFromParent_Done,
     /* 1173756 */   // Label 17124: @1173756
     /* 1173756 */   GIM_Try, /*On fail goto*//*Label 17125*/ GIMT_Encode4(1173836), // Rule ID 16137 //
     /* 1173761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1173772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1173775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1173778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1173781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173800 */     // MIs[0] round
     /* 1173800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1173813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173835 */     // GIR_Coverage, 16137,
     /* 1173835 */     GIR_EraseRootFromParent_Done,
     /* 1173836 */   // Label 17125: @1173836
     /* 1173836 */   GIM_Try, /*On fail goto*//*Label 17126*/ GIMT_Encode4(1173916), // Rule ID 16140 //
     /* 1173841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1173852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1173855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1173858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1173861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173880 */     // MIs[0] round
     /* 1173880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173915 */     // GIR_Coverage, 16140,
     /* 1173915 */     GIR_EraseRootFromParent_Done,
     /* 1173916 */   // Label 17126: @1173916
     /* 1173916 */   GIM_Try, /*On fail goto*//*Label 17127*/ GIMT_Encode4(1173996), // Rule ID 16141 //
     /* 1173921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1173932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1173935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1173938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1173941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173960 */     // MIs[0] round
     /* 1173960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1173973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173995 */     // GIR_Coverage, 16141,
     /* 1173995 */     GIR_EraseRootFromParent_Done,
     /* 1173996 */   // Label 17127: @1173996
     /* 1173996 */   GIM_Try, /*On fail goto*//*Label 17128*/ GIMT_Encode4(1174076), // Rule ID 16144 //
     /* 1174001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1174021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174040 */     // MIs[0] round
     /* 1174040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174075 */     // GIR_Coverage, 16144,
     /* 1174075 */     GIR_EraseRootFromParent_Done,
     /* 1174076 */   // Label 17128: @1174076
     /* 1174076 */   GIM_Try, /*On fail goto*//*Label 17129*/ GIMT_Encode4(1174156), // Rule ID 16145 //
     /* 1174081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1174092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1174095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1174098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1174101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174120 */     // MIs[0] round
     /* 1174120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1174151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174155 */     // GIR_Coverage, 16145,
     /* 1174155 */     GIR_EraseRootFromParent_Done,
     /* 1174156 */   // Label 17129: @1174156
     /* 1174156 */   GIM_Try, /*On fail goto*//*Label 17130*/ GIMT_Encode4(1174236), // Rule ID 16148 //
     /* 1174161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1174181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174200 */     // MIs[0] round
     /* 1174200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174235 */     // GIR_Coverage, 16148,
     /* 1174235 */     GIR_EraseRootFromParent_Done,
     /* 1174236 */   // Label 17130: @1174236
     /* 1174236 */   GIM_Try, /*On fail goto*//*Label 17131*/ GIMT_Encode4(1174316), // Rule ID 16149 //
     /* 1174241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1174252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1174255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1174258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1174261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174280 */     // MIs[0] round
     /* 1174280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174290 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1174293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174315 */     // GIR_Coverage, 16149,
     /* 1174315 */     GIR_EraseRootFromParent_Done,
     /* 1174316 */   // Label 17131: @1174316
     /* 1174316 */   GIM_Try, /*On fail goto*//*Label 17132*/ GIMT_Encode4(1174396), // Rule ID 16152 //
     /* 1174321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174360 */     // MIs[0] round
     /* 1174360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174395 */     // GIR_Coverage, 16152,
     /* 1174395 */     GIR_EraseRootFromParent_Done,
     /* 1174396 */   // Label 17132: @1174396
     /* 1174396 */   GIM_Try, /*On fail goto*//*Label 17133*/ GIMT_Encode4(1174476), // Rule ID 16153 //
     /* 1174401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1174412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1174415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1174418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1174421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174440 */     // MIs[0] round
     /* 1174440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174450 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1174453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174475 */     // GIR_Coverage, 16153,
     /* 1174475 */     GIR_EraseRootFromParent_Done,
     /* 1174476 */   // Label 17133: @1174476
     /* 1174476 */   GIM_Try, /*On fail goto*//*Label 17134*/ GIMT_Encode4(1174556), // Rule ID 16156 //
     /* 1174481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1174484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1174501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174520 */     // MIs[0] round
     /* 1174520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174530 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174555 */     // GIR_Coverage, 16156,
     /* 1174555 */     GIR_EraseRootFromParent_Done,
     /* 1174556 */   // Label 17134: @1174556
     /* 1174556 */   GIM_Try, /*On fail goto*//*Label 17135*/ GIMT_Encode4(1174636), // Rule ID 16157 //
     /* 1174561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1174564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1174572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1174575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1174578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1174581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174600 */     // MIs[0] round
     /* 1174600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174610 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1174613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1174631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174635 */     // GIR_Coverage, 16157,
     /* 1174635 */     GIR_EraseRootFromParent_Done,
     /* 1174636 */   // Label 17135: @1174636
     /* 1174636 */   GIM_Try, /*On fail goto*//*Label 17136*/ GIMT_Encode4(1174716), // Rule ID 16160 //
     /* 1174641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1174652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1174655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1174658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174680 */     // MIs[0] round
     /* 1174680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174690 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1174693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174715 */     // GIR_Coverage, 16160,
     /* 1174715 */     GIR_EraseRootFromParent_Done,
     /* 1174716 */   // Label 17136: @1174716
     /* 1174716 */   GIM_Try, /*On fail goto*//*Label 17137*/ GIMT_Encode4(1174796), // Rule ID 16161 //
     /* 1174721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1174732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1174735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1174738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174760 */     // MIs[0] round
     /* 1174760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174770 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1174773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174795 */     // GIR_Coverage, 16161,
     /* 1174795 */     GIR_EraseRootFromParent_Done,
     /* 1174796 */   // Label 17137: @1174796
     /* 1174796 */   GIM_Try, /*On fail goto*//*Label 17138*/ GIMT_Encode4(1174876), // Rule ID 16164 //
     /* 1174801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1174812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1174815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1174818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174840 */     // MIs[0] round
     /* 1174840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1174853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174875 */     // GIR_Coverage, 16164,
     /* 1174875 */     GIR_EraseRootFromParent_Done,
     /* 1174876 */   // Label 17138: @1174876
     /* 1174876 */   GIM_Try, /*On fail goto*//*Label 17139*/ GIMT_Encode4(1174956), // Rule ID 16165 //
     /* 1174881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1174892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1174895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1174898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1174901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1174920 */     // MIs[0] round
     /* 1174920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174930 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1174933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174955 */     // GIR_Coverage, 16165,
     /* 1174955 */     GIR_EraseRootFromParent_Done,
     /* 1174956 */   // Label 17139: @1174956
     /* 1174956 */   GIM_Try, /*On fail goto*//*Label 17140*/ GIMT_Encode4(1175036), // Rule ID 16168 //
     /* 1174961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1174969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1174972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1174975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1174978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1174981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175000 */     // MIs[0] round
     /* 1175000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175010 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175035 */     // GIR_Coverage, 16168,
     /* 1175035 */     GIR_EraseRootFromParent_Done,
     /* 1175036 */   // Label 17140: @1175036
     /* 1175036 */   GIM_Try, /*On fail goto*//*Label 17141*/ GIMT_Encode4(1175116), // Rule ID 16169 //
     /* 1175041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1175052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1175055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1175058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175080 */     // MIs[0] round
     /* 1175080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175090 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175115 */     // GIR_Coverage, 16169,
     /* 1175115 */     GIR_EraseRootFromParent_Done,
     /* 1175116 */   // Label 17141: @1175116
     /* 1175116 */   GIM_Try, /*On fail goto*//*Label 17142*/ GIMT_Encode4(1175196), // Rule ID 16172 //
     /* 1175121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175160 */     // MIs[0] round
     /* 1175160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175195 */     // GIR_Coverage, 16172,
     /* 1175195 */     GIR_EraseRootFromParent_Done,
     /* 1175196 */   // Label 17142: @1175196
     /* 1175196 */   GIM_Try, /*On fail goto*//*Label 17143*/ GIMT_Encode4(1175276), // Rule ID 16173 //
     /* 1175201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1175212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1175215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1175218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175240 */     // MIs[0] round
     /* 1175240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175250 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1175253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175275 */     // GIR_Coverage, 16173,
     /* 1175275 */     GIR_EraseRootFromParent_Done,
     /* 1175276 */   // Label 17143: @1175276
     /* 1175276 */   GIM_Try, /*On fail goto*//*Label 17144*/ GIMT_Encode4(1175356), // Rule ID 16176 //
     /* 1175281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175320 */     // MIs[0] round
     /* 1175320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175330 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175355 */     // GIR_Coverage, 16176,
     /* 1175355 */     GIR_EraseRootFromParent_Done,
     /* 1175356 */   // Label 17144: @1175356
     /* 1175356 */   GIM_Try, /*On fail goto*//*Label 17145*/ GIMT_Encode4(1175436), // Rule ID 16177 //
     /* 1175361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1175372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1175375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1175378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175400 */     // MIs[0] round
     /* 1175400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175410 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175435 */     // GIR_Coverage, 16177,
     /* 1175435 */     GIR_EraseRootFromParent_Done,
     /* 1175436 */   // Label 17145: @1175436
     /* 1175436 */   GIM_Try, /*On fail goto*//*Label 17146*/ GIMT_Encode4(1175516), // Rule ID 16180 //
     /* 1175441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175480 */     // MIs[0] round
     /* 1175480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175515 */     // GIR_Coverage, 16180,
     /* 1175515 */     GIR_EraseRootFromParent_Done,
     /* 1175516 */   // Label 17146: @1175516
     /* 1175516 */   GIM_Try, /*On fail goto*//*Label 17147*/ GIMT_Encode4(1175596), // Rule ID 16181 //
     /* 1175521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1175538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175560 */     // MIs[0] round
     /* 1175560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1175573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175595 */     // GIR_Coverage, 16181,
     /* 1175595 */     GIR_EraseRootFromParent_Done,
     /* 1175596 */   // Label 17147: @1175596
     /* 1175596 */   GIM_Try, /*On fail goto*//*Label 17148*/ GIMT_Encode4(1175676), // Rule ID 16184 //
     /* 1175601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1175612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1175615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1175618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175640 */     // MIs[0] round
     /* 1175640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175650 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175675 */     // GIR_Coverage, 16184,
     /* 1175675 */     GIR_EraseRootFromParent_Done,
     /* 1175676 */   // Label 17148: @1175676
     /* 1175676 */   GIM_Try, /*On fail goto*//*Label 17149*/ GIMT_Encode4(1175756), // Rule ID 16185 //
     /* 1175681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1175692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1175695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1175698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175720 */     // MIs[0] round
     /* 1175720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175730 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11599:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1175751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175755 */     // GIR_Coverage, 16185,
     /* 1175755 */     GIR_EraseRootFromParent_Done,
     /* 1175756 */   // Label 17149: @1175756
     /* 1175756 */   GIM_Try, /*On fail goto*//*Label 17150*/ GIMT_Encode4(1175836), // Rule ID 16188 //
     /* 1175761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1175772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1175775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1175778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175800 */     // MIs[0] round
     /* 1175800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175810 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175835 */     // GIR_Coverage, 16188,
     /* 1175835 */     GIR_EraseRootFromParent_Done,
     /* 1175836 */   // Label 17150: @1175836
     /* 1175836 */   GIM_Try, /*On fail goto*//*Label 17151*/ GIMT_Encode4(1175916), // Rule ID 16189 //
     /* 1175841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1175852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1175855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1175858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1175861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175880 */     // MIs[0] round
     /* 1175880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175915 */     // GIR_Coverage, 16189,
     /* 1175915 */     GIR_EraseRootFromParent_Done,
     /* 1175916 */   // Label 17151: @1175916
     /* 1175916 */   GIM_Try, /*On fail goto*//*Label 17152*/ GIMT_Encode4(1175996), // Rule ID 16192 //
     /* 1175921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1175929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1175932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1175935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1175938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1175941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1175960 */     // MIs[0] round
     /* 1175960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1175973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175995 */     // GIR_Coverage, 16192,
     /* 1175995 */     GIR_EraseRootFromParent_Done,
     /* 1175996 */   // Label 17152: @1175996
     /* 1175996 */   GIM_Try, /*On fail goto*//*Label 17153*/ GIMT_Encode4(1176076), // Rule ID 16193 //
     /* 1176001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1176012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1176015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1176018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176040 */     // MIs[0] round
     /* 1176040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1176071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176075 */     // GIR_Coverage, 16193,
     /* 1176075 */     GIR_EraseRootFromParent_Done,
     /* 1176076 */   // Label 17153: @1176076
     /* 1176076 */   GIM_Try, /*On fail goto*//*Label 17154*/ GIMT_Encode4(1176156), // Rule ID 16196 //
     /* 1176081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1176084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176120 */     // MIs[0] round
     /* 1176120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176130 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176155 */     // GIR_Coverage, 16196,
     /* 1176155 */     GIR_EraseRootFromParent_Done,
     /* 1176156 */   // Label 17154: @1176156
     /* 1176156 */   GIM_Try, /*On fail goto*//*Label 17155*/ GIMT_Encode4(1176236), // Rule ID 16197 //
     /* 1176161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1176164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1176172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1176175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1176178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176200 */     // MIs[0] round
     /* 1176200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176210 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1176213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1176231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176235 */     // GIR_Coverage, 16197,
     /* 1176235 */     GIR_EraseRootFromParent_Done,
     /* 1176236 */   // Label 17155: @1176236
     /* 1176236 */   GIM_Try, /*On fail goto*//*Label 17156*/ GIMT_Encode4(1176316), // Rule ID 16200 //
     /* 1176241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176280 */     // MIs[0] round
     /* 1176280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176315 */     // GIR_Coverage, 16200,
     /* 1176315 */     GIR_EraseRootFromParent_Done,
     /* 1176316 */   // Label 17156: @1176316
     /* 1176316 */   GIM_Try, /*On fail goto*//*Label 17157*/ GIMT_Encode4(1176396), // Rule ID 16201 //
     /* 1176321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1176338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176360 */     // MIs[0] round
     /* 1176360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176370 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176395 */     // GIR_Coverage, 16201,
     /* 1176395 */     GIR_EraseRootFromParent_Done,
     /* 1176396 */   // Label 17157: @1176396
     /* 1176396 */   GIM_Try, /*On fail goto*//*Label 17158*/ GIMT_Encode4(1176476), // Rule ID 16204 //
     /* 1176401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176440 */     // MIs[0] round
     /* 1176440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176450 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176475 */     // GIR_Coverage, 16204,
     /* 1176475 */     GIR_EraseRootFromParent_Done,
     /* 1176476 */   // Label 17158: @1176476
     /* 1176476 */   GIM_Try, /*On fail goto*//*Label 17159*/ GIMT_Encode4(1176556), // Rule ID 16205 //
     /* 1176481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1176498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176520 */     // MIs[0] round
     /* 1176520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176530 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176555 */     // GIR_Coverage, 16205,
     /* 1176555 */     GIR_EraseRootFromParent_Done,
     /* 1176556 */   // Label 17159: @1176556
     /* 1176556 */   GIM_Try, /*On fail goto*//*Label 17160*/ GIMT_Encode4(1176636), // Rule ID 16208 //
     /* 1176561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1176572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1176575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176600 */     // MIs[0] round
     /* 1176600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176610 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1176613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176635 */     // GIR_Coverage, 16208,
     /* 1176635 */     GIR_EraseRootFromParent_Done,
     /* 1176636 */   // Label 17160: @1176636
     /* 1176636 */   GIM_Try, /*On fail goto*//*Label 17161*/ GIMT_Encode4(1176716), // Rule ID 16209 //
     /* 1176641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1176652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1176655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1176658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176680 */     // MIs[0] round
     /* 1176680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176690 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1176693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176715 */     // GIR_Coverage, 16209,
     /* 1176715 */     GIR_EraseRootFromParent_Done,
     /* 1176716 */   // Label 17161: @1176716
     /* 1176716 */   GIM_Try, /*On fail goto*//*Label 17162*/ GIMT_Encode4(1176796), // Rule ID 16212 //
     /* 1176721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1176732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1176735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176760 */     // MIs[0] round
     /* 1176760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176795 */     // GIR_Coverage, 16212,
     /* 1176795 */     GIR_EraseRootFromParent_Done,
     /* 1176796 */   // Label 17162: @1176796
     /* 1176796 */   GIM_Try, /*On fail goto*//*Label 17163*/ GIMT_Encode4(1176876), // Rule ID 16213 //
     /* 1176801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1176812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1176815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176840 */     // MIs[0] round
     /* 1176840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1176853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176875 */     // GIR_Coverage, 16213,
     /* 1176875 */     GIR_EraseRootFromParent_Done,
     /* 1176876 */   // Label 17163: @1176876
     /* 1176876 */   GIM_Try, /*On fail goto*//*Label 17164*/ GIMT_Encode4(1176956), // Rule ID 16216 //
     /* 1176881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1176892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1176895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176920 */     // MIs[0] round
     /* 1176920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176930 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1176933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1176951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176955 */     // GIR_Coverage, 16216,
     /* 1176955 */     GIR_EraseRootFromParent_Done,
     /* 1176956 */   // Label 17164: @1176956
     /* 1176956 */   GIM_Try, /*On fail goto*//*Label 17165*/ GIMT_Encode4(1177036), // Rule ID 16217 //
     /* 1176961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1176969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1176972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1176975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177000 */     // MIs[0] round
     /* 1177000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177035 */     // GIR_Coverage, 16217,
     /* 1177035 */     GIR_EraseRootFromParent_Done,
     /* 1177036 */   // Label 17165: @1177036
     /* 1177036 */   GIM_Try, /*On fail goto*//*Label 17166*/ GIMT_Encode4(1177116), // Rule ID 16220 //
     /* 1177041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177080 */     // MIs[0] round
     /* 1177080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177115 */     // GIR_Coverage, 16220,
     /* 1177115 */     GIR_EraseRootFromParent_Done,
     /* 1177116 */   // Label 17166: @1177116
     /* 1177116 */   GIM_Try, /*On fail goto*//*Label 17167*/ GIMT_Encode4(1177196), // Rule ID 16221 //
     /* 1177121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1177132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1177135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1177138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177160 */     // MIs[0] round
     /* 1177160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177195 */     // GIR_Coverage, 16221,
     /* 1177195 */     GIR_EraseRootFromParent_Done,
     /* 1177196 */   // Label 17167: @1177196
     /* 1177196 */   GIM_Try, /*On fail goto*//*Label 17168*/ GIMT_Encode4(1177276), // Rule ID 16224 //
     /* 1177201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177240 */     // MIs[0] round
     /* 1177240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177275 */     // GIR_Coverage, 16224,
     /* 1177275 */     GIR_EraseRootFromParent_Done,
     /* 1177276 */   // Label 17168: @1177276
     /* 1177276 */   GIM_Try, /*On fail goto*//*Label 17169*/ GIMT_Encode4(1177356), // Rule ID 16225 //
     /* 1177281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1177292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1177295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177320 */     // MIs[0] round
     /* 1177320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177355 */     // GIR_Coverage, 16225,
     /* 1177355 */     GIR_EraseRootFromParent_Done,
     /* 1177356 */   // Label 17169: @1177356
     /* 1177356 */   GIM_Try, /*On fail goto*//*Label 17170*/ GIMT_Encode4(1177436), // Rule ID 16228 //
     /* 1177361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177400 */     // MIs[0] round
     /* 1177400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177410 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177435 */     // GIR_Coverage, 16228,
     /* 1177435 */     GIR_EraseRootFromParent_Done,
     /* 1177436 */   // Label 17170: @1177436
     /* 1177436 */   GIM_Try, /*On fail goto*//*Label 17171*/ GIMT_Encode4(1177516), // Rule ID 16229 //
     /* 1177441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1177452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1177455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177480 */     // MIs[0] round
     /* 1177480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177515 */     // GIR_Coverage, 16229,
     /* 1177515 */     GIR_EraseRootFromParent_Done,
     /* 1177516 */   // Label 17171: @1177516
     /* 1177516 */   GIM_Try, /*On fail goto*//*Label 17172*/ GIMT_Encode4(1177596), // Rule ID 16232 //
     /* 1177521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1177532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1177535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177560 */     // MIs[0] round
     /* 1177560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177570 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177595 */     // GIR_Coverage, 16232,
     /* 1177595 */     GIR_EraseRootFromParent_Done,
     /* 1177596 */   // Label 17172: @1177596
     /* 1177596 */   GIM_Try, /*On fail goto*//*Label 17173*/ GIMT_Encode4(1177676), // Rule ID 16233 //
     /* 1177601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1177612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1177615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177640 */     // MIs[0] round
     /* 1177640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1177653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177675 */     // GIR_Coverage, 16233,
     /* 1177675 */     GIR_EraseRootFromParent_Done,
     /* 1177676 */   // Label 17173: @1177676
     /* 1177676 */   GIM_Try, /*On fail goto*//*Label 17174*/ GIMT_Encode4(1177756), // Rule ID 16236 //
     /* 1177681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1177692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1177695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1177698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177720 */     // MIs[0] round
     /* 1177720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177730 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177755 */     // GIR_Coverage, 16236,
     /* 1177755 */     GIR_EraseRootFromParent_Done,
     /* 1177756 */   // Label 17174: @1177756
     /* 1177756 */   GIM_Try, /*On fail goto*//*Label 17175*/ GIMT_Encode4(1177836), // Rule ID 16237 //
     /* 1177761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1177772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1177775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1177778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177800 */     // MIs[0] round
     /* 1177800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177810 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1177813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177835 */     // GIR_Coverage, 16237,
     /* 1177835 */     GIR_EraseRootFromParent_Done,
     /* 1177836 */   // Label 17175: @1177836
     /* 1177836 */   GIM_Try, /*On fail goto*//*Label 17176*/ GIMT_Encode4(1177916), // Rule ID 16240 //
     /* 1177841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1177844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1177852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1177855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1177858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177880 */     // MIs[0] round
     /* 1177880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177890 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177915 */     // GIR_Coverage, 16240,
     /* 1177915 */     GIR_EraseRootFromParent_Done,
     /* 1177916 */   // Label 17176: @1177916
     /* 1177916 */   GIM_Try, /*On fail goto*//*Label 17177*/ GIMT_Encode4(1177996), // Rule ID 16241 //
     /* 1177921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1177924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1177929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1177932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1177935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1177938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177960 */     // MIs[0] round
     /* 1177960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177970 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1177973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1177991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177995 */     // GIR_Coverage, 16241,
     /* 1177995 */     GIR_EraseRootFromParent_Done,
     /* 1177996 */   // Label 17177: @1177996
     /* 1177996 */   GIM_Try, /*On fail goto*//*Label 17178*/ GIMT_Encode4(1178076), // Rule ID 16244 //
     /* 1178001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1178004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178040 */     // MIs[0] round
     /* 1178040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178050 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178075 */     // GIR_Coverage, 16244,
     /* 1178075 */     GIR_EraseRootFromParent_Done,
     /* 1178076 */   // Label 17178: @1178076
     /* 1178076 */   GIM_Try, /*On fail goto*//*Label 17179*/ GIMT_Encode4(1178156), // Rule ID 16245 //
     /* 1178081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1178084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1178089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1178092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1178095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178120 */     // MIs[0] round
     /* 1178120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178130 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1178133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1178151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178155 */     // GIR_Coverage, 16245,
     /* 1178155 */     GIR_EraseRootFromParent_Done,
     /* 1178156 */   // Label 17179: @1178156
     /* 1178156 */   GIM_Try, /*On fail goto*//*Label 17180*/ GIMT_Encode4(1178239), // Rule ID 16336 //
     /* 1178161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178200 */     // MIs[0] round
     /* 1178200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178210 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1178213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178238 */     // GIR_Coverage, 16336,
     /* 1178238 */     GIR_EraseRootFromParent_Done,
     /* 1178239 */   // Label 17180: @1178239
     /* 1178239 */   GIM_Try, /*On fail goto*//*Label 17181*/ GIMT_Encode4(1178322), // Rule ID 16337 //
     /* 1178244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178283 */     // MIs[0] round
     /* 1178283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178293 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1178296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178304 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178321 */     // GIR_Coverage, 16337,
     /* 1178321 */     GIR_EraseRootFromParent_Done,
     /* 1178322 */   // Label 17181: @1178322
     /* 1178322 */   GIM_Try, /*On fail goto*//*Label 17182*/ GIMT_Encode4(1178405), // Rule ID 16340 //
     /* 1178327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178366 */     // MIs[0] round
     /* 1178366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178404 */     // GIR_Coverage, 16340,
     /* 1178404 */     GIR_EraseRootFromParent_Done,
     /* 1178405 */   // Label 17182: @1178405
     /* 1178405 */   GIM_Try, /*On fail goto*//*Label 17183*/ GIMT_Encode4(1178488), // Rule ID 16341 //
     /* 1178410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178449 */     // MIs[0] round
     /* 1178449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178459 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1178462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178470 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178487 */     // GIR_Coverage, 16341,
     /* 1178487 */     GIR_EraseRootFromParent_Done,
     /* 1178488 */   // Label 17183: @1178488
     /* 1178488 */   GIM_Try, /*On fail goto*//*Label 17184*/ GIMT_Encode4(1178571), // Rule ID 16344 //
     /* 1178493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178532 */     // MIs[0] round
     /* 1178532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178542 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1178545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178570 */     // GIR_Coverage, 16344,
     /* 1178570 */     GIR_EraseRootFromParent_Done,
     /* 1178571 */   // Label 17184: @1178571
     /* 1178571 */   GIM_Try, /*On fail goto*//*Label 17185*/ GIMT_Encode4(1178654), // Rule ID 16345 //
     /* 1178576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178615 */     // MIs[0] round
     /* 1178615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178625 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1178628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178636 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178653 */     // GIR_Coverage, 16345,
     /* 1178653 */     GIR_EraseRootFromParent_Done,
     /* 1178654 */   // Label 17185: @1178654
     /* 1178654 */   GIM_Try, /*On fail goto*//*Label 17186*/ GIMT_Encode4(1178737), // Rule ID 16348 //
     /* 1178659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1178670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1178673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1178676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1178679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178698 */     // MIs[0] round
     /* 1178698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178708 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1178711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178736 */     // GIR_Coverage, 16348,
     /* 1178736 */     GIR_EraseRootFromParent_Done,
     /* 1178737 */   // Label 17186: @1178737
     /* 1178737 */   GIM_Try, /*On fail goto*//*Label 17187*/ GIMT_Encode4(1178820), // Rule ID 16349 //
     /* 1178742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1178753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1178756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1178759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1178762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178781 */     // MIs[0] round
     /* 1178781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178791 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1178794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178802 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178819 */     // GIR_Coverage, 16349,
     /* 1178819 */     GIR_EraseRootFromParent_Done,
     /* 1178820 */   // Label 17187: @1178820
     /* 1178820 */   GIM_Try, /*On fail goto*//*Label 17188*/ GIMT_Encode4(1178903), // Rule ID 16352 //
     /* 1178825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1178836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1178839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1178842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1178845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178864 */     // MIs[0] round
     /* 1178864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178874 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1178877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178902 */     // GIR_Coverage, 16352,
     /* 1178902 */     GIR_EraseRootFromParent_Done,
     /* 1178903 */   // Label 17188: @1178903
     /* 1178903 */   GIM_Try, /*On fail goto*//*Label 17189*/ GIMT_Encode4(1178986), // Rule ID 16353 //
     /* 1178908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1178919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1178922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1178925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1178928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178947 */     // MIs[0] round
     /* 1178947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178957 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1178960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178968 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178985 */     // GIR_Coverage, 16353,
     /* 1178985 */     GIR_EraseRootFromParent_Done,
     /* 1178986 */   // Label 17189: @1178986
     /* 1178986 */   GIM_Try, /*On fail goto*//*Label 17190*/ GIMT_Encode4(1179069), // Rule ID 16356 //
     /* 1178991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179030 */     // MIs[0] round
     /* 1179030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179040 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179068 */     // GIR_Coverage, 16356,
     /* 1179068 */     GIR_EraseRootFromParent_Done,
     /* 1179069 */   // Label 17190: @1179069
     /* 1179069 */   GIM_Try, /*On fail goto*//*Label 17191*/ GIMT_Encode4(1179152), // Rule ID 16357 //
     /* 1179074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179113 */     // MIs[0] round
     /* 1179113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179123 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179134 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179151 */     // GIR_Coverage, 16357,
     /* 1179151 */     GIR_EraseRootFromParent_Done,
     /* 1179152 */   // Label 17191: @1179152
     /* 1179152 */   GIM_Try, /*On fail goto*//*Label 17192*/ GIMT_Encode4(1179235), // Rule ID 16360 //
     /* 1179157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179196 */     // MIs[0] round
     /* 1179196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179206 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1179209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179234 */     // GIR_Coverage, 16360,
     /* 1179234 */     GIR_EraseRootFromParent_Done,
     /* 1179235 */   // Label 17192: @1179235
     /* 1179235 */   GIM_Try, /*On fail goto*//*Label 17193*/ GIMT_Encode4(1179318), // Rule ID 16361 //
     /* 1179240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179279 */     // MIs[0] round
     /* 1179279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179289 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1179292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179300 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179317 */     // GIR_Coverage, 16361,
     /* 1179317 */     GIR_EraseRootFromParent_Done,
     /* 1179318 */   // Label 17193: @1179318
     /* 1179318 */   GIM_Try, /*On fail goto*//*Label 17194*/ GIMT_Encode4(1179401), // Rule ID 16364 //
     /* 1179323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179362 */     // MIs[0] round
     /* 1179362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179372 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179400 */     // GIR_Coverage, 16364,
     /* 1179400 */     GIR_EraseRootFromParent_Done,
     /* 1179401 */   // Label 17194: @1179401
     /* 1179401 */   GIM_Try, /*On fail goto*//*Label 17195*/ GIMT_Encode4(1179484), // Rule ID 16365 //
     /* 1179406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179445 */     // MIs[0] round
     /* 1179445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179455 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1179458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179466 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179479 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179483 */     // GIR_Coverage, 16365,
     /* 1179483 */     GIR_EraseRootFromParent_Done,
     /* 1179484 */   // Label 17195: @1179484
     /* 1179484 */   GIM_Try, /*On fail goto*//*Label 17196*/ GIMT_Encode4(1179567), // Rule ID 16368 //
     /* 1179489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179528 */     // MIs[0] round
     /* 1179528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179538 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179566 */     // GIR_Coverage, 16368,
     /* 1179566 */     GIR_EraseRootFromParent_Done,
     /* 1179567 */   // Label 17196: @1179567
     /* 1179567 */   GIM_Try, /*On fail goto*//*Label 17197*/ GIMT_Encode4(1179650), // Rule ID 16369 //
     /* 1179572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179611 */     // MIs[0] round
     /* 1179611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179621 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1179624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179632 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179649 */     // GIR_Coverage, 16369,
     /* 1179649 */     GIR_EraseRootFromParent_Done,
     /* 1179650 */   // Label 17197: @1179650
     /* 1179650 */   GIM_Try, /*On fail goto*//*Label 17198*/ GIMT_Encode4(1179733), // Rule ID 16372 //
     /* 1179655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1179666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1179669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1179672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1179675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179694 */     // MIs[0] round
     /* 1179694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179732 */     // GIR_Coverage, 16372,
     /* 1179732 */     GIR_EraseRootFromParent_Done,
     /* 1179733 */   // Label 17198: @1179733
     /* 1179733 */   GIM_Try, /*On fail goto*//*Label 17199*/ GIMT_Encode4(1179816), // Rule ID 16373 //
     /* 1179738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1179749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1179752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1179755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1179758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179777 */     // MIs[0] round
     /* 1179777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179787 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1179790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179798 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179815 */     // GIR_Coverage, 16373,
     /* 1179815 */     GIR_EraseRootFromParent_Done,
     /* 1179816 */   // Label 17199: @1179816
     /* 1179816 */   GIM_Try, /*On fail goto*//*Label 17200*/ GIMT_Encode4(1179899), // Rule ID 16376 //
     /* 1179821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1179832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1179835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1179838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1179841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179860 */     // MIs[0] round
     /* 1179860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179898 */     // GIR_Coverage, 16376,
     /* 1179898 */     GIR_EraseRootFromParent_Done,
     /* 1179899 */   // Label 17200: @1179899
     /* 1179899 */   GIM_Try, /*On fail goto*//*Label 17201*/ GIMT_Encode4(1179982), // Rule ID 16377 //
     /* 1179904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1179915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1179918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1179921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1179924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179943 */     // MIs[0] round
     /* 1179943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179953 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1179956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179964 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179981 */     // GIR_Coverage, 16377,
     /* 1179981 */     GIR_EraseRootFromParent_Done,
     /* 1179982 */   // Label 17201: @1179982
     /* 1179982 */   GIM_Try, /*On fail goto*//*Label 17202*/ GIMT_Encode4(1180065), // Rule ID 16380 //
     /* 1179987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1179990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1179995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1179998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180026 */     // MIs[0] round
     /* 1180026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1180039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180064 */     // GIR_Coverage, 16380,
     /* 1180064 */     GIR_EraseRootFromParent_Done,
     /* 1180065 */   // Label 17202: @1180065
     /* 1180065 */   GIM_Try, /*On fail goto*//*Label 17203*/ GIMT_Encode4(1180148), // Rule ID 16381 //
     /* 1180070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1180081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180109 */     // MIs[0] round
     /* 1180109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180119 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1180122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180130 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180147 */     // GIR_Coverage, 16381,
     /* 1180147 */     GIR_EraseRootFromParent_Done,
     /* 1180148 */   // Label 17203: @1180148
     /* 1180148 */   GIM_Try, /*On fail goto*//*Label 17204*/ GIMT_Encode4(1180231), // Rule ID 16384 //
     /* 1180153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180192 */     // MIs[0] round
     /* 1180192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180230 */     // GIR_Coverage, 16384,
     /* 1180230 */     GIR_EraseRootFromParent_Done,
     /* 1180231 */   // Label 17204: @1180231
     /* 1180231 */   GIM_Try, /*On fail goto*//*Label 17205*/ GIMT_Encode4(1180314), // Rule ID 16385 //
     /* 1180236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180275 */     // MIs[0] round
     /* 1180275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180285 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1180288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180296 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180313 */     // GIR_Coverage, 16385,
     /* 1180313 */     GIR_EraseRootFromParent_Done,
     /* 1180314 */   // Label 17205: @1180314
     /* 1180314 */   GIM_Try, /*On fail goto*//*Label 17206*/ GIMT_Encode4(1180397), // Rule ID 16388 //
     /* 1180319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180358 */     // MIs[0] round
     /* 1180358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180396 */     // GIR_Coverage, 16388,
     /* 1180396 */     GIR_EraseRootFromParent_Done,
     /* 1180397 */   // Label 17206: @1180397
     /* 1180397 */   GIM_Try, /*On fail goto*//*Label 17207*/ GIMT_Encode4(1180480), // Rule ID 16389 //
     /* 1180402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180441 */     // MIs[0] round
     /* 1180441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180451 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1180454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180462 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180479 */     // GIR_Coverage, 16389,
     /* 1180479 */     GIR_EraseRootFromParent_Done,
     /* 1180480 */   // Label 17207: @1180480
     /* 1180480 */   GIM_Try, /*On fail goto*//*Label 17208*/ GIMT_Encode4(1180563), // Rule ID 16392 //
     /* 1180485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180524 */     // MIs[0] round
     /* 1180524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180562 */     // GIR_Coverage, 16392,
     /* 1180562 */     GIR_EraseRootFromParent_Done,
     /* 1180563 */   // Label 17208: @1180563
     /* 1180563 */   GIM_Try, /*On fail goto*//*Label 17209*/ GIMT_Encode4(1180646), // Rule ID 16393 //
     /* 1180568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180607 */     // MIs[0] round
     /* 1180607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180617 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1180620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180628 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180641 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180645 */     // GIR_Coverage, 16393,
     /* 1180645 */     GIR_EraseRootFromParent_Done,
     /* 1180646 */   // Label 17209: @1180646
     /* 1180646 */   GIM_Try, /*On fail goto*//*Label 17210*/ GIMT_Encode4(1180729), // Rule ID 16396 //
     /* 1180651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1180662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1180665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1180668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180690 */     // MIs[0] round
     /* 1180690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180700 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1180703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180728 */     // GIR_Coverage, 16396,
     /* 1180728 */     GIR_EraseRootFromParent_Done,
     /* 1180729 */   // Label 17210: @1180729
     /* 1180729 */   GIM_Try, /*On fail goto*//*Label 17211*/ GIMT_Encode4(1180812), // Rule ID 16397 //
     /* 1180734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1180745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1180748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1180751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180773 */     // MIs[0] round
     /* 1180773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180783 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1180786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180794 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180811 */     // GIR_Coverage, 16397,
     /* 1180811 */     GIR_EraseRootFromParent_Done,
     /* 1180812 */   // Label 17211: @1180812
     /* 1180812 */   GIM_Try, /*On fail goto*//*Label 17212*/ GIMT_Encode4(1180895), // Rule ID 16400 //
     /* 1180817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1180828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1180831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1180834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180856 */     // MIs[0] round
     /* 1180856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180866 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1180869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180894 */     // GIR_Coverage, 16400,
     /* 1180894 */     GIR_EraseRootFromParent_Done,
     /* 1180895 */   // Label 17212: @1180895
     /* 1180895 */   GIM_Try, /*On fail goto*//*Label 17213*/ GIMT_Encode4(1180978), // Rule ID 16401 //
     /* 1180900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1180911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1180914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1180917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1180920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1180939 */     // MIs[0] round
     /* 1180939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180949 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1180952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180960 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1180970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180977 */     // GIR_Coverage, 16401,
     /* 1180977 */     GIR_EraseRootFromParent_Done,
     /* 1180978 */   // Label 17213: @1180978
     /* 1180978 */   GIM_Try, /*On fail goto*//*Label 17214*/ GIMT_Encode4(1181061), // Rule ID 16404 //
     /* 1180983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1180991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1180994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1180997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181022 */     // MIs[0] round
     /* 1181022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181032 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181060 */     // GIR_Coverage, 16404,
     /* 1181060 */     GIR_EraseRootFromParent_Done,
     /* 1181061 */   // Label 17214: @1181061
     /* 1181061 */   GIM_Try, /*On fail goto*//*Label 17215*/ GIMT_Encode4(1181144), // Rule ID 16405 //
     /* 1181066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1181077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1181080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181105 */     // MIs[0] round
     /* 1181105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181115 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181126 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181143 */     // GIR_Coverage, 16405,
     /* 1181143 */     GIR_EraseRootFromParent_Done,
     /* 1181144 */   // Label 17215: @1181144
     /* 1181144 */   GIM_Try, /*On fail goto*//*Label 17216*/ GIMT_Encode4(1181227), // Rule ID 16408 //
     /* 1181149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181188 */     // MIs[0] round
     /* 1181188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181198 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181226 */     // GIR_Coverage, 16408,
     /* 1181226 */     GIR_EraseRootFromParent_Done,
     /* 1181227 */   // Label 17216: @1181227
     /* 1181227 */   GIM_Try, /*On fail goto*//*Label 17217*/ GIMT_Encode4(1181310), // Rule ID 16409 //
     /* 1181232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181271 */     // MIs[0] round
     /* 1181271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181281 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1181284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181292 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181309 */     // GIR_Coverage, 16409,
     /* 1181309 */     GIR_EraseRootFromParent_Done,
     /* 1181310 */   // Label 17217: @1181310
     /* 1181310 */   GIM_Try, /*On fail goto*//*Label 17218*/ GIMT_Encode4(1181393), // Rule ID 16412 //
     /* 1181315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181354 */     // MIs[0] round
     /* 1181354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181392 */     // GIR_Coverage, 16412,
     /* 1181392 */     GIR_EraseRootFromParent_Done,
     /* 1181393 */   // Label 17218: @1181393
     /* 1181393 */   GIM_Try, /*On fail goto*//*Label 17219*/ GIMT_Encode4(1181476), // Rule ID 16413 //
     /* 1181398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181437 */     // MIs[0] round
     /* 1181437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181447 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1181450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181458 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181475 */     // GIR_Coverage, 16413,
     /* 1181475 */     GIR_EraseRootFromParent_Done,
     /* 1181476 */   // Label 17219: @1181476
     /* 1181476 */   GIM_Try, /*On fail goto*//*Label 17220*/ GIMT_Encode4(1181559), // Rule ID 16416 //
     /* 1181481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181520 */     // MIs[0] round
     /* 1181520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181530 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1181533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181558 */     // GIR_Coverage, 16416,
     /* 1181558 */     GIR_EraseRootFromParent_Done,
     /* 1181559 */   // Label 17220: @1181559
     /* 1181559 */   GIM_Try, /*On fail goto*//*Label 17221*/ GIMT_Encode4(1181642), // Rule ID 16417 //
     /* 1181564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181603 */     // MIs[0] round
     /* 1181603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181613 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1181616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181624 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181641 */     // GIR_Coverage, 16417,
     /* 1181641 */     GIR_EraseRootFromParent_Done,
     /* 1181642 */   // Label 17221: @1181642
     /* 1181642 */   GIM_Try, /*On fail goto*//*Label 17222*/ GIMT_Encode4(1181725), // Rule ID 16420 //
     /* 1181647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1181658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1181661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1181664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181686 */     // MIs[0] round
     /* 1181686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181724 */     // GIR_Coverage, 16420,
     /* 1181724 */     GIR_EraseRootFromParent_Done,
     /* 1181725 */   // Label 17222: @1181725
     /* 1181725 */   GIM_Try, /*On fail goto*//*Label 17223*/ GIMT_Encode4(1181808), // Rule ID 16421 //
     /* 1181730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1181741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1181744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1181747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181769 */     // MIs[0] round
     /* 1181769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181779 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1181782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181790 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181807 */     // GIR_Coverage, 16421,
     /* 1181807 */     GIR_EraseRootFromParent_Done,
     /* 1181808 */   // Label 17223: @1181808
     /* 1181808 */   GIM_Try, /*On fail goto*//*Label 17224*/ GIMT_Encode4(1181891), // Rule ID 16424 //
     /* 1181813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1181824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1181827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1181830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181852 */     // MIs[0] round
     /* 1181852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181862 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181890 */     // GIR_Coverage, 16424,
     /* 1181890 */     GIR_EraseRootFromParent_Done,
     /* 1181891 */   // Label 17224: @1181891
     /* 1181891 */   GIM_Try, /*On fail goto*//*Label 17225*/ GIMT_Encode4(1181974), // Rule ID 16425 //
     /* 1181896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1181907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1181910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1181913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181935 */     // MIs[0] round
     /* 1181935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181945 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1181948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181956 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1181966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181973 */     // GIR_Coverage, 16425,
     /* 1181973 */     GIR_EraseRootFromParent_Done,
     /* 1181974 */   // Label 17225: @1181974
     /* 1181974 */   GIM_Try, /*On fail goto*//*Label 17226*/ GIMT_Encode4(1182057), // Rule ID 16428 //
     /* 1181979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1181987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1181990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1181993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1181996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182018 */     // MIs[0] round
     /* 1182018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182028 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182056 */     // GIR_Coverage, 16428,
     /* 1182056 */     GIR_EraseRootFromParent_Done,
     /* 1182057 */   // Label 17226: @1182057
     /* 1182057 */   GIM_Try, /*On fail goto*//*Label 17227*/ GIMT_Encode4(1182140), // Rule ID 16429 //
     /* 1182062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1182073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1182076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1182079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182101 */     // MIs[0] round
     /* 1182101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182111 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182122 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182139 */     // GIR_Coverage, 16429,
     /* 1182139 */     GIR_EraseRootFromParent_Done,
     /* 1182140 */   // Label 17227: @1182140
     /* 1182140 */   GIM_Try, /*On fail goto*//*Label 17228*/ GIMT_Encode4(1182223), // Rule ID 16432 //
     /* 1182145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182184 */     // MIs[0] round
     /* 1182184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182222 */     // GIR_Coverage, 16432,
     /* 1182222 */     GIR_EraseRootFromParent_Done,
     /* 1182223 */   // Label 17228: @1182223
     /* 1182223 */   GIM_Try, /*On fail goto*//*Label 17229*/ GIMT_Encode4(1182306), // Rule ID 16433 //
     /* 1182228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182267 */     // MIs[0] round
     /* 1182267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182277 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182288 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182305 */     // GIR_Coverage, 16433,
     /* 1182305 */     GIR_EraseRootFromParent_Done,
     /* 1182306 */   // Label 17229: @1182306
     /* 1182306 */   GIM_Try, /*On fail goto*//*Label 17230*/ GIMT_Encode4(1182389), // Rule ID 16436 //
     /* 1182311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182350 */     // MIs[0] round
     /* 1182350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182388 */     // GIR_Coverage, 16436,
     /* 1182388 */     GIR_EraseRootFromParent_Done,
     /* 1182389 */   // Label 17230: @1182389
     /* 1182389 */   GIM_Try, /*On fail goto*//*Label 17231*/ GIMT_Encode4(1182472), // Rule ID 16437 //
     /* 1182394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182433 */     // MIs[0] round
     /* 1182433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182443 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1182446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182454 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182471 */     // GIR_Coverage, 16437,
     /* 1182471 */     GIR_EraseRootFromParent_Done,
     /* 1182472 */   // Label 17231: @1182472
     /* 1182472 */   GIM_Try, /*On fail goto*//*Label 17232*/ GIMT_Encode4(1182555), // Rule ID 16440 //
     /* 1182477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182516 */     // MIs[0] round
     /* 1182516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182554 */     // GIR_Coverage, 16440,
     /* 1182554 */     GIR_EraseRootFromParent_Done,
     /* 1182555 */   // Label 17232: @1182555
     /* 1182555 */   GIM_Try, /*On fail goto*//*Label 17233*/ GIMT_Encode4(1182638), // Rule ID 16441 //
     /* 1182560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182599 */     // MIs[0] round
     /* 1182599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1182612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182620 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182637 */     // GIR_Coverage, 16441,
     /* 1182637 */     GIR_EraseRootFromParent_Done,
     /* 1182638 */   // Label 17233: @1182638
     /* 1182638 */   GIM_Try, /*On fail goto*//*Label 17234*/ GIMT_Encode4(1182721), // Rule ID 16444 //
     /* 1182643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1182654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1182657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1182660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182682 */     // MIs[0] round
     /* 1182682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182692 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182720 */     // GIR_Coverage, 16444,
     /* 1182720 */     GIR_EraseRootFromParent_Done,
     /* 1182721 */   // Label 17234: @1182721
     /* 1182721 */   GIM_Try, /*On fail goto*//*Label 17235*/ GIMT_Encode4(1182804), // Rule ID 16445 //
     /* 1182726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1182737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1182740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1182743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182765 */     // MIs[0] round
     /* 1182765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182775 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1182778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182786 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182803 */     // GIR_Coverage, 16445,
     /* 1182803 */     GIR_EraseRootFromParent_Done,
     /* 1182804 */   // Label 17235: @1182804
     /* 1182804 */   GIM_Try, /*On fail goto*//*Label 17236*/ GIMT_Encode4(1182887), // Rule ID 16448 //
     /* 1182809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1182820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1182823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1182826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182848 */     // MIs[0] round
     /* 1182848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182886 */     // GIR_Coverage, 16448,
     /* 1182886 */     GIR_EraseRootFromParent_Done,
     /* 1182887 */   // Label 17236: @1182887
     /* 1182887 */   GIM_Try, /*On fail goto*//*Label 17237*/ GIMT_Encode4(1182970), // Rule ID 16449 //
     /* 1182892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1182903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1182906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1182909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182931 */     // MIs[0] round
     /* 1182931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1182944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182952 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182969 */     // GIR_Coverage, 16449,
     /* 1182969 */     GIR_EraseRootFromParent_Done,
     /* 1182970 */   // Label 17237: @1182970
     /* 1182970 */   GIM_Try, /*On fail goto*//*Label 17238*/ GIMT_Encode4(1183053), // Rule ID 16452 //
     /* 1182975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1182983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1182986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1182989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1182992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183014 */     // MIs[0] round
     /* 1183014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183024 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1183027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183052 */     // GIR_Coverage, 16452,
     /* 1183052 */     GIR_EraseRootFromParent_Done,
     /* 1183053 */   // Label 17238: @1183053
     /* 1183053 */   GIM_Try, /*On fail goto*//*Label 17239*/ GIMT_Encode4(1183136), // Rule ID 16453 //
     /* 1183058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1183066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1183069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1183072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1183075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183097 */     // MIs[0] round
     /* 1183097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183107 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1183110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183118 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183135 */     // GIR_Coverage, 16453,
     /* 1183135 */     GIR_EraseRootFromParent_Done,
     /* 1183136 */   // Label 17239: @1183136
     /* 1183136 */   GIM_Try, /*On fail goto*//*Label 17240*/ GIMT_Encode4(1183219), // Rule ID 16516 //
     /* 1183141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1183152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1183155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1183161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183180 */     // MIs[0] round
     /* 1183180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183190 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1183193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183218 */     // GIR_Coverage, 16516,
     /* 1183218 */     GIR_EraseRootFromParent_Done,
     /* 1183219 */   // Label 17240: @1183219
     /* 1183219 */   GIM_Try, /*On fail goto*//*Label 17241*/ GIMT_Encode4(1183302), // Rule ID 16517 //
     /* 1183224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1183235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1183238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1183244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183263 */     // MIs[0] round
     /* 1183263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183273 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1183276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183284 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183301 */     // GIR_Coverage, 16517,
     /* 1183301 */     GIR_EraseRootFromParent_Done,
     /* 1183302 */   // Label 17241: @1183302
     /* 1183302 */   GIM_Try, /*On fail goto*//*Label 17242*/ GIMT_Encode4(1183385), // Rule ID 16520 //
     /* 1183307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183346 */     // MIs[0] round
     /* 1183346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183356 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183384 */     // GIR_Coverage, 16520,
     /* 1183384 */     GIR_EraseRootFromParent_Done,
     /* 1183385 */   // Label 17242: @1183385
     /* 1183385 */   GIM_Try, /*On fail goto*//*Label 17243*/ GIMT_Encode4(1183468), // Rule ID 16521 //
     /* 1183390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1183401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1183404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1183410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183429 */     // MIs[0] round
     /* 1183429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183439 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1183442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183450 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183467 */     // GIR_Coverage, 16521,
     /* 1183467 */     GIR_EraseRootFromParent_Done,
     /* 1183468 */   // Label 17243: @1183468
     /* 1183468 */   GIM_Try, /*On fail goto*//*Label 17244*/ GIMT_Encode4(1183551), // Rule ID 16524 //
     /* 1183473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1183484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1183487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1183493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183512 */     // MIs[0] round
     /* 1183512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183522 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1183525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183550 */     // GIR_Coverage, 16524,
     /* 1183550 */     GIR_EraseRootFromParent_Done,
     /* 1183551 */   // Label 17244: @1183551
     /* 1183551 */   GIM_Try, /*On fail goto*//*Label 17245*/ GIMT_Encode4(1183634), // Rule ID 16525 //
     /* 1183556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1183567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1183570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1183576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183595 */     // MIs[0] round
     /* 1183595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183605 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1183608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183616 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183633 */     // GIR_Coverage, 16525,
     /* 1183633 */     GIR_EraseRootFromParent_Done,
     /* 1183634 */   // Label 17245: @1183634
     /* 1183634 */   GIM_Try, /*On fail goto*//*Label 17246*/ GIMT_Encode4(1183717), // Rule ID 16528 //
     /* 1183639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1183650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1183653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1183656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1183659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183678 */     // MIs[0] round
     /* 1183678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1183691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183712 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183716 */     // GIR_Coverage, 16528,
     /* 1183716 */     GIR_EraseRootFromParent_Done,
     /* 1183717 */   // Label 17246: @1183717
     /* 1183717 */   GIM_Try, /*On fail goto*//*Label 17247*/ GIMT_Encode4(1183800), // Rule ID 16529 //
     /* 1183722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1183733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1183736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1183739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1183742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183761 */     // MIs[0] round
     /* 1183761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183771 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1183774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183782 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183799 */     // GIR_Coverage, 16529,
     /* 1183799 */     GIR_EraseRootFromParent_Done,
     /* 1183800 */   // Label 17247: @1183800
     /* 1183800 */   GIM_Try, /*On fail goto*//*Label 17248*/ GIMT_Encode4(1183883), // Rule ID 16532 //
     /* 1183805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1183816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1183819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1183822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1183825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183844 */     // MIs[0] round
     /* 1183844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183854 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1183857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183882 */     // GIR_Coverage, 16532,
     /* 1183882 */     GIR_EraseRootFromParent_Done,
     /* 1183883 */   // Label 17248: @1183883
     /* 1183883 */   GIM_Try, /*On fail goto*//*Label 17249*/ GIMT_Encode4(1183966), // Rule ID 16533 //
     /* 1183888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1183891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1183899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1183902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1183905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1183908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183927 */     // MIs[0] round
     /* 1183927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183937 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1183940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183948 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1183958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183965 */     // GIR_Coverage, 16533,
     /* 1183965 */     GIR_EraseRootFromParent_Done,
     /* 1183966 */   // Label 17249: @1183966
     /* 1183966 */   GIM_Try, /*On fail goto*//*Label 17250*/ GIMT_Encode4(1184049), // Rule ID 16536 //
     /* 1183971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1183974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1183982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1183985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1183988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1183991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184010 */     // MIs[0] round
     /* 1184010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184020 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184048 */     // GIR_Coverage, 16536,
     /* 1184048 */     GIR_EraseRootFromParent_Done,
     /* 1184049 */   // Label 17250: @1184049
     /* 1184049 */   GIM_Try, /*On fail goto*//*Label 17251*/ GIMT_Encode4(1184132), // Rule ID 16537 //
     /* 1184054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1184065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1184068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1184074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184093 */     // MIs[0] round
     /* 1184093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184103 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184114 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1184124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184131 */     // GIR_Coverage, 16537,
     /* 1184131 */     GIR_EraseRootFromParent_Done,
     /* 1184132 */   // Label 17251: @1184132
     /* 1184132 */   GIM_Try, /*On fail goto*//*Label 17252*/ GIMT_Encode4(1184215), // Rule ID 16540 //
     /* 1184137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1184148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1184151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1184154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1184157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184176 */     // MIs[0] round
     /* 1184176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184186 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1184189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184214 */     // GIR_Coverage, 16540,
     /* 1184214 */     GIR_EraseRootFromParent_Done,
     /* 1184215 */   // Label 17252: @1184215
     /* 1184215 */   GIM_Try, /*On fail goto*//*Label 17253*/ GIMT_Encode4(1184298), // Rule ID 16541 //
     /* 1184220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1184231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1184234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1184237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1184240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184259 */     // MIs[0] round
     /* 1184259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184269 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1184272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184280 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184297 */     // GIR_Coverage, 16541,
     /* 1184297 */     GIR_EraseRootFromParent_Done,
     /* 1184298 */   // Label 17253: @1184298
     /* 1184298 */   GIM_Try, /*On fail goto*//*Label 17254*/ GIMT_Encode4(1184381), // Rule ID 16544 //
     /* 1184303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184342 */     // MIs[0] round
     /* 1184342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184380 */     // GIR_Coverage, 16544,
     /* 1184380 */     GIR_EraseRootFromParent_Done,
     /* 1184381 */   // Label 17254: @1184381
     /* 1184381 */   GIM_Try, /*On fail goto*//*Label 17255*/ GIMT_Encode4(1184464), // Rule ID 16545 //
     /* 1184386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1184397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1184400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1184406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184425 */     // MIs[0] round
     /* 1184425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184435 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1184438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184463 */     // GIR_Coverage, 16545,
     /* 1184463 */     GIR_EraseRootFromParent_Done,
     /* 1184464 */   // Label 17255: @1184464
     /* 1184464 */   GIM_Try, /*On fail goto*//*Label 17256*/ GIMT_Encode4(1184547), // Rule ID 16548 //
     /* 1184469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1184480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1184483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1184489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184508 */     // MIs[0] round
     /* 1184508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184546 */     // GIR_Coverage, 16548,
     /* 1184546 */     GIR_EraseRootFromParent_Done,
     /* 1184547 */   // Label 17256: @1184547
     /* 1184547 */   GIM_Try, /*On fail goto*//*Label 17257*/ GIMT_Encode4(1184630), // Rule ID 16549 //
     /* 1184552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1184563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1184566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1184572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184591 */     // MIs[0] round
     /* 1184591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184601 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1184604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184612 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184629 */     // GIR_Coverage, 16549,
     /* 1184629 */     GIR_EraseRootFromParent_Done,
     /* 1184630 */   // Label 17257: @1184630
     /* 1184630 */   GIM_Try, /*On fail goto*//*Label 17258*/ GIMT_Encode4(1184713), // Rule ID 16552 //
     /* 1184635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1184646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1184649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1184652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1184655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184674 */     // MIs[0] round
     /* 1184674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184712 */     // GIR_Coverage, 16552,
     /* 1184712 */     GIR_EraseRootFromParent_Done,
     /* 1184713 */   // Label 17258: @1184713
     /* 1184713 */   GIM_Try, /*On fail goto*//*Label 17259*/ GIMT_Encode4(1184796), // Rule ID 16553 //
     /* 1184718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1184729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1184732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1184735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1184738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184757 */     // MIs[0] round
     /* 1184757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184767 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1184770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184778 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184795 */     // GIR_Coverage, 16553,
     /* 1184795 */     GIR_EraseRootFromParent_Done,
     /* 1184796 */   // Label 17259: @1184796
     /* 1184796 */   GIM_Try, /*On fail goto*//*Label 17260*/ GIMT_Encode4(1184879), // Rule ID 16556 //
     /* 1184801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1184804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1184812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1184815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1184818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184840 */     // MIs[0] round
     /* 1184840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184850 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184874 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184878 */     // GIR_Coverage, 16556,
     /* 1184878 */     GIR_EraseRootFromParent_Done,
     /* 1184879 */   // Label 17260: @1184879
     /* 1184879 */   GIM_Try, /*On fail goto*//*Label 17261*/ GIMT_Encode4(1184962), // Rule ID 16557 //
     /* 1184884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1184887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1184895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1184898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1184901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184923 */     // MIs[0] round
     /* 1184923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184933 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1184936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184944 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1184960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184961 */     // GIR_Coverage, 16557,
     /* 1184961 */     GIR_EraseRootFromParent_Done,
     /* 1184962 */   // Label 17261: @1184962
     /* 1184962 */   GIM_Try, /*On fail goto*//*Label 17262*/ GIMT_Encode4(1185045), // Rule ID 16560 //
     /* 1184967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1184970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1184975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1184978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1184981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1184984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1184987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185006 */     // MIs[0] round
     /* 1185006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1185019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185044 */     // GIR_Coverage, 16560,
     /* 1185044 */     GIR_EraseRootFromParent_Done,
     /* 1185045 */   // Label 17262: @1185045
     /* 1185045 */   GIM_Try, /*On fail goto*//*Label 17263*/ GIMT_Encode4(1185128), // Rule ID 16561 //
     /* 1185050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1185061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1185064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1185067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1185070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185089 */     // MIs[0] round
     /* 1185089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185099 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1185102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185110 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185127 */     // GIR_Coverage, 16561,
     /* 1185127 */     GIR_EraseRootFromParent_Done,
     /* 1185128 */   // Label 17263: @1185128
     /* 1185128 */   GIM_Try, /*On fail goto*//*Label 17264*/ GIMT_Encode4(1185211), // Rule ID 16564 //
     /* 1185133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1185144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1185147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1185153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185172 */     // MIs[0] round
     /* 1185172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185210 */     // GIR_Coverage, 16564,
     /* 1185210 */     GIR_EraseRootFromParent_Done,
     /* 1185211 */   // Label 17264: @1185211
     /* 1185211 */   GIM_Try, /*On fail goto*//*Label 17265*/ GIMT_Encode4(1185294), // Rule ID 16565 //
     /* 1185216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1185227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1185230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1185236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185255 */     // MIs[0] round
     /* 1185255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1185268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185276 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185293 */     // GIR_Coverage, 16565,
     /* 1185293 */     GIR_EraseRootFromParent_Done,
     /* 1185294 */   // Label 17265: @1185294
     /* 1185294 */   GIM_Try, /*On fail goto*//*Label 17266*/ GIMT_Encode4(1185377), // Rule ID 16568 //
     /* 1185299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1185310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1185313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185338 */     // MIs[0] round
     /* 1185338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185376 */     // GIR_Coverage, 16568,
     /* 1185376 */     GIR_EraseRootFromParent_Done,
     /* 1185377 */   // Label 17266: @1185377
     /* 1185377 */   GIM_Try, /*On fail goto*//*Label 17267*/ GIMT_Encode4(1185460), // Rule ID 16569 //
     /* 1185382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1185393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1185396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1185402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185421 */     // MIs[0] round
     /* 1185421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1185434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185442 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185459 */     // GIR_Coverage, 16569,
     /* 1185459 */     GIR_EraseRootFromParent_Done,
     /* 1185460 */   // Label 17267: @1185460
     /* 1185460 */   GIM_Try, /*On fail goto*//*Label 17268*/ GIMT_Encode4(1185543), // Rule ID 16572 //
     /* 1185465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1185468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185504 */     // MIs[0] round
     /* 1185504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185542 */     // GIR_Coverage, 16572,
     /* 1185542 */     GIR_EraseRootFromParent_Done,
     /* 1185543 */   // Label 17268: @1185543
     /* 1185543 */   GIM_Try, /*On fail goto*//*Label 17269*/ GIMT_Encode4(1185626), // Rule ID 16573 //
     /* 1185548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1185551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185587 */     // MIs[0] round
     /* 1185587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185597 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1185600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185608 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185625 */     // GIR_Coverage, 16573,
     /* 1185625 */     GIR_EraseRootFromParent_Done,
     /* 1185626 */   // Label 17269: @1185626
     /* 1185626 */   GIM_Try, /*On fail goto*//*Label 17270*/ GIMT_Encode4(1185709), // Rule ID 16576 //
     /* 1185631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1185642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1185645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1185648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185670 */     // MIs[0] round
     /* 1185670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1185683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185708 */     // GIR_Coverage, 16576,
     /* 1185708 */     GIR_EraseRootFromParent_Done,
     /* 1185709 */   // Label 17270: @1185709
     /* 1185709 */   GIM_Try, /*On fail goto*//*Label 17271*/ GIMT_Encode4(1185792), // Rule ID 16577 //
     /* 1185714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1185725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1185728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1185731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185753 */     // MIs[0] round
     /* 1185753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185763 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1185766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185774 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185791 */     // GIR_Coverage, 16577,
     /* 1185791 */     GIR_EraseRootFromParent_Done,
     /* 1185792 */   // Label 17271: @1185792
     /* 1185792 */   GIM_Try, /*On fail goto*//*Label 17272*/ GIMT_Encode4(1185875), // Rule ID 16580 //
     /* 1185797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1185808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1185811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1185814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185836 */     // MIs[0] round
     /* 1185836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1185849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185874 */     // GIR_Coverage, 16580,
     /* 1185874 */     GIR_EraseRootFromParent_Done,
     /* 1185875 */   // Label 17272: @1185875
     /* 1185875 */   GIM_Try, /*On fail goto*//*Label 17273*/ GIMT_Encode4(1185958), // Rule ID 16581 //
     /* 1185880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1185883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1185891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1185894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1185897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1185900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1185919 */     // MIs[0] round
     /* 1185919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185929 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1185932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185940 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1185950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1185956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185957 */     // GIR_Coverage, 16581,
     /* 1185957 */     GIR_EraseRootFromParent_Done,
     /* 1185958 */   // Label 17273: @1185958
     /* 1185958 */   GIM_Try, /*On fail goto*//*Label 17274*/ GIMT_Encode4(1186041), // Rule ID 16584 //
     /* 1185963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1185966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1185971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1185974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1185977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1185980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1185983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186002 */     // MIs[0] round
     /* 1186002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186012 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186040 */     // GIR_Coverage, 16584,
     /* 1186040 */     GIR_EraseRootFromParent_Done,
     /* 1186041 */   // Label 17274: @1186041
     /* 1186041 */   GIM_Try, /*On fail goto*//*Label 17275*/ GIMT_Encode4(1186124), // Rule ID 16585 //
     /* 1186046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1186057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1186060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186085 */     // MIs[0] round
     /* 1186085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186095 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186106 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186123 */     // GIR_Coverage, 16585,
     /* 1186123 */     GIR_EraseRootFromParent_Done,
     /* 1186124 */   // Label 17275: @1186124
     /* 1186124 */   GIM_Try, /*On fail goto*//*Label 17276*/ GIMT_Encode4(1186207), // Rule ID 16588 //
     /* 1186129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1186140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1186143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186168 */     // MIs[0] round
     /* 1186168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186178 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186206 */     // GIR_Coverage, 16588,
     /* 1186206 */     GIR_EraseRootFromParent_Done,
     /* 1186207 */   // Label 17276: @1186207
     /* 1186207 */   GIM_Try, /*On fail goto*//*Label 17277*/ GIMT_Encode4(1186290), // Rule ID 16589 //
     /* 1186212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1186223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1186226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186251 */     // MIs[0] round
     /* 1186251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186261 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1186264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186272 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186289 */     // GIR_Coverage, 16589,
     /* 1186289 */     GIR_EraseRootFromParent_Done,
     /* 1186290 */   // Label 17277: @1186290
     /* 1186290 */   GIM_Try, /*On fail goto*//*Label 17278*/ GIMT_Encode4(1186373), // Rule ID 16592 //
     /* 1186295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1186306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1186309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186334 */     // MIs[0] round
     /* 1186334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186372 */     // GIR_Coverage, 16592,
     /* 1186372 */     GIR_EraseRootFromParent_Done,
     /* 1186373 */   // Label 17278: @1186373
     /* 1186373 */   GIM_Try, /*On fail goto*//*Label 17279*/ GIMT_Encode4(1186456), // Rule ID 16593 //
     /* 1186378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1186389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1186392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186417 */     // MIs[0] round
     /* 1186417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186427 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1186430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186438 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186455 */     // GIR_Coverage, 16593,
     /* 1186455 */     GIR_EraseRootFromParent_Done,
     /* 1186456 */   // Label 17279: @1186456
     /* 1186456 */   GIM_Try, /*On fail goto*//*Label 17280*/ GIMT_Encode4(1186539), // Rule ID 16596 //
     /* 1186461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1186472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1186475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1186478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186500 */     // MIs[0] round
     /* 1186500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186510 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1186513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186538 */     // GIR_Coverage, 16596,
     /* 1186538 */     GIR_EraseRootFromParent_Done,
     /* 1186539 */   // Label 17280: @1186539
     /* 1186539 */   GIM_Try, /*On fail goto*//*Label 17281*/ GIMT_Encode4(1186622), // Rule ID 16597 //
     /* 1186544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1186555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1186558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1186561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1186575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1186579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186583 */     // MIs[0] round
     /* 1186583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186593 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1186596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186604 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1186614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186621 */     // GIR_Coverage, 16597,
     /* 1186621 */     GIR_EraseRootFromParent_Done,
     /* 1186622 */   // Label 17281: @1186622
     /* 1186622 */   GIM_Try, /*On fail goto*//*Label 17282*/ GIMT_Encode4(1186705), // Rule ID 16600 //
     /* 1186627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1186638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1186641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186666 */     // MIs[0] round
     /* 1186666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186676 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186704 */     // GIR_Coverage, 16600,
     /* 1186704 */     GIR_EraseRootFromParent_Done,
     /* 1186705 */   // Label 17282: @1186705
     /* 1186705 */   GIM_Try, /*On fail goto*//*Label 17283*/ GIMT_Encode4(1186788), // Rule ID 16601 //
     /* 1186710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1186721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1186724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186749 */     // MIs[0] round
     /* 1186749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186759 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1186762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186770 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186787 */     // GIR_Coverage, 16601,
     /* 1186787 */     GIR_EraseRootFromParent_Done,
     /* 1186788 */   // Label 17283: @1186788
     /* 1186788 */   GIM_Try, /*On fail goto*//*Label 17284*/ GIMT_Encode4(1186871), // Rule ID 16604 //
     /* 1186793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1186804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1186807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186832 */     // MIs[0] round
     /* 1186832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186842 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186870 */     // GIR_Coverage, 16604,
     /* 1186870 */     GIR_EraseRootFromParent_Done,
     /* 1186871 */   // Label 17284: @1186871
     /* 1186871 */   GIM_Try, /*On fail goto*//*Label 17285*/ GIMT_Encode4(1186954), // Rule ID 16605 //
     /* 1186876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1186879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1186887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1186890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186915 */     // MIs[0] round
     /* 1186915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186925 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1186928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186936 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186949 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1186952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186953 */     // GIR_Coverage, 16605,
     /* 1186953 */     GIR_EraseRootFromParent_Done,
     /* 1186954 */   // Label 17285: @1186954
     /* 1186954 */   GIM_Try, /*On fail goto*//*Label 17286*/ GIMT_Encode4(1187037), // Rule ID 16608 //
     /* 1186959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1186962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1186967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1186970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1186973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1186976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1186998 */     // MIs[0] round
     /* 1186998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187036 */     // GIR_Coverage, 16608,
     /* 1187036 */     GIR_EraseRootFromParent_Done,
     /* 1187037 */   // Label 17286: @1187037
     /* 1187037 */   GIM_Try, /*On fail goto*//*Label 17287*/ GIMT_Encode4(1187120), // Rule ID 16609 //
     /* 1187042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1187053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1187056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1187059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187081 */     // MIs[0] round
     /* 1187081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187091 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187102 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187119 */     // GIR_Coverage, 16609,
     /* 1187119 */     GIR_EraseRootFromParent_Done,
     /* 1187120 */   // Label 17287: @1187120
     /* 1187120 */   GIM_Try, /*On fail goto*//*Label 17288*/ GIMT_Encode4(1187203), // Rule ID 16612 //
     /* 1187125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1187136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1187139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187164 */     // MIs[0] round
     /* 1187164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187202 */     // GIR_Coverage, 16612,
     /* 1187202 */     GIR_EraseRootFromParent_Done,
     /* 1187203 */   // Label 17288: @1187203
     /* 1187203 */   GIM_Try, /*On fail goto*//*Label 17289*/ GIMT_Encode4(1187286), // Rule ID 16613 //
     /* 1187208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1187219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1187222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187247 */     // MIs[0] round
     /* 1187247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187268 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187285 */     // GIR_Coverage, 16613,
     /* 1187285 */     GIR_EraseRootFromParent_Done,
     /* 1187286 */   // Label 17289: @1187286
     /* 1187286 */   GIM_Try, /*On fail goto*//*Label 17290*/ GIMT_Encode4(1187369), // Rule ID 16616 //
     /* 1187291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1187294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187330 */     // MIs[0] round
     /* 1187330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187368 */     // GIR_Coverage, 16616,
     /* 1187368 */     GIR_EraseRootFromParent_Done,
     /* 1187369 */   // Label 17290: @1187369
     /* 1187369 */   GIM_Try, /*On fail goto*//*Label 17291*/ GIMT_Encode4(1187452), // Rule ID 16617 //
     /* 1187374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1187377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187413 */     // MIs[0] round
     /* 1187413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187423 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1187426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187434 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187451 */     // GIR_Coverage, 16617,
     /* 1187451 */     GIR_EraseRootFromParent_Done,
     /* 1187452 */   // Label 17291: @1187452
     /* 1187452 */   GIM_Try, /*On fail goto*//*Label 17292*/ GIMT_Encode4(1187535), // Rule ID 16620 //
     /* 1187457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1187468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1187471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1187474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187496 */     // MIs[0] round
     /* 1187496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187534 */     // GIR_Coverage, 16620,
     /* 1187534 */     GIR_EraseRootFromParent_Done,
     /* 1187535 */   // Label 17292: @1187535
     /* 1187535 */   GIM_Try, /*On fail goto*//*Label 17293*/ GIMT_Encode4(1187618), // Rule ID 16621 //
     /* 1187540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1187551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1187554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1187557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187579 */     // MIs[0] round
     /* 1187579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187589 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1187592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187600 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187617 */     // GIR_Coverage, 16621,
     /* 1187617 */     GIR_EraseRootFromParent_Done,
     /* 1187618 */   // Label 17293: @1187618
     /* 1187618 */   GIM_Try, /*On fail goto*//*Label 17294*/ GIMT_Encode4(1187701), // Rule ID 16624 //
     /* 1187623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1187634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1187637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1187640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187662 */     // MIs[0] round
     /* 1187662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187700 */     // GIR_Coverage, 16624,
     /* 1187700 */     GIR_EraseRootFromParent_Done,
     /* 1187701 */   // Label 17294: @1187701
     /* 1187701 */   GIM_Try, /*On fail goto*//*Label 17295*/ GIMT_Encode4(1187784), // Rule ID 16625 //
     /* 1187706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1187717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1187720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1187723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1187737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187745 */     // MIs[0] round
     /* 1187745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187755 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1187758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187766 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187783 */     // GIR_Coverage, 16625,
     /* 1187783 */     GIR_EraseRootFromParent_Done,
     /* 1187784 */   // Label 17295: @1187784
     /* 1187784 */   GIM_Try, /*On fail goto*//*Label 17296*/ GIMT_Encode4(1187867), // Rule ID 16628 //
     /* 1187789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1187800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1187803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1187806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187828 */     // MIs[0] round
     /* 1187828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187866 */     // GIR_Coverage, 16628,
     /* 1187866 */     GIR_EraseRootFromParent_Done,
     /* 1187867 */   // Label 17296: @1187867
     /* 1187867 */   GIM_Try, /*On fail goto*//*Label 17297*/ GIMT_Encode4(1187950), // Rule ID 16629 //
     /* 1187872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1187875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1187883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1187886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1187889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187911 */     // MIs[0] round
     /* 1187911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187921 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1187924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187932 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1187948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187949 */     // GIR_Coverage, 16629,
     /* 1187949 */     GIR_EraseRootFromParent_Done,
     /* 1187950 */   // Label 17297: @1187950
     /* 1187950 */   GIM_Try, /*On fail goto*//*Label 17298*/ GIMT_Encode4(1188033), // Rule ID 16632 //
     /* 1187955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1187958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1187963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1187966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1187969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1187972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1187994 */     // MIs[0] round
     /* 1187994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188004 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1188007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188032 */     // GIR_Coverage, 16632,
     /* 1188032 */     GIR_EraseRootFromParent_Done,
     /* 1188033 */   // Label 17298: @1188033
     /* 1188033 */   GIM_Try, /*On fail goto*//*Label 17299*/ GIMT_Encode4(1188116), // Rule ID 16633 //
     /* 1188038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1188041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1188046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1188049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1188052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1188055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1188058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1188077 */     // MIs[0] round
     /* 1188077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188087 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1188090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188098 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1188114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188115 */     // GIR_Coverage, 16633,
     /* 1188115 */     GIR_EraseRootFromParent_Done,
     /* 1188116 */   // Label 17299: @1188116
     /* 1188116 */   GIM_Try, /*On fail goto*//*Label 17300*/ GIMT_Encode4(1188196), // Rule ID 16696 //
     /* 1188121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188160 */     // MIs[0] round
     /* 1188160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188170 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1188173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188195 */     // GIR_Coverage, 16696,
     /* 1188195 */     GIR_EraseRootFromParent_Done,
     /* 1188196 */   // Label 17300: @1188196
     /* 1188196 */   GIM_Try, /*On fail goto*//*Label 17301*/ GIMT_Encode4(1188276), // Rule ID 16697 //
     /* 1188201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188240 */     // MIs[0] round
     /* 1188240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188250 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1188253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188275 */     // GIR_Coverage, 16697,
     /* 1188275 */     GIR_EraseRootFromParent_Done,
     /* 1188276 */   // Label 17301: @1188276
     /* 1188276 */   GIM_Try, /*On fail goto*//*Label 17302*/ GIMT_Encode4(1188356), // Rule ID 16700 //
     /* 1188281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188320 */     // MIs[0] round
     /* 1188320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188330 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188355 */     // GIR_Coverage, 16700,
     /* 1188355 */     GIR_EraseRootFromParent_Done,
     /* 1188356 */   // Label 17302: @1188356
     /* 1188356 */   GIM_Try, /*On fail goto*//*Label 17303*/ GIMT_Encode4(1188436), // Rule ID 16701 //
     /* 1188361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188400 */     // MIs[0] round
     /* 1188400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188410 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1188413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188435 */     // GIR_Coverage, 16701,
     /* 1188435 */     GIR_EraseRootFromParent_Done,
     /* 1188436 */   // Label 17303: @1188436
     /* 1188436 */   GIM_Try, /*On fail goto*//*Label 17304*/ GIMT_Encode4(1188516), // Rule ID 16704 //
     /* 1188441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188480 */     // MIs[0] round
     /* 1188480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188490 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1188493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188515 */     // GIR_Coverage, 16704,
     /* 1188515 */     GIR_EraseRootFromParent_Done,
     /* 1188516 */   // Label 17304: @1188516
     /* 1188516 */   GIM_Try, /*On fail goto*//*Label 17305*/ GIMT_Encode4(1188596), // Rule ID 16705 //
     /* 1188521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188560 */     // MIs[0] round
     /* 1188560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188570 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1188573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188595 */     // GIR_Coverage, 16705,
     /* 1188595 */     GIR_EraseRootFromParent_Done,
     /* 1188596 */   // Label 17305: @1188596
     /* 1188596 */   GIM_Try, /*On fail goto*//*Label 17306*/ GIMT_Encode4(1188676), // Rule ID 16708 //
     /* 1188601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1188618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188640 */     // MIs[0] round
     /* 1188640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188650 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1188653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188675 */     // GIR_Coverage, 16708,
     /* 1188675 */     GIR_EraseRootFromParent_Done,
     /* 1188676 */   // Label 17306: @1188676
     /* 1188676 */   GIM_Try, /*On fail goto*//*Label 17307*/ GIMT_Encode4(1188756), // Rule ID 16709 //
     /* 1188681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1188698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188720 */     // MIs[0] round
     /* 1188720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188730 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1188733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188755 */     // GIR_Coverage, 16709,
     /* 1188755 */     GIR_EraseRootFromParent_Done,
     /* 1188756 */   // Label 17307: @1188756
     /* 1188756 */   GIM_Try, /*On fail goto*//*Label 17308*/ GIMT_Encode4(1188836), // Rule ID 16712 //
     /* 1188761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1188781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188800 */     // MIs[0] round
     /* 1188800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188810 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1188813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188835 */     // GIR_Coverage, 16712,
     /* 1188835 */     GIR_EraseRootFromParent_Done,
     /* 1188836 */   // Label 17308: @1188836
     /* 1188836 */   GIM_Try, /*On fail goto*//*Label 17309*/ GIMT_Encode4(1188916), // Rule ID 16713 //
     /* 1188841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1188861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188880 */     // MIs[0] round
     /* 1188880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188890 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1188893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188915 */     // GIR_Coverage, 16713,
     /* 1188915 */     GIR_EraseRootFromParent_Done,
     /* 1188916 */   // Label 17309: @1188916
     /* 1188916 */   GIM_Try, /*On fail goto*//*Label 17310*/ GIMT_Encode4(1188996), // Rule ID 16716 //
     /* 1188921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1188924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1188932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1188935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1188938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1188941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188960 */     // MIs[0] round
     /* 1188960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188970 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1188973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188995 */     // GIR_Coverage, 16716,
     /* 1188995 */     GIR_EraseRootFromParent_Done,
     /* 1188996 */   // Label 17310: @1188996
     /* 1188996 */   GIM_Try, /*On fail goto*//*Label 17311*/ GIMT_Encode4(1189076), // Rule ID 16717 //
     /* 1189001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1189004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1189012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1189015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1189018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1189021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189040 */     // MIs[0] round
     /* 1189040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1189053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189075 */     // GIR_Coverage, 16717,
     /* 1189075 */     GIR_EraseRootFromParent_Done,
     /* 1189076 */   // Label 17311: @1189076
     /* 1189076 */   GIM_Try, /*On fail goto*//*Label 17312*/ GIMT_Encode4(1189156), // Rule ID 16720 //
     /* 1189081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189120 */     // MIs[0] round
     /* 1189120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189130 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1189133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189155 */     // GIR_Coverage, 16720,
     /* 1189155 */     GIR_EraseRootFromParent_Done,
     /* 1189156 */   // Label 17312: @1189156
     /* 1189156 */   GIM_Try, /*On fail goto*//*Label 17313*/ GIMT_Encode4(1189236), // Rule ID 16721 //
     /* 1189161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189200 */     // MIs[0] round
     /* 1189200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189210 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1189213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189235 */     // GIR_Coverage, 16721,
     /* 1189235 */     GIR_EraseRootFromParent_Done,
     /* 1189236 */   // Label 17313: @1189236
     /* 1189236 */   GIM_Try, /*On fail goto*//*Label 17314*/ GIMT_Encode4(1189316), // Rule ID 16724 //
     /* 1189241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189280 */     // MIs[0] round
     /* 1189280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189290 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1189293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189315 */     // GIR_Coverage, 16724,
     /* 1189315 */     GIR_EraseRootFromParent_Done,
     /* 1189316 */   // Label 17314: @1189316
     /* 1189316 */   GIM_Try, /*On fail goto*//*Label 17315*/ GIMT_Encode4(1189396), // Rule ID 16725 //
     /* 1189321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189360 */     // MIs[0] round
     /* 1189360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189370 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1189373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189395 */     // GIR_Coverage, 16725,
     /* 1189395 */     GIR_EraseRootFromParent_Done,
     /* 1189396 */   // Label 17315: @1189396
     /* 1189396 */   GIM_Try, /*On fail goto*//*Label 17316*/ GIMT_Encode4(1189476), // Rule ID 16728 //
     /* 1189401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189440 */     // MIs[0] round
     /* 1189440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189450 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1189453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189475 */     // GIR_Coverage, 16728,
     /* 1189475 */     GIR_EraseRootFromParent_Done,
     /* 1189476 */   // Label 17316: @1189476
     /* 1189476 */   GIM_Try, /*On fail goto*//*Label 17317*/ GIMT_Encode4(1189556), // Rule ID 16729 //
     /* 1189481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189520 */     // MIs[0] round
     /* 1189520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189530 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1189533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189555 */     // GIR_Coverage, 16729,
     /* 1189555 */     GIR_EraseRootFromParent_Done,
     /* 1189556 */   // Label 17317: @1189556
     /* 1189556 */   GIM_Try, /*On fail goto*//*Label 17318*/ GIMT_Encode4(1189636), // Rule ID 16732 //
     /* 1189561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1189578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189600 */     // MIs[0] round
     /* 1189600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189610 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1189613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189635 */     // GIR_Coverage, 16732,
     /* 1189635 */     GIR_EraseRootFromParent_Done,
     /* 1189636 */   // Label 17318: @1189636
     /* 1189636 */   GIM_Try, /*On fail goto*//*Label 17319*/ GIMT_Encode4(1189716), // Rule ID 16733 //
     /* 1189641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1189658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189680 */     // MIs[0] round
     /* 1189680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189690 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1189693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189715 */     // GIR_Coverage, 16733,
     /* 1189715 */     GIR_EraseRootFromParent_Done,
     /* 1189716 */   // Label 17319: @1189716
     /* 1189716 */   GIM_Try, /*On fail goto*//*Label 17320*/ GIMT_Encode4(1189796), // Rule ID 16736 //
     /* 1189721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1189738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189760 */     // MIs[0] round
     /* 1189760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189770 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1189773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189795 */     // GIR_Coverage, 16736,
     /* 1189795 */     GIR_EraseRootFromParent_Done,
     /* 1189796 */   // Label 17320: @1189796
     /* 1189796 */   GIM_Try, /*On fail goto*//*Label 17321*/ GIMT_Encode4(1189876), // Rule ID 16737 //
     /* 1189801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1189818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189840 */     // MIs[0] round
     /* 1189840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189850 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1189853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189875 */     // GIR_Coverage, 16737,
     /* 1189875 */     GIR_EraseRootFromParent_Done,
     /* 1189876 */   // Label 17321: @1189876
     /* 1189876 */   GIM_Try, /*On fail goto*//*Label 17322*/ GIMT_Encode4(1189956), // Rule ID 16740 //
     /* 1189881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1189892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1189895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1189898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1189901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189920 */     // MIs[0] round
     /* 1189920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189930 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1189933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189955 */     // GIR_Coverage, 16740,
     /* 1189955 */     GIR_EraseRootFromParent_Done,
     /* 1189956 */   // Label 17322: @1189956
     /* 1189956 */   GIM_Try, /*On fail goto*//*Label 17323*/ GIMT_Encode4(1190036), // Rule ID 16741 //
     /* 1189961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1189969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1189972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1189975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1189978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1189981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190000 */     // MIs[0] round
     /* 1190000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190010 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1190013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190035 */     // GIR_Coverage, 16741,
     /* 1190035 */     GIR_EraseRootFromParent_Done,
     /* 1190036 */   // Label 17323: @1190036
     /* 1190036 */   GIM_Try, /*On fail goto*//*Label 17324*/ GIMT_Encode4(1190116), // Rule ID 16744 //
     /* 1190041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190080 */     // MIs[0] round
     /* 1190080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1190093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190115 */     // GIR_Coverage, 16744,
     /* 1190115 */     GIR_EraseRootFromParent_Done,
     /* 1190116 */   // Label 17324: @1190116
     /* 1190116 */   GIM_Try, /*On fail goto*//*Label 17325*/ GIMT_Encode4(1190196), // Rule ID 16745 //
     /* 1190121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190160 */     // MIs[0] round
     /* 1190160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190170 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1190173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190195 */     // GIR_Coverage, 16745,
     /* 1190195 */     GIR_EraseRootFromParent_Done,
     /* 1190196 */   // Label 17325: @1190196
     /* 1190196 */   GIM_Try, /*On fail goto*//*Label 17326*/ GIMT_Encode4(1190276), // Rule ID 16748 //
     /* 1190201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190240 */     // MIs[0] round
     /* 1190240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190250 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1190253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190275 */     // GIR_Coverage, 16748,
     /* 1190275 */     GIR_EraseRootFromParent_Done,
     /* 1190276 */   // Label 17326: @1190276
     /* 1190276 */   GIM_Try, /*On fail goto*//*Label 17327*/ GIMT_Encode4(1190356), // Rule ID 16749 //
     /* 1190281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190320 */     // MIs[0] round
     /* 1190320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190330 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1190333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190355 */     // GIR_Coverage, 16749,
     /* 1190355 */     GIR_EraseRootFromParent_Done,
     /* 1190356 */   // Label 17327: @1190356
     /* 1190356 */   GIM_Try, /*On fail goto*//*Label 17328*/ GIMT_Encode4(1190436), // Rule ID 16752 //
     /* 1190361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190400 */     // MIs[0] round
     /* 1190400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190410 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190435 */     // GIR_Coverage, 16752,
     /* 1190435 */     GIR_EraseRootFromParent_Done,
     /* 1190436 */   // Label 17328: @1190436
     /* 1190436 */   GIM_Try, /*On fail goto*//*Label 17329*/ GIMT_Encode4(1190516), // Rule ID 16753 //
     /* 1190441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190480 */     // MIs[0] round
     /* 1190480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190490 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1190493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190515 */     // GIR_Coverage, 16753,
     /* 1190515 */     GIR_EraseRootFromParent_Done,
     /* 1190516 */   // Label 17329: @1190516
     /* 1190516 */   GIM_Try, /*On fail goto*//*Label 17330*/ GIMT_Encode4(1190596), // Rule ID 16756 //
     /* 1190521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1190538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190560 */     // MIs[0] round
     /* 1190560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190570 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1190573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190595 */     // GIR_Coverage, 16756,
     /* 1190595 */     GIR_EraseRootFromParent_Done,
     /* 1190596 */   // Label 17330: @1190596
     /* 1190596 */   GIM_Try, /*On fail goto*//*Label 17331*/ GIMT_Encode4(1190676), // Rule ID 16757 //
     /* 1190601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1190604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1190618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190640 */     // MIs[0] round
     /* 1190640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190650 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1190653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190675 */     // GIR_Coverage, 16757,
     /* 1190675 */     GIR_EraseRootFromParent_Done,
     /* 1190676 */   // Label 17331: @1190676
     /* 1190676 */   GIM_Try, /*On fail goto*//*Label 17332*/ GIMT_Encode4(1190756), // Rule ID 16760 //
     /* 1190681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1190698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190720 */     // MIs[0] round
     /* 1190720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190730 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1190733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190755 */     // GIR_Coverage, 16760,
     /* 1190755 */     GIR_EraseRootFromParent_Done,
     /* 1190756 */   // Label 17332: @1190756
     /* 1190756 */   GIM_Try, /*On fail goto*//*Label 17333*/ GIMT_Encode4(1190836), // Rule ID 16761 //
     /* 1190761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1190764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1190778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190800 */     // MIs[0] round
     /* 1190800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190810 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1190813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190835 */     // GIR_Coverage, 16761,
     /* 1190835 */     GIR_EraseRootFromParent_Done,
     /* 1190836 */   // Label 17333: @1190836
     /* 1190836 */   GIM_Try, /*On fail goto*//*Label 17334*/ GIMT_Encode4(1190916), // Rule ID 16764 //
     /* 1190841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1190852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1190855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1190880 */     // MIs[0] round
     /* 1190880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190890 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1190893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190915 */     // GIR_Coverage, 16764,
     /* 1190915 */     GIR_EraseRootFromParent_Done,
     /* 1190916 */   // Label 17334: @1190916
     /* 1190916 */   GIM_Try, /*On fail goto*//*Label 17335*/ GIMT_Encode4(1190996), // Rule ID 16765 //
     /* 1190921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1190929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1190932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1190935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1190960 */     // MIs[0] round
     /* 1190960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190970 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1190973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190995 */     // GIR_Coverage, 16765,
     /* 1190995 */     GIR_EraseRootFromParent_Done,
     /* 1190996 */   // Label 17335: @1190996
     /* 1190996 */   GIM_Try, /*On fail goto*//*Label 17336*/ GIMT_Encode4(1191076), // Rule ID 16768 //
     /* 1191001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191040 */     // MIs[0] round
     /* 1191040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191050 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1191053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191075 */     // GIR_Coverage, 16768,
     /* 1191075 */     GIR_EraseRootFromParent_Done,
     /* 1191076 */   // Label 17336: @1191076
     /* 1191076 */   GIM_Try, /*On fail goto*//*Label 17337*/ GIMT_Encode4(1191156), // Rule ID 16769 //
     /* 1191081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191120 */     // MIs[0] round
     /* 1191120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191130 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1191133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191155 */     // GIR_Coverage, 16769,
     /* 1191155 */     GIR_EraseRootFromParent_Done,
     /* 1191156 */   // Label 17337: @1191156
     /* 1191156 */   GIM_Try, /*On fail goto*//*Label 17338*/ GIMT_Encode4(1191236), // Rule ID 16772 //
     /* 1191161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191200 */     // MIs[0] round
     /* 1191200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191210 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1191213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191235 */     // GIR_Coverage, 16772,
     /* 1191235 */     GIR_EraseRootFromParent_Done,
     /* 1191236 */   // Label 17338: @1191236
     /* 1191236 */   GIM_Try, /*On fail goto*//*Label 17339*/ GIMT_Encode4(1191316), // Rule ID 16773 //
     /* 1191241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191280 */     // MIs[0] round
     /* 1191280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191290 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1191293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191315 */     // GIR_Coverage, 16773,
     /* 1191315 */     GIR_EraseRootFromParent_Done,
     /* 1191316 */   // Label 17339: @1191316
     /* 1191316 */   GIM_Try, /*On fail goto*//*Label 17340*/ GIMT_Encode4(1191396), // Rule ID 16776 //
     /* 1191321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1191324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191360 */     // MIs[0] round
     /* 1191360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191370 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191395 */     // GIR_Coverage, 16776,
     /* 1191395 */     GIR_EraseRootFromParent_Done,
     /* 1191396 */   // Label 17340: @1191396
     /* 1191396 */   GIM_Try, /*On fail goto*//*Label 17341*/ GIMT_Encode4(1191476), // Rule ID 16777 //
     /* 1191401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1191404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191440 */     // MIs[0] round
     /* 1191440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191450 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1191453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191475 */     // GIR_Coverage, 16777,
     /* 1191475 */     GIR_EraseRootFromParent_Done,
     /* 1191476 */   // Label 17341: @1191476
     /* 1191476 */   GIM_Try, /*On fail goto*//*Label 17342*/ GIMT_Encode4(1191556), // Rule ID 16780 //
     /* 1191481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191520 */     // MIs[0] round
     /* 1191520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191530 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1191533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191555 */     // GIR_Coverage, 16780,
     /* 1191555 */     GIR_EraseRootFromParent_Done,
     /* 1191556 */   // Label 17342: @1191556
     /* 1191556 */   GIM_Try, /*On fail goto*//*Label 17343*/ GIMT_Encode4(1191636), // Rule ID 16781 //
     /* 1191561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191600 */     // MIs[0] round
     /* 1191600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191610 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1191613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191635 */     // GIR_Coverage, 16781,
     /* 1191635 */     GIR_EraseRootFromParent_Done,
     /* 1191636 */   // Label 17343: @1191636
     /* 1191636 */   GIM_Try, /*On fail goto*//*Label 17344*/ GIMT_Encode4(1191716), // Rule ID 16784 //
     /* 1191641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191680 */     // MIs[0] round
     /* 1191680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191690 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1191693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191715 */     // GIR_Coverage, 16784,
     /* 1191715 */     GIR_EraseRootFromParent_Done,
     /* 1191716 */   // Label 17344: @1191716
     /* 1191716 */   GIM_Try, /*On fail goto*//*Label 17345*/ GIMT_Encode4(1191796), // Rule ID 16785 //
     /* 1191721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191760 */     // MIs[0] round
     /* 1191760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191770 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1191773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191795 */     // GIR_Coverage, 16785,
     /* 1191795 */     GIR_EraseRootFromParent_Done,
     /* 1191796 */   // Label 17345: @1191796
     /* 1191796 */   GIM_Try, /*On fail goto*//*Label 17346*/ GIMT_Encode4(1191876), // Rule ID 16788 //
     /* 1191801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1191812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1191815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1191818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191840 */     // MIs[0] round
     /* 1191840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191850 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1191853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191875 */     // GIR_Coverage, 16788,
     /* 1191875 */     GIR_EraseRootFromParent_Done,
     /* 1191876 */   // Label 17346: @1191876
     /* 1191876 */   GIM_Try, /*On fail goto*//*Label 17347*/ GIMT_Encode4(1191956), // Rule ID 16789 //
     /* 1191881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1191892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1191895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1191898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191920 */     // MIs[0] round
     /* 1191920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191930 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1191933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191955 */     // GIR_Coverage, 16789,
     /* 1191955 */     GIR_EraseRootFromParent_Done,
     /* 1191956 */   // Label 17347: @1191956
     /* 1191956 */   GIM_Try, /*On fail goto*//*Label 17348*/ GIMT_Encode4(1192036), // Rule ID 16792 //
     /* 1191961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1191969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1191972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1191975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1191978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192000 */     // MIs[0] round
     /* 1192000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192010 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1192013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192035 */     // GIR_Coverage, 16792,
     /* 1192035 */     GIR_EraseRootFromParent_Done,
     /* 1192036 */   // Label 17348: @1192036
     /* 1192036 */   GIM_Try, /*On fail goto*//*Label 17349*/ GIMT_Encode4(1192116), // Rule ID 16793 //
     /* 1192041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1192052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1192055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1192058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192080 */     // MIs[0] round
     /* 1192080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1192093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192115 */     // GIR_Coverage, 16793,
     /* 1192115 */     GIR_EraseRootFromParent_Done,
     /* 1192116 */   // Label 17349: @1192116
     /* 1192116 */   GIM_Try, /*On fail goto*//*Label 17350*/ GIMT_Encode4(1192196), // Rule ID 16796 //
     /* 1192121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192160 */     // MIs[0] round
     /* 1192160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192170 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1192173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192195 */     // GIR_Coverage, 16796,
     /* 1192195 */     GIR_EraseRootFromParent_Done,
     /* 1192196 */   // Label 17350: @1192196
     /* 1192196 */   GIM_Try, /*On fail goto*//*Label 17351*/ GIMT_Encode4(1192276), // Rule ID 16797 //
     /* 1192201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192240 */     // MIs[0] round
     /* 1192240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192250 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1192253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192275 */     // GIR_Coverage, 16797,
     /* 1192275 */     GIR_EraseRootFromParent_Done,
     /* 1192276 */   // Label 17351: @1192276
     /* 1192276 */   GIM_Try, /*On fail goto*//*Label 17352*/ GIMT_Encode4(1192356), // Rule ID 16800 //
     /* 1192281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192320 */     // MIs[0] round
     /* 1192320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192330 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192355 */     // GIR_Coverage, 16800,
     /* 1192355 */     GIR_EraseRootFromParent_Done,
     /* 1192356 */   // Label 17352: @1192356
     /* 1192356 */   GIM_Try, /*On fail goto*//*Label 17353*/ GIMT_Encode4(1192436), // Rule ID 16801 //
     /* 1192361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192400 */     // MIs[0] round
     /* 1192400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192410 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1192413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192435 */     // GIR_Coverage, 16801,
     /* 1192435 */     GIR_EraseRootFromParent_Done,
     /* 1192436 */   // Label 17353: @1192436
     /* 1192436 */   GIM_Try, /*On fail goto*//*Label 17354*/ GIMT_Encode4(1192516), // Rule ID 16804 //
     /* 1192441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192480 */     // MIs[0] round
     /* 1192480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192490 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1192493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192515 */     // GIR_Coverage, 16804,
     /* 1192515 */     GIR_EraseRootFromParent_Done,
     /* 1192516 */   // Label 17354: @1192516
     /* 1192516 */   GIM_Try, /*On fail goto*//*Label 17355*/ GIMT_Encode4(1192596), // Rule ID 16805 //
     /* 1192521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192560 */     // MIs[0] round
     /* 1192560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192570 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11185:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1192573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192595 */     // GIR_Coverage, 16805,
     /* 1192595 */     GIR_EraseRootFromParent_Done,
     /* 1192596 */   // Label 17355: @1192596
     /* 1192596 */   GIM_Try, /*On fail goto*//*Label 17356*/ GIMT_Encode4(1192676), // Rule ID 16808 //
     /* 1192601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1192612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1192615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192640 */     // MIs[0] round
     /* 1192640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192650 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1192653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192675 */     // GIR_Coverage, 16808,
     /* 1192675 */     GIR_EraseRootFromParent_Done,
     /* 1192676 */   // Label 17356: @1192676
     /* 1192676 */   GIM_Try, /*On fail goto*//*Label 17357*/ GIMT_Encode4(1192756), // Rule ID 16809 //
     /* 1192681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1192692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1192695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192720 */     // MIs[0] round
     /* 1192720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192730 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11185:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1192733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192755 */     // GIR_Coverage, 16809,
     /* 1192755 */     GIR_EraseRootFromParent_Done,
     /* 1192756 */   // Label 17357: @1192756
     /* 1192756 */   GIM_Try, /*On fail goto*//*Label 17358*/ GIMT_Encode4(1192836), // Rule ID 16812 //
     /* 1192761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1192772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1192775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192800 */     // MIs[0] round
     /* 1192800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192810 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1192813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192835 */     // GIR_Coverage, 16812,
     /* 1192835 */     GIR_EraseRootFromParent_Done,
     /* 1192836 */   // Label 17358: @1192836
     /* 1192836 */   GIM_Try, /*On fail goto*//*Label 17359*/ GIMT_Encode4(1192916), // Rule ID 16813 //
     /* 1192841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1192849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1192852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1192855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192880 */     // MIs[0] round
     /* 1192880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192890 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11185:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1192893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192915 */     // GIR_Coverage, 16813,
     /* 1192915 */     GIR_EraseRootFromParent_Done,
     /* 1192916 */   // Label 17359: @1192916
     /* 1192916 */   GIM_Try, /*On fail goto*//*Label 17360*/ GIMT_Encode4(1192996), // Rule ID 16816 //
     /* 1192921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1192924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1192932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1192935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1192938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1192941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1192960 */     // MIs[0] round
     /* 1192960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192970 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1192973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192995 */     // GIR_Coverage, 16816,
     /* 1192995 */     GIR_EraseRootFromParent_Done,
     /* 1192996 */   // Label 17360: @1192996
     /* 1192996 */   GIM_Try, /*On fail goto*//*Label 17361*/ GIMT_Encode4(1193076), // Rule ID 16817 //
     /* 1193001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1193012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1193015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1193021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193040 */     // MIs[0] round
     /* 1193040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193050 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1193053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193075 */     // GIR_Coverage, 16817,
     /* 1193075 */     GIR_EraseRootFromParent_Done,
     /* 1193076 */   // Label 17361: @1193076
     /* 1193076 */   GIM_Try, /*On fail goto*//*Label 17362*/ GIMT_Encode4(1193156), // Rule ID 16820 //
     /* 1193081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1193101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193120 */     // MIs[0] round
     /* 1193120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193130 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1193133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193155 */     // GIR_Coverage, 16820,
     /* 1193155 */     GIR_EraseRootFromParent_Done,
     /* 1193156 */   // Label 17362: @1193156
     /* 1193156 */   GIM_Try, /*On fail goto*//*Label 17363*/ GIMT_Encode4(1193236), // Rule ID 16821 //
     /* 1193161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1193181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193200 */     // MIs[0] round
     /* 1193200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193210 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1193213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193235 */     // GIR_Coverage, 16821,
     /* 1193235 */     GIR_EraseRootFromParent_Done,
     /* 1193236 */   // Label 17363: @1193236
     /* 1193236 */   GIM_Try, /*On fail goto*//*Label 17364*/ GIMT_Encode4(1193316), // Rule ID 16824 //
     /* 1193241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1193261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193280 */     // MIs[0] round
     /* 1193280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1193293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193315 */     // GIR_Coverage, 16824,
     /* 1193315 */     GIR_EraseRootFromParent_Done,
     /* 1193316 */   // Label 17364: @1193316
     /* 1193316 */   GIM_Try, /*On fail goto*//*Label 17365*/ GIMT_Encode4(1193396), // Rule ID 16825 //
     /* 1193321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1193341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193360 */     // MIs[0] round
     /* 1193360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1193373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193395 */     // GIR_Coverage, 16825,
     /* 1193395 */     GIR_EraseRootFromParent_Done,
     /* 1193396 */   // Label 17365: @1193396
     /* 1193396 */   GIM_Try, /*On fail goto*//*Label 17366*/ GIMT_Encode4(1193476), // Rule ID 16828 //
     /* 1193401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193440 */     // MIs[0] round
     /* 1193440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193450 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1193453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193475 */     // GIR_Coverage, 16828,
     /* 1193475 */     GIR_EraseRootFromParent_Done,
     /* 1193476 */   // Label 17366: @1193476
     /* 1193476 */   GIM_Try, /*On fail goto*//*Label 17367*/ GIMT_Encode4(1193556), // Rule ID 16829 //
     /* 1193481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1193501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193520 */     // MIs[0] round
     /* 1193520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193530 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1193533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193555 */     // GIR_Coverage, 16829,
     /* 1193555 */     GIR_EraseRootFromParent_Done,
     /* 1193556 */   // Label 17367: @1193556
     /* 1193556 */   GIM_Try, /*On fail goto*//*Label 17368*/ GIMT_Encode4(1193636), // Rule ID 16832 //
     /* 1193561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1193572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1193575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1193578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1193581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193600 */     // MIs[0] round
     /* 1193600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193610 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1193613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193635 */     // GIR_Coverage, 16832,
     /* 1193635 */     GIR_EraseRootFromParent_Done,
     /* 1193636 */   // Label 17368: @1193636
     /* 1193636 */   GIM_Try, /*On fail goto*//*Label 17369*/ GIMT_Encode4(1193716), // Rule ID 16833 //
     /* 1193641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1193652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1193655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1193658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1193661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193680 */     // MIs[0] round
     /* 1193680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193690 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1193693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193715 */     // GIR_Coverage, 16833,
     /* 1193715 */     GIR_EraseRootFromParent_Done,
     /* 1193716 */   // Label 17369: @1193716
     /* 1193716 */   GIM_Try, /*On fail goto*//*Label 17370*/ GIMT_Encode4(1193796), // Rule ID 16836 //
     /* 1193721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1193724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1193732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1193735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1193738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1193741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193760 */     // MIs[0] round
     /* 1193760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193770 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1193773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193795 */     // GIR_Coverage, 16836,
     /* 1193795 */     GIR_EraseRootFromParent_Done,
     /* 1193796 */   // Label 17370: @1193796
     /* 1193796 */   GIM_Try, /*On fail goto*//*Label 17371*/ GIMT_Encode4(1193876), // Rule ID 16837 //
     /* 1193801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1193804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1193812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1193815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1193818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1193821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193840 */     // MIs[0] round
     /* 1193840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193850 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1193853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193875 */     // GIR_Coverage, 16837,
     /* 1193875 */     GIR_EraseRootFromParent_Done,
     /* 1193876 */   // Label 17371: @1193876
     /* 1193876 */   GIM_Try, /*On fail goto*//*Label 17372*/ GIMT_Encode4(1193956), // Rule ID 16840 //
     /* 1193881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1193892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1193895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1193898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1193901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193920 */     // MIs[0] round
     /* 1193920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193930 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1193933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193955 */     // GIR_Coverage, 16840,
     /* 1193955 */     GIR_EraseRootFromParent_Done,
     /* 1193956 */   // Label 17372: @1193956
     /* 1193956 */   GIM_Try, /*On fail goto*//*Label 17373*/ GIMT_Encode4(1194036), // Rule ID 16841 //
     /* 1193961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1193969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1193972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1193975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1193978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1193981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1193996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194000 */     // MIs[0] round
     /* 1194000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194010 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1194013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194035 */     // GIR_Coverage, 16841,
     /* 1194035 */     GIR_EraseRootFromParent_Done,
     /* 1194036 */   // Label 17373: @1194036
     /* 1194036 */   GIM_Try, /*On fail goto*//*Label 17374*/ GIMT_Encode4(1194116), // Rule ID 16844 //
     /* 1194041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1194061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194080 */     // MIs[0] round
     /* 1194080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194090 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1194093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194115 */     // GIR_Coverage, 16844,
     /* 1194115 */     GIR_EraseRootFromParent_Done,
     /* 1194116 */   // Label 17374: @1194116
     /* 1194116 */   GIM_Try, /*On fail goto*//*Label 17375*/ GIMT_Encode4(1194196), // Rule ID 16845 //
     /* 1194121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1194141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194160 */     // MIs[0] round
     /* 1194160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194170 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1194173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194195 */     // GIR_Coverage, 16845,
     /* 1194195 */     GIR_EraseRootFromParent_Done,
     /* 1194196 */   // Label 17375: @1194196
     /* 1194196 */   GIM_Try, /*On fail goto*//*Label 17376*/ GIMT_Encode4(1194276), // Rule ID 16848 //
     /* 1194201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1194221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194240 */     // MIs[0] round
     /* 1194240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194250 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1194253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194275 */     // GIR_Coverage, 16848,
     /* 1194275 */     GIR_EraseRootFromParent_Done,
     /* 1194276 */   // Label 17376: @1194276
     /* 1194276 */   GIM_Try, /*On fail goto*//*Label 17377*/ GIMT_Encode4(1194356), // Rule ID 16849 //
     /* 1194281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1194301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194320 */     // MIs[0] round
     /* 1194320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194330 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1194333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194355 */     // GIR_Coverage, 16849,
     /* 1194355 */     GIR_EraseRootFromParent_Done,
     /* 1194356 */   // Label 17377: @1194356
     /* 1194356 */   GIM_Try, /*On fail goto*//*Label 17378*/ GIMT_Encode4(1194436), // Rule ID 16852 //
     /* 1194361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194400 */     // MIs[0] round
     /* 1194400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194410 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194435 */     // GIR_Coverage, 16852,
     /* 1194435 */     GIR_EraseRootFromParent_Done,
     /* 1194436 */   // Label 17378: @1194436
     /* 1194436 */   GIM_Try, /*On fail goto*//*Label 17379*/ GIMT_Encode4(1194516), // Rule ID 16853 //
     /* 1194441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1194461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194480 */     // MIs[0] round
     /* 1194480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194490 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1194493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194515 */     // GIR_Coverage, 16853,
     /* 1194515 */     GIR_EraseRootFromParent_Done,
     /* 1194516 */   // Label 17379: @1194516
     /* 1194516 */   GIM_Try, /*On fail goto*//*Label 17380*/ GIMT_Encode4(1194596), // Rule ID 16856 //
     /* 1194521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1194532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1194535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1194538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1194541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194560 */     // MIs[0] round
     /* 1194560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194570 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1194573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194595 */     // GIR_Coverage, 16856,
     /* 1194595 */     GIR_EraseRootFromParent_Done,
     /* 1194596 */   // Label 17380: @1194596
     /* 1194596 */   GIM_Try, /*On fail goto*//*Label 17381*/ GIMT_Encode4(1194676), // Rule ID 16857 //
     /* 1194601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1194612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1194615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1194618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1194621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194640 */     // MIs[0] round
     /* 1194640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194650 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1194653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194675 */     // GIR_Coverage, 16857,
     /* 1194675 */     GIR_EraseRootFromParent_Done,
     /* 1194676 */   // Label 17381: @1194676
     /* 1194676 */   GIM_Try, /*On fail goto*//*Label 17382*/ GIMT_Encode4(1194756), // Rule ID 16860 //
     /* 1194681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1194692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1194695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1194698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1194701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194720 */     // MIs[0] round
     /* 1194720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194730 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1194733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194755 */     // GIR_Coverage, 16860,
     /* 1194755 */     GIR_EraseRootFromParent_Done,
     /* 1194756 */   // Label 17382: @1194756
     /* 1194756 */   GIM_Try, /*On fail goto*//*Label 17383*/ GIMT_Encode4(1194836), // Rule ID 16861 //
     /* 1194761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1194772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1194775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1194778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1194781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194800 */     // MIs[0] round
     /* 1194800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194810 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1194813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194835 */     // GIR_Coverage, 16861,
     /* 1194835 */     GIR_EraseRootFromParent_Done,
     /* 1194836 */   // Label 17383: @1194836
     /* 1194836 */   GIM_Try, /*On fail goto*//*Label 17384*/ GIMT_Encode4(1194916), // Rule ID 16864 //
     /* 1194841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1194852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1194855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1194858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1194861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194880 */     // MIs[0] round
     /* 1194880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194890 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1194893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194915 */     // GIR_Coverage, 16864,
     /* 1194915 */     GIR_EraseRootFromParent_Done,
     /* 1194916 */   // Label 17384: @1194916
     /* 1194916 */   GIM_Try, /*On fail goto*//*Label 17385*/ GIMT_Encode4(1194996), // Rule ID 16865 //
     /* 1194921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1194924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1194929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1194932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1194935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1194938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1194941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194960 */     // MIs[0] round
     /* 1194960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194970 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1194973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194995 */     // GIR_Coverage, 16865,
     /* 1194995 */     GIR_EraseRootFromParent_Done,
     /* 1194996 */   // Label 17385: @1194996
     /* 1194996 */   GIM_Try, /*On fail goto*//*Label 17386*/ GIMT_Encode4(1195076), // Rule ID 16868 //
     /* 1195001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1195021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195040 */     // MIs[0] round
     /* 1195040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195050 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1195053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195075 */     // GIR_Coverage, 16868,
     /* 1195075 */     GIR_EraseRootFromParent_Done,
     /* 1195076 */   // Label 17386: @1195076
     /* 1195076 */   GIM_Try, /*On fail goto*//*Label 17387*/ GIMT_Encode4(1195156), // Rule ID 16869 //
     /* 1195081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1195101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195120 */     // MIs[0] round
     /* 1195120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195130 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1195133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195155 */     // GIR_Coverage, 16869,
     /* 1195155 */     GIR_EraseRootFromParent_Done,
     /* 1195156 */   // Label 17387: @1195156
     /* 1195156 */   GIM_Try, /*On fail goto*//*Label 17388*/ GIMT_Encode4(1195236), // Rule ID 16872 //
     /* 1195161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1195181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195200 */     // MIs[0] round
     /* 1195200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195210 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1195213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195235 */     // GIR_Coverage, 16872,
     /* 1195235 */     GIR_EraseRootFromParent_Done,
     /* 1195236 */   // Label 17388: @1195236
     /* 1195236 */   GIM_Try, /*On fail goto*//*Label 17389*/ GIMT_Encode4(1195316), // Rule ID 16873 //
     /* 1195241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1195261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195280 */     // MIs[0] round
     /* 1195280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195290 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1195293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195315 */     // GIR_Coverage, 16873,
     /* 1195315 */     GIR_EraseRootFromParent_Done,
     /* 1195316 */   // Label 17389: @1195316
     /* 1195316 */   GIM_Try, /*On fail goto*//*Label 17390*/ GIMT_Encode4(1195396), // Rule ID 16876 //
     /* 1195321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195360 */     // MIs[0] round
     /* 1195360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195370 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195395 */     // GIR_Coverage, 16876,
     /* 1195395 */     GIR_EraseRootFromParent_Done,
     /* 1195396 */   // Label 17390: @1195396
     /* 1195396 */   GIM_Try, /*On fail goto*//*Label 17391*/ GIMT_Encode4(1195476), // Rule ID 16877 //
     /* 1195401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1195412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1195415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195440 */     // MIs[0] round
     /* 1195440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195450 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1195453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195475 */     // GIR_Coverage, 16877,
     /* 1195475 */     GIR_EraseRootFromParent_Done,
     /* 1195476 */   // Label 17391: @1195476
     /* 1195476 */   GIM_Try, /*On fail goto*//*Label 17392*/ GIMT_Encode4(1195556), // Rule ID 16880 //
     /* 1195481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1195492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1195495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195520 */     // MIs[0] round
     /* 1195520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195530 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1195533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195555 */     // GIR_Coverage, 16880,
     /* 1195555 */     GIR_EraseRootFromParent_Done,
     /* 1195556 */   // Label 17392: @1195556
     /* 1195556 */   GIM_Try, /*On fail goto*//*Label 17393*/ GIMT_Encode4(1195636), // Rule ID 16881 //
     /* 1195561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1195572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1195575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195600 */     // MIs[0] round
     /* 1195600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195610 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1195613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195635 */     // GIR_Coverage, 16881,
     /* 1195635 */     GIR_EraseRootFromParent_Done,
     /* 1195636 */   // Label 17393: @1195636
     /* 1195636 */   GIM_Try, /*On fail goto*//*Label 17394*/ GIMT_Encode4(1195716), // Rule ID 16884 //
     /* 1195641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1195652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1195655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1195658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195680 */     // MIs[0] round
     /* 1195680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195690 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1195693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195715 */     // GIR_Coverage, 16884,
     /* 1195715 */     GIR_EraseRootFromParent_Done,
     /* 1195716 */   // Label 17394: @1195716
     /* 1195716 */   GIM_Try, /*On fail goto*//*Label 17395*/ GIMT_Encode4(1195796), // Rule ID 16885 //
     /* 1195721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1195724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1195732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1195735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1195738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1195760 */     // MIs[0] round
     /* 1195760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195770 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1195773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1195791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195795 */     // GIR_Coverage, 16885,
     /* 1195795 */     GIR_EraseRootFromParent_Done,
     /* 1195796 */   // Label 17395: @1195796
     /* 1195796 */   GIM_Try, /*On fail goto*//*Label 17396*/ GIMT_Encode4(1195876), // Rule ID 16888 //
     /* 1195801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1195804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1195812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1195815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1195818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195840 */     // MIs[0] round
     /* 1195840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195850 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1195853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195875 */     // GIR_Coverage, 16888,
     /* 1195875 */     GIR_EraseRootFromParent_Done,
     /* 1195876 */   // Label 17396: @1195876
     /* 1195876 */   GIM_Try, /*On fail goto*//*Label 17397*/ GIMT_Encode4(1195956), // Rule ID 16889 //
     /* 1195881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1195884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1195892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1195895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1195898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1195901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1195920 */     // MIs[0] round
     /* 1195920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195930 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11277:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1195933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195955 */     // GIR_Coverage, 16889,
     /* 1195955 */     GIR_EraseRootFromParent_Done,
     /* 1195956 */   // Label 17397: @1195956
     /* 1195956 */   GIM_Try, /*On fail goto*//*Label 17398*/ GIMT_Encode4(1196036), // Rule ID 16892 //
     /* 1195961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1195964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1195969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1195972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1195975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1195978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1195981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196000 */     // MIs[0] round
     /* 1196000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196010 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1196013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196035 */     // GIR_Coverage, 16892,
     /* 1196035 */     GIR_EraseRootFromParent_Done,
     /* 1196036 */   // Label 17398: @1196036
     /* 1196036 */   GIM_Try, /*On fail goto*//*Label 17399*/ GIMT_Encode4(1196116), // Rule ID 16893 //
     /* 1196041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1196052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1196055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1196058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196080 */     // MIs[0] round
     /* 1196080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11277:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1196093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196115 */     // GIR_Coverage, 16893,
     /* 1196115 */     GIR_EraseRootFromParent_Done,
     /* 1196116 */   // Label 17399: @1196116
     /* 1196116 */   GIM_Try, /*On fail goto*//*Label 17400*/ GIMT_Encode4(1196196), // Rule ID 16896 //
     /* 1196121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1196124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1196138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196160 */     // MIs[0] round
     /* 1196160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196170 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1196173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196195 */     // GIR_Coverage, 16896,
     /* 1196195 */     GIR_EraseRootFromParent_Done,
     /* 1196196 */   // Label 17400: @1196196
     /* 1196196 */   GIM_Try, /*On fail goto*//*Label 17401*/ GIMT_Encode4(1196276), // Rule ID 16897 //
     /* 1196201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1196204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1196218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1196221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1196240 */     // MIs[0] round
     /* 1196240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196250 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11277:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1196253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1196271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196275 */     // GIR_Coverage, 16897,
     /* 1196275 */     GIR_EraseRootFromParent_Done,
     /* 1196276 */   // Label 17401: @1196276
     /* 1196276 */   GIM_Try, /*On fail goto*//*Label 17402*/ GIMT_Encode4(1196356), // Rule ID 16900 //
     /* 1196281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1196292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1196295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196320 */     // MIs[0] round
     /* 1196320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196330 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196355 */     // GIR_Coverage, 16900,
     /* 1196355 */     GIR_EraseRootFromParent_Done,
     /* 1196356 */   // Label 17402: @1196356
     /* 1196356 */   GIM_Try, /*On fail goto*//*Label 17403*/ GIMT_Encode4(1196436), // Rule ID 16901 //
     /* 1196361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1196372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1196375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196400 */     // MIs[0] round
     /* 1196400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196410 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1196413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196435 */     // GIR_Coverage, 16901,
     /* 1196435 */     GIR_EraseRootFromParent_Done,
     /* 1196436 */   // Label 17403: @1196436
     /* 1196436 */   GIM_Try, /*On fail goto*//*Label 17404*/ GIMT_Encode4(1196516), // Rule ID 16904 //
     /* 1196441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1196452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1196455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196480 */     // MIs[0] round
     /* 1196480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196490 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1196493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196515 */     // GIR_Coverage, 16904,
     /* 1196515 */     GIR_EraseRootFromParent_Done,
     /* 1196516 */   // Label 17404: @1196516
     /* 1196516 */   GIM_Try, /*On fail goto*//*Label 17405*/ GIMT_Encode4(1196596), // Rule ID 16905 //
     /* 1196521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1196532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1196535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196560 */     // MIs[0] round
     /* 1196560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196570 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1196573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196595 */     // GIR_Coverage, 16905,
     /* 1196595 */     GIR_EraseRootFromParent_Done,
     /* 1196596 */   // Label 17405: @1196596
     /* 1196596 */   GIM_Try, /*On fail goto*//*Label 17406*/ GIMT_Encode4(1196676), // Rule ID 16908 //
     /* 1196601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1196604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1196612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1196615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1196618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196640 */     // MIs[0] round
     /* 1196640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196650 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1196653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196675 */     // GIR_Coverage, 16908,
     /* 1196675 */     GIR_EraseRootFromParent_Done,
     /* 1196676 */   // Label 17406: @1196676
     /* 1196676 */   GIM_Try, /*On fail goto*//*Label 17407*/ GIMT_Encode4(1196756), // Rule ID 16909 //
     /* 1196681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1196684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1196692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1196695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1196698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196720 */     // MIs[0] round
     /* 1196720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196730 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1196733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196755 */     // GIR_Coverage, 16909,
     /* 1196755 */     GIR_EraseRootFromParent_Done,
     /* 1196756 */   // Label 17407: @1196756
     /* 1196756 */   GIM_Try, /*On fail goto*//*Label 17408*/ GIMT_Encode4(1196836), // Rule ID 16912 //
     /* 1196761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1196772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1196775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1196778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196800 */     // MIs[0] round
     /* 1196800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1196813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196835 */     // GIR_Coverage, 16912,
     /* 1196835 */     GIR_EraseRootFromParent_Done,
     /* 1196836 */   // Label 17408: @1196836
     /* 1196836 */   GIM_Try, /*On fail goto*//*Label 17409*/ GIMT_Encode4(1196916), // Rule ID 16913 //
     /* 1196841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1196844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1196852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1196855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1196858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196880 */     // MIs[0] round
     /* 1196880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196890 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1196893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196915 */     // GIR_Coverage, 16913,
     /* 1196915 */     GIR_EraseRootFromParent_Done,
     /* 1196916 */   // Label 17409: @1196916
     /* 1196916 */   GIM_Try, /*On fail goto*//*Label 17410*/ GIMT_Encode4(1196996), // Rule ID 16916 //
     /* 1196921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1196924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1196929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1196932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1196935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1196938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1196941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1196960 */     // MIs[0] round
     /* 1196960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196970 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1196973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196995 */     // GIR_Coverage, 16916,
     /* 1196995 */     GIR_EraseRootFromParent_Done,
     /* 1196996 */   // Label 17410: @1196996
     /* 1196996 */   GIM_Try, /*On fail goto*//*Label 17411*/ GIMT_Encode4(1197076), // Rule ID 16917 //
     /* 1197001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1197012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1197015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1197018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197040 */     // MIs[0] round
     /* 1197040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197050 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1197053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197075 */     // GIR_Coverage, 16917,
     /* 1197075 */     GIR_EraseRootFromParent_Done,
     /* 1197076 */   // Label 17411: @1197076
     /* 1197076 */   GIM_Try, /*On fail goto*//*Label 17412*/ GIMT_Encode4(1197156), // Rule ID 16920 //
     /* 1197081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1197084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1197098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197120 */     // MIs[0] round
     /* 1197120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197130 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1197133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197155 */     // GIR_Coverage, 16920,
     /* 1197155 */     GIR_EraseRootFromParent_Done,
     /* 1197156 */   // Label 17412: @1197156
     /* 1197156 */   GIM_Try, /*On fail goto*//*Label 17413*/ GIMT_Encode4(1197236), // Rule ID 16921 //
     /* 1197161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1197164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1197178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197200 */     // MIs[0] round
     /* 1197200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197210 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1197213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197235 */     // GIR_Coverage, 16921,
     /* 1197235 */     GIR_EraseRootFromParent_Done,
     /* 1197236 */   // Label 17413: @1197236
     /* 1197236 */   GIM_Try, /*On fail goto*//*Label 17414*/ GIMT_Encode4(1197316), // Rule ID 16924 //
     /* 1197241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1197258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197280 */     // MIs[0] round
     /* 1197280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197290 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1197293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197315 */     // GIR_Coverage, 16924,
     /* 1197315 */     GIR_EraseRootFromParent_Done,
     /* 1197316 */   // Label 17414: @1197316
     /* 1197316 */   GIM_Try, /*On fail goto*//*Label 17415*/ GIMT_Encode4(1197396), // Rule ID 16925 //
     /* 1197321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1197338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197360 */     // MIs[0] round
     /* 1197360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11277:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1197373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197395 */     // GIR_Coverage, 16925,
     /* 1197395 */     GIR_EraseRootFromParent_Done,
     /* 1197396 */   // Label 17415: @1197396
     /* 1197396 */   GIM_Try, /*On fail goto*//*Label 17416*/ GIMT_Encode4(1197476), // Rule ID 16928 //
     /* 1197401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197440 */     // MIs[0] round
     /* 1197440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197450 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1197453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197475 */     // GIR_Coverage, 16928,
     /* 1197475 */     GIR_EraseRootFromParent_Done,
     /* 1197476 */   // Label 17416: @1197476
     /* 1197476 */   GIM_Try, /*On fail goto*//*Label 17417*/ GIMT_Encode4(1197556), // Rule ID 16929 //
     /* 1197481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1197492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1197495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1197498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197520 */     // MIs[0] round
     /* 1197520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197530 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11277:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1197533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197555 */     // GIR_Coverage, 16929,
     /* 1197555 */     GIR_EraseRootFromParent_Done,
     /* 1197556 */   // Label 17417: @1197556
     /* 1197556 */   GIM_Try, /*On fail goto*//*Label 17418*/ GIMT_Encode4(1197636), // Rule ID 16932 //
     /* 1197561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1197564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1197572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1197575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1197578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197600 */     // MIs[0] round
     /* 1197600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197610 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1197613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197635 */     // GIR_Coverage, 16932,
     /* 1197635 */     GIR_EraseRootFromParent_Done,
     /* 1197636 */   // Label 17418: @1197636
     /* 1197636 */   GIM_Try, /*On fail goto*//*Label 17419*/ GIMT_Encode4(1197716), // Rule ID 16933 //
     /* 1197641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1197644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1197649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1197652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1197655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1197658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1197661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1197680 */     // MIs[0] round
     /* 1197680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197690 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11277:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1197693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1197711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197715 */     // GIR_Coverage, 16933,
     /* 1197715 */     GIR_EraseRootFromParent_Done,
     /* 1197716 */   // Label 17419: @1197716
     /* 1197716 */   GIM_Try, /*On fail goto*//*Label 17420*/ GIMT_Encode4(1197796), // Rule ID 16936 //
     /* 1197721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1197732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1197735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1197738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197760 */     // MIs[0] round
     /* 1197760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197770 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1197773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197795 */     // GIR_Coverage, 16936,
     /* 1197795 */     GIR_EraseRootFromParent_Done,
     /* 1197796 */   // Label 17420: @1197796
     /* 1197796 */   GIM_Try, /*On fail goto*//*Label 17421*/ GIMT_Encode4(1197876), // Rule ID 16937 //
     /* 1197801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1197812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1197815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1197818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197840 */     // MIs[0] round
     /* 1197840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197850 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1197853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197875 */     // GIR_Coverage, 16937,
     /* 1197875 */     GIR_EraseRootFromParent_Done,
     /* 1197876 */   // Label 17421: @1197876
     /* 1197876 */   GIM_Try, /*On fail goto*//*Label 17422*/ GIMT_Encode4(1197956), // Rule ID 16940 //
     /* 1197881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1197884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1197892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1197895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197920 */     // MIs[0] round
     /* 1197920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197930 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1197933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197955 */     // GIR_Coverage, 16940,
     /* 1197955 */     GIR_EraseRootFromParent_Done,
     /* 1197956 */   // Label 17422: @1197956
     /* 1197956 */   GIM_Try, /*On fail goto*//*Label 17423*/ GIMT_Encode4(1198036), // Rule ID 16941 //
     /* 1197961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1197964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1197969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1197972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1197975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198000 */     // MIs[0] round
     /* 1198000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198010 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1198013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198035 */     // GIR_Coverage, 16941,
     /* 1198035 */     GIR_EraseRootFromParent_Done,
     /* 1198036 */   // Label 17423: @1198036
     /* 1198036 */   GIM_Try, /*On fail goto*//*Label 17424*/ GIMT_Encode4(1198116), // Rule ID 16944 //
     /* 1198041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1198058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198080 */     // MIs[0] round
     /* 1198080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198090 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1198093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198115 */     // GIR_Coverage, 16944,
     /* 1198115 */     GIR_EraseRootFromParent_Done,
     /* 1198116 */   // Label 17424: @1198116
     /* 1198116 */   GIM_Try, /*On fail goto*//*Label 17425*/ GIMT_Encode4(1198196), // Rule ID 16945 //
     /* 1198121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1198138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198160 */     // MIs[0] round
     /* 1198160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198170 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1198173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198195 */     // GIR_Coverage, 16945,
     /* 1198195 */     GIR_EraseRootFromParent_Done,
     /* 1198196 */   // Label 17425: @1198196
     /* 1198196 */   GIM_Try, /*On fail goto*//*Label 17426*/ GIMT_Encode4(1198276), // Rule ID 16948 //
     /* 1198201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1198212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1198215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198240 */     // MIs[0] round
     /* 1198240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198250 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1198253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198275 */     // GIR_Coverage, 16948,
     /* 1198275 */     GIR_EraseRootFromParent_Done,
     /* 1198276 */   // Label 17426: @1198276
     /* 1198276 */   GIM_Try, /*On fail goto*//*Label 17427*/ GIMT_Encode4(1198356), // Rule ID 16949 //
     /* 1198281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1198292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1198295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198320 */     // MIs[0] round
     /* 1198320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198330 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11263:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1198333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198355 */     // GIR_Coverage, 16949,
     /* 1198355 */     GIR_EraseRootFromParent_Done,
     /* 1198356 */   // Label 17427: @1198356
     /* 1198356 */   GIM_Try, /*On fail goto*//*Label 17428*/ GIMT_Encode4(1198436), // Rule ID 16952 //
     /* 1198361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1198364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198400 */     // MIs[0] round
     /* 1198400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198410 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198435 */     // GIR_Coverage, 16952,
     /* 1198435 */     GIR_EraseRootFromParent_Done,
     /* 1198436 */   // Label 17428: @1198436
     /* 1198436 */   GIM_Try, /*On fail goto*//*Label 17429*/ GIMT_Encode4(1198516), // Rule ID 16953 //
     /* 1198441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1198444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1198458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198480 */     // MIs[0] round
     /* 1198480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11263:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1198493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198515 */     // GIR_Coverage, 16953,
     /* 1198515 */     GIR_EraseRootFromParent_Done,
     /* 1198516 */   // Label 17429: @1198516
     /* 1198516 */   GIM_Try, /*On fail goto*//*Label 17430*/ GIMT_Encode4(1198596), // Rule ID 16956 //
     /* 1198521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1198524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1198532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1198535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1198538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198560 */     // MIs[0] round
     /* 1198560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1198573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198595 */     // GIR_Coverage, 16956,
     /* 1198595 */     GIR_EraseRootFromParent_Done,
     /* 1198596 */   // Label 17430: @1198596
     /* 1198596 */   GIM_Try, /*On fail goto*//*Label 17431*/ GIMT_Encode4(1198676), // Rule ID 16957 //
     /* 1198601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1198604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1198612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1198615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1198618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1198621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1198640 */     // MIs[0] round
     /* 1198640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198650 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11263:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1198653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1198671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198675 */     // GIR_Coverage, 16957,
     /* 1198675 */     GIR_EraseRootFromParent_Done,
     /* 1198676 */   // Label 17431: @1198676
     /* 1198676 */   GIM_Try, /*On fail goto*//*Label 17432*/ GIMT_Encode4(1198756), // Rule ID 16960 //
     /* 1198681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1198692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1198695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198720 */     // MIs[0] round
     /* 1198720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198730 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1198733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198755 */     // GIR_Coverage, 16960,
     /* 1198755 */     GIR_EraseRootFromParent_Done,
     /* 1198756 */   // Label 17432: @1198756
     /* 1198756 */   GIM_Try, /*On fail goto*//*Label 17433*/ GIMT_Encode4(1198836), // Rule ID 16961 //
     /* 1198761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1198772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1198775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198800 */     // MIs[0] round
     /* 1198800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198810 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1198813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198835 */     // GIR_Coverage, 16961,
     /* 1198835 */     GIR_EraseRootFromParent_Done,
     /* 1198836 */   // Label 17433: @1198836
     /* 1198836 */   GIM_Try, /*On fail goto*//*Label 17434*/ GIMT_Encode4(1198916), // Rule ID 16964 //
     /* 1198841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1198844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1198852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1198855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1198858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198880 */     // MIs[0] round
     /* 1198880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198890 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1198893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198915 */     // GIR_Coverage, 16964,
     /* 1198915 */     GIR_EraseRootFromParent_Done,
     /* 1198916 */   // Label 17434: @1198916
     /* 1198916 */   GIM_Try, /*On fail goto*//*Label 17435*/ GIMT_Encode4(1198996), // Rule ID 16965 //
     /* 1198921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1198924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1198929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1198932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1198935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1198938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1198941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1198960 */     // MIs[0] round
     /* 1198960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198970 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1198973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198995 */     // GIR_Coverage, 16965,
     /* 1198995 */     GIR_EraseRootFromParent_Done,
     /* 1198996 */   // Label 17435: @1198996
     /* 1198996 */   GIM_Try, /*On fail goto*//*Label 17436*/ GIMT_Encode4(1199076), // Rule ID 16968 //
     /* 1199001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1199004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1199012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1199015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199040 */     // MIs[0] round
     /* 1199040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199050 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1199053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199075 */     // GIR_Coverage, 16968,
     /* 1199075 */     GIR_EraseRootFromParent_Done,
     /* 1199076 */   // Label 17436: @1199076
     /* 1199076 */   GIM_Try, /*On fail goto*//*Label 17437*/ GIMT_Encode4(1199156), // Rule ID 16969 //
     /* 1199081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1199084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1199092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1199095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1199098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199120 */     // MIs[0] round
     /* 1199120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199130 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1199133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199155 */     // GIR_Coverage, 16969,
     /* 1199155 */     GIR_EraseRootFromParent_Done,
     /* 1199156 */   // Label 17437: @1199156
     /* 1199156 */   GIM_Try, /*On fail goto*//*Label 17438*/ GIMT_Encode4(1199236), // Rule ID 16972 //
     /* 1199161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1199172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1199175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199200 */     // MIs[0] round
     /* 1199200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199210 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1199213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199235 */     // GIR_Coverage, 16972,
     /* 1199235 */     GIR_EraseRootFromParent_Done,
     /* 1199236 */   // Label 17438: @1199236
     /* 1199236 */   GIM_Try, /*On fail goto*//*Label 17439*/ GIMT_Encode4(1199316), // Rule ID 16973 //
     /* 1199241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1199252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1199255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199280 */     // MIs[0] round
     /* 1199280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199290 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1199293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199315 */     // GIR_Coverage, 16973,
     /* 1199315 */     GIR_EraseRootFromParent_Done,
     /* 1199316 */   // Label 17439: @1199316
     /* 1199316 */   GIM_Try, /*On fail goto*//*Label 17440*/ GIMT_Encode4(1199396), // Rule ID 16976 //
     /* 1199321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199360 */     // MIs[0] round
     /* 1199360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199370 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199395 */     // GIR_Coverage, 16976,
     /* 1199395 */     GIR_EraseRootFromParent_Done,
     /* 1199396 */   // Label 17440: @1199396
     /* 1199396 */   GIM_Try, /*On fail goto*//*Label 17441*/ GIMT_Encode4(1199476), // Rule ID 16977 //
     /* 1199401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1199412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1199415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199440 */     // MIs[0] round
     /* 1199440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199450 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1199453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199475 */     // GIR_Coverage, 16977,
     /* 1199475 */     GIR_EraseRootFromParent_Done,
     /* 1199476 */   // Label 17441: @1199476
     /* 1199476 */   GIM_Try, /*On fail goto*//*Label 17442*/ GIMT_Encode4(1199556), // Rule ID 16980 //
     /* 1199481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1199484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1199492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1199495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199520 */     // MIs[0] round
     /* 1199520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199530 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1199533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199555 */     // GIR_Coverage, 16980,
     /* 1199555 */     GIR_EraseRootFromParent_Done,
     /* 1199556 */   // Label 17442: @1199556
     /* 1199556 */   GIM_Try, /*On fail goto*//*Label 17443*/ GIMT_Encode4(1199636), // Rule ID 16981 //
     /* 1199561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1199564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1199572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1199575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1199578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1199581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1199600 */     // MIs[0] round
     /* 1199600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199610 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1199613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199635 */     // GIR_Coverage, 16981,
     /* 1199635 */     GIR_EraseRootFromParent_Done,
     /* 1199636 */   // Label 17443: @1199636
     /* 1199636 */   GIM_Try, /*On fail goto*//*Label 17444*/ GIMT_Encode4(1199716), // Rule ID 16984 //
     /* 1199641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1199652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1199655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1199658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199680 */     // MIs[0] round
     /* 1199680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199690 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1199693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199715 */     // GIR_Coverage, 16984,
     /* 1199715 */     GIR_EraseRootFromParent_Done,
     /* 1199716 */   // Label 17444: @1199716
     /* 1199716 */   GIM_Try, /*On fail goto*//*Label 17445*/ GIMT_Encode4(1199796), // Rule ID 16985 //
     /* 1199721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1199732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1199735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1199738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199760 */     // MIs[0] round
     /* 1199760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199770 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11263:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1199773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199795 */     // GIR_Coverage, 16985,
     /* 1199795 */     GIR_EraseRootFromParent_Done,
     /* 1199796 */   // Label 17445: @1199796
     /* 1199796 */   GIM_Try, /*On fail goto*//*Label 17446*/ GIMT_Encode4(1199876), // Rule ID 16988 //
     /* 1199801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1199812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1199815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1199818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199840 */     // MIs[0] round
     /* 1199840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199850 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1199853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199875 */     // GIR_Coverage, 16988,
     /* 1199875 */     GIR_EraseRootFromParent_Done,
     /* 1199876 */   // Label 17446: @1199876
     /* 1199876 */   GIM_Try, /*On fail goto*//*Label 17447*/ GIMT_Encode4(1199956), // Rule ID 16989 //
     /* 1199881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1199884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1199892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1199895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1199898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1199920 */     // MIs[0] round
     /* 1199920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199930 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11263:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1199933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1199951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199955 */     // GIR_Coverage, 16989,
     /* 1199955 */     GIR_EraseRootFromParent_Done,
     /* 1199956 */   // Label 17447: @1199956
     /* 1199956 */   GIM_Try, /*On fail goto*//*Label 17448*/ GIMT_Encode4(1200036), // Rule ID 16992 //
     /* 1199961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1199964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1199969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1199972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1199975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1199978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1199981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200000 */     // MIs[0] round
     /* 1200000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200010 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1200013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200035 */     // GIR_Coverage, 16992,
     /* 1200035 */     GIR_EraseRootFromParent_Done,
     /* 1200036 */   // Label 17448: @1200036
     /* 1200036 */   GIM_Try, /*On fail goto*//*Label 17449*/ GIMT_Encode4(1200116), // Rule ID 16993 //
     /* 1200041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1200044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1200049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1200052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1200055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1200058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1200061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1200080 */     // MIs[0] round
     /* 1200080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200090 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11263:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1200093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1200111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200115 */     // GIR_Coverage, 16993,
     /* 1200115 */     GIR_EraseRootFromParent_Done,
     /* 1200116 */   // Label 17449: @1200116
     /* 1200116 */   GIM_Try, /*On fail goto*//*Label 17450*/ GIMT_Encode4(1200196), // Rule ID 16996 //
     /* 1200121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1200132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1200135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1200141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200160 */     // MIs[0] round
     /* 1200160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200170 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1200173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200195 */     // GIR_Coverage, 16996,
     /* 1200195 */     GIR_EraseRootFromParent_Done,
     /* 1200196 */   // Label 17450: @1200196
     /* 1200196 */   GIM_Try, /*On fail goto*//*Label 17451*/ GIMT_Encode4(1200276), // Rule ID 16997 //
     /* 1200201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1200212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1200215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1200218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1200221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200240 */     // MIs[0] round
     /* 1200240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200250 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1200253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200275 */     // GIR_Coverage, 16997,
     /* 1200275 */     GIR_EraseRootFromParent_Done,
     /* 1200276 */   // Label 17451: @1200276
     /* 1200276 */   GIM_Try, /*On fail goto*//*Label 17452*/ GIMT_Encode4(1200356), // Rule ID 17000 //
     /* 1200281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1200301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200320 */     // MIs[0] round
     /* 1200320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200330 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200355 */     // GIR_Coverage, 17000,
     /* 1200355 */     GIR_EraseRootFromParent_Done,
     /* 1200356 */   // Label 17452: @1200356
     /* 1200356 */   GIM_Try, /*On fail goto*//*Label 17453*/ GIMT_Encode4(1200436), // Rule ID 17001 //
     /* 1200361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1200381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200400 */     // MIs[0] round
     /* 1200400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200410 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1200413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200435 */     // GIR_Coverage, 17001,
     /* 1200435 */     GIR_EraseRootFromParent_Done,
     /* 1200436 */   // Label 17453: @1200436
     /* 1200436 */   GIM_Try, /*On fail goto*//*Label 17454*/ GIMT_Encode4(1200516), // Rule ID 17004 //
     /* 1200441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1200461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200480 */     // MIs[0] round
     /* 1200480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200490 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1200493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200515 */     // GIR_Coverage, 17004,
     /* 1200515 */     GIR_EraseRootFromParent_Done,
     /* 1200516 */   // Label 17454: @1200516
     /* 1200516 */   GIM_Try, /*On fail goto*//*Label 17455*/ GIMT_Encode4(1200596), // Rule ID 17005 //
     /* 1200521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1200541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200560 */     // MIs[0] round
     /* 1200560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200570 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1200573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200595 */     // GIR_Coverage, 17005,
     /* 1200595 */     GIR_EraseRootFromParent_Done,
     /* 1200596 */   // Label 17455: @1200596
     /* 1200596 */   GIM_Try, /*On fail goto*//*Label 17456*/ GIMT_Encode4(1200676), // Rule ID 17008 //
     /* 1200601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1200621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200640 */     // MIs[0] round
     /* 1200640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200650 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1200653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200675 */     // GIR_Coverage, 17008,
     /* 1200675 */     GIR_EraseRootFromParent_Done,
     /* 1200676 */   // Label 17456: @1200676
     /* 1200676 */   GIM_Try, /*On fail goto*//*Label 17457*/ GIMT_Encode4(1200756), // Rule ID 17009 //
     /* 1200681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1200701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200720 */     // MIs[0] round
     /* 1200720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200730 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1200733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200755 */     // GIR_Coverage, 17009,
     /* 1200755 */     GIR_EraseRootFromParent_Done,
     /* 1200756 */   // Label 17457: @1200756
     /* 1200756 */   GIM_Try, /*On fail goto*//*Label 17458*/ GIMT_Encode4(1200836), // Rule ID 17012 //
     /* 1200761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1200781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200800 */     // MIs[0] round
     /* 1200800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200810 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1200813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200835 */     // GIR_Coverage, 17012,
     /* 1200835 */     GIR_EraseRootFromParent_Done,
     /* 1200836 */   // Label 17458: @1200836
     /* 1200836 */   GIM_Try, /*On fail goto*//*Label 17459*/ GIMT_Encode4(1200916), // Rule ID 17013 //
     /* 1200841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1200861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200880 */     // MIs[0] round
     /* 1200880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200890 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1200893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200915 */     // GIR_Coverage, 17013,
     /* 1200915 */     GIR_EraseRootFromParent_Done,
     /* 1200916 */   // Label 17459: @1200916
     /* 1200916 */   GIM_Try, /*On fail goto*//*Label 17460*/ GIMT_Encode4(1200996), // Rule ID 17016 //
     /* 1200921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1200924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1200929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1200932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1200935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1200938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1200941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200960 */     // MIs[0] round
     /* 1200960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200970 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1200973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200995 */     // GIR_Coverage, 17016,
     /* 1200995 */     GIR_EraseRootFromParent_Done,
     /* 1200996 */   // Label 17460: @1200996
     /* 1200996 */   GIM_Try, /*On fail goto*//*Label 17461*/ GIMT_Encode4(1201076), // Rule ID 17017 //
     /* 1201001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1201012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1201015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1201018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1201021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201040 */     // MIs[0] round
     /* 1201040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1201053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201075 */     // GIR_Coverage, 17017,
     /* 1201075 */     GIR_EraseRootFromParent_Done,
     /* 1201076 */   // Label 17461: @1201076
     /* 1201076 */   GIM_Try, /*On fail goto*//*Label 17462*/ GIMT_Encode4(1201156), // Rule ID 17020 //
     /* 1201081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1201101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201120 */     // MIs[0] round
     /* 1201120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201130 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1201133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201155 */     // GIR_Coverage, 17020,
     /* 1201155 */     GIR_EraseRootFromParent_Done,
     /* 1201156 */   // Label 17462: @1201156
     /* 1201156 */   GIM_Try, /*On fail goto*//*Label 17463*/ GIMT_Encode4(1201236), // Rule ID 17021 //
     /* 1201161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1201172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1201175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1201181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201200 */     // MIs[0] round
     /* 1201200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201210 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1201213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201235 */     // GIR_Coverage, 17021,
     /* 1201235 */     GIR_EraseRootFromParent_Done,
     /* 1201236 */   // Label 17463: @1201236
     /* 1201236 */   GIM_Try, /*On fail goto*//*Label 17464*/ GIMT_Encode4(1201316), // Rule ID 17024 //
     /* 1201241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1201261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201280 */     // MIs[0] round
     /* 1201280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201290 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1201293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201315 */     // GIR_Coverage, 17024,
     /* 1201315 */     GIR_EraseRootFromParent_Done,
     /* 1201316 */   // Label 17464: @1201316
     /* 1201316 */   GIM_Try, /*On fail goto*//*Label 17465*/ GIMT_Encode4(1201396), // Rule ID 17025 //
     /* 1201321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1201332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1201335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1201341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201360 */     // MIs[0] round
     /* 1201360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201370 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1201373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201395 */     // GIR_Coverage, 17025,
     /* 1201395 */     GIR_EraseRootFromParent_Done,
     /* 1201396 */   // Label 17465: @1201396
     /* 1201396 */   GIM_Try, /*On fail goto*//*Label 17466*/ GIMT_Encode4(1201476), // Rule ID 17028 //
     /* 1201401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201440 */     // MIs[0] round
     /* 1201440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201450 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1201453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201475 */     // GIR_Coverage, 17028,
     /* 1201475 */     GIR_EraseRootFromParent_Done,
     /* 1201476 */   // Label 17466: @1201476
     /* 1201476 */   GIM_Try, /*On fail goto*//*Label 17467*/ GIMT_Encode4(1201556), // Rule ID 17029 //
     /* 1201481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1201501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201520 */     // MIs[0] round
     /* 1201520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201530 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1201533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201555 */     // GIR_Coverage, 17029,
     /* 1201555 */     GIR_EraseRootFromParent_Done,
     /* 1201556 */   // Label 17467: @1201556
     /* 1201556 */   GIM_Try, /*On fail goto*//*Label 17468*/ GIMT_Encode4(1201636), // Rule ID 17032 //
     /* 1201561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1201572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1201575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1201578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201600 */     // MIs[0] round
     /* 1201600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201610 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1201613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201635 */     // GIR_Coverage, 17032,
     /* 1201635 */     GIR_EraseRootFromParent_Done,
     /* 1201636 */   // Label 17468: @1201636
     /* 1201636 */   GIM_Try, /*On fail goto*//*Label 17469*/ GIMT_Encode4(1201716), // Rule ID 17033 //
     /* 1201641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1201652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1201655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1201658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201680 */     // MIs[0] round
     /* 1201680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201690 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1201693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201715 */     // GIR_Coverage, 17033,
     /* 1201715 */     GIR_EraseRootFromParent_Done,
     /* 1201716 */   // Label 17469: @1201716
     /* 1201716 */   GIM_Try, /*On fail goto*//*Label 17470*/ GIMT_Encode4(1201796), // Rule ID 17036 //
     /* 1201721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1201732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1201735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1201738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201760 */     // MIs[0] round
     /* 1201760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201770 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1201773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201795 */     // GIR_Coverage, 17036,
     /* 1201795 */     GIR_EraseRootFromParent_Done,
     /* 1201796 */   // Label 17470: @1201796
     /* 1201796 */   GIM_Try, /*On fail goto*//*Label 17471*/ GIMT_Encode4(1201876), // Rule ID 17037 //
     /* 1201801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1201812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1201815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1201818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201840 */     // MIs[0] round
     /* 1201840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201850 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11279:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1201853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201875 */     // GIR_Coverage, 17037,
     /* 1201875 */     GIR_EraseRootFromParent_Done,
     /* 1201876 */   // Label 17471: @1201876
     /* 1201876 */   GIM_Try, /*On fail goto*//*Label 17472*/ GIMT_Encode4(1201956), // Rule ID 17040 //
     /* 1201881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1201892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1201920 */     // MIs[0] round
     /* 1201920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1201933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201955 */     // GIR_Coverage, 17040,
     /* 1201955 */     GIR_EraseRootFromParent_Done,
     /* 1201956 */   // Label 17472: @1201956
     /* 1201956 */   GIM_Try, /*On fail goto*//*Label 17473*/ GIMT_Encode4(1202036), // Rule ID 17041 //
     /* 1201961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1201969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1201972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1201978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1201981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202000 */     // MIs[0] round
     /* 1202000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202010 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1202013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202035 */     // GIR_Coverage, 17041,
     /* 1202035 */     GIR_EraseRootFromParent_Done,
     /* 1202036 */   // Label 17473: @1202036
     /* 1202036 */   GIM_Try, /*On fail goto*//*Label 17474*/ GIMT_Encode4(1202116), // Rule ID 17044 //
     /* 1202041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1202052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1202055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202080 */     // MIs[0] round
     /* 1202080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202090 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1202093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202115 */     // GIR_Coverage, 17044,
     /* 1202115 */     GIR_EraseRootFromParent_Done,
     /* 1202116 */   // Label 17474: @1202116
     /* 1202116 */   GIM_Try, /*On fail goto*//*Label 17475*/ GIMT_Encode4(1202196), // Rule ID 17045 //
     /* 1202121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1202132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1202135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1202138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202160 */     // MIs[0] round
     /* 1202160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202170 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1202173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202195 */     // GIR_Coverage, 17045,
     /* 1202195 */     GIR_EraseRootFromParent_Done,
     /* 1202196 */   // Label 17475: @1202196
     /* 1202196 */   GIM_Try, /*On fail goto*//*Label 17476*/ GIMT_Encode4(1202276), // Rule ID 17048 //
     /* 1202201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1202212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1202215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202240 */     // MIs[0] round
     /* 1202240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202250 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1202253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202275 */     // GIR_Coverage, 17048,
     /* 1202275 */     GIR_EraseRootFromParent_Done,
     /* 1202276 */   // Label 17476: @1202276
     /* 1202276 */   GIM_Try, /*On fail goto*//*Label 17477*/ GIMT_Encode4(1202356), // Rule ID 17049 //
     /* 1202281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1202292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1202295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1202298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202320 */     // MIs[0] round
     /* 1202320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202330 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1202333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202355 */     // GIR_Coverage, 17049,
     /* 1202355 */     GIR_EraseRootFromParent_Done,
     /* 1202356 */   // Label 17477: @1202356
     /* 1202356 */   GIM_Try, /*On fail goto*//*Label 17478*/ GIMT_Encode4(1202436), // Rule ID 17052 //
     /* 1202361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202400 */     // MIs[0] round
     /* 1202400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202435 */     // GIR_Coverage, 17052,
     /* 1202435 */     GIR_EraseRootFromParent_Done,
     /* 1202436 */   // Label 17478: @1202436
     /* 1202436 */   GIM_Try, /*On fail goto*//*Label 17479*/ GIMT_Encode4(1202516), // Rule ID 17053 //
     /* 1202441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1202452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1202455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202480 */     // MIs[0] round
     /* 1202480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11279:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1202493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202515 */     // GIR_Coverage, 17053,
     /* 1202515 */     GIR_EraseRootFromParent_Done,
     /* 1202516 */   // Label 17479: @1202516
     /* 1202516 */   GIM_Try, /*On fail goto*//*Label 17480*/ GIMT_Encode4(1202596), // Rule ID 17056 //
     /* 1202521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1202532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1202535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202560 */     // MIs[0] round
     /* 1202560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202570 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1202573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202595 */     // GIR_Coverage, 17056,
     /* 1202595 */     GIR_EraseRootFromParent_Done,
     /* 1202596 */   // Label 17480: @1202596
     /* 1202596 */   GIM_Try, /*On fail goto*//*Label 17481*/ GIMT_Encode4(1202676), // Rule ID 17057 //
     /* 1202601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1202612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1202615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202640 */     // MIs[0] round
     /* 1202640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202650 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11279:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1202653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202675 */     // GIR_Coverage, 17057,
     /* 1202675 */     GIR_EraseRootFromParent_Done,
     /* 1202676 */   // Label 17481: @1202676
     /* 1202676 */   GIM_Try, /*On fail goto*//*Label 17482*/ GIMT_Encode4(1202756), // Rule ID 17060 //
     /* 1202681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1202692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1202695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202720 */     // MIs[0] round
     /* 1202720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202730 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1202733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202755 */     // GIR_Coverage, 17060,
     /* 1202755 */     GIR_EraseRootFromParent_Done,
     /* 1202756 */   // Label 17482: @1202756
     /* 1202756 */   GIM_Try, /*On fail goto*//*Label 17483*/ GIMT_Encode4(1202836), // Rule ID 17061 //
     /* 1202761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1202772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1202775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202800 */     // MIs[0] round
     /* 1202800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202810 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11279:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1202813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202835 */     // GIR_Coverage, 17061,
     /* 1202835 */     GIR_EraseRootFromParent_Done,
     /* 1202836 */   // Label 17483: @1202836
     /* 1202836 */   GIM_Try, /*On fail goto*//*Label 17484*/ GIMT_Encode4(1202916), // Rule ID 17064 //
     /* 1202841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1202852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1202855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1202858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202880 */     // MIs[0] round
     /* 1202880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202890 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1202893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202915 */     // GIR_Coverage, 17064,
     /* 1202915 */     GIR_EraseRootFromParent_Done,
     /* 1202916 */   // Label 17484: @1202916
     /* 1202916 */   GIM_Try, /*On fail goto*//*Label 17485*/ GIMT_Encode4(1202996), // Rule ID 17065 //
     /* 1202921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1202929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1202932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1202935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1202938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1202941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1202960 */     // MIs[0] round
     /* 1202960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202970 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11279:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1202973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202995 */     // GIR_Coverage, 17065,
     /* 1202995 */     GIR_EraseRootFromParent_Done,
     /* 1202996 */   // Label 17485: @1202996
     /* 1202996 */   GIM_Try, /*On fail goto*//*Label 17486*/ GIMT_Encode4(1203076), // Rule ID 17068 //
     /* 1203001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1203018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203040 */     // MIs[0] round
     /* 1203040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203050 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1203053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203075 */     // GIR_Coverage, 17068,
     /* 1203075 */     GIR_EraseRootFromParent_Done,
     /* 1203076 */   // Label 17486: @1203076
     /* 1203076 */   GIM_Try, /*On fail goto*//*Label 17487*/ GIMT_Encode4(1203156), // Rule ID 17069 //
     /* 1203081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1203098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203120 */     // MIs[0] round
     /* 1203120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203130 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1203133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203155 */     // GIR_Coverage, 17069,
     /* 1203155 */     GIR_EraseRootFromParent_Done,
     /* 1203156 */   // Label 17487: @1203156
     /* 1203156 */   GIM_Try, /*On fail goto*//*Label 17488*/ GIMT_Encode4(1203236), // Rule ID 17072 //
     /* 1203161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1203172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1203175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1203178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1203181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203200 */     // MIs[0] round
     /* 1203200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203210 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1203213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203235 */     // GIR_Coverage, 17072,
     /* 1203235 */     GIR_EraseRootFromParent_Done,
     /* 1203236 */   // Label 17488: @1203236
     /* 1203236 */   GIM_Try, /*On fail goto*//*Label 17489*/ GIMT_Encode4(1203316), // Rule ID 17073 //
     /* 1203241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1203252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1203255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1203258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1203261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203280 */     // MIs[0] round
     /* 1203280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203290 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1203293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203315 */     // GIR_Coverage, 17073,
     /* 1203315 */     GIR_EraseRootFromParent_Done,
     /* 1203316 */   // Label 17489: @1203316
     /* 1203316 */   GIM_Try, /*On fail goto*//*Label 17490*/ GIMT_Encode4(1203396), // Rule ID 17076 //
     /* 1203321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203360 */     // MIs[0] round
     /* 1203360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11315:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203395 */     // GIR_Coverage, 17076,
     /* 1203395 */     GIR_EraseRootFromParent_Done,
     /* 1203396 */   // Label 17490: @1203396
     /* 1203396 */   GIM_Try, /*On fail goto*//*Label 17491*/ GIMT_Encode4(1203476), // Rule ID 17077 //
     /* 1203401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1203412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1203415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1203418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1203421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203440 */     // MIs[0] round
     /* 1203440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203450 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11315:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1203453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203475 */     // GIR_Coverage, 17077,
     /* 1203475 */     GIR_EraseRootFromParent_Done,
     /* 1203476 */   // Label 17491: @1203476
     /* 1203476 */   GIM_Try, /*On fail goto*//*Label 17492*/ GIMT_Encode4(1203556), // Rule ID 17080 //
     /* 1203481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1203498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1203501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203520 */     // MIs[0] round
     /* 1203520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203530 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11315:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1203533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203555 */     // GIR_Coverage, 17080,
     /* 1203555 */     GIR_EraseRootFromParent_Done,
     /* 1203556 */   // Label 17492: @1203556
     /* 1203556 */   GIM_Try, /*On fail goto*//*Label 17493*/ GIMT_Encode4(1203636), // Rule ID 17081 //
     /* 1203561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1203578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1203581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203600 */     // MIs[0] round
     /* 1203600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203610 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11315:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1203613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203635 */     // GIR_Coverage, 17081,
     /* 1203635 */     GIR_EraseRootFromParent_Done,
     /* 1203636 */   // Label 17493: @1203636
     /* 1203636 */   GIM_Try, /*On fail goto*//*Label 17494*/ GIMT_Encode4(1203716), // Rule ID 17084 //
     /* 1203641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1203658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1203661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203680 */     // MIs[0] round
     /* 1203680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203690 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11315:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1203693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203715 */     // GIR_Coverage, 17084,
     /* 1203715 */     GIR_EraseRootFromParent_Done,
     /* 1203716 */   // Label 17494: @1203716
     /* 1203716 */   GIM_Try, /*On fail goto*//*Label 17495*/ GIMT_Encode4(1203796), // Rule ID 17085 //
     /* 1203721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1203738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1203741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203760 */     // MIs[0] round
     /* 1203760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203770 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11315:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1203773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203795 */     // GIR_Coverage, 17085,
     /* 1203795 */     GIR_EraseRootFromParent_Done,
     /* 1203796 */   // Label 17495: @1203796
     /* 1203796 */   GIM_Try, /*On fail goto*//*Label 17496*/ GIMT_Encode4(1203876), // Rule ID 17088 //
     /* 1203801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1203812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1203815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1203818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1203821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203840 */     // MIs[0] round
     /* 1203840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203850 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1203853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203875 */     // GIR_Coverage, 17088,
     /* 1203875 */     GIR_EraseRootFromParent_Done,
     /* 1203876 */   // Label 17496: @1203876
     /* 1203876 */   GIM_Try, /*On fail goto*//*Label 17497*/ GIMT_Encode4(1203956), // Rule ID 17089 //
     /* 1203881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1203892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1203895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1203898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1203901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203920 */     // MIs[0] round
     /* 1203920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203930 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1203933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203955 */     // GIR_Coverage, 17089,
     /* 1203955 */     GIR_EraseRootFromParent_Done,
     /* 1203956 */   // Label 17497: @1203956
     /* 1203956 */   GIM_Try, /*On fail goto*//*Label 17498*/ GIMT_Encode4(1204036), // Rule ID 17092 //
     /* 1203961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1203969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1203978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1203981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204000 */     // MIs[0] round
     /* 1204000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204010 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11315:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1204013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204035 */     // GIR_Coverage, 17092,
     /* 1204035 */     GIR_EraseRootFromParent_Done,
     /* 1204036 */   // Label 17498: @1204036
     /* 1204036 */   GIM_Try, /*On fail goto*//*Label 17499*/ GIMT_Encode4(1204116), // Rule ID 17093 //
     /* 1204041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1204052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1204055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1204058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1204061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204080 */     // MIs[0] round
     /* 1204080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11315:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1204093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204115 */     // GIR_Coverage, 17093,
     /* 1204115 */     GIR_EraseRootFromParent_Done,
     /* 1204116 */   // Label 17499: @1204116
     /* 1204116 */   GIM_Try, /*On fail goto*//*Label 17500*/ GIMT_Encode4(1204196), // Rule ID 17096 //
     /* 1204121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1204132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1204135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1204141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204160 */     // MIs[0] round
     /* 1204160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204170 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11315:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1204173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204195 */     // GIR_Coverage, 17096,
     /* 1204195 */     GIR_EraseRootFromParent_Done,
     /* 1204196 */   // Label 17500: @1204196
     /* 1204196 */   GIM_Try, /*On fail goto*//*Label 17501*/ GIMT_Encode4(1204276), // Rule ID 17097 //
     /* 1204201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1204212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1204215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1204221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204240 */     // MIs[0] round
     /* 1204240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204250 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11315:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1204253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204275 */     // GIR_Coverage, 17097,
     /* 1204275 */     GIR_EraseRootFromParent_Done,
     /* 1204276 */   // Label 17501: @1204276
     /* 1204276 */   GIM_Try, /*On fail goto*//*Label 17502*/ GIMT_Encode4(1204356), // Rule ID 17100 //
     /* 1204281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1204292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1204295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1204301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204320 */     // MIs[0] round
     /* 1204320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204330 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11315:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204355 */     // GIR_Coverage, 17100,
     /* 1204355 */     GIR_EraseRootFromParent_Done,
     /* 1204356 */   // Label 17502: @1204356
     /* 1204356 */   GIM_Try, /*On fail goto*//*Label 17503*/ GIMT_Encode4(1204436), // Rule ID 17101 //
     /* 1204361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1204372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1204375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1204381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204400 */     // MIs[0] round
     /* 1204400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204410 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11315:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1204413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204435 */     // GIR_Coverage, 17101,
     /* 1204435 */     GIR_EraseRootFromParent_Done,
     /* 1204436 */   // Label 17503: @1204436
     /* 1204436 */   GIM_Try, /*On fail goto*//*Label 17504*/ GIMT_Encode4(1204516), // Rule ID 17104 //
     /* 1204441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204480 */     // MIs[0] round
     /* 1204480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204490 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1204493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204515 */     // GIR_Coverage, 17104,
     /* 1204515 */     GIR_EraseRootFromParent_Done,
     /* 1204516 */   // Label 17504: @1204516
     /* 1204516 */   GIM_Try, /*On fail goto*//*Label 17505*/ GIMT_Encode4(1204596), // Rule ID 17105 //
     /* 1204521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1204538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204560 */     // MIs[0] round
     /* 1204560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204570 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1204573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204595 */     // GIR_Coverage, 17105,
     /* 1204595 */     GIR_EraseRootFromParent_Done,
     /* 1204596 */   // Label 17505: @1204596
     /* 1204596 */   GIM_Try, /*On fail goto*//*Label 17506*/ GIMT_Encode4(1204676), // Rule ID 17108 //
     /* 1204601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204640 */     // MIs[0] round
     /* 1204640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1204653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204675 */     // GIR_Coverage, 17108,
     /* 1204675 */     GIR_EraseRootFromParent_Done,
     /* 1204676 */   // Label 17506: @1204676
     /* 1204676 */   GIM_Try, /*On fail goto*//*Label 17507*/ GIMT_Encode4(1204756), // Rule ID 17109 //
     /* 1204681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1204698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204720 */     // MIs[0] round
     /* 1204720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204730 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11315:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1204733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204755 */     // GIR_Coverage, 17109,
     /* 1204755 */     GIR_EraseRootFromParent_Done,
     /* 1204756 */   // Label 17507: @1204756
     /* 1204756 */   GIM_Try, /*On fail goto*//*Label 17508*/ GIMT_Encode4(1204836), // Rule ID 17112 //
     /* 1204761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1204778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204800 */     // MIs[0] round
     /* 1204800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204810 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11315:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1204813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204835 */     // GIR_Coverage, 17112,
     /* 1204835 */     GIR_EraseRootFromParent_Done,
     /* 1204836 */   // Label 17508: @1204836
     /* 1204836 */   GIM_Try, /*On fail goto*//*Label 17509*/ GIMT_Encode4(1204916), // Rule ID 17113 //
     /* 1204841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1204858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204880 */     // MIs[0] round
     /* 1204880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204890 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11315:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1204893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204915 */     // GIR_Coverage, 17113,
     /* 1204915 */     GIR_EraseRootFromParent_Done,
     /* 1204916 */   // Label 17509: @1204916
     /* 1204916 */   GIM_Try, /*On fail goto*//*Label 17510*/ GIMT_Encode4(1204996), // Rule ID 17116 //
     /* 1204921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1204929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1204938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1204941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1204960 */     // MIs[0] round
     /* 1204960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204970 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11315:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1204973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204995 */     // GIR_Coverage, 17116,
     /* 1204995 */     GIR_EraseRootFromParent_Done,
     /* 1204996 */   // Label 17510: @1204996
     /* 1204996 */   GIM_Try, /*On fail goto*//*Label 17511*/ GIMT_Encode4(1205076), // Rule ID 17117 //
     /* 1205001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1205018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205040 */     // MIs[0] round
     /* 1205040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205050 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11315:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1205053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205075 */     // GIR_Coverage, 17117,
     /* 1205075 */     GIR_EraseRootFromParent_Done,
     /* 1205076 */   // Label 17511: @1205076
     /* 1205076 */   GIM_Try, /*On fail goto*//*Label 17512*/ GIMT_Encode4(1205156), // Rule ID 17120 //
     /* 1205081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1205092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1205095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1205098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205120 */     // MIs[0] round
     /* 1205120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205130 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11315:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1205133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205155 */     // GIR_Coverage, 17120,
     /* 1205155 */     GIR_EraseRootFromParent_Done,
     /* 1205156 */   // Label 17512: @1205156
     /* 1205156 */   GIM_Try, /*On fail goto*//*Label 17513*/ GIMT_Encode4(1205236), // Rule ID 17121 //
     /* 1205161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1205172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1205175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1205178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205200 */     // MIs[0] round
     /* 1205200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205210 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11315:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1205213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205235 */     // GIR_Coverage, 17121,
     /* 1205235 */     GIR_EraseRootFromParent_Done,
     /* 1205236 */   // Label 17513: @1205236
     /* 1205236 */   GIM_Try, /*On fail goto*//*Label 17514*/ GIMT_Encode4(1205316), // Rule ID 17124 //
     /* 1205241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1205252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1205255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205280 */     // MIs[0] round
     /* 1205280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205290 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1205293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205315 */     // GIR_Coverage, 17124,
     /* 1205315 */     GIR_EraseRootFromParent_Done,
     /* 1205316 */   // Label 17514: @1205316
     /* 1205316 */   GIM_Try, /*On fail goto*//*Label 17515*/ GIMT_Encode4(1205396), // Rule ID 17125 //
     /* 1205321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1205332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1205335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205360 */     // MIs[0] round
     /* 1205360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205370 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11315:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1205373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205395 */     // GIR_Coverage, 17125,
     /* 1205395 */     GIR_EraseRootFromParent_Done,
     /* 1205396 */   // Label 17515: @1205396
     /* 1205396 */   GIM_Try, /*On fail goto*//*Label 17516*/ GIMT_Encode4(1205476), // Rule ID 17128 //
     /* 1205401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205440 */     // MIs[0] round
     /* 1205440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205450 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11315:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1205453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205475 */     // GIR_Coverage, 17128,
     /* 1205475 */     GIR_EraseRootFromParent_Done,
     /* 1205476 */   // Label 17516: @1205476
     /* 1205476 */   GIM_Try, /*On fail goto*//*Label 17517*/ GIMT_Encode4(1205556), // Rule ID 17129 //
     /* 1205481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1205492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1205495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205520 */     // MIs[0] round
     /* 1205520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205530 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11315:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1205533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205555 */     // GIR_Coverage, 17129,
     /* 1205555 */     GIR_EraseRootFromParent_Done,
     /* 1205556 */   // Label 17517: @1205556
     /* 1205556 */   GIM_Try, /*On fail goto*//*Label 17518*/ GIMT_Encode4(1205636), // Rule ID 17132 //
     /* 1205561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205600 */     // MIs[0] round
     /* 1205600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205610 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11315:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1205613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205635 */     // GIR_Coverage, 17132,
     /* 1205635 */     GIR_EraseRootFromParent_Done,
     /* 1205636 */   // Label 17518: @1205636
     /* 1205636 */   GIM_Try, /*On fail goto*//*Label 17519*/ GIMT_Encode4(1205716), // Rule ID 17133 //
     /* 1205641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205680 */     // MIs[0] round
     /* 1205680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205690 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11315:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1205693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205715 */     // GIR_Coverage, 17133,
     /* 1205715 */     GIR_EraseRootFromParent_Done,
     /* 1205716 */   // Label 17519: @1205716
     /* 1205716 */   GIM_Try, /*On fail goto*//*Label 17520*/ GIMT_Encode4(1205796), // Rule ID 17136 //
     /* 1205721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205760 */     // MIs[0] round
     /* 1205760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205770 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11315:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1205773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205795 */     // GIR_Coverage, 17136,
     /* 1205795 */     GIR_EraseRootFromParent_Done,
     /* 1205796 */   // Label 17520: @1205796
     /* 1205796 */   GIM_Try, /*On fail goto*//*Label 17521*/ GIMT_Encode4(1205876), // Rule ID 17137 //
     /* 1205801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1205809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1205821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1205840 */     // MIs[0] round
     /* 1205840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205850 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11315:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1205853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205875 */     // GIR_Coverage, 17137,
     /* 1205875 */     GIR_EraseRootFromParent_Done,
     /* 1205876 */   // Label 17521: @1205876
     /* 1205876 */   GIM_Try, /*On fail goto*//*Label 17522*/ GIMT_Encode4(1205956), // Rule ID 17142 //
     /* 1205881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1205901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205920 */     // MIs[0] round
     /* 1205920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205930 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1205933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205955 */     // GIR_Coverage, 17142,
     /* 1205955 */     GIR_EraseRootFromParent_Done,
     /* 1205956 */   // Label 17522: @1205956
     /* 1205956 */   GIM_Try, /*On fail goto*//*Label 17523*/ GIMT_Encode4(1206036), // Rule ID 17143 //
     /* 1205961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1205969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1205981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206000 */     // MIs[0] round
     /* 1206000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206010 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1206013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206035 */     // GIR_Coverage, 17143,
     /* 1206035 */     GIR_EraseRootFromParent_Done,
     /* 1206036 */   // Label 17523: @1206036
     /* 1206036 */   GIM_Try, /*On fail goto*//*Label 17524*/ GIMT_Encode4(1206116), // Rule ID 17152 //
     /* 1206041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1206052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1206055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1206061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206080 */     // MIs[0] round
     /* 1206080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206090 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1206093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206115 */     // GIR_Coverage, 17152,
     /* 1206115 */     GIR_EraseRootFromParent_Done,
     /* 1206116 */   // Label 17524: @1206116
     /* 1206116 */   GIM_Try, /*On fail goto*//*Label 17525*/ GIMT_Encode4(1206196), // Rule ID 17153 //
     /* 1206121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1206132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1206135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1206138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1206141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206160 */     // MIs[0] round
     /* 1206160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206170 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1206173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206195 */     // GIR_Coverage, 17153,
     /* 1206195 */     GIR_EraseRootFromParent_Done,
     /* 1206196 */   // Label 17525: @1206196
     /* 1206196 */   GIM_Try, /*On fail goto*//*Label 17526*/ GIMT_Encode4(1206276), // Rule ID 17162 //
     /* 1206201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1206212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1206215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1206221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206240 */     // MIs[0] round
     /* 1206240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206250 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1206253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206275 */     // GIR_Coverage, 17162,
     /* 1206275 */     GIR_EraseRootFromParent_Done,
     /* 1206276 */   // Label 17526: @1206276
     /* 1206276 */   GIM_Try, /*On fail goto*//*Label 17527*/ GIMT_Encode4(1206356), // Rule ID 17163 //
     /* 1206281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1206292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1206295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1206298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1206301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206320 */     // MIs[0] round
     /* 1206320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206330 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1206333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206355 */     // GIR_Coverage, 17163,
     /* 1206355 */     GIR_EraseRootFromParent_Done,
     /* 1206356 */   // Label 17527: @1206356
     /* 1206356 */   GIM_Try, /*On fail goto*//*Label 17528*/ GIMT_Encode4(1206436), // Rule ID 17172 //
     /* 1206361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206400 */     // MIs[0] round
     /* 1206400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206410 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206435 */     // GIR_Coverage, 17172,
     /* 1206435 */     GIR_EraseRootFromParent_Done,
     /* 1206436 */   // Label 17528: @1206436
     /* 1206436 */   GIM_Try, /*On fail goto*//*Label 17529*/ GIMT_Encode4(1206516), // Rule ID 17173 //
     /* 1206441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1206461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206480 */     // MIs[0] round
     /* 1206480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206490 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1206493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206515 */     // GIR_Coverage, 17173,
     /* 1206515 */     GIR_EraseRootFromParent_Done,
     /* 1206516 */   // Label 17529: @1206516
     /* 1206516 */   GIM_Try, /*On fail goto*//*Label 17530*/ GIMT_Encode4(1206596), // Rule ID 17182 //
     /* 1206521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1206538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1206541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206560 */     // MIs[0] round
     /* 1206560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1206573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206595 */     // GIR_Coverage, 17182,
     /* 1206595 */     GIR_EraseRootFromParent_Done,
     /* 1206596 */   // Label 17530: @1206596
     /* 1206596 */   GIM_Try, /*On fail goto*//*Label 17531*/ GIMT_Encode4(1206676), // Rule ID 17183 //
     /* 1206601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1206618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1206621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206640 */     // MIs[0] round
     /* 1206640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206650 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1206653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206675 */     // GIR_Coverage, 17183,
     /* 1206675 */     GIR_EraseRootFromParent_Done,
     /* 1206676 */   // Label 17531: @1206676
     /* 1206676 */   GIM_Try, /*On fail goto*//*Label 17532*/ GIMT_Encode4(1206756), // Rule ID 17192 //
     /* 1206681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1206698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1206701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206720 */     // MIs[0] round
     /* 1206720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206730 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1206733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206755 */     // GIR_Coverage, 17192,
     /* 1206755 */     GIR_EraseRootFromParent_Done,
     /* 1206756 */   // Label 17532: @1206756
     /* 1206756 */   GIM_Try, /*On fail goto*//*Label 17533*/ GIMT_Encode4(1206836), // Rule ID 17193 //
     /* 1206761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1206778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1206781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206800 */     // MIs[0] round
     /* 1206800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206810 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1206813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206835 */     // GIR_Coverage, 17193,
     /* 1206835 */     GIR_EraseRootFromParent_Done,
     /* 1206836 */   // Label 17533: @1206836
     /* 1206836 */   GIM_Try, /*On fail goto*//*Label 17534*/ GIMT_Encode4(1206916), // Rule ID 17202 //
     /* 1206841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1206858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1206861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206880 */     // MIs[0] round
     /* 1206880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206890 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1206893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206915 */     // GIR_Coverage, 17202,
     /* 1206915 */     GIR_EraseRootFromParent_Done,
     /* 1206916 */   // Label 17534: @1206916
     /* 1206916 */   GIM_Try, /*On fail goto*//*Label 17535*/ GIMT_Encode4(1206996), // Rule ID 17203 //
     /* 1206921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1206929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1206938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1206941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206960 */     // MIs[0] round
     /* 1206960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206970 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1206973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206995 */     // GIR_Coverage, 17203,
     /* 1206995 */     GIR_EraseRootFromParent_Done,
     /* 1206996 */   // Label 17535: @1206996
     /* 1206996 */   GIM_Try, /*On fail goto*//*Label 17536*/ GIMT_Encode4(1207076), // Rule ID 17212 //
     /* 1207001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1207012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1207015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1207021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207040 */     // MIs[0] round
     /* 1207040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207050 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1207053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207075 */     // GIR_Coverage, 17212,
     /* 1207075 */     GIR_EraseRootFromParent_Done,
     /* 1207076 */   // Label 17536: @1207076
     /* 1207076 */   GIM_Try, /*On fail goto*//*Label 17537*/ GIMT_Encode4(1207156), // Rule ID 17213 //
     /* 1207081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1207084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1207092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1207095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1207098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1207101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207120 */     // MIs[0] round
     /* 1207120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207130 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1207133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207155 */     // GIR_Coverage, 17213,
     /* 1207155 */     GIR_EraseRootFromParent_Done,
     /* 1207156 */   // Label 17537: @1207156
     /* 1207156 */   GIM_Try, /*On fail goto*//*Label 17538*/ GIMT_Encode4(1207236), // Rule ID 17220 //
     /* 1207161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207200 */     // MIs[0] round
     /* 1207200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207210 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1207213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207235 */     // GIR_Coverage, 17220,
     /* 1207235 */     GIR_EraseRootFromParent_Done,
     /* 1207236 */   // Label 17538: @1207236
     /* 1207236 */   GIM_Try, /*On fail goto*//*Label 17539*/ GIMT_Encode4(1207316), // Rule ID 17221 //
     /* 1207241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207280 */     // MIs[0] round
     /* 1207280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1207293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207315 */     // GIR_Coverage, 17221,
     /* 1207315 */     GIR_EraseRootFromParent_Done,
     /* 1207316 */   // Label 17539: @1207316
     /* 1207316 */   GIM_Try, /*On fail goto*//*Label 17540*/ GIMT_Encode4(1207396), // Rule ID 17224 //
     /* 1207321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207360 */     // MIs[0] round
     /* 1207360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207370 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207395 */     // GIR_Coverage, 17224,
     /* 1207395 */     GIR_EraseRootFromParent_Done,
     /* 1207396 */   // Label 17540: @1207396
     /* 1207396 */   GIM_Try, /*On fail goto*//*Label 17541*/ GIMT_Encode4(1207476), // Rule ID 17225 //
     /* 1207401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207440 */     // MIs[0] round
     /* 1207440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207450 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11281:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1207453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207475 */     // GIR_Coverage, 17225,
     /* 1207475 */     GIR_EraseRootFromParent_Done,
     /* 1207476 */   // Label 17541: @1207476
     /* 1207476 */   GIM_Try, /*On fail goto*//*Label 17542*/ GIMT_Encode4(1207556), // Rule ID 17228 //
     /* 1207481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1207498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207520 */     // MIs[0] round
     /* 1207520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207530 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1207533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207555 */     // GIR_Coverage, 17228,
     /* 1207555 */     GIR_EraseRootFromParent_Done,
     /* 1207556 */   // Label 17542: @1207556
     /* 1207556 */   GIM_Try, /*On fail goto*//*Label 17543*/ GIMT_Encode4(1207636), // Rule ID 17229 //
     /* 1207561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1207572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1207575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1207578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207600 */     // MIs[0] round
     /* 1207600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207610 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1207613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207635 */     // GIR_Coverage, 17229,
     /* 1207635 */     GIR_EraseRootFromParent_Done,
     /* 1207636 */   // Label 17543: @1207636
     /* 1207636 */   GIM_Try, /*On fail goto*//*Label 17544*/ GIMT_Encode4(1207716), // Rule ID 17232 //
     /* 1207641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1207652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1207655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1207658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207680 */     // MIs[0] round
     /* 1207680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207690 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1207693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207715 */     // GIR_Coverage, 17232,
     /* 1207715 */     GIR_EraseRootFromParent_Done,
     /* 1207716 */   // Label 17544: @1207716
     /* 1207716 */   GIM_Try, /*On fail goto*//*Label 17545*/ GIMT_Encode4(1207796), // Rule ID 17233 //
     /* 1207721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1207732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1207735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1207738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207760 */     // MIs[0] round
     /* 1207760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207770 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1207773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207795 */     // GIR_Coverage, 17233,
     /* 1207795 */     GIR_EraseRootFromParent_Done,
     /* 1207796 */   // Label 17545: @1207796
     /* 1207796 */   GIM_Try, /*On fail goto*//*Label 17546*/ GIMT_Encode4(1207876), // Rule ID 17236 //
     /* 1207801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1207804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1207812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1207815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1207818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207840 */     // MIs[0] round
     /* 1207840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207850 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1207853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207875 */     // GIR_Coverage, 17236,
     /* 1207875 */     GIR_EraseRootFromParent_Done,
     /* 1207876 */   // Label 17546: @1207876
     /* 1207876 */   GIM_Try, /*On fail goto*//*Label 17547*/ GIMT_Encode4(1207956), // Rule ID 17237 //
     /* 1207881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1207884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1207892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1207895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1207898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1207901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1207916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1207920 */     // MIs[0] round
     /* 1207920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207930 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1207933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207955 */     // GIR_Coverage, 17237,
     /* 1207955 */     GIR_EraseRootFromParent_Done,
     /* 1207956 */   // Label 17547: @1207956
     /* 1207956 */   GIM_Try, /*On fail goto*//*Label 17548*/ GIMT_Encode4(1208036), // Rule ID 17240 //
     /* 1207961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1207964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1207969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1207981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208000 */     // MIs[0] round
     /* 1208000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208010 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1208013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208035 */     // GIR_Coverage, 17240,
     /* 1208035 */     GIR_EraseRootFromParent_Done,
     /* 1208036 */   // Label 17548: @1208036
     /* 1208036 */   GIM_Try, /*On fail goto*//*Label 17549*/ GIMT_Encode4(1208116), // Rule ID 17241 //
     /* 1208041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1208052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1208055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1208058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208080 */     // MIs[0] round
     /* 1208080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208090 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11281:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1208093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208115 */     // GIR_Coverage, 17241,
     /* 1208115 */     GIR_EraseRootFromParent_Done,
     /* 1208116 */   // Label 17549: @1208116
     /* 1208116 */   GIM_Try, /*On fail goto*//*Label 17550*/ GIMT_Encode4(1208196), // Rule ID 17244 //
     /* 1208121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208160 */     // MIs[0] round
     /* 1208160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208170 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1208173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208195 */     // GIR_Coverage, 17244,
     /* 1208195 */     GIR_EraseRootFromParent_Done,
     /* 1208196 */   // Label 17550: @1208196
     /* 1208196 */   GIM_Try, /*On fail goto*//*Label 17551*/ GIMT_Encode4(1208276), // Rule ID 17245 //
     /* 1208201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208240 */     // MIs[0] round
     /* 1208240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11281:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1208253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208275 */     // GIR_Coverage, 17245,
     /* 1208275 */     GIR_EraseRootFromParent_Done,
     /* 1208276 */   // Label 17551: @1208276
     /* 1208276 */   GIM_Try, /*On fail goto*//*Label 17552*/ GIMT_Encode4(1208356), // Rule ID 17248 //
     /* 1208281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208320 */     // MIs[0] round
     /* 1208320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208330 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208355 */     // GIR_Coverage, 17248,
     /* 1208355 */     GIR_EraseRootFromParent_Done,
     /* 1208356 */   // Label 17552: @1208356
     /* 1208356 */   GIM_Try, /*On fail goto*//*Label 17553*/ GIMT_Encode4(1208436), // Rule ID 17249 //
     /* 1208361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208400 */     // MIs[0] round
     /* 1208400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208410 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11281:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1208413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208435 */     // GIR_Coverage, 17249,
     /* 1208435 */     GIR_EraseRootFromParent_Done,
     /* 1208436 */   // Label 17553: @1208436
     /* 1208436 */   GIM_Try, /*On fail goto*//*Label 17554*/ GIMT_Encode4(1208516), // Rule ID 17252 //
     /* 1208441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1208444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1208458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208480 */     // MIs[0] round
     /* 1208480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208490 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1208493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208515 */     // GIR_Coverage, 17252,
     /* 1208515 */     GIR_EraseRootFromParent_Done,
     /* 1208516 */   // Label 17554: @1208516
     /* 1208516 */   GIM_Try, /*On fail goto*//*Label 17555*/ GIMT_Encode4(1208596), // Rule ID 17253 //
     /* 1208521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1208524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1208529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1208532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1208535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1208538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1208541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1208560 */     // MIs[0] round
     /* 1208560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208570 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11281:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1208573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208595 */     // GIR_Coverage, 17253,
     /* 1208595 */     GIR_EraseRootFromParent_Done,
     /* 1208596 */   // Label 17555: @1208596
     /* 1208596 */   GIM_Try, /*On fail goto*//*Label 17556*/ GIMT_Encode4(1208676), // Rule ID 17258 //
     /* 1208601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1208612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1208615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1208618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1208621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208640 */     // MIs[0] round
     /* 1208640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208650 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1208653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208675 */     // GIR_Coverage, 17258,
     /* 1208675 */     GIR_EraseRootFromParent_Done,
     /* 1208676 */   // Label 17556: @1208676
     /* 1208676 */   GIM_Try, /*On fail goto*//*Label 17557*/ GIMT_Encode4(1208756), // Rule ID 17259 //
     /* 1208681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1208692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1208695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1208698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1208701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208720 */     // MIs[0] round
     /* 1208720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208730 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1208733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208755 */     // GIR_Coverage, 17259,
     /* 1208755 */     GIR_EraseRootFromParent_Done,
     /* 1208756 */   // Label 17557: @1208756
     /* 1208756 */   GIM_Try, /*On fail goto*//*Label 17558*/ GIMT_Encode4(1208836), // Rule ID 17268 //
     /* 1208761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1208772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1208775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1208778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1208781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208800 */     // MIs[0] round
     /* 1208800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208810 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1208813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208835 */     // GIR_Coverage, 17268,
     /* 1208835 */     GIR_EraseRootFromParent_Done,
     /* 1208836 */   // Label 17558: @1208836
     /* 1208836 */   GIM_Try, /*On fail goto*//*Label 17559*/ GIMT_Encode4(1208916), // Rule ID 17269 //
     /* 1208841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1208844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1208852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1208855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1208858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1208861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208880 */     // MIs[0] round
     /* 1208880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208890 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1208893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208915 */     // GIR_Coverage, 17269,
     /* 1208915 */     GIR_EraseRootFromParent_Done,
     /* 1208916 */   // Label 17559: @1208916
     /* 1208916 */   GIM_Try, /*On fail goto*//*Label 17560*/ GIMT_Encode4(1208996), // Rule ID 17278 //
     /* 1208921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1208924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1208929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1208938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1208941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1208960 */     // MIs[0] round
     /* 1208960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208970 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1208973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208995 */     // GIR_Coverage, 17278,
     /* 1208995 */     GIR_EraseRootFromParent_Done,
     /* 1208996 */   // Label 17560: @1208996
     /* 1208996 */   GIM_Try, /*On fail goto*//*Label 17561*/ GIMT_Encode4(1209076), // Rule ID 17279 //
     /* 1209001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1209012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1209015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1209018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1209021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209040 */     // MIs[0] round
     /* 1209040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1209053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209075 */     // GIR_Coverage, 17279,
     /* 1209075 */     GIR_EraseRootFromParent_Done,
     /* 1209076 */   // Label 17561: @1209076
     /* 1209076 */   GIM_Try, /*On fail goto*//*Label 17562*/ GIMT_Encode4(1209156), // Rule ID 17288 //
     /* 1209081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1209092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1209095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209120 */     // MIs[0] round
     /* 1209120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209130 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1209133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209155 */     // GIR_Coverage, 17288,
     /* 1209155 */     GIR_EraseRootFromParent_Done,
     /* 1209156 */   // Label 17562: @1209156
     /* 1209156 */   GIM_Try, /*On fail goto*//*Label 17563*/ GIMT_Encode4(1209236), // Rule ID 17289 //
     /* 1209161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1209172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1209175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1209178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1209181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209200 */     // MIs[0] round
     /* 1209200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209210 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1209213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209235 */     // GIR_Coverage, 17289,
     /* 1209235 */     GIR_EraseRootFromParent_Done,
     /* 1209236 */   // Label 17563: @1209236
     /* 1209236 */   GIM_Try, /*On fail goto*//*Label 17564*/ GIMT_Encode4(1209316), // Rule ID 17298 //
     /* 1209241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1209244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1209258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209280 */     // MIs[0] round
     /* 1209280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209290 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1209293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209315 */     // GIR_Coverage, 17298,
     /* 1209315 */     GIR_EraseRootFromParent_Done,
     /* 1209316 */   // Label 17564: @1209316
     /* 1209316 */   GIM_Try, /*On fail goto*//*Label 17565*/ GIMT_Encode4(1209396), // Rule ID 17299 //
     /* 1209321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1209324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1209332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1209335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1209338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1209341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209360 */     // MIs[0] round
     /* 1209360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209370 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1209373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209395 */     // GIR_Coverage, 17299,
     /* 1209395 */     GIR_EraseRootFromParent_Done,
     /* 1209396 */   // Label 17565: @1209396
     /* 1209396 */   GIM_Try, /*On fail goto*//*Label 17566*/ GIMT_Encode4(1209476), // Rule ID 17308 //
     /* 1209401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209440 */     // MIs[0] round
     /* 1209440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209450 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1209453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209475 */     // GIR_Coverage, 17308,
     /* 1209475 */     GIR_EraseRootFromParent_Done,
     /* 1209476 */   // Label 17566: @1209476
     /* 1209476 */   GIM_Try, /*On fail goto*//*Label 17567*/ GIMT_Encode4(1209556), // Rule ID 17309 //
     /* 1209481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1209492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1209495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1209498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1209501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209520 */     // MIs[0] round
     /* 1209520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209530 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1209533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209555 */     // GIR_Coverage, 17309,
     /* 1209555 */     GIR_EraseRootFromParent_Done,
     /* 1209556 */   // Label 17567: @1209556
     /* 1209556 */   GIM_Try, /*On fail goto*//*Label 17568*/ GIMT_Encode4(1209636), // Rule ID 17318 //
     /* 1209561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1209572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1209575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1209578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1209581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209600 */     // MIs[0] round
     /* 1209600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209610 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1209613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209635 */     // GIR_Coverage, 17318,
     /* 1209635 */     GIR_EraseRootFromParent_Done,
     /* 1209636 */   // Label 17568: @1209636
     /* 1209636 */   GIM_Try, /*On fail goto*//*Label 17569*/ GIMT_Encode4(1209716), // Rule ID 17319 //
     /* 1209641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1209652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1209655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1209658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1209661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209680 */     // MIs[0] round
     /* 1209680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209690 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1209693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209715 */     // GIR_Coverage, 17319,
     /* 1209715 */     GIR_EraseRootFromParent_Done,
     /* 1209716 */   // Label 17569: @1209716
     /* 1209716 */   GIM_Try, /*On fail goto*//*Label 17570*/ GIMT_Encode4(1209796), // Rule ID 17328 //
     /* 1209721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1209732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1209735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1209738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1209741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209760 */     // MIs[0] round
     /* 1209760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209770 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1209773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209795 */     // GIR_Coverage, 17328,
     /* 1209795 */     GIR_EraseRootFromParent_Done,
     /* 1209796 */   // Label 17570: @1209796
     /* 1209796 */   GIM_Try, /*On fail goto*//*Label 17571*/ GIMT_Encode4(1209876), // Rule ID 17329 //
     /* 1209801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1209812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1209815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1209818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1209821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1209840 */     // MIs[0] round
     /* 1209840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209850 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1209853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209875 */     // GIR_Coverage, 17329,
     /* 1209875 */     GIR_EraseRootFromParent_Done,
     /* 1209876 */   // Label 17571: @1209876
     /* 1209876 */   GIM_Try, /*On fail goto*//*Label 17572*/ GIMT_Encode4(1209956), // Rule ID 17338 //
     /* 1209881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1209884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1209901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209920 */     // MIs[0] round
     /* 1209920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209930 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1209933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209955 */     // GIR_Coverage, 17338,
     /* 1209955 */     GIR_EraseRootFromParent_Done,
     /* 1209956 */   // Label 17572: @1209956
     /* 1209956 */   GIM_Try, /*On fail goto*//*Label 17573*/ GIMT_Encode4(1210036), // Rule ID 17339 //
     /* 1209961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1209964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1209969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1209981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210000 */     // MIs[0] round
     /* 1210000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210010 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1210013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210035 */     // GIR_Coverage, 17339,
     /* 1210035 */     GIR_EraseRootFromParent_Done,
     /* 1210036 */   // Label 17573: @1210036
     /* 1210036 */   GIM_Try, /*On fail goto*//*Label 17574*/ GIMT_Encode4(1210116), // Rule ID 17346 //
     /* 1210041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1210052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1210055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1210058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210080 */     // MIs[0] round
     /* 1210080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210090 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1210093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210115 */     // GIR_Coverage, 17346,
     /* 1210115 */     GIR_EraseRootFromParent_Done,
     /* 1210116 */   // Label 17574: @1210116
     /* 1210116 */   GIM_Try, /*On fail goto*//*Label 17575*/ GIMT_Encode4(1210196), // Rule ID 17347 //
     /* 1210121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1210132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1210135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1210138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210160 */     // MIs[0] round
     /* 1210160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210170 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1210173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210195 */     // GIR_Coverage, 17347,
     /* 1210195 */     GIR_EraseRootFromParent_Done,
     /* 1210196 */   // Label 17575: @1210196
     /* 1210196 */   GIM_Try, /*On fail goto*//*Label 17576*/ GIMT_Encode4(1210276), // Rule ID 17350 //
     /* 1210201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1210212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1210215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1210218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210240 */     // MIs[0] round
     /* 1210240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210250 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1210253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210275 */     // GIR_Coverage, 17350,
     /* 1210275 */     GIR_EraseRootFromParent_Done,
     /* 1210276 */   // Label 17576: @1210276
     /* 1210276 */   GIM_Try, /*On fail goto*//*Label 17577*/ GIMT_Encode4(1210356), // Rule ID 17351 //
     /* 1210281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1210292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1210295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1210298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210320 */     // MIs[0] round
     /* 1210320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210330 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11317:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1210333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210355 */     // GIR_Coverage, 17351,
     /* 1210355 */     GIR_EraseRootFromParent_Done,
     /* 1210356 */   // Label 17577: @1210356
     /* 1210356 */   GIM_Try, /*On fail goto*//*Label 17578*/ GIMT_Encode4(1210436), // Rule ID 17354 //
     /* 1210361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210400 */     // MIs[0] round
     /* 1210400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210410 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210435 */     // GIR_Coverage, 17354,
     /* 1210435 */     GIR_EraseRootFromParent_Done,
     /* 1210436 */   // Label 17578: @1210436
     /* 1210436 */   GIM_Try, /*On fail goto*//*Label 17579*/ GIMT_Encode4(1210516), // Rule ID 17355 //
     /* 1210441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210480 */     // MIs[0] round
     /* 1210480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210490 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1210493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210515 */     // GIR_Coverage, 17355,
     /* 1210515 */     GIR_EraseRootFromParent_Done,
     /* 1210516 */   // Label 17579: @1210516
     /* 1210516 */   GIM_Try, /*On fail goto*//*Label 17580*/ GIMT_Encode4(1210596), // Rule ID 17358 //
     /* 1210521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210560 */     // MIs[0] round
     /* 1210560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210570 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1210573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210595 */     // GIR_Coverage, 17358,
     /* 1210595 */     GIR_EraseRootFromParent_Done,
     /* 1210596 */   // Label 17580: @1210596
     /* 1210596 */   GIM_Try, /*On fail goto*//*Label 17581*/ GIMT_Encode4(1210676), // Rule ID 17359 //
     /* 1210601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210640 */     // MIs[0] round
     /* 1210640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210650 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1210653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210675 */     // GIR_Coverage, 17359,
     /* 1210675 */     GIR_EraseRootFromParent_Done,
     /* 1210676 */   // Label 17581: @1210676
     /* 1210676 */   GIM_Try, /*On fail goto*//*Label 17582*/ GIMT_Encode4(1210756), // Rule ID 17362 //
     /* 1210681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1210684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1210692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1210695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210720 */     // MIs[0] round
     /* 1210720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210730 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1210733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210755 */     // GIR_Coverage, 17362,
     /* 1210755 */     GIR_EraseRootFromParent_Done,
     /* 1210756 */   // Label 17582: @1210756
     /* 1210756 */   GIM_Try, /*On fail goto*//*Label 17583*/ GIMT_Encode4(1210836), // Rule ID 17363 //
     /* 1210761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1210764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1210772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1210775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210800 */     // MIs[0] round
     /* 1210800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210810 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1210813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210835 */     // GIR_Coverage, 17363,
     /* 1210835 */     GIR_EraseRootFromParent_Done,
     /* 1210836 */   // Label 17583: @1210836
     /* 1210836 */   GIM_Try, /*On fail goto*//*Label 17584*/ GIMT_Encode4(1210916), // Rule ID 17366 //
     /* 1210841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1210844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210880 */     // MIs[0] round
     /* 1210880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210890 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1210893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210915 */     // GIR_Coverage, 17366,
     /* 1210915 */     GIR_EraseRootFromParent_Done,
     /* 1210916 */   // Label 17584: @1210916
     /* 1210916 */   GIM_Try, /*On fail goto*//*Label 17585*/ GIMT_Encode4(1210996), // Rule ID 17367 //
     /* 1210921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1210924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1210929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210960 */     // MIs[0] round
     /* 1210960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210970 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11317:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1210973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210995 */     // GIR_Coverage, 17367,
     /* 1210995 */     GIR_EraseRootFromParent_Done,
     /* 1210996 */   // Label 17585: @1210996
     /* 1210996 */   GIM_Try, /*On fail goto*//*Label 17586*/ GIMT_Encode4(1211076), // Rule ID 17370 //
     /* 1211001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211040 */     // MIs[0] round
     /* 1211040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1211053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211075 */     // GIR_Coverage, 17370,
     /* 1211075 */     GIR_EraseRootFromParent_Done,
     /* 1211076 */   // Label 17586: @1211076
     /* 1211076 */   GIM_Try, /*On fail goto*//*Label 17587*/ GIMT_Encode4(1211156), // Rule ID 17371 //
     /* 1211081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211120 */     // MIs[0] round
     /* 1211120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211130 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11317:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1211133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211155 */     // GIR_Coverage, 17371,
     /* 1211155 */     GIR_EraseRootFromParent_Done,
     /* 1211156 */   // Label 17587: @1211156
     /* 1211156 */   GIM_Try, /*On fail goto*//*Label 17588*/ GIMT_Encode4(1211236), // Rule ID 17374 //
     /* 1211161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211200 */     // MIs[0] round
     /* 1211200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211210 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1211213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211235 */     // GIR_Coverage, 17374,
     /* 1211235 */     GIR_EraseRootFromParent_Done,
     /* 1211236 */   // Label 17588: @1211236
     /* 1211236 */   GIM_Try, /*On fail goto*//*Label 17589*/ GIMT_Encode4(1211316), // Rule ID 17375 //
     /* 1211241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211280 */     // MIs[0] round
     /* 1211280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211290 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11317:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1211293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211315 */     // GIR_Coverage, 17375,
     /* 1211315 */     GIR_EraseRootFromParent_Done,
     /* 1211316 */   // Label 17589: @1211316
     /* 1211316 */   GIM_Try, /*On fail goto*//*Label 17590*/ GIMT_Encode4(1211396), // Rule ID 17378 //
     /* 1211321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1211324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211360 */     // MIs[0] round
     /* 1211360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211370 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211395 */     // GIR_Coverage, 17378,
     /* 1211395 */     GIR_EraseRootFromParent_Done,
     /* 1211396 */   // Label 17590: @1211396
     /* 1211396 */   GIM_Try, /*On fail goto*//*Label 17591*/ GIMT_Encode4(1211476), // Rule ID 17379 //
     /* 1211401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1211404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1211409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211440 */     // MIs[0] round
     /* 1211440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211450 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11317:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1211453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211475 */     // GIR_Coverage, 17379,
     /* 1211475 */     GIR_EraseRootFromParent_Done,
     /* 1211476 */   // Label 17591: @1211476
     /* 1211476 */   GIM_Try, /*On fail goto*//*Label 17592*/ GIMT_Encode4(1211556), // Rule ID 17382 //
     /* 1211481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211520 */     // MIs[0] round
     /* 1211520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211530 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1211533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211555 */     // GIR_Coverage, 17382,
     /* 1211555 */     GIR_EraseRootFromParent_Done,
     /* 1211556 */   // Label 17592: @1211556
     /* 1211556 */   GIM_Try, /*On fail goto*//*Label 17593*/ GIMT_Encode4(1211636), // Rule ID 17383 //
     /* 1211561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1211564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211600 */     // MIs[0] round
     /* 1211600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211610 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1211613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211635 */     // GIR_Coverage, 17383,
     /* 1211635 */     GIR_EraseRootFromParent_Done,
     /* 1211636 */   // Label 17593: @1211636
     /* 1211636 */   GIM_Try, /*On fail goto*//*Label 17594*/ GIMT_Encode4(1211716), // Rule ID 17386 //
     /* 1211641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1211652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1211655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211680 */     // MIs[0] round
     /* 1211680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211690 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1211693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211715 */     // GIR_Coverage, 17386,
     /* 1211715 */     GIR_EraseRootFromParent_Done,
     /* 1211716 */   // Label 17594: @1211716
     /* 1211716 */   GIM_Try, /*On fail goto*//*Label 17595*/ GIMT_Encode4(1211796), // Rule ID 17387 //
     /* 1211721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1211724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1211732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1211735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211760 */     // MIs[0] round
     /* 1211760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211770 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1211773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211795 */     // GIR_Coverage, 17387,
     /* 1211795 */     GIR_EraseRootFromParent_Done,
     /* 1211796 */   // Label 17595: @1211796
     /* 1211796 */   GIM_Try, /*On fail goto*//*Label 17596*/ GIMT_Encode4(1211876), // Rule ID 17390 //
     /* 1211801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1211804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1211812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1211815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1211821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211840 */     // MIs[0] round
     /* 1211840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211850 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1211853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211875 */     // GIR_Coverage, 17390,
     /* 1211875 */     GIR_EraseRootFromParent_Done,
     /* 1211876 */   // Label 17596: @1211876
     /* 1211876 */   GIM_Try, /*On fail goto*//*Label 17597*/ GIMT_Encode4(1211956), // Rule ID 17391 //
     /* 1211881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1211884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1211892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1211895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1211901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211920 */     // MIs[0] round
     /* 1211920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211930 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1211933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211955 */     // GIR_Coverage, 17391,
     /* 1211955 */     GIR_EraseRootFromParent_Done,
     /* 1211956 */   // Label 17597: @1211956
     /* 1211956 */   GIM_Try, /*On fail goto*//*Label 17598*/ GIMT_Encode4(1212036), // Rule ID 17394 //
     /* 1211961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1211972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1211975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1211978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1211981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212000 */     // MIs[0] round
     /* 1212000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212010 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1212013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212035 */     // GIR_Coverage, 17394,
     /* 1212035 */     GIR_EraseRootFromParent_Done,
     /* 1212036 */   // Label 17598: @1212036
     /* 1212036 */   GIM_Try, /*On fail goto*//*Label 17599*/ GIMT_Encode4(1212116), // Rule ID 17395 //
     /* 1212041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1212052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1212055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212080 */     // MIs[0] round
     /* 1212080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212090 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1212093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212115 */     // GIR_Coverage, 17395,
     /* 1212115 */     GIR_EraseRootFromParent_Done,
     /* 1212116 */   // Label 17599: @1212116
     /* 1212116 */   GIM_Try, /*On fail goto*//*Label 17600*/ GIMT_Encode4(1212196), // Rule ID 17398 //
     /* 1212121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212160 */     // MIs[0] round
     /* 1212160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212170 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1212173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212195 */     // GIR_Coverage, 17398,
     /* 1212195 */     GIR_EraseRootFromParent_Done,
     /* 1212196 */   // Label 17600: @1212196
     /* 1212196 */   GIM_Try, /*On fail goto*//*Label 17601*/ GIMT_Encode4(1212276), // Rule ID 17399 //
     /* 1212201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212240 */     // MIs[0] round
     /* 1212240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212250 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1212253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212275 */     // GIR_Coverage, 17399,
     /* 1212275 */     GIR_EraseRootFromParent_Done,
     /* 1212276 */   // Label 17601: @1212276
     /* 1212276 */   GIM_Try, /*On fail goto*//*Label 17602*/ GIMT_Encode4(1212356), // Rule ID 17402 //
     /* 1212281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1212284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212320 */     // MIs[0] round
     /* 1212320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212330 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212355 */     // GIR_Coverage, 17402,
     /* 1212355 */     GIR_EraseRootFromParent_Done,
     /* 1212356 */   // Label 17602: @1212356
     /* 1212356 */   GIM_Try, /*On fail goto*//*Label 17603*/ GIMT_Encode4(1212436), // Rule ID 17403 //
     /* 1212361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1212364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212400 */     // MIs[0] round
     /* 1212400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1212413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212435 */     // GIR_Coverage, 17403,
     /* 1212435 */     GIR_EraseRootFromParent_Done,
     /* 1212436 */   // Label 17603: @1212436
     /* 1212436 */   GIM_Try, /*On fail goto*//*Label 17604*/ GIMT_Encode4(1212516), // Rule ID 17406 //
     /* 1212441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212480 */     // MIs[0] round
     /* 1212480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212490 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1212493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212515 */     // GIR_Coverage, 17406,
     /* 1212515 */     GIR_EraseRootFromParent_Done,
     /* 1212516 */   // Label 17604: @1212516
     /* 1212516 */   GIM_Try, /*On fail goto*//*Label 17605*/ GIMT_Encode4(1212596), // Rule ID 17407 //
     /* 1212521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212560 */     // MIs[0] round
     /* 1212560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212570 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1212573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212595 */     // GIR_Coverage, 17407,
     /* 1212595 */     GIR_EraseRootFromParent_Done,
     /* 1212596 */   // Label 17605: @1212596
     /* 1212596 */   GIM_Try, /*On fail goto*//*Label 17606*/ GIMT_Encode4(1212676), // Rule ID 17410 //
     /* 1212601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1212612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1212615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1212618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1212621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212640 */     // MIs[0] round
     /* 1212640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212650 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1212653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212675 */     // GIR_Coverage, 17410,
     /* 1212675 */     GIR_EraseRootFromParent_Done,
     /* 1212676 */   // Label 17606: @1212676
     /* 1212676 */   GIM_Try, /*On fail goto*//*Label 17607*/ GIMT_Encode4(1212756), // Rule ID 17411 //
     /* 1212681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1212692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1212695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1212698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1212701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212720 */     // MIs[0] round
     /* 1212720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212730 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1212733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212755 */     // GIR_Coverage, 17411,
     /* 1212755 */     GIR_EraseRootFromParent_Done,
     /* 1212756 */   // Label 17607: @1212756
     /* 1212756 */   GIM_Try, /*On fail goto*//*Label 17608*/ GIMT_Encode4(1212836), // Rule ID 17414 //
     /* 1212761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1212772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1212775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1212778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1212781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212800 */     // MIs[0] round
     /* 1212800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212810 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1212813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212835 */     // GIR_Coverage, 17414,
     /* 1212835 */     GIR_EraseRootFromParent_Done,
     /* 1212836 */   // Label 17608: @1212836
     /* 1212836 */   GIM_Try, /*On fail goto*//*Label 17609*/ GIMT_Encode4(1212916), // Rule ID 17415 //
     /* 1212841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1212852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1212855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1212858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1212861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212880 */     // MIs[0] round
     /* 1212880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212890 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1212893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212915 */     // GIR_Coverage, 17415,
     /* 1212915 */     GIR_EraseRootFromParent_Done,
     /* 1212916 */   // Label 17609: @1212916
     /* 1212916 */   GIM_Try, /*On fail goto*//*Label 17610*/ GIMT_Encode4(1212996), // Rule ID 17418 //
     /* 1212921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1212929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1212932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1212935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1212938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1212941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212960 */     // MIs[0] round
     /* 1212960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212970 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1212973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212995 */     // GIR_Coverage, 17418,
     /* 1212995 */     GIR_EraseRootFromParent_Done,
     /* 1212996 */   // Label 17610: @1212996
     /* 1212996 */   GIM_Try, /*On fail goto*//*Label 17611*/ GIMT_Encode4(1213076), // Rule ID 17419 //
     /* 1213001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1213012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1213015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213040 */     // MIs[0] round
     /* 1213040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1213053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213075 */     // GIR_Coverage, 17419,
     /* 1213075 */     GIR_EraseRootFromParent_Done,
     /* 1213076 */   // Label 17611: @1213076
     /* 1213076 */   GIM_Try, /*On fail goto*//*Label 17612*/ GIMT_Encode4(1213156), // Rule ID 17422 //
     /* 1213081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213120 */     // MIs[0] round
     /* 1213120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213130 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1213133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213155 */     // GIR_Coverage, 17422,
     /* 1213155 */     GIR_EraseRootFromParent_Done,
     /* 1213156 */   // Label 17612: @1213156
     /* 1213156 */   GIM_Try, /*On fail goto*//*Label 17613*/ GIMT_Encode4(1213236), // Rule ID 17423 //
     /* 1213161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213200 */     // MIs[0] round
     /* 1213200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213210 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1213213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213235 */     // GIR_Coverage, 17423,
     /* 1213235 */     GIR_EraseRootFromParent_Done,
     /* 1213236 */   // Label 17613: @1213236
     /* 1213236 */   GIM_Try, /*On fail goto*//*Label 17614*/ GIMT_Encode4(1213316), // Rule ID 17426 //
     /* 1213241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213280 */     // MIs[0] round
     /* 1213280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213290 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1213293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213315 */     // GIR_Coverage, 17426,
     /* 1213315 */     GIR_EraseRootFromParent_Done,
     /* 1213316 */   // Label 17614: @1213316
     /* 1213316 */   GIM_Try, /*On fail goto*//*Label 17615*/ GIMT_Encode4(1213396), // Rule ID 17427 //
     /* 1213321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213360 */     // MIs[0] round
     /* 1213360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213370 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1213373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213395 */     // GIR_Coverage, 17427,
     /* 1213395 */     GIR_EraseRootFromParent_Done,
     /* 1213396 */   // Label 17615: @1213396
     /* 1213396 */   GIM_Try, /*On fail goto*//*Label 17616*/ GIMT_Encode4(1213476), // Rule ID 17430 //
     /* 1213401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213440 */     // MIs[0] round
     /* 1213440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213450 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1213453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213475 */     // GIR_Coverage, 17430,
     /* 1213475 */     GIR_EraseRootFromParent_Done,
     /* 1213476 */   // Label 17616: @1213476
     /* 1213476 */   GIM_Try, /*On fail goto*//*Label 17617*/ GIMT_Encode4(1213556), // Rule ID 17431 //
     /* 1213481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213520 */     // MIs[0] round
     /* 1213520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213530 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1213533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213555 */     // GIR_Coverage, 17431,
     /* 1213555 */     GIR_EraseRootFromParent_Done,
     /* 1213556 */   // Label 17617: @1213556
     /* 1213556 */   GIM_Try, /*On fail goto*//*Label 17618*/ GIMT_Encode4(1213636), // Rule ID 17434 //
     /* 1213561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1213581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213600 */     // MIs[0] round
     /* 1213600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213610 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1213613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213635 */     // GIR_Coverage, 17434,
     /* 1213635 */     GIR_EraseRootFromParent_Done,
     /* 1213636 */   // Label 17618: @1213636
     /* 1213636 */   GIM_Try, /*On fail goto*//*Label 17619*/ GIMT_Encode4(1213716), // Rule ID 17435 //
     /* 1213641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1213661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213680 */     // MIs[0] round
     /* 1213680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213690 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1213693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213715 */     // GIR_Coverage, 17435,
     /* 1213715 */     GIR_EraseRootFromParent_Done,
     /* 1213716 */   // Label 17619: @1213716
     /* 1213716 */   GIM_Try, /*On fail goto*//*Label 17620*/ GIMT_Encode4(1213796), // Rule ID 17438 //
     /* 1213721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1213741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213760 */     // MIs[0] round
     /* 1213760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213770 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1213773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213795 */     // GIR_Coverage, 17438,
     /* 1213795 */     GIR_EraseRootFromParent_Done,
     /* 1213796 */   // Label 17620: @1213796
     /* 1213796 */   GIM_Try, /*On fail goto*//*Label 17621*/ GIMT_Encode4(1213876), // Rule ID 17439 //
     /* 1213801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1213821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213840 */     // MIs[0] round
     /* 1213840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213850 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1213853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213875 */     // GIR_Coverage, 17439,
     /* 1213875 */     GIR_EraseRootFromParent_Done,
     /* 1213876 */   // Label 17621: @1213876
     /* 1213876 */   GIM_Try, /*On fail goto*//*Label 17622*/ GIMT_Encode4(1213956), // Rule ID 17442 //
     /* 1213881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1213884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1213892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1213895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1213898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1213920 */     // MIs[0] round
     /* 1213920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213930 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1213933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213955 */     // GIR_Coverage, 17442,
     /* 1213955 */     GIR_EraseRootFromParent_Done,
     /* 1213956 */   // Label 17622: @1213956
     /* 1213956 */   GIM_Try, /*On fail goto*//*Label 17623*/ GIMT_Encode4(1214036), // Rule ID 17443 //
     /* 1213961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1213964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1213969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1213972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1213975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1213978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1213981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1213996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214000 */     // MIs[0] round
     /* 1214000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214010 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1214013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214035 */     // GIR_Coverage, 17443,
     /* 1214035 */     GIR_EraseRootFromParent_Done,
     /* 1214036 */   // Label 17623: @1214036
     /* 1214036 */   GIM_Try, /*On fail goto*//*Label 17624*/ GIMT_Encode4(1214116), // Rule ID 17446 //
     /* 1214041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214080 */     // MIs[0] round
     /* 1214080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214090 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1214093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214115 */     // GIR_Coverage, 17446,
     /* 1214115 */     GIR_EraseRootFromParent_Done,
     /* 1214116 */   // Label 17624: @1214116
     /* 1214116 */   GIM_Try, /*On fail goto*//*Label 17625*/ GIMT_Encode4(1214196), // Rule ID 17447 //
     /* 1214121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214160 */     // MIs[0] round
     /* 1214160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214170 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1214173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214195 */     // GIR_Coverage, 17447,
     /* 1214195 */     GIR_EraseRootFromParent_Done,
     /* 1214196 */   // Label 17625: @1214196
     /* 1214196 */   GIM_Try, /*On fail goto*//*Label 17626*/ GIMT_Encode4(1214276), // Rule ID 17450 //
     /* 1214201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214240 */     // MIs[0] round
     /* 1214240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214250 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1214253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214275 */     // GIR_Coverage, 17450,
     /* 1214275 */     GIR_EraseRootFromParent_Done,
     /* 1214276 */   // Label 17626: @1214276
     /* 1214276 */   GIM_Try, /*On fail goto*//*Label 17627*/ GIMT_Encode4(1214356), // Rule ID 17451 //
     /* 1214281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1214284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214320 */     // MIs[0] round
     /* 1214320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214330 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1214333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214355 */     // GIR_Coverage, 17451,
     /* 1214355 */     GIR_EraseRootFromParent_Done,
     /* 1214356 */   // Label 17627: @1214356
     /* 1214356 */   GIM_Try, /*On fail goto*//*Label 17628*/ GIMT_Encode4(1214436), // Rule ID 17454 //
     /* 1214361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214400 */     // MIs[0] round
     /* 1214400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214410 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214435 */     // GIR_Coverage, 17454,
     /* 1214435 */     GIR_EraseRootFromParent_Done,
     /* 1214436 */   // Label 17628: @1214436
     /* 1214436 */   GIM_Try, /*On fail goto*//*Label 17629*/ GIMT_Encode4(1214516), // Rule ID 17455 //
     /* 1214441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214480 */     // MIs[0] round
     /* 1214480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214490 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1214493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214515 */     // GIR_Coverage, 17455,
     /* 1214515 */     GIR_EraseRootFromParent_Done,
     /* 1214516 */   // Label 17629: @1214516
     /* 1214516 */   GIM_Try, /*On fail goto*//*Label 17630*/ GIMT_Encode4(1214596), // Rule ID 17458 //
     /* 1214521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214560 */     // MIs[0] round
     /* 1214560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1214573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214595 */     // GIR_Coverage, 17458,
     /* 1214595 */     GIR_EraseRootFromParent_Done,
     /* 1214596 */   // Label 17630: @1214596
     /* 1214596 */   GIM_Try, /*On fail goto*//*Label 17631*/ GIMT_Encode4(1214676), // Rule ID 17459 //
     /* 1214601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1214604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214640 */     // MIs[0] round
     /* 1214640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1214653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214675 */     // GIR_Coverage, 17459,
     /* 1214675 */     GIR_EraseRootFromParent_Done,
     /* 1214676 */   // Label 17631: @1214676
     /* 1214676 */   GIM_Try, /*On fail goto*//*Label 17632*/ GIMT_Encode4(1214756), // Rule ID 17462 //
     /* 1214681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1214684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1214701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1214720 */     // MIs[0] round
     /* 1214720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214730 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1214733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214755 */     // GIR_Coverage, 17462,
     /* 1214755 */     GIR_EraseRootFromParent_Done,
     /* 1214756 */   // Label 17632: @1214756
     /* 1214756 */   GIM_Try, /*On fail goto*//*Label 17633*/ GIMT_Encode4(1214836), // Rule ID 17463 //
     /* 1214761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1214764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1214781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1214800 */     // MIs[0] round
     /* 1214800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214810 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1214813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214835 */     // GIR_Coverage, 17463,
     /* 1214835 */     GIR_EraseRootFromParent_Done,
     /* 1214836 */   // Label 17633: @1214836
     /* 1214836 */   GIM_Try, /*On fail goto*//*Label 17634*/ GIMT_Encode4(1214916), // Rule ID 17466 //
     /* 1214841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1214852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1214855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1214858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214880 */     // MIs[0] round
     /* 1214880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214890 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1214893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214915 */     // GIR_Coverage, 17466,
     /* 1214915 */     GIR_EraseRootFromParent_Done,
     /* 1214916 */   // Label 17634: @1214916
     /* 1214916 */   GIM_Try, /*On fail goto*//*Label 17635*/ GIMT_Encode4(1214996), // Rule ID 17467 //
     /* 1214921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1214929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1214932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1214935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1214938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1214956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214960 */     // MIs[0] round
     /* 1214960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214970 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1214973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214995 */     // GIR_Coverage, 17467,
     /* 1214995 */     GIR_EraseRootFromParent_Done,
     /* 1214996 */   // Label 17635: @1214996
     /* 1214996 */   GIM_Try, /*On fail goto*//*Label 17636*/ GIMT_Encode4(1215076), // Rule ID 17470 //
     /* 1215001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215040 */     // MIs[0] round
     /* 1215040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215050 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1215053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215075 */     // GIR_Coverage, 17470,
     /* 1215075 */     GIR_EraseRootFromParent_Done,
     /* 1215076 */   // Label 17636: @1215076
     /* 1215076 */   GIM_Try, /*On fail goto*//*Label 17637*/ GIMT_Encode4(1215156), // Rule ID 17471 //
     /* 1215081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215120 */     // MIs[0] round
     /* 1215120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215130 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1215133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215155 */     // GIR_Coverage, 17471,
     /* 1215155 */     GIR_EraseRootFromParent_Done,
     /* 1215156 */   // Label 17637: @1215156
     /* 1215156 */   GIM_Try, /*On fail goto*//*Label 17638*/ GIMT_Encode4(1215236), // Rule ID 17474 //
     /* 1215161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215200 */     // MIs[0] round
     /* 1215200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215210 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1215213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215235 */     // GIR_Coverage, 17474,
     /* 1215235 */     GIR_EraseRootFromParent_Done,
     /* 1215236 */   // Label 17638: @1215236
     /* 1215236 */   GIM_Try, /*On fail goto*//*Label 17639*/ GIMT_Encode4(1215316), // Rule ID 17475 //
     /* 1215241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215280 */     // MIs[0] round
     /* 1215280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215290 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1215293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215315 */     // GIR_Coverage, 17475,
     /* 1215315 */     GIR_EraseRootFromParent_Done,
     /* 1215316 */   // Label 17639: @1215316
     /* 1215316 */   GIM_Try, /*On fail goto*//*Label 17640*/ GIMT_Encode4(1215396), // Rule ID 17478 //
     /* 1215321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215360 */     // MIs[0] round
     /* 1215360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215395 */     // GIR_Coverage, 17478,
     /* 1215395 */     GIR_EraseRootFromParent_Done,
     /* 1215396 */   // Label 17640: @1215396
     /* 1215396 */   GIM_Try, /*On fail goto*//*Label 17641*/ GIMT_Encode4(1215476), // Rule ID 17479 //
     /* 1215401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215440 */     // MIs[0] round
     /* 1215440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215450 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1215453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215475 */     // GIR_Coverage, 17479,
     /* 1215475 */     GIR_EraseRootFromParent_Done,
     /* 1215476 */   // Label 17641: @1215476
     /* 1215476 */   GIM_Try, /*On fail goto*//*Label 17642*/ GIMT_Encode4(1215556), // Rule ID 17482 //
     /* 1215481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215520 */     // MIs[0] round
     /* 1215520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215530 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1215533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215555 */     // GIR_Coverage, 17482,
     /* 1215555 */     GIR_EraseRootFromParent_Done,
     /* 1215556 */   // Label 17642: @1215556
     /* 1215556 */   GIM_Try, /*On fail goto*//*Label 17643*/ GIMT_Encode4(1215636), // Rule ID 17483 //
     /* 1215561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215600 */     // MIs[0] round
     /* 1215600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215610 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1215613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215635 */     // GIR_Coverage, 17483,
     /* 1215635 */     GIR_EraseRootFromParent_Done,
     /* 1215636 */   // Label 17643: @1215636
     /* 1215636 */   GIM_Try, /*On fail goto*//*Label 17644*/ GIMT_Encode4(1215716), // Rule ID 17486 //
     /* 1215641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1215652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1215655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1215658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215680 */     // MIs[0] round
     /* 1215680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215690 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1215693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215715 */     // GIR_Coverage, 17486,
     /* 1215715 */     GIR_EraseRootFromParent_Done,
     /* 1215716 */   // Label 17644: @1215716
     /* 1215716 */   GIM_Try, /*On fail goto*//*Label 17645*/ GIMT_Encode4(1215796), // Rule ID 17487 //
     /* 1215721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1215732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1215735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1215738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215760 */     // MIs[0] round
     /* 1215760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215770 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1215773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215795 */     // GIR_Coverage, 17487,
     /* 1215795 */     GIR_EraseRootFromParent_Done,
     /* 1215796 */   // Label 17645: @1215796
     /* 1215796 */   GIM_Try, /*On fail goto*//*Label 17646*/ GIMT_Encode4(1215876), // Rule ID 17490 //
     /* 1215801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1215812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1215815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1215818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215840 */     // MIs[0] round
     /* 1215840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215850 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1215853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215875 */     // GIR_Coverage, 17490,
     /* 1215875 */     GIR_EraseRootFromParent_Done,
     /* 1215876 */   // Label 17646: @1215876
     /* 1215876 */   GIM_Try, /*On fail goto*//*Label 17647*/ GIMT_Encode4(1215956), // Rule ID 17491 //
     /* 1215881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1215884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1215892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1215895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1215898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215920 */     // MIs[0] round
     /* 1215920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215930 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1215933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1215951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215955 */     // GIR_Coverage, 17491,
     /* 1215955 */     GIR_EraseRootFromParent_Done,
     /* 1215956 */   // Label 17647: @1215956
     /* 1215956 */   GIM_Try, /*On fail goto*//*Label 17648*/ GIMT_Encode4(1216036), // Rule ID 17494 //
     /* 1215961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1215969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1215972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1215975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1215978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216000 */     // MIs[0] round
     /* 1216000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216010 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1216013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216035 */     // GIR_Coverage, 17494,
     /* 1216035 */     GIR_EraseRootFromParent_Done,
     /* 1216036 */   // Label 17648: @1216036
     /* 1216036 */   GIM_Try, /*On fail goto*//*Label 17649*/ GIMT_Encode4(1216116), // Rule ID 17495 //
     /* 1216041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1216052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1216055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1216058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216080 */     // MIs[0] round
     /* 1216080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216090 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1216093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216115 */     // GIR_Coverage, 17495,
     /* 1216115 */     GIR_EraseRootFromParent_Done,
     /* 1216116 */   // Label 17649: @1216116
     /* 1216116 */   GIM_Try, /*On fail goto*//*Label 17650*/ GIMT_Encode4(1216196), // Rule ID 17498 //
     /* 1216121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216160 */     // MIs[0] round
     /* 1216160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216170 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1216173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216195 */     // GIR_Coverage, 17498,
     /* 1216195 */     GIR_EraseRootFromParent_Done,
     /* 1216196 */   // Label 17650: @1216196
     /* 1216196 */   GIM_Try, /*On fail goto*//*Label 17651*/ GIMT_Encode4(1216276), // Rule ID 17499 //
     /* 1216201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1216209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216240 */     // MIs[0] round
     /* 1216240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216250 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1216253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216275 */     // GIR_Coverage, 17499,
     /* 1216275 */     GIR_EraseRootFromParent_Done,
     /* 1216276 */   // Label 17651: @1216276
     /* 1216276 */   GIM_Try, /*On fail goto*//*Label 17652*/ GIMT_Encode4(1216356), // Rule ID 17502 //
     /* 1216281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1216301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216320 */     // MIs[0] round
     /* 1216320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216330 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216355 */     // GIR_Coverage, 17502,
     /* 1216355 */     GIR_EraseRootFromParent_Done,
     /* 1216356 */   // Label 17652: @1216356
     /* 1216356 */   GIM_Try, /*On fail goto*//*Label 17653*/ GIMT_Encode4(1216436), // Rule ID 17503 //
     /* 1216361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1216381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216400 */     // MIs[0] round
     /* 1216400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216410 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1216413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216435 */     // GIR_Coverage, 17503,
     /* 1216435 */     GIR_EraseRootFromParent_Done,
     /* 1216436 */   // Label 17653: @1216436
     /* 1216436 */   GIM_Try, /*On fail goto*//*Label 17654*/ GIMT_Encode4(1216516), // Rule ID 17506 //
     /* 1216441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1216461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216480 */     // MIs[0] round
     /* 1216480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216490 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1216493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216515 */     // GIR_Coverage, 17506,
     /* 1216515 */     GIR_EraseRootFromParent_Done,
     /* 1216516 */   // Label 17654: @1216516
     /* 1216516 */   GIM_Try, /*On fail goto*//*Label 17655*/ GIMT_Encode4(1216596), // Rule ID 17507 //
     /* 1216521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1216541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216560 */     // MIs[0] round
     /* 1216560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216570 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1216573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216595 */     // GIR_Coverage, 17507,
     /* 1216595 */     GIR_EraseRootFromParent_Done,
     /* 1216596 */   // Label 17655: @1216596
     /* 1216596 */   GIM_Try, /*On fail goto*//*Label 17656*/ GIMT_Encode4(1216676), // Rule ID 17510 //
     /* 1216601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1216612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1216615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1216618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1216621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216640 */     // MIs[0] round
     /* 1216640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216650 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1216653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216675 */     // GIR_Coverage, 17510,
     /* 1216675 */     GIR_EraseRootFromParent_Done,
     /* 1216676 */   // Label 17656: @1216676
     /* 1216676 */   GIM_Try, /*On fail goto*//*Label 17657*/ GIMT_Encode4(1216756), // Rule ID 17511 //
     /* 1216681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1216692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1216695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1216698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1216701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216720 */     // MIs[0] round
     /* 1216720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216730 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1216733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216755 */     // GIR_Coverage, 17511,
     /* 1216755 */     GIR_EraseRootFromParent_Done,
     /* 1216756 */   // Label 17657: @1216756
     /* 1216756 */   GIM_Try, /*On fail goto*//*Label 17658*/ GIMT_Encode4(1216836), // Rule ID 17514 //
     /* 1216761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1216772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1216775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1216781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216800 */     // MIs[0] round
     /* 1216800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216810 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1216813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216835 */     // GIR_Coverage, 17514,
     /* 1216835 */     GIR_EraseRootFromParent_Done,
     /* 1216836 */   // Label 17658: @1216836
     /* 1216836 */   GIM_Try, /*On fail goto*//*Label 17659*/ GIMT_Encode4(1216916), // Rule ID 17515 //
     /* 1216841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1216852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1216855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1216861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216880 */     // MIs[0] round
     /* 1216880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216890 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1216893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216915 */     // GIR_Coverage, 17515,
     /* 1216915 */     GIR_EraseRootFromParent_Done,
     /* 1216916 */   // Label 17659: @1216916
     /* 1216916 */   GIM_Try, /*On fail goto*//*Label 17660*/ GIMT_Encode4(1216996), // Rule ID 17518 //
     /* 1216921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1216932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1216935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1216938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1216941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216960 */     // MIs[0] round
     /* 1216960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216970 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1216973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216995 */     // GIR_Coverage, 17518,
     /* 1216995 */     GIR_EraseRootFromParent_Done,
     /* 1216996 */   // Label 17660: @1216996
     /* 1216996 */   GIM_Try, /*On fail goto*//*Label 17661*/ GIMT_Encode4(1217076), // Rule ID 17519 //
     /* 1217001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1217012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1217015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1217018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1217021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217040 */     // MIs[0] round
     /* 1217040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217050 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1217053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217075 */     // GIR_Coverage, 17519,
     /* 1217075 */     GIR_EraseRootFromParent_Done,
     /* 1217076 */   // Label 17661: @1217076
     /* 1217076 */   GIM_Try, /*On fail goto*//*Label 17662*/ GIMT_Encode4(1217156), // Rule ID 17522 //
     /* 1217081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1217084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1217101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217120 */     // MIs[0] round
     /* 1217120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217130 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1217133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217155 */     // GIR_Coverage, 17522,
     /* 1217155 */     GIR_EraseRootFromParent_Done,
     /* 1217156 */   // Label 17662: @1217156
     /* 1217156 */   GIM_Try, /*On fail goto*//*Label 17663*/ GIMT_Encode4(1217236), // Rule ID 17523 //
     /* 1217161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1217164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1217181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217200 */     // MIs[0] round
     /* 1217200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217210 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1217213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217235 */     // GIR_Coverage, 17523,
     /* 1217235 */     GIR_EraseRootFromParent_Done,
     /* 1217236 */   // Label 17663: @1217236
     /* 1217236 */   GIM_Try, /*On fail goto*//*Label 17664*/ GIMT_Encode4(1217316), // Rule ID 17526 //
     /* 1217241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217280 */     // MIs[0] round
     /* 1217280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217290 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1217293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217315 */     // GIR_Coverage, 17526,
     /* 1217315 */     GIR_EraseRootFromParent_Done,
     /* 1217316 */   // Label 17664: @1217316
     /* 1217316 */   GIM_Try, /*On fail goto*//*Label 17665*/ GIMT_Encode4(1217396), // Rule ID 17527 //
     /* 1217321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1217341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217360 */     // MIs[0] round
     /* 1217360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217370 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1217373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217395 */     // GIR_Coverage, 17527,
     /* 1217395 */     GIR_EraseRootFromParent_Done,
     /* 1217396 */   // Label 17665: @1217396
     /* 1217396 */   GIM_Try, /*On fail goto*//*Label 17666*/ GIMT_Encode4(1217476), // Rule ID 17530 //
     /* 1217401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217440 */     // MIs[0] round
     /* 1217440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217450 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1217453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217475 */     // GIR_Coverage, 17530,
     /* 1217475 */     GIR_EraseRootFromParent_Done,
     /* 1217476 */   // Label 17666: @1217476
     /* 1217476 */   GIM_Try, /*On fail goto*//*Label 17667*/ GIMT_Encode4(1217556), // Rule ID 17531 //
     /* 1217481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1217501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217520 */     // MIs[0] round
     /* 1217520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217530 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1217533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217555 */     // GIR_Coverage, 17531,
     /* 1217555 */     GIR_EraseRootFromParent_Done,
     /* 1217556 */   // Label 17667: @1217556
     /* 1217556 */   GIM_Try, /*On fail goto*//*Label 17668*/ GIMT_Encode4(1217636), // Rule ID 17534 //
     /* 1217561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1217572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1217575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1217581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217600 */     // MIs[0] round
     /* 1217600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217610 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1217613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217635 */     // GIR_Coverage, 17534,
     /* 1217635 */     GIR_EraseRootFromParent_Done,
     /* 1217636 */   // Label 17668: @1217636
     /* 1217636 */   GIM_Try, /*On fail goto*//*Label 17669*/ GIMT_Encode4(1217716), // Rule ID 17535 //
     /* 1217641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1217652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1217655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1217661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217680 */     // MIs[0] round
     /* 1217680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217690 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1217693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217715 */     // GIR_Coverage, 17535,
     /* 1217715 */     GIR_EraseRootFromParent_Done,
     /* 1217716 */   // Label 17669: @1217716
     /* 1217716 */   GIM_Try, /*On fail goto*//*Label 17670*/ GIMT_Encode4(1217796), // Rule ID 17538 //
     /* 1217721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1217732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1217735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1217741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217760 */     // MIs[0] round
     /* 1217760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217770 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1217773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217795 */     // GIR_Coverage, 17538,
     /* 1217795 */     GIR_EraseRootFromParent_Done,
     /* 1217796 */   // Label 17670: @1217796
     /* 1217796 */   GIM_Try, /*On fail goto*//*Label 17671*/ GIMT_Encode4(1217876), // Rule ID 17539 //
     /* 1217801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1217812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1217815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1217821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217840 */     // MIs[0] round
     /* 1217840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217850 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1217853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217875 */     // GIR_Coverage, 17539,
     /* 1217875 */     GIR_EraseRootFromParent_Done,
     /* 1217876 */   // Label 17671: @1217876
     /* 1217876 */   GIM_Try, /*On fail goto*//*Label 17672*/ GIMT_Encode4(1217956), // Rule ID 17542 //
     /* 1217881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1217892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1217895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1217898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1217901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217920 */     // MIs[0] round
     /* 1217920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217930 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1217933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217955 */     // GIR_Coverage, 17542,
     /* 1217955 */     GIR_EraseRootFromParent_Done,
     /* 1217956 */   // Label 17672: @1217956
     /* 1217956 */   GIM_Try, /*On fail goto*//*Label 17673*/ GIMT_Encode4(1218036), // Rule ID 17543 //
     /* 1217961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1217969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1217972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1217975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1217978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1217981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218000 */     // MIs[0] round
     /* 1218000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218010 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1218013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218035 */     // GIR_Coverage, 17543,
     /* 1218035 */     GIR_EraseRootFromParent_Done,
     /* 1218036 */   // Label 17673: @1218036
     /* 1218036 */   GIM_Try, /*On fail goto*//*Label 17674*/ GIMT_Encode4(1218116), // Rule ID 17546 //
     /* 1218041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1218061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218080 */     // MIs[0] round
     /* 1218080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218090 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1218093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218115 */     // GIR_Coverage, 17546,
     /* 1218115 */     GIR_EraseRootFromParent_Done,
     /* 1218116 */   // Label 17674: @1218116
     /* 1218116 */   GIM_Try, /*On fail goto*//*Label 17675*/ GIMT_Encode4(1218196), // Rule ID 17547 //
     /* 1218121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1218141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218160 */     // MIs[0] round
     /* 1218160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218170 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1218173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218195 */     // GIR_Coverage, 17547,
     /* 1218195 */     GIR_EraseRootFromParent_Done,
     /* 1218196 */   // Label 17675: @1218196
     /* 1218196 */   GIM_Try, /*On fail goto*//*Label 17676*/ GIMT_Encode4(1218276), // Rule ID 17550 //
     /* 1218201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218240 */     // MIs[0] round
     /* 1218240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1218253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218275 */     // GIR_Coverage, 17550,
     /* 1218275 */     GIR_EraseRootFromParent_Done,
     /* 1218276 */   // Label 17676: @1218276
     /* 1218276 */   GIM_Try, /*On fail goto*//*Label 17677*/ GIMT_Encode4(1218356), // Rule ID 17551 //
     /* 1218281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1218301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218320 */     // MIs[0] round
     /* 1218320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218330 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1218333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218355 */     // GIR_Coverage, 17551,
     /* 1218355 */     GIR_EraseRootFromParent_Done,
     /* 1218356 */   // Label 17677: @1218356
     /* 1218356 */   GIM_Try, /*On fail goto*//*Label 17678*/ GIMT_Encode4(1218436), // Rule ID 17554 //
     /* 1218361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218400 */     // MIs[0] round
     /* 1218400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218410 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218435 */     // GIR_Coverage, 17554,
     /* 1218435 */     GIR_EraseRootFromParent_Done,
     /* 1218436 */   // Label 17678: @1218436
     /* 1218436 */   GIM_Try, /*On fail goto*//*Label 17679*/ GIMT_Encode4(1218516), // Rule ID 17555 //
     /* 1218441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1218461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218480 */     // MIs[0] round
     /* 1218480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218490 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1218493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218515 */     // GIR_Coverage, 17555,
     /* 1218515 */     GIR_EraseRootFromParent_Done,
     /* 1218516 */   // Label 17679: @1218516
     /* 1218516 */   GIM_Try, /*On fail goto*//*Label 17680*/ GIMT_Encode4(1218596), // Rule ID 17558 //
     /* 1218521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1218532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1218535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1218541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218560 */     // MIs[0] round
     /* 1218560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218570 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1218573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218595 */     // GIR_Coverage, 17558,
     /* 1218595 */     GIR_EraseRootFromParent_Done,
     /* 1218596 */   // Label 17680: @1218596
     /* 1218596 */   GIM_Try, /*On fail goto*//*Label 17681*/ GIMT_Encode4(1218676), // Rule ID 17559 //
     /* 1218601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1218612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1218615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1218621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218640 */     // MIs[0] round
     /* 1218640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218650 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1218653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218675 */     // GIR_Coverage, 17559,
     /* 1218675 */     GIR_EraseRootFromParent_Done,
     /* 1218676 */   // Label 17681: @1218676
     /* 1218676 */   GIM_Try, /*On fail goto*//*Label 17682*/ GIMT_Encode4(1218756), // Rule ID 17562 //
     /* 1218681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1218692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1218695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1218698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218720 */     // MIs[0] round
     /* 1218720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218730 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1218733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218755 */     // GIR_Coverage, 17562,
     /* 1218755 */     GIR_EraseRootFromParent_Done,
     /* 1218756 */   // Label 17682: @1218756
     /* 1218756 */   GIM_Try, /*On fail goto*//*Label 17683*/ GIMT_Encode4(1218836), // Rule ID 17563 //
     /* 1218761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1218772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1218775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1218778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218800 */     // MIs[0] round
     /* 1218800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218810 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1218813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218835 */     // GIR_Coverage, 17563,
     /* 1218835 */     GIR_EraseRootFromParent_Done,
     /* 1218836 */   // Label 17683: @1218836
     /* 1218836 */   GIM_Try, /*On fail goto*//*Label 17684*/ GIMT_Encode4(1218916), // Rule ID 17566 //
     /* 1218841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1218844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1218852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1218855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1218858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218880 */     // MIs[0] round
     /* 1218880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218890 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1218893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218915 */     // GIR_Coverage, 17566,
     /* 1218915 */     GIR_EraseRootFromParent_Done,
     /* 1218916 */   // Label 17684: @1218916
     /* 1218916 */   GIM_Try, /*On fail goto*//*Label 17685*/ GIMT_Encode4(1218996), // Rule ID 17567 //
     /* 1218921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1218924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1218929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1218932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1218935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1218938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1218941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1218960 */     // MIs[0] round
     /* 1218960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218970 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1218973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218995 */     // GIR_Coverage, 17567,
     /* 1218995 */     GIR_EraseRootFromParent_Done,
     /* 1218996 */   // Label 17685: @1218996
     /* 1218996 */   GIM_Try, /*On fail goto*//*Label 17686*/ GIMT_Encode4(1219076), // Rule ID 17570 //
     /* 1219001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219040 */     // MIs[0] round
     /* 1219040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219050 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1219053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219075 */     // GIR_Coverage, 17570,
     /* 1219075 */     GIR_EraseRootFromParent_Done,
     /* 1219076 */   // Label 17686: @1219076
     /* 1219076 */   GIM_Try, /*On fail goto*//*Label 17687*/ GIMT_Encode4(1219156), // Rule ID 17571 //
     /* 1219081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1219092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1219095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219120 */     // MIs[0] round
     /* 1219120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219130 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1219133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219155 */     // GIR_Coverage, 17571,
     /* 1219155 */     GIR_EraseRootFromParent_Done,
     /* 1219156 */   // Label 17687: @1219156
     /* 1219156 */   GIM_Try, /*On fail goto*//*Label 17688*/ GIMT_Encode4(1219236), // Rule ID 17574 //
     /* 1219161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219200 */     // MIs[0] round
     /* 1219200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219210 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1219213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219235 */     // GIR_Coverage, 17574,
     /* 1219235 */     GIR_EraseRootFromParent_Done,
     /* 1219236 */   // Label 17688: @1219236
     /* 1219236 */   GIM_Try, /*On fail goto*//*Label 17689*/ GIMT_Encode4(1219316), // Rule ID 17575 //
     /* 1219241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1219252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1219255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219280 */     // MIs[0] round
     /* 1219280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219290 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1219293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219315 */     // GIR_Coverage, 17575,
     /* 1219315 */     GIR_EraseRootFromParent_Done,
     /* 1219316 */   // Label 17689: @1219316
     /* 1219316 */   GIM_Try, /*On fail goto*//*Label 17690*/ GIMT_Encode4(1219396), // Rule ID 17578 //
     /* 1219321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1219324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219360 */     // MIs[0] round
     /* 1219360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219370 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219395 */     // GIR_Coverage, 17578,
     /* 1219395 */     GIR_EraseRootFromParent_Done,
     /* 1219396 */   // Label 17690: @1219396
     /* 1219396 */   GIM_Try, /*On fail goto*//*Label 17691*/ GIMT_Encode4(1219476), // Rule ID 17579 //
     /* 1219401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1219404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1219421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1219440 */     // MIs[0] round
     /* 1219440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219450 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1219453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219475 */     // GIR_Coverage, 17579,
     /* 1219475 */     GIR_EraseRootFromParent_Done,
     /* 1219476 */   // Label 17691: @1219476
     /* 1219476 */   GIM_Try, /*On fail goto*//*Label 17692*/ GIMT_Encode4(1219556), // Rule ID 17582 //
     /* 1219481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1219484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1219498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219520 */     // MIs[0] round
     /* 1219520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219530 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1219533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219555 */     // GIR_Coverage, 17582,
     /* 1219555 */     GIR_EraseRootFromParent_Done,
     /* 1219556 */   // Label 17692: @1219556
     /* 1219556 */   GIM_Try, /*On fail goto*//*Label 17693*/ GIMT_Encode4(1219636), // Rule ID 17583 //
     /* 1219561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1219564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1219578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1219581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1219600 */     // MIs[0] round
     /* 1219600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219610 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1219613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1219631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219635 */     // GIR_Coverage, 17583,
     /* 1219635 */     GIR_EraseRootFromParent_Done,
     /* 1219636 */   // Label 17693: @1219636
     /* 1219636 */   GIM_Try, /*On fail goto*//*Label 17694*/ GIMT_Encode4(1219716), // Rule ID 17586 //
     /* 1219641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1219652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1219655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1219658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219680 */     // MIs[0] round
     /* 1219680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219690 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1219693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219715 */     // GIR_Coverage, 17586,
     /* 1219715 */     GIR_EraseRootFromParent_Done,
     /* 1219716 */   // Label 17694: @1219716
     /* 1219716 */   GIM_Try, /*On fail goto*//*Label 17695*/ GIMT_Encode4(1219796), // Rule ID 17587 //
     /* 1219721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1219732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1219735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1219738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219760 */     // MIs[0] round
     /* 1219760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219770 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1219773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219795 */     // GIR_Coverage, 17587,
     /* 1219795 */     GIR_EraseRootFromParent_Done,
     /* 1219796 */   // Label 17695: @1219796
     /* 1219796 */   GIM_Try, /*On fail goto*//*Label 17696*/ GIMT_Encode4(1219876), // Rule ID 17590 //
     /* 1219801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1219812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1219815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1219818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219840 */     // MIs[0] round
     /* 1219840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219850 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1219853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219875 */     // GIR_Coverage, 17590,
     /* 1219875 */     GIR_EraseRootFromParent_Done,
     /* 1219876 */   // Label 17696: @1219876
     /* 1219876 */   GIM_Try, /*On fail goto*//*Label 17697*/ GIMT_Encode4(1219956), // Rule ID 17591 //
     /* 1219881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1219884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1219892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1219895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1219898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1219920 */     // MIs[0] round
     /* 1219920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219930 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1219933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219955 */     // GIR_Coverage, 17591,
     /* 1219955 */     GIR_EraseRootFromParent_Done,
     /* 1219956 */   // Label 17697: @1219956
     /* 1219956 */   GIM_Try, /*On fail goto*//*Label 17698*/ GIMT_Encode4(1220036), // Rule ID 17594 //
     /* 1219961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1219964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1219969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1219972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1219975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1219978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1219981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220000 */     // MIs[0] round
     /* 1220000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220010 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1220013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220035 */     // GIR_Coverage, 17594,
     /* 1220035 */     GIR_EraseRootFromParent_Done,
     /* 1220036 */   // Label 17698: @1220036
     /* 1220036 */   GIM_Try, /*On fail goto*//*Label 17699*/ GIMT_Encode4(1220116), // Rule ID 17595 //
     /* 1220041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1220044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1220052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1220055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1220058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220080 */     // MIs[0] round
     /* 1220080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220090 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1220093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220115 */     // GIR_Coverage, 17595,
     /* 1220115 */     GIR_EraseRootFromParent_Done,
     /* 1220116 */   // Label 17699: @1220116
     /* 1220116 */   GIM_Try, /*On fail goto*//*Label 17700*/ GIMT_Encode4(1220196), // Rule ID 17598 //
     /* 1220121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1220138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220160 */     // MIs[0] round
     /* 1220160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220170 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1220173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220195 */     // GIR_Coverage, 17598,
     /* 1220195 */     GIR_EraseRootFromParent_Done,
     /* 1220196 */   // Label 17700: @1220196
     /* 1220196 */   GIM_Try, /*On fail goto*//*Label 17701*/ GIMT_Encode4(1220276), // Rule ID 17599 //
     /* 1220201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1220218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220240 */     // MIs[0] round
     /* 1220240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220250 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1220253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220275 */     // GIR_Coverage, 17599,
     /* 1220275 */     GIR_EraseRootFromParent_Done,
     /* 1220276 */   // Label 17701: @1220276
     /* 1220276 */   GIM_Try, /*On fail goto*//*Label 17702*/ GIMT_Encode4(1220356), // Rule ID 17602 //
     /* 1220281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220320 */     // MIs[0] round
     /* 1220320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220330 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220355 */     // GIR_Coverage, 17602,
     /* 1220355 */     GIR_EraseRootFromParent_Done,
     /* 1220356 */   // Label 17702: @1220356
     /* 1220356 */   GIM_Try, /*On fail goto*//*Label 17703*/ GIMT_Encode4(1220436), // Rule ID 17603 //
     /* 1220361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220400 */     // MIs[0] round
     /* 1220400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220410 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1220413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220435 */     // GIR_Coverage, 17603,
     /* 1220435 */     GIR_EraseRootFromParent_Done,
     /* 1220436 */   // Label 17703: @1220436
     /* 1220436 */   GIM_Try, /*On fail goto*//*Label 17704*/ GIMT_Encode4(1220516), // Rule ID 17606 //
     /* 1220441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1220444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1220458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220480 */     // MIs[0] round
     /* 1220480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220490 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1220493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220515 */     // GIR_Coverage, 17606,
     /* 1220515 */     GIR_EraseRootFromParent_Done,
     /* 1220516 */   // Label 17704: @1220516
     /* 1220516 */   GIM_Try, /*On fail goto*//*Label 17705*/ GIMT_Encode4(1220596), // Rule ID 17607 //
     /* 1220521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1220524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1220538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1220541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1220560 */     // MIs[0] round
     /* 1220560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220570 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1220573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220595 */     // GIR_Coverage, 17607,
     /* 1220595 */     GIR_EraseRootFromParent_Done,
     /* 1220596 */   // Label 17705: @1220596
     /* 1220596 */   GIM_Try, /*On fail goto*//*Label 17706*/ GIMT_Encode4(1220676), // Rule ID 17610 //
     /* 1220601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1220612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1220615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1220618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220640 */     // MIs[0] round
     /* 1220640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220650 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1220653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220675 */     // GIR_Coverage, 17610,
     /* 1220675 */     GIR_EraseRootFromParent_Done,
     /* 1220676 */   // Label 17706: @1220676
     /* 1220676 */   GIM_Try, /*On fail goto*//*Label 17707*/ GIMT_Encode4(1220756), // Rule ID 17611 //
     /* 1220681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1220692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1220695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1220698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220720 */     // MIs[0] round
     /* 1220720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220730 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1220733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220755 */     // GIR_Coverage, 17611,
     /* 1220755 */     GIR_EraseRootFromParent_Done,
     /* 1220756 */   // Label 17707: @1220756
     /* 1220756 */   GIM_Try, /*On fail goto*//*Label 17708*/ GIMT_Encode4(1220836), // Rule ID 17614 //
     /* 1220761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1220772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1220775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1220778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220800 */     // MIs[0] round
     /* 1220800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220810 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1220813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220835 */     // GIR_Coverage, 17614,
     /* 1220835 */     GIR_EraseRootFromParent_Done,
     /* 1220836 */   // Label 17708: @1220836
     /* 1220836 */   GIM_Try, /*On fail goto*//*Label 17709*/ GIMT_Encode4(1220916), // Rule ID 17615 //
     /* 1220841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1220844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1220852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1220855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1220858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220880 */     // MIs[0] round
     /* 1220880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220890 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1220893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220915 */     // GIR_Coverage, 17615,
     /* 1220915 */     GIR_EraseRootFromParent_Done,
     /* 1220916 */   // Label 17709: @1220916
     /* 1220916 */   GIM_Try, /*On fail goto*//*Label 17710*/ GIMT_Encode4(1220996), // Rule ID 17618 //
     /* 1220921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1220924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1220929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1220932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1220935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1220938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1220941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1220960 */     // MIs[0] round
     /* 1220960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220970 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1220973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1220991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220995 */     // GIR_Coverage, 17618,
     /* 1220995 */     GIR_EraseRootFromParent_Done,
     /* 1220996 */   // Label 17710: @1220996
     /* 1220996 */   GIM_Try, /*On fail goto*//*Label 17711*/ GIMT_Encode4(1221076), // Rule ID 17619 //
     /* 1221001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1221009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1221012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1221015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1221018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221040 */     // MIs[0] round
     /* 1221040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221050 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1221053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221075 */     // GIR_Coverage, 17619,
     /* 1221075 */     GIR_EraseRootFromParent_Done,
     /* 1221076 */   // Label 17711: @1221076
     /* 1221076 */   GIM_Try, /*On fail goto*//*Label 17712*/ GIMT_Encode4(1221156), // Rule ID 17622 //
     /* 1221081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1221092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1221095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1221098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221120 */     // MIs[0] round
     /* 1221120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221130 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1221133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221155 */     // GIR_Coverage, 17622,
     /* 1221155 */     GIR_EraseRootFromParent_Done,
     /* 1221156 */   // Label 17712: @1221156
     /* 1221156 */   GIM_Try, /*On fail goto*//*Label 17713*/ GIMT_Encode4(1221236), // Rule ID 17623 //
     /* 1221161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1221172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1221175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1221178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221200 */     // MIs[0] round
     /* 1221200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221210 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1221213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221235 */     // GIR_Coverage, 17623,
     /* 1221235 */     GIR_EraseRootFromParent_Done,
     /* 1221236 */   // Label 17713: @1221236
     /* 1221236 */   GIM_Try, /*On fail goto*//*Label 17714*/ GIMT_Encode4(1221316), // Rule ID 17626 //
     /* 1221241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1221252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1221255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221280 */     // MIs[0] round
     /* 1221280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221290 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1221293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221315 */     // GIR_Coverage, 17626,
     /* 1221315 */     GIR_EraseRootFromParent_Done,
     /* 1221316 */   // Label 17714: @1221316
     /* 1221316 */   GIM_Try, /*On fail goto*//*Label 17715*/ GIMT_Encode4(1221396), // Rule ID 17627 //
     /* 1221321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1221332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1221335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221360 */     // MIs[0] round
     /* 1221360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221370 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1221373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221395 */     // GIR_Coverage, 17627,
     /* 1221395 */     GIR_EraseRootFromParent_Done,
     /* 1221396 */   // Label 17715: @1221396
     /* 1221396 */   GIM_Try, /*On fail goto*//*Label 17716*/ GIMT_Encode4(1221476), // Rule ID 17630 //
     /* 1221401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221440 */     // MIs[0] round
     /* 1221440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221450 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1221453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221475 */     // GIR_Coverage, 17630,
     /* 1221475 */     GIR_EraseRootFromParent_Done,
     /* 1221476 */   // Label 17716: @1221476
     /* 1221476 */   GIM_Try, /*On fail goto*//*Label 17717*/ GIMT_Encode4(1221556), // Rule ID 17631 //
     /* 1221481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1221492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1221495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221520 */     // MIs[0] round
     /* 1221520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221530 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1221533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221555 */     // GIR_Coverage, 17631,
     /* 1221555 */     GIR_EraseRootFromParent_Done,
     /* 1221556 */   // Label 17717: @1221556
     /* 1221556 */   GIM_Try, /*On fail goto*//*Label 17718*/ GIMT_Encode4(1221636), // Rule ID 17634 //
     /* 1221561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1221572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1221575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1221578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221600 */     // MIs[0] round
     /* 1221600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221610 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1221613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221635 */     // GIR_Coverage, 17634,
     /* 1221635 */     GIR_EraseRootFromParent_Done,
     /* 1221636 */   // Label 17718: @1221636
     /* 1221636 */   GIM_Try, /*On fail goto*//*Label 17719*/ GIMT_Encode4(1221716), // Rule ID 17635 //
     /* 1221641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1221652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1221655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1221658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1221661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221680 */     // MIs[0] round
     /* 1221680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221690 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11249:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1221693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221715 */     // GIR_Coverage, 17635,
     /* 1221715 */     GIR_EraseRootFromParent_Done,
     /* 1221716 */   // Label 17719: @1221716
     /* 1221716 */   GIM_Try, /*On fail goto*//*Label 17720*/ GIMT_Encode4(1221796), // Rule ID 17638 //
     /* 1221721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1221732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1221735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1221738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221760 */     // MIs[0] round
     /* 1221760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221770 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1221773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221795 */     // GIR_Coverage, 17638,
     /* 1221795 */     GIR_EraseRootFromParent_Done,
     /* 1221796 */   // Label 17720: @1221796
     /* 1221796 */   GIM_Try, /*On fail goto*//*Label 17721*/ GIMT_Encode4(1221876), // Rule ID 17639 //
     /* 1221801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1221812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1221815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1221818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221840 */     // MIs[0] round
     /* 1221840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221850 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1221853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221875 */     // GIR_Coverage, 17639,
     /* 1221875 */     GIR_EraseRootFromParent_Done,
     /* 1221876 */   // Label 17721: @1221876
     /* 1221876 */   GIM_Try, /*On fail goto*//*Label 17722*/ GIMT_Encode4(1221956), // Rule ID 17642 //
     /* 1221881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1221884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1221892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1221895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1221898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1221920 */     // MIs[0] round
     /* 1221920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221930 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1221933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1221951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221955 */     // GIR_Coverage, 17642,
     /* 1221955 */     GIR_EraseRootFromParent_Done,
     /* 1221956 */   // Label 17722: @1221956
     /* 1221956 */   GIM_Try, /*On fail goto*//*Label 17723*/ GIMT_Encode4(1222036), // Rule ID 17643 //
     /* 1221961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1221964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1221969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1221972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1221975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1221978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1221981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1222000 */     // MIs[0] round
     /* 1222000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222010 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1222013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222035 */     // GIR_Coverage, 17643,
     /* 1222035 */     GIR_EraseRootFromParent_Done,
     /* 1222036 */   // Label 17723: @1222036
     /* 1222036 */   GIM_Try, /*On fail goto*//*Label 17724*/ GIMT_Encode4(1222116), // Rule ID 17646 //
     /* 1222041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1222052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1222055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222080 */     // MIs[0] round
     /* 1222080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222090 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1222093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222115 */     // GIR_Coverage, 17646,
     /* 1222115 */     GIR_EraseRootFromParent_Done,
     /* 1222116 */   // Label 17724: @1222116
     /* 1222116 */   GIM_Try, /*On fail goto*//*Label 17725*/ GIMT_Encode4(1222196), // Rule ID 17647 //
     /* 1222121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1222132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1222135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222160 */     // MIs[0] round
     /* 1222160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222170 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1222173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222195 */     // GIR_Coverage, 17647,
     /* 1222195 */     GIR_EraseRootFromParent_Done,
     /* 1222196 */   // Label 17725: @1222196
     /* 1222196 */   GIM_Try, /*On fail goto*//*Label 17726*/ GIMT_Encode4(1222276), // Rule ID 17650 //
     /* 1222201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1222212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1222215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222240 */     // MIs[0] round
     /* 1222240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222250 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1222253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222275 */     // GIR_Coverage, 17650,
     /* 1222275 */     GIR_EraseRootFromParent_Done,
     /* 1222276 */   // Label 17726: @1222276
     /* 1222276 */   GIM_Try, /*On fail goto*//*Label 17727*/ GIMT_Encode4(1222356), // Rule ID 17651 //
     /* 1222281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1222292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1222295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222320 */     // MIs[0] round
     /* 1222320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222330 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1222333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222355 */     // GIR_Coverage, 17651,
     /* 1222355 */     GIR_EraseRootFromParent_Done,
     /* 1222356 */   // Label 17727: @1222356
     /* 1222356 */   GIM_Try, /*On fail goto*//*Label 17728*/ GIMT_Encode4(1222436), // Rule ID 17654 //
     /* 1222361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222400 */     // MIs[0] round
     /* 1222400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222410 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222435 */     // GIR_Coverage, 17654,
     /* 1222435 */     GIR_EraseRootFromParent_Done,
     /* 1222436 */   // Label 17728: @1222436
     /* 1222436 */   GIM_Try, /*On fail goto*//*Label 17729*/ GIMT_Encode4(1222516), // Rule ID 17655 //
     /* 1222441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1222452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1222455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1222461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1222480 */     // MIs[0] round
     /* 1222480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222490 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1222493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222515 */     // GIR_Coverage, 17655,
     /* 1222515 */     GIR_EraseRootFromParent_Done,
     /* 1222516 */   // Label 17729: @1222516
     /* 1222516 */   GIM_Try, /*On fail goto*//*Label 17730*/ GIMT_Encode4(1222596), // Rule ID 17658 //
     /* 1222521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1222532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1222535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1222538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222560 */     // MIs[0] round
     /* 1222560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222570 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1222573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222595 */     // GIR_Coverage, 17658,
     /* 1222595 */     GIR_EraseRootFromParent_Done,
     /* 1222596 */   // Label 17730: @1222596
     /* 1222596 */   GIM_Try, /*On fail goto*//*Label 17731*/ GIMT_Encode4(1222676), // Rule ID 17659 //
     /* 1222601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1222612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1222615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1222618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222640 */     // MIs[0] round
     /* 1222640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222650 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1222653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222675 */     // GIR_Coverage, 17659,
     /* 1222675 */     GIR_EraseRootFromParent_Done,
     /* 1222676 */   // Label 17731: @1222676
     /* 1222676 */   GIM_Try, /*On fail goto*//*Label 17732*/ GIMT_Encode4(1222756), // Rule ID 17662 //
     /* 1222681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1222692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1222695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1222698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222720 */     // MIs[0] round
     /* 1222720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222730 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1222733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222755 */     // GIR_Coverage, 17662,
     /* 1222755 */     GIR_EraseRootFromParent_Done,
     /* 1222756 */   // Label 17732: @1222756
     /* 1222756 */   GIM_Try, /*On fail goto*//*Label 17733*/ GIMT_Encode4(1222836), // Rule ID 17663 //
     /* 1222761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1222772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1222775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1222778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222800 */     // MIs[0] round
     /* 1222800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222810 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1222813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222835 */     // GIR_Coverage, 17663,
     /* 1222835 */     GIR_EraseRootFromParent_Done,
     /* 1222836 */   // Label 17733: @1222836
     /* 1222836 */   GIM_Try, /*On fail goto*//*Label 17734*/ GIMT_Encode4(1222916), // Rule ID 17666 //
     /* 1222841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1222852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1222855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1222858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222880 */     // MIs[0] round
     /* 1222880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222890 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1222893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222915 */     // GIR_Coverage, 17666,
     /* 1222915 */     GIR_EraseRootFromParent_Done,
     /* 1222916 */   // Label 17734: @1222916
     /* 1222916 */   GIM_Try, /*On fail goto*//*Label 17735*/ GIMT_Encode4(1222996), // Rule ID 17667 //
     /* 1222921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1222929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1222932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1222935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1222938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1222941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1222960 */     // MIs[0] round
     /* 1222960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222970 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1222973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1222977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222995 */     // GIR_Coverage, 17667,
     /* 1222995 */     GIR_EraseRootFromParent_Done,
     /* 1222996 */   // Label 17735: @1222996
     /* 1222996 */   GIM_Try, /*On fail goto*//*Label 17736*/ GIMT_Encode4(1223076), // Rule ID 17670 //
     /* 1223001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1223012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1223015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223040 */     // MIs[0] round
     /* 1223040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1223053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223075 */     // GIR_Coverage, 17670,
     /* 1223075 */     GIR_EraseRootFromParent_Done,
     /* 1223076 */   // Label 17736: @1223076
     /* 1223076 */   GIM_Try, /*On fail goto*//*Label 17737*/ GIMT_Encode4(1223156), // Rule ID 17671 //
     /* 1223081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1223092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1223095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223120 */     // MIs[0] round
     /* 1223120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223130 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1223133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223155 */     // GIR_Coverage, 17671,
     /* 1223155 */     GIR_EraseRootFromParent_Done,
     /* 1223156 */   // Label 17737: @1223156
     /* 1223156 */   GIM_Try, /*On fail goto*//*Label 17738*/ GIMT_Encode4(1223236), // Rule ID 17674 //
     /* 1223161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1223172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1223175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223200 */     // MIs[0] round
     /* 1223200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223210 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1223213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223235 */     // GIR_Coverage, 17674,
     /* 1223235 */     GIR_EraseRootFromParent_Done,
     /* 1223236 */   // Label 17738: @1223236
     /* 1223236 */   GIM_Try, /*On fail goto*//*Label 17739*/ GIMT_Encode4(1223316), // Rule ID 17675 //
     /* 1223241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1223252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1223255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223280 */     // MIs[0] round
     /* 1223280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223290 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1223293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223315 */     // GIR_Coverage, 17675,
     /* 1223315 */     GIR_EraseRootFromParent_Done,
     /* 1223316 */   // Label 17739: @1223316
     /* 1223316 */   GIM_Try, /*On fail goto*//*Label 17740*/ GIMT_Encode4(1223396), // Rule ID 17678 //
     /* 1223321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223360 */     // MIs[0] round
     /* 1223360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223370 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223395 */     // GIR_Coverage, 17678,
     /* 1223395 */     GIR_EraseRootFromParent_Done,
     /* 1223396 */   // Label 17740: @1223396
     /* 1223396 */   GIM_Try, /*On fail goto*//*Label 17741*/ GIMT_Encode4(1223476), // Rule ID 17679 //
     /* 1223401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1223409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1223412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1223415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1223421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1223440 */     // MIs[0] round
     /* 1223440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223450 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1223453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223475 */     // GIR_Coverage, 17679,
     /* 1223475 */     GIR_EraseRootFromParent_Done,
     /* 1223476 */   // Label 17741: @1223476
     /* 1223476 */   GIM_Try, /*On fail goto*//*Label 17742*/ GIMT_Encode4(1223556), // Rule ID 17682 //
     /* 1223481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1223492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1223495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1223498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1223501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223520 */     // MIs[0] round
     /* 1223520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223530 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1223533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223555 */     // GIR_Coverage, 17682,
     /* 1223555 */     GIR_EraseRootFromParent_Done,
     /* 1223556 */   // Label 17742: @1223556
     /* 1223556 */   GIM_Try, /*On fail goto*//*Label 17743*/ GIMT_Encode4(1223636), // Rule ID 17683 //
     /* 1223561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1223572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1223575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1223578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1223581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223600 */     // MIs[0] round
     /* 1223600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223610 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1223613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223635 */     // GIR_Coverage, 17683,
     /* 1223635 */     GIR_EraseRootFromParent_Done,
     /* 1223636 */   // Label 17743: @1223636
     /* 1223636 */   GIM_Try, /*On fail goto*//*Label 17744*/ GIMT_Encode4(1223716), // Rule ID 17686 //
     /* 1223641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1223658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1223661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223680 */     // MIs[0] round
     /* 1223680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223690 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1223693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223715 */     // GIR_Coverage, 17686,
     /* 1223715 */     GIR_EraseRootFromParent_Done,
     /* 1223716 */   // Label 17744: @1223716
     /* 1223716 */   GIM_Try, /*On fail goto*//*Label 17745*/ GIMT_Encode4(1223796), // Rule ID 17687 //
     /* 1223721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1223738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1223741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223760 */     // MIs[0] round
     /* 1223760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223770 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1223773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223795 */     // GIR_Coverage, 17687,
     /* 1223795 */     GIR_EraseRootFromParent_Done,
     /* 1223796 */   // Label 17745: @1223796
     /* 1223796 */   GIM_Try, /*On fail goto*//*Label 17746*/ GIMT_Encode4(1223876), // Rule ID 17690 //
     /* 1223801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1223821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223840 */     // MIs[0] round
     /* 1223840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223850 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1223853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223875 */     // GIR_Coverage, 17690,
     /* 1223875 */     GIR_EraseRootFromParent_Done,
     /* 1223876 */   // Label 17746: @1223876
     /* 1223876 */   GIM_Try, /*On fail goto*//*Label 17747*/ GIMT_Encode4(1223956), // Rule ID 17691 //
     /* 1223881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1223884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1223892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1223895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1223898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1223901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223920 */     // MIs[0] round
     /* 1223920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1223933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1223937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1223951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223955 */     // GIR_Coverage, 17691,
     /* 1223955 */     GIR_EraseRootFromParent_Done,
     /* 1223956 */   // Label 17747: @1223956
     /* 1223956 */   GIM_Try, /*On fail goto*//*Label 17748*/ GIMT_Encode4(1224036), // Rule ID 17694 //
     /* 1223961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1223964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1223969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1223972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1223975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1223978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1223981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224000 */     // MIs[0] round
     /* 1224000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224010 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1224013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224035 */     // GIR_Coverage, 17694,
     /* 1224035 */     GIR_EraseRootFromParent_Done,
     /* 1224036 */   // Label 17748: @1224036
     /* 1224036 */   GIM_Try, /*On fail goto*//*Label 17749*/ GIMT_Encode4(1224116), // Rule ID 17695 //
     /* 1224041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1224052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1224055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1224061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224080 */     // MIs[0] round
     /* 1224080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224090 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1224093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224115 */     // GIR_Coverage, 17695,
     /* 1224115 */     GIR_EraseRootFromParent_Done,
     /* 1224116 */   // Label 17749: @1224116
     /* 1224116 */   GIM_Try, /*On fail goto*//*Label 17750*/ GIMT_Encode4(1224196), // Rule ID 17698 //
     /* 1224121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1224141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224160 */     // MIs[0] round
     /* 1224160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224170 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1224173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224195 */     // GIR_Coverage, 17698,
     /* 1224195 */     GIR_EraseRootFromParent_Done,
     /* 1224196 */   // Label 17750: @1224196
     /* 1224196 */   GIM_Try, /*On fail goto*//*Label 17751*/ GIMT_Encode4(1224276), // Rule ID 17699 //
     /* 1224201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1224204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1224212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1224215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1224218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1224221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224240 */     // MIs[0] round
     /* 1224240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224250 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1224253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224275 */     // GIR_Coverage, 17699,
     /* 1224275 */     GIR_EraseRootFromParent_Done,
     /* 1224276 */   // Label 17751: @1224276
     /* 1224276 */   GIM_Try, /*On fail goto*//*Label 17752*/ GIMT_Encode4(1224356), // Rule ID 17702 //
     /* 1224281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1224301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224320 */     // MIs[0] round
     /* 1224320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224330 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224355 */     // GIR_Coverage, 17702,
     /* 1224355 */     GIR_EraseRootFromParent_Done,
     /* 1224356 */   // Label 17752: @1224356
     /* 1224356 */   GIM_Try, /*On fail goto*//*Label 17753*/ GIMT_Encode4(1224436), // Rule ID 17703 //
     /* 1224361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1224381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224400 */     // MIs[0] round
     /* 1224400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1224413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224435 */     // GIR_Coverage, 17703,
     /* 1224435 */     GIR_EraseRootFromParent_Done,
     /* 1224436 */   // Label 17753: @1224436
     /* 1224436 */   GIM_Try, /*On fail goto*//*Label 17754*/ GIMT_Encode4(1224516), // Rule ID 17706 //
     /* 1224441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224480 */     // MIs[0] round
     /* 1224480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224490 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1224493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224515 */     // GIR_Coverage, 17706,
     /* 1224515 */     GIR_EraseRootFromParent_Done,
     /* 1224516 */   // Label 17754: @1224516
     /* 1224516 */   GIM_Try, /*On fail goto*//*Label 17755*/ GIMT_Encode4(1224596), // Rule ID 17707 //
     /* 1224521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1224532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1224535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224560 */     // MIs[0] round
     /* 1224560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224570 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1224573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224595 */     // GIR_Coverage, 17707,
     /* 1224595 */     GIR_EraseRootFromParent_Done,
     /* 1224596 */   // Label 17755: @1224596
     /* 1224596 */   GIM_Try, /*On fail goto*//*Label 17756*/ GIMT_Encode4(1224676), // Rule ID 17710 //
     /* 1224601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1224612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1224615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1224618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1224621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224640 */     // MIs[0] round
     /* 1224640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224650 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1224653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224675 */     // GIR_Coverage, 17710,
     /* 1224675 */     GIR_EraseRootFromParent_Done,
     /* 1224676 */   // Label 17756: @1224676
     /* 1224676 */   GIM_Try, /*On fail goto*//*Label 17757*/ GIMT_Encode4(1224756), // Rule ID 17711 //
     /* 1224681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1224692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1224695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1224698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1224701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224720 */     // MIs[0] round
     /* 1224720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224730 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1224733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224755 */     // GIR_Coverage, 17711,
     /* 1224755 */     GIR_EraseRootFromParent_Done,
     /* 1224756 */   // Label 17757: @1224756
     /* 1224756 */   GIM_Try, /*On fail goto*//*Label 17758*/ GIMT_Encode4(1224836), // Rule ID 17714 //
     /* 1224761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1224764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1224772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1224775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1224781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224800 */     // MIs[0] round
     /* 1224800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224810 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1224813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224835 */     // GIR_Coverage, 17714,
     /* 1224835 */     GIR_EraseRootFromParent_Done,
     /* 1224836 */   // Label 17758: @1224836
     /* 1224836 */   GIM_Try, /*On fail goto*//*Label 17759*/ GIMT_Encode4(1224916), // Rule ID 17715 //
     /* 1224841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1224844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1224852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1224855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1224858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1224861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1224872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1224880 */     // MIs[0] round
     /* 1224880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224890 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1224893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224915 */     // GIR_Coverage, 17715,
     /* 1224915 */     GIR_EraseRootFromParent_Done,
     /* 1224916 */   // Label 17759: @1224916
     /* 1224916 */   GIM_Try, /*On fail goto*//*Label 17760*/ GIMT_Encode4(1224996), // Rule ID 17718 //
     /* 1224921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1224924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1224929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1224932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1224935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1224938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1224941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1224960 */     // MIs[0] round
     /* 1224960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224970 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1224973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1224977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224995 */     // GIR_Coverage, 17718,
     /* 1224995 */     GIR_EraseRootFromParent_Done,
     /* 1224996 */   // Label 17760: @1224996
     /* 1224996 */   GIM_Try, /*On fail goto*//*Label 17761*/ GIMT_Encode4(1225076), // Rule ID 17719 //
     /* 1225001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1225012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1225015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1225018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225040 */     // MIs[0] round
     /* 1225040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225050 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1225053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225075 */     // GIR_Coverage, 17719,
     /* 1225075 */     GIR_EraseRootFromParent_Done,
     /* 1225076 */   // Label 17761: @1225076
     /* 1225076 */   GIM_Try, /*On fail goto*//*Label 17762*/ GIMT_Encode4(1225156), // Rule ID 17722 //
     /* 1225081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225120 */     // MIs[0] round
     /* 1225120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225130 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1225133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225155 */     // GIR_Coverage, 17722,
     /* 1225155 */     GIR_EraseRootFromParent_Done,
     /* 1225156 */   // Label 17762: @1225156
     /* 1225156 */   GIM_Try, /*On fail goto*//*Label 17763*/ GIMT_Encode4(1225236), // Rule ID 17723 //
     /* 1225161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1225178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225200 */     // MIs[0] round
     /* 1225200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225210 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11305:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1225213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225235 */     // GIR_Coverage, 17723,
     /* 1225235 */     GIR_EraseRootFromParent_Done,
     /* 1225236 */   // Label 17763: @1225236
     /* 1225236 */   GIM_Try, /*On fail goto*//*Label 17764*/ GIMT_Encode4(1225316), // Rule ID 17726 //
     /* 1225241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1225252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1225255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225280 */     // MIs[0] round
     /* 1225280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225290 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1225293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225315 */     // GIR_Coverage, 17726,
     /* 1225315 */     GIR_EraseRootFromParent_Done,
     /* 1225316 */   // Label 17764: @1225316
     /* 1225316 */   GIM_Try, /*On fail goto*//*Label 17765*/ GIMT_Encode4(1225396), // Rule ID 17727 //
     /* 1225321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1225332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1225335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1225338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225360 */     // MIs[0] round
     /* 1225360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1225373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225395 */     // GIR_Coverage, 17727,
     /* 1225395 */     GIR_EraseRootFromParent_Done,
     /* 1225396 */   // Label 17765: @1225396
     /* 1225396 */   GIM_Try, /*On fail goto*//*Label 17766*/ GIMT_Encode4(1225476), // Rule ID 17730 //
     /* 1225401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225440 */     // MIs[0] round
     /* 1225440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225450 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1225453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225475 */     // GIR_Coverage, 17730,
     /* 1225475 */     GIR_EraseRootFromParent_Done,
     /* 1225476 */   // Label 17766: @1225476
     /* 1225476 */   GIM_Try, /*On fail goto*//*Label 17767*/ GIMT_Encode4(1225556), // Rule ID 17731 //
     /* 1225481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1225492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1225495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1225498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225520 */     // MIs[0] round
     /* 1225520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225530 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1225533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225555 */     // GIR_Coverage, 17731,
     /* 1225555 */     GIR_EraseRootFromParent_Done,
     /* 1225556 */   // Label 17767: @1225556
     /* 1225556 */   GIM_Try, /*On fail goto*//*Label 17768*/ GIMT_Encode4(1225636), // Rule ID 17734 //
     /* 1225561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1225564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1225572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1225575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1225578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225600 */     // MIs[0] round
     /* 1225600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225610 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1225613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225635 */     // GIR_Coverage, 17734,
     /* 1225635 */     GIR_EraseRootFromParent_Done,
     /* 1225636 */   // Label 17768: @1225636
     /* 1225636 */   GIM_Try, /*On fail goto*//*Label 17769*/ GIMT_Encode4(1225716), // Rule ID 17735 //
     /* 1225641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1225644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1225652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1225655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1225658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1225661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1225680 */     // MIs[0] round
     /* 1225680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225690 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1225693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225715 */     // GIR_Coverage, 17735,
     /* 1225715 */     GIR_EraseRootFromParent_Done,
     /* 1225716 */   // Label 17769: @1225716
     /* 1225716 */   GIM_Try, /*On fail goto*//*Label 17770*/ GIMT_Encode4(1225796), // Rule ID 17738 //
     /* 1225721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1225738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225760 */     // MIs[0] round
     /* 1225760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225770 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1225773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225795 */     // GIR_Coverage, 17738,
     /* 1225795 */     GIR_EraseRootFromParent_Done,
     /* 1225796 */   // Label 17770: @1225796
     /* 1225796 */   GIM_Try, /*On fail goto*//*Label 17771*/ GIMT_Encode4(1225876), // Rule ID 17739 //
     /* 1225801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1225818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225840 */     // MIs[0] round
     /* 1225840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225850 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11305:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1225853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225875 */     // GIR_Coverage, 17739,
     /* 1225875 */     GIR_EraseRootFromParent_Done,
     /* 1225876 */   // Label 17771: @1225876
     /* 1225876 */   GIM_Try, /*On fail goto*//*Label 17772*/ GIMT_Encode4(1225956), // Rule ID 17742 //
     /* 1225881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1225884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1225892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1225920 */     // MIs[0] round
     /* 1225920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225930 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1225933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1225937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225955 */     // GIR_Coverage, 17742,
     /* 1225955 */     GIR_EraseRootFromParent_Done,
     /* 1225956 */   // Label 17772: @1225956
     /* 1225956 */   GIM_Try, /*On fail goto*//*Label 17773*/ GIMT_Encode4(1226036), // Rule ID 17743 //
     /* 1225961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1225964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1225969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1225972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1225975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1225978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1225981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226000 */     // MIs[0] round
     /* 1226000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226010 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11305:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1226013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226035 */     // GIR_Coverage, 17743,
     /* 1226035 */     GIR_EraseRootFromParent_Done,
     /* 1226036 */   // Label 17773: @1226036
     /* 1226036 */   GIM_Try, /*On fail goto*//*Label 17774*/ GIMT_Encode4(1226116), // Rule ID 17746 //
     /* 1226041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1226052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1226055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226080 */     // MIs[0] round
     /* 1226080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226090 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1226093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226115 */     // GIR_Coverage, 17746,
     /* 1226115 */     GIR_EraseRootFromParent_Done,
     /* 1226116 */   // Label 17774: @1226116
     /* 1226116 */   GIM_Try, /*On fail goto*//*Label 17775*/ GIMT_Encode4(1226196), // Rule ID 17747 //
     /* 1226121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1226132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1226135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1226138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1226156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226160 */     // MIs[0] round
     /* 1226160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226170 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11305:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1226173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226195 */     // GIR_Coverage, 17747,
     /* 1226195 */     GIR_EraseRootFromParent_Done,
     /* 1226196 */   // Label 17775: @1226196
     /* 1226196 */   GIM_Try, /*On fail goto*//*Label 17776*/ GIMT_Encode4(1226276), // Rule ID 17750 //
     /* 1226201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1226204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1226212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1226215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226240 */     // MIs[0] round
     /* 1226240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226250 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1226253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226275 */     // GIR_Coverage, 17750,
     /* 1226275 */     GIR_EraseRootFromParent_Done,
     /* 1226276 */   // Label 17776: @1226276
     /* 1226276 */   GIM_Try, /*On fail goto*//*Label 17777*/ GIMT_Encode4(1226356), // Rule ID 17751 //
     /* 1226281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1226284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1226289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1226292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1226295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1226298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1226301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1226320 */     // MIs[0] round
     /* 1226320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226330 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11305:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1226333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1226337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226355 */     // GIR_Coverage, 17751,
     /* 1226355 */     GIR_EraseRootFromParent_Done,
     /* 1226356 */   // Label 17777: @1226356
     /* 1226356 */   GIM_Try, /*On fail goto*//*Label 17778*/ GIMT_Encode4(1226436), // Rule ID 22828 //
     /* 1226361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226400 */     // MIs[0] round
     /* 1226400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226410 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226435 */     // GIR_Coverage, 22828,
     /* 1226435 */     GIR_EraseRootFromParent_Done,
     /* 1226436 */   // Label 17778: @1226436
     /* 1226436 */   GIM_Try, /*On fail goto*//*Label 17779*/ GIMT_Encode4(1226516), // Rule ID 22829 //
     /* 1226441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226480 */     // MIs[0] round
     /* 1226480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226490 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1226493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226515 */     // GIR_Coverage, 22829,
     /* 1226515 */     GIR_EraseRootFromParent_Done,
     /* 1226516 */   // Label 17779: @1226516
     /* 1226516 */   GIM_Try, /*On fail goto*//*Label 17780*/ GIMT_Encode4(1226596), // Rule ID 22832 //
     /* 1226521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226560 */     // MIs[0] round
     /* 1226560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1226573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226595 */     // GIR_Coverage, 22832,
     /* 1226595 */     GIR_EraseRootFromParent_Done,
     /* 1226596 */   // Label 17780: @1226596
     /* 1226596 */   GIM_Try, /*On fail goto*//*Label 17781*/ GIMT_Encode4(1226676), // Rule ID 22833 //
     /* 1226601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226640 */     // MIs[0] round
     /* 1226640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1226653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226675 */     // GIR_Coverage, 22833,
     /* 1226675 */     GIR_EraseRootFromParent_Done,
     /* 1226676 */   // Label 17781: @1226676
     /* 1226676 */   GIM_Try, /*On fail goto*//*Label 17782*/ GIMT_Encode4(1226756), // Rule ID 22836 //
     /* 1226681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226720 */     // MIs[0] round
     /* 1226720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226730 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1226733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226755 */     // GIR_Coverage, 22836,
     /* 1226755 */     GIR_EraseRootFromParent_Done,
     /* 1226756 */   // Label 17782: @1226756
     /* 1226756 */   GIM_Try, /*On fail goto*//*Label 17783*/ GIMT_Encode4(1226836), // Rule ID 22837 //
     /* 1226761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1226772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1226775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1226781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226800 */     // MIs[0] round
     /* 1226800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226810 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1226813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226835 */     // GIR_Coverage, 22837,
     /* 1226835 */     GIR_EraseRootFromParent_Done,
     /* 1226836 */   // Label 17783: @1226836
     /* 1226836 */   GIM_Try, /*On fail goto*//*Label 17784*/ GIMT_Encode4(1226916), // Rule ID 22840 //
     /* 1226841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226880 */     // MIs[0] round
     /* 1226880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226890 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1226893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226915 */     // GIR_Coverage, 22840,
     /* 1226915 */     GIR_EraseRootFromParent_Done,
     /* 1226916 */   // Label 17784: @1226916
     /* 1226916 */   GIM_Try, /*On fail goto*//*Label 17785*/ GIMT_Encode4(1226996), // Rule ID 22841 //
     /* 1226921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1226929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226960 */     // MIs[0] round
     /* 1226960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226970 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1226973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226995 */     // GIR_Coverage, 22841,
     /* 1226995 */     GIR_EraseRootFromParent_Done,
     /* 1226996 */   // Label 17785: @1226996
     /* 1226996 */   GIM_Try, /*On fail goto*//*Label 17786*/ GIMT_Encode4(1227076), // Rule ID 22844 //
     /* 1227001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1227004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1227018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227040 */     // MIs[0] round
     /* 1227040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1227053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227075 */     // GIR_Coverage, 22844,
     /* 1227075 */     GIR_EraseRootFromParent_Done,
     /* 1227076 */   // Label 17786: @1227076
     /* 1227076 */   GIM_Try, /*On fail goto*//*Label 17787*/ GIMT_Encode4(1227156), // Rule ID 22845 //
     /* 1227081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1227084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1227098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227120 */     // MIs[0] round
     /* 1227120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227130 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1227133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1227151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227155 */     // GIR_Coverage, 22845,
     /* 1227155 */     GIR_EraseRootFromParent_Done,
     /* 1227156 */   // Label 17787: @1227156
     /* 1227156 */   GIM_Try, /*On fail goto*//*Label 17788*/ GIMT_Encode4(1227236), // Rule ID 22848 //
     /* 1227161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227200 */     // MIs[0] round
     /* 1227200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227210 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1227213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227235 */     // GIR_Coverage, 22848,
     /* 1227235 */     GIR_EraseRootFromParent_Done,
     /* 1227236 */   // Label 17788: @1227236
     /* 1227236 */   GIM_Try, /*On fail goto*//*Label 17789*/ GIMT_Encode4(1227316), // Rule ID 22849 //
     /* 1227241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227280 */     // MIs[0] round
     /* 1227280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227290 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1227293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227315 */     // GIR_Coverage, 22849,
     /* 1227315 */     GIR_EraseRootFromParent_Done,
     /* 1227316 */   // Label 17789: @1227316
     /* 1227316 */   GIM_Try, /*On fail goto*//*Label 17790*/ GIMT_Encode4(1227396), // Rule ID 22852 //
     /* 1227321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227360 */     // MIs[0] round
     /* 1227360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227370 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227395 */     // GIR_Coverage, 22852,
     /* 1227395 */     GIR_EraseRootFromParent_Done,
     /* 1227396 */   // Label 17790: @1227396
     /* 1227396 */   GIM_Try, /*On fail goto*//*Label 17791*/ GIMT_Encode4(1227476), // Rule ID 22853 //
     /* 1227401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227440 */     // MIs[0] round
     /* 1227440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227450 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1227453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227475 */     // GIR_Coverage, 22853,
     /* 1227475 */     GIR_EraseRootFromParent_Done,
     /* 1227476 */   // Label 17791: @1227476
     /* 1227476 */   GIM_Try, /*On fail goto*//*Label 17792*/ GIMT_Encode4(1227556), // Rule ID 22856 //
     /* 1227481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227520 */     // MIs[0] round
     /* 1227520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227530 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1227533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227555 */     // GIR_Coverage, 22856,
     /* 1227555 */     GIR_EraseRootFromParent_Done,
     /* 1227556 */   // Label 17792: @1227556
     /* 1227556 */   GIM_Try, /*On fail goto*//*Label 17793*/ GIMT_Encode4(1227636), // Rule ID 22857 //
     /* 1227561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1227572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1227575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1227581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227600 */     // MIs[0] round
     /* 1227600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227610 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11257:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1227613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227635 */     // GIR_Coverage, 22857,
     /* 1227635 */     GIR_EraseRootFromParent_Done,
     /* 1227636 */   // Label 17793: @1227636
     /* 1227636 */   GIM_Try, /*On fail goto*//*Label 17794*/ GIMT_Encode4(1227716), // Rule ID 22860 //
     /* 1227641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227680 */     // MIs[0] round
     /* 1227680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227690 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1227693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227715 */     // GIR_Coverage, 22860,
     /* 1227715 */     GIR_EraseRootFromParent_Done,
     /* 1227716 */   // Label 17794: @1227716
     /* 1227716 */   GIM_Try, /*On fail goto*//*Label 17795*/ GIMT_Encode4(1227796), // Rule ID 22861 //
     /* 1227721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227760 */     // MIs[0] round
     /* 1227760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227770 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1227773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227795 */     // GIR_Coverage, 22861,
     /* 1227795 */     GIR_EraseRootFromParent_Done,
     /* 1227796 */   // Label 17795: @1227796
     /* 1227796 */   GIM_Try, /*On fail goto*//*Label 17796*/ GIMT_Encode4(1227876), // Rule ID 22864 //
     /* 1227801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227840 */     // MIs[0] round
     /* 1227840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227850 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1227853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227875 */     // GIR_Coverage, 22864,
     /* 1227875 */     GIR_EraseRootFromParent_Done,
     /* 1227876 */   // Label 17796: @1227876
     /* 1227876 */   GIM_Try, /*On fail goto*//*Label 17797*/ GIMT_Encode4(1227956), // Rule ID 22865 //
     /* 1227881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227920 */     // MIs[0] round
     /* 1227920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227930 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1227933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227955 */     // GIR_Coverage, 22865,
     /* 1227955 */     GIR_EraseRootFromParent_Done,
     /* 1227956 */   // Label 17797: @1227956
     /* 1227956 */   GIM_Try, /*On fail goto*//*Label 17798*/ GIMT_Encode4(1228036), // Rule ID 22868 //
     /* 1227961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1227969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1227978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228000 */     // MIs[0] round
     /* 1228000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228010 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1228013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228035 */     // GIR_Coverage, 22868,
     /* 1228035 */     GIR_EraseRootFromParent_Done,
     /* 1228036 */   // Label 17798: @1228036
     /* 1228036 */   GIM_Try, /*On fail goto*//*Label 17799*/ GIMT_Encode4(1228116), // Rule ID 22869 //
     /* 1228041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1228058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228080 */     // MIs[0] round
     /* 1228080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11257:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1228093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228115 */     // GIR_Coverage, 22869,
     /* 1228115 */     GIR_EraseRootFromParent_Done,
     /* 1228116 */   // Label 17799: @1228116
     /* 1228116 */   GIM_Try, /*On fail goto*//*Label 17800*/ GIMT_Encode4(1228196), // Rule ID 22872 //
     /* 1228121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1228138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228160 */     // MIs[0] round
     /* 1228160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228170 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1228173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228195 */     // GIR_Coverage, 22872,
     /* 1228195 */     GIR_EraseRootFromParent_Done,
     /* 1228196 */   // Label 17800: @1228196
     /* 1228196 */   GIM_Try, /*On fail goto*//*Label 17801*/ GIMT_Encode4(1228276), // Rule ID 22873 //
     /* 1228201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1228218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228240 */     // MIs[0] round
     /* 1228240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228250 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1228253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228275 */     // GIR_Coverage, 22873,
     /* 1228275 */     GIR_EraseRootFromParent_Done,
     /* 1228276 */   // Label 17801: @1228276
     /* 1228276 */   GIM_Try, /*On fail goto*//*Label 17802*/ GIMT_Encode4(1228356), // Rule ID 22876 //
     /* 1228281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1228298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228320 */     // MIs[0] round
     /* 1228320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228330 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228355 */     // GIR_Coverage, 22876,
     /* 1228355 */     GIR_EraseRootFromParent_Done,
     /* 1228356 */   // Label 17802: @1228356
     /* 1228356 */   GIM_Try, /*On fail goto*//*Label 17803*/ GIMT_Encode4(1228436), // Rule ID 22877 //
     /* 1228361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1228378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1228396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228400 */     // MIs[0] round
     /* 1228400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1228413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228435 */     // GIR_Coverage, 22877,
     /* 1228435 */     GIR_EraseRootFromParent_Done,
     /* 1228436 */   // Label 17803: @1228436
     /* 1228436 */   GIM_Try, /*On fail goto*//*Label 17804*/ GIMT_Encode4(1228516), // Rule ID 22880 //
     /* 1228441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1228444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228480 */     // MIs[0] round
     /* 1228480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1228493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228515 */     // GIR_Coverage, 22880,
     /* 1228515 */     GIR_EraseRootFromParent_Done,
     /* 1228516 */   // Label 17804: @1228516
     /* 1228516 */   GIM_Try, /*On fail goto*//*Label 17805*/ GIMT_Encode4(1228596), // Rule ID 22881 //
     /* 1228521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1228524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1228529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1228538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228560 */     // MIs[0] round
     /* 1228560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11257:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1228573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1228591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228595 */     // GIR_Coverage, 22881,
     /* 1228595 */     GIR_EraseRootFromParent_Done,
     /* 1228596 */   // Label 17805: @1228596
     /* 1228596 */   GIM_Try, /*On fail goto*//*Label 17806*/ GIMT_Encode4(1228676), // Rule ID 22884 //
     /* 1228601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228640 */     // MIs[0] round
     /* 1228640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228650 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1228653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228675 */     // GIR_Coverage, 22884,
     /* 1228675 */     GIR_EraseRootFromParent_Done,
     /* 1228676 */   // Label 17806: @1228676
     /* 1228676 */   GIM_Try, /*On fail goto*//*Label 17807*/ GIMT_Encode4(1228756), // Rule ID 22885 //
     /* 1228681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228720 */     // MIs[0] round
     /* 1228720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228730 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1228733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228755 */     // GIR_Coverage, 22885,
     /* 1228755 */     GIR_EraseRootFromParent_Done,
     /* 1228756 */   // Label 17807: @1228756
     /* 1228756 */   GIM_Try, /*On fail goto*//*Label 17808*/ GIMT_Encode4(1228836), // Rule ID 22888 //
     /* 1228761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228800 */     // MIs[0] round
     /* 1228800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228810 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1228813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228835 */     // GIR_Coverage, 22888,
     /* 1228835 */     GIR_EraseRootFromParent_Done,
     /* 1228836 */   // Label 17808: @1228836
     /* 1228836 */   GIM_Try, /*On fail goto*//*Label 17809*/ GIMT_Encode4(1228916), // Rule ID 22889 //
     /* 1228841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1228852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1228855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1228861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228880 */     // MIs[0] round
     /* 1228880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228890 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1228893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228915 */     // GIR_Coverage, 22889,
     /* 1228915 */     GIR_EraseRootFromParent_Done,
     /* 1228916 */   // Label 17809: @1228916
     /* 1228916 */   GIM_Try, /*On fail goto*//*Label 17810*/ GIMT_Encode4(1228996), // Rule ID 22892 //
     /* 1228921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1228929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228960 */     // MIs[0] round
     /* 1228960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228970 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1228973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228995 */     // GIR_Coverage, 22892,
     /* 1228995 */     GIR_EraseRootFromParent_Done,
     /* 1228996 */   // Label 17810: @1228996
     /* 1228996 */   GIM_Try, /*On fail goto*//*Label 17811*/ GIMT_Encode4(1229076), // Rule ID 22893 //
     /* 1229001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229040 */     // MIs[0] round
     /* 1229040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229050 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1229053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229075 */     // GIR_Coverage, 22893,
     /* 1229075 */     GIR_EraseRootFromParent_Done,
     /* 1229076 */   // Label 17811: @1229076
     /* 1229076 */   GIM_Try, /*On fail goto*//*Label 17812*/ GIMT_Encode4(1229156), // Rule ID 22896 //
     /* 1229081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229120 */     // MIs[0] round
     /* 1229120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229130 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1229133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229155 */     // GIR_Coverage, 22896,
     /* 1229155 */     GIR_EraseRootFromParent_Done,
     /* 1229156 */   // Label 17812: @1229156
     /* 1229156 */   GIM_Try, /*On fail goto*//*Label 17813*/ GIMT_Encode4(1229236), // Rule ID 22897 //
     /* 1229161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1229178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229200 */     // MIs[0] round
     /* 1229200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229210 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1229213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229235 */     // GIR_Coverage, 22897,
     /* 1229235 */     GIR_EraseRootFromParent_Done,
     /* 1229236 */   // Label 17813: @1229236
     /* 1229236 */   GIM_Try, /*On fail goto*//*Label 17814*/ GIMT_Encode4(1229316), // Rule ID 22900 //
     /* 1229241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229280 */     // MIs[0] round
     /* 1229280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229290 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1229293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229315 */     // GIR_Coverage, 22900,
     /* 1229315 */     GIR_EraseRootFromParent_Done,
     /* 1229316 */   // Label 17814: @1229316
     /* 1229316 */   GIM_Try, /*On fail goto*//*Label 17815*/ GIMT_Encode4(1229396), // Rule ID 22901 //
     /* 1229321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1229338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229360 */     // MIs[0] round
     /* 1229360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229370 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1229373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229395 */     // GIR_Coverage, 22901,
     /* 1229395 */     GIR_EraseRootFromParent_Done,
     /* 1229396 */   // Label 17815: @1229396
     /* 1229396 */   GIM_Try, /*On fail goto*//*Label 17816*/ GIMT_Encode4(1229476), // Rule ID 22904 //
     /* 1229401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1229404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229440 */     // MIs[0] round
     /* 1229440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229450 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1229453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229475 */     // GIR_Coverage, 22904,
     /* 1229475 */     GIR_EraseRootFromParent_Done,
     /* 1229476 */   // Label 17816: @1229476
     /* 1229476 */   GIM_Try, /*On fail goto*//*Label 17817*/ GIMT_Encode4(1229556), // Rule ID 22905 //
     /* 1229481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1229484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1229498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229520 */     // MIs[0] round
     /* 1229520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229530 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1229533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1229551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229555 */     // GIR_Coverage, 22905,
     /* 1229555 */     GIR_EraseRootFromParent_Done,
     /* 1229556 */   // Label 17817: @1229556
     /* 1229556 */   GIM_Try, /*On fail goto*//*Label 17818*/ GIMT_Encode4(1229636), // Rule ID 22908 //
     /* 1229561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229600 */     // MIs[0] round
     /* 1229600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229610 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1229613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229635 */     // GIR_Coverage, 22908,
     /* 1229635 */     GIR_EraseRootFromParent_Done,
     /* 1229636 */   // Label 17818: @1229636
     /* 1229636 */   GIM_Try, /*On fail goto*//*Label 17819*/ GIMT_Encode4(1229716), // Rule ID 22909 //
     /* 1229641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1229658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229680 */     // MIs[0] round
     /* 1229680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229690 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1229693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229715 */     // GIR_Coverage, 22909,
     /* 1229715 */     GIR_EraseRootFromParent_Done,
     /* 1229716 */   // Label 17819: @1229716
     /* 1229716 */   GIM_Try, /*On fail goto*//*Label 17820*/ GIMT_Encode4(1229796), // Rule ID 22912 //
     /* 1229721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229760 */     // MIs[0] round
     /* 1229760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229770 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1229773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229795 */     // GIR_Coverage, 22912,
     /* 1229795 */     GIR_EraseRootFromParent_Done,
     /* 1229796 */   // Label 17820: @1229796
     /* 1229796 */   GIM_Try, /*On fail goto*//*Label 17821*/ GIMT_Encode4(1229876), // Rule ID 22913 //
     /* 1229801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229840 */     // MIs[0] round
     /* 1229840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229850 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1229853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229875 */     // GIR_Coverage, 22913,
     /* 1229875 */     GIR_EraseRootFromParent_Done,
     /* 1229876 */   // Label 17821: @1229876
     /* 1229876 */   GIM_Try, /*On fail goto*//*Label 17822*/ GIMT_Encode4(1229956), // Rule ID 22916 //
     /* 1229881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229920 */     // MIs[0] round
     /* 1229920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229930 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1229933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229955 */     // GIR_Coverage, 22916,
     /* 1229955 */     GIR_EraseRootFromParent_Done,
     /* 1229956 */   // Label 17822: @1229956
     /* 1229956 */   GIM_Try, /*On fail goto*//*Label 17823*/ GIMT_Encode4(1230036), // Rule ID 22917 //
     /* 1229961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1229969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1229972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1229975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1229981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230000 */     // MIs[0] round
     /* 1230000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230010 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11259:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1230013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1230031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230035 */     // GIR_Coverage, 22917,
     /* 1230035 */     GIR_EraseRootFromParent_Done,
     /* 1230036 */   // Label 17823: @1230036
     /* 1230036 */   GIM_Try, /*On fail goto*//*Label 17824*/ GIMT_Encode4(1230116), // Rule ID 22920 //
     /* 1230041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230080 */     // MIs[0] round
     /* 1230080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1230093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230115 */     // GIR_Coverage, 22920,
     /* 1230115 */     GIR_EraseRootFromParent_Done,
     /* 1230116 */   // Label 17824: @1230116
     /* 1230116 */   GIM_Try, /*On fail goto*//*Label 17825*/ GIMT_Encode4(1230196), // Rule ID 22921 //
     /* 1230121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230160 */     // MIs[0] round
     /* 1230160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230170 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1230173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230195 */     // GIR_Coverage, 22921,
     /* 1230195 */     GIR_EraseRootFromParent_Done,
     /* 1230196 */   // Label 17825: @1230196
     /* 1230196 */   GIM_Try, /*On fail goto*//*Label 17826*/ GIMT_Encode4(1230276), // Rule ID 22924 //
     /* 1230201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230240 */     // MIs[0] round
     /* 1230240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230250 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1230253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230275 */     // GIR_Coverage, 22924,
     /* 1230275 */     GIR_EraseRootFromParent_Done,
     /* 1230276 */   // Label 17826: @1230276
     /* 1230276 */   GIM_Try, /*On fail goto*//*Label 17827*/ GIMT_Encode4(1230356), // Rule ID 22925 //
     /* 1230281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230320 */     // MIs[0] round
     /* 1230320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230330 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1230333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230355 */     // GIR_Coverage, 22925,
     /* 1230355 */     GIR_EraseRootFromParent_Done,
     /* 1230356 */   // Label 17827: @1230356
     /* 1230356 */   GIM_Try, /*On fail goto*//*Label 17828*/ GIMT_Encode4(1230436), // Rule ID 22928 //
     /* 1230361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1230364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230400 */     // MIs[0] round
     /* 1230400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230410 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230435 */     // GIR_Coverage, 22928,
     /* 1230435 */     GIR_EraseRootFromParent_Done,
     /* 1230436 */   // Label 17828: @1230436
     /* 1230436 */   GIM_Try, /*On fail goto*//*Label 17829*/ GIMT_Encode4(1230516), // Rule ID 22929 //
     /* 1230441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1230444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1230452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1230455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1230461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230480 */     // MIs[0] round
     /* 1230480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230490 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11259:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1230493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1230511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230515 */     // GIR_Coverage, 22929,
     /* 1230515 */     GIR_EraseRootFromParent_Done,
     /* 1230516 */   // Label 17829: @1230516
     /* 1230516 */   GIM_Try, /*On fail goto*//*Label 17830*/ GIMT_Encode4(1230596), // Rule ID 22932 //
     /* 1230521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1230538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230560 */     // MIs[0] round
     /* 1230560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1230573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230595 */     // GIR_Coverage, 22932,
     /* 1230595 */     GIR_EraseRootFromParent_Done,
     /* 1230596 */   // Label 17830: @1230596
     /* 1230596 */   GIM_Try, /*On fail goto*//*Label 17831*/ GIMT_Encode4(1230676), // Rule ID 22933 //
     /* 1230601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1230618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230640 */     // MIs[0] round
     /* 1230640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230650 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1230653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230675 */     // GIR_Coverage, 22933,
     /* 1230675 */     GIR_EraseRootFromParent_Done,
     /* 1230676 */   // Label 17831: @1230676
     /* 1230676 */   GIM_Try, /*On fail goto*//*Label 17832*/ GIMT_Encode4(1230756), // Rule ID 22936 //
     /* 1230681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1230698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230720 */     // MIs[0] round
     /* 1230720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230730 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1230733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230755 */     // GIR_Coverage, 22936,
     /* 1230755 */     GIR_EraseRootFromParent_Done,
     /* 1230756 */   // Label 17832: @1230756
     /* 1230756 */   GIM_Try, /*On fail goto*//*Label 17833*/ GIMT_Encode4(1230836), // Rule ID 22937 //
     /* 1230761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1230778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230800 */     // MIs[0] round
     /* 1230800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230810 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1230813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230835 */     // GIR_Coverage, 22937,
     /* 1230835 */     GIR_EraseRootFromParent_Done,
     /* 1230836 */   // Label 17833: @1230836
     /* 1230836 */   GIM_Try, /*On fail goto*//*Label 17834*/ GIMT_Encode4(1230916), // Rule ID 22940 //
     /* 1230841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1230844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1230858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230880 */     // MIs[0] round
     /* 1230880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230890 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1230893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230915 */     // GIR_Coverage, 22940,
     /* 1230915 */     GIR_EraseRootFromParent_Done,
     /* 1230916 */   // Label 17834: @1230916
     /* 1230916 */   GIM_Try, /*On fail goto*//*Label 17835*/ GIMT_Encode4(1230996), // Rule ID 22941 //
     /* 1230921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1230924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1230929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1230932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1230935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1230938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1230941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230960 */     // MIs[0] round
     /* 1230960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230970 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11259:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1230973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1230977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1230991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230995 */     // GIR_Coverage, 22941,
     /* 1230995 */     GIR_EraseRootFromParent_Done,
     /* 1230996 */   // Label 17835: @1230996
     /* 1230996 */   GIM_Try, /*On fail goto*//*Label 17836*/ GIMT_Encode4(1231076), // Rule ID 23064 //
     /* 1231001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1231018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231040 */     // MIs[0] round
     /* 1231040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231050 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1231053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231075 */     // GIR_Coverage, 23064,
     /* 1231075 */     GIR_EraseRootFromParent_Done,
     /* 1231076 */   // Label 17836: @1231076
     /* 1231076 */   GIM_Try, /*On fail goto*//*Label 17837*/ GIMT_Encode4(1231156), // Rule ID 23065 //
     /* 1231081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1231098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231120 */     // MIs[0] round
     /* 1231120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231130 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1231133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231155 */     // GIR_Coverage, 23065,
     /* 1231155 */     GIR_EraseRootFromParent_Done,
     /* 1231156 */   // Label 17837: @1231156
     /* 1231156 */   GIM_Try, /*On fail goto*//*Label 17838*/ GIMT_Encode4(1231236), // Rule ID 23068 //
     /* 1231161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1231178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231200 */     // MIs[0] round
     /* 1231200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231210 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1231213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231235 */     // GIR_Coverage, 23068,
     /* 1231235 */     GIR_EraseRootFromParent_Done,
     /* 1231236 */   // Label 17838: @1231236
     /* 1231236 */   GIM_Try, /*On fail goto*//*Label 17839*/ GIMT_Encode4(1231316), // Rule ID 23069 //
     /* 1231241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1231258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231280 */     // MIs[0] round
     /* 1231280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231290 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1231293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231315 */     // GIR_Coverage, 23069,
     /* 1231315 */     GIR_EraseRootFromParent_Done,
     /* 1231316 */   // Label 17839: @1231316
     /* 1231316 */   GIM_Try, /*On fail goto*//*Label 17840*/ GIMT_Encode4(1231396), // Rule ID 23072 //
     /* 1231321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231360 */     // MIs[0] round
     /* 1231360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231370 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231395 */     // GIR_Coverage, 23072,
     /* 1231395 */     GIR_EraseRootFromParent_Done,
     /* 1231396 */   // Label 17840: @1231396
     /* 1231396 */   GIM_Try, /*On fail goto*//*Label 17841*/ GIMT_Encode4(1231476), // Rule ID 23073 //
     /* 1231401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1231418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231440 */     // MIs[0] round
     /* 1231440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231450 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1231453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231475 */     // GIR_Coverage, 23073,
     /* 1231475 */     GIR_EraseRootFromParent_Done,
     /* 1231476 */   // Label 17841: @1231476
     /* 1231476 */   GIM_Try, /*On fail goto*//*Label 17842*/ GIMT_Encode4(1231556), // Rule ID 23076 //
     /* 1231481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231520 */     // MIs[0] round
     /* 1231520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231530 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1231533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231555 */     // GIR_Coverage, 23076,
     /* 1231555 */     GIR_EraseRootFromParent_Done,
     /* 1231556 */   // Label 17842: @1231556
     /* 1231556 */   GIM_Try, /*On fail goto*//*Label 17843*/ GIMT_Encode4(1231636), // Rule ID 23077 //
     /* 1231561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1231578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231600 */     // MIs[0] round
     /* 1231600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231610 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1231613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231635 */     // GIR_Coverage, 23077,
     /* 1231635 */     GIR_EraseRootFromParent_Done,
     /* 1231636 */   // Label 17843: @1231636
     /* 1231636 */   GIM_Try, /*On fail goto*//*Label 17844*/ GIMT_Encode4(1231716), // Rule ID 23080 //
     /* 1231641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1231644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1231658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231680 */     // MIs[0] round
     /* 1231680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231690 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1231693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231715 */     // GIR_Coverage, 23080,
     /* 1231715 */     GIR_EraseRootFromParent_Done,
     /* 1231716 */   // Label 17844: @1231716
     /* 1231716 */   GIM_Try, /*On fail goto*//*Label 17845*/ GIMT_Encode4(1231796), // Rule ID 23081 //
     /* 1231721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1231724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1231732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1231735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1231738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1231741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231760 */     // MIs[0] round
     /* 1231760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231770 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1231773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1231791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231795 */     // GIR_Coverage, 23081,
     /* 1231795 */     GIR_EraseRootFromParent_Done,
     /* 1231796 */   // Label 17845: @1231796
     /* 1231796 */   GIM_Try, /*On fail goto*//*Label 17846*/ GIMT_Encode4(1231876), // Rule ID 23084 //
     /* 1231801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231840 */     // MIs[0] round
     /* 1231840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231850 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1231853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231875 */     // GIR_Coverage, 23084,
     /* 1231875 */     GIR_EraseRootFromParent_Done,
     /* 1231876 */   // Label 17846: @1231876
     /* 1231876 */   GIM_Try, /*On fail goto*//*Label 17847*/ GIMT_Encode4(1231956), // Rule ID 23085 //
     /* 1231881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1231884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1231898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231920 */     // MIs[0] round
     /* 1231920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231930 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1231933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1231937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1231951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231955 */     // GIR_Coverage, 23085,
     /* 1231955 */     GIR_EraseRootFromParent_Done,
     /* 1231956 */   // Label 17847: @1231956
     /* 1231956 */   GIM_Try, /*On fail goto*//*Label 17848*/ GIMT_Encode4(1232036), // Rule ID 23088 //
     /* 1231961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1231964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1231969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1231972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1231975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1231978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1231981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232000 */     // MIs[0] round
     /* 1232000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232010 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1232013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232035 */     // GIR_Coverage, 23088,
     /* 1232035 */     GIR_EraseRootFromParent_Done,
     /* 1232036 */   // Label 17848: @1232036
     /* 1232036 */   GIM_Try, /*On fail goto*//*Label 17849*/ GIMT_Encode4(1232116), // Rule ID 23089 //
     /* 1232041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1232058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232080 */     // MIs[0] round
     /* 1232080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1232093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232115 */     // GIR_Coverage, 23089,
     /* 1232115 */     GIR_EraseRootFromParent_Done,
     /* 1232116 */   // Label 17849: @1232116
     /* 1232116 */   GIM_Try, /*On fail goto*//*Label 17850*/ GIMT_Encode4(1232196), // Rule ID 23092 //
     /* 1232121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232160 */     // MIs[0] round
     /* 1232160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232170 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1232173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232195 */     // GIR_Coverage, 23092,
     /* 1232195 */     GIR_EraseRootFromParent_Done,
     /* 1232196 */   // Label 17850: @1232196
     /* 1232196 */   GIM_Try, /*On fail goto*//*Label 17851*/ GIMT_Encode4(1232276), // Rule ID 23093 //
     /* 1232201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1232218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232240 */     // MIs[0] round
     /* 1232240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232250 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11313:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1232253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232275 */     // GIR_Coverage, 23093,
     /* 1232275 */     GIR_EraseRootFromParent_Done,
     /* 1232276 */   // Label 17851: @1232276
     /* 1232276 */   GIM_Try, /*On fail goto*//*Label 17852*/ GIMT_Encode4(1232356), // Rule ID 23096 //
     /* 1232281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232320 */     // MIs[0] round
     /* 1232320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232330 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232355 */     // GIR_Coverage, 23096,
     /* 1232355 */     GIR_EraseRootFromParent_Done,
     /* 1232356 */   // Label 17852: @1232356
     /* 1232356 */   GIM_Try, /*On fail goto*//*Label 17853*/ GIMT_Encode4(1232436), // Rule ID 23097 //
     /* 1232361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1232378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1232396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232400 */     // MIs[0] round
     /* 1232400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1232413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232435 */     // GIR_Coverage, 23097,
     /* 1232435 */     GIR_EraseRootFromParent_Done,
     /* 1232436 */   // Label 17853: @1232436
     /* 1232436 */   GIM_Try, /*On fail goto*//*Label 17854*/ GIMT_Encode4(1232516), // Rule ID 23100 //
     /* 1232441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232480 */     // MIs[0] round
     /* 1232480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1232493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232515 */     // GIR_Coverage, 23100,
     /* 1232515 */     GIR_EraseRootFromParent_Done,
     /* 1232516 */   // Label 17854: @1232516
     /* 1232516 */   GIM_Try, /*On fail goto*//*Label 17855*/ GIMT_Encode4(1232596), // Rule ID 23101 //
     /* 1232521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1232538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1232556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232560 */     // MIs[0] round
     /* 1232560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232570 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1232573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232595 */     // GIR_Coverage, 23101,
     /* 1232595 */     GIR_EraseRootFromParent_Done,
     /* 1232596 */   // Label 17855: @1232596
     /* 1232596 */   GIM_Try, /*On fail goto*//*Label 17856*/ GIMT_Encode4(1232676), // Rule ID 23104 //
     /* 1232601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1232604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1232618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232640 */     // MIs[0] round
     /* 1232640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232650 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1232653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232675 */     // GIR_Coverage, 23104,
     /* 1232675 */     GIR_EraseRootFromParent_Done,
     /* 1232676 */   // Label 17856: @1232676
     /* 1232676 */   GIM_Try, /*On fail goto*//*Label 17857*/ GIMT_Encode4(1232756), // Rule ID 23105 //
     /* 1232681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1232684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1232689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1232692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1232695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1232698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1232701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1232716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232720 */     // MIs[0] round
     /* 1232720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232730 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11313:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1232733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232755 */     // GIR_Coverage, 23105,
     /* 1232755 */     GIR_EraseRootFromParent_Done,
     /* 1232756 */   // Label 17857: @1232756
     /* 1232756 */   GIM_Try, /*On fail goto*//*Label 17858*/ GIMT_Encode4(1232836), // Rule ID 23108 //
     /* 1232761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232800 */     // MIs[0] round
     /* 1232800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232810 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1232813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232835 */     // GIR_Coverage, 23108,
     /* 1232835 */     GIR_EraseRootFromParent_Done,
     /* 1232836 */   // Label 17858: @1232836
     /* 1232836 */   GIM_Try, /*On fail goto*//*Label 17859*/ GIMT_Encode4(1232916), // Rule ID 23109 //
     /* 1232841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1232844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232880 */     // MIs[0] round
     /* 1232880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232890 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1232893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232915 */     // GIR_Coverage, 23109,
     /* 1232915 */     GIR_EraseRootFromParent_Done,
     /* 1232916 */   // Label 17859: @1232916
     /* 1232916 */   GIM_Try, /*On fail goto*//*Label 17860*/ GIMT_Encode4(1232996), // Rule ID 23112 //
     /* 1232921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1232924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1232929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1232932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1232935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1232938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1232941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232960 */     // MIs[0] round
     /* 1232960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1232963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232970 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1232973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1232983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232995 */     // GIR_Coverage, 23112,
     /* 1232995 */     GIR_EraseRootFromParent_Done,
     /* 1232996 */   // Label 17860: @1232996
     /* 1232996 */   GIM_Try, /*On fail goto*//*Label 17861*/ GIMT_Encode4(1233076), // Rule ID 23113 //
     /* 1233001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1233018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233040 */     // MIs[0] round
     /* 1233040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233050 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1233053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233075 */     // GIR_Coverage, 23113,
     /* 1233075 */     GIR_EraseRootFromParent_Done,
     /* 1233076 */   // Label 17861: @1233076
     /* 1233076 */   GIM_Try, /*On fail goto*//*Label 17862*/ GIMT_Encode4(1233156), // Rule ID 23116 //
     /* 1233081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233120 */     // MIs[0] round
     /* 1233120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233130 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1233133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233155 */     // GIR_Coverage, 23116,
     /* 1233155 */     GIR_EraseRootFromParent_Done,
     /* 1233156 */   // Label 17862: @1233156
     /* 1233156 */   GIM_Try, /*On fail goto*//*Label 17863*/ GIMT_Encode4(1233236), // Rule ID 23117 //
     /* 1233161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1233178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233200 */     // MIs[0] round
     /* 1233200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233210 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1233213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233235 */     // GIR_Coverage, 23117,
     /* 1233235 */     GIR_EraseRootFromParent_Done,
     /* 1233236 */   // Label 17863: @1233236
     /* 1233236 */   GIM_Try, /*On fail goto*//*Label 17864*/ GIMT_Encode4(1233316), // Rule ID 23120 //
     /* 1233241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233280 */     // MIs[0] round
     /* 1233280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233290 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1233293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233315 */     // GIR_Coverage, 23120,
     /* 1233315 */     GIR_EraseRootFromParent_Done,
     /* 1233316 */   // Label 17864: @1233316
     /* 1233316 */   GIM_Try, /*On fail goto*//*Label 17865*/ GIMT_Encode4(1233396), // Rule ID 23121 //
     /* 1233321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233360 */     // MIs[0] round
     /* 1233360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233370 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1233373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233395 */     // GIR_Coverage, 23121,
     /* 1233395 */     GIR_EraseRootFromParent_Done,
     /* 1233396 */   // Label 17865: @1233396
     /* 1233396 */   GIM_Try, /*On fail goto*//*Label 17866*/ GIMT_Encode4(1233476), // Rule ID 23124 //
     /* 1233401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1233404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233440 */     // MIs[0] round
     /* 1233440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233450 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1233453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233475 */     // GIR_Coverage, 23124,
     /* 1233475 */     GIR_EraseRootFromParent_Done,
     /* 1233476 */   // Label 17866: @1233476
     /* 1233476 */   GIM_Try, /*On fail goto*//*Label 17867*/ GIMT_Encode4(1233556), // Rule ID 23125 //
     /* 1233481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1233484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233520 */     // MIs[0] round
     /* 1233520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233530 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1233533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233555 */     // GIR_Coverage, 23125,
     /* 1233555 */     GIR_EraseRootFromParent_Done,
     /* 1233556 */   // Label 17867: @1233556
     /* 1233556 */   GIM_Try, /*On fail goto*//*Label 17868*/ GIMT_Encode4(1233636), // Rule ID 23128 //
     /* 1233561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1233578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233600 */     // MIs[0] round
     /* 1233600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233610 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1233613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233635 */     // GIR_Coverage, 23128,
     /* 1233635 */     GIR_EraseRootFromParent_Done,
     /* 1233636 */   // Label 17868: @1233636
     /* 1233636 */   GIM_Try, /*On fail goto*//*Label 17869*/ GIMT_Encode4(1233716), // Rule ID 23129 //
     /* 1233641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1233658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233680 */     // MIs[0] round
     /* 1233680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233690 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1233693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233715 */     // GIR_Coverage, 23129,
     /* 1233715 */     GIR_EraseRootFromParent_Done,
     /* 1233716 */   // Label 17869: @1233716
     /* 1233716 */   GIM_Try, /*On fail goto*//*Label 17870*/ GIMT_Encode4(1233796), // Rule ID 23132 //
     /* 1233721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1233738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233760 */     // MIs[0] round
     /* 1233760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233770 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1233773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233795 */     // GIR_Coverage, 23132,
     /* 1233795 */     GIR_EraseRootFromParent_Done,
     /* 1233796 */   // Label 17870: @1233796
     /* 1233796 */   GIM_Try, /*On fail goto*//*Label 17871*/ GIMT_Encode4(1233876), // Rule ID 23133 //
     /* 1233801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1233818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233840 */     // MIs[0] round
     /* 1233840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233850 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1233850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1233853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233875 */     // GIR_Coverage, 23133,
     /* 1233875 */     GIR_EraseRootFromParent_Done,
     /* 1233876 */   // Label 17871: @1233876
     /* 1233876 */   GIM_Try, /*On fail goto*//*Label 17872*/ GIMT_Encode4(1233956), // Rule ID 23136 //
     /* 1233881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1233884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1233898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233920 */     // MIs[0] round
     /* 1233920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1233923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233930 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1233930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1233933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1233937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1233943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1233954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233955 */     // GIR_Coverage, 23136,
     /* 1233955 */     GIR_EraseRootFromParent_Done,
     /* 1233956 */   // Label 17872: @1233956
     /* 1233956 */   GIM_Try, /*On fail goto*//*Label 17873*/ GIMT_Encode4(1234036), // Rule ID 23137 //
     /* 1233961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1233964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1233969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1233978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234000 */     // MIs[0] round
     /* 1234000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234010 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11311:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1234013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234035 */     // GIR_Coverage, 23137,
     /* 1234035 */     GIR_EraseRootFromParent_Done,
     /* 1234036 */   // Label 17873: @1234036
     /* 1234036 */   GIM_Try, /*On fail goto*//*Label 17874*/ GIMT_Encode4(1234116), // Rule ID 23140 //
     /* 1234041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234080 */     // MIs[0] round
     /* 1234080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234090 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1234093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234115 */     // GIR_Coverage, 23140,
     /* 1234115 */     GIR_EraseRootFromParent_Done,
     /* 1234116 */   // Label 17874: @1234116
     /* 1234116 */   GIM_Try, /*On fail goto*//*Label 17875*/ GIMT_Encode4(1234196), // Rule ID 23141 //
     /* 1234121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234160 */     // MIs[0] round
     /* 1234160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234170 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1234173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234195 */     // GIR_Coverage, 23141,
     /* 1234195 */     GIR_EraseRootFromParent_Done,
     /* 1234196 */   // Label 17875: @1234196
     /* 1234196 */   GIM_Try, /*On fail goto*//*Label 17876*/ GIMT_Encode4(1234276), // Rule ID 23144 //
     /* 1234201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234240 */     // MIs[0] round
     /* 1234240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234250 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1234253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234275 */     // GIR_Coverage, 23144,
     /* 1234275 */     GIR_EraseRootFromParent_Done,
     /* 1234276 */   // Label 17876: @1234276
     /* 1234276 */   GIM_Try, /*On fail goto*//*Label 17877*/ GIMT_Encode4(1234356), // Rule ID 23145 //
     /* 1234281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234320 */     // MIs[0] round
     /* 1234320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234330 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1234333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234355 */     // GIR_Coverage, 23145,
     /* 1234355 */     GIR_EraseRootFromParent_Done,
     /* 1234356 */   // Label 17877: @1234356
     /* 1234356 */   GIM_Try, /*On fail goto*//*Label 17878*/ GIMT_Encode4(1234436), // Rule ID 23148 //
     /* 1234361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1234364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234400 */     // MIs[0] round
     /* 1234400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234410 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234435 */     // GIR_Coverage, 23148,
     /* 1234435 */     GIR_EraseRootFromParent_Done,
     /* 1234436 */   // Label 17878: @1234436
     /* 1234436 */   GIM_Try, /*On fail goto*//*Label 17879*/ GIMT_Encode4(1234516), // Rule ID 23149 //
     /* 1234441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1234444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1234449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1234452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1234455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1234461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234480 */     // MIs[0] round
     /* 1234480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11311:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1234493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1234497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234515 */     // GIR_Coverage, 23149,
     /* 1234515 */     GIR_EraseRootFromParent_Done,
     /* 1234516 */   // Label 17879: @1234516
     /* 1234516 */   GIM_Try, /*On fail goto*//*Label 17880*/ GIMT_Encode4(1234596), // Rule ID 64353 //
     /* 1234521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1234532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1234535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1234538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234560 */     // MIs[0] round
     /* 1234560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234570 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1234573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234595 */     // GIR_Coverage, 64353,
     /* 1234595 */     GIR_EraseRootFromParent_Done,
     /* 1234596 */   // Label 17880: @1234596
     /* 1234596 */   GIM_Try, /*On fail goto*//*Label 17881*/ GIMT_Encode4(1234676), // Rule ID 64354 //
     /* 1234601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1234612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1234615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1234618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234640 */     // MIs[0] round
     /* 1234640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234650 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1234653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234675 */     // GIR_Coverage, 64354,
     /* 1234675 */     GIR_EraseRootFromParent_Done,
     /* 1234676 */   // Label 17881: @1234676
     /* 1234676 */   GIM_Try, /*On fail goto*//*Label 17882*/ GIMT_Encode4(1234756), // Rule ID 64357 //
     /* 1234681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1234692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1234695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1234698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234720 */     // MIs[0] round
     /* 1234720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1234733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234755 */     // GIR_Coverage, 64357,
     /* 1234755 */     GIR_EraseRootFromParent_Done,
     /* 1234756 */   // Label 17882: @1234756
     /* 1234756 */   GIM_Try, /*On fail goto*//*Label 17883*/ GIMT_Encode4(1234836), // Rule ID 64358 //
     /* 1234761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1234772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1234775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1234778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234800 */     // MIs[0] round
     /* 1234800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234810 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1234813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234835 */     // GIR_Coverage, 64358,
     /* 1234835 */     GIR_EraseRootFromParent_Done,
     /* 1234836 */   // Label 17883: @1234836
     /* 1234836 */   GIM_Try, /*On fail goto*//*Label 17884*/ GIMT_Encode4(1234916), // Rule ID 64361 //
     /* 1234841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1234844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1234852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1234855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234880 */     // MIs[0] round
     /* 1234880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234890 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1234890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1234893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234915 */     // GIR_Coverage, 64361,
     /* 1234915 */     GIR_EraseRootFromParent_Done,
     /* 1234916 */   // Label 17884: @1234916
     /* 1234916 */   GIM_Try, /*On fail goto*//*Label 17885*/ GIMT_Encode4(1234996), // Rule ID 64362 //
     /* 1234921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1234924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1234929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1234932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1234935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1234941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1234952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1234960 */     // MIs[0] round
     /* 1234960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1234963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1234970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1234973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1234983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1234994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234995 */     // GIR_Coverage, 64362,
     /* 1234995 */     GIR_EraseRootFromParent_Done,
     /* 1234996 */   // Label 17885: @1234996
     /* 1234996 */   GIM_Try, /*On fail goto*//*Label 17886*/ GIMT_Encode4(1235076), // Rule ID 64365 //
     /* 1235001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235040 */     // MIs[0] round
     /* 1235040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1235053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235075 */     // GIR_Coverage, 64365,
     /* 1235075 */     GIR_EraseRootFromParent_Done,
     /* 1235076 */   // Label 17886: @1235076
     /* 1235076 */   GIM_Try, /*On fail goto*//*Label 17887*/ GIMT_Encode4(1235156), // Rule ID 64366 //
     /* 1235081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235120 */     // MIs[0] round
     /* 1235120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235130 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1235133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235155 */     // GIR_Coverage, 64366,
     /* 1235155 */     GIR_EraseRootFromParent_Done,
     /* 1235156 */   // Label 17887: @1235156
     /* 1235156 */   GIM_Try, /*On fail goto*//*Label 17888*/ GIMT_Encode4(1235236), // Rule ID 64369 //
     /* 1235161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235200 */     // MIs[0] round
     /* 1235200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235210 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1235213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235235 */     // GIR_Coverage, 64369,
     /* 1235235 */     GIR_EraseRootFromParent_Done,
     /* 1235236 */   // Label 17888: @1235236
     /* 1235236 */   GIM_Try, /*On fail goto*//*Label 17889*/ GIMT_Encode4(1235316), // Rule ID 64370 //
     /* 1235241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1235249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235280 */     // MIs[0] round
     /* 1235280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1235293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235315 */     // GIR_Coverage, 64370,
     /* 1235315 */     GIR_EraseRootFromParent_Done,
     /* 1235316 */   // Label 17889: @1235316
     /* 1235316 */   GIM_Try, /*On fail goto*//*Label 17890*/ GIMT_Encode4(1235396), // Rule ID 64373 //
     /* 1235321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235360 */     // MIs[0] round
     /* 1235360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235370 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1235373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235395 */     // GIR_Coverage, 64373,
     /* 1235395 */     GIR_EraseRootFromParent_Done,
     /* 1235396 */   // Label 17890: @1235396
     /* 1235396 */   GIM_Try, /*On fail goto*//*Label 17891*/ GIMT_Encode4(1235476), // Rule ID 64374 //
     /* 1235401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1235418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235440 */     // MIs[0] round
     /* 1235440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235450 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1235453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235475 */     // GIR_Coverage, 64374,
     /* 1235475 */     GIR_EraseRootFromParent_Done,
     /* 1235476 */   // Label 17891: @1235476
     /* 1235476 */   GIM_Try, /*On fail goto*//*Label 17892*/ GIMT_Encode4(1235556), // Rule ID 64377 //
     /* 1235481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235520 */     // MIs[0] round
     /* 1235520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235530 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1235533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235555 */     // GIR_Coverage, 64377,
     /* 1235555 */     GIR_EraseRootFromParent_Done,
     /* 1235556 */   // Label 17892: @1235556
     /* 1235556 */   GIM_Try, /*On fail goto*//*Label 17893*/ GIMT_Encode4(1235636), // Rule ID 64378 //
     /* 1235561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1235578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235600 */     // MIs[0] round
     /* 1235600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235610 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1235613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235635 */     // GIR_Coverage, 64378,
     /* 1235635 */     GIR_EraseRootFromParent_Done,
     /* 1235636 */   // Label 17893: @1235636
     /* 1235636 */   GIM_Try, /*On fail goto*//*Label 17894*/ GIMT_Encode4(1235716), // Rule ID 64381 //
     /* 1235641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235680 */     // MIs[0] round
     /* 1235680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235690 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1235693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235715 */     // GIR_Coverage, 64381,
     /* 1235715 */     GIR_EraseRootFromParent_Done,
     /* 1235716 */   // Label 17894: @1235716
     /* 1235716 */   GIM_Try, /*On fail goto*//*Label 17895*/ GIMT_Encode4(1235796), // Rule ID 64382 //
     /* 1235721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1235738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235760 */     // MIs[0] round
     /* 1235760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235770 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1235773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235795 */     // GIR_Coverage, 64382,
     /* 1235795 */     GIR_EraseRootFromParent_Done,
     /* 1235796 */   // Label 17895: @1235796
     /* 1235796 */   GIM_Try, /*On fail goto*//*Label 17896*/ GIMT_Encode4(1235876), // Rule ID 64385 //
     /* 1235801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235840 */     // MIs[0] round
     /* 1235840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1235850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1235853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235875 */     // GIR_Coverage, 64385,
     /* 1235875 */     GIR_EraseRootFromParent_Done,
     /* 1235876 */   // Label 17896: @1235876
     /* 1235876 */   GIM_Try, /*On fail goto*//*Label 17897*/ GIMT_Encode4(1235956), // Rule ID 64386 //
     /* 1235881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1235884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1235892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1235895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1235898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1235920 */     // MIs[0] round
     /* 1235920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1235923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235930 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1235930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1235933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1235943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1235954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235955 */     // GIR_Coverage, 64386,
     /* 1235955 */     GIR_EraseRootFromParent_Done,
     /* 1235956 */   // Label 17897: @1235956
     /* 1235956 */   GIM_Try, /*On fail goto*//*Label 17898*/ GIMT_Encode4(1236036), // Rule ID 64389 //
     /* 1235961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1235964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1235969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1235972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1235975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1235978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236000 */     // MIs[0] round
     /* 1236000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236010 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1236013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236035 */     // GIR_Coverage, 64389,
     /* 1236035 */     GIR_EraseRootFromParent_Done,
     /* 1236036 */   // Label 17898: @1236036
     /* 1236036 */   GIM_Try, /*On fail goto*//*Label 17899*/ GIMT_Encode4(1236116), // Rule ID 64390 //
     /* 1236041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1236044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1236049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1236052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1236055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1236058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236080 */     // MIs[0] round
     /* 1236080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236090 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1236093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236115 */     // GIR_Coverage, 64390,
     /* 1236115 */     GIR_EraseRootFromParent_Done,
     /* 1236116 */   // Label 17899: @1236116
     /* 1236116 */   GIM_Try, /*On fail goto*//*Label 17900*/ GIMT_Encode4(1236196), // Rule ID 65103 //
     /* 1236121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236160 */     // MIs[0] round
     /* 1236160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236170 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1236173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236195 */     // GIR_Coverage, 65103,
     /* 1236195 */     GIR_EraseRootFromParent_Done,
     /* 1236196 */   // Label 17900: @1236196
     /* 1236196 */   GIM_Try, /*On fail goto*//*Label 17901*/ GIMT_Encode4(1236276), // Rule ID 65104 //
     /* 1236201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236240 */     // MIs[0] round
     /* 1236240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236250 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11035:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4),
     /* 1236253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236275 */     // GIR_Coverage, 65104,
     /* 1236275 */     GIR_EraseRootFromParent_Done,
     /* 1236276 */   // Label 17901: @1236276
     /* 1236276 */   GIM_Try, /*On fail goto*//*Label 17902*/ GIMT_Encode4(1236356), // Rule ID 65107 //
     /* 1236281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236320 */     // MIs[0] round
     /* 1236320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236330 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1236333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236355 */     // GIR_Coverage, 65107,
     /* 1236355 */     GIR_EraseRootFromParent_Done,
     /* 1236356 */   // Label 17902: @1236356
     /* 1236356 */   GIM_Try, /*On fail goto*//*Label 17903*/ GIMT_Encode4(1236436), // Rule ID 65108 //
     /* 1236361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236400 */     // MIs[0] round
     /* 1236400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236410 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2),
     /* 1236413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236435 */     // GIR_Coverage, 65108,
     /* 1236435 */     GIR_EraseRootFromParent_Done,
     /* 1236436 */   // Label 17903: @1236436
     /* 1236436 */   GIM_Try, /*On fail goto*//*Label 17904*/ GIMT_Encode4(1236516), // Rule ID 65111 //
     /* 1236441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1236452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1236455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236480 */     // MIs[0] round
     /* 1236480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236490 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11035:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1236493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236515 */     // GIR_Coverage, 65111,
     /* 1236515 */     GIR_EraseRootFromParent_Done,
     /* 1236516 */   // Label 17904: @1236516
     /* 1236516 */   GIM_Try, /*On fail goto*//*Label 17905*/ GIMT_Encode4(1236596), // Rule ID 65112 //
     /* 1236521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1236532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1236535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236560 */     // MIs[0] round
     /* 1236560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236570 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11035:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1),
     /* 1236573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236595 */     // GIR_Coverage, 65112,
     /* 1236595 */     GIR_EraseRootFromParent_Done,
     /* 1236596 */   // Label 17905: @1236596
     /* 1236596 */   GIM_Try, /*On fail goto*//*Label 17906*/ GIMT_Encode4(1236676), // Rule ID 65115 //
     /* 1236601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1236612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1236615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1236618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236640 */     // MIs[0] round
     /* 1236640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236650 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1236653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236675 */     // GIR_Coverage, 65115,
     /* 1236675 */     GIR_EraseRootFromParent_Done,
     /* 1236676 */   // Label 17906: @1236676
     /* 1236676 */   GIM_Try, /*On fail goto*//*Label 17907*/ GIMT_Encode4(1236756), // Rule ID 65116 //
     /* 1236681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1236692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1236695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1236698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1236716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236720 */     // MIs[0] round
     /* 1236720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236730 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2),
     /* 1236733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236755 */     // GIR_Coverage, 65116,
     /* 1236755 */     GIR_EraseRootFromParent_Done,
     /* 1236756 */   // Label 17907: @1236756
     /* 1236756 */   GIM_Try, /*On fail goto*//*Label 17908*/ GIMT_Encode4(1236836), // Rule ID 65119 //
     /* 1236761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1236772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1236775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1236778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236800 */     // MIs[0] round
     /* 1236800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236810 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1236813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236835 */     // GIR_Coverage, 65119,
     /* 1236835 */     GIR_EraseRootFromParent_Done,
     /* 1236836 */   // Label 17908: @1236836
     /* 1236836 */   GIM_Try, /*On fail goto*//*Label 17909*/ GIMT_Encode4(1236916), // Rule ID 65120 //
     /* 1236841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1236844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1236852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1236855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1236858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1236876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236880 */     // MIs[0] round
     /* 1236880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236890 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1236890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4),
     /* 1236893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236915 */     // GIR_Coverage, 65120,
     /* 1236915 */     GIR_EraseRootFromParent_Done,
     /* 1236916 */   // Label 17909: @1236916
     /* 1236916 */   GIM_Try, /*On fail goto*//*Label 17910*/ GIMT_Encode4(1236996), // Rule ID 65123 //
     /* 1236921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1236924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1236929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1236932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1236935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1236938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1236956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1236960 */     // MIs[0] round
     /* 1236960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1236963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236970 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1236970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1236973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1236983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1236994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236995 */     // GIR_Coverage, 65123,
     /* 1236995 */     GIR_EraseRootFromParent_Done,
     /* 1236996 */   // Label 17910: @1236996
     /* 1236996 */   GIM_Try, /*On fail goto*//*Label 17911*/ GIMT_Encode4(1237076), // Rule ID 65124 //
     /* 1237001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt),
     /* 1237009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237040 */     // MIs[0] round
     /* 1237040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237050 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADT_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8),
     /* 1237053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237075 */     // GIR_Coverage, 65124,
     /* 1237075 */     GIR_EraseRootFromParent_Done,
     /* 1237076 */   // Label 17911: @1237076
     /* 1237076 */   GIM_Try, /*On fail goto*//*Label 17912*/ GIMT_Encode4(1237156), // Rule ID 65127 //
     /* 1237081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1237092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1237095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1237098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237120 */     // MIs[0] round
     /* 1237120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237130 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1237133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237155 */     // GIR_Coverage, 65127,
     /* 1237155 */     GIR_EraseRootFromParent_Done,
     /* 1237156 */   // Label 17912: @1237156
     /* 1237156 */   GIM_Try, /*On fail goto*//*Label 17913*/ GIMT_Encode4(1237236), // Rule ID 65128 //
     /* 1237161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1237172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1237175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1237178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237200 */     // MIs[0] round
     /* 1237200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237210 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11033:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4),
     /* 1237213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237235 */     // GIR_Coverage, 65128,
     /* 1237235 */     GIR_EraseRootFromParent_Done,
     /* 1237236 */   // Label 17913: @1237236
     /* 1237236 */   GIM_Try, /*On fail goto*//*Label 17914*/ GIMT_Encode4(1237316), // Rule ID 65131 //
     /* 1237241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1237252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1237255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1237258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237280 */     // MIs[0] round
     /* 1237280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237290 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1237293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237315 */     // GIR_Coverage, 65131,
     /* 1237315 */     GIR_EraseRootFromParent_Done,
     /* 1237316 */   // Label 17914: @1237316
     /* 1237316 */   GIM_Try, /*On fail goto*//*Label 17915*/ GIMT_Encode4(1237396), // Rule ID 65132 //
     /* 1237321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1237332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1237335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1237338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237360 */     // MIs[0] round
     /* 1237360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237370 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2),
     /* 1237373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237395 */     // GIR_Coverage, 65132,
     /* 1237395 */     GIR_EraseRootFromParent_Done,
     /* 1237396 */   // Label 17915: @1237396
     /* 1237396 */   GIM_Try, /*On fail goto*//*Label 17916*/ GIMT_Encode4(1237476), // Rule ID 65135 //
     /* 1237401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237440 */     // MIs[0] round
     /* 1237440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237450 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11033:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1237453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237475 */     // GIR_Coverage, 65135,
     /* 1237475 */     GIR_EraseRootFromParent_Done,
     /* 1237476 */   // Label 17916: @1237476
     /* 1237476 */   GIM_Try, /*On fail goto*//*Label 17917*/ GIMT_Encode4(1237556), // Rule ID 65136 //
     /* 1237481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1237492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1237495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1237498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237520 */     // MIs[0] round
     /* 1237520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237530 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11033:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1),
     /* 1237533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237555 */     // GIR_Coverage, 65136,
     /* 1237555 */     GIR_EraseRootFromParent_Done,
     /* 1237556 */   // Label 17917: @1237556
     /* 1237556 */   GIM_Try, /*On fail goto*//*Label 17918*/ GIMT_Encode4(1237636), // Rule ID 65139 //
     /* 1237561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237600 */     // MIs[0] round
     /* 1237600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237610 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1237613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237635 */     // GIR_Coverage, 65139,
     /* 1237635 */     GIR_EraseRootFromParent_Done,
     /* 1237636 */   // Label 17918: @1237636
     /* 1237636 */   GIM_Try, /*On fail goto*//*Label 17919*/ GIMT_Encode4(1237716), // Rule ID 65140 //
     /* 1237641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237680 */     // MIs[0] round
     /* 1237680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237690 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2),
     /* 1237693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237715 */     // GIR_Coverage, 65140,
     /* 1237715 */     GIR_EraseRootFromParent_Done,
     /* 1237716 */   // Label 17919: @1237716
     /* 1237716 */   GIM_Try, /*On fail goto*//*Label 17920*/ GIMT_Encode4(1237796), // Rule ID 65143 //
     /* 1237721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237760 */     // MIs[0] round
     /* 1237760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237770 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1237773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237795 */     // GIR_Coverage, 65143,
     /* 1237795 */     GIR_EraseRootFromParent_Done,
     /* 1237796 */   // Label 17920: @1237796
     /* 1237796 */   GIM_Try, /*On fail goto*//*Label 17921*/ GIMT_Encode4(1237876), // Rule ID 65144 //
     /* 1237801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237840 */     // MIs[0] round
     /* 1237840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237850 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1237850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4),
     /* 1237853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237875 */     // GIR_Coverage, 65144,
     /* 1237875 */     GIR_EraseRootFromParent_Done,
     /* 1237876 */   // Label 17921: @1237876
     /* 1237876 */   GIM_Try, /*On fail goto*//*Label 17922*/ GIMT_Encode4(1237956), // Rule ID 65147 //
     /* 1237881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 1237884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1237920 */     // MIs[0] round
     /* 1237920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1237923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237930 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1237930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1237933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1237943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1237954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237955 */     // GIR_Coverage, 65147,
     /* 1237955 */     GIR_EraseRootFromParent_Done,
     /* 1237956 */   // Label 17922: @1237956
     /* 1237956 */   GIM_Try, /*On fail goto*//*Label 17923*/ GIMT_Encode4(1238036), // Rule ID 65148 //
     /* 1237961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 1237964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb),
     /* 1237969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1238000 */     // MIs[0] round
     /* 1238000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1238003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238010 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoNDS_VFPMADB_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8),
     /* 1238013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1238023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238035 */     // GIR_Coverage, 65148,
     /* 1238035 */     GIR_EraseRootFromParent_Done,
     /* 1238036 */   // Label 17923: @1238036
     /* 1238036 */   GIM_Try, /*On fail goto*//*Label 17924*/ GIMT_Encode4(1238120), // Rule ID 2716 //
     /* 1238041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1238049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238094 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1238097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238119 */     // GIR_Coverage, 2716,
     /* 1238119 */     GIR_EraseRootFromParent_Done,
     /* 1238120 */   // Label 17924: @1238120
     /* 1238120 */   GIM_Try, /*On fail goto*//*Label 17925*/ GIMT_Encode4(1238204), // Rule ID 2717 //
     /* 1238125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1238133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238178 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1238181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238203 */     // GIR_Coverage, 2717,
     /* 1238203 */     GIR_EraseRootFromParent_Done,
     /* 1238204 */   // Label 17925: @1238204
     /* 1238204 */   GIM_Try, /*On fail goto*//*Label 17926*/ GIMT_Encode4(1238288), // Rule ID 2728 //
     /* 1238209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1238217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238262 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1238262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1238265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1238271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1238273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238287 */     // GIR_Coverage, 2728,
     /* 1238287 */     GIR_EraseRootFromParent_Done,
     /* 1238288 */   // Label 17926: @1238288
     /* 1238288 */   GIM_Try, /*On fail goto*//*Label 17927*/ GIMT_Encode4(1238372), // Rule ID 2729 //
     /* 1238293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1238301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1238304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1238307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238346 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1238346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1238349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1238355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1238357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1238370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238371 */     // GIR_Coverage, 2729,
     /* 1238371 */     GIR_EraseRootFromParent_Done,
     /* 1238372 */   // Label 17927: @1238372
     /* 1238372 */   GIM_Try, /*On fail goto*//*Label 17928*/ GIMT_Encode4(1238453), // Rule ID 2730 //
     /* 1238377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238430 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1238433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238452 */     // GIR_Coverage, 2730,
     /* 1238452 */     GIR_EraseRootFromParent_Done,
     /* 1238453 */   // Label 17928: @1238453
     /* 1238453 */   GIM_Try, /*On fail goto*//*Label 17929*/ GIMT_Encode4(1238534), // Rule ID 2731 //
     /* 1238458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1238469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1238472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1238478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238511 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1238511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1238514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238533 */     // GIR_Coverage, 2731,
     /* 1238533 */     GIR_EraseRootFromParent_Done,
     /* 1238534 */   // Label 17929: @1238534
     /* 1238534 */   GIM_Try, /*On fail goto*//*Label 17930*/ GIMT_Encode4(1238618), // Rule ID 2780 //
     /* 1238539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1238547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1238550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1238553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1238559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238592 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1238592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1238595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1238599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238617 */     // GIR_Coverage, 2780,
     /* 1238617 */     GIR_EraseRootFromParent_Done,
     /* 1238618 */   // Label 17930: @1238618
     /* 1238618 */   GIM_Try, /*On fail goto*//*Label 17931*/ GIMT_Encode4(1238702), // Rule ID 2781 //
     /* 1238623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1238631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1238634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1238637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1238640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1238643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1238646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1238676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1238679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1238683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1238700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238701 */     // GIR_Coverage, 2781,
     /* 1238701 */     GIR_EraseRootFromParent_Done,
     /* 1238702 */   // Label 17931: @1238702
     /* 1238702 */   GIM_Try, /*On fail goto*//*Label 17932*/ GIMT_Encode4(1238783), // Rule ID 5116 //
     /* 1238707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1238718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1238721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1238724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1238727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1238730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238760 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1238763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238782 */     // GIR_Coverage, 5116,
     /* 1238782 */     GIR_EraseRootFromParent_Done,
     /* 1238783 */   // Label 17932: @1238783
     /* 1238783 */   GIM_Try, /*On fail goto*//*Label 17933*/ GIMT_Encode4(1238864), // Rule ID 5117 //
     /* 1238788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1238799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1238802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1238805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1238808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1238811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238841 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1238841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1238844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238863 */     // GIR_Coverage, 5117,
     /* 1238863 */     GIR_EraseRootFromParent_Done,
     /* 1238864 */   // Label 17933: @1238864
     /* 1238864 */   GIM_Try, /*On fail goto*//*Label 17934*/ GIMT_Encode4(1238945), // Rule ID 5118 //
     /* 1238869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1238880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1238883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1238886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1238889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238922 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1238922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1238925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1238943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238944 */     // GIR_Coverage, 5118,
     /* 1238944 */     GIR_EraseRootFromParent_Done,
     /* 1238945 */   // Label 17934: @1238945
     /* 1238945 */   GIM_Try, /*On fail goto*//*Label 17935*/ GIMT_Encode4(1239026), // Rule ID 5119 //
     /* 1238950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1238961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1238964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1238967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1238970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1238980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1238992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239003 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239025 */     // GIR_Coverage, 5119,
     /* 1239025 */     GIR_EraseRootFromParent_Done,
     /* 1239026 */   // Label 17935: @1239026
     /* 1239026 */   GIM_Try, /*On fail goto*//*Label 17936*/ GIMT_Encode4(1239107), // Rule ID 5120 //
     /* 1239031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239106 */     // GIR_Coverage, 5120,
     /* 1239106 */     GIR_EraseRootFromParent_Done,
     /* 1239107 */   // Label 17936: @1239107
     /* 1239107 */   GIM_Try, /*On fail goto*//*Label 17937*/ GIMT_Encode4(1239188), // Rule ID 5121 //
     /* 1239112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239165 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1239168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239187 */     // GIR_Coverage, 5121,
     /* 1239187 */     GIR_EraseRootFromParent_Done,
     /* 1239188 */   // Label 17937: @1239188
     /* 1239188 */   GIM_Try, /*On fail goto*//*Label 17938*/ GIMT_Encode4(1239269), // Rule ID 5122 //
     /* 1239193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239246 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239268 */     // GIR_Coverage, 5122,
     /* 1239268 */     GIR_EraseRootFromParent_Done,
     /* 1239269 */   // Label 17938: @1239269
     /* 1239269 */   GIM_Try, /*On fail goto*//*Label 17939*/ GIMT_Encode4(1239350), // Rule ID 5123 //
     /* 1239274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239349 */     // GIR_Coverage, 5123,
     /* 1239349 */     GIR_EraseRootFromParent_Done,
     /* 1239350 */   // Label 17939: @1239350
     /* 1239350 */   GIM_Try, /*On fail goto*//*Label 17940*/ GIMT_Encode4(1239431), // Rule ID 5124 //
     /* 1239355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239408 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1239408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239430 */     // GIR_Coverage, 5124,
     /* 1239430 */     GIR_EraseRootFromParent_Done,
     /* 1239431 */   // Label 17940: @1239431
     /* 1239431 */   GIM_Try, /*On fail goto*//*Label 17941*/ GIMT_Encode4(1239512), // Rule ID 5125 //
     /* 1239436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239489 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1239489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1239492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239511 */     // GIR_Coverage, 5125,
     /* 1239511 */     GIR_EraseRootFromParent_Done,
     /* 1239512 */   // Label 17941: @1239512
     /* 1239512 */   GIM_Try, /*On fail goto*//*Label 17942*/ GIMT_Encode4(1239593), // Rule ID 5126 //
     /* 1239517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1239534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1239537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239592 */     // GIR_Coverage, 5126,
     /* 1239592 */     GIR_EraseRootFromParent_Done,
     /* 1239593 */   // Label 17942: @1239593
     /* 1239593 */   GIM_Try, /*On fail goto*//*Label 17943*/ GIMT_Encode4(1239674), // Rule ID 5127 //
     /* 1239598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1239609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1239612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1239615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1239618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239651 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239673 */     // GIR_Coverage, 5127,
     /* 1239673 */     GIR_EraseRootFromParent_Done,
     /* 1239674 */   // Label 17943: @1239674
     /* 1239674 */   GIM_Try, /*On fail goto*//*Label 17944*/ GIMT_Encode4(1239755), // Rule ID 5128 //
     /* 1239679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1239690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1239693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1239696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1239699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239754 */     // GIR_Coverage, 5128,
     /* 1239754 */     GIR_EraseRootFromParent_Done,
     /* 1239755 */   // Label 17944: @1239755
     /* 1239755 */   GIM_Try, /*On fail goto*//*Label 17945*/ GIMT_Encode4(1239836), // Rule ID 5129 //
     /* 1239760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1239771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1239774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1239777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1239780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239813 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239835 */     // GIR_Coverage, 5129,
     /* 1239835 */     GIR_EraseRootFromParent_Done,
     /* 1239836 */   // Label 17945: @1239836
     /* 1239836 */   GIM_Try, /*On fail goto*//*Label 17946*/ GIMT_Encode4(1239917), // Rule ID 5130 //
     /* 1239841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1239852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1239855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1239858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1239861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1239894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239916 */     // GIR_Coverage, 5130,
     /* 1239916 */     GIR_EraseRootFromParent_Done,
     /* 1239917 */   // Label 17946: @1239917
     /* 1239917 */   GIM_Try, /*On fail goto*//*Label 17947*/ GIMT_Encode4(1239998), // Rule ID 5131 //
     /* 1239922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1239933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1239936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1239939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1239942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239975 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1239975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1239978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239997 */     // GIR_Coverage, 5131,
     /* 1239997 */     GIR_EraseRootFromParent_Done,
     /* 1239998 */   // Label 17947: @1239998
     /* 1239998 */   GIM_Try, /*On fail goto*//*Label 17948*/ GIMT_Encode4(1240079), // Rule ID 5132 //
     /* 1240003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1240006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240056 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1240056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240078 */     // GIR_Coverage, 5132,
     /* 1240078 */     GIR_EraseRootFromParent_Done,
     /* 1240079 */   // Label 17948: @1240079
     /* 1240079 */   GIM_Try, /*On fail goto*//*Label 17949*/ GIMT_Encode4(1240160), // Rule ID 5133 //
     /* 1240084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1240087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240137 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1240137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1240140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240159 */     // GIR_Coverage, 5133,
     /* 1240159 */     GIR_EraseRootFromParent_Done,
     /* 1240160 */   // Label 17949: @1240160
     /* 1240160 */   GIM_Try, /*On fail goto*//*Label 17950*/ GIMT_Encode4(1240241), // Rule ID 5134 //
     /* 1240165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240240 */     // GIR_Coverage, 5134,
     /* 1240240 */     GIR_EraseRootFromParent_Done,
     /* 1240241 */   // Label 17950: @1240241
     /* 1240241 */   GIM_Try, /*On fail goto*//*Label 17951*/ GIMT_Encode4(1240322), // Rule ID 5135 //
     /* 1240246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240299 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240321 */     // GIR_Coverage, 5135,
     /* 1240321 */     GIR_EraseRootFromParent_Done,
     /* 1240322 */   // Label 17951: @1240322
     /* 1240322 */   GIM_Try, /*On fail goto*//*Label 17952*/ GIMT_Encode4(1240403), // Rule ID 5136 //
     /* 1240327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240380 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240402 */     // GIR_Coverage, 5136,
     /* 1240402 */     GIR_EraseRootFromParent_Done,
     /* 1240403 */   // Label 17952: @1240403
     /* 1240403 */   GIM_Try, /*On fail goto*//*Label 17953*/ GIMT_Encode4(1240484), // Rule ID 5137 //
     /* 1240408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240461 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240483 */     // GIR_Coverage, 5137,
     /* 1240483 */     GIR_EraseRootFromParent_Done,
     /* 1240484 */   // Label 17953: @1240484
     /* 1240484 */   GIM_Try, /*On fail goto*//*Label 17954*/ GIMT_Encode4(1240565), // Rule ID 5138 //
     /* 1240489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1240500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1240503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1240506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1240509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1240512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1240519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240542 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1240545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240564 */     // GIR_Coverage, 5138,
     /* 1240564 */     GIR_EraseRootFromParent_Done,
     /* 1240565 */   // Label 17954: @1240565
     /* 1240565 */   GIM_Try, /*On fail goto*//*Label 17955*/ GIMT_Encode4(1240646), // Rule ID 5139 //
     /* 1240570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1240581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1240584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1240587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1240590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1240593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1240600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1240612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240623 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1240626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240645 */     // GIR_Coverage, 5139,
     /* 1240645 */     GIR_EraseRootFromParent_Done,
     /* 1240646 */   // Label 17955: @1240646
     /* 1240646 */   GIM_Try, /*On fail goto*//*Label 17956*/ GIMT_Encode4(1240727), // Rule ID 5140 //
     /* 1240651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1240662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1240665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1240668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1240671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1240704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240726 */     // GIR_Coverage, 5140,
     /* 1240726 */     GIR_EraseRootFromParent_Done,
     /* 1240727 */   // Label 17956: @1240727
     /* 1240727 */   GIM_Try, /*On fail goto*//*Label 17957*/ GIMT_Encode4(1240808), // Rule ID 5141 //
     /* 1240732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1240743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1240746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1240749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1240752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240785 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1240785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1240788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240807 */     // GIR_Coverage, 5141,
     /* 1240807 */     GIR_EraseRootFromParent_Done,
     /* 1240808 */   // Label 17957: @1240808
     /* 1240808 */   GIM_Try, /*On fail goto*//*Label 17958*/ GIMT_Encode4(1240889), // Rule ID 5142 //
     /* 1240813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1240824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1240827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1240830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1240833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1240866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240888 */     // GIR_Coverage, 5142,
     /* 1240888 */     GIR_EraseRootFromParent_Done,
     /* 1240889 */   // Label 17958: @1240889
     /* 1240889 */   GIM_Try, /*On fail goto*//*Label 17959*/ GIMT_Encode4(1240970), // Rule ID 5143 //
     /* 1240894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1240905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1240908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1240911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1240914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240947 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1240947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1240950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240969 */     // GIR_Coverage, 5143,
     /* 1240969 */     GIR_EraseRootFromParent_Done,
     /* 1240970 */   // Label 17959: @1240970
     /* 1240970 */   GIM_Try, /*On fail goto*//*Label 17960*/ GIMT_Encode4(1241051), // Rule ID 5144 //
     /* 1240975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1240983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1240986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1240989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1240992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1240995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241028 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241050 */     // GIR_Coverage, 5144,
     /* 1241050 */     GIR_EraseRootFromParent_Done,
     /* 1241051 */   // Label 17960: @1241051
     /* 1241051 */   GIM_Try, /*On fail goto*//*Label 17961*/ GIMT_Encode4(1241132), // Rule ID 5145 //
     /* 1241056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1241076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241109 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241131 */     // GIR_Coverage, 5145,
     /* 1241131 */     GIR_EraseRootFromParent_Done,
     /* 1241132 */   // Label 17961: @1241132
     /* 1241132 */   GIM_Try, /*On fail goto*//*Label 17962*/ GIMT_Encode4(1241213), // Rule ID 5146 //
     /* 1241137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241212 */     // GIR_Coverage, 5146,
     /* 1241212 */     GIR_EraseRootFromParent_Done,
     /* 1241213 */   // Label 17962: @1241213
     /* 1241213 */   GIM_Try, /*On fail goto*//*Label 17963*/ GIMT_Encode4(1241294), // Rule ID 5147 //
     /* 1241218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241271 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241293 */     // GIR_Coverage, 5147,
     /* 1241293 */     GIR_EraseRootFromParent_Done,
     /* 1241294 */   // Label 17963: @1241294
     /* 1241294 */   GIM_Try, /*On fail goto*//*Label 17964*/ GIMT_Encode4(1241375), // Rule ID 5148 //
     /* 1241299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241352 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241374 */     // GIR_Coverage, 5148,
     /* 1241374 */     GIR_EraseRootFromParent_Done,
     /* 1241375 */   // Label 17964: @1241375
     /* 1241375 */   GIM_Try, /*On fail goto*//*Label 17965*/ GIMT_Encode4(1241456), // Rule ID 5149 //
     /* 1241380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241433 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241455 */     // GIR_Coverage, 5149,
     /* 1241455 */     GIR_EraseRootFromParent_Done,
     /* 1241456 */   // Label 17965: @1241456
     /* 1241456 */   GIM_Try, /*On fail goto*//*Label 17966*/ GIMT_Encode4(1241537), // Rule ID 5150 //
     /* 1241461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1241472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1241475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1241478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1241481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241514 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241536 */     // GIR_Coverage, 5150,
     /* 1241536 */     GIR_EraseRootFromParent_Done,
     /* 1241537 */   // Label 17966: @1241537
     /* 1241537 */   GIM_Try, /*On fail goto*//*Label 17967*/ GIMT_Encode4(1241618), // Rule ID 5151 //
     /* 1241542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1241553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1241556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1241559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1241562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241595 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1241598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241617 */     // GIR_Coverage, 5151,
     /* 1241617 */     GIR_EraseRootFromParent_Done,
     /* 1241618 */   // Label 17967: @1241618
     /* 1241618 */   GIM_Try, /*On fail goto*//*Label 17968*/ GIMT_Encode4(1241699), // Rule ID 5152 //
     /* 1241623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1241626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1241634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1241637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1241640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1241643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1241646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1241676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241698 */     // GIR_Coverage, 5152,
     /* 1241698 */     GIR_EraseRootFromParent_Done,
     /* 1241699 */   // Label 17968: @1241699
     /* 1241699 */   GIM_Try, /*On fail goto*//*Label 17969*/ GIMT_Encode4(1241780), // Rule ID 5153 //
     /* 1241704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1241707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1241715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1241718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1241721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1241724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1241727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1241757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1241760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241779 */     // GIR_Coverage, 5153,
     /* 1241779 */     GIR_EraseRootFromParent_Done,
     /* 1241780 */   // Label 17969: @1241780
     /* 1241780 */   GIM_Try, /*On fail goto*//*Label 17970*/ GIMT_Encode4(1241861), // Rule ID 5154 //
     /* 1241785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1241788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1241796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1241799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1241802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1241805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1241838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241860 */     // GIR_Coverage, 5154,
     /* 1241860 */     GIR_EraseRootFromParent_Done,
     /* 1241861 */   // Label 17970: @1241861
     /* 1241861 */   GIM_Try, /*On fail goto*//*Label 17971*/ GIMT_Encode4(1241942), // Rule ID 5155 //
     /* 1241866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1241869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1241877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1241880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1241883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1241886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241919 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1241919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1241922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1241940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241941 */     // GIR_Coverage, 5155,
     /* 1241941 */     GIR_EraseRootFromParent_Done,
     /* 1241942 */   // Label 17971: @1241942
     /* 1241942 */   GIM_Try, /*On fail goto*//*Label 17972*/ GIMT_Encode4(1242023), // Rule ID 5156 //
     /* 1241947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1241950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1241955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1241958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1241961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1241964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1241967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242000 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242022 */     // GIR_Coverage, 5156,
     /* 1242022 */     GIR_EraseRootFromParent_Done,
     /* 1242023 */   // Label 17972: @1242023
     /* 1242023 */   GIM_Try, /*On fail goto*//*Label 17973*/ GIMT_Encode4(1242104), // Rule ID 5157 //
     /* 1242028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1242039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1242042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1242045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1242048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242081 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1242084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242103 */     // GIR_Coverage, 5157,
     /* 1242103 */     GIR_EraseRootFromParent_Done,
     /* 1242104 */   // Label 17973: @1242104
     /* 1242104 */   GIM_Try, /*On fail goto*//*Label 17974*/ GIMT_Encode4(1242185), // Rule ID 5158 //
     /* 1242109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242162 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1242165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242184 */     // GIR_Coverage, 5158,
     /* 1242184 */     GIR_EraseRootFromParent_Done,
     /* 1242185 */   // Label 17974: @1242185
     /* 1242185 */   GIM_Try, /*On fail goto*//*Label 17975*/ GIMT_Encode4(1242266), // Rule ID 5159 //
     /* 1242190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242243 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1242246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242265 */     // GIR_Coverage, 5159,
     /* 1242265 */     GIR_EraseRootFromParent_Done,
     /* 1242266 */   // Label 17975: @1242266
     /* 1242266 */   GIM_Try, /*On fail goto*//*Label 17976*/ GIMT_Encode4(1242347), // Rule ID 5160 //
     /* 1242271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242324 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242346 */     // GIR_Coverage, 5160,
     /* 1242346 */     GIR_EraseRootFromParent_Done,
     /* 1242347 */   // Label 17976: @1242347
     /* 1242347 */   GIM_Try, /*On fail goto*//*Label 17977*/ GIMT_Encode4(1242428), // Rule ID 5161 //
     /* 1242352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242405 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242427 */     // GIR_Coverage, 5161,
     /* 1242427 */     GIR_EraseRootFromParent_Done,
     /* 1242428 */   // Label 17977: @1242428
     /* 1242428 */   GIM_Try, /*On fail goto*//*Label 17978*/ GIMT_Encode4(1242509), // Rule ID 5162 //
     /* 1242433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242486 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242508 */     // GIR_Coverage, 5162,
     /* 1242508 */     GIR_EraseRootFromParent_Done,
     /* 1242509 */   // Label 17978: @1242509
     /* 1242509 */   GIM_Try, /*On fail goto*//*Label 17979*/ GIMT_Encode4(1242590), // Rule ID 5163 //
     /* 1242514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242567 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242589 */     // GIR_Coverage, 5163,
     /* 1242589 */     GIR_EraseRootFromParent_Done,
     /* 1242590 */   // Label 17979: @1242590
     /* 1242590 */   GIM_Try, /*On fail goto*//*Label 17980*/ GIMT_Encode4(1242671), // Rule ID 5164 //
     /* 1242595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1242606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1242609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1242612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1242648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242670 */     // GIR_Coverage, 5164,
     /* 1242670 */     GIR_EraseRootFromParent_Done,
     /* 1242671 */   // Label 17980: @1242671
     /* 1242671 */   GIM_Try, /*On fail goto*//*Label 17981*/ GIMT_Encode4(1242752), // Rule ID 5165 //
     /* 1242676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1242687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1242690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1242693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242729 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1242729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1242732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242751 */     // GIR_Coverage, 5165,
     /* 1242751 */     GIR_EraseRootFromParent_Done,
     /* 1242752 */   // Label 17981: @1242752
     /* 1242752 */   GIM_Try, /*On fail goto*//*Label 17982*/ GIMT_Encode4(1242833), // Rule ID 5166 //
     /* 1242757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1242768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1242771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1242774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242810 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1242810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242832 */     // GIR_Coverage, 5166,
     /* 1242832 */     GIR_EraseRootFromParent_Done,
     /* 1242833 */   // Label 17982: @1242833
     /* 1242833 */   GIM_Try, /*On fail goto*//*Label 17983*/ GIMT_Encode4(1242914), // Rule ID 5167 //
     /* 1242838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1242849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1242852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1242855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242891 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1242891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1242912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242913 */     // GIR_Coverage, 5167,
     /* 1242913 */     GIR_EraseRootFromParent_Done,
     /* 1242914 */   // Label 17983: @1242914
     /* 1242914 */   GIM_Try, /*On fail goto*//*Label 17984*/ GIMT_Encode4(1242995), // Rule ID 5168 //
     /* 1242919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1242927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1242930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1242933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1242936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242972 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1242972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1242975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242994 */     // GIR_Coverage, 5168,
     /* 1242994 */     GIR_EraseRootFromParent_Done,
     /* 1242995 */   // Label 17984: @1242995
     /* 1242995 */   GIM_Try, /*On fail goto*//*Label 17985*/ GIMT_Encode4(1243076), // Rule ID 5169 //
     /* 1243000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243053 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1243053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1243056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243075 */     // GIR_Coverage, 5169,
     /* 1243075 */     GIR_EraseRootFromParent_Done,
     /* 1243076 */   // Label 17985: @1243076
     /* 1243076 */   GIM_Try, /*On fail goto*//*Label 17986*/ GIMT_Encode4(1243157), // Rule ID 5170 //
     /* 1243081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243134 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243156 */     // GIR_Coverage, 5170,
     /* 1243156 */     GIR_EraseRootFromParent_Done,
     /* 1243157 */   // Label 17986: @1243157
     /* 1243157 */   GIM_Try, /*On fail goto*//*Label 17987*/ GIMT_Encode4(1243238), // Rule ID 5171 //
     /* 1243162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243215 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11142:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243237 */     // GIR_Coverage, 5171,
     /* 1243237 */     GIR_EraseRootFromParent_Done,
     /* 1243238 */   // Label 17987: @1243238
     /* 1243238 */   GIM_Try, /*On fail goto*//*Label 17988*/ GIMT_Encode4(1243319), // Rule ID 5172 //
     /* 1243243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243296 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243318 */     // GIR_Coverage, 5172,
     /* 1243318 */     GIR_EraseRootFromParent_Done,
     /* 1243319 */   // Label 17988: @1243319
     /* 1243319 */   GIM_Try, /*On fail goto*//*Label 17989*/ GIMT_Encode4(1243400), // Rule ID 5173 //
     /* 1243324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243377 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243399 */     // GIR_Coverage, 5173,
     /* 1243399 */     GIR_EraseRootFromParent_Done,
     /* 1243400 */   // Label 17989: @1243400
     /* 1243400 */   GIM_Try, /*On fail goto*//*Label 17990*/ GIMT_Encode4(1243481), // Rule ID 5174 //
     /* 1243405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1243458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243480 */     // GIR_Coverage, 5174,
     /* 1243480 */     GIR_EraseRootFromParent_Done,
     /* 1243481 */   // Label 17990: @1243481
     /* 1243481 */   GIM_Try, /*On fail goto*//*Label 17991*/ GIMT_Encode4(1243562), // Rule ID 5175 //
     /* 1243486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243539 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1243539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243561 */     // GIR_Coverage, 5175,
     /* 1243561 */     GIR_EraseRootFromParent_Done,
     /* 1243562 */   // Label 17991: @1243562
     /* 1243562 */   GIM_Try, /*On fail goto*//*Label 17992*/ GIMT_Encode4(1243643), // Rule ID 5176 //
     /* 1243567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1243570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1243578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1243581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1243584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1243620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243642 */     // GIR_Coverage, 5176,
     /* 1243642 */     GIR_EraseRootFromParent_Done,
     /* 1243643 */   // Label 17992: @1243643
     /* 1243643 */   GIM_Try, /*On fail goto*//*Label 17993*/ GIMT_Encode4(1243724), // Rule ID 5177 //
     /* 1243648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1243651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1243659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1243662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1243665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243701 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1243701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1243704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1243722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243723 */     // GIR_Coverage, 5177,
     /* 1243723 */     GIR_EraseRootFromParent_Done,
     /* 1243724 */   // Label 17993: @1243724
     /* 1243724 */   GIM_Try, /*On fail goto*//*Label 17994*/ GIMT_Encode4(1243805), // Rule ID 5178 //
     /* 1243729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1243740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1243743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1243746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1243752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1243759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243782 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1243785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243804 */     // GIR_Coverage, 5178,
     /* 1243804 */     GIR_EraseRootFromParent_Done,
     /* 1243805 */   // Label 17994: @1243805
     /* 1243805 */   GIM_Try, /*On fail goto*//*Label 17995*/ GIMT_Encode4(1243886), // Rule ID 5179 //
     /* 1243810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1243821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1243824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1243827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1243833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1243840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1243848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243863 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1243866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243885 */     // GIR_Coverage, 5179,
     /* 1243885 */     GIR_EraseRootFromParent_Done,
     /* 1243886 */   // Label 17995: @1243886
     /* 1243886 */   GIM_Try, /*On fail goto*//*Label 17996*/ GIMT_Encode4(1243967), // Rule ID 5180 //
     /* 1243891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1243902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1243905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1243908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1243914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1243921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1243929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243944 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1243947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243966 */     // GIR_Coverage, 5180,
     /* 1243966 */     GIR_EraseRootFromParent_Done,
     /* 1243967 */   // Label 17996: @1243967
     /* 1243967 */   GIM_Try, /*On fail goto*//*Label 17997*/ GIMT_Encode4(1244048), // Rule ID 5181 //
     /* 1243972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1243980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1243983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1243986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1243989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1243995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244025 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244047 */     // GIR_Coverage, 5181,
     /* 1244047 */     GIR_EraseRootFromParent_Done,
     /* 1244048 */   // Label 17997: @1244048
     /* 1244048 */   GIM_Try, /*On fail goto*//*Label 17998*/ GIMT_Encode4(1244129), // Rule ID 5182 //
     /* 1244053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244106 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244128 */     // GIR_Coverage, 5182,
     /* 1244128 */     GIR_EraseRootFromParent_Done,
     /* 1244129 */   // Label 17998: @1244129
     /* 1244129 */   GIM_Try, /*On fail goto*//*Label 17999*/ GIMT_Encode4(1244210), // Rule ID 5183 //
     /* 1244134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244187 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244209 */     // GIR_Coverage, 5183,
     /* 1244209 */     GIR_EraseRootFromParent_Done,
     /* 1244210 */   // Label 17999: @1244210
     /* 1244210 */   GIM_Try, /*On fail goto*//*Label 18000*/ GIMT_Encode4(1244291), // Rule ID 5184 //
     /* 1244215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244290 */     // GIR_Coverage, 5184,
     /* 1244290 */     GIR_EraseRootFromParent_Done,
     /* 1244291 */   // Label 18000: @1244291
     /* 1244291 */   GIM_Try, /*On fail goto*//*Label 18001*/ GIMT_Encode4(1244372), // Rule ID 5185 //
     /* 1244296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244349 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244371 */     // GIR_Coverage, 5185,
     /* 1244371 */     GIR_EraseRootFromParent_Done,
     /* 1244372 */   // Label 18001: @1244372
     /* 1244372 */   GIM_Try, /*On fail goto*//*Label 18002*/ GIMT_Encode4(1244453), // Rule ID 5186 //
     /* 1244377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244430 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244452 */     // GIR_Coverage, 5186,
     /* 1244452 */     GIR_EraseRootFromParent_Done,
     /* 1244453 */   // Label 18002: @1244453
     /* 1244453 */   GIM_Try, /*On fail goto*//*Label 18003*/ GIMT_Encode4(1244534), // Rule ID 5187 //
     /* 1244458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244511 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244533 */     // GIR_Coverage, 5187,
     /* 1244533 */     GIR_EraseRootFromParent_Done,
     /* 1244534 */   // Label 18003: @1244534
     /* 1244534 */   GIM_Try, /*On fail goto*//*Label 18004*/ GIMT_Encode4(1244615), // Rule ID 5188 //
     /* 1244539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1244550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1244553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1244556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244592 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244614 */     // GIR_Coverage, 5188,
     /* 1244614 */     GIR_EraseRootFromParent_Done,
     /* 1244615 */   // Label 18004: @1244615
     /* 1244615 */   GIM_Try, /*On fail goto*//*Label 18005*/ GIMT_Encode4(1244696), // Rule ID 5189 //
     /* 1244620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1244631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1244634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1244637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244673 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1244676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244695 */     // GIR_Coverage, 5189,
     /* 1244695 */     GIR_EraseRootFromParent_Done,
     /* 1244696 */   // Label 18005: @1244696
     /* 1244696 */   GIM_Try, /*On fail goto*//*Label 18006*/ GIMT_Encode4(1244777), // Rule ID 5190 //
     /* 1244701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1244712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1244715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1244718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1244724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1244754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244776 */     // GIR_Coverage, 5190,
     /* 1244776 */     GIR_EraseRootFromParent_Done,
     /* 1244777 */   // Label 18006: @1244777
     /* 1244777 */   GIM_Try, /*On fail goto*//*Label 18007*/ GIMT_Encode4(1244858), // Rule ID 5191 //
     /* 1244782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1244793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1244796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1244799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1244805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1244835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1244838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244857 */     // GIR_Coverage, 5191,
     /* 1244857 */     GIR_EraseRootFromParent_Done,
     /* 1244858 */   // Label 18007: @1244858
     /* 1244858 */   GIM_Try, /*On fail goto*//*Label 18008*/ GIMT_Encode4(1244939), // Rule ID 5192 //
     /* 1244863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1244874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1244877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1244880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244916 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1244916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1244919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244938 */     // GIR_Coverage, 5192,
     /* 1244938 */     GIR_EraseRootFromParent_Done,
     /* 1244939 */   // Label 18008: @1244939
     /* 1244939 */   GIM_Try, /*On fail goto*//*Label 18009*/ GIMT_Encode4(1245020), // Rule ID 5193 //
     /* 1244944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1244952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1244955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1244958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1244961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244997 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1244997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245019 */     // GIR_Coverage, 5193,
     /* 1245019 */     GIR_EraseRootFromParent_Done,
     /* 1245020 */   // Label 18009: @1245020
     /* 1245020 */   GIM_Try, /*On fail goto*//*Label 18010*/ GIMT_Encode4(1245101), // Rule ID 5194 //
     /* 1245025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245078 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245100 */     // GIR_Coverage, 5194,
     /* 1245100 */     GIR_EraseRootFromParent_Done,
     /* 1245101 */   // Label 18010: @1245101
     /* 1245101 */   GIM_Try, /*On fail goto*//*Label 18011*/ GIMT_Encode4(1245182), // Rule ID 5195 //
     /* 1245106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245159 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245181 */     // GIR_Coverage, 5195,
     /* 1245181 */     GIR_EraseRootFromParent_Done,
     /* 1245182 */   // Label 18011: @1245182
     /* 1245182 */   GIM_Try, /*On fail goto*//*Label 18012*/ GIMT_Encode4(1245263), // Rule ID 5196 //
     /* 1245187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245262 */     // GIR_Coverage, 5196,
     /* 1245262 */     GIR_EraseRootFromParent_Done,
     /* 1245263 */   // Label 18012: @1245263
     /* 1245263 */   GIM_Try, /*On fail goto*//*Label 18013*/ GIMT_Encode4(1245344), // Rule ID 5197 //
     /* 1245268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245321 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1245324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245343 */     // GIR_Coverage, 5197,
     /* 1245343 */     GIR_EraseRootFromParent_Done,
     /* 1245344 */   // Label 18013: @1245344
     /* 1245344 */   GIM_Try, /*On fail goto*//*Label 18014*/ GIMT_Encode4(1245425), // Rule ID 5198 //
     /* 1245349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245402 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245424 */     // GIR_Coverage, 5198,
     /* 1245424 */     GIR_EraseRootFromParent_Done,
     /* 1245425 */   // Label 18014: @1245425
     /* 1245425 */   GIM_Try, /*On fail goto*//*Label 18015*/ GIMT_Encode4(1245506), // Rule ID 5199 //
     /* 1245430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245483 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1245486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245505 */     // GIR_Coverage, 5199,
     /* 1245505 */     GIR_EraseRootFromParent_Done,
     /* 1245506 */   // Label 18015: @1245506
     /* 1245506 */   GIM_Try, /*On fail goto*//*Label 18016*/ GIMT_Encode4(1245587), // Rule ID 5200 //
     /* 1245511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1245522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1245525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1245528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245564 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245586 */     // GIR_Coverage, 5200,
     /* 1245586 */     GIR_EraseRootFromParent_Done,
     /* 1245587 */   // Label 18016: @1245587
     /* 1245587 */   GIM_Try, /*On fail goto*//*Label 18017*/ GIMT_Encode4(1245668), // Rule ID 5201 //
     /* 1245592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1245600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1245603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1245606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1245609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245645 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1245648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245667 */     // GIR_Coverage, 5201,
     /* 1245667 */     GIR_EraseRootFromParent_Done,
     /* 1245668 */   // Label 18017: @1245668
     /* 1245668 */   GIM_Try, /*On fail goto*//*Label 18018*/ GIMT_Encode4(1245749), // Rule ID 5506 //
     /* 1245673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1245684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1245687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1245690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1245693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1245696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1245726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1245729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245748 */     // GIR_Coverage, 5506,
     /* 1245748 */     GIR_EraseRootFromParent_Done,
     /* 1245749 */   // Label 18018: @1245749
     /* 1245749 */   GIM_Try, /*On fail goto*//*Label 18019*/ GIMT_Encode4(1245830), // Rule ID 5507 //
     /* 1245754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1245765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1245768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1245771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1245774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1245777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245807 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1245807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1245810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245829 */     // GIR_Coverage, 5507,
     /* 1245829 */     GIR_EraseRootFromParent_Done,
     /* 1245830 */   // Label 18019: @1245830
     /* 1245830 */   GIM_Try, /*On fail goto*//*Label 18020*/ GIMT_Encode4(1245911), // Rule ID 5508 //
     /* 1245835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1245846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1245849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1245852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1245855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245888 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1245888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1245891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245910 */     // GIR_Coverage, 5508,
     /* 1245910 */     GIR_EraseRootFromParent_Done,
     /* 1245911 */   // Label 18020: @1245911
     /* 1245911 */   GIM_Try, /*On fail goto*//*Label 18021*/ GIMT_Encode4(1245992), // Rule ID 5509 //
     /* 1245916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1245927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1245930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1245933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1245936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1245946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1245958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245969 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1245969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1245972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1245990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245991 */     // GIR_Coverage, 5509,
     /* 1245991 */     GIR_EraseRootFromParent_Done,
     /* 1245992 */   // Label 18021: @1245992
     /* 1245992 */   GIM_Try, /*On fail goto*//*Label 18022*/ GIMT_Encode4(1246073), // Rule ID 5510 //
     /* 1245997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246050 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246072 */     // GIR_Coverage, 5510,
     /* 1246072 */     GIR_EraseRootFromParent_Done,
     /* 1246073 */   // Label 18022: @1246073
     /* 1246073 */   GIM_Try, /*On fail goto*//*Label 18023*/ GIMT_Encode4(1246154), // Rule ID 5511 //
     /* 1246078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1246089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1246092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246131 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246153 */     // GIR_Coverage, 5511,
     /* 1246153 */     GIR_EraseRootFromParent_Done,
     /* 1246154 */   // Label 18023: @1246154
     /* 1246154 */   GIM_Try, /*On fail goto*//*Label 18024*/ GIMT_Encode4(1246235), // Rule ID 5512 //
     /* 1246159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246212 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246234 */     // GIR_Coverage, 5512,
     /* 1246234 */     GIR_EraseRootFromParent_Done,
     /* 1246235 */   // Label 18024: @1246235
     /* 1246235 */   GIM_Try, /*On fail goto*//*Label 18025*/ GIMT_Encode4(1246316), // Rule ID 5513 //
     /* 1246240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1246251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1246254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246293 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1246296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246315 */     // GIR_Coverage, 5513,
     /* 1246315 */     GIR_EraseRootFromParent_Done,
     /* 1246316 */   // Label 18025: @1246316
     /* 1246316 */   GIM_Try, /*On fail goto*//*Label 18026*/ GIMT_Encode4(1246397), // Rule ID 5514 //
     /* 1246321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246396 */     // GIR_Coverage, 5514,
     /* 1246396 */     GIR_EraseRootFromParent_Done,
     /* 1246397 */   // Label 18026: @1246397
     /* 1246397 */   GIM_Try, /*On fail goto*//*Label 18027*/ GIMT_Encode4(1246478), // Rule ID 5515 //
     /* 1246402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1246413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1246416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246455 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246477 */     // GIR_Coverage, 5515,
     /* 1246477 */     GIR_EraseRootFromParent_Done,
     /* 1246478 */   // Label 18027: @1246478
     /* 1246478 */   GIM_Try, /*On fail goto*//*Label 18028*/ GIMT_Encode4(1246559), // Rule ID 5516 //
     /* 1246483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1246494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1246497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1246503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246536 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1246536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246558 */     // GIR_Coverage, 5516,
     /* 1246558 */     GIR_EraseRootFromParent_Done,
     /* 1246559 */   // Label 18028: @1246559
     /* 1246559 */   GIM_Try, /*On fail goto*//*Label 18029*/ GIMT_Encode4(1246640), // Rule ID 5517 //
     /* 1246564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1246575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1246578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1246584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246617 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1246617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1246620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246639 */     // GIR_Coverage, 5517,
     /* 1246639 */     GIR_EraseRootFromParent_Done,
     /* 1246640 */   // Label 18029: @1246640
     /* 1246640 */   GIM_Try, /*On fail goto*//*Label 18030*/ GIMT_Encode4(1246721), // Rule ID 5518 //
     /* 1246645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1246656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1246659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1246662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1246665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246698 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1246698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1246701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246720 */     // GIR_Coverage, 5518,
     /* 1246720 */     GIR_EraseRootFromParent_Done,
     /* 1246721 */   // Label 18030: @1246721
     /* 1246721 */   GIM_Try, /*On fail goto*//*Label 18031*/ GIMT_Encode4(1246802), // Rule ID 5519 //
     /* 1246726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1246737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1246740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1246743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1246746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246779 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1246779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1246782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246801 */     // GIR_Coverage, 5519,
     /* 1246801 */     GIR_EraseRootFromParent_Done,
     /* 1246802 */   // Label 18031: @1246802
     /* 1246802 */   GIM_Try, /*On fail goto*//*Label 18032*/ GIMT_Encode4(1246883), // Rule ID 5520 //
     /* 1246807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1246818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1246821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1246824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1246827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246860 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1246860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1246863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246882 */     // GIR_Coverage, 5520,
     /* 1246882 */     GIR_EraseRootFromParent_Done,
     /* 1246883 */   // Label 18032: @1246883
     /* 1246883 */   GIM_Try, /*On fail goto*//*Label 18033*/ GIMT_Encode4(1246964), // Rule ID 5521 //
     /* 1246888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1246899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1246902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1246905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1246908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246941 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1246941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1246944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246963 */     // GIR_Coverage, 5521,
     /* 1246963 */     GIR_EraseRootFromParent_Done,
     /* 1246964 */   // Label 18033: @1246964
     /* 1246964 */   GIM_Try, /*On fail goto*//*Label 18034*/ GIMT_Encode4(1247045), // Rule ID 5522 //
     /* 1246969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1246980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1246983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1246986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1246989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1246999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247022 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1247022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247044 */     // GIR_Coverage, 5522,
     /* 1247044 */     GIR_EraseRootFromParent_Done,
     /* 1247045 */   // Label 18034: @1247045
     /* 1247045 */   GIM_Try, /*On fail goto*//*Label 18035*/ GIMT_Encode4(1247126), // Rule ID 5523 //
     /* 1247050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1247061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1247064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1247070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247103 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1247103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247125 */     // GIR_Coverage, 5523,
     /* 1247125 */     GIR_EraseRootFromParent_Done,
     /* 1247126 */   // Label 18035: @1247126
     /* 1247126 */   GIM_Try, /*On fail goto*//*Label 18036*/ GIMT_Encode4(1247207), // Rule ID 5524 //
     /* 1247131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1247134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1247184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247206 */     // GIR_Coverage, 5524,
     /* 1247206 */     GIR_EraseRootFromParent_Done,
     /* 1247207 */   // Label 18036: @1247207
     /* 1247207 */   GIM_Try, /*On fail goto*//*Label 18037*/ GIMT_Encode4(1247288), // Rule ID 5525 //
     /* 1247212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1247215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1247223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1247226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1247242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247265 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1247265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1247268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247287 */     // GIR_Coverage, 5525,
     /* 1247287 */     GIR_EraseRootFromParent_Done,
     /* 1247288 */   // Label 18037: @1247288
     /* 1247288 */   GIM_Try, /*On fail goto*//*Label 18038*/ GIMT_Encode4(1247369), // Rule ID 5526 //
     /* 1247293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247368 */     // GIR_Coverage, 5526,
     /* 1247368 */     GIR_EraseRootFromParent_Done,
     /* 1247369 */   // Label 18038: @1247369
     /* 1247369 */   GIM_Try, /*On fail goto*//*Label 18039*/ GIMT_Encode4(1247450), // Rule ID 5527 //
     /* 1247374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1247385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1247388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247427 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247449 */     // GIR_Coverage, 5527,
     /* 1247449 */     GIR_EraseRootFromParent_Done,
     /* 1247450 */   // Label 18039: @1247450
     /* 1247450 */   GIM_Try, /*On fail goto*//*Label 18040*/ GIMT_Encode4(1247531), // Rule ID 5528 //
     /* 1247455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1247466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1247469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1247475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247508 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1247511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247530 */     // GIR_Coverage, 5528,
     /* 1247530 */     GIR_EraseRootFromParent_Done,
     /* 1247531 */   // Label 18040: @1247531
     /* 1247531 */   GIM_Try, /*On fail goto*//*Label 18041*/ GIMT_Encode4(1247612), // Rule ID 5529 //
     /* 1247536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1247547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1247550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1247556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247589 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1247592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247611 */     // GIR_Coverage, 5529,
     /* 1247611 */     GIR_EraseRootFromParent_Done,
     /* 1247612 */   // Label 18041: @1247612
     /* 1247612 */   GIM_Try, /*On fail goto*//*Label 18042*/ GIMT_Encode4(1247693), // Rule ID 5530 //
     /* 1247617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1247628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1247631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1247634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1247637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1247640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1247647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247670 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1247670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1247673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247692 */     // GIR_Coverage, 5530,
     /* 1247692 */     GIR_EraseRootFromParent_Done,
     /* 1247693 */   // Label 18042: @1247693
     /* 1247693 */   GIM_Try, /*On fail goto*//*Label 18043*/ GIMT_Encode4(1247774), // Rule ID 5531 //
     /* 1247698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1247709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1247712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1247715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1247718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1247721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1247728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1247740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247751 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1247751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1247754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247773 */     // GIR_Coverage, 5531,
     /* 1247773 */     GIR_EraseRootFromParent_Done,
     /* 1247774 */   // Label 18043: @1247774
     /* 1247774 */   GIM_Try, /*On fail goto*//*Label 18044*/ GIMT_Encode4(1247855), // Rule ID 5532 //
     /* 1247779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1247790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1247793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1247796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1247799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1247832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247854 */     // GIR_Coverage, 5532,
     /* 1247854 */     GIR_EraseRootFromParent_Done,
     /* 1247855 */   // Label 18044: @1247855
     /* 1247855 */   GIM_Try, /*On fail goto*//*Label 18045*/ GIMT_Encode4(1247936), // Rule ID 5533 //
     /* 1247860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1247871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1247874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1247877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1247880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1247890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247913 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1247913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1247916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247935 */     // GIR_Coverage, 5533,
     /* 1247935 */     GIR_EraseRootFromParent_Done,
     /* 1247936 */   // Label 18045: @1247936
     /* 1247936 */   GIM_Try, /*On fail goto*//*Label 18046*/ GIMT_Encode4(1248017), // Rule ID 5534 //
     /* 1247941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1247949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1247952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1247955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1247958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1247961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1247971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247994 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1247994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1247997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248016 */     // GIR_Coverage, 5534,
     /* 1248016 */     GIR_EraseRootFromParent_Done,
     /* 1248017 */   // Label 18046: @1248017
     /* 1248017 */   GIM_Try, /*On fail goto*//*Label 18047*/ GIMT_Encode4(1248098), // Rule ID 5535 //
     /* 1248022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1248033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1248036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1248042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248075 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248097 */     // GIR_Coverage, 5535,
     /* 1248097 */     GIR_EraseRootFromParent_Done,
     /* 1248098 */   // Label 18047: @1248098
     /* 1248098 */   GIM_Try, /*On fail goto*//*Label 18048*/ GIMT_Encode4(1248179), // Rule ID 5536 //
     /* 1248103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248156 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1248156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248178 */     // GIR_Coverage, 5536,
     /* 1248178 */     GIR_EraseRootFromParent_Done,
     /* 1248179 */   // Label 18048: @1248179
     /* 1248179 */   GIM_Try, /*On fail goto*//*Label 18049*/ GIMT_Encode4(1248260), // Rule ID 5537 //
     /* 1248184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1248195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1248198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248237 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1248237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248259 */     // GIR_Coverage, 5537,
     /* 1248259 */     GIR_EraseRootFromParent_Done,
     /* 1248260 */   // Label 18049: @1248260
     /* 1248260 */   GIM_Try, /*On fail goto*//*Label 18050*/ GIMT_Encode4(1248341), // Rule ID 5538 //
     /* 1248265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248340 */     // GIR_Coverage, 5538,
     /* 1248340 */     GIR_EraseRootFromParent_Done,
     /* 1248341 */   // Label 18050: @1248341
     /* 1248341 */   GIM_Try, /*On fail goto*//*Label 18051*/ GIMT_Encode4(1248422), // Rule ID 5539 //
     /* 1248346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1248357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1248360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248421 */     // GIR_Coverage, 5539,
     /* 1248421 */     GIR_EraseRootFromParent_Done,
     /* 1248422 */   // Label 18051: @1248422
     /* 1248422 */   GIM_Try, /*On fail goto*//*Label 18052*/ GIMT_Encode4(1248503), // Rule ID 5540 //
     /* 1248427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1248447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248502 */     // GIR_Coverage, 5540,
     /* 1248502 */     GIR_EraseRootFromParent_Done,
     /* 1248503 */   // Label 18052: @1248503
     /* 1248503 */   GIM_Try, /*On fail goto*//*Label 18053*/ GIMT_Encode4(1248584), // Rule ID 5541 //
     /* 1248508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1248519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1248522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1248528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248561 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248583 */     // GIR_Coverage, 5541,
     /* 1248583 */     GIR_EraseRootFromParent_Done,
     /* 1248584 */   // Label 18053: @1248584
     /* 1248584 */   GIM_Try, /*On fail goto*//*Label 18054*/ GIMT_Encode4(1248665), // Rule ID 5542 //
     /* 1248589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1248600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1248603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1248606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1248609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1248642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248664 */     // GIR_Coverage, 5542,
     /* 1248664 */     GIR_EraseRootFromParent_Done,
     /* 1248665 */   // Label 18054: @1248665
     /* 1248665 */   GIM_Try, /*On fail goto*//*Label 18055*/ GIMT_Encode4(1248746), // Rule ID 5543 //
     /* 1248670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1248681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1248684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1248687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1248690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1248700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1248723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1248726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248745 */     // GIR_Coverage, 5543,
     /* 1248745 */     GIR_EraseRootFromParent_Done,
     /* 1248746 */   // Label 18055: @1248746
     /* 1248746 */   GIM_Try, /*On fail goto*//*Label 18056*/ GIMT_Encode4(1248827), // Rule ID 5544 //
     /* 1248751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1248754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1248762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1248765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1248768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1248771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1248774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1248804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248826 */     // GIR_Coverage, 5544,
     /* 1248826 */     GIR_EraseRootFromParent_Done,
     /* 1248827 */   // Label 18056: @1248827
     /* 1248827 */   GIM_Try, /*On fail goto*//*Label 18057*/ GIMT_Encode4(1248908), // Rule ID 5545 //
     /* 1248832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1248835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1248843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1248846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1248849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1248852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1248855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1248862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248885 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1248885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1248888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248907 */     // GIR_Coverage, 5545,
     /* 1248907 */     GIR_EraseRootFromParent_Done,
     /* 1248908 */   // Label 18057: @1248908
     /* 1248908 */   GIM_Try, /*On fail goto*//*Label 18058*/ GIMT_Encode4(1248989), // Rule ID 5546 //
     /* 1248913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1248916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1248921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1248924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1248927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1248930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1248933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1248943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1248966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1248969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1248987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248988 */     // GIR_Coverage, 5546,
     /* 1248988 */     GIR_EraseRootFromParent_Done,
     /* 1248989 */   // Label 18058: @1248989
     /* 1248989 */   GIM_Try, /*On fail goto*//*Label 18059*/ GIMT_Encode4(1249070), // Rule ID 5547 //
     /* 1248994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1248997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1249005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1249008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1249014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1249024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249047 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1249050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249069 */     // GIR_Coverage, 5547,
     /* 1249069 */     GIR_EraseRootFromParent_Done,
     /* 1249070 */   // Label 18059: @1249070
     /* 1249070 */   GIM_Try, /*On fail goto*//*Label 18060*/ GIMT_Encode4(1249151), // Rule ID 5548 //
     /* 1249075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249128 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1249128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249150 */     // GIR_Coverage, 5548,
     /* 1249150 */     GIR_EraseRootFromParent_Done,
     /* 1249151 */   // Label 18060: @1249151
     /* 1249151 */   GIM_Try, /*On fail goto*//*Label 18061*/ GIMT_Encode4(1249232), // Rule ID 5549 //
     /* 1249156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1249167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1249170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1249186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249209 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1249209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1249212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249231 */     // GIR_Coverage, 5549,
     /* 1249231 */     GIR_EraseRootFromParent_Done,
     /* 1249232 */   // Label 18061: @1249232
     /* 1249232 */   GIM_Try, /*On fail goto*//*Label 18062*/ GIMT_Encode4(1249313), // Rule ID 5550 //
     /* 1249237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249290 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1249293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249312 */     // GIR_Coverage, 5550,
     /* 1249312 */     GIR_EraseRootFromParent_Done,
     /* 1249313 */   // Label 18062: @1249313
     /* 1249313 */   GIM_Try, /*On fail goto*//*Label 18063*/ GIMT_Encode4(1249394), // Rule ID 5551 //
     /* 1249318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1249329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1249332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1249374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249393 */     // GIR_Coverage, 5551,
     /* 1249393 */     GIR_EraseRootFromParent_Done,
     /* 1249394 */   // Label 18063: @1249394
     /* 1249394 */   GIM_Try, /*On fail goto*//*Label 18064*/ GIMT_Encode4(1249475), // Rule ID 5552 //
     /* 1249399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249474 */     // GIR_Coverage, 5552,
     /* 1249474 */     GIR_EraseRootFromParent_Done,
     /* 1249475 */   // Label 18064: @1249475
     /* 1249475 */   GIM_Try, /*On fail goto*//*Label 18065*/ GIMT_Encode4(1249556), // Rule ID 5553 //
     /* 1249480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1249491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1249494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249533 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249555 */     // GIR_Coverage, 5553,
     /* 1249555 */     GIR_EraseRootFromParent_Done,
     /* 1249556 */   // Label 18065: @1249556
     /* 1249556 */   GIM_Try, /*On fail goto*//*Label 18066*/ GIMT_Encode4(1249637), // Rule ID 5554 //
     /* 1249561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1249572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1249575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1249578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249614 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1249614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1249617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249636 */     // GIR_Coverage, 5554,
     /* 1249636 */     GIR_EraseRootFromParent_Done,
     /* 1249637 */   // Label 18066: @1249637
     /* 1249637 */   GIM_Try, /*On fail goto*//*Label 18067*/ GIMT_Encode4(1249718), // Rule ID 5555 //
     /* 1249642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1249653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1249656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1249659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249695 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1249695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1249698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249717 */     // GIR_Coverage, 5555,
     /* 1249717 */     GIR_EraseRootFromParent_Done,
     /* 1249718 */   // Label 18067: @1249718
     /* 1249718 */   GIM_Try, /*On fail goto*//*Label 18068*/ GIMT_Encode4(1249799), // Rule ID 5556 //
     /* 1249723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1249734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1249737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1249740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1249776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249798 */     // GIR_Coverage, 5556,
     /* 1249798 */     GIR_EraseRootFromParent_Done,
     /* 1249799 */   // Label 18068: @1249799
     /* 1249799 */   GIM_Try, /*On fail goto*//*Label 18069*/ GIMT_Encode4(1249880), // Rule ID 5557 //
     /* 1249804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1249815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1249818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1249821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249857 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1249857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1249860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249879 */     // GIR_Coverage, 5557,
     /* 1249879 */     GIR_EraseRootFromParent_Done,
     /* 1249880 */   // Label 18069: @1249880
     /* 1249880 */   GIM_Try, /*On fail goto*//*Label 18070*/ GIMT_Encode4(1249961), // Rule ID 5558 //
     /* 1249885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1249896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1249899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1249902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1249938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1249941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1249959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249960 */     // GIR_Coverage, 5558,
     /* 1249960 */     GIR_EraseRootFromParent_Done,
     /* 1249961 */   // Label 18070: @1249961
     /* 1249961 */   GIM_Try, /*On fail goto*//*Label 18071*/ GIMT_Encode4(1250042), // Rule ID 5559 //
     /* 1249966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1249974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1249977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1249980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1249983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1249996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250019 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250041 */     // GIR_Coverage, 5559,
     /* 1250041 */     GIR_EraseRootFromParent_Done,
     /* 1250042 */   // Label 18071: @1250042
     /* 1250042 */   GIM_Try, /*On fail goto*//*Label 18072*/ GIMT_Encode4(1250123), // Rule ID 5560 //
     /* 1250047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1250100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250122 */     // GIR_Coverage, 5560,
     /* 1250122 */     GIR_EraseRootFromParent_Done,
     /* 1250123 */   // Label 18072: @1250123
     /* 1250123 */   GIM_Try, /*On fail goto*//*Label 18073*/ GIMT_Encode4(1250204), // Rule ID 5561 //
     /* 1250128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1250139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1250142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250181 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1250181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1250184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250203 */     // GIR_Coverage, 5561,
     /* 1250203 */     GIR_EraseRootFromParent_Done,
     /* 1250204 */   // Label 18073: @1250204
     /* 1250204 */   GIM_Try, /*On fail goto*//*Label 18074*/ GIMT_Encode4(1250285), // Rule ID 5562 //
     /* 1250209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250262 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1250262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250284 */     // GIR_Coverage, 5562,
     /* 1250284 */     GIR_EraseRootFromParent_Done,
     /* 1250285 */   // Label 18074: @1250285
     /* 1250285 */   GIM_Try, /*On fail goto*//*Label 18075*/ GIMT_Encode4(1250366), // Rule ID 5563 //
     /* 1250290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1250301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1250304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250343 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11535:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1250343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250365 */     // GIR_Coverage, 5563,
     /* 1250365 */     GIR_EraseRootFromParent_Done,
     /* 1250366 */   // Label 18075: @1250366
     /* 1250366 */   GIM_Try, /*On fail goto*//*Label 18076*/ GIMT_Encode4(1250447), // Rule ID 5564 //
     /* 1250371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250424 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1250424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250446 */     // GIR_Coverage, 5564,
     /* 1250446 */     GIR_EraseRootFromParent_Done,
     /* 1250447 */   // Label 18076: @1250447
     /* 1250447 */   GIM_Try, /*On fail goto*//*Label 18077*/ GIMT_Encode4(1250528), // Rule ID 5565 //
     /* 1250452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1250463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1250466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250505 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11535:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1250505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250527 */     // GIR_Coverage, 5565,
     /* 1250527 */     GIR_EraseRootFromParent_Done,
     /* 1250528 */   // Label 18077: @1250528
     /* 1250528 */   GIM_Try, /*On fail goto*//*Label 18078*/ GIMT_Encode4(1250609), // Rule ID 5566 //
     /* 1250533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1250544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1250547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1250550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250586 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1250586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250608 */     // GIR_Coverage, 5566,
     /* 1250608 */     GIR_EraseRootFromParent_Done,
     /* 1250609 */   // Label 18078: @1250609
     /* 1250609 */   GIM_Try, /*On fail goto*//*Label 18079*/ GIMT_Encode4(1250690), // Rule ID 5567 //
     /* 1250614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1250625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1250628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1250631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250667 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11535:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1250667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250689 */     // GIR_Coverage, 5567,
     /* 1250689 */     GIR_EraseRootFromParent_Done,
     /* 1250690 */   // Label 18079: @1250690
     /* 1250690 */   GIM_Try, /*On fail goto*//*Label 18080*/ GIMT_Encode4(1250771), // Rule ID 5568 //
     /* 1250695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1250698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1250706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1250709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1250712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1250748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250770 */     // GIR_Coverage, 5568,
     /* 1250770 */     GIR_EraseRootFromParent_Done,
     /* 1250771 */   // Label 18080: @1250771
     /* 1250771 */   GIM_Try, /*On fail goto*//*Label 18081*/ GIMT_Encode4(1250852), // Rule ID 5569 //
     /* 1250776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1250779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1250787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1250790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1250793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1250806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250829 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11535:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1250829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1250832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1250850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250851 */     // GIR_Coverage, 5569,
     /* 1250851 */     GIR_EraseRootFromParent_Done,
     /* 1250852 */   // Label 18081: @1250852
     /* 1250852 */   GIM_Try, /*On fail goto*//*Label 18082*/ GIMT_Encode4(1250933), // Rule ID 5570 //
     /* 1250857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1250868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1250871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1250874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1250880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1250887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250910 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1250910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1250913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250932 */     // GIR_Coverage, 5570,
     /* 1250932 */     GIR_EraseRootFromParent_Done,
     /* 1250933 */   // Label 18082: @1250933
     /* 1250933 */   GIM_Try, /*On fail goto*//*Label 18083*/ GIMT_Encode4(1251014), // Rule ID 5571 //
     /* 1250938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1250946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1250949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1250952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1250955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1250961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1250968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1250976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250991 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1250991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1250994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251013 */     // GIR_Coverage, 5571,
     /* 1251013 */     GIR_EraseRootFromParent_Done,
     /* 1251014 */   // Label 18083: @1251014
     /* 1251014 */   GIM_Try, /*On fail goto*//*Label 18084*/ GIMT_Encode4(1251095), // Rule ID 5572 //
     /* 1251019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251072 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251094 */     // GIR_Coverage, 5572,
     /* 1251094 */     GIR_EraseRootFromParent_Done,
     /* 1251095 */   // Label 18084: @1251095
     /* 1251095 */   GIM_Try, /*On fail goto*//*Label 18085*/ GIMT_Encode4(1251176), // Rule ID 5573 //
     /* 1251100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1251111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1251114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251153 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251175 */     // GIR_Coverage, 5573,
     /* 1251175 */     GIR_EraseRootFromParent_Done,
     /* 1251176 */   // Label 18085: @1251176
     /* 1251176 */   GIM_Try, /*On fail goto*//*Label 18086*/ GIMT_Encode4(1251257), // Rule ID 5574 //
     /* 1251181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251234 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1251234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251256 */     // GIR_Coverage, 5574,
     /* 1251256 */     GIR_EraseRootFromParent_Done,
     /* 1251257 */   // Label 18086: @1251257
     /* 1251257 */   GIM_Try, /*On fail goto*//*Label 18087*/ GIMT_Encode4(1251338), // Rule ID 5575 //
     /* 1251262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1251273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1251276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251315 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1251315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251337 */     // GIR_Coverage, 5575,
     /* 1251337 */     GIR_EraseRootFromParent_Done,
     /* 1251338 */   // Label 18087: @1251338
     /* 1251338 */   GIM_Try, /*On fail goto*//*Label 18088*/ GIMT_Encode4(1251419), // Rule ID 5576 //
     /* 1251343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251418 */     // GIR_Coverage, 5576,
     /* 1251418 */     GIR_EraseRootFromParent_Done,
     /* 1251419 */   // Label 18088: @1251419
     /* 1251419 */   GIM_Try, /*On fail goto*//*Label 18089*/ GIMT_Encode4(1251500), // Rule ID 5577 //
     /* 1251424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1251435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1251438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251477 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251499 */     // GIR_Coverage, 5577,
     /* 1251499 */     GIR_EraseRootFromParent_Done,
     /* 1251500 */   // Label 18089: @1251500
     /* 1251500 */   GIM_Try, /*On fail goto*//*Label 18090*/ GIMT_Encode4(1251581), // Rule ID 5578 //
     /* 1251505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1251516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1251519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1251522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251580 */     // GIR_Coverage, 5578,
     /* 1251580 */     GIR_EraseRootFromParent_Done,
     /* 1251581 */   // Label 18090: @1251581
     /* 1251581 */   GIM_Try, /*On fail goto*//*Label 18091*/ GIMT_Encode4(1251662), // Rule ID 5579 //
     /* 1251586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1251597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1251600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1251603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1251616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251639 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1251642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251661 */     // GIR_Coverage, 5579,
     /* 1251661 */     GIR_EraseRootFromParent_Done,
     /* 1251662 */   // Label 18091: @1251662
     /* 1251662 */   GIM_Try, /*On fail goto*//*Label 18092*/ GIMT_Encode4(1251743), // Rule ID 5580 //
     /* 1251667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1251678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1251681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1251684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1251720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251742 */     // GIR_Coverage, 5580,
     /* 1251742 */     GIR_EraseRootFromParent_Done,
     /* 1251743 */   // Label 18092: @1251743
     /* 1251743 */   GIM_Try, /*On fail goto*//*Label 18093*/ GIMT_Encode4(1251824), // Rule ID 5581 //
     /* 1251748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1251759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1251762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1251765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1251778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251801 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1251801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1251804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251823 */     // GIR_Coverage, 5581,
     /* 1251823 */     GIR_EraseRootFromParent_Done,
     /* 1251824 */   // Label 18093: @1251824
     /* 1251824 */   GIM_Try, /*On fail goto*//*Label 18094*/ GIMT_Encode4(1251905), // Rule ID 5582 //
     /* 1251829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1251840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1251843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1251846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1251852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251882 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1251882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251904 */     // GIR_Coverage, 5582,
     /* 1251904 */     GIR_EraseRootFromParent_Done,
     /* 1251905 */   // Label 18094: @1251905
     /* 1251905 */   GIM_Try, /*On fail goto*//*Label 18095*/ GIMT_Encode4(1251986), // Rule ID 5583 //
     /* 1251910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1251921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1251924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1251927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1251933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1251940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1251963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1251966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251985 */     // GIR_Coverage, 5583,
     /* 1251985 */     GIR_EraseRootFromParent_Done,
     /* 1251986 */   // Label 18095: @1251986
     /* 1251986 */   GIM_Try, /*On fail goto*//*Label 18096*/ GIMT_Encode4(1252067), // Rule ID 5584 //
     /* 1251991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1251999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252066 */     // GIR_Coverage, 5584,
     /* 1252066 */     GIR_EraseRootFromParent_Done,
     /* 1252067 */   // Label 18096: @1252067
     /* 1252067 */   GIM_Try, /*On fail goto*//*Label 18097*/ GIMT_Encode4(1252148), // Rule ID 5585 //
     /* 1252072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1252083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1252086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252125 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252147 */     // GIR_Coverage, 5585,
     /* 1252147 */     GIR_EraseRootFromParent_Done,
     /* 1252148 */   // Label 18097: @1252148
     /* 1252148 */   GIM_Try, /*On fail goto*//*Label 18098*/ GIMT_Encode4(1252229), // Rule ID 5586 //
     /* 1252153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1252206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252228 */     // GIR_Coverage, 5586,
     /* 1252228 */     GIR_EraseRootFromParent_Done,
     /* 1252229 */   // Label 18098: @1252229
     /* 1252229 */   GIM_Try, /*On fail goto*//*Label 18099*/ GIMT_Encode4(1252310), // Rule ID 5587 //
     /* 1252234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1252245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1252248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252287 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1252287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252309 */     // GIR_Coverage, 5587,
     /* 1252309 */     GIR_EraseRootFromParent_Done,
     /* 1252310 */   // Label 18099: @1252310
     /* 1252310 */   GIM_Try, /*On fail goto*//*Label 18100*/ GIMT_Encode4(1252391), // Rule ID 5588 //
     /* 1252315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252390 */     // GIR_Coverage, 5588,
     /* 1252390 */     GIR_EraseRootFromParent_Done,
     /* 1252391 */   // Label 18100: @1252391
     /* 1252391 */   GIM_Try, /*On fail goto*//*Label 18101*/ GIMT_Encode4(1252472), // Rule ID 5589 //
     /* 1252396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1252407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1252410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1252426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252449 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11535:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1252452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252471 */     // GIR_Coverage, 5589,
     /* 1252471 */     GIR_EraseRootFromParent_Done,
     /* 1252472 */   // Label 18101: @1252472
     /* 1252472 */   GIM_Try, /*On fail goto*//*Label 18102*/ GIMT_Encode4(1252553), // Rule ID 5590 //
     /* 1252477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1252488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1252491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1252494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252552 */     // GIR_Coverage, 5590,
     /* 1252552 */     GIR_EraseRootFromParent_Done,
     /* 1252553 */   // Label 18102: @1252553
     /* 1252553 */   GIM_Try, /*On fail goto*//*Label 18103*/ GIMT_Encode4(1252634), // Rule ID 5591 //
     /* 1252558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1252569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1252572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1252575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1252588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252611 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11535:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1252614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252633 */     // GIR_Coverage, 5591,
     /* 1252633 */     GIR_EraseRootFromParent_Done,
     /* 1252634 */   // Label 18103: @1252634
     /* 1252634 */   GIM_Try, /*On fail goto*//*Label 18104*/ GIMT_Encode4(1252715), // Rule ID 5592 //
     /* 1252639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1252650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1252653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1252656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252692 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1252692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252714 */     // GIR_Coverage, 5592,
     /* 1252714 */     GIR_EraseRootFromParent_Done,
     /* 1252715 */   // Label 18104: @1252715
     /* 1252715 */   GIM_Try, /*On fail goto*//*Label 18105*/ GIMT_Encode4(1252796), // Rule ID 5593 //
     /* 1252720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1252723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1252728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1252731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1252734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1252737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1252750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252773 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11535:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1252773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1252776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1252794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252795 */     // GIR_Coverage, 5593,
     /* 1252795 */     GIR_EraseRootFromParent_Done,
     /* 1252796 */   // Label 18105: @1252796
     /* 1252796 */   GIM_Try, /*On fail goto*//*Label 18106*/ GIMT_Encode4(1252880), // Rule ID 7804 //
     /* 1252801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1252812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1252815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1252818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1252821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252854 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1252857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252879 */     // GIR_Coverage, 7804,
     /* 1252879 */     GIR_EraseRootFromParent_Done,
     /* 1252880 */   // Label 18106: @1252880
     /* 1252880 */   GIM_Try, /*On fail goto*//*Label 18107*/ GIMT_Encode4(1252964), // Rule ID 7805 //
     /* 1252885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1252896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1252899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1252902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1252905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252938 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1252941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1252959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252963 */     // GIR_Coverage, 7805,
     /* 1252963 */     GIR_EraseRootFromParent_Done,
     /* 1252964 */   // Label 18107: @1252964
     /* 1252964 */   GIM_Try, /*On fail goto*//*Label 18108*/ GIMT_Encode4(1253048), // Rule ID 7808 //
     /* 1252969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1252980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1252983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1252986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1252989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253022 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253047 */     // GIR_Coverage, 7808,
     /* 1253047 */     GIR_EraseRootFromParent_Done,
     /* 1253048 */   // Label 18108: @1253048
     /* 1253048 */   GIM_Try, /*On fail goto*//*Label 18109*/ GIMT_Encode4(1253132), // Rule ID 7809 //
     /* 1253053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1253073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253106 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253131 */     // GIR_Coverage, 7809,
     /* 1253131 */     GIR_EraseRootFromParent_Done,
     /* 1253132 */   // Label 18109: @1253132
     /* 1253132 */   GIM_Try, /*On fail goto*//*Label 18110*/ GIMT_Encode4(1253216), // Rule ID 7812 //
     /* 1253137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253215 */     // GIR_Coverage, 7812,
     /* 1253215 */     GIR_EraseRootFromParent_Done,
     /* 1253216 */   // Label 18110: @1253216
     /* 1253216 */   GIM_Try, /*On fail goto*//*Label 18111*/ GIMT_Encode4(1253300), // Rule ID 7813 //
     /* 1253221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253274 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1253277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253299 */     // GIR_Coverage, 7813,
     /* 1253299 */     GIR_EraseRootFromParent_Done,
     /* 1253300 */   // Label 18111: @1253300
     /* 1253300 */   GIM_Try, /*On fail goto*//*Label 18112*/ GIMT_Encode4(1253384), // Rule ID 7816 //
     /* 1253305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253358 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253383 */     // GIR_Coverage, 7816,
     /* 1253383 */     GIR_EraseRootFromParent_Done,
     /* 1253384 */   // Label 18112: @1253384
     /* 1253384 */   GIM_Try, /*On fail goto*//*Label 18113*/ GIMT_Encode4(1253468), // Rule ID 7817 //
     /* 1253389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1253406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1253409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253442 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253467 */     // GIR_Coverage, 7817,
     /* 1253467 */     GIR_EraseRootFromParent_Done,
     /* 1253468 */   // Label 18113: @1253468
     /* 1253468 */   GIM_Try, /*On fail goto*//*Label 18114*/ GIMT_Encode4(1253552), // Rule ID 7820 //
     /* 1253473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1253493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253526 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253551 */     // GIR_Coverage, 7820,
     /* 1253551 */     GIR_EraseRootFromParent_Done,
     /* 1253552 */   // Label 18114: @1253552
     /* 1253552 */   GIM_Try, /*On fail goto*//*Label 18115*/ GIMT_Encode4(1253636), // Rule ID 7821 //
     /* 1253557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1253574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1253577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253610 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1253613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1253631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253635 */     // GIR_Coverage, 7821,
     /* 1253635 */     GIR_EraseRootFromParent_Done,
     /* 1253636 */   // Label 18115: @1253636
     /* 1253636 */   GIM_Try, /*On fail goto*//*Label 18116*/ GIMT_Encode4(1253720), // Rule ID 7824 //
     /* 1253641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1253658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1253661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253694 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1253697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253719 */     // GIR_Coverage, 7824,
     /* 1253719 */     GIR_EraseRootFromParent_Done,
     /* 1253720 */   // Label 18116: @1253720
     /* 1253720 */   GIM_Try, /*On fail goto*//*Label 18117*/ GIMT_Encode4(1253804), // Rule ID 7825 //
     /* 1253725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1253742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1253745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1253781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253803 */     // GIR_Coverage, 7825,
     /* 1253803 */     GIR_EraseRootFromParent_Done,
     /* 1253804 */   // Label 18117: @1253804
     /* 1253804 */   GIM_Try, /*On fail goto*//*Label 18118*/ GIMT_Encode4(1253888), // Rule ID 7828 //
     /* 1253809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1253826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1253829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1253865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253887 */     // GIR_Coverage, 7828,
     /* 1253887 */     GIR_EraseRootFromParent_Done,
     /* 1253888 */   // Label 18118: @1253888
     /* 1253888 */   GIM_Try, /*On fail goto*//*Label 18119*/ GIMT_Encode4(1253972), // Rule ID 7829 //
     /* 1253893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1253910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1253913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253946 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1253949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1253967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253971 */     // GIR_Coverage, 7829,
     /* 1253971 */     GIR_EraseRootFromParent_Done,
     /* 1253972 */   // Label 18119: @1253972
     /* 1253972 */   GIM_Try, /*On fail goto*//*Label 18120*/ GIMT_Encode4(1254056), // Rule ID 7832 //
     /* 1253977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1253994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1253997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254030 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254055 */     // GIR_Coverage, 7832,
     /* 1254055 */     GIR_EraseRootFromParent_Done,
     /* 1254056 */   // Label 18120: @1254056
     /* 1254056 */   GIM_Try, /*On fail goto*//*Label 18121*/ GIMT_Encode4(1254140), // Rule ID 7833 //
     /* 1254061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254114 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254139 */     // GIR_Coverage, 7833,
     /* 1254139 */     GIR_EraseRootFromParent_Done,
     /* 1254140 */   // Label 18121: @1254140
     /* 1254140 */   GIM_Try, /*On fail goto*//*Label 18122*/ GIMT_Encode4(1254224), // Rule ID 7836 //
     /* 1254145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1254148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254198 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254223 */     // GIR_Coverage, 7836,
     /* 1254223 */     GIR_EraseRootFromParent_Done,
     /* 1254224 */   // Label 18122: @1254224
     /* 1254224 */   GIM_Try, /*On fail goto*//*Label 18123*/ GIMT_Encode4(1254308), // Rule ID 7837 //
     /* 1254229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1254232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254282 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1254285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1254303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254307 */     // GIR_Coverage, 7837,
     /* 1254307 */     GIR_EraseRootFromParent_Done,
     /* 1254308 */   // Label 18123: @1254308
     /* 1254308 */   GIM_Try, /*On fail goto*//*Label 18124*/ GIMT_Encode4(1254392), // Rule ID 7840 //
     /* 1254313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1254333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254366 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254391 */     // GIR_Coverage, 7840,
     /* 1254391 */     GIR_EraseRootFromParent_Done,
     /* 1254392 */   // Label 18124: @1254392
     /* 1254392 */   GIM_Try, /*On fail goto*//*Label 18125*/ GIMT_Encode4(1254476), // Rule ID 7841 //
     /* 1254397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1254414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1254417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1254420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254475 */     // GIR_Coverage, 7841,
     /* 1254475 */     GIR_EraseRootFromParent_Done,
     /* 1254476 */   // Label 18125: @1254476
     /* 1254476 */   GIM_Try, /*On fail goto*//*Label 18126*/ GIMT_Encode4(1254560), // Rule ID 7844 //
     /* 1254481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1254492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1254495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1254498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1254501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254534 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1254537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254559 */     // GIR_Coverage, 7844,
     /* 1254559 */     GIR_EraseRootFromParent_Done,
     /* 1254560 */   // Label 18126: @1254560
     /* 1254560 */   GIM_Try, /*On fail goto*//*Label 18127*/ GIMT_Encode4(1254644), // Rule ID 7845 //
     /* 1254565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1254576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1254579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1254582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1254585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1254588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1254607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254618 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1254621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254643 */     // GIR_Coverage, 7845,
     /* 1254643 */     GIR_EraseRootFromParent_Done,
     /* 1254644 */   // Label 18127: @1254644
     /* 1254644 */   GIM_Try, /*On fail goto*//*Label 18128*/ GIMT_Encode4(1254728), // Rule ID 7848 //
     /* 1254649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1254660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1254663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1254666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1254669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1254672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254702 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1254705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254727 */     // GIR_Coverage, 7848,
     /* 1254727 */     GIR_EraseRootFromParent_Done,
     /* 1254728 */   // Label 18128: @1254728
     /* 1254728 */   GIM_Try, /*On fail goto*//*Label 18129*/ GIMT_Encode4(1254812), // Rule ID 7849 //
     /* 1254733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1254744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1254747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1254750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1254753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1254756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1254775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254786 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1254789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254811 */     // GIR_Coverage, 7849,
     /* 1254811 */     GIR_EraseRootFromParent_Done,
     /* 1254812 */   // Label 18129: @1254812
     /* 1254812 */   GIM_Try, /*On fail goto*//*Label 18130*/ GIMT_Encode4(1254896), // Rule ID 7852 //
     /* 1254817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1254834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1254837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254870 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254895 */     // GIR_Coverage, 7852,
     /* 1254895 */     GIR_EraseRootFromParent_Done,
     /* 1254896 */   // Label 18130: @1254896
     /* 1254896 */   GIM_Try, /*On fail goto*//*Label 18131*/ GIMT_Encode4(1254980), // Rule ID 7853 //
     /* 1254901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1254918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1254921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1254943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254954 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1254957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254979 */     // GIR_Coverage, 7853,
     /* 1254979 */     GIR_EraseRootFromParent_Done,
     /* 1254980 */   // Label 18131: @1254980
     /* 1254980 */   GIM_Try, /*On fail goto*//*Label 18132*/ GIMT_Encode4(1255064), // Rule ID 7856 //
     /* 1254985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1254993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1254996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1254999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255038 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255063 */     // GIR_Coverage, 7856,
     /* 1255063 */     GIR_EraseRootFromParent_Done,
     /* 1255064 */   // Label 18132: @1255064
     /* 1255064 */   GIM_Try, /*On fail goto*//*Label 18133*/ GIMT_Encode4(1255148), // Rule ID 7857 //
     /* 1255069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255122 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255147 */     // GIR_Coverage, 7857,
     /* 1255147 */     GIR_EraseRootFromParent_Done,
     /* 1255148 */   // Label 18133: @1255148
     /* 1255148 */   GIM_Try, /*On fail goto*//*Label 18134*/ GIMT_Encode4(1255232), // Rule ID 7860 //
     /* 1255153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1255173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255206 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255231 */     // GIR_Coverage, 7860,
     /* 1255231 */     GIR_EraseRootFromParent_Done,
     /* 1255232 */   // Label 18134: @1255232
     /* 1255232 */   GIM_Try, /*On fail goto*//*Label 18135*/ GIMT_Encode4(1255316), // Rule ID 7861 //
     /* 1255237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1255257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255290 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255315 */     // GIR_Coverage, 7861,
     /* 1255315 */     GIR_EraseRootFromParent_Done,
     /* 1255316 */   // Label 18135: @1255316
     /* 1255316 */   GIM_Try, /*On fail goto*//*Label 18136*/ GIMT_Encode4(1255400), // Rule ID 7864 //
     /* 1255321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1255341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255374 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255399 */     // GIR_Coverage, 7864,
     /* 1255399 */     GIR_EraseRootFromParent_Done,
     /* 1255400 */   // Label 18136: @1255400
     /* 1255400 */   GIM_Try, /*On fail goto*//*Label 18137*/ GIMT_Encode4(1255484), // Rule ID 7865 //
     /* 1255405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1255416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1255419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1255422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1255425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1255428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255458 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255483 */     // GIR_Coverage, 7865,
     /* 1255483 */     GIR_EraseRootFromParent_Done,
     /* 1255484 */   // Label 18137: @1255484
     /* 1255484 */   GIM_Try, /*On fail goto*//*Label 18138*/ GIMT_Encode4(1255568), // Rule ID 7868 //
     /* 1255489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1255509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255567 */     // GIR_Coverage, 7868,
     /* 1255567 */     GIR_EraseRootFromParent_Done,
     /* 1255568 */   // Label 18138: @1255568
     /* 1255568 */   GIM_Try, /*On fail goto*//*Label 18139*/ GIMT_Encode4(1255652), // Rule ID 7869 //
     /* 1255573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1255590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1255593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255626 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1255629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255651 */     // GIR_Coverage, 7869,
     /* 1255651 */     GIR_EraseRootFromParent_Done,
     /* 1255652 */   // Label 18139: @1255652
     /* 1255652 */   GIM_Try, /*On fail goto*//*Label 18140*/ GIMT_Encode4(1255736), // Rule ID 7872 //
     /* 1255657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1255674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1255677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255710 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255735 */     // GIR_Coverage, 7872,
     /* 1255735 */     GIR_EraseRootFromParent_Done,
     /* 1255736 */   // Label 18140: @1255736
     /* 1255736 */   GIM_Try, /*On fail goto*//*Label 18141*/ GIMT_Encode4(1255820), // Rule ID 7873 //
     /* 1255741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1255758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1255761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255794 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1255797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1255815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255819 */     // GIR_Coverage, 7873,
     /* 1255819 */     GIR_EraseRootFromParent_Done,
     /* 1255820 */   // Label 18141: @1255820
     /* 1255820 */   GIM_Try, /*On fail goto*//*Label 18142*/ GIMT_Encode4(1255904), // Rule ID 7876 //
     /* 1255825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1255828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1255836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1255839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1255842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1255845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1255848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255878 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255903 */     // GIR_Coverage, 7876,
     /* 1255903 */     GIR_EraseRootFromParent_Done,
     /* 1255904 */   // Label 18142: @1255904
     /* 1255904 */   GIM_Try, /*On fail goto*//*Label 18143*/ GIMT_Encode4(1255988), // Rule ID 7877 //
     /* 1255909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1255912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1255917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1255920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1255923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1255926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1255929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1255932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255962 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1255965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255987 */     // GIR_Coverage, 7877,
     /* 1255987 */     GIR_EraseRootFromParent_Done,
     /* 1255988 */   // Label 18143: @1255988
     /* 1255988 */   GIM_Try, /*On fail goto*//*Label 18144*/ GIMT_Encode4(1256072), // Rule ID 7880 //
     /* 1255993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1255996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256046 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256071 */     // GIR_Coverage, 7880,
     /* 1256071 */     GIR_EraseRootFromParent_Done,
     /* 1256072 */   // Label 18144: @1256072
     /* 1256072 */   GIM_Try, /*On fail goto*//*Label 18145*/ GIMT_Encode4(1256156), // Rule ID 7881 //
     /* 1256077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1256133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256155 */     // GIR_Coverage, 7881,
     /* 1256155 */     GIR_EraseRootFromParent_Done,
     /* 1256156 */   // Label 18145: @1256156
     /* 1256156 */   GIM_Try, /*On fail goto*//*Label 18146*/ GIMT_Encode4(1256240), // Rule ID 7884 //
     /* 1256161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1256181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256214 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256239 */     // GIR_Coverage, 7884,
     /* 1256239 */     GIR_EraseRootFromParent_Done,
     /* 1256240 */   // Label 18146: @1256240
     /* 1256240 */   GIM_Try, /*On fail goto*//*Label 18147*/ GIMT_Encode4(1256324), // Rule ID 7885 //
     /* 1256245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1256265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256298 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1256301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256323 */     // GIR_Coverage, 7885,
     /* 1256323 */     GIR_EraseRootFromParent_Done,
     /* 1256324 */   // Label 18147: @1256324
     /* 1256324 */   GIM_Try, /*On fail goto*//*Label 18148*/ GIMT_Encode4(1256408), // Rule ID 7888 //
     /* 1256329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1256346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256382 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1256385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256407 */     // GIR_Coverage, 7888,
     /* 1256407 */     GIR_EraseRootFromParent_Done,
     /* 1256408 */   // Label 18148: @1256408
     /* 1256408 */   GIM_Try, /*On fail goto*//*Label 18149*/ GIMT_Encode4(1256492), // Rule ID 7889 //
     /* 1256413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1256430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256466 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1256469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256491 */     // GIR_Coverage, 7889,
     /* 1256491 */     GIR_EraseRootFromParent_Done,
     /* 1256492 */   // Label 18149: @1256492
     /* 1256492 */   GIM_Try, /*On fail goto*//*Label 18150*/ GIMT_Encode4(1256576), // Rule ID 7892 //
     /* 1256497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1256514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256550 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1256553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256575 */     // GIR_Coverage, 7892,
     /* 1256575 */     GIR_EraseRootFromParent_Done,
     /* 1256576 */   // Label 18150: @1256576
     /* 1256576 */   GIM_Try, /*On fail goto*//*Label 18151*/ GIMT_Encode4(1256660), // Rule ID 7893 //
     /* 1256581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1256598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256634 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1256637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256659 */     // GIR_Coverage, 7893,
     /* 1256659 */     GIR_EraseRootFromParent_Done,
     /* 1256660 */   // Label 18151: @1256660
     /* 1256660 */   GIM_Try, /*On fail goto*//*Label 18152*/ GIMT_Encode4(1256744), // Rule ID 7896 //
     /* 1256665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1256682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256718 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1256721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256743 */     // GIR_Coverage, 7896,
     /* 1256743 */     GIR_EraseRootFromParent_Done,
     /* 1256744 */   // Label 18152: @1256744
     /* 1256744 */   GIM_Try, /*On fail goto*//*Label 18153*/ GIMT_Encode4(1256828), // Rule ID 7897 //
     /* 1256749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1256766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256802 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1256805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1256823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256827 */     // GIR_Coverage, 7897,
     /* 1256827 */     GIR_EraseRootFromParent_Done,
     /* 1256828 */   // Label 18153: @1256828
     /* 1256828 */   GIM_Try, /*On fail goto*//*Label 18154*/ GIMT_Encode4(1256912), // Rule ID 7900 //
     /* 1256833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1256850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1256853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256886 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1256889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256911 */     // GIR_Coverage, 7900,
     /* 1256911 */     GIR_EraseRootFromParent_Done,
     /* 1256912 */   // Label 18154: @1256912
     /* 1256912 */   GIM_Try, /*On fail goto*//*Label 18155*/ GIMT_Encode4(1256996), // Rule ID 7901 //
     /* 1256917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1256925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1256928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1256931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1256934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1256937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1256940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1256959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256970 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1256973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256995 */     // GIR_Coverage, 7901,
     /* 1256995 */     GIR_EraseRootFromParent_Done,
     /* 1256996 */   // Label 18155: @1256996
     /* 1256996 */   GIM_Try, /*On fail goto*//*Label 18156*/ GIMT_Encode4(1257080), // Rule ID 7904 //
     /* 1257001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257054 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257079 */     // GIR_Coverage, 7904,
     /* 1257079 */     GIR_EraseRootFromParent_Done,
     /* 1257080 */   // Label 18156: @1257080
     /* 1257080 */   GIM_Try, /*On fail goto*//*Label 18157*/ GIMT_Encode4(1257164), // Rule ID 7905 //
     /* 1257085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257138 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257163 */     // GIR_Coverage, 7905,
     /* 1257163 */     GIR_EraseRootFromParent_Done,
     /* 1257164 */   // Label 18157: @1257164
     /* 1257164 */   GIM_Try, /*On fail goto*//*Label 18158*/ GIMT_Encode4(1257248), // Rule ID 7908 //
     /* 1257169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257222 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257247 */     // GIR_Coverage, 7908,
     /* 1257247 */     GIR_EraseRootFromParent_Done,
     /* 1257248 */   // Label 18158: @1257248
     /* 1257248 */   GIM_Try, /*On fail goto*//*Label 18159*/ GIMT_Encode4(1257332), // Rule ID 7909 //
     /* 1257253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257306 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1257309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257331 */     // GIR_Coverage, 7909,
     /* 1257331 */     GIR_EraseRootFromParent_Done,
     /* 1257332 */   // Label 18159: @1257332
     /* 1257332 */   GIM_Try, /*On fail goto*//*Label 18160*/ GIMT_Encode4(1257416), // Rule ID 7912 //
     /* 1257337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257390 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257415 */     // GIR_Coverage, 7912,
     /* 1257415 */     GIR_EraseRootFromParent_Done,
     /* 1257416 */   // Label 18160: @1257416
     /* 1257416 */   GIM_Try, /*On fail goto*//*Label 18161*/ GIMT_Encode4(1257500), // Rule ID 7913 //
     /* 1257421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1257438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257474 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257499 */     // GIR_Coverage, 7913,
     /* 1257499 */     GIR_EraseRootFromParent_Done,
     /* 1257500 */   // Label 18161: @1257500
     /* 1257500 */   GIM_Try, /*On fail goto*//*Label 18162*/ GIMT_Encode4(1257584), // Rule ID 7916 //
     /* 1257505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257558 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257583 */     // GIR_Coverage, 7916,
     /* 1257583 */     GIR_EraseRootFromParent_Done,
     /* 1257584 */   // Label 18162: @1257584
     /* 1257584 */   GIM_Try, /*On fail goto*//*Label 18163*/ GIMT_Encode4(1257668), // Rule ID 7917 //
     /* 1257589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1257606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257642 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257667 */     // GIR_Coverage, 7917,
     /* 1257667 */     GIR_EraseRootFromParent_Done,
     /* 1257668 */   // Label 18163: @1257668
     /* 1257668 */   GIM_Try, /*On fail goto*//*Label 18164*/ GIMT_Encode4(1257752), // Rule ID 7920 //
     /* 1257673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257726 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257751 */     // GIR_Coverage, 7920,
     /* 1257751 */     GIR_EraseRootFromParent_Done,
     /* 1257752 */   // Label 18164: @1257752
     /* 1257752 */   GIM_Try, /*On fail goto*//*Label 18165*/ GIMT_Encode4(1257836), // Rule ID 7921 //
     /* 1257757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1257774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257810 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1257831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257835 */     // GIR_Coverage, 7921,
     /* 1257835 */     GIR_EraseRootFromParent_Done,
     /* 1257836 */   // Label 18165: @1257836
     /* 1257836 */   GIM_Try, /*On fail goto*//*Label 18166*/ GIMT_Encode4(1257920), // Rule ID 7924 //
     /* 1257841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1257844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1257858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257894 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257919 */     // GIR_Coverage, 7924,
     /* 1257919 */     GIR_EraseRootFromParent_Done,
     /* 1257920 */   // Label 18166: @1257920
     /* 1257920 */   GIM_Try, /*On fail goto*//*Label 18167*/ GIMT_Encode4(1258004), // Rule ID 7925 //
     /* 1257925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1257928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1257933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1257942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257978 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1257981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258003 */     // GIR_Coverage, 7925,
     /* 1258003 */     GIR_EraseRootFromParent_Done,
     /* 1258004 */   // Label 18167: @1258004
     /* 1258004 */   GIM_Try, /*On fail goto*//*Label 18168*/ GIMT_Encode4(1258088), // Rule ID 7928 //
     /* 1258009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258062 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258087 */     // GIR_Coverage, 7928,
     /* 1258087 */     GIR_EraseRootFromParent_Done,
     /* 1258088 */   // Label 18168: @1258088
     /* 1258088 */   GIM_Try, /*On fail goto*//*Label 18169*/ GIMT_Encode4(1258172), // Rule ID 7929 //
     /* 1258093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258146 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258171 */     // GIR_Coverage, 7929,
     /* 1258171 */     GIR_EraseRootFromParent_Done,
     /* 1258172 */   // Label 18169: @1258172
     /* 1258172 */   GIM_Try, /*On fail goto*//*Label 18170*/ GIMT_Encode4(1258256), // Rule ID 7932 //
     /* 1258177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258230 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258255 */     // GIR_Coverage, 7932,
     /* 1258255 */     GIR_EraseRootFromParent_Done,
     /* 1258256 */   // Label 18170: @1258256
     /* 1258256 */   GIM_Try, /*On fail goto*//*Label 18171*/ GIMT_Encode4(1258340), // Rule ID 7933 //
     /* 1258261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1258278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258314 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258339 */     // GIR_Coverage, 7933,
     /* 1258339 */     GIR_EraseRootFromParent_Done,
     /* 1258340 */   // Label 18171: @1258340
     /* 1258340 */   GIM_Try, /*On fail goto*//*Label 18172*/ GIMT_Encode4(1258424), // Rule ID 7936 //
     /* 1258345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258398 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258423 */     // GIR_Coverage, 7936,
     /* 1258423 */     GIR_EraseRootFromParent_Done,
     /* 1258424 */   // Label 18172: @1258424
     /* 1258424 */   GIM_Try, /*On fail goto*//*Label 18173*/ GIMT_Encode4(1258508), // Rule ID 7937 //
     /* 1258429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1258440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1258443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1258446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1258452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258482 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258507 */     // GIR_Coverage, 7937,
     /* 1258507 */     GIR_EraseRootFromParent_Done,
     /* 1258508 */   // Label 18173: @1258508
     /* 1258508 */   GIM_Try, /*On fail goto*//*Label 18174*/ GIMT_Encode4(1258592), // Rule ID 7940 //
     /* 1258513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1258530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258566 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258591 */     // GIR_Coverage, 7940,
     /* 1258591 */     GIR_EraseRootFromParent_Done,
     /* 1258592 */   // Label 18174: @1258592
     /* 1258592 */   GIM_Try, /*On fail goto*//*Label 18175*/ GIMT_Encode4(1258676), // Rule ID 7941 //
     /* 1258597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1258614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1258653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258675 */     // GIR_Coverage, 7941,
     /* 1258675 */     GIR_EraseRootFromParent_Done,
     /* 1258676 */   // Label 18175: @1258676
     /* 1258676 */   GIM_Try, /*On fail goto*//*Label 18176*/ GIMT_Encode4(1258760), // Rule ID 7944 //
     /* 1258681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258734 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258759 */     // GIR_Coverage, 7944,
     /* 1258759 */     GIR_EraseRootFromParent_Done,
     /* 1258760 */   // Label 18176: @1258760
     /* 1258760 */   GIM_Try, /*On fail goto*//*Label 18177*/ GIMT_Encode4(1258844), // Rule ID 7945 //
     /* 1258765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1258782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1258803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258818 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1258821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258843 */     // GIR_Coverage, 7945,
     /* 1258843 */     GIR_EraseRootFromParent_Done,
     /* 1258844 */   // Label 18177: @1258844
     /* 1258844 */   GIM_Try, /*On fail goto*//*Label 18178*/ GIMT_Encode4(1258928), // Rule ID 7948 //
     /* 1258849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1258866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258902 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258927 */     // GIR_Coverage, 7948,
     /* 1258927 */     GIR_EraseRootFromParent_Done,
     /* 1258928 */   // Label 18178: @1258928
     /* 1258928 */   GIM_Try, /*On fail goto*//*Label 18179*/ GIMT_Encode4(1259012), // Rule ID 7949 //
     /* 1258933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1258941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1258950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1258956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1258971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258986 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1258989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259011 */     // GIR_Coverage, 7949,
     /* 1259011 */     GIR_EraseRootFromParent_Done,
     /* 1259012 */   // Label 18179: @1259012
     /* 1259012 */   GIM_Try, /*On fail goto*//*Label 18180*/ GIMT_Encode4(1259096), // Rule ID 7952 //
     /* 1259017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259070 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259095 */     // GIR_Coverage, 7952,
     /* 1259095 */     GIR_EraseRootFromParent_Done,
     /* 1259096 */   // Label 18180: @1259096
     /* 1259096 */   GIM_Try, /*On fail goto*//*Label 18181*/ GIMT_Encode4(1259180), // Rule ID 7953 //
     /* 1259101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259154 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259179 */     // GIR_Coverage, 7953,
     /* 1259179 */     GIR_EraseRootFromParent_Done,
     /* 1259180 */   // Label 18181: @1259180
     /* 1259180 */   GIM_Try, /*On fail goto*//*Label 18182*/ GIMT_Encode4(1259264), // Rule ID 7956 //
     /* 1259185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259238 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259263 */     // GIR_Coverage, 7956,
     /* 1259263 */     GIR_EraseRootFromParent_Done,
     /* 1259264 */   // Label 18182: @1259264
     /* 1259264 */   GIM_Try, /*On fail goto*//*Label 18183*/ GIMT_Encode4(1259348), // Rule ID 7957 //
     /* 1259269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1259286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259322 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259347 */     // GIR_Coverage, 7957,
     /* 1259347 */     GIR_EraseRootFromParent_Done,
     /* 1259348 */   // Label 18183: @1259348
     /* 1259348 */   GIM_Try, /*On fail goto*//*Label 18184*/ GIMT_Encode4(1259432), // Rule ID 7960 //
     /* 1259353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259406 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259431 */     // GIR_Coverage, 7960,
     /* 1259431 */     GIR_EraseRootFromParent_Done,
     /* 1259432 */   // Label 18184: @1259432
     /* 1259432 */   GIM_Try, /*On fail goto*//*Label 18185*/ GIMT_Encode4(1259516), // Rule ID 7961 //
     /* 1259437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1259454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259490 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259515 */     // GIR_Coverage, 7961,
     /* 1259515 */     GIR_EraseRootFromParent_Done,
     /* 1259516 */   // Label 18185: @1259516
     /* 1259516 */   GIM_Try, /*On fail goto*//*Label 18186*/ GIMT_Encode4(1259600), // Rule ID 7964 //
     /* 1259521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1259532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1259535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1259538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259574 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259599 */     // GIR_Coverage, 7964,
     /* 1259599 */     GIR_EraseRootFromParent_Done,
     /* 1259600 */   // Label 18186: @1259600
     /* 1259600 */   GIM_Try, /*On fail goto*//*Label 18187*/ GIMT_Encode4(1259684), // Rule ID 7965 //
     /* 1259605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1259608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1259616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1259619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1259622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1259628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1259661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259683 */     // GIR_Coverage, 7965,
     /* 1259683 */     GIR_EraseRootFromParent_Done,
     /* 1259684 */   // Label 18187: @1259684
     /* 1259684 */   GIM_Try, /*On fail goto*//*Label 18188*/ GIMT_Encode4(1259768), // Rule ID 7968 //
     /* 1259689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1259706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259742 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259767 */     // GIR_Coverage, 7968,
     /* 1259767 */     GIR_EraseRootFromParent_Done,
     /* 1259768 */   // Label 18188: @1259768
     /* 1259768 */   GIM_Try, /*On fail goto*//*Label 18189*/ GIMT_Encode4(1259852), // Rule ID 7969 //
     /* 1259773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1259776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1259790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259826 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1259829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259851 */     // GIR_Coverage, 7969,
     /* 1259851 */     GIR_EraseRootFromParent_Done,
     /* 1259852 */   // Label 18189: @1259852
     /* 1259852 */   GIM_Try, /*On fail goto*//*Label 18190*/ GIMT_Encode4(1259936), // Rule ID 7972 //
     /* 1259857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1259860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1259874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259910 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1259931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259935 */     // GIR_Coverage, 7972,
     /* 1259935 */     GIR_EraseRootFromParent_Done,
     /* 1259936 */   // Label 18190: @1259936
     /* 1259936 */   GIM_Try, /*On fail goto*//*Label 18191*/ GIMT_Encode4(1260020), // Rule ID 7973 //
     /* 1259941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1259944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1259949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1259958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259994 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1259997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260019 */     // GIR_Coverage, 7973,
     /* 1260019 */     GIR_EraseRootFromParent_Done,
     /* 1260020 */   // Label 18191: @1260020
     /* 1260020 */   GIM_Try, /*On fail goto*//*Label 18192*/ GIMT_Encode4(1260104), // Rule ID 8064 //
     /* 1260025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1260081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260103 */     // GIR_Coverage, 8064,
     /* 1260103 */     GIR_EraseRootFromParent_Done,
     /* 1260104 */   // Label 18192: @1260104
     /* 1260104 */   GIM_Try, /*On fail goto*//*Label 18193*/ GIMT_Encode4(1260188), // Rule ID 8065 //
     /* 1260109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260162 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1260165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260187 */     // GIR_Coverage, 8065,
     /* 1260187 */     GIR_EraseRootFromParent_Done,
     /* 1260188 */   // Label 18193: @1260188
     /* 1260188 */   GIM_Try, /*On fail goto*//*Label 18194*/ GIMT_Encode4(1260272), // Rule ID 8068 //
     /* 1260193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1260213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260246 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260271 */     // GIR_Coverage, 8068,
     /* 1260271 */     GIR_EraseRootFromParent_Done,
     /* 1260272 */   // Label 18194: @1260272
     /* 1260272 */   GIM_Try, /*On fail goto*//*Label 18195*/ GIMT_Encode4(1260356), // Rule ID 8069 //
     /* 1260277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1260294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1260297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260330 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260355 */     // GIR_Coverage, 8069,
     /* 1260355 */     GIR_EraseRootFromParent_Done,
     /* 1260356 */   // Label 18195: @1260356
     /* 1260356 */   GIM_Try, /*On fail goto*//*Label 18196*/ GIMT_Encode4(1260440), // Rule ID 8072 //
     /* 1260361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1260381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260414 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260439 */     // GIR_Coverage, 8072,
     /* 1260439 */     GIR_EraseRootFromParent_Done,
     /* 1260440 */   // Label 18196: @1260440
     /* 1260440 */   GIM_Try, /*On fail goto*//*Label 18197*/ GIMT_Encode4(1260524), // Rule ID 8073 //
     /* 1260445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1260462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1260465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260498 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260523 */     // GIR_Coverage, 8073,
     /* 1260523 */     GIR_EraseRootFromParent_Done,
     /* 1260524 */   // Label 18197: @1260524
     /* 1260524 */   GIM_Try, /*On fail goto*//*Label 18198*/ GIMT_Encode4(1260608), // Rule ID 8076 //
     /* 1260529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1260546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1260549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260582 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260607 */     // GIR_Coverage, 8076,
     /* 1260607 */     GIR_EraseRootFromParent_Done,
     /* 1260608 */   // Label 18198: @1260608
     /* 1260608 */   GIM_Try, /*On fail goto*//*Label 18199*/ GIMT_Encode4(1260692), // Rule ID 8077 //
     /* 1260613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1260630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1260633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260666 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1260669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260691 */     // GIR_Coverage, 8077,
     /* 1260691 */     GIR_EraseRootFromParent_Done,
     /* 1260692 */   // Label 18199: @1260692
     /* 1260692 */   GIM_Try, /*On fail goto*//*Label 18200*/ GIMT_Encode4(1260776), // Rule ID 8080 //
     /* 1260697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1260714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1260717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260775 */     // GIR_Coverage, 8080,
     /* 1260775 */     GIR_EraseRootFromParent_Done,
     /* 1260776 */   // Label 18200: @1260776
     /* 1260776 */   GIM_Try, /*On fail goto*//*Label 18201*/ GIMT_Encode4(1260860), // Rule ID 8081 //
     /* 1260781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1260798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1260801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260834 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1260855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260859 */     // GIR_Coverage, 8081,
     /* 1260859 */     GIR_EraseRootFromParent_Done,
     /* 1260860 */   // Label 18201: @1260860
     /* 1260860 */   GIM_Try, /*On fail goto*//*Label 18202*/ GIMT_Encode4(1260944), // Rule ID 8084 //
     /* 1260865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1260882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1260885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260918 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1260921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260943 */     // GIR_Coverage, 8084,
     /* 1260943 */     GIR_EraseRootFromParent_Done,
     /* 1260944 */   // Label 18202: @1260944
     /* 1260944 */   GIM_Try, /*On fail goto*//*Label 18203*/ GIMT_Encode4(1261028), // Rule ID 8085 //
     /* 1260949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1260966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1260969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261002 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1261005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261027 */     // GIR_Coverage, 8085,
     /* 1261027 */     GIR_EraseRootFromParent_Done,
     /* 1261028 */   // Label 18203: @1261028
     /* 1261028 */   GIM_Try, /*On fail goto*//*Label 18204*/ GIMT_Encode4(1261112), // Rule ID 8088 //
     /* 1261033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261086 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261111 */     // GIR_Coverage, 8088,
     /* 1261111 */     GIR_EraseRootFromParent_Done,
     /* 1261112 */   // Label 18204: @1261112
     /* 1261112 */   GIM_Try, /*On fail goto*//*Label 18205*/ GIMT_Encode4(1261196), // Rule ID 8089 //
     /* 1261117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261170 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261195 */     // GIR_Coverage, 8089,
     /* 1261195 */     GIR_EraseRootFromParent_Done,
     /* 1261196 */   // Label 18205: @1261196
     /* 1261196 */   GIM_Try, /*On fail goto*//*Label 18206*/ GIMT_Encode4(1261280), // Rule ID 8092 //
     /* 1261201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261254 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261279 */     // GIR_Coverage, 8092,
     /* 1261279 */     GIR_EraseRootFromParent_Done,
     /* 1261280 */   // Label 18206: @1261280
     /* 1261280 */   GIM_Try, /*On fail goto*//*Label 18207*/ GIMT_Encode4(1261364), // Rule ID 8093 //
     /* 1261285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1261302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1261305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261338 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261363 */     // GIR_Coverage, 8093,
     /* 1261363 */     GIR_EraseRootFromParent_Done,
     /* 1261364 */   // Label 18207: @1261364
     /* 1261364 */   GIM_Try, /*On fail goto*//*Label 18208*/ GIMT_Encode4(1261448), // Rule ID 8096 //
     /* 1261369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261447 */     // GIR_Coverage, 8096,
     /* 1261447 */     GIR_EraseRootFromParent_Done,
     /* 1261448 */   // Label 18208: @1261448
     /* 1261448 */   GIM_Try, /*On fail goto*//*Label 18209*/ GIMT_Encode4(1261532), // Rule ID 8097 //
     /* 1261453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1261470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1261473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261531 */     // GIR_Coverage, 8097,
     /* 1261531 */     GIR_EraseRootFromParent_Done,
     /* 1261532 */   // Label 18209: @1261532
     /* 1261532 */   GIM_Try, /*On fail goto*//*Label 18210*/ GIMT_Encode4(1261616), // Rule ID 8100 //
     /* 1261537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1261540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1261554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1261557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261590 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261615 */     // GIR_Coverage, 8100,
     /* 1261615 */     GIR_EraseRootFromParent_Done,
     /* 1261616 */   // Label 18210: @1261616
     /* 1261616 */   GIM_Try, /*On fail goto*//*Label 18211*/ GIMT_Encode4(1261700), // Rule ID 8101 //
     /* 1261621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1261624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1261638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1261641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261674 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1261677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1261695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261699 */     // GIR_Coverage, 8101,
     /* 1261699 */     GIR_EraseRootFromParent_Done,
     /* 1261700 */   // Label 18211: @1261700
     /* 1261700 */   GIM_Try, /*On fail goto*//*Label 18212*/ GIMT_Encode4(1261784), // Rule ID 8104 //
     /* 1261705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1261716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1261719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1261722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1261725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1261728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261758 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1261761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261783 */     // GIR_Coverage, 8104,
     /* 1261783 */     GIR_EraseRootFromParent_Done,
     /* 1261784 */   // Label 18212: @1261784
     /* 1261784 */   GIM_Try, /*On fail goto*//*Label 18213*/ GIMT_Encode4(1261868), // Rule ID 8105 //
     /* 1261789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1261800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1261803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1261806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1261809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1261812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1261831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261842 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1261845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261867 */     // GIR_Coverage, 8105,
     /* 1261867 */     GIR_EraseRootFromParent_Done,
     /* 1261868 */   // Label 18213: @1261868
     /* 1261868 */   GIM_Try, /*On fail goto*//*Label 18214*/ GIMT_Encode4(1261952), // Rule ID 8108 //
     /* 1261873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1261884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1261887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1261890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1261893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1261896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261926 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1261929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261951 */     // GIR_Coverage, 8108,
     /* 1261951 */     GIR_EraseRootFromParent_Done,
     /* 1261952 */   // Label 18214: @1261952
     /* 1261952 */   GIM_Try, /*On fail goto*//*Label 18215*/ GIMT_Encode4(1262036), // Rule ID 8109 //
     /* 1261957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1261965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1261968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1261971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1261974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1261977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1261980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1261999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262010 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262035 */     // GIR_Coverage, 8109,
     /* 1262035 */     GIR_EraseRootFromParent_Done,
     /* 1262036 */   // Label 18215: @1262036
     /* 1262036 */   GIM_Try, /*On fail goto*//*Label 18216*/ GIMT_Encode4(1262120), // Rule ID 8112 //
     /* 1262041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262094 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262119 */     // GIR_Coverage, 8112,
     /* 1262119 */     GIR_EraseRootFromParent_Done,
     /* 1262120 */   // Label 18216: @1262120
     /* 1262120 */   GIM_Try, /*On fail goto*//*Label 18217*/ GIMT_Encode4(1262204), // Rule ID 8113 //
     /* 1262125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262178 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262203 */     // GIR_Coverage, 8113,
     /* 1262203 */     GIR_EraseRootFromParent_Done,
     /* 1262204 */   // Label 18217: @1262204
     /* 1262204 */   GIM_Try, /*On fail goto*//*Label 18218*/ GIMT_Encode4(1262288), // Rule ID 8116 //
     /* 1262209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1262229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262287 */     // GIR_Coverage, 8116,
     /* 1262287 */     GIR_EraseRootFromParent_Done,
     /* 1262288 */   // Label 18218: @1262288
     /* 1262288 */   GIM_Try, /*On fail goto*//*Label 18219*/ GIMT_Encode4(1262372), // Rule ID 8117 //
     /* 1262293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1262310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1262313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262346 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262371 */     // GIR_Coverage, 8117,
     /* 1262371 */     GIR_EraseRootFromParent_Done,
     /* 1262372 */   // Label 18219: @1262372
     /* 1262372 */   GIM_Try, /*On fail goto*//*Label 18220*/ GIMT_Encode4(1262456), // Rule ID 8120 //
     /* 1262377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1262397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262430 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262455 */     // GIR_Coverage, 8120,
     /* 1262455 */     GIR_EraseRootFromParent_Done,
     /* 1262456 */   // Label 18220: @1262456
     /* 1262456 */   GIM_Try, /*On fail goto*//*Label 18221*/ GIMT_Encode4(1262540), // Rule ID 8121 //
     /* 1262461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1262478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1262481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262539 */     // GIR_Coverage, 8121,
     /* 1262539 */     GIR_EraseRootFromParent_Done,
     /* 1262540 */   // Label 18221: @1262540
     /* 1262540 */   GIM_Try, /*On fail goto*//*Label 18222*/ GIMT_Encode4(1262624), // Rule ID 8124 //
     /* 1262545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1262562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1262565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262598 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262623 */     // GIR_Coverage, 8124,
     /* 1262623 */     GIR_EraseRootFromParent_Done,
     /* 1262624 */   // Label 18222: @1262624
     /* 1262624 */   GIM_Try, /*On fail goto*//*Label 18223*/ GIMT_Encode4(1262708), // Rule ID 8125 //
     /* 1262629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1262646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1262649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262682 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1262685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262707 */     // GIR_Coverage, 8125,
     /* 1262707 */     GIR_EraseRootFromParent_Done,
     /* 1262708 */   // Label 18223: @1262708
     /* 1262708 */   GIM_Try, /*On fail goto*//*Label 18224*/ GIMT_Encode4(1262792), // Rule ID 8128 //
     /* 1262713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1262730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1262733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262766 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262791 */     // GIR_Coverage, 8128,
     /* 1262791 */     GIR_EraseRootFromParent_Done,
     /* 1262792 */   // Label 18224: @1262792
     /* 1262792 */   GIM_Try, /*On fail goto*//*Label 18225*/ GIMT_Encode4(1262876), // Rule ID 8129 //
     /* 1262797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1262814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1262817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1262853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262875 */     // GIR_Coverage, 8129,
     /* 1262875 */     GIR_EraseRootFromParent_Done,
     /* 1262876 */   // Label 18225: @1262876
     /* 1262876 */   GIM_Try, /*On fail goto*//*Label 18226*/ GIMT_Encode4(1262960), // Rule ID 8132 //
     /* 1262881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1262898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1262901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262934 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1262937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262959 */     // GIR_Coverage, 8132,
     /* 1262959 */     GIR_EraseRootFromParent_Done,
     /* 1262960 */   // Label 18226: @1262960
     /* 1262960 */   GIM_Try, /*On fail goto*//*Label 18227*/ GIMT_Encode4(1263044), // Rule ID 8133 //
     /* 1262965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1262973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1262976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1262979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1262982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1262985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1262988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263018 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263043 */     // GIR_Coverage, 8133,
     /* 1263043 */     GIR_EraseRootFromParent_Done,
     /* 1263044 */   // Label 18227: @1263044
     /* 1263044 */   GIM_Try, /*On fail goto*//*Label 18228*/ GIMT_Encode4(1263128), // Rule ID 8136 //
     /* 1263049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263102 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263127 */     // GIR_Coverage, 8136,
     /* 1263127 */     GIR_EraseRootFromParent_Done,
     /* 1263128 */   // Label 18228: @1263128
     /* 1263128 */   GIM_Try, /*On fail goto*//*Label 18229*/ GIMT_Encode4(1263212), // Rule ID 8137 //
     /* 1263133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263186 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263211 */     // GIR_Coverage, 8137,
     /* 1263211 */     GIR_EraseRootFromParent_Done,
     /* 1263212 */   // Label 18229: @1263212
     /* 1263212 */   GIM_Try, /*On fail goto*//*Label 18230*/ GIMT_Encode4(1263296), // Rule ID 8140 //
     /* 1263217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1263237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263270 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263295 */     // GIR_Coverage, 8140,
     /* 1263295 */     GIR_EraseRootFromParent_Done,
     /* 1263296 */   // Label 18230: @1263296
     /* 1263296 */   GIM_Try, /*On fail goto*//*Label 18231*/ GIMT_Encode4(1263380), // Rule ID 8141 //
     /* 1263301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1263318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1263321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263354 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1263357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263379 */     // GIR_Coverage, 8141,
     /* 1263379 */     GIR_EraseRootFromParent_Done,
     /* 1263380 */   // Label 18231: @1263380
     /* 1263380 */   GIM_Try, /*On fail goto*//*Label 18232*/ GIMT_Encode4(1263464), // Rule ID 8144 //
     /* 1263385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1263405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263463 */     // GIR_Coverage, 8144,
     /* 1263463 */     GIR_EraseRootFromParent_Done,
     /* 1263464 */   // Label 18232: @1263464
     /* 1263464 */   GIM_Try, /*On fail goto*//*Label 18233*/ GIMT_Encode4(1263548), // Rule ID 8145 //
     /* 1263469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1263486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1263489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263522 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1263525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263547 */     // GIR_Coverage, 8145,
     /* 1263547 */     GIR_EraseRootFromParent_Done,
     /* 1263548 */   // Label 18233: @1263548
     /* 1263548 */   GIM_Try, /*On fail goto*//*Label 18234*/ GIMT_Encode4(1263632), // Rule ID 8148 //
     /* 1263553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1263556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1263570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1263573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263606 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263631 */     // GIR_Coverage, 8148,
     /* 1263631 */     GIR_EraseRootFromParent_Done,
     /* 1263632 */   // Label 18234: @1263632
     /* 1263632 */   GIM_Try, /*On fail goto*//*Label 18235*/ GIMT_Encode4(1263716), // Rule ID 8149 //
     /* 1263637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1263640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1263654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1263657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263690 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1263693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1263711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263715 */     // GIR_Coverage, 8149,
     /* 1263715 */     GIR_EraseRootFromParent_Done,
     /* 1263716 */   // Label 18235: @1263716
     /* 1263716 */   GIM_Try, /*On fail goto*//*Label 18236*/ GIMT_Encode4(1263800), // Rule ID 8152 //
     /* 1263721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1263732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1263735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1263738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1263744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263774 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1263777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263799 */     // GIR_Coverage, 8152,
     /* 1263799 */     GIR_EraseRootFromParent_Done,
     /* 1263800 */   // Label 18236: @1263800
     /* 1263800 */   GIM_Try, /*On fail goto*//*Label 18237*/ GIMT_Encode4(1263884), // Rule ID 8153 //
     /* 1263805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1263816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1263819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1263822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1263828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263858 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1263861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263883 */     // GIR_Coverage, 8153,
     /* 1263883 */     GIR_EraseRootFromParent_Done,
     /* 1263884 */   // Label 18237: @1263884
     /* 1263884 */   GIM_Try, /*On fail goto*//*Label 18238*/ GIMT_Encode4(1263968), // Rule ID 8156 //
     /* 1263889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1263906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1263909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1263931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263942 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1263945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263967 */     // GIR_Coverage, 8156,
     /* 1263967 */     GIR_EraseRootFromParent_Done,
     /* 1263968 */   // Label 18238: @1263968
     /* 1263968 */   GIM_Try, /*On fail goto*//*Label 18239*/ GIMT_Encode4(1264052), // Rule ID 8157 //
     /* 1263973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1263981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1263984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1263987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1263990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1263993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1263996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264026 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264051 */     // GIR_Coverage, 8157,
     /* 1264051 */     GIR_EraseRootFromParent_Done,
     /* 1264052 */   // Label 18239: @1264052
     /* 1264052 */   GIM_Try, /*On fail goto*//*Label 18240*/ GIMT_Encode4(1264136), // Rule ID 8160 //
     /* 1264057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264110 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264135 */     // GIR_Coverage, 8160,
     /* 1264135 */     GIR_EraseRootFromParent_Done,
     /* 1264136 */   // Label 18240: @1264136
     /* 1264136 */   GIM_Try, /*On fail goto*//*Label 18241*/ GIMT_Encode4(1264220), // Rule ID 8161 //
     /* 1264141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264194 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264219 */     // GIR_Coverage, 8161,
     /* 1264219 */     GIR_EraseRootFromParent_Done,
     /* 1264220 */   // Label 18241: @1264220
     /* 1264220 */   GIM_Try, /*On fail goto*//*Label 18242*/ GIMT_Encode4(1264304), // Rule ID 8164 //
     /* 1264225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264278 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264303 */     // GIR_Coverage, 8164,
     /* 1264303 */     GIR_EraseRootFromParent_Done,
     /* 1264304 */   // Label 18242: @1264304
     /* 1264304 */   GIM_Try, /*On fail goto*//*Label 18243*/ GIMT_Encode4(1264388), // Rule ID 8165 //
     /* 1264309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1264326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264362 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1264365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264387 */     // GIR_Coverage, 8165,
     /* 1264387 */     GIR_EraseRootFromParent_Done,
     /* 1264388 */   // Label 18243: @1264388
     /* 1264388 */   GIM_Try, /*On fail goto*//*Label 18244*/ GIMT_Encode4(1264472), // Rule ID 8168 //
     /* 1264393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264471 */     // GIR_Coverage, 8168,
     /* 1264471 */     GIR_EraseRootFromParent_Done,
     /* 1264472 */   // Label 18244: @1264472
     /* 1264472 */   GIM_Try, /*On fail goto*//*Label 18245*/ GIMT_Encode4(1264556), // Rule ID 8169 //
     /* 1264477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1264494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264555 */     // GIR_Coverage, 8169,
     /* 1264555 */     GIR_EraseRootFromParent_Done,
     /* 1264556 */   // Label 18245: @1264556
     /* 1264556 */   GIM_Try, /*On fail goto*//*Label 18246*/ GIMT_Encode4(1264640), // Rule ID 8172 //
     /* 1264561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1264578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264614 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264639 */     // GIR_Coverage, 8172,
     /* 1264639 */     GIR_EraseRootFromParent_Done,
     /* 1264640 */   // Label 18246: @1264640
     /* 1264640 */   GIM_Try, /*On fail goto*//*Label 18247*/ GIMT_Encode4(1264724), // Rule ID 8173 //
     /* 1264645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1264662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1264701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264723 */     // GIR_Coverage, 8173,
     /* 1264723 */     GIR_EraseRootFromParent_Done,
     /* 1264724 */   // Label 18247: @1264724
     /* 1264724 */   GIM_Try, /*On fail goto*//*Label 18248*/ GIMT_Encode4(1264808), // Rule ID 8176 //
     /* 1264729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1264746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1264785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264807 */     // GIR_Coverage, 8176,
     /* 1264807 */     GIR_EraseRootFromParent_Done,
     /* 1264808 */   // Label 18248: @1264808
     /* 1264808 */   GIM_Try, /*On fail goto*//*Label 18249*/ GIMT_Encode4(1264892), // Rule ID 8177 //
     /* 1264813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1264830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264866 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1264869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264891 */     // GIR_Coverage, 8177,
     /* 1264891 */     GIR_EraseRootFromParent_Done,
     /* 1264892 */   // Label 18249: @1264892
     /* 1264892 */   GIM_Try, /*On fail goto*//*Label 18250*/ GIMT_Encode4(1264976), // Rule ID 8180 //
     /* 1264897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1264914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1264953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1264971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264975 */     // GIR_Coverage, 8180,
     /* 1264975 */     GIR_EraseRootFromParent_Done,
     /* 1264976 */   // Label 18250: @1264976
     /* 1264976 */   GIM_Try, /*On fail goto*//*Label 18251*/ GIMT_Encode4(1265060), // Rule ID 8181 //
     /* 1264981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1264989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1264998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265059 */     // GIR_Coverage, 8181,
     /* 1265059 */     GIR_EraseRootFromParent_Done,
     /* 1265060 */   // Label 18251: @1265060
     /* 1265060 */   GIM_Try, /*On fail goto*//*Label 18252*/ GIMT_Encode4(1265144), // Rule ID 8184 //
     /* 1265065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265118 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265143 */     // GIR_Coverage, 8184,
     /* 1265143 */     GIR_EraseRootFromParent_Done,
     /* 1265144 */   // Label 18252: @1265144
     /* 1265144 */   GIM_Try, /*On fail goto*//*Label 18253*/ GIMT_Encode4(1265228), // Rule ID 8185 //
     /* 1265149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265227 */     // GIR_Coverage, 8185,
     /* 1265227 */     GIR_EraseRootFromParent_Done,
     /* 1265228 */   // Label 18253: @1265228
     /* 1265228 */   GIM_Try, /*On fail goto*//*Label 18254*/ GIMT_Encode4(1265312), // Rule ID 8188 //
     /* 1265233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1265236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265286 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265311 */     // GIR_Coverage, 8188,
     /* 1265311 */     GIR_EraseRootFromParent_Done,
     /* 1265312 */   // Label 18254: @1265312
     /* 1265312 */   GIM_Try, /*On fail goto*//*Label 18255*/ GIMT_Encode4(1265396), // Rule ID 8189 //
     /* 1265317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1265320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1265334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265370 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1265373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1265391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265395 */     // GIR_Coverage, 8189,
     /* 1265395 */     GIR_EraseRootFromParent_Done,
     /* 1265396 */   // Label 18255: @1265396
     /* 1265396 */   GIM_Try, /*On fail goto*//*Label 18256*/ GIMT_Encode4(1265480), // Rule ID 8192 //
     /* 1265401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265454 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1265457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265479 */     // GIR_Coverage, 8192,
     /* 1265479 */     GIR_EraseRootFromParent_Done,
     /* 1265480 */   // Label 18256: @1265480
     /* 1265480 */   GIM_Try, /*On fail goto*//*Label 18257*/ GIMT_Encode4(1265564), // Rule ID 8193 //
     /* 1265485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1265496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1265499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1265502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1265508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265538 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1265541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265563 */     // GIR_Coverage, 8193,
     /* 1265563 */     GIR_EraseRootFromParent_Done,
     /* 1265564 */   // Label 18257: @1265564
     /* 1265564 */   GIM_Try, /*On fail goto*//*Label 18258*/ GIMT_Encode4(1265648), // Rule ID 8196 //
     /* 1265569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1265580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1265583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1265586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1265592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1265607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265622 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1265625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265647 */     // GIR_Coverage, 8196,
     /* 1265647 */     GIR_EraseRootFromParent_Done,
     /* 1265648 */   // Label 18258: @1265648
     /* 1265648 */   GIM_Try, /*On fail goto*//*Label 18259*/ GIMT_Encode4(1265732), // Rule ID 8197 //
     /* 1265653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1265664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1265667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1265670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1265676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1265691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265706 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1265709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265731 */     // GIR_Coverage, 8197,
     /* 1265731 */     GIR_EraseRootFromParent_Done,
     /* 1265732 */   // Label 18259: @1265732
     /* 1265732 */   GIM_Try, /*On fail goto*//*Label 18260*/ GIMT_Encode4(1265816), // Rule ID 8200 //
     /* 1265737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1265748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1265751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1265754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1265760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1265775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265790 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1265793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265815 */     // GIR_Coverage, 8200,
     /* 1265815 */     GIR_EraseRootFromParent_Done,
     /* 1265816 */   // Label 18260: @1265816
     /* 1265816 */   GIM_Try, /*On fail goto*//*Label 18261*/ GIMT_Encode4(1265900), // Rule ID 8201 //
     /* 1265821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1265832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1265835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1265838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1265844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1265859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265874 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1265877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265899 */     // GIR_Coverage, 8201,
     /* 1265899 */     GIR_EraseRootFromParent_Done,
     /* 1265900 */   // Label 18261: @1265900
     /* 1265900 */   GIM_Try, /*On fail goto*//*Label 18262*/ GIMT_Encode4(1265984), // Rule ID 8204 //
     /* 1265905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1265922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1265943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1265961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265983 */     // GIR_Coverage, 8204,
     /* 1265983 */     GIR_EraseRootFromParent_Done,
     /* 1265984 */   // Label 18262: @1265984
     /* 1265984 */   GIM_Try, /*On fail goto*//*Label 18263*/ GIMT_Encode4(1266068), // Rule ID 8205 //
     /* 1265989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1265997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266042 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266067 */     // GIR_Coverage, 8205,
     /* 1266067 */     GIR_EraseRootFromParent_Done,
     /* 1266068 */   // Label 18263: @1266068
     /* 1266068 */   GIM_Try, /*On fail goto*//*Label 18264*/ GIMT_Encode4(1266152), // Rule ID 8208 //
     /* 1266073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266126 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266151 */     // GIR_Coverage, 8208,
     /* 1266151 */     GIR_EraseRootFromParent_Done,
     /* 1266152 */   // Label 18264: @1266152
     /* 1266152 */   GIM_Try, /*On fail goto*//*Label 18265*/ GIMT_Encode4(1266236), // Rule ID 8209 //
     /* 1266157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266210 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266235 */     // GIR_Coverage, 8209,
     /* 1266235 */     GIR_EraseRootFromParent_Done,
     /* 1266236 */   // Label 18265: @1266236
     /* 1266236 */   GIM_Try, /*On fail goto*//*Label 18266*/ GIMT_Encode4(1266320), // Rule ID 8212 //
     /* 1266241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266294 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266319 */     // GIR_Coverage, 8212,
     /* 1266319 */     GIR_EraseRootFromParent_Done,
     /* 1266320 */   // Label 18266: @1266320
     /* 1266320 */   GIM_Try, /*On fail goto*//*Label 18267*/ GIMT_Encode4(1266404), // Rule ID 8213 //
     /* 1266325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1266342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266378 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266403 */     // GIR_Coverage, 8213,
     /* 1266403 */     GIR_EraseRootFromParent_Done,
     /* 1266404 */   // Label 18267: @1266404
     /* 1266404 */   GIM_Try, /*On fail goto*//*Label 18268*/ GIMT_Encode4(1266488), // Rule ID 8216 //
     /* 1266409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266462 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266487 */     // GIR_Coverage, 8216,
     /* 1266487 */     GIR_EraseRootFromParent_Done,
     /* 1266488 */   // Label 18268: @1266488
     /* 1266488 */   GIM_Try, /*On fail goto*//*Label 18269*/ GIMT_Encode4(1266572), // Rule ID 8217 //
     /* 1266493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1266504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1266507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1266510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1266516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266546 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266571 */     // GIR_Coverage, 8217,
     /* 1266571 */     GIR_EraseRootFromParent_Done,
     /* 1266572 */   // Label 18269: @1266572
     /* 1266572 */   GIM_Try, /*On fail goto*//*Label 18270*/ GIMT_Encode4(1266656), // Rule ID 8220 //
     /* 1266577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1266594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266630 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266655 */     // GIR_Coverage, 8220,
     /* 1266655 */     GIR_EraseRootFromParent_Done,
     /* 1266656 */   // Label 18270: @1266656
     /* 1266656 */   GIM_Try, /*On fail goto*//*Label 18271*/ GIMT_Encode4(1266740), // Rule ID 8221 //
     /* 1266661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1266678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1266717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266739 */     // GIR_Coverage, 8221,
     /* 1266739 */     GIR_EraseRootFromParent_Done,
     /* 1266740 */   // Label 18271: @1266740
     /* 1266740 */   GIM_Try, /*On fail goto*//*Label 18272*/ GIMT_Encode4(1266824), // Rule ID 8224 //
     /* 1266745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1266762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266798 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266823 */     // GIR_Coverage, 8224,
     /* 1266823 */     GIR_EraseRootFromParent_Done,
     /* 1266824 */   // Label 18272: @1266824
     /* 1266824 */   GIM_Try, /*On fail goto*//*Label 18273*/ GIMT_Encode4(1266908), // Rule ID 8225 //
     /* 1266829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1266846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266882 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1266885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266907 */     // GIR_Coverage, 8225,
     /* 1266907 */     GIR_EraseRootFromParent_Done,
     /* 1266908 */   // Label 18273: @1266908
     /* 1266908 */   GIM_Try, /*On fail goto*//*Label 18274*/ GIMT_Encode4(1266992), // Rule ID 8228 //
     /* 1266913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1266916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1266921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1266924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1266927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1266930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1266936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266966 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1266969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1266987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266991 */     // GIR_Coverage, 8228,
     /* 1266991 */     GIR_EraseRootFromParent_Done,
     /* 1266992 */   // Label 18274: @1266992
     /* 1266992 */   GIM_Try, /*On fail goto*//*Label 18275*/ GIMT_Encode4(1267076), // Rule ID 8229 //
     /* 1266997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1267053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267075 */     // GIR_Coverage, 8229,
     /* 1267075 */     GIR_EraseRootFromParent_Done,
     /* 1267076 */   // Label 18275: @1267076
     /* 1267076 */   GIM_Try, /*On fail goto*//*Label 18276*/ GIMT_Encode4(1267160), // Rule ID 8232 //
     /* 1267081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267159 */     // GIR_Coverage, 8232,
     /* 1267159 */     GIR_EraseRootFromParent_Done,
     /* 1267160 */   // Label 18276: @1267160
     /* 1267160 */   GIM_Try, /*On fail goto*//*Label 18277*/ GIMT_Encode4(1267244), // Rule ID 8233 //
     /* 1267165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267218 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1267221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267243 */     // GIR_Coverage, 8233,
     /* 1267243 */     GIR_EraseRootFromParent_Done,
     /* 1267244 */   // Label 18277: @1267244
     /* 1267244 */   GIM_Try, /*On fail goto*//*Label 18278*/ GIMT_Encode4(1267328), // Rule ID 8236 //
     /* 1267249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267327 */     // GIR_Coverage, 8236,
     /* 1267327 */     GIR_EraseRootFromParent_Done,
     /* 1267328 */   // Label 18278: @1267328
     /* 1267328 */   GIM_Try, /*On fail goto*//*Label 18279*/ GIMT_Encode4(1267412), // Rule ID 8237 //
     /* 1267333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1267341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1267350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267386 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1267389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267411 */     // GIR_Coverage, 8237,
     /* 1267411 */     GIR_EraseRootFromParent_Done,
     /* 1267412 */   // Label 18279: @1267412
     /* 1267412 */   GIM_Try, /*On fail goto*//*Label 18280*/ GIMT_Encode4(1267496), // Rule ID 8328 //
     /* 1267417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1267437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1267473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267495 */     // GIR_Coverage, 8328,
     /* 1267495 */     GIR_EraseRootFromParent_Done,
     /* 1267496 */   // Label 18280: @1267496
     /* 1267496 */   GIM_Try, /*On fail goto*//*Label 18281*/ GIMT_Encode4(1267580), // Rule ID 8329 //
     /* 1267501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1267518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1267521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267554 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1267557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267579 */     // GIR_Coverage, 8329,
     /* 1267579 */     GIR_EraseRootFromParent_Done,
     /* 1267580 */   // Label 18281: @1267580
     /* 1267580 */   GIM_Try, /*On fail goto*//*Label 18282*/ GIMT_Encode4(1267664), // Rule ID 8332 //
     /* 1267585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1267602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1267605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267638 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1267641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267663 */     // GIR_Coverage, 8332,
     /* 1267663 */     GIR_EraseRootFromParent_Done,
     /* 1267664 */   // Label 18282: @1267664
     /* 1267664 */   GIM_Try, /*On fail goto*//*Label 18283*/ GIMT_Encode4(1267748), // Rule ID 8333 //
     /* 1267669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1267686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1267689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267722 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1267725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267747 */     // GIR_Coverage, 8333,
     /* 1267747 */     GIR_EraseRootFromParent_Done,
     /* 1267748 */   // Label 18283: @1267748
     /* 1267748 */   GIM_Try, /*On fail goto*//*Label 18284*/ GIMT_Encode4(1267832), // Rule ID 8336 //
     /* 1267753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1267770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1267773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1267809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267831 */     // GIR_Coverage, 8336,
     /* 1267831 */     GIR_EraseRootFromParent_Done,
     /* 1267832 */   // Label 18284: @1267832
     /* 1267832 */   GIM_Try, /*On fail goto*//*Label 18285*/ GIMT_Encode4(1267916), // Rule ID 8337 //
     /* 1267837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1267854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1267857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1267893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1267911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267915 */     // GIR_Coverage, 8337,
     /* 1267915 */     GIR_EraseRootFromParent_Done,
     /* 1267916 */   // Label 18285: @1267916
     /* 1267916 */   GIM_Try, /*On fail goto*//*Label 18286*/ GIMT_Encode4(1268000), // Rule ID 8340 //
     /* 1267921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1267932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1267935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1267938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1267941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1267944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267974 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1267977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267999 */     // GIR_Coverage, 8340,
     /* 1267999 */     GIR_EraseRootFromParent_Done,
     /* 1268000 */   // Label 18286: @1268000
     /* 1268000 */   GIM_Try, /*On fail goto*//*Label 18287*/ GIMT_Encode4(1268084), // Rule ID 8341 //
     /* 1268005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1268025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268058 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1268061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268083 */     // GIR_Coverage, 8341,
     /* 1268083 */     GIR_EraseRootFromParent_Done,
     /* 1268084 */   // Label 18287: @1268084
     /* 1268084 */   GIM_Try, /*On fail goto*//*Label 18288*/ GIMT_Encode4(1268168), // Rule ID 8344 //
     /* 1268089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268167 */     // GIR_Coverage, 8344,
     /* 1268167 */     GIR_EraseRootFromParent_Done,
     /* 1268168 */   // Label 18288: @1268168
     /* 1268168 */   GIM_Try, /*On fail goto*//*Label 18289*/ GIMT_Encode4(1268252), // Rule ID 8345 //
     /* 1268173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268251 */     // GIR_Coverage, 8345,
     /* 1268251 */     GIR_EraseRootFromParent_Done,
     /* 1268252 */   // Label 18289: @1268252
     /* 1268252 */   GIM_Try, /*On fail goto*//*Label 18290*/ GIMT_Encode4(1268336), // Rule ID 8348 //
     /* 1268257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1268277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268310 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268335 */     // GIR_Coverage, 8348,
     /* 1268335 */     GIR_EraseRootFromParent_Done,
     /* 1268336 */   // Label 18290: @1268336
     /* 1268336 */   GIM_Try, /*On fail goto*//*Label 18291*/ GIMT_Encode4(1268420), // Rule ID 8349 //
     /* 1268341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1268358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1268361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268394 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1268397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268419 */     // GIR_Coverage, 8349,
     /* 1268419 */     GIR_EraseRootFromParent_Done,
     /* 1268420 */   // Label 18291: @1268420
     /* 1268420 */   GIM_Try, /*On fail goto*//*Label 18292*/ GIMT_Encode4(1268504), // Rule ID 8352 //
     /* 1268425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268478 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268503 */     // GIR_Coverage, 8352,
     /* 1268503 */     GIR_EraseRootFromParent_Done,
     /* 1268504 */   // Label 18292: @1268504
     /* 1268504 */   GIM_Try, /*On fail goto*//*Label 18293*/ GIMT_Encode4(1268588), // Rule ID 8353 //
     /* 1268509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1268526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1268529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268562 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268587 */     // GIR_Coverage, 8353,
     /* 1268587 */     GIR_EraseRootFromParent_Done,
     /* 1268588 */   // Label 18293: @1268588
     /* 1268588 */   GIM_Try, /*On fail goto*//*Label 18294*/ GIMT_Encode4(1268672), // Rule ID 8356 //
     /* 1268593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1268610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1268613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268646 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268671 */     // GIR_Coverage, 8356,
     /* 1268671 */     GIR_EraseRootFromParent_Done,
     /* 1268672 */   // Label 18294: @1268672
     /* 1268672 */   GIM_Try, /*On fail goto*//*Label 18295*/ GIMT_Encode4(1268756), // Rule ID 8357 //
     /* 1268677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1268694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1268697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268755 */     // GIR_Coverage, 8357,
     /* 1268755 */     GIR_EraseRootFromParent_Done,
     /* 1268756 */   // Label 18295: @1268756
     /* 1268756 */   GIM_Try, /*On fail goto*//*Label 18296*/ GIMT_Encode4(1268840), // Rule ID 8360 //
     /* 1268761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1268778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1268781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268814 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268839 */     // GIR_Coverage, 8360,
     /* 1268839 */     GIR_EraseRootFromParent_Done,
     /* 1268840 */   // Label 18296: @1268840
     /* 1268840 */   GIM_Try, /*On fail goto*//*Label 18297*/ GIMT_Encode4(1268924), // Rule ID 8361 //
     /* 1268845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1268862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1268865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1268919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268923 */     // GIR_Coverage, 8361,
     /* 1268923 */     GIR_EraseRootFromParent_Done,
     /* 1268924 */   // Label 18297: @1268924
     /* 1268924 */   GIM_Try, /*On fail goto*//*Label 18298*/ GIMT_Encode4(1269008), // Rule ID 8364 //
     /* 1268929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1268932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1268946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1268949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268982 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1268985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269007 */     // GIR_Coverage, 8364,
     /* 1269007 */     GIR_EraseRootFromParent_Done,
     /* 1269008 */   // Label 18298: @1269008
     /* 1269008 */   GIM_Try, /*On fail goto*//*Label 18299*/ GIMT_Encode4(1269092), // Rule ID 8365 //
     /* 1269013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1269016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269066 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1269069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269091 */     // GIR_Coverage, 8365,
     /* 1269091 */     GIR_EraseRootFromParent_Done,
     /* 1269092 */   // Label 18299: @1269092
     /* 1269092 */   GIM_Try, /*On fail goto*//*Label 18300*/ GIMT_Encode4(1269176), // Rule ID 8368 //
     /* 1269097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1269117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269150 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269175 */     // GIR_Coverage, 8368,
     /* 1269175 */     GIR_EraseRootFromParent_Done,
     /* 1269176 */   // Label 18300: @1269176
     /* 1269176 */   GIM_Try, /*On fail goto*//*Label 18301*/ GIMT_Encode4(1269260), // Rule ID 8369 //
     /* 1269181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1269201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269234 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269259 */     // GIR_Coverage, 8369,
     /* 1269259 */     GIR_EraseRootFromParent_Done,
     /* 1269260 */   // Label 18301: @1269260
     /* 1269260 */   GIM_Try, /*On fail goto*//*Label 18302*/ GIMT_Encode4(1269344), // Rule ID 8372 //
     /* 1269265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1269285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269318 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269343 */     // GIR_Coverage, 8372,
     /* 1269343 */     GIR_EraseRootFromParent_Done,
     /* 1269344 */   // Label 18302: @1269344
     /* 1269344 */   GIM_Try, /*On fail goto*//*Label 18303*/ GIMT_Encode4(1269428), // Rule ID 8373 //
     /* 1269349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1269366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1269369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269402 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269427 */     // GIR_Coverage, 8373,
     /* 1269427 */     GIR_EraseRootFromParent_Done,
     /* 1269428 */   // Label 18303: @1269428
     /* 1269428 */   GIM_Try, /*On fail goto*//*Label 18304*/ GIMT_Encode4(1269512), // Rule ID 8376 //
     /* 1269433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1269444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1269447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1269450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1269453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1269456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269486 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1269489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269511 */     // GIR_Coverage, 8376,
     /* 1269511 */     GIR_EraseRootFromParent_Done,
     /* 1269512 */   // Label 18304: @1269512
     /* 1269512 */   GIM_Try, /*On fail goto*//*Label 18305*/ GIMT_Encode4(1269596), // Rule ID 8377 //
     /* 1269517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1269528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1269531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1269534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1269537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1269540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269570 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1269573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269595 */     // GIR_Coverage, 8377,
     /* 1269595 */     GIR_EraseRootFromParent_Done,
     /* 1269596 */   // Label 18305: @1269596
     /* 1269596 */   GIM_Try, /*On fail goto*//*Label 18306*/ GIMT_Encode4(1269680), // Rule ID 8380 //
     /* 1269601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1269618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1269621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269654 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269679 */     // GIR_Coverage, 8380,
     /* 1269679 */     GIR_EraseRootFromParent_Done,
     /* 1269680 */   // Label 18306: @1269680
     /* 1269680 */   GIM_Try, /*On fail goto*//*Label 18307*/ GIMT_Encode4(1269764), // Rule ID 8381 //
     /* 1269685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1269702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1269705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1269741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269763 */     // GIR_Coverage, 8381,
     /* 1269763 */     GIR_EraseRootFromParent_Done,
     /* 1269764 */   // Label 18307: @1269764
     /* 1269764 */   GIM_Try, /*On fail goto*//*Label 18308*/ GIMT_Encode4(1269848), // Rule ID 8384 //
     /* 1269769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1269786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1269789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269822 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269847 */     // GIR_Coverage, 8384,
     /* 1269847 */     GIR_EraseRootFromParent_Done,
     /* 1269848 */   // Label 18308: @1269848
     /* 1269848 */   GIM_Try, /*On fail goto*//*Label 18309*/ GIMT_Encode4(1269932), // Rule ID 8385 //
     /* 1269853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1269870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1269873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1269895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269906 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1269909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269931 */     // GIR_Coverage, 8385,
     /* 1269931 */     GIR_EraseRootFromParent_Done,
     /* 1269932 */   // Label 18309: @1269932
     /* 1269932 */   GIM_Try, /*On fail goto*//*Label 18310*/ GIMT_Encode4(1270016), // Rule ID 8388 //
     /* 1269937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1269945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1269948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1269951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1269954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1269957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1269960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1269979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269990 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1269993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270015 */     // GIR_Coverage, 8388,
     /* 1270015 */     GIR_EraseRootFromParent_Done,
     /* 1270016 */   // Label 18310: @1270016
     /* 1270016 */   GIM_Try, /*On fail goto*//*Label 18311*/ GIMT_Encode4(1270100), // Rule ID 8389 //
     /* 1270021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1270041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270074 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270099 */     // GIR_Coverage, 8389,
     /* 1270099 */     GIR_EraseRootFromParent_Done,
     /* 1270100 */   // Label 18311: @1270100
     /* 1270100 */   GIM_Try, /*On fail goto*//*Label 18312*/ GIMT_Encode4(1270184), // Rule ID 8392 //
     /* 1270105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1270125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270158 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270183 */     // GIR_Coverage, 8392,
     /* 1270183 */     GIR_EraseRootFromParent_Done,
     /* 1270184 */   // Label 18312: @1270184
     /* 1270184 */   GIM_Try, /*On fail goto*//*Label 18313*/ GIMT_Encode4(1270268), // Rule ID 8393 //
     /* 1270189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1270209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270242 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270267 */     // GIR_Coverage, 8393,
     /* 1270267 */     GIR_EraseRootFromParent_Done,
     /* 1270268 */   // Label 18313: @1270268
     /* 1270268 */   GIM_Try, /*On fail goto*//*Label 18314*/ GIMT_Encode4(1270352), // Rule ID 8396 //
     /* 1270273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1270293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270326 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270351 */     // GIR_Coverage, 8396,
     /* 1270351 */     GIR_EraseRootFromParent_Done,
     /* 1270352 */   // Label 18314: @1270352
     /* 1270352 */   GIM_Try, /*On fail goto*//*Label 18315*/ GIMT_Encode4(1270436), // Rule ID 8397 //
     /* 1270357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1270374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1270377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270435 */     // GIR_Coverage, 8397,
     /* 1270435 */     GIR_EraseRootFromParent_Done,
     /* 1270436 */   // Label 18315: @1270436
     /* 1270436 */   GIM_Try, /*On fail goto*//*Label 18316*/ GIMT_Encode4(1270520), // Rule ID 8400 //
     /* 1270441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1270458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1270461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270494 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270519 */     // GIR_Coverage, 8400,
     /* 1270519 */     GIR_EraseRootFromParent_Done,
     /* 1270520 */   // Label 18316: @1270520
     /* 1270520 */   GIM_Try, /*On fail goto*//*Label 18317*/ GIMT_Encode4(1270604), // Rule ID 8401 //
     /* 1270525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1270542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1270545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270578 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1270581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270603 */     // GIR_Coverage, 8401,
     /* 1270603 */     GIR_EraseRootFromParent_Done,
     /* 1270604 */   // Label 18317: @1270604
     /* 1270604 */   GIM_Try, /*On fail goto*//*Label 18318*/ GIMT_Encode4(1270688), // Rule ID 8404 //
     /* 1270609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1270612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1270620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1270623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1270626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1270629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1270632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270687 */     // GIR_Coverage, 8404,
     /* 1270687 */     GIR_EraseRootFromParent_Done,
     /* 1270688 */   // Label 18318: @1270688
     /* 1270688 */   GIM_Try, /*On fail goto*//*Label 18319*/ GIMT_Encode4(1270772), // Rule ID 8405 //
     /* 1270693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1270696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1270704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1270707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1270710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1270713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1270716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270746 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1270749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270771 */     // GIR_Coverage, 8405,
     /* 1270771 */     GIR_EraseRootFromParent_Done,
     /* 1270772 */   // Label 18319: @1270772
     /* 1270772 */   GIM_Try, /*On fail goto*//*Label 18320*/ GIMT_Encode4(1270856), // Rule ID 8408 //
     /* 1270777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1270780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1270794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1270797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270830 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270855 */     // GIR_Coverage, 8408,
     /* 1270855 */     GIR_EraseRootFromParent_Done,
     /* 1270856 */   // Label 18320: @1270856
     /* 1270856 */   GIM_Try, /*On fail goto*//*Label 18321*/ GIMT_Encode4(1270940), // Rule ID 8409 //
     /* 1270861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1270864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1270878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1270881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270914 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1270917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1270935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270939 */     // GIR_Coverage, 8409,
     /* 1270939 */     GIR_EraseRootFromParent_Done,
     /* 1270940 */   // Label 18321: @1270940
     /* 1270940 */   GIM_Try, /*On fail goto*//*Label 18322*/ GIMT_Encode4(1271024), // Rule ID 8412 //
     /* 1270945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1270948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1270953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1270962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1270965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270998 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271023 */     // GIR_Coverage, 8412,
     /* 1271023 */     GIR_EraseRootFromParent_Done,
     /* 1271024 */   // Label 18322: @1271024
     /* 1271024 */   GIM_Try, /*On fail goto*//*Label 18323*/ GIMT_Encode4(1271108), // Rule ID 8413 //
     /* 1271029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1271049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271082 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1271085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271107 */     // GIR_Coverage, 8413,
     /* 1271107 */     GIR_EraseRootFromParent_Done,
     /* 1271108 */   // Label 18323: @1271108
     /* 1271108 */   GIM_Try, /*On fail goto*//*Label 18324*/ GIMT_Encode4(1271192), // Rule ID 8416 //
     /* 1271113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271166 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1271169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271191 */     // GIR_Coverage, 8416,
     /* 1271191 */     GIR_EraseRootFromParent_Done,
     /* 1271192 */   // Label 18324: @1271192
     /* 1271192 */   GIM_Try, /*On fail goto*//*Label 18325*/ GIMT_Encode4(1271276), // Rule ID 8417 //
     /* 1271197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271250 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1271253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271275 */     // GIR_Coverage, 8417,
     /* 1271275 */     GIR_EraseRootFromParent_Done,
     /* 1271276 */   // Label 18325: @1271276
     /* 1271276 */   GIM_Try, /*On fail goto*//*Label 18326*/ GIMT_Encode4(1271360), // Rule ID 8420 //
     /* 1271281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271334 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271359 */     // GIR_Coverage, 8420,
     /* 1271359 */     GIR_EraseRootFromParent_Done,
     /* 1271360 */   // Label 18326: @1271360
     /* 1271360 */   GIM_Try, /*On fail goto*//*Label 18327*/ GIMT_Encode4(1271444), // Rule ID 8421 //
     /* 1271365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1271382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271418 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271443 */     // GIR_Coverage, 8421,
     /* 1271443 */     GIR_EraseRootFromParent_Done,
     /* 1271444 */   // Label 18327: @1271444
     /* 1271444 */   GIM_Try, /*On fail goto*//*Label 18328*/ GIMT_Encode4(1271528), // Rule ID 8424 //
     /* 1271449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1271466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271502 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271527 */     // GIR_Coverage, 8424,
     /* 1271527 */     GIR_EraseRootFromParent_Done,
     /* 1271528 */   // Label 18328: @1271528
     /* 1271528 */   GIM_Try, /*On fail goto*//*Label 18329*/ GIMT_Encode4(1271612), // Rule ID 8425 //
     /* 1271533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1271550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271586 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271611 */     // GIR_Coverage, 8425,
     /* 1271611 */     GIR_EraseRootFromParent_Done,
     /* 1271612 */   // Label 18329: @1271612
     /* 1271612 */   GIM_Try, /*On fail goto*//*Label 18330*/ GIMT_Encode4(1271696), // Rule ID 8428 //
     /* 1271617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1271634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271670 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271695 */     // GIR_Coverage, 8428,
     /* 1271695 */     GIR_EraseRootFromParent_Done,
     /* 1271696 */   // Label 18330: @1271696
     /* 1271696 */   GIM_Try, /*On fail goto*//*Label 18331*/ GIMT_Encode4(1271780), // Rule ID 8429 //
     /* 1271701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1271718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271754 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1271757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271779 */     // GIR_Coverage, 8429,
     /* 1271779 */     GIR_EraseRootFromParent_Done,
     /* 1271780 */   // Label 18331: @1271780
     /* 1271780 */   GIM_Try, /*On fail goto*//*Label 18332*/ GIMT_Encode4(1271864), // Rule ID 8432 //
     /* 1271785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1271802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271838 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271863 */     // GIR_Coverage, 8432,
     /* 1271863 */     GIR_EraseRootFromParent_Done,
     /* 1271864 */   // Label 18332: @1271864
     /* 1271864 */   GIM_Try, /*On fail goto*//*Label 18333*/ GIMT_Encode4(1271948), // Rule ID 8433 //
     /* 1271869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1271886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1271889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1271925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1271943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271947 */     // GIR_Coverage, 8433,
     /* 1271947 */     GIR_EraseRootFromParent_Done,
     /* 1271948 */   // Label 18333: @1271948
     /* 1271948 */   GIM_Try, /*On fail goto*//*Label 18334*/ GIMT_Encode4(1272032), // Rule ID 8436 //
     /* 1271953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1271961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1271970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272006 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272031 */     // GIR_Coverage, 8436,
     /* 1272031 */     GIR_EraseRootFromParent_Done,
     /* 1272032 */   // Label 18334: @1272032
     /* 1272032 */   GIM_Try, /*On fail goto*//*Label 18335*/ GIMT_Encode4(1272116), // Rule ID 8437 //
     /* 1272037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272090 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1272093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272115 */     // GIR_Coverage, 8437,
     /* 1272115 */     GIR_EraseRootFromParent_Done,
     /* 1272116 */   // Label 18335: @1272116
     /* 1272116 */   GIM_Try, /*On fail goto*//*Label 18336*/ GIMT_Encode4(1272200), // Rule ID 8440 //
     /* 1272121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272174 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272199 */     // GIR_Coverage, 8440,
     /* 1272199 */     GIR_EraseRootFromParent_Done,
     /* 1272200 */   // Label 18336: @1272200
     /* 1272200 */   GIM_Try, /*On fail goto*//*Label 18337*/ GIMT_Encode4(1272284), // Rule ID 8441 //
     /* 1272205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272283 */     // GIR_Coverage, 8441,
     /* 1272283 */     GIR_EraseRootFromParent_Done,
     /* 1272284 */   // Label 18337: @1272284
     /* 1272284 */   GIM_Try, /*On fail goto*//*Label 18338*/ GIMT_Encode4(1272368), // Rule ID 8444 //
     /* 1272289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272342 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272367 */     // GIR_Coverage, 8444,
     /* 1272367 */     GIR_EraseRootFromParent_Done,
     /* 1272368 */   // Label 18338: @1272368
     /* 1272368 */   GIM_Try, /*On fail goto*//*Label 18339*/ GIMT_Encode4(1272452), // Rule ID 8445 //
     /* 1272373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1272390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272426 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272451 */     // GIR_Coverage, 8445,
     /* 1272451 */     GIR_EraseRootFromParent_Done,
     /* 1272452 */   // Label 18339: @1272452
     /* 1272452 */   GIM_Try, /*On fail goto*//*Label 18340*/ GIMT_Encode4(1272536), // Rule ID 8448 //
     /* 1272457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1272474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272510 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272535 */     // GIR_Coverage, 8448,
     /* 1272535 */     GIR_EraseRootFromParent_Done,
     /* 1272536 */   // Label 18340: @1272536
     /* 1272536 */   GIM_Try, /*On fail goto*//*Label 18341*/ GIMT_Encode4(1272620), // Rule ID 8449 //
     /* 1272541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1272558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272619 */     // GIR_Coverage, 8449,
     /* 1272619 */     GIR_EraseRootFromParent_Done,
     /* 1272620 */   // Label 18341: @1272620
     /* 1272620 */   GIM_Try, /*On fail goto*//*Label 18342*/ GIMT_Encode4(1272704), // Rule ID 8452 //
     /* 1272625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1272628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1272642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272678 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272703 */     // GIR_Coverage, 8452,
     /* 1272703 */     GIR_EraseRootFromParent_Done,
     /* 1272704 */   // Label 18342: @1272704
     /* 1272704 */   GIM_Try, /*On fail goto*//*Label 18343*/ GIMT_Encode4(1272788), // Rule ID 8453 //
     /* 1272709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1272712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1272726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272762 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1272765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1272783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272787 */     // GIR_Coverage, 8453,
     /* 1272787 */     GIR_EraseRootFromParent_Done,
     /* 1272788 */   // Label 18343: @1272788
     /* 1272788 */   GIM_Try, /*On fail goto*//*Label 18344*/ GIMT_Encode4(1272872), // Rule ID 8456 //
     /* 1272793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1272804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1272807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1272810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1272816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1272831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272846 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1272849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272871 */     // GIR_Coverage, 8456,
     /* 1272871 */     GIR_EraseRootFromParent_Done,
     /* 1272872 */   // Label 18344: @1272872
     /* 1272872 */   GIM_Try, /*On fail goto*//*Label 18345*/ GIMT_Encode4(1272956), // Rule ID 8457 //
     /* 1272877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1272888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1272891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1272894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1272900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1272915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272930 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1272933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272955 */     // GIR_Coverage, 8457,
     /* 1272955 */     GIR_EraseRootFromParent_Done,
     /* 1272956 */   // Label 18345: @1272956
     /* 1272956 */   GIM_Try, /*On fail goto*//*Label 18346*/ GIMT_Encode4(1273040), // Rule ID 8460 //
     /* 1272961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1272969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1272972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1272975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1272978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1272984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1272999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273014 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273039 */     // GIR_Coverage, 8460,
     /* 1273039 */     GIR_EraseRootFromParent_Done,
     /* 1273040 */   // Label 18346: @1273040
     /* 1273040 */   GIM_Try, /*On fail goto*//*Label 18347*/ GIMT_Encode4(1273124), // Rule ID 8461 //
     /* 1273045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273098 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273123 */     // GIR_Coverage, 8461,
     /* 1273123 */     GIR_EraseRootFromParent_Done,
     /* 1273124 */   // Label 18347: @1273124
     /* 1273124 */   GIM_Try, /*On fail goto*//*Label 18348*/ GIMT_Encode4(1273208), // Rule ID 8464 //
     /* 1273129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273182 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273207 */     // GIR_Coverage, 8464,
     /* 1273207 */     GIR_EraseRootFromParent_Done,
     /* 1273208 */   // Label 18348: @1273208
     /* 1273208 */   GIM_Try, /*On fail goto*//*Label 18349*/ GIMT_Encode4(1273292), // Rule ID 8465 //
     /* 1273213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273266 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273291 */     // GIR_Coverage, 8465,
     /* 1273291 */     GIR_EraseRootFromParent_Done,
     /* 1273292 */   // Label 18349: @1273292
     /* 1273292 */   GIM_Try, /*On fail goto*//*Label 18350*/ GIMT_Encode4(1273376), // Rule ID 8468 //
     /* 1273297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273350 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273375 */     // GIR_Coverage, 8468,
     /* 1273375 */     GIR_EraseRootFromParent_Done,
     /* 1273376 */   // Label 18350: @1273376
     /* 1273376 */   GIM_Try, /*On fail goto*//*Label 18351*/ GIMT_Encode4(1273460), // Rule ID 8469 //
     /* 1273381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1273398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273434 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273459 */     // GIR_Coverage, 8469,
     /* 1273459 */     GIR_EraseRootFromParent_Done,
     /* 1273460 */   // Label 18351: @1273460
     /* 1273460 */   GIM_Try, /*On fail goto*//*Label 18352*/ GIMT_Encode4(1273544), // Rule ID 8472 //
     /* 1273465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1273482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273518 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273543 */     // GIR_Coverage, 8472,
     /* 1273543 */     GIR_EraseRootFromParent_Done,
     /* 1273544 */   // Label 18352: @1273544
     /* 1273544 */   GIM_Try, /*On fail goto*//*Label 18353*/ GIMT_Encode4(1273628), // Rule ID 8473 //
     /* 1273549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1273566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273602 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1273605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273627 */     // GIR_Coverage, 8473,
     /* 1273627 */     GIR_EraseRootFromParent_Done,
     /* 1273628 */   // Label 18353: @1273628
     /* 1273628 */   GIM_Try, /*On fail goto*//*Label 18354*/ GIMT_Encode4(1273712), // Rule ID 8476 //
     /* 1273633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1273650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273686 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273711 */     // GIR_Coverage, 8476,
     /* 1273711 */     GIR_EraseRootFromParent_Done,
     /* 1273712 */   // Label 18354: @1273712
     /* 1273712 */   GIM_Try, /*On fail goto*//*Label 18355*/ GIMT_Encode4(1273796), // Rule ID 8477 //
     /* 1273717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1273734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273770 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1273773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273795 */     // GIR_Coverage, 8477,
     /* 1273795 */     GIR_EraseRootFromParent_Done,
     /* 1273796 */   // Label 18355: @1273796
     /* 1273796 */   GIM_Try, /*On fail goto*//*Label 18356*/ GIMT_Encode4(1273880), // Rule ID 8480 //
     /* 1273801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1273818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273854 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273879 */     // GIR_Coverage, 8480,
     /* 1273879 */     GIR_EraseRootFromParent_Done,
     /* 1273880 */   // Label 18356: @1273880
     /* 1273880 */   GIM_Try, /*On fail goto*//*Label 18357*/ GIMT_Encode4(1273964), // Rule ID 8481 //
     /* 1273885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1273902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273938 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1273941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273963 */     // GIR_Coverage, 8481,
     /* 1273963 */     GIR_EraseRootFromParent_Done,
     /* 1273964 */   // Label 18357: @1273964
     /* 1273964 */   GIM_Try, /*On fail goto*//*Label 18358*/ GIMT_Encode4(1274048), // Rule ID 8484 //
     /* 1273969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1273977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1273986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274022 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274047 */     // GIR_Coverage, 8484,
     /* 1274047 */     GIR_EraseRootFromParent_Done,
     /* 1274048 */   // Label 18358: @1274048
     /* 1274048 */   GIM_Try, /*On fail goto*//*Label 18359*/ GIMT_Encode4(1274132), // Rule ID 8485 //
     /* 1274053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274106 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274131 */     // GIR_Coverage, 8485,
     /* 1274131 */     GIR_EraseRootFromParent_Done,
     /* 1274132 */   // Label 18359: @1274132
     /* 1274132 */   GIM_Try, /*On fail goto*//*Label 18360*/ GIMT_Encode4(1274216), // Rule ID 8488 //
     /* 1274137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274190 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274215 */     // GIR_Coverage, 8488,
     /* 1274215 */     GIR_EraseRootFromParent_Done,
     /* 1274216 */   // Label 18360: @1274216
     /* 1274216 */   GIM_Try, /*On fail goto*//*Label 18361*/ GIMT_Encode4(1274300), // Rule ID 8489 //
     /* 1274221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274299 */     // GIR_Coverage, 8489,
     /* 1274299 */     GIR_EraseRootFromParent_Done,
     /* 1274300 */   // Label 18361: @1274300
     /* 1274300 */   GIM_Try, /*On fail goto*//*Label 18362*/ GIMT_Encode4(1274384), // Rule ID 8492 //
     /* 1274305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274358 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274383 */     // GIR_Coverage, 8492,
     /* 1274383 */     GIR_EraseRootFromParent_Done,
     /* 1274384 */   // Label 18362: @1274384
     /* 1274384 */   GIM_Try, /*On fail goto*//*Label 18363*/ GIMT_Encode4(1274468), // Rule ID 8493 //
     /* 1274389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1274406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1274412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274442 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1274445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274467 */     // GIR_Coverage, 8493,
     /* 1274467 */     GIR_EraseRootFromParent_Done,
     /* 1274468 */   // Label 18363: @1274468
     /* 1274468 */   GIM_Try, /*On fail goto*//*Label 18364*/ GIMT_Encode4(1274552), // Rule ID 8496 //
     /* 1274473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1274490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274526 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274551 */     // GIR_Coverage, 8496,
     /* 1274551 */     GIR_EraseRootFromParent_Done,
     /* 1274552 */   // Label 18364: @1274552
     /* 1274552 */   GIM_Try, /*On fail goto*//*Label 18365*/ GIMT_Encode4(1274636), // Rule ID 8497 //
     /* 1274557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1274574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1274613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274635 */     // GIR_Coverage, 8497,
     /* 1274635 */     GIR_EraseRootFromParent_Done,
     /* 1274636 */   // Label 18365: @1274636
     /* 1274636 */   GIM_Try, /*On fail goto*//*Label 18366*/ GIMT_Encode4(1274720), // Rule ID 8500 //
     /* 1274641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1274644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1274658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274694 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274719 */     // GIR_Coverage, 8500,
     /* 1274719 */     GIR_EraseRootFromParent_Done,
     /* 1274720 */   // Label 18366: @1274720
     /* 1274720 */   GIM_Try, /*On fail goto*//*Label 18367*/ GIMT_Encode4(1274804), // Rule ID 8501 //
     /* 1274725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1274728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1274733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1274742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274778 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1274781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1274799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274803 */     // GIR_Coverage, 8501,
     /* 1274803 */     GIR_EraseRootFromParent_Done,
     /* 1274804 */   // Label 18367: @1274804
     /* 1274804 */   GIM_Try, /*On fail goto*//*Label 18368*/ GIMT_Encode4(1274888), // Rule ID 8504 //
     /* 1274809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1274820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1274823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1274826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1274829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1274832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274862 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1274865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274887 */     // GIR_Coverage, 8504,
     /* 1274887 */     GIR_EraseRootFromParent_Done,
     /* 1274888 */   // Label 18368: @1274888
     /* 1274888 */   GIM_Try, /*On fail goto*//*Label 18369*/ GIMT_Encode4(1274972), // Rule ID 8505 //
     /* 1274893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1274904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1274907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1274910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1274913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1274916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274946 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1274949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274971 */     // GIR_Coverage, 8505,
     /* 1274971 */     GIR_EraseRootFromParent_Done,
     /* 1274972 */   // Label 18369: @1274972
     /* 1274972 */   GIM_Try, /*On fail goto*//*Label 18370*/ GIMT_Encode4(1275056), // Rule ID 8508 //
     /* 1274977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1274988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1274991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1274994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1274997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275030 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275055 */     // GIR_Coverage, 8508,
     /* 1275055 */     GIR_EraseRootFromParent_Done,
     /* 1275056 */   // Label 18370: @1275056
     /* 1275056 */   GIM_Try, /*On fail goto*//*Label 18371*/ GIMT_Encode4(1275140), // Rule ID 8509 //
     /* 1275061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1275081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275114 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275139 */     // GIR_Coverage, 8509,
     /* 1275139 */     GIR_EraseRootFromParent_Done,
     /* 1275140 */   // Label 18371: @1275140
     /* 1275140 */   GIM_Try, /*On fail goto*//*Label 18372*/ GIMT_Encode4(1275224), // Rule ID 8512 //
     /* 1275145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1275165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275198 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275223 */     // GIR_Coverage, 8512,
     /* 1275223 */     GIR_EraseRootFromParent_Done,
     /* 1275224 */   // Label 18372: @1275224
     /* 1275224 */   GIM_Try, /*On fail goto*//*Label 18373*/ GIMT_Encode4(1275308), // Rule ID 8513 //
     /* 1275229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1275249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275307 */     // GIR_Coverage, 8513,
     /* 1275307 */     GIR_EraseRootFromParent_Done,
     /* 1275308 */   // Label 18373: @1275308
     /* 1275308 */   GIM_Try, /*On fail goto*//*Label 18374*/ GIMT_Encode4(1275392), // Rule ID 8516 //
     /* 1275313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1275333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275366 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275391 */     // GIR_Coverage, 8516,
     /* 1275391 */     GIR_EraseRootFromParent_Done,
     /* 1275392 */   // Label 18374: @1275392
     /* 1275392 */   GIM_Try, /*On fail goto*//*Label 18375*/ GIMT_Encode4(1275476), // Rule ID 8517 //
     /* 1275397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1275414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1275417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275450 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1275453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275475 */     // GIR_Coverage, 8517,
     /* 1275475 */     GIR_EraseRootFromParent_Done,
     /* 1275476 */   // Label 18375: @1275476
     /* 1275476 */   GIM_Try, /*On fail goto*//*Label 18376*/ GIMT_Encode4(1275560), // Rule ID 8520 //
     /* 1275481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1275498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1275501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275534 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275559 */     // GIR_Coverage, 8520,
     /* 1275559 */     GIR_EraseRootFromParent_Done,
     /* 1275560 */   // Label 18376: @1275560
     /* 1275560 */   GIM_Try, /*On fail goto*//*Label 18377*/ GIMT_Encode4(1275644), // Rule ID 8521 //
     /* 1275565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1275582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1275585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275618 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1275639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275643 */     // GIR_Coverage, 8521,
     /* 1275643 */     GIR_EraseRootFromParent_Done,
     /* 1275644 */   // Label 18377: @1275644
     /* 1275644 */   GIM_Try, /*On fail goto*//*Label 18378*/ GIMT_Encode4(1275728), // Rule ID 8524 //
     /* 1275649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1275666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1275669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275702 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275727 */     // GIR_Coverage, 8524,
     /* 1275727 */     GIR_EraseRootFromParent_Done,
     /* 1275728 */   // Label 18378: @1275728
     /* 1275728 */   GIM_Try, /*On fail goto*//*Label 18379*/ GIMT_Encode4(1275812), // Rule ID 8525 //
     /* 1275733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1275750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1275753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1275789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275811 */     // GIR_Coverage, 8525,
     /* 1275811 */     GIR_EraseRootFromParent_Done,
     /* 1275812 */   // Label 18379: @1275812
     /* 1275812 */   GIM_Try, /*On fail goto*//*Label 18380*/ GIMT_Encode4(1275896), // Rule ID 8528 //
     /* 1275817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1275834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275870 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1275873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275895 */     // GIR_Coverage, 8528,
     /* 1275895 */     GIR_EraseRootFromParent_Done,
     /* 1275896 */   // Label 18380: @1275896
     /* 1275896 */   GIM_Try, /*On fail goto*//*Label 18381*/ GIMT_Encode4(1275980), // Rule ID 8529 //
     /* 1275901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1275918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1275921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275954 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1275957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275979 */     // GIR_Coverage, 8529,
     /* 1275979 */     GIR_EraseRootFromParent_Done,
     /* 1275980 */   // Label 18381: @1275980
     /* 1275980 */   GIM_Try, /*On fail goto*//*Label 18382*/ GIMT_Encode4(1276064), // Rule ID 8532 //
     /* 1275985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276063 */     // GIR_Coverage, 8532,
     /* 1276063 */     GIR_EraseRootFromParent_Done,
     /* 1276064 */   // Label 18382: @1276064
     /* 1276064 */   GIM_Try, /*On fail goto*//*Label 18383*/ GIMT_Encode4(1276148), // Rule ID 8533 //
     /* 1276069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276122 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276147 */     // GIR_Coverage, 8533,
     /* 1276147 */     GIR_EraseRootFromParent_Done,
     /* 1276148 */   // Label 18383: @1276148
     /* 1276148 */   GIM_Try, /*On fail goto*//*Label 18384*/ GIMT_Encode4(1276232), // Rule ID 8536 //
     /* 1276153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276206 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276231 */     // GIR_Coverage, 8536,
     /* 1276231 */     GIR_EraseRootFromParent_Done,
     /* 1276232 */   // Label 18384: @1276232
     /* 1276232 */   GIM_Try, /*On fail goto*//*Label 18385*/ GIMT_Encode4(1276316), // Rule ID 8537 //
     /* 1276237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276315 */     // GIR_Coverage, 8537,
     /* 1276315 */     GIR_EraseRootFromParent_Done,
     /* 1276316 */   // Label 18385: @1276316
     /* 1276316 */   GIM_Try, /*On fail goto*//*Label 18386*/ GIMT_Encode4(1276400), // Rule ID 8540 //
     /* 1276321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1276324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276374 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276399 */     // GIR_Coverage, 8540,
     /* 1276399 */     GIR_EraseRootFromParent_Done,
     /* 1276400 */   // Label 18386: @1276400
     /* 1276400 */   GIM_Try, /*On fail goto*//*Label 18387*/ GIMT_Encode4(1276484), // Rule ID 8541 //
     /* 1276405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1276408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1276422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1276425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276458 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1276461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1276479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276483 */     // GIR_Coverage, 8541,
     /* 1276483 */     GIR_EraseRootFromParent_Done,
     /* 1276484 */   // Label 18387: @1276484
     /* 1276484 */   GIM_Try, /*On fail goto*//*Label 18388*/ GIMT_Encode4(1276568), // Rule ID 8544 //
     /* 1276489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1276500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1276503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1276506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1276509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1276512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276542 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1276545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276567 */     // GIR_Coverage, 8544,
     /* 1276567 */     GIR_EraseRootFromParent_Done,
     /* 1276568 */   // Label 18388: @1276568
     /* 1276568 */   GIM_Try, /*On fail goto*//*Label 18389*/ GIMT_Encode4(1276652), // Rule ID 8545 //
     /* 1276573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1276584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1276587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1276590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1276593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1276596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1276615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276626 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1276629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276651 */     // GIR_Coverage, 8545,
     /* 1276651 */     GIR_EraseRootFromParent_Done,
     /* 1276652 */   // Label 18389: @1276652
     /* 1276652 */   GIM_Try, /*On fail goto*//*Label 18390*/ GIMT_Encode4(1276736), // Rule ID 8548 //
     /* 1276657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1276668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1276671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1276674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1276677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1276680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276710 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1276713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276735 */     // GIR_Coverage, 8548,
     /* 1276735 */     GIR_EraseRootFromParent_Done,
     /* 1276736 */   // Label 18390: @1276736
     /* 1276736 */   GIM_Try, /*On fail goto*//*Label 18391*/ GIMT_Encode4(1276820), // Rule ID 8549 //
     /* 1276741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1276752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1276755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1276758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1276761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1276764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1276783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276794 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1276797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276819 */     // GIR_Coverage, 8549,
     /* 1276819 */     GIR_EraseRootFromParent_Done,
     /* 1276820 */   // Label 18391: @1276820
     /* 1276820 */   GIM_Try, /*On fail goto*//*Label 18392*/ GIMT_Encode4(1276904), // Rule ID 8552 //
     /* 1276825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1276836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1276839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1276842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1276845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1276848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276878 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1276881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276903 */     // GIR_Coverage, 8552,
     /* 1276903 */     GIR_EraseRootFromParent_Done,
     /* 1276904 */   // Label 18392: @1276904
     /* 1276904 */   GIM_Try, /*On fail goto*//*Label 18393*/ GIMT_Encode4(1276988), // Rule ID 8553 //
     /* 1276909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1276917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1276920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1276923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1276926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1276929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1276932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1276951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276962 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1276965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276987 */     // GIR_Coverage, 8553,
     /* 1276987 */     GIR_EraseRootFromParent_Done,
     /* 1276988 */   // Label 18393: @1276988
     /* 1276988 */   GIM_Try, /*On fail goto*//*Label 18394*/ GIMT_Encode4(1277072), // Rule ID 8556 //
     /* 1276993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277046 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277071 */     // GIR_Coverage, 8556,
     /* 1277071 */     GIR_EraseRootFromParent_Done,
     /* 1277072 */   // Label 18394: @1277072
     /* 1277072 */   GIM_Try, /*On fail goto*//*Label 18395*/ GIMT_Encode4(1277156), // Rule ID 8557 //
     /* 1277077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277130 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277155 */     // GIR_Coverage, 8557,
     /* 1277155 */     GIR_EraseRootFromParent_Done,
     /* 1277156 */   // Label 18395: @1277156
     /* 1277156 */   GIM_Try, /*On fail goto*//*Label 18396*/ GIMT_Encode4(1277240), // Rule ID 8560 //
     /* 1277161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1277181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277214 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277239 */     // GIR_Coverage, 8560,
     /* 1277239 */     GIR_EraseRootFromParent_Done,
     /* 1277240 */   // Label 18396: @1277240
     /* 1277240 */   GIM_Try, /*On fail goto*//*Label 18397*/ GIMT_Encode4(1277324), // Rule ID 8561 //
     /* 1277245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1277265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277298 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277323 */     // GIR_Coverage, 8561,
     /* 1277323 */     GIR_EraseRootFromParent_Done,
     /* 1277324 */   // Label 18397: @1277324
     /* 1277324 */   GIM_Try, /*On fail goto*//*Label 18398*/ GIMT_Encode4(1277408), // Rule ID 8564 //
     /* 1277329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1277349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277382 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277407 */     // GIR_Coverage, 8564,
     /* 1277407 */     GIR_EraseRootFromParent_Done,
     /* 1277408 */   // Label 18398: @1277408
     /* 1277408 */   GIM_Try, /*On fail goto*//*Label 18399*/ GIMT_Encode4(1277492), // Rule ID 8565 //
     /* 1277413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1277430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1277433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277466 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277491 */     // GIR_Coverage, 8565,
     /* 1277491 */     GIR_EraseRootFromParent_Done,
     /* 1277492 */   // Label 18399: @1277492
     /* 1277492 */   GIM_Try, /*On fail goto*//*Label 18400*/ GIMT_Encode4(1277576), // Rule ID 8568 //
     /* 1277497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1277514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1277517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277550 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277575 */     // GIR_Coverage, 8568,
     /* 1277575 */     GIR_EraseRootFromParent_Done,
     /* 1277576 */   // Label 18400: @1277576
     /* 1277576 */   GIM_Try, /*On fail goto*//*Label 18401*/ GIMT_Encode4(1277660), // Rule ID 8569 //
     /* 1277581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1277592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1277595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1277598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1277601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1277604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277634 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1277637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277659 */     // GIR_Coverage, 8569,
     /* 1277659 */     GIR_EraseRootFromParent_Done,
     /* 1277660 */   // Label 18401: @1277660
     /* 1277660 */   GIM_Try, /*On fail goto*//*Label 18402*/ GIMT_Encode4(1277744), // Rule ID 8572 //
     /* 1277665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1277682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1277685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277743 */     // GIR_Coverage, 8572,
     /* 1277743 */     GIR_EraseRootFromParent_Done,
     /* 1277744 */   // Label 18402: @1277744
     /* 1277744 */   GIM_Try, /*On fail goto*//*Label 18403*/ GIMT_Encode4(1277828), // Rule ID 8573 //
     /* 1277749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1277766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1277769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277802 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1277805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277827 */     // GIR_Coverage, 8573,
     /* 1277827 */     GIR_EraseRootFromParent_Done,
     /* 1277828 */   // Label 18403: @1277828
     /* 1277828 */   GIM_Try, /*On fail goto*//*Label 18404*/ GIMT_Encode4(1277912), // Rule ID 8576 //
     /* 1277833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1277850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1277853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277886 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277911 */     // GIR_Coverage, 8576,
     /* 1277911 */     GIR_EraseRootFromParent_Done,
     /* 1277912 */   // Label 18404: @1277912
     /* 1277912 */   GIM_Try, /*On fail goto*//*Label 18405*/ GIMT_Encode4(1277996), // Rule ID 8577 //
     /* 1277917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1277925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1277934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1277937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277970 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1277973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277995 */     // GIR_Coverage, 8577,
     /* 1277995 */     GIR_EraseRootFromParent_Done,
     /* 1277996 */   // Label 18405: @1277996
     /* 1277996 */   GIM_Try, /*On fail goto*//*Label 18406*/ GIMT_Encode4(1278080), // Rule ID 8580 //
     /* 1278001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278054 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278079 */     // GIR_Coverage, 8580,
     /* 1278079 */     GIR_EraseRootFromParent_Done,
     /* 1278080 */   // Label 18406: @1278080
     /* 1278080 */   GIM_Try, /*On fail goto*//*Label 18407*/ GIMT_Encode4(1278164), // Rule ID 8581 //
     /* 1278085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278138 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1278141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278163 */     // GIR_Coverage, 8581,
     /* 1278163 */     GIR_EraseRootFromParent_Done,
     /* 1278164 */   // Label 18407: @1278164
     /* 1278164 */   GIM_Try, /*On fail goto*//*Label 18408*/ GIMT_Encode4(1278248), // Rule ID 8584 //
     /* 1278169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1278189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278222 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278247 */     // GIR_Coverage, 8584,
     /* 1278247 */     GIR_EraseRootFromParent_Done,
     /* 1278248 */   // Label 18408: @1278248
     /* 1278248 */   GIM_Try, /*On fail goto*//*Label 18409*/ GIMT_Encode4(1278332), // Rule ID 8585 //
     /* 1278253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1278273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278306 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1278309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278331 */     // GIR_Coverage, 8585,
     /* 1278331 */     GIR_EraseRootFromParent_Done,
     /* 1278332 */   // Label 18409: @1278332
     /* 1278332 */   GIM_Try, /*On fail goto*//*Label 18410*/ GIMT_Encode4(1278416), // Rule ID 8588 //
     /* 1278337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1278357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278390 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278415 */     // GIR_Coverage, 8588,
     /* 1278415 */     GIR_EraseRootFromParent_Done,
     /* 1278416 */   // Label 18410: @1278416
     /* 1278416 */   GIM_Try, /*On fail goto*//*Label 18411*/ GIMT_Encode4(1278500), // Rule ID 8589 //
     /* 1278421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1278438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1278441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278474 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1278477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278499 */     // GIR_Coverage, 8589,
     /* 1278499 */     GIR_EraseRootFromParent_Done,
     /* 1278500 */   // Label 18411: @1278500
     /* 1278500 */   GIM_Try, /*On fail goto*//*Label 18412*/ GIMT_Encode4(1278584), // Rule ID 8592 //
     /* 1278505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1278516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1278519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1278522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1278528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1278561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278583 */     // GIR_Coverage, 8592,
     /* 1278583 */     GIR_EraseRootFromParent_Done,
     /* 1278584 */   // Label 18412: @1278584
     /* 1278584 */   GIM_Try, /*On fail goto*//*Label 18413*/ GIMT_Encode4(1278668), // Rule ID 8593 //
     /* 1278589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1278600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1278603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1278606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1278612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278642 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1278645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278667 */     // GIR_Coverage, 8593,
     /* 1278667 */     GIR_EraseRootFromParent_Done,
     /* 1278668 */   // Label 18413: @1278668
     /* 1278668 */   GIM_Try, /*On fail goto*//*Label 18414*/ GIMT_Encode4(1278752), // Rule ID 8596 //
     /* 1278673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1278690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278726 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1278729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278751 */     // GIR_Coverage, 8596,
     /* 1278751 */     GIR_EraseRootFromParent_Done,
     /* 1278752 */   // Label 18414: @1278752
     /* 1278752 */   GIM_Try, /*On fail goto*//*Label 18415*/ GIMT_Encode4(1278836), // Rule ID 8597 //
     /* 1278757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1278774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278810 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1278813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278835 */     // GIR_Coverage, 8597,
     /* 1278835 */     GIR_EraseRootFromParent_Done,
     /* 1278836 */   // Label 18415: @1278836
     /* 1278836 */   GIM_Try, /*On fail goto*//*Label 18416*/ GIMT_Encode4(1278920), // Rule ID 8600 //
     /* 1278841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1278858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1278861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278894 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1278897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278919 */     // GIR_Coverage, 8600,
     /* 1278919 */     GIR_EraseRootFromParent_Done,
     /* 1278920 */   // Label 18416: @1278920
     /* 1278920 */   GIM_Try, /*On fail goto*//*Label 18417*/ GIMT_Encode4(1279004), // Rule ID 8601 //
     /* 1278925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1278933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1278942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1278945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1278967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278978 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1278981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1278999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279003 */     // GIR_Coverage, 8601,
     /* 1279003 */     GIR_EraseRootFromParent_Done,
     /* 1279004 */   // Label 18417: @1279004
     /* 1279004 */   GIM_Try, /*On fail goto*//*Label 18418*/ GIMT_Encode4(1279088), // Rule ID 8604 //
     /* 1279009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279062 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279087 */     // GIR_Coverage, 8604,
     /* 1279087 */     GIR_EraseRootFromParent_Done,
     /* 1279088 */   // Label 18418: @1279088
     /* 1279088 */   GIM_Try, /*On fail goto*//*Label 18419*/ GIMT_Encode4(1279172), // Rule ID 8605 //
     /* 1279093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279146 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1279149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279171 */     // GIR_Coverage, 8605,
     /* 1279171 */     GIR_EraseRootFromParent_Done,
     /* 1279172 */   // Label 18419: @1279172
     /* 1279172 */   GIM_Try, /*On fail goto*//*Label 18420*/ GIMT_Encode4(1279256), // Rule ID 8608 //
     /* 1279177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279230 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279255 */     // GIR_Coverage, 8608,
     /* 1279255 */     GIR_EraseRootFromParent_Done,
     /* 1279256 */   // Label 18420: @1279256
     /* 1279256 */   GIM_Try, /*On fail goto*//*Label 18421*/ GIMT_Encode4(1279340), // Rule ID 8609 //
     /* 1279261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1279278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279314 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279339 */     // GIR_Coverage, 8609,
     /* 1279339 */     GIR_EraseRootFromParent_Done,
     /* 1279340 */   // Label 18421: @1279340
     /* 1279340 */   GIM_Try, /*On fail goto*//*Label 18422*/ GIMT_Encode4(1279424), // Rule ID 8612 //
     /* 1279345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279398 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279423 */     // GIR_Coverage, 8612,
     /* 1279423 */     GIR_EraseRootFromParent_Done,
     /* 1279424 */   // Label 18422: @1279424
     /* 1279424 */   GIM_Try, /*On fail goto*//*Label 18423*/ GIMT_Encode4(1279508), // Rule ID 8613 //
     /* 1279429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1279446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279482 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1279485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279507 */     // GIR_Coverage, 8613,
     /* 1279507 */     GIR_EraseRootFromParent_Done,
     /* 1279508 */   // Label 18423: @1279508
     /* 1279508 */   GIM_Try, /*On fail goto*//*Label 18424*/ GIMT_Encode4(1279592), // Rule ID 8616 //
     /* 1279513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1279530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279566 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279591 */     // GIR_Coverage, 8616,
     /* 1279591 */     GIR_EraseRootFromParent_Done,
     /* 1279592 */   // Label 18424: @1279592
     /* 1279592 */   GIM_Try, /*On fail goto*//*Label 18425*/ GIMT_Encode4(1279676), // Rule ID 8617 //
     /* 1279597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1279614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279675 */     // GIR_Coverage, 8617,
     /* 1279675 */     GIR_EraseRootFromParent_Done,
     /* 1279676 */   // Label 18425: @1279676
     /* 1279676 */   GIM_Try, /*On fail goto*//*Label 18426*/ GIMT_Encode4(1279760), // Rule ID 8620 //
     /* 1279681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1279698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279734 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279759 */     // GIR_Coverage, 8620,
     /* 1279759 */     GIR_EraseRootFromParent_Done,
     /* 1279760 */   // Label 18426: @1279760
     /* 1279760 */   GIM_Try, /*On fail goto*//*Label 18427*/ GIMT_Encode4(1279844), // Rule ID 8621 //
     /* 1279765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1279782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279818 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279843 */     // GIR_Coverage, 8621,
     /* 1279843 */     GIR_EraseRootFromParent_Done,
     /* 1279844 */   // Label 18427: @1279844
     /* 1279844 */   GIM_Try, /*On fail goto*//*Label 18428*/ GIMT_Encode4(1279928), // Rule ID 8624 //
     /* 1279849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1279866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279902 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1279923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279927 */     // GIR_Coverage, 8624,
     /* 1279927 */     GIR_EraseRootFromParent_Done,
     /* 1279928 */   // Label 18428: @1279928
     /* 1279928 */   GIM_Try, /*On fail goto*//*Label 18429*/ GIMT_Encode4(1280012), // Rule ID 8625 //
     /* 1279933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1279941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1279950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1279989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280011 */     // GIR_Coverage, 8625,
     /* 1280011 */     GIR_EraseRootFromParent_Done,
     /* 1280012 */   // Label 18429: @1280012
     /* 1280012 */   GIM_Try, /*On fail goto*//*Label 18430*/ GIMT_Encode4(1280096), // Rule ID 8628 //
     /* 1280017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1280020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280070 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280095 */     // GIR_Coverage, 8628,
     /* 1280095 */     GIR_EraseRootFromParent_Done,
     /* 1280096 */   // Label 18430: @1280096
     /* 1280096 */   GIM_Try, /*On fail goto*//*Label 18431*/ GIMT_Encode4(1280180), // Rule ID 8629 //
     /* 1280101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1280104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280154 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1280157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280179 */     // GIR_Coverage, 8629,
     /* 1280179 */     GIR_EraseRootFromParent_Done,
     /* 1280180 */   // Label 18431: @1280180
     /* 1280180 */   GIM_Try, /*On fail goto*//*Label 18432*/ GIMT_Encode4(1280264), // Rule ID 8632 //
     /* 1280185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280238 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280263 */     // GIR_Coverage, 8632,
     /* 1280263 */     GIR_EraseRootFromParent_Done,
     /* 1280264 */   // Label 18432: @1280264
     /* 1280264 */   GIM_Try, /*On fail goto*//*Label 18433*/ GIMT_Encode4(1280348), // Rule ID 8633 //
     /* 1280269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1280286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280322 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280347 */     // GIR_Coverage, 8633,
     /* 1280347 */     GIR_EraseRootFromParent_Done,
     /* 1280348 */   // Label 18433: @1280348
     /* 1280348 */   GIM_Try, /*On fail goto*//*Label 18434*/ GIMT_Encode4(1280432), // Rule ID 8636 //
     /* 1280353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280406 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280431 */     // GIR_Coverage, 8636,
     /* 1280431 */     GIR_EraseRootFromParent_Done,
     /* 1280432 */   // Label 18434: @1280432
     /* 1280432 */   GIM_Try, /*On fail goto*//*Label 18435*/ GIMT_Encode4(1280516), // Rule ID 8637 //
     /* 1280437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1280448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1280451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1280454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1280460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280490 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280515 */     // GIR_Coverage, 8637,
     /* 1280515 */     GIR_EraseRootFromParent_Done,
     /* 1280516 */   // Label 18435: @1280516
     /* 1280516 */   GIM_Try, /*On fail goto*//*Label 18436*/ GIMT_Encode4(1280600), // Rule ID 8640 //
     /* 1280521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1280532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1280535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1280538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1280544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1280559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280574 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1280577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280599 */     // GIR_Coverage, 8640,
     /* 1280599 */     GIR_EraseRootFromParent_Done,
     /* 1280600 */   // Label 18436: @1280600
     /* 1280600 */   GIM_Try, /*On fail goto*//*Label 18437*/ GIMT_Encode4(1280684), // Rule ID 8641 //
     /* 1280605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1280616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1280619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1280622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1280628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1280643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280658 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1280661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280683 */     // GIR_Coverage, 8641,
     /* 1280683 */     GIR_EraseRootFromParent_Done,
     /* 1280684 */   // Label 18437: @1280684
     /* 1280684 */   GIM_Try, /*On fail goto*//*Label 18438*/ GIMT_Encode4(1280768), // Rule ID 8644 //
     /* 1280689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1280706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280742 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280767 */     // GIR_Coverage, 8644,
     /* 1280767 */     GIR_EraseRootFromParent_Done,
     /* 1280768 */   // Label 18438: @1280768
     /* 1280768 */   GIM_Try, /*On fail goto*//*Label 18439*/ GIMT_Encode4(1280852), // Rule ID 8645 //
     /* 1280773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1280790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1280811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280826 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1280829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280851 */     // GIR_Coverage, 8645,
     /* 1280851 */     GIR_EraseRootFromParent_Done,
     /* 1280852 */   // Label 18439: @1280852
     /* 1280852 */   GIM_Try, /*On fail goto*//*Label 18440*/ GIMT_Encode4(1280936), // Rule ID 8648 //
     /* 1280857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1280874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280910 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280935 */     // GIR_Coverage, 8648,
     /* 1280935 */     GIR_EraseRootFromParent_Done,
     /* 1280936 */   // Label 18440: @1280936
     /* 1280936 */   GIM_Try, /*On fail goto*//*Label 18441*/ GIMT_Encode4(1281020), // Rule ID 8649 //
     /* 1280941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1280949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1280952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1280955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1280958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1280964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1280979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1280997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281019 */     // GIR_Coverage, 8649,
     /* 1281019 */     GIR_EraseRootFromParent_Done,
     /* 1281020 */   // Label 18441: @1281020
     /* 1281020 */   GIM_Try, /*On fail goto*//*Label 18442*/ GIMT_Encode4(1281104), // Rule ID 8652 //
     /* 1281025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281078 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281103 */     // GIR_Coverage, 8652,
     /* 1281103 */     GIR_EraseRootFromParent_Done,
     /* 1281104 */   // Label 18442: @1281104
     /* 1281104 */   GIM_Try, /*On fail goto*//*Label 18443*/ GIMT_Encode4(1281188), // Rule ID 8653 //
     /* 1281109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281162 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281187 */     // GIR_Coverage, 8653,
     /* 1281187 */     GIR_EraseRootFromParent_Done,
     /* 1281188 */   // Label 18443: @1281188
     /* 1281188 */   GIM_Try, /*On fail goto*//*Label 18444*/ GIMT_Encode4(1281272), // Rule ID 8656 //
     /* 1281193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281246 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281271 */     // GIR_Coverage, 8656,
     /* 1281271 */     GIR_EraseRootFromParent_Done,
     /* 1281272 */   // Label 18444: @1281272
     /* 1281272 */   GIM_Try, /*On fail goto*//*Label 18445*/ GIMT_Encode4(1281356), // Rule ID 8657 //
     /* 1281277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1281294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281330 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281355 */     // GIR_Coverage, 8657,
     /* 1281355 */     GIR_EraseRootFromParent_Done,
     /* 1281356 */   // Label 18445: @1281356
     /* 1281356 */   GIM_Try, /*On fail goto*//*Label 18446*/ GIMT_Encode4(1281440), // Rule ID 8660 //
     /* 1281361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281414 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281439 */     // GIR_Coverage, 8660,
     /* 1281439 */     GIR_EraseRootFromParent_Done,
     /* 1281440 */   // Label 18446: @1281440
     /* 1281440 */   GIM_Try, /*On fail goto*//*Label 18447*/ GIMT_Encode4(1281524), // Rule ID 8661 //
     /* 1281445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1281462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281523 */     // GIR_Coverage, 8661,
     /* 1281523 */     GIR_EraseRootFromParent_Done,
     /* 1281524 */   // Label 18447: @1281524
     /* 1281524 */   GIM_Try, /*On fail goto*//*Label 18448*/ GIMT_Encode4(1281608), // Rule ID 8664 //
     /* 1281529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1281546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281582 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281607 */     // GIR_Coverage, 8664,
     /* 1281607 */     GIR_EraseRootFromParent_Done,
     /* 1281608 */   // Label 18448: @1281608
     /* 1281608 */   GIM_Try, /*On fail goto*//*Label 18449*/ GIMT_Encode4(1281692), // Rule ID 8665 //
     /* 1281613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1281630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281666 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1281669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1281687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281691 */     // GIR_Coverage, 8665,
     /* 1281691 */     GIR_EraseRootFromParent_Done,
     /* 1281692 */   // Label 18449: @1281692
     /* 1281692 */   GIM_Try, /*On fail goto*//*Label 18450*/ GIMT_Encode4(1281776), // Rule ID 8668 //
     /* 1281697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1281700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1281708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1281711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1281714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1281720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1281771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281775 */     // GIR_Coverage, 8668,
     /* 1281775 */     GIR_EraseRootFromParent_Done,
     /* 1281776 */   // Label 18450: @1281776
     /* 1281776 */   GIM_Try, /*On fail goto*//*Label 18451*/ GIMT_Encode4(1281860), // Rule ID 8669 //
     /* 1281781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1281784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1281792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1281795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1281798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1281804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281834 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1281837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1281855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281859 */     // GIR_Coverage, 8669,
     /* 1281859 */     GIR_EraseRootFromParent_Done,
     /* 1281860 */   // Label 18451: @1281860
     /* 1281860 */   GIM_Try, /*On fail goto*//*Label 18452*/ GIMT_Encode4(1281944), // Rule ID 8672 //
     /* 1281865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1281868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1281882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281918 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1281921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1281939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281943 */     // GIR_Coverage, 8672,
     /* 1281943 */     GIR_EraseRootFromParent_Done,
     /* 1281944 */   // Label 18452: @1281944
     /* 1281944 */   GIM_Try, /*On fail goto*//*Label 18453*/ GIMT_Encode4(1282028), // Rule ID 8673 //
     /* 1281949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1281952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1281957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1281960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1281963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1281966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1281972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282002 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1282005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282027 */     // GIR_Coverage, 8673,
     /* 1282027 */     GIR_EraseRootFromParent_Done,
     /* 1282028 */   // Label 18453: @1282028
     /* 1282028 */   GIM_Try, /*On fail goto*//*Label 18454*/ GIMT_Encode4(1282112), // Rule ID 8676 //
     /* 1282033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282086 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282111 */     // GIR_Coverage, 8676,
     /* 1282111 */     GIR_EraseRootFromParent_Done,
     /* 1282112 */   // Label 18454: @1282112
     /* 1282112 */   GIM_Try, /*On fail goto*//*Label 18455*/ GIMT_Encode4(1282196), // Rule ID 8677 //
     /* 1282117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1282125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282170 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1282173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282195 */     // GIR_Coverage, 8677,
     /* 1282195 */     GIR_EraseRootFromParent_Done,
     /* 1282196 */   // Label 18455: @1282196
     /* 1282196 */   GIM_Try, /*On fail goto*//*Label 18456*/ GIMT_Encode4(1282280), // Rule ID 8680 //
     /* 1282201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1282221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282254 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1282257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282279 */     // GIR_Coverage, 8680,
     /* 1282279 */     GIR_EraseRootFromParent_Done,
     /* 1282280 */   // Label 18456: @1282280
     /* 1282280 */   GIM_Try, /*On fail goto*//*Label 18457*/ GIMT_Encode4(1282364), // Rule ID 8681 //
     /* 1282285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1282302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1282305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282338 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1282341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282363 */     // GIR_Coverage, 8681,
     /* 1282363 */     GIR_EraseRootFromParent_Done,
     /* 1282364 */   // Label 18457: @1282364
     /* 1282364 */   GIM_Try, /*On fail goto*//*Label 18458*/ GIMT_Encode4(1282448), // Rule ID 8684 //
     /* 1282369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1282389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282447 */     // GIR_Coverage, 8684,
     /* 1282447 */     GIR_EraseRootFromParent_Done,
     /* 1282448 */   // Label 18458: @1282448
     /* 1282448 */   GIM_Try, /*On fail goto*//*Label 18459*/ GIMT_Encode4(1282532), // Rule ID 8685 //
     /* 1282453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1282470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1282473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282531 */     // GIR_Coverage, 8685,
     /* 1282531 */     GIR_EraseRootFromParent_Done,
     /* 1282532 */   // Label 18459: @1282532
     /* 1282532 */   GIM_Try, /*On fail goto*//*Label 18460*/ GIMT_Encode4(1282616), // Rule ID 8688 //
     /* 1282537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1282554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1282557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282590 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1282593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282615 */     // GIR_Coverage, 8688,
     /* 1282615 */     GIR_EraseRootFromParent_Done,
     /* 1282616 */   // Label 18460: @1282616
     /* 1282616 */   GIM_Try, /*On fail goto*//*Label 18461*/ GIMT_Encode4(1282700), // Rule ID 8689 //
     /* 1282621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1282638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1282641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282674 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1282677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1282695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282699 */     // GIR_Coverage, 8689,
     /* 1282699 */     GIR_EraseRootFromParent_Done,
     /* 1282700 */   // Label 18461: @1282700
     /* 1282700 */   GIM_Try, /*On fail goto*//*Label 18462*/ GIMT_Encode4(1282784), // Rule ID 8692 //
     /* 1282705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1282722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1282725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282758 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282783 */     // GIR_Coverage, 8692,
     /* 1282783 */     GIR_EraseRootFromParent_Done,
     /* 1282784 */   // Label 18462: @1282784
     /* 1282784 */   GIM_Try, /*On fail goto*//*Label 18463*/ GIMT_Encode4(1282868), // Rule ID 8693 //
     /* 1282789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1282800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1282803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1282806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1282809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1282812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282842 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1282845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282867 */     // GIR_Coverage, 8693,
     /* 1282867 */     GIR_EraseRootFromParent_Done,
     /* 1282868 */   // Label 18463: @1282868
     /* 1282868 */   GIM_Try, /*On fail goto*//*Label 18464*/ GIMT_Encode4(1282952), // Rule ID 8696 //
     /* 1282873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1282890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1282893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1282929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1282947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282951 */     // GIR_Coverage, 8696,
     /* 1282951 */     GIR_EraseRootFromParent_Done,
     /* 1282952 */   // Label 18464: @1282952
     /* 1282952 */   GIM_Try, /*On fail goto*//*Label 18465*/ GIMT_Encode4(1283036), // Rule ID 8697 //
     /* 1282957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1282974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1282977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283010 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283035 */     // GIR_Coverage, 8697,
     /* 1283035 */     GIR_EraseRootFromParent_Done,
     /* 1283036 */   // Label 18465: @1283036
     /* 1283036 */   GIM_Try, /*On fail goto*//*Label 18466*/ GIMT_Encode4(1283120), // Rule ID 8700 //
     /* 1283041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283094 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283119 */     // GIR_Coverage, 8700,
     /* 1283119 */     GIR_EraseRootFromParent_Done,
     /* 1283120 */   // Label 18466: @1283120
     /* 1283120 */   GIM_Try, /*On fail goto*//*Label 18467*/ GIMT_Encode4(1283204), // Rule ID 8701 //
     /* 1283125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283178 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1283181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283203 */     // GIR_Coverage, 8701,
     /* 1283203 */     GIR_EraseRootFromParent_Done,
     /* 1283204 */   // Label 18467: @1283204
     /* 1283204 */   GIM_Try, /*On fail goto*//*Label 18468*/ GIMT_Encode4(1283288), // Rule ID 8704 //
     /* 1283209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283287 */     // GIR_Coverage, 8704,
     /* 1283287 */     GIR_EraseRootFromParent_Done,
     /* 1283288 */   // Label 18468: @1283288
     /* 1283288 */   GIM_Try, /*On fail goto*//*Label 18469*/ GIMT_Encode4(1283372), // Rule ID 8705 //
     /* 1283293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1283304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1283307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1283310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1283313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1283316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283346 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283371 */     // GIR_Coverage, 8705,
     /* 1283371 */     GIR_EraseRootFromParent_Done,
     /* 1283372 */   // Label 18469: @1283372
     /* 1283372 */   GIM_Try, /*On fail goto*//*Label 18470*/ GIMT_Encode4(1283456), // Rule ID 8708 //
     /* 1283377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283430 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283455 */     // GIR_Coverage, 8708,
     /* 1283455 */     GIR_EraseRootFromParent_Done,
     /* 1283456 */   // Label 18470: @1283456
     /* 1283456 */   GIM_Try, /*On fail goto*//*Label 18471*/ GIMT_Encode4(1283540), // Rule ID 8709 //
     /* 1283461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1283478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1283481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283514 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283539 */     // GIR_Coverage, 8709,
     /* 1283539 */     GIR_EraseRootFromParent_Done,
     /* 1283540 */   // Label 18471: @1283540
     /* 1283540 */   GIM_Try, /*On fail goto*//*Label 18472*/ GIMT_Encode4(1283624), // Rule ID 8712 //
     /* 1283545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1283562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1283565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283598 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283623 */     // GIR_Coverage, 8712,
     /* 1283623 */     GIR_EraseRootFromParent_Done,
     /* 1283624 */   // Label 18472: @1283624
     /* 1283624 */   GIM_Try, /*On fail goto*//*Label 18473*/ GIMT_Encode4(1283708), // Rule ID 8713 //
     /* 1283629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1283646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1283649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283682 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283707 */     // GIR_Coverage, 8713,
     /* 1283707 */     GIR_EraseRootFromParent_Done,
     /* 1283708 */   // Label 18473: @1283708
     /* 1283708 */   GIM_Try, /*On fail goto*//*Label 18474*/ GIMT_Encode4(1283792), // Rule ID 8716 //
     /* 1283713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1283716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1283730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1283733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283766 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283791 */     // GIR_Coverage, 8716,
     /* 1283791 */     GIR_EraseRootFromParent_Done,
     /* 1283792 */   // Label 18474: @1283792
     /* 1283792 */   GIM_Try, /*On fail goto*//*Label 18475*/ GIMT_Encode4(1283876), // Rule ID 8717 //
     /* 1283797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1283800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1283814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1283817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1283853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1283871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283875 */     // GIR_Coverage, 8717,
     /* 1283875 */     GIR_EraseRootFromParent_Done,
     /* 1283876 */   // Label 18475: @1283876
     /* 1283876 */   GIM_Try, /*On fail goto*//*Label 18476*/ GIMT_Encode4(1283960), // Rule ID 8720 //
     /* 1283881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1283892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1283895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1283898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1283901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1283904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1283919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1283923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283934 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1283937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283959 */     // GIR_Coverage, 8720,
     /* 1283959 */     GIR_EraseRootFromParent_Done,
     /* 1283960 */   // Label 18476: @1283960
     /* 1283960 */   GIM_Try, /*On fail goto*//*Label 18477*/ GIMT_Encode4(1284044), // Rule ID 8721 //
     /* 1283965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1283973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1283976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1283979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1283982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1283985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1283988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284018 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284043 */     // GIR_Coverage, 8721,
     /* 1284043 */     GIR_EraseRootFromParent_Done,
     /* 1284044 */   // Label 18477: @1284044
     /* 1284044 */   GIM_Try, /*On fail goto*//*Label 18478*/ GIMT_Encode4(1284128), // Rule ID 8724 //
     /* 1284049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284102 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284127 */     // GIR_Coverage, 8724,
     /* 1284127 */     GIR_EraseRootFromParent_Done,
     /* 1284128 */   // Label 18478: @1284128
     /* 1284128 */   GIM_Try, /*On fail goto*//*Label 18479*/ GIMT_Encode4(1284212), // Rule ID 8725 //
     /* 1284133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284186 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284211 */     // GIR_Coverage, 8725,
     /* 1284211 */     GIR_EraseRootFromParent_Done,
     /* 1284212 */   // Label 18479: @1284212
     /* 1284212 */   GIM_Try, /*On fail goto*//*Label 18480*/ GIMT_Encode4(1284296), // Rule ID 8728 //
     /* 1284217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1284237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284270 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284295 */     // GIR_Coverage, 8728,
     /* 1284295 */     GIR_EraseRootFromParent_Done,
     /* 1284296 */   // Label 18480: @1284296
     /* 1284296 */   GIM_Try, /*On fail goto*//*Label 18481*/ GIMT_Encode4(1284380), // Rule ID 8729 //
     /* 1284301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1284312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1284315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1284318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1284321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1284324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284354 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284379 */     // GIR_Coverage, 8729,
     /* 1284379 */     GIR_EraseRootFromParent_Done,
     /* 1284380 */   // Label 18481: @1284380
     /* 1284380 */   GIM_Try, /*On fail goto*//*Label 18482*/ GIMT_Encode4(1284464), // Rule ID 8732 //
     /* 1284385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1284405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284438 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284463 */     // GIR_Coverage, 8732,
     /* 1284463 */     GIR_EraseRootFromParent_Done,
     /* 1284464 */   // Label 18482: @1284464
     /* 1284464 */   GIM_Try, /*On fail goto*//*Label 18483*/ GIMT_Encode4(1284548), // Rule ID 8733 //
     /* 1284469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1284486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1284489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284522 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284547 */     // GIR_Coverage, 8733,
     /* 1284547 */     GIR_EraseRootFromParent_Done,
     /* 1284548 */   // Label 18483: @1284548
     /* 1284548 */   GIM_Try, /*On fail goto*//*Label 18484*/ GIMT_Encode4(1284632), // Rule ID 8736 //
     /* 1284553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1284570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1284573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284631 */     // GIR_Coverage, 8736,
     /* 1284631 */     GIR_EraseRootFromParent_Done,
     /* 1284632 */   // Label 18484: @1284632
     /* 1284632 */   GIM_Try, /*On fail goto*//*Label 18485*/ GIMT_Encode4(1284716), // Rule ID 8737 //
     /* 1284637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1284654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1284657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284690 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1284693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284715 */     // GIR_Coverage, 8737,
     /* 1284715 */     GIR_EraseRootFromParent_Done,
     /* 1284716 */   // Label 18485: @1284716
     /* 1284716 */   GIM_Try, /*On fail goto*//*Label 18486*/ GIMT_Encode4(1284800), // Rule ID 8740 //
     /* 1284721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1284738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1284741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284774 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284799 */     // GIR_Coverage, 8740,
     /* 1284799 */     GIR_EraseRootFromParent_Done,
     /* 1284800 */   // Label 18486: @1284800
     /* 1284800 */   GIM_Try, /*On fail goto*//*Label 18487*/ GIMT_Encode4(1284884), // Rule ID 8741 //
     /* 1284805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1284822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1284825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1284847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284858 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1284861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284883 */     // GIR_Coverage, 8741,
     /* 1284883 */     GIR_EraseRootFromParent_Done,
     /* 1284884 */   // Label 18487: @1284884
     /* 1284884 */   GIM_Try, /*On fail goto*//*Label 18488*/ GIMT_Encode4(1284968), // Rule ID 8744 //
     /* 1284889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1284906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1284909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284942 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1284945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284967 */     // GIR_Coverage, 8744,
     /* 1284967 */     GIR_EraseRootFromParent_Done,
     /* 1284968 */   // Label 18488: @1284968
     /* 1284968 */   GIM_Try, /*On fail goto*//*Label 18489*/ GIMT_Encode4(1285052), // Rule ID 8745 //
     /* 1284973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1284981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1284990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1284993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285026 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285051 */     // GIR_Coverage, 8745,
     /* 1285051 */     GIR_EraseRootFromParent_Done,
     /* 1285052 */   // Label 18489: @1285052
     /* 1285052 */   GIM_Try, /*On fail goto*//*Label 18490*/ GIMT_Encode4(1285136), // Rule ID 8748 //
     /* 1285057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285135 */     // GIR_Coverage, 8748,
     /* 1285135 */     GIR_EraseRootFromParent_Done,
     /* 1285136 */   // Label 18490: @1285136
     /* 1285136 */   GIM_Try, /*On fail goto*//*Label 18491*/ GIMT_Encode4(1285220), // Rule ID 8749 //
     /* 1285141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285194 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285219 */     // GIR_Coverage, 8749,
     /* 1285219 */     GIR_EraseRootFromParent_Done,
     /* 1285220 */   // Label 18491: @1285220
     /* 1285220 */   GIM_Try, /*On fail goto*//*Label 18492*/ GIMT_Encode4(1285304), // Rule ID 8752 //
     /* 1285225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1285245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285278 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285303 */     // GIR_Coverage, 8752,
     /* 1285303 */     GIR_EraseRootFromParent_Done,
     /* 1285304 */   // Label 18492: @1285304
     /* 1285304 */   GIM_Try, /*On fail goto*//*Label 18493*/ GIMT_Encode4(1285388), // Rule ID 8753 //
     /* 1285309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1285326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1285329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285387 */     // GIR_Coverage, 8753,
     /* 1285387 */     GIR_EraseRootFromParent_Done,
     /* 1285388 */   // Label 18493: @1285388
     /* 1285388 */   GIM_Try, /*On fail goto*//*Label 18494*/ GIMT_Encode4(1285472), // Rule ID 8756 //
     /* 1285393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1285413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285471 */     // GIR_Coverage, 8756,
     /* 1285471 */     GIR_EraseRootFromParent_Done,
     /* 1285472 */   // Label 18494: @1285472
     /* 1285472 */   GIM_Try, /*On fail goto*//*Label 18495*/ GIMT_Encode4(1285556), // Rule ID 8757 //
     /* 1285477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1285488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1285491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1285494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1285497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1285500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1285533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285555 */     // GIR_Coverage, 8757,
     /* 1285555 */     GIR_EraseRootFromParent_Done,
     /* 1285556 */   // Label 18495: @1285556
     /* 1285556 */   GIM_Try, /*On fail goto*//*Label 18496*/ GIMT_Encode4(1285640), // Rule ID 8760 //
     /* 1285561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1285578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1285581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285614 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285639 */     // GIR_Coverage, 8760,
     /* 1285639 */     GIR_EraseRootFromParent_Done,
     /* 1285640 */   // Label 18496: @1285640
     /* 1285640 */   GIM_Try, /*On fail goto*//*Label 18497*/ GIMT_Encode4(1285724), // Rule ID 8761 //
     /* 1285645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1285662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1285665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285698 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1285701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285723 */     // GIR_Coverage, 8761,
     /* 1285723 */     GIR_EraseRootFromParent_Done,
     /* 1285724 */   // Label 18497: @1285724
     /* 1285724 */   GIM_Try, /*On fail goto*//*Label 18498*/ GIMT_Encode4(1285808), // Rule ID 8764 //
     /* 1285729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1285732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1285746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1285749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285807 */     // GIR_Coverage, 8764,
     /* 1285807 */     GIR_EraseRootFromParent_Done,
     /* 1285808 */   // Label 18498: @1285808
     /* 1285808 */   GIM_Try, /*On fail goto*//*Label 18499*/ GIMT_Encode4(1285892), // Rule ID 8765 //
     /* 1285813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1285816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1285830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1285833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285866 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1285869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1285887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285891 */     // GIR_Coverage, 8765,
     /* 1285891 */     GIR_EraseRootFromParent_Done,
     /* 1285892 */   // Label 18499: @1285892
     /* 1285892 */   GIM_Try, /*On fail goto*//*Label 18500*/ GIMT_Encode4(1285976), // Rule ID 8768 //
     /* 1285897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1285908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1285911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1285914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1285917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1285920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1285939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285950 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1285953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285975 */     // GIR_Coverage, 8768,
     /* 1285975 */     GIR_EraseRootFromParent_Done,
     /* 1285976 */   // Label 18500: @1285976
     /* 1285976 */   GIM_Try, /*On fail goto*//*Label 18501*/ GIMT_Encode4(1286060), // Rule ID 8769 //
     /* 1285981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1285989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1285992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1285995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1285998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286034 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1286037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286059 */     // GIR_Coverage, 8769,
     /* 1286059 */     GIR_EraseRootFromParent_Done,
     /* 1286060 */   // Label 18501: @1286060
     /* 1286060 */   GIM_Try, /*On fail goto*//*Label 18502*/ GIMT_Encode4(1286144), // Rule ID 8772 //
     /* 1286065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286118 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286143 */     // GIR_Coverage, 8772,
     /* 1286143 */     GIR_EraseRootFromParent_Done,
     /* 1286144 */   // Label 18502: @1286144
     /* 1286144 */   GIM_Try, /*On fail goto*//*Label 18503*/ GIMT_Encode4(1286228), // Rule ID 8773 //
     /* 1286149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286202 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286227 */     // GIR_Coverage, 8773,
     /* 1286227 */     GIR_EraseRootFromParent_Done,
     /* 1286228 */   // Label 18503: @1286228
     /* 1286228 */   GIM_Try, /*On fail goto*//*Label 18504*/ GIMT_Encode4(1286312), // Rule ID 8776 //
     /* 1286233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286286 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286311 */     // GIR_Coverage, 8776,
     /* 1286311 */     GIR_EraseRootFromParent_Done,
     /* 1286312 */   // Label 18504: @1286312
     /* 1286312 */   GIM_Try, /*On fail goto*//*Label 18505*/ GIMT_Encode4(1286396), // Rule ID 8777 //
     /* 1286317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1286334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286395 */     // GIR_Coverage, 8777,
     /* 1286395 */     GIR_EraseRootFromParent_Done,
     /* 1286396 */   // Label 18505: @1286396
     /* 1286396 */   GIM_Try, /*On fail goto*//*Label 18506*/ GIMT_Encode4(1286480), // Rule ID 8780 //
     /* 1286401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286454 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286479 */     // GIR_Coverage, 8780,
     /* 1286479 */     GIR_EraseRootFromParent_Done,
     /* 1286480 */   // Label 18506: @1286480
     /* 1286480 */   GIM_Try, /*On fail goto*//*Label 18507*/ GIMT_Encode4(1286564), // Rule ID 8781 //
     /* 1286485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1286502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286538 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1286541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286563 */     // GIR_Coverage, 8781,
     /* 1286563 */     GIR_EraseRootFromParent_Done,
     /* 1286564 */   // Label 18507: @1286564
     /* 1286564 */   GIM_Try, /*On fail goto*//*Label 18508*/ GIMT_Encode4(1286648), // Rule ID 8784 //
     /* 1286569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1286586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286622 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286647 */     // GIR_Coverage, 8784,
     /* 1286647 */     GIR_EraseRootFromParent_Done,
     /* 1286648 */   // Label 18508: @1286648
     /* 1286648 */   GIM_Try, /*On fail goto*//*Label 18509*/ GIMT_Encode4(1286732), // Rule ID 8785 //
     /* 1286653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1286670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286706 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1286727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286731 */     // GIR_Coverage, 8785,
     /* 1286731 */     GIR_EraseRootFromParent_Done,
     /* 1286732 */   // Label 18509: @1286732
     /* 1286732 */   GIM_Try, /*On fail goto*//*Label 18510*/ GIMT_Encode4(1286816), // Rule ID 8788 //
     /* 1286737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1286754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286790 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286815 */     // GIR_Coverage, 8788,
     /* 1286815 */     GIR_EraseRootFromParent_Done,
     /* 1286816 */   // Label 18510: @1286816
     /* 1286816 */   GIM_Try, /*On fail goto*//*Label 18511*/ GIMT_Encode4(1286900), // Rule ID 8789 //
     /* 1286821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1286838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286874 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1286877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286899 */     // GIR_Coverage, 8789,
     /* 1286899 */     GIR_EraseRootFromParent_Done,
     /* 1286900 */   // Label 18511: @1286900
     /* 1286900 */   GIM_Try, /*On fail goto*//*Label 18512*/ GIMT_Encode4(1286984), // Rule ID 8792 //
     /* 1286905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1286922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286958 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1286961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286983 */     // GIR_Coverage, 8792,
     /* 1286983 */     GIR_EraseRootFromParent_Done,
     /* 1286984 */   // Label 18512: @1286984
     /* 1286984 */   GIM_Try, /*On fail goto*//*Label 18513*/ GIMT_Encode4(1287068), // Rule ID 8793 //
     /* 1286989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1286997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287042 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287067 */     // GIR_Coverage, 8793,
     /* 1287067 */     GIR_EraseRootFromParent_Done,
     /* 1287068 */   // Label 18513: @1287068
     /* 1287068 */   GIM_Try, /*On fail goto*//*Label 18514*/ GIMT_Encode4(1287152), // Rule ID 8796 //
     /* 1287073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287126 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287151 */     // GIR_Coverage, 8796,
     /* 1287151 */     GIR_EraseRootFromParent_Done,
     /* 1287152 */   // Label 18514: @1287152
     /* 1287152 */   GIM_Try, /*On fail goto*//*Label 18515*/ GIMT_Encode4(1287236), // Rule ID 8797 //
     /* 1287157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287210 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287235 */     // GIR_Coverage, 8797,
     /* 1287235 */     GIR_EraseRootFromParent_Done,
     /* 1287236 */   // Label 18515: @1287236
     /* 1287236 */   GIM_Try, /*On fail goto*//*Label 18516*/ GIMT_Encode4(1287320), // Rule ID 8800 //
     /* 1287241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287294 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287319 */     // GIR_Coverage, 8800,
     /* 1287319 */     GIR_EraseRootFromParent_Done,
     /* 1287320 */   // Label 18516: @1287320
     /* 1287320 */   GIM_Try, /*On fail goto*//*Label 18517*/ GIMT_Encode4(1287404), // Rule ID 8801 //
     /* 1287325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1287342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287378 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287403 */     // GIR_Coverage, 8801,
     /* 1287403 */     GIR_EraseRootFromParent_Done,
     /* 1287404 */   // Label 18517: @1287404
     /* 1287404 */   GIM_Try, /*On fail goto*//*Label 18518*/ GIMT_Encode4(1287488), // Rule ID 8804 //
     /* 1287409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1287412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287462 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287487 */     // GIR_Coverage, 8804,
     /* 1287487 */     GIR_EraseRootFromParent_Done,
     /* 1287488 */   // Label 18518: @1287488
     /* 1287488 */   GIM_Try, /*On fail goto*//*Label 18519*/ GIMT_Encode4(1287572), // Rule ID 8805 //
     /* 1287493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1287496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1287510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287546 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1287549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1287567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287571 */     // GIR_Coverage, 8805,
     /* 1287571 */     GIR_EraseRootFromParent_Done,
     /* 1287572 */   // Label 18519: @1287572
     /* 1287572 */   GIM_Try, /*On fail goto*//*Label 18520*/ GIMT_Encode4(1287656), // Rule ID 8808 //
     /* 1287577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1287588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1287591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1287594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1287600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1287615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287630 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1287633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287655 */     // GIR_Coverage, 8808,
     /* 1287655 */     GIR_EraseRootFromParent_Done,
     /* 1287656 */   // Label 18520: @1287656
     /* 1287656 */   GIM_Try, /*On fail goto*//*Label 18521*/ GIMT_Encode4(1287740), // Rule ID 8809 //
     /* 1287661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1287672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1287675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1287678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1287684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1287699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287714 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1287717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287739 */     // GIR_Coverage, 8809,
     /* 1287739 */     GIR_EraseRootFromParent_Done,
     /* 1287740 */   // Label 18521: @1287740
     /* 1287740 */   GIM_Try, /*On fail goto*//*Label 18522*/ GIMT_Encode4(1287824), // Rule ID 8812 //
     /* 1287745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1287756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1287759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1287762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1287768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1287783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287798 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1287801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287823 */     // GIR_Coverage, 8812,
     /* 1287823 */     GIR_EraseRootFromParent_Done,
     /* 1287824 */   // Label 18522: @1287824
     /* 1287824 */   GIM_Try, /*On fail goto*//*Label 18523*/ GIMT_Encode4(1287908), // Rule ID 8813 //
     /* 1287829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1287840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1287843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1287846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1287852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1287867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287882 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1287885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287907 */     // GIR_Coverage, 8813,
     /* 1287907 */     GIR_EraseRootFromParent_Done,
     /* 1287908 */   // Label 18523: @1287908
     /* 1287908 */   GIM_Try, /*On fail goto*//*Label 18524*/ GIMT_Encode4(1287992), // Rule ID 8816 //
     /* 1287913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1287921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1287924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1287927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1287930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1287936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1287951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287966 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1287969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287991 */     // GIR_Coverage, 8816,
     /* 1287991 */     GIR_EraseRootFromParent_Done,
     /* 1287992 */   // Label 18524: @1287992
     /* 1287992 */   GIM_Try, /*On fail goto*//*Label 18525*/ GIMT_Encode4(1288076), // Rule ID 8817 //
     /* 1287997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288050 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288075 */     // GIR_Coverage, 8817,
     /* 1288075 */     GIR_EraseRootFromParent_Done,
     /* 1288076 */   // Label 18525: @1288076
     /* 1288076 */   GIM_Try, /*On fail goto*//*Label 18526*/ GIMT_Encode4(1288160), // Rule ID 8820 //
     /* 1288081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288134 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288159 */     // GIR_Coverage, 8820,
     /* 1288159 */     GIR_EraseRootFromParent_Done,
     /* 1288160 */   // Label 18526: @1288160
     /* 1288160 */   GIM_Try, /*On fail goto*//*Label 18527*/ GIMT_Encode4(1288244), // Rule ID 8821 //
     /* 1288165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288218 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288243 */     // GIR_Coverage, 8821,
     /* 1288243 */     GIR_EraseRootFromParent_Done,
     /* 1288244 */   // Label 18527: @1288244
     /* 1288244 */   GIM_Try, /*On fail goto*//*Label 18528*/ GIMT_Encode4(1288328), // Rule ID 8824 //
     /* 1288249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288302 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288327 */     // GIR_Coverage, 8824,
     /* 1288327 */     GIR_EraseRootFromParent_Done,
     /* 1288328 */   // Label 18528: @1288328
     /* 1288328 */   GIM_Try, /*On fail goto*//*Label 18529*/ GIMT_Encode4(1288412), // Rule ID 8825 //
     /* 1288333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1288350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288386 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288411 */     // GIR_Coverage, 8825,
     /* 1288411 */     GIR_EraseRootFromParent_Done,
     /* 1288412 */   // Label 18529: @1288412
     /* 1288412 */   GIM_Try, /*On fail goto*//*Label 18530*/ GIMT_Encode4(1288496), // Rule ID 8828 //
     /* 1288417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288470 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288495 */     // GIR_Coverage, 8828,
     /* 1288495 */     GIR_EraseRootFromParent_Done,
     /* 1288496 */   // Label 18530: @1288496
     /* 1288496 */   GIM_Try, /*On fail goto*//*Label 18531*/ GIMT_Encode4(1288580), // Rule ID 8829 //
     /* 1288501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1288518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288554 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288579 */     // GIR_Coverage, 8829,
     /* 1288579 */     GIR_EraseRootFromParent_Done,
     /* 1288580 */   // Label 18531: @1288580
     /* 1288580 */   GIM_Try, /*On fail goto*//*Label 18532*/ GIMT_Encode4(1288664), // Rule ID 8832 //
     /* 1288585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1288596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1288599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1288602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1288608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288638 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288663 */     // GIR_Coverage, 8832,
     /* 1288663 */     GIR_EraseRootFromParent_Done,
     /* 1288664 */   // Label 18532: @1288664
     /* 1288664 */   GIM_Try, /*On fail goto*//*Label 18533*/ GIMT_Encode4(1288748), // Rule ID 8833 //
     /* 1288669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1288680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1288683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1288686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1288692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288722 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1288725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288747 */     // GIR_Coverage, 8833,
     /* 1288747 */     GIR_EraseRootFromParent_Done,
     /* 1288748 */   // Label 18533: @1288748
     /* 1288748 */   GIM_Try, /*On fail goto*//*Label 18534*/ GIMT_Encode4(1288832), // Rule ID 8836 //
     /* 1288753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1288770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288806 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288831 */     // GIR_Coverage, 8836,
     /* 1288831 */     GIR_EraseRootFromParent_Done,
     /* 1288832 */   // Label 18534: @1288832
     /* 1288832 */   GIM_Try, /*On fail goto*//*Label 18535*/ GIMT_Encode4(1288916), // Rule ID 8837 //
     /* 1288837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1288854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1288893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288915 */     // GIR_Coverage, 8837,
     /* 1288915 */     GIR_EraseRootFromParent_Done,
     /* 1288916 */   // Label 18535: @1288916
     /* 1288916 */   GIM_Try, /*On fail goto*//*Label 18536*/ GIMT_Encode4(1289000), // Rule ID 8840 //
     /* 1288921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1288929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1288938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288974 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1288977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288999 */     // GIR_Coverage, 8840,
     /* 1288999 */     GIR_EraseRootFromParent_Done,
     /* 1289000 */   // Label 18536: @1289000
     /* 1289000 */   GIM_Try, /*On fail goto*//*Label 18537*/ GIMT_Encode4(1289084), // Rule ID 8841 //
     /* 1289005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289058 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289083 */     // GIR_Coverage, 8841,
     /* 1289083 */     GIR_EraseRootFromParent_Done,
     /* 1289084 */   // Label 18537: @1289084
     /* 1289084 */   GIM_Try, /*On fail goto*//*Label 18538*/ GIMT_Encode4(1289168), // Rule ID 8844 //
     /* 1289089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289167 */     // GIR_Coverage, 8844,
     /* 1289167 */     GIR_EraseRootFromParent_Done,
     /* 1289168 */   // Label 18538: @1289168
     /* 1289168 */   GIM_Try, /*On fail goto*//*Label 18539*/ GIMT_Encode4(1289252), // Rule ID 8845 //
     /* 1289173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289226 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1289229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289251 */     // GIR_Coverage, 8845,
     /* 1289251 */     GIR_EraseRootFromParent_Done,
     /* 1289252 */   // Label 18539: @1289252
     /* 1289252 */   GIM_Try, /*On fail goto*//*Label 18540*/ GIMT_Encode4(1289336), // Rule ID 8848 //
     /* 1289257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289310 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289335 */     // GIR_Coverage, 8848,
     /* 1289335 */     GIR_EraseRootFromParent_Done,
     /* 1289336 */   // Label 18540: @1289336
     /* 1289336 */   GIM_Try, /*On fail goto*//*Label 18541*/ GIMT_Encode4(1289420), // Rule ID 8849 //
     /* 1289341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1289358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289394 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1289397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289419 */     // GIR_Coverage, 8849,
     /* 1289419 */     GIR_EraseRootFromParent_Done,
     /* 1289420 */   // Label 18541: @1289420
     /* 1289420 */   GIM_Try, /*On fail goto*//*Label 18542*/ GIMT_Encode4(1289504), // Rule ID 8852 //
     /* 1289425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289478 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289503 */     // GIR_Coverage, 8852,
     /* 1289503 */     GIR_EraseRootFromParent_Done,
     /* 1289504 */   // Label 18542: @1289504
     /* 1289504 */   GIM_Try, /*On fail goto*//*Label 18543*/ GIMT_Encode4(1289588), // Rule ID 8853 //
     /* 1289509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1289517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1289526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289562 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1289565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289587 */     // GIR_Coverage, 8853,
     /* 1289587 */     GIR_EraseRootFromParent_Done,
     /* 1289588 */   // Label 18543: @1289588
     /* 1289588 */   GIM_Try, /*On fail goto*//*Label 18544*/ GIMT_Encode4(1289672), // Rule ID 8944 //
     /* 1289593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1289604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1289607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1289610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1289613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1289616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289646 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1289649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289671 */     // GIR_Coverage, 8944,
     /* 1289671 */     GIR_EraseRootFromParent_Done,
     /* 1289672 */   // Label 18544: @1289672
     /* 1289672 */   GIM_Try, /*On fail goto*//*Label 18545*/ GIMT_Encode4(1289756), // Rule ID 8945 //
     /* 1289677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1289688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1289691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1289694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1289697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1289700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289730 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1289733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289755 */     // GIR_Coverage, 8945,
     /* 1289755 */     GIR_EraseRootFromParent_Done,
     /* 1289756 */   // Label 18545: @1289756
     /* 1289756 */   GIM_Try, /*On fail goto*//*Label 18546*/ GIMT_Encode4(1289840), // Rule ID 8948 //
     /* 1289761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1289778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1289781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289814 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1289817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289839 */     // GIR_Coverage, 8948,
     /* 1289839 */     GIR_EraseRootFromParent_Done,
     /* 1289840 */   // Label 18546: @1289840
     /* 1289840 */   GIM_Try, /*On fail goto*//*Label 18547*/ GIMT_Encode4(1289924), // Rule ID 8949 //
     /* 1289845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1289862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1289865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1289901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1289919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289923 */     // GIR_Coverage, 8949,
     /* 1289923 */     GIR_EraseRootFromParent_Done,
     /* 1289924 */   // Label 18547: @1289924
     /* 1289924 */   GIM_Try, /*On fail goto*//*Label 18548*/ GIMT_Encode4(1290008), // Rule ID 8952 //
     /* 1289929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1289946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1289949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289982 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1289985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290007 */     // GIR_Coverage, 8952,
     /* 1290007 */     GIR_EraseRootFromParent_Done,
     /* 1290008 */   // Label 18548: @1290008
     /* 1290008 */   GIM_Try, /*On fail goto*//*Label 18549*/ GIMT_Encode4(1290092), // Rule ID 8953 //
     /* 1290013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1290033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290066 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290091 */     // GIR_Coverage, 8953,
     /* 1290091 */     GIR_EraseRootFromParent_Done,
     /* 1290092 */   // Label 18549: @1290092
     /* 1290092 */   GIM_Try, /*On fail goto*//*Label 18550*/ GIMT_Encode4(1290176), // Rule ID 8956 //
     /* 1290097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1290117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290150 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290175 */     // GIR_Coverage, 8956,
     /* 1290175 */     GIR_EraseRootFromParent_Done,
     /* 1290176 */   // Label 18550: @1290176
     /* 1290176 */   GIM_Try, /*On fail goto*//*Label 18551*/ GIMT_Encode4(1290260), // Rule ID 8957 //
     /* 1290181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1290201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290234 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1290237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290259 */     // GIR_Coverage, 8957,
     /* 1290259 */     GIR_EraseRootFromParent_Done,
     /* 1290260 */   // Label 18551: @1290260
     /* 1290260 */   GIM_Try, /*On fail goto*//*Label 18552*/ GIMT_Encode4(1290344), // Rule ID 8960 //
     /* 1290265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1290285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290318 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290343 */     // GIR_Coverage, 8960,
     /* 1290343 */     GIR_EraseRootFromParent_Done,
     /* 1290344 */   // Label 18552: @1290344
     /* 1290344 */   GIM_Try, /*On fail goto*//*Label 18553*/ GIMT_Encode4(1290428), // Rule ID 8961 //
     /* 1290349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1290366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1290369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290402 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290427 */     // GIR_Coverage, 8961,
     /* 1290427 */     GIR_EraseRootFromParent_Done,
     /* 1290428 */   // Label 18553: @1290428
     /* 1290428 */   GIM_Try, /*On fail goto*//*Label 18554*/ GIMT_Encode4(1290512), // Rule ID 8964 //
     /* 1290433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1290450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1290453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290486 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290511 */     // GIR_Coverage, 8964,
     /* 1290511 */     GIR_EraseRootFromParent_Done,
     /* 1290512 */   // Label 18554: @1290512
     /* 1290512 */   GIM_Try, /*On fail goto*//*Label 18555*/ GIMT_Encode4(1290596), // Rule ID 8965 //
     /* 1290517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1290534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1290537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290570 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1290573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1290591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290595 */     // GIR_Coverage, 8965,
     /* 1290595 */     GIR_EraseRootFromParent_Done,
     /* 1290596 */   // Label 18555: @1290596
     /* 1290596 */   GIM_Try, /*On fail goto*//*Label 18556*/ GIMT_Encode4(1290680), // Rule ID 8968 //
     /* 1290601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1290618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1290621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290654 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1290657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290679 */     // GIR_Coverage, 8968,
     /* 1290679 */     GIR_EraseRootFromParent_Done,
     /* 1290680 */   // Label 18556: @1290680
     /* 1290680 */   GIM_Try, /*On fail goto*//*Label 18557*/ GIMT_Encode4(1290764), // Rule ID 8969 //
     /* 1290685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1290702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1290705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290738 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1290741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290763 */     // GIR_Coverage, 8969,
     /* 1290763 */     GIR_EraseRootFromParent_Done,
     /* 1290764 */   // Label 18557: @1290764
     /* 1290764 */   GIM_Try, /*On fail goto*//*Label 18558*/ GIMT_Encode4(1290848), // Rule ID 8972 //
     /* 1290769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1290786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1290825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290847 */     // GIR_Coverage, 8972,
     /* 1290847 */     GIR_EraseRootFromParent_Done,
     /* 1290848 */   // Label 18558: @1290848
     /* 1290848 */   GIM_Try, /*On fail goto*//*Label 18559*/ GIMT_Encode4(1290932), // Rule ID 8973 //
     /* 1290853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1290870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1290873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290906 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1290909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290931 */     // GIR_Coverage, 8973,
     /* 1290931 */     GIR_EraseRootFromParent_Done,
     /* 1290932 */   // Label 18559: @1290932
     /* 1290932 */   GIM_Try, /*On fail goto*//*Label 18560*/ GIMT_Encode4(1291016), // Rule ID 8976 //
     /* 1290937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1290954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1290957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290990 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1290993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291015 */     // GIR_Coverage, 8976,
     /* 1291015 */     GIR_EraseRootFromParent_Done,
     /* 1291016 */   // Label 18560: @1291016
     /* 1291016 */   GIM_Try, /*On fail goto*//*Label 18561*/ GIMT_Encode4(1291100), // Rule ID 8977 //
     /* 1291021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1291041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291074 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291099 */     // GIR_Coverage, 8977,
     /* 1291099 */     GIR_EraseRootFromParent_Done,
     /* 1291100 */   // Label 18561: @1291100
     /* 1291100 */   GIM_Try, /*On fail goto*//*Label 18562*/ GIMT_Encode4(1291184), // Rule ID 8980 //
     /* 1291105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1291108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291158 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291183 */     // GIR_Coverage, 8980,
     /* 1291183 */     GIR_EraseRootFromParent_Done,
     /* 1291184 */   // Label 18562: @1291184
     /* 1291184 */   GIM_Try, /*On fail goto*//*Label 18563*/ GIMT_Encode4(1291268), // Rule ID 8981 //
     /* 1291189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1291192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1291209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1291245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291267 */     // GIR_Coverage, 8981,
     /* 1291267 */     GIR_EraseRootFromParent_Done,
     /* 1291268 */   // Label 18563: @1291268
     /* 1291268 */   GIM_Try, /*On fail goto*//*Label 18564*/ GIMT_Encode4(1291352), // Rule ID 8984 //
     /* 1291273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1291293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291326 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291351 */     // GIR_Coverage, 8984,
     /* 1291351 */     GIR_EraseRootFromParent_Done,
     /* 1291352 */   // Label 18564: @1291352
     /* 1291352 */   GIM_Try, /*On fail goto*//*Label 18565*/ GIMT_Encode4(1291436), // Rule ID 8985 //
     /* 1291357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1291374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1291377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291410 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291435 */     // GIR_Coverage, 8985,
     /* 1291435 */     GIR_EraseRootFromParent_Done,
     /* 1291436 */   // Label 18565: @1291436
     /* 1291436 */   GIM_Try, /*On fail goto*//*Label 18566*/ GIMT_Encode4(1291520), // Rule ID 8988 //
     /* 1291441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1291452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1291455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1291461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291494 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1291497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291519 */     // GIR_Coverage, 8988,
     /* 1291519 */     GIR_EraseRootFromParent_Done,
     /* 1291520 */   // Label 18566: @1291520
     /* 1291520 */   GIM_Try, /*On fail goto*//*Label 18567*/ GIMT_Encode4(1291604), // Rule ID 8989 //
     /* 1291525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1291536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1291539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1291542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1291545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1291548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291578 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1291581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291603 */     // GIR_Coverage, 8989,
     /* 1291603 */     GIR_EraseRootFromParent_Done,
     /* 1291604 */   // Label 18567: @1291604
     /* 1291604 */   GIM_Try, /*On fail goto*//*Label 18568*/ GIMT_Encode4(1291688), // Rule ID 8992 //
     /* 1291609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1291620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1291623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1291626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1291629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1291632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291662 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1291665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291687 */     // GIR_Coverage, 8992,
     /* 1291687 */     GIR_EraseRootFromParent_Done,
     /* 1291688 */   // Label 18568: @1291688
     /* 1291688 */   GIM_Try, /*On fail goto*//*Label 18569*/ GIMT_Encode4(1291772), // Rule ID 8993 //
     /* 1291693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1291704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1291707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1291710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1291713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1291716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1291735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291746 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1291749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291771 */     // GIR_Coverage, 8993,
     /* 1291771 */     GIR_EraseRootFromParent_Done,
     /* 1291772 */   // Label 18569: @1291772
     /* 1291772 */   GIM_Try, /*On fail goto*//*Label 18570*/ GIMT_Encode4(1291856), // Rule ID 8996 //
     /* 1291777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1291794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1291797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291830 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291855 */     // GIR_Coverage, 8996,
     /* 1291855 */     GIR_EraseRootFromParent_Done,
     /* 1291856 */   // Label 18570: @1291856
     /* 1291856 */   GIM_Try, /*On fail goto*//*Label 18571*/ GIMT_Encode4(1291940), // Rule ID 8997 //
     /* 1291861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1291878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1291881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1291903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291914 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1291917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291939 */     // GIR_Coverage, 8997,
     /* 1291939 */     GIR_EraseRootFromParent_Done,
     /* 1291940 */   // Label 18571: @1291940
     /* 1291940 */   GIM_Try, /*On fail goto*//*Label 18572*/ GIMT_Encode4(1292024), // Rule ID 9000 //
     /* 1291945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1291953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1291956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1291959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1291962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1291965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1291968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1291987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291998 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292023 */     // GIR_Coverage, 9000,
     /* 1292023 */     GIR_EraseRootFromParent_Done,
     /* 1292024 */   // Label 18572: @1292024
     /* 1292024 */   GIM_Try, /*On fail goto*//*Label 18573*/ GIMT_Encode4(1292108), // Rule ID 9001 //
     /* 1292029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1292049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292082 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292107 */     // GIR_Coverage, 9001,
     /* 1292107 */     GIR_EraseRootFromParent_Done,
     /* 1292108 */   // Label 18573: @1292108
     /* 1292108 */   GIM_Try, /*On fail goto*//*Label 18574*/ GIMT_Encode4(1292192), // Rule ID 9004 //
     /* 1292113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1292133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292166 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292191 */     // GIR_Coverage, 9004,
     /* 1292191 */     GIR_EraseRootFromParent_Done,
     /* 1292192 */   // Label 18574: @1292192
     /* 1292192 */   GIM_Try, /*On fail goto*//*Label 18575*/ GIMT_Encode4(1292276), // Rule ID 9005 //
     /* 1292197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1292217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292250 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292275 */     // GIR_Coverage, 9005,
     /* 1292275 */     GIR_EraseRootFromParent_Done,
     /* 1292276 */   // Label 18575: @1292276
     /* 1292276 */   GIM_Try, /*On fail goto*//*Label 18576*/ GIMT_Encode4(1292360), // Rule ID 9008 //
     /* 1292281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1292301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292334 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292359 */     // GIR_Coverage, 9008,
     /* 1292359 */     GIR_EraseRootFromParent_Done,
     /* 1292360 */   // Label 18576: @1292360
     /* 1292360 */   GIM_Try, /*On fail goto*//*Label 18577*/ GIMT_Encode4(1292444), // Rule ID 9009 //
     /* 1292365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1292382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1292385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292418 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292443 */     // GIR_Coverage, 9009,
     /* 1292443 */     GIR_EraseRootFromParent_Done,
     /* 1292444 */   // Label 18577: @1292444
     /* 1292444 */   GIM_Try, /*On fail goto*//*Label 18578*/ GIMT_Encode4(1292528), // Rule ID 9012 //
     /* 1292449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1292469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292502 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292527 */     // GIR_Coverage, 9012,
     /* 1292527 */     GIR_EraseRootFromParent_Done,
     /* 1292528 */   // Label 18578: @1292528
     /* 1292528 */   GIM_Try, /*On fail goto*//*Label 18579*/ GIMT_Encode4(1292612), // Rule ID 9013 //
     /* 1292533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1292550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1292553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292586 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1292589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292611 */     // GIR_Coverage, 9013,
     /* 1292611 */     GIR_EraseRootFromParent_Done,
     /* 1292612 */   // Label 18579: @1292612
     /* 1292612 */   GIM_Try, /*On fail goto*//*Label 18580*/ GIMT_Encode4(1292696), // Rule ID 9016 //
     /* 1292617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1292634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1292637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292670 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292695 */     // GIR_Coverage, 9016,
     /* 1292695 */     GIR_EraseRootFromParent_Done,
     /* 1292696 */   // Label 18580: @1292696
     /* 1292696 */   GIM_Try, /*On fail goto*//*Label 18581*/ GIMT_Encode4(1292780), // Rule ID 9017 //
     /* 1292701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1292718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1292721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1292757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1292775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292779 */     // GIR_Coverage, 9017,
     /* 1292779 */     GIR_EraseRootFromParent_Done,
     /* 1292780 */   // Label 18581: @1292780
     /* 1292780 */   GIM_Try, /*On fail goto*//*Label 18582*/ GIMT_Encode4(1292864), // Rule ID 9020 //
     /* 1292785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1292788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1292796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1292799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1292802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1292805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1292808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292838 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1292859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292863 */     // GIR_Coverage, 9020,
     /* 1292863 */     GIR_EraseRootFromParent_Done,
     /* 1292864 */   // Label 18582: @1292864
     /* 1292864 */   GIM_Try, /*On fail goto*//*Label 18583*/ GIMT_Encode4(1292948), // Rule ID 9021 //
     /* 1292869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1292872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1292880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1292883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1292886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1292889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1292892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1292925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1292943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292947 */     // GIR_Coverage, 9021,
     /* 1292947 */     GIR_EraseRootFromParent_Done,
     /* 1292948 */   // Label 18583: @1292948
     /* 1292948 */   GIM_Try, /*On fail goto*//*Label 18584*/ GIMT_Encode4(1293032), // Rule ID 9024 //
     /* 1292953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1292956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1292961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1292964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1292967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1292970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1292973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1292976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293006 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293031 */     // GIR_Coverage, 9024,
     /* 1293031 */     GIR_EraseRootFromParent_Done,
     /* 1293032 */   // Label 18584: @1293032
     /* 1293032 */   GIM_Try, /*On fail goto*//*Label 18585*/ GIMT_Encode4(1293116), // Rule ID 9025 //
     /* 1293037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1293057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1293093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293115 */     // GIR_Coverage, 9025,
     /* 1293115 */     GIR_EraseRootFromParent_Done,
     /* 1293116 */   // Label 18585: @1293116
     /* 1293116 */   GIM_Try, /*On fail goto*//*Label 18586*/ GIMT_Encode4(1293200), // Rule ID 9028 //
     /* 1293121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1293141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293174 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293199 */     // GIR_Coverage, 9028,
     /* 1293199 */     GIR_EraseRootFromParent_Done,
     /* 1293200 */   // Label 18586: @1293200
     /* 1293200 */   GIM_Try, /*On fail goto*//*Label 18587*/ GIMT_Encode4(1293284), // Rule ID 9029 //
     /* 1293205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1293225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1293261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293283 */     // GIR_Coverage, 9029,
     /* 1293283 */     GIR_EraseRootFromParent_Done,
     /* 1293284 */   // Label 18587: @1293284
     /* 1293284 */   GIM_Try, /*On fail goto*//*Label 18588*/ GIMT_Encode4(1293368), // Rule ID 9032 //
     /* 1293289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293342 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1293345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293367 */     // GIR_Coverage, 9032,
     /* 1293367 */     GIR_EraseRootFromParent_Done,
     /* 1293368 */   // Label 18588: @1293368
     /* 1293368 */   GIM_Try, /*On fail goto*//*Label 18589*/ GIMT_Encode4(1293452), // Rule ID 9033 //
     /* 1293373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1293390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293426 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1293429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293451 */     // GIR_Coverage, 9033,
     /* 1293451 */     GIR_EraseRootFromParent_Done,
     /* 1293452 */   // Label 18589: @1293452
     /* 1293452 */   GIM_Try, /*On fail goto*//*Label 18590*/ GIMT_Encode4(1293536), // Rule ID 9036 //
     /* 1293457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293510 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293535 */     // GIR_Coverage, 9036,
     /* 1293535 */     GIR_EraseRootFromParent_Done,
     /* 1293536 */   // Label 18590: @1293536
     /* 1293536 */   GIM_Try, /*On fail goto*//*Label 18591*/ GIMT_Encode4(1293620), // Rule ID 9037 //
     /* 1293541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1293558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293594 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293619 */     // GIR_Coverage, 9037,
     /* 1293619 */     GIR_EraseRootFromParent_Done,
     /* 1293620 */   // Label 18591: @1293620
     /* 1293620 */   GIM_Try, /*On fail goto*//*Label 18592*/ GIMT_Encode4(1293704), // Rule ID 9040 //
     /* 1293625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1293642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293678 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1293681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293703 */     // GIR_Coverage, 9040,
     /* 1293703 */     GIR_EraseRootFromParent_Done,
     /* 1293704 */   // Label 18592: @1293704
     /* 1293704 */   GIM_Try, /*On fail goto*//*Label 18593*/ GIMT_Encode4(1293788), // Rule ID 9041 //
     /* 1293709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1293726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1293765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1293783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293787 */     // GIR_Coverage, 9041,
     /* 1293787 */     GIR_EraseRootFromParent_Done,
     /* 1293788 */   // Label 18593: @1293788
     /* 1293788 */   GIM_Try, /*On fail goto*//*Label 18594*/ GIMT_Encode4(1293872), // Rule ID 9044 //
     /* 1293793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1293810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293846 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293871 */     // GIR_Coverage, 9044,
     /* 1293871 */     GIR_EraseRootFromParent_Done,
     /* 1293872 */   // Label 18594: @1293872
     /* 1293872 */   GIM_Try, /*On fail goto*//*Label 18595*/ GIMT_Encode4(1293956), // Rule ID 9045 //
     /* 1293877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1293888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1293891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1293894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1293900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293930 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1293933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293955 */     // GIR_Coverage, 9045,
     /* 1293955 */     GIR_EraseRootFromParent_Done,
     /* 1293956 */   // Label 18595: @1293956
     /* 1293956 */   GIM_Try, /*On fail goto*//*Label 18596*/ GIMT_Encode4(1294040), // Rule ID 9048 //
     /* 1293961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1293969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1293978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294014 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294039 */     // GIR_Coverage, 9048,
     /* 1294039 */     GIR_EraseRootFromParent_Done,
     /* 1294040 */   // Label 18596: @1294040
     /* 1294040 */   GIM_Try, /*On fail goto*//*Label 18597*/ GIMT_Encode4(1294124), // Rule ID 9049 //
     /* 1294045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294098 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294123 */     // GIR_Coverage, 9049,
     /* 1294123 */     GIR_EraseRootFromParent_Done,
     /* 1294124 */   // Label 18597: @1294124
     /* 1294124 */   GIM_Try, /*On fail goto*//*Label 18598*/ GIMT_Encode4(1294208), // Rule ID 9052 //
     /* 1294129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294182 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294207 */     // GIR_Coverage, 9052,
     /* 1294207 */     GIR_EraseRootFromParent_Done,
     /* 1294208 */   // Label 18598: @1294208
     /* 1294208 */   GIM_Try, /*On fail goto*//*Label 18599*/ GIMT_Encode4(1294292), // Rule ID 9053 //
     /* 1294213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294266 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1294269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294291 */     // GIR_Coverage, 9053,
     /* 1294291 */     GIR_EraseRootFromParent_Done,
     /* 1294292 */   // Label 18599: @1294292
     /* 1294292 */   GIM_Try, /*On fail goto*//*Label 18600*/ GIMT_Encode4(1294376), // Rule ID 9056 //
     /* 1294297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294350 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294375 */     // GIR_Coverage, 9056,
     /* 1294375 */     GIR_EraseRootFromParent_Done,
     /* 1294376 */   // Label 18600: @1294376
     /* 1294376 */   GIM_Try, /*On fail goto*//*Label 18601*/ GIMT_Encode4(1294460), // Rule ID 9057 //
     /* 1294381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1294398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294434 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294459 */     // GIR_Coverage, 9057,
     /* 1294459 */     GIR_EraseRootFromParent_Done,
     /* 1294460 */   // Label 18601: @1294460
     /* 1294460 */   GIM_Try, /*On fail goto*//*Label 18602*/ GIMT_Encode4(1294544), // Rule ID 9060 //
     /* 1294465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294543 */     // GIR_Coverage, 9060,
     /* 1294543 */     GIR_EraseRootFromParent_Done,
     /* 1294544 */   // Label 18602: @1294544
     /* 1294544 */   GIM_Try, /*On fail goto*//*Label 18603*/ GIMT_Encode4(1294628), // Rule ID 9061 //
     /* 1294549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1294566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294627 */     // GIR_Coverage, 9061,
     /* 1294627 */     GIR_EraseRootFromParent_Done,
     /* 1294628 */   // Label 18603: @1294628
     /* 1294628 */   GIM_Try, /*On fail goto*//*Label 18604*/ GIMT_Encode4(1294712), // Rule ID 9064 //
     /* 1294633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1294650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294686 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294711 */     // GIR_Coverage, 9064,
     /* 1294711 */     GIR_EraseRootFromParent_Done,
     /* 1294712 */   // Label 18604: @1294712
     /* 1294712 */   GIM_Try, /*On fail goto*//*Label 18605*/ GIMT_Encode4(1294796), // Rule ID 9065 //
     /* 1294717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1294734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294770 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1294791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294795 */     // GIR_Coverage, 9065,
     /* 1294795 */     GIR_EraseRootFromParent_Done,
     /* 1294796 */   // Label 18605: @1294796
     /* 1294796 */   GIM_Try, /*On fail goto*//*Label 18606*/ GIMT_Encode4(1294880), // Rule ID 9068 //
     /* 1294801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1294804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1294818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294854 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294879 */     // GIR_Coverage, 9068,
     /* 1294879 */     GIR_EraseRootFromParent_Done,
     /* 1294880 */   // Label 18606: @1294880
     /* 1294880 */   GIM_Try, /*On fail goto*//*Label 18607*/ GIMT_Encode4(1294964), // Rule ID 9069 //
     /* 1294885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1294888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1294902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294938 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1294941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294963 */     // GIR_Coverage, 9069,
     /* 1294963 */     GIR_EraseRootFromParent_Done,
     /* 1294964 */   // Label 18607: @1294964
     /* 1294964 */   GIM_Try, /*On fail goto*//*Label 18608*/ GIMT_Encode4(1295048), // Rule ID 9072 //
     /* 1294969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1294977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1294980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1294983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1294986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1294992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295022 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295047 */     // GIR_Coverage, 9072,
     /* 1295047 */     GIR_EraseRootFromParent_Done,
     /* 1295048 */   // Label 18608: @1295048
     /* 1295048 */   GIM_Try, /*On fail goto*//*Label 18609*/ GIMT_Encode4(1295132), // Rule ID 9073 //
     /* 1295053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295106 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295131 */     // GIR_Coverage, 9073,
     /* 1295131 */     GIR_EraseRootFromParent_Done,
     /* 1295132 */   // Label 18609: @1295132
     /* 1295132 */   GIM_Try, /*On fail goto*//*Label 18610*/ GIMT_Encode4(1295216), // Rule ID 9076 //
     /* 1295137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295190 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295215 */     // GIR_Coverage, 9076,
     /* 1295215 */     GIR_EraseRootFromParent_Done,
     /* 1295216 */   // Label 18610: @1295216
     /* 1295216 */   GIM_Try, /*On fail goto*//*Label 18611*/ GIMT_Encode4(1295300), // Rule ID 9077 //
     /* 1295221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295274 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295299 */     // GIR_Coverage, 9077,
     /* 1295299 */     GIR_EraseRootFromParent_Done,
     /* 1295300 */   // Label 18611: @1295300
     /* 1295300 */   GIM_Try, /*On fail goto*//*Label 18612*/ GIMT_Encode4(1295384), // Rule ID 9080 //
     /* 1295305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295358 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295383 */     // GIR_Coverage, 9080,
     /* 1295383 */     GIR_EraseRootFromParent_Done,
     /* 1295384 */   // Label 18612: @1295384
     /* 1295384 */   GIM_Try, /*On fail goto*//*Label 18613*/ GIMT_Encode4(1295468), // Rule ID 9081 //
     /* 1295389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1295400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1295403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1295406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1295412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295442 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295467 */     // GIR_Coverage, 9081,
     /* 1295467 */     GIR_EraseRootFromParent_Done,
     /* 1295468 */   // Label 18613: @1295468
     /* 1295468 */   GIM_Try, /*On fail goto*//*Label 18614*/ GIMT_Encode4(1295552), // Rule ID 9084 //
     /* 1295473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295526 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295551 */     // GIR_Coverage, 9084,
     /* 1295551 */     GIR_EraseRootFromParent_Done,
     /* 1295552 */   // Label 18614: @1295552
     /* 1295552 */   GIM_Try, /*On fail goto*//*Label 18615*/ GIMT_Encode4(1295636), // Rule ID 9085 //
     /* 1295557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1295574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295610 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1295613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295635 */     // GIR_Coverage, 9085,
     /* 1295635 */     GIR_EraseRootFromParent_Done,
     /* 1295636 */   // Label 18615: @1295636
     /* 1295636 */   GIM_Try, /*On fail goto*//*Label 18616*/ GIMT_Encode4(1295720), // Rule ID 9088 //
     /* 1295641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1295658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295694 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295719 */     // GIR_Coverage, 9088,
     /* 1295719 */     GIR_EraseRootFromParent_Done,
     /* 1295720 */   // Label 18616: @1295720
     /* 1295720 */   GIM_Try, /*On fail goto*//*Label 18617*/ GIMT_Encode4(1295804), // Rule ID 9089 //
     /* 1295725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1295742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295778 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1295781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295803 */     // GIR_Coverage, 9089,
     /* 1295803 */     GIR_EraseRootFromParent_Done,
     /* 1295804 */   // Label 18617: @1295804
     /* 1295804 */   GIM_Try, /*On fail goto*//*Label 18618*/ GIMT_Encode4(1295888), // Rule ID 9092 //
     /* 1295809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1295826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295862 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295887 */     // GIR_Coverage, 9092,
     /* 1295887 */     GIR_EraseRootFromParent_Done,
     /* 1295888 */   // Label 18618: @1295888
     /* 1295888 */   GIM_Try, /*On fail goto*//*Label 18619*/ GIMT_Encode4(1295972), // Rule ID 9093 //
     /* 1295893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1295910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1295931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295946 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1295949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295971 */     // GIR_Coverage, 9093,
     /* 1295971 */     GIR_EraseRootFromParent_Done,
     /* 1295972 */   // Label 18619: @1295972
     /* 1295972 */   GIM_Try, /*On fail goto*//*Label 18620*/ GIMT_Encode4(1296056), // Rule ID 9096 //
     /* 1295977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1295985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1295988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1295991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1295994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296030 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296055 */     // GIR_Coverage, 9096,
     /* 1296055 */     GIR_EraseRootFromParent_Done,
     /* 1296056 */   // Label 18620: @1296056
     /* 1296056 */   GIM_Try, /*On fail goto*//*Label 18621*/ GIMT_Encode4(1296140), // Rule ID 9097 //
     /* 1296061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296114 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296139 */     // GIR_Coverage, 9097,
     /* 1296139 */     GIR_EraseRootFromParent_Done,
     /* 1296140 */   // Label 18621: @1296140
     /* 1296140 */   GIM_Try, /*On fail goto*//*Label 18622*/ GIMT_Encode4(1296224), // Rule ID 9100 //
     /* 1296145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296198 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296223 */     // GIR_Coverage, 9100,
     /* 1296223 */     GIR_EraseRootFromParent_Done,
     /* 1296224 */   // Label 18622: @1296224
     /* 1296224 */   GIM_Try, /*On fail goto*//*Label 18623*/ GIMT_Encode4(1296308), // Rule ID 9101 //
     /* 1296229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296282 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296307 */     // GIR_Coverage, 9101,
     /* 1296307 */     GIR_EraseRootFromParent_Done,
     /* 1296308 */   // Label 18623: @1296308
     /* 1296308 */   GIM_Try, /*On fail goto*//*Label 18624*/ GIMT_Encode4(1296392), // Rule ID 9104 //
     /* 1296313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296366 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296391 */     // GIR_Coverage, 9104,
     /* 1296391 */     GIR_EraseRootFromParent_Done,
     /* 1296392 */   // Label 18624: @1296392
     /* 1296392 */   GIM_Try, /*On fail goto*//*Label 18625*/ GIMT_Encode4(1296476), // Rule ID 9105 //
     /* 1296397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1296414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296475 */     // GIR_Coverage, 9105,
     /* 1296475 */     GIR_EraseRootFromParent_Done,
     /* 1296476 */   // Label 18625: @1296476
     /* 1296476 */   GIM_Try, /*On fail goto*//*Label 18626*/ GIMT_Encode4(1296560), // Rule ID 9108 //
     /* 1296481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1296498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296534 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296559 */     // GIR_Coverage, 9108,
     /* 1296559 */     GIR_EraseRootFromParent_Done,
     /* 1296560 */   // Label 18626: @1296560
     /* 1296560 */   GIM_Try, /*On fail goto*//*Label 18627*/ GIMT_Encode4(1296644), // Rule ID 9109 //
     /* 1296565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1296568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1296576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1296579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1296582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1296588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296618 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1296621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296643 */     // GIR_Coverage, 9109,
     /* 1296643 */     GIR_EraseRootFromParent_Done,
     /* 1296644 */   // Label 18627: @1296644
     /* 1296644 */   GIM_Try, /*On fail goto*//*Label 18628*/ GIMT_Encode4(1296728), // Rule ID 9112 //
     /* 1296649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1296666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296702 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296727 */     // GIR_Coverage, 9112,
     /* 1296727 */     GIR_EraseRootFromParent_Done,
     /* 1296728 */   // Label 18628: @1296728
     /* 1296728 */   GIM_Try, /*On fail goto*//*Label 18629*/ GIMT_Encode4(1296812), // Rule ID 9113 //
     /* 1296733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1296736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1296750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296786 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1296789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296811 */     // GIR_Coverage, 9113,
     /* 1296811 */     GIR_EraseRootFromParent_Done,
     /* 1296812 */   // Label 18629: @1296812
     /* 1296812 */   GIM_Try, /*On fail goto*//*Label 18630*/ GIMT_Encode4(1296896), // Rule ID 9116 //
     /* 1296817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1296820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1296834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296870 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296895 */     // GIR_Coverage, 9116,
     /* 1296895 */     GIR_EraseRootFromParent_Done,
     /* 1296896 */   // Label 18630: @1296896
     /* 1296896 */   GIM_Try, /*On fail goto*//*Label 18631*/ GIMT_Encode4(1296980), // Rule ID 9117 //
     /* 1296901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1296904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1296909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1296918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296954 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1296957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1296975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296979 */     // GIR_Coverage, 9117,
     /* 1296979 */     GIR_EraseRootFromParent_Done,
     /* 1296980 */   // Label 18631: @1296980
     /* 1296980 */   GIM_Try, /*On fail goto*//*Label 18632*/ GIMT_Encode4(1297064), // Rule ID 9208 //
     /* 1296985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1296993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1296996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1296999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297038 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1297041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297063 */     // GIR_Coverage, 9208,
     /* 1297063 */     GIR_EraseRootFromParent_Done,
     /* 1297064 */   // Label 18632: @1297064
     /* 1297064 */   GIM_Try, /*On fail goto*//*Label 18633*/ GIMT_Encode4(1297148), // Rule ID 9209 //
     /* 1297069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1297086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297122 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1297125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297147 */     // GIR_Coverage, 9209,
     /* 1297147 */     GIR_EraseRootFromParent_Done,
     /* 1297148 */   // Label 18633: @1297148
     /* 1297148 */   GIM_Try, /*On fail goto*//*Label 18634*/ GIMT_Encode4(1297232), // Rule ID 9212 //
     /* 1297153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297206 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297231 */     // GIR_Coverage, 9212,
     /* 1297231 */     GIR_EraseRootFromParent_Done,
     /* 1297232 */   // Label 18634: @1297232
     /* 1297232 */   GIM_Try, /*On fail goto*//*Label 18635*/ GIMT_Encode4(1297316), // Rule ID 9213 //
     /* 1297237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297290 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297315 */     // GIR_Coverage, 9213,
     /* 1297315 */     GIR_EraseRootFromParent_Done,
     /* 1297316 */   // Label 18635: @1297316
     /* 1297316 */   GIM_Try, /*On fail goto*//*Label 18636*/ GIMT_Encode4(1297400), // Rule ID 9216 //
     /* 1297321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297374 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297399 */     // GIR_Coverage, 9216,
     /* 1297399 */     GIR_EraseRootFromParent_Done,
     /* 1297400 */   // Label 18636: @1297400
     /* 1297400 */   GIM_Try, /*On fail goto*//*Label 18637*/ GIMT_Encode4(1297484), // Rule ID 9217 //
     /* 1297405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297458 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297483 */     // GIR_Coverage, 9217,
     /* 1297483 */     GIR_EraseRootFromParent_Done,
     /* 1297484 */   // Label 18637: @1297484
     /* 1297484 */   GIM_Try, /*On fail goto*//*Label 18638*/ GIMT_Encode4(1297568), // Rule ID 9220 //
     /* 1297489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1297506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297542 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297567 */     // GIR_Coverage, 9220,
     /* 1297567 */     GIR_EraseRootFromParent_Done,
     /* 1297568 */   // Label 18638: @1297568
     /* 1297568 */   GIM_Try, /*On fail goto*//*Label 18639*/ GIMT_Encode4(1297652), // Rule ID 9221 //
     /* 1297573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1297590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297626 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1297629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297651 */     // GIR_Coverage, 9221,
     /* 1297651 */     GIR_EraseRootFromParent_Done,
     /* 1297652 */   // Label 18639: @1297652
     /* 1297652 */   GIM_Try, /*On fail goto*//*Label 18640*/ GIMT_Encode4(1297736), // Rule ID 9224 //
     /* 1297657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1297674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297710 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297735 */     // GIR_Coverage, 9224,
     /* 1297735 */     GIR_EraseRootFromParent_Done,
     /* 1297736 */   // Label 18640: @1297736
     /* 1297736 */   GIM_Try, /*On fail goto*//*Label 18641*/ GIMT_Encode4(1297820), // Rule ID 9225 //
     /* 1297741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1297758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297794 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1297815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297819 */     // GIR_Coverage, 9225,
     /* 1297819 */     GIR_EraseRootFromParent_Done,
     /* 1297820 */   // Label 18641: @1297820
     /* 1297820 */   GIM_Try, /*On fail goto*//*Label 18642*/ GIMT_Encode4(1297904), // Rule ID 9228 //
     /* 1297825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1297842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297878 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297903 */     // GIR_Coverage, 9228,
     /* 1297903 */     GIR_EraseRootFromParent_Done,
     /* 1297904 */   // Label 18642: @1297904
     /* 1297904 */   GIM_Try, /*On fail goto*//*Label 18643*/ GIMT_Encode4(1297988), // Rule ID 9229 //
     /* 1297909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1297920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1297923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1297926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1297932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297962 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1297965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297987 */     // GIR_Coverage, 9229,
     /* 1297987 */     GIR_EraseRootFromParent_Done,
     /* 1297988 */   // Label 18643: @1297988
     /* 1297988 */   GIM_Try, /*On fail goto*//*Label 18644*/ GIMT_Encode4(1298072), // Rule ID 9232 //
     /* 1297993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298046 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298071 */     // GIR_Coverage, 9232,
     /* 1298071 */     GIR_EraseRootFromParent_Done,
     /* 1298072 */   // Label 18644: @1298072
     /* 1298072 */   GIM_Try, /*On fail goto*//*Label 18645*/ GIMT_Encode4(1298156), // Rule ID 9233 //
     /* 1298077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298130 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298155 */     // GIR_Coverage, 9233,
     /* 1298155 */     GIR_EraseRootFromParent_Done,
     /* 1298156 */   // Label 18645: @1298156
     /* 1298156 */   GIM_Try, /*On fail goto*//*Label 18646*/ GIMT_Encode4(1298240), // Rule ID 9236 //
     /* 1298161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298214 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298239 */     // GIR_Coverage, 9236,
     /* 1298239 */     GIR_EraseRootFromParent_Done,
     /* 1298240 */   // Label 18646: @1298240
     /* 1298240 */   GIM_Try, /*On fail goto*//*Label 18647*/ GIMT_Encode4(1298324), // Rule ID 9237 //
     /* 1298245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298298 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298323 */     // GIR_Coverage, 9237,
     /* 1298323 */     GIR_EraseRootFromParent_Done,
     /* 1298324 */   // Label 18647: @1298324
     /* 1298324 */   GIM_Try, /*On fail goto*//*Label 18648*/ GIMT_Encode4(1298408), // Rule ID 9240 //
     /* 1298329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298382 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298407 */     // GIR_Coverage, 9240,
     /* 1298407 */     GIR_EraseRootFromParent_Done,
     /* 1298408 */   // Label 18648: @1298408
     /* 1298408 */   GIM_Try, /*On fail goto*//*Label 18649*/ GIMT_Encode4(1298492), // Rule ID 9241 //
     /* 1298413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298466 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298491 */     // GIR_Coverage, 9241,
     /* 1298491 */     GIR_EraseRootFromParent_Done,
     /* 1298492 */   // Label 18649: @1298492
     /* 1298492 */   GIM_Try, /*On fail goto*//*Label 18650*/ GIMT_Encode4(1298576), // Rule ID 9244 //
     /* 1298497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1298500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1298514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298550 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298575 */     // GIR_Coverage, 9244,
     /* 1298575 */     GIR_EraseRootFromParent_Done,
     /* 1298576 */   // Label 18650: @1298576
     /* 1298576 */   GIM_Try, /*On fail goto*//*Label 18651*/ GIMT_Encode4(1298660), // Rule ID 9245 //
     /* 1298581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1298584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1298598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298634 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1298637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1298655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298659 */     // GIR_Coverage, 9245,
     /* 1298659 */     GIR_EraseRootFromParent_Done,
     /* 1298660 */   // Label 18651: @1298660
     /* 1298660 */   GIM_Try, /*On fail goto*//*Label 18652*/ GIMT_Encode4(1298744), // Rule ID 9248 //
     /* 1298665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1298676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1298679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1298682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1298688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1298703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298718 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1298721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298743 */     // GIR_Coverage, 9248,
     /* 1298743 */     GIR_EraseRootFromParent_Done,
     /* 1298744 */   // Label 18652: @1298744
     /* 1298744 */   GIM_Try, /*On fail goto*//*Label 18653*/ GIMT_Encode4(1298828), // Rule ID 9249 //
     /* 1298749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1298760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1298763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1298766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1298772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1298787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298802 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1298805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298827 */     // GIR_Coverage, 9249,
     /* 1298827 */     GIR_EraseRootFromParent_Done,
     /* 1298828 */   // Label 18653: @1298828
     /* 1298828 */   GIM_Try, /*On fail goto*//*Label 18654*/ GIMT_Encode4(1298912), // Rule ID 9252 //
     /* 1298833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1298844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1298847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1298850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1298853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1298856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1298871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298886 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1298889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298911 */     // GIR_Coverage, 9252,
     /* 1298911 */     GIR_EraseRootFromParent_Done,
     /* 1298912 */   // Label 18654: @1298912
     /* 1298912 */   GIM_Try, /*On fail goto*//*Label 18655*/ GIMT_Encode4(1298996), // Rule ID 9253 //
     /* 1298917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1298928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1298931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1298934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1298937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1298940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1298955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1298959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298970 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1298973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1298979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1298981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298995 */     // GIR_Coverage, 9253,
     /* 1298995 */     GIR_EraseRootFromParent_Done,
     /* 1298996 */   // Label 18655: @1298996
     /* 1298996 */   GIM_Try, /*On fail goto*//*Label 18656*/ GIMT_Encode4(1299080), // Rule ID 9256 //
     /* 1299001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299054 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299079 */     // GIR_Coverage, 9256,
     /* 1299079 */     GIR_EraseRootFromParent_Done,
     /* 1299080 */   // Label 18656: @1299080
     /* 1299080 */   GIM_Try, /*On fail goto*//*Label 18657*/ GIMT_Encode4(1299164), // Rule ID 9257 //
     /* 1299085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299138 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299163 */     // GIR_Coverage, 9257,
     /* 1299163 */     GIR_EraseRootFromParent_Done,
     /* 1299164 */   // Label 18657: @1299164
     /* 1299164 */   GIM_Try, /*On fail goto*//*Label 18658*/ GIMT_Encode4(1299248), // Rule ID 9260 //
     /* 1299169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299222 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299247 */     // GIR_Coverage, 9260,
     /* 1299247 */     GIR_EraseRootFromParent_Done,
     /* 1299248 */   // Label 18658: @1299248
     /* 1299248 */   GIM_Try, /*On fail goto*//*Label 18659*/ GIMT_Encode4(1299332), // Rule ID 9261 //
     /* 1299253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299306 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299331 */     // GIR_Coverage, 9261,
     /* 1299331 */     GIR_EraseRootFromParent_Done,
     /* 1299332 */   // Label 18659: @1299332
     /* 1299332 */   GIM_Try, /*On fail goto*//*Label 18660*/ GIMT_Encode4(1299416), // Rule ID 9264 //
     /* 1299337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299390 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299415 */     // GIR_Coverage, 9264,
     /* 1299415 */     GIR_EraseRootFromParent_Done,
     /* 1299416 */   // Label 18660: @1299416
     /* 1299416 */   GIM_Try, /*On fail goto*//*Label 18661*/ GIMT_Encode4(1299500), // Rule ID 9265 //
     /* 1299421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299499 */     // GIR_Coverage, 9265,
     /* 1299499 */     GIR_EraseRootFromParent_Done,
     /* 1299500 */   // Label 18661: @1299500
     /* 1299500 */   GIM_Try, /*On fail goto*//*Label 18662*/ GIMT_Encode4(1299584), // Rule ID 9268 //
     /* 1299505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1299522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299558 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299583 */     // GIR_Coverage, 9268,
     /* 1299583 */     GIR_EraseRootFromParent_Done,
     /* 1299584 */   // Label 18662: @1299584
     /* 1299584 */   GIM_Try, /*On fail goto*//*Label 18663*/ GIMT_Encode4(1299668), // Rule ID 9269 //
     /* 1299589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1299606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299642 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1299645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299667 */     // GIR_Coverage, 9269,
     /* 1299667 */     GIR_EraseRootFromParent_Done,
     /* 1299668 */   // Label 18663: @1299668
     /* 1299668 */   GIM_Try, /*On fail goto*//*Label 18664*/ GIMT_Encode4(1299752), // Rule ID 9272 //
     /* 1299673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1299684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1299687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1299690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299726 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299751 */     // GIR_Coverage, 9272,
     /* 1299751 */     GIR_EraseRootFromParent_Done,
     /* 1299752 */   // Label 18664: @1299752
     /* 1299752 */   GIM_Try, /*On fail goto*//*Label 18665*/ GIMT_Encode4(1299836), // Rule ID 9273 //
     /* 1299757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1299768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1299771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1299774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1299780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1299813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299835 */     // GIR_Coverage, 9273,
     /* 1299835 */     GIR_EraseRootFromParent_Done,
     /* 1299836 */   // Label 18665: @1299836
     /* 1299836 */   GIM_Try, /*On fail goto*//*Label 18666*/ GIMT_Encode4(1299920), // Rule ID 9276 //
     /* 1299841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1299858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1299861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299919 */     // GIR_Coverage, 9276,
     /* 1299919 */     GIR_EraseRootFromParent_Done,
     /* 1299920 */   // Label 18666: @1299920
     /* 1299920 */   GIM_Try, /*On fail goto*//*Label 18667*/ GIMT_Encode4(1300004), // Rule ID 9277 //
     /* 1299925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1299942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1299945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1299967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299978 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1299981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1299987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1299989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300003 */     // GIR_Coverage, 9277,
     /* 1300003 */     GIR_EraseRootFromParent_Done,
     /* 1300004 */   // Label 18667: @1300004
     /* 1300004 */   GIM_Try, /*On fail goto*//*Label 18668*/ GIMT_Encode4(1300088), // Rule ID 9280 //
     /* 1300009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300062 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300087 */     // GIR_Coverage, 9280,
     /* 1300087 */     GIR_EraseRootFromParent_Done,
     /* 1300088 */   // Label 18668: @1300088
     /* 1300088 */   GIM_Try, /*On fail goto*//*Label 18669*/ GIMT_Encode4(1300172), // Rule ID 9281 //
     /* 1300093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300146 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300171 */     // GIR_Coverage, 9281,
     /* 1300171 */     GIR_EraseRootFromParent_Done,
     /* 1300172 */   // Label 18669: @1300172
     /* 1300172 */   GIM_Try, /*On fail goto*//*Label 18670*/ GIMT_Encode4(1300256), // Rule ID 9284 //
     /* 1300177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300230 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300255 */     // GIR_Coverage, 9284,
     /* 1300255 */     GIR_EraseRootFromParent_Done,
     /* 1300256 */   // Label 18670: @1300256
     /* 1300256 */   GIM_Try, /*On fail goto*//*Label 18671*/ GIMT_Encode4(1300340), // Rule ID 9285 //
     /* 1300261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300314 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1300317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300339 */     // GIR_Coverage, 9285,
     /* 1300339 */     GIR_EraseRootFromParent_Done,
     /* 1300340 */   // Label 18671: @1300340
     /* 1300340 */   GIM_Try, /*On fail goto*//*Label 18672*/ GIMT_Encode4(1300424), // Rule ID 9288 //
     /* 1300345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300398 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300423 */     // GIR_Coverage, 9288,
     /* 1300423 */     GIR_EraseRootFromParent_Done,
     /* 1300424 */   // Label 18672: @1300424
     /* 1300424 */   GIM_Try, /*On fail goto*//*Label 18673*/ GIMT_Encode4(1300508), // Rule ID 9289 //
     /* 1300429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1300446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300482 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1300485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300507 */     // GIR_Coverage, 9289,
     /* 1300507 */     GIR_EraseRootFromParent_Done,
     /* 1300508 */   // Label 18673: @1300508
     /* 1300508 */   GIM_Try, /*On fail goto*//*Label 18674*/ GIMT_Encode4(1300592), // Rule ID 9292 //
     /* 1300513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1300530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300566 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300591 */     // GIR_Coverage, 9292,
     /* 1300591 */     GIR_EraseRootFromParent_Done,
     /* 1300592 */   // Label 18674: @1300592
     /* 1300592 */   GIM_Try, /*On fail goto*//*Label 18675*/ GIMT_Encode4(1300676), // Rule ID 9293 //
     /* 1300597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1300614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1300653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300675 */     // GIR_Coverage, 9293,
     /* 1300675 */     GIR_EraseRootFromParent_Done,
     /* 1300676 */   // Label 18675: @1300676
     /* 1300676 */   GIM_Try, /*On fail goto*//*Label 18676*/ GIMT_Encode4(1300760), // Rule ID 9384 //
     /* 1300681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1300692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1300695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1300698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1300704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300734 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1300737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300759 */     // GIR_Coverage, 9384,
     /* 1300759 */     GIR_EraseRootFromParent_Done,
     /* 1300760 */   // Label 18676: @1300760
     /* 1300760 */   GIM_Try, /*On fail goto*//*Label 18677*/ GIMT_Encode4(1300844), // Rule ID 9385 //
     /* 1300765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1300776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1300779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1300782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1300788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300818 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1300821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300843 */     // GIR_Coverage, 9385,
     /* 1300843 */     GIR_EraseRootFromParent_Done,
     /* 1300844 */   // Label 18677: @1300844
     /* 1300844 */   GIM_Try, /*On fail goto*//*Label 18678*/ GIMT_Encode4(1300928), // Rule ID 9388 //
     /* 1300849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1300866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1300869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300902 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1300905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1300923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300927 */     // GIR_Coverage, 9388,
     /* 1300927 */     GIR_EraseRootFromParent_Done,
     /* 1300928 */   // Label 18678: @1300928
     /* 1300928 */   GIM_Try, /*On fail goto*//*Label 18679*/ GIMT_Encode4(1301012), // Rule ID 9389 //
     /* 1300933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1300941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1300950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1300953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1300975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1300989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1300995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1300997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301011 */     // GIR_Coverage, 9389,
     /* 1301011 */     GIR_EraseRootFromParent_Done,
     /* 1301012 */   // Label 18679: @1301012
     /* 1301012 */   GIM_Try, /*On fail goto*//*Label 18680*/ GIMT_Encode4(1301096), // Rule ID 9392 //
     /* 1301017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301070 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301095 */     // GIR_Coverage, 9392,
     /* 1301095 */     GIR_EraseRootFromParent_Done,
     /* 1301096 */   // Label 18680: @1301096
     /* 1301096 */   GIM_Try, /*On fail goto*//*Label 18681*/ GIMT_Encode4(1301180), // Rule ID 9393 //
     /* 1301101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301154 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301179 */     // GIR_Coverage, 9393,
     /* 1301179 */     GIR_EraseRootFromParent_Done,
     /* 1301180 */   // Label 18681: @1301180
     /* 1301180 */   GIM_Try, /*On fail goto*//*Label 18682*/ GIMT_Encode4(1301264), // Rule ID 9396 //
     /* 1301185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301238 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301263 */     // GIR_Coverage, 9396,
     /* 1301263 */     GIR_EraseRootFromParent_Done,
     /* 1301264 */   // Label 18682: @1301264
     /* 1301264 */   GIM_Try, /*On fail goto*//*Label 18683*/ GIMT_Encode4(1301348), // Rule ID 9397 //
     /* 1301269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301322 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1301325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301347 */     // GIR_Coverage, 9397,
     /* 1301347 */     GIR_EraseRootFromParent_Done,
     /* 1301348 */   // Label 18683: @1301348
     /* 1301348 */   GIM_Try, /*On fail goto*//*Label 18684*/ GIMT_Encode4(1301432), // Rule ID 9400 //
     /* 1301353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301431 */     // GIR_Coverage, 9400,
     /* 1301431 */     GIR_EraseRootFromParent_Done,
     /* 1301432 */   // Label 18684: @1301432
     /* 1301432 */   GIM_Try, /*On fail goto*//*Label 18685*/ GIMT_Encode4(1301516), // Rule ID 9401 //
     /* 1301437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1301454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301490 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301515 */     // GIR_Coverage, 9401,
     /* 1301515 */     GIR_EraseRootFromParent_Done,
     /* 1301516 */   // Label 18685: @1301516
     /* 1301516 */   GIM_Try, /*On fail goto*//*Label 18686*/ GIMT_Encode4(1301600), // Rule ID 9404 //
     /* 1301521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1301538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301574 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301599 */     // GIR_Coverage, 9404,
     /* 1301599 */     GIR_EraseRootFromParent_Done,
     /* 1301600 */   // Label 18686: @1301600
     /* 1301600 */   GIM_Try, /*On fail goto*//*Label 18687*/ GIMT_Encode4(1301684), // Rule ID 9405 //
     /* 1301605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1301622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1301661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1301679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301683 */     // GIR_Coverage, 9405,
     /* 1301683 */     GIR_EraseRootFromParent_Done,
     /* 1301684 */   // Label 18687: @1301684
     /* 1301684 */   GIM_Try, /*On fail goto*//*Label 18688*/ GIMT_Encode4(1301768), // Rule ID 9408 //
     /* 1301689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1301706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301742 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1301745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301767 */     // GIR_Coverage, 9408,
     /* 1301767 */     GIR_EraseRootFromParent_Done,
     /* 1301768 */   // Label 18688: @1301768
     /* 1301768 */   GIM_Try, /*On fail goto*//*Label 18689*/ GIMT_Encode4(1301852), // Rule ID 9409 //
     /* 1301773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1301790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301826 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1301829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301851 */     // GIR_Coverage, 9409,
     /* 1301851 */     GIR_EraseRootFromParent_Done,
     /* 1301852 */   // Label 18689: @1301852
     /* 1301852 */   GIM_Try, /*On fail goto*//*Label 18690*/ GIMT_Encode4(1301936), // Rule ID 9412 //
     /* 1301857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1301874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1301877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301910 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1301913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1301919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1301921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301935 */     // GIR_Coverage, 9412,
     /* 1301935 */     GIR_EraseRootFromParent_Done,
     /* 1301936 */   // Label 18690: @1301936
     /* 1301936 */   GIM_Try, /*On fail goto*//*Label 18691*/ GIMT_Encode4(1302020), // Rule ID 9413 //
     /* 1301941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1301958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1301961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1301983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301994 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1301997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302019 */     // GIR_Coverage, 9413,
     /* 1302019 */     GIR_EraseRootFromParent_Done,
     /* 1302020 */   // Label 18691: @1302020
     /* 1302020 */   GIM_Try, /*On fail goto*//*Label 18692*/ GIMT_Encode4(1302104), // Rule ID 9416 //
     /* 1302025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302078 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302103 */     // GIR_Coverage, 9416,
     /* 1302103 */     GIR_EraseRootFromParent_Done,
     /* 1302104 */   // Label 18692: @1302104
     /* 1302104 */   GIM_Try, /*On fail goto*//*Label 18693*/ GIMT_Encode4(1302188), // Rule ID 9417 //
     /* 1302109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302162 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302187 */     // GIR_Coverage, 9417,
     /* 1302187 */     GIR_EraseRootFromParent_Done,
     /* 1302188 */   // Label 18693: @1302188
     /* 1302188 */   GIM_Try, /*On fail goto*//*Label 18694*/ GIMT_Encode4(1302272), // Rule ID 9420 //
     /* 1302193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1302196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302246 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302271 */     // GIR_Coverage, 9420,
     /* 1302271 */     GIR_EraseRootFromParent_Done,
     /* 1302272 */   // Label 18694: @1302272
     /* 1302272 */   GIM_Try, /*On fail goto*//*Label 18695*/ GIMT_Encode4(1302356), // Rule ID 9421 //
     /* 1302277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1302280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1302333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302355 */     // GIR_Coverage, 9421,
     /* 1302355 */     GIR_EraseRootFromParent_Done,
     /* 1302356 */   // Label 18695: @1302356
     /* 1302356 */   GIM_Try, /*On fail goto*//*Label 18696*/ GIMT_Encode4(1302440), // Rule ID 9424 //
     /* 1302361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302439 */     // GIR_Coverage, 9424,
     /* 1302439 */     GIR_EraseRootFromParent_Done,
     /* 1302440 */   // Label 18696: @1302440
     /* 1302440 */   GIM_Try, /*On fail goto*//*Label 18697*/ GIMT_Encode4(1302524), // Rule ID 9425 //
     /* 1302445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1302456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1302459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1302462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1302468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302498 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302523 */     // GIR_Coverage, 9425,
     /* 1302523 */     GIR_EraseRootFromParent_Done,
     /* 1302524 */   // Label 18697: @1302524
     /* 1302524 */   GIM_Try, /*On fail goto*//*Label 18698*/ GIMT_Encode4(1302608), // Rule ID 9428 //
     /* 1302529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1302540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1302543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1302546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1302552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1302567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302582 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1302585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302607 */     // GIR_Coverage, 9428,
     /* 1302607 */     GIR_EraseRootFromParent_Done,
     /* 1302608 */   // Label 18698: @1302608
     /* 1302608 */   GIM_Try, /*On fail goto*//*Label 18699*/ GIMT_Encode4(1302692), // Rule ID 9429 //
     /* 1302613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1302624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1302627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1302630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1302636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1302651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302666 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1302669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302691 */     // GIR_Coverage, 9429,
     /* 1302691 */     GIR_EraseRootFromParent_Done,
     /* 1302692 */   // Label 18699: @1302692
     /* 1302692 */   GIM_Try, /*On fail goto*//*Label 18700*/ GIMT_Encode4(1302776), // Rule ID 9432 //
     /* 1302697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1302708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1302711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1302714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1302720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1302735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302750 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1302753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302775 */     // GIR_Coverage, 9432,
     /* 1302775 */     GIR_EraseRootFromParent_Done,
     /* 1302776 */   // Label 18700: @1302776
     /* 1302776 */   GIM_Try, /*On fail goto*//*Label 18701*/ GIMT_Encode4(1302860), // Rule ID 9433 //
     /* 1302781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1302792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1302795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1302798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1302804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1302819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302834 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1302837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302859 */     // GIR_Coverage, 9433,
     /* 1302859 */     GIR_EraseRootFromParent_Done,
     /* 1302860 */   // Label 18701: @1302860
     /* 1302860 */   GIM_Try, /*On fail goto*//*Label 18702*/ GIMT_Encode4(1302944), // Rule ID 9436 //
     /* 1302865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1302882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1302885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302918 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1302921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1302927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1302929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302943 */     // GIR_Coverage, 9436,
     /* 1302943 */     GIR_EraseRootFromParent_Done,
     /* 1302944 */   // Label 18702: @1302944
     /* 1302944 */   GIM_Try, /*On fail goto*//*Label 18703*/ GIMT_Encode4(1303028), // Rule ID 9437 //
     /* 1302949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1302966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1302969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1302987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1302991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303002 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303027 */     // GIR_Coverage, 9437,
     /* 1303027 */     GIR_EraseRootFromParent_Done,
     /* 1303028 */   // Label 18703: @1303028
     /* 1303028 */   GIM_Try, /*On fail goto*//*Label 18704*/ GIMT_Encode4(1303112), // Rule ID 9440 //
     /* 1303033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303086 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303111 */     // GIR_Coverage, 9440,
     /* 1303111 */     GIR_EraseRootFromParent_Done,
     /* 1303112 */   // Label 18704: @1303112
     /* 1303112 */   GIM_Try, /*On fail goto*//*Label 18705*/ GIMT_Encode4(1303196), // Rule ID 9441 //
     /* 1303117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303170 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303195 */     // GIR_Coverage, 9441,
     /* 1303195 */     GIR_EraseRootFromParent_Done,
     /* 1303196 */   // Label 18705: @1303196
     /* 1303196 */   GIM_Try, /*On fail goto*//*Label 18706*/ GIMT_Encode4(1303280), // Rule ID 9444 //
     /* 1303201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303254 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303279 */     // GIR_Coverage, 9444,
     /* 1303279 */     GIR_EraseRootFromParent_Done,
     /* 1303280 */   // Label 18706: @1303280
     /* 1303280 */   GIM_Try, /*On fail goto*//*Label 18707*/ GIMT_Encode4(1303364), // Rule ID 9445 //
     /* 1303285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303338 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303363 */     // GIR_Coverage, 9445,
     /* 1303363 */     GIR_EraseRootFromParent_Done,
     /* 1303364 */   // Label 18707: @1303364
     /* 1303364 */   GIM_Try, /*On fail goto*//*Label 18708*/ GIMT_Encode4(1303448), // Rule ID 9448 //
     /* 1303369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303422 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303447 */     // GIR_Coverage, 9448,
     /* 1303447 */     GIR_EraseRootFromParent_Done,
     /* 1303448 */   // Label 18708: @1303448
     /* 1303448 */   GIM_Try, /*On fail goto*//*Label 18709*/ GIMT_Encode4(1303532), // Rule ID 9449 //
     /* 1303453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1303464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1303467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1303470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1303476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303506 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303531 */     // GIR_Coverage, 9449,
     /* 1303531 */     GIR_EraseRootFromParent_Done,
     /* 1303532 */   // Label 18709: @1303532
     /* 1303532 */   GIM_Try, /*On fail goto*//*Label 18710*/ GIMT_Encode4(1303616), // Rule ID 9452 //
     /* 1303537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1303554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303615 */     // GIR_Coverage, 9452,
     /* 1303615 */     GIR_EraseRootFromParent_Done,
     /* 1303616 */   // Label 18710: @1303616
     /* 1303616 */   GIM_Try, /*On fail goto*//*Label 18711*/ GIMT_Encode4(1303700), // Rule ID 9453 //
     /* 1303621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1303638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303674 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1303677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303699 */     // GIR_Coverage, 9453,
     /* 1303699 */     GIR_EraseRootFromParent_Done,
     /* 1303700 */   // Label 18711: @1303700
     /* 1303700 */   GIM_Try, /*On fail goto*//*Label 18712*/ GIMT_Encode4(1303784), // Rule ID 9456 //
     /* 1303705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1303722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303758 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303783 */     // GIR_Coverage, 9456,
     /* 1303783 */     GIR_EraseRootFromParent_Done,
     /* 1303784 */   // Label 18712: @1303784
     /* 1303784 */   GIM_Try, /*On fail goto*//*Label 18713*/ GIMT_Encode4(1303868), // Rule ID 9457 //
     /* 1303789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1303806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303842 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1303845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1303863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303867 */     // GIR_Coverage, 9457,
     /* 1303867 */     GIR_EraseRootFromParent_Done,
     /* 1303868 */   // Label 18713: @1303868
     /* 1303868 */   GIM_Try, /*On fail goto*//*Label 18714*/ GIMT_Encode4(1303952), // Rule ID 9460 //
     /* 1303873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1303876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1303884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1303887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1303890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1303893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1303896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1303929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1303935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1303937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1303947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303951 */     // GIR_Coverage, 9460,
     /* 1303951 */     GIR_EraseRootFromParent_Done,
     /* 1303952 */   // Label 18714: @1303952
     /* 1303952 */   GIM_Try, /*On fail goto*//*Label 18715*/ GIMT_Encode4(1304036), // Rule ID 9461 //
     /* 1303957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1303960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1303968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1303971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1303974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1303977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1303980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1303999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304010 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1304013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304035 */     // GIR_Coverage, 9461,
     /* 1304035 */     GIR_EraseRootFromParent_Done,
     /* 1304036 */   // Label 18715: @1304036
     /* 1304036 */   GIM_Try, /*On fail goto*//*Label 18716*/ GIMT_Encode4(1304120), // Rule ID 9464 //
     /* 1304041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304094 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304119 */     // GIR_Coverage, 9464,
     /* 1304119 */     GIR_EraseRootFromParent_Done,
     /* 1304120 */   // Label 18716: @1304120
     /* 1304120 */   GIM_Try, /*On fail goto*//*Label 18717*/ GIMT_Encode4(1304204), // Rule ID 9465 //
     /* 1304125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304178 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1304181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304203 */     // GIR_Coverage, 9465,
     /* 1304203 */     GIR_EraseRootFromParent_Done,
     /* 1304204 */   // Label 18717: @1304204
     /* 1304204 */   GIM_Try, /*On fail goto*//*Label 18718*/ GIMT_Encode4(1304288), // Rule ID 9468 //
     /* 1304209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1304229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304287 */     // GIR_Coverage, 9468,
     /* 1304287 */     GIR_EraseRootFromParent_Done,
     /* 1304288 */   // Label 18718: @1304288
     /* 1304288 */   GIM_Try, /*On fail goto*//*Label 18719*/ GIMT_Encode4(1304372), // Rule ID 9469 //
     /* 1304293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1304313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1304335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304346 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1304349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1304355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1304357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304371 */     // GIR_Coverage, 9469,
     /* 1304371 */     GIR_EraseRootFromParent_Done,
     /* 1304372 */   // Label 18719: @1304372
     /* 1304372 */   GIM_Try, /*On fail goto*//*Label 18720*/ GIMT_Encode4(1304456), // Rule ID 9560 //
     /* 1304377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1304397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304430 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304455 */     // GIR_Coverage, 9560,
     /* 1304455 */     GIR_EraseRootFromParent_Done,
     /* 1304456 */   // Label 18720: @1304456
     /* 1304456 */   GIM_Try, /*On fail goto*//*Label 18721*/ GIMT_Encode4(1304540), // Rule ID 9561 //
     /* 1304461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1304478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1304481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304514 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304539 */     // GIR_Coverage, 9561,
     /* 1304539 */     GIR_EraseRootFromParent_Done,
     /* 1304540 */   // Label 18721: @1304540
     /* 1304540 */   GIM_Try, /*On fail goto*//*Label 18722*/ GIMT_Encode4(1304624), // Rule ID 9564 //
     /* 1304545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1304562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1304565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304598 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1304601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304623 */     // GIR_Coverage, 9564,
     /* 1304623 */     GIR_EraseRootFromParent_Done,
     /* 1304624 */   // Label 18722: @1304624
     /* 1304624 */   GIM_Try, /*On fail goto*//*Label 18723*/ GIMT_Encode4(1304708), // Rule ID 9565 //
     /* 1304629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1304646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1304649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304682 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1304685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1304703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304707 */     // GIR_Coverage, 9565,
     /* 1304707 */     GIR_EraseRootFromParent_Done,
     /* 1304708 */   // Label 18723: @1304708
     /* 1304708 */   GIM_Try, /*On fail goto*//*Label 18724*/ GIMT_Encode4(1304792), // Rule ID 9568 //
     /* 1304713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1304724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1304727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1304730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1304733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1304736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304766 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304791 */     // GIR_Coverage, 9568,
     /* 1304791 */     GIR_EraseRootFromParent_Done,
     /* 1304792 */   // Label 18724: @1304792
     /* 1304792 */   GIM_Try, /*On fail goto*//*Label 18725*/ GIMT_Encode4(1304876), // Rule ID 9569 //
     /* 1304797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1304808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1304811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1304814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1304817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1304820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1304853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304875 */     // GIR_Coverage, 9569,
     /* 1304875 */     GIR_EraseRootFromParent_Done,
     /* 1304876 */   // Label 18725: @1304876
     /* 1304876 */   GIM_Try, /*On fail goto*//*Label 18726*/ GIMT_Encode4(1304960), // Rule ID 9572 //
     /* 1304881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1304898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1304901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304934 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1304937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1304955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304959 */     // GIR_Coverage, 9572,
     /* 1304959 */     GIR_EraseRootFromParent_Done,
     /* 1304960 */   // Label 18726: @1304960
     /* 1304960 */   GIM_Try, /*On fail goto*//*Label 18727*/ GIMT_Encode4(1305044), // Rule ID 9573 //
     /* 1304965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1304973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1304982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1304985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305018 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305043 */     // GIR_Coverage, 9573,
     /* 1305043 */     GIR_EraseRootFromParent_Done,
     /* 1305044 */   // Label 18727: @1305044
     /* 1305044 */   GIM_Try, /*On fail goto*//*Label 18728*/ GIMT_Encode4(1305128), // Rule ID 9576 //
     /* 1305049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305127 */     // GIR_Coverage, 9576,
     /* 1305127 */     GIR_EraseRootFromParent_Done,
     /* 1305128 */   // Label 18728: @1305128
     /* 1305128 */   GIM_Try, /*On fail goto*//*Label 18729*/ GIMT_Encode4(1305212), // Rule ID 9577 //
     /* 1305133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305186 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1305189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305211 */     // GIR_Coverage, 9577,
     /* 1305211 */     GIR_EraseRootFromParent_Done,
     /* 1305212 */   // Label 18729: @1305212
     /* 1305212 */   GIM_Try, /*On fail goto*//*Label 18730*/ GIMT_Encode4(1305296), // Rule ID 9580 //
     /* 1305217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1305237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305270 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305295 */     // GIR_Coverage, 9580,
     /* 1305295 */     GIR_EraseRootFromParent_Done,
     /* 1305296 */   // Label 18730: @1305296
     /* 1305296 */   GIM_Try, /*On fail goto*//*Label 18731*/ GIMT_Encode4(1305380), // Rule ID 9581 //
     /* 1305301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1305312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1305315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1305318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1305321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1305324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305354 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305379 */     // GIR_Coverage, 9581,
     /* 1305379 */     GIR_EraseRootFromParent_Done,
     /* 1305380 */   // Label 18731: @1305380
     /* 1305380 */   GIM_Try, /*On fail goto*//*Label 18732*/ GIMT_Encode4(1305464), // Rule ID 9584 //
     /* 1305385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1305405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305463 */     // GIR_Coverage, 9584,
     /* 1305463 */     GIR_EraseRootFromParent_Done,
     /* 1305464 */   // Label 18732: @1305464
     /* 1305464 */   GIM_Try, /*On fail goto*//*Label 18733*/ GIMT_Encode4(1305548), // Rule ID 9585 //
     /* 1305469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1305486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1305489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305522 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305547 */     // GIR_Coverage, 9585,
     /* 1305547 */     GIR_EraseRootFromParent_Done,
     /* 1305548 */   // Label 18733: @1305548
     /* 1305548 */   GIM_Try, /*On fail goto*//*Label 18734*/ GIMT_Encode4(1305632), // Rule ID 9588 //
     /* 1305553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1305570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1305573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305606 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305631 */     // GIR_Coverage, 9588,
     /* 1305631 */     GIR_EraseRootFromParent_Done,
     /* 1305632 */   // Label 18734: @1305632
     /* 1305632 */   GIM_Try, /*On fail goto*//*Label 18735*/ GIMT_Encode4(1305716), // Rule ID 9589 //
     /* 1305637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1305654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1305657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305690 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305715 */     // GIR_Coverage, 9589,
     /* 1305715 */     GIR_EraseRootFromParent_Done,
     /* 1305716 */   // Label 18735: @1305716
     /* 1305716 */   GIM_Try, /*On fail goto*//*Label 18736*/ GIMT_Encode4(1305800), // Rule ID 9592 //
     /* 1305721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1305724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1305738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1305741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305774 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305799 */     // GIR_Coverage, 9592,
     /* 1305799 */     GIR_EraseRootFromParent_Done,
     /* 1305800 */   // Label 18736: @1305800
     /* 1305800 */   GIM_Try, /*On fail goto*//*Label 18737*/ GIMT_Encode4(1305884), // Rule ID 9593 //
     /* 1305805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1305808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1305822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1305825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305858 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1305861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305883 */     // GIR_Coverage, 9593,
     /* 1305883 */     GIR_EraseRootFromParent_Done,
     /* 1305884 */   // Label 18737: @1305884
     /* 1305884 */   GIM_Try, /*On fail goto*//*Label 18738*/ GIMT_Encode4(1305968), // Rule ID 9596 //
     /* 1305889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1305900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1305903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1305906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1305909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1305912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1305927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1305931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305942 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1305945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305967 */     // GIR_Coverage, 9596,
     /* 1305967 */     GIR_EraseRootFromParent_Done,
     /* 1305968 */   // Label 18738: @1305968
     /* 1305968 */   GIM_Try, /*On fail goto*//*Label 18739*/ GIMT_Encode4(1306052), // Rule ID 9597 //
     /* 1305973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1305981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1305984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1305987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1305990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1305993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1305996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306026 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306051 */     // GIR_Coverage, 9597,
     /* 1306051 */     GIR_EraseRootFromParent_Done,
     /* 1306052 */   // Label 18739: @1306052
     /* 1306052 */   GIM_Try, /*On fail goto*//*Label 18740*/ GIMT_Encode4(1306136), // Rule ID 9600 //
     /* 1306057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306110 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306135 */     // GIR_Coverage, 9600,
     /* 1306135 */     GIR_EraseRootFromParent_Done,
     /* 1306136 */   // Label 18740: @1306136
     /* 1306136 */   GIM_Try, /*On fail goto*//*Label 18741*/ GIMT_Encode4(1306220), // Rule ID 9601 //
     /* 1306141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306194 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306219 */     // GIR_Coverage, 9601,
     /* 1306219 */     GIR_EraseRootFromParent_Done,
     /* 1306220 */   // Label 18741: @1306220
     /* 1306220 */   GIM_Try, /*On fail goto*//*Label 18742*/ GIMT_Encode4(1306304), // Rule ID 9604 //
     /* 1306225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1306245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306278 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306303 */     // GIR_Coverage, 9604,
     /* 1306303 */     GIR_EraseRootFromParent_Done,
     /* 1306304 */   // Label 18742: @1306304
     /* 1306304 */   GIM_Try, /*On fail goto*//*Label 18743*/ GIMT_Encode4(1306388), // Rule ID 9605 //
     /* 1306309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1306320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1306323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1306326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1306329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1306332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306362 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306387 */     // GIR_Coverage, 9605,
     /* 1306387 */     GIR_EraseRootFromParent_Done,
     /* 1306388 */   // Label 18743: @1306388
     /* 1306388 */   GIM_Try, /*On fail goto*//*Label 18744*/ GIMT_Encode4(1306472), // Rule ID 9608 //
     /* 1306393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1306413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306446 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306471 */     // GIR_Coverage, 9608,
     /* 1306471 */     GIR_EraseRootFromParent_Done,
     /* 1306472 */   // Label 18744: @1306472
     /* 1306472 */   GIM_Try, /*On fail goto*//*Label 18745*/ GIMT_Encode4(1306556), // Rule ID 9609 //
     /* 1306477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1306494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1306497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306530 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306555 */     // GIR_Coverage, 9609,
     /* 1306555 */     GIR_EraseRootFromParent_Done,
     /* 1306556 */   // Label 18745: @1306556
     /* 1306556 */   GIM_Try, /*On fail goto*//*Label 18746*/ GIMT_Encode4(1306640), // Rule ID 9612 //
     /* 1306561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1306578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1306581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306614 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306639 */     // GIR_Coverage, 9612,
     /* 1306639 */     GIR_EraseRootFromParent_Done,
     /* 1306640 */   // Label 18746: @1306640
     /* 1306640 */   GIM_Try, /*On fail goto*//*Label 18747*/ GIMT_Encode4(1306724), // Rule ID 9613 //
     /* 1306645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1306662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1306665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306698 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1306701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306723 */     // GIR_Coverage, 9613,
     /* 1306723 */     GIR_EraseRootFromParent_Done,
     /* 1306724 */   // Label 18747: @1306724
     /* 1306724 */   GIM_Try, /*On fail goto*//*Label 18748*/ GIMT_Encode4(1306808), // Rule ID 9616 //
     /* 1306729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1306746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1306749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306782 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306807 */     // GIR_Coverage, 9616,
     /* 1306807 */     GIR_EraseRootFromParent_Done,
     /* 1306808 */   // Label 18748: @1306808
     /* 1306808 */   GIM_Try, /*On fail goto*//*Label 18749*/ GIMT_Encode4(1306892), // Rule ID 9617 //
     /* 1306813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1306830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1306833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1306855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306866 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1306869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306891 */     // GIR_Coverage, 9617,
     /* 1306891 */     GIR_EraseRootFromParent_Done,
     /* 1306892 */   // Label 18749: @1306892
     /* 1306892 */   GIM_Try, /*On fail goto*//*Label 18750*/ GIMT_Encode4(1306976), // Rule ID 9620 //
     /* 1306897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1306908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1306911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1306914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1306917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1306920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306950 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1306953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306975 */     // GIR_Coverage, 9620,
     /* 1306975 */     GIR_EraseRootFromParent_Done,
     /* 1306976 */   // Label 18750: @1306976
     /* 1306976 */   GIM_Try, /*On fail goto*//*Label 18751*/ GIMT_Encode4(1307060), // Rule ID 9621 //
     /* 1306981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1306989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1306992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1306995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1306998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1307001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307059 */     // GIR_Coverage, 9621,
     /* 1307059 */     GIR_EraseRootFromParent_Done,
     /* 1307060 */   // Label 18751: @1307060
     /* 1307060 */   GIM_Try, /*On fail goto*//*Label 18752*/ GIMT_Encode4(1307144), // Rule ID 9624 //
     /* 1307065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307118 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307143 */     // GIR_Coverage, 9624,
     /* 1307143 */     GIR_EraseRootFromParent_Done,
     /* 1307144 */   // Label 18752: @1307144
     /* 1307144 */   GIM_Try, /*On fail goto*//*Label 18753*/ GIMT_Encode4(1307228), // Rule ID 9625 //
     /* 1307149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307202 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307227 */     // GIR_Coverage, 9625,
     /* 1307227 */     GIR_EraseRootFromParent_Done,
     /* 1307228 */   // Label 18753: @1307228
     /* 1307228 */   GIM_Try, /*On fail goto*//*Label 18754*/ GIMT_Encode4(1307312), // Rule ID 9628 //
     /* 1307233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1307253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307286 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307311 */     // GIR_Coverage, 9628,
     /* 1307311 */     GIR_EraseRootFromParent_Done,
     /* 1307312 */   // Label 18754: @1307312
     /* 1307312 */   GIM_Try, /*On fail goto*//*Label 18755*/ GIMT_Encode4(1307396), // Rule ID 9629 //
     /* 1307317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1307334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1307337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307370 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307395 */     // GIR_Coverage, 9629,
     /* 1307395 */     GIR_EraseRootFromParent_Done,
     /* 1307396 */   // Label 18755: @1307396
     /* 1307396 */   GIM_Try, /*On fail goto*//*Label 18756*/ GIMT_Encode4(1307480), // Rule ID 9632 //
     /* 1307401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1307421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307454 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307479 */     // GIR_Coverage, 9632,
     /* 1307479 */     GIR_EraseRootFromParent_Done,
     /* 1307480 */   // Label 18756: @1307480
     /* 1307480 */   GIM_Try, /*On fail goto*//*Label 18757*/ GIMT_Encode4(1307564), // Rule ID 9633 //
     /* 1307485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1307496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1307499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1307502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1307505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1307508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307538 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1307541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307563 */     // GIR_Coverage, 9633,
     /* 1307563 */     GIR_EraseRootFromParent_Done,
     /* 1307564 */   // Label 18757: @1307564
     /* 1307564 */   GIM_Try, /*On fail goto*//*Label 18758*/ GIMT_Encode4(1307648), // Rule ID 9636 //
     /* 1307569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1307586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1307589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307622 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307647 */     // GIR_Coverage, 9636,
     /* 1307647 */     GIR_EraseRootFromParent_Done,
     /* 1307648 */   // Label 18758: @1307648
     /* 1307648 */   GIM_Try, /*On fail goto*//*Label 18759*/ GIMT_Encode4(1307732), // Rule ID 9637 //
     /* 1307653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1307670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1307673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307706 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1307709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307731 */     // GIR_Coverage, 9637,
     /* 1307731 */     GIR_EraseRootFromParent_Done,
     /* 1307732 */   // Label 18759: @1307732
     /* 1307732 */   GIM_Try, /*On fail goto*//*Label 18760*/ GIMT_Encode4(1307816), // Rule ID 9640 //
     /* 1307737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1307740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1307754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1307757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307790 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307815 */     // GIR_Coverage, 9640,
     /* 1307815 */     GIR_EraseRootFromParent_Done,
     /* 1307816 */   // Label 18760: @1307816
     /* 1307816 */   GIM_Try, /*On fail goto*//*Label 18761*/ GIMT_Encode4(1307900), // Rule ID 9641 //
     /* 1307821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1307824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1307829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1307838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1307841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307874 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1307877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1307895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307899 */     // GIR_Coverage, 9641,
     /* 1307899 */     GIR_EraseRootFromParent_Done,
     /* 1307900 */   // Label 18761: @1307900
     /* 1307900 */   GIM_Try, /*On fail goto*//*Label 18762*/ GIMT_Encode4(1307984), // Rule ID 9644 //
     /* 1307905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1307916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1307919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1307922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1307925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1307928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307958 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1307961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307983 */     // GIR_Coverage, 9644,
     /* 1307983 */     GIR_EraseRootFromParent_Done,
     /* 1307984 */   // Label 18762: @1307984
     /* 1307984 */   GIM_Try, /*On fail goto*//*Label 18763*/ GIMT_Encode4(1308068), // Rule ID 9645 //
     /* 1307989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1307997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1308006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1308009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308042 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1308045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308067 */     // GIR_Coverage, 9645,
     /* 1308067 */     GIR_EraseRootFromParent_Done,
     /* 1308068 */   // Label 18763: @1308068
     /* 1308068 */   GIM_Try, /*On fail goto*//*Label 18764*/ GIMT_Encode4(1308152), // Rule ID 9648 //
     /* 1308073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308126 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308151 */     // GIR_Coverage, 9648,
     /* 1308151 */     GIR_EraseRootFromParent_Done,
     /* 1308152 */   // Label 18764: @1308152
     /* 1308152 */   GIM_Try, /*On fail goto*//*Label 18765*/ GIMT_Encode4(1308236), // Rule ID 9649 //
     /* 1308157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308210 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308235 */     // GIR_Coverage, 9649,
     /* 1308235 */     GIR_EraseRootFromParent_Done,
     /* 1308236 */   // Label 18765: @1308236
     /* 1308236 */   GIM_Try, /*On fail goto*//*Label 18766*/ GIMT_Encode4(1308320), // Rule ID 9652 //
     /* 1308241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308294 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308319 */     // GIR_Coverage, 9652,
     /* 1308319 */     GIR_EraseRootFromParent_Done,
     /* 1308320 */   // Label 18766: @1308320
     /* 1308320 */   GIM_Try, /*On fail goto*//*Label 18767*/ GIMT_Encode4(1308404), // Rule ID 9653 //
     /* 1308325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1308342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1308345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308378 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308403 */     // GIR_Coverage, 9653,
     /* 1308403 */     GIR_EraseRootFromParent_Done,
     /* 1308404 */   // Label 18767: @1308404
     /* 1308404 */   GIM_Try, /*On fail goto*//*Label 18768*/ GIMT_Encode4(1308488), // Rule ID 9656 //
     /* 1308409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308462 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308487 */     // GIR_Coverage, 9656,
     /* 1308487 */     GIR_EraseRootFromParent_Done,
     /* 1308488 */   // Label 18768: @1308488
     /* 1308488 */   GIM_Try, /*On fail goto*//*Label 18769*/ GIMT_Encode4(1308572), // Rule ID 9657 //
     /* 1308493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1308510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1308513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308546 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1308549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308571 */     // GIR_Coverage, 9657,
     /* 1308571 */     GIR_EraseRootFromParent_Done,
     /* 1308572 */   // Label 18769: @1308572
     /* 1308572 */   GIM_Try, /*On fail goto*//*Label 18770*/ GIMT_Encode4(1308656), // Rule ID 9660 //
     /* 1308577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1308594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1308597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308630 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308655 */     // GIR_Coverage, 9660,
     /* 1308655 */     GIR_EraseRootFromParent_Done,
     /* 1308656 */   // Label 18770: @1308656
     /* 1308656 */   GIM_Try, /*On fail goto*//*Label 18771*/ GIMT_Encode4(1308740), // Rule ID 9661 //
     /* 1308661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1308678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1308681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308714 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1308735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308739 */     // GIR_Coverage, 9661,
     /* 1308739 */     GIR_EraseRootFromParent_Done,
     /* 1308740 */   // Label 18771: @1308740
     /* 1308740 */   GIM_Try, /*On fail goto*//*Label 18772*/ GIMT_Encode4(1308824), // Rule ID 9664 //
     /* 1308745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1308762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1308765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308798 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308823 */     // GIR_Coverage, 9664,
     /* 1308823 */     GIR_EraseRootFromParent_Done,
     /* 1308824 */   // Label 18772: @1308824
     /* 1308824 */   GIM_Try, /*On fail goto*//*Label 18773*/ GIMT_Encode4(1308908), // Rule ID 9665 //
     /* 1308829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1308846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1308849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308882 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1308885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308907 */     // GIR_Coverage, 9665,
     /* 1308907 */     GIR_EraseRootFromParent_Done,
     /* 1308908 */   // Label 18773: @1308908
     /* 1308908 */   GIM_Try, /*On fail goto*//*Label 18774*/ GIMT_Encode4(1308992), // Rule ID 9668 //
     /* 1308913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1308921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1308930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1308933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308966 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1308969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308991 */     // GIR_Coverage, 9668,
     /* 1308991 */     GIR_EraseRootFromParent_Done,
     /* 1308992 */   // Label 18774: @1308992
     /* 1308992 */   GIM_Try, /*On fail goto*//*Label 18775*/ GIMT_Encode4(1309076), // Rule ID 9669 //
     /* 1308997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309050 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309075 */     // GIR_Coverage, 9669,
     /* 1309075 */     GIR_EraseRootFromParent_Done,
     /* 1309076 */   // Label 18775: @1309076
     /* 1309076 */   GIM_Try, /*On fail goto*//*Label 18776*/ GIMT_Encode4(1309160), // Rule ID 9672 //
     /* 1309081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309159 */     // GIR_Coverage, 9672,
     /* 1309159 */     GIR_EraseRootFromParent_Done,
     /* 1309160 */   // Label 18776: @1309160
     /* 1309160 */   GIM_Try, /*On fail goto*//*Label 18777*/ GIMT_Encode4(1309244), // Rule ID 9673 //
     /* 1309165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309218 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309243 */     // GIR_Coverage, 9673,
     /* 1309243 */     GIR_EraseRootFromParent_Done,
     /* 1309244 */   // Label 18777: @1309244
     /* 1309244 */   GIM_Try, /*On fail goto*//*Label 18778*/ GIMT_Encode4(1309328), // Rule ID 9676 //
     /* 1309249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309327 */     // GIR_Coverage, 9676,
     /* 1309327 */     GIR_EraseRootFromParent_Done,
     /* 1309328 */   // Label 18778: @1309328
     /* 1309328 */   GIM_Try, /*On fail goto*//*Label 18779*/ GIMT_Encode4(1309412), // Rule ID 9677 //
     /* 1309333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1309350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1309353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309386 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309411 */     // GIR_Coverage, 9677,
     /* 1309411 */     GIR_EraseRootFromParent_Done,
     /* 1309412 */   // Label 18779: @1309412
     /* 1309412 */   GIM_Try, /*On fail goto*//*Label 18780*/ GIMT_Encode4(1309496), // Rule ID 9680 //
     /* 1309417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1309420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309495 */     // GIR_Coverage, 9680,
     /* 1309495 */     GIR_EraseRootFromParent_Done,
     /* 1309496 */   // Label 18780: @1309496
     /* 1309496 */   GIM_Try, /*On fail goto*//*Label 18781*/ GIMT_Encode4(1309580), // Rule ID 9681 //
     /* 1309501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1309504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1309518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1309521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309554 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1309557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1309575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309579 */     // GIR_Coverage, 9681,
     /* 1309579 */     GIR_EraseRootFromParent_Done,
     /* 1309580 */   // Label 18781: @1309580
     /* 1309580 */   GIM_Try, /*On fail goto*//*Label 18782*/ GIMT_Encode4(1309664), // Rule ID 9684 //
     /* 1309585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1309596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1309599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1309602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1309605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1309608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309638 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1309641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309663 */     // GIR_Coverage, 9684,
     /* 1309663 */     GIR_EraseRootFromParent_Done,
     /* 1309664 */   // Label 18782: @1309664
     /* 1309664 */   GIM_Try, /*On fail goto*//*Label 18783*/ GIMT_Encode4(1309748), // Rule ID 9685 //
     /* 1309669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1309680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1309683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1309686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1309689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1309692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1309711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309722 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1309725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309747 */     // GIR_Coverage, 9685,
     /* 1309747 */     GIR_EraseRootFromParent_Done,
     /* 1309748 */   // Label 18783: @1309748
     /* 1309748 */   GIM_Try, /*On fail goto*//*Label 18784*/ GIMT_Encode4(1309832), // Rule ID 9688 //
     /* 1309753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1309764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1309767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1309770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1309773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1309776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309806 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1309809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309831 */     // GIR_Coverage, 9688,
     /* 1309831 */     GIR_EraseRootFromParent_Done,
     /* 1309832 */   // Label 18784: @1309832
     /* 1309832 */   GIM_Try, /*On fail goto*//*Label 18785*/ GIMT_Encode4(1309916), // Rule ID 9689 //
     /* 1309837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1309848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1309851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1309854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1309857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1309860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1309879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309890 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1309893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309915 */     // GIR_Coverage, 9689,
     /* 1309915 */     GIR_EraseRootFromParent_Done,
     /* 1309916 */   // Label 18785: @1309916
     /* 1309916 */   GIM_Try, /*On fail goto*//*Label 18786*/ GIMT_Encode4(1310000), // Rule ID 9692 //
     /* 1309921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1309929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1309932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1309935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1309938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1309941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1309944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1309963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309974 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1309977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309999 */     // GIR_Coverage, 9692,
     /* 1309999 */     GIR_EraseRootFromParent_Done,
     /* 1310000 */   // Label 18786: @1310000
     /* 1310000 */   GIM_Try, /*On fail goto*//*Label 18787*/ GIMT_Encode4(1310084), // Rule ID 9693 //
     /* 1310005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310058 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310083 */     // GIR_Coverage, 9693,
     /* 1310083 */     GIR_EraseRootFromParent_Done,
     /* 1310084 */   // Label 18787: @1310084
     /* 1310084 */   GIM_Try, /*On fail goto*//*Label 18788*/ GIMT_Encode4(1310168), // Rule ID 9696 //
     /* 1310089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310142 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310167 */     // GIR_Coverage, 9696,
     /* 1310167 */     GIR_EraseRootFromParent_Done,
     /* 1310168 */   // Label 18788: @1310168
     /* 1310168 */   GIM_Try, /*On fail goto*//*Label 18789*/ GIMT_Encode4(1310252), // Rule ID 9697 //
     /* 1310173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310226 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310251 */     // GIR_Coverage, 9697,
     /* 1310251 */     GIR_EraseRootFromParent_Done,
     /* 1310252 */   // Label 18789: @1310252
     /* 1310252 */   GIM_Try, /*On fail goto*//*Label 18790*/ GIMT_Encode4(1310336), // Rule ID 9700 //
     /* 1310257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310310 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310335 */     // GIR_Coverage, 9700,
     /* 1310335 */     GIR_EraseRootFromParent_Done,
     /* 1310336 */   // Label 18790: @1310336
     /* 1310336 */   GIM_Try, /*On fail goto*//*Label 18791*/ GIMT_Encode4(1310420), // Rule ID 9701 //
     /* 1310341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1310358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1310361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310394 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310419 */     // GIR_Coverage, 9701,
     /* 1310419 */     GIR_EraseRootFromParent_Done,
     /* 1310420 */   // Label 18791: @1310420
     /* 1310420 */   GIM_Try, /*On fail goto*//*Label 18792*/ GIMT_Encode4(1310504), // Rule ID 9704 //
     /* 1310425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1310442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1310445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310478 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310503 */     // GIR_Coverage, 9704,
     /* 1310503 */     GIR_EraseRootFromParent_Done,
     /* 1310504 */   // Label 18792: @1310504
     /* 1310504 */   GIM_Try, /*On fail goto*//*Label 18793*/ GIMT_Encode4(1310588), // Rule ID 9705 //
     /* 1310509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1310526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1310529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310562 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310587 */     // GIR_Coverage, 9705,
     /* 1310587 */     GIR_EraseRootFromParent_Done,
     /* 1310588 */   // Label 18793: @1310588
     /* 1310588 */   GIM_Try, /*On fail goto*//*Label 18794*/ GIMT_Encode4(1310672), // Rule ID 9708 //
     /* 1310593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1310604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1310607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1310610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1310613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1310616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310646 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310671 */     // GIR_Coverage, 9708,
     /* 1310671 */     GIR_EraseRootFromParent_Done,
     /* 1310672 */   // Label 18794: @1310672
     /* 1310672 */   GIM_Try, /*On fail goto*//*Label 18795*/ GIMT_Encode4(1310756), // Rule ID 9709 //
     /* 1310677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1310688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1310691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1310694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1310697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1310700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310730 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1310733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310755 */     // GIR_Coverage, 9709,
     /* 1310755 */     GIR_EraseRootFromParent_Done,
     /* 1310756 */   // Label 18795: @1310756
     /* 1310756 */   GIM_Try, /*On fail goto*//*Label 18796*/ GIMT_Encode4(1310840), // Rule ID 9712 //
     /* 1310761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1310778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1310781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310814 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310839 */     // GIR_Coverage, 9712,
     /* 1310839 */     GIR_EraseRootFromParent_Done,
     /* 1310840 */   // Label 18796: @1310840
     /* 1310840 */   GIM_Try, /*On fail goto*//*Label 18797*/ GIMT_Encode4(1310924), // Rule ID 9713 //
     /* 1310845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1310862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1310865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310898 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1310901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310923 */     // GIR_Coverage, 9713,
     /* 1310923 */     GIR_EraseRootFromParent_Done,
     /* 1310924 */   // Label 18797: @1310924
     /* 1310924 */   GIM_Try, /*On fail goto*//*Label 18798*/ GIMT_Encode4(1311008), // Rule ID 9716 //
     /* 1310929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1310937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1310946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1310949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310982 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1310985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311007 */     // GIR_Coverage, 9716,
     /* 1311007 */     GIR_EraseRootFromParent_Done,
     /* 1311008 */   // Label 18798: @1311008
     /* 1311008 */   GIM_Try, /*On fail goto*//*Label 18799*/ GIMT_Encode4(1311092), // Rule ID 9717 //
     /* 1311013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311066 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311091 */     // GIR_Coverage, 9717,
     /* 1311091 */     GIR_EraseRootFromParent_Done,
     /* 1311092 */   // Label 18799: @1311092
     /* 1311092 */   GIM_Try, /*On fail goto*//*Label 18800*/ GIMT_Encode4(1311176), // Rule ID 9720 //
     /* 1311097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311175 */     // GIR_Coverage, 9720,
     /* 1311175 */     GIR_EraseRootFromParent_Done,
     /* 1311176 */   // Label 18800: @1311176
     /* 1311176 */   GIM_Try, /*On fail goto*//*Label 18801*/ GIMT_Encode4(1311260), // Rule ID 9721 //
     /* 1311181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311234 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1311237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311259 */     // GIR_Coverage, 9721,
     /* 1311259 */     GIR_EraseRootFromParent_Done,
     /* 1311260 */   // Label 18801: @1311260
     /* 1311260 */   GIM_Try, /*On fail goto*//*Label 18802*/ GIMT_Encode4(1311344), // Rule ID 9724 //
     /* 1311265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311318 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311343 */     // GIR_Coverage, 9724,
     /* 1311343 */     GIR_EraseRootFromParent_Done,
     /* 1311344 */   // Label 18802: @1311344
     /* 1311344 */   GIM_Try, /*On fail goto*//*Label 18803*/ GIMT_Encode4(1311428), // Rule ID 9725 //
     /* 1311349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1311366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1311369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311402 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1311405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311427 */     // GIR_Coverage, 9725,
     /* 1311427 */     GIR_EraseRootFromParent_Done,
     /* 1311428 */   // Label 18803: @1311428
     /* 1311428 */   GIM_Try, /*On fail goto*//*Label 18804*/ GIMT_Encode4(1311512), // Rule ID 9728 //
     /* 1311433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1311450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1311453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311486 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311511 */     // GIR_Coverage, 9728,
     /* 1311511 */     GIR_EraseRootFromParent_Done,
     /* 1311512 */   // Label 18804: @1311512
     /* 1311512 */   GIM_Try, /*On fail goto*//*Label 18805*/ GIMT_Encode4(1311596), // Rule ID 9729 //
     /* 1311517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1311525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1311534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1311537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311570 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1311573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311595 */     // GIR_Coverage, 9729,
     /* 1311595 */     GIR_EraseRootFromParent_Done,
     /* 1311596 */   // Label 18805: @1311596
     /* 1311596 */   GIM_Try, /*On fail goto*//*Label 18806*/ GIMT_Encode4(1311680), // Rule ID 9732 //
     /* 1311601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1311612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1311615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1311618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1311621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1311624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311654 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1311657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311679 */     // GIR_Coverage, 9732,
     /* 1311679 */     GIR_EraseRootFromParent_Done,
     /* 1311680 */   // Label 18806: @1311680
     /* 1311680 */   GIM_Try, /*On fail goto*//*Label 18807*/ GIMT_Encode4(1311764), // Rule ID 9733 //
     /* 1311685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1311696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1311699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1311702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1311705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1311708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311738 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1311741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311763 */     // GIR_Coverage, 9733,
     /* 1311763 */     GIR_EraseRootFromParent_Done,
     /* 1311764 */   // Label 18807: @1311764
     /* 1311764 */   GIM_Try, /*On fail goto*//*Label 18808*/ GIMT_Encode4(1311848), // Rule ID 9736 //
     /* 1311769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1311786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1311789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311822 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1311825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311847 */     // GIR_Coverage, 9736,
     /* 1311847 */     GIR_EraseRootFromParent_Done,
     /* 1311848 */   // Label 18808: @1311848
     /* 1311848 */   GIM_Try, /*On fail goto*//*Label 18809*/ GIMT_Encode4(1311932), // Rule ID 9737 //
     /* 1311853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1311870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1311873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311906 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1311909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1311927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311931 */     // GIR_Coverage, 9737,
     /* 1311931 */     GIR_EraseRootFromParent_Done,
     /* 1311932 */   // Label 18809: @1311932
     /* 1311932 */   GIM_Try, /*On fail goto*//*Label 18810*/ GIMT_Encode4(1312016), // Rule ID 9740 //
     /* 1311937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1311945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1311954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1311957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311990 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1311993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312015 */     // GIR_Coverage, 9740,
     /* 1312015 */     GIR_EraseRootFromParent_Done,
     /* 1312016 */   // Label 18810: @1312016
     /* 1312016 */   GIM_Try, /*On fail goto*//*Label 18811*/ GIMT_Encode4(1312100), // Rule ID 9741 //
     /* 1312021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312074 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312099 */     // GIR_Coverage, 9741,
     /* 1312099 */     GIR_EraseRootFromParent_Done,
     /* 1312100 */   // Label 18811: @1312100
     /* 1312100 */   GIM_Try, /*On fail goto*//*Label 18812*/ GIMT_Encode4(1312184), // Rule ID 9744 //
     /* 1312105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312158 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312183 */     // GIR_Coverage, 9744,
     /* 1312183 */     GIR_EraseRootFromParent_Done,
     /* 1312184 */   // Label 18812: @1312184
     /* 1312184 */   GIM_Try, /*On fail goto*//*Label 18813*/ GIMT_Encode4(1312268), // Rule ID 9745 //
     /* 1312189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312242 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1312245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312267 */     // GIR_Coverage, 9745,
     /* 1312267 */     GIR_EraseRootFromParent_Done,
     /* 1312268 */   // Label 18813: @1312268
     /* 1312268 */   GIM_Try, /*On fail goto*//*Label 18814*/ GIMT_Encode4(1312352), // Rule ID 9748 //
     /* 1312273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312326 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312351 */     // GIR_Coverage, 9748,
     /* 1312351 */     GIR_EraseRootFromParent_Done,
     /* 1312352 */   // Label 18814: @1312352
     /* 1312352 */   GIM_Try, /*On fail goto*//*Label 18815*/ GIMT_Encode4(1312436), // Rule ID 9749 //
     /* 1312357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1312374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1312377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312410 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312435 */     // GIR_Coverage, 9749,
     /* 1312435 */     GIR_EraseRootFromParent_Done,
     /* 1312436 */   // Label 18815: @1312436
     /* 1312436 */   GIM_Try, /*On fail goto*//*Label 18816*/ GIMT_Encode4(1312520), // Rule ID 9752 //
     /* 1312441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1312461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312494 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312519 */     // GIR_Coverage, 9752,
     /* 1312519 */     GIR_EraseRootFromParent_Done,
     /* 1312520 */   // Label 18816: @1312520
     /* 1312520 */   GIM_Try, /*On fail goto*//*Label 18817*/ GIMT_Encode4(1312604), // Rule ID 9753 //
     /* 1312525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1312536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1312539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1312542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1312545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312578 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1312581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1312599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312603 */     // GIR_Coverage, 9753,
     /* 1312603 */     GIR_EraseRootFromParent_Done,
     /* 1312604 */   // Label 18817: @1312604
     /* 1312604 */   GIM_Try, /*On fail goto*//*Label 18818*/ GIMT_Encode4(1312688), // Rule ID 9756 //
     /* 1312609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1312626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1312629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312662 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1312665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312687 */     // GIR_Coverage, 9756,
     /* 1312687 */     GIR_EraseRootFromParent_Done,
     /* 1312688 */   // Label 18818: @1312688
     /* 1312688 */   GIM_Try, /*On fail goto*//*Label 18819*/ GIMT_Encode4(1312772), // Rule ID 9757 //
     /* 1312693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1312710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1312713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312746 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1312749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312771 */     // GIR_Coverage, 9757,
     /* 1312771 */     GIR_EraseRootFromParent_Done,
     /* 1312772 */   // Label 18819: @1312772
     /* 1312772 */   GIM_Try, /*On fail goto*//*Label 18820*/ GIMT_Encode4(1312856), // Rule ID 9760 //
     /* 1312777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1312794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1312797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312830 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1312833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312855 */     // GIR_Coverage, 9760,
     /* 1312855 */     GIR_EraseRootFromParent_Done,
     /* 1312856 */   // Label 18820: @1312856
     /* 1312856 */   GIM_Try, /*On fail goto*//*Label 18821*/ GIMT_Encode4(1312940), // Rule ID 9761 //
     /* 1312861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1312878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1312881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312914 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1312917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312939 */     // GIR_Coverage, 9761,
     /* 1312939 */     GIR_EraseRootFromParent_Done,
     /* 1312940 */   // Label 18821: @1312940
     /* 1312940 */   GIM_Try, /*On fail goto*//*Label 18822*/ GIMT_Encode4(1313024), // Rule ID 9764 //
     /* 1312945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1312953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1312956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1312962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1312965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312998 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313023 */     // GIR_Coverage, 9764,
     /* 1313023 */     GIR_EraseRootFromParent_Done,
     /* 1313024 */   // Label 18822: @1313024
     /* 1313024 */   GIM_Try, /*On fail goto*//*Label 18823*/ GIMT_Encode4(1313108), // Rule ID 9765 //
     /* 1313029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1313040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1313043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313082 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313107 */     // GIR_Coverage, 9765,
     /* 1313107 */     GIR_EraseRootFromParent_Done,
     /* 1313108 */   // Label 18823: @1313108
     /* 1313108 */   GIM_Try, /*On fail goto*//*Label 18824*/ GIMT_Encode4(1313192), // Rule ID 9768 //
     /* 1313113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1313116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313166 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313191 */     // GIR_Coverage, 9768,
     /* 1313191 */     GIR_EraseRootFromParent_Done,
     /* 1313192 */   // Label 18824: @1313192
     /* 1313192 */   GIM_Try, /*On fail goto*//*Label 18825*/ GIMT_Encode4(1313276), // Rule ID 9769 //
     /* 1313197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1313200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1313208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1313211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313250 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1313253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313275 */     // GIR_Coverage, 9769,
     /* 1313275 */     GIR_EraseRootFromParent_Done,
     /* 1313276 */   // Label 18825: @1313276
     /* 1313276 */   GIM_Try, /*On fail goto*//*Label 18826*/ GIMT_Encode4(1313360), // Rule ID 9772 //
     /* 1313281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313334 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313359 */     // GIR_Coverage, 9772,
     /* 1313359 */     GIR_EraseRootFromParent_Done,
     /* 1313360 */   // Label 18826: @1313360
     /* 1313360 */   GIM_Try, /*On fail goto*//*Label 18827*/ GIMT_Encode4(1313444), // Rule ID 9773 //
     /* 1313365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1313382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1313385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313418 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313443 */     // GIR_Coverage, 9773,
     /* 1313443 */     GIR_EraseRootFromParent_Done,
     /* 1313444 */   // Label 18827: @1313444
     /* 1313444 */   GIM_Try, /*On fail goto*//*Label 18828*/ GIMT_Encode4(1313528), // Rule ID 9776 //
     /* 1313449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1313460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1313463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1313466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1313469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1313472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313502 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1313505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313527 */     // GIR_Coverage, 9776,
     /* 1313527 */     GIR_EraseRootFromParent_Done,
     /* 1313528 */   // Label 18828: @1313528
     /* 1313528 */   GIM_Try, /*On fail goto*//*Label 18829*/ GIMT_Encode4(1313612), // Rule ID 9777 //
     /* 1313533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1313544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1313547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1313550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1313553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1313556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313586 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1313589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313611 */     // GIR_Coverage, 9777,
     /* 1313611 */     GIR_EraseRootFromParent_Done,
     /* 1313612 */   // Label 18829: @1313612
     /* 1313612 */   GIM_Try, /*On fail goto*//*Label 18830*/ GIMT_Encode4(1313696), // Rule ID 9780 //
     /* 1313617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1313628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1313631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1313634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1313637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1313640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313670 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1313673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313695 */     // GIR_Coverage, 9780,
     /* 1313695 */     GIR_EraseRootFromParent_Done,
     /* 1313696 */   // Label 18830: @1313696
     /* 1313696 */   GIM_Try, /*On fail goto*//*Label 18831*/ GIMT_Encode4(1313780), // Rule ID 9781 //
     /* 1313701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1313712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1313715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1313718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1313721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1313724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1313743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313754 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1313757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313779 */     // GIR_Coverage, 9781,
     /* 1313779 */     GIR_EraseRootFromParent_Done,
     /* 1313780 */   // Label 18831: @1313780
     /* 1313780 */   GIM_Try, /*On fail goto*//*Label 18832*/ GIMT_Encode4(1313864), // Rule ID 9784 //
     /* 1313785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1313796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1313799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1313802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1313805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313838 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1313838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313863 */     // GIR_Coverage, 9784,
     /* 1313863 */     GIR_EraseRootFromParent_Done,
     /* 1313864 */   // Label 18832: @1313864
     /* 1313864 */   GIM_Try, /*On fail goto*//*Label 18833*/ GIMT_Encode4(1313948), // Rule ID 9785 //
     /* 1313869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1313880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1313883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1313886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1313889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1313911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313922 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1313922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1313925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1313931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1313933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1313946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313947 */     // GIR_Coverage, 9785,
     /* 1313947 */     GIR_EraseRootFromParent_Done,
     /* 1313948 */   // Label 18833: @1313948
     /* 1313948 */   GIM_Try, /*On fail goto*//*Label 18834*/ GIMT_Encode4(1314032), // Rule ID 9788 //
     /* 1313953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1313961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1313964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1313967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1313970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1313973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1313976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1313995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314006 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314031 */     // GIR_Coverage, 9788,
     /* 1314031 */     GIR_EraseRootFromParent_Done,
     /* 1314032 */   // Label 18834: @1314032
     /* 1314032 */   GIM_Try, /*On fail goto*//*Label 18835*/ GIMT_Encode4(1314116), // Rule ID 9789 //
     /* 1314037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314090 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314115 */     // GIR_Coverage, 9789,
     /* 1314115 */     GIR_EraseRootFromParent_Done,
     /* 1314116 */   // Label 18835: @1314116
     /* 1314116 */   GIM_Try, /*On fail goto*//*Label 18836*/ GIMT_Encode4(1314200), // Rule ID 9792 //
     /* 1314121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314174 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314199 */     // GIR_Coverage, 9792,
     /* 1314199 */     GIR_EraseRootFromParent_Done,
     /* 1314200 */   // Label 18836: @1314200
     /* 1314200 */   GIM_Try, /*On fail goto*//*Label 18837*/ GIMT_Encode4(1314284), // Rule ID 9793 //
     /* 1314205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1314216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1314219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314258 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314283 */     // GIR_Coverage, 9793,
     /* 1314283 */     GIR_EraseRootFromParent_Done,
     /* 1314284 */   // Label 18837: @1314284
     /* 1314284 */   GIM_Try, /*On fail goto*//*Label 18838*/ GIMT_Encode4(1314368), // Rule ID 9796 //
     /* 1314289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314342 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314367 */     // GIR_Coverage, 9796,
     /* 1314367 */     GIR_EraseRootFromParent_Done,
     /* 1314368 */   // Label 18838: @1314368
     /* 1314368 */   GIM_Try, /*On fail goto*//*Label 18839*/ GIMT_Encode4(1314452), // Rule ID 9797 //
     /* 1314373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1314390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1314393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314426 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314451 */     // GIR_Coverage, 9797,
     /* 1314451 */     GIR_EraseRootFromParent_Done,
     /* 1314452 */   // Label 18839: @1314452
     /* 1314452 */   GIM_Try, /*On fail goto*//*Label 18840*/ GIMT_Encode4(1314536), // Rule ID 9800 //
     /* 1314457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1314474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1314477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314510 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314535 */     // GIR_Coverage, 9800,
     /* 1314535 */     GIR_EraseRootFromParent_Done,
     /* 1314536 */   // Label 18840: @1314536
     /* 1314536 */   GIM_Try, /*On fail goto*//*Label 18841*/ GIMT_Encode4(1314620), // Rule ID 9801 //
     /* 1314541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1314552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1314555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1314558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1314561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314594 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1314597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314619 */     // GIR_Coverage, 9801,
     /* 1314619 */     GIR_EraseRootFromParent_Done,
     /* 1314620 */   // Label 18841: @1314620
     /* 1314620 */   GIM_Try, /*On fail goto*//*Label 18842*/ GIMT_Encode4(1314704), // Rule ID 9804 //
     /* 1314625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1314642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1314645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314678 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314703 */     // GIR_Coverage, 9804,
     /* 1314703 */     GIR_EraseRootFromParent_Done,
     /* 1314704 */   // Label 18842: @1314704
     /* 1314704 */   GIM_Try, /*On fail goto*//*Label 18843*/ GIMT_Encode4(1314788), // Rule ID 9805 //
     /* 1314709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1314720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1314723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1314726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1314729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314762 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1314765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1314783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314787 */     // GIR_Coverage, 9805,
     /* 1314787 */     GIR_EraseRootFromParent_Done,
     /* 1314788 */   // Label 18843: @1314788
     /* 1314788 */   GIM_Try, /*On fail goto*//*Label 18844*/ GIMT_Encode4(1314872), // Rule ID 9808 //
     /* 1314793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1314796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1314804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1314807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1314810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1314813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1314816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314846 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1314846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1314867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314871 */     // GIR_Coverage, 9808,
     /* 1314871 */     GIR_EraseRootFromParent_Done,
     /* 1314872 */   // Label 18844: @1314872
     /* 1314872 */   GIM_Try, /*On fail goto*//*Label 18845*/ GIMT_Encode4(1314956), // Rule ID 9809 //
     /* 1314877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1314880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1314888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1314891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1314894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1314897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1314900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314930 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1314930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1314933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1314939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1314941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1314951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1314954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314955 */     // GIR_Coverage, 9809,
     /* 1314955 */     GIR_EraseRootFromParent_Done,
     /* 1314956 */   // Label 18845: @1314956
     /* 1314956 */   GIM_Try, /*On fail goto*//*Label 18846*/ GIMT_Encode4(1315040), // Rule ID 9812 //
     /* 1314961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1314964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1314969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1314972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1314975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1314978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1314981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1314984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1314995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315014 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315039 */     // GIR_Coverage, 9812,
     /* 1315039 */     GIR_EraseRootFromParent_Done,
     /* 1315040 */   // Label 18846: @1315040
     /* 1315040 */   GIM_Try, /*On fail goto*//*Label 18847*/ GIMT_Encode4(1315124), // Rule ID 9813 //
     /* 1315045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315098 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1315101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315123 */     // GIR_Coverage, 9813,
     /* 1315123 */     GIR_EraseRootFromParent_Done,
     /* 1315124 */   // Label 18847: @1315124
     /* 1315124 */   GIM_Try, /*On fail goto*//*Label 18848*/ GIMT_Encode4(1315208), // Rule ID 9816 //
     /* 1315129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315207 */     // GIR_Coverage, 9816,
     /* 1315207 */     GIR_EraseRootFromParent_Done,
     /* 1315208 */   // Label 18848: @1315208
     /* 1315208 */   GIM_Try, /*On fail goto*//*Label 18849*/ GIMT_Encode4(1315292), // Rule ID 9817 //
     /* 1315213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1315221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1315224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1315227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315266 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1315269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315291 */     // GIR_Coverage, 9817,
     /* 1315291 */     GIR_EraseRootFromParent_Done,
     /* 1315292 */   // Label 18849: @1315292
     /* 1315292 */   GIM_Try, /*On fail goto*//*Label 18850*/ GIMT_Encode4(1315376), // Rule ID 9820 //
     /* 1315297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315350 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1315353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315375 */     // GIR_Coverage, 9820,
     /* 1315375 */     GIR_EraseRootFromParent_Done,
     /* 1315376 */   // Label 18850: @1315376
     /* 1315376 */   GIM_Try, /*On fail goto*//*Label 18851*/ GIMT_Encode4(1315460), // Rule ID 9821 //
     /* 1315381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1315401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315434 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1315437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315459 */     // GIR_Coverage, 9821,
     /* 1315459 */     GIR_EraseRootFromParent_Done,
     /* 1315460 */   // Label 18851: @1315460
     /* 1315460 */   GIM_Try, /*On fail goto*//*Label 18852*/ GIMT_Encode4(1315544), // Rule ID 9824 //
     /* 1315465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1315482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1315485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315518 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315543 */     // GIR_Coverage, 9824,
     /* 1315543 */     GIR_EraseRootFromParent_Done,
     /* 1315544 */   // Label 18852: @1315544
     /* 1315544 */   GIM_Try, /*On fail goto*//*Label 18853*/ GIMT_Encode4(1315628), // Rule ID 9825 //
     /* 1315549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1315566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1315569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315602 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315627 */     // GIR_Coverage, 9825,
     /* 1315627 */     GIR_EraseRootFromParent_Done,
     /* 1315628 */   // Label 18853: @1315628
     /* 1315628 */   GIM_Try, /*On fail goto*//*Label 18854*/ GIMT_Encode4(1315712), // Rule ID 9828 //
     /* 1315633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1315650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1315653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315686 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1315689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315711 */     // GIR_Coverage, 9828,
     /* 1315711 */     GIR_EraseRootFromParent_Done,
     /* 1315712 */   // Label 18854: @1315712
     /* 1315712 */   GIM_Try, /*On fail goto*//*Label 18855*/ GIMT_Encode4(1315796), // Rule ID 9829 //
     /* 1315717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1315728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1315731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1315734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1315737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315770 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1315773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1315791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315795 */     // GIR_Coverage, 9829,
     /* 1315795 */     GIR_EraseRootFromParent_Done,
     /* 1315796 */   // Label 18855: @1315796
     /* 1315796 */   GIM_Try, /*On fail goto*//*Label 18856*/ GIMT_Encode4(1315880), // Rule ID 9832 //
     /* 1315801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1315818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1315821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315854 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1315854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315879 */     // GIR_Coverage, 9832,
     /* 1315879 */     GIR_EraseRootFromParent_Done,
     /* 1315880 */   // Label 18856: @1315880
     /* 1315880 */   GIM_Try, /*On fail goto*//*Label 18857*/ GIMT_Encode4(1315964), // Rule ID 9833 //
     /* 1315885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1315896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1315899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1315902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1315905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315938 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1315938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1315941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1315947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1315949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1315959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1315962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315963 */     // GIR_Coverage, 9833,
     /* 1315963 */     GIR_EraseRootFromParent_Done,
     /* 1315964 */   // Label 18857: @1315964
     /* 1315964 */   GIM_Try, /*On fail goto*//*Label 18858*/ GIMT_Encode4(1316048), // Rule ID 9836 //
     /* 1315969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1315977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1315980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1315983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1315986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1315989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1315999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316022 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316047 */     // GIR_Coverage, 9836,
     /* 1316047 */     GIR_EraseRootFromParent_Done,
     /* 1316048 */   // Label 18858: @1316048
     /* 1316048 */   GIM_Try, /*On fail goto*//*Label 18859*/ GIMT_Encode4(1316132), // Rule ID 9837 //
     /* 1316053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1316073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316106 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316131 */     // GIR_Coverage, 9837,
     /* 1316131 */     GIR_EraseRootFromParent_Done,
     /* 1316132 */   // Label 18859: @1316132
     /* 1316132 */   GIM_Try, /*On fail goto*//*Label 18860*/ GIMT_Encode4(1316216), // Rule ID 9840 //
     /* 1316137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316215 */     // GIR_Coverage, 9840,
     /* 1316215 */     GIR_EraseRootFromParent_Done,
     /* 1316216 */   // Label 18860: @1316216
     /* 1316216 */   GIM_Try, /*On fail goto*//*Label 18861*/ GIMT_Encode4(1316300), // Rule ID 9841 //
     /* 1316221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1316241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316274 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1316277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316299 */     // GIR_Coverage, 9841,
     /* 1316299 */     GIR_EraseRootFromParent_Done,
     /* 1316300 */   // Label 18861: @1316300
     /* 1316300 */   GIM_Try, /*On fail goto*//*Label 18862*/ GIMT_Encode4(1316384), // Rule ID 9844 //
     /* 1316305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316358 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316383 */     // GIR_Coverage, 9844,
     /* 1316383 */     GIR_EraseRootFromParent_Done,
     /* 1316384 */   // Label 18862: @1316384
     /* 1316384 */   GIM_Try, /*On fail goto*//*Label 18863*/ GIMT_Encode4(1316468), // Rule ID 9845 //
     /* 1316389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1316400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1316403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1316409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316442 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316467 */     // GIR_Coverage, 9845,
     /* 1316467 */     GIR_EraseRootFromParent_Done,
     /* 1316468 */   // Label 18863: @1316468
     /* 1316468 */   GIM_Try, /*On fail goto*//*Label 18864*/ GIMT_Encode4(1316552), // Rule ID 9848 //
     /* 1316473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1316493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316526 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316551 */     // GIR_Coverage, 9848,
     /* 1316551 */     GIR_EraseRootFromParent_Done,
     /* 1316552 */   // Label 18864: @1316552
     /* 1316552 */   GIM_Try, /*On fail goto*//*Label 18865*/ GIMT_Encode4(1316636), // Rule ID 9849 //
     /* 1316557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1316568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1316571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1316574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1316577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316610 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316635 */     // GIR_Coverage, 9849,
     /* 1316635 */     GIR_EraseRootFromParent_Done,
     /* 1316636 */   // Label 18865: @1316636
     /* 1316636 */   GIM_Try, /*On fail goto*//*Label 18866*/ GIMT_Encode4(1316720), // Rule ID 9852 //
     /* 1316641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1316658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1316661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316694 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316719 */     // GIR_Coverage, 9852,
     /* 1316719 */     GIR_EraseRootFromParent_Done,
     /* 1316720 */   // Label 18866: @1316720
     /* 1316720 */   GIM_Try, /*On fail goto*//*Label 18867*/ GIMT_Encode4(1316804), // Rule ID 9853 //
     /* 1316725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1316736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1316739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1316742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1316745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316778 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316803 */     // GIR_Coverage, 9853,
     /* 1316803 */     GIR_EraseRootFromParent_Done,
     /* 1316804 */   // Label 18867: @1316804
     /* 1316804 */   GIM_Try, /*On fail goto*//*Label 18868*/ GIMT_Encode4(1316888), // Rule ID 9856 //
     /* 1316809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1316812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1316826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1316829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316862 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1316862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316887 */     // GIR_Coverage, 9856,
     /* 1316887 */     GIR_EraseRootFromParent_Done,
     /* 1316888 */   // Label 18868: @1316888
     /* 1316888 */   GIM_Try, /*On fail goto*//*Label 18869*/ GIMT_Encode4(1316972), // Rule ID 9857 //
     /* 1316893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1316896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1316904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1316907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1316910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1316913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316946 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1316946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1316949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1316955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1316957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1316967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1316970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316971 */     // GIR_Coverage, 9857,
     /* 1316971 */     GIR_EraseRootFromParent_Done,
     /* 1316972 */   // Label 18869: @1316972
     /* 1316972 */   GIM_Try, /*On fail goto*//*Label 18870*/ GIMT_Encode4(1317056), // Rule ID 9860 //
     /* 1316977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1316985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1316988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1316991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1316994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1316997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317030 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317055 */     // GIR_Coverage, 9860,
     /* 1317055 */     GIR_EraseRootFromParent_Done,
     /* 1317056 */   // Label 18870: @1317056
     /* 1317056 */   GIM_Try, /*On fail goto*//*Label 18871*/ GIMT_Encode4(1317140), // Rule ID 9861 //
     /* 1317061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1317081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317114 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317139 */     // GIR_Coverage, 9861,
     /* 1317139 */     GIR_EraseRootFromParent_Done,
     /* 1317140 */   // Label 18871: @1317140
     /* 1317140 */   GIM_Try, /*On fail goto*//*Label 18872*/ GIMT_Encode4(1317224), // Rule ID 9864 //
     /* 1317145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317198 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317223 */     // GIR_Coverage, 9864,
     /* 1317223 */     GIR_EraseRootFromParent_Done,
     /* 1317224 */   // Label 18872: @1317224
     /* 1317224 */   GIM_Try, /*On fail goto*//*Label 18873*/ GIMT_Encode4(1317308), // Rule ID 9865 //
     /* 1317229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1317249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317282 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317307 */     // GIR_Coverage, 9865,
     /* 1317307 */     GIR_EraseRootFromParent_Done,
     /* 1317308 */   // Label 18873: @1317308
     /* 1317308 */   GIM_Try, /*On fail goto*//*Label 18874*/ GIMT_Encode4(1317392), // Rule ID 9868 //
     /* 1317313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317366 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317391 */     // GIR_Coverage, 9868,
     /* 1317391 */     GIR_EraseRootFromParent_Done,
     /* 1317392 */   // Label 18874: @1317392
     /* 1317392 */   GIM_Try, /*On fail goto*//*Label 18875*/ GIMT_Encode4(1317476), // Rule ID 9869 //
     /* 1317397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1317408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1317411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1317417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317450 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317475 */     // GIR_Coverage, 9869,
     /* 1317475 */     GIR_EraseRootFromParent_Done,
     /* 1317476 */   // Label 18875: @1317476
     /* 1317476 */   GIM_Try, /*On fail goto*//*Label 18876*/ GIMT_Encode4(1317560), // Rule ID 9872 //
     /* 1317481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1317492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1317495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1317498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1317501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317534 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317559 */     // GIR_Coverage, 9872,
     /* 1317559 */     GIR_EraseRootFromParent_Done,
     /* 1317560 */   // Label 18876: @1317560
     /* 1317560 */   GIM_Try, /*On fail goto*//*Label 18877*/ GIMT_Encode4(1317644), // Rule ID 9873 //
     /* 1317565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1317576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1317579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1317582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1317585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1317621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317643 */     // GIR_Coverage, 9873,
     /* 1317643 */     GIR_EraseRootFromParent_Done,
     /* 1317644 */   // Label 18877: @1317644
     /* 1317644 */   GIM_Try, /*On fail goto*//*Label 18878*/ GIMT_Encode4(1317728), // Rule ID 9876 //
     /* 1317649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1317666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1317669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317702 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317727 */     // GIR_Coverage, 9876,
     /* 1317727 */     GIR_EraseRootFromParent_Done,
     /* 1317728 */   // Label 18878: @1317728
     /* 1317728 */   GIM_Try, /*On fail goto*//*Label 18879*/ GIMT_Encode4(1317812), // Rule ID 9877 //
     /* 1317733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1317744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1317747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1317750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1317753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317786 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1317789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317811 */     // GIR_Coverage, 9877,
     /* 1317811 */     GIR_EraseRootFromParent_Done,
     /* 1317812 */   // Label 18879: @1317812
     /* 1317812 */   GIM_Try, /*On fail goto*//*Label 18880*/ GIMT_Encode4(1317896), // Rule ID 9880 //
     /* 1317817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1317834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1317837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317870 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1317870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317895 */     // GIR_Coverage, 9880,
     /* 1317895 */     GIR_EraseRootFromParent_Done,
     /* 1317896 */   // Label 18880: @1317896
     /* 1317896 */   GIM_Try, /*On fail goto*//*Label 18881*/ GIMT_Encode4(1317980), // Rule ID 9881 //
     /* 1317901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1317912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1317915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1317918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1317921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317954 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1317954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1317957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1317963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1317965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1317978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317979 */     // GIR_Coverage, 9881,
     /* 1317979 */     GIR_EraseRootFromParent_Done,
     /* 1317980 */   // Label 18881: @1317980
     /* 1317980 */   GIM_Try, /*On fail goto*//*Label 18882*/ GIMT_Encode4(1318064), // Rule ID 9884 //
     /* 1317985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1317993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1317996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1317999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318063 */     // GIR_Coverage, 9884,
     /* 1318063 */     GIR_EraseRootFromParent_Done,
     /* 1318064 */   // Label 18882: @1318064
     /* 1318064 */   GIM_Try, /*On fail goto*//*Label 18883*/ GIMT_Encode4(1318148), // Rule ID 9885 //
     /* 1318069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1318089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318122 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318147 */     // GIR_Coverage, 9885,
     /* 1318147 */     GIR_EraseRootFromParent_Done,
     /* 1318148 */   // Label 18883: @1318148
     /* 1318148 */   GIM_Try, /*On fail goto*//*Label 18884*/ GIMT_Encode4(1318232), // Rule ID 9888 //
     /* 1318153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318206 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318231 */     // GIR_Coverage, 9888,
     /* 1318231 */     GIR_EraseRootFromParent_Done,
     /* 1318232 */   // Label 18884: @1318232
     /* 1318232 */   GIM_Try, /*On fail goto*//*Label 18885*/ GIMT_Encode4(1318316), // Rule ID 9889 //
     /* 1318237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1318257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318290 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318315 */     // GIR_Coverage, 9889,
     /* 1318315 */     GIR_EraseRootFromParent_Done,
     /* 1318316 */   // Label 18885: @1318316
     /* 1318316 */   GIM_Try, /*On fail goto*//*Label 18886*/ GIMT_Encode4(1318400), // Rule ID 9892 //
     /* 1318321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318374 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318399 */     // GIR_Coverage, 9892,
     /* 1318399 */     GIR_EraseRootFromParent_Done,
     /* 1318400 */   // Label 18886: @1318400
     /* 1318400 */   GIM_Try, /*On fail goto*//*Label 18887*/ GIMT_Encode4(1318484), // Rule ID 9893 //
     /* 1318405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1318416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1318419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1318425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318483 */     // GIR_Coverage, 9893,
     /* 1318483 */     GIR_EraseRootFromParent_Done,
     /* 1318484 */   // Label 18887: @1318484
     /* 1318484 */   GIM_Try, /*On fail goto*//*Label 18888*/ GIMT_Encode4(1318568), // Rule ID 9896 //
     /* 1318489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1318500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1318503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1318509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318542 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318567 */     // GIR_Coverage, 9896,
     /* 1318567 */     GIR_EraseRootFromParent_Done,
     /* 1318568 */   // Label 18888: @1318568
     /* 1318568 */   GIM_Try, /*On fail goto*//*Label 18889*/ GIMT_Encode4(1318652), // Rule ID 9897 //
     /* 1318573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1318576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1318584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1318587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1318590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1318593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1318596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318626 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1318629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318651 */     // GIR_Coverage, 9897,
     /* 1318651 */     GIR_EraseRootFromParent_Done,
     /* 1318652 */   // Label 18889: @1318652
     /* 1318652 */   GIM_Try, /*On fail goto*//*Label 18890*/ GIMT_Encode4(1318736), // Rule ID 9900 //
     /* 1318657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1318674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1318677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318710 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318735 */     // GIR_Coverage, 9900,
     /* 1318735 */     GIR_EraseRootFromParent_Done,
     /* 1318736 */   // Label 18890: @1318736
     /* 1318736 */   GIM_Try, /*On fail goto*//*Label 18891*/ GIMT_Encode4(1318820), // Rule ID 9901 //
     /* 1318741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1318744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1318752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1318755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1318758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1318761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318794 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1318797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318819 */     // GIR_Coverage, 9901,
     /* 1318819 */     GIR_EraseRootFromParent_Done,
     /* 1318820 */   // Label 18891: @1318820
     /* 1318820 */   GIM_Try, /*On fail goto*//*Label 18892*/ GIMT_Encode4(1318904), // Rule ID 9904 //
     /* 1318825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1318828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1318842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1318845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318878 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1318878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318903 */     // GIR_Coverage, 9904,
     /* 1318903 */     GIR_EraseRootFromParent_Done,
     /* 1318904 */   // Label 18892: @1318904
     /* 1318904 */   GIM_Try, /*On fail goto*//*Label 18893*/ GIMT_Encode4(1318988), // Rule ID 9905 //
     /* 1318909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1318912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1318917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1318920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1318923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1318926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1318929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1318943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318962 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1318962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1318965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1318971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1318973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1318983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1318986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318987 */     // GIR_Coverage, 9905,
     /* 1318987 */     GIR_EraseRootFromParent_Done,
     /* 1318988 */   // Label 18893: @1318988
     /* 1318988 */   GIM_Try, /*On fail goto*//*Label 18894*/ GIMT_Encode4(1319069), // Rule ID 13846 //
     /* 1318993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1319004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1319007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319046 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1319049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319068 */     // GIR_Coverage, 13846,
     /* 1319068 */     GIR_EraseRootFromParent_Done,
     /* 1319069 */   // Label 18894: @1319069
     /* 1319069 */   GIM_Try, /*On fail goto*//*Label 18895*/ GIMT_Encode4(1319150), // Rule ID 13847 //
     /* 1319074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1319085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1319088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1319091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1319094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319127 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1319130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319149 */     // GIR_Coverage, 13847,
     /* 1319149 */     GIR_EraseRootFromParent_Done,
     /* 1319150 */   // Label 18895: @1319150
     /* 1319150 */   GIM_Try, /*On fail goto*//*Label 18896*/ GIMT_Encode4(1319231), // Rule ID 13848 //
     /* 1319155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1319166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1319169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319208 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319230 */     // GIR_Coverage, 13848,
     /* 1319230 */     GIR_EraseRootFromParent_Done,
     /* 1319231 */   // Label 18896: @1319231
     /* 1319231 */   GIM_Try, /*On fail goto*//*Label 18897*/ GIMT_Encode4(1319312), // Rule ID 13849 //
     /* 1319236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1319247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1319250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1319253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1319256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319289 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319311 */     // GIR_Coverage, 13849,
     /* 1319311 */     GIR_EraseRootFromParent_Done,
     /* 1319312 */   // Label 18897: @1319312
     /* 1319312 */   GIM_Try, /*On fail goto*//*Label 18898*/ GIMT_Encode4(1319393), // Rule ID 13850 //
     /* 1319317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319370 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1319370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319392 */     // GIR_Coverage, 13850,
     /* 1319392 */     GIR_EraseRootFromParent_Done,
     /* 1319393 */   // Label 18898: @1319393
     /* 1319393 */   GIM_Try, /*On fail goto*//*Label 18899*/ GIMT_Encode4(1319474), // Rule ID 13851 //
     /* 1319398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1319409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1319412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1319415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1319418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319451 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1319451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1319472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319473 */     // GIR_Coverage, 13851,
     /* 1319473 */     GIR_EraseRootFromParent_Done,
     /* 1319474 */   // Label 18899: @1319474
     /* 1319474 */   GIM_Try, /*On fail goto*//*Label 18900*/ GIMT_Encode4(1319555), // Rule ID 13852 //
     /* 1319479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1319490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1319493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319532 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1319532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319554 */     // GIR_Coverage, 13852,
     /* 1319554 */     GIR_EraseRootFromParent_Done,
     /* 1319555 */   // Label 18900: @1319555
     /* 1319555 */   GIM_Try, /*On fail goto*//*Label 18901*/ GIMT_Encode4(1319636), // Rule ID 13853 //
     /* 1319560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1319571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1319574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319613 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1319613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1319616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319635 */     // GIR_Coverage, 13853,
     /* 1319635 */     GIR_EraseRootFromParent_Done,
     /* 1319636 */   // Label 18901: @1319636
     /* 1319636 */   GIM_Try, /*On fail goto*//*Label 18902*/ GIMT_Encode4(1319717), // Rule ID 13854 //
     /* 1319641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1319652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1319655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1319661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1319694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319716 */     // GIR_Coverage, 13854,
     /* 1319716 */     GIR_EraseRootFromParent_Done,
     /* 1319717 */   // Label 18902: @1319717
     /* 1319717 */   GIM_Try, /*On fail goto*//*Label 18903*/ GIMT_Encode4(1319798), // Rule ID 13855 //
     /* 1319722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1319733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1319736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1319742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319775 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1319775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319797 */     // GIR_Coverage, 13855,
     /* 1319797 */     GIR_EraseRootFromParent_Done,
     /* 1319798 */   // Label 18903: @1319798
     /* 1319798 */   GIM_Try, /*On fail goto*//*Label 18904*/ GIMT_Encode4(1319879), // Rule ID 13856 //
     /* 1319803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1319814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1319817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1319820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1319823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1319856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319878 */     // GIR_Coverage, 13856,
     /* 1319878 */     GIR_EraseRootFromParent_Done,
     /* 1319879 */   // Label 18904: @1319879
     /* 1319879 */   GIM_Try, /*On fail goto*//*Label 18905*/ GIMT_Encode4(1319960), // Rule ID 13857 //
     /* 1319884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1319887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1319895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1319898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1319901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1319904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319937 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1319937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1319940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319959 */     // GIR_Coverage, 13857,
     /* 1319959 */     GIR_EraseRootFromParent_Done,
     /* 1319960 */   // Label 18905: @1319960
     /* 1319960 */   GIM_Try, /*On fail goto*//*Label 18906*/ GIMT_Encode4(1320041), // Rule ID 13858 //
     /* 1319965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1319968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1319976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1319979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1319982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1319985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1319995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320040 */     // GIR_Coverage, 13858,
     /* 1320040 */     GIR_EraseRootFromParent_Done,
     /* 1320041 */   // Label 18906: @1320041
     /* 1320041 */   GIM_Try, /*On fail goto*//*Label 18907*/ GIMT_Encode4(1320122), // Rule ID 13859 //
     /* 1320046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1320057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1320060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1320063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1320066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320099 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320121 */     // GIR_Coverage, 13859,
     /* 1320121 */     GIR_EraseRootFromParent_Done,
     /* 1320122 */   // Label 18907: @1320122
     /* 1320122 */   GIM_Try, /*On fail goto*//*Label 18908*/ GIMT_Encode4(1320203), // Rule ID 13860 //
     /* 1320127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1320180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320202 */     // GIR_Coverage, 13860,
     /* 1320202 */     GIR_EraseRootFromParent_Done,
     /* 1320203 */   // Label 18908: @1320203
     /* 1320203 */   GIM_Try, /*On fail goto*//*Label 18909*/ GIMT_Encode4(1320284), // Rule ID 13861 //
     /* 1320208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1320219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1320222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320261 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1320261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320283 */     // GIR_Coverage, 13861,
     /* 1320283 */     GIR_EraseRootFromParent_Done,
     /* 1320284 */   // Label 18909: @1320284
     /* 1320284 */   GIM_Try, /*On fail goto*//*Label 18910*/ GIMT_Encode4(1320365), // Rule ID 13862 //
     /* 1320289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1320342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320364 */     // GIR_Coverage, 13862,
     /* 1320364 */     GIR_EraseRootFromParent_Done,
     /* 1320365 */   // Label 18910: @1320365
     /* 1320365 */   GIM_Try, /*On fail goto*//*Label 18911*/ GIMT_Encode4(1320446), // Rule ID 13863 //
     /* 1320370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1320381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1320384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320423 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1320423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320445 */     // GIR_Coverage, 13863,
     /* 1320445 */     GIR_EraseRootFromParent_Done,
     /* 1320446 */   // Label 18911: @1320446
     /* 1320446 */   GIM_Try, /*On fail goto*//*Label 18912*/ GIMT_Encode4(1320527), // Rule ID 13864 //
     /* 1320451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1320454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1320462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1320465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320504 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1320504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320526 */     // GIR_Coverage, 13864,
     /* 1320526 */     GIR_EraseRootFromParent_Done,
     /* 1320527 */   // Label 18912: @1320527
     /* 1320527 */   GIM_Try, /*On fail goto*//*Label 18913*/ GIMT_Encode4(1320608), // Rule ID 13865 //
     /* 1320532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1320535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1320543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1320546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1320562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320585 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1320585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1320588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320607 */     // GIR_Coverage, 13865,
     /* 1320607 */     GIR_EraseRootFromParent_Done,
     /* 1320608 */   // Label 18913: @1320608
     /* 1320608 */   GIM_Try, /*On fail goto*//*Label 18914*/ GIMT_Encode4(1320689), // Rule ID 13866 //
     /* 1320613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1320624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1320627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1320630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1320633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1320643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320666 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1320669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320688 */     // GIR_Coverage, 13866,
     /* 1320688 */     GIR_EraseRootFromParent_Done,
     /* 1320689 */   // Label 18914: @1320689
     /* 1320689 */   GIM_Try, /*On fail goto*//*Label 18915*/ GIMT_Encode4(1320770), // Rule ID 13867 //
     /* 1320694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1320705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1320708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1320711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1320714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1320724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320747 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1320750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320769 */     // GIR_Coverage, 13867,
     /* 1320769 */     GIR_EraseRootFromParent_Done,
     /* 1320770 */   // Label 18915: @1320770
     /* 1320770 */   GIM_Try, /*On fail goto*//*Label 18916*/ GIMT_Encode4(1320851), // Rule ID 13868 //
     /* 1320775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1320786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1320789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1320792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1320795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1320798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1320805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320828 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1320831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320850 */     // GIR_Coverage, 13868,
     /* 1320850 */     GIR_EraseRootFromParent_Done,
     /* 1320851 */   // Label 18916: @1320851
     /* 1320851 */   GIM_Try, /*On fail goto*//*Label 18917*/ GIMT_Encode4(1320932), // Rule ID 13869 //
     /* 1320856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1320859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1320867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1320870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1320873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1320876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1320879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1320886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320909 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1320909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1320912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1320930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320931 */     // GIR_Coverage, 13869,
     /* 1320931 */     GIR_EraseRootFromParent_Done,
     /* 1320932 */   // Label 18917: @1320932
     /* 1320932 */   GIM_Try, /*On fail goto*//*Label 18918*/ GIMT_Encode4(1321013), // Rule ID 13870 //
     /* 1320937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1320940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1320945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1320948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1320951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1320954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1320957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1320960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1320967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320990 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1320990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1320993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321012 */     // GIR_Coverage, 13870,
     /* 1321012 */     GIR_EraseRootFromParent_Done,
     /* 1321013 */   // Label 18918: @1321013
     /* 1321013 */   GIM_Try, /*On fail goto*//*Label 18919*/ GIMT_Encode4(1321094), // Rule ID 13871 //
     /* 1321018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1321029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1321032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1321035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1321038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1321041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321071 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1321071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1321092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321093 */     // GIR_Coverage, 13871,
     /* 1321093 */     GIR_EraseRootFromParent_Done,
     /* 1321094 */   // Label 18919: @1321094
     /* 1321094 */   GIM_Try, /*On fail goto*//*Label 18920*/ GIMT_Encode4(1321175), // Rule ID 13872 //
     /* 1321099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321174 */     // GIR_Coverage, 13872,
     /* 1321174 */     GIR_EraseRootFromParent_Done,
     /* 1321175 */   // Label 18920: @1321175
     /* 1321175 */   GIM_Try, /*On fail goto*//*Label 18921*/ GIMT_Encode4(1321256), // Rule ID 13873 //
     /* 1321180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1321191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1321194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1321197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1321200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321255 */     // GIR_Coverage, 13873,
     /* 1321255 */     GIR_EraseRootFromParent_Done,
     /* 1321256 */   // Label 18921: @1321256
     /* 1321256 */   GIM_Try, /*On fail goto*//*Label 18922*/ GIMT_Encode4(1321337), // Rule ID 13874 //
     /* 1321261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321336 */     // GIR_Coverage, 13874,
     /* 1321336 */     GIR_EraseRootFromParent_Done,
     /* 1321337 */   // Label 18922: @1321337
     /* 1321337 */   GIM_Try, /*On fail goto*//*Label 18923*/ GIMT_Encode4(1321418), // Rule ID 13875 //
     /* 1321342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1321353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1321356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1321359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1321362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321395 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321417 */     // GIR_Coverage, 13875,
     /* 1321417 */     GIR_EraseRootFromParent_Done,
     /* 1321418 */   // Label 18923: @1321418
     /* 1321418 */   GIM_Try, /*On fail goto*//*Label 18924*/ GIMT_Encode4(1321499), // Rule ID 13876 //
     /* 1321423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321476 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1321476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321498 */     // GIR_Coverage, 13876,
     /* 1321498 */     GIR_EraseRootFromParent_Done,
     /* 1321499 */   // Label 18924: @1321499
     /* 1321499 */   GIM_Try, /*On fail goto*//*Label 18925*/ GIMT_Encode4(1321580), // Rule ID 13877 //
     /* 1321504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1321515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1321518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1321521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1321524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1321527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321557 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1321557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321579 */     // GIR_Coverage, 13877,
     /* 1321579 */     GIR_EraseRootFromParent_Done,
     /* 1321580 */   // Label 18925: @1321580
     /* 1321580 */   GIM_Try, /*On fail goto*//*Label 18926*/ GIMT_Encode4(1321661), // Rule ID 13878 //
     /* 1321585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1321596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1321599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1321602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1321605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321638 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1321638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321660 */     // GIR_Coverage, 13878,
     /* 1321660 */     GIR_EraseRootFromParent_Done,
     /* 1321661 */   // Label 18926: @1321661
     /* 1321661 */   GIM_Try, /*On fail goto*//*Label 18927*/ GIMT_Encode4(1321742), // Rule ID 13879 //
     /* 1321666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1321677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1321680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1321683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1321686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1321696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1321719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1321722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321741 */     // GIR_Coverage, 13879,
     /* 1321741 */     GIR_EraseRootFromParent_Done,
     /* 1321742 */   // Label 18927: @1321742
     /* 1321742 */   GIM_Try, /*On fail goto*//*Label 18928*/ GIMT_Encode4(1321823), // Rule ID 13880 //
     /* 1321747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1321758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1321761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1321764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1321767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1321800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321822 */     // GIR_Coverage, 13880,
     /* 1321822 */     GIR_EraseRootFromParent_Done,
     /* 1321823 */   // Label 18928: @1321823
     /* 1321823 */   GIM_Try, /*On fail goto*//*Label 18929*/ GIMT_Encode4(1321904), // Rule ID 13881 //
     /* 1321828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1321839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1321842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1321845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1321848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1321858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321881 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1321881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1321884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321903 */     // GIR_Coverage, 13881,
     /* 1321903 */     GIR_EraseRootFromParent_Done,
     /* 1321904 */   // Label 18929: @1321904
     /* 1321904 */   GIM_Try, /*On fail goto*//*Label 18930*/ GIMT_Encode4(1321985), // Rule ID 13882 //
     /* 1321909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1321912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1321920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1321923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1321926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1321929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1321939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1321962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1321965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321984 */     // GIR_Coverage, 13882,
     /* 1321984 */     GIR_EraseRootFromParent_Done,
     /* 1321985 */   // Label 18930: @1321985
     /* 1321985 */   GIM_Try, /*On fail goto*//*Label 18931*/ GIMT_Encode4(1322066), // Rule ID 13883 //
     /* 1321990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1321993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1321998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1322001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1322004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1322007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1322010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1322013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322043 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1322043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322065 */     // GIR_Coverage, 13883,
     /* 1322065 */     GIR_EraseRootFromParent_Done,
     /* 1322066 */   // Label 18931: @1322066
     /* 1322066 */   GIM_Try, /*On fail goto*//*Label 18932*/ GIMT_Encode4(1322147), // Rule ID 13884 //
     /* 1322071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322146 */     // GIR_Coverage, 13884,
     /* 1322146 */     GIR_EraseRootFromParent_Done,
     /* 1322147 */   // Label 18932: @1322147
     /* 1322147 */   GIM_Try, /*On fail goto*//*Label 18933*/ GIMT_Encode4(1322228), // Rule ID 13885 //
     /* 1322152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1322163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1322166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1322169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1322172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1322182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1322194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1322208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322227 */     // GIR_Coverage, 13885,
     /* 1322227 */     GIR_EraseRootFromParent_Done,
     /* 1322228 */   // Label 18933: @1322228
     /* 1322228 */   GIM_Try, /*On fail goto*//*Label 18934*/ GIMT_Encode4(1322309), // Rule ID 13886 //
     /* 1322233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322286 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322308 */     // GIR_Coverage, 13886,
     /* 1322308 */     GIR_EraseRootFromParent_Done,
     /* 1322309 */   // Label 18934: @1322309
     /* 1322309 */   GIM_Try, /*On fail goto*//*Label 18935*/ GIMT_Encode4(1322390), // Rule ID 13887 //
     /* 1322314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1322325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1322328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1322331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1322334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1322344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1322356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322367 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1322370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322389 */     // GIR_Coverage, 13887,
     /* 1322389 */     GIR_EraseRootFromParent_Done,
     /* 1322390 */   // Label 18935: @1322390
     /* 1322390 */   GIM_Try, /*On fail goto*//*Label 18936*/ GIMT_Encode4(1322471), // Rule ID 13888 //
     /* 1322395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1322398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1322406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1322409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322448 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1322448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322470 */     // GIR_Coverage, 13888,
     /* 1322470 */     GIR_EraseRootFromParent_Done,
     /* 1322471 */   // Label 18936: @1322471
     /* 1322471 */   GIM_Try, /*On fail goto*//*Label 18937*/ GIMT_Encode4(1322552), // Rule ID 13889 //
     /* 1322476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1322479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1322487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1322490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1322493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1322496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1322499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1322506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322529 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1322529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1322532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322551 */     // GIR_Coverage, 13889,
     /* 1322551 */     GIR_EraseRootFromParent_Done,
     /* 1322552 */   // Label 18937: @1322552
     /* 1322552 */   GIM_Try, /*On fail goto*//*Label 18938*/ GIMT_Encode4(1322633), // Rule ID 13890 //
     /* 1322557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1322568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1322571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1322574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322610 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1322610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1322613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322632 */     // GIR_Coverage, 13890,
     /* 1322632 */     GIR_EraseRootFromParent_Done,
     /* 1322633 */   // Label 18938: @1322633
     /* 1322633 */   GIM_Try, /*On fail goto*//*Label 18939*/ GIMT_Encode4(1322714), // Rule ID 13891 //
     /* 1322638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1322649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1322652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1322655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322691 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1322691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1322694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322713 */     // GIR_Coverage, 13891,
     /* 1322713 */     GIR_EraseRootFromParent_Done,
     /* 1322714 */   // Label 18939: @1322714
     /* 1322714 */   GIM_Try, /*On fail goto*//*Label 18940*/ GIMT_Encode4(1322795), // Rule ID 13892 //
     /* 1322719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1322730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1322733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1322736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322772 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1322772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1322775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322794 */     // GIR_Coverage, 13892,
     /* 1322794 */     GIR_EraseRootFromParent_Done,
     /* 1322795 */   // Label 18940: @1322795
     /* 1322795 */   GIM_Try, /*On fail goto*//*Label 18941*/ GIMT_Encode4(1322876), // Rule ID 13893 //
     /* 1322800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1322811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1322814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1322817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322853 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1322853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1322856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322875 */     // GIR_Coverage, 13893,
     /* 1322875 */     GIR_EraseRootFromParent_Done,
     /* 1322876 */   // Label 18941: @1322876
     /* 1322876 */   GIM_Try, /*On fail goto*//*Label 18942*/ GIMT_Encode4(1322957), // Rule ID 13894 //
     /* 1322881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1322884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1322892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1322895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1322898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1322923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1322934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1322937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1322955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322956 */     // GIR_Coverage, 13894,
     /* 1322956 */     GIR_EraseRootFromParent_Done,
     /* 1322957 */   // Label 18942: @1322957
     /* 1322957 */   GIM_Try, /*On fail goto*//*Label 18943*/ GIMT_Encode4(1323038), // Rule ID 13895 //
     /* 1322962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1322965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1322970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1322973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1322976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1322979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1322992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323015 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323037 */     // GIR_Coverage, 13895,
     /* 1323037 */     GIR_EraseRootFromParent_Done,
     /* 1323038 */   // Label 18943: @1323038
     /* 1323038 */   GIM_Try, /*On fail goto*//*Label 18944*/ GIMT_Encode4(1323119), // Rule ID 13896 //
     /* 1323043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323096 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323118 */     // GIR_Coverage, 13896,
     /* 1323118 */     GIR_EraseRootFromParent_Done,
     /* 1323119 */   // Label 18944: @1323119
     /* 1323119 */   GIM_Try, /*On fail goto*//*Label 18945*/ GIMT_Encode4(1323200), // Rule ID 13897 //
     /* 1323124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1323135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1323138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1323141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1323180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323199 */     // GIR_Coverage, 13897,
     /* 1323199 */     GIR_EraseRootFromParent_Done,
     /* 1323200 */   // Label 18945: @1323200
     /* 1323200 */   GIM_Try, /*On fail goto*//*Label 18946*/ GIMT_Encode4(1323281), // Rule ID 13898 //
     /* 1323205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323258 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323280 */     // GIR_Coverage, 13898,
     /* 1323280 */     GIR_EraseRootFromParent_Done,
     /* 1323281 */   // Label 18946: @1323281
     /* 1323281 */   GIM_Try, /*On fail goto*//*Label 18947*/ GIMT_Encode4(1323362), // Rule ID 13899 //
     /* 1323286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1323297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1323300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1323303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323339 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323361 */     // GIR_Coverage, 13899,
     /* 1323361 */     GIR_EraseRootFromParent_Done,
     /* 1323362 */   // Label 18947: @1323362
     /* 1323362 */   GIM_Try, /*On fail goto*//*Label 18948*/ GIMT_Encode4(1323443), // Rule ID 13900 //
     /* 1323367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323420 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1323420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323442 */     // GIR_Coverage, 13900,
     /* 1323442 */     GIR_EraseRootFromParent_Done,
     /* 1323443 */   // Label 18948: @1323443
     /* 1323443 */   GIM_Try, /*On fail goto*//*Label 18949*/ GIMT_Encode4(1323524), // Rule ID 13901 //
     /* 1323448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1323459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1323462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1323465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323501 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1323504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323523 */     // GIR_Coverage, 13901,
     /* 1323523 */     GIR_EraseRootFromParent_Done,
     /* 1323524 */   // Label 18949: @1323524
     /* 1323524 */   GIM_Try, /*On fail goto*//*Label 18950*/ GIMT_Encode4(1323605), // Rule ID 13902 //
     /* 1323529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1323540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1323543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1323546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1323582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323604 */     // GIR_Coverage, 13902,
     /* 1323604 */     GIR_EraseRootFromParent_Done,
     /* 1323605 */   // Label 18950: @1323605
     /* 1323605 */   GIM_Try, /*On fail goto*//*Label 18951*/ GIMT_Encode4(1323686), // Rule ID 13903 //
     /* 1323610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1323621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1323624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1323627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323663 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1323663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1323684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323685 */     // GIR_Coverage, 13903,
     /* 1323685 */     GIR_EraseRootFromParent_Done,
     /* 1323686 */   // Label 18951: @1323686
     /* 1323686 */   GIM_Try, /*On fail goto*//*Label 18952*/ GIMT_Encode4(1323767), // Rule ID 13904 //
     /* 1323691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1323702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1323705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1323708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1323744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323766 */     // GIR_Coverage, 13904,
     /* 1323766 */     GIR_EraseRootFromParent_Done,
     /* 1323767 */   // Label 18952: @1323767
     /* 1323767 */   GIM_Try, /*On fail goto*//*Label 18953*/ GIMT_Encode4(1323848), // Rule ID 13905 //
     /* 1323772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1323783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1323786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1323789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1323825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323847 */     // GIR_Coverage, 13905,
     /* 1323847 */     GIR_EraseRootFromParent_Done,
     /* 1323848 */   // Label 18953: @1323848
     /* 1323848 */   GIM_Try, /*On fail goto*//*Label 18954*/ GIMT_Encode4(1323929), // Rule ID 13906 //
     /* 1323853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1323856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1323864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1323867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1323870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1323873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1323906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323928 */     // GIR_Coverage, 13906,
     /* 1323928 */     GIR_EraseRootFromParent_Done,
     /* 1323929 */   // Label 18954: @1323929
     /* 1323929 */   GIM_Try, /*On fail goto*//*Label 18955*/ GIMT_Encode4(1324010), // Rule ID 13907 //
     /* 1323934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1323937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1323942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1323945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1323948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1323951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1323957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1323964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1323976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323987 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1323987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1323990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324009 */     // GIR_Coverage, 13907,
     /* 1324009 */     GIR_EraseRootFromParent_Done,
     /* 1324010 */   // Label 18955: @1324010
     /* 1324010 */   GIM_Try, /*On fail goto*//*Label 18956*/ GIMT_Encode4(1324091), // Rule ID 13908 //
     /* 1324015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1324018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1324068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324090 */     // GIR_Coverage, 13908,
     /* 1324090 */     GIR_EraseRootFromParent_Done,
     /* 1324091 */   // Label 18956: @1324091
     /* 1324091 */   GIM_Try, /*On fail goto*//*Label 18957*/ GIMT_Encode4(1324172), // Rule ID 13909 //
     /* 1324096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1324099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1324107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1324110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1324113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1324126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324149 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1324149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1324152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324171 */     // GIR_Coverage, 13909,
     /* 1324171 */     GIR_EraseRootFromParent_Done,
     /* 1324172 */   // Label 18957: @1324172
     /* 1324172 */   GIM_Try, /*On fail goto*//*Label 18958*/ GIMT_Encode4(1324253), // Rule ID 13910 //
     /* 1324177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324252 */     // GIR_Coverage, 13910,
     /* 1324252 */     GIR_EraseRootFromParent_Done,
     /* 1324253 */   // Label 18958: @1324253
     /* 1324253 */   GIM_Try, /*On fail goto*//*Label 18959*/ GIMT_Encode4(1324334), // Rule ID 13911 //
     /* 1324258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1324269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1324272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1324275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324333 */     // GIR_Coverage, 13911,
     /* 1324333 */     GIR_EraseRootFromParent_Done,
     /* 1324334 */   // Label 18959: @1324334
     /* 1324334 */   GIM_Try, /*On fail goto*//*Label 18960*/ GIMT_Encode4(1324415), // Rule ID 13912 //
     /* 1324339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324392 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324414 */     // GIR_Coverage, 13912,
     /* 1324414 */     GIR_EraseRootFromParent_Done,
     /* 1324415 */   // Label 18960: @1324415
     /* 1324415 */   GIM_Try, /*On fail goto*//*Label 18961*/ GIMT_Encode4(1324496), // Rule ID 13913 //
     /* 1324420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1324431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1324434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1324437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1324443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324473 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324495 */     // GIR_Coverage, 13913,
     /* 1324495 */     GIR_EraseRootFromParent_Done,
     /* 1324496 */   // Label 18961: @1324496
     /* 1324496 */   GIM_Try, /*On fail goto*//*Label 18962*/ GIMT_Encode4(1324577), // Rule ID 13914 //
     /* 1324501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1324512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1324515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1324518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1324524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1324531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324554 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1324554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1324557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324576 */     // GIR_Coverage, 13914,
     /* 1324576 */     GIR_EraseRootFromParent_Done,
     /* 1324577 */   // Label 18962: @1324577
     /* 1324577 */   GIM_Try, /*On fail goto*//*Label 18963*/ GIMT_Encode4(1324658), // Rule ID 13915 //
     /* 1324582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1324593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1324596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1324599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1324605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1324612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324635 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1324635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1324638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1324656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324657 */     // GIR_Coverage, 13915,
     /* 1324657 */     GIR_EraseRootFromParent_Done,
     /* 1324658 */   // Label 18963: @1324658
     /* 1324658 */   GIM_Try, /*On fail goto*//*Label 18964*/ GIMT_Encode4(1324739), // Rule ID 13916 //
     /* 1324663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1324674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1324677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1324680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1324716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324738 */     // GIR_Coverage, 13916,
     /* 1324738 */     GIR_EraseRootFromParent_Done,
     /* 1324739 */   // Label 18964: @1324739
     /* 1324739 */   GIM_Try, /*On fail goto*//*Label 18965*/ GIMT_Encode4(1324820), // Rule ID 13917 //
     /* 1324744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1324755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1324758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1324761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1324774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1324797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1324800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324819 */     // GIR_Coverage, 13917,
     /* 1324819 */     GIR_EraseRootFromParent_Done,
     /* 1324820 */   // Label 18965: @1324820
     /* 1324820 */   GIM_Try, /*On fail goto*//*Label 18966*/ GIMT_Encode4(1324901), // Rule ID 13918 //
     /* 1324825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1324836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1324839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1324842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324878 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1324878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324900 */     // GIR_Coverage, 13918,
     /* 1324900 */     GIR_EraseRootFromParent_Done,
     /* 1324901 */   // Label 18966: @1324901
     /* 1324901 */   GIM_Try, /*On fail goto*//*Label 18967*/ GIMT_Encode4(1324982), // Rule ID 13919 //
     /* 1324906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1324909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1324917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1324920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1324923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1324936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1324948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1324959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1324962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324981 */     // GIR_Coverage, 13919,
     /* 1324981 */     GIR_EraseRootFromParent_Done,
     /* 1324982 */   // Label 18967: @1324982
     /* 1324982 */   GIM_Try, /*On fail goto*//*Label 18968*/ GIMT_Encode4(1325063), // Rule ID 13920 //
     /* 1324987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1324990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1324995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1324998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1325040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325062 */     // GIR_Coverage, 13920,
     /* 1325062 */     GIR_EraseRootFromParent_Done,
     /* 1325063 */   // Label 18968: @1325063
     /* 1325063 */   GIM_Try, /*On fail goto*//*Label 18969*/ GIMT_Encode4(1325144), // Rule ID 13921 //
     /* 1325068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1325079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1325082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325121 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1325121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325143 */     // GIR_Coverage, 13921,
     /* 1325143 */     GIR_EraseRootFromParent_Done,
     /* 1325144 */   // Label 18969: @1325144
     /* 1325144 */   GIM_Try, /*On fail goto*//*Label 18970*/ GIMT_Encode4(1325225), // Rule ID 13922 //
     /* 1325149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325224 */     // GIR_Coverage, 13922,
     /* 1325224 */     GIR_EraseRootFromParent_Done,
     /* 1325225 */   // Label 18970: @1325225
     /* 1325225 */   GIM_Try, /*On fail goto*//*Label 18971*/ GIMT_Encode4(1325306), // Rule ID 13923 //
     /* 1325230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1325241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1325244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1325247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325283 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325305 */     // GIR_Coverage, 13923,
     /* 1325305 */     GIR_EraseRootFromParent_Done,
     /* 1325306 */   // Label 18971: @1325306
     /* 1325306 */   GIM_Try, /*On fail goto*//*Label 18972*/ GIMT_Encode4(1325387), // Rule ID 13924 //
     /* 1325311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325386 */     // GIR_Coverage, 13924,
     /* 1325386 */     GIR_EraseRootFromParent_Done,
     /* 1325387 */   // Label 18972: @1325387
     /* 1325387 */   GIM_Try, /*On fail goto*//*Label 18973*/ GIMT_Encode4(1325468), // Rule ID 13925 //
     /* 1325392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1325403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1325406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1325409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325445 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325467 */     // GIR_Coverage, 13925,
     /* 1325467 */     GIR_EraseRootFromParent_Done,
     /* 1325468 */   // Label 18973: @1325468
     /* 1325468 */   GIM_Try, /*On fail goto*//*Label 18974*/ GIMT_Encode4(1325549), // Rule ID 13926 //
     /* 1325473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1325476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1325484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1325487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1325526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325548 */     // GIR_Coverage, 13926,
     /* 1325548 */     GIR_EraseRootFromParent_Done,
     /* 1325549 */   // Label 18974: @1325549
     /* 1325549 */   GIM_Try, /*On fail goto*//*Label 18975*/ GIMT_Encode4(1325630), // Rule ID 13927 //
     /* 1325554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1325557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1325565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1325568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1325571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325607 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1325607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1325610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325629 */     // GIR_Coverage, 13927,
     /* 1325629 */     GIR_EraseRootFromParent_Done,
     /* 1325630 */   // Label 18975: @1325630
     /* 1325630 */   GIM_Try, /*On fail goto*//*Label 18976*/ GIMT_Encode4(1325711), // Rule ID 13928 //
     /* 1325635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1325638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1325646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1325649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1325652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1325658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1325688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325710 */     // GIR_Coverage, 13928,
     /* 1325710 */     GIR_EraseRootFromParent_Done,
     /* 1325711 */   // Label 18976: @1325711
     /* 1325711 */   GIM_Try, /*On fail goto*//*Label 18977*/ GIMT_Encode4(1325792), // Rule ID 13929 //
     /* 1325716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1325719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1325727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1325730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1325733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1325739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1325746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1325769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1325772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325791 */     // GIR_Coverage, 13929,
     /* 1325791 */     GIR_EraseRootFromParent_Done,
     /* 1325792 */   // Label 18977: @1325792
     /* 1325792 */   GIM_Try, /*On fail goto*//*Label 18978*/ GIMT_Encode4(1325873), // Rule ID 13930 //
     /* 1325797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1325800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1325808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1325811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1325814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1325850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325872 */     // GIR_Coverage, 13930,
     /* 1325872 */     GIR_EraseRootFromParent_Done,
     /* 1325873 */   // Label 18978: @1325873
     /* 1325873 */   GIM_Try, /*On fail goto*//*Label 18979*/ GIMT_Encode4(1325954), // Rule ID 13931 //
     /* 1325878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1325881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1325889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1325892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1325895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1325898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1325908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1325920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325931 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1325931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1325934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325953 */     // GIR_Coverage, 13931,
     /* 1325953 */     GIR_EraseRootFromParent_Done,
     /* 1325954 */   // Label 18979: @1325954
     /* 1325954 */   GIM_Try, /*On fail goto*//*Label 18980*/ GIMT_Encode4(1326035), // Rule ID 13932 //
     /* 1325959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1325962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1325967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1325970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1325973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1325976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1325979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1325989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1326012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326034 */     // GIR_Coverage, 13932,
     /* 1326034 */     GIR_EraseRootFromParent_Done,
     /* 1326035 */   // Label 18980: @1326035
     /* 1326035 */   GIM_Try, /*On fail goto*//*Label 18981*/ GIMT_Encode4(1326116), // Rule ID 13933 //
     /* 1326040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1326043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1326048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1326051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1326054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1326060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1326070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1326082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326093 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1326093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1326096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326115 */     // GIR_Coverage, 13933,
     /* 1326115 */     GIR_EraseRootFromParent_Done,
     /* 1326116 */   // Label 18981: @1326116
     /* 1326116 */   GIM_Try, /*On fail goto*//*Label 18982*/ GIMT_Encode4(1326200), // Rule ID 19772 //
     /* 1326121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1326141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326174 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1326177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326199 */     // GIR_Coverage, 19772,
     /* 1326199 */     GIR_EraseRootFromParent_Done,
     /* 1326200 */   // Label 18982: @1326200
     /* 1326200 */   GIM_Try, /*On fail goto*//*Label 18983*/ GIMT_Encode4(1326284), // Rule ID 19773 //
     /* 1326205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1326222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1326225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326258 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1326261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326283 */     // GIR_Coverage, 19773,
     /* 1326283 */     GIR_EraseRootFromParent_Done,
     /* 1326284 */   // Label 18983: @1326284
     /* 1326284 */   GIM_Try, /*On fail goto*//*Label 18984*/ GIMT_Encode4(1326368), // Rule ID 19776 //
     /* 1326289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1326309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326342 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326367 */     // GIR_Coverage, 19776,
     /* 1326367 */     GIR_EraseRootFromParent_Done,
     /* 1326368 */   // Label 18984: @1326368
     /* 1326368 */   GIM_Try, /*On fail goto*//*Label 18985*/ GIMT_Encode4(1326452), // Rule ID 19777 //
     /* 1326373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1326390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1326393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326426 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326451 */     // GIR_Coverage, 19777,
     /* 1326451 */     GIR_EraseRootFromParent_Done,
     /* 1326452 */   // Label 18985: @1326452
     /* 1326452 */   GIM_Try, /*On fail goto*//*Label 18986*/ GIMT_Encode4(1326536), // Rule ID 19780 //
     /* 1326457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1326474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1326477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326510 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326535 */     // GIR_Coverage, 19780,
     /* 1326535 */     GIR_EraseRootFromParent_Done,
     /* 1326536 */   // Label 18986: @1326536
     /* 1326536 */   GIM_Try, /*On fail goto*//*Label 18987*/ GIMT_Encode4(1326620), // Rule ID 19781 //
     /* 1326541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1326544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1326558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1326561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326594 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1326597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326619 */     // GIR_Coverage, 19781,
     /* 1326619 */     GIR_EraseRootFromParent_Done,
     /* 1326620 */   // Label 18987: @1326620
     /* 1326620 */   GIM_Try, /*On fail goto*//*Label 18988*/ GIMT_Encode4(1326704), // Rule ID 19784 //
     /* 1326625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1326628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1326642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1326645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326678 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1326681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326703 */     // GIR_Coverage, 19784,
     /* 1326703 */     GIR_EraseRootFromParent_Done,
     /* 1326704 */   // Label 18988: @1326704
     /* 1326704 */   GIM_Try, /*On fail goto*//*Label 18989*/ GIMT_Encode4(1326788), // Rule ID 19785 //
     /* 1326709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1326726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1326729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1326765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326787 */     // GIR_Coverage, 19785,
     /* 1326787 */     GIR_EraseRootFromParent_Done,
     /* 1326788 */   // Label 18989: @1326788
     /* 1326788 */   GIM_Try, /*On fail goto*//*Label 18990*/ GIMT_Encode4(1326872), // Rule ID 19788 //
     /* 1326793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1326810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1326813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326846 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1326849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326871 */     // GIR_Coverage, 19788,
     /* 1326871 */     GIR_EraseRootFromParent_Done,
     /* 1326872 */   // Label 18990: @1326872
     /* 1326872 */   GIM_Try, /*On fail goto*//*Label 18991*/ GIMT_Encode4(1326956), // Rule ID 19789 //
     /* 1326877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1326880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1326894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1326897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326930 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1326933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326955 */     // GIR_Coverage, 19789,
     /* 1326955 */     GIR_EraseRootFromParent_Done,
     /* 1326956 */   // Label 18991: @1326956
     /* 1326956 */   GIM_Try, /*On fail goto*//*Label 18992*/ GIMT_Encode4(1327040), // Rule ID 19792 //
     /* 1326961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1326964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1326969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1326972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1326975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1326978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1326981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1326984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327014 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327039 */     // GIR_Coverage, 19792,
     /* 1327039 */     GIR_EraseRootFromParent_Done,
     /* 1327040 */   // Label 18992: @1327040
     /* 1327040 */   GIM_Try, /*On fail goto*//*Label 18993*/ GIMT_Encode4(1327124), // Rule ID 19793 //
     /* 1327045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1327048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1327065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327098 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1327101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327123 */     // GIR_Coverage, 19793,
     /* 1327123 */     GIR_EraseRootFromParent_Done,
     /* 1327124 */   // Label 18993: @1327124
     /* 1327124 */   GIM_Try, /*On fail goto*//*Label 18994*/ GIMT_Encode4(1327208), // Rule ID 19796 //
     /* 1327129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1327149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327182 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327207 */     // GIR_Coverage, 19796,
     /* 1327207 */     GIR_EraseRootFromParent_Done,
     /* 1327208 */   // Label 18994: @1327208
     /* 1327208 */   GIM_Try, /*On fail goto*//*Label 18995*/ GIMT_Encode4(1327292), // Rule ID 19797 //
     /* 1327213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1327230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1327233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327266 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327291 */     // GIR_Coverage, 19797,
     /* 1327291 */     GIR_EraseRootFromParent_Done,
     /* 1327292 */   // Label 18995: @1327292
     /* 1327292 */   GIM_Try, /*On fail goto*//*Label 18996*/ GIMT_Encode4(1327376), // Rule ID 19800 //
     /* 1327297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1327317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327350 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327375 */     // GIR_Coverage, 19800,
     /* 1327375 */     GIR_EraseRootFromParent_Done,
     /* 1327376 */   // Label 18996: @1327376
     /* 1327376 */   GIM_Try, /*On fail goto*//*Label 18997*/ GIMT_Encode4(1327460), // Rule ID 19801 //
     /* 1327381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1327398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1327401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327434 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327459 */     // GIR_Coverage, 19801,
     /* 1327459 */     GIR_EraseRootFromParent_Done,
     /* 1327460 */   // Label 18997: @1327460
     /* 1327460 */   GIM_Try, /*On fail goto*//*Label 18998*/ GIMT_Encode4(1327544), // Rule ID 19804 //
     /* 1327465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1327476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1327479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1327482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1327485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1327488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327518 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1327521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327543 */     // GIR_Coverage, 19804,
     /* 1327543 */     GIR_EraseRootFromParent_Done,
     /* 1327544 */   // Label 18998: @1327544
     /* 1327544 */   GIM_Try, /*On fail goto*//*Label 18999*/ GIMT_Encode4(1327628), // Rule ID 19805 //
     /* 1327549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1327560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1327563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1327566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1327569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1327572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327602 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1327605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327627 */     // GIR_Coverage, 19805,
     /* 1327627 */     GIR_EraseRootFromParent_Done,
     /* 1327628 */   // Label 18999: @1327628
     /* 1327628 */   GIM_Try, /*On fail goto*//*Label 19000*/ GIMT_Encode4(1327712), // Rule ID 19808 //
     /* 1327633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1327650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1327653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327686 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327711 */     // GIR_Coverage, 19808,
     /* 1327711 */     GIR_EraseRootFromParent_Done,
     /* 1327712 */   // Label 19000: @1327712
     /* 1327712 */   GIM_Try, /*On fail goto*//*Label 19001*/ GIMT_Encode4(1327796), // Rule ID 19809 //
     /* 1327717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1327734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1327737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1327759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327770 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1327773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327795 */     // GIR_Coverage, 19809,
     /* 1327795 */     GIR_EraseRootFromParent_Done,
     /* 1327796 */   // Label 19001: @1327796
     /* 1327796 */   GIM_Try, /*On fail goto*//*Label 19002*/ GIMT_Encode4(1327880), // Rule ID 19812 //
     /* 1327801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1327818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1327821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327854 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327879 */     // GIR_Coverage, 19812,
     /* 1327879 */     GIR_EraseRootFromParent_Done,
     /* 1327880 */   // Label 19002: @1327880
     /* 1327880 */   GIM_Try, /*On fail goto*//*Label 19003*/ GIMT_Encode4(1327964), // Rule ID 19813 //
     /* 1327885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1327902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1327905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1327927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327938 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1327941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327963 */     // GIR_Coverage, 19813,
     /* 1327963 */     GIR_EraseRootFromParent_Done,
     /* 1327964 */   // Label 19003: @1327964
     /* 1327964 */   GIM_Try, /*On fail goto*//*Label 19004*/ GIMT_Encode4(1328048), // Rule ID 19816 //
     /* 1327969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1327977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1327980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1327983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1327986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1327989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1327992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328022 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328047 */     // GIR_Coverage, 19816,
     /* 1328047 */     GIR_EraseRootFromParent_Done,
     /* 1328048 */   // Label 19004: @1328048
     /* 1328048 */   GIM_Try, /*On fail goto*//*Label 19005*/ GIMT_Encode4(1328132), // Rule ID 19817 //
     /* 1328053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1328070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1328073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328106 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328131 */     // GIR_Coverage, 19817,
     /* 1328131 */     GIR_EraseRootFromParent_Done,
     /* 1328132 */   // Label 19005: @1328132
     /* 1328132 */   GIM_Try, /*On fail goto*//*Label 19006*/ GIMT_Encode4(1328216), // Rule ID 19820 //
     /* 1328137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1328157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328190 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328215 */     // GIR_Coverage, 19820,
     /* 1328215 */     GIR_EraseRootFromParent_Done,
     /* 1328216 */   // Label 19006: @1328216
     /* 1328216 */   GIM_Try, /*On fail goto*//*Label 19007*/ GIMT_Encode4(1328300), // Rule ID 19821 //
     /* 1328221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1328238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1328241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328274 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1328277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328299 */     // GIR_Coverage, 19821,
     /* 1328299 */     GIR_EraseRootFromParent_Done,
     /* 1328300 */   // Label 19007: @1328300
     /* 1328300 */   GIM_Try, /*On fail goto*//*Label 19008*/ GIMT_Encode4(1328384), // Rule ID 19824 //
     /* 1328305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1328325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328358 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328383 */     // GIR_Coverage, 19824,
     /* 1328383 */     GIR_EraseRootFromParent_Done,
     /* 1328384 */   // Label 19008: @1328384
     /* 1328384 */   GIM_Try, /*On fail goto*//*Label 19009*/ GIMT_Encode4(1328468), // Rule ID 19825 //
     /* 1328389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1328406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1328409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1328445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328467 */     // GIR_Coverage, 19825,
     /* 1328467 */     GIR_EraseRootFromParent_Done,
     /* 1328468 */   // Label 19009: @1328468
     /* 1328468 */   GIM_Try, /*On fail goto*//*Label 19010*/ GIMT_Encode4(1328552), // Rule ID 19828 //
     /* 1328473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1328476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1328490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1328493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328526 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328551 */     // GIR_Coverage, 19828,
     /* 1328551 */     GIR_EraseRootFromParent_Done,
     /* 1328552 */   // Label 19010: @1328552
     /* 1328552 */   GIM_Try, /*On fail goto*//*Label 19011*/ GIMT_Encode4(1328636), // Rule ID 19829 //
     /* 1328557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1328574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1328577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328610 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1328613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328635 */     // GIR_Coverage, 19829,
     /* 1328635 */     GIR_EraseRootFromParent_Done,
     /* 1328636 */   // Label 19011: @1328636
     /* 1328636 */   GIM_Try, /*On fail goto*//*Label 19012*/ GIMT_Encode4(1328720), // Rule ID 19832 //
     /* 1328641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1328644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1328652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1328655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1328658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1328664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328694 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1328697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328719 */     // GIR_Coverage, 19832,
     /* 1328719 */     GIR_EraseRootFromParent_Done,
     /* 1328720 */   // Label 19012: @1328720
     /* 1328720 */   GIM_Try, /*On fail goto*//*Label 19013*/ GIMT_Encode4(1328804), // Rule ID 19833 //
     /* 1328725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1328728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1328736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1328739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1328742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1328748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328778 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1328781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328803 */     // GIR_Coverage, 19833,
     /* 1328803 */     GIR_EraseRootFromParent_Done,
     /* 1328804 */   // Label 19013: @1328804
     /* 1328804 */   GIM_Try, /*On fail goto*//*Label 19014*/ GIMT_Encode4(1328888), // Rule ID 19836 //
     /* 1328809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1328812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1328826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1328865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328887 */     // GIR_Coverage, 19836,
     /* 1328887 */     GIR_EraseRootFromParent_Done,
     /* 1328888 */   // Label 19014: @1328888
     /* 1328888 */   GIM_Try, /*On fail goto*//*Label 19015*/ GIMT_Encode4(1328972), // Rule ID 19837 //
     /* 1328893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1328896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1328904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1328907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1328910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1328916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328946 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1328949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328971 */     // GIR_Coverage, 19837,
     /* 1328971 */     GIR_EraseRootFromParent_Done,
     /* 1328972 */   // Label 19015: @1328972
     /* 1328972 */   GIM_Try, /*On fail goto*//*Label 19016*/ GIMT_Encode4(1329056), // Rule ID 19840 //
     /* 1328977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1328985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1328988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1328991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1328994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329030 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1329033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329055 */     // GIR_Coverage, 19840,
     /* 1329055 */     GIR_EraseRootFromParent_Done,
     /* 1329056 */   // Label 19016: @1329056
     /* 1329056 */   GIM_Try, /*On fail goto*//*Label 19017*/ GIMT_Encode4(1329140), // Rule ID 19841 //
     /* 1329061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329114 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1329117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329139 */     // GIR_Coverage, 19841,
     /* 1329139 */     GIR_EraseRootFromParent_Done,
     /* 1329140 */   // Label 19017: @1329140
     /* 1329140 */   GIM_Try, /*On fail goto*//*Label 19018*/ GIMT_Encode4(1329224), // Rule ID 19844 //
     /* 1329145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329198 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1329201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329223 */     // GIR_Coverage, 19844,
     /* 1329223 */     GIR_EraseRootFromParent_Done,
     /* 1329224 */   // Label 19018: @1329224
     /* 1329224 */   GIM_Try, /*On fail goto*//*Label 19019*/ GIMT_Encode4(1329308), // Rule ID 19845 //
     /* 1329229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1329246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1329285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329307 */     // GIR_Coverage, 19845,
     /* 1329307 */     GIR_EraseRootFromParent_Done,
     /* 1329308 */   // Label 19019: @1329308
     /* 1329308 */   GIM_Try, /*On fail goto*//*Label 19020*/ GIMT_Encode4(1329392), // Rule ID 19848 //
     /* 1329313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1329316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329366 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1329369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329391 */     // GIR_Coverage, 19848,
     /* 1329391 */     GIR_EraseRootFromParent_Done,
     /* 1329392 */   // Label 19020: @1329392
     /* 1329392 */   GIM_Try, /*On fail goto*//*Label 19021*/ GIMT_Encode4(1329476), // Rule ID 19849 //
     /* 1329397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1329414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329450 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1329453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329475 */     // GIR_Coverage, 19849,
     /* 1329475 */     GIR_EraseRootFromParent_Done,
     /* 1329476 */   // Label 19021: @1329476
     /* 1329476 */   GIM_Try, /*On fail goto*//*Label 19022*/ GIMT_Encode4(1329560), // Rule ID 19852 //
     /* 1329481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1329484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329534 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1329537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329559 */     // GIR_Coverage, 19852,
     /* 1329559 */     GIR_EraseRootFromParent_Done,
     /* 1329560 */   // Label 19022: @1329560
     /* 1329560 */   GIM_Try, /*On fail goto*//*Label 19023*/ GIMT_Encode4(1329644), // Rule ID 19853 //
     /* 1329565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1329568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1329582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329618 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1329621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329643 */     // GIR_Coverage, 19853,
     /* 1329643 */     GIR_EraseRootFromParent_Done,
     /* 1329644 */   // Label 19023: @1329644
     /* 1329644 */   GIM_Try, /*On fail goto*//*Label 19024*/ GIMT_Encode4(1329728), // Rule ID 19856 //
     /* 1329649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1329660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1329663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1329666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329702 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1329705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329727 */     // GIR_Coverage, 19856,
     /* 1329727 */     GIR_EraseRootFromParent_Done,
     /* 1329728 */   // Label 19024: @1329728
     /* 1329728 */   GIM_Try, /*On fail goto*//*Label 19025*/ GIMT_Encode4(1329812), // Rule ID 19857 //
     /* 1329733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1329744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1329747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1329750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329786 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1329789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329811 */     // GIR_Coverage, 19857,
     /* 1329811 */     GIR_EraseRootFromParent_Done,
     /* 1329812 */   // Label 19025: @1329812
     /* 1329812 */   GIM_Try, /*On fail goto*//*Label 19026*/ GIMT_Encode4(1329896), // Rule ID 19860 //
     /* 1329817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1329828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1329831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1329834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1329840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329870 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1329873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329895 */     // GIR_Coverage, 19860,
     /* 1329895 */     GIR_EraseRootFromParent_Done,
     /* 1329896 */   // Label 19026: @1329896
     /* 1329896 */   GIM_Try, /*On fail goto*//*Label 19027*/ GIMT_Encode4(1329980), // Rule ID 19861 //
     /* 1329901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1329912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1329915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1329918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1329921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1329924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1329943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329954 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1329957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329979 */     // GIR_Coverage, 19861,
     /* 1329979 */     GIR_EraseRootFromParent_Done,
     /* 1329980 */   // Label 19027: @1329980
     /* 1329980 */   GIM_Try, /*On fail goto*//*Label 19028*/ GIMT_Encode4(1330064), // Rule ID 19864 //
     /* 1329985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1329993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1329996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1329999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330038 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1330041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330063 */     // GIR_Coverage, 19864,
     /* 1330063 */     GIR_EraseRootFromParent_Done,
     /* 1330064 */   // Label 19028: @1330064
     /* 1330064 */   GIM_Try, /*On fail goto*//*Label 19029*/ GIMT_Encode4(1330148), // Rule ID 19865 //
     /* 1330069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1330089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1330111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330122 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1330125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330147 */     // GIR_Coverage, 19865,
     /* 1330147 */     GIR_EraseRootFromParent_Done,
     /* 1330148 */   // Label 19029: @1330148
     /* 1330148 */   GIM_Try, /*On fail goto*//*Label 19030*/ GIMT_Encode4(1330232), // Rule ID 19868 //
     /* 1330153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330206 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1330209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330231 */     // GIR_Coverage, 19868,
     /* 1330231 */     GIR_EraseRootFromParent_Done,
     /* 1330232 */   // Label 19030: @1330232
     /* 1330232 */   GIM_Try, /*On fail goto*//*Label 19031*/ GIMT_Encode4(1330316), // Rule ID 19869 //
     /* 1330237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1330254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330290 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1330293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330315 */     // GIR_Coverage, 19869,
     /* 1330315 */     GIR_EraseRootFromParent_Done,
     /* 1330316 */   // Label 19031: @1330316
     /* 1330316 */   GIM_Try, /*On fail goto*//*Label 19032*/ GIMT_Encode4(1330400), // Rule ID 19872 //
     /* 1330321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330374 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1330377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330399 */     // GIR_Coverage, 19872,
     /* 1330399 */     GIR_EraseRootFromParent_Done,
     /* 1330400 */   // Label 19032: @1330400
     /* 1330400 */   GIM_Try, /*On fail goto*//*Label 19033*/ GIMT_Encode4(1330484), // Rule ID 19873 //
     /* 1330405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1330422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330458 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1330461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330483 */     // GIR_Coverage, 19873,
     /* 1330483 */     GIR_EraseRootFromParent_Done,
     /* 1330484 */   // Label 19033: @1330484
     /* 1330484 */   GIM_Try, /*On fail goto*//*Label 19034*/ GIMT_Encode4(1330568), // Rule ID 19876 //
     /* 1330489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330542 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1330545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330567 */     // GIR_Coverage, 19876,
     /* 1330567 */     GIR_EraseRootFromParent_Done,
     /* 1330568 */   // Label 19034: @1330568
     /* 1330568 */   GIM_Try, /*On fail goto*//*Label 19035*/ GIMT_Encode4(1330652), // Rule ID 19877 //
     /* 1330573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1330590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1330593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1330615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330626 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1330629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330651 */     // GIR_Coverage, 19877,
     /* 1330651 */     GIR_EraseRootFromParent_Done,
     /* 1330652 */   // Label 19035: @1330652
     /* 1330652 */   GIM_Try, /*On fail goto*//*Label 19036*/ GIMT_Encode4(1330736), // Rule ID 19880 //
     /* 1330657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1330660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1330674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330710 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1330713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330735 */     // GIR_Coverage, 19880,
     /* 1330735 */     GIR_EraseRootFromParent_Done,
     /* 1330736 */   // Label 19036: @1330736
     /* 1330736 */   GIM_Try, /*On fail goto*//*Label 19037*/ GIMT_Encode4(1330820), // Rule ID 19881 //
     /* 1330741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1330744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1330758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330794 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1330797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330819 */     // GIR_Coverage, 19881,
     /* 1330819 */     GIR_EraseRootFromParent_Done,
     /* 1330820 */   // Label 19037: @1330820
     /* 1330820 */   GIM_Try, /*On fail goto*//*Label 19038*/ GIMT_Encode4(1330904), // Rule ID 19884 //
     /* 1330825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1330828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1330842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330878 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1330881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330903 */     // GIR_Coverage, 19884,
     /* 1330903 */     GIR_EraseRootFromParent_Done,
     /* 1330904 */   // Label 19038: @1330904
     /* 1330904 */   GIM_Try, /*On fail goto*//*Label 19039*/ GIMT_Encode4(1330988), // Rule ID 19885 //
     /* 1330909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1330912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1330917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1330926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1330929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1330951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330962 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1330965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330987 */     // GIR_Coverage, 19885,
     /* 1330987 */     GIR_EraseRootFromParent_Done,
     /* 1330988 */   // Label 19039: @1330988
     /* 1330988 */   GIM_Try, /*On fail goto*//*Label 19040*/ GIMT_Encode4(1331072), // Rule ID 19888 //
     /* 1330993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1330996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331046 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1331049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331071 */     // GIR_Coverage, 19888,
     /* 1331071 */     GIR_EraseRootFromParent_Done,
     /* 1331072 */   // Label 19040: @1331072
     /* 1331072 */   GIM_Try, /*On fail goto*//*Label 19041*/ GIMT_Encode4(1331156), // Rule ID 19889 //
     /* 1331077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1331085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1331097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1331119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331130 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1331133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331155 */     // GIR_Coverage, 19889,
     /* 1331155 */     GIR_EraseRootFromParent_Done,
     /* 1331156 */   // Label 19041: @1331156
     /* 1331156 */   GIM_Try, /*On fail goto*//*Label 19042*/ GIMT_Encode4(1331240), // Rule ID 19892 //
     /* 1331161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1331181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331214 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1331217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331239 */     // GIR_Coverage, 19892,
     /* 1331239 */     GIR_EraseRootFromParent_Done,
     /* 1331240 */   // Label 19042: @1331240
     /* 1331240 */   GIM_Try, /*On fail goto*//*Label 19043*/ GIMT_Encode4(1331324), // Rule ID 19893 //
     /* 1331245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1331262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1331265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331298 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1331301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331323 */     // GIR_Coverage, 19893,
     /* 1331323 */     GIR_EraseRootFromParent_Done,
     /* 1331324 */   // Label 19043: @1331324
     /* 1331324 */   GIM_Try, /*On fail goto*//*Label 19044*/ GIMT_Encode4(1331408), // Rule ID 19896 //
     /* 1331329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1331349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331382 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331407 */     // GIR_Coverage, 19896,
     /* 1331407 */     GIR_EraseRootFromParent_Done,
     /* 1331408 */   // Label 19044: @1331408
     /* 1331408 */   GIM_Try, /*On fail goto*//*Label 19045*/ GIMT_Encode4(1331492), // Rule ID 19897 //
     /* 1331413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1331430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1331433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331466 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331491 */     // GIR_Coverage, 19897,
     /* 1331491 */     GIR_EraseRootFromParent_Done,
     /* 1331492 */   // Label 19045: @1331492
     /* 1331492 */   GIM_Try, /*On fail goto*//*Label 19046*/ GIMT_Encode4(1331576), // Rule ID 19900 //
     /* 1331497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1331514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1331517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331550 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331575 */     // GIR_Coverage, 19900,
     /* 1331575 */     GIR_EraseRootFromParent_Done,
     /* 1331576 */   // Label 19046: @1331576
     /* 1331576 */   GIM_Try, /*On fail goto*//*Label 19047*/ GIMT_Encode4(1331660), // Rule ID 19901 //
     /* 1331581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1331592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1331595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1331598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1331601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1331604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331634 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1331637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331659 */     // GIR_Coverage, 19901,
     /* 1331659 */     GIR_EraseRootFromParent_Done,
     /* 1331660 */   // Label 19047: @1331660
     /* 1331660 */   GIM_Try, /*On fail goto*//*Label 19048*/ GIMT_Encode4(1331744), // Rule ID 19904 //
     /* 1331665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1331668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1331682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1331685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331718 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1331721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331743 */     // GIR_Coverage, 19904,
     /* 1331743 */     GIR_EraseRootFromParent_Done,
     /* 1331744 */   // Label 19048: @1331744
     /* 1331744 */   GIM_Try, /*On fail goto*//*Label 19049*/ GIMT_Encode4(1331828), // Rule ID 19905 //
     /* 1331749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1331766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1331769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331802 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1331805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331827 */     // GIR_Coverage, 19905,
     /* 1331827 */     GIR_EraseRootFromParent_Done,
     /* 1331828 */   // Label 19049: @1331828
     /* 1331828 */   GIM_Try, /*On fail goto*//*Label 19050*/ GIMT_Encode4(1331912), // Rule ID 19908 //
     /* 1331833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1331850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1331853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331886 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1331889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331911 */     // GIR_Coverage, 19908,
     /* 1331911 */     GIR_EraseRootFromParent_Done,
     /* 1331912 */   // Label 19050: @1331912
     /* 1331912 */   GIM_Try, /*On fail goto*//*Label 19051*/ GIMT_Encode4(1331996), // Rule ID 19909 //
     /* 1331917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1331925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1331934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1331937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331970 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1331973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331995 */     // GIR_Coverage, 19909,
     /* 1331995 */     GIR_EraseRootFromParent_Done,
     /* 1331996 */   // Label 19051: @1331996
     /* 1331996 */   GIM_Try, /*On fail goto*//*Label 19052*/ GIMT_Encode4(1332080), // Rule ID 19912 //
     /* 1332001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1332004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1332021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332054 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332079 */     // GIR_Coverage, 19912,
     /* 1332079 */     GIR_EraseRootFromParent_Done,
     /* 1332080 */   // Label 19052: @1332080
     /* 1332080 */   GIM_Try, /*On fail goto*//*Label 19053*/ GIMT_Encode4(1332164), // Rule ID 19913 //
     /* 1332085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1332088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1332105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332138 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1332141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332163 */     // GIR_Coverage, 19913,
     /* 1332163 */     GIR_EraseRootFromParent_Done,
     /* 1332164 */   // Label 19053: @1332164
     /* 1332164 */   GIM_Try, /*On fail goto*//*Label 19054*/ GIMT_Encode4(1332248), // Rule ID 19916 //
     /* 1332169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1332189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332222 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332247 */     // GIR_Coverage, 19916,
     /* 1332247 */     GIR_EraseRootFromParent_Done,
     /* 1332248 */   // Label 19054: @1332248
     /* 1332248 */   GIM_Try, /*On fail goto*//*Label 19055*/ GIMT_Encode4(1332332), // Rule ID 19917 //
     /* 1332253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1332270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1332273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332306 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332331 */     // GIR_Coverage, 19917,
     /* 1332331 */     GIR_EraseRootFromParent_Done,
     /* 1332332 */   // Label 19055: @1332332
     /* 1332332 */   GIM_Try, /*On fail goto*//*Label 19056*/ GIMT_Encode4(1332416), // Rule ID 19920 //
     /* 1332337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1332357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332390 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332415 */     // GIR_Coverage, 19920,
     /* 1332415 */     GIR_EraseRootFromParent_Done,
     /* 1332416 */   // Label 19056: @1332416
     /* 1332416 */   GIM_Try, /*On fail goto*//*Label 19057*/ GIMT_Encode4(1332500), // Rule ID 19921 //
     /* 1332421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1332432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1332435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1332438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1332441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1332444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332499 */     // GIR_Coverage, 19921,
     /* 1332499 */     GIR_EraseRootFromParent_Done,
     /* 1332500 */   // Label 19057: @1332500
     /* 1332500 */   GIM_Try, /*On fail goto*//*Label 19058*/ GIMT_Encode4(1332584), // Rule ID 19924 //
     /* 1332505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1332516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1332519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1332522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1332525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1332528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332558 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1332561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332583 */     // GIR_Coverage, 19924,
     /* 1332583 */     GIR_EraseRootFromParent_Done,
     /* 1332584 */   // Label 19058: @1332584
     /* 1332584 */   GIM_Try, /*On fail goto*//*Label 19059*/ GIMT_Encode4(1332668), // Rule ID 19925 //
     /* 1332589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1332600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1332603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1332606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1332609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1332612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332642 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1332645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332667 */     // GIR_Coverage, 19925,
     /* 1332667 */     GIR_EraseRootFromParent_Done,
     /* 1332668 */   // Label 19059: @1332668
     /* 1332668 */   GIM_Try, /*On fail goto*//*Label 19060*/ GIMT_Encode4(1332752), // Rule ID 19928 //
     /* 1332673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1332690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1332693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332726 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332751 */     // GIR_Coverage, 19928,
     /* 1332751 */     GIR_EraseRootFromParent_Done,
     /* 1332752 */   // Label 19060: @1332752
     /* 1332752 */   GIM_Try, /*On fail goto*//*Label 19061*/ GIMT_Encode4(1332836), // Rule ID 19929 //
     /* 1332757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1332774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1332777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1332799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1332813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332835 */     // GIR_Coverage, 19929,
     /* 1332835 */     GIR_EraseRootFromParent_Done,
     /* 1332836 */   // Label 19061: @1332836
     /* 1332836 */   GIM_Try, /*On fail goto*//*Label 19062*/ GIMT_Encode4(1332920), // Rule ID 19932 //
     /* 1332841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1332858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1332861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332894 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332919 */     // GIR_Coverage, 19932,
     /* 1332919 */     GIR_EraseRootFromParent_Done,
     /* 1332920 */   // Label 19062: @1332920
     /* 1332920 */   GIM_Try, /*On fail goto*//*Label 19063*/ GIMT_Encode4(1333004), // Rule ID 19933 //
     /* 1332925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1332933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1332942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1332945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1332967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332978 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1332981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333003 */     // GIR_Coverage, 19933,
     /* 1333003 */     GIR_EraseRootFromParent_Done,
     /* 1333004 */   // Label 19063: @1333004
     /* 1333004 */   GIM_Try, /*On fail goto*//*Label 19064*/ GIMT_Encode4(1333088), // Rule ID 19936 //
     /* 1333009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1333029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333062 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333087 */     // GIR_Coverage, 19936,
     /* 1333087 */     GIR_EraseRootFromParent_Done,
     /* 1333088 */   // Label 19064: @1333088
     /* 1333088 */   GIM_Try, /*On fail goto*//*Label 19065*/ GIMT_Encode4(1333172), // Rule ID 19937 //
     /* 1333093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1333110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1333113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333146 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333171 */     // GIR_Coverage, 19937,
     /* 1333171 */     GIR_EraseRootFromParent_Done,
     /* 1333172 */   // Label 19065: @1333172
     /* 1333172 */   GIM_Try, /*On fail goto*//*Label 19066*/ GIMT_Encode4(1333256), // Rule ID 19940 //
     /* 1333177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1333197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333230 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333255 */     // GIR_Coverage, 19940,
     /* 1333255 */     GIR_EraseRootFromParent_Done,
     /* 1333256 */   // Label 19066: @1333256
     /* 1333256 */   GIM_Try, /*On fail goto*//*Label 19067*/ GIMT_Encode4(1333340), // Rule ID 19941 //
     /* 1333261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1333278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1333281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333314 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1333317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333339 */     // GIR_Coverage, 19941,
     /* 1333339 */     GIR_EraseRootFromParent_Done,
     /* 1333340 */   // Label 19067: @1333340
     /* 1333340 */   GIM_Try, /*On fail goto*//*Label 19068*/ GIMT_Encode4(1333424), // Rule ID 19944 //
     /* 1333345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1333365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333398 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333423 */     // GIR_Coverage, 19944,
     /* 1333423 */     GIR_EraseRootFromParent_Done,
     /* 1333424 */   // Label 19068: @1333424
     /* 1333424 */   GIM_Try, /*On fail goto*//*Label 19069*/ GIMT_Encode4(1333508), // Rule ID 19945 //
     /* 1333429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1333446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1333449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333482 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1333485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333507 */     // GIR_Coverage, 19945,
     /* 1333507 */     GIR_EraseRootFromParent_Done,
     /* 1333508 */   // Label 19069: @1333508
     /* 1333508 */   GIM_Try, /*On fail goto*//*Label 19070*/ GIMT_Encode4(1333592), // Rule ID 19948 //
     /* 1333513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1333516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1333530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1333533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333566 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333591 */     // GIR_Coverage, 19948,
     /* 1333591 */     GIR_EraseRootFromParent_Done,
     /* 1333592 */   // Label 19070: @1333592
     /* 1333592 */   GIM_Try, /*On fail goto*//*Label 19071*/ GIMT_Encode4(1333676), // Rule ID 19949 //
     /* 1333597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1333614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1333617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1333653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333675 */     // GIR_Coverage, 19949,
     /* 1333675 */     GIR_EraseRootFromParent_Done,
     /* 1333676 */   // Label 19071: @1333676
     /* 1333676 */   GIM_Try, /*On fail goto*//*Label 19072*/ GIMT_Encode4(1333760), // Rule ID 19952 //
     /* 1333681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1333692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1333695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1333698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333734 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1333737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333759 */     // GIR_Coverage, 19952,
     /* 1333759 */     GIR_EraseRootFromParent_Done,
     /* 1333760 */   // Label 19072: @1333760
     /* 1333760 */   GIM_Try, /*On fail goto*//*Label 19073*/ GIMT_Encode4(1333844), // Rule ID 19953 //
     /* 1333765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1333776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1333779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1333782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333818 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1333821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333843 */     // GIR_Coverage, 19953,
     /* 1333843 */     GIR_EraseRootFromParent_Done,
     /* 1333844 */   // Label 19073: @1333844
     /* 1333844 */   GIM_Try, /*On fail goto*//*Label 19074*/ GIMT_Encode4(1333928), // Rule ID 19956 //
     /* 1333849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1333866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333902 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1333905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333927 */     // GIR_Coverage, 19956,
     /* 1333927 */     GIR_EraseRootFromParent_Done,
     /* 1333928 */   // Label 19074: @1333928
     /* 1333928 */   GIM_Try, /*On fail goto*//*Label 19075*/ GIMT_Encode4(1334012), // Rule ID 19957 //
     /* 1333933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1333941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1333944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1333947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1333950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1333956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1333989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334011 */     // GIR_Coverage, 19957,
     /* 1334011 */     GIR_EraseRootFromParent_Done,
     /* 1334012 */   // Label 19075: @1334012
     /* 1334012 */   GIM_Try, /*On fail goto*//*Label 19076*/ GIMT_Encode4(1334096), // Rule ID 19960 //
     /* 1334017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334070 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1334073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334095 */     // GIR_Coverage, 19960,
     /* 1334095 */     GIR_EraseRootFromParent_Done,
     /* 1334096 */   // Label 19076: @1334096
     /* 1334096 */   GIM_Try, /*On fail goto*//*Label 19077*/ GIMT_Encode4(1334180), // Rule ID 19961 //
     /* 1334101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1334118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334154 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1334157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334179 */     // GIR_Coverage, 19961,
     /* 1334179 */     GIR_EraseRootFromParent_Done,
     /* 1334180 */   // Label 19077: @1334180
     /* 1334180 */   GIM_Try, /*On fail goto*//*Label 19078*/ GIMT_Encode4(1334264), // Rule ID 19964 //
     /* 1334185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334238 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1334241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334263 */     // GIR_Coverage, 19964,
     /* 1334263 */     GIR_EraseRootFromParent_Done,
     /* 1334264 */   // Label 19078: @1334264
     /* 1334264 */   GIM_Try, /*On fail goto*//*Label 19079*/ GIMT_Encode4(1334348), // Rule ID 19965 //
     /* 1334269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1334286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334322 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1334325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334347 */     // GIR_Coverage, 19965,
     /* 1334347 */     GIR_EraseRootFromParent_Done,
     /* 1334348 */   // Label 19079: @1334348
     /* 1334348 */   GIM_Try, /*On fail goto*//*Label 19080*/ GIMT_Encode4(1334432), // Rule ID 19968 //
     /* 1334353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334406 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1334409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334431 */     // GIR_Coverage, 19968,
     /* 1334431 */     GIR_EraseRootFromParent_Done,
     /* 1334432 */   // Label 19080: @1334432
     /* 1334432 */   GIM_Try, /*On fail goto*//*Label 19081*/ GIMT_Encode4(1334516), // Rule ID 19969 //
     /* 1334437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1334454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334490 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1334493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334515 */     // GIR_Coverage, 19969,
     /* 1334515 */     GIR_EraseRootFromParent_Done,
     /* 1334516 */   // Label 19081: @1334516
     /* 1334516 */   GIM_Try, /*On fail goto*//*Label 19082*/ GIMT_Encode4(1334600), // Rule ID 19972 //
     /* 1334521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1334538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334574 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1334577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334599 */     // GIR_Coverage, 19972,
     /* 1334599 */     GIR_EraseRootFromParent_Done,
     /* 1334600 */   // Label 19082: @1334600
     /* 1334600 */   GIM_Try, /*On fail goto*//*Label 19083*/ GIMT_Encode4(1334684), // Rule ID 19973 //
     /* 1334605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1334622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334658 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1334661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334683 */     // GIR_Coverage, 19973,
     /* 1334683 */     GIR_EraseRootFromParent_Done,
     /* 1334684 */   // Label 19083: @1334684
     /* 1334684 */   GIM_Try, /*On fail goto*//*Label 19084*/ GIMT_Encode4(1334768), // Rule ID 19976 //
     /* 1334689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1334706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334742 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1334745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334767 */     // GIR_Coverage, 19976,
     /* 1334767 */     GIR_EraseRootFromParent_Done,
     /* 1334768 */   // Label 19084: @1334768
     /* 1334768 */   GIM_Try, /*On fail goto*//*Label 19085*/ GIMT_Encode4(1334852), // Rule ID 19977 //
     /* 1334773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1334790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334826 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1334829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334851 */     // GIR_Coverage, 19977,
     /* 1334851 */     GIR_EraseRootFromParent_Done,
     /* 1334852 */   // Label 19085: @1334852
     /* 1334852 */   GIM_Try, /*On fail goto*//*Label 19086*/ GIMT_Encode4(1334936), // Rule ID 19980 //
     /* 1334857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1334868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1334871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1334874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334910 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1334913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334935 */     // GIR_Coverage, 19980,
     /* 1334935 */     GIR_EraseRootFromParent_Done,
     /* 1334936 */   // Label 19086: @1334936
     /* 1334936 */   GIM_Try, /*On fail goto*//*Label 19087*/ GIMT_Encode4(1335020), // Rule ID 19981 //
     /* 1334941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1334949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1334952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1334955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1334958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1334961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1334983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334994 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1334997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335019 */     // GIR_Coverage, 19981,
     /* 1335019 */     GIR_EraseRootFromParent_Done,
     /* 1335020 */   // Label 19087: @1335020
     /* 1335020 */   GIM_Try, /*On fail goto*//*Label 19088*/ GIMT_Encode4(1335104), // Rule ID 19984 //
     /* 1335025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335078 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1335081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335103 */     // GIR_Coverage, 19984,
     /* 1335103 */     GIR_EraseRootFromParent_Done,
     /* 1335104 */   // Label 19088: @1335104
     /* 1335104 */   GIM_Try, /*On fail goto*//*Label 19089*/ GIMT_Encode4(1335188), // Rule ID 19985 //
     /* 1335109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1335120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1335123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1335126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1335129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1335132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1335151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335162 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1335165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335187 */     // GIR_Coverage, 19985,
     /* 1335187 */     GIR_EraseRootFromParent_Done,
     /* 1335188 */   // Label 19089: @1335188
     /* 1335188 */   GIM_Try, /*On fail goto*//*Label 19090*/ GIMT_Encode4(1335272), // Rule ID 19988 //
     /* 1335193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335246 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1335249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335271 */     // GIR_Coverage, 19988,
     /* 1335271 */     GIR_EraseRootFromParent_Done,
     /* 1335272 */   // Label 19090: @1335272
     /* 1335272 */   GIM_Try, /*On fail goto*//*Label 19091*/ GIMT_Encode4(1335356), // Rule ID 19989 //
     /* 1335277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1335294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335330 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1335333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335355 */     // GIR_Coverage, 19989,
     /* 1335355 */     GIR_EraseRootFromParent_Done,
     /* 1335356 */   // Label 19091: @1335356
     /* 1335356 */   GIM_Try, /*On fail goto*//*Label 19092*/ GIMT_Encode4(1335440), // Rule ID 19992 //
     /* 1335361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335414 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1335417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335439 */     // GIR_Coverage, 19992,
     /* 1335439 */     GIR_EraseRootFromParent_Done,
     /* 1335440 */   // Label 19092: @1335440
     /* 1335440 */   GIM_Try, /*On fail goto*//*Label 19093*/ GIMT_Encode4(1335524), // Rule ID 19993 //
     /* 1335445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1335462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1335501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335523 */     // GIR_Coverage, 19993,
     /* 1335523 */     GIR_EraseRootFromParent_Done,
     /* 1335524 */   // Label 19093: @1335524
     /* 1335524 */   GIM_Try, /*On fail goto*//*Label 19094*/ GIMT_Encode4(1335608), // Rule ID 19996 //
     /* 1335529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1335546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335582 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1335585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335607 */     // GIR_Coverage, 19996,
     /* 1335607 */     GIR_EraseRootFromParent_Done,
     /* 1335608 */   // Label 19094: @1335608
     /* 1335608 */   GIM_Try, /*On fail goto*//*Label 19095*/ GIMT_Encode4(1335692), // Rule ID 19997 //
     /* 1335613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1335630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1335633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1335651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1335655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335666 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1335669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335691 */     // GIR_Coverage, 19997,
     /* 1335691 */     GIR_EraseRootFromParent_Done,
     /* 1335692 */   // Label 19095: @1335692
     /* 1335692 */   GIM_Try, /*On fail goto*//*Label 19096*/ GIMT_Encode4(1335776), // Rule ID 20000 //
     /* 1335697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1335700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1335714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1335753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335775 */     // GIR_Coverage, 20000,
     /* 1335775 */     GIR_EraseRootFromParent_Done,
     /* 1335776 */   // Label 19096: @1335776
     /* 1335776 */   GIM_Try, /*On fail goto*//*Label 19097*/ GIMT_Encode4(1335860), // Rule ID 20001 //
     /* 1335781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1335784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1335798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335834 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1335837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335859 */     // GIR_Coverage, 20001,
     /* 1335859 */     GIR_EraseRootFromParent_Done,
     /* 1335860 */   // Label 19097: @1335860
     /* 1335860 */   GIM_Try, /*On fail goto*//*Label 19098*/ GIMT_Encode4(1335944), // Rule ID 20004 //
     /* 1335865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1335868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1335882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335918 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1335921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335943 */     // GIR_Coverage, 20004,
     /* 1335943 */     GIR_EraseRootFromParent_Done,
     /* 1335944 */   // Label 19098: @1335944
     /* 1335944 */   GIM_Try, /*On fail goto*//*Label 19099*/ GIMT_Encode4(1336028), // Rule ID 20005 //
     /* 1335949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1335952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1335957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1335966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1335969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1335991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336002 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1336005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336027 */     // GIR_Coverage, 20005,
     /* 1336027 */     GIR_EraseRootFromParent_Done,
     /* 1336028 */   // Label 19099: @1336028
     /* 1336028 */   GIM_Try, /*On fail goto*//*Label 19100*/ GIMT_Encode4(1336112), // Rule ID 20008 //
     /* 1336033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336086 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1336089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336111 */     // GIR_Coverage, 20008,
     /* 1336111 */     GIR_EraseRootFromParent_Done,
     /* 1336112 */   // Label 19100: @1336112
     /* 1336112 */   GIM_Try, /*On fail goto*//*Label 19101*/ GIMT_Encode4(1336196), // Rule ID 20009 //
     /* 1336117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1336125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1336134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1336137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1336159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336170 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1336173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336195 */     // GIR_Coverage, 20009,
     /* 1336195 */     GIR_EraseRootFromParent_Done,
     /* 1336196 */   // Label 19101: @1336196
     /* 1336196 */   GIM_Try, /*On fail goto*//*Label 19102*/ GIMT_Encode4(1336280), // Rule ID 20012 //
     /* 1336201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1336221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336254 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1336257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336279 */     // GIR_Coverage, 20012,
     /* 1336279 */     GIR_EraseRootFromParent_Done,
     /* 1336280 */   // Label 19102: @1336280
     /* 1336280 */   GIM_Try, /*On fail goto*//*Label 19103*/ GIMT_Encode4(1336364), // Rule ID 20013 //
     /* 1336285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1336302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1336305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336338 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1336341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336363 */     // GIR_Coverage, 20013,
     /* 1336363 */     GIR_EraseRootFromParent_Done,
     /* 1336364 */   // Label 19103: @1336364
     /* 1336364 */   GIM_Try, /*On fail goto*//*Label 19104*/ GIMT_Encode4(1336448), // Rule ID 20016 //
     /* 1336369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1336389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336422 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336447 */     // GIR_Coverage, 20016,
     /* 1336447 */     GIR_EraseRootFromParent_Done,
     /* 1336448 */   // Label 19104: @1336448
     /* 1336448 */   GIM_Try, /*On fail goto*//*Label 19105*/ GIMT_Encode4(1336532), // Rule ID 20017 //
     /* 1336453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1336470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1336473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336506 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336531 */     // GIR_Coverage, 20017,
     /* 1336531 */     GIR_EraseRootFromParent_Done,
     /* 1336532 */   // Label 19105: @1336532
     /* 1336532 */   GIM_Try, /*On fail goto*//*Label 19106*/ GIMT_Encode4(1336616), // Rule ID 20020 //
     /* 1336537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1336554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1336557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336590 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336615 */     // GIR_Coverage, 20020,
     /* 1336615 */     GIR_EraseRootFromParent_Done,
     /* 1336616 */   // Label 19106: @1336616
     /* 1336616 */   GIM_Try, /*On fail goto*//*Label 19107*/ GIMT_Encode4(1336700), // Rule ID 20021 //
     /* 1336621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1336632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1336635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1336638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1336641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1336644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336674 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1336677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336699 */     // GIR_Coverage, 20021,
     /* 1336699 */     GIR_EraseRootFromParent_Done,
     /* 1336700 */   // Label 19107: @1336700
     /* 1336700 */   GIM_Try, /*On fail goto*//*Label 19108*/ GIMT_Encode4(1336784), // Rule ID 20024 //
     /* 1336705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1336722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1336725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336758 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1336761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336783 */     // GIR_Coverage, 20024,
     /* 1336783 */     GIR_EraseRootFromParent_Done,
     /* 1336784 */   // Label 19108: @1336784
     /* 1336784 */   GIM_Try, /*On fail goto*//*Label 19109*/ GIMT_Encode4(1336868), // Rule ID 20025 //
     /* 1336789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1336806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1336809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336842 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1336845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336867 */     // GIR_Coverage, 20025,
     /* 1336867 */     GIR_EraseRootFromParent_Done,
     /* 1336868 */   // Label 19109: @1336868
     /* 1336868 */   GIM_Try, /*On fail goto*//*Label 19110*/ GIMT_Encode4(1336952), // Rule ID 20028 //
     /* 1336873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1336890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1336893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1336929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336951 */     // GIR_Coverage, 20028,
     /* 1336951 */     GIR_EraseRootFromParent_Done,
     /* 1336952 */   // Label 19110: @1336952
     /* 1336952 */   GIM_Try, /*On fail goto*//*Label 19111*/ GIMT_Encode4(1337036), // Rule ID 20029 //
     /* 1336957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1336965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1336974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1336977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337010 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337035 */     // GIR_Coverage, 20029,
     /* 1337035 */     GIR_EraseRootFromParent_Done,
     /* 1337036 */   // Label 19111: @1337036
     /* 1337036 */   GIM_Try, /*On fail goto*//*Label 19112*/ GIMT_Encode4(1337120), // Rule ID 20032 //
     /* 1337041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1337044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1337061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337094 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337119 */     // GIR_Coverage, 20032,
     /* 1337119 */     GIR_EraseRootFromParent_Done,
     /* 1337120 */   // Label 19112: @1337120
     /* 1337120 */   GIM_Try, /*On fail goto*//*Label 19113*/ GIMT_Encode4(1337204), // Rule ID 20033 //
     /* 1337125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1337128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1337142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1337145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337178 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1337181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337203 */     // GIR_Coverage, 20033,
     /* 1337203 */     GIR_EraseRootFromParent_Done,
     /* 1337204 */   // Label 19113: @1337204
     /* 1337204 */   GIM_Try, /*On fail goto*//*Label 19114*/ GIMT_Encode4(1337288), // Rule ID 20036 //
     /* 1337209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1337229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337262 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337287 */     // GIR_Coverage, 20036,
     /* 1337287 */     GIR_EraseRootFromParent_Done,
     /* 1337288 */   // Label 19114: @1337288
     /* 1337288 */   GIM_Try, /*On fail goto*//*Label 19115*/ GIMT_Encode4(1337372), // Rule ID 20037 //
     /* 1337293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1337310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1337313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337346 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337371 */     // GIR_Coverage, 20037,
     /* 1337371 */     GIR_EraseRootFromParent_Done,
     /* 1337372 */   // Label 19115: @1337372
     /* 1337372 */   GIM_Try, /*On fail goto*//*Label 19116*/ GIMT_Encode4(1337456), // Rule ID 20040 //
     /* 1337377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1337397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337430 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337455 */     // GIR_Coverage, 20040,
     /* 1337455 */     GIR_EraseRootFromParent_Done,
     /* 1337456 */   // Label 19116: @1337456
     /* 1337456 */   GIM_Try, /*On fail goto*//*Label 19117*/ GIMT_Encode4(1337540), // Rule ID 20041 //
     /* 1337461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1337472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1337475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1337478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1337481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1337484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337539 */     // GIR_Coverage, 20041,
     /* 1337539 */     GIR_EraseRootFromParent_Done,
     /* 1337540 */   // Label 19117: @1337540
     /* 1337540 */   GIM_Try, /*On fail goto*//*Label 19118*/ GIMT_Encode4(1337624), // Rule ID 20044 //
     /* 1337545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1337556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1337559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1337562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1337565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1337568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337598 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1337601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337623 */     // GIR_Coverage, 20044,
     /* 1337623 */     GIR_EraseRootFromParent_Done,
     /* 1337624 */   // Label 19118: @1337624
     /* 1337624 */   GIM_Try, /*On fail goto*//*Label 19119*/ GIMT_Encode4(1337708), // Rule ID 20045 //
     /* 1337629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1337640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1337643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1337646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1337649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1337652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337682 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1337685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337707 */     // GIR_Coverage, 20045,
     /* 1337707 */     GIR_EraseRootFromParent_Done,
     /* 1337708 */   // Label 19119: @1337708
     /* 1337708 */   GIM_Try, /*On fail goto*//*Label 19120*/ GIMT_Encode4(1337792), // Rule ID 20048 //
     /* 1337713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1337730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1337733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337766 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337791 */     // GIR_Coverage, 20048,
     /* 1337791 */     GIR_EraseRootFromParent_Done,
     /* 1337792 */   // Label 19120: @1337792
     /* 1337792 */   GIM_Try, /*On fail goto*//*Label 19121*/ GIMT_Encode4(1337876), // Rule ID 20049 //
     /* 1337797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1337814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1337817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1337839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337850 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1337853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337875 */     // GIR_Coverage, 20049,
     /* 1337875 */     GIR_EraseRootFromParent_Done,
     /* 1337876 */   // Label 19121: @1337876
     /* 1337876 */   GIM_Try, /*On fail goto*//*Label 19122*/ GIMT_Encode4(1337960), // Rule ID 20052 //
     /* 1337881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1337898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1337901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1337923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337934 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1337937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337959 */     // GIR_Coverage, 20052,
     /* 1337959 */     GIR_EraseRootFromParent_Done,
     /* 1337960 */   // Label 19122: @1337960
     /* 1337960 */   GIM_Try, /*On fail goto*//*Label 19123*/ GIMT_Encode4(1338044), // Rule ID 20053 //
     /* 1337965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1337973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1337982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1337985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338018 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338043 */     // GIR_Coverage, 20053,
     /* 1338043 */     GIR_EraseRootFromParent_Done,
     /* 1338044 */   // Label 19123: @1338044
     /* 1338044 */   GIM_Try, /*On fail goto*//*Label 19124*/ GIMT_Encode4(1338128), // Rule ID 20056 //
     /* 1338049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1338069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338102 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338127 */     // GIR_Coverage, 20056,
     /* 1338127 */     GIR_EraseRootFromParent_Done,
     /* 1338128 */   // Label 19124: @1338128
     /* 1338128 */   GIM_Try, /*On fail goto*//*Label 19125*/ GIMT_Encode4(1338212), // Rule ID 20057 //
     /* 1338133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1338150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1338153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338186 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338211 */     // GIR_Coverage, 20057,
     /* 1338211 */     GIR_EraseRootFromParent_Done,
     /* 1338212 */   // Label 19125: @1338212
     /* 1338212 */   GIM_Try, /*On fail goto*//*Label 19126*/ GIMT_Encode4(1338296), // Rule ID 20060 //
     /* 1338217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1338237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338270 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338295 */     // GIR_Coverage, 20060,
     /* 1338295 */     GIR_EraseRootFromParent_Done,
     /* 1338296 */   // Label 19126: @1338296
     /* 1338296 */   GIM_Try, /*On fail goto*//*Label 19127*/ GIMT_Encode4(1338380), // Rule ID 20061 //
     /* 1338301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1338318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1338321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338354 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1338357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338379 */     // GIR_Coverage, 20061,
     /* 1338379 */     GIR_EraseRootFromParent_Done,
     /* 1338380 */   // Label 19127: @1338380
     /* 1338380 */   GIM_Try, /*On fail goto*//*Label 19128*/ GIMT_Encode4(1338464), // Rule ID 20064 //
     /* 1338385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1338405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338438 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338463 */     // GIR_Coverage, 20064,
     /* 1338463 */     GIR_EraseRootFromParent_Done,
     /* 1338464 */   // Label 19128: @1338464
     /* 1338464 */   GIM_Try, /*On fail goto*//*Label 19129*/ GIMT_Encode4(1338548), // Rule ID 20065 //
     /* 1338469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1338486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1338489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338522 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1338525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338547 */     // GIR_Coverage, 20065,
     /* 1338547 */     GIR_EraseRootFromParent_Done,
     /* 1338548 */   // Label 19129: @1338548
     /* 1338548 */   GIM_Try, /*On fail goto*//*Label 19130*/ GIMT_Encode4(1338632), // Rule ID 20068 //
     /* 1338553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1338570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1338573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338606 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338631 */     // GIR_Coverage, 20068,
     /* 1338631 */     GIR_EraseRootFromParent_Done,
     /* 1338632 */   // Label 19130: @1338632
     /* 1338632 */   GIM_Try, /*On fail goto*//*Label 19131*/ GIMT_Encode4(1338716), // Rule ID 20069 //
     /* 1338637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1338654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1338657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338690 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1338693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338715 */     // GIR_Coverage, 20069,
     /* 1338715 */     GIR_EraseRootFromParent_Done,
     /* 1338716 */   // Label 19131: @1338716
     /* 1338716 */   GIM_Try, /*On fail goto*//*Label 19132*/ GIMT_Encode4(1338800), // Rule ID 20072 //
     /* 1338721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1338732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1338735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1338738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1338744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338774 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1338777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338799 */     // GIR_Coverage, 20072,
     /* 1338799 */     GIR_EraseRootFromParent_Done,
     /* 1338800 */   // Label 19132: @1338800
     /* 1338800 */   GIM_Try, /*On fail goto*//*Label 19133*/ GIMT_Encode4(1338884), // Rule ID 20073 //
     /* 1338805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1338816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1338819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1338822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1338828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338858 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1338861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338883 */     // GIR_Coverage, 20073,
     /* 1338883 */     GIR_EraseRootFromParent_Done,
     /* 1338884 */   // Label 19133: @1338884
     /* 1338884 */   GIM_Try, /*On fail goto*//*Label 19134*/ GIMT_Encode4(1338968), // Rule ID 20076 //
     /* 1338889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1338906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338942 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1338945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338967 */     // GIR_Coverage, 20076,
     /* 1338967 */     GIR_EraseRootFromParent_Done,
     /* 1338968 */   // Label 19134: @1338968
     /* 1338968 */   GIM_Try, /*On fail goto*//*Label 19135*/ GIMT_Encode4(1339052), // Rule ID 20077 //
     /* 1338973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1338981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1338984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1338987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1338990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1338996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339026 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1339029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339051 */     // GIR_Coverage, 20077,
     /* 1339051 */     GIR_EraseRootFromParent_Done,
     /* 1339052 */   // Label 19135: @1339052
     /* 1339052 */   GIM_Try, /*On fail goto*//*Label 19136*/ GIMT_Encode4(1339136), // Rule ID 20080 //
     /* 1339057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339110 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1339113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339135 */     // GIR_Coverage, 20080,
     /* 1339135 */     GIR_EraseRootFromParent_Done,
     /* 1339136 */   // Label 19136: @1339136
     /* 1339136 */   GIM_Try, /*On fail goto*//*Label 19137*/ GIMT_Encode4(1339220), // Rule ID 20081 //
     /* 1339141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1339158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339194 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1339197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339219 */     // GIR_Coverage, 20081,
     /* 1339219 */     GIR_EraseRootFromParent_Done,
     /* 1339220 */   // Label 19137: @1339220
     /* 1339220 */   GIM_Try, /*On fail goto*//*Label 19138*/ GIMT_Encode4(1339304), // Rule ID 20084 //
     /* 1339225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339278 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1339281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339303 */     // GIR_Coverage, 20084,
     /* 1339303 */     GIR_EraseRootFromParent_Done,
     /* 1339304 */   // Label 19138: @1339304
     /* 1339304 */   GIM_Try, /*On fail goto*//*Label 19139*/ GIMT_Encode4(1339388), // Rule ID 20085 //
     /* 1339309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1339326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339362 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1339365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339387 */     // GIR_Coverage, 20085,
     /* 1339387 */     GIR_EraseRootFromParent_Done,
     /* 1339388 */   // Label 19139: @1339388
     /* 1339388 */   GIM_Try, /*On fail goto*//*Label 19140*/ GIMT_Encode4(1339472), // Rule ID 20088 //
     /* 1339393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1339449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339471 */     // GIR_Coverage, 20088,
     /* 1339471 */     GIR_EraseRootFromParent_Done,
     /* 1339472 */   // Label 19140: @1339472
     /* 1339472 */   GIM_Try, /*On fail goto*//*Label 19141*/ GIMT_Encode4(1339556), // Rule ID 20089 //
     /* 1339477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1339494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1339533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339555 */     // GIR_Coverage, 20089,
     /* 1339555 */     GIR_EraseRootFromParent_Done,
     /* 1339556 */   // Label 19141: @1339556
     /* 1339556 */   GIM_Try, /*On fail goto*//*Label 19142*/ GIMT_Encode4(1339640), // Rule ID 20092 //
     /* 1339561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1339578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339614 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1339617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339639 */     // GIR_Coverage, 20092,
     /* 1339639 */     GIR_EraseRootFromParent_Done,
     /* 1339640 */   // Label 19142: @1339640
     /* 1339640 */   GIM_Try, /*On fail goto*//*Label 19143*/ GIMT_Encode4(1339724), // Rule ID 20093 //
     /* 1339645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1339662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1339701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339723 */     // GIR_Coverage, 20093,
     /* 1339723 */     GIR_EraseRootFromParent_Done,
     /* 1339724 */   // Label 19143: @1339724
     /* 1339724 */   GIM_Try, /*On fail goto*//*Label 19144*/ GIMT_Encode4(1339808), // Rule ID 20096 //
     /* 1339729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1339746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1339785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339807 */     // GIR_Coverage, 20096,
     /* 1339807 */     GIR_EraseRootFromParent_Done,
     /* 1339808 */   // Label 19144: @1339808
     /* 1339808 */   GIM_Try, /*On fail goto*//*Label 19145*/ GIMT_Encode4(1339892), // Rule ID 20097 //
     /* 1339813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1339830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339866 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1339869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339891 */     // GIR_Coverage, 20097,
     /* 1339891 */     GIR_EraseRootFromParent_Done,
     /* 1339892 */   // Label 19145: @1339892
     /* 1339892 */   GIM_Try, /*On fail goto*//*Label 19146*/ GIMT_Encode4(1339976), // Rule ID 20100 //
     /* 1339897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1339908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1339911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1339914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1339920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339950 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1339953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339975 */     // GIR_Coverage, 20100,
     /* 1339975 */     GIR_EraseRootFromParent_Done,
     /* 1339976 */   // Label 19146: @1339976
     /* 1339976 */   GIM_Try, /*On fail goto*//*Label 19147*/ GIMT_Encode4(1340060), // Rule ID 20101 //
     /* 1339981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1339989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1339992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1339995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1339998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340034 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1340037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340059 */     // GIR_Coverage, 20101,
     /* 1340059 */     GIR_EraseRootFromParent_Done,
     /* 1340060 */   // Label 19147: @1340060
     /* 1340060 */   GIM_Try, /*On fail goto*//*Label 19148*/ GIMT_Encode4(1340144), // Rule ID 20104 //
     /* 1340065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340118 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1340121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340143 */     // GIR_Coverage, 20104,
     /* 1340143 */     GIR_EraseRootFromParent_Done,
     /* 1340144 */   // Label 19148: @1340144
     /* 1340144 */   GIM_Try, /*On fail goto*//*Label 19149*/ GIMT_Encode4(1340228), // Rule ID 20105 //
     /* 1340149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1340160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1340163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1340166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1340172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340202 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1340205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340227 */     // GIR_Coverage, 20105,
     /* 1340227 */     GIR_EraseRootFromParent_Done,
     /* 1340228 */   // Label 19149: @1340228
     /* 1340228 */   GIM_Try, /*On fail goto*//*Label 19150*/ GIMT_Encode4(1340312), // Rule ID 20108 //
     /* 1340233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340286 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1340289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340311 */     // GIR_Coverage, 20108,
     /* 1340311 */     GIR_EraseRootFromParent_Done,
     /* 1340312 */   // Label 19150: @1340312
     /* 1340312 */   GIM_Try, /*On fail goto*//*Label 19151*/ GIMT_Encode4(1340396), // Rule ID 20109 //
     /* 1340317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1340334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1340373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340395 */     // GIR_Coverage, 20109,
     /* 1340395 */     GIR_EraseRootFromParent_Done,
     /* 1340396 */   // Label 19151: @1340396
     /* 1340396 */   GIM_Try, /*On fail goto*//*Label 19152*/ GIMT_Encode4(1340480), // Rule ID 20112 //
     /* 1340401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340454 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1340457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340479 */     // GIR_Coverage, 20112,
     /* 1340479 */     GIR_EraseRootFromParent_Done,
     /* 1340480 */   // Label 19152: @1340480
     /* 1340480 */   GIM_Try, /*On fail goto*//*Label 19153*/ GIMT_Encode4(1340564), // Rule ID 20113 //
     /* 1340485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1340502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340538 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1340541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340563 */     // GIR_Coverage, 20113,
     /* 1340563 */     GIR_EraseRootFromParent_Done,
     /* 1340564 */   // Label 19153: @1340564
     /* 1340564 */   GIM_Try, /*On fail goto*//*Label 19154*/ GIMT_Encode4(1340648), // Rule ID 20116 //
     /* 1340569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1340586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340622 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1340625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340647 */     // GIR_Coverage, 20116,
     /* 1340647 */     GIR_EraseRootFromParent_Done,
     /* 1340648 */   // Label 19154: @1340648
     /* 1340648 */   GIM_Try, /*On fail goto*//*Label 19155*/ GIMT_Encode4(1340732), // Rule ID 20117 //
     /* 1340653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1340670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1340691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340706 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1340709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340731 */     // GIR_Coverage, 20117,
     /* 1340731 */     GIR_EraseRootFromParent_Done,
     /* 1340732 */   // Label 19155: @1340732
     /* 1340732 */   GIM_Try, /*On fail goto*//*Label 19156*/ GIMT_Encode4(1340816), // Rule ID 20120 //
     /* 1340737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1340740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1340754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340790 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1340793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340815 */     // GIR_Coverage, 20120,
     /* 1340815 */     GIR_EraseRootFromParent_Done,
     /* 1340816 */   // Label 19156: @1340816
     /* 1340816 */   GIM_Try, /*On fail goto*//*Label 19157*/ GIMT_Encode4(1340900), // Rule ID 20121 //
     /* 1340821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1340824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1340838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340874 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1340877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340899 */     // GIR_Coverage, 20121,
     /* 1340899 */     GIR_EraseRootFromParent_Done,
     /* 1340900 */   // Label 19157: @1340900
     /* 1340900 */   GIM_Try, /*On fail goto*//*Label 19158*/ GIMT_Encode4(1340984), // Rule ID 20124 //
     /* 1340905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1340908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1340922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340958 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1340961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340983 */     // GIR_Coverage, 20124,
     /* 1340983 */     GIR_EraseRootFromParent_Done,
     /* 1340984 */   // Label 19158: @1340984
     /* 1340984 */   GIM_Try, /*On fail goto*//*Label 19159*/ GIMT_Encode4(1341068), // Rule ID 20125 //
     /* 1340989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1340992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1340997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341042 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1341045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341067 */     // GIR_Coverage, 20125,
     /* 1341067 */     GIR_EraseRootFromParent_Done,
     /* 1341068 */   // Label 19159: @1341068
     /* 1341068 */   GIM_Try, /*On fail goto*//*Label 19160*/ GIMT_Encode4(1341152), // Rule ID 20128 //
     /* 1341073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341126 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1341129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341151 */     // GIR_Coverage, 20128,
     /* 1341151 */     GIR_EraseRootFromParent_Done,
     /* 1341152 */   // Label 19160: @1341152
     /* 1341152 */   GIM_Try, /*On fail goto*//*Label 19161*/ GIMT_Encode4(1341236), // Rule ID 20129 //
     /* 1341157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1341165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1341174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341210 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1341213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341235 */     // GIR_Coverage, 20129,
     /* 1341235 */     GIR_EraseRootFromParent_Done,
     /* 1341236 */   // Label 19161: @1341236
     /* 1341236 */   GIM_Try, /*On fail goto*//*Label 19162*/ GIMT_Encode4(1341320), // Rule ID 20132 //
     /* 1341241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1341261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341294 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1341297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341319 */     // GIR_Coverage, 20132,
     /* 1341319 */     GIR_EraseRootFromParent_Done,
     /* 1341320 */   // Label 19162: @1341320
     /* 1341320 */   GIM_Try, /*On fail goto*//*Label 19163*/ GIMT_Encode4(1341404), // Rule ID 20133 //
     /* 1341325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1341342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1341345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341378 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1341381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341403 */     // GIR_Coverage, 20133,
     /* 1341403 */     GIR_EraseRootFromParent_Done,
     /* 1341404 */   // Label 19163: @1341404
     /* 1341404 */   GIM_Try, /*On fail goto*//*Label 19164*/ GIMT_Encode4(1341488), // Rule ID 20136 //
     /* 1341409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1341429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341462 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341487 */     // GIR_Coverage, 20136,
     /* 1341487 */     GIR_EraseRootFromParent_Done,
     /* 1341488 */   // Label 19164: @1341488
     /* 1341488 */   GIM_Try, /*On fail goto*//*Label 19165*/ GIMT_Encode4(1341572), // Rule ID 20137 //
     /* 1341493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1341510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1341513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341546 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341571 */     // GIR_Coverage, 20137,
     /* 1341571 */     GIR_EraseRootFromParent_Done,
     /* 1341572 */   // Label 19165: @1341572
     /* 1341572 */   GIM_Try, /*On fail goto*//*Label 19166*/ GIMT_Encode4(1341656), // Rule ID 20140 //
     /* 1341577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1341594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1341597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341630 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341655 */     // GIR_Coverage, 20140,
     /* 1341655 */     GIR_EraseRootFromParent_Done,
     /* 1341656 */   // Label 19166: @1341656
     /* 1341656 */   GIM_Try, /*On fail goto*//*Label 19167*/ GIMT_Encode4(1341740), // Rule ID 20141 //
     /* 1341661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1341672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1341675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1341678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1341681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1341684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341714 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1341717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341739 */     // GIR_Coverage, 20141,
     /* 1341739 */     GIR_EraseRootFromParent_Done,
     /* 1341740 */   // Label 19167: @1341740
     /* 1341740 */   GIM_Try, /*On fail goto*//*Label 19168*/ GIMT_Encode4(1341824), // Rule ID 20144 //
     /* 1341745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1341762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1341765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341798 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1341801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341823 */     // GIR_Coverage, 20144,
     /* 1341823 */     GIR_EraseRootFromParent_Done,
     /* 1341824 */   // Label 19168: @1341824
     /* 1341824 */   GIM_Try, /*On fail goto*//*Label 19169*/ GIMT_Encode4(1341908), // Rule ID 20145 //
     /* 1341829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1341846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1341849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341882 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1341885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341907 */     // GIR_Coverage, 20145,
     /* 1341907 */     GIR_EraseRootFromParent_Done,
     /* 1341908 */   // Label 19169: @1341908
     /* 1341908 */   GIM_Try, /*On fail goto*//*Label 19170*/ GIMT_Encode4(1341992), // Rule ID 20148 //
     /* 1341913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1341921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1341930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1341933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341966 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1341969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341991 */     // GIR_Coverage, 20148,
     /* 1341991 */     GIR_EraseRootFromParent_Done,
     /* 1341992 */   // Label 19170: @1341992
     /* 1341992 */   GIM_Try, /*On fail goto*//*Label 19171*/ GIMT_Encode4(1342076), // Rule ID 20149 //
     /* 1341997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1342017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342075 */     // GIR_Coverage, 20149,
     /* 1342075 */     GIR_EraseRootFromParent_Done,
     /* 1342076 */   // Label 19171: @1342076
     /* 1342076 */   GIM_Try, /*On fail goto*//*Label 19172*/ GIMT_Encode4(1342160), // Rule ID 20152 //
     /* 1342081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1342084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1342101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342134 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342159 */     // GIR_Coverage, 20152,
     /* 1342159 */     GIR_EraseRootFromParent_Done,
     /* 1342160 */   // Label 19172: @1342160
     /* 1342160 */   GIM_Try, /*On fail goto*//*Label 19173*/ GIMT_Encode4(1342244), // Rule ID 20153 //
     /* 1342165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1342168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1342182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1342185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342218 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1342221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342243 */     // GIR_Coverage, 20153,
     /* 1342243 */     GIR_EraseRootFromParent_Done,
     /* 1342244 */   // Label 19173: @1342244
     /* 1342244 */   GIM_Try, /*On fail goto*//*Label 19174*/ GIMT_Encode4(1342328), // Rule ID 20156 //
     /* 1342249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1342269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342302 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342327 */     // GIR_Coverage, 20156,
     /* 1342327 */     GIR_EraseRootFromParent_Done,
     /* 1342328 */   // Label 19174: @1342328
     /* 1342328 */   GIM_Try, /*On fail goto*//*Label 19175*/ GIMT_Encode4(1342412), // Rule ID 20157 //
     /* 1342333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1342350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1342353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342386 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342411 */     // GIR_Coverage, 20157,
     /* 1342411 */     GIR_EraseRootFromParent_Done,
     /* 1342412 */   // Label 19175: @1342412
     /* 1342412 */   GIM_Try, /*On fail goto*//*Label 19176*/ GIMT_Encode4(1342496), // Rule ID 20160 //
     /* 1342417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1342437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342470 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1342473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342495 */     // GIR_Coverage, 20160,
     /* 1342495 */     GIR_EraseRootFromParent_Done,
     /* 1342496 */   // Label 19176: @1342496
     /* 1342496 */   GIM_Try, /*On fail goto*//*Label 19177*/ GIMT_Encode4(1342580), // Rule ID 20161 //
     /* 1342501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1342512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1342515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1342518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1342521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1342524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342554 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1342557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342579 */     // GIR_Coverage, 20161,
     /* 1342579 */     GIR_EraseRootFromParent_Done,
     /* 1342580 */   // Label 19177: @1342580
     /* 1342580 */   GIM_Try, /*On fail goto*//*Label 19178*/ GIMT_Encode4(1342664), // Rule ID 20164 //
     /* 1342585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1342596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1342599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1342602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1342605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1342608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342638 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1342641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342663 */     // GIR_Coverage, 20164,
     /* 1342663 */     GIR_EraseRootFromParent_Done,
     /* 1342664 */   // Label 19178: @1342664
     /* 1342664 */   GIM_Try, /*On fail goto*//*Label 19179*/ GIMT_Encode4(1342748), // Rule ID 20165 //
     /* 1342669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1342680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1342683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1342686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1342689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1342692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342722 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1342725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342747 */     // GIR_Coverage, 20165,
     /* 1342747 */     GIR_EraseRootFromParent_Done,
     /* 1342748 */   // Label 19179: @1342748
     /* 1342748 */   GIM_Try, /*On fail goto*//*Label 19180*/ GIMT_Encode4(1342832), // Rule ID 20168 //
     /* 1342753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1342770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1342773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342806 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342831 */     // GIR_Coverage, 20168,
     /* 1342831 */     GIR_EraseRootFromParent_Done,
     /* 1342832 */   // Label 19180: @1342832
     /* 1342832 */   GIM_Try, /*On fail goto*//*Label 19181*/ GIMT_Encode4(1342916), // Rule ID 20169 //
     /* 1342837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1342854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1342857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1342879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342890 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1342893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342915 */     // GIR_Coverage, 20169,
     /* 1342915 */     GIR_EraseRootFromParent_Done,
     /* 1342916 */   // Label 19181: @1342916
     /* 1342916 */   GIM_Try, /*On fail goto*//*Label 19182*/ GIMT_Encode4(1343000), // Rule ID 20172 //
     /* 1342921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1342929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1342938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1342941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342974 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1342977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342999 */     // GIR_Coverage, 20172,
     /* 1342999 */     GIR_EraseRootFromParent_Done,
     /* 1343000 */   // Label 19182: @1343000
     /* 1343000 */   GIM_Try, /*On fail goto*//*Label 19183*/ GIMT_Encode4(1343084), // Rule ID 20173 //
     /* 1343005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1343025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343058 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343083 */     // GIR_Coverage, 20173,
     /* 1343083 */     GIR_EraseRootFromParent_Done,
     /* 1343084 */   // Label 19183: @1343084
     /* 1343084 */   GIM_Try, /*On fail goto*//*Label 19184*/ GIMT_Encode4(1343168), // Rule ID 20176 //
     /* 1343089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1343109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343142 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343167 */     // GIR_Coverage, 20176,
     /* 1343167 */     GIR_EraseRootFromParent_Done,
     /* 1343168 */   // Label 19184: @1343168
     /* 1343168 */   GIM_Try, /*On fail goto*//*Label 19185*/ GIMT_Encode4(1343252), // Rule ID 20177 //
     /* 1343173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1343190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1343193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343226 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343251 */     // GIR_Coverage, 20177,
     /* 1343251 */     GIR_EraseRootFromParent_Done,
     /* 1343252 */   // Label 19185: @1343252
     /* 1343252 */   GIM_Try, /*On fail goto*//*Label 19186*/ GIMT_Encode4(1343336), // Rule ID 20180 //
     /* 1343257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1343277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343310 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343335 */     // GIR_Coverage, 20180,
     /* 1343335 */     GIR_EraseRootFromParent_Done,
     /* 1343336 */   // Label 19186: @1343336
     /* 1343336 */   GIM_Try, /*On fail goto*//*Label 19187*/ GIMT_Encode4(1343420), // Rule ID 20181 //
     /* 1343341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1343358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1343361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343394 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1343397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343419 */     // GIR_Coverage, 20181,
     /* 1343419 */     GIR_EraseRootFromParent_Done,
     /* 1343420 */   // Label 19187: @1343420
     /* 1343420 */   GIM_Try, /*On fail goto*//*Label 19188*/ GIMT_Encode4(1343504), // Rule ID 20184 //
     /* 1343425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1343442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1343445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343478 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343503 */     // GIR_Coverage, 20184,
     /* 1343503 */     GIR_EraseRootFromParent_Done,
     /* 1343504 */   // Label 19188: @1343504
     /* 1343504 */   GIM_Try, /*On fail goto*//*Label 19189*/ GIMT_Encode4(1343588), // Rule ID 20185 //
     /* 1343509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1343526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1343529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343562 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1343565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343587 */     // GIR_Coverage, 20185,
     /* 1343587 */     GIR_EraseRootFromParent_Done,
     /* 1343588 */   // Label 19189: @1343588
     /* 1343588 */   GIM_Try, /*On fail goto*//*Label 19190*/ GIMT_Encode4(1343672), // Rule ID 20188 //
     /* 1343593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1343610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1343613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343646 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343671 */     // GIR_Coverage, 20188,
     /* 1343671 */     GIR_EraseRootFromParent_Done,
     /* 1343672 */   // Label 19190: @1343672
     /* 1343672 */   GIM_Try, /*On fail goto*//*Label 19191*/ GIMT_Encode4(1343756), // Rule ID 20189 //
     /* 1343677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1343694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1343697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343730 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1343733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343755 */     // GIR_Coverage, 20189,
     /* 1343755 */     GIR_EraseRootFromParent_Done,
     /* 1343756 */   // Label 19191: @1343756
     /* 1343756 */   GIM_Try, /*On fail goto*//*Label 19192*/ GIMT_Encode4(1343840), // Rule ID 20192 //
     /* 1343761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1343772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1343775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1343778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1343784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343814 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1343817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343839 */     // GIR_Coverage, 20192,
     /* 1343839 */     GIR_EraseRootFromParent_Done,
     /* 1343840 */   // Label 19192: @1343840
     /* 1343840 */   GIM_Try, /*On fail goto*//*Label 19193*/ GIMT_Encode4(1343924), // Rule ID 20193 //
     /* 1343845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1343856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1343859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1343862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1343868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343898 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1343901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343923 */     // GIR_Coverage, 20193,
     /* 1343923 */     GIR_EraseRootFromParent_Done,
     /* 1343924 */   // Label 19193: @1343924
     /* 1343924 */   GIM_Try, /*On fail goto*//*Label 19194*/ GIMT_Encode4(1344008), // Rule ID 20196 //
     /* 1343929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1343937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1343940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1343943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1343946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1343952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343982 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1343985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344007 */     // GIR_Coverage, 20196,
     /* 1344007 */     GIR_EraseRootFromParent_Done,
     /* 1344008 */   // Label 19194: @1344008
     /* 1344008 */   GIM_Try, /*On fail goto*//*Label 19195*/ GIMT_Encode4(1344092), // Rule ID 20197 //
     /* 1344013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1344030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344066 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1344069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344091 */     // GIR_Coverage, 20197,
     /* 1344091 */     GIR_EraseRootFromParent_Done,
     /* 1344092 */   // Label 19195: @1344092
     /* 1344092 */   GIM_Try, /*On fail goto*//*Label 19196*/ GIMT_Encode4(1344176), // Rule ID 20200 //
     /* 1344097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344150 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1344153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344175 */     // GIR_Coverage, 20200,
     /* 1344175 */     GIR_EraseRootFromParent_Done,
     /* 1344176 */   // Label 19196: @1344176
     /* 1344176 */   GIM_Try, /*On fail goto*//*Label 19197*/ GIMT_Encode4(1344260), // Rule ID 20201 //
     /* 1344181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1344198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344234 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1344237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344259 */     // GIR_Coverage, 20201,
     /* 1344259 */     GIR_EraseRootFromParent_Done,
     /* 1344260 */   // Label 19197: @1344260
     /* 1344260 */   GIM_Try, /*On fail goto*//*Label 19198*/ GIMT_Encode4(1344344), // Rule ID 20204 //
     /* 1344265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344318 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1344321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344343 */     // GIR_Coverage, 20204,
     /* 1344343 */     GIR_EraseRootFromParent_Done,
     /* 1344344 */   // Label 19198: @1344344
     /* 1344344 */   GIM_Try, /*On fail goto*//*Label 19199*/ GIMT_Encode4(1344428), // Rule ID 20205 //
     /* 1344349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1344366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344402 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1344405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344427 */     // GIR_Coverage, 20205,
     /* 1344427 */     GIR_EraseRootFromParent_Done,
     /* 1344428 */   // Label 19199: @1344428
     /* 1344428 */   GIM_Try, /*On fail goto*//*Label 19200*/ GIMT_Encode4(1344512), // Rule ID 20208 //
     /* 1344433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1344450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344486 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1344489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344511 */     // GIR_Coverage, 20208,
     /* 1344511 */     GIR_EraseRootFromParent_Done,
     /* 1344512 */   // Label 19200: @1344512
     /* 1344512 */   GIM_Try, /*On fail goto*//*Label 19201*/ GIMT_Encode4(1344596), // Rule ID 20209 //
     /* 1344517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1344534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344570 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1344573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344595 */     // GIR_Coverage, 20209,
     /* 1344595 */     GIR_EraseRootFromParent_Done,
     /* 1344596 */   // Label 19201: @1344596
     /* 1344596 */   GIM_Try, /*On fail goto*//*Label 19202*/ GIMT_Encode4(1344680), // Rule ID 20212 //
     /* 1344601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1344618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344654 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1344657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344679 */     // GIR_Coverage, 20212,
     /* 1344679 */     GIR_EraseRootFromParent_Done,
     /* 1344680 */   // Label 19202: @1344680
     /* 1344680 */   GIM_Try, /*On fail goto*//*Label 19203*/ GIMT_Encode4(1344764), // Rule ID 20213 //
     /* 1344685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1344702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344738 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1344741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344763 */     // GIR_Coverage, 20213,
     /* 1344763 */     GIR_EraseRootFromParent_Done,
     /* 1344764 */   // Label 19203: @1344764
     /* 1344764 */   GIM_Try, /*On fail goto*//*Label 19204*/ GIMT_Encode4(1344848), // Rule ID 20216 //
     /* 1344769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1344786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344822 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1344825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344847 */     // GIR_Coverage, 20216,
     /* 1344847 */     GIR_EraseRootFromParent_Done,
     /* 1344848 */   // Label 19204: @1344848
     /* 1344848 */   GIM_Try, /*On fail goto*//*Label 19205*/ GIMT_Encode4(1344932), // Rule ID 20217 //
     /* 1344853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1344870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344906 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1344909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344931 */     // GIR_Coverage, 20217,
     /* 1344931 */     GIR_EraseRootFromParent_Done,
     /* 1344932 */   // Label 19205: @1344932
     /* 1344932 */   GIM_Try, /*On fail goto*//*Label 19206*/ GIMT_Encode4(1345016), // Rule ID 20220 //
     /* 1344937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1344945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1344948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1344951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1344954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1344957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1344960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1344979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344990 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1344993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345015 */     // GIR_Coverage, 20220,
     /* 1345015 */     GIR_EraseRootFromParent_Done,
     /* 1345016 */   // Label 19206: @1345016
     /* 1345016 */   GIM_Try, /*On fail goto*//*Label 19207*/ GIMT_Encode4(1345100), // Rule ID 20221 //
     /* 1345021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1345038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345074 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1345077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345099 */     // GIR_Coverage, 20221,
     /* 1345099 */     GIR_EraseRootFromParent_Done,
     /* 1345100 */   // Label 19207: @1345100
     /* 1345100 */   GIM_Try, /*On fail goto*//*Label 19208*/ GIMT_Encode4(1345184), // Rule ID 20224 //
     /* 1345105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345158 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1345161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345183 */     // GIR_Coverage, 20224,
     /* 1345183 */     GIR_EraseRootFromParent_Done,
     /* 1345184 */   // Label 19208: @1345184
     /* 1345184 */   GIM_Try, /*On fail goto*//*Label 19209*/ GIMT_Encode4(1345268), // Rule ID 20225 //
     /* 1345189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1345200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1345203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1345206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1345209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1345212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1345231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345242 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1345245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345267 */     // GIR_Coverage, 20225,
     /* 1345267 */     GIR_EraseRootFromParent_Done,
     /* 1345268 */   // Label 19209: @1345268
     /* 1345268 */   GIM_Try, /*On fail goto*//*Label 19210*/ GIMT_Encode4(1345352), // Rule ID 20228 //
     /* 1345273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345326 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1345329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345351 */     // GIR_Coverage, 20228,
     /* 1345351 */     GIR_EraseRootFromParent_Done,
     /* 1345352 */   // Label 19210: @1345352
     /* 1345352 */   GIM_Try, /*On fail goto*//*Label 19211*/ GIMT_Encode4(1345436), // Rule ID 20229 //
     /* 1345357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1345374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345410 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1345413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345435 */     // GIR_Coverage, 20229,
     /* 1345435 */     GIR_EraseRootFromParent_Done,
     /* 1345436 */   // Label 19211: @1345436
     /* 1345436 */   GIM_Try, /*On fail goto*//*Label 19212*/ GIMT_Encode4(1345520), // Rule ID 20232 //
     /* 1345441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1345458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345494 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1345497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345519 */     // GIR_Coverage, 20232,
     /* 1345519 */     GIR_EraseRootFromParent_Done,
     /* 1345520 */   // Label 19212: @1345520
     /* 1345520 */   GIM_Try, /*On fail goto*//*Label 19213*/ GIMT_Encode4(1345604), // Rule ID 20233 //
     /* 1345525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1345542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345578 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1345581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345603 */     // GIR_Coverage, 20233,
     /* 1345603 */     GIR_EraseRootFromParent_Done,
     /* 1345604 */   // Label 19213: @1345604
     /* 1345604 */   GIM_Try, /*On fail goto*//*Label 19214*/ GIMT_Encode4(1345688), // Rule ID 20236 //
     /* 1345609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1345626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345662 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1345665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345687 */     // GIR_Coverage, 20236,
     /* 1345687 */     GIR_EraseRootFromParent_Done,
     /* 1345688 */   // Label 19214: @1345688
     /* 1345688 */   GIM_Try, /*On fail goto*//*Label 19215*/ GIMT_Encode4(1345772), // Rule ID 20237 //
     /* 1345693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1345710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1345713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1345731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1345735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345746 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1345749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345771 */     // GIR_Coverage, 20237,
     /* 1345771 */     GIR_EraseRootFromParent_Done,
     /* 1345772 */   // Label 19215: @1345772
     /* 1345772 */   GIM_Try, /*On fail goto*//*Label 19216*/ GIMT_Encode4(1345856), // Rule ID 20240 //
     /* 1345777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1345780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1345794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1345833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345855 */     // GIR_Coverage, 20240,
     /* 1345855 */     GIR_EraseRootFromParent_Done,
     /* 1345856 */   // Label 19216: @1345856
     /* 1345856 */   GIM_Try, /*On fail goto*//*Label 19217*/ GIMT_Encode4(1345940), // Rule ID 20241 //
     /* 1345861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1345864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1345878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345914 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1345917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1345923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1345925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345939 */     // GIR_Coverage, 20241,
     /* 1345939 */     GIR_EraseRootFromParent_Done,
     /* 1345940 */   // Label 19217: @1345940
     /* 1345940 */   GIM_Try, /*On fail goto*//*Label 19218*/ GIMT_Encode4(1346024), // Rule ID 20244 //
     /* 1345945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1345948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1345953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1345962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1345965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1345987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345998 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1346001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346023 */     // GIR_Coverage, 20244,
     /* 1346023 */     GIR_EraseRootFromParent_Done,
     /* 1346024 */   // Label 19218: @1346024
     /* 1346024 */   GIM_Try, /*On fail goto*//*Label 19219*/ GIMT_Encode4(1346108), // Rule ID 20245 //
     /* 1346029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1346046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346082 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1346085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346107 */     // GIR_Coverage, 20245,
     /* 1346107 */     GIR_EraseRootFromParent_Done,
     /* 1346108 */   // Label 19219: @1346108
     /* 1346108 */   GIM_Try, /*On fail goto*//*Label 19220*/ GIMT_Encode4(1346192), // Rule ID 20248 //
     /* 1346113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346166 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1346169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346191 */     // GIR_Coverage, 20248,
     /* 1346191 */     GIR_EraseRootFromParent_Done,
     /* 1346192 */   // Label 19220: @1346192
     /* 1346192 */   GIM_Try, /*On fail goto*//*Label 19221*/ GIMT_Encode4(1346276), // Rule ID 20249 //
     /* 1346197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1346205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1346214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1346217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1346239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346250 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1346253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346275 */     // GIR_Coverage, 20249,
     /* 1346275 */     GIR_EraseRootFromParent_Done,
     /* 1346276 */   // Label 19221: @1346276
     /* 1346276 */   GIM_Try, /*On fail goto*//*Label 19222*/ GIMT_Encode4(1346360), // Rule ID 20252 //
     /* 1346281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346334 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1346337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346359 */     // GIR_Coverage, 20252,
     /* 1346359 */     GIR_EraseRootFromParent_Done,
     /* 1346360 */   // Label 19222: @1346360
     /* 1346360 */   GIM_Try, /*On fail goto*//*Label 19223*/ GIMT_Encode4(1346444), // Rule ID 20253 //
     /* 1346365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1346382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346418 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1346421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346443 */     // GIR_Coverage, 20253,
     /* 1346443 */     GIR_EraseRootFromParent_Done,
     /* 1346444 */   // Label 19223: @1346444
     /* 1346444 */   GIM_Try, /*On fail goto*//*Label 19224*/ GIMT_Encode4(1346528), // Rule ID 20256 //
     /* 1346449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1346466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346502 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1346505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346527 */     // GIR_Coverage, 20256,
     /* 1346527 */     GIR_EraseRootFromParent_Done,
     /* 1346528 */   // Label 19224: @1346528
     /* 1346528 */   GIM_Try, /*On fail goto*//*Label 19225*/ GIMT_Encode4(1346612), // Rule ID 20257 //
     /* 1346533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1346550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346586 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1346589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346611 */     // GIR_Coverage, 20257,
     /* 1346611 */     GIR_EraseRootFromParent_Done,
     /* 1346612 */   // Label 19225: @1346612
     /* 1346612 */   GIM_Try, /*On fail goto*//*Label 19226*/ GIMT_Encode4(1346696), // Rule ID 20260 //
     /* 1346617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1346634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346670 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1346673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346695 */     // GIR_Coverage, 20260,
     /* 1346695 */     GIR_EraseRootFromParent_Done,
     /* 1346696 */   // Label 19226: @1346696
     /* 1346696 */   GIM_Try, /*On fail goto*//*Label 19227*/ GIMT_Encode4(1346780), // Rule ID 20261 //
     /* 1346701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1346712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1346715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1346718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1346724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346754 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1346757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346779 */     // GIR_Coverage, 20261,
     /* 1346779 */     GIR_EraseRootFromParent_Done,
     /* 1346780 */   // Label 19227: @1346780
     /* 1346780 */   GIM_Try, /*On fail goto*//*Label 19228*/ GIMT_Encode4(1346864), // Rule ID 20264 //
     /* 1346785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1346802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346838 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1346841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346863 */     // GIR_Coverage, 20264,
     /* 1346863 */     GIR_EraseRootFromParent_Done,
     /* 1346864 */   // Label 19228: @1346864
     /* 1346864 */   GIM_Try, /*On fail goto*//*Label 19229*/ GIMT_Encode4(1346948), // Rule ID 20265 //
     /* 1346869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1346886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1346889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1346911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346922 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1346925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1346931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1346933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346947 */     // GIR_Coverage, 20265,
     /* 1346947 */     GIR_EraseRootFromParent_Done,
     /* 1346948 */   // Label 19229: @1346948
     /* 1346948 */   GIM_Try, /*On fail goto*//*Label 19230*/ GIMT_Encode4(1347032), // Rule ID 20268 //
     /* 1346953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1346970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1346973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1346995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347006 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1347009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347031 */     // GIR_Coverage, 20268,
     /* 1347031 */     GIR_EraseRootFromParent_Done,
     /* 1347032 */   // Label 19230: @1347032
     /* 1347032 */   GIM_Try, /*On fail goto*//*Label 19231*/ GIMT_Encode4(1347116), // Rule ID 20269 //
     /* 1347037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1347054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347090 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1347093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347115 */     // GIR_Coverage, 20269,
     /* 1347115 */     GIR_EraseRootFromParent_Done,
     /* 1347116 */   // Label 19231: @1347116
     /* 1347116 */   GIM_Try, /*On fail goto*//*Label 19232*/ GIMT_Encode4(1347200), // Rule ID 20272 //
     /* 1347121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1347124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347174 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1347177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347199 */     // GIR_Coverage, 20272,
     /* 1347199 */     GIR_EraseRootFromParent_Done,
     /* 1347200 */   // Label 19232: @1347200
     /* 1347200 */   GIM_Try, /*On fail goto*//*Label 19233*/ GIMT_Encode4(1347284), // Rule ID 20273 //
     /* 1347205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1347222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1347225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1347247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347258 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1347261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347283 */     // GIR_Coverage, 20273,
     /* 1347283 */     GIR_EraseRootFromParent_Done,
     /* 1347284 */   // Label 19233: @1347284
     /* 1347284 */   GIM_Try, /*On fail goto*//*Label 19234*/ GIMT_Encode4(1347368), // Rule ID 20276 //
     /* 1347289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347342 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1347345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347367 */     // GIR_Coverage, 20276,
     /* 1347367 */     GIR_EraseRootFromParent_Done,
     /* 1347368 */   // Label 19234: @1347368
     /* 1347368 */   GIM_Try, /*On fail goto*//*Label 19235*/ GIMT_Encode4(1347452), // Rule ID 20277 //
     /* 1347373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1347390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347426 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1347429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347451 */     // GIR_Coverage, 20277,
     /* 1347451 */     GIR_EraseRootFromParent_Done,
     /* 1347452 */   // Label 19235: @1347452
     /* 1347452 */   GIM_Try, /*On fail goto*//*Label 19236*/ GIMT_Encode4(1347536), // Rule ID 20280 //
     /* 1347457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1347468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1347471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347510 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1347513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347535 */     // GIR_Coverage, 20280,
     /* 1347535 */     GIR_EraseRootFromParent_Done,
     /* 1347536 */   // Label 19236: @1347536
     /* 1347536 */   GIM_Try, /*On fail goto*//*Label 19237*/ GIMT_Encode4(1347620), // Rule ID 20281 //
     /* 1347541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1347552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1347555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1347558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1347564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347594 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1347597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347619 */     // GIR_Coverage, 20281,
     /* 1347619 */     GIR_EraseRootFromParent_Done,
     /* 1347620 */   // Label 19237: @1347620
     /* 1347620 */   GIM_Try, /*On fail goto*//*Label 19238*/ GIMT_Encode4(1347704), // Rule ID 20284 //
     /* 1347625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1347636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1347639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1347642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1347648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347678 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1347681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347703 */     // GIR_Coverage, 20284,
     /* 1347703 */     GIR_EraseRootFromParent_Done,
     /* 1347704 */   // Label 19238: @1347704
     /* 1347704 */   GIM_Try, /*On fail goto*//*Label 19239*/ GIMT_Encode4(1347788), // Rule ID 20285 //
     /* 1347709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1347720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1347723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1347726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1347729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1347732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1347751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347762 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1347765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347787 */     // GIR_Coverage, 20285,
     /* 1347787 */     GIR_EraseRootFromParent_Done,
     /* 1347788 */   // Label 19239: @1347788
     /* 1347788 */   GIM_Try, /*On fail goto*//*Label 19240*/ GIMT_Encode4(1347872), // Rule ID 20288 //
     /* 1347793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1347810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347846 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1347849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347871 */     // GIR_Coverage, 20288,
     /* 1347871 */     GIR_EraseRootFromParent_Done,
     /* 1347872 */   // Label 19240: @1347872
     /* 1347872 */   GIM_Try, /*On fail goto*//*Label 19241*/ GIMT_Encode4(1347956), // Rule ID 20289 //
     /* 1347877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1347894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1347915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1347919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1347933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1347939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1347941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347955 */     // GIR_Coverage, 20289,
     /* 1347955 */     GIR_EraseRootFromParent_Done,
     /* 1347956 */   // Label 19241: @1347956
     /* 1347956 */   GIM_Try, /*On fail goto*//*Label 19242*/ GIMT_Encode4(1348040), // Rule ID 20292 //
     /* 1347961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1347978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1347981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348014 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1348017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348039 */     // GIR_Coverage, 20292,
     /* 1348039 */     GIR_EraseRootFromParent_Done,
     /* 1348040 */   // Label 19242: @1348040
     /* 1348040 */   GIM_Try, /*On fail goto*//*Label 19243*/ GIMT_Encode4(1348124), // Rule ID 20293 //
     /* 1348045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1348062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348098 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1348101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348123 */     // GIR_Coverage, 20293,
     /* 1348123 */     GIR_EraseRootFromParent_Done,
     /* 1348124 */   // Label 19243: @1348124
     /* 1348124 */   GIM_Try, /*On fail goto*//*Label 19244*/ GIMT_Encode4(1348208), // Rule ID 20296 //
     /* 1348129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348182 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1348185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348207 */     // GIR_Coverage, 20296,
     /* 1348207 */     GIR_EraseRootFromParent_Done,
     /* 1348208 */   // Label 19244: @1348208
     /* 1348208 */   GIM_Try, /*On fail goto*//*Label 19245*/ GIMT_Encode4(1348292), // Rule ID 20297 //
     /* 1348213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1348230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1348233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1348255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348266 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1348269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348291 */     // GIR_Coverage, 20297,
     /* 1348291 */     GIR_EraseRootFromParent_Done,
     /* 1348292 */   // Label 19245: @1348292
     /* 1348292 */   GIM_Try, /*On fail goto*//*Label 19246*/ GIMT_Encode4(1348376), // Rule ID 20300 //
     /* 1348297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348350 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1348353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348375 */     // GIR_Coverage, 20300,
     /* 1348375 */     GIR_EraseRootFromParent_Done,
     /* 1348376 */   // Label 19246: @1348376
     /* 1348376 */   GIM_Try, /*On fail goto*//*Label 19247*/ GIMT_Encode4(1348460), // Rule ID 20301 //
     /* 1348381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1348398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348434 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1348437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348459 */     // GIR_Coverage, 20301,
     /* 1348459 */     GIR_EraseRootFromParent_Done,
     /* 1348460 */   // Label 19247: @1348460
     /* 1348460 */   GIM_Try, /*On fail goto*//*Label 19248*/ GIMT_Encode4(1348544), // Rule ID 20304 //
     /* 1348465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1348521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348543 */     // GIR_Coverage, 20304,
     /* 1348543 */     GIR_EraseRootFromParent_Done,
     /* 1348544 */   // Label 19248: @1348544
     /* 1348544 */   GIM_Try, /*On fail goto*//*Label 19249*/ GIMT_Encode4(1348628), // Rule ID 20305 //
     /* 1348549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1348566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1348605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348627 */     // GIR_Coverage, 20305,
     /* 1348627 */     GIR_EraseRootFromParent_Done,
     /* 1348628 */   // Label 19249: @1348628
     /* 1348628 */   GIM_Try, /*On fail goto*//*Label 19250*/ GIMT_Encode4(1348712), // Rule ID 20308 //
     /* 1348633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1348650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348686 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1348689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348711 */     // GIR_Coverage, 20308,
     /* 1348711 */     GIR_EraseRootFromParent_Done,
     /* 1348712 */   // Label 19250: @1348712
     /* 1348712 */   GIM_Try, /*On fail goto*//*Label 19251*/ GIMT_Encode4(1348796), // Rule ID 20309 //
     /* 1348717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1348725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1348734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1348737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1348759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1348773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348795 */     // GIR_Coverage, 20309,
     /* 1348795 */     GIR_EraseRootFromParent_Done,
     /* 1348796 */   // Label 19251: @1348796
     /* 1348796 */   GIM_Try, /*On fail goto*//*Label 19252*/ GIMT_Encode4(1348880), // Rule ID 20312 //
     /* 1348801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1348812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1348815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1348818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348854 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1348857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348879 */     // GIR_Coverage, 20312,
     /* 1348879 */     GIR_EraseRootFromParent_Done,
     /* 1348880 */   // Label 19252: @1348880
     /* 1348880 */   GIM_Try, /*On fail goto*//*Label 19253*/ GIMT_Encode4(1348964), // Rule ID 20313 //
     /* 1348885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1348896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1348899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1348902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1348927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348938 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1348941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1348947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1348949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348963 */     // GIR_Coverage, 20313,
     /* 1348963 */     GIR_EraseRootFromParent_Done,
     /* 1348964 */   // Label 19253: @1348964
     /* 1348964 */   GIM_Try, /*On fail goto*//*Label 19254*/ GIMT_Encode4(1349048), // Rule ID 20316 //
     /* 1348969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1348986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1348989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349022 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1349025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349047 */     // GIR_Coverage, 20316,
     /* 1349047 */     GIR_EraseRootFromParent_Done,
     /* 1349048 */   // Label 19254: @1349048
     /* 1349048 */   GIM_Try, /*On fail goto*//*Label 19255*/ GIMT_Encode4(1349132), // Rule ID 20317 //
     /* 1349053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1349070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349106 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1349109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349131 */     // GIR_Coverage, 20317,
     /* 1349131 */     GIR_EraseRootFromParent_Done,
     /* 1349132 */   // Label 19255: @1349132
     /* 1349132 */   GIM_Try, /*On fail goto*//*Label 19256*/ GIMT_Encode4(1349216), // Rule ID 20320 //
     /* 1349137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1349193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349215 */     // GIR_Coverage, 20320,
     /* 1349215 */     GIR_EraseRootFromParent_Done,
     /* 1349216 */   // Label 19256: @1349216
     /* 1349216 */   GIM_Try, /*On fail goto*//*Label 19257*/ GIMT_Encode4(1349300), // Rule ID 20321 //
     /* 1349221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1349238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349274 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1349277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349299 */     // GIR_Coverage, 20321,
     /* 1349299 */     GIR_EraseRootFromParent_Done,
     /* 1349300 */   // Label 19257: @1349300
     /* 1349300 */   GIM_Try, /*On fail goto*//*Label 19258*/ GIMT_Encode4(1349384), // Rule ID 20324 //
     /* 1349305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349358 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1349361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349383 */     // GIR_Coverage, 20324,
     /* 1349383 */     GIR_EraseRootFromParent_Done,
     /* 1349384 */   // Label 19258: @1349384
     /* 1349384 */   GIM_Try, /*On fail goto*//*Label 19259*/ GIMT_Encode4(1349468), // Rule ID 20325 //
     /* 1349389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1349406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1349445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349467 */     // GIR_Coverage, 20325,
     /* 1349467 */     GIR_EraseRootFromParent_Done,
     /* 1349468 */   // Label 19259: @1349468
     /* 1349468 */   GIM_Try, /*On fail goto*//*Label 19260*/ GIMT_Encode4(1349552), // Rule ID 20328 //
     /* 1349473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1349490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349526 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1349529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349551 */     // GIR_Coverage, 20328,
     /* 1349551 */     GIR_EraseRootFromParent_Done,
     /* 1349552 */   // Label 19260: @1349552
     /* 1349552 */   GIM_Try, /*On fail goto*//*Label 19261*/ GIMT_Encode4(1349636), // Rule ID 20329 //
     /* 1349557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1349574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1349577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1349599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349610 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1349613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349635 */     // GIR_Coverage, 20329,
     /* 1349635 */     GIR_EraseRootFromParent_Done,
     /* 1349636 */   // Label 19261: @1349636
     /* 1349636 */   GIM_Try, /*On fail goto*//*Label 19262*/ GIMT_Encode4(1349720), // Rule ID 20332 //
     /* 1349641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1349658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349694 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1349697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349719 */     // GIR_Coverage, 20332,
     /* 1349719 */     GIR_EraseRootFromParent_Done,
     /* 1349720 */   // Label 19262: @1349720
     /* 1349720 */   GIM_Try, /*On fail goto*//*Label 19263*/ GIMT_Encode4(1349804), // Rule ID 20333 //
     /* 1349725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1349736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1349739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1349742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1349745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1349767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349778 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1349781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349803 */     // GIR_Coverage, 20333,
     /* 1349803 */     GIR_EraseRootFromParent_Done,
     /* 1349804 */   // Label 19263: @1349804
     /* 1349804 */   GIM_Try, /*On fail goto*//*Label 19264*/ GIMT_Encode4(1349888), // Rule ID 20336 //
     /* 1349809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1349826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349862 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1349865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349887 */     // GIR_Coverage, 20336,
     /* 1349887 */     GIR_EraseRootFromParent_Done,
     /* 1349888 */   // Label 19264: @1349888
     /* 1349888 */   GIM_Try, /*On fail goto*//*Label 19265*/ GIMT_Encode4(1349972), // Rule ID 20337 //
     /* 1349893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1349896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1349910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349946 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1349949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349971 */     // GIR_Coverage, 20337,
     /* 1349971 */     GIR_EraseRootFromParent_Done,
     /* 1349972 */   // Label 19265: @1349972
     /* 1349972 */   GIM_Try, /*On fail goto*//*Label 19266*/ GIMT_Encode4(1350056), // Rule ID 20340 //
     /* 1349977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1349988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1349991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1349994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350030 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1350033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350055 */     // GIR_Coverage, 20340,
     /* 1350055 */     GIR_EraseRootFromParent_Done,
     /* 1350056 */   // Label 19266: @1350056
     /* 1350056 */   GIM_Try, /*On fail goto*//*Label 19267*/ GIMT_Encode4(1350140), // Rule ID 20341 //
     /* 1350061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1350078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350114 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1350117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350139 */     // GIR_Coverage, 20341,
     /* 1350139 */     GIR_EraseRootFromParent_Done,
     /* 1350140 */   // Label 19267: @1350140
     /* 1350140 */   GIM_Try, /*On fail goto*//*Label 19268*/ GIMT_Encode4(1350224), // Rule ID 20344 //
     /* 1350145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350198 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1350201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350223 */     // GIR_Coverage, 20344,
     /* 1350223 */     GIR_EraseRootFromParent_Done,
     /* 1350224 */   // Label 19268: @1350224
     /* 1350224 */   GIM_Try, /*On fail goto*//*Label 19269*/ GIMT_Encode4(1350308), // Rule ID 20345 //
     /* 1350229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1350240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1350243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1350246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1350252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350282 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1350285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350307 */     // GIR_Coverage, 20345,
     /* 1350307 */     GIR_EraseRootFromParent_Done,
     /* 1350308 */   // Label 19269: @1350308
     /* 1350308 */   GIM_Try, /*On fail goto*//*Label 19270*/ GIMT_Encode4(1350392), // Rule ID 20348 //
     /* 1350313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350366 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1350369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350391 */     // GIR_Coverage, 20348,
     /* 1350391 */     GIR_EraseRootFromParent_Done,
     /* 1350392 */   // Label 19270: @1350392
     /* 1350392 */   GIM_Try, /*On fail goto*//*Label 19271*/ GIMT_Encode4(1350476), // Rule ID 20349 //
     /* 1350397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1350414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1350453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350475 */     // GIR_Coverage, 20349,
     /* 1350475 */     GIR_EraseRootFromParent_Done,
     /* 1350476 */   // Label 19271: @1350476
     /* 1350476 */   GIM_Try, /*On fail goto*//*Label 19272*/ GIMT_Encode4(1350560), // Rule ID 20352 //
     /* 1350481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1350498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350534 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1350537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350559 */     // GIR_Coverage, 20352,
     /* 1350559 */     GIR_EraseRootFromParent_Done,
     /* 1350560 */   // Label 19272: @1350560
     /* 1350560 */   GIM_Try, /*On fail goto*//*Label 19273*/ GIMT_Encode4(1350644), // Rule ID 20353 //
     /* 1350565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1350576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1350579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1350582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1350588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1350603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350618 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1350621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350643 */     // GIR_Coverage, 20353,
     /* 1350643 */     GIR_EraseRootFromParent_Done,
     /* 1350644 */   // Label 19273: @1350644
     /* 1350644 */   GIM_Try, /*On fail goto*//*Label 19274*/ GIMT_Encode4(1350728), // Rule ID 20356 //
     /* 1350649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1350666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350702 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1350705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350727 */     // GIR_Coverage, 20356,
     /* 1350727 */     GIR_EraseRootFromParent_Done,
     /* 1350728 */   // Label 19274: @1350728
     /* 1350728 */   GIM_Try, /*On fail goto*//*Label 19275*/ GIMT_Encode4(1350812), // Rule ID 20357 //
     /* 1350733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1350744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1350747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1350750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1350756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1350771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350786 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1350789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350811 */     // GIR_Coverage, 20357,
     /* 1350811 */     GIR_EraseRootFromParent_Done,
     /* 1350812 */   // Label 19275: @1350812
     /* 1350812 */   GIM_Try, /*On fail goto*//*Label 19276*/ GIMT_Encode4(1350896), // Rule ID 20360 //
     /* 1350817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1350820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1350834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1350859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350870 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1350870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1350873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350895 */     // GIR_Coverage, 20360,
     /* 1350895 */     GIR_EraseRootFromParent_Done,
     /* 1350896 */   // Label 19276: @1350896
     /* 1350896 */   GIM_Try, /*On fail goto*//*Label 19277*/ GIMT_Encode4(1350980), // Rule ID 20361 //
     /* 1350901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1350904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1350912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1350915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1350918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1350921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1350939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1350943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350954 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1350954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1350957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1350975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1350978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350979 */     // GIR_Coverage, 20361,
     /* 1350979 */     GIR_EraseRootFromParent_Done,
     /* 1350980 */   // Label 19277: @1350980
     /* 1350980 */   GIM_Try, /*On fail goto*//*Label 19278*/ GIMT_Encode4(1351064), // Rule ID 20364 //
     /* 1350985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1350988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1350993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1350996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1350999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1351041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351063 */     // GIR_Coverage, 20364,
     /* 1351063 */     GIR_EraseRootFromParent_Done,
     /* 1351064 */   // Label 19278: @1351064
     /* 1351064 */   GIM_Try, /*On fail goto*//*Label 19279*/ GIMT_Encode4(1351148), // Rule ID 20365 //
     /* 1351069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1351086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1351107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351122 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1351125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351147 */     // GIR_Coverage, 20365,
     /* 1351147 */     GIR_EraseRootFromParent_Done,
     /* 1351148 */   // Label 19279: @1351148
     /* 1351148 */   GIM_Try, /*On fail goto*//*Label 19280*/ GIMT_Encode4(1351232), // Rule ID 20368 //
     /* 1351153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351206 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1351209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351231 */     // GIR_Coverage, 20368,
     /* 1351231 */     GIR_EraseRootFromParent_Done,
     /* 1351232 */   // Label 19280: @1351232
     /* 1351232 */   GIM_Try, /*On fail goto*//*Label 19281*/ GIMT_Encode4(1351316), // Rule ID 20369 //
     /* 1351237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1351245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1351248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1351251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1351254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1351275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351290 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1351293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351315 */     // GIR_Coverage, 20369,
     /* 1351315 */     GIR_EraseRootFromParent_Done,
     /* 1351316 */   // Label 19281: @1351316
     /* 1351316 */   GIM_Try, /*On fail goto*//*Label 19282*/ GIMT_Encode4(1351400), // Rule ID 20372 //
     /* 1351321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351374 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1351377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351399 */     // GIR_Coverage, 20372,
     /* 1351399 */     GIR_EraseRootFromParent_Done,
     /* 1351400 */   // Label 19282: @1351400
     /* 1351400 */   GIM_Try, /*On fail goto*//*Label 19283*/ GIMT_Encode4(1351484), // Rule ID 20373 //
     /* 1351405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1351422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1351425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351458 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1351461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351483 */     // GIR_Coverage, 20373,
     /* 1351483 */     GIR_EraseRootFromParent_Done,
     /* 1351484 */   // Label 19283: @1351484
     /* 1351484 */   GIM_Try, /*On fail goto*//*Label 19284*/ GIMT_Encode4(1351568), // Rule ID 20376 //
     /* 1351489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1351506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1351509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351542 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1351545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351567 */     // GIR_Coverage, 20376,
     /* 1351567 */     GIR_EraseRootFromParent_Done,
     /* 1351568 */   // Label 19284: @1351568
     /* 1351568 */   GIM_Try, /*On fail goto*//*Label 19285*/ GIMT_Encode4(1351652), // Rule ID 20377 //
     /* 1351573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1351584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1351587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1351590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1351593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351626 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1351629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351651 */     // GIR_Coverage, 20377,
     /* 1351651 */     GIR_EraseRootFromParent_Done,
     /* 1351652 */   // Label 19285: @1351652
     /* 1351652 */   GIM_Try, /*On fail goto*//*Label 19286*/ GIMT_Encode4(1351736), // Rule ID 20380 //
     /* 1351657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1351674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1351677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351710 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1351713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351735 */     // GIR_Coverage, 20380,
     /* 1351735 */     GIR_EraseRootFromParent_Done,
     /* 1351736 */   // Label 19286: @1351736
     /* 1351736 */   GIM_Try, /*On fail goto*//*Label 19287*/ GIMT_Encode4(1351820), // Rule ID 20381 //
     /* 1351741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1351752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1351755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1351758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1351761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351794 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1351797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351819 */     // GIR_Coverage, 20381,
     /* 1351819 */     GIR_EraseRootFromParent_Done,
     /* 1351820 */   // Label 19287: @1351820
     /* 1351820 */   GIM_Try, /*On fail goto*//*Label 19288*/ GIMT_Encode4(1351904), // Rule ID 20384 //
     /* 1351825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1351842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1351845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351878 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1351878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1351881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351903 */     // GIR_Coverage, 20384,
     /* 1351903 */     GIR_EraseRootFromParent_Done,
     /* 1351904 */   // Label 19288: @1351904
     /* 1351904 */   GIM_Try, /*On fail goto*//*Label 19289*/ GIMT_Encode4(1351988), // Rule ID 20385 //
     /* 1351909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1351917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1351920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1351923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1351926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1351929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351962 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1351962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1351965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1351971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1351973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1351986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351987 */     // GIR_Coverage, 20385,
     /* 1351987 */     GIR_EraseRootFromParent_Done,
     /* 1351988 */   // Label 19289: @1351988
     /* 1351988 */   GIM_Try, /*On fail goto*//*Label 19290*/ GIMT_Encode4(1352072), // Rule ID 20388 //
     /* 1351993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352046 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352071 */     // GIR_Coverage, 20388,
     /* 1352071 */     GIR_EraseRootFromParent_Done,
     /* 1352072 */   // Label 19290: @1352072
     /* 1352072 */   GIM_Try, /*On fail goto*//*Label 19291*/ GIMT_Encode4(1352156), // Rule ID 20389 //
     /* 1352077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1352088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1352091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1352094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1352097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1352100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352130 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352155 */     // GIR_Coverage, 20389,
     /* 1352155 */     GIR_EraseRootFromParent_Done,
     /* 1352156 */   // Label 19291: @1352156
     /* 1352156 */   GIM_Try, /*On fail goto*//*Label 19292*/ GIMT_Encode4(1352240), // Rule ID 20392 //
     /* 1352161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1352164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352214 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352239 */     // GIR_Coverage, 20392,
     /* 1352239 */     GIR_EraseRootFromParent_Done,
     /* 1352240 */   // Label 19292: @1352240
     /* 1352240 */   GIM_Try, /*On fail goto*//*Label 19293*/ GIMT_Encode4(1352324), // Rule ID 20393 //
     /* 1352245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1352248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1352256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1352259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1352262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1352265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1352268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352298 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1352301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1352319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352323 */     // GIR_Coverage, 20393,
     /* 1352323 */     GIR_EraseRootFromParent_Done,
     /* 1352324 */   // Label 19293: @1352324
     /* 1352324 */   GIM_Try, /*On fail goto*//*Label 19294*/ GIMT_Encode4(1352408), // Rule ID 20396 //
     /* 1352329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352382 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352407 */     // GIR_Coverage, 20396,
     /* 1352407 */     GIR_EraseRootFromParent_Done,
     /* 1352408 */   // Label 19294: @1352408
     /* 1352408 */   GIM_Try, /*On fail goto*//*Label 19295*/ GIMT_Encode4(1352492), // Rule ID 20397 //
     /* 1352413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1352424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1352427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1352430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1352433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1352436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352466 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352491 */     // GIR_Coverage, 20397,
     /* 1352491 */     GIR_EraseRootFromParent_Done,
     /* 1352492 */   // Label 19295: @1352492
     /* 1352492 */   GIM_Try, /*On fail goto*//*Label 19296*/ GIMT_Encode4(1352576), // Rule ID 20400 //
     /* 1352497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1352508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1352511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352550 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1352553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352575 */     // GIR_Coverage, 20400,
     /* 1352575 */     GIR_EraseRootFromParent_Done,
     /* 1352576 */   // Label 19296: @1352576
     /* 1352576 */   GIM_Try, /*On fail goto*//*Label 19297*/ GIMT_Encode4(1352660), // Rule ID 20401 //
     /* 1352581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1352592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1352595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1352637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352659 */     // GIR_Coverage, 20401,
     /* 1352659 */     GIR_EraseRootFromParent_Done,
     /* 1352660 */   // Label 19297: @1352660
     /* 1352660 */   GIM_Try, /*On fail goto*//*Label 19298*/ GIMT_Encode4(1352744), // Rule ID 20404 //
     /* 1352665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1352676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1352679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1352682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1352685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1352688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352718 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1352721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352743 */     // GIR_Coverage, 20404,
     /* 1352743 */     GIR_EraseRootFromParent_Done,
     /* 1352744 */   // Label 19298: @1352744
     /* 1352744 */   GIM_Try, /*On fail goto*//*Label 19299*/ GIMT_Encode4(1352828), // Rule ID 20405 //
     /* 1352749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1352760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1352763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1352766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1352769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1352772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352802 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1352805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352827 */     // GIR_Coverage, 20405,
     /* 1352827 */     GIR_EraseRootFromParent_Done,
     /* 1352828 */   // Label 19299: @1352828
     /* 1352828 */   GIM_Try, /*On fail goto*//*Label 19300*/ GIMT_Encode4(1352912), // Rule ID 20408 //
     /* 1352833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1352850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1352853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352886 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1352886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352911 */     // GIR_Coverage, 20408,
     /* 1352911 */     GIR_EraseRootFromParent_Done,
     /* 1352912 */   // Label 19300: @1352912
     /* 1352912 */   GIM_Try, /*On fail goto*//*Label 19301*/ GIMT_Encode4(1352996), // Rule ID 20409 //
     /* 1352917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1352925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1352928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1352931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1352934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1352937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1352951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352970 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1352970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1352973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1352979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1352981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1352994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352995 */     // GIR_Coverage, 20409,
     /* 1352995 */     GIR_EraseRootFromParent_Done,
     /* 1352996 */   // Label 19301: @1352996
     /* 1352996 */   GIM_Try, /*On fail goto*//*Label 19302*/ GIMT_Encode4(1353080), // Rule ID 20412 //
     /* 1353001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353079 */     // GIR_Coverage, 20412,
     /* 1353079 */     GIR_EraseRootFromParent_Done,
     /* 1353080 */   // Label 19302: @1353080
     /* 1353080 */   GIM_Try, /*On fail goto*//*Label 19303*/ GIMT_Encode4(1353164), // Rule ID 20413 //
     /* 1353085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353138 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353163 */     // GIR_Coverage, 20413,
     /* 1353163 */     GIR_EraseRootFromParent_Done,
     /* 1353164 */   // Label 19303: @1353164
     /* 1353164 */   GIM_Try, /*On fail goto*//*Label 19304*/ GIMT_Encode4(1353248), // Rule ID 20416 //
     /* 1353169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353222 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353247 */     // GIR_Coverage, 20416,
     /* 1353247 */     GIR_EraseRootFromParent_Done,
     /* 1353248 */   // Label 19304: @1353248
     /* 1353248 */   GIM_Try, /*On fail goto*//*Label 19305*/ GIMT_Encode4(1353332), // Rule ID 20417 //
     /* 1353253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1353264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1353267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353306 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353331 */     // GIR_Coverage, 20417,
     /* 1353331 */     GIR_EraseRootFromParent_Done,
     /* 1353332 */   // Label 19305: @1353332
     /* 1353332 */   GIM_Try, /*On fail goto*//*Label 19306*/ GIMT_Encode4(1353416), // Rule ID 20420 //
     /* 1353337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353390 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353415 */     // GIR_Coverage, 20420,
     /* 1353415 */     GIR_EraseRootFromParent_Done,
     /* 1353416 */   // Label 19306: @1353416
     /* 1353416 */   GIM_Try, /*On fail goto*//*Label 19307*/ GIMT_Encode4(1353500), // Rule ID 20421 //
     /* 1353421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1353432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1353435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353474 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1353477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353499 */     // GIR_Coverage, 20421,
     /* 1353499 */     GIR_EraseRootFromParent_Done,
     /* 1353500 */   // Label 19307: @1353500
     /* 1353500 */   GIM_Try, /*On fail goto*//*Label 19308*/ GIMT_Encode4(1353584), // Rule ID 20424 //
     /* 1353505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1353522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1353525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353558 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353583 */     // GIR_Coverage, 20424,
     /* 1353583 */     GIR_EraseRootFromParent_Done,
     /* 1353584 */   // Label 19308: @1353584
     /* 1353584 */   GIM_Try, /*On fail goto*//*Label 19309*/ GIMT_Encode4(1353668), // Rule ID 20425 //
     /* 1353589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1353600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1353603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1353606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1353609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1353612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353642 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1353645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353667 */     // GIR_Coverage, 20425,
     /* 1353667 */     GIR_EraseRootFromParent_Done,
     /* 1353668 */   // Label 19309: @1353668
     /* 1353668 */   GIM_Try, /*On fail goto*//*Label 19310*/ GIMT_Encode4(1353752), // Rule ID 20428 //
     /* 1353673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1353690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1353693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353726 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353751 */     // GIR_Coverage, 20428,
     /* 1353751 */     GIR_EraseRootFromParent_Done,
     /* 1353752 */   // Label 19310: @1353752
     /* 1353752 */   GIM_Try, /*On fail goto*//*Label 19311*/ GIMT_Encode4(1353836), // Rule ID 20429 //
     /* 1353757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1353765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1353768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1353771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1353774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1353777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353810 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1353813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353835 */     // GIR_Coverage, 20429,
     /* 1353835 */     GIR_EraseRootFromParent_Done,
     /* 1353836 */   // Label 19311: @1353836
     /* 1353836 */   GIM_Try, /*On fail goto*//*Label 19312*/ GIMT_Encode4(1353920), // Rule ID 20432 //
     /* 1353841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1353844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1353852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1353855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1353858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1353861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353894 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1353894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1353897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1353918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353919 */     // GIR_Coverage, 20432,
     /* 1353919 */     GIR_EraseRootFromParent_Done,
     /* 1353920 */   // Label 19312: @1353920
     /* 1353920 */   GIM_Try, /*On fail goto*//*Label 19313*/ GIMT_Encode4(1354004), // Rule ID 20433 //
     /* 1353925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1353928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1353933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1353936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1353939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1353942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1353945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1353948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1353967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353978 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1353978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1353981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1353987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1353989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1353999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354003 */     // GIR_Coverage, 20433,
     /* 1354003 */     GIR_EraseRootFromParent_Done,
     /* 1354004 */   // Label 19313: @1354004
     /* 1354004 */   GIM_Try, /*On fail goto*//*Label 19314*/ GIMT_Encode4(1354088), // Rule ID 20436 //
     /* 1354009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354062 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354087 */     // GIR_Coverage, 20436,
     /* 1354087 */     GIR_EraseRootFromParent_Done,
     /* 1354088 */   // Label 19314: @1354088
     /* 1354088 */   GIM_Try, /*On fail goto*//*Label 19315*/ GIMT_Encode4(1354172), // Rule ID 20437 //
     /* 1354093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1354110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1354113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354146 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354171 */     // GIR_Coverage, 20437,
     /* 1354171 */     GIR_EraseRootFromParent_Done,
     /* 1354172 */   // Label 19315: @1354172
     /* 1354172 */   GIM_Try, /*On fail goto*//*Label 19316*/ GIMT_Encode4(1354256), // Rule ID 20440 //
     /* 1354177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354230 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354255 */     // GIR_Coverage, 20440,
     /* 1354255 */     GIR_EraseRootFromParent_Done,
     /* 1354256 */   // Label 19316: @1354256
     /* 1354256 */   GIM_Try, /*On fail goto*//*Label 19317*/ GIMT_Encode4(1354340), // Rule ID 20441 //
     /* 1354261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1354278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1354281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354314 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1354317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354339 */     // GIR_Coverage, 20441,
     /* 1354339 */     GIR_EraseRootFromParent_Done,
     /* 1354340 */   // Label 19317: @1354340
     /* 1354340 */   GIM_Try, /*On fail goto*//*Label 19318*/ GIMT_Encode4(1354424), // Rule ID 20444 //
     /* 1354345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1354365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354398 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354423 */     // GIR_Coverage, 20444,
     /* 1354423 */     GIR_EraseRootFromParent_Done,
     /* 1354424 */   // Label 19318: @1354424
     /* 1354424 */   GIM_Try, /*On fail goto*//*Label 19319*/ GIMT_Encode4(1354508), // Rule ID 20445 //
     /* 1354429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1354440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1354443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1354446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1354449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354482 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354507 */     // GIR_Coverage, 20445,
     /* 1354507 */     GIR_EraseRootFromParent_Done,
     /* 1354508 */   // Label 19319: @1354508
     /* 1354508 */   GIM_Try, /*On fail goto*//*Label 19320*/ GIMT_Encode4(1354592), // Rule ID 20448 //
     /* 1354513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1354516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1354530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1354533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354566 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354591 */     // GIR_Coverage, 20448,
     /* 1354591 */     GIR_EraseRootFromParent_Done,
     /* 1354592 */   // Label 19320: @1354592
     /* 1354592 */   GIM_Try, /*On fail goto*//*Label 19321*/ GIMT_Encode4(1354676), // Rule ID 20449 //
     /* 1354597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1354600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1354608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1354611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1354614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1354617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354650 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1354671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354675 */     // GIR_Coverage, 20449,
     /* 1354675 */     GIR_EraseRootFromParent_Done,
     /* 1354676 */   // Label 19321: @1354676
     /* 1354676 */   GIM_Try, /*On fail goto*//*Label 19322*/ GIMT_Encode4(1354760), // Rule ID 20452 //
     /* 1354681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1354684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1354698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1354701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354734 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354759 */     // GIR_Coverage, 20452,
     /* 1354759 */     GIR_EraseRootFromParent_Done,
     /* 1354760 */   // Label 19322: @1354760
     /* 1354760 */   GIM_Try, /*On fail goto*//*Label 19323*/ GIMT_Encode4(1354844), // Rule ID 20453 //
     /* 1354765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1354776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1354779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1354782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1354785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354818 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1354821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354843 */     // GIR_Coverage, 20453,
     /* 1354843 */     GIR_EraseRootFromParent_Done,
     /* 1354844 */   // Label 19323: @1354844
     /* 1354844 */   GIM_Try, /*On fail goto*//*Label 19324*/ GIMT_Encode4(1354928), // Rule ID 20456 //
     /* 1354849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1354852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1354866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1354869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1354902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1354905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1354923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1354926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354927 */     // GIR_Coverage, 20456,
     /* 1354927 */     GIR_EraseRootFromParent_Done,
     /* 1354928 */   // Label 19324: @1354928
     /* 1354928 */   GIM_Try, /*On fail goto*//*Label 19325*/ GIMT_Encode4(1355012), // Rule ID 20457 //
     /* 1354933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1354936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1354941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1354944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1354947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1354950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1354953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1354975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354986 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1354986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1354989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1354995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1354997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355011 */     // GIR_Coverage, 20457,
     /* 1355011 */     GIR_EraseRootFromParent_Done,
     /* 1355012 */   // Label 19325: @1355012
     /* 1355012 */   GIM_Try, /*On fail goto*//*Label 19326*/ GIMT_Encode4(1355096), // Rule ID 20460 //
     /* 1355017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1355037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355070 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355095 */     // GIR_Coverage, 20460,
     /* 1355095 */     GIR_EraseRootFromParent_Done,
     /* 1355096 */   // Label 19326: @1355096
     /* 1355096 */   GIM_Try, /*On fail goto*//*Label 19327*/ GIMT_Encode4(1355180), // Rule ID 20461 //
     /* 1355101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1355118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1355121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355154 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355179 */     // GIR_Coverage, 20461,
     /* 1355179 */     GIR_EraseRootFromParent_Done,
     /* 1355180 */   // Label 19327: @1355180
     /* 1355180 */   GIM_Try, /*On fail goto*//*Label 19328*/ GIMT_Encode4(1355264), // Rule ID 20464 //
     /* 1355185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1355188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1355196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1355199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1355202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1355205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355238 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355263 */     // GIR_Coverage, 20464,
     /* 1355263 */     GIR_EraseRootFromParent_Done,
     /* 1355264 */   // Label 19328: @1355264
     /* 1355264 */   GIM_Try, /*On fail goto*//*Label 19329*/ GIMT_Encode4(1355348), // Rule ID 20465 //
     /* 1355269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1355272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1355280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1355283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1355286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1355289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1355292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355322 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355347 */     // GIR_Coverage, 20465,
     /* 1355347 */     GIR_EraseRootFromParent_Done,
     /* 1355348 */   // Label 19329: @1355348
     /* 1355348 */   GIM_Try, /*On fail goto*//*Label 19330*/ GIMT_Encode4(1355432), // Rule ID 20468 //
     /* 1355353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1355370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1355373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355406 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355431 */     // GIR_Coverage, 20468,
     /* 1355431 */     GIR_EraseRootFromParent_Done,
     /* 1355432 */   // Label 19330: @1355432
     /* 1355432 */   GIM_Try, /*On fail goto*//*Label 19331*/ GIMT_Encode4(1355516), // Rule ID 20469 //
     /* 1355437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1355448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1355451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1355454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1355457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355490 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355515 */     // GIR_Coverage, 20469,
     /* 1355515 */     GIR_EraseRootFromParent_Done,
     /* 1355516 */   // Label 19331: @1355516
     /* 1355516 */   GIM_Try, /*On fail goto*//*Label 19332*/ GIMT_Encode4(1355600), // Rule ID 20472 //
     /* 1355521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1355538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1355541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355574 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355599 */     // GIR_Coverage, 20472,
     /* 1355599 */     GIR_EraseRootFromParent_Done,
     /* 1355600 */   // Label 19332: @1355600
     /* 1355600 */   GIM_Try, /*On fail goto*//*Label 19333*/ GIMT_Encode4(1355684), // Rule ID 20473 //
     /* 1355605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1355616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1355619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1355622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1355625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1355647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355658 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1355661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355683 */     // GIR_Coverage, 20473,
     /* 1355683 */     GIR_EraseRootFromParent_Done,
     /* 1355684 */   // Label 19333: @1355684
     /* 1355684 */   GIM_Try, /*On fail goto*//*Label 19334*/ GIMT_Encode4(1355768), // Rule ID 20476 //
     /* 1355689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1355692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1355706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1355709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355742 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355767 */     // GIR_Coverage, 20476,
     /* 1355767 */     GIR_EraseRootFromParent_Done,
     /* 1355768 */   // Label 19334: @1355768
     /* 1355768 */   GIM_Try, /*On fail goto*//*Label 19335*/ GIMT_Encode4(1355852), // Rule ID 20477 //
     /* 1355773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1355776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1355784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1355787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1355790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1355793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1355796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1355815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355826 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1355829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355851 */     // GIR_Coverage, 20477,
     /* 1355851 */     GIR_EraseRootFromParent_Done,
     /* 1355852 */   // Label 19335: @1355852
     /* 1355852 */   GIM_Try, /*On fail goto*//*Label 19336*/ GIMT_Encode4(1355936), // Rule ID 20480 //
     /* 1355857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1355860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1355874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1355877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355910 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1355910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1355917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1355919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1355921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1355931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1355934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355935 */     // GIR_Coverage, 20480,
     /* 1355935 */     GIR_EraseRootFromParent_Done,
     /* 1355936 */   // Label 19336: @1355936
     /* 1355936 */   GIM_Try, /*On fail goto*//*Label 19337*/ GIMT_Encode4(1356020), // Rule ID 20481 //
     /* 1355941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1355944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1355949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1355952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1355955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1355958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1355961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1355983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355994 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1355994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1355997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356019 */     // GIR_Coverage, 20481,
     /* 1356019 */     GIR_EraseRootFromParent_Done,
     /* 1356020 */   // Label 19337: @1356020
     /* 1356020 */   GIM_Try, /*On fail goto*//*Label 19338*/ GIMT_Encode4(1356104), // Rule ID 20484 //
     /* 1356025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1356045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356078 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356103 */     // GIR_Coverage, 20484,
     /* 1356103 */     GIR_EraseRootFromParent_Done,
     /* 1356104 */   // Label 19338: @1356104
     /* 1356104 */   GIM_Try, /*On fail goto*//*Label 19339*/ GIMT_Encode4(1356188), // Rule ID 20485 //
     /* 1356109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1356120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1356123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1356126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1356129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1356132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1356165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356187 */     // GIR_Coverage, 20485,
     /* 1356187 */     GIR_EraseRootFromParent_Done,
     /* 1356188 */   // Label 19339: @1356188
     /* 1356188 */   GIM_Try, /*On fail goto*//*Label 19340*/ GIMT_Encode4(1356272), // Rule ID 20488 //
     /* 1356193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1356196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1356210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1356213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356246 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1356246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356271 */     // GIR_Coverage, 20488,
     /* 1356271 */     GIR_EraseRootFromParent_Done,
     /* 1356272 */   // Label 19340: @1356272
     /* 1356272 */   GIM_Try, /*On fail goto*//*Label 19341*/ GIMT_Encode4(1356356), // Rule ID 20489 //
     /* 1356277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1356280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1356285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1356288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1356291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1356294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1356297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356330 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1356330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1356333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1356339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1356341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1356354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356355 */     // GIR_Coverage, 20489,
     /* 1356355 */     GIR_EraseRootFromParent_Done,
     /* 1356356 */   // Label 19341: @1356356
     /* 1356356 */   GIM_Try, /*On fail goto*//*Label 19342*/ GIMT_Encode4(1356437), // Rule ID 20546 //
     /* 1356361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1356364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1356381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356414 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1356417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356436 */     // GIR_Coverage, 20546,
     /* 1356436 */     GIR_EraseRootFromParent_Done,
     /* 1356437 */   // Label 19342: @1356437
     /* 1356437 */   GIM_Try, /*On fail goto*//*Label 19343*/ GIMT_Encode4(1356518), // Rule ID 20547 //
     /* 1356442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1356445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1356462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356495 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1356498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356517 */     // GIR_Coverage, 20547,
     /* 1356517 */     GIR_EraseRootFromParent_Done,
     /* 1356518 */   // Label 19343: @1356518
     /* 1356518 */   GIM_Try, /*On fail goto*//*Label 19344*/ GIMT_Encode4(1356599), // Rule ID 20548 //
     /* 1356523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356576 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1356579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356598 */     // GIR_Coverage, 20548,
     /* 1356598 */     GIR_EraseRootFromParent_Done,
     /* 1356599 */   // Label 19344: @1356599
     /* 1356599 */   GIM_Try, /*On fail goto*//*Label 19345*/ GIMT_Encode4(1356680), // Rule ID 20549 //
     /* 1356604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1356615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1356618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1356621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356657 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1356660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356679 */     // GIR_Coverage, 20549,
     /* 1356679 */     GIR_EraseRootFromParent_Done,
     /* 1356680 */   // Label 19345: @1356680
     /* 1356680 */   GIM_Try, /*On fail goto*//*Label 19346*/ GIMT_Encode4(1356761), // Rule ID 20550 //
     /* 1356685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1356688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1356696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1356699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1356702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1356705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356738 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1356741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356760 */     // GIR_Coverage, 20550,
     /* 1356760 */     GIR_EraseRootFromParent_Done,
     /* 1356761 */   // Label 19346: @1356761
     /* 1356761 */   GIM_Try, /*On fail goto*//*Label 19347*/ GIMT_Encode4(1356842), // Rule ID 20551 //
     /* 1356766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1356769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1356774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1356777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1356780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1356783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1356786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356819 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1356822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356841 */     // GIR_Coverage, 20551,
     /* 1356841 */     GIR_EraseRootFromParent_Done,
     /* 1356842 */   // Label 19347: @1356842
     /* 1356842 */   GIM_Try, /*On fail goto*//*Label 19348*/ GIMT_Encode4(1356923), // Rule ID 20552 //
     /* 1356847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1356850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1356858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1356861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1356864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356900 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1356900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1356903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356922 */     // GIR_Coverage, 20552,
     /* 1356922 */     GIR_EraseRootFromParent_Done,
     /* 1356923 */   // Label 19348: @1356923
     /* 1356923 */   GIM_Try, /*On fail goto*//*Label 19349*/ GIMT_Encode4(1357004), // Rule ID 20553 //
     /* 1356928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1356931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1356936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1356939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1356942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1356945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1356948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1356951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1356970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356981 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1356981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1356984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1356988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357003 */     // GIR_Coverage, 20553,
     /* 1357003 */     GIR_EraseRootFromParent_Done,
     /* 1357004 */   // Label 19349: @1357004
     /* 1357004 */   GIM_Try, /*On fail goto*//*Label 19350*/ GIMT_Encode4(1357085), // Rule ID 20554 //
     /* 1357009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1357029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357062 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357084 */     // GIR_Coverage, 20554,
     /* 1357084 */     GIR_EraseRootFromParent_Done,
     /* 1357085 */   // Label 19350: @1357085
     /* 1357085 */   GIM_Try, /*On fail goto*//*Label 19351*/ GIMT_Encode4(1357166), // Rule ID 20555 //
     /* 1357090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1357110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357143 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1357146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357165 */     // GIR_Coverage, 20555,
     /* 1357165 */     GIR_EraseRootFromParent_Done,
     /* 1357166 */   // Label 19351: @1357166
     /* 1357166 */   GIM_Try, /*On fail goto*//*Label 19352*/ GIMT_Encode4(1357247), // Rule ID 20556 //
     /* 1357171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357224 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1357227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357246 */     // GIR_Coverage, 20556,
     /* 1357246 */     GIR_EraseRootFromParent_Done,
     /* 1357247 */   // Label 19352: @1357247
     /* 1357247 */   GIM_Try, /*On fail goto*//*Label 19353*/ GIMT_Encode4(1357328), // Rule ID 20557 //
     /* 1357252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1357263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1357266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1357269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1357275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357305 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1357308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357327 */     // GIR_Coverage, 20557,
     /* 1357327 */     GIR_EraseRootFromParent_Done,
     /* 1357328 */   // Label 19353: @1357328
     /* 1357328 */   GIM_Try, /*On fail goto*//*Label 19354*/ GIMT_Encode4(1357409), // Rule ID 20558 //
     /* 1357333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1357336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357386 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357408 */     // GIR_Coverage, 20558,
     /* 1357408 */     GIR_EraseRootFromParent_Done,
     /* 1357409 */   // Label 19354: @1357409
     /* 1357409 */   GIM_Try, /*On fail goto*//*Label 19355*/ GIMT_Encode4(1357490), // Rule ID 20559 //
     /* 1357414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1357417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357467 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357489 */     // GIR_Coverage, 20559,
     /* 1357489 */     GIR_EraseRootFromParent_Done,
     /* 1357490 */   // Label 19355: @1357490
     /* 1357490 */   GIM_Try, /*On fail goto*//*Label 19356*/ GIMT_Encode4(1357571), // Rule ID 20560 //
     /* 1357495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1357498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357548 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1357548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1357551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357570 */     // GIR_Coverage, 20560,
     /* 1357570 */     GIR_EraseRootFromParent_Done,
     /* 1357571 */   // Label 19356: @1357571
     /* 1357571 */   GIM_Try, /*On fail goto*//*Label 19357*/ GIMT_Encode4(1357652), // Rule ID 20561 //
     /* 1357576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1357579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1357593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1357596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1357618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357629 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11211:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1357629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1357632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357651 */     // GIR_Coverage, 20561,
     /* 1357651 */     GIR_EraseRootFromParent_Done,
     /* 1357652 */   // Label 19357: @1357652
     /* 1357652 */   GIM_Try, /*On fail goto*//*Label 19358*/ GIMT_Encode4(1357733), // Rule ID 20562 //
     /* 1357657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1357674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357710 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357732 */     // GIR_Coverage, 20562,
     /* 1357732 */     GIR_EraseRootFromParent_Done,
     /* 1357733 */   // Label 19358: @1357733
     /* 1357733 */   GIM_Try, /*On fail goto*//*Label 19359*/ GIMT_Encode4(1357814), // Rule ID 20563 //
     /* 1357738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1357755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357791 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1357794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357813 */     // GIR_Coverage, 20563,
     /* 1357813 */     GIR_EraseRootFromParent_Done,
     /* 1357814 */   // Label 19359: @1357814
     /* 1357814 */   GIM_Try, /*On fail goto*//*Label 19360*/ GIMT_Encode4(1357895), // Rule ID 20564 //
     /* 1357819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1357822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1357836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357872 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1357872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1357875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357894 */     // GIR_Coverage, 20564,
     /* 1357894 */     GIR_EraseRootFromParent_Done,
     /* 1357895 */   // Label 19360: @1357895
     /* 1357895 */   GIM_Try, /*On fail goto*//*Label 19361*/ GIMT_Encode4(1357976), // Rule ID 20565 //
     /* 1357900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1357903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1357908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1357917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1357920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1357942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357953 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1357953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1357956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1357960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357975 */     // GIR_Coverage, 20565,
     /* 1357975 */     GIR_EraseRootFromParent_Done,
     /* 1357976 */   // Label 19361: @1357976
     /* 1357976 */   GIM_Try, /*On fail goto*//*Label 19362*/ GIMT_Encode4(1358057), // Rule ID 20566 //
     /* 1357981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1357984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1357989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1357992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1357995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1357998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358034 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358056 */     // GIR_Coverage, 20566,
     /* 1358056 */     GIR_EraseRootFromParent_Done,
     /* 1358057 */   // Label 19362: @1358057
     /* 1358057 */   GIM_Try, /*On fail goto*//*Label 19363*/ GIMT_Encode4(1358138), // Rule ID 20567 //
     /* 1358062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358115 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1358118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358137 */     // GIR_Coverage, 20567,
     /* 1358137 */     GIR_EraseRootFromParent_Done,
     /* 1358138 */   // Label 19363: @1358138
     /* 1358138 */   GIM_Try, /*On fail goto*//*Label 19364*/ GIMT_Encode4(1358219), // Rule ID 20568 //
     /* 1358143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1358146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1358196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1358199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358218 */     // GIR_Coverage, 20568,
     /* 1358218 */     GIR_EraseRootFromParent_Done,
     /* 1358219 */   // Label 19364: @1358219
     /* 1358219 */   GIM_Try, /*On fail goto*//*Label 19365*/ GIMT_Encode4(1358300), // Rule ID 20569 //
     /* 1358224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1358227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1358241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1358244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1358266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358277 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1358277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1358280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358299 */     // GIR_Coverage, 20569,
     /* 1358299 */     GIR_EraseRootFromParent_Done,
     /* 1358300 */   // Label 19365: @1358300
     /* 1358300 */   GIM_Try, /*On fail goto*//*Label 19366*/ GIMT_Encode4(1358381), // Rule ID 20570 //
     /* 1358305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1358308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358358 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358380 */     // GIR_Coverage, 20570,
     /* 1358380 */     GIR_EraseRootFromParent_Done,
     /* 1358381 */   // Label 19366: @1358381
     /* 1358381 */   GIM_Try, /*On fail goto*//*Label 19367*/ GIMT_Encode4(1358462), // Rule ID 20571 //
     /* 1358386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1358389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1358406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358439 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1358442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358461 */     // GIR_Coverage, 20571,
     /* 1358461 */     GIR_EraseRootFromParent_Done,
     /* 1358462 */   // Label 19367: @1358462
     /* 1358462 */   GIM_Try, /*On fail goto*//*Label 19368*/ GIMT_Encode4(1358543), // Rule ID 20572 //
     /* 1358467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1358470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1358523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358542 */     // GIR_Coverage, 20572,
     /* 1358542 */     GIR_EraseRootFromParent_Done,
     /* 1358543 */   // Label 19368: @1358543
     /* 1358543 */   GIM_Try, /*On fail goto*//*Label 19369*/ GIMT_Encode4(1358624), // Rule ID 20573 //
     /* 1358548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1358551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1358559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1358562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1358565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1358578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1358586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358601 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1358604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358623 */     // GIR_Coverage, 20573,
     /* 1358623 */     GIR_EraseRootFromParent_Done,
     /* 1358624 */   // Label 19369: @1358624
     /* 1358624 */   GIM_Try, /*On fail goto*//*Label 19370*/ GIMT_Encode4(1358705), // Rule ID 20574 //
     /* 1358629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1358632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1358640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1358643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1358649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358682 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1358685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358704 */     // GIR_Coverage, 20574,
     /* 1358704 */     GIR_EraseRootFromParent_Done,
     /* 1358705 */   // Label 19370: @1358705
     /* 1358705 */   GIM_Try, /*On fail goto*//*Label 19371*/ GIMT_Encode4(1358786), // Rule ID 20575 //
     /* 1358710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1358713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1358721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1358724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1358730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358763 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1358766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358785 */     // GIR_Coverage, 20575,
     /* 1358785 */     GIR_EraseRootFromParent_Done,
     /* 1358786 */   // Label 19371: @1358786
     /* 1358786 */   GIM_Try, /*On fail goto*//*Label 19372*/ GIMT_Encode4(1358867), // Rule ID 20576 //
     /* 1358791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1358794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1358802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1358805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358844 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1358844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1358847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358866 */     // GIR_Coverage, 20576,
     /* 1358866 */     GIR_EraseRootFromParent_Done,
     /* 1358867 */   // Label 19372: @1358867
     /* 1358867 */   GIM_Try, /*On fail goto*//*Label 19373*/ GIMT_Encode4(1358948), // Rule ID 20577 //
     /* 1358872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1358875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1358880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1358883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1358886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1358889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1358892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1358895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1358902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1358910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1358914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358925 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1358925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1358928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1358932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358947 */     // GIR_Coverage, 20577,
     /* 1358947 */     GIR_EraseRootFromParent_Done,
     /* 1358948 */   // Label 19373: @1358948
     /* 1358948 */   GIM_Try, /*On fail goto*//*Label 19374*/ GIMT_Encode4(1359029), // Rule ID 20578 //
     /* 1358953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1358956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1358961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1358964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1358967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1358970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1358973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1358976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1358983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359006 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359028 */     // GIR_Coverage, 20578,
     /* 1359028 */     GIR_EraseRootFromParent_Done,
     /* 1359029 */   // Label 19374: @1359029
     /* 1359029 */   GIM_Try, /*On fail goto*//*Label 19375*/ GIMT_Encode4(1359110), // Rule ID 20579 //
     /* 1359034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1359037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1359054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359087 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359109 */     // GIR_Coverage, 20579,
     /* 1359109 */     GIR_EraseRootFromParent_Done,
     /* 1359110 */   // Label 19375: @1359110
     /* 1359110 */   GIM_Try, /*On fail goto*//*Label 19376*/ GIMT_Encode4(1359191), // Rule ID 20580 //
     /* 1359115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1359118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359168 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1359168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1359171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359190 */     // GIR_Coverage, 20580,
     /* 1359190 */     GIR_EraseRootFromParent_Done,
     /* 1359191 */   // Label 19376: @1359191
     /* 1359191 */   GIM_Try, /*On fail goto*//*Label 19377*/ GIMT_Encode4(1359272), // Rule ID 20581 //
     /* 1359196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1359199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1359207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1359210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1359213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1359216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1359219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1359238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359249 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1359249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1359252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359271 */     // GIR_Coverage, 20581,
     /* 1359271 */     GIR_EraseRootFromParent_Done,
     /* 1359272 */   // Label 19377: @1359272
     /* 1359272 */   GIM_Try, /*On fail goto*//*Label 19378*/ GIMT_Encode4(1359353), // Rule ID 20582 //
     /* 1359277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359330 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1359333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359352 */     // GIR_Coverage, 20582,
     /* 1359352 */     GIR_EraseRootFromParent_Done,
     /* 1359353 */   // Label 19378: @1359353
     /* 1359353 */   GIM_Try, /*On fail goto*//*Label 19379*/ GIMT_Encode4(1359434), // Rule ID 20583 //
     /* 1359358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1359378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359411 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1359414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359433 */     // GIR_Coverage, 20583,
     /* 1359433 */     GIR_EraseRootFromParent_Done,
     /* 1359434 */   // Label 19379: @1359434
     /* 1359434 */   GIM_Try, /*On fail goto*//*Label 19380*/ GIMT_Encode4(1359515), // Rule ID 20584 //
     /* 1359439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359492 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1359495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359514 */     // GIR_Coverage, 20584,
     /* 1359514 */     GIR_EraseRootFromParent_Done,
     /* 1359515 */   // Label 19380: @1359515
     /* 1359515 */   GIM_Try, /*On fail goto*//*Label 19381*/ GIMT_Encode4(1359596), // Rule ID 20585 //
     /* 1359520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1359531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1359534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1359537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1359550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359573 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1359576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359595 */     // GIR_Coverage, 20585,
     /* 1359595 */     GIR_EraseRootFromParent_Done,
     /* 1359596 */   // Label 19381: @1359596
     /* 1359596 */   GIM_Try, /*On fail goto*//*Label 19382*/ GIMT_Encode4(1359677), // Rule ID 20586 //
     /* 1359601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1359612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1359615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1359621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359654 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1359657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359676 */     // GIR_Coverage, 20586,
     /* 1359676 */     GIR_EraseRootFromParent_Done,
     /* 1359677 */   // Label 19382: @1359677
     /* 1359677 */   GIM_Try, /*On fail goto*//*Label 19383*/ GIMT_Encode4(1359758), // Rule ID 20587 //
     /* 1359682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1359693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1359696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1359702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359735 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1359738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359757 */     // GIR_Coverage, 20587,
     /* 1359757 */     GIR_EraseRootFromParent_Done,
     /* 1359758 */   // Label 19383: @1359758
     /* 1359758 */   GIM_Try, /*On fail goto*//*Label 19384*/ GIMT_Encode4(1359839), // Rule ID 20588 //
     /* 1359763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1359774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1359777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359816 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1359819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359838 */     // GIR_Coverage, 20588,
     /* 1359838 */     GIR_EraseRootFromParent_Done,
     /* 1359839 */   // Label 19384: @1359839
     /* 1359839 */   GIM_Try, /*On fail goto*//*Label 19385*/ GIMT_Encode4(1359920), // Rule ID 20589 //
     /* 1359844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1359847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1359852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1359855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1359858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1359861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1359864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1359874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1359882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1359886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359897 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1359897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1359900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359919 */     // GIR_Coverage, 20589,
     /* 1359919 */     GIR_EraseRootFromParent_Done,
     /* 1359920 */   // Label 19385: @1359920
     /* 1359920 */   GIM_Try, /*On fail goto*//*Label 19386*/ GIMT_Encode4(1360001), // Rule ID 20590 //
     /* 1359925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1359928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1359933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1359936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1359939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1359942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1359945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1359955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1359967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359978 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1359978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1359981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1359985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360000 */     // GIR_Coverage, 20590,
     /* 1360000 */     GIR_EraseRootFromParent_Done,
     /* 1360001 */   // Label 19386: @1360001
     /* 1360001 */   GIM_Try, /*On fail goto*//*Label 19387*/ GIMT_Encode4(1360082), // Rule ID 20591 //
     /* 1360006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1360026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360059 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1360062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360081 */     // GIR_Coverage, 20591,
     /* 1360081 */     GIR_EraseRootFromParent_Done,
     /* 1360082 */   // Label 19387: @1360082
     /* 1360082 */   GIM_Try, /*On fail goto*//*Label 19388*/ GIMT_Encode4(1360163), // Rule ID 20592 //
     /* 1360087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1360090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360140 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1360140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1360143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360162 */     // GIR_Coverage, 20592,
     /* 1360162 */     GIR_EraseRootFromParent_Done,
     /* 1360163 */   // Label 19388: @1360163
     /* 1360163 */   GIM_Try, /*On fail goto*//*Label 19389*/ GIMT_Encode4(1360244), // Rule ID 20593 //
     /* 1360168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1360171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1360179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1360182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1360185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1360188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1360210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360221 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1360221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1360224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360243 */     // GIR_Coverage, 20593,
     /* 1360243 */     GIR_EraseRootFromParent_Done,
     /* 1360244 */   // Label 19389: @1360244
     /* 1360244 */   GIM_Try, /*On fail goto*//*Label 19390*/ GIMT_Encode4(1360325), // Rule ID 20594 //
     /* 1360249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1360269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360302 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1360305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360324 */     // GIR_Coverage, 20594,
     /* 1360324 */     GIR_EraseRootFromParent_Done,
     /* 1360325 */   // Label 19390: @1360325
     /* 1360325 */   GIM_Try, /*On fail goto*//*Label 19391*/ GIMT_Encode4(1360406), // Rule ID 20595 //
     /* 1360330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1360350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360383 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1360386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360405 */     // GIR_Coverage, 20595,
     /* 1360405 */     GIR_EraseRootFromParent_Done,
     /* 1360406 */   // Label 19391: @1360406
     /* 1360406 */   GIM_Try, /*On fail goto*//*Label 19392*/ GIMT_Encode4(1360487), // Rule ID 20596 //
     /* 1360411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360464 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1360467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360486 */     // GIR_Coverage, 20596,
     /* 1360486 */     GIR_EraseRootFromParent_Done,
     /* 1360487 */   // Label 19392: @1360487
     /* 1360487 */   GIM_Try, /*On fail goto*//*Label 19393*/ GIMT_Encode4(1360568), // Rule ID 20597 //
     /* 1360492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1360503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1360506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1360509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1360515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1360522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360545 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1360548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360567 */     // GIR_Coverage, 20597,
     /* 1360567 */     GIR_EraseRootFromParent_Done,
     /* 1360568 */   // Label 19393: @1360568
     /* 1360568 */   GIM_Try, /*On fail goto*//*Label 19394*/ GIMT_Encode4(1360649), // Rule ID 20598 //
     /* 1360573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1360584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1360587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1360590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1360593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360626 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1360629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360648 */     // GIR_Coverage, 20598,
     /* 1360648 */     GIR_EraseRootFromParent_Done,
     /* 1360649 */   // Label 19394: @1360649
     /* 1360649 */   GIM_Try, /*On fail goto*//*Label 19395*/ GIMT_Encode4(1360730), // Rule ID 20599 //
     /* 1360654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1360665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1360668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1360671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1360674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360707 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1360710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360729 */     // GIR_Coverage, 20599,
     /* 1360729 */     GIR_EraseRootFromParent_Done,
     /* 1360730 */   // Label 19395: @1360730
     /* 1360730 */   GIM_Try, /*On fail goto*//*Label 19396*/ GIMT_Encode4(1360811), // Rule ID 20600 //
     /* 1360735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1360746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1360749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1360752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360788 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1360791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360810 */     // GIR_Coverage, 20600,
     /* 1360810 */     GIR_EraseRootFromParent_Done,
     /* 1360811 */   // Label 19396: @1360811
     /* 1360811 */   GIM_Try, /*On fail goto*//*Label 19397*/ GIMT_Encode4(1360892), // Rule ID 20601 //
     /* 1360816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1360824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1360827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1360830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1360833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1360836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1360846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1360858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360869 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1360869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1360872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360891 */     // GIR_Coverage, 20601,
     /* 1360891 */     GIR_EraseRootFromParent_Done,
     /* 1360892 */   // Label 19397: @1360892
     /* 1360892 */   GIM_Try, /*On fail goto*//*Label 19398*/ GIMT_Encode4(1360973), // Rule ID 20602 //
     /* 1360897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1360900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1360908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1360911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1360914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1360917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1360927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360950 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1360950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1360953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1360957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1360971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360972 */     // GIR_Coverage, 20602,
     /* 1360972 */     GIR_EraseRootFromParent_Done,
     /* 1360973 */   // Label 19398: @1360973
     /* 1360973 */   GIM_Try, /*On fail goto*//*Label 19399*/ GIMT_Encode4(1361054), // Rule ID 20603 //
     /* 1360978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1360981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1360986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1360989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1360992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1360995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1360998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361031 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1361034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361053 */     // GIR_Coverage, 20603,
     /* 1361053 */     GIR_EraseRootFromParent_Done,
     /* 1361054 */   // Label 19399: @1361054
     /* 1361054 */   GIM_Try, /*On fail goto*//*Label 19400*/ GIMT_Encode4(1361135), // Rule ID 20604 //
     /* 1361059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1361062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361112 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1361112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1361115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361134 */     // GIR_Coverage, 20604,
     /* 1361134 */     GIR_EraseRootFromParent_Done,
     /* 1361135 */   // Label 19400: @1361135
     /* 1361135 */   GIM_Try, /*On fail goto*//*Label 19401*/ GIMT_Encode4(1361216), // Rule ID 20605 //
     /* 1361140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1361143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1361148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1361151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1361154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1361160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1361170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1361182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361193 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1361193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1361196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1361200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361215 */     // GIR_Coverage, 20605,
     /* 1361215 */     GIR_EraseRootFromParent_Done,
     /* 1361216 */   // Label 19401: @1361216
     /* 1361216 */   GIM_Try, /*On fail goto*//*Label 19402*/ GIMT_Encode4(1361300), // Rule ID 21986 //
     /* 1361221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1361238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361274 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1361277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361299 */     // GIR_Coverage, 21986,
     /* 1361299 */     GIR_EraseRootFromParent_Done,
     /* 1361300 */   // Label 19402: @1361300
     /* 1361300 */   GIM_Try, /*On fail goto*//*Label 19403*/ GIMT_Encode4(1361384), // Rule ID 21987 //
     /* 1361305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1361322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361358 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1361361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361383 */     // GIR_Coverage, 21987,
     /* 1361383 */     GIR_EraseRootFromParent_Done,
     /* 1361384 */   // Label 19403: @1361384
     /* 1361384 */   GIM_Try, /*On fail goto*//*Label 19404*/ GIMT_Encode4(1361468), // Rule ID 21990 //
     /* 1361389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1361406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1361445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361467 */     // GIR_Coverage, 21990,
     /* 1361467 */     GIR_EraseRootFromParent_Done,
     /* 1361468 */   // Label 19404: @1361468
     /* 1361468 */   GIM_Try, /*On fail goto*//*Label 19405*/ GIMT_Encode4(1361552), // Rule ID 21991 //
     /* 1361473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1361490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361526 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1361529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361551 */     // GIR_Coverage, 21991,
     /* 1361551 */     GIR_EraseRootFromParent_Done,
     /* 1361552 */   // Label 19405: @1361552
     /* 1361552 */   GIM_Try, /*On fail goto*//*Label 19406*/ GIMT_Encode4(1361636), // Rule ID 21994 //
     /* 1361557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1361574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1361613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361635 */     // GIR_Coverage, 21994,
     /* 1361635 */     GIR_EraseRootFromParent_Done,
     /* 1361636 */   // Label 19406: @1361636
     /* 1361636 */   GIM_Try, /*On fail goto*//*Label 19407*/ GIMT_Encode4(1361720), // Rule ID 21995 //
     /* 1361641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1361658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1361697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361719 */     // GIR_Coverage, 21995,
     /* 1361719 */     GIR_EraseRootFromParent_Done,
     /* 1361720 */   // Label 19407: @1361720
     /* 1361720 */   GIM_Try, /*On fail goto*//*Label 19408*/ GIMT_Encode4(1361804), // Rule ID 21998 //
     /* 1361725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1361742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361778 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1361781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361803 */     // GIR_Coverage, 21998,
     /* 1361803 */     GIR_EraseRootFromParent_Done,
     /* 1361804 */   // Label 19408: @1361804
     /* 1361804 */   GIM_Try, /*On fail goto*//*Label 19409*/ GIMT_Encode4(1361888), // Rule ID 21999 //
     /* 1361809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1361820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1361823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1361826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1361829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361862 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1361865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1361883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361887 */     // GIR_Coverage, 21999,
     /* 1361887 */     GIR_EraseRootFromParent_Done,
     /* 1361888 */   // Label 19409: @1361888
     /* 1361888 */   GIM_Try, /*On fail goto*//*Label 19410*/ GIMT_Encode4(1361972), // Rule ID 22002 //
     /* 1361893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1361910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1361949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361971 */     // GIR_Coverage, 22002,
     /* 1361971 */     GIR_EraseRootFromParent_Done,
     /* 1361972 */   // Label 19410: @1361972
     /* 1361972 */   GIM_Try, /*On fail goto*//*Label 19411*/ GIMT_Encode4(1362056), // Rule ID 22003 //
     /* 1361977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1361985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1361994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1362033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362055 */     // GIR_Coverage, 22003,
     /* 1362055 */     GIR_EraseRootFromParent_Done,
     /* 1362056 */   // Label 19411: @1362056
     /* 1362056 */   GIM_Try, /*On fail goto*//*Label 19412*/ GIMT_Encode4(1362140), // Rule ID 22006 //
     /* 1362061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362114 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1362117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362139 */     // GIR_Coverage, 22006,
     /* 1362139 */     GIR_EraseRootFromParent_Done,
     /* 1362140 */   // Label 19412: @1362140
     /* 1362140 */   GIM_Try, /*On fail goto*//*Label 19413*/ GIMT_Encode4(1362224), // Rule ID 22007 //
     /* 1362145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362198 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1362201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362223 */     // GIR_Coverage, 22007,
     /* 1362223 */     GIR_EraseRootFromParent_Done,
     /* 1362224 */   // Label 19413: @1362224
     /* 1362224 */   GIM_Try, /*On fail goto*//*Label 19414*/ GIMT_Encode4(1362308), // Rule ID 22010 //
     /* 1362229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1362246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1362285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362307 */     // GIR_Coverage, 22010,
     /* 1362307 */     GIR_EraseRootFromParent_Done,
     /* 1362308 */   // Label 19414: @1362308
     /* 1362308 */   GIM_Try, /*On fail goto*//*Label 19415*/ GIMT_Encode4(1362392), // Rule ID 22011 //
     /* 1362313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1362330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1362369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362391 */     // GIR_Coverage, 22011,
     /* 1362391 */     GIR_EraseRootFromParent_Done,
     /* 1362392 */   // Label 19415: @1362392
     /* 1362392 */   GIM_Try, /*On fail goto*//*Label 19416*/ GIMT_Encode4(1362476), // Rule ID 22014 //
     /* 1362397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1362414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1362453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362475 */     // GIR_Coverage, 22014,
     /* 1362475 */     GIR_EraseRootFromParent_Done,
     /* 1362476 */   // Label 19416: @1362476
     /* 1362476 */   GIM_Try, /*On fail goto*//*Label 19417*/ GIMT_Encode4(1362560), // Rule ID 22015 //
     /* 1362481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1362498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1362537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362559 */     // GIR_Coverage, 22015,
     /* 1362559 */     GIR_EraseRootFromParent_Done,
     /* 1362560 */   // Label 19417: @1362560
     /* 1362560 */   GIM_Try, /*On fail goto*//*Label 19418*/ GIMT_Encode4(1362644), // Rule ID 22018 //
     /* 1362565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1362568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1362582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1362621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362643 */     // GIR_Coverage, 22018,
     /* 1362643 */     GIR_EraseRootFromParent_Done,
     /* 1362644 */   // Label 19418: @1362644
     /* 1362644 */   GIM_Try, /*On fail goto*//*Label 19419*/ GIMT_Encode4(1362728), // Rule ID 22019 //
     /* 1362649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1362652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1362660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1362663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1362666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1362669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1362705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1362723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362727 */     // GIR_Coverage, 22019,
     /* 1362727 */     GIR_EraseRootFromParent_Done,
     /* 1362728 */   // Label 19419: @1362728
     /* 1362728 */   GIM_Try, /*On fail goto*//*Label 19420*/ GIMT_Encode4(1362812), // Rule ID 22022 //
     /* 1362733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1362750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362786 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1362789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362811 */     // GIR_Coverage, 22022,
     /* 1362811 */     GIR_EraseRootFromParent_Done,
     /* 1362812 */   // Label 19420: @1362812
     /* 1362812 */   GIM_Try, /*On fail goto*//*Label 19421*/ GIMT_Encode4(1362896), // Rule ID 22023 //
     /* 1362817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1362834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1362840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1362855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362870 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1362873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362895 */     // GIR_Coverage, 22023,
     /* 1362895 */     GIR_EraseRootFromParent_Done,
     /* 1362896 */   // Label 19421: @1362896
     /* 1362896 */   GIM_Try, /*On fail goto*//*Label 19422*/ GIMT_Encode4(1362980), // Rule ID 22026 //
     /* 1362901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1362918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1362924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1362939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362954 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1362957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362979 */     // GIR_Coverage, 22026,
     /* 1362979 */     GIR_EraseRootFromParent_Done,
     /* 1362980 */   // Label 19422: @1362980
     /* 1362980 */   GIM_Try, /*On fail goto*//*Label 19423*/ GIMT_Encode4(1363064), // Rule ID 22027 //
     /* 1362985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1362993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1363002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363038 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1363041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363063 */     // GIR_Coverage, 22027,
     /* 1363063 */     GIR_EraseRootFromParent_Done,
     /* 1363064 */   // Label 19423: @1363064
     /* 1363064 */   GIM_Try, /*On fail goto*//*Label 19424*/ GIMT_Encode4(1363148), // Rule ID 22030 //
     /* 1363069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363122 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1363125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363147 */     // GIR_Coverage, 22030,
     /* 1363147 */     GIR_EraseRootFromParent_Done,
     /* 1363148 */   // Label 19424: @1363148
     /* 1363148 */   GIM_Try, /*On fail goto*//*Label 19425*/ GIMT_Encode4(1363232), // Rule ID 22031 //
     /* 1363153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363206 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1363209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363231 */     // GIR_Coverage, 22031,
     /* 1363231 */     GIR_EraseRootFromParent_Done,
     /* 1363232 */   // Label 19425: @1363232
     /* 1363232 */   GIM_Try, /*On fail goto*//*Label 19426*/ GIMT_Encode4(1363316), // Rule ID 22034 //
     /* 1363237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1363254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1363293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363315 */     // GIR_Coverage, 22034,
     /* 1363315 */     GIR_EraseRootFromParent_Done,
     /* 1363316 */   // Label 19426: @1363316
     /* 1363316 */   GIM_Try, /*On fail goto*//*Label 19427*/ GIMT_Encode4(1363400), // Rule ID 22035 //
     /* 1363321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1363338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1363377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363399 */     // GIR_Coverage, 22035,
     /* 1363399 */     GIR_EraseRootFromParent_Done,
     /* 1363400 */   // Label 19427: @1363400
     /* 1363400 */   GIM_Try, /*On fail goto*//*Label 19428*/ GIMT_Encode4(1363484), // Rule ID 22038 //
     /* 1363405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1363422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363458 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1363461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363483 */     // GIR_Coverage, 22038,
     /* 1363483 */     GIR_EraseRootFromParent_Done,
     /* 1363484 */   // Label 19428: @1363484
     /* 1363484 */   GIM_Try, /*On fail goto*//*Label 19429*/ GIMT_Encode4(1363568), // Rule ID 22039 //
     /* 1363489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1363506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363542 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1363545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363567 */     // GIR_Coverage, 22039,
     /* 1363567 */     GIR_EraseRootFromParent_Done,
     /* 1363568 */   // Label 19429: @1363568
     /* 1363568 */   GIM_Try, /*On fail goto*//*Label 19430*/ GIMT_Encode4(1363652), // Rule ID 22042 //
     /* 1363573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1363590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1363629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363651 */     // GIR_Coverage, 22042,
     /* 1363651 */     GIR_EraseRootFromParent_Done,
     /* 1363652 */   // Label 19430: @1363652
     /* 1363652 */   GIM_Try, /*On fail goto*//*Label 19431*/ GIMT_Encode4(1363736), // Rule ID 22043 //
     /* 1363657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1363674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1363713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363735 */     // GIR_Coverage, 22043,
     /* 1363735 */     GIR_EraseRootFromParent_Done,
     /* 1363736 */   // Label 19431: @1363736
     /* 1363736 */   GIM_Try, /*On fail goto*//*Label 19432*/ GIMT_Encode4(1363820), // Rule ID 22046 //
     /* 1363741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1363758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363794 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1363797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363819 */     // GIR_Coverage, 22046,
     /* 1363819 */     GIR_EraseRootFromParent_Done,
     /* 1363820 */   // Label 19432: @1363820
     /* 1363820 */   GIM_Try, /*On fail goto*//*Label 19433*/ GIMT_Encode4(1363904), // Rule ID 22047 //
     /* 1363825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1363842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363878 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1363881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363903 */     // GIR_Coverage, 22047,
     /* 1363903 */     GIR_EraseRootFromParent_Done,
     /* 1363904 */   // Label 19433: @1363904
     /* 1363904 */   GIM_Try, /*On fail goto*//*Label 19434*/ GIMT_Encode4(1363988), // Rule ID 22050 //
     /* 1363909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1363917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1363926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1363932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1363965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363987 */     // GIR_Coverage, 22050,
     /* 1363987 */     GIR_EraseRootFromParent_Done,
     /* 1363988 */   // Label 19434: @1363988
     /* 1363988 */   GIM_Try, /*On fail goto*//*Label 19435*/ GIMT_Encode4(1364072), // Rule ID 22051 //
     /* 1363993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1364010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1364049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364071 */     // GIR_Coverage, 22051,
     /* 1364071 */     GIR_EraseRootFromParent_Done,
     /* 1364072 */   // Label 19435: @1364072
     /* 1364072 */   GIM_Try, /*On fail goto*//*Label 19436*/ GIMT_Encode4(1364156), // Rule ID 22054 //
     /* 1364077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1364133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364155 */     // GIR_Coverage, 22054,
     /* 1364155 */     GIR_EraseRootFromParent_Done,
     /* 1364156 */   // Label 19436: @1364156
     /* 1364156 */   GIM_Try, /*On fail goto*//*Label 19437*/ GIMT_Encode4(1364240), // Rule ID 22055 //
     /* 1364161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364214 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1364217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364239 */     // GIR_Coverage, 22055,
     /* 1364239 */     GIR_EraseRootFromParent_Done,
     /* 1364240 */   // Label 19437: @1364240
     /* 1364240 */   GIM_Try, /*On fail goto*//*Label 19438*/ GIMT_Encode4(1364324), // Rule ID 22058 //
     /* 1364245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364298 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1364301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364323 */     // GIR_Coverage, 22058,
     /* 1364323 */     GIR_EraseRootFromParent_Done,
     /* 1364324 */   // Label 19438: @1364324
     /* 1364324 */   GIM_Try, /*On fail goto*//*Label 19439*/ GIMT_Encode4(1364408), // Rule ID 22059 //
     /* 1364329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1364346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364382 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1364385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364407 */     // GIR_Coverage, 22059,
     /* 1364407 */     GIR_EraseRootFromParent_Done,
     /* 1364408 */   // Label 19439: @1364408
     /* 1364408 */   GIM_Try, /*On fail goto*//*Label 19440*/ GIMT_Encode4(1364492), // Rule ID 22062 //
     /* 1364413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364466 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1364469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364491 */     // GIR_Coverage, 22062,
     /* 1364491 */     GIR_EraseRootFromParent_Done,
     /* 1364492 */   // Label 19440: @1364492
     /* 1364492 */   GIM_Try, /*On fail goto*//*Label 19441*/ GIMT_Encode4(1364576), // Rule ID 22063 //
     /* 1364497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1364514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1364553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364575 */     // GIR_Coverage, 22063,
     /* 1364575 */     GIR_EraseRootFromParent_Done,
     /* 1364576 */   // Label 19441: @1364576
     /* 1364576 */   GIM_Try, /*On fail goto*//*Label 19442*/ GIMT_Encode4(1364660), // Rule ID 22066 //
     /* 1364581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1364584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1364598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364634 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1364637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364659 */     // GIR_Coverage, 22066,
     /* 1364659 */     GIR_EraseRootFromParent_Done,
     /* 1364660 */   // Label 19442: @1364660
     /* 1364660 */   GIM_Try, /*On fail goto*//*Label 19443*/ GIMT_Encode4(1364744), // Rule ID 22067 //
     /* 1364665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1364668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1364673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1364676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1364679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1364682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1364685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364718 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1364721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1364739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364743 */     // GIR_Coverage, 22067,
     /* 1364743 */     GIR_EraseRootFromParent_Done,
     /* 1364744 */   // Label 19443: @1364744
     /* 1364744 */   GIM_Try, /*On fail goto*//*Label 19444*/ GIMT_Encode4(1364828), // Rule ID 22070 //
     /* 1364749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1364766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1364772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364802 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1364805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364827 */     // GIR_Coverage, 22070,
     /* 1364827 */     GIR_EraseRootFromParent_Done,
     /* 1364828 */   // Label 19444: @1364828
     /* 1364828 */   GIM_Try, /*On fail goto*//*Label 19445*/ GIMT_Encode4(1364912), // Rule ID 22071 //
     /* 1364833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1364850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1364856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1364889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364911 */     // GIR_Coverage, 22071,
     /* 1364911 */     GIR_EraseRootFromParent_Done,
     /* 1364912 */   // Label 19445: @1364912
     /* 1364912 */   GIM_Try, /*On fail goto*//*Label 19446*/ GIMT_Encode4(1364996), // Rule ID 22074 //
     /* 1364917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1364925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1364928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1364931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1364934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1364937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1364940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1364973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364995 */     // GIR_Coverage, 22074,
     /* 1364995 */     GIR_EraseRootFromParent_Done,
     /* 1364996 */   // Label 19446: @1364996
     /* 1364996 */   GIM_Try, /*On fail goto*//*Label 19447*/ GIMT_Encode4(1365080), // Rule ID 22075 //
     /* 1365001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365054 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1365057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365079 */     // GIR_Coverage, 22075,
     /* 1365079 */     GIR_EraseRootFromParent_Done,
     /* 1365080 */   // Label 19447: @1365080
     /* 1365080 */   GIM_Try, /*On fail goto*//*Label 19448*/ GIMT_Encode4(1365164), // Rule ID 22078 //
     /* 1365085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365138 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1365141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365163 */     // GIR_Coverage, 22078,
     /* 1365163 */     GIR_EraseRootFromParent_Done,
     /* 1365164 */   // Label 19448: @1365164
     /* 1365164 */   GIM_Try, /*On fail goto*//*Label 19449*/ GIMT_Encode4(1365248), // Rule ID 22079 //
     /* 1365169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365222 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1365225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365247 */     // GIR_Coverage, 22079,
     /* 1365247 */     GIR_EraseRootFromParent_Done,
     /* 1365248 */   // Label 19449: @1365248
     /* 1365248 */   GIM_Try, /*On fail goto*//*Label 19450*/ GIMT_Encode4(1365332), // Rule ID 22082 //
     /* 1365253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365306 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1365309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365331 */     // GIR_Coverage, 22082,
     /* 1365331 */     GIR_EraseRootFromParent_Done,
     /* 1365332 */   // Label 19450: @1365332
     /* 1365332 */   GIM_Try, /*On fail goto*//*Label 19451*/ GIMT_Encode4(1365416), // Rule ID 22083 //
     /* 1365337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1365354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1365393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365415 */     // GIR_Coverage, 22083,
     /* 1365415 */     GIR_EraseRootFromParent_Done,
     /* 1365416 */   // Label 19451: @1365416
     /* 1365416 */   GIM_Try, /*On fail goto*//*Label 19452*/ GIMT_Encode4(1365500), // Rule ID 22086 //
     /* 1365421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365474 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1365477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365499 */     // GIR_Coverage, 22086,
     /* 1365499 */     GIR_EraseRootFromParent_Done,
     /* 1365500 */   // Label 19452: @1365500
     /* 1365500 */   GIM_Try, /*On fail goto*//*Label 19453*/ GIMT_Encode4(1365584), // Rule ID 22087 //
     /* 1365505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1365522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1365561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365583 */     // GIR_Coverage, 22087,
     /* 1365583 */     GIR_EraseRootFromParent_Done,
     /* 1365584 */   // Label 19453: @1365584
     /* 1365584 */   GIM_Try, /*On fail goto*//*Label 19454*/ GIMT_Encode4(1365668), // Rule ID 22090 //
     /* 1365589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1365606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365642 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1365645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365667 */     // GIR_Coverage, 22090,
     /* 1365667 */     GIR_EraseRootFromParent_Done,
     /* 1365668 */   // Label 19454: @1365668
     /* 1365668 */   GIM_Try, /*On fail goto*//*Label 19455*/ GIMT_Encode4(1365752), // Rule ID 22091 //
     /* 1365673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1365684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1365687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1365690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1365693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1365729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365751 */     // GIR_Coverage, 22091,
     /* 1365751 */     GIR_EraseRootFromParent_Done,
     /* 1365752 */   // Label 19455: @1365752
     /* 1365752 */   GIM_Try, /*On fail goto*//*Label 19456*/ GIMT_Encode4(1365836), // Rule ID 22094 //
     /* 1365757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1365774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365810 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1365813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365835 */     // GIR_Coverage, 22094,
     /* 1365835 */     GIR_EraseRootFromParent_Done,
     /* 1365836 */   // Label 19456: @1365836
     /* 1365836 */   GIM_Try, /*On fail goto*//*Label 19457*/ GIMT_Encode4(1365920), // Rule ID 22095 //
     /* 1365841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1365858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365894 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1365897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365919 */     // GIR_Coverage, 22095,
     /* 1365919 */     GIR_EraseRootFromParent_Done,
     /* 1365920 */   // Label 19457: @1365920
     /* 1365920 */   GIM_Try, /*On fail goto*//*Label 19458*/ GIMT_Encode4(1366004), // Rule ID 22098 //
     /* 1365925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1365933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1365936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1365939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1365942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1365945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1365981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1365999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366003 */     // GIR_Coverage, 22098,
     /* 1366003 */     GIR_EraseRootFromParent_Done,
     /* 1366004 */   // Label 19458: @1366004
     /* 1366004 */   GIM_Try, /*On fail goto*//*Label 19459*/ GIMT_Encode4(1366088), // Rule ID 22099 //
     /* 1366009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366062 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1366065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366087 */     // GIR_Coverage, 22099,
     /* 1366087 */     GIR_EraseRootFromParent_Done,
     /* 1366088 */   // Label 19459: @1366088
     /* 1366088 */   GIM_Try, /*On fail goto*//*Label 19460*/ GIMT_Encode4(1366172), // Rule ID 22102 //
     /* 1366093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1366149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366171 */     // GIR_Coverage, 22102,
     /* 1366171 */     GIR_EraseRootFromParent_Done,
     /* 1366172 */   // Label 19460: @1366172
     /* 1366172 */   GIM_Try, /*On fail goto*//*Label 19461*/ GIMT_Encode4(1366256), // Rule ID 22103 //
     /* 1366177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1366233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366255 */     // GIR_Coverage, 22103,
     /* 1366255 */     GIR_EraseRootFromParent_Done,
     /* 1366256 */   // Label 19461: @1366256
     /* 1366256 */   GIM_Try, /*On fail goto*//*Label 19462*/ GIMT_Encode4(1366340), // Rule ID 22106 //
     /* 1366261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1366264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366314 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1366317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366339 */     // GIR_Coverage, 22106,
     /* 1366339 */     GIR_EraseRootFromParent_Done,
     /* 1366340 */   // Label 19462: @1366340
     /* 1366340 */   GIM_Try, /*On fail goto*//*Label 19463*/ GIMT_Encode4(1366424), // Rule ID 22107 //
     /* 1366345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1366348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1366356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1366359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1366362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1366365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1366401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1366419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366423 */     // GIR_Coverage, 22107,
     /* 1366423 */     GIR_EraseRootFromParent_Done,
     /* 1366424 */   // Label 19463: @1366424
     /* 1366424 */   GIM_Try, /*On fail goto*//*Label 19464*/ GIMT_Encode4(1366508), // Rule ID 22110 //
     /* 1366429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1366446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1366485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366507 */     // GIR_Coverage, 22110,
     /* 1366507 */     GIR_EraseRootFromParent_Done,
     /* 1366508 */   // Label 19464: @1366508
     /* 1366508 */   GIM_Try, /*On fail goto*//*Label 19465*/ GIMT_Encode4(1366592), // Rule ID 22111 //
     /* 1366513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1366530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1366536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366566 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1366569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366591 */     // GIR_Coverage, 22111,
     /* 1366591 */     GIR_EraseRootFromParent_Done,
     /* 1366592 */   // Label 19465: @1366592
     /* 1366592 */   GIM_Try, /*On fail goto*//*Label 19466*/ GIMT_Encode4(1366676), // Rule ID 22114 //
     /* 1366597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1366614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1366620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366650 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1366653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366675 */     // GIR_Coverage, 22114,
     /* 1366675 */     GIR_EraseRootFromParent_Done,
     /* 1366676 */   // Label 19466: @1366676
     /* 1366676 */   GIM_Try, /*On fail goto*//*Label 19467*/ GIMT_Encode4(1366760), // Rule ID 22115 //
     /* 1366681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1366698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1366704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1366719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366734 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1366737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366759 */     // GIR_Coverage, 22115,
     /* 1366759 */     GIR_EraseRootFromParent_Done,
     /* 1366760 */   // Label 19467: @1366760
     /* 1366760 */   GIM_Try, /*On fail goto*//*Label 19468*/ GIMT_Encode4(1366844), // Rule ID 22118 //
     /* 1366765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1366782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1366788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366818 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1366821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366843 */     // GIR_Coverage, 22118,
     /* 1366843 */     GIR_EraseRootFromParent_Done,
     /* 1366844 */   // Label 19468: @1366844
     /* 1366844 */   GIM_Try, /*On fail goto*//*Label 19469*/ GIMT_Encode4(1366928), // Rule ID 22119 //
     /* 1366849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1366866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1366872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1366887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366902 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11498:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1366905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366927 */     // GIR_Coverage, 22119,
     /* 1366927 */     GIR_EraseRootFromParent_Done,
     /* 1366928 */   // Label 19469: @1366928
     /* 1366928 */   GIM_Try, /*On fail goto*//*Label 19470*/ GIMT_Encode4(1367012), // Rule ID 22122 //
     /* 1366933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1366941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1366950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1366971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366986 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1366989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367011 */     // GIR_Coverage, 22122,
     /* 1367011 */     GIR_EraseRootFromParent_Done,
     /* 1367012 */   // Label 19470: @1367012
     /* 1367012 */   GIM_Try, /*On fail goto*//*Label 19471*/ GIMT_Encode4(1367096), // Rule ID 22123 //
     /* 1367017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367070 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1367073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367095 */     // GIR_Coverage, 22123,
     /* 1367095 */     GIR_EraseRootFromParent_Done,
     /* 1367096 */   // Label 19471: @1367096
     /* 1367096 */   GIM_Try, /*On fail goto*//*Label 19472*/ GIMT_Encode4(1367180), // Rule ID 22126 //
     /* 1367101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1367157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367179 */     // GIR_Coverage, 22126,
     /* 1367179 */     GIR_EraseRootFromParent_Done,
     /* 1367180 */   // Label 19472: @1367180
     /* 1367180 */   GIM_Try, /*On fail goto*//*Label 19473*/ GIMT_Encode4(1367264), // Rule ID 22127 //
     /* 1367185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1367241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367263 */     // GIR_Coverage, 22127,
     /* 1367263 */     GIR_EraseRootFromParent_Done,
     /* 1367264 */   // Label 19473: @1367264
     /* 1367264 */   GIM_Try, /*On fail goto*//*Label 19474*/ GIMT_Encode4(1367348), // Rule ID 22130 //
     /* 1367269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367322 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1367325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367347 */     // GIR_Coverage, 22130,
     /* 1367347 */     GIR_EraseRootFromParent_Done,
     /* 1367348 */   // Label 19474: @1367348
     /* 1367348 */   GIM_Try, /*On fail goto*//*Label 19475*/ GIMT_Encode4(1367432), // Rule ID 22131 //
     /* 1367353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1367370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11498:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1367409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367431 */     // GIR_Coverage, 22131,
     /* 1367431 */     GIR_EraseRootFromParent_Done,
     /* 1367432 */   // Label 19475: @1367432
     /* 1367432 */   GIM_Try, /*On fail goto*//*Label 19476*/ GIMT_Encode4(1367516), // Rule ID 22134 //
     /* 1367437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1367454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1367493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367515 */     // GIR_Coverage, 22134,
     /* 1367515 */     GIR_EraseRootFromParent_Done,
     /* 1367516 */   // Label 19476: @1367516
     /* 1367516 */   GIM_Try, /*On fail goto*//*Label 19477*/ GIMT_Encode4(1367600), // Rule ID 22135 //
     /* 1367521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1367538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1367544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1367577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367599 */     // GIR_Coverage, 22135,
     /* 1367599 */     GIR_EraseRootFromParent_Done,
     /* 1367600 */   // Label 19477: @1367600
     /* 1367600 */   GIM_Try, /*On fail goto*//*Label 19478*/ GIMT_Encode4(1367684), // Rule ID 22138 //
     /* 1367605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1367622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367658 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1367661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367683 */     // GIR_Coverage, 22138,
     /* 1367683 */     GIR_EraseRootFromParent_Done,
     /* 1367684 */   // Label 19478: @1367684
     /* 1367684 */   GIM_Try, /*On fail goto*//*Label 19479*/ GIMT_Encode4(1367768), // Rule ID 22139 //
     /* 1367689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1367706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367742 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1367745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367767 */     // GIR_Coverage, 22139,
     /* 1367767 */     GIR_EraseRootFromParent_Done,
     /* 1367768 */   // Label 19479: @1367768
     /* 1367768 */   GIM_Try, /*On fail goto*//*Label 19480*/ GIMT_Encode4(1367852), // Rule ID 22142 //
     /* 1367773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1367790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1367829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367851 */     // GIR_Coverage, 22142,
     /* 1367851 */     GIR_EraseRootFromParent_Done,
     /* 1367852 */   // Label 19480: @1367852
     /* 1367852 */   GIM_Try, /*On fail goto*//*Label 19481*/ GIMT_Encode4(1367936), // Rule ID 22143 //
     /* 1367857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1367868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1367871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1367874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11498:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1367913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367935 */     // GIR_Coverage, 22143,
     /* 1367935 */     GIR_EraseRootFromParent_Done,
     /* 1367936 */   // Label 19481: @1367936
     /* 1367936 */   GIM_Try, /*On fail goto*//*Label 19482*/ GIMT_Encode4(1368020), // Rule ID 22146 //
     /* 1367941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1367944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1367949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1367952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1367955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1367958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1367961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1367964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1367997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368019 */     // GIR_Coverage, 22146,
     /* 1368019 */     GIR_EraseRootFromParent_Done,
     /* 1368020 */   // Label 19482: @1368020
     /* 1368020 */   GIM_Try, /*On fail goto*//*Label 19483*/ GIMT_Encode4(1368104), // Rule ID 22147 //
     /* 1368025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1368081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368103 */     // GIR_Coverage, 22147,
     /* 1368103 */     GIR_EraseRootFromParent_Done,
     /* 1368104 */   // Label 19483: @1368104
     /* 1368104 */   GIM_Try, /*On fail goto*//*Label 19484*/ GIMT_Encode4(1368188), // Rule ID 22150 //
     /* 1368109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1368165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368187 */     // GIR_Coverage, 22150,
     /* 1368187 */     GIR_EraseRootFromParent_Done,
     /* 1368188 */   // Label 19484: @1368188
     /* 1368188 */   GIM_Try, /*On fail goto*//*Label 19485*/ GIMT_Encode4(1368272), // Rule ID 22151 //
     /* 1368193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368246 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1368249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368271 */     // GIR_Coverage, 22151,
     /* 1368271 */     GIR_EraseRootFromParent_Done,
     /* 1368272 */   // Label 19485: @1368272
     /* 1368272 */   GIM_Try, /*On fail goto*//*Label 19486*/ GIMT_Encode4(1368356), // Rule ID 22154 //
     /* 1368277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368330 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1368333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368355 */     // GIR_Coverage, 22154,
     /* 1368355 */     GIR_EraseRootFromParent_Done,
     /* 1368356 */   // Label 19486: @1368356
     /* 1368356 */   GIM_Try, /*On fail goto*//*Label 19487*/ GIMT_Encode4(1368440), // Rule ID 22155 //
     /* 1368361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1368369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1368378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11498:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1368417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368439 */     // GIR_Coverage, 22155,
     /* 1368439 */     GIR_EraseRootFromParent_Done,
     /* 1368440 */   // Label 19487: @1368440
     /* 1368440 */   GIM_Try, /*On fail goto*//*Label 19488*/ GIMT_Encode4(1368524), // Rule ID 22158 //
     /* 1368445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1368462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1368501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368523 */     // GIR_Coverage, 22158,
     /* 1368523 */     GIR_EraseRootFromParent_Done,
     /* 1368524 */   // Label 19488: @1368524
     /* 1368524 */   GIM_Try, /*On fail goto*//*Label 19489*/ GIMT_Encode4(1368608), // Rule ID 22159 //
     /* 1368529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1368546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1368585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368607 */     // GIR_Coverage, 22159,
     /* 1368607 */     GIR_EraseRootFromParent_Done,
     /* 1368608 */   // Label 19489: @1368608
     /* 1368608 */   GIM_Try, /*On fail goto*//*Label 19490*/ GIMT_Encode4(1368692), // Rule ID 22162 //
     /* 1368613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1368630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368666 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1368669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368691 */     // GIR_Coverage, 22162,
     /* 1368691 */     GIR_EraseRootFromParent_Done,
     /* 1368692 */   // Label 19490: @1368692
     /* 1368692 */   GIM_Try, /*On fail goto*//*Label 19491*/ GIMT_Encode4(1368776), // Rule ID 22163 //
     /* 1368697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1368714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1368753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368775 */     // GIR_Coverage, 22163,
     /* 1368775 */     GIR_EraseRootFromParent_Done,
     /* 1368776 */   // Label 19491: @1368776
     /* 1368776 */   GIM_Try, /*On fail goto*//*Label 19492*/ GIMT_Encode4(1368860), // Rule ID 22166 //
     /* 1368781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1368798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368834 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1368837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368859 */     // GIR_Coverage, 22166,
     /* 1368859 */     GIR_EraseRootFromParent_Done,
     /* 1368860 */   // Label 19492: @1368860
     /* 1368860 */   GIM_Try, /*On fail goto*//*Label 19493*/ GIMT_Encode4(1368944), // Rule ID 22167 //
     /* 1368865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1368876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1368879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1368882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1368885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1368921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1368939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368943 */     // GIR_Coverage, 22167,
     /* 1368943 */     GIR_EraseRootFromParent_Done,
     /* 1368944 */   // Label 19493: @1368944
     /* 1368944 */   GIM_Try, /*On fail goto*//*Label 19494*/ GIMT_Encode4(1369028), // Rule ID 22170 //
     /* 1368949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1368957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1368966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1368972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369002 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1369005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369027 */     // GIR_Coverage, 22170,
     /* 1369027 */     GIR_EraseRootFromParent_Done,
     /* 1369028 */   // Label 19494: @1369028
     /* 1369028 */   GIM_Try, /*On fail goto*//*Label 19495*/ GIMT_Encode4(1369112), // Rule ID 22171 //
     /* 1369033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1369089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369111 */     // GIR_Coverage, 22171,
     /* 1369111 */     GIR_EraseRootFromParent_Done,
     /* 1369112 */   // Label 19495: @1369112
     /* 1369112 */   GIM_Try, /*On fail goto*//*Label 19496*/ GIMT_Encode4(1369196), // Rule ID 22174 //
     /* 1369117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1369173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369195 */     // GIR_Coverage, 22174,
     /* 1369195 */     GIR_EraseRootFromParent_Done,
     /* 1369196 */   // Label 19496: @1369196
     /* 1369196 */   GIM_Try, /*On fail goto*//*Label 19497*/ GIMT_Encode4(1369280), // Rule ID 22175 //
     /* 1369201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369254 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1369257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369279 */     // GIR_Coverage, 22175,
     /* 1369279 */     GIR_EraseRootFromParent_Done,
     /* 1369280 */   // Label 19497: @1369280
     /* 1369280 */   GIM_Try, /*On fail goto*//*Label 19498*/ GIMT_Encode4(1369364), // Rule ID 22178 //
     /* 1369285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1369341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369363 */     // GIR_Coverage, 22178,
     /* 1369363 */     GIR_EraseRootFromParent_Done,
     /* 1369364 */   // Label 19498: @1369364
     /* 1369364 */   GIM_Try, /*On fail goto*//*Label 19499*/ GIMT_Encode4(1369448), // Rule ID 22179 //
     /* 1369369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1369386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1369425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369447 */     // GIR_Coverage, 22179,
     /* 1369447 */     GIR_EraseRootFromParent_Done,
     /* 1369448 */   // Label 19499: @1369448
     /* 1369448 */   GIM_Try, /*On fail goto*//*Label 19500*/ GIMT_Encode4(1369532), // Rule ID 22182 //
     /* 1369453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1369470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369506 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1369509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369531 */     // GIR_Coverage, 22182,
     /* 1369531 */     GIR_EraseRootFromParent_Done,
     /* 1369532 */   // Label 19500: @1369532
     /* 1369532 */   GIM_Try, /*On fail goto*//*Label 19501*/ GIMT_Encode4(1369616), // Rule ID 22183 //
     /* 1369537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1369554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1369593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369615 */     // GIR_Coverage, 22183,
     /* 1369615 */     GIR_EraseRootFromParent_Done,
     /* 1369616 */   // Label 19501: @1369616
     /* 1369616 */   GIM_Try, /*On fail goto*//*Label 19502*/ GIMT_Encode4(1369700), // Rule ID 22186 //
     /* 1369621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1369638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1369677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369699 */     // GIR_Coverage, 22186,
     /* 1369699 */     GIR_EraseRootFromParent_Done,
     /* 1369700 */   // Label 19502: @1369700
     /* 1369700 */   GIM_Try, /*On fail goto*//*Label 19503*/ GIMT_Encode4(1369784), // Rule ID 22187 //
     /* 1369705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1369722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369758 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1369761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369783 */     // GIR_Coverage, 22187,
     /* 1369783 */     GIR_EraseRootFromParent_Done,
     /* 1369784 */   // Label 19503: @1369784
     /* 1369784 */   GIM_Try, /*On fail goto*//*Label 19504*/ GIMT_Encode4(1369868), // Rule ID 22190 //
     /* 1369789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1369806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1369845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369867 */     // GIR_Coverage, 22190,
     /* 1369867 */     GIR_EraseRootFromParent_Done,
     /* 1369868 */   // Label 19504: @1369868
     /* 1369868 */   GIM_Try, /*On fail goto*//*Label 19505*/ GIMT_Encode4(1369952), // Rule ID 22191 //
     /* 1369873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1369884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1369887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1369890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1369893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1369929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1369947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369951 */     // GIR_Coverage, 22191,
     /* 1369951 */     GIR_EraseRootFromParent_Done,
     /* 1369952 */   // Label 19505: @1369952
     /* 1369952 */   GIM_Try, /*On fail goto*//*Label 19506*/ GIMT_Encode4(1370036), // Rule ID 22194 //
     /* 1369957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1369960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1369965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1369974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370010 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1370013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370035 */     // GIR_Coverage, 22194,
     /* 1370035 */     GIR_EraseRootFromParent_Done,
     /* 1370036 */   // Label 19506: @1370036
     /* 1370036 */   GIM_Try, /*On fail goto*//*Label 19507*/ GIMT_Encode4(1370120), // Rule ID 22195 //
     /* 1370041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1370044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1370097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370119 */     // GIR_Coverage, 22195,
     /* 1370119 */     GIR_EraseRootFromParent_Done,
     /* 1370120 */   // Label 19507: @1370120
     /* 1370120 */   GIM_Try, /*On fail goto*//*Label 19508*/ GIMT_Encode4(1370204), // Rule ID 22198 //
     /* 1370125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370178 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1370181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370203 */     // GIR_Coverage, 22198,
     /* 1370203 */     GIR_EraseRootFromParent_Done,
     /* 1370204 */   // Label 19508: @1370204
     /* 1370204 */   GIM_Try, /*On fail goto*//*Label 19509*/ GIMT_Encode4(1370288), // Rule ID 22199 //
     /* 1370209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370262 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1370265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370287 */     // GIR_Coverage, 22199,
     /* 1370287 */     GIR_EraseRootFromParent_Done,
     /* 1370288 */   // Label 19509: @1370288
     /* 1370288 */   GIM_Try, /*On fail goto*//*Label 19510*/ GIMT_Encode4(1370372), // Rule ID 22202 //
     /* 1370293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1370349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370371 */     // GIR_Coverage, 22202,
     /* 1370371 */     GIR_EraseRootFromParent_Done,
     /* 1370372 */   // Label 19510: @1370372
     /* 1370372 */   GIM_Try, /*On fail goto*//*Label 19511*/ GIMT_Encode4(1370456), // Rule ID 22203 //
     /* 1370377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1370394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370430 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1370433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370455 */     // GIR_Coverage, 22203,
     /* 1370455 */     GIR_EraseRootFromParent_Done,
     /* 1370456 */   // Label 19511: @1370456
     /* 1370456 */   GIM_Try, /*On fail goto*//*Label 19512*/ GIMT_Encode4(1370540), // Rule ID 22206 //
     /* 1370461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1370478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1370484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370514 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1370517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370539 */     // GIR_Coverage, 22206,
     /* 1370539 */     GIR_EraseRootFromParent_Done,
     /* 1370540 */   // Label 19512: @1370540
     /* 1370540 */   GIM_Try, /*On fail goto*//*Label 19513*/ GIMT_Encode4(1370624), // Rule ID 22207 //
     /* 1370545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1370562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1370568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1370583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370598 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11508:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1370601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370623 */     // GIR_Coverage, 22207,
     /* 1370623 */     GIR_EraseRootFromParent_Done,
     /* 1370624 */   // Label 19513: @1370624
     /* 1370624 */   GIM_Try, /*On fail goto*//*Label 19514*/ GIMT_Encode4(1370708), // Rule ID 22210 //
     /* 1370629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1370646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1370685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370707 */     // GIR_Coverage, 22210,
     /* 1370707 */     GIR_EraseRootFromParent_Done,
     /* 1370708 */   // Label 19514: @1370708
     /* 1370708 */   GIM_Try, /*On fail goto*//*Label 19515*/ GIMT_Encode4(1370792), // Rule ID 22211 //
     /* 1370713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1370730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370766 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1370769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370791 */     // GIR_Coverage, 22211,
     /* 1370791 */     GIR_EraseRootFromParent_Done,
     /* 1370792 */   // Label 19515: @1370792
     /* 1370792 */   GIM_Try, /*On fail goto*//*Label 19516*/ GIMT_Encode4(1370876), // Rule ID 22214 //
     /* 1370797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1370814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1370853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370875 */     // GIR_Coverage, 22214,
     /* 1370875 */     GIR_EraseRootFromParent_Done,
     /* 1370876 */   // Label 19516: @1370876
     /* 1370876 */   GIM_Try, /*On fail goto*//*Label 19517*/ GIMT_Encode4(1370960), // Rule ID 22215 //
     /* 1370881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1370898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1370919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370934 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1370937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370959 */     // GIR_Coverage, 22215,
     /* 1370959 */     GIR_EraseRootFromParent_Done,
     /* 1370960 */   // Label 19517: @1370960
     /* 1370960 */   GIM_Try, /*On fail goto*//*Label 19518*/ GIMT_Encode4(1371044), // Rule ID 22218 //
     /* 1370965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1370973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1370982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1370988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371018 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1371021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371043 */     // GIR_Coverage, 22218,
     /* 1371043 */     GIR_EraseRootFromParent_Done,
     /* 1371044 */   // Label 19518: @1371044
     /* 1371044 */   GIM_Try, /*On fail goto*//*Label 19519*/ GIMT_Encode4(1371128), // Rule ID 22219 //
     /* 1371049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11508:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1371105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371127 */     // GIR_Coverage, 22219,
     /* 1371127 */     GIR_EraseRootFromParent_Done,
     /* 1371128 */   // Label 19519: @1371128
     /* 1371128 */   GIM_Try, /*On fail goto*//*Label 19520*/ GIMT_Encode4(1371212), // Rule ID 22222 //
     /* 1371133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371186 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1371189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371211 */     // GIR_Coverage, 22222,
     /* 1371211 */     GIR_EraseRootFromParent_Done,
     /* 1371212 */   // Label 19520: @1371212
     /* 1371212 */   GIM_Try, /*On fail goto*//*Label 19521*/ GIMT_Encode4(1371296), // Rule ID 22223 //
     /* 1371217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1371273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371295 */     // GIR_Coverage, 22223,
     /* 1371295 */     GIR_EraseRootFromParent_Done,
     /* 1371296 */   // Label 19521: @1371296
     /* 1371296 */   GIM_Try, /*On fail goto*//*Label 19522*/ GIMT_Encode4(1371380), // Rule ID 22226 //
     /* 1371301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1371357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371379 */     // GIR_Coverage, 22226,
     /* 1371379 */     GIR_EraseRootFromParent_Done,
     /* 1371380 */   // Label 19522: @1371380
     /* 1371380 */   GIM_Try, /*On fail goto*//*Label 19523*/ GIMT_Encode4(1371464), // Rule ID 22227 //
     /* 1371385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1371402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371438 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1371441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371463 */     // GIR_Coverage, 22227,
     /* 1371463 */     GIR_EraseRootFromParent_Done,
     /* 1371464 */   // Label 19523: @1371464
     /* 1371464 */   GIM_Try, /*On fail goto*//*Label 19524*/ GIMT_Encode4(1371548), // Rule ID 22230 //
     /* 1371469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371522 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1371525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371547 */     // GIR_Coverage, 22230,
     /* 1371547 */     GIR_EraseRootFromParent_Done,
     /* 1371548 */   // Label 19524: @1371548
     /* 1371548 */   GIM_Try, /*On fail goto*//*Label 19525*/ GIMT_Encode4(1371632), // Rule ID 22231 //
     /* 1371553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1371570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371606 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11508:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1371609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1371627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371631 */     // GIR_Coverage, 22231,
     /* 1371631 */     GIR_EraseRootFromParent_Done,
     /* 1371632 */   // Label 19525: @1371632
     /* 1371632 */   GIM_Try, /*On fail goto*//*Label 19526*/ GIMT_Encode4(1371716), // Rule ID 22234 //
     /* 1371637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1371654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1371693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371715 */     // GIR_Coverage, 22234,
     /* 1371715 */     GIR_EraseRootFromParent_Done,
     /* 1371716 */   // Label 19526: @1371716
     /* 1371716 */   GIM_Try, /*On fail goto*//*Label 19527*/ GIMT_Encode4(1371800), // Rule ID 22235 //
     /* 1371721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1371724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1371738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1371744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1371777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371799 */     // GIR_Coverage, 22235,
     /* 1371799 */     GIR_EraseRootFromParent_Done,
     /* 1371800 */   // Label 19527: @1371800
     /* 1371800 */   GIM_Try, /*On fail goto*//*Label 19528*/ GIMT_Encode4(1371884), // Rule ID 22238 //
     /* 1371805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1371822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371858 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1371861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371883 */     // GIR_Coverage, 22238,
     /* 1371883 */     GIR_EraseRootFromParent_Done,
     /* 1371884 */   // Label 19528: @1371884
     /* 1371884 */   GIM_Try, /*On fail goto*//*Label 19529*/ GIMT_Encode4(1371968), // Rule ID 22239 //
     /* 1371889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1371892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1371906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371942 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1371945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1371963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371967 */     // GIR_Coverage, 22239,
     /* 1371967 */     GIR_EraseRootFromParent_Done,
     /* 1371968 */   // Label 19529: @1371968
     /* 1371968 */   GIM_Try, /*On fail goto*//*Label 19530*/ GIMT_Encode4(1372052), // Rule ID 22242 //
     /* 1371973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1371976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1371981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1371984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1371987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1371990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1371993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1372029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372051 */     // GIR_Coverage, 22242,
     /* 1372051 */     GIR_EraseRootFromParent_Done,
     /* 1372052 */   // Label 19530: @1372052
     /* 1372052 */   GIM_Try, /*On fail goto*//*Label 19531*/ GIMT_Encode4(1372136), // Rule ID 22243 //
     /* 1372057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1372065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372110 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11508:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1372113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372135 */     // GIR_Coverage, 22243,
     /* 1372135 */     GIR_EraseRootFromParent_Done,
     /* 1372136 */   // Label 19531: @1372136
     /* 1372136 */   GIM_Try, /*On fail goto*//*Label 19532*/ GIMT_Encode4(1372220), // Rule ID 22246 //
     /* 1372141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372194 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1372197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372219 */     // GIR_Coverage, 22246,
     /* 1372219 */     GIR_EraseRootFromParent_Done,
     /* 1372220 */   // Label 19532: @1372220
     /* 1372220 */   GIM_Try, /*On fail goto*//*Label 19533*/ GIMT_Encode4(1372304), // Rule ID 22247 //
     /* 1372225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372278 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1372281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372303 */     // GIR_Coverage, 22247,
     /* 1372303 */     GIR_EraseRootFromParent_Done,
     /* 1372304 */   // Label 19533: @1372304
     /* 1372304 */   GIM_Try, /*On fail goto*//*Label 19534*/ GIMT_Encode4(1372388), // Rule ID 22250 //
     /* 1372309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372362 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1372365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372387 */     // GIR_Coverage, 22250,
     /* 1372387 */     GIR_EraseRootFromParent_Done,
     /* 1372388 */   // Label 19534: @1372388
     /* 1372388 */   GIM_Try, /*On fail goto*//*Label 19535*/ GIMT_Encode4(1372472), // Rule ID 22251 //
     /* 1372393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1372410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1372449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372471 */     // GIR_Coverage, 22251,
     /* 1372471 */     GIR_EraseRootFromParent_Done,
     /* 1372472 */   // Label 19535: @1372472
     /* 1372472 */   GIM_Try, /*On fail goto*//*Label 19536*/ GIMT_Encode4(1372556), // Rule ID 22254 //
     /* 1372477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372530 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1372533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372555 */     // GIR_Coverage, 22254,
     /* 1372555 */     GIR_EraseRootFromParent_Done,
     /* 1372556 */   // Label 19536: @1372556
     /* 1372556 */   GIM_Try, /*On fail goto*//*Label 19537*/ GIMT_Encode4(1372640), // Rule ID 22255 //
     /* 1372561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1372578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372614 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1372617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1372635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372639 */     // GIR_Coverage, 22255,
     /* 1372639 */     GIR_EraseRootFromParent_Done,
     /* 1372640 */   // Label 19537: @1372640
     /* 1372640 */   GIM_Try, /*On fail goto*//*Label 19538*/ GIMT_Encode4(1372724), // Rule ID 22258 //
     /* 1372645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1372662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1372701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372723 */     // GIR_Coverage, 22258,
     /* 1372723 */     GIR_EraseRootFromParent_Done,
     /* 1372724 */   // Label 19538: @1372724
     /* 1372724 */   GIM_Try, /*On fail goto*//*Label 19539*/ GIMT_Encode4(1372808), // Rule ID 22259 //
     /* 1372729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1372746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1372785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372807 */     // GIR_Coverage, 22259,
     /* 1372807 */     GIR_EraseRootFromParent_Done,
     /* 1372808 */   // Label 19539: @1372808
     /* 1372808 */   GIM_Try, /*On fail goto*//*Label 19540*/ GIMT_Encode4(1372892), // Rule ID 22262 //
     /* 1372813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1372830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1372869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372891 */     // GIR_Coverage, 22262,
     /* 1372891 */     GIR_EraseRootFromParent_Done,
     /* 1372892 */   // Label 19540: @1372892
     /* 1372892 */   GIM_Try, /*On fail goto*//*Label 19541*/ GIMT_Encode4(1372976), // Rule ID 22263 //
     /* 1372897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1372908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1372911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1372914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1372917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1372953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1372971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372975 */     // GIR_Coverage, 22263,
     /* 1372975 */     GIR_EraseRootFromParent_Done,
     /* 1372976 */   // Label 19541: @1372976
     /* 1372976 */   GIM_Try, /*On fail goto*//*Label 19542*/ GIMT_Encode4(1373060), // Rule ID 22266 //
     /* 1372981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1372989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1372998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1373037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373059 */     // GIR_Coverage, 22266,
     /* 1373059 */     GIR_EraseRootFromParent_Done,
     /* 1373060 */   // Label 19542: @1373060
     /* 1373060 */   GIM_Try, /*On fail goto*//*Label 19543*/ GIMT_Encode4(1373144), // Rule ID 22267 //
     /* 1373065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1373121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373143 */     // GIR_Coverage, 22267,
     /* 1373143 */     GIR_EraseRootFromParent_Done,
     /* 1373144 */   // Label 19543: @1373144
     /* 1373144 */   GIM_Try, /*On fail goto*//*Label 19544*/ GIMT_Encode4(1373228), // Rule ID 22270 //
     /* 1373149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373202 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1373205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373227 */     // GIR_Coverage, 22270,
     /* 1373227 */     GIR_EraseRootFromParent_Done,
     /* 1373228 */   // Label 19544: @1373228
     /* 1373228 */   GIM_Try, /*On fail goto*//*Label 19545*/ GIMT_Encode4(1373312), // Rule ID 22271 //
     /* 1373233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373286 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1373289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373311 */     // GIR_Coverage, 22271,
     /* 1373311 */     GIR_EraseRootFromParent_Done,
     /* 1373312 */   // Label 19545: @1373312
     /* 1373312 */   GIM_Try, /*On fail goto*//*Label 19546*/ GIMT_Encode4(1373396), // Rule ID 22274 //
     /* 1373317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1373373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373395 */     // GIR_Coverage, 22274,
     /* 1373395 */     GIR_EraseRootFromParent_Done,
     /* 1373396 */   // Label 19546: @1373396
     /* 1373396 */   GIM_Try, /*On fail goto*//*Label 19547*/ GIMT_Encode4(1373480), // Rule ID 22275 //
     /* 1373401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1373418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1373457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373479 */     // GIR_Coverage, 22275,
     /* 1373479 */     GIR_EraseRootFromParent_Done,
     /* 1373480 */   // Label 19547: @1373480
     /* 1373480 */   GIM_Try, /*On fail goto*//*Label 19548*/ GIMT_Encode4(1373564), // Rule ID 22278 //
     /* 1373485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373538 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1373541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373563 */     // GIR_Coverage, 22278,
     /* 1373563 */     GIR_EraseRootFromParent_Done,
     /* 1373564 */   // Label 19548: @1373564
     /* 1373564 */   GIM_Try, /*On fail goto*//*Label 19549*/ GIMT_Encode4(1373648), // Rule ID 22279 //
     /* 1373569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1373586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373622 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1373625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373647 */     // GIR_Coverage, 22279,
     /* 1373647 */     GIR_EraseRootFromParent_Done,
     /* 1373648 */   // Label 19549: @1373648
     /* 1373648 */   GIM_Try, /*On fail goto*//*Label 19550*/ GIMT_Encode4(1373732), // Rule ID 22282 //
     /* 1373653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1373656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1373670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1373709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373731 */     // GIR_Coverage, 22282,
     /* 1373731 */     GIR_EraseRootFromParent_Done,
     /* 1373732 */   // Label 19550: @1373732
     /* 1373732 */   GIM_Try, /*On fail goto*//*Label 19551*/ GIMT_Encode4(1373816), // Rule ID 22283 //
     /* 1373737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1373740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1373748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1373751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1373754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1373757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373790 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1373793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1373811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373815 */     // GIR_Coverage, 22283,
     /* 1373815 */     GIR_EraseRootFromParent_Done,
     /* 1373816 */   // Label 19551: @1373816
     /* 1373816 */   GIM_Try, /*On fail goto*//*Label 19552*/ GIMT_Encode4(1373900), // Rule ID 22286 //
     /* 1373821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1373838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1373844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1373877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373899 */     // GIR_Coverage, 22286,
     /* 1373899 */     GIR_EraseRootFromParent_Done,
     /* 1373900 */   // Label 19552: @1373900
     /* 1373900 */   GIM_Try, /*On fail goto*//*Label 19553*/ GIMT_Encode4(1373984), // Rule ID 22287 //
     /* 1373905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1373922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1373928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1373943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373958 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1373961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373983 */     // GIR_Coverage, 22287,
     /* 1373983 */     GIR_EraseRootFromParent_Done,
     /* 1373984 */   // Label 19553: @1373984
     /* 1373984 */   GIM_Try, /*On fail goto*//*Label 19554*/ GIMT_Encode4(1374068), // Rule ID 22290 //
     /* 1373989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1373997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374042 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1374045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374067 */     // GIR_Coverage, 22290,
     /* 1374067 */     GIR_EraseRootFromParent_Done,
     /* 1374068 */   // Label 19554: @1374068
     /* 1374068 */   GIM_Try, /*On fail goto*//*Label 19555*/ GIMT_Encode4(1374152), // Rule ID 22291 //
     /* 1374073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374126 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1374129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374151 */     // GIR_Coverage, 22291,
     /* 1374151 */     GIR_EraseRootFromParent_Done,
     /* 1374152 */   // Label 19555: @1374152
     /* 1374152 */   GIM_Try, /*On fail goto*//*Label 19556*/ GIMT_Encode4(1374236), // Rule ID 22294 //
     /* 1374157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374210 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1374213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374235 */     // GIR_Coverage, 22294,
     /* 1374235 */     GIR_EraseRootFromParent_Done,
     /* 1374236 */   // Label 19556: @1374236
     /* 1374236 */   GIM_Try, /*On fail goto*//*Label 19557*/ GIMT_Encode4(1374320), // Rule ID 22295 //
     /* 1374241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374294 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1374297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374319 */     // GIR_Coverage, 22295,
     /* 1374319 */     GIR_EraseRootFromParent_Done,
     /* 1374320 */   // Label 19557: @1374320
     /* 1374320 */   GIM_Try, /*On fail goto*//*Label 19558*/ GIMT_Encode4(1374404), // Rule ID 22298 //
     /* 1374325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374378 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1374381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374403 */     // GIR_Coverage, 22298,
     /* 1374403 */     GIR_EraseRootFromParent_Done,
     /* 1374404 */   // Label 19558: @1374404
     /* 1374404 */   GIM_Try, /*On fail goto*//*Label 19559*/ GIMT_Encode4(1374488), // Rule ID 22299 //
     /* 1374409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1374426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374462 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1374465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374487 */     // GIR_Coverage, 22299,
     /* 1374487 */     GIR_EraseRootFromParent_Done,
     /* 1374488 */   // Label 19559: @1374488
     /* 1374488 */   GIM_Try, /*On fail goto*//*Label 19560*/ GIMT_Encode4(1374572), // Rule ID 22302 //
     /* 1374493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1374549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374571 */     // GIR_Coverage, 22302,
     /* 1374571 */     GIR_EraseRootFromParent_Done,
     /* 1374572 */   // Label 19560: @1374572
     /* 1374572 */   GIM_Try, /*On fail goto*//*Label 19561*/ GIMT_Encode4(1374656), // Rule ID 22303 //
     /* 1374577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1374594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1374633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374655 */     // GIR_Coverage, 22303,
     /* 1374655 */     GIR_EraseRootFromParent_Done,
     /* 1374656 */   // Label 19561: @1374656
     /* 1374656 */   GIM_Try, /*On fail goto*//*Label 19562*/ GIMT_Encode4(1374740), // Rule ID 22306 //
     /* 1374661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1374678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1374717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374739 */     // GIR_Coverage, 22306,
     /* 1374739 */     GIR_EraseRootFromParent_Done,
     /* 1374740 */   // Label 19562: @1374740
     /* 1374740 */   GIM_Try, /*On fail goto*//*Label 19563*/ GIMT_Encode4(1374824), // Rule ID 22307 //
     /* 1374745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1374762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1374783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374798 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1374801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374823 */     // GIR_Coverage, 22307,
     /* 1374823 */     GIR_EraseRootFromParent_Done,
     /* 1374824 */   // Label 19563: @1374824
     /* 1374824 */   GIM_Try, /*On fail goto*//*Label 19564*/ GIMT_Encode4(1374908), // Rule ID 22310 //
     /* 1374829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1374846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1374852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374882 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1374885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374907 */     // GIR_Coverage, 22310,
     /* 1374907 */     GIR_EraseRootFromParent_Done,
     /* 1374908 */   // Label 19564: @1374908
     /* 1374908 */   GIM_Try, /*On fail goto*//*Label 19565*/ GIMT_Encode4(1374992), // Rule ID 22311 //
     /* 1374913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1374921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1374930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1374936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1374969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374991 */     // GIR_Coverage, 22311,
     /* 1374991 */     GIR_EraseRootFromParent_Done,
     /* 1374992 */   // Label 19565: @1374992
     /* 1374992 */   GIM_Try, /*On fail goto*//*Label 19566*/ GIMT_Encode4(1375076), // Rule ID 22314 //
     /* 1374997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1375053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375075 */     // GIR_Coverage, 22314,
     /* 1375075 */     GIR_EraseRootFromParent_Done,
     /* 1375076 */   // Label 19566: @1375076
     /* 1375076 */   GIM_Try, /*On fail goto*//*Label 19567*/ GIMT_Encode4(1375160), // Rule ID 22315 //
     /* 1375081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1375137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375159 */     // GIR_Coverage, 22315,
     /* 1375159 */     GIR_EraseRootFromParent_Done,
     /* 1375160 */   // Label 19567: @1375160
     /* 1375160 */   GIM_Try, /*On fail goto*//*Label 19568*/ GIMT_Encode4(1375244), // Rule ID 22318 //
     /* 1375165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1375221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375243 */     // GIR_Coverage, 22318,
     /* 1375243 */     GIR_EraseRootFromParent_Done,
     /* 1375244 */   // Label 19568: @1375244
     /* 1375244 */   GIM_Try, /*On fail goto*//*Label 19569*/ GIMT_Encode4(1375328), // Rule ID 22319 //
     /* 1375249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375302 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1375305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375327 */     // GIR_Coverage, 22319,
     /* 1375327 */     GIR_EraseRootFromParent_Done,
     /* 1375328 */   // Label 19569: @1375328
     /* 1375328 */   GIM_Try, /*On fail goto*//*Label 19570*/ GIMT_Encode4(1375412), // Rule ID 22322 //
     /* 1375333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375386 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1375389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375411 */     // GIR_Coverage, 22322,
     /* 1375411 */     GIR_EraseRootFromParent_Done,
     /* 1375412 */   // Label 19570: @1375412
     /* 1375412 */   GIM_Try, /*On fail goto*//*Label 19571*/ GIMT_Encode4(1375496), // Rule ID 22323 //
     /* 1375417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1375434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1375440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1375473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375495 */     // GIR_Coverage, 22323,
     /* 1375495 */     GIR_EraseRootFromParent_Done,
     /* 1375496 */   // Label 19571: @1375496
     /* 1375496 */   GIM_Try, /*On fail goto*//*Label 19572*/ GIMT_Encode4(1375580), // Rule ID 22326 //
     /* 1375501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375554 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1375557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375579 */     // GIR_Coverage, 22326,
     /* 1375579 */     GIR_EraseRootFromParent_Done,
     /* 1375580 */   // Label 19572: @1375580
     /* 1375580 */   GIM_Try, /*On fail goto*//*Label 19573*/ GIMT_Encode4(1375664), // Rule ID 22327 //
     /* 1375585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1375602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375638 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1375641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375663 */     // GIR_Coverage, 22327,
     /* 1375663 */     GIR_EraseRootFromParent_Done,
     /* 1375664 */   // Label 19573: @1375664
     /* 1375664 */   GIM_Try, /*On fail goto*//*Label 19574*/ GIMT_Encode4(1375748), // Rule ID 22330 //
     /* 1375669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1375672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1375686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375722 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1375725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375747 */     // GIR_Coverage, 22330,
     /* 1375747 */     GIR_EraseRootFromParent_Done,
     /* 1375748 */   // Label 19574: @1375748
     /* 1375748 */   GIM_Try, /*On fail goto*//*Label 19575*/ GIMT_Encode4(1375832), // Rule ID 22331 //
     /* 1375753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1375756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1375761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1375764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1375767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1375770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1375773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375806 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1375809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1375827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375831 */     // GIR_Coverage, 22331,
     /* 1375831 */     GIR_EraseRootFromParent_Done,
     /* 1375832 */   // Label 19575: @1375832
     /* 1375832 */   GIM_Try, /*On fail goto*//*Label 19576*/ GIMT_Encode4(1375916), // Rule ID 22334 //
     /* 1375837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1375854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1375860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375890 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1375893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375915 */     // GIR_Coverage, 22334,
     /* 1375915 */     GIR_EraseRootFromParent_Done,
     /* 1375916 */   // Label 19576: @1375916
     /* 1375916 */   GIM_Try, /*On fail goto*//*Label 19577*/ GIMT_Encode4(1376000), // Rule ID 22335 //
     /* 1375921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1375929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1375938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1375944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1375977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375999 */     // GIR_Coverage, 22335,
     /* 1375999 */     GIR_EraseRootFromParent_Done,
     /* 1376000 */   // Label 19577: @1376000
     /* 1376000 */   GIM_Try, /*On fail goto*//*Label 19578*/ GIMT_Encode4(1376084), // Rule ID 22338 //
     /* 1376005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376058 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1376061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376083 */     // GIR_Coverage, 22338,
     /* 1376083 */     GIR_EraseRootFromParent_Done,
     /* 1376084 */   // Label 19578: @1376084
     /* 1376084 */   GIM_Try, /*On fail goto*//*Label 19579*/ GIMT_Encode4(1376168), // Rule ID 22339 //
     /* 1376089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1376145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376167 */     // GIR_Coverage, 22339,
     /* 1376167 */     GIR_EraseRootFromParent_Done,
     /* 1376168 */   // Label 19579: @1376168
     /* 1376168 */   GIM_Try, /*On fail goto*//*Label 19580*/ GIMT_Encode4(1376252), // Rule ID 22342 //
     /* 1376173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1376229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376251 */     // GIR_Coverage, 22342,
     /* 1376251 */     GIR_EraseRootFromParent_Done,
     /* 1376252 */   // Label 19580: @1376252
     /* 1376252 */   GIM_Try, /*On fail goto*//*Label 19581*/ GIMT_Encode4(1376336), // Rule ID 22343 //
     /* 1376257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376310 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1376313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376335 */     // GIR_Coverage, 22343,
     /* 1376335 */     GIR_EraseRootFromParent_Done,
     /* 1376336 */   // Label 19581: @1376336
     /* 1376336 */   GIM_Try, /*On fail goto*//*Label 19582*/ GIMT_Encode4(1376420), // Rule ID 22346 //
     /* 1376341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1376397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376419 */     // GIR_Coverage, 22346,
     /* 1376419 */     GIR_EraseRootFromParent_Done,
     /* 1376420 */   // Label 19582: @1376420
     /* 1376420 */   GIM_Try, /*On fail goto*//*Label 19583*/ GIMT_Encode4(1376504), // Rule ID 22347 //
     /* 1376425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1376442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1376481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376503 */     // GIR_Coverage, 22347,
     /* 1376503 */     GIR_EraseRootFromParent_Done,
     /* 1376504 */   // Label 19583: @1376504
     /* 1376504 */   GIM_Try, /*On fail goto*//*Label 19584*/ GIMT_Encode4(1376588), // Rule ID 22350 //
     /* 1376509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1376526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1376565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376587 */     // GIR_Coverage, 22350,
     /* 1376587 */     GIR_EraseRootFromParent_Done,
     /* 1376588 */   // Label 19584: @1376588
     /* 1376588 */   GIM_Try, /*On fail goto*//*Label 19585*/ GIMT_Encode4(1376672), // Rule ID 22351 //
     /* 1376593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1376604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1376607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1376610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1376613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1376649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1376667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376671 */     // GIR_Coverage, 22351,
     /* 1376671 */     GIR_EraseRootFromParent_Done,
     /* 1376672 */   // Label 19585: @1376672
     /* 1376672 */   GIM_Try, /*On fail goto*//*Label 19586*/ GIMT_Encode4(1376756), // Rule ID 22354 //
     /* 1376677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1376694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1376733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376755 */     // GIR_Coverage, 22354,
     /* 1376755 */     GIR_EraseRootFromParent_Done,
     /* 1376756 */   // Label 19586: @1376756
     /* 1376756 */   GIM_Try, /*On fail goto*//*Label 19587*/ GIMT_Encode4(1376840), // Rule ID 22355 //
     /* 1376761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1376778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1376817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376839 */     // GIR_Coverage, 22355,
     /* 1376839 */     GIR_EraseRootFromParent_Done,
     /* 1376840 */   // Label 19587: @1376840
     /* 1376840 */   GIM_Try, /*On fail goto*//*Label 19588*/ GIMT_Encode4(1376924), // Rule ID 22358 //
     /* 1376845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1376862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376898 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1376901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376923 */     // GIR_Coverage, 22358,
     /* 1376923 */     GIR_EraseRootFromParent_Done,
     /* 1376924 */   // Label 19588: @1376924
     /* 1376924 */   GIM_Try, /*On fail goto*//*Label 19589*/ GIMT_Encode4(1377008), // Rule ID 22359 //
     /* 1376929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1376937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1376946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1376985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377007 */     // GIR_Coverage, 22359,
     /* 1377007 */     GIR_EraseRootFromParent_Done,
     /* 1377008 */   // Label 19589: @1377008
     /* 1377008 */   GIM_Try, /*On fail goto*//*Label 19590*/ GIMT_Encode4(1377092), // Rule ID 22362 //
     /* 1377013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377066 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1377069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377091 */     // GIR_Coverage, 22362,
     /* 1377091 */     GIR_EraseRootFromParent_Done,
     /* 1377092 */   // Label 19590: @1377092
     /* 1377092 */   GIM_Try, /*On fail goto*//*Label 19591*/ GIMT_Encode4(1377176), // Rule ID 22363 //
     /* 1377097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1377153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377175 */     // GIR_Coverage, 22363,
     /* 1377175 */     GIR_EraseRootFromParent_Done,
     /* 1377176 */   // Label 19591: @1377176
     /* 1377176 */   GIM_Try, /*On fail goto*//*Label 19592*/ GIMT_Encode4(1377260), // Rule ID 22366 //
     /* 1377181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1377237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377259 */     // GIR_Coverage, 22366,
     /* 1377259 */     GIR_EraseRootFromParent_Done,
     /* 1377260 */   // Label 19592: @1377260
     /* 1377260 */   GIM_Try, /*On fail goto*//*Label 19593*/ GIMT_Encode4(1377344), // Rule ID 22367 //
     /* 1377265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1377282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1377321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377343 */     // GIR_Coverage, 22367,
     /* 1377343 */     GIR_EraseRootFromParent_Done,
     /* 1377344 */   // Label 19593: @1377344
     /* 1377344 */   GIM_Try, /*On fail goto*//*Label 19594*/ GIMT_Encode4(1377428), // Rule ID 22370 //
     /* 1377349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1377352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1377405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377427 */     // GIR_Coverage, 22370,
     /* 1377427 */     GIR_EraseRootFromParent_Done,
     /* 1377428 */   // Label 19594: @1377428
     /* 1377428 */   GIM_Try, /*On fail goto*//*Label 19595*/ GIMT_Encode4(1377512), // Rule ID 22371 //
     /* 1377433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1377436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1377444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1377447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1377450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1377453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1377489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1377507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377511 */     // GIR_Coverage, 22371,
     /* 1377511 */     GIR_EraseRootFromParent_Done,
     /* 1377512 */   // Label 19595: @1377512
     /* 1377512 */   GIM_Try, /*On fail goto*//*Label 19596*/ GIMT_Encode4(1377596), // Rule ID 22374 //
     /* 1377517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1377534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1377540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1377555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1377573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377595 */     // GIR_Coverage, 22374,
     /* 1377595 */     GIR_EraseRootFromParent_Done,
     /* 1377596 */   // Label 19596: @1377596
     /* 1377596 */   GIM_Try, /*On fail goto*//*Label 19597*/ GIMT_Encode4(1377680), // Rule ID 22375 //
     /* 1377601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1377618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1377624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1377639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377654 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1377657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377679 */     // GIR_Coverage, 22375,
     /* 1377679 */     GIR_EraseRootFromParent_Done,
     /* 1377680 */   // Label 19597: @1377680
     /* 1377680 */   GIM_Try, /*On fail goto*//*Label 19598*/ GIMT_Encode4(1377764), // Rule ID 22378 //
     /* 1377685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1377702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1377708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1377723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377738 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1377741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377763 */     // GIR_Coverage, 22378,
     /* 1377763 */     GIR_EraseRootFromParent_Done,
     /* 1377764 */   // Label 19598: @1377764
     /* 1377764 */   GIM_Try, /*On fail goto*//*Label 19599*/ GIMT_Encode4(1377848), // Rule ID 22379 //
     /* 1377769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1377786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1377792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1377807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377822 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1377825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377847 */     // GIR_Coverage, 22379,
     /* 1377847 */     GIR_EraseRootFromParent_Done,
     /* 1377848 */   // Label 19599: @1377848
     /* 1377848 */   GIM_Try, /*On fail goto*//*Label 19600*/ GIMT_Encode4(1377932), // Rule ID 22382 //
     /* 1377853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1377870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1377876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1377891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377906 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1377909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377931 */     // GIR_Coverage, 22382,
     /* 1377931 */     GIR_EraseRootFromParent_Done,
     /* 1377932 */   // Label 19600: @1377932
     /* 1377932 */   GIM_Try, /*On fail goto*//*Label 19601*/ GIMT_Encode4(1378016), // Rule ID 22383 //
     /* 1377937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1377945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1377954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1377960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1377975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377990 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11506:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1377993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378015 */     // GIR_Coverage, 22383,
     /* 1378015 */     GIR_EraseRootFromParent_Done,
     /* 1378016 */   // Label 19601: @1378016
     /* 1378016 */   GIM_Try, /*On fail goto*//*Label 19602*/ GIMT_Encode4(1378100), // Rule ID 22386 //
     /* 1378021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378074 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1378077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378099 */     // GIR_Coverage, 22386,
     /* 1378099 */     GIR_EraseRootFromParent_Done,
     /* 1378100 */   // Label 19602: @1378100
     /* 1378100 */   GIM_Try, /*On fail goto*//*Label 19603*/ GIMT_Encode4(1378184), // Rule ID 22387 //
     /* 1378105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1378161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378183 */     // GIR_Coverage, 22387,
     /* 1378183 */     GIR_EraseRootFromParent_Done,
     /* 1378184 */   // Label 19603: @1378184
     /* 1378184 */   GIM_Try, /*On fail goto*//*Label 19604*/ GIMT_Encode4(1378268), // Rule ID 22390 //
     /* 1378189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378242 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1378245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378267 */     // GIR_Coverage, 22390,
     /* 1378267 */     GIR_EraseRootFromParent_Done,
     /* 1378268 */   // Label 19604: @1378268
     /* 1378268 */   GIM_Try, /*On fail goto*//*Label 19605*/ GIMT_Encode4(1378352), // Rule ID 22391 //
     /* 1378273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1378290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378326 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1378329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378351 */     // GIR_Coverage, 22391,
     /* 1378351 */     GIR_EraseRootFromParent_Done,
     /* 1378352 */   // Label 19605: @1378352
     /* 1378352 */   GIM_Try, /*On fail goto*//*Label 19606*/ GIMT_Encode4(1378436), // Rule ID 22394 //
     /* 1378357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378410 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1378413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378435 */     // GIR_Coverage, 22394,
     /* 1378435 */     GIR_EraseRootFromParent_Done,
     /* 1378436 */   // Label 19606: @1378436
     /* 1378436 */   GIM_Try, /*On fail goto*//*Label 19607*/ GIMT_Encode4(1378520), // Rule ID 22395 //
     /* 1378441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1378458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378494 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11506:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1378497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378519 */     // GIR_Coverage, 22395,
     /* 1378519 */     GIR_EraseRootFromParent_Done,
     /* 1378520 */   // Label 19607: @1378520
     /* 1378520 */   GIM_Try, /*On fail goto*//*Label 19608*/ GIMT_Encode4(1378604), // Rule ID 22398 //
     /* 1378525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1378542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1378548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378578 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1378581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378603 */     // GIR_Coverage, 22398,
     /* 1378603 */     GIR_EraseRootFromParent_Done,
     /* 1378604 */   // Label 19608: @1378604
     /* 1378604 */   GIM_Try, /*On fail goto*//*Label 19609*/ GIMT_Encode4(1378688), // Rule ID 22399 //
     /* 1378609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1378626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1378632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378662 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1378665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378687 */     // GIR_Coverage, 22399,
     /* 1378687 */     GIR_EraseRootFromParent_Done,
     /* 1378688 */   // Label 19609: @1378688
     /* 1378688 */   GIM_Try, /*On fail goto*//*Label 19610*/ GIMT_Encode4(1378772), // Rule ID 22402 //
     /* 1378693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1378710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378746 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1378749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378771 */     // GIR_Coverage, 22402,
     /* 1378771 */     GIR_EraseRootFromParent_Done,
     /* 1378772 */   // Label 19610: @1378772
     /* 1378772 */   GIM_Try, /*On fail goto*//*Label 19611*/ GIMT_Encode4(1378856), // Rule ID 22403 //
     /* 1378777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1378794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1378833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378855 */     // GIR_Coverage, 22403,
     /* 1378855 */     GIR_EraseRootFromParent_Done,
     /* 1378856 */   // Label 19611: @1378856
     /* 1378856 */   GIM_Try, /*On fail goto*//*Label 19612*/ GIMT_Encode4(1378940), // Rule ID 22406 //
     /* 1378861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1378878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378914 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1378917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378939 */     // GIR_Coverage, 22406,
     /* 1378939 */     GIR_EraseRootFromParent_Done,
     /* 1378940 */   // Label 19612: @1378940
     /* 1378940 */   GIM_Try, /*On fail goto*//*Label 19613*/ GIMT_Encode4(1379024), // Rule ID 22407 //
     /* 1378945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1378953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1378962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378998 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11506:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1379001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379023 */     // GIR_Coverage, 22407,
     /* 1379023 */     GIR_EraseRootFromParent_Done,
     /* 1379024 */   // Label 19613: @1379024
     /* 1379024 */   GIM_Try, /*On fail goto*//*Label 19614*/ GIMT_Encode4(1379108), // Rule ID 22410 //
     /* 1379029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1379085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379107 */     // GIR_Coverage, 22410,
     /* 1379107 */     GIR_EraseRootFromParent_Done,
     /* 1379108 */   // Label 19614: @1379108
     /* 1379108 */   GIM_Try, /*On fail goto*//*Label 19615*/ GIMT_Encode4(1379192), // Rule ID 22411 //
     /* 1379113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1379169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379191 */     // GIR_Coverage, 22411,
     /* 1379191 */     GIR_EraseRootFromParent_Done,
     /* 1379192 */   // Label 19615: @1379192
     /* 1379192 */   GIM_Try, /*On fail goto*//*Label 19616*/ GIMT_Encode4(1379276), // Rule ID 22414 //
     /* 1379197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379250 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1379253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379275 */     // GIR_Coverage, 22414,
     /* 1379275 */     GIR_EraseRootFromParent_Done,
     /* 1379276 */   // Label 19616: @1379276
     /* 1379276 */   GIM_Try, /*On fail goto*//*Label 19617*/ GIMT_Encode4(1379360), // Rule ID 22415 //
     /* 1379281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1379298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1379337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379359 */     // GIR_Coverage, 22415,
     /* 1379359 */     GIR_EraseRootFromParent_Done,
     /* 1379360 */   // Label 19617: @1379360
     /* 1379360 */   GIM_Try, /*On fail goto*//*Label 19618*/ GIMT_Encode4(1379444), // Rule ID 22418 //
     /* 1379365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379418 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1379421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379443 */     // GIR_Coverage, 22418,
     /* 1379443 */     GIR_EraseRootFromParent_Done,
     /* 1379444 */   // Label 19618: @1379444
     /* 1379444 */   GIM_Try, /*On fail goto*//*Label 19619*/ GIMT_Encode4(1379528), // Rule ID 22419 //
     /* 1379449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1379457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1379466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11506:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1379505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379527 */     // GIR_Coverage, 22419,
     /* 1379527 */     GIR_EraseRootFromParent_Done,
     /* 1379528 */   // Label 19619: @1379528
     /* 1379528 */   GIM_Try, /*On fail goto*//*Label 19620*/ GIMT_Encode4(1379612), // Rule ID 22422 //
     /* 1379533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1379550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1379556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379586 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1379589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379611 */     // GIR_Coverage, 22422,
     /* 1379611 */     GIR_EraseRootFromParent_Done,
     /* 1379612 */   // Label 19620: @1379612
     /* 1379612 */   GIM_Try, /*On fail goto*//*Label 19621*/ GIMT_Encode4(1379696), // Rule ID 22423 //
     /* 1379617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1379634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1379640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1379673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379695 */     // GIR_Coverage, 22423,
     /* 1379695 */     GIR_EraseRootFromParent_Done,
     /* 1379696 */   // Label 19621: @1379696
     /* 1379696 */   GIM_Try, /*On fail goto*//*Label 19622*/ GIMT_Encode4(1379780), // Rule ID 22426 //
     /* 1379701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1379718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379754 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1379757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379779 */     // GIR_Coverage, 22426,
     /* 1379779 */     GIR_EraseRootFromParent_Done,
     /* 1379780 */   // Label 19622: @1379780
     /* 1379780 */   GIM_Try, /*On fail goto*//*Label 19623*/ GIMT_Encode4(1379864), // Rule ID 22427 //
     /* 1379785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1379802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379838 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1379841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379863 */     // GIR_Coverage, 22427,
     /* 1379863 */     GIR_EraseRootFromParent_Done,
     /* 1379864 */   // Label 19623: @1379864
     /* 1379864 */   GIM_Try, /*On fail goto*//*Label 19624*/ GIMT_Encode4(1379948), // Rule ID 22430 //
     /* 1379869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1379886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379922 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1379925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1379943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379947 */     // GIR_Coverage, 22430,
     /* 1379947 */     GIR_EraseRootFromParent_Done,
     /* 1379948 */   // Label 19624: @1379948
     /* 1379948 */   GIM_Try, /*On fail goto*//*Label 19625*/ GIMT_Encode4(1380032), // Rule ID 22431 //
     /* 1379953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1379961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1379964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1379967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1379970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1379973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380006 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1380009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380031 */     // GIR_Coverage, 22431,
     /* 1380031 */     GIR_EraseRootFromParent_Done,
     /* 1380032 */   // Label 19625: @1380032
     /* 1380032 */   GIM_Try, /*On fail goto*//*Label 19626*/ GIMT_Encode4(1380116), // Rule ID 22434 //
     /* 1380037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1380093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380115 */     // GIR_Coverage, 22434,
     /* 1380115 */     GIR_EraseRootFromParent_Done,
     /* 1380116 */   // Label 19626: @1380116
     /* 1380116 */   GIM_Try, /*On fail goto*//*Label 19627*/ GIMT_Encode4(1380200), // Rule ID 22435 //
     /* 1380121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1380177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380199 */     // GIR_Coverage, 22435,
     /* 1380199 */     GIR_EraseRootFromParent_Done,
     /* 1380200 */   // Label 19627: @1380200
     /* 1380200 */   GIM_Try, /*On fail goto*//*Label 19628*/ GIMT_Encode4(1380284), // Rule ID 22438 //
     /* 1380205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1380261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380283 */     // GIR_Coverage, 22438,
     /* 1380283 */     GIR_EraseRootFromParent_Done,
     /* 1380284 */   // Label 19628: @1380284
     /* 1380284 */   GIM_Try, /*On fail goto*//*Label 19629*/ GIMT_Encode4(1380368), // Rule ID 22439 //
     /* 1380289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1380306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1380345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380367 */     // GIR_Coverage, 22439,
     /* 1380367 */     GIR_EraseRootFromParent_Done,
     /* 1380368 */   // Label 19629: @1380368
     /* 1380368 */   GIM_Try, /*On fail goto*//*Label 19630*/ GIMT_Encode4(1380452), // Rule ID 22442 //
     /* 1380373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380426 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1380429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380451 */     // GIR_Coverage, 22442,
     /* 1380451 */     GIR_EraseRootFromParent_Done,
     /* 1380452 */   // Label 19630: @1380452
     /* 1380452 */   GIM_Try, /*On fail goto*//*Label 19631*/ GIMT_Encode4(1380536), // Rule ID 22443 //
     /* 1380457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1380474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1380513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380535 */     // GIR_Coverage, 22443,
     /* 1380535 */     GIR_EraseRootFromParent_Done,
     /* 1380536 */   // Label 19631: @1380536
     /* 1380536 */   GIM_Try, /*On fail goto*//*Label 19632*/ GIMT_Encode4(1380620), // Rule ID 22446 //
     /* 1380541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1380558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1380597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380619 */     // GIR_Coverage, 22446,
     /* 1380619 */     GIR_EraseRootFromParent_Done,
     /* 1380620 */   // Label 19632: @1380620
     /* 1380620 */   GIM_Try, /*On fail goto*//*Label 19633*/ GIMT_Encode4(1380704), // Rule ID 22447 //
     /* 1380625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1380642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380678 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1380681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380703 */     // GIR_Coverage, 22447,
     /* 1380703 */     GIR_EraseRootFromParent_Done,
     /* 1380704 */   // Label 19633: @1380704
     /* 1380704 */   GIM_Try, /*On fail goto*//*Label 19634*/ GIMT_Encode4(1380788), // Rule ID 22450 //
     /* 1380709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1380726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1380765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380787 */     // GIR_Coverage, 22450,
     /* 1380787 */     GIR_EraseRootFromParent_Done,
     /* 1380788 */   // Label 19634: @1380788
     /* 1380788 */   GIM_Try, /*On fail goto*//*Label 19635*/ GIMT_Encode4(1380872), // Rule ID 22451 //
     /* 1380793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1380810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380846 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1380849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380871 */     // GIR_Coverage, 22451,
     /* 1380871 */     GIR_EraseRootFromParent_Done,
     /* 1380872 */   // Label 19635: @1380872
     /* 1380872 */   GIM_Try, /*On fail goto*//*Label 19636*/ GIMT_Encode4(1380956), // Rule ID 22454 //
     /* 1380877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1380894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380930 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1380933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1380951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380955 */     // GIR_Coverage, 22454,
     /* 1380955 */     GIR_EraseRootFromParent_Done,
     /* 1380956 */   // Label 19636: @1380956
     /* 1380956 */   GIM_Try, /*On fail goto*//*Label 19637*/ GIMT_Encode4(1381040), // Rule ID 22455 //
     /* 1380961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1380969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1380972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1380975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1380978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1380981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381014 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1381017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381039 */     // GIR_Coverage, 22455,
     /* 1381039 */     GIR_EraseRootFromParent_Done,
     /* 1381040 */   // Label 19637: @1381040
     /* 1381040 */   GIM_Try, /*On fail goto*//*Label 19638*/ GIMT_Encode4(1381124), // Rule ID 22458 //
     /* 1381045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1381048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1381101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381123 */     // GIR_Coverage, 22458,
     /* 1381123 */     GIR_EraseRootFromParent_Done,
     /* 1381124 */   // Label 19638: @1381124
     /* 1381124 */   GIM_Try, /*On fail goto*//*Label 19639*/ GIMT_Encode4(1381208), // Rule ID 22459 //
     /* 1381129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1381132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1381185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381207 */     // GIR_Coverage, 22459,
     /* 1381207 */     GIR_EraseRootFromParent_Done,
     /* 1381208 */   // Label 19639: @1381208
     /* 1381208 */   GIM_Try, /*On fail goto*//*Label 19640*/ GIMT_Encode4(1381292), // Rule ID 22462 //
     /* 1381213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1381269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381291 */     // GIR_Coverage, 22462,
     /* 1381291 */     GIR_EraseRootFromParent_Done,
     /* 1381292 */   // Label 19640: @1381292
     /* 1381292 */   GIM_Try, /*On fail goto*//*Label 19641*/ GIMT_Encode4(1381376), // Rule ID 22463 //
     /* 1381297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1381314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381350 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1381353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381375 */     // GIR_Coverage, 22463,
     /* 1381375 */     GIR_EraseRootFromParent_Done,
     /* 1381376 */   // Label 19641: @1381376
     /* 1381376 */   GIM_Try, /*On fail goto*//*Label 19642*/ GIMT_Encode4(1381460), // Rule ID 22466 //
     /* 1381381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381434 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1381437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381459 */     // GIR_Coverage, 22466,
     /* 1381459 */     GIR_EraseRootFromParent_Done,
     /* 1381460 */   // Label 19642: @1381460
     /* 1381460 */   GIM_Try, /*On fail goto*//*Label 19643*/ GIMT_Encode4(1381544), // Rule ID 22467 //
     /* 1381465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1381482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1381488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381518 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1381521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381543 */     // GIR_Coverage, 22467,
     /* 1381543 */     GIR_EraseRootFromParent_Done,
     /* 1381544 */   // Label 19643: @1381544
     /* 1381544 */   GIM_Try, /*On fail goto*//*Label 19644*/ GIMT_Encode4(1381628), // Rule ID 22470 //
     /* 1381549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1381566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1381572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1381587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1381605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381627 */     // GIR_Coverage, 22470,
     /* 1381627 */     GIR_EraseRootFromParent_Done,
     /* 1381628 */   // Label 19644: @1381628
     /* 1381628 */   GIM_Try, /*On fail goto*//*Label 19645*/ GIMT_Encode4(1381712), // Rule ID 22471 //
     /* 1381633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1381650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1381656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1381671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381686 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11504:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1381689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381711 */     // GIR_Coverage, 22471,
     /* 1381711 */     GIR_EraseRootFromParent_Done,
     /* 1381712 */   // Label 19645: @1381712
     /* 1381712 */   GIM_Try, /*On fail goto*//*Label 19646*/ GIMT_Encode4(1381796), // Rule ID 22474 //
     /* 1381717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1381734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381770 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1381773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381795 */     // GIR_Coverage, 22474,
     /* 1381795 */     GIR_EraseRootFromParent_Done,
     /* 1381796 */   // Label 19646: @1381796
     /* 1381796 */   GIM_Try, /*On fail goto*//*Label 19647*/ GIMT_Encode4(1381880), // Rule ID 22475 //
     /* 1381801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1381818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1381839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381854 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1381857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381879 */     // GIR_Coverage, 22475,
     /* 1381879 */     GIR_EraseRootFromParent_Done,
     /* 1381880 */   // Label 19647: @1381880
     /* 1381880 */   GIM_Try, /*On fail goto*//*Label 19648*/ GIMT_Encode4(1381964), // Rule ID 22478 //
     /* 1381885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1381902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1381923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381938 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1381941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381963 */     // GIR_Coverage, 22478,
     /* 1381963 */     GIR_EraseRootFromParent_Done,
     /* 1381964 */   // Label 19648: @1381964
     /* 1381964 */   GIM_Try, /*On fail goto*//*Label 19649*/ GIMT_Encode4(1382048), // Rule ID 22479 //
     /* 1381969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1381977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1381986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1381992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382022 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1382025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382047 */     // GIR_Coverage, 22479,
     /* 1382047 */     GIR_EraseRootFromParent_Done,
     /* 1382048 */   // Label 19649: @1382048
     /* 1382048 */   GIM_Try, /*On fail goto*//*Label 19650*/ GIMT_Encode4(1382132), // Rule ID 22482 //
     /* 1382053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1382109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382131 */     // GIR_Coverage, 22482,
     /* 1382131 */     GIR_EraseRootFromParent_Done,
     /* 1382132 */   // Label 19650: @1382132
     /* 1382132 */   GIM_Try, /*On fail goto*//*Label 19651*/ GIMT_Encode4(1382216), // Rule ID 22483 //
     /* 1382137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11504:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1382193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382215 */     // GIR_Coverage, 22483,
     /* 1382215 */     GIR_EraseRootFromParent_Done,
     /* 1382216 */   // Label 19651: @1382216
     /* 1382216 */   GIM_Try, /*On fail goto*//*Label 19652*/ GIMT_Encode4(1382300), // Rule ID 22486 //
     /* 1382221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1382277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382299 */     // GIR_Coverage, 22486,
     /* 1382299 */     GIR_EraseRootFromParent_Done,
     /* 1382300 */   // Label 19652: @1382300
     /* 1382300 */   GIM_Try, /*On fail goto*//*Label 19653*/ GIMT_Encode4(1382384), // Rule ID 22487 //
     /* 1382305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1382322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1382361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382383 */     // GIR_Coverage, 22487,
     /* 1382383 */     GIR_EraseRootFromParent_Done,
     /* 1382384 */   // Label 19653: @1382384
     /* 1382384 */   GIM_Try, /*On fail goto*//*Label 19654*/ GIMT_Encode4(1382468), // Rule ID 22490 //
     /* 1382389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382442 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1382445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382467 */     // GIR_Coverage, 22490,
     /* 1382467 */     GIR_EraseRootFromParent_Done,
     /* 1382468 */   // Label 19654: @1382468
     /* 1382468 */   GIM_Try, /*On fail goto*//*Label 19655*/ GIMT_Encode4(1382552), // Rule ID 22491 //
     /* 1382473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1382490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382526 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1382529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382551 */     // GIR_Coverage, 22491,
     /* 1382551 */     GIR_EraseRootFromParent_Done,
     /* 1382552 */   // Label 19655: @1382552
     /* 1382552 */   GIM_Try, /*On fail goto*//*Label 19656*/ GIMT_Encode4(1382636), // Rule ID 22494 //
     /* 1382557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1382574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382610 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1382613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382635 */     // GIR_Coverage, 22494,
     /* 1382635 */     GIR_EraseRootFromParent_Done,
     /* 1382636 */   // Label 19656: @1382636
     /* 1382636 */   GIM_Try, /*On fail goto*//*Label 19657*/ GIMT_Encode4(1382720), // Rule ID 22495 //
     /* 1382641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1382652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1382655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1382658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1382661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382694 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11504:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1382697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1382715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382719 */     // GIR_Coverage, 22495,
     /* 1382719 */     GIR_EraseRootFromParent_Done,
     /* 1382720 */   // Label 19657: @1382720
     /* 1382720 */   GIM_Try, /*On fail goto*//*Label 19658*/ GIMT_Encode4(1382804), // Rule ID 22498 //
     /* 1382725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1382728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1382742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382778 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1382781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382803 */     // GIR_Coverage, 22498,
     /* 1382803 */     GIR_EraseRootFromParent_Done,
     /* 1382804 */   // Label 19658: @1382804
     /* 1382804 */   GIM_Try, /*On fail goto*//*Label 19659*/ GIMT_Encode4(1382888), // Rule ID 22499 //
     /* 1382809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1382812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1382826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1382832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382862 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1382865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382887 */     // GIR_Coverage, 22499,
     /* 1382887 */     GIR_EraseRootFromParent_Done,
     /* 1382888 */   // Label 19659: @1382888
     /* 1382888 */   GIM_Try, /*On fail goto*//*Label 19660*/ GIMT_Encode4(1382972), // Rule ID 22502 //
     /* 1382893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1382896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1382910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1382916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1382949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382971 */     // GIR_Coverage, 22502,
     /* 1382971 */     GIR_EraseRootFromParent_Done,
     /* 1382972 */   // Label 19660: @1382972
     /* 1382972 */   GIM_Try, /*On fail goto*//*Label 19661*/ GIMT_Encode4(1383056), // Rule ID 22503 //
     /* 1382977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1382980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1382985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1382988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1382991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1382994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1382997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383030 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1383033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383055 */     // GIR_Coverage, 22503,
     /* 1383055 */     GIR_EraseRootFromParent_Done,
     /* 1383056 */   // Label 19661: @1383056
     /* 1383056 */   GIM_Try, /*On fail goto*//*Label 19662*/ GIMT_Encode4(1383140), // Rule ID 22506 //
     /* 1383061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1383117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383139 */     // GIR_Coverage, 22506,
     /* 1383139 */     GIR_EraseRootFromParent_Done,
     /* 1383140 */   // Label 19662: @1383140
     /* 1383140 */   GIM_Try, /*On fail goto*//*Label 19663*/ GIMT_Encode4(1383224), // Rule ID 22507 //
     /* 1383145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1383153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383198 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11504:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1383201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383223 */     // GIR_Coverage, 22507,
     /* 1383223 */     GIR_EraseRootFromParent_Done,
     /* 1383224 */   // Label 19663: @1383224
     /* 1383224 */   GIM_Try, /*On fail goto*//*Label 19664*/ GIMT_Encode4(1383308), // Rule ID 22510 //
     /* 1383229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1383285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383307 */     // GIR_Coverage, 22510,
     /* 1383307 */     GIR_EraseRootFromParent_Done,
     /* 1383308 */   // Label 19664: @1383308
     /* 1383308 */   GIM_Try, /*On fail goto*//*Label 19665*/ GIMT_Encode4(1383392), // Rule ID 22511 //
     /* 1383313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1383330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383366 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1383369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383391 */     // GIR_Coverage, 22511,
     /* 1383391 */     GIR_EraseRootFromParent_Done,
     /* 1383392 */   // Label 19665: @1383392
     /* 1383392 */   GIM_Try, /*On fail goto*//*Label 19666*/ GIMT_Encode4(1383476), // Rule ID 22514 //
     /* 1383397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1383453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383475 */     // GIR_Coverage, 22514,
     /* 1383475 */     GIR_EraseRootFromParent_Done,
     /* 1383476 */   // Label 19666: @1383476
     /* 1383476 */   GIM_Try, /*On fail goto*//*Label 19667*/ GIMT_Encode4(1383560), // Rule ID 22515 //
     /* 1383481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1383498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383534 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1383537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383559 */     // GIR_Coverage, 22515,
     /* 1383559 */     GIR_EraseRootFromParent_Done,
     /* 1383560 */   // Label 19667: @1383560
     /* 1383560 */   GIM_Try, /*On fail goto*//*Label 19668*/ GIMT_Encode4(1383644), // Rule ID 22518 //
     /* 1383565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1383582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383618 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1383621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383643 */     // GIR_Coverage, 22518,
     /* 1383643 */     GIR_EraseRootFromParent_Done,
     /* 1383644 */   // Label 19668: @1383644
     /* 1383644 */   GIM_Try, /*On fail goto*//*Label 19669*/ GIMT_Encode4(1383728), // Rule ID 22519 //
     /* 1383649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1383660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1383663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1383666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1383669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1383705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1383723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383727 */     // GIR_Coverage, 22519,
     /* 1383727 */     GIR_EraseRootFromParent_Done,
     /* 1383728 */   // Label 19669: @1383728
     /* 1383728 */   GIM_Try, /*On fail goto*//*Label 19670*/ GIMT_Encode4(1383812), // Rule ID 22522 //
     /* 1383733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1383750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1383789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383811 */     // GIR_Coverage, 22522,
     /* 1383811 */     GIR_EraseRootFromParent_Done,
     /* 1383812 */   // Label 19670: @1383812
     /* 1383812 */   GIM_Try, /*On fail goto*//*Label 19671*/ GIMT_Encode4(1383896), // Rule ID 22523 //
     /* 1383817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1383834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1383840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1383873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383895 */     // GIR_Coverage, 22523,
     /* 1383895 */     GIR_EraseRootFromParent_Done,
     /* 1383896 */   // Label 19671: @1383896
     /* 1383896 */   GIM_Try, /*On fail goto*//*Label 19672*/ GIMT_Encode4(1383980), // Rule ID 22526 //
     /* 1383901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1383918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1383921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383954 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1383957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383979 */     // GIR_Coverage, 22526,
     /* 1383979 */     GIR_EraseRootFromParent_Done,
     /* 1383980 */   // Label 19672: @1383980
     /* 1383980 */   GIM_Try, /*On fail goto*//*Label 19673*/ GIMT_Encode4(1384064), // Rule ID 22527 //
     /* 1383985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1383993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1383996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1383999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384038 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1384041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384063 */     // GIR_Coverage, 22527,
     /* 1384063 */     GIR_EraseRootFromParent_Done,
     /* 1384064 */   // Label 19673: @1384064
     /* 1384064 */   GIM_Try, /*On fail goto*//*Label 19674*/ GIMT_Encode4(1384148), // Rule ID 22530 //
     /* 1384069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1384125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384147 */     // GIR_Coverage, 22530,
     /* 1384147 */     GIR_EraseRootFromParent_Done,
     /* 1384148 */   // Label 19674: @1384148
     /* 1384148 */   GIM_Try, /*On fail goto*//*Label 19675*/ GIMT_Encode4(1384232), // Rule ID 22531 //
     /* 1384153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1384209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384231 */     // GIR_Coverage, 22531,
     /* 1384231 */     GIR_EraseRootFromParent_Done,
     /* 1384232 */   // Label 19675: @1384232
     /* 1384232 */   GIM_Try, /*On fail goto*//*Label 19676*/ GIMT_Encode4(1384316), // Rule ID 22534 //
     /* 1384237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1384293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384315 */     // GIR_Coverage, 22534,
     /* 1384315 */     GIR_EraseRootFromParent_Done,
     /* 1384316 */   // Label 19676: @1384316
     /* 1384316 */   GIM_Try, /*On fail goto*//*Label 19677*/ GIMT_Encode4(1384400), // Rule ID 22535 //
     /* 1384321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1384338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1384344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1384377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384399 */     // GIR_Coverage, 22535,
     /* 1384399 */     GIR_EraseRootFromParent_Done,
     /* 1384400 */   // Label 19677: @1384400
     /* 1384400 */   GIM_Try, /*On fail goto*//*Label 19678*/ GIMT_Encode4(1384484), // Rule ID 22538 //
     /* 1384405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384458 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1384461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384483 */     // GIR_Coverage, 22538,
     /* 1384483 */     GIR_EraseRootFromParent_Done,
     /* 1384484 */   // Label 19678: @1384484
     /* 1384484 */   GIM_Try, /*On fail goto*//*Label 19679*/ GIMT_Encode4(1384568), // Rule ID 22539 //
     /* 1384489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1384506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384542 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1384545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384567 */     // GIR_Coverage, 22539,
     /* 1384567 */     GIR_EraseRootFromParent_Done,
     /* 1384568 */   // Label 19679: @1384568
     /* 1384568 */   GIM_Try, /*On fail goto*//*Label 19680*/ GIMT_Encode4(1384652), // Rule ID 22542 //
     /* 1384573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1384590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1384629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384651 */     // GIR_Coverage, 22542,
     /* 1384651 */     GIR_EraseRootFromParent_Done,
     /* 1384652 */   // Label 19680: @1384652
     /* 1384652 */   GIM_Try, /*On fail goto*//*Label 19681*/ GIMT_Encode4(1384736), // Rule ID 22543 //
     /* 1384657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1384674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384710 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1384713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384735 */     // GIR_Coverage, 22543,
     /* 1384735 */     GIR_EraseRootFromParent_Done,
     /* 1384736 */   // Label 19681: @1384736
     /* 1384736 */   GIM_Try, /*On fail goto*//*Label 19682*/ GIMT_Encode4(1384820), // Rule ID 22546 //
     /* 1384741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1384744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1384758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1384797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384819 */     // GIR_Coverage, 22546,
     /* 1384819 */     GIR_EraseRootFromParent_Done,
     /* 1384820 */   // Label 19682: @1384820
     /* 1384820 */   GIM_Try, /*On fail goto*//*Label 19683*/ GIMT_Encode4(1384904), // Rule ID 22547 //
     /* 1384825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1384828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1384842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384878 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1384881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384903 */     // GIR_Coverage, 22547,
     /* 1384903 */     GIR_EraseRootFromParent_Done,
     /* 1384904 */   // Label 19683: @1384904
     /* 1384904 */   GIM_Try, /*On fail goto*//*Label 19684*/ GIMT_Encode4(1384988), // Rule ID 22550 //
     /* 1384909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1384917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1384920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1384923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1384926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1384929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1384932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1384947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384962 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1384965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384987 */     // GIR_Coverage, 22550,
     /* 1384987 */     GIR_EraseRootFromParent_Done,
     /* 1384988 */   // Label 19684: @1384988
     /* 1384988 */   GIM_Try, /*On fail goto*//*Label 19685*/ GIMT_Encode4(1385072), // Rule ID 22551 //
     /* 1384993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385046 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1385049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385071 */     // GIR_Coverage, 22551,
     /* 1385071 */     GIR_EraseRootFromParent_Done,
     /* 1385072 */   // Label 19685: @1385072
     /* 1385072 */   GIM_Try, /*On fail goto*//*Label 19686*/ GIMT_Encode4(1385156), // Rule ID 22554 //
     /* 1385077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385130 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1385133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385155 */     // GIR_Coverage, 22554,
     /* 1385155 */     GIR_EraseRootFromParent_Done,
     /* 1385156 */   // Label 19686: @1385156
     /* 1385156 */   GIM_Try, /*On fail goto*//*Label 19687*/ GIMT_Encode4(1385240), // Rule ID 22555 //
     /* 1385161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385214 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1385217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385239 */     // GIR_Coverage, 22555,
     /* 1385239 */     GIR_EraseRootFromParent_Done,
     /* 1385240 */   // Label 19687: @1385240
     /* 1385240 */   GIM_Try, /*On fail goto*//*Label 19688*/ GIMT_Encode4(1385324), // Rule ID 22558 //
     /* 1385245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385298 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1385301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385323 */     // GIR_Coverage, 22558,
     /* 1385323 */     GIR_EraseRootFromParent_Done,
     /* 1385324 */   // Label 19688: @1385324
     /* 1385324 */   GIM_Try, /*On fail goto*//*Label 19689*/ GIMT_Encode4(1385408), // Rule ID 22559 //
     /* 1385329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1385340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1385343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1385349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385382 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11502:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1385385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385407 */     // GIR_Coverage, 22559,
     /* 1385407 */     GIR_EraseRootFromParent_Done,
     /* 1385408 */   // Label 19689: @1385408
     /* 1385408 */   GIM_Try, /*On fail goto*//*Label 19690*/ GIMT_Encode4(1385492), // Rule ID 22562 //
     /* 1385413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1385469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385491 */     // GIR_Coverage, 22562,
     /* 1385491 */     GIR_EraseRootFromParent_Done,
     /* 1385492 */   // Label 19690: @1385492
     /* 1385492 */   GIM_Try, /*On fail goto*//*Label 19691*/ GIMT_Encode4(1385576), // Rule ID 22563 //
     /* 1385497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1385514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1385553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385575 */     // GIR_Coverage, 22563,
     /* 1385575 */     GIR_EraseRootFromParent_Done,
     /* 1385576 */   // Label 19691: @1385576
     /* 1385576 */   GIM_Try, /*On fail goto*//*Label 19692*/ GIMT_Encode4(1385660), // Rule ID 22566 //
     /* 1385581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1385598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385634 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1385637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385659 */     // GIR_Coverage, 22566,
     /* 1385659 */     GIR_EraseRootFromParent_Done,
     /* 1385660 */   // Label 19692: @1385660
     /* 1385660 */   GIM_Try, /*On fail goto*//*Label 19693*/ GIMT_Encode4(1385744), // Rule ID 22567 //
     /* 1385665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1385682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385718 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1385721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385743 */     // GIR_Coverage, 22567,
     /* 1385743 */     GIR_EraseRootFromParent_Done,
     /* 1385744 */   // Label 19693: @1385744
     /* 1385744 */   GIM_Try, /*On fail goto*//*Label 19694*/ GIMT_Encode4(1385828), // Rule ID 22570 //
     /* 1385749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1385766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1385805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385827 */     // GIR_Coverage, 22570,
     /* 1385827 */     GIR_EraseRootFromParent_Done,
     /* 1385828 */   // Label 19694: @1385828
     /* 1385828 */   GIM_Try, /*On fail goto*//*Label 19695*/ GIMT_Encode4(1385912), // Rule ID 22571 //
     /* 1385833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1385850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11502:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1385889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385911 */     // GIR_Coverage, 22571,
     /* 1385911 */     GIR_EraseRootFromParent_Done,
     /* 1385912 */   // Label 19695: @1385912
     /* 1385912 */   GIM_Try, /*On fail goto*//*Label 19696*/ GIMT_Encode4(1385996), // Rule ID 22574 //
     /* 1385917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1385925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1385934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1385973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385995 */     // GIR_Coverage, 22574,
     /* 1385995 */     GIR_EraseRootFromParent_Done,
     /* 1385996 */   // Label 19696: @1385996
     /* 1385996 */   GIM_Try, /*On fail goto*//*Label 19697*/ GIMT_Encode4(1386080), // Rule ID 22575 //
     /* 1386001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1386057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386079 */     // GIR_Coverage, 22575,
     /* 1386079 */     GIR_EraseRootFromParent_Done,
     /* 1386080 */   // Label 19697: @1386080
     /* 1386080 */   GIM_Try, /*On fail goto*//*Label 19698*/ GIMT_Encode4(1386164), // Rule ID 22578 //
     /* 1386085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386138 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1386141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386163 */     // GIR_Coverage, 22578,
     /* 1386163 */     GIR_EraseRootFromParent_Done,
     /* 1386164 */   // Label 19698: @1386164
     /* 1386164 */   GIM_Try, /*On fail goto*//*Label 19699*/ GIMT_Encode4(1386248), // Rule ID 22579 //
     /* 1386169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1386225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386247 */     // GIR_Coverage, 22579,
     /* 1386247 */     GIR_EraseRootFromParent_Done,
     /* 1386248 */   // Label 19699: @1386248
     /* 1386248 */   GIM_Try, /*On fail goto*//*Label 19700*/ GIMT_Encode4(1386332), // Rule ID 22582 //
     /* 1386253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386306 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1386309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386331 */     // GIR_Coverage, 22582,
     /* 1386331 */     GIR_EraseRootFromParent_Done,
     /* 1386332 */   // Label 19700: @1386332
     /* 1386332 */   GIM_Try, /*On fail goto*//*Label 19701*/ GIMT_Encode4(1386416), // Rule ID 22583 //
     /* 1386337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11502:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1386393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386415 */     // GIR_Coverage, 22583,
     /* 1386415 */     GIR_EraseRootFromParent_Done,
     /* 1386416 */   // Label 19701: @1386416
     /* 1386416 */   GIM_Try, /*On fail goto*//*Label 19702*/ GIMT_Encode4(1386500), // Rule ID 22586 //
     /* 1386421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386474 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1386477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386499 */     // GIR_Coverage, 22586,
     /* 1386499 */     GIR_EraseRootFromParent_Done,
     /* 1386500 */   // Label 19702: @1386500
     /* 1386500 */   GIM_Try, /*On fail goto*//*Label 19703*/ GIMT_Encode4(1386584), // Rule ID 22587 //
     /* 1386505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1386522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1386528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386558 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1386561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386583 */     // GIR_Coverage, 22587,
     /* 1386583 */     GIR_EraseRootFromParent_Done,
     /* 1386584 */   // Label 19703: @1386584
     /* 1386584 */   GIM_Try, /*On fail goto*//*Label 19704*/ GIMT_Encode4(1386668), // Rule ID 22590 //
     /* 1386589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1386606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386642 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1386645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386667 */     // GIR_Coverage, 22590,
     /* 1386667 */     GIR_EraseRootFromParent_Done,
     /* 1386668 */   // Label 19704: @1386668
     /* 1386668 */   GIM_Try, /*On fail goto*//*Label 19705*/ GIMT_Encode4(1386752), // Rule ID 22591 //
     /* 1386673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1386690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1386729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386751 */     // GIR_Coverage, 22591,
     /* 1386751 */     GIR_EraseRootFromParent_Done,
     /* 1386752 */   // Label 19705: @1386752
     /* 1386752 */   GIM_Try, /*On fail goto*//*Label 19706*/ GIMT_Encode4(1386836), // Rule ID 22594 //
     /* 1386757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1386760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1386774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1386813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386835 */     // GIR_Coverage, 22594,
     /* 1386835 */     GIR_EraseRootFromParent_Done,
     /* 1386836 */   // Label 19706: @1386836
     /* 1386836 */   GIM_Try, /*On fail goto*//*Label 19707*/ GIMT_Encode4(1386920), // Rule ID 22595 //
     /* 1386841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1386844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1386849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1386858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11502:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1386897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1386915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386919 */     // GIR_Coverage, 22595,
     /* 1386919 */     GIR_EraseRootFromParent_Done,
     /* 1386920 */   // Label 19707: @1386920
     /* 1386920 */   GIM_Try, /*On fail goto*//*Label 19708*/ GIMT_Encode4(1387004), // Rule ID 22598 //
     /* 1386925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1386933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1386936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1386939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1386942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1386945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1386948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386978 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1386981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387003 */     // GIR_Coverage, 22598,
     /* 1387003 */     GIR_EraseRootFromParent_Done,
     /* 1387004 */   // Label 19708: @1387004
     /* 1387004 */   GIM_Try, /*On fail goto*//*Label 19709*/ GIMT_Encode4(1387088), // Rule ID 22599 //
     /* 1387009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387062 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1387065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387087 */     // GIR_Coverage, 22599,
     /* 1387087 */     GIR_EraseRootFromParent_Done,
     /* 1387088 */   // Label 19709: @1387088
     /* 1387088 */   GIM_Try, /*On fail goto*//*Label 19710*/ GIMT_Encode4(1387172), // Rule ID 22602 //
     /* 1387093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387146 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1387149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387171 */     // GIR_Coverage, 22602,
     /* 1387171 */     GIR_EraseRootFromParent_Done,
     /* 1387172 */   // Label 19710: @1387172
     /* 1387172 */   GIM_Try, /*On fail goto*//*Label 19711*/ GIMT_Encode4(1387256), // Rule ID 22603 //
     /* 1387177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387230 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1387233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387255 */     // GIR_Coverage, 22603,
     /* 1387255 */     GIR_EraseRootFromParent_Done,
     /* 1387256 */   // Label 19711: @1387256
     /* 1387256 */   GIM_Try, /*On fail goto*//*Label 19712*/ GIMT_Encode4(1387340), // Rule ID 22606 //
     /* 1387261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387314 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1387317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387339 */     // GIR_Coverage, 22606,
     /* 1387339 */     GIR_EraseRootFromParent_Done,
     /* 1387340 */   // Label 19712: @1387340
     /* 1387340 */   GIM_Try, /*On fail goto*//*Label 19713*/ GIMT_Encode4(1387424), // Rule ID 22607 //
     /* 1387345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387398 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1387401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387423 */     // GIR_Coverage, 22607,
     /* 1387423 */     GIR_EraseRootFromParent_Done,
     /* 1387424 */   // Label 19713: @1387424
     /* 1387424 */   GIM_Try, /*On fail goto*//*Label 19714*/ GIMT_Encode4(1387508), // Rule ID 22610 //
     /* 1387429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387482 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1387485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387507 */     // GIR_Coverage, 22610,
     /* 1387507 */     GIR_EraseRootFromParent_Done,
     /* 1387508 */   // Label 19714: @1387508
     /* 1387508 */   GIM_Try, /*On fail goto*//*Label 19715*/ GIMT_Encode4(1387592), // Rule ID 22611 //
     /* 1387513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387566 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1387569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387591 */     // GIR_Coverage, 22611,
     /* 1387591 */     GIR_EraseRootFromParent_Done,
     /* 1387592 */   // Label 19715: @1387592
     /* 1387592 */   GIM_Try, /*On fail goto*//*Label 19716*/ GIMT_Encode4(1387676), // Rule ID 22614 //
     /* 1387597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1387653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387675 */     // GIR_Coverage, 22614,
     /* 1387675 */     GIR_EraseRootFromParent_Done,
     /* 1387676 */   // Label 19716: @1387676
     /* 1387676 */   GIM_Try, /*On fail goto*//*Label 19717*/ GIMT_Encode4(1387760), // Rule ID 22615 //
     /* 1387681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387734 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1387737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387759 */     // GIR_Coverage, 22615,
     /* 1387759 */     GIR_EraseRootFromParent_Done,
     /* 1387760 */   // Label 19717: @1387760
     /* 1387760 */   GIM_Try, /*On fail goto*//*Label 19718*/ GIMT_Encode4(1387844), // Rule ID 22618 //
     /* 1387765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1387782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1387821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387843 */     // GIR_Coverage, 22618,
     /* 1387843 */     GIR_EraseRootFromParent_Done,
     /* 1387844 */   // Label 19718: @1387844
     /* 1387844 */   GIM_Try, /*On fail goto*//*Label 19719*/ GIMT_Encode4(1387928), // Rule ID 22619 //
     /* 1387849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1387866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1387905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387927 */     // GIR_Coverage, 22619,
     /* 1387927 */     GIR_EraseRootFromParent_Done,
     /* 1387928 */   // Label 19719: @1387928
     /* 1387928 */   GIM_Try, /*On fail goto*//*Label 19720*/ GIMT_Encode4(1388012), // Rule ID 22622 //
     /* 1387933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1387941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1387944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1387947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1387950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1387953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1387956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387986 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1387989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388011 */     // GIR_Coverage, 22622,
     /* 1388011 */     GIR_EraseRootFromParent_Done,
     /* 1388012 */   // Label 19720: @1388012
     /* 1388012 */   GIM_Try, /*On fail goto*//*Label 19721*/ GIMT_Encode4(1388096), // Rule ID 22623 //
     /* 1388017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1388073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388095 */     // GIR_Coverage, 22623,
     /* 1388095 */     GIR_EraseRootFromParent_Done,
     /* 1388096 */   // Label 19721: @1388096
     /* 1388096 */   GIM_Try, /*On fail goto*//*Label 19722*/ GIMT_Encode4(1388180), // Rule ID 22626 //
     /* 1388101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1388157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388179 */     // GIR_Coverage, 22626,
     /* 1388179 */     GIR_EraseRootFromParent_Done,
     /* 1388180 */   // Label 19722: @1388180
     /* 1388180 */   GIM_Try, /*On fail goto*//*Label 19723*/ GIMT_Encode4(1388264), // Rule ID 22627 //
     /* 1388185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1388241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388263 */     // GIR_Coverage, 22627,
     /* 1388263 */     GIR_EraseRootFromParent_Done,
     /* 1388264 */   // Label 19723: @1388264
     /* 1388264 */   GIM_Try, /*On fail goto*//*Label 19724*/ GIMT_Encode4(1388348), // Rule ID 22630 //
     /* 1388269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1388325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388347 */     // GIR_Coverage, 22630,
     /* 1388347 */     GIR_EraseRootFromParent_Done,
     /* 1388348 */   // Label 19724: @1388348
     /* 1388348 */   GIM_Try, /*On fail goto*//*Label 19725*/ GIMT_Encode4(1388432), // Rule ID 22631 //
     /* 1388353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1388409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388431 */     // GIR_Coverage, 22631,
     /* 1388431 */     GIR_EraseRootFromParent_Done,
     /* 1388432 */   // Label 19725: @1388432
     /* 1388432 */   GIM_Try, /*On fail goto*//*Label 19726*/ GIMT_Encode4(1388516), // Rule ID 22634 //
     /* 1388437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1388440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1388454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1388493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388515 */     // GIR_Coverage, 22634,
     /* 1388515 */     GIR_EraseRootFromParent_Done,
     /* 1388516 */   // Label 19726: @1388516
     /* 1388516 */   GIM_Try, /*On fail goto*//*Label 19727*/ GIMT_Encode4(1388600), // Rule ID 22635 //
     /* 1388521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1388524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1388538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1388577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1388595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388599 */     // GIR_Coverage, 22635,
     /* 1388599 */     GIR_EraseRootFromParent_Done,
     /* 1388600 */   // Label 19727: @1388600
     /* 1388600 */   GIM_Try, /*On fail goto*//*Label 19728*/ GIMT_Encode4(1388684), // Rule ID 22638 //
     /* 1388605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1388661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388683 */     // GIR_Coverage, 22638,
     /* 1388683 */     GIR_EraseRootFromParent_Done,
     /* 1388684 */   // Label 19728: @1388684
     /* 1388684 */   GIM_Try, /*On fail goto*//*Label 19729*/ GIMT_Encode4(1388768), // Rule ID 22639 //
     /* 1388689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388742 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1388745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388767 */     // GIR_Coverage, 22639,
     /* 1388767 */     GIR_EraseRootFromParent_Done,
     /* 1388768 */   // Label 19729: @1388768
     /* 1388768 */   GIM_Try, /*On fail goto*//*Label 19730*/ GIMT_Encode4(1388852), // Rule ID 22642 //
     /* 1388773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1388790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1388796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1388829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388851 */     // GIR_Coverage, 22642,
     /* 1388851 */     GIR_EraseRootFromParent_Done,
     /* 1388852 */   // Label 19730: @1388852
     /* 1388852 */   GIM_Try, /*On fail goto*//*Label 19731*/ GIMT_Encode4(1388936), // Rule ID 22643 //
     /* 1388857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1388874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1388880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388910 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1388913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388935 */     // GIR_Coverage, 22643,
     /* 1388935 */     GIR_EraseRootFromParent_Done,
     /* 1388936 */   // Label 19731: @1388936
     /* 1388936 */   GIM_Try, /*On fail goto*//*Label 19732*/ GIMT_Encode4(1389020), // Rule ID 22646 //
     /* 1388941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1388949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1388952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1388955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1388958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1388961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1388964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1388979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388994 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1388997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389019 */     // GIR_Coverage, 22646,
     /* 1389019 */     GIR_EraseRootFromParent_Done,
     /* 1389020 */   // Label 19732: @1389020
     /* 1389020 */   GIM_Try, /*On fail goto*//*Label 19733*/ GIMT_Encode4(1389104), // Rule ID 22647 //
     /* 1389025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1389036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1389039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1389042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1389045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1389048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389078 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11500:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1389081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389103 */     // GIR_Coverage, 22647,
     /* 1389103 */     GIR_EraseRootFromParent_Done,
     /* 1389104 */   // Label 19733: @1389104
     /* 1389104 */   GIM_Try, /*On fail goto*//*Label 19734*/ GIMT_Encode4(1389188), // Rule ID 22650 //
     /* 1389109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389162 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1389165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389187 */     // GIR_Coverage, 22650,
     /* 1389187 */     GIR_EraseRootFromParent_Done,
     /* 1389188 */   // Label 19734: @1389188
     /* 1389188 */   GIM_Try, /*On fail goto*//*Label 19735*/ GIMT_Encode4(1389272), // Rule ID 22651 //
     /* 1389193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389246 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1389249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389271 */     // GIR_Coverage, 22651,
     /* 1389271 */     GIR_EraseRootFromParent_Done,
     /* 1389272 */   // Label 19735: @1389272
     /* 1389272 */   GIM_Try, /*On fail goto*//*Label 19736*/ GIMT_Encode4(1389356), // Rule ID 22654 //
     /* 1389277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1389333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389355 */     // GIR_Coverage, 22654,
     /* 1389355 */     GIR_EraseRootFromParent_Done,
     /* 1389356 */   // Label 19736: @1389356
     /* 1389356 */   GIM_Try, /*On fail goto*//*Label 19737*/ GIMT_Encode4(1389440), // Rule ID 22655 //
     /* 1389361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1389417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389439 */     // GIR_Coverage, 22655,
     /* 1389439 */     GIR_EraseRootFromParent_Done,
     /* 1389440 */   // Label 19737: @1389440
     /* 1389440 */   GIM_Try, /*On fail goto*//*Label 19738*/ GIMT_Encode4(1389524), // Rule ID 22658 //
     /* 1389445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1389501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389523 */     // GIR_Coverage, 22658,
     /* 1389523 */     GIR_EraseRootFromParent_Done,
     /* 1389524 */   // Label 19738: @1389524
     /* 1389524 */   GIM_Try, /*On fail goto*//*Label 19739*/ GIMT_Encode4(1389608), // Rule ID 22659 //
     /* 1389529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11500:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1389585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389607 */     // GIR_Coverage, 22659,
     /* 1389607 */     GIR_EraseRootFromParent_Done,
     /* 1389608 */   // Label 19739: @1389608
     /* 1389608 */   GIM_Try, /*On fail goto*//*Label 19740*/ GIMT_Encode4(1389692), // Rule ID 22662 //
     /* 1389613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389666 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1389669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389691 */     // GIR_Coverage, 22662,
     /* 1389691 */     GIR_EraseRootFromParent_Done,
     /* 1389692 */   // Label 19740: @1389692
     /* 1389692 */   GIM_Try, /*On fail goto*//*Label 19741*/ GIMT_Encode4(1389776), // Rule ID 22663 //
     /* 1389697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1389753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389775 */     // GIR_Coverage, 22663,
     /* 1389775 */     GIR_EraseRootFromParent_Done,
     /* 1389776 */   // Label 19741: @1389776
     /* 1389776 */   GIM_Try, /*On fail goto*//*Label 19742*/ GIMT_Encode4(1389860), // Rule ID 22666 //
     /* 1389781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1389798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1389837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389859 */     // GIR_Coverage, 22666,
     /* 1389859 */     GIR_EraseRootFromParent_Done,
     /* 1389860 */   // Label 19742: @1389860
     /* 1389860 */   GIM_Try, /*On fail goto*//*Label 19743*/ GIMT_Encode4(1389944), // Rule ID 22667 //
     /* 1389865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1389882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1389921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389943 */     // GIR_Coverage, 22667,
     /* 1389943 */     GIR_EraseRootFromParent_Done,
     /* 1389944 */   // Label 19743: @1389944
     /* 1389944 */   GIM_Try, /*On fail goto*//*Label 19744*/ GIMT_Encode4(1390028), // Rule ID 22670 //
     /* 1389949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1389957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1389966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1390005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390027 */     // GIR_Coverage, 22670,
     /* 1390027 */     GIR_EraseRootFromParent_Done,
     /* 1390028 */   // Label 19744: @1390028
     /* 1390028 */   GIM_Try, /*On fail goto*//*Label 19745*/ GIMT_Encode4(1390112), // Rule ID 22671 //
     /* 1390033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1390050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390086 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11500:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1390089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390111 */     // GIR_Coverage, 22671,
     /* 1390111 */     GIR_EraseRootFromParent_Done,
     /* 1390112 */   // Label 19745: @1390112
     /* 1390112 */   GIM_Try, /*On fail goto*//*Label 19746*/ GIMT_Encode4(1390196), // Rule ID 22674 //
     /* 1390117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390170 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1390173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390195 */     // GIR_Coverage, 22674,
     /* 1390195 */     GIR_EraseRootFromParent_Done,
     /* 1390196 */   // Label 19746: @1390196
     /* 1390196 */   GIM_Try, /*On fail goto*//*Label 19747*/ GIMT_Encode4(1390280), // Rule ID 22675 //
     /* 1390201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1390218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1390239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390254 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1390257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390279 */     // GIR_Coverage, 22675,
     /* 1390279 */     GIR_EraseRootFromParent_Done,
     /* 1390280 */   // Label 19747: @1390280
     /* 1390280 */   GIM_Try, /*On fail goto*//*Label 19748*/ GIMT_Encode4(1390364), // Rule ID 22678 //
     /* 1390285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390338 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1390341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390363 */     // GIR_Coverage, 22678,
     /* 1390363 */     GIR_EraseRootFromParent_Done,
     /* 1390364 */   // Label 19748: @1390364
     /* 1390364 */   GIM_Try, /*On fail goto*//*Label 19749*/ GIMT_Encode4(1390448), // Rule ID 22679 //
     /* 1390369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1390386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1390407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390422 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1390425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390447 */     // GIR_Coverage, 22679,
     /* 1390447 */     GIR_EraseRootFromParent_Done,
     /* 1390448 */   // Label 19749: @1390448
     /* 1390448 */   GIM_Try, /*On fail goto*//*Label 19750*/ GIMT_Encode4(1390532), // Rule ID 22682 //
     /* 1390453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1390456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390506 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1390509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390531 */     // GIR_Coverage, 22682,
     /* 1390531 */     GIR_EraseRootFromParent_Done,
     /* 1390532 */   // Label 19750: @1390532
     /* 1390532 */   GIM_Try, /*On fail goto*//*Label 19751*/ GIMT_Encode4(1390616), // Rule ID 22683 //
     /* 1390537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1390540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1390545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1390554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1390560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390590 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11500:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1390593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390615 */     // GIR_Coverage, 22683,
     /* 1390615 */     GIR_EraseRootFromParent_Done,
     /* 1390616 */   // Label 19751: @1390616
     /* 1390616 */   GIM_Try, /*On fail goto*//*Label 19752*/ GIMT_Encode4(1390700), // Rule ID 22686 //
     /* 1390621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1390638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1390677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390699 */     // GIR_Coverage, 22686,
     /* 1390699 */     GIR_EraseRootFromParent_Done,
     /* 1390700 */   // Label 19752: @1390700
     /* 1390700 */   GIM_Try, /*On fail goto*//*Label 19753*/ GIMT_Encode4(1390784), // Rule ID 22687 //
     /* 1390705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1390722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390758 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1390761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390783 */     // GIR_Coverage, 22687,
     /* 1390783 */     GIR_EraseRootFromParent_Done,
     /* 1390784 */   // Label 19753: @1390784
     /* 1390784 */   GIM_Try, /*On fail goto*//*Label 19754*/ GIMT_Encode4(1390868), // Rule ID 22690 //
     /* 1390789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1390806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390842 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1390845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390867 */     // GIR_Coverage, 22690,
     /* 1390867 */     GIR_EraseRootFromParent_Done,
     /* 1390868 */   // Label 19754: @1390868
     /* 1390868 */   GIM_Try, /*On fail goto*//*Label 19755*/ GIMT_Encode4(1390952), // Rule ID 22691 //
     /* 1390873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1390890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390926 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1390929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1390947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390951 */     // GIR_Coverage, 22691,
     /* 1390951 */     GIR_EraseRootFromParent_Done,
     /* 1390952 */   // Label 19755: @1390952
     /* 1390952 */   GIM_Try, /*On fail goto*//*Label 19756*/ GIMT_Encode4(1391036), // Rule ID 22694 //
     /* 1390957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1390960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1390965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1390974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391010 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1391013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391035 */     // GIR_Coverage, 22694,
     /* 1391035 */     GIR_EraseRootFromParent_Done,
     /* 1391036 */   // Label 19756: @1391036
     /* 1391036 */   GIM_Try, /*On fail goto*//*Label 19757*/ GIMT_Encode4(1391120), // Rule ID 22695 //
     /* 1391041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1391058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1391097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391119 */     // GIR_Coverage, 22695,
     /* 1391119 */     GIR_EraseRootFromParent_Done,
     /* 1391120 */   // Label 19757: @1391120
     /* 1391120 */   GIM_Try, /*On fail goto*//*Label 19758*/ GIMT_Encode4(1391204), // Rule ID 22698 //
     /* 1391125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1391181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391203 */     // GIR_Coverage, 22698,
     /* 1391203 */     GIR_EraseRootFromParent_Done,
     /* 1391204 */   // Label 19758: @1391204
     /* 1391204 */   GIM_Try, /*On fail goto*//*Label 19759*/ GIMT_Encode4(1391288), // Rule ID 22699 //
     /* 1391209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1391226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391262 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1391265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391287 */     // GIR_Coverage, 22699,
     /* 1391287 */     GIR_EraseRootFromParent_Done,
     /* 1391288 */   // Label 19759: @1391288
     /* 1391288 */   GIM_Try, /*On fail goto*//*Label 19760*/ GIMT_Encode4(1391372), // Rule ID 22702 //
     /* 1391293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391346 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1391349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391371 */     // GIR_Coverage, 22702,
     /* 1391371 */     GIR_EraseRootFromParent_Done,
     /* 1391372 */   // Label 19760: @1391372
     /* 1391372 */   GIM_Try, /*On fail goto*//*Label 19761*/ GIMT_Encode4(1391456), // Rule ID 22703 //
     /* 1391377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1391394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391430 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1391433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391455 */     // GIR_Coverage, 22703,
     /* 1391455 */     GIR_EraseRootFromParent_Done,
     /* 1391456 */   // Label 19761: @1391456
     /* 1391456 */   GIM_Try, /*On fail goto*//*Label 19762*/ GIMT_Encode4(1391540), // Rule ID 22706 //
     /* 1391461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1391478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1391517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391539 */     // GIR_Coverage, 22706,
     /* 1391539 */     GIR_EraseRootFromParent_Done,
     /* 1391540 */   // Label 19762: @1391540
     /* 1391540 */   GIM_Try, /*On fail goto*//*Label 19763*/ GIMT_Encode4(1391624), // Rule ID 22707 //
     /* 1391545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1391562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391598 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1391601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391623 */     // GIR_Coverage, 22707,
     /* 1391623 */     GIR_EraseRootFromParent_Done,
     /* 1391624 */   // Label 19763: @1391624
     /* 1391624 */   GIM_Try, /*On fail goto*//*Label 19764*/ GIMT_Encode4(1391708), // Rule ID 22710 //
     /* 1391629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1391646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1391685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391707 */     // GIR_Coverage, 22710,
     /* 1391707 */     GIR_EraseRootFromParent_Done,
     /* 1391708 */   // Label 19764: @1391708
     /* 1391708 */   GIM_Try, /*On fail goto*//*Label 19765*/ GIMT_Encode4(1391792), // Rule ID 22711 //
     /* 1391713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1391730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391766 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1391769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1391787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391791 */     // GIR_Coverage, 22711,
     /* 1391791 */     GIR_EraseRootFromParent_Done,
     /* 1391792 */   // Label 19765: @1391792
     /* 1391792 */   GIM_Try, /*On fail goto*//*Label 19766*/ GIMT_Encode4(1391876), // Rule ID 22714 //
     /* 1391797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1391814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1391853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391875 */     // GIR_Coverage, 22714,
     /* 1391875 */     GIR_EraseRootFromParent_Done,
     /* 1391876 */   // Label 19766: @1391876
     /* 1391876 */   GIM_Try, /*On fail goto*//*Label 19767*/ GIMT_Encode4(1391960), // Rule ID 22715 //
     /* 1391881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1391884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1391898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1391937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391959 */     // GIR_Coverage, 22715,
     /* 1391959 */     GIR_EraseRootFromParent_Done,
     /* 1391960 */   // Label 19767: @1391960
     /* 1391960 */   GIM_Try, /*On fail goto*//*Label 19768*/ GIMT_Encode4(1392044), // Rule ID 22718 //
     /* 1391965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1391968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1391973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1391982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1391988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1392021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392043 */     // GIR_Coverage, 22718,
     /* 1392043 */     GIR_EraseRootFromParent_Done,
     /* 1392044 */   // Label 19768: @1392044
     /* 1392044 */   GIM_Try, /*On fail goto*//*Label 19769*/ GIMT_Encode4(1392128), // Rule ID 22719 //
     /* 1392049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1392066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392102 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1392105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392127 */     // GIR_Coverage, 22719,
     /* 1392127 */     GIR_EraseRootFromParent_Done,
     /* 1392128 */   // Label 19769: @1392128
     /* 1392128 */   GIM_Try, /*On fail goto*//*Label 19770*/ GIMT_Encode4(1392212), // Rule ID 22722 //
     /* 1392133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392186 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1392189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392211 */     // GIR_Coverage, 22722,
     /* 1392211 */     GIR_EraseRootFromParent_Done,
     /* 1392212 */   // Label 19770: @1392212
     /* 1392212 */   GIM_Try, /*On fail goto*//*Label 19771*/ GIMT_Encode4(1392296), // Rule ID 22723 //
     /* 1392217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1392234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392270 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1392273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392295 */     // GIR_Coverage, 22723,
     /* 1392295 */     GIR_EraseRootFromParent_Done,
     /* 1392296 */   // Label 19771: @1392296
     /* 1392296 */   GIM_Try, /*On fail goto*//*Label 19772*/ GIMT_Encode4(1392380), // Rule ID 22726 //
     /* 1392301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392354 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1392357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392379 */     // GIR_Coverage, 22726,
     /* 1392379 */     GIR_EraseRootFromParent_Done,
     /* 1392380 */   // Label 19772: @1392380
     /* 1392380 */   GIM_Try, /*On fail goto*//*Label 19773*/ GIMT_Encode4(1392464), // Rule ID 22727 //
     /* 1392385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1392402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392438 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1392441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392463 */     // GIR_Coverage, 22727,
     /* 1392463 */     GIR_EraseRootFromParent_Done,
     /* 1392464 */   // Label 19773: @1392464
     /* 1392464 */   GIM_Try, /*On fail goto*//*Label 19774*/ GIMT_Encode4(1392548), // Rule ID 22730 //
     /* 1392469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1392486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1392492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392522 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1392525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392547 */     // GIR_Coverage, 22730,
     /* 1392547 */     GIR_EraseRootFromParent_Done,
     /* 1392548 */   // Label 19774: @1392548
     /* 1392548 */   GIM_Try, /*On fail goto*//*Label 19775*/ GIMT_Encode4(1392632), // Rule ID 22731 //
     /* 1392553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1392570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1392576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11664:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1392609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1392627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392631 */     // GIR_Coverage, 22731,
     /* 1392631 */     GIR_EraseRootFromParent_Done,
     /* 1392632 */   // Label 19775: @1392632
     /* 1392632 */   GIM_Try, /*On fail goto*//*Label 19776*/ GIMT_Encode4(1392716), // Rule ID 22734 //
     /* 1392637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1392654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1392693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392715 */     // GIR_Coverage, 22734,
     /* 1392715 */     GIR_EraseRootFromParent_Done,
     /* 1392716 */   // Label 19776: @1392716
     /* 1392716 */   GIM_Try, /*On fail goto*//*Label 19777*/ GIMT_Encode4(1392800), // Rule ID 22735 //
     /* 1392721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1392738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1392777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392799 */     // GIR_Coverage, 22735,
     /* 1392799 */     GIR_EraseRootFromParent_Done,
     /* 1392800 */   // Label 19777: @1392800
     /* 1392800 */   GIM_Try, /*On fail goto*//*Label 19778*/ GIMT_Encode4(1392884), // Rule ID 22738 //
     /* 1392805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1392822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1392861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392883 */     // GIR_Coverage, 22738,
     /* 1392883 */     GIR_EraseRootFromParent_Done,
     /* 1392884 */   // Label 19778: @1392884
     /* 1392884 */   GIM_Try, /*On fail goto*//*Label 19779*/ GIMT_Encode4(1392968), // Rule ID 22739 //
     /* 1392889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1392892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1392906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392942 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1392945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392967 */     // GIR_Coverage, 22739,
     /* 1392967 */     GIR_EraseRootFromParent_Done,
     /* 1392968 */   // Label 19779: @1392968
     /* 1392968 */   GIM_Try, /*On fail goto*//*Label 19780*/ GIMT_Encode4(1393052), // Rule ID 22742 //
     /* 1392973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1392976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1392981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1392990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1392996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1393029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393051 */     // GIR_Coverage, 22742,
     /* 1393051 */     GIR_EraseRootFromParent_Done,
     /* 1393052 */   // Label 19780: @1393052
     /* 1393052 */   GIM_Try, /*On fail goto*//*Label 19781*/ GIMT_Encode4(1393136), // Rule ID 22743 //
     /* 1393057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11664:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1393113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393135 */     // GIR_Coverage, 22743,
     /* 1393135 */     GIR_EraseRootFromParent_Done,
     /* 1393136 */   // Label 19781: @1393136
     /* 1393136 */   GIM_Try, /*On fail goto*//*Label 19782*/ GIMT_Encode4(1393220), // Rule ID 22746 //
     /* 1393141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1393197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393219 */     // GIR_Coverage, 22746,
     /* 1393219 */     GIR_EraseRootFromParent_Done,
     /* 1393220 */   // Label 19782: @1393220
     /* 1393220 */   GIM_Try, /*On fail goto*//*Label 19783*/ GIMT_Encode4(1393304), // Rule ID 22747 //
     /* 1393225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1393242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393278 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1393281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393303 */     // GIR_Coverage, 22747,
     /* 1393303 */     GIR_EraseRootFromParent_Done,
     /* 1393304 */   // Label 19783: @1393304
     /* 1393304 */   GIM_Try, /*On fail goto*//*Label 19784*/ GIMT_Encode4(1393388), // Rule ID 22750 //
     /* 1393309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1393365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393387 */     // GIR_Coverage, 22750,
     /* 1393387 */     GIR_EraseRootFromParent_Done,
     /* 1393388 */   // Label 19784: @1393388
     /* 1393388 */   GIM_Try, /*On fail goto*//*Label 19785*/ GIMT_Encode4(1393472), // Rule ID 22751 //
     /* 1393393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1393410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1393449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393471 */     // GIR_Coverage, 22751,
     /* 1393471 */     GIR_EraseRootFromParent_Done,
     /* 1393472 */   // Label 19785: @1393472
     /* 1393472 */   GIM_Try, /*On fail goto*//*Label 19786*/ GIMT_Encode4(1393556), // Rule ID 22754 //
     /* 1393477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1393494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1393533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393555 */     // GIR_Coverage, 22754,
     /* 1393555 */     GIR_EraseRootFromParent_Done,
     /* 1393556 */   // Label 19786: @1393556
     /* 1393556 */   GIM_Try, /*On fail goto*//*Label 19787*/ GIMT_Encode4(1393640), // Rule ID 22755 //
     /* 1393561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1393569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1393578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393614 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11664:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1393617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393639 */     // GIR_Coverage, 22755,
     /* 1393639 */     GIR_EraseRootFromParent_Done,
     /* 1393640 */   // Label 19787: @1393640
     /* 1393640 */   GIM_Try, /*On fail goto*//*Label 19788*/ GIMT_Encode4(1393724), // Rule ID 22758 //
     /* 1393645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1393662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1393668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1393701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393723 */     // GIR_Coverage, 22758,
     /* 1393723 */     GIR_EraseRootFromParent_Done,
     /* 1393724 */   // Label 19788: @1393724
     /* 1393724 */   GIM_Try, /*On fail goto*//*Label 19789*/ GIMT_Encode4(1393808), // Rule ID 22759 //
     /* 1393729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1393746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1393752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1393785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393807 */     // GIR_Coverage, 22759,
     /* 1393807 */     GIR_EraseRootFromParent_Done,
     /* 1393808 */   // Label 19789: @1393808
     /* 1393808 */   GIM_Try, /*On fail goto*//*Label 19790*/ GIMT_Encode4(1393892), // Rule ID 22762 //
     /* 1393813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1393830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1393836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1393869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393891 */     // GIR_Coverage, 22762,
     /* 1393891 */     GIR_EraseRootFromParent_Done,
     /* 1393892 */   // Label 19790: @1393892
     /* 1393892 */   GIM_Try, /*On fail goto*//*Label 19791*/ GIMT_Encode4(1393976), // Rule ID 22763 //
     /* 1393897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1393900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1393914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1393920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1393953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1393971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393975 */     // GIR_Coverage, 22763,
     /* 1393975 */     GIR_EraseRootFromParent_Done,
     /* 1393976 */   // Label 19791: @1393976
     /* 1393976 */   GIM_Try, /*On fail goto*//*Label 19792*/ GIMT_Encode4(1394060), // Rule ID 22766 //
     /* 1393981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1393984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1393989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1393998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1394037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394059 */     // GIR_Coverage, 22766,
     /* 1394059 */     GIR_EraseRootFromParent_Done,
     /* 1394060 */   // Label 19792: @1394060
     /* 1394060 */   GIM_Try, /*On fail goto*//*Label 19793*/ GIMT_Encode4(1394144), // Rule ID 22767 //
     /* 1394065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1394082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1394121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394143 */     // GIR_Coverage, 22767,
     /* 1394143 */     GIR_EraseRootFromParent_Done,
     /* 1394144 */   // Label 19793: @1394144
     /* 1394144 */   GIM_Try, /*On fail goto*//*Label 19794*/ GIMT_Encode4(1394228), // Rule ID 22770 //
     /* 1394149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394202 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1394205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394227 */     // GIR_Coverage, 22770,
     /* 1394227 */     GIR_EraseRootFromParent_Done,
     /* 1394228 */   // Label 19794: @1394228
     /* 1394228 */   GIM_Try, /*On fail goto*//*Label 19795*/ GIMT_Encode4(1394312), // Rule ID 22771 //
     /* 1394233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1394250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1394289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394311 */     // GIR_Coverage, 22771,
     /* 1394311 */     GIR_EraseRootFromParent_Done,
     /* 1394312 */   // Label 19795: @1394312
     /* 1394312 */   GIM_Try, /*On fail goto*//*Label 19796*/ GIMT_Encode4(1394396), // Rule ID 22774 //
     /* 1394317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394370 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1394373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394395 */     // GIR_Coverage, 22774,
     /* 1394395 */     GIR_EraseRootFromParent_Done,
     /* 1394396 */   // Label 19796: @1394396
     /* 1394396 */   GIM_Try, /*On fail goto*//*Label 19797*/ GIMT_Encode4(1394480), // Rule ID 22775 //
     /* 1394401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1394418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394454 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1394457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394479 */     // GIR_Coverage, 22775,
     /* 1394479 */     GIR_EraseRootFromParent_Done,
     /* 1394480 */   // Label 19797: @1394480
     /* 1394480 */   GIM_Try, /*On fail goto*//*Label 19798*/ GIMT_Encode4(1394564), // Rule ID 22778 //
     /* 1394485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1394502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1394541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394563 */     // GIR_Coverage, 22778,
     /* 1394563 */     GIR_EraseRootFromParent_Done,
     /* 1394564 */   // Label 19798: @1394564
     /* 1394564 */   GIM_Try, /*On fail goto*//*Label 19799*/ GIMT_Encode4(1394648), // Rule ID 22779 //
     /* 1394569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1394586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1394592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1394625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394647 */     // GIR_Coverage, 22779,
     /* 1394647 */     GIR_EraseRootFromParent_Done,
     /* 1394648 */   // Label 19799: @1394648
     /* 1394648 */   GIM_Try, /*On fail goto*//*Label 19800*/ GIMT_Encode4(1394732), // Rule ID 22782 //
     /* 1394653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1394670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1394709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394731 */     // GIR_Coverage, 22782,
     /* 1394731 */     GIR_EraseRootFromParent_Done,
     /* 1394732 */   // Label 19800: @1394732
     /* 1394732 */   GIM_Try, /*On fail goto*//*Label 19801*/ GIMT_Encode4(1394816), // Rule ID 22783 //
     /* 1394737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1394754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1394793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1394811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394815 */     // GIR_Coverage, 22783,
     /* 1394815 */     GIR_EraseRootFromParent_Done,
     /* 1394816 */   // Label 19801: @1394816
     /* 1394816 */   GIM_Try, /*On fail goto*//*Label 19802*/ GIMT_Encode4(1394900), // Rule ID 22786 //
     /* 1394821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1394838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394874 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1394877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394899 */     // GIR_Coverage, 22786,
     /* 1394899 */     GIR_EraseRootFromParent_Done,
     /* 1394900 */   // Label 19802: @1394900
     /* 1394900 */   GIM_Try, /*On fail goto*//*Label 19803*/ GIMT_Encode4(1394984), // Rule ID 22787 //
     /* 1394905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1394908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1394922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1394961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394983 */     // GIR_Coverage, 22787,
     /* 1394983 */     GIR_EraseRootFromParent_Done,
     /* 1394984 */   // Label 19803: @1394984
     /* 1394984 */   GIM_Try, /*On fail goto*//*Label 19804*/ GIMT_Encode4(1395068), // Rule ID 22790 //
     /* 1394989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1394992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1394997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395042 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1395045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395067 */     // GIR_Coverage, 22790,
     /* 1395067 */     GIR_EraseRootFromParent_Done,
     /* 1395068 */   // Label 19804: @1395068
     /* 1395068 */   GIM_Try, /*On fail goto*//*Label 19805*/ GIMT_Encode4(1395152), // Rule ID 22791 //
     /* 1395073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1395090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1395129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1395147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395151 */     // GIR_Coverage, 22791,
     /* 1395151 */     GIR_EraseRootFromParent_Done,
     /* 1395152 */   // Label 19805: @1395152
     /* 1395152 */   GIM_Try, /*On fail goto*//*Label 19806*/ GIMT_Encode4(1395236), // Rule ID 22794 //
     /* 1395157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1395174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395210 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1395213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395235 */     // GIR_Coverage, 22794,
     /* 1395235 */     GIR_EraseRootFromParent_Done,
     /* 1395236 */   // Label 19806: @1395236
     /* 1395236 */   GIM_Try, /*On fail goto*//*Label 19807*/ GIMT_Encode4(1395320), // Rule ID 22795 //
     /* 1395241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1395258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395294 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1395297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395319 */     // GIR_Coverage, 22795,
     /* 1395319 */     GIR_EraseRootFromParent_Done,
     /* 1395320 */   // Label 19807: @1395320
     /* 1395320 */   GIM_Try, /*On fail goto*//*Label 19808*/ GIMT_Encode4(1395404), // Rule ID 22798 //
     /* 1395325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1395342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395378 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1395381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395403 */     // GIR_Coverage, 22798,
     /* 1395403 */     GIR_EraseRootFromParent_Done,
     /* 1395404 */   // Label 19808: @1395404
     /* 1395404 */   GIM_Try, /*On fail goto*//*Label 19809*/ GIMT_Encode4(1395488), // Rule ID 22799 //
     /* 1395409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1395426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1395432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395462 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1395465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395487 */     // GIR_Coverage, 22799,
     /* 1395487 */     GIR_EraseRootFromParent_Done,
     /* 1395488 */   // Label 19809: @1395488
     /* 1395488 */   GIM_Try, /*On fail goto*//*Label 19810*/ GIMT_Encode4(1395572), // Rule ID 22802 //
     /* 1395493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1395510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1395516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1395549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395571 */     // GIR_Coverage, 22802,
     /* 1395571 */     GIR_EraseRootFromParent_Done,
     /* 1395572 */   // Label 19810: @1395572
     /* 1395572 */   GIM_Try, /*On fail goto*//*Label 19811*/ GIMT_Encode4(1395656), // Rule ID 22803 //
     /* 1395577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1395588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1395591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1395594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1395597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1395600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11662:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1395633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395655 */     // GIR_Coverage, 22803,
     /* 1395655 */     GIR_EraseRootFromParent_Done,
     /* 1395656 */   // Label 19811: @1395656
     /* 1395656 */   GIM_Try, /*On fail goto*//*Label 19812*/ GIMT_Encode4(1395740), // Rule ID 22806 //
     /* 1395661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1395678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395714 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1395717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395739 */     // GIR_Coverage, 22806,
     /* 1395739 */     GIR_EraseRootFromParent_Done,
     /* 1395740 */   // Label 19812: @1395740
     /* 1395740 */   GIM_Try, /*On fail goto*//*Label 19813*/ GIMT_Encode4(1395824), // Rule ID 22807 //
     /* 1395745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1395762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1395783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1395801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395823 */     // GIR_Coverage, 22807,
     /* 1395823 */     GIR_EraseRootFromParent_Done,
     /* 1395824 */   // Label 19813: @1395824
     /* 1395824 */   GIM_Try, /*On fail goto*//*Label 19814*/ GIMT_Encode4(1395908), // Rule ID 22810 //
     /* 1395829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1395846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395882 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1395885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395907 */     // GIR_Coverage, 22810,
     /* 1395907 */     GIR_EraseRootFromParent_Done,
     /* 1395908 */   // Label 19814: @1395908
     /* 1395908 */   GIM_Try, /*On fail goto*//*Label 19815*/ GIMT_Encode4(1395992), // Rule ID 22811 //
     /* 1395913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1395921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1395924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1395927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1395930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1395933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1395936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1395951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1395969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395991 */     // GIR_Coverage, 22811,
     /* 1395991 */     GIR_EraseRootFromParent_Done,
     /* 1395992 */   // Label 19815: @1395992
     /* 1395992 */   GIM_Try, /*On fail goto*//*Label 19816*/ GIMT_Encode4(1396076), // Rule ID 22814 //
     /* 1395997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1396053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396075 */     // GIR_Coverage, 22814,
     /* 1396075 */     GIR_EraseRootFromParent_Done,
     /* 1396076 */   // Label 19816: @1396076
     /* 1396076 */   GIM_Try, /*On fail goto*//*Label 19817*/ GIMT_Encode4(1396160), // Rule ID 22815 //
     /* 1396081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1396098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1396101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1396104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11662:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1396137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396159 */     // GIR_Coverage, 22815,
     /* 1396159 */     GIR_EraseRootFromParent_Done,
     /* 1396160 */   // Label 19817: @1396160
     /* 1396160 */   GIM_Try, /*On fail goto*//*Label 19818*/ GIMT_Encode4(1396244), // Rule ID 22818 //
     /* 1396165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396218 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1396221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396243 */     // GIR_Coverage, 22818,
     /* 1396243 */     GIR_EraseRootFromParent_Done,
     /* 1396244 */   // Label 19818: @1396244
     /* 1396244 */   GIM_Try, /*On fail goto*//*Label 19819*/ GIMT_Encode4(1396328), // Rule ID 22819 //
     /* 1396249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1396266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396302 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1396305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396327 */     // GIR_Coverage, 22819,
     /* 1396327 */     GIR_EraseRootFromParent_Done,
     /* 1396328 */   // Label 19819: @1396328
     /* 1396328 */   GIM_Try, /*On fail goto*//*Label 19820*/ GIMT_Encode4(1396412), // Rule ID 22822 //
     /* 1396333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396386 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1396389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396411 */     // GIR_Coverage, 22822,
     /* 1396411 */     GIR_EraseRootFromParent_Done,
     /* 1396412 */   // Label 19820: @1396412
     /* 1396412 */   GIM_Try, /*On fail goto*//*Label 19821*/ GIMT_Encode4(1396496), // Rule ID 22823 //
     /* 1396417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1396434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1396455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1396473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396495 */     // GIR_Coverage, 22823,
     /* 1396495 */     GIR_EraseRootFromParent_Done,
     /* 1396496 */   // Label 19821: @1396496
     /* 1396496 */   GIM_Try, /*On fail goto*//*Label 19822*/ GIMT_Encode4(1396580), // Rule ID 22826 //
     /* 1396501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1396518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396554 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1396557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396579 */     // GIR_Coverage, 22826,
     /* 1396579 */     GIR_EraseRootFromParent_Done,
     /* 1396580 */   // Label 19822: @1396580
     /* 1396580 */   GIM_Try, /*On fail goto*//*Label 19823*/ GIMT_Encode4(1396664), // Rule ID 22827 //
     /* 1396585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1396593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1396602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1396605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1396623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396638 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11662:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1396641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396663 */     // GIR_Coverage, 22827,
     /* 1396663 */     GIR_EraseRootFromParent_Done,
     /* 1396664 */   // Label 19823: @1396664
     /* 1396664 */   GIM_Try, /*On fail goto*//*Label 19824*/ GIMT_Encode4(1396748), // Rule ID 22946 //
     /* 1396669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1396672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1396686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396722 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1396725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396747 */     // GIR_Coverage, 22946,
     /* 1396747 */     GIR_EraseRootFromParent_Done,
     /* 1396748 */   // Label 19824: @1396748
     /* 1396748 */   GIM_Try, /*On fail goto*//*Label 19825*/ GIMT_Encode4(1396832), // Rule ID 22947 //
     /* 1396753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1396756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1396770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396806 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1396809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396831 */     // GIR_Coverage, 22947,
     /* 1396831 */     GIR_EraseRootFromParent_Done,
     /* 1396832 */   // Label 19825: @1396832
     /* 1396832 */   GIM_Try, /*On fail goto*//*Label 19826*/ GIMT_Encode4(1396916), // Rule ID 22950 //
     /* 1396837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1396840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1396854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396890 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1396890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1396893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396915 */     // GIR_Coverage, 22950,
     /* 1396915 */     GIR_EraseRootFromParent_Done,
     /* 1396916 */   // Label 19826: @1396916
     /* 1396916 */   GIM_Try, /*On fail goto*//*Label 19827*/ GIMT_Encode4(1397000), // Rule ID 22951 //
     /* 1396921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1396924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1396929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1396938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1396941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396974 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1396974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1396977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1396981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1396985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1396998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396999 */     // GIR_Coverage, 22951,
     /* 1396999 */     GIR_EraseRootFromParent_Done,
     /* 1397000 */   // Label 19827: @1397000
     /* 1397000 */   GIM_Try, /*On fail goto*//*Label 19828*/ GIMT_Encode4(1397084), // Rule ID 22954 //
     /* 1397005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397058 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1397061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397083 */     // GIR_Coverage, 22954,
     /* 1397083 */     GIR_EraseRootFromParent_Done,
     /* 1397084 */   // Label 19828: @1397084
     /* 1397084 */   GIM_Try, /*On fail goto*//*Label 19829*/ GIMT_Encode4(1397168), // Rule ID 22955 //
     /* 1397089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1397106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1397145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397167 */     // GIR_Coverage, 22955,
     /* 1397167 */     GIR_EraseRootFromParent_Done,
     /* 1397168 */   // Label 19829: @1397168
     /* 1397168 */   GIM_Try, /*On fail goto*//*Label 19830*/ GIMT_Encode4(1397252), // Rule ID 22958 //
     /* 1397173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397226 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1397229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397251 */     // GIR_Coverage, 22958,
     /* 1397251 */     GIR_EraseRootFromParent_Done,
     /* 1397252 */   // Label 19830: @1397252
     /* 1397252 */   GIM_Try, /*On fail goto*//*Label 19831*/ GIMT_Encode4(1397336), // Rule ID 22959 //
     /* 1397257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1397274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397310 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1397313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397335 */     // GIR_Coverage, 22959,
     /* 1397335 */     GIR_EraseRootFromParent_Done,
     /* 1397336 */   // Label 19831: @1397336
     /* 1397336 */   GIM_Try, /*On fail goto*//*Label 19832*/ GIMT_Encode4(1397420), // Rule ID 22962 //
     /* 1397341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1397344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397394 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1397397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397419 */     // GIR_Coverage, 22962,
     /* 1397419 */     GIR_EraseRootFromParent_Done,
     /* 1397420 */   // Label 19832: @1397420
     /* 1397420 */   GIM_Try, /*On fail goto*//*Label 19833*/ GIMT_Encode4(1397504), // Rule ID 22963 //
     /* 1397425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1397428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1397436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1397439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1397442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1397445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1397448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397478 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1397481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397503 */     // GIR_Coverage, 22963,
     /* 1397503 */     GIR_EraseRootFromParent_Done,
     /* 1397504 */   // Label 19833: @1397504
     /* 1397504 */   GIM_Try, /*On fail goto*//*Label 19834*/ GIMT_Encode4(1397588), // Rule ID 22966 //
     /* 1397509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1397512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1397526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397562 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1397565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1397583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397587 */     // GIR_Coverage, 22966,
     /* 1397587 */     GIR_EraseRootFromParent_Done,
     /* 1397588 */   // Label 19834: @1397588
     /* 1397588 */   GIM_Try, /*On fail goto*//*Label 19835*/ GIMT_Encode4(1397672), // Rule ID 22967 //
     /* 1397593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1397596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1397604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1397607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1397610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1397613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1397616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397646 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1397649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1397667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397671 */     // GIR_Coverage, 22967,
     /* 1397671 */     GIR_EraseRootFromParent_Done,
     /* 1397672 */   // Label 19835: @1397672
     /* 1397672 */   GIM_Try, /*On fail goto*//*Label 19836*/ GIMT_Encode4(1397756), // Rule ID 22970 //
     /* 1397677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1397694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397730 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1397733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397755 */     // GIR_Coverage, 22970,
     /* 1397755 */     GIR_EraseRootFromParent_Done,
     /* 1397756 */   // Label 19836: @1397756
     /* 1397756 */   GIM_Try, /*On fail goto*//*Label 19837*/ GIMT_Encode4(1397840), // Rule ID 22971 //
     /* 1397761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1397778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397814 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1397817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397839 */     // GIR_Coverage, 22971,
     /* 1397839 */     GIR_EraseRootFromParent_Done,
     /* 1397840 */   // Label 19837: @1397840
     /* 1397840 */   GIM_Try, /*On fail goto*//*Label 19838*/ GIMT_Encode4(1397924), // Rule ID 22974 //
     /* 1397845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1397848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1397862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397898 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1397898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1397901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1397922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397923 */     // GIR_Coverage, 22974,
     /* 1397923 */     GIR_EraseRootFromParent_Done,
     /* 1397924 */   // Label 19838: @1397924
     /* 1397924 */   GIM_Try, /*On fail goto*//*Label 19839*/ GIMT_Encode4(1398008), // Rule ID 22975 //
     /* 1397929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1397932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1397937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1397940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1397943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1397946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1397949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1397959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1397971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397982 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1397982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1397985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1397989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1397993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398007 */     // GIR_Coverage, 22975,
     /* 1398007 */     GIR_EraseRootFromParent_Done,
     /* 1398008 */   // Label 19839: @1398008
     /* 1398008 */   GIM_Try, /*On fail goto*//*Label 19840*/ GIMT_Encode4(1398092), // Rule ID 22978 //
     /* 1398013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1398016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398066 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1398069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398091 */     // GIR_Coverage, 22978,
     /* 1398091 */     GIR_EraseRootFromParent_Done,
     /* 1398092 */   // Label 19840: @1398092
     /* 1398092 */   GIM_Try, /*On fail goto*//*Label 19841*/ GIMT_Encode4(1398176), // Rule ID 22979 //
     /* 1398097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1398100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1398108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1398111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1398114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1398117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1398120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398150 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11256:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1398153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398175 */     // GIR_Coverage, 22979,
     /* 1398175 */     GIR_EraseRootFromParent_Done,
     /* 1398176 */   // Label 19841: @1398176
     /* 1398176 */   GIM_Try, /*On fail goto*//*Label 19842*/ GIMT_Encode4(1398260), // Rule ID 22982 //
     /* 1398181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398234 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1398237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398259 */     // GIR_Coverage, 22982,
     /* 1398259 */     GIR_EraseRootFromParent_Done,
     /* 1398260 */   // Label 19842: @1398260
     /* 1398260 */   GIM_Try, /*On fail goto*//*Label 19843*/ GIMT_Encode4(1398344), // Rule ID 22983 //
     /* 1398265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1398282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398318 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1398321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398343 */     // GIR_Coverage, 22983,
     /* 1398343 */     GIR_EraseRootFromParent_Done,
     /* 1398344 */   // Label 19843: @1398344
     /* 1398344 */   GIM_Try, /*On fail goto*//*Label 19844*/ GIMT_Encode4(1398428), // Rule ID 22986 //
     /* 1398349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398402 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1398405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398427 */     // GIR_Coverage, 22986,
     /* 1398427 */     GIR_EraseRootFromParent_Done,
     /* 1398428 */   // Label 19844: @1398428
     /* 1398428 */   GIM_Try, /*On fail goto*//*Label 19845*/ GIMT_Encode4(1398512), // Rule ID 22987 //
     /* 1398433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398486 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1398489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398511 */     // GIR_Coverage, 22987,
     /* 1398511 */     GIR_EraseRootFromParent_Done,
     /* 1398512 */   // Label 19845: @1398512
     /* 1398512 */   GIM_Try, /*On fail goto*//*Label 19846*/ GIMT_Encode4(1398596), // Rule ID 22990 //
     /* 1398517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1398520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1398534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398570 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1398573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398595 */     // GIR_Coverage, 22990,
     /* 1398595 */     GIR_EraseRootFromParent_Done,
     /* 1398596 */   // Label 19846: @1398596
     /* 1398596 */   GIM_Try, /*On fail goto*//*Label 19847*/ GIMT_Encode4(1398680), // Rule ID 22991 //
     /* 1398601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1398604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1398612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1398615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1398618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1398621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398654 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11256:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1398657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398679 */     // GIR_Coverage, 22991,
     /* 1398679 */     GIR_EraseRootFromParent_Done,
     /* 1398680 */   // Label 19847: @1398680
     /* 1398680 */   GIM_Try, /*On fail goto*//*Label 19848*/ GIMT_Encode4(1398764), // Rule ID 22994 //
     /* 1398685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1398688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1398702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398738 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1398741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398763 */     // GIR_Coverage, 22994,
     /* 1398763 */     GIR_EraseRootFromParent_Done,
     /* 1398764 */   // Label 19848: @1398764
     /* 1398764 */   GIM_Try, /*On fail goto*//*Label 19849*/ GIMT_Encode4(1398848), // Rule ID 22995 //
     /* 1398769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1398772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1398786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398822 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1398825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398847 */     // GIR_Coverage, 22995,
     /* 1398847 */     GIR_EraseRootFromParent_Done,
     /* 1398848 */   // Label 19849: @1398848
     /* 1398848 */   GIM_Try, /*On fail goto*//*Label 19850*/ GIMT_Encode4(1398932), // Rule ID 22998 //
     /* 1398853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1398856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1398870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398906 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1398906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1398909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1398917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1398930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398931 */     // GIR_Coverage, 22998,
     /* 1398931 */     GIR_EraseRootFromParent_Done,
     /* 1398932 */   // Label 19850: @1398932
     /* 1398932 */   GIM_Try, /*On fail goto*//*Label 19851*/ GIMT_Encode4(1399016), // Rule ID 22999 //
     /* 1398937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1398940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1398945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1398948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1398951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1398954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1398957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398990 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1398990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1398993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1398997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399015 */     // GIR_Coverage, 22999,
     /* 1399015 */     GIR_EraseRootFromParent_Done,
     /* 1399016 */   // Label 19851: @1399016
     /* 1399016 */   GIM_Try, /*On fail goto*//*Label 19852*/ GIMT_Encode4(1399100), // Rule ID 23002 //
     /* 1399021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1399024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399074 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1399077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399099 */     // GIR_Coverage, 23002,
     /* 1399099 */     GIR_EraseRootFromParent_Done,
     /* 1399100 */   // Label 19852: @1399100
     /* 1399100 */   GIM_Try, /*On fail goto*//*Label 19853*/ GIMT_Encode4(1399184), // Rule ID 23003 //
     /* 1399105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1399108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1399113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1399122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1399125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1399128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1399143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399158 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11256:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1399161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399183 */     // GIR_Coverage, 23003,
     /* 1399183 */     GIR_EraseRootFromParent_Done,
     /* 1399184 */   // Label 19853: @1399184
     /* 1399184 */   GIM_Try, /*On fail goto*//*Label 19854*/ GIMT_Encode4(1399268), // Rule ID 23006 //
     /* 1399189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1399206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399242 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1399245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399267 */     // GIR_Coverage, 23006,
     /* 1399267 */     GIR_EraseRootFromParent_Done,
     /* 1399268 */   // Label 19854: @1399268
     /* 1399268 */   GIM_Try, /*On fail goto*//*Label 19855*/ GIMT_Encode4(1399352), // Rule ID 23007 //
     /* 1399273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1399290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399326 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1399329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399351 */     // GIR_Coverage, 23007,
     /* 1399351 */     GIR_EraseRootFromParent_Done,
     /* 1399352 */   // Label 19855: @1399352
     /* 1399352 */   GIM_Try, /*On fail goto*//*Label 19856*/ GIMT_Encode4(1399436), // Rule ID 23010 //
     /* 1399357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399410 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1399413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399435 */     // GIR_Coverage, 23010,
     /* 1399435 */     GIR_EraseRootFromParent_Done,
     /* 1399436 */   // Label 19856: @1399436
     /* 1399436 */   GIM_Try, /*On fail goto*//*Label 19857*/ GIMT_Encode4(1399520), // Rule ID 23011 //
     /* 1399441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399494 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1399497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399519 */     // GIR_Coverage, 23011,
     /* 1399519 */     GIR_EraseRootFromParent_Done,
     /* 1399520 */   // Label 19857: @1399520
     /* 1399520 */   GIM_Try, /*On fail goto*//*Label 19858*/ GIMT_Encode4(1399604), // Rule ID 23014 //
     /* 1399525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1399528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1399542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399578 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1399581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399603 */     // GIR_Coverage, 23014,
     /* 1399603 */     GIR_EraseRootFromParent_Done,
     /* 1399604 */   // Label 19858: @1399604
     /* 1399604 */   GIM_Try, /*On fail goto*//*Label 19859*/ GIMT_Encode4(1399688), // Rule ID 23015 //
     /* 1399609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1399612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1399626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1399632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399662 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1399665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399687 */     // GIR_Coverage, 23015,
     /* 1399687 */     GIR_EraseRootFromParent_Done,
     /* 1399688 */   // Label 19859: @1399688
     /* 1399688 */   GIM_Try, /*On fail goto*//*Label 19860*/ GIMT_Encode4(1399772), // Rule ID 23018 //
     /* 1399693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1399696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1399710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399746 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1399749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399771 */     // GIR_Coverage, 23018,
     /* 1399771 */     GIR_EraseRootFromParent_Done,
     /* 1399772 */   // Label 19860: @1399772
     /* 1399772 */   GIM_Try, /*On fail goto*//*Label 19861*/ GIMT_Encode4(1399856), // Rule ID 23019 //
     /* 1399777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1399780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1399794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1399797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1399800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399830 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1399833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399855 */     // GIR_Coverage, 23019,
     /* 1399855 */     GIR_EraseRootFromParent_Done,
     /* 1399856 */   // Label 19861: @1399856
     /* 1399856 */   GIM_Try, /*On fail goto*//*Label 19862*/ GIMT_Encode4(1399940), // Rule ID 23022 //
     /* 1399861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1399864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1399878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399914 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1399914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1399917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1399921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1399923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1399925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1399927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1399938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399939 */     // GIR_Coverage, 23022,
     /* 1399939 */     GIR_EraseRootFromParent_Done,
     /* 1399940 */   // Label 19862: @1399940
     /* 1399940 */   GIM_Try, /*On fail goto*//*Label 19863*/ GIMT_Encode4(1400024), // Rule ID 23023 //
     /* 1399945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1399948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1399953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1399962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1399965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1399968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399998 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1399998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1400001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400023 */     // GIR_Coverage, 23023,
     /* 1400023 */     GIR_EraseRootFromParent_Done,
     /* 1400024 */   // Label 19863: @1400024
     /* 1400024 */   GIM_Try, /*On fail goto*//*Label 19864*/ GIMT_Encode4(1400108), // Rule ID 23026 //
     /* 1400029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1400032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1400046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400082 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1400085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400107 */     // GIR_Coverage, 23026,
     /* 1400107 */     GIR_EraseRootFromParent_Done,
     /* 1400108 */   // Label 19864: @1400108
     /* 1400108 */   GIM_Try, /*On fail goto*//*Label 19865*/ GIMT_Encode4(1400192), // Rule ID 23027 //
     /* 1400113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1400116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1400124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1400127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1400130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1400133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1400136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400166 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1400169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1400187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400191 */     // GIR_Coverage, 23027,
     /* 1400191 */     GIR_EraseRootFromParent_Done,
     /* 1400192 */   // Label 19865: @1400192
     /* 1400192 */   GIM_Try, /*On fail goto*//*Label 19866*/ GIMT_Encode4(1400276), // Rule ID 23030 //
     /* 1400197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1400214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400250 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1400253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400275 */     // GIR_Coverage, 23030,
     /* 1400275 */     GIR_EraseRootFromParent_Done,
     /* 1400276 */   // Label 19866: @1400276
     /* 1400276 */   GIM_Try, /*On fail goto*//*Label 19867*/ GIMT_Encode4(1400360), // Rule ID 23031 //
     /* 1400281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1400298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400334 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1400337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400359 */     // GIR_Coverage, 23031,
     /* 1400359 */     GIR_EraseRootFromParent_Done,
     /* 1400360 */   // Label 19867: @1400360
     /* 1400360 */   GIM_Try, /*On fail goto*//*Label 19868*/ GIMT_Encode4(1400444), // Rule ID 23034 //
     /* 1400365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400418 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1400421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400443 */     // GIR_Coverage, 23034,
     /* 1400443 */     GIR_EraseRootFromParent_Done,
     /* 1400444 */   // Label 19868: @1400444
     /* 1400444 */   GIM_Try, /*On fail goto*//*Label 19869*/ GIMT_Encode4(1400528), // Rule ID 23035 //
     /* 1400449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1400472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400502 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1400505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400527 */     // GIR_Coverage, 23035,
     /* 1400527 */     GIR_EraseRootFromParent_Done,
     /* 1400528 */   // Label 19869: @1400528
     /* 1400528 */   GIM_Try, /*On fail goto*//*Label 19870*/ GIMT_Encode4(1400612), // Rule ID 23038 //
     /* 1400533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1400536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1400550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1400556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400586 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1400589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400611 */     // GIR_Coverage, 23038,
     /* 1400611 */     GIR_EraseRootFromParent_Done,
     /* 1400612 */   // Label 19870: @1400612
     /* 1400612 */   GIM_Try, /*On fail goto*//*Label 19871*/ GIMT_Encode4(1400696), // Rule ID 23039 //
     /* 1400617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1400620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1400628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1400631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1400634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1400637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1400640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400670 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1400673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400695 */     // GIR_Coverage, 23039,
     /* 1400695 */     GIR_EraseRootFromParent_Done,
     /* 1400696 */   // Label 19871: @1400696
     /* 1400696 */   GIM_Try, /*On fail goto*//*Label 19872*/ GIMT_Encode4(1400780), // Rule ID 23042 //
     /* 1400701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1400704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1400718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400754 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1400757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400779 */     // GIR_Coverage, 23042,
     /* 1400779 */     GIR_EraseRootFromParent_Done,
     /* 1400780 */   // Label 19872: @1400780
     /* 1400780 */   GIM_Try, /*On fail goto*//*Label 19873*/ GIMT_Encode4(1400864), // Rule ID 23043 //
     /* 1400785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1400788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1400802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1400808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400838 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1400838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1400841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400863 */     // GIR_Coverage, 23043,
     /* 1400863 */     GIR_EraseRootFromParent_Done,
     /* 1400864 */   // Label 19873: @1400864
     /* 1400864 */   GIM_Try, /*On fail goto*//*Label 19874*/ GIMT_Encode4(1400948), // Rule ID 23046 //
     /* 1400869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1400872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1400886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400922 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1400922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1400925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1400929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1400931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1400933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1400935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1400946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400947 */     // GIR_Coverage, 23046,
     /* 1400947 */     GIR_EraseRootFromParent_Done,
     /* 1400948 */   // Label 19874: @1400948
     /* 1400948 */   GIM_Try, /*On fail goto*//*Label 19875*/ GIMT_Encode4(1401032), // Rule ID 23047 //
     /* 1400953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1400956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1400961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1400964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1400967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1400970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1400973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1400976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1400983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1400995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401006 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1401009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401031 */     // GIR_Coverage, 23047,
     /* 1401031 */     GIR_EraseRootFromParent_Done,
     /* 1401032 */   // Label 19875: @1401032
     /* 1401032 */   GIM_Try, /*On fail goto*//*Label 19876*/ GIMT_Encode4(1401116), // Rule ID 23050 //
     /* 1401037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1401040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1401054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1401093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401115 */     // GIR_Coverage, 23050,
     /* 1401115 */     GIR_EraseRootFromParent_Done,
     /* 1401116 */   // Label 19876: @1401116
     /* 1401116 */   GIM_Try, /*On fail goto*//*Label 19877*/ GIMT_Encode4(1401200), // Rule ID 23051 //
     /* 1401121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1401124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1401132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1401135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1401138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1401141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1401144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401174 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1401177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401199 */     // GIR_Coverage, 23051,
     /* 1401199 */     GIR_EraseRootFromParent_Done,
     /* 1401200 */   // Label 19877: @1401200
     /* 1401200 */   GIM_Try, /*On fail goto*//*Label 19878*/ GIMT_Encode4(1401284), // Rule ID 23054 //
     /* 1401205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401258 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1401261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401283 */     // GIR_Coverage, 23054,
     /* 1401283 */     GIR_EraseRootFromParent_Done,
     /* 1401284 */   // Label 19878: @1401284
     /* 1401284 */   GIM_Try, /*On fail goto*//*Label 19879*/ GIMT_Encode4(1401368), // Rule ID 23055 //
     /* 1401289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401342 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1401345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401367 */     // GIR_Coverage, 23055,
     /* 1401367 */     GIR_EraseRootFromParent_Done,
     /* 1401368 */   // Label 19879: @1401368
     /* 1401368 */   GIM_Try, /*On fail goto*//*Label 19880*/ GIMT_Encode4(1401452), // Rule ID 23058 //
     /* 1401373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401426 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1401429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401451 */     // GIR_Coverage, 23058,
     /* 1401451 */     GIR_EraseRootFromParent_Done,
     /* 1401452 */   // Label 19880: @1401452
     /* 1401452 */   GIM_Try, /*On fail goto*//*Label 19881*/ GIMT_Encode4(1401536), // Rule ID 23059 //
     /* 1401457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1401480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401510 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1401513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401535 */     // GIR_Coverage, 23059,
     /* 1401535 */     GIR_EraseRootFromParent_Done,
     /* 1401536 */   // Label 19881: @1401536
     /* 1401536 */   GIM_Try, /*On fail goto*//*Label 19882*/ GIMT_Encode4(1401620), // Rule ID 23062 //
     /* 1401541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1401544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1401558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401594 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1401594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1401597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401619 */     // GIR_Coverage, 23062,
     /* 1401619 */     GIR_EraseRootFromParent_Done,
     /* 1401620 */   // Label 19882: @1401620
     /* 1401620 */   GIM_Try, /*On fail goto*//*Label 19883*/ GIMT_Encode4(1401704), // Rule ID 23063 //
     /* 1401625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1401628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1401633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1401636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1401639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1401642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1401645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1401648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401678 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1401678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1401681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1401685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1401689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1401702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401703 */     // GIR_Coverage, 23063,
     /* 1401703 */     GIR_EraseRootFromParent_Done,
     /* 1401704 */   // Label 19883: @1401704
     /* 1401704 */   GIM_Reject,
     /* 1401705 */ // Label 13825: @1401705
     /* 1401705 */ GIM_Try, /*On fail goto*//*Label 19884*/ GIMT_Encode4(2015506),
     /* 1401710 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 1401713 */   GIM_Try, /*On fail goto*//*Label 19885*/ GIMT_Encode4(1401799), // Rule ID 7356 //
     /* 1401718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1401721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1401729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1401732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1401735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1401741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401764 */     // MIs[0] policy
     /* 1401764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401774 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1401777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401798 */     // GIR_Coverage, 7356,
     /* 1401798 */     GIR_EraseRootFromParent_Done,
     /* 1401799 */   // Label 19885: @1401799
     /* 1401799 */   GIM_Try, /*On fail goto*//*Label 19886*/ GIMT_Encode4(1401885), // Rule ID 7357 //
     /* 1401804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1401807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1401815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1401818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1401821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1401824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1401827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401842 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401850 */     // MIs[0] policy
     /* 1401850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1401863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401884 */     // GIR_Coverage, 7357,
     /* 1401884 */     GIR_EraseRootFromParent_Done,
     /* 1401885 */   // Label 19886: @1401885
     /* 1401885 */   GIM_Try, /*On fail goto*//*Label 19887*/ GIMT_Encode4(1401971), // Rule ID 7360 //
     /* 1401890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1401893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1401901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1401904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1401907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1401910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1401932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401936 */     // MIs[0] policy
     /* 1401936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1401949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1401957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1401959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1401967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401970 */     // GIR_Coverage, 7360,
     /* 1401970 */     GIR_EraseRootFromParent_Done,
     /* 1401971 */   // Label 19887: @1401971
     /* 1401971 */   GIM_Try, /*On fail goto*//*Label 19888*/ GIMT_Encode4(1402057), // Rule ID 7361 //
     /* 1401976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1401979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1401984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1401987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1401990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1401993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1401996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1401999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402022 */     // MIs[0] policy
     /* 1402022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402032 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402056 */     // GIR_Coverage, 7361,
     /* 1402056 */     GIR_EraseRootFromParent_Done,
     /* 1402057 */   // Label 19888: @1402057
     /* 1402057 */   GIM_Try, /*On fail goto*//*Label 19889*/ GIMT_Encode4(1402143), // Rule ID 7364 //
     /* 1402062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1402073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1402076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1402079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402108 */     // MIs[0] policy
     /* 1402108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402142 */     // GIR_Coverage, 7364,
     /* 1402142 */     GIR_EraseRootFromParent_Done,
     /* 1402143 */   // Label 19889: @1402143
     /* 1402143 */   GIM_Try, /*On fail goto*//*Label 19890*/ GIMT_Encode4(1402229), // Rule ID 7365 //
     /* 1402148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1402159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1402162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1402165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402186 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402194 */     // MIs[0] policy
     /* 1402194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402204 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402228 */     // GIR_Coverage, 7365,
     /* 1402228 */     GIR_EraseRootFromParent_Done,
     /* 1402229 */   // Label 19890: @1402229
     /* 1402229 */   GIM_Try, /*On fail goto*//*Label 19891*/ GIMT_Encode4(1402315), // Rule ID 7368 //
     /* 1402234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1402245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1402248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1402251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402272 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402280 */     // MIs[0] policy
     /* 1402280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402290 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402314 */     // GIR_Coverage, 7368,
     /* 1402314 */     GIR_EraseRootFromParent_Done,
     /* 1402315 */   // Label 19891: @1402315
     /* 1402315 */   GIM_Try, /*On fail goto*//*Label 19892*/ GIMT_Encode4(1402401), // Rule ID 7369 //
     /* 1402320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1402331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1402334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1402337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402358 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402366 */     // MIs[0] policy
     /* 1402366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1402379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402400 */     // GIR_Coverage, 7369,
     /* 1402400 */     GIR_EraseRootFromParent_Done,
     /* 1402401 */   // Label 19892: @1402401
     /* 1402401 */   GIM_Try, /*On fail goto*//*Label 19893*/ GIMT_Encode4(1402487), // Rule ID 7372 //
     /* 1402406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1402417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1402420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1402423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402452 */     // MIs[0] policy
     /* 1402452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402462 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402486 */     // GIR_Coverage, 7372,
     /* 1402486 */     GIR_EraseRootFromParent_Done,
     /* 1402487 */   // Label 19893: @1402487
     /* 1402487 */   GIM_Try, /*On fail goto*//*Label 19894*/ GIMT_Encode4(1402573), // Rule ID 7373 //
     /* 1402492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1402503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1402506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1402509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1402515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402538 */     // MIs[0] policy
     /* 1402538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402572 */     // GIR_Coverage, 7373,
     /* 1402572 */     GIR_EraseRootFromParent_Done,
     /* 1402573 */   // Label 19894: @1402573
     /* 1402573 */   GIM_Try, /*On fail goto*//*Label 19895*/ GIMT_Encode4(1402659), // Rule ID 7376 //
     /* 1402578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1402589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1402592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1402595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402624 */     // MIs[0] policy
     /* 1402624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402658 */     // GIR_Coverage, 7376,
     /* 1402658 */     GIR_EraseRootFromParent_Done,
     /* 1402659 */   // Label 19895: @1402659
     /* 1402659 */   GIM_Try, /*On fail goto*//*Label 19896*/ GIMT_Encode4(1402745), // Rule ID 7377 //
     /* 1402664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1402675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1402678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1402681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1402687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402702 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402710 */     // MIs[0] policy
     /* 1402710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402720 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1402723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402744 */     // GIR_Coverage, 7377,
     /* 1402744 */     GIR_EraseRootFromParent_Done,
     /* 1402745 */   // Label 19896: @1402745
     /* 1402745 */   GIM_Try, /*On fail goto*//*Label 19897*/ GIMT_Encode4(1402831), // Rule ID 7380 //
     /* 1402750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1402761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1402764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1402767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402796 */     // MIs[0] policy
     /* 1402796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402806 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1402809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402830 */     // GIR_Coverage, 7380,
     /* 1402830 */     GIR_EraseRootFromParent_Done,
     /* 1402831 */   // Label 19897: @1402831
     /* 1402831 */   GIM_Try, /*On fail goto*//*Label 19898*/ GIMT_Encode4(1402917), // Rule ID 7381 //
     /* 1402836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1402839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1402847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1402850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1402853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1402856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1402859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402882 */     // MIs[0] policy
     /* 1402882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402892 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1402895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1402913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402916 */     // GIR_Coverage, 7381,
     /* 1402916 */     GIR_EraseRootFromParent_Done,
     /* 1402917 */   // Label 19898: @1402917
     /* 1402917 */   GIM_Try, /*On fail goto*//*Label 19899*/ GIMT_Encode4(1403003), // Rule ID 7384 //
     /* 1402922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1402925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1402930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1402933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1402936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1402939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1402942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1402945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1402964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402968 */     // MIs[0] policy
     /* 1402968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1402981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1402989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1402991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403002 */     // GIR_Coverage, 7384,
     /* 1403002 */     GIR_EraseRootFromParent_Done,
     /* 1403003 */   // Label 19899: @1403003
     /* 1403003 */   GIM_Try, /*On fail goto*//*Label 19900*/ GIMT_Encode4(1403089), // Rule ID 7385 //
     /* 1403008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1403019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1403022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1403025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1403031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403054 */     // MIs[0] policy
     /* 1403054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403064 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403088 */     // GIR_Coverage, 7385,
     /* 1403088 */     GIR_EraseRootFromParent_Done,
     /* 1403089 */   // Label 19900: @1403089
     /* 1403089 */   GIM_Try, /*On fail goto*//*Label 19901*/ GIMT_Encode4(1403175), // Rule ID 7388 //
     /* 1403094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403140 */     // MIs[0] policy
     /* 1403140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403174 */     // GIR_Coverage, 7388,
     /* 1403174 */     GIR_EraseRootFromParent_Done,
     /* 1403175 */   // Label 19901: @1403175
     /* 1403175 */   GIM_Try, /*On fail goto*//*Label 19902*/ GIMT_Encode4(1403261), // Rule ID 7389 //
     /* 1403180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1403191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1403194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1403197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1403203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403218 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403226 */     // MIs[0] policy
     /* 1403226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403260 */     // GIR_Coverage, 7389,
     /* 1403260 */     GIR_EraseRootFromParent_Done,
     /* 1403261 */   // Label 19902: @1403261
     /* 1403261 */   GIM_Try, /*On fail goto*//*Label 19903*/ GIMT_Encode4(1403347), // Rule ID 7392 //
     /* 1403266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1403269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403312 */     // MIs[0] policy
     /* 1403312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403322 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403346 */     // GIR_Coverage, 7392,
     /* 1403346 */     GIR_EraseRootFromParent_Done,
     /* 1403347 */   // Label 19903: @1403347
     /* 1403347 */   GIM_Try, /*On fail goto*//*Label 19904*/ GIMT_Encode4(1403433), // Rule ID 7393 //
     /* 1403352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1403355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1403363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1403366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1403369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1403375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1403382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1403390 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403398 */     // MIs[0] policy
     /* 1403398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1403411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403432 */     // GIR_Coverage, 7393,
     /* 1403432 */     GIR_EraseRootFromParent_Done,
     /* 1403433 */   // Label 19904: @1403433
     /* 1403433 */   GIM_Try, /*On fail goto*//*Label 19905*/ GIMT_Encode4(1403519), // Rule ID 7396 //
     /* 1403438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1403449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1403452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1403455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1403461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403484 */     // MIs[0] policy
     /* 1403484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1403497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403518 */     // GIR_Coverage, 7396,
     /* 1403518 */     GIR_EraseRootFromParent_Done,
     /* 1403519 */   // Label 19905: @1403519
     /* 1403519 */   GIM_Try, /*On fail goto*//*Label 19906*/ GIMT_Encode4(1403605), // Rule ID 7397 //
     /* 1403524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1403535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1403538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1403541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1403547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403570 */     // MIs[0] policy
     /* 1403570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403580 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1403583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403604 */     // GIR_Coverage, 7397,
     /* 1403604 */     GIR_EraseRootFromParent_Done,
     /* 1403605 */   // Label 19906: @1403605
     /* 1403605 */   GIM_Try, /*On fail goto*//*Label 19907*/ GIMT_Encode4(1403691), // Rule ID 7400 //
     /* 1403610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1403621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1403624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1403627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1403633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1403640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403656 */     // MIs[0] policy
     /* 1403656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403666 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1403669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403690 */     // GIR_Coverage, 7400,
     /* 1403690 */     GIR_EraseRootFromParent_Done,
     /* 1403691 */   // Label 19907: @1403691
     /* 1403691 */   GIM_Try, /*On fail goto*//*Label 19908*/ GIMT_Encode4(1403777), // Rule ID 7401 //
     /* 1403696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1403707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1403710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1403713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1403719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1403726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403742 */     // MIs[0] policy
     /* 1403742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403752 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1403755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403776 */     // GIR_Coverage, 7401,
     /* 1403776 */     GIR_EraseRootFromParent_Done,
     /* 1403777 */   // Label 19908: @1403777
     /* 1403777 */   GIM_Try, /*On fail goto*//*Label 19909*/ GIMT_Encode4(1403863), // Rule ID 7404 //
     /* 1403782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1403793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1403796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1403799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1403805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1403812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403828 */     // MIs[0] policy
     /* 1403828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403838 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1403841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403862 */     // GIR_Coverage, 7404,
     /* 1403862 */     GIR_EraseRootFromParent_Done,
     /* 1403863 */   // Label 19909: @1403863
     /* 1403863 */   GIM_Try, /*On fail goto*//*Label 19910*/ GIMT_Encode4(1403949), // Rule ID 7405 //
     /* 1403868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1403871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1403879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1403882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1403885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1403888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1403891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1403898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403914 */     // MIs[0] policy
     /* 1403914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403924 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1403927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1403935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1403937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1403945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403948 */     // GIR_Coverage, 7405,
     /* 1403948 */     GIR_EraseRootFromParent_Done,
     /* 1403949 */   // Label 19910: @1403949
     /* 1403949 */   GIM_Try, /*On fail goto*//*Label 19911*/ GIMT_Encode4(1404035), // Rule ID 7408 //
     /* 1403954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1403957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1403962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1403965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1403968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1403971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1403974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1403977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1403996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404000 */     // MIs[0] policy
     /* 1404000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404034 */     // GIR_Coverage, 7408,
     /* 1404034 */     GIR_EraseRootFromParent_Done,
     /* 1404035 */   // Label 19911: @1404035
     /* 1404035 */   GIM_Try, /*On fail goto*//*Label 19912*/ GIMT_Encode4(1404121), // Rule ID 7409 //
     /* 1404040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1404051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1404054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404078 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404086 */     // MIs[0] policy
     /* 1404086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404120 */     // GIR_Coverage, 7409,
     /* 1404120 */     GIR_EraseRootFromParent_Done,
     /* 1404121 */   // Label 19912: @1404121
     /* 1404121 */   GIM_Try, /*On fail goto*//*Label 19913*/ GIMT_Encode4(1404207), // Rule ID 7412 //
     /* 1404126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404172 */     // MIs[0] policy
     /* 1404172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404206 */     // GIR_Coverage, 7412,
     /* 1404206 */     GIR_EraseRootFromParent_Done,
     /* 1404207 */   // Label 19913: @1404207
     /* 1404207 */   GIM_Try, /*On fail goto*//*Label 19914*/ GIMT_Encode4(1404293), // Rule ID 7413 //
     /* 1404212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1404223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1404226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404258 */     // MIs[0] policy
     /* 1404258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404268 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404292 */     // GIR_Coverage, 7413,
     /* 1404292 */     GIR_EraseRootFromParent_Done,
     /* 1404293 */   // Label 19914: @1404293
     /* 1404293 */   GIM_Try, /*On fail goto*//*Label 19915*/ GIMT_Encode4(1404379), // Rule ID 7416 //
     /* 1404298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404344 */     // MIs[0] policy
     /* 1404344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404354 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404378 */     // GIR_Coverage, 7416,
     /* 1404378 */     GIR_EraseRootFromParent_Done,
     /* 1404379 */   // Label 19915: @1404379
     /* 1404379 */   GIM_Try, /*On fail goto*//*Label 19916*/ GIMT_Encode4(1404465), // Rule ID 7417 //
     /* 1404384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1404395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1404398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1404401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1404407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404430 */     // MIs[0] policy
     /* 1404430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404440 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404464 */     // GIR_Coverage, 7417,
     /* 1404464 */     GIR_EraseRootFromParent_Done,
     /* 1404465 */   // Label 19916: @1404465
     /* 1404465 */   GIM_Try, /*On fail goto*//*Label 19917*/ GIMT_Encode4(1404551), // Rule ID 7420 //
     /* 1404470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1404493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404516 */     // MIs[0] policy
     /* 1404516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404550 */     // GIR_Coverage, 7420,
     /* 1404550 */     GIR_EraseRootFromParent_Done,
     /* 1404551 */   // Label 19917: @1404551
     /* 1404551 */   GIM_Try, /*On fail goto*//*Label 19918*/ GIMT_Encode4(1404637), // Rule ID 7421 //
     /* 1404556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1404573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1404579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404602 */     // MIs[0] policy
     /* 1404602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1404615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404636 */     // GIR_Coverage, 7421,
     /* 1404636 */     GIR_EraseRootFromParent_Done,
     /* 1404637 */   // Label 19918: @1404637
     /* 1404637 */   GIM_Try, /*On fail goto*//*Label 19919*/ GIMT_Encode4(1404723), // Rule ID 7424 //
     /* 1404642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1404653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1404656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1404659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404688 */     // MIs[0] policy
     /* 1404688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404722 */     // GIR_Coverage, 7424,
     /* 1404722 */     GIR_EraseRootFromParent_Done,
     /* 1404723 */   // Label 19919: @1404723
     /* 1404723 */   GIM_Try, /*On fail goto*//*Label 19920*/ GIMT_Encode4(1404809), // Rule ID 7425 //
     /* 1404728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1404739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1404742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1404745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1404751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404774 */     // MIs[0] policy
     /* 1404774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1404787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404808 */     // GIR_Coverage, 7425,
     /* 1404808 */     GIR_EraseRootFromParent_Done,
     /* 1404809 */   // Label 19920: @1404809
     /* 1404809 */   GIM_Try, /*On fail goto*//*Label 19921*/ GIMT_Encode4(1404895), // Rule ID 7428 //
     /* 1404814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1404817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1404825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1404828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1404831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1404834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404860 */     // MIs[0] policy
     /* 1404860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404894 */     // GIR_Coverage, 7428,
     /* 1404894 */     GIR_EraseRootFromParent_Done,
     /* 1404895 */   // Label 19921: @1404895
     /* 1404895 */   GIM_Try, /*On fail goto*//*Label 19922*/ GIMT_Encode4(1404981), // Rule ID 7429 //
     /* 1404900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1404903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1404911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1404914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1404917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1404920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1404923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1404942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404946 */     // MIs[0] policy
     /* 1404946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404956 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1404959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1404967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1404969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1404977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404980 */     // GIR_Coverage, 7429,
     /* 1404980 */     GIR_EraseRootFromParent_Done,
     /* 1404981 */   // Label 19922: @1404981
     /* 1404981 */   GIM_Try, /*On fail goto*//*Label 19923*/ GIMT_Encode4(1405067), // Rule ID 7432 //
     /* 1404986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1404989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1404994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1404997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405032 */     // MIs[0] policy
     /* 1405032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405066 */     // GIR_Coverage, 7432,
     /* 1405066 */     GIR_EraseRootFromParent_Done,
     /* 1405067 */   // Label 19923: @1405067
     /* 1405067 */   GIM_Try, /*On fail goto*//*Label 19924*/ GIMT_Encode4(1405153), // Rule ID 7433 //
     /* 1405072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1405089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1405095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405118 */     // MIs[0] policy
     /* 1405118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1405131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405152 */     // GIR_Coverage, 7433,
     /* 1405152 */     GIR_EraseRootFromParent_Done,
     /* 1405153 */   // Label 19924: @1405153
     /* 1405153 */   GIM_Try, /*On fail goto*//*Label 19925*/ GIMT_Encode4(1405239), // Rule ID 7436 //
     /* 1405158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405204 */     // MIs[0] policy
     /* 1405204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405238 */     // GIR_Coverage, 7436,
     /* 1405238 */     GIR_EraseRootFromParent_Done,
     /* 1405239 */   // Label 19925: @1405239
     /* 1405239 */   GIM_Try, /*On fail goto*//*Label 19926*/ GIMT_Encode4(1405325), // Rule ID 7437 //
     /* 1405244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1405261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1405267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405290 */     // MIs[0] policy
     /* 1405290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405300 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1405303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405324 */     // GIR_Coverage, 7437,
     /* 1405324 */     GIR_EraseRootFromParent_Done,
     /* 1405325 */   // Label 19926: @1405325
     /* 1405325 */   GIM_Try, /*On fail goto*//*Label 19927*/ GIMT_Encode4(1405411), // Rule ID 7440 //
     /* 1405330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1405333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1405350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405376 */     // MIs[0] policy
     /* 1405376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405410 */     // GIR_Coverage, 7440,
     /* 1405410 */     GIR_EraseRootFromParent_Done,
     /* 1405411 */   // Label 19927: @1405411
     /* 1405411 */   GIM_Try, /*On fail goto*//*Label 19928*/ GIMT_Encode4(1405497), // Rule ID 7441 //
     /* 1405416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1405419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1405424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1405433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1405436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1405439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1405458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405462 */     // MIs[0] policy
     /* 1405462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1405475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1405483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1405485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1405493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405496 */     // GIR_Coverage, 7441,
     /* 1405496 */     GIR_EraseRootFromParent_Done,
     /* 1405497 */   // Label 19928: @1405497
     /* 1405497 */   GIM_Try, /*On fail goto*//*Label 19929*/ GIMT_Encode4(1405585), // Rule ID 2746 //
     /* 1405502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1405505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1405513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1405516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405541 */     // MIs[0] Operand 5
     /* 1405541 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405552 */     // MIs[0] policy
     /* 1405552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405562 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1405565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405584 */     // GIR_Coverage, 2746,
     /* 1405584 */     GIR_EraseRootFromParent_Done,
     /* 1405585 */   // Label 19929: @1405585
     /* 1405585 */   GIM_Try, /*On fail goto*//*Label 19930*/ GIMT_Encode4(1405673), // Rule ID 2747 //
     /* 1405590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1405593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1405601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1405604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405629 */     // MIs[0] Operand 5
     /* 1405629 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405640 */     // MIs[0] policy
     /* 1405640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405650 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1405653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405672 */     // GIR_Coverage, 2747,
     /* 1405672 */     GIR_EraseRootFromParent_Done,
     /* 1405673 */   // Label 19930: @1405673
     /* 1405673 */   GIM_Try, /*On fail goto*//*Label 19931*/ GIMT_Encode4(1405761), // Rule ID 20638 //
     /* 1405678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1405681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1405689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1405692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1405695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1405698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405717 */     // MIs[0] Operand 5
     /* 1405717 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405728 */     // MIs[0] policy
     /* 1405728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405738 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1405741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405760 */     // GIR_Coverage, 20638,
     /* 1405760 */     GIR_EraseRootFromParent_Done,
     /* 1405761 */   // Label 19931: @1405761
     /* 1405761 */   GIM_Try, /*On fail goto*//*Label 19932*/ GIMT_Encode4(1405849), // Rule ID 20639 //
     /* 1405766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1405769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1405777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1405780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1405783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1405786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405805 */     // MIs[0] Operand 5
     /* 1405805 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405816 */     // MIs[0] policy
     /* 1405816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1405829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405848 */     // GIR_Coverage, 20639,
     /* 1405848 */     GIR_EraseRootFromParent_Done,
     /* 1405849 */   // Label 19932: @1405849
     /* 1405849 */   GIM_Try, /*On fail goto*//*Label 19933*/ GIMT_Encode4(1405937), // Rule ID 20642 //
     /* 1405854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1405857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1405865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1405868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1405871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405893 */     // MIs[0] Operand 5
     /* 1405893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405904 */     // MIs[0] policy
     /* 1405904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405914 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1405917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405936 */     // GIR_Coverage, 20642,
     /* 1405936 */     GIR_EraseRootFromParent_Done,
     /* 1405937 */   // Label 19933: @1405937
     /* 1405937 */   GIM_Try, /*On fail goto*//*Label 19934*/ GIMT_Encode4(1406025), // Rule ID 20643 //
     /* 1405942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1405945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1405950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1405953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1405956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1405959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405981 */     // MIs[0] Operand 5
     /* 1405981 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405992 */     // MIs[0] policy
     /* 1405992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406002 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406024 */     // GIR_Coverage, 20643,
     /* 1406024 */     GIR_EraseRootFromParent_Done,
     /* 1406025 */   // Label 19934: @1406025
     /* 1406025 */   GIM_Try, /*On fail goto*//*Label 19935*/ GIMT_Encode4(1406113), // Rule ID 20646 //
     /* 1406030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406069 */     // MIs[0] Operand 5
     /* 1406069 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406080 */     // MIs[0] policy
     /* 1406080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406112 */     // GIR_Coverage, 20646,
     /* 1406112 */     GIR_EraseRootFromParent_Done,
     /* 1406113 */   // Label 19935: @1406113
     /* 1406113 */   GIM_Try, /*On fail goto*//*Label 19936*/ GIMT_Encode4(1406201), // Rule ID 20647 //
     /* 1406118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1406129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1406132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406157 */     // MIs[0] Operand 5
     /* 1406157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406168 */     // MIs[0] policy
     /* 1406168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406178 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406200 */     // GIR_Coverage, 20647,
     /* 1406200 */     GIR_EraseRootFromParent_Done,
     /* 1406201 */   // Label 19936: @1406201
     /* 1406201 */   GIM_Try, /*On fail goto*//*Label 19937*/ GIMT_Encode4(1406289), // Rule ID 20650 //
     /* 1406206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1406209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406245 */     // MIs[0] Operand 5
     /* 1406245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406256 */     // MIs[0] policy
     /* 1406256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406266 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406288 */     // GIR_Coverage, 20650,
     /* 1406288 */     GIR_EraseRootFromParent_Done,
     /* 1406289 */   // Label 19937: @1406289
     /* 1406289 */   GIM_Try, /*On fail goto*//*Label 19938*/ GIMT_Encode4(1406377), // Rule ID 20651 //
     /* 1406294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1406297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406333 */     // MIs[0] Operand 5
     /* 1406333 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406344 */     // MIs[0] policy
     /* 1406344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406376 */     // GIR_Coverage, 20651,
     /* 1406376 */     GIR_EraseRootFromParent_Done,
     /* 1406377 */   // Label 19938: @1406377
     /* 1406377 */   GIM_Try, /*On fail goto*//*Label 19939*/ GIMT_Encode4(1406465), // Rule ID 20654 //
     /* 1406382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1406385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406421 */     // MIs[0] Operand 5
     /* 1406421 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406432 */     // MIs[0] policy
     /* 1406432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406464 */     // GIR_Coverage, 20654,
     /* 1406464 */     GIR_EraseRootFromParent_Done,
     /* 1406465 */   // Label 19939: @1406465
     /* 1406465 */   GIM_Try, /*On fail goto*//*Label 19940*/ GIMT_Encode4(1406553), // Rule ID 20655 //
     /* 1406470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1406473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1406487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406509 */     // MIs[0] Operand 5
     /* 1406509 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406520 */     // MIs[0] policy
     /* 1406520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1406533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1406549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406552 */     // GIR_Coverage, 20655,
     /* 1406552 */     GIR_EraseRootFromParent_Done,
     /* 1406553 */   // Label 19940: @1406553
     /* 1406553 */   GIM_Try, /*On fail goto*//*Label 19941*/ GIMT_Encode4(1406641), // Rule ID 20658 //
     /* 1406558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1406569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1406572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1406575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1406578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1406585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406597 */     // MIs[0] Operand 5
     /* 1406597 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406608 */     // MIs[0] policy
     /* 1406608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1406621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406640 */     // GIR_Coverage, 20658,
     /* 1406640 */     GIR_EraseRootFromParent_Done,
     /* 1406641 */   // Label 19941: @1406641
     /* 1406641 */   GIM_Try, /*On fail goto*//*Label 19942*/ GIMT_Encode4(1406729), // Rule ID 20659 //
     /* 1406646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1406657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1406660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1406663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1406666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1406673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406685 */     // MIs[0] Operand 5
     /* 1406685 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406696 */     // MIs[0] policy
     /* 1406696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406706 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1406709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406728 */     // GIR_Coverage, 20659,
     /* 1406728 */     GIR_EraseRootFromParent_Done,
     /* 1406729 */   // Label 19942: @1406729
     /* 1406729 */   GIM_Try, /*On fail goto*//*Label 19943*/ GIMT_Encode4(1406817), // Rule ID 20662 //
     /* 1406734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1406745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1406748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1406751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1406754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1406761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406773 */     // MIs[0] Operand 5
     /* 1406773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406784 */     // MIs[0] policy
     /* 1406784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406794 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1406797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406803 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406816 */     // GIR_Coverage, 20662,
     /* 1406816 */     GIR_EraseRootFromParent_Done,
     /* 1406817 */   // Label 19943: @1406817
     /* 1406817 */   GIM_Try, /*On fail goto*//*Label 19944*/ GIMT_Encode4(1406905), // Rule ID 20663 //
     /* 1406822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1406833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1406836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1406839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1406842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1406849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406861 */     // MIs[0] Operand 5
     /* 1406861 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406872 */     // MIs[0] policy
     /* 1406872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406882 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1406885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406904 */     // GIR_Coverage, 20663,
     /* 1406904 */     GIR_EraseRootFromParent_Done,
     /* 1406905 */   // Label 19944: @1406905
     /* 1406905 */   GIM_Try, /*On fail goto*//*Label 19945*/ GIMT_Encode4(1406993), // Rule ID 20666 //
     /* 1406910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1406918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1406921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1406924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1406927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1406930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1406937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1406941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1406945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406949 */     // MIs[0] Operand 5
     /* 1406949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406960 */     // MIs[0] policy
     /* 1406960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406970 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1406973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406992 */     // GIR_Coverage, 20666,
     /* 1406992 */     GIR_EraseRootFromParent_Done,
     /* 1406993 */   // Label 19945: @1406993
     /* 1406993 */   GIM_Try, /*On fail goto*//*Label 19946*/ GIMT_Encode4(1407081), // Rule ID 20667 //
     /* 1406998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1407009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1407012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1407015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1407018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407037 */     // MIs[0] Operand 5
     /* 1407037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407048 */     // MIs[0] policy
     /* 1407048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407058 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1407077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407080 */     // GIR_Coverage, 20667,
     /* 1407080 */     GIR_EraseRootFromParent_Done,
     /* 1407081 */   // Label 19946: @1407081
     /* 1407081 */   GIM_Try, /*On fail goto*//*Label 19947*/ GIMT_Encode4(1407169), // Rule ID 20670 //
     /* 1407086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407125 */     // MIs[0] Operand 5
     /* 1407125 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407136 */     // MIs[0] policy
     /* 1407136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407168 */     // GIR_Coverage, 20670,
     /* 1407168 */     GIR_EraseRootFromParent_Done,
     /* 1407169 */   // Label 19947: @1407169
     /* 1407169 */   GIM_Try, /*On fail goto*//*Label 19948*/ GIMT_Encode4(1407257), // Rule ID 20671 //
     /* 1407174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1407185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1407188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407213 */     // MIs[0] Operand 5
     /* 1407213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407224 */     // MIs[0] policy
     /* 1407224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407256 */     // GIR_Coverage, 20671,
     /* 1407256 */     GIR_EraseRootFromParent_Done,
     /* 1407257 */   // Label 19948: @1407257
     /* 1407257 */   GIM_Try, /*On fail goto*//*Label 19949*/ GIMT_Encode4(1407345), // Rule ID 20674 //
     /* 1407262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407301 */     // MIs[0] Operand 5
     /* 1407301 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407312 */     // MIs[0] policy
     /* 1407312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407344 */     // GIR_Coverage, 20674,
     /* 1407344 */     GIR_EraseRootFromParent_Done,
     /* 1407345 */   // Label 19949: @1407345
     /* 1407345 */   GIM_Try, /*On fail goto*//*Label 19950*/ GIMT_Encode4(1407433), // Rule ID 20675 //
     /* 1407350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1407361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1407364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407389 */     // MIs[0] Operand 5
     /* 1407389 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407400 */     // MIs[0] policy
     /* 1407400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407410 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407432 */     // GIR_Coverage, 20675,
     /* 1407432 */     GIR_EraseRootFromParent_Done,
     /* 1407433 */   // Label 19950: @1407433
     /* 1407433 */   GIM_Try, /*On fail goto*//*Label 19951*/ GIMT_Encode4(1407521), // Rule ID 20678 //
     /* 1407438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1407441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407477 */     // MIs[0] Operand 5
     /* 1407477 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407488 */     // MIs[0] policy
     /* 1407488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407520 */     // GIR_Coverage, 20678,
     /* 1407520 */     GIR_EraseRootFromParent_Done,
     /* 1407521 */   // Label 19951: @1407521
     /* 1407521 */   GIM_Try, /*On fail goto*//*Label 19952*/ GIMT_Encode4(1407609), // Rule ID 20679 //
     /* 1407526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1407529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1407537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1407540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1407543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1407546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407565 */     // MIs[0] Operand 5
     /* 1407565 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407576 */     // MIs[0] policy
     /* 1407576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407586 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1407589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407608 */     // GIR_Coverage, 20679,
     /* 1407608 */     GIR_EraseRootFromParent_Done,
     /* 1407609 */   // Label 19952: @1407609
     /* 1407609 */   GIM_Try, /*On fail goto*//*Label 19953*/ GIMT_Encode4(1407697), // Rule ID 20682 //
     /* 1407614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1407617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1407625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1407628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1407631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1407634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407653 */     // MIs[0] Operand 5
     /* 1407653 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407664 */     // MIs[0] policy
     /* 1407664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407696 */     // GIR_Coverage, 20682,
     /* 1407696 */     GIR_EraseRootFromParent_Done,
     /* 1407697 */   // Label 19953: @1407697
     /* 1407697 */   GIM_Try, /*On fail goto*//*Label 19954*/ GIMT_Encode4(1407785), // Rule ID 20683 //
     /* 1407702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1407705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1407713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1407716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1407719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1407722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1407729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407741 */     // MIs[0] Operand 5
     /* 1407741 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407752 */     // MIs[0] policy
     /* 1407752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407762 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1407765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407784 */     // GIR_Coverage, 20683,
     /* 1407784 */     GIR_EraseRootFromParent_Done,
     /* 1407785 */   // Label 19954: @1407785
     /* 1407785 */   GIM_Try, /*On fail goto*//*Label 19955*/ GIMT_Encode4(1407873), // Rule ID 20686 //
     /* 1407790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1407793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1407801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1407804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1407807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407829 */     // MIs[0] Operand 5
     /* 1407829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407840 */     // MIs[0] policy
     /* 1407840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407872 */     // GIR_Coverage, 20686,
     /* 1407872 */     GIR_EraseRootFromParent_Done,
     /* 1407873 */   // Label 19955: @1407873
     /* 1407873 */   GIM_Try, /*On fail goto*//*Label 19956*/ GIMT_Encode4(1407961), // Rule ID 20687 //
     /* 1407878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1407881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1407889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1407892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1407895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407917 */     // MIs[0] Operand 5
     /* 1407917 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407928 */     // MIs[0] policy
     /* 1407928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407938 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1407941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1407957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407960 */     // GIR_Coverage, 20687,
     /* 1407960 */     GIR_EraseRootFromParent_Done,
     /* 1407961 */   // Label 19956: @1407961
     /* 1407961 */   GIM_Try, /*On fail goto*//*Label 19957*/ GIMT_Encode4(1408049), // Rule ID 20690 //
     /* 1407966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1407969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1407974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1407977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1407980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1407983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408005 */     // MIs[0] Operand 5
     /* 1408005 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408016 */     // MIs[0] policy
     /* 1408016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408026 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408048 */     // GIR_Coverage, 20690,
     /* 1408048 */     GIR_EraseRootFromParent_Done,
     /* 1408049 */   // Label 19957: @1408049
     /* 1408049 */   GIM_Try, /*On fail goto*//*Label 19958*/ GIMT_Encode4(1408137), // Rule ID 20691 //
     /* 1408054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1408057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1408062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1408065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1408068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1408071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1408081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408093 */     // MIs[0] Operand 5
     /* 1408093 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408104 */     // MIs[0] policy
     /* 1408104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1408117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1408133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408136 */     // GIR_Coverage, 20691,
     /* 1408136 */     GIR_EraseRootFromParent_Done,
     /* 1408137 */   // Label 19958: @1408137
     /* 1408137 */   GIM_Try, /*On fail goto*//*Label 19959*/ GIMT_Encode4(1408225), // Rule ID 20694 //
     /* 1408142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408181 */     // MIs[0] Operand 5
     /* 1408181 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408192 */     // MIs[0] policy
     /* 1408192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408202 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408224 */     // GIR_Coverage, 20694,
     /* 1408224 */     GIR_EraseRootFromParent_Done,
     /* 1408225 */   // Label 19959: @1408225
     /* 1408225 */   GIM_Try, /*On fail goto*//*Label 19960*/ GIMT_Encode4(1408313), // Rule ID 20695 //
     /* 1408230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1408247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408269 */     // MIs[0] Operand 5
     /* 1408269 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408280 */     // MIs[0] policy
     /* 1408280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408290 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1408293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408312 */     // GIR_Coverage, 20695,
     /* 1408312 */     GIR_EraseRootFromParent_Done,
     /* 1408313 */   // Label 19960: @1408313
     /* 1408313 */   GIM_Try, /*On fail goto*//*Label 19961*/ GIMT_Encode4(1408401), // Rule ID 20698 //
     /* 1408318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408357 */     // MIs[0] Operand 5
     /* 1408357 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408368 */     // MIs[0] policy
     /* 1408368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408400 */     // GIR_Coverage, 20698,
     /* 1408400 */     GIR_EraseRootFromParent_Done,
     /* 1408401 */   // Label 19961: @1408401
     /* 1408401 */   GIM_Try, /*On fail goto*//*Label 19962*/ GIMT_Encode4(1408489), // Rule ID 20699 //
     /* 1408406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1408423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408445 */     // MIs[0] Operand 5
     /* 1408445 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408456 */     // MIs[0] policy
     /* 1408456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408466 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408488 */     // GIR_Coverage, 20699,
     /* 1408488 */     GIR_EraseRootFromParent_Done,
     /* 1408489 */   // Label 19962: @1408489
     /* 1408489 */   GIM_Try, /*On fail goto*//*Label 19963*/ GIMT_Encode4(1408577), // Rule ID 20702 //
     /* 1408494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1408511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408533 */     // MIs[0] Operand 5
     /* 1408533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408544 */     // MIs[0] policy
     /* 1408544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408576 */     // GIR_Coverage, 20702,
     /* 1408576 */     GIR_EraseRootFromParent_Done,
     /* 1408577 */   // Label 19963: @1408577
     /* 1408577 */   GIM_Try, /*On fail goto*//*Label 19964*/ GIMT_Encode4(1408665), // Rule ID 20703 //
     /* 1408582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1408585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1408593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1408596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1408599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408621 */     // MIs[0] Operand 5
     /* 1408621 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408632 */     // MIs[0] policy
     /* 1408632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408642 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1408645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408651 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408664 */     // GIR_Coverage, 20703,
     /* 1408664 */     GIR_EraseRootFromParent_Done,
     /* 1408665 */   // Label 19964: @1408665
     /* 1408665 */   GIM_Try, /*On fail goto*//*Label 19965*/ GIMT_Encode4(1408753), // Rule ID 20706 //
     /* 1408670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1408681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1408684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1408687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408709 */     // MIs[0] Operand 5
     /* 1408709 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408720 */     // MIs[0] policy
     /* 1408720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408730 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1408733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408752 */     // GIR_Coverage, 20706,
     /* 1408752 */     GIR_EraseRootFromParent_Done,
     /* 1408753 */   // Label 19965: @1408753
     /* 1408753 */   GIM_Try, /*On fail goto*//*Label 19966*/ GIMT_Encode4(1408841), // Rule ID 20707 //
     /* 1408758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1408769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1408772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1408775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408797 */     // MIs[0] Operand 5
     /* 1408797 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408808 */     // MIs[0] policy
     /* 1408808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1408821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408840 */     // GIR_Coverage, 20707,
     /* 1408840 */     GIR_EraseRootFromParent_Done,
     /* 1408841 */   // Label 19966: @1408841
     /* 1408841 */   GIM_Try, /*On fail goto*//*Label 19967*/ GIMT_Encode4(1408929), // Rule ID 20710 //
     /* 1408846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1408857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1408860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1408863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408885 */     // MIs[0] Operand 5
     /* 1408885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408896 */     // MIs[0] policy
     /* 1408896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1408909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1408925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408928 */     // GIR_Coverage, 20710,
     /* 1408928 */     GIR_EraseRootFromParent_Done,
     /* 1408929 */   // Label 19967: @1408929
     /* 1408929 */   GIM_Try, /*On fail goto*//*Label 19968*/ GIMT_Encode4(1409017), // Rule ID 20711 //
     /* 1408934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1408937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1408942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1408945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1408948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1408951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408973 */     // MIs[0] Operand 5
     /* 1408973 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408984 */     // MIs[0] policy
     /* 1408984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408994 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1408997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409016 */     // GIR_Coverage, 20711,
     /* 1409016 */     GIR_EraseRootFromParent_Done,
     /* 1409017 */   // Label 19968: @1409017
     /* 1409017 */   GIM_Try, /*On fail goto*//*Label 19969*/ GIMT_Encode4(1409105), // Rule ID 20714 //
     /* 1409022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1409025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409061 */     // MIs[0] Operand 5
     /* 1409061 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409072 */     // MIs[0] policy
     /* 1409072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409104 */     // GIR_Coverage, 20714,
     /* 1409104 */     GIR_EraseRootFromParent_Done,
     /* 1409105 */   // Label 19969: @1409105
     /* 1409105 */   GIM_Try, /*On fail goto*//*Label 19970*/ GIMT_Encode4(1409193), // Rule ID 20715 //
     /* 1409110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1409113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1409121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1409124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409149 */     // MIs[0] Operand 5
     /* 1409149 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409160 */     // MIs[0] policy
     /* 1409160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409170 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1409173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1409189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409192 */     // GIR_Coverage, 20715,
     /* 1409192 */     GIR_EraseRootFromParent_Done,
     /* 1409193 */   // Label 19970: @1409193
     /* 1409193 */   GIM_Try, /*On fail goto*//*Label 19971*/ GIMT_Encode4(1409281), // Rule ID 20718 //
     /* 1409198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409237 */     // MIs[0] Operand 5
     /* 1409237 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409248 */     // MIs[0] policy
     /* 1409248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409258 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409280 */     // GIR_Coverage, 20718,
     /* 1409280 */     GIR_EraseRootFromParent_Done,
     /* 1409281 */   // Label 19971: @1409281
     /* 1409281 */   GIM_Try, /*On fail goto*//*Label 19972*/ GIMT_Encode4(1409369), // Rule ID 20719 //
     /* 1409286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1409303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409325 */     // MIs[0] Operand 5
     /* 1409325 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409336 */     // MIs[0] policy
     /* 1409336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409368 */     // GIR_Coverage, 20719,
     /* 1409368 */     GIR_EraseRootFromParent_Done,
     /* 1409369 */   // Label 19972: @1409369
     /* 1409369 */   GIM_Try, /*On fail goto*//*Label 19973*/ GIMT_Encode4(1409457), // Rule ID 20722 //
     /* 1409374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409413 */     // MIs[0] Operand 5
     /* 1409413 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409424 */     // MIs[0] policy
     /* 1409424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409456 */     // GIR_Coverage, 20722,
     /* 1409456 */     GIR_EraseRootFromParent_Done,
     /* 1409457 */   // Label 19973: @1409457
     /* 1409457 */   GIM_Try, /*On fail goto*//*Label 19974*/ GIMT_Encode4(1409545), // Rule ID 20723 //
     /* 1409462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1409479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409501 */     // MIs[0] Operand 5
     /* 1409501 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409512 */     // MIs[0] policy
     /* 1409512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409522 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409544 */     // GIR_Coverage, 20723,
     /* 1409544 */     GIR_EraseRootFromParent_Done,
     /* 1409545 */   // Label 19974: @1409545
     /* 1409545 */   GIM_Try, /*On fail goto*//*Label 19975*/ GIMT_Encode4(1409633), // Rule ID 20726 //
     /* 1409550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1409553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1409561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1409564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1409567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1409570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1409577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409589 */     // MIs[0] Operand 5
     /* 1409589 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409600 */     // MIs[0] policy
     /* 1409600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409610 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1409613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409632 */     // GIR_Coverage, 20726,
     /* 1409632 */     GIR_EraseRootFromParent_Done,
     /* 1409633 */   // Label 19975: @1409633
     /* 1409633 */   GIM_Try, /*On fail goto*//*Label 19976*/ GIMT_Encode4(1409721), // Rule ID 20727 //
     /* 1409638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1409641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1409649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1409652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1409655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1409658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1409665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409677 */     // MIs[0] Operand 5
     /* 1409677 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409688 */     // MIs[0] policy
     /* 1409688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409698 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1409701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409720 */     // GIR_Coverage, 20727,
     /* 1409720 */     GIR_EraseRootFromParent_Done,
     /* 1409721 */   // Label 19976: @1409721
     /* 1409721 */   GIM_Try, /*On fail goto*//*Label 19977*/ GIMT_Encode4(1409809), // Rule ID 20730 //
     /* 1409726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1409729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1409737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1409740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1409743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409765 */     // MIs[0] Operand 5
     /* 1409765 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409776 */     // MIs[0] policy
     /* 1409776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409808 */     // GIR_Coverage, 20730,
     /* 1409808 */     GIR_EraseRootFromParent_Done,
     /* 1409809 */   // Label 19977: @1409809
     /* 1409809 */   GIM_Try, /*On fail goto*//*Label 19978*/ GIMT_Encode4(1409897), // Rule ID 20731 //
     /* 1409814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1409825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1409828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1409831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409853 */     // MIs[0] Operand 5
     /* 1409853 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409864 */     // MIs[0] policy
     /* 1409864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1409877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409896 */     // GIR_Coverage, 20731,
     /* 1409896 */     GIR_EraseRootFromParent_Done,
     /* 1409897 */   // Label 19978: @1409897
     /* 1409897 */   GIM_Try, /*On fail goto*//*Label 19979*/ GIMT_Encode4(1409985), // Rule ID 20734 //
     /* 1409902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1409905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1409913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1409916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1409919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409941 */     // MIs[0] Operand 5
     /* 1409941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409952 */     // MIs[0] policy
     /* 1409952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1409965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409984 */     // GIR_Coverage, 20734,
     /* 1409984 */     GIR_EraseRootFromParent_Done,
     /* 1409985 */   // Label 19979: @1409985
     /* 1409985 */   GIM_Try, /*On fail goto*//*Label 19980*/ GIMT_Encode4(1410073), // Rule ID 20735 //
     /* 1409990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1409998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1410001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1410004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1410007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410029 */     // MIs[0] Operand 5
     /* 1410029 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410040 */     // MIs[0] policy
     /* 1410040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410050 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410072 */     // GIR_Coverage, 20735,
     /* 1410072 */     GIR_EraseRootFromParent_Done,
     /* 1410073 */   // Label 19980: @1410073
     /* 1410073 */   GIM_Try, /*On fail goto*//*Label 19981*/ GIMT_Encode4(1410161), // Rule ID 20738 //
     /* 1410078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1410081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1410095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410117 */     // MIs[0] Operand 5
     /* 1410117 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410128 */     // MIs[0] policy
     /* 1410128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410138 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410160 */     // GIR_Coverage, 20738,
     /* 1410160 */     GIR_EraseRootFromParent_Done,
     /* 1410161 */   // Label 19981: @1410161
     /* 1410161 */   GIM_Try, /*On fail goto*//*Label 19982*/ GIMT_Encode4(1410249), // Rule ID 20739 //
     /* 1410166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1410169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1410177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1410180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1410183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410205 */     // MIs[0] Operand 5
     /* 1410205 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410216 */     // MIs[0] policy
     /* 1410216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1410245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410248 */     // GIR_Coverage, 20739,
     /* 1410248 */     GIR_EraseRootFromParent_Done,
     /* 1410249 */   // Label 19982: @1410249
     /* 1410249 */   GIM_Try, /*On fail goto*//*Label 19983*/ GIMT_Encode4(1410337), // Rule ID 20742 //
     /* 1410254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1410271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410293 */     // MIs[0] Operand 5
     /* 1410293 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410304 */     // MIs[0] policy
     /* 1410304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410336 */     // GIR_Coverage, 20742,
     /* 1410336 */     GIR_EraseRootFromParent_Done,
     /* 1410337 */   // Label 19983: @1410337
     /* 1410337 */   GIM_Try, /*On fail goto*//*Label 19984*/ GIMT_Encode4(1410425), // Rule ID 20743 //
     /* 1410342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1410353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1410356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1410359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410381 */     // MIs[0] Operand 5
     /* 1410381 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410392 */     // MIs[0] policy
     /* 1410392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410402 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1410405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410424 */     // GIR_Coverage, 20743,
     /* 1410424 */     GIR_EraseRootFromParent_Done,
     /* 1410425 */   // Label 19984: @1410425
     /* 1410425 */   GIM_Try, /*On fail goto*//*Label 19985*/ GIMT_Encode4(1410513), // Rule ID 20746 //
     /* 1410430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1410441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1410444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1410447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410469 */     // MIs[0] Operand 5
     /* 1410469 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410480 */     // MIs[0] policy
     /* 1410480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410490 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410512 */     // GIR_Coverage, 20746,
     /* 1410512 */     GIR_EraseRootFromParent_Done,
     /* 1410513 */   // Label 19985: @1410513
     /* 1410513 */   GIM_Try, /*On fail goto*//*Label 19986*/ GIMT_Encode4(1410601), // Rule ID 20747 //
     /* 1410518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1410529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1410532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1410535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410557 */     // MIs[0] Operand 5
     /* 1410557 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410568 */     // MIs[0] policy
     /* 1410568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410578 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1410581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410600 */     // GIR_Coverage, 20747,
     /* 1410600 */     GIR_EraseRootFromParent_Done,
     /* 1410601 */   // Label 19986: @1410601
     /* 1410601 */   GIM_Try, /*On fail goto*//*Label 19987*/ GIMT_Encode4(1410689), // Rule ID 20750 //
     /* 1410606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1410609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1410617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1410620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1410623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410645 */     // MIs[0] Operand 5
     /* 1410645 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410656 */     // MIs[0] policy
     /* 1410656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410666 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410688 */     // GIR_Coverage, 20750,
     /* 1410688 */     GIR_EraseRootFromParent_Done,
     /* 1410689 */   // Label 19987: @1410689
     /* 1410689 */   GIM_Try, /*On fail goto*//*Label 19988*/ GIMT_Encode4(1410777), // Rule ID 20751 //
     /* 1410694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1410697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1410702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1410705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1410708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1410711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1410721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410733 */     // MIs[0] Operand 5
     /* 1410733 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410744 */     // MIs[0] policy
     /* 1410744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410754 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1410757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1410773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410776 */     // GIR_Coverage, 20751,
     /* 1410776 */     GIR_EraseRootFromParent_Done,
     /* 1410777 */   // Label 19988: @1410777
     /* 1410777 */   GIM_Try, /*On fail goto*//*Label 19989*/ GIMT_Encode4(1410865), // Rule ID 21110 //
     /* 1410782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1410790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1410793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1410796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410821 */     // MIs[0] Operand 5
     /* 1410821 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410832 */     // MIs[0] policy
     /* 1410832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410842 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1410845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410864 */     // GIR_Coverage, 21110,
     /* 1410864 */     GIR_EraseRootFromParent_Done,
     /* 1410865 */   // Label 19989: @1410865
     /* 1410865 */   GIM_Try, /*On fail goto*//*Label 19990*/ GIMT_Encode4(1410953), // Rule ID 21111 //
     /* 1410870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1410878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1410881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1410884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410909 */     // MIs[0] Operand 5
     /* 1410909 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410920 */     // MIs[0] policy
     /* 1410920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1410933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1410949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410952 */     // GIR_Coverage, 21111,
     /* 1410952 */     GIR_EraseRootFromParent_Done,
     /* 1410953 */   // Label 19990: @1410953
     /* 1410953 */   GIM_Try, /*On fail goto*//*Label 19991*/ GIMT_Encode4(1411041), // Rule ID 21114 //
     /* 1410958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1410966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1410969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1410972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1410975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410997 */     // MIs[0] Operand 5
     /* 1410997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411008 */     // MIs[0] policy
     /* 1411008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411040 */     // GIR_Coverage, 21114,
     /* 1411040 */     GIR_EraseRootFromParent_Done,
     /* 1411041 */   // Label 19991: @1411041
     /* 1411041 */   GIM_Try, /*On fail goto*//*Label 19992*/ GIMT_Encode4(1411129), // Rule ID 21115 //
     /* 1411046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1411057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1411060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1411063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411085 */     // MIs[0] Operand 5
     /* 1411085 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411096 */     // MIs[0] policy
     /* 1411096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411106 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411128 */     // GIR_Coverage, 21115,
     /* 1411128 */     GIR_EraseRootFromParent_Done,
     /* 1411129 */   // Label 19992: @1411129
     /* 1411129 */   GIM_Try, /*On fail goto*//*Label 19993*/ GIMT_Encode4(1411217), // Rule ID 21118 //
     /* 1411134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1411145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1411148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411173 */     // MIs[0] Operand 5
     /* 1411173 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411184 */     // MIs[0] policy
     /* 1411184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411216 */     // GIR_Coverage, 21118,
     /* 1411216 */     GIR_EraseRootFromParent_Done,
     /* 1411217 */   // Label 19993: @1411217
     /* 1411217 */   GIM_Try, /*On fail goto*//*Label 19994*/ GIMT_Encode4(1411305), // Rule ID 21119 //
     /* 1411222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1411233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1411236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1411239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411261 */     // MIs[0] Operand 5
     /* 1411261 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411272 */     // MIs[0] policy
     /* 1411272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411291 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411304 */     // GIR_Coverage, 21119,
     /* 1411304 */     GIR_EraseRootFromParent_Done,
     /* 1411305 */   // Label 19994: @1411305
     /* 1411305 */   GIM_Try, /*On fail goto*//*Label 19995*/ GIMT_Encode4(1411393), // Rule ID 21122 //
     /* 1411310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411349 */     // MIs[0] Operand 5
     /* 1411349 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411360 */     // MIs[0] policy
     /* 1411360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411370 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1411373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411392 */     // GIR_Coverage, 21122,
     /* 1411392 */     GIR_EraseRootFromParent_Done,
     /* 1411393 */   // Label 19995: @1411393
     /* 1411393 */   GIM_Try, /*On fail goto*//*Label 19996*/ GIMT_Encode4(1411481), // Rule ID 21123 //
     /* 1411398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1411409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1411412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1411415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411437 */     // MIs[0] Operand 5
     /* 1411437 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411448 */     // MIs[0] policy
     /* 1411448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411458 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1411461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411480 */     // GIR_Coverage, 21123,
     /* 1411480 */     GIR_EraseRootFromParent_Done,
     /* 1411481 */   // Label 19996: @1411481
     /* 1411481 */   GIM_Try, /*On fail goto*//*Label 19997*/ GIMT_Encode4(1411569), // Rule ID 21126 //
     /* 1411486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1411489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1411497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1411500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1411503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411525 */     // MIs[0] Operand 5
     /* 1411525 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411536 */     // MIs[0] policy
     /* 1411536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1411549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411568 */     // GIR_Coverage, 21126,
     /* 1411568 */     GIR_EraseRootFromParent_Done,
     /* 1411569 */   // Label 19997: @1411569
     /* 1411569 */   GIM_Try, /*On fail goto*//*Label 19998*/ GIMT_Encode4(1411657), // Rule ID 21127 //
     /* 1411574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1411577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1411585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1411588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1411591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1411601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411613 */     // MIs[0] Operand 5
     /* 1411613 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411624 */     // MIs[0] policy
     /* 1411624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1411637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411656 */     // GIR_Coverage, 21127,
     /* 1411656 */     GIR_EraseRootFromParent_Done,
     /* 1411657 */   // Label 19998: @1411657
     /* 1411657 */   GIM_Try, /*On fail goto*//*Label 19999*/ GIMT_Encode4(1411745), // Rule ID 21130 //
     /* 1411662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1411665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1411673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1411676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411701 */     // MIs[0] Operand 5
     /* 1411701 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411712 */     // MIs[0] policy
     /* 1411712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411722 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411744 */     // GIR_Coverage, 21130,
     /* 1411744 */     GIR_EraseRootFromParent_Done,
     /* 1411745 */   // Label 19999: @1411745
     /* 1411745 */   GIM_Try, /*On fail goto*//*Label 20000*/ GIMT_Encode4(1411833), // Rule ID 21131 //
     /* 1411750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1411753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1411761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1411764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411789 */     // MIs[0] Operand 5
     /* 1411789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411800 */     // MIs[0] policy
     /* 1411800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1411813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411832 */     // GIR_Coverage, 21131,
     /* 1411832 */     GIR_EraseRootFromParent_Done,
     /* 1411833 */   // Label 20000: @1411833
     /* 1411833 */   GIM_Try, /*On fail goto*//*Label 20001*/ GIMT_Encode4(1411921), // Rule ID 21134 //
     /* 1411838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1411841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1411849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1411852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411877 */     // MIs[0] Operand 5
     /* 1411877 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411888 */     // MIs[0] policy
     /* 1411888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411898 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1411917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411920 */     // GIR_Coverage, 21134,
     /* 1411920 */     GIR_EraseRootFromParent_Done,
     /* 1411921 */   // Label 20001: @1411921
     /* 1411921 */   GIM_Try, /*On fail goto*//*Label 20002*/ GIMT_Encode4(1412009), // Rule ID 21135 //
     /* 1411926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1411929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1411934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1411937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1411940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411965 */     // MIs[0] Operand 5
     /* 1411965 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411976 */     // MIs[0] policy
     /* 1411976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1411989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411995 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412008 */     // GIR_Coverage, 21135,
     /* 1412008 */     GIR_EraseRootFromParent_Done,
     /* 1412009 */   // Label 20002: @1412009
     /* 1412009 */   GIM_Try, /*On fail goto*//*Label 20003*/ GIMT_Encode4(1412097), // Rule ID 21138 //
     /* 1412014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412053 */     // MIs[0] Operand 5
     /* 1412053 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412064 */     // MIs[0] policy
     /* 1412064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412074 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1412077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412096 */     // GIR_Coverage, 21138,
     /* 1412096 */     GIR_EraseRootFromParent_Done,
     /* 1412097 */   // Label 20003: @1412097
     /* 1412097 */   GIM_Try, /*On fail goto*//*Label 20004*/ GIMT_Encode4(1412185), // Rule ID 21139 //
     /* 1412102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1412113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1412116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1412119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412141 */     // MIs[0] Operand 5
     /* 1412141 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412152 */     // MIs[0] policy
     /* 1412152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412162 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1412165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412184 */     // GIR_Coverage, 21139,
     /* 1412184 */     GIR_EraseRootFromParent_Done,
     /* 1412185 */   // Label 20004: @1412185
     /* 1412185 */   GIM_Try, /*On fail goto*//*Label 20005*/ GIMT_Encode4(1412273), // Rule ID 21142 //
     /* 1412190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1412193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1412201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1412204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412229 */     // MIs[0] Operand 5
     /* 1412229 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412240 */     // MIs[0] policy
     /* 1412240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412250 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412272 */     // GIR_Coverage, 21142,
     /* 1412272 */     GIR_EraseRootFromParent_Done,
     /* 1412273 */   // Label 20005: @1412273
     /* 1412273 */   GIM_Try, /*On fail goto*//*Label 20006*/ GIMT_Encode4(1412361), // Rule ID 21143 //
     /* 1412278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1412281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1412286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1412289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1412292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1412295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1412305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412317 */     // MIs[0] Operand 5
     /* 1412317 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412328 */     // MIs[0] policy
     /* 1412328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1412341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412347 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412360 */     // GIR_Coverage, 21143,
     /* 1412360 */     GIR_EraseRootFromParent_Done,
     /* 1412361 */   // Label 20006: @1412361
     /* 1412361 */   GIM_Try, /*On fail goto*//*Label 20007*/ GIMT_Encode4(1412449), // Rule ID 21146 //
     /* 1412366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412405 */     // MIs[0] Operand 5
     /* 1412405 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412416 */     // MIs[0] policy
     /* 1412416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412426 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1412429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412448 */     // GIR_Coverage, 21146,
     /* 1412448 */     GIR_EraseRootFromParent_Done,
     /* 1412449 */   // Label 20007: @1412449
     /* 1412449 */   GIM_Try, /*On fail goto*//*Label 20008*/ GIMT_Encode4(1412537), // Rule ID 21147 //
     /* 1412454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1412471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412493 */     // MIs[0] Operand 5
     /* 1412493 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412504 */     // MIs[0] policy
     /* 1412504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1412517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412536 */     // GIR_Coverage, 21147,
     /* 1412536 */     GIR_EraseRootFromParent_Done,
     /* 1412537 */   // Label 20008: @1412537
     /* 1412537 */   GIM_Try, /*On fail goto*//*Label 20009*/ GIMT_Encode4(1412625), // Rule ID 21150 //
     /* 1412542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1412553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1412556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1412559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412581 */     // MIs[0] Operand 5
     /* 1412581 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412592 */     // MIs[0] policy
     /* 1412592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1412605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412624 */     // GIR_Coverage, 21150,
     /* 1412624 */     GIR_EraseRootFromParent_Done,
     /* 1412625 */   // Label 20009: @1412625
     /* 1412625 */   GIM_Try, /*On fail goto*//*Label 20010*/ GIMT_Encode4(1412713), // Rule ID 21151 //
     /* 1412630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1412641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1412644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1412647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412669 */     // MIs[0] Operand 5
     /* 1412669 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412680 */     // MIs[0] policy
     /* 1412680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1412693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412712 */     // GIR_Coverage, 21151,
     /* 1412712 */     GIR_EraseRootFromParent_Done,
     /* 1412713 */   // Label 20010: @1412713
     /* 1412713 */   GIM_Try, /*On fail goto*//*Label 20011*/ GIMT_Encode4(1412801), // Rule ID 21154 //
     /* 1412718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1412729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1412732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1412735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412757 */     // MIs[0] Operand 5
     /* 1412757 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412768 */     // MIs[0] policy
     /* 1412768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1412781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412800 */     // GIR_Coverage, 21154,
     /* 1412800 */     GIR_EraseRootFromParent_Done,
     /* 1412801 */   // Label 20011: @1412801
     /* 1412801 */   GIM_Try, /*On fail goto*//*Label 20012*/ GIMT_Encode4(1412889), // Rule ID 21155 //
     /* 1412806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1412817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1412820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1412823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412845 */     // MIs[0] Operand 5
     /* 1412845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412856 */     // MIs[0] policy
     /* 1412856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1412869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412888 */     // GIR_Coverage, 21155,
     /* 1412888 */     GIR_EraseRootFromParent_Done,
     /* 1412889 */   // Label 20012: @1412889
     /* 1412889 */   GIM_Try, /*On fail goto*//*Label 20013*/ GIMT_Encode4(1412977), // Rule ID 21158 //
     /* 1412894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1412897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1412905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1412908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1412911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412933 */     // MIs[0] Operand 5
     /* 1412933 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412944 */     // MIs[0] policy
     /* 1412944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412954 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1412957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1412973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412976 */     // GIR_Coverage, 21158,
     /* 1412976 */     GIR_EraseRootFromParent_Done,
     /* 1412977 */   // Label 20013: @1412977
     /* 1412977 */   GIM_Try, /*On fail goto*//*Label 20014*/ GIMT_Encode4(1413065), // Rule ID 21159 //
     /* 1412982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1412985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1412990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1412993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1412996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1412999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413021 */     // MIs[0] Operand 5
     /* 1413021 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413032 */     // MIs[0] policy
     /* 1413032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413042 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413064 */     // GIR_Coverage, 21159,
     /* 1413064 */     GIR_EraseRootFromParent_Done,
     /* 1413065 */   // Label 20014: @1413065
     /* 1413065 */   GIM_Try, /*On fail goto*//*Label 20015*/ GIMT_Encode4(1413153), // Rule ID 21162 //
     /* 1413070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1413081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1413084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413109 */     // MIs[0] Operand 5
     /* 1413109 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413120 */     // MIs[0] policy
     /* 1413120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413152 */     // GIR_Coverage, 21162,
     /* 1413152 */     GIR_EraseRootFromParent_Done,
     /* 1413153 */   // Label 20015: @1413153
     /* 1413153 */   GIM_Try, /*On fail goto*//*Label 20016*/ GIMT_Encode4(1413241), // Rule ID 21163 //
     /* 1413158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1413161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1413169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1413172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1413175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1413178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413197 */     // MIs[0] Operand 5
     /* 1413197 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413208 */     // MIs[0] policy
     /* 1413208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413240 */     // GIR_Coverage, 21163,
     /* 1413240 */     GIR_EraseRootFromParent_Done,
     /* 1413241 */   // Label 20016: @1413241
     /* 1413241 */   GIM_Try, /*On fail goto*//*Label 20017*/ GIMT_Encode4(1413329), // Rule ID 21166 //
     /* 1413246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1413257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1413260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413285 */     // MIs[0] Operand 5
     /* 1413285 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413296 */     // MIs[0] policy
     /* 1413296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413306 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413328 */     // GIR_Coverage, 21166,
     /* 1413328 */     GIR_EraseRootFromParent_Done,
     /* 1413329 */   // Label 20017: @1413329
     /* 1413329 */   GIM_Try, /*On fail goto*//*Label 20018*/ GIMT_Encode4(1413417), // Rule ID 21167 //
     /* 1413334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1413345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1413348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413373 */     // MIs[0] Operand 5
     /* 1413373 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413384 */     // MIs[0] policy
     /* 1413384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413394 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1413397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413416 */     // GIR_Coverage, 21167,
     /* 1413416 */     GIR_EraseRootFromParent_Done,
     /* 1413417 */   // Label 20018: @1413417
     /* 1413417 */   GIM_Try, /*On fail goto*//*Label 20019*/ GIMT_Encode4(1413505), // Rule ID 21170 //
     /* 1413422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1413433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1413436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1413439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413461 */     // MIs[0] Operand 5
     /* 1413461 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413472 */     // MIs[0] policy
     /* 1413472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413482 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413504 */     // GIR_Coverage, 21170,
     /* 1413504 */     GIR_EraseRootFromParent_Done,
     /* 1413505 */   // Label 20019: @1413505
     /* 1413505 */   GIM_Try, /*On fail goto*//*Label 20020*/ GIMT_Encode4(1413593), // Rule ID 21171 //
     /* 1413510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1413521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1413524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1413527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1413530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1413537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413549 */     // MIs[0] Operand 5
     /* 1413549 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413560 */     // MIs[0] policy
     /* 1413560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413570 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1413573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413592 */     // GIR_Coverage, 21171,
     /* 1413592 */     GIR_EraseRootFromParent_Done,
     /* 1413593 */   // Label 20020: @1413593
     /* 1413593 */   GIM_Try, /*On fail goto*//*Label 20021*/ GIMT_Encode4(1413681), // Rule ID 21174 //
     /* 1413598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1413609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1413612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1413615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413637 */     // MIs[0] Operand 5
     /* 1413637 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413648 */     // MIs[0] policy
     /* 1413648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413658 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413680 */     // GIR_Coverage, 21174,
     /* 1413680 */     GIR_EraseRootFromParent_Done,
     /* 1413681 */   // Label 20021: @1413681
     /* 1413681 */   GIM_Try, /*On fail goto*//*Label 20022*/ GIMT_Encode4(1413769), // Rule ID 21175 //
     /* 1413686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1413697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1413700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1413703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1413706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1413713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1413721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413725 */     // MIs[0] Operand 5
     /* 1413725 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413736 */     // MIs[0] policy
     /* 1413736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413746 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1413749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413768 */     // GIR_Coverage, 21175,
     /* 1413768 */     GIR_EraseRootFromParent_Done,
     /* 1413769 */   // Label 20022: @1413769
     /* 1413769 */   GIM_Try, /*On fail goto*//*Label 20023*/ GIMT_Encode4(1413857), // Rule ID 21178 //
     /* 1413774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1413777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1413785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1413788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1413791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413813 */     // MIs[0] Operand 5
     /* 1413813 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413824 */     // MIs[0] policy
     /* 1413824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413834 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413856 */     // GIR_Coverage, 21178,
     /* 1413856 */     GIR_EraseRootFromParent_Done,
     /* 1413857 */   // Label 20023: @1413857
     /* 1413857 */   GIM_Try, /*On fail goto*//*Label 20024*/ GIMT_Encode4(1413945), // Rule ID 21179 //
     /* 1413862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1413865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1413870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1413873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1413876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1413879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1413882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1413889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1413893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1413897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413901 */     // MIs[0] Operand 5
     /* 1413901 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1413912 */     // MIs[0] policy
     /* 1413912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413922 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1413925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1413931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1413933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413944 */     // GIR_Coverage, 21179,
     /* 1413944 */     GIR_EraseRootFromParent_Done,
     /* 1413945 */   // Label 20024: @1413945
     /* 1413945 */   GIM_Try, /*On fail goto*//*Label 20025*/ GIMT_Encode4(1414033), // Rule ID 21482 //
     /* 1413950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1413953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1413958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1413961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1413964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1413967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1413970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413989 */     // MIs[0] Operand 5
     /* 1413989 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414000 */     // MIs[0] policy
     /* 1414000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414010 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1414013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414032 */     // GIR_Coverage, 21482,
     /* 1414032 */     GIR_EraseRootFromParent_Done,
     /* 1414033 */   // Label 20025: @1414033
     /* 1414033 */   GIM_Try, /*On fail goto*//*Label 20026*/ GIMT_Encode4(1414121), // Rule ID 21483 //
     /* 1414038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1414049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1414052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1414055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1414058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414077 */     // MIs[0] Operand 5
     /* 1414077 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414088 */     // MIs[0] policy
     /* 1414088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414098 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1414101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414120 */     // GIR_Coverage, 21483,
     /* 1414120 */     GIR_EraseRootFromParent_Done,
     /* 1414121 */   // Label 20026: @1414121
     /* 1414121 */   GIM_Try, /*On fail goto*//*Label 20027*/ GIMT_Encode4(1414209), // Rule ID 21486 //
     /* 1414126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414165 */     // MIs[0] Operand 5
     /* 1414165 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414176 */     // MIs[0] policy
     /* 1414176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414186 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1414189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414208 */     // GIR_Coverage, 21486,
     /* 1414208 */     GIR_EraseRootFromParent_Done,
     /* 1414209 */   // Label 20027: @1414209
     /* 1414209 */   GIM_Try, /*On fail goto*//*Label 20028*/ GIMT_Encode4(1414297), // Rule ID 21487 //
     /* 1414214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1414225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1414228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1414231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1414234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414253 */     // MIs[0] Operand 5
     /* 1414253 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414264 */     // MIs[0] policy
     /* 1414264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414274 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1414277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414296 */     // GIR_Coverage, 21487,
     /* 1414296 */     GIR_EraseRootFromParent_Done,
     /* 1414297 */   // Label 20028: @1414297
     /* 1414297 */   GIM_Try, /*On fail goto*//*Label 20029*/ GIMT_Encode4(1414385), // Rule ID 21490 //
     /* 1414302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414341 */     // MIs[0] Operand 5
     /* 1414341 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414352 */     // MIs[0] policy
     /* 1414352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414362 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1414365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414384 */     // GIR_Coverage, 21490,
     /* 1414384 */     GIR_EraseRootFromParent_Done,
     /* 1414385 */   // Label 20029: @1414385
     /* 1414385 */   GIM_Try, /*On fail goto*//*Label 20030*/ GIMT_Encode4(1414473), // Rule ID 21491 //
     /* 1414390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1414401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1414404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1414410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414429 */     // MIs[0] Operand 5
     /* 1414429 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414440 */     // MIs[0] policy
     /* 1414440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1414453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414472 */     // GIR_Coverage, 21491,
     /* 1414472 */     GIR_EraseRootFromParent_Done,
     /* 1414473 */   // Label 20030: @1414473
     /* 1414473 */   GIM_Try, /*On fail goto*//*Label 20031*/ GIMT_Encode4(1414561), // Rule ID 21494 //
     /* 1414478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1414489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1414492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1414495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414517 */     // MIs[0] Operand 5
     /* 1414517 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414528 */     // MIs[0] policy
     /* 1414528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414538 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1414541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414560 */     // GIR_Coverage, 21494,
     /* 1414560 */     GIR_EraseRootFromParent_Done,
     /* 1414561 */   // Label 20031: @1414561
     /* 1414561 */   GIM_Try, /*On fail goto*//*Label 20032*/ GIMT_Encode4(1414649), // Rule ID 21495 //
     /* 1414566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1414577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1414580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1414583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1414586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414605 */     // MIs[0] Operand 5
     /* 1414605 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414616 */     // MIs[0] policy
     /* 1414616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414626 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1414629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414648 */     // GIR_Coverage, 21495,
     /* 1414648 */     GIR_EraseRootFromParent_Done,
     /* 1414649 */   // Label 20032: @1414649
     /* 1414649 */   GIM_Try, /*On fail goto*//*Label 20033*/ GIMT_Encode4(1414737), // Rule ID 21498 //
     /* 1414654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1414665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1414668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1414671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1414674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414693 */     // MIs[0] Operand 5
     /* 1414693 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414704 */     // MIs[0] policy
     /* 1414704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414714 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1414717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414736 */     // GIR_Coverage, 21498,
     /* 1414736 */     GIR_EraseRootFromParent_Done,
     /* 1414737 */   // Label 20033: @1414737
     /* 1414737 */   GIM_Try, /*On fail goto*//*Label 20034*/ GIMT_Encode4(1414825), // Rule ID 21499 //
     /* 1414742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1414753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1414756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1414759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1414762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414781 */     // MIs[0] Operand 5
     /* 1414781 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414792 */     // MIs[0] policy
     /* 1414792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1414805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414824 */     // GIR_Coverage, 21499,
     /* 1414824 */     GIR_EraseRootFromParent_Done,
     /* 1414825 */   // Label 20034: @1414825
     /* 1414825 */   GIM_Try, /*On fail goto*//*Label 20035*/ GIMT_Encode4(1414913), // Rule ID 21502 //
     /* 1414830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1414833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1414841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1414844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1414847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1414850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414869 */     // MIs[0] Operand 5
     /* 1414869 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414880 */     // MIs[0] policy
     /* 1414880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414890 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1414893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414912 */     // GIR_Coverage, 21502,
     /* 1414912 */     GIR_EraseRootFromParent_Done,
     /* 1414913 */   // Label 20035: @1414913
     /* 1414913 */   GIM_Try, /*On fail goto*//*Label 20036*/ GIMT_Encode4(1415001), // Rule ID 21503 //
     /* 1414918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1414921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1414926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1414929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1414932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1414935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1414938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1414953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414957 */     // MIs[0] Operand 5
     /* 1414957 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1414968 */     // MIs[0] policy
     /* 1414968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414978 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1414981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1414987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1414989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415000 */     // GIR_Coverage, 21503,
     /* 1415000 */     GIR_EraseRootFromParent_Done,
     /* 1415001 */   // Label 20036: @1415001
     /* 1415001 */   GIM_Try, /*On fail goto*//*Label 20037*/ GIMT_Encode4(1415089), // Rule ID 21506 //
     /* 1415006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415045 */     // MIs[0] Operand 5
     /* 1415045 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415056 */     // MIs[0] policy
     /* 1415056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415066 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1415069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415088 */     // GIR_Coverage, 21506,
     /* 1415088 */     GIR_EraseRootFromParent_Done,
     /* 1415089 */   // Label 20037: @1415089
     /* 1415089 */   GIM_Try, /*On fail goto*//*Label 20038*/ GIMT_Encode4(1415177), // Rule ID 21507 //
     /* 1415094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1415105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1415108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1415111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415133 */     // MIs[0] Operand 5
     /* 1415133 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415144 */     // MIs[0] policy
     /* 1415144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415154 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1415157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415176 */     // GIR_Coverage, 21507,
     /* 1415176 */     GIR_EraseRootFromParent_Done,
     /* 1415177 */   // Label 20038: @1415177
     /* 1415177 */   GIM_Try, /*On fail goto*//*Label 20039*/ GIMT_Encode4(1415265), // Rule ID 21510 //
     /* 1415182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415221 */     // MIs[0] Operand 5
     /* 1415221 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415232 */     // MIs[0] policy
     /* 1415232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415242 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415264 */     // GIR_Coverage, 21510,
     /* 1415264 */     GIR_EraseRootFromParent_Done,
     /* 1415265 */   // Label 20039: @1415265
     /* 1415265 */   GIM_Try, /*On fail goto*//*Label 20040*/ GIMT_Encode4(1415353), // Rule ID 21511 //
     /* 1415270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1415281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1415284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1415287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1415290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415309 */     // MIs[0] Operand 5
     /* 1415309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415320 */     // MIs[0] policy
     /* 1415320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415330 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415339 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415352 */     // GIR_Coverage, 21511,
     /* 1415352 */     GIR_EraseRootFromParent_Done,
     /* 1415353 */   // Label 20040: @1415353
     /* 1415353 */   GIM_Try, /*On fail goto*//*Label 20041*/ GIMT_Encode4(1415441), // Rule ID 21514 //
     /* 1415358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415397 */     // MIs[0] Operand 5
     /* 1415397 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415408 */     // MIs[0] policy
     /* 1415408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415440 */     // GIR_Coverage, 21514,
     /* 1415440 */     GIR_EraseRootFromParent_Done,
     /* 1415441 */   // Label 20041: @1415441
     /* 1415441 */   GIM_Try, /*On fail goto*//*Label 20042*/ GIMT_Encode4(1415529), // Rule ID 21515 //
     /* 1415446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1415457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1415460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1415466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415485 */     // MIs[0] Operand 5
     /* 1415485 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415496 */     // MIs[0] policy
     /* 1415496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1415509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415528 */     // GIR_Coverage, 21515,
     /* 1415528 */     GIR_EraseRootFromParent_Done,
     /* 1415529 */   // Label 20042: @1415529
     /* 1415529 */   GIM_Try, /*On fail goto*//*Label 20043*/ GIMT_Encode4(1415617), // Rule ID 21518 //
     /* 1415534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1415545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1415548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1415551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1415554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415573 */     // MIs[0] Operand 5
     /* 1415573 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415584 */     // MIs[0] policy
     /* 1415584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1415597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415616 */     // GIR_Coverage, 21518,
     /* 1415616 */     GIR_EraseRootFromParent_Done,
     /* 1415617 */   // Label 20043: @1415617
     /* 1415617 */   GIM_Try, /*On fail goto*//*Label 20044*/ GIMT_Encode4(1415705), // Rule ID 21519 //
     /* 1415622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1415633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1415636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1415639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1415642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415661 */     // MIs[0] Operand 5
     /* 1415661 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415672 */     // MIs[0] policy
     /* 1415672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1415685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415704 */     // GIR_Coverage, 21519,
     /* 1415704 */     GIR_EraseRootFromParent_Done,
     /* 1415705 */   // Label 20044: @1415705
     /* 1415705 */   GIM_Try, /*On fail goto*//*Label 20045*/ GIMT_Encode4(1415793), // Rule ID 21522 //
     /* 1415710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1415713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1415721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1415724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1415727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415749 */     // MIs[0] Operand 5
     /* 1415749 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415760 */     // MIs[0] policy
     /* 1415760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415770 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1415773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415792 */     // GIR_Coverage, 21522,
     /* 1415792 */     GIR_EraseRootFromParent_Done,
     /* 1415793 */   // Label 20045: @1415793
     /* 1415793 */   GIM_Try, /*On fail goto*//*Label 20046*/ GIMT_Encode4(1415881), // Rule ID 21523 //
     /* 1415798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1415801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1415809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1415812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1415815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1415818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415837 */     // MIs[0] Operand 5
     /* 1415837 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415848 */     // MIs[0] policy
     /* 1415848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1415861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415880 */     // GIR_Coverage, 21523,
     /* 1415880 */     GIR_EraseRootFromParent_Done,
     /* 1415881 */   // Label 20046: @1415881
     /* 1415881 */   GIM_Try, /*On fail goto*//*Label 20047*/ GIMT_Encode4(1415969), // Rule ID 21526 //
     /* 1415886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1415889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1415897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1415900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1415903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1415913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1415921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415925 */     // MIs[0] Operand 5
     /* 1415925 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1415936 */     // MIs[0] policy
     /* 1415936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1415949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1415955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1415957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415968 */     // GIR_Coverage, 21526,
     /* 1415968 */     GIR_EraseRootFromParent_Done,
     /* 1415969 */   // Label 20047: @1415969
     /* 1415969 */   GIM_Try, /*On fail goto*//*Label 20048*/ GIMT_Encode4(1416057), // Rule ID 21527 //
     /* 1415974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1415977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1415982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1415985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1415988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1415991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1415994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416013 */     // MIs[0] Operand 5
     /* 1416013 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416024 */     // MIs[0] policy
     /* 1416024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1416037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416056 */     // GIR_Coverage, 21527,
     /* 1416056 */     GIR_EraseRootFromParent_Done,
     /* 1416057 */   // Label 20048: @1416057
     /* 1416057 */   GIM_Try, /*On fail goto*//*Label 20049*/ GIMT_Encode4(1416145), // Rule ID 21530 //
     /* 1416062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416101 */     // MIs[0] Operand 5
     /* 1416101 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416112 */     // MIs[0] policy
     /* 1416112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1416125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416144 */     // GIR_Coverage, 21530,
     /* 1416144 */     GIR_EraseRootFromParent_Done,
     /* 1416145 */   // Label 20049: @1416145
     /* 1416145 */   GIM_Try, /*On fail goto*//*Label 20050*/ GIMT_Encode4(1416233), // Rule ID 21531 //
     /* 1416150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1416161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1416164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416189 */     // MIs[0] Operand 5
     /* 1416189 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416200 */     // MIs[0] policy
     /* 1416200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416210 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1416213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416232 */     // GIR_Coverage, 21531,
     /* 1416232 */     GIR_EraseRootFromParent_Done,
     /* 1416233 */   // Label 20050: @1416233
     /* 1416233 */   GIM_Try, /*On fail goto*//*Label 20051*/ GIMT_Encode4(1416321), // Rule ID 21534 //
     /* 1416238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416277 */     // MIs[0] Operand 5
     /* 1416277 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416288 */     // MIs[0] policy
     /* 1416288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416320 */     // GIR_Coverage, 21534,
     /* 1416320 */     GIR_EraseRootFromParent_Done,
     /* 1416321 */   // Label 20051: @1416321
     /* 1416321 */   GIM_Try, /*On fail goto*//*Label 20052*/ GIMT_Encode4(1416409), // Rule ID 21535 //
     /* 1416326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1416337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1416340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416365 */     // MIs[0] Operand 5
     /* 1416365 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416376 */     // MIs[0] policy
     /* 1416376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416386 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1416389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416408 */     // GIR_Coverage, 21535,
     /* 1416408 */     GIR_EraseRootFromParent_Done,
     /* 1416409 */   // Label 20052: @1416409
     /* 1416409 */   GIM_Try, /*On fail goto*//*Label 20053*/ GIMT_Encode4(1416497), // Rule ID 21538 //
     /* 1416414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1416417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416453 */     // MIs[0] Operand 5
     /* 1416453 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416464 */     // MIs[0] policy
     /* 1416464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416474 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416496 */     // GIR_Coverage, 21538,
     /* 1416496 */     GIR_EraseRootFromParent_Done,
     /* 1416497 */   // Label 20053: @1416497
     /* 1416497 */   GIM_Try, /*On fail goto*//*Label 20054*/ GIMT_Encode4(1416585), // Rule ID 21539 //
     /* 1416502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1416505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1416510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1416522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416541 */     // MIs[0] Operand 5
     /* 1416541 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416552 */     // MIs[0] policy
     /* 1416552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416562 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1416565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416584 */     // GIR_Coverage, 21539,
     /* 1416584 */     GIR_EraseRootFromParent_Done,
     /* 1416585 */   // Label 20054: @1416585
     /* 1416585 */   GIM_Try, /*On fail goto*//*Label 20055*/ GIMT_Encode4(1416673), // Rule ID 21542 //
     /* 1416590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1416601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1416604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1416607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416629 */     // MIs[0] Operand 5
     /* 1416629 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416640 */     // MIs[0] policy
     /* 1416640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416650 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1416653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1416669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416672 */     // GIR_Coverage, 21542,
     /* 1416672 */     GIR_EraseRootFromParent_Done,
     /* 1416673 */   // Label 20055: @1416673
     /* 1416673 */   GIM_Try, /*On fail goto*//*Label 20056*/ GIMT_Encode4(1416761), // Rule ID 21543 //
     /* 1416678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1416681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1416689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1416692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1416695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1416698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416717 */     // MIs[0] Operand 5
     /* 1416717 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416728 */     // MIs[0] policy
     /* 1416728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416738 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1416741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1416757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416760 */     // GIR_Coverage, 21543,
     /* 1416760 */     GIR_EraseRootFromParent_Done,
     /* 1416761 */   // Label 20056: @1416761
     /* 1416761 */   GIM_Try, /*On fail goto*//*Label 20057*/ GIMT_Encode4(1416849), // Rule ID 21546 //
     /* 1416766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1416777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1416780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1416783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416805 */     // MIs[0] Operand 5
     /* 1416805 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416816 */     // MIs[0] policy
     /* 1416816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416826 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1416829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1416845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416848 */     // GIR_Coverage, 21546,
     /* 1416848 */     GIR_EraseRootFromParent_Done,
     /* 1416849 */   // Label 20057: @1416849
     /* 1416849 */   GIM_Try, /*On fail goto*//*Label 20058*/ GIMT_Encode4(1416937), // Rule ID 21547 //
     /* 1416854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1416857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1416865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1416868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1416871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1416874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416893 */     // MIs[0] Operand 5
     /* 1416893 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416904 */     // MIs[0] policy
     /* 1416904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416914 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1416917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1416923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1416925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1416933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416936 */     // GIR_Coverage, 21547,
     /* 1416936 */     GIR_EraseRootFromParent_Done,
     /* 1416937 */   // Label 20058: @1416937
     /* 1416937 */   GIM_Try, /*On fail goto*//*Label 20059*/ GIMT_Encode4(1417025), // Rule ID 21550 //
     /* 1416942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1416945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1416950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1416953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1416956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1416959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1416962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1416969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1416977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416981 */     // MIs[0] Operand 5
     /* 1416981 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1416992 */     // MIs[0] policy
     /* 1416992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417002 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417024 */     // GIR_Coverage, 21550,
     /* 1417024 */     GIR_EraseRootFromParent_Done,
     /* 1417025 */   // Label 20059: @1417025
     /* 1417025 */   GIM_Try, /*On fail goto*//*Label 20060*/ GIMT_Encode4(1417113), // Rule ID 21551 //
     /* 1417030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1417047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1417050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417069 */     // MIs[0] Operand 5
     /* 1417069 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417080 */     // MIs[0] policy
     /* 1417080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417090 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417112 */     // GIR_Coverage, 21551,
     /* 1417112 */     GIR_EraseRootFromParent_Done,
     /* 1417113 */   // Label 20060: @1417113
     /* 1417113 */   GIM_Try, /*On fail goto*//*Label 20061*/ GIMT_Encode4(1417201), // Rule ID 21554 //
     /* 1417118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1417129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1417132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1417135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417157 */     // MIs[0] Operand 5
     /* 1417157 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417168 */     // MIs[0] policy
     /* 1417168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417178 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1417181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417200 */     // GIR_Coverage, 21554,
     /* 1417200 */     GIR_EraseRootFromParent_Done,
     /* 1417201 */   // Label 20061: @1417201
     /* 1417201 */   GIM_Try, /*On fail goto*//*Label 20062*/ GIMT_Encode4(1417289), // Rule ID 21555 //
     /* 1417206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1417217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1417220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1417223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1417226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417245 */     // MIs[0] Operand 5
     /* 1417245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417256 */     // MIs[0] policy
     /* 1417256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1417269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417288 */     // GIR_Coverage, 21555,
     /* 1417288 */     GIR_EraseRootFromParent_Done,
     /* 1417289 */   // Label 20062: @1417289
     /* 1417289 */   GIM_Try, /*On fail goto*//*Label 20063*/ GIMT_Encode4(1417377), // Rule ID 21558 //
     /* 1417294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1417305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1417308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1417311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1417314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417333 */     // MIs[0] Operand 5
     /* 1417333 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417344 */     // MIs[0] policy
     /* 1417344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417354 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1417357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417376 */     // GIR_Coverage, 21558,
     /* 1417376 */     GIR_EraseRootFromParent_Done,
     /* 1417377 */   // Label 20063: @1417377
     /* 1417377 */   GIM_Try, /*On fail goto*//*Label 20064*/ GIMT_Encode4(1417465), // Rule ID 21559 //
     /* 1417382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1417393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1417396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1417399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1417402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1417409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1417413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417421 */     // MIs[0] Operand 5
     /* 1417421 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417432 */     // MIs[0] policy
     /* 1417432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417442 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1417445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417464 */     // GIR_Coverage, 21559,
     /* 1417464 */     GIR_EraseRootFromParent_Done,
     /* 1417465 */   // Label 20064: @1417465
     /* 1417465 */   GIM_Try, /*On fail goto*//*Label 20065*/ GIMT_Encode4(1417553), // Rule ID 21562 //
     /* 1417470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1417473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1417481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1417484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1417487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1417490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1417497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417509 */     // MIs[0] Operand 5
     /* 1417509 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417520 */     // MIs[0] policy
     /* 1417520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417530 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1417533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417552 */     // GIR_Coverage, 21562,
     /* 1417552 */     GIR_EraseRootFromParent_Done,
     /* 1417553 */   // Label 20065: @1417553
     /* 1417553 */   GIM_Try, /*On fail goto*//*Label 20066*/ GIMT_Encode4(1417641), // Rule ID 21563 //
     /* 1417558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1417561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1417569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1417572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1417575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1417578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1417585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1417589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1417593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417597 */     // MIs[0] Operand 5
     /* 1417597 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417608 */     // MIs[0] policy
     /* 1417608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1417621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417640 */     // GIR_Coverage, 21563,
     /* 1417640 */     GIR_EraseRootFromParent_Done,
     /* 1417641 */   // Label 20066: @1417641
     /* 1417641 */   GIM_Try, /*On fail goto*//*Label 20067*/ GIMT_Encode4(1417729), // Rule ID 21566 //
     /* 1417646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1417649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1417657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1417660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1417663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417685 */     // MIs[0] Operand 5
     /* 1417685 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417696 */     // MIs[0] policy
     /* 1417696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1417709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417728 */     // GIR_Coverage, 21566,
     /* 1417728 */     GIR_EraseRootFromParent_Done,
     /* 1417729 */   // Label 20067: @1417729
     /* 1417729 */   GIM_Try, /*On fail goto*//*Label 20068*/ GIMT_Encode4(1417817), // Rule ID 21567 //
     /* 1417734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1417737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1417745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1417748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1417751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1417754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417773 */     // MIs[0] Operand 5
     /* 1417773 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417784 */     // MIs[0] policy
     /* 1417784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1417797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417803 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417816 */     // GIR_Coverage, 21567,
     /* 1417816 */     GIR_EraseRootFromParent_Done,
     /* 1417817 */   // Label 20068: @1417817
     /* 1417817 */   GIM_Try, /*On fail goto*//*Label 20069*/ GIMT_Encode4(1417905), // Rule ID 21570 //
     /* 1417822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1417825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1417833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1417836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1417839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417861 */     // MIs[0] Operand 5
     /* 1417861 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417872 */     // MIs[0] policy
     /* 1417872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417882 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417904 */     // GIR_Coverage, 21570,
     /* 1417904 */     GIR_EraseRootFromParent_Done,
     /* 1417905 */   // Label 20069: @1417905
     /* 1417905 */   GIM_Try, /*On fail goto*//*Label 20070*/ GIMT_Encode4(1417993), // Rule ID 21571 //
     /* 1417910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1417913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1417918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1417921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1417924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1417927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1417930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417949 */     // MIs[0] Operand 5
     /* 1417949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1417960 */     // MIs[0] policy
     /* 1417960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417970 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1417973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1417979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1417981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417992 */     // GIR_Coverage, 21571,
     /* 1417992 */     GIR_EraseRootFromParent_Done,
     /* 1417993 */   // Label 20070: @1417993
     /* 1417993 */   GIM_Try, /*On fail goto*//*Label 20071*/ GIMT_Encode4(1418081), // Rule ID 21574 //
     /* 1417998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1418015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418037 */     // MIs[0] Operand 5
     /* 1418037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418048 */     // MIs[0] policy
     /* 1418048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418080 */     // GIR_Coverage, 21574,
     /* 1418080 */     GIR_EraseRootFromParent_Done,
     /* 1418081 */   // Label 20071: @1418081
     /* 1418081 */   GIM_Try, /*On fail goto*//*Label 20072*/ GIMT_Encode4(1418169), // Rule ID 21575 //
     /* 1418086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1418103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418125 */     // MIs[0] Operand 5
     /* 1418125 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418136 */     // MIs[0] policy
     /* 1418136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418168 */     // GIR_Coverage, 21575,
     /* 1418168 */     GIR_EraseRootFromParent_Done,
     /* 1418169 */   // Label 20072: @1418169
     /* 1418169 */   GIM_Try, /*On fail goto*//*Label 20073*/ GIMT_Encode4(1418257), // Rule ID 21578 //
     /* 1418174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1418185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1418188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1418191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418213 */     // MIs[0] Operand 5
     /* 1418213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418224 */     // MIs[0] policy
     /* 1418224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418256 */     // GIR_Coverage, 21578,
     /* 1418256 */     GIR_EraseRootFromParent_Done,
     /* 1418257 */   // Label 20073: @1418257
     /* 1418257 */   GIM_Try, /*On fail goto*//*Label 20074*/ GIMT_Encode4(1418345), // Rule ID 21579 //
     /* 1418262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1418273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1418276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1418279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1418282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418301 */     // MIs[0] Operand 5
     /* 1418301 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418312 */     // MIs[0] policy
     /* 1418312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418322 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418344 */     // GIR_Coverage, 21579,
     /* 1418344 */     GIR_EraseRootFromParent_Done,
     /* 1418345 */   // Label 20074: @1418345
     /* 1418345 */   GIM_Try, /*On fail goto*//*Label 20075*/ GIMT_Encode4(1418433), // Rule ID 21582 //
     /* 1418350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1418353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1418361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1418364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1418367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418389 */     // MIs[0] Operand 5
     /* 1418389 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418400 */     // MIs[0] policy
     /* 1418400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418410 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418432 */     // GIR_Coverage, 21582,
     /* 1418432 */     GIR_EraseRootFromParent_Done,
     /* 1418433 */   // Label 20075: @1418433
     /* 1418433 */   GIM_Try, /*On fail goto*//*Label 20076*/ GIMT_Encode4(1418521), // Rule ID 21583 //
     /* 1418438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1418441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1418449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1418452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1418455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1418458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1418465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1418473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418477 */     // MIs[0] Operand 5
     /* 1418477 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418488 */     // MIs[0] policy
     /* 1418488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418498 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1418501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418520 */     // GIR_Coverage, 21583,
     /* 1418520 */     GIR_EraseRootFromParent_Done,
     /* 1418521 */   // Label 20076: @1418521
     /* 1418521 */   GIM_Try, /*On fail goto*//*Label 20077*/ GIMT_Encode4(1418609), // Rule ID 21586 //
     /* 1418526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1418529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1418537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1418540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1418543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418565 */     // MIs[0] Operand 5
     /* 1418565 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418576 */     // MIs[0] policy
     /* 1418576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1418589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418608 */     // GIR_Coverage, 21586,
     /* 1418608 */     GIR_EraseRootFromParent_Done,
     /* 1418609 */   // Label 20077: @1418609
     /* 1418609 */   GIM_Try, /*On fail goto*//*Label 20078*/ GIMT_Encode4(1418697), // Rule ID 21587 //
     /* 1418614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1418617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1418625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1418628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1418631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1418634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418653 */     // MIs[0] Operand 5
     /* 1418653 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418664 */     // MIs[0] policy
     /* 1418664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418674 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1418677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418696 */     // GIR_Coverage, 21587,
     /* 1418696 */     GIR_EraseRootFromParent_Done,
     /* 1418697 */   // Label 20078: @1418697
     /* 1418697 */   GIM_Try, /*On fail goto*//*Label 20079*/ GIMT_Encode4(1418785), // Rule ID 21590 //
     /* 1418702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1418705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1418719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1418722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418741 */     // MIs[0] Operand 5
     /* 1418741 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418752 */     // MIs[0] policy
     /* 1418752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418784 */     // GIR_Coverage, 21590,
     /* 1418784 */     GIR_EraseRootFromParent_Done,
     /* 1418785 */   // Label 20079: @1418785
     /* 1418785 */   GIM_Try, /*On fail goto*//*Label 20080*/ GIMT_Encode4(1418873), // Rule ID 21591 //
     /* 1418790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1418793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1418807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1418810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418829 */     // MIs[0] Operand 5
     /* 1418829 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418840 */     // MIs[0] policy
     /* 1418840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1418853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418872 */     // GIR_Coverage, 21591,
     /* 1418872 */     GIR_EraseRootFromParent_Done,
     /* 1418873 */   // Label 20080: @1418873
     /* 1418873 */   GIM_Try, /*On fail goto*//*Label 20081*/ GIMT_Encode4(1418961), // Rule ID 21594 //
     /* 1418878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1418881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1418889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1418892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1418895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1418913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418917 */     // MIs[0] Operand 5
     /* 1418917 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1418928 */     // MIs[0] policy
     /* 1418928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1418941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1418947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1418949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418960 */     // GIR_Coverage, 21594,
     /* 1418960 */     GIR_EraseRootFromParent_Done,
     /* 1418961 */   // Label 20081: @1418961
     /* 1418961 */   GIM_Try, /*On fail goto*//*Label 20082*/ GIMT_Encode4(1419049), // Rule ID 21595 //
     /* 1418966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1418969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1418974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1418977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1418980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1418983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1418986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419005 */     // MIs[0] Operand 5
     /* 1419005 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419016 */     // MIs[0] policy
     /* 1419016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1419029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419048 */     // GIR_Coverage, 21595,
     /* 1419048 */     GIR_EraseRootFromParent_Done,
     /* 1419049 */   // Label 20082: @1419049
     /* 1419049 */   GIM_Try, /*On fail goto*//*Label 20083*/ GIMT_Encode4(1419137), // Rule ID 21598 //
     /* 1419054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1419057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1419071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419093 */     // MIs[0] Operand 5
     /* 1419093 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419104 */     // MIs[0] policy
     /* 1419104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419114 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1419117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419136 */     // GIR_Coverage, 21598,
     /* 1419136 */     GIR_EraseRootFromParent_Done,
     /* 1419137 */   // Label 20083: @1419137
     /* 1419137 */   GIM_Try, /*On fail goto*//*Label 20084*/ GIMT_Encode4(1419225), // Rule ID 21599 //
     /* 1419142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1419145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1419150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1419153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1419156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1419159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1419162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419181 */     // MIs[0] Operand 5
     /* 1419181 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1419192 */     // MIs[0] policy
     /* 1419192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419202 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1419205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1419211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1419213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1419221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419224 */     // GIR_Coverage, 21599,
     /* 1419224 */     GIR_EraseRootFromParent_Done,
     /* 1419225 */   // Label 20084: @1419225
     /* 1419225 */   GIM_Try, /*On fail goto*//*Label 20085*/ GIMT_Encode4(1419324), // Rule ID 2796 //
     /* 1419230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1419241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1419244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1419247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419280 */     // MIs[1] Operand 1
     /* 1419280 */     // No operand predicates
     /* 1419280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419284 */     // MIs[0] policy
     /* 1419284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1419299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419305 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419320 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419323 */     // GIR_Coverage, 2796,
     /* 1419323 */     GIR_EraseRootFromParent_Done,
     /* 1419324 */   // Label 20085: @1419324
     /* 1419324 */   GIM_Try, /*On fail goto*//*Label 20086*/ GIMT_Encode4(1419423), // Rule ID 2797 //
     /* 1419329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1419340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1419343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1419346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419379 */     // MIs[1] Operand 1
     /* 1419379 */     // No operand predicates
     /* 1419379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419383 */     // MIs[0] policy
     /* 1419383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419395 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1419398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419404 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419422 */     // GIR_Coverage, 2797,
     /* 1419422 */     GIR_EraseRootFromParent_Done,
     /* 1419423 */   // Label 20086: @1419423
     /* 1419423 */   GIM_Try, /*On fail goto*//*Label 20087*/ GIMT_Encode4(1419522), // Rule ID 2804 //
     /* 1419428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1419439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1419442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1419445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1419451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419478 */     // MIs[1] Operand 1
     /* 1419478 */     // No operand predicates
     /* 1419478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419482 */     // MIs[0] policy
     /* 1419482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419494 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1419497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419503 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419521 */     // GIR_Coverage, 2804,
     /* 1419521 */     GIR_EraseRootFromParent_Done,
     /* 1419522 */   // Label 20087: @1419522
     /* 1419522 */   GIM_Try, /*On fail goto*//*Label 20088*/ GIMT_Encode4(1419621), // Rule ID 2805 //
     /* 1419527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1419538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1419541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1419544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1419550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419577 */     // MIs[1] Operand 1
     /* 1419577 */     // No operand predicates
     /* 1419577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419581 */     // MIs[0] policy
     /* 1419581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419593 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1419596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419602 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419620 */     // GIR_Coverage, 2805,
     /* 1419620 */     GIR_EraseRootFromParent_Done,
     /* 1419621 */   // Label 20088: @1419621
     /* 1419621 */   GIM_Try, /*On fail goto*//*Label 20089*/ GIMT_Encode4(1419720), // Rule ID 2812 //
     /* 1419626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1419637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1419640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1419643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1419649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419676 */     // MIs[1] Operand 1
     /* 1419676 */     // No operand predicates
     /* 1419676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419680 */     // MIs[0] policy
     /* 1419680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419692 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1419695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419701 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419719 */     // GIR_Coverage, 2812,
     /* 1419719 */     GIR_EraseRootFromParent_Done,
     /* 1419720 */   // Label 20089: @1419720
     /* 1419720 */   GIM_Try, /*On fail goto*//*Label 20090*/ GIMT_Encode4(1419819), // Rule ID 2813 //
     /* 1419725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1419736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1419739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1419742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1419748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419775 */     // MIs[1] Operand 1
     /* 1419775 */     // No operand predicates
     /* 1419775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419779 */     // MIs[0] policy
     /* 1419779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419791 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1419794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419800 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419818 */     // GIR_Coverage, 2813,
     /* 1419818 */     GIR_EraseRootFromParent_Done,
     /* 1419819 */   // Label 20090: @1419819
     /* 1419819 */   GIM_Try, /*On fail goto*//*Label 20091*/ GIMT_Encode4(1419918), // Rule ID 2820 //
     /* 1419824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1419835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1419838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1419841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419874 */     // MIs[1] Operand 1
     /* 1419874 */     // No operand predicates
     /* 1419874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419878 */     // MIs[0] policy
     /* 1419878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1419893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419899 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1419904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419917 */     // GIR_Coverage, 2820,
     /* 1419917 */     GIR_EraseRootFromParent_Done,
     /* 1419918 */   // Label 20091: @1419918
     /* 1419918 */   GIM_Try, /*On fail goto*//*Label 20092*/ GIMT_Encode4(1420017), // Rule ID 2821 //
     /* 1419923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1419931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1419934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1419937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1419940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1419946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1419953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1419961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1419973 */     // MIs[1] Operand 1
     /* 1419973 */     // No operand predicates
     /* 1419973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419977 */     // MIs[0] policy
     /* 1419977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419989 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1419992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419998 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420016 */     // GIR_Coverage, 2821,
     /* 1420016 */     GIR_EraseRootFromParent_Done,
     /* 1420017 */   // Label 20092: @1420017
     /* 1420017 */   GIM_Try, /*On fail goto*//*Label 20093*/ GIMT_Encode4(1420116), // Rule ID 2828 //
     /* 1420022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420072 */     // MIs[1] Operand 1
     /* 1420072 */     // No operand predicates
     /* 1420072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420076 */     // MIs[0] policy
     /* 1420076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420088 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420097 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420115 */     // GIR_Coverage, 2828,
     /* 1420115 */     GIR_EraseRootFromParent_Done,
     /* 1420116 */   // Label 20093: @1420116
     /* 1420116 */   GIM_Try, /*On fail goto*//*Label 20094*/ GIMT_Encode4(1420215), // Rule ID 2829 //
     /* 1420121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1420132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1420135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1420138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420171 */     // MIs[1] Operand 1
     /* 1420171 */     // No operand predicates
     /* 1420171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420175 */     // MIs[0] policy
     /* 1420175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420187 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420196 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420214 */     // GIR_Coverage, 2829,
     /* 1420214 */     GIR_EraseRootFromParent_Done,
     /* 1420215 */   // Label 20094: @1420215
     /* 1420215 */   GIM_Try, /*On fail goto*//*Label 20095*/ GIMT_Encode4(1420314), // Rule ID 2836 //
     /* 1420220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1420231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1420234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1420237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420270 */     // MIs[1] Operand 1
     /* 1420270 */     // No operand predicates
     /* 1420270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420274 */     // MIs[0] policy
     /* 1420274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420286 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420295 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420313 */     // GIR_Coverage, 2836,
     /* 1420313 */     GIR_EraseRootFromParent_Done,
     /* 1420314 */   // Label 20095: @1420314
     /* 1420314 */   GIM_Try, /*On fail goto*//*Label 20096*/ GIMT_Encode4(1420413), // Rule ID 2837 //
     /* 1420319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1420330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1420333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1420336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1420342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420369 */     // MIs[1] Operand 1
     /* 1420369 */     // No operand predicates
     /* 1420369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420373 */     // MIs[0] policy
     /* 1420373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420385 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1420388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420394 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420412 */     // GIR_Coverage, 2837,
     /* 1420412 */     GIR_EraseRootFromParent_Done,
     /* 1420413 */   // Label 20096: @1420413
     /* 1420413 */   GIM_Try, /*On fail goto*//*Label 20097*/ GIMT_Encode4(1420512), // Rule ID 2844 //
     /* 1420418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1420429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1420432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1420435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420468 */     // MIs[1] Operand 1
     /* 1420468 */     // No operand predicates
     /* 1420468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420472 */     // MIs[0] policy
     /* 1420472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420484 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420493 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420511 */     // GIR_Coverage, 2844,
     /* 1420511 */     GIR_EraseRootFromParent_Done,
     /* 1420512 */   // Label 20097: @1420512
     /* 1420512 */   GIM_Try, /*On fail goto*//*Label 20098*/ GIMT_Encode4(1420611), // Rule ID 2845 //
     /* 1420517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1420528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1420531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1420534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420567 */     // MIs[1] Operand 1
     /* 1420567 */     // No operand predicates
     /* 1420567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420571 */     // MIs[0] policy
     /* 1420571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420583 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420592 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1420607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420610 */     // GIR_Coverage, 2845,
     /* 1420610 */     GIR_EraseRootFromParent_Done,
     /* 1420611 */   // Label 20098: @1420611
     /* 1420611 */   GIM_Try, /*On fail goto*//*Label 20099*/ GIMT_Encode4(1420710), // Rule ID 2852 //
     /* 1420616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1420627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1420630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1420633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420666 */     // MIs[1] Operand 1
     /* 1420666 */     // No operand predicates
     /* 1420666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420670 */     // MIs[0] policy
     /* 1420670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420691 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420709 */     // GIR_Coverage, 2852,
     /* 1420709 */     GIR_EraseRootFromParent_Done,
     /* 1420710 */   // Label 20099: @1420710
     /* 1420710 */   GIM_Try, /*On fail goto*//*Label 20100*/ GIMT_Encode4(1420809), // Rule ID 2853 //
     /* 1420715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1420726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1420729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1420732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420765 */     // MIs[1] Operand 1
     /* 1420765 */     // No operand predicates
     /* 1420765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420769 */     // MIs[0] policy
     /* 1420769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420781 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420790 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420808 */     // GIR_Coverage, 2853,
     /* 1420808 */     GIR_EraseRootFromParent_Done,
     /* 1420809 */   // Label 20100: @1420809
     /* 1420809 */   GIM_Try, /*On fail goto*//*Label 20101*/ GIMT_Encode4(1420908), // Rule ID 2860 //
     /* 1420814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1420825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1420828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1420831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420864 */     // MIs[1] Operand 1
     /* 1420864 */     // No operand predicates
     /* 1420864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420868 */     // MIs[0] policy
     /* 1420868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420889 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420907 */     // GIR_Coverage, 2860,
     /* 1420907 */     GIR_EraseRootFromParent_Done,
     /* 1420908 */   // Label 20101: @1420908
     /* 1420908 */   GIM_Try, /*On fail goto*//*Label 20102*/ GIMT_Encode4(1421007), // Rule ID 2861 //
     /* 1420913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1420921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1420924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1420927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1420930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1420943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1420951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1420963 */     // MIs[1] Operand 1
     /* 1420963 */     // No operand predicates
     /* 1420963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420967 */     // MIs[0] policy
     /* 1420967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420979 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1420982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420988 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1420993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1421003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421006 */     // GIR_Coverage, 2861,
     /* 1421006 */     GIR_EraseRootFromParent_Done,
     /* 1421007 */   // Label 20102: @1421007
     /* 1421007 */   GIM_Try, /*On fail goto*//*Label 20103*/ GIMT_Encode4(1421106), // Rule ID 2868 //
     /* 1421012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1421015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421062 */     // MIs[1] Operand 1
     /* 1421062 */     // No operand predicates
     /* 1421062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421066 */     // MIs[0] policy
     /* 1421066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421078 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421087 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421105 */     // GIR_Coverage, 2868,
     /* 1421105 */     GIR_EraseRootFromParent_Done,
     /* 1421106 */   // Label 20103: @1421106
     /* 1421106 */   GIM_Try, /*On fail goto*//*Label 20104*/ GIMT_Encode4(1421205), // Rule ID 2869 //
     /* 1421111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1421114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1421122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1421125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1421128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421161 */     // MIs[1] Operand 1
     /* 1421161 */     // No operand predicates
     /* 1421161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421165 */     // MIs[0] policy
     /* 1421165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1421180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421186 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421204 */     // GIR_Coverage, 2869,
     /* 1421204 */     GIR_EraseRootFromParent_Done,
     /* 1421205 */   // Label 20104: @1421205
     /* 1421205 */   GIM_Try, /*On fail goto*//*Label 20105*/ GIMT_Encode4(1421304), // Rule ID 2876 //
     /* 1421210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1421227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1421233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421260 */     // MIs[1] Operand 1
     /* 1421260 */     // No operand predicates
     /* 1421260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421264 */     // MIs[0] policy
     /* 1421264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421276 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421285 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421303 */     // GIR_Coverage, 2876,
     /* 1421303 */     GIR_EraseRootFromParent_Done,
     /* 1421304 */   // Label 20105: @1421304
     /* 1421304 */   GIM_Try, /*On fail goto*//*Label 20106*/ GIMT_Encode4(1421403), // Rule ID 2877 //
     /* 1421309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1421320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1421323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1421326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1421332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421359 */     // MIs[1] Operand 1
     /* 1421359 */     // No operand predicates
     /* 1421359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421363 */     // MIs[0] policy
     /* 1421363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421375 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421384 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421402 */     // GIR_Coverage, 2877,
     /* 1421402 */     GIR_EraseRootFromParent_Done,
     /* 1421403 */   // Label 20106: @1421403
     /* 1421403 */   GIM_Try, /*On fail goto*//*Label 20107*/ GIMT_Encode4(1421502), // Rule ID 2884 //
     /* 1421408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1421425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1421431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421458 */     // MIs[1] Operand 1
     /* 1421458 */     // No operand predicates
     /* 1421458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421462 */     // MIs[0] policy
     /* 1421462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421474 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1421477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421483 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421498 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421501 */     // GIR_Coverage, 2884,
     /* 1421501 */     GIR_EraseRootFromParent_Done,
     /* 1421502 */   // Label 20107: @1421502
     /* 1421502 */   GIM_Try, /*On fail goto*//*Label 20108*/ GIMT_Encode4(1421601), // Rule ID 2885 //
     /* 1421507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1421518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1421521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1421524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1421530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421557 */     // MIs[1] Operand 1
     /* 1421557 */     // No operand predicates
     /* 1421557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421561 */     // MIs[0] policy
     /* 1421561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421573 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1421576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421582 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421600 */     // GIR_Coverage, 2885,
     /* 1421600 */     GIR_EraseRootFromParent_Done,
     /* 1421601 */   // Label 20108: @1421601
     /* 1421601 */   GIM_Try, /*On fail goto*//*Label 20109*/ GIMT_Encode4(1421700), // Rule ID 2892 //
     /* 1421606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1421617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1421620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1421623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1421629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1421636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421656 */     // MIs[1] Operand 1
     /* 1421656 */     // No operand predicates
     /* 1421656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421660 */     // MIs[0] policy
     /* 1421660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421672 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1421675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421681 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421699 */     // GIR_Coverage, 2892,
     /* 1421699 */     GIR_EraseRootFromParent_Done,
     /* 1421700 */   // Label 20109: @1421700
     /* 1421700 */   GIM_Try, /*On fail goto*//*Label 20110*/ GIMT_Encode4(1421799), // Rule ID 2893 //
     /* 1421705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1421716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1421719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1421722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1421728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1421735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421755 */     // MIs[1] Operand 1
     /* 1421755 */     // No operand predicates
     /* 1421755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421759 */     // MIs[0] policy
     /* 1421759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421771 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1421774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421780 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421798 */     // GIR_Coverage, 2893,
     /* 1421798 */     GIR_EraseRootFromParent_Done,
     /* 1421799 */   // Label 20110: @1421799
     /* 1421799 */   GIM_Try, /*On fail goto*//*Label 20111*/ GIMT_Encode4(1421898), // Rule ID 2900 //
     /* 1421804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1421815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1421818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1421821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421854 */     // MIs[1] Operand 1
     /* 1421854 */     // No operand predicates
     /* 1421854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421858 */     // MIs[0] policy
     /* 1421858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421870 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421879 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421897 */     // GIR_Coverage, 2900,
     /* 1421897 */     GIR_EraseRootFromParent_Done,
     /* 1421898 */   // Label 20111: @1421898
     /* 1421898 */   GIM_Try, /*On fail goto*//*Label 20112*/ GIMT_Encode4(1421997), // Rule ID 2901 //
     /* 1421903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1421911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1421914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1421917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1421920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1421933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1421941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1421953 */     // MIs[1] Operand 1
     /* 1421953 */     // No operand predicates
     /* 1421953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421957 */     // MIs[0] policy
     /* 1421957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1421972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421978 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1421983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421996 */     // GIR_Coverage, 2901,
     /* 1421996 */     GIR_EraseRootFromParent_Done,
     /* 1421997 */   // Label 20112: @1421997
     /* 1421997 */   GIM_Try, /*On fail goto*//*Label 20113*/ GIMT_Encode4(1422096), // Rule ID 2908 //
     /* 1422002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1422019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422052 */     // MIs[1] Operand 1
     /* 1422052 */     // No operand predicates
     /* 1422052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422056 */     // MIs[0] policy
     /* 1422056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422068 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422077 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422095 */     // GIR_Coverage, 2908,
     /* 1422095 */     GIR_EraseRootFromParent_Done,
     /* 1422096 */   // Label 20113: @1422096
     /* 1422096 */   GIM_Try, /*On fail goto*//*Label 20114*/ GIMT_Encode4(1422195), // Rule ID 2909 //
     /* 1422101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1422112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1422115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1422118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422151 */     // MIs[1] Operand 1
     /* 1422151 */     // No operand predicates
     /* 1422151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422155 */     // MIs[0] policy
     /* 1422155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422167 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422176 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422194 */     // GIR_Coverage, 2909,
     /* 1422194 */     GIR_EraseRootFromParent_Done,
     /* 1422195 */   // Label 20114: @1422195
     /* 1422195 */   GIM_Try, /*On fail goto*//*Label 20115*/ GIMT_Encode4(1422294), // Rule ID 2916 //
     /* 1422200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1422211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1422214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1422217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1422223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422250 */     // MIs[1] Operand 1
     /* 1422250 */     // No operand predicates
     /* 1422250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422254 */     // MIs[0] policy
     /* 1422254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422266 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422275 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422293 */     // GIR_Coverage, 2916,
     /* 1422293 */     GIR_EraseRootFromParent_Done,
     /* 1422294 */   // Label 20115: @1422294
     /* 1422294 */   GIM_Try, /*On fail goto*//*Label 20116*/ GIMT_Encode4(1422393), // Rule ID 2917 //
     /* 1422299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1422310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1422313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1422316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1422322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422349 */     // MIs[1] Operand 1
     /* 1422349 */     // No operand predicates
     /* 1422349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422353 */     // MIs[0] policy
     /* 1422353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422365 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422374 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422392 */     // GIR_Coverage, 2917,
     /* 1422392 */     GIR_EraseRootFromParent_Done,
     /* 1422393 */   // Label 20116: @1422393
     /* 1422393 */   GIM_Try, /*On fail goto*//*Label 20117*/ GIMT_Encode4(1422492), // Rule ID 2924 //
     /* 1422398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422448 */     // MIs[1] Operand 1
     /* 1422448 */     // No operand predicates
     /* 1422448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422452 */     // MIs[0] policy
     /* 1422452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422473 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422491 */     // GIR_Coverage, 2924,
     /* 1422491 */     GIR_EraseRootFromParent_Done,
     /* 1422492 */   // Label 20117: @1422492
     /* 1422492 */   GIM_Try, /*On fail goto*//*Label 20118*/ GIMT_Encode4(1422591), // Rule ID 2925 //
     /* 1422497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1422508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1422511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1422514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1422527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1422535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422547 */     // MIs[1] Operand 1
     /* 1422547 */     // No operand predicates
     /* 1422547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422551 */     // MIs[0] policy
     /* 1422551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422563 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1422566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422572 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422590 */     // GIR_Coverage, 2925,
     /* 1422590 */     GIR_EraseRootFromParent_Done,
     /* 1422591 */   // Label 20118: @1422591
     /* 1422591 */   GIM_Try, /*On fail goto*//*Label 20119*/ GIMT_Encode4(1422690), // Rule ID 2932 //
     /* 1422596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1422607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1422610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1422613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422646 */     // MIs[1] Operand 1
     /* 1422646 */     // No operand predicates
     /* 1422646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422650 */     // MIs[0] policy
     /* 1422650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422662 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422671 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422689 */     // GIR_Coverage, 2932,
     /* 1422689 */     GIR_EraseRootFromParent_Done,
     /* 1422690 */   // Label 20119: @1422690
     /* 1422690 */   GIM_Try, /*On fail goto*//*Label 20120*/ GIMT_Encode4(1422789), // Rule ID 2933 //
     /* 1422695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1422706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1422709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1422712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1422725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1422733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422745 */     // MIs[1] Operand 1
     /* 1422745 */     // No operand predicates
     /* 1422745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422749 */     // MIs[0] policy
     /* 1422749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422761 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1422764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422770 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422788 */     // GIR_Coverage, 2933,
     /* 1422788 */     GIR_EraseRootFromParent_Done,
     /* 1422789 */   // Label 20120: @1422789
     /* 1422789 */   GIM_Try, /*On fail goto*//*Label 20121*/ GIMT_Encode4(1422888), // Rule ID 2940 //
     /* 1422794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1422805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1422808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1422811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422844 */     // MIs[1] Operand 1
     /* 1422844 */     // No operand predicates
     /* 1422844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422848 */     // MIs[0] policy
     /* 1422848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422860 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422869 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422887 */     // GIR_Coverage, 2940,
     /* 1422887 */     GIR_EraseRootFromParent_Done,
     /* 1422888 */   // Label 20121: @1422888
     /* 1422888 */   GIM_Try, /*On fail goto*//*Label 20122*/ GIMT_Encode4(1422987), // Rule ID 2941 //
     /* 1422893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1422901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1422904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1422907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1422910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1422916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1422923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1422931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1422943 */     // MIs[1] Operand 1
     /* 1422943 */     // No operand predicates
     /* 1422943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422947 */     // MIs[0] policy
     /* 1422947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422959 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1422962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422968 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1422973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422986 */     // GIR_Coverage, 2941,
     /* 1422986 */     GIR_EraseRootFromParent_Done,
     /* 1422987 */   // Label 20122: @1422987
     /* 1422987 */   GIM_Try, /*On fail goto*//*Label 20123*/ GIMT_Encode4(1423086), // Rule ID 2948 //
     /* 1422992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1422995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1423003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1423006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1423009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423042 */     // MIs[1] Operand 1
     /* 1423042 */     // No operand predicates
     /* 1423042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423046 */     // MIs[0] policy
     /* 1423046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423067 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423085 */     // GIR_Coverage, 2948,
     /* 1423085 */     GIR_EraseRootFromParent_Done,
     /* 1423086 */   // Label 20123: @1423086
     /* 1423086 */   GIM_Try, /*On fail goto*//*Label 20124*/ GIMT_Encode4(1423185), // Rule ID 2949 //
     /* 1423091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1423102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1423105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1423108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423141 */     // MIs[1] Operand 1
     /* 1423141 */     // No operand predicates
     /* 1423141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423145 */     // MIs[0] policy
     /* 1423145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423157 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1423160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423166 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423184 */     // GIR_Coverage, 2949,
     /* 1423184 */     GIR_EraseRootFromParent_Done,
     /* 1423185 */   // Label 20124: @1423185
     /* 1423185 */   GIM_Try, /*On fail goto*//*Label 20125*/ GIMT_Encode4(1423284), // Rule ID 2956 //
     /* 1423190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1423201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1423204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1423207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423240 */     // MIs[1] Operand 1
     /* 1423240 */     // No operand predicates
     /* 1423240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423244 */     // MIs[0] policy
     /* 1423244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423256 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423265 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423283 */     // GIR_Coverage, 2956,
     /* 1423283 */     GIR_EraseRootFromParent_Done,
     /* 1423284 */   // Label 20125: @1423284
     /* 1423284 */   GIM_Try, /*On fail goto*//*Label 20126*/ GIMT_Encode4(1423383), // Rule ID 2957 //
     /* 1423289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1423300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1423303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1423306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423339 */     // MIs[1] Operand 1
     /* 1423339 */     // No operand predicates
     /* 1423339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423343 */     // MIs[0] policy
     /* 1423343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423355 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1423358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423364 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423382 */     // GIR_Coverage, 2957,
     /* 1423382 */     GIR_EraseRootFromParent_Done,
     /* 1423383 */   // Label 20126: @1423383
     /* 1423383 */   GIM_Try, /*On fail goto*//*Label 20127*/ GIMT_Encode4(1423482), // Rule ID 2964 //
     /* 1423388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1423399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1423402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1423405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423438 */     // MIs[1] Operand 1
     /* 1423438 */     // No operand predicates
     /* 1423438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423442 */     // MIs[0] policy
     /* 1423442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423463 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423481 */     // GIR_Coverage, 2964,
     /* 1423481 */     GIR_EraseRootFromParent_Done,
     /* 1423482 */   // Label 20127: @1423482
     /* 1423482 */   GIM_Try, /*On fail goto*//*Label 20128*/ GIMT_Encode4(1423581), // Rule ID 2965 //
     /* 1423487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1423495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1423498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1423501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1423504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1423537 */     // MIs[1] Operand 1
     /* 1423537 */     // No operand predicates
     /* 1423537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423541 */     // MIs[0] policy
     /* 1423541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423553 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1423556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423562 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1423567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423580 */     // GIR_Coverage, 2965,
     /* 1423580 */     GIR_EraseRootFromParent_Done,
     /* 1423581 */   // Label 20128: @1423581
     /* 1423581 */   GIM_Try, /*On fail goto*//*Label 20129*/ GIMT_Encode4(1423678), // Rule ID 3148 //
     /* 1423586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1423597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1423600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1423603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423636 */     // MIs[1] Operand 1
     /* 1423636 */     // No operand predicates
     /* 1423636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423640 */     // MIs[0] policy
     /* 1423640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423652 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1423655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423677 */     // GIR_Coverage, 3148,
     /* 1423677 */     GIR_EraseRootFromParent_Done,
     /* 1423678 */   // Label 20129: @1423678
     /* 1423678 */   GIM_Try, /*On fail goto*//*Label 20130*/ GIMT_Encode4(1423775), // Rule ID 3149 //
     /* 1423683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1423694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1423697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1423700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423733 */     // MIs[1] Operand 1
     /* 1423733 */     // No operand predicates
     /* 1423733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423737 */     // MIs[0] policy
     /* 1423737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423749 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1423752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423774 */     // GIR_Coverage, 3149,
     /* 1423774 */     GIR_EraseRootFromParent_Done,
     /* 1423775 */   // Label 20130: @1423775
     /* 1423775 */   GIM_Try, /*On fail goto*//*Label 20131*/ GIMT_Encode4(1423872), // Rule ID 3152 //
     /* 1423780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1423791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1423794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1423797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423830 */     // MIs[1] Operand 1
     /* 1423830 */     // No operand predicates
     /* 1423830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423834 */     // MIs[0] policy
     /* 1423834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423846 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1423849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423871 */     // GIR_Coverage, 3152,
     /* 1423871 */     GIR_EraseRootFromParent_Done,
     /* 1423872 */   // Label 20131: @1423872
     /* 1423872 */   GIM_Try, /*On fail goto*//*Label 20132*/ GIMT_Encode4(1423969), // Rule ID 3153 //
     /* 1423877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1423888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1423891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1423894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1423900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423927 */     // MIs[1] Operand 1
     /* 1423927 */     // No operand predicates
     /* 1423927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423931 */     // MIs[0] policy
     /* 1423931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423943 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1423946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423968 */     // GIR_Coverage, 3153,
     /* 1423968 */     GIR_EraseRootFromParent_Done,
     /* 1423969 */   // Label 20132: @1423969
     /* 1423969 */   GIM_Try, /*On fail goto*//*Label 20133*/ GIMT_Encode4(1424066), // Rule ID 3156 //
     /* 1423974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1423982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1423985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1423988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1423991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1423997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424024 */     // MIs[1] Operand 1
     /* 1424024 */     // No operand predicates
     /* 1424024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424028 */     // MIs[0] policy
     /* 1424028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424040 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424065 */     // GIR_Coverage, 3156,
     /* 1424065 */     GIR_EraseRootFromParent_Done,
     /* 1424066 */   // Label 20133: @1424066
     /* 1424066 */   GIM_Try, /*On fail goto*//*Label 20134*/ GIMT_Encode4(1424163), // Rule ID 3157 //
     /* 1424071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1424082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1424085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1424088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424121 */     // MIs[1] Operand 1
     /* 1424121 */     // No operand predicates
     /* 1424121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424125 */     // MIs[0] policy
     /* 1424125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424137 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424162 */     // GIR_Coverage, 3157,
     /* 1424162 */     GIR_EraseRootFromParent_Done,
     /* 1424163 */   // Label 20134: @1424163
     /* 1424163 */   GIM_Try, /*On fail goto*//*Label 20135*/ GIMT_Encode4(1424260), // Rule ID 3160 //
     /* 1424168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1424179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1424182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1424185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424218 */     // MIs[1] Operand 1
     /* 1424218 */     // No operand predicates
     /* 1424218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424222 */     // MIs[0] policy
     /* 1424222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424234 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424259 */     // GIR_Coverage, 3160,
     /* 1424259 */     GIR_EraseRootFromParent_Done,
     /* 1424260 */   // Label 20135: @1424260
     /* 1424260 */   GIM_Try, /*On fail goto*//*Label 20136*/ GIMT_Encode4(1424357), // Rule ID 3161 //
     /* 1424265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1424276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1424279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1424282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424315 */     // MIs[1] Operand 1
     /* 1424315 */     // No operand predicates
     /* 1424315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424319 */     // MIs[0] policy
     /* 1424319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424331 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1424334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424356 */     // GIR_Coverage, 3161,
     /* 1424356 */     GIR_EraseRootFromParent_Done,
     /* 1424357 */   // Label 20136: @1424357
     /* 1424357 */   GIM_Try, /*On fail goto*//*Label 20137*/ GIMT_Encode4(1424454), // Rule ID 3164 //
     /* 1424362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1424373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1424376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1424379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424412 */     // MIs[1] Operand 1
     /* 1424412 */     // No operand predicates
     /* 1424412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424416 */     // MIs[0] policy
     /* 1424416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424428 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424453 */     // GIR_Coverage, 3164,
     /* 1424453 */     GIR_EraseRootFromParent_Done,
     /* 1424454 */   // Label 20137: @1424454
     /* 1424454 */   GIM_Try, /*On fail goto*//*Label 20138*/ GIMT_Encode4(1424551), // Rule ID 3165 //
     /* 1424459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1424470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1424473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1424476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424509 */     // MIs[1] Operand 1
     /* 1424509 */     // No operand predicates
     /* 1424509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424513 */     // MIs[0] policy
     /* 1424513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424525 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424550 */     // GIR_Coverage, 3165,
     /* 1424550 */     GIR_EraseRootFromParent_Done,
     /* 1424551 */   // Label 20138: @1424551
     /* 1424551 */   GIM_Try, /*On fail goto*//*Label 20139*/ GIMT_Encode4(1424648), // Rule ID 3168 //
     /* 1424556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1424567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1424570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1424573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424606 */     // MIs[1] Operand 1
     /* 1424606 */     // No operand predicates
     /* 1424606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424610 */     // MIs[0] policy
     /* 1424610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424647 */     // GIR_Coverage, 3168,
     /* 1424647 */     GIR_EraseRootFromParent_Done,
     /* 1424648 */   // Label 20139: @1424648
     /* 1424648 */   GIM_Try, /*On fail goto*//*Label 20140*/ GIMT_Encode4(1424745), // Rule ID 3169 //
     /* 1424653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1424664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1424667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1424670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1424676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424703 */     // MIs[1] Operand 1
     /* 1424703 */     // No operand predicates
     /* 1424703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424707 */     // MIs[0] policy
     /* 1424707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424719 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1424722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424744 */     // GIR_Coverage, 3169,
     /* 1424744 */     GIR_EraseRootFromParent_Done,
     /* 1424745 */   // Label 20140: @1424745
     /* 1424745 */   GIM_Try, /*On fail goto*//*Label 20141*/ GIMT_Encode4(1424842), // Rule ID 3172 //
     /* 1424750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1424761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1424764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1424767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424800 */     // MIs[1] Operand 1
     /* 1424800 */     // No operand predicates
     /* 1424800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424804 */     // MIs[0] policy
     /* 1424804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424841 */     // GIR_Coverage, 3172,
     /* 1424841 */     GIR_EraseRootFromParent_Done,
     /* 1424842 */   // Label 20141: @1424842
     /* 1424842 */   GIM_Try, /*On fail goto*//*Label 20142*/ GIMT_Encode4(1424939), // Rule ID 3173 //
     /* 1424847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1424858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1424861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1424864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424897 */     // MIs[1] Operand 1
     /* 1424897 */     // No operand predicates
     /* 1424897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424901 */     // MIs[0] policy
     /* 1424901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424913 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1424916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1424935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424938 */     // GIR_Coverage, 3173,
     /* 1424938 */     GIR_EraseRootFromParent_Done,
     /* 1424939 */   // Label 20142: @1424939
     /* 1424939 */   GIM_Try, /*On fail goto*//*Label 20143*/ GIMT_Encode4(1425036), // Rule ID 3176 //
     /* 1424944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1424952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1424955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1424958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1424961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1424974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1424982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424994 */     // MIs[1] Operand 1
     /* 1424994 */     // No operand predicates
     /* 1424994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424998 */     // MIs[0] policy
     /* 1424998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425010 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425035 */     // GIR_Coverage, 3176,
     /* 1425035 */     GIR_EraseRootFromParent_Done,
     /* 1425036 */   // Label 20143: @1425036
     /* 1425036 */   GIM_Try, /*On fail goto*//*Label 20144*/ GIMT_Encode4(1425133), // Rule ID 3177 //
     /* 1425041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1425052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1425055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1425058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425091 */     // MIs[1] Operand 1
     /* 1425091 */     // No operand predicates
     /* 1425091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425095 */     // MIs[0] policy
     /* 1425095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425107 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1425129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425132 */     // GIR_Coverage, 3177,
     /* 1425132 */     GIR_EraseRootFromParent_Done,
     /* 1425133 */   // Label 20144: @1425133
     /* 1425133 */   GIM_Try, /*On fail goto*//*Label 20145*/ GIMT_Encode4(1425230), // Rule ID 3180 //
     /* 1425138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1425149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1425152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1425155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425188 */     // MIs[1] Operand 1
     /* 1425188 */     // No operand predicates
     /* 1425188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425192 */     // MIs[0] policy
     /* 1425192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425229 */     // GIR_Coverage, 3180,
     /* 1425229 */     GIR_EraseRootFromParent_Done,
     /* 1425230 */   // Label 20145: @1425230
     /* 1425230 */   GIM_Try, /*On fail goto*//*Label 20146*/ GIMT_Encode4(1425327), // Rule ID 3181 //
     /* 1425235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1425246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1425249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1425252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425285 */     // MIs[1] Operand 1
     /* 1425285 */     // No operand predicates
     /* 1425285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425289 */     // MIs[0] policy
     /* 1425289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425301 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1425323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425326 */     // GIR_Coverage, 3181,
     /* 1425326 */     GIR_EraseRootFromParent_Done,
     /* 1425327 */   // Label 20146: @1425327
     /* 1425327 */   GIM_Try, /*On fail goto*//*Label 20147*/ GIMT_Encode4(1425424), // Rule ID 3184 //
     /* 1425332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1425335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1425343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1425346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1425349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425382 */     // MIs[1] Operand 1
     /* 1425382 */     // No operand predicates
     /* 1425382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425386 */     // MIs[0] policy
     /* 1425386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425423 */     // GIR_Coverage, 3184,
     /* 1425423 */     GIR_EraseRootFromParent_Done,
     /* 1425424 */   // Label 20147: @1425424
     /* 1425424 */   GIM_Try, /*On fail goto*//*Label 20148*/ GIMT_Encode4(1425521), // Rule ID 3185 //
     /* 1425429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1425440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1425443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1425446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425479 */     // MIs[1] Operand 1
     /* 1425479 */     // No operand predicates
     /* 1425479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425483 */     // MIs[0] policy
     /* 1425483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425495 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1425498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425520 */     // GIR_Coverage, 3185,
     /* 1425520 */     GIR_EraseRootFromParent_Done,
     /* 1425521 */   // Label 20148: @1425521
     /* 1425521 */   GIM_Try, /*On fail goto*//*Label 20149*/ GIMT_Encode4(1425618), // Rule ID 3188 //
     /* 1425526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1425537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1425540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1425543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1425549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425576 */     // MIs[1] Operand 1
     /* 1425576 */     // No operand predicates
     /* 1425576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425580 */     // MIs[0] policy
     /* 1425580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425617 */     // GIR_Coverage, 3188,
     /* 1425617 */     GIR_EraseRootFromParent_Done,
     /* 1425618 */   // Label 20149: @1425618
     /* 1425618 */   GIM_Try, /*On fail goto*//*Label 20150*/ GIMT_Encode4(1425715), // Rule ID 3189 //
     /* 1425623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1425634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1425637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1425640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1425646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425673 */     // MIs[1] Operand 1
     /* 1425673 */     // No operand predicates
     /* 1425673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425677 */     // MIs[0] policy
     /* 1425677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425689 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1425692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425714 */     // GIR_Coverage, 3189,
     /* 1425714 */     GIR_EraseRootFromParent_Done,
     /* 1425715 */   // Label 20150: @1425715
     /* 1425715 */   GIM_Try, /*On fail goto*//*Label 20151*/ GIMT_Encode4(1425812), // Rule ID 3192 //
     /* 1425720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1425731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1425734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1425737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1425743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425770 */     // MIs[1] Operand 1
     /* 1425770 */     // No operand predicates
     /* 1425770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425774 */     // MIs[0] policy
     /* 1425774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1425789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425811 */     // GIR_Coverage, 3192,
     /* 1425811 */     GIR_EraseRootFromParent_Done,
     /* 1425812 */   // Label 20151: @1425812
     /* 1425812 */   GIM_Try, /*On fail goto*//*Label 20152*/ GIMT_Encode4(1425909), // Rule ID 3193 //
     /* 1425817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1425828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1425831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1425834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1425840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425867 */     // MIs[1] Operand 1
     /* 1425867 */     // No operand predicates
     /* 1425867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425871 */     // MIs[0] policy
     /* 1425871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425883 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1425886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425908 */     // GIR_Coverage, 3193,
     /* 1425908 */     GIR_EraseRootFromParent_Done,
     /* 1425909 */   // Label 20152: @1425909
     /* 1425909 */   GIM_Try, /*On fail goto*//*Label 20153*/ GIMT_Encode4(1426006), // Rule ID 3196 //
     /* 1425914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1425922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1425925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1425928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1425931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1425937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1425944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425964 */     // MIs[1] Operand 1
     /* 1425964 */     // No operand predicates
     /* 1425964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425968 */     // MIs[0] policy
     /* 1425968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425980 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1425983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426005 */     // GIR_Coverage, 3196,
     /* 1426005 */     GIR_EraseRootFromParent_Done,
     /* 1426006 */   // Label 20153: @1426006
     /* 1426006 */   GIM_Try, /*On fail goto*//*Label 20154*/ GIMT_Encode4(1426103), // Rule ID 3197 //
     /* 1426011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1426022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1426025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1426028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1426034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426061 */     // MIs[1] Operand 1
     /* 1426061 */     // No operand predicates
     /* 1426061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426065 */     // MIs[0] policy
     /* 1426065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426077 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426102 */     // GIR_Coverage, 3197,
     /* 1426102 */     GIR_EraseRootFromParent_Done,
     /* 1426103 */   // Label 20154: @1426103
     /* 1426103 */   GIM_Try, /*On fail goto*//*Label 20155*/ GIMT_Encode4(1426200), // Rule ID 3200 //
     /* 1426108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426158 */     // MIs[1] Operand 1
     /* 1426158 */     // No operand predicates
     /* 1426158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426162 */     // MIs[0] policy
     /* 1426162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426199 */     // GIR_Coverage, 3200,
     /* 1426199 */     GIR_EraseRootFromParent_Done,
     /* 1426200 */   // Label 20155: @1426200
     /* 1426200 */   GIM_Try, /*On fail goto*//*Label 20156*/ GIMT_Encode4(1426297), // Rule ID 3201 //
     /* 1426205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1426216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1426219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1426222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426255 */     // MIs[1] Operand 1
     /* 1426255 */     // No operand predicates
     /* 1426255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426259 */     // MIs[0] policy
     /* 1426259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426271 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426296 */     // GIR_Coverage, 3201,
     /* 1426296 */     GIR_EraseRootFromParent_Done,
     /* 1426297 */   // Label 20156: @1426297
     /* 1426297 */   GIM_Try, /*On fail goto*//*Label 20157*/ GIMT_Encode4(1426394), // Rule ID 3204 //
     /* 1426302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426352 */     // MIs[1] Operand 1
     /* 1426352 */     // No operand predicates
     /* 1426352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426356 */     // MIs[0] policy
     /* 1426356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426393 */     // GIR_Coverage, 3204,
     /* 1426393 */     GIR_EraseRootFromParent_Done,
     /* 1426394 */   // Label 20157: @1426394
     /* 1426394 */   GIM_Try, /*On fail goto*//*Label 20158*/ GIMT_Encode4(1426491), // Rule ID 3205 //
     /* 1426399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1426410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1426413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1426416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1426422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426449 */     // MIs[1] Operand 1
     /* 1426449 */     // No operand predicates
     /* 1426449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426453 */     // MIs[0] policy
     /* 1426453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426465 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426490 */     // GIR_Coverage, 3205,
     /* 1426490 */     GIR_EraseRootFromParent_Done,
     /* 1426491 */   // Label 20158: @1426491
     /* 1426491 */   GIM_Try, /*On fail goto*//*Label 20159*/ GIMT_Encode4(1426588), // Rule ID 3208 //
     /* 1426496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426546 */     // MIs[1] Operand 1
     /* 1426546 */     // No operand predicates
     /* 1426546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426550 */     // MIs[0] policy
     /* 1426550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426562 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426587 */     // GIR_Coverage, 3208,
     /* 1426587 */     GIR_EraseRootFromParent_Done,
     /* 1426588 */   // Label 20159: @1426588
     /* 1426588 */   GIM_Try, /*On fail goto*//*Label 20160*/ GIMT_Encode4(1426685), // Rule ID 3209 //
     /* 1426593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1426604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1426607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1426610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1426616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1426623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1426631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426643 */     // MIs[1] Operand 1
     /* 1426643 */     // No operand predicates
     /* 1426643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426647 */     // MIs[0] policy
     /* 1426647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426659 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1426662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426684 */     // GIR_Coverage, 3209,
     /* 1426684 */     GIR_EraseRootFromParent_Done,
     /* 1426685 */   // Label 20160: @1426685
     /* 1426685 */   GIM_Try, /*On fail goto*//*Label 20161*/ GIMT_Encode4(1426782), // Rule ID 3212 //
     /* 1426690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1426701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1426704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1426707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426740 */     // MIs[1] Operand 1
     /* 1426740 */     // No operand predicates
     /* 1426740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426744 */     // MIs[0] policy
     /* 1426744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426781 */     // GIR_Coverage, 3212,
     /* 1426781 */     GIR_EraseRootFromParent_Done,
     /* 1426782 */   // Label 20161: @1426782
     /* 1426782 */   GIM_Try, /*On fail goto*//*Label 20162*/ GIMT_Encode4(1426879), // Rule ID 3213 //
     /* 1426787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1426798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1426801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1426804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1426817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1426825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426837 */     // MIs[1] Operand 1
     /* 1426837 */     // No operand predicates
     /* 1426837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426841 */     // MIs[0] policy
     /* 1426841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1426856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426878 */     // GIR_Coverage, 3213,
     /* 1426878 */     GIR_EraseRootFromParent_Done,
     /* 1426879 */   // Label 20162: @1426879
     /* 1426879 */   GIM_Try, /*On fail goto*//*Label 20163*/ GIMT_Encode4(1426976), // Rule ID 3216 //
     /* 1426884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1426895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1426898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1426901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1426914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1426922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426934 */     // MIs[1] Operand 1
     /* 1426934 */     // No operand predicates
     /* 1426934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426938 */     // MIs[0] policy
     /* 1426938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1426953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426975 */     // GIR_Coverage, 3216,
     /* 1426975 */     GIR_EraseRootFromParent_Done,
     /* 1426976 */   // Label 20163: @1426976
     /* 1426976 */   GIM_Try, /*On fail goto*//*Label 20164*/ GIMT_Encode4(1427073), // Rule ID 3217 //
     /* 1426981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1426989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1426992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1426995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1426998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427031 */     // MIs[1] Operand 1
     /* 1427031 */     // No operand predicates
     /* 1427031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427035 */     // MIs[0] policy
     /* 1427035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427047 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427072 */     // GIR_Coverage, 3217,
     /* 1427072 */     GIR_EraseRootFromParent_Done,
     /* 1427073 */   // Label 20164: @1427073
     /* 1427073 */   GIM_Try, /*On fail goto*//*Label 20165*/ GIMT_Encode4(1427170), // Rule ID 3220 //
     /* 1427078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427128 */     // MIs[1] Operand 1
     /* 1427128 */     // No operand predicates
     /* 1427128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427132 */     // MIs[0] policy
     /* 1427132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427144 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427169 */     // GIR_Coverage, 3220,
     /* 1427169 */     GIR_EraseRootFromParent_Done,
     /* 1427170 */   // Label 20165: @1427170
     /* 1427170 */   GIM_Try, /*On fail goto*//*Label 20166*/ GIMT_Encode4(1427267), // Rule ID 3221 //
     /* 1427175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1427186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1427189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1427192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427225 */     // MIs[1] Operand 1
     /* 1427225 */     // No operand predicates
     /* 1427225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427229 */     // MIs[0] policy
     /* 1427229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427241 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427266 */     // GIR_Coverage, 3221,
     /* 1427266 */     GIR_EraseRootFromParent_Done,
     /* 1427267 */   // Label 20166: @1427267
     /* 1427267 */   GIM_Try, /*On fail goto*//*Label 20167*/ GIMT_Encode4(1427364), // Rule ID 3224 //
     /* 1427272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427322 */     // MIs[1] Operand 1
     /* 1427322 */     // No operand predicates
     /* 1427322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427326 */     // MIs[0] policy
     /* 1427326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427363 */     // GIR_Coverage, 3224,
     /* 1427363 */     GIR_EraseRootFromParent_Done,
     /* 1427364 */   // Label 20167: @1427364
     /* 1427364 */   GIM_Try, /*On fail goto*//*Label 20168*/ GIMT_Encode4(1427461), // Rule ID 3225 //
     /* 1427369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1427380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1427383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1427386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427419 */     // MIs[1] Operand 1
     /* 1427419 */     // No operand predicates
     /* 1427419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427423 */     // MIs[0] policy
     /* 1427423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427435 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1427438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427460 */     // GIR_Coverage, 3225,
     /* 1427460 */     GIR_EraseRootFromParent_Done,
     /* 1427461 */   // Label 20168: @1427461
     /* 1427461 */   GIM_Try, /*On fail goto*//*Label 20169*/ GIMT_Encode4(1427558), // Rule ID 3228 //
     /* 1427466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427516 */     // MIs[1] Operand 1
     /* 1427516 */     // No operand predicates
     /* 1427516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427520 */     // MIs[0] policy
     /* 1427520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427532 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427557 */     // GIR_Coverage, 3228,
     /* 1427557 */     GIR_EraseRootFromParent_Done,
     /* 1427558 */   // Label 20169: @1427558
     /* 1427558 */   GIM_Try, /*On fail goto*//*Label 20170*/ GIMT_Encode4(1427655), // Rule ID 3229 //
     /* 1427563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1427574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1427577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1427580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427613 */     // MIs[1] Operand 1
     /* 1427613 */     // No operand predicates
     /* 1427613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427617 */     // MIs[0] policy
     /* 1427617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427629 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1427632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427654 */     // GIR_Coverage, 3229,
     /* 1427654 */     GIR_EraseRootFromParent_Done,
     /* 1427655 */   // Label 20170: @1427655
     /* 1427655 */   GIM_Try, /*On fail goto*//*Label 20171*/ GIMT_Encode4(1427752), // Rule ID 3232 //
     /* 1427660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1427671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1427674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1427677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427710 */     // MIs[1] Operand 1
     /* 1427710 */     // No operand predicates
     /* 1427710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427714 */     // MIs[0] policy
     /* 1427714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427751 */     // GIR_Coverage, 3232,
     /* 1427751 */     GIR_EraseRootFromParent_Done,
     /* 1427752 */   // Label 20171: @1427752
     /* 1427752 */   GIM_Try, /*On fail goto*//*Label 20172*/ GIMT_Encode4(1427849), // Rule ID 3233 //
     /* 1427757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1427765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1427768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1427771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1427774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1427780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427807 */     // MIs[1] Operand 1
     /* 1427807 */     // No operand predicates
     /* 1427807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427811 */     // MIs[0] policy
     /* 1427811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427823 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1427826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427848 */     // GIR_Coverage, 3233,
     /* 1427848 */     GIR_EraseRootFromParent_Done,
     /* 1427849 */   // Label 20172: @1427849
     /* 1427849 */   GIM_Try, /*On fail goto*//*Label 20173*/ GIMT_Encode4(1427946), // Rule ID 3500 //
     /* 1427854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1427865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1427868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1427871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427904 */     // MIs[1] Operand 1
     /* 1427904 */     // No operand predicates
     /* 1427904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427908 */     // MIs[0] policy
     /* 1427908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427920 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1427923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427945 */     // GIR_Coverage, 3500,
     /* 1427945 */     GIR_EraseRootFromParent_Done,
     /* 1427946 */   // Label 20173: @1427946
     /* 1427946 */   GIM_Try, /*On fail goto*//*Label 20174*/ GIMT_Encode4(1428043), // Rule ID 3501 //
     /* 1427951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1427959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1427962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1427965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1427968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428001 */     // MIs[1] Operand 1
     /* 1428001 */     // No operand predicates
     /* 1428001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428005 */     // MIs[0] policy
     /* 1428005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428017 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1428020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428042 */     // GIR_Coverage, 3501,
     /* 1428042 */     GIR_EraseRootFromParent_Done,
     /* 1428043 */   // Label 20174: @1428043
     /* 1428043 */   GIM_Try, /*On fail goto*//*Label 20175*/ GIMT_Encode4(1428140), // Rule ID 3504 //
     /* 1428048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1428059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1428062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1428065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428098 */     // MIs[1] Operand 1
     /* 1428098 */     // No operand predicates
     /* 1428098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428102 */     // MIs[0] policy
     /* 1428102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428139 */     // GIR_Coverage, 3504,
     /* 1428139 */     GIR_EraseRootFromParent_Done,
     /* 1428140 */   // Label 20175: @1428140
     /* 1428140 */   GIM_Try, /*On fail goto*//*Label 20176*/ GIMT_Encode4(1428237), // Rule ID 3505 //
     /* 1428145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1428156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1428159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1428162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428195 */     // MIs[1] Operand 1
     /* 1428195 */     // No operand predicates
     /* 1428195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428199 */     // MIs[0] policy
     /* 1428199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428211 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428236 */     // GIR_Coverage, 3505,
     /* 1428236 */     GIR_EraseRootFromParent_Done,
     /* 1428237 */   // Label 20176: @1428237
     /* 1428237 */   GIM_Try, /*On fail goto*//*Label 20177*/ GIMT_Encode4(1428334), // Rule ID 3508 //
     /* 1428242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1428253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1428256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1428259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428292 */     // MIs[1] Operand 1
     /* 1428292 */     // No operand predicates
     /* 1428292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428296 */     // MIs[0] policy
     /* 1428296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428308 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428333 */     // GIR_Coverage, 3508,
     /* 1428333 */     GIR_EraseRootFromParent_Done,
     /* 1428334 */   // Label 20177: @1428334
     /* 1428334 */   GIM_Try, /*On fail goto*//*Label 20178*/ GIMT_Encode4(1428431), // Rule ID 3509 //
     /* 1428339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1428350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1428353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1428356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428389 */     // MIs[1] Operand 1
     /* 1428389 */     // No operand predicates
     /* 1428389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428393 */     // MIs[0] policy
     /* 1428393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428405 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428430 */     // GIR_Coverage, 3509,
     /* 1428430 */     GIR_EraseRootFromParent_Done,
     /* 1428431 */   // Label 20178: @1428431
     /* 1428431 */   GIM_Try, /*On fail goto*//*Label 20179*/ GIMT_Encode4(1428528), // Rule ID 3512 //
     /* 1428436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1428447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1428450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1428453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428486 */     // MIs[1] Operand 1
     /* 1428486 */     // No operand predicates
     /* 1428486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428490 */     // MIs[0] policy
     /* 1428490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428502 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428527 */     // GIR_Coverage, 3512,
     /* 1428527 */     GIR_EraseRootFromParent_Done,
     /* 1428528 */   // Label 20179: @1428528
     /* 1428528 */   GIM_Try, /*On fail goto*//*Label 20180*/ GIMT_Encode4(1428625), // Rule ID 3513 //
     /* 1428533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1428544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1428547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1428550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428583 */     // MIs[1] Operand 1
     /* 1428583 */     // No operand predicates
     /* 1428583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428587 */     // MIs[0] policy
     /* 1428587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428599 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1428602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428624 */     // GIR_Coverage, 3513,
     /* 1428624 */     GIR_EraseRootFromParent_Done,
     /* 1428625 */   // Label 20180: @1428625
     /* 1428625 */   GIM_Try, /*On fail goto*//*Label 20181*/ GIMT_Encode4(1428722), // Rule ID 3516 //
     /* 1428630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1428641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1428644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1428647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428680 */     // MIs[1] Operand 1
     /* 1428680 */     // No operand predicates
     /* 1428680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428684 */     // MIs[0] policy
     /* 1428684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428696 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428721 */     // GIR_Coverage, 3516,
     /* 1428721 */     GIR_EraseRootFromParent_Done,
     /* 1428722 */   // Label 20181: @1428722
     /* 1428722 */   GIM_Try, /*On fail goto*//*Label 20182*/ GIMT_Encode4(1428819), // Rule ID 3517 //
     /* 1428727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1428738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1428741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1428744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1428750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428777 */     // MIs[1] Operand 1
     /* 1428777 */     // No operand predicates
     /* 1428777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428781 */     // MIs[0] policy
     /* 1428781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428793 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428818 */     // GIR_Coverage, 3517,
     /* 1428818 */     GIR_EraseRootFromParent_Done,
     /* 1428819 */   // Label 20182: @1428819
     /* 1428819 */   GIM_Try, /*On fail goto*//*Label 20183*/ GIMT_Encode4(1428916), // Rule ID 3520 //
     /* 1428824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1428835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1428838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1428841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428874 */     // MIs[1] Operand 1
     /* 1428874 */     // No operand predicates
     /* 1428874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428878 */     // MIs[0] policy
     /* 1428878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428890 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428915 */     // GIR_Coverage, 3520,
     /* 1428915 */     GIR_EraseRootFromParent_Done,
     /* 1428916 */   // Label 20183: @1428916
     /* 1428916 */   GIM_Try, /*On fail goto*//*Label 20184*/ GIMT_Encode4(1429013), // Rule ID 3521 //
     /* 1428921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1428929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1428932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1428935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1428938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1428944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1428951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1428959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428971 */     // MIs[1] Operand 1
     /* 1428971 */     // No operand predicates
     /* 1428971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428975 */     // MIs[0] policy
     /* 1428975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428987 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1428990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429012 */     // GIR_Coverage, 3521,
     /* 1429012 */     GIR_EraseRootFromParent_Done,
     /* 1429013 */   // Label 20184: @1429013
     /* 1429013 */   GIM_Try, /*On fail goto*//*Label 20185*/ GIMT_Encode4(1429110), // Rule ID 3524 //
     /* 1429018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1429029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1429032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1429035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429068 */     // MIs[1] Operand 1
     /* 1429068 */     // No operand predicates
     /* 1429068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429072 */     // MIs[0] policy
     /* 1429072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429109 */     // GIR_Coverage, 3524,
     /* 1429109 */     GIR_EraseRootFromParent_Done,
     /* 1429110 */   // Label 20185: @1429110
     /* 1429110 */   GIM_Try, /*On fail goto*//*Label 20186*/ GIMT_Encode4(1429207), // Rule ID 3525 //
     /* 1429115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1429126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1429129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1429132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429165 */     // MIs[1] Operand 1
     /* 1429165 */     // No operand predicates
     /* 1429165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429169 */     // MIs[0] policy
     /* 1429169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429181 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429206 */     // GIR_Coverage, 3525,
     /* 1429206 */     GIR_EraseRootFromParent_Done,
     /* 1429207 */   // Label 20186: @1429207
     /* 1429207 */   GIM_Try, /*On fail goto*//*Label 20187*/ GIMT_Encode4(1429304), // Rule ID 3528 //
     /* 1429212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1429223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1429226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1429229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429262 */     // MIs[1] Operand 1
     /* 1429262 */     // No operand predicates
     /* 1429262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429266 */     // MIs[0] policy
     /* 1429266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429278 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429303 */     // GIR_Coverage, 3528,
     /* 1429303 */     GIR_EraseRootFromParent_Done,
     /* 1429304 */   // Label 20187: @1429304
     /* 1429304 */   GIM_Try, /*On fail goto*//*Label 20188*/ GIMT_Encode4(1429401), // Rule ID 3529 //
     /* 1429309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1429320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1429323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1429326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429359 */     // MIs[1] Operand 1
     /* 1429359 */     // No operand predicates
     /* 1429359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429363 */     // MIs[0] policy
     /* 1429363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429375 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1429397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429400 */     // GIR_Coverage, 3529,
     /* 1429400 */     GIR_EraseRootFromParent_Done,
     /* 1429401 */   // Label 20188: @1429401
     /* 1429401 */   GIM_Try, /*On fail goto*//*Label 20189*/ GIMT_Encode4(1429498), // Rule ID 3532 //
     /* 1429406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1429417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1429420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1429423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429456 */     // MIs[1] Operand 1
     /* 1429456 */     // No operand predicates
     /* 1429456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429460 */     // MIs[0] policy
     /* 1429460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429472 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429497 */     // GIR_Coverage, 3532,
     /* 1429497 */     GIR_EraseRootFromParent_Done,
     /* 1429498 */   // Label 20189: @1429498
     /* 1429498 */   GIM_Try, /*On fail goto*//*Label 20190*/ GIMT_Encode4(1429595), // Rule ID 3533 //
     /* 1429503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1429514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1429517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1429520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429553 */     // MIs[1] Operand 1
     /* 1429553 */     // No operand predicates
     /* 1429553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429557 */     // MIs[0] policy
     /* 1429557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429569 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429594 */     // GIR_Coverage, 3533,
     /* 1429594 */     GIR_EraseRootFromParent_Done,
     /* 1429595 */   // Label 20190: @1429595
     /* 1429595 */   GIM_Try, /*On fail goto*//*Label 20191*/ GIMT_Encode4(1429692), // Rule ID 3536 //
     /* 1429600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1429603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1429611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1429614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1429617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429650 */     // MIs[1] Operand 1
     /* 1429650 */     // No operand predicates
     /* 1429650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429654 */     // MIs[0] policy
     /* 1429654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429666 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429691 */     // GIR_Coverage, 3536,
     /* 1429691 */     GIR_EraseRootFromParent_Done,
     /* 1429692 */   // Label 20191: @1429692
     /* 1429692 */   GIM_Try, /*On fail goto*//*Label 20192*/ GIMT_Encode4(1429789), // Rule ID 3537 //
     /* 1429697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1429700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1429708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1429711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1429714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429747 */     // MIs[1] Operand 1
     /* 1429747 */     // No operand predicates
     /* 1429747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429751 */     // MIs[0] policy
     /* 1429751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429763 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1429766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429788 */     // GIR_Coverage, 3537,
     /* 1429788 */     GIR_EraseRootFromParent_Done,
     /* 1429789 */   // Label 20192: @1429789
     /* 1429789 */   GIM_Try, /*On fail goto*//*Label 20193*/ GIMT_Encode4(1429886), // Rule ID 3540 //
     /* 1429794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1429805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1429808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1429811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429844 */     // MIs[1] Operand 1
     /* 1429844 */     // No operand predicates
     /* 1429844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429848 */     // MIs[0] policy
     /* 1429848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429860 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1429863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429885 */     // GIR_Coverage, 3540,
     /* 1429885 */     GIR_EraseRootFromParent_Done,
     /* 1429886 */   // Label 20193: @1429886
     /* 1429886 */   GIM_Try, /*On fail goto*//*Label 20194*/ GIMT_Encode4(1429983), // Rule ID 3541 //
     /* 1429891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1429902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1429905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1429908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429941 */     // MIs[1] Operand 1
     /* 1429941 */     // No operand predicates
     /* 1429941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429945 */     // MIs[0] policy
     /* 1429945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429957 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1429960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429982 */     // GIR_Coverage, 3541,
     /* 1429982 */     GIR_EraseRootFromParent_Done,
     /* 1429983 */   // Label 20194: @1429983
     /* 1429983 */   GIM_Try, /*On fail goto*//*Label 20195*/ GIMT_Encode4(1430080), // Rule ID 3544 //
     /* 1429988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1429996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1429999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1430002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1430005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430038 */     // MIs[1] Operand 1
     /* 1430038 */     // No operand predicates
     /* 1430038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430042 */     // MIs[0] policy
     /* 1430042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430054 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430079 */     // GIR_Coverage, 3544,
     /* 1430079 */     GIR_EraseRootFromParent_Done,
     /* 1430080 */   // Label 20195: @1430080
     /* 1430080 */   GIM_Try, /*On fail goto*//*Label 20196*/ GIMT_Encode4(1430177), // Rule ID 3545 //
     /* 1430085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1430096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1430099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1430102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430135 */     // MIs[1] Operand 1
     /* 1430135 */     // No operand predicates
     /* 1430135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430139 */     // MIs[0] policy
     /* 1430139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430151 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430176 */     // GIR_Coverage, 3545,
     /* 1430176 */     GIR_EraseRootFromParent_Done,
     /* 1430177 */   // Label 20196: @1430177
     /* 1430177 */   GIM_Try, /*On fail goto*//*Label 20197*/ GIMT_Encode4(1430274), // Rule ID 3548 //
     /* 1430182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1430193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1430196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1430199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1430205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430232 */     // MIs[1] Operand 1
     /* 1430232 */     // No operand predicates
     /* 1430232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430236 */     // MIs[0] policy
     /* 1430236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430248 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430273 */     // GIR_Coverage, 3548,
     /* 1430273 */     GIR_EraseRootFromParent_Done,
     /* 1430274 */   // Label 20197: @1430274
     /* 1430274 */   GIM_Try, /*On fail goto*//*Label 20198*/ GIMT_Encode4(1430371), // Rule ID 3549 //
     /* 1430279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1430290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1430293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1430296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1430302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430329 */     // MIs[1] Operand 1
     /* 1430329 */     // No operand predicates
     /* 1430329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430333 */     // MIs[0] policy
     /* 1430333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430345 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430370 */     // GIR_Coverage, 3549,
     /* 1430370 */     GIR_EraseRootFromParent_Done,
     /* 1430371 */   // Label 20198: @1430371
     /* 1430371 */   GIM_Try, /*On fail goto*//*Label 20199*/ GIMT_Encode4(1430468), // Rule ID 3552 //
     /* 1430376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1430387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1430390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1430393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430426 */     // MIs[1] Operand 1
     /* 1430426 */     // No operand predicates
     /* 1430426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430430 */     // MIs[0] policy
     /* 1430430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430467 */     // GIR_Coverage, 3552,
     /* 1430467 */     GIR_EraseRootFromParent_Done,
     /* 1430468 */   // Label 20199: @1430468
     /* 1430468 */   GIM_Try, /*On fail goto*//*Label 20200*/ GIMT_Encode4(1430565), // Rule ID 3553 //
     /* 1430473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1430484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1430487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1430490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430523 */     // MIs[1] Operand 1
     /* 1430523 */     // No operand predicates
     /* 1430523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430527 */     // MIs[0] policy
     /* 1430527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430539 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1430542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430564 */     // GIR_Coverage, 3553,
     /* 1430564 */     GIR_EraseRootFromParent_Done,
     /* 1430565 */   // Label 20200: @1430565
     /* 1430565 */   GIM_Try, /*On fail goto*//*Label 20201*/ GIMT_Encode4(1430662), // Rule ID 3556 //
     /* 1430570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1430581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1430584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1430587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430620 */     // MIs[1] Operand 1
     /* 1430620 */     // No operand predicates
     /* 1430620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430624 */     // MIs[0] policy
     /* 1430624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430636 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430661 */     // GIR_Coverage, 3556,
     /* 1430661 */     GIR_EraseRootFromParent_Done,
     /* 1430662 */   // Label 20201: @1430662
     /* 1430662 */   GIM_Try, /*On fail goto*//*Label 20202*/ GIMT_Encode4(1430759), // Rule ID 3557 //
     /* 1430667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1430678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1430681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1430684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1430690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1430697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1430705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430717 */     // MIs[1] Operand 1
     /* 1430717 */     // No operand predicates
     /* 1430717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430721 */     // MIs[0] policy
     /* 1430721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430733 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1430736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430758 */     // GIR_Coverage, 3557,
     /* 1430758 */     GIR_EraseRootFromParent_Done,
     /* 1430759 */   // Label 20202: @1430759
     /* 1430759 */   GIM_Try, /*On fail goto*//*Label 20203*/ GIMT_Encode4(1430856), // Rule ID 3560 //
     /* 1430764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1430775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1430778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1430781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430814 */     // MIs[1] Operand 1
     /* 1430814 */     // No operand predicates
     /* 1430814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430818 */     // MIs[0] policy
     /* 1430818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430830 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430855 */     // GIR_Coverage, 3560,
     /* 1430855 */     GIR_EraseRootFromParent_Done,
     /* 1430856 */   // Label 20203: @1430856
     /* 1430856 */   GIM_Try, /*On fail goto*//*Label 20204*/ GIMT_Encode4(1430953), // Rule ID 3561 //
     /* 1430861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1430872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1430875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1430878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1430884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1430891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1430899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430911 */     // MIs[1] Operand 1
     /* 1430911 */     // No operand predicates
     /* 1430911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430915 */     // MIs[0] policy
     /* 1430915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430927 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1430930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430952 */     // GIR_Coverage, 3561,
     /* 1430952 */     GIR_EraseRootFromParent_Done,
     /* 1430953 */   // Label 20204: @1430953
     /* 1430953 */   GIM_Try, /*On fail goto*//*Label 20205*/ GIMT_Encode4(1431050), // Rule ID 3564 //
     /* 1430958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1430966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1430969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1430972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1430975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1430981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1430988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1430996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431008 */     // MIs[1] Operand 1
     /* 1431008 */     // No operand predicates
     /* 1431008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431012 */     // MIs[0] policy
     /* 1431012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431049 */     // GIR_Coverage, 3564,
     /* 1431049 */     GIR_EraseRootFromParent_Done,
     /* 1431050 */   // Label 20205: @1431050
     /* 1431050 */   GIM_Try, /*On fail goto*//*Label 20206*/ GIMT_Encode4(1431147), // Rule ID 3565 //
     /* 1431055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1431066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1431069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1431072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431105 */     // MIs[1] Operand 1
     /* 1431105 */     // No operand predicates
     /* 1431105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431109 */     // MIs[0] policy
     /* 1431109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431121 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431146 */     // GIR_Coverage, 3565,
     /* 1431146 */     GIR_EraseRootFromParent_Done,
     /* 1431147 */   // Label 20206: @1431147
     /* 1431147 */   GIM_Try, /*On fail goto*//*Label 20207*/ GIMT_Encode4(1431244), // Rule ID 3568 //
     /* 1431152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1431163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1431166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1431169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431202 */     // MIs[1] Operand 1
     /* 1431202 */     // No operand predicates
     /* 1431202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431206 */     // MIs[0] policy
     /* 1431206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431243 */     // GIR_Coverage, 3568,
     /* 1431243 */     GIR_EraseRootFromParent_Done,
     /* 1431244 */   // Label 20207: @1431244
     /* 1431244 */   GIM_Try, /*On fail goto*//*Label 20208*/ GIMT_Encode4(1431341), // Rule ID 3569 //
     /* 1431249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1431260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1431263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1431266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431299 */     // MIs[1] Operand 1
     /* 1431299 */     // No operand predicates
     /* 1431299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431303 */     // MIs[0] policy
     /* 1431303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431315 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431340 */     // GIR_Coverage, 3569,
     /* 1431340 */     GIR_EraseRootFromParent_Done,
     /* 1431341 */   // Label 20208: @1431341
     /* 1431341 */   GIM_Try, /*On fail goto*//*Label 20209*/ GIMT_Encode4(1431438), // Rule ID 3572 //
     /* 1431346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1431357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1431360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1431363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431396 */     // MIs[1] Operand 1
     /* 1431396 */     // No operand predicates
     /* 1431396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431400 */     // MIs[0] policy
     /* 1431400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431412 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431437 */     // GIR_Coverage, 3572,
     /* 1431437 */     GIR_EraseRootFromParent_Done,
     /* 1431438 */   // Label 20209: @1431438
     /* 1431438 */   GIM_Try, /*On fail goto*//*Label 20210*/ GIMT_Encode4(1431535), // Rule ID 3573 //
     /* 1431443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1431454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1431457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1431460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431493 */     // MIs[1] Operand 1
     /* 1431493 */     // No operand predicates
     /* 1431493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431497 */     // MIs[0] policy
     /* 1431497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431509 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431534 */     // GIR_Coverage, 3573,
     /* 1431534 */     GIR_EraseRootFromParent_Done,
     /* 1431535 */   // Label 20210: @1431535
     /* 1431535 */   GIM_Try, /*On fail goto*//*Label 20211*/ GIMT_Encode4(1431632), // Rule ID 3576 //
     /* 1431540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1431551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1431554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1431557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431590 */     // MIs[1] Operand 1
     /* 1431590 */     // No operand predicates
     /* 1431590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431594 */     // MIs[0] policy
     /* 1431594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431606 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431631 */     // GIR_Coverage, 3576,
     /* 1431631 */     GIR_EraseRootFromParent_Done,
     /* 1431632 */   // Label 20211: @1431632
     /* 1431632 */   GIM_Try, /*On fail goto*//*Label 20212*/ GIMT_Encode4(1431729), // Rule ID 3577 //
     /* 1431637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1431640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1431648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1431651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1431654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431687 */     // MIs[1] Operand 1
     /* 1431687 */     // No operand predicates
     /* 1431687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431691 */     // MIs[0] policy
     /* 1431691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431703 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1431706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431728 */     // GIR_Coverage, 3577,
     /* 1431728 */     GIR_EraseRootFromParent_Done,
     /* 1431729 */   // Label 20212: @1431729
     /* 1431729 */   GIM_Try, /*On fail goto*//*Label 20213*/ GIMT_Encode4(1431826), // Rule ID 3580 //
     /* 1431734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1431745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1431748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1431751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431784 */     // MIs[1] Operand 1
     /* 1431784 */     // No operand predicates
     /* 1431784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431788 */     // MIs[0] policy
     /* 1431788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431825 */     // GIR_Coverage, 3580,
     /* 1431825 */     GIR_EraseRootFromParent_Done,
     /* 1431826 */   // Label 20213: @1431826
     /* 1431826 */   GIM_Try, /*On fail goto*//*Label 20214*/ GIMT_Encode4(1431923), // Rule ID 3581 //
     /* 1431831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1431834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1431842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1431845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1431848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431881 */     // MIs[1] Operand 1
     /* 1431881 */     // No operand predicates
     /* 1431881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431885 */     // MIs[0] policy
     /* 1431885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431897 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1431900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431922 */     // GIR_Coverage, 3581,
     /* 1431922 */     GIR_EraseRootFromParent_Done,
     /* 1431923 */   // Label 20214: @1431923
     /* 1431923 */   GIM_Try, /*On fail goto*//*Label 20215*/ GIMT_Encode4(1432020), // Rule ID 3584 //
     /* 1431928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1431936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1431939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1431942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1431945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1431958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1431966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431978 */     // MIs[1] Operand 1
     /* 1431978 */     // No operand predicates
     /* 1431978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431982 */     // MIs[0] policy
     /* 1431982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1431997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432019 */     // GIR_Coverage, 3584,
     /* 1432019 */     GIR_EraseRootFromParent_Done,
     /* 1432020 */   // Label 20215: @1432020
     /* 1432020 */   GIM_Try, /*On fail goto*//*Label 20216*/ GIMT_Encode4(1432117), // Rule ID 3585 //
     /* 1432025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1432028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1432033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1432036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1432039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1432042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432075 */     // MIs[1] Operand 1
     /* 1432075 */     // No operand predicates
     /* 1432075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432079 */     // MIs[0] policy
     /* 1432079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432091 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1432094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1432113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432116 */     // GIR_Coverage, 3585,
     /* 1432116 */     GIR_EraseRootFromParent_Done,
     /* 1432117 */   // Label 20216: @1432117
     /* 1432117 */   GIM_Try, /*On fail goto*//*Label 20217*/ GIMT_Encode4(1432214), // Rule ID 5948 //
     /* 1432122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1432133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1432136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1432139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432172 */     // MIs[1] Operand 1
     /* 1432172 */     // No operand predicates
     /* 1432172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432176 */     // MIs[0] policy
     /* 1432176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432188 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1432191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432213 */     // GIR_Coverage, 5948,
     /* 1432213 */     GIR_EraseRootFromParent_Done,
     /* 1432214 */   // Label 20217: @1432214
     /* 1432214 */   GIM_Try, /*On fail goto*//*Label 20218*/ GIMT_Encode4(1432311), // Rule ID 5949 //
     /* 1432219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1432230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1432233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1432236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432269 */     // MIs[1] Operand 1
     /* 1432269 */     // No operand predicates
     /* 1432269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432273 */     // MIs[0] policy
     /* 1432273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432285 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1432288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432310 */     // GIR_Coverage, 5949,
     /* 1432310 */     GIR_EraseRootFromParent_Done,
     /* 1432311 */   // Label 20218: @1432311
     /* 1432311 */   GIM_Try, /*On fail goto*//*Label 20219*/ GIMT_Encode4(1432408), // Rule ID 5952 //
     /* 1432316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1432327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1432330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1432333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432366 */     // MIs[1] Operand 1
     /* 1432366 */     // No operand predicates
     /* 1432366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432370 */     // MIs[0] policy
     /* 1432370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432407 */     // GIR_Coverage, 5952,
     /* 1432407 */     GIR_EraseRootFromParent_Done,
     /* 1432408 */   // Label 20219: @1432408
     /* 1432408 */   GIM_Try, /*On fail goto*//*Label 20220*/ GIMT_Encode4(1432505), // Rule ID 5953 //
     /* 1432413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1432424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1432427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1432430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432463 */     // MIs[1] Operand 1
     /* 1432463 */     // No operand predicates
     /* 1432463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432467 */     // MIs[0] policy
     /* 1432467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432479 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432504 */     // GIR_Coverage, 5953,
     /* 1432504 */     GIR_EraseRootFromParent_Done,
     /* 1432505 */   // Label 20220: @1432505
     /* 1432505 */   GIM_Try, /*On fail goto*//*Label 20221*/ GIMT_Encode4(1432602), // Rule ID 5956 //
     /* 1432510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1432521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1432524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1432527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432560 */     // MIs[1] Operand 1
     /* 1432560 */     // No operand predicates
     /* 1432560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432564 */     // MIs[0] policy
     /* 1432564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432576 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1432579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432601 */     // GIR_Coverage, 5956,
     /* 1432601 */     GIR_EraseRootFromParent_Done,
     /* 1432602 */   // Label 20221: @1432602
     /* 1432602 */   GIM_Try, /*On fail goto*//*Label 20222*/ GIMT_Encode4(1432699), // Rule ID 5957 //
     /* 1432607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1432618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1432621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1432624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432657 */     // MIs[1] Operand 1
     /* 1432657 */     // No operand predicates
     /* 1432657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432661 */     // MIs[0] policy
     /* 1432661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432673 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1432676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432698 */     // GIR_Coverage, 5957,
     /* 1432698 */     GIR_EraseRootFromParent_Done,
     /* 1432699 */   // Label 20222: @1432699
     /* 1432699 */   GIM_Try, /*On fail goto*//*Label 20223*/ GIMT_Encode4(1432796), // Rule ID 5960 //
     /* 1432704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1432715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1432718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1432721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432754 */     // MIs[1] Operand 1
     /* 1432754 */     // No operand predicates
     /* 1432754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432758 */     // MIs[0] policy
     /* 1432758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432770 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432795 */     // GIR_Coverage, 5960,
     /* 1432795 */     GIR_EraseRootFromParent_Done,
     /* 1432796 */   // Label 20223: @1432796
     /* 1432796 */   GIM_Try, /*On fail goto*//*Label 20224*/ GIMT_Encode4(1432893), // Rule ID 5961 //
     /* 1432801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1432812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1432815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1432818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1432824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432851 */     // MIs[1] Operand 1
     /* 1432851 */     // No operand predicates
     /* 1432851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432855 */     // MIs[0] policy
     /* 1432855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432867 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1432870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432892 */     // GIR_Coverage, 5961,
     /* 1432892 */     GIR_EraseRootFromParent_Done,
     /* 1432893 */   // Label 20224: @1432893
     /* 1432893 */   GIM_Try, /*On fail goto*//*Label 20225*/ GIMT_Encode4(1432990), // Rule ID 5964 //
     /* 1432898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1432906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1432909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1432912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1432915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1432921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1432928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1432936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432948 */     // MIs[1] Operand 1
     /* 1432948 */     // No operand predicates
     /* 1432948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432952 */     // MIs[0] policy
     /* 1432952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1432967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432989 */     // GIR_Coverage, 5964,
     /* 1432989 */     GIR_EraseRootFromParent_Done,
     /* 1432990 */   // Label 20225: @1432990
     /* 1432990 */   GIM_Try, /*On fail goto*//*Label 20226*/ GIMT_Encode4(1433087), // Rule ID 5965 //
     /* 1432995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1433006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1433009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1433012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433045 */     // MIs[1] Operand 1
     /* 1433045 */     // No operand predicates
     /* 1433045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433049 */     // MIs[0] policy
     /* 1433049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433061 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433086 */     // GIR_Coverage, 5965,
     /* 1433086 */     GIR_EraseRootFromParent_Done,
     /* 1433087 */   // Label 20226: @1433087
     /* 1433087 */   GIM_Try, /*On fail goto*//*Label 20227*/ GIMT_Encode4(1433184), // Rule ID 5968 //
     /* 1433092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1433109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433142 */     // MIs[1] Operand 1
     /* 1433142 */     // No operand predicates
     /* 1433142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433146 */     // MIs[0] policy
     /* 1433146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433158 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433183 */     // GIR_Coverage, 5968,
     /* 1433183 */     GIR_EraseRootFromParent_Done,
     /* 1433184 */   // Label 20227: @1433184
     /* 1433184 */   GIM_Try, /*On fail goto*//*Label 20228*/ GIMT_Encode4(1433281), // Rule ID 5969 //
     /* 1433189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1433200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1433203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1433206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433239 */     // MIs[1] Operand 1
     /* 1433239 */     // No operand predicates
     /* 1433239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433243 */     // MIs[0] policy
     /* 1433243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433255 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1433258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433280 */     // GIR_Coverage, 5969,
     /* 1433280 */     GIR_EraseRootFromParent_Done,
     /* 1433281 */   // Label 20228: @1433281
     /* 1433281 */   GIM_Try, /*On fail goto*//*Label 20229*/ GIMT_Encode4(1433378), // Rule ID 5972 //
     /* 1433286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1433297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1433300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1433303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433336 */     // MIs[1] Operand 1
     /* 1433336 */     // No operand predicates
     /* 1433336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433340 */     // MIs[0] policy
     /* 1433340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433377 */     // GIR_Coverage, 5972,
     /* 1433377 */     GIR_EraseRootFromParent_Done,
     /* 1433378 */   // Label 20229: @1433378
     /* 1433378 */   GIM_Try, /*On fail goto*//*Label 20230*/ GIMT_Encode4(1433475), // Rule ID 5973 //
     /* 1433383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1433394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1433397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1433400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433433 */     // MIs[1] Operand 1
     /* 1433433 */     // No operand predicates
     /* 1433433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433437 */     // MIs[0] policy
     /* 1433437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433449 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1433471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433474 */     // GIR_Coverage, 5973,
     /* 1433474 */     GIR_EraseRootFromParent_Done,
     /* 1433475 */   // Label 20230: @1433475
     /* 1433475 */   GIM_Try, /*On fail goto*//*Label 20231*/ GIMT_Encode4(1433572), // Rule ID 5976 //
     /* 1433480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1433497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433530 */     // MIs[1] Operand 1
     /* 1433530 */     // No operand predicates
     /* 1433530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433534 */     // MIs[0] policy
     /* 1433534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433571 */     // GIR_Coverage, 5976,
     /* 1433571 */     GIR_EraseRootFromParent_Done,
     /* 1433572 */   // Label 20231: @1433572
     /* 1433572 */   GIM_Try, /*On fail goto*//*Label 20232*/ GIMT_Encode4(1433669), // Rule ID 5977 //
     /* 1433577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1433588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1433591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1433594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433627 */     // MIs[1] Operand 1
     /* 1433627 */     // No operand predicates
     /* 1433627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433631 */     // MIs[0] policy
     /* 1433631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433643 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1433665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433668 */     // GIR_Coverage, 5977,
     /* 1433668 */     GIR_EraseRootFromParent_Done,
     /* 1433669 */   // Label 20232: @1433669
     /* 1433669 */   GIM_Try, /*On fail goto*//*Label 20233*/ GIMT_Encode4(1433766), // Rule ID 5980 //
     /* 1433674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1433685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1433688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1433691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433724 */     // MIs[1] Operand 1
     /* 1433724 */     // No operand predicates
     /* 1433724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433728 */     // MIs[0] policy
     /* 1433728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433740 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433765 */     // GIR_Coverage, 5980,
     /* 1433765 */     GIR_EraseRootFromParent_Done,
     /* 1433766 */   // Label 20233: @1433766
     /* 1433766 */   GIM_Try, /*On fail goto*//*Label 20234*/ GIMT_Encode4(1433863), // Rule ID 5981 //
     /* 1433771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1433782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1433785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1433788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433821 */     // MIs[1] Operand 1
     /* 1433821 */     // No operand predicates
     /* 1433821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433825 */     // MIs[0] policy
     /* 1433825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433837 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433862 */     // GIR_Coverage, 5981,
     /* 1433862 */     GIR_EraseRootFromParent_Done,
     /* 1433863 */   // Label 20234: @1433863
     /* 1433863 */   GIM_Try, /*On fail goto*//*Label 20235*/ GIMT_Encode4(1433960), // Rule ID 5984 //
     /* 1433868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1433871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1433879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1433882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1433885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433918 */     // MIs[1] Operand 1
     /* 1433918 */     // No operand predicates
     /* 1433918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433922 */     // MIs[0] policy
     /* 1433922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433934 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1433937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433959 */     // GIR_Coverage, 5984,
     /* 1433959 */     GIR_EraseRootFromParent_Done,
     /* 1433960 */   // Label 20235: @1433960
     /* 1433960 */   GIM_Try, /*On fail goto*//*Label 20236*/ GIMT_Encode4(1434057), // Rule ID 5985 //
     /* 1433965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1433968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1433973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1433976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1433979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1433982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1433988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1433995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1433999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434015 */     // MIs[1] Operand 1
     /* 1434015 */     // No operand predicates
     /* 1434015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434019 */     // MIs[0] policy
     /* 1434019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434031 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1434034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434056 */     // GIR_Coverage, 5985,
     /* 1434056 */     GIR_EraseRootFromParent_Done,
     /* 1434057 */   // Label 20236: @1434057
     /* 1434057 */   GIM_Try, /*On fail goto*//*Label 20237*/ GIMT_Encode4(1434154), // Rule ID 5988 //
     /* 1434062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1434073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1434076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1434079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434112 */     // MIs[1] Operand 1
     /* 1434112 */     // No operand predicates
     /* 1434112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434116 */     // MIs[0] policy
     /* 1434116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434153 */     // GIR_Coverage, 5988,
     /* 1434153 */     GIR_EraseRootFromParent_Done,
     /* 1434154 */   // Label 20237: @1434154
     /* 1434154 */   GIM_Try, /*On fail goto*//*Label 20238*/ GIMT_Encode4(1434251), // Rule ID 5989 //
     /* 1434159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1434170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1434173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1434176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434209 */     // MIs[1] Operand 1
     /* 1434209 */     // No operand predicates
     /* 1434209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434213 */     // MIs[0] policy
     /* 1434213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434225 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434250 */     // GIR_Coverage, 5989,
     /* 1434250 */     GIR_EraseRootFromParent_Done,
     /* 1434251 */   // Label 20238: @1434251
     /* 1434251 */   GIM_Try, /*On fail goto*//*Label 20239*/ GIMT_Encode4(1434348), // Rule ID 5992 //
     /* 1434256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1434267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1434270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1434273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434306 */     // MIs[1] Operand 1
     /* 1434306 */     // No operand predicates
     /* 1434306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434310 */     // MIs[0] policy
     /* 1434310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434322 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434347 */     // GIR_Coverage, 5992,
     /* 1434347 */     GIR_EraseRootFromParent_Done,
     /* 1434348 */   // Label 20239: @1434348
     /* 1434348 */   GIM_Try, /*On fail goto*//*Label 20240*/ GIMT_Encode4(1434445), // Rule ID 5993 //
     /* 1434353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1434364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1434367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1434370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1434376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434403 */     // MIs[1] Operand 1
     /* 1434403 */     // No operand predicates
     /* 1434403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434407 */     // MIs[0] policy
     /* 1434407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434419 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434444 */     // GIR_Coverage, 5993,
     /* 1434444 */     GIR_EraseRootFromParent_Done,
     /* 1434445 */   // Label 20240: @1434445
     /* 1434445 */   GIM_Try, /*On fail goto*//*Label 20241*/ GIMT_Encode4(1434542), // Rule ID 5996 //
     /* 1434450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1434461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1434464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1434467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1434473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434500 */     // MIs[1] Operand 1
     /* 1434500 */     // No operand predicates
     /* 1434500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434504 */     // MIs[0] policy
     /* 1434504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434516 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1434519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434541 */     // GIR_Coverage, 5996,
     /* 1434541 */     GIR_EraseRootFromParent_Done,
     /* 1434542 */   // Label 20241: @1434542
     /* 1434542 */   GIM_Try, /*On fail goto*//*Label 20242*/ GIMT_Encode4(1434639), // Rule ID 5997 //
     /* 1434547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1434558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1434561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1434564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1434570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434597 */     // MIs[1] Operand 1
     /* 1434597 */     // No operand predicates
     /* 1434597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434601 */     // MIs[0] policy
     /* 1434601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434613 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1434616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434638 */     // GIR_Coverage, 5997,
     /* 1434638 */     GIR_EraseRootFromParent_Done,
     /* 1434639 */   // Label 20242: @1434639
     /* 1434639 */   GIM_Try, /*On fail goto*//*Label 20243*/ GIMT_Encode4(1434736), // Rule ID 6000 //
     /* 1434644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1434655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1434658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1434661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1434667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434694 */     // MIs[1] Operand 1
     /* 1434694 */     // No operand predicates
     /* 1434694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434698 */     // MIs[0] policy
     /* 1434698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434735 */     // GIR_Coverage, 6000,
     /* 1434735 */     GIR_EraseRootFromParent_Done,
     /* 1434736 */   // Label 20243: @1434736
     /* 1434736 */   GIM_Try, /*On fail goto*//*Label 20244*/ GIMT_Encode4(1434833), // Rule ID 6001 //
     /* 1434741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1434752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1434755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1434758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1434764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1434771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1434779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434791 */     // MIs[1] Operand 1
     /* 1434791 */     // No operand predicates
     /* 1434791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434795 */     // MIs[0] policy
     /* 1434795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1434810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434832 */     // GIR_Coverage, 6001,
     /* 1434832 */     GIR_EraseRootFromParent_Done,
     /* 1434833 */   // Label 20244: @1434833
     /* 1434833 */   GIM_Try, /*On fail goto*//*Label 20245*/ GIMT_Encode4(1434930), // Rule ID 6004 //
     /* 1434838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1434849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1434852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1434855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434888 */     // MIs[1] Operand 1
     /* 1434888 */     // No operand predicates
     /* 1434888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434892 */     // MIs[0] policy
     /* 1434892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434904 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1434907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434929 */     // GIR_Coverage, 6004,
     /* 1434929 */     GIR_EraseRootFromParent_Done,
     /* 1434930 */   // Label 20245: @1434930
     /* 1434930 */   GIM_Try, /*On fail goto*//*Label 20246*/ GIMT_Encode4(1435027), // Rule ID 6005 //
     /* 1434935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1434943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1434946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1434949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1434952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1434958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1434965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1434973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434985 */     // MIs[1] Operand 1
     /* 1434985 */     // No operand predicates
     /* 1434985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434989 */     // MIs[0] policy
     /* 1434989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435026 */     // GIR_Coverage, 6005,
     /* 1435026 */     GIR_EraseRootFromParent_Done,
     /* 1435027 */   // Label 20246: @1435027
     /* 1435027 */   GIM_Try, /*On fail goto*//*Label 20247*/ GIMT_Encode4(1435124), // Rule ID 6008 //
     /* 1435032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1435043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1435046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1435049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1435055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435082 */     // MIs[1] Operand 1
     /* 1435082 */     // No operand predicates
     /* 1435082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435086 */     // MIs[0] policy
     /* 1435086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435098 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435123 */     // GIR_Coverage, 6008,
     /* 1435123 */     GIR_EraseRootFromParent_Done,
     /* 1435124 */   // Label 20247: @1435124
     /* 1435124 */   GIM_Try, /*On fail goto*//*Label 20248*/ GIMT_Encode4(1435221), // Rule ID 6009 //
     /* 1435129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1435140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1435143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1435146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1435152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435179 */     // MIs[1] Operand 1
     /* 1435179 */     // No operand predicates
     /* 1435179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435183 */     // MIs[0] policy
     /* 1435183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435195 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435220 */     // GIR_Coverage, 6009,
     /* 1435220 */     GIR_EraseRootFromParent_Done,
     /* 1435221 */   // Label 20248: @1435221
     /* 1435221 */   GIM_Try, /*On fail goto*//*Label 20249*/ GIMT_Encode4(1435318), // Rule ID 6012 //
     /* 1435226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1435237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1435240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1435243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435276 */     // MIs[1] Operand 1
     /* 1435276 */     // No operand predicates
     /* 1435276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435280 */     // MIs[0] policy
     /* 1435280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435317 */     // GIR_Coverage, 6012,
     /* 1435317 */     GIR_EraseRootFromParent_Done,
     /* 1435318 */   // Label 20249: @1435318
     /* 1435318 */   GIM_Try, /*On fail goto*//*Label 20250*/ GIMT_Encode4(1435415), // Rule ID 6013 //
     /* 1435323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1435334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1435337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1435340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435373 */     // MIs[1] Operand 1
     /* 1435373 */     // No operand predicates
     /* 1435373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435377 */     // MIs[0] policy
     /* 1435377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435414 */     // GIR_Coverage, 6013,
     /* 1435414 */     GIR_EraseRootFromParent_Done,
     /* 1435415 */   // Label 20250: @1435415
     /* 1435415 */   GIM_Try, /*On fail goto*//*Label 20251*/ GIMT_Encode4(1435512), // Rule ID 6016 //
     /* 1435420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1435431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1435434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1435437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435470 */     // MIs[1] Operand 1
     /* 1435470 */     // No operand predicates
     /* 1435470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435474 */     // MIs[0] policy
     /* 1435474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435486 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435511 */     // GIR_Coverage, 6016,
     /* 1435511 */     GIR_EraseRootFromParent_Done,
     /* 1435512 */   // Label 20251: @1435512
     /* 1435512 */   GIM_Try, /*On fail goto*//*Label 20252*/ GIMT_Encode4(1435609), // Rule ID 6017 //
     /* 1435517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1435528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1435531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1435534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1435547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1435555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435567 */     // MIs[1] Operand 1
     /* 1435567 */     // No operand predicates
     /* 1435567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435571 */     // MIs[0] policy
     /* 1435571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435583 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1435586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435608 */     // GIR_Coverage, 6017,
     /* 1435608 */     GIR_EraseRootFromParent_Done,
     /* 1435609 */   // Label 20252: @1435609
     /* 1435609 */   GIM_Try, /*On fail goto*//*Label 20253*/ GIMT_Encode4(1435706), // Rule ID 6020 //
     /* 1435614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1435625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1435628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1435631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435664 */     // MIs[1] Operand 1
     /* 1435664 */     // No operand predicates
     /* 1435664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435668 */     // MIs[0] policy
     /* 1435668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435705 */     // GIR_Coverage, 6020,
     /* 1435705 */     GIR_EraseRootFromParent_Done,
     /* 1435706 */   // Label 20253: @1435706
     /* 1435706 */   GIM_Try, /*On fail goto*//*Label 20254*/ GIMT_Encode4(1435803), // Rule ID 6021 //
     /* 1435711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1435722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1435725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1435728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1435734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1435741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1435749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435761 */     // MIs[1] Operand 1
     /* 1435761 */     // No operand predicates
     /* 1435761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435765 */     // MIs[0] policy
     /* 1435765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435777 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1435780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435802 */     // GIR_Coverage, 6021,
     /* 1435802 */     GIR_EraseRootFromParent_Done,
     /* 1435803 */   // Label 20254: @1435803
     /* 1435803 */   GIM_Try, /*On fail goto*//*Label 20255*/ GIMT_Encode4(1435900), // Rule ID 6024 //
     /* 1435808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1435811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1435819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1435822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1435825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435858 */     // MIs[1] Operand 1
     /* 1435858 */     // No operand predicates
     /* 1435858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435862 */     // MIs[0] policy
     /* 1435862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435874 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435899 */     // GIR_Coverage, 6024,
     /* 1435899 */     GIR_EraseRootFromParent_Done,
     /* 1435900 */   // Label 20255: @1435900
     /* 1435900 */   GIM_Try, /*On fail goto*//*Label 20256*/ GIMT_Encode4(1435997), // Rule ID 6025 //
     /* 1435905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1435908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1435913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1435916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1435919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1435922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1435935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1435943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435955 */     // MIs[1] Operand 1
     /* 1435955 */     // No operand predicates
     /* 1435955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435959 */     // MIs[0] policy
     /* 1435959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435971 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1435974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435996 */     // GIR_Coverage, 6025,
     /* 1435996 */     GIR_EraseRootFromParent_Done,
     /* 1435997 */   // Label 20256: @1435997
     /* 1435997 */   GIM_Try, /*On fail goto*//*Label 20257*/ GIMT_Encode4(1436094), // Rule ID 6028 //
     /* 1436002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1436013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1436016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1436019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436052 */     // MIs[1] Operand 1
     /* 1436052 */     // No operand predicates
     /* 1436052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436056 */     // MIs[0] policy
     /* 1436056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436068 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436093 */     // GIR_Coverage, 6028,
     /* 1436093 */     GIR_EraseRootFromParent_Done,
     /* 1436094 */   // Label 20257: @1436094
     /* 1436094 */   GIM_Try, /*On fail goto*//*Label 20258*/ GIMT_Encode4(1436191), // Rule ID 6029 //
     /* 1436099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1436110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1436113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1436116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436149 */     // MIs[1] Operand 1
     /* 1436149 */     // No operand predicates
     /* 1436149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436153 */     // MIs[0] policy
     /* 1436153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436165 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1436168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436190 */     // GIR_Coverage, 6029,
     /* 1436190 */     GIR_EraseRootFromParent_Done,
     /* 1436191 */   // Label 20258: @1436191
     /* 1436191 */   GIM_Try, /*On fail goto*//*Label 20259*/ GIMT_Encode4(1436288), // Rule ID 6032 //
     /* 1436196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1436199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1436207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1436210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1436213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436246 */     // MIs[1] Operand 1
     /* 1436246 */     // No operand predicates
     /* 1436246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436250 */     // MIs[0] policy
     /* 1436250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436262 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436287 */     // GIR_Coverage, 6032,
     /* 1436287 */     GIR_EraseRootFromParent_Done,
     /* 1436288 */   // Label 20259: @1436288
     /* 1436288 */   GIM_Try, /*On fail goto*//*Label 20260*/ GIMT_Encode4(1436385), // Rule ID 6033 //
     /* 1436293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1436296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1436301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1436304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1436307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1436310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436343 */     // MIs[1] Operand 1
     /* 1436343 */     // No operand predicates
     /* 1436343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436347 */     // MIs[0] policy
     /* 1436347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436359 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1436362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436384 */     // GIR_Coverage, 6033,
     /* 1436384 */     GIR_EraseRootFromParent_Done,
     /* 1436385 */   // Label 20260: @1436385
     /* 1436385 */   GIM_Try, /*On fail goto*//*Label 20261*/ GIMT_Encode4(1436482), // Rule ID 6212 //
     /* 1436390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1436401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1436404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1436407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436440 */     // MIs[1] Operand 1
     /* 1436440 */     // No operand predicates
     /* 1436440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436444 */     // MIs[0] policy
     /* 1436444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436456 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1436459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436481 */     // GIR_Coverage, 6212,
     /* 1436481 */     GIR_EraseRootFromParent_Done,
     /* 1436482 */   // Label 20261: @1436482
     /* 1436482 */   GIM_Try, /*On fail goto*//*Label 20262*/ GIMT_Encode4(1436579), // Rule ID 6213 //
     /* 1436487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1436498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1436501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1436504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436537 */     // MIs[1] Operand 1
     /* 1436537 */     // No operand predicates
     /* 1436537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436541 */     // MIs[0] policy
     /* 1436541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436553 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1436556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436578 */     // GIR_Coverage, 6213,
     /* 1436578 */     GIR_EraseRootFromParent_Done,
     /* 1436579 */   // Label 20262: @1436579
     /* 1436579 */   GIM_Try, /*On fail goto*//*Label 20263*/ GIMT_Encode4(1436676), // Rule ID 6216 //
     /* 1436584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1436595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1436598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1436601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436634 */     // MIs[1] Operand 1
     /* 1436634 */     // No operand predicates
     /* 1436634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436638 */     // MIs[0] policy
     /* 1436638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436650 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1436653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436675 */     // GIR_Coverage, 6216,
     /* 1436675 */     GIR_EraseRootFromParent_Done,
     /* 1436676 */   // Label 20263: @1436676
     /* 1436676 */   GIM_Try, /*On fail goto*//*Label 20264*/ GIMT_Encode4(1436773), // Rule ID 6217 //
     /* 1436681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1436692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1436695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1436698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1436704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436731 */     // MIs[1] Operand 1
     /* 1436731 */     // No operand predicates
     /* 1436731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436735 */     // MIs[0] policy
     /* 1436735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436747 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1436750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436772 */     // GIR_Coverage, 6217,
     /* 1436772 */     GIR_EraseRootFromParent_Done,
     /* 1436773 */   // Label 20264: @1436773
     /* 1436773 */   GIM_Try, /*On fail goto*//*Label 20265*/ GIMT_Encode4(1436870), // Rule ID 6220 //
     /* 1436778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1436789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1436792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1436795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436828 */     // MIs[1] Operand 1
     /* 1436828 */     // No operand predicates
     /* 1436828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436832 */     // MIs[0] policy
     /* 1436832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1436847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436869 */     // GIR_Coverage, 6220,
     /* 1436869 */     GIR_EraseRootFromParent_Done,
     /* 1436870 */   // Label 20265: @1436870
     /* 1436870 */   GIM_Try, /*On fail goto*//*Label 20266*/ GIMT_Encode4(1436967), // Rule ID 6221 //
     /* 1436875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1436886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1436889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1436892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1436898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1436905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1436913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436925 */     // MIs[1] Operand 1
     /* 1436925 */     // No operand predicates
     /* 1436925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436929 */     // MIs[0] policy
     /* 1436929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436941 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1436944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436966 */     // GIR_Coverage, 6221,
     /* 1436966 */     GIR_EraseRootFromParent_Done,
     /* 1436967 */   // Label 20266: @1436967
     /* 1436967 */   GIM_Try, /*On fail goto*//*Label 20267*/ GIMT_Encode4(1437064), // Rule ID 6224 //
     /* 1436972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1436980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1436983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1436986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1436989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1436995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437022 */     // MIs[1] Operand 1
     /* 1437022 */     // No operand predicates
     /* 1437022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437026 */     // MIs[0] policy
     /* 1437026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437038 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437063 */     // GIR_Coverage, 6224,
     /* 1437063 */     GIR_EraseRootFromParent_Done,
     /* 1437064 */   // Label 20267: @1437064
     /* 1437064 */   GIM_Try, /*On fail goto*//*Label 20268*/ GIMT_Encode4(1437161), // Rule ID 6225 //
     /* 1437069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1437080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1437083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1437086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437119 */     // MIs[1] Operand 1
     /* 1437119 */     // No operand predicates
     /* 1437119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437123 */     // MIs[0] policy
     /* 1437123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437135 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1437138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437160 */     // GIR_Coverage, 6225,
     /* 1437160 */     GIR_EraseRootFromParent_Done,
     /* 1437161 */   // Label 20268: @1437161
     /* 1437161 */   GIM_Try, /*On fail goto*//*Label 20269*/ GIMT_Encode4(1437258), // Rule ID 6228 //
     /* 1437166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1437177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1437180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1437183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437216 */     // MIs[1] Operand 1
     /* 1437216 */     // No operand predicates
     /* 1437216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437220 */     // MIs[0] policy
     /* 1437220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437257 */     // GIR_Coverage, 6228,
     /* 1437257 */     GIR_EraseRootFromParent_Done,
     /* 1437258 */   // Label 20269: @1437258
     /* 1437258 */   GIM_Try, /*On fail goto*//*Label 20270*/ GIMT_Encode4(1437355), // Rule ID 6229 //
     /* 1437263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1437274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1437277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1437280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437313 */     // MIs[1] Operand 1
     /* 1437313 */     // No operand predicates
     /* 1437313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437317 */     // MIs[0] policy
     /* 1437317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437329 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437354 */     // GIR_Coverage, 6229,
     /* 1437354 */     GIR_EraseRootFromParent_Done,
     /* 1437355 */   // Label 20270: @1437355
     /* 1437355 */   GIM_Try, /*On fail goto*//*Label 20271*/ GIMT_Encode4(1437452), // Rule ID 6232 //
     /* 1437360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1437371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1437374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1437377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437410 */     // MIs[1] Operand 1
     /* 1437410 */     // No operand predicates
     /* 1437410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437414 */     // MIs[0] policy
     /* 1437414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437426 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437451 */     // GIR_Coverage, 6232,
     /* 1437451 */     GIR_EraseRootFromParent_Done,
     /* 1437452 */   // Label 20271: @1437452
     /* 1437452 */   GIM_Try, /*On fail goto*//*Label 20272*/ GIMT_Encode4(1437549), // Rule ID 6233 //
     /* 1437457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1437468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1437471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1437474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1437480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437507 */     // MIs[1] Operand 1
     /* 1437507 */     // No operand predicates
     /* 1437507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437511 */     // MIs[0] policy
     /* 1437511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437523 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1437526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437548 */     // GIR_Coverage, 6233,
     /* 1437548 */     GIR_EraseRootFromParent_Done,
     /* 1437549 */   // Label 20272: @1437549
     /* 1437549 */   GIM_Try, /*On fail goto*//*Label 20273*/ GIMT_Encode4(1437646), // Rule ID 6236 //
     /* 1437554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1437565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1437568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1437571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437604 */     // MIs[1] Operand 1
     /* 1437604 */     // No operand predicates
     /* 1437604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437608 */     // MIs[0] policy
     /* 1437608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437620 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1437623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437645 */     // GIR_Coverage, 6236,
     /* 1437645 */     GIR_EraseRootFromParent_Done,
     /* 1437646 */   // Label 20273: @1437646
     /* 1437646 */   GIM_Try, /*On fail goto*//*Label 20274*/ GIMT_Encode4(1437743), // Rule ID 6237 //
     /* 1437651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1437662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1437665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1437668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437701 */     // MIs[1] Operand 1
     /* 1437701 */     // No operand predicates
     /* 1437701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437705 */     // MIs[0] policy
     /* 1437705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437717 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1437720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1437739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437742 */     // GIR_Coverage, 6237,
     /* 1437742 */     GIR_EraseRootFromParent_Done,
     /* 1437743 */   // Label 20274: @1437743
     /* 1437743 */   GIM_Try, /*On fail goto*//*Label 20275*/ GIMT_Encode4(1437840), // Rule ID 6240 //
     /* 1437748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1437759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1437762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1437765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437798 */     // MIs[1] Operand 1
     /* 1437798 */     // No operand predicates
     /* 1437798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437802 */     // MIs[0] policy
     /* 1437802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1437817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437839 */     // GIR_Coverage, 6240,
     /* 1437839 */     GIR_EraseRootFromParent_Done,
     /* 1437840 */   // Label 20275: @1437840
     /* 1437840 */   GIM_Try, /*On fail goto*//*Label 20276*/ GIMT_Encode4(1437937), // Rule ID 6241 //
     /* 1437845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1437856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1437859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1437862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437895 */     // MIs[1] Operand 1
     /* 1437895 */     // No operand predicates
     /* 1437895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437899 */     // MIs[0] policy
     /* 1437899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437911 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1437914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437936 */     // GIR_Coverage, 6241,
     /* 1437936 */     GIR_EraseRootFromParent_Done,
     /* 1437937 */   // Label 20276: @1437937
     /* 1437937 */   GIM_Try, /*On fail goto*//*Label 20277*/ GIMT_Encode4(1438034), // Rule ID 6244 //
     /* 1437942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1437950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1437953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1437956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1437959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1437972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1437980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437992 */     // MIs[1] Operand 1
     /* 1437992 */     // No operand predicates
     /* 1437992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437996 */     // MIs[0] policy
     /* 1437996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438033 */     // GIR_Coverage, 6244,
     /* 1438033 */     GIR_EraseRootFromParent_Done,
     /* 1438034 */   // Label 20277: @1438034
     /* 1438034 */   GIM_Try, /*On fail goto*//*Label 20278*/ GIMT_Encode4(1438131), // Rule ID 6245 //
     /* 1438039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1438050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1438053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1438056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438089 */     // MIs[1] Operand 1
     /* 1438089 */     // No operand predicates
     /* 1438089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438093 */     // MIs[0] policy
     /* 1438093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438105 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1438127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438130 */     // GIR_Coverage, 6245,
     /* 1438130 */     GIR_EraseRootFromParent_Done,
     /* 1438131 */   // Label 20278: @1438131
     /* 1438131 */   GIM_Try, /*On fail goto*//*Label 20279*/ GIMT_Encode4(1438228), // Rule ID 6248 //
     /* 1438136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1438139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1438153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438186 */     // MIs[1] Operand 1
     /* 1438186 */     // No operand predicates
     /* 1438186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438190 */     // MIs[0] policy
     /* 1438190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438227 */     // GIR_Coverage, 6248,
     /* 1438227 */     GIR_EraseRootFromParent_Done,
     /* 1438228 */   // Label 20279: @1438228
     /* 1438228 */   GIM_Try, /*On fail goto*//*Label 20280*/ GIMT_Encode4(1438325), // Rule ID 6249 //
     /* 1438233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1438236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1438244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1438247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1438250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438283 */     // MIs[1] Operand 1
     /* 1438283 */     // No operand predicates
     /* 1438283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438287 */     // MIs[0] policy
     /* 1438287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438299 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1438302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438324 */     // GIR_Coverage, 6249,
     /* 1438324 */     GIR_EraseRootFromParent_Done,
     /* 1438325 */   // Label 20280: @1438325
     /* 1438325 */   GIM_Try, /*On fail goto*//*Label 20281*/ GIMT_Encode4(1438422), // Rule ID 6252 //
     /* 1438330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1438341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1438344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1438347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438380 */     // MIs[1] Operand 1
     /* 1438380 */     // No operand predicates
     /* 1438380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438384 */     // MIs[0] policy
     /* 1438384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438421 */     // GIR_Coverage, 6252,
     /* 1438421 */     GIR_EraseRootFromParent_Done,
     /* 1438422 */   // Label 20281: @1438422
     /* 1438422 */   GIM_Try, /*On fail goto*//*Label 20282*/ GIMT_Encode4(1438519), // Rule ID 6253 //
     /* 1438427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1438438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1438441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1438444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1438450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438477 */     // MIs[1] Operand 1
     /* 1438477 */     // No operand predicates
     /* 1438477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438481 */     // MIs[0] policy
     /* 1438481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438518 */     // GIR_Coverage, 6253,
     /* 1438518 */     GIR_EraseRootFromParent_Done,
     /* 1438519 */   // Label 20282: @1438519
     /* 1438519 */   GIM_Try, /*On fail goto*//*Label 20283*/ GIMT_Encode4(1438616), // Rule ID 6256 //
     /* 1438524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1438535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1438538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1438541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1438547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438574 */     // MIs[1] Operand 1
     /* 1438574 */     // No operand predicates
     /* 1438574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438578 */     // MIs[0] policy
     /* 1438578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438590 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1438593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438615 */     // GIR_Coverage, 6256,
     /* 1438615 */     GIR_EraseRootFromParent_Done,
     /* 1438616 */   // Label 20283: @1438616
     /* 1438616 */   GIM_Try, /*On fail goto*//*Label 20284*/ GIMT_Encode4(1438713), // Rule ID 6257 //
     /* 1438621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1438632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1438635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1438638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1438644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438671 */     // MIs[1] Operand 1
     /* 1438671 */     // No operand predicates
     /* 1438671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438675 */     // MIs[0] policy
     /* 1438675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438687 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1438690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438712 */     // GIR_Coverage, 6257,
     /* 1438712 */     GIR_EraseRootFromParent_Done,
     /* 1438713 */   // Label 20284: @1438713
     /* 1438713 */   GIM_Try, /*On fail goto*//*Label 20285*/ GIMT_Encode4(1438810), // Rule ID 6260 //
     /* 1438718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1438729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1438732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1438735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1438741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438768 */     // MIs[1] Operand 1
     /* 1438768 */     // No operand predicates
     /* 1438768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438772 */     // MIs[0] policy
     /* 1438772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438784 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1438787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438809 */     // GIR_Coverage, 6260,
     /* 1438809 */     GIR_EraseRootFromParent_Done,
     /* 1438810 */   // Label 20285: @1438810
     /* 1438810 */   GIM_Try, /*On fail goto*//*Label 20286*/ GIMT_Encode4(1438907), // Rule ID 6261 //
     /* 1438815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1438826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1438829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1438832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1438838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438865 */     // MIs[1] Operand 1
     /* 1438865 */     // No operand predicates
     /* 1438865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438869 */     // MIs[0] policy
     /* 1438869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438881 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1438884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438906 */     // GIR_Coverage, 6261,
     /* 1438906 */     GIR_EraseRootFromParent_Done,
     /* 1438907 */   // Label 20286: @1438907
     /* 1438907 */   GIM_Try, /*On fail goto*//*Label 20287*/ GIMT_Encode4(1439004), // Rule ID 6264 //
     /* 1438912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1438920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1438923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1438926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1438929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1438942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1438950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438962 */     // MIs[1] Operand 1
     /* 1438962 */     // No operand predicates
     /* 1438962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438966 */     // MIs[0] policy
     /* 1438966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1438981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439003 */     // GIR_Coverage, 6264,
     /* 1439003 */     GIR_EraseRootFromParent_Done,
     /* 1439004 */   // Label 20287: @1439004
     /* 1439004 */   GIM_Try, /*On fail goto*//*Label 20288*/ GIMT_Encode4(1439101), // Rule ID 6265 //
     /* 1439009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1439020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1439023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1439026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439059 */     // MIs[1] Operand 1
     /* 1439059 */     // No operand predicates
     /* 1439059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439063 */     // MIs[0] policy
     /* 1439063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439075 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439100 */     // GIR_Coverage, 6265,
     /* 1439100 */     GIR_EraseRootFromParent_Done,
     /* 1439101 */   // Label 20288: @1439101
     /* 1439101 */   GIM_Try, /*On fail goto*//*Label 20289*/ GIMT_Encode4(1439198), // Rule ID 6268 //
     /* 1439106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1439117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1439120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1439123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439156 */     // MIs[1] Operand 1
     /* 1439156 */     // No operand predicates
     /* 1439156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439160 */     // MIs[0] policy
     /* 1439160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439172 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439197 */     // GIR_Coverage, 6268,
     /* 1439197 */     GIR_EraseRootFromParent_Done,
     /* 1439198 */   // Label 20289: @1439198
     /* 1439198 */   GIM_Try, /*On fail goto*//*Label 20290*/ GIMT_Encode4(1439295), // Rule ID 6269 //
     /* 1439203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1439214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1439217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1439220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439253 */     // MIs[1] Operand 1
     /* 1439253 */     // No operand predicates
     /* 1439253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439257 */     // MIs[0] policy
     /* 1439257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439269 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439294 */     // GIR_Coverage, 6269,
     /* 1439294 */     GIR_EraseRootFromParent_Done,
     /* 1439295 */   // Label 20290: @1439295
     /* 1439295 */   GIM_Try, /*On fail goto*//*Label 20291*/ GIMT_Encode4(1439392), // Rule ID 6272 //
     /* 1439300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1439317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439350 */     // MIs[1] Operand 1
     /* 1439350 */     // No operand predicates
     /* 1439350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439354 */     // MIs[0] policy
     /* 1439354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439366 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439391 */     // GIR_Coverage, 6272,
     /* 1439391 */     GIR_EraseRootFromParent_Done,
     /* 1439392 */   // Label 20291: @1439392
     /* 1439392 */   GIM_Try, /*On fail goto*//*Label 20292*/ GIMT_Encode4(1439489), // Rule ID 6273 //
     /* 1439397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1439408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1439411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1439414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1439420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439447 */     // MIs[1] Operand 1
     /* 1439447 */     // No operand predicates
     /* 1439447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439451 */     // MIs[0] policy
     /* 1439451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439463 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439488 */     // GIR_Coverage, 6273,
     /* 1439488 */     GIR_EraseRootFromParent_Done,
     /* 1439489 */   // Label 20292: @1439489
     /* 1439489 */   GIM_Try, /*On fail goto*//*Label 20293*/ GIMT_Encode4(1439586), // Rule ID 6276 //
     /* 1439494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1439511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439544 */     // MIs[1] Operand 1
     /* 1439544 */     // No operand predicates
     /* 1439544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439548 */     // MIs[0] policy
     /* 1439548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439585 */     // GIR_Coverage, 6276,
     /* 1439585 */     GIR_EraseRootFromParent_Done,
     /* 1439586 */   // Label 20293: @1439586
     /* 1439586 */   GIM_Try, /*On fail goto*//*Label 20294*/ GIMT_Encode4(1439683), // Rule ID 6277 //
     /* 1439591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1439602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1439605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1439608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1439621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1439629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439641 */     // MIs[1] Operand 1
     /* 1439641 */     // No operand predicates
     /* 1439641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439645 */     // MIs[0] policy
     /* 1439645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1439660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439682 */     // GIR_Coverage, 6277,
     /* 1439682 */     GIR_EraseRootFromParent_Done,
     /* 1439683 */   // Label 20294: @1439683
     /* 1439683 */   GIM_Try, /*On fail goto*//*Label 20295*/ GIMT_Encode4(1439780), // Rule ID 6280 //
     /* 1439688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1439699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1439702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1439705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439738 */     // MIs[1] Operand 1
     /* 1439738 */     // No operand predicates
     /* 1439738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439742 */     // MIs[0] policy
     /* 1439742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439779 */     // GIR_Coverage, 6280,
     /* 1439779 */     GIR_EraseRootFromParent_Done,
     /* 1439780 */   // Label 20295: @1439780
     /* 1439780 */   GIM_Try, /*On fail goto*//*Label 20296*/ GIMT_Encode4(1439877), // Rule ID 6281 //
     /* 1439785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1439796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1439799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1439802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1439815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1439823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439835 */     // MIs[1] Operand 1
     /* 1439835 */     // No operand predicates
     /* 1439835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439839 */     // MIs[0] policy
     /* 1439839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1439854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439876 */     // GIR_Coverage, 6281,
     /* 1439876 */     GIR_EraseRootFromParent_Done,
     /* 1439877 */   // Label 20296: @1439877
     /* 1439877 */   GIM_Try, /*On fail goto*//*Label 20297*/ GIMT_Encode4(1439974), // Rule ID 6284 //
     /* 1439882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1439893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1439896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1439899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1439905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1439912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1439920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1439932 */     // MIs[1] Operand 1
     /* 1439932 */     // No operand predicates
     /* 1439932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439936 */     // MIs[0] policy
     /* 1439936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1439951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439973 */     // GIR_Coverage, 6284,
     /* 1439973 */     GIR_EraseRootFromParent_Done,
     /* 1439974 */   // Label 20297: @1439974
     /* 1439974 */   GIM_Try, /*On fail goto*//*Label 20298*/ GIMT_Encode4(1440071), // Rule ID 6285 //
     /* 1439979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1439987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1439990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1439993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1439996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440029 */     // MIs[1] Operand 1
     /* 1440029 */     // No operand predicates
     /* 1440029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440033 */     // MIs[0] policy
     /* 1440033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440045 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440070 */     // GIR_Coverage, 6285,
     /* 1440070 */     GIR_EraseRootFromParent_Done,
     /* 1440071 */   // Label 20298: @1440071
     /* 1440071 */   GIM_Try, /*On fail goto*//*Label 20299*/ GIMT_Encode4(1440168), // Rule ID 6288 //
     /* 1440076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1440087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1440090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1440093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440126 */     // MIs[1] Operand 1
     /* 1440126 */     // No operand predicates
     /* 1440126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440130 */     // MIs[0] policy
     /* 1440130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440167 */     // GIR_Coverage, 6288,
     /* 1440167 */     GIR_EraseRootFromParent_Done,
     /* 1440168 */   // Label 20299: @1440168
     /* 1440168 */   GIM_Try, /*On fail goto*//*Label 20300*/ GIMT_Encode4(1440265), // Rule ID 6289 //
     /* 1440173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1440184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1440187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1440190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440223 */     // MIs[1] Operand 1
     /* 1440223 */     // No operand predicates
     /* 1440223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440227 */     // MIs[0] policy
     /* 1440227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440239 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1440242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440264 */     // GIR_Coverage, 6289,
     /* 1440264 */     GIR_EraseRootFromParent_Done,
     /* 1440265 */   // Label 20300: @1440265
     /* 1440265 */   GIM_Try, /*On fail goto*//*Label 20301*/ GIMT_Encode4(1440362), // Rule ID 6292 //
     /* 1440270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1440281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1440284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1440287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440320 */     // MIs[1] Operand 1
     /* 1440320 */     // No operand predicates
     /* 1440320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440324 */     // MIs[0] policy
     /* 1440324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440336 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440361 */     // GIR_Coverage, 6292,
     /* 1440361 */     GIR_EraseRootFromParent_Done,
     /* 1440362 */   // Label 20301: @1440362
     /* 1440362 */   GIM_Try, /*On fail goto*//*Label 20302*/ GIMT_Encode4(1440459), // Rule ID 6293 //
     /* 1440367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1440378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1440381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1440384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1440390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440417 */     // MIs[1] Operand 1
     /* 1440417 */     // No operand predicates
     /* 1440417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440421 */     // MIs[0] policy
     /* 1440421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440433 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1440436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440458 */     // GIR_Coverage, 6293,
     /* 1440458 */     GIR_EraseRootFromParent_Done,
     /* 1440459 */   // Label 20302: @1440459
     /* 1440459 */   GIM_Try, /*On fail goto*//*Label 20303*/ GIMT_Encode4(1440556), // Rule ID 6296 //
     /* 1440464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1440481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440514 */     // MIs[1] Operand 1
     /* 1440514 */     // No operand predicates
     /* 1440514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440518 */     // MIs[0] policy
     /* 1440518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440530 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440555 */     // GIR_Coverage, 6296,
     /* 1440555 */     GIR_EraseRootFromParent_Done,
     /* 1440556 */   // Label 20303: @1440556
     /* 1440556 */   GIM_Try, /*On fail goto*//*Label 20304*/ GIMT_Encode4(1440653), // Rule ID 6297 //
     /* 1440561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1440569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1440572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1440575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1440578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440611 */     // MIs[1] Operand 1
     /* 1440611 */     // No operand predicates
     /* 1440611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440615 */     // MIs[0] policy
     /* 1440615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440627 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1440630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440652 */     // GIR_Coverage, 6297,
     /* 1440652 */     GIR_EraseRootFromParent_Done,
     /* 1440653 */   // Label 20304: @1440653
     /* 1440653 */   GIM_Try, /*On fail goto*//*Label 20305*/ GIMT_Encode4(1440750), // Rule ID 6476 //
     /* 1440658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1440669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1440672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1440675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440708 */     // MIs[1] Operand 1
     /* 1440708 */     // No operand predicates
     /* 1440708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440712 */     // MIs[0] policy
     /* 1440712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440724 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1440727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440749 */     // GIR_Coverage, 6476,
     /* 1440749 */     GIR_EraseRootFromParent_Done,
     /* 1440750 */   // Label 20305: @1440750
     /* 1440750 */   GIM_Try, /*On fail goto*//*Label 20306*/ GIMT_Encode4(1440847), // Rule ID 6477 //
     /* 1440755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1440766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1440769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1440772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440805 */     // MIs[1] Operand 1
     /* 1440805 */     // No operand predicates
     /* 1440805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440809 */     // MIs[0] policy
     /* 1440809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440821 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1440824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440846 */     // GIR_Coverage, 6477,
     /* 1440846 */     GIR_EraseRootFromParent_Done,
     /* 1440847 */   // Label 20306: @1440847
     /* 1440847 */   GIM_Try, /*On fail goto*//*Label 20307*/ GIMT_Encode4(1440944), // Rule ID 6480 //
     /* 1440852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1440863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1440866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1440869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440902 */     // MIs[1] Operand 1
     /* 1440902 */     // No operand predicates
     /* 1440902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440906 */     // MIs[0] policy
     /* 1440906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440918 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1440921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440943 */     // GIR_Coverage, 6480,
     /* 1440943 */     GIR_EraseRootFromParent_Done,
     /* 1440944 */   // Label 20307: @1440944
     /* 1440944 */   GIM_Try, /*On fail goto*//*Label 20308*/ GIMT_Encode4(1441041), // Rule ID 6481 //
     /* 1440949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1440957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1440960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1440963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1440966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1440999 */     // MIs[1] Operand 1
     /* 1440999 */     // No operand predicates
     /* 1440999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441003 */     // MIs[0] policy
     /* 1441003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441015 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441040 */     // GIR_Coverage, 6481,
     /* 1441040 */     GIR_EraseRootFromParent_Done,
     /* 1441041 */   // Label 20308: @1441041
     /* 1441041 */   GIM_Try, /*On fail goto*//*Label 20309*/ GIMT_Encode4(1441138), // Rule ID 6484 //
     /* 1441046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1441057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1441060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1441063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441096 */     // MIs[1] Operand 1
     /* 1441096 */     // No operand predicates
     /* 1441096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441100 */     // MIs[0] policy
     /* 1441100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441112 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441137 */     // GIR_Coverage, 6484,
     /* 1441137 */     GIR_EraseRootFromParent_Done,
     /* 1441138 */   // Label 20309: @1441138
     /* 1441138 */   GIM_Try, /*On fail goto*//*Label 20310*/ GIMT_Encode4(1441235), // Rule ID 6485 //
     /* 1441143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1441154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1441157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1441160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441193 */     // MIs[1] Operand 1
     /* 1441193 */     // No operand predicates
     /* 1441193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441197 */     // MIs[0] policy
     /* 1441197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441209 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441234 */     // GIR_Coverage, 6485,
     /* 1441234 */     GIR_EraseRootFromParent_Done,
     /* 1441235 */   // Label 20310: @1441235
     /* 1441235 */   GIM_Try, /*On fail goto*//*Label 20311*/ GIMT_Encode4(1441332), // Rule ID 6488 //
     /* 1441240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1441251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1441254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1441257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441290 */     // MIs[1] Operand 1
     /* 1441290 */     // No operand predicates
     /* 1441290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441294 */     // MIs[0] policy
     /* 1441294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441306 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441331 */     // GIR_Coverage, 6488,
     /* 1441331 */     GIR_EraseRootFromParent_Done,
     /* 1441332 */   // Label 20311: @1441332
     /* 1441332 */   GIM_Try, /*On fail goto*//*Label 20312*/ GIMT_Encode4(1441429), // Rule ID 6489 //
     /* 1441337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1441348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1441351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1441354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441387 */     // MIs[1] Operand 1
     /* 1441387 */     // No operand predicates
     /* 1441387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441391 */     // MIs[0] policy
     /* 1441391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441403 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1441406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441428 */     // GIR_Coverage, 6489,
     /* 1441428 */     GIR_EraseRootFromParent_Done,
     /* 1441429 */   // Label 20312: @1441429
     /* 1441429 */   GIM_Try, /*On fail goto*//*Label 20313*/ GIMT_Encode4(1441526), // Rule ID 6492 //
     /* 1441434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1441445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1441448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1441451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441484 */     // MIs[1] Operand 1
     /* 1441484 */     // No operand predicates
     /* 1441484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441488 */     // MIs[0] policy
     /* 1441488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441525 */     // GIR_Coverage, 6492,
     /* 1441525 */     GIR_EraseRootFromParent_Done,
     /* 1441526 */   // Label 20313: @1441526
     /* 1441526 */   GIM_Try, /*On fail goto*//*Label 20314*/ GIMT_Encode4(1441623), // Rule ID 6493 //
     /* 1441531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1441542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1441545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1441548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1441554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441581 */     // MIs[1] Operand 1
     /* 1441581 */     // No operand predicates
     /* 1441581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441585 */     // MIs[0] policy
     /* 1441585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441597 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441622 */     // GIR_Coverage, 6493,
     /* 1441622 */     GIR_EraseRootFromParent_Done,
     /* 1441623 */   // Label 20314: @1441623
     /* 1441623 */   GIM_Try, /*On fail goto*//*Label 20315*/ GIMT_Encode4(1441720), // Rule ID 6496 //
     /* 1441628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1441639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1441642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1441645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441678 */     // MIs[1] Operand 1
     /* 1441678 */     // No operand predicates
     /* 1441678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441682 */     // MIs[0] policy
     /* 1441682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441719 */     // GIR_Coverage, 6496,
     /* 1441719 */     GIR_EraseRootFromParent_Done,
     /* 1441720 */   // Label 20315: @1441720
     /* 1441720 */   GIM_Try, /*On fail goto*//*Label 20316*/ GIMT_Encode4(1441817), // Rule ID 6497 //
     /* 1441725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1441736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1441739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1441742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1441748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441775 */     // MIs[1] Operand 1
     /* 1441775 */     // No operand predicates
     /* 1441775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441779 */     // MIs[0] policy
     /* 1441779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441791 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1441794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441816 */     // GIR_Coverage, 6497,
     /* 1441816 */     GIR_EraseRootFromParent_Done,
     /* 1441817 */   // Label 20316: @1441817
     /* 1441817 */   GIM_Try, /*On fail goto*//*Label 20317*/ GIMT_Encode4(1441914), // Rule ID 6500 //
     /* 1441822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1441833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1441836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1441839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441872 */     // MIs[1] Operand 1
     /* 1441872 */     // No operand predicates
     /* 1441872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441876 */     // MIs[0] policy
     /* 1441876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441888 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1441891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1441910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441913 */     // GIR_Coverage, 6500,
     /* 1441913 */     GIR_EraseRootFromParent_Done,
     /* 1441914 */   // Label 20317: @1441914
     /* 1441914 */   GIM_Try, /*On fail goto*//*Label 20318*/ GIMT_Encode4(1442011), // Rule ID 6501 //
     /* 1441919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1441927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1441930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1441933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1441936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1441949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1441957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1441969 */     // MIs[1] Operand 1
     /* 1441969 */     // No operand predicates
     /* 1441969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441973 */     // MIs[0] policy
     /* 1441973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441985 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1441988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442010 */     // GIR_Coverage, 6501,
     /* 1442010 */     GIR_EraseRootFromParent_Done,
     /* 1442011 */   // Label 20318: @1442011
     /* 1442011 */   GIM_Try, /*On fail goto*//*Label 20319*/ GIMT_Encode4(1442108), // Rule ID 6504 //
     /* 1442016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1442027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1442030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1442033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442066 */     // MIs[1] Operand 1
     /* 1442066 */     // No operand predicates
     /* 1442066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442070 */     // MIs[0] policy
     /* 1442070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442107 */     // GIR_Coverage, 6504,
     /* 1442107 */     GIR_EraseRootFromParent_Done,
     /* 1442108 */   // Label 20319: @1442108
     /* 1442108 */   GIM_Try, /*On fail goto*//*Label 20320*/ GIMT_Encode4(1442205), // Rule ID 6505 //
     /* 1442113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1442124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1442127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1442130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442163 */     // MIs[1] Operand 1
     /* 1442163 */     // No operand predicates
     /* 1442163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442167 */     // MIs[0] policy
     /* 1442167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442179 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1442201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442204 */     // GIR_Coverage, 6505,
     /* 1442204 */     GIR_EraseRootFromParent_Done,
     /* 1442205 */   // Label 20320: @1442205
     /* 1442205 */   GIM_Try, /*On fail goto*//*Label 20321*/ GIMT_Encode4(1442302), // Rule ID 6508 //
     /* 1442210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1442221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1442224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1442227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442260 */     // MIs[1] Operand 1
     /* 1442260 */     // No operand predicates
     /* 1442260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442264 */     // MIs[0] policy
     /* 1442264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442276 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442301 */     // GIR_Coverage, 6508,
     /* 1442301 */     GIR_EraseRootFromParent_Done,
     /* 1442302 */   // Label 20321: @1442302
     /* 1442302 */   GIM_Try, /*On fail goto*//*Label 20322*/ GIMT_Encode4(1442399), // Rule ID 6509 //
     /* 1442307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1442318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1442321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1442324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442357 */     // MIs[1] Operand 1
     /* 1442357 */     // No operand predicates
     /* 1442357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442361 */     // MIs[0] policy
     /* 1442361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442373 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442398 */     // GIR_Coverage, 6509,
     /* 1442398 */     GIR_EraseRootFromParent_Done,
     /* 1442399 */   // Label 20322: @1442399
     /* 1442399 */   GIM_Try, /*On fail goto*//*Label 20323*/ GIMT_Encode4(1442496), // Rule ID 6512 //
     /* 1442404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1442421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442454 */     // MIs[1] Operand 1
     /* 1442454 */     // No operand predicates
     /* 1442454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442458 */     // MIs[0] policy
     /* 1442458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442495 */     // GIR_Coverage, 6512,
     /* 1442495 */     GIR_EraseRootFromParent_Done,
     /* 1442496 */   // Label 20323: @1442496
     /* 1442496 */   GIM_Try, /*On fail goto*//*Label 20324*/ GIMT_Encode4(1442593), // Rule ID 6513 //
     /* 1442501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1442512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1442515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1442518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442551 */     // MIs[1] Operand 1
     /* 1442551 */     // No operand predicates
     /* 1442551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442555 */     // MIs[0] policy
     /* 1442555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442567 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1442570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442592 */     // GIR_Coverage, 6513,
     /* 1442592 */     GIR_EraseRootFromParent_Done,
     /* 1442593 */   // Label 20324: @1442593
     /* 1442593 */   GIM_Try, /*On fail goto*//*Label 20325*/ GIMT_Encode4(1442690), // Rule ID 6516 //
     /* 1442598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1442609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1442612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1442615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1442621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442648 */     // MIs[1] Operand 1
     /* 1442648 */     // No operand predicates
     /* 1442648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442652 */     // MIs[0] policy
     /* 1442652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1442667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442689 */     // GIR_Coverage, 6516,
     /* 1442689 */     GIR_EraseRootFromParent_Done,
     /* 1442690 */   // Label 20325: @1442690
     /* 1442690 */   GIM_Try, /*On fail goto*//*Label 20326*/ GIMT_Encode4(1442787), // Rule ID 6517 //
     /* 1442695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1442706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1442709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1442712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1442718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442745 */     // MIs[1] Operand 1
     /* 1442745 */     // No operand predicates
     /* 1442745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442749 */     // MIs[0] policy
     /* 1442749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442761 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1442764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442786 */     // GIR_Coverage, 6517,
     /* 1442786 */     GIR_EraseRootFromParent_Done,
     /* 1442787 */   // Label 20326: @1442787
     /* 1442787 */   GIM_Try, /*On fail goto*//*Label 20327*/ GIMT_Encode4(1442884), // Rule ID 6520 //
     /* 1442792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1442803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1442806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1442809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1442815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442842 */     // MIs[1] Operand 1
     /* 1442842 */     // No operand predicates
     /* 1442842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442846 */     // MIs[0] policy
     /* 1442846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1442861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442883 */     // GIR_Coverage, 6520,
     /* 1442883 */     GIR_EraseRootFromParent_Done,
     /* 1442884 */   // Label 20327: @1442884
     /* 1442884 */   GIM_Try, /*On fail goto*//*Label 20328*/ GIMT_Encode4(1442981), // Rule ID 6521 //
     /* 1442889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1442900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1442903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1442906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1442912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1442939 */     // MIs[1] Operand 1
     /* 1442939 */     // No operand predicates
     /* 1442939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442943 */     // MIs[0] policy
     /* 1442943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442955 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1442958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442980 */     // GIR_Coverage, 6521,
     /* 1442980 */     GIR_EraseRootFromParent_Done,
     /* 1442981 */   // Label 20328: @1442981
     /* 1442981 */   GIM_Try, /*On fail goto*//*Label 20329*/ GIMT_Encode4(1443078), // Rule ID 6524 //
     /* 1442986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1442994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1442997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1443000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1443003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1443009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443036 */     // MIs[1] Operand 1
     /* 1443036 */     // No operand predicates
     /* 1443036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443040 */     // MIs[0] policy
     /* 1443040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443052 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443077 */     // GIR_Coverage, 6524,
     /* 1443077 */     GIR_EraseRootFromParent_Done,
     /* 1443078 */   // Label 20329: @1443078
     /* 1443078 */   GIM_Try, /*On fail goto*//*Label 20330*/ GIMT_Encode4(1443175), // Rule ID 6525 //
     /* 1443083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1443094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1443097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1443100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1443106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443133 */     // MIs[1] Operand 1
     /* 1443133 */     // No operand predicates
     /* 1443133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443137 */     // MIs[0] policy
     /* 1443137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443149 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443174 */     // GIR_Coverage, 6525,
     /* 1443174 */     GIR_EraseRootFromParent_Done,
     /* 1443175 */   // Label 20330: @1443175
     /* 1443175 */   GIM_Try, /*On fail goto*//*Label 20331*/ GIMT_Encode4(1443272), // Rule ID 6528 //
     /* 1443180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1443191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1443194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443230 */     // MIs[1] Operand 1
     /* 1443230 */     // No operand predicates
     /* 1443230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443234 */     // MIs[0] policy
     /* 1443234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443271 */     // GIR_Coverage, 6528,
     /* 1443271 */     GIR_EraseRootFromParent_Done,
     /* 1443272 */   // Label 20331: @1443272
     /* 1443272 */   GIM_Try, /*On fail goto*//*Label 20332*/ GIMT_Encode4(1443369), // Rule ID 6529 //
     /* 1443277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1443288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1443291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1443294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443327 */     // MIs[1] Operand 1
     /* 1443327 */     // No operand predicates
     /* 1443327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443331 */     // MIs[0] policy
     /* 1443331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443368 */     // GIR_Coverage, 6529,
     /* 1443368 */     GIR_EraseRootFromParent_Done,
     /* 1443369 */   // Label 20332: @1443369
     /* 1443369 */   GIM_Try, /*On fail goto*//*Label 20333*/ GIMT_Encode4(1443466), // Rule ID 6532 //
     /* 1443374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1443385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1443388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443424 */     // MIs[1] Operand 1
     /* 1443424 */     // No operand predicates
     /* 1443424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443428 */     // MIs[0] policy
     /* 1443428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443440 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443465 */     // GIR_Coverage, 6532,
     /* 1443465 */     GIR_EraseRootFromParent_Done,
     /* 1443466 */   // Label 20333: @1443466
     /* 1443466 */   GIM_Try, /*On fail goto*//*Label 20334*/ GIMT_Encode4(1443563), // Rule ID 6533 //
     /* 1443471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1443482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1443485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1443488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1443494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443521 */     // MIs[1] Operand 1
     /* 1443521 */     // No operand predicates
     /* 1443521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443525 */     // MIs[0] policy
     /* 1443525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443537 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1443540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443562 */     // GIR_Coverage, 6533,
     /* 1443562 */     GIR_EraseRootFromParent_Done,
     /* 1443563 */   // Label 20334: @1443563
     /* 1443563 */   GIM_Try, /*On fail goto*//*Label 20335*/ GIMT_Encode4(1443660), // Rule ID 6536 //
     /* 1443568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1443579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1443582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1443585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443618 */     // MIs[1] Operand 1
     /* 1443618 */     // No operand predicates
     /* 1443618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443622 */     // MIs[0] policy
     /* 1443622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443634 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443659 */     // GIR_Coverage, 6536,
     /* 1443659 */     GIR_EraseRootFromParent_Done,
     /* 1443660 */   // Label 20335: @1443660
     /* 1443660 */   GIM_Try, /*On fail goto*//*Label 20336*/ GIMT_Encode4(1443757), // Rule ID 6537 //
     /* 1443665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1443676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1443679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1443682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1443688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1443695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1443703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443715 */     // MIs[1] Operand 1
     /* 1443715 */     // No operand predicates
     /* 1443715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443719 */     // MIs[0] policy
     /* 1443719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443731 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1443734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443756 */     // GIR_Coverage, 6537,
     /* 1443756 */     GIR_EraseRootFromParent_Done,
     /* 1443757 */   // Label 20336: @1443757
     /* 1443757 */   GIM_Try, /*On fail goto*//*Label 20337*/ GIMT_Encode4(1443854), // Rule ID 6540 //
     /* 1443762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1443773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1443776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1443779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443812 */     // MIs[1] Operand 1
     /* 1443812 */     // No operand predicates
     /* 1443812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443816 */     // MIs[0] policy
     /* 1443816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443853 */     // GIR_Coverage, 6540,
     /* 1443853 */     GIR_EraseRootFromParent_Done,
     /* 1443854 */   // Label 20337: @1443854
     /* 1443854 */   GIM_Try, /*On fail goto*//*Label 20338*/ GIMT_Encode4(1443951), // Rule ID 6541 //
     /* 1443859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1443870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1443873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1443876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1443889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1443897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1443909 */     // MIs[1] Operand 1
     /* 1443909 */     // No operand predicates
     /* 1443909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443913 */     // MIs[0] policy
     /* 1443913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1443928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443950 */     // GIR_Coverage, 6541,
     /* 1443950 */     GIR_EraseRootFromParent_Done,
     /* 1443951 */   // Label 20338: @1443951
     /* 1443951 */   GIM_Try, /*On fail goto*//*Label 20339*/ GIMT_Encode4(1444048), // Rule ID 6544 //
     /* 1443956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1443964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1443967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1443970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1443973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1443986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1443994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444006 */     // MIs[1] Operand 1
     /* 1444006 */     // No operand predicates
     /* 1444006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444010 */     // MIs[0] policy
     /* 1444010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444047 */     // GIR_Coverage, 6544,
     /* 1444047 */     GIR_EraseRootFromParent_Done,
     /* 1444048 */   // Label 20339: @1444048
     /* 1444048 */   GIM_Try, /*On fail goto*//*Label 20340*/ GIMT_Encode4(1444145), // Rule ID 6545 //
     /* 1444053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1444064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1444067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1444070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444103 */     // MIs[1] Operand 1
     /* 1444103 */     // No operand predicates
     /* 1444103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444107 */     // MIs[0] policy
     /* 1444107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444119 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444144 */     // GIR_Coverage, 6545,
     /* 1444144 */     GIR_EraseRootFromParent_Done,
     /* 1444145 */   // Label 20340: @1444145
     /* 1444145 */   GIM_Try, /*On fail goto*//*Label 20341*/ GIMT_Encode4(1444242), // Rule ID 6548 //
     /* 1444150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1444161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1444164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1444167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444200 */     // MIs[1] Operand 1
     /* 1444200 */     // No operand predicates
     /* 1444200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444204 */     // MIs[0] policy
     /* 1444204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444216 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444241 */     // GIR_Coverage, 6548,
     /* 1444241 */     GIR_EraseRootFromParent_Done,
     /* 1444242 */   // Label 20341: @1444242
     /* 1444242 */   GIM_Try, /*On fail goto*//*Label 20342*/ GIMT_Encode4(1444339), // Rule ID 6549 //
     /* 1444247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1444258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1444261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1444264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444297 */     // MIs[1] Operand 1
     /* 1444297 */     // No operand predicates
     /* 1444297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444301 */     // MIs[0] policy
     /* 1444301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444313 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444338 */     // GIR_Coverage, 6549,
     /* 1444338 */     GIR_EraseRootFromParent_Done,
     /* 1444339 */   // Label 20342: @1444339
     /* 1444339 */   GIM_Try, /*On fail goto*//*Label 20343*/ GIMT_Encode4(1444436), // Rule ID 6552 //
     /* 1444344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1444361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444394 */     // MIs[1] Operand 1
     /* 1444394 */     // No operand predicates
     /* 1444394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444398 */     // MIs[0] policy
     /* 1444398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444435 */     // GIR_Coverage, 6552,
     /* 1444435 */     GIR_EraseRootFromParent_Done,
     /* 1444436 */   // Label 20343: @1444436
     /* 1444436 */   GIM_Try, /*On fail goto*//*Label 20344*/ GIMT_Encode4(1444533), // Rule ID 6553 //
     /* 1444441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1444452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1444455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1444458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444491 */     // MIs[1] Operand 1
     /* 1444491 */     // No operand predicates
     /* 1444491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444495 */     // MIs[0] policy
     /* 1444495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444507 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1444510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444532 */     // GIR_Coverage, 6553,
     /* 1444532 */     GIR_EraseRootFromParent_Done,
     /* 1444533 */   // Label 20344: @1444533
     /* 1444533 */   GIM_Try, /*On fail goto*//*Label 20345*/ GIMT_Encode4(1444630), // Rule ID 6556 //
     /* 1444538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1444549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1444552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1444555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444588 */     // MIs[1] Operand 1
     /* 1444588 */     // No operand predicates
     /* 1444588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444592 */     // MIs[0] policy
     /* 1444592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444629 */     // GIR_Coverage, 6556,
     /* 1444629 */     GIR_EraseRootFromParent_Done,
     /* 1444630 */   // Label 20345: @1444630
     /* 1444630 */   GIM_Try, /*On fail goto*//*Label 20346*/ GIMT_Encode4(1444727), // Rule ID 6557 //
     /* 1444635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1444646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1444649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1444652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444685 */     // MIs[1] Operand 1
     /* 1444685 */     // No operand predicates
     /* 1444685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444689 */     // MIs[0] policy
     /* 1444689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444701 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1444704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444726 */     // GIR_Coverage, 6557,
     /* 1444726 */     GIR_EraseRootFromParent_Done,
     /* 1444727 */   // Label 20346: @1444727
     /* 1444727 */   GIM_Try, /*On fail goto*//*Label 20347*/ GIMT_Encode4(1444824), // Rule ID 6560 //
     /* 1444732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1444743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1444746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1444749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444782 */     // MIs[1] Operand 1
     /* 1444782 */     // No operand predicates
     /* 1444782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444786 */     // MIs[0] policy
     /* 1444786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444798 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444823 */     // GIR_Coverage, 6560,
     /* 1444823 */     GIR_EraseRootFromParent_Done,
     /* 1444824 */   // Label 20347: @1444824
     /* 1444824 */   GIM_Try, /*On fail goto*//*Label 20348*/ GIMT_Encode4(1444921), // Rule ID 6561 //
     /* 1444829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1444837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1444840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1444843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1444846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1444852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1444879 */     // MIs[1] Operand 1
     /* 1444879 */     // No operand predicates
     /* 1444879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444883 */     // MIs[0] policy
     /* 1444883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444895 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1444898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444920 */     // GIR_Coverage, 6561,
     /* 1444920 */     GIR_EraseRootFromParent_Done,
     /* 1444921 */   // Label 20348: @1444921
     /* 1444921 */   GIM_Try, /*On fail goto*//*Label 20349*/ GIMT_Encode4(1445018), // Rule ID 6740 //
     /* 1444926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1444934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1444937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1444940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1444943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1444949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444976 */     // MIs[1] Operand 1
     /* 1444976 */     // No operand predicates
     /* 1444976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444980 */     // MIs[0] policy
     /* 1444980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1444995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445017 */     // GIR_Coverage, 6740,
     /* 1445017 */     GIR_EraseRootFromParent_Done,
     /* 1445018 */   // Label 20349: @1445018
     /* 1445018 */   GIM_Try, /*On fail goto*//*Label 20350*/ GIMT_Encode4(1445115), // Rule ID 6741 //
     /* 1445023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1445034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1445037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1445040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445073 */     // MIs[1] Operand 1
     /* 1445073 */     // No operand predicates
     /* 1445073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445077 */     // MIs[0] policy
     /* 1445077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445089 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1445092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445114 */     // GIR_Coverage, 6741,
     /* 1445114 */     GIR_EraseRootFromParent_Done,
     /* 1445115 */   // Label 20350: @1445115
     /* 1445115 */   GIM_Try, /*On fail goto*//*Label 20351*/ GIMT_Encode4(1445212), // Rule ID 6744 //
     /* 1445120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1445131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1445134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1445137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445170 */     // MIs[1] Operand 1
     /* 1445170 */     // No operand predicates
     /* 1445170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445174 */     // MIs[0] policy
     /* 1445174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445186 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445211 */     // GIR_Coverage, 6744,
     /* 1445211 */     GIR_EraseRootFromParent_Done,
     /* 1445212 */   // Label 20351: @1445212
     /* 1445212 */   GIM_Try, /*On fail goto*//*Label 20352*/ GIMT_Encode4(1445309), // Rule ID 6745 //
     /* 1445217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1445228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1445231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1445234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445267 */     // MIs[1] Operand 1
     /* 1445267 */     // No operand predicates
     /* 1445267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445271 */     // MIs[0] policy
     /* 1445271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445283 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445308 */     // GIR_Coverage, 6745,
     /* 1445308 */     GIR_EraseRootFromParent_Done,
     /* 1445309 */   // Label 20352: @1445309
     /* 1445309 */   GIM_Try, /*On fail goto*//*Label 20353*/ GIMT_Encode4(1445406), // Rule ID 6748 //
     /* 1445314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1445325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1445328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1445331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445364 */     // MIs[1] Operand 1
     /* 1445364 */     // No operand predicates
     /* 1445364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445368 */     // MIs[0] policy
     /* 1445368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445380 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445405 */     // GIR_Coverage, 6748,
     /* 1445405 */     GIR_EraseRootFromParent_Done,
     /* 1445406 */   // Label 20353: @1445406
     /* 1445406 */   GIM_Try, /*On fail goto*//*Label 20354*/ GIMT_Encode4(1445503), // Rule ID 6749 //
     /* 1445411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1445422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1445425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1445428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445461 */     // MIs[1] Operand 1
     /* 1445461 */     // No operand predicates
     /* 1445461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445465 */     // MIs[0] policy
     /* 1445465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445477 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445502 */     // GIR_Coverage, 6749,
     /* 1445502 */     GIR_EraseRootFromParent_Done,
     /* 1445503 */   // Label 20354: @1445503
     /* 1445503 */   GIM_Try, /*On fail goto*//*Label 20355*/ GIMT_Encode4(1445600), // Rule ID 6752 //
     /* 1445508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1445519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1445522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1445525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445558 */     // MIs[1] Operand 1
     /* 1445558 */     // No operand predicates
     /* 1445558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445562 */     // MIs[0] policy
     /* 1445562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445574 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445599 */     // GIR_Coverage, 6752,
     /* 1445599 */     GIR_EraseRootFromParent_Done,
     /* 1445600 */   // Label 20355: @1445600
     /* 1445600 */   GIM_Try, /*On fail goto*//*Label 20356*/ GIMT_Encode4(1445697), // Rule ID 6753 //
     /* 1445605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1445616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1445619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1445622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445655 */     // MIs[1] Operand 1
     /* 1445655 */     // No operand predicates
     /* 1445655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445659 */     // MIs[0] policy
     /* 1445659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445671 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1445674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445696 */     // GIR_Coverage, 6753,
     /* 1445696 */     GIR_EraseRootFromParent_Done,
     /* 1445697 */   // Label 20356: @1445697
     /* 1445697 */   GIM_Try, /*On fail goto*//*Label 20357*/ GIMT_Encode4(1445794), // Rule ID 6756 //
     /* 1445702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1445713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1445716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1445719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445752 */     // MIs[1] Operand 1
     /* 1445752 */     // No operand predicates
     /* 1445752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445756 */     // MIs[0] policy
     /* 1445756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445793 */     // GIR_Coverage, 6756,
     /* 1445793 */     GIR_EraseRootFromParent_Done,
     /* 1445794 */   // Label 20357: @1445794
     /* 1445794 */   GIM_Try, /*On fail goto*//*Label 20358*/ GIMT_Encode4(1445891), // Rule ID 6757 //
     /* 1445799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1445810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1445813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1445816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1445822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445849 */     // MIs[1] Operand 1
     /* 1445849 */     // No operand predicates
     /* 1445849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445853 */     // MIs[0] policy
     /* 1445853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445865 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445890 */     // GIR_Coverage, 6757,
     /* 1445890 */     GIR_EraseRootFromParent_Done,
     /* 1445891 */   // Label 20358: @1445891
     /* 1445891 */   GIM_Try, /*On fail goto*//*Label 20359*/ GIMT_Encode4(1445988), // Rule ID 6760 //
     /* 1445896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1445904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1445907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1445910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1445913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1445919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1445926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1445934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445946 */     // MIs[1] Operand 1
     /* 1445946 */     // No operand predicates
     /* 1445946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445950 */     // MIs[0] policy
     /* 1445950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445962 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1445965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445987 */     // GIR_Coverage, 6760,
     /* 1445987 */     GIR_EraseRootFromParent_Done,
     /* 1445988 */   // Label 20359: @1445988
     /* 1445988 */   GIM_Try, /*On fail goto*//*Label 20360*/ GIMT_Encode4(1446085), // Rule ID 6761 //
     /* 1445993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1446004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1446007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1446010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446043 */     // MIs[1] Operand 1
     /* 1446043 */     // No operand predicates
     /* 1446043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446047 */     // MIs[0] policy
     /* 1446047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446059 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1446062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446084 */     // GIR_Coverage, 6761,
     /* 1446084 */     GIR_EraseRootFromParent_Done,
     /* 1446085 */   // Label 20360: @1446085
     /* 1446085 */   GIM_Try, /*On fail goto*//*Label 20361*/ GIMT_Encode4(1446182), // Rule ID 6764 //
     /* 1446090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1446101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1446104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1446107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446140 */     // MIs[1] Operand 1
     /* 1446140 */     // No operand predicates
     /* 1446140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446144 */     // MIs[0] policy
     /* 1446144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446156 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446181 */     // GIR_Coverage, 6764,
     /* 1446181 */     GIR_EraseRootFromParent_Done,
     /* 1446182 */   // Label 20361: @1446182
     /* 1446182 */   GIM_Try, /*On fail goto*//*Label 20362*/ GIMT_Encode4(1446279), // Rule ID 6765 //
     /* 1446187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1446198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1446201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1446204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446237 */     // MIs[1] Operand 1
     /* 1446237 */     // No operand predicates
     /* 1446237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446241 */     // MIs[0] policy
     /* 1446241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446253 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446278 */     // GIR_Coverage, 6765,
     /* 1446278 */     GIR_EraseRootFromParent_Done,
     /* 1446279 */   // Label 20362: @1446279
     /* 1446279 */   GIM_Try, /*On fail goto*//*Label 20363*/ GIMT_Encode4(1446376), // Rule ID 6768 //
     /* 1446284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1446295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1446298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446334 */     // MIs[1] Operand 1
     /* 1446334 */     // No operand predicates
     /* 1446334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446338 */     // MIs[0] policy
     /* 1446338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446375 */     // GIR_Coverage, 6768,
     /* 1446375 */     GIR_EraseRootFromParent_Done,
     /* 1446376 */   // Label 20363: @1446376
     /* 1446376 */   GIM_Try, /*On fail goto*//*Label 20364*/ GIMT_Encode4(1446473), // Rule ID 6769 //
     /* 1446381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1446392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1446395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1446398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446431 */     // MIs[1] Operand 1
     /* 1446431 */     // No operand predicates
     /* 1446431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446435 */     // MIs[0] policy
     /* 1446435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446447 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1446469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446472 */     // GIR_Coverage, 6769,
     /* 1446472 */     GIR_EraseRootFromParent_Done,
     /* 1446473 */   // Label 20364: @1446473
     /* 1446473 */   GIM_Try, /*On fail goto*//*Label 20365*/ GIMT_Encode4(1446570), // Rule ID 6772 //
     /* 1446478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1446495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446528 */     // MIs[1] Operand 1
     /* 1446528 */     // No operand predicates
     /* 1446528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446532 */     // MIs[0] policy
     /* 1446532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446569 */     // GIR_Coverage, 6772,
     /* 1446569 */     GIR_EraseRootFromParent_Done,
     /* 1446570 */   // Label 20365: @1446570
     /* 1446570 */   GIM_Try, /*On fail goto*//*Label 20366*/ GIMT_Encode4(1446667), // Rule ID 6773 //
     /* 1446575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1446586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1446589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1446592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446625 */     // MIs[1] Operand 1
     /* 1446625 */     // No operand predicates
     /* 1446625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446629 */     // MIs[0] policy
     /* 1446629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446641 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446666 */     // GIR_Coverage, 6773,
     /* 1446666 */     GIR_EraseRootFromParent_Done,
     /* 1446667 */   // Label 20366: @1446667
     /* 1446667 */   GIM_Try, /*On fail goto*//*Label 20367*/ GIMT_Encode4(1446764), // Rule ID 6776 //
     /* 1446672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1446675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1446683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1446686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1446689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446722 */     // MIs[1] Operand 1
     /* 1446722 */     // No operand predicates
     /* 1446722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446726 */     // MIs[0] policy
     /* 1446726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446738 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446763 */     // GIR_Coverage, 6776,
     /* 1446763 */     GIR_EraseRootFromParent_Done,
     /* 1446764 */   // Label 20367: @1446764
     /* 1446764 */   GIM_Try, /*On fail goto*//*Label 20368*/ GIMT_Encode4(1446861), // Rule ID 6777 //
     /* 1446769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1446772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1446780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1446783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1446786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446819 */     // MIs[1] Operand 1
     /* 1446819 */     // No operand predicates
     /* 1446819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446823 */     // MIs[0] policy
     /* 1446823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446835 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1446838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446860 */     // GIR_Coverage, 6777,
     /* 1446860 */     GIR_EraseRootFromParent_Done,
     /* 1446861 */   // Label 20368: @1446861
     /* 1446861 */   GIM_Try, /*On fail goto*//*Label 20369*/ GIMT_Encode4(1446958), // Rule ID 6780 //
     /* 1446866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1446877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1446880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1446883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1446896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446916 */     // MIs[1] Operand 1
     /* 1446916 */     // No operand predicates
     /* 1446916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446920 */     // MIs[0] policy
     /* 1446920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1446935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446957 */     // GIR_Coverage, 6780,
     /* 1446957 */     GIR_EraseRootFromParent_Done,
     /* 1446958 */   // Label 20369: @1446958
     /* 1446958 */   GIM_Try, /*On fail goto*//*Label 20370*/ GIMT_Encode4(1447055), // Rule ID 6781 //
     /* 1446963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1446971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1446974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1446977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1446980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1446993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447013 */     // MIs[1] Operand 1
     /* 1447013 */     // No operand predicates
     /* 1447013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447017 */     // MIs[0] policy
     /* 1447017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447029 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447054 */     // GIR_Coverage, 6781,
     /* 1447054 */     GIR_EraseRootFromParent_Done,
     /* 1447055 */   // Label 20370: @1447055
     /* 1447055 */   GIM_Try, /*On fail goto*//*Label 20371*/ GIMT_Encode4(1447152), // Rule ID 6784 //
     /* 1447060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1447071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1447074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1447077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447110 */     // MIs[1] Operand 1
     /* 1447110 */     // No operand predicates
     /* 1447110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447114 */     // MIs[0] policy
     /* 1447114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447151 */     // GIR_Coverage, 6784,
     /* 1447151 */     GIR_EraseRootFromParent_Done,
     /* 1447152 */   // Label 20371: @1447152
     /* 1447152 */   GIM_Try, /*On fail goto*//*Label 20372*/ GIMT_Encode4(1447249), // Rule ID 6785 //
     /* 1447157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1447168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1447171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1447174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447207 */     // MIs[1] Operand 1
     /* 1447207 */     // No operand predicates
     /* 1447207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447211 */     // MIs[0] policy
     /* 1447211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447223 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447248 */     // GIR_Coverage, 6785,
     /* 1447248 */     GIR_EraseRootFromParent_Done,
     /* 1447249 */   // Label 20372: @1447249
     /* 1447249 */   GIM_Try, /*On fail goto*//*Label 20373*/ GIMT_Encode4(1447346), // Rule ID 6788 //
     /* 1447254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1447265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1447268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1447271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1447277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447304 */     // MIs[1] Operand 1
     /* 1447304 */     // No operand predicates
     /* 1447304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447308 */     // MIs[0] policy
     /* 1447308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447320 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447345 */     // GIR_Coverage, 6788,
     /* 1447345 */     GIR_EraseRootFromParent_Done,
     /* 1447346 */   // Label 20373: @1447346
     /* 1447346 */   GIM_Try, /*On fail goto*//*Label 20374*/ GIMT_Encode4(1447443), // Rule ID 6789 //
     /* 1447351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1447362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1447365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1447368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1447374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447401 */     // MIs[1] Operand 1
     /* 1447401 */     // No operand predicates
     /* 1447401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447405 */     // MIs[0] policy
     /* 1447405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447417 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447442 */     // GIR_Coverage, 6789,
     /* 1447442 */     GIR_EraseRootFromParent_Done,
     /* 1447443 */   // Label 20374: @1447443
     /* 1447443 */   GIM_Try, /*On fail goto*//*Label 20375*/ GIMT_Encode4(1447540), // Rule ID 6792 //
     /* 1447448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1447459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1447462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1447465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447498 */     // MIs[1] Operand 1
     /* 1447498 */     // No operand predicates
     /* 1447498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447502 */     // MIs[0] policy
     /* 1447502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447539 */     // GIR_Coverage, 6792,
     /* 1447539 */     GIR_EraseRootFromParent_Done,
     /* 1447540 */   // Label 20375: @1447540
     /* 1447540 */   GIM_Try, /*On fail goto*//*Label 20376*/ GIMT_Encode4(1447637), // Rule ID 6793 //
     /* 1447545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1447556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1447559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1447562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1447568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1447575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1447583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447595 */     // MIs[1] Operand 1
     /* 1447595 */     // No operand predicates
     /* 1447595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447599 */     // MIs[0] policy
     /* 1447599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447611 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1447614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447636 */     // GIR_Coverage, 6793,
     /* 1447636 */     GIR_EraseRootFromParent_Done,
     /* 1447637 */   // Label 20376: @1447637
     /* 1447637 */   GIM_Try, /*On fail goto*//*Label 20377*/ GIMT_Encode4(1447734), // Rule ID 6796 //
     /* 1447642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1447653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1447656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1447659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447692 */     // MIs[1] Operand 1
     /* 1447692 */     // No operand predicates
     /* 1447692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447696 */     // MIs[0] policy
     /* 1447696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447708 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447733 */     // GIR_Coverage, 6796,
     /* 1447733 */     GIR_EraseRootFromParent_Done,
     /* 1447734 */   // Label 20377: @1447734
     /* 1447734 */   GIM_Try, /*On fail goto*//*Label 20378*/ GIMT_Encode4(1447831), // Rule ID 6797 //
     /* 1447739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1447750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1447753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1447756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1447762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1447769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1447777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447789 */     // MIs[1] Operand 1
     /* 1447789 */     // No operand predicates
     /* 1447789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447793 */     // MIs[0] policy
     /* 1447793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447805 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1447808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447830 */     // GIR_Coverage, 6797,
     /* 1447830 */     GIR_EraseRootFromParent_Done,
     /* 1447831 */   // Label 20378: @1447831
     /* 1447831 */   GIM_Try, /*On fail goto*//*Label 20379*/ GIMT_Encode4(1447928), // Rule ID 6800 //
     /* 1447836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1447847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1447850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1447853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447886 */     // MIs[1] Operand 1
     /* 1447886 */     // No operand predicates
     /* 1447886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447890 */     // MIs[0] policy
     /* 1447890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447902 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1447905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447927 */     // GIR_Coverage, 6800,
     /* 1447927 */     GIR_EraseRootFromParent_Done,
     /* 1447928 */   // Label 20379: @1447928
     /* 1447928 */   GIM_Try, /*On fail goto*//*Label 20380*/ GIMT_Encode4(1448025), // Rule ID 6801 //
     /* 1447933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1447941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1447944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1447947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1447950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1447956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1447963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1447971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447983 */     // MIs[1] Operand 1
     /* 1447983 */     // No operand predicates
     /* 1447983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447987 */     // MIs[0] policy
     /* 1447987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447999 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448024 */     // GIR_Coverage, 6801,
     /* 1448024 */     GIR_EraseRootFromParent_Done,
     /* 1448025 */   // Label 20380: @1448025
     /* 1448025 */   GIM_Try, /*On fail goto*//*Label 20381*/ GIMT_Encode4(1448122), // Rule ID 6804 //
     /* 1448030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1448041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1448047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448080 */     // MIs[1] Operand 1
     /* 1448080 */     // No operand predicates
     /* 1448080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448084 */     // MIs[0] policy
     /* 1448084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448121 */     // GIR_Coverage, 6804,
     /* 1448121 */     GIR_EraseRootFromParent_Done,
     /* 1448122 */   // Label 20381: @1448122
     /* 1448122 */   GIM_Try, /*On fail goto*//*Label 20382*/ GIMT_Encode4(1448219), // Rule ID 6805 //
     /* 1448127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1448138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1448141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1448144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448177 */     // MIs[1] Operand 1
     /* 1448177 */     // No operand predicates
     /* 1448177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448181 */     // MIs[0] policy
     /* 1448181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448193 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448218 */     // GIR_Coverage, 6805,
     /* 1448218 */     GIR_EraseRootFromParent_Done,
     /* 1448219 */   // Label 20382: @1448219
     /* 1448219 */   GIM_Try, /*On fail goto*//*Label 20383*/ GIMT_Encode4(1448316), // Rule ID 6808 //
     /* 1448224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1448241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448274 */     // MIs[1] Operand 1
     /* 1448274 */     // No operand predicates
     /* 1448274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448278 */     // MIs[0] policy
     /* 1448278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448315 */     // GIR_Coverage, 6808,
     /* 1448315 */     GIR_EraseRootFromParent_Done,
     /* 1448316 */   // Label 20383: @1448316
     /* 1448316 */   GIM_Try, /*On fail goto*//*Label 20384*/ GIMT_Encode4(1448413), // Rule ID 6809 //
     /* 1448321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1448332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1448335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1448338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448371 */     // MIs[1] Operand 1
     /* 1448371 */     // No operand predicates
     /* 1448371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448375 */     // MIs[0] policy
     /* 1448375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448387 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448412 */     // GIR_Coverage, 6809,
     /* 1448412 */     GIR_EraseRootFromParent_Done,
     /* 1448413 */   // Label 20384: @1448413
     /* 1448413 */   GIM_Try, /*On fail goto*//*Label 20385*/ GIMT_Encode4(1448510), // Rule ID 6812 //
     /* 1448418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1448435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448468 */     // MIs[1] Operand 1
     /* 1448468 */     // No operand predicates
     /* 1448468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448472 */     // MIs[0] policy
     /* 1448472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448484 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448509 */     // GIR_Coverage, 6812,
     /* 1448509 */     GIR_EraseRootFromParent_Done,
     /* 1448510 */   // Label 20385: @1448510
     /* 1448510 */   GIM_Try, /*On fail goto*//*Label 20386*/ GIMT_Encode4(1448607), // Rule ID 6813 //
     /* 1448515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1448526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1448529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1448532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1448545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1448553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448565 */     // MIs[1] Operand 1
     /* 1448565 */     // No operand predicates
     /* 1448565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448569 */     // MIs[0] policy
     /* 1448569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448581 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1448584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448606 */     // GIR_Coverage, 6813,
     /* 1448606 */     GIR_EraseRootFromParent_Done,
     /* 1448607 */   // Label 20386: @1448607
     /* 1448607 */   GIM_Try, /*On fail goto*//*Label 20387*/ GIMT_Encode4(1448704), // Rule ID 6816 //
     /* 1448612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1448615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1448623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1448626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1448629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448662 */     // MIs[1] Operand 1
     /* 1448662 */     // No operand predicates
     /* 1448662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448666 */     // MIs[0] policy
     /* 1448666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448703 */     // GIR_Coverage, 6816,
     /* 1448703 */     GIR_EraseRootFromParent_Done,
     /* 1448704 */   // Label 20387: @1448704
     /* 1448704 */   GIM_Try, /*On fail goto*//*Label 20388*/ GIMT_Encode4(1448801), // Rule ID 6817 //
     /* 1448709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1448712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1448720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1448723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1448726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448759 */     // MIs[1] Operand 1
     /* 1448759 */     // No operand predicates
     /* 1448759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448763 */     // MIs[0] policy
     /* 1448763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448775 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1448778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448800 */     // GIR_Coverage, 6817,
     /* 1448800 */     GIR_EraseRootFromParent_Done,
     /* 1448801 */   // Label 20388: @1448801
     /* 1448801 */   GIM_Try, /*On fail goto*//*Label 20389*/ GIMT_Encode4(1448898), // Rule ID 6820 //
     /* 1448806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1448809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1448817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1448820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1448823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448856 */     // MIs[1] Operand 1
     /* 1448856 */     // No operand predicates
     /* 1448856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448860 */     // MIs[0] policy
     /* 1448860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448872 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448897 */     // GIR_Coverage, 6820,
     /* 1448897 */     GIR_EraseRootFromParent_Done,
     /* 1448898 */   // Label 20389: @1448898
     /* 1448898 */   GIM_Try, /*On fail goto*//*Label 20390*/ GIMT_Encode4(1448995), // Rule ID 6821 //
     /* 1448903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1448906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1448911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1448914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1448917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1448920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1448933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1448941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448953 */     // MIs[1] Operand 1
     /* 1448953 */     // No operand predicates
     /* 1448953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448957 */     // MIs[0] policy
     /* 1448957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448969 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1448972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448994 */     // GIR_Coverage, 6821,
     /* 1448994 */     GIR_EraseRootFromParent_Done,
     /* 1448995 */   // Label 20390: @1448995
     /* 1448995 */   GIM_Try, /*On fail goto*//*Label 20391*/ GIMT_Encode4(1449092), // Rule ID 6824 //
     /* 1449000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1449003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1449011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1449014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1449017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449050 */     // MIs[1] Operand 1
     /* 1449050 */     // No operand predicates
     /* 1449050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449054 */     // MIs[0] policy
     /* 1449054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449066 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449091 */     // GIR_Coverage, 6824,
     /* 1449091 */     GIR_EraseRootFromParent_Done,
     /* 1449092 */   // Label 20391: @1449092
     /* 1449092 */   GIM_Try, /*On fail goto*//*Label 20392*/ GIMT_Encode4(1449189), // Rule ID 6825 //
     /* 1449097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1449100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1449105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1449108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1449111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1449114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449147 */     // MIs[1] Operand 1
     /* 1449147 */     // No operand predicates
     /* 1449147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449151 */     // MIs[0] policy
     /* 1449151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449163 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1449166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1449185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449188 */     // GIR_Coverage, 6825,
     /* 1449188 */     GIR_EraseRootFromParent_Done,
     /* 1449189 */   // Label 20392: @1449189
     /* 1449189 */   GIM_Try, /*On fail goto*//*Label 20393*/ GIMT_Encode4(1449286), // Rule ID 7004 //
     /* 1449194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1449205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1449208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1449211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449244 */     // MIs[1] Operand 1
     /* 1449244 */     // No operand predicates
     /* 1449244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449248 */     // MIs[0] policy
     /* 1449248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449260 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1449263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449285 */     // GIR_Coverage, 7004,
     /* 1449285 */     GIR_EraseRootFromParent_Done,
     /* 1449286 */   // Label 20393: @1449286
     /* 1449286 */   GIM_Try, /*On fail goto*//*Label 20394*/ GIMT_Encode4(1449383), // Rule ID 7005 //
     /* 1449291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1449302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1449305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1449308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449341 */     // MIs[1] Operand 1
     /* 1449341 */     // No operand predicates
     /* 1449341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449345 */     // MIs[0] policy
     /* 1449345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449357 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1449360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449382 */     // GIR_Coverage, 7005,
     /* 1449382 */     GIR_EraseRootFromParent_Done,
     /* 1449383 */   // Label 20394: @1449383
     /* 1449383 */   GIM_Try, /*On fail goto*//*Label 20395*/ GIMT_Encode4(1449480), // Rule ID 7008 //
     /* 1449388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1449399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1449402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1449405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449438 */     // MIs[1] Operand 1
     /* 1449438 */     // No operand predicates
     /* 1449438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449442 */     // MIs[0] policy
     /* 1449442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449454 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449479 */     // GIR_Coverage, 7008,
     /* 1449479 */     GIR_EraseRootFromParent_Done,
     /* 1449480 */   // Label 20395: @1449480
     /* 1449480 */   GIM_Try, /*On fail goto*//*Label 20396*/ GIMT_Encode4(1449577), // Rule ID 7009 //
     /* 1449485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1449496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1449499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1449502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449535 */     // MIs[1] Operand 1
     /* 1449535 */     // No operand predicates
     /* 1449535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449539 */     // MIs[0] policy
     /* 1449539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449551 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449576 */     // GIR_Coverage, 7009,
     /* 1449576 */     GIR_EraseRootFromParent_Done,
     /* 1449577 */   // Label 20396: @1449577
     /* 1449577 */   GIM_Try, /*On fail goto*//*Label 20397*/ GIMT_Encode4(1449674), // Rule ID 7012 //
     /* 1449582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1449593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1449596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1449599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449632 */     // MIs[1] Operand 1
     /* 1449632 */     // No operand predicates
     /* 1449632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449636 */     // MIs[0] policy
     /* 1449636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449648 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1449651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449673 */     // GIR_Coverage, 7012,
     /* 1449673 */     GIR_EraseRootFromParent_Done,
     /* 1449674 */   // Label 20397: @1449674
     /* 1449674 */   GIM_Try, /*On fail goto*//*Label 20398*/ GIMT_Encode4(1449771), // Rule ID 7013 //
     /* 1449679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1449690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1449693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1449696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1449702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449729 */     // MIs[1] Operand 1
     /* 1449729 */     // No operand predicates
     /* 1449729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449733 */     // MIs[0] policy
     /* 1449733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449745 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1449748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449770 */     // GIR_Coverage, 7013,
     /* 1449770 */     GIR_EraseRootFromParent_Done,
     /* 1449771 */   // Label 20398: @1449771
     /* 1449771 */   GIM_Try, /*On fail goto*//*Label 20399*/ GIMT_Encode4(1449868), // Rule ID 7016 //
     /* 1449776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1449787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1449790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1449793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449826 */     // MIs[1] Operand 1
     /* 1449826 */     // No operand predicates
     /* 1449826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449830 */     // MIs[0] policy
     /* 1449830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449842 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449867 */     // GIR_Coverage, 7016,
     /* 1449867 */     GIR_EraseRootFromParent_Done,
     /* 1449868 */   // Label 20399: @1449868
     /* 1449868 */   GIM_Try, /*On fail goto*//*Label 20400*/ GIMT_Encode4(1449965), // Rule ID 7017 //
     /* 1449873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1449884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1449887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1449890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1449896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1449903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1449911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449923 */     // MIs[1] Operand 1
     /* 1449923 */     // No operand predicates
     /* 1449923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449927 */     // MIs[0] policy
     /* 1449927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449939 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1449942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449964 */     // GIR_Coverage, 7017,
     /* 1449964 */     GIR_EraseRootFromParent_Done,
     /* 1449965 */   // Label 20400: @1449965
     /* 1449965 */   GIM_Try, /*On fail goto*//*Label 20401*/ GIMT_Encode4(1450062), // Rule ID 7020 //
     /* 1449970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1449978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1449981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1449984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1449987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1449993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450020 */     // MIs[1] Operand 1
     /* 1450020 */     // No operand predicates
     /* 1450020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450024 */     // MIs[0] policy
     /* 1450024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450036 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450061 */     // GIR_Coverage, 7020,
     /* 1450061 */     GIR_EraseRootFromParent_Done,
     /* 1450062 */   // Label 20401: @1450062
     /* 1450062 */   GIM_Try, /*On fail goto*//*Label 20402*/ GIMT_Encode4(1450159), // Rule ID 7021 //
     /* 1450067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1450078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1450081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1450084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450117 */     // MIs[1] Operand 1
     /* 1450117 */     // No operand predicates
     /* 1450117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450121 */     // MIs[0] policy
     /* 1450121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450133 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450158 */     // GIR_Coverage, 7021,
     /* 1450158 */     GIR_EraseRootFromParent_Done,
     /* 1450159 */   // Label 20402: @1450159
     /* 1450159 */   GIM_Try, /*On fail goto*//*Label 20403*/ GIMT_Encode4(1450256), // Rule ID 7024 //
     /* 1450164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1450181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450214 */     // MIs[1] Operand 1
     /* 1450214 */     // No operand predicates
     /* 1450214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450218 */     // MIs[0] policy
     /* 1450218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450230 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450255 */     // GIR_Coverage, 7024,
     /* 1450255 */     GIR_EraseRootFromParent_Done,
     /* 1450256 */   // Label 20403: @1450256
     /* 1450256 */   GIM_Try, /*On fail goto*//*Label 20404*/ GIMT_Encode4(1450353), // Rule ID 7025 //
     /* 1450261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1450272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1450275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1450278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450311 */     // MIs[1] Operand 1
     /* 1450311 */     // No operand predicates
     /* 1450311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450315 */     // MIs[0] policy
     /* 1450315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450327 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1450330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450352 */     // GIR_Coverage, 7025,
     /* 1450352 */     GIR_EraseRootFromParent_Done,
     /* 1450353 */   // Label 20404: @1450353
     /* 1450353 */   GIM_Try, /*On fail goto*//*Label 20405*/ GIMT_Encode4(1450450), // Rule ID 7028 //
     /* 1450358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1450369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1450372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1450375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450408 */     // MIs[1] Operand 1
     /* 1450408 */     // No operand predicates
     /* 1450408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450412 */     // MIs[0] policy
     /* 1450412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450449 */     // GIR_Coverage, 7028,
     /* 1450449 */     GIR_EraseRootFromParent_Done,
     /* 1450450 */   // Label 20405: @1450450
     /* 1450450 */   GIM_Try, /*On fail goto*//*Label 20406*/ GIMT_Encode4(1450547), // Rule ID 7029 //
     /* 1450455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1450466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1450469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1450472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450505 */     // MIs[1] Operand 1
     /* 1450505 */     // No operand predicates
     /* 1450505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450509 */     // MIs[0] policy
     /* 1450509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450521 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1450543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450546 */     // GIR_Coverage, 7029,
     /* 1450546 */     GIR_EraseRootFromParent_Done,
     /* 1450547 */   // Label 20406: @1450547
     /* 1450547 */   GIM_Try, /*On fail goto*//*Label 20407*/ GIMT_Encode4(1450644), // Rule ID 7032 //
     /* 1450552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1450563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1450566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1450569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450602 */     // MIs[1] Operand 1
     /* 1450602 */     // No operand predicates
     /* 1450602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450606 */     // MIs[0] policy
     /* 1450606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450618 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450643 */     // GIR_Coverage, 7032,
     /* 1450643 */     GIR_EraseRootFromParent_Done,
     /* 1450644 */   // Label 20407: @1450644
     /* 1450644 */   GIM_Try, /*On fail goto*//*Label 20408*/ GIMT_Encode4(1450741), // Rule ID 7033 //
     /* 1450649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1450660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1450663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1450666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450699 */     // MIs[1] Operand 1
     /* 1450699 */     // No operand predicates
     /* 1450699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450703 */     // MIs[0] policy
     /* 1450703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450715 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1450737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450740 */     // GIR_Coverage, 7033,
     /* 1450740 */     GIR_EraseRootFromParent_Done,
     /* 1450741 */   // Label 20408: @1450741
     /* 1450741 */   GIM_Try, /*On fail goto*//*Label 20409*/ GIMT_Encode4(1450838), // Rule ID 7036 //
     /* 1450746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1450757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1450760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1450763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450796 */     // MIs[1] Operand 1
     /* 1450796 */     // No operand predicates
     /* 1450796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450800 */     // MIs[0] policy
     /* 1450800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450812 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450837 */     // GIR_Coverage, 7036,
     /* 1450837 */     GIR_EraseRootFromParent_Done,
     /* 1450838 */   // Label 20409: @1450838
     /* 1450838 */   GIM_Try, /*On fail goto*//*Label 20410*/ GIMT_Encode4(1450935), // Rule ID 7037 //
     /* 1450843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1450854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1450857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1450860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450893 */     // MIs[1] Operand 1
     /* 1450893 */     // No operand predicates
     /* 1450893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450897 */     // MIs[0] policy
     /* 1450897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450909 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1450912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450934 */     // GIR_Coverage, 7037,
     /* 1450934 */     GIR_EraseRootFromParent_Done,
     /* 1450935 */   // Label 20410: @1450935
     /* 1450935 */   GIM_Try, /*On fail goto*//*Label 20411*/ GIMT_Encode4(1451032), // Rule ID 7040 //
     /* 1450940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1450943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1450948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1450951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1450954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1450957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1450963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1450970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1450978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450990 */     // MIs[1] Operand 1
     /* 1450990 */     // No operand predicates
     /* 1450990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450994 */     // MIs[0] policy
     /* 1450994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451006 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451031 */     // GIR_Coverage, 7040,
     /* 1451031 */     GIR_EraseRootFromParent_Done,
     /* 1451032 */   // Label 20411: @1451032
     /* 1451032 */   GIM_Try, /*On fail goto*//*Label 20412*/ GIMT_Encode4(1451129), // Rule ID 7041 //
     /* 1451037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1451040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1451048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1451051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1451054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451087 */     // MIs[1] Operand 1
     /* 1451087 */     // No operand predicates
     /* 1451087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451091 */     // MIs[0] policy
     /* 1451091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451103 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1451106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451128 */     // GIR_Coverage, 7041,
     /* 1451128 */     GIR_EraseRootFromParent_Done,
     /* 1451129 */   // Label 20412: @1451129
     /* 1451129 */   GIM_Try, /*On fail goto*//*Label 20413*/ GIMT_Encode4(1451226), // Rule ID 7044 //
     /* 1451134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1451145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1451148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1451151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451184 */     // MIs[1] Operand 1
     /* 1451184 */     // No operand predicates
     /* 1451184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451188 */     // MIs[0] policy
     /* 1451188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451225 */     // GIR_Coverage, 7044,
     /* 1451225 */     GIR_EraseRootFromParent_Done,
     /* 1451226 */   // Label 20413: @1451226
     /* 1451226 */   GIM_Try, /*On fail goto*//*Label 20414*/ GIMT_Encode4(1451323), // Rule ID 7045 //
     /* 1451231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1451242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1451245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1451248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451281 */     // MIs[1] Operand 1
     /* 1451281 */     // No operand predicates
     /* 1451281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451285 */     // MIs[0] policy
     /* 1451285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451297 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451322 */     // GIR_Coverage, 7045,
     /* 1451322 */     GIR_EraseRootFromParent_Done,
     /* 1451323 */   // Label 20414: @1451323
     /* 1451323 */   GIM_Try, /*On fail goto*//*Label 20415*/ GIMT_Encode4(1451420), // Rule ID 7048 //
     /* 1451328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1451339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1451342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1451345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451378 */     // MIs[1] Operand 1
     /* 1451378 */     // No operand predicates
     /* 1451378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451382 */     // MIs[0] policy
     /* 1451382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451394 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451419 */     // GIR_Coverage, 7048,
     /* 1451419 */     GIR_EraseRootFromParent_Done,
     /* 1451420 */   // Label 20415: @1451420
     /* 1451420 */   GIM_Try, /*On fail goto*//*Label 20416*/ GIMT_Encode4(1451517), // Rule ID 7049 //
     /* 1451425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1451436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1451439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1451442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1451448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451475 */     // MIs[1] Operand 1
     /* 1451475 */     // No operand predicates
     /* 1451475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451479 */     // MIs[0] policy
     /* 1451479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451491 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451516 */     // GIR_Coverage, 7049,
     /* 1451516 */     GIR_EraseRootFromParent_Done,
     /* 1451517 */   // Label 20416: @1451517
     /* 1451517 */   GIM_Try, /*On fail goto*//*Label 20417*/ GIMT_Encode4(1451614), // Rule ID 7052 //
     /* 1451522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1451533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1451536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1451539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1451545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451572 */     // MIs[1] Operand 1
     /* 1451572 */     // No operand predicates
     /* 1451572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451576 */     // MIs[0] policy
     /* 1451576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451588 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1451591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451613 */     // GIR_Coverage, 7052,
     /* 1451613 */     GIR_EraseRootFromParent_Done,
     /* 1451614 */   // Label 20417: @1451614
     /* 1451614 */   GIM_Try, /*On fail goto*//*Label 20418*/ GIMT_Encode4(1451711), // Rule ID 7053 //
     /* 1451619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1451630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1451633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1451636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1451642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451669 */     // MIs[1] Operand 1
     /* 1451669 */     // No operand predicates
     /* 1451669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451673 */     // MIs[0] policy
     /* 1451673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451685 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1451688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451710 */     // GIR_Coverage, 7053,
     /* 1451710 */     GIR_EraseRootFromParent_Done,
     /* 1451711 */   // Label 20418: @1451711
     /* 1451711 */   GIM_Try, /*On fail goto*//*Label 20419*/ GIMT_Encode4(1451808), // Rule ID 7056 //
     /* 1451716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1451727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1451730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1451733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451766 */     // MIs[1] Operand 1
     /* 1451766 */     // No operand predicates
     /* 1451766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451770 */     // MIs[0] policy
     /* 1451770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451807 */     // GIR_Coverage, 7056,
     /* 1451807 */     GIR_EraseRootFromParent_Done,
     /* 1451808 */   // Label 20419: @1451808
     /* 1451808 */   GIM_Try, /*On fail goto*//*Label 20420*/ GIMT_Encode4(1451905), // Rule ID 7057 //
     /* 1451813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1451824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1451827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1451830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451863 */     // MIs[1] Operand 1
     /* 1451863 */     // No operand predicates
     /* 1451863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451867 */     // MIs[0] policy
     /* 1451867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1451882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451904 */     // GIR_Coverage, 7057,
     /* 1451904 */     GIR_EraseRootFromParent_Done,
     /* 1451905 */   // Label 20420: @1451905
     /* 1451905 */   GIM_Try, /*On fail goto*//*Label 20421*/ GIMT_Encode4(1452002), // Rule ID 7060 //
     /* 1451910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1451918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1451921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1451924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1451927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1451940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451960 */     // MIs[1] Operand 1
     /* 1451960 */     // No operand predicates
     /* 1451960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451964 */     // MIs[0] policy
     /* 1451964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451976 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1451979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1451998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452001 */     // GIR_Coverage, 7060,
     /* 1452001 */     GIR_EraseRootFromParent_Done,
     /* 1452002 */   // Label 20421: @1452002
     /* 1452002 */   GIM_Try, /*On fail goto*//*Label 20422*/ GIMT_Encode4(1452099), // Rule ID 7061 //
     /* 1452007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1452018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1452021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1452024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452057 */     // MIs[1] Operand 1
     /* 1452057 */     // No operand predicates
     /* 1452057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452061 */     // MIs[0] policy
     /* 1452061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452073 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452098 */     // GIR_Coverage, 7061,
     /* 1452098 */     GIR_EraseRootFromParent_Done,
     /* 1452099 */   // Label 20422: @1452099
     /* 1452099 */   GIM_Try, /*On fail goto*//*Label 20423*/ GIMT_Encode4(1452196), // Rule ID 7064 //
     /* 1452104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1452115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1452118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452154 */     // MIs[1] Operand 1
     /* 1452154 */     // No operand predicates
     /* 1452154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452158 */     // MIs[0] policy
     /* 1452158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452195 */     // GIR_Coverage, 7064,
     /* 1452195 */     GIR_EraseRootFromParent_Done,
     /* 1452196 */   // Label 20423: @1452196
     /* 1452196 */   GIM_Try, /*On fail goto*//*Label 20424*/ GIMT_Encode4(1452293), // Rule ID 7065 //
     /* 1452201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1452212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1452215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452251 */     // MIs[1] Operand 1
     /* 1452251 */     // No operand predicates
     /* 1452251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452255 */     // MIs[0] policy
     /* 1452255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452267 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452292 */     // GIR_Coverage, 7065,
     /* 1452292 */     GIR_EraseRootFromParent_Done,
     /* 1452293 */   // Label 20424: @1452293
     /* 1452293 */   GIM_Try, /*On fail goto*//*Label 20425*/ GIMT_Encode4(1452390), // Rule ID 7068 //
     /* 1452298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1452309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1452312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452348 */     // MIs[1] Operand 1
     /* 1452348 */     // No operand predicates
     /* 1452348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452352 */     // MIs[0] policy
     /* 1452352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452389 */     // GIR_Coverage, 7068,
     /* 1452389 */     GIR_EraseRootFromParent_Done,
     /* 1452390 */   // Label 20425: @1452390
     /* 1452390 */   GIM_Try, /*On fail goto*//*Label 20426*/ GIMT_Encode4(1452487), // Rule ID 7069 //
     /* 1452395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1452406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1452409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452445 */     // MIs[1] Operand 1
     /* 1452445 */     // No operand predicates
     /* 1452445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452449 */     // MIs[0] policy
     /* 1452449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452461 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452486 */     // GIR_Coverage, 7069,
     /* 1452486 */     GIR_EraseRootFromParent_Done,
     /* 1452487 */   // Label 20426: @1452487
     /* 1452487 */   GIM_Try, /*On fail goto*//*Label 20427*/ GIMT_Encode4(1452584), // Rule ID 7072 //
     /* 1452492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1452503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1452506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1452509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452542 */     // MIs[1] Operand 1
     /* 1452542 */     // No operand predicates
     /* 1452542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452546 */     // MIs[0] policy
     /* 1452546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452583 */     // GIR_Coverage, 7072,
     /* 1452583 */     GIR_EraseRootFromParent_Done,
     /* 1452584 */   // Label 20427: @1452584
     /* 1452584 */   GIM_Try, /*On fail goto*//*Label 20428*/ GIMT_Encode4(1452681), // Rule ID 7073 //
     /* 1452589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1452600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1452603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1452606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452639 */     // MIs[1] Operand 1
     /* 1452639 */     // No operand predicates
     /* 1452639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452643 */     // MIs[0] policy
     /* 1452643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452655 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1452658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452680 */     // GIR_Coverage, 7073,
     /* 1452680 */     GIR_EraseRootFromParent_Done,
     /* 1452681 */   // Label 20428: @1452681
     /* 1452681 */   GIM_Try, /*On fail goto*//*Label 20429*/ GIMT_Encode4(1452778), // Rule ID 7076 //
     /* 1452686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1452697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1452700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1452703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452736 */     // MIs[1] Operand 1
     /* 1452736 */     // No operand predicates
     /* 1452736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452740 */     // MIs[0] policy
     /* 1452740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452777 */     // GIR_Coverage, 7076,
     /* 1452777 */     GIR_EraseRootFromParent_Done,
     /* 1452778 */   // Label 20429: @1452778
     /* 1452778 */   GIM_Try, /*On fail goto*//*Label 20430*/ GIMT_Encode4(1452875), // Rule ID 7077 //
     /* 1452783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1452794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1452797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1452800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1452813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452833 */     // MIs[1] Operand 1
     /* 1452833 */     // No operand predicates
     /* 1452833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452837 */     // MIs[0] policy
     /* 1452837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452849 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1452852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1452871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452874 */     // GIR_Coverage, 7077,
     /* 1452874 */     GIR_EraseRootFromParent_Done,
     /* 1452875 */   // Label 20430: @1452875
     /* 1452875 */   GIM_Try, /*On fail goto*//*Label 20431*/ GIMT_Encode4(1452972), // Rule ID 7080 //
     /* 1452880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1452883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1452891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1452894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1452897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452930 */     // MIs[1] Operand 1
     /* 1452930 */     // No operand predicates
     /* 1452930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452934 */     // MIs[0] policy
     /* 1452934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452946 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1452949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1452968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452971 */     // GIR_Coverage, 7080,
     /* 1452971 */     GIR_EraseRootFromParent_Done,
     /* 1452972 */   // Label 20431: @1452972
     /* 1452972 */   GIM_Try, /*On fail goto*//*Label 20432*/ GIMT_Encode4(1453069), // Rule ID 7081 //
     /* 1452977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1452980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1452985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1452988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1452991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1452994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453027 */     // MIs[1] Operand 1
     /* 1453027 */     // No operand predicates
     /* 1453027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453031 */     // MIs[0] policy
     /* 1453031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453043 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1453046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453068 */     // GIR_Coverage, 7081,
     /* 1453068 */     GIR_EraseRootFromParent_Done,
     /* 1453069 */   // Label 20432: @1453069
     /* 1453069 */   GIM_Try, /*On fail goto*//*Label 20433*/ GIMT_Encode4(1453166), // Rule ID 7084 //
     /* 1453074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1453085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1453088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453124 */     // MIs[1] Operand 1
     /* 1453124 */     // No operand predicates
     /* 1453124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453128 */     // MIs[0] policy
     /* 1453128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453165 */     // GIR_Coverage, 7084,
     /* 1453165 */     GIR_EraseRootFromParent_Done,
     /* 1453166 */   // Label 20433: @1453166
     /* 1453166 */   GIM_Try, /*On fail goto*//*Label 20434*/ GIMT_Encode4(1453263), // Rule ID 7085 //
     /* 1453171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1453182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1453185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453221 */     // MIs[1] Operand 1
     /* 1453221 */     // No operand predicates
     /* 1453221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453225 */     // MIs[0] policy
     /* 1453225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453237 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1453240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453262 */     // GIR_Coverage, 7085,
     /* 1453262 */     GIR_EraseRootFromParent_Done,
     /* 1453263 */   // Label 20434: @1453263
     /* 1453263 */   GIM_Try, /*On fail goto*//*Label 20435*/ GIMT_Encode4(1453360), // Rule ID 7088 //
     /* 1453268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1453271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1453279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1453282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453318 */     // MIs[1] Operand 1
     /* 1453318 */     // No operand predicates
     /* 1453318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453322 */     // MIs[0] policy
     /* 1453322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453334 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453359 */     // GIR_Coverage, 7088,
     /* 1453359 */     GIR_EraseRootFromParent_Done,
     /* 1453360 */   // Label 20435: @1453360
     /* 1453360 */   GIM_Try, /*On fail goto*//*Label 20436*/ GIMT_Encode4(1453457), // Rule ID 7089 //
     /* 1453365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1453368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1453373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1453376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1453379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1453395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453415 */     // MIs[1] Operand 1
     /* 1453415 */     // No operand predicates
     /* 1453415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453419 */     // MIs[0] policy
     /* 1453419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453431 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1453434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1453453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453456 */     // GIR_Coverage, 7089,
     /* 1453456 */     GIR_EraseRootFromParent_Done,
     /* 1453457 */   // Label 20436: @1453457
     /* 1453457 */   GIM_Try, /*On fail goto*//*Label 20437*/ GIMT_Encode4(1453554), // Rule ID 7268 //
     /* 1453462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1453473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1453476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1453479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453512 */     // MIs[1] Operand 1
     /* 1453512 */     // No operand predicates
     /* 1453512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453516 */     // MIs[0] policy
     /* 1453516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453528 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1453531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453553 */     // GIR_Coverage, 7268,
     /* 1453553 */     GIR_EraseRootFromParent_Done,
     /* 1453554 */   // Label 20437: @1453554
     /* 1453554 */   GIM_Try, /*On fail goto*//*Label 20438*/ GIMT_Encode4(1453651), // Rule ID 7269 //
     /* 1453559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1453570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1453573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1453576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453609 */     // MIs[1] Operand 1
     /* 1453609 */     // No operand predicates
     /* 1453609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453613 */     // MIs[0] policy
     /* 1453613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453625 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1453628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453650 */     // GIR_Coverage, 7269,
     /* 1453650 */     GIR_EraseRootFromParent_Done,
     /* 1453651 */   // Label 20438: @1453651
     /* 1453651 */   GIM_Try, /*On fail goto*//*Label 20439*/ GIMT_Encode4(1453748), // Rule ID 7272 //
     /* 1453656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1453667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1453670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1453673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453706 */     // MIs[1] Operand 1
     /* 1453706 */     // No operand predicates
     /* 1453706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453710 */     // MIs[0] policy
     /* 1453710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453722 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1453725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453747 */     // GIR_Coverage, 7272,
     /* 1453747 */     GIR_EraseRootFromParent_Done,
     /* 1453748 */   // Label 20439: @1453748
     /* 1453748 */   GIM_Try, /*On fail goto*//*Label 20440*/ GIMT_Encode4(1453845), // Rule ID 7273 //
     /* 1453753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1453764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1453767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1453770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453803 */     // MIs[1] Operand 1
     /* 1453803 */     // No operand predicates
     /* 1453803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453807 */     // MIs[0] policy
     /* 1453807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453819 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1453822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453844 */     // GIR_Coverage, 7273,
     /* 1453844 */     GIR_EraseRootFromParent_Done,
     /* 1453845 */   // Label 20440: @1453845
     /* 1453845 */   GIM_Try, /*On fail goto*//*Label 20441*/ GIMT_Encode4(1453942), // Rule ID 7276 //
     /* 1453850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1453861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1453864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1453867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453900 */     // MIs[1] Operand 1
     /* 1453900 */     // No operand predicates
     /* 1453900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453904 */     // MIs[0] policy
     /* 1453904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453916 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1453919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1453938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453941 */     // GIR_Coverage, 7276,
     /* 1453941 */     GIR_EraseRootFromParent_Done,
     /* 1453942 */   // Label 20441: @1453942
     /* 1453942 */   GIM_Try, /*On fail goto*//*Label 20442*/ GIMT_Encode4(1454039), // Rule ID 7277 //
     /* 1453947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1453955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1453958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1453961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1453964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453997 */     // MIs[1] Operand 1
     /* 1453997 */     // No operand predicates
     /* 1453997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454001 */     // MIs[0] policy
     /* 1454001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454013 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454038 */     // GIR_Coverage, 7277,
     /* 1454038 */     GIR_EraseRootFromParent_Done,
     /* 1454039 */   // Label 20442: @1454039
     /* 1454039 */   GIM_Try, /*On fail goto*//*Label 20443*/ GIMT_Encode4(1454136), // Rule ID 7280 //
     /* 1454044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454094 */     // MIs[1] Operand 1
     /* 1454094 */     // No operand predicates
     /* 1454094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454098 */     // MIs[0] policy
     /* 1454098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454135 */     // GIR_Coverage, 7280,
     /* 1454135 */     GIR_EraseRootFromParent_Done,
     /* 1454136 */   // Label 20443: @1454136
     /* 1454136 */   GIM_Try, /*On fail goto*//*Label 20444*/ GIMT_Encode4(1454233), // Rule ID 7281 //
     /* 1454141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1454152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1454155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454191 */     // MIs[1] Operand 1
     /* 1454191 */     // No operand predicates
     /* 1454191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454195 */     // MIs[0] policy
     /* 1454195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454207 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1454210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454232 */     // GIR_Coverage, 7281,
     /* 1454232 */     GIR_EraseRootFromParent_Done,
     /* 1454233 */   // Label 20444: @1454233
     /* 1454233 */   GIM_Try, /*On fail goto*//*Label 20445*/ GIMT_Encode4(1454330), // Rule ID 7284 //
     /* 1454238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454288 */     // MIs[1] Operand 1
     /* 1454288 */     // No operand predicates
     /* 1454288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454292 */     // MIs[0] policy
     /* 1454292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454304 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454329 */     // GIR_Coverage, 7284,
     /* 1454329 */     GIR_EraseRootFromParent_Done,
     /* 1454330 */   // Label 20445: @1454330
     /* 1454330 */   GIM_Try, /*On fail goto*//*Label 20446*/ GIMT_Encode4(1454427), // Rule ID 7285 //
     /* 1454335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1454346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1454349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454385 */     // MIs[1] Operand 1
     /* 1454385 */     // No operand predicates
     /* 1454385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454389 */     // MIs[0] policy
     /* 1454389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454401 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454426 */     // GIR_Coverage, 7285,
     /* 1454426 */     GIR_EraseRootFromParent_Done,
     /* 1454427 */   // Label 20446: @1454427
     /* 1454427 */   GIM_Try, /*On fail goto*//*Label 20447*/ GIMT_Encode4(1454524), // Rule ID 7288 //
     /* 1454432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454482 */     // MIs[1] Operand 1
     /* 1454482 */     // No operand predicates
     /* 1454482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454486 */     // MIs[0] policy
     /* 1454486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454523 */     // GIR_Coverage, 7288,
     /* 1454523 */     GIR_EraseRootFromParent_Done,
     /* 1454524 */   // Label 20447: @1454524
     /* 1454524 */   GIM_Try, /*On fail goto*//*Label 20448*/ GIMT_Encode4(1454621), // Rule ID 7289 //
     /* 1454529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1454540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1454543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1454546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454579 */     // MIs[1] Operand 1
     /* 1454579 */     // No operand predicates
     /* 1454579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454583 */     // MIs[0] policy
     /* 1454583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1454598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454620 */     // GIR_Coverage, 7289,
     /* 1454620 */     GIR_EraseRootFromParent_Done,
     /* 1454621 */   // Label 20448: @1454621
     /* 1454621 */   GIM_Try, /*On fail goto*//*Label 20449*/ GIMT_Encode4(1454718), // Rule ID 7292 //
     /* 1454626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1454637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1454640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1454643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454676 */     // MIs[1] Operand 1
     /* 1454676 */     // No operand predicates
     /* 1454676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454680 */     // MIs[0] policy
     /* 1454680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1454695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454717 */     // GIR_Coverage, 7292,
     /* 1454717 */     GIR_EraseRootFromParent_Done,
     /* 1454718 */   // Label 20449: @1454718
     /* 1454718 */   GIM_Try, /*On fail goto*//*Label 20450*/ GIMT_Encode4(1454815), // Rule ID 7293 //
     /* 1454723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1454734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1454737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1454740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454773 */     // MIs[1] Operand 1
     /* 1454773 */     // No operand predicates
     /* 1454773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454777 */     // MIs[0] policy
     /* 1454777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454789 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1454792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454814 */     // GIR_Coverage, 7293,
     /* 1454814 */     GIR_EraseRootFromParent_Done,
     /* 1454815 */   // Label 20450: @1454815
     /* 1454815 */   GIM_Try, /*On fail goto*//*Label 20451*/ GIMT_Encode4(1454912), // Rule ID 7296 //
     /* 1454820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1454831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1454834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454870 */     // MIs[1] Operand 1
     /* 1454870 */     // No operand predicates
     /* 1454870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454874 */     // MIs[0] policy
     /* 1454874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1454889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1454908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454911 */     // GIR_Coverage, 7296,
     /* 1454911 */     GIR_EraseRootFromParent_Done,
     /* 1454912 */   // Label 20451: @1454912
     /* 1454912 */   GIM_Try, /*On fail goto*//*Label 20452*/ GIMT_Encode4(1455009), // Rule ID 7297 //
     /* 1454917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1454925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1454928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1454931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454967 */     // MIs[1] Operand 1
     /* 1454967 */     // No operand predicates
     /* 1454967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454971 */     // MIs[0] policy
     /* 1454971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454983 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1454986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455008 */     // GIR_Coverage, 7297,
     /* 1455008 */     GIR_EraseRootFromParent_Done,
     /* 1455009 */   // Label 20452: @1455009
     /* 1455009 */   GIM_Try, /*On fail goto*//*Label 20453*/ GIMT_Encode4(1455106), // Rule ID 7300 //
     /* 1455014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455064 */     // MIs[1] Operand 1
     /* 1455064 */     // No operand predicates
     /* 1455064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455068 */     // MIs[0] policy
     /* 1455068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455105 */     // GIR_Coverage, 7300,
     /* 1455105 */     GIR_EraseRootFromParent_Done,
     /* 1455106 */   // Label 20453: @1455106
     /* 1455106 */   GIM_Try, /*On fail goto*//*Label 20454*/ GIMT_Encode4(1455203), // Rule ID 7301 //
     /* 1455111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1455122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1455125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455161 */     // MIs[1] Operand 1
     /* 1455161 */     // No operand predicates
     /* 1455161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455165 */     // MIs[0] policy
     /* 1455165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455177 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1455199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455202 */     // GIR_Coverage, 7301,
     /* 1455202 */     GIR_EraseRootFromParent_Done,
     /* 1455203 */   // Label 20454: @1455203
     /* 1455203 */   GIM_Try, /*On fail goto*//*Label 20455*/ GIMT_Encode4(1455300), // Rule ID 7304 //
     /* 1455208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1455211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455258 */     // MIs[1] Operand 1
     /* 1455258 */     // No operand predicates
     /* 1455258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455262 */     // MIs[0] policy
     /* 1455262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455299 */     // GIR_Coverage, 7304,
     /* 1455299 */     GIR_EraseRootFromParent_Done,
     /* 1455300 */   // Label 20455: @1455300
     /* 1455300 */   GIM_Try, /*On fail goto*//*Label 20456*/ GIMT_Encode4(1455397), // Rule ID 7305 //
     /* 1455305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1455308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1455316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1455319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1455322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455355 */     // MIs[1] Operand 1
     /* 1455355 */     // No operand predicates
     /* 1455355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455359 */     // MIs[0] policy
     /* 1455359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455371 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1455374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1455393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455396 */     // GIR_Coverage, 7305,
     /* 1455396 */     GIR_EraseRootFromParent_Done,
     /* 1455397 */   // Label 20456: @1455397
     /* 1455397 */   GIM_Try, /*On fail goto*//*Label 20457*/ GIMT_Encode4(1455494), // Rule ID 7308 //
     /* 1455402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1455413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1455416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1455419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455452 */     // MIs[1] Operand 1
     /* 1455452 */     // No operand predicates
     /* 1455452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455456 */     // MIs[0] policy
     /* 1455456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455468 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1455471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455493 */     // GIR_Coverage, 7308,
     /* 1455493 */     GIR_EraseRootFromParent_Done,
     /* 1455494 */   // Label 20457: @1455494
     /* 1455494 */   GIM_Try, /*On fail goto*//*Label 20458*/ GIMT_Encode4(1455591), // Rule ID 7309 //
     /* 1455499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1455510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1455513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1455516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1455522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455549 */     // MIs[1] Operand 1
     /* 1455549 */     // No operand predicates
     /* 1455549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455553 */     // MIs[0] policy
     /* 1455553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455565 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1455568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455590 */     // GIR_Coverage, 7309,
     /* 1455590 */     GIR_EraseRootFromParent_Done,
     /* 1455591 */   // Label 20458: @1455591
     /* 1455591 */   GIM_Try, /*On fail goto*//*Label 20459*/ GIMT_Encode4(1455688), // Rule ID 7312 //
     /* 1455596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1455607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1455610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1455613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1455619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455646 */     // MIs[1] Operand 1
     /* 1455646 */     // No operand predicates
     /* 1455646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455650 */     // MIs[0] policy
     /* 1455650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455662 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1455665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455687 */     // GIR_Coverage, 7312,
     /* 1455687 */     GIR_EraseRootFromParent_Done,
     /* 1455688 */   // Label 20459: @1455688
     /* 1455688 */   GIM_Try, /*On fail goto*//*Label 20460*/ GIMT_Encode4(1455785), // Rule ID 7313 //
     /* 1455693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1455704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1455707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1455710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1455716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455743 */     // MIs[1] Operand 1
     /* 1455743 */     // No operand predicates
     /* 1455743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455747 */     // MIs[0] policy
     /* 1455747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455759 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1455762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455784 */     // GIR_Coverage, 7313,
     /* 1455784 */     GIR_EraseRootFromParent_Done,
     /* 1455785 */   // Label 20460: @1455785
     /* 1455785 */   GIM_Try, /*On fail goto*//*Label 20461*/ GIMT_Encode4(1455882), // Rule ID 7316 //
     /* 1455790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1455801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1455804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1455807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1455813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455840 */     // MIs[1] Operand 1
     /* 1455840 */     // No operand predicates
     /* 1455840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455844 */     // MIs[0] policy
     /* 1455844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455856 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1455859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455881 */     // GIR_Coverage, 7316,
     /* 1455881 */     GIR_EraseRootFromParent_Done,
     /* 1455882 */   // Label 20461: @1455882
     /* 1455882 */   GIM_Try, /*On fail goto*//*Label 20462*/ GIMT_Encode4(1455979), // Rule ID 7317 //
     /* 1455887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1455898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1455901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1455904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1455910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1455917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455937 */     // MIs[1] Operand 1
     /* 1455937 */     // No operand predicates
     /* 1455937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455941 */     // MIs[0] policy
     /* 1455941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455953 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1455956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455978 */     // GIR_Coverage, 7317,
     /* 1455978 */     GIR_EraseRootFromParent_Done,
     /* 1455979 */   // Label 20462: @1455979
     /* 1455979 */   GIM_Try, /*On fail goto*//*Label 20463*/ GIMT_Encode4(1456076), // Rule ID 7320 //
     /* 1455984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1455992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1455995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1455998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456034 */     // MIs[1] Operand 1
     /* 1456034 */     // No operand predicates
     /* 1456034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456038 */     // MIs[0] policy
     /* 1456038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456075 */     // GIR_Coverage, 7320,
     /* 1456075 */     GIR_EraseRootFromParent_Done,
     /* 1456076 */   // Label 20463: @1456076
     /* 1456076 */   GIM_Try, /*On fail goto*//*Label 20464*/ GIMT_Encode4(1456173), // Rule ID 7321 //
     /* 1456081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1456092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1456095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1456098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456131 */     // MIs[1] Operand 1
     /* 1456131 */     // No operand predicates
     /* 1456131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456135 */     // MIs[0] policy
     /* 1456135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456147 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456172 */     // GIR_Coverage, 7321,
     /* 1456172 */     GIR_EraseRootFromParent_Done,
     /* 1456173 */   // Label 20464: @1456173
     /* 1456173 */   GIM_Try, /*On fail goto*//*Label 20465*/ GIMT_Encode4(1456270), // Rule ID 7324 //
     /* 1456178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456228 */     // MIs[1] Operand 1
     /* 1456228 */     // No operand predicates
     /* 1456228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456232 */     // MIs[0] policy
     /* 1456232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456269 */     // GIR_Coverage, 7324,
     /* 1456269 */     GIR_EraseRootFromParent_Done,
     /* 1456270 */   // Label 20465: @1456270
     /* 1456270 */   GIM_Try, /*On fail goto*//*Label 20466*/ GIMT_Encode4(1456367), // Rule ID 7325 //
     /* 1456275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1456292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456325 */     // MIs[1] Operand 1
     /* 1456325 */     // No operand predicates
     /* 1456325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456329 */     // MIs[0] policy
     /* 1456329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456341 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456366 */     // GIR_Coverage, 7325,
     /* 1456366 */     GIR_EraseRootFromParent_Done,
     /* 1456367 */   // Label 20466: @1456367
     /* 1456367 */   GIM_Try, /*On fail goto*//*Label 20467*/ GIMT_Encode4(1456464), // Rule ID 7328 //
     /* 1456372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1456383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1456386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456422 */     // MIs[1] Operand 1
     /* 1456422 */     // No operand predicates
     /* 1456422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456426 */     // MIs[0] policy
     /* 1456426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456438 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456463 */     // GIR_Coverage, 7328,
     /* 1456463 */     GIR_EraseRootFromParent_Done,
     /* 1456464 */   // Label 20467: @1456464
     /* 1456464 */   GIM_Try, /*On fail goto*//*Label 20468*/ GIMT_Encode4(1456561), // Rule ID 7329 //
     /* 1456469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1456480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1456483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1456486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1456492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456519 */     // MIs[1] Operand 1
     /* 1456519 */     // No operand predicates
     /* 1456519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456523 */     // MIs[0] policy
     /* 1456523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456535 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1456538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456560 */     // GIR_Coverage, 7329,
     /* 1456560 */     GIR_EraseRootFromParent_Done,
     /* 1456561 */   // Label 20468: @1456561
     /* 1456561 */   GIM_Try, /*On fail goto*//*Label 20469*/ GIMT_Encode4(1456658), // Rule ID 7332 //
     /* 1456566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1456577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1456580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1456583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456616 */     // MIs[1] Operand 1
     /* 1456616 */     // No operand predicates
     /* 1456616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456620 */     // MIs[0] policy
     /* 1456620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456657 */     // GIR_Coverage, 7332,
     /* 1456657 */     GIR_EraseRootFromParent_Done,
     /* 1456658 */   // Label 20469: @1456658
     /* 1456658 */   GIM_Try, /*On fail goto*//*Label 20470*/ GIMT_Encode4(1456755), // Rule ID 7333 //
     /* 1456663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1456674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1456677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1456680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456713 */     // MIs[1] Operand 1
     /* 1456713 */     // No operand predicates
     /* 1456713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456717 */     // MIs[0] policy
     /* 1456717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456729 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1456732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456754 */     // GIR_Coverage, 7333,
     /* 1456754 */     GIR_EraseRootFromParent_Done,
     /* 1456755 */   // Label 20470: @1456755
     /* 1456755 */   GIM_Try, /*On fail goto*//*Label 20471*/ GIMT_Encode4(1456852), // Rule ID 7336 //
     /* 1456760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1456777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456810 */     // MIs[1] Operand 1
     /* 1456810 */     // No operand predicates
     /* 1456810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456814 */     // MIs[0] policy
     /* 1456814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456826 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456851 */     // GIR_Coverage, 7336,
     /* 1456851 */     GIR_EraseRootFromParent_Done,
     /* 1456852 */   // Label 20471: @1456852
     /* 1456852 */   GIM_Try, /*On fail goto*//*Label 20472*/ GIMT_Encode4(1456949), // Rule ID 7337 //
     /* 1456857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1456874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456907 */     // MIs[1] Operand 1
     /* 1456907 */     // No operand predicates
     /* 1456907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456911 */     // MIs[0] policy
     /* 1456911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456923 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1456926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456948 */     // GIR_Coverage, 7337,
     /* 1456948 */     GIR_EraseRootFromParent_Done,
     /* 1456949 */   // Label 20472: @1456949
     /* 1456949 */   GIM_Try, /*On fail goto*//*Label 20473*/ GIMT_Encode4(1457046), // Rule ID 7340 //
     /* 1456954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1456962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1456965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1456968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1456971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1456984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457004 */     // MIs[1] Operand 1
     /* 1457004 */     // No operand predicates
     /* 1457004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457008 */     // MIs[0] policy
     /* 1457008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457045 */     // GIR_Coverage, 7340,
     /* 1457045 */     GIR_EraseRootFromParent_Done,
     /* 1457046 */   // Label 20473: @1457046
     /* 1457046 */   GIM_Try, /*On fail goto*//*Label 20474*/ GIMT_Encode4(1457143), // Rule ID 7341 //
     /* 1457051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1457062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1457065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1457068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1457074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457101 */     // MIs[1] Operand 1
     /* 1457101 */     // No operand predicates
     /* 1457101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457105 */     // MIs[0] policy
     /* 1457105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457117 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1457139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457142 */     // GIR_Coverage, 7341,
     /* 1457142 */     GIR_EraseRootFromParent_Done,
     /* 1457143 */   // Label 20474: @1457143
     /* 1457143 */   GIM_Try, /*On fail goto*//*Label 20475*/ GIMT_Encode4(1457240), // Rule ID 7344 //
     /* 1457148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1457159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1457162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457198 */     // MIs[1] Operand 1
     /* 1457198 */     // No operand predicates
     /* 1457198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457202 */     // MIs[0] policy
     /* 1457202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457239 */     // GIR_Coverage, 7344,
     /* 1457239 */     GIR_EraseRootFromParent_Done,
     /* 1457240 */   // Label 20475: @1457240
     /* 1457240 */   GIM_Try, /*On fail goto*//*Label 20476*/ GIMT_Encode4(1457337), // Rule ID 7345 //
     /* 1457245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1457256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1457259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1457262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1457275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1457283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457295 */     // MIs[1] Operand 1
     /* 1457295 */     // No operand predicates
     /* 1457295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457299 */     // MIs[0] policy
     /* 1457299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1457314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457336 */     // GIR_Coverage, 7345,
     /* 1457336 */     GIR_EraseRootFromParent_Done,
     /* 1457337 */   // Label 20476: @1457337
     /* 1457337 */   GIM_Try, /*On fail goto*//*Label 20477*/ GIMT_Encode4(1457434), // Rule ID 7348 //
     /* 1457342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1457353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1457356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1457359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457392 */     // MIs[1] Operand 1
     /* 1457392 */     // No operand predicates
     /* 1457392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457396 */     // MIs[0] policy
     /* 1457396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457408 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457433 */     // GIR_Coverage, 7348,
     /* 1457433 */     GIR_EraseRootFromParent_Done,
     /* 1457434 */   // Label 20477: @1457434
     /* 1457434 */   GIM_Try, /*On fail goto*//*Label 20478*/ GIMT_Encode4(1457531), // Rule ID 7349 //
     /* 1457439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1457450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1457453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1457456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1457469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1457477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457489 */     // MIs[1] Operand 1
     /* 1457489 */     // No operand predicates
     /* 1457489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457493 */     // MIs[0] policy
     /* 1457493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457505 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1457508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457530 */     // GIR_Coverage, 7349,
     /* 1457530 */     GIR_EraseRootFromParent_Done,
     /* 1457531 */   // Label 20478: @1457531
     /* 1457531 */   GIM_Try, /*On fail goto*//*Label 20479*/ GIMT_Encode4(1457628), // Rule ID 7352 //
     /* 1457536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1457539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1457547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1457550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1457553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457586 */     // MIs[1] Operand 1
     /* 1457586 */     // No operand predicates
     /* 1457586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457590 */     // MIs[0] policy
     /* 1457590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457627 */     // GIR_Coverage, 7352,
     /* 1457627 */     GIR_EraseRootFromParent_Done,
     /* 1457628 */   // Label 20479: @1457628
     /* 1457628 */   GIM_Try, /*On fail goto*//*Label 20480*/ GIMT_Encode4(1457725), // Rule ID 7353 //
     /* 1457633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1457636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1457641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1457644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1457647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1457650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1457656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1457663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1457671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457683 */     // MIs[1] Operand 1
     /* 1457683 */     // No operand predicates
     /* 1457683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457687 */     // MIs[0] policy
     /* 1457687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457699 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1457702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1457721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457724 */     // GIR_Coverage, 7353,
     /* 1457724 */     GIR_EraseRootFromParent_Done,
     /* 1457725 */   // Label 20480: @1457725
     /* 1457725 */   GIM_Try, /*On fail goto*//*Label 20481*/ GIMT_Encode4(1457822), // Rule ID 7564 //
     /* 1457730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1457741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1457744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1457747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457780 */     // MIs[1] Operand 1
     /* 1457780 */     // No operand predicates
     /* 1457780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457784 */     // MIs[0] policy
     /* 1457784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457796 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1457799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457821 */     // GIR_Coverage, 7564,
     /* 1457821 */     GIR_EraseRootFromParent_Done,
     /* 1457822 */   // Label 20481: @1457822
     /* 1457822 */   GIM_Try, /*On fail goto*//*Label 20482*/ GIMT_Encode4(1457919), // Rule ID 7565 //
     /* 1457827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1457838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1457841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1457844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457877 */     // MIs[1] Operand 1
     /* 1457877 */     // No operand predicates
     /* 1457877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457881 */     // MIs[0] policy
     /* 1457881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457893 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1457896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457918 */     // GIR_Coverage, 7565,
     /* 1457918 */     GIR_EraseRootFromParent_Done,
     /* 1457919 */   // Label 20482: @1457919
     /* 1457919 */   GIM_Try, /*On fail goto*//*Label 20483*/ GIMT_Encode4(1458016), // Rule ID 7568 //
     /* 1457924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1457932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1457935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1457938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1457941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1457974 */     // MIs[1] Operand 1
     /* 1457974 */     // No operand predicates
     /* 1457974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457978 */     // MIs[0] policy
     /* 1457978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457990 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1457993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458015 */     // GIR_Coverage, 7568,
     /* 1458015 */     GIR_EraseRootFromParent_Done,
     /* 1458016 */   // Label 20483: @1458016
     /* 1458016 */   GIM_Try, /*On fail goto*//*Label 20484*/ GIMT_Encode4(1458113), // Rule ID 7569 //
     /* 1458021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1458032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1458035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1458038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458071 */     // MIs[1] Operand 1
     /* 1458071 */     // No operand predicates
     /* 1458071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458075 */     // MIs[0] policy
     /* 1458075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458087 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1458090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458112 */     // GIR_Coverage, 7569,
     /* 1458112 */     GIR_EraseRootFromParent_Done,
     /* 1458113 */   // Label 20484: @1458113
     /* 1458113 */   GIM_Try, /*On fail goto*//*Label 20485*/ GIMT_Encode4(1458210), // Rule ID 7572 //
     /* 1458118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458168 */     // MIs[1] Operand 1
     /* 1458168 */     // No operand predicates
     /* 1458168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458172 */     // MIs[0] policy
     /* 1458172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458184 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1458187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458209 */     // GIR_Coverage, 7572,
     /* 1458209 */     GIR_EraseRootFromParent_Done,
     /* 1458210 */   // Label 20485: @1458210
     /* 1458210 */   GIM_Try, /*On fail goto*//*Label 20486*/ GIMT_Encode4(1458307), // Rule ID 7573 //
     /* 1458215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1458226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1458229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458265 */     // MIs[1] Operand 1
     /* 1458265 */     // No operand predicates
     /* 1458265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458269 */     // MIs[0] policy
     /* 1458269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458281 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1458284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458306 */     // GIR_Coverage, 7573,
     /* 1458306 */     GIR_EraseRootFromParent_Done,
     /* 1458307 */   // Label 20486: @1458307
     /* 1458307 */   GIM_Try, /*On fail goto*//*Label 20487*/ GIMT_Encode4(1458404), // Rule ID 7576 //
     /* 1458312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1458329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458362 */     // MIs[1] Operand 1
     /* 1458362 */     // No operand predicates
     /* 1458362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458366 */     // MIs[0] policy
     /* 1458366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458378 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1458381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458403 */     // GIR_Coverage, 7576,
     /* 1458403 */     GIR_EraseRootFromParent_Done,
     /* 1458404 */   // Label 20487: @1458404
     /* 1458404 */   GIM_Try, /*On fail goto*//*Label 20488*/ GIMT_Encode4(1458501), // Rule ID 7577 //
     /* 1458409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1458426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458459 */     // MIs[1] Operand 1
     /* 1458459 */     // No operand predicates
     /* 1458459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458463 */     // MIs[0] policy
     /* 1458463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458475 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1458478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458500 */     // GIR_Coverage, 7577,
     /* 1458500 */     GIR_EraseRootFromParent_Done,
     /* 1458501 */   // Label 20488: @1458501
     /* 1458501 */   GIM_Try, /*On fail goto*//*Label 20489*/ GIMT_Encode4(1458598), // Rule ID 7580 //
     /* 1458506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1458517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1458520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1458523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1458529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458556 */     // MIs[1] Operand 1
     /* 1458556 */     // No operand predicates
     /* 1458556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458560 */     // MIs[0] policy
     /* 1458560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458572 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1458575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458597 */     // GIR_Coverage, 7580,
     /* 1458597 */     GIR_EraseRootFromParent_Done,
     /* 1458598 */   // Label 20489: @1458598
     /* 1458598 */   GIM_Try, /*On fail goto*//*Label 20490*/ GIMT_Encode4(1458695), // Rule ID 7581 //
     /* 1458603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1458614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1458617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1458620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1458626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458653 */     // MIs[1] Operand 1
     /* 1458653 */     // No operand predicates
     /* 1458653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458657 */     // MIs[0] policy
     /* 1458657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458669 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1458672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458694 */     // GIR_Coverage, 7581,
     /* 1458694 */     GIR_EraseRootFromParent_Done,
     /* 1458695 */   // Label 20490: @1458695
     /* 1458695 */   GIM_Try, /*On fail goto*//*Label 20491*/ GIMT_Encode4(1458792), // Rule ID 7584 //
     /* 1458700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1458711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1458714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1458717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1458723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458750 */     // MIs[1] Operand 1
     /* 1458750 */     // No operand predicates
     /* 1458750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458754 */     // MIs[0] policy
     /* 1458754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458766 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1458769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458791 */     // GIR_Coverage, 7584,
     /* 1458791 */     GIR_EraseRootFromParent_Done,
     /* 1458792 */   // Label 20491: @1458792
     /* 1458792 */   GIM_Try, /*On fail goto*//*Label 20492*/ GIMT_Encode4(1458889), // Rule ID 7585 //
     /* 1458797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1458808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1458811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1458814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1458820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1458827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1458831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1458835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458847 */     // MIs[1] Operand 1
     /* 1458847 */     // No operand predicates
     /* 1458847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458851 */     // MIs[0] policy
     /* 1458851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458863 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1458866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458888 */     // GIR_Coverage, 7585,
     /* 1458888 */     GIR_EraseRootFromParent_Done,
     /* 1458889 */   // Label 20492: @1458889
     /* 1458889 */   GIM_Try, /*On fail goto*//*Label 20493*/ GIMT_Encode4(1458986), // Rule ID 7588 //
     /* 1458894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1458905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1458908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1458911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1458944 */     // MIs[1] Operand 1
     /* 1458944 */     // No operand predicates
     /* 1458944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458948 */     // MIs[0] policy
     /* 1458948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458960 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1458963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458985 */     // GIR_Coverage, 7588,
     /* 1458985 */     GIR_EraseRootFromParent_Done,
     /* 1458986 */   // Label 20493: @1458986
     /* 1458986 */   GIM_Try, /*On fail goto*//*Label 20494*/ GIMT_Encode4(1459083), // Rule ID 7589 //
     /* 1458991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1458999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1459002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1459005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1459008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459041 */     // MIs[1] Operand 1
     /* 1459041 */     // No operand predicates
     /* 1459041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459045 */     // MIs[0] policy
     /* 1459045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459057 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1459060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459082 */     // GIR_Coverage, 7589,
     /* 1459082 */     GIR_EraseRootFromParent_Done,
     /* 1459083 */   // Label 20494: @1459083
     /* 1459083 */   GIM_Try, /*On fail goto*//*Label 20495*/ GIMT_Encode4(1459180), // Rule ID 7592 //
     /* 1459088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459138 */     // MIs[1] Operand 1
     /* 1459138 */     // No operand predicates
     /* 1459138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459142 */     // MIs[0] policy
     /* 1459142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459179 */     // GIR_Coverage, 7592,
     /* 1459179 */     GIR_EraseRootFromParent_Done,
     /* 1459180 */   // Label 20495: @1459180
     /* 1459180 */   GIM_Try, /*On fail goto*//*Label 20496*/ GIMT_Encode4(1459277), // Rule ID 7593 //
     /* 1459185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1459196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1459199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1459202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1459208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459235 */     // MIs[1] Operand 1
     /* 1459235 */     // No operand predicates
     /* 1459235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459239 */     // MIs[0] policy
     /* 1459239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459251 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459276 */     // GIR_Coverage, 7593,
     /* 1459276 */     GIR_EraseRootFromParent_Done,
     /* 1459277 */   // Label 20496: @1459277
     /* 1459277 */   GIM_Try, /*On fail goto*//*Label 20497*/ GIMT_Encode4(1459374), // Rule ID 7596 //
     /* 1459282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1459299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1459305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459332 */     // MIs[1] Operand 1
     /* 1459332 */     // No operand predicates
     /* 1459332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459336 */     // MIs[0] policy
     /* 1459336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459348 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1459351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459373 */     // GIR_Coverage, 7596,
     /* 1459373 */     GIR_EraseRootFromParent_Done,
     /* 1459374 */   // Label 20497: @1459374
     /* 1459374 */   GIM_Try, /*On fail goto*//*Label 20498*/ GIMT_Encode4(1459471), // Rule ID 7597 //
     /* 1459379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1459390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1459393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1459396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1459402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459429 */     // MIs[1] Operand 1
     /* 1459429 */     // No operand predicates
     /* 1459429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459433 */     // MIs[0] policy
     /* 1459433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459445 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1459448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459470 */     // GIR_Coverage, 7597,
     /* 1459470 */     GIR_EraseRootFromParent_Done,
     /* 1459471 */   // Label 20498: @1459471
     /* 1459471 */   GIM_Try, /*On fail goto*//*Label 20499*/ GIMT_Encode4(1459568), // Rule ID 7600 //
     /* 1459476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1459493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459526 */     // MIs[1] Operand 1
     /* 1459526 */     // No operand predicates
     /* 1459526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459530 */     // MIs[0] policy
     /* 1459530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459542 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1459545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459567 */     // GIR_Coverage, 7600,
     /* 1459567 */     GIR_EraseRootFromParent_Done,
     /* 1459568 */   // Label 20499: @1459568
     /* 1459568 */   GIM_Try, /*On fail goto*//*Label 20500*/ GIMT_Encode4(1459665), // Rule ID 7601 //
     /* 1459573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1459590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459623 */     // MIs[1] Operand 1
     /* 1459623 */     // No operand predicates
     /* 1459623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459627 */     // MIs[0] policy
     /* 1459627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459639 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1459642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459664 */     // GIR_Coverage, 7601,
     /* 1459664 */     GIR_EraseRootFromParent_Done,
     /* 1459665 */   // Label 20500: @1459665
     /* 1459665 */   GIM_Try, /*On fail goto*//*Label 20501*/ GIMT_Encode4(1459762), // Rule ID 7604 //
     /* 1459670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1459681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1459684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1459687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459720 */     // MIs[1] Operand 1
     /* 1459720 */     // No operand predicates
     /* 1459720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459724 */     // MIs[0] policy
     /* 1459724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1459739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459761 */     // GIR_Coverage, 7604,
     /* 1459761 */     GIR_EraseRootFromParent_Done,
     /* 1459762 */   // Label 20501: @1459762
     /* 1459762 */   GIM_Try, /*On fail goto*//*Label 20502*/ GIMT_Encode4(1459859), // Rule ID 7605 //
     /* 1459767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1459778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1459781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1459784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459817 */     // MIs[1] Operand 1
     /* 1459817 */     // No operand predicates
     /* 1459817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459821 */     // MIs[0] policy
     /* 1459821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459833 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1459836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459858 */     // GIR_Coverage, 7605,
     /* 1459858 */     GIR_EraseRootFromParent_Done,
     /* 1459859 */   // Label 20502: @1459859
     /* 1459859 */   GIM_Try, /*On fail goto*//*Label 20503*/ GIMT_Encode4(1459956), // Rule ID 7608 //
     /* 1459864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1459867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1459875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1459878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1459881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1459914 */     // MIs[1] Operand 1
     /* 1459914 */     // No operand predicates
     /* 1459914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459918 */     // MIs[0] policy
     /* 1459918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1459933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1459952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459955 */     // GIR_Coverage, 7608,
     /* 1459955 */     GIR_EraseRootFromParent_Done,
     /* 1459956 */   // Label 20503: @1459956
     /* 1459956 */   GIM_Try, /*On fail goto*//*Label 20504*/ GIMT_Encode4(1460053), // Rule ID 7609 //
     /* 1459961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1459964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1459969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1459972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1459975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1459978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1459984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1459991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1459999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460011 */     // MIs[1] Operand 1
     /* 1460011 */     // No operand predicates
     /* 1460011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460015 */     // MIs[0] policy
     /* 1460015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460027 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1460030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460052 */     // GIR_Coverage, 7609,
     /* 1460052 */     GIR_EraseRootFromParent_Done,
     /* 1460053 */   // Label 20504: @1460053
     /* 1460053 */   GIM_Try, /*On fail goto*//*Label 20505*/ GIMT_Encode4(1460150), // Rule ID 7612 //
     /* 1460058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460108 */     // MIs[1] Operand 1
     /* 1460108 */     // No operand predicates
     /* 1460108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460112 */     // MIs[0] policy
     /* 1460112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1460127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460149 */     // GIR_Coverage, 7612,
     /* 1460149 */     GIR_EraseRootFromParent_Done,
     /* 1460150 */   // Label 20505: @1460150
     /* 1460150 */   GIM_Try, /*On fail goto*//*Label 20506*/ GIMT_Encode4(1460247), // Rule ID 7613 //
     /* 1460155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1460166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1460169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460205 */     // MIs[1] Operand 1
     /* 1460205 */     // No operand predicates
     /* 1460205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460209 */     // MIs[0] policy
     /* 1460209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460221 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1460224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460246 */     // GIR_Coverage, 7613,
     /* 1460246 */     GIR_EraseRootFromParent_Done,
     /* 1460247 */   // Label 20506: @1460247
     /* 1460247 */   GIM_Try, /*On fail goto*//*Label 20507*/ GIMT_Encode4(1460344), // Rule ID 7616 //
     /* 1460252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460302 */     // MIs[1] Operand 1
     /* 1460302 */     // No operand predicates
     /* 1460302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460306 */     // MIs[0] policy
     /* 1460306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460343 */     // GIR_Coverage, 7616,
     /* 1460343 */     GIR_EraseRootFromParent_Done,
     /* 1460344 */   // Label 20507: @1460344
     /* 1460344 */   GIM_Try, /*On fail goto*//*Label 20508*/ GIMT_Encode4(1460441), // Rule ID 7617 //
     /* 1460349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460399 */     // MIs[1] Operand 1
     /* 1460399 */     // No operand predicates
     /* 1460399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460403 */     // MIs[0] policy
     /* 1460403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460415 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1460418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460440 */     // GIR_Coverage, 7617,
     /* 1460440 */     GIR_EraseRootFromParent_Done,
     /* 1460441 */   // Label 20508: @1460441
     /* 1460441 */   GIM_Try, /*On fail goto*//*Label 20509*/ GIMT_Encode4(1460538), // Rule ID 7620 //
     /* 1460446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1460449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1460463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460496 */     // MIs[1] Operand 1
     /* 1460496 */     // No operand predicates
     /* 1460496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460500 */     // MIs[0] policy
     /* 1460500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460512 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460537 */     // GIR_Coverage, 7620,
     /* 1460537 */     GIR_EraseRootFromParent_Done,
     /* 1460538 */   // Label 20509: @1460538
     /* 1460538 */   GIM_Try, /*On fail goto*//*Label 20510*/ GIMT_Encode4(1460635), // Rule ID 7621 //
     /* 1460543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1460546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1460551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1460560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460593 */     // MIs[1] Operand 1
     /* 1460593 */     // No operand predicates
     /* 1460593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460597 */     // MIs[0] policy
     /* 1460597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1460612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460634 */     // GIR_Coverage, 7621,
     /* 1460634 */     GIR_EraseRootFromParent_Done,
     /* 1460635 */   // Label 20510: @1460635
     /* 1460635 */   GIM_Try, /*On fail goto*//*Label 20511*/ GIMT_Encode4(1460732), // Rule ID 7744 //
     /* 1460640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1460651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1460654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1460657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460690 */     // MIs[1] Operand 1
     /* 1460690 */     // No operand predicates
     /* 1460690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460694 */     // MIs[0] policy
     /* 1460694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1460709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1460728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460731 */     // GIR_Coverage, 7744,
     /* 1460731 */     GIR_EraseRootFromParent_Done,
     /* 1460732 */   // Label 20511: @1460732
     /* 1460732 */   GIM_Try, /*On fail goto*//*Label 20512*/ GIMT_Encode4(1460829), // Rule ID 7745 //
     /* 1460737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1460748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1460751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1460754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1460760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460787 */     // MIs[1] Operand 1
     /* 1460787 */     // No operand predicates
     /* 1460787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460791 */     // MIs[0] policy
     /* 1460791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460803 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1460806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1460825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460828 */     // GIR_Coverage, 7745,
     /* 1460828 */     GIR_EraseRootFromParent_Done,
     /* 1460829 */   // Label 20512: @1460829
     /* 1460829 */   GIM_Try, /*On fail goto*//*Label 20513*/ GIMT_Encode4(1460926), // Rule ID 7748 //
     /* 1460834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1460845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1460848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1460851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460884 */     // MIs[1] Operand 1
     /* 1460884 */     // No operand predicates
     /* 1460884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460888 */     // MIs[0] policy
     /* 1460888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460900 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1460903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1460922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460925 */     // GIR_Coverage, 7748,
     /* 1460925 */     GIR_EraseRootFromParent_Done,
     /* 1460926 */   // Label 20513: @1460926
     /* 1460926 */   GIM_Try, /*On fail goto*//*Label 20514*/ GIMT_Encode4(1461023), // Rule ID 7749 //
     /* 1460931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1460939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1460942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1460945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1460948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1460961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1460969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1460981 */     // MIs[1] Operand 1
     /* 1460981 */     // No operand predicates
     /* 1460981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460985 */     // MIs[0] policy
     /* 1460985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460997 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461022 */     // GIR_Coverage, 7749,
     /* 1461022 */     GIR_EraseRootFromParent_Done,
     /* 1461023 */   // Label 20514: @1461023
     /* 1461023 */   GIM_Try, /*On fail goto*//*Label 20515*/ GIMT_Encode4(1461120), // Rule ID 7752 //
     /* 1461028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1461045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461078 */     // MIs[1] Operand 1
     /* 1461078 */     // No operand predicates
     /* 1461078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461082 */     // MIs[0] policy
     /* 1461082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461094 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1461097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461119 */     // GIR_Coverage, 7752,
     /* 1461119 */     GIR_EraseRootFromParent_Done,
     /* 1461120 */   // Label 20515: @1461120
     /* 1461120 */   GIM_Try, /*On fail goto*//*Label 20516*/ GIMT_Encode4(1461217), // Rule ID 7753 //
     /* 1461125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1461142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461175 */     // MIs[1] Operand 1
     /* 1461175 */     // No operand predicates
     /* 1461175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461179 */     // MIs[0] policy
     /* 1461179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461191 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1461194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461216 */     // GIR_Coverage, 7753,
     /* 1461216 */     GIR_EraseRootFromParent_Done,
     /* 1461217 */   // Label 20516: @1461217
     /* 1461217 */   GIM_Try, /*On fail goto*//*Label 20517*/ GIMT_Encode4(1461314), // Rule ID 7756 //
     /* 1461222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1461233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1461236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1461239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461272 */     // MIs[1] Operand 1
     /* 1461272 */     // No operand predicates
     /* 1461272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461276 */     // MIs[0] policy
     /* 1461276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461288 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1461291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461313 */     // GIR_Coverage, 7756,
     /* 1461313 */     GIR_EraseRootFromParent_Done,
     /* 1461314 */   // Label 20517: @1461314
     /* 1461314 */   GIM_Try, /*On fail goto*//*Label 20518*/ GIMT_Encode4(1461411), // Rule ID 7757 //
     /* 1461319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1461330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1461333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1461336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461369 */     // MIs[1] Operand 1
     /* 1461369 */     // No operand predicates
     /* 1461369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461373 */     // MIs[0] policy
     /* 1461373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461385 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1461388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461410 */     // GIR_Coverage, 7757,
     /* 1461410 */     GIR_EraseRootFromParent_Done,
     /* 1461411 */   // Label 20518: @1461411
     /* 1461411 */   GIM_Try, /*On fail goto*//*Label 20519*/ GIMT_Encode4(1461508), // Rule ID 7760 //
     /* 1461416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1461427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1461430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1461433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1461439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461466 */     // MIs[1] Operand 1
     /* 1461466 */     // No operand predicates
     /* 1461466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461470 */     // MIs[0] policy
     /* 1461470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1461485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461507 */     // GIR_Coverage, 7760,
     /* 1461507 */     GIR_EraseRootFromParent_Done,
     /* 1461508 */   // Label 20519: @1461508
     /* 1461508 */   GIM_Try, /*On fail goto*//*Label 20520*/ GIMT_Encode4(1461605), // Rule ID 7761 //
     /* 1461513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1461524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1461527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1461530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1461536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1461543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1461547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461563 */     // MIs[1] Operand 1
     /* 1461563 */     // No operand predicates
     /* 1461563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461567 */     // MIs[0] policy
     /* 1461567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461579 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1461582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461604 */     // GIR_Coverage, 7761,
     /* 1461604 */     GIR_EraseRootFromParent_Done,
     /* 1461605 */   // Label 20520: @1461605
     /* 1461605 */   GIM_Try, /*On fail goto*//*Label 20521*/ GIMT_Encode4(1461702), // Rule ID 7764 //
     /* 1461610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1461621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1461624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1461627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1461633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461660 */     // MIs[1] Operand 1
     /* 1461660 */     // No operand predicates
     /* 1461660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461664 */     // MIs[0] policy
     /* 1461664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461676 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1461679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461701 */     // GIR_Coverage, 7764,
     /* 1461701 */     GIR_EraseRootFromParent_Done,
     /* 1461702 */   // Label 20521: @1461702
     /* 1461702 */   GIM_Try, /*On fail goto*//*Label 20522*/ GIMT_Encode4(1461799), // Rule ID 7765 //
     /* 1461707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1461718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1461721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1461724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1461730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461757 */     // MIs[1] Operand 1
     /* 1461757 */     // No operand predicates
     /* 1461757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461761 */     // MIs[0] policy
     /* 1461761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461773 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1461776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461798 */     // GIR_Coverage, 7765,
     /* 1461798 */     GIR_EraseRootFromParent_Done,
     /* 1461799 */   // Label 20522: @1461799
     /* 1461799 */   GIM_Try, /*On fail goto*//*Label 20523*/ GIMT_Encode4(1461896), // Rule ID 7768 //
     /* 1461804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1461815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1461818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1461821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461854 */     // MIs[1] Operand 1
     /* 1461854 */     // No operand predicates
     /* 1461854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461858 */     // MIs[0] policy
     /* 1461858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461870 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1461892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461895 */     // GIR_Coverage, 7768,
     /* 1461895 */     GIR_EraseRootFromParent_Done,
     /* 1461896 */   // Label 20523: @1461896
     /* 1461896 */   GIM_Try, /*On fail goto*//*Label 20524*/ GIMT_Encode4(1461993), // Rule ID 7769 //
     /* 1461901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1461909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1461912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1461915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1461918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1461951 */     // MIs[1] Operand 1
     /* 1461951 */     // No operand predicates
     /* 1461951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461955 */     // MIs[0] policy
     /* 1461955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461967 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1461970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1461989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461992 */     // GIR_Coverage, 7769,
     /* 1461992 */     GIR_EraseRootFromParent_Done,
     /* 1461993 */   // Label 20524: @1461993
     /* 1461993 */   GIM_Try, /*On fail goto*//*Label 20525*/ GIMT_Encode4(1462090), // Rule ID 7772 //
     /* 1461998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462048 */     // MIs[1] Operand 1
     /* 1462048 */     // No operand predicates
     /* 1462048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462052 */     // MIs[0] policy
     /* 1462052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462089 */     // GIR_Coverage, 7772,
     /* 1462089 */     GIR_EraseRootFromParent_Done,
     /* 1462090 */   // Label 20525: @1462090
     /* 1462090 */   GIM_Try, /*On fail goto*//*Label 20526*/ GIMT_Encode4(1462187), // Rule ID 7773 //
     /* 1462095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462145 */     // MIs[1] Operand 1
     /* 1462145 */     // No operand predicates
     /* 1462145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462149 */     // MIs[0] policy
     /* 1462149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462161 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462186 */     // GIR_Coverage, 7773,
     /* 1462186 */     GIR_EraseRootFromParent_Done,
     /* 1462187 */   // Label 20526: @1462187
     /* 1462187 */   GIM_Try, /*On fail goto*//*Label 20527*/ GIMT_Encode4(1462284), // Rule ID 7776 //
     /* 1462192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1462209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462242 */     // MIs[1] Operand 1
     /* 1462242 */     // No operand predicates
     /* 1462242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462246 */     // MIs[0] policy
     /* 1462246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462258 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1462261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462283 */     // GIR_Coverage, 7776,
     /* 1462283 */     GIR_EraseRootFromParent_Done,
     /* 1462284 */   // Label 20527: @1462284
     /* 1462284 */   GIM_Try, /*On fail goto*//*Label 20528*/ GIMT_Encode4(1462381), // Rule ID 7777 //
     /* 1462289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1462306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462339 */     // MIs[1] Operand 1
     /* 1462339 */     // No operand predicates
     /* 1462339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462343 */     // MIs[0] policy
     /* 1462343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462355 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1462358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462380 */     // GIR_Coverage, 7777,
     /* 1462380 */     GIR_EraseRootFromParent_Done,
     /* 1462381 */   // Label 20528: @1462381
     /* 1462381 */   GIM_Try, /*On fail goto*//*Label 20529*/ GIMT_Encode4(1462478), // Rule ID 7780 //
     /* 1462386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1462403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462436 */     // MIs[1] Operand 1
     /* 1462436 */     // No operand predicates
     /* 1462436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462440 */     // MIs[0] policy
     /* 1462440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1462455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462477 */     // GIR_Coverage, 7780,
     /* 1462477 */     GIR_EraseRootFromParent_Done,
     /* 1462478 */   // Label 20529: @1462478
     /* 1462478 */   GIM_Try, /*On fail goto*//*Label 20530*/ GIMT_Encode4(1462575), // Rule ID 7781 //
     /* 1462483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1462494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1462497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1462500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1462513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1462517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462533 */     // MIs[1] Operand 1
     /* 1462533 */     // No operand predicates
     /* 1462533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462537 */     // MIs[0] policy
     /* 1462537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462549 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1462552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462574 */     // GIR_Coverage, 7781,
     /* 1462574 */     GIR_EraseRootFromParent_Done,
     /* 1462575 */   // Label 20530: @1462575
     /* 1462575 */   GIM_Try, /*On fail goto*//*Label 20531*/ GIMT_Encode4(1462672), // Rule ID 7784 //
     /* 1462580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1462591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1462594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1462597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1462603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462630 */     // MIs[1] Operand 1
     /* 1462630 */     // No operand predicates
     /* 1462630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462634 */     // MIs[0] policy
     /* 1462634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462646 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1462649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462671 */     // GIR_Coverage, 7784,
     /* 1462671 */     GIR_EraseRootFromParent_Done,
     /* 1462672 */   // Label 20531: @1462672
     /* 1462672 */   GIM_Try, /*On fail goto*//*Label 20532*/ GIMT_Encode4(1462769), // Rule ID 7785 //
     /* 1462677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1462688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1462691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1462694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1462700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1462707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1462711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1462715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462727 */     // MIs[1] Operand 1
     /* 1462727 */     // No operand predicates
     /* 1462727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462731 */     // MIs[0] policy
     /* 1462731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462743 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1462746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462768 */     // GIR_Coverage, 7785,
     /* 1462768 */     GIR_EraseRootFromParent_Done,
     /* 1462769 */   // Label 20532: @1462769
     /* 1462769 */   GIM_Try, /*On fail goto*//*Label 20533*/ GIMT_Encode4(1462866), // Rule ID 7788 //
     /* 1462774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1462777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1462785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1462788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1462791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462824 */     // MIs[1] Operand 1
     /* 1462824 */     // No operand predicates
     /* 1462824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462828 */     // MIs[0] policy
     /* 1462828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462865 */     // GIR_Coverage, 7788,
     /* 1462865 */     GIR_EraseRootFromParent_Done,
     /* 1462866 */   // Label 20533: @1462866
     /* 1462866 */   GIM_Try, /*On fail goto*//*Label 20534*/ GIMT_Encode4(1462963), // Rule ID 7789 //
     /* 1462871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1462874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1462882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1462885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1462888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1462921 */     // MIs[1] Operand 1
     /* 1462921 */     // No operand predicates
     /* 1462921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462925 */     // MIs[0] policy
     /* 1462925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462937 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1462940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462962 */     // GIR_Coverage, 7789,
     /* 1462962 */     GIR_EraseRootFromParent_Done,
     /* 1462963 */   // Label 20534: @1462963
     /* 1462963 */   GIM_Try, /*On fail goto*//*Label 20535*/ GIMT_Encode4(1463060), // Rule ID 7792 //
     /* 1462968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1462971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1462976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1462979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1462982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1462985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463018 */     // MIs[1] Operand 1
     /* 1463018 */     // No operand predicates
     /* 1463018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463022 */     // MIs[0] policy
     /* 1463022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1463037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463059 */     // GIR_Coverage, 7792,
     /* 1463059 */     GIR_EraseRootFromParent_Done,
     /* 1463060 */   // Label 20535: @1463060
     /* 1463060 */   GIM_Try, /*On fail goto*//*Label 20536*/ GIMT_Encode4(1463157), // Rule ID 7793 //
     /* 1463065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1463076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1463079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1463082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463115 */     // MIs[1] Operand 1
     /* 1463115 */     // No operand predicates
     /* 1463115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463119 */     // MIs[0] policy
     /* 1463119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463131 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1463134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463156 */     // GIR_Coverage, 7793,
     /* 1463156 */     GIR_EraseRootFromParent_Done,
     /* 1463157 */   // Label 20536: @1463157
     /* 1463157 */   GIM_Try, /*On fail goto*//*Label 20537*/ GIMT_Encode4(1463254), // Rule ID 7796 //
     /* 1463162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463212 */     // MIs[1] Operand 1
     /* 1463212 */     // No operand predicates
     /* 1463212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463216 */     // MIs[0] policy
     /* 1463216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463253 */     // GIR_Coverage, 7796,
     /* 1463253 */     GIR_EraseRootFromParent_Done,
     /* 1463254 */   // Label 20537: @1463254
     /* 1463254 */   GIM_Try, /*On fail goto*//*Label 20538*/ GIMT_Encode4(1463351), // Rule ID 7797 //
     /* 1463259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1463270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1463273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1463276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463309 */     // MIs[1] Operand 1
     /* 1463309 */     // No operand predicates
     /* 1463309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463313 */     // MIs[0] policy
     /* 1463313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1463328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463350 */     // GIR_Coverage, 7797,
     /* 1463350 */     GIR_EraseRootFromParent_Done,
     /* 1463351 */   // Label 20538: @1463351
     /* 1463351 */   GIM_Try, /*On fail goto*//*Label 20539*/ GIMT_Encode4(1463448), // Rule ID 7800 //
     /* 1463356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1463359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463406 */     // MIs[1] Operand 1
     /* 1463406 */     // No operand predicates
     /* 1463406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463410 */     // MIs[0] policy
     /* 1463410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463422 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463447 */     // GIR_Coverage, 7800,
     /* 1463447 */     GIR_EraseRootFromParent_Done,
     /* 1463448 */   // Label 20539: @1463448
     /* 1463448 */   GIM_Try, /*On fail goto*//*Label 20540*/ GIMT_Encode4(1463545), // Rule ID 7801 //
     /* 1463453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1463456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1463461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1463464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1463467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1463470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1463503 */     // MIs[1] Operand 1
     /* 1463503 */     // No operand predicates
     /* 1463503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463507 */     // MIs[0] policy
     /* 1463507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463519 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1463522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463544 */     // GIR_Coverage, 7801,
     /* 1463544 */     GIR_EraseRootFromParent_Done,
     /* 1463545 */   // Label 20540: @1463545
     /* 1463545 */   GIM_Try, /*On fail goto*//*Label 20541*/ GIMT_Encode4(1463645), // Rule ID 14230 //
     /* 1463550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1463561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1463564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1463567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463600 */     // MIs[1] Operand 1
     /* 1463600 */     // No operand predicates
     /* 1463600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463604 */     // MIs[0] policy
     /* 1463604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463616 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1463619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463644 */     // GIR_Coverage, 14230,
     /* 1463644 */     GIR_EraseRootFromParent_Done,
     /* 1463645 */   // Label 20541: @1463645
     /* 1463645 */   GIM_Try, /*On fail goto*//*Label 20542*/ GIMT_Encode4(1463745), // Rule ID 14231 //
     /* 1463650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1463661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1463664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1463667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463700 */     // MIs[1] Operand 1
     /* 1463700 */     // No operand predicates
     /* 1463700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463704 */     // MIs[0] policy
     /* 1463704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463716 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1463719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463744 */     // GIR_Coverage, 14231,
     /* 1463744 */     GIR_EraseRootFromParent_Done,
     /* 1463745 */   // Label 20542: @1463745
     /* 1463745 */   GIM_Try, /*On fail goto*//*Label 20543*/ GIMT_Encode4(1463845), // Rule ID 14234 //
     /* 1463750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1463761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1463764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1463767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463800 */     // MIs[1] Operand 1
     /* 1463800 */     // No operand predicates
     /* 1463800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463804 */     // MIs[0] policy
     /* 1463804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463816 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1463819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463844 */     // GIR_Coverage, 14234,
     /* 1463844 */     GIR_EraseRootFromParent_Done,
     /* 1463845 */   // Label 20543: @1463845
     /* 1463845 */   GIM_Try, /*On fail goto*//*Label 20544*/ GIMT_Encode4(1463945), // Rule ID 14235 //
     /* 1463850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1463861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1463864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1463867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463900 */     // MIs[1] Operand 1
     /* 1463900 */     // No operand predicates
     /* 1463900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463904 */     // MIs[0] policy
     /* 1463904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1463919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463944 */     // GIR_Coverage, 14235,
     /* 1463944 */     GIR_EraseRootFromParent_Done,
     /* 1463945 */   // Label 20544: @1463945
     /* 1463945 */   GIM_Try, /*On fail goto*//*Label 20545*/ GIMT_Encode4(1464045), // Rule ID 14238 //
     /* 1463950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1463958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1463961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1463964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1463967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1463973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464000 */     // MIs[1] Operand 1
     /* 1464000 */     // No operand predicates
     /* 1464000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464004 */     // MIs[0] policy
     /* 1464004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464016 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464044 */     // GIR_Coverage, 14238,
     /* 1464044 */     GIR_EraseRootFromParent_Done,
     /* 1464045 */   // Label 20545: @1464045
     /* 1464045 */   GIM_Try, /*On fail goto*//*Label 20546*/ GIMT_Encode4(1464145), // Rule ID 14239 //
     /* 1464050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1464061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1464064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1464067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464100 */     // MIs[1] Operand 1
     /* 1464100 */     // No operand predicates
     /* 1464100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464104 */     // MIs[0] policy
     /* 1464104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464116 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464144 */     // GIR_Coverage, 14239,
     /* 1464144 */     GIR_EraseRootFromParent_Done,
     /* 1464145 */   // Label 20546: @1464145
     /* 1464145 */   GIM_Try, /*On fail goto*//*Label 20547*/ GIMT_Encode4(1464245), // Rule ID 14242 //
     /* 1464150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464200 */     // MIs[1] Operand 1
     /* 1464200 */     // No operand predicates
     /* 1464200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464204 */     // MIs[0] policy
     /* 1464204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464216 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464244 */     // GIR_Coverage, 14242,
     /* 1464244 */     GIR_EraseRootFromParent_Done,
     /* 1464245 */   // Label 20547: @1464245
     /* 1464245 */   GIM_Try, /*On fail goto*//*Label 20548*/ GIMT_Encode4(1464345), // Rule ID 14243 //
     /* 1464250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1464261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1464264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1464267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464300 */     // MIs[1] Operand 1
     /* 1464300 */     // No operand predicates
     /* 1464300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464304 */     // MIs[0] policy
     /* 1464304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464316 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1464319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464344 */     // GIR_Coverage, 14243,
     /* 1464344 */     GIR_EraseRootFromParent_Done,
     /* 1464345 */   // Label 20548: @1464345
     /* 1464345 */   GIM_Try, /*On fail goto*//*Label 20549*/ GIMT_Encode4(1464445), // Rule ID 14246 //
     /* 1464350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464400 */     // MIs[1] Operand 1
     /* 1464400 */     // No operand predicates
     /* 1464400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464404 */     // MIs[0] policy
     /* 1464404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464444 */     // GIR_Coverage, 14246,
     /* 1464444 */     GIR_EraseRootFromParent_Done,
     /* 1464445 */   // Label 20549: @1464445
     /* 1464445 */   GIM_Try, /*On fail goto*//*Label 20550*/ GIMT_Encode4(1464545), // Rule ID 14247 //
     /* 1464450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1464461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1464464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1464467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1464473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464500 */     // MIs[1] Operand 1
     /* 1464500 */     // No operand predicates
     /* 1464500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464504 */     // MIs[0] policy
     /* 1464504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464516 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464544 */     // GIR_Coverage, 14247,
     /* 1464544 */     GIR_EraseRootFromParent_Done,
     /* 1464545 */   // Label 20550: @1464545
     /* 1464545 */   GIM_Try, /*On fail goto*//*Label 20551*/ GIMT_Encode4(1464645), // Rule ID 14250 //
     /* 1464550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1464561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1464564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1464567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464600 */     // MIs[1] Operand 1
     /* 1464600 */     // No operand predicates
     /* 1464600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464604 */     // MIs[0] policy
     /* 1464604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464616 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464644 */     // GIR_Coverage, 14250,
     /* 1464644 */     GIR_EraseRootFromParent_Done,
     /* 1464645 */   // Label 20551: @1464645
     /* 1464645 */   GIM_Try, /*On fail goto*//*Label 20552*/ GIMT_Encode4(1464745), // Rule ID 14251 //
     /* 1464650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1464661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1464664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1464667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1464673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464700 */     // MIs[1] Operand 1
     /* 1464700 */     // No operand predicates
     /* 1464700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464704 */     // MIs[0] policy
     /* 1464704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464716 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1464719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464744 */     // GIR_Coverage, 14251,
     /* 1464744 */     GIR_EraseRootFromParent_Done,
     /* 1464745 */   // Label 20552: @1464745
     /* 1464745 */   GIM_Try, /*On fail goto*//*Label 20553*/ GIMT_Encode4(1464845), // Rule ID 14254 //
     /* 1464750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1464761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1464764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1464767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464800 */     // MIs[1] Operand 1
     /* 1464800 */     // No operand predicates
     /* 1464800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464804 */     // MIs[0] policy
     /* 1464804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1464819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464844 */     // GIR_Coverage, 14254,
     /* 1464844 */     GIR_EraseRootFromParent_Done,
     /* 1464845 */   // Label 20553: @1464845
     /* 1464845 */   GIM_Try, /*On fail goto*//*Label 20554*/ GIMT_Encode4(1464945), // Rule ID 14255 //
     /* 1464850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1464861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1464864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1464867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464900 */     // MIs[1] Operand 1
     /* 1464900 */     // No operand predicates
     /* 1464900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464904 */     // MIs[0] policy
     /* 1464904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464916 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1464919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1464938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464944 */     // GIR_Coverage, 14255,
     /* 1464944 */     GIR_EraseRootFromParent_Done,
     /* 1464945 */   // Label 20554: @1464945
     /* 1464945 */   GIM_Try, /*On fail goto*//*Label 20555*/ GIMT_Encode4(1465045), // Rule ID 14258 //
     /* 1464950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1464958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1464961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1464964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1464967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1464980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1464988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465000 */     // MIs[1] Operand 1
     /* 1465000 */     // No operand predicates
     /* 1465000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465004 */     // MIs[0] policy
     /* 1465004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465044 */     // GIR_Coverage, 14258,
     /* 1465044 */     GIR_EraseRootFromParent_Done,
     /* 1465045 */   // Label 20555: @1465045
     /* 1465045 */   GIM_Try, /*On fail goto*//*Label 20556*/ GIMT_Encode4(1465145), // Rule ID 14259 //
     /* 1465050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1465061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1465064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1465067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465100 */     // MIs[1] Operand 1
     /* 1465100 */     // No operand predicates
     /* 1465100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465104 */     // MIs[0] policy
     /* 1465104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465116 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1465138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465144 */     // GIR_Coverage, 14259,
     /* 1465144 */     GIR_EraseRootFromParent_Done,
     /* 1465145 */   // Label 20556: @1465145
     /* 1465145 */   GIM_Try, /*On fail goto*//*Label 20557*/ GIMT_Encode4(1465245), // Rule ID 14262 //
     /* 1465150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1465161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1465164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465200 */     // MIs[1] Operand 1
     /* 1465200 */     // No operand predicates
     /* 1465200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465204 */     // MIs[0] policy
     /* 1465204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465244 */     // GIR_Coverage, 14262,
     /* 1465244 */     GIR_EraseRootFromParent_Done,
     /* 1465245 */   // Label 20557: @1465245
     /* 1465245 */   GIM_Try, /*On fail goto*//*Label 20558*/ GIMT_Encode4(1465345), // Rule ID 14263 //
     /* 1465250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1465261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1465264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1465267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465300 */     // MIs[1] Operand 1
     /* 1465300 */     // No operand predicates
     /* 1465300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465304 */     // MIs[0] policy
     /* 1465304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465344 */     // GIR_Coverage, 14263,
     /* 1465344 */     GIR_EraseRootFromParent_Done,
     /* 1465345 */   // Label 20558: @1465345
     /* 1465345 */   GIM_Try, /*On fail goto*//*Label 20559*/ GIMT_Encode4(1465445), // Rule ID 14266 //
     /* 1465350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1465361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1465364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1465367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465400 */     // MIs[1] Operand 1
     /* 1465400 */     // No operand predicates
     /* 1465400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465404 */     // MIs[0] policy
     /* 1465404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465416 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465444 */     // GIR_Coverage, 14266,
     /* 1465444 */     GIR_EraseRootFromParent_Done,
     /* 1465445 */   // Label 20559: @1465445
     /* 1465445 */   GIM_Try, /*On fail goto*//*Label 20560*/ GIMT_Encode4(1465545), // Rule ID 14267 //
     /* 1465450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1465461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1465464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1465467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465500 */     // MIs[1] Operand 1
     /* 1465500 */     // No operand predicates
     /* 1465500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465504 */     // MIs[0] policy
     /* 1465504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465516 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1465519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465544 */     // GIR_Coverage, 14267,
     /* 1465544 */     GIR_EraseRootFromParent_Done,
     /* 1465545 */   // Label 20560: @1465545
     /* 1465545 */   GIM_Try, /*On fail goto*//*Label 20561*/ GIMT_Encode4(1465645), // Rule ID 14270 //
     /* 1465550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1465561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1465564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1465567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1465573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465600 */     // MIs[1] Operand 1
     /* 1465600 */     // No operand predicates
     /* 1465600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465604 */     // MIs[0] policy
     /* 1465604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465616 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1465619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465644 */     // GIR_Coverage, 14270,
     /* 1465644 */     GIR_EraseRootFromParent_Done,
     /* 1465645 */   // Label 20561: @1465645
     /* 1465645 */   GIM_Try, /*On fail goto*//*Label 20562*/ GIMT_Encode4(1465745), // Rule ID 14271 //
     /* 1465650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1465661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1465664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1465667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1465673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465700 */     // MIs[1] Operand 1
     /* 1465700 */     // No operand predicates
     /* 1465700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465704 */     // MIs[0] policy
     /* 1465704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465716 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1465719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465744 */     // GIR_Coverage, 14271,
     /* 1465744 */     GIR_EraseRootFromParent_Done,
     /* 1465745 */   // Label 20562: @1465745
     /* 1465745 */   GIM_Try, /*On fail goto*//*Label 20563*/ GIMT_Encode4(1465845), // Rule ID 14274 //
     /* 1465750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1465761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1465764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1465767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1465773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465800 */     // MIs[1] Operand 1
     /* 1465800 */     // No operand predicates
     /* 1465800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465804 */     // MIs[0] policy
     /* 1465804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465816 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1465819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465844 */     // GIR_Coverage, 14274,
     /* 1465844 */     GIR_EraseRootFromParent_Done,
     /* 1465845 */   // Label 20563: @1465845
     /* 1465845 */   GIM_Try, /*On fail goto*//*Label 20564*/ GIMT_Encode4(1465945), // Rule ID 14275 //
     /* 1465850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1465861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1465864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1465867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1465873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465900 */     // MIs[1] Operand 1
     /* 1465900 */     // No operand predicates
     /* 1465900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465904 */     // MIs[0] policy
     /* 1465904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465916 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1465919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465944 */     // GIR_Coverage, 14275,
     /* 1465944 */     GIR_EraseRootFromParent_Done,
     /* 1465945 */   // Label 20564: @1465945
     /* 1465945 */   GIM_Try, /*On fail goto*//*Label 20565*/ GIMT_Encode4(1466045), // Rule ID 14278 //
     /* 1465950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1465958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1465961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1465964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1465967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1465973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466000 */     // MIs[1] Operand 1
     /* 1466000 */     // No operand predicates
     /* 1466000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466004 */     // MIs[0] policy
     /* 1466004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466016 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466044 */     // GIR_Coverage, 14278,
     /* 1466044 */     GIR_EraseRootFromParent_Done,
     /* 1466045 */   // Label 20565: @1466045
     /* 1466045 */   GIM_Try, /*On fail goto*//*Label 20566*/ GIMT_Encode4(1466145), // Rule ID 14279 //
     /* 1466050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1466061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1466064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1466067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1466073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466100 */     // MIs[1] Operand 1
     /* 1466100 */     // No operand predicates
     /* 1466100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466104 */     // MIs[0] policy
     /* 1466104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466116 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466144 */     // GIR_Coverage, 14279,
     /* 1466144 */     GIR_EraseRootFromParent_Done,
     /* 1466145 */   // Label 20566: @1466145
     /* 1466145 */   GIM_Try, /*On fail goto*//*Label 20567*/ GIMT_Encode4(1466245), // Rule ID 14282 //
     /* 1466150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1466167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466200 */     // MIs[1] Operand 1
     /* 1466200 */     // No operand predicates
     /* 1466200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466204 */     // MIs[0] policy
     /* 1466204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466244 */     // GIR_Coverage, 14282,
     /* 1466244 */     GIR_EraseRootFromParent_Done,
     /* 1466245 */   // Label 20567: @1466245
     /* 1466245 */   GIM_Try, /*On fail goto*//*Label 20568*/ GIMT_Encode4(1466345), // Rule ID 14283 //
     /* 1466250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1466261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1466264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1466267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466300 */     // MIs[1] Operand 1
     /* 1466300 */     // No operand predicates
     /* 1466300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466304 */     // MIs[0] policy
     /* 1466304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466344 */     // GIR_Coverage, 14283,
     /* 1466344 */     GIR_EraseRootFromParent_Done,
     /* 1466345 */   // Label 20568: @1466345
     /* 1466345 */   GIM_Try, /*On fail goto*//*Label 20569*/ GIMT_Encode4(1466445), // Rule ID 14286 //
     /* 1466350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1466367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466400 */     // MIs[1] Operand 1
     /* 1466400 */     // No operand predicates
     /* 1466400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466404 */     // MIs[0] policy
     /* 1466404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466444 */     // GIR_Coverage, 14286,
     /* 1466444 */     GIR_EraseRootFromParent_Done,
     /* 1466445 */   // Label 20569: @1466445
     /* 1466445 */   GIM_Try, /*On fail goto*//*Label 20570*/ GIMT_Encode4(1466545), // Rule ID 14287 //
     /* 1466450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1466461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1466464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1466467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1466473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466500 */     // MIs[1] Operand 1
     /* 1466500 */     // No operand predicates
     /* 1466500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466504 */     // MIs[0] policy
     /* 1466504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1466519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466544 */     // GIR_Coverage, 14287,
     /* 1466544 */     GIR_EraseRootFromParent_Done,
     /* 1466545 */   // Label 20570: @1466545
     /* 1466545 */   GIM_Try, /*On fail goto*//*Label 20571*/ GIMT_Encode4(1466645), // Rule ID 14290 //
     /* 1466550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1466561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1466564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1466567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1466573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466600 */     // MIs[1] Operand 1
     /* 1466600 */     // No operand predicates
     /* 1466600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466604 */     // MIs[0] policy
     /* 1466604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466616 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466644 */     // GIR_Coverage, 14290,
     /* 1466644 */     GIR_EraseRootFromParent_Done,
     /* 1466645 */   // Label 20571: @1466645
     /* 1466645 */   GIM_Try, /*On fail goto*//*Label 20572*/ GIMT_Encode4(1466745), // Rule ID 14291 //
     /* 1466650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1466661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1466664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1466667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1466673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1466680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1466688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466700 */     // MIs[1] Operand 1
     /* 1466700 */     // No operand predicates
     /* 1466700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466704 */     // MIs[0] policy
     /* 1466704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466716 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1466719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466744 */     // GIR_Coverage, 14291,
     /* 1466744 */     GIR_EraseRootFromParent_Done,
     /* 1466745 */   // Label 20572: @1466745
     /* 1466745 */   GIM_Try, /*On fail goto*//*Label 20573*/ GIMT_Encode4(1466845), // Rule ID 14294 //
     /* 1466750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1466761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1466764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1466767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466800 */     // MIs[1] Operand 1
     /* 1466800 */     // No operand predicates
     /* 1466800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466804 */     // MIs[0] policy
     /* 1466804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466844 */     // GIR_Coverage, 14294,
     /* 1466844 */     GIR_EraseRootFromParent_Done,
     /* 1466845 */   // Label 20573: @1466845
     /* 1466845 */   GIM_Try, /*On fail goto*//*Label 20574*/ GIMT_Encode4(1466945), // Rule ID 14295 //
     /* 1466850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1466861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1466864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1466867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1466880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1466888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1466900 */     // MIs[1] Operand 1
     /* 1466900 */     // No operand predicates
     /* 1466900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466904 */     // MIs[0] policy
     /* 1466904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1466919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1466923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1466943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466944 */     // GIR_Coverage, 14295,
     /* 1466944 */     GIR_EraseRootFromParent_Done,
     /* 1466945 */   // Label 20574: @1466945
     /* 1466945 */   GIM_Try, /*On fail goto*//*Label 20575*/ GIMT_Encode4(1467045), // Rule ID 14298 //
     /* 1466950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1466958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1466961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1466964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1466967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1466980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1466988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467000 */     // MIs[1] Operand 1
     /* 1467000 */     // No operand predicates
     /* 1467000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467004 */     // MIs[0] policy
     /* 1467004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467044 */     // GIR_Coverage, 14298,
     /* 1467044 */     GIR_EraseRootFromParent_Done,
     /* 1467045 */   // Label 20575: @1467045
     /* 1467045 */   GIM_Try, /*On fail goto*//*Label 20576*/ GIMT_Encode4(1467145), // Rule ID 14299 //
     /* 1467050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1467061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1467064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1467067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467100 */     // MIs[1] Operand 1
     /* 1467100 */     // No operand predicates
     /* 1467100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467104 */     // MIs[0] policy
     /* 1467104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467144 */     // GIR_Coverage, 14299,
     /* 1467144 */     GIR_EraseRootFromParent_Done,
     /* 1467145 */   // Label 20576: @1467145
     /* 1467145 */   GIM_Try, /*On fail goto*//*Label 20577*/ GIMT_Encode4(1467245), // Rule ID 14302 //
     /* 1467150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1467167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467200 */     // MIs[1] Operand 1
     /* 1467200 */     // No operand predicates
     /* 1467200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467204 */     // MIs[0] policy
     /* 1467204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467216 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467244 */     // GIR_Coverage, 14302,
     /* 1467244 */     GIR_EraseRootFromParent_Done,
     /* 1467245 */   // Label 20577: @1467245
     /* 1467245 */   GIM_Try, /*On fail goto*//*Label 20578*/ GIMT_Encode4(1467345), // Rule ID 14303 //
     /* 1467250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1467261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1467264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1467267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467300 */     // MIs[1] Operand 1
     /* 1467300 */     // No operand predicates
     /* 1467300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467304 */     // MIs[0] policy
     /* 1467304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467316 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467344 */     // GIR_Coverage, 14303,
     /* 1467344 */     GIR_EraseRootFromParent_Done,
     /* 1467345 */   // Label 20578: @1467345
     /* 1467345 */   GIM_Try, /*On fail goto*//*Label 20579*/ GIMT_Encode4(1467445), // Rule ID 14306 //
     /* 1467350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1467367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467400 */     // MIs[1] Operand 1
     /* 1467400 */     // No operand predicates
     /* 1467400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467404 */     // MIs[0] policy
     /* 1467404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467444 */     // GIR_Coverage, 14306,
     /* 1467444 */     GIR_EraseRootFromParent_Done,
     /* 1467445 */   // Label 20579: @1467445
     /* 1467445 */   GIM_Try, /*On fail goto*//*Label 20580*/ GIMT_Encode4(1467545), // Rule ID 14307 //
     /* 1467450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1467461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1467464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1467467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467500 */     // MIs[1] Operand 1
     /* 1467500 */     // No operand predicates
     /* 1467500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467504 */     // MIs[0] policy
     /* 1467504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1467519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467544 */     // GIR_Coverage, 14307,
     /* 1467544 */     GIR_EraseRootFromParent_Done,
     /* 1467545 */   // Label 20580: @1467545
     /* 1467545 */   GIM_Try, /*On fail goto*//*Label 20581*/ GIMT_Encode4(1467645), // Rule ID 14310 //
     /* 1467550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1467561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1467564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1467567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467600 */     // MIs[1] Operand 1
     /* 1467600 */     // No operand predicates
     /* 1467600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467604 */     // MIs[0] policy
     /* 1467604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467644 */     // GIR_Coverage, 14310,
     /* 1467644 */     GIR_EraseRootFromParent_Done,
     /* 1467645 */   // Label 20581: @1467645
     /* 1467645 */   GIM_Try, /*On fail goto*//*Label 20582*/ GIMT_Encode4(1467745), // Rule ID 14311 //
     /* 1467650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1467661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1467664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1467667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467700 */     // MIs[1] Operand 1
     /* 1467700 */     // No operand predicates
     /* 1467700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467704 */     // MIs[0] policy
     /* 1467704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1467719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467744 */     // GIR_Coverage, 14311,
     /* 1467744 */     GIR_EraseRootFromParent_Done,
     /* 1467745 */   // Label 20582: @1467745
     /* 1467745 */   GIM_Try, /*On fail goto*//*Label 20583*/ GIMT_Encode4(1467845), // Rule ID 14314 //
     /* 1467750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1467761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1467764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1467767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467800 */     // MIs[1] Operand 1
     /* 1467800 */     // No operand predicates
     /* 1467800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467804 */     // MIs[0] policy
     /* 1467804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467816 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467844 */     // GIR_Coverage, 14314,
     /* 1467844 */     GIR_EraseRootFromParent_Done,
     /* 1467845 */   // Label 20583: @1467845
     /* 1467845 */   GIM_Try, /*On fail goto*//*Label 20584*/ GIMT_Encode4(1467945), // Rule ID 14315 //
     /* 1467850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1467858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1467861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1467864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1467867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1467880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1467888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1467900 */     // MIs[1] Operand 1
     /* 1467900 */     // No operand predicates
     /* 1467900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467904 */     // MIs[0] policy
     /* 1467904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467916 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1467919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1467923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1467943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467944 */     // GIR_Coverage, 14315,
     /* 1467944 */     GIR_EraseRootFromParent_Done,
     /* 1467945 */   // Label 20584: @1467945
     /* 1467945 */   GIM_Try, /*On fail goto*//*Label 20585*/ GIMT_Encode4(1468045), // Rule ID 14494 //
     /* 1467950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1467958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1467961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1467964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1467967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1467973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468000 */     // MIs[1] Operand 1
     /* 1468000 */     // No operand predicates
     /* 1468000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468004 */     // MIs[0] policy
     /* 1468004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468016 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1468019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468044 */     // GIR_Coverage, 14494,
     /* 1468044 */     GIR_EraseRootFromParent_Done,
     /* 1468045 */   // Label 20585: @1468045
     /* 1468045 */   GIM_Try, /*On fail goto*//*Label 20586*/ GIMT_Encode4(1468145), // Rule ID 14495 //
     /* 1468050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1468061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1468064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1468067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468100 */     // MIs[1] Operand 1
     /* 1468100 */     // No operand predicates
     /* 1468100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468104 */     // MIs[0] policy
     /* 1468104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468116 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1468119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468144 */     // GIR_Coverage, 14495,
     /* 1468144 */     GIR_EraseRootFromParent_Done,
     /* 1468145 */   // Label 20586: @1468145
     /* 1468145 */   GIM_Try, /*On fail goto*//*Label 20587*/ GIMT_Encode4(1468245), // Rule ID 14498 //
     /* 1468150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1468161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1468164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1468167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468200 */     // MIs[1] Operand 1
     /* 1468200 */     // No operand predicates
     /* 1468200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468204 */     // MIs[0] policy
     /* 1468204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468216 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468244 */     // GIR_Coverage, 14498,
     /* 1468244 */     GIR_EraseRootFromParent_Done,
     /* 1468245 */   // Label 20587: @1468245
     /* 1468245 */   GIM_Try, /*On fail goto*//*Label 20588*/ GIMT_Encode4(1468345), // Rule ID 14499 //
     /* 1468250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1468261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1468264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1468267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468300 */     // MIs[1] Operand 1
     /* 1468300 */     // No operand predicates
     /* 1468300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468304 */     // MIs[0] policy
     /* 1468304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468316 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468344 */     // GIR_Coverage, 14499,
     /* 1468344 */     GIR_EraseRootFromParent_Done,
     /* 1468345 */   // Label 20588: @1468345
     /* 1468345 */   GIM_Try, /*On fail goto*//*Label 20589*/ GIMT_Encode4(1468445), // Rule ID 14502 //
     /* 1468350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1468361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1468364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1468367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468400 */     // MIs[1] Operand 1
     /* 1468400 */     // No operand predicates
     /* 1468400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468404 */     // MIs[0] policy
     /* 1468404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468416 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468444 */     // GIR_Coverage, 14502,
     /* 1468444 */     GIR_EraseRootFromParent_Done,
     /* 1468445 */   // Label 20589: @1468445
     /* 1468445 */   GIM_Try, /*On fail goto*//*Label 20590*/ GIMT_Encode4(1468545), // Rule ID 14503 //
     /* 1468450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1468461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1468464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1468467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468500 */     // MIs[1] Operand 1
     /* 1468500 */     // No operand predicates
     /* 1468500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468504 */     // MIs[0] policy
     /* 1468504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468516 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468544 */     // GIR_Coverage, 14503,
     /* 1468544 */     GIR_EraseRootFromParent_Done,
     /* 1468545 */   // Label 20590: @1468545
     /* 1468545 */   GIM_Try, /*On fail goto*//*Label 20591*/ GIMT_Encode4(1468645), // Rule ID 14506 //
     /* 1468550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1468561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1468564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1468567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468600 */     // MIs[1] Operand 1
     /* 1468600 */     // No operand predicates
     /* 1468600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468604 */     // MIs[0] policy
     /* 1468604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468616 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468644 */     // GIR_Coverage, 14506,
     /* 1468644 */     GIR_EraseRootFromParent_Done,
     /* 1468645 */   // Label 20591: @1468645
     /* 1468645 */   GIM_Try, /*On fail goto*//*Label 20592*/ GIMT_Encode4(1468745), // Rule ID 14507 //
     /* 1468650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1468661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1468664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1468667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468700 */     // MIs[1] Operand 1
     /* 1468700 */     // No operand predicates
     /* 1468700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468704 */     // MIs[0] policy
     /* 1468704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1468719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468744 */     // GIR_Coverage, 14507,
     /* 1468744 */     GIR_EraseRootFromParent_Done,
     /* 1468745 */   // Label 20592: @1468745
     /* 1468745 */   GIM_Try, /*On fail goto*//*Label 20593*/ GIMT_Encode4(1468845), // Rule ID 14510 //
     /* 1468750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1468761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1468764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1468767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468800 */     // MIs[1] Operand 1
     /* 1468800 */     // No operand predicates
     /* 1468800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468804 */     // MIs[0] policy
     /* 1468804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468816 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468844 */     // GIR_Coverage, 14510,
     /* 1468844 */     GIR_EraseRootFromParent_Done,
     /* 1468845 */   // Label 20593: @1468845
     /* 1468845 */   GIM_Try, /*On fail goto*//*Label 20594*/ GIMT_Encode4(1468945), // Rule ID 14511 //
     /* 1468850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1468861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1468864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1468867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1468873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1468900 */     // MIs[1] Operand 1
     /* 1468900 */     // No operand predicates
     /* 1468900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468904 */     // MIs[0] policy
     /* 1468904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468916 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1468919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1468923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1468943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468944 */     // GIR_Coverage, 14511,
     /* 1468944 */     GIR_EraseRootFromParent_Done,
     /* 1468945 */   // Label 20594: @1468945
     /* 1468945 */   GIM_Try, /*On fail goto*//*Label 20595*/ GIMT_Encode4(1469045), // Rule ID 14514 //
     /* 1468950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1468958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1468961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1468964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1468967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1468973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1468980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1468988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469000 */     // MIs[1] Operand 1
     /* 1469000 */     // No operand predicates
     /* 1469000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469004 */     // MIs[0] policy
     /* 1469004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469044 */     // GIR_Coverage, 14514,
     /* 1469044 */     GIR_EraseRootFromParent_Done,
     /* 1469045 */   // Label 20595: @1469045
     /* 1469045 */   GIM_Try, /*On fail goto*//*Label 20596*/ GIMT_Encode4(1469145), // Rule ID 14515 //
     /* 1469050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1469061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1469064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1469067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469100 */     // MIs[1] Operand 1
     /* 1469100 */     // No operand predicates
     /* 1469100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469104 */     // MIs[0] policy
     /* 1469104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469116 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1469119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469144 */     // GIR_Coverage, 14515,
     /* 1469144 */     GIR_EraseRootFromParent_Done,
     /* 1469145 */   // Label 20596: @1469145
     /* 1469145 */   GIM_Try, /*On fail goto*//*Label 20597*/ GIMT_Encode4(1469245), // Rule ID 14518 //
     /* 1469150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1469161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1469164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1469167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469200 */     // MIs[1] Operand 1
     /* 1469200 */     // No operand predicates
     /* 1469200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469204 */     // MIs[0] policy
     /* 1469204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469216 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469244 */     // GIR_Coverage, 14518,
     /* 1469244 */     GIR_EraseRootFromParent_Done,
     /* 1469245 */   // Label 20597: @1469245
     /* 1469245 */   GIM_Try, /*On fail goto*//*Label 20598*/ GIMT_Encode4(1469345), // Rule ID 14519 //
     /* 1469250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1469261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1469264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1469267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469300 */     // MIs[1] Operand 1
     /* 1469300 */     // No operand predicates
     /* 1469300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469304 */     // MIs[0] policy
     /* 1469304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469316 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1469338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469344 */     // GIR_Coverage, 14519,
     /* 1469344 */     GIR_EraseRootFromParent_Done,
     /* 1469345 */   // Label 20598: @1469345
     /* 1469345 */   GIM_Try, /*On fail goto*//*Label 20599*/ GIMT_Encode4(1469445), // Rule ID 14522 //
     /* 1469350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1469361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1469364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469400 */     // MIs[1] Operand 1
     /* 1469400 */     // No operand predicates
     /* 1469400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469404 */     // MIs[0] policy
     /* 1469404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469444 */     // GIR_Coverage, 14522,
     /* 1469444 */     GIR_EraseRootFromParent_Done,
     /* 1469445 */   // Label 20599: @1469445
     /* 1469445 */   GIM_Try, /*On fail goto*//*Label 20600*/ GIMT_Encode4(1469545), // Rule ID 14523 //
     /* 1469450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1469461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1469464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1469467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469500 */     // MIs[1] Operand 1
     /* 1469500 */     // No operand predicates
     /* 1469500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469504 */     // MIs[0] policy
     /* 1469504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469516 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1469538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469544 */     // GIR_Coverage, 14523,
     /* 1469544 */     GIR_EraseRootFromParent_Done,
     /* 1469545 */   // Label 20600: @1469545
     /* 1469545 */   GIM_Try, /*On fail goto*//*Label 20601*/ GIMT_Encode4(1469645), // Rule ID 14526 //
     /* 1469550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1469561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1469564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1469567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469600 */     // MIs[1] Operand 1
     /* 1469600 */     // No operand predicates
     /* 1469600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469604 */     // MIs[0] policy
     /* 1469604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469644 */     // GIR_Coverage, 14526,
     /* 1469644 */     GIR_EraseRootFromParent_Done,
     /* 1469645 */   // Label 20601: @1469645
     /* 1469645 */   GIM_Try, /*On fail goto*//*Label 20602*/ GIMT_Encode4(1469745), // Rule ID 14527 //
     /* 1469650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1469661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1469664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1469667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469700 */     // MIs[1] Operand 1
     /* 1469700 */     // No operand predicates
     /* 1469700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469704 */     // MIs[0] policy
     /* 1469704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469744 */     // GIR_Coverage, 14527,
     /* 1469744 */     GIR_EraseRootFromParent_Done,
     /* 1469745 */   // Label 20602: @1469745
     /* 1469745 */   GIM_Try, /*On fail goto*//*Label 20603*/ GIMT_Encode4(1469845), // Rule ID 14530 //
     /* 1469750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1469753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1469761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1469764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1469767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469800 */     // MIs[1] Operand 1
     /* 1469800 */     // No operand predicates
     /* 1469800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469804 */     // MIs[0] policy
     /* 1469804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469844 */     // GIR_Coverage, 14530,
     /* 1469844 */     GIR_EraseRootFromParent_Done,
     /* 1469845 */   // Label 20603: @1469845
     /* 1469845 */   GIM_Try, /*On fail goto*//*Label 20604*/ GIMT_Encode4(1469945), // Rule ID 14531 //
     /* 1469850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1469853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1469861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1469864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1469867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1469873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1469880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1469888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1469900 */     // MIs[1] Operand 1
     /* 1469900 */     // No operand predicates
     /* 1469900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469904 */     // MIs[0] policy
     /* 1469904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1469919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1469923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1469943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469944 */     // GIR_Coverage, 14531,
     /* 1469944 */     GIR_EraseRootFromParent_Done,
     /* 1469945 */   // Label 20604: @1469945
     /* 1469945 */   GIM_Try, /*On fail goto*//*Label 20605*/ GIMT_Encode4(1470045), // Rule ID 14534 //
     /* 1469950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1469958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1469961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1469964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1469967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1469973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470000 */     // MIs[1] Operand 1
     /* 1470000 */     // No operand predicates
     /* 1470000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470004 */     // MIs[0] policy
     /* 1470004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470016 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470044 */     // GIR_Coverage, 14534,
     /* 1470044 */     GIR_EraseRootFromParent_Done,
     /* 1470045 */   // Label 20605: @1470045
     /* 1470045 */   GIM_Try, /*On fail goto*//*Label 20606*/ GIMT_Encode4(1470145), // Rule ID 14535 //
     /* 1470050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1470061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1470064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1470067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470100 */     // MIs[1] Operand 1
     /* 1470100 */     // No operand predicates
     /* 1470100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470104 */     // MIs[0] policy
     /* 1470104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470116 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470144 */     // GIR_Coverage, 14535,
     /* 1470144 */     GIR_EraseRootFromParent_Done,
     /* 1470145 */   // Label 20606: @1470145
     /* 1470145 */   GIM_Try, /*On fail goto*//*Label 20607*/ GIMT_Encode4(1470245), // Rule ID 14538 //
     /* 1470150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1470167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470200 */     // MIs[1] Operand 1
     /* 1470200 */     // No operand predicates
     /* 1470200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470204 */     // MIs[0] policy
     /* 1470204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470216 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470244 */     // GIR_Coverage, 14538,
     /* 1470244 */     GIR_EraseRootFromParent_Done,
     /* 1470245 */   // Label 20607: @1470245
     /* 1470245 */   GIM_Try, /*On fail goto*//*Label 20608*/ GIMT_Encode4(1470345), // Rule ID 14539 //
     /* 1470250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1470261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1470264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1470267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470300 */     // MIs[1] Operand 1
     /* 1470300 */     // No operand predicates
     /* 1470300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470304 */     // MIs[0] policy
     /* 1470304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470344 */     // GIR_Coverage, 14539,
     /* 1470344 */     GIR_EraseRootFromParent_Done,
     /* 1470345 */   // Label 20608: @1470345
     /* 1470345 */   GIM_Try, /*On fail goto*//*Label 20609*/ GIMT_Encode4(1470445), // Rule ID 14542 //
     /* 1470350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1470361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1470364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1470367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1470373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470400 */     // MIs[1] Operand 1
     /* 1470400 */     // No operand predicates
     /* 1470400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470404 */     // MIs[0] policy
     /* 1470404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470416 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1470419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470444 */     // GIR_Coverage, 14542,
     /* 1470444 */     GIR_EraseRootFromParent_Done,
     /* 1470445 */   // Label 20609: @1470445
     /* 1470445 */   GIM_Try, /*On fail goto*//*Label 20610*/ GIMT_Encode4(1470545), // Rule ID 14543 //
     /* 1470450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1470461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1470464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1470467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1470473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470500 */     // MIs[1] Operand 1
     /* 1470500 */     // No operand predicates
     /* 1470500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470504 */     // MIs[0] policy
     /* 1470504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470516 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1470519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470544 */     // GIR_Coverage, 14543,
     /* 1470544 */     GIR_EraseRootFromParent_Done,
     /* 1470545 */   // Label 20610: @1470545
     /* 1470545 */   GIM_Try, /*On fail goto*//*Label 20611*/ GIMT_Encode4(1470645), // Rule ID 14546 //
     /* 1470550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1470561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1470564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1470567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1470573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470600 */     // MIs[1] Operand 1
     /* 1470600 */     // No operand predicates
     /* 1470600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470604 */     // MIs[0] policy
     /* 1470604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470644 */     // GIR_Coverage, 14546,
     /* 1470644 */     GIR_EraseRootFromParent_Done,
     /* 1470645 */   // Label 20611: @1470645
     /* 1470645 */   GIM_Try, /*On fail goto*//*Label 20612*/ GIMT_Encode4(1470745), // Rule ID 14547 //
     /* 1470650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1470661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1470664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1470667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1470673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1470680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1470688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470700 */     // MIs[1] Operand 1
     /* 1470700 */     // No operand predicates
     /* 1470700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470704 */     // MIs[0] policy
     /* 1470704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1470719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470744 */     // GIR_Coverage, 14547,
     /* 1470744 */     GIR_EraseRootFromParent_Done,
     /* 1470745 */   // Label 20612: @1470745
     /* 1470745 */   GIM_Try, /*On fail goto*//*Label 20613*/ GIMT_Encode4(1470845), // Rule ID 14550 //
     /* 1470750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1470761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1470764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1470767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470800 */     // MIs[1] Operand 1
     /* 1470800 */     // No operand predicates
     /* 1470800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470804 */     // MIs[0] policy
     /* 1470804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470844 */     // GIR_Coverage, 14550,
     /* 1470844 */     GIR_EraseRootFromParent_Done,
     /* 1470845 */   // Label 20613: @1470845
     /* 1470845 */   GIM_Try, /*On fail goto*//*Label 20614*/ GIMT_Encode4(1470945), // Rule ID 14551 //
     /* 1470850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1470861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1470864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1470867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1470873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1470880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1470888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1470900 */     // MIs[1] Operand 1
     /* 1470900 */     // No operand predicates
     /* 1470900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470904 */     // MIs[0] policy
     /* 1470904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470916 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1470919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1470923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1470943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470944 */     // GIR_Coverage, 14551,
     /* 1470944 */     GIR_EraseRootFromParent_Done,
     /* 1470945 */   // Label 20614: @1470945
     /* 1470945 */   GIM_Try, /*On fail goto*//*Label 20615*/ GIMT_Encode4(1471045), // Rule ID 14554 //
     /* 1470950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1470958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1470961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1470964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1470967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1470973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1470980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1470988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471000 */     // MIs[1] Operand 1
     /* 1471000 */     // No operand predicates
     /* 1471000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471004 */     // MIs[0] policy
     /* 1471004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471016 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471044 */     // GIR_Coverage, 14554,
     /* 1471044 */     GIR_EraseRootFromParent_Done,
     /* 1471045 */   // Label 20615: @1471045
     /* 1471045 */   GIM_Try, /*On fail goto*//*Label 20616*/ GIMT_Encode4(1471145), // Rule ID 14555 //
     /* 1471050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1471061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1471064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1471067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1471073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471100 */     // MIs[1] Operand 1
     /* 1471100 */     // No operand predicates
     /* 1471100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471104 */     // MIs[0] policy
     /* 1471104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471116 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471144 */     // GIR_Coverage, 14555,
     /* 1471144 */     GIR_EraseRootFromParent_Done,
     /* 1471145 */   // Label 20616: @1471145
     /* 1471145 */   GIM_Try, /*On fail goto*//*Label 20617*/ GIMT_Encode4(1471245), // Rule ID 14558 //
     /* 1471150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1471167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471200 */     // MIs[1] Operand 1
     /* 1471200 */     // No operand predicates
     /* 1471200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471204 */     // MIs[0] policy
     /* 1471204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471244 */     // GIR_Coverage, 14558,
     /* 1471244 */     GIR_EraseRootFromParent_Done,
     /* 1471245 */   // Label 20617: @1471245
     /* 1471245 */   GIM_Try, /*On fail goto*//*Label 20618*/ GIMT_Encode4(1471345), // Rule ID 14559 //
     /* 1471250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1471261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1471264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1471267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471300 */     // MIs[1] Operand 1
     /* 1471300 */     // No operand predicates
     /* 1471300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471304 */     // MIs[0] policy
     /* 1471304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471344 */     // GIR_Coverage, 14559,
     /* 1471344 */     GIR_EraseRootFromParent_Done,
     /* 1471345 */   // Label 20618: @1471345
     /* 1471345 */   GIM_Try, /*On fail goto*//*Label 20619*/ GIMT_Encode4(1471445), // Rule ID 14562 //
     /* 1471350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1471367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471400 */     // MIs[1] Operand 1
     /* 1471400 */     // No operand predicates
     /* 1471400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471404 */     // MIs[0] policy
     /* 1471404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471444 */     // GIR_Coverage, 14562,
     /* 1471444 */     GIR_EraseRootFromParent_Done,
     /* 1471445 */   // Label 20619: @1471445
     /* 1471445 */   GIM_Try, /*On fail goto*//*Label 20620*/ GIMT_Encode4(1471545), // Rule ID 14563 //
     /* 1471450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1471461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1471464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1471467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471500 */     // MIs[1] Operand 1
     /* 1471500 */     // No operand predicates
     /* 1471500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471504 */     // MIs[0] policy
     /* 1471504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1471519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471544 */     // GIR_Coverage, 14563,
     /* 1471544 */     GIR_EraseRootFromParent_Done,
     /* 1471545 */   // Label 20620: @1471545
     /* 1471545 */   GIM_Try, /*On fail goto*//*Label 20621*/ GIMT_Encode4(1471645), // Rule ID 14566 //
     /* 1471550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1471561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1471564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1471567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471600 */     // MIs[1] Operand 1
     /* 1471600 */     // No operand predicates
     /* 1471600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471604 */     // MIs[0] policy
     /* 1471604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471616 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471644 */     // GIR_Coverage, 14566,
     /* 1471644 */     GIR_EraseRootFromParent_Done,
     /* 1471645 */   // Label 20621: @1471645
     /* 1471645 */   GIM_Try, /*On fail goto*//*Label 20622*/ GIMT_Encode4(1471745), // Rule ID 14567 //
     /* 1471650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1471661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1471664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1471667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1471680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1471688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471700 */     // MIs[1] Operand 1
     /* 1471700 */     // No operand predicates
     /* 1471700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471704 */     // MIs[0] policy
     /* 1471704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471716 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1471719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471738 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471744 */     // GIR_Coverage, 14567,
     /* 1471744 */     GIR_EraseRootFromParent_Done,
     /* 1471745 */   // Label 20622: @1471745
     /* 1471745 */   GIM_Try, /*On fail goto*//*Label 20623*/ GIMT_Encode4(1471845), // Rule ID 14570 //
     /* 1471750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1471753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1471761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1471764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1471767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471800 */     // MIs[1] Operand 1
     /* 1471800 */     // No operand predicates
     /* 1471800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471804 */     // MIs[0] policy
     /* 1471804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471844 */     // GIR_Coverage, 14570,
     /* 1471844 */     GIR_EraseRootFromParent_Done,
     /* 1471845 */   // Label 20623: @1471845
     /* 1471845 */   GIM_Try, /*On fail goto*//*Label 20624*/ GIMT_Encode4(1471945), // Rule ID 14571 //
     /* 1471850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1471853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1471861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1471864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1471867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1471880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1471888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1471900 */     // MIs[1] Operand 1
     /* 1471900 */     // No operand predicates
     /* 1471900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471904 */     // MIs[0] policy
     /* 1471904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1471919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1471923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1471943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471944 */     // GIR_Coverage, 14571,
     /* 1471944 */     GIR_EraseRootFromParent_Done,
     /* 1471945 */   // Label 20624: @1471945
     /* 1471945 */   GIM_Try, /*On fail goto*//*Label 20625*/ GIMT_Encode4(1472045), // Rule ID 14574 //
     /* 1471950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1471953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1471958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1471961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1471964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1471967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1471980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1471988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472000 */     // MIs[1] Operand 1
     /* 1472000 */     // No operand predicates
     /* 1472000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472004 */     // MIs[0] policy
     /* 1472004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1472019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472044 */     // GIR_Coverage, 14574,
     /* 1472044 */     GIR_EraseRootFromParent_Done,
     /* 1472045 */   // Label 20625: @1472045
     /* 1472045 */   GIM_Try, /*On fail goto*//*Label 20626*/ GIMT_Encode4(1472145), // Rule ID 14575 //
     /* 1472050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1472061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1472064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1472067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472100 */     // MIs[1] Operand 1
     /* 1472100 */     // No operand predicates
     /* 1472100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472104 */     // MIs[0] policy
     /* 1472104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1472119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472144 */     // GIR_Coverage, 14575,
     /* 1472144 */     GIR_EraseRootFromParent_Done,
     /* 1472145 */   // Label 20626: @1472145
     /* 1472145 */   GIM_Try, /*On fail goto*//*Label 20627*/ GIMT_Encode4(1472245), // Rule ID 14578 //
     /* 1472150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1472153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1472161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1472164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1472167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472200 */     // MIs[1] Operand 1
     /* 1472200 */     // No operand predicates
     /* 1472200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472204 */     // MIs[0] policy
     /* 1472204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472244 */     // GIR_Coverage, 14578,
     /* 1472244 */     GIR_EraseRootFromParent_Done,
     /* 1472245 */   // Label 20627: @1472245
     /* 1472245 */   GIM_Try, /*On fail goto*//*Label 20628*/ GIMT_Encode4(1472345), // Rule ID 14579 //
     /* 1472250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1472253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1472258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1472261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1472264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1472267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1472300 */     // MIs[1] Operand 1
     /* 1472300 */     // No operand predicates
     /* 1472300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472304 */     // MIs[0] policy
     /* 1472304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472316 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1472319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1472323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1472338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1472343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472344 */     // GIR_Coverage, 14579,
     /* 1472344 */     GIR_EraseRootFromParent_Done,
     /* 1472345 */   // Label 20628: @1472345
     /* 1472345 */   GIM_Try, /*On fail goto*//*Label 20629*/ GIMT_Encode4(1472442), // Rule ID 23698 //
     /* 1472350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1472361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1472364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1472367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472400 */     // MIs[1] Operand 1
     /* 1472400 */     // No operand predicates
     /* 1472400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472404 */     // MIs[0] policy
     /* 1472404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472416 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1472419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472438 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472441 */     // GIR_Coverage, 23698,
     /* 1472441 */     GIR_EraseRootFromParent_Done,
     /* 1472442 */   // Label 20629: @1472442
     /* 1472442 */   GIM_Try, /*On fail goto*//*Label 20630*/ GIMT_Encode4(1472539), // Rule ID 23699 //
     /* 1472447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1472458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1472461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1472464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472497 */     // MIs[1] Operand 1
     /* 1472497 */     // No operand predicates
     /* 1472497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472501 */     // MIs[0] policy
     /* 1472501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472513 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1472516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472538 */     // GIR_Coverage, 23699,
     /* 1472538 */     GIR_EraseRootFromParent_Done,
     /* 1472539 */   // Label 20630: @1472539
     /* 1472539 */   GIM_Try, /*On fail goto*//*Label 20631*/ GIMT_Encode4(1472636), // Rule ID 23702 //
     /* 1472544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1472555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1472558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1472561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472590 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472594 */     // MIs[1] Operand 1
     /* 1472594 */     // No operand predicates
     /* 1472594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472598 */     // MIs[0] policy
     /* 1472598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472610 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1472613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472632 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472635 */     // GIR_Coverage, 23702,
     /* 1472635 */     GIR_EraseRootFromParent_Done,
     /* 1472636 */   // Label 20631: @1472636
     /* 1472636 */   GIM_Try, /*On fail goto*//*Label 20632*/ GIMT_Encode4(1472733), // Rule ID 23703 //
     /* 1472641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1472652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1472655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1472658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1472664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472691 */     // MIs[1] Operand 1
     /* 1472691 */     // No operand predicates
     /* 1472691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472695 */     // MIs[0] policy
     /* 1472695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472707 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1472710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472732 */     // GIR_Coverage, 23703,
     /* 1472732 */     GIR_EraseRootFromParent_Done,
     /* 1472733 */   // Label 20632: @1472733
     /* 1472733 */   GIM_Try, /*On fail goto*//*Label 20633*/ GIMT_Encode4(1472830), // Rule ID 23706 //
     /* 1472738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1472749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1472752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1472755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472784 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472788 */     // MIs[1] Operand 1
     /* 1472788 */     // No operand predicates
     /* 1472788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472792 */     // MIs[0] policy
     /* 1472792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472804 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1472807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472826 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472829 */     // GIR_Coverage, 23706,
     /* 1472829 */     GIR_EraseRootFromParent_Done,
     /* 1472830 */   // Label 20633: @1472830
     /* 1472830 */   GIM_Try, /*On fail goto*//*Label 20634*/ GIMT_Encode4(1472927), // Rule ID 23707 //
     /* 1472835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1472846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1472849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1472852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1472858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472885 */     // MIs[1] Operand 1
     /* 1472885 */     // No operand predicates
     /* 1472885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472889 */     // MIs[0] policy
     /* 1472889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472901 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1472904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472926 */     // GIR_Coverage, 23707,
     /* 1472926 */     GIR_EraseRootFromParent_Done,
     /* 1472927 */   // Label 20634: @1472927
     /* 1472927 */   GIM_Try, /*On fail goto*//*Label 20635*/ GIMT_Encode4(1473024), // Rule ID 23710 //
     /* 1472932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1472940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1472943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1472946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1472949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1472955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1472962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1472970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472982 */     // MIs[1] Operand 1
     /* 1472982 */     // No operand predicates
     /* 1472982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472986 */     // MIs[0] policy
     /* 1472986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472998 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473020 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473023 */     // GIR_Coverage, 23710,
     /* 1473023 */     GIR_EraseRootFromParent_Done,
     /* 1473024 */   // Label 20635: @1473024
     /* 1473024 */   GIM_Try, /*On fail goto*//*Label 20636*/ GIMT_Encode4(1473121), // Rule ID 23711 //
     /* 1473029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1473040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1473043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1473046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473079 */     // MIs[1] Operand 1
     /* 1473079 */     // No operand predicates
     /* 1473079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473083 */     // MIs[0] policy
     /* 1473083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473095 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1473098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473120 */     // GIR_Coverage, 23711,
     /* 1473120 */     GIR_EraseRootFromParent_Done,
     /* 1473121 */   // Label 20636: @1473121
     /* 1473121 */   GIM_Try, /*On fail goto*//*Label 20637*/ GIMT_Encode4(1473218), // Rule ID 23714 //
     /* 1473126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1473143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473176 */     // MIs[1] Operand 1
     /* 1473176 */     // No operand predicates
     /* 1473176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473180 */     // MIs[0] policy
     /* 1473180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473192 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473214 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473217 */     // GIR_Coverage, 23714,
     /* 1473217 */     GIR_EraseRootFromParent_Done,
     /* 1473218 */   // Label 20637: @1473218
     /* 1473218 */   GIM_Try, /*On fail goto*//*Label 20638*/ GIMT_Encode4(1473315), // Rule ID 23715 //
     /* 1473223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1473234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1473237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1473240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473273 */     // MIs[1] Operand 1
     /* 1473273 */     // No operand predicates
     /* 1473273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473277 */     // MIs[0] policy
     /* 1473277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473289 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473314 */     // GIR_Coverage, 23715,
     /* 1473314 */     GIR_EraseRootFromParent_Done,
     /* 1473315 */   // Label 20638: @1473315
     /* 1473315 */   GIM_Try, /*On fail goto*//*Label 20639*/ GIMT_Encode4(1473412), // Rule ID 23718 //
     /* 1473320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1473337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473370 */     // MIs[1] Operand 1
     /* 1473370 */     // No operand predicates
     /* 1473370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473374 */     // MIs[0] policy
     /* 1473374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473408 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473411 */     // GIR_Coverage, 23718,
     /* 1473411 */     GIR_EraseRootFromParent_Done,
     /* 1473412 */   // Label 20639: @1473412
     /* 1473412 */   GIM_Try, /*On fail goto*//*Label 20640*/ GIMT_Encode4(1473509), // Rule ID 23719 //
     /* 1473417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1473428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1473431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1473434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1473440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473467 */     // MIs[1] Operand 1
     /* 1473467 */     // No operand predicates
     /* 1473467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473471 */     // MIs[0] policy
     /* 1473471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473483 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1473486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473508 */     // GIR_Coverage, 23719,
     /* 1473508 */     GIR_EraseRootFromParent_Done,
     /* 1473509 */   // Label 20640: @1473509
     /* 1473509 */   GIM_Try, /*On fail goto*//*Label 20641*/ GIMT_Encode4(1473606), // Rule ID 23722 //
     /* 1473514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1473525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1473528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1473531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473564 */     // MIs[1] Operand 1
     /* 1473564 */     // No operand predicates
     /* 1473564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473568 */     // MIs[0] policy
     /* 1473568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473580 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473602 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473605 */     // GIR_Coverage, 23722,
     /* 1473605 */     GIR_EraseRootFromParent_Done,
     /* 1473606 */   // Label 20641: @1473606
     /* 1473606 */   GIM_Try, /*On fail goto*//*Label 20642*/ GIMT_Encode4(1473703), // Rule ID 23723 //
     /* 1473611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1473622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1473625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1473628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473661 */     // MIs[1] Operand 1
     /* 1473661 */     // No operand predicates
     /* 1473661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473665 */     // MIs[0] policy
     /* 1473665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1473699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473702 */     // GIR_Coverage, 23723,
     /* 1473702 */     GIR_EraseRootFromParent_Done,
     /* 1473703 */   // Label 20642: @1473703
     /* 1473703 */   GIM_Try, /*On fail goto*//*Label 20643*/ GIMT_Encode4(1473800), // Rule ID 23726 //
     /* 1473708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1473719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1473722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1473725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473758 */     // MIs[1] Operand 1
     /* 1473758 */     // No operand predicates
     /* 1473758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473762 */     // MIs[0] policy
     /* 1473762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473796 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473799 */     // GIR_Coverage, 23726,
     /* 1473799 */     GIR_EraseRootFromParent_Done,
     /* 1473800 */   // Label 20643: @1473800
     /* 1473800 */   GIM_Try, /*On fail goto*//*Label 20644*/ GIMT_Encode4(1473897), // Rule ID 23727 //
     /* 1473805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1473816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1473819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1473822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473855 */     // MIs[1] Operand 1
     /* 1473855 */     // No operand predicates
     /* 1473855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473859 */     // MIs[0] policy
     /* 1473859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473871 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473896 */     // GIR_Coverage, 23727,
     /* 1473896 */     GIR_EraseRootFromParent_Done,
     /* 1473897 */   // Label 20644: @1473897
     /* 1473897 */   GIM_Try, /*On fail goto*//*Label 20645*/ GIMT_Encode4(1473994), // Rule ID 23730 //
     /* 1473902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1473910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1473913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1473916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1473919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1473932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1473940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473952 */     // MIs[1] Operand 1
     /* 1473952 */     // No operand predicates
     /* 1473952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473956 */     // MIs[0] policy
     /* 1473956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473968 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1473971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473990 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473993 */     // GIR_Coverage, 23730,
     /* 1473993 */     GIR_EraseRootFromParent_Done,
     /* 1473994 */   // Label 20645: @1473994
     /* 1473994 */   GIM_Try, /*On fail goto*//*Label 20646*/ GIMT_Encode4(1474091), // Rule ID 23731 //
     /* 1473999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1474010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1474013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1474016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474049 */     // MIs[1] Operand 1
     /* 1474049 */     // No operand predicates
     /* 1474049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474053 */     // MIs[0] policy
     /* 1474053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474065 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474090 */     // GIR_Coverage, 23731,
     /* 1474090 */     GIR_EraseRootFromParent_Done,
     /* 1474091 */   // Label 20646: @1474091
     /* 1474091 */   GIM_Try, /*On fail goto*//*Label 20647*/ GIMT_Encode4(1474188), // Rule ID 23734 //
     /* 1474096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1474099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1474107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1474110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1474113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474142 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474146 */     // MIs[1] Operand 1
     /* 1474146 */     // No operand predicates
     /* 1474146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474150 */     // MIs[0] policy
     /* 1474150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474187 */     // GIR_Coverage, 23734,
     /* 1474187 */     GIR_EraseRootFromParent_Done,
     /* 1474188 */   // Label 20647: @1474188
     /* 1474188 */   GIM_Try, /*On fail goto*//*Label 20648*/ GIMT_Encode4(1474285), // Rule ID 23735 //
     /* 1474193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1474196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1474204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1474207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1474210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474243 */     // MIs[1] Operand 1
     /* 1474243 */     // No operand predicates
     /* 1474243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474247 */     // MIs[0] policy
     /* 1474247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474259 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474284 */     // GIR_Coverage, 23735,
     /* 1474284 */     GIR_EraseRootFromParent_Done,
     /* 1474285 */   // Label 20648: @1474285
     /* 1474285 */   GIM_Try, /*On fail goto*//*Label 20649*/ GIMT_Encode4(1474382), // Rule ID 23738 //
     /* 1474290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1474301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1474304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1474307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474340 */     // MIs[1] Operand 1
     /* 1474340 */     // No operand predicates
     /* 1474340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474344 */     // MIs[0] policy
     /* 1474344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474381 */     // GIR_Coverage, 23738,
     /* 1474381 */     GIR_EraseRootFromParent_Done,
     /* 1474382 */   // Label 20649: @1474382
     /* 1474382 */   GIM_Try, /*On fail goto*//*Label 20650*/ GIMT_Encode4(1474479), // Rule ID 23739 //
     /* 1474387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1474398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1474401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1474404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1474410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474437 */     // MIs[1] Operand 1
     /* 1474437 */     // No operand predicates
     /* 1474437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474441 */     // MIs[0] policy
     /* 1474441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474453 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474478 */     // GIR_Coverage, 23739,
     /* 1474478 */     GIR_EraseRootFromParent_Done,
     /* 1474479 */   // Label 20650: @1474479
     /* 1474479 */   GIM_Try, /*On fail goto*//*Label 20651*/ GIMT_Encode4(1474576), // Rule ID 23742 //
     /* 1474484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1474495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1474498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1474501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474534 */     // MIs[1] Operand 1
     /* 1474534 */     // No operand predicates
     /* 1474534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474538 */     // MIs[0] policy
     /* 1474538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474550 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1474553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474575 */     // GIR_Coverage, 23742,
     /* 1474575 */     GIR_EraseRootFromParent_Done,
     /* 1474576 */   // Label 20651: @1474576
     /* 1474576 */   GIM_Try, /*On fail goto*//*Label 20652*/ GIMT_Encode4(1474673), // Rule ID 23743 //
     /* 1474581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1474592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1474595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1474598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1474604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474631 */     // MIs[1] Operand 1
     /* 1474631 */     // No operand predicates
     /* 1474631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474635 */     // MIs[0] policy
     /* 1474635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474647 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1474650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474672 */     // GIR_Coverage, 23743,
     /* 1474672 */     GIR_EraseRootFromParent_Done,
     /* 1474673 */   // Label 20652: @1474673
     /* 1474673 */   GIM_Try, /*On fail goto*//*Label 20653*/ GIMT_Encode4(1474770), // Rule ID 23746 //
     /* 1474678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1474689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1474692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1474695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1474701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474728 */     // MIs[1] Operand 1
     /* 1474728 */     // No operand predicates
     /* 1474728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474732 */     // MIs[0] policy
     /* 1474732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474744 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1474747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474769 */     // GIR_Coverage, 23746,
     /* 1474769 */     GIR_EraseRootFromParent_Done,
     /* 1474770 */   // Label 20653: @1474770
     /* 1474770 */   GIM_Try, /*On fail goto*//*Label 20654*/ GIMT_Encode4(1474867), // Rule ID 23747 //
     /* 1474775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1474786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1474789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1474792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1474798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474825 */     // MIs[1] Operand 1
     /* 1474825 */     // No operand predicates
     /* 1474825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474829 */     // MIs[0] policy
     /* 1474829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474841 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1474844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1474863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474866 */     // GIR_Coverage, 23747,
     /* 1474866 */     GIR_EraseRootFromParent_Done,
     /* 1474867 */   // Label 20654: @1474867
     /* 1474867 */   GIM_Try, /*On fail goto*//*Label 20655*/ GIMT_Encode4(1474964), // Rule ID 23750 //
     /* 1474872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1474875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1474883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1474886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1474889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1474910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474922 */     // MIs[1] Operand 1
     /* 1474922 */     // No operand predicates
     /* 1474922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474926 */     // MIs[0] policy
     /* 1474926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1474941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474963 */     // GIR_Coverage, 23750,
     /* 1474963 */     GIR_EraseRootFromParent_Done,
     /* 1474964 */   // Label 20655: @1474964
     /* 1474964 */   GIM_Try, /*On fail goto*//*Label 20656*/ GIMT_Encode4(1475061), // Rule ID 23751 //
     /* 1474969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1474972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1474980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1474983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1474986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1474999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475019 */     // MIs[1] Operand 1
     /* 1475019 */     // No operand predicates
     /* 1475019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475023 */     // MIs[0] policy
     /* 1475023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475035 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475060 */     // GIR_Coverage, 23751,
     /* 1475060 */     GIR_EraseRootFromParent_Done,
     /* 1475061 */   // Label 20656: @1475061
     /* 1475061 */   GIM_Try, /*On fail goto*//*Label 20657*/ GIMT_Encode4(1475158), // Rule ID 23754 //
     /* 1475066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475116 */     // MIs[1] Operand 1
     /* 1475116 */     // No operand predicates
     /* 1475116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475120 */     // MIs[0] policy
     /* 1475120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475132 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475157 */     // GIR_Coverage, 23754,
     /* 1475157 */     GIR_EraseRootFromParent_Done,
     /* 1475158 */   // Label 20657: @1475158
     /* 1475158 */   GIM_Try, /*On fail goto*//*Label 20658*/ GIMT_Encode4(1475255), // Rule ID 23755 //
     /* 1475163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475213 */     // MIs[1] Operand 1
     /* 1475213 */     // No operand predicates
     /* 1475213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475217 */     // MIs[0] policy
     /* 1475217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475229 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475254 */     // GIR_Coverage, 23755,
     /* 1475254 */     GIR_EraseRootFromParent_Done,
     /* 1475255 */   // Label 20658: @1475255
     /* 1475255 */   GIM_Try, /*On fail goto*//*Label 20659*/ GIMT_Encode4(1475352), // Rule ID 23758 //
     /* 1475260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475310 */     // MIs[1] Operand 1
     /* 1475310 */     // No operand predicates
     /* 1475310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475314 */     // MIs[0] policy
     /* 1475314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475351 */     // GIR_Coverage, 23758,
     /* 1475351 */     GIR_EraseRootFromParent_Done,
     /* 1475352 */   // Label 20659: @1475352
     /* 1475352 */   GIM_Try, /*On fail goto*//*Label 20660*/ GIMT_Encode4(1475449), // Rule ID 23759 //
     /* 1475357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475407 */     // MIs[1] Operand 1
     /* 1475407 */     // No operand predicates
     /* 1475407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475411 */     // MIs[0] policy
     /* 1475411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475423 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475448 */     // GIR_Coverage, 23759,
     /* 1475448 */     GIR_EraseRootFromParent_Done,
     /* 1475449 */   // Label 20660: @1475449
     /* 1475449 */   GIM_Try, /*On fail goto*//*Label 20661*/ GIMT_Encode4(1475546), // Rule ID 23762 //
     /* 1475454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1475471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475504 */     // MIs[1] Operand 1
     /* 1475504 */     // No operand predicates
     /* 1475504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475508 */     // MIs[0] policy
     /* 1475508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475545 */     // GIR_Coverage, 23762,
     /* 1475545 */     GIR_EraseRootFromParent_Done,
     /* 1475546 */   // Label 20661: @1475546
     /* 1475546 */   GIM_Try, /*On fail goto*//*Label 20662*/ GIMT_Encode4(1475643), // Rule ID 23763 //
     /* 1475551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1475562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1475565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1475568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475601 */     // MIs[1] Operand 1
     /* 1475601 */     // No operand predicates
     /* 1475601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475605 */     // MIs[0] policy
     /* 1475605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475617 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475642 */     // GIR_Coverage, 23763,
     /* 1475642 */     GIR_EraseRootFromParent_Done,
     /* 1475643 */   // Label 20662: @1475643
     /* 1475643 */   GIM_Try, /*On fail goto*//*Label 20663*/ GIMT_Encode4(1475740), // Rule ID 23766 //
     /* 1475648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1475659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1475662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1475665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475698 */     // MIs[1] Operand 1
     /* 1475698 */     // No operand predicates
     /* 1475698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475702 */     // MIs[0] policy
     /* 1475702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475736 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475739 */     // GIR_Coverage, 23766,
     /* 1475739 */     GIR_EraseRootFromParent_Done,
     /* 1475740 */   // Label 20663: @1475740
     /* 1475740 */   GIM_Try, /*On fail goto*//*Label 20664*/ GIMT_Encode4(1475837), // Rule ID 23767 //
     /* 1475745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1475756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1475759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1475762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475795 */     // MIs[1] Operand 1
     /* 1475795 */     // No operand predicates
     /* 1475795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475799 */     // MIs[0] policy
     /* 1475799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475811 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475836 */     // GIR_Coverage, 23767,
     /* 1475836 */     GIR_EraseRootFromParent_Done,
     /* 1475837 */   // Label 20664: @1475837
     /* 1475837 */   GIM_Try, /*On fail goto*//*Label 20665*/ GIMT_Encode4(1475934), // Rule ID 23770 //
     /* 1475842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1475845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1475853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1475856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1475859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475892 */     // MIs[1] Operand 1
     /* 1475892 */     // No operand predicates
     /* 1475892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475896 */     // MIs[0] policy
     /* 1475896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475930 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475933 */     // GIR_Coverage, 23770,
     /* 1475933 */     GIR_EraseRootFromParent_Done,
     /* 1475934 */   // Label 20665: @1475934
     /* 1475934 */   GIM_Try, /*On fail goto*//*Label 20666*/ GIMT_Encode4(1476031), // Rule ID 23771 //
     /* 1475939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1475942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1475950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1475953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1475956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475989 */     // MIs[1] Operand 1
     /* 1475989 */     // No operand predicates
     /* 1475989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475993 */     // MIs[0] policy
     /* 1475993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476005 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476030 */     // GIR_Coverage, 23771,
     /* 1476030 */     GIR_EraseRootFromParent_Done,
     /* 1476031 */   // Label 20666: @1476031
     /* 1476031 */   GIM_Try, /*On fail goto*//*Label 20667*/ GIMT_Encode4(1476128), // Rule ID 23774 //
     /* 1476036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476086 */     // MIs[1] Operand 1
     /* 1476086 */     // No operand predicates
     /* 1476086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476090 */     // MIs[0] policy
     /* 1476090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476124 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476127 */     // GIR_Coverage, 23774,
     /* 1476127 */     GIR_EraseRootFromParent_Done,
     /* 1476128 */   // Label 20667: @1476128
     /* 1476128 */   GIM_Try, /*On fail goto*//*Label 20668*/ GIMT_Encode4(1476225), // Rule ID 23775 //
     /* 1476133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476183 */     // MIs[1] Operand 1
     /* 1476183 */     // No operand predicates
     /* 1476183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476187 */     // MIs[0] policy
     /* 1476187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476199 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476224 */     // GIR_Coverage, 23775,
     /* 1476224 */     GIR_EraseRootFromParent_Done,
     /* 1476225 */   // Label 20668: @1476225
     /* 1476225 */   GIM_Try, /*On fail goto*//*Label 20669*/ GIMT_Encode4(1476322), // Rule ID 23778 //
     /* 1476230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476280 */     // MIs[1] Operand 1
     /* 1476280 */     // No operand predicates
     /* 1476280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476284 */     // MIs[0] policy
     /* 1476284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476321 */     // GIR_Coverage, 23778,
     /* 1476321 */     GIR_EraseRootFromParent_Done,
     /* 1476322 */   // Label 20669: @1476322
     /* 1476322 */   GIM_Try, /*On fail goto*//*Label 20670*/ GIMT_Encode4(1476419), // Rule ID 23779 //
     /* 1476327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476377 */     // MIs[1] Operand 1
     /* 1476377 */     // No operand predicates
     /* 1476377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476381 */     // MIs[0] policy
     /* 1476381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476418 */     // GIR_Coverage, 23779,
     /* 1476418 */     GIR_EraseRootFromParent_Done,
     /* 1476419 */   // Label 20670: @1476419
     /* 1476419 */   GIM_Try, /*On fail goto*//*Label 20671*/ GIMT_Encode4(1476516), // Rule ID 23782 //
     /* 1476424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1476427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1476435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1476438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1476441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476474 */     // MIs[1] Operand 1
     /* 1476474 */     // No operand predicates
     /* 1476474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476478 */     // MIs[0] policy
     /* 1476478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476490 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476512 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476515 */     // GIR_Coverage, 23782,
     /* 1476515 */     GIR_EraseRootFromParent_Done,
     /* 1476516 */   // Label 20671: @1476516
     /* 1476516 */   GIM_Try, /*On fail goto*//*Label 20672*/ GIMT_Encode4(1476613), // Rule ID 23783 //
     /* 1476521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1476524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1476532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1476535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1476538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476571 */     // MIs[1] Operand 1
     /* 1476571 */     // No operand predicates
     /* 1476571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476575 */     // MIs[0] policy
     /* 1476575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476587 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476612 */     // GIR_Coverage, 23783,
     /* 1476612 */     GIR_EraseRootFromParent_Done,
     /* 1476613 */   // Label 20672: @1476613
     /* 1476613 */   GIM_Try, /*On fail goto*//*Label 20673*/ GIMT_Encode4(1476710), // Rule ID 23874 //
     /* 1476618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1476629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1476632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1476635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476668 */     // MIs[1] Operand 1
     /* 1476668 */     // No operand predicates
     /* 1476668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476672 */     // MIs[0] policy
     /* 1476672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476684 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1476687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476706 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476709 */     // GIR_Coverage, 23874,
     /* 1476709 */     GIR_EraseRootFromParent_Done,
     /* 1476710 */   // Label 20673: @1476710
     /* 1476710 */   GIM_Try, /*On fail goto*//*Label 20674*/ GIMT_Encode4(1476807), // Rule ID 23875 //
     /* 1476715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1476726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1476729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1476732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1476738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476765 */     // MIs[1] Operand 1
     /* 1476765 */     // No operand predicates
     /* 1476765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476769 */     // MIs[0] policy
     /* 1476769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476781 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1476784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476806 */     // GIR_Coverage, 23875,
     /* 1476806 */     GIR_EraseRootFromParent_Done,
     /* 1476807 */   // Label 20674: @1476807
     /* 1476807 */   GIM_Try, /*On fail goto*//*Label 20675*/ GIMT_Encode4(1476904), // Rule ID 23878 //
     /* 1476812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1476815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1476823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1476826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1476829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476862 */     // MIs[1] Operand 1
     /* 1476862 */     // No operand predicates
     /* 1476862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476866 */     // MIs[0] policy
     /* 1476866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476878 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1476881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476900 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476903 */     // GIR_Coverage, 23878,
     /* 1476903 */     GIR_EraseRootFromParent_Done,
     /* 1476904 */   // Label 20675: @1476904
     /* 1476904 */   GIM_Try, /*On fail goto*//*Label 20676*/ GIMT_Encode4(1477001), // Rule ID 23879 //
     /* 1476909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1476912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1476917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1476920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1476923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1476926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1476939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1476947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476959 */     // MIs[1] Operand 1
     /* 1476959 */     // No operand predicates
     /* 1476959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476963 */     // MIs[0] policy
     /* 1476963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476975 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1476978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1476997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477000 */     // GIR_Coverage, 23879,
     /* 1477000 */     GIR_EraseRootFromParent_Done,
     /* 1477001 */   // Label 20676: @1477001
     /* 1477001 */   GIM_Try, /*On fail goto*//*Label 20677*/ GIMT_Encode4(1477098), // Rule ID 23882 //
     /* 1477006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1477017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1477020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1477023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477056 */     // MIs[1] Operand 1
     /* 1477056 */     // No operand predicates
     /* 1477056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477060 */     // MIs[0] policy
     /* 1477060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477072 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477094 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477097 */     // GIR_Coverage, 23882,
     /* 1477097 */     GIR_EraseRootFromParent_Done,
     /* 1477098 */   // Label 20677: @1477098
     /* 1477098 */   GIM_Try, /*On fail goto*//*Label 20678*/ GIMT_Encode4(1477195), // Rule ID 23883 //
     /* 1477103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1477114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1477117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1477120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477153 */     // MIs[1] Operand 1
     /* 1477153 */     // No operand predicates
     /* 1477153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477157 */     // MIs[0] policy
     /* 1477157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477169 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477194 */     // GIR_Coverage, 23883,
     /* 1477194 */     GIR_EraseRootFromParent_Done,
     /* 1477195 */   // Label 20678: @1477195
     /* 1477195 */   GIM_Try, /*On fail goto*//*Label 20679*/ GIMT_Encode4(1477292), // Rule ID 23886 //
     /* 1477200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477250 */     // MIs[1] Operand 1
     /* 1477250 */     // No operand predicates
     /* 1477250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477254 */     // MIs[0] policy
     /* 1477254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477288 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477291 */     // GIR_Coverage, 23886,
     /* 1477291 */     GIR_EraseRootFromParent_Done,
     /* 1477292 */   // Label 20679: @1477292
     /* 1477292 */   GIM_Try, /*On fail goto*//*Label 20680*/ GIMT_Encode4(1477389), // Rule ID 23887 //
     /* 1477297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477347 */     // MIs[1] Operand 1
     /* 1477347 */     // No operand predicates
     /* 1477347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477351 */     // MIs[0] policy
     /* 1477351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477363 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477388 */     // GIR_Coverage, 23887,
     /* 1477388 */     GIR_EraseRootFromParent_Done,
     /* 1477389 */   // Label 20680: @1477389
     /* 1477389 */   GIM_Try, /*On fail goto*//*Label 20681*/ GIMT_Encode4(1477486), // Rule ID 23890 //
     /* 1477394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477444 */     // MIs[1] Operand 1
     /* 1477444 */     // No operand predicates
     /* 1477444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477448 */     // MIs[0] policy
     /* 1477448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477460 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477482 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477485 */     // GIR_Coverage, 23890,
     /* 1477485 */     GIR_EraseRootFromParent_Done,
     /* 1477486 */   // Label 20681: @1477486
     /* 1477486 */   GIM_Try, /*On fail goto*//*Label 20682*/ GIMT_Encode4(1477583), // Rule ID 23891 //
     /* 1477491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477541 */     // MIs[1] Operand 1
     /* 1477541 */     // No operand predicates
     /* 1477541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477545 */     // MIs[0] policy
     /* 1477545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477557 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477582 */     // GIR_Coverage, 23891,
     /* 1477582 */     GIR_EraseRootFromParent_Done,
     /* 1477583 */   // Label 20682: @1477583
     /* 1477583 */   GIM_Try, /*On fail goto*//*Label 20683*/ GIMT_Encode4(1477680), // Rule ID 23894 //
     /* 1477588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1477605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477638 */     // MIs[1] Operand 1
     /* 1477638 */     // No operand predicates
     /* 1477638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477642 */     // MIs[0] policy
     /* 1477642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477676 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477679 */     // GIR_Coverage, 23894,
     /* 1477679 */     GIR_EraseRootFromParent_Done,
     /* 1477680 */   // Label 20683: @1477680
     /* 1477680 */   GIM_Try, /*On fail goto*//*Label 20684*/ GIMT_Encode4(1477777), // Rule ID 23895 //
     /* 1477685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1477702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477735 */     // MIs[1] Operand 1
     /* 1477735 */     // No operand predicates
     /* 1477735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477739 */     // MIs[0] policy
     /* 1477739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477751 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477776 */     // GIR_Coverage, 23895,
     /* 1477776 */     GIR_EraseRootFromParent_Done,
     /* 1477777 */   // Label 20684: @1477777
     /* 1477777 */   GIM_Try, /*On fail goto*//*Label 20685*/ GIMT_Encode4(1477874), // Rule ID 23898 //
     /* 1477782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1477793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1477796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1477799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477832 */     // MIs[1] Operand 1
     /* 1477832 */     // No operand predicates
     /* 1477832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477836 */     // MIs[0] policy
     /* 1477836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477848 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1477851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477873 */     // GIR_Coverage, 23898,
     /* 1477873 */     GIR_EraseRootFromParent_Done,
     /* 1477874 */   // Label 20685: @1477874
     /* 1477874 */   GIM_Try, /*On fail goto*//*Label 20686*/ GIMT_Encode4(1477971), // Rule ID 23899 //
     /* 1477879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1477882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1477890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1477893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1477896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477929 */     // MIs[1] Operand 1
     /* 1477929 */     // No operand predicates
     /* 1477929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477933 */     // MIs[0] policy
     /* 1477933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477945 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1477948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1477967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477970 */     // GIR_Coverage, 23899,
     /* 1477970 */     GIR_EraseRootFromParent_Done,
     /* 1477971 */   // Label 20686: @1477971
     /* 1477971 */   GIM_Try, /*On fail goto*//*Label 20687*/ GIMT_Encode4(1478068), // Rule ID 23902 //
     /* 1477976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1477979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1477987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1477990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1477993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478026 */     // MIs[1] Operand 1
     /* 1478026 */     // No operand predicates
     /* 1478026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478030 */     // MIs[0] policy
     /* 1478030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478042 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478067 */     // GIR_Coverage, 23902,
     /* 1478067 */     GIR_EraseRootFromParent_Done,
     /* 1478068 */   // Label 20687: @1478068
     /* 1478068 */   GIM_Try, /*On fail goto*//*Label 20688*/ GIMT_Encode4(1478165), // Rule ID 23903 //
     /* 1478073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1478084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1478087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1478090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478123 */     // MIs[1] Operand 1
     /* 1478123 */     // No operand predicates
     /* 1478123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478127 */     // MIs[0] policy
     /* 1478127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478139 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478164 */     // GIR_Coverage, 23903,
     /* 1478164 */     GIR_EraseRootFromParent_Done,
     /* 1478165 */   // Label 20688: @1478165
     /* 1478165 */   GIM_Try, /*On fail goto*//*Label 20689*/ GIMT_Encode4(1478262), // Rule ID 23906 //
     /* 1478170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1478181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478220 */     // MIs[1] Operand 1
     /* 1478220 */     // No operand predicates
     /* 1478220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478224 */     // MIs[0] policy
     /* 1478224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478261 */     // GIR_Coverage, 23906,
     /* 1478261 */     GIR_EraseRootFromParent_Done,
     /* 1478262 */   // Label 20689: @1478262
     /* 1478262 */   GIM_Try, /*On fail goto*//*Label 20690*/ GIMT_Encode4(1478359), // Rule ID 23907 //
     /* 1478267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1478278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478317 */     // MIs[1] Operand 1
     /* 1478317 */     // No operand predicates
     /* 1478317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478321 */     // MIs[0] policy
     /* 1478321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478333 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478342 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478358 */     // GIR_Coverage, 23907,
     /* 1478358 */     GIR_EraseRootFromParent_Done,
     /* 1478359 */   // Label 20690: @1478359
     /* 1478359 */   GIM_Try, /*On fail goto*//*Label 20691*/ GIMT_Encode4(1478456), // Rule ID 23910 //
     /* 1478364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1478367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478414 */     // MIs[1] Operand 1
     /* 1478414 */     // No operand predicates
     /* 1478414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478418 */     // MIs[0] policy
     /* 1478418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478430 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478455 */     // GIR_Coverage, 23910,
     /* 1478455 */     GIR_EraseRootFromParent_Done,
     /* 1478456 */   // Label 20691: @1478456
     /* 1478456 */   GIM_Try, /*On fail goto*//*Label 20692*/ GIMT_Encode4(1478553), // Rule ID 23911 //
     /* 1478461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1478464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478511 */     // MIs[1] Operand 1
     /* 1478511 */     // No operand predicates
     /* 1478511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478515 */     // MIs[0] policy
     /* 1478515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478552 */     // GIR_Coverage, 23911,
     /* 1478552 */     GIR_EraseRootFromParent_Done,
     /* 1478553 */   // Label 20692: @1478553
     /* 1478553 */   GIM_Try, /*On fail goto*//*Label 20693*/ GIMT_Encode4(1478650), // Rule ID 23914 //
     /* 1478558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1478569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1478572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1478575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1478581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478608 */     // MIs[1] Operand 1
     /* 1478608 */     // No operand predicates
     /* 1478608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478612 */     // MIs[0] policy
     /* 1478612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478624 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1478627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478649 */     // GIR_Coverage, 23914,
     /* 1478649 */     GIR_EraseRootFromParent_Done,
     /* 1478650 */   // Label 20693: @1478650
     /* 1478650 */   GIM_Try, /*On fail goto*//*Label 20694*/ GIMT_Encode4(1478747), // Rule ID 23915 //
     /* 1478655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1478666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1478669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1478672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1478678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478705 */     // MIs[1] Operand 1
     /* 1478705 */     // No operand predicates
     /* 1478705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478709 */     // MIs[0] policy
     /* 1478709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478721 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1478724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478746 */     // GIR_Coverage, 23915,
     /* 1478746 */     GIR_EraseRootFromParent_Done,
     /* 1478747 */   // Label 20694: @1478747
     /* 1478747 */   GIM_Try, /*On fail goto*//*Label 20695*/ GIMT_Encode4(1478844), // Rule ID 23918 //
     /* 1478752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1478763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1478766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1478769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1478775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478802 */     // MIs[1] Operand 1
     /* 1478802 */     // No operand predicates
     /* 1478802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478806 */     // MIs[0] policy
     /* 1478806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478818 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1478821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478843 */     // GIR_Coverage, 23918,
     /* 1478843 */     GIR_EraseRootFromParent_Done,
     /* 1478844 */   // Label 20695: @1478844
     /* 1478844 */   GIM_Try, /*On fail goto*//*Label 20696*/ GIMT_Encode4(1478941), // Rule ID 23919 //
     /* 1478849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1478852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1478860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1478863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1478866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1478872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478899 */     // MIs[1] Operand 1
     /* 1478899 */     // No operand predicates
     /* 1478899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478903 */     // MIs[0] policy
     /* 1478903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478915 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1478918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1478937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478940 */     // GIR_Coverage, 23919,
     /* 1478940 */     GIR_EraseRootFromParent_Done,
     /* 1478941 */   // Label 20696: @1478941
     /* 1478941 */   GIM_Try, /*On fail goto*//*Label 20697*/ GIMT_Encode4(1479038), // Rule ID 23922 //
     /* 1478946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1478949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1478957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1478960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1478963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1478969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1478976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478996 */     // MIs[1] Operand 1
     /* 1478996 */     // No operand predicates
     /* 1478996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479000 */     // MIs[0] policy
     /* 1479000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479037 */     // GIR_Coverage, 23922,
     /* 1479037 */     GIR_EraseRootFromParent_Done,
     /* 1479038 */   // Label 20697: @1479038
     /* 1479038 */   GIM_Try, /*On fail goto*//*Label 20698*/ GIMT_Encode4(1479135), // Rule ID 23923 //
     /* 1479043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1479054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1479057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1479060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1479066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479093 */     // MIs[1] Operand 1
     /* 1479093 */     // No operand predicates
     /* 1479093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479097 */     // MIs[0] policy
     /* 1479097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479109 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1479131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479134 */     // GIR_Coverage, 23923,
     /* 1479134 */     GIR_EraseRootFromParent_Done,
     /* 1479135 */   // Label 20698: @1479135
     /* 1479135 */   GIM_Try, /*On fail goto*//*Label 20699*/ GIMT_Encode4(1479232), // Rule ID 23926 //
     /* 1479140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479190 */     // MIs[1] Operand 1
     /* 1479190 */     // No operand predicates
     /* 1479190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479194 */     // MIs[0] policy
     /* 1479194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479231 */     // GIR_Coverage, 23926,
     /* 1479231 */     GIR_EraseRootFromParent_Done,
     /* 1479232 */   // Label 20699: @1479232
     /* 1479232 */   GIM_Try, /*On fail goto*//*Label 20700*/ GIMT_Encode4(1479329), // Rule ID 23927 //
     /* 1479237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1479248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1479251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1479254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479287 */     // MIs[1] Operand 1
     /* 1479287 */     // No operand predicates
     /* 1479287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479291 */     // MIs[0] policy
     /* 1479291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479303 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479328 */     // GIR_Coverage, 23927,
     /* 1479328 */     GIR_EraseRootFromParent_Done,
     /* 1479329 */   // Label 20700: @1479329
     /* 1479329 */   GIM_Try, /*On fail goto*//*Label 20701*/ GIMT_Encode4(1479426), // Rule ID 23930 //
     /* 1479334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1479351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479384 */     // MIs[1] Operand 1
     /* 1479384 */     // No operand predicates
     /* 1479384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479388 */     // MIs[0] policy
     /* 1479388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479422 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479425 */     // GIR_Coverage, 23930,
     /* 1479425 */     GIR_EraseRootFromParent_Done,
     /* 1479426 */   // Label 20701: @1479426
     /* 1479426 */   GIM_Try, /*On fail goto*//*Label 20702*/ GIMT_Encode4(1479523), // Rule ID 23931 //
     /* 1479431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1479442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1479445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1479448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479481 */     // MIs[1] Operand 1
     /* 1479481 */     // No operand predicates
     /* 1479481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479485 */     // MIs[0] policy
     /* 1479485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479497 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479522 */     // GIR_Coverage, 23931,
     /* 1479522 */     GIR_EraseRootFromParent_Done,
     /* 1479523 */   // Label 20702: @1479523
     /* 1479523 */   GIM_Try, /*On fail goto*//*Label 20703*/ GIMT_Encode4(1479620), // Rule ID 23934 //
     /* 1479528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1479539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1479542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1479545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479578 */     // MIs[1] Operand 1
     /* 1479578 */     // No operand predicates
     /* 1479578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479582 */     // MIs[0] policy
     /* 1479582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479594 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479616 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479619 */     // GIR_Coverage, 23934,
     /* 1479619 */     GIR_EraseRootFromParent_Done,
     /* 1479620 */   // Label 20703: @1479620
     /* 1479620 */   GIM_Try, /*On fail goto*//*Label 20704*/ GIMT_Encode4(1479717), // Rule ID 23935 //
     /* 1479625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1479636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1479639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1479642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1479648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479675 */     // MIs[1] Operand 1
     /* 1479675 */     // No operand predicates
     /* 1479675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479679 */     // MIs[0] policy
     /* 1479679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479691 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1479713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479716 */     // GIR_Coverage, 23935,
     /* 1479716 */     GIR_EraseRootFromParent_Done,
     /* 1479717 */   // Label 20704: @1479717
     /* 1479717 */   GIM_Try, /*On fail goto*//*Label 20705*/ GIMT_Encode4(1479814), // Rule ID 23938 //
     /* 1479722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1479733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1479736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1479739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479772 */     // MIs[1] Operand 1
     /* 1479772 */     // No operand predicates
     /* 1479772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479776 */     // MIs[0] policy
     /* 1479776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479788 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479810 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479813 */     // GIR_Coverage, 23938,
     /* 1479813 */     GIR_EraseRootFromParent_Done,
     /* 1479814 */   // Label 20705: @1479814
     /* 1479814 */   GIM_Try, /*On fail goto*//*Label 20706*/ GIMT_Encode4(1479911), // Rule ID 23939 //
     /* 1479819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1479822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1479830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1479833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1479836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479869 */     // MIs[1] Operand 1
     /* 1479869 */     // No operand predicates
     /* 1479869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479873 */     // MIs[0] policy
     /* 1479873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479885 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479910 */     // GIR_Coverage, 23939,
     /* 1479910 */     GIR_EraseRootFromParent_Done,
     /* 1479911 */   // Label 20706: @1479911
     /* 1479911 */   GIM_Try, /*On fail goto*//*Label 20707*/ GIMT_Encode4(1480008), // Rule ID 23942 //
     /* 1479916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1479919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1479927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1479930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1479933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479966 */     // MIs[1] Operand 1
     /* 1479966 */     // No operand predicates
     /* 1479966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479970 */     // MIs[0] policy
     /* 1479970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480004 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480007 */     // GIR_Coverage, 23942,
     /* 1480007 */     GIR_EraseRootFromParent_Done,
     /* 1480008 */   // Label 20707: @1480008
     /* 1480008 */   GIM_Try, /*On fail goto*//*Label 20708*/ GIMT_Encode4(1480105), // Rule ID 23943 //
     /* 1480013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1480024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1480027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1480030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480063 */     // MIs[1] Operand 1
     /* 1480063 */     // No operand predicates
     /* 1480063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480067 */     // MIs[0] policy
     /* 1480067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480079 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480104 */     // GIR_Coverage, 23943,
     /* 1480104 */     GIR_EraseRootFromParent_Done,
     /* 1480105 */   // Label 20708: @1480105
     /* 1480105 */   GIM_Try, /*On fail goto*//*Label 20709*/ GIMT_Encode4(1480202), // Rule ID 23946 //
     /* 1480110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480160 */     // MIs[1] Operand 1
     /* 1480160 */     // No operand predicates
     /* 1480160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480164 */     // MIs[0] policy
     /* 1480164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480198 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480201 */     // GIR_Coverage, 23946,
     /* 1480201 */     GIR_EraseRootFromParent_Done,
     /* 1480202 */   // Label 20709: @1480202
     /* 1480202 */   GIM_Try, /*On fail goto*//*Label 20710*/ GIMT_Encode4(1480299), // Rule ID 23947 //
     /* 1480207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1480218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1480221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1480224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1480230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480257 */     // MIs[1] Operand 1
     /* 1480257 */     // No operand predicates
     /* 1480257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480261 */     // MIs[0] policy
     /* 1480261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480273 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1480295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480298 */     // GIR_Coverage, 23947,
     /* 1480298 */     GIR_EraseRootFromParent_Done,
     /* 1480299 */   // Label 20710: @1480299
     /* 1480299 */   GIM_Try, /*On fail goto*//*Label 20711*/ GIMT_Encode4(1480396), // Rule ID 23950 //
     /* 1480304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1480321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480354 */     // MIs[1] Operand 1
     /* 1480354 */     // No operand predicates
     /* 1480354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480358 */     // MIs[0] policy
     /* 1480358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480370 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480392 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480395 */     // GIR_Coverage, 23950,
     /* 1480395 */     GIR_EraseRootFromParent_Done,
     /* 1480396 */   // Label 20711: @1480396
     /* 1480396 */   GIM_Try, /*On fail goto*//*Label 20712*/ GIMT_Encode4(1480493), // Rule ID 23951 //
     /* 1480401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1480412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1480415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1480418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1480431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1480439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480451 */     // MIs[1] Operand 1
     /* 1480451 */     // No operand predicates
     /* 1480451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480455 */     // MIs[0] policy
     /* 1480455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480467 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1480470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480492 */     // GIR_Coverage, 23951,
     /* 1480492 */     GIR_EraseRootFromParent_Done,
     /* 1480493 */   // Label 20712: @1480493
     /* 1480493 */   GIM_Try, /*On fail goto*//*Label 20713*/ GIMT_Encode4(1480590), // Rule ID 23954 //
     /* 1480498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1480509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1480512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1480515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480548 */     // MIs[1] Operand 1
     /* 1480548 */     // No operand predicates
     /* 1480548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480552 */     // MIs[0] policy
     /* 1480552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480564 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480586 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480589 */     // GIR_Coverage, 23954,
     /* 1480589 */     GIR_EraseRootFromParent_Done,
     /* 1480590 */   // Label 20713: @1480590
     /* 1480590 */   GIM_Try, /*On fail goto*//*Label 20714*/ GIMT_Encode4(1480687), // Rule ID 23955 //
     /* 1480595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1480606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1480609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1480612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1480625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1480633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480645 */     // MIs[1] Operand 1
     /* 1480645 */     // No operand predicates
     /* 1480645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480649 */     // MIs[0] policy
     /* 1480649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480661 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1480664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480686 */     // GIR_Coverage, 23955,
     /* 1480686 */     GIR_EraseRootFromParent_Done,
     /* 1480687 */   // Label 20714: @1480687
     /* 1480687 */   GIM_Try, /*On fail goto*//*Label 20715*/ GIMT_Encode4(1480784), // Rule ID 23958 //
     /* 1480692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1480695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1480703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1480706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1480709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480742 */     // MIs[1] Operand 1
     /* 1480742 */     // No operand predicates
     /* 1480742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480746 */     // MIs[0] policy
     /* 1480746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480758 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480780 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480783 */     // GIR_Coverage, 23958,
     /* 1480783 */     GIR_EraseRootFromParent_Done,
     /* 1480784 */   // Label 20715: @1480784
     /* 1480784 */   GIM_Try, /*On fail goto*//*Label 20716*/ GIMT_Encode4(1480881), // Rule ID 23959 //
     /* 1480789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1480792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1480800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1480803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1480806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480839 */     // MIs[1] Operand 1
     /* 1480839 */     // No operand predicates
     /* 1480839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480843 */     // MIs[0] policy
     /* 1480843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480855 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480880 */     // GIR_Coverage, 23959,
     /* 1480880 */     GIR_EraseRootFromParent_Done,
     /* 1480881 */   // Label 20716: @1480881
     /* 1480881 */   GIM_Try, /*On fail goto*//*Label 20717*/ GIMT_Encode4(1480978), // Rule ID 24198 //
     /* 1480886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1480889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1480897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1480900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1480903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480936 */     // MIs[1] Operand 1
     /* 1480936 */     // No operand predicates
     /* 1480936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480940 */     // MIs[0] policy
     /* 1480940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480952 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1480955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480974 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480977 */     // GIR_Coverage, 24198,
     /* 1480977 */     GIR_EraseRootFromParent_Done,
     /* 1480978 */   // Label 20717: @1480978
     /* 1480978 */   GIM_Try, /*On fail goto*//*Label 20718*/ GIMT_Encode4(1481075), // Rule ID 24199 //
     /* 1480983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1480986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1480991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1480994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1480997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1481000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481033 */     // MIs[1] Operand 1
     /* 1481033 */     // No operand predicates
     /* 1481033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481037 */     // MIs[0] policy
     /* 1481037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481049 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1481052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481074 */     // GIR_Coverage, 24199,
     /* 1481074 */     GIR_EraseRootFromParent_Done,
     /* 1481075 */   // Label 20718: @1481075
     /* 1481075 */   GIM_Try, /*On fail goto*//*Label 20719*/ GIMT_Encode4(1481172), // Rule ID 24202 //
     /* 1481080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1481083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481130 */     // MIs[1] Operand 1
     /* 1481130 */     // No operand predicates
     /* 1481130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481134 */     // MIs[0] policy
     /* 1481134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481146 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481168 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481171 */     // GIR_Coverage, 24202,
     /* 1481171 */     GIR_EraseRootFromParent_Done,
     /* 1481172 */   // Label 20719: @1481172
     /* 1481172 */   GIM_Try, /*On fail goto*//*Label 20720*/ GIMT_Encode4(1481269), // Rule ID 24203 //
     /* 1481177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1481180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481227 */     // MIs[1] Operand 1
     /* 1481227 */     // No operand predicates
     /* 1481227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481231 */     // MIs[0] policy
     /* 1481231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481243 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481268 */     // GIR_Coverage, 24203,
     /* 1481268 */     GIR_EraseRootFromParent_Done,
     /* 1481269 */   // Label 20720: @1481269
     /* 1481269 */   GIM_Try, /*On fail goto*//*Label 20721*/ GIMT_Encode4(1481366), // Rule ID 24206 //
     /* 1481274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1481277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481324 */     // MIs[1] Operand 1
     /* 1481324 */     // No operand predicates
     /* 1481324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481328 */     // MIs[0] policy
     /* 1481328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481340 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481365 */     // GIR_Coverage, 24206,
     /* 1481365 */     GIR_EraseRootFromParent_Done,
     /* 1481366 */   // Label 20721: @1481366
     /* 1481366 */   GIM_Try, /*On fail goto*//*Label 20722*/ GIMT_Encode4(1481463), // Rule ID 24207 //
     /* 1481371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1481374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481421 */     // MIs[1] Operand 1
     /* 1481421 */     // No operand predicates
     /* 1481421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481425 */     // MIs[0] policy
     /* 1481425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481437 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1481440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481462 */     // GIR_Coverage, 24207,
     /* 1481462 */     GIR_EraseRootFromParent_Done,
     /* 1481463 */   // Label 20722: @1481463
     /* 1481463 */   GIM_Try, /*On fail goto*//*Label 20723*/ GIMT_Encode4(1481560), // Rule ID 24210 //
     /* 1481468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1481471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481514 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481518 */     // MIs[1] Operand 1
     /* 1481518 */     // No operand predicates
     /* 1481518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481522 */     // MIs[0] policy
     /* 1481522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481534 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481559 */     // GIR_Coverage, 24210,
     /* 1481559 */     GIR_EraseRootFromParent_Done,
     /* 1481560 */   // Label 20723: @1481560
     /* 1481560 */   GIM_Try, /*On fail goto*//*Label 20724*/ GIMT_Encode4(1481657), // Rule ID 24211 //
     /* 1481565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1481568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481615 */     // MIs[1] Operand 1
     /* 1481615 */     // No operand predicates
     /* 1481615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481619 */     // MIs[0] policy
     /* 1481619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481631 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481656 */     // GIR_Coverage, 24211,
     /* 1481656 */     GIR_EraseRootFromParent_Done,
     /* 1481657 */   // Label 20724: @1481657
     /* 1481657 */   GIM_Try, /*On fail goto*//*Label 20725*/ GIMT_Encode4(1481754), // Rule ID 24214 //
     /* 1481662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1481665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1481673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1481676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1481679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481712 */     // MIs[1] Operand 1
     /* 1481712 */     // No operand predicates
     /* 1481712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481716 */     // MIs[0] policy
     /* 1481716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481728 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481753 */     // GIR_Coverage, 24214,
     /* 1481753 */     GIR_EraseRootFromParent_Done,
     /* 1481754 */   // Label 20725: @1481754
     /* 1481754 */   GIM_Try, /*On fail goto*//*Label 20726*/ GIMT_Encode4(1481851), // Rule ID 24215 //
     /* 1481759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1481762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1481770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1481773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1481776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481809 */     // MIs[1] Operand 1
     /* 1481809 */     // No operand predicates
     /* 1481809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481813 */     // MIs[0] policy
     /* 1481813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481825 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481850 */     // GIR_Coverage, 24215,
     /* 1481850 */     GIR_EraseRootFromParent_Done,
     /* 1481851 */   // Label 20726: @1481851
     /* 1481851 */   GIM_Try, /*On fail goto*//*Label 20727*/ GIMT_Encode4(1481948), // Rule ID 24218 //
     /* 1481856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1481859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1481867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1481870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1481873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481902 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481906 */     // MIs[1] Operand 1
     /* 1481906 */     // No operand predicates
     /* 1481906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481910 */     // MIs[0] policy
     /* 1481910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481922 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1481925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1481929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481947 */     // GIR_Coverage, 24218,
     /* 1481947 */     GIR_EraseRootFromParent_Done,
     /* 1481948 */   // Label 20727: @1481948
     /* 1481948 */   GIM_Try, /*On fail goto*//*Label 20728*/ GIMT_Encode4(1482045), // Rule ID 24219 //
     /* 1481953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1481956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1481961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1481964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1481967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1481970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482003 */     // MIs[1] Operand 1
     /* 1482003 */     // No operand predicates
     /* 1482003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482007 */     // MIs[0] policy
     /* 1482007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482019 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1482022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482044 */     // GIR_Coverage, 24219,
     /* 1482044 */     GIR_EraseRootFromParent_Done,
     /* 1482045 */   // Label 20728: @1482045
     /* 1482045 */   GIM_Try, /*On fail goto*//*Label 20729*/ GIMT_Encode4(1482142), // Rule ID 24222 //
     /* 1482050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1482053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482100 */     // MIs[1] Operand 1
     /* 1482100 */     // No operand predicates
     /* 1482100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482104 */     // MIs[0] policy
     /* 1482104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482116 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482141 */     // GIR_Coverage, 24222,
     /* 1482141 */     GIR_EraseRootFromParent_Done,
     /* 1482142 */   // Label 20729: @1482142
     /* 1482142 */   GIM_Try, /*On fail goto*//*Label 20730*/ GIMT_Encode4(1482239), // Rule ID 24223 //
     /* 1482147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1482150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482197 */     // MIs[1] Operand 1
     /* 1482197 */     // No operand predicates
     /* 1482197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482201 */     // MIs[0] policy
     /* 1482201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482213 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482238 */     // GIR_Coverage, 24223,
     /* 1482238 */     GIR_EraseRootFromParent_Done,
     /* 1482239 */   // Label 20730: @1482239
     /* 1482239 */   GIM_Try, /*On fail goto*//*Label 20731*/ GIMT_Encode4(1482336), // Rule ID 24226 //
     /* 1482244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1482247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482294 */     // MIs[1] Operand 1
     /* 1482294 */     // No operand predicates
     /* 1482294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482298 */     // MIs[0] policy
     /* 1482298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482310 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482335 */     // GIR_Coverage, 24226,
     /* 1482335 */     GIR_EraseRootFromParent_Done,
     /* 1482336 */   // Label 20731: @1482336
     /* 1482336 */   GIM_Try, /*On fail goto*//*Label 20732*/ GIMT_Encode4(1482433), // Rule ID 24227 //
     /* 1482341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1482344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482391 */     // MIs[1] Operand 1
     /* 1482391 */     // No operand predicates
     /* 1482391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482395 */     // MIs[0] policy
     /* 1482395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482407 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482432 */     // GIR_Coverage, 24227,
     /* 1482432 */     GIR_EraseRootFromParent_Done,
     /* 1482433 */   // Label 20732: @1482433
     /* 1482433 */   GIM_Try, /*On fail goto*//*Label 20733*/ GIMT_Encode4(1482530), // Rule ID 24230 //
     /* 1482438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1482441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1482449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1482452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1482455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482488 */     // MIs[1] Operand 1
     /* 1482488 */     // No operand predicates
     /* 1482488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482492 */     // MIs[0] policy
     /* 1482492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482504 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1482507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482529 */     // GIR_Coverage, 24230,
     /* 1482529 */     GIR_EraseRootFromParent_Done,
     /* 1482530 */   // Label 20733: @1482530
     /* 1482530 */   GIM_Try, /*On fail goto*//*Label 20734*/ GIMT_Encode4(1482627), // Rule ID 24231 //
     /* 1482535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1482538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1482546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1482549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1482552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482585 */     // MIs[1] Operand 1
     /* 1482585 */     // No operand predicates
     /* 1482585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482589 */     // MIs[0] policy
     /* 1482589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482601 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1482604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482626 */     // GIR_Coverage, 24231,
     /* 1482626 */     GIR_EraseRootFromParent_Done,
     /* 1482627 */   // Label 20734: @1482627
     /* 1482627 */   GIM_Try, /*On fail goto*//*Label 20735*/ GIMT_Encode4(1482724), // Rule ID 24234 //
     /* 1482632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1482635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1482643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1482646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1482649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482682 */     // MIs[1] Operand 1
     /* 1482682 */     // No operand predicates
     /* 1482682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482686 */     // MIs[0] policy
     /* 1482686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482698 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482723 */     // GIR_Coverage, 24234,
     /* 1482723 */     GIR_EraseRootFromParent_Done,
     /* 1482724 */   // Label 20735: @1482724
     /* 1482724 */   GIM_Try, /*On fail goto*//*Label 20736*/ GIMT_Encode4(1482821), // Rule ID 24235 //
     /* 1482729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1482732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1482740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1482743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1482746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1482752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482779 */     // MIs[1] Operand 1
     /* 1482779 */     // No operand predicates
     /* 1482779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482783 */     // MIs[0] policy
     /* 1482783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482795 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1482798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482820 */     // GIR_Coverage, 24235,
     /* 1482820 */     GIR_EraseRootFromParent_Done,
     /* 1482821 */   // Label 20736: @1482821
     /* 1482821 */   GIM_Try, /*On fail goto*//*Label 20737*/ GIMT_Encode4(1482918), // Rule ID 24238 //
     /* 1482826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1482829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1482837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1482840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1482843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482876 */     // MIs[1] Operand 1
     /* 1482876 */     // No operand predicates
     /* 1482876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482880 */     // MIs[0] policy
     /* 1482880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482892 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1482914 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482917 */     // GIR_Coverage, 24238,
     /* 1482917 */     GIR_EraseRootFromParent_Done,
     /* 1482918 */   // Label 20737: @1482918
     /* 1482918 */   GIM_Try, /*On fail goto*//*Label 20738*/ GIMT_Encode4(1483015), // Rule ID 24239 //
     /* 1482923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1482926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1482931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1482934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1482937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1482940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482973 */     // MIs[1] Operand 1
     /* 1482973 */     // No operand predicates
     /* 1482973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482977 */     // MIs[0] policy
     /* 1482977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482989 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1482992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1482996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483014 */     // GIR_Coverage, 24239,
     /* 1483014 */     GIR_EraseRootFromParent_Done,
     /* 1483015 */   // Label 20738: @1483015
     /* 1483015 */   GIM_Try, /*On fail goto*//*Label 20739*/ GIMT_Encode4(1483112), // Rule ID 24242 //
     /* 1483020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1483023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483070 */     // MIs[1] Operand 1
     /* 1483070 */     // No operand predicates
     /* 1483070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483074 */     // MIs[0] policy
     /* 1483074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483086 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483108 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483111 */     // GIR_Coverage, 24242,
     /* 1483111 */     GIR_EraseRootFromParent_Done,
     /* 1483112 */   // Label 20739: @1483112
     /* 1483112 */   GIM_Try, /*On fail goto*//*Label 20740*/ GIMT_Encode4(1483209), // Rule ID 24243 //
     /* 1483117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1483120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483167 */     // MIs[1] Operand 1
     /* 1483167 */     // No operand predicates
     /* 1483167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483171 */     // MIs[0] policy
     /* 1483171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483183 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483208 */     // GIR_Coverage, 24243,
     /* 1483208 */     GIR_EraseRootFromParent_Done,
     /* 1483209 */   // Label 20740: @1483209
     /* 1483209 */   GIM_Try, /*On fail goto*//*Label 20741*/ GIMT_Encode4(1483306), // Rule ID 24246 //
     /* 1483214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1483217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483264 */     // MIs[1] Operand 1
     /* 1483264 */     // No operand predicates
     /* 1483264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483268 */     // MIs[0] policy
     /* 1483268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483280 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483302 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483305 */     // GIR_Coverage, 24246,
     /* 1483305 */     GIR_EraseRootFromParent_Done,
     /* 1483306 */   // Label 20741: @1483306
     /* 1483306 */   GIM_Try, /*On fail goto*//*Label 20742*/ GIMT_Encode4(1483403), // Rule ID 24247 //
     /* 1483311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1483314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483361 */     // MIs[1] Operand 1
     /* 1483361 */     // No operand predicates
     /* 1483361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483365 */     // MIs[0] policy
     /* 1483365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483377 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1483380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483402 */     // GIR_Coverage, 24247,
     /* 1483402 */     GIR_EraseRootFromParent_Done,
     /* 1483403 */   // Label 20742: @1483403
     /* 1483403 */   GIM_Try, /*On fail goto*//*Label 20743*/ GIMT_Encode4(1483500), // Rule ID 24250 //
     /* 1483408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1483411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1483425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483458 */     // MIs[1] Operand 1
     /* 1483458 */     // No operand predicates
     /* 1483458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483462 */     // MIs[0] policy
     /* 1483462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483474 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483499 */     // GIR_Coverage, 24250,
     /* 1483499 */     GIR_EraseRootFromParent_Done,
     /* 1483500 */   // Label 20743: @1483500
     /* 1483500 */   GIM_Try, /*On fail goto*//*Label 20744*/ GIMT_Encode4(1483597), // Rule ID 24251 //
     /* 1483505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1483508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1483516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1483519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1483522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483555 */     // MIs[1] Operand 1
     /* 1483555 */     // No operand predicates
     /* 1483555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483559 */     // MIs[0] policy
     /* 1483559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483571 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1483574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483596 */     // GIR_Coverage, 24251,
     /* 1483596 */     GIR_EraseRootFromParent_Done,
     /* 1483597 */   // Label 20744: @1483597
     /* 1483597 */   GIM_Try, /*On fail goto*//*Label 20745*/ GIMT_Encode4(1483694), // Rule ID 24254 //
     /* 1483602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1483605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1483613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1483616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1483619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483652 */     // MIs[1] Operand 1
     /* 1483652 */     // No operand predicates
     /* 1483652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483656 */     // MIs[0] policy
     /* 1483656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483668 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483690 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483693 */     // GIR_Coverage, 24254,
     /* 1483693 */     GIR_EraseRootFromParent_Done,
     /* 1483694 */   // Label 20745: @1483694
     /* 1483694 */   GIM_Try, /*On fail goto*//*Label 20746*/ GIMT_Encode4(1483791), // Rule ID 24255 //
     /* 1483699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1483702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1483707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1483710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1483713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1483716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483749 */     // MIs[1] Operand 1
     /* 1483749 */     // No operand predicates
     /* 1483749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483753 */     // MIs[0] policy
     /* 1483753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483765 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1483768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483790 */     // GIR_Coverage, 24255,
     /* 1483790 */     GIR_EraseRootFromParent_Done,
     /* 1483791 */   // Label 20746: @1483791
     /* 1483791 */   GIM_Try, /*On fail goto*//*Label 20747*/ GIMT_Encode4(1483888), // Rule ID 24318 //
     /* 1483796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1483799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1483807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1483810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1483813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1483819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1483826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483846 */     // MIs[1] Operand 1
     /* 1483846 */     // No operand predicates
     /* 1483846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483850 */     // MIs[0] policy
     /* 1483850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483862 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1483865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483884 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483887 */     // GIR_Coverage, 24318,
     /* 1483887 */     GIR_EraseRootFromParent_Done,
     /* 1483888 */   // Label 20747: @1483888
     /* 1483888 */   GIM_Try, /*On fail goto*//*Label 20748*/ GIMT_Encode4(1483985), // Rule ID 24319 //
     /* 1483893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1483896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1483904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1483907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1483910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1483916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1483923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1483931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483943 */     // MIs[1] Operand 1
     /* 1483943 */     // No operand predicates
     /* 1483943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483947 */     // MIs[0] policy
     /* 1483947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483959 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1483962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1483966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483984 */     // GIR_Coverage, 24319,
     /* 1483984 */     GIR_EraseRootFromParent_Done,
     /* 1483985 */   // Label 20748: @1483985
     /* 1483985 */   GIM_Try, /*On fail goto*//*Label 20749*/ GIMT_Encode4(1484082), // Rule ID 24322 //
     /* 1483990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1483993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1483998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1484001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1484004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1484007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484040 */     // MIs[1] Operand 1
     /* 1484040 */     // No operand predicates
     /* 1484040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484044 */     // MIs[0] policy
     /* 1484044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484056 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484078 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484081 */     // GIR_Coverage, 24322,
     /* 1484081 */     GIR_EraseRootFromParent_Done,
     /* 1484082 */   // Label 20749: @1484082
     /* 1484082 */   GIM_Try, /*On fail goto*//*Label 20750*/ GIMT_Encode4(1484179), // Rule ID 24323 //
     /* 1484087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1484090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1484098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1484101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1484104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484137 */     // MIs[1] Operand 1
     /* 1484137 */     // No operand predicates
     /* 1484137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484141 */     // MIs[0] policy
     /* 1484141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484153 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484178 */     // GIR_Coverage, 24323,
     /* 1484178 */     GIR_EraseRootFromParent_Done,
     /* 1484179 */   // Label 20750: @1484179
     /* 1484179 */   GIM_Try, /*On fail goto*//*Label 20751*/ GIMT_Encode4(1484276), // Rule ID 24326 //
     /* 1484184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1484187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484234 */     // MIs[1] Operand 1
     /* 1484234 */     // No operand predicates
     /* 1484234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484238 */     // MIs[0] policy
     /* 1484238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484250 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484272 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484275 */     // GIR_Coverage, 24326,
     /* 1484275 */     GIR_EraseRootFromParent_Done,
     /* 1484276 */   // Label 20751: @1484276
     /* 1484276 */   GIM_Try, /*On fail goto*//*Label 20752*/ GIMT_Encode4(1484373), // Rule ID 24327 //
     /* 1484281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1484284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484331 */     // MIs[1] Operand 1
     /* 1484331 */     // No operand predicates
     /* 1484331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484335 */     // MIs[0] policy
     /* 1484335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484347 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1484350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484372 */     // GIR_Coverage, 24327,
     /* 1484372 */     GIR_EraseRootFromParent_Done,
     /* 1484373 */   // Label 20752: @1484373
     /* 1484373 */   GIM_Try, /*On fail goto*//*Label 20753*/ GIMT_Encode4(1484470), // Rule ID 24330 //
     /* 1484378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1484381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1484395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484424 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484428 */     // MIs[1] Operand 1
     /* 1484428 */     // No operand predicates
     /* 1484428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484432 */     // MIs[0] policy
     /* 1484432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484444 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484466 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484469 */     // GIR_Coverage, 24330,
     /* 1484469 */     GIR_EraseRootFromParent_Done,
     /* 1484470 */   // Label 20753: @1484470
     /* 1484470 */   GIM_Try, /*On fail goto*//*Label 20754*/ GIMT_Encode4(1484567), // Rule ID 24331 //
     /* 1484475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1484478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1484486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1484489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1484492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484525 */     // MIs[1] Operand 1
     /* 1484525 */     // No operand predicates
     /* 1484525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484529 */     // MIs[0] policy
     /* 1484529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484541 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1484563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484566 */     // GIR_Coverage, 24331,
     /* 1484566 */     GIR_EraseRootFromParent_Done,
     /* 1484567 */   // Label 20754: @1484567
     /* 1484567 */   GIM_Try, /*On fail goto*//*Label 20755*/ GIMT_Encode4(1484664), // Rule ID 24334 //
     /* 1484572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1484575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1484583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1484586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1484589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484622 */     // MIs[1] Operand 1
     /* 1484622 */     // No operand predicates
     /* 1484622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484626 */     // MIs[0] policy
     /* 1484626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484638 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484660 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484663 */     // GIR_Coverage, 24334,
     /* 1484663 */     GIR_EraseRootFromParent_Done,
     /* 1484664 */   // Label 20755: @1484664
     /* 1484664 */   GIM_Try, /*On fail goto*//*Label 20756*/ GIMT_Encode4(1484761), // Rule ID 24335 //
     /* 1484669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1484672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1484680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1484683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1484686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484719 */     // MIs[1] Operand 1
     /* 1484719 */     // No operand predicates
     /* 1484719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484723 */     // MIs[0] policy
     /* 1484723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484735 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484760 */     // GIR_Coverage, 24335,
     /* 1484760 */     GIR_EraseRootFromParent_Done,
     /* 1484761 */   // Label 20756: @1484761
     /* 1484761 */   GIM_Try, /*On fail goto*//*Label 20757*/ GIMT_Encode4(1484858), // Rule ID 24338 //
     /* 1484766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1484769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1484777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1484780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1484783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484816 */     // MIs[1] Operand 1
     /* 1484816 */     // No operand predicates
     /* 1484816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484820 */     // MIs[0] policy
     /* 1484820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484832 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484854 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484857 */     // GIR_Coverage, 24338,
     /* 1484857 */     GIR_EraseRootFromParent_Done,
     /* 1484858 */   // Label 20757: @1484858
     /* 1484858 */   GIM_Try, /*On fail goto*//*Label 20758*/ GIMT_Encode4(1484955), // Rule ID 24339 //
     /* 1484863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1484866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1484874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1484877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1484880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484913 */     // MIs[1] Operand 1
     /* 1484913 */     // No operand predicates
     /* 1484913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484917 */     // MIs[0] policy
     /* 1484917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484929 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1484932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1484936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484954 */     // GIR_Coverage, 24339,
     /* 1484954 */     GIR_EraseRootFromParent_Done,
     /* 1484955 */   // Label 20758: @1484955
     /* 1484955 */   GIM_Try, /*On fail goto*//*Label 20759*/ GIMT_Encode4(1485052), // Rule ID 24342 //
     /* 1484960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1484963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1484968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1484971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1484974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1484977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1484990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1484998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485010 */     // MIs[1] Operand 1
     /* 1485010 */     // No operand predicates
     /* 1485010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485014 */     // MIs[0] policy
     /* 1485014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485026 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485051 */     // GIR_Coverage, 24342,
     /* 1485051 */     GIR_EraseRootFromParent_Done,
     /* 1485052 */   // Label 20759: @1485052
     /* 1485052 */   GIM_Try, /*On fail goto*//*Label 20760*/ GIMT_Encode4(1485149), // Rule ID 24343 //
     /* 1485057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1485060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1485068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1485071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1485074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485107 */     // MIs[1] Operand 1
     /* 1485107 */     // No operand predicates
     /* 1485107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485111 */     // MIs[0] policy
     /* 1485111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485123 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485148 */     // GIR_Coverage, 24343,
     /* 1485148 */     GIR_EraseRootFromParent_Done,
     /* 1485149 */   // Label 20760: @1485149
     /* 1485149 */   GIM_Try, /*On fail goto*//*Label 20761*/ GIMT_Encode4(1485246), // Rule ID 24346 //
     /* 1485154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1485157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1485165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1485168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1485171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485204 */     // MIs[1] Operand 1
     /* 1485204 */     // No operand predicates
     /* 1485204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485208 */     // MIs[0] policy
     /* 1485208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485220 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485245 */     // GIR_Coverage, 24346,
     /* 1485245 */     GIR_EraseRootFromParent_Done,
     /* 1485246 */   // Label 20761: @1485246
     /* 1485246 */   GIM_Try, /*On fail goto*//*Label 20762*/ GIMT_Encode4(1485343), // Rule ID 24347 //
     /* 1485251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1485254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1485262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1485265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1485268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485301 */     // MIs[1] Operand 1
     /* 1485301 */     // No operand predicates
     /* 1485301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485305 */     // MIs[0] policy
     /* 1485305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485317 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485326 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485342 */     // GIR_Coverage, 24347,
     /* 1485342 */     GIR_EraseRootFromParent_Done,
     /* 1485343 */   // Label 20762: @1485343
     /* 1485343 */   GIM_Try, /*On fail goto*//*Label 20763*/ GIMT_Encode4(1485440), // Rule ID 24350 //
     /* 1485348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1485351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1485359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1485362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1485365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1485371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485394 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485398 */     // MIs[1] Operand 1
     /* 1485398 */     // No operand predicates
     /* 1485398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485402 */     // MIs[0] policy
     /* 1485402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485414 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1485417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485439 */     // GIR_Coverage, 24350,
     /* 1485439 */     GIR_EraseRootFromParent_Done,
     /* 1485440 */   // Label 20763: @1485440
     /* 1485440 */   GIM_Try, /*On fail goto*//*Label 20764*/ GIMT_Encode4(1485537), // Rule ID 24351 //
     /* 1485445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1485448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1485456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1485459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1485462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1485468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485495 */     // MIs[1] Operand 1
     /* 1485495 */     // No operand predicates
     /* 1485495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485499 */     // MIs[0] policy
     /* 1485499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485511 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1485514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1485533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485536 */     // GIR_Coverage, 24351,
     /* 1485536 */     GIR_EraseRootFromParent_Done,
     /* 1485537 */   // Label 20764: @1485537
     /* 1485537 */   GIM_Try, /*On fail goto*//*Label 20765*/ GIMT_Encode4(1485634), // Rule ID 24354 //
     /* 1485542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1485545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1485553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1485556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1485559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485592 */     // MIs[1] Operand 1
     /* 1485592 */     // No operand predicates
     /* 1485592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485596 */     // MIs[0] policy
     /* 1485596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485608 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485633 */     // GIR_Coverage, 24354,
     /* 1485633 */     GIR_EraseRootFromParent_Done,
     /* 1485634 */   // Label 20765: @1485634
     /* 1485634 */   GIM_Try, /*On fail goto*//*Label 20766*/ GIMT_Encode4(1485731), // Rule ID 24355 //
     /* 1485639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1485642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1485650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1485653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1485656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485689 */     // MIs[1] Operand 1
     /* 1485689 */     // No operand predicates
     /* 1485689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485693 */     // MIs[0] policy
     /* 1485693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485705 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1485708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485730 */     // GIR_Coverage, 24355,
     /* 1485730 */     GIR_EraseRootFromParent_Done,
     /* 1485731 */   // Label 20766: @1485731
     /* 1485731 */   GIM_Try, /*On fail goto*//*Label 20767*/ GIMT_Encode4(1485828), // Rule ID 24358 //
     /* 1485736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1485739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1485747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1485750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1485753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485782 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485786 */     // MIs[1] Operand 1
     /* 1485786 */     // No operand predicates
     /* 1485786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485790 */     // MIs[0] policy
     /* 1485790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485802 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485827 */     // GIR_Coverage, 24358,
     /* 1485827 */     GIR_EraseRootFromParent_Done,
     /* 1485828 */   // Label 20767: @1485828
     /* 1485828 */   GIM_Try, /*On fail goto*//*Label 20768*/ GIMT_Encode4(1485925), // Rule ID 24359 //
     /* 1485833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1485836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1485844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1485847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1485850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485883 */     // MIs[1] Operand 1
     /* 1485883 */     // No operand predicates
     /* 1485883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485887 */     // MIs[0] policy
     /* 1485887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485899 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1485902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1485906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485924 */     // GIR_Coverage, 24359,
     /* 1485924 */     GIR_EraseRootFromParent_Done,
     /* 1485925 */   // Label 20768: @1485925
     /* 1485925 */   GIM_Try, /*On fail goto*//*Label 20769*/ GIMT_Encode4(1486022), // Rule ID 24362 //
     /* 1485930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1485933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1485938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1485941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1485944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1485947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485980 */     // MIs[1] Operand 1
     /* 1485980 */     // No operand predicates
     /* 1485980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485984 */     // MIs[0] policy
     /* 1485984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485996 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1485999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486021 */     // GIR_Coverage, 24362,
     /* 1486021 */     GIR_EraseRootFromParent_Done,
     /* 1486022 */   // Label 20769: @1486022
     /* 1486022 */   GIM_Try, /*On fail goto*//*Label 20770*/ GIMT_Encode4(1486119), // Rule ID 24363 //
     /* 1486027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1486030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1486038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1486041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1486044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486077 */     // MIs[1] Operand 1
     /* 1486077 */     // No operand predicates
     /* 1486077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486081 */     // MIs[0] policy
     /* 1486081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486093 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1486115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486118 */     // GIR_Coverage, 24363,
     /* 1486118 */     GIR_EraseRootFromParent_Done,
     /* 1486119 */   // Label 20770: @1486119
     /* 1486119 */   GIM_Try, /*On fail goto*//*Label 20771*/ GIMT_Encode4(1486216), // Rule ID 24366 //
     /* 1486124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1486127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1486135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1486138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1486141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486174 */     // MIs[1] Operand 1
     /* 1486174 */     // No operand predicates
     /* 1486174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486178 */     // MIs[0] policy
     /* 1486178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486190 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486215 */     // GIR_Coverage, 24366,
     /* 1486215 */     GIR_EraseRootFromParent_Done,
     /* 1486216 */   // Label 20771: @1486216
     /* 1486216 */   GIM_Try, /*On fail goto*//*Label 20772*/ GIMT_Encode4(1486313), // Rule ID 24367 //
     /* 1486221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1486224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1486232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1486235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1486238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486271 */     // MIs[1] Operand 1
     /* 1486271 */     // No operand predicates
     /* 1486271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486275 */     // MIs[0] policy
     /* 1486275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486287 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1486290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486312 */     // GIR_Coverage, 24367,
     /* 1486312 */     GIR_EraseRootFromParent_Done,
     /* 1486313 */   // Label 20772: @1486313
     /* 1486313 */   GIM_Try, /*On fail goto*//*Label 20773*/ GIMT_Encode4(1486410), // Rule ID 24370 //
     /* 1486318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1486321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1486329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1486332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1486335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486368 */     // MIs[1] Operand 1
     /* 1486368 */     // No operand predicates
     /* 1486368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486372 */     // MIs[0] policy
     /* 1486372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486384 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486409 */     // GIR_Coverage, 24370,
     /* 1486409 */     GIR_EraseRootFromParent_Done,
     /* 1486410 */   // Label 20773: @1486410
     /* 1486410 */   GIM_Try, /*On fail goto*//*Label 20774*/ GIMT_Encode4(1486507), // Rule ID 24371 //
     /* 1486415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1486418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1486426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1486429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1486432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486465 */     // MIs[1] Operand 1
     /* 1486465 */     // No operand predicates
     /* 1486465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486469 */     // MIs[0] policy
     /* 1486469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486481 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1486484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486506 */     // GIR_Coverage, 24371,
     /* 1486506 */     GIR_EraseRootFromParent_Done,
     /* 1486507 */   // Label 20774: @1486507
     /* 1486507 */   GIM_Try, /*On fail goto*//*Label 20775*/ GIMT_Encode4(1486604), // Rule ID 24374 //
     /* 1486512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1486515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1486523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1486526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1486529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486562 */     // MIs[1] Operand 1
     /* 1486562 */     // No operand predicates
     /* 1486562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486566 */     // MIs[0] policy
     /* 1486566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486578 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486600 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486603 */     // GIR_Coverage, 24374,
     /* 1486603 */     GIR_EraseRootFromParent_Done,
     /* 1486604 */   // Label 20775: @1486604
     /* 1486604 */   GIM_Try, /*On fail goto*//*Label 20776*/ GIMT_Encode4(1486701), // Rule ID 24375 //
     /* 1486609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1486612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1486617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1486620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1486623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1486626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486659 */     // MIs[1] Operand 1
     /* 1486659 */     // No operand predicates
     /* 1486659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486663 */     // MIs[0] policy
     /* 1486663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486675 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1486678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1486682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486700 */     // GIR_Coverage, 24375,
     /* 1486700 */     GIR_EraseRootFromParent_Done,
     /* 1486701 */   // Label 20776: @1486701
     /* 1486701 */   GIM_Try, /*On fail goto*//*Label 20777*/ GIMT_Encode4(1486798), // Rule ID 24674 //
     /* 1486706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1486717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1486720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1486723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486756 */     // MIs[1] Operand 1
     /* 1486756 */     // No operand predicates
     /* 1486756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486760 */     // MIs[0] policy
     /* 1486760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486772 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1486775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486794 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486797 */     // GIR_Coverage, 24674,
     /* 1486797 */     GIR_EraseRootFromParent_Done,
     /* 1486798 */   // Label 20777: @1486798
     /* 1486798 */   GIM_Try, /*On fail goto*//*Label 20778*/ GIMT_Encode4(1486895), // Rule ID 24675 //
     /* 1486803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1486806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1486814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1486817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1486820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486853 */     // MIs[1] Operand 1
     /* 1486853 */     // No operand predicates
     /* 1486853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486857 */     // MIs[0] policy
     /* 1486857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486869 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1486872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486894 */     // GIR_Coverage, 24675,
     /* 1486894 */     GIR_EraseRootFromParent_Done,
     /* 1486895 */   // Label 20778: @1486895
     /* 1486895 */   GIM_Try, /*On fail goto*//*Label 20779*/ GIMT_Encode4(1486992), // Rule ID 24678 //
     /* 1486900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1486903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1486911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1486914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1486917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486946 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486950 */     // MIs[1] Operand 1
     /* 1486950 */     // No operand predicates
     /* 1486950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486954 */     // MIs[0] policy
     /* 1486954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486966 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1486969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1486988 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486991 */     // GIR_Coverage, 24678,
     /* 1486991 */     GIR_EraseRootFromParent_Done,
     /* 1486992 */   // Label 20779: @1486992
     /* 1486992 */   GIM_Try, /*On fail goto*//*Label 20780*/ GIMT_Encode4(1487089), // Rule ID 24679 //
     /* 1486997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1487008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1487011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1487014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487047 */     // MIs[1] Operand 1
     /* 1487047 */     // No operand predicates
     /* 1487047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487051 */     // MIs[0] policy
     /* 1487051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487063 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487072 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487088 */     // GIR_Coverage, 24679,
     /* 1487088 */     GIR_EraseRootFromParent_Done,
     /* 1487089 */   // Label 20780: @1487089
     /* 1487089 */   GIM_Try, /*On fail goto*//*Label 20781*/ GIMT_Encode4(1487186), // Rule ID 24682 //
     /* 1487094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1487105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1487108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487144 */     // MIs[1] Operand 1
     /* 1487144 */     // No operand predicates
     /* 1487144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487148 */     // MIs[0] policy
     /* 1487148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487160 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487182 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487185 */     // GIR_Coverage, 24682,
     /* 1487185 */     GIR_EraseRootFromParent_Done,
     /* 1487186 */   // Label 20781: @1487186
     /* 1487186 */   GIM_Try, /*On fail goto*//*Label 20782*/ GIMT_Encode4(1487283), // Rule ID 24683 //
     /* 1487191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1487202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1487205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487241 */     // MIs[1] Operand 1
     /* 1487241 */     // No operand predicates
     /* 1487241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487245 */     // MIs[0] policy
     /* 1487245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487257 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487282 */     // GIR_Coverage, 24683,
     /* 1487282 */     GIR_EraseRootFromParent_Done,
     /* 1487283 */   // Label 20782: @1487283
     /* 1487283 */   GIM_Try, /*On fail goto*//*Label 20783*/ GIMT_Encode4(1487380), // Rule ID 24686 //
     /* 1487288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487338 */     // MIs[1] Operand 1
     /* 1487338 */     // No operand predicates
     /* 1487338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487342 */     // MIs[0] policy
     /* 1487342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487354 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487376 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487379 */     // GIR_Coverage, 24686,
     /* 1487379 */     GIR_EraseRootFromParent_Done,
     /* 1487380 */   // Label 20783: @1487380
     /* 1487380 */   GIM_Try, /*On fail goto*//*Label 20784*/ GIMT_Encode4(1487477), // Rule ID 24687 //
     /* 1487385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1487402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487435 */     // MIs[1] Operand 1
     /* 1487435 */     // No operand predicates
     /* 1487435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487439 */     // MIs[0] policy
     /* 1487439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487451 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1487454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487476 */     // GIR_Coverage, 24687,
     /* 1487476 */     GIR_EraseRootFromParent_Done,
     /* 1487477 */   // Label 20784: @1487477
     /* 1487477 */   GIM_Try, /*On fail goto*//*Label 20785*/ GIMT_Encode4(1487574), // Rule ID 24690 //
     /* 1487482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1487499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487532 */     // MIs[1] Operand 1
     /* 1487532 */     // No operand predicates
     /* 1487532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487536 */     // MIs[0] policy
     /* 1487536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487570 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487573 */     // GIR_Coverage, 24690,
     /* 1487573 */     GIR_EraseRootFromParent_Done,
     /* 1487574 */   // Label 20785: @1487574
     /* 1487574 */   GIM_Try, /*On fail goto*//*Label 20786*/ GIMT_Encode4(1487671), // Rule ID 24691 //
     /* 1487579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1487596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487629 */     // MIs[1] Operand 1
     /* 1487629 */     // No operand predicates
     /* 1487629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487633 */     // MIs[0] policy
     /* 1487633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487645 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487670 */     // GIR_Coverage, 24691,
     /* 1487670 */     GIR_EraseRootFromParent_Done,
     /* 1487671 */   // Label 20786: @1487671
     /* 1487671 */   GIM_Try, /*On fail goto*//*Label 20787*/ GIMT_Encode4(1487768), // Rule ID 24694 //
     /* 1487676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1487687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1487690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1487693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487722 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487726 */     // MIs[1] Operand 1
     /* 1487726 */     // No operand predicates
     /* 1487726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487730 */     // MIs[0] policy
     /* 1487730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1487764 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487767 */     // GIR_Coverage, 24694,
     /* 1487767 */     GIR_EraseRootFromParent_Done,
     /* 1487768 */   // Label 20787: @1487768
     /* 1487768 */   GIM_Try, /*On fail goto*//*Label 20788*/ GIMT_Encode4(1487865), // Rule ID 24695 //
     /* 1487773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1487784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1487787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1487790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487823 */     // MIs[1] Operand 1
     /* 1487823 */     // No operand predicates
     /* 1487823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487827 */     // MIs[0] policy
     /* 1487827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487839 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1487842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1487861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487864 */     // GIR_Coverage, 24695,
     /* 1487864 */     GIR_EraseRootFromParent_Done,
     /* 1487865 */   // Label 20788: @1487865
     /* 1487865 */   GIM_Try, /*On fail goto*//*Label 20789*/ GIMT_Encode4(1487962), // Rule ID 24698 //
     /* 1487870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1487873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1487881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1487884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1487887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487920 */     // MIs[1] Operand 1
     /* 1487920 */     // No operand predicates
     /* 1487920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487924 */     // MIs[0] policy
     /* 1487924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1487939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487958 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487961 */     // GIR_Coverage, 24698,
     /* 1487961 */     GIR_EraseRootFromParent_Done,
     /* 1487962 */   // Label 20789: @1487962
     /* 1487962 */   GIM_Try, /*On fail goto*//*Label 20790*/ GIMT_Encode4(1488059), // Rule ID 24699 //
     /* 1487967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1487970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1487978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1487981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1487984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488017 */     // MIs[1] Operand 1
     /* 1488017 */     // No operand predicates
     /* 1488017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488021 */     // MIs[0] policy
     /* 1488021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488033 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488042 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488058 */     // GIR_Coverage, 24699,
     /* 1488058 */     GIR_EraseRootFromParent_Done,
     /* 1488059 */   // Label 20790: @1488059
     /* 1488059 */   GIM_Try, /*On fail goto*//*Label 20791*/ GIMT_Encode4(1488156), // Rule ID 24702 //
     /* 1488064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488114 */     // MIs[1] Operand 1
     /* 1488114 */     // No operand predicates
     /* 1488114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488118 */     // MIs[0] policy
     /* 1488118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488155 */     // GIR_Coverage, 24702,
     /* 1488155 */     GIR_EraseRootFromParent_Done,
     /* 1488156 */   // Label 20791: @1488156
     /* 1488156 */   GIM_Try, /*On fail goto*//*Label 20792*/ GIMT_Encode4(1488253), // Rule ID 24703 //
     /* 1488161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1488172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1488175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488211 */     // MIs[1] Operand 1
     /* 1488211 */     // No operand predicates
     /* 1488211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488215 */     // MIs[0] policy
     /* 1488215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488252 */     // GIR_Coverage, 24703,
     /* 1488252 */     GIR_EraseRootFromParent_Done,
     /* 1488253 */   // Label 20792: @1488253
     /* 1488253 */   GIM_Try, /*On fail goto*//*Label 20793*/ GIMT_Encode4(1488350), // Rule ID 24706 //
     /* 1488258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488308 */     // MIs[1] Operand 1
     /* 1488308 */     // No operand predicates
     /* 1488308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488312 */     // MIs[0] policy
     /* 1488312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488346 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488349 */     // GIR_Coverage, 24706,
     /* 1488349 */     GIR_EraseRootFromParent_Done,
     /* 1488350 */   // Label 20793: @1488350
     /* 1488350 */   GIM_Try, /*On fail goto*//*Label 20794*/ GIMT_Encode4(1488447), // Rule ID 24707 //
     /* 1488355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1488372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488405 */     // MIs[1] Operand 1
     /* 1488405 */     // No operand predicates
     /* 1488405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488409 */     // MIs[0] policy
     /* 1488409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488421 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1488443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488446 */     // GIR_Coverage, 24707,
     /* 1488446 */     GIR_EraseRootFromParent_Done,
     /* 1488447 */   // Label 20794: @1488447
     /* 1488447 */   GIM_Try, /*On fail goto*//*Label 20795*/ GIMT_Encode4(1488544), // Rule ID 24710 //
     /* 1488452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1488455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1488469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488502 */     // MIs[1] Operand 1
     /* 1488502 */     // No operand predicates
     /* 1488502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488506 */     // MIs[0] policy
     /* 1488506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488543 */     // GIR_Coverage, 24710,
     /* 1488543 */     GIR_EraseRootFromParent_Done,
     /* 1488544 */   // Label 20795: @1488544
     /* 1488544 */   GIM_Try, /*On fail goto*//*Label 20796*/ GIMT_Encode4(1488641), // Rule ID 24711 //
     /* 1488549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1488552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1488560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1488563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1488566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488599 */     // MIs[1] Operand 1
     /* 1488599 */     // No operand predicates
     /* 1488599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488603 */     // MIs[0] policy
     /* 1488603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488615 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1488618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1488637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488640 */     // GIR_Coverage, 24711,
     /* 1488640 */     GIR_EraseRootFromParent_Done,
     /* 1488641 */   // Label 20796: @1488641
     /* 1488641 */   GIM_Try, /*On fail goto*//*Label 20797*/ GIMT_Encode4(1488738), // Rule ID 24714 //
     /* 1488646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1488657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1488660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1488663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1488669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488696 */     // MIs[1] Operand 1
     /* 1488696 */     // No operand predicates
     /* 1488696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488700 */     // MIs[0] policy
     /* 1488700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488712 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1488715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488737 */     // GIR_Coverage, 24714,
     /* 1488737 */     GIR_EraseRootFromParent_Done,
     /* 1488738 */   // Label 20797: @1488738
     /* 1488738 */   GIM_Try, /*On fail goto*//*Label 20798*/ GIMT_Encode4(1488835), // Rule ID 24715 //
     /* 1488743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1488754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1488757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1488760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1488766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488793 */     // MIs[1] Operand 1
     /* 1488793 */     // No operand predicates
     /* 1488793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488797 */     // MIs[0] policy
     /* 1488797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488809 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1488812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488834 */     // GIR_Coverage, 24715,
     /* 1488834 */     GIR_EraseRootFromParent_Done,
     /* 1488835 */   // Label 20798: @1488835
     /* 1488835 */   GIM_Try, /*On fail goto*//*Label 20799*/ GIMT_Encode4(1488932), // Rule ID 24718 //
     /* 1488840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1488843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1488851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1488854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1488857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1488863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488890 */     // MIs[1] Operand 1
     /* 1488890 */     // No operand predicates
     /* 1488890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488894 */     // MIs[0] policy
     /* 1488894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488906 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1488909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488931 */     // GIR_Coverage, 24718,
     /* 1488931 */     GIR_EraseRootFromParent_Done,
     /* 1488932 */   // Label 20799: @1488932
     /* 1488932 */   GIM_Try, /*On fail goto*//*Label 20800*/ GIMT_Encode4(1489029), // Rule ID 24719 //
     /* 1488937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1488940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1488945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1488948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1488951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1488954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1488960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488987 */     // MIs[1] Operand 1
     /* 1488987 */     // No operand predicates
     /* 1488987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488991 */     // MIs[0] policy
     /* 1488991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489003 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489028 */     // GIR_Coverage, 24719,
     /* 1489028 */     GIR_EraseRootFromParent_Done,
     /* 1489029 */   // Label 20800: @1489029
     /* 1489029 */   GIM_Try, /*On fail goto*//*Label 20801*/ GIMT_Encode4(1489126), // Rule ID 24722 //
     /* 1489034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1489045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1489048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1489051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1489057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489080 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489084 */     // MIs[1] Operand 1
     /* 1489084 */     // No operand predicates
     /* 1489084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489088 */     // MIs[0] policy
     /* 1489088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489100 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489125 */     // GIR_Coverage, 24722,
     /* 1489125 */     GIR_EraseRootFromParent_Done,
     /* 1489126 */   // Label 20801: @1489126
     /* 1489126 */   GIM_Try, /*On fail goto*//*Label 20802*/ GIMT_Encode4(1489223), // Rule ID 24723 //
     /* 1489131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1489142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1489145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1489148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1489154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489181 */     // MIs[1] Operand 1
     /* 1489181 */     // No operand predicates
     /* 1489181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489185 */     // MIs[0] policy
     /* 1489185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489197 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1489219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489222 */     // GIR_Coverage, 24723,
     /* 1489222 */     GIR_EraseRootFromParent_Done,
     /* 1489223 */   // Label 20802: @1489223
     /* 1489223 */   GIM_Try, /*On fail goto*//*Label 20803*/ GIMT_Encode4(1489320), // Rule ID 24726 //
     /* 1489228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1489239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1489242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489278 */     // MIs[1] Operand 1
     /* 1489278 */     // No operand predicates
     /* 1489278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489282 */     // MIs[0] policy
     /* 1489282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489319 */     // GIR_Coverage, 24726,
     /* 1489319 */     GIR_EraseRootFromParent_Done,
     /* 1489320 */   // Label 20803: @1489320
     /* 1489320 */   GIM_Try, /*On fail goto*//*Label 20804*/ GIMT_Encode4(1489417), // Rule ID 24727 //
     /* 1489325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1489336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1489339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489375 */     // MIs[1] Operand 1
     /* 1489375 */     // No operand predicates
     /* 1489375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489379 */     // MIs[0] policy
     /* 1489379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489400 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489416 */     // GIR_Coverage, 24727,
     /* 1489416 */     GIR_EraseRootFromParent_Done,
     /* 1489417 */   // Label 20804: @1489417
     /* 1489417 */   GIM_Try, /*On fail goto*//*Label 20805*/ GIMT_Encode4(1489514), // Rule ID 24730 //
     /* 1489422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1489433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1489436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489472 */     // MIs[1] Operand 1
     /* 1489472 */     // No operand predicates
     /* 1489472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489476 */     // MIs[0] policy
     /* 1489476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489513 */     // GIR_Coverage, 24730,
     /* 1489513 */     GIR_EraseRootFromParent_Done,
     /* 1489514 */   // Label 20805: @1489514
     /* 1489514 */   GIM_Try, /*On fail goto*//*Label 20806*/ GIMT_Encode4(1489611), // Rule ID 24731 //
     /* 1489519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1489530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1489533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489569 */     // MIs[1] Operand 1
     /* 1489569 */     // No operand predicates
     /* 1489569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489573 */     // MIs[0] policy
     /* 1489573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489585 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1489588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489610 */     // GIR_Coverage, 24731,
     /* 1489610 */     GIR_EraseRootFromParent_Done,
     /* 1489611 */   // Label 20806: @1489611
     /* 1489611 */   GIM_Try, /*On fail goto*//*Label 20807*/ GIMT_Encode4(1489708), // Rule ID 24734 //
     /* 1489616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1489627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1489630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1489633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489666 */     // MIs[1] Operand 1
     /* 1489666 */     // No operand predicates
     /* 1489666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489670 */     // MIs[0] policy
     /* 1489670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489682 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489707 */     // GIR_Coverage, 24734,
     /* 1489707 */     GIR_EraseRootFromParent_Done,
     /* 1489708 */   // Label 20807: @1489708
     /* 1489708 */   GIM_Try, /*On fail goto*//*Label 20808*/ GIMT_Encode4(1489805), // Rule ID 24735 //
     /* 1489713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1489724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1489727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1489730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1489736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489763 */     // MIs[1] Operand 1
     /* 1489763 */     // No operand predicates
     /* 1489763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489767 */     // MIs[0] policy
     /* 1489767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489779 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1489782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489804 */     // GIR_Coverage, 24735,
     /* 1489804 */     GIR_EraseRootFromParent_Done,
     /* 1489805 */   // Label 20808: @1489805
     /* 1489805 */   GIM_Try, /*On fail goto*//*Label 20809*/ GIMT_Encode4(1489902), // Rule ID 24738 //
     /* 1489810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1489813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1489821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1489824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489860 */     // MIs[1] Operand 1
     /* 1489860 */     // No operand predicates
     /* 1489860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489864 */     // MIs[0] policy
     /* 1489864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489876 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489901 */     // GIR_Coverage, 24738,
     /* 1489901 */     GIR_EraseRootFromParent_Done,
     /* 1489902 */   // Label 20809: @1489902
     /* 1489902 */   GIM_Try, /*On fail goto*//*Label 20810*/ GIMT_Encode4(1489999), // Rule ID 24739 //
     /* 1489907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1489910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1489915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1489918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1489921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489957 */     // MIs[1] Operand 1
     /* 1489957 */     // No operand predicates
     /* 1489957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489961 */     // MIs[0] policy
     /* 1489961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1489976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489998 */     // GIR_Coverage, 24739,
     /* 1489998 */     GIR_EraseRootFromParent_Done,
     /* 1489999 */   // Label 20810: @1489999
     /* 1489999 */   GIM_Try, /*On fail goto*//*Label 20811*/ GIMT_Encode4(1490096), // Rule ID 24742 //
     /* 1490004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1490015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1490018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490054 */     // MIs[1] Operand 1
     /* 1490054 */     // No operand predicates
     /* 1490054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490058 */     // MIs[0] policy
     /* 1490058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490070 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490092 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490095 */     // GIR_Coverage, 24742,
     /* 1490095 */     GIR_EraseRootFromParent_Done,
     /* 1490096 */   // Label 20811: @1490096
     /* 1490096 */   GIM_Try, /*On fail goto*//*Label 20812*/ GIMT_Encode4(1490193), // Rule ID 24743 //
     /* 1490101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1490112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1490115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490151 */     // MIs[1] Operand 1
     /* 1490151 */     // No operand predicates
     /* 1490151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490155 */     // MIs[0] policy
     /* 1490155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490167 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490192 */     // GIR_Coverage, 24743,
     /* 1490192 */     GIR_EraseRootFromParent_Done,
     /* 1490193 */   // Label 20812: @1490193
     /* 1490193 */   GIM_Try, /*On fail goto*//*Label 20813*/ GIMT_Encode4(1490290), // Rule ID 24746 //
     /* 1490198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1490201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1490209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1490212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1490215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490248 */     // MIs[1] Operand 1
     /* 1490248 */     // No operand predicates
     /* 1490248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490252 */     // MIs[0] policy
     /* 1490252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490286 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490289 */     // GIR_Coverage, 24746,
     /* 1490289 */     GIR_EraseRootFromParent_Done,
     /* 1490290 */   // Label 20813: @1490290
     /* 1490290 */   GIM_Try, /*On fail goto*//*Label 20814*/ GIMT_Encode4(1490387), // Rule ID 24747 //
     /* 1490295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1490298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1490306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1490309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1490312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1490318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490345 */     // MIs[1] Operand 1
     /* 1490345 */     // No operand predicates
     /* 1490345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490349 */     // MIs[0] policy
     /* 1490349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490361 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490386 */     // GIR_Coverage, 24747,
     /* 1490386 */     GIR_EraseRootFromParent_Done,
     /* 1490387 */   // Label 20814: @1490387
     /* 1490387 */   GIM_Try, /*On fail goto*//*Label 20815*/ GIMT_Encode4(1490484), // Rule ID 24750 //
     /* 1490392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1490395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490442 */     // MIs[1] Operand 1
     /* 1490442 */     // No operand predicates
     /* 1490442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490446 */     // MIs[0] policy
     /* 1490446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490458 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490480 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490483 */     // GIR_Coverage, 24750,
     /* 1490483 */     GIR_EraseRootFromParent_Done,
     /* 1490484 */   // Label 20815: @1490484
     /* 1490484 */   GIM_Try, /*On fail goto*//*Label 20816*/ GIMT_Encode4(1490581), // Rule ID 24751 //
     /* 1490489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1490492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1490500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1490503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1490506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1490519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1490527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490539 */     // MIs[1] Operand 1
     /* 1490539 */     // No operand predicates
     /* 1490539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490543 */     // MIs[0] policy
     /* 1490543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1490558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490580 */     // GIR_Coverage, 24751,
     /* 1490580 */     GIR_EraseRootFromParent_Done,
     /* 1490581 */   // Label 20816: @1490581
     /* 1490581 */   GIM_Try, /*On fail goto*//*Label 20817*/ GIMT_Encode4(1490678), // Rule ID 24754 //
     /* 1490586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1490589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1490597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1490600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1490603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490636 */     // MIs[1] Operand 1
     /* 1490636 */     // No operand predicates
     /* 1490636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490640 */     // MIs[0] policy
     /* 1490640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490674 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490677 */     // GIR_Coverage, 24754,
     /* 1490677 */     GIR_EraseRootFromParent_Done,
     /* 1490678 */   // Label 20817: @1490678
     /* 1490678 */   GIM_Try, /*On fail goto*//*Label 20818*/ GIMT_Encode4(1490775), // Rule ID 24755 //
     /* 1490683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1490686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1490694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1490697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1490700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1490713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490729 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490733 */     // MIs[1] Operand 1
     /* 1490733 */     // No operand predicates
     /* 1490733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490737 */     // MIs[0] policy
     /* 1490737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490749 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1490752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490774 */     // GIR_Coverage, 24755,
     /* 1490774 */     GIR_EraseRootFromParent_Done,
     /* 1490775 */   // Label 20818: @1490775
     /* 1490775 */   GIM_Try, /*On fail goto*//*Label 20819*/ GIMT_Encode4(1490872), // Rule ID 24758 //
     /* 1490780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1490783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1490797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490830 */     // MIs[1] Operand 1
     /* 1490830 */     // No operand predicates
     /* 1490830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490834 */     // MIs[0] policy
     /* 1490834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490846 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490868 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490871 */     // GIR_Coverage, 24758,
     /* 1490871 */     GIR_EraseRootFromParent_Done,
     /* 1490872 */   // Label 20819: @1490872
     /* 1490872 */   GIM_Try, /*On fail goto*//*Label 20820*/ GIMT_Encode4(1490969), // Rule ID 24759 //
     /* 1490877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1490880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1490894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490927 */     // MIs[1] Operand 1
     /* 1490927 */     // No operand predicates
     /* 1490927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490931 */     // MIs[0] policy
     /* 1490931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490943 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1490946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490952 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1490965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490968 */     // GIR_Coverage, 24759,
     /* 1490968 */     GIR_EraseRootFromParent_Done,
     /* 1490969 */   // Label 20820: @1490969
     /* 1490969 */   GIM_Try, /*On fail goto*//*Label 20821*/ GIMT_Encode4(1491066), // Rule ID 24966 //
     /* 1490974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1490977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1490982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1490985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1490988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1490991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491024 */     // MIs[1] Operand 1
     /* 1491024 */     // No operand predicates
     /* 1491024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491028 */     // MIs[0] policy
     /* 1491028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491040 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491062 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491065 */     // GIR_Coverage, 24966,
     /* 1491065 */     GIR_EraseRootFromParent_Done,
     /* 1491066 */   // Label 20821: @1491066
     /* 1491066 */   GIM_Try, /*On fail goto*//*Label 20822*/ GIMT_Encode4(1491163), // Rule ID 24967 //
     /* 1491071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1491074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1491082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1491085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1491088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491121 */     // MIs[1] Operand 1
     /* 1491121 */     // No operand predicates
     /* 1491121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491125 */     // MIs[0] policy
     /* 1491125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491137 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1491140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491162 */     // GIR_Coverage, 24967,
     /* 1491162 */     GIR_EraseRootFromParent_Done,
     /* 1491163 */   // Label 20822: @1491163
     /* 1491163 */   GIM_Try, /*On fail goto*//*Label 20823*/ GIMT_Encode4(1491260), // Rule ID 24970 //
     /* 1491168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1491171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491214 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491218 */     // MIs[1] Operand 1
     /* 1491218 */     // No operand predicates
     /* 1491218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491222 */     // MIs[0] policy
     /* 1491222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491234 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491256 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491259 */     // GIR_Coverage, 24970,
     /* 1491259 */     GIR_EraseRootFromParent_Done,
     /* 1491260 */   // Label 20823: @1491260
     /* 1491260 */   GIM_Try, /*On fail goto*//*Label 20824*/ GIMT_Encode4(1491357), // Rule ID 24971 //
     /* 1491265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1491268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491315 */     // MIs[1] Operand 1
     /* 1491315 */     // No operand predicates
     /* 1491315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491319 */     // MIs[0] policy
     /* 1491319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491331 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491356 */     // GIR_Coverage, 24971,
     /* 1491356 */     GIR_EraseRootFromParent_Done,
     /* 1491357 */   // Label 20824: @1491357
     /* 1491357 */   GIM_Try, /*On fail goto*//*Label 20825*/ GIMT_Encode4(1491454), // Rule ID 24974 //
     /* 1491362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1491365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491412 */     // MIs[1] Operand 1
     /* 1491412 */     // No operand predicates
     /* 1491412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491416 */     // MIs[0] policy
     /* 1491416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491428 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491450 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491453 */     // GIR_Coverage, 24974,
     /* 1491453 */     GIR_EraseRootFromParent_Done,
     /* 1491454 */   // Label 20825: @1491454
     /* 1491454 */   GIM_Try, /*On fail goto*//*Label 20826*/ GIMT_Encode4(1491551), // Rule ID 24975 //
     /* 1491459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1491462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491509 */     // MIs[1] Operand 1
     /* 1491509 */     // No operand predicates
     /* 1491509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491513 */     // MIs[0] policy
     /* 1491513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491525 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1491528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491550 */     // GIR_Coverage, 24975,
     /* 1491550 */     GIR_EraseRootFromParent_Done,
     /* 1491551 */   // Label 20826: @1491551
     /* 1491551 */   GIM_Try, /*On fail goto*//*Label 20827*/ GIMT_Encode4(1491648), // Rule ID 24978 //
     /* 1491556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1491559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1491567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1491570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1491573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491606 */     // MIs[1] Operand 1
     /* 1491606 */     // No operand predicates
     /* 1491606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491610 */     // MIs[0] policy
     /* 1491610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491622 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491644 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491647 */     // GIR_Coverage, 24978,
     /* 1491647 */     GIR_EraseRootFromParent_Done,
     /* 1491648 */   // Label 20827: @1491648
     /* 1491648 */   GIM_Try, /*On fail goto*//*Label 20828*/ GIMT_Encode4(1491745), // Rule ID 24979 //
     /* 1491653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1491656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1491664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1491667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1491670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491703 */     // MIs[1] Operand 1
     /* 1491703 */     // No operand predicates
     /* 1491703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491707 */     // MIs[0] policy
     /* 1491707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491719 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491744 */     // GIR_Coverage, 24979,
     /* 1491744 */     GIR_EraseRootFromParent_Done,
     /* 1491745 */   // Label 20828: @1491745
     /* 1491745 */   GIM_Try, /*On fail goto*//*Label 20829*/ GIMT_Encode4(1491842), // Rule ID 24982 //
     /* 1491750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1491753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1491761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1491764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1491767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491800 */     // MIs[1] Operand 1
     /* 1491800 */     // No operand predicates
     /* 1491800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491804 */     // MIs[0] policy
     /* 1491804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491816 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491838 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491841 */     // GIR_Coverage, 24982,
     /* 1491841 */     GIR_EraseRootFromParent_Done,
     /* 1491842 */   // Label 20829: @1491842
     /* 1491842 */   GIM_Try, /*On fail goto*//*Label 20830*/ GIMT_Encode4(1491939), // Rule ID 24983 //
     /* 1491847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1491850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1491858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1491861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1491864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491897 */     // MIs[1] Operand 1
     /* 1491897 */     // No operand predicates
     /* 1491897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491901 */     // MIs[0] policy
     /* 1491901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491913 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1491916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491938 */     // GIR_Coverage, 24983,
     /* 1491938 */     GIR_EraseRootFromParent_Done,
     /* 1491939 */   // Label 20830: @1491939
     /* 1491939 */   GIM_Try, /*On fail goto*//*Label 20831*/ GIMT_Encode4(1492036), // Rule ID 24986 //
     /* 1491944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1491947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1491952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1491955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1491958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1491961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491990 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1491994 */     // MIs[1] Operand 1
     /* 1491994 */     // No operand predicates
     /* 1491994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491998 */     // MIs[0] policy
     /* 1491998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492010 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492032 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492035 */     // GIR_Coverage, 24986,
     /* 1492035 */     GIR_EraseRootFromParent_Done,
     /* 1492036 */   // Label 20831: @1492036
     /* 1492036 */   GIM_Try, /*On fail goto*//*Label 20832*/ GIMT_Encode4(1492133), // Rule ID 24987 //
     /* 1492041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1492044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1492052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1492055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1492058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492091 */     // MIs[1] Operand 1
     /* 1492091 */     // No operand predicates
     /* 1492091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492095 */     // MIs[0] policy
     /* 1492095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492107 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1492110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492132 */     // GIR_Coverage, 24987,
     /* 1492132 */     GIR_EraseRootFromParent_Done,
     /* 1492133 */   // Label 20832: @1492133
     /* 1492133 */   GIM_Try, /*On fail goto*//*Label 20833*/ GIMT_Encode4(1492230), // Rule ID 24990 //
     /* 1492138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1492141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492188 */     // MIs[1] Operand 1
     /* 1492188 */     // No operand predicates
     /* 1492188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492192 */     // MIs[0] policy
     /* 1492192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492204 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492229 */     // GIR_Coverage, 24990,
     /* 1492229 */     GIR_EraseRootFromParent_Done,
     /* 1492230 */   // Label 20833: @1492230
     /* 1492230 */   GIM_Try, /*On fail goto*//*Label 20834*/ GIMT_Encode4(1492327), // Rule ID 24991 //
     /* 1492235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1492238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492285 */     // MIs[1] Operand 1
     /* 1492285 */     // No operand predicates
     /* 1492285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492289 */     // MIs[0] policy
     /* 1492289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492301 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492326 */     // GIR_Coverage, 24991,
     /* 1492326 */     GIR_EraseRootFromParent_Done,
     /* 1492327 */   // Label 20834: @1492327
     /* 1492327 */   GIM_Try, /*On fail goto*//*Label 20835*/ GIMT_Encode4(1492424), // Rule ID 24994 //
     /* 1492332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1492335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1492349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492382 */     // MIs[1] Operand 1
     /* 1492382 */     // No operand predicates
     /* 1492382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492386 */     // MIs[0] policy
     /* 1492386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492398 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492423 */     // GIR_Coverage, 24994,
     /* 1492423 */     GIR_EraseRootFromParent_Done,
     /* 1492424 */   // Label 20835: @1492424
     /* 1492424 */   GIM_Try, /*On fail goto*//*Label 20836*/ GIMT_Encode4(1492521), // Rule ID 24995 //
     /* 1492429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1492432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1492446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492479 */     // MIs[1] Operand 1
     /* 1492479 */     // No operand predicates
     /* 1492479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492483 */     // MIs[0] policy
     /* 1492483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492495 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492520 */     // GIR_Coverage, 24995,
     /* 1492520 */     GIR_EraseRootFromParent_Done,
     /* 1492521 */   // Label 20836: @1492521
     /* 1492521 */   GIM_Try, /*On fail goto*//*Label 20837*/ GIMT_Encode4(1492618), // Rule ID 24998 //
     /* 1492526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1492529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1492537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1492540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1492543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492576 */     // MIs[1] Operand 1
     /* 1492576 */     // No operand predicates
     /* 1492576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492580 */     // MIs[0] policy
     /* 1492580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492592 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1492595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492617 */     // GIR_Coverage, 24998,
     /* 1492617 */     GIR_EraseRootFromParent_Done,
     /* 1492618 */   // Label 20837: @1492618
     /* 1492618 */   GIM_Try, /*On fail goto*//*Label 20838*/ GIMT_Encode4(1492715), // Rule ID 24999 //
     /* 1492623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1492626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1492634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1492637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1492640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492673 */     // MIs[1] Operand 1
     /* 1492673 */     // No operand predicates
     /* 1492673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492677 */     // MIs[0] policy
     /* 1492677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492689 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1492692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492714 */     // GIR_Coverage, 24999,
     /* 1492714 */     GIR_EraseRootFromParent_Done,
     /* 1492715 */   // Label 20838: @1492715
     /* 1492715 */   GIM_Try, /*On fail goto*//*Label 20839*/ GIMT_Encode4(1492812), // Rule ID 25002 //
     /* 1492720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1492723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1492731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1492734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1492737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492770 */     // MIs[1] Operand 1
     /* 1492770 */     // No operand predicates
     /* 1492770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492774 */     // MIs[0] policy
     /* 1492774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492786 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492811 */     // GIR_Coverage, 25002,
     /* 1492811 */     GIR_EraseRootFromParent_Done,
     /* 1492812 */   // Label 20839: @1492812
     /* 1492812 */   GIM_Try, /*On fail goto*//*Label 20840*/ GIMT_Encode4(1492909), // Rule ID 25003 //
     /* 1492817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1492820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1492828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1492831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1492834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1492840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492867 */     // MIs[1] Operand 1
     /* 1492867 */     // No operand predicates
     /* 1492867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492871 */     // MIs[0] policy
     /* 1492871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492883 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1492886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1492905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492908 */     // GIR_Coverage, 25003,
     /* 1492908 */     GIR_EraseRootFromParent_Done,
     /* 1492909 */   // Label 20840: @1492909
     /* 1492909 */   GIM_Try, /*On fail goto*//*Label 20841*/ GIMT_Encode4(1493006), // Rule ID 25006 //
     /* 1492914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1492917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1492922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1492925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1492928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1492931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1492964 */     // MIs[1] Operand 1
     /* 1492964 */     // No operand predicates
     /* 1492964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492968 */     // MIs[0] policy
     /* 1492968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492980 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1492983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493005 */     // GIR_Coverage, 25006,
     /* 1493005 */     GIR_EraseRootFromParent_Done,
     /* 1493006 */   // Label 20841: @1493006
     /* 1493006 */   GIM_Try, /*On fail goto*//*Label 20842*/ GIMT_Encode4(1493103), // Rule ID 25007 //
     /* 1493011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1493014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493061 */     // MIs[1] Operand 1
     /* 1493061 */     // No operand predicates
     /* 1493061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493065 */     // MIs[0] policy
     /* 1493065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493077 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493102 */     // GIR_Coverage, 25007,
     /* 1493102 */     GIR_EraseRootFromParent_Done,
     /* 1493103 */   // Label 20842: @1493103
     /* 1493103 */   GIM_Try, /*On fail goto*//*Label 20843*/ GIMT_Encode4(1493200), // Rule ID 25010 //
     /* 1493108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1493111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493158 */     // MIs[1] Operand 1
     /* 1493158 */     // No operand predicates
     /* 1493158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493162 */     // MIs[0] policy
     /* 1493162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493174 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493199 */     // GIR_Coverage, 25010,
     /* 1493199 */     GIR_EraseRootFromParent_Done,
     /* 1493200 */   // Label 20843: @1493200
     /* 1493200 */   GIM_Try, /*On fail goto*//*Label 20844*/ GIMT_Encode4(1493297), // Rule ID 25011 //
     /* 1493205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1493208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493255 */     // MIs[1] Operand 1
     /* 1493255 */     // No operand predicates
     /* 1493255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493259 */     // MIs[0] policy
     /* 1493259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493271 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493296 */     // GIR_Coverage, 25011,
     /* 1493296 */     GIR_EraseRootFromParent_Done,
     /* 1493297 */   // Label 20844: @1493297
     /* 1493297 */   GIM_Try, /*On fail goto*//*Label 20845*/ GIMT_Encode4(1493394), // Rule ID 25014 //
     /* 1493302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1493305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1493319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493352 */     // MIs[1] Operand 1
     /* 1493352 */     // No operand predicates
     /* 1493352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493356 */     // MIs[0] policy
     /* 1493356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493368 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493393 */     // GIR_Coverage, 25014,
     /* 1493393 */     GIR_EraseRootFromParent_Done,
     /* 1493394 */   // Label 20845: @1493394
     /* 1493394 */   GIM_Try, /*On fail goto*//*Label 20846*/ GIMT_Encode4(1493491), // Rule ID 25015 //
     /* 1493399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1493402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1493416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493449 */     // MIs[1] Operand 1
     /* 1493449 */     // No operand predicates
     /* 1493449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493453 */     // MIs[0] policy
     /* 1493453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493465 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1493468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493490 */     // GIR_Coverage, 25015,
     /* 1493490 */     GIR_EraseRootFromParent_Done,
     /* 1493491 */   // Label 20846: @1493491
     /* 1493491 */   GIM_Try, /*On fail goto*//*Label 20847*/ GIMT_Encode4(1493588), // Rule ID 25018 //
     /* 1493496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1493499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1493507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1493510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1493513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493546 */     // MIs[1] Operand 1
     /* 1493546 */     // No operand predicates
     /* 1493546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493550 */     // MIs[0] policy
     /* 1493550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493562 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493587 */     // GIR_Coverage, 25018,
     /* 1493587 */     GIR_EraseRootFromParent_Done,
     /* 1493588 */   // Label 20847: @1493588
     /* 1493588 */   GIM_Try, /*On fail goto*//*Label 20848*/ GIMT_Encode4(1493685), // Rule ID 25019 //
     /* 1493593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1493596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1493604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1493607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1493610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493643 */     // MIs[1] Operand 1
     /* 1493643 */     // No operand predicates
     /* 1493643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493647 */     // MIs[0] policy
     /* 1493647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493659 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1493662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493684 */     // GIR_Coverage, 25019,
     /* 1493684 */     GIR_EraseRootFromParent_Done,
     /* 1493685 */   // Label 20848: @1493685
     /* 1493685 */   GIM_Try, /*On fail goto*//*Label 20849*/ GIMT_Encode4(1493782), // Rule ID 25022 //
     /* 1493690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1493693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1493701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1493704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1493707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493740 */     // MIs[1] Operand 1
     /* 1493740 */     // No operand predicates
     /* 1493740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493744 */     // MIs[0] policy
     /* 1493744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493756 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493778 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493781 */     // GIR_Coverage, 25022,
     /* 1493781 */     GIR_EraseRootFromParent_Done,
     /* 1493782 */   // Label 20849: @1493782
     /* 1493782 */   GIM_Try, /*On fail goto*//*Label 20850*/ GIMT_Encode4(1493879), // Rule ID 25023 //
     /* 1493787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1493790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1493795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1493798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1493801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1493804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493837 */     // MIs[1] Operand 1
     /* 1493837 */     // No operand predicates
     /* 1493837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493841 */     // MIs[0] policy
     /* 1493841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493853 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1493856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493878 */     // GIR_Coverage, 25023,
     /* 1493878 */     GIR_EraseRootFromParent_Done,
     /* 1493879 */   // Label 20850: @1493879
     /* 1493879 */   GIM_Try, /*On fail goto*//*Label 20851*/ GIMT_Encode4(1493976), // Rule ID 61034 //
     /* 1493884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1493887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1493895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1493898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1493901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1493907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1493914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1493922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493930 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1493934 */     // MIs[1] Operand 1
     /* 1493934 */     // No operand predicates
     /* 1493934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493938 */     // MIs[0] policy
     /* 1493938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493950 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1493953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1493972 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493975 */     // GIR_Coverage, 61034,
     /* 1493975 */     GIR_EraseRootFromParent_Done,
     /* 1493976 */   // Label 20851: @1493976
     /* 1493976 */   GIM_Try, /*On fail goto*//*Label 20852*/ GIMT_Encode4(1494073), // Rule ID 61035 //
     /* 1493981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1493984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1493989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1493992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1493995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1493998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1494004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494031 */     // MIs[1] Operand 1
     /* 1494031 */     // No operand predicates
     /* 1494031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494035 */     // MIs[0] policy
     /* 1494035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494047 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1494050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494072 */     // GIR_Coverage, 61035,
     /* 1494072 */     GIR_EraseRootFromParent_Done,
     /* 1494073 */   // Label 20852: @1494073
     /* 1494073 */   GIM_Try, /*On fail goto*//*Label 20853*/ GIMT_Encode4(1494170), // Rule ID 61042 //
     /* 1494078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1494089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1494092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494128 */     // MIs[1] Operand 1
     /* 1494128 */     // No operand predicates
     /* 1494128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494132 */     // MIs[0] policy
     /* 1494132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1494147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494166 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494169 */     // GIR_Coverage, 61042,
     /* 1494169 */     GIR_EraseRootFromParent_Done,
     /* 1494170 */   // Label 20853: @1494170
     /* 1494170 */   GIM_Try, /*On fail goto*//*Label 20854*/ GIMT_Encode4(1494267), // Rule ID 61043 //
     /* 1494175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1494186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1494189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1494192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494225 */     // MIs[1] Operand 1
     /* 1494225 */     // No operand predicates
     /* 1494225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494229 */     // MIs[0] policy
     /* 1494229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494241 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1494244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494266 */     // GIR_Coverage, 61043,
     /* 1494266 */     GIR_EraseRootFromParent_Done,
     /* 1494267 */   // Label 20854: @1494267
     /* 1494267 */   GIM_Try, /*On fail goto*//*Label 20855*/ GIMT_Encode4(1494364), // Rule ID 61050 //
     /* 1494272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1494289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494322 */     // MIs[1] Operand 1
     /* 1494322 */     // No operand predicates
     /* 1494322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494326 */     // MIs[0] policy
     /* 1494326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494338 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1494341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494360 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494363 */     // GIR_Coverage, 61050,
     /* 1494363 */     GIR_EraseRootFromParent_Done,
     /* 1494364 */   // Label 20855: @1494364
     /* 1494364 */   GIM_Try, /*On fail goto*//*Label 20856*/ GIMT_Encode4(1494461), // Rule ID 61051 //
     /* 1494369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1494380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1494383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1494386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494419 */     // MIs[1] Operand 1
     /* 1494419 */     // No operand predicates
     /* 1494419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494423 */     // MIs[0] policy
     /* 1494423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494435 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1494438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494460 */     // GIR_Coverage, 61051,
     /* 1494460 */     GIR_EraseRootFromParent_Done,
     /* 1494461 */   // Label 20856: @1494461
     /* 1494461 */   GIM_Try, /*On fail goto*//*Label 20857*/ GIMT_Encode4(1494558), // Rule ID 61058 //
     /* 1494466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1494477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1494480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1494483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494516 */     // MIs[1] Operand 1
     /* 1494516 */     // No operand predicates
     /* 1494516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494520 */     // MIs[0] policy
     /* 1494520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494532 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1494535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494554 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494557 */     // GIR_Coverage, 61058,
     /* 1494557 */     GIR_EraseRootFromParent_Done,
     /* 1494558 */   // Label 20857: @1494558
     /* 1494558 */   GIM_Try, /*On fail goto*//*Label 20858*/ GIMT_Encode4(1494655), // Rule ID 61059 //
     /* 1494563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1494574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1494577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1494580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494613 */     // MIs[1] Operand 1
     /* 1494613 */     // No operand predicates
     /* 1494613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494617 */     // MIs[0] policy
     /* 1494617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494629 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1494632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494654 */     // GIR_Coverage, 61059,
     /* 1494654 */     GIR_EraseRootFromParent_Done,
     /* 1494655 */   // Label 20858: @1494655
     /* 1494655 */   GIM_Try, /*On fail goto*//*Label 20859*/ GIMT_Encode4(1494752), // Rule ID 61066 //
     /* 1494660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1494671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1494674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1494677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1494683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494710 */     // MIs[1] Operand 1
     /* 1494710 */     // No operand predicates
     /* 1494710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494714 */     // MIs[0] policy
     /* 1494714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494726 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1494729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494748 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494751 */     // GIR_Coverage, 61066,
     /* 1494751 */     GIR_EraseRootFromParent_Done,
     /* 1494752 */   // Label 20859: @1494752
     /* 1494752 */   GIM_Try, /*On fail goto*//*Label 20860*/ GIMT_Encode4(1494849), // Rule ID 61067 //
     /* 1494757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1494768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1494771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1494774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1494780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494807 */     // MIs[1] Operand 1
     /* 1494807 */     // No operand predicates
     /* 1494807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494811 */     // MIs[0] policy
     /* 1494811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494823 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1494826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494848 */     // GIR_Coverage, 61067,
     /* 1494848 */     GIR_EraseRootFromParent_Done,
     /* 1494849 */   // Label 20860: @1494849
     /* 1494849 */   GIM_Try, /*On fail goto*//*Label 20861*/ GIMT_Encode4(1494946), // Rule ID 61074 //
     /* 1494854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1494857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1494865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1494868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1494871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1494877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1494904 */     // MIs[1] Operand 1
     /* 1494904 */     // No operand predicates
     /* 1494904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494908 */     // MIs[0] policy
     /* 1494908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494920 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1494923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1494942 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494945 */     // GIR_Coverage, 61074,
     /* 1494945 */     GIR_EraseRootFromParent_Done,
     /* 1494946 */   // Label 20861: @1494946
     /* 1494946 */   GIM_Try, /*On fail goto*//*Label 20862*/ GIMT_Encode4(1495043), // Rule ID 61075 //
     /* 1494951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1494954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1494959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1494962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1494965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1494968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1494974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495001 */     // MIs[1] Operand 1
     /* 1495001 */     // No operand predicates
     /* 1495001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495005 */     // MIs[0] policy
     /* 1495005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495017 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1495020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1495039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495042 */     // GIR_Coverage, 61075,
     /* 1495042 */     GIR_EraseRootFromParent_Done,
     /* 1495043 */   // Label 20862: @1495043
     /* 1495043 */   GIM_Try, /*On fail goto*//*Label 20863*/ GIMT_Encode4(1495140), // Rule ID 61082 //
     /* 1495048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495098 */     // MIs[1] Operand 1
     /* 1495098 */     // No operand predicates
     /* 1495098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495102 */     // MIs[0] policy
     /* 1495102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1495117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495136 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495139 */     // GIR_Coverage, 61082,
     /* 1495139 */     GIR_EraseRootFromParent_Done,
     /* 1495140 */   // Label 20863: @1495140
     /* 1495140 */   GIM_Try, /*On fail goto*//*Label 20864*/ GIMT_Encode4(1495237), // Rule ID 61083 //
     /* 1495145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1495162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1495168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495195 */     // MIs[1] Operand 1
     /* 1495195 */     // No operand predicates
     /* 1495195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495199 */     // MIs[0] policy
     /* 1495199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495211 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1495214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495236 */     // GIR_Coverage, 61083,
     /* 1495236 */     GIR_EraseRootFromParent_Done,
     /* 1495237 */   // Label 20864: @1495237
     /* 1495237 */   GIM_Try, /*On fail goto*//*Label 20865*/ GIMT_Encode4(1495334), // Rule ID 61090 //
     /* 1495242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495292 */     // MIs[1] Operand 1
     /* 1495292 */     // No operand predicates
     /* 1495292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495296 */     // MIs[0] policy
     /* 1495296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1495311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495330 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495333 */     // GIR_Coverage, 61090,
     /* 1495333 */     GIR_EraseRootFromParent_Done,
     /* 1495334 */   // Label 20865: @1495334
     /* 1495334 */   GIM_Try, /*On fail goto*//*Label 20866*/ GIMT_Encode4(1495431), // Rule ID 61091 //
     /* 1495339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1495362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1495369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495389 */     // MIs[1] Operand 1
     /* 1495389 */     // No operand predicates
     /* 1495389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495393 */     // MIs[0] policy
     /* 1495393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495405 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1495408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495430 */     // GIR_Coverage, 61091,
     /* 1495430 */     GIR_EraseRootFromParent_Done,
     /* 1495431 */   // Label 20866: @1495431
     /* 1495431 */   GIM_Try, /*On fail goto*//*Label 20867*/ GIMT_Encode4(1495528), // Rule ID 61098 //
     /* 1495436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1495453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495486 */     // MIs[1] Operand 1
     /* 1495486 */     // No operand predicates
     /* 1495486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495490 */     // MIs[0] policy
     /* 1495490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495524 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495527 */     // GIR_Coverage, 61098,
     /* 1495527 */     GIR_EraseRootFromParent_Done,
     /* 1495528 */   // Label 20867: @1495528
     /* 1495528 */   GIM_Try, /*On fail goto*//*Label 20868*/ GIMT_Encode4(1495625), // Rule ID 61099 //
     /* 1495533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1495544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1495547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1495550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1495556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1495563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495583 */     // MIs[1] Operand 1
     /* 1495583 */     // No operand predicates
     /* 1495583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495587 */     // MIs[0] policy
     /* 1495587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495599 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1495602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495624 */     // GIR_Coverage, 61099,
     /* 1495624 */     GIR_EraseRootFromParent_Done,
     /* 1495625 */   // Label 20868: @1495625
     /* 1495625 */   GIM_Try, /*On fail goto*//*Label 20869*/ GIMT_Encode4(1495722), // Rule ID 61106 //
     /* 1495630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1495641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1495644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1495647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495680 */     // MIs[1] Operand 1
     /* 1495680 */     // No operand predicates
     /* 1495680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495684 */     // MIs[0] policy
     /* 1495684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1495699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495721 */     // GIR_Coverage, 61106,
     /* 1495721 */     GIR_EraseRootFromParent_Done,
     /* 1495722 */   // Label 20869: @1495722
     /* 1495722 */   GIM_Try, /*On fail goto*//*Label 20870*/ GIMT_Encode4(1495819), // Rule ID 61107 //
     /* 1495727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1495738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1495741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1495744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1495750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1495757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495777 */     // MIs[1] Operand 1
     /* 1495777 */     // No operand predicates
     /* 1495777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495781 */     // MIs[0] policy
     /* 1495781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495793 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1495796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495818 */     // GIR_Coverage, 61107,
     /* 1495818 */     GIR_EraseRootFromParent_Done,
     /* 1495819 */   // Label 20870: @1495819
     /* 1495819 */   GIM_Try, /*On fail goto*//*Label 20871*/ GIMT_Encode4(1495916), // Rule ID 61114 //
     /* 1495824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1495827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1495835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1495838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1495841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1495844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495874 */     // MIs[1] Operand 1
     /* 1495874 */     // No operand predicates
     /* 1495874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495878 */     // MIs[0] policy
     /* 1495878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1495893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1495904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495915 */     // GIR_Coverage, 61114,
     /* 1495915 */     GIR_EraseRootFromParent_Done,
     /* 1495916 */   // Label 20871: @1495916
     /* 1495916 */   GIM_Try, /*On fail goto*//*Label 20872*/ GIMT_Encode4(1496013), // Rule ID 61115 //
     /* 1495921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1495924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1495929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1495932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1495935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1495938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1495941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1495944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1495951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1495955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1495963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1495967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1495971 */     // MIs[1] Operand 1
     /* 1495971 */     // No operand predicates
     /* 1495971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1495975 */     // MIs[0] policy
     /* 1495975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1495980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495987 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1495990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1495994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1495999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496012 */     // GIR_Coverage, 61115,
     /* 1496012 */     GIR_EraseRootFromParent_Done,
     /* 1496013 */   // Label 20872: @1496013
     /* 1496013 */   GIM_Try, /*On fail goto*//*Label 20873*/ GIMT_Encode4(1496110), // Rule ID 61122 //
     /* 1496018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1496035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496064 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496068 */     // MIs[1] Operand 1
     /* 1496068 */     // No operand predicates
     /* 1496068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496072 */     // MIs[0] policy
     /* 1496072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1496087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496109 */     // GIR_Coverage, 61122,
     /* 1496109 */     GIR_EraseRootFromParent_Done,
     /* 1496110 */   // Label 20873: @1496110
     /* 1496110 */   GIM_Try, /*On fail goto*//*Label 20874*/ GIMT_Encode4(1496207), // Rule ID 61123 //
     /* 1496115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1496126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1496129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1496132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496165 */     // MIs[1] Operand 1
     /* 1496165 */     // No operand predicates
     /* 1496165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496169 */     // MIs[0] policy
     /* 1496169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496181 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1496184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496206 */     // GIR_Coverage, 61123,
     /* 1496206 */     GIR_EraseRootFromParent_Done,
     /* 1496207 */   // Label 20874: @1496207
     /* 1496207 */   GIM_Try, /*On fail goto*//*Label 20875*/ GIMT_Encode4(1496304), // Rule ID 61130 //
     /* 1496212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496262 */     // MIs[1] Operand 1
     /* 1496262 */     // No operand predicates
     /* 1496262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496266 */     // MIs[0] policy
     /* 1496266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496278 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496303 */     // GIR_Coverage, 61130,
     /* 1496303 */     GIR_EraseRootFromParent_Done,
     /* 1496304 */   // Label 20875: @1496304
     /* 1496304 */   GIM_Try, /*On fail goto*//*Label 20876*/ GIMT_Encode4(1496401), // Rule ID 61131 //
     /* 1496309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1496326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1496332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1496339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496359 */     // MIs[1] Operand 1
     /* 1496359 */     // No operand predicates
     /* 1496359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496363 */     // MIs[0] policy
     /* 1496363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496375 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1496378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496400 */     // GIR_Coverage, 61131,
     /* 1496400 */     GIR_EraseRootFromParent_Done,
     /* 1496401 */   // Label 20876: @1496401
     /* 1496401 */   GIM_Try, /*On fail goto*//*Label 20877*/ GIMT_Encode4(1496498), // Rule ID 61138 //
     /* 1496406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496456 */     // MIs[1] Operand 1
     /* 1496456 */     // No operand predicates
     /* 1496456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496460 */     // MIs[0] policy
     /* 1496460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496497 */     // GIR_Coverage, 61138,
     /* 1496497 */     GIR_EraseRootFromParent_Done,
     /* 1496498 */   // Label 20877: @1496498
     /* 1496498 */   GIM_Try, /*On fail goto*//*Label 20878*/ GIMT_Encode4(1496595), // Rule ID 61139 //
     /* 1496503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1496526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1496533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496553 */     // MIs[1] Operand 1
     /* 1496553 */     // No operand predicates
     /* 1496553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496557 */     // MIs[0] policy
     /* 1496557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496569 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1496572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496594 */     // GIR_Coverage, 61139,
     /* 1496594 */     GIR_EraseRootFromParent_Done,
     /* 1496595 */   // Label 20878: @1496595
     /* 1496595 */   GIM_Try, /*On fail goto*//*Label 20879*/ GIMT_Encode4(1496692), // Rule ID 61146 //
     /* 1496600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1496603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1496611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1496614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1496617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496650 */     // MIs[1] Operand 1
     /* 1496650 */     // No operand predicates
     /* 1496650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496654 */     // MIs[0] policy
     /* 1496654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496666 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1496669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496691 */     // GIR_Coverage, 61146,
     /* 1496691 */     GIR_EraseRootFromParent_Done,
     /* 1496692 */   // Label 20879: @1496692
     /* 1496692 */   GIM_Try, /*On fail goto*//*Label 20880*/ GIMT_Encode4(1496789), // Rule ID 61147 //
     /* 1496697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1496700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1496705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1496708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1496711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1496714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1496720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1496727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1496747 */     // MIs[1] Operand 1
     /* 1496747 */     // No operand predicates
     /* 1496747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496751 */     // MIs[0] policy
     /* 1496751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496763 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1496766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496788 */     // GIR_Coverage, 61147,
     /* 1496788 */     GIR_EraseRootFromParent_Done,
     /* 1496789 */   // Label 20880: @1496789
     /* 1496789 */   GIM_Try, /*On fail goto*//*Label 20881*/ GIMT_Encode4(1496886), // Rule ID 62002 //
     /* 1496794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1496797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1496805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1496808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1496811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1496814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496840 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496844 */     // MIs[1] Operand 1
     /* 1496844 */     // No operand predicates
     /* 1496844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496848 */     // MIs[0] policy
     /* 1496848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1496863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496885 */     // GIR_Coverage, 62002,
     /* 1496885 */     GIR_EraseRootFromParent_Done,
     /* 1496886 */   // Label 20881: @1496886
     /* 1496886 */   GIM_Try, /*On fail goto*//*Label 20882*/ GIMT_Encode4(1496983), // Rule ID 62003 //
     /* 1496891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1496894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1496902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1496905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1496908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1496911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1496914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1496921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1496929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1496933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1496937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1496941 */     // MIs[1] Operand 1
     /* 1496941 */     // No operand predicates
     /* 1496941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1496945 */     // MIs[0] policy
     /* 1496945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1496950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496957 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1496960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1496964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1496969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1496971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1496979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496982 */     // GIR_Coverage, 62003,
     /* 1496982 */     GIR_EraseRootFromParent_Done,
     /* 1496983 */   // Label 20882: @1496983
     /* 1496983 */   GIM_Try, /*On fail goto*//*Label 20883*/ GIMT_Encode4(1497080), // Rule ID 62006 //
     /* 1496988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1496991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1496996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1496999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1497002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1497005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497038 */     // MIs[1] Operand 1
     /* 1497038 */     // No operand predicates
     /* 1497038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497042 */     // MIs[0] policy
     /* 1497042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497054 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497079 */     // GIR_Coverage, 62006,
     /* 1497079 */     GIR_EraseRootFromParent_Done,
     /* 1497080 */   // Label 20883: @1497080
     /* 1497080 */   GIM_Try, /*On fail goto*//*Label 20884*/ GIMT_Encode4(1497177), // Rule ID 62007 //
     /* 1497085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1497096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1497099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1497102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497135 */     // MIs[1] Operand 1
     /* 1497135 */     // No operand predicates
     /* 1497135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497139 */     // MIs[0] policy
     /* 1497139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497151 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497176 */     // GIR_Coverage, 62007,
     /* 1497176 */     GIR_EraseRootFromParent_Done,
     /* 1497177 */   // Label 20884: @1497177
     /* 1497177 */   GIM_Try, /*On fail goto*//*Label 20885*/ GIMT_Encode4(1497274), // Rule ID 62010 //
     /* 1497182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1497193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1497196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1497199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497232 */     // MIs[1] Operand 1
     /* 1497232 */     // No operand predicates
     /* 1497232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497236 */     // MIs[0] policy
     /* 1497236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497270 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497273 */     // GIR_Coverage, 62010,
     /* 1497273 */     GIR_EraseRootFromParent_Done,
     /* 1497274 */   // Label 20885: @1497274
     /* 1497274 */   GIM_Try, /*On fail goto*//*Label 20886*/ GIMT_Encode4(1497371), // Rule ID 62011 //
     /* 1497279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1497290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1497293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1497296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1497302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497329 */     // MIs[1] Operand 1
     /* 1497329 */     // No operand predicates
     /* 1497329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497333 */     // MIs[0] policy
     /* 1497333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497345 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1497367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497370 */     // GIR_Coverage, 62011,
     /* 1497370 */     GIR_EraseRootFromParent_Done,
     /* 1497371 */   // Label 20886: @1497371
     /* 1497371 */   GIM_Try, /*On fail goto*//*Label 20887*/ GIMT_Encode4(1497468), // Rule ID 62014 //
     /* 1497376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497426 */     // MIs[1] Operand 1
     /* 1497426 */     // No operand predicates
     /* 1497426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497430 */     // MIs[0] policy
     /* 1497430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497442 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497464 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497467 */     // GIR_Coverage, 62014,
     /* 1497467 */     GIR_EraseRootFromParent_Done,
     /* 1497468 */   // Label 20887: @1497468
     /* 1497468 */   GIM_Try, /*On fail goto*//*Label 20888*/ GIMT_Encode4(1497565), // Rule ID 62015 //
     /* 1497473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1497490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497523 */     // MIs[1] Operand 1
     /* 1497523 */     // No operand predicates
     /* 1497523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497527 */     // MIs[0] policy
     /* 1497527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497539 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1497542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497564 */     // GIR_Coverage, 62015,
     /* 1497564 */     GIR_EraseRootFromParent_Done,
     /* 1497565 */   // Label 20888: @1497565
     /* 1497565 */   GIM_Try, /*On fail goto*//*Label 20889*/ GIMT_Encode4(1497662), // Rule ID 62018 //
     /* 1497570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1497581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1497584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1497587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497620 */     // MIs[1] Operand 1
     /* 1497620 */     // No operand predicates
     /* 1497620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497624 */     // MIs[0] policy
     /* 1497624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497658 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497661 */     // GIR_Coverage, 62018,
     /* 1497661 */     GIR_EraseRootFromParent_Done,
     /* 1497662 */   // Label 20889: @1497662
     /* 1497662 */   GIM_Try, /*On fail goto*//*Label 20890*/ GIMT_Encode4(1497759), // Rule ID 62019 //
     /* 1497667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1497678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1497681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1497684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1497690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497717 */     // MIs[1] Operand 1
     /* 1497717 */     // No operand predicates
     /* 1497717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497721 */     // MIs[0] policy
     /* 1497721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497733 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497758 */     // GIR_Coverage, 62019,
     /* 1497758 */     GIR_EraseRootFromParent_Done,
     /* 1497759 */   // Label 20890: @1497759
     /* 1497759 */   GIM_Try, /*On fail goto*//*Label 20891*/ GIMT_Encode4(1497856), // Rule ID 62022 //
     /* 1497764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1497775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1497778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1497781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497814 */     // MIs[1] Operand 1
     /* 1497814 */     // No operand predicates
     /* 1497814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497818 */     // MIs[0] policy
     /* 1497818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497855 */     // GIR_Coverage, 62022,
     /* 1497855 */     GIR_EraseRootFromParent_Done,
     /* 1497856 */   // Label 20891: @1497856
     /* 1497856 */   GIM_Try, /*On fail goto*//*Label 20892*/ GIMT_Encode4(1497953), // Rule ID 62023 //
     /* 1497861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1497864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1497872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1497875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1497878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1497881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1497884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1497903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1497907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1497911 */     // MIs[1] Operand 1
     /* 1497911 */     // No operand predicates
     /* 1497911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1497915 */     // MIs[0] policy
     /* 1497915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1497920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497927 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1497930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1497934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1497939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1497941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497952 */     // GIR_Coverage, 62023,
     /* 1497952 */     GIR_EraseRootFromParent_Done,
     /* 1497953 */   // Label 20892: @1497953
     /* 1497953 */   GIM_Try, /*On fail goto*//*Label 20893*/ GIMT_Encode4(1498050), // Rule ID 62026 //
     /* 1497958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1497961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1497966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1497969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1497972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1497975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1497978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1497981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1497988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498008 */     // MIs[1] Operand 1
     /* 1498008 */     // No operand predicates
     /* 1498008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498012 */     // MIs[0] policy
     /* 1498012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498049 */     // GIR_Coverage, 62026,
     /* 1498049 */     GIR_EraseRootFromParent_Done,
     /* 1498050 */   // Label 20893: @1498050
     /* 1498050 */   GIM_Try, /*On fail goto*//*Label 20894*/ GIMT_Encode4(1498147), // Rule ID 62027 //
     /* 1498055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1498066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1498069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1498072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1498078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498105 */     // MIs[1] Operand 1
     /* 1498105 */     // No operand predicates
     /* 1498105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498109 */     // MIs[0] policy
     /* 1498109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498121 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498146 */     // GIR_Coverage, 62027,
     /* 1498146 */     GIR_EraseRootFromParent_Done,
     /* 1498147 */   // Label 20894: @1498147
     /* 1498147 */   GIM_Try, /*On fail goto*//*Label 20895*/ GIMT_Encode4(1498244), // Rule ID 62030 //
     /* 1498152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1498169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498202 */     // MIs[1] Operand 1
     /* 1498202 */     // No operand predicates
     /* 1498202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498206 */     // MIs[0] policy
     /* 1498206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498243 */     // GIR_Coverage, 62030,
     /* 1498243 */     GIR_EraseRootFromParent_Done,
     /* 1498244 */   // Label 20895: @1498244
     /* 1498244 */   GIM_Try, /*On fail goto*//*Label 20896*/ GIMT_Encode4(1498341), // Rule ID 62031 //
     /* 1498249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1498260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1498263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1498266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1498272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498299 */     // MIs[1] Operand 1
     /* 1498299 */     // No operand predicates
     /* 1498299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498303 */     // MIs[0] policy
     /* 1498303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498315 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498340 */     // GIR_Coverage, 62031,
     /* 1498340 */     GIR_EraseRootFromParent_Done,
     /* 1498341 */   // Label 20896: @1498341
     /* 1498341 */   GIM_Try, /*On fail goto*//*Label 20897*/ GIMT_Encode4(1498438), // Rule ID 62034 //
     /* 1498346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1498363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498396 */     // MIs[1] Operand 1
     /* 1498396 */     // No operand predicates
     /* 1498396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498400 */     // MIs[0] policy
     /* 1498400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498412 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498437 */     // GIR_Coverage, 62034,
     /* 1498437 */     GIR_EraseRootFromParent_Done,
     /* 1498438 */   // Label 20897: @1498438
     /* 1498438 */   GIM_Try, /*On fail goto*//*Label 20898*/ GIMT_Encode4(1498535), // Rule ID 62035 //
     /* 1498443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1498460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1498466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498493 */     // MIs[1] Operand 1
     /* 1498493 */     // No operand predicates
     /* 1498493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498497 */     // MIs[0] policy
     /* 1498497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498509 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498534 */     // GIR_Coverage, 62035,
     /* 1498534 */     GIR_EraseRootFromParent_Done,
     /* 1498535 */   // Label 20898: @1498535
     /* 1498535 */   GIM_Try, /*On fail goto*//*Label 20899*/ GIMT_Encode4(1498632), // Rule ID 62038 //
     /* 1498540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1498551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1498554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1498557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498590 */     // MIs[1] Operand 1
     /* 1498590 */     // No operand predicates
     /* 1498590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498594 */     // MIs[0] policy
     /* 1498594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498631 */     // GIR_Coverage, 62038,
     /* 1498631 */     GIR_EraseRootFromParent_Done,
     /* 1498632 */   // Label 20899: @1498632
     /* 1498632 */   GIM_Try, /*On fail goto*//*Label 20900*/ GIMT_Encode4(1498729), // Rule ID 62039 //
     /* 1498637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1498648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1498651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1498654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1498660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1498667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498687 */     // MIs[1] Operand 1
     /* 1498687 */     // No operand predicates
     /* 1498687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498691 */     // MIs[0] policy
     /* 1498691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498703 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1498706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498728 */     // GIR_Coverage, 62039,
     /* 1498728 */     GIR_EraseRootFromParent_Done,
     /* 1498729 */   // Label 20900: @1498729
     /* 1498729 */   GIM_Try, /*On fail goto*//*Label 20901*/ GIMT_Encode4(1498826), // Rule ID 62042 //
     /* 1498734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1498745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1498748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1498751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498784 */     // MIs[1] Operand 1
     /* 1498784 */     // No operand predicates
     /* 1498784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498788 */     // MIs[0] policy
     /* 1498788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1498803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498825 */     // GIR_Coverage, 62042,
     /* 1498825 */     GIR_EraseRootFromParent_Done,
     /* 1498826 */   // Label 20901: @1498826
     /* 1498826 */   GIM_Try, /*On fail goto*//*Label 20902*/ GIMT_Encode4(1498923), // Rule ID 62043 //
     /* 1498831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1498834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1498842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1498845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1498848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1498851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1498854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1498861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498881 */     // MIs[1] Operand 1
     /* 1498881 */     // No operand predicates
     /* 1498881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498885 */     // MIs[0] policy
     /* 1498885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498897 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1498900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1498904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1498909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1498911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1498919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498922 */     // GIR_Coverage, 62043,
     /* 1498922 */     GIR_EraseRootFromParent_Done,
     /* 1498923 */   // Label 20902: @1498923
     /* 1498923 */   GIM_Try, /*On fail goto*//*Label 20903*/ GIMT_Encode4(1499020), // Rule ID 62046 //
     /* 1498928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1498931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1498936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1498939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1498942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1498945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1498948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1498951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1498958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1498970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1498974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1498978 */     // MIs[1] Operand 1
     /* 1498978 */     // No operand predicates
     /* 1498978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1498982 */     // MIs[0] policy
     /* 1498982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1498987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498994 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1498997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499019 */     // GIR_Coverage, 62046,
     /* 1499019 */     GIR_EraseRootFromParent_Done,
     /* 1499020 */   // Label 20903: @1499020
     /* 1499020 */   GIM_Try, /*On fail goto*//*Label 20904*/ GIMT_Encode4(1499117), // Rule ID 62047 //
     /* 1499025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1499036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1499039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1499042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499075 */     // MIs[1] Operand 1
     /* 1499075 */     // No operand predicates
     /* 1499075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499079 */     // MIs[0] policy
     /* 1499079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499091 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499116 */     // GIR_Coverage, 62047,
     /* 1499116 */     GIR_EraseRootFromParent_Done,
     /* 1499117 */   // Label 20904: @1499117
     /* 1499117 */   GIM_Try, /*On fail goto*//*Label 20905*/ GIMT_Encode4(1499214), // Rule ID 62050 //
     /* 1499122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1499133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1499136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1499139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1499145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499172 */     // MIs[1] Operand 1
     /* 1499172 */     // No operand predicates
     /* 1499172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499176 */     // MIs[0] policy
     /* 1499176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499188 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499213 */     // GIR_Coverage, 62050,
     /* 1499213 */     GIR_EraseRootFromParent_Done,
     /* 1499214 */   // Label 20905: @1499214
     /* 1499214 */   GIM_Try, /*On fail goto*//*Label 20906*/ GIMT_Encode4(1499311), // Rule ID 62051 //
     /* 1499219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1499230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1499233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1499236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1499242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499269 */     // MIs[1] Operand 1
     /* 1499269 */     // No operand predicates
     /* 1499269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499273 */     // MIs[0] policy
     /* 1499273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499285 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1499307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499310 */     // GIR_Coverage, 62051,
     /* 1499310 */     GIR_EraseRootFromParent_Done,
     /* 1499311 */   // Label 20906: @1499311
     /* 1499311 */   GIM_Try, /*On fail goto*//*Label 20907*/ GIMT_Encode4(1499408), // Rule ID 62054 //
     /* 1499316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1499327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1499330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499366 */     // MIs[1] Operand 1
     /* 1499366 */     // No operand predicates
     /* 1499366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499370 */     // MIs[0] policy
     /* 1499370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499407 */     // GIR_Coverage, 62054,
     /* 1499407 */     GIR_EraseRootFromParent_Done,
     /* 1499408 */   // Label 20907: @1499408
     /* 1499408 */   GIM_Try, /*On fail goto*//*Label 20908*/ GIMT_Encode4(1499505), // Rule ID 62055 //
     /* 1499413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1499424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1499427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1499430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1499436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499463 */     // MIs[1] Operand 1
     /* 1499463 */     // No operand predicates
     /* 1499463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499467 */     // MIs[0] policy
     /* 1499467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499504 */     // GIR_Coverage, 62055,
     /* 1499504 */     GIR_EraseRootFromParent_Done,
     /* 1499505 */   // Label 20908: @1499505
     /* 1499505 */   GIM_Try, /*On fail goto*//*Label 20909*/ GIMT_Encode4(1499602), // Rule ID 62058 //
     /* 1499510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1499521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1499524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1499527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499560 */     // MIs[1] Operand 1
     /* 1499560 */     // No operand predicates
     /* 1499560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499564 */     // MIs[0] policy
     /* 1499564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499576 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499601 */     // GIR_Coverage, 62058,
     /* 1499601 */     GIR_EraseRootFromParent_Done,
     /* 1499602 */   // Label 20909: @1499602
     /* 1499602 */   GIM_Try, /*On fail goto*//*Label 20910*/ GIMT_Encode4(1499699), // Rule ID 62059 //
     /* 1499607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1499618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1499621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1499624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1499630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1499637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499657 */     // MIs[1] Operand 1
     /* 1499657 */     // No operand predicates
     /* 1499657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499661 */     // MIs[0] policy
     /* 1499661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499673 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1499676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499698 */     // GIR_Coverage, 62059,
     /* 1499698 */     GIR_EraseRootFromParent_Done,
     /* 1499699 */   // Label 20910: @1499699
     /* 1499699 */   GIM_Try, /*On fail goto*//*Label 20911*/ GIMT_Encode4(1499796), // Rule ID 62062 //
     /* 1499704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1499715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1499718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1499721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499754 */     // MIs[1] Operand 1
     /* 1499754 */     // No operand predicates
     /* 1499754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499758 */     // MIs[0] policy
     /* 1499758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499770 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499795 */     // GIR_Coverage, 62062,
     /* 1499795 */     GIR_EraseRootFromParent_Done,
     /* 1499796 */   // Label 20911: @1499796
     /* 1499796 */   GIM_Try, /*On fail goto*//*Label 20912*/ GIMT_Encode4(1499893), // Rule ID 62063 //
     /* 1499801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1499812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1499815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1499818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1499821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1499824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1499831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499851 */     // MIs[1] Operand 1
     /* 1499851 */     // No operand predicates
     /* 1499851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499855 */     // MIs[0] policy
     /* 1499855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499867 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1499870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499892 */     // GIR_Coverage, 62063,
     /* 1499892 */     GIR_EraseRootFromParent_Done,
     /* 1499893 */   // Label 20912: @1499893
     /* 1499893 */   GIM_Try, /*On fail goto*//*Label 20913*/ GIMT_Encode4(1499990), // Rule ID 62066 //
     /* 1499898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1499901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1499906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1499909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1499912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1499915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1499918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1499921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1499928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1499940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1499944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1499948 */     // MIs[1] Operand 1
     /* 1499948 */     // No operand predicates
     /* 1499948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1499952 */     // MIs[0] policy
     /* 1499952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1499957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1499967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1499971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1499976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1499978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499989 */     // GIR_Coverage, 62066,
     /* 1499989 */     GIR_EraseRootFromParent_Done,
     /* 1499990 */   // Label 20913: @1499990
     /* 1499990 */   GIM_Try, /*On fail goto*//*Label 20914*/ GIMT_Encode4(1500087), // Rule ID 62067 //
     /* 1499995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1499998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1500006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1500009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1500012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500045 */     // MIs[1] Operand 1
     /* 1500045 */     // No operand predicates
     /* 1500045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500049 */     // MIs[0] policy
     /* 1500049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500061 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500086 */     // GIR_Coverage, 62067,
     /* 1500086 */     GIR_EraseRootFromParent_Done,
     /* 1500087 */   // Label 20914: @1500087
     /* 1500087 */   GIM_Try, /*On fail goto*//*Label 20915*/ GIMT_Encode4(1500184), // Rule ID 62070 //
     /* 1500092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500142 */     // MIs[1] Operand 1
     /* 1500142 */     // No operand predicates
     /* 1500142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500146 */     // MIs[0] policy
     /* 1500146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500183 */     // GIR_Coverage, 62070,
     /* 1500183 */     GIR_EraseRootFromParent_Done,
     /* 1500184 */   // Label 20915: @1500184
     /* 1500184 */   GIM_Try, /*On fail goto*//*Label 20916*/ GIMT_Encode4(1500281), // Rule ID 62071 //
     /* 1500189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1500200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1500203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1500206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500239 */     // MIs[1] Operand 1
     /* 1500239 */     // No operand predicates
     /* 1500239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500243 */     // MIs[0] policy
     /* 1500243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500255 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500280 */     // GIR_Coverage, 62071,
     /* 1500280 */     GIR_EraseRootFromParent_Done,
     /* 1500281 */   // Label 20916: @1500281
     /* 1500281 */   GIM_Try, /*On fail goto*//*Label 20917*/ GIMT_Encode4(1500378), // Rule ID 62074 //
     /* 1500286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1500297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1500300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1500303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500336 */     // MIs[1] Operand 1
     /* 1500336 */     // No operand predicates
     /* 1500336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500340 */     // MIs[0] policy
     /* 1500340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500352 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500377 */     // GIR_Coverage, 62074,
     /* 1500377 */     GIR_EraseRootFromParent_Done,
     /* 1500378 */   // Label 20917: @1500378
     /* 1500378 */   GIM_Try, /*On fail goto*//*Label 20918*/ GIMT_Encode4(1500475), // Rule ID 62075 //
     /* 1500383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1500394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1500397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1500400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1500406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500433 */     // MIs[1] Operand 1
     /* 1500433 */     // No operand predicates
     /* 1500433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500437 */     // MIs[0] policy
     /* 1500437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500449 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500474 */     // GIR_Coverage, 62075,
     /* 1500474 */     GIR_EraseRootFromParent_Done,
     /* 1500475 */   // Label 20918: @1500475
     /* 1500475 */   GIM_Try, /*On fail goto*//*Label 20919*/ GIMT_Encode4(1500572), // Rule ID 62078 //
     /* 1500480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1500491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1500494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1500497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500530 */     // MIs[1] Operand 1
     /* 1500530 */     // No operand predicates
     /* 1500530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500534 */     // MIs[0] policy
     /* 1500534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500546 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500571 */     // GIR_Coverage, 62078,
     /* 1500571 */     GIR_EraseRootFromParent_Done,
     /* 1500572 */   // Label 20919: @1500572
     /* 1500572 */   GIM_Try, /*On fail goto*//*Label 20920*/ GIMT_Encode4(1500669), // Rule ID 62079 //
     /* 1500577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1500588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1500591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1500594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1500600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1500607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500627 */     // MIs[1] Operand 1
     /* 1500627 */     // No operand predicates
     /* 1500627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500631 */     // MIs[0] policy
     /* 1500631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500643 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1500646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500668 */     // GIR_Coverage, 62079,
     /* 1500668 */     GIR_EraseRootFromParent_Done,
     /* 1500669 */   // Label 20920: @1500669
     /* 1500669 */   GIM_Try, /*On fail goto*//*Label 20921*/ GIMT_Encode4(1500766), // Rule ID 62082 //
     /* 1500674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1500685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1500688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1500691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500724 */     // MIs[1] Operand 1
     /* 1500724 */     // No operand predicates
     /* 1500724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500728 */     // MIs[0] policy
     /* 1500728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500740 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500765 */     // GIR_Coverage, 62082,
     /* 1500765 */     GIR_EraseRootFromParent_Done,
     /* 1500766 */   // Label 20921: @1500766
     /* 1500766 */   GIM_Try, /*On fail goto*//*Label 20922*/ GIMT_Encode4(1500863), // Rule ID 62083 //
     /* 1500771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1500782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1500785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1500788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1500794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1500801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500821 */     // MIs[1] Operand 1
     /* 1500821 */     // No operand predicates
     /* 1500821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500825 */     // MIs[0] policy
     /* 1500825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500837 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1500840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500862 */     // GIR_Coverage, 62083,
     /* 1500862 */     GIR_EraseRootFromParent_Done,
     /* 1500863 */   // Label 20922: @1500863
     /* 1500863 */   GIM_Try, /*On fail goto*//*Label 20923*/ GIMT_Encode4(1500960), // Rule ID 62086 //
     /* 1500868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1500871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1500879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1500882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1500885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1500888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1500910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1500914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1500918 */     // MIs[1] Operand 1
     /* 1500918 */     // No operand predicates
     /* 1500918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1500922 */     // MIs[0] policy
     /* 1500922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1500927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1500937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1500941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1500946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1500948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500959 */     // GIR_Coverage, 62086,
     /* 1500959 */     GIR_EraseRootFromParent_Done,
     /* 1500960 */   // Label 20923: @1500960
     /* 1500960 */   GIM_Try, /*On fail goto*//*Label 20924*/ GIMT_Encode4(1501057), // Rule ID 62087 //
     /* 1500965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1500968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1500973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1500976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1500979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1500982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1500985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1500988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1500995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1500999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1501007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1501011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1501015 */     // MIs[1] Operand 1
     /* 1501015 */     // No operand predicates
     /* 1501015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501019 */     // MIs[0] policy
     /* 1501019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1501024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501031 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1501034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1501043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1501045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501056 */     // GIR_Coverage, 62087,
     /* 1501056 */     GIR_EraseRootFromParent_Done,
     /* 1501057 */   // Label 20924: @1501057
     /* 1501057 */   GIM_Try, /*On fail goto*//*Label 20925*/ GIMT_Encode4(1501139), // Rule ID 2706 //
     /* 1501062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1501070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501101 */     // MIs[0] round
     /* 1501101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501104 */     // MIs[0] policy
     /* 1501104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501114 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1501117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501138 */     // GIR_Coverage, 2706,
     /* 1501138 */     GIR_EraseRootFromParent_Done,
     /* 1501139 */   // Label 20925: @1501139
     /* 1501139 */   GIM_Try, /*On fail goto*//*Label 20926*/ GIMT_Encode4(1501221), // Rule ID 2707 //
     /* 1501144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1501152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501183 */     // MIs[0] round
     /* 1501183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501186 */     // MIs[0] policy
     /* 1501186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501196 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1501199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501220 */     // GIR_Coverage, 2707,
     /* 1501220 */     GIR_EraseRootFromParent_Done,
     /* 1501221 */   // Label 20926: @1501221
     /* 1501221 */   GIM_Try, /*On fail goto*//*Label 20927*/ GIMT_Encode4(1501303), // Rule ID 2742 //
     /* 1501226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1501229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1501234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501265 */     // MIs[0] round
     /* 1501265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501268 */     // MIs[0] policy
     /* 1501268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1501281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501302 */     // GIR_Coverage, 2742,
     /* 1501302 */     GIR_EraseRootFromParent_Done,
     /* 1501303 */   // Label 20927: @1501303
     /* 1501303 */   GIM_Try, /*On fail goto*//*Label 20928*/ GIMT_Encode4(1501385), // Rule ID 2743 //
     /* 1501308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1501311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1501316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1501328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1501335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1501347 */     // MIs[0] round
     /* 1501347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501350 */     // MIs[0] policy
     /* 1501350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501360 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1501363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1501367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1501369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1501371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501384 */     // GIR_Coverage, 2743,
     /* 1501384 */     GIR_EraseRootFromParent_Done,
     /* 1501385 */   // Label 20928: @1501385
     /* 1501385 */   GIM_Try, /*On fail goto*//*Label 20929*/ GIMT_Encode4(1501467), // Rule ID 2774 //
     /* 1501390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501429 */     // MIs[0] round
     /* 1501429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501432 */     // MIs[0] policy
     /* 1501432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501442 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1501445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501466 */     // GIR_Coverage, 2774,
     /* 1501466 */     GIR_EraseRootFromParent_Done,
     /* 1501467 */   // Label 20929: @1501467
     /* 1501467 */   GIM_Try, /*On fail goto*//*Label 20930*/ GIMT_Encode4(1501549), // Rule ID 2775 //
     /* 1501472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1501483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1501486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1501489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1501492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501511 */     // MIs[0] round
     /* 1501511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501514 */     // MIs[0] policy
     /* 1501514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501524 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1501527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501548 */     // GIR_Coverage, 2775,
     /* 1501548 */     GIR_EraseRootFromParent_Done,
     /* 1501549 */   // Label 20930: @1501549
     /* 1501549 */   GIM_Try, /*On fail goto*//*Label 20931*/ GIMT_Encode4(1501631), // Rule ID 17754 //
     /* 1501554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1501571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1501574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501593 */     // MIs[0] round
     /* 1501593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501596 */     // MIs[0] policy
     /* 1501596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501606 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1501609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501630 */     // GIR_Coverage, 17754,
     /* 1501630 */     GIR_EraseRootFromParent_Done,
     /* 1501631 */   // Label 20931: @1501631
     /* 1501631 */   GIM_Try, /*On fail goto*//*Label 20932*/ GIMT_Encode4(1501713), // Rule ID 17755 //
     /* 1501636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1501647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1501650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1501653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1501656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501675 */     // MIs[0] round
     /* 1501675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501678 */     // MIs[0] policy
     /* 1501678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501688 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1501691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501712 */     // GIR_Coverage, 17755,
     /* 1501712 */     GIR_EraseRootFromParent_Done,
     /* 1501713 */   // Label 20932: @1501713
     /* 1501713 */   GIM_Try, /*On fail goto*//*Label 20933*/ GIMT_Encode4(1501795), // Rule ID 17758 //
     /* 1501718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1501721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1501729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1501732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1501735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1501738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501757 */     // MIs[0] round
     /* 1501757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501760 */     // MIs[0] policy
     /* 1501760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501770 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1501773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501794 */     // GIR_Coverage, 17758,
     /* 1501794 */     GIR_EraseRootFromParent_Done,
     /* 1501795 */   // Label 20933: @1501795
     /* 1501795 */   GIM_Try, /*On fail goto*//*Label 20934*/ GIMT_Encode4(1501877), // Rule ID 17759 //
     /* 1501800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1501803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1501811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1501814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1501817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1501820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501839 */     // MIs[0] round
     /* 1501839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501842 */     // MIs[0] policy
     /* 1501842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501852 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1501855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501876 */     // GIR_Coverage, 17759,
     /* 1501876 */     GIR_EraseRootFromParent_Done,
     /* 1501877 */   // Label 20934: @1501877
     /* 1501877 */   GIM_Try, /*On fail goto*//*Label 20935*/ GIMT_Encode4(1501959), // Rule ID 17762 //
     /* 1501882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1501893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1501896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1501899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1501902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501921 */     // MIs[0] round
     /* 1501921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501924 */     // MIs[0] policy
     /* 1501924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501934 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1501937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501958 */     // GIR_Coverage, 17762,
     /* 1501958 */     GIR_EraseRootFromParent_Done,
     /* 1501959 */   // Label 20935: @1501959
     /* 1501959 */   GIM_Try, /*On fail goto*//*Label 20936*/ GIMT_Encode4(1502041), // Rule ID 17763 //
     /* 1501964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1501972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1501975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1501978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1501981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1501984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1501999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502003 */     // MIs[0] round
     /* 1502003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502006 */     // MIs[0] policy
     /* 1502006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502016 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1502019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502040 */     // GIR_Coverage, 17763,
     /* 1502040 */     GIR_EraseRootFromParent_Done,
     /* 1502041 */   // Label 20936: @1502041
     /* 1502041 */   GIM_Try, /*On fail goto*//*Label 20937*/ GIMT_Encode4(1502123), // Rule ID 17766 //
     /* 1502046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502085 */     // MIs[0] round
     /* 1502085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502088 */     // MIs[0] policy
     /* 1502088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502098 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1502101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502122 */     // GIR_Coverage, 17766,
     /* 1502122 */     GIR_EraseRootFromParent_Done,
     /* 1502123 */   // Label 20937: @1502123
     /* 1502123 */   GIM_Try, /*On fail goto*//*Label 20938*/ GIMT_Encode4(1502205), // Rule ID 17767 //
     /* 1502128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1502145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502167 */     // MIs[0] round
     /* 1502167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502170 */     // MIs[0] policy
     /* 1502170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502180 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1502183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502204 */     // GIR_Coverage, 17767,
     /* 1502204 */     GIR_EraseRootFromParent_Done,
     /* 1502205 */   // Label 20938: @1502205
     /* 1502205 */   GIM_Try, /*On fail goto*//*Label 20939*/ GIMT_Encode4(1502287), // Rule ID 17770 //
     /* 1502210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1502213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502249 */     // MIs[0] round
     /* 1502249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502252 */     // MIs[0] policy
     /* 1502252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502262 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1502265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502286 */     // GIR_Coverage, 17770,
     /* 1502286 */     GIR_EraseRootFromParent_Done,
     /* 1502287 */   // Label 20939: @1502287
     /* 1502287 */   GIM_Try, /*On fail goto*//*Label 20940*/ GIMT_Encode4(1502369), // Rule ID 17771 //
     /* 1502292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1502295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1502303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1502306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1502309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1502312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502331 */     // MIs[0] round
     /* 1502331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502334 */     // MIs[0] policy
     /* 1502334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502344 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1502347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502368 */     // GIR_Coverage, 17771,
     /* 1502368 */     GIR_EraseRootFromParent_Done,
     /* 1502369 */   // Label 20940: @1502369
     /* 1502369 */   GIM_Try, /*On fail goto*//*Label 20941*/ GIMT_Encode4(1502451), // Rule ID 17774 //
     /* 1502374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502413 */     // MIs[0] round
     /* 1502413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502416 */     // MIs[0] policy
     /* 1502416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502426 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1502429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502450 */     // GIR_Coverage, 17774,
     /* 1502450 */     GIR_EraseRootFromParent_Done,
     /* 1502451 */   // Label 20941: @1502451
     /* 1502451 */   GIM_Try, /*On fail goto*//*Label 20942*/ GIMT_Encode4(1502533), // Rule ID 17775 //
     /* 1502456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1502467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1502470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1502473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1502476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502495 */     // MIs[0] round
     /* 1502495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502498 */     // MIs[0] policy
     /* 1502498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502508 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1502511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502532 */     // GIR_Coverage, 17775,
     /* 1502532 */     GIR_EraseRootFromParent_Done,
     /* 1502533 */   // Label 20942: @1502533
     /* 1502533 */   GIM_Try, /*On fail goto*//*Label 20943*/ GIMT_Encode4(1502615), // Rule ID 17778 //
     /* 1502538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1502549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1502552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1502555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1502558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502577 */     // MIs[0] round
     /* 1502577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502580 */     // MIs[0] policy
     /* 1502580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502590 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1502593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502614 */     // GIR_Coverage, 17778,
     /* 1502614 */     GIR_EraseRootFromParent_Done,
     /* 1502615 */   // Label 20943: @1502615
     /* 1502615 */   GIM_Try, /*On fail goto*//*Label 20944*/ GIMT_Encode4(1502697), // Rule ID 17779 //
     /* 1502620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1502631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1502634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1502637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1502640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1502659 */     // MIs[0] round
     /* 1502659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502662 */     // MIs[0] policy
     /* 1502662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502672 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1502675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502696 */     // GIR_Coverage, 17779,
     /* 1502696 */     GIR_EraseRootFromParent_Done,
     /* 1502697 */   // Label 20944: @1502697
     /* 1502697 */   GIM_Try, /*On fail goto*//*Label 20945*/ GIMT_Encode4(1502779), // Rule ID 17782 //
     /* 1502702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1502713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1502716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1502719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1502722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502741 */     // MIs[0] round
     /* 1502741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502744 */     // MIs[0] policy
     /* 1502744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502754 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1502757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502778 */     // GIR_Coverage, 17782,
     /* 1502778 */     GIR_EraseRootFromParent_Done,
     /* 1502779 */   // Label 20945: @1502779
     /* 1502779 */   GIM_Try, /*On fail goto*//*Label 20946*/ GIMT_Encode4(1502861), // Rule ID 17783 //
     /* 1502784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1502795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1502798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1502801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1502804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502823 */     // MIs[0] round
     /* 1502823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502826 */     // MIs[0] policy
     /* 1502826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502836 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1502839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502860 */     // GIR_Coverage, 17783,
     /* 1502860 */     GIR_EraseRootFromParent_Done,
     /* 1502861 */   // Label 20946: @1502861
     /* 1502861 */   GIM_Try, /*On fail goto*//*Label 20947*/ GIMT_Encode4(1502943), // Rule ID 17786 //
     /* 1502866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1502877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1502880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1502883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1502886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502905 */     // MIs[0] round
     /* 1502905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502908 */     // MIs[0] policy
     /* 1502908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502918 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1502921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502942 */     // GIR_Coverage, 17786,
     /* 1502942 */     GIR_EraseRootFromParent_Done,
     /* 1502943 */   // Label 20947: @1502943
     /* 1502943 */   GIM_Try, /*On fail goto*//*Label 20948*/ GIMT_Encode4(1503025), // Rule ID 17787 //
     /* 1502948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1502956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1502959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1502962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1502965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1502968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1502987 */     // MIs[0] round
     /* 1502987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502990 */     // MIs[0] policy
     /* 1502990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503000 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1503003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503024 */     // GIR_Coverage, 17787,
     /* 1503024 */     GIR_EraseRootFromParent_Done,
     /* 1503025 */   // Label 20948: @1503025
     /* 1503025 */   GIM_Try, /*On fail goto*//*Label 20949*/ GIMT_Encode4(1503107), // Rule ID 17790 //
     /* 1503030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503069 */     // MIs[0] round
     /* 1503069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503072 */     // MIs[0] policy
     /* 1503072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503082 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1503085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503106 */     // GIR_Coverage, 17790,
     /* 1503106 */     GIR_EraseRootFromParent_Done,
     /* 1503107 */   // Label 20949: @1503107
     /* 1503107 */   GIM_Try, /*On fail goto*//*Label 20950*/ GIMT_Encode4(1503189), // Rule ID 17791 //
     /* 1503112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1503129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503151 */     // MIs[0] round
     /* 1503151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503154 */     // MIs[0] policy
     /* 1503154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503164 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1503167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503188 */     // GIR_Coverage, 17791,
     /* 1503188 */     GIR_EraseRootFromParent_Done,
     /* 1503189 */   // Label 20950: @1503189
     /* 1503189 */   GIM_Try, /*On fail goto*//*Label 20951*/ GIMT_Encode4(1503271), // Rule ID 17794 //
     /* 1503194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503233 */     // MIs[0] round
     /* 1503233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503236 */     // MIs[0] policy
     /* 1503236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503246 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1503249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503270 */     // GIR_Coverage, 17794,
     /* 1503270 */     GIR_EraseRootFromParent_Done,
     /* 1503271 */   // Label 20951: @1503271
     /* 1503271 */   GIM_Try, /*On fail goto*//*Label 20952*/ GIMT_Encode4(1503353), // Rule ID 17795 //
     /* 1503276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1503290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1503293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1503296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503315 */     // MIs[0] round
     /* 1503315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503318 */     // MIs[0] policy
     /* 1503318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503328 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1503331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503352 */     // GIR_Coverage, 17795,
     /* 1503352 */     GIR_EraseRootFromParent_Done,
     /* 1503353 */   // Label 20952: @1503353
     /* 1503353 */   GIM_Try, /*On fail goto*//*Label 20953*/ GIMT_Encode4(1503435), // Rule ID 17798 //
     /* 1503358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503397 */     // MIs[0] round
     /* 1503397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503400 */     // MIs[0] policy
     /* 1503400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503410 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1503413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503434 */     // GIR_Coverage, 17798,
     /* 1503434 */     GIR_EraseRootFromParent_Done,
     /* 1503435 */   // Label 20953: @1503435
     /* 1503435 */   GIM_Try, /*On fail goto*//*Label 20954*/ GIMT_Encode4(1503517), // Rule ID 17799 //
     /* 1503440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1503451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1503454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1503457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1503460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503479 */     // MIs[0] round
     /* 1503479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503482 */     // MIs[0] policy
     /* 1503482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503492 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1503495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503516 */     // GIR_Coverage, 17799,
     /* 1503516 */     GIR_EraseRootFromParent_Done,
     /* 1503517 */   // Label 20954: @1503517
     /* 1503517 */   GIM_Try, /*On fail goto*//*Label 20955*/ GIMT_Encode4(1503599), // Rule ID 17802 //
     /* 1503522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1503533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1503536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1503539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1503542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503561 */     // MIs[0] round
     /* 1503561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503564 */     // MIs[0] policy
     /* 1503564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503574 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1503577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503598 */     // GIR_Coverage, 17802,
     /* 1503598 */     GIR_EraseRootFromParent_Done,
     /* 1503599 */   // Label 20955: @1503599
     /* 1503599 */   GIM_Try, /*On fail goto*//*Label 20956*/ GIMT_Encode4(1503681), // Rule ID 17803 //
     /* 1503604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1503615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1503618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1503621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1503624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503643 */     // MIs[0] round
     /* 1503643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503646 */     // MIs[0] policy
     /* 1503646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503656 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1503659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503680 */     // GIR_Coverage, 17803,
     /* 1503680 */     GIR_EraseRootFromParent_Done,
     /* 1503681 */   // Label 20956: @1503681
     /* 1503681 */   GIM_Try, /*On fail goto*//*Label 20957*/ GIMT_Encode4(1503763), // Rule ID 17806 //
     /* 1503686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1503697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1503700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1503703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1503706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503725 */     // MIs[0] round
     /* 1503725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503728 */     // MIs[0] policy
     /* 1503728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503738 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1503741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503762 */     // GIR_Coverage, 17806,
     /* 1503762 */     GIR_EraseRootFromParent_Done,
     /* 1503763 */   // Label 20957: @1503763
     /* 1503763 */   GIM_Try, /*On fail goto*//*Label 20958*/ GIMT_Encode4(1503845), // Rule ID 17807 //
     /* 1503768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1503779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1503782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1503785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1503788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503807 */     // MIs[0] round
     /* 1503807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503810 */     // MIs[0] policy
     /* 1503810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503820 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1503823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503844 */     // GIR_Coverage, 17807,
     /* 1503844 */     GIR_EraseRootFromParent_Done,
     /* 1503845 */   // Label 20958: @1503845
     /* 1503845 */   GIM_Try, /*On fail goto*//*Label 20959*/ GIMT_Encode4(1503927), // Rule ID 17810 //
     /* 1503850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1503853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1503861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1503864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1503870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503889 */     // MIs[0] round
     /* 1503889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503892 */     // MIs[0] policy
     /* 1503892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503902 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1503905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503926 */     // GIR_Coverage, 17810,
     /* 1503926 */     GIR_EraseRootFromParent_Done,
     /* 1503927 */   // Label 20959: @1503927
     /* 1503927 */   GIM_Try, /*On fail goto*//*Label 20960*/ GIMT_Encode4(1504009), // Rule ID 17811 //
     /* 1503932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1503940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1503943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1503946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1503952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503971 */     // MIs[0] round
     /* 1503971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503974 */     // MIs[0] policy
     /* 1503974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503984 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1503987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504008 */     // GIR_Coverage, 17811,
     /* 1504008 */     GIR_EraseRootFromParent_Done,
     /* 1504009 */   // Label 20960: @1504009
     /* 1504009 */   GIM_Try, /*On fail goto*//*Label 20961*/ GIMT_Encode4(1504091), // Rule ID 17814 //
     /* 1504014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504053 */     // MIs[0] round
     /* 1504053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504056 */     // MIs[0] policy
     /* 1504056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504066 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1504069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504090 */     // GIR_Coverage, 17814,
     /* 1504090 */     GIR_EraseRootFromParent_Done,
     /* 1504091 */   // Label 20961: @1504091
     /* 1504091 */   GIM_Try, /*On fail goto*//*Label 20962*/ GIMT_Encode4(1504173), // Rule ID 17815 //
     /* 1504096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504135 */     // MIs[0] round
     /* 1504135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504138 */     // MIs[0] policy
     /* 1504138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504148 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1504151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504172 */     // GIR_Coverage, 17815,
     /* 1504172 */     GIR_EraseRootFromParent_Done,
     /* 1504173 */   // Label 20962: @1504173
     /* 1504173 */   GIM_Try, /*On fail goto*//*Label 20963*/ GIMT_Encode4(1504255), // Rule ID 17818 //
     /* 1504178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504217 */     // MIs[0] round
     /* 1504217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504220 */     // MIs[0] policy
     /* 1504220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504230 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1504233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504254 */     // GIR_Coverage, 17818,
     /* 1504254 */     GIR_EraseRootFromParent_Done,
     /* 1504255 */   // Label 20963: @1504255
     /* 1504255 */   GIM_Try, /*On fail goto*//*Label 20964*/ GIMT_Encode4(1504337), // Rule ID 17819 //
     /* 1504260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1504263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504299 */     // MIs[0] round
     /* 1504299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504302 */     // MIs[0] policy
     /* 1504302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504312 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1504315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504336 */     // GIR_Coverage, 17819,
     /* 1504336 */     GIR_EraseRootFromParent_Done,
     /* 1504337 */   // Label 20964: @1504337
     /* 1504337 */   GIM_Try, /*On fail goto*//*Label 20965*/ GIMT_Encode4(1504419), // Rule ID 17822 //
     /* 1504342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504381 */     // MIs[0] round
     /* 1504381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504384 */     // MIs[0] policy
     /* 1504384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504394 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1504397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504418 */     // GIR_Coverage, 17822,
     /* 1504418 */     GIR_EraseRootFromParent_Done,
     /* 1504419 */   // Label 20965: @1504419
     /* 1504419 */   GIM_Try, /*On fail goto*//*Label 20966*/ GIMT_Encode4(1504501), // Rule ID 17823 //
     /* 1504424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1504435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1504438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1504444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504463 */     // MIs[0] round
     /* 1504463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504466 */     // MIs[0] policy
     /* 1504466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504476 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1504479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504500 */     // GIR_Coverage, 17823,
     /* 1504500 */     GIR_EraseRootFromParent_Done,
     /* 1504501 */   // Label 20966: @1504501
     /* 1504501 */   GIM_Try, /*On fail goto*//*Label 20967*/ GIMT_Encode4(1504583), // Rule ID 17826 //
     /* 1504506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1504517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1504520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1504526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504545 */     // MIs[0] round
     /* 1504545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504548 */     // MIs[0] policy
     /* 1504548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504558 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1504561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504582 */     // GIR_Coverage, 17826,
     /* 1504582 */     GIR_EraseRootFromParent_Done,
     /* 1504583 */   // Label 20967: @1504583
     /* 1504583 */   GIM_Try, /*On fail goto*//*Label 20968*/ GIMT_Encode4(1504665), // Rule ID 17827 //
     /* 1504588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1504591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1504599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1504602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1504608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504627 */     // MIs[0] round
     /* 1504627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504630 */     // MIs[0] policy
     /* 1504630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504640 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1504643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504664 */     // GIR_Coverage, 17827,
     /* 1504664 */     GIR_EraseRootFromParent_Done,
     /* 1504665 */   // Label 20968: @1504665
     /* 1504665 */   GIM_Try, /*On fail goto*//*Label 20969*/ GIMT_Encode4(1504747), // Rule ID 17830 //
     /* 1504670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1504673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1504681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1504684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1504690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504709 */     // MIs[0] round
     /* 1504709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504712 */     // MIs[0] policy
     /* 1504712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504722 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1504725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504746 */     // GIR_Coverage, 17830,
     /* 1504746 */     GIR_EraseRootFromParent_Done,
     /* 1504747 */   // Label 20969: @1504747
     /* 1504747 */   GIM_Try, /*On fail goto*//*Label 20970*/ GIMT_Encode4(1504829), // Rule ID 17831 //
     /* 1504752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1504763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1504766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1504772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504791 */     // MIs[0] round
     /* 1504791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504794 */     // MIs[0] policy
     /* 1504794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1504807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504828 */     // GIR_Coverage, 17831,
     /* 1504828 */     GIR_EraseRootFromParent_Done,
     /* 1504829 */   // Label 20970: @1504829
     /* 1504829 */   GIM_Try, /*On fail goto*//*Label 20971*/ GIMT_Encode4(1504911), // Rule ID 17834 //
     /* 1504834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1504845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1504848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1504854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504873 */     // MIs[0] round
     /* 1504873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504876 */     // MIs[0] policy
     /* 1504876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504886 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1504889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504910 */     // GIR_Coverage, 17834,
     /* 1504910 */     GIR_EraseRootFromParent_Done,
     /* 1504911 */   // Label 20971: @1504911
     /* 1504911 */   GIM_Try, /*On fail goto*//*Label 20972*/ GIMT_Encode4(1504993), // Rule ID 17835 //
     /* 1504916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1504924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1504927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1504930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1504933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1504936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1504951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504955 */     // MIs[0] round
     /* 1504955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504958 */     // MIs[0] policy
     /* 1504958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504968 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1504971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504992 */     // GIR_Coverage, 17835,
     /* 1504992 */     GIR_EraseRootFromParent_Done,
     /* 1504993 */   // Label 20972: @1504993
     /* 1504993 */   GIM_Try, /*On fail goto*//*Label 20973*/ GIMT_Encode4(1505075), // Rule ID 17838 //
     /* 1504998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505037 */     // MIs[0] round
     /* 1505037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505040 */     // MIs[0] policy
     /* 1505040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505050 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1505053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505074 */     // GIR_Coverage, 17838,
     /* 1505074 */     GIR_EraseRootFromParent_Done,
     /* 1505075 */   // Label 20973: @1505075
     /* 1505075 */   GIM_Try, /*On fail goto*//*Label 20974*/ GIMT_Encode4(1505157), // Rule ID 17839 //
     /* 1505080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505119 */     // MIs[0] round
     /* 1505119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505122 */     // MIs[0] policy
     /* 1505122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505132 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1505135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505156 */     // GIR_Coverage, 17839,
     /* 1505156 */     GIR_EraseRootFromParent_Done,
     /* 1505157 */   // Label 20974: @1505157
     /* 1505157 */   GIM_Try, /*On fail goto*//*Label 20975*/ GIMT_Encode4(1505239), // Rule ID 17842 //
     /* 1505162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505201 */     // MIs[0] round
     /* 1505201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505204 */     // MIs[0] policy
     /* 1505204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505214 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1505217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505238 */     // GIR_Coverage, 17842,
     /* 1505238 */     GIR_EraseRootFromParent_Done,
     /* 1505239 */   // Label 20975: @1505239
     /* 1505239 */   GIM_Try, /*On fail goto*//*Label 20976*/ GIMT_Encode4(1505321), // Rule ID 17843 //
     /* 1505244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1505261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1505279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505283 */     // MIs[0] round
     /* 1505283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505286 */     // MIs[0] policy
     /* 1505286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505296 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1505299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505320 */     // GIR_Coverage, 17843,
     /* 1505320 */     GIR_EraseRootFromParent_Done,
     /* 1505321 */   // Label 20976: @1505321
     /* 1505321 */   GIM_Try, /*On fail goto*//*Label 20977*/ GIMT_Encode4(1505403), // Rule ID 17846 //
     /* 1505326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505365 */     // MIs[0] round
     /* 1505365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505368 */     // MIs[0] policy
     /* 1505368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505378 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1505381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505402 */     // GIR_Coverage, 17846,
     /* 1505402 */     GIR_EraseRootFromParent_Done,
     /* 1505403 */   // Label 20977: @1505403
     /* 1505403 */   GIM_Try, /*On fail goto*//*Label 20978*/ GIMT_Encode4(1505485), // Rule ID 17847 //
     /* 1505408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1505419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1505422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1505428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505447 */     // MIs[0] round
     /* 1505447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505450 */     // MIs[0] policy
     /* 1505450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505460 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1505463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505484 */     // GIR_Coverage, 17847,
     /* 1505484 */     GIR_EraseRootFromParent_Done,
     /* 1505485 */   // Label 20978: @1505485
     /* 1505485 */   GIM_Try, /*On fail goto*//*Label 20979*/ GIMT_Encode4(1505567), // Rule ID 17850 //
     /* 1505490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1505501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1505504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1505510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505529 */     // MIs[0] round
     /* 1505529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505532 */     // MIs[0] policy
     /* 1505532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505542 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1505545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505566 */     // GIR_Coverage, 17850,
     /* 1505566 */     GIR_EraseRootFromParent_Done,
     /* 1505567 */   // Label 20979: @1505567
     /* 1505567 */   GIM_Try, /*On fail goto*//*Label 20980*/ GIMT_Encode4(1505649), // Rule ID 17851 //
     /* 1505572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1505583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1505586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1505592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505611 */     // MIs[0] round
     /* 1505611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505614 */     // MIs[0] policy
     /* 1505614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505624 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1505627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505648 */     // GIR_Coverage, 17851,
     /* 1505648 */     GIR_EraseRootFromParent_Done,
     /* 1505649 */   // Label 20980: @1505649
     /* 1505649 */   GIM_Try, /*On fail goto*//*Label 20981*/ GIMT_Encode4(1505731), // Rule ID 17854 //
     /* 1505654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1505665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1505668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1505674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505693 */     // MIs[0] round
     /* 1505693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505696 */     // MIs[0] policy
     /* 1505696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505706 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1505709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505730 */     // GIR_Coverage, 17854,
     /* 1505730 */     GIR_EraseRootFromParent_Done,
     /* 1505731 */   // Label 20981: @1505731
     /* 1505731 */   GIM_Try, /*On fail goto*//*Label 20982*/ GIMT_Encode4(1505813), // Rule ID 17855 //
     /* 1505736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1505747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1505750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1505753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1505756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1505771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505775 */     // MIs[0] round
     /* 1505775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505778 */     // MIs[0] policy
     /* 1505778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505788 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1505791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505812 */     // GIR_Coverage, 17855,
     /* 1505812 */     GIR_EraseRootFromParent_Done,
     /* 1505813 */   // Label 20982: @1505813
     /* 1505813 */   GIM_Try, /*On fail goto*//*Label 20983*/ GIMT_Encode4(1505895), // Rule ID 17858 //
     /* 1505818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1505821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1505829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1505832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1505835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1505838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1505853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505857 */     // MIs[0] round
     /* 1505857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505860 */     // MIs[0] policy
     /* 1505860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505870 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1505873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505894 */     // GIR_Coverage, 17858,
     /* 1505894 */     GIR_EraseRootFromParent_Done,
     /* 1505895 */   // Label 20983: @1505895
     /* 1505895 */   GIM_Try, /*On fail goto*//*Label 20984*/ GIMT_Encode4(1505977), // Rule ID 17859 //
     /* 1505900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1505903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1505911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1505914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1505917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1505920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1505935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505939 */     // MIs[0] round
     /* 1505939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505942 */     // MIs[0] policy
     /* 1505942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1505955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505976 */     // GIR_Coverage, 17859,
     /* 1505976 */     GIR_EraseRootFromParent_Done,
     /* 1505977 */   // Label 20984: @1505977
     /* 1505977 */   GIM_Try, /*On fail goto*//*Label 20985*/ GIMT_Encode4(1506059), // Rule ID 17862 //
     /* 1505982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1505985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1505990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1505993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1505996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1505999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506021 */     // MIs[0] round
     /* 1506021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506024 */     // MIs[0] policy
     /* 1506024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506034 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1506037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506058 */     // GIR_Coverage, 17862,
     /* 1506058 */     GIR_EraseRootFromParent_Done,
     /* 1506059 */   // Label 20985: @1506059
     /* 1506059 */   GIM_Try, /*On fail goto*//*Label 20986*/ GIMT_Encode4(1506141), // Rule ID 17863 //
     /* 1506064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506103 */     // MIs[0] round
     /* 1506103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506106 */     // MIs[0] policy
     /* 1506106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506116 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1506119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506140 */     // GIR_Coverage, 17863,
     /* 1506140 */     GIR_EraseRootFromParent_Done,
     /* 1506141 */   // Label 20986: @1506141
     /* 1506141 */   GIM_Try, /*On fail goto*//*Label 20987*/ GIMT_Encode4(1506223), // Rule ID 17866 //
     /* 1506146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506185 */     // MIs[0] round
     /* 1506185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506188 */     // MIs[0] policy
     /* 1506188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506198 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1506201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506222 */     // GIR_Coverage, 17866,
     /* 1506222 */     GIR_EraseRootFromParent_Done,
     /* 1506223 */   // Label 20987: @1506223
     /* 1506223 */   GIM_Try, /*On fail goto*//*Label 20988*/ GIMT_Encode4(1506305), // Rule ID 17867 //
     /* 1506228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1506236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1506245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1506263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506267 */     // MIs[0] round
     /* 1506267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506270 */     // MIs[0] policy
     /* 1506270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506280 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1506283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506304 */     // GIR_Coverage, 17867,
     /* 1506304 */     GIR_EraseRootFromParent_Done,
     /* 1506305 */   // Label 20988: @1506305
     /* 1506305 */   GIM_Try, /*On fail goto*//*Label 20989*/ GIMT_Encode4(1506387), // Rule ID 17870 //
     /* 1506310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1506327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506349 */     // MIs[0] round
     /* 1506349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506352 */     // MIs[0] policy
     /* 1506352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506362 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1506365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506386 */     // GIR_Coverage, 17870,
     /* 1506386 */     GIR_EraseRootFromParent_Done,
     /* 1506387 */   // Label 20989: @1506387
     /* 1506387 */   GIM_Try, /*On fail goto*//*Label 20990*/ GIMT_Encode4(1506469), // Rule ID 17871 //
     /* 1506392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1506403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1506406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1506409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1506412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506431 */     // MIs[0] round
     /* 1506431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506434 */     // MIs[0] policy
     /* 1506434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506444 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1506447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506468 */     // GIR_Coverage, 17871,
     /* 1506468 */     GIR_EraseRootFromParent_Done,
     /* 1506469 */   // Label 20990: @1506469
     /* 1506469 */   GIM_Try, /*On fail goto*//*Label 20991*/ GIMT_Encode4(1506551), // Rule ID 17874 //
     /* 1506474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1506485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1506488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1506491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1506494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506513 */     // MIs[0] round
     /* 1506513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506516 */     // MIs[0] policy
     /* 1506516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506526 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1506529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506550 */     // GIR_Coverage, 17874,
     /* 1506550 */     GIR_EraseRootFromParent_Done,
     /* 1506551 */   // Label 20991: @1506551
     /* 1506551 */   GIM_Try, /*On fail goto*//*Label 20992*/ GIMT_Encode4(1506633), // Rule ID 17875 //
     /* 1506556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1506567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1506570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1506573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1506576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506595 */     // MIs[0] round
     /* 1506595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506598 */     // MIs[0] policy
     /* 1506598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506608 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1506611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506632 */     // GIR_Coverage, 17875,
     /* 1506632 */     GIR_EraseRootFromParent_Done,
     /* 1506633 */   // Label 20992: @1506633
     /* 1506633 */   GIM_Try, /*On fail goto*//*Label 20993*/ GIMT_Encode4(1506715), // Rule ID 17878 //
     /* 1506638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1506649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1506652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1506655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1506658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506677 */     // MIs[0] round
     /* 1506677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506680 */     // MIs[0] policy
     /* 1506680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506690 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1506693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506714 */     // GIR_Coverage, 17878,
     /* 1506714 */     GIR_EraseRootFromParent_Done,
     /* 1506715 */   // Label 20993: @1506715
     /* 1506715 */   GIM_Try, /*On fail goto*//*Label 20994*/ GIMT_Encode4(1506797), // Rule ID 17879 //
     /* 1506720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1506731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1506734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1506737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1506740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506759 */     // MIs[0] round
     /* 1506759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506762 */     // MIs[0] policy
     /* 1506762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506772 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1506775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506796 */     // GIR_Coverage, 17879,
     /* 1506796 */     GIR_EraseRootFromParent_Done,
     /* 1506797 */   // Label 20994: @1506797
     /* 1506797 */   GIM_Try, /*On fail goto*//*Label 20995*/ GIMT_Encode4(1506879), // Rule ID 17882 //
     /* 1506802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1506805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1506813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1506816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1506819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1506822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506841 */     // MIs[0] round
     /* 1506841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506844 */     // MIs[0] policy
     /* 1506844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506854 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1506857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506878 */     // GIR_Coverage, 17882,
     /* 1506878 */     GIR_EraseRootFromParent_Done,
     /* 1506879 */   // Label 20995: @1506879
     /* 1506879 */   GIM_Try, /*On fail goto*//*Label 20996*/ GIMT_Encode4(1506961), // Rule ID 17883 //
     /* 1506884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1506895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1506898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1506901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1506904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506923 */     // MIs[0] round
     /* 1506923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506926 */     // MIs[0] policy
     /* 1506926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506936 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1506939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506960 */     // GIR_Coverage, 17883,
     /* 1506960 */     GIR_EraseRootFromParent_Done,
     /* 1506961 */   // Label 20996: @1506961
     /* 1506961 */   GIM_Try, /*On fail goto*//*Label 20997*/ GIMT_Encode4(1507043), // Rule ID 17886 //
     /* 1506966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1506974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1506977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1506980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1506983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1506986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1506997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507005 */     // MIs[0] round
     /* 1507005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507008 */     // MIs[0] policy
     /* 1507008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507018 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1507021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507042 */     // GIR_Coverage, 17886,
     /* 1507042 */     GIR_EraseRootFromParent_Done,
     /* 1507043 */   // Label 20997: @1507043
     /* 1507043 */   GIM_Try, /*On fail goto*//*Label 20998*/ GIMT_Encode4(1507125), // Rule ID 17887 //
     /* 1507048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1507065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507087 */     // MIs[0] round
     /* 1507087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507090 */     // MIs[0] policy
     /* 1507090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507100 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1507103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507124 */     // GIR_Coverage, 17887,
     /* 1507124 */     GIR_EraseRootFromParent_Done,
     /* 1507125 */   // Label 20998: @1507125
     /* 1507125 */   GIM_Try, /*On fail goto*//*Label 20999*/ GIMT_Encode4(1507207), // Rule ID 17890 //
     /* 1507130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1507133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1507147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507169 */     // MIs[0] round
     /* 1507169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507172 */     // MIs[0] policy
     /* 1507172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507182 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1507185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507206 */     // GIR_Coverage, 17890,
     /* 1507206 */     GIR_EraseRootFromParent_Done,
     /* 1507207 */   // Label 20999: @1507207
     /* 1507207 */   GIM_Try, /*On fail goto*//*Label 21000*/ GIMT_Encode4(1507289), // Rule ID 17891 //
     /* 1507212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1507215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1507229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507251 */     // MIs[0] round
     /* 1507251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507254 */     // MIs[0] policy
     /* 1507254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507264 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1507267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507288 */     // GIR_Coverage, 17891,
     /* 1507288 */     GIR_EraseRootFromParent_Done,
     /* 1507289 */   // Label 21000: @1507289
     /* 1507289 */   GIM_Try, /*On fail goto*//*Label 21001*/ GIMT_Encode4(1507371), // Rule ID 17894 //
     /* 1507294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1507311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507333 */     // MIs[0] round
     /* 1507333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507336 */     // MIs[0] policy
     /* 1507336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507346 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1507349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507370 */     // GIR_Coverage, 17894,
     /* 1507370 */     GIR_EraseRootFromParent_Done,
     /* 1507371 */   // Label 21001: @1507371
     /* 1507371 */   GIM_Try, /*On fail goto*//*Label 21002*/ GIMT_Encode4(1507453), // Rule ID 17895 //
     /* 1507376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1507387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1507390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1507393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1507396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507415 */     // MIs[0] round
     /* 1507415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507418 */     // MIs[0] policy
     /* 1507418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507428 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1507431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507452 */     // GIR_Coverage, 17895,
     /* 1507452 */     GIR_EraseRootFromParent_Done,
     /* 1507453 */   // Label 21002: @1507453
     /* 1507453 */   GIM_Try, /*On fail goto*//*Label 21003*/ GIMT_Encode4(1507535), // Rule ID 17898 //
     /* 1507458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1507469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1507472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1507475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1507478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507497 */     // MIs[0] round
     /* 1507497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507500 */     // MIs[0] policy
     /* 1507500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507510 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1507513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507534 */     // GIR_Coverage, 17898,
     /* 1507534 */     GIR_EraseRootFromParent_Done,
     /* 1507535 */   // Label 21003: @1507535
     /* 1507535 */   GIM_Try, /*On fail goto*//*Label 21004*/ GIMT_Encode4(1507617), // Rule ID 17899 //
     /* 1507540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1507551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1507554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1507557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1507560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507579 */     // MIs[0] round
     /* 1507579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507582 */     // MIs[0] policy
     /* 1507582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507592 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1507595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507616 */     // GIR_Coverage, 17899,
     /* 1507616 */     GIR_EraseRootFromParent_Done,
     /* 1507617 */   // Label 21004: @1507617
     /* 1507617 */   GIM_Try, /*On fail goto*//*Label 21005*/ GIMT_Encode4(1507699), // Rule ID 17902 //
     /* 1507622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1507633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1507636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1507639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1507642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507661 */     // MIs[0] round
     /* 1507661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507664 */     // MIs[0] policy
     /* 1507664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507674 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1507677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507698 */     // GIR_Coverage, 17902,
     /* 1507698 */     GIR_EraseRootFromParent_Done,
     /* 1507699 */   // Label 21005: @1507699
     /* 1507699 */   GIM_Try, /*On fail goto*//*Label 21006*/ GIMT_Encode4(1507781), // Rule ID 17903 //
     /* 1507704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1507715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1507718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1507721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1507724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507743 */     // MIs[0] round
     /* 1507743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507746 */     // MIs[0] policy
     /* 1507746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507756 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1507759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507780 */     // GIR_Coverage, 17903,
     /* 1507780 */     GIR_EraseRootFromParent_Done,
     /* 1507781 */   // Label 21006: @1507781
     /* 1507781 */   GIM_Try, /*On fail goto*//*Label 21007*/ GIMT_Encode4(1507863), // Rule ID 17906 //
     /* 1507786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1507797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1507800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1507803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1507806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507825 */     // MIs[0] round
     /* 1507825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507828 */     // MIs[0] policy
     /* 1507828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507838 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1507841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507862 */     // GIR_Coverage, 17906,
     /* 1507862 */     GIR_EraseRootFromParent_Done,
     /* 1507863 */   // Label 21007: @1507863
     /* 1507863 */   GIM_Try, /*On fail goto*//*Label 21008*/ GIMT_Encode4(1507945), // Rule ID 17907 //
     /* 1507868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1507879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1507882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1507885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1507888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1507907 */     // MIs[0] round
     /* 1507907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507910 */     // MIs[0] policy
     /* 1507910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507920 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1507923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507944 */     // GIR_Coverage, 17907,
     /* 1507944 */     GIR_EraseRootFromParent_Done,
     /* 1507945 */   // Label 21008: @1507945
     /* 1507945 */   GIM_Try, /*On fail goto*//*Label 21009*/ GIMT_Encode4(1508027), // Rule ID 17910 //
     /* 1507950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1507958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1507961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1507964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1507967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1507970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1507989 */     // MIs[0] round
     /* 1507989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507992 */     // MIs[0] policy
     /* 1507992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508002 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1508005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508026 */     // GIR_Coverage, 17910,
     /* 1508026 */     GIR_EraseRootFromParent_Done,
     /* 1508027 */   // Label 21009: @1508027
     /* 1508027 */   GIM_Try, /*On fail goto*//*Label 21010*/ GIMT_Encode4(1508109), // Rule ID 17911 //
     /* 1508032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1508049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508071 */     // MIs[0] round
     /* 1508071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508074 */     // MIs[0] policy
     /* 1508074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508084 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1508087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508108 */     // GIR_Coverage, 17911,
     /* 1508108 */     GIR_EraseRootFromParent_Done,
     /* 1508109 */   // Label 21010: @1508109
     /* 1508109 */   GIM_Try, /*On fail goto*//*Label 21011*/ GIMT_Encode4(1508191), // Rule ID 17914 //
     /* 1508114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1508131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508153 */     // MIs[0] round
     /* 1508153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508156 */     // MIs[0] policy
     /* 1508156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508166 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1508169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508190 */     // GIR_Coverage, 17914,
     /* 1508190 */     GIR_EraseRootFromParent_Done,
     /* 1508191 */   // Label 21011: @1508191
     /* 1508191 */   GIM_Try, /*On fail goto*//*Label 21012*/ GIMT_Encode4(1508273), // Rule ID 17915 //
     /* 1508196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1508213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508235 */     // MIs[0] round
     /* 1508235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508238 */     // MIs[0] policy
     /* 1508238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508248 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1508251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508272 */     // GIR_Coverage, 17915,
     /* 1508272 */     GIR_EraseRootFromParent_Done,
     /* 1508273 */   // Label 21012: @1508273
     /* 1508273 */   GIM_Try, /*On fail goto*//*Label 21013*/ GIMT_Encode4(1508355), // Rule ID 17918 //
     /* 1508278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1508295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508317 */     // MIs[0] round
     /* 1508317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508320 */     // MIs[0] policy
     /* 1508320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508330 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1508333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508354 */     // GIR_Coverage, 17918,
     /* 1508354 */     GIR_EraseRootFromParent_Done,
     /* 1508355 */   // Label 21013: @1508355
     /* 1508355 */   GIM_Try, /*On fail goto*//*Label 21014*/ GIMT_Encode4(1508437), // Rule ID 17919 //
     /* 1508360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1508371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1508374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1508377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1508380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508399 */     // MIs[0] round
     /* 1508399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508402 */     // MIs[0] policy
     /* 1508402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508412 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1508415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508436 */     // GIR_Coverage, 17919,
     /* 1508436 */     GIR_EraseRootFromParent_Done,
     /* 1508437 */   // Label 21014: @1508437
     /* 1508437 */   GIM_Try, /*On fail goto*//*Label 21015*/ GIMT_Encode4(1508519), // Rule ID 17922 //
     /* 1508442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1508453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1508456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1508459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1508462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508481 */     // MIs[0] round
     /* 1508481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508484 */     // MIs[0] policy
     /* 1508484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508494 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1508497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508518 */     // GIR_Coverage, 17922,
     /* 1508518 */     GIR_EraseRootFromParent_Done,
     /* 1508519 */   // Label 21015: @1508519
     /* 1508519 */   GIM_Try, /*On fail goto*//*Label 21016*/ GIMT_Encode4(1508601), // Rule ID 17923 //
     /* 1508524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1508535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1508538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1508541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1508544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508563 */     // MIs[0] round
     /* 1508563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508566 */     // MIs[0] policy
     /* 1508566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508576 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1508579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508600 */     // GIR_Coverage, 17923,
     /* 1508600 */     GIR_EraseRootFromParent_Done,
     /* 1508601 */   // Label 21016: @1508601
     /* 1508601 */   GIM_Try, /*On fail goto*//*Label 21017*/ GIMT_Encode4(1508683), // Rule ID 17926 //
     /* 1508606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1508609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1508617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1508620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1508623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1508626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508645 */     // MIs[0] round
     /* 1508645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508648 */     // MIs[0] policy
     /* 1508648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508658 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1508661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508682 */     // GIR_Coverage, 17926,
     /* 1508682 */     GIR_EraseRootFromParent_Done,
     /* 1508683 */   // Label 21017: @1508683
     /* 1508683 */   GIM_Try, /*On fail goto*//*Label 21018*/ GIMT_Encode4(1508765), // Rule ID 17927 //
     /* 1508688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1508699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1508702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1508705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1508708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508727 */     // MIs[0] round
     /* 1508727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508730 */     // MIs[0] policy
     /* 1508730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508740 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1508743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508764 */     // GIR_Coverage, 17927,
     /* 1508764 */     GIR_EraseRootFromParent_Done,
     /* 1508765 */   // Label 21018: @1508765
     /* 1508765 */   GIM_Try, /*On fail goto*//*Label 21019*/ GIMT_Encode4(1508847), // Rule ID 17930 //
     /* 1508770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1508781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1508784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1508790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508809 */     // MIs[0] round
     /* 1508809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508812 */     // MIs[0] policy
     /* 1508812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508822 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1508825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508846 */     // GIR_Coverage, 17930,
     /* 1508846 */     GIR_EraseRootFromParent_Done,
     /* 1508847 */   // Label 21019: @1508847
     /* 1508847 */   GIM_Try, /*On fail goto*//*Label 21020*/ GIMT_Encode4(1508929), // Rule ID 17931 //
     /* 1508852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1508863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1508866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1508872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508891 */     // MIs[0] round
     /* 1508891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508894 */     // MIs[0] policy
     /* 1508894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508904 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1508907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508928 */     // GIR_Coverage, 17931,
     /* 1508928 */     GIR_EraseRootFromParent_Done,
     /* 1508929 */   // Label 21020: @1508929
     /* 1508929 */   GIM_Try, /*On fail goto*//*Label 21021*/ GIMT_Encode4(1509011), // Rule ID 17934 //
     /* 1508934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1508942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1508945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1508948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1508954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508973 */     // MIs[0] round
     /* 1508973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508976 */     // MIs[0] policy
     /* 1508976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508986 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1508989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509010 */     // GIR_Coverage, 17934,
     /* 1509010 */     GIR_EraseRootFromParent_Done,
     /* 1509011 */   // Label 21021: @1509011
     /* 1509011 */   GIM_Try, /*On fail goto*//*Label 21022*/ GIMT_Encode4(1509093), // Rule ID 17935 //
     /* 1509016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509055 */     // MIs[0] round
     /* 1509055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509058 */     // MIs[0] policy
     /* 1509058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509068 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1509071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509092 */     // GIR_Coverage, 17935,
     /* 1509092 */     GIR_EraseRootFromParent_Done,
     /* 1509093 */   // Label 21022: @1509093
     /* 1509093 */   GIM_Try, /*On fail goto*//*Label 21023*/ GIMT_Encode4(1509175), // Rule ID 17938 //
     /* 1509098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509137 */     // MIs[0] round
     /* 1509137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509140 */     // MIs[0] policy
     /* 1509140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509150 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1509153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509174 */     // GIR_Coverage, 17938,
     /* 1509174 */     GIR_EraseRootFromParent_Done,
     /* 1509175 */   // Label 21023: @1509175
     /* 1509175 */   GIM_Try, /*On fail goto*//*Label 21024*/ GIMT_Encode4(1509257), // Rule ID 17939 //
     /* 1509180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509219 */     // MIs[0] round
     /* 1509219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509222 */     // MIs[0] policy
     /* 1509222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509232 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1509235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509256 */     // GIR_Coverage, 17939,
     /* 1509256 */     GIR_EraseRootFromParent_Done,
     /* 1509257 */   // Label 21024: @1509257
     /* 1509257 */   GIM_Try, /*On fail goto*//*Label 21025*/ GIMT_Encode4(1509339), // Rule ID 17942 //
     /* 1509262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509301 */     // MIs[0] round
     /* 1509301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509304 */     // MIs[0] policy
     /* 1509304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509314 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1509317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509338 */     // GIR_Coverage, 17942,
     /* 1509338 */     GIR_EraseRootFromParent_Done,
     /* 1509339 */   // Label 21025: @1509339
     /* 1509339 */   GIM_Try, /*On fail goto*//*Label 21026*/ GIMT_Encode4(1509421), // Rule ID 17943 //
     /* 1509344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1509355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1509358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1509364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509383 */     // MIs[0] round
     /* 1509383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509386 */     // MIs[0] policy
     /* 1509386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509396 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11241:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1509399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509420 */     // GIR_Coverage, 17943,
     /* 1509420 */     GIR_EraseRootFromParent_Done,
     /* 1509421 */   // Label 21026: @1509421
     /* 1509421 */   GIM_Try, /*On fail goto*//*Label 21027*/ GIMT_Encode4(1509503), // Rule ID 17946 //
     /* 1509426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1509446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509465 */     // MIs[0] round
     /* 1509465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509468 */     // MIs[0] policy
     /* 1509468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509478 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1509481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509502 */     // GIR_Coverage, 17946,
     /* 1509502 */     GIR_EraseRootFromParent_Done,
     /* 1509503 */   // Label 21027: @1509503
     /* 1509503 */   GIM_Try, /*On fail goto*//*Label 21028*/ GIMT_Encode4(1509585), // Rule ID 17947 //
     /* 1509508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1509519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1509522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1509528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509547 */     // MIs[0] round
     /* 1509547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509550 */     // MIs[0] policy
     /* 1509550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509560 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1509563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509584 */     // GIR_Coverage, 17947,
     /* 1509584 */     GIR_EraseRootFromParent_Done,
     /* 1509585 */   // Label 21028: @1509585
     /* 1509585 */   GIM_Try, /*On fail goto*//*Label 21029*/ GIMT_Encode4(1509667), // Rule ID 17950 //
     /* 1509590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1509601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1509604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1509610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509629 */     // MIs[0] round
     /* 1509629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509632 */     // MIs[0] policy
     /* 1509632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509642 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1509645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509666 */     // GIR_Coverage, 17950,
     /* 1509666 */     GIR_EraseRootFromParent_Done,
     /* 1509667 */   // Label 21029: @1509667
     /* 1509667 */   GIM_Try, /*On fail goto*//*Label 21030*/ GIMT_Encode4(1509749), // Rule ID 17951 //
     /* 1509672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1509683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1509686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1509692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509711 */     // MIs[0] round
     /* 1509711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509714 */     // MIs[0] policy
     /* 1509714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509724 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1509727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509748 */     // GIR_Coverage, 17951,
     /* 1509748 */     GIR_EraseRootFromParent_Done,
     /* 1509749 */   // Label 21030: @1509749
     /* 1509749 */   GIM_Try, /*On fail goto*//*Label 21031*/ GIMT_Encode4(1509831), // Rule ID 17954 //
     /* 1509754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1509765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1509768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1509774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509793 */     // MIs[0] round
     /* 1509793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509796 */     // MIs[0] policy
     /* 1509796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509806 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1509809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509830 */     // GIR_Coverage, 17954,
     /* 1509830 */     GIR_EraseRootFromParent_Done,
     /* 1509831 */   // Label 21031: @1509831
     /* 1509831 */   GIM_Try, /*On fail goto*//*Label 21032*/ GIMT_Encode4(1509913), // Rule ID 17955 //
     /* 1509836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1509847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1509850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1509856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509875 */     // MIs[0] round
     /* 1509875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509878 */     // MIs[0] policy
     /* 1509878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509888 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1509891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509912 */     // GIR_Coverage, 17955,
     /* 1509912 */     GIR_EraseRootFromParent_Done,
     /* 1509913 */   // Label 21032: @1509913
     /* 1509913 */   GIM_Try, /*On fail goto*//*Label 21033*/ GIMT_Encode4(1509995), // Rule ID 17958 //
     /* 1509918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1509926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1509929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1509932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1509935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1509938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1509953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509957 */     // MIs[0] round
     /* 1509957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509960 */     // MIs[0] policy
     /* 1509960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509970 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1509973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509994 */     // GIR_Coverage, 17958,
     /* 1509994 */     GIR_EraseRootFromParent_Done,
     /* 1509995 */   // Label 21033: @1509995
     /* 1509995 */   GIM_Try, /*On fail goto*//*Label 21034*/ GIMT_Encode4(1510077), // Rule ID 17959 //
     /* 1510000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510039 */     // MIs[0] round
     /* 1510039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510042 */     // MIs[0] policy
     /* 1510042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510052 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1510055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510076 */     // GIR_Coverage, 17959,
     /* 1510076 */     GIR_EraseRootFromParent_Done,
     /* 1510077 */   // Label 21034: @1510077
     /* 1510077 */   GIM_Try, /*On fail goto*//*Label 21035*/ GIMT_Encode4(1510159), // Rule ID 17962 //
     /* 1510082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510121 */     // MIs[0] round
     /* 1510121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510124 */     // MIs[0] policy
     /* 1510124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510134 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1510137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510158 */     // GIR_Coverage, 17962,
     /* 1510158 */     GIR_EraseRootFromParent_Done,
     /* 1510159 */   // Label 21035: @1510159
     /* 1510159 */   GIM_Try, /*On fail goto*//*Label 21036*/ GIMT_Encode4(1510241), // Rule ID 17963 //
     /* 1510164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1510181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1510199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510203 */     // MIs[0] round
     /* 1510203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510206 */     // MIs[0] policy
     /* 1510206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510216 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1510219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510240 */     // GIR_Coverage, 17963,
     /* 1510240 */     GIR_EraseRootFromParent_Done,
     /* 1510241 */   // Label 21036: @1510241
     /* 1510241 */   GIM_Try, /*On fail goto*//*Label 21037*/ GIMT_Encode4(1510323), // Rule ID 17966 //
     /* 1510246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510285 */     // MIs[0] round
     /* 1510285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510288 */     // MIs[0] policy
     /* 1510288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510298 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1510301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510322 */     // GIR_Coverage, 17966,
     /* 1510322 */     GIR_EraseRootFromParent_Done,
     /* 1510323 */   // Label 21037: @1510323
     /* 1510323 */   GIM_Try, /*On fail goto*//*Label 21038*/ GIMT_Encode4(1510405), // Rule ID 17967 //
     /* 1510328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1510339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1510342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1510348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510367 */     // MIs[0] round
     /* 1510367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510370 */     // MIs[0] policy
     /* 1510370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510380 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1510383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510404 */     // GIR_Coverage, 17967,
     /* 1510404 */     GIR_EraseRootFromParent_Done,
     /* 1510405 */   // Label 21038: @1510405
     /* 1510405 */   GIM_Try, /*On fail goto*//*Label 21039*/ GIMT_Encode4(1510487), // Rule ID 17970 //
     /* 1510410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510449 */     // MIs[0] round
     /* 1510449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510452 */     // MIs[0] policy
     /* 1510452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510462 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1510465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510486 */     // GIR_Coverage, 17970,
     /* 1510486 */     GIR_EraseRootFromParent_Done,
     /* 1510487 */   // Label 21039: @1510487
     /* 1510487 */   GIM_Try, /*On fail goto*//*Label 21040*/ GIMT_Encode4(1510569), // Rule ID 17971 //
     /* 1510492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1510503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1510506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1510512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510531 */     // MIs[0] round
     /* 1510531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510534 */     // MIs[0] policy
     /* 1510534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510544 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1510547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510568 */     // GIR_Coverage, 17971,
     /* 1510568 */     GIR_EraseRootFromParent_Done,
     /* 1510569 */   // Label 21040: @1510569
     /* 1510569 */   GIM_Try, /*On fail goto*//*Label 21041*/ GIMT_Encode4(1510651), // Rule ID 17974 //
     /* 1510574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1510585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1510588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1510594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510613 */     // MIs[0] round
     /* 1510613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510616 */     // MIs[0] policy
     /* 1510616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510626 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1510629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510650 */     // GIR_Coverage, 17974,
     /* 1510650 */     GIR_EraseRootFromParent_Done,
     /* 1510651 */   // Label 21041: @1510651
     /* 1510651 */   GIM_Try, /*On fail goto*//*Label 21042*/ GIMT_Encode4(1510733), // Rule ID 17975 //
     /* 1510656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1510667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1510670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1510673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1510676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1510691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510695 */     // MIs[0] round
     /* 1510695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510698 */     // MIs[0] policy
     /* 1510698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510708 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1510711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510732 */     // GIR_Coverage, 17975,
     /* 1510732 */     GIR_EraseRootFromParent_Done,
     /* 1510733 */   // Label 21042: @1510733
     /* 1510733 */   GIM_Try, /*On fail goto*//*Label 21043*/ GIMT_Encode4(1510815), // Rule ID 17978 //
     /* 1510738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1510741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1510749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1510752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1510758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510777 */     // MIs[0] round
     /* 1510777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510780 */     // MIs[0] policy
     /* 1510780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1510793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510814 */     // GIR_Coverage, 17978,
     /* 1510814 */     GIR_EraseRootFromParent_Done,
     /* 1510815 */   // Label 21043: @1510815
     /* 1510815 */   GIM_Try, /*On fail goto*//*Label 21044*/ GIMT_Encode4(1510897), // Rule ID 17979 //
     /* 1510820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1510823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1510831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1510834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1510840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510859 */     // MIs[0] round
     /* 1510859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510862 */     // MIs[0] policy
     /* 1510862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510872 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1510875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510896 */     // GIR_Coverage, 17979,
     /* 1510896 */     GIR_EraseRootFromParent_Done,
     /* 1510897 */   // Label 21044: @1510897
     /* 1510897 */   GIM_Try, /*On fail goto*//*Label 21045*/ GIMT_Encode4(1510979), // Rule ID 17982 //
     /* 1510902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1510905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1510913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1510916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1510919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1510922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1510937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510941 */     // MIs[0] round
     /* 1510941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510944 */     // MIs[0] policy
     /* 1510944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510954 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1510957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510978 */     // GIR_Coverage, 17982,
     /* 1510978 */     GIR_EraseRootFromParent_Done,
     /* 1510979 */   // Label 21045: @1510979
     /* 1510979 */   GIM_Try, /*On fail goto*//*Label 21046*/ GIMT_Encode4(1511061), // Rule ID 17983 //
     /* 1510984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1510987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1510992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1510995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1510998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511023 */     // MIs[0] round
     /* 1511023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511026 */     // MIs[0] policy
     /* 1511026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511036 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1511039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511060 */     // GIR_Coverage, 17983,
     /* 1511060 */     GIR_EraseRootFromParent_Done,
     /* 1511061 */   // Label 21046: @1511061
     /* 1511061 */   GIM_Try, /*On fail goto*//*Label 21047*/ GIMT_Encode4(1511143), // Rule ID 17986 //
     /* 1511066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511105 */     // MIs[0] round
     /* 1511105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511108 */     // MIs[0] policy
     /* 1511108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511118 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1511121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511142 */     // GIR_Coverage, 17986,
     /* 1511142 */     GIR_EraseRootFromParent_Done,
     /* 1511143 */   // Label 21047: @1511143
     /* 1511143 */   GIM_Try, /*On fail goto*//*Label 21048*/ GIMT_Encode4(1511225), // Rule ID 17987 //
     /* 1511148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1511156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1511165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1511183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511187 */     // MIs[0] round
     /* 1511187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511190 */     // MIs[0] policy
     /* 1511190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511200 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1511203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511224 */     // GIR_Coverage, 17987,
     /* 1511224 */     GIR_EraseRootFromParent_Done,
     /* 1511225 */   // Label 21048: @1511225
     /* 1511225 */   GIM_Try, /*On fail goto*//*Label 21049*/ GIMT_Encode4(1511307), // Rule ID 17990 //
     /* 1511230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1511247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511269 */     // MIs[0] round
     /* 1511269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511272 */     // MIs[0] policy
     /* 1511272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511282 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1511285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511306 */     // GIR_Coverage, 17990,
     /* 1511306 */     GIR_EraseRootFromParent_Done,
     /* 1511307 */   // Label 21049: @1511307
     /* 1511307 */   GIM_Try, /*On fail goto*//*Label 21050*/ GIMT_Encode4(1511389), // Rule ID 17991 //
     /* 1511312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1511323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1511326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1511329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1511332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511351 */     // MIs[0] round
     /* 1511351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511354 */     // MIs[0] policy
     /* 1511354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511364 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1511367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511388 */     // GIR_Coverage, 17991,
     /* 1511388 */     GIR_EraseRootFromParent_Done,
     /* 1511389 */   // Label 21050: @1511389
     /* 1511389 */   GIM_Try, /*On fail goto*//*Label 21051*/ GIMT_Encode4(1511471), // Rule ID 17994 //
     /* 1511394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1511411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511433 */     // MIs[0] round
     /* 1511433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511436 */     // MIs[0] policy
     /* 1511436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511446 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1511449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511470 */     // GIR_Coverage, 17994,
     /* 1511470 */     GIR_EraseRootFromParent_Done,
     /* 1511471 */   // Label 21051: @1511471
     /* 1511471 */   GIM_Try, /*On fail goto*//*Label 21052*/ GIMT_Encode4(1511553), // Rule ID 17995 //
     /* 1511476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1511487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1511490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1511493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1511496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511515 */     // MIs[0] round
     /* 1511515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511518 */     // MIs[0] policy
     /* 1511518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511528 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1511531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511552 */     // GIR_Coverage, 17995,
     /* 1511552 */     GIR_EraseRootFromParent_Done,
     /* 1511553 */   // Label 21052: @1511553
     /* 1511553 */   GIM_Try, /*On fail goto*//*Label 21053*/ GIMT_Encode4(1511635), // Rule ID 17998 //
     /* 1511558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1511569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1511572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1511575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1511578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511597 */     // MIs[0] round
     /* 1511597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511600 */     // MIs[0] policy
     /* 1511600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511610 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1511613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511634 */     // GIR_Coverage, 17998,
     /* 1511634 */     GIR_EraseRootFromParent_Done,
     /* 1511635 */   // Label 21053: @1511635
     /* 1511635 */   GIM_Try, /*On fail goto*//*Label 21054*/ GIMT_Encode4(1511717), // Rule ID 17999 //
     /* 1511640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1511651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1511654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1511657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1511660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511679 */     // MIs[0] round
     /* 1511679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511682 */     // MIs[0] policy
     /* 1511682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511692 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1511695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511716 */     // GIR_Coverage, 17999,
     /* 1511716 */     GIR_EraseRootFromParent_Done,
     /* 1511717 */   // Label 21054: @1511717
     /* 1511717 */   GIM_Try, /*On fail goto*//*Label 21055*/ GIMT_Encode4(1511799), // Rule ID 18002 //
     /* 1511722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1511725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1511733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1511736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1511739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1511742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511761 */     // MIs[0] round
     /* 1511761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511764 */     // MIs[0] policy
     /* 1511764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511774 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1511777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511798 */     // GIR_Coverage, 18002,
     /* 1511798 */     GIR_EraseRootFromParent_Done,
     /* 1511799 */   // Label 21055: @1511799
     /* 1511799 */   GIM_Try, /*On fail goto*//*Label 21056*/ GIMT_Encode4(1511881), // Rule ID 18003 //
     /* 1511804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1511807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1511815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1511818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1511821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1511824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511843 */     // MIs[0] round
     /* 1511843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511846 */     // MIs[0] policy
     /* 1511846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511856 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1511859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511880 */     // GIR_Coverage, 18003,
     /* 1511880 */     GIR_EraseRootFromParent_Done,
     /* 1511881 */   // Label 21056: @1511881
     /* 1511881 */   GIM_Try, /*On fail goto*//*Label 21057*/ GIMT_Encode4(1511963), // Rule ID 18006 //
     /* 1511886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1511897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1511900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1511903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1511906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511925 */     // MIs[0] round
     /* 1511925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511928 */     // MIs[0] policy
     /* 1511928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511938 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1511941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511962 */     // GIR_Coverage, 18006,
     /* 1511962 */     GIR_EraseRootFromParent_Done,
     /* 1511963 */   // Label 21057: @1511963
     /* 1511963 */   GIM_Try, /*On fail goto*//*Label 21058*/ GIMT_Encode4(1512045), // Rule ID 18007 //
     /* 1511968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1511976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1511979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1511982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1511985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1511988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1511999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512007 */     // MIs[0] round
     /* 1512007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512010 */     // MIs[0] policy
     /* 1512010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512020 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1512023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512044 */     // GIR_Coverage, 18007,
     /* 1512044 */     GIR_EraseRootFromParent_Done,
     /* 1512045 */   // Label 21058: @1512045
     /* 1512045 */   GIM_Try, /*On fail goto*//*Label 21059*/ GIMT_Encode4(1512127), // Rule ID 18010 //
     /* 1512050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1512053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1512067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512089 */     // MIs[0] round
     /* 1512089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512092 */     // MIs[0] policy
     /* 1512092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512102 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1512105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512126 */     // GIR_Coverage, 18010,
     /* 1512126 */     GIR_EraseRootFromParent_Done,
     /* 1512127 */   // Label 21059: @1512127
     /* 1512127 */   GIM_Try, /*On fail goto*//*Label 21060*/ GIMT_Encode4(1512209), // Rule ID 18011 //
     /* 1512132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1512135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1512149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512171 */     // MIs[0] round
     /* 1512171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512174 */     // MIs[0] policy
     /* 1512174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512184 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1512187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512208 */     // GIR_Coverage, 18011,
     /* 1512208 */     GIR_EraseRootFromParent_Done,
     /* 1512209 */   // Label 21060: @1512209
     /* 1512209 */   GIM_Try, /*On fail goto*//*Label 21061*/ GIMT_Encode4(1512291), // Rule ID 18014 //
     /* 1512214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1512231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512253 */     // MIs[0] round
     /* 1512253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512256 */     // MIs[0] policy
     /* 1512256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512266 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1512269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512290 */     // GIR_Coverage, 18014,
     /* 1512290 */     GIR_EraseRootFromParent_Done,
     /* 1512291 */   // Label 21061: @1512291
     /* 1512291 */   GIM_Try, /*On fail goto*//*Label 21062*/ GIMT_Encode4(1512373), // Rule ID 18015 //
     /* 1512296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1512307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1512310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1512313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1512316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512335 */     // MIs[0] round
     /* 1512335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512338 */     // MIs[0] policy
     /* 1512338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512348 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1512351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512372 */     // GIR_Coverage, 18015,
     /* 1512372 */     GIR_EraseRootFromParent_Done,
     /* 1512373 */   // Label 21062: @1512373
     /* 1512373 */   GIM_Try, /*On fail goto*//*Label 21063*/ GIMT_Encode4(1512455), // Rule ID 18018 //
     /* 1512378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1512395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512417 */     // MIs[0] round
     /* 1512417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512420 */     // MIs[0] policy
     /* 1512420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512430 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1512433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512454 */     // GIR_Coverage, 18018,
     /* 1512454 */     GIR_EraseRootFromParent_Done,
     /* 1512455 */   // Label 21063: @1512455
     /* 1512455 */   GIM_Try, /*On fail goto*//*Label 21064*/ GIMT_Encode4(1512537), // Rule ID 18019 //
     /* 1512460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1512471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1512474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1512477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1512480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512499 */     // MIs[0] round
     /* 1512499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512502 */     // MIs[0] policy
     /* 1512502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512512 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1512515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512536 */     // GIR_Coverage, 18019,
     /* 1512536 */     GIR_EraseRootFromParent_Done,
     /* 1512537 */   // Label 21064: @1512537
     /* 1512537 */   GIM_Try, /*On fail goto*//*Label 21065*/ GIMT_Encode4(1512619), // Rule ID 18022 //
     /* 1512542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1512553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1512556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1512559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1512562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512581 */     // MIs[0] round
     /* 1512581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512584 */     // MIs[0] policy
     /* 1512584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512594 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1512597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512618 */     // GIR_Coverage, 18022,
     /* 1512618 */     GIR_EraseRootFromParent_Done,
     /* 1512619 */   // Label 21065: @1512619
     /* 1512619 */   GIM_Try, /*On fail goto*//*Label 21066*/ GIMT_Encode4(1512701), // Rule ID 18023 //
     /* 1512624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1512635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1512638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1512641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1512644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1512663 */     // MIs[0] round
     /* 1512663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512666 */     // MIs[0] policy
     /* 1512666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512676 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1512679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512700 */     // GIR_Coverage, 18023,
     /* 1512700 */     GIR_EraseRootFromParent_Done,
     /* 1512701 */   // Label 21066: @1512701
     /* 1512701 */   GIM_Try, /*On fail goto*//*Label 21067*/ GIMT_Encode4(1512783), // Rule ID 18026 //
     /* 1512706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1512717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1512720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1512723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1512726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512745 */     // MIs[0] round
     /* 1512745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512748 */     // MIs[0] policy
     /* 1512748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512758 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1512761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512782 */     // GIR_Coverage, 18026,
     /* 1512782 */     GIR_EraseRootFromParent_Done,
     /* 1512783 */   // Label 21067: @1512783
     /* 1512783 */   GIM_Try, /*On fail goto*//*Label 21068*/ GIMT_Encode4(1512865), // Rule ID 18027 //
     /* 1512788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1512799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1512802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1512805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1512808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1512827 */     // MIs[0] round
     /* 1512827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512830 */     // MIs[0] policy
     /* 1512830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512840 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1512843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512864 */     // GIR_Coverage, 18027,
     /* 1512864 */     GIR_EraseRootFromParent_Done,
     /* 1512865 */   // Label 21068: @1512865
     /* 1512865 */   GIM_Try, /*On fail goto*//*Label 21069*/ GIMT_Encode4(1512947), // Rule ID 18030 //
     /* 1512870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1512881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1512884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1512887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1512890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512909 */     // MIs[0] round
     /* 1512909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512912 */     // MIs[0] policy
     /* 1512912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512922 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1512925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512946 */     // GIR_Coverage, 18030,
     /* 1512946 */     GIR_EraseRootFromParent_Done,
     /* 1512947 */   // Label 21069: @1512947
     /* 1512947 */   GIM_Try, /*On fail goto*//*Label 21070*/ GIMT_Encode4(1513029), // Rule ID 18031 //
     /* 1512952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1512960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1512963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1512966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1512969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1512972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1512991 */     // MIs[0] round
     /* 1512991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512994 */     // MIs[0] policy
     /* 1512994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513004 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1513007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513028 */     // GIR_Coverage, 18031,
     /* 1513028 */     GIR_EraseRootFromParent_Done,
     /* 1513029 */   // Label 21070: @1513029
     /* 1513029 */   GIM_Try, /*On fail goto*//*Label 21071*/ GIMT_Encode4(1513111), // Rule ID 18034 //
     /* 1513034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1513051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513073 */     // MIs[0] round
     /* 1513073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513076 */     // MIs[0] policy
     /* 1513076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513086 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1513089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513110 */     // GIR_Coverage, 18034,
     /* 1513110 */     GIR_EraseRootFromParent_Done,
     /* 1513111 */   // Label 21071: @1513111
     /* 1513111 */   GIM_Try, /*On fail goto*//*Label 21072*/ GIMT_Encode4(1513193), // Rule ID 18035 //
     /* 1513116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1513133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513155 */     // MIs[0] round
     /* 1513155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513158 */     // MIs[0] policy
     /* 1513158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513168 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1513171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513192 */     // GIR_Coverage, 18035,
     /* 1513192 */     GIR_EraseRootFromParent_Done,
     /* 1513193 */   // Label 21072: @1513193
     /* 1513193 */   GIM_Try, /*On fail goto*//*Label 21073*/ GIMT_Encode4(1513275), // Rule ID 18038 //
     /* 1513198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1513215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513237 */     // MIs[0] round
     /* 1513237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513240 */     // MIs[0] policy
     /* 1513240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1513253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513274 */     // GIR_Coverage, 18038,
     /* 1513274 */     GIR_EraseRootFromParent_Done,
     /* 1513275 */   // Label 21073: @1513275
     /* 1513275 */   GIM_Try, /*On fail goto*//*Label 21074*/ GIMT_Encode4(1513357), // Rule ID 18039 //
     /* 1513280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1513291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1513294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1513297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1513300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513319 */     // MIs[0] round
     /* 1513319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513322 */     // MIs[0] policy
     /* 1513322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513332 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1513335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513356 */     // GIR_Coverage, 18039,
     /* 1513356 */     GIR_EraseRootFromParent_Done,
     /* 1513357 */   // Label 21074: @1513357
     /* 1513357 */   GIM_Try, /*On fail goto*//*Label 21075*/ GIMT_Encode4(1513439), // Rule ID 18042 //
     /* 1513362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1513379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513401 */     // MIs[0] round
     /* 1513401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513404 */     // MIs[0] policy
     /* 1513404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513414 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1513417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513438 */     // GIR_Coverage, 18042,
     /* 1513438 */     GIR_EraseRootFromParent_Done,
     /* 1513439 */   // Label 21075: @1513439
     /* 1513439 */   GIM_Try, /*On fail goto*//*Label 21076*/ GIMT_Encode4(1513521), // Rule ID 18043 //
     /* 1513444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1513455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1513458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1513461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1513464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513483 */     // MIs[0] round
     /* 1513483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513486 */     // MIs[0] policy
     /* 1513486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513496 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1513499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513520 */     // GIR_Coverage, 18043,
     /* 1513520 */     GIR_EraseRootFromParent_Done,
     /* 1513521 */   // Label 21076: @1513521
     /* 1513521 */   GIM_Try, /*On fail goto*//*Label 21077*/ GIMT_Encode4(1513603), // Rule ID 18046 //
     /* 1513526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1513537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1513540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1513543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1513546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513565 */     // MIs[0] round
     /* 1513565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513568 */     // MIs[0] policy
     /* 1513568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513578 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1513581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513602 */     // GIR_Coverage, 18046,
     /* 1513602 */     GIR_EraseRootFromParent_Done,
     /* 1513603 */   // Label 21077: @1513603
     /* 1513603 */   GIM_Try, /*On fail goto*//*Label 21078*/ GIMT_Encode4(1513685), // Rule ID 18047 //
     /* 1513608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1513611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1513619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1513622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1513625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1513628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513647 */     // MIs[0] round
     /* 1513647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513650 */     // MIs[0] policy
     /* 1513650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513660 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1513663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1513681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513684 */     // GIR_Coverage, 18047,
     /* 1513684 */     GIR_EraseRootFromParent_Done,
     /* 1513685 */   // Label 21078: @1513685
     /* 1513685 */   GIM_Try, /*On fail goto*//*Label 21079*/ GIMT_Encode4(1513767), // Rule ID 18050 //
     /* 1513690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1513701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1513704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1513710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513729 */     // MIs[0] round
     /* 1513729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513732 */     // MIs[0] policy
     /* 1513732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513742 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1513745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513766 */     // GIR_Coverage, 18050,
     /* 1513766 */     GIR_EraseRootFromParent_Done,
     /* 1513767 */   // Label 21079: @1513767
     /* 1513767 */   GIM_Try, /*On fail goto*//*Label 21080*/ GIMT_Encode4(1513849), // Rule ID 18051 //
     /* 1513772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1513783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1513786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1513792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513811 */     // MIs[0] round
     /* 1513811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513814 */     // MIs[0] policy
     /* 1513814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513824 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1513827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513848 */     // GIR_Coverage, 18051,
     /* 1513848 */     GIR_EraseRootFromParent_Done,
     /* 1513849 */   // Label 21080: @1513849
     /* 1513849 */   GIM_Try, /*On fail goto*//*Label 21081*/ GIMT_Encode4(1513931), // Rule ID 18054 //
     /* 1513854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1513865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1513868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1513874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513893 */     // MIs[0] round
     /* 1513893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513896 */     // MIs[0] policy
     /* 1513896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513906 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1513909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513930 */     // GIR_Coverage, 18054,
     /* 1513930 */     GIR_EraseRootFromParent_Done,
     /* 1513931 */   // Label 21081: @1513931
     /* 1513931 */   GIM_Try, /*On fail goto*//*Label 21082*/ GIMT_Encode4(1514013), // Rule ID 18055 //
     /* 1513936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1513944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1513947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1513950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1513956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1513975 */     // MIs[0] round
     /* 1513975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513978 */     // MIs[0] policy
     /* 1513978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513988 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1513991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514012 */     // GIR_Coverage, 18055,
     /* 1514012 */     GIR_EraseRootFromParent_Done,
     /* 1514013 */   // Label 21082: @1514013
     /* 1514013 */   GIM_Try, /*On fail goto*//*Label 21083*/ GIMT_Encode4(1514095), // Rule ID 18058 //
     /* 1514018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514057 */     // MIs[0] round
     /* 1514057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514060 */     // MIs[0] policy
     /* 1514060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514070 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1514073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514094 */     // GIR_Coverage, 18058,
     /* 1514094 */     GIR_EraseRootFromParent_Done,
     /* 1514095 */   // Label 21083: @1514095
     /* 1514095 */   GIM_Try, /*On fail goto*//*Label 21084*/ GIMT_Encode4(1514177), // Rule ID 18059 //
     /* 1514100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514139 */     // MIs[0] round
     /* 1514139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514142 */     // MIs[0] policy
     /* 1514142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514152 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1514155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514176 */     // GIR_Coverage, 18059,
     /* 1514176 */     GIR_EraseRootFromParent_Done,
     /* 1514177 */   // Label 21084: @1514177
     /* 1514177 */   GIM_Try, /*On fail goto*//*Label 21085*/ GIMT_Encode4(1514259), // Rule ID 18062 //
     /* 1514182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514221 */     // MIs[0] round
     /* 1514221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514224 */     // MIs[0] policy
     /* 1514224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514234 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1514237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514258 */     // GIR_Coverage, 18062,
     /* 1514258 */     GIR_EraseRootFromParent_Done,
     /* 1514259 */   // Label 21085: @1514259
     /* 1514259 */   GIM_Try, /*On fail goto*//*Label 21086*/ GIMT_Encode4(1514341), // Rule ID 18063 //
     /* 1514264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514303 */     // MIs[0] round
     /* 1514303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514306 */     // MIs[0] policy
     /* 1514306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514316 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11214:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1514319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514340 */     // GIR_Coverage, 18063,
     /* 1514340 */     GIR_EraseRootFromParent_Done,
     /* 1514341 */   // Label 21086: @1514341
     /* 1514341 */   GIM_Try, /*On fail goto*//*Label 21087*/ GIMT_Encode4(1514423), // Rule ID 18066 //
     /* 1514346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514385 */     // MIs[0] round
     /* 1514385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514388 */     // MIs[0] policy
     /* 1514388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514398 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1514401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514422 */     // GIR_Coverage, 18066,
     /* 1514422 */     GIR_EraseRootFromParent_Done,
     /* 1514423 */   // Label 21087: @1514423
     /* 1514423 */   GIM_Try, /*On fail goto*//*Label 21088*/ GIMT_Encode4(1514505), // Rule ID 18067 //
     /* 1514428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1514439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1514442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1514445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1514448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1514463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514467 */     // MIs[0] round
     /* 1514467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514470 */     // MIs[0] policy
     /* 1514470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514480 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1514483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514504 */     // GIR_Coverage, 18067,
     /* 1514504 */     GIR_EraseRootFromParent_Done,
     /* 1514505 */   // Label 21088: @1514505
     /* 1514505 */   GIM_Try, /*On fail goto*//*Label 21089*/ GIMT_Encode4(1514587), // Rule ID 18070 //
     /* 1514510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1514521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1514524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1514530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514549 */     // MIs[0] round
     /* 1514549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514552 */     // MIs[0] policy
     /* 1514552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514562 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1514565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514586 */     // GIR_Coverage, 18070,
     /* 1514586 */     GIR_EraseRootFromParent_Done,
     /* 1514587 */   // Label 21089: @1514587
     /* 1514587 */   GIM_Try, /*On fail goto*//*Label 21090*/ GIMT_Encode4(1514669), // Rule ID 18071 //
     /* 1514592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1514603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1514606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1514612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514631 */     // MIs[0] round
     /* 1514631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514634 */     // MIs[0] policy
     /* 1514634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514644 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1514647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514668 */     // GIR_Coverage, 18071,
     /* 1514668 */     GIR_EraseRootFromParent_Done,
     /* 1514669 */   // Label 21090: @1514669
     /* 1514669 */   GIM_Try, /*On fail goto*//*Label 21091*/ GIMT_Encode4(1514751), // Rule ID 18074 //
     /* 1514674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1514685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1514688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1514694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514713 */     // MIs[0] round
     /* 1514713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514716 */     // MIs[0] policy
     /* 1514716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514726 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1514729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514750 */     // GIR_Coverage, 18074,
     /* 1514750 */     GIR_EraseRootFromParent_Done,
     /* 1514751 */   // Label 21091: @1514751
     /* 1514751 */   GIM_Try, /*On fail goto*//*Label 21092*/ GIMT_Encode4(1514833), // Rule ID 18075 //
     /* 1514756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1514767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1514770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1514776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514795 */     // MIs[0] round
     /* 1514795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514798 */     // MIs[0] policy
     /* 1514798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514808 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1514811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514832 */     // GIR_Coverage, 18075,
     /* 1514832 */     GIR_EraseRootFromParent_Done,
     /* 1514833 */   // Label 21092: @1514833
     /* 1514833 */   GIM_Try, /*On fail goto*//*Label 21093*/ GIMT_Encode4(1514915), // Rule ID 18078 //
     /* 1514838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1514849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1514852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1514858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514877 */     // MIs[0] round
     /* 1514877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514880 */     // MIs[0] policy
     /* 1514880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514890 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1514893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514914 */     // GIR_Coverage, 18078,
     /* 1514914 */     GIR_EraseRootFromParent_Done,
     /* 1514915 */   // Label 21093: @1514915
     /* 1514915 */   GIM_Try, /*On fail goto*//*Label 21094*/ GIMT_Encode4(1514997), // Rule ID 18079 //
     /* 1514920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1514928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1514931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1514934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1514937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1514940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1514955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514959 */     // MIs[0] round
     /* 1514959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514962 */     // MIs[0] policy
     /* 1514962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514972 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1514975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514996 */     // GIR_Coverage, 18079,
     /* 1514996 */     GIR_EraseRootFromParent_Done,
     /* 1514997 */   // Label 21094: @1514997
     /* 1514997 */   GIM_Try, /*On fail goto*//*Label 21095*/ GIMT_Encode4(1515079), // Rule ID 18082 //
     /* 1515002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515041 */     // MIs[0] round
     /* 1515041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515044 */     // MIs[0] policy
     /* 1515044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515054 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1515057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515078 */     // GIR_Coverage, 18082,
     /* 1515078 */     GIR_EraseRootFromParent_Done,
     /* 1515079 */   // Label 21095: @1515079
     /* 1515079 */   GIM_Try, /*On fail goto*//*Label 21096*/ GIMT_Encode4(1515161), // Rule ID 18083 //
     /* 1515084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1515101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1515119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515123 */     // MIs[0] round
     /* 1515123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515126 */     // MIs[0] policy
     /* 1515126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515136 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1515139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515160 */     // GIR_Coverage, 18083,
     /* 1515160 */     GIR_EraseRootFromParent_Done,
     /* 1515161 */   // Label 21096: @1515161
     /* 1515161 */   GIM_Try, /*On fail goto*//*Label 21097*/ GIMT_Encode4(1515243), // Rule ID 18086 //
     /* 1515166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515205 */     // MIs[0] round
     /* 1515205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515208 */     // MIs[0] policy
     /* 1515208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515218 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1515221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515242 */     // GIR_Coverage, 18086,
     /* 1515242 */     GIR_EraseRootFromParent_Done,
     /* 1515243 */   // Label 21097: @1515243
     /* 1515243 */   GIM_Try, /*On fail goto*//*Label 21098*/ GIMT_Encode4(1515325), // Rule ID 18087 //
     /* 1515248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515287 */     // MIs[0] round
     /* 1515287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515290 */     // MIs[0] policy
     /* 1515290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515300 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1515303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515324 */     // GIR_Coverage, 18087,
     /* 1515324 */     GIR_EraseRootFromParent_Done,
     /* 1515325 */   // Label 21098: @1515325
     /* 1515325 */   GIM_Try, /*On fail goto*//*Label 21099*/ GIMT_Encode4(1515407), // Rule ID 18090 //
     /* 1515330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515369 */     // MIs[0] round
     /* 1515369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515372 */     // MIs[0] policy
     /* 1515372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515382 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1515385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515406 */     // GIR_Coverage, 18090,
     /* 1515406 */     GIR_EraseRootFromParent_Done,
     /* 1515407 */   // Label 21099: @1515407
     /* 1515407 */   GIM_Try, /*On fail goto*//*Label 21100*/ GIMT_Encode4(1515489), // Rule ID 18091 //
     /* 1515412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1515423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1515426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1515432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515451 */     // MIs[0] round
     /* 1515451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515454 */     // MIs[0] policy
     /* 1515454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515464 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1515467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515488 */     // GIR_Coverage, 18091,
     /* 1515488 */     GIR_EraseRootFromParent_Done,
     /* 1515489 */   // Label 21100: @1515489
     /* 1515489 */   GIM_Try, /*On fail goto*//*Label 21101*/ GIMT_Encode4(1515571), // Rule ID 18094 //
     /* 1515494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1515505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1515508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1515514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515533 */     // MIs[0] round
     /* 1515533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515536 */     // MIs[0] policy
     /* 1515536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515546 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1515549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515570 */     // GIR_Coverage, 18094,
     /* 1515570 */     GIR_EraseRootFromParent_Done,
     /* 1515571 */   // Label 21101: @1515571
     /* 1515571 */   GIM_Try, /*On fail goto*//*Label 21102*/ GIMT_Encode4(1515653), // Rule ID 18095 //
     /* 1515576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1515587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1515590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1515593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1515596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1515611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515615 */     // MIs[0] round
     /* 1515615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515618 */     // MIs[0] policy
     /* 1515618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515628 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1515631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515652 */     // GIR_Coverage, 18095,
     /* 1515652 */     GIR_EraseRootFromParent_Done,
     /* 1515653 */   // Label 21102: @1515653
     /* 1515653 */   GIM_Try, /*On fail goto*//*Label 21103*/ GIMT_Encode4(1515735), // Rule ID 18098 //
     /* 1515658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1515661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1515669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1515672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1515678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515697 */     // MIs[0] round
     /* 1515697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515700 */     // MIs[0] policy
     /* 1515700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515710 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1515713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515734 */     // GIR_Coverage, 18098,
     /* 1515734 */     GIR_EraseRootFromParent_Done,
     /* 1515735 */   // Label 21103: @1515735
     /* 1515735 */   GIM_Try, /*On fail goto*//*Label 21104*/ GIMT_Encode4(1515817), // Rule ID 18099 //
     /* 1515740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1515743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1515751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1515754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1515760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515779 */     // MIs[0] round
     /* 1515779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515782 */     // MIs[0] policy
     /* 1515782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515792 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1515795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515816 */     // GIR_Coverage, 18099,
     /* 1515816 */     GIR_EraseRootFromParent_Done,
     /* 1515817 */   // Label 21104: @1515817
     /* 1515817 */   GIM_Try, /*On fail goto*//*Label 21105*/ GIMT_Encode4(1515899), // Rule ID 18102 //
     /* 1515822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1515825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1515833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1515836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1515842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515861 */     // MIs[0] round
     /* 1515861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515864 */     // MIs[0] policy
     /* 1515864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515874 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1515877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515898 */     // GIR_Coverage, 18102,
     /* 1515898 */     GIR_EraseRootFromParent_Done,
     /* 1515899 */   // Label 21105: @1515899
     /* 1515899 */   GIM_Try, /*On fail goto*//*Label 21106*/ GIMT_Encode4(1515981), // Rule ID 18103 //
     /* 1515904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1515907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1515915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1515918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1515921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1515924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1515939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515943 */     // MIs[0] round
     /* 1515943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515946 */     // MIs[0] policy
     /* 1515946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515956 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1515959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515980 */     // GIR_Coverage, 18103,
     /* 1515980 */     GIR_EraseRootFromParent_Done,
     /* 1515981 */   // Label 21106: @1515981
     /* 1515981 */   GIM_Try, /*On fail goto*//*Label 21107*/ GIMT_Encode4(1516063), // Rule ID 18106 //
     /* 1515986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1515989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1515994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1515997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516025 */     // MIs[0] round
     /* 1516025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516028 */     // MIs[0] policy
     /* 1516028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516038 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1516041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516062 */     // GIR_Coverage, 18106,
     /* 1516062 */     GIR_EraseRootFromParent_Done,
     /* 1516063 */   // Label 21107: @1516063
     /* 1516063 */   GIM_Try, /*On fail goto*//*Label 21108*/ GIMT_Encode4(1516145), // Rule ID 18107 //
     /* 1516068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1516076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1516085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1516103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516107 */     // MIs[0] round
     /* 1516107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516110 */     // MIs[0] policy
     /* 1516110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516120 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1516123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516144 */     // GIR_Coverage, 18107,
     /* 1516144 */     GIR_EraseRootFromParent_Done,
     /* 1516145 */   // Label 21108: @1516145
     /* 1516145 */   GIM_Try, /*On fail goto*//*Label 21109*/ GIMT_Encode4(1516227), // Rule ID 18110 //
     /* 1516150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1516167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516189 */     // MIs[0] round
     /* 1516189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516192 */     // MIs[0] policy
     /* 1516192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516202 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1516205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516226 */     // GIR_Coverage, 18110,
     /* 1516226 */     GIR_EraseRootFromParent_Done,
     /* 1516227 */   // Label 21109: @1516227
     /* 1516227 */   GIM_Try, /*On fail goto*//*Label 21110*/ GIMT_Encode4(1516309), // Rule ID 18111 //
     /* 1516232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1516249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516271 */     // MIs[0] round
     /* 1516271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516274 */     // MIs[0] policy
     /* 1516274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516284 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1516287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516308 */     // GIR_Coverage, 18111,
     /* 1516308 */     GIR_EraseRootFromParent_Done,
     /* 1516309 */   // Label 21110: @1516309
     /* 1516309 */   GIM_Try, /*On fail goto*//*Label 21111*/ GIMT_Encode4(1516391), // Rule ID 18114 //
     /* 1516314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1516331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516353 */     // MIs[0] round
     /* 1516353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516356 */     // MIs[0] policy
     /* 1516356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516366 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1516369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516390 */     // GIR_Coverage, 18114,
     /* 1516390 */     GIR_EraseRootFromParent_Done,
     /* 1516391 */   // Label 21111: @1516391
     /* 1516391 */   GIM_Try, /*On fail goto*//*Label 21112*/ GIMT_Encode4(1516473), // Rule ID 18115 //
     /* 1516396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1516407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1516410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1516413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1516416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516435 */     // MIs[0] round
     /* 1516435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516438 */     // MIs[0] policy
     /* 1516438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516448 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1516451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516472 */     // GIR_Coverage, 18115,
     /* 1516472 */     GIR_EraseRootFromParent_Done,
     /* 1516473 */   // Label 21112: @1516473
     /* 1516473 */   GIM_Try, /*On fail goto*//*Label 21113*/ GIMT_Encode4(1516555), // Rule ID 18118 //
     /* 1516478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1516489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1516492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1516495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1516498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516517 */     // MIs[0] round
     /* 1516517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516520 */     // MIs[0] policy
     /* 1516520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516530 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1516533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516554 */     // GIR_Coverage, 18118,
     /* 1516554 */     GIR_EraseRootFromParent_Done,
     /* 1516555 */   // Label 21113: @1516555
     /* 1516555 */   GIM_Try, /*On fail goto*//*Label 21114*/ GIMT_Encode4(1516637), // Rule ID 18119 //
     /* 1516560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1516571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1516574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1516577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1516580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516599 */     // MIs[0] round
     /* 1516599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516602 */     // MIs[0] policy
     /* 1516602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516612 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1516615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516636 */     // GIR_Coverage, 18119,
     /* 1516636 */     GIR_EraseRootFromParent_Done,
     /* 1516637 */   // Label 21114: @1516637
     /* 1516637 */   GIM_Try, /*On fail goto*//*Label 21115*/ GIMT_Encode4(1516719), // Rule ID 18122 //
     /* 1516642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1516653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1516656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1516659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1516662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516681 */     // MIs[0] round
     /* 1516681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516684 */     // MIs[0] policy
     /* 1516684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516694 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1516697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516718 */     // GIR_Coverage, 18122,
     /* 1516718 */     GIR_EraseRootFromParent_Done,
     /* 1516719 */   // Label 21115: @1516719
     /* 1516719 */   GIM_Try, /*On fail goto*//*Label 21116*/ GIMT_Encode4(1516801), // Rule ID 18123 //
     /* 1516724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1516727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1516735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1516738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1516741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1516744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516763 */     // MIs[0] round
     /* 1516763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516766 */     // MIs[0] policy
     /* 1516766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516776 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1516779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1516797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516800 */     // GIR_Coverage, 18123,
     /* 1516800 */     GIR_EraseRootFromParent_Done,
     /* 1516801 */   // Label 21116: @1516801
     /* 1516801 */   GIM_Try, /*On fail goto*//*Label 21117*/ GIMT_Encode4(1516883), // Rule ID 18126 //
     /* 1516806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1516817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1516820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1516823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1516826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516845 */     // MIs[0] round
     /* 1516845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516848 */     // MIs[0] policy
     /* 1516848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516858 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1516861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516882 */     // GIR_Coverage, 18126,
     /* 1516882 */     GIR_EraseRootFromParent_Done,
     /* 1516883 */   // Label 21117: @1516883
     /* 1516883 */   GIM_Try, /*On fail goto*//*Label 21118*/ GIMT_Encode4(1516965), // Rule ID 18127 //
     /* 1516888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1516899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1516902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1516905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1516908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516927 */     // MIs[0] round
     /* 1516927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516930 */     // MIs[0] policy
     /* 1516930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516940 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1516943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516964 */     // GIR_Coverage, 18127,
     /* 1516964 */     GIR_EraseRootFromParent_Done,
     /* 1516965 */   // Label 21118: @1516965
     /* 1516965 */   GIM_Try, /*On fail goto*//*Label 21119*/ GIMT_Encode4(1517047), // Rule ID 18130 //
     /* 1516970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1516978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1516981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1516984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1516987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1516990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517009 */     // MIs[0] round
     /* 1517009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517012 */     // MIs[0] policy
     /* 1517012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517022 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1517025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517046 */     // GIR_Coverage, 18130,
     /* 1517046 */     GIR_EraseRootFromParent_Done,
     /* 1517047 */   // Label 21119: @1517047
     /* 1517047 */   GIM_Try, /*On fail goto*//*Label 21120*/ GIMT_Encode4(1517129), // Rule ID 18131 //
     /* 1517052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1517055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1517069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517091 */     // MIs[0] round
     /* 1517091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517094 */     // MIs[0] policy
     /* 1517094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517104 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1517107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517128 */     // GIR_Coverage, 18131,
     /* 1517128 */     GIR_EraseRootFromParent_Done,
     /* 1517129 */   // Label 21120: @1517129
     /* 1517129 */   GIM_Try, /*On fail goto*//*Label 21121*/ GIMT_Encode4(1517211), // Rule ID 18134 //
     /* 1517134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1517151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517173 */     // MIs[0] round
     /* 1517173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517176 */     // MIs[0] policy
     /* 1517176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517186 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1517189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517210 */     // GIR_Coverage, 18134,
     /* 1517210 */     GIR_EraseRootFromParent_Done,
     /* 1517211 */   // Label 21121: @1517211
     /* 1517211 */   GIM_Try, /*On fail goto*//*Label 21122*/ GIMT_Encode4(1517293), // Rule ID 18135 //
     /* 1517216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1517233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517255 */     // MIs[0] round
     /* 1517255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517258 */     // MIs[0] policy
     /* 1517258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517268 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1517271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517292 */     // GIR_Coverage, 18135,
     /* 1517292 */     GIR_EraseRootFromParent_Done,
     /* 1517293 */   // Label 21122: @1517293
     /* 1517293 */   GIM_Try, /*On fail goto*//*Label 21123*/ GIMT_Encode4(1517375), // Rule ID 18138 //
     /* 1517298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1517315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517337 */     // MIs[0] round
     /* 1517337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517340 */     // MIs[0] policy
     /* 1517340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517350 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1517353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517374 */     // GIR_Coverage, 18138,
     /* 1517374 */     GIR_EraseRootFromParent_Done,
     /* 1517375 */   // Label 21123: @1517375
     /* 1517375 */   GIM_Try, /*On fail goto*//*Label 21124*/ GIMT_Encode4(1517457), // Rule ID 18139 //
     /* 1517380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1517391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1517394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1517397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1517400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517419 */     // MIs[0] round
     /* 1517419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517422 */     // MIs[0] policy
     /* 1517422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517432 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1517435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517456 */     // GIR_Coverage, 18139,
     /* 1517456 */     GIR_EraseRootFromParent_Done,
     /* 1517457 */   // Label 21124: @1517457
     /* 1517457 */   GIM_Try, /*On fail goto*//*Label 21125*/ GIMT_Encode4(1517539), // Rule ID 18142 //
     /* 1517462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1517479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1517482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517501 */     // MIs[0] round
     /* 1517501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517504 */     // MIs[0] policy
     /* 1517504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517514 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1517517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517538 */     // GIR_Coverage, 18142,
     /* 1517538 */     GIR_EraseRootFromParent_Done,
     /* 1517539 */   // Label 21125: @1517539
     /* 1517539 */   GIM_Try, /*On fail goto*//*Label 21126*/ GIMT_Encode4(1517621), // Rule ID 18143 //
     /* 1517544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1517555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1517558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1517561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1517564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517583 */     // MIs[0] round
     /* 1517583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517586 */     // MIs[0] policy
     /* 1517586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517596 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1517599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517620 */     // GIR_Coverage, 18143,
     /* 1517620 */     GIR_EraseRootFromParent_Done,
     /* 1517621 */   // Label 21126: @1517621
     /* 1517621 */   GIM_Try, /*On fail goto*//*Label 21127*/ GIMT_Encode4(1517703), // Rule ID 18146 //
     /* 1517626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1517637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1517640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1517643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1517646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517665 */     // MIs[0] round
     /* 1517665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517668 */     // MIs[0] policy
     /* 1517668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517678 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1517681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517702 */     // GIR_Coverage, 18146,
     /* 1517702 */     GIR_EraseRootFromParent_Done,
     /* 1517703 */   // Label 21127: @1517703
     /* 1517703 */   GIM_Try, /*On fail goto*//*Label 21128*/ GIMT_Encode4(1517785), // Rule ID 18147 //
     /* 1517708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1517719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1517722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1517725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1517728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517747 */     // MIs[0] round
     /* 1517747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517750 */     // MIs[0] policy
     /* 1517750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517760 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1517763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517784 */     // GIR_Coverage, 18147,
     /* 1517784 */     GIR_EraseRootFromParent_Done,
     /* 1517785 */   // Label 21128: @1517785
     /* 1517785 */   GIM_Try, /*On fail goto*//*Label 21129*/ GIMT_Encode4(1517867), // Rule ID 18150 //
     /* 1517790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1517801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1517804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1517807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1517810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517829 */     // MIs[0] round
     /* 1517829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517832 */     // MIs[0] policy
     /* 1517832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517842 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1517845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517866 */     // GIR_Coverage, 18150,
     /* 1517866 */     GIR_EraseRootFromParent_Done,
     /* 1517867 */   // Label 21129: @1517867
     /* 1517867 */   GIM_Try, /*On fail goto*//*Label 21130*/ GIMT_Encode4(1517949), // Rule ID 18151 //
     /* 1517872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1517883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1517886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1517889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1517892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1517911 */     // MIs[0] round
     /* 1517911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517914 */     // MIs[0] policy
     /* 1517914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517924 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1517927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517948 */     // GIR_Coverage, 18151,
     /* 1517948 */     GIR_EraseRootFromParent_Done,
     /* 1517949 */   // Label 21130: @1517949
     /* 1517949 */   GIM_Try, /*On fail goto*//*Label 21131*/ GIMT_Encode4(1518031), // Rule ID 18154 //
     /* 1517954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1517962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1517965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1517968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1517971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1517974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1517993 */     // MIs[0] round
     /* 1517993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517996 */     // MIs[0] policy
     /* 1517996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518006 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1518009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518030 */     // GIR_Coverage, 18154,
     /* 1518030 */     GIR_EraseRootFromParent_Done,
     /* 1518031 */   // Label 21131: @1518031
     /* 1518031 */   GIM_Try, /*On fail goto*//*Label 21132*/ GIMT_Encode4(1518113), // Rule ID 18155 //
     /* 1518036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1518053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518075 */     // MIs[0] round
     /* 1518075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518078 */     // MIs[0] policy
     /* 1518078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518088 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1518091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518112 */     // GIR_Coverage, 18155,
     /* 1518112 */     GIR_EraseRootFromParent_Done,
     /* 1518113 */   // Label 21132: @1518113
     /* 1518113 */   GIM_Try, /*On fail goto*//*Label 21133*/ GIMT_Encode4(1518195), // Rule ID 18158 //
     /* 1518118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1518135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518157 */     // MIs[0] round
     /* 1518157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518160 */     // MIs[0] policy
     /* 1518160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518170 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1518173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518194 */     // GIR_Coverage, 18158,
     /* 1518194 */     GIR_EraseRootFromParent_Done,
     /* 1518195 */   // Label 21133: @1518195
     /* 1518195 */   GIM_Try, /*On fail goto*//*Label 21134*/ GIMT_Encode4(1518277), // Rule ID 18159 //
     /* 1518200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1518217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518239 */     // MIs[0] round
     /* 1518239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518242 */     // MIs[0] policy
     /* 1518242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518252 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1518255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518276 */     // GIR_Coverage, 18159,
     /* 1518276 */     GIR_EraseRootFromParent_Done,
     /* 1518277 */   // Label 21134: @1518277
     /* 1518277 */   GIM_Try, /*On fail goto*//*Label 21135*/ GIMT_Encode4(1518359), // Rule ID 18162 //
     /* 1518282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1518299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518321 */     // MIs[0] round
     /* 1518321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518324 */     // MIs[0] policy
     /* 1518324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518334 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1518337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518358 */     // GIR_Coverage, 18162,
     /* 1518358 */     GIR_EraseRootFromParent_Done,
     /* 1518359 */   // Label 21135: @1518359
     /* 1518359 */   GIM_Try, /*On fail goto*//*Label 21136*/ GIMT_Encode4(1518441), // Rule ID 18163 //
     /* 1518364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1518375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1518378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1518381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1518384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518403 */     // MIs[0] round
     /* 1518403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518406 */     // MIs[0] policy
     /* 1518406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518416 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1518419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518440 */     // GIR_Coverage, 18163,
     /* 1518440 */     GIR_EraseRootFromParent_Done,
     /* 1518441 */   // Label 21136: @1518441
     /* 1518441 */   GIM_Try, /*On fail goto*//*Label 21137*/ GIMT_Encode4(1518523), // Rule ID 18166 //
     /* 1518446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1518457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1518460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1518463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1518466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518485 */     // MIs[0] round
     /* 1518485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518488 */     // MIs[0] policy
     /* 1518488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518498 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1518501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518522 */     // GIR_Coverage, 18166,
     /* 1518522 */     GIR_EraseRootFromParent_Done,
     /* 1518523 */   // Label 21137: @1518523
     /* 1518523 */   GIM_Try, /*On fail goto*//*Label 21138*/ GIMT_Encode4(1518605), // Rule ID 18167 //
     /* 1518528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1518539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1518542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1518545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1518548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518567 */     // MIs[0] round
     /* 1518567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518570 */     // MIs[0] policy
     /* 1518570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518580 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1518583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518604 */     // GIR_Coverage, 18167,
     /* 1518604 */     GIR_EraseRootFromParent_Done,
     /* 1518605 */   // Label 21138: @1518605
     /* 1518605 */   GIM_Try, /*On fail goto*//*Label 21139*/ GIMT_Encode4(1518687), // Rule ID 18170 //
     /* 1518610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1518621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1518624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1518630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518649 */     // MIs[0] round
     /* 1518649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518652 */     // MIs[0] policy
     /* 1518652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518662 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1518665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518686 */     // GIR_Coverage, 18170,
     /* 1518686 */     GIR_EraseRootFromParent_Done,
     /* 1518687 */   // Label 21139: @1518687
     /* 1518687 */   GIM_Try, /*On fail goto*//*Label 21140*/ GIMT_Encode4(1518769), // Rule ID 18171 //
     /* 1518692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1518703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1518706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1518712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518731 */     // MIs[0] round
     /* 1518731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518734 */     // MIs[0] policy
     /* 1518734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518744 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1518747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518768 */     // GIR_Coverage, 18171,
     /* 1518768 */     GIR_EraseRootFromParent_Done,
     /* 1518769 */   // Label 21140: @1518769
     /* 1518769 */   GIM_Try, /*On fail goto*//*Label 21141*/ GIMT_Encode4(1518851), // Rule ID 18174 //
     /* 1518774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1518785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1518788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1518794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518813 */     // MIs[0] round
     /* 1518813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518816 */     // MIs[0] policy
     /* 1518816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518826 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1518829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518850 */     // GIR_Coverage, 18174,
     /* 1518850 */     GIR_EraseRootFromParent_Done,
     /* 1518851 */   // Label 21141: @1518851
     /* 1518851 */   GIM_Try, /*On fail goto*//*Label 21142*/ GIMT_Encode4(1518933), // Rule ID 18175 //
     /* 1518856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1518867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1518870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1518876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518895 */     // MIs[0] round
     /* 1518895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518898 */     // MIs[0] policy
     /* 1518898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518908 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1518911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518932 */     // GIR_Coverage, 18175,
     /* 1518932 */     GIR_EraseRootFromParent_Done,
     /* 1518933 */   // Label 21142: @1518933
     /* 1518933 */   GIM_Try, /*On fail goto*//*Label 21143*/ GIMT_Encode4(1519015), // Rule ID 18178 //
     /* 1518938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1518946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1518949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1518952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1518958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1518977 */     // MIs[0] round
     /* 1518977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518980 */     // MIs[0] policy
     /* 1518980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518990 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1518993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519014 */     // GIR_Coverage, 18178,
     /* 1519014 */     GIR_EraseRootFromParent_Done,
     /* 1519015 */   // Label 21143: @1519015
     /* 1519015 */   GIM_Try, /*On fail goto*//*Label 21144*/ GIMT_Encode4(1519097), // Rule ID 18179 //
     /* 1519020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519059 */     // MIs[0] round
     /* 1519059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519062 */     // MIs[0] policy
     /* 1519062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519072 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1519075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519096 */     // GIR_Coverage, 18179,
     /* 1519096 */     GIR_EraseRootFromParent_Done,
     /* 1519097 */   // Label 21144: @1519097
     /* 1519097 */   GIM_Try, /*On fail goto*//*Label 21145*/ GIMT_Encode4(1519179), // Rule ID 18182 //
     /* 1519102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519141 */     // MIs[0] round
     /* 1519141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519144 */     // MIs[0] policy
     /* 1519144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519154 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1519157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519178 */     // GIR_Coverage, 18182,
     /* 1519178 */     GIR_EraseRootFromParent_Done,
     /* 1519179 */   // Label 21145: @1519179
     /* 1519179 */   GIM_Try, /*On fail goto*//*Label 21146*/ GIMT_Encode4(1519261), // Rule ID 18183 //
     /* 1519184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519223 */     // MIs[0] round
     /* 1519223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519226 */     // MIs[0] policy
     /* 1519226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519236 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11245:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1519239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519260 */     // GIR_Coverage, 18183,
     /* 1519260 */     GIR_EraseRootFromParent_Done,
     /* 1519261 */   // Label 21146: @1519261
     /* 1519261 */   GIM_Try, /*On fail goto*//*Label 21147*/ GIMT_Encode4(1519343), // Rule ID 18186 //
     /* 1519266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519305 */     // MIs[0] round
     /* 1519305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519308 */     // MIs[0] policy
     /* 1519308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519318 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1519321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519342 */     // GIR_Coverage, 18186,
     /* 1519342 */     GIR_EraseRootFromParent_Done,
     /* 1519343 */   // Label 21147: @1519343
     /* 1519343 */   GIM_Try, /*On fail goto*//*Label 21148*/ GIMT_Encode4(1519425), // Rule ID 18187 //
     /* 1519348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1519359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1519362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1519365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1519368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1519383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519387 */     // MIs[0] round
     /* 1519387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519390 */     // MIs[0] policy
     /* 1519390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519400 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1519403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519424 */     // GIR_Coverage, 18187,
     /* 1519424 */     GIR_EraseRootFromParent_Done,
     /* 1519425 */   // Label 21148: @1519425
     /* 1519425 */   GIM_Try, /*On fail goto*//*Label 21149*/ GIMT_Encode4(1519507), // Rule ID 18190 //
     /* 1519430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1519444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1519450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519469 */     // MIs[0] round
     /* 1519469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519472 */     // MIs[0] policy
     /* 1519472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519482 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1519485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519506 */     // GIR_Coverage, 18190,
     /* 1519506 */     GIR_EraseRootFromParent_Done,
     /* 1519507 */   // Label 21149: @1519507
     /* 1519507 */   GIM_Try, /*On fail goto*//*Label 21150*/ GIMT_Encode4(1519589), // Rule ID 18191 //
     /* 1519512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1519523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1519526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1519532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519551 */     // MIs[0] round
     /* 1519551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519554 */     // MIs[0] policy
     /* 1519554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519564 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1519567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519588 */     // GIR_Coverage, 18191,
     /* 1519588 */     GIR_EraseRootFromParent_Done,
     /* 1519589 */   // Label 21150: @1519589
     /* 1519589 */   GIM_Try, /*On fail goto*//*Label 21151*/ GIMT_Encode4(1519671), // Rule ID 18194 //
     /* 1519594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1519605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1519608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1519614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519633 */     // MIs[0] round
     /* 1519633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519636 */     // MIs[0] policy
     /* 1519636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519646 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1519649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519670 */     // GIR_Coverage, 18194,
     /* 1519670 */     GIR_EraseRootFromParent_Done,
     /* 1519671 */   // Label 21151: @1519671
     /* 1519671 */   GIM_Try, /*On fail goto*//*Label 21152*/ GIMT_Encode4(1519753), // Rule ID 18195 //
     /* 1519676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1519687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1519690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1519696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519715 */     // MIs[0] round
     /* 1519715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519718 */     // MIs[0] policy
     /* 1519718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519728 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1519731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519752 */     // GIR_Coverage, 18195,
     /* 1519752 */     GIR_EraseRootFromParent_Done,
     /* 1519753 */   // Label 21152: @1519753
     /* 1519753 */   GIM_Try, /*On fail goto*//*Label 21153*/ GIMT_Encode4(1519835), // Rule ID 18198 //
     /* 1519758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1519769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1519772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1519778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519797 */     // MIs[0] round
     /* 1519797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519800 */     // MIs[0] policy
     /* 1519800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519810 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1519813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519834 */     // GIR_Coverage, 18198,
     /* 1519834 */     GIR_EraseRootFromParent_Done,
     /* 1519835 */   // Label 21153: @1519835
     /* 1519835 */   GIM_Try, /*On fail goto*//*Label 21154*/ GIMT_Encode4(1519917), // Rule ID 18199 //
     /* 1519840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1519851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1519854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1519860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519879 */     // MIs[0] round
     /* 1519879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519882 */     // MIs[0] policy
     /* 1519882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519892 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1519895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519916 */     // GIR_Coverage, 18199,
     /* 1519916 */     GIR_EraseRootFromParent_Done,
     /* 1519917 */   // Label 21154: @1519917
     /* 1519917 */   GIM_Try, /*On fail goto*//*Label 21155*/ GIMT_Encode4(1519999), // Rule ID 18202 //
     /* 1519922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1519930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1519933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1519936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1519939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1519942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1519957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519961 */     // MIs[0] round
     /* 1519961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519964 */     // MIs[0] policy
     /* 1519964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519974 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1519977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519998 */     // GIR_Coverage, 18202,
     /* 1519998 */     GIR_EraseRootFromParent_Done,
     /* 1519999 */   // Label 21155: @1519999
     /* 1519999 */   GIM_Try, /*On fail goto*//*Label 21156*/ GIMT_Encode4(1520081), // Rule ID 18203 //
     /* 1520004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1520021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1520039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520043 */     // MIs[0] round
     /* 1520043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520046 */     // MIs[0] policy
     /* 1520046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520056 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1520059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520080 */     // GIR_Coverage, 18203,
     /* 1520080 */     GIR_EraseRootFromParent_Done,
     /* 1520081 */   // Label 21156: @1520081
     /* 1520081 */   GIM_Try, /*On fail goto*//*Label 21157*/ GIMT_Encode4(1520163), // Rule ID 18206 //
     /* 1520086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520125 */     // MIs[0] round
     /* 1520125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520128 */     // MIs[0] policy
     /* 1520128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520138 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1520141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520162 */     // GIR_Coverage, 18206,
     /* 1520162 */     GIR_EraseRootFromParent_Done,
     /* 1520163 */   // Label 21157: @1520163
     /* 1520163 */   GIM_Try, /*On fail goto*//*Label 21158*/ GIMT_Encode4(1520245), // Rule ID 18207 //
     /* 1520168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520207 */     // MIs[0] round
     /* 1520207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520210 */     // MIs[0] policy
     /* 1520210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520220 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1520223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520244 */     // GIR_Coverage, 18207,
     /* 1520244 */     GIR_EraseRootFromParent_Done,
     /* 1520245 */   // Label 21158: @1520245
     /* 1520245 */   GIM_Try, /*On fail goto*//*Label 21159*/ GIMT_Encode4(1520327), // Rule ID 18210 //
     /* 1520250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520289 */     // MIs[0] round
     /* 1520289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520292 */     // MIs[0] policy
     /* 1520292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520302 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1520305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520326 */     // GIR_Coverage, 18210,
     /* 1520326 */     GIR_EraseRootFromParent_Done,
     /* 1520327 */   // Label 21159: @1520327
     /* 1520327 */   GIM_Try, /*On fail goto*//*Label 21160*/ GIMT_Encode4(1520409), // Rule ID 18211 //
     /* 1520332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1520343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1520346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1520352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520371 */     // MIs[0] round
     /* 1520371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520374 */     // MIs[0] policy
     /* 1520374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520384 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1520387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520408 */     // GIR_Coverage, 18211,
     /* 1520408 */     GIR_EraseRootFromParent_Done,
     /* 1520409 */   // Label 21160: @1520409
     /* 1520409 */   GIM_Try, /*On fail goto*//*Label 21161*/ GIMT_Encode4(1520491), // Rule ID 18214 //
     /* 1520414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520453 */     // MIs[0] round
     /* 1520453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520456 */     // MIs[0] policy
     /* 1520456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520466 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1520469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520490 */     // GIR_Coverage, 18214,
     /* 1520490 */     GIR_EraseRootFromParent_Done,
     /* 1520491 */   // Label 21161: @1520491
     /* 1520491 */   GIM_Try, /*On fail goto*//*Label 21162*/ GIMT_Encode4(1520573), // Rule ID 18215 //
     /* 1520496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1520507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1520510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1520513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1520516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1520531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520535 */     // MIs[0] round
     /* 1520535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520538 */     // MIs[0] policy
     /* 1520538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520548 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1520551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520572 */     // GIR_Coverage, 18215,
     /* 1520572 */     GIR_EraseRootFromParent_Done,
     /* 1520573 */   // Label 21162: @1520573
     /* 1520573 */   GIM_Try, /*On fail goto*//*Label 21163*/ GIMT_Encode4(1520655), // Rule ID 18218 //
     /* 1520578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1520589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1520592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1520598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520617 */     // MIs[0] round
     /* 1520617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520620 */     // MIs[0] policy
     /* 1520620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520630 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1520633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520654 */     // GIR_Coverage, 18218,
     /* 1520654 */     GIR_EraseRootFromParent_Done,
     /* 1520655 */   // Label 21163: @1520655
     /* 1520655 */   GIM_Try, /*On fail goto*//*Label 21164*/ GIMT_Encode4(1520737), // Rule ID 18219 //
     /* 1520660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1520663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1520671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1520674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1520680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520699 */     // MIs[0] round
     /* 1520699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520702 */     // MIs[0] policy
     /* 1520702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520712 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11245:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1520715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520736 */     // GIR_Coverage, 18219,
     /* 1520736 */     GIR_EraseRootFromParent_Done,
     /* 1520737 */   // Label 21164: @1520737
     /* 1520737 */   GIM_Try, /*On fail goto*//*Label 21165*/ GIMT_Encode4(1520819), // Rule ID 18222 //
     /* 1520742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1520753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1520756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1520762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520781 */     // MIs[0] round
     /* 1520781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520784 */     // MIs[0] policy
     /* 1520784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520794 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1520797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520818 */     // GIR_Coverage, 18222,
     /* 1520818 */     GIR_EraseRootFromParent_Done,
     /* 1520819 */   // Label 21165: @1520819
     /* 1520819 */   GIM_Try, /*On fail goto*//*Label 21166*/ GIMT_Encode4(1520901), // Rule ID 18223 //
     /* 1520824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1520827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1520835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1520838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1520844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520863 */     // MIs[0] round
     /* 1520863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520866 */     // MIs[0] policy
     /* 1520866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520876 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11245:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1520879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520900 */     // GIR_Coverage, 18223,
     /* 1520900 */     GIR_EraseRootFromParent_Done,
     /* 1520901 */   // Label 21166: @1520901
     /* 1520901 */   GIM_Try, /*On fail goto*//*Label 21167*/ GIMT_Encode4(1520983), // Rule ID 18226 //
     /* 1520906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1520917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1520920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1520923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1520926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1520941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520945 */     // MIs[0] round
     /* 1520945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520948 */     // MIs[0] policy
     /* 1520948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520958 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1520961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520982 */     // GIR_Coverage, 18226,
     /* 1520982 */     GIR_EraseRootFromParent_Done,
     /* 1520983 */   // Label 21167: @1520983
     /* 1520983 */   GIM_Try, /*On fail goto*//*Label 21168*/ GIMT_Encode4(1521065), // Rule ID 18227 //
     /* 1520988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1520991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1520996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1520999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1521005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1521023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521027 */     // MIs[0] round
     /* 1521027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521030 */     // MIs[0] policy
     /* 1521030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521040 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11245:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1521043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521064 */     // GIR_Coverage, 18227,
     /* 1521064 */     GIR_EraseRootFromParent_Done,
     /* 1521065 */   // Label 21168: @1521065
     /* 1521065 */   GIM_Try, /*On fail goto*//*Label 21169*/ GIMT_Encode4(1521147), // Rule ID 18230 //
     /* 1521070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1521087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521109 */     // MIs[0] round
     /* 1521109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521112 */     // MIs[0] policy
     /* 1521112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521122 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1521125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521146 */     // GIR_Coverage, 18230,
     /* 1521146 */     GIR_EraseRootFromParent_Done,
     /* 1521147 */   // Label 21169: @1521147
     /* 1521147 */   GIM_Try, /*On fail goto*//*Label 21170*/ GIMT_Encode4(1521229), // Rule ID 18231 //
     /* 1521152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1521169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521191 */     // MIs[0] round
     /* 1521191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521194 */     // MIs[0] policy
     /* 1521194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521204 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1521207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521228 */     // GIR_Coverage, 18231,
     /* 1521228 */     GIR_EraseRootFromParent_Done,
     /* 1521229 */   // Label 21170: @1521229
     /* 1521229 */   GIM_Try, /*On fail goto*//*Label 21171*/ GIMT_Encode4(1521311), // Rule ID 18234 //
     /* 1521234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1521251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521273 */     // MIs[0] round
     /* 1521273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521276 */     // MIs[0] policy
     /* 1521276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521286 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1521289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521310 */     // GIR_Coverage, 18234,
     /* 1521310 */     GIR_EraseRootFromParent_Done,
     /* 1521311 */   // Label 21171: @1521311
     /* 1521311 */   GIM_Try, /*On fail goto*//*Label 21172*/ GIMT_Encode4(1521393), // Rule ID 18235 //
     /* 1521316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1521327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1521330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1521333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1521336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521355 */     // MIs[0] round
     /* 1521355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521358 */     // MIs[0] policy
     /* 1521358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521368 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1521371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521392 */     // GIR_Coverage, 18235,
     /* 1521392 */     GIR_EraseRootFromParent_Done,
     /* 1521393 */   // Label 21172: @1521393
     /* 1521393 */   GIM_Try, /*On fail goto*//*Label 21173*/ GIMT_Encode4(1521475), // Rule ID 18238 //
     /* 1521398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521437 */     // MIs[0] round
     /* 1521437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521440 */     // MIs[0] policy
     /* 1521440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521450 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1521453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521474 */     // GIR_Coverage, 18238,
     /* 1521474 */     GIR_EraseRootFromParent_Done,
     /* 1521475 */   // Label 21173: @1521475
     /* 1521475 */   GIM_Try, /*On fail goto*//*Label 21174*/ GIMT_Encode4(1521557), // Rule ID 18239 //
     /* 1521480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1521491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1521494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1521497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1521500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521519 */     // MIs[0] round
     /* 1521519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521522 */     // MIs[0] policy
     /* 1521522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521532 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1521535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521556 */     // GIR_Coverage, 18239,
     /* 1521556 */     GIR_EraseRootFromParent_Done,
     /* 1521557 */   // Label 21174: @1521557
     /* 1521557 */   GIM_Try, /*On fail goto*//*Label 21175*/ GIMT_Encode4(1521639), // Rule ID 18242 //
     /* 1521562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1521573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1521576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1521579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1521582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521601 */     // MIs[0] round
     /* 1521601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521604 */     // MIs[0] policy
     /* 1521604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521614 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1521617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521638 */     // GIR_Coverage, 18242,
     /* 1521638 */     GIR_EraseRootFromParent_Done,
     /* 1521639 */   // Label 21175: @1521639
     /* 1521639 */   GIM_Try, /*On fail goto*//*Label 21176*/ GIMT_Encode4(1521721), // Rule ID 18243 //
     /* 1521644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1521655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1521658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1521661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1521664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521683 */     // MIs[0] round
     /* 1521683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521686 */     // MIs[0] policy
     /* 1521686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521696 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1521699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521720 */     // GIR_Coverage, 18243,
     /* 1521720 */     GIR_EraseRootFromParent_Done,
     /* 1521721 */   // Label 21176: @1521721
     /* 1521721 */   GIM_Try, /*On fail goto*//*Label 21177*/ GIMT_Encode4(1521803), // Rule ID 18246 //
     /* 1521726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1521737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1521740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1521743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1521746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521765 */     // MIs[0] round
     /* 1521765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521768 */     // MIs[0] policy
     /* 1521768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521778 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1521781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521802 */     // GIR_Coverage, 18246,
     /* 1521802 */     GIR_EraseRootFromParent_Done,
     /* 1521803 */   // Label 21177: @1521803
     /* 1521803 */   GIM_Try, /*On fail goto*//*Label 21178*/ GIMT_Encode4(1521885), // Rule ID 18247 //
     /* 1521808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1521819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1521822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1521825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1521828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521847 */     // MIs[0] round
     /* 1521847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521850 */     // MIs[0] policy
     /* 1521850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1521863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521884 */     // GIR_Coverage, 18247,
     /* 1521884 */     GIR_EraseRootFromParent_Done,
     /* 1521885 */   // Label 21178: @1521885
     /* 1521885 */   GIM_Try, /*On fail goto*//*Label 21179*/ GIMT_Encode4(1521967), // Rule ID 18250 //
     /* 1521890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1521901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1521904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1521907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1521910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521929 */     // MIs[0] round
     /* 1521929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521932 */     // MIs[0] policy
     /* 1521932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521942 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1521945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521966 */     // GIR_Coverage, 18250,
     /* 1521966 */     GIR_EraseRootFromParent_Done,
     /* 1521967 */   // Label 21179: @1521967
     /* 1521967 */   GIM_Try, /*On fail goto*//*Label 21180*/ GIMT_Encode4(1522049), // Rule ID 18251 //
     /* 1521972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1521980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1521983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1521986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1521989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1521992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522011 */     // MIs[0] round
     /* 1522011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522014 */     // MIs[0] policy
     /* 1522014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522024 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1522027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522048 */     // GIR_Coverage, 18251,
     /* 1522048 */     GIR_EraseRootFromParent_Done,
     /* 1522049 */   // Label 21180: @1522049
     /* 1522049 */   GIM_Try, /*On fail goto*//*Label 21181*/ GIMT_Encode4(1522131), // Rule ID 18254 //
     /* 1522054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1522071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522093 */     // MIs[0] round
     /* 1522093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522096 */     // MIs[0] policy
     /* 1522096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522106 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1522109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522130 */     // GIR_Coverage, 18254,
     /* 1522130 */     GIR_EraseRootFromParent_Done,
     /* 1522131 */   // Label 21181: @1522131
     /* 1522131 */   GIM_Try, /*On fail goto*//*Label 21182*/ GIMT_Encode4(1522213), // Rule ID 18255 //
     /* 1522136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1522153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522175 */     // MIs[0] round
     /* 1522175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522178 */     // MIs[0] policy
     /* 1522178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522188 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1522191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522212 */     // GIR_Coverage, 18255,
     /* 1522212 */     GIR_EraseRootFromParent_Done,
     /* 1522213 */   // Label 21182: @1522213
     /* 1522213 */   GIM_Try, /*On fail goto*//*Label 21183*/ GIMT_Encode4(1522295), // Rule ID 18258 //
     /* 1522218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1522235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522257 */     // MIs[0] round
     /* 1522257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522260 */     // MIs[0] policy
     /* 1522260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522270 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1522273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522294 */     // GIR_Coverage, 18258,
     /* 1522294 */     GIR_EraseRootFromParent_Done,
     /* 1522295 */   // Label 21183: @1522295
     /* 1522295 */   GIM_Try, /*On fail goto*//*Label 21184*/ GIMT_Encode4(1522377), // Rule ID 18259 //
     /* 1522300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1522311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1522314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1522317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1522320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522339 */     // MIs[0] round
     /* 1522339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522342 */     // MIs[0] policy
     /* 1522342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522352 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1522355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522376 */     // GIR_Coverage, 18259,
     /* 1522376 */     GIR_EraseRootFromParent_Done,
     /* 1522377 */   // Label 21184: @1522377
     /* 1522377 */   GIM_Try, /*On fail goto*//*Label 21185*/ GIMT_Encode4(1522459), // Rule ID 18262 //
     /* 1522382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1522399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522421 */     // MIs[0] round
     /* 1522421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522424 */     // MIs[0] policy
     /* 1522424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522434 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1522437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522458 */     // GIR_Coverage, 18262,
     /* 1522458 */     GIR_EraseRootFromParent_Done,
     /* 1522459 */   // Label 21185: @1522459
     /* 1522459 */   GIM_Try, /*On fail goto*//*Label 21186*/ GIMT_Encode4(1522541), // Rule ID 18263 //
     /* 1522464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1522475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1522478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1522481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1522484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522503 */     // MIs[0] round
     /* 1522503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522506 */     // MIs[0] policy
     /* 1522506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522516 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1522519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522540 */     // GIR_Coverage, 18263,
     /* 1522540 */     GIR_EraseRootFromParent_Done,
     /* 1522541 */   // Label 21186: @1522541
     /* 1522541 */   GIM_Try, /*On fail goto*//*Label 21187*/ GIMT_Encode4(1522623), // Rule ID 18266 //
     /* 1522546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1522557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1522560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1522563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1522566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522585 */     // MIs[0] round
     /* 1522585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522588 */     // MIs[0] policy
     /* 1522588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522598 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1522601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522622 */     // GIR_Coverage, 18266,
     /* 1522622 */     GIR_EraseRootFromParent_Done,
     /* 1522623 */   // Label 21187: @1522623
     /* 1522623 */   GIM_Try, /*On fail goto*//*Label 21188*/ GIMT_Encode4(1522705), // Rule ID 18267 //
     /* 1522628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1522639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1522642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1522645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1522648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522667 */     // MIs[0] round
     /* 1522667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522670 */     // MIs[0] policy
     /* 1522670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522680 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1522683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522704 */     // GIR_Coverage, 18267,
     /* 1522704 */     GIR_EraseRootFromParent_Done,
     /* 1522705 */   // Label 21188: @1522705
     /* 1522705 */   GIM_Try, /*On fail goto*//*Label 21189*/ GIMT_Encode4(1522787), // Rule ID 18270 //
     /* 1522710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1522721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1522724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1522727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1522730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522749 */     // MIs[0] round
     /* 1522749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522752 */     // MIs[0] policy
     /* 1522752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522762 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1522765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522786 */     // GIR_Coverage, 18270,
     /* 1522786 */     GIR_EraseRootFromParent_Done,
     /* 1522787 */   // Label 21189: @1522787
     /* 1522787 */   GIM_Try, /*On fail goto*//*Label 21190*/ GIMT_Encode4(1522869), // Rule ID 18271 //
     /* 1522792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1522803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1522806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1522809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1522812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1522831 */     // MIs[0] round
     /* 1522831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522834 */     // MIs[0] policy
     /* 1522834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522844 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1522847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522868 */     // GIR_Coverage, 18271,
     /* 1522868 */     GIR_EraseRootFromParent_Done,
     /* 1522869 */   // Label 21190: @1522869
     /* 1522869 */   GIM_Try, /*On fail goto*//*Label 21191*/ GIMT_Encode4(1522951), // Rule ID 18274 //
     /* 1522874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1522885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1522888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1522891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1522894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522913 */     // MIs[0] round
     /* 1522913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522916 */     // MIs[0] policy
     /* 1522916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522926 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1522929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522950 */     // GIR_Coverage, 18274,
     /* 1522950 */     GIR_EraseRootFromParent_Done,
     /* 1522951 */   // Label 21191: @1522951
     /* 1522951 */   GIM_Try, /*On fail goto*//*Label 21192*/ GIMT_Encode4(1523033), // Rule ID 18275 //
     /* 1522956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1522964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1522967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1522970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1522973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1522976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1522995 */     // MIs[0] round
     /* 1522995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522998 */     // MIs[0] policy
     /* 1522998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523008 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1523011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523032 */     // GIR_Coverage, 18275,
     /* 1523032 */     GIR_EraseRootFromParent_Done,
     /* 1523033 */   // Label 21192: @1523033
     /* 1523033 */   GIM_Try, /*On fail goto*//*Label 21193*/ GIMT_Encode4(1523115), // Rule ID 18278 //
     /* 1523038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1523055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523077 */     // MIs[0] round
     /* 1523077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523080 */     // MIs[0] policy
     /* 1523080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1523093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523114 */     // GIR_Coverage, 18278,
     /* 1523114 */     GIR_EraseRootFromParent_Done,
     /* 1523115 */   // Label 21193: @1523115
     /* 1523115 */   GIM_Try, /*On fail goto*//*Label 21194*/ GIMT_Encode4(1523197), // Rule ID 18279 //
     /* 1523120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1523137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523159 */     // MIs[0] round
     /* 1523159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523162 */     // MIs[0] policy
     /* 1523162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523172 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1523175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523196 */     // GIR_Coverage, 18279,
     /* 1523196 */     GIR_EraseRootFromParent_Done,
     /* 1523197 */   // Label 21194: @1523197
     /* 1523197 */   GIM_Try, /*On fail goto*//*Label 21195*/ GIMT_Encode4(1523279), // Rule ID 18282 //
     /* 1523202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1523219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523241 */     // MIs[0] round
     /* 1523241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523244 */     // MIs[0] policy
     /* 1523244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523254 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1523257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523278 */     // GIR_Coverage, 18282,
     /* 1523278 */     GIR_EraseRootFromParent_Done,
     /* 1523279 */   // Label 21195: @1523279
     /* 1523279 */   GIM_Try, /*On fail goto*//*Label 21196*/ GIMT_Encode4(1523361), // Rule ID 18283 //
     /* 1523284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1523295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1523298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1523301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1523304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523323 */     // MIs[0] round
     /* 1523323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523326 */     // MIs[0] policy
     /* 1523326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523336 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1523339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523360 */     // GIR_Coverage, 18283,
     /* 1523360 */     GIR_EraseRootFromParent_Done,
     /* 1523361 */   // Label 21196: @1523361
     /* 1523361 */   GIM_Try, /*On fail goto*//*Label 21197*/ GIMT_Encode4(1523443), // Rule ID 18286 //
     /* 1523366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1523383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523405 */     // MIs[0] round
     /* 1523405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523408 */     // MIs[0] policy
     /* 1523408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523418 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1523421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523442 */     // GIR_Coverage, 18286,
     /* 1523442 */     GIR_EraseRootFromParent_Done,
     /* 1523443 */   // Label 21197: @1523443
     /* 1523443 */   GIM_Try, /*On fail goto*//*Label 21198*/ GIMT_Encode4(1523525), // Rule ID 18287 //
     /* 1523448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1523459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1523462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1523465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1523468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523487 */     // MIs[0] round
     /* 1523487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523490 */     // MIs[0] policy
     /* 1523490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523500 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1523503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523524 */     // GIR_Coverage, 18287,
     /* 1523524 */     GIR_EraseRootFromParent_Done,
     /* 1523525 */   // Label 21198: @1523525
     /* 1523525 */   GIM_Try, /*On fail goto*//*Label 21199*/ GIMT_Encode4(1523607), // Rule ID 18290 //
     /* 1523530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1523541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1523544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1523550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523569 */     // MIs[0] round
     /* 1523569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523572 */     // MIs[0] policy
     /* 1523572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523582 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1523585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523606 */     // GIR_Coverage, 18290,
     /* 1523606 */     GIR_EraseRootFromParent_Done,
     /* 1523607 */   // Label 21199: @1523607
     /* 1523607 */   GIM_Try, /*On fail goto*//*Label 21200*/ GIMT_Encode4(1523689), // Rule ID 18291 //
     /* 1523612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1523623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1523626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1523632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523651 */     // MIs[0] round
     /* 1523651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523654 */     // MIs[0] policy
     /* 1523654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523664 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1523667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523688 */     // GIR_Coverage, 18291,
     /* 1523688 */     GIR_EraseRootFromParent_Done,
     /* 1523689 */   // Label 21200: @1523689
     /* 1523689 */   GIM_Try, /*On fail goto*//*Label 21201*/ GIMT_Encode4(1523771), // Rule ID 18294 //
     /* 1523694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1523705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1523708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1523714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523733 */     // MIs[0] round
     /* 1523733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523736 */     // MIs[0] policy
     /* 1523736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523746 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1523749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523770 */     // GIR_Coverage, 18294,
     /* 1523770 */     GIR_EraseRootFromParent_Done,
     /* 1523771 */   // Label 21201: @1523771
     /* 1523771 */   GIM_Try, /*On fail goto*//*Label 21202*/ GIMT_Encode4(1523853), // Rule ID 18295 //
     /* 1523776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1523787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1523790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1523796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523815 */     // MIs[0] round
     /* 1523815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523818 */     // MIs[0] policy
     /* 1523818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523828 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1523831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523852 */     // GIR_Coverage, 18295,
     /* 1523852 */     GIR_EraseRootFromParent_Done,
     /* 1523853 */   // Label 21202: @1523853
     /* 1523853 */   GIM_Try, /*On fail goto*//*Label 21203*/ GIMT_Encode4(1523935), // Rule ID 18298 //
     /* 1523858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1523869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1523872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1523878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523897 */     // MIs[0] round
     /* 1523897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523900 */     // MIs[0] policy
     /* 1523900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523910 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1523913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523934 */     // GIR_Coverage, 18298,
     /* 1523934 */     GIR_EraseRootFromParent_Done,
     /* 1523935 */   // Label 21203: @1523935
     /* 1523935 */   GIM_Try, /*On fail goto*//*Label 21204*/ GIMT_Encode4(1524017), // Rule ID 18299 //
     /* 1523940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1523948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1523951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1523954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1523960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1523979 */     // MIs[0] round
     /* 1523979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523982 */     // MIs[0] policy
     /* 1523982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523992 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1523995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524016 */     // GIR_Coverage, 18299,
     /* 1524016 */     GIR_EraseRootFromParent_Done,
     /* 1524017 */   // Label 21204: @1524017
     /* 1524017 */   GIM_Try, /*On fail goto*//*Label 21205*/ GIMT_Encode4(1524099), // Rule ID 18302 //
     /* 1524022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524061 */     // MIs[0] round
     /* 1524061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524064 */     // MIs[0] policy
     /* 1524064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524074 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1524077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524098 */     // GIR_Coverage, 18302,
     /* 1524098 */     GIR_EraseRootFromParent_Done,
     /* 1524099 */   // Label 21205: @1524099
     /* 1524099 */   GIM_Try, /*On fail goto*//*Label 21206*/ GIMT_Encode4(1524181), // Rule ID 18303 //
     /* 1524104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524143 */     // MIs[0] round
     /* 1524143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524146 */     // MIs[0] policy
     /* 1524146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524156 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1524159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524180 */     // GIR_Coverage, 18303,
     /* 1524180 */     GIR_EraseRootFromParent_Done,
     /* 1524181 */   // Label 21206: @1524181
     /* 1524181 */   GIM_Try, /*On fail goto*//*Label 21207*/ GIMT_Encode4(1524263), // Rule ID 18306 //
     /* 1524186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524225 */     // MIs[0] round
     /* 1524225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524228 */     // MIs[0] policy
     /* 1524228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524238 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1524241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524262 */     // GIR_Coverage, 18306,
     /* 1524262 */     GIR_EraseRootFromParent_Done,
     /* 1524263 */   // Label 21207: @1524263
     /* 1524263 */   GIM_Try, /*On fail goto*//*Label 21208*/ GIMT_Encode4(1524345), // Rule ID 18307 //
     /* 1524268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1524285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1524288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1524303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524307 */     // MIs[0] round
     /* 1524307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524310 */     // MIs[0] policy
     /* 1524310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524320 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1524323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524344 */     // GIR_Coverage, 18307,
     /* 1524344 */     GIR_EraseRootFromParent_Done,
     /* 1524345 */   // Label 21208: @1524345
     /* 1524345 */   GIM_Try, /*On fail goto*//*Label 21209*/ GIMT_Encode4(1524427), // Rule ID 18310 //
     /* 1524350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1524353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524389 */     // MIs[0] round
     /* 1524389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524392 */     // MIs[0] policy
     /* 1524392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1524405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524426 */     // GIR_Coverage, 18310,
     /* 1524426 */     GIR_EraseRootFromParent_Done,
     /* 1524427 */   // Label 21209: @1524427
     /* 1524427 */   GIM_Try, /*On fail goto*//*Label 21210*/ GIMT_Encode4(1524509), // Rule ID 18311 //
     /* 1524432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1524443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1524446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1524452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524471 */     // MIs[0] round
     /* 1524471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524474 */     // MIs[0] policy
     /* 1524474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524484 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1524487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524508 */     // GIR_Coverage, 18311,
     /* 1524508 */     GIR_EraseRootFromParent_Done,
     /* 1524509 */   // Label 21210: @1524509
     /* 1524509 */   GIM_Try, /*On fail goto*//*Label 21211*/ GIMT_Encode4(1524591), // Rule ID 18314 //
     /* 1524514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1524525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1524528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1524534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524553 */     // MIs[0] round
     /* 1524553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524556 */     // MIs[0] policy
     /* 1524556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524566 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1524569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524590 */     // GIR_Coverage, 18314,
     /* 1524590 */     GIR_EraseRootFromParent_Done,
     /* 1524591 */   // Label 21211: @1524591
     /* 1524591 */   GIM_Try, /*On fail goto*//*Label 21212*/ GIMT_Encode4(1524673), // Rule ID 18315 //
     /* 1524596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1524607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1524610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1524616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1524635 */     // MIs[0] round
     /* 1524635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524638 */     // MIs[0] policy
     /* 1524638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524648 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1524651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524672 */     // GIR_Coverage, 18315,
     /* 1524672 */     GIR_EraseRootFromParent_Done,
     /* 1524673 */   // Label 21212: @1524673
     /* 1524673 */   GIM_Try, /*On fail goto*//*Label 21213*/ GIMT_Encode4(1524755), // Rule ID 18318 //
     /* 1524678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1524689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1524692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1524698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524717 */     // MIs[0] round
     /* 1524717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524720 */     // MIs[0] policy
     /* 1524720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524730 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1524733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524754 */     // GIR_Coverage, 18318,
     /* 1524754 */     GIR_EraseRootFromParent_Done,
     /* 1524755 */   // Label 21213: @1524755
     /* 1524755 */   GIM_Try, /*On fail goto*//*Label 21214*/ GIMT_Encode4(1524837), // Rule ID 18319 //
     /* 1524760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1524771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1524774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1524780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524799 */     // MIs[0] round
     /* 1524799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524802 */     // MIs[0] policy
     /* 1524802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524812 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1524815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524836 */     // GIR_Coverage, 18319,
     /* 1524836 */     GIR_EraseRootFromParent_Done,
     /* 1524837 */   // Label 21214: @1524837
     /* 1524837 */   GIM_Try, /*On fail goto*//*Label 21215*/ GIMT_Encode4(1524919), // Rule ID 18322 //
     /* 1524842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1524853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1524856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1524862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524881 */     // MIs[0] round
     /* 1524881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524884 */     // MIs[0] policy
     /* 1524884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524894 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1524897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524918 */     // GIR_Coverage, 18322,
     /* 1524918 */     GIR_EraseRootFromParent_Done,
     /* 1524919 */   // Label 21215: @1524919
     /* 1524919 */   GIM_Try, /*On fail goto*//*Label 21216*/ GIMT_Encode4(1525001), // Rule ID 18323 //
     /* 1524924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1524932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1524935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1524938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1524941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1524944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1524959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524963 */     // MIs[0] round
     /* 1524963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524966 */     // MIs[0] policy
     /* 1524966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524976 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1524979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525000 */     // GIR_Coverage, 18323,
     /* 1525000 */     GIR_EraseRootFromParent_Done,
     /* 1525001 */   // Label 21216: @1525001
     /* 1525001 */   GIM_Try, /*On fail goto*//*Label 21217*/ GIMT_Encode4(1525083), // Rule ID 18326 //
     /* 1525006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525045 */     // MIs[0] round
     /* 1525045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525048 */     // MIs[0] policy
     /* 1525048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525058 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1525061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525082 */     // GIR_Coverage, 18326,
     /* 1525082 */     GIR_EraseRootFromParent_Done,
     /* 1525083 */   // Label 21217: @1525083
     /* 1525083 */   GIM_Try, /*On fail goto*//*Label 21218*/ GIMT_Encode4(1525165), // Rule ID 18327 //
     /* 1525088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525127 */     // MIs[0] round
     /* 1525127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525130 */     // MIs[0] policy
     /* 1525130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525140 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1525143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525164 */     // GIR_Coverage, 18327,
     /* 1525164 */     GIR_EraseRootFromParent_Done,
     /* 1525165 */   // Label 21218: @1525165
     /* 1525165 */   GIM_Try, /*On fail goto*//*Label 21219*/ GIMT_Encode4(1525247), // Rule ID 18330 //
     /* 1525170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525209 */     // MIs[0] round
     /* 1525209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525212 */     // MIs[0] policy
     /* 1525212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525222 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1525225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525246 */     // GIR_Coverage, 18330,
     /* 1525246 */     GIR_EraseRootFromParent_Done,
     /* 1525247 */   // Label 21219: @1525247
     /* 1525247 */   GIM_Try, /*On fail goto*//*Label 21220*/ GIMT_Encode4(1525329), // Rule ID 18331 //
     /* 1525252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525291 */     // MIs[0] round
     /* 1525291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525294 */     // MIs[0] policy
     /* 1525294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525304 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1525307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525328 */     // GIR_Coverage, 18331,
     /* 1525328 */     GIR_EraseRootFromParent_Done,
     /* 1525329 */   // Label 21220: @1525329
     /* 1525329 */   GIM_Try, /*On fail goto*//*Label 21221*/ GIMT_Encode4(1525411), // Rule ID 18334 //
     /* 1525334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525373 */     // MIs[0] round
     /* 1525373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525376 */     // MIs[0] policy
     /* 1525376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525386 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1525389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525410 */     // GIR_Coverage, 18334,
     /* 1525410 */     GIR_EraseRootFromParent_Done,
     /* 1525411 */   // Label 21221: @1525411
     /* 1525411 */   GIM_Try, /*On fail goto*//*Label 21222*/ GIMT_Encode4(1525493), // Rule ID 18335 //
     /* 1525416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1525427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1525430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1525433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1525436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1525451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525455 */     // MIs[0] round
     /* 1525455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525458 */     // MIs[0] policy
     /* 1525458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525468 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1525471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525492 */     // GIR_Coverage, 18335,
     /* 1525492 */     GIR_EraseRootFromParent_Done,
     /* 1525493 */   // Label 21222: @1525493
     /* 1525493 */   GIM_Try, /*On fail goto*//*Label 21223*/ GIMT_Encode4(1525575), // Rule ID 18338 //
     /* 1525498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1525509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1525512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1525518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525537 */     // MIs[0] round
     /* 1525537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525540 */     // MIs[0] policy
     /* 1525540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525550 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1525553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525574 */     // GIR_Coverage, 18338,
     /* 1525574 */     GIR_EraseRootFromParent_Done,
     /* 1525575 */   // Label 21223: @1525575
     /* 1525575 */   GIM_Try, /*On fail goto*//*Label 21224*/ GIMT_Encode4(1525657), // Rule ID 18339 //
     /* 1525580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1525591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1525594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1525600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525619 */     // MIs[0] round
     /* 1525619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525622 */     // MIs[0] policy
     /* 1525622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525632 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1525635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525656 */     // GIR_Coverage, 18339,
     /* 1525656 */     GIR_EraseRootFromParent_Done,
     /* 1525657 */   // Label 21224: @1525657
     /* 1525657 */   GIM_Try, /*On fail goto*//*Label 21225*/ GIMT_Encode4(1525739), // Rule ID 18342 //
     /* 1525662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1525673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1525676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1525682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525701 */     // MIs[0] round
     /* 1525701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525704 */     // MIs[0] policy
     /* 1525704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525714 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1525717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525738 */     // GIR_Coverage, 18342,
     /* 1525738 */     GIR_EraseRootFromParent_Done,
     /* 1525739 */   // Label 21225: @1525739
     /* 1525739 */   GIM_Try, /*On fail goto*//*Label 21226*/ GIMT_Encode4(1525821), // Rule ID 18343 //
     /* 1525744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1525755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1525758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1525764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525783 */     // MIs[0] round
     /* 1525783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525786 */     // MIs[0] policy
     /* 1525786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525796 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1525799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525820 */     // GIR_Coverage, 18343,
     /* 1525820 */     GIR_EraseRootFromParent_Done,
     /* 1525821 */   // Label 21226: @1525821
     /* 1525821 */   GIM_Try, /*On fail goto*//*Label 21227*/ GIMT_Encode4(1525903), // Rule ID 18346 //
     /* 1525826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1525837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1525840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1525846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525865 */     // MIs[0] round
     /* 1525865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525868 */     // MIs[0] policy
     /* 1525868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525878 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1525881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525902 */     // GIR_Coverage, 18346,
     /* 1525902 */     GIR_EraseRootFromParent_Done,
     /* 1525903 */   // Label 21227: @1525903
     /* 1525903 */   GIM_Try, /*On fail goto*//*Label 21228*/ GIMT_Encode4(1525985), // Rule ID 18347 //
     /* 1525908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1525916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1525919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1525922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1525925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1525928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1525943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525947 */     // MIs[0] round
     /* 1525947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525950 */     // MIs[0] policy
     /* 1525950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525960 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1525963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525984 */     // GIR_Coverage, 18347,
     /* 1525984 */     GIR_EraseRootFromParent_Done,
     /* 1525985 */   // Label 21228: @1525985
     /* 1525985 */   GIM_Try, /*On fail goto*//*Label 21229*/ GIMT_Encode4(1526067), // Rule ID 18350 //
     /* 1525990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1525998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1526007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526029 */     // MIs[0] round
     /* 1526029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526032 */     // MIs[0] policy
     /* 1526032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526042 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1526045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526066 */     // GIR_Coverage, 18350,
     /* 1526066 */     GIR_EraseRootFromParent_Done,
     /* 1526067 */   // Label 21229: @1526067
     /* 1526067 */   GIM_Try, /*On fail goto*//*Label 21230*/ GIMT_Encode4(1526149), // Rule ID 18351 //
     /* 1526072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1526089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526111 */     // MIs[0] round
     /* 1526111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526114 */     // MIs[0] policy
     /* 1526114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526124 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1526127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526148 */     // GIR_Coverage, 18351,
     /* 1526148 */     GIR_EraseRootFromParent_Done,
     /* 1526149 */   // Label 21230: @1526149
     /* 1526149 */   GIM_Try, /*On fail goto*//*Label 21231*/ GIMT_Encode4(1526231), // Rule ID 18354 //
     /* 1526154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1526171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526193 */     // MIs[0] round
     /* 1526193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526196 */     // MIs[0] policy
     /* 1526196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526206 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1526209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526230 */     // GIR_Coverage, 18354,
     /* 1526230 */     GIR_EraseRootFromParent_Done,
     /* 1526231 */   // Label 21231: @1526231
     /* 1526231 */   GIM_Try, /*On fail goto*//*Label 21232*/ GIMT_Encode4(1526313), // Rule ID 18355 //
     /* 1526236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1526253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526275 */     // MIs[0] round
     /* 1526275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526278 */     // MIs[0] policy
     /* 1526278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526288 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1526291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526312 */     // GIR_Coverage, 18355,
     /* 1526312 */     GIR_EraseRootFromParent_Done,
     /* 1526313 */   // Label 21232: @1526313
     /* 1526313 */   GIM_Try, /*On fail goto*//*Label 21233*/ GIMT_Encode4(1526395), // Rule ID 18358 //
     /* 1526318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526357 */     // MIs[0] round
     /* 1526357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526360 */     // MIs[0] policy
     /* 1526360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1526373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526394 */     // GIR_Coverage, 18358,
     /* 1526394 */     GIR_EraseRootFromParent_Done,
     /* 1526395 */   // Label 21233: @1526395
     /* 1526395 */   GIM_Try, /*On fail goto*//*Label 21234*/ GIMT_Encode4(1526477), // Rule ID 18359 //
     /* 1526400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1526411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1526414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1526417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1526420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526439 */     // MIs[0] round
     /* 1526439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526442 */     // MIs[0] policy
     /* 1526442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526452 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1526455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526476 */     // GIR_Coverage, 18359,
     /* 1526476 */     GIR_EraseRootFromParent_Done,
     /* 1526477 */   // Label 21234: @1526477
     /* 1526477 */   GIM_Try, /*On fail goto*//*Label 21235*/ GIMT_Encode4(1526559), // Rule ID 18362 //
     /* 1526482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1526493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1526496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1526499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1526502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526521 */     // MIs[0] round
     /* 1526521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526524 */     // MIs[0] policy
     /* 1526524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526534 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1526537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526558 */     // GIR_Coverage, 18362,
     /* 1526558 */     GIR_EraseRootFromParent_Done,
     /* 1526559 */   // Label 21235: @1526559
     /* 1526559 */   GIM_Try, /*On fail goto*//*Label 21236*/ GIMT_Encode4(1526641), // Rule ID 18363 //
     /* 1526564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1526575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1526578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1526581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1526584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526603 */     // MIs[0] round
     /* 1526603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526606 */     // MIs[0] policy
     /* 1526606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526616 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1526619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526640 */     // GIR_Coverage, 18363,
     /* 1526640 */     GIR_EraseRootFromParent_Done,
     /* 1526641 */   // Label 21236: @1526641
     /* 1526641 */   GIM_Try, /*On fail goto*//*Label 21237*/ GIMT_Encode4(1526723), // Rule ID 18366 //
     /* 1526646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1526657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1526660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1526663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1526666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526685 */     // MIs[0] round
     /* 1526685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526688 */     // MIs[0] policy
     /* 1526688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526698 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1526701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526722 */     // GIR_Coverage, 18366,
     /* 1526722 */     GIR_EraseRootFromParent_Done,
     /* 1526723 */   // Label 21237: @1526723
     /* 1526723 */   GIM_Try, /*On fail goto*//*Label 21238*/ GIMT_Encode4(1526805), // Rule ID 18367 //
     /* 1526728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1526739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1526742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1526745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1526748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526767 */     // MIs[0] round
     /* 1526767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526770 */     // MIs[0] policy
     /* 1526770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526780 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1526783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526804 */     // GIR_Coverage, 18367,
     /* 1526804 */     GIR_EraseRootFromParent_Done,
     /* 1526805 */   // Label 21238: @1526805
     /* 1526805 */   GIM_Try, /*On fail goto*//*Label 21239*/ GIMT_Encode4(1526887), // Rule ID 18370 //
     /* 1526810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1526821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1526824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1526827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1526830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526849 */     // MIs[0] round
     /* 1526849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526852 */     // MIs[0] policy
     /* 1526852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526862 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1526865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526886 */     // GIR_Coverage, 18370,
     /* 1526886 */     GIR_EraseRootFromParent_Done,
     /* 1526887 */   // Label 21239: @1526887
     /* 1526887 */   GIM_Try, /*On fail goto*//*Label 21240*/ GIMT_Encode4(1526969), // Rule ID 18371 //
     /* 1526892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1526903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1526906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1526909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1526912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526931 */     // MIs[0] round
     /* 1526931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526934 */     // MIs[0] policy
     /* 1526934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526944 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1526947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526968 */     // GIR_Coverage, 18371,
     /* 1526968 */     GIR_EraseRootFromParent_Done,
     /* 1526969 */   // Label 21240: @1526969
     /* 1526969 */   GIM_Try, /*On fail goto*//*Label 21241*/ GIMT_Encode4(1527051), // Rule ID 18374 //
     /* 1526974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1526982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1526985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1526988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1526991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1526994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527013 */     // MIs[0] round
     /* 1527013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527016 */     // MIs[0] policy
     /* 1527016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527026 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1527029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527050 */     // GIR_Coverage, 18374,
     /* 1527050 */     GIR_EraseRootFromParent_Done,
     /* 1527051 */   // Label 21241: @1527051
     /* 1527051 */   GIM_Try, /*On fail goto*//*Label 21242*/ GIMT_Encode4(1527133), // Rule ID 18375 //
     /* 1527056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1527073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527095 */     // MIs[0] round
     /* 1527095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527098 */     // MIs[0] policy
     /* 1527098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527108 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1527111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527132 */     // GIR_Coverage, 18375,
     /* 1527132 */     GIR_EraseRootFromParent_Done,
     /* 1527133 */   // Label 21242: @1527133
     /* 1527133 */   GIM_Try, /*On fail goto*//*Label 21243*/ GIMT_Encode4(1527215), // Rule ID 18378 //
     /* 1527138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1527155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527177 */     // MIs[0] round
     /* 1527177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527180 */     // MIs[0] policy
     /* 1527180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527190 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1527193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527214 */     // GIR_Coverage, 18378,
     /* 1527214 */     GIR_EraseRootFromParent_Done,
     /* 1527215 */   // Label 21243: @1527215
     /* 1527215 */   GIM_Try, /*On fail goto*//*Label 21244*/ GIMT_Encode4(1527297), // Rule ID 18379 //
     /* 1527220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1527237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527259 */     // MIs[0] round
     /* 1527259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527262 */     // MIs[0] policy
     /* 1527262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527272 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1527275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527296 */     // GIR_Coverage, 18379,
     /* 1527296 */     GIR_EraseRootFromParent_Done,
     /* 1527297 */   // Label 21244: @1527297
     /* 1527297 */   GIM_Try, /*On fail goto*//*Label 21245*/ GIMT_Encode4(1527379), // Rule ID 18382 //
     /* 1527302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1527319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527341 */     // MIs[0] round
     /* 1527341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527344 */     // MIs[0] policy
     /* 1527344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527354 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1527357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527378 */     // GIR_Coverage, 18382,
     /* 1527378 */     GIR_EraseRootFromParent_Done,
     /* 1527379 */   // Label 21245: @1527379
     /* 1527379 */   GIM_Try, /*On fail goto*//*Label 21246*/ GIMT_Encode4(1527461), // Rule ID 18383 //
     /* 1527384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1527395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1527398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1527401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1527404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527423 */     // MIs[0] round
     /* 1527423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527426 */     // MIs[0] policy
     /* 1527426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527436 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1527439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527460 */     // GIR_Coverage, 18383,
     /* 1527460 */     GIR_EraseRootFromParent_Done,
     /* 1527461 */   // Label 21246: @1527461
     /* 1527461 */   GIM_Try, /*On fail goto*//*Label 21247*/ GIMT_Encode4(1527543), // Rule ID 18386 //
     /* 1527466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1527477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1527480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1527483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1527486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527505 */     // MIs[0] round
     /* 1527505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527508 */     // MIs[0] policy
     /* 1527508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527518 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1527521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527542 */     // GIR_Coverage, 18386,
     /* 1527542 */     GIR_EraseRootFromParent_Done,
     /* 1527543 */   // Label 21247: @1527543
     /* 1527543 */   GIM_Try, /*On fail goto*//*Label 21248*/ GIMT_Encode4(1527625), // Rule ID 18387 //
     /* 1527548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1527559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1527562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1527565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1527568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527587 */     // MIs[0] round
     /* 1527587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527590 */     // MIs[0] policy
     /* 1527590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527600 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1527603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527624 */     // GIR_Coverage, 18387,
     /* 1527624 */     GIR_EraseRootFromParent_Done,
     /* 1527625 */   // Label 21248: @1527625
     /* 1527625 */   GIM_Try, /*On fail goto*//*Label 21249*/ GIMT_Encode4(1527707), // Rule ID 18390 //
     /* 1527630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1527641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1527644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1527647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1527650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527669 */     // MIs[0] round
     /* 1527669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527672 */     // MIs[0] policy
     /* 1527672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527682 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1527685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527706 */     // GIR_Coverage, 18390,
     /* 1527706 */     GIR_EraseRootFromParent_Done,
     /* 1527707 */   // Label 21249: @1527707
     /* 1527707 */   GIM_Try, /*On fail goto*//*Label 21250*/ GIMT_Encode4(1527789), // Rule ID 18391 //
     /* 1527712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1527723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1527726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1527729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1527732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527751 */     // MIs[0] round
     /* 1527751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527754 */     // MIs[0] policy
     /* 1527754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527764 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1527767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527788 */     // GIR_Coverage, 18391,
     /* 1527788 */     GIR_EraseRootFromParent_Done,
     /* 1527789 */   // Label 21250: @1527789
     /* 1527789 */   GIM_Try, /*On fail goto*//*Label 21251*/ GIMT_Encode4(1527871), // Rule ID 18394 //
     /* 1527794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1527805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1527808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1527811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1527814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527833 */     // MIs[0] round
     /* 1527833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527836 */     // MIs[0] policy
     /* 1527836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527846 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1527849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527870 */     // GIR_Coverage, 18394,
     /* 1527870 */     GIR_EraseRootFromParent_Done,
     /* 1527871 */   // Label 21251: @1527871
     /* 1527871 */   GIM_Try, /*On fail goto*//*Label 21252*/ GIMT_Encode4(1527953), // Rule ID 18395 //
     /* 1527876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1527887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1527890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1527893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1527896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1527915 */     // MIs[0] round
     /* 1527915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527918 */     // MIs[0] policy
     /* 1527918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527928 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1527931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527952 */     // GIR_Coverage, 18395,
     /* 1527952 */     GIR_EraseRootFromParent_Done,
     /* 1527953 */   // Label 21252: @1527953
     /* 1527953 */   GIM_Try, /*On fail goto*//*Label 21253*/ GIMT_Encode4(1528035), // Rule ID 18398 //
     /* 1527958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1527961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1527966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1527969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1527972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1527975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1527978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527997 */     // MIs[0] round
     /* 1527997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528000 */     // MIs[0] policy
     /* 1528000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528010 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1528013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528034 */     // GIR_Coverage, 18398,
     /* 1528034 */     GIR_EraseRootFromParent_Done,
     /* 1528035 */   // Label 21253: @1528035
     /* 1528035 */   GIM_Try, /*On fail goto*//*Label 21254*/ GIMT_Encode4(1528117), // Rule ID 18399 //
     /* 1528040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1528057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528079 */     // MIs[0] round
     /* 1528079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528082 */     // MIs[0] policy
     /* 1528082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528092 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1528095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528116 */     // GIR_Coverage, 18399,
     /* 1528116 */     GIR_EraseRootFromParent_Done,
     /* 1528117 */   // Label 21254: @1528117
     /* 1528117 */   GIM_Try, /*On fail goto*//*Label 21255*/ GIMT_Encode4(1528199), // Rule ID 18402 //
     /* 1528122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1528139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528161 */     // MIs[0] round
     /* 1528161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528164 */     // MIs[0] policy
     /* 1528164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528174 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1528177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528198 */     // GIR_Coverage, 18402,
     /* 1528198 */     GIR_EraseRootFromParent_Done,
     /* 1528199 */   // Label 21255: @1528199
     /* 1528199 */   GIM_Try, /*On fail goto*//*Label 21256*/ GIMT_Encode4(1528281), // Rule ID 18403 //
     /* 1528204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1528221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528243 */     // MIs[0] round
     /* 1528243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528246 */     // MIs[0] policy
     /* 1528246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528256 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1528259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528280 */     // GIR_Coverage, 18403,
     /* 1528280 */     GIR_EraseRootFromParent_Done,
     /* 1528281 */   // Label 21256: @1528281
     /* 1528281 */   GIM_Try, /*On fail goto*//*Label 21257*/ GIMT_Encode4(1528363), // Rule ID 18406 //
     /* 1528286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1528303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528325 */     // MIs[0] round
     /* 1528325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528328 */     // MIs[0] policy
     /* 1528328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528338 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1528341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528362 */     // GIR_Coverage, 18406,
     /* 1528362 */     GIR_EraseRootFromParent_Done,
     /* 1528363 */   // Label 21257: @1528363
     /* 1528363 */   GIM_Try, /*On fail goto*//*Label 21258*/ GIMT_Encode4(1528445), // Rule ID 18407 //
     /* 1528368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1528379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1528382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1528385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1528388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528407 */     // MIs[0] round
     /* 1528407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528410 */     // MIs[0] policy
     /* 1528410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528420 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1528423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528444 */     // GIR_Coverage, 18407,
     /* 1528444 */     GIR_EraseRootFromParent_Done,
     /* 1528445 */   // Label 21258: @1528445
     /* 1528445 */   GIM_Try, /*On fail goto*//*Label 21259*/ GIMT_Encode4(1528527), // Rule ID 18410 //
     /* 1528450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1528461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1528464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528489 */     // MIs[0] round
     /* 1528489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528492 */     // MIs[0] policy
     /* 1528492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528502 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1528505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528526 */     // GIR_Coverage, 18410,
     /* 1528526 */     GIR_EraseRootFromParent_Done,
     /* 1528527 */   // Label 21259: @1528527
     /* 1528527 */   GIM_Try, /*On fail goto*//*Label 21260*/ GIMT_Encode4(1528609), // Rule ID 18411 //
     /* 1528532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1528543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1528546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1528552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528571 */     // MIs[0] round
     /* 1528571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528574 */     // MIs[0] policy
     /* 1528574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528584 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1528587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528608 */     // GIR_Coverage, 18411,
     /* 1528608 */     GIR_EraseRootFromParent_Done,
     /* 1528609 */   // Label 21260: @1528609
     /* 1528609 */   GIM_Try, /*On fail goto*//*Label 21261*/ GIMT_Encode4(1528691), // Rule ID 18414 //
     /* 1528614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1528625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1528628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1528634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528653 */     // MIs[0] round
     /* 1528653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528656 */     // MIs[0] policy
     /* 1528656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528666 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1528669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528690 */     // GIR_Coverage, 18414,
     /* 1528690 */     GIR_EraseRootFromParent_Done,
     /* 1528691 */   // Label 21261: @1528691
     /* 1528691 */   GIM_Try, /*On fail goto*//*Label 21262*/ GIMT_Encode4(1528773), // Rule ID 18415 //
     /* 1528696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1528707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1528710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1528716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528735 */     // MIs[0] round
     /* 1528735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528738 */     // MIs[0] policy
     /* 1528738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528748 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1528751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528772 */     // GIR_Coverage, 18415,
     /* 1528772 */     GIR_EraseRootFromParent_Done,
     /* 1528773 */   // Label 21262: @1528773
     /* 1528773 */   GIM_Try, /*On fail goto*//*Label 21263*/ GIMT_Encode4(1528855), // Rule ID 18418 //
     /* 1528778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1528789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1528792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1528798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528817 */     // MIs[0] round
     /* 1528817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528820 */     // MIs[0] policy
     /* 1528820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528830 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1528833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528854 */     // GIR_Coverage, 18418,
     /* 1528854 */     GIR_EraseRootFromParent_Done,
     /* 1528855 */   // Label 21263: @1528855
     /* 1528855 */   GIM_Try, /*On fail goto*//*Label 21264*/ GIMT_Encode4(1528937), // Rule ID 18419 //
     /* 1528860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1528871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1528874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1528880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528899 */     // MIs[0] round
     /* 1528899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528902 */     // MIs[0] policy
     /* 1528902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528912 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1528915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528936 */     // GIR_Coverage, 18419,
     /* 1528936 */     GIR_EraseRootFromParent_Done,
     /* 1528937 */   // Label 21264: @1528937
     /* 1528937 */   GIM_Try, /*On fail goto*//*Label 21265*/ GIMT_Encode4(1529019), // Rule ID 18422 //
     /* 1528942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1528950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1528953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1528956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1528962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1528981 */     // MIs[0] round
     /* 1528981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528984 */     // MIs[0] policy
     /* 1528984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528994 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1528997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529018 */     // GIR_Coverage, 18422,
     /* 1529018 */     GIR_EraseRootFromParent_Done,
     /* 1529019 */   // Label 21265: @1529019
     /* 1529019 */   GIM_Try, /*On fail goto*//*Label 21266*/ GIMT_Encode4(1529101), // Rule ID 18423 //
     /* 1529024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529063 */     // MIs[0] round
     /* 1529063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529066 */     // MIs[0] policy
     /* 1529066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529076 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11243:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1529079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529100 */     // GIR_Coverage, 18423,
     /* 1529100 */     GIR_EraseRootFromParent_Done,
     /* 1529101 */   // Label 21266: @1529101
     /* 1529101 */   GIM_Try, /*On fail goto*//*Label 21267*/ GIMT_Encode4(1529183), // Rule ID 18426 //
     /* 1529106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529145 */     // MIs[0] round
     /* 1529145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529148 */     // MIs[0] policy
     /* 1529148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529158 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1529161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529182 */     // GIR_Coverage, 18426,
     /* 1529182 */     GIR_EraseRootFromParent_Done,
     /* 1529183 */   // Label 21267: @1529183
     /* 1529183 */   GIM_Try, /*On fail goto*//*Label 21268*/ GIMT_Encode4(1529265), // Rule ID 18427 //
     /* 1529188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529227 */     // MIs[0] round
     /* 1529227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529230 */     // MIs[0] policy
     /* 1529230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529240 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1529243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529264 */     // GIR_Coverage, 18427,
     /* 1529264 */     GIR_EraseRootFromParent_Done,
     /* 1529265 */   // Label 21268: @1529265
     /* 1529265 */   GIM_Try, /*On fail goto*//*Label 21269*/ GIMT_Encode4(1529347), // Rule ID 18430 //
     /* 1529270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1529273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529309 */     // MIs[0] round
     /* 1529309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529312 */     // MIs[0] policy
     /* 1529312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529322 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1529325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529346 */     // GIR_Coverage, 18430,
     /* 1529346 */     GIR_EraseRootFromParent_Done,
     /* 1529347 */   // Label 21269: @1529347
     /* 1529347 */   GIM_Try, /*On fail goto*//*Label 21270*/ GIMT_Encode4(1529429), // Rule ID 18431 //
     /* 1529352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1529363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1529366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1529372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529391 */     // MIs[0] round
     /* 1529391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529394 */     // MIs[0] policy
     /* 1529394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529404 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1529407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529428 */     // GIR_Coverage, 18431,
     /* 1529428 */     GIR_EraseRootFromParent_Done,
     /* 1529429 */   // Label 21270: @1529429
     /* 1529429 */   GIM_Try, /*On fail goto*//*Label 21271*/ GIMT_Encode4(1529511), // Rule ID 18434 //
     /* 1529434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1529445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1529448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1529454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529473 */     // MIs[0] round
     /* 1529473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529476 */     // MIs[0] policy
     /* 1529476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529486 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1529489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529510 */     // GIR_Coverage, 18434,
     /* 1529510 */     GIR_EraseRootFromParent_Done,
     /* 1529511 */   // Label 21271: @1529511
     /* 1529511 */   GIM_Try, /*On fail goto*//*Label 21272*/ GIMT_Encode4(1529593), // Rule ID 18435 //
     /* 1529516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1529527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1529530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1529536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529555 */     // MIs[0] round
     /* 1529555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529558 */     // MIs[0] policy
     /* 1529558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529568 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1529571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529592 */     // GIR_Coverage, 18435,
     /* 1529592 */     GIR_EraseRootFromParent_Done,
     /* 1529593 */   // Label 21272: @1529593
     /* 1529593 */   GIM_Try, /*On fail goto*//*Label 21273*/ GIMT_Encode4(1529675), // Rule ID 18438 //
     /* 1529598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1529609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1529612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1529618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529637 */     // MIs[0] round
     /* 1529637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529640 */     // MIs[0] policy
     /* 1529640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529650 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1529653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529674 */     // GIR_Coverage, 18438,
     /* 1529674 */     GIR_EraseRootFromParent_Done,
     /* 1529675 */   // Label 21273: @1529675
     /* 1529675 */   GIM_Try, /*On fail goto*//*Label 21274*/ GIMT_Encode4(1529757), // Rule ID 18439 //
     /* 1529680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1529691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1529694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1529700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529719 */     // MIs[0] round
     /* 1529719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529722 */     // MIs[0] policy
     /* 1529722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529732 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1529735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529756 */     // GIR_Coverage, 18439,
     /* 1529756 */     GIR_EraseRootFromParent_Done,
     /* 1529757 */   // Label 21274: @1529757
     /* 1529757 */   GIM_Try, /*On fail goto*//*Label 21275*/ GIMT_Encode4(1529839), // Rule ID 18442 //
     /* 1529762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1529773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1529776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1529782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529801 */     // MIs[0] round
     /* 1529801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529804 */     // MIs[0] policy
     /* 1529804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529814 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1529817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529838 */     // GIR_Coverage, 18442,
     /* 1529838 */     GIR_EraseRootFromParent_Done,
     /* 1529839 */   // Label 21275: @1529839
     /* 1529839 */   GIM_Try, /*On fail goto*//*Label 21276*/ GIMT_Encode4(1529921), // Rule ID 18443 //
     /* 1529844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1529855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1529858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1529861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1529864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1529879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529883 */     // MIs[0] round
     /* 1529883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529886 */     // MIs[0] policy
     /* 1529886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529896 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1529899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529920 */     // GIR_Coverage, 18443,
     /* 1529920 */     GIR_EraseRootFromParent_Done,
     /* 1529921 */   // Label 21276: @1529921
     /* 1529921 */   GIM_Try, /*On fail goto*//*Label 21277*/ GIMT_Encode4(1530003), // Rule ID 18446 //
     /* 1529926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1529934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1529937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1529940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1529943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1529946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1529961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1529965 */     // MIs[0] round
     /* 1529965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529968 */     // MIs[0] policy
     /* 1529968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529978 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1529981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530002 */     // GIR_Coverage, 18446,
     /* 1530002 */     GIR_EraseRootFromParent_Done,
     /* 1530003 */   // Label 21277: @1530003
     /* 1530003 */   GIM_Try, /*On fail goto*//*Label 21278*/ GIMT_Encode4(1530085), // Rule ID 18447 //
     /* 1530008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530047 */     // MIs[0] round
     /* 1530047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530050 */     // MIs[0] policy
     /* 1530050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530060 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1530063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530084 */     // GIR_Coverage, 18447,
     /* 1530084 */     GIR_EraseRootFromParent_Done,
     /* 1530085 */   // Label 21278: @1530085
     /* 1530085 */   GIM_Try, /*On fail goto*//*Label 21279*/ GIMT_Encode4(1530167), // Rule ID 18450 //
     /* 1530090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530129 */     // MIs[0] round
     /* 1530129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530132 */     // MIs[0] policy
     /* 1530132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530142 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1530145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530166 */     // GIR_Coverage, 18450,
     /* 1530166 */     GIR_EraseRootFromParent_Done,
     /* 1530167 */   // Label 21279: @1530167
     /* 1530167 */   GIM_Try, /*On fail goto*//*Label 21280*/ GIMT_Encode4(1530249), // Rule ID 18451 //
     /* 1530172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530211 */     // MIs[0] round
     /* 1530211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530214 */     // MIs[0] policy
     /* 1530214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530224 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1530227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530248 */     // GIR_Coverage, 18451,
     /* 1530248 */     GIR_EraseRootFromParent_Done,
     /* 1530249 */   // Label 21280: @1530249
     /* 1530249 */   GIM_Try, /*On fail goto*//*Label 21281*/ GIMT_Encode4(1530331), // Rule ID 18454 //
     /* 1530254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530293 */     // MIs[0] round
     /* 1530293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530296 */     // MIs[0] policy
     /* 1530296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530306 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1530309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530330 */     // GIR_Coverage, 18454,
     /* 1530330 */     GIR_EraseRootFromParent_Done,
     /* 1530331 */   // Label 21281: @1530331
     /* 1530331 */   GIM_Try, /*On fail goto*//*Label 21282*/ GIMT_Encode4(1530413), // Rule ID 18455 //
     /* 1530336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1530347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1530350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1530353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1530356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1530371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530375 */     // MIs[0] round
     /* 1530375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530378 */     // MIs[0] policy
     /* 1530378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530388 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1530391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530412 */     // GIR_Coverage, 18455,
     /* 1530412 */     GIR_EraseRootFromParent_Done,
     /* 1530413 */   // Label 21282: @1530413
     /* 1530413 */   GIM_Try, /*On fail goto*//*Label 21283*/ GIMT_Encode4(1530495), // Rule ID 18458 //
     /* 1530418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530457 */     // MIs[0] round
     /* 1530457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530460 */     // MIs[0] policy
     /* 1530460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530470 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1530473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530494 */     // GIR_Coverage, 18458,
     /* 1530494 */     GIR_EraseRootFromParent_Done,
     /* 1530495 */   // Label 21283: @1530495
     /* 1530495 */   GIM_Try, /*On fail goto*//*Label 21284*/ GIMT_Encode4(1530577), // Rule ID 18459 //
     /* 1530500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1530511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1530514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1530520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530539 */     // MIs[0] round
     /* 1530539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530542 */     // MIs[0] policy
     /* 1530542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530552 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11243:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1530555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530576 */     // GIR_Coverage, 18459,
     /* 1530576 */     GIR_EraseRootFromParent_Done,
     /* 1530577 */   // Label 21284: @1530577
     /* 1530577 */   GIM_Try, /*On fail goto*//*Label 21285*/ GIMT_Encode4(1530659), // Rule ID 18462 //
     /* 1530582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1530593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1530596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1530602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530621 */     // MIs[0] round
     /* 1530621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530624 */     // MIs[0] policy
     /* 1530624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530634 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1530637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530658 */     // GIR_Coverage, 18462,
     /* 1530658 */     GIR_EraseRootFromParent_Done,
     /* 1530659 */   // Label 21285: @1530659
     /* 1530659 */   GIM_Try, /*On fail goto*//*Label 21286*/ GIMT_Encode4(1530741), // Rule ID 18463 //
     /* 1530664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1530675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1530678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1530684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530703 */     // MIs[0] round
     /* 1530703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530706 */     // MIs[0] policy
     /* 1530706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530716 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11243:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1530719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530740 */     // GIR_Coverage, 18463,
     /* 1530740 */     GIR_EraseRootFromParent_Done,
     /* 1530741 */   // Label 21286: @1530741
     /* 1530741 */   GIM_Try, /*On fail goto*//*Label 21287*/ GIMT_Encode4(1530823), // Rule ID 18466 //
     /* 1530746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1530757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1530760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1530766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530785 */     // MIs[0] round
     /* 1530785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530788 */     // MIs[0] policy
     /* 1530788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530798 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1530801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530822 */     // GIR_Coverage, 18466,
     /* 1530822 */     GIR_EraseRootFromParent_Done,
     /* 1530823 */   // Label 21287: @1530823
     /* 1530823 */   GIM_Try, /*On fail goto*//*Label 21288*/ GIMT_Encode4(1530905), // Rule ID 18467 //
     /* 1530828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1530836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1530839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1530842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1530845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1530848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1530863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530867 */     // MIs[0] round
     /* 1530867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530870 */     // MIs[0] policy
     /* 1530870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530880 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11243:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1530883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530904 */     // GIR_Coverage, 18467,
     /* 1530904 */     GIR_EraseRootFromParent_Done,
     /* 1530905 */   // Label 21288: @1530905
     /* 1530905 */   GIM_Try, /*On fail goto*//*Label 21289*/ GIMT_Encode4(1530987), // Rule ID 18470 //
     /* 1530910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1530918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1530921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1530924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1530927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1530930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530949 */     // MIs[0] round
     /* 1530949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530952 */     // MIs[0] policy
     /* 1530952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530962 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1530965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530986 */     // GIR_Coverage, 18470,
     /* 1530986 */     GIR_EraseRootFromParent_Done,
     /* 1530987 */   // Label 21289: @1530987
     /* 1530987 */   GIM_Try, /*On fail goto*//*Label 21290*/ GIMT_Encode4(1531069), // Rule ID 18471 //
     /* 1530992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1531009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531031 */     // MIs[0] round
     /* 1531031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531034 */     // MIs[0] policy
     /* 1531034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531044 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1531047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531068 */     // GIR_Coverage, 18471,
     /* 1531068 */     GIR_EraseRootFromParent_Done,
     /* 1531069 */   // Label 21290: @1531069
     /* 1531069 */   GIM_Try, /*On fail goto*//*Label 21291*/ GIMT_Encode4(1531151), // Rule ID 18474 //
     /* 1531074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1531091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531113 */     // MIs[0] round
     /* 1531113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531116 */     // MIs[0] policy
     /* 1531116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531126 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1531129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531150 */     // GIR_Coverage, 18474,
     /* 1531150 */     GIR_EraseRootFromParent_Done,
     /* 1531151 */   // Label 21291: @1531151
     /* 1531151 */   GIM_Try, /*On fail goto*//*Label 21292*/ GIMT_Encode4(1531233), // Rule ID 18475 //
     /* 1531156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1531173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531195 */     // MIs[0] round
     /* 1531195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531198 */     // MIs[0] policy
     /* 1531198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531208 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1531211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531232 */     // GIR_Coverage, 18475,
     /* 1531232 */     GIR_EraseRootFromParent_Done,
     /* 1531233 */   // Label 21292: @1531233
     /* 1531233 */   GIM_Try, /*On fail goto*//*Label 21293*/ GIMT_Encode4(1531315), // Rule ID 18478 //
     /* 1531238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531277 */     // MIs[0] round
     /* 1531277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531280 */     // MIs[0] policy
     /* 1531280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531290 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1531293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531314 */     // GIR_Coverage, 18478,
     /* 1531314 */     GIR_EraseRootFromParent_Done,
     /* 1531315 */   // Label 21293: @1531315
     /* 1531315 */   GIM_Try, /*On fail goto*//*Label 21294*/ GIMT_Encode4(1531397), // Rule ID 18479 //
     /* 1531320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1531331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1531334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1531337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1531340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531359 */     // MIs[0] round
     /* 1531359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531362 */     // MIs[0] policy
     /* 1531362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531372 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1531375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531396 */     // GIR_Coverage, 18479,
     /* 1531396 */     GIR_EraseRootFromParent_Done,
     /* 1531397 */   // Label 21294: @1531397
     /* 1531397 */   GIM_Try, /*On fail goto*//*Label 21295*/ GIMT_Encode4(1531479), // Rule ID 18482 //
     /* 1531402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531441 */     // MIs[0] round
     /* 1531441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531444 */     // MIs[0] policy
     /* 1531444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531454 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1531457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531478 */     // GIR_Coverage, 18482,
     /* 1531478 */     GIR_EraseRootFromParent_Done,
     /* 1531479 */   // Label 21295: @1531479
     /* 1531479 */   GIM_Try, /*On fail goto*//*Label 21296*/ GIMT_Encode4(1531561), // Rule ID 18483 //
     /* 1531484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1531495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1531498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1531501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1531504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531523 */     // MIs[0] round
     /* 1531523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531526 */     // MIs[0] policy
     /* 1531526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531536 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1531539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531560 */     // GIR_Coverage, 18483,
     /* 1531560 */     GIR_EraseRootFromParent_Done,
     /* 1531561 */   // Label 21296: @1531561
     /* 1531561 */   GIM_Try, /*On fail goto*//*Label 21297*/ GIMT_Encode4(1531643), // Rule ID 18486 //
     /* 1531566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1531577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1531580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1531583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1531586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531605 */     // MIs[0] round
     /* 1531605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531608 */     // MIs[0] policy
     /* 1531608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531618 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1531621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531642 */     // GIR_Coverage, 18486,
     /* 1531642 */     GIR_EraseRootFromParent_Done,
     /* 1531643 */   // Label 21297: @1531643
     /* 1531643 */   GIM_Try, /*On fail goto*//*Label 21298*/ GIMT_Encode4(1531725), // Rule ID 18487 //
     /* 1531648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1531659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1531662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1531665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1531668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531687 */     // MIs[0] round
     /* 1531687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531690 */     // MIs[0] policy
     /* 1531690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531700 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1531703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531724 */     // GIR_Coverage, 18487,
     /* 1531724 */     GIR_EraseRootFromParent_Done,
     /* 1531725 */   // Label 21298: @1531725
     /* 1531725 */   GIM_Try, /*On fail goto*//*Label 21299*/ GIMT_Encode4(1531807), // Rule ID 18490 //
     /* 1531730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1531741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1531744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1531747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1531750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531769 */     // MIs[0] round
     /* 1531769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531772 */     // MIs[0] policy
     /* 1531772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531782 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1531785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531806 */     // GIR_Coverage, 18490,
     /* 1531806 */     GIR_EraseRootFromParent_Done,
     /* 1531807 */   // Label 21299: @1531807
     /* 1531807 */   GIM_Try, /*On fail goto*//*Label 21300*/ GIMT_Encode4(1531889), // Rule ID 18491 //
     /* 1531812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1531823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1531826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1531829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1531832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531851 */     // MIs[0] round
     /* 1531851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531854 */     // MIs[0] policy
     /* 1531854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531864 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1531867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531888 */     // GIR_Coverage, 18491,
     /* 1531888 */     GIR_EraseRootFromParent_Done,
     /* 1531889 */   // Label 21300: @1531889
     /* 1531889 */   GIM_Try, /*On fail goto*//*Label 21301*/ GIMT_Encode4(1531971), // Rule ID 18494 //
     /* 1531894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1531905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1531908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1531911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1531914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531933 */     // MIs[0] round
     /* 1531933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531936 */     // MIs[0] policy
     /* 1531936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531946 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1531949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531970 */     // GIR_Coverage, 18494,
     /* 1531970 */     GIR_EraseRootFromParent_Done,
     /* 1531971 */   // Label 21301: @1531971
     /* 1531971 */   GIM_Try, /*On fail goto*//*Label 21302*/ GIMT_Encode4(1532053), // Rule ID 18495 //
     /* 1531976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1531984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1531987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1531990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1531993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1531996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532015 */     // MIs[0] round
     /* 1532015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532018 */     // MIs[0] policy
     /* 1532018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532028 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1532031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532052 */     // GIR_Coverage, 18495,
     /* 1532052 */     GIR_EraseRootFromParent_Done,
     /* 1532053 */   // Label 21302: @1532053
     /* 1532053 */   GIM_Try, /*On fail goto*//*Label 21303*/ GIMT_Encode4(1532135), // Rule ID 18498 //
     /* 1532058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532097 */     // MIs[0] round
     /* 1532097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532100 */     // MIs[0] policy
     /* 1532100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532110 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1532113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532134 */     // GIR_Coverage, 18498,
     /* 1532134 */     GIR_EraseRootFromParent_Done,
     /* 1532135 */   // Label 21303: @1532135
     /* 1532135 */   GIM_Try, /*On fail goto*//*Label 21304*/ GIMT_Encode4(1532217), // Rule ID 18499 //
     /* 1532140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1532157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532179 */     // MIs[0] round
     /* 1532179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532182 */     // MIs[0] policy
     /* 1532182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532192 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1532195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532216 */     // GIR_Coverage, 18499,
     /* 1532216 */     GIR_EraseRootFromParent_Done,
     /* 1532217 */   // Label 21304: @1532217
     /* 1532217 */   GIM_Try, /*On fail goto*//*Label 21305*/ GIMT_Encode4(1532299), // Rule ID 18502 //
     /* 1532222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1532239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532261 */     // MIs[0] round
     /* 1532261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532264 */     // MIs[0] policy
     /* 1532264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532274 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1532277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532298 */     // GIR_Coverage, 18502,
     /* 1532298 */     GIR_EraseRootFromParent_Done,
     /* 1532299 */   // Label 21305: @1532299
     /* 1532299 */   GIM_Try, /*On fail goto*//*Label 21306*/ GIMT_Encode4(1532381), // Rule ID 18503 //
     /* 1532304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1532315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1532318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1532321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1532324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532343 */     // MIs[0] round
     /* 1532343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532346 */     // MIs[0] policy
     /* 1532346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532356 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1532359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532380 */     // GIR_Coverage, 18503,
     /* 1532380 */     GIR_EraseRootFromParent_Done,
     /* 1532381 */   // Label 21306: @1532381
     /* 1532381 */   GIM_Try, /*On fail goto*//*Label 21307*/ GIMT_Encode4(1532463), // Rule ID 18506 //
     /* 1532386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532425 */     // MIs[0] round
     /* 1532425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532428 */     // MIs[0] policy
     /* 1532428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532438 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1532441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532462 */     // GIR_Coverage, 18506,
     /* 1532462 */     GIR_EraseRootFromParent_Done,
     /* 1532463 */   // Label 21307: @1532463
     /* 1532463 */   GIM_Try, /*On fail goto*//*Label 21308*/ GIMT_Encode4(1532545), // Rule ID 18507 //
     /* 1532468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1532479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1532482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1532485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1532488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532507 */     // MIs[0] round
     /* 1532507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532510 */     // MIs[0] policy
     /* 1532510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532520 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1532523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532544 */     // GIR_Coverage, 18507,
     /* 1532544 */     GIR_EraseRootFromParent_Done,
     /* 1532545 */   // Label 21308: @1532545
     /* 1532545 */   GIM_Try, /*On fail goto*//*Label 21309*/ GIMT_Encode4(1532627), // Rule ID 18510 //
     /* 1532550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1532561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1532564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1532567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1532570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532589 */     // MIs[0] round
     /* 1532589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532592 */     // MIs[0] policy
     /* 1532592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532602 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1532605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532626 */     // GIR_Coverage, 18510,
     /* 1532626 */     GIR_EraseRootFromParent_Done,
     /* 1532627 */   // Label 21309: @1532627
     /* 1532627 */   GIM_Try, /*On fail goto*//*Label 21310*/ GIMT_Encode4(1532709), // Rule ID 18511 //
     /* 1532632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1532643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1532646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1532649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1532652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532671 */     // MIs[0] round
     /* 1532671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532674 */     // MIs[0] policy
     /* 1532674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532684 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1532687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532708 */     // GIR_Coverage, 18511,
     /* 1532708 */     GIR_EraseRootFromParent_Done,
     /* 1532709 */   // Label 21310: @1532709
     /* 1532709 */   GIM_Try, /*On fail goto*//*Label 21311*/ GIMT_Encode4(1532791), // Rule ID 18514 //
     /* 1532714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1532725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1532728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1532731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1532734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532753 */     // MIs[0] round
     /* 1532753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532756 */     // MIs[0] policy
     /* 1532756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532766 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1532769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532790 */     // GIR_Coverage, 18514,
     /* 1532790 */     GIR_EraseRootFromParent_Done,
     /* 1532791 */   // Label 21311: @1532791
     /* 1532791 */   GIM_Try, /*On fail goto*//*Label 21312*/ GIMT_Encode4(1532873), // Rule ID 18515 //
     /* 1532796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1532807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1532810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1532813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1532816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1532835 */     // MIs[0] round
     /* 1532835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532838 */     // MIs[0] policy
     /* 1532838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532848 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1532851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532872 */     // GIR_Coverage, 18515,
     /* 1532872 */     GIR_EraseRootFromParent_Done,
     /* 1532873 */   // Label 21312: @1532873
     /* 1532873 */   GIM_Try, /*On fail goto*//*Label 21313*/ GIMT_Encode4(1532955), // Rule ID 18518 //
     /* 1532878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1532881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1532889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1532892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1532895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1532898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532917 */     // MIs[0] round
     /* 1532917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532920 */     // MIs[0] policy
     /* 1532920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532930 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1532933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532954 */     // GIR_Coverage, 18518,
     /* 1532954 */     GIR_EraseRootFromParent_Done,
     /* 1532955 */   // Label 21313: @1532955
     /* 1532955 */   GIM_Try, /*On fail goto*//*Label 21314*/ GIMT_Encode4(1533037), // Rule ID 18519 //
     /* 1532960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1532963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1532968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1532971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1532974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1532977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1532980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532999 */     // MIs[0] round
     /* 1532999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533002 */     // MIs[0] policy
     /* 1533002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533012 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1533015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533036 */     // GIR_Coverage, 18519,
     /* 1533036 */     GIR_EraseRootFromParent_Done,
     /* 1533037 */   // Label 21314: @1533037
     /* 1533037 */   GIM_Try, /*On fail goto*//*Label 21315*/ GIMT_Encode4(1533119), // Rule ID 18522 //
     /* 1533042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1533059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533081 */     // MIs[0] round
     /* 1533081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533084 */     // MIs[0] policy
     /* 1533084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533094 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1533097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533118 */     // GIR_Coverage, 18522,
     /* 1533118 */     GIR_EraseRootFromParent_Done,
     /* 1533119 */   // Label 21315: @1533119
     /* 1533119 */   GIM_Try, /*On fail goto*//*Label 21316*/ GIMT_Encode4(1533201), // Rule ID 18523 //
     /* 1533124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1533141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533163 */     // MIs[0] round
     /* 1533163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533166 */     // MIs[0] policy
     /* 1533166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533176 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1533179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533200 */     // GIR_Coverage, 18523,
     /* 1533200 */     GIR_EraseRootFromParent_Done,
     /* 1533201 */   // Label 21316: @1533201
     /* 1533201 */   GIM_Try, /*On fail goto*//*Label 21317*/ GIMT_Encode4(1533283), // Rule ID 18526 //
     /* 1533206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1533223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533245 */     // MIs[0] round
     /* 1533245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533248 */     // MIs[0] policy
     /* 1533248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533258 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1533261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533282 */     // GIR_Coverage, 18526,
     /* 1533282 */     GIR_EraseRootFromParent_Done,
     /* 1533283 */   // Label 21317: @1533283
     /* 1533283 */   GIM_Try, /*On fail goto*//*Label 21318*/ GIMT_Encode4(1533365), // Rule ID 18527 //
     /* 1533288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1533299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1533302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1533305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1533308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533327 */     // MIs[0] round
     /* 1533327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533330 */     // MIs[0] policy
     /* 1533330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533340 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1533343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533364 */     // GIR_Coverage, 18527,
     /* 1533364 */     GIR_EraseRootFromParent_Done,
     /* 1533365 */   // Label 21318: @1533365
     /* 1533365 */   GIM_Try, /*On fail goto*//*Label 21319*/ GIMT_Encode4(1533447), // Rule ID 18530 //
     /* 1533370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533409 */     // MIs[0] round
     /* 1533409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533412 */     // MIs[0] policy
     /* 1533412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533422 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1533425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533446 */     // GIR_Coverage, 18530,
     /* 1533446 */     GIR_EraseRootFromParent_Done,
     /* 1533447 */   // Label 21319: @1533447
     /* 1533447 */   GIM_Try, /*On fail goto*//*Label 21320*/ GIMT_Encode4(1533529), // Rule ID 18531 //
     /* 1533452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1533463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1533466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1533472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533491 */     // MIs[0] round
     /* 1533491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533494 */     // MIs[0] policy
     /* 1533494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533504 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1533507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533528 */     // GIR_Coverage, 18531,
     /* 1533528 */     GIR_EraseRootFromParent_Done,
     /* 1533529 */   // Label 21320: @1533529
     /* 1533529 */   GIM_Try, /*On fail goto*//*Label 21321*/ GIMT_Encode4(1533611), // Rule ID 18534 //
     /* 1533534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1533545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1533548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1533554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533573 */     // MIs[0] round
     /* 1533573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533576 */     // MIs[0] policy
     /* 1533576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533586 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1533589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533610 */     // GIR_Coverage, 18534,
     /* 1533610 */     GIR_EraseRootFromParent_Done,
     /* 1533611 */   // Label 21321: @1533611
     /* 1533611 */   GIM_Try, /*On fail goto*//*Label 21322*/ GIMT_Encode4(1533693), // Rule ID 18535 //
     /* 1533616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1533627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1533630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1533636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533655 */     // MIs[0] round
     /* 1533655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533658 */     // MIs[0] policy
     /* 1533658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533668 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1533671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533692 */     // GIR_Coverage, 18535,
     /* 1533692 */     GIR_EraseRootFromParent_Done,
     /* 1533693 */   // Label 21322: @1533693
     /* 1533693 */   GIM_Try, /*On fail goto*//*Label 21323*/ GIMT_Encode4(1533775), // Rule ID 18538 //
     /* 1533698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1533709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1533712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1533718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533737 */     // MIs[0] round
     /* 1533737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533740 */     // MIs[0] policy
     /* 1533740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533750 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1533753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533774 */     // GIR_Coverage, 18538,
     /* 1533774 */     GIR_EraseRootFromParent_Done,
     /* 1533775 */   // Label 21323: @1533775
     /* 1533775 */   GIM_Try, /*On fail goto*//*Label 21324*/ GIMT_Encode4(1533857), // Rule ID 18539 //
     /* 1533780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1533791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1533794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1533800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533819 */     // MIs[0] round
     /* 1533819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533822 */     // MIs[0] policy
     /* 1533822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533832 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1533835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533856 */     // GIR_Coverage, 18539,
     /* 1533856 */     GIR_EraseRootFromParent_Done,
     /* 1533857 */   // Label 21324: @1533857
     /* 1533857 */   GIM_Try, /*On fail goto*//*Label 21325*/ GIMT_Encode4(1533939), // Rule ID 18542 //
     /* 1533862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1533873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1533876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1533882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533901 */     // MIs[0] round
     /* 1533901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533904 */     // MIs[0] policy
     /* 1533904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533914 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1533917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533938 */     // GIR_Coverage, 18542,
     /* 1533938 */     GIR_EraseRootFromParent_Done,
     /* 1533939 */   // Label 21325: @1533939
     /* 1533939 */   GIM_Try, /*On fail goto*//*Label 21326*/ GIMT_Encode4(1534021), // Rule ID 18543 //
     /* 1533944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1533952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1533955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1533958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1533964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1533983 */     // MIs[0] round
     /* 1533983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533986 */     // MIs[0] policy
     /* 1533986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533996 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1533999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534020 */     // GIR_Coverage, 18543,
     /* 1534020 */     GIR_EraseRootFromParent_Done,
     /* 1534021 */   // Label 21326: @1534021
     /* 1534021 */   GIM_Try, /*On fail goto*//*Label 21327*/ GIMT_Encode4(1534103), // Rule ID 18546 //
     /* 1534026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534065 */     // MIs[0] round
     /* 1534065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534068 */     // MIs[0] policy
     /* 1534068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534078 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1534081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534102 */     // GIR_Coverage, 18546,
     /* 1534102 */     GIR_EraseRootFromParent_Done,
     /* 1534103 */   // Label 21327: @1534103
     /* 1534103 */   GIM_Try, /*On fail goto*//*Label 21328*/ GIMT_Encode4(1534185), // Rule ID 18547 //
     /* 1534108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1534128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534147 */     // MIs[0] round
     /* 1534147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534150 */     // MIs[0] policy
     /* 1534150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534160 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1534163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534184 */     // GIR_Coverage, 18547,
     /* 1534184 */     GIR_EraseRootFromParent_Done,
     /* 1534185 */   // Label 21328: @1534185
     /* 1534185 */   GIM_Try, /*On fail goto*//*Label 21329*/ GIMT_Encode4(1534267), // Rule ID 18550 //
     /* 1534190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1534193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534229 */     // MIs[0] round
     /* 1534229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534232 */     // MIs[0] policy
     /* 1534232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534242 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1534245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534266 */     // GIR_Coverage, 18550,
     /* 1534266 */     GIR_EraseRootFromParent_Done,
     /* 1534267 */   // Label 21329: @1534267
     /* 1534267 */   GIM_Try, /*On fail goto*//*Label 21330*/ GIMT_Encode4(1534349), // Rule ID 18551 //
     /* 1534272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1534275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1534292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534311 */     // MIs[0] round
     /* 1534311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534314 */     // MIs[0] policy
     /* 1534314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534324 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1534327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534348 */     // GIR_Coverage, 18551,
     /* 1534348 */     GIR_EraseRootFromParent_Done,
     /* 1534349 */   // Label 21330: @1534349
     /* 1534349 */   GIM_Try, /*On fail goto*//*Label 21331*/ GIMT_Encode4(1534431), // Rule ID 18554 //
     /* 1534354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534393 */     // MIs[0] round
     /* 1534393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534396 */     // MIs[0] policy
     /* 1534396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534406 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1534409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534430 */     // GIR_Coverage, 18554,
     /* 1534430 */     GIR_EraseRootFromParent_Done,
     /* 1534431 */   // Label 21331: @1534431
     /* 1534431 */   GIM_Try, /*On fail goto*//*Label 21332*/ GIMT_Encode4(1534513), // Rule ID 18555 //
     /* 1534436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1534447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1534450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534475 */     // MIs[0] round
     /* 1534475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534478 */     // MIs[0] policy
     /* 1534478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534488 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1534491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534512 */     // GIR_Coverage, 18555,
     /* 1534512 */     GIR_EraseRootFromParent_Done,
     /* 1534513 */   // Label 21332: @1534513
     /* 1534513 */   GIM_Try, /*On fail goto*//*Label 21333*/ GIMT_Encode4(1534595), // Rule ID 18558 //
     /* 1534518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1534529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1534532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1534538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534557 */     // MIs[0] round
     /* 1534557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534560 */     // MIs[0] policy
     /* 1534560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534570 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1534573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534594 */     // GIR_Coverage, 18558,
     /* 1534594 */     GIR_EraseRootFromParent_Done,
     /* 1534595 */   // Label 21333: @1534595
     /* 1534595 */   GIM_Try, /*On fail goto*//*Label 21334*/ GIMT_Encode4(1534677), // Rule ID 18559 //
     /* 1534600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1534611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1534614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1534620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534639 */     // MIs[0] round
     /* 1534639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534642 */     // MIs[0] policy
     /* 1534642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534652 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1534655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534676 */     // GIR_Coverage, 18559,
     /* 1534676 */     GIR_EraseRootFromParent_Done,
     /* 1534677 */   // Label 21334: @1534677
     /* 1534677 */   GIM_Try, /*On fail goto*//*Label 21335*/ GIMT_Encode4(1534759), // Rule ID 18562 //
     /* 1534682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1534685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1534693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1534696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1534702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534721 */     // MIs[0] round
     /* 1534721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534724 */     // MIs[0] policy
     /* 1534724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534734 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1534737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534758 */     // GIR_Coverage, 18562,
     /* 1534758 */     GIR_EraseRootFromParent_Done,
     /* 1534759 */   // Label 21335: @1534759
     /* 1534759 */   GIM_Try, /*On fail goto*//*Label 21336*/ GIMT_Encode4(1534841), // Rule ID 18563 //
     /* 1534764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1534767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1534775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1534778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1534781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1534784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1534799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534803 */     // MIs[0] round
     /* 1534803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534806 */     // MIs[0] policy
     /* 1534806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534816 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1534819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534840 */     // GIR_Coverage, 18563,
     /* 1534840 */     GIR_EraseRootFromParent_Done,
     /* 1534841 */   // Label 21336: @1534841
     /* 1534841 */   GIM_Try, /*On fail goto*//*Label 21337*/ GIMT_Encode4(1534923), // Rule ID 18566 //
     /* 1534846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1534849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1534857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1534860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1534866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534885 */     // MIs[0] round
     /* 1534885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534888 */     // MIs[0] policy
     /* 1534888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534898 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1534901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1534919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534922 */     // GIR_Coverage, 18566,
     /* 1534922 */     GIR_EraseRootFromParent_Done,
     /* 1534923 */   // Label 21337: @1534923
     /* 1534923 */   GIM_Try, /*On fail goto*//*Label 21338*/ GIMT_Encode4(1535005), // Rule ID 18567 //
     /* 1534928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1534931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1534936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1534939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1534942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1534945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1534948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1534963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534967 */     // MIs[0] round
     /* 1534967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534970 */     // MIs[0] policy
     /* 1534970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534980 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1534983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535004 */     // GIR_Coverage, 18567,
     /* 1535004 */     GIR_EraseRootFromParent_Done,
     /* 1535005 */   // Label 21338: @1535005
     /* 1535005 */   GIM_Try, /*On fail goto*//*Label 21339*/ GIMT_Encode4(1535087), // Rule ID 18570 //
     /* 1535010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535049 */     // MIs[0] round
     /* 1535049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535052 */     // MIs[0] policy
     /* 1535052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535062 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1535065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535086 */     // GIR_Coverage, 18570,
     /* 1535086 */     GIR_EraseRootFromParent_Done,
     /* 1535087 */   // Label 21339: @1535087
     /* 1535087 */   GIM_Try, /*On fail goto*//*Label 21340*/ GIMT_Encode4(1535169), // Rule ID 18571 //
     /* 1535092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1535103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1535106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535131 */     // MIs[0] round
     /* 1535131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535134 */     // MIs[0] policy
     /* 1535134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535144 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1535147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535168 */     // GIR_Coverage, 18571,
     /* 1535168 */     GIR_EraseRootFromParent_Done,
     /* 1535169 */   // Label 21340: @1535169
     /* 1535169 */   GIM_Try, /*On fail goto*//*Label 21341*/ GIMT_Encode4(1535251), // Rule ID 18574 //
     /* 1535174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1535177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535213 */     // MIs[0] round
     /* 1535213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535216 */     // MIs[0] policy
     /* 1535216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535226 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1535229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535250 */     // GIR_Coverage, 18574,
     /* 1535250 */     GIR_EraseRootFromParent_Done,
     /* 1535251 */   // Label 21341: @1535251
     /* 1535251 */   GIM_Try, /*On fail goto*//*Label 21342*/ GIMT_Encode4(1535333), // Rule ID 18575 //
     /* 1535256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1535259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1535267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1535270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1535273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1535276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1535291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535295 */     // MIs[0] round
     /* 1535295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535298 */     // MIs[0] policy
     /* 1535298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535308 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1535311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535332 */     // GIR_Coverage, 18575,
     /* 1535332 */     GIR_EraseRootFromParent_Done,
     /* 1535333 */   // Label 21342: @1535333
     /* 1535333 */   GIM_Try, /*On fail goto*//*Label 21343*/ GIMT_Encode4(1535415), // Rule ID 18578 //
     /* 1535338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535377 */     // MIs[0] round
     /* 1535377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535380 */     // MIs[0] policy
     /* 1535380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535390 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1535393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535414 */     // GIR_Coverage, 18578,
     /* 1535414 */     GIR_EraseRootFromParent_Done,
     /* 1535415 */   // Label 21343: @1535415
     /* 1535415 */   GIM_Try, /*On fail goto*//*Label 21344*/ GIMT_Encode4(1535497), // Rule ID 18579 //
     /* 1535420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1535440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535459 */     // MIs[0] round
     /* 1535459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535462 */     // MIs[0] policy
     /* 1535462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535472 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1535475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535496 */     // GIR_Coverage, 18579,
     /* 1535496 */     GIR_EraseRootFromParent_Done,
     /* 1535497 */   // Label 21344: @1535497
     /* 1535497 */   GIM_Try, /*On fail goto*//*Label 21345*/ GIMT_Encode4(1535579), // Rule ID 18582 //
     /* 1535502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1535522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535541 */     // MIs[0] round
     /* 1535541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535544 */     // MIs[0] policy
     /* 1535544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535554 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1535557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535578 */     // GIR_Coverage, 18582,
     /* 1535578 */     GIR_EraseRootFromParent_Done,
     /* 1535579 */   // Label 21345: @1535579
     /* 1535579 */   GIM_Try, /*On fail goto*//*Label 21346*/ GIMT_Encode4(1535661), // Rule ID 18583 //
     /* 1535584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1535604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535623 */     // MIs[0] round
     /* 1535623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535626 */     // MIs[0] policy
     /* 1535626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535636 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1535639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535660 */     // GIR_Coverage, 18583,
     /* 1535660 */     GIR_EraseRootFromParent_Done,
     /* 1535661 */   // Label 21346: @1535661
     /* 1535661 */   GIM_Try, /*On fail goto*//*Label 21347*/ GIMT_Encode4(1535743), // Rule ID 18586 //
     /* 1535666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1535669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1535677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1535680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1535686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535705 */     // MIs[0] round
     /* 1535705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535708 */     // MIs[0] policy
     /* 1535708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535718 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1535721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535742 */     // GIR_Coverage, 18586,
     /* 1535742 */     GIR_EraseRootFromParent_Done,
     /* 1535743 */   // Label 21347: @1535743
     /* 1535743 */   GIM_Try, /*On fail goto*//*Label 21348*/ GIMT_Encode4(1535825), // Rule ID 18587 //
     /* 1535748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1535751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1535756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1535759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1535762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1535765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1535768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1535783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535787 */     // MIs[0] round
     /* 1535787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535790 */     // MIs[0] policy
     /* 1535790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535800 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1535803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1535821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535824 */     // GIR_Coverage, 18587,
     /* 1535824 */     GIR_EraseRootFromParent_Done,
     /* 1535825 */   // Label 21348: @1535825
     /* 1535825 */   GIM_Try, /*On fail goto*//*Label 21349*/ GIMT_Encode4(1535907), // Rule ID 18590 //
     /* 1535830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1535833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1535841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1535844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1535847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1535850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535869 */     // MIs[0] round
     /* 1535869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535872 */     // MIs[0] policy
     /* 1535872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535882 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1535885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535906 */     // GIR_Coverage, 18590,
     /* 1535906 */     GIR_EraseRootFromParent_Done,
     /* 1535907 */   // Label 21349: @1535907
     /* 1535907 */   GIM_Try, /*On fail goto*//*Label 21350*/ GIMT_Encode4(1535989), // Rule ID 18591 //
     /* 1535912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1535915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1535920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1535923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1535926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1535929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1535932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535951 */     // MIs[0] round
     /* 1535951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535954 */     // MIs[0] policy
     /* 1535954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535964 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1535967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535988 */     // GIR_Coverage, 18591,
     /* 1535988 */     GIR_EraseRootFromParent_Done,
     /* 1535989 */   // Label 21350: @1535989
     /* 1535989 */   GIM_Try, /*On fail goto*//*Label 21351*/ GIMT_Encode4(1536071), // Rule ID 18594 //
     /* 1535994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1535997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1536011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536033 */     // MIs[0] round
     /* 1536033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536036 */     // MIs[0] policy
     /* 1536036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536046 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1536049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536070 */     // GIR_Coverage, 18594,
     /* 1536070 */     GIR_EraseRootFromParent_Done,
     /* 1536071 */   // Label 21351: @1536071
     /* 1536071 */   GIM_Try, /*On fail goto*//*Label 21352*/ GIMT_Encode4(1536153), // Rule ID 18595 //
     /* 1536076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1536087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1536090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1536093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1536096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536115 */     // MIs[0] round
     /* 1536115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536118 */     // MIs[0] policy
     /* 1536118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536128 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1536131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536152 */     // GIR_Coverage, 18595,
     /* 1536152 */     GIR_EraseRootFromParent_Done,
     /* 1536153 */   // Label 21352: @1536153
     /* 1536153 */   GIM_Try, /*On fail goto*//*Label 21353*/ GIMT_Encode4(1536235), // Rule ID 18598 //
     /* 1536158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1536175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536197 */     // MIs[0] round
     /* 1536197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536200 */     // MIs[0] policy
     /* 1536200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536210 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1536213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536234 */     // GIR_Coverage, 18598,
     /* 1536234 */     GIR_EraseRootFromParent_Done,
     /* 1536235 */   // Label 21353: @1536235
     /* 1536235 */   GIM_Try, /*On fail goto*//*Label 21354*/ GIMT_Encode4(1536317), // Rule ID 18599 //
     /* 1536240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1536251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1536254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1536257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536279 */     // MIs[0] round
     /* 1536279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536282 */     // MIs[0] policy
     /* 1536282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536292 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1536295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536316 */     // GIR_Coverage, 18599,
     /* 1536316 */     GIR_EraseRootFromParent_Done,
     /* 1536317 */   // Label 21354: @1536317
     /* 1536317 */   GIM_Try, /*On fail goto*//*Label 21355*/ GIMT_Encode4(1536399), // Rule ID 18602 //
     /* 1536322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1536339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536361 */     // MIs[0] round
     /* 1536361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536364 */     // MIs[0] policy
     /* 1536364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536374 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1536377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536398 */     // GIR_Coverage, 18602,
     /* 1536398 */     GIR_EraseRootFromParent_Done,
     /* 1536399 */   // Label 21355: @1536399
     /* 1536399 */   GIM_Try, /*On fail goto*//*Label 21356*/ GIMT_Encode4(1536481), // Rule ID 18603 //
     /* 1536404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1536415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1536418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1536421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536443 */     // MIs[0] round
     /* 1536443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536446 */     // MIs[0] policy
     /* 1536446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536456 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1536459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536480 */     // GIR_Coverage, 18603,
     /* 1536480 */     GIR_EraseRootFromParent_Done,
     /* 1536481 */   // Label 21356: @1536481
     /* 1536481 */   GIM_Try, /*On fail goto*//*Label 21357*/ GIMT_Encode4(1536563), // Rule ID 18606 //
     /* 1536486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1536489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1536497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1536500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1536503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536525 */     // MIs[0] round
     /* 1536525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536528 */     // MIs[0] policy
     /* 1536528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536538 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1536541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536562 */     // GIR_Coverage, 18606,
     /* 1536562 */     GIR_EraseRootFromParent_Done,
     /* 1536563 */   // Label 21357: @1536563
     /* 1536563 */   GIM_Try, /*On fail goto*//*Label 21358*/ GIMT_Encode4(1536645), // Rule ID 18607 //
     /* 1536568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1536571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1536579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1536582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1536585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536607 */     // MIs[0] round
     /* 1536607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536610 */     // MIs[0] policy
     /* 1536610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536620 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1536623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536644 */     // GIR_Coverage, 18607,
     /* 1536644 */     GIR_EraseRootFromParent_Done,
     /* 1536645 */   // Label 21358: @1536645
     /* 1536645 */   GIM_Try, /*On fail goto*//*Label 21359*/ GIMT_Encode4(1536727), // Rule ID 18610 //
     /* 1536650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1536653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1536667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1536670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536689 */     // MIs[0] round
     /* 1536689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536692 */     // MIs[0] policy
     /* 1536692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536702 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1536705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536726 */     // GIR_Coverage, 18610,
     /* 1536726 */     GIR_EraseRootFromParent_Done,
     /* 1536727 */   // Label 21359: @1536727
     /* 1536727 */   GIM_Try, /*On fail goto*//*Label 21360*/ GIMT_Encode4(1536809), // Rule ID 18611 //
     /* 1536732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1536735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1536749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1536752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536771 */     // MIs[0] round
     /* 1536771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536774 */     // MIs[0] policy
     /* 1536774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536784 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1536787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1536805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536808 */     // GIR_Coverage, 18611,
     /* 1536808 */     GIR_EraseRootFromParent_Done,
     /* 1536809 */   // Label 21360: @1536809
     /* 1536809 */   GIM_Try, /*On fail goto*//*Label 21361*/ GIMT_Encode4(1536891), // Rule ID 18614 //
     /* 1536814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1536825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1536828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1536831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1536834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536853 */     // MIs[0] round
     /* 1536853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536856 */     // MIs[0] policy
     /* 1536856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536866 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1536869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536890 */     // GIR_Coverage, 18614,
     /* 1536890 */     GIR_EraseRootFromParent_Done,
     /* 1536891 */   // Label 21361: @1536891
     /* 1536891 */   GIM_Try, /*On fail goto*//*Label 21362*/ GIMT_Encode4(1536973), // Rule ID 18615 //
     /* 1536896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1536899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1536907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1536910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1536913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1536916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536935 */     // MIs[0] round
     /* 1536935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536938 */     // MIs[0] policy
     /* 1536938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536948 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1536951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536972 */     // GIR_Coverage, 18615,
     /* 1536972 */     GIR_EraseRootFromParent_Done,
     /* 1536973 */   // Label 21362: @1536973
     /* 1536973 */   GIM_Try, /*On fail goto*//*Label 21363*/ GIMT_Encode4(1537055), // Rule ID 18618 //
     /* 1536978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1536981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1536986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1536989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1536992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1536995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1536998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537017 */     // MIs[0] round
     /* 1537017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537020 */     // MIs[0] policy
     /* 1537020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537030 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1537033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537054 */     // GIR_Coverage, 18618,
     /* 1537054 */     GIR_EraseRootFromParent_Done,
     /* 1537055 */   // Label 21363: @1537055
     /* 1537055 */   GIM_Try, /*On fail goto*//*Label 21364*/ GIMT_Encode4(1537137), // Rule ID 18619 //
     /* 1537060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1537071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1537074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1537077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537099 */     // MIs[0] round
     /* 1537099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537102 */     // MIs[0] policy
     /* 1537102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537112 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1537115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537136 */     // GIR_Coverage, 18619,
     /* 1537136 */     GIR_EraseRootFromParent_Done,
     /* 1537137 */   // Label 21364: @1537137
     /* 1537137 */   GIM_Try, /*On fail goto*//*Label 21365*/ GIMT_Encode4(1537219), // Rule ID 18622 //
     /* 1537142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1537145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1537159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537181 */     // MIs[0] round
     /* 1537181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537184 */     // MIs[0] policy
     /* 1537184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537194 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1537197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537218 */     // GIR_Coverage, 18622,
     /* 1537218 */     GIR_EraseRootFromParent_Done,
     /* 1537219 */   // Label 21365: @1537219
     /* 1537219 */   GIM_Try, /*On fail goto*//*Label 21366*/ GIMT_Encode4(1537301), // Rule ID 18623 //
     /* 1537224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1537227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1537235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1537238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1537241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1537244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537263 */     // MIs[0] round
     /* 1537263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537266 */     // MIs[0] policy
     /* 1537266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537276 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1537279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537300 */     // GIR_Coverage, 18623,
     /* 1537300 */     GIR_EraseRootFromParent_Done,
     /* 1537301 */   // Label 21366: @1537301
     /* 1537301 */   GIM_Try, /*On fail goto*//*Label 21367*/ GIMT_Encode4(1537383), // Rule ID 18626 //
     /* 1537306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1537323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537345 */     // MIs[0] round
     /* 1537345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537348 */     // MIs[0] policy
     /* 1537348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537358 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1537361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537382 */     // GIR_Coverage, 18626,
     /* 1537382 */     GIR_EraseRootFromParent_Done,
     /* 1537383 */   // Label 21367: @1537383
     /* 1537383 */   GIM_Try, /*On fail goto*//*Label 21368*/ GIMT_Encode4(1537465), // Rule ID 18627 //
     /* 1537388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1537405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1537408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537427 */     // MIs[0] round
     /* 1537427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537430 */     // MIs[0] policy
     /* 1537430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537440 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1537443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537464 */     // GIR_Coverage, 18627,
     /* 1537464 */     GIR_EraseRootFromParent_Done,
     /* 1537465 */   // Label 21368: @1537465
     /* 1537465 */   GIM_Try, /*On fail goto*//*Label 21369*/ GIMT_Encode4(1537547), // Rule ID 18630 //
     /* 1537470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1537487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1537490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537509 */     // MIs[0] round
     /* 1537509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537512 */     // MIs[0] policy
     /* 1537512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537522 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1537525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537546 */     // GIR_Coverage, 18630,
     /* 1537546 */     GIR_EraseRootFromParent_Done,
     /* 1537547 */   // Label 21369: @1537547
     /* 1537547 */   GIM_Try, /*On fail goto*//*Label 21370*/ GIMT_Encode4(1537629), // Rule ID 18631 //
     /* 1537552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1537569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1537572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537591 */     // MIs[0] round
     /* 1537591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537594 */     // MIs[0] policy
     /* 1537594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537604 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1537607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537628 */     // GIR_Coverage, 18631,
     /* 1537628 */     GIR_EraseRootFromParent_Done,
     /* 1537629 */   // Label 21370: @1537629
     /* 1537629 */   GIM_Try, /*On fail goto*//*Label 21371*/ GIMT_Encode4(1537711), // Rule ID 18634 //
     /* 1537634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1537637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1537645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1537648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1537651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1537654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537673 */     // MIs[0] round
     /* 1537673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537676 */     // MIs[0] policy
     /* 1537676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537686 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1537689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537710 */     // GIR_Coverage, 18634,
     /* 1537710 */     GIR_EraseRootFromParent_Done,
     /* 1537711 */   // Label 21371: @1537711
     /* 1537711 */   GIM_Try, /*On fail goto*//*Label 21372*/ GIMT_Encode4(1537793), // Rule ID 18635 //
     /* 1537716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1537719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1537727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1537730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1537733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1537736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537755 */     // MIs[0] round
     /* 1537755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537758 */     // MIs[0] policy
     /* 1537758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537768 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1537771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537792 */     // GIR_Coverage, 18635,
     /* 1537792 */     GIR_EraseRootFromParent_Done,
     /* 1537793 */   // Label 21372: @1537793
     /* 1537793 */   GIM_Try, /*On fail goto*//*Label 21373*/ GIMT_Encode4(1537875), // Rule ID 18638 //
     /* 1537798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1537801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1537809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1537812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1537815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1537818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537837 */     // MIs[0] round
     /* 1537837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537840 */     // MIs[0] policy
     /* 1537840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537850 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1537853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537874 */     // GIR_Coverage, 18638,
     /* 1537874 */     GIR_EraseRootFromParent_Done,
     /* 1537875 */   // Label 21373: @1537875
     /* 1537875 */   GIM_Try, /*On fail goto*//*Label 21374*/ GIMT_Encode4(1537957), // Rule ID 18639 //
     /* 1537880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1537883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1537891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1537894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1537897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1537900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537919 */     // MIs[0] round
     /* 1537919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537922 */     // MIs[0] policy
     /* 1537922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537932 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1537935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1537953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537956 */     // GIR_Coverage, 18639,
     /* 1537956 */     GIR_EraseRootFromParent_Done,
     /* 1537957 */   // Label 21374: @1537957
     /* 1537957 */   GIM_Try, /*On fail goto*//*Label 21375*/ GIMT_Encode4(1538039), // Rule ID 18642 //
     /* 1537962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1537965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1537970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1537973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1537976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1537979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1537982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538001 */     // MIs[0] round
     /* 1538001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538004 */     // MIs[0] policy
     /* 1538004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538014 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1538017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538038 */     // GIR_Coverage, 18642,
     /* 1538038 */     GIR_EraseRootFromParent_Done,
     /* 1538039 */   // Label 21375: @1538039
     /* 1538039 */   GIM_Try, /*On fail goto*//*Label 21376*/ GIMT_Encode4(1538121), // Rule ID 18643 //
     /* 1538044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1538061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1538064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538083 */     // MIs[0] round
     /* 1538083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538086 */     // MIs[0] policy
     /* 1538086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538096 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1538099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538120 */     // GIR_Coverage, 18643,
     /* 1538120 */     GIR_EraseRootFromParent_Done,
     /* 1538121 */   // Label 21376: @1538121
     /* 1538121 */   GIM_Try, /*On fail goto*//*Label 21377*/ GIMT_Encode4(1538203), // Rule ID 18646 //
     /* 1538126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1538129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1538143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538165 */     // MIs[0] round
     /* 1538165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538168 */     // MIs[0] policy
     /* 1538168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538178 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1538181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538202 */     // GIR_Coverage, 18646,
     /* 1538202 */     GIR_EraseRootFromParent_Done,
     /* 1538203 */   // Label 21377: @1538203
     /* 1538203 */   GIM_Try, /*On fail goto*//*Label 21378*/ GIMT_Encode4(1538285), // Rule ID 18647 //
     /* 1538208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1538211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1538225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1538228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538247 */     // MIs[0] round
     /* 1538247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538250 */     // MIs[0] policy
     /* 1538250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538260 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1538263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1538281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538284 */     // GIR_Coverage, 18647,
     /* 1538284 */     GIR_EraseRootFromParent_Done,
     /* 1538285 */   // Label 21378: @1538285
     /* 1538285 */   GIM_Try, /*On fail goto*//*Label 21379*/ GIMT_Encode4(1538367), // Rule ID 18650 //
     /* 1538290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1538301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1538304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538329 */     // MIs[0] round
     /* 1538329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538332 */     // MIs[0] policy
     /* 1538332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538342 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1538345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538366 */     // GIR_Coverage, 18650,
     /* 1538366 */     GIR_EraseRootFromParent_Done,
     /* 1538367 */   // Label 21379: @1538367
     /* 1538367 */   GIM_Try, /*On fail goto*//*Label 21380*/ GIMT_Encode4(1538449), // Rule ID 18651 //
     /* 1538372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1538383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1538386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538411 */     // MIs[0] round
     /* 1538411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538414 */     // MIs[0] policy
     /* 1538414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538424 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1538427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538448 */     // GIR_Coverage, 18651,
     /* 1538448 */     GIR_EraseRootFromParent_Done,
     /* 1538449 */   // Label 21380: @1538449
     /* 1538449 */   GIM_Try, /*On fail goto*//*Label 21381*/ GIMT_Encode4(1538531), // Rule ID 18654 //
     /* 1538454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1538465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1538468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538493 */     // MIs[0] round
     /* 1538493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538496 */     // MIs[0] policy
     /* 1538496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538506 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1538509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538530 */     // GIR_Coverage, 18654,
     /* 1538530 */     GIR_EraseRootFromParent_Done,
     /* 1538531 */   // Label 21381: @1538531
     /* 1538531 */   GIM_Try, /*On fail goto*//*Label 21382*/ GIMT_Encode4(1538613), // Rule ID 18655 //
     /* 1538536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1538547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1538550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538575 */     // MIs[0] round
     /* 1538575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538578 */     // MIs[0] policy
     /* 1538578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538588 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1538591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538612 */     // GIR_Coverage, 18655,
     /* 1538612 */     GIR_EraseRootFromParent_Done,
     /* 1538613 */   // Label 21382: @1538613
     /* 1538613 */   GIM_Try, /*On fail goto*//*Label 21383*/ GIMT_Encode4(1538695), // Rule ID 18658 //
     /* 1538618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1538621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1538638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538657 */     // MIs[0] round
     /* 1538657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538660 */     // MIs[0] policy
     /* 1538660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538670 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1538673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538694 */     // GIR_Coverage, 18658,
     /* 1538694 */     GIR_EraseRootFromParent_Done,
     /* 1538695 */   // Label 21383: @1538695
     /* 1538695 */   GIM_Try, /*On fail goto*//*Label 21384*/ GIMT_Encode4(1538777), // Rule ID 18659 //
     /* 1538700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1538703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1538720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538739 */     // MIs[0] round
     /* 1538739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538742 */     // MIs[0] policy
     /* 1538742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538752 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1538755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538776 */     // GIR_Coverage, 18659,
     /* 1538776 */     GIR_EraseRootFromParent_Done,
     /* 1538777 */   // Label 21384: @1538777
     /* 1538777 */   GIM_Try, /*On fail goto*//*Label 21385*/ GIMT_Encode4(1538859), // Rule ID 18662 //
     /* 1538782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1538785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1538793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1538796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1538802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538821 */     // MIs[0] round
     /* 1538821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538824 */     // MIs[0] policy
     /* 1538824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538834 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1538837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538858 */     // GIR_Coverage, 18662,
     /* 1538858 */     GIR_EraseRootFromParent_Done,
     /* 1538859 */   // Label 21385: @1538859
     /* 1538859 */   GIM_Try, /*On fail goto*//*Label 21386*/ GIMT_Encode4(1538941), // Rule ID 18663 //
     /* 1538864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1538867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1538875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1538878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1538884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538903 */     // MIs[0] round
     /* 1538903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538906 */     // MIs[0] policy
     /* 1538906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538916 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11247:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1538919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538940 */     // GIR_Coverage, 18663,
     /* 1538940 */     GIR_EraseRootFromParent_Done,
     /* 1538941 */   // Label 21386: @1538941
     /* 1538941 */   GIM_Try, /*On fail goto*//*Label 21387*/ GIMT_Encode4(1539023), // Rule ID 18666 //
     /* 1538946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1538949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1538954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1538957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1538960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1538963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1538966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1538981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538985 */     // MIs[0] round
     /* 1538985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538988 */     // MIs[0] policy
     /* 1538988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538998 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1539001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539022 */     // GIR_Coverage, 18666,
     /* 1539022 */     GIR_EraseRootFromParent_Done,
     /* 1539023 */   // Label 21387: @1539023
     /* 1539023 */   GIM_Try, /*On fail goto*//*Label 21388*/ GIMT_Encode4(1539105), // Rule ID 18667 //
     /* 1539028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1539031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1539039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1539042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539067 */     // MIs[0] round
     /* 1539067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539070 */     // MIs[0] policy
     /* 1539070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539080 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1539083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539104 */     // GIR_Coverage, 18667,
     /* 1539104 */     GIR_EraseRootFromParent_Done,
     /* 1539105 */   // Label 21388: @1539105
     /* 1539105 */   GIM_Try, /*On fail goto*//*Label 21389*/ GIMT_Encode4(1539187), // Rule ID 18670 //
     /* 1539110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1539113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1539130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539149 */     // MIs[0] round
     /* 1539149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539152 */     // MIs[0] policy
     /* 1539152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539162 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1539165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539186 */     // GIR_Coverage, 18670,
     /* 1539186 */     GIR_EraseRootFromParent_Done,
     /* 1539187 */   // Label 21389: @1539187
     /* 1539187 */   GIM_Try, /*On fail goto*//*Label 21390*/ GIMT_Encode4(1539269), // Rule ID 18671 //
     /* 1539192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1539195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1539209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1539212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1539227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539231 */     // MIs[0] round
     /* 1539231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539234 */     // MIs[0] policy
     /* 1539234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539244 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1539247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1539265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539268 */     // GIR_Coverage, 18671,
     /* 1539268 */     GIR_EraseRootFromParent_Done,
     /* 1539269 */   // Label 21390: @1539269
     /* 1539269 */   GIM_Try, /*On fail goto*//*Label 21391*/ GIMT_Encode4(1539351), // Rule ID 18674 //
     /* 1539274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1539285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1539288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539313 */     // MIs[0] round
     /* 1539313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539316 */     // MIs[0] policy
     /* 1539316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539326 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1539329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539350 */     // GIR_Coverage, 18674,
     /* 1539350 */     GIR_EraseRootFromParent_Done,
     /* 1539351 */   // Label 21391: @1539351
     /* 1539351 */   GIM_Try, /*On fail goto*//*Label 21392*/ GIMT_Encode4(1539433), // Rule ID 18675 //
     /* 1539356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1539367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1539370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539395 */     // MIs[0] round
     /* 1539395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539398 */     // MIs[0] policy
     /* 1539398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539408 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1539411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539432 */     // GIR_Coverage, 18675,
     /* 1539432 */     GIR_EraseRootFromParent_Done,
     /* 1539433 */   // Label 21392: @1539433
     /* 1539433 */   GIM_Try, /*On fail goto*//*Label 21393*/ GIMT_Encode4(1539515), // Rule ID 18678 //
     /* 1539438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1539449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1539452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539477 */     // MIs[0] round
     /* 1539477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539480 */     // MIs[0] policy
     /* 1539480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539490 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1539493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539514 */     // GIR_Coverage, 18678,
     /* 1539514 */     GIR_EraseRootFromParent_Done,
     /* 1539515 */   // Label 21393: @1539515
     /* 1539515 */   GIM_Try, /*On fail goto*//*Label 21394*/ GIMT_Encode4(1539597), // Rule ID 18679 //
     /* 1539520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1539531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1539534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539559 */     // MIs[0] round
     /* 1539559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539562 */     // MIs[0] policy
     /* 1539562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539572 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1539575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539596 */     // GIR_Coverage, 18679,
     /* 1539596 */     GIR_EraseRootFromParent_Done,
     /* 1539597 */   // Label 21394: @1539597
     /* 1539597 */   GIM_Try, /*On fail goto*//*Label 21395*/ GIMT_Encode4(1539679), // Rule ID 18682 //
     /* 1539602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1539605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1539613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1539616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1539622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539641 */     // MIs[0] round
     /* 1539641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539644 */     // MIs[0] policy
     /* 1539644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539654 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1539657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539678 */     // GIR_Coverage, 18682,
     /* 1539678 */     GIR_EraseRootFromParent_Done,
     /* 1539679 */   // Label 21395: @1539679
     /* 1539679 */   GIM_Try, /*On fail goto*//*Label 21396*/ GIMT_Encode4(1539761), // Rule ID 18683 //
     /* 1539684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1539687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1539695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1539698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1539704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539723 */     // MIs[0] round
     /* 1539723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539726 */     // MIs[0] policy
     /* 1539726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539736 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1539739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539760 */     // GIR_Coverage, 18683,
     /* 1539760 */     GIR_EraseRootFromParent_Done,
     /* 1539761 */   // Label 21396: @1539761
     /* 1539761 */   GIM_Try, /*On fail goto*//*Label 21397*/ GIMT_Encode4(1539843), // Rule ID 18686 //
     /* 1539766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1539769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1539777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1539780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539805 */     // MIs[0] round
     /* 1539805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539808 */     // MIs[0] policy
     /* 1539808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539818 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1539821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539842 */     // GIR_Coverage, 18686,
     /* 1539842 */     GIR_EraseRootFromParent_Done,
     /* 1539843 */   // Label 21397: @1539843
     /* 1539843 */   GIM_Try, /*On fail goto*//*Label 21398*/ GIMT_Encode4(1539925), // Rule ID 18687 //
     /* 1539848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1539851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1539859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1539862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539887 */     // MIs[0] round
     /* 1539887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539890 */     // MIs[0] policy
     /* 1539890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539900 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1539903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539924 */     // GIR_Coverage, 18687,
     /* 1539924 */     GIR_EraseRootFromParent_Done,
     /* 1539925 */   // Label 21398: @1539925
     /* 1539925 */   GIM_Try, /*On fail goto*//*Label 21399*/ GIMT_Encode4(1540007), // Rule ID 18690 //
     /* 1539930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1539933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1539938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1539941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1539944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1539950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539969 */     // MIs[0] round
     /* 1539969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539972 */     // MIs[0] policy
     /* 1539972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539982 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1539985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540006 */     // GIR_Coverage, 18690,
     /* 1540006 */     GIR_EraseRootFromParent_Done,
     /* 1540007 */   // Label 21399: @1540007
     /* 1540007 */   GIM_Try, /*On fail goto*//*Label 21400*/ GIMT_Encode4(1540089), // Rule ID 18691 //
     /* 1540012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1540032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540051 */     // MIs[0] round
     /* 1540051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540054 */     // MIs[0] policy
     /* 1540054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540064 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1540067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540088 */     // GIR_Coverage, 18691,
     /* 1540088 */     GIR_EraseRootFromParent_Done,
     /* 1540089 */   // Label 21400: @1540089
     /* 1540089 */   GIM_Try, /*On fail goto*//*Label 21401*/ GIMT_Encode4(1540171), // Rule ID 18694 //
     /* 1540094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1540097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1540114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540133 */     // MIs[0] round
     /* 1540133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540136 */     // MIs[0] policy
     /* 1540136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540146 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1540149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540170 */     // GIR_Coverage, 18694,
     /* 1540170 */     GIR_EraseRootFromParent_Done,
     /* 1540171 */   // Label 21401: @1540171
     /* 1540171 */   GIM_Try, /*On fail goto*//*Label 21402*/ GIMT_Encode4(1540253), // Rule ID 18695 //
     /* 1540176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1540179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1540196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540215 */     // MIs[0] round
     /* 1540215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540218 */     // MIs[0] policy
     /* 1540218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540228 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1540231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540252 */     // GIR_Coverage, 18695,
     /* 1540252 */     GIR_EraseRootFromParent_Done,
     /* 1540253 */   // Label 21402: @1540253
     /* 1540253 */   GIM_Try, /*On fail goto*//*Label 21403*/ GIMT_Encode4(1540335), // Rule ID 18698 //
     /* 1540258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1540269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1540272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1540278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540297 */     // MIs[0] round
     /* 1540297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540300 */     // MIs[0] policy
     /* 1540300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540310 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1540313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540334 */     // GIR_Coverage, 18698,
     /* 1540334 */     GIR_EraseRootFromParent_Done,
     /* 1540335 */   // Label 21403: @1540335
     /* 1540335 */   GIM_Try, /*On fail goto*//*Label 21404*/ GIMT_Encode4(1540417), // Rule ID 18699 //
     /* 1540340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1540351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1540354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1540360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540379 */     // MIs[0] round
     /* 1540379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540382 */     // MIs[0] policy
     /* 1540382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540392 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1540395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540416 */     // GIR_Coverage, 18699,
     /* 1540416 */     GIR_EraseRootFromParent_Done,
     /* 1540417 */   // Label 21404: @1540417
     /* 1540417 */   GIM_Try, /*On fail goto*//*Label 21405*/ GIMT_Encode4(1540499), // Rule ID 18702 //
     /* 1540422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1540433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1540436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1540442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540461 */     // MIs[0] round
     /* 1540461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540464 */     // MIs[0] policy
     /* 1540464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540474 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1540477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540498 */     // GIR_Coverage, 18702,
     /* 1540498 */     GIR_EraseRootFromParent_Done,
     /* 1540499 */   // Label 21405: @1540499
     /* 1540499 */   GIM_Try, /*On fail goto*//*Label 21406*/ GIMT_Encode4(1540581), // Rule ID 18703 //
     /* 1540504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1540515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1540518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1540524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540543 */     // MIs[0] round
     /* 1540543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540546 */     // MIs[0] policy
     /* 1540546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540556 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1540559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540580 */     // GIR_Coverage, 18703,
     /* 1540580 */     GIR_EraseRootFromParent_Done,
     /* 1540581 */   // Label 21406: @1540581
     /* 1540581 */   GIM_Try, /*On fail goto*//*Label 21407*/ GIMT_Encode4(1540663), // Rule ID 18706 //
     /* 1540586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1540589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1540597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1540600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1540606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540625 */     // MIs[0] round
     /* 1540625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540628 */     // MIs[0] policy
     /* 1540628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540638 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1540641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540662 */     // GIR_Coverage, 18706,
     /* 1540662 */     GIR_EraseRootFromParent_Done,
     /* 1540663 */   // Label 21407: @1540663
     /* 1540663 */   GIM_Try, /*On fail goto*//*Label 21408*/ GIMT_Encode4(1540745), // Rule ID 18707 //
     /* 1540668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1540671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1540676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1540679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1540682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1540685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1540688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1540703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540707 */     // MIs[0] round
     /* 1540707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540710 */     // MIs[0] policy
     /* 1540710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540720 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1540723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1540741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540744 */     // GIR_Coverage, 18707,
     /* 1540744 */     GIR_EraseRootFromParent_Done,
     /* 1540745 */   // Label 21408: @1540745
     /* 1540745 */   GIM_Try, /*On fail goto*//*Label 21409*/ GIMT_Encode4(1540827), // Rule ID 18710 //
     /* 1540750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1540767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1540770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540789 */     // MIs[0] round
     /* 1540789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540792 */     // MIs[0] policy
     /* 1540792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540802 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1540805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540826 */     // GIR_Coverage, 18710,
     /* 1540826 */     GIR_EraseRootFromParent_Done,
     /* 1540827 */   // Label 21409: @1540827
     /* 1540827 */   GIM_Try, /*On fail goto*//*Label 21410*/ GIMT_Encode4(1540909), // Rule ID 18711 //
     /* 1540832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1540849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1540852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540871 */     // MIs[0] round
     /* 1540871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540874 */     // MIs[0] policy
     /* 1540874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540884 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1540887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540908 */     // GIR_Coverage, 18711,
     /* 1540908 */     GIR_EraseRootFromParent_Done,
     /* 1540909 */   // Label 21410: @1540909
     /* 1540909 */   GIM_Try, /*On fail goto*//*Label 21411*/ GIMT_Encode4(1540991), // Rule ID 18714 //
     /* 1540914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1540922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1540925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1540928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1540931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1540934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540953 */     // MIs[0] round
     /* 1540953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540956 */     // MIs[0] policy
     /* 1540956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540966 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1540969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540990 */     // GIR_Coverage, 18714,
     /* 1540990 */     GIR_EraseRootFromParent_Done,
     /* 1540991 */   // Label 21411: @1540991
     /* 1540991 */   GIM_Try, /*On fail goto*//*Label 21412*/ GIMT_Encode4(1541073), // Rule ID 18715 //
     /* 1540996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1541013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541035 */     // MIs[0] round
     /* 1541035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541038 */     // MIs[0] policy
     /* 1541038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541048 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1541051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541072 */     // GIR_Coverage, 18715,
     /* 1541072 */     GIR_EraseRootFromParent_Done,
     /* 1541073 */   // Label 21412: @1541073
     /* 1541073 */   GIM_Try, /*On fail goto*//*Label 21413*/ GIMT_Encode4(1541155), // Rule ID 18718 //
     /* 1541078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541117 */     // MIs[0] round
     /* 1541117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541120 */     // MIs[0] policy
     /* 1541120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541130 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1541133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541154 */     // GIR_Coverage, 18718,
     /* 1541154 */     GIR_EraseRootFromParent_Done,
     /* 1541155 */   // Label 21413: @1541155
     /* 1541155 */   GIM_Try, /*On fail goto*//*Label 21414*/ GIMT_Encode4(1541237), // Rule ID 18719 //
     /* 1541160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1541177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541199 */     // MIs[0] round
     /* 1541199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541202 */     // MIs[0] policy
     /* 1541202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541212 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1541215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541236 */     // GIR_Coverage, 18719,
     /* 1541236 */     GIR_EraseRootFromParent_Done,
     /* 1541237 */   // Label 21414: @1541237
     /* 1541237 */   GIM_Try, /*On fail goto*//*Label 21415*/ GIMT_Encode4(1541319), // Rule ID 18722 //
     /* 1541242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1541259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1541262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541281 */     // MIs[0] round
     /* 1541281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541284 */     // MIs[0] policy
     /* 1541284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541294 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1541297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541318 */     // GIR_Coverage, 18722,
     /* 1541318 */     GIR_EraseRootFromParent_Done,
     /* 1541319 */   // Label 21415: @1541319
     /* 1541319 */   GIM_Try, /*On fail goto*//*Label 21416*/ GIMT_Encode4(1541401), // Rule ID 18723 //
     /* 1541324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1541335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1541338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1541341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1541344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541363 */     // MIs[0] round
     /* 1541363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541366 */     // MIs[0] policy
     /* 1541366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541376 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1541379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541400 */     // GIR_Coverage, 18723,
     /* 1541400 */     GIR_EraseRootFromParent_Done,
     /* 1541401 */   // Label 21416: @1541401
     /* 1541401 */   GIM_Try, /*On fail goto*//*Label 21417*/ GIMT_Encode4(1541483), // Rule ID 18726 //
     /* 1541406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1541423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1541426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541445 */     // MIs[0] round
     /* 1541445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541448 */     // MIs[0] policy
     /* 1541448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541458 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1541461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541482 */     // GIR_Coverage, 18726,
     /* 1541482 */     GIR_EraseRootFromParent_Done,
     /* 1541483 */   // Label 21417: @1541483
     /* 1541483 */   GIM_Try, /*On fail goto*//*Label 21418*/ GIMT_Encode4(1541565), // Rule ID 18727 //
     /* 1541488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1541499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1541502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1541505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1541508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541527 */     // MIs[0] round
     /* 1541527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541530 */     // MIs[0] policy
     /* 1541530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541540 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1541543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541564 */     // GIR_Coverage, 18727,
     /* 1541564 */     GIR_EraseRootFromParent_Done,
     /* 1541565 */   // Label 21418: @1541565
     /* 1541565 */   GIM_Try, /*On fail goto*//*Label 21419*/ GIMT_Encode4(1541647), // Rule ID 18730 //
     /* 1541570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1541581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1541584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1541587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1541590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541609 */     // MIs[0] round
     /* 1541609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541612 */     // MIs[0] policy
     /* 1541612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541622 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1541625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541646 */     // GIR_Coverage, 18730,
     /* 1541646 */     GIR_EraseRootFromParent_Done,
     /* 1541647 */   // Label 21419: @1541647
     /* 1541647 */   GIM_Try, /*On fail goto*//*Label 21420*/ GIMT_Encode4(1541729), // Rule ID 18731 //
     /* 1541652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1541663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1541666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1541669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1541672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541691 */     // MIs[0] round
     /* 1541691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541694 */     // MIs[0] policy
     /* 1541694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541704 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1541707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541728 */     // GIR_Coverage, 18731,
     /* 1541728 */     GIR_EraseRootFromParent_Done,
     /* 1541729 */   // Label 21420: @1541729
     /* 1541729 */   GIM_Try, /*On fail goto*//*Label 21421*/ GIMT_Encode4(1541811), // Rule ID 18734 //
     /* 1541734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1541751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1541754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541773 */     // MIs[0] round
     /* 1541773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541776 */     // MIs[0] policy
     /* 1541776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541786 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1541789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541810 */     // GIR_Coverage, 18734,
     /* 1541810 */     GIR_EraseRootFromParent_Done,
     /* 1541811 */   // Label 21421: @1541811
     /* 1541811 */   GIM_Try, /*On fail goto*//*Label 21422*/ GIMT_Encode4(1541893), // Rule ID 18735 //
     /* 1541816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1541833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1541836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541855 */     // MIs[0] round
     /* 1541855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541858 */     // MIs[0] policy
     /* 1541858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541868 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1541871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541892 */     // GIR_Coverage, 18735,
     /* 1541892 */     GIR_EraseRootFromParent_Done,
     /* 1541893 */   // Label 21422: @1541893
     /* 1541893 */   GIM_Try, /*On fail goto*//*Label 21423*/ GIMT_Encode4(1541975), // Rule ID 18738 //
     /* 1541898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1541909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1541912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1541915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1541918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541937 */     // MIs[0] round
     /* 1541937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541940 */     // MIs[0] policy
     /* 1541940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541950 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1541953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541974 */     // GIR_Coverage, 18738,
     /* 1541974 */     GIR_EraseRootFromParent_Done,
     /* 1541975 */   // Label 21423: @1541975
     /* 1541975 */   GIM_Try, /*On fail goto*//*Label 21424*/ GIMT_Encode4(1542057), // Rule ID 18739 //
     /* 1541980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1541988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1541991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1541994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1541997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542019 */     // MIs[0] round
     /* 1542019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542022 */     // MIs[0] policy
     /* 1542022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542032 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1542035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542056 */     // GIR_Coverage, 18739,
     /* 1542056 */     GIR_EraseRootFromParent_Done,
     /* 1542057 */   // Label 21424: @1542057
     /* 1542057 */   GIM_Try, /*On fail goto*//*Label 21425*/ GIMT_Encode4(1542139), // Rule ID 18742 //
     /* 1542062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542101 */     // MIs[0] round
     /* 1542101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542104 */     // MIs[0] policy
     /* 1542104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542114 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1542117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542138 */     // GIR_Coverage, 18742,
     /* 1542138 */     GIR_EraseRootFromParent_Done,
     /* 1542139 */   // Label 21425: @1542139
     /* 1542139 */   GIM_Try, /*On fail goto*//*Label 21426*/ GIMT_Encode4(1542221), // Rule ID 18743 //
     /* 1542144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1542161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542183 */     // MIs[0] round
     /* 1542183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542186 */     // MIs[0] policy
     /* 1542186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542196 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1542199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542220 */     // GIR_Coverage, 18743,
     /* 1542220 */     GIR_EraseRootFromParent_Done,
     /* 1542221 */   // Label 21426: @1542221
     /* 1542221 */   GIM_Try, /*On fail goto*//*Label 21427*/ GIMT_Encode4(1542303), // Rule ID 18746 //
     /* 1542226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542265 */     // MIs[0] round
     /* 1542265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542268 */     // MIs[0] policy
     /* 1542268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542278 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1542281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542302 */     // GIR_Coverage, 18746,
     /* 1542302 */     GIR_EraseRootFromParent_Done,
     /* 1542303 */   // Label 21427: @1542303
     /* 1542303 */   GIM_Try, /*On fail goto*//*Label 21428*/ GIMT_Encode4(1542385), // Rule ID 18747 //
     /* 1542308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1542319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1542322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1542328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542347 */     // MIs[0] round
     /* 1542347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542350 */     // MIs[0] policy
     /* 1542350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542360 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1542363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542384 */     // GIR_Coverage, 18747,
     /* 1542384 */     GIR_EraseRootFromParent_Done,
     /* 1542385 */   // Label 21428: @1542385
     /* 1542385 */   GIM_Try, /*On fail goto*//*Label 21429*/ GIMT_Encode4(1542467), // Rule ID 18750 //
     /* 1542390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542429 */     // MIs[0] round
     /* 1542429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542432 */     // MIs[0] policy
     /* 1542432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542442 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1542445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542466 */     // GIR_Coverage, 18750,
     /* 1542466 */     GIR_EraseRootFromParent_Done,
     /* 1542467 */   // Label 21429: @1542467
     /* 1542467 */   GIM_Try, /*On fail goto*//*Label 21430*/ GIMT_Encode4(1542549), // Rule ID 18751 //
     /* 1542472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1542483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1542486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1542492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542511 */     // MIs[0] round
     /* 1542511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542514 */     // MIs[0] policy
     /* 1542514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11299:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1542527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542548 */     // GIR_Coverage, 18751,
     /* 1542548 */     GIR_EraseRootFromParent_Done,
     /* 1542549 */   // Label 21430: @1542549
     /* 1542549 */   GIM_Try, /*On fail goto*//*Label 21431*/ GIMT_Encode4(1542631), // Rule ID 18754 //
     /* 1542554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1542565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1542568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1542574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542593 */     // MIs[0] round
     /* 1542593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542596 */     // MIs[0] policy
     /* 1542596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542606 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1542609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542630 */     // GIR_Coverage, 18754,
     /* 1542630 */     GIR_EraseRootFromParent_Done,
     /* 1542631 */   // Label 21431: @1542631
     /* 1542631 */   GIM_Try, /*On fail goto*//*Label 21432*/ GIMT_Encode4(1542713), // Rule ID 18755 //
     /* 1542636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1542647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1542650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1542656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542675 */     // MIs[0] round
     /* 1542675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542678 */     // MIs[0] policy
     /* 1542678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542688 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1542691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542712 */     // GIR_Coverage, 18755,
     /* 1542712 */     GIR_EraseRootFromParent_Done,
     /* 1542713 */   // Label 21432: @1542713
     /* 1542713 */   GIM_Try, /*On fail goto*//*Label 21433*/ GIMT_Encode4(1542795), // Rule ID 18758 //
     /* 1542718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1542729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1542732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1542738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542757 */     // MIs[0] round
     /* 1542757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542760 */     // MIs[0] policy
     /* 1542760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542770 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1542773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542794 */     // GIR_Coverage, 18758,
     /* 1542794 */     GIR_EraseRootFromParent_Done,
     /* 1542795 */   // Label 21433: @1542795
     /* 1542795 */   GIM_Try, /*On fail goto*//*Label 21434*/ GIMT_Encode4(1542877), // Rule ID 18759 //
     /* 1542800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1542811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1542814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1542820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542839 */     // MIs[0] round
     /* 1542839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542842 */     // MIs[0] policy
     /* 1542842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542852 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1542855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542876 */     // GIR_Coverage, 18759,
     /* 1542876 */     GIR_EraseRootFromParent_Done,
     /* 1542877 */   // Label 21434: @1542877
     /* 1542877 */   GIM_Try, /*On fail goto*//*Label 21435*/ GIMT_Encode4(1542959), // Rule ID 18762 //
     /* 1542882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1542893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1542896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1542902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542921 */     // MIs[0] round
     /* 1542921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542924 */     // MIs[0] policy
     /* 1542924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542934 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1542937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542958 */     // GIR_Coverage, 18762,
     /* 1542958 */     GIR_EraseRootFromParent_Done,
     /* 1542959 */   // Label 21435: @1542959
     /* 1542959 */   GIM_Try, /*On fail goto*//*Label 21436*/ GIMT_Encode4(1543041), // Rule ID 18763 //
     /* 1542964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1542972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1542975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1542978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1542984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543003 */     // MIs[0] round
     /* 1543003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543006 */     // MIs[0] policy
     /* 1543006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543016 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1543019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543040 */     // GIR_Coverage, 18763,
     /* 1543040 */     GIR_EraseRootFromParent_Done,
     /* 1543041 */   // Label 21436: @1543041
     /* 1543041 */   GIM_Try, /*On fail goto*//*Label 21437*/ GIMT_Encode4(1543123), // Rule ID 18766 //
     /* 1543046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543085 */     // MIs[0] round
     /* 1543085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543088 */     // MIs[0] policy
     /* 1543088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543098 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1543101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543122 */     // GIR_Coverage, 18766,
     /* 1543122 */     GIR_EraseRootFromParent_Done,
     /* 1543123 */   // Label 21437: @1543123
     /* 1543123 */   GIM_Try, /*On fail goto*//*Label 21438*/ GIMT_Encode4(1543205), // Rule ID 18767 //
     /* 1543128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543167 */     // MIs[0] round
     /* 1543167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543170 */     // MIs[0] policy
     /* 1543170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543180 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11299:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1543183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543204 */     // GIR_Coverage, 18767,
     /* 1543204 */     GIR_EraseRootFromParent_Done,
     /* 1543205 */   // Label 21438: @1543205
     /* 1543205 */   GIM_Try, /*On fail goto*//*Label 21439*/ GIMT_Encode4(1543287), // Rule ID 18770 //
     /* 1543210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1543221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1543224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1543230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543249 */     // MIs[0] round
     /* 1543249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543252 */     // MIs[0] policy
     /* 1543252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543262 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1543265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543286 */     // GIR_Coverage, 18770,
     /* 1543286 */     GIR_EraseRootFromParent_Done,
     /* 1543287 */   // Label 21439: @1543287
     /* 1543287 */   GIM_Try, /*On fail goto*//*Label 21440*/ GIMT_Encode4(1543369), // Rule ID 18771 //
     /* 1543292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1543303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1543306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1543312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543331 */     // MIs[0] round
     /* 1543331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543334 */     // MIs[0] policy
     /* 1543334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543344 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11299:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1543347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543368 */     // GIR_Coverage, 18771,
     /* 1543368 */     GIR_EraseRootFromParent_Done,
     /* 1543369 */   // Label 21440: @1543369
     /* 1543369 */   GIM_Try, /*On fail goto*//*Label 21441*/ GIMT_Encode4(1543451), // Rule ID 18774 //
     /* 1543374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1543385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1543388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543413 */     // MIs[0] round
     /* 1543413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543416 */     // MIs[0] policy
     /* 1543416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543426 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1543429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543450 */     // GIR_Coverage, 18774,
     /* 1543450 */     GIR_EraseRootFromParent_Done,
     /* 1543451 */   // Label 21441: @1543451
     /* 1543451 */   GIM_Try, /*On fail goto*//*Label 21442*/ GIMT_Encode4(1543533), // Rule ID 18775 //
     /* 1543456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1543467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1543470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1543476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543495 */     // MIs[0] round
     /* 1543495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543498 */     // MIs[0] policy
     /* 1543498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11299:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1543511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543532 */     // GIR_Coverage, 18775,
     /* 1543532 */     GIR_EraseRootFromParent_Done,
     /* 1543533 */   // Label 21442: @1543533
     /* 1543533 */   GIM_Try, /*On fail goto*//*Label 21443*/ GIMT_Encode4(1543615), // Rule ID 18778 //
     /* 1543538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1543549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1543552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1543558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543577 */     // MIs[0] round
     /* 1543577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543580 */     // MIs[0] policy
     /* 1543580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543590 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1543593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543614 */     // GIR_Coverage, 18778,
     /* 1543614 */     GIR_EraseRootFromParent_Done,
     /* 1543615 */   // Label 21443: @1543615
     /* 1543615 */   GIM_Try, /*On fail goto*//*Label 21444*/ GIMT_Encode4(1543697), // Rule ID 18779 //
     /* 1543620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1543628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1543631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1543634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1543637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1543640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1543655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543659 */     // MIs[0] round
     /* 1543659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543662 */     // MIs[0] policy
     /* 1543662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543672 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11299:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1543675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543696 */     // GIR_Coverage, 18779,
     /* 1543696 */     GIR_EraseRootFromParent_Done,
     /* 1543697 */   // Label 21444: @1543697
     /* 1543697 */   GIM_Try, /*On fail goto*//*Label 21445*/ GIMT_Encode4(1543779), // Rule ID 18782 //
     /* 1543702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1543713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1543716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1543719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1543722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543741 */     // MIs[0] round
     /* 1543741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543744 */     // MIs[0] policy
     /* 1543744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543754 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1543757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543778 */     // GIR_Coverage, 18782,
     /* 1543778 */     GIR_EraseRootFromParent_Done,
     /* 1543779 */   // Label 21445: @1543779
     /* 1543779 */   GIM_Try, /*On fail goto*//*Label 21446*/ GIMT_Encode4(1543861), // Rule ID 18783 //
     /* 1543784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1543795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1543798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1543801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1543804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543823 */     // MIs[0] round
     /* 1543823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543826 */     // MIs[0] policy
     /* 1543826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543836 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1543839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543860 */     // GIR_Coverage, 18783,
     /* 1543860 */     GIR_EraseRootFromParent_Done,
     /* 1543861 */   // Label 21446: @1543861
     /* 1543861 */   GIM_Try, /*On fail goto*//*Label 21447*/ GIMT_Encode4(1543943), // Rule ID 18786 //
     /* 1543866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1543883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543905 */     // MIs[0] round
     /* 1543905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543908 */     // MIs[0] policy
     /* 1543908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543918 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1543921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543942 */     // GIR_Coverage, 18786,
     /* 1543942 */     GIR_EraseRootFromParent_Done,
     /* 1543943 */   // Label 21447: @1543943
     /* 1543943 */   GIM_Try, /*On fail goto*//*Label 21448*/ GIMT_Encode4(1544025), // Rule ID 18787 //
     /* 1543948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1543956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1543965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543987 */     // MIs[0] round
     /* 1543987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543990 */     // MIs[0] policy
     /* 1543990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544000 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1544003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544024 */     // GIR_Coverage, 18787,
     /* 1544024 */     GIR_EraseRootFromParent_Done,
     /* 1544025 */   // Label 21448: @1544025
     /* 1544025 */   GIM_Try, /*On fail goto*//*Label 21449*/ GIMT_Encode4(1544107), // Rule ID 18790 //
     /* 1544030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544069 */     // MIs[0] round
     /* 1544069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544072 */     // MIs[0] policy
     /* 1544072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1544085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544106 */     // GIR_Coverage, 18790,
     /* 1544106 */     GIR_EraseRootFromParent_Done,
     /* 1544107 */   // Label 21449: @1544107
     /* 1544107 */   GIM_Try, /*On fail goto*//*Label 21450*/ GIMT_Encode4(1544189), // Rule ID 18791 //
     /* 1544112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1544129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544151 */     // MIs[0] round
     /* 1544151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544154 */     // MIs[0] policy
     /* 1544154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544164 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1544167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544188 */     // GIR_Coverage, 18791,
     /* 1544188 */     GIR_EraseRootFromParent_Done,
     /* 1544189 */   // Label 21450: @1544189
     /* 1544189 */   GIM_Try, /*On fail goto*//*Label 21451*/ GIMT_Encode4(1544271), // Rule ID 18794 //
     /* 1544194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1544211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544233 */     // MIs[0] round
     /* 1544233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544236 */     // MIs[0] policy
     /* 1544236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544246 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1544249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544270 */     // GIR_Coverage, 18794,
     /* 1544270 */     GIR_EraseRootFromParent_Done,
     /* 1544271 */   // Label 21451: @1544271
     /* 1544271 */   GIM_Try, /*On fail goto*//*Label 21452*/ GIMT_Encode4(1544353), // Rule ID 18795 //
     /* 1544276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1544290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1544293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1544296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544315 */     // MIs[0] round
     /* 1544315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544318 */     // MIs[0] policy
     /* 1544318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544328 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1544331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544352 */     // GIR_Coverage, 18795,
     /* 1544352 */     GIR_EraseRootFromParent_Done,
     /* 1544353 */   // Label 21452: @1544353
     /* 1544353 */   GIM_Try, /*On fail goto*//*Label 21453*/ GIMT_Encode4(1544435), // Rule ID 18798 //
     /* 1544358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1544375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544397 */     // MIs[0] round
     /* 1544397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544400 */     // MIs[0] policy
     /* 1544400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544410 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1544413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544434 */     // GIR_Coverage, 18798,
     /* 1544434 */     GIR_EraseRootFromParent_Done,
     /* 1544435 */   // Label 21453: @1544435
     /* 1544435 */   GIM_Try, /*On fail goto*//*Label 21454*/ GIMT_Encode4(1544517), // Rule ID 18799 //
     /* 1544440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1544451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1544454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1544457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1544460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544479 */     // MIs[0] round
     /* 1544479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544482 */     // MIs[0] policy
     /* 1544482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544492 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1544495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544516 */     // GIR_Coverage, 18799,
     /* 1544516 */     GIR_EraseRootFromParent_Done,
     /* 1544517 */   // Label 21454: @1544517
     /* 1544517 */   GIM_Try, /*On fail goto*//*Label 21455*/ GIMT_Encode4(1544599), // Rule ID 18802 //
     /* 1544522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1544533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1544536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1544539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1544542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544561 */     // MIs[0] round
     /* 1544561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544564 */     // MIs[0] policy
     /* 1544564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544574 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1544577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544598 */     // GIR_Coverage, 18802,
     /* 1544598 */     GIR_EraseRootFromParent_Done,
     /* 1544599 */   // Label 21455: @1544599
     /* 1544599 */   GIM_Try, /*On fail goto*//*Label 21456*/ GIMT_Encode4(1544681), // Rule ID 18803 //
     /* 1544604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1544615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1544618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1544621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1544624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544643 */     // MIs[0] round
     /* 1544643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544646 */     // MIs[0] policy
     /* 1544646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544656 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1544659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544680 */     // GIR_Coverage, 18803,
     /* 1544680 */     GIR_EraseRootFromParent_Done,
     /* 1544681 */   // Label 21456: @1544681
     /* 1544681 */   GIM_Try, /*On fail goto*//*Label 21457*/ GIMT_Encode4(1544763), // Rule ID 18806 //
     /* 1544686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1544703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1544706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544725 */     // MIs[0] round
     /* 1544725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544728 */     // MIs[0] policy
     /* 1544728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544738 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1544741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544762 */     // GIR_Coverage, 18806,
     /* 1544762 */     GIR_EraseRootFromParent_Done,
     /* 1544763 */   // Label 21457: @1544763
     /* 1544763 */   GIM_Try, /*On fail goto*//*Label 21458*/ GIMT_Encode4(1544845), // Rule ID 18807 //
     /* 1544768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1544785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1544788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544807 */     // MIs[0] round
     /* 1544807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544810 */     // MIs[0] policy
     /* 1544810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544820 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1544823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544844 */     // GIR_Coverage, 18807,
     /* 1544844 */     GIR_EraseRootFromParent_Done,
     /* 1544845 */   // Label 21458: @1544845
     /* 1544845 */   GIM_Try, /*On fail goto*//*Label 21459*/ GIMT_Encode4(1544927), // Rule ID 18810 //
     /* 1544850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1544867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544889 */     // MIs[0] round
     /* 1544889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544892 */     // MIs[0] policy
     /* 1544892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544902 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1544905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544926 */     // GIR_Coverage, 18810,
     /* 1544926 */     GIR_EraseRootFromParent_Done,
     /* 1544927 */   // Label 21459: @1544927
     /* 1544927 */   GIM_Try, /*On fail goto*//*Label 21460*/ GIMT_Encode4(1545009), // Rule ID 18811 //
     /* 1544932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1544940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1544949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544971 */     // MIs[0] round
     /* 1544971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544974 */     // MIs[0] policy
     /* 1544974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544984 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1544987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545008 */     // GIR_Coverage, 18811,
     /* 1545008 */     GIR_EraseRootFromParent_Done,
     /* 1545009 */   // Label 21460: @1545009
     /* 1545009 */   GIM_Try, /*On fail goto*//*Label 21461*/ GIMT_Encode4(1545091), // Rule ID 18814 //
     /* 1545014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545053 */     // MIs[0] round
     /* 1545053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545056 */     // MIs[0] policy
     /* 1545056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545066 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1545069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545090 */     // GIR_Coverage, 18814,
     /* 1545090 */     GIR_EraseRootFromParent_Done,
     /* 1545091 */   // Label 21461: @1545091
     /* 1545091 */   GIM_Try, /*On fail goto*//*Label 21462*/ GIMT_Encode4(1545173), // Rule ID 18815 //
     /* 1545096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1545113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545135 */     // MIs[0] round
     /* 1545135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545138 */     // MIs[0] policy
     /* 1545138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545148 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1545151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545172 */     // GIR_Coverage, 18815,
     /* 1545172 */     GIR_EraseRootFromParent_Done,
     /* 1545173 */   // Label 21462: @1545173
     /* 1545173 */   GIM_Try, /*On fail goto*//*Label 21463*/ GIMT_Encode4(1545255), // Rule ID 18818 //
     /* 1545178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545217 */     // MIs[0] round
     /* 1545217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545220 */     // MIs[0] policy
     /* 1545220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545230 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1545233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545254 */     // GIR_Coverage, 18818,
     /* 1545254 */     GIR_EraseRootFromParent_Done,
     /* 1545255 */   // Label 21463: @1545255
     /* 1545255 */   GIM_Try, /*On fail goto*//*Label 21464*/ GIMT_Encode4(1545337), // Rule ID 18819 //
     /* 1545260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1545271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1545274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1545280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545299 */     // MIs[0] round
     /* 1545299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545302 */     // MIs[0] policy
     /* 1545302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545312 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1545315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545336 */     // GIR_Coverage, 18819,
     /* 1545336 */     GIR_EraseRootFromParent_Done,
     /* 1545337 */   // Label 21464: @1545337
     /* 1545337 */   GIM_Try, /*On fail goto*//*Label 21465*/ GIMT_Encode4(1545419), // Rule ID 18822 //
     /* 1545342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1545353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1545356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1545362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545381 */     // MIs[0] round
     /* 1545381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545384 */     // MIs[0] policy
     /* 1545384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545394 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1545397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545418 */     // GIR_Coverage, 18822,
     /* 1545418 */     GIR_EraseRootFromParent_Done,
     /* 1545419 */   // Label 21465: @1545419
     /* 1545419 */   GIM_Try, /*On fail goto*//*Label 21466*/ GIMT_Encode4(1545501), // Rule ID 18823 //
     /* 1545424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1545435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1545438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1545444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545463 */     // MIs[0] round
     /* 1545463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545466 */     // MIs[0] policy
     /* 1545466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545476 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11307:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1545479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545500 */     // GIR_Coverage, 18823,
     /* 1545500 */     GIR_EraseRootFromParent_Done,
     /* 1545501 */   // Label 21466: @1545501
     /* 1545501 */   GIM_Try, /*On fail goto*//*Label 21467*/ GIMT_Encode4(1545583), // Rule ID 18826 //
     /* 1545506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1545517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1545520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1545526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545545 */     // MIs[0] round
     /* 1545545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545548 */     // MIs[0] policy
     /* 1545548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545558 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1545561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545582 */     // GIR_Coverage, 18826,
     /* 1545582 */     GIR_EraseRootFromParent_Done,
     /* 1545583 */   // Label 21467: @1545583
     /* 1545583 */   GIM_Try, /*On fail goto*//*Label 21468*/ GIMT_Encode4(1545665), // Rule ID 18827 //
     /* 1545588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1545599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1545602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1545608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545627 */     // MIs[0] round
     /* 1545627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545630 */     // MIs[0] policy
     /* 1545630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545640 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1545643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545664 */     // GIR_Coverage, 18827,
     /* 1545664 */     GIR_EraseRootFromParent_Done,
     /* 1545665 */   // Label 21468: @1545665
     /* 1545665 */   GIM_Try, /*On fail goto*//*Label 21469*/ GIMT_Encode4(1545747), // Rule ID 18830 //
     /* 1545670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1545681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1545684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1545690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545709 */     // MIs[0] round
     /* 1545709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545712 */     // MIs[0] policy
     /* 1545712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545722 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1545725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545746 */     // GIR_Coverage, 18830,
     /* 1545746 */     GIR_EraseRootFromParent_Done,
     /* 1545747 */   // Label 21469: @1545747
     /* 1545747 */   GIM_Try, /*On fail goto*//*Label 21470*/ GIMT_Encode4(1545829), // Rule ID 18831 //
     /* 1545752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1545763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1545766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1545772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545791 */     // MIs[0] round
     /* 1545791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545794 */     // MIs[0] policy
     /* 1545794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545804 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1545807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545828 */     // GIR_Coverage, 18831,
     /* 1545828 */     GIR_EraseRootFromParent_Done,
     /* 1545829 */   // Label 21470: @1545829
     /* 1545829 */   GIM_Try, /*On fail goto*//*Label 21471*/ GIMT_Encode4(1545911), // Rule ID 18834 //
     /* 1545834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545873 */     // MIs[0] round
     /* 1545873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545876 */     // MIs[0] policy
     /* 1545876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545886 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1545889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545910 */     // GIR_Coverage, 18834,
     /* 1545910 */     GIR_EraseRootFromParent_Done,
     /* 1545911 */   // Label 21471: @1545911
     /* 1545911 */   GIM_Try, /*On fail goto*//*Label 21472*/ GIMT_Encode4(1545993), // Rule ID 18835 //
     /* 1545916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1545924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545955 */     // MIs[0] round
     /* 1545955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545958 */     // MIs[0] policy
     /* 1545958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545968 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1545971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545992 */     // GIR_Coverage, 18835,
     /* 1545992 */     GIR_EraseRootFromParent_Done,
     /* 1545993 */   // Label 21472: @1545993
     /* 1545993 */   GIM_Try, /*On fail goto*//*Label 21473*/ GIMT_Encode4(1546075), // Rule ID 18838 //
     /* 1545998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546037 */     // MIs[0] round
     /* 1546037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546040 */     // MIs[0] policy
     /* 1546040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1546053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546074 */     // GIR_Coverage, 18838,
     /* 1546074 */     GIR_EraseRootFromParent_Done,
     /* 1546075 */   // Label 21473: @1546075
     /* 1546075 */   GIM_Try, /*On fail goto*//*Label 21474*/ GIMT_Encode4(1546157), // Rule ID 18839 //
     /* 1546080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1546100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546119 */     // MIs[0] round
     /* 1546119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546122 */     // MIs[0] policy
     /* 1546122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546132 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11307:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1546135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546156 */     // GIR_Coverage, 18839,
     /* 1546156 */     GIR_EraseRootFromParent_Done,
     /* 1546157 */   // Label 21474: @1546157
     /* 1546157 */   GIM_Try, /*On fail goto*//*Label 21475*/ GIMT_Encode4(1546239), // Rule ID 18842 //
     /* 1546162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546201 */     // MIs[0] round
     /* 1546201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546204 */     // MIs[0] policy
     /* 1546204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546214 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1546217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546238 */     // GIR_Coverage, 18842,
     /* 1546238 */     GIR_EraseRootFromParent_Done,
     /* 1546239 */   // Label 21475: @1546239
     /* 1546239 */   GIM_Try, /*On fail goto*//*Label 21476*/ GIMT_Encode4(1546321), // Rule ID 18843 //
     /* 1546244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1546255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1546258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1546264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546283 */     // MIs[0] round
     /* 1546283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546286 */     // MIs[0] policy
     /* 1546286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546296 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11307:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1546299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546320 */     // GIR_Coverage, 18843,
     /* 1546320 */     GIR_EraseRootFromParent_Done,
     /* 1546321 */   // Label 21476: @1546321
     /* 1546321 */   GIM_Try, /*On fail goto*//*Label 21477*/ GIMT_Encode4(1546403), // Rule ID 18846 //
     /* 1546326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1546337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1546340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1546346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546365 */     // MIs[0] round
     /* 1546365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546368 */     // MIs[0] policy
     /* 1546368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546378 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1546381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546402 */     // GIR_Coverage, 18846,
     /* 1546402 */     GIR_EraseRootFromParent_Done,
     /* 1546403 */   // Label 21477: @1546403
     /* 1546403 */   GIM_Try, /*On fail goto*//*Label 21478*/ GIMT_Encode4(1546485), // Rule ID 18847 //
     /* 1546408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1546419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1546422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1546428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546447 */     // MIs[0] round
     /* 1546447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546450 */     // MIs[0] policy
     /* 1546450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546460 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11307:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1546463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546484 */     // GIR_Coverage, 18847,
     /* 1546484 */     GIR_EraseRootFromParent_Done,
     /* 1546485 */   // Label 21478: @1546485
     /* 1546485 */   GIM_Try, /*On fail goto*//*Label 21479*/ GIMT_Encode4(1546567), // Rule ID 18850 //
     /* 1546490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1546493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1546501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1546504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1546510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546529 */     // MIs[0] round
     /* 1546529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546532 */     // MIs[0] policy
     /* 1546532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546542 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1546545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546566 */     // GIR_Coverage, 18850,
     /* 1546566 */     GIR_EraseRootFromParent_Done,
     /* 1546567 */   // Label 21479: @1546567
     /* 1546567 */   GIM_Try, /*On fail goto*//*Label 21480*/ GIMT_Encode4(1546649), // Rule ID 18851 //
     /* 1546572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1546575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1546580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1546583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1546586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1546589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1546592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1546603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1546607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546611 */     // MIs[0] round
     /* 1546611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546614 */     // MIs[0] policy
     /* 1546614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546624 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11307:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1546627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546648 */     // GIR_Coverage, 18851,
     /* 1546648 */     GIR_EraseRootFromParent_Done,
     /* 1546649 */   // Label 21480: @1546649
     /* 1546649 */   GIM_Try, /*On fail goto*//*Label 21481*/ GIMT_Encode4(1546731), // Rule ID 18854 //
     /* 1546654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1546671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1546674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546693 */     // MIs[0] round
     /* 1546693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546696 */     // MIs[0] policy
     /* 1546696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546706 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1546709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546730 */     // GIR_Coverage, 18854,
     /* 1546730 */     GIR_EraseRootFromParent_Done,
     /* 1546731 */   // Label 21481: @1546731
     /* 1546731 */   GIM_Try, /*On fail goto*//*Label 21482*/ GIMT_Encode4(1546813), // Rule ID 18855 //
     /* 1546736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1546753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1546756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546775 */     // MIs[0] round
     /* 1546775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546778 */     // MIs[0] policy
     /* 1546778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546788 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1546791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546812 */     // GIR_Coverage, 18855,
     /* 1546812 */     GIR_EraseRootFromParent_Done,
     /* 1546813 */   // Label 21482: @1546813
     /* 1546813 */   GIM_Try, /*On fail goto*//*Label 21483*/ GIMT_Encode4(1546895), // Rule ID 18858 //
     /* 1546818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1546835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1546838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546857 */     // MIs[0] round
     /* 1546857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546860 */     // MIs[0] policy
     /* 1546860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546870 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1546873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546894 */     // GIR_Coverage, 18858,
     /* 1546894 */     GIR_EraseRootFromParent_Done,
     /* 1546895 */   // Label 21483: @1546895
     /* 1546895 */   GIM_Try, /*On fail goto*//*Label 21484*/ GIMT_Encode4(1546977), // Rule ID 18859 //
     /* 1546900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1546903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1546917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1546920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546939 */     // MIs[0] round
     /* 1546939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546942 */     // MIs[0] policy
     /* 1546942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546952 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1546955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1546959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1546961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1546963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546976 */     // GIR_Coverage, 18859,
     /* 1546976 */     GIR_EraseRootFromParent_Done,
     /* 1546977 */   // Label 21484: @1546977
     /* 1546977 */   GIM_Try, /*On fail goto*//*Label 21485*/ GIMT_Encode4(1547059), // Rule ID 18862 //
     /* 1546982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1546985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1546990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1546993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1546996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1546999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547021 */     // MIs[0] round
     /* 1547021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547024 */     // MIs[0] policy
     /* 1547024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547034 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1547037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547058 */     // GIR_Coverage, 18862,
     /* 1547058 */     GIR_EraseRootFromParent_Done,
     /* 1547059 */   // Label 21485: @1547059
     /* 1547059 */   GIM_Try, /*On fail goto*//*Label 21486*/ GIMT_Encode4(1547141), // Rule ID 18863 //
     /* 1547064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1547081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1547084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547103 */     // MIs[0] round
     /* 1547103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547106 */     // MIs[0] policy
     /* 1547106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547116 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1547119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547140 */     // GIR_Coverage, 18863,
     /* 1547140 */     GIR_EraseRootFromParent_Done,
     /* 1547141 */   // Label 21486: @1547141
     /* 1547141 */   GIM_Try, /*On fail goto*//*Label 21487*/ GIMT_Encode4(1547223), // Rule ID 18866 //
     /* 1547146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547185 */     // MIs[0] round
     /* 1547185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547188 */     // MIs[0] policy
     /* 1547188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547198 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1547201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547222 */     // GIR_Coverage, 18866,
     /* 1547222 */     GIR_EraseRootFromParent_Done,
     /* 1547223 */   // Label 21487: @1547223
     /* 1547223 */   GIM_Try, /*On fail goto*//*Label 21488*/ GIMT_Encode4(1547305), // Rule ID 18867 //
     /* 1547228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1547245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1547248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547267 */     // MIs[0] round
     /* 1547267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547270 */     // MIs[0] policy
     /* 1547270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547280 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1547283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547304 */     // GIR_Coverage, 18867,
     /* 1547304 */     GIR_EraseRootFromParent_Done,
     /* 1547305 */   // Label 21488: @1547305
     /* 1547305 */   GIM_Try, /*On fail goto*//*Label 21489*/ GIMT_Encode4(1547387), // Rule ID 18870 //
     /* 1547310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1547313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1547327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1547330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547349 */     // MIs[0] round
     /* 1547349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547352 */     // MIs[0] policy
     /* 1547352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547362 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1547365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547386 */     // GIR_Coverage, 18870,
     /* 1547386 */     GIR_EraseRootFromParent_Done,
     /* 1547387 */   // Label 21489: @1547387
     /* 1547387 */   GIM_Try, /*On fail goto*//*Label 21490*/ GIMT_Encode4(1547469), // Rule ID 18871 //
     /* 1547392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1547395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1547409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1547412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547431 */     // MIs[0] round
     /* 1547431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547434 */     // MIs[0] policy
     /* 1547434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547444 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1547447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547468 */     // GIR_Coverage, 18871,
     /* 1547468 */     GIR_EraseRootFromParent_Done,
     /* 1547469 */   // Label 21490: @1547469
     /* 1547469 */   GIM_Try, /*On fail goto*//*Label 21491*/ GIMT_Encode4(1547551), // Rule ID 18874 //
     /* 1547474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1547485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1547488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1547491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1547494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547513 */     // MIs[0] round
     /* 1547513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547516 */     // MIs[0] policy
     /* 1547516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547526 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1547529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547550 */     // GIR_Coverage, 18874,
     /* 1547550 */     GIR_EraseRootFromParent_Done,
     /* 1547551 */   // Label 21491: @1547551
     /* 1547551 */   GIM_Try, /*On fail goto*//*Label 21492*/ GIMT_Encode4(1547633), // Rule ID 18875 //
     /* 1547556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1547567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1547570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1547573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1547576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547595 */     // MIs[0] round
     /* 1547595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547598 */     // MIs[0] policy
     /* 1547598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547608 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1547611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547632 */     // GIR_Coverage, 18875,
     /* 1547632 */     GIR_EraseRootFromParent_Done,
     /* 1547633 */   // Label 21492: @1547633
     /* 1547633 */   GIM_Try, /*On fail goto*//*Label 21493*/ GIMT_Encode4(1547715), // Rule ID 18878 //
     /* 1547638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1547655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1547658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547677 */     // MIs[0] round
     /* 1547677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547680 */     // MIs[0] policy
     /* 1547680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547690 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1547693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547714 */     // GIR_Coverage, 18878,
     /* 1547714 */     GIR_EraseRootFromParent_Done,
     /* 1547715 */   // Label 21493: @1547715
     /* 1547715 */   GIM_Try, /*On fail goto*//*Label 21494*/ GIMT_Encode4(1547797), // Rule ID 18879 //
     /* 1547720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1547737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1547740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1547759 */     // MIs[0] round
     /* 1547759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547762 */     // MIs[0] policy
     /* 1547762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547772 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1547775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547796 */     // GIR_Coverage, 18879,
     /* 1547796 */     GIR_EraseRootFromParent_Done,
     /* 1547797 */   // Label 21494: @1547797
     /* 1547797 */   GIM_Try, /*On fail goto*//*Label 21495*/ GIMT_Encode4(1547879), // Rule ID 18882 //
     /* 1547802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1547819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1547822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547841 */     // MIs[0] round
     /* 1547841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547844 */     // MIs[0] policy
     /* 1547844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547854 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1547857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547878 */     // GIR_Coverage, 18882,
     /* 1547878 */     GIR_EraseRootFromParent_Done,
     /* 1547879 */   // Label 21495: @1547879
     /* 1547879 */   GIM_Try, /*On fail goto*//*Label 21496*/ GIMT_Encode4(1547961), // Rule ID 18883 //
     /* 1547884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1547887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1547901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1547904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547923 */     // MIs[0] round
     /* 1547923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547926 */     // MIs[0] policy
     /* 1547926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547936 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1547939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1547943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1547945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1547947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547960 */     // GIR_Coverage, 18883,
     /* 1547960 */     GIR_EraseRootFromParent_Done,
     /* 1547961 */   // Label 21496: @1547961
     /* 1547961 */   GIM_Try, /*On fail goto*//*Label 21497*/ GIMT_Encode4(1548043), // Rule ID 18886 //
     /* 1547966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1547969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1547974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1547977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1547980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1547983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1547986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548005 */     // MIs[0] round
     /* 1548005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548008 */     // MIs[0] policy
     /* 1548008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548018 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1548021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548042 */     // GIR_Coverage, 18886,
     /* 1548042 */     GIR_EraseRootFromParent_Done,
     /* 1548043 */   // Label 21497: @1548043
     /* 1548043 */   GIM_Try, /*On fail goto*//*Label 21498*/ GIMT_Encode4(1548125), // Rule ID 18887 //
     /* 1548048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1548051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1548065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1548068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548087 */     // MIs[0] round
     /* 1548087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548090 */     // MIs[0] policy
     /* 1548090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548100 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1548103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548124 */     // GIR_Coverage, 18887,
     /* 1548124 */     GIR_EraseRootFromParent_Done,
     /* 1548125 */   // Label 21498: @1548125
     /* 1548125 */   GIM_Try, /*On fail goto*//*Label 21499*/ GIMT_Encode4(1548207), // Rule ID 18890 //
     /* 1548130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548169 */     // MIs[0] round
     /* 1548169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548172 */     // MIs[0] policy
     /* 1548172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548182 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1548185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548206 */     // GIR_Coverage, 18890,
     /* 1548206 */     GIR_EraseRootFromParent_Done,
     /* 1548207 */   // Label 21499: @1548207
     /* 1548207 */   GIM_Try, /*On fail goto*//*Label 21500*/ GIMT_Encode4(1548289), // Rule ID 18891 //
     /* 1548212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1548232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548251 */     // MIs[0] round
     /* 1548251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548254 */     // MIs[0] policy
     /* 1548254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548264 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1548267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548288 */     // GIR_Coverage, 18891,
     /* 1548288 */     GIR_EraseRootFromParent_Done,
     /* 1548289 */   // Label 21500: @1548289
     /* 1548289 */   GIM_Try, /*On fail goto*//*Label 21501*/ GIMT_Encode4(1548371), // Rule ID 18894 //
     /* 1548294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548333 */     // MIs[0] round
     /* 1548333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548336 */     // MIs[0] policy
     /* 1548336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548346 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1548349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548370 */     // GIR_Coverage, 18894,
     /* 1548370 */     GIR_EraseRootFromParent_Done,
     /* 1548371 */   // Label 21501: @1548371
     /* 1548371 */   GIM_Try, /*On fail goto*//*Label 21502*/ GIMT_Encode4(1548453), // Rule ID 18895 //
     /* 1548376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1548396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548415 */     // MIs[0] round
     /* 1548415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548418 */     // MIs[0] policy
     /* 1548418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548428 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11303:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1548431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548452 */     // GIR_Coverage, 18895,
     /* 1548452 */     GIR_EraseRootFromParent_Done,
     /* 1548453 */   // Label 21502: @1548453
     /* 1548453 */   GIM_Try, /*On fail goto*//*Label 21503*/ GIMT_Encode4(1548535), // Rule ID 18898 //
     /* 1548458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1548469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1548472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1548478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548497 */     // MIs[0] round
     /* 1548497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548500 */     // MIs[0] policy
     /* 1548500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548510 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1548513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548534 */     // GIR_Coverage, 18898,
     /* 1548534 */     GIR_EraseRootFromParent_Done,
     /* 1548535 */   // Label 21503: @1548535
     /* 1548535 */   GIM_Try, /*On fail goto*//*Label 21504*/ GIMT_Encode4(1548617), // Rule ID 18899 //
     /* 1548540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1548551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1548554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1548560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548579 */     // MIs[0] round
     /* 1548579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548582 */     // MIs[0] policy
     /* 1548582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548592 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1548595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548616 */     // GIR_Coverage, 18899,
     /* 1548616 */     GIR_EraseRootFromParent_Done,
     /* 1548617 */   // Label 21504: @1548617
     /* 1548617 */   GIM_Try, /*On fail goto*//*Label 21505*/ GIMT_Encode4(1548699), // Rule ID 18902 //
     /* 1548622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1548633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1548636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1548642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548661 */     // MIs[0] round
     /* 1548661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548664 */     // MIs[0] policy
     /* 1548664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548674 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1548677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548698 */     // GIR_Coverage, 18902,
     /* 1548698 */     GIR_EraseRootFromParent_Done,
     /* 1548699 */   // Label 21505: @1548699
     /* 1548699 */   GIM_Try, /*On fail goto*//*Label 21506*/ GIMT_Encode4(1548781), // Rule ID 18903 //
     /* 1548704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1548715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1548718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1548724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1548743 */     // MIs[0] round
     /* 1548743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548746 */     // MIs[0] policy
     /* 1548746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548756 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1548759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548780 */     // GIR_Coverage, 18903,
     /* 1548780 */     GIR_EraseRootFromParent_Done,
     /* 1548781 */   // Label 21506: @1548781
     /* 1548781 */   GIM_Try, /*On fail goto*//*Label 21507*/ GIMT_Encode4(1548863), // Rule ID 18906 //
     /* 1548786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1548789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1548797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1548800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1548806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548825 */     // MIs[0] round
     /* 1548825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548828 */     // MIs[0] policy
     /* 1548828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548838 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1548841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548862 */     // GIR_Coverage, 18906,
     /* 1548862 */     GIR_EraseRootFromParent_Done,
     /* 1548863 */   // Label 21507: @1548863
     /* 1548863 */   GIM_Try, /*On fail goto*//*Label 21508*/ GIMT_Encode4(1548945), // Rule ID 18907 //
     /* 1548868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1548871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1548879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1548882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1548885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1548888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1548903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548907 */     // MIs[0] round
     /* 1548907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548910 */     // MIs[0] policy
     /* 1548910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548920 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1548923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1548927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1548929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1548931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548944 */     // GIR_Coverage, 18907,
     /* 1548944 */     GIR_EraseRootFromParent_Done,
     /* 1548945 */   // Label 21508: @1548945
     /* 1548945 */   GIM_Try, /*On fail goto*//*Label 21509*/ GIMT_Encode4(1549027), // Rule ID 18910 //
     /* 1548950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1548953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1548958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1548961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1548964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1548967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1548970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1548985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548989 */     // MIs[0] round
     /* 1548989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548992 */     // MIs[0] policy
     /* 1548992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549002 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1549005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549026 */     // GIR_Coverage, 18910,
     /* 1549026 */     GIR_EraseRootFromParent_Done,
     /* 1549027 */   // Label 21509: @1549027
     /* 1549027 */   GIM_Try, /*On fail goto*//*Label 21510*/ GIMT_Encode4(1549109), // Rule ID 18911 //
     /* 1549032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1549052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549071 */     // MIs[0] round
     /* 1549071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549074 */     // MIs[0] policy
     /* 1549074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549084 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11303:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1549087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549108 */     // GIR_Coverage, 18911,
     /* 1549108 */     GIR_EraseRootFromParent_Done,
     /* 1549109 */   // Label 21510: @1549109
     /* 1549109 */   GIM_Try, /*On fail goto*//*Label 21511*/ GIMT_Encode4(1549191), // Rule ID 18914 //
     /* 1549114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549153 */     // MIs[0] round
     /* 1549153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549156 */     // MIs[0] policy
     /* 1549156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549166 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1549169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549190 */     // GIR_Coverage, 18914,
     /* 1549190 */     GIR_EraseRootFromParent_Done,
     /* 1549191 */   // Label 21511: @1549191
     /* 1549191 */   GIM_Try, /*On fail goto*//*Label 21512*/ GIMT_Encode4(1549273), // Rule ID 18915 //
     /* 1549196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1549207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1549210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1549216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549235 */     // MIs[0] round
     /* 1549235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549238 */     // MIs[0] policy
     /* 1549238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549248 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11303:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1549251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549272 */     // GIR_Coverage, 18915,
     /* 1549272 */     GIR_EraseRootFromParent_Done,
     /* 1549273 */   // Label 21512: @1549273
     /* 1549273 */   GIM_Try, /*On fail goto*//*Label 21513*/ GIMT_Encode4(1549355), // Rule ID 18918 //
     /* 1549278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549317 */     // MIs[0] round
     /* 1549317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549320 */     // MIs[0] policy
     /* 1549320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549330 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1549333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549354 */     // GIR_Coverage, 18918,
     /* 1549354 */     GIR_EraseRootFromParent_Done,
     /* 1549355 */   // Label 21513: @1549355
     /* 1549355 */   GIM_Try, /*On fail goto*//*Label 21514*/ GIMT_Encode4(1549437), // Rule ID 18919 //
     /* 1549360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1549371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1549374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1549380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549399 */     // MIs[0] round
     /* 1549399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549402 */     // MIs[0] policy
     /* 1549402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549412 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11303:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1549415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549436 */     // GIR_Coverage, 18919,
     /* 1549436 */     GIR_EraseRootFromParent_Done,
     /* 1549437 */   // Label 21514: @1549437
     /* 1549437 */   GIM_Try, /*On fail goto*//*Label 21515*/ GIMT_Encode4(1549519), // Rule ID 18922 //
     /* 1549442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1549445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1549453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1549456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1549462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549481 */     // MIs[0] round
     /* 1549481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549484 */     // MIs[0] policy
     /* 1549484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549494 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1549497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549518 */     // GIR_Coverage, 18922,
     /* 1549518 */     GIR_EraseRootFromParent_Done,
     /* 1549519 */   // Label 21515: @1549519
     /* 1549519 */   GIM_Try, /*On fail goto*//*Label 21516*/ GIMT_Encode4(1549601), // Rule ID 18923 //
     /* 1549524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1549527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1549532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1549535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1549538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1549541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1549544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1549559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549563 */     // MIs[0] round
     /* 1549563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549566 */     // MIs[0] policy
     /* 1549566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549576 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11303:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1549579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549600 */     // GIR_Coverage, 18923,
     /* 1549600 */     GIR_EraseRootFromParent_Done,
     /* 1549601 */   // Label 21516: @1549601
     /* 1549601 */   GIM_Try, /*On fail goto*//*Label 21517*/ GIMT_Encode4(1549683), // Rule ID 18926 //
     /* 1549606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1549617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1549620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1549623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1549626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549645 */     // MIs[0] round
     /* 1549645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549648 */     // MIs[0] policy
     /* 1549648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549658 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1549661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549682 */     // GIR_Coverage, 18926,
     /* 1549682 */     GIR_EraseRootFromParent_Done,
     /* 1549683 */   // Label 21517: @1549683
     /* 1549683 */   GIM_Try, /*On fail goto*//*Label 21518*/ GIMT_Encode4(1549765), // Rule ID 18927 //
     /* 1549688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1549699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1549702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1549705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1549708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549727 */     // MIs[0] round
     /* 1549727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549730 */     // MIs[0] policy
     /* 1549730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549740 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1549743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549764 */     // GIR_Coverage, 18927,
     /* 1549764 */     GIR_EraseRootFromParent_Done,
     /* 1549765 */   // Label 21518: @1549765
     /* 1549765 */   GIM_Try, /*On fail goto*//*Label 21519*/ GIMT_Encode4(1549847), // Rule ID 18930 //
     /* 1549770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1549781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1549784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1549787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1549790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549809 */     // MIs[0] round
     /* 1549809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549812 */     // MIs[0] policy
     /* 1549812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549822 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1549825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549846 */     // GIR_Coverage, 18930,
     /* 1549846 */     GIR_EraseRootFromParent_Done,
     /* 1549847 */   // Label 21519: @1549847
     /* 1549847 */   GIM_Try, /*On fail goto*//*Label 21520*/ GIMT_Encode4(1549929), // Rule ID 18931 //
     /* 1549852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1549855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1549863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1549866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1549869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1549872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549891 */     // MIs[0] round
     /* 1549891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549894 */     // MIs[0] policy
     /* 1549894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549904 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1549907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549928 */     // GIR_Coverage, 18931,
     /* 1549928 */     GIR_EraseRootFromParent_Done,
     /* 1549929 */   // Label 21520: @1549929
     /* 1549929 */   GIM_Try, /*On fail goto*//*Label 21521*/ GIMT_Encode4(1550011), // Rule ID 18934 //
     /* 1549934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1549937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1549942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1549951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1549954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549973 */     // MIs[0] round
     /* 1549973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549976 */     // MIs[0] policy
     /* 1549976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549986 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1549989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1549993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1549995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1549997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550010 */     // GIR_Coverage, 18934,
     /* 1550010 */     GIR_EraseRootFromParent_Done,
     /* 1550011 */   // Label 21521: @1550011
     /* 1550011 */   GIM_Try, /*On fail goto*//*Label 21522*/ GIMT_Encode4(1550093), // Rule ID 18935 //
     /* 1550016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1550027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1550030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1550033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1550036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550055 */     // MIs[0] round
     /* 1550055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550058 */     // MIs[0] policy
     /* 1550058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550068 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1550071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550092 */     // GIR_Coverage, 18935,
     /* 1550092 */     GIR_EraseRootFromParent_Done,
     /* 1550093 */   // Label 21522: @1550093
     /* 1550093 */   GIM_Try, /*On fail goto*//*Label 21523*/ GIMT_Encode4(1550175), // Rule ID 18938 //
     /* 1550098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1550109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1550112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1550118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550137 */     // MIs[0] round
     /* 1550137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550140 */     // MIs[0] policy
     /* 1550140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550150 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1550153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550174 */     // GIR_Coverage, 18938,
     /* 1550174 */     GIR_EraseRootFromParent_Done,
     /* 1550175 */   // Label 21523: @1550175
     /* 1550175 */   GIM_Try, /*On fail goto*//*Label 21524*/ GIMT_Encode4(1550257), // Rule ID 18939 //
     /* 1550180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1550191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1550194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1550197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1550200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550219 */     // MIs[0] round
     /* 1550219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550222 */     // MIs[0] policy
     /* 1550222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550232 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1550235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550256 */     // GIR_Coverage, 18939,
     /* 1550256 */     GIR_EraseRootFromParent_Done,
     /* 1550257 */   // Label 21524: @1550257
     /* 1550257 */   GIM_Try, /*On fail goto*//*Label 21525*/ GIMT_Encode4(1550339), // Rule ID 18942 //
     /* 1550262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1550265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1550279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1550282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550301 */     // MIs[0] round
     /* 1550301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550304 */     // MIs[0] policy
     /* 1550304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550314 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1550317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550338 */     // GIR_Coverage, 18942,
     /* 1550338 */     GIR_EraseRootFromParent_Done,
     /* 1550339 */   // Label 21525: @1550339
     /* 1550339 */   GIM_Try, /*On fail goto*//*Label 21526*/ GIMT_Encode4(1550421), // Rule ID 18943 //
     /* 1550344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1550347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1550361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1550364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550383 */     // MIs[0] round
     /* 1550383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550386 */     // MIs[0] policy
     /* 1550386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550396 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1550399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550420 */     // GIR_Coverage, 18943,
     /* 1550420 */     GIR_EraseRootFromParent_Done,
     /* 1550421 */   // Label 21526: @1550421
     /* 1550421 */   GIM_Try, /*On fail goto*//*Label 21527*/ GIMT_Encode4(1550503), // Rule ID 18946 //
     /* 1550426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1550437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1550440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1550446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550465 */     // MIs[0] round
     /* 1550465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550468 */     // MIs[0] policy
     /* 1550468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550478 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1550481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550502 */     // GIR_Coverage, 18946,
     /* 1550502 */     GIR_EraseRootFromParent_Done,
     /* 1550503 */   // Label 21527: @1550503
     /* 1550503 */   GIM_Try, /*On fail goto*//*Label 21528*/ GIMT_Encode4(1550585), // Rule ID 18947 //
     /* 1550508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1550519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1550522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1550528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550547 */     // MIs[0] round
     /* 1550547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550550 */     // MIs[0] policy
     /* 1550550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550560 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1550563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550584 */     // GIR_Coverage, 18947,
     /* 1550584 */     GIR_EraseRootFromParent_Done,
     /* 1550585 */   // Label 21528: @1550585
     /* 1550585 */   GIM_Try, /*On fail goto*//*Label 21529*/ GIMT_Encode4(1550667), // Rule ID 18950 //
     /* 1550590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1550601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1550604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1550607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1550610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550629 */     // MIs[0] round
     /* 1550629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550632 */     // MIs[0] policy
     /* 1550632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550642 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1550645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550666 */     // GIR_Coverage, 18950,
     /* 1550666 */     GIR_EraseRootFromParent_Done,
     /* 1550667 */   // Label 21529: @1550667
     /* 1550667 */   GIM_Try, /*On fail goto*//*Label 21530*/ GIMT_Encode4(1550749), // Rule ID 18951 //
     /* 1550672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1550683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1550686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1550689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1550692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550711 */     // MIs[0] round
     /* 1550711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550714 */     // MIs[0] policy
     /* 1550714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550724 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1550727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550748 */     // GIR_Coverage, 18951,
     /* 1550748 */     GIR_EraseRootFromParent_Done,
     /* 1550749 */   // Label 21530: @1550749
     /* 1550749 */   GIM_Try, /*On fail goto*//*Label 21531*/ GIMT_Encode4(1550831), // Rule ID 18954 //
     /* 1550754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1550771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1550774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550793 */     // MIs[0] round
     /* 1550793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550796 */     // MIs[0] policy
     /* 1550796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550806 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1550809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550830 */     // GIR_Coverage, 18954,
     /* 1550830 */     GIR_EraseRootFromParent_Done,
     /* 1550831 */   // Label 21531: @1550831
     /* 1550831 */   GIM_Try, /*On fail goto*//*Label 21532*/ GIMT_Encode4(1550913), // Rule ID 18955 //
     /* 1550836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1550839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1550853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1550856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550875 */     // MIs[0] round
     /* 1550875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550878 */     // MIs[0] policy
     /* 1550878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550888 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1550891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550912 */     // GIR_Coverage, 18955,
     /* 1550912 */     GIR_EraseRootFromParent_Done,
     /* 1550913 */   // Label 21532: @1550913
     /* 1550913 */   GIM_Try, /*On fail goto*//*Label 21533*/ GIMT_Encode4(1550995), // Rule ID 18958 //
     /* 1550918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1550921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1550926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1550935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1550938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550957 */     // MIs[0] round
     /* 1550957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550960 */     // MIs[0] policy
     /* 1550960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550970 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1550973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1550977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1550979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1550981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550994 */     // GIR_Coverage, 18958,
     /* 1550994 */     GIR_EraseRootFromParent_Done,
     /* 1550995 */   // Label 21533: @1550995
     /* 1550995 */   GIM_Try, /*On fail goto*//*Label 21534*/ GIMT_Encode4(1551077), // Rule ID 18959 //
     /* 1551000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1551011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1551014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1551017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1551020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551039 */     // MIs[0] round
     /* 1551039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551042 */     // MIs[0] policy
     /* 1551042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551052 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1551055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551076 */     // GIR_Coverage, 18959,
     /* 1551076 */     GIR_EraseRootFromParent_Done,
     /* 1551077 */   // Label 21534: @1551077
     /* 1551077 */   GIM_Try, /*On fail goto*//*Label 21535*/ GIMT_Encode4(1551159), // Rule ID 18962 //
     /* 1551082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1551102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551121 */     // MIs[0] round
     /* 1551121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551124 */     // MIs[0] policy
     /* 1551124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551134 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1551137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551158 */     // GIR_Coverage, 18962,
     /* 1551158 */     GIR_EraseRootFromParent_Done,
     /* 1551159 */   // Label 21535: @1551159
     /* 1551159 */   GIM_Try, /*On fail goto*//*Label 21536*/ GIMT_Encode4(1551241), // Rule ID 18963 //
     /* 1551164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1551175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1551178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1551184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551203 */     // MIs[0] round
     /* 1551203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551206 */     // MIs[0] policy
     /* 1551206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551216 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1551219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551240 */     // GIR_Coverage, 18963,
     /* 1551240 */     GIR_EraseRootFromParent_Done,
     /* 1551241 */   // Label 21536: @1551241
     /* 1551241 */   GIM_Try, /*On fail goto*//*Label 21537*/ GIMT_Encode4(1551323), // Rule ID 18966 //
     /* 1551246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1551266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551285 */     // MIs[0] round
     /* 1551285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551288 */     // MIs[0] policy
     /* 1551288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551298 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1551301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551322 */     // GIR_Coverage, 18966,
     /* 1551322 */     GIR_EraseRootFromParent_Done,
     /* 1551323 */   // Label 21537: @1551323
     /* 1551323 */   GIM_Try, /*On fail goto*//*Label 21538*/ GIMT_Encode4(1551405), // Rule ID 18967 //
     /* 1551328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1551348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551367 */     // MIs[0] round
     /* 1551367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551370 */     // MIs[0] policy
     /* 1551370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551380 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11309:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1551383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551404 */     // GIR_Coverage, 18967,
     /* 1551404 */     GIR_EraseRootFromParent_Done,
     /* 1551405 */   // Label 21538: @1551405
     /* 1551405 */   GIM_Try, /*On fail goto*//*Label 21539*/ GIMT_Encode4(1551487), // Rule ID 18970 //
     /* 1551410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1551430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551449 */     // MIs[0] round
     /* 1551449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551452 */     // MIs[0] policy
     /* 1551452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551462 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1551465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551486 */     // GIR_Coverage, 18970,
     /* 1551486 */     GIR_EraseRootFromParent_Done,
     /* 1551487 */   // Label 21539: @1551487
     /* 1551487 */   GIM_Try, /*On fail goto*//*Label 21540*/ GIMT_Encode4(1551569), // Rule ID 18971 //
     /* 1551492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1551503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1551506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1551512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551531 */     // MIs[0] round
     /* 1551531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551534 */     // MIs[0] policy
     /* 1551534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1551547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551568 */     // GIR_Coverage, 18971,
     /* 1551568 */     GIR_EraseRootFromParent_Done,
     /* 1551569 */   // Label 21540: @1551569
     /* 1551569 */   GIM_Try, /*On fail goto*//*Label 21541*/ GIMT_Encode4(1551651), // Rule ID 18974 //
     /* 1551574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1551594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551613 */     // MIs[0] round
     /* 1551613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551616 */     // MIs[0] policy
     /* 1551616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551626 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1551629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551650 */     // GIR_Coverage, 18974,
     /* 1551650 */     GIR_EraseRootFromParent_Done,
     /* 1551651 */   // Label 21541: @1551651
     /* 1551651 */   GIM_Try, /*On fail goto*//*Label 21542*/ GIMT_Encode4(1551733), // Rule ID 18975 //
     /* 1551656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1551667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1551670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1551676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551695 */     // MIs[0] round
     /* 1551695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551698 */     // MIs[0] policy
     /* 1551698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551708 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1551711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551732 */     // GIR_Coverage, 18975,
     /* 1551732 */     GIR_EraseRootFromParent_Done,
     /* 1551733 */   // Label 21542: @1551733
     /* 1551733 */   GIM_Try, /*On fail goto*//*Label 21543*/ GIMT_Encode4(1551815), // Rule ID 18978 //
     /* 1551738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1551741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1551749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1551752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1551758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551777 */     // MIs[0] round
     /* 1551777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551780 */     // MIs[0] policy
     /* 1551780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551790 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1551793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551814 */     // GIR_Coverage, 18978,
     /* 1551814 */     GIR_EraseRootFromParent_Done,
     /* 1551815 */   // Label 21543: @1551815
     /* 1551815 */   GIM_Try, /*On fail goto*//*Label 21544*/ GIMT_Encode4(1551897), // Rule ID 18979 //
     /* 1551820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1551823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1551831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1551834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1551837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1551840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1551855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551859 */     // MIs[0] round
     /* 1551859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551862 */     // MIs[0] policy
     /* 1551862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551872 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1551875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551896 */     // GIR_Coverage, 18979,
     /* 1551896 */     GIR_EraseRootFromParent_Done,
     /* 1551897 */   // Label 21544: @1551897
     /* 1551897 */   GIM_Try, /*On fail goto*//*Label 21545*/ GIMT_Encode4(1551979), // Rule ID 18982 //
     /* 1551902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1551905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1551913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1551916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1551919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1551922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1551937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551941 */     // MIs[0] round
     /* 1551941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551944 */     // MIs[0] policy
     /* 1551944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551954 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1551957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1551961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1551963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1551965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551978 */     // GIR_Coverage, 18982,
     /* 1551978 */     GIR_EraseRootFromParent_Done,
     /* 1551979 */   // Label 21545: @1551979
     /* 1551979 */   GIM_Try, /*On fail goto*//*Label 21546*/ GIMT_Encode4(1552061), // Rule ID 18983 //
     /* 1551984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1551987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1551992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1551995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1551998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1552004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552023 */     // MIs[0] round
     /* 1552023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552026 */     // MIs[0] policy
     /* 1552026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11309:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1552039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552060 */     // GIR_Coverage, 18983,
     /* 1552060 */     GIR_EraseRootFromParent_Done,
     /* 1552061 */   // Label 21546: @1552061
     /* 1552061 */   GIM_Try, /*On fail goto*//*Label 21547*/ GIMT_Encode4(1552143), // Rule ID 18986 //
     /* 1552066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1552086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552105 */     // MIs[0] round
     /* 1552105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552108 */     // MIs[0] policy
     /* 1552108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552118 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1552121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552142 */     // GIR_Coverage, 18986,
     /* 1552142 */     GIR_EraseRootFromParent_Done,
     /* 1552143 */   // Label 21547: @1552143
     /* 1552143 */   GIM_Try, /*On fail goto*//*Label 21548*/ GIMT_Encode4(1552225), // Rule ID 18987 //
     /* 1552148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1552168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552187 */     // MIs[0] round
     /* 1552187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552190 */     // MIs[0] policy
     /* 1552190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552200 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11309:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1552203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552224 */     // GIR_Coverage, 18987,
     /* 1552224 */     GIR_EraseRootFromParent_Done,
     /* 1552225 */   // Label 21548: @1552225
     /* 1552225 */   GIM_Try, /*On fail goto*//*Label 21549*/ GIMT_Encode4(1552307), // Rule ID 18990 //
     /* 1552230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1552250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552269 */     // MIs[0] round
     /* 1552269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552272 */     // MIs[0] policy
     /* 1552272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552282 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1552285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552306 */     // GIR_Coverage, 18990,
     /* 1552306 */     GIR_EraseRootFromParent_Done,
     /* 1552307 */   // Label 21549: @1552307
     /* 1552307 */   GIM_Try, /*On fail goto*//*Label 21550*/ GIMT_Encode4(1552389), // Rule ID 18991 //
     /* 1552312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1552332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552351 */     // MIs[0] round
     /* 1552351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552354 */     // MIs[0] policy
     /* 1552354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552364 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11309:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1552367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552388 */     // GIR_Coverage, 18991,
     /* 1552388 */     GIR_EraseRootFromParent_Done,
     /* 1552389 */   // Label 21550: @1552389
     /* 1552389 */   GIM_Try, /*On fail goto*//*Label 21551*/ GIMT_Encode4(1552471), // Rule ID 18994 //
     /* 1552394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1552397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1552414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552433 */     // MIs[0] round
     /* 1552433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552436 */     // MIs[0] policy
     /* 1552436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552446 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1552449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552470 */     // GIR_Coverage, 18994,
     /* 1552470 */     GIR_EraseRootFromParent_Done,
     /* 1552471 */   // Label 21551: @1552471
     /* 1552471 */   GIM_Try, /*On fail goto*//*Label 21552*/ GIMT_Encode4(1552553), // Rule ID 18995 //
     /* 1552476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1552479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1552484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1552493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1552496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1552511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552515 */     // MIs[0] round
     /* 1552515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552518 */     // MIs[0] policy
     /* 1552518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552528 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11309:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1552531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1552535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1552537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1552539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552552 */     // GIR_Coverage, 18995,
     /* 1552552 */     GIR_EraseRootFromParent_Done,
     /* 1552553 */   // Label 21552: @1552553
     /* 1552553 */   GIM_Try, /*On fail goto*//*Label 21553*/ GIMT_Encode4(1552635), // Rule ID 19000 //
     /* 1552558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1552561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1552569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1552572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1552575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552597 */     // MIs[0] round
     /* 1552597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552600 */     // MIs[0] policy
     /* 1552600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552610 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1552613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552634 */     // GIR_Coverage, 19000,
     /* 1552634 */     GIR_EraseRootFromParent_Done,
     /* 1552635 */   // Label 21553: @1552635
     /* 1552635 */   GIM_Try, /*On fail goto*//*Label 21554*/ GIMT_Encode4(1552717), // Rule ID 19001 //
     /* 1552640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1552643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1552651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1552654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1552657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552679 */     // MIs[0] round
     /* 1552679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552682 */     // MIs[0] policy
     /* 1552682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552692 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1552695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552716 */     // GIR_Coverage, 19001,
     /* 1552716 */     GIR_EraseRootFromParent_Done,
     /* 1552717 */   // Label 21554: @1552717
     /* 1552717 */   GIM_Try, /*On fail goto*//*Label 21555*/ GIMT_Encode4(1552799), // Rule ID 19004 //
     /* 1552722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1552725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1552733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1552736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1552739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1552742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552761 */     // MIs[0] round
     /* 1552761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552764 */     // MIs[0] policy
     /* 1552764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552774 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1552777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552798 */     // GIR_Coverage, 19004,
     /* 1552798 */     GIR_EraseRootFromParent_Done,
     /* 1552799 */   // Label 21555: @1552799
     /* 1552799 */   GIM_Try, /*On fail goto*//*Label 21556*/ GIMT_Encode4(1552881), // Rule ID 19005 //
     /* 1552804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1552807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1552815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1552818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1552821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1552824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552843 */     // MIs[0] round
     /* 1552843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552846 */     // MIs[0] policy
     /* 1552846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552856 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1552859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552880 */     // GIR_Coverage, 19005,
     /* 1552880 */     GIR_EraseRootFromParent_Done,
     /* 1552881 */   // Label 21556: @1552881
     /* 1552881 */   GIM_Try, /*On fail goto*//*Label 21557*/ GIMT_Encode4(1552963), // Rule ID 19008 //
     /* 1552886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1552889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1552897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1552900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1552903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1552906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552925 */     // MIs[0] round
     /* 1552925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552928 */     // MIs[0] policy
     /* 1552928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552938 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1552941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552962 */     // GIR_Coverage, 19008,
     /* 1552962 */     GIR_EraseRootFromParent_Done,
     /* 1552963 */   // Label 21557: @1552963
     /* 1552963 */   GIM_Try, /*On fail goto*//*Label 21558*/ GIMT_Encode4(1553045), // Rule ID 19009 //
     /* 1552968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1552971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1552976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1552979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1552982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1552985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1552988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1552995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1552999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553007 */     // MIs[0] round
     /* 1553007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553010 */     // MIs[0] policy
     /* 1553010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553020 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11276:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1553023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553044 */     // GIR_Coverage, 19009,
     /* 1553044 */     GIR_EraseRootFromParent_Done,
     /* 1553045 */   // Label 21558: @1553045
     /* 1553045 */   GIM_Try, /*On fail goto*//*Label 21559*/ GIMT_Encode4(1553127), // Rule ID 19012 //
     /* 1553050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1553053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553089 */     // MIs[0] round
     /* 1553089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553092 */     // MIs[0] policy
     /* 1553092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1553105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553126 */     // GIR_Coverage, 19012,
     /* 1553126 */     GIR_EraseRootFromParent_Done,
     /* 1553127 */   // Label 21559: @1553127
     /* 1553127 */   GIM_Try, /*On fail goto*//*Label 21560*/ GIMT_Encode4(1553209), // Rule ID 19013 //
     /* 1553132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553171 */     // MIs[0] round
     /* 1553171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553174 */     // MIs[0] policy
     /* 1553174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11276:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1553187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553208 */     // GIR_Coverage, 19013,
     /* 1553208 */     GIR_EraseRootFromParent_Done,
     /* 1553209 */   // Label 21560: @1553209
     /* 1553209 */   GIM_Try, /*On fail goto*//*Label 21561*/ GIMT_Encode4(1553291), // Rule ID 19016 //
     /* 1553214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1553217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553253 */     // MIs[0] round
     /* 1553253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553256 */     // MIs[0] policy
     /* 1553256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553266 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1553269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553290 */     // GIR_Coverage, 19016,
     /* 1553290 */     GIR_EraseRootFromParent_Done,
     /* 1553291 */   // Label 21561: @1553291
     /* 1553291 */   GIM_Try, /*On fail goto*//*Label 21562*/ GIMT_Encode4(1553373), // Rule ID 19017 //
     /* 1553296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1553299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553335 */     // MIs[0] round
     /* 1553335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553338 */     // MIs[0] policy
     /* 1553338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553348 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11276:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1553351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553372 */     // GIR_Coverage, 19017,
     /* 1553372 */     GIR_EraseRootFromParent_Done,
     /* 1553373 */   // Label 21562: @1553373
     /* 1553373 */   GIM_Try, /*On fail goto*//*Label 21563*/ GIMT_Encode4(1553455), // Rule ID 19020 //
     /* 1553378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553417 */     // MIs[0] round
     /* 1553417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553420 */     // MIs[0] policy
     /* 1553420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553430 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1553433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553454 */     // GIR_Coverage, 19020,
     /* 1553454 */     GIR_EraseRootFromParent_Done,
     /* 1553455 */   // Label 21563: @1553455
     /* 1553455 */   GIM_Try, /*On fail goto*//*Label 21564*/ GIMT_Encode4(1553537), // Rule ID 19021 //
     /* 1553460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1553471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1553474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1553477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1553480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553499 */     // MIs[0] round
     /* 1553499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553502 */     // MIs[0] policy
     /* 1553502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553512 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1553515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553536 */     // GIR_Coverage, 19021,
     /* 1553536 */     GIR_EraseRootFromParent_Done,
     /* 1553537 */   // Label 21564: @1553537
     /* 1553537 */   GIM_Try, /*On fail goto*//*Label 21565*/ GIMT_Encode4(1553619), // Rule ID 19024 //
     /* 1553542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1553553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1553556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1553559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1553562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1553569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553581 */     // MIs[0] round
     /* 1553581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553584 */     // MIs[0] policy
     /* 1553584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553594 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1553597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553618 */     // GIR_Coverage, 19024,
     /* 1553618 */     GIR_EraseRootFromParent_Done,
     /* 1553619 */   // Label 21565: @1553619
     /* 1553619 */   GIM_Try, /*On fail goto*//*Label 21566*/ GIMT_Encode4(1553701), // Rule ID 19025 //
     /* 1553624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1553635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1553638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1553641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1553644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1553651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1553659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553663 */     // MIs[0] round
     /* 1553663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553666 */     // MIs[0] policy
     /* 1553666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553676 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1553679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553685 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553700 */     // GIR_Coverage, 19025,
     /* 1553700 */     GIR_EraseRootFromParent_Done,
     /* 1553701 */   // Label 21566: @1553701
     /* 1553701 */   GIM_Try, /*On fail goto*//*Label 21567*/ GIMT_Encode4(1553783), // Rule ID 19028 //
     /* 1553706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1553709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1553717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1553720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1553723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1553726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1553733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553745 */     // MIs[0] round
     /* 1553745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553748 */     // MIs[0] policy
     /* 1553748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553758 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1553761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553782 */     // GIR_Coverage, 19028,
     /* 1553782 */     GIR_EraseRootFromParent_Done,
     /* 1553783 */   // Label 21567: @1553783
     /* 1553783 */   GIM_Try, /*On fail goto*//*Label 21568*/ GIMT_Encode4(1553865), // Rule ID 19029 //
     /* 1553788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1553791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1553799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1553802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1553805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1553808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1553815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1553823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553827 */     // MIs[0] round
     /* 1553827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553830 */     // MIs[0] policy
     /* 1553830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553840 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1553843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553864 */     // GIR_Coverage, 19029,
     /* 1553864 */     GIR_EraseRootFromParent_Done,
     /* 1553865 */   // Label 21568: @1553865
     /* 1553865 */   GIM_Try, /*On fail goto*//*Label 21569*/ GIMT_Encode4(1553947), // Rule ID 19032 //
     /* 1553870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1553873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1553881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1553884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1553887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553909 */     // MIs[0] round
     /* 1553909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553912 */     // MIs[0] policy
     /* 1553912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553922 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1553925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553946 */     // GIR_Coverage, 19032,
     /* 1553946 */     GIR_EraseRootFromParent_Done,
     /* 1553947 */   // Label 21569: @1553947
     /* 1553947 */   GIM_Try, /*On fail goto*//*Label 21570*/ GIMT_Encode4(1554029), // Rule ID 19033 //
     /* 1553952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1553955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1553960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1553963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1553966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1553969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1553979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1553987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553991 */     // MIs[0] round
     /* 1553991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553994 */     // MIs[0] policy
     /* 1553994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554004 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1554007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554028 */     // GIR_Coverage, 19033,
     /* 1554028 */     GIR_EraseRootFromParent_Done,
     /* 1554029 */   // Label 21570: @1554029
     /* 1554029 */   GIM_Try, /*On fail goto*//*Label 21571*/ GIMT_Encode4(1554111), // Rule ID 19036 //
     /* 1554034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554073 */     // MIs[0] round
     /* 1554073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554076 */     // MIs[0] policy
     /* 1554076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554086 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1554089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554110 */     // GIR_Coverage, 19036,
     /* 1554110 */     GIR_EraseRootFromParent_Done,
     /* 1554111 */   // Label 21571: @1554111
     /* 1554111 */   GIM_Try, /*On fail goto*//*Label 21572*/ GIMT_Encode4(1554193), // Rule ID 19037 //
     /* 1554116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554155 */     // MIs[0] round
     /* 1554155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554158 */     // MIs[0] policy
     /* 1554158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554168 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1554171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554192 */     // GIR_Coverage, 19037,
     /* 1554192 */     GIR_EraseRootFromParent_Done,
     /* 1554193 */   // Label 21572: @1554193
     /* 1554193 */   GIM_Try, /*On fail goto*//*Label 21573*/ GIMT_Encode4(1554275), // Rule ID 19040 //
     /* 1554198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1554201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554237 */     // MIs[0] round
     /* 1554237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554240 */     // MIs[0] policy
     /* 1554240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554250 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1554253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554274 */     // GIR_Coverage, 19040,
     /* 1554274 */     GIR_EraseRootFromParent_Done,
     /* 1554275 */   // Label 21573: @1554275
     /* 1554275 */   GIM_Try, /*On fail goto*//*Label 21574*/ GIMT_Encode4(1554357), // Rule ID 19041 //
     /* 1554280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1554283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554319 */     // MIs[0] round
     /* 1554319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554322 */     // MIs[0] policy
     /* 1554322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554332 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1554335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554341 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554356 */     // GIR_Coverage, 19041,
     /* 1554356 */     GIR_EraseRootFromParent_Done,
     /* 1554357 */   // Label 21574: @1554357
     /* 1554357 */   GIM_Try, /*On fail goto*//*Label 21575*/ GIMT_Encode4(1554439), // Rule ID 19044 //
     /* 1554362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554401 */     // MIs[0] round
     /* 1554401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554404 */     // MIs[0] policy
     /* 1554404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554414 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1554417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554438 */     // GIR_Coverage, 19044,
     /* 1554438 */     GIR_EraseRootFromParent_Done,
     /* 1554439 */   // Label 21575: @1554439
     /* 1554439 */   GIM_Try, /*On fail goto*//*Label 21576*/ GIMT_Encode4(1554521), // Rule ID 19045 //
     /* 1554444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1554455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1554458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1554461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1554464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554483 */     // MIs[0] round
     /* 1554483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554486 */     // MIs[0] policy
     /* 1554486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554496 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11276:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1554499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554520 */     // GIR_Coverage, 19045,
     /* 1554520 */     GIR_EraseRootFromParent_Done,
     /* 1554521 */   // Label 21576: @1554521
     /* 1554521 */   GIM_Try, /*On fail goto*//*Label 21577*/ GIMT_Encode4(1554603), // Rule ID 19048 //
     /* 1554526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1554537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1554540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1554543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554565 */     // MIs[0] round
     /* 1554565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554568 */     // MIs[0] policy
     /* 1554568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554578 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1554581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554602 */     // GIR_Coverage, 19048,
     /* 1554602 */     GIR_EraseRootFromParent_Done,
     /* 1554603 */   // Label 21577: @1554603
     /* 1554603 */   GIM_Try, /*On fail goto*//*Label 21578*/ GIMT_Encode4(1554685), // Rule ID 19049 //
     /* 1554608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1554619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1554622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1554625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554647 */     // MIs[0] round
     /* 1554647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554650 */     // MIs[0] policy
     /* 1554650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554660 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11276:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1554663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554684 */     // GIR_Coverage, 19049,
     /* 1554684 */     GIR_EraseRootFromParent_Done,
     /* 1554685 */   // Label 21578: @1554685
     /* 1554685 */   GIM_Try, /*On fail goto*//*Label 21579*/ GIMT_Encode4(1554767), // Rule ID 19052 //
     /* 1554690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1554693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1554701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1554704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1554707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554729 */     // MIs[0] round
     /* 1554729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554732 */     // MIs[0] policy
     /* 1554732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554742 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1554745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554766 */     // GIR_Coverage, 19052,
     /* 1554766 */     GIR_EraseRootFromParent_Done,
     /* 1554767 */   // Label 21579: @1554767
     /* 1554767 */   GIM_Try, /*On fail goto*//*Label 21580*/ GIMT_Encode4(1554849), // Rule ID 19053 //
     /* 1554772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1554775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1554780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1554783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1554786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1554789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554811 */     // MIs[0] round
     /* 1554811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554814 */     // MIs[0] policy
     /* 1554814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554824 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11276:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1554827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1554845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554848 */     // GIR_Coverage, 19053,
     /* 1554848 */     GIR_EraseRootFromParent_Done,
     /* 1554849 */   // Label 21580: @1554849
     /* 1554849 */   GIM_Try, /*On fail goto*//*Label 21581*/ GIMT_Encode4(1554931), // Rule ID 19112 //
     /* 1554854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1554857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1554865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1554868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1554871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1554874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554893 */     // MIs[0] round
     /* 1554893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554896 */     // MIs[0] policy
     /* 1554896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554906 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1554909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554930 */     // GIR_Coverage, 19112,
     /* 1554930 */     GIR_EraseRootFromParent_Done,
     /* 1554931 */   // Label 21581: @1554931
     /* 1554931 */   GIM_Try, /*On fail goto*//*Label 21582*/ GIMT_Encode4(1555013), // Rule ID 19113 //
     /* 1554936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1554939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1554944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1554947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1554950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1554953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1554956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1554963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1554971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554975 */     // MIs[0] round
     /* 1554975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554978 */     // MIs[0] policy
     /* 1554978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554988 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1554991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555012 */     // GIR_Coverage, 19113,
     /* 1555012 */     GIR_EraseRootFromParent_Done,
     /* 1555013 */   // Label 21582: @1555013
     /* 1555013 */   GIM_Try, /*On fail goto*//*Label 21583*/ GIMT_Encode4(1555095), // Rule ID 19116 //
     /* 1555018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555057 */     // MIs[0] round
     /* 1555057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555060 */     // MIs[0] policy
     /* 1555060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555070 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1555073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555094 */     // GIR_Coverage, 19116,
     /* 1555094 */     GIR_EraseRootFromParent_Done,
     /* 1555095 */   // Label 21583: @1555095
     /* 1555095 */   GIM_Try, /*On fail goto*//*Label 21584*/ GIMT_Encode4(1555177), // Rule ID 19117 //
     /* 1555100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555139 */     // MIs[0] round
     /* 1555139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555142 */     // MIs[0] policy
     /* 1555142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555152 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1555155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555176 */     // GIR_Coverage, 19117,
     /* 1555176 */     GIR_EraseRootFromParent_Done,
     /* 1555177 */   // Label 21584: @1555177
     /* 1555177 */   GIM_Try, /*On fail goto*//*Label 21585*/ GIMT_Encode4(1555259), // Rule ID 19120 //
     /* 1555182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1555185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555221 */     // MIs[0] round
     /* 1555221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555224 */     // MIs[0] policy
     /* 1555224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555234 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1555237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555258 */     // GIR_Coverage, 19120,
     /* 1555258 */     GIR_EraseRootFromParent_Done,
     /* 1555259 */   // Label 21585: @1555259
     /* 1555259 */   GIM_Try, /*On fail goto*//*Label 21586*/ GIMT_Encode4(1555341), // Rule ID 19121 //
     /* 1555264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1555267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555303 */     // MIs[0] round
     /* 1555303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555306 */     // MIs[0] policy
     /* 1555306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555316 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1555319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555340 */     // GIR_Coverage, 19121,
     /* 1555340 */     GIR_EraseRootFromParent_Done,
     /* 1555341 */   // Label 21586: @1555341
     /* 1555341 */   GIM_Try, /*On fail goto*//*Label 21587*/ GIMT_Encode4(1555423), // Rule ID 19124 //
     /* 1555346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555385 */     // MIs[0] round
     /* 1555385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555388 */     // MIs[0] policy
     /* 1555388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555398 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1555401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555422 */     // GIR_Coverage, 19124,
     /* 1555422 */     GIR_EraseRootFromParent_Done,
     /* 1555423 */   // Label 21587: @1555423
     /* 1555423 */   GIM_Try, /*On fail goto*//*Label 21588*/ GIMT_Encode4(1555505), // Rule ID 19125 //
     /* 1555428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555467 */     // MIs[0] round
     /* 1555467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555470 */     // MIs[0] policy
     /* 1555470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555480 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1555483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555504 */     // GIR_Coverage, 19125,
     /* 1555504 */     GIR_EraseRootFromParent_Done,
     /* 1555505 */   // Label 21588: @1555505
     /* 1555505 */   GIM_Try, /*On fail goto*//*Label 21589*/ GIMT_Encode4(1555587), // Rule ID 19128 //
     /* 1555510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1555513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1555527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555549 */     // MIs[0] round
     /* 1555549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555552 */     // MIs[0] policy
     /* 1555552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555562 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1555565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555571 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555586 */     // GIR_Coverage, 19128,
     /* 1555586 */     GIR_EraseRootFromParent_Done,
     /* 1555587 */   // Label 21589: @1555587
     /* 1555587 */   GIM_Try, /*On fail goto*//*Label 21590*/ GIMT_Encode4(1555669), // Rule ID 19129 //
     /* 1555592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1555595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1555603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1555606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1555609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555631 */     // MIs[0] round
     /* 1555631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555634 */     // MIs[0] policy
     /* 1555634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555644 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1555647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555668 */     // GIR_Coverage, 19129,
     /* 1555668 */     GIR_EraseRootFromParent_Done,
     /* 1555669 */   // Label 21590: @1555669
     /* 1555669 */   GIM_Try, /*On fail goto*//*Label 21591*/ GIMT_Encode4(1555751), // Rule ID 19132 //
     /* 1555674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1555677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1555685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1555688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1555691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555713 */     // MIs[0] round
     /* 1555713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555716 */     // MIs[0] policy
     /* 1555716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555726 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1555729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555750 */     // GIR_Coverage, 19132,
     /* 1555750 */     GIR_EraseRootFromParent_Done,
     /* 1555751 */   // Label 21591: @1555751
     /* 1555751 */   GIM_Try, /*On fail goto*//*Label 21592*/ GIMT_Encode4(1555833), // Rule ID 19133 //
     /* 1555756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1555759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1555767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1555770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1555773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555795 */     // MIs[0] round
     /* 1555795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555798 */     // MIs[0] policy
     /* 1555798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555808 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1555811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555832 */     // GIR_Coverage, 19133,
     /* 1555832 */     GIR_EraseRootFromParent_Done,
     /* 1555833 */   // Label 21592: @1555833
     /* 1555833 */   GIM_Try, /*On fail goto*//*Label 21593*/ GIMT_Encode4(1555915), // Rule ID 19136 //
     /* 1555838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1555841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1555849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1555852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1555855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555877 */     // MIs[0] round
     /* 1555877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555880 */     // MIs[0] policy
     /* 1555880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555890 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1555893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555914 */     // GIR_Coverage, 19136,
     /* 1555914 */     GIR_EraseRootFromParent_Done,
     /* 1555915 */   // Label 21593: @1555915
     /* 1555915 */   GIM_Try, /*On fail goto*//*Label 21594*/ GIMT_Encode4(1555997), // Rule ID 19137 //
     /* 1555920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1555923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1555928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1555931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1555934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1555937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555959 */     // MIs[0] round
     /* 1555959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555962 */     // MIs[0] policy
     /* 1555962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555972 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1555975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555981 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555996 */     // GIR_Coverage, 19137,
     /* 1555996 */     GIR_EraseRootFromParent_Done,
     /* 1555997 */   // Label 21594: @1555997
     /* 1555997 */   GIM_Try, /*On fail goto*//*Label 21595*/ GIMT_Encode4(1556079), // Rule ID 19140 //
     /* 1556002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556041 */     // MIs[0] round
     /* 1556041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556044 */     // MIs[0] policy
     /* 1556044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556054 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1556057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556063 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556078 */     // GIR_Coverage, 19140,
     /* 1556078 */     GIR_EraseRootFromParent_Done,
     /* 1556079 */   // Label 21595: @1556079
     /* 1556079 */   GIM_Try, /*On fail goto*//*Label 21596*/ GIMT_Encode4(1556161), // Rule ID 19141 //
     /* 1556084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556123 */     // MIs[0] round
     /* 1556123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556126 */     // MIs[0] policy
     /* 1556126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556136 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1556139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556160 */     // GIR_Coverage, 19141,
     /* 1556160 */     GIR_EraseRootFromParent_Done,
     /* 1556161 */   // Label 21596: @1556161
     /* 1556161 */   GIM_Try, /*On fail goto*//*Label 21597*/ GIMT_Encode4(1556243), // Rule ID 19144 //
     /* 1556166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1556169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556205 */     // MIs[0] round
     /* 1556205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556208 */     // MIs[0] policy
     /* 1556208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556218 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1556221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556227 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556242 */     // GIR_Coverage, 19144,
     /* 1556242 */     GIR_EraseRootFromParent_Done,
     /* 1556243 */   // Label 21597: @1556243
     /* 1556243 */   GIM_Try, /*On fail goto*//*Label 21598*/ GIMT_Encode4(1556325), // Rule ID 19145 //
     /* 1556248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1556251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556287 */     // MIs[0] round
     /* 1556287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556290 */     // MIs[0] policy
     /* 1556290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556300 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1556303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556324 */     // GIR_Coverage, 19145,
     /* 1556324 */     GIR_EraseRootFromParent_Done,
     /* 1556325 */   // Label 21598: @1556325
     /* 1556325 */   GIM_Try, /*On fail goto*//*Label 21599*/ GIMT_Encode4(1556407), // Rule ID 19148 //
     /* 1556330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556369 */     // MIs[0] round
     /* 1556369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556372 */     // MIs[0] policy
     /* 1556372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1556385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556406 */     // GIR_Coverage, 19148,
     /* 1556406 */     GIR_EraseRootFromParent_Done,
     /* 1556407 */   // Label 21599: @1556407
     /* 1556407 */   GIM_Try, /*On fail goto*//*Label 21600*/ GIMT_Encode4(1556489), // Rule ID 19149 //
     /* 1556412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556451 */     // MIs[0] round
     /* 1556451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556454 */     // MIs[0] policy
     /* 1556454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556464 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1556467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556488 */     // GIR_Coverage, 19149,
     /* 1556488 */     GIR_EraseRootFromParent_Done,
     /* 1556489 */   // Label 21600: @1556489
     /* 1556489 */   GIM_Try, /*On fail goto*//*Label 21601*/ GIMT_Encode4(1556571), // Rule ID 19152 //
     /* 1556494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1556505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1556508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1556511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556533 */     // MIs[0] round
     /* 1556533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556536 */     // MIs[0] policy
     /* 1556536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556546 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1556549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556570 */     // GIR_Coverage, 19152,
     /* 1556570 */     GIR_EraseRootFromParent_Done,
     /* 1556571 */   // Label 21601: @1556571
     /* 1556571 */   GIM_Try, /*On fail goto*//*Label 21602*/ GIMT_Encode4(1556653), // Rule ID 19153 //
     /* 1556576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1556587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1556590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1556593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556615 */     // MIs[0] round
     /* 1556615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556618 */     // MIs[0] policy
     /* 1556618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556628 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1556631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556652 */     // GIR_Coverage, 19153,
     /* 1556652 */     GIR_EraseRootFromParent_Done,
     /* 1556653 */   // Label 21602: @1556653
     /* 1556653 */   GIM_Try, /*On fail goto*//*Label 21603*/ GIMT_Encode4(1556735), // Rule ID 19156 //
     /* 1556658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1556661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1556669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1556672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1556675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556697 */     // MIs[0] round
     /* 1556697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556700 */     // MIs[0] policy
     /* 1556700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556710 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1556713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556734 */     // GIR_Coverage, 19156,
     /* 1556734 */     GIR_EraseRootFromParent_Done,
     /* 1556735 */   // Label 21603: @1556735
     /* 1556735 */   GIM_Try, /*On fail goto*//*Label 21604*/ GIMT_Encode4(1556817), // Rule ID 19157 //
     /* 1556740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1556743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1556751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1556754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1556757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556779 */     // MIs[0] round
     /* 1556779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556782 */     // MIs[0] policy
     /* 1556782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556792 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1556795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556816 */     // GIR_Coverage, 19157,
     /* 1556816 */     GIR_EraseRootFromParent_Done,
     /* 1556817 */   // Label 21604: @1556817
     /* 1556817 */   GIM_Try, /*On fail goto*//*Label 21605*/ GIMT_Encode4(1556899), // Rule ID 19160 //
     /* 1556822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1556825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1556833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1556836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1556839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556861 */     // MIs[0] round
     /* 1556861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556864 */     // MIs[0] policy
     /* 1556864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556874 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1556877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556898 */     // GIR_Coverage, 19160,
     /* 1556898 */     GIR_EraseRootFromParent_Done,
     /* 1556899 */   // Label 21605: @1556899
     /* 1556899 */   GIM_Try, /*On fail goto*//*Label 21606*/ GIMT_Encode4(1556981), // Rule ID 19161 //
     /* 1556904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1556907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1556915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1556918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1556921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556943 */     // MIs[0] round
     /* 1556943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556946 */     // MIs[0] policy
     /* 1556946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556956 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1556959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556980 */     // GIR_Coverage, 19161,
     /* 1556980 */     GIR_EraseRootFromParent_Done,
     /* 1556981 */   // Label 21606: @1556981
     /* 1556981 */   GIM_Try, /*On fail goto*//*Label 21607*/ GIMT_Encode4(1557063), // Rule ID 19164 //
     /* 1556986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1556989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1556994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1556997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557025 */     // MIs[0] round
     /* 1557025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557028 */     // MIs[0] policy
     /* 1557028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557038 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1557041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557062 */     // GIR_Coverage, 19164,
     /* 1557062 */     GIR_EraseRootFromParent_Done,
     /* 1557063 */   // Label 21607: @1557063
     /* 1557063 */   GIM_Try, /*On fail goto*//*Label 21608*/ GIMT_Encode4(1557145), // Rule ID 19165 //
     /* 1557068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557107 */     // MIs[0] round
     /* 1557107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557110 */     // MIs[0] policy
     /* 1557110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557120 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1557123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557144 */     // GIR_Coverage, 19165,
     /* 1557144 */     GIR_EraseRootFromParent_Done,
     /* 1557145 */   // Label 21608: @1557145
     /* 1557145 */   GIM_Try, /*On fail goto*//*Label 21609*/ GIMT_Encode4(1557227), // Rule ID 19168 //
     /* 1557150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1557153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557189 */     // MIs[0] round
     /* 1557189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557192 */     // MIs[0] policy
     /* 1557192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557202 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1557205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557226 */     // GIR_Coverage, 19168,
     /* 1557226 */     GIR_EraseRootFromParent_Done,
     /* 1557227 */   // Label 21609: @1557227
     /* 1557227 */   GIM_Try, /*On fail goto*//*Label 21610*/ GIMT_Encode4(1557309), // Rule ID 19169 //
     /* 1557232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1557235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1557240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557271 */     // MIs[0] round
     /* 1557271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557274 */     // MIs[0] policy
     /* 1557274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557284 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1557287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557308 */     // GIR_Coverage, 19169,
     /* 1557308 */     GIR_EraseRootFromParent_Done,
     /* 1557309 */   // Label 21610: @1557309
     /* 1557309 */   GIM_Try, /*On fail goto*//*Label 21611*/ GIMT_Encode4(1557391), // Rule ID 20754 //
     /* 1557314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557353 */     // MIs[0] round
     /* 1557353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557356 */     // MIs[0] policy
     /* 1557356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557390 */     // GIR_Coverage, 20754,
     /* 1557390 */     GIR_EraseRootFromParent_Done,
     /* 1557391 */   // Label 21611: @1557391
     /* 1557391 */   GIM_Try, /*On fail goto*//*Label 21612*/ GIMT_Encode4(1557473), // Rule ID 20755 //
     /* 1557396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1557399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1557407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1557410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1557413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557435 */     // MIs[0] round
     /* 1557435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557438 */     // MIs[0] policy
     /* 1557438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557448 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557472 */     // GIR_Coverage, 20755,
     /* 1557472 */     GIR_EraseRootFromParent_Done,
     /* 1557473 */   // Label 21612: @1557473
     /* 1557473 */   GIM_Try, /*On fail goto*//*Label 21613*/ GIMT_Encode4(1557555), // Rule ID 20758 //
     /* 1557478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1557481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557517 */     // MIs[0] round
     /* 1557517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557520 */     // MIs[0] policy
     /* 1557520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557530 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557554 */     // GIR_Coverage, 20758,
     /* 1557554 */     GIR_EraseRootFromParent_Done,
     /* 1557555 */   // Label 21613: @1557555
     /* 1557555 */   GIM_Try, /*On fail goto*//*Label 21614*/ GIMT_Encode4(1557637), // Rule ID 20759 //
     /* 1557560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1557563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1557571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1557574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1557577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557599 */     // MIs[0] round
     /* 1557599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557602 */     // MIs[0] policy
     /* 1557602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557612 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1557615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557636 */     // GIR_Coverage, 20759,
     /* 1557636 */     GIR_EraseRootFromParent_Done,
     /* 1557637 */   // Label 21614: @1557637
     /* 1557637 */   GIM_Try, /*On fail goto*//*Label 21615*/ GIMT_Encode4(1557719), // Rule ID 20762 //
     /* 1557642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1557653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1557656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1557659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557681 */     // MIs[0] round
     /* 1557681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557684 */     // MIs[0] policy
     /* 1557684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1557697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557718 */     // GIR_Coverage, 20762,
     /* 1557718 */     GIR_EraseRootFromParent_Done,
     /* 1557719 */   // Label 21615: @1557719
     /* 1557719 */   GIM_Try, /*On fail goto*//*Label 21616*/ GIMT_Encode4(1557801), // Rule ID 20763 //
     /* 1557724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1557727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1557735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1557738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1557741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557763 */     // MIs[0] round
     /* 1557763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557766 */     // MIs[0] policy
     /* 1557766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1557779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1557797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557800 */     // GIR_Coverage, 20763,
     /* 1557800 */     GIR_EraseRootFromParent_Done,
     /* 1557801 */   // Label 21616: @1557801
     /* 1557801 */   GIM_Try, /*On fail goto*//*Label 21617*/ GIMT_Encode4(1557883), // Rule ID 20766 //
     /* 1557806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1557809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1557817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1557820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1557823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557845 */     // MIs[0] round
     /* 1557845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557848 */     // MIs[0] policy
     /* 1557848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1557861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557882 */     // GIR_Coverage, 20766,
     /* 1557882 */     GIR_EraseRootFromParent_Done,
     /* 1557883 */   // Label 21617: @1557883
     /* 1557883 */   GIM_Try, /*On fail goto*//*Label 21618*/ GIMT_Encode4(1557965), // Rule ID 20767 //
     /* 1557888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1557891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1557899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1557902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1557905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557927 */     // MIs[0] round
     /* 1557927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557930 */     // MIs[0] policy
     /* 1557930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1557943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557964 */     // GIR_Coverage, 20767,
     /* 1557964 */     GIR_EraseRootFromParent_Done,
     /* 1557965 */   // Label 21618: @1557965
     /* 1557965 */   GIM_Try, /*On fail goto*//*Label 21619*/ GIMT_Encode4(1558047), // Rule ID 20770 //
     /* 1557970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1557973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1557978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1557981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1557984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1557987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558009 */     // MIs[0] round
     /* 1558009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558012 */     // MIs[0] policy
     /* 1558012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558022 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558046 */     // GIR_Coverage, 20770,
     /* 1558046 */     GIR_EraseRootFromParent_Done,
     /* 1558047 */   // Label 21619: @1558047
     /* 1558047 */   GIM_Try, /*On fail goto*//*Label 21620*/ GIMT_Encode4(1558129), // Rule ID 20771 //
     /* 1558052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1558055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558091 */     // MIs[0] round
     /* 1558091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558094 */     // MIs[0] policy
     /* 1558094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1558107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558128 */     // GIR_Coverage, 20771,
     /* 1558128 */     GIR_EraseRootFromParent_Done,
     /* 1558129 */   // Label 21620: @1558129
     /* 1558129 */   GIM_Try, /*On fail goto*//*Label 21621*/ GIMT_Encode4(1558211), // Rule ID 20774 //
     /* 1558134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558173 */     // MIs[0] round
     /* 1558173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558176 */     // MIs[0] policy
     /* 1558176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558210 */     // GIR_Coverage, 20774,
     /* 1558210 */     GIR_EraseRootFromParent_Done,
     /* 1558211 */   // Label 21621: @1558211
     /* 1558211 */   GIM_Try, /*On fail goto*//*Label 21622*/ GIMT_Encode4(1558293), // Rule ID 20775 //
     /* 1558216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558255 */     // MIs[0] round
     /* 1558255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558258 */     // MIs[0] policy
     /* 1558258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558268 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558292 */     // GIR_Coverage, 20775,
     /* 1558292 */     GIR_EraseRootFromParent_Done,
     /* 1558293 */   // Label 21622: @1558293
     /* 1558293 */   GIM_Try, /*On fail goto*//*Label 21623*/ GIMT_Encode4(1558375), // Rule ID 20778 //
     /* 1558298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558337 */     // MIs[0] round
     /* 1558337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558340 */     // MIs[0] policy
     /* 1558340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558374 */     // GIR_Coverage, 20778,
     /* 1558374 */     GIR_EraseRootFromParent_Done,
     /* 1558375 */   // Label 21623: @1558375
     /* 1558375 */   GIM_Try, /*On fail goto*//*Label 21624*/ GIMT_Encode4(1558457), // Rule ID 20779 //
     /* 1558380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1558391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1558394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1558397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558419 */     // MIs[0] round
     /* 1558419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558422 */     // MIs[0] policy
     /* 1558422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558456 */     // GIR_Coverage, 20779,
     /* 1558456 */     GIR_EraseRootFromParent_Done,
     /* 1558457 */   // Label 21624: @1558457
     /* 1558457 */   GIM_Try, /*On fail goto*//*Label 21625*/ GIMT_Encode4(1558539), // Rule ID 20782 //
     /* 1558462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1558473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1558476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1558479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1558482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558501 */     // MIs[0] round
     /* 1558501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558504 */     // MIs[0] policy
     /* 1558504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558514 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1558517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558523 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558538 */     // GIR_Coverage, 20782,
     /* 1558538 */     GIR_EraseRootFromParent_Done,
     /* 1558539 */   // Label 21625: @1558539
     /* 1558539 */   GIM_Try, /*On fail goto*//*Label 21626*/ GIMT_Encode4(1558621), // Rule ID 20783 //
     /* 1558544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1558555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1558558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1558561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1558564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558583 */     // MIs[0] round
     /* 1558583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558586 */     // MIs[0] policy
     /* 1558586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558596 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1558599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558605 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558620 */     // GIR_Coverage, 20783,
     /* 1558620 */     GIR_EraseRootFromParent_Done,
     /* 1558621 */   // Label 21626: @1558621
     /* 1558621 */   GIM_Try, /*On fail goto*//*Label 21627*/ GIMT_Encode4(1558703), // Rule ID 20786 //
     /* 1558626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1558637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1558640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1558643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558665 */     // MIs[0] round
     /* 1558665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558668 */     // MIs[0] policy
     /* 1558668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558678 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558687 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558702 */     // GIR_Coverage, 20786,
     /* 1558702 */     GIR_EraseRootFromParent_Done,
     /* 1558703 */   // Label 21627: @1558703
     /* 1558703 */   GIM_Try, /*On fail goto*//*Label 21628*/ GIMT_Encode4(1558785), // Rule ID 20787 //
     /* 1558708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1558719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1558722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1558725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558747 */     // MIs[0] round
     /* 1558747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558750 */     // MIs[0] policy
     /* 1558750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1558763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558784 */     // GIR_Coverage, 20787,
     /* 1558784 */     GIR_EraseRootFromParent_Done,
     /* 1558785 */   // Label 21628: @1558785
     /* 1558785 */   GIM_Try, /*On fail goto*//*Label 21629*/ GIMT_Encode4(1558867), // Rule ID 20790 //
     /* 1558790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1558801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1558804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1558807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558829 */     // MIs[0] round
     /* 1558829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558832 */     // MIs[0] policy
     /* 1558832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558866 */     // GIR_Coverage, 20790,
     /* 1558866 */     GIR_EraseRootFromParent_Done,
     /* 1558867 */   // Label 21629: @1558867
     /* 1558867 */   GIM_Try, /*On fail goto*//*Label 21630*/ GIMT_Encode4(1558949), // Rule ID 20791 //
     /* 1558872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1558883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1558886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1558889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1558899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1558907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558911 */     // MIs[0] round
     /* 1558911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558914 */     // MIs[0] policy
     /* 1558914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558924 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1558927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558948 */     // GIR_Coverage, 20791,
     /* 1558948 */     GIR_EraseRootFromParent_Done,
     /* 1558949 */   // Label 21630: @1558949
     /* 1558949 */   GIM_Try, /*On fail goto*//*Label 21631*/ GIMT_Encode4(1559031), // Rule ID 20794 //
     /* 1558954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1558962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1558965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1558968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1558971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1558974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1558981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1558989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558993 */     // MIs[0] round
     /* 1558993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558996 */     // MIs[0] policy
     /* 1558996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559006 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559030 */     // GIR_Coverage, 20794,
     /* 1559030 */     GIR_EraseRootFromParent_Done,
     /* 1559031 */   // Label 21631: @1559031
     /* 1559031 */   GIM_Try, /*On fail goto*//*Label 21632*/ GIMT_Encode4(1559113), // Rule ID 20795 //
     /* 1559036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559075 */     // MIs[0] round
     /* 1559075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559078 */     // MIs[0] policy
     /* 1559078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559088 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559112 */     // GIR_Coverage, 20795,
     /* 1559112 */     GIR_EraseRootFromParent_Done,
     /* 1559113 */   // Label 21632: @1559113
     /* 1559113 */   GIM_Try, /*On fail goto*//*Label 21633*/ GIMT_Encode4(1559195), // Rule ID 20798 //
     /* 1559118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559157 */     // MIs[0] round
     /* 1559157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559160 */     // MIs[0] policy
     /* 1559160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559194 */     // GIR_Coverage, 20798,
     /* 1559194 */     GIR_EraseRootFromParent_Done,
     /* 1559195 */   // Label 21633: @1559195
     /* 1559195 */   GIM_Try, /*On fail goto*//*Label 21634*/ GIMT_Encode4(1559277), // Rule ID 20799 //
     /* 1559200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559239 */     // MIs[0] round
     /* 1559239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559242 */     // MIs[0] policy
     /* 1559242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1559255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559276 */     // GIR_Coverage, 20799,
     /* 1559276 */     GIR_EraseRootFromParent_Done,
     /* 1559277 */   // Label 21634: @1559277
     /* 1559277 */   GIM_Try, /*On fail goto*//*Label 21635*/ GIMT_Encode4(1559359), // Rule ID 20802 //
     /* 1559282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559321 */     // MIs[0] round
     /* 1559321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559324 */     // MIs[0] policy
     /* 1559324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559343 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559358 */     // GIR_Coverage, 20802,
     /* 1559358 */     GIR_EraseRootFromParent_Done,
     /* 1559359 */   // Label 21635: @1559359
     /* 1559359 */   GIM_Try, /*On fail goto*//*Label 21636*/ GIMT_Encode4(1559441), // Rule ID 20803 //
     /* 1559364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1559375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1559378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1559381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559403 */     // MIs[0] round
     /* 1559403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559406 */     // MIs[0] policy
     /* 1559406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559416 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1559419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559440 */     // GIR_Coverage, 20803,
     /* 1559440 */     GIR_EraseRootFromParent_Done,
     /* 1559441 */   // Label 21636: @1559441
     /* 1559441 */   GIM_Try, /*On fail goto*//*Label 21637*/ GIMT_Encode4(1559523), // Rule ID 20806 //
     /* 1559446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1559457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1559460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1559463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559485 */     // MIs[0] round
     /* 1559485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559488 */     // MIs[0] policy
     /* 1559488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559498 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559522 */     // GIR_Coverage, 20806,
     /* 1559522 */     GIR_EraseRootFromParent_Done,
     /* 1559523 */   // Label 21637: @1559523
     /* 1559523 */   GIM_Try, /*On fail goto*//*Label 21638*/ GIMT_Encode4(1559605), // Rule ID 20807 //
     /* 1559528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1559536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1559539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1559542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1559545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559567 */     // MIs[0] round
     /* 1559567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559570 */     // MIs[0] policy
     /* 1559570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559580 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1559583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559604 */     // GIR_Coverage, 20807,
     /* 1559604 */     GIR_EraseRootFromParent_Done,
     /* 1559605 */   // Label 21638: @1559605
     /* 1559605 */   GIM_Try, /*On fail goto*//*Label 21639*/ GIMT_Encode4(1559687), // Rule ID 20810 //
     /* 1559610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1559613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1559621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1559624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1559627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559649 */     // MIs[0] round
     /* 1559649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559652 */     // MIs[0] policy
     /* 1559652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559662 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1559665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559686 */     // GIR_Coverage, 20810,
     /* 1559686 */     GIR_EraseRootFromParent_Done,
     /* 1559687 */   // Label 21639: @1559687
     /* 1559687 */   GIM_Try, /*On fail goto*//*Label 21640*/ GIMT_Encode4(1559769), // Rule ID 20811 //
     /* 1559692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1559703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1559706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1559709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559731 */     // MIs[0] round
     /* 1559731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559734 */     // MIs[0] policy
     /* 1559734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1559747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559768 */     // GIR_Coverage, 20811,
     /* 1559768 */     GIR_EraseRootFromParent_Done,
     /* 1559769 */   // Label 21640: @1559769
     /* 1559769 */   GIM_Try, /*On fail goto*//*Label 21641*/ GIMT_Encode4(1559851), // Rule ID 20814 //
     /* 1559774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1559777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1559785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1559788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1559791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559813 */     // MIs[0] round
     /* 1559813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559816 */     // MIs[0] policy
     /* 1559816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1559829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559835 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559850 */     // GIR_Coverage, 20814,
     /* 1559850 */     GIR_EraseRootFromParent_Done,
     /* 1559851 */   // Label 21641: @1559851
     /* 1559851 */   GIM_Try, /*On fail goto*//*Label 21642*/ GIMT_Encode4(1559933), // Rule ID 20815 //
     /* 1559856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1559867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1559870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1559873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559895 */     // MIs[0] round
     /* 1559895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559898 */     // MIs[0] policy
     /* 1559898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559908 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1559911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559932 */     // GIR_Coverage, 20815,
     /* 1559932 */     GIR_EraseRootFromParent_Done,
     /* 1559933 */   // Label 21642: @1559933
     /* 1559933 */   GIM_Try, /*On fail goto*//*Label 21643*/ GIMT_Encode4(1560015), // Rule ID 20818 //
     /* 1559938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1559946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1559949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1559952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1559955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1559958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1559965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1559973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559977 */     // MIs[0] round
     /* 1559977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559980 */     // MIs[0] policy
     /* 1559980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559990 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1559993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560014 */     // GIR_Coverage, 20818,
     /* 1560014 */     GIR_EraseRootFromParent_Done,
     /* 1560015 */   // Label 21643: @1560015
     /* 1560015 */   GIM_Try, /*On fail goto*//*Label 21644*/ GIMT_Encode4(1560097), // Rule ID 20819 //
     /* 1560020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1560037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560059 */     // MIs[0] round
     /* 1560059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560062 */     // MIs[0] policy
     /* 1560062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560072 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1560075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560096 */     // GIR_Coverage, 20819,
     /* 1560096 */     GIR_EraseRootFromParent_Done,
     /* 1560097 */   // Label 21644: @1560097
     /* 1560097 */   GIM_Try, /*On fail goto*//*Label 21645*/ GIMT_Encode4(1560179), // Rule ID 20822 //
     /* 1560102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560141 */     // MIs[0] round
     /* 1560141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560144 */     // MIs[0] policy
     /* 1560144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560178 */     // GIR_Coverage, 20822,
     /* 1560178 */     GIR_EraseRootFromParent_Done,
     /* 1560179 */   // Label 21645: @1560179
     /* 1560179 */   GIM_Try, /*On fail goto*//*Label 21646*/ GIMT_Encode4(1560261), // Rule ID 20823 //
     /* 1560184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1560195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1560198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560223 */     // MIs[0] round
     /* 1560223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560226 */     // MIs[0] policy
     /* 1560226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560236 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560260 */     // GIR_Coverage, 20823,
     /* 1560260 */     GIR_EraseRootFromParent_Done,
     /* 1560261 */   // Label 21646: @1560261
     /* 1560261 */   GIM_Try, /*On fail goto*//*Label 21647*/ GIMT_Encode4(1560343), // Rule ID 20826 //
     /* 1560266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1560269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560305 */     // MIs[0] round
     /* 1560305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560308 */     // MIs[0] policy
     /* 1560308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560342 */     // GIR_Coverage, 20826,
     /* 1560342 */     GIR_EraseRootFromParent_Done,
     /* 1560343 */   // Label 21647: @1560343
     /* 1560343 */   GIM_Try, /*On fail goto*//*Label 21648*/ GIMT_Encode4(1560425), // Rule ID 20827 //
     /* 1560348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1560351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1560365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560387 */     // MIs[0] round
     /* 1560387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560390 */     // MIs[0] policy
     /* 1560390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1560421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560424 */     // GIR_Coverage, 20827,
     /* 1560424 */     GIR_EraseRootFromParent_Done,
     /* 1560425 */   // Label 21648: @1560425
     /* 1560425 */   GIM_Try, /*On fail goto*//*Label 21649*/ GIMT_Encode4(1560507), // Rule ID 20830 //
     /* 1560430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1560433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1560444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1560447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560469 */     // MIs[0] round
     /* 1560469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560472 */     // MIs[0] policy
     /* 1560472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560506 */     // GIR_Coverage, 20830,
     /* 1560506 */     GIR_EraseRootFromParent_Done,
     /* 1560507 */   // Label 21649: @1560507
     /* 1560507 */   GIM_Try, /*On fail goto*//*Label 21650*/ GIMT_Encode4(1560589), // Rule ID 20831 //
     /* 1560512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1560515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1560523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1560526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1560529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560551 */     // MIs[0] round
     /* 1560551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560554 */     // MIs[0] policy
     /* 1560554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560564 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1560567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560588 */     // GIR_Coverage, 20831,
     /* 1560588 */     GIR_EraseRootFromParent_Done,
     /* 1560589 */   // Label 21650: @1560589
     /* 1560589 */   GIM_Try, /*On fail goto*//*Label 21651*/ GIMT_Encode4(1560671), // Rule ID 20834 //
     /* 1560594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1560605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1560608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1560611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560633 */     // MIs[0] round
     /* 1560633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560636 */     // MIs[0] policy
     /* 1560636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1560649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560670 */     // GIR_Coverage, 20834,
     /* 1560670 */     GIR_EraseRootFromParent_Done,
     /* 1560671 */   // Label 21651: @1560671
     /* 1560671 */   GIM_Try, /*On fail goto*//*Label 21652*/ GIMT_Encode4(1560753), // Rule ID 20835 //
     /* 1560676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1560687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1560690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1560693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560715 */     // MIs[0] round
     /* 1560715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560718 */     // MIs[0] policy
     /* 1560718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1560731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560752 */     // GIR_Coverage, 20835,
     /* 1560752 */     GIR_EraseRootFromParent_Done,
     /* 1560753 */   // Label 21652: @1560753
     /* 1560753 */   GIM_Try, /*On fail goto*//*Label 21653*/ GIMT_Encode4(1560835), // Rule ID 20838 //
     /* 1560758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1560769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1560772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1560775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1560778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560797 */     // MIs[0] round
     /* 1560797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560800 */     // MIs[0] policy
     /* 1560800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560810 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1560813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560834 */     // GIR_Coverage, 20838,
     /* 1560834 */     GIR_EraseRootFromParent_Done,
     /* 1560835 */   // Label 21653: @1560835
     /* 1560835 */   GIM_Try, /*On fail goto*//*Label 21654*/ GIMT_Encode4(1560917), // Rule ID 20839 //
     /* 1560840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1560851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1560854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1560857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1560860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560879 */     // MIs[0] round
     /* 1560879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560882 */     // MIs[0] policy
     /* 1560882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1560895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560916 */     // GIR_Coverage, 20839,
     /* 1560916 */     GIR_EraseRootFromParent_Done,
     /* 1560917 */   // Label 21654: @1560917
     /* 1560917 */   GIM_Try, /*On fail goto*//*Label 21655*/ GIMT_Encode4(1560999), // Rule ID 20842 //
     /* 1560922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1560930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1560933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1560936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1560939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1560942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560961 */     // MIs[0] round
     /* 1560961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560964 */     // MIs[0] policy
     /* 1560964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560974 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1560977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560983 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560998 */     // GIR_Coverage, 20842,
     /* 1560998 */     GIR_EraseRootFromParent_Done,
     /* 1560999 */   // Label 21655: @1560999
     /* 1560999 */   GIM_Try, /*On fail goto*//*Label 21656*/ GIMT_Encode4(1561081), // Rule ID 20843 //
     /* 1561004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1561015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1561018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1561021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1561024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561043 */     // MIs[0] round
     /* 1561043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561046 */     // MIs[0] policy
     /* 1561046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561056 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561080 */     // GIR_Coverage, 20843,
     /* 1561080 */     GIR_EraseRootFromParent_Done,
     /* 1561081 */   // Label 21656: @1561081
     /* 1561081 */   GIM_Try, /*On fail goto*//*Label 21657*/ GIMT_Encode4(1561163), // Rule ID 20846 //
     /* 1561086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561125 */     // MIs[0] round
     /* 1561125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561128 */     // MIs[0] policy
     /* 1561128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561162 */     // GIR_Coverage, 20846,
     /* 1561162 */     GIR_EraseRootFromParent_Done,
     /* 1561163 */   // Label 21657: @1561163
     /* 1561163 */   GIM_Try, /*On fail goto*//*Label 21658*/ GIMT_Encode4(1561245), // Rule ID 20847 //
     /* 1561168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1561179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1561182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561207 */     // MIs[0] round
     /* 1561207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561210 */     // MIs[0] policy
     /* 1561210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561244 */     // GIR_Coverage, 20847,
     /* 1561244 */     GIR_EraseRootFromParent_Done,
     /* 1561245 */   // Label 21658: @1561245
     /* 1561245 */   GIM_Try, /*On fail goto*//*Label 21659*/ GIMT_Encode4(1561327), // Rule ID 20850 //
     /* 1561250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561289 */     // MIs[0] round
     /* 1561289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561292 */     // MIs[0] policy
     /* 1561292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561326 */     // GIR_Coverage, 20850,
     /* 1561326 */     GIR_EraseRootFromParent_Done,
     /* 1561327 */   // Label 21659: @1561327
     /* 1561327 */   GIM_Try, /*On fail goto*//*Label 21660*/ GIMT_Encode4(1561409), // Rule ID 20851 //
     /* 1561332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1561343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1561346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561371 */     // MIs[0] round
     /* 1561371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561374 */     // MIs[0] policy
     /* 1561374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561408 */     // GIR_Coverage, 20851,
     /* 1561408 */     GIR_EraseRootFromParent_Done,
     /* 1561409 */   // Label 21660: @1561409
     /* 1561409 */   GIM_Try, /*On fail goto*//*Label 21661*/ GIMT_Encode4(1561491), // Rule ID 20854 //
     /* 1561414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1561417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561453 */     // MIs[0] round
     /* 1561453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561456 */     // MIs[0] policy
     /* 1561456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561466 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561490 */     // GIR_Coverage, 20854,
     /* 1561490 */     GIR_EraseRootFromParent_Done,
     /* 1561491 */   // Label 21661: @1561491
     /* 1561491 */   GIM_Try, /*On fail goto*//*Label 21662*/ GIMT_Encode4(1561573), // Rule ID 20855 //
     /* 1561496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1561499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1561513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561535 */     // MIs[0] round
     /* 1561535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561538 */     // MIs[0] policy
     /* 1561538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561548 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561572 */     // GIR_Coverage, 20855,
     /* 1561572 */     GIR_EraseRootFromParent_Done,
     /* 1561573 */   // Label 21662: @1561573
     /* 1561573 */   GIM_Try, /*On fail goto*//*Label 21663*/ GIMT_Encode4(1561655), // Rule ID 20858 //
     /* 1561578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1561581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1561589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1561592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1561595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561617 */     // MIs[0] round
     /* 1561617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561620 */     // MIs[0] policy
     /* 1561620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561654 */     // GIR_Coverage, 20858,
     /* 1561654 */     GIR_EraseRootFromParent_Done,
     /* 1561655 */   // Label 21663: @1561655
     /* 1561655 */   GIM_Try, /*On fail goto*//*Label 21664*/ GIMT_Encode4(1561737), // Rule ID 20859 //
     /* 1561660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1561663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1561671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1561674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1561677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561699 */     // MIs[0] round
     /* 1561699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561702 */     // MIs[0] policy
     /* 1561702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1561715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561736 */     // GIR_Coverage, 20859,
     /* 1561736 */     GIR_EraseRootFromParent_Done,
     /* 1561737 */   // Label 21664: @1561737
     /* 1561737 */   GIM_Try, /*On fail goto*//*Label 21665*/ GIMT_Encode4(1561819), // Rule ID 20862 //
     /* 1561742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1561745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1561753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1561756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1561759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561781 */     // MIs[0] round
     /* 1561781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561784 */     // MIs[0] policy
     /* 1561784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561803 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561818 */     // GIR_Coverage, 20862,
     /* 1561818 */     GIR_EraseRootFromParent_Done,
     /* 1561819 */   // Label 21665: @1561819
     /* 1561819 */   GIM_Try, /*On fail goto*//*Label 21666*/ GIMT_Encode4(1561901), // Rule ID 20863 //
     /* 1561824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1561827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1561835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1561838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1561841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561863 */     // MIs[0] round
     /* 1561863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561866 */     // MIs[0] policy
     /* 1561866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1561879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561900 */     // GIR_Coverage, 20863,
     /* 1561900 */     GIR_EraseRootFromParent_Done,
     /* 1561901 */   // Label 21666: @1561901
     /* 1561901 */   GIM_Try, /*On fail goto*//*Label 21667*/ GIMT_Encode4(1561983), // Rule ID 20866 //
     /* 1561906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1561909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1561917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1561920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1561923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561945 */     // MIs[0] round
     /* 1561945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561948 */     // MIs[0] policy
     /* 1561948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561958 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1561961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1561979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561982 */     // GIR_Coverage, 20866,
     /* 1561982 */     GIR_EraseRootFromParent_Done,
     /* 1561983 */   // Label 21667: @1561983
     /* 1561983 */   GIM_Try, /*On fail goto*//*Label 21668*/ GIMT_Encode4(1562065), // Rule ID 20867 //
     /* 1561988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1561991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1561996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1561999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1562002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1562005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562027 */     // MIs[0] round
     /* 1562027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562030 */     // MIs[0] policy
     /* 1562030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1562043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562064 */     // GIR_Coverage, 20867,
     /* 1562064 */     GIR_EraseRootFromParent_Done,
     /* 1562065 */   // Label 21668: @1562065
     /* 1562065 */   GIM_Try, /*On fail goto*//*Label 21669*/ GIMT_Encode4(1562147), // Rule ID 20990 //
     /* 1562070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562109 */     // MIs[0] round
     /* 1562109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562112 */     // MIs[0] policy
     /* 1562112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562122 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1562125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562146 */     // GIR_Coverage, 20990,
     /* 1562146 */     GIR_EraseRootFromParent_Done,
     /* 1562147 */   // Label 21669: @1562147
     /* 1562147 */   GIM_Try, /*On fail goto*//*Label 21670*/ GIMT_Encode4(1562229), // Rule ID 20991 //
     /* 1562152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1562163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1562166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1562169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562191 */     // MIs[0] round
     /* 1562191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562194 */     // MIs[0] policy
     /* 1562194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562204 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1562207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562213 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562228 */     // GIR_Coverage, 20991,
     /* 1562228 */     GIR_EraseRootFromParent_Done,
     /* 1562229 */   // Label 21670: @1562229
     /* 1562229 */   GIM_Try, /*On fail goto*//*Label 21671*/ GIMT_Encode4(1562311), // Rule ID 20994 //
     /* 1562234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562273 */     // MIs[0] round
     /* 1562273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562276 */     // MIs[0] policy
     /* 1562276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562286 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1562289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562295 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562310 */     // GIR_Coverage, 20994,
     /* 1562310 */     GIR_EraseRootFromParent_Done,
     /* 1562311 */   // Label 21671: @1562311
     /* 1562311 */   GIM_Try, /*On fail goto*//*Label 21672*/ GIMT_Encode4(1562393), // Rule ID 20995 //
     /* 1562316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1562327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1562330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562355 */     // MIs[0] round
     /* 1562355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562358 */     // MIs[0] policy
     /* 1562358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562368 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1562371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562392 */     // GIR_Coverage, 20995,
     /* 1562392 */     GIR_EraseRootFromParent_Done,
     /* 1562393 */   // Label 21672: @1562393
     /* 1562393 */   GIM_Try, /*On fail goto*//*Label 21673*/ GIMT_Encode4(1562475), // Rule ID 20998 //
     /* 1562398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562437 */     // MIs[0] round
     /* 1562437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562440 */     // MIs[0] policy
     /* 1562440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562450 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1562453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562474 */     // GIR_Coverage, 20998,
     /* 1562474 */     GIR_EraseRootFromParent_Done,
     /* 1562475 */   // Label 21673: @1562475
     /* 1562475 */   GIM_Try, /*On fail goto*//*Label 21674*/ GIMT_Encode4(1562557), // Rule ID 20999 //
     /* 1562480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1562491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1562494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562519 */     // MIs[0] round
     /* 1562519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562522 */     // MIs[0] policy
     /* 1562522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562532 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1562535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562556 */     // GIR_Coverage, 20999,
     /* 1562556 */     GIR_EraseRootFromParent_Done,
     /* 1562557 */   // Label 21674: @1562557
     /* 1562557 */   GIM_Try, /*On fail goto*//*Label 21675*/ GIMT_Encode4(1562639), // Rule ID 21002 //
     /* 1562562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1562573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1562576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1562579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562601 */     // MIs[0] round
     /* 1562601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562604 */     // MIs[0] policy
     /* 1562604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562614 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1562617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562638 */     // GIR_Coverage, 21002,
     /* 1562638 */     GIR_EraseRootFromParent_Done,
     /* 1562639 */   // Label 21675: @1562639
     /* 1562639 */   GIM_Try, /*On fail goto*//*Label 21676*/ GIMT_Encode4(1562721), // Rule ID 21003 //
     /* 1562644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1562655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1562658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1562661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562683 */     // MIs[0] round
     /* 1562683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562686 */     // MIs[0] policy
     /* 1562686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562696 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1562699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562720 */     // GIR_Coverage, 21003,
     /* 1562720 */     GIR_EraseRootFromParent_Done,
     /* 1562721 */   // Label 21676: @1562721
     /* 1562721 */   GIM_Try, /*On fail goto*//*Label 21677*/ GIMT_Encode4(1562803), // Rule ID 21006 //
     /* 1562726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1562729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1562737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1562740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1562743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562765 */     // MIs[0] round
     /* 1562765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562768 */     // MIs[0] policy
     /* 1562768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562778 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1562781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562802 */     // GIR_Coverage, 21006,
     /* 1562802 */     GIR_EraseRootFromParent_Done,
     /* 1562803 */   // Label 21677: @1562803
     /* 1562803 */   GIM_Try, /*On fail goto*//*Label 21678*/ GIMT_Encode4(1562885), // Rule ID 21007 //
     /* 1562808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1562811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1562819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1562822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1562825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562847 */     // MIs[0] round
     /* 1562847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562850 */     // MIs[0] policy
     /* 1562850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1562863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562884 */     // GIR_Coverage, 21007,
     /* 1562884 */     GIR_EraseRootFromParent_Done,
     /* 1562885 */   // Label 21678: @1562885
     /* 1562885 */   GIM_Try, /*On fail goto*//*Label 21679*/ GIMT_Encode4(1562967), // Rule ID 21010 //
     /* 1562890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1562893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1562901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1562904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1562907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562929 */     // MIs[0] round
     /* 1562929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562932 */     // MIs[0] policy
     /* 1562932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562942 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1562945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1562963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562966 */     // GIR_Coverage, 21010,
     /* 1562966 */     GIR_EraseRootFromParent_Done,
     /* 1562967 */   // Label 21679: @1562967
     /* 1562967 */   GIM_Try, /*On fail goto*//*Label 21680*/ GIMT_Encode4(1563049), // Rule ID 21011 //
     /* 1562972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1562975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1562980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1562983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1562986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1562989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563011 */     // MIs[0] round
     /* 1563011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563014 */     // MIs[0] policy
     /* 1563014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563024 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1563027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1563045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563048 */     // GIR_Coverage, 21011,
     /* 1563048 */     GIR_EraseRootFromParent_Done,
     /* 1563049 */   // Label 21680: @1563049
     /* 1563049 */   GIM_Try, /*On fail goto*//*Label 21681*/ GIMT_Encode4(1563131), // Rule ID 21014 //
     /* 1563054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563093 */     // MIs[0] round
     /* 1563093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563096 */     // MIs[0] policy
     /* 1563096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563106 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1563109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563130 */     // GIR_Coverage, 21014,
     /* 1563130 */     GIR_EraseRootFromParent_Done,
     /* 1563131 */   // Label 21681: @1563131
     /* 1563131 */   GIM_Try, /*On fail goto*//*Label 21682*/ GIMT_Encode4(1563213), // Rule ID 21015 //
     /* 1563136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1563147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1563150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563175 */     // MIs[0] round
     /* 1563175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563178 */     // MIs[0] policy
     /* 1563178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563188 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1563191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563212 */     // GIR_Coverage, 21015,
     /* 1563212 */     GIR_EraseRootFromParent_Done,
     /* 1563213 */   // Label 21682: @1563213
     /* 1563213 */   GIM_Try, /*On fail goto*//*Label 21683*/ GIMT_Encode4(1563295), // Rule ID 21018 //
     /* 1563218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563257 */     // MIs[0] round
     /* 1563257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563260 */     // MIs[0] policy
     /* 1563260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563270 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1563273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563294 */     // GIR_Coverage, 21018,
     /* 1563294 */     GIR_EraseRootFromParent_Done,
     /* 1563295 */   // Label 21683: @1563295
     /* 1563295 */   GIM_Try, /*On fail goto*//*Label 21684*/ GIMT_Encode4(1563377), // Rule ID 21019 //
     /* 1563300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1563311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1563314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1563317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563339 */     // MIs[0] round
     /* 1563339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563342 */     // MIs[0] policy
     /* 1563342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563352 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1563355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563376 */     // GIR_Coverage, 21019,
     /* 1563376 */     GIR_EraseRootFromParent_Done,
     /* 1563377 */   // Label 21684: @1563377
     /* 1563377 */   GIM_Try, /*On fail goto*//*Label 21685*/ GIMT_Encode4(1563459), // Rule ID 21022 //
     /* 1563382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563421 */     // MIs[0] round
     /* 1563421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563424 */     // MIs[0] policy
     /* 1563424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563434 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1563437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563458 */     // GIR_Coverage, 21022,
     /* 1563458 */     GIR_EraseRootFromParent_Done,
     /* 1563459 */   // Label 21685: @1563459
     /* 1563459 */   GIM_Try, /*On fail goto*//*Label 21686*/ GIMT_Encode4(1563541), // Rule ID 21023 //
     /* 1563464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1563475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1563478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1563481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1563484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563503 */     // MIs[0] round
     /* 1563503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563506 */     // MIs[0] policy
     /* 1563506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563516 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1563519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1563537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563540 */     // GIR_Coverage, 21023,
     /* 1563540 */     GIR_EraseRootFromParent_Done,
     /* 1563541 */   // Label 21686: @1563541
     /* 1563541 */   GIM_Try, /*On fail goto*//*Label 21687*/ GIMT_Encode4(1563623), // Rule ID 21026 //
     /* 1563546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1563557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1563560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563585 */     // MIs[0] round
     /* 1563585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563588 */     // MIs[0] policy
     /* 1563588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563598 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1563601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563622 */     // GIR_Coverage, 21026,
     /* 1563622 */     GIR_EraseRootFromParent_Done,
     /* 1563623 */   // Label 21687: @1563623
     /* 1563623 */   GIM_Try, /*On fail goto*//*Label 21688*/ GIMT_Encode4(1563705), // Rule ID 21027 //
     /* 1563628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1563639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1563642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1563655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563667 */     // MIs[0] round
     /* 1563667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563670 */     // MIs[0] policy
     /* 1563670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563680 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1563683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563704 */     // GIR_Coverage, 21027,
     /* 1563704 */     GIR_EraseRootFromParent_Done,
     /* 1563705 */   // Label 21688: @1563705
     /* 1563705 */   GIM_Try, /*On fail goto*//*Label 21689*/ GIMT_Encode4(1563787), // Rule ID 21030 //
     /* 1563710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1563721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1563724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1563727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563749 */     // MIs[0] round
     /* 1563749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563752 */     // MIs[0] policy
     /* 1563752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563762 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1563765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563786 */     // GIR_Coverage, 21030,
     /* 1563786 */     GIR_EraseRootFromParent_Done,
     /* 1563787 */   // Label 21689: @1563787
     /* 1563787 */   GIM_Try, /*On fail goto*//*Label 21690*/ GIMT_Encode4(1563869), // Rule ID 21031 //
     /* 1563792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1563803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1563806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1563809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563831 */     // MIs[0] round
     /* 1563831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563834 */     // MIs[0] policy
     /* 1563834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563844 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1563847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563868 */     // GIR_Coverage, 21031,
     /* 1563868 */     GIR_EraseRootFromParent_Done,
     /* 1563869 */   // Label 21690: @1563869
     /* 1563869 */   GIM_Try, /*On fail goto*//*Label 21691*/ GIMT_Encode4(1563951), // Rule ID 21034 //
     /* 1563874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1563877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1563885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1563888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1563891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563913 */     // MIs[0] round
     /* 1563913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563916 */     // MIs[0] policy
     /* 1563916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563926 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1563929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563950 */     // GIR_Coverage, 21034,
     /* 1563950 */     GIR_EraseRootFromParent_Done,
     /* 1563951 */   // Label 21691: @1563951
     /* 1563951 */   GIM_Try, /*On fail goto*//*Label 21692*/ GIMT_Encode4(1564033), // Rule ID 21035 //
     /* 1563956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1563959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1563964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1563967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1563970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1563973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1563976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563995 */     // MIs[0] round
     /* 1563995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563998 */     // MIs[0] policy
     /* 1563998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564008 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1564011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564032 */     // GIR_Coverage, 21035,
     /* 1564032 */     GIR_EraseRootFromParent_Done,
     /* 1564033 */   // Label 21692: @1564033
     /* 1564033 */   GIM_Try, /*On fail goto*//*Label 21693*/ GIMT_Encode4(1564115), // Rule ID 21038 //
     /* 1564038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564077 */     // MIs[0] round
     /* 1564077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564080 */     // MIs[0] policy
     /* 1564080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564090 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1564093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564114 */     // GIR_Coverage, 21038,
     /* 1564114 */     GIR_EraseRootFromParent_Done,
     /* 1564115 */   // Label 21693: @1564115
     /* 1564115 */   GIM_Try, /*On fail goto*//*Label 21694*/ GIMT_Encode4(1564197), // Rule ID 21039 //
     /* 1564120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1564131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1564134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1564137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564159 */     // MIs[0] round
     /* 1564159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564162 */     // MIs[0] policy
     /* 1564162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564172 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11190:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1564175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564196 */     // GIR_Coverage, 21039,
     /* 1564196 */     GIR_EraseRootFromParent_Done,
     /* 1564197 */   // Label 21694: @1564197
     /* 1564197 */   GIM_Try, /*On fail goto*//*Label 21695*/ GIMT_Encode4(1564279), // Rule ID 21042 //
     /* 1564202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564241 */     // MIs[0] round
     /* 1564241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564244 */     // MIs[0] policy
     /* 1564244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564254 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1564257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564278 */     // GIR_Coverage, 21042,
     /* 1564278 */     GIR_EraseRootFromParent_Done,
     /* 1564279 */   // Label 21695: @1564279
     /* 1564279 */   GIM_Try, /*On fail goto*//*Label 21696*/ GIMT_Encode4(1564361), // Rule ID 21043 //
     /* 1564284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1564295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1564298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1564301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564323 */     // MIs[0] round
     /* 1564323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564326 */     // MIs[0] policy
     /* 1564326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564336 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11190:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1564339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564360 */     // GIR_Coverage, 21043,
     /* 1564360 */     GIR_EraseRootFromParent_Done,
     /* 1564361 */   // Label 21696: @1564361
     /* 1564361 */   GIM_Try, /*On fail goto*//*Label 21697*/ GIMT_Encode4(1564443), // Rule ID 21046 //
     /* 1564366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1564369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564405 */     // MIs[0] round
     /* 1564405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564408 */     // MIs[0] policy
     /* 1564408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564418 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1564421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564442 */     // GIR_Coverage, 21046,
     /* 1564442 */     GIR_EraseRootFromParent_Done,
     /* 1564443 */   // Label 21697: @1564443
     /* 1564443 */   GIM_Try, /*On fail goto*//*Label 21698*/ GIMT_Encode4(1564525), // Rule ID 21047 //
     /* 1564448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1564451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1564456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1564459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1564462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1564465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1564475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564487 */     // MIs[0] round
     /* 1564487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564490 */     // MIs[0] policy
     /* 1564490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564500 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11190:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1564503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1564521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564524 */     // GIR_Coverage, 21047,
     /* 1564524 */     GIR_EraseRootFromParent_Done,
     /* 1564525 */   // Label 21698: @1564525
     /* 1564525 */   GIM_Try, /*On fail goto*//*Label 21699*/ GIMT_Encode4(1564607), // Rule ID 21050 //
     /* 1564530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1564541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1564544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1564547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564569 */     // MIs[0] round
     /* 1564569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564572 */     // MIs[0] policy
     /* 1564572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564582 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1564585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564606 */     // GIR_Coverage, 21050,
     /* 1564606 */     GIR_EraseRootFromParent_Done,
     /* 1564607 */   // Label 21699: @1564607
     /* 1564607 */   GIM_Try, /*On fail goto*//*Label 21700*/ GIMT_Encode4(1564689), // Rule ID 21051 //
     /* 1564612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1564623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1564626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1564629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564651 */     // MIs[0] round
     /* 1564651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564654 */     // MIs[0] policy
     /* 1564654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564664 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1564667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564688 */     // GIR_Coverage, 21051,
     /* 1564688 */     GIR_EraseRootFromParent_Done,
     /* 1564689 */   // Label 21700: @1564689
     /* 1564689 */   GIM_Try, /*On fail goto*//*Label 21701*/ GIMT_Encode4(1564771), // Rule ID 21054 //
     /* 1564694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1564705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1564708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1564711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564733 */     // MIs[0] round
     /* 1564733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564736 */     // MIs[0] policy
     /* 1564736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564746 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1564749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564770 */     // GIR_Coverage, 21054,
     /* 1564770 */     GIR_EraseRootFromParent_Done,
     /* 1564771 */   // Label 21701: @1564771
     /* 1564771 */   GIM_Try, /*On fail goto*//*Label 21702*/ GIMT_Encode4(1564853), // Rule ID 21055 //
     /* 1564776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1564787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1564790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1564793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564815 */     // MIs[0] round
     /* 1564815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564818 */     // MIs[0] policy
     /* 1564818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564828 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1564831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564852 */     // GIR_Coverage, 21055,
     /* 1564852 */     GIR_EraseRootFromParent_Done,
     /* 1564853 */   // Label 21702: @1564853
     /* 1564853 */   GIM_Try, /*On fail goto*//*Label 21703*/ GIMT_Encode4(1564935), // Rule ID 21058 //
     /* 1564858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1564869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1564872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1564875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564897 */     // MIs[0] round
     /* 1564897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564900 */     // MIs[0] policy
     /* 1564900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564910 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1564913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1564931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564934 */     // GIR_Coverage, 21058,
     /* 1564934 */     GIR_EraseRootFromParent_Done,
     /* 1564935 */   // Label 21703: @1564935
     /* 1564935 */   GIM_Try, /*On fail goto*//*Label 21704*/ GIMT_Encode4(1565017), // Rule ID 21059 //
     /* 1564940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1564948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1564951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1564954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1564957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564979 */     // MIs[0] round
     /* 1564979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564982 */     // MIs[0] policy
     /* 1564982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564992 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1564995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565016 */     // GIR_Coverage, 21059,
     /* 1565016 */     GIR_EraseRootFromParent_Done,
     /* 1565017 */   // Label 21704: @1565017
     /* 1565017 */   GIM_Try, /*On fail goto*//*Label 21705*/ GIMT_Encode4(1565099), // Rule ID 21062 //
     /* 1565022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565061 */     // MIs[0] round
     /* 1565061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565064 */     // MIs[0] policy
     /* 1565064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565074 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1565077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565098 */     // GIR_Coverage, 21062,
     /* 1565098 */     GIR_EraseRootFromParent_Done,
     /* 1565099 */   // Label 21705: @1565099
     /* 1565099 */   GIM_Try, /*On fail goto*//*Label 21706*/ GIMT_Encode4(1565181), // Rule ID 21063 //
     /* 1565104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1565115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1565118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1565121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565143 */     // MIs[0] round
     /* 1565143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565146 */     // MIs[0] policy
     /* 1565146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565156 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1565159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565180 */     // GIR_Coverage, 21063,
     /* 1565180 */     GIR_EraseRootFromParent_Done,
     /* 1565181 */   // Label 21706: @1565181
     /* 1565181 */   GIM_Try, /*On fail goto*//*Label 21707*/ GIMT_Encode4(1565263), // Rule ID 21066 //
     /* 1565186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1565189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565225 */     // MIs[0] round
     /* 1565225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565228 */     // MIs[0] policy
     /* 1565228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565238 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1565241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565262 */     // GIR_Coverage, 21066,
     /* 1565262 */     GIR_EraseRootFromParent_Done,
     /* 1565263 */   // Label 21707: @1565263
     /* 1565263 */   GIM_Try, /*On fail goto*//*Label 21708*/ GIMT_Encode4(1565345), // Rule ID 21067 //
     /* 1565268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1565285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565307 */     // MIs[0] round
     /* 1565307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565310 */     // MIs[0] policy
     /* 1565310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565320 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1565323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565344 */     // GIR_Coverage, 21067,
     /* 1565344 */     GIR_EraseRootFromParent_Done,
     /* 1565345 */   // Label 21708: @1565345
     /* 1565345 */   GIM_Try, /*On fail goto*//*Label 21709*/ GIMT_Encode4(1565427), // Rule ID 21070 //
     /* 1565350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1565353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565389 */     // MIs[0] round
     /* 1565389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565392 */     // MIs[0] policy
     /* 1565392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565402 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1565405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565426 */     // GIR_Coverage, 21070,
     /* 1565426 */     GIR_EraseRootFromParent_Done,
     /* 1565427 */   // Label 21709: @1565427
     /* 1565427 */   GIM_Try, /*On fail goto*//*Label 21710*/ GIMT_Encode4(1565509), // Rule ID 21071 //
     /* 1565432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1565435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1565443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1565446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565471 */     // MIs[0] round
     /* 1565471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565474 */     // MIs[0] policy
     /* 1565474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565484 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1565487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1565505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565508 */     // GIR_Coverage, 21071,
     /* 1565508 */     GIR_EraseRootFromParent_Done,
     /* 1565509 */   // Label 21710: @1565509
     /* 1565509 */   GIM_Try, /*On fail goto*//*Label 21711*/ GIMT_Encode4(1565591), // Rule ID 21074 //
     /* 1565514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1565525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1565528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1565531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565553 */     // MIs[0] round
     /* 1565553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565556 */     // MIs[0] policy
     /* 1565556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565566 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1565569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565590 */     // GIR_Coverage, 21074,
     /* 1565590 */     GIR_EraseRootFromParent_Done,
     /* 1565591 */   // Label 21711: @1565591
     /* 1565591 */   GIM_Try, /*On fail goto*//*Label 21712*/ GIMT_Encode4(1565673), // Rule ID 21075 //
     /* 1565596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1565607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1565610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1565613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565635 */     // MIs[0] round
     /* 1565635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565638 */     // MIs[0] policy
     /* 1565638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565648 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1565651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565672 */     // GIR_Coverage, 21075,
     /* 1565672 */     GIR_EraseRootFromParent_Done,
     /* 1565673 */   // Label 21712: @1565673
     /* 1565673 */   GIM_Try, /*On fail goto*//*Label 21713*/ GIMT_Encode4(1565755), // Rule ID 21078 //
     /* 1565678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1565689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1565692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1565695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565717 */     // MIs[0] round
     /* 1565717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565720 */     // MIs[0] policy
     /* 1565720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565730 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1565733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565754 */     // GIR_Coverage, 21078,
     /* 1565754 */     GIR_EraseRootFromParent_Done,
     /* 1565755 */   // Label 21713: @1565755
     /* 1565755 */   GIM_Try, /*On fail goto*//*Label 21714*/ GIMT_Encode4(1565837), // Rule ID 21079 //
     /* 1565760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1565771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1565774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1565777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565799 */     // MIs[0] round
     /* 1565799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565802 */     // MIs[0] policy
     /* 1565802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565812 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1565815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565836 */     // GIR_Coverage, 21079,
     /* 1565836 */     GIR_EraseRootFromParent_Done,
     /* 1565837 */   // Label 21714: @1565837
     /* 1565837 */   GIM_Try, /*On fail goto*//*Label 21715*/ GIMT_Encode4(1565919), // Rule ID 21082 //
     /* 1565842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1565853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1565856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1565859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1565862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565881 */     // MIs[0] round
     /* 1565881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565884 */     // MIs[0] policy
     /* 1565884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565894 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1565897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565918 */     // GIR_Coverage, 21082,
     /* 1565918 */     GIR_EraseRootFromParent_Done,
     /* 1565919 */   // Label 21715: @1565919
     /* 1565919 */   GIM_Try, /*On fail goto*//*Label 21716*/ GIMT_Encode4(1566001), // Rule ID 21083 //
     /* 1565924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1565932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1565935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1565938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1565941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1565944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1565951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565963 */     // MIs[0] round
     /* 1565963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565966 */     // MIs[0] policy
     /* 1565966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565976 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1565979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566000 */     // GIR_Coverage, 21083,
     /* 1566000 */     GIR_EraseRootFromParent_Done,
     /* 1566001 */   // Label 21716: @1566001
     /* 1566001 */   GIM_Try, /*On fail goto*//*Label 21717*/ GIMT_Encode4(1566083), // Rule ID 21086 //
     /* 1566006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566045 */     // MIs[0] round
     /* 1566045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566048 */     // MIs[0] policy
     /* 1566048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566058 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1566061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566082 */     // GIR_Coverage, 21086,
     /* 1566082 */     GIR_EraseRootFromParent_Done,
     /* 1566083 */   // Label 21717: @1566083
     /* 1566083 */   GIM_Try, /*On fail goto*//*Label 21718*/ GIMT_Encode4(1566165), // Rule ID 21087 //
     /* 1566088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1566099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1566102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1566105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566127 */     // MIs[0] round
     /* 1566127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566130 */     // MIs[0] policy
     /* 1566130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566140 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1566143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566164 */     // GIR_Coverage, 21087,
     /* 1566164 */     GIR_EraseRootFromParent_Done,
     /* 1566165 */   // Label 21718: @1566165
     /* 1566165 */   GIM_Try, /*On fail goto*//*Label 21719*/ GIMT_Encode4(1566247), // Rule ID 21090 //
     /* 1566170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566209 */     // MIs[0] round
     /* 1566209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566212 */     // MIs[0] policy
     /* 1566212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566222 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1566225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566246 */     // GIR_Coverage, 21090,
     /* 1566246 */     GIR_EraseRootFromParent_Done,
     /* 1566247 */   // Label 21719: @1566247
     /* 1566247 */   GIM_Try, /*On fail goto*//*Label 21720*/ GIMT_Encode4(1566329), // Rule ID 21091 //
     /* 1566252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1566263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1566266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1566269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566291 */     // MIs[0] round
     /* 1566291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566294 */     // MIs[0] policy
     /* 1566294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566304 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1566307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566328 */     // GIR_Coverage, 21091,
     /* 1566328 */     GIR_EraseRootFromParent_Done,
     /* 1566329 */   // Label 21720: @1566329
     /* 1566329 */   GIM_Try, /*On fail goto*//*Label 21721*/ GIMT_Encode4(1566411), // Rule ID 21094 //
     /* 1566334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1566351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566373 */     // MIs[0] round
     /* 1566373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566376 */     // MIs[0] policy
     /* 1566376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566386 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1566389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566410 */     // GIR_Coverage, 21094,
     /* 1566410 */     GIR_EraseRootFromParent_Done,
     /* 1566411 */   // Label 21721: @1566411
     /* 1566411 */   GIM_Try, /*On fail goto*//*Label 21722*/ GIMT_Encode4(1566493), // Rule ID 21095 //
     /* 1566416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1566427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1566430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1566433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566455 */     // MIs[0] round
     /* 1566455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566458 */     // MIs[0] policy
     /* 1566458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566468 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1566471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1566489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566492 */     // GIR_Coverage, 21095,
     /* 1566492 */     GIR_EraseRootFromParent_Done,
     /* 1566493 */   // Label 21722: @1566493
     /* 1566493 */   GIM_Try, /*On fail goto*//*Label 21723*/ GIMT_Encode4(1566575), // Rule ID 21098 //
     /* 1566498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1566501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1566509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1566512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1566515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566537 */     // MIs[0] round
     /* 1566537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566540 */     // MIs[0] policy
     /* 1566540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566550 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1566553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566574 */     // GIR_Coverage, 21098,
     /* 1566574 */     GIR_EraseRootFromParent_Done,
     /* 1566575 */   // Label 21723: @1566575
     /* 1566575 */   GIM_Try, /*On fail goto*//*Label 21724*/ GIMT_Encode4(1566657), // Rule ID 21099 //
     /* 1566580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1566583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1566591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1566594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1566597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566619 */     // MIs[0] round
     /* 1566619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566622 */     // MIs[0] policy
     /* 1566622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566632 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1566635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566656 */     // GIR_Coverage, 21099,
     /* 1566656 */     GIR_EraseRootFromParent_Done,
     /* 1566657 */   // Label 21724: @1566657
     /* 1566657 */   GIM_Try, /*On fail goto*//*Label 21725*/ GIMT_Encode4(1566739), // Rule ID 21102 //
     /* 1566662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1566665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1566673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1566676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1566679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566701 */     // MIs[0] round
     /* 1566701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566704 */     // MIs[0] policy
     /* 1566704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566714 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1566717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566738 */     // GIR_Coverage, 21102,
     /* 1566738 */     GIR_EraseRootFromParent_Done,
     /* 1566739 */   // Label 21725: @1566739
     /* 1566739 */   GIM_Try, /*On fail goto*//*Label 21726*/ GIMT_Encode4(1566821), // Rule ID 21103 //
     /* 1566744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1566747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1566755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1566758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1566761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566783 */     // MIs[0] round
     /* 1566783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566786 */     // MIs[0] policy
     /* 1566786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566796 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1566799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566820 */     // GIR_Coverage, 21103,
     /* 1566820 */     GIR_EraseRootFromParent_Done,
     /* 1566821 */   // Label 21726: @1566821
     /* 1566821 */   GIM_Try, /*On fail goto*//*Label 21727*/ GIMT_Encode4(1566903), // Rule ID 21106 //
     /* 1566826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1566829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1566837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1566840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1566843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566865 */     // MIs[0] round
     /* 1566865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566868 */     // MIs[0] policy
     /* 1566868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566878 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1566881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566902 */     // GIR_Coverage, 21106,
     /* 1566902 */     GIR_EraseRootFromParent_Done,
     /* 1566903 */   // Label 21727: @1566903
     /* 1566903 */   GIM_Try, /*On fail goto*//*Label 21728*/ GIMT_Encode4(1566985), // Rule ID 21107 //
     /* 1566908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1566911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1566916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1566919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1566922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1566925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1566935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566947 */     // MIs[0] round
     /* 1566947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566950 */     // MIs[0] policy
     /* 1566950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566960 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1566963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1566981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566984 */     // GIR_Coverage, 21107,
     /* 1566984 */     GIR_EraseRootFromParent_Done,
     /* 1566985 */   // Label 21728: @1566985
     /* 1566985 */   GIM_Try, /*On fail goto*//*Label 21729*/ GIMT_Encode4(1567067), // Rule ID 21182 //
     /* 1566990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1566998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567029 */     // MIs[0] round
     /* 1567029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567032 */     // MIs[0] policy
     /* 1567032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1567045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567066 */     // GIR_Coverage, 21182,
     /* 1567066 */     GIR_EraseRootFromParent_Done,
     /* 1567067 */   // Label 21729: @1567067
     /* 1567067 */   GIM_Try, /*On fail goto*//*Label 21730*/ GIMT_Encode4(1567149), // Rule ID 21183 //
     /* 1567072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1567089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567111 */     // MIs[0] round
     /* 1567111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567114 */     // MIs[0] policy
     /* 1567114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567124 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1567127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567148 */     // GIR_Coverage, 21183,
     /* 1567148 */     GIR_EraseRootFromParent_Done,
     /* 1567149 */   // Label 21730: @1567149
     /* 1567149 */   GIM_Try, /*On fail goto*//*Label 21731*/ GIMT_Encode4(1567231), // Rule ID 21186 //
     /* 1567154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567193 */     // MIs[0] round
     /* 1567193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567196 */     // MIs[0] policy
     /* 1567196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567230 */     // GIR_Coverage, 21186,
     /* 1567230 */     GIR_EraseRootFromParent_Done,
     /* 1567231 */   // Label 21731: @1567231
     /* 1567231 */   GIM_Try, /*On fail goto*//*Label 21732*/ GIMT_Encode4(1567313), // Rule ID 21187 //
     /* 1567236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1567253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567275 */     // MIs[0] round
     /* 1567275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567278 */     // MIs[0] policy
     /* 1567278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11296:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567312 */     // GIR_Coverage, 21187,
     /* 1567312 */     GIR_EraseRootFromParent_Done,
     /* 1567313 */   // Label 21732: @1567313
     /* 1567313 */   GIM_Try, /*On fail goto*//*Label 21733*/ GIMT_Encode4(1567395), // Rule ID 21190 //
     /* 1567318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1567335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567357 */     // MIs[0] round
     /* 1567357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567360 */     // MIs[0] policy
     /* 1567360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1567373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567394 */     // GIR_Coverage, 21190,
     /* 1567394 */     GIR_EraseRootFromParent_Done,
     /* 1567395 */   // Label 21733: @1567395
     /* 1567395 */   GIM_Try, /*On fail goto*//*Label 21734*/ GIMT_Encode4(1567477), // Rule ID 21191 //
     /* 1567400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1567417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567439 */     // MIs[0] round
     /* 1567439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567442 */     // MIs[0] policy
     /* 1567442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1567455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567476 */     // GIR_Coverage, 21191,
     /* 1567476 */     GIR_EraseRootFromParent_Done,
     /* 1567477 */   // Label 21734: @1567477
     /* 1567477 */   GIM_Try, /*On fail goto*//*Label 21735*/ GIMT_Encode4(1567559), // Rule ID 21194 //
     /* 1567482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1567499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567521 */     // MIs[0] round
     /* 1567521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567524 */     // MIs[0] policy
     /* 1567524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1567537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567558 */     // GIR_Coverage, 21194,
     /* 1567558 */     GIR_EraseRootFromParent_Done,
     /* 1567559 */   // Label 21735: @1567559
     /* 1567559 */   GIM_Try, /*On fail goto*//*Label 21736*/ GIMT_Encode4(1567641), // Rule ID 21195 //
     /* 1567564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1567575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1567578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1567581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567603 */     // MIs[0] round
     /* 1567603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567606 */     // MIs[0] policy
     /* 1567606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567616 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1567619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567640 */     // GIR_Coverage, 21195,
     /* 1567640 */     GIR_EraseRootFromParent_Done,
     /* 1567641 */   // Label 21736: @1567641
     /* 1567641 */   GIM_Try, /*On fail goto*//*Label 21737*/ GIMT_Encode4(1567723), // Rule ID 21198 //
     /* 1567646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1567649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1567657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1567660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1567663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567685 */     // MIs[0] round
     /* 1567685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567688 */     // MIs[0] policy
     /* 1567688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567698 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1567701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567722 */     // GIR_Coverage, 21198,
     /* 1567722 */     GIR_EraseRootFromParent_Done,
     /* 1567723 */   // Label 21737: @1567723
     /* 1567723 */   GIM_Try, /*On fail goto*//*Label 21738*/ GIMT_Encode4(1567805), // Rule ID 21199 //
     /* 1567728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1567731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1567739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1567742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1567745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1567755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567767 */     // MIs[0] round
     /* 1567767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567770 */     // MIs[0] policy
     /* 1567770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567780 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1567783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567804 */     // GIR_Coverage, 21199,
     /* 1567804 */     GIR_EraseRootFromParent_Done,
     /* 1567805 */   // Label 21738: @1567805
     /* 1567805 */   GIM_Try, /*On fail goto*//*Label 21739*/ GIMT_Encode4(1567887), // Rule ID 21202 //
     /* 1567810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1567813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1567821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1567824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1567827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567849 */     // MIs[0] round
     /* 1567849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567852 */     // MIs[0] policy
     /* 1567852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567862 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567886 */     // GIR_Coverage, 21202,
     /* 1567886 */     GIR_EraseRootFromParent_Done,
     /* 1567887 */   // Label 21739: @1567887
     /* 1567887 */   GIM_Try, /*On fail goto*//*Label 21740*/ GIMT_Encode4(1567969), // Rule ID 21203 //
     /* 1567892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1567895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1567903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1567906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1567909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567931 */     // MIs[0] round
     /* 1567931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567934 */     // MIs[0] policy
     /* 1567934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567944 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11296:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1567947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567968 */     // GIR_Coverage, 21203,
     /* 1567968 */     GIR_EraseRootFromParent_Done,
     /* 1567969 */   // Label 21740: @1567969
     /* 1567969 */   GIM_Try, /*On fail goto*//*Label 21741*/ GIMT_Encode4(1568051), // Rule ID 21206 //
     /* 1567974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1567977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1567982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1567985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1567988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1567991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568013 */     // MIs[0] round
     /* 1568013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568016 */     // MIs[0] policy
     /* 1568016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568026 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1568029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568050 */     // GIR_Coverage, 21206,
     /* 1568050 */     GIR_EraseRootFromParent_Done,
     /* 1568051 */   // Label 21741: @1568051
     /* 1568051 */   GIM_Try, /*On fail goto*//*Label 21742*/ GIMT_Encode4(1568133), // Rule ID 21207 //
     /* 1568056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1568067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1568070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568095 */     // MIs[0] round
     /* 1568095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568098 */     // MIs[0] policy
     /* 1568098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11296:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1568111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568132 */     // GIR_Coverage, 21207,
     /* 1568132 */     GIR_EraseRootFromParent_Done,
     /* 1568133 */   // Label 21742: @1568133
     /* 1568133 */   GIM_Try, /*On fail goto*//*Label 21743*/ GIMT_Encode4(1568215), // Rule ID 21210 //
     /* 1568138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568177 */     // MIs[0] round
     /* 1568177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568180 */     // MIs[0] policy
     /* 1568180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568214 */     // GIR_Coverage, 21210,
     /* 1568214 */     GIR_EraseRootFromParent_Done,
     /* 1568215 */   // Label 21743: @1568215
     /* 1568215 */   GIM_Try, /*On fail goto*//*Label 21744*/ GIMT_Encode4(1568297), // Rule ID 21211 //
     /* 1568220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1568231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1568234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568259 */     // MIs[0] round
     /* 1568259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568262 */     // MIs[0] policy
     /* 1568262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568272 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11296:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1568275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568296 */     // GIR_Coverage, 21211,
     /* 1568296 */     GIR_EraseRootFromParent_Done,
     /* 1568297 */   // Label 21744: @1568297
     /* 1568297 */   GIM_Try, /*On fail goto*//*Label 21745*/ GIMT_Encode4(1568379), // Rule ID 21214 //
     /* 1568302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1568305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568341 */     // MIs[0] round
     /* 1568341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568344 */     // MIs[0] policy
     /* 1568344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568354 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568378 */     // GIR_Coverage, 21214,
     /* 1568378 */     GIR_EraseRootFromParent_Done,
     /* 1568379 */   // Label 21745: @1568379
     /* 1568379 */   GIM_Try, /*On fail goto*//*Label 21746*/ GIMT_Encode4(1568461), // Rule ID 21215 //
     /* 1568384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1568387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1568392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1568395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1568398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1568411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568423 */     // MIs[0] round
     /* 1568423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568426 */     // MIs[0] policy
     /* 1568426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568436 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11296:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1568439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568460 */     // GIR_Coverage, 21215,
     /* 1568460 */     GIR_EraseRootFromParent_Done,
     /* 1568461 */   // Label 21746: @1568461
     /* 1568461 */   GIM_Try, /*On fail goto*//*Label 21747*/ GIMT_Encode4(1568543), // Rule ID 21218 //
     /* 1568466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568505 */     // MIs[0] round
     /* 1568505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568508 */     // MIs[0] policy
     /* 1568508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568518 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1568521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568542 */     // GIR_Coverage, 21218,
     /* 1568542 */     GIR_EraseRootFromParent_Done,
     /* 1568543 */   // Label 21747: @1568543
     /* 1568543 */   GIM_Try, /*On fail goto*//*Label 21748*/ GIMT_Encode4(1568625), // Rule ID 21219 //
     /* 1568548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1568559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1568562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1568565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568587 */     // MIs[0] round
     /* 1568587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568590 */     // MIs[0] policy
     /* 1568590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568600 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1568603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568624 */     // GIR_Coverage, 21219,
     /* 1568624 */     GIR_EraseRootFromParent_Done,
     /* 1568625 */   // Label 21748: @1568625
     /* 1568625 */   GIM_Try, /*On fail goto*//*Label 21749*/ GIMT_Encode4(1568707), // Rule ID 21222 //
     /* 1568630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1568641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1568644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1568647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568669 */     // MIs[0] round
     /* 1568669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568672 */     // MIs[0] policy
     /* 1568672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568682 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1568685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568706 */     // GIR_Coverage, 21222,
     /* 1568706 */     GIR_EraseRootFromParent_Done,
     /* 1568707 */   // Label 21749: @1568707
     /* 1568707 */   GIM_Try, /*On fail goto*//*Label 21750*/ GIMT_Encode4(1568789), // Rule ID 21223 //
     /* 1568712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1568723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1568726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1568729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568751 */     // MIs[0] round
     /* 1568751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568754 */     // MIs[0] policy
     /* 1568754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11294:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1568767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568788 */     // GIR_Coverage, 21223,
     /* 1568788 */     GIR_EraseRootFromParent_Done,
     /* 1568789 */   // Label 21750: @1568789
     /* 1568789 */   GIM_Try, /*On fail goto*//*Label 21751*/ GIMT_Encode4(1568871), // Rule ID 21226 //
     /* 1568794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1568805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1568808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1568811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568833 */     // MIs[0] round
     /* 1568833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568836 */     // MIs[0] policy
     /* 1568836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568846 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1568849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568870 */     // GIR_Coverage, 21226,
     /* 1568870 */     GIR_EraseRootFromParent_Done,
     /* 1568871 */   // Label 21751: @1568871
     /* 1568871 */   GIM_Try, /*On fail goto*//*Label 21752*/ GIMT_Encode4(1568953), // Rule ID 21227 //
     /* 1568876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1568887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1568890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1568893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568915 */     // MIs[0] round
     /* 1568915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568918 */     // MIs[0] policy
     /* 1568918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1568931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568952 */     // GIR_Coverage, 21227,
     /* 1568952 */     GIR_EraseRootFromParent_Done,
     /* 1568953 */   // Label 21752: @1568953
     /* 1568953 */   GIM_Try, /*On fail goto*//*Label 21753*/ GIMT_Encode4(1569035), // Rule ID 21230 //
     /* 1568958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1568966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1568969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1568972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1568975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568997 */     // MIs[0] round
     /* 1568997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569000 */     // MIs[0] policy
     /* 1569000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569010 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569034 */     // GIR_Coverage, 21230,
     /* 1569034 */     GIR_EraseRootFromParent_Done,
     /* 1569035 */   // Label 21753: @1569035
     /* 1569035 */   GIM_Try, /*On fail goto*//*Label 21754*/ GIMT_Encode4(1569117), // Rule ID 21231 //
     /* 1569040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1569051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1569054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1569057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569079 */     // MIs[0] round
     /* 1569079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569082 */     // MIs[0] policy
     /* 1569082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569092 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569116 */     // GIR_Coverage, 21231,
     /* 1569116 */     GIR_EraseRootFromParent_Done,
     /* 1569117 */   // Label 21754: @1569117
     /* 1569117 */   GIM_Try, /*On fail goto*//*Label 21755*/ GIMT_Encode4(1569199), // Rule ID 21234 //
     /* 1569122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1569133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1569136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569161 */     // MIs[0] round
     /* 1569161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569164 */     // MIs[0] policy
     /* 1569164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569198 */     // GIR_Coverage, 21234,
     /* 1569198 */     GIR_EraseRootFromParent_Done,
     /* 1569199 */   // Label 21755: @1569199
     /* 1569199 */   GIM_Try, /*On fail goto*//*Label 21756*/ GIMT_Encode4(1569281), // Rule ID 21235 //
     /* 1569204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1569215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1569218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1569221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569243 */     // MIs[0] round
     /* 1569243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569246 */     // MIs[0] policy
     /* 1569246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569256 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569280 */     // GIR_Coverage, 21235,
     /* 1569280 */     GIR_EraseRootFromParent_Done,
     /* 1569281 */   // Label 21756: @1569281
     /* 1569281 */   GIM_Try, /*On fail goto*//*Label 21757*/ GIMT_Encode4(1569363), // Rule ID 21238 //
     /* 1569286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569325 */     // MIs[0] round
     /* 1569325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569328 */     // MIs[0] policy
     /* 1569328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569338 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569347 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569362 */     // GIR_Coverage, 21238,
     /* 1569362 */     GIR_EraseRootFromParent_Done,
     /* 1569363 */   // Label 21757: @1569363
     /* 1569363 */   GIM_Try, /*On fail goto*//*Label 21758*/ GIMT_Encode4(1569445), // Rule ID 21239 //
     /* 1569368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1569379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1569382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569407 */     // MIs[0] round
     /* 1569407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569410 */     // MIs[0] policy
     /* 1569410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11294:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1569423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569444 */     // GIR_Coverage, 21239,
     /* 1569444 */     GIR_EraseRootFromParent_Done,
     /* 1569445 */   // Label 21758: @1569445
     /* 1569445 */   GIM_Try, /*On fail goto*//*Label 21759*/ GIMT_Encode4(1569527), // Rule ID 21242 //
     /* 1569450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1569461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1569464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569489 */     // MIs[0] round
     /* 1569489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569492 */     // MIs[0] policy
     /* 1569492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569526 */     // GIR_Coverage, 21242,
     /* 1569526 */     GIR_EraseRootFromParent_Done,
     /* 1569527 */   // Label 21759: @1569527
     /* 1569527 */   GIM_Try, /*On fail goto*//*Label 21760*/ GIMT_Encode4(1569609), // Rule ID 21243 //
     /* 1569532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1569543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1569546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569571 */     // MIs[0] round
     /* 1569571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569574 */     // MIs[0] policy
     /* 1569574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11294:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1569587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569608 */     // GIR_Coverage, 21243,
     /* 1569608 */     GIR_EraseRootFromParent_Done,
     /* 1569609 */   // Label 21760: @1569609
     /* 1569609 */   GIM_Try, /*On fail goto*//*Label 21761*/ GIMT_Encode4(1569691), // Rule ID 21246 //
     /* 1569614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1569625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1569628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1569631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569653 */     // MIs[0] round
     /* 1569653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569656 */     // MIs[0] policy
     /* 1569656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569666 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569690 */     // GIR_Coverage, 21246,
     /* 1569690 */     GIR_EraseRootFromParent_Done,
     /* 1569691 */   // Label 21761: @1569691
     /* 1569691 */   GIM_Try, /*On fail goto*//*Label 21762*/ GIMT_Encode4(1569773), // Rule ID 21247 //
     /* 1569696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1569707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1569710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1569713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569735 */     // MIs[0] round
     /* 1569735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569738 */     // MIs[0] policy
     /* 1569738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569748 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11294:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1569751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569772 */     // GIR_Coverage, 21247,
     /* 1569772 */     GIR_EraseRootFromParent_Done,
     /* 1569773 */   // Label 21762: @1569773
     /* 1569773 */   GIM_Try, /*On fail goto*//*Label 21763*/ GIMT_Encode4(1569855), // Rule ID 21250 //
     /* 1569778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1569789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1569792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1569795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569817 */     // MIs[0] round
     /* 1569817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569820 */     // MIs[0] policy
     /* 1569820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569830 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569854 */     // GIR_Coverage, 21250,
     /* 1569854 */     GIR_EraseRootFromParent_Done,
     /* 1569855 */   // Label 21763: @1569855
     /* 1569855 */   GIM_Try, /*On fail goto*//*Label 21764*/ GIMT_Encode4(1569937), // Rule ID 21251 //
     /* 1569860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1569868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1569871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1569874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1569877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1569887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569899 */     // MIs[0] round
     /* 1569899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569902 */     // MIs[0] policy
     /* 1569902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569912 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11294:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1569915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569936 */     // GIR_Coverage, 21251,
     /* 1569936 */     GIR_EraseRootFromParent_Done,
     /* 1569937 */   // Label 21764: @1569937
     /* 1569937 */   GIM_Try, /*On fail goto*//*Label 21765*/ GIMT_Encode4(1570019), // Rule ID 21602 //
     /* 1569942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1569950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1569953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1569956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1569959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569981 */     // MIs[0] round
     /* 1569981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569984 */     // MIs[0] policy
     /* 1569984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569994 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1569997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570018 */     // GIR_Coverage, 21602,
     /* 1570018 */     GIR_EraseRootFromParent_Done,
     /* 1570019 */   // Label 21765: @1570019
     /* 1570019 */   GIM_Try, /*On fail goto*//*Label 21766*/ GIMT_Encode4(1570101), // Rule ID 21603 //
     /* 1570024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1570035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1570038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1570041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570063 */     // MIs[0] round
     /* 1570063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570066 */     // MIs[0] policy
     /* 1570066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570076 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1570079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570100 */     // GIR_Coverage, 21603,
     /* 1570100 */     GIR_EraseRootFromParent_Done,
     /* 1570101 */   // Label 21766: @1570101
     /* 1570101 */   GIM_Try, /*On fail goto*//*Label 21767*/ GIMT_Encode4(1570183), // Rule ID 21606 //
     /* 1570106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570145 */     // MIs[0] round
     /* 1570145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570148 */     // MIs[0] policy
     /* 1570148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570158 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570182 */     // GIR_Coverage, 21606,
     /* 1570182 */     GIR_EraseRootFromParent_Done,
     /* 1570183 */   // Label 21767: @1570183
     /* 1570183 */   GIM_Try, /*On fail goto*//*Label 21768*/ GIMT_Encode4(1570265), // Rule ID 21607 //
     /* 1570188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1570199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1570202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1570205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570227 */     // MIs[0] round
     /* 1570227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570230 */     // MIs[0] policy
     /* 1570230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570240 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570264 */     // GIR_Coverage, 21607,
     /* 1570264 */     GIR_EraseRootFromParent_Done,
     /* 1570265 */   // Label 21768: @1570265
     /* 1570265 */   GIM_Try, /*On fail goto*//*Label 21769*/ GIMT_Encode4(1570347), // Rule ID 21610 //
     /* 1570270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570309 */     // MIs[0] round
     /* 1570309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570312 */     // MIs[0] policy
     /* 1570312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570322 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1570325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570346 */     // GIR_Coverage, 21610,
     /* 1570346 */     GIR_EraseRootFromParent_Done,
     /* 1570347 */   // Label 21769: @1570347
     /* 1570347 */   GIM_Try, /*On fail goto*//*Label 21770*/ GIMT_Encode4(1570429), // Rule ID 21611 //
     /* 1570352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1570363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1570366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1570369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570391 */     // MIs[0] round
     /* 1570391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570394 */     // MIs[0] policy
     /* 1570394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570404 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1570407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570428 */     // GIR_Coverage, 21611,
     /* 1570428 */     GIR_EraseRootFromParent_Done,
     /* 1570429 */   // Label 21770: @1570429
     /* 1570429 */   GIM_Try, /*On fail goto*//*Label 21771*/ GIMT_Encode4(1570511), // Rule ID 21614 //
     /* 1570434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1570445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1570448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570473 */     // MIs[0] round
     /* 1570473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570476 */     // MIs[0] policy
     /* 1570476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570486 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1570489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570510 */     // GIR_Coverage, 21614,
     /* 1570510 */     GIR_EraseRootFromParent_Done,
     /* 1570511 */   // Label 21771: @1570511
     /* 1570511 */   GIM_Try, /*On fail goto*//*Label 21772*/ GIMT_Encode4(1570593), // Rule ID 21615 //
     /* 1570516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1570527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1570530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1570533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570555 */     // MIs[0] round
     /* 1570555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570558 */     // MIs[0] policy
     /* 1570558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11238:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1570571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570592 */     // GIR_Coverage, 21615,
     /* 1570592 */     GIR_EraseRootFromParent_Done,
     /* 1570593 */   // Label 21772: @1570593
     /* 1570593 */   GIM_Try, /*On fail goto*//*Label 21773*/ GIMT_Encode4(1570675), // Rule ID 21618 //
     /* 1570598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1570609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1570612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1570615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570637 */     // MIs[0] round
     /* 1570637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570640 */     // MIs[0] policy
     /* 1570640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1570653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570674 */     // GIR_Coverage, 21618,
     /* 1570674 */     GIR_EraseRootFromParent_Done,
     /* 1570675 */   // Label 21773: @1570675
     /* 1570675 */   GIM_Try, /*On fail goto*//*Label 21774*/ GIMT_Encode4(1570757), // Rule ID 21619 //
     /* 1570680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1570691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1570694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1570697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570719 */     // MIs[0] round
     /* 1570719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570722 */     // MIs[0] policy
     /* 1570722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570732 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1570735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570756 */     // GIR_Coverage, 21619,
     /* 1570756 */     GIR_EraseRootFromParent_Done,
     /* 1570757 */   // Label 21774: @1570757
     /* 1570757 */   GIM_Try, /*On fail goto*//*Label 21775*/ GIMT_Encode4(1570839), // Rule ID 21622 //
     /* 1570762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1570773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1570776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1570779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1570782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570801 */     // MIs[0] round
     /* 1570801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570804 */     // MIs[0] policy
     /* 1570804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1570817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570838 */     // GIR_Coverage, 21622,
     /* 1570838 */     GIR_EraseRootFromParent_Done,
     /* 1570839 */   // Label 21775: @1570839
     /* 1570839 */   GIM_Try, /*On fail goto*//*Label 21776*/ GIMT_Encode4(1570921), // Rule ID 21623 //
     /* 1570844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1570855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1570858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1570861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1570864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570883 */     // MIs[0] round
     /* 1570883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570886 */     // MIs[0] policy
     /* 1570886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570896 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1570899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1570917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570920 */     // GIR_Coverage, 21623,
     /* 1570920 */     GIR_EraseRootFromParent_Done,
     /* 1570921 */   // Label 21776: @1570921
     /* 1570921 */   GIM_Try, /*On fail goto*//*Label 21777*/ GIMT_Encode4(1571003), // Rule ID 21626 //
     /* 1570926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1570929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1570934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1570937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1570940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1570943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570965 */     // MIs[0] round
     /* 1570965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570968 */     // MIs[0] policy
     /* 1570968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1570981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571002 */     // GIR_Coverage, 21626,
     /* 1571002 */     GIR_EraseRootFromParent_Done,
     /* 1571003 */   // Label 21777: @1571003
     /* 1571003 */   GIM_Try, /*On fail goto*//*Label 21778*/ GIMT_Encode4(1571085), // Rule ID 21627 //
     /* 1571008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571047 */     // MIs[0] round
     /* 1571047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571050 */     // MIs[0] policy
     /* 1571050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1571063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571084 */     // GIR_Coverage, 21627,
     /* 1571084 */     GIR_EraseRootFromParent_Done,
     /* 1571085 */   // Label 21778: @1571085
     /* 1571085 */   GIM_Try, /*On fail goto*//*Label 21779*/ GIMT_Encode4(1571167), // Rule ID 21630 //
     /* 1571090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571129 */     // MIs[0] round
     /* 1571129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571132 */     // MIs[0] policy
     /* 1571132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571142 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571166 */     // GIR_Coverage, 21630,
     /* 1571166 */     GIR_EraseRootFromParent_Done,
     /* 1571167 */   // Label 21779: @1571167
     /* 1571167 */   GIM_Try, /*On fail goto*//*Label 21780*/ GIMT_Encode4(1571249), // Rule ID 21631 //
     /* 1571172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1571183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1571186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1571189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571211 */     // MIs[0] round
     /* 1571211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571214 */     // MIs[0] policy
     /* 1571214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571224 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571248 */     // GIR_Coverage, 21631,
     /* 1571248 */     GIR_EraseRootFromParent_Done,
     /* 1571249 */   // Label 21780: @1571249
     /* 1571249 */   GIM_Try, /*On fail goto*//*Label 21781*/ GIMT_Encode4(1571331), // Rule ID 21634 //
     /* 1571254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571293 */     // MIs[0] round
     /* 1571293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571296 */     // MIs[0] policy
     /* 1571296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571306 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571330 */     // GIR_Coverage, 21634,
     /* 1571330 */     GIR_EraseRootFromParent_Done,
     /* 1571331 */   // Label 21781: @1571331
     /* 1571331 */   GIM_Try, /*On fail goto*//*Label 21782*/ GIMT_Encode4(1571413), // Rule ID 21635 //
     /* 1571336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1571347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1571350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1571353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571375 */     // MIs[0] round
     /* 1571375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571378 */     // MIs[0] policy
     /* 1571378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571388 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11238:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571412 */     // GIR_Coverage, 21635,
     /* 1571412 */     GIR_EraseRootFromParent_Done,
     /* 1571413 */   // Label 21782: @1571413
     /* 1571413 */   GIM_Try, /*On fail goto*//*Label 21783*/ GIMT_Encode4(1571495), // Rule ID 21638 //
     /* 1571418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571457 */     // MIs[0] round
     /* 1571457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571460 */     // MIs[0] policy
     /* 1571460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571470 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571494 */     // GIR_Coverage, 21638,
     /* 1571494 */     GIR_EraseRootFromParent_Done,
     /* 1571495 */   // Label 21783: @1571495
     /* 1571495 */   GIM_Try, /*On fail goto*//*Label 21784*/ GIMT_Encode4(1571577), // Rule ID 21639 //
     /* 1571500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1571511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1571514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1571517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571539 */     // MIs[0] round
     /* 1571539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571542 */     // MIs[0] policy
     /* 1571542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1571555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571576 */     // GIR_Coverage, 21639,
     /* 1571576 */     GIR_EraseRootFromParent_Done,
     /* 1571577 */   // Label 21784: @1571577
     /* 1571577 */   GIM_Try, /*On fail goto*//*Label 21785*/ GIMT_Encode4(1571659), // Rule ID 21642 //
     /* 1571582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1571585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1571593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1571596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1571599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571621 */     // MIs[0] round
     /* 1571621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571624 */     // MIs[0] policy
     /* 1571624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1571637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571658 */     // GIR_Coverage, 21642,
     /* 1571658 */     GIR_EraseRootFromParent_Done,
     /* 1571659 */   // Label 21785: @1571659
     /* 1571659 */   GIM_Try, /*On fail goto*//*Label 21786*/ GIMT_Encode4(1571741), // Rule ID 21643 //
     /* 1571664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1571667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1571675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1571678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1571681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1571684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571703 */     // MIs[0] round
     /* 1571703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571706 */     // MIs[0] policy
     /* 1571706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571716 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1571719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571740 */     // GIR_Coverage, 21643,
     /* 1571740 */     GIR_EraseRootFromParent_Done,
     /* 1571741 */   // Label 21786: @1571741
     /* 1571741 */   GIM_Try, /*On fail goto*//*Label 21787*/ GIMT_Encode4(1571823), // Rule ID 21646 //
     /* 1571746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1571749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1571757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1571760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1571763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571785 */     // MIs[0] round
     /* 1571785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571788 */     // MIs[0] policy
     /* 1571788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571822 */     // GIR_Coverage, 21646,
     /* 1571822 */     GIR_EraseRootFromParent_Done,
     /* 1571823 */   // Label 21787: @1571823
     /* 1571823 */   GIM_Try, /*On fail goto*//*Label 21788*/ GIMT_Encode4(1571905), // Rule ID 21647 //
     /* 1571828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1571831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1571839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1571842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1571845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571867 */     // MIs[0] round
     /* 1571867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571870 */     // MIs[0] policy
     /* 1571870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571880 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1571883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571904 */     // GIR_Coverage, 21647,
     /* 1571904 */     GIR_EraseRootFromParent_Done,
     /* 1571905 */   // Label 21788: @1571905
     /* 1571905 */   GIM_Try, /*On fail goto*//*Label 21789*/ GIMT_Encode4(1571987), // Rule ID 21650 //
     /* 1571910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1571913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1571918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1571921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1571924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1571927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571949 */     // MIs[0] round
     /* 1571949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571952 */     // MIs[0] policy
     /* 1571952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571962 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1571965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571986 */     // GIR_Coverage, 21650,
     /* 1571986 */     GIR_EraseRootFromParent_Done,
     /* 1571987 */   // Label 21789: @1571987
     /* 1571987 */   GIM_Try, /*On fail goto*//*Label 21790*/ GIMT_Encode4(1572069), // Rule ID 21651 //
     /* 1571992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1571995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1572003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1572006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1572009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572031 */     // MIs[0] round
     /* 1572031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572034 */     // MIs[0] policy
     /* 1572034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1572047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572068 */     // GIR_Coverage, 21651,
     /* 1572068 */     GIR_EraseRootFromParent_Done,
     /* 1572069 */   // Label 21790: @1572069
     /* 1572069 */   GIM_Try, /*On fail goto*//*Label 21791*/ GIMT_Encode4(1572151), // Rule ID 21654 //
     /* 1572074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572113 */     // MIs[0] round
     /* 1572113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572116 */     // MIs[0] policy
     /* 1572116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572150 */     // GIR_Coverage, 21654,
     /* 1572150 */     GIR_EraseRootFromParent_Done,
     /* 1572151 */   // Label 21791: @1572151
     /* 1572151 */   GIM_Try, /*On fail goto*//*Label 21792*/ GIMT_Encode4(1572233), // Rule ID 21655 //
     /* 1572156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1572167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1572170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1572173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572195 */     // MIs[0] round
     /* 1572195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572198 */     // MIs[0] policy
     /* 1572198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1572211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572232 */     // GIR_Coverage, 21655,
     /* 1572232 */     GIR_EraseRootFromParent_Done,
     /* 1572233 */   // Label 21792: @1572233
     /* 1572233 */   GIM_Try, /*On fail goto*//*Label 21793*/ GIMT_Encode4(1572315), // Rule ID 21658 //
     /* 1572238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1572241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572277 */     // MIs[0] round
     /* 1572277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572280 */     // MIs[0] policy
     /* 1572280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572314 */     // GIR_Coverage, 21658,
     /* 1572314 */     GIR_EraseRootFromParent_Done,
     /* 1572315 */   // Label 21793: @1572315
     /* 1572315 */   GIM_Try, /*On fail goto*//*Label 21794*/ GIMT_Encode4(1572397), // Rule ID 21659 //
     /* 1572320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1572323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1572328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1572331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1572334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1572337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572359 */     // MIs[0] round
     /* 1572359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572362 */     // MIs[0] policy
     /* 1572362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572372 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1572375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1572393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572396 */     // GIR_Coverage, 21659,
     /* 1572396 */     GIR_EraseRootFromParent_Done,
     /* 1572397 */   // Label 21794: @1572397
     /* 1572397 */   GIM_Try, /*On fail goto*//*Label 21795*/ GIMT_Encode4(1572479), // Rule ID 21662 //
     /* 1572402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1572413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1572416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572441 */     // MIs[0] round
     /* 1572441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572444 */     // MIs[0] policy
     /* 1572444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572454 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1572457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572478 */     // GIR_Coverage, 21662,
     /* 1572478 */     GIR_EraseRootFromParent_Done,
     /* 1572479 */   // Label 21795: @1572479
     /* 1572479 */   GIM_Try, /*On fail goto*//*Label 21796*/ GIMT_Encode4(1572561), // Rule ID 21663 //
     /* 1572484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1572495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1572498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1572501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1572504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572523 */     // MIs[0] round
     /* 1572523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572526 */     // MIs[0] policy
     /* 1572526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572536 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1572539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572560 */     // GIR_Coverage, 21663,
     /* 1572560 */     GIR_EraseRootFromParent_Done,
     /* 1572561 */   // Label 21796: @1572561
     /* 1572561 */   GIM_Try, /*On fail goto*//*Label 21797*/ GIMT_Encode4(1572643), // Rule ID 21666 //
     /* 1572566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1572577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1572580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1572583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572605 */     // MIs[0] round
     /* 1572605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572608 */     // MIs[0] policy
     /* 1572608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572618 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1572621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572642 */     // GIR_Coverage, 21666,
     /* 1572642 */     GIR_EraseRootFromParent_Done,
     /* 1572643 */   // Label 21797: @1572643
     /* 1572643 */   GIM_Try, /*On fail goto*//*Label 21798*/ GIMT_Encode4(1572725), // Rule ID 21667 //
     /* 1572648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1572659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1572662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1572665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572687 */     // MIs[0] round
     /* 1572687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572690 */     // MIs[0] policy
     /* 1572690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572700 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1572703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572724 */     // GIR_Coverage, 21667,
     /* 1572724 */     GIR_EraseRootFromParent_Done,
     /* 1572725 */   // Label 21798: @1572725
     /* 1572725 */   GIM_Try, /*On fail goto*//*Label 21799*/ GIMT_Encode4(1572807), // Rule ID 21670 //
     /* 1572730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1572741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1572744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1572747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572769 */     // MIs[0] round
     /* 1572769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572772 */     // MIs[0] policy
     /* 1572772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572782 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1572785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572806 */     // GIR_Coverage, 21670,
     /* 1572806 */     GIR_EraseRootFromParent_Done,
     /* 1572807 */   // Label 21799: @1572807
     /* 1572807 */   GIM_Try, /*On fail goto*//*Label 21800*/ GIMT_Encode4(1572889), // Rule ID 21671 //
     /* 1572812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1572823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1572826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1572829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572851 */     // MIs[0] round
     /* 1572851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572854 */     // MIs[0] policy
     /* 1572854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1572867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572888 */     // GIR_Coverage, 21671,
     /* 1572888 */     GIR_EraseRootFromParent_Done,
     /* 1572889 */   // Label 21800: @1572889
     /* 1572889 */   GIM_Try, /*On fail goto*//*Label 21801*/ GIMT_Encode4(1572971), // Rule ID 21674 //
     /* 1572894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1572897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1572905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1572908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1572911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572933 */     // MIs[0] round
     /* 1572933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572936 */     // MIs[0] policy
     /* 1572936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572946 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1572949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572970 */     // GIR_Coverage, 21674,
     /* 1572970 */     GIR_EraseRootFromParent_Done,
     /* 1572971 */   // Label 21801: @1572971
     /* 1572971 */   GIM_Try, /*On fail goto*//*Label 21802*/ GIMT_Encode4(1573053), // Rule ID 21675 //
     /* 1572976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1572979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1572984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1572987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1572990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1572993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573015 */     // MIs[0] round
     /* 1573015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573018 */     // MIs[0] policy
     /* 1573018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11236:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573052 */     // GIR_Coverage, 21675,
     /* 1573052 */     GIR_EraseRootFromParent_Done,
     /* 1573053 */   // Label 21802: @1573053
     /* 1573053 */   GIM_Try, /*On fail goto*//*Label 21803*/ GIMT_Encode4(1573135), // Rule ID 21678 //
     /* 1573058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1573075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573097 */     // MIs[0] round
     /* 1573097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573100 */     // MIs[0] policy
     /* 1573100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573110 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573134 */     // GIR_Coverage, 21678,
     /* 1573134 */     GIR_EraseRootFromParent_Done,
     /* 1573135 */   // Label 21803: @1573135
     /* 1573135 */   GIM_Try, /*On fail goto*//*Label 21804*/ GIMT_Encode4(1573217), // Rule ID 21679 //
     /* 1573140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1573151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1573154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1573157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1573160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573179 */     // MIs[0] round
     /* 1573179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573182 */     // MIs[0] policy
     /* 1573182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573192 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573216 */     // GIR_Coverage, 21679,
     /* 1573216 */     GIR_EraseRootFromParent_Done,
     /* 1573217 */   // Label 21804: @1573217
     /* 1573217 */   GIM_Try, /*On fail goto*//*Label 21805*/ GIMT_Encode4(1573299), // Rule ID 21682 //
     /* 1573222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1573225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1573239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1573242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573261 */     // MIs[0] round
     /* 1573261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573264 */     // MIs[0] policy
     /* 1573264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573274 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1573277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573298 */     // GIR_Coverage, 21682,
     /* 1573298 */     GIR_EraseRootFromParent_Done,
     /* 1573299 */   // Label 21805: @1573299
     /* 1573299 */   GIM_Try, /*On fail goto*//*Label 21806*/ GIMT_Encode4(1573381), // Rule ID 21683 //
     /* 1573304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1573307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1573315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1573318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1573321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1573324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573343 */     // MIs[0] round
     /* 1573343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573346 */     // MIs[0] policy
     /* 1573346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1573359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573380 */     // GIR_Coverage, 21683,
     /* 1573380 */     GIR_EraseRootFromParent_Done,
     /* 1573381 */   // Label 21806: @1573381
     /* 1573381 */   GIM_Try, /*On fail goto*//*Label 21807*/ GIMT_Encode4(1573463), // Rule ID 21686 //
     /* 1573386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1573397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1573400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573425 */     // MIs[0] round
     /* 1573425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573428 */     // MIs[0] policy
     /* 1573428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573462 */     // GIR_Coverage, 21686,
     /* 1573462 */     GIR_EraseRootFromParent_Done,
     /* 1573463 */   // Label 21807: @1573463
     /* 1573463 */   GIM_Try, /*On fail goto*//*Label 21808*/ GIMT_Encode4(1573545), // Rule ID 21687 //
     /* 1573468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1573479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1573482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1573485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1573488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573507 */     // MIs[0] round
     /* 1573507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573510 */     // MIs[0] policy
     /* 1573510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573520 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1573523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573544 */     // GIR_Coverage, 21687,
     /* 1573544 */     GIR_EraseRootFromParent_Done,
     /* 1573545 */   // Label 21808: @1573545
     /* 1573545 */   GIM_Try, /*On fail goto*//*Label 21809*/ GIMT_Encode4(1573627), // Rule ID 21690 //
     /* 1573550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1573561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1573564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1573567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573589 */     // MIs[0] round
     /* 1573589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573592 */     // MIs[0] policy
     /* 1573592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573602 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1573605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573626 */     // GIR_Coverage, 21690,
     /* 1573626 */     GIR_EraseRootFromParent_Done,
     /* 1573627 */   // Label 21809: @1573627
     /* 1573627 */   GIM_Try, /*On fail goto*//*Label 21810*/ GIMT_Encode4(1573709), // Rule ID 21691 //
     /* 1573632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1573643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1573646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1573649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1573652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573671 */     // MIs[0] round
     /* 1573671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573674 */     // MIs[0] policy
     /* 1573674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1573687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573708 */     // GIR_Coverage, 21691,
     /* 1573708 */     GIR_EraseRootFromParent_Done,
     /* 1573709 */   // Label 21810: @1573709
     /* 1573709 */   GIM_Try, /*On fail goto*//*Label 21811*/ GIMT_Encode4(1573791), // Rule ID 21694 //
     /* 1573714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1573725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1573728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1573731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573753 */     // MIs[0] round
     /* 1573753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573756 */     // MIs[0] policy
     /* 1573756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573766 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573790 */     // GIR_Coverage, 21694,
     /* 1573790 */     GIR_EraseRootFromParent_Done,
     /* 1573791 */   // Label 21811: @1573791
     /* 1573791 */   GIM_Try, /*On fail goto*//*Label 21812*/ GIMT_Encode4(1573873), // Rule ID 21695 //
     /* 1573796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1573807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1573810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1573813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1573816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573835 */     // MIs[0] round
     /* 1573835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573838 */     // MIs[0] policy
     /* 1573838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573848 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11236:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1573851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573872 */     // GIR_Coverage, 21695,
     /* 1573872 */     GIR_EraseRootFromParent_Done,
     /* 1573873 */   // Label 21812: @1573873
     /* 1573873 */   GIM_Try, /*On fail goto*//*Label 21813*/ GIMT_Encode4(1573955), // Rule ID 21698 //
     /* 1573878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1573881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1573889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1573892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1573895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573917 */     // MIs[0] round
     /* 1573917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1573920 */     // MIs[0] policy
     /* 1573920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1573933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1573939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1573941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1573943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573954 */     // GIR_Coverage, 21698,
     /* 1573954 */     GIR_EraseRootFromParent_Done,
     /* 1573955 */   // Label 21813: @1573955
     /* 1573955 */   GIM_Try, /*On fail goto*//*Label 21814*/ GIMT_Encode4(1574037), // Rule ID 21699 //
     /* 1573960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1573963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1573968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1573971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1573974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1573977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1573980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573999 */     // MIs[0] round
     /* 1573999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574002 */     // MIs[0] policy
     /* 1574002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574012 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574036 */     // GIR_Coverage, 21699,
     /* 1574036 */     GIR_EraseRootFromParent_Done,
     /* 1574037 */   // Label 21814: @1574037
     /* 1574037 */   GIM_Try, /*On fail goto*//*Label 21815*/ GIMT_Encode4(1574119), // Rule ID 21702 //
     /* 1574042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1574045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574081 */     // MIs[0] round
     /* 1574081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574084 */     // MIs[0] policy
     /* 1574084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574094 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574118 */     // GIR_Coverage, 21702,
     /* 1574118 */     GIR_EraseRootFromParent_Done,
     /* 1574119 */   // Label 21815: @1574119
     /* 1574119 */   GIM_Try, /*On fail goto*//*Label 21816*/ GIMT_Encode4(1574201), // Rule ID 21703 //
     /* 1574124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1574127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1574135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1574138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1574141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1574144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574163 */     // MIs[0] round
     /* 1574163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574166 */     // MIs[0] policy
     /* 1574166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574176 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574200 */     // GIR_Coverage, 21703,
     /* 1574200 */     GIR_EraseRootFromParent_Done,
     /* 1574201 */   // Label 21816: @1574201
     /* 1574201 */   GIM_Try, /*On fail goto*//*Label 21817*/ GIMT_Encode4(1574283), // Rule ID 21706 //
     /* 1574206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1574217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1574220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1574223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574245 */     // MIs[0] round
     /* 1574245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574248 */     // MIs[0] policy
     /* 1574248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574258 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574282 */     // GIR_Coverage, 21706,
     /* 1574282 */     GIR_EraseRootFromParent_Done,
     /* 1574283 */   // Label 21817: @1574283
     /* 1574283 */   GIM_Try, /*On fail goto*//*Label 21818*/ GIMT_Encode4(1574365), // Rule ID 21707 //
     /* 1574288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1574299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1574302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1574305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574327 */     // MIs[0] round
     /* 1574327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574330 */     // MIs[0] policy
     /* 1574330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574340 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1574343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574364 */     // GIR_Coverage, 21707,
     /* 1574364 */     GIR_EraseRootFromParent_Done,
     /* 1574365 */   // Label 21818: @1574365
     /* 1574365 */   GIM_Try, /*On fail goto*//*Label 21819*/ GIMT_Encode4(1574447), // Rule ID 21710 //
     /* 1574370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1574381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1574384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1574387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574409 */     // MIs[0] round
     /* 1574409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574412 */     // MIs[0] policy
     /* 1574412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574446 */     // GIR_Coverage, 21710,
     /* 1574446 */     GIR_EraseRootFromParent_Done,
     /* 1574447 */   // Label 21819: @1574447
     /* 1574447 */   GIM_Try, /*On fail goto*//*Label 21820*/ GIMT_Encode4(1574529), // Rule ID 21711 //
     /* 1574452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1574463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1574466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1574469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1574472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574491 */     // MIs[0] round
     /* 1574491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574494 */     // MIs[0] policy
     /* 1574494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1574507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574528 */     // GIR_Coverage, 21711,
     /* 1574528 */     GIR_EraseRootFromParent_Done,
     /* 1574529 */   // Label 21820: @1574529
     /* 1574529 */   GIM_Try, /*On fail goto*//*Label 21821*/ GIMT_Encode4(1574611), // Rule ID 21714 //
     /* 1574534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1574545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1574548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1574551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574573 */     // MIs[0] round
     /* 1574573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574576 */     // MIs[0] policy
     /* 1574576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574610 */     // GIR_Coverage, 21714,
     /* 1574610 */     GIR_EraseRootFromParent_Done,
     /* 1574611 */   // Label 21821: @1574611
     /* 1574611 */   GIM_Try, /*On fail goto*//*Label 21822*/ GIMT_Encode4(1574693), // Rule ID 21715 //
     /* 1574616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1574627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1574630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1574633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1574636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574655 */     // MIs[0] round
     /* 1574655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574658 */     // MIs[0] policy
     /* 1574658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1574671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574692 */     // GIR_Coverage, 21715,
     /* 1574692 */     GIR_EraseRootFromParent_Done,
     /* 1574693 */   // Label 21822: @1574693
     /* 1574693 */   GIM_Try, /*On fail goto*//*Label 21823*/ GIMT_Encode4(1574775), // Rule ID 21718 //
     /* 1574698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1574701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1574709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1574712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1574715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574737 */     // MIs[0] round
     /* 1574737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574740 */     // MIs[0] policy
     /* 1574740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574750 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574774 */     // GIR_Coverage, 21718,
     /* 1574774 */     GIR_EraseRootFromParent_Done,
     /* 1574775 */   // Label 21823: @1574775
     /* 1574775 */   GIM_Try, /*On fail goto*//*Label 21824*/ GIMT_Encode4(1574857), // Rule ID 21719 //
     /* 1574780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1574783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1574788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1574791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1574794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1574797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1574800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574819 */     // MIs[0] round
     /* 1574819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574822 */     // MIs[0] policy
     /* 1574822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574832 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1574835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574856 */     // GIR_Coverage, 21719,
     /* 1574856 */     GIR_EraseRootFromParent_Done,
     /* 1574857 */   // Label 21824: @1574857
     /* 1574857 */   GIM_Try, /*On fail goto*//*Label 21825*/ GIMT_Encode4(1574939), // Rule ID 21842 //
     /* 1574862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1574865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1574870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1574873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1574876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1574879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574901 */     // MIs[0] round
     /* 1574901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574904 */     // MIs[0] policy
     /* 1574904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574914 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1574917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1574923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1574925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1574927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574938 */     // GIR_Coverage, 21842,
     /* 1574938 */     GIR_EraseRootFromParent_Done,
     /* 1574939 */   // Label 21825: @1574939
     /* 1574939 */   GIM_Try, /*On fail goto*//*Label 21826*/ GIMT_Encode4(1575021), // Rule ID 21843 //
     /* 1574944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1574947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1574952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1574955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1574958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1574961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1574964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574983 */     // MIs[0] round
     /* 1574983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1574986 */     // MIs[0] policy
     /* 1574986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574996 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1574999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575020 */     // GIR_Coverage, 21843,
     /* 1575020 */     GIR_EraseRootFromParent_Done,
     /* 1575021 */   // Label 21826: @1575021
     /* 1575021 */   GIM_Try, /*On fail goto*//*Label 21827*/ GIMT_Encode4(1575103), // Rule ID 21846 //
     /* 1575026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1575043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575065 */     // MIs[0] round
     /* 1575065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575068 */     // MIs[0] policy
     /* 1575068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575078 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1575081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575102 */     // GIR_Coverage, 21846,
     /* 1575102 */     GIR_EraseRootFromParent_Done,
     /* 1575103 */   // Label 21827: @1575103
     /* 1575103 */   GIM_Try, /*On fail goto*//*Label 21828*/ GIMT_Encode4(1575185), // Rule ID 21847 //
     /* 1575108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1575125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575147 */     // MIs[0] round
     /* 1575147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575150 */     // MIs[0] policy
     /* 1575150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575160 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1575163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575184 */     // GIR_Coverage, 21847,
     /* 1575184 */     GIR_EraseRootFromParent_Done,
     /* 1575185 */   // Label 21828: @1575185
     /* 1575185 */   GIM_Try, /*On fail goto*//*Label 21829*/ GIMT_Encode4(1575267), // Rule ID 21850 //
     /* 1575190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575229 */     // MIs[0] round
     /* 1575229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575232 */     // MIs[0] policy
     /* 1575232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575242 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1575245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575266 */     // GIR_Coverage, 21850,
     /* 1575266 */     GIR_EraseRootFromParent_Done,
     /* 1575267 */   // Label 21829: @1575267
     /* 1575267 */   GIM_Try, /*On fail goto*//*Label 21830*/ GIMT_Encode4(1575349), // Rule ID 21851 //
     /* 1575272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1575289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1575292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575311 */     // MIs[0] round
     /* 1575311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575314 */     // MIs[0] policy
     /* 1575314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575324 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11228:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1575327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575348 */     // GIR_Coverage, 21851,
     /* 1575348 */     GIR_EraseRootFromParent_Done,
     /* 1575349 */   // Label 21830: @1575349
     /* 1575349 */   GIM_Try, /*On fail goto*//*Label 21831*/ GIMT_Encode4(1575431), // Rule ID 21854 //
     /* 1575354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575393 */     // MIs[0] round
     /* 1575393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575396 */     // MIs[0] policy
     /* 1575396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575406 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1575409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575430 */     // GIR_Coverage, 21854,
     /* 1575430 */     GIR_EraseRootFromParent_Done,
     /* 1575431 */   // Label 21831: @1575431
     /* 1575431 */   GIM_Try, /*On fail goto*//*Label 21832*/ GIMT_Encode4(1575513), // Rule ID 21855 //
     /* 1575436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1575453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1575456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575475 */     // MIs[0] round
     /* 1575475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575478 */     // MIs[0] policy
     /* 1575478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575488 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1575491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575512 */     // GIR_Coverage, 21855,
     /* 1575512 */     GIR_EraseRootFromParent_Done,
     /* 1575513 */   // Label 21832: @1575513
     /* 1575513 */   GIM_Try, /*On fail goto*//*Label 21833*/ GIMT_Encode4(1575595), // Rule ID 21858 //
     /* 1575518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1575521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1575529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1575532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1575535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1575538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575557 */     // MIs[0] round
     /* 1575557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575560 */     // MIs[0] policy
     /* 1575560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575570 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1575573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575594 */     // GIR_Coverage, 21858,
     /* 1575594 */     GIR_EraseRootFromParent_Done,
     /* 1575595 */   // Label 21833: @1575595
     /* 1575595 */   GIM_Try, /*On fail goto*//*Label 21834*/ GIMT_Encode4(1575677), // Rule ID 21859 //
     /* 1575600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1575603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1575611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1575614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1575617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1575620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575639 */     // MIs[0] round
     /* 1575639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575642 */     // MIs[0] policy
     /* 1575642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575652 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1575655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1575673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575676 */     // GIR_Coverage, 21859,
     /* 1575676 */     GIR_EraseRootFromParent_Done,
     /* 1575677 */   // Label 21834: @1575677
     /* 1575677 */   GIM_Try, /*On fail goto*//*Label 21835*/ GIMT_Encode4(1575759), // Rule ID 21862 //
     /* 1575682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1575685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1575693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1575696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1575699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575721 */     // MIs[0] round
     /* 1575721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575724 */     // MIs[0] policy
     /* 1575724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575734 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1575737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575758 */     // GIR_Coverage, 21862,
     /* 1575758 */     GIR_EraseRootFromParent_Done,
     /* 1575759 */   // Label 21835: @1575759
     /* 1575759 */   GIM_Try, /*On fail goto*//*Label 21836*/ GIMT_Encode4(1575841), // Rule ID 21863 //
     /* 1575764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1575767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1575775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1575778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1575781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1575784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575803 */     // MIs[0] round
     /* 1575803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575806 */     // MIs[0] policy
     /* 1575806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575816 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1575819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575840 */     // GIR_Coverage, 21863,
     /* 1575840 */     GIR_EraseRootFromParent_Done,
     /* 1575841 */   // Label 21836: @1575841
     /* 1575841 */   GIM_Try, /*On fail goto*//*Label 21837*/ GIMT_Encode4(1575923), // Rule ID 21866 //
     /* 1575846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1575849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575885 */     // MIs[0] round
     /* 1575885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575888 */     // MIs[0] policy
     /* 1575888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575898 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1575901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575922 */     // GIR_Coverage, 21866,
     /* 1575922 */     GIR_EraseRootFromParent_Done,
     /* 1575923 */   // Label 21837: @1575923
     /* 1575923 */   GIM_Try, /*On fail goto*//*Label 21838*/ GIMT_Encode4(1576005), // Rule ID 21867 //
     /* 1575928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1575931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1575936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1575939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1575942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1575945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1575948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575967 */     // MIs[0] round
     /* 1575967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1575970 */     // MIs[0] policy
     /* 1575970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575980 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11228:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1575983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1575989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1575991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1575993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576004 */     // GIR_Coverage, 21867,
     /* 1576004 */     GIR_EraseRootFromParent_Done,
     /* 1576005 */   // Label 21838: @1576005
     /* 1576005 */   GIM_Try, /*On fail goto*//*Label 21839*/ GIMT_Encode4(1576087), // Rule ID 21870 //
     /* 1576010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576049 */     // MIs[0] round
     /* 1576049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576052 */     // MIs[0] policy
     /* 1576052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576062 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1576065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576086 */     // GIR_Coverage, 21870,
     /* 1576086 */     GIR_EraseRootFromParent_Done,
     /* 1576087 */   // Label 21839: @1576087
     /* 1576087 */   GIM_Try, /*On fail goto*//*Label 21840*/ GIMT_Encode4(1576169), // Rule ID 21871 //
     /* 1576092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1576109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576131 */     // MIs[0] round
     /* 1576131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576134 */     // MIs[0] policy
     /* 1576134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576144 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11228:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1576147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576168 */     // GIR_Coverage, 21871,
     /* 1576168 */     GIR_EraseRootFromParent_Done,
     /* 1576169 */   // Label 21840: @1576169
     /* 1576169 */   GIM_Try, /*On fail goto*//*Label 21841*/ GIMT_Encode4(1576251), // Rule ID 21874 //
     /* 1576174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1576177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576213 */     // MIs[0] round
     /* 1576213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576216 */     // MIs[0] policy
     /* 1576216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576226 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1576229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576250 */     // GIR_Coverage, 21874,
     /* 1576250 */     GIR_EraseRootFromParent_Done,
     /* 1576251 */   // Label 21841: @1576251
     /* 1576251 */   GIM_Try, /*On fail goto*//*Label 21842*/ GIMT_Encode4(1576333), // Rule ID 21875 //
     /* 1576256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1576259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1576264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1576273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576295 */     // MIs[0] round
     /* 1576295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576298 */     // MIs[0] policy
     /* 1576298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576308 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11228:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1576311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1576329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576332 */     // GIR_Coverage, 21875,
     /* 1576332 */     GIR_EraseRootFromParent_Done,
     /* 1576333 */   // Label 21842: @1576333
     /* 1576333 */   GIM_Try, /*On fail goto*//*Label 21843*/ GIMT_Encode4(1576415), // Rule ID 21878 //
     /* 1576338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576377 */     // MIs[0] round
     /* 1576377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576380 */     // MIs[0] policy
     /* 1576380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576390 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1576393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576414 */     // GIR_Coverage, 21878,
     /* 1576414 */     GIR_EraseRootFromParent_Done,
     /* 1576415 */   // Label 21843: @1576415
     /* 1576415 */   GIM_Try, /*On fail goto*//*Label 21844*/ GIMT_Encode4(1576497), // Rule ID 21879 //
     /* 1576420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1576431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1576434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1576437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1576440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576459 */     // MIs[0] round
     /* 1576459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576462 */     // MIs[0] policy
     /* 1576462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576472 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1576475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576496 */     // GIR_Coverage, 21879,
     /* 1576496 */     GIR_EraseRootFromParent_Done,
     /* 1576497 */   // Label 21844: @1576497
     /* 1576497 */   GIM_Try, /*On fail goto*//*Label 21845*/ GIMT_Encode4(1576579), // Rule ID 21882 //
     /* 1576502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576541 */     // MIs[0] round
     /* 1576541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576544 */     // MIs[0] policy
     /* 1576544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576554 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1576557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576578 */     // GIR_Coverage, 21882,
     /* 1576578 */     GIR_EraseRootFromParent_Done,
     /* 1576579 */   // Label 21845: @1576579
     /* 1576579 */   GIM_Try, /*On fail goto*//*Label 21846*/ GIMT_Encode4(1576661), // Rule ID 21883 //
     /* 1576584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1576595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1576598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1576601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1576604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576623 */     // MIs[0] round
     /* 1576623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576626 */     // MIs[0] policy
     /* 1576626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576636 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1576639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576660 */     // GIR_Coverage, 21883,
     /* 1576660 */     GIR_EraseRootFromParent_Done,
     /* 1576661 */   // Label 21846: @1576661
     /* 1576661 */   GIM_Try, /*On fail goto*//*Label 21847*/ GIMT_Encode4(1576743), // Rule ID 21886 //
     /* 1576666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1576677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1576680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1576683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576705 */     // MIs[0] round
     /* 1576705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576708 */     // MIs[0] policy
     /* 1576708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576718 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1576721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576742 */     // GIR_Coverage, 21886,
     /* 1576742 */     GIR_EraseRootFromParent_Done,
     /* 1576743 */   // Label 21847: @1576743
     /* 1576743 */   GIM_Try, /*On fail goto*//*Label 21848*/ GIMT_Encode4(1576825), // Rule ID 21887 //
     /* 1576748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1576759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1576762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1576765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1576768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576787 */     // MIs[0] round
     /* 1576787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576790 */     // MIs[0] policy
     /* 1576790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576800 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11226:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1576803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576824 */     // GIR_Coverage, 21887,
     /* 1576824 */     GIR_EraseRootFromParent_Done,
     /* 1576825 */   // Label 21848: @1576825
     /* 1576825 */   GIM_Try, /*On fail goto*//*Label 21849*/ GIMT_Encode4(1576907), // Rule ID 21890 //
     /* 1576830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1576841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1576844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1576847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576869 */     // MIs[0] round
     /* 1576869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576872 */     // MIs[0] policy
     /* 1576872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576882 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1576885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576906 */     // GIR_Coverage, 21890,
     /* 1576906 */     GIR_EraseRootFromParent_Done,
     /* 1576907 */   // Label 21849: @1576907
     /* 1576907 */   GIM_Try, /*On fail goto*//*Label 21850*/ GIMT_Encode4(1576989), // Rule ID 21891 //
     /* 1576912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1576915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1576920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1576923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1576926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1576929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1576932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576951 */     // MIs[0] round
     /* 1576951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1576954 */     // MIs[0] policy
     /* 1576954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576964 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1576967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1576973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1576975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1576977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576988 */     // GIR_Coverage, 21891,
     /* 1576988 */     GIR_EraseRootFromParent_Done,
     /* 1576989 */   // Label 21850: @1576989
     /* 1576989 */   GIM_Try, /*On fail goto*//*Label 21851*/ GIMT_Encode4(1577071), // Rule ID 21894 //
     /* 1576994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1576997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577033 */     // MIs[0] round
     /* 1577033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577036 */     // MIs[0] policy
     /* 1577036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577046 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1577049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577070 */     // GIR_Coverage, 21894,
     /* 1577070 */     GIR_EraseRootFromParent_Done,
     /* 1577071 */   // Label 21851: @1577071
     /* 1577071 */   GIM_Try, /*On fail goto*//*Label 21852*/ GIMT_Encode4(1577153), // Rule ID 21895 //
     /* 1577076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1577079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1577087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1577090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1577093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1577096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577115 */     // MIs[0] round
     /* 1577115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577118 */     // MIs[0] policy
     /* 1577118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577128 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1577131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577152 */     // GIR_Coverage, 21895,
     /* 1577152 */     GIR_EraseRootFromParent_Done,
     /* 1577153 */   // Label 21852: @1577153
     /* 1577153 */   GIM_Try, /*On fail goto*//*Label 21853*/ GIMT_Encode4(1577235), // Rule ID 21898 //
     /* 1577158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1577169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1577172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577197 */     // MIs[0] round
     /* 1577197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577200 */     // MIs[0] policy
     /* 1577200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577210 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1577213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577234 */     // GIR_Coverage, 21898,
     /* 1577234 */     GIR_EraseRootFromParent_Done,
     /* 1577235 */   // Label 21853: @1577235
     /* 1577235 */   GIM_Try, /*On fail goto*//*Label 21854*/ GIMT_Encode4(1577317), // Rule ID 21899 //
     /* 1577240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1577251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1577254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1577257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577279 */     // MIs[0] round
     /* 1577279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577282 */     // MIs[0] policy
     /* 1577282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577292 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1577295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577316 */     // GIR_Coverage, 21899,
     /* 1577316 */     GIR_EraseRootFromParent_Done,
     /* 1577317 */   // Label 21854: @1577317
     /* 1577317 */   GIM_Try, /*On fail goto*//*Label 21855*/ GIMT_Encode4(1577399), // Rule ID 21902 //
     /* 1577322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1577333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1577336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1577339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577361 */     // MIs[0] round
     /* 1577361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577364 */     // MIs[0] policy
     /* 1577364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577374 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1577377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577398 */     // GIR_Coverage, 21902,
     /* 1577398 */     GIR_EraseRootFromParent_Done,
     /* 1577399 */   // Label 21855: @1577399
     /* 1577399 */   GIM_Try, /*On fail goto*//*Label 21856*/ GIMT_Encode4(1577481), // Rule ID 21903 //
     /* 1577404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1577415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1577418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1577421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577443 */     // MIs[0] round
     /* 1577443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577446 */     // MIs[0] policy
     /* 1577446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577456 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1577459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577480 */     // GIR_Coverage, 21903,
     /* 1577480 */     GIR_EraseRootFromParent_Done,
     /* 1577481 */   // Label 21856: @1577481
     /* 1577481 */   GIM_Try, /*On fail goto*//*Label 21857*/ GIMT_Encode4(1577563), // Rule ID 21906 //
     /* 1577486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1577497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1577500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1577503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577525 */     // MIs[0] round
     /* 1577525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577528 */     // MIs[0] policy
     /* 1577528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577538 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1577541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577562 */     // GIR_Coverage, 21906,
     /* 1577562 */     GIR_EraseRootFromParent_Done,
     /* 1577563 */   // Label 21857: @1577563
     /* 1577563 */   GIM_Try, /*On fail goto*//*Label 21858*/ GIMT_Encode4(1577645), // Rule ID 21907 //
     /* 1577568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1577579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1577582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1577585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1577588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577607 */     // MIs[0] round
     /* 1577607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577610 */     // MIs[0] policy
     /* 1577610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1577623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577644 */     // GIR_Coverage, 21907,
     /* 1577644 */     GIR_EraseRootFromParent_Done,
     /* 1577645 */   // Label 21858: @1577645
     /* 1577645 */   GIM_Try, /*On fail goto*//*Label 21859*/ GIMT_Encode4(1577727), // Rule ID 21910 //
     /* 1577650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1577653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1577661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1577664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1577667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577689 */     // MIs[0] round
     /* 1577689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577692 */     // MIs[0] policy
     /* 1577692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577702 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1577705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577726 */     // GIR_Coverage, 21910,
     /* 1577726 */     GIR_EraseRootFromParent_Done,
     /* 1577727 */   // Label 21859: @1577727
     /* 1577727 */   GIM_Try, /*On fail goto*//*Label 21860*/ GIMT_Encode4(1577809), // Rule ID 21911 //
     /* 1577732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1577735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1577740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1577743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1577746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1577749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1577752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577771 */     // MIs[0] round
     /* 1577771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577774 */     // MIs[0] policy
     /* 1577774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577784 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1577787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577808 */     // GIR_Coverage, 21911,
     /* 1577808 */     GIR_EraseRootFromParent_Done,
     /* 1577809 */   // Label 21860: @1577809
     /* 1577809 */   GIM_Try, /*On fail goto*//*Label 21861*/ GIMT_Encode4(1577891), // Rule ID 21914 //
     /* 1577814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1577817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1577822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1577831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577853 */     // MIs[0] round
     /* 1577853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577856 */     // MIs[0] policy
     /* 1577856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577866 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1577869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577890 */     // GIR_Coverage, 21914,
     /* 1577890 */     GIR_EraseRootFromParent_Done,
     /* 1577891 */   // Label 21861: @1577891
     /* 1577891 */   GIM_Try, /*On fail goto*//*Label 21862*/ GIMT_Encode4(1577973), // Rule ID 21915 //
     /* 1577896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1577899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1577904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1577913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1577916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577935 */     // MIs[0] round
     /* 1577935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1577938 */     // MIs[0] policy
     /* 1577938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577948 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1577951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1577957 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1577959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1577961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1577969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577972 */     // GIR_Coverage, 21915,
     /* 1577972 */     GIR_EraseRootFromParent_Done,
     /* 1577973 */   // Label 21862: @1577973
     /* 1577973 */   GIM_Try, /*On fail goto*//*Label 21863*/ GIMT_Encode4(1578055), // Rule ID 21918 //
     /* 1577978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1577981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1577986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1577989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1577992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1577995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1577998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578017 */     // MIs[0] round
     /* 1578017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578020 */     // MIs[0] policy
     /* 1578020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578030 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1578033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578054 */     // GIR_Coverage, 21918,
     /* 1578054 */     GIR_EraseRootFromParent_Done,
     /* 1578055 */   // Label 21863: @1578055
     /* 1578055 */   GIM_Try, /*On fail goto*//*Label 21864*/ GIMT_Encode4(1578137), // Rule ID 21919 //
     /* 1578060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1578071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1578074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1578077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578099 */     // MIs[0] round
     /* 1578099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578102 */     // MIs[0] policy
     /* 1578102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578112 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1578115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578136 */     // GIR_Coverage, 21919,
     /* 1578136 */     GIR_EraseRootFromParent_Done,
     /* 1578137 */   // Label 21864: @1578137
     /* 1578137 */   GIM_Try, /*On fail goto*//*Label 21865*/ GIMT_Encode4(1578219), // Rule ID 21922 //
     /* 1578142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1578153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1578156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578181 */     // MIs[0] round
     /* 1578181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578184 */     // MIs[0] policy
     /* 1578184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578194 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1578197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578218 */     // GIR_Coverage, 21922,
     /* 1578218 */     GIR_EraseRootFromParent_Done,
     /* 1578219 */   // Label 21865: @1578219
     /* 1578219 */   GIM_Try, /*On fail goto*//*Label 21866*/ GIMT_Encode4(1578301), // Rule ID 21923 //
     /* 1578224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1578235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1578238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1578241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578263 */     // MIs[0] round
     /* 1578263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578266 */     // MIs[0] policy
     /* 1578266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578276 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11224:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1578279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578300 */     // GIR_Coverage, 21923,
     /* 1578300 */     GIR_EraseRootFromParent_Done,
     /* 1578301 */   // Label 21866: @1578301
     /* 1578301 */   GIM_Try, /*On fail goto*//*Label 21867*/ GIMT_Encode4(1578383), // Rule ID 21926 //
     /* 1578306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578345 */     // MIs[0] round
     /* 1578345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578348 */     // MIs[0] policy
     /* 1578348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578358 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1578361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578382 */     // GIR_Coverage, 21926,
     /* 1578382 */     GIR_EraseRootFromParent_Done,
     /* 1578383 */   // Label 21867: @1578383
     /* 1578383 */   GIM_Try, /*On fail goto*//*Label 21868*/ GIMT_Encode4(1578465), // Rule ID 21927 //
     /* 1578388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1578405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1578408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578427 */     // MIs[0] round
     /* 1578427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578430 */     // MIs[0] policy
     /* 1578430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578440 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1578443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578464 */     // GIR_Coverage, 21927,
     /* 1578464 */     GIR_EraseRootFromParent_Done,
     /* 1578465 */   // Label 21868: @1578465
     /* 1578465 */   GIM_Try, /*On fail goto*//*Label 21869*/ GIMT_Encode4(1578547), // Rule ID 21930 //
     /* 1578470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 1578473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1578481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1578484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1578487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1578490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578509 */     // MIs[0] round
     /* 1578509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578512 */     // MIs[0] policy
     /* 1578512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578522 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1578525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578546 */     // GIR_Coverage, 21930,
     /* 1578546 */     GIR_EraseRootFromParent_Done,
     /* 1578547 */   // Label 21869: @1578547
     /* 1578547 */   GIM_Try, /*On fail goto*//*Label 21870*/ GIMT_Encode4(1578629), // Rule ID 21931 //
     /* 1578552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 1578555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1578563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1578566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1578569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1578572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578591 */     // MIs[0] round
     /* 1578591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578594 */     // MIs[0] policy
     /* 1578594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578604 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1578607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578628 */     // GIR_Coverage, 21931,
     /* 1578628 */     GIR_EraseRootFromParent_Done,
     /* 1578629 */   // Label 21870: @1578629
     /* 1578629 */   GIM_Try, /*On fail goto*//*Label 21871*/ GIMT_Encode4(1578711), // Rule ID 21934 //
     /* 1578634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1578637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1578651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578673 */     // MIs[0] round
     /* 1578673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578676 */     // MIs[0] policy
     /* 1578676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578686 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1578689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578710 */     // GIR_Coverage, 21934,
     /* 1578710 */     GIR_EraseRootFromParent_Done,
     /* 1578711 */   // Label 21871: @1578711
     /* 1578711 */   GIM_Try, /*On fail goto*//*Label 21872*/ GIMT_Encode4(1578793), // Rule ID 21935 //
     /* 1578716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1578719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1578733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1578736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578755 */     // MIs[0] round
     /* 1578755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578758 */     // MIs[0] policy
     /* 1578758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578768 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1578771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578792 */     // GIR_Coverage, 21935,
     /* 1578792 */     GIR_EraseRootFromParent_Done,
     /* 1578793 */   // Label 21872: @1578793
     /* 1578793 */   GIM_Try, /*On fail goto*//*Label 21873*/ GIMT_Encode4(1578875), // Rule ID 21938 //
     /* 1578798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1578801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1578815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578837 */     // MIs[0] round
     /* 1578837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578840 */     // MIs[0] policy
     /* 1578840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578850 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1578853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578874 */     // GIR_Coverage, 21938,
     /* 1578874 */     GIR_EraseRootFromParent_Done,
     /* 1578875 */   // Label 21873: @1578875
     /* 1578875 */   GIM_Try, /*On fail goto*//*Label 21874*/ GIMT_Encode4(1578957), // Rule ID 21939 //
     /* 1578880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1578883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1578897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1578900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578919 */     // MIs[0] round
     /* 1578919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1578922 */     // MIs[0] policy
     /* 1578922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578932 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1578935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1578941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1578943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1578945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1578953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578956 */     // GIR_Coverage, 21939,
     /* 1578956 */     GIR_EraseRootFromParent_Done,
     /* 1578957 */   // Label 21874: @1578957
     /* 1578957 */   GIM_Try, /*On fail goto*//*Label 21875*/ GIMT_Encode4(1579039), // Rule ID 21942 //
     /* 1578962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1578965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1578970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1578979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1578982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579001 */     // MIs[0] round
     /* 1579001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579004 */     // MIs[0] policy
     /* 1579004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579014 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1579017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579038 */     // GIR_Coverage, 21942,
     /* 1579038 */     GIR_EraseRootFromParent_Done,
     /* 1579039 */   // Label 21875: @1579039
     /* 1579039 */   GIM_Try, /*On fail goto*//*Label 21876*/ GIMT_Encode4(1579121), // Rule ID 21943 //
     /* 1579044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1579055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1579058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1579061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1579064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579083 */     // MIs[0] round
     /* 1579083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579086 */     // MIs[0] policy
     /* 1579086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579096 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1579099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579120 */     // GIR_Coverage, 21943,
     /* 1579120 */     GIR_EraseRootFromParent_Done,
     /* 1579121 */   // Label 21876: @1579121
     /* 1579121 */   GIM_Try, /*On fail goto*//*Label 21877*/ GIMT_Encode4(1579203), // Rule ID 21946 //
     /* 1579126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1579129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579165 */     // MIs[0] round
     /* 1579165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579168 */     // MIs[0] policy
     /* 1579168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579178 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1579181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579202 */     // GIR_Coverage, 21946,
     /* 1579202 */     GIR_EraseRootFromParent_Done,
     /* 1579203 */   // Label 21877: @1579203
     /* 1579203 */   GIM_Try, /*On fail goto*//*Label 21878*/ GIMT_Encode4(1579285), // Rule ID 21947 //
     /* 1579208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1579211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1579216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1579225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1579228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579247 */     // MIs[0] round
     /* 1579247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1579250 */     // MIs[0] policy
     /* 1579250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579260 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1579263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1579269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1579271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1579273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579284 */     // GIR_Coverage, 21947,
     /* 1579284 */     GIR_EraseRootFromParent_Done,
     /* 1579285 */   // Label 21878: @1579285
     /* 1579285 */   GIM_Try, /*On fail goto*//*Label 21879*/ GIMT_Encode4(1579367), // Rule ID 2756 //
     /* 1579290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579321 */     // MIs[0] passthru
     /* 1579321 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579334 */     // MIs[0] policy
     /* 1579334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579344 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1579347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579366 */     // GIR_Coverage, 2756,
     /* 1579366 */     GIR_EraseRootFromParent_Done,
     /* 1579367 */   // Label 21879: @1579367
     /* 1579367 */   GIM_Try, /*On fail goto*//*Label 21880*/ GIMT_Encode4(1579449), // Rule ID 2757 //
     /* 1579372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1579383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1579386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1579389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579403 */     // MIs[0] passthru
     /* 1579403 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579416 */     // MIs[0] policy
     /* 1579416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579426 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1579429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579448 */     // GIR_Coverage, 2757,
     /* 1579448 */     GIR_EraseRootFromParent_Done,
     /* 1579449 */   // Label 21880: @1579449
     /* 1579449 */   GIM_Try, /*On fail goto*//*Label 21881*/ GIMT_Encode4(1579531), // Rule ID 4072 //
     /* 1579454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1579465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1579468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1579471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579485 */     // MIs[0] passthru
     /* 1579485 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579498 */     // MIs[0] policy
     /* 1579498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579508 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1579511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579530 */     // GIR_Coverage, 4072,
     /* 1579530 */     GIR_EraseRootFromParent_Done,
     /* 1579531 */   // Label 21881: @1579531
     /* 1579531 */   GIM_Try, /*On fail goto*//*Label 21882*/ GIMT_Encode4(1579613), // Rule ID 4073 //
     /* 1579536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1579547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1579550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1579553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579567 */     // MIs[0] passthru
     /* 1579567 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579580 */     // MIs[0] policy
     /* 1579580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579590 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1579593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579612 */     // GIR_Coverage, 4073,
     /* 1579612 */     GIR_EraseRootFromParent_Done,
     /* 1579613 */   // Label 21882: @1579613
     /* 1579613 */   GIM_Try, /*On fail goto*//*Label 21883*/ GIMT_Encode4(1579695), // Rule ID 4082 //
     /* 1579618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1579629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1579632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1579635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579649 */     // MIs[0] passthru
     /* 1579649 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579662 */     // MIs[0] policy
     /* 1579662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579672 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1579675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579694 */     // GIR_Coverage, 4082,
     /* 1579694 */     GIR_EraseRootFromParent_Done,
     /* 1579695 */   // Label 21883: @1579695
     /* 1579695 */   GIM_Try, /*On fail goto*//*Label 21884*/ GIMT_Encode4(1579777), // Rule ID 4083 //
     /* 1579700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1579711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1579714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1579717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579731 */     // MIs[0] passthru
     /* 1579731 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579744 */     // MIs[0] policy
     /* 1579744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579754 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1579757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579776 */     // GIR_Coverage, 4083,
     /* 1579776 */     GIR_EraseRootFromParent_Done,
     /* 1579777 */   // Label 21884: @1579777
     /* 1579777 */   GIM_Try, /*On fail goto*//*Label 21885*/ GIMT_Encode4(1579859), // Rule ID 4092 //
     /* 1579782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1579793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1579796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1579799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579813 */     // MIs[0] passthru
     /* 1579813 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579826 */     // MIs[0] policy
     /* 1579826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1579839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579858 */     // GIR_Coverage, 4092,
     /* 1579858 */     GIR_EraseRootFromParent_Done,
     /* 1579859 */   // Label 21885: @1579859
     /* 1579859 */   GIM_Try, /*On fail goto*//*Label 21886*/ GIMT_Encode4(1579941), // Rule ID 4093 //
     /* 1579864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1579875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1579878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1579881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579895 */     // MIs[0] passthru
     /* 1579895 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579908 */     // MIs[0] policy
     /* 1579908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1579921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1579937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579940 */     // GIR_Coverage, 4093,
     /* 1579940 */     GIR_EraseRootFromParent_Done,
     /* 1579941 */   // Label 21886: @1579941
     /* 1579941 */   GIM_Try, /*On fail goto*//*Label 21887*/ GIMT_Encode4(1580023), // Rule ID 4102 //
     /* 1579946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1579954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1579957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1579960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1579963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1579966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579977 */     // MIs[0] passthru
     /* 1579977 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579990 */     // MIs[0] policy
     /* 1579990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580000 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580022 */     // GIR_Coverage, 4102,
     /* 1580022 */     GIR_EraseRootFromParent_Done,
     /* 1580023 */   // Label 21887: @1580023
     /* 1580023 */   GIM_Try, /*On fail goto*//*Label 21888*/ GIMT_Encode4(1580105), // Rule ID 4103 //
     /* 1580028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580059 */     // MIs[0] passthru
     /* 1580059 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580072 */     // MIs[0] policy
     /* 1580072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580082 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580104 */     // GIR_Coverage, 4103,
     /* 1580104 */     GIR_EraseRootFromParent_Done,
     /* 1580105 */   // Label 21888: @1580105
     /* 1580105 */   GIM_Try, /*On fail goto*//*Label 21889*/ GIMT_Encode4(1580187), // Rule ID 4112 //
     /* 1580110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580141 */     // MIs[0] passthru
     /* 1580141 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580154 */     // MIs[0] policy
     /* 1580154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580164 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580186 */     // GIR_Coverage, 4112,
     /* 1580186 */     GIR_EraseRootFromParent_Done,
     /* 1580187 */   // Label 21889: @1580187
     /* 1580187 */   GIM_Try, /*On fail goto*//*Label 21890*/ GIMT_Encode4(1580269), // Rule ID 4113 //
     /* 1580192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580223 */     // MIs[0] passthru
     /* 1580223 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580236 */     // MIs[0] policy
     /* 1580236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580268 */     // GIR_Coverage, 4113,
     /* 1580268 */     GIR_EraseRootFromParent_Done,
     /* 1580269 */   // Label 21890: @1580269
     /* 1580269 */   GIM_Try, /*On fail goto*//*Label 21891*/ GIMT_Encode4(1580351), // Rule ID 4122 //
     /* 1580274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580305 */     // MIs[0] passthru
     /* 1580305 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580318 */     // MIs[0] policy
     /* 1580318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580328 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580350 */     // GIR_Coverage, 4122,
     /* 1580350 */     GIR_EraseRootFromParent_Done,
     /* 1580351 */   // Label 21891: @1580351
     /* 1580351 */   GIM_Try, /*On fail goto*//*Label 21892*/ GIMT_Encode4(1580433), // Rule ID 4123 //
     /* 1580356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1580367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1580370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1580373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580387 */     // MIs[0] passthru
     /* 1580387 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580400 */     // MIs[0] policy
     /* 1580400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580410 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1580413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580432 */     // GIR_Coverage, 4123,
     /* 1580432 */     GIR_EraseRootFromParent_Done,
     /* 1580433 */   // Label 21892: @1580433
     /* 1580433 */   GIM_Try, /*On fail goto*//*Label 21893*/ GIMT_Encode4(1580515), // Rule ID 4132 //
     /* 1580438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1580455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580469 */     // MIs[0] passthru
     /* 1580469 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580482 */     // MIs[0] policy
     /* 1580482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580514 */     // GIR_Coverage, 4132,
     /* 1580514 */     GIR_EraseRootFromParent_Done,
     /* 1580515 */   // Label 21893: @1580515
     /* 1580515 */   GIM_Try, /*On fail goto*//*Label 21894*/ GIMT_Encode4(1580597), // Rule ID 4133 //
     /* 1580520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1580531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1580534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1580537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580551 */     // MIs[0] passthru
     /* 1580551 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580564 */     // MIs[0] policy
     /* 1580564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1580577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580596 */     // GIR_Coverage, 4133,
     /* 1580596 */     GIR_EraseRootFromParent_Done,
     /* 1580597 */   // Label 21894: @1580597
     /* 1580597 */   GIM_Try, /*On fail goto*//*Label 21895*/ GIMT_Encode4(1580679), // Rule ID 4142 //
     /* 1580602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1580613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1580616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1580619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580633 */     // MIs[0] passthru
     /* 1580633 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580646 */     // MIs[0] policy
     /* 1580646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1580659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580678 */     // GIR_Coverage, 4142,
     /* 1580678 */     GIR_EraseRootFromParent_Done,
     /* 1580679 */   // Label 21895: @1580679
     /* 1580679 */   GIM_Try, /*On fail goto*//*Label 21896*/ GIMT_Encode4(1580761), // Rule ID 4143 //
     /* 1580684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1580695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1580698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1580701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580715 */     // MIs[0] passthru
     /* 1580715 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580728 */     // MIs[0] policy
     /* 1580728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1580741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580760 */     // GIR_Coverage, 4143,
     /* 1580760 */     GIR_EraseRootFromParent_Done,
     /* 1580761 */   // Label 21896: @1580761
     /* 1580761 */   GIM_Try, /*On fail goto*//*Label 21897*/ GIMT_Encode4(1580843), // Rule ID 4152 //
     /* 1580766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1580777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1580780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1580783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580797 */     // MIs[0] passthru
     /* 1580797 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580810 */     // MIs[0] policy
     /* 1580810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580820 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580842 */     // GIR_Coverage, 4152,
     /* 1580842 */     GIR_EraseRootFromParent_Done,
     /* 1580843 */   // Label 21897: @1580843
     /* 1580843 */   GIM_Try, /*On fail goto*//*Label 21898*/ GIMT_Encode4(1580925), // Rule ID 4153 //
     /* 1580848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1580859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1580862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1580865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580879 */     // MIs[0] passthru
     /* 1580879 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580892 */     // MIs[0] policy
     /* 1580892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1580905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1580921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580924 */     // GIR_Coverage, 4153,
     /* 1580924 */     GIR_EraseRootFromParent_Done,
     /* 1580925 */   // Label 21898: @1580925
     /* 1580925 */   GIM_Try, /*On fail goto*//*Label 21899*/ GIMT_Encode4(1581007), // Rule ID 4162 //
     /* 1580930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1580938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1580941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1580944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1580947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580961 */     // MIs[0] passthru
     /* 1580961 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580974 */     // MIs[0] policy
     /* 1580974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1580987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581006 */     // GIR_Coverage, 4162,
     /* 1581006 */     GIR_EraseRootFromParent_Done,
     /* 1581007 */   // Label 21899: @1581007
     /* 1581007 */   GIM_Try, /*On fail goto*//*Label 21900*/ GIMT_Encode4(1581089), // Rule ID 4163 //
     /* 1581012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581043 */     // MIs[0] passthru
     /* 1581043 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581056 */     // MIs[0] policy
     /* 1581056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581066 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581088 */     // GIR_Coverage, 4163,
     /* 1581088 */     GIR_EraseRootFromParent_Done,
     /* 1581089 */   // Label 21900: @1581089
     /* 1581089 */   GIM_Try, /*On fail goto*//*Label 21901*/ GIMT_Encode4(1581171), // Rule ID 4172 //
     /* 1581094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581125 */     // MIs[0] passthru
     /* 1581125 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581138 */     // MIs[0] policy
     /* 1581138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581148 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581170 */     // GIR_Coverage, 4172,
     /* 1581170 */     GIR_EraseRootFromParent_Done,
     /* 1581171 */   // Label 21901: @1581171
     /* 1581171 */   GIM_Try, /*On fail goto*//*Label 21902*/ GIMT_Encode4(1581253), // Rule ID 4173 //
     /* 1581176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581207 */     // MIs[0] passthru
     /* 1581207 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581220 */     // MIs[0] policy
     /* 1581220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1581233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581252 */     // GIR_Coverage, 4173,
     /* 1581252 */     GIR_EraseRootFromParent_Done,
     /* 1581253 */   // Label 21902: @1581253
     /* 1581253 */   GIM_Try, /*On fail goto*//*Label 21903*/ GIMT_Encode4(1581335), // Rule ID 4182 //
     /* 1581258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581289 */     // MIs[0] passthru
     /* 1581289 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581302 */     // MIs[0] policy
     /* 1581302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581312 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581334 */     // GIR_Coverage, 4182,
     /* 1581334 */     GIR_EraseRootFromParent_Done,
     /* 1581335 */   // Label 21903: @1581335
     /* 1581335 */   GIM_Try, /*On fail goto*//*Label 21904*/ GIMT_Encode4(1581417), // Rule ID 4183 //
     /* 1581340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1581351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1581354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1581357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581371 */     // MIs[0] passthru
     /* 1581371 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581384 */     // MIs[0] policy
     /* 1581384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1581397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581416 */     // GIR_Coverage, 4183,
     /* 1581416 */     GIR_EraseRootFromParent_Done,
     /* 1581417 */   // Label 21904: @1581417
     /* 1581417 */   GIM_Try, /*On fail goto*//*Label 21905*/ GIMT_Encode4(1581499), // Rule ID 4192 //
     /* 1581422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581453 */     // MIs[0] passthru
     /* 1581453 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581466 */     // MIs[0] policy
     /* 1581466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581476 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581498 */     // GIR_Coverage, 4192,
     /* 1581498 */     GIR_EraseRootFromParent_Done,
     /* 1581499 */   // Label 21905: @1581499
     /* 1581499 */   GIM_Try, /*On fail goto*//*Label 21906*/ GIMT_Encode4(1581581), // Rule ID 4193 //
     /* 1581504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1581515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1581518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1581521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581535 */     // MIs[0] passthru
     /* 1581535 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581548 */     // MIs[0] policy
     /* 1581548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581558 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1581561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581580 */     // GIR_Coverage, 4193,
     /* 1581580 */     GIR_EraseRootFromParent_Done,
     /* 1581581 */   // Label 21906: @1581581
     /* 1581581 */   GIM_Try, /*On fail goto*//*Label 21907*/ GIMT_Encode4(1581663), // Rule ID 4202 //
     /* 1581586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1581597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1581600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1581603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581617 */     // MIs[0] passthru
     /* 1581617 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581630 */     // MIs[0] policy
     /* 1581630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581662 */     // GIR_Coverage, 4202,
     /* 1581662 */     GIR_EraseRootFromParent_Done,
     /* 1581663 */   // Label 21907: @1581663
     /* 1581663 */   GIM_Try, /*On fail goto*//*Label 21908*/ GIMT_Encode4(1581745), // Rule ID 4203 //
     /* 1581668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1581676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1581679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1581682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1581685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581699 */     // MIs[0] passthru
     /* 1581699 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581712 */     // MIs[0] policy
     /* 1581712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581722 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1581725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581744 */     // GIR_Coverage, 4203,
     /* 1581744 */     GIR_EraseRootFromParent_Done,
     /* 1581745 */   // Label 21908: @1581745
     /* 1581745 */   GIM_Try, /*On fail goto*//*Label 21909*/ GIMT_Encode4(1581827), // Rule ID 4272 //
     /* 1581750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1581761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1581764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1581767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581781 */     // MIs[0] passthru
     /* 1581781 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581794 */     // MIs[0] policy
     /* 1581794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581804 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1581807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581826 */     // GIR_Coverage, 4272,
     /* 1581826 */     GIR_EraseRootFromParent_Done,
     /* 1581827 */   // Label 21909: @1581827
     /* 1581827 */   GIM_Try, /*On fail goto*//*Label 21910*/ GIMT_Encode4(1581909), // Rule ID 4273 //
     /* 1581832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1581843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1581846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1581849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581863 */     // MIs[0] passthru
     /* 1581863 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581876 */     // MIs[0] policy
     /* 1581876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581886 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1581889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581908 */     // GIR_Coverage, 4273,
     /* 1581908 */     GIR_EraseRootFromParent_Done,
     /* 1581909 */   // Label 21910: @1581909
     /* 1581909 */   GIM_Try, /*On fail goto*//*Label 21911*/ GIMT_Encode4(1581991), // Rule ID 4282 //
     /* 1581914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1581922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1581925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1581928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1581931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581945 */     // MIs[0] passthru
     /* 1581945 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581958 */     // MIs[0] policy
     /* 1581958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581968 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1581971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581990 */     // GIR_Coverage, 4282,
     /* 1581990 */     GIR_EraseRootFromParent_Done,
     /* 1581991 */   // Label 21911: @1581991
     /* 1581991 */   GIM_Try, /*On fail goto*//*Label 21912*/ GIMT_Encode4(1582073), // Rule ID 4283 //
     /* 1581996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1582007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1582010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1582013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582027 */     // MIs[0] passthru
     /* 1582027 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582040 */     // MIs[0] policy
     /* 1582040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582050 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582072 */     // GIR_Coverage, 4283,
     /* 1582072 */     GIR_EraseRootFromParent_Done,
     /* 1582073 */   // Label 21912: @1582073
     /* 1582073 */   GIM_Try, /*On fail goto*//*Label 21913*/ GIMT_Encode4(1582155), // Rule ID 4292 //
     /* 1582078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582109 */     // MIs[0] passthru
     /* 1582109 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582122 */     // MIs[0] policy
     /* 1582122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582154 */     // GIR_Coverage, 4292,
     /* 1582154 */     GIR_EraseRootFromParent_Done,
     /* 1582155 */   // Label 21913: @1582155
     /* 1582155 */   GIM_Try, /*On fail goto*//*Label 21914*/ GIMT_Encode4(1582237), // Rule ID 4293 //
     /* 1582160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1582171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1582174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1582177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582191 */     // MIs[0] passthru
     /* 1582191 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582204 */     // MIs[0] policy
     /* 1582204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582214 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582236 */     // GIR_Coverage, 4293,
     /* 1582236 */     GIR_EraseRootFromParent_Done,
     /* 1582237 */   // Label 21914: @1582237
     /* 1582237 */   GIM_Try, /*On fail goto*//*Label 21915*/ GIMT_Encode4(1582319), // Rule ID 4302 //
     /* 1582242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582273 */     // MIs[0] passthru
     /* 1582273 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582286 */     // MIs[0] policy
     /* 1582286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1582299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582318 */     // GIR_Coverage, 4302,
     /* 1582318 */     GIR_EraseRootFromParent_Done,
     /* 1582319 */   // Label 21915: @1582319
     /* 1582319 */   GIM_Try, /*On fail goto*//*Label 21916*/ GIMT_Encode4(1582401), // Rule ID 4303 //
     /* 1582324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1582335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1582338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1582341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582355 */     // MIs[0] passthru
     /* 1582355 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582368 */     // MIs[0] policy
     /* 1582368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1582381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582400 */     // GIR_Coverage, 4303,
     /* 1582400 */     GIR_EraseRootFromParent_Done,
     /* 1582401 */   // Label 21916: @1582401
     /* 1582401 */   GIM_Try, /*On fail goto*//*Label 21917*/ GIMT_Encode4(1582483), // Rule ID 4312 //
     /* 1582406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582437 */     // MIs[0] passthru
     /* 1582437 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582450 */     // MIs[0] policy
     /* 1582450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1582463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582482 */     // GIR_Coverage, 4312,
     /* 1582482 */     GIR_EraseRootFromParent_Done,
     /* 1582483 */   // Label 21917: @1582483
     /* 1582483 */   GIM_Try, /*On fail goto*//*Label 21918*/ GIMT_Encode4(1582565), // Rule ID 4313 //
     /* 1582488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1582499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1582502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1582505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1582508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582519 */     // MIs[0] passthru
     /* 1582519 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582532 */     // MIs[0] policy
     /* 1582532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582542 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1582545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582564 */     // GIR_Coverage, 4313,
     /* 1582564 */     GIR_EraseRootFromParent_Done,
     /* 1582565 */   // Label 21918: @1582565
     /* 1582565 */   GIM_Try, /*On fail goto*//*Label 21919*/ GIMT_Encode4(1582647), // Rule ID 4322 //
     /* 1582570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1582581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1582584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1582587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1582590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582601 */     // MIs[0] passthru
     /* 1582601 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582614 */     // MIs[0] policy
     /* 1582614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582624 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1582627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582646 */     // GIR_Coverage, 4322,
     /* 1582646 */     GIR_EraseRootFromParent_Done,
     /* 1582647 */   // Label 21919: @1582647
     /* 1582647 */   GIM_Try, /*On fail goto*//*Label 21920*/ GIMT_Encode4(1582729), // Rule ID 4323 //
     /* 1582652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1582663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1582666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1582669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1582672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582683 */     // MIs[0] passthru
     /* 1582683 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582696 */     // MIs[0] policy
     /* 1582696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1582709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582728 */     // GIR_Coverage, 4323,
     /* 1582728 */     GIR_EraseRootFromParent_Done,
     /* 1582729 */   // Label 21920: @1582729
     /* 1582729 */   GIM_Try, /*On fail goto*//*Label 21921*/ GIMT_Encode4(1582811), // Rule ID 4332 //
     /* 1582734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1582745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1582748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1582751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582765 */     // MIs[0] passthru
     /* 1582765 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582778 */     // MIs[0] policy
     /* 1582778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582788 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582810 */     // GIR_Coverage, 4332,
     /* 1582810 */     GIR_EraseRootFromParent_Done,
     /* 1582811 */   // Label 21921: @1582811
     /* 1582811 */   GIM_Try, /*On fail goto*//*Label 21922*/ GIMT_Encode4(1582893), // Rule ID 4333 //
     /* 1582816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1582827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1582830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1582833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582847 */     // MIs[0] passthru
     /* 1582847 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582860 */     // MIs[0] policy
     /* 1582860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1582873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582892 */     // GIR_Coverage, 4333,
     /* 1582892 */     GIR_EraseRootFromParent_Done,
     /* 1582893 */   // Label 21922: @1582893
     /* 1582893 */   GIM_Try, /*On fail goto*//*Label 21923*/ GIMT_Encode4(1582975), // Rule ID 4342 //
     /* 1582898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1582909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1582912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1582915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582929 */     // MIs[0] passthru
     /* 1582929 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582942 */     // MIs[0] policy
     /* 1582942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1582955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1582971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582974 */     // GIR_Coverage, 4342,
     /* 1582974 */     GIR_EraseRootFromParent_Done,
     /* 1582975 */   // Label 21923: @1582975
     /* 1582975 */   GIM_Try, /*On fail goto*//*Label 21924*/ GIMT_Encode4(1583057), // Rule ID 4343 //
     /* 1582980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1582988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1582991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1582994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1582997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583011 */     // MIs[0] passthru
     /* 1583011 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583024 */     // MIs[0] policy
     /* 1583024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583056 */     // GIR_Coverage, 4343,
     /* 1583056 */     GIR_EraseRootFromParent_Done,
     /* 1583057 */   // Label 21924: @1583057
     /* 1583057 */   GIM_Try, /*On fail goto*//*Label 21925*/ GIMT_Encode4(1583139), // Rule ID 4352 //
     /* 1583062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583093 */     // MIs[0] passthru
     /* 1583093 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583106 */     // MIs[0] policy
     /* 1583106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583138 */     // GIR_Coverage, 4352,
     /* 1583138 */     GIR_EraseRootFromParent_Done,
     /* 1583139 */   // Label 21925: @1583139
     /* 1583139 */   GIM_Try, /*On fail goto*//*Label 21926*/ GIMT_Encode4(1583221), // Rule ID 4353 //
     /* 1583144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1583155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1583158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1583161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583175 */     // MIs[0] passthru
     /* 1583175 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583188 */     // MIs[0] policy
     /* 1583188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583220 */     // GIR_Coverage, 4353,
     /* 1583220 */     GIR_EraseRootFromParent_Done,
     /* 1583221 */   // Label 21926: @1583221
     /* 1583221 */   GIM_Try, /*On fail goto*//*Label 21927*/ GIMT_Encode4(1583303), // Rule ID 4362 //
     /* 1583226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583257 */     // MIs[0] passthru
     /* 1583257 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583270 */     // MIs[0] policy
     /* 1583270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583302 */     // GIR_Coverage, 4362,
     /* 1583302 */     GIR_EraseRootFromParent_Done,
     /* 1583303 */   // Label 21927: @1583303
     /* 1583303 */   GIM_Try, /*On fail goto*//*Label 21928*/ GIMT_Encode4(1583385), // Rule ID 4363 //
     /* 1583308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1583319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1583322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1583325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1583328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583339 */     // MIs[0] passthru
     /* 1583339 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583352 */     // MIs[0] policy
     /* 1583352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583362 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583384 */     // GIR_Coverage, 4363,
     /* 1583384 */     GIR_EraseRootFromParent_Done,
     /* 1583385 */   // Label 21928: @1583385
     /* 1583385 */   GIM_Try, /*On fail goto*//*Label 21929*/ GIMT_Encode4(1583467), // Rule ID 4372 //
     /* 1583390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583421 */     // MIs[0] passthru
     /* 1583421 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583434 */     // MIs[0] policy
     /* 1583434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583466 */     // GIR_Coverage, 4372,
     /* 1583466 */     GIR_EraseRootFromParent_Done,
     /* 1583467 */   // Label 21929: @1583467
     /* 1583467 */   GIM_Try, /*On fail goto*//*Label 21930*/ GIMT_Encode4(1583549), // Rule ID 4373 //
     /* 1583472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1583483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1583486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1583489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1583492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1583499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1583503 */     // MIs[0] passthru
     /* 1583503 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583516 */     // MIs[0] policy
     /* 1583516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1583529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583548 */     // GIR_Coverage, 4373,
     /* 1583548 */     GIR_EraseRootFromParent_Done,
     /* 1583549 */   // Label 21930: @1583549
     /* 1583549 */   GIM_Try, /*On fail goto*//*Label 21931*/ GIMT_Encode4(1583631), // Rule ID 4382 //
     /* 1583554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1583557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1583565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1583568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1583571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583585 */     // MIs[0] passthru
     /* 1583585 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583598 */     // MIs[0] policy
     /* 1583598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583608 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583630 */     // GIR_Coverage, 4382,
     /* 1583630 */     GIR_EraseRootFromParent_Done,
     /* 1583631 */   // Label 21931: @1583631
     /* 1583631 */   GIM_Try, /*On fail goto*//*Label 21932*/ GIMT_Encode4(1583713), // Rule ID 4383 //
     /* 1583636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1583639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1583647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1583650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1583653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583667 */     // MIs[0] passthru
     /* 1583667 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583680 */     // MIs[0] policy
     /* 1583680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1583693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583712 */     // GIR_Coverage, 4383,
     /* 1583712 */     GIR_EraseRootFromParent_Done,
     /* 1583713 */   // Label 21932: @1583713
     /* 1583713 */   GIM_Try, /*On fail goto*//*Label 21933*/ GIMT_Encode4(1583795), // Rule ID 4392 //
     /* 1583718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1583721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1583729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1583732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1583735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583749 */     // MIs[0] passthru
     /* 1583749 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583762 */     // MIs[0] policy
     /* 1583762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583794 */     // GIR_Coverage, 4392,
     /* 1583794 */     GIR_EraseRootFromParent_Done,
     /* 1583795 */   // Label 21933: @1583795
     /* 1583795 */   GIM_Try, /*On fail goto*//*Label 21934*/ GIMT_Encode4(1583877), // Rule ID 4393 //
     /* 1583800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1583803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1583811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1583814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1583817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1583827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583831 */     // MIs[0] passthru
     /* 1583831 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583844 */     // MIs[0] policy
     /* 1583844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583854 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1583857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583876 */     // GIR_Coverage, 4393,
     /* 1583876 */     GIR_EraseRootFromParent_Done,
     /* 1583877 */   // Label 21934: @1583877
     /* 1583877 */   GIM_Try, /*On fail goto*//*Label 21935*/ GIMT_Encode4(1583959), // Rule ID 4402 //
     /* 1583882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1583885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1583893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1583896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1583899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583913 */     // MIs[0] passthru
     /* 1583913 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1583918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1583922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583926 */     // MIs[0] policy
     /* 1583926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583936 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1583939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583958 */     // GIR_Coverage, 4402,
     /* 1583958 */     GIR_EraseRootFromParent_Done,
     /* 1583959 */   // Label 21935: @1583959
     /* 1583959 */   GIM_Try, /*On fail goto*//*Label 21936*/ GIMT_Encode4(1584041), // Rule ID 4403 //
     /* 1583964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1583967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1583972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1583975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1583978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1583981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1583991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1583995 */     // MIs[0] passthru
     /* 1583995 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584008 */     // MIs[0] policy
     /* 1584008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1584021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584040 */     // GIR_Coverage, 4403,
     /* 1584040 */     GIR_EraseRootFromParent_Done,
     /* 1584041 */   // Label 21936: @1584041
     /* 1584041 */   GIM_Try, /*On fail goto*//*Label 21937*/ GIMT_Encode4(1584123), // Rule ID 4412 //
     /* 1584046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1584049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584077 */     // MIs[0] passthru
     /* 1584077 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584090 */     // MIs[0] policy
     /* 1584090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584100 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1584103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584122 */     // GIR_Coverage, 4412,
     /* 1584122 */     GIR_EraseRootFromParent_Done,
     /* 1584123 */   // Label 21937: @1584123
     /* 1584123 */   GIM_Try, /*On fail goto*//*Label 21938*/ GIMT_Encode4(1584205), // Rule ID 4413 //
     /* 1584128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1584131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1584136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1584139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1584142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1584145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1584155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1584159 */     // MIs[0] passthru
     /* 1584159 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584172 */     // MIs[0] policy
     /* 1584172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1584185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584204 */     // GIR_Coverage, 4413,
     /* 1584204 */     GIR_EraseRootFromParent_Done,
     /* 1584205 */   // Label 21938: @1584205
     /* 1584205 */   GIM_Try, /*On fail goto*//*Label 21939*/ GIMT_Encode4(1584287), // Rule ID 4482 //
     /* 1584210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584241 */     // MIs[0] passthru
     /* 1584241 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584254 */     // MIs[0] policy
     /* 1584254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584264 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1584267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584286 */     // GIR_Coverage, 4482,
     /* 1584286 */     GIR_EraseRootFromParent_Done,
     /* 1584287 */   // Label 21939: @1584287
     /* 1584287 */   GIM_Try, /*On fail goto*//*Label 21940*/ GIMT_Encode4(1584369), // Rule ID 4483 //
     /* 1584292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1584303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1584306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1584309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584323 */     // MIs[0] passthru
     /* 1584323 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584336 */     // MIs[0] policy
     /* 1584336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1584349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584368 */     // GIR_Coverage, 4483,
     /* 1584368 */     GIR_EraseRootFromParent_Done,
     /* 1584369 */   // Label 21940: @1584369
     /* 1584369 */   GIM_Try, /*On fail goto*//*Label 21941*/ GIMT_Encode4(1584451), // Rule ID 4492 //
     /* 1584374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584405 */     // MIs[0] passthru
     /* 1584405 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584418 */     // MIs[0] policy
     /* 1584418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584428 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1584431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584450 */     // GIR_Coverage, 4492,
     /* 1584450 */     GIR_EraseRootFromParent_Done,
     /* 1584451 */   // Label 21941: @1584451
     /* 1584451 */   GIM_Try, /*On fail goto*//*Label 21942*/ GIMT_Encode4(1584533), // Rule ID 4493 //
     /* 1584456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1584467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1584470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1584473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584487 */     // MIs[0] passthru
     /* 1584487 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584500 */     // MIs[0] policy
     /* 1584500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584510 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1584513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584532 */     // GIR_Coverage, 4493,
     /* 1584532 */     GIR_EraseRootFromParent_Done,
     /* 1584533 */   // Label 21942: @1584533
     /* 1584533 */   GIM_Try, /*On fail goto*//*Label 21943*/ GIMT_Encode4(1584615), // Rule ID 4502 //
     /* 1584538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1584555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584569 */     // MIs[0] passthru
     /* 1584569 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584582 */     // MIs[0] policy
     /* 1584582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584592 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1584595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584614 */     // GIR_Coverage, 4502,
     /* 1584614 */     GIR_EraseRootFromParent_Done,
     /* 1584615 */   // Label 21943: @1584615
     /* 1584615 */   GIM_Try, /*On fail goto*//*Label 21944*/ GIMT_Encode4(1584697), // Rule ID 4503 //
     /* 1584620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1584637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584651 */     // MIs[0] passthru
     /* 1584651 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584664 */     // MIs[0] policy
     /* 1584664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584674 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1584677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584696 */     // GIR_Coverage, 4503,
     /* 1584696 */     GIR_EraseRootFromParent_Done,
     /* 1584697 */   // Label 21944: @1584697
     /* 1584697 */   GIM_Try, /*On fail goto*//*Label 21945*/ GIMT_Encode4(1584779), // Rule ID 4512 //
     /* 1584702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1584713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1584716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1584719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584733 */     // MIs[0] passthru
     /* 1584733 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584746 */     // MIs[0] policy
     /* 1584746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584756 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1584759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584778 */     // GIR_Coverage, 4512,
     /* 1584778 */     GIR_EraseRootFromParent_Done,
     /* 1584779 */   // Label 21945: @1584779
     /* 1584779 */   GIM_Try, /*On fail goto*//*Label 21946*/ GIMT_Encode4(1584861), // Rule ID 4513 //
     /* 1584784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1584795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1584798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1584801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584815 */     // MIs[0] passthru
     /* 1584815 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584828 */     // MIs[0] policy
     /* 1584828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1584841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584860 */     // GIR_Coverage, 4513,
     /* 1584860 */     GIR_EraseRootFromParent_Done,
     /* 1584861 */   // Label 21946: @1584861
     /* 1584861 */   GIM_Try, /*On fail goto*//*Label 21947*/ GIMT_Encode4(1584943), // Rule ID 4522 //
     /* 1584866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1584877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1584880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1584883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584897 */     // MIs[0] passthru
     /* 1584897 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584910 */     // MIs[0] policy
     /* 1584910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1584923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1584929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584942 */     // GIR_Coverage, 4522,
     /* 1584942 */     GIR_EraseRootFromParent_Done,
     /* 1584943 */   // Label 21947: @1584943
     /* 1584943 */   GIM_Try, /*On fail goto*//*Label 21948*/ GIMT_Encode4(1585025), // Rule ID 4523 //
     /* 1584948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1584956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1584959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1584962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1584965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584979 */     // MIs[0] passthru
     /* 1584979 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1584984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584992 */     // MIs[0] policy
     /* 1584992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585024 */     // GIR_Coverage, 4523,
     /* 1585024 */     GIR_EraseRootFromParent_Done,
     /* 1585025 */   // Label 21948: @1585025
     /* 1585025 */   GIM_Try, /*On fail goto*//*Label 21949*/ GIMT_Encode4(1585107), // Rule ID 4532 //
     /* 1585030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585061 */     // MIs[0] passthru
     /* 1585061 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585074 */     // MIs[0] policy
     /* 1585074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585106 */     // GIR_Coverage, 4532,
     /* 1585106 */     GIR_EraseRootFromParent_Done,
     /* 1585107 */   // Label 21949: @1585107
     /* 1585107 */   GIM_Try, /*On fail goto*//*Label 21950*/ GIMT_Encode4(1585189), // Rule ID 4533 //
     /* 1585112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585143 */     // MIs[0] passthru
     /* 1585143 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585156 */     // MIs[0] policy
     /* 1585156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585188 */     // GIR_Coverage, 4533,
     /* 1585188 */     GIR_EraseRootFromParent_Done,
     /* 1585189 */   // Label 21950: @1585189
     /* 1585189 */   GIM_Try, /*On fail goto*//*Label 21951*/ GIMT_Encode4(1585271), // Rule ID 4542 //
     /* 1585194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585225 */     // MIs[0] passthru
     /* 1585225 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585238 */     // MIs[0] policy
     /* 1585238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585248 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1585251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585270 */     // GIR_Coverage, 4542,
     /* 1585270 */     GIR_EraseRootFromParent_Done,
     /* 1585271 */   // Label 21951: @1585271
     /* 1585271 */   GIM_Try, /*On fail goto*//*Label 21952*/ GIMT_Encode4(1585353), // Rule ID 4543 //
     /* 1585276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1585287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1585290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1585293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1585296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585307 */     // MIs[0] passthru
     /* 1585307 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585320 */     // MIs[0] policy
     /* 1585320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585330 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1585333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585352 */     // GIR_Coverage, 4543,
     /* 1585352 */     GIR_EraseRootFromParent_Done,
     /* 1585353 */   // Label 21952: @1585353
     /* 1585353 */   GIM_Try, /*On fail goto*//*Label 21953*/ GIMT_Encode4(1585435), // Rule ID 4552 //
     /* 1585358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585389 */     // MIs[0] passthru
     /* 1585389 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585402 */     // MIs[0] policy
     /* 1585402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585412 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585434 */     // GIR_Coverage, 4552,
     /* 1585434 */     GIR_EraseRootFromParent_Done,
     /* 1585435 */   // Label 21953: @1585435
     /* 1585435 */   GIM_Try, /*On fail goto*//*Label 21954*/ GIMT_Encode4(1585517), // Rule ID 4553 //
     /* 1585440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1585451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1585454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1585457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1585460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1585467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585471 */     // MIs[0] passthru
     /* 1585471 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585484 */     // MIs[0] policy
     /* 1585484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585494 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1585497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585516 */     // GIR_Coverage, 4553,
     /* 1585516 */     GIR_EraseRootFromParent_Done,
     /* 1585517 */   // Label 21954: @1585517
     /* 1585517 */   GIM_Try, /*On fail goto*//*Label 21955*/ GIMT_Encode4(1585599), // Rule ID 4562 //
     /* 1585522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1585539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585553 */     // MIs[0] passthru
     /* 1585553 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585566 */     // MIs[0] policy
     /* 1585566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1585579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585598 */     // GIR_Coverage, 4562,
     /* 1585598 */     GIR_EraseRootFromParent_Done,
     /* 1585599 */   // Label 21955: @1585599
     /* 1585599 */   GIM_Try, /*On fail goto*//*Label 21956*/ GIMT_Encode4(1585681), // Rule ID 4563 //
     /* 1585604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1585621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585635 */     // MIs[0] passthru
     /* 1585635 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1585644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585648 */     // MIs[0] policy
     /* 1585648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1585661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585680 */     // GIR_Coverage, 4563,
     /* 1585680 */     GIR_EraseRootFromParent_Done,
     /* 1585681 */   // Label 21956: @1585681
     /* 1585681 */   GIM_Try, /*On fail goto*//*Label 21957*/ GIMT_Encode4(1585763), // Rule ID 4572 //
     /* 1585686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1585697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1585700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1585703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585717 */     // MIs[0] passthru
     /* 1585717 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585730 */     // MIs[0] policy
     /* 1585730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585740 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585762 */     // GIR_Coverage, 4572,
     /* 1585762 */     GIR_EraseRootFromParent_Done,
     /* 1585763 */   // Label 21957: @1585763
     /* 1585763 */   GIM_Try, /*On fail goto*//*Label 21958*/ GIMT_Encode4(1585845), // Rule ID 4573 //
     /* 1585768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1585779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1585782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1585785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585799 */     // MIs[0] passthru
     /* 1585799 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585812 */     // MIs[0] policy
     /* 1585812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1585825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585844 */     // GIR_Coverage, 4573,
     /* 1585844 */     GIR_EraseRootFromParent_Done,
     /* 1585845 */   // Label 21958: @1585845
     /* 1585845 */   GIM_Try, /*On fail goto*//*Label 21959*/ GIMT_Encode4(1585927), // Rule ID 4582 //
     /* 1585850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1585861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1585864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1585867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585881 */     // MIs[0] passthru
     /* 1585881 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585894 */     // MIs[0] policy
     /* 1585894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585904 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585926 */     // GIR_Coverage, 4582,
     /* 1585926 */     GIR_EraseRootFromParent_Done,
     /* 1585927 */   // Label 21959: @1585927
     /* 1585927 */   GIM_Try, /*On fail goto*//*Label 21960*/ GIMT_Encode4(1586009), // Rule ID 4583 //
     /* 1585932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1585940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1585943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1585946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1585949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585963 */     // MIs[0] passthru
     /* 1585963 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1585968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585976 */     // MIs[0] policy
     /* 1585976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585986 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1585989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1585995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1586005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586008 */     // GIR_Coverage, 4583,
     /* 1586008 */     GIR_EraseRootFromParent_Done,
     /* 1586009 */   // Label 21960: @1586009
     /* 1586009 */   GIM_Try, /*On fail goto*//*Label 21961*/ GIMT_Encode4(1586091), // Rule ID 4592 //
     /* 1586014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586045 */     // MIs[0] passthru
     /* 1586045 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586058 */     // MIs[0] policy
     /* 1586058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1586071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586090 */     // GIR_Coverage, 4592,
     /* 1586090 */     GIR_EraseRootFromParent_Done,
     /* 1586091 */   // Label 21961: @1586091
     /* 1586091 */   GIM_Try, /*On fail goto*//*Label 21962*/ GIMT_Encode4(1586173), // Rule ID 4593 //
     /* 1586096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1586107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1586110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1586113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586127 */     // MIs[0] passthru
     /* 1586127 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586140 */     // MIs[0] policy
     /* 1586140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1586153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586172 */     // GIR_Coverage, 4593,
     /* 1586172 */     GIR_EraseRootFromParent_Done,
     /* 1586173 */   // Label 21962: @1586173
     /* 1586173 */   GIM_Try, /*On fail goto*//*Label 21963*/ GIMT_Encode4(1586255), // Rule ID 4602 //
     /* 1586178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586209 */     // MIs[0] passthru
     /* 1586209 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586222 */     // MIs[0] policy
     /* 1586222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586254 */     // GIR_Coverage, 4602,
     /* 1586254 */     GIR_EraseRootFromParent_Done,
     /* 1586255 */   // Label 21963: @1586255
     /* 1586255 */   GIM_Try, /*On fail goto*//*Label 21964*/ GIMT_Encode4(1586337), // Rule ID 4603 //
     /* 1586260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1586277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586291 */     // MIs[0] passthru
     /* 1586291 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586304 */     // MIs[0] policy
     /* 1586304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1586317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586336 */     // GIR_Coverage, 4603,
     /* 1586336 */     GIR_EraseRootFromParent_Done,
     /* 1586337 */   // Label 21964: @1586337
     /* 1586337 */   GIM_Try, /*On fail goto*//*Label 21965*/ GIMT_Encode4(1586419), // Rule ID 4612 //
     /* 1586342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586373 */     // MIs[0] passthru
     /* 1586373 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586386 */     // MIs[0] policy
     /* 1586386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586418 */     // GIR_Coverage, 4612,
     /* 1586418 */     GIR_EraseRootFromParent_Done,
     /* 1586419 */   // Label 21965: @1586419
     /* 1586419 */   GIM_Try, /*On fail goto*//*Label 21966*/ GIMT_Encode4(1586501), // Rule ID 4613 //
     /* 1586424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1586441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586455 */     // MIs[0] passthru
     /* 1586455 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586468 */     // MIs[0] policy
     /* 1586468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586478 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1586481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586500 */     // GIR_Coverage, 4613,
     /* 1586500 */     GIR_EraseRootFromParent_Done,
     /* 1586501 */   // Label 21966: @1586501
     /* 1586501 */   GIM_Try, /*On fail goto*//*Label 21967*/ GIMT_Encode4(1586583), // Rule ID 4622 //
     /* 1586506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1586509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586537 */     // MIs[0] passthru
     /* 1586537 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586550 */     // MIs[0] policy
     /* 1586550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1586563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586582 */     // GIR_Coverage, 4622,
     /* 1586582 */     GIR_EraseRootFromParent_Done,
     /* 1586583 */   // Label 21967: @1586583
     /* 1586583 */   GIM_Try, /*On fail goto*//*Label 21968*/ GIMT_Encode4(1586665), // Rule ID 4623 //
     /* 1586588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1586591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1586596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586619 */     // MIs[0] passthru
     /* 1586619 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586632 */     // MIs[0] policy
     /* 1586632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1586645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586664 */     // GIR_Coverage, 4623,
     /* 1586664 */     GIR_EraseRootFromParent_Done,
     /* 1586665 */   // Label 21968: @1586665
     /* 1586665 */   GIM_Try, /*On fail goto*//*Label 21969*/ GIMT_Encode4(1586747), // Rule ID 4692 //
     /* 1586670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1586681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1586684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1586687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586701 */     // MIs[0] passthru
     /* 1586701 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586714 */     // MIs[0] policy
     /* 1586714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1586727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586746 */     // GIR_Coverage, 4692,
     /* 1586746 */     GIR_EraseRootFromParent_Done,
     /* 1586747 */   // Label 21969: @1586747
     /* 1586747 */   GIM_Try, /*On fail goto*//*Label 21970*/ GIMT_Encode4(1586829), // Rule ID 4693 //
     /* 1586752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1586763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1586766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1586769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1586772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586783 */     // MIs[0] passthru
     /* 1586783 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586796 */     // MIs[0] policy
     /* 1586796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586806 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1586809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586828 */     // GIR_Coverage, 4693,
     /* 1586828 */     GIR_EraseRootFromParent_Done,
     /* 1586829 */   // Label 21970: @1586829
     /* 1586829 */   GIM_Try, /*On fail goto*//*Label 21971*/ GIMT_Encode4(1586911), // Rule ID 4702 //
     /* 1586834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1586845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1586848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1586851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586865 */     // MIs[0] passthru
     /* 1586865 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586878 */     // MIs[0] policy
     /* 1586878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586888 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1586891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586910 */     // GIR_Coverage, 4702,
     /* 1586910 */     GIR_EraseRootFromParent_Done,
     /* 1586911 */   // Label 21971: @1586911
     /* 1586911 */   GIM_Try, /*On fail goto*//*Label 21972*/ GIMT_Encode4(1586993), // Rule ID 4703 //
     /* 1586916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1586924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1586927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1586930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1586933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586947 */     // MIs[0] passthru
     /* 1586947 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1586952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586960 */     // MIs[0] policy
     /* 1586960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586970 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1586973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586992 */     // GIR_Coverage, 4703,
     /* 1586992 */     GIR_EraseRootFromParent_Done,
     /* 1586993 */   // Label 21972: @1586993
     /* 1586993 */   GIM_Try, /*On fail goto*//*Label 21973*/ GIMT_Encode4(1587075), // Rule ID 4712 //
     /* 1586998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587029 */     // MIs[0] passthru
     /* 1587029 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587042 */     // MIs[0] policy
     /* 1587042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587074 */     // GIR_Coverage, 4712,
     /* 1587074 */     GIR_EraseRootFromParent_Done,
     /* 1587075 */   // Label 21973: @1587075
     /* 1587075 */   GIM_Try, /*On fail goto*//*Label 21974*/ GIMT_Encode4(1587157), // Rule ID 4713 //
     /* 1587080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587111 */     // MIs[0] passthru
     /* 1587111 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587124 */     // MIs[0] policy
     /* 1587124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587134 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587156 */     // GIR_Coverage, 4713,
     /* 1587156 */     GIR_EraseRootFromParent_Done,
     /* 1587157 */   // Label 21974: @1587157
     /* 1587157 */   GIM_Try, /*On fail goto*//*Label 21975*/ GIMT_Encode4(1587239), // Rule ID 4722 //
     /* 1587162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1587173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1587176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587193 */     // MIs[0] passthru
     /* 1587193 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587206 */     // MIs[0] policy
     /* 1587206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1587219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587238 */     // GIR_Coverage, 4722,
     /* 1587238 */     GIR_EraseRootFromParent_Done,
     /* 1587239 */   // Label 21975: @1587239
     /* 1587239 */   GIM_Try, /*On fail goto*//*Label 21976*/ GIMT_Encode4(1587321), // Rule ID 4723 //
     /* 1587244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1587255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1587258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1587271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587275 */     // MIs[0] passthru
     /* 1587275 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587288 */     // MIs[0] policy
     /* 1587288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1587301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587320 */     // GIR_Coverage, 4723,
     /* 1587320 */     GIR_EraseRootFromParent_Done,
     /* 1587321 */   // Label 21976: @1587321
     /* 1587321 */   GIM_Try, /*On fail goto*//*Label 21977*/ GIMT_Encode4(1587403), // Rule ID 4732 //
     /* 1587326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1587337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1587340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1587343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587357 */     // MIs[0] passthru
     /* 1587357 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587370 */     // MIs[0] policy
     /* 1587370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1587383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587402 */     // GIR_Coverage, 4732,
     /* 1587402 */     GIR_EraseRootFromParent_Done,
     /* 1587403 */   // Label 21977: @1587403
     /* 1587403 */   GIM_Try, /*On fail goto*//*Label 21978*/ GIMT_Encode4(1587485), // Rule ID 4733 //
     /* 1587408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1587419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1587422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1587425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1587428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1587435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587439 */     // MIs[0] passthru
     /* 1587439 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1587448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587452 */     // MIs[0] policy
     /* 1587452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587462 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1587465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587484 */     // GIR_Coverage, 4733,
     /* 1587484 */     GIR_EraseRootFromParent_Done,
     /* 1587485 */   // Label 21978: @1587485
     /* 1587485 */   GIM_Try, /*On fail goto*//*Label 21979*/ GIMT_Encode4(1587567), // Rule ID 4742 //
     /* 1587490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1587501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1587504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1587507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1587510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587521 */     // MIs[0] passthru
     /* 1587521 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587534 */     // MIs[0] policy
     /* 1587534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587544 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1587547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587566 */     // GIR_Coverage, 4742,
     /* 1587566 */     GIR_EraseRootFromParent_Done,
     /* 1587567 */   // Label 21979: @1587567
     /* 1587567 */   GIM_Try, /*On fail goto*//*Label 21980*/ GIMT_Encode4(1587649), // Rule ID 4743 //
     /* 1587572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1587583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1587586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1587589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1587592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1587599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1587603 */     // MIs[0] passthru
     /* 1587603 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1587612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587616 */     // MIs[0] policy
     /* 1587616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1587629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587648 */     // GIR_Coverage, 4743,
     /* 1587648 */     GIR_EraseRootFromParent_Done,
     /* 1587649 */   // Label 21980: @1587649
     /* 1587649 */   GIM_Try, /*On fail goto*//*Label 21981*/ GIMT_Encode4(1587731), // Rule ID 4752 //
     /* 1587654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1587665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1587668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1587671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587685 */     // MIs[0] passthru
     /* 1587685 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587698 */     // MIs[0] policy
     /* 1587698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587708 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1587711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587730 */     // GIR_Coverage, 4752,
     /* 1587730 */     GIR_EraseRootFromParent_Done,
     /* 1587731 */   // Label 21981: @1587731
     /* 1587731 */   GIM_Try, /*On fail goto*//*Label 21982*/ GIMT_Encode4(1587813), // Rule ID 4753 //
     /* 1587736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1587747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1587750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1587753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587767 */     // MIs[0] passthru
     /* 1587767 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587780 */     // MIs[0] policy
     /* 1587780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587790 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1587793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587812 */     // GIR_Coverage, 4753,
     /* 1587812 */     GIR_EraseRootFromParent_Done,
     /* 1587813 */   // Label 21982: @1587813
     /* 1587813 */   GIM_Try, /*On fail goto*//*Label 21983*/ GIMT_Encode4(1587895), // Rule ID 4762 //
     /* 1587818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1587829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1587832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1587835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587849 */     // MIs[0] passthru
     /* 1587849 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587862 */     // MIs[0] policy
     /* 1587862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587872 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587894 */     // GIR_Coverage, 4762,
     /* 1587894 */     GIR_EraseRootFromParent_Done,
     /* 1587895 */   // Label 21983: @1587895
     /* 1587895 */   GIM_Try, /*On fail goto*//*Label 21984*/ GIMT_Encode4(1587977), // Rule ID 4763 //
     /* 1587900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1587911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1587914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1587917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587931 */     // MIs[0] passthru
     /* 1587931 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1587936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587944 */     // MIs[0] policy
     /* 1587944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1587957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587976 */     // GIR_Coverage, 4763,
     /* 1587976 */     GIR_EraseRootFromParent_Done,
     /* 1587977 */   // Label 21984: @1587977
     /* 1587977 */   GIM_Try, /*On fail goto*//*Label 21985*/ GIMT_Encode4(1588059), // Rule ID 4772 //
     /* 1587982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1587990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1587993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1587996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1587999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588013 */     // MIs[0] passthru
     /* 1588013 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588026 */     // MIs[0] policy
     /* 1588026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588058 */     // GIR_Coverage, 4772,
     /* 1588058 */     GIR_EraseRootFromParent_Done,
     /* 1588059 */   // Label 21985: @1588059
     /* 1588059 */   GIM_Try, /*On fail goto*//*Label 21986*/ GIMT_Encode4(1588141), // Rule ID 4773 //
     /* 1588064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1588075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1588078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1588081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588095 */     // MIs[0] passthru
     /* 1588095 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588108 */     // MIs[0] policy
     /* 1588108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588118 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588140 */     // GIR_Coverage, 4773,
     /* 1588140 */     GIR_EraseRootFromParent_Done,
     /* 1588141 */   // Label 21986: @1588141
     /* 1588141 */   GIM_Try, /*On fail goto*//*Label 21987*/ GIMT_Encode4(1588223), // Rule ID 4782 //
     /* 1588146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1588157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1588160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1588163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588177 */     // MIs[0] passthru
     /* 1588177 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588190 */     // MIs[0] policy
     /* 1588190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588200 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588222 */     // GIR_Coverage, 4782,
     /* 1588222 */     GIR_EraseRootFromParent_Done,
     /* 1588223 */   // Label 21987: @1588223
     /* 1588223 */   GIM_Try, /*On fail goto*//*Label 21988*/ GIMT_Encode4(1588305), // Rule ID 4783 //
     /* 1588228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1588239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1588242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1588245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588259 */     // MIs[0] passthru
     /* 1588259 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588272 */     // MIs[0] policy
     /* 1588272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588304 */     // GIR_Coverage, 4783,
     /* 1588304 */     GIR_EraseRootFromParent_Done,
     /* 1588305 */   // Label 21988: @1588305
     /* 1588305 */   GIM_Try, /*On fail goto*//*Label 21989*/ GIMT_Encode4(1588387), // Rule ID 4792 //
     /* 1588310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1588321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1588324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1588327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588341 */     // MIs[0] passthru
     /* 1588341 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588354 */     // MIs[0] policy
     /* 1588354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588386 */     // GIR_Coverage, 4792,
     /* 1588386 */     GIR_EraseRootFromParent_Done,
     /* 1588387 */   // Label 21989: @1588387
     /* 1588387 */   GIM_Try, /*On fail goto*//*Label 21990*/ GIMT_Encode4(1588469), // Rule ID 4793 //
     /* 1588392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1588403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1588406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1588409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588423 */     // MIs[0] passthru
     /* 1588423 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588436 */     // MIs[0] policy
     /* 1588436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1588449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588468 */     // GIR_Coverage, 4793,
     /* 1588468 */     GIR_EraseRootFromParent_Done,
     /* 1588469 */   // Label 21990: @1588469
     /* 1588469 */   GIM_Try, /*On fail goto*//*Label 21991*/ GIMT_Encode4(1588551), // Rule ID 4802 //
     /* 1588474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1588491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588505 */     // MIs[0] passthru
     /* 1588505 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588518 */     // MIs[0] policy
     /* 1588518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588528 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1588531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588550 */     // GIR_Coverage, 4802,
     /* 1588550 */     GIR_EraseRootFromParent_Done,
     /* 1588551 */   // Label 21991: @1588551
     /* 1588551 */   GIM_Try, /*On fail goto*//*Label 21992*/ GIMT_Encode4(1588633), // Rule ID 4803 //
     /* 1588556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1588559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1588573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588587 */     // MIs[0] passthru
     /* 1588587 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588600 */     // MIs[0] policy
     /* 1588600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588610 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1588613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588632 */     // GIR_Coverage, 4803,
     /* 1588632 */     GIR_EraseRootFromParent_Done,
     /* 1588633 */   // Label 21992: @1588633
     /* 1588633 */   GIM_Try, /*On fail goto*//*Label 21993*/ GIMT_Encode4(1588715), // Rule ID 4812 //
     /* 1588638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1588649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1588652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1588655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588669 */     // MIs[0] passthru
     /* 1588669 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588682 */     // MIs[0] policy
     /* 1588682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588714 */     // GIR_Coverage, 4812,
     /* 1588714 */     GIR_EraseRootFromParent_Done,
     /* 1588715 */   // Label 21993: @1588715
     /* 1588715 */   GIM_Try, /*On fail goto*//*Label 21994*/ GIMT_Encode4(1588797), // Rule ID 4813 //
     /* 1588720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1588723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1588731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1588734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1588737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588751 */     // MIs[0] passthru
     /* 1588751 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588764 */     // MIs[0] policy
     /* 1588764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588774 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1588777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588796 */     // GIR_Coverage, 4813,
     /* 1588796 */     GIR_EraseRootFromParent_Done,
     /* 1588797 */   // Label 21994: @1588797
     /* 1588797 */   GIM_Try, /*On fail goto*//*Label 21995*/ GIMT_Encode4(1588879), // Rule ID 4822 //
     /* 1588802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1588813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1588816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1588819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588833 */     // MIs[0] passthru
     /* 1588833 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588846 */     // MIs[0] policy
     /* 1588846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588856 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588878 */     // GIR_Coverage, 4822,
     /* 1588878 */     GIR_EraseRootFromParent_Done,
     /* 1588879 */   // Label 21995: @1588879
     /* 1588879 */   GIM_Try, /*On fail goto*//*Label 21996*/ GIMT_Encode4(1588961), // Rule ID 4823 //
     /* 1588884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1588887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1588895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1588898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1588901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1588904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588915 */     // MIs[0] passthru
     /* 1588915 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1588920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588928 */     // MIs[0] policy
     /* 1588928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588938 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1588941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588960 */     // GIR_Coverage, 4823,
     /* 1588960 */     GIR_EraseRootFromParent_Done,
     /* 1588961 */   // Label 21996: @1588961
     /* 1588961 */   GIM_Try, /*On fail goto*//*Label 21997*/ GIMT_Encode4(1589043), // Rule ID 4832 //
     /* 1588966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1588969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1588974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1588977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1588980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1588983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588997 */     // MIs[0] passthru
     /* 1588997 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589010 */     // MIs[0] policy
     /* 1589010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589020 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1589023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589042 */     // GIR_Coverage, 4832,
     /* 1589042 */     GIR_EraseRootFromParent_Done,
     /* 1589043 */   // Label 21997: @1589043
     /* 1589043 */   GIM_Try, /*On fail goto*//*Label 21998*/ GIMT_Encode4(1589125), // Rule ID 4833 //
     /* 1589048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1589051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1589056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1589059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1589062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1589065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589079 */     // MIs[0] passthru
     /* 1589079 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1589084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589092 */     // MIs[0] policy
     /* 1589092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1589105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589124 */     // GIR_Coverage, 4833,
     /* 1589124 */     GIR_EraseRootFromParent_Done,
     /* 1589125 */   // Label 21998: @1589125
     /* 1589125 */   GIM_Try, /*On fail goto*//*Label 21999*/ GIMT_Encode4(1589211), // Rule ID 2720 //
     /* 1589130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589176 */     // MIs[0] policy
     /* 1589176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589186 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1589189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589210 */     // GIR_Coverage, 2720,
     /* 1589210 */     GIR_EraseRootFromParent_Done,
     /* 1589211 */   // Label 21999: @1589211
     /* 1589211 */   GIM_Try, /*On fail goto*//*Label 22000*/ GIMT_Encode4(1589297), // Rule ID 2721 //
     /* 1589216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589262 */     // MIs[0] policy
     /* 1589262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589272 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1589275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589296 */     // GIR_Coverage, 2721,
     /* 1589296 */     GIR_EraseRootFromParent_Done,
     /* 1589297 */   // Label 22000: @1589297
     /* 1589297 */   GIM_Try, /*On fail goto*//*Label 22001*/ GIMT_Encode4(1589383), // Rule ID 2758 //
     /* 1589302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1589310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1589313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1589316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1589319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589348 */     // MIs[0] policy
     /* 1589348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1589361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589382 */     // GIR_Coverage, 2758,
     /* 1589382 */     GIR_EraseRootFromParent_Done,
     /* 1589383 */   // Label 22001: @1589383
     /* 1589383 */   GIM_Try, /*On fail goto*//*Label 22002*/ GIMT_Encode4(1589469), // Rule ID 2759 //
     /* 1589388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1589396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1589399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1589402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1589405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589434 */     // MIs[0] policy
     /* 1589434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589444 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1589447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589468 */     // GIR_Coverage, 2759,
     /* 1589468 */     GIR_EraseRootFromParent_Done,
     /* 1589469 */   // Label 22002: @1589469
     /* 1589469 */   GIM_Try, /*On fail goto*//*Label 22003*/ GIMT_Encode4(1589555), // Rule ID 2772 //
     /* 1589474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1589482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589520 */     // MIs[0] policy
     /* 1589520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589530 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1589533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1589537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589554 */     // GIR_Coverage, 2772,
     /* 1589554 */     GIR_EraseRootFromParent_Done,
     /* 1589555 */   // Label 22003: @1589555
     /* 1589555 */   GIM_Try, /*On fail goto*//*Label 22004*/ GIMT_Encode4(1589641), // Rule ID 2773 //
     /* 1589560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1589568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589606 */     // MIs[0] policy
     /* 1589606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589616 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1589619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1589623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589640 */     // GIR_Coverage, 2773,
     /* 1589640 */     GIR_EraseRootFromParent_Done,
     /* 1589641 */   // Label 22004: @1589641
     /* 1589641 */   GIM_Try, /*On fail goto*//*Label 22005*/ GIMT_Encode4(1589727), // Rule ID 2792 //
     /* 1589646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589692 */     // MIs[0] policy
     /* 1589692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589702 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1589705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589726 */     // GIR_Coverage, 2792,
     /* 1589726 */     GIR_EraseRootFromParent_Done,
     /* 1589727 */   // Label 22005: @1589727
     /* 1589727 */   GIM_Try, /*On fail goto*//*Label 22006*/ GIMT_Encode4(1589813), // Rule ID 2793 //
     /* 1589732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1589743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1589746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1589749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1589752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1589755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589778 */     // MIs[0] policy
     /* 1589778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589788 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1589791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589812 */     // GIR_Coverage, 2793,
     /* 1589812 */     GIR_EraseRootFromParent_Done,
     /* 1589813 */   // Label 22006: @1589813
     /* 1589813 */   GIM_Try, /*On fail goto*//*Label 22007*/ GIMT_Encode4(1589899), // Rule ID 2800 //
     /* 1589818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1589829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1589832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1589835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1589838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589864 */     // MIs[0] policy
     /* 1589864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589874 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1589877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589898 */     // GIR_Coverage, 2800,
     /* 1589898 */     GIR_EraseRootFromParent_Done,
     /* 1589899 */   // Label 22007: @1589899
     /* 1589899 */   GIM_Try, /*On fail goto*//*Label 22008*/ GIMT_Encode4(1589985), // Rule ID 2801 //
     /* 1589904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1589915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1589918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1589921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1589924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1589934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1589946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589950 */     // MIs[0] policy
     /* 1589950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589960 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1589963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1589969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1589971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1589981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589984 */     // GIR_Coverage, 2801,
     /* 1589984 */     GIR_EraseRootFromParent_Done,
     /* 1589985 */   // Label 22008: @1589985
     /* 1589985 */   GIM_Try, /*On fail goto*//*Label 22009*/ GIMT_Encode4(1590071), // Rule ID 2808 //
     /* 1589990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1589998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590036 */     // MIs[0] policy
     /* 1590036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590070 */     // GIR_Coverage, 2808,
     /* 1590070 */     GIR_EraseRootFromParent_Done,
     /* 1590071 */   // Label 22009: @1590071
     /* 1590071 */   GIM_Try, /*On fail goto*//*Label 22010*/ GIMT_Encode4(1590157), // Rule ID 2809 //
     /* 1590076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1590096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590122 */     // MIs[0] policy
     /* 1590122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590132 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590156 */     // GIR_Coverage, 2809,
     /* 1590156 */     GIR_EraseRootFromParent_Done,
     /* 1590157 */   // Label 22010: @1590157
     /* 1590157 */   GIM_Try, /*On fail goto*//*Label 22011*/ GIMT_Encode4(1590243), // Rule ID 2816 //
     /* 1590162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1590179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1590182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590208 */     // MIs[0] policy
     /* 1590208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590242 */     // GIR_Coverage, 2816,
     /* 1590242 */     GIR_EraseRootFromParent_Done,
     /* 1590243 */   // Label 22011: @1590243
     /* 1590243 */   GIM_Try, /*On fail goto*//*Label 22012*/ GIMT_Encode4(1590329), // Rule ID 2817 //
     /* 1590248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1590265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1590268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590294 */     // MIs[0] policy
     /* 1590294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590304 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1590307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590328 */     // GIR_Coverage, 2817,
     /* 1590328 */     GIR_EraseRootFromParent_Done,
     /* 1590329 */   // Label 22012: @1590329
     /* 1590329 */   GIM_Try, /*On fail goto*//*Label 22013*/ GIMT_Encode4(1590415), // Rule ID 2824 //
     /* 1590334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1590351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1590354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590380 */     // MIs[0] policy
     /* 1590380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590414 */     // GIR_Coverage, 2824,
     /* 1590414 */     GIR_EraseRootFromParent_Done,
     /* 1590415 */   // Label 22013: @1590415
     /* 1590415 */   GIM_Try, /*On fail goto*//*Label 22014*/ GIMT_Encode4(1590501), // Rule ID 2825 //
     /* 1590420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1590431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1590434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1590437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1590440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590466 */     // MIs[0] policy
     /* 1590466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590476 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590500 */     // GIR_Coverage, 2825,
     /* 1590500 */     GIR_EraseRootFromParent_Done,
     /* 1590501 */   // Label 22014: @1590501
     /* 1590501 */   GIM_Try, /*On fail goto*//*Label 22015*/ GIMT_Encode4(1590587), // Rule ID 2832 //
     /* 1590506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1590517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1590520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1590523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1590526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590552 */     // MIs[0] policy
     /* 1590552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590562 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590586 */     // GIR_Coverage, 2832,
     /* 1590586 */     GIR_EraseRootFromParent_Done,
     /* 1590587 */   // Label 22015: @1590587
     /* 1590587 */   GIM_Try, /*On fail goto*//*Label 22016*/ GIMT_Encode4(1590673), // Rule ID 2833 //
     /* 1590592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1590603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1590606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1590609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1590612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590638 */     // MIs[0] policy
     /* 1590638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590648 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1590651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1590669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590672 */     // GIR_Coverage, 2833,
     /* 1590672 */     GIR_EraseRootFromParent_Done,
     /* 1590673 */   // Label 22016: @1590673
     /* 1590673 */   GIM_Try, /*On fail goto*//*Label 22017*/ GIMT_Encode4(1590759), // Rule ID 2840 //
     /* 1590678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1590689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1590692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1590695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1590698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590724 */     // MIs[0] policy
     /* 1590724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590734 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1590737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590758 */     // GIR_Coverage, 2840,
     /* 1590758 */     GIR_EraseRootFromParent_Done,
     /* 1590759 */   // Label 22017: @1590759
     /* 1590759 */   GIM_Try, /*On fail goto*//*Label 22018*/ GIMT_Encode4(1590845), // Rule ID 2841 //
     /* 1590764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1590775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1590778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1590781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1590784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590810 */     // MIs[0] policy
     /* 1590810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590820 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1590823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590844 */     // GIR_Coverage, 2841,
     /* 1590844 */     GIR_EraseRootFromParent_Done,
     /* 1590845 */   // Label 22018: @1590845
     /* 1590845 */   GIM_Try, /*On fail goto*//*Label 22019*/ GIMT_Encode4(1590931), // Rule ID 2848 //
     /* 1590850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1590861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1590864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1590867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1590870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590896 */     // MIs[0] policy
     /* 1590896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590906 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1590909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1590915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1590917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1590927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590930 */     // GIR_Coverage, 2848,
     /* 1590930 */     GIR_EraseRootFromParent_Done,
     /* 1590931 */   // Label 22019: @1590931
     /* 1590931 */   GIM_Try, /*On fail goto*//*Label 22020*/ GIMT_Encode4(1591017), // Rule ID 2849 //
     /* 1590936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1590944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1590947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1590950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1590953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1590956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590982 */     // MIs[0] policy
     /* 1590982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590992 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1590995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591016 */     // GIR_Coverage, 2849,
     /* 1591016 */     GIR_EraseRootFromParent_Done,
     /* 1591017 */   // Label 22020: @1591017
     /* 1591017 */   GIM_Try, /*On fail goto*//*Label 22021*/ GIMT_Encode4(1591103), // Rule ID 2856 //
     /* 1591022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1591042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591068 */     // MIs[0] policy
     /* 1591068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591078 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591102 */     // GIR_Coverage, 2856,
     /* 1591102 */     GIR_EraseRootFromParent_Done,
     /* 1591103 */   // Label 22021: @1591103
     /* 1591103 */   GIM_Try, /*On fail goto*//*Label 22022*/ GIMT_Encode4(1591189), // Rule ID 2857 //
     /* 1591108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1591128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591154 */     // MIs[0] policy
     /* 1591154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591188 */     // GIR_Coverage, 2857,
     /* 1591188 */     GIR_EraseRootFromParent_Done,
     /* 1591189 */   // Label 22022: @1591189
     /* 1591189 */   GIM_Try, /*On fail goto*//*Label 22023*/ GIMT_Encode4(1591275), // Rule ID 2864 //
     /* 1591194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1591197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1591205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1591208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1591211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1591214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591240 */     // MIs[0] policy
     /* 1591240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591250 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591274 */     // GIR_Coverage, 2864,
     /* 1591274 */     GIR_EraseRootFromParent_Done,
     /* 1591275 */   // Label 22023: @1591275
     /* 1591275 */   GIM_Try, /*On fail goto*//*Label 22024*/ GIMT_Encode4(1591361), // Rule ID 2865 //
     /* 1591280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1591283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1591291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1591294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1591297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1591300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591326 */     // MIs[0] policy
     /* 1591326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1591339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1591357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591360 */     // GIR_Coverage, 2865,
     /* 1591360 */     GIR_EraseRootFromParent_Done,
     /* 1591361 */   // Label 22024: @1591361
     /* 1591361 */   GIM_Try, /*On fail goto*//*Label 22025*/ GIMT_Encode4(1591447), // Rule ID 2872 //
     /* 1591366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1591377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1591380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1591383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591412 */     // MIs[0] policy
     /* 1591412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591422 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591446 */     // GIR_Coverage, 2872,
     /* 1591446 */     GIR_EraseRootFromParent_Done,
     /* 1591447 */   // Label 22025: @1591447
     /* 1591447 */   GIM_Try, /*On fail goto*//*Label 22026*/ GIMT_Encode4(1591533), // Rule ID 2873 //
     /* 1591452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1591463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1591466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1591469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1591472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1591475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591498 */     // MIs[0] policy
     /* 1591498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591508 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591532 */     // GIR_Coverage, 2873,
     /* 1591532 */     GIR_EraseRootFromParent_Done,
     /* 1591533 */   // Label 22026: @1591533
     /* 1591533 */   GIM_Try, /*On fail goto*//*Label 22027*/ GIMT_Encode4(1591619), // Rule ID 2880 //
     /* 1591538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1591549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1591552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1591555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1591558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1591561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1591568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591584 */     // MIs[0] policy
     /* 1591584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591594 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1591597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591618 */     // GIR_Coverage, 2880,
     /* 1591618 */     GIR_EraseRootFromParent_Done,
     /* 1591619 */   // Label 22027: @1591619
     /* 1591619 */   GIM_Try, /*On fail goto*//*Label 22028*/ GIMT_Encode4(1591705), // Rule ID 2881 //
     /* 1591624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1591635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1591638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1591641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1591644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1591647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1591654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1591666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591670 */     // MIs[0] policy
     /* 1591670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591680 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1591683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591704 */     // GIR_Coverage, 2881,
     /* 1591704 */     GIR_EraseRootFromParent_Done,
     /* 1591705 */   // Label 22028: @1591705
     /* 1591705 */   GIM_Try, /*On fail goto*//*Label 22029*/ GIMT_Encode4(1591791), // Rule ID 2888 //
     /* 1591710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1591721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1591724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1591727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1591730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1591733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1591740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591756 */     // MIs[0] policy
     /* 1591756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591766 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1591769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591790 */     // GIR_Coverage, 2888,
     /* 1591790 */     GIR_EraseRootFromParent_Done,
     /* 1591791 */   // Label 22029: @1591791
     /* 1591791 */   GIM_Try, /*On fail goto*//*Label 22030*/ GIMT_Encode4(1591877), // Rule ID 2889 //
     /* 1591796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1591807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1591810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1591813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1591816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1591819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1591826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1591838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591842 */     // MIs[0] policy
     /* 1591842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591852 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1591855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591876 */     // GIR_Coverage, 2889,
     /* 1591876 */     GIR_EraseRootFromParent_Done,
     /* 1591877 */   // Label 22030: @1591877
     /* 1591877 */   GIM_Try, /*On fail goto*//*Label 22031*/ GIMT_Encode4(1591963), // Rule ID 2896 //
     /* 1591882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1591893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1591896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1591899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1591902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1591924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591928 */     // MIs[0] policy
     /* 1591928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591938 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1591941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1591947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1591949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591962 */     // GIR_Coverage, 2896,
     /* 1591962 */     GIR_EraseRootFromParent_Done,
     /* 1591963 */   // Label 22031: @1591963
     /* 1591963 */   GIM_Try, /*On fail goto*//*Label 22032*/ GIMT_Encode4(1592049), // Rule ID 2897 //
     /* 1591968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1591976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1591979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1591982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1591985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1591988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1591998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592014 */     // MIs[0] policy
     /* 1592014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592048 */     // GIR_Coverage, 2897,
     /* 1592048 */     GIR_EraseRootFromParent_Done,
     /* 1592049 */   // Label 22032: @1592049
     /* 1592049 */   GIM_Try, /*On fail goto*//*Label 22033*/ GIMT_Encode4(1592135), // Rule ID 2904 //
     /* 1592054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592100 */     // MIs[0] policy
     /* 1592100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592110 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592134 */     // GIR_Coverage, 2904,
     /* 1592134 */     GIR_EraseRootFromParent_Done,
     /* 1592135 */   // Label 22033: @1592135
     /* 1592135 */   GIM_Try, /*On fail goto*//*Label 22034*/ GIMT_Encode4(1592221), // Rule ID 2905 //
     /* 1592140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1592160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592186 */     // MIs[0] policy
     /* 1592186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592196 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592220 */     // GIR_Coverage, 2905,
     /* 1592220 */     GIR_EraseRootFromParent_Done,
     /* 1592221 */   // Label 22034: @1592221
     /* 1592221 */   GIM_Try, /*On fail goto*//*Label 22035*/ GIMT_Encode4(1592307), // Rule ID 2912 //
     /* 1592226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1592237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1592240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1592243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1592246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592272 */     // MIs[0] policy
     /* 1592272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592282 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592306 */     // GIR_Coverage, 2912,
     /* 1592306 */     GIR_EraseRootFromParent_Done,
     /* 1592307 */   // Label 22035: @1592307
     /* 1592307 */   GIM_Try, /*On fail goto*//*Label 22036*/ GIMT_Encode4(1592393), // Rule ID 2913 //
     /* 1592312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1592323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1592326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1592329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1592332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592358 */     // MIs[0] policy
     /* 1592358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592368 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592392 */     // GIR_Coverage, 2913,
     /* 1592392 */     GIR_EraseRootFromParent_Done,
     /* 1592393 */   // Label 22036: @1592393
     /* 1592393 */   GIM_Try, /*On fail goto*//*Label 22037*/ GIMT_Encode4(1592479), // Rule ID 2920 //
     /* 1592398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1592409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1592412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1592415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592444 */     // MIs[0] policy
     /* 1592444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592454 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592478 */     // GIR_Coverage, 2920,
     /* 1592478 */     GIR_EraseRootFromParent_Done,
     /* 1592479 */   // Label 22037: @1592479
     /* 1592479 */   GIM_Try, /*On fail goto*//*Label 22038*/ GIMT_Encode4(1592565), // Rule ID 2921 //
     /* 1592484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1592495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1592498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1592501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1592504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1592507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592530 */     // MIs[0] policy
     /* 1592530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592564 */     // GIR_Coverage, 2921,
     /* 1592564 */     GIR_EraseRootFromParent_Done,
     /* 1592565 */   // Label 22038: @1592565
     /* 1592565 */   GIM_Try, /*On fail goto*//*Label 22039*/ GIMT_Encode4(1592651), // Rule ID 2928 //
     /* 1592570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1592581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1592584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1592587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1592590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592616 */     // MIs[0] policy
     /* 1592616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592650 */     // GIR_Coverage, 2928,
     /* 1592650 */     GIR_EraseRootFromParent_Done,
     /* 1592651 */   // Label 22039: @1592651
     /* 1592651 */   GIM_Try, /*On fail goto*//*Label 22040*/ GIMT_Encode4(1592737), // Rule ID 2929 //
     /* 1592656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1592667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1592670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1592673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1592676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592702 */     // MIs[0] policy
     /* 1592702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1592715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592736 */     // GIR_Coverage, 2929,
     /* 1592736 */     GIR_EraseRootFromParent_Done,
     /* 1592737 */   // Label 22040: @1592737
     /* 1592737 */   GIM_Try, /*On fail goto*//*Label 22041*/ GIMT_Encode4(1592823), // Rule ID 2936 //
     /* 1592742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1592753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1592756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1592759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1592762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592788 */     // MIs[0] policy
     /* 1592788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592798 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592822 */     // GIR_Coverage, 2936,
     /* 1592822 */     GIR_EraseRootFromParent_Done,
     /* 1592823 */   // Label 22041: @1592823
     /* 1592823 */   GIM_Try, /*On fail goto*//*Label 22042*/ GIMT_Encode4(1592909), // Rule ID 2937 //
     /* 1592828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1592839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1592842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1592845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1592848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592874 */     // MIs[0] policy
     /* 1592874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592884 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1592887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1592905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592908 */     // GIR_Coverage, 2937,
     /* 1592908 */     GIR_EraseRootFromParent_Done,
     /* 1592909 */   // Label 22042: @1592909
     /* 1592909 */   GIM_Try, /*On fail goto*//*Label 22043*/ GIMT_Encode4(1592995), // Rule ID 2944 //
     /* 1592914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1592917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1592922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1592925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1592928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1592931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1592934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1592937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592960 */     // MIs[0] policy
     /* 1592960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1592973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1592979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1592981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1592991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592994 */     // GIR_Coverage, 2944,
     /* 1592994 */     GIR_EraseRootFromParent_Done,
     /* 1592995 */   // Label 22043: @1592995
     /* 1592995 */   GIM_Try, /*On fail goto*//*Label 22044*/ GIMT_Encode4(1593081), // Rule ID 2945 //
     /* 1593000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1593011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1593014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1593017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1593020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593046 */     // MIs[0] policy
     /* 1593046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593056 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1593059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593080 */     // GIR_Coverage, 2945,
     /* 1593080 */     GIR_EraseRootFromParent_Done,
     /* 1593081 */   // Label 22044: @1593081
     /* 1593081 */   GIM_Try, /*On fail goto*//*Label 22045*/ GIMT_Encode4(1593167), // Rule ID 2952 //
     /* 1593086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1593106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593132 */     // MIs[0] policy
     /* 1593132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593142 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593166 */     // GIR_Coverage, 2952,
     /* 1593166 */     GIR_EraseRootFromParent_Done,
     /* 1593167 */   // Label 22045: @1593167
     /* 1593167 */   GIM_Try, /*On fail goto*//*Label 22046*/ GIMT_Encode4(1593253), // Rule ID 2953 //
     /* 1593172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1593192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593218 */     // MIs[0] policy
     /* 1593218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593228 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1593231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593252 */     // GIR_Coverage, 2953,
     /* 1593252 */     GIR_EraseRootFromParent_Done,
     /* 1593253 */   // Label 22046: @1593253
     /* 1593253 */   GIM_Try, /*On fail goto*//*Label 22047*/ GIMT_Encode4(1593339), // Rule ID 2960 //
     /* 1593258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1593269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1593272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1593275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1593278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593304 */     // MIs[0] policy
     /* 1593304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593314 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593338 */     // GIR_Coverage, 2960,
     /* 1593338 */     GIR_EraseRootFromParent_Done,
     /* 1593339 */   // Label 22047: @1593339
     /* 1593339 */   GIM_Try, /*On fail goto*//*Label 22048*/ GIMT_Encode4(1593425), // Rule ID 2961 //
     /* 1593344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1593352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1593355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1593358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1593361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1593364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593390 */     // MIs[0] policy
     /* 1593390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593400 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1593403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1593409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1593411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593424 */     // GIR_Coverage, 2961,
     /* 1593424 */     GIR_EraseRootFromParent_Done,
     /* 1593425 */   // Label 22048: @1593425
     /* 1593425 */   GIM_Try, /*On fail goto*//*Label 22049*/ GIMT_Encode4(1593511), // Rule ID 2976 //
     /* 1593430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1593441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1593444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1593447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1593450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593476 */     // MIs[0] policy
     /* 1593476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593486 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593510 */     // GIR_Coverage, 2976,
     /* 1593510 */     GIR_EraseRootFromParent_Done,
     /* 1593511 */   // Label 22049: @1593511
     /* 1593511 */   GIM_Try, /*On fail goto*//*Label 22050*/ GIMT_Encode4(1593597), // Rule ID 2977 //
     /* 1593516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1593527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1593530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1593533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1593536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593562 */     // MIs[0] policy
     /* 1593562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593572 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593596 */     // GIR_Coverage, 2977,
     /* 1593596 */     GIR_EraseRootFromParent_Done,
     /* 1593597 */   // Label 22050: @1593597
     /* 1593597 */   GIM_Try, /*On fail goto*//*Label 22051*/ GIMT_Encode4(1593683), // Rule ID 2980 //
     /* 1593602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1593613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1593616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1593619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1593622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593648 */     // MIs[0] policy
     /* 1593648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593658 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1593661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593682 */     // GIR_Coverage, 2980,
     /* 1593682 */     GIR_EraseRootFromParent_Done,
     /* 1593683 */   // Label 22051: @1593683
     /* 1593683 */   GIM_Try, /*On fail goto*//*Label 22052*/ GIMT_Encode4(1593769), // Rule ID 2981 //
     /* 1593688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1593699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1593702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1593705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1593708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593734 */     // MIs[0] policy
     /* 1593734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593744 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1593747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1593765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593768 */     // GIR_Coverage, 2981,
     /* 1593768 */     GIR_EraseRootFromParent_Done,
     /* 1593769 */   // Label 22052: @1593769
     /* 1593769 */   GIM_Try, /*On fail goto*//*Label 22053*/ GIMT_Encode4(1593855), // Rule ID 2984 //
     /* 1593774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1593785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1593788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1593791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1593794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593820 */     // MIs[0] policy
     /* 1593820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593830 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593854 */     // GIR_Coverage, 2984,
     /* 1593854 */     GIR_EraseRootFromParent_Done,
     /* 1593855 */   // Label 22053: @1593855
     /* 1593855 */   GIM_Try, /*On fail goto*//*Label 22054*/ GIMT_Encode4(1593941), // Rule ID 2985 //
     /* 1593860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1593871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1593874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1593877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1593880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1593883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593906 */     // MIs[0] policy
     /* 1593906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593916 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1593919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593940 */     // GIR_Coverage, 2985,
     /* 1593940 */     GIR_EraseRootFromParent_Done,
     /* 1593941 */   // Label 22054: @1593941
     /* 1593941 */   GIM_Try, /*On fail goto*//*Label 22055*/ GIMT_Encode4(1594027), // Rule ID 2988 //
     /* 1593946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1593957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1593960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1593963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1593966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1593976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1593988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593992 */     // MIs[0] policy
     /* 1593992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594002 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594026 */     // GIR_Coverage, 2988,
     /* 1594026 */     GIR_EraseRootFromParent_Done,
     /* 1594027 */   // Label 22055: @1594027
     /* 1594027 */   GIM_Try, /*On fail goto*//*Label 22056*/ GIMT_Encode4(1594113), // Rule ID 2989 //
     /* 1594032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1594043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1594046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1594049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1594052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594078 */     // MIs[0] policy
     /* 1594078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594088 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594112 */     // GIR_Coverage, 2989,
     /* 1594112 */     GIR_EraseRootFromParent_Done,
     /* 1594113 */   // Label 22056: @1594113
     /* 1594113 */   GIM_Try, /*On fail goto*//*Label 22057*/ GIMT_Encode4(1594199), // Rule ID 2992 //
     /* 1594118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594164 */     // MIs[0] policy
     /* 1594164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594198 */     // GIR_Coverage, 2992,
     /* 1594198 */     GIR_EraseRootFromParent_Done,
     /* 1594199 */   // Label 22057: @1594199
     /* 1594199 */   GIM_Try, /*On fail goto*//*Label 22058*/ GIMT_Encode4(1594285), // Rule ID 2993 //
     /* 1594204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1594215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1594218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1594221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1594224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594250 */     // MIs[0] policy
     /* 1594250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1594263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594284 */     // GIR_Coverage, 2993,
     /* 1594284 */     GIR_EraseRootFromParent_Done,
     /* 1594285 */   // Label 22058: @1594285
     /* 1594285 */   GIM_Try, /*On fail goto*//*Label 22059*/ GIMT_Encode4(1594371), // Rule ID 2996 //
     /* 1594290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594336 */     // MIs[0] policy
     /* 1594336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594370 */     // GIR_Coverage, 2996,
     /* 1594370 */     GIR_EraseRootFromParent_Done,
     /* 1594371 */   // Label 22059: @1594371
     /* 1594371 */   GIM_Try, /*On fail goto*//*Label 22060*/ GIMT_Encode4(1594457), // Rule ID 2997 //
     /* 1594376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1594387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1594390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1594393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1594396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594422 */     // MIs[0] policy
     /* 1594422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594456 */     // GIR_Coverage, 2997,
     /* 1594456 */     GIR_EraseRootFromParent_Done,
     /* 1594457 */   // Label 22060: @1594457
     /* 1594457 */   GIM_Try, /*On fail goto*//*Label 22061*/ GIMT_Encode4(1594543), // Rule ID 3000 //
     /* 1594462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1594473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1594476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1594479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1594482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594508 */     // MIs[0] policy
     /* 1594508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594542 */     // GIR_Coverage, 3000,
     /* 1594542 */     GIR_EraseRootFromParent_Done,
     /* 1594543 */   // Label 22061: @1594543
     /* 1594543 */   GIM_Try, /*On fail goto*//*Label 22062*/ GIMT_Encode4(1594629), // Rule ID 3001 //
     /* 1594548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1594559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1594562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1594565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1594568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594594 */     // MIs[0] policy
     /* 1594594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594628 */     // GIR_Coverage, 3001,
     /* 1594628 */     GIR_EraseRootFromParent_Done,
     /* 1594629 */   // Label 22062: @1594629
     /* 1594629 */   GIM_Try, /*On fail goto*//*Label 22063*/ GIMT_Encode4(1594715), // Rule ID 3004 //
     /* 1594634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1594645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1594648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1594651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1594654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594680 */     // MIs[0] policy
     /* 1594680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594714 */     // GIR_Coverage, 3004,
     /* 1594714 */     GIR_EraseRootFromParent_Done,
     /* 1594715 */   // Label 22063: @1594715
     /* 1594715 */   GIM_Try, /*On fail goto*//*Label 22064*/ GIMT_Encode4(1594801), // Rule ID 3005 //
     /* 1594720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1594731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1594734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1594737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1594740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594766 */     // MIs[0] policy
     /* 1594766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594776 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1594797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594800 */     // GIR_Coverage, 3005,
     /* 1594800 */     GIR_EraseRootFromParent_Done,
     /* 1594801 */   // Label 22064: @1594801
     /* 1594801 */   GIM_Try, /*On fail goto*//*Label 22065*/ GIMT_Encode4(1594887), // Rule ID 3008 //
     /* 1594806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1594809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1594817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1594820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1594823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1594826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594852 */     // MIs[0] policy
     /* 1594852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594862 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594886 */     // GIR_Coverage, 3008,
     /* 1594886 */     GIR_EraseRootFromParent_Done,
     /* 1594887 */   // Label 22065: @1594887
     /* 1594887 */   GIM_Try, /*On fail goto*//*Label 22066*/ GIMT_Encode4(1594973), // Rule ID 3009 //
     /* 1594892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1594895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1594903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1594906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1594909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1594912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594938 */     // MIs[0] policy
     /* 1594938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594948 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1594951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594972 */     // GIR_Coverage, 3009,
     /* 1594972 */     GIR_EraseRootFromParent_Done,
     /* 1594973 */   // Label 22066: @1594973
     /* 1594973 */   GIM_Try, /*On fail goto*//*Label 22067*/ GIMT_Encode4(1595059), // Rule ID 3012 //
     /* 1594978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1594989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1594992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1594995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1594998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595024 */     // MIs[0] policy
     /* 1595024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595034 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595058 */     // GIR_Coverage, 3012,
     /* 1595058 */     GIR_EraseRootFromParent_Done,
     /* 1595059 */   // Label 22067: @1595059
     /* 1595059 */   GIM_Try, /*On fail goto*//*Label 22068*/ GIMT_Encode4(1595145), // Rule ID 3013 //
     /* 1595064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595110 */     // MIs[0] policy
     /* 1595110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595120 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595144 */     // GIR_Coverage, 3013,
     /* 1595144 */     GIR_EraseRootFromParent_Done,
     /* 1595145 */   // Label 22068: @1595145
     /* 1595145 */   GIM_Try, /*On fail goto*//*Label 22069*/ GIMT_Encode4(1595231), // Rule ID 3016 //
     /* 1595150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595196 */     // MIs[0] policy
     /* 1595196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595206 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595230 */     // GIR_Coverage, 3016,
     /* 1595230 */     GIR_EraseRootFromParent_Done,
     /* 1595231 */   // Label 22069: @1595231
     /* 1595231 */   GIM_Try, /*On fail goto*//*Label 22070*/ GIMT_Encode4(1595317), // Rule ID 3017 //
     /* 1595236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1595247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1595250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1595253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1595256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595282 */     // MIs[0] policy
     /* 1595282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595292 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595316 */     // GIR_Coverage, 3017,
     /* 1595316 */     GIR_EraseRootFromParent_Done,
     /* 1595317 */   // Label 22070: @1595317
     /* 1595317 */   GIM_Try, /*On fail goto*//*Label 22071*/ GIMT_Encode4(1595403), // Rule ID 3020 //
     /* 1595322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595368 */     // MIs[0] policy
     /* 1595368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595378 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595402 */     // GIR_Coverage, 3020,
     /* 1595402 */     GIR_EraseRootFromParent_Done,
     /* 1595403 */   // Label 22071: @1595403
     /* 1595403 */   GIM_Try, /*On fail goto*//*Label 22072*/ GIMT_Encode4(1595489), // Rule ID 3021 //
     /* 1595408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1595419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1595422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1595425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1595428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1595431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595454 */     // MIs[0] policy
     /* 1595454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595464 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595488 */     // GIR_Coverage, 3021,
     /* 1595488 */     GIR_EraseRootFromParent_Done,
     /* 1595489 */   // Label 22072: @1595489
     /* 1595489 */   GIM_Try, /*On fail goto*//*Label 22073*/ GIMT_Encode4(1595575), // Rule ID 3024 //
     /* 1595494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1595505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1595508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1595511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1595514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595540 */     // MIs[0] policy
     /* 1595540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595550 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595574 */     // GIR_Coverage, 3024,
     /* 1595574 */     GIR_EraseRootFromParent_Done,
     /* 1595575 */   // Label 22073: @1595575
     /* 1595575 */   GIM_Try, /*On fail goto*//*Label 22074*/ GIMT_Encode4(1595661), // Rule ID 3025 //
     /* 1595580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1595591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1595594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1595597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1595600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595626 */     // MIs[0] policy
     /* 1595626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595636 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1595639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595660 */     // GIR_Coverage, 3025,
     /* 1595660 */     GIR_EraseRootFromParent_Done,
     /* 1595661 */   // Label 22074: @1595661
     /* 1595661 */   GIM_Try, /*On fail goto*//*Label 22075*/ GIMT_Encode4(1595747), // Rule ID 3028 //
     /* 1595666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1595677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1595680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1595683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1595686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595712 */     // MIs[0] policy
     /* 1595712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595722 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595746 */     // GIR_Coverage, 3028,
     /* 1595746 */     GIR_EraseRootFromParent_Done,
     /* 1595747 */   // Label 22075: @1595747
     /* 1595747 */   GIM_Try, /*On fail goto*//*Label 22076*/ GIMT_Encode4(1595833), // Rule ID 3029 //
     /* 1595752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1595763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1595766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1595769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1595772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1595782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1595794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595798 */     // MIs[0] policy
     /* 1595798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595808 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1595811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595832 */     // GIR_Coverage, 3029,
     /* 1595832 */     GIR_EraseRootFromParent_Done,
     /* 1595833 */   // Label 22076: @1595833
     /* 1595833 */   GIM_Try, /*On fail goto*//*Label 22077*/ GIMT_Encode4(1595919), // Rule ID 3032 //
     /* 1595838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1595849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1595852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1595855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1595858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595884 */     // MIs[0] policy
     /* 1595884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595918 */     // GIR_Coverage, 3032,
     /* 1595918 */     GIR_EraseRootFromParent_Done,
     /* 1595919 */   // Label 22077: @1595919
     /* 1595919 */   GIM_Try, /*On fail goto*//*Label 22078*/ GIMT_Encode4(1596005), // Rule ID 3033 //
     /* 1595924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1595932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1595935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1595938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1595941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1595944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1595947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1595954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1595966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595970 */     // MIs[0] policy
     /* 1595970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595980 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1595983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596004 */     // GIR_Coverage, 3033,
     /* 1596004 */     GIR_EraseRootFromParent_Done,
     /* 1596005 */   // Label 22078: @1596005
     /* 1596005 */   GIM_Try, /*On fail goto*//*Label 22079*/ GIMT_Encode4(1596091), // Rule ID 3036 //
     /* 1596010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596056 */     // MIs[0] policy
     /* 1596056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596090 */     // GIR_Coverage, 3036,
     /* 1596090 */     GIR_EraseRootFromParent_Done,
     /* 1596091 */   // Label 22079: @1596091
     /* 1596091 */   GIM_Try, /*On fail goto*//*Label 22080*/ GIMT_Encode4(1596177), // Rule ID 3037 //
     /* 1596096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1596107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1596110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1596113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1596116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596142 */     // MIs[0] policy
     /* 1596142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596176 */     // GIR_Coverage, 3037,
     /* 1596176 */     GIR_EraseRootFromParent_Done,
     /* 1596177 */   // Label 22080: @1596177
     /* 1596177 */   GIM_Try, /*On fail goto*//*Label 22081*/ GIMT_Encode4(1596263), // Rule ID 3040 //
     /* 1596182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596228 */     // MIs[0] policy
     /* 1596228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596238 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596262 */     // GIR_Coverage, 3040,
     /* 1596262 */     GIR_EraseRootFromParent_Done,
     /* 1596263 */   // Label 22081: @1596263
     /* 1596263 */   GIM_Try, /*On fail goto*//*Label 22082*/ GIMT_Encode4(1596349), // Rule ID 3041 //
     /* 1596268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1596279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1596282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1596285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1596288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596314 */     // MIs[0] policy
     /* 1596314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596324 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596348 */     // GIR_Coverage, 3041,
     /* 1596348 */     GIR_EraseRootFromParent_Done,
     /* 1596349 */   // Label 22082: @1596349
     /* 1596349 */   GIM_Try, /*On fail goto*//*Label 22083*/ GIMT_Encode4(1596435), // Rule ID 3044 //
     /* 1596354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596400 */     // MIs[0] policy
     /* 1596400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596410 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596434 */     // GIR_Coverage, 3044,
     /* 1596434 */     GIR_EraseRootFromParent_Done,
     /* 1596435 */   // Label 22083: @1596435
     /* 1596435 */   GIM_Try, /*On fail goto*//*Label 22084*/ GIMT_Encode4(1596521), // Rule ID 3045 //
     /* 1596440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1596451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1596454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1596457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1596460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596486 */     // MIs[0] policy
     /* 1596486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1596517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596520 */     // GIR_Coverage, 3045,
     /* 1596520 */     GIR_EraseRootFromParent_Done,
     /* 1596521 */   // Label 22084: @1596521
     /* 1596521 */   GIM_Try, /*On fail goto*//*Label 22085*/ GIMT_Encode4(1596607), // Rule ID 3048 //
     /* 1596526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1596537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1596540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1596543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1596546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1596549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596572 */     // MIs[0] policy
     /* 1596572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596606 */     // GIR_Coverage, 3048,
     /* 1596606 */     GIR_EraseRootFromParent_Done,
     /* 1596607 */   // Label 22085: @1596607
     /* 1596607 */   GIM_Try, /*On fail goto*//*Label 22086*/ GIMT_Encode4(1596693), // Rule ID 3049 //
     /* 1596612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1596615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1596623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1596626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1596629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1596632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1596635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596658 */     // MIs[0] policy
     /* 1596658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1596671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596692 */     // GIR_Coverage, 3049,
     /* 1596692 */     GIR_EraseRootFromParent_Done,
     /* 1596693 */   // Label 22086: @1596693
     /* 1596693 */   GIM_Try, /*On fail goto*//*Label 22087*/ GIMT_Encode4(1596779), // Rule ID 3052 //
     /* 1596698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1596709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1596712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1596715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1596718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596744 */     // MIs[0] policy
     /* 1596744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596754 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596778 */     // GIR_Coverage, 3052,
     /* 1596778 */     GIR_EraseRootFromParent_Done,
     /* 1596779 */   // Label 22087: @1596779
     /* 1596779 */   GIM_Try, /*On fail goto*//*Label 22088*/ GIMT_Encode4(1596865), // Rule ID 3053 //
     /* 1596784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1596787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1596795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1596798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1596801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1596804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1596807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596830 */     // MIs[0] policy
     /* 1596830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596840 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1596843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596864 */     // GIR_Coverage, 3053,
     /* 1596864 */     GIR_EraseRootFromParent_Done,
     /* 1596865 */   // Label 22088: @1596865
     /* 1596865 */   GIM_Try, /*On fail goto*//*Label 22089*/ GIMT_Encode4(1596951), // Rule ID 3056 //
     /* 1596870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1596873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1596881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1596884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1596887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1596890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596916 */     // MIs[0] policy
     /* 1596916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1596929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1596947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596950 */     // GIR_Coverage, 3056,
     /* 1596950 */     GIR_EraseRootFromParent_Done,
     /* 1596951 */   // Label 22089: @1596951
     /* 1596951 */   GIM_Try, /*On fail goto*//*Label 22090*/ GIMT_Encode4(1597037), // Rule ID 3057 //
     /* 1596956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1596959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1596964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1596967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1596970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1596973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1596976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597002 */     // MIs[0] policy
     /* 1597002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1597015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597036 */     // GIR_Coverage, 3057,
     /* 1597036 */     GIR_EraseRootFromParent_Done,
     /* 1597037 */   // Label 22090: @1597037
     /* 1597037 */   GIM_Try, /*On fail goto*//*Label 22091*/ GIMT_Encode4(1597123), // Rule ID 3060 //
     /* 1597042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1597053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1597056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1597059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597088 */     // MIs[0] policy
     /* 1597088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597098 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1597101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597122 */     // GIR_Coverage, 3060,
     /* 1597122 */     GIR_EraseRootFromParent_Done,
     /* 1597123 */   // Label 22091: @1597123
     /* 1597123 */   GIM_Try, /*On fail goto*//*Label 22092*/ GIMT_Encode4(1597209), // Rule ID 3061 //
     /* 1597128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1597139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1597142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1597145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597174 */     // MIs[0] policy
     /* 1597174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597184 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1597187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597208 */     // GIR_Coverage, 3061,
     /* 1597208 */     GIR_EraseRootFromParent_Done,
     /* 1597209 */   // Label 22092: @1597209
     /* 1597209 */   GIM_Try, /*On fail goto*//*Label 22093*/ GIMT_Encode4(1597295), // Rule ID 3064 //
     /* 1597214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597260 */     // MIs[0] policy
     /* 1597260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597270 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597294 */     // GIR_Coverage, 3064,
     /* 1597294 */     GIR_EraseRootFromParent_Done,
     /* 1597295 */   // Label 22093: @1597295
     /* 1597295 */   GIM_Try, /*On fail goto*//*Label 22094*/ GIMT_Encode4(1597381), // Rule ID 3065 //
     /* 1597300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1597311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1597314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1597317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597346 */     // MIs[0] policy
     /* 1597346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597356 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597380 */     // GIR_Coverage, 3065,
     /* 1597380 */     GIR_EraseRootFromParent_Done,
     /* 1597381 */   // Label 22094: @1597381
     /* 1597381 */   GIM_Try, /*On fail goto*//*Label 22095*/ GIMT_Encode4(1597467), // Rule ID 3068 //
     /* 1597386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597432 */     // MIs[0] policy
     /* 1597432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597442 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597466 */     // GIR_Coverage, 3068,
     /* 1597466 */     GIR_EraseRootFromParent_Done,
     /* 1597467 */   // Label 22095: @1597467
     /* 1597467 */   GIM_Try, /*On fail goto*//*Label 22096*/ GIMT_Encode4(1597553), // Rule ID 3069 //
     /* 1597472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1597483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1597486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1597489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597518 */     // MIs[0] policy
     /* 1597518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597528 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1597549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597552 */     // GIR_Coverage, 3069,
     /* 1597552 */     GIR_EraseRootFromParent_Done,
     /* 1597553 */   // Label 22096: @1597553
     /* 1597553 */   GIM_Try, /*On fail goto*//*Label 22097*/ GIMT_Encode4(1597639), // Rule ID 3072 //
     /* 1597558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1597569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1597572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1597575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597604 */     // MIs[0] policy
     /* 1597604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597614 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597638 */     // GIR_Coverage, 3072,
     /* 1597638 */     GIR_EraseRootFromParent_Done,
     /* 1597639 */   // Label 22097: @1597639
     /* 1597639 */   GIM_Try, /*On fail goto*//*Label 22098*/ GIMT_Encode4(1597725), // Rule ID 3073 //
     /* 1597644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1597655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1597658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1597661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597690 */     // MIs[0] policy
     /* 1597690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1597703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597724 */     // GIR_Coverage, 3073,
     /* 1597724 */     GIR_EraseRootFromParent_Done,
     /* 1597725 */   // Label 22098: @1597725
     /* 1597725 */   GIM_Try, /*On fail goto*//*Label 22099*/ GIMT_Encode4(1597811), // Rule ID 3076 //
     /* 1597730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1597741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1597744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1597747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597776 */     // MIs[0] policy
     /* 1597776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597786 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597810 */     // GIR_Coverage, 3076,
     /* 1597810 */     GIR_EraseRootFromParent_Done,
     /* 1597811 */   // Label 22099: @1597811
     /* 1597811 */   GIM_Try, /*On fail goto*//*Label 22100*/ GIMT_Encode4(1597897), // Rule ID 3077 //
     /* 1597816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1597827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1597830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1597833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1597836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597862 */     // MIs[0] policy
     /* 1597862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597872 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1597893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597896 */     // GIR_Coverage, 3077,
     /* 1597896 */     GIR_EraseRootFromParent_Done,
     /* 1597897 */   // Label 22100: @1597897
     /* 1597897 */   GIM_Try, /*On fail goto*//*Label 22101*/ GIMT_Encode4(1597983), // Rule ID 3080 //
     /* 1597902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1597913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1597916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1597919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1597922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1597925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1597932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1597940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1597944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597948 */     // MIs[0] policy
     /* 1597948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1597961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597982 */     // GIR_Coverage, 3080,
     /* 1597982 */     GIR_EraseRootFromParent_Done,
     /* 1597983 */   // Label 22101: @1597983
     /* 1597983 */   GIM_Try, /*On fail goto*//*Label 22102*/ GIMT_Encode4(1598069), // Rule ID 3081 //
     /* 1597988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1597996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1597999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1598002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1598005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598034 */     // MIs[0] policy
     /* 1598034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598044 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1598047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598068 */     // GIR_Coverage, 3081,
     /* 1598068 */     GIR_EraseRootFromParent_Done,
     /* 1598069 */   // Label 22102: @1598069
     /* 1598069 */   GIM_Try, /*On fail goto*//*Label 22103*/ GIMT_Encode4(1598155), // Rule ID 3084 //
     /* 1598074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598120 */     // MIs[0] policy
     /* 1598120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598130 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598154 */     // GIR_Coverage, 3084,
     /* 1598154 */     GIR_EraseRootFromParent_Done,
     /* 1598155 */   // Label 22103: @1598155
     /* 1598155 */   GIM_Try, /*On fail goto*//*Label 22104*/ GIMT_Encode4(1598241), // Rule ID 3085 //
     /* 1598160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1598171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1598174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1598177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1598183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598206 */     // MIs[0] policy
     /* 1598206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598216 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11144:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598240 */     // GIR_Coverage, 3085,
     /* 1598240 */     GIR_EraseRootFromParent_Done,
     /* 1598241 */   // Label 22104: @1598241
     /* 1598241 */   GIM_Try, /*On fail goto*//*Label 22105*/ GIMT_Encode4(1598327), // Rule ID 3088 //
     /* 1598246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598292 */     // MIs[0] policy
     /* 1598292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598302 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598326 */     // GIR_Coverage, 3088,
     /* 1598326 */     GIR_EraseRootFromParent_Done,
     /* 1598327 */   // Label 22105: @1598327
     /* 1598327 */   GIM_Try, /*On fail goto*//*Label 22106*/ GIMT_Encode4(1598413), // Rule ID 3089 //
     /* 1598332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1598343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1598346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1598349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598378 */     // MIs[0] policy
     /* 1598378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598388 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598412 */     // GIR_Coverage, 3089,
     /* 1598412 */     GIR_EraseRootFromParent_Done,
     /* 1598413 */   // Label 22106: @1598413
     /* 1598413 */   GIM_Try, /*On fail goto*//*Label 22107*/ GIMT_Encode4(1598499), // Rule ID 3092 //
     /* 1598418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598464 */     // MIs[0] policy
     /* 1598464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598498 */     // GIR_Coverage, 3092,
     /* 1598498 */     GIR_EraseRootFromParent_Done,
     /* 1598499 */   // Label 22107: @1598499
     /* 1598499 */   GIM_Try, /*On fail goto*//*Label 22108*/ GIMT_Encode4(1598585), // Rule ID 3093 //
     /* 1598504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1598515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1598518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1598521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598550 */     // MIs[0] policy
     /* 1598550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598560 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598584 */     // GIR_Coverage, 3093,
     /* 1598584 */     GIR_EraseRootFromParent_Done,
     /* 1598585 */   // Label 22108: @1598585
     /* 1598585 */   GIM_Try, /*On fail goto*//*Label 22109*/ GIMT_Encode4(1598671), // Rule ID 3096 //
     /* 1598590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1598593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1598601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1598604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1598607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598636 */     // MIs[0] policy
     /* 1598636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598646 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598670 */     // GIR_Coverage, 3096,
     /* 1598670 */     GIR_EraseRootFromParent_Done,
     /* 1598671 */   // Label 22109: @1598671
     /* 1598671 */   GIM_Try, /*On fail goto*//*Label 22110*/ GIMT_Encode4(1598757), // Rule ID 3097 //
     /* 1598676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1598679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1598687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1598690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1598693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598722 */     // MIs[0] policy
     /* 1598722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598732 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1598735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598756 */     // GIR_Coverage, 3097,
     /* 1598756 */     GIR_EraseRootFromParent_Done,
     /* 1598757 */   // Label 22110: @1598757
     /* 1598757 */   GIM_Try, /*On fail goto*//*Label 22111*/ GIMT_Encode4(1598843), // Rule ID 3100 //
     /* 1598762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1598773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1598776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1598779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1598785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1598792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598808 */     // MIs[0] policy
     /* 1598808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1598821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598842 */     // GIR_Coverage, 3100,
     /* 1598842 */     GIR_EraseRootFromParent_Done,
     /* 1598843 */   // Label 22111: @1598843
     /* 1598843 */   GIM_Try, /*On fail goto*//*Label 22112*/ GIMT_Encode4(1598929), // Rule ID 3101 //
     /* 1598848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1598859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1598862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1598865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1598871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1598878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1598886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598894 */     // MIs[0] policy
     /* 1598894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598904 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1598907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598928 */     // GIR_Coverage, 3101,
     /* 1598928 */     GIR_EraseRootFromParent_Done,
     /* 1598929 */   // Label 22112: @1598929
     /* 1598929 */   GIM_Try, /*On fail goto*//*Label 22113*/ GIMT_Encode4(1599015), // Rule ID 3104 //
     /* 1598934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1598942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1598945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1598948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1598951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1598957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1598964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1598972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598980 */     // MIs[0] policy
     /* 1598980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1598993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599014 */     // GIR_Coverage, 3104,
     /* 1599014 */     GIR_EraseRootFromParent_Done,
     /* 1599015 */   // Label 22113: @1599015
     /* 1599015 */   GIM_Try, /*On fail goto*//*Label 22114*/ GIMT_Encode4(1599101), // Rule ID 3105 //
     /* 1599020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1599037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599066 */     // MIs[0] policy
     /* 1599066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599100 */     // GIR_Coverage, 3105,
     /* 1599100 */     GIR_EraseRootFromParent_Done,
     /* 1599101 */   // Label 22114: @1599101
     /* 1599101 */   GIM_Try, /*On fail goto*//*Label 22115*/ GIMT_Encode4(1599187), // Rule ID 3108 //
     /* 1599106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599152 */     // MIs[0] policy
     /* 1599152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599162 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599186 */     // GIR_Coverage, 3108,
     /* 1599186 */     GIR_EraseRootFromParent_Done,
     /* 1599187 */   // Label 22115: @1599187
     /* 1599187 */   GIM_Try, /*On fail goto*//*Label 22116*/ GIMT_Encode4(1599273), // Rule ID 3109 //
     /* 1599192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1599203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1599206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1599209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1599215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599238 */     // MIs[0] policy
     /* 1599238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599248 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599272 */     // GIR_Coverage, 3109,
     /* 1599272 */     GIR_EraseRootFromParent_Done,
     /* 1599273 */   // Label 22116: @1599273
     /* 1599273 */   GIM_Try, /*On fail goto*//*Label 22117*/ GIMT_Encode4(1599359), // Rule ID 3112 //
     /* 1599278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599324 */     // MIs[0] policy
     /* 1599324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599358 */     // GIR_Coverage, 3112,
     /* 1599358 */     GIR_EraseRootFromParent_Done,
     /* 1599359 */   // Label 22117: @1599359
     /* 1599359 */   GIM_Try, /*On fail goto*//*Label 22118*/ GIMT_Encode4(1599445), // Rule ID 3113 //
     /* 1599364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1599375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1599378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1599381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599410 */     // MIs[0] policy
     /* 1599410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599420 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599444 */     // GIR_Coverage, 3113,
     /* 1599444 */     GIR_EraseRootFromParent_Done,
     /* 1599445 */   // Label 22118: @1599445
     /* 1599445 */   GIM_Try, /*On fail goto*//*Label 22119*/ GIMT_Encode4(1599531), // Rule ID 3116 //
     /* 1599450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1599461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1599464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1599467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599496 */     // MIs[0] policy
     /* 1599496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599506 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599530 */     // GIR_Coverage, 3116,
     /* 1599530 */     GIR_EraseRootFromParent_Done,
     /* 1599531 */   // Label 22119: @1599531
     /* 1599531 */   GIM_Try, /*On fail goto*//*Label 22120*/ GIMT_Encode4(1599617), // Rule ID 3117 //
     /* 1599536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1599547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1599550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1599553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599582 */     // MIs[0] policy
     /* 1599582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599592 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1599595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599616 */     // GIR_Coverage, 3117,
     /* 1599616 */     GIR_EraseRootFromParent_Done,
     /* 1599617 */   // Label 22120: @1599617
     /* 1599617 */   GIM_Try, /*On fail goto*//*Label 22121*/ GIMT_Encode4(1599703), // Rule ID 3120 //
     /* 1599622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1599633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1599636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1599639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599668 */     // MIs[0] policy
     /* 1599668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599678 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599702 */     // GIR_Coverage, 3120,
     /* 1599702 */     GIR_EraseRootFromParent_Done,
     /* 1599703 */   // Label 22121: @1599703
     /* 1599703 */   GIM_Try, /*On fail goto*//*Label 22122*/ GIMT_Encode4(1599789), // Rule ID 3121 //
     /* 1599708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1599719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1599722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1599725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1599738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1599746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599754 */     // MIs[0] policy
     /* 1599754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599764 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1599767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599788 */     // GIR_Coverage, 3121,
     /* 1599788 */     GIR_EraseRootFromParent_Done,
     /* 1599789 */   // Label 22122: @1599789
     /* 1599789 */   GIM_Try, /*On fail goto*//*Label 22123*/ GIMT_Encode4(1599875), // Rule ID 3124 //
     /* 1599794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1599805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1599808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1599811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599840 */     // MIs[0] policy
     /* 1599840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599874 */     // GIR_Coverage, 3124,
     /* 1599874 */     GIR_EraseRootFromParent_Done,
     /* 1599875 */   // Label 22123: @1599875
     /* 1599875 */   GIM_Try, /*On fail goto*//*Label 22124*/ GIMT_Encode4(1599961), // Rule ID 3125 //
     /* 1599880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1599891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1599894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1599897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599926 */     // MIs[0] policy
     /* 1599926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599936 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1599939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599960 */     // GIR_Coverage, 3125,
     /* 1599960 */     GIR_EraseRootFromParent_Done,
     /* 1599961 */   // Label 22124: @1599961
     /* 1599961 */   GIM_Try, /*On fail goto*//*Label 22125*/ GIMT_Encode4(1600047), // Rule ID 3128 //
     /* 1599966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1599974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1599977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1599980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1599983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600012 */     // MIs[0] policy
     /* 1600012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600046 */     // GIR_Coverage, 3128,
     /* 1600046 */     GIR_EraseRootFromParent_Done,
     /* 1600047 */   // Label 22125: @1600047
     /* 1600047 */   GIM_Try, /*On fail goto*//*Label 22126*/ GIMT_Encode4(1600133), // Rule ID 3129 //
     /* 1600052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1600069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600098 */     // MIs[0] policy
     /* 1600098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600108 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600132 */     // GIR_Coverage, 3129,
     /* 1600132 */     GIR_EraseRootFromParent_Done,
     /* 1600133 */   // Label 22126: @1600133
     /* 1600133 */   GIM_Try, /*On fail goto*//*Label 22127*/ GIMT_Encode4(1600219), // Rule ID 3132 //
     /* 1600138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600184 */     // MIs[0] policy
     /* 1600184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600218 */     // GIR_Coverage, 3132,
     /* 1600218 */     GIR_EraseRootFromParent_Done,
     /* 1600219 */   // Label 22127: @1600219
     /* 1600219 */   GIM_Try, /*On fail goto*//*Label 22128*/ GIMT_Encode4(1600305), // Rule ID 3133 //
     /* 1600224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1600235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1600238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1600241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600270 */     // MIs[0] policy
     /* 1600270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600280 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600304 */     // GIR_Coverage, 3133,
     /* 1600304 */     GIR_EraseRootFromParent_Done,
     /* 1600305 */   // Label 22128: @1600305
     /* 1600305 */   GIM_Try, /*On fail goto*//*Label 22129*/ GIMT_Encode4(1600391), // Rule ID 3136 //
     /* 1600310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600356 */     // MIs[0] policy
     /* 1600356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600366 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600390 */     // GIR_Coverage, 3136,
     /* 1600390 */     GIR_EraseRootFromParent_Done,
     /* 1600391 */   // Label 22129: @1600391
     /* 1600391 */   GIM_Try, /*On fail goto*//*Label 22130*/ GIMT_Encode4(1600477), // Rule ID 3137 //
     /* 1600396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1600407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1600410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1600413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1600419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600442 */     // MIs[0] policy
     /* 1600442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600452 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1600455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600476 */     // GIR_Coverage, 3137,
     /* 1600476 */     GIR_EraseRootFromParent_Done,
     /* 1600477 */   // Label 22130: @1600477
     /* 1600477 */   GIM_Try, /*On fail goto*//*Label 22131*/ GIMT_Encode4(1600563), // Rule ID 3140 //
     /* 1600482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1600493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1600496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600528 */     // MIs[0] policy
     /* 1600528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600538 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600562 */     // GIR_Coverage, 3140,
     /* 1600562 */     GIR_EraseRootFromParent_Done,
     /* 1600563 */   // Label 22131: @1600563
     /* 1600563 */   GIM_Try, /*On fail goto*//*Label 22132*/ GIMT_Encode4(1600649), // Rule ID 3141 //
     /* 1600568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1600579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1600582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1600585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600614 */     // MIs[0] policy
     /* 1600614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600624 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1600627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600648 */     // GIR_Coverage, 3141,
     /* 1600648 */     GIR_EraseRootFromParent_Done,
     /* 1600649 */   // Label 22132: @1600649
     /* 1600649 */   GIM_Try, /*On fail goto*//*Label 22133*/ GIMT_Encode4(1600735), // Rule ID 3144 //
     /* 1600654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1600657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1600665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1600668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1600671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600700 */     // MIs[0] policy
     /* 1600700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600710 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600734 */     // GIR_Coverage, 3144,
     /* 1600734 */     GIR_EraseRootFromParent_Done,
     /* 1600735 */   // Label 22133: @1600735
     /* 1600735 */   GIM_Try, /*On fail goto*//*Label 22134*/ GIMT_Encode4(1600821), // Rule ID 3145 //
     /* 1600740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1600743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1600748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1600751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1600754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1600757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600786 */     // MIs[0] policy
     /* 1600786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600796 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1600799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1600817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600820 */     // GIR_Coverage, 3145,
     /* 1600820 */     GIR_EraseRootFromParent_Done,
     /* 1600821 */   // Label 22134: @1600821
     /* 1600821 */   GIM_Try, /*On fail goto*//*Label 22135*/ GIMT_Encode4(1600907), // Rule ID 3236 //
     /* 1600826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1600837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1600840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1600843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1600846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600872 */     // MIs[0] policy
     /* 1600872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600882 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1600885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600906 */     // GIR_Coverage, 3236,
     /* 1600906 */     GIR_EraseRootFromParent_Done,
     /* 1600907 */   // Label 22135: @1600907
     /* 1600907 */   GIM_Try, /*On fail goto*//*Label 22136*/ GIMT_Encode4(1600993), // Rule ID 3237 //
     /* 1600912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1600923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1600926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1600929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1600932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1600935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1600942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1600954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600958 */     // MIs[0] policy
     /* 1600958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600968 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1600971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600992 */     // GIR_Coverage, 3237,
     /* 1600992 */     GIR_EraseRootFromParent_Done,
     /* 1600993 */   // Label 22136: @1600993
     /* 1600993 */   GIM_Try, /*On fail goto*//*Label 22137*/ GIMT_Encode4(1601079), // Rule ID 3240 //
     /* 1600998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1601018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601044 */     // MIs[0] policy
     /* 1601044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601054 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601078 */     // GIR_Coverage, 3240,
     /* 1601078 */     GIR_EraseRootFromParent_Done,
     /* 1601079 */   // Label 22137: @1601079
     /* 1601079 */   GIM_Try, /*On fail goto*//*Label 22138*/ GIMT_Encode4(1601165), // Rule ID 3241 //
     /* 1601084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1601104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601130 */     // MIs[0] policy
     /* 1601130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601140 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601164 */     // GIR_Coverage, 3241,
     /* 1601164 */     GIR_EraseRootFromParent_Done,
     /* 1601165 */   // Label 22138: @1601165
     /* 1601165 */   GIM_Try, /*On fail goto*//*Label 22139*/ GIMT_Encode4(1601251), // Rule ID 3244 //
     /* 1601170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1601190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601216 */     // MIs[0] policy
     /* 1601216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601226 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601250 */     // GIR_Coverage, 3244,
     /* 1601250 */     GIR_EraseRootFromParent_Done,
     /* 1601251 */   // Label 22139: @1601251
     /* 1601251 */   GIM_Try, /*On fail goto*//*Label 22140*/ GIMT_Encode4(1601337), // Rule ID 3245 //
     /* 1601256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1601267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1601270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1601273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1601276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601302 */     // MIs[0] policy
     /* 1601302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601312 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601336 */     // GIR_Coverage, 3245,
     /* 1601336 */     GIR_EraseRootFromParent_Done,
     /* 1601337 */   // Label 22140: @1601337
     /* 1601337 */   GIM_Try, /*On fail goto*//*Label 22141*/ GIMT_Encode4(1601423), // Rule ID 3248 //
     /* 1601342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1601362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601388 */     // MIs[0] policy
     /* 1601388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601398 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601422 */     // GIR_Coverage, 3248,
     /* 1601422 */     GIR_EraseRootFromParent_Done,
     /* 1601423 */   // Label 22141: @1601423
     /* 1601423 */   GIM_Try, /*On fail goto*//*Label 22142*/ GIMT_Encode4(1601509), // Rule ID 3249 //
     /* 1601428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1601439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1601442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1601445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1601448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601474 */     // MIs[0] policy
     /* 1601474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601484 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1601487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601508 */     // GIR_Coverage, 3249,
     /* 1601508 */     GIR_EraseRootFromParent_Done,
     /* 1601509 */   // Label 22142: @1601509
     /* 1601509 */   GIM_Try, /*On fail goto*//*Label 22143*/ GIMT_Encode4(1601595), // Rule ID 3252 //
     /* 1601514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1601525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1601528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1601531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1601534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601560 */     // MIs[0] policy
     /* 1601560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601570 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601594 */     // GIR_Coverage, 3252,
     /* 1601594 */     GIR_EraseRootFromParent_Done,
     /* 1601595 */   // Label 22143: @1601595
     /* 1601595 */   GIM_Try, /*On fail goto*//*Label 22144*/ GIMT_Encode4(1601681), // Rule ID 3253 //
     /* 1601600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1601611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1601614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1601617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1601620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601646 */     // MIs[0] policy
     /* 1601646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601656 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1601677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601680 */     // GIR_Coverage, 3253,
     /* 1601680 */     GIR_EraseRootFromParent_Done,
     /* 1601681 */   // Label 22144: @1601681
     /* 1601681 */   GIM_Try, /*On fail goto*//*Label 22145*/ GIMT_Encode4(1601767), // Rule ID 3256 //
     /* 1601686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1601697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1601700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1601703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1601706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601732 */     // MIs[0] policy
     /* 1601732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601766 */     // GIR_Coverage, 3256,
     /* 1601766 */     GIR_EraseRootFromParent_Done,
     /* 1601767 */   // Label 22145: @1601767
     /* 1601767 */   GIM_Try, /*On fail goto*//*Label 22146*/ GIMT_Encode4(1601853), // Rule ID 3257 //
     /* 1601772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1601783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1601786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1601789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1601792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601818 */     // MIs[0] policy
     /* 1601818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601828 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1601831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601852 */     // GIR_Coverage, 3257,
     /* 1601852 */     GIR_EraseRootFromParent_Done,
     /* 1601853 */   // Label 22146: @1601853
     /* 1601853 */   GIM_Try, /*On fail goto*//*Label 22147*/ GIMT_Encode4(1601939), // Rule ID 3260 //
     /* 1601858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1601869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1601872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1601875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1601878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601904 */     // MIs[0] policy
     /* 1601904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601914 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1601917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601938 */     // GIR_Coverage, 3260,
     /* 1601938 */     GIR_EraseRootFromParent_Done,
     /* 1601939 */   // Label 22147: @1601939
     /* 1601939 */   GIM_Try, /*On fail goto*//*Label 22148*/ GIMT_Encode4(1602025), // Rule ID 3261 //
     /* 1601944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1601955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1601958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1601961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1601964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601990 */     // MIs[0] policy
     /* 1601990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602000 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602024 */     // GIR_Coverage, 3261,
     /* 1602024 */     GIR_EraseRootFromParent_Done,
     /* 1602025 */   // Label 22148: @1602025
     /* 1602025 */   GIM_Try, /*On fail goto*//*Label 22149*/ GIMT_Encode4(1602111), // Rule ID 3264 //
     /* 1602030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1602050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602076 */     // MIs[0] policy
     /* 1602076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602110 */     // GIR_Coverage, 3264,
     /* 1602110 */     GIR_EraseRootFromParent_Done,
     /* 1602111 */   // Label 22149: @1602111
     /* 1602111 */   GIM_Try, /*On fail goto*//*Label 22150*/ GIMT_Encode4(1602197), // Rule ID 3265 //
     /* 1602116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1602127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1602130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1602133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1602136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602162 */     // MIs[0] policy
     /* 1602162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602196 */     // GIR_Coverage, 3265,
     /* 1602196 */     GIR_EraseRootFromParent_Done,
     /* 1602197 */   // Label 22150: @1602197
     /* 1602197 */   GIM_Try, /*On fail goto*//*Label 22151*/ GIMT_Encode4(1602283), // Rule ID 3268 //
     /* 1602202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1602222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602248 */     // MIs[0] policy
     /* 1602248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602282 */     // GIR_Coverage, 3268,
     /* 1602282 */     GIR_EraseRootFromParent_Done,
     /* 1602283 */   // Label 22151: @1602283
     /* 1602283 */   GIM_Try, /*On fail goto*//*Label 22152*/ GIMT_Encode4(1602369), // Rule ID 3269 //
     /* 1602288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1602299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1602302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1602305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1602308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602334 */     // MIs[0] policy
     /* 1602334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602368 */     // GIR_Coverage, 3269,
     /* 1602368 */     GIR_EraseRootFromParent_Done,
     /* 1602369 */   // Label 22152: @1602369
     /* 1602369 */   GIM_Try, /*On fail goto*//*Label 22153*/ GIMT_Encode4(1602455), // Rule ID 3272 //
     /* 1602374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1602377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1602394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602420 */     // MIs[0] policy
     /* 1602420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602430 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602454 */     // GIR_Coverage, 3272,
     /* 1602454 */     GIR_EraseRootFromParent_Done,
     /* 1602455 */   // Label 22153: @1602455
     /* 1602455 */   GIM_Try, /*On fail goto*//*Label 22154*/ GIMT_Encode4(1602541), // Rule ID 3273 //
     /* 1602460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1602463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1602471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1602474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1602477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1602480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602506 */     // MIs[0] policy
     /* 1602506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602516 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1602519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1602537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602540 */     // GIR_Coverage, 3273,
     /* 1602540 */     GIR_EraseRootFromParent_Done,
     /* 1602541 */   // Label 22154: @1602541
     /* 1602541 */   GIM_Try, /*On fail goto*//*Label 22155*/ GIMT_Encode4(1602627), // Rule ID 3276 //
     /* 1602546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1602557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1602560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1602563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1602566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1602569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1602576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602592 */     // MIs[0] policy
     /* 1602592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602602 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1602605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602626 */     // GIR_Coverage, 3276,
     /* 1602626 */     GIR_EraseRootFromParent_Done,
     /* 1602627 */   // Label 22155: @1602627
     /* 1602627 */   GIM_Try, /*On fail goto*//*Label 22156*/ GIMT_Encode4(1602713), // Rule ID 3277 //
     /* 1602632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1602643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1602646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1602649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1602652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1602655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1602662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1602674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602678 */     // MIs[0] policy
     /* 1602678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1602691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602712 */     // GIR_Coverage, 3277,
     /* 1602712 */     GIR_EraseRootFromParent_Done,
     /* 1602713 */   // Label 22156: @1602713
     /* 1602713 */   GIM_Try, /*On fail goto*//*Label 22157*/ GIMT_Encode4(1602799), // Rule ID 3280 //
     /* 1602718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1602729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1602732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1602735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1602738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1602741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602764 */     // MIs[0] policy
     /* 1602764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602774 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1602777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602798 */     // GIR_Coverage, 3280,
     /* 1602798 */     GIR_EraseRootFromParent_Done,
     /* 1602799 */   // Label 22157: @1602799
     /* 1602799 */   GIM_Try, /*On fail goto*//*Label 22158*/ GIMT_Encode4(1602885), // Rule ID 3281 //
     /* 1602804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1602815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1602818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1602821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1602824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1602827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1602834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1602846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602850 */     // MIs[0] policy
     /* 1602850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602860 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1602863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602884 */     // GIR_Coverage, 3281,
     /* 1602884 */     GIR_EraseRootFromParent_Done,
     /* 1602885 */   // Label 22158: @1602885
     /* 1602885 */   GIM_Try, /*On fail goto*//*Label 22159*/ GIMT_Encode4(1602971), // Rule ID 3284 //
     /* 1602890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1602901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1602904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1602907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1602910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1602913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1602920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1602932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602936 */     // MIs[0] policy
     /* 1602936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602946 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1602949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602970 */     // GIR_Coverage, 3284,
     /* 1602970 */     GIR_EraseRootFromParent_Done,
     /* 1602971 */   // Label 22159: @1602971
     /* 1602971 */   GIM_Try, /*On fail goto*//*Label 22160*/ GIMT_Encode4(1603057), // Rule ID 3285 //
     /* 1602976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1602984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1602987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1602990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1602993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1602996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1602999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603022 */     // MIs[0] policy
     /* 1603022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603032 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603056 */     // GIR_Coverage, 3285,
     /* 1603056 */     GIR_EraseRootFromParent_Done,
     /* 1603057 */   // Label 22160: @1603057
     /* 1603057 */   GIM_Try, /*On fail goto*//*Label 22161*/ GIMT_Encode4(1603143), // Rule ID 3288 //
     /* 1603062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1603082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603108 */     // MIs[0] policy
     /* 1603108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603142 */     // GIR_Coverage, 3288,
     /* 1603142 */     GIR_EraseRootFromParent_Done,
     /* 1603143 */   // Label 22161: @1603143
     /* 1603143 */   GIM_Try, /*On fail goto*//*Label 22162*/ GIMT_Encode4(1603229), // Rule ID 3289 //
     /* 1603148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1603159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1603162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1603165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1603168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603194 */     // MIs[0] policy
     /* 1603194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603204 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603228 */     // GIR_Coverage, 3289,
     /* 1603228 */     GIR_EraseRootFromParent_Done,
     /* 1603229 */   // Label 22162: @1603229
     /* 1603229 */   GIM_Try, /*On fail goto*//*Label 22163*/ GIMT_Encode4(1603315), // Rule ID 3292 //
     /* 1603234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1603254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603280 */     // MIs[0] policy
     /* 1603280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603290 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603314 */     // GIR_Coverage, 3292,
     /* 1603314 */     GIR_EraseRootFromParent_Done,
     /* 1603315 */   // Label 22163: @1603315
     /* 1603315 */   GIM_Try, /*On fail goto*//*Label 22164*/ GIMT_Encode4(1603401), // Rule ID 3293 //
     /* 1603320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1603331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1603334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1603337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1603340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603366 */     // MIs[0] policy
     /* 1603366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603376 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603400 */     // GIR_Coverage, 3293,
     /* 1603400 */     GIR_EraseRootFromParent_Done,
     /* 1603401 */   // Label 22164: @1603401
     /* 1603401 */   GIM_Try, /*On fail goto*//*Label 22165*/ GIMT_Encode4(1603487), // Rule ID 3296 //
     /* 1603406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1603426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603452 */     // MIs[0] policy
     /* 1603452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603462 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603486 */     // GIR_Coverage, 3296,
     /* 1603486 */     GIR_EraseRootFromParent_Done,
     /* 1603487 */   // Label 22165: @1603487
     /* 1603487 */   GIM_Try, /*On fail goto*//*Label 22166*/ GIMT_Encode4(1603573), // Rule ID 3297 //
     /* 1603492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1603503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1603506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1603509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1603512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603538 */     // MIs[0] policy
     /* 1603538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603548 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603572 */     // GIR_Coverage, 3297,
     /* 1603572 */     GIR_EraseRootFromParent_Done,
     /* 1603573 */   // Label 22166: @1603573
     /* 1603573 */   GIM_Try, /*On fail goto*//*Label 22167*/ GIMT_Encode4(1603659), // Rule ID 3300 //
     /* 1603578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1603589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1603592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1603595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1603598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603624 */     // MIs[0] policy
     /* 1603624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603658 */     // GIR_Coverage, 3300,
     /* 1603658 */     GIR_EraseRootFromParent_Done,
     /* 1603659 */   // Label 22167: @1603659
     /* 1603659 */   GIM_Try, /*On fail goto*//*Label 22168*/ GIMT_Encode4(1603745), // Rule ID 3301 //
     /* 1603664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1603675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1603678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1603681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1603684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603710 */     // MIs[0] policy
     /* 1603710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603720 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1603723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603744 */     // GIR_Coverage, 3301,
     /* 1603744 */     GIR_EraseRootFromParent_Done,
     /* 1603745 */   // Label 22168: @1603745
     /* 1603745 */   GIM_Try, /*On fail goto*//*Label 22169*/ GIMT_Encode4(1603831), // Rule ID 3304 //
     /* 1603750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1603761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1603764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1603767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1603770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603796 */     // MIs[0] policy
     /* 1603796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603806 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603830 */     // GIR_Coverage, 3304,
     /* 1603830 */     GIR_EraseRootFromParent_Done,
     /* 1603831 */   // Label 22169: @1603831
     /* 1603831 */   GIM_Try, /*On fail goto*//*Label 22170*/ GIMT_Encode4(1603917), // Rule ID 3305 //
     /* 1603836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1603847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1603850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1603853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1603856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1603859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603882 */     // MIs[0] policy
     /* 1603882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1603895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603916 */     // GIR_Coverage, 3305,
     /* 1603916 */     GIR_EraseRootFromParent_Done,
     /* 1603917 */   // Label 22170: @1603917
     /* 1603917 */   GIM_Try, /*On fail goto*//*Label 22171*/ GIMT_Encode4(1604003), // Rule ID 3308 //
     /* 1603922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1603930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1603933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1603936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1603939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1603942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603968 */     // MIs[0] policy
     /* 1603968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1603981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604002 */     // GIR_Coverage, 3308,
     /* 1604002 */     GIR_EraseRootFromParent_Done,
     /* 1604003 */   // Label 22171: @1604003
     /* 1604003 */   GIM_Try, /*On fail goto*//*Label 22172*/ GIMT_Encode4(1604089), // Rule ID 3309 //
     /* 1604008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1604019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1604022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1604025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1604028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604054 */     // MIs[0] policy
     /* 1604054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604064 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604088 */     // GIR_Coverage, 3309,
     /* 1604088 */     GIR_EraseRootFromParent_Done,
     /* 1604089 */   // Label 22172: @1604089
     /* 1604089 */   GIM_Try, /*On fail goto*//*Label 22173*/ GIMT_Encode4(1604175), // Rule ID 3312 //
     /* 1604094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1604114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604140 */     // MIs[0] policy
     /* 1604140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604150 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604174 */     // GIR_Coverage, 3312,
     /* 1604174 */     GIR_EraseRootFromParent_Done,
     /* 1604175 */   // Label 22173: @1604175
     /* 1604175 */   GIM_Try, /*On fail goto*//*Label 22174*/ GIMT_Encode4(1604261), // Rule ID 3313 //
     /* 1604180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1604191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1604194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1604197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1604200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604226 */     // MIs[0] policy
     /* 1604226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604236 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1604239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604260 */     // GIR_Coverage, 3313,
     /* 1604260 */     GIR_EraseRootFromParent_Done,
     /* 1604261 */   // Label 22174: @1604261
     /* 1604261 */   GIM_Try, /*On fail goto*//*Label 22175*/ GIMT_Encode4(1604347), // Rule ID 3316 //
     /* 1604266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1604286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604312 */     // MIs[0] policy
     /* 1604312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604322 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604346 */     // GIR_Coverage, 3316,
     /* 1604346 */     GIR_EraseRootFromParent_Done,
     /* 1604347 */   // Label 22175: @1604347
     /* 1604347 */   GIM_Try, /*On fail goto*//*Label 22176*/ GIMT_Encode4(1604433), // Rule ID 3317 //
     /* 1604352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1604363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1604366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1604369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1604372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604398 */     // MIs[0] policy
     /* 1604398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604408 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1604411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604432 */     // GIR_Coverage, 3317,
     /* 1604432 */     GIR_EraseRootFromParent_Done,
     /* 1604433 */   // Label 22176: @1604433
     /* 1604433 */   GIM_Try, /*On fail goto*//*Label 22177*/ GIMT_Encode4(1604519), // Rule ID 3320 //
     /* 1604438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1604441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1604449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1604452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1604455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1604458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604484 */     // MIs[0] policy
     /* 1604484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604518 */     // GIR_Coverage, 3320,
     /* 1604518 */     GIR_EraseRootFromParent_Done,
     /* 1604519 */   // Label 22177: @1604519
     /* 1604519 */   GIM_Try, /*On fail goto*//*Label 22178*/ GIMT_Encode4(1604605), // Rule ID 3321 //
     /* 1604524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1604527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1604535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1604538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1604541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1604544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604570 */     // MIs[0] policy
     /* 1604570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604580 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1604583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1604601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604604 */     // GIR_Coverage, 3321,
     /* 1604604 */     GIR_EraseRootFromParent_Done,
     /* 1604605 */   // Label 22178: @1604605
     /* 1604605 */   GIM_Try, /*On fail goto*//*Label 22179*/ GIMT_Encode4(1604691), // Rule ID 3324 //
     /* 1604610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1604621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1604624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1604627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1604633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604656 */     // MIs[0] policy
     /* 1604656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604666 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1604669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604690 */     // GIR_Coverage, 3324,
     /* 1604690 */     GIR_EraseRootFromParent_Done,
     /* 1604691 */   // Label 22179: @1604691
     /* 1604691 */   GIM_Try, /*On fail goto*//*Label 22180*/ GIMT_Encode4(1604777), // Rule ID 3325 //
     /* 1604696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1604707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1604710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1604713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1604719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604742 */     // MIs[0] policy
     /* 1604742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604752 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1604755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604776 */     // GIR_Coverage, 3325,
     /* 1604776 */     GIR_EraseRootFromParent_Done,
     /* 1604777 */   // Label 22180: @1604777
     /* 1604777 */   GIM_Try, /*On fail goto*//*Label 22181*/ GIMT_Encode4(1604863), // Rule ID 3328 //
     /* 1604782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1604793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1604796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1604799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604828 */     // MIs[0] policy
     /* 1604828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1604841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604862 */     // GIR_Coverage, 3328,
     /* 1604862 */     GIR_EraseRootFromParent_Done,
     /* 1604863 */   // Label 22181: @1604863
     /* 1604863 */   GIM_Try, /*On fail goto*//*Label 22182*/ GIMT_Encode4(1604949), // Rule ID 3329 //
     /* 1604868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1604879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1604882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1604885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1604891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604914 */     // MIs[0] policy
     /* 1604914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604924 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1604927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604948 */     // GIR_Coverage, 3329,
     /* 1604948 */     GIR_EraseRootFromParent_Done,
     /* 1604949 */   // Label 22182: @1604949
     /* 1604949 */   GIM_Try, /*On fail goto*//*Label 22183*/ GIMT_Encode4(1605035), // Rule ID 3332 //
     /* 1604954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1604962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1604965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1604968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1604971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1604984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1604992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605000 */     // MIs[0] policy
     /* 1605000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605010 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605034 */     // GIR_Coverage, 3332,
     /* 1605034 */     GIR_EraseRootFromParent_Done,
     /* 1605035 */   // Label 22183: @1605035
     /* 1605035 */   GIM_Try, /*On fail goto*//*Label 22184*/ GIMT_Encode4(1605121), // Rule ID 3333 //
     /* 1605040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1605051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1605054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1605057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605086 */     // MIs[0] policy
     /* 1605086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605120 */     // GIR_Coverage, 3333,
     /* 1605120 */     GIR_EraseRootFromParent_Done,
     /* 1605121 */   // Label 22184: @1605121
     /* 1605121 */   GIM_Try, /*On fail goto*//*Label 22185*/ GIMT_Encode4(1605207), // Rule ID 3336 //
     /* 1605126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605172 */     // MIs[0] policy
     /* 1605172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605206 */     // GIR_Coverage, 3336,
     /* 1605206 */     GIR_EraseRootFromParent_Done,
     /* 1605207 */   // Label 22185: @1605207
     /* 1605207 */   GIM_Try, /*On fail goto*//*Label 22186*/ GIMT_Encode4(1605293), // Rule ID 3337 //
     /* 1605212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1605229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605258 */     // MIs[0] policy
     /* 1605258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1605271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605292 */     // GIR_Coverage, 3337,
     /* 1605292 */     GIR_EraseRootFromParent_Done,
     /* 1605293 */   // Label 22186: @1605293
     /* 1605293 */   GIM_Try, /*On fail goto*//*Label 22187*/ GIMT_Encode4(1605379), // Rule ID 3340 //
     /* 1605298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605344 */     // MIs[0] policy
     /* 1605344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605354 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605378 */     // GIR_Coverage, 3340,
     /* 1605378 */     GIR_EraseRootFromParent_Done,
     /* 1605379 */   // Label 22187: @1605379
     /* 1605379 */   GIM_Try, /*On fail goto*//*Label 22188*/ GIMT_Encode4(1605465), // Rule ID 3341 //
     /* 1605384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1605401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605430 */     // MIs[0] policy
     /* 1605430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605464 */     // GIR_Coverage, 3341,
     /* 1605464 */     GIR_EraseRootFromParent_Done,
     /* 1605465 */   // Label 22188: @1605465
     /* 1605465 */   GIM_Try, /*On fail goto*//*Label 22189*/ GIMT_Encode4(1605551), // Rule ID 3344 //
     /* 1605470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1605487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605516 */     // MIs[0] policy
     /* 1605516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605526 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605550 */     // GIR_Coverage, 3344,
     /* 1605550 */     GIR_EraseRootFromParent_Done,
     /* 1605551 */   // Label 22189: @1605551
     /* 1605551 */   GIM_Try, /*On fail goto*//*Label 22190*/ GIMT_Encode4(1605637), // Rule ID 3345 //
     /* 1605556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1605567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1605570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1605573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605602 */     // MIs[0] policy
     /* 1605602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605612 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1605615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605636 */     // GIR_Coverage, 3345,
     /* 1605636 */     GIR_EraseRootFromParent_Done,
     /* 1605637 */   // Label 22190: @1605637
     /* 1605637 */   GIM_Try, /*On fail goto*//*Label 22191*/ GIMT_Encode4(1605723), // Rule ID 3348 //
     /* 1605642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1605653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1605656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1605659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605688 */     // MIs[0] policy
     /* 1605688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605698 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1605701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605722 */     // GIR_Coverage, 3348,
     /* 1605722 */     GIR_EraseRootFromParent_Done,
     /* 1605723 */   // Label 22191: @1605723
     /* 1605723 */   GIM_Try, /*On fail goto*//*Label 22192*/ GIMT_Encode4(1605809), // Rule ID 3349 //
     /* 1605728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1605739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1605742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1605745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605774 */     // MIs[0] policy
     /* 1605774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605784 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11622:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1605787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605808 */     // GIR_Coverage, 3349,
     /* 1605808 */     GIR_EraseRootFromParent_Done,
     /* 1605809 */   // Label 22192: @1605809
     /* 1605809 */   GIM_Try, /*On fail goto*//*Label 22193*/ GIMT_Encode4(1605895), // Rule ID 3352 //
     /* 1605814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1605825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1605828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1605831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605860 */     // MIs[0] policy
     /* 1605860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1605873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605894 */     // GIR_Coverage, 3352,
     /* 1605894 */     GIR_EraseRootFromParent_Done,
     /* 1605895 */   // Label 22193: @1605895
     /* 1605895 */   GIM_Try, /*On fail goto*//*Label 22194*/ GIMT_Encode4(1605981), // Rule ID 3353 //
     /* 1605900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1605911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1605914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1605917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605946 */     // MIs[0] policy
     /* 1605946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605956 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11622:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1605959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1605977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605980 */     // GIR_Coverage, 3353,
     /* 1605980 */     GIR_EraseRootFromParent_Done,
     /* 1605981 */   // Label 22194: @1605981
     /* 1605981 */   GIM_Try, /*On fail goto*//*Label 22195*/ GIMT_Encode4(1606067), // Rule ID 3356 //
     /* 1605986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1605994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1605997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606032 */     // MIs[0] policy
     /* 1606032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606066 */     // GIR_Coverage, 3356,
     /* 1606066 */     GIR_EraseRootFromParent_Done,
     /* 1606067 */   // Label 22195: @1606067
     /* 1606067 */   GIM_Try, /*On fail goto*//*Label 22196*/ GIMT_Encode4(1606153), // Rule ID 3357 //
     /* 1606072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1606089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606118 */     // MIs[0] policy
     /* 1606118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606128 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11622:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1606149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606152 */     // GIR_Coverage, 3357,
     /* 1606152 */     GIR_EraseRootFromParent_Done,
     /* 1606153 */   // Label 22196: @1606153
     /* 1606153 */   GIM_Try, /*On fail goto*//*Label 22197*/ GIMT_Encode4(1606239), // Rule ID 3360 //
     /* 1606158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1606161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606204 */     // MIs[0] policy
     /* 1606204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606238 */     // GIR_Coverage, 3360,
     /* 1606238 */     GIR_EraseRootFromParent_Done,
     /* 1606239 */   // Label 22197: @1606239
     /* 1606239 */   GIM_Try, /*On fail goto*//*Label 22198*/ GIMT_Encode4(1606325), // Rule ID 3361 //
     /* 1606244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1606247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1606255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1606258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1606261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606290 */     // MIs[0] policy
     /* 1606290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11622:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1606303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1606321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606324 */     // GIR_Coverage, 3361,
     /* 1606324 */     GIR_EraseRootFromParent_Done,
     /* 1606325 */   // Label 22198: @1606325
     /* 1606325 */   GIM_Try, /*On fail goto*//*Label 22199*/ GIMT_Encode4(1606411), // Rule ID 3364 //
     /* 1606330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606376 */     // MIs[0] policy
     /* 1606376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606386 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606410 */     // GIR_Coverage, 3364,
     /* 1606410 */     GIR_EraseRootFromParent_Done,
     /* 1606411 */   // Label 22199: @1606411
     /* 1606411 */   GIM_Try, /*On fail goto*//*Label 22200*/ GIMT_Encode4(1606497), // Rule ID 3365 //
     /* 1606416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1606427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1606430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606462 */     // MIs[0] policy
     /* 1606462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606472 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606496 */     // GIR_Coverage, 3365,
     /* 1606496 */     GIR_EraseRootFromParent_Done,
     /* 1606497 */   // Label 22200: @1606497
     /* 1606497 */   GIM_Try, /*On fail goto*//*Label 22201*/ GIMT_Encode4(1606583), // Rule ID 3368 //
     /* 1606502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606548 */     // MIs[0] policy
     /* 1606548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606558 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1606561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606582 */     // GIR_Coverage, 3368,
     /* 1606582 */     GIR_EraseRootFromParent_Done,
     /* 1606583 */   // Label 22201: @1606583
     /* 1606583 */   GIM_Try, /*On fail goto*//*Label 22202*/ GIMT_Encode4(1606669), // Rule ID 3369 //
     /* 1606588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1606599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1606602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606634 */     // MIs[0] policy
     /* 1606634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606644 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1606647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606668 */     // GIR_Coverage, 3369,
     /* 1606668 */     GIR_EraseRootFromParent_Done,
     /* 1606669 */   // Label 22202: @1606669
     /* 1606669 */   GIM_Try, /*On fail goto*//*Label 22203*/ GIMT_Encode4(1606755), // Rule ID 3372 //
     /* 1606674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1606685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1606688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1606691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1606697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606720 */     // MIs[0] policy
     /* 1606720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606730 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1606733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606754 */     // GIR_Coverage, 3372,
     /* 1606754 */     GIR_EraseRootFromParent_Done,
     /* 1606755 */   // Label 22203: @1606755
     /* 1606755 */   GIM_Try, /*On fail goto*//*Label 22204*/ GIMT_Encode4(1606841), // Rule ID 3373 //
     /* 1606760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1606771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1606774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1606777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1606783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606806 */     // MIs[0] policy
     /* 1606806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606816 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1606819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606840 */     // GIR_Coverage, 3373,
     /* 1606840 */     GIR_EraseRootFromParent_Done,
     /* 1606841 */   // Label 22204: @1606841
     /* 1606841 */   GIM_Try, /*On fail goto*//*Label 22205*/ GIMT_Encode4(1606927), // Rule ID 3376 //
     /* 1606846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1606857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1606860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1606863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1606866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606892 */     // MIs[0] policy
     /* 1606892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606926 */     // GIR_Coverage, 3376,
     /* 1606926 */     GIR_EraseRootFromParent_Done,
     /* 1606927 */   // Label 22205: @1606927
     /* 1606927 */   GIM_Try, /*On fail goto*//*Label 22206*/ GIMT_Encode4(1607013), // Rule ID 3377 //
     /* 1606932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1606940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1606943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1606946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1606949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1606952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1606974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606978 */     // MIs[0] policy
     /* 1606978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606988 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1606991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607012 */     // GIR_Coverage, 3377,
     /* 1607012 */     GIR_EraseRootFromParent_Done,
     /* 1607013 */   // Label 22206: @1607013
     /* 1607013 */   GIM_Try, /*On fail goto*//*Label 22207*/ GIMT_Encode4(1607099), // Rule ID 3380 //
     /* 1607018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607064 */     // MIs[0] policy
     /* 1607064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607098 */     // GIR_Coverage, 3380,
     /* 1607098 */     GIR_EraseRootFromParent_Done,
     /* 1607099 */   // Label 22207: @1607099
     /* 1607099 */   GIM_Try, /*On fail goto*//*Label 22208*/ GIMT_Encode4(1607185), // Rule ID 3381 //
     /* 1607104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1607115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1607118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607150 */     // MIs[0] policy
     /* 1607150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607160 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607184 */     // GIR_Coverage, 3381,
     /* 1607184 */     GIR_EraseRootFromParent_Done,
     /* 1607185 */   // Label 22208: @1607185
     /* 1607185 */   GIM_Try, /*On fail goto*//*Label 22209*/ GIMT_Encode4(1607271), // Rule ID 3384 //
     /* 1607190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607236 */     // MIs[0] policy
     /* 1607236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607270 */     // GIR_Coverage, 3384,
     /* 1607270 */     GIR_EraseRootFromParent_Done,
     /* 1607271 */   // Label 22209: @1607271
     /* 1607271 */   GIM_Try, /*On fail goto*//*Label 22210*/ GIMT_Encode4(1607357), // Rule ID 3385 //
     /* 1607276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1607287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1607290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1607293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1607299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607322 */     // MIs[0] policy
     /* 1607322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607332 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607356 */     // GIR_Coverage, 3385,
     /* 1607356 */     GIR_EraseRootFromParent_Done,
     /* 1607357 */   // Label 22210: @1607357
     /* 1607357 */   GIM_Try, /*On fail goto*//*Label 22211*/ GIMT_Encode4(1607443), // Rule ID 3388 //
     /* 1607362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607408 */     // MIs[0] policy
     /* 1607408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607442 */     // GIR_Coverage, 3388,
     /* 1607442 */     GIR_EraseRootFromParent_Done,
     /* 1607443 */   // Label 22211: @1607443
     /* 1607443 */   GIM_Try, /*On fail goto*//*Label 22212*/ GIMT_Encode4(1607529), // Rule ID 3389 //
     /* 1607448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607494 */     // MIs[0] policy
     /* 1607494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607528 */     // GIR_Coverage, 3389,
     /* 1607528 */     GIR_EraseRootFromParent_Done,
     /* 1607529 */   // Label 22212: @1607529
     /* 1607529 */   GIM_Try, /*On fail goto*//*Label 22213*/ GIMT_Encode4(1607615), // Rule ID 3392 //
     /* 1607534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1607545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1607548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1607551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607580 */     // MIs[0] policy
     /* 1607580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607590 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607614 */     // GIR_Coverage, 3392,
     /* 1607614 */     GIR_EraseRootFromParent_Done,
     /* 1607615 */   // Label 22213: @1607615
     /* 1607615 */   GIM_Try, /*On fail goto*//*Label 22214*/ GIMT_Encode4(1607701), // Rule ID 3393 //
     /* 1607620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1607631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1607634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1607637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607666 */     // MIs[0] policy
     /* 1607666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1607679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607700 */     // GIR_Coverage, 3393,
     /* 1607700 */     GIR_EraseRootFromParent_Done,
     /* 1607701 */   // Label 22214: @1607701
     /* 1607701 */   GIM_Try, /*On fail goto*//*Label 22215*/ GIMT_Encode4(1607787), // Rule ID 3396 //
     /* 1607706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1607717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1607720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1607723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607752 */     // MIs[0] policy
     /* 1607752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607762 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607786 */     // GIR_Coverage, 3396,
     /* 1607786 */     GIR_EraseRootFromParent_Done,
     /* 1607787 */   // Label 22215: @1607787
     /* 1607787 */   GIM_Try, /*On fail goto*//*Label 22216*/ GIMT_Encode4(1607873), // Rule ID 3397 //
     /* 1607792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1607803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1607806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1607809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607838 */     // MIs[0] policy
     /* 1607838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607848 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1607851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607872 */     // GIR_Coverage, 3397,
     /* 1607872 */     GIR_EraseRootFromParent_Done,
     /* 1607873 */   // Label 22216: @1607873
     /* 1607873 */   GIM_Try, /*On fail goto*//*Label 22217*/ GIMT_Encode4(1607959), // Rule ID 3400 //
     /* 1607878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1607881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1607889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1607892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1607895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1607898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1607920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607924 */     // MIs[0] policy
     /* 1607924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1607937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1607955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607958 */     // GIR_Coverage, 3400,
     /* 1607958 */     GIR_EraseRootFromParent_Done,
     /* 1607959 */   // Label 22217: @1607959
     /* 1607959 */   GIM_Try, /*On fail goto*//*Label 22218*/ GIMT_Encode4(1608045), // Rule ID 3401 //
     /* 1607964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1607967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1607972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1607975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1607978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1607981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1607984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608010 */     // MIs[0] policy
     /* 1608010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608020 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11622:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1608023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608044 */     // GIR_Coverage, 3401,
     /* 1608044 */     GIR_EraseRootFromParent_Done,
     /* 1608045 */   // Label 22218: @1608045
     /* 1608045 */   GIM_Try, /*On fail goto*//*Label 22219*/ GIMT_Encode4(1608131), // Rule ID 3404 //
     /* 1608050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608096 */     // MIs[0] policy
     /* 1608096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608106 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608130 */     // GIR_Coverage, 3404,
     /* 1608130 */     GIR_EraseRootFromParent_Done,
     /* 1608131 */   // Label 22219: @1608131
     /* 1608131 */   GIM_Try, /*On fail goto*//*Label 22220*/ GIMT_Encode4(1608217), // Rule ID 3405 //
     /* 1608136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1608147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1608150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1608153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608182 */     // MIs[0] policy
     /* 1608182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608192 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11622:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1608195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608216 */     // GIR_Coverage, 3405,
     /* 1608216 */     GIR_EraseRootFromParent_Done,
     /* 1608217 */   // Label 22220: @1608217
     /* 1608217 */   GIM_Try, /*On fail goto*//*Label 22221*/ GIMT_Encode4(1608303), // Rule ID 3408 //
     /* 1608222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1608225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608268 */     // MIs[0] policy
     /* 1608268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608278 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608302 */     // GIR_Coverage, 3408,
     /* 1608302 */     GIR_EraseRootFromParent_Done,
     /* 1608303 */   // Label 22221: @1608303
     /* 1608303 */   GIM_Try, /*On fail goto*//*Label 22222*/ GIMT_Encode4(1608389), // Rule ID 3409 //
     /* 1608308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1608311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1608316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1608325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608354 */     // MIs[0] policy
     /* 1608354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608364 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11622:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1608367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1608385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608388 */     // GIR_Coverage, 3409,
     /* 1608388 */     GIR_EraseRootFromParent_Done,
     /* 1608389 */   // Label 22222: @1608389
     /* 1608389 */   GIM_Try, /*On fail goto*//*Label 22223*/ GIMT_Encode4(1608475), // Rule ID 3412 //
     /* 1608394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608440 */     // MIs[0] policy
     /* 1608440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608450 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1608453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608474 */     // GIR_Coverage, 3412,
     /* 1608474 */     GIR_EraseRootFromParent_Done,
     /* 1608475 */   // Label 22223: @1608475
     /* 1608475 */   GIM_Try, /*On fail goto*//*Label 22224*/ GIMT_Encode4(1608561), // Rule ID 3413 //
     /* 1608480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1608491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1608494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608526 */     // MIs[0] policy
     /* 1608526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608536 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1608539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608560 */     // GIR_Coverage, 3413,
     /* 1608560 */     GIR_EraseRootFromParent_Done,
     /* 1608561 */   // Label 22224: @1608561
     /* 1608561 */   GIM_Try, /*On fail goto*//*Label 22225*/ GIMT_Encode4(1608647), // Rule ID 3416 //
     /* 1608566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1608577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1608580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608612 */     // MIs[0] policy
     /* 1608612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1608625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608646 */     // GIR_Coverage, 3416,
     /* 1608646 */     GIR_EraseRootFromParent_Done,
     /* 1608647 */   // Label 22225: @1608647
     /* 1608647 */   GIM_Try, /*On fail goto*//*Label 22226*/ GIMT_Encode4(1608733), // Rule ID 3417 //
     /* 1608652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1608663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1608666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608698 */     // MIs[0] policy
     /* 1608698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608708 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1608711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608732 */     // GIR_Coverage, 3417,
     /* 1608732 */     GIR_EraseRootFromParent_Done,
     /* 1608733 */   // Label 22226: @1608733
     /* 1608733 */   GIM_Try, /*On fail goto*//*Label 22227*/ GIMT_Encode4(1608819), // Rule ID 3420 //
     /* 1608738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1608749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1608752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608784 */     // MIs[0] policy
     /* 1608784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608794 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1608797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608818 */     // GIR_Coverage, 3420,
     /* 1608818 */     GIR_EraseRootFromParent_Done,
     /* 1608819 */   // Label 22227: @1608819
     /* 1608819 */   GIM_Try, /*On fail goto*//*Label 22228*/ GIMT_Encode4(1608905), // Rule ID 3421 //
     /* 1608824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1608835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1608838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608870 */     // MIs[0] policy
     /* 1608870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608880 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1608883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608904 */     // GIR_Coverage, 3421,
     /* 1608904 */     GIR_EraseRootFromParent_Done,
     /* 1608905 */   // Label 22228: @1608905
     /* 1608905 */   GIM_Try, /*On fail goto*//*Label 22229*/ GIMT_Encode4(1608991), // Rule ID 3424 //
     /* 1608910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1608918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1608921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1608924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1608927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608956 */     // MIs[0] policy
     /* 1608956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608966 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1608969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1608987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608990 */     // GIR_Coverage, 3424,
     /* 1608990 */     GIR_EraseRootFromParent_Done,
     /* 1608991 */   // Label 22229: @1608991
     /* 1608991 */   GIM_Try, /*On fail goto*//*Label 22230*/ GIMT_Encode4(1609077), // Rule ID 3425 //
     /* 1608996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1609007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1609010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609042 */     // MIs[0] policy
     /* 1609042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609052 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1609055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609076 */     // GIR_Coverage, 3425,
     /* 1609076 */     GIR_EraseRootFromParent_Done,
     /* 1609077 */   // Label 22230: @1609077
     /* 1609077 */   GIM_Try, /*On fail goto*//*Label 22231*/ GIMT_Encode4(1609163), // Rule ID 3428 //
     /* 1609082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609128 */     // MIs[0] policy
     /* 1609128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609138 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609162 */     // GIR_Coverage, 3428,
     /* 1609162 */     GIR_EraseRootFromParent_Done,
     /* 1609163 */   // Label 22231: @1609163
     /* 1609163 */   GIM_Try, /*On fail goto*//*Label 22232*/ GIMT_Encode4(1609249), // Rule ID 3429 //
     /* 1609168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1609179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1609182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609214 */     // MIs[0] policy
     /* 1609214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609224 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609248 */     // GIR_Coverage, 3429,
     /* 1609248 */     GIR_EraseRootFromParent_Done,
     /* 1609249 */   // Label 22232: @1609249
     /* 1609249 */   GIM_Try, /*On fail goto*//*Label 22233*/ GIMT_Encode4(1609335), // Rule ID 3432 //
     /* 1609254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609300 */     // MIs[0] policy
     /* 1609300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609310 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609334 */     // GIR_Coverage, 3432,
     /* 1609334 */     GIR_EraseRootFromParent_Done,
     /* 1609335 */   // Label 22233: @1609335
     /* 1609335 */   GIM_Try, /*On fail goto*//*Label 22234*/ GIMT_Encode4(1609421), // Rule ID 3433 //
     /* 1609340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1609357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609386 */     // MIs[0] policy
     /* 1609386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1609399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609420 */     // GIR_Coverage, 3433,
     /* 1609420 */     GIR_EraseRootFromParent_Done,
     /* 1609421 */   // Label 22234: @1609421
     /* 1609421 */   GIM_Try, /*On fail goto*//*Label 22235*/ GIMT_Encode4(1609507), // Rule ID 3436 //
     /* 1609426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609472 */     // MIs[0] policy
     /* 1609472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609482 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609506 */     // GIR_Coverage, 3436,
     /* 1609506 */     GIR_EraseRootFromParent_Done,
     /* 1609507 */   // Label 22235: @1609507
     /* 1609507 */   GIM_Try, /*On fail goto*//*Label 22236*/ GIMT_Encode4(1609593), // Rule ID 3437 //
     /* 1609512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1609523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1609526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1609529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609558 */     // MIs[0] policy
     /* 1609558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609568 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609592 */     // GIR_Coverage, 3437,
     /* 1609592 */     GIR_EraseRootFromParent_Done,
     /* 1609593 */   // Label 22236: @1609593
     /* 1609593 */   GIM_Try, /*On fail goto*//*Label 22237*/ GIMT_Encode4(1609679), // Rule ID 3440 //
     /* 1609598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1609609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1609612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609644 */     // MIs[0] policy
     /* 1609644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609654 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609678 */     // GIR_Coverage, 3440,
     /* 1609678 */     GIR_EraseRootFromParent_Done,
     /* 1609679 */   // Label 22237: @1609679
     /* 1609679 */   GIM_Try, /*On fail goto*//*Label 22238*/ GIMT_Encode4(1609765), // Rule ID 3441 //
     /* 1609684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1609695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1609698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609730 */     // MIs[0] policy
     /* 1609730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609764 */     // GIR_Coverage, 3441,
     /* 1609764 */     GIR_EraseRootFromParent_Done,
     /* 1609765 */   // Label 22238: @1609765
     /* 1609765 */   GIM_Try, /*On fail goto*//*Label 22239*/ GIMT_Encode4(1609851), // Rule ID 3444 //
     /* 1609770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1609781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1609784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1609787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609816 */     // MIs[0] policy
     /* 1609816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609850 */     // GIR_Coverage, 3444,
     /* 1609850 */     GIR_EraseRootFromParent_Done,
     /* 1609851 */   // Label 22239: @1609851
     /* 1609851 */   GIM_Try, /*On fail goto*//*Label 22240*/ GIMT_Encode4(1609937), // Rule ID 3445 //
     /* 1609856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1609867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1609870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1609873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609902 */     // MIs[0] policy
     /* 1609902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1609915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1609933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609936 */     // GIR_Coverage, 3445,
     /* 1609936 */     GIR_EraseRootFromParent_Done,
     /* 1609937 */   // Label 22240: @1609937
     /* 1609937 */   GIM_Try, /*On fail goto*//*Label 22241*/ GIMT_Encode4(1610023), // Rule ID 3448 //
     /* 1609942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1609945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1609950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1609953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1609956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1609959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609988 */     // MIs[0] policy
     /* 1609988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609998 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610022 */     // GIR_Coverage, 3448,
     /* 1610022 */     GIR_EraseRootFromParent_Done,
     /* 1610023 */   // Label 22241: @1610023
     /* 1610023 */   GIM_Try, /*On fail goto*//*Label 22242*/ GIMT_Encode4(1610109), // Rule ID 3449 //
     /* 1610028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1610031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1610045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610074 */     // MIs[0] policy
     /* 1610074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610084 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1610087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1610105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610108 */     // GIR_Coverage, 3449,
     /* 1610108 */     GIR_EraseRootFromParent_Done,
     /* 1610109 */   // Label 22242: @1610109
     /* 1610109 */   GIM_Try, /*On fail goto*//*Label 22243*/ GIMT_Encode4(1610195), // Rule ID 3452 //
     /* 1610114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610160 */     // MIs[0] policy
     /* 1610160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610170 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610194 */     // GIR_Coverage, 3452,
     /* 1610194 */     GIR_EraseRootFromParent_Done,
     /* 1610195 */   // Label 22243: @1610195
     /* 1610195 */   GIM_Try, /*On fail goto*//*Label 22244*/ GIMT_Encode4(1610281), // Rule ID 3453 //
     /* 1610200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1610211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1610214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1610217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610246 */     // MIs[0] policy
     /* 1610246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610280 */     // GIR_Coverage, 3453,
     /* 1610280 */     GIR_EraseRootFromParent_Done,
     /* 1610281 */   // Label 22244: @1610281
     /* 1610281 */   GIM_Try, /*On fail goto*//*Label 22245*/ GIMT_Encode4(1610367), // Rule ID 3456 //
     /* 1610286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610332 */     // MIs[0] policy
     /* 1610332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610342 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610366 */     // GIR_Coverage, 3456,
     /* 1610366 */     GIR_EraseRootFromParent_Done,
     /* 1610367 */   // Label 22245: @1610367
     /* 1610367 */   GIM_Try, /*On fail goto*//*Label 22246*/ GIMT_Encode4(1610453), // Rule ID 3457 //
     /* 1610372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1610383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1610386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1610389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610418 */     // MIs[0] policy
     /* 1610418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610428 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610452 */     // GIR_Coverage, 3457,
     /* 1610452 */     GIR_EraseRootFromParent_Done,
     /* 1610453 */   // Label 22246: @1610453
     /* 1610453 */   GIM_Try, /*On fail goto*//*Label 22247*/ GIMT_Encode4(1610539), // Rule ID 3460 //
     /* 1610458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610504 */     // MIs[0] policy
     /* 1610504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1610517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610538 */     // GIR_Coverage, 3460,
     /* 1610538 */     GIR_EraseRootFromParent_Done,
     /* 1610539 */   // Label 22247: @1610539
     /* 1610539 */   GIM_Try, /*On fail goto*//*Label 22248*/ GIMT_Encode4(1610625), // Rule ID 3461 //
     /* 1610544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1610555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1610558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1610561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1610567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610590 */     // MIs[0] policy
     /* 1610590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1610603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610624 */     // GIR_Coverage, 3461,
     /* 1610624 */     GIR_EraseRootFromParent_Done,
     /* 1610625 */   // Label 22248: @1610625
     /* 1610625 */   GIM_Try, /*On fail goto*//*Label 22249*/ GIMT_Encode4(1610711), // Rule ID 3464 //
     /* 1610630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1610647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610676 */     // MIs[0] policy
     /* 1610676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610710 */     // GIR_Coverage, 3464,
     /* 1610710 */     GIR_EraseRootFromParent_Done,
     /* 1610711 */   // Label 22249: @1610711
     /* 1610711 */   GIM_Try, /*On fail goto*//*Label 22250*/ GIMT_Encode4(1610797), // Rule ID 3465 //
     /* 1610716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1610727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1610730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1610733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610762 */     // MIs[0] policy
     /* 1610762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1610775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610796 */     // GIR_Coverage, 3465,
     /* 1610796 */     GIR_EraseRootFromParent_Done,
     /* 1610797 */   // Label 22250: @1610797
     /* 1610797 */   GIM_Try, /*On fail goto*//*Label 22251*/ GIMT_Encode4(1610883), // Rule ID 3468 //
     /* 1610802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1610813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1610816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1610819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610848 */     // MIs[0] policy
     /* 1610848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610858 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610882 */     // GIR_Coverage, 3468,
     /* 1610882 */     GIR_EraseRootFromParent_Done,
     /* 1610883 */   // Label 22251: @1610883
     /* 1610883 */   GIM_Try, /*On fail goto*//*Label 22252*/ GIMT_Encode4(1610969), // Rule ID 3469 //
     /* 1610888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1610899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1610902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1610905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610934 */     // MIs[0] policy
     /* 1610934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1610947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610968 */     // GIR_Coverage, 3469,
     /* 1610968 */     GIR_EraseRootFromParent_Done,
     /* 1610969 */   // Label 22252: @1610969
     /* 1610969 */   GIM_Try, /*On fail goto*//*Label 22253*/ GIMT_Encode4(1611055), // Rule ID 3472 //
     /* 1610974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1610982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1610985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1610988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1610991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1610997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611020 */     // MIs[0] policy
     /* 1611020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611030 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611054 */     // GIR_Coverage, 3472,
     /* 1611054 */     GIR_EraseRootFromParent_Done,
     /* 1611055 */   // Label 22253: @1611055
     /* 1611055 */   GIM_Try, /*On fail goto*//*Label 22254*/ GIMT_Encode4(1611141), // Rule ID 3473 //
     /* 1611060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1611077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611106 */     // MIs[0] policy
     /* 1611106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611116 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611140 */     // GIR_Coverage, 3473,
     /* 1611140 */     GIR_EraseRootFromParent_Done,
     /* 1611141 */   // Label 22254: @1611141
     /* 1611141 */   GIM_Try, /*On fail goto*//*Label 22255*/ GIMT_Encode4(1611227), // Rule ID 3476 //
     /* 1611146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611192 */     // MIs[0] policy
     /* 1611192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611226 */     // GIR_Coverage, 3476,
     /* 1611226 */     GIR_EraseRootFromParent_Done,
     /* 1611227 */   // Label 22255: @1611227
     /* 1611227 */   GIM_Try, /*On fail goto*//*Label 22256*/ GIMT_Encode4(1611313), // Rule ID 3477 //
     /* 1611232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1611243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1611246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1611249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611278 */     // MIs[0] policy
     /* 1611278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611312 */     // GIR_Coverage, 3477,
     /* 1611312 */     GIR_EraseRootFromParent_Done,
     /* 1611313 */   // Label 22256: @1611313
     /* 1611313 */   GIM_Try, /*On fail goto*//*Label 22257*/ GIMT_Encode4(1611399), // Rule ID 3480 //
     /* 1611318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611364 */     // MIs[0] policy
     /* 1611364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611374 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611398 */     // GIR_Coverage, 3480,
     /* 1611398 */     GIR_EraseRootFromParent_Done,
     /* 1611399 */   // Label 22257: @1611399
     /* 1611399 */   GIM_Try, /*On fail goto*//*Label 22258*/ GIMT_Encode4(1611485), // Rule ID 3481 //
     /* 1611404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1611415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1611418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1611421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611450 */     // MIs[0] policy
     /* 1611450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611484 */     // GIR_Coverage, 3481,
     /* 1611484 */     GIR_EraseRootFromParent_Done,
     /* 1611485 */   // Label 22258: @1611485
     /* 1611485 */   GIM_Try, /*On fail goto*//*Label 22259*/ GIMT_Encode4(1611571), // Rule ID 3484 //
     /* 1611490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611536 */     // MIs[0] policy
     /* 1611536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611570 */     // GIR_Coverage, 3484,
     /* 1611570 */     GIR_EraseRootFromParent_Done,
     /* 1611571 */   // Label 22259: @1611571
     /* 1611571 */   GIM_Try, /*On fail goto*//*Label 22260*/ GIMT_Encode4(1611657), // Rule ID 3485 //
     /* 1611576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1611587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1611590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1611593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611622 */     // MIs[0] policy
     /* 1611622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1611635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1611653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611656 */     // GIR_Coverage, 3485,
     /* 1611656 */     GIR_EraseRootFromParent_Done,
     /* 1611657 */   // Label 22260: @1611657
     /* 1611657 */   GIM_Try, /*On fail goto*//*Label 22261*/ GIMT_Encode4(1611743), // Rule ID 3488 //
     /* 1611662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1611665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1611673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1611676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1611679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611708 */     // MIs[0] policy
     /* 1611708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611742 */     // GIR_Coverage, 3488,
     /* 1611742 */     GIR_EraseRootFromParent_Done,
     /* 1611743 */   // Label 22261: @1611743
     /* 1611743 */   GIM_Try, /*On fail goto*//*Label 22262*/ GIMT_Encode4(1611829), // Rule ID 3489 //
     /* 1611748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1611751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1611759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1611762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1611765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611794 */     // MIs[0] policy
     /* 1611794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611804 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1611807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611828 */     // GIR_Coverage, 3489,
     /* 1611828 */     GIR_EraseRootFromParent_Done,
     /* 1611829 */   // Label 22262: @1611829
     /* 1611829 */   GIM_Try, /*On fail goto*//*Label 22263*/ GIMT_Encode4(1611915), // Rule ID 3492 //
     /* 1611834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1611837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1611845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1611848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1611851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1611854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611880 */     // MIs[0] policy
     /* 1611880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611890 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611914 */     // GIR_Coverage, 3492,
     /* 1611914 */     GIR_EraseRootFromParent_Done,
     /* 1611915 */   // Label 22263: @1611915
     /* 1611915 */   GIM_Try, /*On fail goto*//*Label 22264*/ GIMT_Encode4(1612001), // Rule ID 3493 //
     /* 1611920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1611923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1611928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1611931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1611934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1611937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1611940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1611962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611966 */     // MIs[0] policy
     /* 1611966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611976 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1611979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1611997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612000 */     // GIR_Coverage, 3493,
     /* 1612000 */     GIR_EraseRootFromParent_Done,
     /* 1612001 */   // Label 22264: @1612001
     /* 1612001 */   GIM_Try, /*On fail goto*//*Label 22265*/ GIMT_Encode4(1612087), // Rule ID 3496 //
     /* 1612006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1612009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1612026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612052 */     // MIs[0] policy
     /* 1612052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612062 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612086 */     // GIR_Coverage, 3496,
     /* 1612086 */     GIR_EraseRootFromParent_Done,
     /* 1612087 */   // Label 22265: @1612087
     /* 1612087 */   GIM_Try, /*On fail goto*//*Label 22266*/ GIMT_Encode4(1612173), // Rule ID 3497 //
     /* 1612092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1612095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1612100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1612103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1612106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1612109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1612112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1612134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612138 */     // MIs[0] policy
     /* 1612138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612148 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1612151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1612169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612172 */     // GIR_Coverage, 3497,
     /* 1612172 */     GIR_EraseRootFromParent_Done,
     /* 1612173 */   // Label 22266: @1612173
     /* 1612173 */   GIM_Try, /*On fail goto*//*Label 22267*/ GIMT_Encode4(1612259), // Rule ID 3588 //
     /* 1612178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1612198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612224 */     // MIs[0] policy
     /* 1612224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612234 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1612237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612258 */     // GIR_Coverage, 3588,
     /* 1612258 */     GIR_EraseRootFromParent_Done,
     /* 1612259 */   // Label 22267: @1612259
     /* 1612259 */   GIM_Try, /*On fail goto*//*Label 22268*/ GIMT_Encode4(1612345), // Rule ID 3589 //
     /* 1612264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1612275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1612278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1612281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1612284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612310 */     // MIs[0] policy
     /* 1612310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612320 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1612323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612344 */     // GIR_Coverage, 3589,
     /* 1612344 */     GIR_EraseRootFromParent_Done,
     /* 1612345 */   // Label 22268: @1612345
     /* 1612345 */   GIM_Try, /*On fail goto*//*Label 22269*/ GIMT_Encode4(1612431), // Rule ID 3592 //
     /* 1612350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1612370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612396 */     // MIs[0] policy
     /* 1612396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612406 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1612409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612430 */     // GIR_Coverage, 3592,
     /* 1612430 */     GIR_EraseRootFromParent_Done,
     /* 1612431 */   // Label 22269: @1612431
     /* 1612431 */   GIM_Try, /*On fail goto*//*Label 22270*/ GIMT_Encode4(1612517), // Rule ID 3593 //
     /* 1612436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1612447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1612450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1612453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1612456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612482 */     // MIs[0] policy
     /* 1612482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612492 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1612495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612516 */     // GIR_Coverage, 3593,
     /* 1612516 */     GIR_EraseRootFromParent_Done,
     /* 1612517 */   // Label 22270: @1612517
     /* 1612517 */   GIM_Try, /*On fail goto*//*Label 22271*/ GIMT_Encode4(1612603), // Rule ID 3596 //
     /* 1612522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1612533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1612536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1612542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612568 */     // MIs[0] policy
     /* 1612568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612578 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1612581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612602 */     // GIR_Coverage, 3596,
     /* 1612602 */     GIR_EraseRootFromParent_Done,
     /* 1612603 */   // Label 22271: @1612603
     /* 1612603 */   GIM_Try, /*On fail goto*//*Label 22272*/ GIMT_Encode4(1612689), // Rule ID 3597 //
     /* 1612608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1612619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1612622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1612625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1612628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612654 */     // MIs[0] policy
     /* 1612654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612664 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1612667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612688 */     // GIR_Coverage, 3597,
     /* 1612688 */     GIR_EraseRootFromParent_Done,
     /* 1612689 */   // Label 22272: @1612689
     /* 1612689 */   GIM_Try, /*On fail goto*//*Label 22273*/ GIMT_Encode4(1612775), // Rule ID 3600 //
     /* 1612694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1612705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1612708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1612711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1612714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612740 */     // MIs[0] policy
     /* 1612740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612750 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1612753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612774 */     // GIR_Coverage, 3600,
     /* 1612774 */     GIR_EraseRootFromParent_Done,
     /* 1612775 */   // Label 22273: @1612775
     /* 1612775 */   GIM_Try, /*On fail goto*//*Label 22274*/ GIMT_Encode4(1612861), // Rule ID 3601 //
     /* 1612780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1612791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1612794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1612797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1612800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612826 */     // MIs[0] policy
     /* 1612826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1612839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612860 */     // GIR_Coverage, 3601,
     /* 1612860 */     GIR_EraseRootFromParent_Done,
     /* 1612861 */   // Label 22274: @1612861
     /* 1612861 */   GIM_Try, /*On fail goto*//*Label 22275*/ GIMT_Encode4(1612947), // Rule ID 3604 //
     /* 1612866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1612877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1612880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1612883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1612886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1612889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612912 */     // MIs[0] policy
     /* 1612912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612922 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1612925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1612943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612946 */     // GIR_Coverage, 3604,
     /* 1612946 */     GIR_EraseRootFromParent_Done,
     /* 1612947 */   // Label 22275: @1612947
     /* 1612947 */   GIM_Try, /*On fail goto*//*Label 22276*/ GIMT_Encode4(1613033), // Rule ID 3605 //
     /* 1612952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1612960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1612963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1612966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1612969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1612972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1612975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612998 */     // MIs[0] policy
     /* 1612998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613008 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613032 */     // GIR_Coverage, 3605,
     /* 1613032 */     GIR_EraseRootFromParent_Done,
     /* 1613033 */   // Label 22276: @1613033
     /* 1613033 */   GIM_Try, /*On fail goto*//*Label 22277*/ GIMT_Encode4(1613119), // Rule ID 3608 //
     /* 1613038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1613058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613084 */     // MIs[0] policy
     /* 1613084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613094 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613118 */     // GIR_Coverage, 3608,
     /* 1613118 */     GIR_EraseRootFromParent_Done,
     /* 1613119 */   // Label 22277: @1613119
     /* 1613119 */   GIM_Try, /*On fail goto*//*Label 22278*/ GIMT_Encode4(1613205), // Rule ID 3609 //
     /* 1613124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1613135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1613138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1613141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1613144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1613147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613170 */     // MIs[0] policy
     /* 1613170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613180 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613204 */     // GIR_Coverage, 3609,
     /* 1613204 */     GIR_EraseRootFromParent_Done,
     /* 1613205 */   // Label 22278: @1613205
     /* 1613205 */   GIM_Try, /*On fail goto*//*Label 22279*/ GIMT_Encode4(1613291), // Rule ID 3612 //
     /* 1613210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1613230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613256 */     // MIs[0] policy
     /* 1613256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613266 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1613269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613290 */     // GIR_Coverage, 3612,
     /* 1613290 */     GIR_EraseRootFromParent_Done,
     /* 1613291 */   // Label 22279: @1613291
     /* 1613291 */   GIM_Try, /*On fail goto*//*Label 22280*/ GIMT_Encode4(1613377), // Rule ID 3613 //
     /* 1613296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1613307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1613310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1613313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1613316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613342 */     // MIs[0] policy
     /* 1613342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1613355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613376 */     // GIR_Coverage, 3613,
     /* 1613376 */     GIR_EraseRootFromParent_Done,
     /* 1613377 */   // Label 22280: @1613377
     /* 1613377 */   GIM_Try, /*On fail goto*//*Label 22281*/ GIMT_Encode4(1613463), // Rule ID 3616 //
     /* 1613382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1613402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613428 */     // MIs[0] policy
     /* 1613428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613438 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613462 */     // GIR_Coverage, 3616,
     /* 1613462 */     GIR_EraseRootFromParent_Done,
     /* 1613463 */   // Label 22281: @1613463
     /* 1613463 */   GIM_Try, /*On fail goto*//*Label 22282*/ GIMT_Encode4(1613549), // Rule ID 3617 //
     /* 1613468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1613479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1613482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1613485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1613488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613514 */     // MIs[0] policy
     /* 1613514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1613527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613548 */     // GIR_Coverage, 3617,
     /* 1613548 */     GIR_EraseRootFromParent_Done,
     /* 1613549 */   // Label 22282: @1613549
     /* 1613549 */   GIM_Try, /*On fail goto*//*Label 22283*/ GIMT_Encode4(1613635), // Rule ID 3620 //
     /* 1613554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1613565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1613568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1613571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1613574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613600 */     // MIs[0] policy
     /* 1613600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1613613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613634 */     // GIR_Coverage, 3620,
     /* 1613634 */     GIR_EraseRootFromParent_Done,
     /* 1613635 */   // Label 22283: @1613635
     /* 1613635 */   GIM_Try, /*On fail goto*//*Label 22284*/ GIMT_Encode4(1613721), // Rule ID 3621 //
     /* 1613640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1613651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1613654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1613657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1613660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613686 */     // MIs[0] policy
     /* 1613686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1613699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613720 */     // GIR_Coverage, 3621,
     /* 1613720 */     GIR_EraseRootFromParent_Done,
     /* 1613721 */   // Label 22284: @1613721
     /* 1613721 */   GIM_Try, /*On fail goto*//*Label 22285*/ GIMT_Encode4(1613807), // Rule ID 3624 //
     /* 1613726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1613737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1613740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1613743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1613746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613772 */     // MIs[0] policy
     /* 1613772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613782 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613806 */     // GIR_Coverage, 3624,
     /* 1613806 */     GIR_EraseRootFromParent_Done,
     /* 1613807 */   // Label 22285: @1613807
     /* 1613807 */   GIM_Try, /*On fail goto*//*Label 22286*/ GIMT_Encode4(1613893), // Rule ID 3625 //
     /* 1613812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1613823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1613826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1613829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1613832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613858 */     // MIs[0] policy
     /* 1613858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1613871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613892 */     // GIR_Coverage, 3625,
     /* 1613892 */     GIR_EraseRootFromParent_Done,
     /* 1613893 */   // Label 22286: @1613893
     /* 1613893 */   GIM_Try, /*On fail goto*//*Label 22287*/ GIMT_Encode4(1613979), // Rule ID 3628 //
     /* 1613898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1613909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1613912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1613915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1613918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1613921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613944 */     // MIs[0] policy
     /* 1613944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613954 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1613957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1613975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613978 */     // GIR_Coverage, 3628,
     /* 1613978 */     GIR_EraseRootFromParent_Done,
     /* 1613979 */   // Label 22287: @1613979
     /* 1613979 */   GIM_Try, /*On fail goto*//*Label 22288*/ GIMT_Encode4(1614065), // Rule ID 3629 //
     /* 1613984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1613992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1613995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1613998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1614001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1614004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614030 */     // MIs[0] policy
     /* 1614030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614040 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614064 */     // GIR_Coverage, 3629,
     /* 1614064 */     GIR_EraseRootFromParent_Done,
     /* 1614065 */   // Label 22288: @1614065
     /* 1614065 */   GIM_Try, /*On fail goto*//*Label 22289*/ GIMT_Encode4(1614151), // Rule ID 3632 //
     /* 1614070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1614090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614116 */     // MIs[0] policy
     /* 1614116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1614129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614150 */     // GIR_Coverage, 3632,
     /* 1614150 */     GIR_EraseRootFromParent_Done,
     /* 1614151 */   // Label 22289: @1614151
     /* 1614151 */   GIM_Try, /*On fail goto*//*Label 22290*/ GIMT_Encode4(1614237), // Rule ID 3633 //
     /* 1614156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1614167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1614170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1614173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1614176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614202 */     // MIs[0] policy
     /* 1614202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614212 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1614215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614236 */     // GIR_Coverage, 3633,
     /* 1614236 */     GIR_EraseRootFromParent_Done,
     /* 1614237 */   // Label 22290: @1614237
     /* 1614237 */   GIM_Try, /*On fail goto*//*Label 22291*/ GIMT_Encode4(1614323), // Rule ID 3636 //
     /* 1614242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1614262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614288 */     // MIs[0] policy
     /* 1614288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614322 */     // GIR_Coverage, 3636,
     /* 1614322 */     GIR_EraseRootFromParent_Done,
     /* 1614323 */   // Label 22291: @1614323
     /* 1614323 */   GIM_Try, /*On fail goto*//*Label 22292*/ GIMT_Encode4(1614409), // Rule ID 3637 //
     /* 1614328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1614339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1614342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1614345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1614348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614374 */     // MIs[0] policy
     /* 1614374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614384 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1614387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614408 */     // GIR_Coverage, 3637,
     /* 1614408 */     GIR_EraseRootFromParent_Done,
     /* 1614409 */   // Label 22292: @1614409
     /* 1614409 */   GIM_Try, /*On fail goto*//*Label 22293*/ GIMT_Encode4(1614495), // Rule ID 3640 //
     /* 1614414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1614434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614460 */     // MIs[0] policy
     /* 1614460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614470 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614494 */     // GIR_Coverage, 3640,
     /* 1614494 */     GIR_EraseRootFromParent_Done,
     /* 1614495 */   // Label 22293: @1614495
     /* 1614495 */   GIM_Try, /*On fail goto*//*Label 22294*/ GIMT_Encode4(1614581), // Rule ID 3641 //
     /* 1614500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1614511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1614514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1614517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1614520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614546 */     // MIs[0] policy
     /* 1614546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614556 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1614559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614580 */     // GIR_Coverage, 3641,
     /* 1614580 */     GIR_EraseRootFromParent_Done,
     /* 1614581 */   // Label 22294: @1614581
     /* 1614581 */   GIM_Try, /*On fail goto*//*Label 22295*/ GIMT_Encode4(1614667), // Rule ID 3644 //
     /* 1614586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1614589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1614597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1614600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1614603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1614606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614632 */     // MIs[0] policy
     /* 1614632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614666 */     // GIR_Coverage, 3644,
     /* 1614666 */     GIR_EraseRootFromParent_Done,
     /* 1614667 */   // Label 22295: @1614667
     /* 1614667 */   GIM_Try, /*On fail goto*//*Label 22296*/ GIMT_Encode4(1614753), // Rule ID 3645 //
     /* 1614672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1614675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1614683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1614686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1614689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1614692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614718 */     // MIs[0] policy
     /* 1614718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614728 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1614731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1614749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614752 */     // GIR_Coverage, 3645,
     /* 1614752 */     GIR_EraseRootFromParent_Done,
     /* 1614753 */   // Label 22296: @1614753
     /* 1614753 */   GIM_Try, /*On fail goto*//*Label 22297*/ GIMT_Encode4(1614839), // Rule ID 3648 //
     /* 1614758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1614769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1614772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1614775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614804 */     // MIs[0] policy
     /* 1614804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614814 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1614817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614838 */     // GIR_Coverage, 3648,
     /* 1614838 */     GIR_EraseRootFromParent_Done,
     /* 1614839 */   // Label 22297: @1614839
     /* 1614839 */   GIM_Try, /*On fail goto*//*Label 22298*/ GIMT_Encode4(1614925), // Rule ID 3649 //
     /* 1614844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1614855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1614858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1614861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614890 */     // MIs[0] policy
     /* 1614890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614900 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1614903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614924 */     // GIR_Coverage, 3649,
     /* 1614924 */     GIR_EraseRootFromParent_Done,
     /* 1614925 */   // Label 22298: @1614925
     /* 1614925 */   GIM_Try, /*On fail goto*//*Label 22299*/ GIMT_Encode4(1615011), // Rule ID 3652 //
     /* 1614930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1614938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1614941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1614944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1614947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614976 */     // MIs[0] policy
     /* 1614976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614986 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1614989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615010 */     // GIR_Coverage, 3652,
     /* 1615010 */     GIR_EraseRootFromParent_Done,
     /* 1615011 */   // Label 22299: @1615011
     /* 1615011 */   GIM_Try, /*On fail goto*//*Label 22300*/ GIMT_Encode4(1615097), // Rule ID 3653 //
     /* 1615016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1615027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1615030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1615033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615062 */     // MIs[0] policy
     /* 1615062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615072 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615096 */     // GIR_Coverage, 3653,
     /* 1615096 */     GIR_EraseRootFromParent_Done,
     /* 1615097 */   // Label 22300: @1615097
     /* 1615097 */   GIM_Try, /*On fail goto*//*Label 22301*/ GIMT_Encode4(1615183), // Rule ID 3656 //
     /* 1615102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615148 */     // MIs[0] policy
     /* 1615148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1615161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615182 */     // GIR_Coverage, 3656,
     /* 1615182 */     GIR_EraseRootFromParent_Done,
     /* 1615183 */   // Label 22301: @1615183
     /* 1615183 */   GIM_Try, /*On fail goto*//*Label 22302*/ GIMT_Encode4(1615269), // Rule ID 3657 //
     /* 1615188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1615199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1615202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1615205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615234 */     // MIs[0] policy
     /* 1615234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11644:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1615247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615268 */     // GIR_Coverage, 3657,
     /* 1615268 */     GIR_EraseRootFromParent_Done,
     /* 1615269 */   // Label 22302: @1615269
     /* 1615269 */   GIM_Try, /*On fail goto*//*Label 22303*/ GIMT_Encode4(1615355), // Rule ID 3660 //
     /* 1615274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615320 */     // MIs[0] policy
     /* 1615320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615330 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1615333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615354 */     // GIR_Coverage, 3660,
     /* 1615354 */     GIR_EraseRootFromParent_Done,
     /* 1615355 */   // Label 22303: @1615355
     /* 1615355 */   GIM_Try, /*On fail goto*//*Label 22304*/ GIMT_Encode4(1615441), // Rule ID 3661 //
     /* 1615360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1615371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1615374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1615377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615406 */     // MIs[0] policy
     /* 1615406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615416 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1615419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615440 */     // GIR_Coverage, 3661,
     /* 1615440 */     GIR_EraseRootFromParent_Done,
     /* 1615441 */   // Label 22304: @1615441
     /* 1615441 */   GIM_Try, /*On fail goto*//*Label 22305*/ GIMT_Encode4(1615527), // Rule ID 3664 //
     /* 1615446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1615457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1615460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1615463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615492 */     // MIs[0] policy
     /* 1615492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615502 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1615505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615526 */     // GIR_Coverage, 3664,
     /* 1615526 */     GIR_EraseRootFromParent_Done,
     /* 1615527 */   // Label 22305: @1615527
     /* 1615527 */   GIM_Try, /*On fail goto*//*Label 22306*/ GIMT_Encode4(1615613), // Rule ID 3665 //
     /* 1615532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1615543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1615546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1615549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615578 */     // MIs[0] policy
     /* 1615578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615588 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1615591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615612 */     // GIR_Coverage, 3665,
     /* 1615612 */     GIR_EraseRootFromParent_Done,
     /* 1615613 */   // Label 22306: @1615613
     /* 1615613 */   GIM_Try, /*On fail goto*//*Label 22307*/ GIMT_Encode4(1615699), // Rule ID 3668 //
     /* 1615618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1615629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1615632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1615635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1615641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615664 */     // MIs[0] policy
     /* 1615664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615674 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1615677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615698 */     // GIR_Coverage, 3668,
     /* 1615698 */     GIR_EraseRootFromParent_Done,
     /* 1615699 */   // Label 22307: @1615699
     /* 1615699 */   GIM_Try, /*On fail goto*//*Label 22308*/ GIMT_Encode4(1615785), // Rule ID 3669 //
     /* 1615704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1615715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1615718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1615721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1615727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615750 */     // MIs[0] policy
     /* 1615750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615760 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1615763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615784 */     // GIR_Coverage, 3669,
     /* 1615784 */     GIR_EraseRootFromParent_Done,
     /* 1615785 */   // Label 22308: @1615785
     /* 1615785 */   GIM_Try, /*On fail goto*//*Label 22309*/ GIMT_Encode4(1615871), // Rule ID 3672 //
     /* 1615790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1615801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1615804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1615807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615836 */     // MIs[0] policy
     /* 1615836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1615867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615870 */     // GIR_Coverage, 3672,
     /* 1615870 */     GIR_EraseRootFromParent_Done,
     /* 1615871 */   // Label 22309: @1615871
     /* 1615871 */   GIM_Try, /*On fail goto*//*Label 22310*/ GIMT_Encode4(1615957), // Rule ID 3673 //
     /* 1615876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1615887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1615890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1615893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615922 */     // MIs[0] policy
     /* 1615922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1615935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1615953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615956 */     // GIR_Coverage, 3673,
     /* 1615956 */     GIR_EraseRootFromParent_Done,
     /* 1615957 */   // Label 22310: @1615957
     /* 1615957 */   GIM_Try, /*On fail goto*//*Label 22311*/ GIMT_Encode4(1616043), // Rule ID 3676 //
     /* 1615962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1615970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1615973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1615976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1615979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616008 */     // MIs[0] policy
     /* 1616008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616018 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616042 */     // GIR_Coverage, 3676,
     /* 1616042 */     GIR_EraseRootFromParent_Done,
     /* 1616043 */   // Label 22311: @1616043
     /* 1616043 */   GIM_Try, /*On fail goto*//*Label 22312*/ GIMT_Encode4(1616129), // Rule ID 3677 //
     /* 1616048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1616059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1616062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1616065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616094 */     // MIs[0] policy
     /* 1616094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11644:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616128 */     // GIR_Coverage, 3677,
     /* 1616128 */     GIR_EraseRootFromParent_Done,
     /* 1616129 */   // Label 22312: @1616129
     /* 1616129 */   GIM_Try, /*On fail goto*//*Label 22313*/ GIMT_Encode4(1616215), // Rule ID 3680 //
     /* 1616134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616180 */     // MIs[0] policy
     /* 1616180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616214 */     // GIR_Coverage, 3680,
     /* 1616214 */     GIR_EraseRootFromParent_Done,
     /* 1616215 */   // Label 22313: @1616215
     /* 1616215 */   GIM_Try, /*On fail goto*//*Label 22314*/ GIMT_Encode4(1616301), // Rule ID 3681 //
     /* 1616220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1616231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1616234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1616237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616266 */     // MIs[0] policy
     /* 1616266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616300 */     // GIR_Coverage, 3681,
     /* 1616300 */     GIR_EraseRootFromParent_Done,
     /* 1616301 */   // Label 22314: @1616301
     /* 1616301 */   GIM_Try, /*On fail goto*//*Label 22315*/ GIMT_Encode4(1616387), // Rule ID 3684 //
     /* 1616306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616352 */     // MIs[0] policy
     /* 1616352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616362 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616386 */     // GIR_Coverage, 3684,
     /* 1616386 */     GIR_EraseRootFromParent_Done,
     /* 1616387 */   // Label 22315: @1616387
     /* 1616387 */   GIM_Try, /*On fail goto*//*Label 22316*/ GIMT_Encode4(1616473), // Rule ID 3685 //
     /* 1616392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1616403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1616406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1616409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616438 */     // MIs[0] policy
     /* 1616438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1616451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616472 */     // GIR_Coverage, 3685,
     /* 1616472 */     GIR_EraseRootFromParent_Done,
     /* 1616473 */   // Label 22316: @1616473
     /* 1616473 */   GIM_Try, /*On fail goto*//*Label 22317*/ GIMT_Encode4(1616559), // Rule ID 3688 //
     /* 1616478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1616489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1616492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1616495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616524 */     // MIs[0] policy
     /* 1616524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1616537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616558 */     // GIR_Coverage, 3688,
     /* 1616558 */     GIR_EraseRootFromParent_Done,
     /* 1616559 */   // Label 22317: @1616559
     /* 1616559 */   GIM_Try, /*On fail goto*//*Label 22318*/ GIMT_Encode4(1616645), // Rule ID 3689 //
     /* 1616564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1616575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1616578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1616581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616610 */     // MIs[0] policy
     /* 1616610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1616623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1616641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616644 */     // GIR_Coverage, 3689,
     /* 1616644 */     GIR_EraseRootFromParent_Done,
     /* 1616645 */   // Label 22318: @1616645
     /* 1616645 */   GIM_Try, /*On fail goto*//*Label 22319*/ GIMT_Encode4(1616731), // Rule ID 3692 //
     /* 1616650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1616653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1616661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1616664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1616667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616696 */     // MIs[0] policy
     /* 1616696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1616727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616730 */     // GIR_Coverage, 3692,
     /* 1616730 */     GIR_EraseRootFromParent_Done,
     /* 1616731 */   // Label 22319: @1616731
     /* 1616731 */   GIM_Try, /*On fail goto*//*Label 22320*/ GIMT_Encode4(1616817), // Rule ID 3693 //
     /* 1616736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1616739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1616747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1616750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1616753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616782 */     // MIs[0] policy
     /* 1616782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11644:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1616795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1616813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616816 */     // GIR_Coverage, 3693,
     /* 1616816 */     GIR_EraseRootFromParent_Done,
     /* 1616817 */   // Label 22320: @1616817
     /* 1616817 */   GIM_Try, /*On fail goto*//*Label 22321*/ GIMT_Encode4(1616903), // Rule ID 3696 //
     /* 1616822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1616825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1616833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1616836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1616839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1616842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616868 */     // MIs[0] policy
     /* 1616868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1616899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616902 */     // GIR_Coverage, 3696,
     /* 1616902 */     GIR_EraseRootFromParent_Done,
     /* 1616903 */   // Label 22321: @1616903
     /* 1616903 */   GIM_Try, /*On fail goto*//*Label 22322*/ GIMT_Encode4(1616989), // Rule ID 3697 //
     /* 1616908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1616911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1616916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1616919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1616922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1616925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1616928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1616950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616954 */     // MIs[0] policy
     /* 1616954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616964 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11644:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1616967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1616985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616988 */     // GIR_Coverage, 3697,
     /* 1616988 */     GIR_EraseRootFromParent_Done,
     /* 1616989 */   // Label 22322: @1616989
     /* 1616989 */   GIM_Try, /*On fail goto*//*Label 22323*/ GIMT_Encode4(1617075), // Rule ID 3700 //
     /* 1616994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1616997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617040 */     // MIs[0] policy
     /* 1617040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617050 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1617053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617074 */     // GIR_Coverage, 3700,
     /* 1617074 */     GIR_EraseRootFromParent_Done,
     /* 1617075 */   // Label 22323: @1617075
     /* 1617075 */   GIM_Try, /*On fail goto*//*Label 22324*/ GIMT_Encode4(1617161), // Rule ID 3701 //
     /* 1617080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1617091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1617094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1617097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617126 */     // MIs[0] policy
     /* 1617126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617136 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11644:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1617139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617160 */     // GIR_Coverage, 3701,
     /* 1617160 */     GIR_EraseRootFromParent_Done,
     /* 1617161 */   // Label 22324: @1617161
     /* 1617161 */   GIM_Try, /*On fail goto*//*Label 22325*/ GIMT_Encode4(1617247), // Rule ID 3704 //
     /* 1617166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1617186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617212 */     // MIs[0] policy
     /* 1617212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617222 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617246 */     // GIR_Coverage, 3704,
     /* 1617246 */     GIR_EraseRootFromParent_Done,
     /* 1617247 */   // Label 22325: @1617247
     /* 1617247 */   GIM_Try, /*On fail goto*//*Label 22326*/ GIMT_Encode4(1617333), // Rule ID 3705 //
     /* 1617252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1617260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1617263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1617266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1617269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1617272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1617294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617298 */     // MIs[0] policy
     /* 1617298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617308 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11644:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1617311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617332 */     // GIR_Coverage, 3705,
     /* 1617332 */     GIR_EraseRootFromParent_Done,
     /* 1617333 */   // Label 22326: @1617333
     /* 1617333 */   GIM_Try, /*On fail goto*//*Label 22327*/ GIMT_Encode4(1617419), // Rule ID 3708 //
     /* 1617338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1617358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617384 */     // MIs[0] policy
     /* 1617384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1617397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617418 */     // GIR_Coverage, 3708,
     /* 1617418 */     GIR_EraseRootFromParent_Done,
     /* 1617419 */   // Label 22327: @1617419
     /* 1617419 */   GIM_Try, /*On fail goto*//*Label 22328*/ GIMT_Encode4(1617505), // Rule ID 3709 //
     /* 1617424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1617435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1617438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1617441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1617444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617470 */     // MIs[0] policy
     /* 1617470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617480 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1617483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617504 */     // GIR_Coverage, 3709,
     /* 1617504 */     GIR_EraseRootFromParent_Done,
     /* 1617505 */   // Label 22328: @1617505
     /* 1617505 */   GIM_Try, /*On fail goto*//*Label 22329*/ GIMT_Encode4(1617591), // Rule ID 3712 //
     /* 1617510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1617521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1617524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1617527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1617530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617556 */     // MIs[0] policy
     /* 1617556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617566 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1617569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617590 */     // GIR_Coverage, 3712,
     /* 1617590 */     GIR_EraseRootFromParent_Done,
     /* 1617591 */   // Label 22329: @1617591
     /* 1617591 */   GIM_Try, /*On fail goto*//*Label 22330*/ GIMT_Encode4(1617677), // Rule ID 3713 //
     /* 1617596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1617607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1617610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1617613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1617616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617642 */     // MIs[0] policy
     /* 1617642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1617655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617676 */     // GIR_Coverage, 3713,
     /* 1617676 */     GIR_EraseRootFromParent_Done,
     /* 1617677 */   // Label 22330: @1617677
     /* 1617677 */   GIM_Try, /*On fail goto*//*Label 22331*/ GIMT_Encode4(1617763), // Rule ID 3716 //
     /* 1617682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1617693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1617696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1617699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1617702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617728 */     // MIs[0] policy
     /* 1617728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617738 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1617741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617762 */     // GIR_Coverage, 3716,
     /* 1617762 */     GIR_EraseRootFromParent_Done,
     /* 1617763 */   // Label 22331: @1617763
     /* 1617763 */   GIM_Try, /*On fail goto*//*Label 22332*/ GIMT_Encode4(1617849), // Rule ID 3717 //
     /* 1617768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1617779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1617782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1617785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1617788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617814 */     // MIs[0] policy
     /* 1617814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1617827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617848 */     // GIR_Coverage, 3717,
     /* 1617848 */     GIR_EraseRootFromParent_Done,
     /* 1617849 */   // Label 22332: @1617849
     /* 1617849 */   GIM_Try, /*On fail goto*//*Label 22333*/ GIMT_Encode4(1617935), // Rule ID 3720 //
     /* 1617854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1617865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1617868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1617871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1617874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617900 */     // MIs[0] policy
     /* 1617900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617910 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1617913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1617931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617934 */     // GIR_Coverage, 3720,
     /* 1617934 */     GIR_EraseRootFromParent_Done,
     /* 1617935 */   // Label 22333: @1617935
     /* 1617935 */   GIM_Try, /*On fail goto*//*Label 22334*/ GIMT_Encode4(1618021), // Rule ID 3721 //
     /* 1617940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1617948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1617951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1617954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1617957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1617960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617986 */     // MIs[0] policy
     /* 1617986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1617999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618020 */     // GIR_Coverage, 3721,
     /* 1618020 */     GIR_EraseRootFromParent_Done,
     /* 1618021 */   // Label 22334: @1618021
     /* 1618021 */   GIM_Try, /*On fail goto*//*Label 22335*/ GIMT_Encode4(1618107), // Rule ID 3724 //
     /* 1618026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1618046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618072 */     // MIs[0] policy
     /* 1618072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618082 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618106 */     // GIR_Coverage, 3724,
     /* 1618106 */     GIR_EraseRootFromParent_Done,
     /* 1618107 */   // Label 22335: @1618107
     /* 1618107 */   GIM_Try, /*On fail goto*//*Label 22336*/ GIMT_Encode4(1618193), // Rule ID 3725 //
     /* 1618112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1618123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1618126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1618129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1618132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1618135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618158 */     // MIs[0] policy
     /* 1618158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618192 */     // GIR_Coverage, 3725,
     /* 1618192 */     GIR_EraseRootFromParent_Done,
     /* 1618193 */   // Label 22336: @1618193
     /* 1618193 */   GIM_Try, /*On fail goto*//*Label 22337*/ GIMT_Encode4(1618279), // Rule ID 3728 //
     /* 1618198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618244 */     // MIs[0] policy
     /* 1618244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618254 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1618257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618278 */     // GIR_Coverage, 3728,
     /* 1618278 */     GIR_EraseRootFromParent_Done,
     /* 1618279 */   // Label 22337: @1618279
     /* 1618279 */   GIM_Try, /*On fail goto*//*Label 22338*/ GIMT_Encode4(1618365), // Rule ID 3729 //
     /* 1618284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1618295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1618298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1618301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1618304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1618307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618330 */     // MIs[0] policy
     /* 1618330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618340 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1618343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618364 */     // GIR_Coverage, 3729,
     /* 1618364 */     GIR_EraseRootFromParent_Done,
     /* 1618365 */   // Label 22338: @1618365
     /* 1618365 */   GIM_Try, /*On fail goto*//*Label 22339*/ GIMT_Encode4(1618451), // Rule ID 3732 //
     /* 1618370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1618390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618416 */     // MIs[0] policy
     /* 1618416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618426 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618450 */     // GIR_Coverage, 3732,
     /* 1618450 */     GIR_EraseRootFromParent_Done,
     /* 1618451 */   // Label 22339: @1618451
     /* 1618451 */   GIM_Try, /*On fail goto*//*Label 22340*/ GIMT_Encode4(1618537), // Rule ID 3733 //
     /* 1618456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1618467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1618470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1618473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1618476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618502 */     // MIs[0] policy
     /* 1618502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618512 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1618515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618536 */     // GIR_Coverage, 3733,
     /* 1618536 */     GIR_EraseRootFromParent_Done,
     /* 1618537 */   // Label 22340: @1618537
     /* 1618537 */   GIM_Try, /*On fail goto*//*Label 22341*/ GIMT_Encode4(1618623), // Rule ID 3736 //
     /* 1618542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1618553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1618556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1618559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1618562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618588 */     // MIs[0] policy
     /* 1618588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618598 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1618601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618622 */     // GIR_Coverage, 3736,
     /* 1618622 */     GIR_EraseRootFromParent_Done,
     /* 1618623 */   // Label 22341: @1618623
     /* 1618623 */   GIM_Try, /*On fail goto*//*Label 22342*/ GIMT_Encode4(1618709), // Rule ID 3737 //
     /* 1618628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1618639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1618642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1618645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1618648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618674 */     // MIs[0] policy
     /* 1618674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1618687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618708 */     // GIR_Coverage, 3737,
     /* 1618708 */     GIR_EraseRootFromParent_Done,
     /* 1618709 */   // Label 22342: @1618709
     /* 1618709 */   GIM_Try, /*On fail goto*//*Label 22343*/ GIMT_Encode4(1618795), // Rule ID 3740 //
     /* 1618714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1618725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1618728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1618731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1618734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618760 */     // MIs[0] policy
     /* 1618760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618770 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1618773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618794 */     // GIR_Coverage, 3740,
     /* 1618794 */     GIR_EraseRootFromParent_Done,
     /* 1618795 */   // Label 22343: @1618795
     /* 1618795 */   GIM_Try, /*On fail goto*//*Label 22344*/ GIMT_Encode4(1618881), // Rule ID 3741 //
     /* 1618800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1618811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1618814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1618817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1618820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618846 */     // MIs[0] policy
     /* 1618846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1618859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618880 */     // GIR_Coverage, 3741,
     /* 1618880 */     GIR_EraseRootFromParent_Done,
     /* 1618881 */   // Label 22344: @1618881
     /* 1618881 */   GIM_Try, /*On fail goto*//*Label 22345*/ GIMT_Encode4(1618967), // Rule ID 3744 //
     /* 1618886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1618897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1618900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1618903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1618906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618932 */     // MIs[0] policy
     /* 1618932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618942 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1618945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1618963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618966 */     // GIR_Coverage, 3744,
     /* 1618966 */     GIR_EraseRootFromParent_Done,
     /* 1618967 */   // Label 22345: @1618967
     /* 1618967 */   GIM_Try, /*On fail goto*//*Label 22346*/ GIMT_Encode4(1619053), // Rule ID 3745 //
     /* 1618972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1618980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1618983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1618986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1618989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1618992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619018 */     // MIs[0] policy
     /* 1619018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619052 */     // GIR_Coverage, 3745,
     /* 1619052 */     GIR_EraseRootFromParent_Done,
     /* 1619053 */   // Label 22346: @1619053
     /* 1619053 */   GIM_Try, /*On fail goto*//*Label 22347*/ GIMT_Encode4(1619139), // Rule ID 3748 //
     /* 1619058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1619078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619104 */     // MIs[0] policy
     /* 1619104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619114 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619138 */     // GIR_Coverage, 3748,
     /* 1619138 */     GIR_EraseRootFromParent_Done,
     /* 1619139 */   // Label 22347: @1619139
     /* 1619139 */   GIM_Try, /*On fail goto*//*Label 22348*/ GIMT_Encode4(1619225), // Rule ID 3749 //
     /* 1619144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1619155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1619158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1619161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1619164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619190 */     // MIs[0] policy
     /* 1619190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619200 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619224 */     // GIR_Coverage, 3749,
     /* 1619224 */     GIR_EraseRootFromParent_Done,
     /* 1619225 */   // Label 22348: @1619225
     /* 1619225 */   GIM_Try, /*On fail goto*//*Label 22349*/ GIMT_Encode4(1619311), // Rule ID 3752 //
     /* 1619230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1619250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619276 */     // MIs[0] policy
     /* 1619276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619286 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619310 */     // GIR_Coverage, 3752,
     /* 1619310 */     GIR_EraseRootFromParent_Done,
     /* 1619311 */   // Label 22349: @1619311
     /* 1619311 */   GIM_Try, /*On fail goto*//*Label 22350*/ GIMT_Encode4(1619397), // Rule ID 3753 //
     /* 1619316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1619327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1619330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1619333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1619336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619362 */     // MIs[0] policy
     /* 1619362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619372 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1619375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619396 */     // GIR_Coverage, 3753,
     /* 1619396 */     GIR_EraseRootFromParent_Done,
     /* 1619397 */   // Label 22350: @1619397
     /* 1619397 */   GIM_Try, /*On fail goto*//*Label 22351*/ GIMT_Encode4(1619483), // Rule ID 3756 //
     /* 1619402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1619422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619448 */     // MIs[0] policy
     /* 1619448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619458 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619482 */     // GIR_Coverage, 3756,
     /* 1619482 */     GIR_EraseRootFromParent_Done,
     /* 1619483 */   // Label 22351: @1619483
     /* 1619483 */   GIM_Try, /*On fail goto*//*Label 22352*/ GIMT_Encode4(1619569), // Rule ID 3757 //
     /* 1619488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1619499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1619502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1619505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1619508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619534 */     // MIs[0] policy
     /* 1619534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1619547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619568 */     // GIR_Coverage, 3757,
     /* 1619568 */     GIR_EraseRootFromParent_Done,
     /* 1619569 */   // Label 22352: @1619569
     /* 1619569 */   GIM_Try, /*On fail goto*//*Label 22353*/ GIMT_Encode4(1619655), // Rule ID 3760 //
     /* 1619574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1619585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1619588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1619591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1619594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619620 */     // MIs[0] policy
     /* 1619620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619630 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619654 */     // GIR_Coverage, 3760,
     /* 1619654 */     GIR_EraseRootFromParent_Done,
     /* 1619655 */   // Label 22353: @1619655
     /* 1619655 */   GIM_Try, /*On fail goto*//*Label 22354*/ GIMT_Encode4(1619741), // Rule ID 3761 //
     /* 1619660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1619671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1619674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1619677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1619680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619706 */     // MIs[0] policy
     /* 1619706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1619719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619740 */     // GIR_Coverage, 3761,
     /* 1619740 */     GIR_EraseRootFromParent_Done,
     /* 1619741 */   // Label 22354: @1619741
     /* 1619741 */   GIM_Try, /*On fail goto*//*Label 22355*/ GIMT_Encode4(1619827), // Rule ID 3764 //
     /* 1619746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1619749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1619757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1619760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1619763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1619766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619792 */     // MIs[0] policy
     /* 1619792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619802 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619826 */     // GIR_Coverage, 3764,
     /* 1619826 */     GIR_EraseRootFromParent_Done,
     /* 1619827 */   // Label 22355: @1619827
     /* 1619827 */   GIM_Try, /*On fail goto*//*Label 22356*/ GIMT_Encode4(1619913), // Rule ID 3765 //
     /* 1619832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1619835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1619843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1619846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1619849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1619852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619878 */     // MIs[0] policy
     /* 1619878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619888 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1619891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1619909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619912 */     // GIR_Coverage, 3765,
     /* 1619912 */     GIR_EraseRootFromParent_Done,
     /* 1619913 */   // Label 22356: @1619913
     /* 1619913 */   GIM_Try, /*On fail goto*//*Label 22357*/ GIMT_Encode4(1619999), // Rule ID 3768 //
     /* 1619918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1619926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1619929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1619932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1619935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619964 */     // MIs[0] policy
     /* 1619964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619974 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1619977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619998 */     // GIR_Coverage, 3768,
     /* 1619998 */     GIR_EraseRootFromParent_Done,
     /* 1619999 */   // Label 22357: @1619999
     /* 1619999 */   GIM_Try, /*On fail goto*//*Label 22358*/ GIMT_Encode4(1620085), // Rule ID 3769 //
     /* 1620004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1620015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1620018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1620021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620050 */     // MIs[0] policy
     /* 1620050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1620063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620084 */     // GIR_Coverage, 3769,
     /* 1620084 */     GIR_EraseRootFromParent_Done,
     /* 1620085 */   // Label 22358: @1620085
     /* 1620085 */   GIM_Try, /*On fail goto*//*Label 22359*/ GIMT_Encode4(1620171), // Rule ID 3772 //
     /* 1620090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620136 */     // MIs[0] policy
     /* 1620136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620146 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1620149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620170 */     // GIR_Coverage, 3772,
     /* 1620170 */     GIR_EraseRootFromParent_Done,
     /* 1620171 */   // Label 22359: @1620171
     /* 1620171 */   GIM_Try, /*On fail goto*//*Label 22360*/ GIMT_Encode4(1620257), // Rule ID 3773 //
     /* 1620176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1620187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1620190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1620193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620222 */     // MIs[0] policy
     /* 1620222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1620235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620256 */     // GIR_Coverage, 3773,
     /* 1620256 */     GIR_EraseRootFromParent_Done,
     /* 1620257 */   // Label 22360: @1620257
     /* 1620257 */   GIM_Try, /*On fail goto*//*Label 22361*/ GIMT_Encode4(1620343), // Rule ID 3776 //
     /* 1620262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620308 */     // MIs[0] policy
     /* 1620308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1620321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620342 */     // GIR_Coverage, 3776,
     /* 1620342 */     GIR_EraseRootFromParent_Done,
     /* 1620343 */   // Label 22361: @1620343
     /* 1620343 */   GIM_Try, /*On fail goto*//*Label 22362*/ GIMT_Encode4(1620429), // Rule ID 3777 //
     /* 1620348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1620359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1620362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1620365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620394 */     // MIs[0] policy
     /* 1620394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620404 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11672:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1620407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620428 */     // GIR_Coverage, 3777,
     /* 1620428 */     GIR_EraseRootFromParent_Done,
     /* 1620429 */   // Label 22362: @1620429
     /* 1620429 */   GIM_Try, /*On fail goto*//*Label 22363*/ GIMT_Encode4(1620515), // Rule ID 3780 //
     /* 1620434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1620445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1620448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1620451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620480 */     // MIs[0] policy
     /* 1620480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1620493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620514 */     // GIR_Coverage, 3780,
     /* 1620514 */     GIR_EraseRootFromParent_Done,
     /* 1620515 */   // Label 22363: @1620515
     /* 1620515 */   GIM_Try, /*On fail goto*//*Label 22364*/ GIMT_Encode4(1620601), // Rule ID 3781 //
     /* 1620520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1620531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1620534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1620537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620566 */     // MIs[0] policy
     /* 1620566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620576 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1620579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620600 */     // GIR_Coverage, 3781,
     /* 1620600 */     GIR_EraseRootFromParent_Done,
     /* 1620601 */   // Label 22364: @1620601
     /* 1620601 */   GIM_Try, /*On fail goto*//*Label 22365*/ GIMT_Encode4(1620687), // Rule ID 3784 //
     /* 1620606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1620617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1620620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1620623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1620629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620652 */     // MIs[0] policy
     /* 1620652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620662 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1620665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620686 */     // GIR_Coverage, 3784,
     /* 1620686 */     GIR_EraseRootFromParent_Done,
     /* 1620687 */   // Label 22365: @1620687
     /* 1620687 */   GIM_Try, /*On fail goto*//*Label 22366*/ GIMT_Encode4(1620773), // Rule ID 3785 //
     /* 1620692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1620703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1620706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1620709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1620715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620738 */     // MIs[0] policy
     /* 1620738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620748 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1620751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620772 */     // GIR_Coverage, 3785,
     /* 1620772 */     GIR_EraseRootFromParent_Done,
     /* 1620773 */   // Label 22366: @1620773
     /* 1620773 */   GIM_Try, /*On fail goto*//*Label 22367*/ GIMT_Encode4(1620859), // Rule ID 3788 //
     /* 1620778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1620789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1620792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1620795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1620801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620824 */     // MIs[0] policy
     /* 1620824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620834 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1620837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620858 */     // GIR_Coverage, 3788,
     /* 1620858 */     GIR_EraseRootFromParent_Done,
     /* 1620859 */   // Label 22367: @1620859
     /* 1620859 */   GIM_Try, /*On fail goto*//*Label 22368*/ GIMT_Encode4(1620945), // Rule ID 3789 //
     /* 1620864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1620875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1620878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1620881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1620887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620910 */     // MIs[0] policy
     /* 1620910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620920 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1620923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1620941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620944 */     // GIR_Coverage, 3789,
     /* 1620944 */     GIR_EraseRootFromParent_Done,
     /* 1620945 */   // Label 22368: @1620945
     /* 1620945 */   GIM_Try, /*On fail goto*//*Label 22369*/ GIMT_Encode4(1621031), // Rule ID 3792 //
     /* 1620950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1620958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1620961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1620964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1620967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620996 */     // MIs[0] policy
     /* 1620996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1621009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621030 */     // GIR_Coverage, 3792,
     /* 1621030 */     GIR_EraseRootFromParent_Done,
     /* 1621031 */   // Label 22369: @1621031
     /* 1621031 */   GIM_Try, /*On fail goto*//*Label 22370*/ GIMT_Encode4(1621117), // Rule ID 3793 //
     /* 1621036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1621047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1621050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1621053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621082 */     // MIs[0] policy
     /* 1621082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621092 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1621095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621116 */     // GIR_Coverage, 3793,
     /* 1621116 */     GIR_EraseRootFromParent_Done,
     /* 1621117 */   // Label 22370: @1621117
     /* 1621117 */   GIM_Try, /*On fail goto*//*Label 22371*/ GIMT_Encode4(1621203), // Rule ID 3796 //
     /* 1621122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621168 */     // MIs[0] policy
     /* 1621168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621202 */     // GIR_Coverage, 3796,
     /* 1621202 */     GIR_EraseRootFromParent_Done,
     /* 1621203 */   // Label 22371: @1621203
     /* 1621203 */   GIM_Try, /*On fail goto*//*Label 22372*/ GIMT_Encode4(1621289), // Rule ID 3797 //
     /* 1621208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1621219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1621222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1621225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621254 */     // MIs[0] policy
     /* 1621254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11672:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621288 */     // GIR_Coverage, 3797,
     /* 1621288 */     GIR_EraseRootFromParent_Done,
     /* 1621289 */   // Label 22372: @1621289
     /* 1621289 */   GIM_Try, /*On fail goto*//*Label 22373*/ GIMT_Encode4(1621375), // Rule ID 3800 //
     /* 1621294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621340 */     // MIs[0] policy
     /* 1621340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621374 */     // GIR_Coverage, 3800,
     /* 1621374 */     GIR_EraseRootFromParent_Done,
     /* 1621375 */   // Label 22373: @1621375
     /* 1621375 */   GIM_Try, /*On fail goto*//*Label 22374*/ GIMT_Encode4(1621461), // Rule ID 3801 //
     /* 1621380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1621391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1621394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1621397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621426 */     // MIs[0] policy
     /* 1621426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621436 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1621439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621460 */     // GIR_Coverage, 3801,
     /* 1621460 */     GIR_EraseRootFromParent_Done,
     /* 1621461 */   // Label 22374: @1621461
     /* 1621461 */   GIM_Try, /*On fail goto*//*Label 22375*/ GIMT_Encode4(1621547), // Rule ID 3804 //
     /* 1621466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1621477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1621480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1621483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621512 */     // MIs[0] policy
     /* 1621512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621546 */     // GIR_Coverage, 3804,
     /* 1621546 */     GIR_EraseRootFromParent_Done,
     /* 1621547 */   // Label 22375: @1621547
     /* 1621547 */   GIM_Try, /*On fail goto*//*Label 22376*/ GIMT_Encode4(1621633), // Rule ID 3805 //
     /* 1621552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1621563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1621566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1621569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621598 */     // MIs[0] policy
     /* 1621598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621608 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1621611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621632 */     // GIR_Coverage, 3805,
     /* 1621632 */     GIR_EraseRootFromParent_Done,
     /* 1621633 */   // Label 22376: @1621633
     /* 1621633 */   GIM_Try, /*On fail goto*//*Label 22377*/ GIMT_Encode4(1621719), // Rule ID 3808 //
     /* 1621638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1621649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1621652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1621655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621684 */     // MIs[0] policy
     /* 1621684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621694 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1621697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621718 */     // GIR_Coverage, 3808,
     /* 1621718 */     GIR_EraseRootFromParent_Done,
     /* 1621719 */   // Label 22377: @1621719
     /* 1621719 */   GIM_Try, /*On fail goto*//*Label 22378*/ GIMT_Encode4(1621805), // Rule ID 3809 //
     /* 1621724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1621735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1621738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1621741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621770 */     // MIs[0] policy
     /* 1621770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621780 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1621783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1621801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621804 */     // GIR_Coverage, 3809,
     /* 1621804 */     GIR_EraseRootFromParent_Done,
     /* 1621805 */   // Label 22378: @1621805
     /* 1621805 */   GIM_Try, /*On fail goto*//*Label 22379*/ GIMT_Encode4(1621891), // Rule ID 3812 //
     /* 1621810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1621813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1621821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1621824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1621827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1621830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621856 */     // MIs[0] policy
     /* 1621856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621866 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621890 */     // GIR_Coverage, 3812,
     /* 1621890 */     GIR_EraseRootFromParent_Done,
     /* 1621891 */   // Label 22379: @1621891
     /* 1621891 */   GIM_Try, /*On fail goto*//*Label 22380*/ GIMT_Encode4(1621977), // Rule ID 3813 //
     /* 1621896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1621899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1621907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1621910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1621913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621942 */     // MIs[0] policy
     /* 1621942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11672:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1621955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621976 */     // GIR_Coverage, 3813,
     /* 1621976 */     GIR_EraseRootFromParent_Done,
     /* 1621977 */   // Label 22380: @1621977
     /* 1621977 */   GIM_Try, /*On fail goto*//*Label 22381*/ GIMT_Encode4(1622063), // Rule ID 3816 //
     /* 1621982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1621985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1621990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1621993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1621996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1621999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622028 */     // MIs[0] policy
     /* 1622028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622038 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1622041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622062 */     // GIR_Coverage, 3816,
     /* 1622062 */     GIR_EraseRootFromParent_Done,
     /* 1622063 */   // Label 22381: @1622063
     /* 1622063 */   GIM_Try, /*On fail goto*//*Label 22382*/ GIMT_Encode4(1622149), // Rule ID 3817 //
     /* 1622068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1622079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1622082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1622085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622114 */     // MIs[0] policy
     /* 1622114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11672:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1622127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622148 */     // GIR_Coverage, 3817,
     /* 1622148 */     GIR_EraseRootFromParent_Done,
     /* 1622149 */   // Label 22382: @1622149
     /* 1622149 */   GIM_Try, /*On fail goto*//*Label 22383*/ GIMT_Encode4(1622235), // Rule ID 3820 //
     /* 1622154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622200 */     // MIs[0] policy
     /* 1622200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622210 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622234 */     // GIR_Coverage, 3820,
     /* 1622234 */     GIR_EraseRootFromParent_Done,
     /* 1622235 */   // Label 22383: @1622235
     /* 1622235 */   GIM_Try, /*On fail goto*//*Label 22384*/ GIMT_Encode4(1622321), // Rule ID 3821 //
     /* 1622240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1622251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1622254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1622257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622286 */     // MIs[0] policy
     /* 1622286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11672:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1622299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622320 */     // GIR_Coverage, 3821,
     /* 1622320 */     GIR_EraseRootFromParent_Done,
     /* 1622321 */   // Label 22384: @1622321
     /* 1622321 */   GIM_Try, /*On fail goto*//*Label 22385*/ GIMT_Encode4(1622407), // Rule ID 3824 //
     /* 1622326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1622346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622372 */     // MIs[0] policy
     /* 1622372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622382 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622406 */     // GIR_Coverage, 3824,
     /* 1622406 */     GIR_EraseRootFromParent_Done,
     /* 1622407 */   // Label 22385: @1622407
     /* 1622407 */   GIM_Try, /*On fail goto*//*Label 22386*/ GIMT_Encode4(1622493), // Rule ID 3825 //
     /* 1622412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1622415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1622420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1622423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1622426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1622429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1622432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1622454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622458 */     // MIs[0] policy
     /* 1622458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11672:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1622471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1622489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622492 */     // GIR_Coverage, 3825,
     /* 1622492 */     GIR_EraseRootFromParent_Done,
     /* 1622493 */   // Label 22386: @1622493
     /* 1622493 */   GIM_Try, /*On fail goto*//*Label 22387*/ GIMT_Encode4(1622579), // Rule ID 3828 //
     /* 1622498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1622509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1622512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1622515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1622518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622544 */     // MIs[0] policy
     /* 1622544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622554 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1622557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622578 */     // GIR_Coverage, 3828,
     /* 1622578 */     GIR_EraseRootFromParent_Done,
     /* 1622579 */   // Label 22387: @1622579
     /* 1622579 */   GIM_Try, /*On fail goto*//*Label 22388*/ GIMT_Encode4(1622665), // Rule ID 3829 //
     /* 1622584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1622595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1622598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1622601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1622604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622630 */     // MIs[0] policy
     /* 1622630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622640 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1622643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622664 */     // GIR_Coverage, 3829,
     /* 1622664 */     GIR_EraseRootFromParent_Done,
     /* 1622665 */   // Label 22388: @1622665
     /* 1622665 */   GIM_Try, /*On fail goto*//*Label 22389*/ GIMT_Encode4(1622751), // Rule ID 3832 //
     /* 1622670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1622681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1622684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1622687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1622690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622716 */     // MIs[0] policy
     /* 1622716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622726 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1622729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622750 */     // GIR_Coverage, 3832,
     /* 1622750 */     GIR_EraseRootFromParent_Done,
     /* 1622751 */   // Label 22389: @1622751
     /* 1622751 */   GIM_Try, /*On fail goto*//*Label 22390*/ GIMT_Encode4(1622837), // Rule ID 3833 //
     /* 1622756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1622767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1622770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1622773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1622776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622802 */     // MIs[0] policy
     /* 1622802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622812 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1622815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622836 */     // GIR_Coverage, 3833,
     /* 1622836 */     GIR_EraseRootFromParent_Done,
     /* 1622837 */   // Label 22390: @1622837
     /* 1622837 */   GIM_Try, /*On fail goto*//*Label 22391*/ GIMT_Encode4(1622923), // Rule ID 3836 //
     /* 1622842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1622853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1622856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1622859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1622862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622888 */     // MIs[0] policy
     /* 1622888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1622901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622922 */     // GIR_Coverage, 3836,
     /* 1622922 */     GIR_EraseRootFromParent_Done,
     /* 1622923 */   // Label 22391: @1622923
     /* 1622923 */   GIM_Try, /*On fail goto*//*Label 22392*/ GIMT_Encode4(1623009), // Rule ID 3837 //
     /* 1622928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1622936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1622939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1622942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1622945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1622948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622974 */     // MIs[0] policy
     /* 1622974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1622987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623008 */     // GIR_Coverage, 3837,
     /* 1623008 */     GIR_EraseRootFromParent_Done,
     /* 1623009 */   // Label 22392: @1623009
     /* 1623009 */   GIM_Try, /*On fail goto*//*Label 22393*/ GIMT_Encode4(1623095), // Rule ID 3840 //
     /* 1623014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1623034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623060 */     // MIs[0] policy
     /* 1623060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623070 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623094 */     // GIR_Coverage, 3840,
     /* 1623094 */     GIR_EraseRootFromParent_Done,
     /* 1623095 */   // Label 22393: @1623095
     /* 1623095 */   GIM_Try, /*On fail goto*//*Label 22394*/ GIMT_Encode4(1623181), // Rule ID 3841 //
     /* 1623100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1623111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1623114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1623117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1623120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623146 */     // MIs[0] policy
     /* 1623146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623180 */     // GIR_Coverage, 3841,
     /* 1623180 */     GIR_EraseRootFromParent_Done,
     /* 1623181 */   // Label 22394: @1623181
     /* 1623181 */   GIM_Try, /*On fail goto*//*Label 22395*/ GIMT_Encode4(1623267), // Rule ID 3844 //
     /* 1623186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1623206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623232 */     // MIs[0] policy
     /* 1623232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623242 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1623245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623266 */     // GIR_Coverage, 3844,
     /* 1623266 */     GIR_EraseRootFromParent_Done,
     /* 1623267 */   // Label 22395: @1623267
     /* 1623267 */   GIM_Try, /*On fail goto*//*Label 22396*/ GIMT_Encode4(1623353), // Rule ID 3845 //
     /* 1623272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1623283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1623286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1623289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1623292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1623295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623318 */     // MIs[0] policy
     /* 1623318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623328 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1623331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623352 */     // GIR_Coverage, 3845,
     /* 1623352 */     GIR_EraseRootFromParent_Done,
     /* 1623353 */   // Label 22396: @1623353
     /* 1623353 */   GIM_Try, /*On fail goto*//*Label 22397*/ GIMT_Encode4(1623439), // Rule ID 3848 //
     /* 1623358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1623378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623404 */     // MIs[0] policy
     /* 1623404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623414 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1623417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623438 */     // GIR_Coverage, 3848,
     /* 1623438 */     GIR_EraseRootFromParent_Done,
     /* 1623439 */   // Label 22397: @1623439
     /* 1623439 */   GIM_Try, /*On fail goto*//*Label 22398*/ GIMT_Encode4(1623525), // Rule ID 3849 //
     /* 1623444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1623455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1623458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1623461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1623464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1623467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623490 */     // MIs[0] policy
     /* 1623490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623500 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1623503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623524 */     // GIR_Coverage, 3849,
     /* 1623524 */     GIR_EraseRootFromParent_Done,
     /* 1623525 */   // Label 22398: @1623525
     /* 1623525 */   GIM_Try, /*On fail goto*//*Label 22399*/ GIMT_Encode4(1623611), // Rule ID 3852 //
     /* 1623530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1623541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1623544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1623547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1623550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623576 */     // MIs[0] policy
     /* 1623576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1623589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623610 */     // GIR_Coverage, 3852,
     /* 1623610 */     GIR_EraseRootFromParent_Done,
     /* 1623611 */   // Label 22399: @1623611
     /* 1623611 */   GIM_Try, /*On fail goto*//*Label 22400*/ GIMT_Encode4(1623697), // Rule ID 3853 //
     /* 1623616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1623627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1623630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1623633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1623636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623662 */     // MIs[0] policy
     /* 1623662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1623675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623696 */     // GIR_Coverage, 3853,
     /* 1623696 */     GIR_EraseRootFromParent_Done,
     /* 1623697 */   // Label 22400: @1623697
     /* 1623697 */   GIM_Try, /*On fail goto*//*Label 22401*/ GIMT_Encode4(1623783), // Rule ID 3856 //
     /* 1623702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1623713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1623716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1623719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1623722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623748 */     // MIs[0] policy
     /* 1623748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1623761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623782 */     // GIR_Coverage, 3856,
     /* 1623782 */     GIR_EraseRootFromParent_Done,
     /* 1623783 */   // Label 22401: @1623783
     /* 1623783 */   GIM_Try, /*On fail goto*//*Label 22402*/ GIMT_Encode4(1623869), // Rule ID 3857 //
     /* 1623788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1623799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1623802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1623805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1623808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623834 */     // MIs[0] policy
     /* 1623834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1623847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623868 */     // GIR_Coverage, 3857,
     /* 1623868 */     GIR_EraseRootFromParent_Done,
     /* 1623869 */   // Label 22402: @1623869
     /* 1623869 */   GIM_Try, /*On fail goto*//*Label 22403*/ GIMT_Encode4(1623955), // Rule ID 3860 //
     /* 1623874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1623885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1623888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1623891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1623894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623920 */     // MIs[0] policy
     /* 1623920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1623933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1623951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623954 */     // GIR_Coverage, 3860,
     /* 1623954 */     GIR_EraseRootFromParent_Done,
     /* 1623955 */   // Label 22403: @1623955
     /* 1623955 */   GIM_Try, /*On fail goto*//*Label 22404*/ GIMT_Encode4(1624041), // Rule ID 3861 //
     /* 1623960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1623968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1623971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1623974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1623977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1623980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624006 */     // MIs[0] policy
     /* 1624006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624016 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624040 */     // GIR_Coverage, 3861,
     /* 1624040 */     GIR_EraseRootFromParent_Done,
     /* 1624041 */   // Label 22404: @1624041
     /* 1624041 */   GIM_Try, /*On fail goto*//*Label 22405*/ GIMT_Encode4(1624127), // Rule ID 3864 //
     /* 1624046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1624066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624092 */     // MIs[0] policy
     /* 1624092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624126 */     // GIR_Coverage, 3864,
     /* 1624126 */     GIR_EraseRootFromParent_Done,
     /* 1624127 */   // Label 22405: @1624127
     /* 1624127 */   GIM_Try, /*On fail goto*//*Label 22406*/ GIMT_Encode4(1624213), // Rule ID 3865 //
     /* 1624132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1624143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1624146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1624149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1624152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624178 */     // MIs[0] policy
     /* 1624178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624188 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624212 */     // GIR_Coverage, 3865,
     /* 1624212 */     GIR_EraseRootFromParent_Done,
     /* 1624213 */   // Label 22406: @1624213
     /* 1624213 */   GIM_Try, /*On fail goto*//*Label 22407*/ GIMT_Encode4(1624299), // Rule ID 3868 //
     /* 1624218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1624238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624264 */     // MIs[0] policy
     /* 1624264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624298 */     // GIR_Coverage, 3868,
     /* 1624298 */     GIR_EraseRootFromParent_Done,
     /* 1624299 */   // Label 22407: @1624299
     /* 1624299 */   GIM_Try, /*On fail goto*//*Label 22408*/ GIMT_Encode4(1624385), // Rule ID 3869 //
     /* 1624304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1624315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1624318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1624321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1624324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624350 */     // MIs[0] policy
     /* 1624350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624360 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624384 */     // GIR_Coverage, 3869,
     /* 1624384 */     GIR_EraseRootFromParent_Done,
     /* 1624385 */   // Label 22408: @1624385
     /* 1624385 */   GIM_Try, /*On fail goto*//*Label 22409*/ GIMT_Encode4(1624471), // Rule ID 3872 //
     /* 1624390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624436 */     // MIs[0] policy
     /* 1624436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624470 */     // GIR_Coverage, 3872,
     /* 1624470 */     GIR_EraseRootFromParent_Done,
     /* 1624471 */   // Label 22409: @1624471
     /* 1624471 */   GIM_Try, /*On fail goto*//*Label 22410*/ GIMT_Encode4(1624557), // Rule ID 3873 //
     /* 1624476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1624487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1624490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1624493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1624496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624522 */     // MIs[0] policy
     /* 1624522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624532 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1624535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624556 */     // GIR_Coverage, 3873,
     /* 1624556 */     GIR_EraseRootFromParent_Done,
     /* 1624557 */   // Label 22410: @1624557
     /* 1624557 */   GIM_Try, /*On fail goto*//*Label 22411*/ GIMT_Encode4(1624643), // Rule ID 3876 //
     /* 1624562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1624573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1624576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1624579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1624582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624608 */     // MIs[0] policy
     /* 1624608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624618 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624642 */     // GIR_Coverage, 3876,
     /* 1624642 */     GIR_EraseRootFromParent_Done,
     /* 1624643 */   // Label 22411: @1624643
     /* 1624643 */   GIM_Try, /*On fail goto*//*Label 22412*/ GIMT_Encode4(1624729), // Rule ID 3877 //
     /* 1624648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1624659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1624662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1624665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1624668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624694 */     // MIs[0] policy
     /* 1624694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624704 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1624707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624728 */     // GIR_Coverage, 3877,
     /* 1624728 */     GIR_EraseRootFromParent_Done,
     /* 1624729 */   // Label 22412: @1624729
     /* 1624729 */   GIM_Try, /*On fail goto*//*Label 22413*/ GIMT_Encode4(1624815), // Rule ID 3880 //
     /* 1624734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1624745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1624748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1624751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1624754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624780 */     // MIs[0] policy
     /* 1624780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624790 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624814 */     // GIR_Coverage, 3880,
     /* 1624814 */     GIR_EraseRootFromParent_Done,
     /* 1624815 */   // Label 22413: @1624815
     /* 1624815 */   GIM_Try, /*On fail goto*//*Label 22414*/ GIMT_Encode4(1624901), // Rule ID 3881 //
     /* 1624820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1624831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1624834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1624837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1624840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624866 */     // MIs[0] policy
     /* 1624866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624876 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1624879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624900 */     // GIR_Coverage, 3881,
     /* 1624900 */     GIR_EraseRootFromParent_Done,
     /* 1624901 */   // Label 22414: @1624901
     /* 1624901 */   GIM_Try, /*On fail goto*//*Label 22415*/ GIMT_Encode4(1624987), // Rule ID 3884 //
     /* 1624906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1624909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1624914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1624917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1624920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1624923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1624926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624952 */     // MIs[0] policy
     /* 1624952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624962 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1624965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1624983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624986 */     // GIR_Coverage, 3884,
     /* 1624986 */     GIR_EraseRootFromParent_Done,
     /* 1624987 */   // Label 22415: @1624987
     /* 1624987 */   GIM_Try, /*On fail goto*//*Label 22416*/ GIMT_Encode4(1625073), // Rule ID 3885 //
     /* 1624992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1624995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1625003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1625006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1625009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1625012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625038 */     // MIs[0] policy
     /* 1625038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625048 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1625051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625072 */     // GIR_Coverage, 3885,
     /* 1625072 */     GIR_EraseRootFromParent_Done,
     /* 1625073 */   // Label 22416: @1625073
     /* 1625073 */   GIM_Try, /*On fail goto*//*Label 22417*/ GIMT_Encode4(1625159), // Rule ID 3888 //
     /* 1625078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625124 */     // MIs[0] policy
     /* 1625124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625134 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1625137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625158 */     // GIR_Coverage, 3888,
     /* 1625158 */     GIR_EraseRootFromParent_Done,
     /* 1625159 */   // Label 22417: @1625159
     /* 1625159 */   GIM_Try, /*On fail goto*//*Label 22418*/ GIMT_Encode4(1625245), // Rule ID 3889 //
     /* 1625164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1625175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1625178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1625181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625210 */     // MIs[0] policy
     /* 1625210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625220 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1625223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625244 */     // GIR_Coverage, 3889,
     /* 1625244 */     GIR_EraseRootFromParent_Done,
     /* 1625245 */   // Label 22418: @1625245
     /* 1625245 */   GIM_Try, /*On fail goto*//*Label 22419*/ GIMT_Encode4(1625331), // Rule ID 3892 //
     /* 1625250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625296 */     // MIs[0] policy
     /* 1625296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625306 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1625309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625330 */     // GIR_Coverage, 3892,
     /* 1625330 */     GIR_EraseRootFromParent_Done,
     /* 1625331 */   // Label 22419: @1625331
     /* 1625331 */   GIM_Try, /*On fail goto*//*Label 22420*/ GIMT_Encode4(1625417), // Rule ID 3893 //
     /* 1625336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1625347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1625350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1625353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625382 */     // MIs[0] policy
     /* 1625382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625392 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1625395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625416 */     // GIR_Coverage, 3893,
     /* 1625416 */     GIR_EraseRootFromParent_Done,
     /* 1625417 */   // Label 22420: @1625417
     /* 1625417 */   GIM_Try, /*On fail goto*//*Label 22421*/ GIMT_Encode4(1625503), // Rule ID 3896 //
     /* 1625422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625468 */     // MIs[0] policy
     /* 1625468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1625481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625502 */     // GIR_Coverage, 3896,
     /* 1625502 */     GIR_EraseRootFromParent_Done,
     /* 1625503 */   // Label 22421: @1625503
     /* 1625503 */   GIM_Try, /*On fail goto*//*Label 22422*/ GIMT_Encode4(1625589), // Rule ID 3897 //
     /* 1625508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1625519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1625522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1625525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625554 */     // MIs[0] policy
     /* 1625554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11640:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1625567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625588 */     // GIR_Coverage, 3897,
     /* 1625588 */     GIR_EraseRootFromParent_Done,
     /* 1625589 */   // Label 22422: @1625589
     /* 1625589 */   GIM_Try, /*On fail goto*//*Label 22423*/ GIMT_Encode4(1625675), // Rule ID 3900 //
     /* 1625594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1625605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1625608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1625611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625640 */     // MIs[0] policy
     /* 1625640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1625653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625674 */     // GIR_Coverage, 3900,
     /* 1625674 */     GIR_EraseRootFromParent_Done,
     /* 1625675 */   // Label 22423: @1625675
     /* 1625675 */   GIM_Try, /*On fail goto*//*Label 22424*/ GIMT_Encode4(1625761), // Rule ID 3901 //
     /* 1625680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1625691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1625694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1625697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625726 */     // MIs[0] policy
     /* 1625726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1625739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625760 */     // GIR_Coverage, 3901,
     /* 1625760 */     GIR_EraseRootFromParent_Done,
     /* 1625761 */   // Label 22424: @1625761
     /* 1625761 */   GIM_Try, /*On fail goto*//*Label 22425*/ GIMT_Encode4(1625847), // Rule ID 3904 //
     /* 1625766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1625777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1625780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1625783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625812 */     // MIs[0] policy
     /* 1625812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625822 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1625825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625846 */     // GIR_Coverage, 3904,
     /* 1625846 */     GIR_EraseRootFromParent_Done,
     /* 1625847 */   // Label 22425: @1625847
     /* 1625847 */   GIM_Try, /*On fail goto*//*Label 22426*/ GIMT_Encode4(1625933), // Rule ID 3905 //
     /* 1625852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1625863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1625866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1625869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625898 */     // MIs[0] policy
     /* 1625898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625908 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1625911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1625929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625932 */     // GIR_Coverage, 3905,
     /* 1625932 */     GIR_EraseRootFromParent_Done,
     /* 1625933 */   // Label 22426: @1625933
     /* 1625933 */   GIM_Try, /*On fail goto*//*Label 22427*/ GIMT_Encode4(1626019), // Rule ID 3908 //
     /* 1625938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1625946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1625949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1625952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1625955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1625961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625984 */     // MIs[0] policy
     /* 1625984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1625997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626018 */     // GIR_Coverage, 3908,
     /* 1626018 */     GIR_EraseRootFromParent_Done,
     /* 1626019 */   // Label 22427: @1626019
     /* 1626019 */   GIM_Try, /*On fail goto*//*Label 22428*/ GIMT_Encode4(1626105), // Rule ID 3909 //
     /* 1626024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1626041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626070 */     // MIs[0] policy
     /* 1626070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626080 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626104 */     // GIR_Coverage, 3909,
     /* 1626104 */     GIR_EraseRootFromParent_Done,
     /* 1626105 */   // Label 22428: @1626105
     /* 1626105 */   GIM_Try, /*On fail goto*//*Label 22429*/ GIMT_Encode4(1626191), // Rule ID 3912 //
     /* 1626110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626156 */     // MIs[0] policy
     /* 1626156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626166 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1626169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626190 */     // GIR_Coverage, 3912,
     /* 1626190 */     GIR_EraseRootFromParent_Done,
     /* 1626191 */   // Label 22429: @1626191
     /* 1626191 */   GIM_Try, /*On fail goto*//*Label 22430*/ GIMT_Encode4(1626277), // Rule ID 3913 //
     /* 1626196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1626207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1626210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1626213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626242 */     // MIs[0] policy
     /* 1626242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626252 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1626255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626276 */     // GIR_Coverage, 3913,
     /* 1626276 */     GIR_EraseRootFromParent_Done,
     /* 1626277 */   // Label 22430: @1626277
     /* 1626277 */   GIM_Try, /*On fail goto*//*Label 22431*/ GIMT_Encode4(1626363), // Rule ID 3916 //
     /* 1626282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626328 */     // MIs[0] policy
     /* 1626328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626362 */     // GIR_Coverage, 3916,
     /* 1626362 */     GIR_EraseRootFromParent_Done,
     /* 1626363 */   // Label 22431: @1626363
     /* 1626363 */   GIM_Try, /*On fail goto*//*Label 22432*/ GIMT_Encode4(1626449), // Rule ID 3917 //
     /* 1626368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1626379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1626382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626414 */     // MIs[0] policy
     /* 1626414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626424 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11640:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1626427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626448 */     // GIR_Coverage, 3917,
     /* 1626448 */     GIR_EraseRootFromParent_Done,
     /* 1626449 */   // Label 22432: @1626449
     /* 1626449 */   GIM_Try, /*On fail goto*//*Label 22433*/ GIMT_Encode4(1626535), // Rule ID 3920 //
     /* 1626454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626500 */     // MIs[0] policy
     /* 1626500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626534 */     // GIR_Coverage, 3920,
     /* 1626534 */     GIR_EraseRootFromParent_Done,
     /* 1626535 */   // Label 22433: @1626535
     /* 1626535 */   GIM_Try, /*On fail goto*//*Label 22434*/ GIMT_Encode4(1626621), // Rule ID 3921 //
     /* 1626540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1626551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1626554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626586 */     // MIs[0] policy
     /* 1626586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626596 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1626599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626620 */     // GIR_Coverage, 3921,
     /* 1626620 */     GIR_EraseRootFromParent_Done,
     /* 1626621 */   // Label 22434: @1626621
     /* 1626621 */   GIM_Try, /*On fail goto*//*Label 22435*/ GIMT_Encode4(1626707), // Rule ID 3924 //
     /* 1626626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1626637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1626640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1626643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626672 */     // MIs[0] policy
     /* 1626672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626682 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1626685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626706 */     // GIR_Coverage, 3924,
     /* 1626706 */     GIR_EraseRootFromParent_Done,
     /* 1626707 */   // Label 22435: @1626707
     /* 1626707 */   GIM_Try, /*On fail goto*//*Label 22436*/ GIMT_Encode4(1626793), // Rule ID 3925 //
     /* 1626712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1626723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1626726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1626729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626758 */     // MIs[0] policy
     /* 1626758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626768 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1626771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626792 */     // GIR_Coverage, 3925,
     /* 1626792 */     GIR_EraseRootFromParent_Done,
     /* 1626793 */   // Label 22436: @1626793
     /* 1626793 */   GIM_Try, /*On fail goto*//*Label 22437*/ GIMT_Encode4(1626879), // Rule ID 3928 //
     /* 1626798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1626809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1626812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1626815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626844 */     // MIs[0] policy
     /* 1626844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626854 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626878 */     // GIR_Coverage, 3928,
     /* 1626878 */     GIR_EraseRootFromParent_Done,
     /* 1626879 */   // Label 22437: @1626879
     /* 1626879 */   GIM_Try, /*On fail goto*//*Label 22438*/ GIMT_Encode4(1626965), // Rule ID 3929 //
     /* 1626884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1626895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1626898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1626901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626930 */     // MIs[0] policy
     /* 1626930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1626943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1626961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626964 */     // GIR_Coverage, 3929,
     /* 1626964 */     GIR_EraseRootFromParent_Done,
     /* 1626965 */   // Label 22438: @1626965
     /* 1626965 */   GIM_Try, /*On fail goto*//*Label 22439*/ GIMT_Encode4(1627051), // Rule ID 3932 //
     /* 1626970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1626973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1626978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1626981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1626984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1626987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1626993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627016 */     // MIs[0] policy
     /* 1627016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1627029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627050 */     // GIR_Coverage, 3932,
     /* 1627050 */     GIR_EraseRootFromParent_Done,
     /* 1627051 */   // Label 22439: @1627051
     /* 1627051 */   GIM_Try, /*On fail goto*//*Label 22440*/ GIMT_Encode4(1627137), // Rule ID 3933 //
     /* 1627056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1627067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1627070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627102 */     // MIs[0] policy
     /* 1627102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627112 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11640:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1627115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627136 */     // GIR_Coverage, 3933,
     /* 1627136 */     GIR_EraseRootFromParent_Done,
     /* 1627137 */   // Label 22440: @1627137
     /* 1627137 */   GIM_Try, /*On fail goto*//*Label 22441*/ GIMT_Encode4(1627223), // Rule ID 3936 //
     /* 1627142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627188 */     // MIs[0] policy
     /* 1627188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627222 */     // GIR_Coverage, 3936,
     /* 1627222 */     GIR_EraseRootFromParent_Done,
     /* 1627223 */   // Label 22441: @1627223
     /* 1627223 */   GIM_Try, /*On fail goto*//*Label 22442*/ GIMT_Encode4(1627309), // Rule ID 3937 //
     /* 1627228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1627239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1627242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627274 */     // MIs[0] policy
     /* 1627274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627284 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11640:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1627287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627308 */     // GIR_Coverage, 3937,
     /* 1627308 */     GIR_EraseRootFromParent_Done,
     /* 1627309 */   // Label 22442: @1627309
     /* 1627309 */   GIM_Try, /*On fail goto*//*Label 22443*/ GIMT_Encode4(1627395), // Rule ID 3940 //
     /* 1627314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627360 */     // MIs[0] policy
     /* 1627360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627370 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627394 */     // GIR_Coverage, 3940,
     /* 1627394 */     GIR_EraseRootFromParent_Done,
     /* 1627395 */   // Label 22443: @1627395
     /* 1627395 */   GIM_Try, /*On fail goto*//*Label 22444*/ GIMT_Encode4(1627481), // Rule ID 3941 //
     /* 1627400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1627411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1627414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627446 */     // MIs[0] policy
     /* 1627446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627456 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11640:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1627459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627480 */     // GIR_Coverage, 3941,
     /* 1627480 */     GIR_EraseRootFromParent_Done,
     /* 1627481 */   // Label 22444: @1627481
     /* 1627481 */   GIM_Try, /*On fail goto*//*Label 22445*/ GIMT_Encode4(1627567), // Rule ID 3944 //
     /* 1627486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1627506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627532 */     // MIs[0] policy
     /* 1627532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1627545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627566 */     // GIR_Coverage, 3944,
     /* 1627566 */     GIR_EraseRootFromParent_Done,
     /* 1627567 */   // Label 22445: @1627567
     /* 1627567 */   GIM_Try, /*On fail goto*//*Label 22446*/ GIMT_Encode4(1627653), // Rule ID 3945 //
     /* 1627572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1627575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1627580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1627583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1627586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1627592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1627614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627618 */     // MIs[0] policy
     /* 1627618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627628 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11640:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1627631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1627649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627652 */     // GIR_Coverage, 3945,
     /* 1627652 */     GIR_EraseRootFromParent_Done,
     /* 1627653 */   // Label 22446: @1627653
     /* 1627653 */   GIM_Try, /*On fail goto*//*Label 22447*/ GIMT_Encode4(1627739), // Rule ID 3948 //
     /* 1627658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1627669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1627672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1627675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1627678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627704 */     // MIs[0] policy
     /* 1627704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627714 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1627717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627738 */     // GIR_Coverage, 3948,
     /* 1627738 */     GIR_EraseRootFromParent_Done,
     /* 1627739 */   // Label 22447: @1627739
     /* 1627739 */   GIM_Try, /*On fail goto*//*Label 22448*/ GIMT_Encode4(1627825), // Rule ID 3949 //
     /* 1627744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1627755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1627758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1627761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1627764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627790 */     // MIs[0] policy
     /* 1627790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627800 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1627803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627824 */     // GIR_Coverage, 3949,
     /* 1627824 */     GIR_EraseRootFromParent_Done,
     /* 1627825 */   // Label 22448: @1627825
     /* 1627825 */   GIM_Try, /*On fail goto*//*Label 22449*/ GIMT_Encode4(1627911), // Rule ID 3952 //
     /* 1627830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1627841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1627844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1627847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1627850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627876 */     // MIs[0] policy
     /* 1627876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627886 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1627889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627910 */     // GIR_Coverage, 3952,
     /* 1627910 */     GIR_EraseRootFromParent_Done,
     /* 1627911 */   // Label 22449: @1627911
     /* 1627911 */   GIM_Try, /*On fail goto*//*Label 22450*/ GIMT_Encode4(1627997), // Rule ID 3953 //
     /* 1627916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1627924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1627927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1627930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1627933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1627936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627962 */     // MIs[0] policy
     /* 1627962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627972 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1627975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627996 */     // GIR_Coverage, 3953,
     /* 1627996 */     GIR_EraseRootFromParent_Done,
     /* 1627997 */   // Label 22450: @1627997
     /* 1627997 */   GIM_Try, /*On fail goto*//*Label 22451*/ GIMT_Encode4(1628083), // Rule ID 3956 //
     /* 1628002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1628022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628048 */     // MIs[0] policy
     /* 1628048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628082 */     // GIR_Coverage, 3956,
     /* 1628082 */     GIR_EraseRootFromParent_Done,
     /* 1628083 */   // Label 22451: @1628083
     /* 1628083 */   GIM_Try, /*On fail goto*//*Label 22452*/ GIMT_Encode4(1628169), // Rule ID 3957 //
     /* 1628088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1628105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1628108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628134 */     // MIs[0] policy
     /* 1628134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628144 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628168 */     // GIR_Coverage, 3957,
     /* 1628168 */     GIR_EraseRootFromParent_Done,
     /* 1628169 */   // Label 22452: @1628169
     /* 1628169 */   GIM_Try, /*On fail goto*//*Label 22453*/ GIMT_Encode4(1628255), // Rule ID 3960 //
     /* 1628174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1628194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628220 */     // MIs[0] policy
     /* 1628220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1628233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628254 */     // GIR_Coverage, 3960,
     /* 1628254 */     GIR_EraseRootFromParent_Done,
     /* 1628255 */   // Label 22453: @1628255
     /* 1628255 */   GIM_Try, /*On fail goto*//*Label 22454*/ GIMT_Encode4(1628341), // Rule ID 3961 //
     /* 1628260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1628271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1628274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1628277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1628280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628306 */     // MIs[0] policy
     /* 1628306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1628319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628340 */     // GIR_Coverage, 3961,
     /* 1628340 */     GIR_EraseRootFromParent_Done,
     /* 1628341 */   // Label 22454: @1628341
     /* 1628341 */   GIM_Try, /*On fail goto*//*Label 22455*/ GIMT_Encode4(1628427), // Rule ID 3964 //
     /* 1628346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1628366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628392 */     // MIs[0] policy
     /* 1628392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1628405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628426 */     // GIR_Coverage, 3964,
     /* 1628426 */     GIR_EraseRootFromParent_Done,
     /* 1628427 */   // Label 22455: @1628427
     /* 1628427 */   GIM_Try, /*On fail goto*//*Label 22456*/ GIMT_Encode4(1628513), // Rule ID 3965 //
     /* 1628432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1628443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1628446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1628449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1628452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1628455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628478 */     // MIs[0] policy
     /* 1628478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1628491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628512 */     // GIR_Coverage, 3965,
     /* 1628512 */     GIR_EraseRootFromParent_Done,
     /* 1628513 */   // Label 22456: @1628513
     /* 1628513 */   GIM_Try, /*On fail goto*//*Label 22457*/ GIMT_Encode4(1628599), // Rule ID 3968 //
     /* 1628518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1628529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1628532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1628535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1628538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1628541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628564 */     // MIs[0] policy
     /* 1628564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628574 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1628577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628598 */     // GIR_Coverage, 3968,
     /* 1628598 */     GIR_EraseRootFromParent_Done,
     /* 1628599 */   // Label 22457: @1628599
     /* 1628599 */   GIM_Try, /*On fail goto*//*Label 22458*/ GIMT_Encode4(1628685), // Rule ID 3969 //
     /* 1628604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1628615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1628618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1628621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1628624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1628627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628650 */     // MIs[0] policy
     /* 1628650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1628663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628684 */     // GIR_Coverage, 3969,
     /* 1628684 */     GIR_EraseRootFromParent_Done,
     /* 1628685 */   // Label 22458: @1628685
     /* 1628685 */   GIM_Try, /*On fail goto*//*Label 22459*/ GIMT_Encode4(1628771), // Rule ID 3972 //
     /* 1628690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1628701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1628704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1628707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1628710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628736 */     // MIs[0] policy
     /* 1628736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1628749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628770 */     // GIR_Coverage, 3972,
     /* 1628770 */     GIR_EraseRootFromParent_Done,
     /* 1628771 */   // Label 22459: @1628771
     /* 1628771 */   GIM_Try, /*On fail goto*//*Label 22460*/ GIMT_Encode4(1628857), // Rule ID 3973 //
     /* 1628776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1628787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1628790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1628793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1628796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628822 */     // MIs[0] policy
     /* 1628822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628832 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1628835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628856 */     // GIR_Coverage, 3973,
     /* 1628856 */     GIR_EraseRootFromParent_Done,
     /* 1628857 */   // Label 22460: @1628857
     /* 1628857 */   GIM_Try, /*On fail goto*//*Label 22461*/ GIMT_Encode4(1628943), // Rule ID 3976 //
     /* 1628862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1628873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1628876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1628879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1628882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628908 */     // MIs[0] policy
     /* 1628908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1628921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1628939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628942 */     // GIR_Coverage, 3976,
     /* 1628942 */     GIR_EraseRootFromParent_Done,
     /* 1628943 */   // Label 22461: @1628943
     /* 1628943 */   GIM_Try, /*On fail goto*//*Label 22462*/ GIMT_Encode4(1629029), // Rule ID 3977 //
     /* 1628948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1628956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1628959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1628962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1628965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1628968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628994 */     // MIs[0] policy
     /* 1628994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629004 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629028 */     // GIR_Coverage, 3977,
     /* 1629028 */     GIR_EraseRootFromParent_Done,
     /* 1629029 */   // Label 22462: @1629029
     /* 1629029 */   GIM_Try, /*On fail goto*//*Label 22463*/ GIMT_Encode4(1629115), // Rule ID 3980 //
     /* 1629034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1629054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629080 */     // MIs[0] policy
     /* 1629080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629114 */     // GIR_Coverage, 3980,
     /* 1629114 */     GIR_EraseRootFromParent_Done,
     /* 1629115 */   // Label 22463: @1629115
     /* 1629115 */   GIM_Try, /*On fail goto*//*Label 22464*/ GIMT_Encode4(1629201), // Rule ID 3981 //
     /* 1629120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1629131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1629134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1629140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629166 */     // MIs[0] policy
     /* 1629166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629200 */     // GIR_Coverage, 3981,
     /* 1629200 */     GIR_EraseRootFromParent_Done,
     /* 1629201 */   // Label 22464: @1629201
     /* 1629201 */   GIM_Try, /*On fail goto*//*Label 22465*/ GIMT_Encode4(1629287), // Rule ID 3984 //
     /* 1629206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1629226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629252 */     // MIs[0] policy
     /* 1629252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629262 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629286 */     // GIR_Coverage, 3984,
     /* 1629286 */     GIR_EraseRootFromParent_Done,
     /* 1629287 */   // Label 22465: @1629287
     /* 1629287 */   GIM_Try, /*On fail goto*//*Label 22466*/ GIMT_Encode4(1629373), // Rule ID 3985 //
     /* 1629292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1629303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1629306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1629312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629338 */     // MIs[0] policy
     /* 1629338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629372 */     // GIR_Coverage, 3985,
     /* 1629372 */     GIR_EraseRootFromParent_Done,
     /* 1629373 */   // Label 22466: @1629373
     /* 1629373 */   GIM_Try, /*On fail goto*//*Label 22467*/ GIMT_Encode4(1629459), // Rule ID 3988 //
     /* 1629378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1629398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629424 */     // MIs[0] policy
     /* 1629424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629458 */     // GIR_Coverage, 3988,
     /* 1629458 */     GIR_EraseRootFromParent_Done,
     /* 1629459 */   // Label 22467: @1629459
     /* 1629459 */   GIM_Try, /*On fail goto*//*Label 22468*/ GIMT_Encode4(1629545), // Rule ID 3989 //
     /* 1629464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1629475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1629478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1629484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629510 */     // MIs[0] policy
     /* 1629510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1629523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629544 */     // GIR_Coverage, 3989,
     /* 1629544 */     GIR_EraseRootFromParent_Done,
     /* 1629545 */   // Label 22468: @1629545
     /* 1629545 */   GIM_Try, /*On fail goto*//*Label 22469*/ GIMT_Encode4(1629631), // Rule ID 3992 //
     /* 1629550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1629553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1629561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1629564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1629567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1629570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629596 */     // MIs[0] policy
     /* 1629596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629630 */     // GIR_Coverage, 3992,
     /* 1629630 */     GIR_EraseRootFromParent_Done,
     /* 1629631 */   // Label 22469: @1629631
     /* 1629631 */   GIM_Try, /*On fail goto*//*Label 22470*/ GIMT_Encode4(1629717), // Rule ID 3993 //
     /* 1629636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1629639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1629647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1629650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1629653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1629656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629682 */     // MIs[0] policy
     /* 1629682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1629695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629716 */     // GIR_Coverage, 3993,
     /* 1629716 */     GIR_EraseRootFromParent_Done,
     /* 1629717 */   // Label 22470: @1629717
     /* 1629717 */   GIM_Try, /*On fail goto*//*Label 22471*/ GIMT_Encode4(1629803), // Rule ID 3996 //
     /* 1629722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1629725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1629733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1629736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1629739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1629742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629768 */     // MIs[0] policy
     /* 1629768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629802 */     // GIR_Coverage, 3996,
     /* 1629802 */     GIR_EraseRootFromParent_Done,
     /* 1629803 */   // Label 22471: @1629803
     /* 1629803 */   GIM_Try, /*On fail goto*//*Label 22472*/ GIMT_Encode4(1629889), // Rule ID 3997 //
     /* 1629808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1629811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1629819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1629822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1629825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1629828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629854 */     // MIs[0] policy
     /* 1629854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1629867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629888 */     // GIR_Coverage, 3997,
     /* 1629888 */     GIR_EraseRootFromParent_Done,
     /* 1629889 */   // Label 22472: @1629889
     /* 1629889 */   GIM_Try, /*On fail goto*//*Label 22473*/ GIMT_Encode4(1629975), // Rule ID 4000 //
     /* 1629894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1629897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1629905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1629908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1629911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1629914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629940 */     // MIs[0] policy
     /* 1629940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1629953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1629971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629974 */     // GIR_Coverage, 4000,
     /* 1629974 */     GIR_EraseRootFromParent_Done,
     /* 1629975 */   // Label 22473: @1629975
     /* 1629975 */   GIM_Try, /*On fail goto*//*Label 22474*/ GIMT_Encode4(1630061), // Rule ID 4001 //
     /* 1629980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1629983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1629988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1629991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1629994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1629997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1630000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630026 */     // MIs[0] policy
     /* 1630026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1630039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630060 */     // GIR_Coverage, 4001,
     /* 1630060 */     GIR_EraseRootFromParent_Done,
     /* 1630061 */   // Label 22474: @1630061
     /* 1630061 */   GIM_Try, /*On fail goto*//*Label 22475*/ GIMT_Encode4(1630147), // Rule ID 4004 //
     /* 1630066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1630086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630112 */     // MIs[0] policy
     /* 1630112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1630125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630146 */     // GIR_Coverage, 4004,
     /* 1630146 */     GIR_EraseRootFromParent_Done,
     /* 1630147 */   // Label 22475: @1630147
     /* 1630147 */   GIM_Try, /*On fail goto*//*Label 22476*/ GIMT_Encode4(1630233), // Rule ID 4005 //
     /* 1630152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1630163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1630166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1630172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630198 */     // MIs[0] policy
     /* 1630198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1630211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630232 */     // GIR_Coverage, 4005,
     /* 1630232 */     GIR_EraseRootFromParent_Done,
     /* 1630233 */   // Label 22476: @1630233
     /* 1630233 */   GIM_Try, /*On fail goto*//*Label 22477*/ GIMT_Encode4(1630319), // Rule ID 4008 //
     /* 1630238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1630249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1630252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1630255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630284 */     // MIs[0] policy
     /* 1630284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1630297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630318 */     // GIR_Coverage, 4008,
     /* 1630318 */     GIR_EraseRootFromParent_Done,
     /* 1630319 */   // Label 22477: @1630319
     /* 1630319 */   GIM_Try, /*On fail goto*//*Label 22478*/ GIMT_Encode4(1630405), // Rule ID 4009 //
     /* 1630324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1630335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1630338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1630341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630370 */     // MIs[0] policy
     /* 1630370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1630383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630404 */     // GIR_Coverage, 4009,
     /* 1630404 */     GIR_EraseRootFromParent_Done,
     /* 1630405 */   // Label 22478: @1630405
     /* 1630405 */   GIM_Try, /*On fail goto*//*Label 22479*/ GIMT_Encode4(1630491), // Rule ID 4012 //
     /* 1630410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1630427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630456 */     // MIs[0] policy
     /* 1630456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630466 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1630469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630490 */     // GIR_Coverage, 4012,
     /* 1630490 */     GIR_EraseRootFromParent_Done,
     /* 1630491 */   // Label 22479: @1630491
     /* 1630491 */   GIM_Try, /*On fail goto*//*Label 22480*/ GIMT_Encode4(1630577), // Rule ID 4013 //
     /* 1630496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1630507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1630510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1630513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630542 */     // MIs[0] policy
     /* 1630542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1630555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630576 */     // GIR_Coverage, 4013,
     /* 1630576 */     GIR_EraseRootFromParent_Done,
     /* 1630577 */   // Label 22480: @1630577
     /* 1630577 */   GIM_Try, /*On fail goto*//*Label 22481*/ GIMT_Encode4(1630663), // Rule ID 4016 //
     /* 1630582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1630593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1630596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1630599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630628 */     // MIs[0] policy
     /* 1630628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630638 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1630641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630662 */     // GIR_Coverage, 4016,
     /* 1630662 */     GIR_EraseRootFromParent_Done,
     /* 1630663 */   // Label 22481: @1630663
     /* 1630663 */   GIM_Try, /*On fail goto*//*Label 22482*/ GIMT_Encode4(1630749), // Rule ID 4017 //
     /* 1630668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1630679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1630682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1630685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630714 */     // MIs[0] policy
     /* 1630714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630724 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11668:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1630727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630748 */     // GIR_Coverage, 4017,
     /* 1630748 */     GIR_EraseRootFromParent_Done,
     /* 1630749 */   // Label 22482: @1630749
     /* 1630749 */   GIM_Try, /*On fail goto*//*Label 22483*/ GIMT_Encode4(1630835), // Rule ID 4020 //
     /* 1630754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1630765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1630768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1630771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630800 */     // MIs[0] policy
     /* 1630800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1630813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630834 */     // GIR_Coverage, 4020,
     /* 1630834 */     GIR_EraseRootFromParent_Done,
     /* 1630835 */   // Label 22483: @1630835
     /* 1630835 */   GIM_Try, /*On fail goto*//*Label 22484*/ GIMT_Encode4(1630921), // Rule ID 4021 //
     /* 1630840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1630851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1630854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1630857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630886 */     // MIs[0] policy
     /* 1630886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1630899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1630917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630920 */     // GIR_Coverage, 4021,
     /* 1630920 */     GIR_EraseRootFromParent_Done,
     /* 1630921 */   // Label 22484: @1630921
     /* 1630921 */   GIM_Try, /*On fail goto*//*Label 22485*/ GIMT_Encode4(1631007), // Rule ID 4024 //
     /* 1630926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1630934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1630937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1630940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1630943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1630949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630972 */     // MIs[0] policy
     /* 1630972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630982 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1630985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631006 */     // GIR_Coverage, 4024,
     /* 1631006 */     GIR_EraseRootFromParent_Done,
     /* 1631007 */   // Label 22485: @1631007
     /* 1631007 */   GIM_Try, /*On fail goto*//*Label 22486*/ GIMT_Encode4(1631093), // Rule ID 4025 //
     /* 1631012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1631023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1631026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1631029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631058 */     // MIs[0] policy
     /* 1631058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631068 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631092 */     // GIR_Coverage, 4025,
     /* 1631092 */     GIR_EraseRootFromParent_Done,
     /* 1631093 */   // Label 22486: @1631093
     /* 1631093 */   GIM_Try, /*On fail goto*//*Label 22487*/ GIMT_Encode4(1631179), // Rule ID 4028 //
     /* 1631098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1631115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631144 */     // MIs[0] policy
     /* 1631144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631154 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1631157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631178 */     // GIR_Coverage, 4028,
     /* 1631178 */     GIR_EraseRootFromParent_Done,
     /* 1631179 */   // Label 22487: @1631179
     /* 1631179 */   GIM_Try, /*On fail goto*//*Label 22488*/ GIMT_Encode4(1631265), // Rule ID 4029 //
     /* 1631184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1631195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1631198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1631201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1631207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631230 */     // MIs[0] policy
     /* 1631230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631240 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1631243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631264 */     // GIR_Coverage, 4029,
     /* 1631264 */     GIR_EraseRootFromParent_Done,
     /* 1631265 */   // Label 22488: @1631265
     /* 1631265 */   GIM_Try, /*On fail goto*//*Label 22489*/ GIMT_Encode4(1631351), // Rule ID 4032 //
     /* 1631270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631316 */     // MIs[0] policy
     /* 1631316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631350 */     // GIR_Coverage, 4032,
     /* 1631350 */     GIR_EraseRootFromParent_Done,
     /* 1631351 */   // Label 22489: @1631351
     /* 1631351 */   GIM_Try, /*On fail goto*//*Label 22490*/ GIMT_Encode4(1631437), // Rule ID 4033 //
     /* 1631356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1631367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1631370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631402 */     // MIs[0] policy
     /* 1631402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631412 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1631415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631436 */     // GIR_Coverage, 4033,
     /* 1631436 */     GIR_EraseRootFromParent_Done,
     /* 1631437 */   // Label 22490: @1631437
     /* 1631437 */   GIM_Try, /*On fail goto*//*Label 22491*/ GIMT_Encode4(1631523), // Rule ID 4036 //
     /* 1631442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1631453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1631456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1631459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631488 */     // MIs[0] policy
     /* 1631488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631498 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631522 */     // GIR_Coverage, 4036,
     /* 1631522 */     GIR_EraseRootFromParent_Done,
     /* 1631523 */   // Label 22491: @1631523
     /* 1631523 */   GIM_Try, /*On fail goto*//*Label 22492*/ GIMT_Encode4(1631609), // Rule ID 4037 //
     /* 1631528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1631539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1631542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1631545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631574 */     // MIs[0] policy
     /* 1631574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11668:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1631587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631608 */     // GIR_Coverage, 4037,
     /* 1631608 */     GIR_EraseRootFromParent_Done,
     /* 1631609 */   // Label 22492: @1631609
     /* 1631609 */   GIM_Try, /*On fail goto*//*Label 22493*/ GIMT_Encode4(1631695), // Rule ID 4040 //
     /* 1631614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1631625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1631628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1631631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631660 */     // MIs[0] policy
     /* 1631660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1631673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631694 */     // GIR_Coverage, 4040,
     /* 1631694 */     GIR_EraseRootFromParent_Done,
     /* 1631695 */   // Label 22493: @1631695
     /* 1631695 */   GIM_Try, /*On fail goto*//*Label 22494*/ GIMT_Encode4(1631781), // Rule ID 4041 //
     /* 1631700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1631711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1631714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1631717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631746 */     // MIs[0] policy
     /* 1631746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1631759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631780 */     // GIR_Coverage, 4041,
     /* 1631780 */     GIR_EraseRootFromParent_Done,
     /* 1631781 */   // Label 22494: @1631781
     /* 1631781 */   GIM_Try, /*On fail goto*//*Label 22495*/ GIMT_Encode4(1631867), // Rule ID 4044 //
     /* 1631786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1631797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1631800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1631803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631832 */     // MIs[0] policy
     /* 1631832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631866 */     // GIR_Coverage, 4044,
     /* 1631866 */     GIR_EraseRootFromParent_Done,
     /* 1631867 */   // Label 22495: @1631867
     /* 1631867 */   GIM_Try, /*On fail goto*//*Label 22496*/ GIMT_Encode4(1631953), // Rule ID 4045 //
     /* 1631872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1631883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1631886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1631889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631918 */     // MIs[0] policy
     /* 1631918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631928 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1631931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1631949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631952 */     // GIR_Coverage, 4045,
     /* 1631952 */     GIR_EraseRootFromParent_Done,
     /* 1631953 */   // Label 22496: @1631953
     /* 1631953 */   GIM_Try, /*On fail goto*//*Label 22497*/ GIMT_Encode4(1632039), // Rule ID 4048 //
     /* 1631958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1631966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1631969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1631972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1631975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632004 */     // MIs[0] policy
     /* 1632004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632014 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632038 */     // GIR_Coverage, 4048,
     /* 1632038 */     GIR_EraseRootFromParent_Done,
     /* 1632039 */   // Label 22497: @1632039
     /* 1632039 */   GIM_Try, /*On fail goto*//*Label 22498*/ GIMT_Encode4(1632125), // Rule ID 4049 //
     /* 1632044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1632055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1632058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1632061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632090 */     // MIs[0] policy
     /* 1632090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632100 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632124 */     // GIR_Coverage, 4049,
     /* 1632124 */     GIR_EraseRootFromParent_Done,
     /* 1632125 */   // Label 22498: @1632125
     /* 1632125 */   GIM_Try, /*On fail goto*//*Label 22499*/ GIMT_Encode4(1632211), // Rule ID 4052 //
     /* 1632130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632176 */     // MIs[0] policy
     /* 1632176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632210 */     // GIR_Coverage, 4052,
     /* 1632210 */     GIR_EraseRootFromParent_Done,
     /* 1632211 */   // Label 22499: @1632211
     /* 1632211 */   GIM_Try, /*On fail goto*//*Label 22500*/ GIMT_Encode4(1632297), // Rule ID 4053 //
     /* 1632216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1632227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1632230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632262 */     // MIs[0] policy
     /* 1632262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11668:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1632275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632296 */     // GIR_Coverage, 4053,
     /* 1632296 */     GIR_EraseRootFromParent_Done,
     /* 1632297 */   // Label 22500: @1632297
     /* 1632297 */   GIM_Try, /*On fail goto*//*Label 22501*/ GIMT_Encode4(1632383), // Rule ID 4056 //
     /* 1632302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632348 */     // MIs[0] policy
     /* 1632348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632382 */     // GIR_Coverage, 4056,
     /* 1632382 */     GIR_EraseRootFromParent_Done,
     /* 1632383 */   // Label 22501: @1632383
     /* 1632383 */   GIM_Try, /*On fail goto*//*Label 22502*/ GIMT_Encode4(1632469), // Rule ID 4057 //
     /* 1632388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1632399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1632402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632434 */     // MIs[0] policy
     /* 1632434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11668:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1632447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632468 */     // GIR_Coverage, 4057,
     /* 1632468 */     GIR_EraseRootFromParent_Done,
     /* 1632469 */   // Label 22502: @1632469
     /* 1632469 */   GIM_Try, /*On fail goto*//*Label 22503*/ GIMT_Encode4(1632555), // Rule ID 4060 //
     /* 1632474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1632485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1632488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1632491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632520 */     // MIs[0] policy
     /* 1632520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1632533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632554 */     // GIR_Coverage, 4060,
     /* 1632554 */     GIR_EraseRootFromParent_Done,
     /* 1632555 */   // Label 22503: @1632555
     /* 1632555 */   GIM_Try, /*On fail goto*//*Label 22504*/ GIMT_Encode4(1632641), // Rule ID 4061 //
     /* 1632560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1632571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1632574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1632577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632606 */     // MIs[0] policy
     /* 1632606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11668:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1632619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632640 */     // GIR_Coverage, 4061,
     /* 1632640 */     GIR_EraseRootFromParent_Done,
     /* 1632641 */   // Label 22504: @1632641
     /* 1632641 */   GIM_Try, /*On fail goto*//*Label 22505*/ GIMT_Encode4(1632727), // Rule ID 4064 //
     /* 1632646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1632649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1632657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1632660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1632663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1632666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632692 */     // MIs[0] policy
     /* 1632692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632702 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632726 */     // GIR_Coverage, 4064,
     /* 1632726 */     GIR_EraseRootFromParent_Done,
     /* 1632727 */   // Label 22505: @1632727
     /* 1632727 */   GIM_Try, /*On fail goto*//*Label 22506*/ GIMT_Encode4(1632813), // Rule ID 4065 //
     /* 1632732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1632735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1632740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1632743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1632746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1632749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1632752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1632774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632778 */     // MIs[0] policy
     /* 1632778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11668:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1632791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1632809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632812 */     // GIR_Coverage, 4065,
     /* 1632812 */     GIR_EraseRootFromParent_Done,
     /* 1632813 */   // Label 22506: @1632813
     /* 1632813 */   GIM_Try, /*On fail goto*//*Label 22507*/ GIMT_Encode4(1632899), // Rule ID 4074 //
     /* 1632818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1632829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1632832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1632835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1632838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632864 */     // MIs[0] policy
     /* 1632864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1632877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632898 */     // GIR_Coverage, 4074,
     /* 1632898 */     GIR_EraseRootFromParent_Done,
     /* 1632899 */   // Label 22507: @1632899
     /* 1632899 */   GIM_Try, /*On fail goto*//*Label 22508*/ GIMT_Encode4(1632985), // Rule ID 4075 //
     /* 1632904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1632915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1632918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1632921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1632924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632950 */     // MIs[0] policy
     /* 1632950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632960 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1632963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632984 */     // GIR_Coverage, 4075,
     /* 1632984 */     GIR_EraseRootFromParent_Done,
     /* 1632985 */   // Label 22508: @1632985
     /* 1632985 */   GIM_Try, /*On fail goto*//*Label 22509*/ GIMT_Encode4(1633071), // Rule ID 4084 //
     /* 1632990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1632998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1633010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633036 */     // MIs[0] policy
     /* 1633036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633070 */     // GIR_Coverage, 4084,
     /* 1633070 */     GIR_EraseRootFromParent_Done,
     /* 1633071 */   // Label 22509: @1633071
     /* 1633071 */   GIM_Try, /*On fail goto*//*Label 22510*/ GIMT_Encode4(1633157), // Rule ID 4085 //
     /* 1633076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1633087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1633090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1633093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1633096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633122 */     // MIs[0] policy
     /* 1633122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633156 */     // GIR_Coverage, 4085,
     /* 1633156 */     GIR_EraseRootFromParent_Done,
     /* 1633157 */   // Label 22510: @1633157
     /* 1633157 */   GIM_Try, /*On fail goto*//*Label 22511*/ GIMT_Encode4(1633243), // Rule ID 4094 //
     /* 1633162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1633182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633208 */     // MIs[0] policy
     /* 1633208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633218 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1633221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633242 */     // GIR_Coverage, 4094,
     /* 1633242 */     GIR_EraseRootFromParent_Done,
     /* 1633243 */   // Label 22511: @1633243
     /* 1633243 */   GIM_Try, /*On fail goto*//*Label 22512*/ GIMT_Encode4(1633329), // Rule ID 4095 //
     /* 1633248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1633259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1633262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1633265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1633268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633294 */     // MIs[0] policy
     /* 1633294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1633307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633328 */     // GIR_Coverage, 4095,
     /* 1633328 */     GIR_EraseRootFromParent_Done,
     /* 1633329 */   // Label 22512: @1633329
     /* 1633329 */   GIM_Try, /*On fail goto*//*Label 22513*/ GIMT_Encode4(1633415), // Rule ID 4104 //
     /* 1633334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1633354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633380 */     // MIs[0] policy
     /* 1633380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1633393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633414 */     // GIR_Coverage, 4104,
     /* 1633414 */     GIR_EraseRootFromParent_Done,
     /* 1633415 */   // Label 22513: @1633415
     /* 1633415 */   GIM_Try, /*On fail goto*//*Label 22514*/ GIMT_Encode4(1633501), // Rule ID 4105 //
     /* 1633420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1633431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1633434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1633437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1633440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633466 */     // MIs[0] policy
     /* 1633466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1633479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633500 */     // GIR_Coverage, 4105,
     /* 1633500 */     GIR_EraseRootFromParent_Done,
     /* 1633501 */   // Label 22514: @1633501
     /* 1633501 */   GIM_Try, /*On fail goto*//*Label 22515*/ GIMT_Encode4(1633587), // Rule ID 4114 //
     /* 1633506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1633526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633552 */     // MIs[0] policy
     /* 1633552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633562 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1633565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633586 */     // GIR_Coverage, 4114,
     /* 1633586 */     GIR_EraseRootFromParent_Done,
     /* 1633587 */   // Label 22515: @1633587
     /* 1633587 */   GIM_Try, /*On fail goto*//*Label 22516*/ GIMT_Encode4(1633673), // Rule ID 4115 //
     /* 1633592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1633603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1633606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1633609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1633612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1633615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633638 */     // MIs[0] policy
     /* 1633638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633648 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1633651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633672 */     // GIR_Coverage, 4115,
     /* 1633672 */     GIR_EraseRootFromParent_Done,
     /* 1633673 */   // Label 22516: @1633673
     /* 1633673 */   GIM_Try, /*On fail goto*//*Label 22517*/ GIMT_Encode4(1633759), // Rule ID 4124 //
     /* 1633678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1633689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1633692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1633695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1633698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633724 */     // MIs[0] policy
     /* 1633724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1633737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633758 */     // GIR_Coverage, 4124,
     /* 1633758 */     GIR_EraseRootFromParent_Done,
     /* 1633759 */   // Label 22517: @1633759
     /* 1633759 */   GIM_Try, /*On fail goto*//*Label 22518*/ GIMT_Encode4(1633845), // Rule ID 4125 //
     /* 1633764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1633775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1633778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1633781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1633784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633810 */     // MIs[0] policy
     /* 1633810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1633823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633844 */     // GIR_Coverage, 4125,
     /* 1633844 */     GIR_EraseRootFromParent_Done,
     /* 1633845 */   // Label 22518: @1633845
     /* 1633845 */   GIM_Try, /*On fail goto*//*Label 22519*/ GIMT_Encode4(1633931), // Rule ID 4134 //
     /* 1633850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1633861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1633864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1633867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1633870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633896 */     // MIs[0] policy
     /* 1633896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633930 */     // GIR_Coverage, 4134,
     /* 1633930 */     GIR_EraseRootFromParent_Done,
     /* 1633931 */   // Label 22519: @1633931
     /* 1633931 */   GIM_Try, /*On fail goto*//*Label 22520*/ GIMT_Encode4(1634017), // Rule ID 4135 //
     /* 1633936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1633944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1633947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1633950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1633953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1633956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633982 */     // MIs[0] policy
     /* 1633982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633992 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1633995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634016 */     // GIR_Coverage, 4135,
     /* 1634016 */     GIR_EraseRootFromParent_Done,
     /* 1634017 */   // Label 22520: @1634017
     /* 1634017 */   GIM_Try, /*On fail goto*//*Label 22521*/ GIMT_Encode4(1634103), // Rule ID 4144 //
     /* 1634022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1634042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634068 */     // MIs[0] policy
     /* 1634068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634078 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634102 */     // GIR_Coverage, 4144,
     /* 1634102 */     GIR_EraseRootFromParent_Done,
     /* 1634103 */   // Label 22521: @1634103
     /* 1634103 */   GIM_Try, /*On fail goto*//*Label 22522*/ GIMT_Encode4(1634189), // Rule ID 4145 //
     /* 1634108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1634119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1634122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1634125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1634128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634154 */     // MIs[0] policy
     /* 1634154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634188 */     // GIR_Coverage, 4145,
     /* 1634188 */     GIR_EraseRootFromParent_Done,
     /* 1634189 */   // Label 22522: @1634189
     /* 1634189 */   GIM_Try, /*On fail goto*//*Label 22523*/ GIMT_Encode4(1634275), // Rule ID 4154 //
     /* 1634194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1634214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634240 */     // MIs[0] policy
     /* 1634240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634250 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634274 */     // GIR_Coverage, 4154,
     /* 1634274 */     GIR_EraseRootFromParent_Done,
     /* 1634275 */   // Label 22523: @1634275
     /* 1634275 */   GIM_Try, /*On fail goto*//*Label 22524*/ GIMT_Encode4(1634361), // Rule ID 4155 //
     /* 1634280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1634291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1634294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1634297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1634300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634326 */     // MIs[0] policy
     /* 1634326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634336 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634360 */     // GIR_Coverage, 4155,
     /* 1634360 */     GIR_EraseRootFromParent_Done,
     /* 1634361 */   // Label 22524: @1634361
     /* 1634361 */   GIM_Try, /*On fail goto*//*Label 22525*/ GIMT_Encode4(1634447), // Rule ID 4164 //
     /* 1634366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1634386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634412 */     // MIs[0] policy
     /* 1634412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634422 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634446 */     // GIR_Coverage, 4164,
     /* 1634446 */     GIR_EraseRootFromParent_Done,
     /* 1634447 */   // Label 22525: @1634447
     /* 1634447 */   GIM_Try, /*On fail goto*//*Label 22526*/ GIMT_Encode4(1634533), // Rule ID 4165 //
     /* 1634452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1634463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1634466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1634469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1634472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634498 */     // MIs[0] policy
     /* 1634498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634508 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1634511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634532 */     // GIR_Coverage, 4165,
     /* 1634532 */     GIR_EraseRootFromParent_Done,
     /* 1634533 */   // Label 22526: @1634533
     /* 1634533 */   GIM_Try, /*On fail goto*//*Label 22527*/ GIMT_Encode4(1634619), // Rule ID 4174 //
     /* 1634538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1634541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1634549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1634552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1634555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1634558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634584 */     // MIs[0] policy
     /* 1634584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1634597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634618 */     // GIR_Coverage, 4174,
     /* 1634618 */     GIR_EraseRootFromParent_Done,
     /* 1634619 */   // Label 22527: @1634619
     /* 1634619 */   GIM_Try, /*On fail goto*//*Label 22528*/ GIMT_Encode4(1634705), // Rule ID 4175 //
     /* 1634624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1634627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1634635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1634638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1634641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1634644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634670 */     // MIs[0] policy
     /* 1634670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634680 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1634683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634704 */     // GIR_Coverage, 4175,
     /* 1634704 */     GIR_EraseRootFromParent_Done,
     /* 1634705 */   // Label 22528: @1634705
     /* 1634705 */   GIM_Try, /*On fail goto*//*Label 22529*/ GIMT_Encode4(1634791), // Rule ID 4184 //
     /* 1634710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1634713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1634721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1634724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1634727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1634730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634756 */     // MIs[0] policy
     /* 1634756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634766 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634790 */     // GIR_Coverage, 4184,
     /* 1634790 */     GIR_EraseRootFromParent_Done,
     /* 1634791 */   // Label 22529: @1634791
     /* 1634791 */   GIM_Try, /*On fail goto*//*Label 22530*/ GIMT_Encode4(1634877), // Rule ID 4185 //
     /* 1634796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1634799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1634807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1634810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1634813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1634816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634842 */     // MIs[0] policy
     /* 1634842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634852 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1634855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634876 */     // GIR_Coverage, 4185,
     /* 1634876 */     GIR_EraseRootFromParent_Done,
     /* 1634877 */   // Label 22530: @1634877
     /* 1634877 */   GIM_Try, /*On fail goto*//*Label 22531*/ GIMT_Encode4(1634963), // Rule ID 4194 //
     /* 1634882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1634885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1634893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1634896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1634899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1634902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634928 */     // MIs[0] policy
     /* 1634928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634938 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1634941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1634959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634962 */     // GIR_Coverage, 4194,
     /* 1634962 */     GIR_EraseRootFromParent_Done,
     /* 1634963 */   // Label 22531: @1634963
     /* 1634963 */   GIM_Try, /*On fail goto*//*Label 22532*/ GIMT_Encode4(1635049), // Rule ID 4195 //
     /* 1634968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1634971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1634976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1634979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1634982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1634985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1634988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635014 */     // MIs[0] policy
     /* 1635014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635024 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1635027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635048 */     // GIR_Coverage, 4195,
     /* 1635048 */     GIR_EraseRootFromParent_Done,
     /* 1635049 */   // Label 22532: @1635049
     /* 1635049 */   GIM_Try, /*On fail goto*//*Label 22533*/ GIMT_Encode4(1635135), // Rule ID 4204 //
     /* 1635054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1635074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635100 */     // MIs[0] policy
     /* 1635100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635110 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1635113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635134 */     // GIR_Coverage, 4204,
     /* 1635134 */     GIR_EraseRootFromParent_Done,
     /* 1635135 */   // Label 22533: @1635135
     /* 1635135 */   GIM_Try, /*On fail goto*//*Label 22534*/ GIMT_Encode4(1635221), // Rule ID 4205 //
     /* 1635140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1635151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1635154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1635157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1635160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635186 */     // MIs[0] policy
     /* 1635186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1635199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635220 */     // GIR_Coverage, 4205,
     /* 1635220 */     GIR_EraseRootFromParent_Done,
     /* 1635221 */   // Label 22534: @1635221
     /* 1635221 */   GIM_Try, /*On fail goto*//*Label 22535*/ GIMT_Encode4(1635307), // Rule ID 4208 //
     /* 1635226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635272 */     // MIs[0] policy
     /* 1635272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635282 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1635285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635306 */     // GIR_Coverage, 4208,
     /* 1635306 */     GIR_EraseRootFromParent_Done,
     /* 1635307 */   // Label 22535: @1635307
     /* 1635307 */   GIM_Try, /*On fail goto*//*Label 22536*/ GIMT_Encode4(1635393), // Rule ID 4209 //
     /* 1635312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1635323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1635326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1635329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635358 */     // MIs[0] policy
     /* 1635358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1635371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635392 */     // GIR_Coverage, 4209,
     /* 1635392 */     GIR_EraseRootFromParent_Done,
     /* 1635393 */   // Label 22536: @1635393
     /* 1635393 */   GIM_Try, /*On fail goto*//*Label 22537*/ GIMT_Encode4(1635479), // Rule ID 4212 //
     /* 1635398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635444 */     // MIs[0] policy
     /* 1635444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635454 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1635457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635478 */     // GIR_Coverage, 4212,
     /* 1635478 */     GIR_EraseRootFromParent_Done,
     /* 1635479 */   // Label 22537: @1635479
     /* 1635479 */   GIM_Try, /*On fail goto*//*Label 22538*/ GIMT_Encode4(1635565), // Rule ID 4213 //
     /* 1635484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1635495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1635498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1635501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635530 */     // MIs[0] policy
     /* 1635530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1635543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635564 */     // GIR_Coverage, 4213,
     /* 1635564 */     GIR_EraseRootFromParent_Done,
     /* 1635565 */   // Label 22538: @1635565
     /* 1635565 */   GIM_Try, /*On fail goto*//*Label 22539*/ GIMT_Encode4(1635651), // Rule ID 4216 //
     /* 1635570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1635581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1635584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1635587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635616 */     // MIs[0] policy
     /* 1635616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1635629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635650 */     // GIR_Coverage, 4216,
     /* 1635650 */     GIR_EraseRootFromParent_Done,
     /* 1635651 */   // Label 22539: @1635651
     /* 1635651 */   GIM_Try, /*On fail goto*//*Label 22540*/ GIMT_Encode4(1635737), // Rule ID 4217 //
     /* 1635656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1635667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1635670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1635673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635702 */     // MIs[0] policy
     /* 1635702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635712 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11646:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1635715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635736 */     // GIR_Coverage, 4217,
     /* 1635736 */     GIR_EraseRootFromParent_Done,
     /* 1635737 */   // Label 22540: @1635737
     /* 1635737 */   GIM_Try, /*On fail goto*//*Label 22541*/ GIMT_Encode4(1635823), // Rule ID 4220 //
     /* 1635742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1635753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1635756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1635759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635788 */     // MIs[0] policy
     /* 1635788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1635801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635822 */     // GIR_Coverage, 4220,
     /* 1635822 */     GIR_EraseRootFromParent_Done,
     /* 1635823 */   // Label 22541: @1635823
     /* 1635823 */   GIM_Try, /*On fail goto*//*Label 22542*/ GIMT_Encode4(1635909), // Rule ID 4221 //
     /* 1635828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1635839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1635842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1635845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635874 */     // MIs[0] policy
     /* 1635874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1635887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635908 */     // GIR_Coverage, 4221,
     /* 1635908 */     GIR_EraseRootFromParent_Done,
     /* 1635909 */   // Label 22542: @1635909
     /* 1635909 */   GIM_Try, /*On fail goto*//*Label 22543*/ GIMT_Encode4(1635995), // Rule ID 4224 //
     /* 1635914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1635922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1635925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1635928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1635931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1635937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635960 */     // MIs[0] policy
     /* 1635960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635970 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1635973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1635991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635994 */     // GIR_Coverage, 4224,
     /* 1635994 */     GIR_EraseRootFromParent_Done,
     /* 1635995 */   // Label 22543: @1635995
     /* 1635995 */   GIM_Try, /*On fail goto*//*Label 22544*/ GIMT_Encode4(1636081), // Rule ID 4225 //
     /* 1636000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1636011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1636014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1636017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636046 */     // MIs[0] policy
     /* 1636046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636056 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636080 */     // GIR_Coverage, 4225,
     /* 1636080 */     GIR_EraseRootFromParent_Done,
     /* 1636081 */   // Label 22544: @1636081
     /* 1636081 */   GIM_Try, /*On fail goto*//*Label 22545*/ GIMT_Encode4(1636167), // Rule ID 4228 //
     /* 1636086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636132 */     // MIs[0] policy
     /* 1636132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636142 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1636145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636166 */     // GIR_Coverage, 4228,
     /* 1636166 */     GIR_EraseRootFromParent_Done,
     /* 1636167 */   // Label 22545: @1636167
     /* 1636167 */   GIM_Try, /*On fail goto*//*Label 22546*/ GIMT_Encode4(1636253), // Rule ID 4229 //
     /* 1636172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1636183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1636186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1636189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1636195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636218 */     // MIs[0] policy
     /* 1636218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636228 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1636231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636252 */     // GIR_Coverage, 4229,
     /* 1636252 */     GIR_EraseRootFromParent_Done,
     /* 1636253 */   // Label 22546: @1636253
     /* 1636253 */   GIM_Try, /*On fail goto*//*Label 22547*/ GIMT_Encode4(1636339), // Rule ID 4232 //
     /* 1636258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636304 */     // MIs[0] policy
     /* 1636304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636314 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636338 */     // GIR_Coverage, 4232,
     /* 1636338 */     GIR_EraseRootFromParent_Done,
     /* 1636339 */   // Label 22547: @1636339
     /* 1636339 */   GIM_Try, /*On fail goto*//*Label 22548*/ GIMT_Encode4(1636425), // Rule ID 4233 //
     /* 1636344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1636355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1636358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1636361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636390 */     // MIs[0] policy
     /* 1636390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636400 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1636403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636424 */     // GIR_Coverage, 4233,
     /* 1636424 */     GIR_EraseRootFromParent_Done,
     /* 1636425 */   // Label 22548: @1636425
     /* 1636425 */   GIM_Try, /*On fail goto*//*Label 22549*/ GIMT_Encode4(1636511), // Rule ID 4236 //
     /* 1636430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636476 */     // MIs[0] policy
     /* 1636476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636510 */     // GIR_Coverage, 4236,
     /* 1636510 */     GIR_EraseRootFromParent_Done,
     /* 1636511 */   // Label 22549: @1636511
     /* 1636511 */   GIM_Try, /*On fail goto*//*Label 22550*/ GIMT_Encode4(1636597), // Rule ID 4237 //
     /* 1636516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1636527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1636530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1636533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636562 */     // MIs[0] policy
     /* 1636562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11646:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1636575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636596 */     // GIR_Coverage, 4237,
     /* 1636596 */     GIR_EraseRootFromParent_Done,
     /* 1636597 */   // Label 22550: @1636597
     /* 1636597 */   GIM_Try, /*On fail goto*//*Label 22551*/ GIMT_Encode4(1636683), // Rule ID 4240 //
     /* 1636602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1636613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1636616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1636619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636648 */     // MIs[0] policy
     /* 1636648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1636661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636682 */     // GIR_Coverage, 4240,
     /* 1636682 */     GIR_EraseRootFromParent_Done,
     /* 1636683 */   // Label 22551: @1636683
     /* 1636683 */   GIM_Try, /*On fail goto*//*Label 22552*/ GIMT_Encode4(1636769), // Rule ID 4241 //
     /* 1636688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1636699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1636702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1636705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636734 */     // MIs[0] policy
     /* 1636734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1636747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636768 */     // GIR_Coverage, 4241,
     /* 1636768 */     GIR_EraseRootFromParent_Done,
     /* 1636769 */   // Label 22552: @1636769
     /* 1636769 */   GIM_Try, /*On fail goto*//*Label 22553*/ GIMT_Encode4(1636855), // Rule ID 4244 //
     /* 1636774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1636785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1636788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1636791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636820 */     // MIs[0] policy
     /* 1636820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636854 */     // GIR_Coverage, 4244,
     /* 1636854 */     GIR_EraseRootFromParent_Done,
     /* 1636855 */   // Label 22553: @1636855
     /* 1636855 */   GIM_Try, /*On fail goto*//*Label 22554*/ GIMT_Encode4(1636941), // Rule ID 4245 //
     /* 1636860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1636871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1636874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1636877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636906 */     // MIs[0] policy
     /* 1636906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636916 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1636919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1636937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636940 */     // GIR_Coverage, 4245,
     /* 1636940 */     GIR_EraseRootFromParent_Done,
     /* 1636941 */   // Label 22554: @1636941
     /* 1636941 */   GIM_Try, /*On fail goto*//*Label 22555*/ GIMT_Encode4(1637027), // Rule ID 4248 //
     /* 1636946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1636954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1636957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1636960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1636963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1636969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636992 */     // MIs[0] policy
     /* 1636992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637002 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637026 */     // GIR_Coverage, 4248,
     /* 1637026 */     GIR_EraseRootFromParent_Done,
     /* 1637027 */   // Label 22555: @1637027
     /* 1637027 */   GIM_Try, /*On fail goto*//*Label 22556*/ GIMT_Encode4(1637113), // Rule ID 4249 //
     /* 1637032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1637043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1637046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1637049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637078 */     // MIs[0] policy
     /* 1637078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637088 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637112 */     // GIR_Coverage, 4249,
     /* 1637112 */     GIR_EraseRootFromParent_Done,
     /* 1637113 */   // Label 22556: @1637113
     /* 1637113 */   GIM_Try, /*On fail goto*//*Label 22557*/ GIMT_Encode4(1637199), // Rule ID 4252 //
     /* 1637118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637164 */     // MIs[0] policy
     /* 1637164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637198 */     // GIR_Coverage, 4252,
     /* 1637198 */     GIR_EraseRootFromParent_Done,
     /* 1637199 */   // Label 22557: @1637199
     /* 1637199 */   GIM_Try, /*On fail goto*//*Label 22558*/ GIMT_Encode4(1637285), // Rule ID 4253 //
     /* 1637204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1637215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1637218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1637221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637250 */     // MIs[0] policy
     /* 1637250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11646:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1637263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637284 */     // GIR_Coverage, 4253,
     /* 1637284 */     GIR_EraseRootFromParent_Done,
     /* 1637285 */   // Label 22558: @1637285
     /* 1637285 */   GIM_Try, /*On fail goto*//*Label 22559*/ GIMT_Encode4(1637371), // Rule ID 4256 //
     /* 1637290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637336 */     // MIs[0] policy
     /* 1637336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637370 */     // GIR_Coverage, 4256,
     /* 1637370 */     GIR_EraseRootFromParent_Done,
     /* 1637371 */   // Label 22559: @1637371
     /* 1637371 */   GIM_Try, /*On fail goto*//*Label 22560*/ GIMT_Encode4(1637457), // Rule ID 4257 //
     /* 1637376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1637387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1637390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1637393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637422 */     // MIs[0] policy
     /* 1637422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11646:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1637435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637456 */     // GIR_Coverage, 4257,
     /* 1637456 */     GIR_EraseRootFromParent_Done,
     /* 1637457 */   // Label 22560: @1637457
     /* 1637457 */   GIM_Try, /*On fail goto*//*Label 22561*/ GIMT_Encode4(1637543), // Rule ID 4260 //
     /* 1637462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1637473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1637476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1637479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637508 */     // MIs[0] policy
     /* 1637508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637542 */     // GIR_Coverage, 4260,
     /* 1637542 */     GIR_EraseRootFromParent_Done,
     /* 1637543 */   // Label 22561: @1637543
     /* 1637543 */   GIM_Try, /*On fail goto*//*Label 22562*/ GIMT_Encode4(1637629), // Rule ID 4261 //
     /* 1637548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1637559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1637562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1637565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637594 */     // MIs[0] policy
     /* 1637594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11646:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1637607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637628 */     // GIR_Coverage, 4261,
     /* 1637628 */     GIR_EraseRootFromParent_Done,
     /* 1637629 */   // Label 22562: @1637629
     /* 1637629 */   GIM_Try, /*On fail goto*//*Label 22563*/ GIMT_Encode4(1637715), // Rule ID 4264 //
     /* 1637634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1637637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1637645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1637648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1637651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1637654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637680 */     // MIs[0] policy
     /* 1637680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637714 */     // GIR_Coverage, 4264,
     /* 1637714 */     GIR_EraseRootFromParent_Done,
     /* 1637715 */   // Label 22563: @1637715
     /* 1637715 */   GIM_Try, /*On fail goto*//*Label 22564*/ GIMT_Encode4(1637801), // Rule ID 4265 //
     /* 1637720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1637723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1637728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1637731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1637734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1637737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1637740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1637762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637766 */     // MIs[0] policy
     /* 1637766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11646:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1637779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1637797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637800 */     // GIR_Coverage, 4265,
     /* 1637800 */     GIR_EraseRootFromParent_Done,
     /* 1637801 */   // Label 22564: @1637801
     /* 1637801 */   GIM_Try, /*On fail goto*//*Label 22565*/ GIMT_Encode4(1637887), // Rule ID 4274 //
     /* 1637806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1637817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1637820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1637823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1637826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637852 */     // MIs[0] policy
     /* 1637852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637862 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1637865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637886 */     // GIR_Coverage, 4274,
     /* 1637886 */     GIR_EraseRootFromParent_Done,
     /* 1637887 */   // Label 22565: @1637887
     /* 1637887 */   GIM_Try, /*On fail goto*//*Label 22566*/ GIMT_Encode4(1637973), // Rule ID 4275 //
     /* 1637892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1637903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1637906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1637909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1637912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637938 */     // MIs[0] policy
     /* 1637938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637948 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1637951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637972 */     // GIR_Coverage, 4275,
     /* 1637972 */     GIR_EraseRootFromParent_Done,
     /* 1637973 */   // Label 22566: @1637973
     /* 1637973 */   GIM_Try, /*On fail goto*//*Label 22567*/ GIMT_Encode4(1638059), // Rule ID 4284 //
     /* 1637978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1637986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1637989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1637992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1637995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1637998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638024 */     // MIs[0] policy
     /* 1638024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638058 */     // GIR_Coverage, 4284,
     /* 1638058 */     GIR_EraseRootFromParent_Done,
     /* 1638059 */   // Label 22567: @1638059
     /* 1638059 */   GIM_Try, /*On fail goto*//*Label 22568*/ GIMT_Encode4(1638145), // Rule ID 4285 //
     /* 1638064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1638075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1638078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1638081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1638084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638110 */     // MIs[0] policy
     /* 1638110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638120 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638144 */     // GIR_Coverage, 4285,
     /* 1638144 */     GIR_EraseRootFromParent_Done,
     /* 1638145 */   // Label 22568: @1638145
     /* 1638145 */   GIM_Try, /*On fail goto*//*Label 22569*/ GIMT_Encode4(1638231), // Rule ID 4294 //
     /* 1638150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1638170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638196 */     // MIs[0] policy
     /* 1638196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1638209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638230 */     // GIR_Coverage, 4294,
     /* 1638230 */     GIR_EraseRootFromParent_Done,
     /* 1638231 */   // Label 22569: @1638231
     /* 1638231 */   GIM_Try, /*On fail goto*//*Label 22570*/ GIMT_Encode4(1638317), // Rule ID 4295 //
     /* 1638236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1638247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1638250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1638253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1638256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638282 */     // MIs[0] policy
     /* 1638282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638292 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1638295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638316 */     // GIR_Coverage, 4295,
     /* 1638316 */     GIR_EraseRootFromParent_Done,
     /* 1638317 */   // Label 22570: @1638317
     /* 1638317 */   GIM_Try, /*On fail goto*//*Label 22571*/ GIMT_Encode4(1638403), // Rule ID 4304 //
     /* 1638322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1638342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638368 */     // MIs[0] policy
     /* 1638368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1638381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638402 */     // GIR_Coverage, 4304,
     /* 1638402 */     GIR_EraseRootFromParent_Done,
     /* 1638403 */   // Label 22571: @1638403
     /* 1638403 */   GIM_Try, /*On fail goto*//*Label 22572*/ GIMT_Encode4(1638489), // Rule ID 4305 //
     /* 1638408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1638419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1638422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1638425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1638428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638454 */     // MIs[0] policy
     /* 1638454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1638467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638488 */     // GIR_Coverage, 4305,
     /* 1638488 */     GIR_EraseRootFromParent_Done,
     /* 1638489 */   // Label 22572: @1638489
     /* 1638489 */   GIM_Try, /*On fail goto*//*Label 22573*/ GIMT_Encode4(1638575), // Rule ID 4314 //
     /* 1638494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1638505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1638508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1638511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1638514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638540 */     // MIs[0] policy
     /* 1638540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638550 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1638553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638574 */     // GIR_Coverage, 4314,
     /* 1638574 */     GIR_EraseRootFromParent_Done,
     /* 1638575 */   // Label 22573: @1638575
     /* 1638575 */   GIM_Try, /*On fail goto*//*Label 22574*/ GIMT_Encode4(1638661), // Rule ID 4315 //
     /* 1638580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1638591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1638594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1638597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1638600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638626 */     // MIs[0] policy
     /* 1638626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638636 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1638639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638660 */     // GIR_Coverage, 4315,
     /* 1638660 */     GIR_EraseRootFromParent_Done,
     /* 1638661 */   // Label 22574: @1638661
     /* 1638661 */   GIM_Try, /*On fail goto*//*Label 22575*/ GIMT_Encode4(1638747), // Rule ID 4324 //
     /* 1638666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1638677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1638680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1638683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1638686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1638689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638712 */     // MIs[0] policy
     /* 1638712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638722 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1638725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638746 */     // GIR_Coverage, 4324,
     /* 1638746 */     GIR_EraseRootFromParent_Done,
     /* 1638747 */   // Label 22575: @1638747
     /* 1638747 */   GIM_Try, /*On fail goto*//*Label 22576*/ GIMT_Encode4(1638833), // Rule ID 4325 //
     /* 1638752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1638763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1638766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1638769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1638772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1638775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638798 */     // MIs[0] policy
     /* 1638798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638808 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1638811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1638829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638832 */     // GIR_Coverage, 4325,
     /* 1638832 */     GIR_EraseRootFromParent_Done,
     /* 1638833 */   // Label 22576: @1638833
     /* 1638833 */   GIM_Try, /*On fail goto*//*Label 22577*/ GIMT_Encode4(1638919), // Rule ID 4334 //
     /* 1638838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1638849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1638852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1638855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1638858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638884 */     // MIs[0] policy
     /* 1638884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638918 */     // GIR_Coverage, 4334,
     /* 1638918 */     GIR_EraseRootFromParent_Done,
     /* 1638919 */   // Label 22577: @1638919
     /* 1638919 */   GIM_Try, /*On fail goto*//*Label 22578*/ GIMT_Encode4(1639005), // Rule ID 4335 //
     /* 1638924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1638932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1638935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1638938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1638941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1638944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638970 */     // MIs[0] policy
     /* 1638970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638980 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1638983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639004 */     // GIR_Coverage, 4335,
     /* 1639004 */     GIR_EraseRootFromParent_Done,
     /* 1639005 */   // Label 22578: @1639005
     /* 1639005 */   GIM_Try, /*On fail goto*//*Label 22579*/ GIMT_Encode4(1639091), // Rule ID 4344 //
     /* 1639010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639056 */     // MIs[0] policy
     /* 1639056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639090 */     // GIR_Coverage, 4344,
     /* 1639090 */     GIR_EraseRootFromParent_Done,
     /* 1639091 */   // Label 22579: @1639091
     /* 1639091 */   GIM_Try, /*On fail goto*//*Label 22580*/ GIMT_Encode4(1639177), // Rule ID 4345 //
     /* 1639096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1639107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1639110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1639113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1639116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639142 */     // MIs[0] policy
     /* 1639142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639152 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639176 */     // GIR_Coverage, 4345,
     /* 1639176 */     GIR_EraseRootFromParent_Done,
     /* 1639177 */   // Label 22580: @1639177
     /* 1639177 */   GIM_Try, /*On fail goto*//*Label 22581*/ GIMT_Encode4(1639263), // Rule ID 4354 //
     /* 1639182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1639202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639228 */     // MIs[0] policy
     /* 1639228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639262 */     // GIR_Coverage, 4354,
     /* 1639262 */     GIR_EraseRootFromParent_Done,
     /* 1639263 */   // Label 22581: @1639263
     /* 1639263 */   GIM_Try, /*On fail goto*//*Label 22582*/ GIMT_Encode4(1639349), // Rule ID 4355 //
     /* 1639268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1639279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1639282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1639285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1639288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639314 */     // MIs[0] policy
     /* 1639314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639348 */     // GIR_Coverage, 4355,
     /* 1639348 */     GIR_EraseRootFromParent_Done,
     /* 1639349 */   // Label 22582: @1639349
     /* 1639349 */   GIM_Try, /*On fail goto*//*Label 22583*/ GIMT_Encode4(1639435), // Rule ID 4364 //
     /* 1639354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1639374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639400 */     // MIs[0] policy
     /* 1639400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639410 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639434 */     // GIR_Coverage, 4364,
     /* 1639434 */     GIR_EraseRootFromParent_Done,
     /* 1639435 */   // Label 22583: @1639435
     /* 1639435 */   GIM_Try, /*On fail goto*//*Label 22584*/ GIMT_Encode4(1639521), // Rule ID 4365 //
     /* 1639440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1639451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1639454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1639457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1639460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639486 */     // MIs[0] policy
     /* 1639486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1639499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639520 */     // GIR_Coverage, 4365,
     /* 1639520 */     GIR_EraseRootFromParent_Done,
     /* 1639521 */   // Label 22584: @1639521
     /* 1639521 */   GIM_Try, /*On fail goto*//*Label 22585*/ GIMT_Encode4(1639607), // Rule ID 4374 //
     /* 1639526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1639537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1639540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1639543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1639546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639572 */     // MIs[0] policy
     /* 1639572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639582 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1639585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639606 */     // GIR_Coverage, 4374,
     /* 1639606 */     GIR_EraseRootFromParent_Done,
     /* 1639607 */   // Label 22585: @1639607
     /* 1639607 */   GIM_Try, /*On fail goto*//*Label 22586*/ GIMT_Encode4(1639693), // Rule ID 4375 //
     /* 1639612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1639623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1639626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1639629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1639632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639658 */     // MIs[0] policy
     /* 1639658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639668 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1639671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1639689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639692 */     // GIR_Coverage, 4375,
     /* 1639692 */     GIR_EraseRootFromParent_Done,
     /* 1639693 */   // Label 22586: @1639693
     /* 1639693 */   GIM_Try, /*On fail goto*//*Label 22587*/ GIMT_Encode4(1639779), // Rule ID 4384 //
     /* 1639698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1639701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1639709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1639712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1639715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1639718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639744 */     // MIs[0] policy
     /* 1639744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1639775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639778 */     // GIR_Coverage, 4384,
     /* 1639778 */     GIR_EraseRootFromParent_Done,
     /* 1639779 */   // Label 22587: @1639779
     /* 1639779 */   GIM_Try, /*On fail goto*//*Label 22588*/ GIMT_Encode4(1639865), // Rule ID 4385 //
     /* 1639784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1639787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1639795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1639798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1639801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1639804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639830 */     // MIs[0] policy
     /* 1639830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639840 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1639843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1639861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639864 */     // GIR_Coverage, 4385,
     /* 1639864 */     GIR_EraseRootFromParent_Done,
     /* 1639865 */   // Label 22588: @1639865
     /* 1639865 */   GIM_Try, /*On fail goto*//*Label 22589*/ GIMT_Encode4(1639951), // Rule ID 4394 //
     /* 1639870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1639873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1639881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1639884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1639887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1639890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639916 */     // MIs[0] policy
     /* 1639916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1639929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1639947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639950 */     // GIR_Coverage, 4394,
     /* 1639950 */     GIR_EraseRootFromParent_Done,
     /* 1639951 */   // Label 22589: @1639951
     /* 1639951 */   GIM_Try, /*On fail goto*//*Label 22590*/ GIMT_Encode4(1640037), // Rule ID 4395 //
     /* 1639956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1639959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1639964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1639967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1639970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1639973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1639976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640002 */     // MIs[0] policy
     /* 1640002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640012 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1640015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640036 */     // GIR_Coverage, 4395,
     /* 1640036 */     GIR_EraseRootFromParent_Done,
     /* 1640037 */   // Label 22590: @1640037
     /* 1640037 */   GIM_Try, /*On fail goto*//*Label 22591*/ GIMT_Encode4(1640123), // Rule ID 4404 //
     /* 1640042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1640062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640088 */     // MIs[0] policy
     /* 1640088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640098 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1640101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640122 */     // GIR_Coverage, 4404,
     /* 1640122 */     GIR_EraseRootFromParent_Done,
     /* 1640123 */   // Label 22591: @1640123
     /* 1640123 */   GIM_Try, /*On fail goto*//*Label 22592*/ GIMT_Encode4(1640209), // Rule ID 4405 //
     /* 1640128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1640139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1640142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1640145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1640148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640174 */     // MIs[0] policy
     /* 1640174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640184 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1640187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640208 */     // GIR_Coverage, 4405,
     /* 1640208 */     GIR_EraseRootFromParent_Done,
     /* 1640209 */   // Label 22592: @1640209
     /* 1640209 */   GIM_Try, /*On fail goto*//*Label 22593*/ GIMT_Encode4(1640295), // Rule ID 4414 //
     /* 1640214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1640234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640260 */     // MIs[0] policy
     /* 1640260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640270 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640294 */     // GIR_Coverage, 4414,
     /* 1640294 */     GIR_EraseRootFromParent_Done,
     /* 1640295 */   // Label 22593: @1640295
     /* 1640295 */   GIM_Try, /*On fail goto*//*Label 22594*/ GIMT_Encode4(1640381), // Rule ID 4415 //
     /* 1640300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1640311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1640314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1640317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1640320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640346 */     // MIs[0] policy
     /* 1640346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640356 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1640359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640380 */     // GIR_Coverage, 4415,
     /* 1640380 */     GIR_EraseRootFromParent_Done,
     /* 1640381 */   // Label 22594: @1640381
     /* 1640381 */   GIM_Try, /*On fail goto*//*Label 22595*/ GIMT_Encode4(1640467), // Rule ID 4418 //
     /* 1640386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640432 */     // MIs[0] policy
     /* 1640432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640442 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1640445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640466 */     // GIR_Coverage, 4418,
     /* 1640466 */     GIR_EraseRootFromParent_Done,
     /* 1640467 */   // Label 22595: @1640467
     /* 1640467 */   GIM_Try, /*On fail goto*//*Label 22596*/ GIMT_Encode4(1640553), // Rule ID 4419 //
     /* 1640472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1640483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1640486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1640489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640518 */     // MIs[0] policy
     /* 1640518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640528 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1640531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640552 */     // GIR_Coverage, 4419,
     /* 1640552 */     GIR_EraseRootFromParent_Done,
     /* 1640553 */   // Label 22596: @1640553
     /* 1640553 */   GIM_Try, /*On fail goto*//*Label 22597*/ GIMT_Encode4(1640639), // Rule ID 4422 //
     /* 1640558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1640569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1640572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1640575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640604 */     // MIs[0] policy
     /* 1640604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640614 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1640617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640638 */     // GIR_Coverage, 4422,
     /* 1640638 */     GIR_EraseRootFromParent_Done,
     /* 1640639 */   // Label 22597: @1640639
     /* 1640639 */   GIM_Try, /*On fail goto*//*Label 22598*/ GIMT_Encode4(1640725), // Rule ID 4423 //
     /* 1640644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1640655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1640658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1640661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640690 */     // MIs[0] policy
     /* 1640690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640700 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1640703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640724 */     // GIR_Coverage, 4423,
     /* 1640724 */     GIR_EraseRootFromParent_Done,
     /* 1640725 */   // Label 22598: @1640725
     /* 1640725 */   GIM_Try, /*On fail goto*//*Label 22599*/ GIMT_Encode4(1640811), // Rule ID 4426 //
     /* 1640730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1640741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1640744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1640747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640776 */     // MIs[0] policy
     /* 1640776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1640789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640810 */     // GIR_Coverage, 4426,
     /* 1640810 */     GIR_EraseRootFromParent_Done,
     /* 1640811 */   // Label 22599: @1640811
     /* 1640811 */   GIM_Try, /*On fail goto*//*Label 22600*/ GIMT_Encode4(1640897), // Rule ID 4427 //
     /* 1640816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1640827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1640830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1640833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640862 */     // MIs[0] policy
     /* 1640862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11674:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1640875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640896 */     // GIR_Coverage, 4427,
     /* 1640896 */     GIR_EraseRootFromParent_Done,
     /* 1640897 */   // Label 22600: @1640897
     /* 1640897 */   GIM_Try, /*On fail goto*//*Label 22601*/ GIMT_Encode4(1640983), // Rule ID 4430 //
     /* 1640902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1640913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1640916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1640919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640948 */     // MIs[0] policy
     /* 1640948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640958 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1640961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1640979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640982 */     // GIR_Coverage, 4430,
     /* 1640982 */     GIR_EraseRootFromParent_Done,
     /* 1640983 */   // Label 22601: @1640983
     /* 1640983 */   GIM_Try, /*On fail goto*//*Label 22602*/ GIMT_Encode4(1641069), // Rule ID 4431 //
     /* 1640988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1640996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1640999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1641002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1641005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641034 */     // MIs[0] policy
     /* 1641034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641068 */     // GIR_Coverage, 4431,
     /* 1641068 */     GIR_EraseRootFromParent_Done,
     /* 1641069 */   // Label 22602: @1641069
     /* 1641069 */   GIM_Try, /*On fail goto*//*Label 22603*/ GIMT_Encode4(1641155), // Rule ID 4434 //
     /* 1641074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641120 */     // MIs[0] policy
     /* 1641120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641130 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1641133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641154 */     // GIR_Coverage, 4434,
     /* 1641154 */     GIR_EraseRootFromParent_Done,
     /* 1641155 */   // Label 22603: @1641155
     /* 1641155 */   GIM_Try, /*On fail goto*//*Label 22604*/ GIMT_Encode4(1641241), // Rule ID 4435 //
     /* 1641160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1641171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1641174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1641177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1641183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641206 */     // MIs[0] policy
     /* 1641206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641216 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1641219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641240 */     // GIR_Coverage, 4435,
     /* 1641240 */     GIR_EraseRootFromParent_Done,
     /* 1641241 */   // Label 22604: @1641241
     /* 1641241 */   GIM_Try, /*On fail goto*//*Label 22605*/ GIMT_Encode4(1641327), // Rule ID 4438 //
     /* 1641246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641292 */     // MIs[0] policy
     /* 1641292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641302 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1641305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641326 */     // GIR_Coverage, 4438,
     /* 1641326 */     GIR_EraseRootFromParent_Done,
     /* 1641327 */   // Label 22605: @1641327
     /* 1641327 */   GIM_Try, /*On fail goto*//*Label 22606*/ GIMT_Encode4(1641413), // Rule ID 4439 //
     /* 1641332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1641343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1641346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1641349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1641355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641378 */     // MIs[0] policy
     /* 1641378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1641391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641412 */     // GIR_Coverage, 4439,
     /* 1641412 */     GIR_EraseRootFromParent_Done,
     /* 1641413 */   // Label 22606: @1641413
     /* 1641413 */   GIM_Try, /*On fail goto*//*Label 22607*/ GIMT_Encode4(1641499), // Rule ID 4442 //
     /* 1641418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641464 */     // MIs[0] policy
     /* 1641464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641474 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641498 */     // GIR_Coverage, 4442,
     /* 1641498 */     GIR_EraseRootFromParent_Done,
     /* 1641499 */   // Label 22607: @1641499
     /* 1641499 */   GIM_Try, /*On fail goto*//*Label 22608*/ GIMT_Encode4(1641585), // Rule ID 4443 //
     /* 1641504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1641515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1641518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1641521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641550 */     // MIs[0] policy
     /* 1641550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641560 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1641563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641584 */     // GIR_Coverage, 4443,
     /* 1641584 */     GIR_EraseRootFromParent_Done,
     /* 1641585 */   // Label 22608: @1641585
     /* 1641585 */   GIM_Try, /*On fail goto*//*Label 22609*/ GIMT_Encode4(1641671), // Rule ID 4446 //
     /* 1641590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1641601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1641604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1641607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641636 */     // MIs[0] policy
     /* 1641636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641646 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1641649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641670 */     // GIR_Coverage, 4446,
     /* 1641670 */     GIR_EraseRootFromParent_Done,
     /* 1641671 */   // Label 22609: @1641671
     /* 1641671 */   GIM_Try, /*On fail goto*//*Label 22610*/ GIMT_Encode4(1641757), // Rule ID 4447 //
     /* 1641676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1641687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1641690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1641693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641722 */     // MIs[0] policy
     /* 1641722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11674:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1641735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641756 */     // GIR_Coverage, 4447,
     /* 1641756 */     GIR_EraseRootFromParent_Done,
     /* 1641757 */   // Label 22610: @1641757
     /* 1641757 */   GIM_Try, /*On fail goto*//*Label 22611*/ GIMT_Encode4(1641843), // Rule ID 4450 //
     /* 1641762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1641773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1641776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1641779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641808 */     // MIs[0] policy
     /* 1641808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641842 */     // GIR_Coverage, 4450,
     /* 1641842 */     GIR_EraseRootFromParent_Done,
     /* 1641843 */   // Label 22611: @1641843
     /* 1641843 */   GIM_Try, /*On fail goto*//*Label 22612*/ GIMT_Encode4(1641929), // Rule ID 4451 //
     /* 1641848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1641859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1641862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1641865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641894 */     // MIs[0] policy
     /* 1641894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641904 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1641907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1641925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641928 */     // GIR_Coverage, 4451,
     /* 1641928 */     GIR_EraseRootFromParent_Done,
     /* 1641929 */   // Label 22612: @1641929
     /* 1641929 */   GIM_Try, /*On fail goto*//*Label 22613*/ GIMT_Encode4(1642015), // Rule ID 4454 //
     /* 1641934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1641942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1641945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1641948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1641951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641980 */     // MIs[0] policy
     /* 1641980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1641993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642014 */     // GIR_Coverage, 4454,
     /* 1642014 */     GIR_EraseRootFromParent_Done,
     /* 1642015 */   // Label 22613: @1642015
     /* 1642015 */   GIM_Try, /*On fail goto*//*Label 22614*/ GIMT_Encode4(1642101), // Rule ID 4455 //
     /* 1642020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1642031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1642034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1642037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642066 */     // MIs[0] policy
     /* 1642066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642100 */     // GIR_Coverage, 4455,
     /* 1642100 */     GIR_EraseRootFromParent_Done,
     /* 1642101 */   // Label 22614: @1642101
     /* 1642101 */   GIM_Try, /*On fail goto*//*Label 22615*/ GIMT_Encode4(1642187), // Rule ID 4458 //
     /* 1642106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642152 */     // MIs[0] policy
     /* 1642152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642162 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642186 */     // GIR_Coverage, 4458,
     /* 1642186 */     GIR_EraseRootFromParent_Done,
     /* 1642187 */   // Label 22615: @1642187
     /* 1642187 */   GIM_Try, /*On fail goto*//*Label 22616*/ GIMT_Encode4(1642273), // Rule ID 4459 //
     /* 1642192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1642203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1642206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1642209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642238 */     // MIs[0] policy
     /* 1642238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642272 */     // GIR_Coverage, 4459,
     /* 1642272 */     GIR_EraseRootFromParent_Done,
     /* 1642273 */   // Label 22616: @1642273
     /* 1642273 */   GIM_Try, /*On fail goto*//*Label 22617*/ GIMT_Encode4(1642359), // Rule ID 4462 //
     /* 1642278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642324 */     // MIs[0] policy
     /* 1642324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642358 */     // GIR_Coverage, 4462,
     /* 1642358 */     GIR_EraseRootFromParent_Done,
     /* 1642359 */   // Label 22617: @1642359
     /* 1642359 */   GIM_Try, /*On fail goto*//*Label 22618*/ GIMT_Encode4(1642445), // Rule ID 4463 //
     /* 1642364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1642375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1642378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1642381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642410 */     // MIs[0] policy
     /* 1642410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11674:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1642423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642444 */     // GIR_Coverage, 4463,
     /* 1642444 */     GIR_EraseRootFromParent_Done,
     /* 1642445 */   // Label 22618: @1642445
     /* 1642445 */   GIM_Try, /*On fail goto*//*Label 22619*/ GIMT_Encode4(1642531), // Rule ID 4466 //
     /* 1642450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642496 */     // MIs[0] policy
     /* 1642496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642530 */     // GIR_Coverage, 4466,
     /* 1642530 */     GIR_EraseRootFromParent_Done,
     /* 1642531 */   // Label 22619: @1642531
     /* 1642531 */   GIM_Try, /*On fail goto*//*Label 22620*/ GIMT_Encode4(1642617), // Rule ID 4467 //
     /* 1642536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1642547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1642550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1642553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642582 */     // MIs[0] policy
     /* 1642582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11674:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1642595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642616 */     // GIR_Coverage, 4467,
     /* 1642616 */     GIR_EraseRootFromParent_Done,
     /* 1642617 */   // Label 22620: @1642617
     /* 1642617 */   GIM_Try, /*On fail goto*//*Label 22621*/ GIMT_Encode4(1642703), // Rule ID 4470 //
     /* 1642622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1642633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1642636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1642639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642668 */     // MIs[0] policy
     /* 1642668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642678 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642702 */     // GIR_Coverage, 4470,
     /* 1642702 */     GIR_EraseRootFromParent_Done,
     /* 1642703 */   // Label 22621: @1642703
     /* 1642703 */   GIM_Try, /*On fail goto*//*Label 22622*/ GIMT_Encode4(1642789), // Rule ID 4471 //
     /* 1642708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1642719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1642722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1642725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642754 */     // MIs[0] policy
     /* 1642754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11674:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1642767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642788 */     // GIR_Coverage, 4471,
     /* 1642788 */     GIR_EraseRootFromParent_Done,
     /* 1642789 */   // Label 22622: @1642789
     /* 1642789 */   GIM_Try, /*On fail goto*//*Label 22623*/ GIMT_Encode4(1642875), // Rule ID 4474 //
     /* 1642794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1642797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1642805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1642808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1642811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1642814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642840 */     // MIs[0] policy
     /* 1642840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642850 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642874 */     // GIR_Coverage, 4474,
     /* 1642874 */     GIR_EraseRootFromParent_Done,
     /* 1642875 */   // Label 22623: @1642875
     /* 1642875 */   GIM_Try, /*On fail goto*//*Label 22624*/ GIMT_Encode4(1642961), // Rule ID 4475 //
     /* 1642880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1642883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1642888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1642891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1642894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1642897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1642900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1642922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642926 */     // MIs[0] policy
     /* 1642926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642936 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11674:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1642939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1642957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642960 */     // GIR_Coverage, 4475,
     /* 1642960 */     GIR_EraseRootFromParent_Done,
     /* 1642961 */   // Label 22624: @1642961
     /* 1642961 */   GIM_Try, /*On fail goto*//*Label 22625*/ GIMT_Encode4(1643047), // Rule ID 4484 //
     /* 1642966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1642974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1642977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1642980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1642983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1642986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643012 */     // MIs[0] policy
     /* 1643012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1643025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643046 */     // GIR_Coverage, 4484,
     /* 1643046 */     GIR_EraseRootFromParent_Done,
     /* 1643047 */   // Label 22625: @1643047
     /* 1643047 */   GIM_Try, /*On fail goto*//*Label 22626*/ GIMT_Encode4(1643133), // Rule ID 4485 //
     /* 1643052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1643063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1643066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1643069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1643072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643098 */     // MIs[0] policy
     /* 1643098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643108 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1643111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643132 */     // GIR_Coverage, 4485,
     /* 1643132 */     GIR_EraseRootFromParent_Done,
     /* 1643133 */   // Label 22626: @1643133
     /* 1643133 */   GIM_Try, /*On fail goto*//*Label 22627*/ GIMT_Encode4(1643219), // Rule ID 4494 //
     /* 1643138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1643158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643184 */     // MIs[0] policy
     /* 1643184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1643197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643218 */     // GIR_Coverage, 4494,
     /* 1643218 */     GIR_EraseRootFromParent_Done,
     /* 1643219 */   // Label 22627: @1643219
     /* 1643219 */   GIM_Try, /*On fail goto*//*Label 22628*/ GIMT_Encode4(1643305), // Rule ID 4495 //
     /* 1643224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1643235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1643238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1643241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1643244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643270 */     // MIs[0] policy
     /* 1643270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1643283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643304 */     // GIR_Coverage, 4495,
     /* 1643304 */     GIR_EraseRootFromParent_Done,
     /* 1643305 */   // Label 22628: @1643305
     /* 1643305 */   GIM_Try, /*On fail goto*//*Label 22629*/ GIMT_Encode4(1643391), // Rule ID 4504 //
     /* 1643310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1643330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643356 */     // MIs[0] policy
     /* 1643356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1643369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643390 */     // GIR_Coverage, 4504,
     /* 1643390 */     GIR_EraseRootFromParent_Done,
     /* 1643391 */   // Label 22629: @1643391
     /* 1643391 */   GIM_Try, /*On fail goto*//*Label 22630*/ GIMT_Encode4(1643477), // Rule ID 4505 //
     /* 1643396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1643407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1643410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1643413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1643416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643442 */     // MIs[0] policy
     /* 1643442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1643455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643476 */     // GIR_Coverage, 4505,
     /* 1643476 */     GIR_EraseRootFromParent_Done,
     /* 1643477 */   // Label 22630: @1643477
     /* 1643477 */   GIM_Try, /*On fail goto*//*Label 22631*/ GIMT_Encode4(1643563), // Rule ID 4514 //
     /* 1643482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1643493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1643496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1643499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1643502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643528 */     // MIs[0] policy
     /* 1643528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643538 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1643541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643562 */     // GIR_Coverage, 4514,
     /* 1643562 */     GIR_EraseRootFromParent_Done,
     /* 1643563 */   // Label 22631: @1643563
     /* 1643563 */   GIM_Try, /*On fail goto*//*Label 22632*/ GIMT_Encode4(1643649), // Rule ID 4515 //
     /* 1643568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1643579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1643582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1643585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1643588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643614 */     // MIs[0] policy
     /* 1643614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643624 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1643627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643648 */     // GIR_Coverage, 4515,
     /* 1643648 */     GIR_EraseRootFromParent_Done,
     /* 1643649 */   // Label 22632: @1643649
     /* 1643649 */   GIM_Try, /*On fail goto*//*Label 22633*/ GIMT_Encode4(1643735), // Rule ID 4524 //
     /* 1643654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1643665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1643668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1643671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1643674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1643677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643700 */     // MIs[0] policy
     /* 1643700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643710 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1643713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643734 */     // GIR_Coverage, 4524,
     /* 1643734 */     GIR_EraseRootFromParent_Done,
     /* 1643735 */   // Label 22633: @1643735
     /* 1643735 */   GIM_Try, /*On fail goto*//*Label 22634*/ GIMT_Encode4(1643821), // Rule ID 4525 //
     /* 1643740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1643751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1643754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1643757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1643760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1643763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643786 */     // MIs[0] policy
     /* 1643786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643796 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1643799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643820 */     // GIR_Coverage, 4525,
     /* 1643820 */     GIR_EraseRootFromParent_Done,
     /* 1643821 */   // Label 22634: @1643821
     /* 1643821 */   GIM_Try, /*On fail goto*//*Label 22635*/ GIMT_Encode4(1643907), // Rule ID 4534 //
     /* 1643826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1643837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1643840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1643843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1643846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1643849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643872 */     // MIs[0] policy
     /* 1643872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643882 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1643885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643906 */     // GIR_Coverage, 4534,
     /* 1643906 */     GIR_EraseRootFromParent_Done,
     /* 1643907 */   // Label 22635: @1643907
     /* 1643907 */   GIM_Try, /*On fail goto*//*Label 22636*/ GIMT_Encode4(1643993), // Rule ID 4535 //
     /* 1643912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1643920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1643923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1643926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1643929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1643932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1643935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643958 */     // MIs[0] policy
     /* 1643958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643968 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1643971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1643989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643992 */     // GIR_Coverage, 4535,
     /* 1643992 */     GIR_EraseRootFromParent_Done,
     /* 1643993 */   // Label 22636: @1643993
     /* 1643993 */   GIM_Try, /*On fail goto*//*Label 22637*/ GIMT_Encode4(1644079), // Rule ID 4544 //
     /* 1643998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1644018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644044 */     // MIs[0] policy
     /* 1644044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1644057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644078 */     // GIR_Coverage, 4544,
     /* 1644078 */     GIR_EraseRootFromParent_Done,
     /* 1644079 */   // Label 22637: @1644079
     /* 1644079 */   GIM_Try, /*On fail goto*//*Label 22638*/ GIMT_Encode4(1644165), // Rule ID 4545 //
     /* 1644084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1644095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1644098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1644101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1644104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644130 */     // MIs[0] policy
     /* 1644130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1644143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644164 */     // GIR_Coverage, 4545,
     /* 1644164 */     GIR_EraseRootFromParent_Done,
     /* 1644165 */   // Label 22638: @1644165
     /* 1644165 */   GIM_Try, /*On fail goto*//*Label 22639*/ GIMT_Encode4(1644251), // Rule ID 4554 //
     /* 1644170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1644190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644216 */     // MIs[0] policy
     /* 1644216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644250 */     // GIR_Coverage, 4554,
     /* 1644250 */     GIR_EraseRootFromParent_Done,
     /* 1644251 */   // Label 22639: @1644251
     /* 1644251 */   GIM_Try, /*On fail goto*//*Label 22640*/ GIMT_Encode4(1644337), // Rule ID 4555 //
     /* 1644256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1644267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1644270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1644273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1644276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644302 */     // MIs[0] policy
     /* 1644302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644312 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644336 */     // GIR_Coverage, 4555,
     /* 1644336 */     GIR_EraseRootFromParent_Done,
     /* 1644337 */   // Label 22640: @1644337
     /* 1644337 */   GIM_Try, /*On fail goto*//*Label 22641*/ GIMT_Encode4(1644423), // Rule ID 4564 //
     /* 1644342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1644362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644388 */     // MIs[0] policy
     /* 1644388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644422 */     // GIR_Coverage, 4564,
     /* 1644422 */     GIR_EraseRootFromParent_Done,
     /* 1644423 */   // Label 22641: @1644423
     /* 1644423 */   GIM_Try, /*On fail goto*//*Label 22642*/ GIMT_Encode4(1644509), // Rule ID 4565 //
     /* 1644428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1644439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1644442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1644445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1644448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644474 */     // MIs[0] policy
     /* 1644474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1644487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644508 */     // GIR_Coverage, 4565,
     /* 1644508 */     GIR_EraseRootFromParent_Done,
     /* 1644509 */   // Label 22642: @1644509
     /* 1644509 */   GIM_Try, /*On fail goto*//*Label 22643*/ GIMT_Encode4(1644595), // Rule ID 4574 //
     /* 1644514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1644525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1644528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1644531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1644534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644560 */     // MIs[0] policy
     /* 1644560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1644573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644594 */     // GIR_Coverage, 4574,
     /* 1644594 */     GIR_EraseRootFromParent_Done,
     /* 1644595 */   // Label 22643: @1644595
     /* 1644595 */   GIM_Try, /*On fail goto*//*Label 22644*/ GIMT_Encode4(1644681), // Rule ID 4575 //
     /* 1644600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1644611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1644614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1644617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1644620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644646 */     // MIs[0] policy
     /* 1644646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644656 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1644659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644680 */     // GIR_Coverage, 4575,
     /* 1644680 */     GIR_EraseRootFromParent_Done,
     /* 1644681 */   // Label 22644: @1644681
     /* 1644681 */   GIM_Try, /*On fail goto*//*Label 22645*/ GIMT_Encode4(1644767), // Rule ID 4584 //
     /* 1644686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1644697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1644700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1644703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1644706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644732 */     // MIs[0] policy
     /* 1644732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644742 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1644745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644766 */     // GIR_Coverage, 4584,
     /* 1644766 */     GIR_EraseRootFromParent_Done,
     /* 1644767 */   // Label 22645: @1644767
     /* 1644767 */   GIM_Try, /*On fail goto*//*Label 22646*/ GIMT_Encode4(1644853), // Rule ID 4585 //
     /* 1644772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1644783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1644786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1644789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1644792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644818 */     // MIs[0] policy
     /* 1644818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644828 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1644831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1644849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644852 */     // GIR_Coverage, 4585,
     /* 1644852 */     GIR_EraseRootFromParent_Done,
     /* 1644853 */   // Label 22646: @1644853
     /* 1644853 */   GIM_Try, /*On fail goto*//*Label 22647*/ GIMT_Encode4(1644939), // Rule ID 4594 //
     /* 1644858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1644861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1644869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1644872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1644875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1644878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644904 */     // MIs[0] policy
     /* 1644904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644914 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1644917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1644935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644938 */     // GIR_Coverage, 4594,
     /* 1644938 */     GIR_EraseRootFromParent_Done,
     /* 1644939 */   // Label 22647: @1644939
     /* 1644939 */   GIM_Try, /*On fail goto*//*Label 22648*/ GIMT_Encode4(1645025), // Rule ID 4595 //
     /* 1644944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1644947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1644952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1644955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1644958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1644961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1644964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644990 */     // MIs[0] policy
     /* 1644990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1645003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645024 */     // GIR_Coverage, 4595,
     /* 1645024 */     GIR_EraseRootFromParent_Done,
     /* 1645025 */   // Label 22648: @1645025
     /* 1645025 */   GIM_Try, /*On fail goto*//*Label 22649*/ GIMT_Encode4(1645111), // Rule ID 4604 //
     /* 1645030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1645050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645076 */     // MIs[0] policy
     /* 1645076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1645089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645110 */     // GIR_Coverage, 4604,
     /* 1645110 */     GIR_EraseRootFromParent_Done,
     /* 1645111 */   // Label 22649: @1645111
     /* 1645111 */   GIM_Try, /*On fail goto*//*Label 22650*/ GIMT_Encode4(1645197), // Rule ID 4605 //
     /* 1645116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1645127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1645130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1645133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1645136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645162 */     // MIs[0] policy
     /* 1645162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645172 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1645175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645196 */     // GIR_Coverage, 4605,
     /* 1645196 */     GIR_EraseRootFromParent_Done,
     /* 1645197 */   // Label 22650: @1645197
     /* 1645197 */   GIM_Try, /*On fail goto*//*Label 22651*/ GIMT_Encode4(1645283), // Rule ID 4614 //
     /* 1645202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1645222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645248 */     // MIs[0] policy
     /* 1645248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645258 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645282 */     // GIR_Coverage, 4614,
     /* 1645282 */     GIR_EraseRootFromParent_Done,
     /* 1645283 */   // Label 22651: @1645283
     /* 1645283 */   GIM_Try, /*On fail goto*//*Label 22652*/ GIMT_Encode4(1645369), // Rule ID 4615 //
     /* 1645288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1645299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1645302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1645305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1645308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645334 */     // MIs[0] policy
     /* 1645334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645344 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1645347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645368 */     // GIR_Coverage, 4615,
     /* 1645368 */     GIR_EraseRootFromParent_Done,
     /* 1645369 */   // Label 22652: @1645369
     /* 1645369 */   GIM_Try, /*On fail goto*//*Label 22653*/ GIMT_Encode4(1645455), // Rule ID 4624 //
     /* 1645374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1645377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1645394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645420 */     // MIs[0] policy
     /* 1645420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645430 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645454 */     // GIR_Coverage, 4624,
     /* 1645454 */     GIR_EraseRootFromParent_Done,
     /* 1645455 */   // Label 22653: @1645455
     /* 1645455 */   GIM_Try, /*On fail goto*//*Label 22654*/ GIMT_Encode4(1645541), // Rule ID 4625 //
     /* 1645460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1645463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1645471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1645474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1645477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1645480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645506 */     // MIs[0] policy
     /* 1645506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1645519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1645537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645540 */     // GIR_Coverage, 4625,
     /* 1645540 */     GIR_EraseRootFromParent_Done,
     /* 1645541 */   // Label 22654: @1645541
     /* 1645541 */   GIM_Try, /*On fail goto*//*Label 22655*/ GIMT_Encode4(1645627), // Rule ID 4628 //
     /* 1645546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1645557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1645560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1645563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645592 */     // MIs[0] policy
     /* 1645592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645602 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1645605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645626 */     // GIR_Coverage, 4628,
     /* 1645626 */     GIR_EraseRootFromParent_Done,
     /* 1645627 */   // Label 22655: @1645627
     /* 1645627 */   GIM_Try, /*On fail goto*//*Label 22656*/ GIMT_Encode4(1645713), // Rule ID 4629 //
     /* 1645632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1645643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1645646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1645649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645678 */     // MIs[0] policy
     /* 1645678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645688 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1645691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645712 */     // GIR_Coverage, 4629,
     /* 1645712 */     GIR_EraseRootFromParent_Done,
     /* 1645713 */   // Label 22656: @1645713
     /* 1645713 */   GIM_Try, /*On fail goto*//*Label 22657*/ GIMT_Encode4(1645799), // Rule ID 4632 //
     /* 1645718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1645729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1645732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1645735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645764 */     // MIs[0] policy
     /* 1645764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645774 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1645777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645798 */     // GIR_Coverage, 4632,
     /* 1645798 */     GIR_EraseRootFromParent_Done,
     /* 1645799 */   // Label 22657: @1645799
     /* 1645799 */   GIM_Try, /*On fail goto*//*Label 22658*/ GIMT_Encode4(1645885), // Rule ID 4633 //
     /* 1645804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1645815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1645818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1645821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645850 */     // MIs[0] policy
     /* 1645850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1645863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645884 */     // GIR_Coverage, 4633,
     /* 1645884 */     GIR_EraseRootFromParent_Done,
     /* 1645885 */   // Label 22658: @1645885
     /* 1645885 */   GIM_Try, /*On fail goto*//*Label 22659*/ GIMT_Encode4(1645971), // Rule ID 4636 //
     /* 1645890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1645901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1645904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1645907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645936 */     // MIs[0] policy
     /* 1645936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1645949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645970 */     // GIR_Coverage, 4636,
     /* 1645970 */     GIR_EraseRootFromParent_Done,
     /* 1645971 */   // Label 22659: @1645971
     /* 1645971 */   GIM_Try, /*On fail goto*//*Label 22660*/ GIMT_Encode4(1646057), // Rule ID 4637 //
     /* 1645976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1645984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1645987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1645990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1645993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646022 */     // MIs[0] policy
     /* 1646022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11642:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646056 */     // GIR_Coverage, 4637,
     /* 1646056 */     GIR_EraseRootFromParent_Done,
     /* 1646057 */   // Label 22660: @1646057
     /* 1646057 */   GIM_Try, /*On fail goto*//*Label 22661*/ GIMT_Encode4(1646143), // Rule ID 4640 //
     /* 1646062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646108 */     // MIs[0] policy
     /* 1646108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646142 */     // GIR_Coverage, 4640,
     /* 1646142 */     GIR_EraseRootFromParent_Done,
     /* 1646143 */   // Label 22661: @1646143
     /* 1646143 */   GIM_Try, /*On fail goto*//*Label 22662*/ GIMT_Encode4(1646229), // Rule ID 4641 //
     /* 1646148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1646159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1646162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1646165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646194 */     // MIs[0] policy
     /* 1646194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646204 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646228 */     // GIR_Coverage, 4641,
     /* 1646228 */     GIR_EraseRootFromParent_Done,
     /* 1646229 */   // Label 22662: @1646229
     /* 1646229 */   GIM_Try, /*On fail goto*//*Label 22663*/ GIMT_Encode4(1646315), // Rule ID 4644 //
     /* 1646234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646280 */     // MIs[0] policy
     /* 1646280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646290 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1646293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646314 */     // GIR_Coverage, 4644,
     /* 1646314 */     GIR_EraseRootFromParent_Done,
     /* 1646315 */   // Label 22663: @1646315
     /* 1646315 */   GIM_Try, /*On fail goto*//*Label 22664*/ GIMT_Encode4(1646401), // Rule ID 4645 //
     /* 1646320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1646331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1646334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1646337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1646343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646366 */     // MIs[0] policy
     /* 1646366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646376 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1646379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646400 */     // GIR_Coverage, 4645,
     /* 1646400 */     GIR_EraseRootFromParent_Done,
     /* 1646401 */   // Label 22664: @1646401
     /* 1646401 */   GIM_Try, /*On fail goto*//*Label 22665*/ GIMT_Encode4(1646487), // Rule ID 4648 //
     /* 1646406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646452 */     // MIs[0] policy
     /* 1646452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646462 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1646465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646486 */     // GIR_Coverage, 4648,
     /* 1646486 */     GIR_EraseRootFromParent_Done,
     /* 1646487 */   // Label 22665: @1646487
     /* 1646487 */   GIM_Try, /*On fail goto*//*Label 22666*/ GIMT_Encode4(1646573), // Rule ID 4649 //
     /* 1646492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1646503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1646506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1646509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1646515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646538 */     // MIs[0] policy
     /* 1646538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646548 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1646551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646572 */     // GIR_Coverage, 4649,
     /* 1646572 */     GIR_EraseRootFromParent_Done,
     /* 1646573 */   // Label 22666: @1646573
     /* 1646573 */   GIM_Try, /*On fail goto*//*Label 22667*/ GIMT_Encode4(1646659), // Rule ID 4652 //
     /* 1646578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1646589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1646592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1646595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646624 */     // MIs[0] policy
     /* 1646624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1646637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646658 */     // GIR_Coverage, 4652,
     /* 1646658 */     GIR_EraseRootFromParent_Done,
     /* 1646659 */   // Label 22667: @1646659
     /* 1646659 */   GIM_Try, /*On fail goto*//*Label 22668*/ GIMT_Encode4(1646745), // Rule ID 4653 //
     /* 1646664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1646675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1646678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1646681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646710 */     // MIs[0] policy
     /* 1646710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646720 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1646723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646744 */     // GIR_Coverage, 4653,
     /* 1646744 */     GIR_EraseRootFromParent_Done,
     /* 1646745 */   // Label 22668: @1646745
     /* 1646745 */   GIM_Try, /*On fail goto*//*Label 22669*/ GIMT_Encode4(1646831), // Rule ID 4656 //
     /* 1646750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1646761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1646764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1646767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646796 */     // MIs[0] policy
     /* 1646796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646830 */     // GIR_Coverage, 4656,
     /* 1646830 */     GIR_EraseRootFromParent_Done,
     /* 1646831 */   // Label 22669: @1646831
     /* 1646831 */   GIM_Try, /*On fail goto*//*Label 22670*/ GIMT_Encode4(1646917), // Rule ID 4657 //
     /* 1646836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1646847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1646850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1646853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646882 */     // MIs[0] policy
     /* 1646882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646892 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11642:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1646895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646916 */     // GIR_Coverage, 4657,
     /* 1646916 */     GIR_EraseRootFromParent_Done,
     /* 1646917 */   // Label 22670: @1646917
     /* 1646917 */   GIM_Try, /*On fail goto*//*Label 22671*/ GIMT_Encode4(1647003), // Rule ID 4660 //
     /* 1646922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1646930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1646933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1646936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1646939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646968 */     // MIs[0] policy
     /* 1646968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646978 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1646981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647002 */     // GIR_Coverage, 4660,
     /* 1647002 */     GIR_EraseRootFromParent_Done,
     /* 1647003 */   // Label 22671: @1647003
     /* 1647003 */   GIM_Try, /*On fail goto*//*Label 22672*/ GIMT_Encode4(1647089), // Rule ID 4661 //
     /* 1647008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1647019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1647022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1647025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647054 */     // MIs[0] policy
     /* 1647054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647088 */     // GIR_Coverage, 4661,
     /* 1647088 */     GIR_EraseRootFromParent_Done,
     /* 1647089 */   // Label 22672: @1647089
     /* 1647089 */   GIM_Try, /*On fail goto*//*Label 22673*/ GIMT_Encode4(1647175), // Rule ID 4664 //
     /* 1647094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647140 */     // MIs[0] policy
     /* 1647140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647150 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647174 */     // GIR_Coverage, 4664,
     /* 1647174 */     GIR_EraseRootFromParent_Done,
     /* 1647175 */   // Label 22673: @1647175
     /* 1647175 */   GIM_Try, /*On fail goto*//*Label 22674*/ GIMT_Encode4(1647261), // Rule ID 4665 //
     /* 1647180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1647191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1647194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1647197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647226 */     // MIs[0] policy
     /* 1647226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647236 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647260 */     // GIR_Coverage, 4665,
     /* 1647260 */     GIR_EraseRootFromParent_Done,
     /* 1647261 */   // Label 22674: @1647261
     /* 1647261 */   GIM_Try, /*On fail goto*//*Label 22675*/ GIMT_Encode4(1647347), // Rule ID 4668 //
     /* 1647266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647312 */     // MIs[0] policy
     /* 1647312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647346 */     // GIR_Coverage, 4668,
     /* 1647346 */     GIR_EraseRootFromParent_Done,
     /* 1647347 */   // Label 22675: @1647347
     /* 1647347 */   GIM_Try, /*On fail goto*//*Label 22676*/ GIMT_Encode4(1647433), // Rule ID 4669 //
     /* 1647352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1647363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1647366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1647369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1647375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647398 */     // MIs[0] policy
     /* 1647398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647408 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1647411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647432 */     // GIR_Coverage, 4669,
     /* 1647432 */     GIR_EraseRootFromParent_Done,
     /* 1647433 */   // Label 22676: @1647433
     /* 1647433 */   GIM_Try, /*On fail goto*//*Label 22677*/ GIMT_Encode4(1647519), // Rule ID 4672 //
     /* 1647438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1647449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1647452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1647455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647484 */     // MIs[0] policy
     /* 1647484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647518 */     // GIR_Coverage, 4672,
     /* 1647518 */     GIR_EraseRootFromParent_Done,
     /* 1647519 */   // Label 22677: @1647519
     /* 1647519 */   GIM_Try, /*On fail goto*//*Label 22678*/ GIMT_Encode4(1647605), // Rule ID 4673 //
     /* 1647524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1647527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1647535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1647538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1647541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647570 */     // MIs[0] policy
     /* 1647570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647580 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11642:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1647583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647604 */     // GIR_Coverage, 4673,
     /* 1647604 */     GIR_EraseRootFromParent_Done,
     /* 1647605 */   // Label 22678: @1647605
     /* 1647605 */   GIM_Try, /*On fail goto*//*Label 22679*/ GIMT_Encode4(1647691), // Rule ID 4676 //
     /* 1647610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1647621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1647624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1647627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647656 */     // MIs[0] policy
     /* 1647656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647690 */     // GIR_Coverage, 4676,
     /* 1647690 */     GIR_EraseRootFromParent_Done,
     /* 1647691 */   // Label 22679: @1647691
     /* 1647691 */   GIM_Try, /*On fail goto*//*Label 22680*/ GIMT_Encode4(1647777), // Rule ID 4677 //
     /* 1647696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1647699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1647707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1647710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1647713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1647726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1647734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647742 */     // MIs[0] policy
     /* 1647742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11642:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1647755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647776 */     // GIR_Coverage, 4677,
     /* 1647776 */     GIR_EraseRootFromParent_Done,
     /* 1647777 */   // Label 22680: @1647777
     /* 1647777 */   GIM_Try, /*On fail goto*//*Label 22681*/ GIMT_Encode4(1647863), // Rule ID 4680 //
     /* 1647782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1647793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1647796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1647799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647828 */     // MIs[0] policy
     /* 1647828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647862 */     // GIR_Coverage, 4680,
     /* 1647862 */     GIR_EraseRootFromParent_Done,
     /* 1647863 */   // Label 22681: @1647863
     /* 1647863 */   GIM_Try, /*On fail goto*//*Label 22682*/ GIMT_Encode4(1647949), // Rule ID 4681 //
     /* 1647868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1647871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1647879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1647882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1647885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1647888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1647898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1647906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647914 */     // MIs[0] policy
     /* 1647914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647924 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11642:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1647927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647948 */     // GIR_Coverage, 4681,
     /* 1647948 */     GIR_EraseRootFromParent_Done,
     /* 1647949 */   // Label 22682: @1647949
     /* 1647949 */   GIM_Try, /*On fail goto*//*Label 22683*/ GIMT_Encode4(1648035), // Rule ID 4684 //
     /* 1647954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1647957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1647962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1647965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1647968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1647971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1647974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1647984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1647992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1647996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648000 */     // MIs[0] policy
     /* 1648000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1648013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648034 */     // GIR_Coverage, 4684,
     /* 1648034 */     GIR_EraseRootFromParent_Done,
     /* 1648035 */   // Label 22683: @1648035
     /* 1648035 */   GIM_Try, /*On fail goto*//*Label 22684*/ GIMT_Encode4(1648121), // Rule ID 4685 //
     /* 1648040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1648043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1648048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1648051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1648054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1648057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1648060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1648082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648086 */     // MIs[0] policy
     /* 1648086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648096 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11642:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1648099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648120 */     // GIR_Coverage, 4685,
     /* 1648120 */     GIR_EraseRootFromParent_Done,
     /* 1648121 */   // Label 22684: @1648121
     /* 1648121 */   GIM_Try, /*On fail goto*//*Label 22685*/ GIMT_Encode4(1648207), // Rule ID 4694 //
     /* 1648126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1648146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648172 */     // MIs[0] policy
     /* 1648172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648182 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1648185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648206 */     // GIR_Coverage, 4694,
     /* 1648206 */     GIR_EraseRootFromParent_Done,
     /* 1648207 */   // Label 22685: @1648207
     /* 1648207 */   GIM_Try, /*On fail goto*//*Label 22686*/ GIMT_Encode4(1648293), // Rule ID 4695 //
     /* 1648212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1648223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1648226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1648229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1648232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648258 */     // MIs[0] policy
     /* 1648258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648268 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1648271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648292 */     // GIR_Coverage, 4695,
     /* 1648292 */     GIR_EraseRootFromParent_Done,
     /* 1648293 */   // Label 22686: @1648293
     /* 1648293 */   GIM_Try, /*On fail goto*//*Label 22687*/ GIMT_Encode4(1648379), // Rule ID 4704 //
     /* 1648298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1648318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648344 */     // MIs[0] policy
     /* 1648344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648354 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1648357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648378 */     // GIR_Coverage, 4704,
     /* 1648378 */     GIR_EraseRootFromParent_Done,
     /* 1648379 */   // Label 22687: @1648379
     /* 1648379 */   GIM_Try, /*On fail goto*//*Label 22688*/ GIMT_Encode4(1648465), // Rule ID 4705 //
     /* 1648384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1648395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1648398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1648401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1648404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648430 */     // MIs[0] policy
     /* 1648430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1648443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648464 */     // GIR_Coverage, 4705,
     /* 1648464 */     GIR_EraseRootFromParent_Done,
     /* 1648465 */   // Label 22688: @1648465
     /* 1648465 */   GIM_Try, /*On fail goto*//*Label 22689*/ GIMT_Encode4(1648551), // Rule ID 4714 //
     /* 1648470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1648481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1648484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1648487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1648490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648516 */     // MIs[0] policy
     /* 1648516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648526 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1648529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648550 */     // GIR_Coverage, 4714,
     /* 1648550 */     GIR_EraseRootFromParent_Done,
     /* 1648551 */   // Label 22689: @1648551
     /* 1648551 */   GIM_Try, /*On fail goto*//*Label 22690*/ GIMT_Encode4(1648637), // Rule ID 4715 //
     /* 1648556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1648567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1648570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1648573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1648576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648602 */     // MIs[0] policy
     /* 1648602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648612 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1648615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648636 */     // GIR_Coverage, 4715,
     /* 1648636 */     GIR_EraseRootFromParent_Done,
     /* 1648637 */   // Label 22690: @1648637
     /* 1648637 */   GIM_Try, /*On fail goto*//*Label 22691*/ GIMT_Encode4(1648723), // Rule ID 4724 //
     /* 1648642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1648653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1648656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1648659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1648662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648688 */     // MIs[0] policy
     /* 1648688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1648701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648722 */     // GIR_Coverage, 4724,
     /* 1648722 */     GIR_EraseRootFromParent_Done,
     /* 1648723 */   // Label 22691: @1648723
     /* 1648723 */   GIM_Try, /*On fail goto*//*Label 22692*/ GIMT_Encode4(1648809), // Rule ID 4725 //
     /* 1648728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1648739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1648742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1648745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1648748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648774 */     // MIs[0] policy
     /* 1648774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648784 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1648787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648808 */     // GIR_Coverage, 4725,
     /* 1648808 */     GIR_EraseRootFromParent_Done,
     /* 1648809 */   // Label 22692: @1648809
     /* 1648809 */   GIM_Try, /*On fail goto*//*Label 22693*/ GIMT_Encode4(1648895), // Rule ID 4734 //
     /* 1648814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1648825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1648828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1648831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1648834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648860 */     // MIs[0] policy
     /* 1648860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648870 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1648873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648894 */     // GIR_Coverage, 4734,
     /* 1648894 */     GIR_EraseRootFromParent_Done,
     /* 1648895 */   // Label 22693: @1648895
     /* 1648895 */   GIM_Try, /*On fail goto*//*Label 22694*/ GIMT_Encode4(1648981), // Rule ID 4735 //
     /* 1648900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1648911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1648914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1648917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1648920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648946 */     // MIs[0] policy
     /* 1648946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648956 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1648959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648980 */     // GIR_Coverage, 4735,
     /* 1648980 */     GIR_EraseRootFromParent_Done,
     /* 1648981 */   // Label 22694: @1648981
     /* 1648981 */   GIM_Try, /*On fail goto*//*Label 22695*/ GIMT_Encode4(1649067), // Rule ID 4744 //
     /* 1648986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1648994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1648997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1649006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649032 */     // MIs[0] policy
     /* 1649032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649042 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649066 */     // GIR_Coverage, 4744,
     /* 1649066 */     GIR_EraseRootFromParent_Done,
     /* 1649067 */   // Label 22695: @1649067
     /* 1649067 */   GIM_Try, /*On fail goto*//*Label 22696*/ GIMT_Encode4(1649153), // Rule ID 4745 //
     /* 1649072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1649092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649118 */     // MIs[0] policy
     /* 1649118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649128 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1649149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649152 */     // GIR_Coverage, 4745,
     /* 1649152 */     GIR_EraseRootFromParent_Done,
     /* 1649153 */   // Label 22696: @1649153
     /* 1649153 */   GIM_Try, /*On fail goto*//*Label 22697*/ GIMT_Encode4(1649239), // Rule ID 4754 //
     /* 1649158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1649178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649204 */     // MIs[0] policy
     /* 1649204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1649217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649238 */     // GIR_Coverage, 4754,
     /* 1649238 */     GIR_EraseRootFromParent_Done,
     /* 1649239 */   // Label 22697: @1649239
     /* 1649239 */   GIM_Try, /*On fail goto*//*Label 22698*/ GIMT_Encode4(1649325), // Rule ID 4755 //
     /* 1649244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1649255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1649258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1649261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1649264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1649267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649290 */     // MIs[0] policy
     /* 1649290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1649303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649324 */     // GIR_Coverage, 4755,
     /* 1649324 */     GIR_EraseRootFromParent_Done,
     /* 1649325 */   // Label 22698: @1649325
     /* 1649325 */   GIM_Try, /*On fail goto*//*Label 22699*/ GIMT_Encode4(1649411), // Rule ID 4764 //
     /* 1649330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1649350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649376 */     // MIs[0] policy
     /* 1649376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649386 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649410 */     // GIR_Coverage, 4764,
     /* 1649410 */     GIR_EraseRootFromParent_Done,
     /* 1649411 */   // Label 22699: @1649411
     /* 1649411 */   GIM_Try, /*On fail goto*//*Label 22700*/ GIMT_Encode4(1649497), // Rule ID 4765 //
     /* 1649416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1649427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1649430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1649433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1649436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1649446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649462 */     // MIs[0] policy
     /* 1649462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649472 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1649475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649496 */     // GIR_Coverage, 4765,
     /* 1649496 */     GIR_EraseRootFromParent_Done,
     /* 1649497 */   // Label 22700: @1649497
     /* 1649497 */   GIM_Try, /*On fail goto*//*Label 22701*/ GIMT_Encode4(1649583), // Rule ID 4774 //
     /* 1649502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1649522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649548 */     // MIs[0] policy
     /* 1649548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649558 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1649561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649582 */     // GIR_Coverage, 4774,
     /* 1649582 */     GIR_EraseRootFromParent_Done,
     /* 1649583 */   // Label 22701: @1649583
     /* 1649583 */   GIM_Try, /*On fail goto*//*Label 22702*/ GIMT_Encode4(1649669), // Rule ID 4775 //
     /* 1649588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1649608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1649630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649634 */     // MIs[0] policy
     /* 1649634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1649647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649668 */     // GIR_Coverage, 4775,
     /* 1649668 */     GIR_EraseRootFromParent_Done,
     /* 1649669 */   // Label 22702: @1649669
     /* 1649669 */   GIM_Try, /*On fail goto*//*Label 22703*/ GIMT_Encode4(1649755), // Rule ID 4784 //
     /* 1649674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1649685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1649688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1649691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1649694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649720 */     // MIs[0] policy
     /* 1649720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649730 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1649733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649754 */     // GIR_Coverage, 4784,
     /* 1649754 */     GIR_EraseRootFromParent_Done,
     /* 1649755 */   // Label 22703: @1649755
     /* 1649755 */   GIM_Try, /*On fail goto*//*Label 22704*/ GIMT_Encode4(1649841), // Rule ID 4785 //
     /* 1649760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1649771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1649774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1649777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1649780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649806 */     // MIs[0] policy
     /* 1649806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1649819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649840 */     // GIR_Coverage, 4785,
     /* 1649840 */     GIR_EraseRootFromParent_Done,
     /* 1649841 */   // Label 22704: @1649841
     /* 1649841 */   GIM_Try, /*On fail goto*//*Label 22705*/ GIMT_Encode4(1649927), // Rule ID 4794 //
     /* 1649846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1649857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1649860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1649863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1649866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649892 */     // MIs[0] policy
     /* 1649892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649902 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649926 */     // GIR_Coverage, 4794,
     /* 1649926 */     GIR_EraseRootFromParent_Done,
     /* 1649927 */   // Label 22705: @1649927
     /* 1649927 */   GIM_Try, /*On fail goto*//*Label 22706*/ GIMT_Encode4(1650013), // Rule ID 4795 //
     /* 1649932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1649940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1649943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1649946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1649949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1649952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649978 */     // MIs[0] policy
     /* 1649978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1649991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1650009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650012 */     // GIR_Coverage, 4795,
     /* 1650012 */     GIR_EraseRootFromParent_Done,
     /* 1650013 */   // Label 22706: @1650013
     /* 1650013 */   GIM_Try, /*On fail goto*//*Label 22707*/ GIMT_Encode4(1650099), // Rule ID 4804 //
     /* 1650018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1650038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650064 */     // MIs[0] policy
     /* 1650064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1650077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650098 */     // GIR_Coverage, 4804,
     /* 1650098 */     GIR_EraseRootFromParent_Done,
     /* 1650099 */   // Label 22707: @1650099
     /* 1650099 */   GIM_Try, /*On fail goto*//*Label 22708*/ GIMT_Encode4(1650185), // Rule ID 4805 //
     /* 1650104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1650115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1650118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1650121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1650124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650150 */     // MIs[0] policy
     /* 1650150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650160 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1650163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650184 */     // GIR_Coverage, 4805,
     /* 1650184 */     GIR_EraseRootFromParent_Done,
     /* 1650185 */   // Label 22708: @1650185
     /* 1650185 */   GIM_Try, /*On fail goto*//*Label 22709*/ GIMT_Encode4(1650271), // Rule ID 4814 //
     /* 1650190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1650210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650236 */     // MIs[0] policy
     /* 1650236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650270 */     // GIR_Coverage, 4814,
     /* 1650270 */     GIR_EraseRootFromParent_Done,
     /* 1650271 */   // Label 22709: @1650271
     /* 1650271 */   GIM_Try, /*On fail goto*//*Label 22710*/ GIMT_Encode4(1650357), // Rule ID 4815 //
     /* 1650276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1650296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650322 */     // MIs[0] policy
     /* 1650322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1650335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650356 */     // GIR_Coverage, 4815,
     /* 1650356 */     GIR_EraseRootFromParent_Done,
     /* 1650357 */   // Label 22710: @1650357
     /* 1650357 */   GIM_Try, /*On fail goto*//*Label 22711*/ GIMT_Encode4(1650443), // Rule ID 4824 //
     /* 1650362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1650382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650408 */     // MIs[0] policy
     /* 1650408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650442 */     // GIR_Coverage, 4824,
     /* 1650442 */     GIR_EraseRootFromParent_Done,
     /* 1650443 */   // Label 22711: @1650443
     /* 1650443 */   GIM_Try, /*On fail goto*//*Label 22712*/ GIMT_Encode4(1650529), // Rule ID 4825 //
     /* 1650448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1650468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650494 */     // MIs[0] policy
     /* 1650494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650504 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1650507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650528 */     // GIR_Coverage, 4825,
     /* 1650528 */     GIR_EraseRootFromParent_Done,
     /* 1650529 */   // Label 22712: @1650529
     /* 1650529 */   GIM_Try, /*On fail goto*//*Label 22713*/ GIMT_Encode4(1650615), // Rule ID 4834 //
     /* 1650534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1650537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1650545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1650548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1650551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1650554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650580 */     // MIs[0] policy
     /* 1650580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1650593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650614 */     // GIR_Coverage, 4834,
     /* 1650614 */     GIR_EraseRootFromParent_Done,
     /* 1650615 */   // Label 22713: @1650615
     /* 1650615 */   GIM_Try, /*On fail goto*//*Label 22714*/ GIMT_Encode4(1650701), // Rule ID 4835 //
     /* 1650620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1650623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1650631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1650634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1650637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1650640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650666 */     // MIs[0] policy
     /* 1650666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1650679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1650697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650700 */     // GIR_Coverage, 4835,
     /* 1650700 */     GIR_EraseRootFromParent_Done,
     /* 1650701 */   // Label 22714: @1650701
     /* 1650701 */   GIM_Try, /*On fail goto*//*Label 22715*/ GIMT_Encode4(1650787), // Rule ID 4838 //
     /* 1650706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1650717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1650720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1650723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650752 */     // MIs[0] policy
     /* 1650752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650762 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1650765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650786 */     // GIR_Coverage, 4838,
     /* 1650786 */     GIR_EraseRootFromParent_Done,
     /* 1650787 */   // Label 22715: @1650787
     /* 1650787 */   GIM_Try, /*On fail goto*//*Label 22716*/ GIMT_Encode4(1650873), // Rule ID 4839 //
     /* 1650792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1650803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1650806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1650809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650838 */     // MIs[0] policy
     /* 1650838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650848 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1650851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650872 */     // GIR_Coverage, 4839,
     /* 1650872 */     GIR_EraseRootFromParent_Done,
     /* 1650873 */   // Label 22716: @1650873
     /* 1650873 */   GIM_Try, /*On fail goto*//*Label 22717*/ GIMT_Encode4(1650959), // Rule ID 4842 //
     /* 1650878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1650889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1650892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1650895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650924 */     // MIs[0] policy
     /* 1650924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650934 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1650937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650958 */     // GIR_Coverage, 4842,
     /* 1650958 */     GIR_EraseRootFromParent_Done,
     /* 1650959 */   // Label 22717: @1650959
     /* 1650959 */   GIM_Try, /*On fail goto*//*Label 22718*/ GIMT_Encode4(1651045), // Rule ID 4843 //
     /* 1650964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1650972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1650975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1650978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1650981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651010 */     // MIs[0] policy
     /* 1651010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651020 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651044 */     // GIR_Coverage, 4843,
     /* 1651044 */     GIR_EraseRootFromParent_Done,
     /* 1651045 */   // Label 22718: @1651045
     /* 1651045 */   GIM_Try, /*On fail goto*//*Label 22719*/ GIMT_Encode4(1651131), // Rule ID 4846 //
     /* 1651050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651096 */     // MIs[0] policy
     /* 1651096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651106 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651130 */     // GIR_Coverage, 4846,
     /* 1651130 */     GIR_EraseRootFromParent_Done,
     /* 1651131 */   // Label 22719: @1651131
     /* 1651131 */   GIM_Try, /*On fail goto*//*Label 22720*/ GIMT_Encode4(1651217), // Rule ID 4847 //
     /* 1651136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651182 */     // MIs[0] policy
     /* 1651182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651192 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11670:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651216 */     // GIR_Coverage, 4847,
     /* 1651216 */     GIR_EraseRootFromParent_Done,
     /* 1651217 */   // Label 22720: @1651217
     /* 1651217 */   GIM_Try, /*On fail goto*//*Label 22721*/ GIMT_Encode4(1651303), // Rule ID 4850 //
     /* 1651222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651268 */     // MIs[0] policy
     /* 1651268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651278 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1651281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651302 */     // GIR_Coverage, 4850,
     /* 1651302 */     GIR_EraseRootFromParent_Done,
     /* 1651303 */   // Label 22721: @1651303
     /* 1651303 */   GIM_Try, /*On fail goto*//*Label 22722*/ GIMT_Encode4(1651389), // Rule ID 4851 //
     /* 1651308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1651319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1651322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1651325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1651338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1651346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651354 */     // MIs[0] policy
     /* 1651354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651364 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1651367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651388 */     // GIR_Coverage, 4851,
     /* 1651388 */     GIR_EraseRootFromParent_Done,
     /* 1651389 */   // Label 22722: @1651389
     /* 1651389 */   GIM_Try, /*On fail goto*//*Label 22723*/ GIMT_Encode4(1651475), // Rule ID 4854 //
     /* 1651394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651440 */     // MIs[0] policy
     /* 1651440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651450 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1651453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651474 */     // GIR_Coverage, 4854,
     /* 1651474 */     GIR_EraseRootFromParent_Done,
     /* 1651475 */   // Label 22723: @1651475
     /* 1651475 */   GIM_Try, /*On fail goto*//*Label 22724*/ GIMT_Encode4(1651561), // Rule ID 4855 //
     /* 1651480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1651491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1651494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1651497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1651503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1651510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1651518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651526 */     // MIs[0] policy
     /* 1651526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651536 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1651539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651560 */     // GIR_Coverage, 4855,
     /* 1651560 */     GIR_EraseRootFromParent_Done,
     /* 1651561 */   // Label 22724: @1651561
     /* 1651561 */   GIM_Try, /*On fail goto*//*Label 22725*/ GIMT_Encode4(1651647), // Rule ID 4858 //
     /* 1651566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1651577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1651580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1651583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1651589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651612 */     // MIs[0] policy
     /* 1651612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651622 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1651625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651646 */     // GIR_Coverage, 4858,
     /* 1651646 */     GIR_EraseRootFromParent_Done,
     /* 1651647 */   // Label 22725: @1651647
     /* 1651647 */   GIM_Try, /*On fail goto*//*Label 22726*/ GIMT_Encode4(1651733), // Rule ID 4859 //
     /* 1651652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1651663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1651666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1651669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1651675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1651682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1651690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651698 */     // MIs[0] policy
     /* 1651698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651708 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1651711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651732 */     // GIR_Coverage, 4859,
     /* 1651732 */     GIR_EraseRootFromParent_Done,
     /* 1651733 */   // Label 22726: @1651733
     /* 1651733 */   GIM_Try, /*On fail goto*//*Label 22727*/ GIMT_Encode4(1651819), // Rule ID 4862 //
     /* 1651738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1651749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1651752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1651755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651784 */     // MIs[0] policy
     /* 1651784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651818 */     // GIR_Coverage, 4862,
     /* 1651818 */     GIR_EraseRootFromParent_Done,
     /* 1651819 */   // Label 22727: @1651819
     /* 1651819 */   GIM_Try, /*On fail goto*//*Label 22728*/ GIMT_Encode4(1651905), // Rule ID 4863 //
     /* 1651824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1651835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1651838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1651841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651870 */     // MIs[0] policy
     /* 1651870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651880 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1651883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651904 */     // GIR_Coverage, 4863,
     /* 1651904 */     GIR_EraseRootFromParent_Done,
     /* 1651905 */   // Label 22728: @1651905
     /* 1651905 */   GIM_Try, /*On fail goto*//*Label 22729*/ GIMT_Encode4(1651991), // Rule ID 4866 //
     /* 1651910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1651918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1651921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1651924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1651927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651956 */     // MIs[0] policy
     /* 1651956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1651969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651990 */     // GIR_Coverage, 4866,
     /* 1651990 */     GIR_EraseRootFromParent_Done,
     /* 1651991 */   // Label 22729: @1651991
     /* 1651991 */   GIM_Try, /*On fail goto*//*Label 22730*/ GIMT_Encode4(1652077), // Rule ID 4867 //
     /* 1651996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1652007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1652010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1652013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652042 */     // MIs[0] policy
     /* 1652042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11670:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652076 */     // GIR_Coverage, 4867,
     /* 1652076 */     GIR_EraseRootFromParent_Done,
     /* 1652077 */   // Label 22730: @1652077
     /* 1652077 */   GIM_Try, /*On fail goto*//*Label 22731*/ GIMT_Encode4(1652163), // Rule ID 4870 //
     /* 1652082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652128 */     // MIs[0] policy
     /* 1652128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652162 */     // GIR_Coverage, 4870,
     /* 1652162 */     GIR_EraseRootFromParent_Done,
     /* 1652163 */   // Label 22731: @1652163
     /* 1652163 */   GIM_Try, /*On fail goto*//*Label 22732*/ GIMT_Encode4(1652249), // Rule ID 4871 //
     /* 1652168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1652179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1652182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1652185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652214 */     // MIs[0] policy
     /* 1652214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652224 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652248 */     // GIR_Coverage, 4871,
     /* 1652248 */     GIR_EraseRootFromParent_Done,
     /* 1652249 */   // Label 22732: @1652249
     /* 1652249 */   GIM_Try, /*On fail goto*//*Label 22733*/ GIMT_Encode4(1652335), // Rule ID 4874 //
     /* 1652254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652300 */     // MIs[0] policy
     /* 1652300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652310 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652334 */     // GIR_Coverage, 4874,
     /* 1652334 */     GIR_EraseRootFromParent_Done,
     /* 1652335 */   // Label 22733: @1652335
     /* 1652335 */   GIM_Try, /*On fail goto*//*Label 22734*/ GIMT_Encode4(1652421), // Rule ID 4875 //
     /* 1652340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1652351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1652354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1652357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652386 */     // MIs[0] policy
     /* 1652386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1652399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652420 */     // GIR_Coverage, 4875,
     /* 1652420 */     GIR_EraseRootFromParent_Done,
     /* 1652421 */   // Label 22734: @1652421
     /* 1652421 */   GIM_Try, /*On fail goto*//*Label 22735*/ GIMT_Encode4(1652507), // Rule ID 4878 //
     /* 1652426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1652440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1652443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652472 */     // MIs[0] policy
     /* 1652472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652482 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652506 */     // GIR_Coverage, 4878,
     /* 1652506 */     GIR_EraseRootFromParent_Done,
     /* 1652507 */   // Label 22735: @1652507
     /* 1652507 */   GIM_Try, /*On fail goto*//*Label 22736*/ GIMT_Encode4(1652593), // Rule ID 4879 //
     /* 1652512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1652523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1652526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1652529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652558 */     // MIs[0] policy
     /* 1652558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652568 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1652571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652592 */     // GIR_Coverage, 4879,
     /* 1652592 */     GIR_EraseRootFromParent_Done,
     /* 1652593 */   // Label 22736: @1652593
     /* 1652593 */   GIM_Try, /*On fail goto*//*Label 22737*/ GIMT_Encode4(1652679), // Rule ID 4882 //
     /* 1652598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1652601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1652609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1652612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1652615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652644 */     // MIs[0] policy
     /* 1652644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652654 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652678 */     // GIR_Coverage, 4882,
     /* 1652678 */     GIR_EraseRootFromParent_Done,
     /* 1652679 */   // Label 22737: @1652679
     /* 1652679 */   GIM_Try, /*On fail goto*//*Label 22738*/ GIMT_Encode4(1652765), // Rule ID 4883 //
     /* 1652684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1652687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1652695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1652698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1652701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652730 */     // MIs[0] policy
     /* 1652730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652740 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11670:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1652743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652764 */     // GIR_Coverage, 4883,
     /* 1652764 */     GIR_EraseRootFromParent_Done,
     /* 1652765 */   // Label 22738: @1652765
     /* 1652765 */   GIM_Try, /*On fail goto*//*Label 22739*/ GIMT_Encode4(1652851), // Rule ID 4886 //
     /* 1652770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1652773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1652781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1652784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1652787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652816 */     // MIs[0] policy
     /* 1652816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652850 */     // GIR_Coverage, 4886,
     /* 1652850 */     GIR_EraseRootFromParent_Done,
     /* 1652851 */   // Label 22739: @1652851
     /* 1652851 */   GIM_Try, /*On fail goto*//*Label 22740*/ GIMT_Encode4(1652937), // Rule ID 4887 //
     /* 1652856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1652859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1652867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1652870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1652873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1652879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652902 */     // MIs[0] policy
     /* 1652902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11670:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1652915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652936 */     // GIR_Coverage, 4887,
     /* 1652936 */     GIR_EraseRootFromParent_Done,
     /* 1652937 */   // Label 22740: @1652937
     /* 1652937 */   GIM_Try, /*On fail goto*//*Label 22741*/ GIMT_Encode4(1653023), // Rule ID 4890 //
     /* 1652942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1652945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1652950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1652953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1652956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1652959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1652965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652988 */     // MIs[0] policy
     /* 1652988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1653001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653022 */     // GIR_Coverage, 4890,
     /* 1653022 */     GIR_EraseRootFromParent_Done,
     /* 1653023 */   // Label 22741: @1653023
     /* 1653023 */   GIM_Try, /*On fail goto*//*Label 22742*/ GIMT_Encode4(1653109), // Rule ID 4891 //
     /* 1653028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1653039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1653042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1653045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653074 */     // MIs[0] policy
     /* 1653074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653084 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11670:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1653087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653108 */     // GIR_Coverage, 4891,
     /* 1653108 */     GIR_EraseRootFromParent_Done,
     /* 1653109 */   // Label 22742: @1653109
     /* 1653109 */   GIM_Try, /*On fail goto*//*Label 22743*/ GIMT_Encode4(1653195), // Rule ID 4894 //
     /* 1653114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1653117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1653125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1653128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1653131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653160 */     // MIs[0] policy
     /* 1653160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653170 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653194 */     // GIR_Coverage, 4894,
     /* 1653194 */     GIR_EraseRootFromParent_Done,
     /* 1653195 */   // Label 22743: @1653195
     /* 1653195 */   GIM_Try, /*On fail goto*//*Label 22744*/ GIMT_Encode4(1653281), // Rule ID 4895 //
     /* 1653200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1653203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1653208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1653211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1653214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1653217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653246 */     // MIs[0] policy
     /* 1653246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653256 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11670:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1653259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653280 */     // GIR_Coverage, 4895,
     /* 1653280 */     GIR_EraseRootFromParent_Done,
     /* 1653281 */   // Label 22744: @1653281
     /* 1653281 */   GIM_Try, /*On fail goto*//*Label 22745*/ GIMT_Encode4(1653367), // Rule ID 5772 //
     /* 1653286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1653297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1653300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1653303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1653306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653332 */     // MIs[0] policy
     /* 1653332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653342 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1653345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653366 */     // GIR_Coverage, 5772,
     /* 1653366 */     GIR_EraseRootFromParent_Done,
     /* 1653367 */   // Label 22745: @1653367
     /* 1653367 */   GIM_Try, /*On fail goto*//*Label 22746*/ GIMT_Encode4(1653453), // Rule ID 5773 //
     /* 1653372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1653383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1653386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1653389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1653392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653418 */     // MIs[0] policy
     /* 1653418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653428 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1653431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653452 */     // GIR_Coverage, 5773,
     /* 1653452 */     GIR_EraseRootFromParent_Done,
     /* 1653453 */   // Label 22746: @1653453
     /* 1653453 */   GIM_Try, /*On fail goto*//*Label 22747*/ GIMT_Encode4(1653539), // Rule ID 5776 //
     /* 1653458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1653469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1653472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1653475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1653478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653504 */     // MIs[0] policy
     /* 1653504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653538 */     // GIR_Coverage, 5776,
     /* 1653538 */     GIR_EraseRootFromParent_Done,
     /* 1653539 */   // Label 22747: @1653539
     /* 1653539 */   GIM_Try, /*On fail goto*//*Label 22748*/ GIMT_Encode4(1653625), // Rule ID 5777 //
     /* 1653544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1653555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1653558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1653561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1653564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653590 */     // MIs[0] policy
     /* 1653590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653600 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653624 */     // GIR_Coverage, 5777,
     /* 1653624 */     GIR_EraseRootFromParent_Done,
     /* 1653625 */   // Label 22748: @1653625
     /* 1653625 */   GIM_Try, /*On fail goto*//*Label 22749*/ GIMT_Encode4(1653711), // Rule ID 5780 //
     /* 1653630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1653641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1653644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1653647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1653650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653676 */     // MIs[0] policy
     /* 1653676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653686 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1653689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653710 */     // GIR_Coverage, 5780,
     /* 1653710 */     GIR_EraseRootFromParent_Done,
     /* 1653711 */   // Label 22749: @1653711
     /* 1653711 */   GIM_Try, /*On fail goto*//*Label 22750*/ GIMT_Encode4(1653797), // Rule ID 5781 //
     /* 1653716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1653727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1653730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1653733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1653736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653762 */     // MIs[0] policy
     /* 1653762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653772 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1653775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1653793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653796 */     // GIR_Coverage, 5781,
     /* 1653796 */     GIR_EraseRootFromParent_Done,
     /* 1653797 */   // Label 22750: @1653797
     /* 1653797 */   GIM_Try, /*On fail goto*//*Label 22751*/ GIMT_Encode4(1653883), // Rule ID 5784 //
     /* 1653802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1653813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1653816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1653819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1653822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653848 */     // MIs[0] policy
     /* 1653848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653858 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653882 */     // GIR_Coverage, 5784,
     /* 1653882 */     GIR_EraseRootFromParent_Done,
     /* 1653883 */   // Label 22751: @1653883
     /* 1653883 */   GIM_Try, /*On fail goto*//*Label 22752*/ GIMT_Encode4(1653969), // Rule ID 5785 //
     /* 1653888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1653899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1653902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1653905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1653908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1653911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1653918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1653930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653934 */     // MIs[0] policy
     /* 1653934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653944 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1653947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653968 */     // GIR_Coverage, 5785,
     /* 1653968 */     GIR_EraseRootFromParent_Done,
     /* 1653969 */   // Label 22752: @1653969
     /* 1653969 */   GIM_Try, /*On fail goto*//*Label 22753*/ GIMT_Encode4(1654055), // Rule ID 5788 //
     /* 1653974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1653985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1653988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1653991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1653994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654020 */     // MIs[0] policy
     /* 1654020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654030 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654054 */     // GIR_Coverage, 5788,
     /* 1654054 */     GIR_EraseRootFromParent_Done,
     /* 1654055 */   // Label 22753: @1654055
     /* 1654055 */   GIM_Try, /*On fail goto*//*Label 22754*/ GIMT_Encode4(1654141), // Rule ID 5789 //
     /* 1654060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1654071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1654080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654106 */     // MIs[0] policy
     /* 1654106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654116 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654140 */     // GIR_Coverage, 5789,
     /* 1654140 */     GIR_EraseRootFromParent_Done,
     /* 1654141 */   // Label 22754: @1654141
     /* 1654141 */   GIM_Try, /*On fail goto*//*Label 22755*/ GIMT_Encode4(1654227), // Rule ID 5792 //
     /* 1654146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1654157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1654160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1654163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1654166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654192 */     // MIs[0] policy
     /* 1654192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654226 */     // GIR_Coverage, 5792,
     /* 1654226 */     GIR_EraseRootFromParent_Done,
     /* 1654227 */   // Label 22755: @1654227
     /* 1654227 */   GIM_Try, /*On fail goto*//*Label 22756*/ GIMT_Encode4(1654313), // Rule ID 5793 //
     /* 1654232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1654243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1654246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1654249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1654252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654278 */     // MIs[0] policy
     /* 1654278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1654291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654312 */     // GIR_Coverage, 5793,
     /* 1654312 */     GIR_EraseRootFromParent_Done,
     /* 1654313 */   // Label 22756: @1654313
     /* 1654313 */   GIM_Try, /*On fail goto*//*Label 22757*/ GIMT_Encode4(1654399), // Rule ID 5796 //
     /* 1654318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1654329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1654332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1654335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1654338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654364 */     // MIs[0] policy
     /* 1654364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654398 */     // GIR_Coverage, 5796,
     /* 1654398 */     GIR_EraseRootFromParent_Done,
     /* 1654399 */   // Label 22757: @1654399
     /* 1654399 */   GIM_Try, /*On fail goto*//*Label 22758*/ GIMT_Encode4(1654485), // Rule ID 5797 //
     /* 1654404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1654415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1654418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1654421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1654424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654450 */     // MIs[0] policy
     /* 1654450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654460 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654484 */     // GIR_Coverage, 5797,
     /* 1654484 */     GIR_EraseRootFromParent_Done,
     /* 1654485 */   // Label 22758: @1654485
     /* 1654485 */   GIM_Try, /*On fail goto*//*Label 22759*/ GIMT_Encode4(1654571), // Rule ID 5800 //
     /* 1654490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1654501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1654504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1654507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1654510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654536 */     // MIs[0] policy
     /* 1654536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654570 */     // GIR_Coverage, 5800,
     /* 1654570 */     GIR_EraseRootFromParent_Done,
     /* 1654571 */   // Label 22759: @1654571
     /* 1654571 */   GIM_Try, /*On fail goto*//*Label 22760*/ GIMT_Encode4(1654657), // Rule ID 5801 //
     /* 1654576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1654587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1654590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1654593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1654596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654622 */     // MIs[0] policy
     /* 1654622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654656 */     // GIR_Coverage, 5801,
     /* 1654656 */     GIR_EraseRootFromParent_Done,
     /* 1654657 */   // Label 22760: @1654657
     /* 1654657 */   GIM_Try, /*On fail goto*//*Label 22761*/ GIMT_Encode4(1654743), // Rule ID 5804 //
     /* 1654662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1654673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1654676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1654679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1654682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654708 */     // MIs[0] policy
     /* 1654708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654742 */     // GIR_Coverage, 5804,
     /* 1654742 */     GIR_EraseRootFromParent_Done,
     /* 1654743 */   // Label 22761: @1654743
     /* 1654743 */   GIM_Try, /*On fail goto*//*Label 22762*/ GIMT_Encode4(1654829), // Rule ID 5805 //
     /* 1654748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1654759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1654762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1654765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1654768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654794 */     // MIs[0] policy
     /* 1654794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654804 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1654825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654828 */     // GIR_Coverage, 5805,
     /* 1654828 */     GIR_EraseRootFromParent_Done,
     /* 1654829 */   // Label 22762: @1654829
     /* 1654829 */   GIM_Try, /*On fail goto*//*Label 22763*/ GIMT_Encode4(1654915), // Rule ID 5808 //
     /* 1654834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1654837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1654845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1654848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1654851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1654854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654880 */     // MIs[0] policy
     /* 1654880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654914 */     // GIR_Coverage, 5808,
     /* 1654914 */     GIR_EraseRootFromParent_Done,
     /* 1654915 */   // Label 22763: @1654915
     /* 1654915 */   GIM_Try, /*On fail goto*//*Label 22764*/ GIMT_Encode4(1655001), // Rule ID 5809 //
     /* 1654920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1654923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1654931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1654934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1654937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1654940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654966 */     // MIs[0] policy
     /* 1654966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1654979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655000 */     // GIR_Coverage, 5809,
     /* 1655000 */     GIR_EraseRootFromParent_Done,
     /* 1655001 */   // Label 22764: @1655001
     /* 1655001 */   GIM_Try, /*On fail goto*//*Label 22765*/ GIMT_Encode4(1655087), // Rule ID 5812 //
     /* 1655006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1655017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1655020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1655023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1655026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655052 */     // MIs[0] policy
     /* 1655052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655062 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655086 */     // GIR_Coverage, 5812,
     /* 1655086 */     GIR_EraseRootFromParent_Done,
     /* 1655087 */   // Label 22765: @1655087
     /* 1655087 */   GIM_Try, /*On fail goto*//*Label 22766*/ GIMT_Encode4(1655173), // Rule ID 5813 //
     /* 1655092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1655103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1655106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1655109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1655112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655138 */     // MIs[0] policy
     /* 1655138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655148 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655172 */     // GIR_Coverage, 5813,
     /* 1655172 */     GIR_EraseRootFromParent_Done,
     /* 1655173 */   // Label 22766: @1655173
     /* 1655173 */   GIM_Try, /*On fail goto*//*Label 22767*/ GIMT_Encode4(1655259), // Rule ID 5816 //
     /* 1655178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1655189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1655192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1655195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1655198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655224 */     // MIs[0] policy
     /* 1655224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655234 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655258 */     // GIR_Coverage, 5816,
     /* 1655258 */     GIR_EraseRootFromParent_Done,
     /* 1655259 */   // Label 22767: @1655259
     /* 1655259 */   GIM_Try, /*On fail goto*//*Label 22768*/ GIMT_Encode4(1655345), // Rule ID 5817 //
     /* 1655264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1655275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1655278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1655281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1655284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655310 */     // MIs[0] policy
     /* 1655310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655320 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655344 */     // GIR_Coverage, 5817,
     /* 1655344 */     GIR_EraseRootFromParent_Done,
     /* 1655345 */   // Label 22768: @1655345
     /* 1655345 */   GIM_Try, /*On fail goto*//*Label 22769*/ GIMT_Encode4(1655431), // Rule ID 5820 //
     /* 1655350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1655361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1655364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1655367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1655370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1655373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655396 */     // MIs[0] policy
     /* 1655396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655406 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655430 */     // GIR_Coverage, 5820,
     /* 1655430 */     GIR_EraseRootFromParent_Done,
     /* 1655431 */   // Label 22769: @1655431
     /* 1655431 */   GIM_Try, /*On fail goto*//*Label 22770*/ GIMT_Encode4(1655517), // Rule ID 5821 //
     /* 1655436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1655447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1655450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1655453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1655456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1655459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655482 */     // MIs[0] policy
     /* 1655482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655492 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655516 */     // GIR_Coverage, 5821,
     /* 1655516 */     GIR_EraseRootFromParent_Done,
     /* 1655517 */   // Label 22770: @1655517
     /* 1655517 */   GIM_Try, /*On fail goto*//*Label 22771*/ GIMT_Encode4(1655603), // Rule ID 5824 //
     /* 1655522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1655533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1655536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1655539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1655542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655568 */     // MIs[0] policy
     /* 1655568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655602 */     // GIR_Coverage, 5824,
     /* 1655602 */     GIR_EraseRootFromParent_Done,
     /* 1655603 */   // Label 22771: @1655603
     /* 1655603 */   GIM_Try, /*On fail goto*//*Label 22772*/ GIMT_Encode4(1655689), // Rule ID 5825 //
     /* 1655608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1655619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1655622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1655625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1655628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1655638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1655650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655654 */     // MIs[0] policy
     /* 1655654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1655667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655688 */     // GIR_Coverage, 5825,
     /* 1655688 */     GIR_EraseRootFromParent_Done,
     /* 1655689 */   // Label 22772: @1655689
     /* 1655689 */   GIM_Try, /*On fail goto*//*Label 22773*/ GIMT_Encode4(1655775), // Rule ID 5828 //
     /* 1655694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1655705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1655708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1655711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1655714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655740 */     // MIs[0] policy
     /* 1655740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655750 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655774 */     // GIR_Coverage, 5828,
     /* 1655774 */     GIR_EraseRootFromParent_Done,
     /* 1655775 */   // Label 22773: @1655775
     /* 1655775 */   GIM_Try, /*On fail goto*//*Label 22774*/ GIMT_Encode4(1655861), // Rule ID 5829 //
     /* 1655780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1655791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1655794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1655797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1655800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1655803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1655810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1655822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655826 */     // MIs[0] policy
     /* 1655826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1655839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655860 */     // GIR_Coverage, 5829,
     /* 1655860 */     GIR_EraseRootFromParent_Done,
     /* 1655861 */   // Label 22774: @1655861
     /* 1655861 */   GIM_Try, /*On fail goto*//*Label 22775*/ GIMT_Encode4(1655947), // Rule ID 5832 //
     /* 1655866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1655877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1655880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1655883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1655886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655912 */     // MIs[0] policy
     /* 1655912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655922 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1655925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655946 */     // GIR_Coverage, 5832,
     /* 1655946 */     GIR_EraseRootFromParent_Done,
     /* 1655947 */   // Label 22775: @1655947
     /* 1655947 */   GIM_Try, /*On fail goto*//*Label 22776*/ GIMT_Encode4(1656033), // Rule ID 5833 //
     /* 1655952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1655960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1655963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1655966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1655969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1655972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1655975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1655982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1655994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655998 */     // MIs[0] policy
     /* 1655998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656032 */     // GIR_Coverage, 5833,
     /* 1656032 */     GIR_EraseRootFromParent_Done,
     /* 1656033 */   // Label 22776: @1656033
     /* 1656033 */   GIM_Try, /*On fail goto*//*Label 22777*/ GIMT_Encode4(1656119), // Rule ID 5836 //
     /* 1656038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1656049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1656052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1656055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1656058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656084 */     // MIs[0] policy
     /* 1656084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656118 */     // GIR_Coverage, 5836,
     /* 1656118 */     GIR_EraseRootFromParent_Done,
     /* 1656119 */   // Label 22777: @1656119
     /* 1656119 */   GIM_Try, /*On fail goto*//*Label 22778*/ GIMT_Encode4(1656205), // Rule ID 5837 //
     /* 1656124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1656135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1656138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1656141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1656144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656170 */     // MIs[0] policy
     /* 1656170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656180 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656204 */     // GIR_Coverage, 5837,
     /* 1656204 */     GIR_EraseRootFromParent_Done,
     /* 1656205 */   // Label 22778: @1656205
     /* 1656205 */   GIM_Try, /*On fail goto*//*Label 22779*/ GIMT_Encode4(1656291), // Rule ID 5840 //
     /* 1656210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1656230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656256 */     // MIs[0] policy
     /* 1656256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656290 */     // GIR_Coverage, 5840,
     /* 1656290 */     GIR_EraseRootFromParent_Done,
     /* 1656291 */   // Label 22779: @1656291
     /* 1656291 */   GIM_Try, /*On fail goto*//*Label 22780*/ GIMT_Encode4(1656377), // Rule ID 5841 //
     /* 1656296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1656307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1656310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1656313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1656316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656342 */     // MIs[0] policy
     /* 1656342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656352 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656376 */     // GIR_Coverage, 5841,
     /* 1656376 */     GIR_EraseRootFromParent_Done,
     /* 1656377 */   // Label 22780: @1656377
     /* 1656377 */   GIM_Try, /*On fail goto*//*Label 22781*/ GIMT_Encode4(1656463), // Rule ID 5844 //
     /* 1656382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1656402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656428 */     // MIs[0] policy
     /* 1656428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656438 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656462 */     // GIR_Coverage, 5844,
     /* 1656462 */     GIR_EraseRootFromParent_Done,
     /* 1656463 */   // Label 22781: @1656463
     /* 1656463 */   GIM_Try, /*On fail goto*//*Label 22782*/ GIMT_Encode4(1656549), // Rule ID 5845 //
     /* 1656468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1656479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1656482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1656485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1656488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656514 */     // MIs[0] policy
     /* 1656514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1656545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656548 */     // GIR_Coverage, 5845,
     /* 1656548 */     GIR_EraseRootFromParent_Done,
     /* 1656549 */   // Label 22782: @1656549
     /* 1656549 */   GIM_Try, /*On fail goto*//*Label 22783*/ GIMT_Encode4(1656635), // Rule ID 5848 //
     /* 1656554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1656557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1656565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1656568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1656571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1656574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656600 */     // MIs[0] policy
     /* 1656600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656634 */     // GIR_Coverage, 5848,
     /* 1656634 */     GIR_EraseRootFromParent_Done,
     /* 1656635 */   // Label 22783: @1656635
     /* 1656635 */   GIM_Try, /*On fail goto*//*Label 22784*/ GIMT_Encode4(1656721), // Rule ID 5849 //
     /* 1656640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1656643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1656651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1656654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1656657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1656660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1656663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656686 */     // MIs[0] policy
     /* 1656686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1656699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656720 */     // GIR_Coverage, 5849,
     /* 1656720 */     GIR_EraseRootFromParent_Done,
     /* 1656721 */   // Label 22784: @1656721
     /* 1656721 */   GIM_Try, /*On fail goto*//*Label 22785*/ GIMT_Encode4(1656807), // Rule ID 5852 //
     /* 1656726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1656729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1656737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1656740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1656743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1656746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656772 */     // MIs[0] policy
     /* 1656772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656806 */     // GIR_Coverage, 5852,
     /* 1656806 */     GIR_EraseRootFromParent_Done,
     /* 1656807 */   // Label 22785: @1656807
     /* 1656807 */   GIM_Try, /*On fail goto*//*Label 22786*/ GIMT_Encode4(1656893), // Rule ID 5853 //
     /* 1656812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1656815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1656823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1656826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1656829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1656832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1656835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656858 */     // MIs[0] policy
     /* 1656858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656868 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1656871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656892 */     // GIR_Coverage, 5853,
     /* 1656892 */     GIR_EraseRootFromParent_Done,
     /* 1656893 */   // Label 22786: @1656893
     /* 1656893 */   GIM_Try, /*On fail goto*//*Label 22787*/ GIMT_Encode4(1656979), // Rule ID 5856 //
     /* 1656898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1656901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1656909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1656912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1656915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1656918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656944 */     // MIs[0] policy
     /* 1656944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1656957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1656975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656978 */     // GIR_Coverage, 5856,
     /* 1656978 */     GIR_EraseRootFromParent_Done,
     /* 1656979 */   // Label 22787: @1656979
     /* 1656979 */   GIM_Try, /*On fail goto*//*Label 22788*/ GIMT_Encode4(1657065), // Rule ID 5857 //
     /* 1656984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1656987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1656992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1656995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1656998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1657001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1657004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657030 */     // MIs[0] policy
     /* 1657030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1657043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657064 */     // GIR_Coverage, 5857,
     /* 1657064 */     GIR_EraseRootFromParent_Done,
     /* 1657065 */   // Label 22788: @1657065
     /* 1657065 */   GIM_Try, /*On fail goto*//*Label 22789*/ GIMT_Encode4(1657151), // Rule ID 5860 //
     /* 1657070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657116 */     // MIs[0] policy
     /* 1657116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1657129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657150 */     // GIR_Coverage, 5860,
     /* 1657150 */     GIR_EraseRootFromParent_Done,
     /* 1657151 */   // Label 22789: @1657151
     /* 1657151 */   GIM_Try, /*On fail goto*//*Label 22790*/ GIMT_Encode4(1657237), // Rule ID 5861 //
     /* 1657156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1657167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1657170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1657173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657202 */     // MIs[0] policy
     /* 1657202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657212 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1657215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657236 */     // GIR_Coverage, 5861,
     /* 1657236 */     GIR_EraseRootFromParent_Done,
     /* 1657237 */   // Label 22790: @1657237
     /* 1657237 */   GIM_Try, /*On fail goto*//*Label 22791*/ GIMT_Encode4(1657323), // Rule ID 5864 //
     /* 1657242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657288 */     // MIs[0] policy
     /* 1657288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657298 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657322 */     // GIR_Coverage, 5864,
     /* 1657322 */     GIR_EraseRootFromParent_Done,
     /* 1657323 */   // Label 22791: @1657323
     /* 1657323 */   GIM_Try, /*On fail goto*//*Label 22792*/ GIMT_Encode4(1657409), // Rule ID 5865 //
     /* 1657328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1657339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1657342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1657345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657374 */     // MIs[0] policy
     /* 1657374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657408 */     // GIR_Coverage, 5865,
     /* 1657408 */     GIR_EraseRootFromParent_Done,
     /* 1657409 */   // Label 22792: @1657409
     /* 1657409 */   GIM_Try, /*On fail goto*//*Label 22793*/ GIMT_Encode4(1657495), // Rule ID 5868 //
     /* 1657414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657460 */     // MIs[0] policy
     /* 1657460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657494 */     // GIR_Coverage, 5868,
     /* 1657494 */     GIR_EraseRootFromParent_Done,
     /* 1657495 */   // Label 22793: @1657495
     /* 1657495 */   GIM_Try, /*On fail goto*//*Label 22794*/ GIMT_Encode4(1657581), // Rule ID 5869 //
     /* 1657500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1657511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1657514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1657517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657546 */     // MIs[0] policy
     /* 1657546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657556 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1657577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657580 */     // GIR_Coverage, 5869,
     /* 1657580 */     GIR_EraseRootFromParent_Done,
     /* 1657581 */   // Label 22794: @1657581
     /* 1657581 */   GIM_Try, /*On fail goto*//*Label 22795*/ GIMT_Encode4(1657667), // Rule ID 5872 //
     /* 1657586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1657597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1657600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1657603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657632 */     // MIs[0] policy
     /* 1657632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657642 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657666 */     // GIR_Coverage, 5872,
     /* 1657666 */     GIR_EraseRootFromParent_Done,
     /* 1657667 */   // Label 22795: @1657667
     /* 1657667 */   GIM_Try, /*On fail goto*//*Label 22796*/ GIMT_Encode4(1657753), // Rule ID 5873 //
     /* 1657672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1657683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1657686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1657689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657718 */     // MIs[0] policy
     /* 1657718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657728 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1657731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657752 */     // GIR_Coverage, 5873,
     /* 1657752 */     GIR_EraseRootFromParent_Done,
     /* 1657753 */   // Label 22796: @1657753
     /* 1657753 */   GIM_Try, /*On fail goto*//*Label 22797*/ GIMT_Encode4(1657839), // Rule ID 5876 //
     /* 1657758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1657769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1657772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1657775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657804 */     // MIs[0] policy
     /* 1657804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657814 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657838 */     // GIR_Coverage, 5876,
     /* 1657838 */     GIR_EraseRootFromParent_Done,
     /* 1657839 */   // Label 22797: @1657839
     /* 1657839 */   GIM_Try, /*On fail goto*//*Label 22798*/ GIMT_Encode4(1657925), // Rule ID 5877 //
     /* 1657844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1657855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1657858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1657861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1657864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657890 */     // MIs[0] policy
     /* 1657890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657924 */     // GIR_Coverage, 5877,
     /* 1657924 */     GIR_EraseRootFromParent_Done,
     /* 1657925 */   // Label 22798: @1657925
     /* 1657925 */   GIM_Try, /*On fail goto*//*Label 22799*/ GIMT_Encode4(1658011), // Rule ID 5880 //
     /* 1657930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1657938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1657941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1657944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1657947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1657950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1657953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1657960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1657968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1657972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657976 */     // MIs[0] policy
     /* 1657976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657986 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1657989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658010 */     // GIR_Coverage, 5880,
     /* 1658010 */     GIR_EraseRootFromParent_Done,
     /* 1658011 */   // Label 22799: @1658011
     /* 1658011 */   GIM_Try, /*On fail goto*//*Label 22800*/ GIMT_Encode4(1658097), // Rule ID 5881 //
     /* 1658016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1658027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1658030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1658033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658062 */     // MIs[0] policy
     /* 1658062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658072 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1658075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658096 */     // GIR_Coverage, 5881,
     /* 1658096 */     GIR_EraseRootFromParent_Done,
     /* 1658097 */   // Label 22800: @1658097
     /* 1658097 */   GIM_Try, /*On fail goto*//*Label 22801*/ GIMT_Encode4(1658183), // Rule ID 5884 //
     /* 1658102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658148 */     // MIs[0] policy
     /* 1658148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658182 */     // GIR_Coverage, 5884,
     /* 1658182 */     GIR_EraseRootFromParent_Done,
     /* 1658183 */   // Label 22801: @1658183
     /* 1658183 */   GIM_Try, /*On fail goto*//*Label 22802*/ GIMT_Encode4(1658269), // Rule ID 5885 //
     /* 1658188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1658199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1658202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1658205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1658211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658234 */     // MIs[0] policy
     /* 1658234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658244 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11157:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658268 */     // GIR_Coverage, 5885,
     /* 1658268 */     GIR_EraseRootFromParent_Done,
     /* 1658269 */   // Label 22802: @1658269
     /* 1658269 */   GIM_Try, /*On fail goto*//*Label 22803*/ GIMT_Encode4(1658355), // Rule ID 5888 //
     /* 1658274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658320 */     // MIs[0] policy
     /* 1658320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658354 */     // GIR_Coverage, 5888,
     /* 1658354 */     GIR_EraseRootFromParent_Done,
     /* 1658355 */   // Label 22803: @1658355
     /* 1658355 */   GIM_Try, /*On fail goto*//*Label 22804*/ GIMT_Encode4(1658441), // Rule ID 5889 //
     /* 1658360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1658371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1658374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1658377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658406 */     // MIs[0] policy
     /* 1658406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658440 */     // GIR_Coverage, 5889,
     /* 1658440 */     GIR_EraseRootFromParent_Done,
     /* 1658441 */   // Label 22804: @1658441
     /* 1658441 */   GIM_Try, /*On fail goto*//*Label 22805*/ GIMT_Encode4(1658527), // Rule ID 5892 //
     /* 1658446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1658457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1658460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1658463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658492 */     // MIs[0] policy
     /* 1658492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658526 */     // GIR_Coverage, 5892,
     /* 1658526 */     GIR_EraseRootFromParent_Done,
     /* 1658527 */   // Label 22805: @1658527
     /* 1658527 */   GIM_Try, /*On fail goto*//*Label 22806*/ GIMT_Encode4(1658613), // Rule ID 5893 //
     /* 1658532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1658543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1658546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1658549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658578 */     // MIs[0] policy
     /* 1658578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658612 */     // GIR_Coverage, 5893,
     /* 1658612 */     GIR_EraseRootFromParent_Done,
     /* 1658613 */   // Label 22806: @1658613
     /* 1658613 */   GIM_Try, /*On fail goto*//*Label 22807*/ GIMT_Encode4(1658699), // Rule ID 5896 //
     /* 1658618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1658621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1658629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1658632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1658635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658664 */     // MIs[0] policy
     /* 1658664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658698 */     // GIR_Coverage, 5896,
     /* 1658698 */     GIR_EraseRootFromParent_Done,
     /* 1658699 */   // Label 22807: @1658699
     /* 1658699 */   GIM_Try, /*On fail goto*//*Label 22808*/ GIMT_Encode4(1658785), // Rule ID 5897 //
     /* 1658704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1658707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1658715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1658718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1658721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658750 */     // MIs[0] policy
     /* 1658750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1658763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658784 */     // GIR_Coverage, 5897,
     /* 1658784 */     GIR_EraseRootFromParent_Done,
     /* 1658785 */   // Label 22808: @1658785
     /* 1658785 */   GIM_Try, /*On fail goto*//*Label 22809*/ GIMT_Encode4(1658871), // Rule ID 5900 //
     /* 1658790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1658801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1658804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1658807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658836 */     // MIs[0] policy
     /* 1658836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1658849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658870 */     // GIR_Coverage, 5900,
     /* 1658870 */     GIR_EraseRootFromParent_Done,
     /* 1658871 */   // Label 22809: @1658871
     /* 1658871 */   GIM_Try, /*On fail goto*//*Label 22810*/ GIMT_Encode4(1658957), // Rule ID 5901 //
     /* 1658876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1658887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1658890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1658893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1658899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1658906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1658914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658922 */     // MIs[0] policy
     /* 1658922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1658935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658956 */     // GIR_Coverage, 5901,
     /* 1658956 */     GIR_EraseRootFromParent_Done,
     /* 1658957 */   // Label 22810: @1658957
     /* 1658957 */   GIM_Try, /*On fail goto*//*Label 22811*/ GIMT_Encode4(1659043), // Rule ID 5904 //
     /* 1658962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1658970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1658973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1658976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1658979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1658985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1658992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1658996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659008 */     // MIs[0] policy
     /* 1659008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659018 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659042 */     // GIR_Coverage, 5904,
     /* 1659042 */     GIR_EraseRootFromParent_Done,
     /* 1659043 */   // Label 22811: @1659043
     /* 1659043 */   GIM_Try, /*On fail goto*//*Label 22812*/ GIMT_Encode4(1659129), // Rule ID 5905 //
     /* 1659048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1659059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1659062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1659065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659094 */     // MIs[0] policy
     /* 1659094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659104 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659128 */     // GIR_Coverage, 5905,
     /* 1659128 */     GIR_EraseRootFromParent_Done,
     /* 1659129 */   // Label 22812: @1659129
     /* 1659129 */   GIM_Try, /*On fail goto*//*Label 22813*/ GIMT_Encode4(1659215), // Rule ID 5908 //
     /* 1659134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659180 */     // MIs[0] policy
     /* 1659180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659190 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659214 */     // GIR_Coverage, 5908,
     /* 1659214 */     GIR_EraseRootFromParent_Done,
     /* 1659215 */   // Label 22813: @1659215
     /* 1659215 */   GIM_Try, /*On fail goto*//*Label 22814*/ GIMT_Encode4(1659301), // Rule ID 5909 //
     /* 1659220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1659231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1659234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1659237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1659243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659266 */     // MIs[0] policy
     /* 1659266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659276 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659300 */     // GIR_Coverage, 5909,
     /* 1659300 */     GIR_EraseRootFromParent_Done,
     /* 1659301 */   // Label 22814: @1659301
     /* 1659301 */   GIM_Try, /*On fail goto*//*Label 22815*/ GIMT_Encode4(1659387), // Rule ID 5912 //
     /* 1659306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659352 */     // MIs[0] policy
     /* 1659352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659386 */     // GIR_Coverage, 5912,
     /* 1659386 */     GIR_EraseRootFromParent_Done,
     /* 1659387 */   // Label 22815: @1659387
     /* 1659387 */   GIM_Try, /*On fail goto*//*Label 22816*/ GIMT_Encode4(1659473), // Rule ID 5913 //
     /* 1659392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1659403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1659406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1659409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659438 */     // MIs[0] policy
     /* 1659438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659472 */     // GIR_Coverage, 5913,
     /* 1659472 */     GIR_EraseRootFromParent_Done,
     /* 1659473 */   // Label 22816: @1659473
     /* 1659473 */   GIM_Try, /*On fail goto*//*Label 22817*/ GIMT_Encode4(1659559), // Rule ID 5916 //
     /* 1659478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1659489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1659492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1659495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659524 */     // MIs[0] policy
     /* 1659524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659558 */     // GIR_Coverage, 5916,
     /* 1659558 */     GIR_EraseRootFromParent_Done,
     /* 1659559 */   // Label 22817: @1659559
     /* 1659559 */   GIM_Try, /*On fail goto*//*Label 22818*/ GIMT_Encode4(1659645), // Rule ID 5917 //
     /* 1659564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1659575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1659578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1659581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659610 */     // MIs[0] policy
     /* 1659610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659620 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1659623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659644 */     // GIR_Coverage, 5917,
     /* 1659644 */     GIR_EraseRootFromParent_Done,
     /* 1659645 */   // Label 22818: @1659645
     /* 1659645 */   GIM_Try, /*On fail goto*//*Label 22819*/ GIMT_Encode4(1659731), // Rule ID 5920 //
     /* 1659650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1659661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1659664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1659667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659696 */     // MIs[0] policy
     /* 1659696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659730 */     // GIR_Coverage, 5920,
     /* 1659730 */     GIR_EraseRootFromParent_Done,
     /* 1659731 */   // Label 22819: @1659731
     /* 1659731 */   GIM_Try, /*On fail goto*//*Label 22820*/ GIMT_Encode4(1659817), // Rule ID 5921 //
     /* 1659736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1659747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1659750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1659753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1659766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1659774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659782 */     // MIs[0] policy
     /* 1659782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659792 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1659795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659816 */     // GIR_Coverage, 5921,
     /* 1659816 */     GIR_EraseRootFromParent_Done,
     /* 1659817 */   // Label 22820: @1659817
     /* 1659817 */   GIM_Try, /*On fail goto*//*Label 22821*/ GIMT_Encode4(1659903), // Rule ID 5924 //
     /* 1659822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1659833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1659836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1659839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659868 */     // MIs[0] policy
     /* 1659868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659902 */     // GIR_Coverage, 5924,
     /* 1659902 */     GIR_EraseRootFromParent_Done,
     /* 1659903 */   // Label 22821: @1659903
     /* 1659903 */   GIM_Try, /*On fail goto*//*Label 22822*/ GIMT_Encode4(1659989), // Rule ID 5925 //
     /* 1659908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1659916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1659919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1659922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1659925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659954 */     // MIs[0] policy
     /* 1659954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1659967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659988 */     // GIR_Coverage, 5925,
     /* 1659988 */     GIR_EraseRootFromParent_Done,
     /* 1659989 */   // Label 22822: @1659989
     /* 1659989 */   GIM_Try, /*On fail goto*//*Label 22823*/ GIMT_Encode4(1660075), // Rule ID 5928 //
     /* 1659994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660040 */     // MIs[0] policy
     /* 1660040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660050 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660074 */     // GIR_Coverage, 5928,
     /* 1660074 */     GIR_EraseRootFromParent_Done,
     /* 1660075 */   // Label 22823: @1660075
     /* 1660075 */   GIM_Try, /*On fail goto*//*Label 22824*/ GIMT_Encode4(1660161), // Rule ID 5929 //
     /* 1660080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660126 */     // MIs[0] policy
     /* 1660126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660136 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660160 */     // GIR_Coverage, 5929,
     /* 1660160 */     GIR_EraseRootFromParent_Done,
     /* 1660161 */   // Label 22824: @1660161
     /* 1660161 */   GIM_Try, /*On fail goto*//*Label 22825*/ GIMT_Encode4(1660247), // Rule ID 5932 //
     /* 1660166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660212 */     // MIs[0] policy
     /* 1660212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660222 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660246 */     // GIR_Coverage, 5932,
     /* 1660246 */     GIR_EraseRootFromParent_Done,
     /* 1660247 */   // Label 22825: @1660247
     /* 1660247 */   GIM_Try, /*On fail goto*//*Label 22826*/ GIMT_Encode4(1660333), // Rule ID 5933 //
     /* 1660252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1660263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1660266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1660269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660298 */     // MIs[0] policy
     /* 1660298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660308 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660332 */     // GIR_Coverage, 5933,
     /* 1660332 */     GIR_EraseRootFromParent_Done,
     /* 1660333 */   // Label 22826: @1660333
     /* 1660333 */   GIM_Try, /*On fail goto*//*Label 22827*/ GIMT_Encode4(1660419), // Rule ID 5936 //
     /* 1660338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660384 */     // MIs[0] policy
     /* 1660384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660418 */     // GIR_Coverage, 5936,
     /* 1660418 */     GIR_EraseRootFromParent_Done,
     /* 1660419 */   // Label 22827: @1660419
     /* 1660419 */   GIM_Try, /*On fail goto*//*Label 22828*/ GIMT_Encode4(1660505), // Rule ID 5937 //
     /* 1660424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1660435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1660438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1660441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1660447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660470 */     // MIs[0] policy
     /* 1660470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1660483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660504 */     // GIR_Coverage, 5937,
     /* 1660504 */     GIR_EraseRootFromParent_Done,
     /* 1660505 */   // Label 22828: @1660505
     /* 1660505 */   GIM_Try, /*On fail goto*//*Label 22829*/ GIMT_Encode4(1660591), // Rule ID 5940 //
     /* 1660510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1660521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1660524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1660527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660556 */     // MIs[0] policy
     /* 1660556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660566 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660590 */     // GIR_Coverage, 5940,
     /* 1660590 */     GIR_EraseRootFromParent_Done,
     /* 1660591 */   // Label 22829: @1660591
     /* 1660591 */   GIM_Try, /*On fail goto*//*Label 22830*/ GIMT_Encode4(1660677), // Rule ID 5941 //
     /* 1660596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1660607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1660610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1660613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660642 */     // MIs[0] policy
     /* 1660642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1660655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660676 */     // GIR_Coverage, 5941,
     /* 1660676 */     GIR_EraseRootFromParent_Done,
     /* 1660677 */   // Label 22830: @1660677
     /* 1660677 */   GIM_Try, /*On fail goto*//*Label 22831*/ GIMT_Encode4(1660763), // Rule ID 5944 //
     /* 1660682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1660685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1660693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1660696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1660699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660728 */     // MIs[0] policy
     /* 1660728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660762 */     // GIR_Coverage, 5944,
     /* 1660762 */     GIR_EraseRootFromParent_Done,
     /* 1660763 */   // Label 22831: @1660763
     /* 1660763 */   GIM_Try, /*On fail goto*//*Label 22832*/ GIMT_Encode4(1660849), // Rule ID 5945 //
     /* 1660768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1660771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1660776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1660779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1660782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1660785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660814 */     // MIs[0] policy
     /* 1660814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660824 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11157:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1660827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1660845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660848 */     // GIR_Coverage, 5945,
     /* 1660848 */     GIR_EraseRootFromParent_Done,
     /* 1660849 */   // Label 22832: @1660849
     /* 1660849 */   GIM_Try, /*On fail goto*//*Label 22833*/ GIMT_Encode4(1660935), // Rule ID 6036 //
     /* 1660854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1660865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1660868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1660871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1660874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1660877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660900 */     // MIs[0] policy
     /* 1660900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660910 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1660913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660934 */     // GIR_Coverage, 6036,
     /* 1660934 */     GIR_EraseRootFromParent_Done,
     /* 1660935 */   // Label 22833: @1660935
     /* 1660935 */   GIM_Try, /*On fail goto*//*Label 22834*/ GIMT_Encode4(1661021), // Rule ID 6037 //
     /* 1660940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1660951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1660954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1660957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1660960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1660963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1660970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1660982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660986 */     // MIs[0] policy
     /* 1660986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1660999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661020 */     // GIR_Coverage, 6037,
     /* 1661020 */     GIR_EraseRootFromParent_Done,
     /* 1661021 */   // Label 22834: @1661021
     /* 1661021 */   GIM_Try, /*On fail goto*//*Label 22835*/ GIMT_Encode4(1661107), // Rule ID 6040 //
     /* 1661026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1661046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661072 */     // MIs[0] policy
     /* 1661072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661082 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661106 */     // GIR_Coverage, 6040,
     /* 1661106 */     GIR_EraseRootFromParent_Done,
     /* 1661107 */   // Label 22835: @1661107
     /* 1661107 */   GIM_Try, /*On fail goto*//*Label 22836*/ GIMT_Encode4(1661193), // Rule ID 6041 //
     /* 1661112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1661123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1661126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1661129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1661132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661158 */     // MIs[0] policy
     /* 1661158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661192 */     // GIR_Coverage, 6041,
     /* 1661192 */     GIR_EraseRootFromParent_Done,
     /* 1661193 */   // Label 22836: @1661193
     /* 1661193 */   GIM_Try, /*On fail goto*//*Label 22837*/ GIMT_Encode4(1661279), // Rule ID 6044 //
     /* 1661198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1661218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661244 */     // MIs[0] policy
     /* 1661244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661254 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661278 */     // GIR_Coverage, 6044,
     /* 1661278 */     GIR_EraseRootFromParent_Done,
     /* 1661279 */   // Label 22837: @1661279
     /* 1661279 */   GIM_Try, /*On fail goto*//*Label 22838*/ GIMT_Encode4(1661365), // Rule ID 6045 //
     /* 1661284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1661295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1661298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1661301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1661304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661330 */     // MIs[0] policy
     /* 1661330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661340 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661364 */     // GIR_Coverage, 6045,
     /* 1661364 */     GIR_EraseRootFromParent_Done,
     /* 1661365 */   // Label 22838: @1661365
     /* 1661365 */   GIM_Try, /*On fail goto*//*Label 22839*/ GIMT_Encode4(1661451), // Rule ID 6048 //
     /* 1661370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1661390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661416 */     // MIs[0] policy
     /* 1661416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661426 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661450 */     // GIR_Coverage, 6048,
     /* 1661450 */     GIR_EraseRootFromParent_Done,
     /* 1661451 */   // Label 22839: @1661451
     /* 1661451 */   GIM_Try, /*On fail goto*//*Label 22840*/ GIMT_Encode4(1661537), // Rule ID 6049 //
     /* 1661456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1661467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1661470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1661473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1661476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661502 */     // MIs[0] policy
     /* 1661502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1661515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661536 */     // GIR_Coverage, 6049,
     /* 1661536 */     GIR_EraseRootFromParent_Done,
     /* 1661537 */   // Label 22840: @1661537
     /* 1661537 */   GIM_Try, /*On fail goto*//*Label 22841*/ GIMT_Encode4(1661623), // Rule ID 6052 //
     /* 1661542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1661553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1661556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1661559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1661562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661588 */     // MIs[0] policy
     /* 1661588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661598 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661622 */     // GIR_Coverage, 6052,
     /* 1661622 */     GIR_EraseRootFromParent_Done,
     /* 1661623 */   // Label 22841: @1661623
     /* 1661623 */   GIM_Try, /*On fail goto*//*Label 22842*/ GIMT_Encode4(1661709), // Rule ID 6053 //
     /* 1661628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1661639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1661642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1661645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1661648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661674 */     // MIs[0] policy
     /* 1661674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1661705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661708 */     // GIR_Coverage, 6053,
     /* 1661708 */     GIR_EraseRootFromParent_Done,
     /* 1661709 */   // Label 22842: @1661709
     /* 1661709 */   GIM_Try, /*On fail goto*//*Label 22843*/ GIMT_Encode4(1661795), // Rule ID 6056 //
     /* 1661714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1661725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1661728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1661731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1661734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661760 */     // MIs[0] policy
     /* 1661760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661770 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661794 */     // GIR_Coverage, 6056,
     /* 1661794 */     GIR_EraseRootFromParent_Done,
     /* 1661795 */   // Label 22843: @1661795
     /* 1661795 */   GIM_Try, /*On fail goto*//*Label 22844*/ GIMT_Encode4(1661881), // Rule ID 6057 //
     /* 1661800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1661811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1661814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1661817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1661820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661846 */     // MIs[0] policy
     /* 1661846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1661859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661880 */     // GIR_Coverage, 6057,
     /* 1661880 */     GIR_EraseRootFromParent_Done,
     /* 1661881 */   // Label 22844: @1661881
     /* 1661881 */   GIM_Try, /*On fail goto*//*Label 22845*/ GIMT_Encode4(1661967), // Rule ID 6060 //
     /* 1661886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1661897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1661900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1661903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1661906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661932 */     // MIs[0] policy
     /* 1661932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661942 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1661945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661966 */     // GIR_Coverage, 6060,
     /* 1661966 */     GIR_EraseRootFromParent_Done,
     /* 1661967 */   // Label 22845: @1661967
     /* 1661967 */   GIM_Try, /*On fail goto*//*Label 22846*/ GIMT_Encode4(1662053), // Rule ID 6061 //
     /* 1661972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1661983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1661986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1661989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1661992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662018 */     // MIs[0] policy
     /* 1662018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662052 */     // GIR_Coverage, 6061,
     /* 1662052 */     GIR_EraseRootFromParent_Done,
     /* 1662053 */   // Label 22846: @1662053
     /* 1662053 */   GIM_Try, /*On fail goto*//*Label 22847*/ GIMT_Encode4(1662139), // Rule ID 6064 //
     /* 1662058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1662078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662104 */     // MIs[0] policy
     /* 1662104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662138 */     // GIR_Coverage, 6064,
     /* 1662138 */     GIR_EraseRootFromParent_Done,
     /* 1662139 */   // Label 22847: @1662139
     /* 1662139 */   GIM_Try, /*On fail goto*//*Label 22848*/ GIMT_Encode4(1662225), // Rule ID 6065 //
     /* 1662144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1662155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1662158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1662161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1662164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662190 */     // MIs[0] policy
     /* 1662190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662224 */     // GIR_Coverage, 6065,
     /* 1662224 */     GIR_EraseRootFromParent_Done,
     /* 1662225 */   // Label 22848: @1662225
     /* 1662225 */   GIM_Try, /*On fail goto*//*Label 22849*/ GIMT_Encode4(1662311), // Rule ID 6068 //
     /* 1662230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1662250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662276 */     // MIs[0] policy
     /* 1662276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662310 */     // GIR_Coverage, 6068,
     /* 1662310 */     GIR_EraseRootFromParent_Done,
     /* 1662311 */   // Label 22849: @1662311
     /* 1662311 */   GIM_Try, /*On fail goto*//*Label 22850*/ GIMT_Encode4(1662397), // Rule ID 6069 //
     /* 1662316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1662327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1662330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1662333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1662336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662362 */     // MIs[0] policy
     /* 1662362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662396 */     // GIR_Coverage, 6069,
     /* 1662396 */     GIR_EraseRootFromParent_Done,
     /* 1662397 */   // Label 22850: @1662397
     /* 1662397 */   GIM_Try, /*On fail goto*//*Label 22851*/ GIMT_Encode4(1662483), // Rule ID 6072 //
     /* 1662402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1662405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1662422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662448 */     // MIs[0] policy
     /* 1662448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662482 */     // GIR_Coverage, 6072,
     /* 1662482 */     GIR_EraseRootFromParent_Done,
     /* 1662483 */   // Label 22851: @1662483
     /* 1662483 */   GIM_Try, /*On fail goto*//*Label 22852*/ GIMT_Encode4(1662569), // Rule ID 6073 //
     /* 1662488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1662491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1662499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1662502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1662505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1662508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662534 */     // MIs[0] policy
     /* 1662534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1662547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1662565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662568 */     // GIR_Coverage, 6073,
     /* 1662568 */     GIR_EraseRootFromParent_Done,
     /* 1662569 */   // Label 22852: @1662569
     /* 1662569 */   GIM_Try, /*On fail goto*//*Label 22853*/ GIMT_Encode4(1662655), // Rule ID 6076 //
     /* 1662574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1662585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1662588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1662591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1662594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1662597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1662604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662620 */     // MIs[0] policy
     /* 1662620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662630 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1662633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662654 */     // GIR_Coverage, 6076,
     /* 1662654 */     GIR_EraseRootFromParent_Done,
     /* 1662655 */   // Label 22853: @1662655
     /* 1662655 */   GIM_Try, /*On fail goto*//*Label 22854*/ GIMT_Encode4(1662741), // Rule ID 6077 //
     /* 1662660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1662671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1662674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1662677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1662680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1662683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1662690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1662702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662706 */     // MIs[0] policy
     /* 1662706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662716 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1662719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662740 */     // GIR_Coverage, 6077,
     /* 1662740 */     GIR_EraseRootFromParent_Done,
     /* 1662741 */   // Label 22854: @1662741
     /* 1662741 */   GIM_Try, /*On fail goto*//*Label 22855*/ GIMT_Encode4(1662827), // Rule ID 6080 //
     /* 1662746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1662757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1662760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1662763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1662766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1662769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1662776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662792 */     // MIs[0] policy
     /* 1662792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662802 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1662805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662826 */     // GIR_Coverage, 6080,
     /* 1662826 */     GIR_EraseRootFromParent_Done,
     /* 1662827 */   // Label 22855: @1662827
     /* 1662827 */   GIM_Try, /*On fail goto*//*Label 22856*/ GIMT_Encode4(1662913), // Rule ID 6081 //
     /* 1662832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1662843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1662846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1662849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1662852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1662855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1662862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1662874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662878 */     // MIs[0] policy
     /* 1662878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662888 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1662891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662912 */     // GIR_Coverage, 6081,
     /* 1662912 */     GIR_EraseRootFromParent_Done,
     /* 1662913 */   // Label 22856: @1662913
     /* 1662913 */   GIM_Try, /*On fail goto*//*Label 22857*/ GIMT_Encode4(1662999), // Rule ID 6084 //
     /* 1662918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1662926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1662929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1662932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1662935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1662938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1662941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1662948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1662960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662964 */     // MIs[0] policy
     /* 1662964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662974 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1662977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662998 */     // GIR_Coverage, 6084,
     /* 1662998 */     GIR_EraseRootFromParent_Done,
     /* 1662999 */   // Label 22857: @1662999
     /* 1662999 */   GIM_Try, /*On fail goto*//*Label 22858*/ GIMT_Encode4(1663085), // Rule ID 6085 //
     /* 1663004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1663024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663050 */     // MIs[0] policy
     /* 1663050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663060 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663084 */     // GIR_Coverage, 6085,
     /* 1663084 */     GIR_EraseRootFromParent_Done,
     /* 1663085 */   // Label 22858: @1663085
     /* 1663085 */   GIM_Try, /*On fail goto*//*Label 22859*/ GIMT_Encode4(1663171), // Rule ID 6088 //
     /* 1663090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1663110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663136 */     // MIs[0] policy
     /* 1663136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663170 */     // GIR_Coverage, 6088,
     /* 1663170 */     GIR_EraseRootFromParent_Done,
     /* 1663171 */   // Label 22859: @1663171
     /* 1663171 */   GIM_Try, /*On fail goto*//*Label 22860*/ GIMT_Encode4(1663257), // Rule ID 6089 //
     /* 1663176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1663187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1663190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1663193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1663196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663222 */     // MIs[0] policy
     /* 1663222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663232 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663256 */     // GIR_Coverage, 6089,
     /* 1663256 */     GIR_EraseRootFromParent_Done,
     /* 1663257 */   // Label 22860: @1663257
     /* 1663257 */   GIM_Try, /*On fail goto*//*Label 22861*/ GIMT_Encode4(1663343), // Rule ID 6092 //
     /* 1663262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1663282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663308 */     // MIs[0] policy
     /* 1663308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663342 */     // GIR_Coverage, 6092,
     /* 1663342 */     GIR_EraseRootFromParent_Done,
     /* 1663343 */   // Label 22861: @1663343
     /* 1663343 */   GIM_Try, /*On fail goto*//*Label 22862*/ GIMT_Encode4(1663429), // Rule ID 6093 //
     /* 1663348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1663359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1663362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1663365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1663368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663394 */     // MIs[0] policy
     /* 1663394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663404 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663428 */     // GIR_Coverage, 6093,
     /* 1663428 */     GIR_EraseRootFromParent_Done,
     /* 1663429 */   // Label 22862: @1663429
     /* 1663429 */   GIM_Try, /*On fail goto*//*Label 22863*/ GIMT_Encode4(1663515), // Rule ID 6096 //
     /* 1663434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1663445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1663448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1663451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1663454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663480 */     // MIs[0] policy
     /* 1663480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663490 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663514 */     // GIR_Coverage, 6096,
     /* 1663514 */     GIR_EraseRootFromParent_Done,
     /* 1663515 */   // Label 22863: @1663515
     /* 1663515 */   GIM_Try, /*On fail goto*//*Label 22864*/ GIMT_Encode4(1663601), // Rule ID 6097 //
     /* 1663520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1663531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1663534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1663537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1663540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663566 */     // MIs[0] policy
     /* 1663566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1663579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663600 */     // GIR_Coverage, 6097,
     /* 1663600 */     GIR_EraseRootFromParent_Done,
     /* 1663601 */   // Label 22864: @1663601
     /* 1663601 */   GIM_Try, /*On fail goto*//*Label 22865*/ GIMT_Encode4(1663687), // Rule ID 6100 //
     /* 1663606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1663617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1663620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1663623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1663626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663652 */     // MIs[0] policy
     /* 1663652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663686 */     // GIR_Coverage, 6100,
     /* 1663686 */     GIR_EraseRootFromParent_Done,
     /* 1663687 */   // Label 22865: @1663687
     /* 1663687 */   GIM_Try, /*On fail goto*//*Label 22866*/ GIMT_Encode4(1663773), // Rule ID 6101 //
     /* 1663692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1663703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1663706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1663709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1663712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663738 */     // MIs[0] policy
     /* 1663738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1663751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663772 */     // GIR_Coverage, 6101,
     /* 1663772 */     GIR_EraseRootFromParent_Done,
     /* 1663773 */   // Label 22866: @1663773
     /* 1663773 */   GIM_Try, /*On fail goto*//*Label 22867*/ GIMT_Encode4(1663859), // Rule ID 6104 //
     /* 1663778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1663789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1663792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1663795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1663798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663824 */     // MIs[0] policy
     /* 1663824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663858 */     // GIR_Coverage, 6104,
     /* 1663858 */     GIR_EraseRootFromParent_Done,
     /* 1663859 */   // Label 22867: @1663859
     /* 1663859 */   GIM_Try, /*On fail goto*//*Label 22868*/ GIMT_Encode4(1663945), // Rule ID 6105 //
     /* 1663864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1663875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1663878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1663881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1663884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1663887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663910 */     // MIs[0] policy
     /* 1663910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1663923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663944 */     // GIR_Coverage, 6105,
     /* 1663944 */     GIR_EraseRootFromParent_Done,
     /* 1663945 */   // Label 22868: @1663945
     /* 1663945 */   GIM_Try, /*On fail goto*//*Label 22869*/ GIMT_Encode4(1664031), // Rule ID 6108 //
     /* 1663950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1663958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1663961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1663964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1663967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1663970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663996 */     // MIs[0] policy
     /* 1663996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664006 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664030 */     // GIR_Coverage, 6108,
     /* 1664030 */     GIR_EraseRootFromParent_Done,
     /* 1664031 */   // Label 22869: @1664031
     /* 1664031 */   GIM_Try, /*On fail goto*//*Label 22870*/ GIMT_Encode4(1664117), // Rule ID 6109 //
     /* 1664036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1664056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664082 */     // MIs[0] policy
     /* 1664082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664092 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664116 */     // GIR_Coverage, 6109,
     /* 1664116 */     GIR_EraseRootFromParent_Done,
     /* 1664117 */   // Label 22870: @1664117
     /* 1664117 */   GIM_Try, /*On fail goto*//*Label 22871*/ GIMT_Encode4(1664203), // Rule ID 6112 //
     /* 1664122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1664142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664168 */     // MIs[0] policy
     /* 1664168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664178 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664202 */     // GIR_Coverage, 6112,
     /* 1664202 */     GIR_EraseRootFromParent_Done,
     /* 1664203 */   // Label 22871: @1664203
     /* 1664203 */   GIM_Try, /*On fail goto*//*Label 22872*/ GIMT_Encode4(1664289), // Rule ID 6113 //
     /* 1664208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1664219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1664222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1664225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1664228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664254 */     // MIs[0] policy
     /* 1664254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1664267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664288 */     // GIR_Coverage, 6113,
     /* 1664288 */     GIR_EraseRootFromParent_Done,
     /* 1664289 */   // Label 22872: @1664289
     /* 1664289 */   GIM_Try, /*On fail goto*//*Label 22873*/ GIMT_Encode4(1664375), // Rule ID 6116 //
     /* 1664294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1664314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664340 */     // MIs[0] policy
     /* 1664340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664374 */     // GIR_Coverage, 6116,
     /* 1664374 */     GIR_EraseRootFromParent_Done,
     /* 1664375 */   // Label 22873: @1664375
     /* 1664375 */   GIM_Try, /*On fail goto*//*Label 22874*/ GIMT_Encode4(1664461), // Rule ID 6117 //
     /* 1664380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1664391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1664394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1664397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1664400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664426 */     // MIs[0] policy
     /* 1664426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1664439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664460 */     // GIR_Coverage, 6117,
     /* 1664460 */     GIR_EraseRootFromParent_Done,
     /* 1664461 */   // Label 22874: @1664461
     /* 1664461 */   GIM_Try, /*On fail goto*//*Label 22875*/ GIMT_Encode4(1664547), // Rule ID 6120 //
     /* 1664466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1664469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1664477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1664480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1664483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1664486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664512 */     // MIs[0] policy
     /* 1664512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664522 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664546 */     // GIR_Coverage, 6120,
     /* 1664546 */     GIR_EraseRootFromParent_Done,
     /* 1664547 */   // Label 22875: @1664547
     /* 1664547 */   GIM_Try, /*On fail goto*//*Label 22876*/ GIMT_Encode4(1664633), // Rule ID 6121 //
     /* 1664552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1664555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1664563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1664566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1664569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1664572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664598 */     // MIs[0] policy
     /* 1664598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664608 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1664611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1664629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664632 */     // GIR_Coverage, 6121,
     /* 1664632 */     GIR_EraseRootFromParent_Done,
     /* 1664633 */   // Label 22876: @1664633
     /* 1664633 */   GIM_Try, /*On fail goto*//*Label 22877*/ GIMT_Encode4(1664719), // Rule ID 6124 //
     /* 1664638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1664649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1664652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1664655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1664661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664684 */     // MIs[0] policy
     /* 1664684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664694 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1664697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664718 */     // GIR_Coverage, 6124,
     /* 1664718 */     GIR_EraseRootFromParent_Done,
     /* 1664719 */   // Label 22877: @1664719
     /* 1664719 */   GIM_Try, /*On fail goto*//*Label 22878*/ GIMT_Encode4(1664805), // Rule ID 6125 //
     /* 1664724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1664735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1664738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1664741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1664747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664770 */     // MIs[0] policy
     /* 1664770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664780 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1664783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664804 */     // GIR_Coverage, 6125,
     /* 1664804 */     GIR_EraseRootFromParent_Done,
     /* 1664805 */   // Label 22878: @1664805
     /* 1664805 */   GIM_Try, /*On fail goto*//*Label 22879*/ GIMT_Encode4(1664891), // Rule ID 6128 //
     /* 1664810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1664821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1664824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1664827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1664830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664856 */     // MIs[0] policy
     /* 1664856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664866 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1664869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664890 */     // GIR_Coverage, 6128,
     /* 1664890 */     GIR_EraseRootFromParent_Done,
     /* 1664891 */   // Label 22879: @1664891
     /* 1664891 */   GIM_Try, /*On fail goto*//*Label 22880*/ GIMT_Encode4(1664977), // Rule ID 6129 //
     /* 1664896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1664907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1664910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1664913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1664916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1664919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1664926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1664934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1664938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664942 */     // MIs[0] policy
     /* 1664942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664952 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1664955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664976 */     // GIR_Coverage, 6129,
     /* 1664976 */     GIR_EraseRootFromParent_Done,
     /* 1664977 */   // Label 22880: @1664977
     /* 1664977 */   GIM_Try, /*On fail goto*//*Label 22881*/ GIMT_Encode4(1665063), // Rule ID 6132 //
     /* 1664982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1664990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1664993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1664996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1664999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665028 */     // MIs[0] policy
     /* 1665028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665038 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665062 */     // GIR_Coverage, 6132,
     /* 1665062 */     GIR_EraseRootFromParent_Done,
     /* 1665063 */   // Label 22881: @1665063
     /* 1665063 */   GIM_Try, /*On fail goto*//*Label 22882*/ GIMT_Encode4(1665149), // Rule ID 6133 //
     /* 1665068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665114 */     // MIs[0] policy
     /* 1665114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665124 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665148 */     // GIR_Coverage, 6133,
     /* 1665148 */     GIR_EraseRootFromParent_Done,
     /* 1665149 */   // Label 22882: @1665149
     /* 1665149 */   GIM_Try, /*On fail goto*//*Label 22883*/ GIMT_Encode4(1665235), // Rule ID 6136 //
     /* 1665154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665200 */     // MIs[0] policy
     /* 1665200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665234 */     // GIR_Coverage, 6136,
     /* 1665234 */     GIR_EraseRootFromParent_Done,
     /* 1665235 */   // Label 22883: @1665235
     /* 1665235 */   GIM_Try, /*On fail goto*//*Label 22884*/ GIMT_Encode4(1665321), // Rule ID 6137 //
     /* 1665240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1665251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1665254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1665257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665286 */     // MIs[0] policy
     /* 1665286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665296 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1665299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665320 */     // GIR_Coverage, 6137,
     /* 1665320 */     GIR_EraseRootFromParent_Done,
     /* 1665321 */   // Label 22884: @1665321
     /* 1665321 */   GIM_Try, /*On fail goto*//*Label 22885*/ GIMT_Encode4(1665407), // Rule ID 6140 //
     /* 1665326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665372 */     // MIs[0] policy
     /* 1665372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665406 */     // GIR_Coverage, 6140,
     /* 1665406 */     GIR_EraseRootFromParent_Done,
     /* 1665407 */   // Label 22885: @1665407
     /* 1665407 */   GIM_Try, /*On fail goto*//*Label 22886*/ GIMT_Encode4(1665493), // Rule ID 6141 //
     /* 1665412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1665423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1665426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1665429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665458 */     // MIs[0] policy
     /* 1665458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665492 */     // GIR_Coverage, 6141,
     /* 1665492 */     GIR_EraseRootFromParent_Done,
     /* 1665493 */   // Label 22886: @1665493
     /* 1665493 */   GIM_Try, /*On fail goto*//*Label 22887*/ GIMT_Encode4(1665579), // Rule ID 6144 //
     /* 1665498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1665509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1665512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1665515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665544 */     // MIs[0] policy
     /* 1665544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665578 */     // GIR_Coverage, 6144,
     /* 1665578 */     GIR_EraseRootFromParent_Done,
     /* 1665579 */   // Label 22887: @1665579
     /* 1665579 */   GIM_Try, /*On fail goto*//*Label 22888*/ GIMT_Encode4(1665665), // Rule ID 6145 //
     /* 1665584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1665595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1665598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1665601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665630 */     // MIs[0] policy
     /* 1665630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1665643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665664 */     // GIR_Coverage, 6145,
     /* 1665664 */     GIR_EraseRootFromParent_Done,
     /* 1665665 */   // Label 22888: @1665665
     /* 1665665 */   GIM_Try, /*On fail goto*//*Label 22889*/ GIMT_Encode4(1665751), // Rule ID 6148 //
     /* 1665670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1665681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1665684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1665687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665716 */     // MIs[0] policy
     /* 1665716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1665729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665750 */     // GIR_Coverage, 6148,
     /* 1665750 */     GIR_EraseRootFromParent_Done,
     /* 1665751 */   // Label 22889: @1665751
     /* 1665751 */   GIM_Try, /*On fail goto*//*Label 22890*/ GIMT_Encode4(1665837), // Rule ID 6149 //
     /* 1665756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1665767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1665770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1665773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665802 */     // MIs[0] policy
     /* 1665802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11496:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1665815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665836 */     // GIR_Coverage, 6149,
     /* 1665836 */     GIR_EraseRootFromParent_Done,
     /* 1665837 */   // Label 22890: @1665837
     /* 1665837 */   GIM_Try, /*On fail goto*//*Label 22891*/ GIMT_Encode4(1665923), // Rule ID 6152 //
     /* 1665842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1665853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1665856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1665859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665888 */     // MIs[0] policy
     /* 1665888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1665901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1665919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665922 */     // GIR_Coverage, 6152,
     /* 1665922 */     GIR_EraseRootFromParent_Done,
     /* 1665923 */   // Label 22891: @1665923
     /* 1665923 */   GIM_Try, /*On fail goto*//*Label 22892*/ GIMT_Encode4(1666009), // Rule ID 6153 //
     /* 1665928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1665936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1665939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1665942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1665945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665974 */     // MIs[0] policy
     /* 1665974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665984 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11496:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1665987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666008 */     // GIR_Coverage, 6153,
     /* 1666008 */     GIR_EraseRootFromParent_Done,
     /* 1666009 */   // Label 22892: @1666009
     /* 1666009 */   GIM_Try, /*On fail goto*//*Label 22893*/ GIMT_Encode4(1666095), // Rule ID 6156 //
     /* 1666014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666060 */     // MIs[0] policy
     /* 1666060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666094 */     // GIR_Coverage, 6156,
     /* 1666094 */     GIR_EraseRootFromParent_Done,
     /* 1666095 */   // Label 22893: @1666095
     /* 1666095 */   GIM_Try, /*On fail goto*//*Label 22894*/ GIMT_Encode4(1666181), // Rule ID 6157 //
     /* 1666100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1666111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1666114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1666117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666146 */     // MIs[0] policy
     /* 1666146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11496:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666180 */     // GIR_Coverage, 6157,
     /* 1666180 */     GIR_EraseRootFromParent_Done,
     /* 1666181 */   // Label 22894: @1666181
     /* 1666181 */   GIM_Try, /*On fail goto*//*Label 22895*/ GIMT_Encode4(1666267), // Rule ID 6160 //
     /* 1666186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1666189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666232 */     // MIs[0] policy
     /* 1666232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666266 */     // GIR_Coverage, 6160,
     /* 1666266 */     GIR_EraseRootFromParent_Done,
     /* 1666267 */   // Label 22895: @1666267
     /* 1666267 */   GIM_Try, /*On fail goto*//*Label 22896*/ GIMT_Encode4(1666353), // Rule ID 6161 //
     /* 1666272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1666275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1666283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1666286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1666289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666318 */     // MIs[0] policy
     /* 1666318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11496:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1666331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1666349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666352 */     // GIR_Coverage, 6161,
     /* 1666352 */     GIR_EraseRootFromParent_Done,
     /* 1666353 */   // Label 22896: @1666353
     /* 1666353 */   GIM_Try, /*On fail goto*//*Label 22897*/ GIMT_Encode4(1666439), // Rule ID 6164 //
     /* 1666358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666404 */     // MIs[0] policy
     /* 1666404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666414 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666438 */     // GIR_Coverage, 6164,
     /* 1666438 */     GIR_EraseRootFromParent_Done,
     /* 1666439 */   // Label 22897: @1666439
     /* 1666439 */   GIM_Try, /*On fail goto*//*Label 22898*/ GIMT_Encode4(1666525), // Rule ID 6165 //
     /* 1666444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1666455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1666458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1666461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1666467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666490 */     // MIs[0] policy
     /* 1666490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666500 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666524 */     // GIR_Coverage, 6165,
     /* 1666524 */     GIR_EraseRootFromParent_Done,
     /* 1666525 */   // Label 22898: @1666525
     /* 1666525 */   GIM_Try, /*On fail goto*//*Label 22899*/ GIMT_Encode4(1666611), // Rule ID 6168 //
     /* 1666530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1666541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1666544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1666547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1666553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666576 */     // MIs[0] policy
     /* 1666576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666586 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1666589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666610 */     // GIR_Coverage, 6168,
     /* 1666610 */     GIR_EraseRootFromParent_Done,
     /* 1666611 */   // Label 22899: @1666611
     /* 1666611 */   GIM_Try, /*On fail goto*//*Label 22900*/ GIMT_Encode4(1666697), // Rule ID 6169 //
     /* 1666616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1666627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1666630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1666633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1666639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1666646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1666654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666662 */     // MIs[0] policy
     /* 1666662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666672 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1666675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666696 */     // GIR_Coverage, 6169,
     /* 1666696 */     GIR_EraseRootFromParent_Done,
     /* 1666697 */   // Label 22900: @1666697
     /* 1666697 */   GIM_Try, /*On fail goto*//*Label 22901*/ GIMT_Encode4(1666783), // Rule ID 6172 //
     /* 1666702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1666713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1666716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1666719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1666725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666748 */     // MIs[0] policy
     /* 1666748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666758 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1666761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666782 */     // GIR_Coverage, 6172,
     /* 1666782 */     GIR_EraseRootFromParent_Done,
     /* 1666783 */   // Label 22901: @1666783
     /* 1666783 */   GIM_Try, /*On fail goto*//*Label 22902*/ GIMT_Encode4(1666869), // Rule ID 6173 //
     /* 1666788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1666799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1666802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1666805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1666811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1666818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1666826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666834 */     // MIs[0] policy
     /* 1666834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1666847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666868 */     // GIR_Coverage, 6173,
     /* 1666868 */     GIR_EraseRootFromParent_Done,
     /* 1666869 */   // Label 22902: @1666869
     /* 1666869 */   GIM_Try, /*On fail goto*//*Label 22903*/ GIMT_Encode4(1666955), // Rule ID 6176 //
     /* 1666874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1666885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1666888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1666891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666920 */     // MIs[0] policy
     /* 1666920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1666933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666954 */     // GIR_Coverage, 6176,
     /* 1666954 */     GIR_EraseRootFromParent_Done,
     /* 1666955 */   // Label 22903: @1666955
     /* 1666955 */   GIM_Try, /*On fail goto*//*Label 22904*/ GIMT_Encode4(1667041), // Rule ID 6177 //
     /* 1666960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1666968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1666971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1666974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1666977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1666990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1666998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667006 */     // MIs[0] policy
     /* 1667006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667016 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667040 */     // GIR_Coverage, 6177,
     /* 1667040 */     GIR_EraseRootFromParent_Done,
     /* 1667041 */   // Label 22904: @1667041
     /* 1667041 */   GIM_Try, /*On fail goto*//*Label 22905*/ GIMT_Encode4(1667127), // Rule ID 6180 //
     /* 1667046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667092 */     // MIs[0] policy
     /* 1667092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667102 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667126 */     // GIR_Coverage, 6180,
     /* 1667126 */     GIR_EraseRootFromParent_Done,
     /* 1667127 */   // Label 22905: @1667127
     /* 1667127 */   GIM_Try, /*On fail goto*//*Label 22906*/ GIMT_Encode4(1667213), // Rule ID 6181 //
     /* 1667132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1667143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1667146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1667149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667178 */     // MIs[0] policy
     /* 1667178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667188 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667212 */     // GIR_Coverage, 6181,
     /* 1667212 */     GIR_EraseRootFromParent_Done,
     /* 1667213 */   // Label 22906: @1667213
     /* 1667213 */   GIM_Try, /*On fail goto*//*Label 22907*/ GIMT_Encode4(1667299), // Rule ID 6184 //
     /* 1667218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667264 */     // MIs[0] policy
     /* 1667264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667298 */     // GIR_Coverage, 6184,
     /* 1667298 */     GIR_EraseRootFromParent_Done,
     /* 1667299 */   // Label 22907: @1667299
     /* 1667299 */   GIM_Try, /*On fail goto*//*Label 22908*/ GIMT_Encode4(1667385), // Rule ID 6185 //
     /* 1667304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1667315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1667318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1667321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667350 */     // MIs[0] policy
     /* 1667350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667360 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667384 */     // GIR_Coverage, 6185,
     /* 1667384 */     GIR_EraseRootFromParent_Done,
     /* 1667385 */   // Label 22908: @1667385
     /* 1667385 */   GIM_Try, /*On fail goto*//*Label 22909*/ GIMT_Encode4(1667471), // Rule ID 6188 //
     /* 1667390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667436 */     // MIs[0] policy
     /* 1667436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667470 */     // GIR_Coverage, 6188,
     /* 1667470 */     GIR_EraseRootFromParent_Done,
     /* 1667471 */   // Label 22909: @1667471
     /* 1667471 */   GIM_Try, /*On fail goto*//*Label 22910*/ GIMT_Encode4(1667557), // Rule ID 6189 //
     /* 1667476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1667487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1667490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1667493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1667499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667522 */     // MIs[0] policy
     /* 1667522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667556 */     // GIR_Coverage, 6189,
     /* 1667556 */     GIR_EraseRootFromParent_Done,
     /* 1667557 */   // Label 22910: @1667557
     /* 1667557 */   GIM_Try, /*On fail goto*//*Label 22911*/ GIMT_Encode4(1667643), // Rule ID 6192 //
     /* 1667562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1667573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1667576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1667579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667608 */     // MIs[0] policy
     /* 1667608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667642 */     // GIR_Coverage, 6192,
     /* 1667642 */     GIR_EraseRootFromParent_Done,
     /* 1667643 */   // Label 22911: @1667643
     /* 1667643 */   GIM_Try, /*On fail goto*//*Label 22912*/ GIMT_Encode4(1667729), // Rule ID 6193 //
     /* 1667648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1667659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1667662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1667665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667694 */     // MIs[0] policy
     /* 1667694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667704 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1667707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667728 */     // GIR_Coverage, 6193,
     /* 1667728 */     GIR_EraseRootFromParent_Done,
     /* 1667729 */   // Label 22912: @1667729
     /* 1667729 */   GIM_Try, /*On fail goto*//*Label 22913*/ GIMT_Encode4(1667815), // Rule ID 6196 //
     /* 1667734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1667745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1667748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1667751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667780 */     // MIs[0] policy
     /* 1667780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667790 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667814 */     // GIR_Coverage, 6196,
     /* 1667814 */     GIR_EraseRootFromParent_Done,
     /* 1667815 */   // Label 22913: @1667815
     /* 1667815 */   GIM_Try, /*On fail goto*//*Label 22914*/ GIMT_Encode4(1667901), // Rule ID 6197 //
     /* 1667820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1667831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1667834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1667837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667866 */     // MIs[0] policy
     /* 1667866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667876 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1667879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667900 */     // GIR_Coverage, 6197,
     /* 1667900 */     GIR_EraseRootFromParent_Done,
     /* 1667901 */   // Label 22914: @1667901
     /* 1667901 */   GIM_Try, /*On fail goto*//*Label 22915*/ GIMT_Encode4(1667987), // Rule ID 6200 //
     /* 1667906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1667909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1667914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1667917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1667920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1667923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667952 */     // MIs[0] policy
     /* 1667952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1667965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667986 */     // GIR_Coverage, 6200,
     /* 1667986 */     GIR_EraseRootFromParent_Done,
     /* 1667987 */   // Label 22915: @1667987
     /* 1667987 */   GIM_Try, /*On fail goto*//*Label 22916*/ GIMT_Encode4(1668073), // Rule ID 6201 //
     /* 1667992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1667995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668038 */     // MIs[0] policy
     /* 1668038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668048 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11496:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1668051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668072 */     // GIR_Coverage, 6201,
     /* 1668072 */     GIR_EraseRootFromParent_Done,
     /* 1668073 */   // Label 22916: @1668073
     /* 1668073 */   GIM_Try, /*On fail goto*//*Label 22917*/ GIMT_Encode4(1668159), // Rule ID 6204 //
     /* 1668078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668124 */     // MIs[0] policy
     /* 1668124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668158 */     // GIR_Coverage, 6204,
     /* 1668158 */     GIR_EraseRootFromParent_Done,
     /* 1668159 */   // Label 22917: @1668159
     /* 1668159 */   GIM_Try, /*On fail goto*//*Label 22918*/ GIMT_Encode4(1668245), // Rule ID 6205 //
     /* 1668164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1668175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1668178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1668181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668210 */     // MIs[0] policy
     /* 1668210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11496:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1668223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668244 */     // GIR_Coverage, 6205,
     /* 1668244 */     GIR_EraseRootFromParent_Done,
     /* 1668245 */   // Label 22918: @1668245
     /* 1668245 */   GIM_Try, /*On fail goto*//*Label 22919*/ GIMT_Encode4(1668331), // Rule ID 6208 //
     /* 1668250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668296 */     // MIs[0] policy
     /* 1668296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668330 */     // GIR_Coverage, 6208,
     /* 1668330 */     GIR_EraseRootFromParent_Done,
     /* 1668331 */   // Label 22919: @1668331
     /* 1668331 */   GIM_Try, /*On fail goto*//*Label 22920*/ GIMT_Encode4(1668417), // Rule ID 6209 //
     /* 1668336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1668344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1668347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1668350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1668353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668382 */     // MIs[0] policy
     /* 1668382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668392 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11496:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1668395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668416 */     // GIR_Coverage, 6209,
     /* 1668416 */     GIR_EraseRootFromParent_Done,
     /* 1668417 */   // Label 22920: @1668417
     /* 1668417 */   GIM_Try, /*On fail goto*//*Label 22921*/ GIMT_Encode4(1668503), // Rule ID 6300 //
     /* 1668422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1668442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668468 */     // MIs[0] policy
     /* 1668468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668478 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1668481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668502 */     // GIR_Coverage, 6300,
     /* 1668502 */     GIR_EraseRootFromParent_Done,
     /* 1668503 */   // Label 22921: @1668503
     /* 1668503 */   GIM_Try, /*On fail goto*//*Label 22922*/ GIMT_Encode4(1668589), // Rule ID 6301 //
     /* 1668508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1668519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1668522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1668525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1668528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668554 */     // MIs[0] policy
     /* 1668554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1668567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668588 */     // GIR_Coverage, 6301,
     /* 1668588 */     GIR_EraseRootFromParent_Done,
     /* 1668589 */   // Label 22922: @1668589
     /* 1668589 */   GIM_Try, /*On fail goto*//*Label 22923*/ GIMT_Encode4(1668675), // Rule ID 6304 //
     /* 1668594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1668605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1668608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1668611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1668614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668640 */     // MIs[0] policy
     /* 1668640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668650 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1668653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668674 */     // GIR_Coverage, 6304,
     /* 1668674 */     GIR_EraseRootFromParent_Done,
     /* 1668675 */   // Label 22923: @1668675
     /* 1668675 */   GIM_Try, /*On fail goto*//*Label 22924*/ GIMT_Encode4(1668761), // Rule ID 6305 //
     /* 1668680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1668691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1668694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1668697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1668700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668726 */     // MIs[0] policy
     /* 1668726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668736 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1668739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668760 */     // GIR_Coverage, 6305,
     /* 1668760 */     GIR_EraseRootFromParent_Done,
     /* 1668761 */   // Label 22924: @1668761
     /* 1668761 */   GIM_Try, /*On fail goto*//*Label 22925*/ GIMT_Encode4(1668847), // Rule ID 6308 //
     /* 1668766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1668777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1668780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1668783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1668786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668812 */     // MIs[0] policy
     /* 1668812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668822 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1668825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668846 */     // GIR_Coverage, 6308,
     /* 1668846 */     GIR_EraseRootFromParent_Done,
     /* 1668847 */   // Label 22925: @1668847
     /* 1668847 */   GIM_Try, /*On fail goto*//*Label 22926*/ GIMT_Encode4(1668933), // Rule ID 6309 //
     /* 1668852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1668863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1668866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1668869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1668872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668898 */     // MIs[0] policy
     /* 1668898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668908 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1668911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1668929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668932 */     // GIR_Coverage, 6309,
     /* 1668932 */     GIR_EraseRootFromParent_Done,
     /* 1668933 */   // Label 22926: @1668933
     /* 1668933 */   GIM_Try, /*On fail goto*//*Label 22927*/ GIMT_Encode4(1669019), // Rule ID 6312 //
     /* 1668938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1668949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1668952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1668955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1668958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1668961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1668968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1668980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668984 */     // MIs[0] policy
     /* 1668984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1668997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669018 */     // GIR_Coverage, 6312,
     /* 1669018 */     GIR_EraseRootFromParent_Done,
     /* 1669019 */   // Label 22927: @1669019
     /* 1669019 */   GIM_Try, /*On fail goto*//*Label 22928*/ GIMT_Encode4(1669105), // Rule ID 6313 //
     /* 1669024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1669044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669070 */     // MIs[0] policy
     /* 1669070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669080 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1669083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669104 */     // GIR_Coverage, 6313,
     /* 1669104 */     GIR_EraseRootFromParent_Done,
     /* 1669105 */   // Label 22928: @1669105
     /* 1669105 */   GIM_Try, /*On fail goto*//*Label 22929*/ GIMT_Encode4(1669191), // Rule ID 6316 //
     /* 1669110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669156 */     // MIs[0] policy
     /* 1669156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669166 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669190 */     // GIR_Coverage, 6316,
     /* 1669190 */     GIR_EraseRootFromParent_Done,
     /* 1669191 */   // Label 22929: @1669191
     /* 1669191 */   GIM_Try, /*On fail goto*//*Label 22930*/ GIMT_Encode4(1669277), // Rule ID 6317 //
     /* 1669196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1669207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1669210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1669213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1669216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669242 */     // MIs[0] policy
     /* 1669242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669252 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669276 */     // GIR_Coverage, 6317,
     /* 1669276 */     GIR_EraseRootFromParent_Done,
     /* 1669277 */   // Label 22930: @1669277
     /* 1669277 */   GIM_Try, /*On fail goto*//*Label 22931*/ GIMT_Encode4(1669363), // Rule ID 6320 //
     /* 1669282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1669302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669328 */     // MIs[0] policy
     /* 1669328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669338 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669362 */     // GIR_Coverage, 6320,
     /* 1669362 */     GIR_EraseRootFromParent_Done,
     /* 1669363 */   // Label 22931: @1669363
     /* 1669363 */   GIM_Try, /*On fail goto*//*Label 22932*/ GIMT_Encode4(1669449), // Rule ID 6321 //
     /* 1669368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1669379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1669382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1669385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1669388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669414 */     // MIs[0] policy
     /* 1669414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669424 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1669427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669448 */     // GIR_Coverage, 6321,
     /* 1669448 */     GIR_EraseRootFromParent_Done,
     /* 1669449 */   // Label 22932: @1669449
     /* 1669449 */   GIM_Try, /*On fail goto*//*Label 22933*/ GIMT_Encode4(1669535), // Rule ID 6324 //
     /* 1669454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1669465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1669468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1669471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1669474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669500 */     // MIs[0] policy
     /* 1669500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669534 */     // GIR_Coverage, 6324,
     /* 1669534 */     GIR_EraseRootFromParent_Done,
     /* 1669535 */   // Label 22933: @1669535
     /* 1669535 */   GIM_Try, /*On fail goto*//*Label 22934*/ GIMT_Encode4(1669621), // Rule ID 6325 //
     /* 1669540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1669551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1669554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1669557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1669560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669586 */     // MIs[0] policy
     /* 1669586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669620 */     // GIR_Coverage, 6325,
     /* 1669620 */     GIR_EraseRootFromParent_Done,
     /* 1669621 */   // Label 22934: @1669621
     /* 1669621 */   GIM_Try, /*On fail goto*//*Label 22935*/ GIMT_Encode4(1669707), // Rule ID 6328 //
     /* 1669626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1669637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1669640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1669643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1669646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669672 */     // MIs[0] policy
     /* 1669672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669706 */     // GIR_Coverage, 6328,
     /* 1669706 */     GIR_EraseRootFromParent_Done,
     /* 1669707 */   // Label 22935: @1669707
     /* 1669707 */   GIM_Try, /*On fail goto*//*Label 22936*/ GIMT_Encode4(1669793), // Rule ID 6329 //
     /* 1669712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1669723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1669726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1669729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1669732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669758 */     // MIs[0] policy
     /* 1669758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669792 */     // GIR_Coverage, 6329,
     /* 1669792 */     GIR_EraseRootFromParent_Done,
     /* 1669793 */   // Label 22936: @1669793
     /* 1669793 */   GIM_Try, /*On fail goto*//*Label 22937*/ GIMT_Encode4(1669879), // Rule ID 6332 //
     /* 1669798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1669809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1669812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1669815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1669818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669844 */     // MIs[0] policy
     /* 1669844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669878 */     // GIR_Coverage, 6332,
     /* 1669878 */     GIR_EraseRootFromParent_Done,
     /* 1669879 */   // Label 22937: @1669879
     /* 1669879 */   GIM_Try, /*On fail goto*//*Label 22938*/ GIMT_Encode4(1669965), // Rule ID 6333 //
     /* 1669884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1669895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1669898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1669901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1669904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669930 */     // MIs[0] policy
     /* 1669930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1669943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1669961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669964 */     // GIR_Coverage, 6333,
     /* 1669964 */     GIR_EraseRootFromParent_Done,
     /* 1669965 */   // Label 22938: @1669965
     /* 1669965 */   GIM_Try, /*On fail goto*//*Label 22939*/ GIMT_Encode4(1670051), // Rule ID 6336 //
     /* 1669970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1669973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1669981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1669984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1669987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1669990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670016 */     // MIs[0] policy
     /* 1670016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670050 */     // GIR_Coverage, 6336,
     /* 1670050 */     GIR_EraseRootFromParent_Done,
     /* 1670051 */   // Label 22939: @1670051
     /* 1670051 */   GIM_Try, /*On fail goto*//*Label 22940*/ GIMT_Encode4(1670137), // Rule ID 6337 //
     /* 1670056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1670059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670102 */     // MIs[0] policy
     /* 1670102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670112 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1670115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1670133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670136 */     // GIR_Coverage, 6337,
     /* 1670136 */     GIR_EraseRootFromParent_Done,
     /* 1670137 */   // Label 22940: @1670137
     /* 1670137 */   GIM_Try, /*On fail goto*//*Label 22941*/ GIMT_Encode4(1670223), // Rule ID 6340 //
     /* 1670142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670188 */     // MIs[0] policy
     /* 1670188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670222 */     // GIR_Coverage, 6340,
     /* 1670222 */     GIR_EraseRootFromParent_Done,
     /* 1670223 */   // Label 22941: @1670223
     /* 1670223 */   GIM_Try, /*On fail goto*//*Label 22942*/ GIMT_Encode4(1670309), // Rule ID 6341 //
     /* 1670228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1670239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1670242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1670245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1670248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670274 */     // MIs[0] policy
     /* 1670274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670308 */     // GIR_Coverage, 6341,
     /* 1670308 */     GIR_EraseRootFromParent_Done,
     /* 1670309 */   // Label 22942: @1670309
     /* 1670309 */   GIM_Try, /*On fail goto*//*Label 22943*/ GIMT_Encode4(1670395), // Rule ID 6344 //
     /* 1670314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1670334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670360 */     // MIs[0] policy
     /* 1670360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670370 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670394 */     // GIR_Coverage, 6344,
     /* 1670394 */     GIR_EraseRootFromParent_Done,
     /* 1670395 */   // Label 22943: @1670395
     /* 1670395 */   GIM_Try, /*On fail goto*//*Label 22944*/ GIMT_Encode4(1670481), // Rule ID 6345 //
     /* 1670400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1670411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1670414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1670417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1670420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1670423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670446 */     // MIs[0] policy
     /* 1670446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670456 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670480 */     // GIR_Coverage, 6345,
     /* 1670480 */     GIR_EraseRootFromParent_Done,
     /* 1670481 */   // Label 22944: @1670481
     /* 1670481 */   GIM_Try, /*On fail goto*//*Label 22945*/ GIMT_Encode4(1670567), // Rule ID 6348 //
     /* 1670486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1670497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1670500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1670503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1670506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1670509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1670516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670532 */     // MIs[0] policy
     /* 1670532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670542 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1670545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670566 */     // GIR_Coverage, 6348,
     /* 1670566 */     GIR_EraseRootFromParent_Done,
     /* 1670567 */   // Label 22945: @1670567
     /* 1670567 */   GIM_Try, /*On fail goto*//*Label 22946*/ GIMT_Encode4(1670653), // Rule ID 6349 //
     /* 1670572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1670583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1670586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1670589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1670592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1670595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1670602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1670614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670618 */     // MIs[0] policy
     /* 1670618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670628 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1670631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670652 */     // GIR_Coverage, 6349,
     /* 1670652 */     GIR_EraseRootFromParent_Done,
     /* 1670653 */   // Label 22946: @1670653
     /* 1670653 */   GIM_Try, /*On fail goto*//*Label 22947*/ GIMT_Encode4(1670739), // Rule ID 6352 //
     /* 1670658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1670669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1670672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1670675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1670678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670704 */     // MIs[0] policy
     /* 1670704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670738 */     // GIR_Coverage, 6352,
     /* 1670738 */     GIR_EraseRootFromParent_Done,
     /* 1670739 */   // Label 22947: @1670739
     /* 1670739 */   GIM_Try, /*On fail goto*//*Label 22948*/ GIMT_Encode4(1670825), // Rule ID 6353 //
     /* 1670744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1670755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1670758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1670761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1670764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1670774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1670786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670790 */     // MIs[0] policy
     /* 1670790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1670803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670824 */     // GIR_Coverage, 6353,
     /* 1670824 */     GIR_EraseRootFromParent_Done,
     /* 1670825 */   // Label 22948: @1670825
     /* 1670825 */   GIM_Try, /*On fail goto*//*Label 22949*/ GIMT_Encode4(1670911), // Rule ID 6356 //
     /* 1670830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1670841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1670844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1670847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1670850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670876 */     // MIs[0] policy
     /* 1670876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670886 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670910 */     // GIR_Coverage, 6356,
     /* 1670910 */     GIR_EraseRootFromParent_Done,
     /* 1670911 */   // Label 22949: @1670911
     /* 1670911 */   GIM_Try, /*On fail goto*//*Label 22950*/ GIMT_Encode4(1670997), // Rule ID 6357 //
     /* 1670916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1670924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1670927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1670930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1670933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1670936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1670939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1670946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1670958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670962 */     // MIs[0] policy
     /* 1670962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1670975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670996 */     // GIR_Coverage, 6357,
     /* 1670996 */     GIR_EraseRootFromParent_Done,
     /* 1670997 */   // Label 22950: @1670997
     /* 1670997 */   GIM_Try, /*On fail goto*//*Label 22951*/ GIMT_Encode4(1671083), // Rule ID 6360 //
     /* 1671002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671048 */     // MIs[0] policy
     /* 1671048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671058 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671082 */     // GIR_Coverage, 6360,
     /* 1671082 */     GIR_EraseRootFromParent_Done,
     /* 1671083 */   // Label 22951: @1671083
     /* 1671083 */   GIM_Try, /*On fail goto*//*Label 22952*/ GIMT_Encode4(1671169), // Rule ID 6361 //
     /* 1671088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1671105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1671108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671134 */     // MIs[0] policy
     /* 1671134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671144 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671168 */     // GIR_Coverage, 6361,
     /* 1671168 */     GIR_EraseRootFromParent_Done,
     /* 1671169 */   // Label 22952: @1671169
     /* 1671169 */   GIM_Try, /*On fail goto*//*Label 22953*/ GIMT_Encode4(1671255), // Rule ID 6364 //
     /* 1671174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671220 */     // MIs[0] policy
     /* 1671220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671254 */     // GIR_Coverage, 6364,
     /* 1671254 */     GIR_EraseRootFromParent_Done,
     /* 1671255 */   // Label 22953: @1671255
     /* 1671255 */   GIM_Try, /*On fail goto*//*Label 22954*/ GIMT_Encode4(1671341), // Rule ID 6365 //
     /* 1671260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1671271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1671274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1671277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1671280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671306 */     // MIs[0] policy
     /* 1671306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671340 */     // GIR_Coverage, 6365,
     /* 1671340 */     GIR_EraseRootFromParent_Done,
     /* 1671341 */   // Label 22954: @1671341
     /* 1671341 */   GIM_Try, /*On fail goto*//*Label 22955*/ GIMT_Encode4(1671427), // Rule ID 6368 //
     /* 1671346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1671366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671392 */     // MIs[0] policy
     /* 1671392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671426 */     // GIR_Coverage, 6368,
     /* 1671426 */     GIR_EraseRootFromParent_Done,
     /* 1671427 */   // Label 22955: @1671427
     /* 1671427 */   GIM_Try, /*On fail goto*//*Label 22956*/ GIMT_Encode4(1671513), // Rule ID 6369 //
     /* 1671432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1671443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1671446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1671449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1671452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671478 */     // MIs[0] policy
     /* 1671478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671512 */     // GIR_Coverage, 6369,
     /* 1671512 */     GIR_EraseRootFromParent_Done,
     /* 1671513 */   // Label 22956: @1671513
     /* 1671513 */   GIM_Try, /*On fail goto*//*Label 22957*/ GIMT_Encode4(1671599), // Rule ID 6372 //
     /* 1671518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1671529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1671532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1671535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1671538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671564 */     // MIs[0] policy
     /* 1671564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671598 */     // GIR_Coverage, 6372,
     /* 1671598 */     GIR_EraseRootFromParent_Done,
     /* 1671599 */   // Label 22957: @1671599
     /* 1671599 */   GIM_Try, /*On fail goto*//*Label 22958*/ GIMT_Encode4(1671685), // Rule ID 6373 //
     /* 1671604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1671615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1671618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1671621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1671624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671650 */     // MIs[0] policy
     /* 1671650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671660 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1671663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1671681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671684 */     // GIR_Coverage, 6373,
     /* 1671684 */     GIR_EraseRootFromParent_Done,
     /* 1671685 */   // Label 22958: @1671685
     /* 1671685 */   GIM_Try, /*On fail goto*//*Label 22959*/ GIMT_Encode4(1671771), // Rule ID 6376 //
     /* 1671690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1671693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1671701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1671704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1671707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1671710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1671713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671736 */     // MIs[0] policy
     /* 1671736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671770 */     // GIR_Coverage, 6376,
     /* 1671770 */     GIR_EraseRootFromParent_Done,
     /* 1671771 */   // Label 22959: @1671771
     /* 1671771 */   GIM_Try, /*On fail goto*//*Label 22960*/ GIMT_Encode4(1671857), // Rule ID 6377 //
     /* 1671776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1671779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1671787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1671790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1671793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1671796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1671799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671822 */     // MIs[0] policy
     /* 1671822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671832 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1671835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671856 */     // GIR_Coverage, 6377,
     /* 1671856 */     GIR_EraseRootFromParent_Done,
     /* 1671857 */   // Label 22960: @1671857
     /* 1671857 */   GIM_Try, /*On fail goto*//*Label 22961*/ GIMT_Encode4(1671943), // Rule ID 6380 //
     /* 1671862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1671865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1671873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1671876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1671879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1671882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671908 */     // MIs[0] policy
     /* 1671908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1671921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671942 */     // GIR_Coverage, 6380,
     /* 1671942 */     GIR_EraseRootFromParent_Done,
     /* 1671943 */   // Label 22961: @1671943
     /* 1671943 */   GIM_Try, /*On fail goto*//*Label 22962*/ GIMT_Encode4(1672029), // Rule ID 6381 //
     /* 1671948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1671951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1671956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1671959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1671962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1671965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1671968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1671971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671994 */     // MIs[0] policy
     /* 1671994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672004 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1672007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672028 */     // GIR_Coverage, 6381,
     /* 1672028 */     GIR_EraseRootFromParent_Done,
     /* 1672029 */   // Label 22962: @1672029
     /* 1672029 */   GIM_Try, /*On fail goto*//*Label 22963*/ GIMT_Encode4(1672115), // Rule ID 6384 //
     /* 1672034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672080 */     // MIs[0] policy
     /* 1672080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672114 */     // GIR_Coverage, 6384,
     /* 1672114 */     GIR_EraseRootFromParent_Done,
     /* 1672115 */   // Label 22963: @1672115
     /* 1672115 */   GIM_Try, /*On fail goto*//*Label 22964*/ GIMT_Encode4(1672201), // Rule ID 6385 //
     /* 1672120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1672131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1672134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1672137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1672140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672166 */     // MIs[0] policy
     /* 1672166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1672179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672200 */     // GIR_Coverage, 6385,
     /* 1672200 */     GIR_EraseRootFromParent_Done,
     /* 1672201 */   // Label 22964: @1672201
     /* 1672201 */   GIM_Try, /*On fail goto*//*Label 22965*/ GIMT_Encode4(1672287), // Rule ID 6388 //
     /* 1672206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672252 */     // MIs[0] policy
     /* 1672252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672262 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1672265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672286 */     // GIR_Coverage, 6388,
     /* 1672286 */     GIR_EraseRootFromParent_Done,
     /* 1672287 */   // Label 22965: @1672287
     /* 1672287 */   GIM_Try, /*On fail goto*//*Label 22966*/ GIMT_Encode4(1672373), // Rule ID 6389 //
     /* 1672292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1672303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1672306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1672309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672338 */     // MIs[0] policy
     /* 1672338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672348 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1672351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672372 */     // GIR_Coverage, 6389,
     /* 1672372 */     GIR_EraseRootFromParent_Done,
     /* 1672373 */   // Label 22966: @1672373
     /* 1672373 */   GIM_Try, /*On fail goto*//*Label 22967*/ GIMT_Encode4(1672459), // Rule ID 6392 //
     /* 1672378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672424 */     // MIs[0] policy
     /* 1672424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672434 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672458 */     // GIR_Coverage, 6392,
     /* 1672458 */     GIR_EraseRootFromParent_Done,
     /* 1672459 */   // Label 22967: @1672459
     /* 1672459 */   GIM_Try, /*On fail goto*//*Label 22968*/ GIMT_Encode4(1672545), // Rule ID 6393 //
     /* 1672464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1672475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1672478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1672481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672510 */     // MIs[0] policy
     /* 1672510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672520 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672544 */     // GIR_Coverage, 6393,
     /* 1672544 */     GIR_EraseRootFromParent_Done,
     /* 1672545 */   // Label 22968: @1672545
     /* 1672545 */   GIM_Try, /*On fail goto*//*Label 22969*/ GIMT_Encode4(1672631), // Rule ID 6396 //
     /* 1672550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1672561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1672564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1672567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672596 */     // MIs[0] policy
     /* 1672596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672606 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1672609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672630 */     // GIR_Coverage, 6396,
     /* 1672630 */     GIR_EraseRootFromParent_Done,
     /* 1672631 */   // Label 22969: @1672631
     /* 1672631 */   GIM_Try, /*On fail goto*//*Label 22970*/ GIMT_Encode4(1672717), // Rule ID 6397 //
     /* 1672636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1672647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1672650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1672653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672682 */     // MIs[0] policy
     /* 1672682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672692 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1672695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1672713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672716 */     // GIR_Coverage, 6397,
     /* 1672716 */     GIR_EraseRootFromParent_Done,
     /* 1672717 */   // Label 22970: @1672717
     /* 1672717 */   GIM_Try, /*On fail goto*//*Label 22971*/ GIMT_Encode4(1672803), // Rule ID 6400 //
     /* 1672722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1672733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1672736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1672739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672768 */     // MIs[0] policy
     /* 1672768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672778 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672802 */     // GIR_Coverage, 6400,
     /* 1672802 */     GIR_EraseRootFromParent_Done,
     /* 1672803 */   // Label 22971: @1672803
     /* 1672803 */   GIM_Try, /*On fail goto*//*Label 22972*/ GIMT_Encode4(1672889), // Rule ID 6401 //
     /* 1672808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1672819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1672822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1672825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1672828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1672831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672854 */     // MIs[0] policy
     /* 1672854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672864 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1672867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672888 */     // GIR_Coverage, 6401,
     /* 1672888 */     GIR_EraseRootFromParent_Done,
     /* 1672889 */   // Label 22972: @1672889
     /* 1672889 */   GIM_Try, /*On fail goto*//*Label 22973*/ GIMT_Encode4(1672975), // Rule ID 6404 //
     /* 1672894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1672905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1672908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1672911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1672914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1672924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1672932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1672936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672940 */     // MIs[0] policy
     /* 1672940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672950 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1672953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672974 */     // GIR_Coverage, 6404,
     /* 1672974 */     GIR_EraseRootFromParent_Done,
     /* 1672975 */   // Label 22973: @1672975
     /* 1672975 */   GIM_Try, /*On fail goto*//*Label 22974*/ GIMT_Encode4(1673061), // Rule ID 6405 //
     /* 1672980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1672988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1672991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1672994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1672997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673026 */     // MIs[0] policy
     /* 1673026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673036 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673060 */     // GIR_Coverage, 6405,
     /* 1673060 */     GIR_EraseRootFromParent_Done,
     /* 1673061 */   // Label 22974: @1673061
     /* 1673061 */   GIM_Try, /*On fail goto*//*Label 22975*/ GIMT_Encode4(1673147), // Rule ID 6408 //
     /* 1673066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673112 */     // MIs[0] policy
     /* 1673112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673146 */     // GIR_Coverage, 6408,
     /* 1673146 */     GIR_EraseRootFromParent_Done,
     /* 1673147 */   // Label 22975: @1673147
     /* 1673147 */   GIM_Try, /*On fail goto*//*Label 22976*/ GIMT_Encode4(1673233), // Rule ID 6409 //
     /* 1673152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1673163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1673166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1673169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673198 */     // MIs[0] policy
     /* 1673198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673208 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1673211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673232 */     // GIR_Coverage, 6409,
     /* 1673232 */     GIR_EraseRootFromParent_Done,
     /* 1673233 */   // Label 22976: @1673233
     /* 1673233 */   GIM_Try, /*On fail goto*//*Label 22977*/ GIMT_Encode4(1673319), // Rule ID 6412 //
     /* 1673238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673284 */     // MIs[0] policy
     /* 1673284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673294 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673318 */     // GIR_Coverage, 6412,
     /* 1673318 */     GIR_EraseRootFromParent_Done,
     /* 1673319 */   // Label 22977: @1673319
     /* 1673319 */   GIM_Try, /*On fail goto*//*Label 22978*/ GIMT_Encode4(1673405), // Rule ID 6413 //
     /* 1673324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1673335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1673338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1673341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673370 */     // MIs[0] policy
     /* 1673370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673380 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11676:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673404 */     // GIR_Coverage, 6413,
     /* 1673404 */     GIR_EraseRootFromParent_Done,
     /* 1673405 */   // Label 22978: @1673405
     /* 1673405 */   GIM_Try, /*On fail goto*//*Label 22979*/ GIMT_Encode4(1673491), // Rule ID 6416 //
     /* 1673410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673456 */     // MIs[0] policy
     /* 1673456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673490 */     // GIR_Coverage, 6416,
     /* 1673490 */     GIR_EraseRootFromParent_Done,
     /* 1673491 */   // Label 22979: @1673491
     /* 1673491 */   GIM_Try, /*On fail goto*//*Label 22980*/ GIMT_Encode4(1673577), // Rule ID 6417 //
     /* 1673496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1673507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1673510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1673513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673542 */     // MIs[0] policy
     /* 1673542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673552 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11676:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673576 */     // GIR_Coverage, 6417,
     /* 1673576 */     GIR_EraseRootFromParent_Done,
     /* 1673577 */   // Label 22980: @1673577
     /* 1673577 */   GIM_Try, /*On fail goto*//*Label 22981*/ GIMT_Encode4(1673663), // Rule ID 6420 //
     /* 1673582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1673593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1673596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1673599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673628 */     // MIs[0] policy
     /* 1673628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673662 */     // GIR_Coverage, 6420,
     /* 1673662 */     GIR_EraseRootFromParent_Done,
     /* 1673663 */   // Label 22981: @1673663
     /* 1673663 */   GIM_Try, /*On fail goto*//*Label 22982*/ GIMT_Encode4(1673749), // Rule ID 6421 //
     /* 1673668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1673679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1673682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1673685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673714 */     // MIs[0] policy
     /* 1673714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673724 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11676:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1673745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673748 */     // GIR_Coverage, 6421,
     /* 1673748 */     GIR_EraseRootFromParent_Done,
     /* 1673749 */   // Label 22982: @1673749
     /* 1673749 */   GIM_Try, /*On fail goto*//*Label 22983*/ GIMT_Encode4(1673835), // Rule ID 6424 //
     /* 1673754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1673757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1673765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1673768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1673771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673800 */     // MIs[0] policy
     /* 1673800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673834 */     // GIR_Coverage, 6424,
     /* 1673834 */     GIR_EraseRootFromParent_Done,
     /* 1673835 */   // Label 22983: @1673835
     /* 1673835 */   GIM_Try, /*On fail goto*//*Label 22984*/ GIMT_Encode4(1673921), // Rule ID 6425 //
     /* 1673840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1673843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1673851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1673854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1673857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673886 */     // MIs[0] policy
     /* 1673886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11676:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1673899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673920 */     // GIR_Coverage, 6425,
     /* 1673920 */     GIR_EraseRootFromParent_Done,
     /* 1673921 */   // Label 22984: @1673921
     /* 1673921 */   GIM_Try, /*On fail goto*//*Label 22985*/ GIMT_Encode4(1674007), // Rule ID 6428 //
     /* 1673926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1673934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1673937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1673940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1673943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1673949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1673956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1673960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1673964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673972 */     // MIs[0] policy
     /* 1673972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673982 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1673985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674006 */     // GIR_Coverage, 6428,
     /* 1674006 */     GIR_EraseRootFromParent_Done,
     /* 1674007 */   // Label 22985: @1674007
     /* 1674007 */   GIM_Try, /*On fail goto*//*Label 22986*/ GIMT_Encode4(1674093), // Rule ID 6429 //
     /* 1674012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674058 */     // MIs[0] policy
     /* 1674058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674092 */     // GIR_Coverage, 6429,
     /* 1674092 */     GIR_EraseRootFromParent_Done,
     /* 1674093 */   // Label 22986: @1674093
     /* 1674093 */   GIM_Try, /*On fail goto*//*Label 22987*/ GIMT_Encode4(1674179), // Rule ID 6432 //
     /* 1674098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674144 */     // MIs[0] policy
     /* 1674144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674154 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674178 */     // GIR_Coverage, 6432,
     /* 1674178 */     GIR_EraseRootFromParent_Done,
     /* 1674179 */   // Label 22987: @1674179
     /* 1674179 */   GIM_Try, /*On fail goto*//*Label 22988*/ GIMT_Encode4(1674265), // Rule ID 6433 //
     /* 1674184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1674195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1674198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1674201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674230 */     // MIs[0] policy
     /* 1674230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674240 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674264 */     // GIR_Coverage, 6433,
     /* 1674264 */     GIR_EraseRootFromParent_Done,
     /* 1674265 */   // Label 22988: @1674265
     /* 1674265 */   GIM_Try, /*On fail goto*//*Label 22989*/ GIMT_Encode4(1674351), // Rule ID 6436 //
     /* 1674270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674316 */     // MIs[0] policy
     /* 1674316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674350 */     // GIR_Coverage, 6436,
     /* 1674350 */     GIR_EraseRootFromParent_Done,
     /* 1674351 */   // Label 22989: @1674351
     /* 1674351 */   GIM_Try, /*On fail goto*//*Label 22990*/ GIMT_Encode4(1674437), // Rule ID 6437 //
     /* 1674356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1674367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1674370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1674373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1674379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674402 */     // MIs[0] policy
     /* 1674402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674412 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674436 */     // GIR_Coverage, 6437,
     /* 1674436 */     GIR_EraseRootFromParent_Done,
     /* 1674437 */   // Label 22990: @1674437
     /* 1674437 */   GIM_Try, /*On fail goto*//*Label 22991*/ GIMT_Encode4(1674523), // Rule ID 6440 //
     /* 1674442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1674453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1674456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1674459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674488 */     // MIs[0] policy
     /* 1674488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674522 */     // GIR_Coverage, 6440,
     /* 1674522 */     GIR_EraseRootFromParent_Done,
     /* 1674523 */   // Label 22991: @1674523
     /* 1674523 */   GIM_Try, /*On fail goto*//*Label 22992*/ GIMT_Encode4(1674609), // Rule ID 6441 //
     /* 1674528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1674539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1674542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1674545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674574 */     // MIs[0] policy
     /* 1674574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1674587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674608 */     // GIR_Coverage, 6441,
     /* 1674608 */     GIR_EraseRootFromParent_Done,
     /* 1674609 */   // Label 22992: @1674609
     /* 1674609 */   GIM_Try, /*On fail goto*//*Label 22993*/ GIMT_Encode4(1674695), // Rule ID 6444 //
     /* 1674614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1674625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1674628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1674631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674660 */     // MIs[0] policy
     /* 1674660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674694 */     // GIR_Coverage, 6444,
     /* 1674694 */     GIR_EraseRootFromParent_Done,
     /* 1674695 */   // Label 22993: @1674695
     /* 1674695 */   GIM_Try, /*On fail goto*//*Label 22994*/ GIMT_Encode4(1674781), // Rule ID 6445 //
     /* 1674700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1674711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1674714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1674717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1674730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1674738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674746 */     // MIs[0] policy
     /* 1674746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674756 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1674759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674780 */     // GIR_Coverage, 6445,
     /* 1674780 */     GIR_EraseRootFromParent_Done,
     /* 1674781 */   // Label 22994: @1674781
     /* 1674781 */   GIM_Try, /*On fail goto*//*Label 22995*/ GIMT_Encode4(1674867), // Rule ID 6448 //
     /* 1674786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1674797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1674800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1674803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674832 */     // MIs[0] policy
     /* 1674832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674866 */     // GIR_Coverage, 6448,
     /* 1674866 */     GIR_EraseRootFromParent_Done,
     /* 1674867 */   // Label 22995: @1674867
     /* 1674867 */   GIM_Try, /*On fail goto*//*Label 22996*/ GIMT_Encode4(1674953), // Rule ID 6449 //
     /* 1674872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1674883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1674886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1674889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1674895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1674902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1674910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674918 */     // MIs[0] policy
     /* 1674918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1674931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674952 */     // GIR_Coverage, 6449,
     /* 1674952 */     GIR_EraseRootFromParent_Done,
     /* 1674953 */   // Label 22996: @1674953
     /* 1674953 */   GIM_Try, /*On fail goto*//*Label 22997*/ GIMT_Encode4(1675039), // Rule ID 6452 //
     /* 1674958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1674966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1674969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1674972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1674975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1674981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675004 */     // MIs[0] policy
     /* 1675004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675038 */     // GIR_Coverage, 6452,
     /* 1675038 */     GIR_EraseRootFromParent_Done,
     /* 1675039 */   // Label 22997: @1675039
     /* 1675039 */   GIM_Try, /*On fail goto*//*Label 22998*/ GIMT_Encode4(1675125), // Rule ID 6453 //
     /* 1675044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675090 */     // MIs[0] policy
     /* 1675090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675124 */     // GIR_Coverage, 6453,
     /* 1675124 */     GIR_EraseRootFromParent_Done,
     /* 1675125 */   // Label 22998: @1675125
     /* 1675125 */   GIM_Try, /*On fail goto*//*Label 22999*/ GIMT_Encode4(1675211), // Rule ID 6456 //
     /* 1675130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675176 */     // MIs[0] policy
     /* 1675176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675210 */     // GIR_Coverage, 6456,
     /* 1675210 */     GIR_EraseRootFromParent_Done,
     /* 1675211 */   // Label 22999: @1675211
     /* 1675211 */   GIM_Try, /*On fail goto*//*Label 23000*/ GIMT_Encode4(1675297), // Rule ID 6457 //
     /* 1675216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1675227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1675230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1675233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675262 */     // MIs[0] policy
     /* 1675262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675272 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675296 */     // GIR_Coverage, 6457,
     /* 1675296 */     GIR_EraseRootFromParent_Done,
     /* 1675297 */   // Label 23000: @1675297
     /* 1675297 */   GIM_Try, /*On fail goto*//*Label 23001*/ GIMT_Encode4(1675383), // Rule ID 6460 //
     /* 1675302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675348 */     // MIs[0] policy
     /* 1675348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675382 */     // GIR_Coverage, 6460,
     /* 1675382 */     GIR_EraseRootFromParent_Done,
     /* 1675383 */   // Label 23001: @1675383
     /* 1675383 */   GIM_Try, /*On fail goto*//*Label 23002*/ GIMT_Encode4(1675469), // Rule ID 6461 //
     /* 1675388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1675399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1675402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1675405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675434 */     // MIs[0] policy
     /* 1675434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1675465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675468 */     // GIR_Coverage, 6461,
     /* 1675468 */     GIR_EraseRootFromParent_Done,
     /* 1675469 */   // Label 23002: @1675469
     /* 1675469 */   GIM_Try, /*On fail goto*//*Label 23003*/ GIMT_Encode4(1675555), // Rule ID 6464 //
     /* 1675474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1675485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1675488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1675491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675520 */     // MIs[0] policy
     /* 1675520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675554 */     // GIR_Coverage, 6464,
     /* 1675554 */     GIR_EraseRootFromParent_Done,
     /* 1675555 */   // Label 23003: @1675555
     /* 1675555 */   GIM_Try, /*On fail goto*//*Label 23004*/ GIMT_Encode4(1675641), // Rule ID 6465 //
     /* 1675560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1675571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1675574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1675577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1675583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675606 */     // MIs[0] policy
     /* 1675606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11676:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1675619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675640 */     // GIR_Coverage, 6465,
     /* 1675640 */     GIR_EraseRootFromParent_Done,
     /* 1675641 */   // Label 23004: @1675641
     /* 1675641 */   GIM_Try, /*On fail goto*//*Label 23005*/ GIMT_Encode4(1675727), // Rule ID 6468 //
     /* 1675646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1675657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1675660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1675663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675692 */     // MIs[0] policy
     /* 1675692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675726 */     // GIR_Coverage, 6468,
     /* 1675726 */     GIR_EraseRootFromParent_Done,
     /* 1675727 */   // Label 23005: @1675727
     /* 1675727 */   GIM_Try, /*On fail goto*//*Label 23006*/ GIMT_Encode4(1675813), // Rule ID 6469 //
     /* 1675732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1675743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1675746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1675749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675778 */     // MIs[0] policy
     /* 1675778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11676:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1675791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675812 */     // GIR_Coverage, 6469,
     /* 1675812 */     GIR_EraseRootFromParent_Done,
     /* 1675813 */   // Label 23006: @1675813
     /* 1675813 */   GIM_Try, /*On fail goto*//*Label 23007*/ GIMT_Encode4(1675899), // Rule ID 6472 //
     /* 1675818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1675821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1675829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1675832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1675835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675864 */     // MIs[0] policy
     /* 1675864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675898 */     // GIR_Coverage, 6472,
     /* 1675898 */     GIR_EraseRootFromParent_Done,
     /* 1675899 */   // Label 23007: @1675899
     /* 1675899 */   GIM_Try, /*On fail goto*//*Label 23008*/ GIMT_Encode4(1675985), // Rule ID 6473 //
     /* 1675904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1675907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1675912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1675915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1675918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1675921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675950 */     // MIs[0] policy
     /* 1675950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11676:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1675963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1675981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675984 */     // GIR_Coverage, 6473,
     /* 1675984 */     GIR_EraseRootFromParent_Done,
     /* 1675985 */   // Label 23008: @1675985
     /* 1675985 */   GIM_Try, /*On fail goto*//*Label 23009*/ GIMT_Encode4(1676071), // Rule ID 6564 //
     /* 1675990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676036 */     // MIs[0] policy
     /* 1676036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676046 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1676049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676070 */     // GIR_Coverage, 6564,
     /* 1676070 */     GIR_EraseRootFromParent_Done,
     /* 1676071 */   // Label 23009: @1676071
     /* 1676071 */   GIM_Try, /*On fail goto*//*Label 23010*/ GIMT_Encode4(1676157), // Rule ID 6565 //
     /* 1676076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676122 */     // MIs[0] policy
     /* 1676122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676132 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1676135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676156 */     // GIR_Coverage, 6565,
     /* 1676156 */     GIR_EraseRootFromParent_Done,
     /* 1676157 */   // Label 23010: @1676157
     /* 1676157 */   GIM_Try, /*On fail goto*//*Label 23011*/ GIMT_Encode4(1676243), // Rule ID 6568 //
     /* 1676162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676208 */     // MIs[0] policy
     /* 1676208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676218 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676242 */     // GIR_Coverage, 6568,
     /* 1676242 */     GIR_EraseRootFromParent_Done,
     /* 1676243 */   // Label 23011: @1676243
     /* 1676243 */   GIM_Try, /*On fail goto*//*Label 23012*/ GIMT_Encode4(1676329), // Rule ID 6569 //
     /* 1676248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1676259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1676262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1676265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1676268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676294 */     // MIs[0] policy
     /* 1676294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676304 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676328 */     // GIR_Coverage, 6569,
     /* 1676328 */     GIR_EraseRootFromParent_Done,
     /* 1676329 */   // Label 23012: @1676329
     /* 1676329 */   GIM_Try, /*On fail goto*//*Label 23013*/ GIMT_Encode4(1676415), // Rule ID 6572 //
     /* 1676334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1676354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676380 */     // MIs[0] policy
     /* 1676380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676414 */     // GIR_Coverage, 6572,
     /* 1676414 */     GIR_EraseRootFromParent_Done,
     /* 1676415 */   // Label 23013: @1676415
     /* 1676415 */   GIM_Try, /*On fail goto*//*Label 23014*/ GIMT_Encode4(1676501), // Rule ID 6573 //
     /* 1676420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1676431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1676434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1676437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1676440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676466 */     // MIs[0] policy
     /* 1676466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676476 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1676497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676500 */     // GIR_Coverage, 6573,
     /* 1676500 */     GIR_EraseRootFromParent_Done,
     /* 1676501 */   // Label 23014: @1676501
     /* 1676501 */   GIM_Try, /*On fail goto*//*Label 23015*/ GIMT_Encode4(1676587), // Rule ID 6576 //
     /* 1676506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1676517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1676520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1676523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1676526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676552 */     // MIs[0] policy
     /* 1676552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676562 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676586 */     // GIR_Coverage, 6576,
     /* 1676586 */     GIR_EraseRootFromParent_Done,
     /* 1676587 */   // Label 23015: @1676587
     /* 1676587 */   GIM_Try, /*On fail goto*//*Label 23016*/ GIMT_Encode4(1676673), // Rule ID 6577 //
     /* 1676592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1676603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1676606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1676609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1676612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676638 */     // MIs[0] policy
     /* 1676638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1676651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676672 */     // GIR_Coverage, 6577,
     /* 1676672 */     GIR_EraseRootFromParent_Done,
     /* 1676673 */   // Label 23016: @1676673
     /* 1676673 */   GIM_Try, /*On fail goto*//*Label 23017*/ GIMT_Encode4(1676759), // Rule ID 6580 //
     /* 1676678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1676689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1676692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1676695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1676698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676724 */     // MIs[0] policy
     /* 1676724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676758 */     // GIR_Coverage, 6580,
     /* 1676758 */     GIR_EraseRootFromParent_Done,
     /* 1676759 */   // Label 23017: @1676759
     /* 1676759 */   GIM_Try, /*On fail goto*//*Label 23018*/ GIMT_Encode4(1676845), // Rule ID 6581 //
     /* 1676764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1676775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1676778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1676781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1676784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676810 */     // MIs[0] policy
     /* 1676810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1676841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676844 */     // GIR_Coverage, 6581,
     /* 1676844 */     GIR_EraseRootFromParent_Done,
     /* 1676845 */   // Label 23018: @1676845
     /* 1676845 */   GIM_Try, /*On fail goto*//*Label 23019*/ GIMT_Encode4(1676931), // Rule ID 6584 //
     /* 1676850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1676861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1676864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1676867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1676870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676896 */     // MIs[0] policy
     /* 1676896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676906 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676930 */     // GIR_Coverage, 6584,
     /* 1676930 */     GIR_EraseRootFromParent_Done,
     /* 1676931 */   // Label 23019: @1676931
     /* 1676931 */   GIM_Try, /*On fail goto*//*Label 23020*/ GIMT_Encode4(1677017), // Rule ID 6585 //
     /* 1676936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1676947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1676950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1676953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1676956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1676966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1676978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676982 */     // MIs[0] policy
     /* 1676982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676992 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1676995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677016 */     // GIR_Coverage, 6585,
     /* 1677016 */     GIR_EraseRootFromParent_Done,
     /* 1677017 */   // Label 23020: @1677017
     /* 1677017 */   GIM_Try, /*On fail goto*//*Label 23021*/ GIMT_Encode4(1677103), // Rule ID 6588 //
     /* 1677022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677068 */     // MIs[0] policy
     /* 1677068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677078 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677102 */     // GIR_Coverage, 6588,
     /* 1677102 */     GIR_EraseRootFromParent_Done,
     /* 1677103 */   // Label 23021: @1677103
     /* 1677103 */   GIM_Try, /*On fail goto*//*Label 23022*/ GIMT_Encode4(1677189), // Rule ID 6589 //
     /* 1677108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1677119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1677122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1677125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1677128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1677131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677154 */     // MIs[0] policy
     /* 1677154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677188 */     // GIR_Coverage, 6589,
     /* 1677188 */     GIR_EraseRootFromParent_Done,
     /* 1677189 */   // Label 23022: @1677189
     /* 1677189 */   GIM_Try, /*On fail goto*//*Label 23023*/ GIMT_Encode4(1677275), // Rule ID 6592 //
     /* 1677194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677240 */     // MIs[0] policy
     /* 1677240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677274 */     // GIR_Coverage, 6592,
     /* 1677274 */     GIR_EraseRootFromParent_Done,
     /* 1677275 */   // Label 23023: @1677275
     /* 1677275 */   GIM_Try, /*On fail goto*//*Label 23024*/ GIMT_Encode4(1677361), // Rule ID 6593 //
     /* 1677280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1677291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1677294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1677297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1677300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677326 */     // MIs[0] policy
     /* 1677326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677336 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677360 */     // GIR_Coverage, 6593,
     /* 1677360 */     GIR_EraseRootFromParent_Done,
     /* 1677361 */   // Label 23024: @1677361
     /* 1677361 */   GIM_Try, /*On fail goto*//*Label 23025*/ GIMT_Encode4(1677447), // Rule ID 6596 //
     /* 1677366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1677386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677412 */     // MIs[0] policy
     /* 1677412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677446 */     // GIR_Coverage, 6596,
     /* 1677446 */     GIR_EraseRootFromParent_Done,
     /* 1677447 */   // Label 23025: @1677447
     /* 1677447 */   GIM_Try, /*On fail goto*//*Label 23026*/ GIMT_Encode4(1677533), // Rule ID 6597 //
     /* 1677452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1677463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1677466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1677469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1677472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677498 */     // MIs[0] policy
     /* 1677498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677508 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677532 */     // GIR_Coverage, 6597,
     /* 1677532 */     GIR_EraseRootFromParent_Done,
     /* 1677533 */   // Label 23026: @1677533
     /* 1677533 */   GIM_Try, /*On fail goto*//*Label 23027*/ GIMT_Encode4(1677619), // Rule ID 6600 //
     /* 1677538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1677541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1677549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1677552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1677555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1677558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677584 */     // MIs[0] policy
     /* 1677584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677618 */     // GIR_Coverage, 6600,
     /* 1677618 */     GIR_EraseRootFromParent_Done,
     /* 1677619 */   // Label 23027: @1677619
     /* 1677619 */   GIM_Try, /*On fail goto*//*Label 23028*/ GIMT_Encode4(1677705), // Rule ID 6601 //
     /* 1677624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1677627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1677635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1677638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1677641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1677644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677670 */     // MIs[0] policy
     /* 1677670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677680 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1677683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1677701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677704 */     // GIR_Coverage, 6601,
     /* 1677704 */     GIR_EraseRootFromParent_Done,
     /* 1677705 */   // Label 23028: @1677705
     /* 1677705 */   GIM_Try, /*On fail goto*//*Label 23029*/ GIMT_Encode4(1677791), // Rule ID 6604 //
     /* 1677710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1677721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1677724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1677727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1677730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1677733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1677740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677756 */     // MIs[0] policy
     /* 1677756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1677769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677790 */     // GIR_Coverage, 6604,
     /* 1677790 */     GIR_EraseRootFromParent_Done,
     /* 1677791 */   // Label 23029: @1677791
     /* 1677791 */   GIM_Try, /*On fail goto*//*Label 23030*/ GIMT_Encode4(1677877), // Rule ID 6605 //
     /* 1677796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1677807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1677810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1677813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1677816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1677819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1677826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1677838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677842 */     // MIs[0] policy
     /* 1677842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1677855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677876 */     // GIR_Coverage, 6605,
     /* 1677876 */     GIR_EraseRootFromParent_Done,
     /* 1677877 */   // Label 23030: @1677877
     /* 1677877 */   GIM_Try, /*On fail goto*//*Label 23031*/ GIMT_Encode4(1677963), // Rule ID 6608 //
     /* 1677882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1677893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1677896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1677899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1677902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1677905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1677912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1677924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677928 */     // MIs[0] policy
     /* 1677928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677938 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1677941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677962 */     // GIR_Coverage, 6608,
     /* 1677962 */     GIR_EraseRootFromParent_Done,
     /* 1677963 */   // Label 23031: @1677963
     /* 1677963 */   GIM_Try, /*On fail goto*//*Label 23032*/ GIMT_Encode4(1678049), // Rule ID 6609 //
     /* 1677968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1677976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1677979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1677982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1677985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1677988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1677991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1677998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678014 */     // MIs[0] policy
     /* 1678014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678024 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678048 */     // GIR_Coverage, 6609,
     /* 1678048 */     GIR_EraseRootFromParent_Done,
     /* 1678049 */   // Label 23032: @1678049
     /* 1678049 */   GIM_Try, /*On fail goto*//*Label 23033*/ GIMT_Encode4(1678135), // Rule ID 6612 //
     /* 1678054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678100 */     // MIs[0] policy
     /* 1678100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678110 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678134 */     // GIR_Coverage, 6612,
     /* 1678134 */     GIR_EraseRootFromParent_Done,
     /* 1678135 */   // Label 23033: @1678135
     /* 1678135 */   GIM_Try, /*On fail goto*//*Label 23034*/ GIMT_Encode4(1678221), // Rule ID 6613 //
     /* 1678140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1678151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1678154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1678157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1678160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1678163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678186 */     // MIs[0] policy
     /* 1678186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678196 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678220 */     // GIR_Coverage, 6613,
     /* 1678220 */     GIR_EraseRootFromParent_Done,
     /* 1678221 */   // Label 23034: @1678221
     /* 1678221 */   GIM_Try, /*On fail goto*//*Label 23035*/ GIMT_Encode4(1678307), // Rule ID 6616 //
     /* 1678226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678272 */     // MIs[0] policy
     /* 1678272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678306 */     // GIR_Coverage, 6616,
     /* 1678306 */     GIR_EraseRootFromParent_Done,
     /* 1678307 */   // Label 23035: @1678307
     /* 1678307 */   GIM_Try, /*On fail goto*//*Label 23036*/ GIMT_Encode4(1678393), // Rule ID 6617 //
     /* 1678312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1678323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1678326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1678329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1678332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678358 */     // MIs[0] policy
     /* 1678358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678368 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678392 */     // GIR_Coverage, 6617,
     /* 1678392 */     GIR_EraseRootFromParent_Done,
     /* 1678393 */   // Label 23036: @1678393
     /* 1678393 */   GIM_Try, /*On fail goto*//*Label 23037*/ GIMT_Encode4(1678479), // Rule ID 6620 //
     /* 1678398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1678418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678444 */     // MIs[0] policy
     /* 1678444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678454 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678478 */     // GIR_Coverage, 6620,
     /* 1678478 */     GIR_EraseRootFromParent_Done,
     /* 1678479 */   // Label 23037: @1678479
     /* 1678479 */   GIM_Try, /*On fail goto*//*Label 23038*/ GIMT_Encode4(1678565), // Rule ID 6621 //
     /* 1678484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1678495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1678498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1678501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1678504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678530 */     // MIs[0] policy
     /* 1678530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678540 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678564 */     // GIR_Coverage, 6621,
     /* 1678564 */     GIR_EraseRootFromParent_Done,
     /* 1678565 */   // Label 23038: @1678565
     /* 1678565 */   GIM_Try, /*On fail goto*//*Label 23039*/ GIMT_Encode4(1678651), // Rule ID 6624 //
     /* 1678570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1678581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1678584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1678587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1678590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678616 */     // MIs[0] policy
     /* 1678616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678650 */     // GIR_Coverage, 6624,
     /* 1678650 */     GIR_EraseRootFromParent_Done,
     /* 1678651 */   // Label 23039: @1678651
     /* 1678651 */   GIM_Try, /*On fail goto*//*Label 23040*/ GIMT_Encode4(1678737), // Rule ID 6625 //
     /* 1678656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1678667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1678670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1678673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1678676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1678686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1678698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678702 */     // MIs[0] policy
     /* 1678702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678712 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1678715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678736 */     // GIR_Coverage, 6625,
     /* 1678736 */     GIR_EraseRootFromParent_Done,
     /* 1678737 */   // Label 23040: @1678737
     /* 1678737 */   GIM_Try, /*On fail goto*//*Label 23041*/ GIMT_Encode4(1678823), // Rule ID 6628 //
     /* 1678742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1678753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1678756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1678759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1678762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678788 */     // MIs[0] policy
     /* 1678788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678822 */     // GIR_Coverage, 6628,
     /* 1678822 */     GIR_EraseRootFromParent_Done,
     /* 1678823 */   // Label 23041: @1678823
     /* 1678823 */   GIM_Try, /*On fail goto*//*Label 23042*/ GIMT_Encode4(1678909), // Rule ID 6629 //
     /* 1678828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1678839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1678842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1678845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1678848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678874 */     // MIs[0] policy
     /* 1678874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1678887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678908 */     // GIR_Coverage, 6629,
     /* 1678908 */     GIR_EraseRootFromParent_Done,
     /* 1678909 */   // Label 23042: @1678909
     /* 1678909 */   GIM_Try, /*On fail goto*//*Label 23043*/ GIMT_Encode4(1678995), // Rule ID 6632 //
     /* 1678914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1678922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1678925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1678928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1678931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1678934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678960 */     // MIs[0] policy
     /* 1678960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1678973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678994 */     // GIR_Coverage, 6632,
     /* 1678994 */     GIR_EraseRootFromParent_Done,
     /* 1678995 */   // Label 23043: @1678995
     /* 1678995 */   GIM_Try, /*On fail goto*//*Label 23044*/ GIMT_Encode4(1679081), // Rule ID 6633 //
     /* 1679000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1679020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679046 */     // MIs[0] policy
     /* 1679046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679080 */     // GIR_Coverage, 6633,
     /* 1679080 */     GIR_EraseRootFromParent_Done,
     /* 1679081 */   // Label 23044: @1679081
     /* 1679081 */   GIM_Try, /*On fail goto*//*Label 23045*/ GIMT_Encode4(1679167), // Rule ID 6636 //
     /* 1679086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679132 */     // MIs[0] policy
     /* 1679132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679166 */     // GIR_Coverage, 6636,
     /* 1679166 */     GIR_EraseRootFromParent_Done,
     /* 1679167 */   // Label 23045: @1679167
     /* 1679167 */   GIM_Try, /*On fail goto*//*Label 23046*/ GIMT_Encode4(1679253), // Rule ID 6637 //
     /* 1679172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1679183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1679186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1679189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1679192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679218 */     // MIs[0] policy
     /* 1679218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679228 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679252 */     // GIR_Coverage, 6637,
     /* 1679252 */     GIR_EraseRootFromParent_Done,
     /* 1679253 */   // Label 23046: @1679253
     /* 1679253 */   GIM_Try, /*On fail goto*//*Label 23047*/ GIMT_Encode4(1679339), // Rule ID 6640 //
     /* 1679258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1679278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679304 */     // MIs[0] policy
     /* 1679304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679338 */     // GIR_Coverage, 6640,
     /* 1679338 */     GIR_EraseRootFromParent_Done,
     /* 1679339 */   // Label 23047: @1679339
     /* 1679339 */   GIM_Try, /*On fail goto*//*Label 23048*/ GIMT_Encode4(1679425), // Rule ID 6641 //
     /* 1679344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1679355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1679358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1679361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1679364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679390 */     // MIs[0] policy
     /* 1679390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1679403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679424 */     // GIR_Coverage, 6641,
     /* 1679424 */     GIR_EraseRootFromParent_Done,
     /* 1679425 */   // Label 23048: @1679425
     /* 1679425 */   GIM_Try, /*On fail goto*//*Label 23049*/ GIMT_Encode4(1679511), // Rule ID 6644 //
     /* 1679430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1679441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1679444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1679447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1679450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679476 */     // MIs[0] policy
     /* 1679476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679486 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679510 */     // GIR_Coverage, 6644,
     /* 1679510 */     GIR_EraseRootFromParent_Done,
     /* 1679511 */   // Label 23049: @1679511
     /* 1679511 */   GIM_Try, /*On fail goto*//*Label 23050*/ GIMT_Encode4(1679597), // Rule ID 6645 //
     /* 1679516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1679527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1679530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1679533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1679536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679562 */     // MIs[0] policy
     /* 1679562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679572 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1679575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679596 */     // GIR_Coverage, 6645,
     /* 1679596 */     GIR_EraseRootFromParent_Done,
     /* 1679597 */   // Label 23050: @1679597
     /* 1679597 */   GIM_Try, /*On fail goto*//*Label 23051*/ GIMT_Encode4(1679683), // Rule ID 6648 //
     /* 1679602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1679605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1679613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1679616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1679619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1679622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679648 */     // MIs[0] policy
     /* 1679648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679658 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679682 */     // GIR_Coverage, 6648,
     /* 1679682 */     GIR_EraseRootFromParent_Done,
     /* 1679683 */   // Label 23051: @1679683
     /* 1679683 */   GIM_Try, /*On fail goto*//*Label 23052*/ GIMT_Encode4(1679769), // Rule ID 6649 //
     /* 1679688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1679691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1679699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1679702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1679705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1679708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679734 */     // MIs[0] policy
     /* 1679734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679744 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1679747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1679765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679768 */     // GIR_Coverage, 6649,
     /* 1679768 */     GIR_EraseRootFromParent_Done,
     /* 1679769 */   // Label 23052: @1679769
     /* 1679769 */   GIM_Try, /*On fail goto*//*Label 23053*/ GIMT_Encode4(1679855), // Rule ID 6652 //
     /* 1679774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1679785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1679788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1679791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1679797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679820 */     // MIs[0] policy
     /* 1679820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679830 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1679833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679854 */     // GIR_Coverage, 6652,
     /* 1679854 */     GIR_EraseRootFromParent_Done,
     /* 1679855 */   // Label 23053: @1679855
     /* 1679855 */   GIM_Try, /*On fail goto*//*Label 23054*/ GIMT_Encode4(1679941), // Rule ID 6653 //
     /* 1679860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1679871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1679874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1679877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1679880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1679883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679906 */     // MIs[0] policy
     /* 1679906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679916 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1679919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679940 */     // GIR_Coverage, 6653,
     /* 1679940 */     GIR_EraseRootFromParent_Done,
     /* 1679941 */   // Label 23054: @1679941
     /* 1679941 */   GIM_Try, /*On fail goto*//*Label 23055*/ GIMT_Encode4(1680027), // Rule ID 6656 //
     /* 1679946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1679954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1679957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1679960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1679963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1679966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1679969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1679976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1679984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1679988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679992 */     // MIs[0] policy
     /* 1679992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680026 */     // GIR_Coverage, 6656,
     /* 1680026 */     GIR_EraseRootFromParent_Done,
     /* 1680027 */   // Label 23055: @1680027
     /* 1680027 */   GIM_Try, /*On fail goto*//*Label 23056*/ GIMT_Encode4(1680113), // Rule ID 6657 //
     /* 1680032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680078 */     // MIs[0] policy
     /* 1680078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680088 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680112 */     // GIR_Coverage, 6657,
     /* 1680112 */     GIR_EraseRootFromParent_Done,
     /* 1680113 */   // Label 23056: @1680113
     /* 1680113 */   GIM_Try, /*On fail goto*//*Label 23057*/ GIMT_Encode4(1680199), // Rule ID 6660 //
     /* 1680118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680164 */     // MIs[0] policy
     /* 1680164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680198 */     // GIR_Coverage, 6660,
     /* 1680198 */     GIR_EraseRootFromParent_Done,
     /* 1680199 */   // Label 23057: @1680199
     /* 1680199 */   GIM_Try, /*On fail goto*//*Label 23058*/ GIMT_Encode4(1680285), // Rule ID 6661 //
     /* 1680204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1680215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1680218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1680221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680250 */     // MIs[0] policy
     /* 1680250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680260 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680284 */     // GIR_Coverage, 6661,
     /* 1680284 */     GIR_EraseRootFromParent_Done,
     /* 1680285 */   // Label 23058: @1680285
     /* 1680285 */   GIM_Try, /*On fail goto*//*Label 23059*/ GIMT_Encode4(1680371), // Rule ID 6664 //
     /* 1680290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680336 */     // MIs[0] policy
     /* 1680336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680370 */     // GIR_Coverage, 6664,
     /* 1680370 */     GIR_EraseRootFromParent_Done,
     /* 1680371 */   // Label 23059: @1680371
     /* 1680371 */   GIM_Try, /*On fail goto*//*Label 23060*/ GIMT_Encode4(1680457), // Rule ID 6665 //
     /* 1680376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1680387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1680390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1680393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680422 */     // MIs[0] policy
     /* 1680422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680432 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1680435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680456 */     // GIR_Coverage, 6665,
     /* 1680456 */     GIR_EraseRootFromParent_Done,
     /* 1680457 */   // Label 23060: @1680457
     /* 1680457 */   GIM_Try, /*On fail goto*//*Label 23061*/ GIMT_Encode4(1680543), // Rule ID 6668 //
     /* 1680462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1680473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1680476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1680479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680508 */     // MIs[0] policy
     /* 1680508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680542 */     // GIR_Coverage, 6668,
     /* 1680542 */     GIR_EraseRootFromParent_Done,
     /* 1680543 */   // Label 23061: @1680543
     /* 1680543 */   GIM_Try, /*On fail goto*//*Label 23062*/ GIMT_Encode4(1680629), // Rule ID 6669 //
     /* 1680548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1680559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1680562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1680565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680594 */     // MIs[0] policy
     /* 1680594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680604 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1680625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680628 */     // GIR_Coverage, 6669,
     /* 1680628 */     GIR_EraseRootFromParent_Done,
     /* 1680629 */   // Label 23062: @1680629
     /* 1680629 */   GIM_Try, /*On fail goto*//*Label 23063*/ GIMT_Encode4(1680715), // Rule ID 6672 //
     /* 1680634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1680645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1680648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1680651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680680 */     // MIs[0] policy
     /* 1680680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680714 */     // GIR_Coverage, 6672,
     /* 1680714 */     GIR_EraseRootFromParent_Done,
     /* 1680715 */   // Label 23063: @1680715
     /* 1680715 */   GIM_Try, /*On fail goto*//*Label 23064*/ GIMT_Encode4(1680801), // Rule ID 6673 //
     /* 1680720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1680731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1680734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1680737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680766 */     // MIs[0] policy
     /* 1680766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680776 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1680779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680800 */     // GIR_Coverage, 6673,
     /* 1680800 */     GIR_EraseRootFromParent_Done,
     /* 1680801 */   // Label 23064: @1680801
     /* 1680801 */   GIM_Try, /*On fail goto*//*Label 23065*/ GIMT_Encode4(1680887), // Rule ID 6676 //
     /* 1680806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1680817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1680820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1680823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680852 */     // MIs[0] policy
     /* 1680852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680862 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1680865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680886 */     // GIR_Coverage, 6676,
     /* 1680886 */     GIR_EraseRootFromParent_Done,
     /* 1680887 */   // Label 23065: @1680887
     /* 1680887 */   GIM_Try, /*On fail goto*//*Label 23066*/ GIMT_Encode4(1680973), // Rule ID 6677 //
     /* 1680892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1680903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1680906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1680909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680938 */     // MIs[0] policy
     /* 1680938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680948 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11554:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1680951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680972 */     // GIR_Coverage, 6677,
     /* 1680972 */     GIR_EraseRootFromParent_Done,
     /* 1680973 */   // Label 23066: @1680973
     /* 1680973 */   GIM_Try, /*On fail goto*//*Label 23067*/ GIMT_Encode4(1681059), // Rule ID 6680 //
     /* 1680978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1680986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1680989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1680992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1680995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681024 */     // MIs[0] policy
     /* 1681024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681058 */     // GIR_Coverage, 6680,
     /* 1681058 */     GIR_EraseRootFromParent_Done,
     /* 1681059 */   // Label 23067: @1681059
     /* 1681059 */   GIM_Try, /*On fail goto*//*Label 23068*/ GIMT_Encode4(1681145), // Rule ID 6681 //
     /* 1681064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681110 */     // MIs[0] policy
     /* 1681110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11554:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681144 */     // GIR_Coverage, 6681,
     /* 1681144 */     GIR_EraseRootFromParent_Done,
     /* 1681145 */   // Label 23068: @1681145
     /* 1681145 */   GIM_Try, /*On fail goto*//*Label 23069*/ GIMT_Encode4(1681231), // Rule ID 6684 //
     /* 1681150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681196 */     // MIs[0] policy
     /* 1681196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681230 */     // GIR_Coverage, 6684,
     /* 1681230 */     GIR_EraseRootFromParent_Done,
     /* 1681231 */   // Label 23069: @1681231
     /* 1681231 */   GIM_Try, /*On fail goto*//*Label 23070*/ GIMT_Encode4(1681317), // Rule ID 6685 //
     /* 1681236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1681247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1681250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1681253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681282 */     // MIs[0] policy
     /* 1681282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11554:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681316 */     // GIR_Coverage, 6685,
     /* 1681316 */     GIR_EraseRootFromParent_Done,
     /* 1681317 */   // Label 23070: @1681317
     /* 1681317 */   GIM_Try, /*On fail goto*//*Label 23071*/ GIMT_Encode4(1681403), // Rule ID 6688 //
     /* 1681322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1681325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681368 */     // MIs[0] policy
     /* 1681368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681378 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681402 */     // GIR_Coverage, 6688,
     /* 1681402 */     GIR_EraseRootFromParent_Done,
     /* 1681403 */   // Label 23071: @1681403
     /* 1681403 */   GIM_Try, /*On fail goto*//*Label 23072*/ GIMT_Encode4(1681489), // Rule ID 6689 //
     /* 1681408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1681411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1681419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1681422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1681425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681454 */     // MIs[0] policy
     /* 1681454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11554:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1681467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1681485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681488 */     // GIR_Coverage, 6689,
     /* 1681488 */     GIR_EraseRootFromParent_Done,
     /* 1681489 */   // Label 23072: @1681489
     /* 1681489 */   GIM_Try, /*On fail goto*//*Label 23073*/ GIMT_Encode4(1681575), // Rule ID 6692 //
     /* 1681494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1681505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1681508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1681511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1681517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1681524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681540 */     // MIs[0] policy
     /* 1681540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681550 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1681553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681574 */     // GIR_Coverage, 6692,
     /* 1681574 */     GIR_EraseRootFromParent_Done,
     /* 1681575 */   // Label 23073: @1681575
     /* 1681575 */   GIM_Try, /*On fail goto*//*Label 23074*/ GIMT_Encode4(1681661), // Rule ID 6693 //
     /* 1681580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1681591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1681594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1681597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1681603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1681610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1681618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681626 */     // MIs[0] policy
     /* 1681626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1681639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681660 */     // GIR_Coverage, 6693,
     /* 1681660 */     GIR_EraseRootFromParent_Done,
     /* 1681661 */   // Label 23074: @1681661
     /* 1681661 */   GIM_Try, /*On fail goto*//*Label 23075*/ GIMT_Encode4(1681747), // Rule ID 6696 //
     /* 1681666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1681677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1681680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1681683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1681689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1681696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681712 */     // MIs[0] policy
     /* 1681712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681722 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1681725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681746 */     // GIR_Coverage, 6696,
     /* 1681746 */     GIR_EraseRootFromParent_Done,
     /* 1681747 */   // Label 23075: @1681747
     /* 1681747 */   GIM_Try, /*On fail goto*//*Label 23076*/ GIMT_Encode4(1681833), // Rule ID 6697 //
     /* 1681752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1681763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1681766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1681769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1681775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1681782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1681790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681798 */     // MIs[0] policy
     /* 1681798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681808 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1681811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681832 */     // GIR_Coverage, 6697,
     /* 1681832 */     GIR_EraseRootFromParent_Done,
     /* 1681833 */   // Label 23076: @1681833
     /* 1681833 */   GIM_Try, /*On fail goto*//*Label 23077*/ GIMT_Encode4(1681919), // Rule ID 6700 //
     /* 1681838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1681849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1681852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1681855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1681861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1681868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681884 */     // MIs[0] policy
     /* 1681884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681894 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1681897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681918 */     // GIR_Coverage, 6700,
     /* 1681918 */     GIR_EraseRootFromParent_Done,
     /* 1681919 */   // Label 23077: @1681919
     /* 1681919 */   GIM_Try, /*On fail goto*//*Label 23078*/ GIMT_Encode4(1682005), // Rule ID 6701 //
     /* 1681924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1681932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1681935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1681938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1681941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1681947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1681954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1681962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681970 */     // MIs[0] policy
     /* 1681970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681980 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1681983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682004 */     // GIR_Coverage, 6701,
     /* 1682004 */     GIR_EraseRootFromParent_Done,
     /* 1682005 */   // Label 23078: @1682005
     /* 1682005 */   GIM_Try, /*On fail goto*//*Label 23079*/ GIMT_Encode4(1682091), // Rule ID 6704 //
     /* 1682010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682056 */     // MIs[0] policy
     /* 1682056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682066 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682090 */     // GIR_Coverage, 6704,
     /* 1682090 */     GIR_EraseRootFromParent_Done,
     /* 1682091 */   // Label 23079: @1682091
     /* 1682091 */   GIM_Try, /*On fail goto*//*Label 23080*/ GIMT_Encode4(1682177), // Rule ID 6705 //
     /* 1682096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1682107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1682110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1682113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682142 */     // MIs[0] policy
     /* 1682142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682176 */     // GIR_Coverage, 6705,
     /* 1682176 */     GIR_EraseRootFromParent_Done,
     /* 1682177 */   // Label 23080: @1682177
     /* 1682177 */   GIM_Try, /*On fail goto*//*Label 23081*/ GIMT_Encode4(1682263), // Rule ID 6708 //
     /* 1682182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682228 */     // MIs[0] policy
     /* 1682228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682238 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682262 */     // GIR_Coverage, 6708,
     /* 1682262 */     GIR_EraseRootFromParent_Done,
     /* 1682263 */   // Label 23081: @1682263
     /* 1682263 */   GIM_Try, /*On fail goto*//*Label 23082*/ GIMT_Encode4(1682349), // Rule ID 6709 //
     /* 1682268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1682279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1682282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1682285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682314 */     // MIs[0] policy
     /* 1682314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682348 */     // GIR_Coverage, 6709,
     /* 1682348 */     GIR_EraseRootFromParent_Done,
     /* 1682349 */   // Label 23082: @1682349
     /* 1682349 */   GIM_Try, /*On fail goto*//*Label 23083*/ GIMT_Encode4(1682435), // Rule ID 6712 //
     /* 1682354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682400 */     // MIs[0] policy
     /* 1682400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682410 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682434 */     // GIR_Coverage, 6712,
     /* 1682434 */     GIR_EraseRootFromParent_Done,
     /* 1682435 */   // Label 23083: @1682435
     /* 1682435 */   GIM_Try, /*On fail goto*//*Label 23084*/ GIMT_Encode4(1682521), // Rule ID 6713 //
     /* 1682440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1682451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1682454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1682457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682486 */     // MIs[0] policy
     /* 1682486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682496 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682520 */     // GIR_Coverage, 6713,
     /* 1682520 */     GIR_EraseRootFromParent_Done,
     /* 1682521 */   // Label 23084: @1682521
     /* 1682521 */   GIM_Try, /*On fail goto*//*Label 23085*/ GIMT_Encode4(1682607), // Rule ID 6716 //
     /* 1682526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1682537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1682540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1682543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1682549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682572 */     // MIs[0] policy
     /* 1682572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682606 */     // GIR_Coverage, 6716,
     /* 1682606 */     GIR_EraseRootFromParent_Done,
     /* 1682607 */   // Label 23085: @1682607
     /* 1682607 */   GIM_Try, /*On fail goto*//*Label 23086*/ GIMT_Encode4(1682693), // Rule ID 6717 //
     /* 1682612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1682623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1682626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1682629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1682635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682658 */     // MIs[0] policy
     /* 1682658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1682671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682692 */     // GIR_Coverage, 6717,
     /* 1682692 */     GIR_EraseRootFromParent_Done,
     /* 1682693 */   // Label 23086: @1682693
     /* 1682693 */   GIM_Try, /*On fail goto*//*Label 23087*/ GIMT_Encode4(1682779), // Rule ID 6720 //
     /* 1682698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1682709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1682712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1682715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682744 */     // MIs[0] policy
     /* 1682744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682778 */     // GIR_Coverage, 6720,
     /* 1682778 */     GIR_EraseRootFromParent_Done,
     /* 1682779 */   // Label 23087: @1682779
     /* 1682779 */   GIM_Try, /*On fail goto*//*Label 23088*/ GIMT_Encode4(1682865), // Rule ID 6721 //
     /* 1682784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1682795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1682798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1682801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1682807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682830 */     // MIs[0] policy
     /* 1682830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1682843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682864 */     // GIR_Coverage, 6721,
     /* 1682864 */     GIR_EraseRootFromParent_Done,
     /* 1682865 */   // Label 23088: @1682865
     /* 1682865 */   GIM_Try, /*On fail goto*//*Label 23089*/ GIMT_Encode4(1682951), // Rule ID 6724 //
     /* 1682870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1682881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1682884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1682887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682916 */     // MIs[0] policy
     /* 1682916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1682929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682950 */     // GIR_Coverage, 6724,
     /* 1682950 */     GIR_EraseRootFromParent_Done,
     /* 1682951 */   // Label 23089: @1682951
     /* 1682951 */   GIM_Try, /*On fail goto*//*Label 23090*/ GIMT_Encode4(1683037), // Rule ID 6725 //
     /* 1682956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1682964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1682967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1682970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1682973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683002 */     // MIs[0] policy
     /* 1683002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683036 */     // GIR_Coverage, 6725,
     /* 1683036 */     GIR_EraseRootFromParent_Done,
     /* 1683037 */   // Label 23090: @1683037
     /* 1683037 */   GIM_Try, /*On fail goto*//*Label 23091*/ GIMT_Encode4(1683123), // Rule ID 6728 //
     /* 1683042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683088 */     // MIs[0] policy
     /* 1683088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683122 */     // GIR_Coverage, 6728,
     /* 1683122 */     GIR_EraseRootFromParent_Done,
     /* 1683123 */   // Label 23091: @1683123
     /* 1683123 */   GIM_Try, /*On fail goto*//*Label 23092*/ GIMT_Encode4(1683209), // Rule ID 6729 //
     /* 1683128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1683139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1683142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1683145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683174 */     // MIs[0] policy
     /* 1683174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11554:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1683187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683208 */     // GIR_Coverage, 6729,
     /* 1683208 */     GIR_EraseRootFromParent_Done,
     /* 1683209 */   // Label 23092: @1683209
     /* 1683209 */   GIM_Try, /*On fail goto*//*Label 23093*/ GIMT_Encode4(1683295), // Rule ID 6732 //
     /* 1683214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683260 */     // MIs[0] policy
     /* 1683260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683294 */     // GIR_Coverage, 6732,
     /* 1683294 */     GIR_EraseRootFromParent_Done,
     /* 1683295 */   // Label 23093: @1683295
     /* 1683295 */   GIM_Try, /*On fail goto*//*Label 23094*/ GIMT_Encode4(1683381), // Rule ID 6733 //
     /* 1683300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1683311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1683314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1683317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683346 */     // MIs[0] policy
     /* 1683346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683356 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11554:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1683359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683380 */     // GIR_Coverage, 6733,
     /* 1683380 */     GIR_EraseRootFromParent_Done,
     /* 1683381 */   // Label 23094: @1683381
     /* 1683381 */   GIM_Try, /*On fail goto*//*Label 23095*/ GIMT_Encode4(1683467), // Rule ID 6736 //
     /* 1683386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1683389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683432 */     // MIs[0] policy
     /* 1683432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683466 */     // GIR_Coverage, 6736,
     /* 1683466 */     GIR_EraseRootFromParent_Done,
     /* 1683467 */   // Label 23095: @1683467
     /* 1683467 */   GIM_Try, /*On fail goto*//*Label 23096*/ GIMT_Encode4(1683553), // Rule ID 6737 //
     /* 1683472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1683475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1683480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1683483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1683486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1683489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683518 */     // MIs[0] policy
     /* 1683518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683528 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11554:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1683531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1683549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683552 */     // GIR_Coverage, 6737,
     /* 1683552 */     GIR_EraseRootFromParent_Done,
     /* 1683553 */   // Label 23096: @1683553
     /* 1683553 */   GIM_Try, /*On fail goto*//*Label 23097*/ GIMT_Encode4(1683639), // Rule ID 6828 //
     /* 1683558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1683569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1683572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1683575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1683578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1683581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683604 */     // MIs[0] policy
     /* 1683604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683614 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1683617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683638 */     // GIR_Coverage, 6828,
     /* 1683638 */     GIR_EraseRootFromParent_Done,
     /* 1683639 */   // Label 23097: @1683639
     /* 1683639 */   GIM_Try, /*On fail goto*//*Label 23098*/ GIMT_Encode4(1683725), // Rule ID 6829 //
     /* 1683644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1683655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1683658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1683661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1683664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1683667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683690 */     // MIs[0] policy
     /* 1683690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683700 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1683703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683724 */     // GIR_Coverage, 6829,
     /* 1683724 */     GIR_EraseRootFromParent_Done,
     /* 1683725 */   // Label 23098: @1683725
     /* 1683725 */   GIM_Try, /*On fail goto*//*Label 23099*/ GIMT_Encode4(1683811), // Rule ID 6832 //
     /* 1683730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1683741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1683744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1683747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1683750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683776 */     // MIs[0] policy
     /* 1683776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683786 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1683789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683810 */     // GIR_Coverage, 6832,
     /* 1683810 */     GIR_EraseRootFromParent_Done,
     /* 1683811 */   // Label 23099: @1683811
     /* 1683811 */   GIM_Try, /*On fail goto*//*Label 23100*/ GIMT_Encode4(1683897), // Rule ID 6833 //
     /* 1683816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1683827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1683830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1683833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1683836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1683839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683862 */     // MIs[0] policy
     /* 1683862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683872 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1683875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683896 */     // GIR_Coverage, 6833,
     /* 1683896 */     GIR_EraseRootFromParent_Done,
     /* 1683897 */   // Label 23100: @1683897
     /* 1683897 */   GIM_Try, /*On fail goto*//*Label 23101*/ GIMT_Encode4(1683983), // Rule ID 6836 //
     /* 1683902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1683913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1683916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1683919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1683922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1683932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1683944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683948 */     // MIs[0] policy
     /* 1683948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683958 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1683961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1683979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683982 */     // GIR_Coverage, 6836,
     /* 1683982 */     GIR_EraseRootFromParent_Done,
     /* 1683983 */   // Label 23101: @1683983
     /* 1683983 */   GIM_Try, /*On fail goto*//*Label 23102*/ GIMT_Encode4(1684069), // Rule ID 6837 //
     /* 1683988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1683999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684034 */     // MIs[0] policy
     /* 1684034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684044 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684068 */     // GIR_Coverage, 6837,
     /* 1684068 */     GIR_EraseRootFromParent_Done,
     /* 1684069 */   // Label 23102: @1684069
     /* 1684069 */   GIM_Try, /*On fail goto*//*Label 23103*/ GIMT_Encode4(1684155), // Rule ID 6840 //
     /* 1684074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684120 */     // MIs[0] policy
     /* 1684120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684130 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684154 */     // GIR_Coverage, 6840,
     /* 1684154 */     GIR_EraseRootFromParent_Done,
     /* 1684155 */   // Label 23103: @1684155
     /* 1684155 */   GIM_Try, /*On fail goto*//*Label 23104*/ GIMT_Encode4(1684241), // Rule ID 6841 //
     /* 1684160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1684171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1684174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1684177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1684180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684206 */     // MIs[0] policy
     /* 1684206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684216 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1684219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684240 */     // GIR_Coverage, 6841,
     /* 1684240 */     GIR_EraseRootFromParent_Done,
     /* 1684241 */   // Label 23104: @1684241
     /* 1684241 */   GIM_Try, /*On fail goto*//*Label 23105*/ GIMT_Encode4(1684327), // Rule ID 6844 //
     /* 1684246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1684266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684292 */     // MIs[0] policy
     /* 1684292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684302 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684326 */     // GIR_Coverage, 6844,
     /* 1684326 */     GIR_EraseRootFromParent_Done,
     /* 1684327 */   // Label 23105: @1684327
     /* 1684327 */   GIM_Try, /*On fail goto*//*Label 23106*/ GIMT_Encode4(1684413), // Rule ID 6845 //
     /* 1684332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1684343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1684346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1684349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1684352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684378 */     // MIs[0] policy
     /* 1684378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684388 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684412 */     // GIR_Coverage, 6845,
     /* 1684412 */     GIR_EraseRootFromParent_Done,
     /* 1684413 */   // Label 23106: @1684413
     /* 1684413 */   GIM_Try, /*On fail goto*//*Label 23107*/ GIMT_Encode4(1684499), // Rule ID 6848 //
     /* 1684418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1684438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684464 */     // MIs[0] policy
     /* 1684464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684474 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684498 */     // GIR_Coverage, 6848,
     /* 1684498 */     GIR_EraseRootFromParent_Done,
     /* 1684499 */   // Label 23107: @1684499
     /* 1684499 */   GIM_Try, /*On fail goto*//*Label 23108*/ GIMT_Encode4(1684585), // Rule ID 6849 //
     /* 1684504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1684515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1684518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1684521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1684524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684550 */     // MIs[0] policy
     /* 1684550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684560 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1684563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684584 */     // GIR_Coverage, 6849,
     /* 1684584 */     GIR_EraseRootFromParent_Done,
     /* 1684585 */   // Label 23108: @1684585
     /* 1684585 */   GIM_Try, /*On fail goto*//*Label 23109*/ GIMT_Encode4(1684671), // Rule ID 6852 //
     /* 1684590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1684601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1684604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1684607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1684610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684636 */     // MIs[0] policy
     /* 1684636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684646 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1684649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684670 */     // GIR_Coverage, 6852,
     /* 1684670 */     GIR_EraseRootFromParent_Done,
     /* 1684671 */   // Label 23109: @1684671
     /* 1684671 */   GIM_Try, /*On fail goto*//*Label 23110*/ GIMT_Encode4(1684757), // Rule ID 6853 //
     /* 1684676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1684687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1684690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1684693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1684696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684722 */     // MIs[0] policy
     /* 1684722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1684735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684756 */     // GIR_Coverage, 6853,
     /* 1684756 */     GIR_EraseRootFromParent_Done,
     /* 1684757 */   // Label 23110: @1684757
     /* 1684757 */   GIM_Try, /*On fail goto*//*Label 23111*/ GIMT_Encode4(1684843), // Rule ID 6856 //
     /* 1684762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1684773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1684776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1684779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1684782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684808 */     // MIs[0] policy
     /* 1684808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1684821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684842 */     // GIR_Coverage, 6856,
     /* 1684842 */     GIR_EraseRootFromParent_Done,
     /* 1684843 */   // Label 23111: @1684843
     /* 1684843 */   GIM_Try, /*On fail goto*//*Label 23112*/ GIMT_Encode4(1684929), // Rule ID 6857 //
     /* 1684848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1684859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1684862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1684865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1684868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684894 */     // MIs[0] policy
     /* 1684894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684904 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1684907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1684925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684928 */     // GIR_Coverage, 6857,
     /* 1684928 */     GIR_EraseRootFromParent_Done,
     /* 1684929 */   // Label 23112: @1684929
     /* 1684929 */   GIM_Try, /*On fail goto*//*Label 23113*/ GIMT_Encode4(1685015), // Rule ID 6860 //
     /* 1684934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1684945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1684948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1684951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1684954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684980 */     // MIs[0] policy
     /* 1684980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1684993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685014 */     // GIR_Coverage, 6860,
     /* 1685014 */     GIR_EraseRootFromParent_Done,
     /* 1685015 */   // Label 23113: @1685015
     /* 1685015 */   GIM_Try, /*On fail goto*//*Label 23114*/ GIMT_Encode4(1685101), // Rule ID 6861 //
     /* 1685020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1685040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685066 */     // MIs[0] policy
     /* 1685066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685076 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685100 */     // GIR_Coverage, 6861,
     /* 1685100 */     GIR_EraseRootFromParent_Done,
     /* 1685101 */   // Label 23114: @1685101
     /* 1685101 */   GIM_Try, /*On fail goto*//*Label 23115*/ GIMT_Encode4(1685187), // Rule ID 6864 //
     /* 1685106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1685109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685152 */     // MIs[0] policy
     /* 1685152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685186 */     // GIR_Coverage, 6864,
     /* 1685186 */     GIR_EraseRootFromParent_Done,
     /* 1685187 */   // Label 23115: @1685187
     /* 1685187 */   GIM_Try, /*On fail goto*//*Label 23116*/ GIMT_Encode4(1685273), // Rule ID 6865 //
     /* 1685192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1685195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1685203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1685206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1685209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1685212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685238 */     // MIs[0] policy
     /* 1685238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685248 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1685251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1685269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685272 */     // GIR_Coverage, 6865,
     /* 1685272 */     GIR_EraseRootFromParent_Done,
     /* 1685273 */   // Label 23116: @1685273
     /* 1685273 */   GIM_Try, /*On fail goto*//*Label 23117*/ GIMT_Encode4(1685359), // Rule ID 6868 //
     /* 1685278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1685298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685324 */     // MIs[0] policy
     /* 1685324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685334 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685358 */     // GIR_Coverage, 6868,
     /* 1685358 */     GIR_EraseRootFromParent_Done,
     /* 1685359 */   // Label 23117: @1685359
     /* 1685359 */   GIM_Try, /*On fail goto*//*Label 23118*/ GIMT_Encode4(1685445), // Rule ID 6869 //
     /* 1685364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1685375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1685378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1685381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1685384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685410 */     // MIs[0] policy
     /* 1685410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685420 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685444 */     // GIR_Coverage, 6869,
     /* 1685444 */     GIR_EraseRootFromParent_Done,
     /* 1685445 */   // Label 23118: @1685445
     /* 1685445 */   GIM_Try, /*On fail goto*//*Label 23119*/ GIMT_Encode4(1685531), // Rule ID 6872 //
     /* 1685450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1685461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1685464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1685467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1685470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1685473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1685480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685496 */     // MIs[0] policy
     /* 1685496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1685509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685530 */     // GIR_Coverage, 6872,
     /* 1685530 */     GIR_EraseRootFromParent_Done,
     /* 1685531 */   // Label 23119: @1685531
     /* 1685531 */   GIM_Try, /*On fail goto*//*Label 23120*/ GIMT_Encode4(1685617), // Rule ID 6873 //
     /* 1685536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1685547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1685550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1685553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1685556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1685559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1685566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1685578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685582 */     // MIs[0] policy
     /* 1685582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685592 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1685595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685616 */     // GIR_Coverage, 6873,
     /* 1685616 */     GIR_EraseRootFromParent_Done,
     /* 1685617 */   // Label 23120: @1685617
     /* 1685617 */   GIM_Try, /*On fail goto*//*Label 23121*/ GIMT_Encode4(1685703), // Rule ID 6876 //
     /* 1685622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1685633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1685636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1685639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1685642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1685645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1685652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685668 */     // MIs[0] policy
     /* 1685668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1685681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685702 */     // GIR_Coverage, 6876,
     /* 1685702 */     GIR_EraseRootFromParent_Done,
     /* 1685703 */   // Label 23121: @1685703
     /* 1685703 */   GIM_Try, /*On fail goto*//*Label 23122*/ GIMT_Encode4(1685789), // Rule ID 6877 //
     /* 1685708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1685719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1685722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1685725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1685728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1685731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1685738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1685750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685754 */     // MIs[0] policy
     /* 1685754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685764 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1685767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685788 */     // GIR_Coverage, 6877,
     /* 1685788 */     GIR_EraseRootFromParent_Done,
     /* 1685789 */   // Label 23122: @1685789
     /* 1685789 */   GIM_Try, /*On fail goto*//*Label 23123*/ GIMT_Encode4(1685875), // Rule ID 6880 //
     /* 1685794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1685805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1685808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1685811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1685814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685840 */     // MIs[0] policy
     /* 1685840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685874 */     // GIR_Coverage, 6880,
     /* 1685874 */     GIR_EraseRootFromParent_Done,
     /* 1685875 */   // Label 23123: @1685875
     /* 1685875 */   GIM_Try, /*On fail goto*//*Label 23124*/ GIMT_Encode4(1685961), // Rule ID 6881 //
     /* 1685880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1685891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1685894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1685897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1685900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1685910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1685922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685926 */     // MIs[0] policy
     /* 1685926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1685939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685960 */     // GIR_Coverage, 6881,
     /* 1685960 */     GIR_EraseRootFromParent_Done,
     /* 1685961 */   // Label 23124: @1685961
     /* 1685961 */   GIM_Try, /*On fail goto*//*Label 23125*/ GIMT_Encode4(1686047), // Rule ID 6884 //
     /* 1685966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1685974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1685977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1685980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1685983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1685986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1685989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1685996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686012 */     // MIs[0] policy
     /* 1686012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686022 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686046 */     // GIR_Coverage, 6884,
     /* 1686046 */     GIR_EraseRootFromParent_Done,
     /* 1686047 */   // Label 23125: @1686047
     /* 1686047 */   GIM_Try, /*On fail goto*//*Label 23126*/ GIMT_Encode4(1686133), // Rule ID 6885 //
     /* 1686052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1686072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686098 */     // MIs[0] policy
     /* 1686098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686132 */     // GIR_Coverage, 6885,
     /* 1686132 */     GIR_EraseRootFromParent_Done,
     /* 1686133 */   // Label 23126: @1686133
     /* 1686133 */   GIM_Try, /*On fail goto*//*Label 23127*/ GIMT_Encode4(1686219), // Rule ID 6888 //
     /* 1686138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686184 */     // MIs[0] policy
     /* 1686184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686218 */     // GIR_Coverage, 6888,
     /* 1686218 */     GIR_EraseRootFromParent_Done,
     /* 1686219 */   // Label 23127: @1686219
     /* 1686219 */   GIM_Try, /*On fail goto*//*Label 23128*/ GIMT_Encode4(1686305), // Rule ID 6889 //
     /* 1686224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1686235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1686238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1686241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1686244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686270 */     // MIs[0] policy
     /* 1686270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686280 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686304 */     // GIR_Coverage, 6889,
     /* 1686304 */     GIR_EraseRootFromParent_Done,
     /* 1686305 */   // Label 23128: @1686305
     /* 1686305 */   GIM_Try, /*On fail goto*//*Label 23129*/ GIMT_Encode4(1686391), // Rule ID 6892 //
     /* 1686310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1686330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686356 */     // MIs[0] policy
     /* 1686356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686390 */     // GIR_Coverage, 6892,
     /* 1686390 */     GIR_EraseRootFromParent_Done,
     /* 1686391 */   // Label 23129: @1686391
     /* 1686391 */   GIM_Try, /*On fail goto*//*Label 23130*/ GIMT_Encode4(1686477), // Rule ID 6893 //
     /* 1686396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1686407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1686410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1686413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1686416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1686419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686442 */     // MIs[0] policy
     /* 1686442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686476 */     // GIR_Coverage, 6893,
     /* 1686476 */     GIR_EraseRootFromParent_Done,
     /* 1686477 */   // Label 23130: @1686477
     /* 1686477 */   GIM_Try, /*On fail goto*//*Label 23131*/ GIMT_Encode4(1686563), // Rule ID 6896 //
     /* 1686482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1686493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1686496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1686499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1686502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686528 */     // MIs[0] policy
     /* 1686528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686538 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686562 */     // GIR_Coverage, 6896,
     /* 1686562 */     GIR_EraseRootFromParent_Done,
     /* 1686563 */   // Label 23131: @1686563
     /* 1686563 */   GIM_Try, /*On fail goto*//*Label 23132*/ GIMT_Encode4(1686649), // Rule ID 6897 //
     /* 1686568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1686579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1686582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1686585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1686588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686614 */     // MIs[0] policy
     /* 1686614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1686627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686648 */     // GIR_Coverage, 6897,
     /* 1686648 */     GIR_EraseRootFromParent_Done,
     /* 1686649 */   // Label 23132: @1686649
     /* 1686649 */   GIM_Try, /*On fail goto*//*Label 23133*/ GIMT_Encode4(1686735), // Rule ID 6900 //
     /* 1686654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1686665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1686668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1686671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1686674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686700 */     // MIs[0] policy
     /* 1686700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686710 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686734 */     // GIR_Coverage, 6900,
     /* 1686734 */     GIR_EraseRootFromParent_Done,
     /* 1686735 */   // Label 23133: @1686735
     /* 1686735 */   GIM_Try, /*On fail goto*//*Label 23134*/ GIMT_Encode4(1686821), // Rule ID 6901 //
     /* 1686740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1686751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1686754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1686757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1686760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686786 */     // MIs[0] policy
     /* 1686786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1686799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686820 */     // GIR_Coverage, 6901,
     /* 1686820 */     GIR_EraseRootFromParent_Done,
     /* 1686821 */   // Label 23134: @1686821
     /* 1686821 */   GIM_Try, /*On fail goto*//*Label 23135*/ GIMT_Encode4(1686907), // Rule ID 6904 //
     /* 1686826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1686829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1686837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1686840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1686843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1686846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1686849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686872 */     // MIs[0] policy
     /* 1686872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1686903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686906 */     // GIR_Coverage, 6904,
     /* 1686906 */     GIR_EraseRootFromParent_Done,
     /* 1686907 */   // Label 23135: @1686907
     /* 1686907 */   GIM_Try, /*On fail goto*//*Label 23136*/ GIMT_Encode4(1686993), // Rule ID 6905 //
     /* 1686912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1686915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1686920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1686923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1686926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1686929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1686932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1686935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686958 */     // MIs[0] policy
     /* 1686958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1686971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1686989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686992 */     // GIR_Coverage, 6905,
     /* 1686992 */     GIR_EraseRootFromParent_Done,
     /* 1686993 */   // Label 23136: @1686993
     /* 1686993 */   GIM_Try, /*On fail goto*//*Label 23137*/ GIMT_Encode4(1687079), // Rule ID 6908 //
     /* 1686998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687044 */     // MIs[0] policy
     /* 1687044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687054 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687078 */     // GIR_Coverage, 6908,
     /* 1687078 */     GIR_EraseRootFromParent_Done,
     /* 1687079 */   // Label 23137: @1687079
     /* 1687079 */   GIM_Try, /*On fail goto*//*Label 23138*/ GIMT_Encode4(1687165), // Rule ID 6909 //
     /* 1687084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1687104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687130 */     // MIs[0] policy
     /* 1687130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1687143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687164 */     // GIR_Coverage, 6909,
     /* 1687164 */     GIR_EraseRootFromParent_Done,
     /* 1687165 */   // Label 23138: @1687165
     /* 1687165 */   GIM_Try, /*On fail goto*//*Label 23139*/ GIMT_Encode4(1687251), // Rule ID 6912 //
     /* 1687170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687216 */     // MIs[0] policy
     /* 1687216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687226 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687250 */     // GIR_Coverage, 6912,
     /* 1687250 */     GIR_EraseRootFromParent_Done,
     /* 1687251 */   // Label 23139: @1687251
     /* 1687251 */   GIM_Try, /*On fail goto*//*Label 23140*/ GIMT_Encode4(1687337), // Rule ID 6913 //
     /* 1687256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1687267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1687270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1687273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1687276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687302 */     // MIs[0] policy
     /* 1687302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1687315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687336 */     // GIR_Coverage, 6913,
     /* 1687336 */     GIR_EraseRootFromParent_Done,
     /* 1687337 */   // Label 23140: @1687337
     /* 1687337 */   GIM_Try, /*On fail goto*//*Label 23141*/ GIMT_Encode4(1687423), // Rule ID 6916 //
     /* 1687342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687388 */     // MIs[0] policy
     /* 1687388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687398 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1687401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687422 */     // GIR_Coverage, 6916,
     /* 1687422 */     GIR_EraseRootFromParent_Done,
     /* 1687423 */   // Label 23141: @1687423
     /* 1687423 */   GIM_Try, /*On fail goto*//*Label 23142*/ GIMT_Encode4(1687509), // Rule ID 6917 //
     /* 1687428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1687439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1687442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1687445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687474 */     // MIs[0] policy
     /* 1687474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687484 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1687487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687508 */     // GIR_Coverage, 6917,
     /* 1687508 */     GIR_EraseRootFromParent_Done,
     /* 1687509 */   // Label 23142: @1687509
     /* 1687509 */   GIM_Try, /*On fail goto*//*Label 23143*/ GIMT_Encode4(1687595), // Rule ID 6920 //
     /* 1687514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1687525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1687528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1687531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687560 */     // MIs[0] policy
     /* 1687560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687570 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1687573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687594 */     // GIR_Coverage, 6920,
     /* 1687594 */     GIR_EraseRootFromParent_Done,
     /* 1687595 */   // Label 23143: @1687595
     /* 1687595 */   GIM_Try, /*On fail goto*//*Label 23144*/ GIMT_Encode4(1687681), // Rule ID 6921 //
     /* 1687600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1687611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1687614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1687617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687646 */     // MIs[0] policy
     /* 1687646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687656 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1687659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687680 */     // GIR_Coverage, 6921,
     /* 1687680 */     GIR_EraseRootFromParent_Done,
     /* 1687681 */   // Label 23144: @1687681
     /* 1687681 */   GIM_Try, /*On fail goto*//*Label 23145*/ GIMT_Encode4(1687767), // Rule ID 6924 //
     /* 1687686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1687697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1687700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1687703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687732 */     // MIs[0] policy
     /* 1687732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687742 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1687745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687766 */     // GIR_Coverage, 6924,
     /* 1687766 */     GIR_EraseRootFromParent_Done,
     /* 1687767 */   // Label 23145: @1687767
     /* 1687767 */   GIM_Try, /*On fail goto*//*Label 23146*/ GIMT_Encode4(1687853), // Rule ID 6925 //
     /* 1687772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1687783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1687786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1687789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687818 */     // MIs[0] policy
     /* 1687818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687828 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1687831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1687849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687852 */     // GIR_Coverage, 6925,
     /* 1687852 */     GIR_EraseRootFromParent_Done,
     /* 1687853 */   // Label 23146: @1687853
     /* 1687853 */   GIM_Try, /*On fail goto*//*Label 23147*/ GIMT_Encode4(1687939), // Rule ID 6928 //
     /* 1687858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1687869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1687872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1687875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1687878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687904 */     // MIs[0] policy
     /* 1687904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1687917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687938 */     // GIR_Coverage, 6928,
     /* 1687938 */     GIR_EraseRootFromParent_Done,
     /* 1687939 */   // Label 23147: @1687939
     /* 1687939 */   GIM_Try, /*On fail goto*//*Label 23148*/ GIMT_Encode4(1688025), // Rule ID 6929 //
     /* 1687944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1687952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1687955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1687958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1687961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1687964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1687967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1687974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1687982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1687986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687990 */     // MIs[0] policy
     /* 1687990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688000 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1688003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688024 */     // GIR_Coverage, 6929,
     /* 1688024 */     GIR_EraseRootFromParent_Done,
     /* 1688025 */   // Label 23148: @1688025
     /* 1688025 */   GIM_Try, /*On fail goto*//*Label 23149*/ GIMT_Encode4(1688111), // Rule ID 6932 //
     /* 1688030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688076 */     // MIs[0] policy
     /* 1688076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688110 */     // GIR_Coverage, 6932,
     /* 1688110 */     GIR_EraseRootFromParent_Done,
     /* 1688111 */   // Label 23149: @1688111
     /* 1688111 */   GIM_Try, /*On fail goto*//*Label 23150*/ GIMT_Encode4(1688197), // Rule ID 6933 //
     /* 1688116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1688127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1688130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1688133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688162 */     // MIs[0] policy
     /* 1688162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688172 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688196 */     // GIR_Coverage, 6933,
     /* 1688196 */     GIR_EraseRootFromParent_Done,
     /* 1688197 */   // Label 23150: @1688197
     /* 1688197 */   GIM_Try, /*On fail goto*//*Label 23151*/ GIMT_Encode4(1688283), // Rule ID 6936 //
     /* 1688202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688248 */     // MIs[0] policy
     /* 1688248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688258 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688282 */     // GIR_Coverage, 6936,
     /* 1688282 */     GIR_EraseRootFromParent_Done,
     /* 1688283 */   // Label 23151: @1688283
     /* 1688283 */   GIM_Try, /*On fail goto*//*Label 23152*/ GIMT_Encode4(1688369), // Rule ID 6937 //
     /* 1688288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1688299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1688302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1688305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688334 */     // MIs[0] policy
     /* 1688334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1688347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688368 */     // GIR_Coverage, 6937,
     /* 1688368 */     GIR_EraseRootFromParent_Done,
     /* 1688369 */   // Label 23152: @1688369
     /* 1688369 */   GIM_Try, /*On fail goto*//*Label 23153*/ GIMT_Encode4(1688455), // Rule ID 6940 //
     /* 1688374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688420 */     // MIs[0] policy
     /* 1688420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688430 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688454 */     // GIR_Coverage, 6940,
     /* 1688454 */     GIR_EraseRootFromParent_Done,
     /* 1688455 */   // Label 23153: @1688455
     /* 1688455 */   GIM_Try, /*On fail goto*//*Label 23154*/ GIMT_Encode4(1688541), // Rule ID 6941 //
     /* 1688460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1688471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1688474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1688477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688506 */     // MIs[0] policy
     /* 1688506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11582:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688540 */     // GIR_Coverage, 6941,
     /* 1688540 */     GIR_EraseRootFromParent_Done,
     /* 1688541 */   // Label 23154: @1688541
     /* 1688541 */   GIM_Try, /*On fail goto*//*Label 23155*/ GIMT_Encode4(1688627), // Rule ID 6944 //
     /* 1688546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1688557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1688560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1688563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688592 */     // MIs[0] policy
     /* 1688592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688626 */     // GIR_Coverage, 6944,
     /* 1688626 */     GIR_EraseRootFromParent_Done,
     /* 1688627 */   // Label 23155: @1688627
     /* 1688627 */   GIM_Try, /*On fail goto*//*Label 23156*/ GIMT_Encode4(1688713), // Rule ID 6945 //
     /* 1688632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1688643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1688646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1688649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688678 */     // MIs[0] policy
     /* 1688678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688688 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688712 */     // GIR_Coverage, 6945,
     /* 1688712 */     GIR_EraseRootFromParent_Done,
     /* 1688713 */   // Label 23156: @1688713
     /* 1688713 */   GIM_Try, /*On fail goto*//*Label 23157*/ GIMT_Encode4(1688799), // Rule ID 6948 //
     /* 1688718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1688729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1688732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1688735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688764 */     // MIs[0] policy
     /* 1688764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688798 */     // GIR_Coverage, 6948,
     /* 1688798 */     GIR_EraseRootFromParent_Done,
     /* 1688799 */   // Label 23157: @1688799
     /* 1688799 */   GIM_Try, /*On fail goto*//*Label 23158*/ GIMT_Encode4(1688885), // Rule ID 6949 //
     /* 1688804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1688815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1688818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1688821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688850 */     // MIs[0] policy
     /* 1688850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1688881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688884 */     // GIR_Coverage, 6949,
     /* 1688884 */     GIR_EraseRootFromParent_Done,
     /* 1688885 */   // Label 23158: @1688885
     /* 1688885 */   GIM_Try, /*On fail goto*//*Label 23159*/ GIMT_Encode4(1688971), // Rule ID 6952 //
     /* 1688890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1688893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1688901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1688904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1688907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688936 */     // MIs[0] policy
     /* 1688936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1688949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688970 */     // GIR_Coverage, 6952,
     /* 1688970 */     GIR_EraseRootFromParent_Done,
     /* 1688971 */   // Label 23159: @1688971
     /* 1688971 */   GIM_Try, /*On fail goto*//*Label 23160*/ GIMT_Encode4(1689057), // Rule ID 6953 //
     /* 1688976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1688979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1688984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1688987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1688990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1688993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689022 */     // MIs[0] policy
     /* 1689022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1689035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689056 */     // GIR_Coverage, 6953,
     /* 1689056 */     GIR_EraseRootFromParent_Done,
     /* 1689057 */   // Label 23160: @1689057
     /* 1689057 */   GIM_Try, /*On fail goto*//*Label 23161*/ GIMT_Encode4(1689143), // Rule ID 6956 //
     /* 1689062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689108 */     // MIs[0] policy
     /* 1689108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689142 */     // GIR_Coverage, 6956,
     /* 1689142 */     GIR_EraseRootFromParent_Done,
     /* 1689143 */   // Label 23161: @1689143
     /* 1689143 */   GIM_Try, /*On fail goto*//*Label 23162*/ GIMT_Encode4(1689229), // Rule ID 6957 //
     /* 1689148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1689159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1689162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1689165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689194 */     // MIs[0] policy
     /* 1689194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689228 */     // GIR_Coverage, 6957,
     /* 1689228 */     GIR_EraseRootFromParent_Done,
     /* 1689229 */   // Label 23162: @1689229
     /* 1689229 */   GIM_Try, /*On fail goto*//*Label 23163*/ GIMT_Encode4(1689315), // Rule ID 6960 //
     /* 1689234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689280 */     // MIs[0] policy
     /* 1689280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689314 */     // GIR_Coverage, 6960,
     /* 1689314 */     GIR_EraseRootFromParent_Done,
     /* 1689315 */   // Label 23163: @1689315
     /* 1689315 */   GIM_Try, /*On fail goto*//*Label 23164*/ GIMT_Encode4(1689401), // Rule ID 6961 //
     /* 1689320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1689331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1689334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1689337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689366 */     // MIs[0] policy
     /* 1689366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689400 */     // GIR_Coverage, 6961,
     /* 1689400 */     GIR_EraseRootFromParent_Done,
     /* 1689401 */   // Label 23164: @1689401
     /* 1689401 */   GIM_Try, /*On fail goto*//*Label 23165*/ GIMT_Encode4(1689487), // Rule ID 6964 //
     /* 1689406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689452 */     // MIs[0] policy
     /* 1689452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689462 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1689465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689486 */     // GIR_Coverage, 6964,
     /* 1689486 */     GIR_EraseRootFromParent_Done,
     /* 1689487 */   // Label 23165: @1689487
     /* 1689487 */   GIM_Try, /*On fail goto*//*Label 23166*/ GIMT_Encode4(1689573), // Rule ID 6965 //
     /* 1689492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1689503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1689506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1689509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1689515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689538 */     // MIs[0] policy
     /* 1689538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689548 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1689551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689572 */     // GIR_Coverage, 6965,
     /* 1689572 */     GIR_EraseRootFromParent_Done,
     /* 1689573 */   // Label 23166: @1689573
     /* 1689573 */   GIM_Try, /*On fail goto*//*Label 23167*/ GIMT_Encode4(1689659), // Rule ID 6968 //
     /* 1689578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1689589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1689592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1689595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689624 */     // MIs[0] policy
     /* 1689624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689658 */     // GIR_Coverage, 6968,
     /* 1689658 */     GIR_EraseRootFromParent_Done,
     /* 1689659 */   // Label 23167: @1689659
     /* 1689659 */   GIM_Try, /*On fail goto*//*Label 23168*/ GIMT_Encode4(1689745), // Rule ID 6969 //
     /* 1689664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1689675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1689678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1689681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1689694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1689702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689710 */     // MIs[0] policy
     /* 1689710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1689723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689744 */     // GIR_Coverage, 6969,
     /* 1689744 */     GIR_EraseRootFromParent_Done,
     /* 1689745 */   // Label 23168: @1689745
     /* 1689745 */   GIM_Try, /*On fail goto*//*Label 23169*/ GIMT_Encode4(1689831), // Rule ID 6972 //
     /* 1689750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1689761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1689764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1689767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689796 */     // MIs[0] policy
     /* 1689796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689830 */     // GIR_Coverage, 6972,
     /* 1689830 */     GIR_EraseRootFromParent_Done,
     /* 1689831 */   // Label 23169: @1689831
     /* 1689831 */   GIM_Try, /*On fail goto*//*Label 23170*/ GIMT_Encode4(1689917), // Rule ID 6973 //
     /* 1689836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1689847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1689850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1689853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1689859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1689866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1689874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689882 */     // MIs[0] policy
     /* 1689882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1689895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689916 */     // GIR_Coverage, 6973,
     /* 1689916 */     GIR_EraseRootFromParent_Done,
     /* 1689917 */   // Label 23170: @1689917
     /* 1689917 */   GIM_Try, /*On fail goto*//*Label 23171*/ GIMT_Encode4(1690003), // Rule ID 6976 //
     /* 1689922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1689930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1689933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1689936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1689939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1689945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1689952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1689960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689968 */     // MIs[0] policy
     /* 1689968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689978 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1689981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690002 */     // GIR_Coverage, 6976,
     /* 1690002 */     GIR_EraseRootFromParent_Done,
     /* 1690003 */   // Label 23171: @1690003
     /* 1690003 */   GIM_Try, /*On fail goto*//*Label 23172*/ GIMT_Encode4(1690089), // Rule ID 6977 //
     /* 1690008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690054 */     // MIs[0] policy
     /* 1690054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690064 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690088 */     // GIR_Coverage, 6977,
     /* 1690088 */     GIR_EraseRootFromParent_Done,
     /* 1690089 */   // Label 23172: @1690089
     /* 1690089 */   GIM_Try, /*On fail goto*//*Label 23173*/ GIMT_Encode4(1690175), // Rule ID 6980 //
     /* 1690094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690140 */     // MIs[0] policy
     /* 1690140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690174 */     // GIR_Coverage, 6980,
     /* 1690174 */     GIR_EraseRootFromParent_Done,
     /* 1690175 */   // Label 23173: @1690175
     /* 1690175 */   GIM_Try, /*On fail goto*//*Label 23174*/ GIMT_Encode4(1690261), // Rule ID 6981 //
     /* 1690180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1690191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1690194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1690197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690226 */     // MIs[0] policy
     /* 1690226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690260 */     // GIR_Coverage, 6981,
     /* 1690260 */     GIR_EraseRootFromParent_Done,
     /* 1690261 */   // Label 23174: @1690261
     /* 1690261 */   GIM_Try, /*On fail goto*//*Label 23175*/ GIMT_Encode4(1690347), // Rule ID 6984 //
     /* 1690266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690312 */     // MIs[0] policy
     /* 1690312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690346 */     // GIR_Coverage, 6984,
     /* 1690346 */     GIR_EraseRootFromParent_Done,
     /* 1690347 */   // Label 23175: @1690347
     /* 1690347 */   GIM_Try, /*On fail goto*//*Label 23176*/ GIMT_Encode4(1690433), // Rule ID 6985 //
     /* 1690352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1690363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1690366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1690369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690398 */     // MIs[0] policy
     /* 1690398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690432 */     // GIR_Coverage, 6985,
     /* 1690432 */     GIR_EraseRootFromParent_Done,
     /* 1690433 */   // Label 23176: @1690433
     /* 1690433 */   GIM_Try, /*On fail goto*//*Label 23177*/ GIMT_Encode4(1690519), // Rule ID 6988 //
     /* 1690438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1690449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1690452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1690455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690484 */     // MIs[0] policy
     /* 1690484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690518 */     // GIR_Coverage, 6988,
     /* 1690518 */     GIR_EraseRootFromParent_Done,
     /* 1690519 */   // Label 23177: @1690519
     /* 1690519 */   GIM_Try, /*On fail goto*//*Label 23178*/ GIMT_Encode4(1690605), // Rule ID 6989 //
     /* 1690524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1690535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1690538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1690541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690570 */     // MIs[0] policy
     /* 1690570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1690583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1690601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690604 */     // GIR_Coverage, 6989,
     /* 1690604 */     GIR_EraseRootFromParent_Done,
     /* 1690605 */   // Label 23178: @1690605
     /* 1690605 */   GIM_Try, /*On fail goto*//*Label 23179*/ GIMT_Encode4(1690691), // Rule ID 6992 //
     /* 1690610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1690613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1690621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1690624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1690627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1690633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690656 */     // MIs[0] policy
     /* 1690656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690690 */     // GIR_Coverage, 6992,
     /* 1690690 */     GIR_EraseRootFromParent_Done,
     /* 1690691 */   // Label 23179: @1690691
     /* 1690691 */   GIM_Try, /*On fail goto*//*Label 23180*/ GIMT_Encode4(1690777), // Rule ID 6993 //
     /* 1690696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1690699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1690707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1690710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1690713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1690719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690742 */     // MIs[0] policy
     /* 1690742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1690755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690776 */     // GIR_Coverage, 6993,
     /* 1690776 */     GIR_EraseRootFromParent_Done,
     /* 1690777 */   // Label 23180: @1690777
     /* 1690777 */   GIM_Try, /*On fail goto*//*Label 23181*/ GIMT_Encode4(1690863), // Rule ID 6996 //
     /* 1690782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1690785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1690793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1690796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1690799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690828 */     // MIs[0] policy
     /* 1690828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690862 */     // GIR_Coverage, 6996,
     /* 1690862 */     GIR_EraseRootFromParent_Done,
     /* 1690863 */   // Label 23181: @1690863
     /* 1690863 */   GIM_Try, /*On fail goto*//*Label 23182*/ GIMT_Encode4(1690949), // Rule ID 6997 //
     /* 1690868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1690871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1690879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1690882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1690885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1690891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690914 */     // MIs[0] policy
     /* 1690914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690924 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1690927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690948 */     // GIR_Coverage, 6997,
     /* 1690948 */     GIR_EraseRootFromParent_Done,
     /* 1690949 */   // Label 23182: @1690949
     /* 1690949 */   GIM_Try, /*On fail goto*//*Label 23183*/ GIMT_Encode4(1691035), // Rule ID 7000 //
     /* 1690954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1690957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1690962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1690965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1690968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1690971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691000 */     // MIs[0] policy
     /* 1691000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691034 */     // GIR_Coverage, 7000,
     /* 1691034 */     GIR_EraseRootFromParent_Done,
     /* 1691035 */   // Label 23183: @1691035
     /* 1691035 */   GIM_Try, /*On fail goto*//*Label 23184*/ GIMT_Encode4(1691121), // Rule ID 7001 //
     /* 1691040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1691048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691086 */     // MIs[0] policy
     /* 1691086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691096 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1691099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691120 */     // GIR_Coverage, 7001,
     /* 1691120 */     GIR_EraseRootFromParent_Done,
     /* 1691121 */   // Label 23184: @1691121
     /* 1691121 */   GIM_Try, /*On fail goto*//*Label 23185*/ GIMT_Encode4(1691207), // Rule ID 7092 //
     /* 1691126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691172 */     // MIs[0] policy
     /* 1691172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691182 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1691185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691206 */     // GIR_Coverage, 7092,
     /* 1691206 */     GIR_EraseRootFromParent_Done,
     /* 1691207 */   // Label 23185: @1691207
     /* 1691207 */   GIM_Try, /*On fail goto*//*Label 23186*/ GIMT_Encode4(1691293), // Rule ID 7093 //
     /* 1691212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1691223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1691226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1691229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1691232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691258 */     // MIs[0] policy
     /* 1691258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691268 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1691271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691292 */     // GIR_Coverage, 7093,
     /* 1691292 */     GIR_EraseRootFromParent_Done,
     /* 1691293 */   // Label 23186: @1691293
     /* 1691293 */   GIM_Try, /*On fail goto*//*Label 23187*/ GIMT_Encode4(1691379), // Rule ID 7096 //
     /* 1691298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1691318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691344 */     // MIs[0] policy
     /* 1691344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691354 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691378 */     // GIR_Coverage, 7096,
     /* 1691378 */     GIR_EraseRootFromParent_Done,
     /* 1691379 */   // Label 23187: @1691379
     /* 1691379 */   GIM_Try, /*On fail goto*//*Label 23188*/ GIMT_Encode4(1691465), // Rule ID 7097 //
     /* 1691384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1691395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1691398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1691401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1691404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691430 */     // MIs[0] policy
     /* 1691430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691440 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691464 */     // GIR_Coverage, 7097,
     /* 1691464 */     GIR_EraseRootFromParent_Done,
     /* 1691465 */   // Label 23188: @1691465
     /* 1691465 */   GIM_Try, /*On fail goto*//*Label 23189*/ GIMT_Encode4(1691551), // Rule ID 7100 //
     /* 1691470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1691481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1691484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1691487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1691490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691516 */     // MIs[0] policy
     /* 1691516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1691529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691550 */     // GIR_Coverage, 7100,
     /* 1691550 */     GIR_EraseRootFromParent_Done,
     /* 1691551 */   // Label 23189: @1691551
     /* 1691551 */   GIM_Try, /*On fail goto*//*Label 23190*/ GIMT_Encode4(1691637), // Rule ID 7101 //
     /* 1691556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1691567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1691570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1691573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1691576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691602 */     // MIs[0] policy
     /* 1691602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691612 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1691615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1691633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691636 */     // GIR_Coverage, 7101,
     /* 1691636 */     GIR_EraseRootFromParent_Done,
     /* 1691637 */   // Label 23190: @1691637
     /* 1691637 */   GIM_Try, /*On fail goto*//*Label 23191*/ GIMT_Encode4(1691723), // Rule ID 7104 //
     /* 1691642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1691653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1691656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1691659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1691662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691688 */     // MIs[0] policy
     /* 1691688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691698 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691722 */     // GIR_Coverage, 7104,
     /* 1691722 */     GIR_EraseRootFromParent_Done,
     /* 1691723 */   // Label 23191: @1691723
     /* 1691723 */   GIM_Try, /*On fail goto*//*Label 23192*/ GIMT_Encode4(1691809), // Rule ID 7105 //
     /* 1691728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1691739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1691742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1691745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1691748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1691751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691774 */     // MIs[0] policy
     /* 1691774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1691787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691808 */     // GIR_Coverage, 7105,
     /* 1691808 */     GIR_EraseRootFromParent_Done,
     /* 1691809 */   // Label 23192: @1691809
     /* 1691809 */   GIM_Try, /*On fail goto*//*Label 23193*/ GIMT_Encode4(1691895), // Rule ID 7108 //
     /* 1691814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1691825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1691828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1691831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1691834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691860 */     // MIs[0] policy
     /* 1691860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691870 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1691873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691894 */     // GIR_Coverage, 7108,
     /* 1691894 */     GIR_EraseRootFromParent_Done,
     /* 1691895 */   // Label 23193: @1691895
     /* 1691895 */   GIM_Try, /*On fail goto*//*Label 23194*/ GIMT_Encode4(1691981), // Rule ID 7109 //
     /* 1691900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1691911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1691914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1691917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1691920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1691930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1691942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691946 */     // MIs[0] policy
     /* 1691946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691956 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1691959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691980 */     // GIR_Coverage, 7109,
     /* 1691980 */     GIR_EraseRootFromParent_Done,
     /* 1691981 */   // Label 23194: @1691981
     /* 1691981 */   GIM_Try, /*On fail goto*//*Label 23195*/ GIMT_Encode4(1692067), // Rule ID 7112 //
     /* 1691986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1691997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692032 */     // MIs[0] policy
     /* 1692032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692066 */     // GIR_Coverage, 7112,
     /* 1692066 */     GIR_EraseRootFromParent_Done,
     /* 1692067 */   // Label 23195: @1692067
     /* 1692067 */   GIM_Try, /*On fail goto*//*Label 23196*/ GIMT_Encode4(1692153), // Rule ID 7113 //
     /* 1692072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1692083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1692086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1692089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1692092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692118 */     // MIs[0] policy
     /* 1692118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692128 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1692131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692152 */     // GIR_Coverage, 7113,
     /* 1692152 */     GIR_EraseRootFromParent_Done,
     /* 1692153 */   // Label 23196: @1692153
     /* 1692153 */   GIM_Try, /*On fail goto*//*Label 23197*/ GIMT_Encode4(1692239), // Rule ID 7116 //
     /* 1692158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692204 */     // MIs[0] policy
     /* 1692204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692214 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692238 */     // GIR_Coverage, 7116,
     /* 1692238 */     GIR_EraseRootFromParent_Done,
     /* 1692239 */   // Label 23197: @1692239
     /* 1692239 */   GIM_Try, /*On fail goto*//*Label 23198*/ GIMT_Encode4(1692325), // Rule ID 7117 //
     /* 1692244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1692261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692290 */     // MIs[0] policy
     /* 1692290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692324 */     // GIR_Coverage, 7117,
     /* 1692324 */     GIR_EraseRootFromParent_Done,
     /* 1692325 */   // Label 23198: @1692325
     /* 1692325 */   GIM_Try, /*On fail goto*//*Label 23199*/ GIMT_Encode4(1692411), // Rule ID 7120 //
     /* 1692330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1692350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692376 */     // MIs[0] policy
     /* 1692376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692410 */     // GIR_Coverage, 7120,
     /* 1692410 */     GIR_EraseRootFromParent_Done,
     /* 1692411 */   // Label 23199: @1692411
     /* 1692411 */   GIM_Try, /*On fail goto*//*Label 23200*/ GIMT_Encode4(1692497), // Rule ID 7121 //
     /* 1692416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1692427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1692430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1692436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692462 */     // MIs[0] policy
     /* 1692462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1692493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692496 */     // GIR_Coverage, 7121,
     /* 1692496 */     GIR_EraseRootFromParent_Done,
     /* 1692497 */   // Label 23200: @1692497
     /* 1692497 */   GIM_Try, /*On fail goto*//*Label 23201*/ GIMT_Encode4(1692583), // Rule ID 7124 //
     /* 1692502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1692513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1692516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1692519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1692522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692548 */     // MIs[0] policy
     /* 1692548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692582 */     // GIR_Coverage, 7124,
     /* 1692582 */     GIR_EraseRootFromParent_Done,
     /* 1692583 */   // Label 23201: @1692583
     /* 1692583 */   GIM_Try, /*On fail goto*//*Label 23202*/ GIMT_Encode4(1692669), // Rule ID 7125 //
     /* 1692588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1692599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1692602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1692605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1692608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692634 */     // MIs[0] policy
     /* 1692634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1692665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692668 */     // GIR_Coverage, 7125,
     /* 1692668 */     GIR_EraseRootFromParent_Done,
     /* 1692669 */   // Label 23202: @1692669
     /* 1692669 */   GIM_Try, /*On fail goto*//*Label 23203*/ GIMT_Encode4(1692755), // Rule ID 7128 //
     /* 1692674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1692677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1692685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1692688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1692691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1692694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692720 */     // MIs[0] policy
     /* 1692720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692754 */     // GIR_Coverage, 7128,
     /* 1692754 */     GIR_EraseRootFromParent_Done,
     /* 1692755 */   // Label 23203: @1692755
     /* 1692755 */   GIM_Try, /*On fail goto*//*Label 23204*/ GIMT_Encode4(1692841), // Rule ID 7129 //
     /* 1692760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1692763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1692771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1692774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1692777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1692780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692806 */     // MIs[0] policy
     /* 1692806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1692819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692840 */     // GIR_Coverage, 7129,
     /* 1692840 */     GIR_EraseRootFromParent_Done,
     /* 1692841 */   // Label 23204: @1692841
     /* 1692841 */   GIM_Try, /*On fail goto*//*Label 23205*/ GIMT_Encode4(1692927), // Rule ID 7132 //
     /* 1692846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1692857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1692860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1692863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1692866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1692869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1692876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692892 */     // MIs[0] policy
     /* 1692892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692902 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1692905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692926 */     // GIR_Coverage, 7132,
     /* 1692926 */     GIR_EraseRootFromParent_Done,
     /* 1692927 */   // Label 23205: @1692927
     /* 1692927 */   GIM_Try, /*On fail goto*//*Label 23206*/ GIMT_Encode4(1693013), // Rule ID 7133 //
     /* 1692932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1692943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1692946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1692949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1692952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1692955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1692962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692978 */     // MIs[0] policy
     /* 1692978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1692991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693012 */     // GIR_Coverage, 7133,
     /* 1693012 */     GIR_EraseRootFromParent_Done,
     /* 1693013 */   // Label 23206: @1693013
     /* 1693013 */   GIM_Try, /*On fail goto*//*Label 23207*/ GIMT_Encode4(1693099), // Rule ID 7136 //
     /* 1693018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693064 */     // MIs[0] policy
     /* 1693064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693074 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693098 */     // GIR_Coverage, 7136,
     /* 1693098 */     GIR_EraseRootFromParent_Done,
     /* 1693099 */   // Label 23207: @1693099
     /* 1693099 */   GIM_Try, /*On fail goto*//*Label 23208*/ GIMT_Encode4(1693185), // Rule ID 7137 //
     /* 1693104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1693121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693150 */     // MIs[0] policy
     /* 1693150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693184 */     // GIR_Coverage, 7137,
     /* 1693184 */     GIR_EraseRootFromParent_Done,
     /* 1693185 */   // Label 23208: @1693185
     /* 1693185 */   GIM_Try, /*On fail goto*//*Label 23209*/ GIMT_Encode4(1693271), // Rule ID 7140 //
     /* 1693190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693236 */     // MIs[0] policy
     /* 1693236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693246 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693270 */     // GIR_Coverage, 7140,
     /* 1693270 */     GIR_EraseRootFromParent_Done,
     /* 1693271 */   // Label 23209: @1693271
     /* 1693271 */   GIM_Try, /*On fail goto*//*Label 23210*/ GIMT_Encode4(1693357), // Rule ID 7141 //
     /* 1693276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1693287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1693290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1693293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1693296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1693299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693322 */     // MIs[0] policy
     /* 1693322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693332 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693356 */     // GIR_Coverage, 7141,
     /* 1693356 */     GIR_EraseRootFromParent_Done,
     /* 1693357 */   // Label 23210: @1693357
     /* 1693357 */   GIM_Try, /*On fail goto*//*Label 23211*/ GIMT_Encode4(1693443), // Rule ID 7144 //
     /* 1693362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693408 */     // MIs[0] policy
     /* 1693408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693442 */     // GIR_Coverage, 7144,
     /* 1693442 */     GIR_EraseRootFromParent_Done,
     /* 1693443 */   // Label 23211: @1693443
     /* 1693443 */   GIM_Try, /*On fail goto*//*Label 23212*/ GIMT_Encode4(1693529), // Rule ID 7145 //
     /* 1693448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1693465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693494 */     // MIs[0] policy
     /* 1693494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693528 */     // GIR_Coverage, 7145,
     /* 1693528 */     GIR_EraseRootFromParent_Done,
     /* 1693529 */   // Label 23212: @1693529
     /* 1693529 */   GIM_Try, /*On fail goto*//*Label 23213*/ GIMT_Encode4(1693615), // Rule ID 7148 //
     /* 1693534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1693545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1693548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1693551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1693554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693580 */     // MIs[0] policy
     /* 1693580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693614 */     // GIR_Coverage, 7148,
     /* 1693614 */     GIR_EraseRootFromParent_Done,
     /* 1693615 */   // Label 23213: @1693615
     /* 1693615 */   GIM_Try, /*On fail goto*//*Label 23214*/ GIMT_Encode4(1693701), // Rule ID 7149 //
     /* 1693620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1693631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1693634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1693637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1693640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693666 */     // MIs[0] policy
     /* 1693666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1693679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693700 */     // GIR_Coverage, 7149,
     /* 1693700 */     GIR_EraseRootFromParent_Done,
     /* 1693701 */   // Label 23214: @1693701
     /* 1693701 */   GIM_Try, /*On fail goto*//*Label 23215*/ GIMT_Encode4(1693787), // Rule ID 7152 //
     /* 1693706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1693717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1693720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1693723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1693726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693752 */     // MIs[0] policy
     /* 1693752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693762 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693786 */     // GIR_Coverage, 7152,
     /* 1693786 */     GIR_EraseRootFromParent_Done,
     /* 1693787 */   // Label 23215: @1693787
     /* 1693787 */   GIM_Try, /*On fail goto*//*Label 23216*/ GIMT_Encode4(1693873), // Rule ID 7153 //
     /* 1693792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1693803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1693806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1693809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1693812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1693822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693838 */     // MIs[0] policy
     /* 1693838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693848 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1693851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693872 */     // GIR_Coverage, 7153,
     /* 1693872 */     GIR_EraseRootFromParent_Done,
     /* 1693873 */   // Label 23216: @1693873
     /* 1693873 */   GIM_Try, /*On fail goto*//*Label 23217*/ GIMT_Encode4(1693959), // Rule ID 7156 //
     /* 1693878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1693889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1693892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1693895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1693898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693924 */     // MIs[0] policy
     /* 1693924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1693937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1693955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693958 */     // GIR_Coverage, 7156,
     /* 1693958 */     GIR_EraseRootFromParent_Done,
     /* 1693959 */   // Label 23217: @1693959
     /* 1693959 */   GIM_Try, /*On fail goto*//*Label 23218*/ GIMT_Encode4(1694045), // Rule ID 7157 //
     /* 1693964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1693972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1693975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1693978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1693981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1693984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694010 */     // MIs[0] policy
     /* 1694010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694044 */     // GIR_Coverage, 7157,
     /* 1694044 */     GIR_EraseRootFromParent_Done,
     /* 1694045 */   // Label 23218: @1694045
     /* 1694045 */   GIM_Try, /*On fail goto*//*Label 23219*/ GIMT_Encode4(1694131), // Rule ID 7160 //
     /* 1694050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694096 */     // MIs[0] policy
     /* 1694096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694130 */     // GIR_Coverage, 7160,
     /* 1694130 */     GIR_EraseRootFromParent_Done,
     /* 1694131 */   // Label 23219: @1694131
     /* 1694131 */   GIM_Try, /*On fail goto*//*Label 23220*/ GIMT_Encode4(1694217), // Rule ID 7161 //
     /* 1694136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1694153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694182 */     // MIs[0] policy
     /* 1694182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694216 */     // GIR_Coverage, 7161,
     /* 1694216 */     GIR_EraseRootFromParent_Done,
     /* 1694217 */   // Label 23220: @1694217
     /* 1694217 */   GIM_Try, /*On fail goto*//*Label 23221*/ GIMT_Encode4(1694303), // Rule ID 7164 //
     /* 1694222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694268 */     // MIs[0] policy
     /* 1694268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694278 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694302 */     // GIR_Coverage, 7164,
     /* 1694302 */     GIR_EraseRootFromParent_Done,
     /* 1694303 */   // Label 23221: @1694303
     /* 1694303 */   GIM_Try, /*On fail goto*//*Label 23222*/ GIMT_Encode4(1694389), // Rule ID 7165 //
     /* 1694308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1694319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1694322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1694325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1694328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1694331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694354 */     // MIs[0] policy
     /* 1694354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694388 */     // GIR_Coverage, 7165,
     /* 1694388 */     GIR_EraseRootFromParent_Done,
     /* 1694389 */   // Label 23222: @1694389
     /* 1694389 */   GIM_Try, /*On fail goto*//*Label 23223*/ GIMT_Encode4(1694475), // Rule ID 7168 //
     /* 1694394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1694414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694440 */     // MIs[0] policy
     /* 1694440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694474 */     // GIR_Coverage, 7168,
     /* 1694474 */     GIR_EraseRootFromParent_Done,
     /* 1694475 */   // Label 23223: @1694475
     /* 1694475 */   GIM_Try, /*On fail goto*//*Label 23224*/ GIMT_Encode4(1694561), // Rule ID 7169 //
     /* 1694480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1694491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1694494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1694500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694526 */     // MIs[0] policy
     /* 1694526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1694539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694560 */     // GIR_Coverage, 7169,
     /* 1694560 */     GIR_EraseRootFromParent_Done,
     /* 1694561 */   // Label 23224: @1694561
     /* 1694561 */   GIM_Try, /*On fail goto*//*Label 23225*/ GIMT_Encode4(1694647), // Rule ID 7172 //
     /* 1694566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1694577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1694580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1694583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1694586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694612 */     // MIs[0] policy
     /* 1694612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694622 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694646 */     // GIR_Coverage, 7172,
     /* 1694646 */     GIR_EraseRootFromParent_Done,
     /* 1694647 */   // Label 23225: @1694647
     /* 1694647 */   GIM_Try, /*On fail goto*//*Label 23226*/ GIMT_Encode4(1694733), // Rule ID 7173 //
     /* 1694652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1694663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1694666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1694669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1694672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694698 */     // MIs[0] policy
     /* 1694698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694708 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1694711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694732 */     // GIR_Coverage, 7173,
     /* 1694732 */     GIR_EraseRootFromParent_Done,
     /* 1694733 */   // Label 23226: @1694733
     /* 1694733 */   GIM_Try, /*On fail goto*//*Label 23227*/ GIMT_Encode4(1694819), // Rule ID 7176 //
     /* 1694738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1694741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1694749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1694752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1694755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1694758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694784 */     // MIs[0] policy
     /* 1694784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694818 */     // GIR_Coverage, 7176,
     /* 1694818 */     GIR_EraseRootFromParent_Done,
     /* 1694819 */   // Label 23227: @1694819
     /* 1694819 */   GIM_Try, /*On fail goto*//*Label 23228*/ GIMT_Encode4(1694905), // Rule ID 7177 //
     /* 1694824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1694827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1694835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1694838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1694841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1694844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1694854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694870 */     // MIs[0] policy
     /* 1694870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694880 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1694883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1694901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694904 */     // GIR_Coverage, 7177,
     /* 1694904 */     GIR_EraseRootFromParent_Done,
     /* 1694905 */   // Label 23228: @1694905
     /* 1694905 */   GIM_Try, /*On fail goto*//*Label 23229*/ GIMT_Encode4(1694991), // Rule ID 7180 //
     /* 1694910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1694918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1694921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1694924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1694927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1694933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694956 */     // MIs[0] policy
     /* 1694956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694966 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1694969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694990 */     // GIR_Coverage, 7180,
     /* 1694990 */     GIR_EraseRootFromParent_Done,
     /* 1694991 */   // Label 23229: @1694991
     /* 1694991 */   GIM_Try, /*On fail goto*//*Label 23230*/ GIMT_Encode4(1695077), // Rule ID 7181 //
     /* 1694996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1695007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1695010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1695013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695042 */     // MIs[0] policy
     /* 1695042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1695055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695076 */     // GIR_Coverage, 7181,
     /* 1695076 */     GIR_EraseRootFromParent_Done,
     /* 1695077 */   // Label 23230: @1695077
     /* 1695077 */   GIM_Try, /*On fail goto*//*Label 23231*/ GIMT_Encode4(1695163), // Rule ID 7184 //
     /* 1695082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695128 */     // MIs[0] policy
     /* 1695128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695138 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695162 */     // GIR_Coverage, 7184,
     /* 1695162 */     GIR_EraseRootFromParent_Done,
     /* 1695163 */   // Label 23231: @1695163
     /* 1695163 */   GIM_Try, /*On fail goto*//*Label 23232*/ GIMT_Encode4(1695249), // Rule ID 7185 //
     /* 1695168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1695179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1695182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1695185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695214 */     // MIs[0] policy
     /* 1695214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695224 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695248 */     // GIR_Coverage, 7185,
     /* 1695248 */     GIR_EraseRootFromParent_Done,
     /* 1695249 */   // Label 23232: @1695249
     /* 1695249 */   GIM_Try, /*On fail goto*//*Label 23233*/ GIMT_Encode4(1695335), // Rule ID 7188 //
     /* 1695254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695300 */     // MIs[0] policy
     /* 1695300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695310 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695334 */     // GIR_Coverage, 7188,
     /* 1695334 */     GIR_EraseRootFromParent_Done,
     /* 1695335 */   // Label 23233: @1695335
     /* 1695335 */   GIM_Try, /*On fail goto*//*Label 23234*/ GIMT_Encode4(1695421), // Rule ID 7189 //
     /* 1695340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1695357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695386 */     // MIs[0] policy
     /* 1695386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695420 */     // GIR_Coverage, 7189,
     /* 1695420 */     GIR_EraseRootFromParent_Done,
     /* 1695421 */   // Label 23234: @1695421
     /* 1695421 */   GIM_Try, /*On fail goto*//*Label 23235*/ GIMT_Encode4(1695507), // Rule ID 7192 //
     /* 1695426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1695443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695472 */     // MIs[0] policy
     /* 1695472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695482 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695506 */     // GIR_Coverage, 7192,
     /* 1695506 */     GIR_EraseRootFromParent_Done,
     /* 1695507 */   // Label 23235: @1695507
     /* 1695507 */   GIM_Try, /*On fail goto*//*Label 23236*/ GIMT_Encode4(1695593), // Rule ID 7193 //
     /* 1695512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1695529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695558 */     // MIs[0] policy
     /* 1695558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1695571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695592 */     // GIR_Coverage, 7193,
     /* 1695592 */     GIR_EraseRootFromParent_Done,
     /* 1695593 */   // Label 23236: @1695593
     /* 1695593 */   GIM_Try, /*On fail goto*//*Label 23237*/ GIMT_Encode4(1695679), // Rule ID 7196 //
     /* 1695598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1695609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1695612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1695615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695644 */     // MIs[0] policy
     /* 1695644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695654 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695678 */     // GIR_Coverage, 7196,
     /* 1695678 */     GIR_EraseRootFromParent_Done,
     /* 1695679 */   // Label 23237: @1695679
     /* 1695679 */   GIM_Try, /*On fail goto*//*Label 23238*/ GIMT_Encode4(1695765), // Rule ID 7197 //
     /* 1695684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1695695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1695698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1695701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695730 */     // MIs[0] policy
     /* 1695730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695740 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695764 */     // GIR_Coverage, 7197,
     /* 1695764 */     GIR_EraseRootFromParent_Done,
     /* 1695765 */   // Label 23238: @1695765
     /* 1695765 */   GIM_Try, /*On fail goto*//*Label 23239*/ GIMT_Encode4(1695851), // Rule ID 7200 //
     /* 1695770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1695781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1695784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1695787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695816 */     // MIs[0] policy
     /* 1695816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695826 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695850 */     // GIR_Coverage, 7200,
     /* 1695850 */     GIR_EraseRootFromParent_Done,
     /* 1695851 */   // Label 23239: @1695851
     /* 1695851 */   GIM_Try, /*On fail goto*//*Label 23240*/ GIMT_Encode4(1695937), // Rule ID 7201 //
     /* 1695856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1695867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1695870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1695873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695902 */     // MIs[0] policy
     /* 1695902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1695915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1695933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695936 */     // GIR_Coverage, 7201,
     /* 1695936 */     GIR_EraseRootFromParent_Done,
     /* 1695937 */   // Label 23240: @1695937
     /* 1695937 */   GIM_Try, /*On fail goto*//*Label 23241*/ GIMT_Encode4(1696023), // Rule ID 7204 //
     /* 1695942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1695950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1695953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1695956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1695959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695988 */     // MIs[0] policy
     /* 1695988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695998 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696022 */     // GIR_Coverage, 7204,
     /* 1696022 */     GIR_EraseRootFromParent_Done,
     /* 1696023 */   // Label 23241: @1696023
     /* 1696023 */   GIM_Try, /*On fail goto*//*Label 23242*/ GIMT_Encode4(1696109), // Rule ID 7205 //
     /* 1696028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1696039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1696042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1696045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696074 */     // MIs[0] policy
     /* 1696074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11580:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696108 */     // GIR_Coverage, 7205,
     /* 1696108 */     GIR_EraseRootFromParent_Done,
     /* 1696109 */   // Label 23242: @1696109
     /* 1696109 */   GIM_Try, /*On fail goto*//*Label 23243*/ GIMT_Encode4(1696195), // Rule ID 7208 //
     /* 1696114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696160 */     // MIs[0] policy
     /* 1696160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696194 */     // GIR_Coverage, 7208,
     /* 1696194 */     GIR_EraseRootFromParent_Done,
     /* 1696195 */   // Label 23243: @1696195
     /* 1696195 */   GIM_Try, /*On fail goto*//*Label 23244*/ GIMT_Encode4(1696281), // Rule ID 7209 //
     /* 1696200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1696217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696246 */     // MIs[0] policy
     /* 1696246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696280 */     // GIR_Coverage, 7209,
     /* 1696280 */     GIR_EraseRootFromParent_Done,
     /* 1696281 */   // Label 23244: @1696281
     /* 1696281 */   GIM_Try, /*On fail goto*//*Label 23245*/ GIMT_Encode4(1696367), // Rule ID 7212 //
     /* 1696286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696332 */     // MIs[0] policy
     /* 1696332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696366 */     // GIR_Coverage, 7212,
     /* 1696366 */     GIR_EraseRootFromParent_Done,
     /* 1696367 */   // Label 23245: @1696367
     /* 1696367 */   GIM_Try, /*On fail goto*//*Label 23246*/ GIMT_Encode4(1696453), // Rule ID 7213 //
     /* 1696372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1696389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696418 */     // MIs[0] policy
     /* 1696418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696452 */     // GIR_Coverage, 7213,
     /* 1696452 */     GIR_EraseRootFromParent_Done,
     /* 1696453 */   // Label 23246: @1696453
     /* 1696453 */   GIM_Try, /*On fail goto*//*Label 23247*/ GIMT_Encode4(1696539), // Rule ID 7216 //
     /* 1696458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1696461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1696469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1696472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696504 */     // MIs[0] policy
     /* 1696504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696538 */     // GIR_Coverage, 7216,
     /* 1696538 */     GIR_EraseRootFromParent_Done,
     /* 1696539 */   // Label 23247: @1696539
     /* 1696539 */   GIM_Try, /*On fail goto*//*Label 23248*/ GIMT_Encode4(1696625), // Rule ID 7217 //
     /* 1696544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1696547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1696555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1696558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696590 */     // MIs[0] policy
     /* 1696590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1696603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1696621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696624 */     // GIR_Coverage, 7217,
     /* 1696624 */     GIR_EraseRootFromParent_Done,
     /* 1696625 */   // Label 23248: @1696625
     /* 1696625 */   GIM_Try, /*On fail goto*//*Label 23249*/ GIMT_Encode4(1696711), // Rule ID 7220 //
     /* 1696630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1696641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1696644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1696647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1696653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696676 */     // MIs[0] policy
     /* 1696676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696686 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1696689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696710 */     // GIR_Coverage, 7220,
     /* 1696710 */     GIR_EraseRootFromParent_Done,
     /* 1696711 */   // Label 23249: @1696711
     /* 1696711 */   GIM_Try, /*On fail goto*//*Label 23250*/ GIMT_Encode4(1696797), // Rule ID 7221 //
     /* 1696716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1696727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1696730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1696733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1696739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696762 */     // MIs[0] policy
     /* 1696762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1696775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696796 */     // GIR_Coverage, 7221,
     /* 1696796 */     GIR_EraseRootFromParent_Done,
     /* 1696797 */   // Label 23250: @1696797
     /* 1696797 */   GIM_Try, /*On fail goto*//*Label 23251*/ GIMT_Encode4(1696883), // Rule ID 7224 //
     /* 1696802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1696813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1696816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1696819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1696825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696848 */     // MIs[0] policy
     /* 1696848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1696861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696882 */     // GIR_Coverage, 7224,
     /* 1696882 */     GIR_EraseRootFromParent_Done,
     /* 1696883 */   // Label 23251: @1696883
     /* 1696883 */   GIM_Try, /*On fail goto*//*Label 23252*/ GIMT_Encode4(1696969), // Rule ID 7225 //
     /* 1696888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1696899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1696902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1696905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1696911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696934 */     // MIs[0] policy
     /* 1696934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696944 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1696947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1696965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696968 */     // GIR_Coverage, 7225,
     /* 1696968 */     GIR_EraseRootFromParent_Done,
     /* 1696969 */   // Label 23252: @1696969
     /* 1696969 */   GIM_Try, /*On fail goto*//*Label 23253*/ GIMT_Encode4(1697055), // Rule ID 7228 //
     /* 1696974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1696982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1696985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1696988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1696991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1696997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697020 */     // MIs[0] policy
     /* 1697020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697030 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697054 */     // GIR_Coverage, 7228,
     /* 1697054 */     GIR_EraseRootFromParent_Done,
     /* 1697055 */   // Label 23253: @1697055
     /* 1697055 */   GIM_Try, /*On fail goto*//*Label 23254*/ GIMT_Encode4(1697141), // Rule ID 7229 //
     /* 1697060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1697071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1697074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1697077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1697083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697106 */     // MIs[0] policy
     /* 1697106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697116 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697140 */     // GIR_Coverage, 7229,
     /* 1697140 */     GIR_EraseRootFromParent_Done,
     /* 1697141 */   // Label 23254: @1697141
     /* 1697141 */   GIM_Try, /*On fail goto*//*Label 23255*/ GIMT_Encode4(1697227), // Rule ID 7232 //
     /* 1697146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697192 */     // MIs[0] policy
     /* 1697192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697226 */     // GIR_Coverage, 7232,
     /* 1697226 */     GIR_EraseRootFromParent_Done,
     /* 1697227 */   // Label 23255: @1697227
     /* 1697227 */   GIM_Try, /*On fail goto*//*Label 23256*/ GIMT_Encode4(1697313), // Rule ID 7233 //
     /* 1697232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1697243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1697246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697278 */     // MIs[0] policy
     /* 1697278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697312 */     // GIR_Coverage, 7233,
     /* 1697312 */     GIR_EraseRootFromParent_Done,
     /* 1697313 */   // Label 23256: @1697313
     /* 1697313 */   GIM_Try, /*On fail goto*//*Label 23257*/ GIMT_Encode4(1697399), // Rule ID 7236 //
     /* 1697318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697364 */     // MIs[0] policy
     /* 1697364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697398 */     // GIR_Coverage, 7236,
     /* 1697398 */     GIR_EraseRootFromParent_Done,
     /* 1697399 */   // Label 23257: @1697399
     /* 1697399 */   GIM_Try, /*On fail goto*//*Label 23258*/ GIMT_Encode4(1697485), // Rule ID 7237 //
     /* 1697404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1697415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1697418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697450 */     // MIs[0] policy
     /* 1697450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697484 */     // GIR_Coverage, 7237,
     /* 1697484 */     GIR_EraseRootFromParent_Done,
     /* 1697485 */   // Label 23258: @1697485
     /* 1697485 */   GIM_Try, /*On fail goto*//*Label 23259*/ GIMT_Encode4(1697571), // Rule ID 7240 //
     /* 1697490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1697501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1697504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697536 */     // MIs[0] policy
     /* 1697536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697570 */     // GIR_Coverage, 7240,
     /* 1697570 */     GIR_EraseRootFromParent_Done,
     /* 1697571 */   // Label 23259: @1697571
     /* 1697571 */   GIM_Try, /*On fail goto*//*Label 23260*/ GIMT_Encode4(1697657), // Rule ID 7241 //
     /* 1697576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1697587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1697590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1697593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1697599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1697606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697622 */     // MIs[0] policy
     /* 1697622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697632 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1697635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1697653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697656 */     // GIR_Coverage, 7241,
     /* 1697656 */     GIR_EraseRootFromParent_Done,
     /* 1697657 */   // Label 23260: @1697657
     /* 1697657 */   GIM_Try, /*On fail goto*//*Label 23261*/ GIMT_Encode4(1697743), // Rule ID 7244 //
     /* 1697662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1697673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1697676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1697679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697708 */     // MIs[0] policy
     /* 1697708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697742 */     // GIR_Coverage, 7244,
     /* 1697742 */     GIR_EraseRootFromParent_Done,
     /* 1697743 */   // Label 23261: @1697743
     /* 1697743 */   GIM_Try, /*On fail goto*//*Label 23262*/ GIMT_Encode4(1697829), // Rule ID 7245 //
     /* 1697748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1697759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1697762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1697765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697794 */     // MIs[0] policy
     /* 1697794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1697807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697828 */     // GIR_Coverage, 7245,
     /* 1697828 */     GIR_EraseRootFromParent_Done,
     /* 1697829 */   // Label 23262: @1697829
     /* 1697829 */   GIM_Try, /*On fail goto*//*Label 23263*/ GIMT_Encode4(1697915), // Rule ID 7248 //
     /* 1697834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1697845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1697848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1697851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697880 */     // MIs[0] policy
     /* 1697880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697914 */     // GIR_Coverage, 7248,
     /* 1697914 */     GIR_EraseRootFromParent_Done,
     /* 1697915 */   // Label 23263: @1697915
     /* 1697915 */   GIM_Try, /*On fail goto*//*Label 23264*/ GIMT_Encode4(1698001), // Rule ID 7249 //
     /* 1697920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1697928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1697931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1697934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1697937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697966 */     // MIs[0] policy
     /* 1697966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1697979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698000 */     // GIR_Coverage, 7249,
     /* 1698000 */     GIR_EraseRootFromParent_Done,
     /* 1698001 */   // Label 23264: @1698001
     /* 1698001 */   GIM_Try, /*On fail goto*//*Label 23265*/ GIMT_Encode4(1698087), // Rule ID 7252 //
     /* 1698006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698052 */     // MIs[0] policy
     /* 1698052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698086 */     // GIR_Coverage, 7252,
     /* 1698086 */     GIR_EraseRootFromParent_Done,
     /* 1698087 */   // Label 23265: @1698087
     /* 1698087 */   GIM_Try, /*On fail goto*//*Label 23266*/ GIMT_Encode4(1698173), // Rule ID 7253 //
     /* 1698092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1698103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1698106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1698109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698138 */     // MIs[0] policy
     /* 1698138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698148 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1698169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698172 */     // GIR_Coverage, 7253,
     /* 1698172 */     GIR_EraseRootFromParent_Done,
     /* 1698173 */   // Label 23266: @1698173
     /* 1698173 */   GIM_Try, /*On fail goto*//*Label 23267*/ GIMT_Encode4(1698259), // Rule ID 7256 //
     /* 1698178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698224 */     // MIs[0] policy
     /* 1698224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698258 */     // GIR_Coverage, 7256,
     /* 1698258 */     GIR_EraseRootFromParent_Done,
     /* 1698259 */   // Label 23267: @1698259
     /* 1698259 */   GIM_Try, /*On fail goto*//*Label 23268*/ GIMT_Encode4(1698345), // Rule ID 7257 //
     /* 1698264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1698275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1698278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1698281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698310 */     // MIs[0] policy
     /* 1698310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1698323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698344 */     // GIR_Coverage, 7257,
     /* 1698344 */     GIR_EraseRootFromParent_Done,
     /* 1698345 */   // Label 23268: @1698345
     /* 1698345 */   GIM_Try, /*On fail goto*//*Label 23269*/ GIMT_Encode4(1698431), // Rule ID 7260 //
     /* 1698350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698396 */     // MIs[0] policy
     /* 1698396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698430 */     // GIR_Coverage, 7260,
     /* 1698430 */     GIR_EraseRootFromParent_Done,
     /* 1698431 */   // Label 23269: @1698431
     /* 1698431 */   GIM_Try, /*On fail goto*//*Label 23270*/ GIMT_Encode4(1698517), // Rule ID 7261 //
     /* 1698436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1698447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1698450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1698453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698482 */     // MIs[0] policy
     /* 1698482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698492 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1698495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698516 */     // GIR_Coverage, 7261,
     /* 1698516 */     GIR_EraseRootFromParent_Done,
     /* 1698517 */   // Label 23270: @1698517
     /* 1698517 */   GIM_Try, /*On fail goto*//*Label 23271*/ GIMT_Encode4(1698603), // Rule ID 7264 //
     /* 1698522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1698525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1698533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1698536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1698539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1698542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698568 */     // MIs[0] policy
     /* 1698568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698578 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698602 */     // GIR_Coverage, 7264,
     /* 1698602 */     GIR_EraseRootFromParent_Done,
     /* 1698603 */   // Label 23271: @1698603
     /* 1698603 */   GIM_Try, /*On fail goto*//*Label 23272*/ GIMT_Encode4(1698689), // Rule ID 7265 //
     /* 1698608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1698611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1698616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1698619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1698622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1698625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1698628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1698638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1698650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698654 */     // MIs[0] policy
     /* 1698654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698664 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1698667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1698685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698688 */     // GIR_Coverage, 7265,
     /* 1698688 */     GIR_EraseRootFromParent_Done,
     /* 1698689 */   // Label 23272: @1698689
     /* 1698689 */   GIM_Try, /*On fail goto*//*Label 23273*/ GIMT_Encode4(1698775), // Rule ID 7444 //
     /* 1698694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1698705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1698708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1698711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1698714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698740 */     // MIs[0] policy
     /* 1698740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698750 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1698753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698774 */     // GIR_Coverage, 7444,
     /* 1698774 */     GIR_EraseRootFromParent_Done,
     /* 1698775 */   // Label 23273: @1698775
     /* 1698775 */   GIM_Try, /*On fail goto*//*Label 23274*/ GIMT_Encode4(1698861), // Rule ID 7445 //
     /* 1698780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1698791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1698794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1698797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1698800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698826 */     // MIs[0] policy
     /* 1698826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698836 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1698839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698860 */     // GIR_Coverage, 7445,
     /* 1698860 */     GIR_EraseRootFromParent_Done,
     /* 1698861 */   // Label 23274: @1698861
     /* 1698861 */   GIM_Try, /*On fail goto*//*Label 23275*/ GIMT_Encode4(1698947), // Rule ID 7448 //
     /* 1698866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1698877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1698880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1698883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1698886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698912 */     // MIs[0] policy
     /* 1698912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698922 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1698925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698946 */     // GIR_Coverage, 7448,
     /* 1698946 */     GIR_EraseRootFromParent_Done,
     /* 1698947 */   // Label 23275: @1698947
     /* 1698947 */   GIM_Try, /*On fail goto*//*Label 23276*/ GIMT_Encode4(1699033), // Rule ID 7449 //
     /* 1698952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1698960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1698963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1698966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1698969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1698972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698998 */     // MIs[0] policy
     /* 1698998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699008 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699032 */     // GIR_Coverage, 7449,
     /* 1699032 */     GIR_EraseRootFromParent_Done,
     /* 1699033 */   // Label 23276: @1699033
     /* 1699033 */   GIM_Try, /*On fail goto*//*Label 23277*/ GIMT_Encode4(1699119), // Rule ID 7452 //
     /* 1699038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699084 */     // MIs[0] policy
     /* 1699084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699094 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699118 */     // GIR_Coverage, 7452,
     /* 1699118 */     GIR_EraseRootFromParent_Done,
     /* 1699119 */   // Label 23277: @1699119
     /* 1699119 */   GIM_Try, /*On fail goto*//*Label 23278*/ GIMT_Encode4(1699205), // Rule ID 7453 //
     /* 1699124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1699135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1699138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1699141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1699144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699170 */     // MIs[0] policy
     /* 1699170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699204 */     // GIR_Coverage, 7453,
     /* 1699204 */     GIR_EraseRootFromParent_Done,
     /* 1699205 */   // Label 23278: @1699205
     /* 1699205 */   GIM_Try, /*On fail goto*//*Label 23279*/ GIMT_Encode4(1699291), // Rule ID 7456 //
     /* 1699210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699256 */     // MIs[0] policy
     /* 1699256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699266 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1699269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699290 */     // GIR_Coverage, 7456,
     /* 1699290 */     GIR_EraseRootFromParent_Done,
     /* 1699291 */   // Label 23279: @1699291
     /* 1699291 */   GIM_Try, /*On fail goto*//*Label 23280*/ GIMT_Encode4(1699377), // Rule ID 7457 //
     /* 1699296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1699307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1699310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1699313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1699316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699342 */     // MIs[0] policy
     /* 1699342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699352 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1699355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699376 */     // GIR_Coverage, 7457,
     /* 1699376 */     GIR_EraseRootFromParent_Done,
     /* 1699377 */   // Label 23280: @1699377
     /* 1699377 */   GIM_Try, /*On fail goto*//*Label 23281*/ GIMT_Encode4(1699463), // Rule ID 7460 //
     /* 1699382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1699402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699428 */     // MIs[0] policy
     /* 1699428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699438 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1699441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699462 */     // GIR_Coverage, 7460,
     /* 1699462 */     GIR_EraseRootFromParent_Done,
     /* 1699463 */   // Label 23281: @1699463
     /* 1699463 */   GIM_Try, /*On fail goto*//*Label 23282*/ GIMT_Encode4(1699549), // Rule ID 7461 //
     /* 1699468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1699479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1699482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1699485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1699488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699514 */     // MIs[0] policy
     /* 1699514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699524 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1699527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699548 */     // GIR_Coverage, 7461,
     /* 1699548 */     GIR_EraseRootFromParent_Done,
     /* 1699549 */   // Label 23282: @1699549
     /* 1699549 */   GIM_Try, /*On fail goto*//*Label 23283*/ GIMT_Encode4(1699635), // Rule ID 7464 //
     /* 1699554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1699565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1699568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1699571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1699574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1699577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699600 */     // MIs[0] policy
     /* 1699600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699610 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1699613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699634 */     // GIR_Coverage, 7464,
     /* 1699634 */     GIR_EraseRootFromParent_Done,
     /* 1699635 */   // Label 23283: @1699635
     /* 1699635 */   GIM_Try, /*On fail goto*//*Label 23284*/ GIMT_Encode4(1699721), // Rule ID 7465 //
     /* 1699640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1699651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1699654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1699657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1699660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1699663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699686 */     // MIs[0] policy
     /* 1699686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699696 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1699699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699720 */     // GIR_Coverage, 7465,
     /* 1699720 */     GIR_EraseRootFromParent_Done,
     /* 1699721 */   // Label 23284: @1699721
     /* 1699721 */   GIM_Try, /*On fail goto*//*Label 23285*/ GIMT_Encode4(1699807), // Rule ID 7468 //
     /* 1699726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1699737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1699740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1699743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1699746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699772 */     // MIs[0] policy
     /* 1699772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699782 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699806 */     // GIR_Coverage, 7468,
     /* 1699806 */     GIR_EraseRootFromParent_Done,
     /* 1699807 */   // Label 23285: @1699807
     /* 1699807 */   GIM_Try, /*On fail goto*//*Label 23286*/ GIMT_Encode4(1699893), // Rule ID 7469 //
     /* 1699812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1699823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1699826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1699829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1699832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699858 */     // MIs[0] policy
     /* 1699858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699868 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1699871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699892 */     // GIR_Coverage, 7469,
     /* 1699892 */     GIR_EraseRootFromParent_Done,
     /* 1699893 */   // Label 23286: @1699893
     /* 1699893 */   GIM_Try, /*On fail goto*//*Label 23287*/ GIMT_Encode4(1699979), // Rule ID 7472 //
     /* 1699898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1699909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1699912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1699915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1699918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699944 */     // MIs[0] policy
     /* 1699944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699954 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1699957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699978 */     // GIR_Coverage, 7472,
     /* 1699978 */     GIR_EraseRootFromParent_Done,
     /* 1699979 */   // Label 23287: @1699979
     /* 1699979 */   GIM_Try, /*On fail goto*//*Label 23288*/ GIMT_Encode4(1700065), // Rule ID 7473 //
     /* 1699984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1699992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1699995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1699998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1700001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1700004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700030 */     // MIs[0] policy
     /* 1700030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700040 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700064 */     // GIR_Coverage, 7473,
     /* 1700064 */     GIR_EraseRootFromParent_Done,
     /* 1700065 */   // Label 23288: @1700065
     /* 1700065 */   GIM_Try, /*On fail goto*//*Label 23289*/ GIMT_Encode4(1700151), // Rule ID 7476 //
     /* 1700070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700116 */     // MIs[0] policy
     /* 1700116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700150 */     // GIR_Coverage, 7476,
     /* 1700150 */     GIR_EraseRootFromParent_Done,
     /* 1700151 */   // Label 23289: @1700151
     /* 1700151 */   GIM_Try, /*On fail goto*//*Label 23290*/ GIMT_Encode4(1700237), // Rule ID 7477 //
     /* 1700156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1700167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1700170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1700173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1700176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700202 */     // MIs[0] policy
     /* 1700202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700212 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700236 */     // GIR_Coverage, 7477,
     /* 1700236 */     GIR_EraseRootFromParent_Done,
     /* 1700237 */   // Label 23290: @1700237
     /* 1700237 */   GIM_Try, /*On fail goto*//*Label 23291*/ GIMT_Encode4(1700323), // Rule ID 7480 //
     /* 1700242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1700262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700288 */     // MIs[0] policy
     /* 1700288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700322 */     // GIR_Coverage, 7480,
     /* 1700322 */     GIR_EraseRootFromParent_Done,
     /* 1700323 */   // Label 23291: @1700323
     /* 1700323 */   GIM_Try, /*On fail goto*//*Label 23292*/ GIMT_Encode4(1700409), // Rule ID 7481 //
     /* 1700328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1700339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1700342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1700345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1700348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700374 */     // MIs[0] policy
     /* 1700374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700384 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700408 */     // GIR_Coverage, 7481,
     /* 1700408 */     GIR_EraseRootFromParent_Done,
     /* 1700409 */   // Label 23292: @1700409
     /* 1700409 */   GIM_Try, /*On fail goto*//*Label 23293*/ GIMT_Encode4(1700495), // Rule ID 7484 //
     /* 1700414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1700434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700460 */     // MIs[0] policy
     /* 1700460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700470 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700494 */     // GIR_Coverage, 7484,
     /* 1700494 */     GIR_EraseRootFromParent_Done,
     /* 1700495 */   // Label 23293: @1700495
     /* 1700495 */   GIM_Try, /*On fail goto*//*Label 23294*/ GIMT_Encode4(1700581), // Rule ID 7485 //
     /* 1700500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1700511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1700514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1700517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1700520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700546 */     // MIs[0] policy
     /* 1700546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1700559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700580 */     // GIR_Coverage, 7485,
     /* 1700580 */     GIR_EraseRootFromParent_Done,
     /* 1700581 */   // Label 23294: @1700581
     /* 1700581 */   GIM_Try, /*On fail goto*//*Label 23295*/ GIMT_Encode4(1700667), // Rule ID 7488 //
     /* 1700586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1700589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1700597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1700600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1700603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1700606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700632 */     // MIs[0] policy
     /* 1700632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700642 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700666 */     // GIR_Coverage, 7488,
     /* 1700666 */     GIR_EraseRootFromParent_Done,
     /* 1700667 */   // Label 23295: @1700667
     /* 1700667 */   GIM_Try, /*On fail goto*//*Label 23296*/ GIMT_Encode4(1700753), // Rule ID 7489 //
     /* 1700672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1700675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1700683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1700686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1700689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1700692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700718 */     // MIs[0] policy
     /* 1700718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700728 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1700731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700752 */     // GIR_Coverage, 7489,
     /* 1700752 */     GIR_EraseRootFromParent_Done,
     /* 1700753 */   // Label 23296: @1700753
     /* 1700753 */   GIM_Try, /*On fail goto*//*Label 23297*/ GIMT_Encode4(1700839), // Rule ID 7492 //
     /* 1700758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1700761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1700769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1700772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1700775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1700778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700804 */     // MIs[0] policy
     /* 1700804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700838 */     // GIR_Coverage, 7492,
     /* 1700838 */     GIR_EraseRootFromParent_Done,
     /* 1700839 */   // Label 23297: @1700839
     /* 1700839 */   GIM_Try, /*On fail goto*//*Label 23298*/ GIMT_Encode4(1700925), // Rule ID 7493 //
     /* 1700844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1700847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1700855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1700858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1700861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1700864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700890 */     // MIs[0] policy
     /* 1700890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1700903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1700921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700924 */     // GIR_Coverage, 7493,
     /* 1700924 */     GIR_EraseRootFromParent_Done,
     /* 1700925 */   // Label 23298: @1700925
     /* 1700925 */   GIM_Try, /*On fail goto*//*Label 23299*/ GIMT_Encode4(1701011), // Rule ID 7496 //
     /* 1700930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1700933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1700938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1700941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1700944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1700947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1700950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700976 */     // MIs[0] policy
     /* 1700976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1700989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701010 */     // GIR_Coverage, 7496,
     /* 1701010 */     GIR_EraseRootFromParent_Done,
     /* 1701011 */   // Label 23299: @1701011
     /* 1701011 */   GIM_Try, /*On fail goto*//*Label 23300*/ GIMT_Encode4(1701097), // Rule ID 7497 //
     /* 1701016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1701027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1701030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1701033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1701036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701062 */     // MIs[0] policy
     /* 1701062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1701075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701096 */     // GIR_Coverage, 7497,
     /* 1701096 */     GIR_EraseRootFromParent_Done,
     /* 1701097 */   // Label 23300: @1701097
     /* 1701097 */   GIM_Try, /*On fail goto*//*Label 23301*/ GIMT_Encode4(1701183), // Rule ID 7500 //
     /* 1701102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701148 */     // MIs[0] policy
     /* 1701148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701182 */     // GIR_Coverage, 7500,
     /* 1701182 */     GIR_EraseRootFromParent_Done,
     /* 1701183 */   // Label 23301: @1701183
     /* 1701183 */   GIM_Try, /*On fail goto*//*Label 23302*/ GIMT_Encode4(1701269), // Rule ID 7501 //
     /* 1701188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1701199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1701202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1701205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1701208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701234 */     // MIs[0] policy
     /* 1701234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701244 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1701247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701268 */     // GIR_Coverage, 7501,
     /* 1701268 */     GIR_EraseRootFromParent_Done,
     /* 1701269 */   // Label 23302: @1701269
     /* 1701269 */   GIM_Try, /*On fail goto*//*Label 23303*/ GIMT_Encode4(1701355), // Rule ID 7504 //
     /* 1701274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701320 */     // MIs[0] policy
     /* 1701320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701330 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1701333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701354 */     // GIR_Coverage, 7504,
     /* 1701354 */     GIR_EraseRootFromParent_Done,
     /* 1701355 */   // Label 23303: @1701355
     /* 1701355 */   GIM_Try, /*On fail goto*//*Label 23304*/ GIMT_Encode4(1701441), // Rule ID 7505 //
     /* 1701360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1701371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1701374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1701377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701406 */     // MIs[0] policy
     /* 1701406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701416 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1701419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701440 */     // GIR_Coverage, 7505,
     /* 1701440 */     GIR_EraseRootFromParent_Done,
     /* 1701441 */   // Label 23304: @1701441
     /* 1701441 */   GIM_Try, /*On fail goto*//*Label 23305*/ GIMT_Encode4(1701527), // Rule ID 7508 //
     /* 1701446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1701457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1701460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1701463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701492 */     // MIs[0] policy
     /* 1701492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1701505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701526 */     // GIR_Coverage, 7508,
     /* 1701526 */     GIR_EraseRootFromParent_Done,
     /* 1701527 */   // Label 23305: @1701527
     /* 1701527 */   GIM_Try, /*On fail goto*//*Label 23306*/ GIMT_Encode4(1701613), // Rule ID 7509 //
     /* 1701532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1701543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1701546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1701549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701578 */     // MIs[0] policy
     /* 1701578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701588 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1701591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701612 */     // GIR_Coverage, 7509,
     /* 1701612 */     GIR_EraseRootFromParent_Done,
     /* 1701613 */   // Label 23306: @1701613
     /* 1701613 */   GIM_Try, /*On fail goto*//*Label 23307*/ GIMT_Encode4(1701699), // Rule ID 7512 //
     /* 1701618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1701629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1701632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1701635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701664 */     // MIs[0] policy
     /* 1701664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701674 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1701677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701698 */     // GIR_Coverage, 7512,
     /* 1701698 */     GIR_EraseRootFromParent_Done,
     /* 1701699 */   // Label 23307: @1701699
     /* 1701699 */   GIM_Try, /*On fail goto*//*Label 23308*/ GIMT_Encode4(1701785), // Rule ID 7513 //
     /* 1701704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1701715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1701718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1701721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701750 */     // MIs[0] policy
     /* 1701750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701760 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1701763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701784 */     // GIR_Coverage, 7513,
     /* 1701784 */     GIR_EraseRootFromParent_Done,
     /* 1701785 */   // Label 23308: @1701785
     /* 1701785 */   GIM_Try, /*On fail goto*//*Label 23309*/ GIMT_Encode4(1701871), // Rule ID 7516 //
     /* 1701790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1701801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1701804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1701807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701836 */     // MIs[0] policy
     /* 1701836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701846 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1701849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701870 */     // GIR_Coverage, 7516,
     /* 1701870 */     GIR_EraseRootFromParent_Done,
     /* 1701871 */   // Label 23309: @1701871
     /* 1701871 */   GIM_Try, /*On fail goto*//*Label 23310*/ GIMT_Encode4(1701957), // Rule ID 7517 //
     /* 1701876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1701887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1701890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1701893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701922 */     // MIs[0] policy
     /* 1701922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11494:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1701935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1701953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701956 */     // GIR_Coverage, 7517,
     /* 1701956 */     GIR_EraseRootFromParent_Done,
     /* 1701957 */   // Label 23310: @1701957
     /* 1701957 */   GIM_Try, /*On fail goto*//*Label 23311*/ GIMT_Encode4(1702043), // Rule ID 7520 //
     /* 1701962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1701970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1701973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1701976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1701979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702008 */     // MIs[0] policy
     /* 1702008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702042 */     // GIR_Coverage, 7520,
     /* 1702042 */     GIR_EraseRootFromParent_Done,
     /* 1702043 */   // Label 23311: @1702043
     /* 1702043 */   GIM_Try, /*On fail goto*//*Label 23312*/ GIMT_Encode4(1702129), // Rule ID 7521 //
     /* 1702048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1702059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1702062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1702065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1702071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702094 */     // MIs[0] policy
     /* 1702094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702128 */     // GIR_Coverage, 7521,
     /* 1702128 */     GIR_EraseRootFromParent_Done,
     /* 1702129 */   // Label 23312: @1702129
     /* 1702129 */   GIM_Try, /*On fail goto*//*Label 23313*/ GIMT_Encode4(1702215), // Rule ID 7524 //
     /* 1702134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702180 */     // MIs[0] policy
     /* 1702180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702190 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1702193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702214 */     // GIR_Coverage, 7524,
     /* 1702214 */     GIR_EraseRootFromParent_Done,
     /* 1702215 */   // Label 23313: @1702215
     /* 1702215 */   GIM_Try, /*On fail goto*//*Label 23314*/ GIMT_Encode4(1702301), // Rule ID 7525 //
     /* 1702220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1702231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1702234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1702237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1702243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702266 */     // MIs[0] policy
     /* 1702266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702276 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1702279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702300 */     // GIR_Coverage, 7525,
     /* 1702300 */     GIR_EraseRootFromParent_Done,
     /* 1702301 */   // Label 23314: @1702301
     /* 1702301 */   GIM_Try, /*On fail goto*//*Label 23315*/ GIMT_Encode4(1702387), // Rule ID 7528 //
     /* 1702306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702352 */     // MIs[0] policy
     /* 1702352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702362 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702386 */     // GIR_Coverage, 7528,
     /* 1702386 */     GIR_EraseRootFromParent_Done,
     /* 1702387 */   // Label 23315: @1702387
     /* 1702387 */   GIM_Try, /*On fail goto*//*Label 23316*/ GIMT_Encode4(1702473), // Rule ID 7529 //
     /* 1702392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1702409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702438 */     // MIs[0] policy
     /* 1702438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702448 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1702451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702472 */     // GIR_Coverage, 7529,
     /* 1702472 */     GIR_EraseRootFromParent_Done,
     /* 1702473 */   // Label 23316: @1702473
     /* 1702473 */   GIM_Try, /*On fail goto*//*Label 23317*/ GIMT_Encode4(1702559), // Rule ID 7532 //
     /* 1702478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1702495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702524 */     // MIs[0] policy
     /* 1702524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1702537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702558 */     // GIR_Coverage, 7532,
     /* 1702558 */     GIR_EraseRootFromParent_Done,
     /* 1702559 */   // Label 23317: @1702559
     /* 1702559 */   GIM_Try, /*On fail goto*//*Label 23318*/ GIMT_Encode4(1702645), // Rule ID 7533 //
     /* 1702564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1702575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1702578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1702581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702610 */     // MIs[0] policy
     /* 1702610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702620 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1702623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702644 */     // GIR_Coverage, 7533,
     /* 1702644 */     GIR_EraseRootFromParent_Done,
     /* 1702645 */   // Label 23318: @1702645
     /* 1702645 */   GIM_Try, /*On fail goto*//*Label 23319*/ GIMT_Encode4(1702731), // Rule ID 7536 //
     /* 1702650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1702661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1702664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1702667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702696 */     // MIs[0] policy
     /* 1702696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1702709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702730 */     // GIR_Coverage, 7536,
     /* 1702730 */     GIR_EraseRootFromParent_Done,
     /* 1702731 */   // Label 23319: @1702731
     /* 1702731 */   GIM_Try, /*On fail goto*//*Label 23320*/ GIMT_Encode4(1702817), // Rule ID 7537 //
     /* 1702736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1702747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1702750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1702753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702782 */     // MIs[0] policy
     /* 1702782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702792 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11494:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1702795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702816 */     // GIR_Coverage, 7537,
     /* 1702816 */     GIR_EraseRootFromParent_Done,
     /* 1702817 */   // Label 23320: @1702817
     /* 1702817 */   GIM_Try, /*On fail goto*//*Label 23321*/ GIMT_Encode4(1702903), // Rule ID 7540 //
     /* 1702822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1702833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1702836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1702839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702868 */     // MIs[0] policy
     /* 1702868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702878 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702902 */     // GIR_Coverage, 7540,
     /* 1702902 */     GIR_EraseRootFromParent_Done,
     /* 1702903 */   // Label 23321: @1702903
     /* 1702903 */   GIM_Try, /*On fail goto*//*Label 23322*/ GIMT_Encode4(1702989), // Rule ID 7541 //
     /* 1702908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1702916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1702919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1702922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1702925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702954 */     // MIs[0] policy
     /* 1702954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1702967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1702985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702988 */     // GIR_Coverage, 7541,
     /* 1702988 */     GIR_EraseRootFromParent_Done,
     /* 1702989 */   // Label 23322: @1702989
     /* 1702989 */   GIM_Try, /*On fail goto*//*Label 23323*/ GIMT_Encode4(1703075), // Rule ID 7544 //
     /* 1702994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703040 */     // MIs[0] policy
     /* 1703040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703050 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703074 */     // GIR_Coverage, 7544,
     /* 1703074 */     GIR_EraseRootFromParent_Done,
     /* 1703075 */   // Label 23323: @1703075
     /* 1703075 */   GIM_Try, /*On fail goto*//*Label 23324*/ GIMT_Encode4(1703161), // Rule ID 7545 //
     /* 1703080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1703091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1703094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1703097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1703103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703126 */     // MIs[0] policy
     /* 1703126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703160 */     // GIR_Coverage, 7545,
     /* 1703160 */     GIR_EraseRootFromParent_Done,
     /* 1703161 */   // Label 23324: @1703161
     /* 1703161 */   GIM_Try, /*On fail goto*//*Label 23325*/ GIMT_Encode4(1703247), // Rule ID 7548 //
     /* 1703166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703212 */     // MIs[0] policy
     /* 1703212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703222 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703246 */     // GIR_Coverage, 7548,
     /* 1703246 */     GIR_EraseRootFromParent_Done,
     /* 1703247 */   // Label 23325: @1703247
     /* 1703247 */   GIM_Try, /*On fail goto*//*Label 23326*/ GIMT_Encode4(1703333), // Rule ID 7549 //
     /* 1703252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703298 */     // MIs[0] policy
     /* 1703298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703308 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1703311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703332 */     // GIR_Coverage, 7549,
     /* 1703332 */     GIR_EraseRootFromParent_Done,
     /* 1703333 */   // Label 23326: @1703333
     /* 1703333 */   GIM_Try, /*On fail goto*//*Label 23327*/ GIMT_Encode4(1703419), // Rule ID 7552 //
     /* 1703338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703384 */     // MIs[0] policy
     /* 1703384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703418 */     // GIR_Coverage, 7552,
     /* 1703418 */     GIR_EraseRootFromParent_Done,
     /* 1703419 */   // Label 23327: @1703419
     /* 1703419 */   GIM_Try, /*On fail goto*//*Label 23328*/ GIMT_Encode4(1703505), // Rule ID 7553 //
     /* 1703424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1703441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703470 */     // MIs[0] policy
     /* 1703470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11494:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1703483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703504 */     // GIR_Coverage, 7553,
     /* 1703504 */     GIR_EraseRootFromParent_Done,
     /* 1703505 */   // Label 23328: @1703505
     /* 1703505 */   GIM_Try, /*On fail goto*//*Label 23329*/ GIMT_Encode4(1703591), // Rule ID 7556 //
     /* 1703510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1703527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703556 */     // MIs[0] policy
     /* 1703556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1703569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703590 */     // GIR_Coverage, 7556,
     /* 1703590 */     GIR_EraseRootFromParent_Done,
     /* 1703591 */   // Label 23329: @1703591
     /* 1703591 */   GIM_Try, /*On fail goto*//*Label 23330*/ GIMT_Encode4(1703677), // Rule ID 7557 //
     /* 1703596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1703607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1703610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1703613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1703626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1703630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703642 */     // MIs[0] policy
     /* 1703642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11494:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1703655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703676 */     // GIR_Coverage, 7557,
     /* 1703676 */     GIR_EraseRootFromParent_Done,
     /* 1703677 */   // Label 23330: @1703677
     /* 1703677 */   GIM_Try, /*On fail goto*//*Label 23331*/ GIMT_Encode4(1703763), // Rule ID 7560 //
     /* 1703682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1703685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1703693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1703696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1703699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1703702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703728 */     // MIs[0] policy
     /* 1703728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703738 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703762 */     // GIR_Coverage, 7560,
     /* 1703762 */     GIR_EraseRootFromParent_Done,
     /* 1703763 */   // Label 23331: @1703763
     /* 1703763 */   GIM_Try, /*On fail goto*//*Label 23332*/ GIMT_Encode4(1703849), // Rule ID 7561 //
     /* 1703768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1703771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1703776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1703779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1703782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1703785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1703788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1703798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1703802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1703806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1703810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703814 */     // MIs[0] policy
     /* 1703814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703824 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11494:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1703827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703848 */     // GIR_Coverage, 7561,
     /* 1703848 */     GIR_EraseRootFromParent_Done,
     /* 1703849 */   // Label 23332: @1703849
     /* 1703849 */   GIM_Try, /*On fail goto*//*Label 23333*/ GIMT_Encode4(1703935), // Rule ID 7624 //
     /* 1703854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1703865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1703868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1703871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1703874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703900 */     // MIs[0] policy
     /* 1703900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703910 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1703913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703934 */     // GIR_Coverage, 7624,
     /* 1703934 */     GIR_EraseRootFromParent_Done,
     /* 1703935 */   // Label 23333: @1703935
     /* 1703935 */   GIM_Try, /*On fail goto*//*Label 23334*/ GIMT_Encode4(1704021), // Rule ID 7625 //
     /* 1703940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1703948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1703951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1703954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1703957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1703960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703986 */     // MIs[0] policy
     /* 1703986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1703999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704020 */     // GIR_Coverage, 7625,
     /* 1704020 */     GIR_EraseRootFromParent_Done,
     /* 1704021 */   // Label 23334: @1704021
     /* 1704021 */   GIM_Try, /*On fail goto*//*Label 23335*/ GIMT_Encode4(1704107), // Rule ID 7628 //
     /* 1704026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704072 */     // MIs[0] policy
     /* 1704072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704082 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704106 */     // GIR_Coverage, 7628,
     /* 1704106 */     GIR_EraseRootFromParent_Done,
     /* 1704107 */   // Label 23335: @1704107
     /* 1704107 */   GIM_Try, /*On fail goto*//*Label 23336*/ GIMT_Encode4(1704193), // Rule ID 7629 //
     /* 1704112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1704123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1704126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1704129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1704132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1704135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704158 */     // MIs[0] policy
     /* 1704158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704192 */     // GIR_Coverage, 7629,
     /* 1704192 */     GIR_EraseRootFromParent_Done,
     /* 1704193 */   // Label 23336: @1704193
     /* 1704193 */   GIM_Try, /*On fail goto*//*Label 23337*/ GIMT_Encode4(1704279), // Rule ID 7632 //
     /* 1704198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704244 */     // MIs[0] policy
     /* 1704244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704254 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1704257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704278 */     // GIR_Coverage, 7632,
     /* 1704278 */     GIR_EraseRootFromParent_Done,
     /* 1704279 */   // Label 23337: @1704279
     /* 1704279 */   GIM_Try, /*On fail goto*//*Label 23338*/ GIMT_Encode4(1704365), // Rule ID 7633 //
     /* 1704284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1704295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1704298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1704301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1704304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1704307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704330 */     // MIs[0] policy
     /* 1704330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704340 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1704343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704364 */     // GIR_Coverage, 7633,
     /* 1704364 */     GIR_EraseRootFromParent_Done,
     /* 1704365 */   // Label 23338: @1704365
     /* 1704365 */   GIM_Try, /*On fail goto*//*Label 23339*/ GIMT_Encode4(1704451), // Rule ID 7636 //
     /* 1704370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1704390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704416 */     // MIs[0] policy
     /* 1704416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1704429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704450 */     // GIR_Coverage, 7636,
     /* 1704450 */     GIR_EraseRootFromParent_Done,
     /* 1704451 */   // Label 23339: @1704451
     /* 1704451 */   GIM_Try, /*On fail goto*//*Label 23340*/ GIMT_Encode4(1704537), // Rule ID 7637 //
     /* 1704456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1704467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1704470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1704476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704502 */     // MIs[0] policy
     /* 1704502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704512 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1704515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704536 */     // GIR_Coverage, 7637,
     /* 1704536 */     GIR_EraseRootFromParent_Done,
     /* 1704537 */   // Label 23340: @1704537
     /* 1704537 */   GIM_Try, /*On fail goto*//*Label 23341*/ GIMT_Encode4(1704623), // Rule ID 7640 //
     /* 1704542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1704553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1704556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1704559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1704562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704588 */     // MIs[0] policy
     /* 1704588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704598 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1704601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704622 */     // GIR_Coverage, 7640,
     /* 1704622 */     GIR_EraseRootFromParent_Done,
     /* 1704623 */   // Label 23341: @1704623
     /* 1704623 */   GIM_Try, /*On fail goto*//*Label 23342*/ GIMT_Encode4(1704709), // Rule ID 7641 //
     /* 1704628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1704639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1704642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1704645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1704648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704674 */     // MIs[0] policy
     /* 1704674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704684 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1704687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704708 */     // GIR_Coverage, 7641,
     /* 1704708 */     GIR_EraseRootFromParent_Done,
     /* 1704709 */   // Label 23342: @1704709
     /* 1704709 */   GIM_Try, /*On fail goto*//*Label 23343*/ GIMT_Encode4(1704795), // Rule ID 7644 //
     /* 1704714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1704725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1704728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1704731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1704734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1704737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704760 */     // MIs[0] policy
     /* 1704760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704770 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1704773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704794 */     // GIR_Coverage, 7644,
     /* 1704794 */     GIR_EraseRootFromParent_Done,
     /* 1704795 */   // Label 23343: @1704795
     /* 1704795 */   GIM_Try, /*On fail goto*//*Label 23344*/ GIMT_Encode4(1704881), // Rule ID 7645 //
     /* 1704800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1704811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1704814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1704817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1704820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1704823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704846 */     // MIs[0] policy
     /* 1704846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704856 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1704859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704880 */     // GIR_Coverage, 7645,
     /* 1704880 */     GIR_EraseRootFromParent_Done,
     /* 1704881 */   // Label 23344: @1704881
     /* 1704881 */   GIM_Try, /*On fail goto*//*Label 23345*/ GIMT_Encode4(1704967), // Rule ID 7648 //
     /* 1704886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1704897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1704900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1704903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1704906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704932 */     // MIs[0] policy
     /* 1704932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704942 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1704945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704966 */     // GIR_Coverage, 7648,
     /* 1704966 */     GIR_EraseRootFromParent_Done,
     /* 1704967 */   // Label 23345: @1704967
     /* 1704967 */   GIM_Try, /*On fail goto*//*Label 23346*/ GIMT_Encode4(1705053), // Rule ID 7649 //
     /* 1704972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1704980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1704983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1704986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1704989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1704992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705018 */     // MIs[0] policy
     /* 1705018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705028 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1705031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705052 */     // GIR_Coverage, 7649,
     /* 1705052 */     GIR_EraseRootFromParent_Done,
     /* 1705053 */   // Label 23346: @1705053
     /* 1705053 */   GIM_Try, /*On fail goto*//*Label 23347*/ GIMT_Encode4(1705139), // Rule ID 7652 //
     /* 1705058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705104 */     // MIs[0] policy
     /* 1705104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705114 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705138 */     // GIR_Coverage, 7652,
     /* 1705138 */     GIR_EraseRootFromParent_Done,
     /* 1705139 */   // Label 23347: @1705139
     /* 1705139 */   GIM_Try, /*On fail goto*//*Label 23348*/ GIMT_Encode4(1705225), // Rule ID 7653 //
     /* 1705144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1705155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1705158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1705161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1705164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705190 */     // MIs[0] policy
     /* 1705190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705200 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705224 */     // GIR_Coverage, 7653,
     /* 1705224 */     GIR_EraseRootFromParent_Done,
     /* 1705225 */   // Label 23348: @1705225
     /* 1705225 */   GIM_Try, /*On fail goto*//*Label 23349*/ GIMT_Encode4(1705311), // Rule ID 7656 //
     /* 1705230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1705250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705276 */     // MIs[0] policy
     /* 1705276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705286 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705310 */     // GIR_Coverage, 7656,
     /* 1705310 */     GIR_EraseRootFromParent_Done,
     /* 1705311 */   // Label 23349: @1705311
     /* 1705311 */   GIM_Try, /*On fail goto*//*Label 23350*/ GIMT_Encode4(1705397), // Rule ID 7657 //
     /* 1705316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1705327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1705330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1705336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705362 */     // MIs[0] policy
     /* 1705362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705372 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705396 */     // GIR_Coverage, 7657,
     /* 1705396 */     GIR_EraseRootFromParent_Done,
     /* 1705397 */   // Label 23350: @1705397
     /* 1705397 */   GIM_Try, /*On fail goto*//*Label 23351*/ GIMT_Encode4(1705483), // Rule ID 7660 //
     /* 1705402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1705422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705448 */     // MIs[0] policy
     /* 1705448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705482 */     // GIR_Coverage, 7660,
     /* 1705482 */     GIR_EraseRootFromParent_Done,
     /* 1705483 */   // Label 23351: @1705483
     /* 1705483 */   GIM_Try, /*On fail goto*//*Label 23352*/ GIMT_Encode4(1705569), // Rule ID 7661 //
     /* 1705488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1705499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1705502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1705508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705534 */     // MIs[0] policy
     /* 1705534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1705547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705568 */     // GIR_Coverage, 7661,
     /* 1705568 */     GIR_EraseRootFromParent_Done,
     /* 1705569 */   // Label 23352: @1705569
     /* 1705569 */   GIM_Try, /*On fail goto*//*Label 23353*/ GIMT_Encode4(1705655), // Rule ID 7664 //
     /* 1705574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1705585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1705588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1705591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1705594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705620 */     // MIs[0] policy
     /* 1705620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705630 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1705633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705654 */     // GIR_Coverage, 7664,
     /* 1705654 */     GIR_EraseRootFromParent_Done,
     /* 1705655 */   // Label 23353: @1705655
     /* 1705655 */   GIM_Try, /*On fail goto*//*Label 23354*/ GIMT_Encode4(1705741), // Rule ID 7665 //
     /* 1705660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1705671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1705674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1705677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1705680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705706 */     // MIs[0] policy
     /* 1705706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705716 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1705719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705740 */     // GIR_Coverage, 7665,
     /* 1705740 */     GIR_EraseRootFromParent_Done,
     /* 1705741 */   // Label 23354: @1705741
     /* 1705741 */   GIM_Try, /*On fail goto*//*Label 23355*/ GIMT_Encode4(1705827), // Rule ID 7668 //
     /* 1705746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1705749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1705757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1705760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1705763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1705766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705792 */     // MIs[0] policy
     /* 1705792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705826 */     // GIR_Coverage, 7668,
     /* 1705826 */     GIR_EraseRootFromParent_Done,
     /* 1705827 */   // Label 23355: @1705827
     /* 1705827 */   GIM_Try, /*On fail goto*//*Label 23356*/ GIMT_Encode4(1705913), // Rule ID 7669 //
     /* 1705832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1705835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1705843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1705846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1705849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1705852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1705855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705878 */     // MIs[0] policy
     /* 1705878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1705891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705912 */     // GIR_Coverage, 7669,
     /* 1705912 */     GIR_EraseRootFromParent_Done,
     /* 1705913 */   // Label 23356: @1705913
     /* 1705913 */   GIM_Try, /*On fail goto*//*Label 23357*/ GIMT_Encode4(1705999), // Rule ID 7672 //
     /* 1705918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1705921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1705926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1705929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1705932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1705935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1705938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1705948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1705960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705964 */     // MIs[0] policy
     /* 1705964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1705977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705998 */     // GIR_Coverage, 7672,
     /* 1705998 */     GIR_EraseRootFromParent_Done,
     /* 1705999 */   // Label 23357: @1705999
     /* 1705999 */   GIM_Try, /*On fail goto*//*Label 23358*/ GIMT_Encode4(1706085), // Rule ID 7673 //
     /* 1706004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1706015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1706018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1706021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1706024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706050 */     // MIs[0] policy
     /* 1706050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1706063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706084 */     // GIR_Coverage, 7673,
     /* 1706084 */     GIR_EraseRootFromParent_Done,
     /* 1706085 */   // Label 23358: @1706085
     /* 1706085 */   GIM_Try, /*On fail goto*//*Label 23359*/ GIMT_Encode4(1706171), // Rule ID 7676 //
     /* 1706090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706136 */     // MIs[0] policy
     /* 1706136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706170 */     // GIR_Coverage, 7676,
     /* 1706170 */     GIR_EraseRootFromParent_Done,
     /* 1706171 */   // Label 23359: @1706171
     /* 1706171 */   GIM_Try, /*On fail goto*//*Label 23360*/ GIMT_Encode4(1706257), // Rule ID 7677 //
     /* 1706176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1706187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1706190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1706193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1706196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1706206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706222 */     // MIs[0] policy
     /* 1706222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1706235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706256 */     // GIR_Coverage, 7677,
     /* 1706256 */     GIR_EraseRootFromParent_Done,
     /* 1706257 */   // Label 23360: @1706257
     /* 1706257 */   GIM_Try, /*On fail goto*//*Label 23361*/ GIMT_Encode4(1706343), // Rule ID 7680 //
     /* 1706262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1706265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1706282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706308 */     // MIs[0] policy
     /* 1706308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706318 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706342 */     // GIR_Coverage, 7680,
     /* 1706342 */     GIR_EraseRootFromParent_Done,
     /* 1706343 */   // Label 23361: @1706343
     /* 1706343 */   GIM_Try, /*On fail goto*//*Label 23362*/ GIMT_Encode4(1706429), // Rule ID 7681 //
     /* 1706348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1706351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1706359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1706362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1706368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1706378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1706390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706394 */     // MIs[0] policy
     /* 1706394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1706407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1706425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706428 */     // GIR_Coverage, 7681,
     /* 1706428 */     GIR_EraseRootFromParent_Done,
     /* 1706429 */   // Label 23362: @1706429
     /* 1706429 */   GIM_Try, /*On fail goto*//*Label 23363*/ GIMT_Encode4(1706515), // Rule ID 7684 //
     /* 1706434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1706451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706480 */     // MIs[0] policy
     /* 1706480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1706493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706514 */     // GIR_Coverage, 7684,
     /* 1706514 */     GIR_EraseRootFromParent_Done,
     /* 1706515 */   // Label 23363: @1706515
     /* 1706515 */   GIM_Try, /*On fail goto*//*Label 23364*/ GIMT_Encode4(1706601), // Rule ID 7685 //
     /* 1706520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1706537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706566 */     // MIs[0] policy
     /* 1706566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706576 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1706579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706600 */     // GIR_Coverage, 7685,
     /* 1706600 */     GIR_EraseRootFromParent_Done,
     /* 1706601 */   // Label 23364: @1706601
     /* 1706601 */   GIM_Try, /*On fail goto*//*Label 23365*/ GIMT_Encode4(1706687), // Rule ID 7688 //
     /* 1706606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1706617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1706620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1706623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706652 */     // MIs[0] policy
     /* 1706652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706662 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1706665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706686 */     // GIR_Coverage, 7688,
     /* 1706686 */     GIR_EraseRootFromParent_Done,
     /* 1706687 */   // Label 23365: @1706687
     /* 1706687 */   GIM_Try, /*On fail goto*//*Label 23366*/ GIMT_Encode4(1706773), // Rule ID 7689 //
     /* 1706692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1706703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1706706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1706709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706738 */     // MIs[0] policy
     /* 1706738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706748 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1706751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706772 */     // GIR_Coverage, 7689,
     /* 1706772 */     GIR_EraseRootFromParent_Done,
     /* 1706773 */   // Label 23366: @1706773
     /* 1706773 */   GIM_Try, /*On fail goto*//*Label 23367*/ GIMT_Encode4(1706859), // Rule ID 7692 //
     /* 1706778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1706789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1706792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1706795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706824 */     // MIs[0] policy
     /* 1706824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706834 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1706837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706858 */     // GIR_Coverage, 7692,
     /* 1706858 */     GIR_EraseRootFromParent_Done,
     /* 1706859 */   // Label 23367: @1706859
     /* 1706859 */   GIM_Try, /*On fail goto*//*Label 23368*/ GIMT_Encode4(1706945), // Rule ID 7693 //
     /* 1706864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1706875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1706878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1706881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706910 */     // MIs[0] policy
     /* 1706910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706920 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1706923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706944 */     // GIR_Coverage, 7693,
     /* 1706944 */     GIR_EraseRootFromParent_Done,
     /* 1706945 */   // Label 23368: @1706945
     /* 1706945 */   GIM_Try, /*On fail goto*//*Label 23369*/ GIMT_Encode4(1707031), // Rule ID 7696 //
     /* 1706950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1706958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1706961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1706964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1706967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1706988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706996 */     // MIs[0] policy
     /* 1706996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707006 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707030 */     // GIR_Coverage, 7696,
     /* 1707030 */     GIR_EraseRootFromParent_Done,
     /* 1707031 */   // Label 23369: @1707031
     /* 1707031 */   GIM_Try, /*On fail goto*//*Label 23370*/ GIMT_Encode4(1707117), // Rule ID 7697 //
     /* 1707036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1707053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707082 */     // MIs[0] policy
     /* 1707082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707116 */     // GIR_Coverage, 7697,
     /* 1707116 */     GIR_EraseRootFromParent_Done,
     /* 1707117 */   // Label 23370: @1707117
     /* 1707117 */   GIM_Try, /*On fail goto*//*Label 23371*/ GIMT_Encode4(1707203), // Rule ID 7700 //
     /* 1707122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1707133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1707136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1707139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707168 */     // MIs[0] policy
     /* 1707168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707178 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1707181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707202 */     // GIR_Coverage, 7700,
     /* 1707202 */     GIR_EraseRootFromParent_Done,
     /* 1707203 */   // Label 23371: @1707203
     /* 1707203 */   GIM_Try, /*On fail goto*//*Label 23372*/ GIMT_Encode4(1707289), // Rule ID 7701 //
     /* 1707208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1707219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1707222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1707225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707254 */     // MIs[0] policy
     /* 1707254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1707267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707288 */     // GIR_Coverage, 7701,
     /* 1707288 */     GIR_EraseRootFromParent_Done,
     /* 1707289 */   // Label 23372: @1707289
     /* 1707289 */   GIM_Try, /*On fail goto*//*Label 23373*/ GIMT_Encode4(1707375), // Rule ID 7704 //
     /* 1707294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1707305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1707308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1707311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1707317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707340 */     // MIs[0] policy
     /* 1707340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707350 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1707353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707374 */     // GIR_Coverage, 7704,
     /* 1707374 */     GIR_EraseRootFromParent_Done,
     /* 1707375 */   // Label 23373: @1707375
     /* 1707375 */   GIM_Try, /*On fail goto*//*Label 23374*/ GIMT_Encode4(1707461), // Rule ID 7705 //
     /* 1707380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1707391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1707394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1707397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1707403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1707410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1707414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1707418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707426 */     // MIs[0] policy
     /* 1707426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707436 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1707439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707460 */     // GIR_Coverage, 7705,
     /* 1707460 */     GIR_EraseRootFromParent_Done,
     /* 1707461 */   // Label 23374: @1707461
     /* 1707461 */   GIM_Try, /*On fail goto*//*Label 23375*/ GIMT_Encode4(1707547), // Rule ID 7708 //
     /* 1707466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707512 */     // MIs[0] policy
     /* 1707512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707522 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707546 */     // GIR_Coverage, 7708,
     /* 1707546 */     GIR_EraseRootFromParent_Done,
     /* 1707547 */   // Label 23375: @1707547
     /* 1707547 */   GIM_Try, /*On fail goto*//*Label 23376*/ GIMT_Encode4(1707633), // Rule ID 7709 //
     /* 1707552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1707563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1707566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707598 */     // MIs[0] policy
     /* 1707598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707608 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1707611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707632 */     // GIR_Coverage, 7709,
     /* 1707632 */     GIR_EraseRootFromParent_Done,
     /* 1707633 */   // Label 23376: @1707633
     /* 1707633 */   GIM_Try, /*On fail goto*//*Label 23377*/ GIMT_Encode4(1707719), // Rule ID 7712 //
     /* 1707638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1707649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1707652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1707655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707684 */     // MIs[0] policy
     /* 1707684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1707697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707718 */     // GIR_Coverage, 7712,
     /* 1707718 */     GIR_EraseRootFromParent_Done,
     /* 1707719 */   // Label 23377: @1707719
     /* 1707719 */   GIM_Try, /*On fail goto*//*Label 23378*/ GIMT_Encode4(1707805), // Rule ID 7713 //
     /* 1707724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1707735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1707738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1707741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707770 */     // MIs[0] policy
     /* 1707770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1707783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707804 */     // GIR_Coverage, 7713,
     /* 1707804 */     GIR_EraseRootFromParent_Done,
     /* 1707805 */   // Label 23378: @1707805
     /* 1707805 */   GIM_Try, /*On fail goto*//*Label 23379*/ GIMT_Encode4(1707891), // Rule ID 7716 //
     /* 1707810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1707821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1707824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1707827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707856 */     // MIs[0] policy
     /* 1707856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707890 */     // GIR_Coverage, 7716,
     /* 1707890 */     GIR_EraseRootFromParent_Done,
     /* 1707891 */   // Label 23379: @1707891
     /* 1707891 */   GIM_Try, /*On fail goto*//*Label 23380*/ GIMT_Encode4(1707977), // Rule ID 7717 //
     /* 1707896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1707907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1707910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1707913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707942 */     // MIs[0] policy
     /* 1707942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707952 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1707955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707976 */     // GIR_Coverage, 7717,
     /* 1707976 */     GIR_EraseRootFromParent_Done,
     /* 1707977 */   // Label 23380: @1707977
     /* 1707977 */   GIM_Try, /*On fail goto*//*Label 23381*/ GIMT_Encode4(1708063), // Rule ID 7720 //
     /* 1707982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1707990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1707993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1707996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1707999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708028 */     // MIs[0] policy
     /* 1708028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708062 */     // GIR_Coverage, 7720,
     /* 1708062 */     GIR_EraseRootFromParent_Done,
     /* 1708063 */   // Label 23381: @1708063
     /* 1708063 */   GIM_Try, /*On fail goto*//*Label 23382*/ GIMT_Encode4(1708149), // Rule ID 7721 //
     /* 1708068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1708079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1708082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1708085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708114 */     // MIs[0] policy
     /* 1708114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708148 */     // GIR_Coverage, 7721,
     /* 1708148 */     GIR_EraseRootFromParent_Done,
     /* 1708149 */   // Label 23382: @1708149
     /* 1708149 */   GIM_Try, /*On fail goto*//*Label 23383*/ GIMT_Encode4(1708235), // Rule ID 7724 //
     /* 1708154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1708171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708200 */     // MIs[0] policy
     /* 1708200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708210 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708234 */     // GIR_Coverage, 7724,
     /* 1708234 */     GIR_EraseRootFromParent_Done,
     /* 1708235 */   // Label 23383: @1708235
     /* 1708235 */   GIM_Try, /*On fail goto*//*Label 23384*/ GIMT_Encode4(1708321), // Rule ID 7725 //
     /* 1708240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1708257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708286 */     // MIs[0] policy
     /* 1708286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708320 */     // GIR_Coverage, 7725,
     /* 1708320 */     GIR_EraseRootFromParent_Done,
     /* 1708321 */   // Label 23384: @1708321
     /* 1708321 */   GIM_Try, /*On fail goto*//*Label 23385*/ GIMT_Encode4(1708407), // Rule ID 7728 //
     /* 1708326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708372 */     // MIs[0] policy
     /* 1708372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708382 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708406 */     // GIR_Coverage, 7728,
     /* 1708406 */     GIR_EraseRootFromParent_Done,
     /* 1708407 */   // Label 23385: @1708407
     /* 1708407 */   GIM_Try, /*On fail goto*//*Label 23386*/ GIMT_Encode4(1708493), // Rule ID 7729 //
     /* 1708412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1708423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1708426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1708429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1708435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708458 */     // MIs[0] policy
     /* 1708458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1708471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708492 */     // GIR_Coverage, 7729,
     /* 1708492 */     GIR_EraseRootFromParent_Done,
     /* 1708493 */   // Label 23386: @1708493
     /* 1708493 */   GIM_Try, /*On fail goto*//*Label 23387*/ GIMT_Encode4(1708579), // Rule ID 7732 //
     /* 1708498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1708515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708544 */     // MIs[0] policy
     /* 1708544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708554 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1708557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708578 */     // GIR_Coverage, 7732,
     /* 1708578 */     GIR_EraseRootFromParent_Done,
     /* 1708579 */   // Label 23387: @1708579
     /* 1708579 */   GIM_Try, /*On fail goto*//*Label 23388*/ GIMT_Encode4(1708665), // Rule ID 7733 //
     /* 1708584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1708595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1708598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1708601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1708607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1708614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1708618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708630 */     // MIs[0] policy
     /* 1708630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1708643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708664 */     // GIR_Coverage, 7733,
     /* 1708664 */     GIR_EraseRootFromParent_Done,
     /* 1708665 */   // Label 23388: @1708665
     /* 1708665 */   GIM_Try, /*On fail goto*//*Label 23389*/ GIMT_Encode4(1708751), // Rule ID 7736 //
     /* 1708670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1708681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1708684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1708687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708716 */     // MIs[0] policy
     /* 1708716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708750 */     // GIR_Coverage, 7736,
     /* 1708750 */     GIR_EraseRootFromParent_Done,
     /* 1708751 */   // Label 23389: @1708751
     /* 1708751 */   GIM_Try, /*On fail goto*//*Label 23390*/ GIMT_Encode4(1708837), // Rule ID 7737 //
     /* 1708756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1708767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1708770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1708773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708802 */     // MIs[0] policy
     /* 1708802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1708815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708836 */     // GIR_Coverage, 7737,
     /* 1708836 */     GIR_EraseRootFromParent_Done,
     /* 1708837 */   // Label 23390: @1708837
     /* 1708837 */   GIM_Try, /*On fail goto*//*Label 23391*/ GIMT_Encode4(1708923), // Rule ID 7740 //
     /* 1708842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1708845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1708853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1708856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1708859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708888 */     // MIs[0] policy
     /* 1708888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708898 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1708919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708922 */     // GIR_Coverage, 7740,
     /* 1708922 */     GIR_EraseRootFromParent_Done,
     /* 1708923 */   // Label 23391: @1708923
     /* 1708923 */   GIM_Try, /*On fail goto*//*Label 23392*/ GIMT_Encode4(1709009), // Rule ID 7741 //
     /* 1708928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1708931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1708936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1708939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1708942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1708945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708974 */     // MIs[0] policy
     /* 1708974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1708987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709008 */     // GIR_Coverage, 7741,
     /* 1709008 */     GIR_EraseRootFromParent_Done,
     /* 1709009 */   // Label 23392: @1709009
     /* 1709009 */   GIM_Try, /*On fail goto*//*Label 23393*/ GIMT_Encode4(1709095), // Rule ID 10256 //
     /* 1709014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1709025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1709028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709060 */     // MIs[0] policy
     /* 1709060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709070 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1709073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709094 */     // GIR_Coverage, 10256,
     /* 1709094 */     GIR_EraseRootFromParent_Done,
     /* 1709095 */   // Label 23393: @1709095
     /* 1709095 */   GIM_Try, /*On fail goto*//*Label 23394*/ GIMT_Encode4(1709181), // Rule ID 10257 //
     /* 1709100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1709111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1709114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1709117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1709120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709146 */     // MIs[0] policy
     /* 1709146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709156 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1709159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709180 */     // GIR_Coverage, 10257,
     /* 1709180 */     GIR_EraseRootFromParent_Done,
     /* 1709181 */   // Label 23394: @1709181
     /* 1709181 */   GIM_Try, /*On fail goto*//*Label 23395*/ GIMT_Encode4(1709267), // Rule ID 10260 //
     /* 1709186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1709197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1709200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709232 */     // MIs[0] policy
     /* 1709232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709242 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709266 */     // GIR_Coverage, 10260,
     /* 1709266 */     GIR_EraseRootFromParent_Done,
     /* 1709267 */   // Label 23395: @1709267
     /* 1709267 */   GIM_Try, /*On fail goto*//*Label 23396*/ GIMT_Encode4(1709353), // Rule ID 10261 //
     /* 1709272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1709283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1709286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1709289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1709292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709318 */     // MIs[0] policy
     /* 1709318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709328 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709352 */     // GIR_Coverage, 10261,
     /* 1709352 */     GIR_EraseRootFromParent_Done,
     /* 1709353 */   // Label 23396: @1709353
     /* 1709353 */   GIM_Try, /*On fail goto*//*Label 23397*/ GIMT_Encode4(1709439), // Rule ID 10264 //
     /* 1709358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1709369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1709372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1709375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1709378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709404 */     // MIs[0] policy
     /* 1709404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709414 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709438 */     // GIR_Coverage, 10264,
     /* 1709438 */     GIR_EraseRootFromParent_Done,
     /* 1709439 */   // Label 23397: @1709439
     /* 1709439 */   GIM_Try, /*On fail goto*//*Label 23398*/ GIMT_Encode4(1709525), // Rule ID 10265 //
     /* 1709444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1709455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1709458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1709461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1709464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709490 */     // MIs[0] policy
     /* 1709490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709500 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1709521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709524 */     // GIR_Coverage, 10265,
     /* 1709524 */     GIR_EraseRootFromParent_Done,
     /* 1709525 */   // Label 23398: @1709525
     /* 1709525 */   GIM_Try, /*On fail goto*//*Label 23399*/ GIMT_Encode4(1709611), // Rule ID 10268 //
     /* 1709530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1709541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1709544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1709547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1709550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709576 */     // MIs[0] policy
     /* 1709576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709610 */     // GIR_Coverage, 10268,
     /* 1709610 */     GIR_EraseRootFromParent_Done,
     /* 1709611 */   // Label 23399: @1709611
     /* 1709611 */   GIM_Try, /*On fail goto*//*Label 23400*/ GIMT_Encode4(1709697), // Rule ID 10269 //
     /* 1709616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1709627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1709630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1709633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1709636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709662 */     // MIs[0] policy
     /* 1709662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709672 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1709675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709696 */     // GIR_Coverage, 10269,
     /* 1709696 */     GIR_EraseRootFromParent_Done,
     /* 1709697 */   // Label 23400: @1709697
     /* 1709697 */   GIM_Try, /*On fail goto*//*Label 23401*/ GIMT_Encode4(1709783), // Rule ID 10272 //
     /* 1709702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1709713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1709716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1709719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1709722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709748 */     // MIs[0] policy
     /* 1709748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709758 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709782 */     // GIR_Coverage, 10272,
     /* 1709782 */     GIR_EraseRootFromParent_Done,
     /* 1709783 */   // Label 23401: @1709783
     /* 1709783 */   GIM_Try, /*On fail goto*//*Label 23402*/ GIMT_Encode4(1709869), // Rule ID 10273 //
     /* 1709788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1709799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1709802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1709805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1709808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709834 */     // MIs[0] policy
     /* 1709834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1709865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709868 */     // GIR_Coverage, 10273,
     /* 1709868 */     GIR_EraseRootFromParent_Done,
     /* 1709869 */   // Label 23402: @1709869
     /* 1709869 */   GIM_Try, /*On fail goto*//*Label 23403*/ GIMT_Encode4(1709955), // Rule ID 10276 //
     /* 1709874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1709885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1709888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1709891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1709894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709920 */     // MIs[0] policy
     /* 1709920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1709933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709954 */     // GIR_Coverage, 10276,
     /* 1709954 */     GIR_EraseRootFromParent_Done,
     /* 1709955 */   // Label 23403: @1709955
     /* 1709955 */   GIM_Try, /*On fail goto*//*Label 23404*/ GIMT_Encode4(1710041), // Rule ID 10277 //
     /* 1709960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1709971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1709974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1709977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1709980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1709983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1709990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1709998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710006 */     // MIs[0] policy
     /* 1710006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1710019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710040 */     // GIR_Coverage, 10277,
     /* 1710040 */     GIR_EraseRootFromParent_Done,
     /* 1710041 */   // Label 23404: @1710041
     /* 1710041 */   GIM_Try, /*On fail goto*//*Label 23405*/ GIMT_Encode4(1710127), // Rule ID 10280 //
     /* 1710046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710092 */     // MIs[0] policy
     /* 1710092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710126 */     // GIR_Coverage, 10280,
     /* 1710126 */     GIR_EraseRootFromParent_Done,
     /* 1710127 */   // Label 23405: @1710127
     /* 1710127 */   GIM_Try, /*On fail goto*//*Label 23406*/ GIMT_Encode4(1710213), // Rule ID 10281 //
     /* 1710132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1710143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1710146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1710149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1710152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1710155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710178 */     // MIs[0] policy
     /* 1710178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710188 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710212 */     // GIR_Coverage, 10281,
     /* 1710212 */     GIR_EraseRootFromParent_Done,
     /* 1710213 */   // Label 23406: @1710213
     /* 1710213 */   GIM_Try, /*On fail goto*//*Label 23407*/ GIMT_Encode4(1710299), // Rule ID 10284 //
     /* 1710218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1710238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710264 */     // MIs[0] policy
     /* 1710264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710298 */     // GIR_Coverage, 10284,
     /* 1710298 */     GIR_EraseRootFromParent_Done,
     /* 1710299 */   // Label 23407: @1710299
     /* 1710299 */   GIM_Try, /*On fail goto*//*Label 23408*/ GIMT_Encode4(1710385), // Rule ID 10285 //
     /* 1710304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1710315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1710318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1710321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1710324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710350 */     // MIs[0] policy
     /* 1710350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710384 */     // GIR_Coverage, 10285,
     /* 1710384 */     GIR_EraseRootFromParent_Done,
     /* 1710385 */   // Label 23408: @1710385
     /* 1710385 */   GIM_Try, /*On fail goto*//*Label 23409*/ GIMT_Encode4(1710471), // Rule ID 10288 //
     /* 1710390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1710407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1710410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710436 */     // MIs[0] policy
     /* 1710436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710446 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710470 */     // GIR_Coverage, 10288,
     /* 1710470 */     GIR_EraseRootFromParent_Done,
     /* 1710471 */   // Label 23409: @1710471
     /* 1710471 */   GIM_Try, /*On fail goto*//*Label 23410*/ GIMT_Encode4(1710557), // Rule ID 10289 //
     /* 1710476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1710487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1710490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1710493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1710496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710522 */     // MIs[0] policy
     /* 1710522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710556 */     // GIR_Coverage, 10289,
     /* 1710556 */     GIR_EraseRootFromParent_Done,
     /* 1710557 */   // Label 23410: @1710557
     /* 1710557 */   GIM_Try, /*On fail goto*//*Label 23411*/ GIMT_Encode4(1710643), // Rule ID 10292 //
     /* 1710562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1710565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1710573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1710576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1710579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1710582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710608 */     // MIs[0] policy
     /* 1710608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710642 */     // GIR_Coverage, 10292,
     /* 1710642 */     GIR_EraseRootFromParent_Done,
     /* 1710643 */   // Label 23411: @1710643
     /* 1710643 */   GIM_Try, /*On fail goto*//*Label 23412*/ GIMT_Encode4(1710729), // Rule ID 10293 //
     /* 1710648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1710651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1710659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1710662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1710665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1710668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710694 */     // MIs[0] policy
     /* 1710694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710704 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1710707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1710725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710728 */     // GIR_Coverage, 10293,
     /* 1710728 */     GIR_EraseRootFromParent_Done,
     /* 1710729 */   // Label 23412: @1710729
     /* 1710729 */   GIM_Try, /*On fail goto*//*Label 23413*/ GIMT_Encode4(1710815), // Rule ID 10296 //
     /* 1710734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1710745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1710748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1710751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1710754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1710757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710780 */     // MIs[0] policy
     /* 1710780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710790 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1710793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710814 */     // GIR_Coverage, 10296,
     /* 1710814 */     GIR_EraseRootFromParent_Done,
     /* 1710815 */   // Label 23413: @1710815
     /* 1710815 */   GIM_Try, /*On fail goto*//*Label 23414*/ GIMT_Encode4(1710901), // Rule ID 10297 //
     /* 1710820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1710831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1710834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1710837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1710840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1710843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1710850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1710862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710866 */     // MIs[0] policy
     /* 1710866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710876 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1710879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710900 */     // GIR_Coverage, 10297,
     /* 1710900 */     GIR_EraseRootFromParent_Done,
     /* 1710901 */   // Label 23414: @1710901
     /* 1710901 */   GIM_Try, /*On fail goto*//*Label 23415*/ GIMT_Encode4(1710987), // Rule ID 10300 //
     /* 1710906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1710914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1710917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1710920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1710923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1710926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1710929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1710936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1710948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710952 */     // MIs[0] policy
     /* 1710952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710962 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1710965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710986 */     // GIR_Coverage, 10300,
     /* 1710986 */     GIR_EraseRootFromParent_Done,
     /* 1710987 */   // Label 23415: @1710987
     /* 1710987 */   GIM_Try, /*On fail goto*//*Label 23416*/ GIMT_Encode4(1711073), // Rule ID 10301 //
     /* 1710992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1711009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1711012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711038 */     // MIs[0] policy
     /* 1711038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711048 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711072 */     // GIR_Coverage, 10301,
     /* 1711072 */     GIR_EraseRootFromParent_Done,
     /* 1711073 */   // Label 23416: @1711073
     /* 1711073 */   GIM_Try, /*On fail goto*//*Label 23417*/ GIMT_Encode4(1711159), // Rule ID 10304 //
     /* 1711078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1711089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1711092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1711095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1711098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1711101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711124 */     // MIs[0] policy
     /* 1711124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711134 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711158 */     // GIR_Coverage, 10304,
     /* 1711158 */     GIR_EraseRootFromParent_Done,
     /* 1711159 */   // Label 23417: @1711159
     /* 1711159 */   GIM_Try, /*On fail goto*//*Label 23418*/ GIMT_Encode4(1711245), // Rule ID 10305 //
     /* 1711164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1711175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1711178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1711181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1711184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1711187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711210 */     // MIs[0] policy
     /* 1711210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711220 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711244 */     // GIR_Coverage, 10305,
     /* 1711244 */     GIR_EraseRootFromParent_Done,
     /* 1711245 */   // Label 23418: @1711245
     /* 1711245 */   GIM_Try, /*On fail goto*//*Label 23419*/ GIMT_Encode4(1711331), // Rule ID 10308 //
     /* 1711250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711296 */     // MIs[0] policy
     /* 1711296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711330 */     // GIR_Coverage, 10308,
     /* 1711330 */     GIR_EraseRootFromParent_Done,
     /* 1711331 */   // Label 23419: @1711331
     /* 1711331 */   GIM_Try, /*On fail goto*//*Label 23420*/ GIMT_Encode4(1711417), // Rule ID 10309 //
     /* 1711336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1711347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1711350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1711353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1711356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711382 */     // MIs[0] policy
     /* 1711382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711416 */     // GIR_Coverage, 10309,
     /* 1711416 */     GIR_EraseRootFromParent_Done,
     /* 1711417 */   // Label 23420: @1711417
     /* 1711417 */   GIM_Try, /*On fail goto*//*Label 23421*/ GIMT_Encode4(1711503), // Rule ID 10312 //
     /* 1711422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1711433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1711436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1711442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711468 */     // MIs[0] policy
     /* 1711468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711502 */     // GIR_Coverage, 10312,
     /* 1711502 */     GIR_EraseRootFromParent_Done,
     /* 1711503 */   // Label 23421: @1711503
     /* 1711503 */   GIM_Try, /*On fail goto*//*Label 23422*/ GIMT_Encode4(1711589), // Rule ID 10313 //
     /* 1711508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1711519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1711522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1711525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1711528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711554 */     // MIs[0] policy
     /* 1711554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711564 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711588 */     // GIR_Coverage, 10313,
     /* 1711588 */     GIR_EraseRootFromParent_Done,
     /* 1711589 */   // Label 23422: @1711589
     /* 1711589 */   GIM_Try, /*On fail goto*//*Label 23423*/ GIMT_Encode4(1711675), // Rule ID 10316 //
     /* 1711594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1711605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1711608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1711611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1711614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711640 */     // MIs[0] policy
     /* 1711640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711650 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711674 */     // GIR_Coverage, 10316,
     /* 1711674 */     GIR_EraseRootFromParent_Done,
     /* 1711675 */   // Label 23423: @1711675
     /* 1711675 */   GIM_Try, /*On fail goto*//*Label 23424*/ GIMT_Encode4(1711761), // Rule ID 10317 //
     /* 1711680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1711691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1711694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1711697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1711700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1711710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1711722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711726 */     // MIs[0] policy
     /* 1711726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711736 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1711739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711760 */     // GIR_Coverage, 10317,
     /* 1711760 */     GIR_EraseRootFromParent_Done,
     /* 1711761 */   // Label 23424: @1711761
     /* 1711761 */   GIM_Try, /*On fail goto*//*Label 23425*/ GIMT_Encode4(1711847), // Rule ID 10320 //
     /* 1711766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1711777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1711780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1711783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1711786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711812 */     // MIs[0] policy
     /* 1711812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711846 */     // GIR_Coverage, 10320,
     /* 1711846 */     GIR_EraseRootFromParent_Done,
     /* 1711847 */   // Label 23425: @1711847
     /* 1711847 */   GIM_Try, /*On fail goto*//*Label 23426*/ GIMT_Encode4(1711933), // Rule ID 10321 //
     /* 1711852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1711863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1711866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1711869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1711872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711898 */     // MIs[0] policy
     /* 1711898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711908 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1711911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711932 */     // GIR_Coverage, 10321,
     /* 1711932 */     GIR_EraseRootFromParent_Done,
     /* 1711933 */   // Label 23426: @1711933
     /* 1711933 */   GIM_Try, /*On fail goto*//*Label 23427*/ GIMT_Encode4(1712019), // Rule ID 10324 //
     /* 1711938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1711946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1711949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1711952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1711955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1711958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711984 */     // MIs[0] policy
     /* 1711984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1711997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712018 */     // GIR_Coverage, 10324,
     /* 1712018 */     GIR_EraseRootFromParent_Done,
     /* 1712019 */   // Label 23427: @1712019
     /* 1712019 */   GIM_Try, /*On fail goto*//*Label 23428*/ GIMT_Encode4(1712105), // Rule ID 10325 //
     /* 1712024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1712035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1712038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1712041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1712044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712070 */     // MIs[0] policy
     /* 1712070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712080 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712104 */     // GIR_Coverage, 10325,
     /* 1712104 */     GIR_EraseRootFromParent_Done,
     /* 1712105 */   // Label 23428: @1712105
     /* 1712105 */   GIM_Try, /*On fail goto*//*Label 23429*/ GIMT_Encode4(1712191), // Rule ID 10328 //
     /* 1712110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1712121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1712124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1712130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712156 */     // MIs[0] policy
     /* 1712156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712190 */     // GIR_Coverage, 10328,
     /* 1712190 */     GIR_EraseRootFromParent_Done,
     /* 1712191 */   // Label 23429: @1712191
     /* 1712191 */   GIM_Try, /*On fail goto*//*Label 23430*/ GIMT_Encode4(1712277), // Rule ID 10329 //
     /* 1712196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1712207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1712210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1712213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1712216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712242 */     // MIs[0] policy
     /* 1712242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712252 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712276 */     // GIR_Coverage, 10329,
     /* 1712276 */     GIR_EraseRootFromParent_Done,
     /* 1712277 */   // Label 23430: @1712277
     /* 1712277 */   GIM_Try, /*On fail goto*//*Label 23431*/ GIMT_Encode4(1712363), // Rule ID 10332 //
     /* 1712282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1712293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1712296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1712302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712328 */     // MIs[0] policy
     /* 1712328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712362 */     // GIR_Coverage, 10332,
     /* 1712362 */     GIR_EraseRootFromParent_Done,
     /* 1712363 */   // Label 23431: @1712363
     /* 1712363 */   GIM_Try, /*On fail goto*//*Label 23432*/ GIMT_Encode4(1712449), // Rule ID 10333 //
     /* 1712368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1712371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1712379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1712382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1712385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1712388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712414 */     // MIs[0] policy
     /* 1712414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1712427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712448 */     // GIR_Coverage, 10333,
     /* 1712448 */     GIR_EraseRootFromParent_Done,
     /* 1712449 */   // Label 23432: @1712449
     /* 1712449 */   GIM_Try, /*On fail goto*//*Label 23433*/ GIMT_Encode4(1712535), // Rule ID 10336 //
     /* 1712454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1712465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1712468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1712471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1712474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712500 */     // MIs[0] policy
     /* 1712500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712510 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712534 */     // GIR_Coverage, 10336,
     /* 1712534 */     GIR_EraseRootFromParent_Done,
     /* 1712535 */   // Label 23433: @1712535
     /* 1712535 */   GIM_Try, /*On fail goto*//*Label 23434*/ GIMT_Encode4(1712621), // Rule ID 10337 //
     /* 1712540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1712543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1712551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1712554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1712557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1712560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712586 */     // MIs[0] policy
     /* 1712586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1712599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712620 */     // GIR_Coverage, 10337,
     /* 1712620 */     GIR_EraseRootFromParent_Done,
     /* 1712621 */   // Label 23434: @1712621
     /* 1712621 */   GIM_Try, /*On fail goto*//*Label 23435*/ GIMT_Encode4(1712707), // Rule ID 10340 //
     /* 1712626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1712629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1712637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1712640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1712643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1712646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712672 */     // MIs[0] policy
     /* 1712672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712682 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712706 */     // GIR_Coverage, 10340,
     /* 1712706 */     GIR_EraseRootFromParent_Done,
     /* 1712707 */   // Label 23435: @1712707
     /* 1712707 */   GIM_Try, /*On fail goto*//*Label 23436*/ GIMT_Encode4(1712793), // Rule ID 10341 //
     /* 1712712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1712715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1712723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1712726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1712729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1712732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712758 */     // MIs[0] policy
     /* 1712758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1712771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1712789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712792 */     // GIR_Coverage, 10341,
     /* 1712792 */     GIR_EraseRootFromParent_Done,
     /* 1712793 */   // Label 23436: @1712793
     /* 1712793 */   GIM_Try, /*On fail goto*//*Label 23437*/ GIMT_Encode4(1712879), // Rule ID 10344 //
     /* 1712798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1712809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1712812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1712815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712844 */     // MIs[0] policy
     /* 1712844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712854 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1712857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712878 */     // GIR_Coverage, 10344,
     /* 1712878 */     GIR_EraseRootFromParent_Done,
     /* 1712879 */   // Label 23437: @1712879
     /* 1712879 */   GIM_Try, /*On fail goto*//*Label 23438*/ GIMT_Encode4(1712965), // Rule ID 10345 //
     /* 1712884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1712895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1712898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1712901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1712904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1712907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1712914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1712922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1712926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712930 */     // MIs[0] policy
     /* 1712930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712940 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1712943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712964 */     // GIR_Coverage, 10345,
     /* 1712964 */     GIR_EraseRootFromParent_Done,
     /* 1712965 */   // Label 23438: @1712965
     /* 1712965 */   GIM_Try, /*On fail goto*//*Label 23439*/ GIMT_Encode4(1713051), // Rule ID 10348 //
     /* 1712970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1712978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1712981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1712984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1712987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1712990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1712993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713016 */     // MIs[0] policy
     /* 1713016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713026 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713050 */     // GIR_Coverage, 10348,
     /* 1713050 */     GIR_EraseRootFromParent_Done,
     /* 1713051 */   // Label 23439: @1713051
     /* 1713051 */   GIM_Try, /*On fail goto*//*Label 23440*/ GIMT_Encode4(1713137), // Rule ID 10349 //
     /* 1713056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1713067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1713070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1713073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713102 */     // MIs[0] policy
     /* 1713102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713112 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713136 */     // GIR_Coverage, 10349,
     /* 1713136 */     GIR_EraseRootFromParent_Done,
     /* 1713137 */   // Label 23440: @1713137
     /* 1713137 */   GIM_Try, /*On fail goto*//*Label 23441*/ GIMT_Encode4(1713223), // Rule ID 10352 //
     /* 1713142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713188 */     // MIs[0] policy
     /* 1713188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713198 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713222 */     // GIR_Coverage, 10352,
     /* 1713222 */     GIR_EraseRootFromParent_Done,
     /* 1713223 */   // Label 23441: @1713223
     /* 1713223 */   GIM_Try, /*On fail goto*//*Label 23442*/ GIMT_Encode4(1713309), // Rule ID 10353 //
     /* 1713228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1713239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1713242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1713245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713274 */     // MIs[0] policy
     /* 1713274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713284 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713308 */     // GIR_Coverage, 10353,
     /* 1713308 */     GIR_EraseRootFromParent_Done,
     /* 1713309 */   // Label 23442: @1713309
     /* 1713309 */   GIM_Try, /*On fail goto*//*Label 23443*/ GIMT_Encode4(1713395), // Rule ID 10356 //
     /* 1713314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713360 */     // MIs[0] policy
     /* 1713360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713370 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713394 */     // GIR_Coverage, 10356,
     /* 1713394 */     GIR_EraseRootFromParent_Done,
     /* 1713395 */   // Label 23443: @1713395
     /* 1713395 */   GIM_Try, /*On fail goto*//*Label 23444*/ GIMT_Encode4(1713481), // Rule ID 10357 //
     /* 1713400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1713411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1713414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1713417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713446 */     // MIs[0] policy
     /* 1713446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713456 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1713459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713480 */     // GIR_Coverage, 10357,
     /* 1713480 */     GIR_EraseRootFromParent_Done,
     /* 1713481 */   // Label 23444: @1713481
     /* 1713481 */   GIM_Try, /*On fail goto*//*Label 23445*/ GIMT_Encode4(1713567), // Rule ID 10360 //
     /* 1713486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1713497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1713500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713532 */     // MIs[0] policy
     /* 1713532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713542 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713566 */     // GIR_Coverage, 10360,
     /* 1713566 */     GIR_EraseRootFromParent_Done,
     /* 1713567 */   // Label 23445: @1713567
     /* 1713567 */   GIM_Try, /*On fail goto*//*Label 23446*/ GIMT_Encode4(1713653), // Rule ID 10361 //
     /* 1713572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1713583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1713586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1713589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713618 */     // MIs[0] policy
     /* 1713618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713628 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1713649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713652 */     // GIR_Coverage, 10361,
     /* 1713652 */     GIR_EraseRootFromParent_Done,
     /* 1713653 */   // Label 23446: @1713653
     /* 1713653 */   GIM_Try, /*On fail goto*//*Label 23447*/ GIMT_Encode4(1713739), // Rule ID 10364 //
     /* 1713658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1713669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1713672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1713675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713704 */     // MIs[0] policy
     /* 1713704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713738 */     // GIR_Coverage, 10364,
     /* 1713738 */     GIR_EraseRootFromParent_Done,
     /* 1713739 */   // Label 23447: @1713739
     /* 1713739 */   GIM_Try, /*On fail goto*//*Label 23448*/ GIMT_Encode4(1713825), // Rule ID 10365 //
     /* 1713744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1713755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1713758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1713761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713790 */     // MIs[0] policy
     /* 1713790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713800 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1713803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713824 */     // GIR_Coverage, 10365,
     /* 1713824 */     GIR_EraseRootFromParent_Done,
     /* 1713825 */   // Label 23448: @1713825
     /* 1713825 */   GIM_Try, /*On fail goto*//*Label 23449*/ GIMT_Encode4(1713911), // Rule ID 10368 //
     /* 1713830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1713841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1713844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1713847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713876 */     // MIs[0] policy
     /* 1713876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713886 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1713889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713910 */     // GIR_Coverage, 10368,
     /* 1713910 */     GIR_EraseRootFromParent_Done,
     /* 1713911 */   // Label 23449: @1713911
     /* 1713911 */   GIM_Try, /*On fail goto*//*Label 23450*/ GIMT_Encode4(1713997), // Rule ID 10369 //
     /* 1713916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1713924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1713927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1713930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1713933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713962 */     // MIs[0] policy
     /* 1713962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713972 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1713975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713996 */     // GIR_Coverage, 10369,
     /* 1713996 */     GIR_EraseRootFromParent_Done,
     /* 1713997 */   // Label 23450: @1713997
     /* 1713997 */   GIM_Try, /*On fail goto*//*Label 23451*/ GIMT_Encode4(1714083), // Rule ID 10372 //
     /* 1714002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714048 */     // MIs[0] policy
     /* 1714048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714058 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714082 */     // GIR_Coverage, 10372,
     /* 1714082 */     GIR_EraseRootFromParent_Done,
     /* 1714083 */   // Label 23451: @1714083
     /* 1714083 */   GIM_Try, /*On fail goto*//*Label 23452*/ GIMT_Encode4(1714169), // Rule ID 10373 //
     /* 1714088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1714105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714134 */     // MIs[0] policy
     /* 1714134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714144 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714168 */     // GIR_Coverage, 10373,
     /* 1714168 */     GIR_EraseRootFromParent_Done,
     /* 1714169 */   // Label 23452: @1714169
     /* 1714169 */   GIM_Try, /*On fail goto*//*Label 23453*/ GIMT_Encode4(1714255), // Rule ID 10376 //
     /* 1714174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714220 */     // MIs[0] policy
     /* 1714220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714254 */     // GIR_Coverage, 10376,
     /* 1714254 */     GIR_EraseRootFromParent_Done,
     /* 1714255 */   // Label 23453: @1714255
     /* 1714255 */   GIM_Try, /*On fail goto*//*Label 23454*/ GIMT_Encode4(1714341), // Rule ID 10377 //
     /* 1714260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1714271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1714274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1714277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714306 */     // MIs[0] policy
     /* 1714306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714340 */     // GIR_Coverage, 10377,
     /* 1714340 */     GIR_EraseRootFromParent_Done,
     /* 1714341 */   // Label 23454: @1714341
     /* 1714341 */   GIM_Try, /*On fail goto*//*Label 23455*/ GIMT_Encode4(1714427), // Rule ID 10380 //
     /* 1714346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1714349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714392 */     // MIs[0] policy
     /* 1714392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714426 */     // GIR_Coverage, 10380,
     /* 1714426 */     GIR_EraseRootFromParent_Done,
     /* 1714427 */   // Label 23455: @1714427
     /* 1714427 */   GIM_Try, /*On fail goto*//*Label 23456*/ GIMT_Encode4(1714513), // Rule ID 10381 //
     /* 1714432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1714435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1714443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1714446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1714449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714478 */     // MIs[0] policy
     /* 1714478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714488 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1714491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1714509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714512 */     // GIR_Coverage, 10381,
     /* 1714512 */     GIR_EraseRootFromParent_Done,
     /* 1714513 */   // Label 23456: @1714513
     /* 1714513 */   GIM_Try, /*On fail goto*//*Label 23457*/ GIMT_Encode4(1714599), // Rule ID 10384 //
     /* 1714518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1714529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1714532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1714535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1714541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1714548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714564 */     // MIs[0] policy
     /* 1714564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714574 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1714577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714598 */     // GIR_Coverage, 10384,
     /* 1714598 */     GIR_EraseRootFromParent_Done,
     /* 1714599 */   // Label 23457: @1714599
     /* 1714599 */   GIM_Try, /*On fail goto*//*Label 23458*/ GIMT_Encode4(1714685), // Rule ID 10385 //
     /* 1714604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1714615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1714618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1714621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1714627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1714634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1714642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714650 */     // MIs[0] policy
     /* 1714650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714660 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1714663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714684 */     // GIR_Coverage, 10385,
     /* 1714684 */     GIR_EraseRootFromParent_Done,
     /* 1714685 */   // Label 23458: @1714685
     /* 1714685 */   GIM_Try, /*On fail goto*//*Label 23459*/ GIMT_Encode4(1714771), // Rule ID 10388 //
     /* 1714690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1714701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1714704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1714707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1714713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714736 */     // MIs[0] policy
     /* 1714736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714746 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1714749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714770 */     // GIR_Coverage, 10388,
     /* 1714770 */     GIR_EraseRootFromParent_Done,
     /* 1714771 */   // Label 23459: @1714771
     /* 1714771 */   GIM_Try, /*On fail goto*//*Label 23460*/ GIMT_Encode4(1714857), // Rule ID 10389 //
     /* 1714776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1714787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1714790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1714793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1714799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1714806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1714814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714822 */     // MIs[0] policy
     /* 1714822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714832 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1714835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714856 */     // GIR_Coverage, 10389,
     /* 1714856 */     GIR_EraseRootFromParent_Done,
     /* 1714857 */   // Label 23460: @1714857
     /* 1714857 */   GIM_Try, /*On fail goto*//*Label 23461*/ GIMT_Encode4(1714943), // Rule ID 10392 //
     /* 1714862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1714873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1714876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1714879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1714885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714908 */     // MIs[0] policy
     /* 1714908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714918 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1714921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714942 */     // GIR_Coverage, 10392,
     /* 1714942 */     GIR_EraseRootFromParent_Done,
     /* 1714943 */   // Label 23461: @1714943
     /* 1714943 */   GIM_Try, /*On fail goto*//*Label 23462*/ GIMT_Encode4(1715029), // Rule ID 10393 //
     /* 1714948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1714956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1714959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1714962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1714965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1714971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1714978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1714986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714994 */     // MIs[0] policy
     /* 1714994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715004 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715028 */     // GIR_Coverage, 10393,
     /* 1715028 */     GIR_EraseRootFromParent_Done,
     /* 1715029 */   // Label 23462: @1715029
     /* 1715029 */   GIM_Try, /*On fail goto*//*Label 23463*/ GIMT_Encode4(1715115), // Rule ID 10396 //
     /* 1715034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715080 */     // MIs[0] policy
     /* 1715080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715114 */     // GIR_Coverage, 10396,
     /* 1715114 */     GIR_EraseRootFromParent_Done,
     /* 1715115 */   // Label 23463: @1715115
     /* 1715115 */   GIM_Try, /*On fail goto*//*Label 23464*/ GIMT_Encode4(1715201), // Rule ID 10397 //
     /* 1715120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1715131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1715134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1715137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715166 */     // MIs[0] policy
     /* 1715166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715176 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715200 */     // GIR_Coverage, 10397,
     /* 1715200 */     GIR_EraseRootFromParent_Done,
     /* 1715201 */   // Label 23464: @1715201
     /* 1715201 */   GIM_Try, /*On fail goto*//*Label 23465*/ GIMT_Encode4(1715287), // Rule ID 10400 //
     /* 1715206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715252 */     // MIs[0] policy
     /* 1715252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715262 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715286 */     // GIR_Coverage, 10400,
     /* 1715286 */     GIR_EraseRootFromParent_Done,
     /* 1715287 */   // Label 23465: @1715287
     /* 1715287 */   GIM_Try, /*On fail goto*//*Label 23466*/ GIMT_Encode4(1715373), // Rule ID 10401 //
     /* 1715292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1715303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1715306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1715309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715338 */     // MIs[0] policy
     /* 1715338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715372 */     // GIR_Coverage, 10401,
     /* 1715372 */     GIR_EraseRootFromParent_Done,
     /* 1715373 */   // Label 23466: @1715373
     /* 1715373 */   GIM_Try, /*On fail goto*//*Label 23467*/ GIMT_Encode4(1715459), // Rule ID 10404 //
     /* 1715378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715424 */     // MIs[0] policy
     /* 1715424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715434 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715458 */     // GIR_Coverage, 10404,
     /* 1715458 */     GIR_EraseRootFromParent_Done,
     /* 1715459 */   // Label 23467: @1715459
     /* 1715459 */   GIM_Try, /*On fail goto*//*Label 23468*/ GIMT_Encode4(1715545), // Rule ID 10405 //
     /* 1715464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1715475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1715478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1715481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715510 */     // MIs[0] policy
     /* 1715510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715520 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715544 */     // GIR_Coverage, 10405,
     /* 1715544 */     GIR_EraseRootFromParent_Done,
     /* 1715545 */   // Label 23468: @1715545
     /* 1715545 */   GIM_Try, /*On fail goto*//*Label 23469*/ GIMT_Encode4(1715631), // Rule ID 10408 //
     /* 1715550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1715561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1715564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1715567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715596 */     // MIs[0] policy
     /* 1715596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715606 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715630 */     // GIR_Coverage, 10408,
     /* 1715630 */     GIR_EraseRootFromParent_Done,
     /* 1715631 */   // Label 23469: @1715631
     /* 1715631 */   GIM_Try, /*On fail goto*//*Label 23470*/ GIMT_Encode4(1715717), // Rule ID 10409 //
     /* 1715636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1715647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1715650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1715653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715682 */     // MIs[0] policy
     /* 1715682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715692 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1715695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715716 */     // GIR_Coverage, 10409,
     /* 1715716 */     GIR_EraseRootFromParent_Done,
     /* 1715717 */   // Label 23470: @1715717
     /* 1715717 */   GIM_Try, /*On fail goto*//*Label 23471*/ GIMT_Encode4(1715803), // Rule ID 10412 //
     /* 1715722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1715733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1715736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1715739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715768 */     // MIs[0] policy
     /* 1715768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715778 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715802 */     // GIR_Coverage, 10412,
     /* 1715802 */     GIR_EraseRootFromParent_Done,
     /* 1715803 */   // Label 23471: @1715803
     /* 1715803 */   GIM_Try, /*On fail goto*//*Label 23472*/ GIMT_Encode4(1715889), // Rule ID 10413 //
     /* 1715808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1715819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1715822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1715825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1715831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715854 */     // MIs[0] policy
     /* 1715854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715864 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1715867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715888 */     // GIR_Coverage, 10413,
     /* 1715888 */     GIR_EraseRootFromParent_Done,
     /* 1715889 */   // Label 23472: @1715889
     /* 1715889 */   GIM_Try, /*On fail goto*//*Label 23473*/ GIMT_Encode4(1715975), // Rule ID 10416 //
     /* 1715894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1715905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1715908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1715911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715940 */     // MIs[0] policy
     /* 1715940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1715953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715974 */     // GIR_Coverage, 10416,
     /* 1715974 */     GIR_EraseRootFromParent_Done,
     /* 1715975 */   // Label 23473: @1715975
     /* 1715975 */   GIM_Try, /*On fail goto*//*Label 23474*/ GIMT_Encode4(1716061), // Rule ID 10417 //
     /* 1715980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1715988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1715991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1715994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1715997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716026 */     // MIs[0] policy
     /* 1716026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716036 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716060 */     // GIR_Coverage, 10417,
     /* 1716060 */     GIR_EraseRootFromParent_Done,
     /* 1716061 */   // Label 23474: @1716061
     /* 1716061 */   GIM_Try, /*On fail goto*//*Label 23475*/ GIMT_Encode4(1716147), // Rule ID 10420 //
     /* 1716066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716112 */     // MIs[0] policy
     /* 1716112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716122 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716146 */     // GIR_Coverage, 10420,
     /* 1716146 */     GIR_EraseRootFromParent_Done,
     /* 1716147 */   // Label 23475: @1716147
     /* 1716147 */   GIM_Try, /*On fail goto*//*Label 23476*/ GIMT_Encode4(1716233), // Rule ID 10421 //
     /* 1716152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1716163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1716166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1716169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716198 */     // MIs[0] policy
     /* 1716198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716208 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11435:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1716211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716232 */     // GIR_Coverage, 10421,
     /* 1716232 */     GIR_EraseRootFromParent_Done,
     /* 1716233 */   // Label 23476: @1716233
     /* 1716233 */   GIM_Try, /*On fail goto*//*Label 23477*/ GIMT_Encode4(1716319), // Rule ID 10424 //
     /* 1716238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716284 */     // MIs[0] policy
     /* 1716284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716318 */     // GIR_Coverage, 10424,
     /* 1716318 */     GIR_EraseRootFromParent_Done,
     /* 1716319 */   // Label 23477: @1716319
     /* 1716319 */   GIM_Try, /*On fail goto*//*Label 23478*/ GIMT_Encode4(1716405), // Rule ID 10425 //
     /* 1716324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1716335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1716338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1716341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716370 */     // MIs[0] policy
     /* 1716370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11435:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1716383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716404 */     // GIR_Coverage, 10425,
     /* 1716404 */     GIR_EraseRootFromParent_Done,
     /* 1716405 */   // Label 23478: @1716405
     /* 1716405 */   GIM_Try, /*On fail goto*//*Label 23479*/ GIMT_Encode4(1716491), // Rule ID 10428 //
     /* 1716410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1716413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716456 */     // MIs[0] policy
     /* 1716456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716490 */     // GIR_Coverage, 10428,
     /* 1716490 */     GIR_EraseRootFromParent_Done,
     /* 1716491 */   // Label 23479: @1716491
     /* 1716491 */   GIM_Try, /*On fail goto*//*Label 23480*/ GIMT_Encode4(1716577), // Rule ID 10429 //
     /* 1716496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1716499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1716504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1716507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1716510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1716513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716542 */     // MIs[0] policy
     /* 1716542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11435:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1716555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1716573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716576 */     // GIR_Coverage, 10429,
     /* 1716576 */     GIR_EraseRootFromParent_Done,
     /* 1716577 */   // Label 23480: @1716577
     /* 1716577 */   GIM_Try, /*On fail goto*//*Label 23481*/ GIMT_Encode4(1716663), // Rule ID 10432 //
     /* 1716582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1716593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1716596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1716599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1716602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1716605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716628 */     // MIs[0] policy
     /* 1716628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716638 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1716641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716662 */     // GIR_Coverage, 10432,
     /* 1716662 */     GIR_EraseRootFromParent_Done,
     /* 1716663 */   // Label 23481: @1716663
     /* 1716663 */   GIM_Try, /*On fail goto*//*Label 23482*/ GIMT_Encode4(1716749), // Rule ID 10433 //
     /* 1716668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1716679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1716682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1716685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1716688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1716691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716714 */     // MIs[0] policy
     /* 1716714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716724 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1716727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716748 */     // GIR_Coverage, 10433,
     /* 1716748 */     GIR_EraseRootFromParent_Done,
     /* 1716749 */   // Label 23482: @1716749
     /* 1716749 */   GIM_Try, /*On fail goto*//*Label 23483*/ GIMT_Encode4(1716835), // Rule ID 10436 //
     /* 1716754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1716765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1716768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1716771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1716774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716800 */     // MIs[0] policy
     /* 1716800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716810 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1716813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716834 */     // GIR_Coverage, 10436,
     /* 1716834 */     GIR_EraseRootFromParent_Done,
     /* 1716835 */   // Label 23483: @1716835
     /* 1716835 */   GIM_Try, /*On fail goto*//*Label 23484*/ GIMT_Encode4(1716921), // Rule ID 10437 //
     /* 1716840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1716851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1716854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1716857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1716860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1716863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716886 */     // MIs[0] policy
     /* 1716886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716896 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1716899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716920 */     // GIR_Coverage, 10437,
     /* 1716920 */     GIR_EraseRootFromParent_Done,
     /* 1716921 */   // Label 23484: @1716921
     /* 1716921 */   GIM_Try, /*On fail goto*//*Label 23485*/ GIMT_Encode4(1717007), // Rule ID 10440 //
     /* 1716926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1716937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1716940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1716943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1716946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1716956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1716968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716972 */     // MIs[0] policy
     /* 1716972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716982 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1716985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717006 */     // GIR_Coverage, 10440,
     /* 1717006 */     GIR_EraseRootFromParent_Done,
     /* 1717007 */   // Label 23485: @1717007
     /* 1717007 */   GIM_Try, /*On fail goto*//*Label 23486*/ GIMT_Encode4(1717093), // Rule ID 10441 //
     /* 1717012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1717023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1717026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1717029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1717032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717058 */     // MIs[0] policy
     /* 1717058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717068 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717092 */     // GIR_Coverage, 10441,
     /* 1717092 */     GIR_EraseRootFromParent_Done,
     /* 1717093 */   // Label 23486: @1717093
     /* 1717093 */   GIM_Try, /*On fail goto*//*Label 23487*/ GIMT_Encode4(1717179), // Rule ID 10444 //
     /* 1717098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1717118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717144 */     // MIs[0] policy
     /* 1717144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717154 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717178 */     // GIR_Coverage, 10444,
     /* 1717178 */     GIR_EraseRootFromParent_Done,
     /* 1717179 */   // Label 23487: @1717179
     /* 1717179 */   GIM_Try, /*On fail goto*//*Label 23488*/ GIMT_Encode4(1717265), // Rule ID 10445 //
     /* 1717184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1717195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1717198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1717201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1717204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717230 */     // MIs[0] policy
     /* 1717230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717240 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1717243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717264 */     // GIR_Coverage, 10445,
     /* 1717264 */     GIR_EraseRootFromParent_Done,
     /* 1717265 */   // Label 23488: @1717265
     /* 1717265 */   GIM_Try, /*On fail goto*//*Label 23489*/ GIMT_Encode4(1717351), // Rule ID 10448 //
     /* 1717270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1717290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717316 */     // MIs[0] policy
     /* 1717316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717326 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717350 */     // GIR_Coverage, 10448,
     /* 1717350 */     GIR_EraseRootFromParent_Done,
     /* 1717351 */   // Label 23489: @1717351
     /* 1717351 */   GIM_Try, /*On fail goto*//*Label 23490*/ GIMT_Encode4(1717437), // Rule ID 10449 //
     /* 1717356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1717367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1717370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1717373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1717376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717402 */     // MIs[0] policy
     /* 1717402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717412 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717436 */     // GIR_Coverage, 10449,
     /* 1717436 */     GIR_EraseRootFromParent_Done,
     /* 1717437 */   // Label 23490: @1717437
     /* 1717437 */   GIM_Try, /*On fail goto*//*Label 23491*/ GIMT_Encode4(1717523), // Rule ID 10452 //
     /* 1717442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1717453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1717456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1717459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1717462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717488 */     // MIs[0] policy
     /* 1717488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717522 */     // GIR_Coverage, 10452,
     /* 1717522 */     GIR_EraseRootFromParent_Done,
     /* 1717523 */   // Label 23491: @1717523
     /* 1717523 */   GIM_Try, /*On fail goto*//*Label 23492*/ GIMT_Encode4(1717609), // Rule ID 10453 //
     /* 1717528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1717539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1717542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1717545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1717548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717574 */     // MIs[0] policy
     /* 1717574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1717587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717608 */     // GIR_Coverage, 10453,
     /* 1717608 */     GIR_EraseRootFromParent_Done,
     /* 1717609 */   // Label 23492: @1717609
     /* 1717609 */   GIM_Try, /*On fail goto*//*Label 23493*/ GIMT_Encode4(1717695), // Rule ID 10456 //
     /* 1717614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1717625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1717628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1717631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1717634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717660 */     // MIs[0] policy
     /* 1717660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717670 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1717673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717694 */     // GIR_Coverage, 10456,
     /* 1717694 */     GIR_EraseRootFromParent_Done,
     /* 1717695 */   // Label 23493: @1717695
     /* 1717695 */   GIM_Try, /*On fail goto*//*Label 23494*/ GIMT_Encode4(1717781), // Rule ID 10457 //
     /* 1717700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1717711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1717714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1717717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1717720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717746 */     // MIs[0] policy
     /* 1717746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717756 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1717759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717780 */     // GIR_Coverage, 10457,
     /* 1717780 */     GIR_EraseRootFromParent_Done,
     /* 1717781 */   // Label 23494: @1717781
     /* 1717781 */   GIM_Try, /*On fail goto*//*Label 23495*/ GIMT_Encode4(1717867), // Rule ID 10460 //
     /* 1717786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1717797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1717800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1717803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1717806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717832 */     // MIs[0] policy
     /* 1717832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717842 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1717845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717866 */     // GIR_Coverage, 10460,
     /* 1717866 */     GIR_EraseRootFromParent_Done,
     /* 1717867 */   // Label 23495: @1717867
     /* 1717867 */   GIM_Try, /*On fail goto*//*Label 23496*/ GIMT_Encode4(1717953), // Rule ID 10461 //
     /* 1717872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1717883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1717886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1717889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1717892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717918 */     // MIs[0] policy
     /* 1717918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717928 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1717931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1717949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717952 */     // GIR_Coverage, 10461,
     /* 1717952 */     GIR_EraseRootFromParent_Done,
     /* 1717953 */   // Label 23496: @1717953
     /* 1717953 */   GIM_Try, /*On fail goto*//*Label 23497*/ GIMT_Encode4(1718039), // Rule ID 10464 //
     /* 1717958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1717969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1717972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1717975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1717978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718004 */     // MIs[0] policy
     /* 1718004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718014 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718038 */     // GIR_Coverage, 10464,
     /* 1718038 */     GIR_EraseRootFromParent_Done,
     /* 1718039 */   // Label 23497: @1718039
     /* 1718039 */   GIM_Try, /*On fail goto*//*Label 23498*/ GIMT_Encode4(1718125), // Rule ID 10465 //
     /* 1718044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1718055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1718058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1718061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1718064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718090 */     // MIs[0] policy
     /* 1718090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718100 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718124 */     // GIR_Coverage, 10465,
     /* 1718124 */     GIR_EraseRootFromParent_Done,
     /* 1718125 */   // Label 23498: @1718125
     /* 1718125 */   GIM_Try, /*On fail goto*//*Label 23499*/ GIMT_Encode4(1718211), // Rule ID 10468 //
     /* 1718130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1718133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1718150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718176 */     // MIs[0] policy
     /* 1718176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718210 */     // GIR_Coverage, 10468,
     /* 1718210 */     GIR_EraseRootFromParent_Done,
     /* 1718211 */   // Label 23499: @1718211
     /* 1718211 */   GIM_Try, /*On fail goto*//*Label 23500*/ GIMT_Encode4(1718297), // Rule ID 10469 //
     /* 1718216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1718219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1718227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1718230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1718233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1718236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718262 */     // MIs[0] policy
     /* 1718262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1718275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1718293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718296 */     // GIR_Coverage, 10469,
     /* 1718296 */     GIR_EraseRootFromParent_Done,
     /* 1718297 */   // Label 23500: @1718297
     /* 1718297 */   GIM_Try, /*On fail goto*//*Label 23501*/ GIMT_Encode4(1718383), // Rule ID 10472 //
     /* 1718302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1718322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718348 */     // MIs[0] policy
     /* 1718348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718358 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718382 */     // GIR_Coverage, 10472,
     /* 1718382 */     GIR_EraseRootFromParent_Done,
     /* 1718383 */   // Label 23501: @1718383
     /* 1718383 */   GIM_Try, /*On fail goto*//*Label 23502*/ GIMT_Encode4(1718469), // Rule ID 10473 //
     /* 1718388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1718399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1718402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1718405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1718408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1718411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718434 */     // MIs[0] policy
     /* 1718434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718444 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718468 */     // GIR_Coverage, 10473,
     /* 1718468 */     GIR_EraseRootFromParent_Done,
     /* 1718469 */   // Label 23502: @1718469
     /* 1718469 */   GIM_Try, /*On fail goto*//*Label 23503*/ GIMT_Encode4(1718555), // Rule ID 10476 //
     /* 1718474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1718485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1718488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1718491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1718494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1718497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718520 */     // MIs[0] policy
     /* 1718520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718530 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1718533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718554 */     // GIR_Coverage, 10476,
     /* 1718554 */     GIR_EraseRootFromParent_Done,
     /* 1718555 */   // Label 23503: @1718555
     /* 1718555 */   GIM_Try, /*On fail goto*//*Label 23504*/ GIMT_Encode4(1718641), // Rule ID 10477 //
     /* 1718560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1718571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1718574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1718577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1718580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1718583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1718590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1718602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718606 */     // MIs[0] policy
     /* 1718606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718616 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1718619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718640 */     // GIR_Coverage, 10477,
     /* 1718640 */     GIR_EraseRootFromParent_Done,
     /* 1718641 */   // Label 23504: @1718641
     /* 1718641 */   GIM_Try, /*On fail goto*//*Label 23505*/ GIMT_Encode4(1718727), // Rule ID 10480 //
     /* 1718646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1718657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1718660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1718663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1718666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1718669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1718676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718692 */     // MIs[0] policy
     /* 1718692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718702 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1718705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718726 */     // GIR_Coverage, 10480,
     /* 1718726 */     GIR_EraseRootFromParent_Done,
     /* 1718727 */   // Label 23505: @1718727
     /* 1718727 */   GIM_Try, /*On fail goto*//*Label 23506*/ GIMT_Encode4(1718813), // Rule ID 10481 //
     /* 1718732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1718743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1718746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1718749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1718752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1718755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1718762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1718774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718778 */     // MIs[0] policy
     /* 1718778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718788 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1718791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718812 */     // GIR_Coverage, 10481,
     /* 1718812 */     GIR_EraseRootFromParent_Done,
     /* 1718813 */   // Label 23506: @1718813
     /* 1718813 */   GIM_Try, /*On fail goto*//*Label 23507*/ GIMT_Encode4(1718899), // Rule ID 10484 //
     /* 1718818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1718829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1718832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1718835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1718838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718864 */     // MIs[0] policy
     /* 1718864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718874 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718898 */     // GIR_Coverage, 10484,
     /* 1718898 */     GIR_EraseRootFromParent_Done,
     /* 1718899 */   // Label 23507: @1718899
     /* 1718899 */   GIM_Try, /*On fail goto*//*Label 23508*/ GIMT_Encode4(1718985), // Rule ID 10485 //
     /* 1718904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1718915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1718918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1718921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1718924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1718934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1718946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718950 */     // MIs[0] policy
     /* 1718950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718960 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1718963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718984 */     // GIR_Coverage, 10485,
     /* 1718984 */     GIR_EraseRootFromParent_Done,
     /* 1718985 */   // Label 23508: @1718985
     /* 1718985 */   GIM_Try, /*On fail goto*//*Label 23509*/ GIMT_Encode4(1719071), // Rule ID 10488 //
     /* 1718990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1718998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1719010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719036 */     // MIs[0] policy
     /* 1719036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719070 */     // GIR_Coverage, 10488,
     /* 1719070 */     GIR_EraseRootFromParent_Done,
     /* 1719071 */   // Label 23509: @1719071
     /* 1719071 */   GIM_Try, /*On fail goto*//*Label 23510*/ GIMT_Encode4(1719157), // Rule ID 10489 //
     /* 1719076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1719096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719122 */     // MIs[0] policy
     /* 1719122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719132 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719156 */     // GIR_Coverage, 10489,
     /* 1719156 */     GIR_EraseRootFromParent_Done,
     /* 1719157 */   // Label 23510: @1719157
     /* 1719157 */   GIM_Try, /*On fail goto*//*Label 23511*/ GIMT_Encode4(1719243), // Rule ID 10492 //
     /* 1719162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1719182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719208 */     // MIs[0] policy
     /* 1719208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719218 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719242 */     // GIR_Coverage, 10492,
     /* 1719242 */     GIR_EraseRootFromParent_Done,
     /* 1719243 */   // Label 23511: @1719243
     /* 1719243 */   GIM_Try, /*On fail goto*//*Label 23512*/ GIMT_Encode4(1719329), // Rule ID 10493 //
     /* 1719248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1719259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1719262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1719265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1719268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719294 */     // MIs[0] policy
     /* 1719294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719304 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719328 */     // GIR_Coverage, 10493,
     /* 1719328 */     GIR_EraseRootFromParent_Done,
     /* 1719329 */   // Label 23512: @1719329
     /* 1719329 */   GIM_Try, /*On fail goto*//*Label 23513*/ GIMT_Encode4(1719415), // Rule ID 10496 //
     /* 1719334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1719354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719380 */     // MIs[0] policy
     /* 1719380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719414 */     // GIR_Coverage, 10496,
     /* 1719414 */     GIR_EraseRootFromParent_Done,
     /* 1719415 */   // Label 23513: @1719415
     /* 1719415 */   GIM_Try, /*On fail goto*//*Label 23514*/ GIMT_Encode4(1719501), // Rule ID 10497 //
     /* 1719420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1719431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1719434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1719437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1719440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1719443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719466 */     // MIs[0] policy
     /* 1719466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719500 */     // GIR_Coverage, 10497,
     /* 1719500 */     GIR_EraseRootFromParent_Done,
     /* 1719501 */   // Label 23514: @1719501
     /* 1719501 */   GIM_Try, /*On fail goto*//*Label 23515*/ GIMT_Encode4(1719587), // Rule ID 10500 //
     /* 1719506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1719517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1719520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1719523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1719526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719552 */     // MIs[0] policy
     /* 1719552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719562 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719586 */     // GIR_Coverage, 10500,
     /* 1719586 */     GIR_EraseRootFromParent_Done,
     /* 1719587 */   // Label 23515: @1719587
     /* 1719587 */   GIM_Try, /*On fail goto*//*Label 23516*/ GIMT_Encode4(1719673), // Rule ID 10501 //
     /* 1719592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1719603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1719606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1719609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1719612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719638 */     // MIs[0] policy
     /* 1719638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719648 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1719651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719672 */     // GIR_Coverage, 10501,
     /* 1719672 */     GIR_EraseRootFromParent_Done,
     /* 1719673 */   // Label 23516: @1719673
     /* 1719673 */   GIM_Try, /*On fail goto*//*Label 23517*/ GIMT_Encode4(1719759), // Rule ID 10504 //
     /* 1719678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1719689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1719692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1719695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1719698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719724 */     // MIs[0] policy
     /* 1719724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719734 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719758 */     // GIR_Coverage, 10504,
     /* 1719758 */     GIR_EraseRootFromParent_Done,
     /* 1719759 */   // Label 23517: @1719759
     /* 1719759 */   GIM_Try, /*On fail goto*//*Label 23518*/ GIMT_Encode4(1719845), // Rule ID 10505 //
     /* 1719764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1719775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1719778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1719781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1719784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719810 */     // MIs[0] policy
     /* 1719810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719820 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1719823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719844 */     // GIR_Coverage, 10505,
     /* 1719844 */     GIR_EraseRootFromParent_Done,
     /* 1719845 */   // Label 23518: @1719845
     /* 1719845 */   GIM_Try, /*On fail goto*//*Label 23519*/ GIMT_Encode4(1719931), // Rule ID 10508 //
     /* 1719850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1719853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1719861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1719864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1719867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1719870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719896 */     // MIs[0] policy
     /* 1719896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1719927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719930 */     // GIR_Coverage, 10508,
     /* 1719930 */     GIR_EraseRootFromParent_Done,
     /* 1719931 */   // Label 23519: @1719931
     /* 1719931 */   GIM_Try, /*On fail goto*//*Label 23520*/ GIMT_Encode4(1720017), // Rule ID 10509 //
     /* 1719936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1719939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1719944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1719947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1719950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1719953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1719956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719982 */     // MIs[0] policy
     /* 1719982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719992 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1719995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720016 */     // GIR_Coverage, 10509,
     /* 1720016 */     GIR_EraseRootFromParent_Done,
     /* 1720017 */   // Label 23520: @1720017
     /* 1720017 */   GIM_Try, /*On fail goto*//*Label 23521*/ GIMT_Encode4(1720103), // Rule ID 10512 //
     /* 1720022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1720042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720068 */     // MIs[0] policy
     /* 1720068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720078 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720102 */     // GIR_Coverage, 10512,
     /* 1720102 */     GIR_EraseRootFromParent_Done,
     /* 1720103 */   // Label 23521: @1720103
     /* 1720103 */   GIM_Try, /*On fail goto*//*Label 23522*/ GIMT_Encode4(1720189), // Rule ID 10513 //
     /* 1720108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1720119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1720122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1720125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1720128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720154 */     // MIs[0] policy
     /* 1720154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1720167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720188 */     // GIR_Coverage, 10513,
     /* 1720188 */     GIR_EraseRootFromParent_Done,
     /* 1720189 */   // Label 23522: @1720189
     /* 1720189 */   GIM_Try, /*On fail goto*//*Label 23523*/ GIMT_Encode4(1720275), // Rule ID 10516 //
     /* 1720194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1720214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720240 */     // MIs[0] policy
     /* 1720240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720250 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720274 */     // GIR_Coverage, 10516,
     /* 1720274 */     GIR_EraseRootFromParent_Done,
     /* 1720275 */   // Label 23523: @1720275
     /* 1720275 */   GIM_Try, /*On fail goto*//*Label 23524*/ GIMT_Encode4(1720361), // Rule ID 10517 //
     /* 1720280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1720291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1720294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1720297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1720300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720326 */     // MIs[0] policy
     /* 1720326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720336 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1720339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720360 */     // GIR_Coverage, 10517,
     /* 1720360 */     GIR_EraseRootFromParent_Done,
     /* 1720361 */   // Label 23524: @1720361
     /* 1720361 */   GIM_Try, /*On fail goto*//*Label 23525*/ GIMT_Encode4(1720447), // Rule ID 10520 //
     /* 1720366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720412 */     // MIs[0] policy
     /* 1720412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720422 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1720425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720446 */     // GIR_Coverage, 10520,
     /* 1720446 */     GIR_EraseRootFromParent_Done,
     /* 1720447 */   // Label 23525: @1720447
     /* 1720447 */   GIM_Try, /*On fail goto*//*Label 23526*/ GIMT_Encode4(1720533), // Rule ID 10521 //
     /* 1720452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1720463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1720466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1720469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720498 */     // MIs[0] policy
     /* 1720498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720508 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1720511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720532 */     // GIR_Coverage, 10521,
     /* 1720532 */     GIR_EraseRootFromParent_Done,
     /* 1720533 */   // Label 23526: @1720533
     /* 1720533 */   GIM_Try, /*On fail goto*//*Label 23527*/ GIMT_Encode4(1720619), // Rule ID 10524 //
     /* 1720538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1720549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1720552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1720555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720584 */     // MIs[0] policy
     /* 1720584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720594 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1720597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720618 */     // GIR_Coverage, 10524,
     /* 1720618 */     GIR_EraseRootFromParent_Done,
     /* 1720619 */   // Label 23527: @1720619
     /* 1720619 */   GIM_Try, /*On fail goto*//*Label 23528*/ GIMT_Encode4(1720705), // Rule ID 10525 //
     /* 1720624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1720635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1720638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1720641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720670 */     // MIs[0] policy
     /* 1720670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720680 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1720683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720704 */     // GIR_Coverage, 10525,
     /* 1720704 */     GIR_EraseRootFromParent_Done,
     /* 1720705 */   // Label 23528: @1720705
     /* 1720705 */   GIM_Try, /*On fail goto*//*Label 23529*/ GIMT_Encode4(1720791), // Rule ID 10528 //
     /* 1720710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1720721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1720724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1720727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720756 */     // MIs[0] policy
     /* 1720756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1720769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720790 */     // GIR_Coverage, 10528,
     /* 1720790 */     GIR_EraseRootFromParent_Done,
     /* 1720791 */   // Label 23529: @1720791
     /* 1720791 */   GIM_Try, /*On fail goto*//*Label 23530*/ GIMT_Encode4(1720877), // Rule ID 10529 //
     /* 1720796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1720807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1720810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1720813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720842 */     // MIs[0] policy
     /* 1720842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720852 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1720855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1720873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720876 */     // GIR_Coverage, 10529,
     /* 1720876 */     GIR_EraseRootFromParent_Done,
     /* 1720877 */   // Label 23530: @1720877
     /* 1720877 */   GIM_Try, /*On fail goto*//*Label 23531*/ GIMT_Encode4(1720963), // Rule ID 10532 //
     /* 1720882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1720893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1720896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1720899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1720902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1720920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1720924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720928 */     // MIs[0] policy
     /* 1720928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720938 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1720941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720962 */     // GIR_Coverage, 10532,
     /* 1720962 */     GIR_EraseRootFromParent_Done,
     /* 1720963 */   // Label 23531: @1720963
     /* 1720963 */   GIM_Try, /*On fail goto*//*Label 23532*/ GIMT_Encode4(1721049), // Rule ID 10533 //
     /* 1720968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1720976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1720979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1720982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1720985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1720988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1720991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1720998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721014 */     // MIs[0] policy
     /* 1721014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721024 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1721027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721048 */     // GIR_Coverage, 10533,
     /* 1721048 */     GIR_EraseRootFromParent_Done,
     /* 1721049 */   // Label 23532: @1721049
     /* 1721049 */   GIM_Try, /*On fail goto*//*Label 23533*/ GIMT_Encode4(1721135), // Rule ID 10536 //
     /* 1721054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721100 */     // MIs[0] policy
     /* 1721100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721110 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721134 */     // GIR_Coverage, 10536,
     /* 1721134 */     GIR_EraseRootFromParent_Done,
     /* 1721135 */   // Label 23533: @1721135
     /* 1721135 */   GIM_Try, /*On fail goto*//*Label 23534*/ GIMT_Encode4(1721221), // Rule ID 10537 //
     /* 1721140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1721151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1721154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1721157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721186 */     // MIs[0] policy
     /* 1721186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721220 */     // GIR_Coverage, 10537,
     /* 1721220 */     GIR_EraseRootFromParent_Done,
     /* 1721221 */   // Label 23534: @1721221
     /* 1721221 */   GIM_Try, /*On fail goto*//*Label 23535*/ GIMT_Encode4(1721307), // Rule ID 10540 //
     /* 1721226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721272 */     // MIs[0] policy
     /* 1721272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721282 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721306 */     // GIR_Coverage, 10540,
     /* 1721306 */     GIR_EraseRootFromParent_Done,
     /* 1721307 */   // Label 23535: @1721307
     /* 1721307 */   GIM_Try, /*On fail goto*//*Label 23536*/ GIMT_Encode4(1721393), // Rule ID 10541 //
     /* 1721312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1721323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1721326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1721329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721358 */     // MIs[0] policy
     /* 1721358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721368 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1721371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721392 */     // GIR_Coverage, 10541,
     /* 1721392 */     GIR_EraseRootFromParent_Done,
     /* 1721393 */   // Label 23536: @1721393
     /* 1721393 */   GIM_Try, /*On fail goto*//*Label 23537*/ GIMT_Encode4(1721479), // Rule ID 10544 //
     /* 1721398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721444 */     // MIs[0] policy
     /* 1721444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721478 */     // GIR_Coverage, 10544,
     /* 1721478 */     GIR_EraseRootFromParent_Done,
     /* 1721479 */   // Label 23537: @1721479
     /* 1721479 */   GIM_Try, /*On fail goto*//*Label 23538*/ GIMT_Encode4(1721565), // Rule ID 10545 //
     /* 1721484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1721495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1721498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1721501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721530 */     // MIs[0] policy
     /* 1721530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721540 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721564 */     // GIR_Coverage, 10545,
     /* 1721564 */     GIR_EraseRootFromParent_Done,
     /* 1721565 */   // Label 23538: @1721565
     /* 1721565 */   GIM_Try, /*On fail goto*//*Label 23539*/ GIMT_Encode4(1721651), // Rule ID 10548 //
     /* 1721570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1721581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1721584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1721587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721616 */     // MIs[0] policy
     /* 1721616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721650 */     // GIR_Coverage, 10548,
     /* 1721650 */     GIR_EraseRootFromParent_Done,
     /* 1721651 */   // Label 23539: @1721651
     /* 1721651 */   GIM_Try, /*On fail goto*//*Label 23540*/ GIMT_Encode4(1721737), // Rule ID 10549 //
     /* 1721656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1721667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1721670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1721673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721702 */     // MIs[0] policy
     /* 1721702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721712 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721736 */     // GIR_Coverage, 10549,
     /* 1721736 */     GIR_EraseRootFromParent_Done,
     /* 1721737 */   // Label 23540: @1721737
     /* 1721737 */   GIM_Try, /*On fail goto*//*Label 23541*/ GIMT_Encode4(1721823), // Rule ID 10552 //
     /* 1721742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1721753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1721756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1721759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721788 */     // MIs[0] policy
     /* 1721788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721798 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721822 */     // GIR_Coverage, 10552,
     /* 1721822 */     GIR_EraseRootFromParent_Done,
     /* 1721823 */   // Label 23541: @1721823
     /* 1721823 */   GIM_Try, /*On fail goto*//*Label 23542*/ GIMT_Encode4(1721909), // Rule ID 10553 //
     /* 1721828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1721839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1721842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1721845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721874 */     // MIs[0] policy
     /* 1721874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1721905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721908 */     // GIR_Coverage, 10553,
     /* 1721908 */     GIR_EraseRootFromParent_Done,
     /* 1721909 */   // Label 23542: @1721909
     /* 1721909 */   GIM_Try, /*On fail goto*//*Label 23543*/ GIMT_Encode4(1721995), // Rule ID 10556 //
     /* 1721914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1721922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1721925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1721928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1721931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721960 */     // MIs[0] policy
     /* 1721960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721970 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1721973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721994 */     // GIR_Coverage, 10556,
     /* 1721994 */     GIR_EraseRootFromParent_Done,
     /* 1721995 */   // Label 23543: @1721995
     /* 1721995 */   GIM_Try, /*On fail goto*//*Label 23544*/ GIMT_Encode4(1722081), // Rule ID 10557 //
     /* 1722000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1722003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1722011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1722014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1722017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722046 */     // MIs[0] policy
     /* 1722046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722056 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1722059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722080 */     // GIR_Coverage, 10557,
     /* 1722080 */     GIR_EraseRootFromParent_Done,
     /* 1722081 */   // Label 23544: @1722081
     /* 1722081 */   GIM_Try, /*On fail goto*//*Label 23545*/ GIMT_Encode4(1722167), // Rule ID 10560 //
     /* 1722086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722132 */     // MIs[0] policy
     /* 1722132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722142 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722166 */     // GIR_Coverage, 10560,
     /* 1722166 */     GIR_EraseRootFromParent_Done,
     /* 1722167 */   // Label 23545: @1722167
     /* 1722167 */   GIM_Try, /*On fail goto*//*Label 23546*/ GIMT_Encode4(1722253), // Rule ID 10561 //
     /* 1722172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1722183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1722186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1722189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722218 */     // MIs[0] policy
     /* 1722218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722252 */     // GIR_Coverage, 10561,
     /* 1722252 */     GIR_EraseRootFromParent_Done,
     /* 1722253 */   // Label 23546: @1722253
     /* 1722253 */   GIM_Try, /*On fail goto*//*Label 23547*/ GIMT_Encode4(1722339), // Rule ID 10564 //
     /* 1722258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722304 */     // MIs[0] policy
     /* 1722304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722314 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722338 */     // GIR_Coverage, 10564,
     /* 1722338 */     GIR_EraseRootFromParent_Done,
     /* 1722339 */   // Label 23547: @1722339
     /* 1722339 */   GIM_Try, /*On fail goto*//*Label 23548*/ GIMT_Encode4(1722425), // Rule ID 10565 //
     /* 1722344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1722355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1722358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1722361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722390 */     // MIs[0] policy
     /* 1722390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722400 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722424 */     // GIR_Coverage, 10565,
     /* 1722424 */     GIR_EraseRootFromParent_Done,
     /* 1722425 */   // Label 23548: @1722425
     /* 1722425 */   GIM_Try, /*On fail goto*//*Label 23549*/ GIMT_Encode4(1722511), // Rule ID 10568 //
     /* 1722430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1722441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1722444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1722447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1722453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722476 */     // MIs[0] policy
     /* 1722476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722486 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1722489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722510 */     // GIR_Coverage, 10568,
     /* 1722510 */     GIR_EraseRootFromParent_Done,
     /* 1722511 */   // Label 23549: @1722511
     /* 1722511 */   GIM_Try, /*On fail goto*//*Label 23550*/ GIMT_Encode4(1722597), // Rule ID 10569 //
     /* 1722516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1722527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1722530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1722533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1722539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722562 */     // MIs[0] policy
     /* 1722562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722572 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1722575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722596 */     // GIR_Coverage, 10569,
     /* 1722596 */     GIR_EraseRootFromParent_Done,
     /* 1722597 */   // Label 23550: @1722597
     /* 1722597 */   GIM_Try, /*On fail goto*//*Label 23551*/ GIMT_Encode4(1722683), // Rule ID 10572 //
     /* 1722602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1722613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1722616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1722619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722648 */     // MIs[0] policy
     /* 1722648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722658 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722682 */     // GIR_Coverage, 10572,
     /* 1722682 */     GIR_EraseRootFromParent_Done,
     /* 1722683 */   // Label 23551: @1722683
     /* 1722683 */   GIM_Try, /*On fail goto*//*Label 23552*/ GIMT_Encode4(1722769), // Rule ID 10573 //
     /* 1722688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1722699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1722702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1722705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1722718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1722726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722734 */     // MIs[0] policy
     /* 1722734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1722747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722768 */     // GIR_Coverage, 10573,
     /* 1722768 */     GIR_EraseRootFromParent_Done,
     /* 1722769 */   // Label 23552: @1722769
     /* 1722769 */   GIM_Try, /*On fail goto*//*Label 23553*/ GIMT_Encode4(1722855), // Rule ID 10576 //
     /* 1722774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1722785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1722788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1722791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722820 */     // MIs[0] policy
     /* 1722820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722830 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722854 */     // GIR_Coverage, 10576,
     /* 1722854 */     GIR_EraseRootFromParent_Done,
     /* 1722855 */   // Label 23553: @1722855
     /* 1722855 */   GIM_Try, /*On fail goto*//*Label 23554*/ GIMT_Encode4(1722941), // Rule ID 10577 //
     /* 1722860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1722871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1722874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1722877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1722883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1722890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1722898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722906 */     // MIs[0] policy
     /* 1722906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722916 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1722919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722940 */     // GIR_Coverage, 10577,
     /* 1722940 */     GIR_EraseRootFromParent_Done,
     /* 1722941 */   // Label 23554: @1722941
     /* 1722941 */   GIM_Try, /*On fail goto*//*Label 23555*/ GIMT_Encode4(1723027), // Rule ID 10580 //
     /* 1722946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1722954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1722957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1722960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1722963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1722969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1722976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1722984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722992 */     // MIs[0] policy
     /* 1722992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723002 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723026 */     // GIR_Coverage, 10580,
     /* 1723026 */     GIR_EraseRootFromParent_Done,
     /* 1723027 */   // Label 23555: @1723027
     /* 1723027 */   GIM_Try, /*On fail goto*//*Label 23556*/ GIMT_Encode4(1723113), // Rule ID 10581 //
     /* 1723032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1723043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1723046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1723049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723078 */     // MIs[0] policy
     /* 1723078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723088 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723112 */     // GIR_Coverage, 10581,
     /* 1723112 */     GIR_EraseRootFromParent_Done,
     /* 1723113 */   // Label 23556: @1723113
     /* 1723113 */   GIM_Try, /*On fail goto*//*Label 23557*/ GIMT_Encode4(1723199), // Rule ID 10584 //
     /* 1723118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723164 */     // MIs[0] policy
     /* 1723164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723198 */     // GIR_Coverage, 10584,
     /* 1723198 */     GIR_EraseRootFromParent_Done,
     /* 1723199 */   // Label 23557: @1723199
     /* 1723199 */   GIM_Try, /*On fail goto*//*Label 23558*/ GIMT_Encode4(1723285), // Rule ID 10585 //
     /* 1723204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1723215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1723218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1723221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723250 */     // MIs[0] policy
     /* 1723250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723284 */     // GIR_Coverage, 10585,
     /* 1723284 */     GIR_EraseRootFromParent_Done,
     /* 1723285 */   // Label 23558: @1723285
     /* 1723285 */   GIM_Try, /*On fail goto*//*Label 23559*/ GIMT_Encode4(1723371), // Rule ID 10588 //
     /* 1723290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723336 */     // MIs[0] policy
     /* 1723336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723370 */     // GIR_Coverage, 10588,
     /* 1723370 */     GIR_EraseRootFromParent_Done,
     /* 1723371 */   // Label 23559: @1723371
     /* 1723371 */   GIM_Try, /*On fail goto*//*Label 23560*/ GIMT_Encode4(1723457), // Rule ID 10589 //
     /* 1723376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1723387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1723390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1723393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723422 */     // MIs[0] policy
     /* 1723422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723432 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723456 */     // GIR_Coverage, 10589,
     /* 1723456 */     GIR_EraseRootFromParent_Done,
     /* 1723457 */   // Label 23560: @1723457
     /* 1723457 */   GIM_Try, /*On fail goto*//*Label 23561*/ GIMT_Encode4(1723543), // Rule ID 10592 //
     /* 1723462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1723473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1723476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1723479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723508 */     // MIs[0] policy
     /* 1723508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723542 */     // GIR_Coverage, 10592,
     /* 1723542 */     GIR_EraseRootFromParent_Done,
     /* 1723543 */   // Label 23561: @1723543
     /* 1723543 */   GIM_Try, /*On fail goto*//*Label 23562*/ GIMT_Encode4(1723629), // Rule ID 10593 //
     /* 1723548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1723559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1723562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1723565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723594 */     // MIs[0] policy
     /* 1723594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723604 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1723607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1723625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723628 */     // GIR_Coverage, 10593,
     /* 1723628 */     GIR_EraseRootFromParent_Done,
     /* 1723629 */   // Label 23562: @1723629
     /* 1723629 */   GIM_Try, /*On fail goto*//*Label 23563*/ GIMT_Encode4(1723715), // Rule ID 10596 //
     /* 1723634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1723645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1723648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1723651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723680 */     // MIs[0] policy
     /* 1723680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723714 */     // GIR_Coverage, 10596,
     /* 1723714 */     GIR_EraseRootFromParent_Done,
     /* 1723715 */   // Label 23563: @1723715
     /* 1723715 */   GIM_Try, /*On fail goto*//*Label 23564*/ GIMT_Encode4(1723801), // Rule ID 10597 //
     /* 1723720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1723723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1723731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1723734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1723737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1723743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723766 */     // MIs[0] policy
     /* 1723766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11433:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1723779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723800 */     // GIR_Coverage, 10597,
     /* 1723800 */     GIR_EraseRootFromParent_Done,
     /* 1723801 */   // Label 23564: @1723801
     /* 1723801 */   GIM_Try, /*On fail goto*//*Label 23565*/ GIMT_Encode4(1723887), // Rule ID 10600 //
     /* 1723806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1723817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1723820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1723823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723852 */     // MIs[0] policy
     /* 1723852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723886 */     // GIR_Coverage, 10600,
     /* 1723886 */     GIR_EraseRootFromParent_Done,
     /* 1723887 */   // Label 23565: @1723887
     /* 1723887 */   GIM_Try, /*On fail goto*//*Label 23566*/ GIMT_Encode4(1723973), // Rule ID 10601 //
     /* 1723892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1723895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1723903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1723906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1723909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1723915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723938 */     // MIs[0] policy
     /* 1723938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11433:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1723951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723972 */     // GIR_Coverage, 10601,
     /* 1723972 */     GIR_EraseRootFromParent_Done,
     /* 1723973 */   // Label 23566: @1723973
     /* 1723973 */   GIM_Try, /*On fail goto*//*Label 23567*/ GIMT_Encode4(1724059), // Rule ID 10604 //
     /* 1723978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1723981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1723986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1723989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1723992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1723995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724024 */     // MIs[0] policy
     /* 1724024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724058 */     // GIR_Coverage, 10604,
     /* 1724058 */     GIR_EraseRootFromParent_Done,
     /* 1724059 */   // Label 23567: @1724059
     /* 1724059 */   GIM_Try, /*On fail goto*//*Label 23568*/ GIMT_Encode4(1724145), // Rule ID 10605 //
     /* 1724064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1724072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724110 */     // MIs[0] policy
     /* 1724110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724120 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11433:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1724123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724144 */     // GIR_Coverage, 10605,
     /* 1724144 */     GIR_EraseRootFromParent_Done,
     /* 1724145 */   // Label 23568: @1724145
     /* 1724145 */   GIM_Try, /*On fail goto*//*Label 23569*/ GIMT_Encode4(1724231), // Rule ID 10608 //
     /* 1724150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1724170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724196 */     // MIs[0] policy
     /* 1724196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724206 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1724209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724230 */     // GIR_Coverage, 10608,
     /* 1724230 */     GIR_EraseRootFromParent_Done,
     /* 1724231 */   // Label 23569: @1724231
     /* 1724231 */   GIM_Try, /*On fail goto*//*Label 23570*/ GIMT_Encode4(1724317), // Rule ID 10609 //
     /* 1724236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1724247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1724250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1724253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1724256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724282 */     // MIs[0] policy
     /* 1724282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724292 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1724295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724316 */     // GIR_Coverage, 10609,
     /* 1724316 */     GIR_EraseRootFromParent_Done,
     /* 1724317 */   // Label 23570: @1724317
     /* 1724317 */   GIM_Try, /*On fail goto*//*Label 23571*/ GIMT_Encode4(1724403), // Rule ID 10612 //
     /* 1724322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1724342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724368 */     // MIs[0] policy
     /* 1724368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724378 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724402 */     // GIR_Coverage, 10612,
     /* 1724402 */     GIR_EraseRootFromParent_Done,
     /* 1724403 */   // Label 23571: @1724403
     /* 1724403 */   GIM_Try, /*On fail goto*//*Label 23572*/ GIMT_Encode4(1724489), // Rule ID 10613 //
     /* 1724408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1724419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1724422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1724425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1724428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724454 */     // MIs[0] policy
     /* 1724454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724464 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724488 */     // GIR_Coverage, 10613,
     /* 1724488 */     GIR_EraseRootFromParent_Done,
     /* 1724489 */   // Label 23572: @1724489
     /* 1724489 */   GIM_Try, /*On fail goto*//*Label 23573*/ GIMT_Encode4(1724575), // Rule ID 10616 //
     /* 1724494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1724505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1724508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1724511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1724514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724540 */     // MIs[0] policy
     /* 1724540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724550 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1724553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724574 */     // GIR_Coverage, 10616,
     /* 1724574 */     GIR_EraseRootFromParent_Done,
     /* 1724575 */   // Label 23573: @1724575
     /* 1724575 */   GIM_Try, /*On fail goto*//*Label 23574*/ GIMT_Encode4(1724661), // Rule ID 10617 //
     /* 1724580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1724591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1724594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1724597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1724600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724626 */     // MIs[0] policy
     /* 1724626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724636 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1724639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1724657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724660 */     // GIR_Coverage, 10617,
     /* 1724660 */     GIR_EraseRootFromParent_Done,
     /* 1724661 */   // Label 23574: @1724661
     /* 1724661 */   GIM_Try, /*On fail goto*//*Label 23575*/ GIMT_Encode4(1724747), // Rule ID 10620 //
     /* 1724666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1724677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1724680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1724683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1724686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724712 */     // MIs[0] policy
     /* 1724712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724722 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724746 */     // GIR_Coverage, 10620,
     /* 1724746 */     GIR_EraseRootFromParent_Done,
     /* 1724747 */   // Label 23575: @1724747
     /* 1724747 */   GIM_Try, /*On fail goto*//*Label 23576*/ GIMT_Encode4(1724833), // Rule ID 10621 //
     /* 1724752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1724763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1724766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1724769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1724772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1724775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724798 */     // MIs[0] policy
     /* 1724798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724808 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1724811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724832 */     // GIR_Coverage, 10621,
     /* 1724832 */     GIR_EraseRootFromParent_Done,
     /* 1724833 */   // Label 23576: @1724833
     /* 1724833 */   GIM_Try, /*On fail goto*//*Label 23577*/ GIMT_Encode4(1724919), // Rule ID 10624 //
     /* 1724838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1724849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1724852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1724855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1724858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724884 */     // MIs[0] policy
     /* 1724884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724894 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1724897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724918 */     // GIR_Coverage, 10624,
     /* 1724918 */     GIR_EraseRootFromParent_Done,
     /* 1724919 */   // Label 23577: @1724919
     /* 1724919 */   GIM_Try, /*On fail goto*//*Label 23578*/ GIMT_Encode4(1725005), // Rule ID 10625 //
     /* 1724924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1724935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1724938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1724941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1724944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1724954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1724966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724970 */     // MIs[0] policy
     /* 1724970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1724983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725004 */     // GIR_Coverage, 10625,
     /* 1725004 */     GIR_EraseRootFromParent_Done,
     /* 1725005 */   // Label 23578: @1725005
     /* 1725005 */   GIM_Try, /*On fail goto*//*Label 23579*/ GIMT_Encode4(1725091), // Rule ID 10628 //
     /* 1725010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1725030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725056 */     // MIs[0] policy
     /* 1725056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725090 */     // GIR_Coverage, 10628,
     /* 1725090 */     GIR_EraseRootFromParent_Done,
     /* 1725091 */   // Label 23579: @1725091
     /* 1725091 */   GIM_Try, /*On fail goto*//*Label 23580*/ GIMT_Encode4(1725177), // Rule ID 10629 //
     /* 1725096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1725107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1725110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1725113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1725116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725142 */     // MIs[0] policy
     /* 1725142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725152 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1725155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725176 */     // GIR_Coverage, 10629,
     /* 1725176 */     GIR_EraseRootFromParent_Done,
     /* 1725177 */   // Label 23580: @1725177
     /* 1725177 */   GIM_Try, /*On fail goto*//*Label 23581*/ GIMT_Encode4(1725263), // Rule ID 10632 //
     /* 1725182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1725202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725228 */     // MIs[0] policy
     /* 1725228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725238 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725262 */     // GIR_Coverage, 10632,
     /* 1725262 */     GIR_EraseRootFromParent_Done,
     /* 1725263 */   // Label 23581: @1725263
     /* 1725263 */   GIM_Try, /*On fail goto*//*Label 23582*/ GIMT_Encode4(1725349), // Rule ID 10633 //
     /* 1725268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1725279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1725282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1725285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1725288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725314 */     // MIs[0] policy
     /* 1725314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725348 */     // GIR_Coverage, 10633,
     /* 1725348 */     GIR_EraseRootFromParent_Done,
     /* 1725349 */   // Label 23582: @1725349
     /* 1725349 */   GIM_Try, /*On fail goto*//*Label 23583*/ GIMT_Encode4(1725435), // Rule ID 10636 //
     /* 1725354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1725374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725400 */     // MIs[0] policy
     /* 1725400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725410 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725434 */     // GIR_Coverage, 10636,
     /* 1725434 */     GIR_EraseRootFromParent_Done,
     /* 1725435 */   // Label 23583: @1725435
     /* 1725435 */   GIM_Try, /*On fail goto*//*Label 23584*/ GIMT_Encode4(1725521), // Rule ID 10637 //
     /* 1725440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1725451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1725454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1725457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1725460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725486 */     // MIs[0] policy
     /* 1725486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725520 */     // GIR_Coverage, 10637,
     /* 1725520 */     GIR_EraseRootFromParent_Done,
     /* 1725521 */   // Label 23584: @1725521
     /* 1725521 */   GIM_Try, /*On fail goto*//*Label 23585*/ GIMT_Encode4(1725607), // Rule ID 10640 //
     /* 1725526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1725537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1725540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1725543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1725546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725572 */     // MIs[0] policy
     /* 1725572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725582 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725606 */     // GIR_Coverage, 10640,
     /* 1725606 */     GIR_EraseRootFromParent_Done,
     /* 1725607 */   // Label 23585: @1725607
     /* 1725607 */   GIM_Try, /*On fail goto*//*Label 23586*/ GIMT_Encode4(1725693), // Rule ID 10641 //
     /* 1725612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1725623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1725626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1725629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1725632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725658 */     // MIs[0] policy
     /* 1725658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1725689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725692 */     // GIR_Coverage, 10641,
     /* 1725692 */     GIR_EraseRootFromParent_Done,
     /* 1725693 */   // Label 23586: @1725693
     /* 1725693 */   GIM_Try, /*On fail goto*//*Label 23587*/ GIMT_Encode4(1725779), // Rule ID 10644 //
     /* 1725698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1725701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1725709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1725712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1725715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1725718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725744 */     // MIs[0] policy
     /* 1725744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725778 */     // GIR_Coverage, 10644,
     /* 1725778 */     GIR_EraseRootFromParent_Done,
     /* 1725779 */   // Label 23587: @1725779
     /* 1725779 */   GIM_Try, /*On fail goto*//*Label 23588*/ GIMT_Encode4(1725865), // Rule ID 10645 //
     /* 1725784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1725795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1725798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1725801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1725804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725830 */     // MIs[0] policy
     /* 1725830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725840 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1725843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725864 */     // GIR_Coverage, 10645,
     /* 1725864 */     GIR_EraseRootFromParent_Done,
     /* 1725865 */   // Label 23588: @1725865
     /* 1725865 */   GIM_Try, /*On fail goto*//*Label 23589*/ GIMT_Encode4(1725951), // Rule ID 10648 //
     /* 1725870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1725881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1725884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1725887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1725890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1725893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725916 */     // MIs[0] policy
     /* 1725916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725926 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1725929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725950 */     // GIR_Coverage, 10648,
     /* 1725950 */     GIR_EraseRootFromParent_Done,
     /* 1725951 */   // Label 23589: @1725951
     /* 1725951 */   GIM_Try, /*On fail goto*//*Label 23590*/ GIMT_Encode4(1726037), // Rule ID 10649 //
     /* 1725956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1725967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1725970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1725973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1725976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1725979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1725986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1725998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726002 */     // MIs[0] policy
     /* 1726002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726036 */     // GIR_Coverage, 10649,
     /* 1726036 */     GIR_EraseRootFromParent_Done,
     /* 1726037 */   // Label 23590: @1726037
     /* 1726037 */   GIM_Try, /*On fail goto*//*Label 23591*/ GIMT_Encode4(1726123), // Rule ID 10652 //
     /* 1726042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1726062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726088 */     // MIs[0] policy
     /* 1726088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726098 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726122 */     // GIR_Coverage, 10652,
     /* 1726122 */     GIR_EraseRootFromParent_Done,
     /* 1726123 */   // Label 23591: @1726123
     /* 1726123 */   GIM_Try, /*On fail goto*//*Label 23592*/ GIMT_Encode4(1726209), // Rule ID 10653 //
     /* 1726128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1726139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1726142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1726145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1726148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726174 */     // MIs[0] policy
     /* 1726174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726184 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726208 */     // GIR_Coverage, 10653,
     /* 1726208 */     GIR_EraseRootFromParent_Done,
     /* 1726209 */   // Label 23592: @1726209
     /* 1726209 */   GIM_Try, /*On fail goto*//*Label 23593*/ GIMT_Encode4(1726295), // Rule ID 10656 //
     /* 1726214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1726234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726260 */     // MIs[0] policy
     /* 1726260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726270 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726294 */     // GIR_Coverage, 10656,
     /* 1726294 */     GIR_EraseRootFromParent_Done,
     /* 1726295 */   // Label 23593: @1726295
     /* 1726295 */   GIM_Try, /*On fail goto*//*Label 23594*/ GIMT_Encode4(1726381), // Rule ID 10657 //
     /* 1726300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1726311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1726314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1726317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1726320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1726323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726346 */     // MIs[0] policy
     /* 1726346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726356 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726380 */     // GIR_Coverage, 10657,
     /* 1726380 */     GIR_EraseRootFromParent_Done,
     /* 1726381 */   // Label 23594: @1726381
     /* 1726381 */   GIM_Try, /*On fail goto*//*Label 23595*/ GIMT_Encode4(1726467), // Rule ID 10660 //
     /* 1726386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1726406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726432 */     // MIs[0] policy
     /* 1726432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726466 */     // GIR_Coverage, 10660,
     /* 1726466 */     GIR_EraseRootFromParent_Done,
     /* 1726467 */   // Label 23595: @1726467
     /* 1726467 */   GIM_Try, /*On fail goto*//*Label 23596*/ GIMT_Encode4(1726553), // Rule ID 10661 //
     /* 1726472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1726483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1726486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1726489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1726492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726518 */     // MIs[0] policy
     /* 1726518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726552 */     // GIR_Coverage, 10661,
     /* 1726552 */     GIR_EraseRootFromParent_Done,
     /* 1726553 */   // Label 23596: @1726553
     /* 1726553 */   GIM_Try, /*On fail goto*//*Label 23597*/ GIMT_Encode4(1726639), // Rule ID 10664 //
     /* 1726558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1726569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1726572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1726575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1726578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726604 */     // MIs[0] policy
     /* 1726604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726614 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726638 */     // GIR_Coverage, 10664,
     /* 1726638 */     GIR_EraseRootFromParent_Done,
     /* 1726639 */   // Label 23597: @1726639
     /* 1726639 */   GIM_Try, /*On fail goto*//*Label 23598*/ GIMT_Encode4(1726725), // Rule ID 10665 //
     /* 1726644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1726655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1726658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1726661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1726664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1726674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1726686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726690 */     // MIs[0] policy
     /* 1726690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726700 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1726703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726724 */     // GIR_Coverage, 10665,
     /* 1726724 */     GIR_EraseRootFromParent_Done,
     /* 1726725 */   // Label 23598: @1726725
     /* 1726725 */   GIM_Try, /*On fail goto*//*Label 23599*/ GIMT_Encode4(1726811), // Rule ID 10668 //
     /* 1726730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1726741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1726744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1726747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1726750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726776 */     // MIs[0] policy
     /* 1726776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726786 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726810 */     // GIR_Coverage, 10668,
     /* 1726810 */     GIR_EraseRootFromParent_Done,
     /* 1726811 */   // Label 23599: @1726811
     /* 1726811 */   GIM_Try, /*On fail goto*//*Label 23600*/ GIMT_Encode4(1726897), // Rule ID 10669 //
     /* 1726816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1726827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1726830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1726833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1726836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1726839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1726846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1726858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726862 */     // MIs[0] policy
     /* 1726862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726872 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1726875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726896 */     // GIR_Coverage, 10669,
     /* 1726896 */     GIR_EraseRootFromParent_Done,
     /* 1726897 */   // Label 23600: @1726897
     /* 1726897 */   GIM_Try, /*On fail goto*//*Label 23601*/ GIMT_Encode4(1726983), // Rule ID 10672 //
     /* 1726902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1726913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1726916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1726919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1726922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726948 */     // MIs[0] policy
     /* 1726948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726958 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1726961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726982 */     // GIR_Coverage, 10672,
     /* 1726982 */     GIR_EraseRootFromParent_Done,
     /* 1726983 */   // Label 23601: @1726983
     /* 1726983 */   GIM_Try, /*On fail goto*//*Label 23602*/ GIMT_Encode4(1727069), // Rule ID 10673 //
     /* 1726988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1726996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1726999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1727002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1727005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1727008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727034 */     // MIs[0] policy
     /* 1727034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727068 */     // GIR_Coverage, 10673,
     /* 1727068 */     GIR_EraseRootFromParent_Done,
     /* 1727069 */   // Label 23602: @1727069
     /* 1727069 */   GIM_Try, /*On fail goto*//*Label 23603*/ GIMT_Encode4(1727155), // Rule ID 10676 //
     /* 1727074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1727094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727120 */     // MIs[0] policy
     /* 1727120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727130 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727154 */     // GIR_Coverage, 10676,
     /* 1727154 */     GIR_EraseRootFromParent_Done,
     /* 1727155 */   // Label 23603: @1727155
     /* 1727155 */   GIM_Try, /*On fail goto*//*Label 23604*/ GIMT_Encode4(1727241), // Rule ID 10677 //
     /* 1727160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1727171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1727174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1727177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1727180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727206 */     // MIs[0] policy
     /* 1727206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727240 */     // GIR_Coverage, 10677,
     /* 1727240 */     GIR_EraseRootFromParent_Done,
     /* 1727241 */   // Label 23604: @1727241
     /* 1727241 */   GIM_Try, /*On fail goto*//*Label 23605*/ GIMT_Encode4(1727327), // Rule ID 10680 //
     /* 1727246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1727266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727292 */     // MIs[0] policy
     /* 1727292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727302 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727326 */     // GIR_Coverage, 10680,
     /* 1727326 */     GIR_EraseRootFromParent_Done,
     /* 1727327 */   // Label 23605: @1727327
     /* 1727327 */   GIM_Try, /*On fail goto*//*Label 23606*/ GIMT_Encode4(1727413), // Rule ID 10681 //
     /* 1727332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1727343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1727346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1727349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1727352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727378 */     // MIs[0] policy
     /* 1727378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727388 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727412 */     // GIR_Coverage, 10681,
     /* 1727412 */     GIR_EraseRootFromParent_Done,
     /* 1727413 */   // Label 23606: @1727413
     /* 1727413 */   GIM_Try, /*On fail goto*//*Label 23607*/ GIMT_Encode4(1727499), // Rule ID 10684 //
     /* 1727418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1727438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727464 */     // MIs[0] policy
     /* 1727464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727498 */     // GIR_Coverage, 10684,
     /* 1727498 */     GIR_EraseRootFromParent_Done,
     /* 1727499 */   // Label 23607: @1727499
     /* 1727499 */   GIM_Try, /*On fail goto*//*Label 23608*/ GIMT_Encode4(1727585), // Rule ID 10685 //
     /* 1727504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1727515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1727518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1727521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1727524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1727527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727550 */     // MIs[0] policy
     /* 1727550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727560 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1727563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727584 */     // GIR_Coverage, 10685,
     /* 1727584 */     GIR_EraseRootFromParent_Done,
     /* 1727585 */   // Label 23608: @1727585
     /* 1727585 */   GIM_Try, /*On fail goto*//*Label 23609*/ GIMT_Encode4(1727671), // Rule ID 10688 //
     /* 1727590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1727601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1727604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1727607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1727610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727636 */     // MIs[0] policy
     /* 1727636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727646 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727670 */     // GIR_Coverage, 10688,
     /* 1727670 */     GIR_EraseRootFromParent_Done,
     /* 1727671 */   // Label 23609: @1727671
     /* 1727671 */   GIM_Try, /*On fail goto*//*Label 23610*/ GIMT_Encode4(1727757), // Rule ID 10689 //
     /* 1727676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1727687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1727690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1727693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1727696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727722 */     // MIs[0] policy
     /* 1727722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727732 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1727735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727756 */     // GIR_Coverage, 10689,
     /* 1727756 */     GIR_EraseRootFromParent_Done,
     /* 1727757 */   // Label 23610: @1727757
     /* 1727757 */   GIM_Try, /*On fail goto*//*Label 23611*/ GIMT_Encode4(1727843), // Rule ID 10692 //
     /* 1727762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1727765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1727773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1727776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1727779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1727782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727808 */     // MIs[0] policy
     /* 1727808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727818 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727842 */     // GIR_Coverage, 10692,
     /* 1727842 */     GIR_EraseRootFromParent_Done,
     /* 1727843 */   // Label 23611: @1727843
     /* 1727843 */   GIM_Try, /*On fail goto*//*Label 23612*/ GIMT_Encode4(1727929), // Rule ID 10693 //
     /* 1727848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1727851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1727859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1727862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1727865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1727868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727894 */     // MIs[0] policy
     /* 1727894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727904 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1727907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1727925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727928 */     // GIR_Coverage, 10693,
     /* 1727928 */     GIR_EraseRootFromParent_Done,
     /* 1727929 */   // Label 23612: @1727929
     /* 1727929 */   GIM_Try, /*On fail goto*//*Label 23613*/ GIMT_Encode4(1728015), // Rule ID 10696 //
     /* 1727934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1727942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1727945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1727948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1727951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1727954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1727957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1727964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1727972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1727976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727980 */     // MIs[0] policy
     /* 1727980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727990 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1727993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728014 */     // GIR_Coverage, 10696,
     /* 1728014 */     GIR_EraseRootFromParent_Done,
     /* 1728015 */   // Label 23613: @1728015
     /* 1728015 */   GIM_Try, /*On fail goto*//*Label 23614*/ GIMT_Encode4(1728101), // Rule ID 10697 //
     /* 1728020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1728031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1728034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1728037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728066 */     // MIs[0] policy
     /* 1728066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728076 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1728079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728100 */     // GIR_Coverage, 10697,
     /* 1728100 */     GIR_EraseRootFromParent_Done,
     /* 1728101 */   // Label 23614: @1728101
     /* 1728101 */   GIM_Try, /*On fail goto*//*Label 23615*/ GIMT_Encode4(1728187), // Rule ID 10700 //
     /* 1728106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728152 */     // MIs[0] policy
     /* 1728152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728162 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728186 */     // GIR_Coverage, 10700,
     /* 1728186 */     GIR_EraseRootFromParent_Done,
     /* 1728187 */   // Label 23615: @1728187
     /* 1728187 */   GIM_Try, /*On fail goto*//*Label 23616*/ GIMT_Encode4(1728273), // Rule ID 10701 //
     /* 1728192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1728203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1728206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1728209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728238 */     // MIs[0] policy
     /* 1728238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728248 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728272 */     // GIR_Coverage, 10701,
     /* 1728272 */     GIR_EraseRootFromParent_Done,
     /* 1728273 */   // Label 23616: @1728273
     /* 1728273 */   GIM_Try, /*On fail goto*//*Label 23617*/ GIMT_Encode4(1728359), // Rule ID 10704 //
     /* 1728278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728324 */     // MIs[0] policy
     /* 1728324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728358 */     // GIR_Coverage, 10704,
     /* 1728358 */     GIR_EraseRootFromParent_Done,
     /* 1728359 */   // Label 23617: @1728359
     /* 1728359 */   GIM_Try, /*On fail goto*//*Label 23618*/ GIMT_Encode4(1728445), // Rule ID 10705 //
     /* 1728364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1728375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1728378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1728381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728410 */     // MIs[0] policy
     /* 1728410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728420 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728444 */     // GIR_Coverage, 10705,
     /* 1728444 */     GIR_EraseRootFromParent_Done,
     /* 1728445 */   // Label 23618: @1728445
     /* 1728445 */   GIM_Try, /*On fail goto*//*Label 23619*/ GIMT_Encode4(1728531), // Rule ID 10708 //
     /* 1728450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1728461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1728464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1728467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728496 */     // MIs[0] policy
     /* 1728496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728506 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728530 */     // GIR_Coverage, 10708,
     /* 1728530 */     GIR_EraseRootFromParent_Done,
     /* 1728531 */   // Label 23619: @1728531
     /* 1728531 */   GIM_Try, /*On fail goto*//*Label 23620*/ GIMT_Encode4(1728617), // Rule ID 10709 //
     /* 1728536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1728547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1728550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1728553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728582 */     // MIs[0] policy
     /* 1728582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728592 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1728595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728616 */     // GIR_Coverage, 10709,
     /* 1728616 */     GIR_EraseRootFromParent_Done,
     /* 1728617 */   // Label 23620: @1728617
     /* 1728617 */   GIM_Try, /*On fail goto*//*Label 23621*/ GIMT_Encode4(1728703), // Rule ID 10712 //
     /* 1728622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1728633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1728636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1728639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728668 */     // MIs[0] policy
     /* 1728668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728678 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728702 */     // GIR_Coverage, 10712,
     /* 1728702 */     GIR_EraseRootFromParent_Done,
     /* 1728703 */   // Label 23621: @1728703
     /* 1728703 */   GIM_Try, /*On fail goto*//*Label 23622*/ GIMT_Encode4(1728789), // Rule ID 10713 //
     /* 1728708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1728719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1728722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1728725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728754 */     // MIs[0] policy
     /* 1728754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1728785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728788 */     // GIR_Coverage, 10713,
     /* 1728788 */     GIR_EraseRootFromParent_Done,
     /* 1728789 */   // Label 23622: @1728789
     /* 1728789 */   GIM_Try, /*On fail goto*//*Label 23623*/ GIMT_Encode4(1728875), // Rule ID 10716 //
     /* 1728794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1728805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1728808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1728811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728840 */     // MIs[0] policy
     /* 1728840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728850 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728874 */     // GIR_Coverage, 10716,
     /* 1728874 */     GIR_EraseRootFromParent_Done,
     /* 1728875 */   // Label 23623: @1728875
     /* 1728875 */   GIM_Try, /*On fail goto*//*Label 23624*/ GIMT_Encode4(1728961), // Rule ID 10717 //
     /* 1728880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1728891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1728894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1728897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1728900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728926 */     // MIs[0] policy
     /* 1728926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728936 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1728939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728960 */     // GIR_Coverage, 10717,
     /* 1728960 */     GIR_EraseRootFromParent_Done,
     /* 1728961 */   // Label 23624: @1728961
     /* 1728961 */   GIM_Try, /*On fail goto*//*Label 23625*/ GIMT_Encode4(1729047), // Rule ID 10720 //
     /* 1728966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1728974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1728977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1728980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1728983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729012 */     // MIs[0] policy
     /* 1729012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729022 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729046 */     // GIR_Coverage, 10720,
     /* 1729046 */     GIR_EraseRootFromParent_Done,
     /* 1729047 */   // Label 23625: @1729047
     /* 1729047 */   GIM_Try, /*On fail goto*//*Label 23626*/ GIMT_Encode4(1729133), // Rule ID 10721 //
     /* 1729052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1729063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1729066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1729069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729098 */     // MIs[0] policy
     /* 1729098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729108 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729132 */     // GIR_Coverage, 10721,
     /* 1729132 */     GIR_EraseRootFromParent_Done,
     /* 1729133 */   // Label 23626: @1729133
     /* 1729133 */   GIM_Try, /*On fail goto*//*Label 23627*/ GIMT_Encode4(1729219), // Rule ID 10724 //
     /* 1729138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729184 */     // MIs[0] policy
     /* 1729184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729218 */     // GIR_Coverage, 10724,
     /* 1729218 */     GIR_EraseRootFromParent_Done,
     /* 1729219 */   // Label 23627: @1729219
     /* 1729219 */   GIM_Try, /*On fail goto*//*Label 23628*/ GIMT_Encode4(1729305), // Rule ID 10725 //
     /* 1729224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1729235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1729238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1729241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729270 */     // MIs[0] policy
     /* 1729270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729304 */     // GIR_Coverage, 10725,
     /* 1729304 */     GIR_EraseRootFromParent_Done,
     /* 1729305 */   // Label 23628: @1729305
     /* 1729305 */   GIM_Try, /*On fail goto*//*Label 23629*/ GIMT_Encode4(1729391), // Rule ID 10728 //
     /* 1729310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729356 */     // MIs[0] policy
     /* 1729356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729390 */     // GIR_Coverage, 10728,
     /* 1729390 */     GIR_EraseRootFromParent_Done,
     /* 1729391 */   // Label 23629: @1729391
     /* 1729391 */   GIM_Try, /*On fail goto*//*Label 23630*/ GIMT_Encode4(1729477), // Rule ID 10729 //
     /* 1729396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1729407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1729410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1729413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729442 */     // MIs[0] policy
     /* 1729442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729452 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729476 */     // GIR_Coverage, 10729,
     /* 1729476 */     GIR_EraseRootFromParent_Done,
     /* 1729477 */   // Label 23630: @1729477
     /* 1729477 */   GIM_Try, /*On fail goto*//*Label 23631*/ GIMT_Encode4(1729563), // Rule ID 10732 //
     /* 1729482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1729485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1729493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1729496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1729499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729528 */     // MIs[0] policy
     /* 1729528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729562 */     // GIR_Coverage, 10732,
     /* 1729562 */     GIR_EraseRootFromParent_Done,
     /* 1729563 */   // Label 23631: @1729563
     /* 1729563 */   GIM_Try, /*On fail goto*//*Label 23632*/ GIMT_Encode4(1729649), // Rule ID 10733 //
     /* 1729568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1729571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1729579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1729582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1729585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729614 */     // MIs[0] policy
     /* 1729614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1729627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1729645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729648 */     // GIR_Coverage, 10733,
     /* 1729648 */     GIR_EraseRootFromParent_Done,
     /* 1729649 */   // Label 23632: @1729649
     /* 1729649 */   GIM_Try, /*On fail goto*//*Label 23633*/ GIMT_Encode4(1729735), // Rule ID 10736 //
     /* 1729654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1729665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1729668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1729671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1729677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1729684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729700 */     // MIs[0] policy
     /* 1729700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1729713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729734 */     // GIR_Coverage, 10736,
     /* 1729734 */     GIR_EraseRootFromParent_Done,
     /* 1729735 */   // Label 23633: @1729735
     /* 1729735 */   GIM_Try, /*On fail goto*//*Label 23634*/ GIMT_Encode4(1729821), // Rule ID 10737 //
     /* 1729740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1729751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1729754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1729757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1729763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1729770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1729778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729786 */     // MIs[0] policy
     /* 1729786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1729799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729820 */     // GIR_Coverage, 10737,
     /* 1729820 */     GIR_EraseRootFromParent_Done,
     /* 1729821 */   // Label 23634: @1729821
     /* 1729821 */   GIM_Try, /*On fail goto*//*Label 23635*/ GIMT_Encode4(1729907), // Rule ID 10740 //
     /* 1729826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1729837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1729840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1729843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1729849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729872 */     // MIs[0] policy
     /* 1729872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729882 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1729885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729906 */     // GIR_Coverage, 10740,
     /* 1729906 */     GIR_EraseRootFromParent_Done,
     /* 1729907 */   // Label 23635: @1729907
     /* 1729907 */   GIM_Try, /*On fail goto*//*Label 23636*/ GIMT_Encode4(1729993), // Rule ID 10741 //
     /* 1729912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1729920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1729923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1729926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1729929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1729935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1729942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1729950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729958 */     // MIs[0] policy
     /* 1729958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729968 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1729971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729992 */     // GIR_Coverage, 10741,
     /* 1729992 */     GIR_EraseRootFromParent_Done,
     /* 1729993 */   // Label 23636: @1729993
     /* 1729993 */   GIM_Try, /*On fail goto*//*Label 23637*/ GIMT_Encode4(1730079), // Rule ID 10744 //
     /* 1729998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730044 */     // MIs[0] policy
     /* 1730044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730054 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730078 */     // GIR_Coverage, 10744,
     /* 1730078 */     GIR_EraseRootFromParent_Done,
     /* 1730079 */   // Label 23637: @1730079
     /* 1730079 */   GIM_Try, /*On fail goto*//*Label 23638*/ GIMT_Encode4(1730165), // Rule ID 10745 //
     /* 1730084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1730107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730130 */     // MIs[0] policy
     /* 1730130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730140 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730164 */     // GIR_Coverage, 10745,
     /* 1730164 */     GIR_EraseRootFromParent_Done,
     /* 1730165 */   // Label 23638: @1730165
     /* 1730165 */   GIM_Try, /*On fail goto*//*Label 23639*/ GIMT_Encode4(1730251), // Rule ID 10748 //
     /* 1730170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730216 */     // MIs[0] policy
     /* 1730216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730250 */     // GIR_Coverage, 10748,
     /* 1730250 */     GIR_EraseRootFromParent_Done,
     /* 1730251 */   // Label 23639: @1730251
     /* 1730251 */   GIM_Try, /*On fail goto*//*Label 23640*/ GIMT_Encode4(1730337), // Rule ID 10749 //
     /* 1730256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1730267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1730270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1730273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730302 */     // MIs[0] policy
     /* 1730302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730336 */     // GIR_Coverage, 10749,
     /* 1730336 */     GIR_EraseRootFromParent_Done,
     /* 1730337 */   // Label 23640: @1730337
     /* 1730337 */   GIM_Try, /*On fail goto*//*Label 23641*/ GIMT_Encode4(1730423), // Rule ID 10752 //
     /* 1730342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730388 */     // MIs[0] policy
     /* 1730388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730398 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730422 */     // GIR_Coverage, 10752,
     /* 1730422 */     GIR_EraseRootFromParent_Done,
     /* 1730423 */   // Label 23641: @1730423
     /* 1730423 */   GIM_Try, /*On fail goto*//*Label 23642*/ GIMT_Encode4(1730509), // Rule ID 10753 //
     /* 1730428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1730439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1730442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1730445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730474 */     // MIs[0] policy
     /* 1730474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730508 */     // GIR_Coverage, 10753,
     /* 1730508 */     GIR_EraseRootFromParent_Done,
     /* 1730509 */   // Label 23642: @1730509
     /* 1730509 */   GIM_Try, /*On fail goto*//*Label 23643*/ GIMT_Encode4(1730595), // Rule ID 10756 //
     /* 1730514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1730525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1730528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1730531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730560 */     // MIs[0] policy
     /* 1730560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730594 */     // GIR_Coverage, 10756,
     /* 1730594 */     GIR_EraseRootFromParent_Done,
     /* 1730595 */   // Label 23643: @1730595
     /* 1730595 */   GIM_Try, /*On fail goto*//*Label 23644*/ GIMT_Encode4(1730681), // Rule ID 10757 //
     /* 1730600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1730611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1730614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1730617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1730630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1730638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730646 */     // MIs[0] policy
     /* 1730646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730656 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1730659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730680 */     // GIR_Coverage, 10757,
     /* 1730680 */     GIR_EraseRootFromParent_Done,
     /* 1730681 */   // Label 23644: @1730681
     /* 1730681 */   GIM_Try, /*On fail goto*//*Label 23645*/ GIMT_Encode4(1730767), // Rule ID 10760 //
     /* 1730686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1730697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1730700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1730703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730732 */     // MIs[0] policy
     /* 1730732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730766 */     // GIR_Coverage, 10760,
     /* 1730766 */     GIR_EraseRootFromParent_Done,
     /* 1730767 */   // Label 23645: @1730767
     /* 1730767 */   GIM_Try, /*On fail goto*//*Label 23646*/ GIMT_Encode4(1730853), // Rule ID 10761 //
     /* 1730772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1730783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1730786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1730789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730818 */     // MIs[0] policy
     /* 1730818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1730831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730852 */     // GIR_Coverage, 10761,
     /* 1730852 */     GIR_EraseRootFromParent_Done,
     /* 1730853 */   // Label 23646: @1730853
     /* 1730853 */   GIM_Try, /*On fail goto*//*Label 23647*/ GIMT_Encode4(1730939), // Rule ID 10764 //
     /* 1730858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1730869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1730872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1730875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730904 */     // MIs[0] policy
     /* 1730904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1730917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730938 */     // GIR_Coverage, 10764,
     /* 1730938 */     GIR_EraseRootFromParent_Done,
     /* 1730939 */   // Label 23647: @1730939
     /* 1730939 */   GIM_Try, /*On fail goto*//*Label 23648*/ GIMT_Encode4(1731025), // Rule ID 10765 //
     /* 1730944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1730952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1730955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1730958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1730961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730990 */     // MIs[0] policy
     /* 1730990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731000 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731024 */     // GIR_Coverage, 10765,
     /* 1731024 */     GIR_EraseRootFromParent_Done,
     /* 1731025 */   // Label 23648: @1731025
     /* 1731025 */   GIM_Try, /*On fail goto*//*Label 23649*/ GIMT_Encode4(1731111), // Rule ID 10768 //
     /* 1731030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731076 */     // MIs[0] policy
     /* 1731076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731086 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731110 */     // GIR_Coverage, 10768,
     /* 1731110 */     GIR_EraseRootFromParent_Done,
     /* 1731111 */   // Label 23649: @1731111
     /* 1731111 */   GIM_Try, /*On fail goto*//*Label 23650*/ GIMT_Encode4(1731197), // Rule ID 10769 //
     /* 1731116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1731127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1731130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1731133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731162 */     // MIs[0] policy
     /* 1731162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731196 */     // GIR_Coverage, 10769,
     /* 1731196 */     GIR_EraseRootFromParent_Done,
     /* 1731197 */   // Label 23650: @1731197
     /* 1731197 */   GIM_Try, /*On fail goto*//*Label 23651*/ GIMT_Encode4(1731283), // Rule ID 10772 //
     /* 1731202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731248 */     // MIs[0] policy
     /* 1731248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731282 */     // GIR_Coverage, 10772,
     /* 1731282 */     GIR_EraseRootFromParent_Done,
     /* 1731283 */   // Label 23651: @1731283
     /* 1731283 */   GIM_Try, /*On fail goto*//*Label 23652*/ GIMT_Encode4(1731369), // Rule ID 10773 //
     /* 1731288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1731299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1731302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1731305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731334 */     // MIs[0] policy
     /* 1731334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731344 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1731347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731368 */     // GIR_Coverage, 10773,
     /* 1731368 */     GIR_EraseRootFromParent_Done,
     /* 1731369 */   // Label 23652: @1731369
     /* 1731369 */   GIM_Try, /*On fail goto*//*Label 23653*/ GIMT_Encode4(1731455), // Rule ID 10776 //
     /* 1731374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731420 */     // MIs[0] policy
     /* 1731420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731454 */     // GIR_Coverage, 10776,
     /* 1731454 */     GIR_EraseRootFromParent_Done,
     /* 1731455 */   // Label 23653: @1731455
     /* 1731455 */   GIM_Try, /*On fail goto*//*Label 23654*/ GIMT_Encode4(1731541), // Rule ID 10777 //
     /* 1731460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1731471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1731474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1731477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731506 */     // MIs[0] policy
     /* 1731506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731516 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1731519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731540 */     // GIR_Coverage, 10777,
     /* 1731540 */     GIR_EraseRootFromParent_Done,
     /* 1731541 */   // Label 23654: @1731541
     /* 1731541 */   GIM_Try, /*On fail goto*//*Label 23655*/ GIMT_Encode4(1731627), // Rule ID 10780 //
     /* 1731546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1731549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1731557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1731560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1731563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731592 */     // MIs[0] policy
     /* 1731592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731602 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731626 */     // GIR_Coverage, 10780,
     /* 1731626 */     GIR_EraseRootFromParent_Done,
     /* 1731627 */   // Label 23655: @1731627
     /* 1731627 */   GIM_Try, /*On fail goto*//*Label 23656*/ GIMT_Encode4(1731713), // Rule ID 10781 //
     /* 1731632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1731635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1731640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1731643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1731646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1731649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731678 */     // MIs[0] policy
     /* 1731678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731688 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11417:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1731691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1731709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731712 */     // GIR_Coverage, 10781,
     /* 1731712 */     GIR_EraseRootFromParent_Done,
     /* 1731713 */   // Label 23656: @1731713
     /* 1731713 */   GIM_Try, /*On fail goto*//*Label 23657*/ GIMT_Encode4(1731799), // Rule ID 10784 //
     /* 1731718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1731729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1731732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1731735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1731738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731764 */     // MIs[0] policy
     /* 1731764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731774 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1731777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731798 */     // GIR_Coverage, 10784,
     /* 1731798 */     GIR_EraseRootFromParent_Done,
     /* 1731799 */   // Label 23657: @1731799
     /* 1731799 */   GIM_Try, /*On fail goto*//*Label 23658*/ GIMT_Encode4(1731885), // Rule ID 10785 //
     /* 1731804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1731815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1731818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1731821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1731824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1731827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731850 */     // MIs[0] policy
     /* 1731850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1731863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731884 */     // GIR_Coverage, 10785,
     /* 1731884 */     GIR_EraseRootFromParent_Done,
     /* 1731885 */   // Label 23658: @1731885
     /* 1731885 */   GIM_Try, /*On fail goto*//*Label 23659*/ GIMT_Encode4(1731971), // Rule ID 10788 //
     /* 1731890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1731901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1731904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1731907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1731910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1731920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1731932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731936 */     // MIs[0] policy
     /* 1731936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731946 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1731949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731970 */     // GIR_Coverage, 10788,
     /* 1731970 */     GIR_EraseRootFromParent_Done,
     /* 1731971 */   // Label 23659: @1731971
     /* 1731971 */   GIM_Try, /*On fail goto*//*Label 23660*/ GIMT_Encode4(1732057), // Rule ID 10789 //
     /* 1731976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1731987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1731990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1731993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1731996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1731999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732022 */     // MIs[0] policy
     /* 1732022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732032 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732056 */     // GIR_Coverage, 10789,
     /* 1732056 */     GIR_EraseRootFromParent_Done,
     /* 1732057 */   // Label 23660: @1732057
     /* 1732057 */   GIM_Try, /*On fail goto*//*Label 23661*/ GIMT_Encode4(1732143), // Rule ID 10792 //
     /* 1732062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1732082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732108 */     // MIs[0] policy
     /* 1732108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732118 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732142 */     // GIR_Coverage, 10792,
     /* 1732142 */     GIR_EraseRootFromParent_Done,
     /* 1732143 */   // Label 23661: @1732143
     /* 1732143 */   GIM_Try, /*On fail goto*//*Label 23662*/ GIMT_Encode4(1732229), // Rule ID 10793 //
     /* 1732148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1732159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1732162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1732165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1732168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732194 */     // MIs[0] policy
     /* 1732194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732204 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732228 */     // GIR_Coverage, 10793,
     /* 1732228 */     GIR_EraseRootFromParent_Done,
     /* 1732229 */   // Label 23662: @1732229
     /* 1732229 */   GIM_Try, /*On fail goto*//*Label 23663*/ GIMT_Encode4(1732315), // Rule ID 10796 //
     /* 1732234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1732254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732280 */     // MIs[0] policy
     /* 1732280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732290 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732314 */     // GIR_Coverage, 10796,
     /* 1732314 */     GIR_EraseRootFromParent_Done,
     /* 1732315 */   // Label 23663: @1732315
     /* 1732315 */   GIM_Try, /*On fail goto*//*Label 23664*/ GIMT_Encode4(1732401), // Rule ID 10797 //
     /* 1732320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1732331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1732334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1732337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1732340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732366 */     // MIs[0] policy
     /* 1732366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1732379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732400 */     // GIR_Coverage, 10797,
     /* 1732400 */     GIR_EraseRootFromParent_Done,
     /* 1732401 */   // Label 23664: @1732401
     /* 1732401 */   GIM_Try, /*On fail goto*//*Label 23665*/ GIMT_Encode4(1732487), // Rule ID 10800 //
     /* 1732406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1732426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732452 */     // MIs[0] policy
     /* 1732452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732462 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732486 */     // GIR_Coverage, 10800,
     /* 1732486 */     GIR_EraseRootFromParent_Done,
     /* 1732487 */   // Label 23665: @1732487
     /* 1732487 */   GIM_Try, /*On fail goto*//*Label 23666*/ GIMT_Encode4(1732573), // Rule ID 10801 //
     /* 1732492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1732503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1732506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1732509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1732512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732538 */     // MIs[0] policy
     /* 1732538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732572 */     // GIR_Coverage, 10801,
     /* 1732572 */     GIR_EraseRootFromParent_Done,
     /* 1732573 */   // Label 23666: @1732573
     /* 1732573 */   GIM_Try, /*On fail goto*//*Label 23667*/ GIMT_Encode4(1732659), // Rule ID 10804 //
     /* 1732578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1732589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1732592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1732595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1732598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732624 */     // MIs[0] policy
     /* 1732624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732634 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732658 */     // GIR_Coverage, 10804,
     /* 1732658 */     GIR_EraseRootFromParent_Done,
     /* 1732659 */   // Label 23667: @1732659
     /* 1732659 */   GIM_Try, /*On fail goto*//*Label 23668*/ GIMT_Encode4(1732745), // Rule ID 10805 //
     /* 1732664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1732675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1732678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1732681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1732684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732710 */     // MIs[0] policy
     /* 1732710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732720 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1732723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732744 */     // GIR_Coverage, 10805,
     /* 1732744 */     GIR_EraseRootFromParent_Done,
     /* 1732745 */   // Label 23668: @1732745
     /* 1732745 */   GIM_Try, /*On fail goto*//*Label 23669*/ GIMT_Encode4(1732831), // Rule ID 10808 //
     /* 1732750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1732761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1732764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1732767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1732770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732796 */     // MIs[0] policy
     /* 1732796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732806 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1732809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732830 */     // GIR_Coverage, 10808,
     /* 1732830 */     GIR_EraseRootFromParent_Done,
     /* 1732831 */   // Label 23669: @1732831
     /* 1732831 */   GIM_Try, /*On fail goto*//*Label 23670*/ GIMT_Encode4(1732917), // Rule ID 10809 //
     /* 1732836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1732847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1732850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1732853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1732856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732882 */     // MIs[0] policy
     /* 1732882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732892 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1732895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732916 */     // GIR_Coverage, 10809,
     /* 1732916 */     GIR_EraseRootFromParent_Done,
     /* 1732917 */   // Label 23670: @1732917
     /* 1732917 */   GIM_Try, /*On fail goto*//*Label 23671*/ GIMT_Encode4(1733003), // Rule ID 10812 //
     /* 1732922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1732933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1732936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1732939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1732942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732968 */     // MIs[0] policy
     /* 1732968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1732981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1732999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733002 */     // GIR_Coverage, 10812,
     /* 1733002 */     GIR_EraseRootFromParent_Done,
     /* 1733003 */   // Label 23671: @1733003
     /* 1733003 */   GIM_Try, /*On fail goto*//*Label 23672*/ GIMT_Encode4(1733089), // Rule ID 10813 //
     /* 1733008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1733019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1733022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1733025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1733028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733054 */     // MIs[0] policy
     /* 1733054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733064 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733088 */     // GIR_Coverage, 10813,
     /* 1733088 */     GIR_EraseRootFromParent_Done,
     /* 1733089 */   // Label 23672: @1733089
     /* 1733089 */   GIM_Try, /*On fail goto*//*Label 23673*/ GIMT_Encode4(1733175), // Rule ID 10816 //
     /* 1733094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1733114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733140 */     // MIs[0] policy
     /* 1733140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733174 */     // GIR_Coverage, 10816,
     /* 1733174 */     GIR_EraseRootFromParent_Done,
     /* 1733175 */   // Label 23673: @1733175
     /* 1733175 */   GIM_Try, /*On fail goto*//*Label 23674*/ GIMT_Encode4(1733261), // Rule ID 10817 //
     /* 1733180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1733191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1733194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1733197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1733200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733226 */     // MIs[0] policy
     /* 1733226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733260 */     // GIR_Coverage, 10817,
     /* 1733260 */     GIR_EraseRootFromParent_Done,
     /* 1733261 */   // Label 23674: @1733261
     /* 1733261 */   GIM_Try, /*On fail goto*//*Label 23675*/ GIMT_Encode4(1733347), // Rule ID 10820 //
     /* 1733266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1733269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1733286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733312 */     // MIs[0] policy
     /* 1733312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733322 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733346 */     // GIR_Coverage, 10820,
     /* 1733346 */     GIR_EraseRootFromParent_Done,
     /* 1733347 */   // Label 23675: @1733347
     /* 1733347 */   GIM_Try, /*On fail goto*//*Label 23676*/ GIMT_Encode4(1733433), // Rule ID 10821 //
     /* 1733352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1733355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1733363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1733366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1733369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1733372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733398 */     // MIs[0] policy
     /* 1733398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1733411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1733429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733432 */     // GIR_Coverage, 10821,
     /* 1733432 */     GIR_EraseRootFromParent_Done,
     /* 1733433 */   // Label 23676: @1733433
     /* 1733433 */   GIM_Try, /*On fail goto*//*Label 23677*/ GIMT_Encode4(1733519), // Rule ID 10824 //
     /* 1733438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1733449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1733452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1733455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1733458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1733461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733484 */     // MIs[0] policy
     /* 1733484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1733497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733518 */     // GIR_Coverage, 10824,
     /* 1733518 */     GIR_EraseRootFromParent_Done,
     /* 1733519 */   // Label 23677: @1733519
     /* 1733519 */   GIM_Try, /*On fail goto*//*Label 23678*/ GIMT_Encode4(1733605), // Rule ID 10825 //
     /* 1733524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1733535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1733538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1733541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1733544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1733547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733570 */     // MIs[0] policy
     /* 1733570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733580 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1733583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733604 */     // GIR_Coverage, 10825,
     /* 1733604 */     GIR_EraseRootFromParent_Done,
     /* 1733605 */   // Label 23678: @1733605
     /* 1733605 */   GIM_Try, /*On fail goto*//*Label 23679*/ GIMT_Encode4(1733691), // Rule ID 10828 //
     /* 1733610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1733621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1733624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1733627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1733630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1733633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1733640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733656 */     // MIs[0] policy
     /* 1733656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733666 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1733669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733690 */     // GIR_Coverage, 10828,
     /* 1733690 */     GIR_EraseRootFromParent_Done,
     /* 1733691 */   // Label 23679: @1733691
     /* 1733691 */   GIM_Try, /*On fail goto*//*Label 23680*/ GIMT_Encode4(1733777), // Rule ID 10829 //
     /* 1733696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1733707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1733710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1733713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1733716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1733719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1733726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1733738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733742 */     // MIs[0] policy
     /* 1733742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733752 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1733755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733776 */     // GIR_Coverage, 10829,
     /* 1733776 */     GIR_EraseRootFromParent_Done,
     /* 1733777 */   // Label 23680: @1733777
     /* 1733777 */   GIM_Try, /*On fail goto*//*Label 23681*/ GIMT_Encode4(1733863), // Rule ID 10832 //
     /* 1733782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1733793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1733796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1733799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1733802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1733805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733828 */     // MIs[0] policy
     /* 1733828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733838 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1733841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733862 */     // GIR_Coverage, 10832,
     /* 1733862 */     GIR_EraseRootFromParent_Done,
     /* 1733863 */   // Label 23681: @1733863
     /* 1733863 */   GIM_Try, /*On fail goto*//*Label 23682*/ GIMT_Encode4(1733949), // Rule ID 10833 //
     /* 1733868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1733879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1733882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1733885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1733888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1733891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1733898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1733910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733914 */     // MIs[0] policy
     /* 1733914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733924 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1733927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733948 */     // GIR_Coverage, 10833,
     /* 1733948 */     GIR_EraseRootFromParent_Done,
     /* 1733949 */   // Label 23682: @1733949
     /* 1733949 */   GIM_Try, /*On fail goto*//*Label 23683*/ GIMT_Encode4(1734035), // Rule ID 10836 //
     /* 1733954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1733962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1733965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1733968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1733971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1733974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1733984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1733996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734000 */     // MIs[0] policy
     /* 1734000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734034 */     // GIR_Coverage, 10836,
     /* 1734034 */     GIR_EraseRootFromParent_Done,
     /* 1734035 */   // Label 23683: @1734035
     /* 1734035 */   GIM_Try, /*On fail goto*//*Label 23684*/ GIMT_Encode4(1734121), // Rule ID 10837 //
     /* 1734040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1734051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1734054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1734057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1734060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734086 */     // MIs[0] policy
     /* 1734086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734120 */     // GIR_Coverage, 10837,
     /* 1734120 */     GIR_EraseRootFromParent_Done,
     /* 1734121 */   // Label 23684: @1734121
     /* 1734121 */   GIM_Try, /*On fail goto*//*Label 23685*/ GIMT_Encode4(1734207), // Rule ID 10840 //
     /* 1734126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1734146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734172 */     // MIs[0] policy
     /* 1734172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734182 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734206 */     // GIR_Coverage, 10840,
     /* 1734206 */     GIR_EraseRootFromParent_Done,
     /* 1734207 */   // Label 23685: @1734207
     /* 1734207 */   GIM_Try, /*On fail goto*//*Label 23686*/ GIMT_Encode4(1734293), // Rule ID 10841 //
     /* 1734212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1734223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1734226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1734229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1734232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734258 */     // MIs[0] policy
     /* 1734258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734268 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734292 */     // GIR_Coverage, 10841,
     /* 1734292 */     GIR_EraseRootFromParent_Done,
     /* 1734293 */   // Label 23686: @1734293
     /* 1734293 */   GIM_Try, /*On fail goto*//*Label 23687*/ GIMT_Encode4(1734379), // Rule ID 10844 //
     /* 1734298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1734318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734344 */     // MIs[0] policy
     /* 1734344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734354 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734378 */     // GIR_Coverage, 10844,
     /* 1734378 */     GIR_EraseRootFromParent_Done,
     /* 1734379 */   // Label 23687: @1734379
     /* 1734379 */   GIM_Try, /*On fail goto*//*Label 23688*/ GIMT_Encode4(1734465), // Rule ID 10845 //
     /* 1734384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1734395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1734398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1734401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1734404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734430 */     // MIs[0] policy
     /* 1734430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734440 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734464 */     // GIR_Coverage, 10845,
     /* 1734464 */     GIR_EraseRootFromParent_Done,
     /* 1734465 */   // Label 23688: @1734465
     /* 1734465 */   GIM_Try, /*On fail goto*//*Label 23689*/ GIMT_Encode4(1734551), // Rule ID 10848 //
     /* 1734470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1734481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1734484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1734487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1734490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734516 */     // MIs[0] policy
     /* 1734516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734526 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734550 */     // GIR_Coverage, 10848,
     /* 1734550 */     GIR_EraseRootFromParent_Done,
     /* 1734551 */   // Label 23689: @1734551
     /* 1734551 */   GIM_Try, /*On fail goto*//*Label 23690*/ GIMT_Encode4(1734637), // Rule ID 10849 //
     /* 1734556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1734567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1734570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1734573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1734576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734602 */     // MIs[0] policy
     /* 1734602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1734615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734636 */     // GIR_Coverage, 10849,
     /* 1734636 */     GIR_EraseRootFromParent_Done,
     /* 1734637 */   // Label 23690: @1734637
     /* 1734637 */   GIM_Try, /*On fail goto*//*Label 23691*/ GIMT_Encode4(1734723), // Rule ID 10852 //
     /* 1734642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1734653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1734656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1734659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1734662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734688 */     // MIs[0] policy
     /* 1734688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734698 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734722 */     // GIR_Coverage, 10852,
     /* 1734722 */     GIR_EraseRootFromParent_Done,
     /* 1734723 */   // Label 23691: @1734723
     /* 1734723 */   GIM_Try, /*On fail goto*//*Label 23692*/ GIMT_Encode4(1734809), // Rule ID 10853 //
     /* 1734728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1734739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1734742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1734745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1734748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734774 */     // MIs[0] policy
     /* 1734774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1734787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734808 */     // GIR_Coverage, 10853,
     /* 1734808 */     GIR_EraseRootFromParent_Done,
     /* 1734809 */   // Label 23692: @1734809
     /* 1734809 */   GIM_Try, /*On fail goto*//*Label 23693*/ GIMT_Encode4(1734895), // Rule ID 10856 //
     /* 1734814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1734825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1734828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1734831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1734834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734860 */     // MIs[0] policy
     /* 1734860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734870 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734894 */     // GIR_Coverage, 10856,
     /* 1734894 */     GIR_EraseRootFromParent_Done,
     /* 1734895 */   // Label 23693: @1734895
     /* 1734895 */   GIM_Try, /*On fail goto*//*Label 23694*/ GIMT_Encode4(1734981), // Rule ID 10857 //
     /* 1734900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1734911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1734914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1734917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1734920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734946 */     // MIs[0] policy
     /* 1734946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734956 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1734959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734980 */     // GIR_Coverage, 10857,
     /* 1734980 */     GIR_EraseRootFromParent_Done,
     /* 1734981 */   // Label 23694: @1734981
     /* 1734981 */   GIM_Try, /*On fail goto*//*Label 23695*/ GIMT_Encode4(1735067), // Rule ID 10860 //
     /* 1734986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1734989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1734994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1734997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1735006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735032 */     // MIs[0] policy
     /* 1735032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735066 */     // GIR_Coverage, 10860,
     /* 1735066 */     GIR_EraseRootFromParent_Done,
     /* 1735067 */   // Label 23695: @1735067
     /* 1735067 */   GIM_Try, /*On fail goto*//*Label 23696*/ GIMT_Encode4(1735153), // Rule ID 10861 //
     /* 1735072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1735092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735118 */     // MIs[0] policy
     /* 1735118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1735131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735152 */     // GIR_Coverage, 10861,
     /* 1735152 */     GIR_EraseRootFromParent_Done,
     /* 1735153 */   // Label 23696: @1735153
     /* 1735153 */   GIM_Try, /*On fail goto*//*Label 23697*/ GIMT_Encode4(1735239), // Rule ID 10864 //
     /* 1735158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1735178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735204 */     // MIs[0] policy
     /* 1735204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735238 */     // GIR_Coverage, 10864,
     /* 1735238 */     GIR_EraseRootFromParent_Done,
     /* 1735239 */   // Label 23697: @1735239
     /* 1735239 */   GIM_Try, /*On fail goto*//*Label 23698*/ GIMT_Encode4(1735325), // Rule ID 10865 //
     /* 1735244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1735255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1735258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1735261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1735264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735290 */     // MIs[0] policy
     /* 1735290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735300 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1735303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735324 */     // GIR_Coverage, 10865,
     /* 1735324 */     GIR_EraseRootFromParent_Done,
     /* 1735325 */   // Label 23698: @1735325
     /* 1735325 */   GIM_Try, /*On fail goto*//*Label 23699*/ GIMT_Encode4(1735411), // Rule ID 10868 //
     /* 1735330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1735350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735376 */     // MIs[0] policy
     /* 1735376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735386 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735410 */     // GIR_Coverage, 10868,
     /* 1735410 */     GIR_EraseRootFromParent_Done,
     /* 1735411 */   // Label 23699: @1735411
     /* 1735411 */   GIM_Try, /*On fail goto*//*Label 23700*/ GIMT_Encode4(1735497), // Rule ID 10869 //
     /* 1735416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1735419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1735427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1735430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1735433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1735436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735462 */     // MIs[0] policy
     /* 1735462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735472 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1735475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1735493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735496 */     // GIR_Coverage, 10869,
     /* 1735496 */     GIR_EraseRootFromParent_Done,
     /* 1735497 */   // Label 23700: @1735497
     /* 1735497 */   GIM_Try, /*On fail goto*//*Label 23701*/ GIMT_Encode4(1735583), // Rule ID 10872 //
     /* 1735502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1735513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1735516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1735519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735548 */     // MIs[0] policy
     /* 1735548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735558 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1735561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735582 */     // GIR_Coverage, 10872,
     /* 1735582 */     GIR_EraseRootFromParent_Done,
     /* 1735583 */   // Label 23701: @1735583
     /* 1735583 */   GIM_Try, /*On fail goto*//*Label 23702*/ GIMT_Encode4(1735669), // Rule ID 10873 //
     /* 1735588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1735599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1735602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1735605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1735611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735634 */     // MIs[0] policy
     /* 1735634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1735647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735668 */     // GIR_Coverage, 10873,
     /* 1735668 */     GIR_EraseRootFromParent_Done,
     /* 1735669 */   // Label 23702: @1735669
     /* 1735669 */   GIM_Try, /*On fail goto*//*Label 23703*/ GIMT_Encode4(1735755), // Rule ID 10876 //
     /* 1735674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1735685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1735688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1735691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735720 */     // MIs[0] policy
     /* 1735720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1735733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735754 */     // GIR_Coverage, 10876,
     /* 1735754 */     GIR_EraseRootFromParent_Done,
     /* 1735755 */   // Label 23703: @1735755
     /* 1735755 */   GIM_Try, /*On fail goto*//*Label 23704*/ GIMT_Encode4(1735841), // Rule ID 10877 //
     /* 1735760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1735771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1735774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1735777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735806 */     // MIs[0] policy
     /* 1735806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735816 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1735819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735840 */     // GIR_Coverage, 10877,
     /* 1735840 */     GIR_EraseRootFromParent_Done,
     /* 1735841 */   // Label 23704: @1735841
     /* 1735841 */   GIM_Try, /*On fail goto*//*Label 23705*/ GIMT_Encode4(1735927), // Rule ID 10880 //
     /* 1735846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1735857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1735860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1735863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1735866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735892 */     // MIs[0] policy
     /* 1735892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735902 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1735905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1735923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735926 */     // GIR_Coverage, 10880,
     /* 1735926 */     GIR_EraseRootFromParent_Done,
     /* 1735927 */   // Label 23705: @1735927
     /* 1735927 */   GIM_Try, /*On fail goto*//*Label 23706*/ GIMT_Encode4(1736013), // Rule ID 10881 //
     /* 1735932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1735940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1735943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1735946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1735949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1735952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1735962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1735970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1735974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735978 */     // MIs[0] policy
     /* 1735978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735988 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1735991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736012 */     // GIR_Coverage, 10881,
     /* 1736012 */     GIR_EraseRootFromParent_Done,
     /* 1736013 */   // Label 23706: @1736013
     /* 1736013 */   GIM_Try, /*On fail goto*//*Label 23707*/ GIMT_Encode4(1736099), // Rule ID 10884 //
     /* 1736018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736064 */     // MIs[0] policy
     /* 1736064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736074 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736098 */     // GIR_Coverage, 10884,
     /* 1736098 */     GIR_EraseRootFromParent_Done,
     /* 1736099 */   // Label 23707: @1736099
     /* 1736099 */   GIM_Try, /*On fail goto*//*Label 23708*/ GIMT_Encode4(1736185), // Rule ID 10885 //
     /* 1736104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1736115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1736118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1736121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736150 */     // MIs[0] policy
     /* 1736150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736160 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1736163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736184 */     // GIR_Coverage, 10885,
     /* 1736184 */     GIR_EraseRootFromParent_Done,
     /* 1736185 */   // Label 23708: @1736185
     /* 1736185 */   GIM_Try, /*On fail goto*//*Label 23709*/ GIMT_Encode4(1736271), // Rule ID 10888 //
     /* 1736190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736236 */     // MIs[0] policy
     /* 1736236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736246 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736270 */     // GIR_Coverage, 10888,
     /* 1736270 */     GIR_EraseRootFromParent_Done,
     /* 1736271 */   // Label 23709: @1736271
     /* 1736271 */   GIM_Try, /*On fail goto*//*Label 23710*/ GIMT_Encode4(1736357), // Rule ID 10889 //
     /* 1736276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1736287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1736290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1736293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736322 */     // MIs[0] policy
     /* 1736322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736332 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736356 */     // GIR_Coverage, 10889,
     /* 1736356 */     GIR_EraseRootFromParent_Done,
     /* 1736357 */   // Label 23710: @1736357
     /* 1736357 */   GIM_Try, /*On fail goto*//*Label 23711*/ GIMT_Encode4(1736443), // Rule ID 10892 //
     /* 1736362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736408 */     // MIs[0] policy
     /* 1736408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736442 */     // GIR_Coverage, 10892,
     /* 1736442 */     GIR_EraseRootFromParent_Done,
     /* 1736443 */   // Label 23711: @1736443
     /* 1736443 */   GIM_Try, /*On fail goto*//*Label 23712*/ GIMT_Encode4(1736529), // Rule ID 10893 //
     /* 1736448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1736459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1736462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1736465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736494 */     // MIs[0] policy
     /* 1736494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736504 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1736507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736528 */     // GIR_Coverage, 10893,
     /* 1736528 */     GIR_EraseRootFromParent_Done,
     /* 1736529 */   // Label 23712: @1736529
     /* 1736529 */   GIM_Try, /*On fail goto*//*Label 23713*/ GIMT_Encode4(1736615), // Rule ID 10896 //
     /* 1736534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1736545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1736548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1736551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736580 */     // MIs[0] policy
     /* 1736580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736590 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736614 */     // GIR_Coverage, 10896,
     /* 1736614 */     GIR_EraseRootFromParent_Done,
     /* 1736615 */   // Label 23713: @1736615
     /* 1736615 */   GIM_Try, /*On fail goto*//*Label 23714*/ GIMT_Encode4(1736701), // Rule ID 10897 //
     /* 1736620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1736631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1736634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1736637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736666 */     // MIs[0] policy
     /* 1736666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736700 */     // GIR_Coverage, 10897,
     /* 1736700 */     GIR_EraseRootFromParent_Done,
     /* 1736701 */   // Label 23714: @1736701
     /* 1736701 */   GIM_Try, /*On fail goto*//*Label 23715*/ GIMT_Encode4(1736787), // Rule ID 10900 //
     /* 1736706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1736717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1736720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1736723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736752 */     // MIs[0] policy
     /* 1736752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736786 */     // GIR_Coverage, 10900,
     /* 1736786 */     GIR_EraseRootFromParent_Done,
     /* 1736787 */   // Label 23715: @1736787
     /* 1736787 */   GIM_Try, /*On fail goto*//*Label 23716*/ GIMT_Encode4(1736873), // Rule ID 10901 //
     /* 1736792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1736803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1736806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1736809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736838 */     // MIs[0] policy
     /* 1736838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736848 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1736869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736872 */     // GIR_Coverage, 10901,
     /* 1736872 */     GIR_EraseRootFromParent_Done,
     /* 1736873 */   // Label 23716: @1736873
     /* 1736873 */   GIM_Try, /*On fail goto*//*Label 23717*/ GIMT_Encode4(1736959), // Rule ID 10904 //
     /* 1736878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1736889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1736892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1736895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736924 */     // MIs[0] policy
     /* 1736924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1736937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1736955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736958 */     // GIR_Coverage, 10904,
     /* 1736958 */     GIR_EraseRootFromParent_Done,
     /* 1736959 */   // Label 23717: @1736959
     /* 1736959 */   GIM_Try, /*On fail goto*//*Label 23718*/ GIMT_Encode4(1737045), // Rule ID 10905 //
     /* 1736964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1736972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1736975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1736978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1736981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737010 */     // MIs[0] policy
     /* 1737010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737044 */     // GIR_Coverage, 10905,
     /* 1737044 */     GIR_EraseRootFromParent_Done,
     /* 1737045 */   // Label 23718: @1737045
     /* 1737045 */   GIM_Try, /*On fail goto*//*Label 23719*/ GIMT_Encode4(1737131), // Rule ID 10908 //
     /* 1737050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1737053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737096 */     // MIs[0] policy
     /* 1737096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737130 */     // GIR_Coverage, 10908,
     /* 1737130 */     GIR_EraseRootFromParent_Done,
     /* 1737131 */   // Label 23719: @1737131
     /* 1737131 */   GIM_Try, /*On fail goto*//*Label 23720*/ GIMT_Encode4(1737217), // Rule ID 10909 //
     /* 1737136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1737139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1737147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1737150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1737153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737182 */     // MIs[0] policy
     /* 1737182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737192 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1737195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1737213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737216 */     // GIR_Coverage, 10909,
     /* 1737216 */     GIR_EraseRootFromParent_Done,
     /* 1737217 */   // Label 23720: @1737217
     /* 1737217 */   GIM_Try, /*On fail goto*//*Label 23721*/ GIMT_Encode4(1737303), // Rule ID 10912 //
     /* 1737222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737268 */     // MIs[0] policy
     /* 1737268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737278 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737302 */     // GIR_Coverage, 10912,
     /* 1737302 */     GIR_EraseRootFromParent_Done,
     /* 1737303 */   // Label 23721: @1737303
     /* 1737303 */   GIM_Try, /*On fail goto*//*Label 23722*/ GIMT_Encode4(1737389), // Rule ID 10913 //
     /* 1737308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1737319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1737322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1737325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737354 */     // MIs[0] policy
     /* 1737354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737364 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737388 */     // GIR_Coverage, 10913,
     /* 1737388 */     GIR_EraseRootFromParent_Done,
     /* 1737389 */   // Label 23722: @1737389
     /* 1737389 */   GIM_Try, /*On fail goto*//*Label 23723*/ GIMT_Encode4(1737475), // Rule ID 10916 //
     /* 1737394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737440 */     // MIs[0] policy
     /* 1737440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737450 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1737453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737474 */     // GIR_Coverage, 10916,
     /* 1737474 */     GIR_EraseRootFromParent_Done,
     /* 1737475 */   // Label 23723: @1737475
     /* 1737475 */   GIM_Try, /*On fail goto*//*Label 23724*/ GIMT_Encode4(1737561), // Rule ID 10917 //
     /* 1737480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1737491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1737494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1737497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1737503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737526 */     // MIs[0] policy
     /* 1737526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737536 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1737539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737560 */     // GIR_Coverage, 10917,
     /* 1737560 */     GIR_EraseRootFromParent_Done,
     /* 1737561 */   // Label 23724: @1737561
     /* 1737561 */   GIM_Try, /*On fail goto*//*Label 23725*/ GIMT_Encode4(1737647), // Rule ID 10920 //
     /* 1737566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1737577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1737580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1737583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1737589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1737596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737612 */     // MIs[0] policy
     /* 1737612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737622 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1737625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737646 */     // GIR_Coverage, 10920,
     /* 1737646 */     GIR_EraseRootFromParent_Done,
     /* 1737647 */   // Label 23725: @1737647
     /* 1737647 */   GIM_Try, /*On fail goto*//*Label 23726*/ GIMT_Encode4(1737733), // Rule ID 10921 //
     /* 1737652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1737663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1737666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1737669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1737675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1737682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1737690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737698 */     // MIs[0] policy
     /* 1737698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737708 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1737711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737732 */     // GIR_Coverage, 10921,
     /* 1737732 */     GIR_EraseRootFromParent_Done,
     /* 1737733 */   // Label 23726: @1737733
     /* 1737733 */   GIM_Try, /*On fail goto*//*Label 23727*/ GIMT_Encode4(1737819), // Rule ID 10924 //
     /* 1737738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1737749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1737752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1737755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737784 */     // MIs[0] policy
     /* 1737784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737818 */     // GIR_Coverage, 10924,
     /* 1737818 */     GIR_EraseRootFromParent_Done,
     /* 1737819 */   // Label 23727: @1737819
     /* 1737819 */   GIM_Try, /*On fail goto*//*Label 23728*/ GIMT_Encode4(1737905), // Rule ID 10925 //
     /* 1737824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1737835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1737838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1737841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1737854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1737862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737870 */     // MIs[0] policy
     /* 1737870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737880 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1737883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737904 */     // GIR_Coverage, 10925,
     /* 1737904 */     GIR_EraseRootFromParent_Done,
     /* 1737905 */   // Label 23728: @1737905
     /* 1737905 */   GIM_Try, /*On fail goto*//*Label 23729*/ GIMT_Encode4(1737991), // Rule ID 10928 //
     /* 1737910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1737918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1737921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1737924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1737927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1737933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1737940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1737948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737956 */     // MIs[0] policy
     /* 1737956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737966 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1737969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737990 */     // GIR_Coverage, 10928,
     /* 1737990 */     GIR_EraseRootFromParent_Done,
     /* 1737991 */   // Label 23729: @1737991
     /* 1737991 */   GIM_Try, /*On fail goto*//*Label 23730*/ GIMT_Encode4(1738077), // Rule ID 10929 //
     /* 1737996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1738007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1738010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1738013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738042 */     // MIs[0] policy
     /* 1738042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738076 */     // GIR_Coverage, 10929,
     /* 1738076 */     GIR_EraseRootFromParent_Done,
     /* 1738077 */   // Label 23730: @1738077
     /* 1738077 */   GIM_Try, /*On fail goto*//*Label 23731*/ GIMT_Encode4(1738163), // Rule ID 10932 //
     /* 1738082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738128 */     // MIs[0] policy
     /* 1738128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738138 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738162 */     // GIR_Coverage, 10932,
     /* 1738162 */     GIR_EraseRootFromParent_Done,
     /* 1738163 */   // Label 23731: @1738163
     /* 1738163 */   GIM_Try, /*On fail goto*//*Label 23732*/ GIMT_Encode4(1738249), // Rule ID 10933 //
     /* 1738168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1738179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1738182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1738185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738214 */     // MIs[0] policy
     /* 1738214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738224 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738248 */     // GIR_Coverage, 10933,
     /* 1738248 */     GIR_EraseRootFromParent_Done,
     /* 1738249 */   // Label 23732: @1738249
     /* 1738249 */   GIM_Try, /*On fail goto*//*Label 23733*/ GIMT_Encode4(1738335), // Rule ID 10936 //
     /* 1738254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738300 */     // MIs[0] policy
     /* 1738300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738334 */     // GIR_Coverage, 10936,
     /* 1738334 */     GIR_EraseRootFromParent_Done,
     /* 1738335 */   // Label 23733: @1738335
     /* 1738335 */   GIM_Try, /*On fail goto*//*Label 23734*/ GIMT_Encode4(1738421), // Rule ID 10937 //
     /* 1738340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1738351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1738354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1738357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738386 */     // MIs[0] policy
     /* 1738386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738420 */     // GIR_Coverage, 10937,
     /* 1738420 */     GIR_EraseRootFromParent_Done,
     /* 1738421 */   // Label 23734: @1738421
     /* 1738421 */   GIM_Try, /*On fail goto*//*Label 23735*/ GIMT_Encode4(1738507), // Rule ID 10940 //
     /* 1738426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1738440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1738443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738472 */     // MIs[0] policy
     /* 1738472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738506 */     // GIR_Coverage, 10940,
     /* 1738506 */     GIR_EraseRootFromParent_Done,
     /* 1738507 */   // Label 23735: @1738507
     /* 1738507 */   GIM_Try, /*On fail goto*//*Label 23736*/ GIMT_Encode4(1738593), // Rule ID 10941 //
     /* 1738512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1738523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1738526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1738529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738558 */     // MIs[0] policy
     /* 1738558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1738571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738592 */     // GIR_Coverage, 10941,
     /* 1738592 */     GIR_EraseRootFromParent_Done,
     /* 1738593 */   // Label 23736: @1738593
     /* 1738593 */   GIM_Try, /*On fail goto*//*Label 23737*/ GIMT_Encode4(1738679), // Rule ID 10944 //
     /* 1738598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1738609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1738612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1738615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738644 */     // MIs[0] policy
     /* 1738644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738678 */     // GIR_Coverage, 10944,
     /* 1738678 */     GIR_EraseRootFromParent_Done,
     /* 1738679 */   // Label 23737: @1738679
     /* 1738679 */   GIM_Try, /*On fail goto*//*Label 23738*/ GIMT_Encode4(1738765), // Rule ID 10945 //
     /* 1738684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1738695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1738698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1738701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738730 */     // MIs[0] policy
     /* 1738730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738740 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1738743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738764 */     // GIR_Coverage, 10945,
     /* 1738764 */     GIR_EraseRootFromParent_Done,
     /* 1738765 */   // Label 23738: @1738765
     /* 1738765 */   GIM_Try, /*On fail goto*//*Label 23739*/ GIMT_Encode4(1738851), // Rule ID 10948 //
     /* 1738770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1738773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1738781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1738784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1738787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738816 */     // MIs[0] policy
     /* 1738816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738826 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738850 */     // GIR_Coverage, 10948,
     /* 1738850 */     GIR_EraseRootFromParent_Done,
     /* 1738851 */   // Label 23739: @1738851
     /* 1738851 */   GIM_Try, /*On fail goto*//*Label 23740*/ GIMT_Encode4(1738937), // Rule ID 10949 //
     /* 1738856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1738859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1738867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1738870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1738873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1738879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738902 */     // MIs[0] policy
     /* 1738902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738912 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1738915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738936 */     // GIR_Coverage, 10949,
     /* 1738936 */     GIR_EraseRootFromParent_Done,
     /* 1738937 */   // Label 23740: @1738937
     /* 1738937 */   GIM_Try, /*On fail goto*//*Label 23741*/ GIMT_Encode4(1739023), // Rule ID 10952 //
     /* 1738942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1738945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1738950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1738953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1738956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1738959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1738965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738988 */     // MIs[0] policy
     /* 1738988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739022 */     // GIR_Coverage, 10952,
     /* 1739022 */     GIR_EraseRootFromParent_Done,
     /* 1739023 */   // Label 23741: @1739023
     /* 1739023 */   GIM_Try, /*On fail goto*//*Label 23742*/ GIMT_Encode4(1739109), // Rule ID 10953 //
     /* 1739028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1739039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1739042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1739045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739074 */     // MIs[0] policy
     /* 1739074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739084 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1739087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739108 */     // GIR_Coverage, 10953,
     /* 1739108 */     GIR_EraseRootFromParent_Done,
     /* 1739109 */   // Label 23742: @1739109
     /* 1739109 */   GIM_Try, /*On fail goto*//*Label 23743*/ GIMT_Encode4(1739195), // Rule ID 10956 //
     /* 1739114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739160 */     // MIs[0] policy
     /* 1739160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739170 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739194 */     // GIR_Coverage, 10956,
     /* 1739194 */     GIR_EraseRootFromParent_Done,
     /* 1739195 */   // Label 23743: @1739195
     /* 1739195 */   GIM_Try, /*On fail goto*//*Label 23744*/ GIMT_Encode4(1739281), // Rule ID 10957 //
     /* 1739200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1739208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1739211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1739214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1739217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739246 */     // MIs[0] policy
     /* 1739246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739256 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11415:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1739259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739280 */     // GIR_Coverage, 10957,
     /* 1739280 */     GIR_EraseRootFromParent_Done,
     /* 1739281 */   // Label 23744: @1739281
     /* 1739281 */   GIM_Try, /*On fail goto*//*Label 23745*/ GIMT_Encode4(1739367), // Rule ID 10960 //
     /* 1739286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1739306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739332 */     // MIs[0] policy
     /* 1739332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739342 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1739345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739366 */     // GIR_Coverage, 10960,
     /* 1739366 */     GIR_EraseRootFromParent_Done,
     /* 1739367 */   // Label 23745: @1739367
     /* 1739367 */   GIM_Try, /*On fail goto*//*Label 23746*/ GIMT_Encode4(1739453), // Rule ID 10961 //
     /* 1739372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1739383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1739386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1739389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1739392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739418 */     // MIs[0] policy
     /* 1739418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739428 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1739431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739452 */     // GIR_Coverage, 10961,
     /* 1739452 */     GIR_EraseRootFromParent_Done,
     /* 1739453 */   // Label 23746: @1739453
     /* 1739453 */   GIM_Try, /*On fail goto*//*Label 23747*/ GIMT_Encode4(1739539), // Rule ID 10964 //
     /* 1739458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1739469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1739472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1739475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1739478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739504 */     // MIs[0] policy
     /* 1739504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739514 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739538 */     // GIR_Coverage, 10964,
     /* 1739538 */     GIR_EraseRootFromParent_Done,
     /* 1739539 */   // Label 23747: @1739539
     /* 1739539 */   GIM_Try, /*On fail goto*//*Label 23748*/ GIMT_Encode4(1739625), // Rule ID 10965 //
     /* 1739544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1739555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1739558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1739561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1739564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739590 */     // MIs[0] policy
     /* 1739590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739600 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739624 */     // GIR_Coverage, 10965,
     /* 1739624 */     GIR_EraseRootFromParent_Done,
     /* 1739625 */   // Label 23748: @1739625
     /* 1739625 */   GIM_Try, /*On fail goto*//*Label 23749*/ GIMT_Encode4(1739711), // Rule ID 10968 //
     /* 1739630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1739641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1739644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1739647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1739650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739676 */     // MIs[0] policy
     /* 1739676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739686 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1739689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739710 */     // GIR_Coverage, 10968,
     /* 1739710 */     GIR_EraseRootFromParent_Done,
     /* 1739711 */   // Label 23749: @1739711
     /* 1739711 */   GIM_Try, /*On fail goto*//*Label 23750*/ GIMT_Encode4(1739797), // Rule ID 10969 //
     /* 1739716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1739727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1739730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1739733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1739736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739762 */     // MIs[0] policy
     /* 1739762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739772 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1739775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1739793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739796 */     // GIR_Coverage, 10969,
     /* 1739796 */     GIR_EraseRootFromParent_Done,
     /* 1739797 */   // Label 23750: @1739797
     /* 1739797 */   GIM_Try, /*On fail goto*//*Label 23751*/ GIMT_Encode4(1739883), // Rule ID 10972 //
     /* 1739802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1739813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1739816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1739819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1739822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739848 */     // MIs[0] policy
     /* 1739848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739858 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739882 */     // GIR_Coverage, 10972,
     /* 1739882 */     GIR_EraseRootFromParent_Done,
     /* 1739883 */   // Label 23751: @1739883
     /* 1739883 */   GIM_Try, /*On fail goto*//*Label 23752*/ GIMT_Encode4(1739969), // Rule ID 10973 //
     /* 1739888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1739899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1739902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1739905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1739908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1739911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1739918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1739930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739934 */     // MIs[0] policy
     /* 1739934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739944 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1739947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739968 */     // GIR_Coverage, 10973,
     /* 1739968 */     GIR_EraseRootFromParent_Done,
     /* 1739969 */   // Label 23752: @1739969
     /* 1739969 */   GIM_Try, /*On fail goto*//*Label 23753*/ GIMT_Encode4(1740055), // Rule ID 10976 //
     /* 1739974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1739985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1739988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1739991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1739994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740020 */     // MIs[0] policy
     /* 1740020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740030 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740054 */     // GIR_Coverage, 10976,
     /* 1740054 */     GIR_EraseRootFromParent_Done,
     /* 1740055 */   // Label 23753: @1740055
     /* 1740055 */   GIM_Try, /*On fail goto*//*Label 23754*/ GIMT_Encode4(1740141), // Rule ID 10977 //
     /* 1740060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1740071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1740080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740106 */     // MIs[0] policy
     /* 1740106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740116 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740140 */     // GIR_Coverage, 10977,
     /* 1740140 */     GIR_EraseRootFromParent_Done,
     /* 1740141 */   // Label 23754: @1740141
     /* 1740141 */   GIM_Try, /*On fail goto*//*Label 23755*/ GIMT_Encode4(1740227), // Rule ID 10980 //
     /* 1740146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1740166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740192 */     // MIs[0] policy
     /* 1740192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740226 */     // GIR_Coverage, 10980,
     /* 1740226 */     GIR_EraseRootFromParent_Done,
     /* 1740227 */   // Label 23755: @1740227
     /* 1740227 */   GIM_Try, /*On fail goto*//*Label 23756*/ GIMT_Encode4(1740313), // Rule ID 10981 //
     /* 1740232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1740243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1740246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1740249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1740252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740278 */     // MIs[0] policy
     /* 1740278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1740291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740312 */     // GIR_Coverage, 10981,
     /* 1740312 */     GIR_EraseRootFromParent_Done,
     /* 1740313 */   // Label 23756: @1740313
     /* 1740313 */   GIM_Try, /*On fail goto*//*Label 23757*/ GIMT_Encode4(1740399), // Rule ID 10984 //
     /* 1740318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1740338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740364 */     // MIs[0] policy
     /* 1740364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740398 */     // GIR_Coverage, 10984,
     /* 1740398 */     GIR_EraseRootFromParent_Done,
     /* 1740399 */   // Label 23757: @1740399
     /* 1740399 */   GIM_Try, /*On fail goto*//*Label 23758*/ GIMT_Encode4(1740485), // Rule ID 10985 //
     /* 1740404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1740415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1740418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1740421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1740424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740450 */     // MIs[0] policy
     /* 1740450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740460 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740484 */     // GIR_Coverage, 10985,
     /* 1740484 */     GIR_EraseRootFromParent_Done,
     /* 1740485 */   // Label 23758: @1740485
     /* 1740485 */   GIM_Try, /*On fail goto*//*Label 23759*/ GIMT_Encode4(1740571), // Rule ID 10988 //
     /* 1740490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1740501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1740504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1740507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1740510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740536 */     // MIs[0] policy
     /* 1740536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740570 */     // GIR_Coverage, 10988,
     /* 1740570 */     GIR_EraseRootFromParent_Done,
     /* 1740571 */   // Label 23759: @1740571
     /* 1740571 */   GIM_Try, /*On fail goto*//*Label 23760*/ GIMT_Encode4(1740657), // Rule ID 10989 //
     /* 1740576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1740587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1740590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1740593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1740596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740622 */     // MIs[0] policy
     /* 1740622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740656 */     // GIR_Coverage, 10989,
     /* 1740656 */     GIR_EraseRootFromParent_Done,
     /* 1740657 */   // Label 23760: @1740657
     /* 1740657 */   GIM_Try, /*On fail goto*//*Label 23761*/ GIMT_Encode4(1740743), // Rule ID 10992 //
     /* 1740662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1740673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1740676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1740679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1740682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740708 */     // MIs[0] policy
     /* 1740708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740718 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740742 */     // GIR_Coverage, 10992,
     /* 1740742 */     GIR_EraseRootFromParent_Done,
     /* 1740743 */   // Label 23761: @1740743
     /* 1740743 */   GIM_Try, /*On fail goto*//*Label 23762*/ GIMT_Encode4(1740829), // Rule ID 10993 //
     /* 1740748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1740759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1740762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1740765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1740768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740794 */     // MIs[0] policy
     /* 1740794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740804 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1740825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740828 */     // GIR_Coverage, 10993,
     /* 1740828 */     GIR_EraseRootFromParent_Done,
     /* 1740829 */   // Label 23762: @1740829
     /* 1740829 */   GIM_Try, /*On fail goto*//*Label 23763*/ GIMT_Encode4(1740915), // Rule ID 10996 //
     /* 1740834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1740845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1740848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1740851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1740854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740880 */     // MIs[0] policy
     /* 1740880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740914 */     // GIR_Coverage, 10996,
     /* 1740914 */     GIR_EraseRootFromParent_Done,
     /* 1740915 */   // Label 23763: @1740915
     /* 1740915 */   GIM_Try, /*On fail goto*//*Label 23764*/ GIMT_Encode4(1741001), // Rule ID 10997 //
     /* 1740920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1740931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1740934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1740937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1740940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740966 */     // MIs[0] policy
     /* 1740966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1740979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741000 */     // GIR_Coverage, 10997,
     /* 1741000 */     GIR_EraseRootFromParent_Done,
     /* 1741001 */   // Label 23764: @1741001
     /* 1741001 */   GIM_Try, /*On fail goto*//*Label 23765*/ GIMT_Encode4(1741087), // Rule ID 11000 //
     /* 1741006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741052 */     // MIs[0] policy
     /* 1741052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741062 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741086 */     // GIR_Coverage, 11000,
     /* 1741086 */     GIR_EraseRootFromParent_Done,
     /* 1741087 */   // Label 23765: @1741087
     /* 1741087 */   GIM_Try, /*On fail goto*//*Label 23766*/ GIMT_Encode4(1741173), // Rule ID 11001 //
     /* 1741092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741138 */     // MIs[0] policy
     /* 1741138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741148 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741172 */     // GIR_Coverage, 11001,
     /* 1741172 */     GIR_EraseRootFromParent_Done,
     /* 1741173 */   // Label 23766: @1741173
     /* 1741173 */   GIM_Try, /*On fail goto*//*Label 23767*/ GIMT_Encode4(1741259), // Rule ID 11004 //
     /* 1741178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1741198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741224 */     // MIs[0] policy
     /* 1741224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741234 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741258 */     // GIR_Coverage, 11004,
     /* 1741258 */     GIR_EraseRootFromParent_Done,
     /* 1741259 */   // Label 23767: @1741259
     /* 1741259 */   GIM_Try, /*On fail goto*//*Label 23768*/ GIMT_Encode4(1741345), // Rule ID 11005 //
     /* 1741264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1741278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1741281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1741284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741310 */     // MIs[0] policy
     /* 1741310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741320 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741344 */     // GIR_Coverage, 11005,
     /* 1741344 */     GIR_EraseRootFromParent_Done,
     /* 1741345 */   // Label 23768: @1741345
     /* 1741345 */   GIM_Try, /*On fail goto*//*Label 23769*/ GIMT_Encode4(1741431), // Rule ID 11008 //
     /* 1741350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1741370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741396 */     // MIs[0] policy
     /* 1741396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741406 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741430 */     // GIR_Coverage, 11008,
     /* 1741430 */     GIR_EraseRootFromParent_Done,
     /* 1741431 */   // Label 23769: @1741431
     /* 1741431 */   GIM_Try, /*On fail goto*//*Label 23770*/ GIMT_Encode4(1741517), // Rule ID 11009 //
     /* 1741436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1741447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1741450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1741453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1741456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1741459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741482 */     // MIs[0] policy
     /* 1741482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741492 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741516 */     // GIR_Coverage, 11009,
     /* 1741516 */     GIR_EraseRootFromParent_Done,
     /* 1741517 */   // Label 23770: @1741517
     /* 1741517 */   GIM_Try, /*On fail goto*//*Label 23771*/ GIMT_Encode4(1741603), // Rule ID 11012 //
     /* 1741522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1741533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1741536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1741539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1741542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741568 */     // MIs[0] policy
     /* 1741568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741578 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741602 */     // GIR_Coverage, 11012,
     /* 1741602 */     GIR_EraseRootFromParent_Done,
     /* 1741603 */   // Label 23771: @1741603
     /* 1741603 */   GIM_Try, /*On fail goto*//*Label 23772*/ GIMT_Encode4(1741689), // Rule ID 11013 //
     /* 1741608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1741619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1741622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1741625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1741628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741654 */     // MIs[0] policy
     /* 1741654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1741667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741688 */     // GIR_Coverage, 11013,
     /* 1741688 */     GIR_EraseRootFromParent_Done,
     /* 1741689 */   // Label 23772: @1741689
     /* 1741689 */   GIM_Try, /*On fail goto*//*Label 23773*/ GIMT_Encode4(1741775), // Rule ID 11016 //
     /* 1741694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1741705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1741708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1741711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1741714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741740 */     // MIs[0] policy
     /* 1741740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741750 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741774 */     // GIR_Coverage, 11016,
     /* 1741774 */     GIR_EraseRootFromParent_Done,
     /* 1741775 */   // Label 23773: @1741775
     /* 1741775 */   GIM_Try, /*On fail goto*//*Label 23774*/ GIMT_Encode4(1741861), // Rule ID 11017 //
     /* 1741780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1741791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1741794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1741797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1741800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1741810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1741822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741826 */     // MIs[0] policy
     /* 1741826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741836 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1741839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741860 */     // GIR_Coverage, 11017,
     /* 1741860 */     GIR_EraseRootFromParent_Done,
     /* 1741861 */   // Label 23774: @1741861
     /* 1741861 */   GIM_Try, /*On fail goto*//*Label 23775*/ GIMT_Encode4(1741947), // Rule ID 11020 //
     /* 1741866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1741877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1741880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1741883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1741886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741912 */     // MIs[0] policy
     /* 1741912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741922 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1741925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741946 */     // GIR_Coverage, 11020,
     /* 1741946 */     GIR_EraseRootFromParent_Done,
     /* 1741947 */   // Label 23775: @1741947
     /* 1741947 */   GIM_Try, /*On fail goto*//*Label 23776*/ GIMT_Encode4(1742033), // Rule ID 11021 //
     /* 1741952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1741960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1741963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1741966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1741969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1741972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1741975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1741982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1741994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741998 */     // MIs[0] policy
     /* 1741998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742032 */     // GIR_Coverage, 11021,
     /* 1742032 */     GIR_EraseRootFromParent_Done,
     /* 1742033 */   // Label 23776: @1742033
     /* 1742033 */   GIM_Try, /*On fail goto*//*Label 23777*/ GIMT_Encode4(1742119), // Rule ID 11024 //
     /* 1742038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742084 */     // MIs[0] policy
     /* 1742084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742118 */     // GIR_Coverage, 11024,
     /* 1742118 */     GIR_EraseRootFromParent_Done,
     /* 1742119 */   // Label 23777: @1742119
     /* 1742119 */   GIM_Try, /*On fail goto*//*Label 23778*/ GIMT_Encode4(1742205), // Rule ID 11025 //
     /* 1742124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742170 */     // MIs[0] policy
     /* 1742170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742180 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742204 */     // GIR_Coverage, 11025,
     /* 1742204 */     GIR_EraseRootFromParent_Done,
     /* 1742205 */   // Label 23778: @1742205
     /* 1742205 */   GIM_Try, /*On fail goto*//*Label 23779*/ GIMT_Encode4(1742291), // Rule ID 11028 //
     /* 1742210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1742230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742256 */     // MIs[0] policy
     /* 1742256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742290 */     // GIR_Coverage, 11028,
     /* 1742290 */     GIR_EraseRootFromParent_Done,
     /* 1742291 */   // Label 23779: @1742291
     /* 1742291 */   GIM_Try, /*On fail goto*//*Label 23780*/ GIMT_Encode4(1742377), // Rule ID 11029 //
     /* 1742296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1742307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1742310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1742313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1742316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742342 */     // MIs[0] policy
     /* 1742342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742352 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742376 */     // GIR_Coverage, 11029,
     /* 1742376 */     GIR_EraseRootFromParent_Done,
     /* 1742377 */   // Label 23780: @1742377
     /* 1742377 */   GIM_Try, /*On fail goto*//*Label 23781*/ GIMT_Encode4(1742463), // Rule ID 11032 //
     /* 1742382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1742402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742428 */     // MIs[0] policy
     /* 1742428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742438 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742462 */     // GIR_Coverage, 11032,
     /* 1742462 */     GIR_EraseRootFromParent_Done,
     /* 1742463 */   // Label 23781: @1742463
     /* 1742463 */   GIM_Try, /*On fail goto*//*Label 23782*/ GIMT_Encode4(1742549), // Rule ID 11033 //
     /* 1742468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1742479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1742482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1742485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1742488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742514 */     // MIs[0] policy
     /* 1742514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742524 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742548 */     // GIR_Coverage, 11033,
     /* 1742548 */     GIR_EraseRootFromParent_Done,
     /* 1742549 */   // Label 23782: @1742549
     /* 1742549 */   GIM_Try, /*On fail goto*//*Label 23783*/ GIMT_Encode4(1742635), // Rule ID 11036 //
     /* 1742554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1742565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1742568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1742571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1742574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742600 */     // MIs[0] policy
     /* 1742600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742634 */     // GIR_Coverage, 11036,
     /* 1742634 */     GIR_EraseRootFromParent_Done,
     /* 1742635 */   // Label 23783: @1742635
     /* 1742635 */   GIM_Try, /*On fail goto*//*Label 23784*/ GIMT_Encode4(1742721), // Rule ID 11037 //
     /* 1742640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1742651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1742654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1742657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1742660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1742663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742686 */     // MIs[0] policy
     /* 1742686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742696 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1742699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742720 */     // GIR_Coverage, 11037,
     /* 1742720 */     GIR_EraseRootFromParent_Done,
     /* 1742721 */   // Label 23784: @1742721
     /* 1742721 */   GIM_Try, /*On fail goto*//*Label 23785*/ GIMT_Encode4(1742807), // Rule ID 11040 //
     /* 1742726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1742737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1742740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1742743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1742746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742772 */     // MIs[0] policy
     /* 1742772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742806 */     // GIR_Coverage, 11040,
     /* 1742806 */     GIR_EraseRootFromParent_Done,
     /* 1742807 */   // Label 23785: @1742807
     /* 1742807 */   GIM_Try, /*On fail goto*//*Label 23786*/ GIMT_Encode4(1742893), // Rule ID 11041 //
     /* 1742812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1742823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1742826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1742829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1742832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742858 */     // MIs[0] policy
     /* 1742858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742868 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1742871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742892 */     // GIR_Coverage, 11041,
     /* 1742892 */     GIR_EraseRootFromParent_Done,
     /* 1742893 */   // Label 23786: @1742893
     /* 1742893 */   GIM_Try, /*On fail goto*//*Label 23787*/ GIMT_Encode4(1742979), // Rule ID 11044 //
     /* 1742898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1742901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1742909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1742912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1742915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1742918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742944 */     // MIs[0] policy
     /* 1742944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1742957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1742975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742978 */     // GIR_Coverage, 11044,
     /* 1742978 */     GIR_EraseRootFromParent_Done,
     /* 1742979 */   // Label 23787: @1742979
     /* 1742979 */   GIM_Try, /*On fail goto*//*Label 23788*/ GIMT_Encode4(1743065), // Rule ID 11045 //
     /* 1742984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1742987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1742992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1742995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1742998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1743001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1743004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743030 */     // MIs[0] policy
     /* 1743030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1743043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1743061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743064 */     // GIR_Coverage, 11045,
     /* 1743064 */     GIR_EraseRootFromParent_Done,
     /* 1743065 */   // Label 23788: @1743065
     /* 1743065 */   GIM_Try, /*On fail goto*//*Label 23789*/ GIMT_Encode4(1743151), // Rule ID 11048 //
     /* 1743070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743116 */     // MIs[0] policy
     /* 1743116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1743129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743150 */     // GIR_Coverage, 11048,
     /* 1743150 */     GIR_EraseRootFromParent_Done,
     /* 1743151 */   // Label 23789: @1743151
     /* 1743151 */   GIM_Try, /*On fail goto*//*Label 23790*/ GIMT_Encode4(1743237), // Rule ID 11049 //
     /* 1743156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743202 */     // MIs[0] policy
     /* 1743202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743212 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1743215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743236 */     // GIR_Coverage, 11049,
     /* 1743236 */     GIR_EraseRootFromParent_Done,
     /* 1743237 */   // Label 23790: @1743237
     /* 1743237 */   GIM_Try, /*On fail goto*//*Label 23791*/ GIMT_Encode4(1743323), // Rule ID 11052 //
     /* 1743242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743288 */     // MIs[0] policy
     /* 1743288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743298 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743322 */     // GIR_Coverage, 11052,
     /* 1743322 */     GIR_EraseRootFromParent_Done,
     /* 1743323 */   // Label 23791: @1743323
     /* 1743323 */   GIM_Try, /*On fail goto*//*Label 23792*/ GIMT_Encode4(1743409), // Rule ID 11053 //
     /* 1743328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743374 */     // MIs[0] policy
     /* 1743374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743384 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743408 */     // GIR_Coverage, 11053,
     /* 1743408 */     GIR_EraseRootFromParent_Done,
     /* 1743409 */   // Label 23792: @1743409
     /* 1743409 */   GIM_Try, /*On fail goto*//*Label 23793*/ GIMT_Encode4(1743495), // Rule ID 11056 //
     /* 1743414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743460 */     // MIs[0] policy
     /* 1743460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743470 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743494 */     // GIR_Coverage, 11056,
     /* 1743494 */     GIR_EraseRootFromParent_Done,
     /* 1743495 */   // Label 23793: @1743495
     /* 1743495 */   GIM_Try, /*On fail goto*//*Label 23794*/ GIMT_Encode4(1743581), // Rule ID 11057 //
     /* 1743500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743546 */     // MIs[0] policy
     /* 1743546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743556 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743580 */     // GIR_Coverage, 11057,
     /* 1743580 */     GIR_EraseRootFromParent_Done,
     /* 1743581 */   // Label 23794: @1743581
     /* 1743581 */   GIM_Try, /*On fail goto*//*Label 23795*/ GIMT_Encode4(1743667), // Rule ID 11060 //
     /* 1743586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1743597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1743600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1743603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743632 */     // MIs[0] policy
     /* 1743632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743642 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743666 */     // GIR_Coverage, 11060,
     /* 1743666 */     GIR_EraseRootFromParent_Done,
     /* 1743667 */   // Label 23795: @1743667
     /* 1743667 */   GIM_Try, /*On fail goto*//*Label 23796*/ GIMT_Encode4(1743753), // Rule ID 11061 //
     /* 1743672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1743683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1743686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1743689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743718 */     // MIs[0] policy
     /* 1743718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743728 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1743731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743752 */     // GIR_Coverage, 11061,
     /* 1743752 */     GIR_EraseRootFromParent_Done,
     /* 1743753 */   // Label 23796: @1743753
     /* 1743753 */   GIM_Try, /*On fail goto*//*Label 23797*/ GIMT_Encode4(1743839), // Rule ID 11064 //
     /* 1743758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1743769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1743772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1743775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743804 */     // MIs[0] policy
     /* 1743804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743814 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743838 */     // GIR_Coverage, 11064,
     /* 1743838 */     GIR_EraseRootFromParent_Done,
     /* 1743839 */   // Label 23797: @1743839
     /* 1743839 */   GIM_Try, /*On fail goto*//*Label 23798*/ GIMT_Encode4(1743925), // Rule ID 11065 //
     /* 1743844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1743855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1743858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1743861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743890 */     // MIs[0] policy
     /* 1743890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743924 */     // GIR_Coverage, 11065,
     /* 1743924 */     GIR_EraseRootFromParent_Done,
     /* 1743925 */   // Label 23798: @1743925
     /* 1743925 */   GIM_Try, /*On fail goto*//*Label 23799*/ GIMT_Encode4(1744011), // Rule ID 11068 //
     /* 1743930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1743938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1743941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1743944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1743947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743976 */     // MIs[0] policy
     /* 1743976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743986 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1743989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744010 */     // GIR_Coverage, 11068,
     /* 1744010 */     GIR_EraseRootFromParent_Done,
     /* 1744011 */   // Label 23799: @1744011
     /* 1744011 */   GIM_Try, /*On fail goto*//*Label 23800*/ GIMT_Encode4(1744097), // Rule ID 11069 //
     /* 1744016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744062 */     // MIs[0] policy
     /* 1744062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744072 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1744075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744096 */     // GIR_Coverage, 11069,
     /* 1744096 */     GIR_EraseRootFromParent_Done,
     /* 1744097 */   // Label 23800: @1744097
     /* 1744097 */   GIM_Try, /*On fail goto*//*Label 23801*/ GIMT_Encode4(1744183), // Rule ID 11072 //
     /* 1744102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744148 */     // MIs[0] policy
     /* 1744148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744158 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744182 */     // GIR_Coverage, 11072,
     /* 1744182 */     GIR_EraseRootFromParent_Done,
     /* 1744183 */   // Label 23801: @1744183
     /* 1744183 */   GIM_Try, /*On fail goto*//*Label 23802*/ GIMT_Encode4(1744269), // Rule ID 11073 //
     /* 1744188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744234 */     // MIs[0] policy
     /* 1744234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744244 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11470:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744268 */     // GIR_Coverage, 11073,
     /* 1744268 */     GIR_EraseRootFromParent_Done,
     /* 1744269 */   // Label 23802: @1744269
     /* 1744269 */   GIM_Try, /*On fail goto*//*Label 23803*/ GIMT_Encode4(1744355), // Rule ID 11076 //
     /* 1744274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744320 */     // MIs[0] policy
     /* 1744320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744330 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744354 */     // GIR_Coverage, 11076,
     /* 1744354 */     GIR_EraseRootFromParent_Done,
     /* 1744355 */   // Label 23803: @1744355
     /* 1744355 */   GIM_Try, /*On fail goto*//*Label 23804*/ GIMT_Encode4(1744441), // Rule ID 11077 //
     /* 1744360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744406 */     // MIs[0] policy
     /* 1744406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11470:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744440 */     // GIR_Coverage, 11077,
     /* 1744440 */     GIR_EraseRootFromParent_Done,
     /* 1744441 */   // Label 23804: @1744441
     /* 1744441 */   GIM_Try, /*On fail goto*//*Label 23805*/ GIMT_Encode4(1744527), // Rule ID 11080 //
     /* 1744446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744492 */     // MIs[0] policy
     /* 1744492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744526 */     // GIR_Coverage, 11080,
     /* 1744526 */     GIR_EraseRootFromParent_Done,
     /* 1744527 */   // Label 23805: @1744527
     /* 1744527 */   GIM_Try, /*On fail goto*//*Label 23806*/ GIMT_Encode4(1744613), // Rule ID 11081 //
     /* 1744532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744578 */     // MIs[0] policy
     /* 1744578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11470:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744612 */     // GIR_Coverage, 11081,
     /* 1744612 */     GIR_EraseRootFromParent_Done,
     /* 1744613 */   // Label 23806: @1744613
     /* 1744613 */   GIM_Try, /*On fail goto*//*Label 23807*/ GIMT_Encode4(1744699), // Rule ID 11084 //
     /* 1744618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1744621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1744629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1744632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1744635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744664 */     // MIs[0] policy
     /* 1744664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744698 */     // GIR_Coverage, 11084,
     /* 1744698 */     GIR_EraseRootFromParent_Done,
     /* 1744699 */   // Label 23807: @1744699
     /* 1744699 */   GIM_Try, /*On fail goto*//*Label 23808*/ GIMT_Encode4(1744785), // Rule ID 11085 //
     /* 1744704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1744707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1744715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1744718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1744721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744750 */     // MIs[0] policy
     /* 1744750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744760 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11470:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1744763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1744781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744784 */     // GIR_Coverage, 11085,
     /* 1744784 */     GIR_EraseRootFromParent_Done,
     /* 1744785 */   // Label 23808: @1744785
     /* 1744785 */   GIM_Try, /*On fail goto*//*Label 23809*/ GIMT_Encode4(1744871), // Rule ID 11088 //
     /* 1744790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1744801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1744804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1744807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744836 */     // MIs[0] policy
     /* 1744836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1744849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744870 */     // GIR_Coverage, 11088,
     /* 1744870 */     GIR_EraseRootFromParent_Done,
     /* 1744871 */   // Label 23809: @1744871
     /* 1744871 */   GIM_Try, /*On fail goto*//*Label 23810*/ GIMT_Encode4(1744957), // Rule ID 11089 //
     /* 1744876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1744887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1744890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1744893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744922 */     // MIs[0] policy
     /* 1744922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1744935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744956 */     // GIR_Coverage, 11089,
     /* 1744956 */     GIR_EraseRootFromParent_Done,
     /* 1744957 */   // Label 23810: @1744957
     /* 1744957 */   GIM_Try, /*On fail goto*//*Label 23811*/ GIMT_Encode4(1745043), // Rule ID 11092 //
     /* 1744962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1744970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1744973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1744976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1744979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1744985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1744992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1744996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745008 */     // MIs[0] policy
     /* 1745008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745018 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745042 */     // GIR_Coverage, 11092,
     /* 1745042 */     GIR_EraseRootFromParent_Done,
     /* 1745043 */   // Label 23811: @1745043
     /* 1745043 */   GIM_Try, /*On fail goto*//*Label 23812*/ GIMT_Encode4(1745129), // Rule ID 11093 //
     /* 1745048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745094 */     // MIs[0] policy
     /* 1745094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745104 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745128 */     // GIR_Coverage, 11093,
     /* 1745128 */     GIR_EraseRootFromParent_Done,
     /* 1745129 */   // Label 23812: @1745129
     /* 1745129 */   GIM_Try, /*On fail goto*//*Label 23813*/ GIMT_Encode4(1745215), // Rule ID 11096 //
     /* 1745134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745180 */     // MIs[0] policy
     /* 1745180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745190 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745214 */     // GIR_Coverage, 11096,
     /* 1745214 */     GIR_EraseRootFromParent_Done,
     /* 1745215 */   // Label 23813: @1745215
     /* 1745215 */   GIM_Try, /*On fail goto*//*Label 23814*/ GIMT_Encode4(1745301), // Rule ID 11097 //
     /* 1745220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745266 */     // MIs[0] policy
     /* 1745266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745276 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745300 */     // GIR_Coverage, 11097,
     /* 1745300 */     GIR_EraseRootFromParent_Done,
     /* 1745301 */   // Label 23814: @1745301
     /* 1745301 */   GIM_Try, /*On fail goto*//*Label 23815*/ GIMT_Encode4(1745387), // Rule ID 11100 //
     /* 1745306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745352 */     // MIs[0] policy
     /* 1745352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745386 */     // GIR_Coverage, 11100,
     /* 1745386 */     GIR_EraseRootFromParent_Done,
     /* 1745387 */   // Label 23815: @1745387
     /* 1745387 */   GIM_Try, /*On fail goto*//*Label 23816*/ GIMT_Encode4(1745473), // Rule ID 11101 //
     /* 1745392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745438 */     // MIs[0] policy
     /* 1745438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745448 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745472 */     // GIR_Coverage, 11101,
     /* 1745472 */     GIR_EraseRootFromParent_Done,
     /* 1745473 */   // Label 23816: @1745473
     /* 1745473 */   GIM_Try, /*On fail goto*//*Label 23817*/ GIMT_Encode4(1745559), // Rule ID 11104 //
     /* 1745478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745524 */     // MIs[0] policy
     /* 1745524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745534 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745558 */     // GIR_Coverage, 11104,
     /* 1745558 */     GIR_EraseRootFromParent_Done,
     /* 1745559 */   // Label 23817: @1745559
     /* 1745559 */   GIM_Try, /*On fail goto*//*Label 23818*/ GIMT_Encode4(1745645), // Rule ID 11105 //
     /* 1745564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745610 */     // MIs[0] policy
     /* 1745610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745620 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1745623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745644 */     // GIR_Coverage, 11105,
     /* 1745644 */     GIR_EraseRootFromParent_Done,
     /* 1745645 */   // Label 23818: @1745645
     /* 1745645 */   GIM_Try, /*On fail goto*//*Label 23819*/ GIMT_Encode4(1745731), // Rule ID 11108 //
     /* 1745650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1745667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745696 */     // MIs[0] policy
     /* 1745696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745730 */     // GIR_Coverage, 11108,
     /* 1745730 */     GIR_EraseRootFromParent_Done,
     /* 1745731 */   // Label 23819: @1745731
     /* 1745731 */   GIM_Try, /*On fail goto*//*Label 23820*/ GIMT_Encode4(1745817), // Rule ID 11109 //
     /* 1745736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1745753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745782 */     // MIs[0] policy
     /* 1745782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745792 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1745795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745816 */     // GIR_Coverage, 11109,
     /* 1745816 */     GIR_EraseRootFromParent_Done,
     /* 1745817 */   // Label 23820: @1745817
     /* 1745817 */   GIM_Try, /*On fail goto*//*Label 23821*/ GIMT_Encode4(1745903), // Rule ID 11112 //
     /* 1745822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1745833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1745836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1745839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745868 */     // MIs[0] policy
     /* 1745868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1745899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745902 */     // GIR_Coverage, 11112,
     /* 1745902 */     GIR_EraseRootFromParent_Done,
     /* 1745903 */   // Label 23821: @1745903
     /* 1745903 */   GIM_Try, /*On fail goto*//*Label 23822*/ GIMT_Encode4(1745989), // Rule ID 11113 //
     /* 1745908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1745916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1745919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1745922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1745925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745954 */     // MIs[0] policy
     /* 1745954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745964 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1745967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1745985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745988 */     // GIR_Coverage, 11113,
     /* 1745988 */     GIR_EraseRootFromParent_Done,
     /* 1745989 */   // Label 23822: @1745989
     /* 1745989 */   GIM_Try, /*On fail goto*//*Label 23823*/ GIMT_Encode4(1746075), // Rule ID 11116 //
     /* 1745994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746040 */     // MIs[0] policy
     /* 1746040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746050 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746074 */     // GIR_Coverage, 11116,
     /* 1746074 */     GIR_EraseRootFromParent_Done,
     /* 1746075 */   // Label 23823: @1746075
     /* 1746075 */   GIM_Try, /*On fail goto*//*Label 23824*/ GIMT_Encode4(1746161), // Rule ID 11117 //
     /* 1746080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746126 */     // MIs[0] policy
     /* 1746126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746136 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746160 */     // GIR_Coverage, 11117,
     /* 1746160 */     GIR_EraseRootFromParent_Done,
     /* 1746161 */   // Label 23824: @1746161
     /* 1746161 */   GIM_Try, /*On fail goto*//*Label 23825*/ GIMT_Encode4(1746247), // Rule ID 11120 //
     /* 1746166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746212 */     // MIs[0] policy
     /* 1746212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746222 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746246 */     // GIR_Coverage, 11120,
     /* 1746246 */     GIR_EraseRootFromParent_Done,
     /* 1746247 */   // Label 23825: @1746247
     /* 1746247 */   GIM_Try, /*On fail goto*//*Label 23826*/ GIMT_Encode4(1746333), // Rule ID 11121 //
     /* 1746252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746298 */     // MIs[0] policy
     /* 1746298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746308 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746332 */     // GIR_Coverage, 11121,
     /* 1746332 */     GIR_EraseRootFromParent_Done,
     /* 1746333 */   // Label 23826: @1746333
     /* 1746333 */   GIM_Try, /*On fail goto*//*Label 23827*/ GIMT_Encode4(1746419), // Rule ID 11124 //
     /* 1746338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746384 */     // MIs[0] policy
     /* 1746384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746418 */     // GIR_Coverage, 11124,
     /* 1746418 */     GIR_EraseRootFromParent_Done,
     /* 1746419 */   // Label 23827: @1746419
     /* 1746419 */   GIM_Try, /*On fail goto*//*Label 23828*/ GIMT_Encode4(1746505), // Rule ID 11125 //
     /* 1746424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1746435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1746438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1746441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746470 */     // MIs[0] policy
     /* 1746470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746480 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11470:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1746483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746504 */     // GIR_Coverage, 11125,
     /* 1746504 */     GIR_EraseRootFromParent_Done,
     /* 1746505 */   // Label 23828: @1746505
     /* 1746505 */   GIM_Try, /*On fail goto*//*Label 23829*/ GIMT_Encode4(1746591), // Rule ID 11128 //
     /* 1746510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1746521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1746524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1746527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746556 */     // MIs[0] policy
     /* 1746556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746566 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746590 */     // GIR_Coverage, 11128,
     /* 1746590 */     GIR_EraseRootFromParent_Done,
     /* 1746591 */   // Label 23829: @1746591
     /* 1746591 */   GIM_Try, /*On fail goto*//*Label 23830*/ GIMT_Encode4(1746677), // Rule ID 11129 //
     /* 1746596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1746607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1746610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1746613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746642 */     // MIs[0] policy
     /* 1746642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746652 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11470:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1746655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746676 */     // GIR_Coverage, 11129,
     /* 1746676 */     GIR_EraseRootFromParent_Done,
     /* 1746677 */   // Label 23830: @1746677
     /* 1746677 */   GIM_Try, /*On fail goto*//*Label 23831*/ GIMT_Encode4(1746763), // Rule ID 11132 //
     /* 1746682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1746685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1746693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1746696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1746699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746728 */     // MIs[0] policy
     /* 1746728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746762 */     // GIR_Coverage, 11132,
     /* 1746762 */     GIR_EraseRootFromParent_Done,
     /* 1746763 */   // Label 23831: @1746763
     /* 1746763 */   GIM_Try, /*On fail goto*//*Label 23832*/ GIMT_Encode4(1746849), // Rule ID 11133 //
     /* 1746768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1746771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1746776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1746779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1746782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1746785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746814 */     // MIs[0] policy
     /* 1746814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746824 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11470:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1746827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1746845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746848 */     // GIR_Coverage, 11133,
     /* 1746848 */     GIR_EraseRootFromParent_Done,
     /* 1746849 */   // Label 23832: @1746849
     /* 1746849 */   GIM_Try, /*On fail goto*//*Label 23833*/ GIMT_Encode4(1746935), // Rule ID 11136 //
     /* 1746854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1746865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1746868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1746871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1746874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746900 */     // MIs[0] policy
     /* 1746900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746910 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1746913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746934 */     // GIR_Coverage, 11136,
     /* 1746934 */     GIR_EraseRootFromParent_Done,
     /* 1746935 */   // Label 23833: @1746935
     /* 1746935 */   GIM_Try, /*On fail goto*//*Label 23834*/ GIMT_Encode4(1747021), // Rule ID 11137 //
     /* 1746940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1746951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1746954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1746957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1746960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746986 */     // MIs[0] policy
     /* 1746986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746996 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1746999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747020 */     // GIR_Coverage, 11137,
     /* 1747020 */     GIR_EraseRootFromParent_Done,
     /* 1747021 */   // Label 23834: @1747021
     /* 1747021 */   GIM_Try, /*On fail goto*//*Label 23835*/ GIMT_Encode4(1747107), // Rule ID 11140 //
     /* 1747026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747072 */     // MIs[0] policy
     /* 1747072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747082 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747106 */     // GIR_Coverage, 11140,
     /* 1747106 */     GIR_EraseRootFromParent_Done,
     /* 1747107 */   // Label 23835: @1747107
     /* 1747107 */   GIM_Try, /*On fail goto*//*Label 23836*/ GIMT_Encode4(1747193), // Rule ID 11141 //
     /* 1747112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1747123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1747126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1747129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1747132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747158 */     // MIs[0] policy
     /* 1747158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747168 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747192 */     // GIR_Coverage, 11141,
     /* 1747192 */     GIR_EraseRootFromParent_Done,
     /* 1747193 */   // Label 23836: @1747193
     /* 1747193 */   GIM_Try, /*On fail goto*//*Label 23837*/ GIMT_Encode4(1747279), // Rule ID 11144 //
     /* 1747198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747244 */     // MIs[0] policy
     /* 1747244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747254 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747278 */     // GIR_Coverage, 11144,
     /* 1747278 */     GIR_EraseRootFromParent_Done,
     /* 1747279 */   // Label 23837: @1747279
     /* 1747279 */   GIM_Try, /*On fail goto*//*Label 23838*/ GIMT_Encode4(1747365), // Rule ID 11145 //
     /* 1747284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1747295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1747298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1747301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1747304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747330 */     // MIs[0] policy
     /* 1747330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747340 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747364 */     // GIR_Coverage, 11145,
     /* 1747364 */     GIR_EraseRootFromParent_Done,
     /* 1747365 */   // Label 23838: @1747365
     /* 1747365 */   GIM_Try, /*On fail goto*//*Label 23839*/ GIMT_Encode4(1747451), // Rule ID 11148 //
     /* 1747370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1747390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747416 */     // MIs[0] policy
     /* 1747416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747426 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747450 */     // GIR_Coverage, 11148,
     /* 1747450 */     GIR_EraseRootFromParent_Done,
     /* 1747451 */   // Label 23839: @1747451
     /* 1747451 */   GIM_Try, /*On fail goto*//*Label 23840*/ GIMT_Encode4(1747537), // Rule ID 11149 //
     /* 1747456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1747476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747502 */     // MIs[0] policy
     /* 1747502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747512 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1747515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747536 */     // GIR_Coverage, 11149,
     /* 1747536 */     GIR_EraseRootFromParent_Done,
     /* 1747537 */   // Label 23840: @1747537
     /* 1747537 */   GIM_Try, /*On fail goto*//*Label 23841*/ GIMT_Encode4(1747623), // Rule ID 11152 //
     /* 1747542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1747559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1747562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747588 */     // MIs[0] policy
     /* 1747588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747598 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747622 */     // GIR_Coverage, 11152,
     /* 1747622 */     GIR_EraseRootFromParent_Done,
     /* 1747623 */   // Label 23841: @1747623
     /* 1747623 */   GIM_Try, /*On fail goto*//*Label 23842*/ GIMT_Encode4(1747709), // Rule ID 11153 //
     /* 1747628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1747645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1747648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747674 */     // MIs[0] policy
     /* 1747674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747708 */     // GIR_Coverage, 11153,
     /* 1747708 */     GIR_EraseRootFromParent_Done,
     /* 1747709 */   // Label 23842: @1747709
     /* 1747709 */   GIM_Try, /*On fail goto*//*Label 23843*/ GIMT_Encode4(1747795), // Rule ID 11156 //
     /* 1747714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1747725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1747728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1747731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1747734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747760 */     // MIs[0] policy
     /* 1747760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747770 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747794 */     // GIR_Coverage, 11156,
     /* 1747794 */     GIR_EraseRootFromParent_Done,
     /* 1747795 */   // Label 23843: @1747795
     /* 1747795 */   GIM_Try, /*On fail goto*//*Label 23844*/ GIMT_Encode4(1747881), // Rule ID 11157 //
     /* 1747800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1747811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1747814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1747817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1747820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747846 */     // MIs[0] policy
     /* 1747846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747856 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1747859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747880 */     // GIR_Coverage, 11157,
     /* 1747880 */     GIR_EraseRootFromParent_Done,
     /* 1747881 */   // Label 23844: @1747881
     /* 1747881 */   GIM_Try, /*On fail goto*//*Label 23845*/ GIMT_Encode4(1747967), // Rule ID 11160 //
     /* 1747886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1747897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1747900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1747903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1747906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747932 */     // MIs[0] policy
     /* 1747932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747942 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1747945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747966 */     // GIR_Coverage, 11160,
     /* 1747966 */     GIR_EraseRootFromParent_Done,
     /* 1747967 */   // Label 23845: @1747967
     /* 1747967 */   GIM_Try, /*On fail goto*//*Label 23846*/ GIMT_Encode4(1748053), // Rule ID 11161 //
     /* 1747972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1747980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1747983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1747986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1747989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1747992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748018 */     // MIs[0] policy
     /* 1748018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748052 */     // GIR_Coverage, 11161,
     /* 1748052 */     GIR_EraseRootFromParent_Done,
     /* 1748053 */   // Label 23846: @1748053
     /* 1748053 */   GIM_Try, /*On fail goto*//*Label 23847*/ GIMT_Encode4(1748139), // Rule ID 11164 //
     /* 1748058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1748078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748104 */     // MIs[0] policy
     /* 1748104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748114 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748138 */     // GIR_Coverage, 11164,
     /* 1748138 */     GIR_EraseRootFromParent_Done,
     /* 1748139 */   // Label 23847: @1748139
     /* 1748139 */   GIM_Try, /*On fail goto*//*Label 23848*/ GIMT_Encode4(1748225), // Rule ID 11165 //
     /* 1748144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1748155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1748158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1748161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1748164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1748167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748190 */     // MIs[0] policy
     /* 1748190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748224 */     // GIR_Coverage, 11165,
     /* 1748224 */     GIR_EraseRootFromParent_Done,
     /* 1748225 */   // Label 23848: @1748225
     /* 1748225 */   GIM_Try, /*On fail goto*//*Label 23849*/ GIMT_Encode4(1748311), // Rule ID 11168 //
     /* 1748230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1748250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748276 */     // MIs[0] policy
     /* 1748276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748310 */     // GIR_Coverage, 11168,
     /* 1748310 */     GIR_EraseRootFromParent_Done,
     /* 1748311 */   // Label 23849: @1748311
     /* 1748311 */   GIM_Try, /*On fail goto*//*Label 23850*/ GIMT_Encode4(1748397), // Rule ID 11169 //
     /* 1748316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1748327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1748330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1748333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1748336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1748339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1748346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1748358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748362 */     // MIs[0] policy
     /* 1748362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1748375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1748393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748396 */     // GIR_Coverage, 11169,
     /* 1748396 */     GIR_EraseRootFromParent_Done,
     /* 1748397 */   // Label 23850: @1748397
     /* 1748397 */   GIM_Try, /*On fail goto*//*Label 23851*/ GIMT_Encode4(1748483), // Rule ID 11172 //
     /* 1748402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748448 */     // MIs[0] policy
     /* 1748448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748458 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1748461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748482 */     // GIR_Coverage, 11172,
     /* 1748482 */     GIR_EraseRootFromParent_Done,
     /* 1748483 */   // Label 23851: @1748483
     /* 1748483 */   GIM_Try, /*On fail goto*//*Label 23852*/ GIMT_Encode4(1748569), // Rule ID 11173 //
     /* 1748488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748534 */     // MIs[0] policy
     /* 1748534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1748547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748568 */     // GIR_Coverage, 11173,
     /* 1748568 */     GIR_EraseRootFromParent_Done,
     /* 1748569 */   // Label 23852: @1748569
     /* 1748569 */   GIM_Try, /*On fail goto*//*Label 23853*/ GIMT_Encode4(1748655), // Rule ID 11176 //
     /* 1748574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1748585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1748588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1748591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1748594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748620 */     // MIs[0] policy
     /* 1748620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748630 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1748633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748654 */     // GIR_Coverage, 11176,
     /* 1748654 */     GIR_EraseRootFromParent_Done,
     /* 1748655 */   // Label 23853: @1748655
     /* 1748655 */   GIM_Try, /*On fail goto*//*Label 23854*/ GIMT_Encode4(1748741), // Rule ID 11177 //
     /* 1748660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1748671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1748674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1748677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1748680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748706 */     // MIs[0] policy
     /* 1748706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748716 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1748719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748740 */     // GIR_Coverage, 11177,
     /* 1748740 */     GIR_EraseRootFromParent_Done,
     /* 1748741 */   // Label 23854: @1748741
     /* 1748741 */   GIM_Try, /*On fail goto*//*Label 23855*/ GIMT_Encode4(1748827), // Rule ID 11180 //
     /* 1748746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1748757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1748760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1748763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1748766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1748769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748792 */     // MIs[0] policy
     /* 1748792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748802 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1748805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748826 */     // GIR_Coverage, 11180,
     /* 1748826 */     GIR_EraseRootFromParent_Done,
     /* 1748827 */   // Label 23855: @1748827
     /* 1748827 */   GIM_Try, /*On fail goto*//*Label 23856*/ GIMT_Encode4(1748913), // Rule ID 11181 //
     /* 1748832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1748843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1748846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1748849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1748852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1748855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748878 */     // MIs[0] policy
     /* 1748878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748888 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1748891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748912 */     // GIR_Coverage, 11181,
     /* 1748912 */     GIR_EraseRootFromParent_Done,
     /* 1748913 */   // Label 23856: @1748913
     /* 1748913 */   GIM_Try, /*On fail goto*//*Label 23857*/ GIMT_Encode4(1748999), // Rule ID 11184 //
     /* 1748918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1748926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1748929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1748932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1748935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1748938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748964 */     // MIs[0] policy
     /* 1748964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1748977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748998 */     // GIR_Coverage, 11184,
     /* 1748998 */     GIR_EraseRootFromParent_Done,
     /* 1748999 */   // Label 23857: @1748999
     /* 1748999 */   GIM_Try, /*On fail goto*//*Label 23858*/ GIMT_Encode4(1749085), // Rule ID 11185 //
     /* 1749004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1749015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1749018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1749021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1749024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749050 */     // MIs[0] policy
     /* 1749050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749084 */     // GIR_Coverage, 11185,
     /* 1749084 */     GIR_EraseRootFromParent_Done,
     /* 1749085 */   // Label 23858: @1749085
     /* 1749085 */   GIM_Try, /*On fail goto*//*Label 23859*/ GIMT_Encode4(1749171), // Rule ID 11188 //
     /* 1749090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749136 */     // MIs[0] policy
     /* 1749136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749146 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749170 */     // GIR_Coverage, 11188,
     /* 1749170 */     GIR_EraseRootFromParent_Done,
     /* 1749171 */   // Label 23859: @1749171
     /* 1749171 */   GIM_Try, /*On fail goto*//*Label 23860*/ GIMT_Encode4(1749257), // Rule ID 11189 //
     /* 1749176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1749187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1749190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1749193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1749196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749222 */     // MIs[0] policy
     /* 1749222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749232 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749256 */     // GIR_Coverage, 11189,
     /* 1749256 */     GIR_EraseRootFromParent_Done,
     /* 1749257 */   // Label 23860: @1749257
     /* 1749257 */   GIM_Try, /*On fail goto*//*Label 23861*/ GIMT_Encode4(1749343), // Rule ID 11192 //
     /* 1749262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1749282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749308 */     // MIs[0] policy
     /* 1749308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749318 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749342 */     // GIR_Coverage, 11192,
     /* 1749342 */     GIR_EraseRootFromParent_Done,
     /* 1749343 */   // Label 23861: @1749343
     /* 1749343 */   GIM_Try, /*On fail goto*//*Label 23862*/ GIMT_Encode4(1749429), // Rule ID 11193 //
     /* 1749348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1749359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1749362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1749365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1749368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1749371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749394 */     // MIs[0] policy
     /* 1749394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749404 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749428 */     // GIR_Coverage, 11193,
     /* 1749428 */     GIR_EraseRootFromParent_Done,
     /* 1749429 */   // Label 23862: @1749429
     /* 1749429 */   GIM_Try, /*On fail goto*//*Label 23863*/ GIMT_Encode4(1749515), // Rule ID 11196 //
     /* 1749434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749480 */     // MIs[0] policy
     /* 1749480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749514 */     // GIR_Coverage, 11196,
     /* 1749514 */     GIR_EraseRootFromParent_Done,
     /* 1749515 */   // Label 23863: @1749515
     /* 1749515 */   GIM_Try, /*On fail goto*//*Label 23864*/ GIMT_Encode4(1749601), // Rule ID 11197 //
     /* 1749520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749566 */     // MIs[0] policy
     /* 1749566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1749579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749600 */     // GIR_Coverage, 11197,
     /* 1749600 */     GIR_EraseRootFromParent_Done,
     /* 1749601 */   // Label 23864: @1749601
     /* 1749601 */   GIM_Try, /*On fail goto*//*Label 23865*/ GIMT_Encode4(1749687), // Rule ID 11200 //
     /* 1749606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1749623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1749626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749652 */     // MIs[0] policy
     /* 1749652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749662 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749686 */     // GIR_Coverage, 11200,
     /* 1749686 */     GIR_EraseRootFromParent_Done,
     /* 1749687 */   // Label 23865: @1749687
     /* 1749687 */   GIM_Try, /*On fail goto*//*Label 23866*/ GIMT_Encode4(1749773), // Rule ID 11201 //
     /* 1749692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1749709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1749712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749738 */     // MIs[0] policy
     /* 1749738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1749751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749772 */     // GIR_Coverage, 11201,
     /* 1749772 */     GIR_EraseRootFromParent_Done,
     /* 1749773 */   // Label 23866: @1749773
     /* 1749773 */   GIM_Try, /*On fail goto*//*Label 23867*/ GIMT_Encode4(1749859), // Rule ID 11204 //
     /* 1749778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1749789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1749792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1749795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1749798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749824 */     // MIs[0] policy
     /* 1749824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749834 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749858 */     // GIR_Coverage, 11204,
     /* 1749858 */     GIR_EraseRootFromParent_Done,
     /* 1749859 */   // Label 23867: @1749859
     /* 1749859 */   GIM_Try, /*On fail goto*//*Label 23868*/ GIMT_Encode4(1749945), // Rule ID 11205 //
     /* 1749864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1749875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1749878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1749881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1749884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749910 */     // MIs[0] policy
     /* 1749910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1749923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749944 */     // GIR_Coverage, 11205,
     /* 1749944 */     GIR_EraseRootFromParent_Done,
     /* 1749945 */   // Label 23868: @1749945
     /* 1749945 */   GIM_Try, /*On fail goto*//*Label 23869*/ GIMT_Encode4(1750031), // Rule ID 11208 //
     /* 1749950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1749958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1749961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1749964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1749967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1749973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749996 */     // MIs[0] policy
     /* 1749996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750006 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1750009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750030 */     // GIR_Coverage, 11208,
     /* 1750030 */     GIR_EraseRootFromParent_Done,
     /* 1750031 */   // Label 23869: @1750031
     /* 1750031 */   GIM_Try, /*On fail goto*//*Label 23870*/ GIMT_Encode4(1750117), // Rule ID 11209 //
     /* 1750036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1750047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1750050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1750053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750082 */     // MIs[0] policy
     /* 1750082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750092 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1750095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750116 */     // GIR_Coverage, 11209,
     /* 1750116 */     GIR_EraseRootFromParent_Done,
     /* 1750117 */   // Label 23870: @1750117
     /* 1750117 */   GIM_Try, /*On fail goto*//*Label 23871*/ GIMT_Encode4(1750203), // Rule ID 11212 //
     /* 1750122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750168 */     // MIs[0] policy
     /* 1750168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750178 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750202 */     // GIR_Coverage, 11212,
     /* 1750202 */     GIR_EraseRootFromParent_Done,
     /* 1750203 */   // Label 23871: @1750203
     /* 1750203 */   GIM_Try, /*On fail goto*//*Label 23872*/ GIMT_Encode4(1750289), // Rule ID 11213 //
     /* 1750208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1750219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1750222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1750225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750254 */     // MIs[0] policy
     /* 1750254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750264 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750288 */     // GIR_Coverage, 11213,
     /* 1750288 */     GIR_EraseRootFromParent_Done,
     /* 1750289 */   // Label 23872: @1750289
     /* 1750289 */   GIM_Try, /*On fail goto*//*Label 23873*/ GIMT_Encode4(1750375), // Rule ID 11216 //
     /* 1750294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1750305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1750308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750340 */     // MIs[0] policy
     /* 1750340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750350 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750374 */     // GIR_Coverage, 11216,
     /* 1750374 */     GIR_EraseRootFromParent_Done,
     /* 1750375 */   // Label 23873: @1750375
     /* 1750375 */   GIM_Try, /*On fail goto*//*Label 23874*/ GIMT_Encode4(1750461), // Rule ID 11217 //
     /* 1750380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1750391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1750394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750426 */     // MIs[0] policy
     /* 1750426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750436 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750460 */     // GIR_Coverage, 11217,
     /* 1750460 */     GIR_EraseRootFromParent_Done,
     /* 1750461 */   // Label 23874: @1750461
     /* 1750461 */   GIM_Try, /*On fail goto*//*Label 23875*/ GIMT_Encode4(1750547), // Rule ID 11220 //
     /* 1750466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1750483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750512 */     // MIs[0] policy
     /* 1750512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750522 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750546 */     // GIR_Coverage, 11220,
     /* 1750546 */     GIR_EraseRootFromParent_Done,
     /* 1750547 */   // Label 23875: @1750547
     /* 1750547 */   GIM_Try, /*On fail goto*//*Label 23876*/ GIMT_Encode4(1750633), // Rule ID 11221 //
     /* 1750552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1750569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750598 */     // MIs[0] policy
     /* 1750598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750608 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1750611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750632 */     // GIR_Coverage, 11221,
     /* 1750632 */     GIR_EraseRootFromParent_Done,
     /* 1750633 */   // Label 23876: @1750633
     /* 1750633 */   GIM_Try, /*On fail goto*//*Label 23877*/ GIMT_Encode4(1750719), // Rule ID 11224 //
     /* 1750638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1750649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1750652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1750655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750684 */     // MIs[0] policy
     /* 1750684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750718 */     // GIR_Coverage, 11224,
     /* 1750718 */     GIR_EraseRootFromParent_Done,
     /* 1750719 */   // Label 23877: @1750719
     /* 1750719 */   GIM_Try, /*On fail goto*//*Label 23878*/ GIMT_Encode4(1750805), // Rule ID 11225 //
     /* 1750724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1750735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1750738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1750741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750770 */     // MIs[0] policy
     /* 1750770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750804 */     // GIR_Coverage, 11225,
     /* 1750804 */     GIR_EraseRootFromParent_Done,
     /* 1750805 */   // Label 23878: @1750805
     /* 1750805 */   GIM_Try, /*On fail goto*//*Label 23879*/ GIMT_Encode4(1750891), // Rule ID 11228 //
     /* 1750810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1750821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1750824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1750827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750856 */     // MIs[0] policy
     /* 1750856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750890 */     // GIR_Coverage, 11228,
     /* 1750890 */     GIR_EraseRootFromParent_Done,
     /* 1750891 */   // Label 23879: @1750891
     /* 1750891 */   GIM_Try, /*On fail goto*//*Label 23880*/ GIMT_Encode4(1750977), // Rule ID 11229 //
     /* 1750896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1750907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1750910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1750913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750942 */     // MIs[0] policy
     /* 1750942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1750955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750976 */     // GIR_Coverage, 11229,
     /* 1750976 */     GIR_EraseRootFromParent_Done,
     /* 1750977 */   // Label 23880: @1750977
     /* 1750977 */   GIM_Try, /*On fail goto*//*Label 23881*/ GIMT_Encode4(1751063), // Rule ID 11232 //
     /* 1750982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1750990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1750993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1750996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1750999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751028 */     // MIs[0] policy
     /* 1751028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751038 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751062 */     // GIR_Coverage, 11232,
     /* 1751062 */     GIR_EraseRootFromParent_Done,
     /* 1751063 */   // Label 23881: @1751063
     /* 1751063 */   GIM_Try, /*On fail goto*//*Label 23882*/ GIMT_Encode4(1751149), // Rule ID 11233 //
     /* 1751068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1751079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1751082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1751085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751114 */     // MIs[0] policy
     /* 1751114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11472:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751148 */     // GIR_Coverage, 11233,
     /* 1751148 */     GIR_EraseRootFromParent_Done,
     /* 1751149 */   // Label 23882: @1751149
     /* 1751149 */   GIM_Try, /*On fail goto*//*Label 23883*/ GIMT_Encode4(1751235), // Rule ID 11236 //
     /* 1751154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1751168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751200 */     // MIs[0] policy
     /* 1751200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751210 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751234 */     // GIR_Coverage, 11236,
     /* 1751234 */     GIR_EraseRootFromParent_Done,
     /* 1751235 */   // Label 23883: @1751235
     /* 1751235 */   GIM_Try, /*On fail goto*//*Label 23884*/ GIMT_Encode4(1751321), // Rule ID 11237 //
     /* 1751240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1751251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1751254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1751257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1751263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751286 */     // MIs[0] policy
     /* 1751286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751296 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751320 */     // GIR_Coverage, 11237,
     /* 1751320 */     GIR_EraseRootFromParent_Done,
     /* 1751321 */   // Label 23884: @1751321
     /* 1751321 */   GIM_Try, /*On fail goto*//*Label 23885*/ GIMT_Encode4(1751407), // Rule ID 11240 //
     /* 1751326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1751343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751372 */     // MIs[0] policy
     /* 1751372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751406 */     // GIR_Coverage, 11240,
     /* 1751406 */     GIR_EraseRootFromParent_Done,
     /* 1751407 */   // Label 23885: @1751407
     /* 1751407 */   GIM_Try, /*On fail goto*//*Label 23886*/ GIMT_Encode4(1751493), // Rule ID 11241 //
     /* 1751412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1751429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751458 */     // MIs[0] policy
     /* 1751458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1751471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751492 */     // GIR_Coverage, 11241,
     /* 1751492 */     GIR_EraseRootFromParent_Done,
     /* 1751493 */   // Label 23886: @1751493
     /* 1751493 */   GIM_Try, /*On fail goto*//*Label 23887*/ GIMT_Encode4(1751579), // Rule ID 11244 //
     /* 1751498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1751509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1751512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1751515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751544 */     // MIs[0] policy
     /* 1751544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751554 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1751557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751578 */     // GIR_Coverage, 11244,
     /* 1751578 */     GIR_EraseRootFromParent_Done,
     /* 1751579 */   // Label 23887: @1751579
     /* 1751579 */   GIM_Try, /*On fail goto*//*Label 23888*/ GIMT_Encode4(1751665), // Rule ID 11245 //
     /* 1751584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1751595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1751598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1751601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751630 */     // MIs[0] policy
     /* 1751630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751640 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1751643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751664 */     // GIR_Coverage, 11245,
     /* 1751664 */     GIR_EraseRootFromParent_Done,
     /* 1751665 */   // Label 23888: @1751665
     /* 1751665 */   GIM_Try, /*On fail goto*//*Label 23889*/ GIMT_Encode4(1751751), // Rule ID 11248 //
     /* 1751670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1751681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1751684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1751687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1751693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751716 */     // MIs[0] policy
     /* 1751716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751726 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1751729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751750 */     // GIR_Coverage, 11248,
     /* 1751750 */     GIR_EraseRootFromParent_Done,
     /* 1751751 */   // Label 23889: @1751751
     /* 1751751 */   GIM_Try, /*On fail goto*//*Label 23890*/ GIMT_Encode4(1751837), // Rule ID 11249 //
     /* 1751756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1751767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1751770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1751773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1751779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751802 */     // MIs[0] policy
     /* 1751802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751812 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1751815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751836 */     // GIR_Coverage, 11249,
     /* 1751836 */     GIR_EraseRootFromParent_Done,
     /* 1751837 */   // Label 23890: @1751837
     /* 1751837 */   GIM_Try, /*On fail goto*//*Label 23891*/ GIMT_Encode4(1751923), // Rule ID 11252 //
     /* 1751842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1751853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1751856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1751859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1751865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751888 */     // MIs[0] policy
     /* 1751888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751898 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1751901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751922 */     // GIR_Coverage, 11252,
     /* 1751922 */     GIR_EraseRootFromParent_Done,
     /* 1751923 */   // Label 23891: @1751923
     /* 1751923 */   GIM_Try, /*On fail goto*//*Label 23892*/ GIMT_Encode4(1752009), // Rule ID 11253 //
     /* 1751928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1751936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1751939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1751942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1751945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1751951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751974 */     // MIs[0] policy
     /* 1751974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751984 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1751987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752008 */     // GIR_Coverage, 11253,
     /* 1752008 */     GIR_EraseRootFromParent_Done,
     /* 1752009 */   // Label 23892: @1752009
     /* 1752009 */   GIM_Try, /*On fail goto*//*Label 23893*/ GIMT_Encode4(1752095), // Rule ID 11256 //
     /* 1752014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752060 */     // MIs[0] policy
     /* 1752060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752070 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752094 */     // GIR_Coverage, 11256,
     /* 1752094 */     GIR_EraseRootFromParent_Done,
     /* 1752095 */   // Label 23893: @1752095
     /* 1752095 */   GIM_Try, /*On fail goto*//*Label 23894*/ GIMT_Encode4(1752181), // Rule ID 11257 //
     /* 1752100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1752111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1752114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1752117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752146 */     // MIs[0] policy
     /* 1752146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752180 */     // GIR_Coverage, 11257,
     /* 1752180 */     GIR_EraseRootFromParent_Done,
     /* 1752181 */   // Label 23894: @1752181
     /* 1752181 */   GIM_Try, /*On fail goto*//*Label 23895*/ GIMT_Encode4(1752267), // Rule ID 11260 //
     /* 1752186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1752197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1752200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1752203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752232 */     // MIs[0] policy
     /* 1752232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752242 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752266 */     // GIR_Coverage, 11260,
     /* 1752266 */     GIR_EraseRootFromParent_Done,
     /* 1752267 */   // Label 23895: @1752267
     /* 1752267 */   GIM_Try, /*On fail goto*//*Label 23896*/ GIMT_Encode4(1752353), // Rule ID 11261 //
     /* 1752272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1752283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1752286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1752289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752318 */     // MIs[0] policy
     /* 1752318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752328 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752352 */     // GIR_Coverage, 11261,
     /* 1752352 */     GIR_EraseRootFromParent_Done,
     /* 1752353 */   // Label 23896: @1752353
     /* 1752353 */   GIM_Try, /*On fail goto*//*Label 23897*/ GIMT_Encode4(1752439), // Rule ID 11264 //
     /* 1752358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1752369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1752372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1752375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752404 */     // MIs[0] policy
     /* 1752404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752414 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752438 */     // GIR_Coverage, 11264,
     /* 1752438 */     GIR_EraseRootFromParent_Done,
     /* 1752439 */   // Label 23897: @1752439
     /* 1752439 */   GIM_Try, /*On fail goto*//*Label 23898*/ GIMT_Encode4(1752525), // Rule ID 11265 //
     /* 1752444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1752455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1752458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1752461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752490 */     // MIs[0] policy
     /* 1752490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752500 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752524 */     // GIR_Coverage, 11265,
     /* 1752524 */     GIR_EraseRootFromParent_Done,
     /* 1752525 */   // Label 23898: @1752525
     /* 1752525 */   GIM_Try, /*On fail goto*//*Label 23899*/ GIMT_Encode4(1752611), // Rule ID 11268 //
     /* 1752530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1752541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1752544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1752547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752576 */     // MIs[0] policy
     /* 1752576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752610 */     // GIR_Coverage, 11268,
     /* 1752610 */     GIR_EraseRootFromParent_Done,
     /* 1752611 */   // Label 23899: @1752611
     /* 1752611 */   GIM_Try, /*On fail goto*//*Label 23900*/ GIMT_Encode4(1752697), // Rule ID 11269 //
     /* 1752616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1752627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1752630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1752633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752662 */     // MIs[0] policy
     /* 1752662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1752675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752696 */     // GIR_Coverage, 11269,
     /* 1752696 */     GIR_EraseRootFromParent_Done,
     /* 1752697 */   // Label 23900: @1752697
     /* 1752697 */   GIM_Try, /*On fail goto*//*Label 23901*/ GIMT_Encode4(1752783), // Rule ID 11272 //
     /* 1752702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1752713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1752716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1752719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752748 */     // MIs[0] policy
     /* 1752748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752758 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752782 */     // GIR_Coverage, 11272,
     /* 1752782 */     GIR_EraseRootFromParent_Done,
     /* 1752783 */   // Label 23901: @1752783
     /* 1752783 */   GIM_Try, /*On fail goto*//*Label 23902*/ GIMT_Encode4(1752869), // Rule ID 11273 //
     /* 1752788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1752799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1752802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1752805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752834 */     // MIs[0] policy
     /* 1752834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1752847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752868 */     // GIR_Coverage, 11273,
     /* 1752868 */     GIR_EraseRootFromParent_Done,
     /* 1752869 */   // Label 23902: @1752869
     /* 1752869 */   GIM_Try, /*On fail goto*//*Label 23903*/ GIMT_Encode4(1752955), // Rule ID 11276 //
     /* 1752874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1752885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1752888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1752891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752920 */     // MIs[0] policy
     /* 1752920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752930 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1752933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752954 */     // GIR_Coverage, 11276,
     /* 1752954 */     GIR_EraseRootFromParent_Done,
     /* 1752955 */   // Label 23903: @1752955
     /* 1752955 */   GIM_Try, /*On fail goto*//*Label 23904*/ GIMT_Encode4(1753041), // Rule ID 11277 //
     /* 1752960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1752968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1752971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1752974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1752977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1753002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753006 */     // MIs[0] policy
     /* 1753006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1753019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753040 */     // GIR_Coverage, 11277,
     /* 1753040 */     GIR_EraseRootFromParent_Done,
     /* 1753041 */   // Label 23904: @1753041
     /* 1753041 */   GIM_Try, /*On fail goto*//*Label 23905*/ GIMT_Encode4(1753127), // Rule ID 11280 //
     /* 1753046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1753066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753092 */     // MIs[0] policy
     /* 1753092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753102 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1753105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753126 */     // GIR_Coverage, 11280,
     /* 1753126 */     GIR_EraseRootFromParent_Done,
     /* 1753127 */   // Label 23905: @1753127
     /* 1753127 */   GIM_Try, /*On fail goto*//*Label 23906*/ GIMT_Encode4(1753213), // Rule ID 11281 //
     /* 1753132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1753143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1753146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1753149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1753152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753178 */     // MIs[0] policy
     /* 1753178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753188 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1753191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753212 */     // GIR_Coverage, 11281,
     /* 1753212 */     GIR_EraseRootFromParent_Done,
     /* 1753213 */   // Label 23906: @1753213
     /* 1753213 */   GIM_Try, /*On fail goto*//*Label 23907*/ GIMT_Encode4(1753299), // Rule ID 11284 //
     /* 1753218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1753229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1753232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1753235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1753238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753264 */     // MIs[0] policy
     /* 1753264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753274 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753298 */     // GIR_Coverage, 11284,
     /* 1753298 */     GIR_EraseRootFromParent_Done,
     /* 1753299 */   // Label 23907: @1753299
     /* 1753299 */   GIM_Try, /*On fail goto*//*Label 23908*/ GIMT_Encode4(1753385), // Rule ID 11285 //
     /* 1753304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1753315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1753318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1753321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1753324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753350 */     // MIs[0] policy
     /* 1753350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753360 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753384 */     // GIR_Coverage, 11285,
     /* 1753384 */     GIR_EraseRootFromParent_Done,
     /* 1753385 */   // Label 23908: @1753385
     /* 1753385 */   GIM_Try, /*On fail goto*//*Label 23909*/ GIMT_Encode4(1753471), // Rule ID 11288 //
     /* 1753390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753436 */     // MIs[0] policy
     /* 1753436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753446 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753470 */     // GIR_Coverage, 11288,
     /* 1753470 */     GIR_EraseRootFromParent_Done,
     /* 1753471 */   // Label 23909: @1753471
     /* 1753471 */   GIM_Try, /*On fail goto*//*Label 23910*/ GIMT_Encode4(1753557), // Rule ID 11289 //
     /* 1753476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753522 */     // MIs[0] policy
     /* 1753522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753556 */     // GIR_Coverage, 11289,
     /* 1753556 */     GIR_EraseRootFromParent_Done,
     /* 1753557 */   // Label 23910: @1753557
     /* 1753557 */   GIM_Try, /*On fail goto*//*Label 23911*/ GIMT_Encode4(1753643), // Rule ID 11292 //
     /* 1753562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1753573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1753576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1753579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1753582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753608 */     // MIs[0] policy
     /* 1753608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753618 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753642 */     // GIR_Coverage, 11292,
     /* 1753642 */     GIR_EraseRootFromParent_Done,
     /* 1753643 */   // Label 23911: @1753643
     /* 1753643 */   GIM_Try, /*On fail goto*//*Label 23912*/ GIMT_Encode4(1753729), // Rule ID 11293 //
     /* 1753648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1753659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1753662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1753665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1753668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753694 */     // MIs[0] policy
     /* 1753694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753704 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1753707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753728 */     // GIR_Coverage, 11293,
     /* 1753728 */     GIR_EraseRootFromParent_Done,
     /* 1753729 */   // Label 23912: @1753729
     /* 1753729 */   GIM_Try, /*On fail goto*//*Label 23913*/ GIMT_Encode4(1753815), // Rule ID 11296 //
     /* 1753734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1753745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1753748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1753751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1753754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753780 */     // MIs[0] policy
     /* 1753780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753790 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753814 */     // GIR_Coverage, 11296,
     /* 1753814 */     GIR_EraseRootFromParent_Done,
     /* 1753815 */   // Label 23913: @1753815
     /* 1753815 */   GIM_Try, /*On fail goto*//*Label 23914*/ GIMT_Encode4(1753901), // Rule ID 11297 //
     /* 1753820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1753831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1753834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1753837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1753840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753866 */     // MIs[0] policy
     /* 1753866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753876 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753900 */     // GIR_Coverage, 11297,
     /* 1753900 */     GIR_EraseRootFromParent_Done,
     /* 1753901 */   // Label 23914: @1753901
     /* 1753901 */   GIM_Try, /*On fail goto*//*Label 23915*/ GIMT_Encode4(1753987), // Rule ID 11300 //
     /* 1753906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1753914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1753917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1753920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1753923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1753926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753952 */     // MIs[0] policy
     /* 1753952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753962 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1753965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753986 */     // GIR_Coverage, 11300,
     /* 1753986 */     GIR_EraseRootFromParent_Done,
     /* 1753987 */   // Label 23915: @1753987
     /* 1753987 */   GIM_Try, /*On fail goto*//*Label 23916*/ GIMT_Encode4(1754073), // Rule ID 11301 //
     /* 1753992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1754003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1754006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1754009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1754012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1754015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754038 */     // MIs[0] policy
     /* 1754038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1754051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754072 */     // GIR_Coverage, 11301,
     /* 1754072 */     GIR_EraseRootFromParent_Done,
     /* 1754073 */   // Label 23916: @1754073
     /* 1754073 */   GIM_Try, /*On fail goto*//*Label 23917*/ GIMT_Encode4(1754159), // Rule ID 11304 //
     /* 1754078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1754098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754124 */     // MIs[0] policy
     /* 1754124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754134 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754158 */     // GIR_Coverage, 11304,
     /* 1754158 */     GIR_EraseRootFromParent_Done,
     /* 1754159 */   // Label 23917: @1754159
     /* 1754159 */   GIM_Try, /*On fail goto*//*Label 23918*/ GIMT_Encode4(1754245), // Rule ID 11305 //
     /* 1754164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1754175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1754178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1754181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1754184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754210 */     // MIs[0] policy
     /* 1754210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754244 */     // GIR_Coverage, 11305,
     /* 1754244 */     GIR_EraseRootFromParent_Done,
     /* 1754245 */   // Label 23918: @1754245
     /* 1754245 */   GIM_Try, /*On fail goto*//*Label 23919*/ GIMT_Encode4(1754331), // Rule ID 11308 //
     /* 1754250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1754261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1754264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1754267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754296 */     // MIs[0] policy
     /* 1754296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754306 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754330 */     // GIR_Coverage, 11308,
     /* 1754330 */     GIR_EraseRootFromParent_Done,
     /* 1754331 */   // Label 23919: @1754331
     /* 1754331 */   GIM_Try, /*On fail goto*//*Label 23920*/ GIMT_Encode4(1754417), // Rule ID 11309 //
     /* 1754336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1754347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1754350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1754353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1754356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1754359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754382 */     // MIs[0] policy
     /* 1754382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754416 */     // GIR_Coverage, 11309,
     /* 1754416 */     GIR_EraseRootFromParent_Done,
     /* 1754417 */   // Label 23920: @1754417
     /* 1754417 */   GIM_Try, /*On fail goto*//*Label 23921*/ GIMT_Encode4(1754503), // Rule ID 11312 //
     /* 1754422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754468 */     // MIs[0] policy
     /* 1754468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754502 */     // GIR_Coverage, 11312,
     /* 1754502 */     GIR_EraseRootFromParent_Done,
     /* 1754503 */   // Label 23921: @1754503
     /* 1754503 */   GIM_Try, /*On fail goto*//*Label 23922*/ GIMT_Encode4(1754589), // Rule ID 11313 //
     /* 1754508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754554 */     // MIs[0] policy
     /* 1754554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1754567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754588 */     // GIR_Coverage, 11313,
     /* 1754588 */     GIR_EraseRootFromParent_Done,
     /* 1754589 */   // Label 23922: @1754589
     /* 1754589 */   GIM_Try, /*On fail goto*//*Label 23923*/ GIMT_Encode4(1754675), // Rule ID 11316 //
     /* 1754594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1754605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1754608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1754611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1754614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754640 */     // MIs[0] policy
     /* 1754640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1754653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754674 */     // GIR_Coverage, 11316,
     /* 1754674 */     GIR_EraseRootFromParent_Done,
     /* 1754675 */   // Label 23923: @1754675
     /* 1754675 */   GIM_Try, /*On fail goto*//*Label 23924*/ GIMT_Encode4(1754761), // Rule ID 11317 //
     /* 1754680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1754691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1754694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1754697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1754700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754726 */     // MIs[0] policy
     /* 1754726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754736 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1754739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754760 */     // GIR_Coverage, 11317,
     /* 1754760 */     GIR_EraseRootFromParent_Done,
     /* 1754761 */   // Label 23924: @1754761
     /* 1754761 */   GIM_Try, /*On fail goto*//*Label 23925*/ GIMT_Encode4(1754847), // Rule ID 11320 //
     /* 1754766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1754777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1754780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1754783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1754786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1754789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754812 */     // MIs[0] policy
     /* 1754812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754822 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1754825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754846 */     // GIR_Coverage, 11320,
     /* 1754846 */     GIR_EraseRootFromParent_Done,
     /* 1754847 */   // Label 23925: @1754847
     /* 1754847 */   GIM_Try, /*On fail goto*//*Label 23926*/ GIMT_Encode4(1754933), // Rule ID 11321 //
     /* 1754852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1754863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1754866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1754869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1754872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1754875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754898 */     // MIs[0] policy
     /* 1754898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754908 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1754911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754932 */     // GIR_Coverage, 11321,
     /* 1754932 */     GIR_EraseRootFromParent_Done,
     /* 1754933 */   // Label 23926: @1754933
     /* 1754933 */   GIM_Try, /*On fail goto*//*Label 23927*/ GIMT_Encode4(1755019), // Rule ID 11324 //
     /* 1754938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1754946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1754949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1754952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1754955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1754958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1754961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1754968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754984 */     // MIs[0] policy
     /* 1754984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754994 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1754997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755018 */     // GIR_Coverage, 11324,
     /* 1755018 */     GIR_EraseRootFromParent_Done,
     /* 1755019 */   // Label 23927: @1755019
     /* 1755019 */   GIM_Try, /*On fail goto*//*Label 23928*/ GIMT_Encode4(1755105), // Rule ID 11325 //
     /* 1755024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1755035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1755038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1755041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1755044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1755047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755070 */     // MIs[0] policy
     /* 1755070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755080 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755104 */     // GIR_Coverage, 11325,
     /* 1755104 */     GIR_EraseRootFromParent_Done,
     /* 1755105 */   // Label 23928: @1755105
     /* 1755105 */   GIM_Try, /*On fail goto*//*Label 23929*/ GIMT_Encode4(1755191), // Rule ID 11328 //
     /* 1755110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1755130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755156 */     // MIs[0] policy
     /* 1755156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755190 */     // GIR_Coverage, 11328,
     /* 1755190 */     GIR_EraseRootFromParent_Done,
     /* 1755191 */   // Label 23929: @1755191
     /* 1755191 */   GIM_Try, /*On fail goto*//*Label 23930*/ GIMT_Encode4(1755277), // Rule ID 11329 //
     /* 1755196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1755207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1755210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1755213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1755216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755242 */     // MIs[0] policy
     /* 1755242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755276 */     // GIR_Coverage, 11329,
     /* 1755276 */     GIR_EraseRootFromParent_Done,
     /* 1755277 */   // Label 23930: @1755277
     /* 1755277 */   GIM_Try, /*On fail goto*//*Label 23931*/ GIMT_Encode4(1755363), // Rule ID 11332 //
     /* 1755282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1755293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1755296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1755299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1755302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755328 */     // MIs[0] policy
     /* 1755328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755338 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755362 */     // GIR_Coverage, 11332,
     /* 1755362 */     GIR_EraseRootFromParent_Done,
     /* 1755363 */   // Label 23931: @1755363
     /* 1755363 */   GIM_Try, /*On fail goto*//*Label 23932*/ GIMT_Encode4(1755449), // Rule ID 11333 //
     /* 1755368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1755379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1755382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1755385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1755388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755414 */     // MIs[0] policy
     /* 1755414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755424 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755448 */     // GIR_Coverage, 11333,
     /* 1755448 */     GIR_EraseRootFromParent_Done,
     /* 1755449 */   // Label 23932: @1755449
     /* 1755449 */   GIM_Try, /*On fail goto*//*Label 23933*/ GIMT_Encode4(1755535), // Rule ID 11336 //
     /* 1755454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1755465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1755468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1755471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1755474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755500 */     // MIs[0] policy
     /* 1755500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755510 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755534 */     // GIR_Coverage, 11336,
     /* 1755534 */     GIR_EraseRootFromParent_Done,
     /* 1755535 */   // Label 23933: @1755535
     /* 1755535 */   GIM_Try, /*On fail goto*//*Label 23934*/ GIMT_Encode4(1755621), // Rule ID 11337 //
     /* 1755540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1755551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1755554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1755557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1755560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755586 */     // MIs[0] policy
     /* 1755586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755596 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1755599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755620 */     // GIR_Coverage, 11337,
     /* 1755620 */     GIR_EraseRootFromParent_Done,
     /* 1755621 */   // Label 23934: @1755621
     /* 1755621 */   GIM_Try, /*On fail goto*//*Label 23935*/ GIMT_Encode4(1755707), // Rule ID 11340 //
     /* 1755626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1755637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1755640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1755643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1755646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755672 */     // MIs[0] policy
     /* 1755672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755706 */     // GIR_Coverage, 11340,
     /* 1755706 */     GIR_EraseRootFromParent_Done,
     /* 1755707 */   // Label 23935: @1755707
     /* 1755707 */   GIM_Try, /*On fail goto*//*Label 23936*/ GIMT_Encode4(1755793), // Rule ID 11341 //
     /* 1755712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1755723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1755726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1755729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1755732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755758 */     // MIs[0] policy
     /* 1755758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1755771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755792 */     // GIR_Coverage, 11341,
     /* 1755792 */     GIR_EraseRootFromParent_Done,
     /* 1755793 */   // Label 23936: @1755793
     /* 1755793 */   GIM_Try, /*On fail goto*//*Label 23937*/ GIMT_Encode4(1755879), // Rule ID 11344 //
     /* 1755798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1755809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1755812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1755815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1755818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755844 */     // MIs[0] policy
     /* 1755844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755878 */     // GIR_Coverage, 11344,
     /* 1755878 */     GIR_EraseRootFromParent_Done,
     /* 1755879 */   // Label 23937: @1755879
     /* 1755879 */   GIM_Try, /*On fail goto*//*Label 23938*/ GIMT_Encode4(1755965), // Rule ID 11345 //
     /* 1755884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1755895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1755898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1755901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1755904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755930 */     // MIs[0] policy
     /* 1755930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755940 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1755943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755964 */     // GIR_Coverage, 11345,
     /* 1755964 */     GIR_EraseRootFromParent_Done,
     /* 1755965 */   // Label 23938: @1755965
     /* 1755965 */   GIM_Try, /*On fail goto*//*Label 23939*/ GIMT_Encode4(1756051), // Rule ID 11348 //
     /* 1755970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1755978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1755981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1755984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1755987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1755990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756016 */     // MIs[0] policy
     /* 1756016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756026 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756050 */     // GIR_Coverage, 11348,
     /* 1756050 */     GIR_EraseRootFromParent_Done,
     /* 1756051 */   // Label 23939: @1756051
     /* 1756051 */   GIM_Try, /*On fail goto*//*Label 23940*/ GIMT_Encode4(1756137), // Rule ID 11349 //
     /* 1756056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1756067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1756070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1756073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1756076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1756079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1756086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1756098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756102 */     // MIs[0] policy
     /* 1756102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1756115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756136 */     // GIR_Coverage, 11349,
     /* 1756136 */     GIR_EraseRootFromParent_Done,
     /* 1756137 */   // Label 23940: @1756137
     /* 1756137 */   GIM_Try, /*On fail goto*//*Label 23941*/ GIMT_Encode4(1756223), // Rule ID 11352 //
     /* 1756142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756188 */     // MIs[0] policy
     /* 1756188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756198 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1756201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756222 */     // GIR_Coverage, 11352,
     /* 1756222 */     GIR_EraseRootFromParent_Done,
     /* 1756223 */   // Label 23941: @1756223
     /* 1756223 */   GIM_Try, /*On fail goto*//*Label 23942*/ GIMT_Encode4(1756309), // Rule ID 11353 //
     /* 1756228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1756239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1756242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1756245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756274 */     // MIs[0] policy
     /* 1756274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756284 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1756287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756308 */     // GIR_Coverage, 11353,
     /* 1756308 */     GIR_EraseRootFromParent_Done,
     /* 1756309 */   // Label 23942: @1756309
     /* 1756309 */   GIM_Try, /*On fail goto*//*Label 23943*/ GIMT_Encode4(1756395), // Rule ID 11356 //
     /* 1756314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1756325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1756328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1756331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756360 */     // MIs[0] policy
     /* 1756360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756370 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756394 */     // GIR_Coverage, 11356,
     /* 1756394 */     GIR_EraseRootFromParent_Done,
     /* 1756395 */   // Label 23943: @1756395
     /* 1756395 */   GIM_Try, /*On fail goto*//*Label 23944*/ GIMT_Encode4(1756481), // Rule ID 11357 //
     /* 1756400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1756411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1756414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1756417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756446 */     // MIs[0] policy
     /* 1756446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756456 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756480 */     // GIR_Coverage, 11357,
     /* 1756480 */     GIR_EraseRootFromParent_Done,
     /* 1756481 */   // Label 23944: @1756481
     /* 1756481 */   GIM_Try, /*On fail goto*//*Label 23945*/ GIMT_Encode4(1756567), // Rule ID 11360 //
     /* 1756486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1756497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1756500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1756503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756532 */     // MIs[0] policy
     /* 1756532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756542 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1756545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756566 */     // GIR_Coverage, 11360,
     /* 1756566 */     GIR_EraseRootFromParent_Done,
     /* 1756567 */   // Label 23945: @1756567
     /* 1756567 */   GIM_Try, /*On fail goto*//*Label 23946*/ GIMT_Encode4(1756653), // Rule ID 11361 //
     /* 1756572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1756583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1756586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1756589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756618 */     // MIs[0] policy
     /* 1756618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756628 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1756631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756652 */     // GIR_Coverage, 11361,
     /* 1756652 */     GIR_EraseRootFromParent_Done,
     /* 1756653 */   // Label 23946: @1756653
     /* 1756653 */   GIM_Try, /*On fail goto*//*Label 23947*/ GIMT_Encode4(1756739), // Rule ID 11364 //
     /* 1756658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1756669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1756672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1756675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756704 */     // MIs[0] policy
     /* 1756704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756714 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756738 */     // GIR_Coverage, 11364,
     /* 1756738 */     GIR_EraseRootFromParent_Done,
     /* 1756739 */   // Label 23947: @1756739
     /* 1756739 */   GIM_Try, /*On fail goto*//*Label 23948*/ GIMT_Encode4(1756825), // Rule ID 11365 //
     /* 1756744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1756755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1756758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1756761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756790 */     // MIs[0] policy
     /* 1756790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756800 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1756803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756824 */     // GIR_Coverage, 11365,
     /* 1756824 */     GIR_EraseRootFromParent_Done,
     /* 1756825 */   // Label 23948: @1756825
     /* 1756825 */   GIM_Try, /*On fail goto*//*Label 23949*/ GIMT_Encode4(1756911), // Rule ID 11368 //
     /* 1756830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1756841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1756844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1756847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756876 */     // MIs[0] policy
     /* 1756876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756886 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1756889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756910 */     // GIR_Coverage, 11368,
     /* 1756910 */     GIR_EraseRootFromParent_Done,
     /* 1756911 */   // Label 23949: @1756911
     /* 1756911 */   GIM_Try, /*On fail goto*//*Label 23950*/ GIMT_Encode4(1756997), // Rule ID 11369 //
     /* 1756916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1756924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1756927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1756930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1756933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756962 */     // MIs[0] policy
     /* 1756962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756972 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1756975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756996 */     // GIR_Coverage, 11369,
     /* 1756996 */     GIR_EraseRootFromParent_Done,
     /* 1756997 */   // Label 23950: @1756997
     /* 1756997 */   GIM_Try, /*On fail goto*//*Label 23951*/ GIMT_Encode4(1757083), // Rule ID 11372 //
     /* 1757002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757048 */     // MIs[0] policy
     /* 1757048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757082 */     // GIR_Coverage, 11372,
     /* 1757082 */     GIR_EraseRootFromParent_Done,
     /* 1757083 */   // Label 23951: @1757083
     /* 1757083 */   GIM_Try, /*On fail goto*//*Label 23952*/ GIMT_Encode4(1757169), // Rule ID 11373 //
     /* 1757088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1757099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1757102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1757105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1757111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757134 */     // MIs[0] policy
     /* 1757134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757144 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1757147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757168 */     // GIR_Coverage, 11373,
     /* 1757168 */     GIR_EraseRootFromParent_Done,
     /* 1757169 */   // Label 23952: @1757169
     /* 1757169 */   GIM_Try, /*On fail goto*//*Label 23953*/ GIMT_Encode4(1757255), // Rule ID 11376 //
     /* 1757174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1757185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1757188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1757191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757220 */     // MIs[0] policy
     /* 1757220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757230 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757254 */     // GIR_Coverage, 11376,
     /* 1757254 */     GIR_EraseRootFromParent_Done,
     /* 1757255 */   // Label 23953: @1757255
     /* 1757255 */   GIM_Try, /*On fail goto*//*Label 23954*/ GIMT_Encode4(1757341), // Rule ID 11377 //
     /* 1757260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1757271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1757274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1757277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757306 */     // MIs[0] policy
     /* 1757306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757316 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757340 */     // GIR_Coverage, 11377,
     /* 1757340 */     GIR_EraseRootFromParent_Done,
     /* 1757341 */   // Label 23954: @1757341
     /* 1757341 */   GIM_Try, /*On fail goto*//*Label 23955*/ GIMT_Encode4(1757427), // Rule ID 11380 //
     /* 1757346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1757357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1757360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1757363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757392 */     // MIs[0] policy
     /* 1757392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757426 */     // GIR_Coverage, 11380,
     /* 1757426 */     GIR_EraseRootFromParent_Done,
     /* 1757427 */   // Label 23955: @1757427
     /* 1757427 */   GIM_Try, /*On fail goto*//*Label 23956*/ GIMT_Encode4(1757513), // Rule ID 11381 //
     /* 1757432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1757443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1757446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1757449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757478 */     // MIs[0] policy
     /* 1757478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757488 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757512 */     // GIR_Coverage, 11381,
     /* 1757512 */     GIR_EraseRootFromParent_Done,
     /* 1757513 */   // Label 23956: @1757513
     /* 1757513 */   GIM_Try, /*On fail goto*//*Label 23957*/ GIMT_Encode4(1757599), // Rule ID 11384 //
     /* 1757518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1757529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1757532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1757535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757564 */     // MIs[0] policy
     /* 1757564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757574 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757598 */     // GIR_Coverage, 11384,
     /* 1757598 */     GIR_EraseRootFromParent_Done,
     /* 1757599 */   // Label 23957: @1757599
     /* 1757599 */   GIM_Try, /*On fail goto*//*Label 23958*/ GIMT_Encode4(1757685), // Rule ID 11385 //
     /* 1757604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1757615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1757618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1757621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757650 */     // MIs[0] policy
     /* 1757650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757660 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1757663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757684 */     // GIR_Coverage, 11385,
     /* 1757684 */     GIR_EraseRootFromParent_Done,
     /* 1757685 */   // Label 23958: @1757685
     /* 1757685 */   GIM_Try, /*On fail goto*//*Label 23959*/ GIMT_Encode4(1757771), // Rule ID 11388 //
     /* 1757690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1757701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1757704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1757707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1757713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757736 */     // MIs[0] policy
     /* 1757736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757746 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1757749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757770 */     // GIR_Coverage, 11388,
     /* 1757770 */     GIR_EraseRootFromParent_Done,
     /* 1757771 */   // Label 23959: @1757771
     /* 1757771 */   GIM_Try, /*On fail goto*//*Label 23960*/ GIMT_Encode4(1757857), // Rule ID 11389 //
     /* 1757776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1757787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1757790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1757793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1757799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757822 */     // MIs[0] policy
     /* 1757822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757832 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1757835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757856 */     // GIR_Coverage, 11389,
     /* 1757856 */     GIR_EraseRootFromParent_Done,
     /* 1757857 */   // Label 23960: @1757857
     /* 1757857 */   GIM_Try, /*On fail goto*//*Label 23961*/ GIMT_Encode4(1757943), // Rule ID 11392 //
     /* 1757862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1757873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1757876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1757879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1757885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1757892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757908 */     // MIs[0] policy
     /* 1757908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757918 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1757921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757942 */     // GIR_Coverage, 11392,
     /* 1757942 */     GIR_EraseRootFromParent_Done,
     /* 1757943 */   // Label 23961: @1757943
     /* 1757943 */   GIM_Try, /*On fail goto*//*Label 23962*/ GIMT_Encode4(1758029), // Rule ID 11393 //
     /* 1757948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1757956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1757959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1757962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1757965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1757971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1757978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757994 */     // MIs[0] policy
     /* 1757994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758004 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758028 */     // GIR_Coverage, 11393,
     /* 1758028 */     GIR_EraseRootFromParent_Done,
     /* 1758029 */   // Label 23962: @1758029
     /* 1758029 */   GIM_Try, /*On fail goto*//*Label 23963*/ GIMT_Encode4(1758115), // Rule ID 11396 //
     /* 1758034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758080 */     // MIs[0] policy
     /* 1758080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758090 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758114 */     // GIR_Coverage, 11396,
     /* 1758114 */     GIR_EraseRootFromParent_Done,
     /* 1758115 */   // Label 23963: @1758115
     /* 1758115 */   GIM_Try, /*On fail goto*//*Label 23964*/ GIMT_Encode4(1758201), // Rule ID 11397 //
     /* 1758120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1758131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1758134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1758137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1758143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758166 */     // MIs[0] policy
     /* 1758166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758176 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1758197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758200 */     // GIR_Coverage, 11397,
     /* 1758200 */     GIR_EraseRootFromParent_Done,
     /* 1758201 */   // Label 23964: @1758201
     /* 1758201 */   GIM_Try, /*On fail goto*//*Label 23965*/ GIMT_Encode4(1758287), // Rule ID 11400 //
     /* 1758206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1758223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758252 */     // MIs[0] policy
     /* 1758252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758262 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758286 */     // GIR_Coverage, 11400,
     /* 1758286 */     GIR_EraseRootFromParent_Done,
     /* 1758287 */   // Label 23965: @1758287
     /* 1758287 */   GIM_Try, /*On fail goto*//*Label 23966*/ GIMT_Encode4(1758373), // Rule ID 11401 //
     /* 1758292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1758303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1758306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1758309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758338 */     // MIs[0] policy
     /* 1758338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758372 */     // GIR_Coverage, 11401,
     /* 1758372 */     GIR_EraseRootFromParent_Done,
     /* 1758373 */   // Label 23966: @1758373
     /* 1758373 */   GIM_Try, /*On fail goto*//*Label 23967*/ GIMT_Encode4(1758459), // Rule ID 11404 //
     /* 1758378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758424 */     // MIs[0] policy
     /* 1758424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758458 */     // GIR_Coverage, 11404,
     /* 1758458 */     GIR_EraseRootFromParent_Done,
     /* 1758459 */   // Label 23967: @1758459
     /* 1758459 */   GIM_Try, /*On fail goto*//*Label 23968*/ GIMT_Encode4(1758545), // Rule ID 11405 //
     /* 1758464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758510 */     // MIs[0] policy
     /* 1758510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758520 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758544 */     // GIR_Coverage, 11405,
     /* 1758544 */     GIR_EraseRootFromParent_Done,
     /* 1758545 */   // Label 23968: @1758545
     /* 1758545 */   GIM_Try, /*On fail goto*//*Label 23969*/ GIMT_Encode4(1758631), // Rule ID 11408 //
     /* 1758550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1758561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1758564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1758567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758596 */     // MIs[0] policy
     /* 1758596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758606 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758630 */     // GIR_Coverage, 11408,
     /* 1758630 */     GIR_EraseRootFromParent_Done,
     /* 1758631 */   // Label 23969: @1758631
     /* 1758631 */   GIM_Try, /*On fail goto*//*Label 23970*/ GIMT_Encode4(1758717), // Rule ID 11409 //
     /* 1758636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1758647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1758650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1758653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758682 */     // MIs[0] policy
     /* 1758682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1758695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758716 */     // GIR_Coverage, 11409,
     /* 1758716 */     GIR_EraseRootFromParent_Done,
     /* 1758717 */   // Label 23970: @1758717
     /* 1758717 */   GIM_Try, /*On fail goto*//*Label 23971*/ GIMT_Encode4(1758803), // Rule ID 11412 //
     /* 1758722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1758733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1758736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1758739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758768 */     // MIs[0] policy
     /* 1758768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758802 */     // GIR_Coverage, 11412,
     /* 1758802 */     GIR_EraseRootFromParent_Done,
     /* 1758803 */   // Label 23971: @1758803
     /* 1758803 */   GIM_Try, /*On fail goto*//*Label 23972*/ GIMT_Encode4(1758889), // Rule ID 11413 //
     /* 1758808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1758819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1758822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1758825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758854 */     // MIs[0] policy
     /* 1758854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1758867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758888 */     // GIR_Coverage, 11413,
     /* 1758888 */     GIR_EraseRootFromParent_Done,
     /* 1758889 */   // Label 23972: @1758889
     /* 1758889 */   GIM_Try, /*On fail goto*//*Label 23973*/ GIMT_Encode4(1758975), // Rule ID 11416 //
     /* 1758894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1758905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1758908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1758911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758940 */     // MIs[0] policy
     /* 1758940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1758953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758974 */     // GIR_Coverage, 11416,
     /* 1758974 */     GIR_EraseRootFromParent_Done,
     /* 1758975 */   // Label 23973: @1758975
     /* 1758975 */   GIM_Try, /*On fail goto*//*Label 23974*/ GIMT_Encode4(1759061), // Rule ID 11417 //
     /* 1758980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1758988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1758991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1758994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1758997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759026 */     // MIs[0] policy
     /* 1759026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1759039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759060 */     // GIR_Coverage, 11417,
     /* 1759060 */     GIR_EraseRootFromParent_Done,
     /* 1759061 */   // Label 23974: @1759061
     /* 1759061 */   GIM_Try, /*On fail goto*//*Label 23975*/ GIMT_Encode4(1759147), // Rule ID 11420 //
     /* 1759066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759112 */     // MIs[0] policy
     /* 1759112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759122 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759146 */     // GIR_Coverage, 11420,
     /* 1759146 */     GIR_EraseRootFromParent_Done,
     /* 1759147 */   // Label 23975: @1759147
     /* 1759147 */   GIM_Try, /*On fail goto*//*Label 23976*/ GIMT_Encode4(1759233), // Rule ID 11421 //
     /* 1759152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1759160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1759163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1759166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1759169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1759175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759198 */     // MIs[0] policy
     /* 1759198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759208 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1759211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1759229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759232 */     // GIR_Coverage, 11421,
     /* 1759232 */     GIR_EraseRootFromParent_Done,
     /* 1759233 */   // Label 23976: @1759233
     /* 1759233 */   GIM_Try, /*On fail goto*//*Label 23977*/ GIMT_Encode4(1759319), // Rule ID 11424 //
     /* 1759238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1759249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1759252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1759255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1759258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759284 */     // MIs[0] policy
     /* 1759284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1759297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759318 */     // GIR_Coverage, 11424,
     /* 1759318 */     GIR_EraseRootFromParent_Done,
     /* 1759319 */   // Label 23977: @1759319
     /* 1759319 */   GIM_Try, /*On fail goto*//*Label 23978*/ GIMT_Encode4(1759405), // Rule ID 11425 //
     /* 1759324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1759335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1759338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1759341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1759344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759370 */     // MIs[0] policy
     /* 1759370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759380 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1759383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759404 */     // GIR_Coverage, 11425,
     /* 1759404 */     GIR_EraseRootFromParent_Done,
     /* 1759405 */   // Label 23978: @1759405
     /* 1759405 */   GIM_Try, /*On fail goto*//*Label 23979*/ GIMT_Encode4(1759491), // Rule ID 11428 //
     /* 1759410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1759421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1759424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1759427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1759430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759456 */     // MIs[0] policy
     /* 1759456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759490 */     // GIR_Coverage, 11428,
     /* 1759490 */     GIR_EraseRootFromParent_Done,
     /* 1759491 */   // Label 23979: @1759491
     /* 1759491 */   GIM_Try, /*On fail goto*//*Label 23980*/ GIMT_Encode4(1759577), // Rule ID 11429 //
     /* 1759496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1759507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1759510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1759513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1759516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759542 */     // MIs[0] policy
     /* 1759542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759576 */     // GIR_Coverage, 11429,
     /* 1759576 */     GIR_EraseRootFromParent_Done,
     /* 1759577 */   // Label 23980: @1759577
     /* 1759577 */   GIM_Try, /*On fail goto*//*Label 23981*/ GIMT_Encode4(1759663), // Rule ID 11432 //
     /* 1759582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1759593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1759596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1759599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1759602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759628 */     // MIs[0] policy
     /* 1759628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759638 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1759641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759662 */     // GIR_Coverage, 11432,
     /* 1759662 */     GIR_EraseRootFromParent_Done,
     /* 1759663 */   // Label 23981: @1759663
     /* 1759663 */   GIM_Try, /*On fail goto*//*Label 23982*/ GIMT_Encode4(1759749), // Rule ID 11433 //
     /* 1759668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1759679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1759682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1759685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1759688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759714 */     // MIs[0] policy
     /* 1759714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759724 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1759727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1759745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759748 */     // GIR_Coverage, 11433,
     /* 1759748 */     GIR_EraseRootFromParent_Done,
     /* 1759749 */   // Label 23982: @1759749
     /* 1759749 */   GIM_Try, /*On fail goto*//*Label 23983*/ GIMT_Encode4(1759835), // Rule ID 11436 //
     /* 1759754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1759765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1759768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1759771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1759774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759800 */     // MIs[0] policy
     /* 1759800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759834 */     // GIR_Coverage, 11436,
     /* 1759834 */     GIR_EraseRootFromParent_Done,
     /* 1759835 */   // Label 23983: @1759835
     /* 1759835 */   GIM_Try, /*On fail goto*//*Label 23984*/ GIMT_Encode4(1759921), // Rule ID 11437 //
     /* 1759840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1759843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1759851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1759854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1759857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1759860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759886 */     // MIs[0] policy
     /* 1759886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1759899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1759917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759920 */     // GIR_Coverage, 11437,
     /* 1759920 */     GIR_EraseRootFromParent_Done,
     /* 1759921 */   // Label 23984: @1759921
     /* 1759921 */   GIM_Try, /*On fail goto*//*Label 23985*/ GIMT_Encode4(1760007), // Rule ID 11440 //
     /* 1759926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1759929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1759934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1759937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1759940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1759943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1759946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759972 */     // MIs[0] policy
     /* 1759972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1759985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760006 */     // GIR_Coverage, 11440,
     /* 1760006 */     GIR_EraseRootFromParent_Done,
     /* 1760007 */   // Label 23985: @1760007
     /* 1760007 */   GIM_Try, /*On fail goto*//*Label 23986*/ GIMT_Encode4(1760093), // Rule ID 11441 //
     /* 1760012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1760023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1760026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1760029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1760032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760058 */     // MIs[0] policy
     /* 1760058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760092 */     // GIR_Coverage, 11441,
     /* 1760092 */     GIR_EraseRootFromParent_Done,
     /* 1760093 */   // Label 23986: @1760093
     /* 1760093 */   GIM_Try, /*On fail goto*//*Label 23987*/ GIMT_Encode4(1760179), // Rule ID 11444 //
     /* 1760098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1760118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760144 */     // MIs[0] policy
     /* 1760144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760154 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760178 */     // GIR_Coverage, 11444,
     /* 1760178 */     GIR_EraseRootFromParent_Done,
     /* 1760179 */   // Label 23987: @1760179
     /* 1760179 */   GIM_Try, /*On fail goto*//*Label 23988*/ GIMT_Encode4(1760265), // Rule ID 11445 //
     /* 1760184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1760195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1760198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1760201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1760204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760230 */     // MIs[0] policy
     /* 1760230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1760243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760264 */     // GIR_Coverage, 11445,
     /* 1760264 */     GIR_EraseRootFromParent_Done,
     /* 1760265 */   // Label 23988: @1760265
     /* 1760265 */   GIM_Try, /*On fail goto*//*Label 23989*/ GIMT_Encode4(1760351), // Rule ID 11448 //
     /* 1760270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1760281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1760284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1760287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1760290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760316 */     // MIs[0] policy
     /* 1760316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760350 */     // GIR_Coverage, 11448,
     /* 1760350 */     GIR_EraseRootFromParent_Done,
     /* 1760351 */   // Label 23989: @1760351
     /* 1760351 */   GIM_Try, /*On fail goto*//*Label 23990*/ GIMT_Encode4(1760437), // Rule ID 11449 //
     /* 1760356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1760367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1760370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1760373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1760376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760402 */     // MIs[0] policy
     /* 1760402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760436 */     // GIR_Coverage, 11449,
     /* 1760436 */     GIR_EraseRootFromParent_Done,
     /* 1760437 */   // Label 23990: @1760437
     /* 1760437 */   GIM_Try, /*On fail goto*//*Label 23991*/ GIMT_Encode4(1760523), // Rule ID 11452 //
     /* 1760442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1760453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1760456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1760459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1760462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760488 */     // MIs[0] policy
     /* 1760488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760522 */     // GIR_Coverage, 11452,
     /* 1760522 */     GIR_EraseRootFromParent_Done,
     /* 1760523 */   // Label 23991: @1760523
     /* 1760523 */   GIM_Try, /*On fail goto*//*Label 23992*/ GIMT_Encode4(1760609), // Rule ID 11453 //
     /* 1760528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1760539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1760542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1760545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1760548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760574 */     // MIs[0] policy
     /* 1760574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1760605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760608 */     // GIR_Coverage, 11453,
     /* 1760608 */     GIR_EraseRootFromParent_Done,
     /* 1760609 */   // Label 23992: @1760609
     /* 1760609 */   GIM_Try, /*On fail goto*//*Label 23993*/ GIMT_Encode4(1760695), // Rule ID 11456 //
     /* 1760614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1760625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1760628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1760631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1760634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760660 */     // MIs[0] policy
     /* 1760660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760694 */     // GIR_Coverage, 11456,
     /* 1760694 */     GIR_EraseRootFromParent_Done,
     /* 1760695 */   // Label 23993: @1760695
     /* 1760695 */   GIM_Try, /*On fail goto*//*Label 23994*/ GIMT_Encode4(1760781), // Rule ID 11457 //
     /* 1760700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1760711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1760714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1760717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1760720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760746 */     // MIs[0] policy
     /* 1760746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1760759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1760777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760780 */     // GIR_Coverage, 11457,
     /* 1760780 */     GIR_EraseRootFromParent_Done,
     /* 1760781 */   // Label 23994: @1760781
     /* 1760781 */   GIM_Try, /*On fail goto*//*Label 23995*/ GIMT_Encode4(1760867), // Rule ID 11460 //
     /* 1760786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1760797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1760800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1760803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1760806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1760809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1760816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760832 */     // MIs[0] policy
     /* 1760832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760842 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1760845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760866 */     // GIR_Coverage, 11460,
     /* 1760866 */     GIR_EraseRootFromParent_Done,
     /* 1760867 */   // Label 23995: @1760867
     /* 1760867 */   GIM_Try, /*On fail goto*//*Label 23996*/ GIMT_Encode4(1760953), // Rule ID 11461 //
     /* 1760872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1760875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1760883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1760886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1760889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1760892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1760895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1760902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760918 */     // MIs[0] policy
     /* 1760918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760928 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1760931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1760949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760952 */     // GIR_Coverage, 11461,
     /* 1760952 */     GIR_EraseRootFromParent_Done,
     /* 1760953 */   // Label 23996: @1760953
     /* 1760953 */   GIM_Try, /*On fail goto*//*Label 23997*/ GIMT_Encode4(1761039), // Rule ID 11464 //
     /* 1760958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1760961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1760966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1760969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1760972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1760975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1760978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1760981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1760988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761004 */     // MIs[0] policy
     /* 1761004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761014 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761038 */     // GIR_Coverage, 11464,
     /* 1761038 */     GIR_EraseRootFromParent_Done,
     /* 1761039 */   // Label 23997: @1761039
     /* 1761039 */   GIM_Try, /*On fail goto*//*Label 23998*/ GIMT_Encode4(1761125), // Rule ID 11465 //
     /* 1761044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1761055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1761058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1761061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1761064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761090 */     // MIs[0] policy
     /* 1761090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761100 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761124 */     // GIR_Coverage, 11465,
     /* 1761124 */     GIR_EraseRootFromParent_Done,
     /* 1761125 */   // Label 23998: @1761125
     /* 1761125 */   GIM_Try, /*On fail goto*//*Label 23999*/ GIMT_Encode4(1761211), // Rule ID 11468 //
     /* 1761130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1761150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761176 */     // MIs[0] policy
     /* 1761176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761186 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761210 */     // GIR_Coverage, 11468,
     /* 1761210 */     GIR_EraseRootFromParent_Done,
     /* 1761211 */   // Label 23999: @1761211
     /* 1761211 */   GIM_Try, /*On fail goto*//*Label 24000*/ GIMT_Encode4(1761297), // Rule ID 11469 //
     /* 1761216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1761227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1761230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1761233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1761236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1761239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761262 */     // MIs[0] policy
     /* 1761262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761272 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1761293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761296 */     // GIR_Coverage, 11469,
     /* 1761296 */     GIR_EraseRootFromParent_Done,
     /* 1761297 */   // Label 24000: @1761297
     /* 1761297 */   GIM_Try, /*On fail goto*//*Label 24001*/ GIMT_Encode4(1761383), // Rule ID 11472 //
     /* 1761302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1761313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1761316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1761319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1761322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761348 */     // MIs[0] policy
     /* 1761348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761358 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761382 */     // GIR_Coverage, 11472,
     /* 1761382 */     GIR_EraseRootFromParent_Done,
     /* 1761383 */   // Label 24001: @1761383
     /* 1761383 */   GIM_Try, /*On fail goto*//*Label 24002*/ GIMT_Encode4(1761469), // Rule ID 11473 //
     /* 1761388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1761399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1761402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1761405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1761408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761434 */     // MIs[0] policy
     /* 1761434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761468 */     // GIR_Coverage, 11473,
     /* 1761468 */     GIR_EraseRootFromParent_Done,
     /* 1761469 */   // Label 24002: @1761469
     /* 1761469 */   GIM_Try, /*On fail goto*//*Label 24003*/ GIMT_Encode4(1761555), // Rule ID 11476 //
     /* 1761474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1761485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1761488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1761491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1761494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761520 */     // MIs[0] policy
     /* 1761520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761530 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761554 */     // GIR_Coverage, 11476,
     /* 1761554 */     GIR_EraseRootFromParent_Done,
     /* 1761555 */   // Label 24003: @1761555
     /* 1761555 */   GIM_Try, /*On fail goto*//*Label 24004*/ GIMT_Encode4(1761641), // Rule ID 11477 //
     /* 1761560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1761571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1761574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1761577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1761580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1761583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761606 */     // MIs[0] policy
     /* 1761606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761640 */     // GIR_Coverage, 11477,
     /* 1761640 */     GIR_EraseRootFromParent_Done,
     /* 1761641 */   // Label 24004: @1761641
     /* 1761641 */   GIM_Try, /*On fail goto*//*Label 24005*/ GIMT_Encode4(1761727), // Rule ID 11480 //
     /* 1761646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1761657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1761660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1761663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1761666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761692 */     // MIs[0] policy
     /* 1761692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761702 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761726 */     // GIR_Coverage, 11480,
     /* 1761726 */     GIR_EraseRootFromParent_Done,
     /* 1761727 */   // Label 24005: @1761727
     /* 1761727 */   GIM_Try, /*On fail goto*//*Label 24006*/ GIMT_Encode4(1761813), // Rule ID 11481 //
     /* 1761732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1761743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1761746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1761749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1761752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1761755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761778 */     // MIs[0] policy
     /* 1761778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1761791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1761809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761812 */     // GIR_Coverage, 11481,
     /* 1761812 */     GIR_EraseRootFromParent_Done,
     /* 1761813 */   // Label 24006: @1761813
     /* 1761813 */   GIM_Try, /*On fail goto*//*Label 24007*/ GIMT_Encode4(1761899), // Rule ID 11484 //
     /* 1761818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1761829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1761832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1761835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1761838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761864 */     // MIs[0] policy
     /* 1761864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761898 */     // GIR_Coverage, 11484,
     /* 1761898 */     GIR_EraseRootFromParent_Done,
     /* 1761899 */   // Label 24007: @1761899
     /* 1761899 */   GIM_Try, /*On fail goto*//*Label 24008*/ GIMT_Encode4(1761985), // Rule ID 11485 //
     /* 1761904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1761907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1761915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1761918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1761921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1761924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761950 */     // MIs[0] policy
     /* 1761950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1761981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761984 */     // GIR_Coverage, 11485,
     /* 1761984 */     GIR_EraseRootFromParent_Done,
     /* 1761985 */   // Label 24008: @1761985
     /* 1761985 */   GIM_Try, /*On fail goto*//*Label 24009*/ GIMT_Encode4(1762071), // Rule ID 11488 //
     /* 1761990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1761993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762036 */     // MIs[0] policy
     /* 1762036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762070 */     // GIR_Coverage, 11488,
     /* 1762070 */     GIR_EraseRootFromParent_Done,
     /* 1762071 */   // Label 24009: @1762071
     /* 1762071 */   GIM_Try, /*On fail goto*//*Label 24010*/ GIMT_Encode4(1762157), // Rule ID 11489 //
     /* 1762076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1762087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1762090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1762093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1762096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762122 */     // MIs[0] policy
     /* 1762122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762132 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762156 */     // GIR_Coverage, 11489,
     /* 1762156 */     GIR_EraseRootFromParent_Done,
     /* 1762157 */   // Label 24010: @1762157
     /* 1762157 */   GIM_Try, /*On fail goto*//*Label 24011*/ GIMT_Encode4(1762243), // Rule ID 11492 //
     /* 1762162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1762179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1762182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762208 */     // MIs[0] policy
     /* 1762208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762218 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762242 */     // GIR_Coverage, 11492,
     /* 1762242 */     GIR_EraseRootFromParent_Done,
     /* 1762243 */   // Label 24011: @1762243
     /* 1762243 */   GIM_Try, /*On fail goto*//*Label 24012*/ GIMT_Encode4(1762329), // Rule ID 11493 //
     /* 1762248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1762259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1762262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1762265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1762268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1762271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762294 */     // MIs[0] policy
     /* 1762294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1762325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762328 */     // GIR_Coverage, 11493,
     /* 1762328 */     GIR_EraseRootFromParent_Done,
     /* 1762329 */   // Label 24012: @1762329
     /* 1762329 */   GIM_Try, /*On fail goto*//*Label 24013*/ GIMT_Encode4(1762415), // Rule ID 11496 //
     /* 1762334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1762345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1762348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1762351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762380 */     // MIs[0] policy
     /* 1762380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762390 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1762393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762414 */     // GIR_Coverage, 11496,
     /* 1762414 */     GIR_EraseRootFromParent_Done,
     /* 1762415 */   // Label 24013: @1762415
     /* 1762415 */   GIM_Try, /*On fail goto*//*Label 24014*/ GIMT_Encode4(1762501), // Rule ID 11497 //
     /* 1762420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1762431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1762434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1762437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762466 */     // MIs[0] policy
     /* 1762466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762476 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1762479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762500 */     // GIR_Coverage, 11497,
     /* 1762500 */     GIR_EraseRootFromParent_Done,
     /* 1762501 */   // Label 24014: @1762501
     /* 1762501 */   GIM_Try, /*On fail goto*//*Label 24015*/ GIMT_Encode4(1762587), // Rule ID 11500 //
     /* 1762506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1762517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1762520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1762523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1762529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762552 */     // MIs[0] policy
     /* 1762552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762562 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1762565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762586 */     // GIR_Coverage, 11500,
     /* 1762586 */     GIR_EraseRootFromParent_Done,
     /* 1762587 */   // Label 24015: @1762587
     /* 1762587 */   GIM_Try, /*On fail goto*//*Label 24016*/ GIMT_Encode4(1762673), // Rule ID 11501 //
     /* 1762592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1762603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1762606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1762609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1762615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762638 */     // MIs[0] policy
     /* 1762638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762648 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1762651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762672 */     // GIR_Coverage, 11501,
     /* 1762672 */     GIR_EraseRootFromParent_Done,
     /* 1762673 */   // Label 24016: @1762673
     /* 1762673 */   GIM_Try, /*On fail goto*//*Label 24017*/ GIMT_Encode4(1762759), // Rule ID 11504 //
     /* 1762678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1762689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1762692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1762695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762724 */     // MIs[0] policy
     /* 1762724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1762737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762758 */     // GIR_Coverage, 11504,
     /* 1762758 */     GIR_EraseRootFromParent_Done,
     /* 1762759 */   // Label 24017: @1762759
     /* 1762759 */   GIM_Try, /*On fail goto*//*Label 24018*/ GIMT_Encode4(1762845), // Rule ID 11505 //
     /* 1762764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1762775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1762778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1762781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762810 */     // MIs[0] policy
     /* 1762810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762820 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1762823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1762841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762844 */     // GIR_Coverage, 11505,
     /* 1762844 */     GIR_EraseRootFromParent_Done,
     /* 1762845 */   // Label 24018: @1762845
     /* 1762845 */   GIM_Try, /*On fail goto*//*Label 24019*/ GIMT_Encode4(1762931), // Rule ID 11508 //
     /* 1762850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1762861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1762864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1762867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762896 */     // MIs[0] policy
     /* 1762896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762906 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1762909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1762927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762930 */     // GIR_Coverage, 11508,
     /* 1762930 */     GIR_EraseRootFromParent_Done,
     /* 1762931 */   // Label 24019: @1762931
     /* 1762931 */   GIM_Try, /*On fail goto*//*Label 24020*/ GIMT_Encode4(1763017), // Rule ID 11509 //
     /* 1762936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1762939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1762947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1762950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1762953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762982 */     // MIs[0] policy
     /* 1762982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762992 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1762995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763016 */     // GIR_Coverage, 11509,
     /* 1763016 */     GIR_EraseRootFromParent_Done,
     /* 1763017 */   // Label 24020: @1763017
     /* 1763017 */   GIM_Try, /*On fail goto*//*Label 24021*/ GIMT_Encode4(1763103), // Rule ID 11512 //
     /* 1763022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763068 */     // MIs[0] policy
     /* 1763068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763078 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763102 */     // GIR_Coverage, 11512,
     /* 1763102 */     GIR_EraseRootFromParent_Done,
     /* 1763103 */   // Label 24021: @1763103
     /* 1763103 */   GIM_Try, /*On fail goto*//*Label 24022*/ GIMT_Encode4(1763189), // Rule ID 11513 //
     /* 1763108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763154 */     // MIs[0] policy
     /* 1763154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763164 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763188 */     // GIR_Coverage, 11513,
     /* 1763188 */     GIR_EraseRootFromParent_Done,
     /* 1763189 */   // Label 24022: @1763189
     /* 1763189 */   GIM_Try, /*On fail goto*//*Label 24023*/ GIMT_Encode4(1763275), // Rule ID 11516 //
     /* 1763194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763240 */     // MIs[0] policy
     /* 1763240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763250 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763274 */     // GIR_Coverage, 11516,
     /* 1763274 */     GIR_EraseRootFromParent_Done,
     /* 1763275 */   // Label 24023: @1763275
     /* 1763275 */   GIM_Try, /*On fail goto*//*Label 24024*/ GIMT_Encode4(1763361), // Rule ID 11517 //
     /* 1763280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763326 */     // MIs[0] policy
     /* 1763326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763336 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1763339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763360 */     // GIR_Coverage, 11517,
     /* 1763360 */     GIR_EraseRootFromParent_Done,
     /* 1763361 */   // Label 24024: @1763361
     /* 1763361 */   GIM_Try, /*On fail goto*//*Label 24025*/ GIMT_Encode4(1763447), // Rule ID 11520 //
     /* 1763366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1763377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1763380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1763383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763412 */     // MIs[0] policy
     /* 1763412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763422 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763446 */     // GIR_Coverage, 11520,
     /* 1763446 */     GIR_EraseRootFromParent_Done,
     /* 1763447 */   // Label 24025: @1763447
     /* 1763447 */   GIM_Try, /*On fail goto*//*Label 24026*/ GIMT_Encode4(1763533), // Rule ID 11521 //
     /* 1763452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1763463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1763466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1763469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1763475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763498 */     // MIs[0] policy
     /* 1763498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763508 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11474:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763532 */     // GIR_Coverage, 11521,
     /* 1763532 */     GIR_EraseRootFromParent_Done,
     /* 1763533 */   // Label 24026: @1763533
     /* 1763533 */   GIM_Try, /*On fail goto*//*Label 24027*/ GIMT_Encode4(1763619), // Rule ID 11524 //
     /* 1763538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1763549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1763552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1763555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763584 */     // MIs[0] policy
     /* 1763584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763618 */     // GIR_Coverage, 11524,
     /* 1763618 */     GIR_EraseRootFromParent_Done,
     /* 1763619 */   // Label 24027: @1763619
     /* 1763619 */   GIM_Try, /*On fail goto*//*Label 24028*/ GIMT_Encode4(1763705), // Rule ID 11525 //
     /* 1763624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1763635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1763638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1763641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763670 */     // MIs[0] policy
     /* 1763670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763680 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11474:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763704 */     // GIR_Coverage, 11525,
     /* 1763704 */     GIR_EraseRootFromParent_Done,
     /* 1763705 */   // Label 24028: @1763705
     /* 1763705 */   GIM_Try, /*On fail goto*//*Label 24029*/ GIMT_Encode4(1763791), // Rule ID 11528 //
     /* 1763710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1763721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1763724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1763727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763756 */     // MIs[0] policy
     /* 1763756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763766 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763790 */     // GIR_Coverage, 11528,
     /* 1763790 */     GIR_EraseRootFromParent_Done,
     /* 1763791 */   // Label 24029: @1763791
     /* 1763791 */   GIM_Try, /*On fail goto*//*Label 24030*/ GIMT_Encode4(1763877), // Rule ID 11529 //
     /* 1763796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1763807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1763810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1763813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763842 */     // MIs[0] policy
     /* 1763842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1763855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763876 */     // GIR_Coverage, 11529,
     /* 1763876 */     GIR_EraseRootFromParent_Done,
     /* 1763877 */   // Label 24030: @1763877
     /* 1763877 */   GIM_Try, /*On fail goto*//*Label 24031*/ GIMT_Encode4(1763963), // Rule ID 11532 //
     /* 1763882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1763893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1763896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1763899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1763902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1763905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1763912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1763920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1763924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763928 */     // MIs[0] policy
     /* 1763928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763938 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1763941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763962 */     // GIR_Coverage, 11532,
     /* 1763962 */     GIR_EraseRootFromParent_Done,
     /* 1763963 */   // Label 24031: @1763963
     /* 1763963 */   GIM_Try, /*On fail goto*//*Label 24032*/ GIMT_Encode4(1764049), // Rule ID 11533 //
     /* 1763968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1763976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1763979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1763982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1763985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1763988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1763991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1763998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764014 */     // MIs[0] policy
     /* 1764014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764024 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764048 */     // GIR_Coverage, 11533,
     /* 1764048 */     GIR_EraseRootFromParent_Done,
     /* 1764049 */   // Label 24032: @1764049
     /* 1764049 */   GIM_Try, /*On fail goto*//*Label 24033*/ GIMT_Encode4(1764135), // Rule ID 11536 //
     /* 1764054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764100 */     // MIs[0] policy
     /* 1764100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764110 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764134 */     // GIR_Coverage, 11536,
     /* 1764134 */     GIR_EraseRootFromParent_Done,
     /* 1764135 */   // Label 24033: @1764135
     /* 1764135 */   GIM_Try, /*On fail goto*//*Label 24034*/ GIMT_Encode4(1764221), // Rule ID 11537 //
     /* 1764140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764186 */     // MIs[0] policy
     /* 1764186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764196 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764220 */     // GIR_Coverage, 11537,
     /* 1764220 */     GIR_EraseRootFromParent_Done,
     /* 1764221 */   // Label 24034: @1764221
     /* 1764221 */   GIM_Try, /*On fail goto*//*Label 24035*/ GIMT_Encode4(1764307), // Rule ID 11540 //
     /* 1764226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1764237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1764240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1764243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1764249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764272 */     // MIs[0] policy
     /* 1764272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764282 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764306 */     // GIR_Coverage, 11540,
     /* 1764306 */     GIR_EraseRootFromParent_Done,
     /* 1764307 */   // Label 24035: @1764307
     /* 1764307 */   GIM_Try, /*On fail goto*//*Label 24036*/ GIMT_Encode4(1764393), // Rule ID 11541 //
     /* 1764312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1764323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1764326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1764329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1764335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764358 */     // MIs[0] policy
     /* 1764358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764368 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764392 */     // GIR_Coverage, 11541,
     /* 1764392 */     GIR_EraseRootFromParent_Done,
     /* 1764393 */   // Label 24036: @1764393
     /* 1764393 */   GIM_Try, /*On fail goto*//*Label 24037*/ GIMT_Encode4(1764479), // Rule ID 11544 //
     /* 1764398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1764409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1764412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1764415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764444 */     // MIs[0] policy
     /* 1764444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764454 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764478 */     // GIR_Coverage, 11544,
     /* 1764478 */     GIR_EraseRootFromParent_Done,
     /* 1764479 */   // Label 24037: @1764479
     /* 1764479 */   GIM_Try, /*On fail goto*//*Label 24038*/ GIMT_Encode4(1764565), // Rule ID 11545 //
     /* 1764484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1764495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1764498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1764501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764530 */     // MIs[0] policy
     /* 1764530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764564 */     // GIR_Coverage, 11545,
     /* 1764564 */     GIR_EraseRootFromParent_Done,
     /* 1764565 */   // Label 24038: @1764565
     /* 1764565 */   GIM_Try, /*On fail goto*//*Label 24039*/ GIMT_Encode4(1764651), // Rule ID 11548 //
     /* 1764570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1764581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1764584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1764587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764616 */     // MIs[0] policy
     /* 1764616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764626 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764650 */     // GIR_Coverage, 11548,
     /* 1764650 */     GIR_EraseRootFromParent_Done,
     /* 1764651 */   // Label 24039: @1764651
     /* 1764651 */   GIM_Try, /*On fail goto*//*Label 24040*/ GIMT_Encode4(1764737), // Rule ID 11549 //
     /* 1764656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1764667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1764670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1764673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764702 */     // MIs[0] policy
     /* 1764702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764712 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1764715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764736 */     // GIR_Coverage, 11549,
     /* 1764736 */     GIR_EraseRootFromParent_Done,
     /* 1764737 */   // Label 24040: @1764737
     /* 1764737 */   GIM_Try, /*On fail goto*//*Label 24041*/ GIMT_Encode4(1764823), // Rule ID 11552 //
     /* 1764742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1764753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1764756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1764759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764788 */     // MIs[0] policy
     /* 1764788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764798 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764822 */     // GIR_Coverage, 11552,
     /* 1764822 */     GIR_EraseRootFromParent_Done,
     /* 1764823 */   // Label 24041: @1764823
     /* 1764823 */   GIM_Try, /*On fail goto*//*Label 24042*/ GIMT_Encode4(1764909), // Rule ID 11553 //
     /* 1764828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1764839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1764842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1764845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1764848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1764858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1764866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764874 */     // MIs[0] policy
     /* 1764874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1764887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764908 */     // GIR_Coverage, 11553,
     /* 1764908 */     GIR_EraseRootFromParent_Done,
     /* 1764909 */   // Label 24042: @1764909
     /* 1764909 */   GIM_Try, /*On fail goto*//*Label 24043*/ GIMT_Encode4(1764995), // Rule ID 11556 //
     /* 1764914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1764922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1764925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1764928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1764931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1764934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1764956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764960 */     // MIs[0] policy
     /* 1764960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764970 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1764973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764994 */     // GIR_Coverage, 11556,
     /* 1764994 */     GIR_EraseRootFromParent_Done,
     /* 1764995 */   // Label 24043: @1764995
     /* 1764995 */   GIM_Try, /*On fail goto*//*Label 24044*/ GIMT_Encode4(1765081), // Rule ID 11557 //
     /* 1765000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765046 */     // MIs[0] policy
     /* 1765046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1765059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765080 */     // GIR_Coverage, 11557,
     /* 1765080 */     GIR_EraseRootFromParent_Done,
     /* 1765081 */   // Label 24044: @1765081
     /* 1765081 */   GIM_Try, /*On fail goto*//*Label 24045*/ GIMT_Encode4(1765167), // Rule ID 11560 //
     /* 1765086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765132 */     // MIs[0] policy
     /* 1765132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765142 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765166 */     // GIR_Coverage, 11560,
     /* 1765166 */     GIR_EraseRootFromParent_Done,
     /* 1765167 */   // Label 24045: @1765167
     /* 1765167 */   GIM_Try, /*On fail goto*//*Label 24046*/ GIMT_Encode4(1765253), // Rule ID 11561 //
     /* 1765172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765218 */     // MIs[0] policy
     /* 1765218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765228 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1765231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765252 */     // GIR_Coverage, 11561,
     /* 1765252 */     GIR_EraseRootFromParent_Done,
     /* 1765253 */   // Label 24046: @1765253
     /* 1765253 */   GIM_Try, /*On fail goto*//*Label 24047*/ GIMT_Encode4(1765339), // Rule ID 11564 //
     /* 1765258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1765269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1765272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1765275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1765278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765304 */     // MIs[0] policy
     /* 1765304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765314 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765338 */     // GIR_Coverage, 11564,
     /* 1765338 */     GIR_EraseRootFromParent_Done,
     /* 1765339 */   // Label 24047: @1765339
     /* 1765339 */   GIM_Try, /*On fail goto*//*Label 24048*/ GIMT_Encode4(1765425), // Rule ID 11565 //
     /* 1765344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1765352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1765355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1765358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1765361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1765364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1765386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765390 */     // MIs[0] policy
     /* 1765390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1765403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765424 */     // GIR_Coverage, 11565,
     /* 1765424 */     GIR_EraseRootFromParent_Done,
     /* 1765425 */   // Label 24048: @1765425
     /* 1765425 */   GIM_Try, /*On fail goto*//*Label 24049*/ GIMT_Encode4(1765511), // Rule ID 11568 //
     /* 1765430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1765450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1765453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1765460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765476 */     // MIs[0] policy
     /* 1765476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1765489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765510 */     // GIR_Coverage, 11568,
     /* 1765510 */     GIR_EraseRootFromParent_Done,
     /* 1765511 */   // Label 24049: @1765511
     /* 1765511 */   GIM_Try, /*On fail goto*//*Label 24050*/ GIMT_Encode4(1765597), // Rule ID 11569 //
     /* 1765516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1765527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1765530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1765533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1765536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1765539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1765546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1765558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765562 */     // MIs[0] policy
     /* 1765562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765572 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1765575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765596 */     // GIR_Coverage, 11569,
     /* 1765596 */     GIR_EraseRootFromParent_Done,
     /* 1765597 */   // Label 24050: @1765597
     /* 1765597 */   GIM_Try, /*On fail goto*//*Label 24051*/ GIMT_Encode4(1765683), // Rule ID 11572 //
     /* 1765602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1765613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1765616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1765619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1765622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1765625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765648 */     // MIs[0] policy
     /* 1765648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765658 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1765661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765682 */     // GIR_Coverage, 11572,
     /* 1765682 */     GIR_EraseRootFromParent_Done,
     /* 1765683 */   // Label 24051: @1765683
     /* 1765683 */   GIM_Try, /*On fail goto*//*Label 24052*/ GIMT_Encode4(1765769), // Rule ID 11573 //
     /* 1765688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1765699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1765702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1765705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1765708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1765711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765734 */     // MIs[0] policy
     /* 1765734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1765747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765768 */     // GIR_Coverage, 11573,
     /* 1765768 */     GIR_EraseRootFromParent_Done,
     /* 1765769 */   // Label 24052: @1765769
     /* 1765769 */   GIM_Try, /*On fail goto*//*Label 24053*/ GIMT_Encode4(1765855), // Rule ID 11576 //
     /* 1765774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1765785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1765788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1765791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1765794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765820 */     // MIs[0] policy
     /* 1765820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765830 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1765833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765854 */     // GIR_Coverage, 11576,
     /* 1765854 */     GIR_EraseRootFromParent_Done,
     /* 1765855 */   // Label 24053: @1765855
     /* 1765855 */   GIM_Try, /*On fail goto*//*Label 24054*/ GIMT_Encode4(1765941), // Rule ID 11577 //
     /* 1765860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1765863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1765871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1765874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1765877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1765880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765906 */     // MIs[0] policy
     /* 1765906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765916 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1765919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1765937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765940 */     // GIR_Coverage, 11577,
     /* 1765940 */     GIR_EraseRootFromParent_Done,
     /* 1765941 */   // Label 24054: @1765941
     /* 1765941 */   GIM_Try, /*On fail goto*//*Label 24055*/ GIMT_Encode4(1766027), // Rule ID 11580 //
     /* 1765946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1765949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1765954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1765957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1765960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1765963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1765966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765992 */     // MIs[0] policy
     /* 1765992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766002 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1766005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766026 */     // GIR_Coverage, 11580,
     /* 1766026 */     GIR_EraseRootFromParent_Done,
     /* 1766027 */   // Label 24055: @1766027
     /* 1766027 */   GIM_Try, /*On fail goto*//*Label 24056*/ GIMT_Encode4(1766113), // Rule ID 11581 //
     /* 1766032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766078 */     // MIs[0] policy
     /* 1766078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766088 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1766091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766112 */     // GIR_Coverage, 11581,
     /* 1766112 */     GIR_EraseRootFromParent_Done,
     /* 1766113 */   // Label 24056: @1766113
     /* 1766113 */   GIM_Try, /*On fail goto*//*Label 24057*/ GIMT_Encode4(1766199), // Rule ID 11584 //
     /* 1766118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766164 */     // MIs[0] policy
     /* 1766164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1766177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766198 */     // GIR_Coverage, 11584,
     /* 1766198 */     GIR_EraseRootFromParent_Done,
     /* 1766199 */   // Label 24057: @1766199
     /* 1766199 */   GIM_Try, /*On fail goto*//*Label 24058*/ GIMT_Encode4(1766285), // Rule ID 11585 //
     /* 1766204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766250 */     // MIs[0] policy
     /* 1766250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766260 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1766263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766284 */     // GIR_Coverage, 11585,
     /* 1766284 */     GIR_EraseRootFromParent_Done,
     /* 1766285 */   // Label 24058: @1766285
     /* 1766285 */   GIM_Try, /*On fail goto*//*Label 24059*/ GIMT_Encode4(1766371), // Rule ID 11588 //
     /* 1766290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766336 */     // MIs[0] policy
     /* 1766336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1766349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766370 */     // GIR_Coverage, 11588,
     /* 1766370 */     GIR_EraseRootFromParent_Done,
     /* 1766371 */   // Label 24059: @1766371
     /* 1766371 */   GIM_Try, /*On fail goto*//*Label 24060*/ GIMT_Encode4(1766457), // Rule ID 11589 //
     /* 1766376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766422 */     // MIs[0] policy
     /* 1766422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1766435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766456 */     // GIR_Coverage, 11589,
     /* 1766456 */     GIR_EraseRootFromParent_Done,
     /* 1766457 */   // Label 24060: @1766457
     /* 1766457 */   GIM_Try, /*On fail goto*//*Label 24061*/ GIMT_Encode4(1766543), // Rule ID 11592 //
     /* 1766462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766508 */     // MIs[0] policy
     /* 1766508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1766521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766542 */     // GIR_Coverage, 11592,
     /* 1766542 */     GIR_EraseRootFromParent_Done,
     /* 1766543 */   // Label 24061: @1766543
     /* 1766543 */   GIM_Try, /*On fail goto*//*Label 24062*/ GIMT_Encode4(1766629), // Rule ID 11593 //
     /* 1766548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766594 */     // MIs[0] policy
     /* 1766594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1766607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766628 */     // GIR_Coverage, 11593,
     /* 1766628 */     GIR_EraseRootFromParent_Done,
     /* 1766629 */   // Label 24062: @1766629
     /* 1766629 */   GIM_Try, /*On fail goto*//*Label 24063*/ GIMT_Encode4(1766715), // Rule ID 11596 //
     /* 1766634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766680 */     // MIs[0] policy
     /* 1766680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1766693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766714 */     // GIR_Coverage, 11596,
     /* 1766714 */     GIR_EraseRootFromParent_Done,
     /* 1766715 */   // Label 24063: @1766715
     /* 1766715 */   GIM_Try, /*On fail goto*//*Label 24064*/ GIMT_Encode4(1766801), // Rule ID 11597 //
     /* 1766720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1766728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766766 */     // MIs[0] policy
     /* 1766766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1766779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766800 */     // GIR_Coverage, 11597,
     /* 1766800 */     GIR_EraseRootFromParent_Done,
     /* 1766801 */   // Label 24064: @1766801
     /* 1766801 */   GIM_Try, /*On fail goto*//*Label 24065*/ GIMT_Encode4(1766887), // Rule ID 11600 //
     /* 1766806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1766814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1766826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766852 */     // MIs[0] policy
     /* 1766852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766862 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1766865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766886 */     // GIR_Coverage, 11600,
     /* 1766886 */     GIR_EraseRootFromParent_Done,
     /* 1766887 */   // Label 24065: @1766887
     /* 1766887 */   GIM_Try, /*On fail goto*//*Label 24066*/ GIMT_Encode4(1766973), // Rule ID 11601 //
     /* 1766892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1766895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1766900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1766903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1766906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1766909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1766912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766938 */     // MIs[0] policy
     /* 1766938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766948 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1766951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766972 */     // GIR_Coverage, 11601,
     /* 1766972 */     GIR_EraseRootFromParent_Done,
     /* 1766973 */   // Label 24066: @1766973
     /* 1766973 */   GIM_Try, /*On fail goto*//*Label 24067*/ GIMT_Encode4(1767059), // Rule ID 11604 //
     /* 1766978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1766981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1766986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767024 */     // MIs[0] policy
     /* 1767024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767034 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1767037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767058 */     // GIR_Coverage, 11604,
     /* 1767058 */     GIR_EraseRootFromParent_Done,
     /* 1767059 */   // Label 24067: @1767059
     /* 1767059 */   GIM_Try, /*On fail goto*//*Label 24068*/ GIMT_Encode4(1767145), // Rule ID 11605 //
     /* 1767064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1767084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767110 */     // MIs[0] policy
     /* 1767110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1767123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767144 */     // GIR_Coverage, 11605,
     /* 1767144 */     GIR_EraseRootFromParent_Done,
     /* 1767145 */   // Label 24068: @1767145
     /* 1767145 */   GIM_Try, /*On fail goto*//*Label 24069*/ GIMT_Encode4(1767231), // Rule ID 11608 //
     /* 1767150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1767170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767196 */     // MIs[0] policy
     /* 1767196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767206 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1767209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767230 */     // GIR_Coverage, 11608,
     /* 1767230 */     GIR_EraseRootFromParent_Done,
     /* 1767231 */   // Label 24069: @1767231
     /* 1767231 */   GIM_Try, /*On fail goto*//*Label 24070*/ GIMT_Encode4(1767317), // Rule ID 11609 //
     /* 1767236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1767256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767282 */     // MIs[0] policy
     /* 1767282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767292 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1767295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767316 */     // GIR_Coverage, 11609,
     /* 1767316 */     GIR_EraseRootFromParent_Done,
     /* 1767317 */   // Label 24070: @1767317
     /* 1767317 */   GIM_Try, /*On fail goto*//*Label 24071*/ GIMT_Encode4(1767403), // Rule ID 11612 //
     /* 1767322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1767342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767368 */     // MIs[0] policy
     /* 1767368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767378 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1767381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767402 */     // GIR_Coverage, 11612,
     /* 1767402 */     GIR_EraseRootFromParent_Done,
     /* 1767403 */   // Label 24071: @1767403
     /* 1767403 */   GIM_Try, /*On fail goto*//*Label 24072*/ GIMT_Encode4(1767489), // Rule ID 11613 //
     /* 1767408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1767419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1767422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1767425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1767428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1767438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1767450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767454 */     // MIs[0] policy
     /* 1767454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767464 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1767467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767488 */     // GIR_Coverage, 11613,
     /* 1767488 */     GIR_EraseRootFromParent_Done,
     /* 1767489 */   // Label 24072: @1767489
     /* 1767489 */   GIM_Try, /*On fail goto*//*Label 24073*/ GIMT_Encode4(1767575), // Rule ID 11616 //
     /* 1767494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767540 */     // MIs[0] policy
     /* 1767540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1767553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767574 */     // GIR_Coverage, 11616,
     /* 1767574 */     GIR_EraseRootFromParent_Done,
     /* 1767575 */   // Label 24073: @1767575
     /* 1767575 */   GIM_Try, /*On fail goto*//*Label 24074*/ GIMT_Encode4(1767661), // Rule ID 11617 //
     /* 1767580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1767591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1767594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1767597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767626 */     // MIs[0] policy
     /* 1767626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1767639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767660 */     // GIR_Coverage, 11617,
     /* 1767660 */     GIR_EraseRootFromParent_Done,
     /* 1767661 */   // Label 24074: @1767661
     /* 1767661 */   GIM_Try, /*On fail goto*//*Label 24075*/ GIMT_Encode4(1767747), // Rule ID 11620 //
     /* 1767666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767712 */     // MIs[0] policy
     /* 1767712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1767725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767746 */     // GIR_Coverage, 11620,
     /* 1767746 */     GIR_EraseRootFromParent_Done,
     /* 1767747 */   // Label 24075: @1767747
     /* 1767747 */   GIM_Try, /*On fail goto*//*Label 24076*/ GIMT_Encode4(1767833), // Rule ID 11621 //
     /* 1767752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1767763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1767766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1767769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1767782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1767790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767798 */     // MIs[0] policy
     /* 1767798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1767811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767832 */     // GIR_Coverage, 11621,
     /* 1767832 */     GIR_EraseRootFromParent_Done,
     /* 1767833 */   // Label 24076: @1767833
     /* 1767833 */   GIM_Try, /*On fail goto*//*Label 24077*/ GIMT_Encode4(1767919), // Rule ID 11624 //
     /* 1767838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1767841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767884 */     // MIs[0] policy
     /* 1767884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767894 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1767897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1767915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767918 */     // GIR_Coverage, 11624,
     /* 1767918 */     GIR_EraseRootFromParent_Done,
     /* 1767919 */   // Label 24077: @1767919
     /* 1767919 */   GIM_Try, /*On fail goto*//*Label 24078*/ GIMT_Encode4(1768005), // Rule ID 11625 //
     /* 1767924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1767927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1767932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1767935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1767938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1767941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1767954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1767962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767970 */     // MIs[0] policy
     /* 1767970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1767983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768004 */     // GIR_Coverage, 11625,
     /* 1768004 */     GIR_EraseRootFromParent_Done,
     /* 1768005 */   // Label 24078: @1768005
     /* 1768005 */   GIM_Try, /*On fail goto*//*Label 24079*/ GIMT_Encode4(1768091), // Rule ID 11628 //
     /* 1768010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768056 */     // MIs[0] policy
     /* 1768056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768066 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1768069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768090 */     // GIR_Coverage, 11628,
     /* 1768090 */     GIR_EraseRootFromParent_Done,
     /* 1768091 */   // Label 24079: @1768091
     /* 1768091 */   GIM_Try, /*On fail goto*//*Label 24080*/ GIMT_Encode4(1768177), // Rule ID 11629 //
     /* 1768096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1768104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768142 */     // MIs[0] policy
     /* 1768142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768152 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1768155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768176 */     // GIR_Coverage, 11629,
     /* 1768176 */     GIR_EraseRootFromParent_Done,
     /* 1768177 */   // Label 24080: @1768177
     /* 1768177 */   GIM_Try, /*On fail goto*//*Label 24081*/ GIMT_Encode4(1768263), // Rule ID 11632 //
     /* 1768182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768228 */     // MIs[0] policy
     /* 1768228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768238 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1768241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768262 */     // GIR_Coverage, 11632,
     /* 1768262 */     GIR_EraseRootFromParent_Done,
     /* 1768263 */   // Label 24081: @1768263
     /* 1768263 */   GIM_Try, /*On fail goto*//*Label 24082*/ GIMT_Encode4(1768349), // Rule ID 11633 //
     /* 1768268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1768288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768314 */     // MIs[0] policy
     /* 1768314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768324 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1768327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768348 */     // GIR_Coverage, 11633,
     /* 1768348 */     GIR_EraseRootFromParent_Done,
     /* 1768349 */   // Label 24082: @1768349
     /* 1768349 */   GIM_Try, /*On fail goto*//*Label 24083*/ GIMT_Encode4(1768435), // Rule ID 11636 //
     /* 1768354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1768374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768400 */     // MIs[0] policy
     /* 1768400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768410 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1768413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768434 */     // GIR_Coverage, 11636,
     /* 1768434 */     GIR_EraseRootFromParent_Done,
     /* 1768435 */   // Label 24083: @1768435
     /* 1768435 */   GIM_Try, /*On fail goto*//*Label 24084*/ GIMT_Encode4(1768521), // Rule ID 11637 //
     /* 1768440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1768451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1768454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1768457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1768460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768486 */     // MIs[0] policy
     /* 1768486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768496 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1768499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768520 */     // GIR_Coverage, 11637,
     /* 1768520 */     GIR_EraseRootFromParent_Done,
     /* 1768521 */   // Label 24084: @1768521
     /* 1768521 */   GIM_Try, /*On fail goto*//*Label 24085*/ GIMT_Encode4(1768607), // Rule ID 11640 //
     /* 1768526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1768537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1768540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1768543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1768546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768572 */     // MIs[0] policy
     /* 1768572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768582 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1768585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768606 */     // GIR_Coverage, 11640,
     /* 1768606 */     GIR_EraseRootFromParent_Done,
     /* 1768607 */   // Label 24085: @1768607
     /* 1768607 */   GIM_Try, /*On fail goto*//*Label 24086*/ GIMT_Encode4(1768693), // Rule ID 11641 //
     /* 1768612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1768623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1768626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1768629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1768632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768658 */     // MIs[0] policy
     /* 1768658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768668 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1768671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768692 */     // GIR_Coverage, 11641,
     /* 1768692 */     GIR_EraseRootFromParent_Done,
     /* 1768693 */   // Label 24086: @1768693
     /* 1768693 */   GIM_Try, /*On fail goto*//*Label 24087*/ GIMT_Encode4(1768779), // Rule ID 11644 //
     /* 1768698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1768718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768744 */     // MIs[0] policy
     /* 1768744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768754 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1768757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768778 */     // GIR_Coverage, 11644,
     /* 1768778 */     GIR_EraseRootFromParent_Done,
     /* 1768779 */   // Label 24087: @1768779
     /* 1768779 */   GIM_Try, /*On fail goto*//*Label 24088*/ GIMT_Encode4(1768865), // Rule ID 11645 //
     /* 1768784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1768795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1768798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1768801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1768804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1768807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768830 */     // MIs[0] policy
     /* 1768830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768840 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1768843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768864 */     // GIR_Coverage, 11645,
     /* 1768864 */     GIR_EraseRootFromParent_Done,
     /* 1768865 */   // Label 24088: @1768865
     /* 1768865 */   GIM_Try, /*On fail goto*//*Label 24089*/ GIMT_Encode4(1768951), // Rule ID 11648 //
     /* 1768870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1768873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768916 */     // MIs[0] policy
     /* 1768916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768926 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1768929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768950 */     // GIR_Coverage, 11648,
     /* 1768950 */     GIR_EraseRootFromParent_Done,
     /* 1768951 */   // Label 24089: @1768951
     /* 1768951 */   GIM_Try, /*On fail goto*//*Label 24090*/ GIMT_Encode4(1769037), // Rule ID 11649 //
     /* 1768956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1768959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1768964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769002 */     // MIs[0] policy
     /* 1769002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1769015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769036 */     // GIR_Coverage, 11649,
     /* 1769036 */     GIR_EraseRootFromParent_Done,
     /* 1769037 */   // Label 24090: @1769037
     /* 1769037 */   GIM_Try, /*On fail goto*//*Label 24091*/ GIMT_Encode4(1769123), // Rule ID 11652 //
     /* 1769042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769088 */     // MIs[0] policy
     /* 1769088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1769101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769122 */     // GIR_Coverage, 11652,
     /* 1769122 */     GIR_EraseRootFromParent_Done,
     /* 1769123 */   // Label 24091: @1769123
     /* 1769123 */   GIM_Try, /*On fail goto*//*Label 24092*/ GIMT_Encode4(1769209), // Rule ID 11653 //
     /* 1769128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1769139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1769142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1769145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769174 */     // MIs[0] policy
     /* 1769174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1769187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769208 */     // GIR_Coverage, 11653,
     /* 1769208 */     GIR_EraseRootFromParent_Done,
     /* 1769209 */   // Label 24092: @1769209
     /* 1769209 */   GIM_Try, /*On fail goto*//*Label 24093*/ GIMT_Encode4(1769295), // Rule ID 11656 //
     /* 1769214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769260 */     // MIs[0] policy
     /* 1769260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1769273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769294 */     // GIR_Coverage, 11656,
     /* 1769294 */     GIR_EraseRootFromParent_Done,
     /* 1769295 */   // Label 24093: @1769295
     /* 1769295 */   GIM_Try, /*On fail goto*//*Label 24094*/ GIMT_Encode4(1769381), // Rule ID 11657 //
     /* 1769300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1769311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1769314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1769317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769346 */     // MIs[0] policy
     /* 1769346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769356 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1769359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769380 */     // GIR_Coverage, 11657,
     /* 1769380 */     GIR_EraseRootFromParent_Done,
     /* 1769381 */   // Label 24094: @1769381
     /* 1769381 */   GIM_Try, /*On fail goto*//*Label 24095*/ GIMT_Encode4(1769467), // Rule ID 11660 //
     /* 1769386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1769389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769432 */     // MIs[0] policy
     /* 1769432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1769445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769466 */     // GIR_Coverage, 11660,
     /* 1769466 */     GIR_EraseRootFromParent_Done,
     /* 1769467 */   // Label 24095: @1769467
     /* 1769467 */   GIM_Try, /*On fail goto*//*Label 24096*/ GIMT_Encode4(1769553), // Rule ID 11661 //
     /* 1769472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1769475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1769480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1769483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1769486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1769489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769518 */     // MIs[0] policy
     /* 1769518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769528 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1769531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1769549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769552 */     // GIR_Coverage, 11661,
     /* 1769552 */     GIR_EraseRootFromParent_Done,
     /* 1769553 */   // Label 24096: @1769553
     /* 1769553 */   GIM_Try, /*On fail goto*//*Label 24097*/ GIMT_Encode4(1769639), // Rule ID 11664 //
     /* 1769558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1769569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1769572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1769575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1769578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769604 */     // MIs[0] policy
     /* 1769604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769614 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1769617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769638 */     // GIR_Coverage, 11664,
     /* 1769638 */     GIR_EraseRootFromParent_Done,
     /* 1769639 */   // Label 24097: @1769639
     /* 1769639 */   GIM_Try, /*On fail goto*//*Label 24098*/ GIMT_Encode4(1769725), // Rule ID 11665 //
     /* 1769644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1769655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1769658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1769661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1769664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1769667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769690 */     // MIs[0] policy
     /* 1769690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769700 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1769703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769724 */     // GIR_Coverage, 11665,
     /* 1769724 */     GIR_EraseRootFromParent_Done,
     /* 1769725 */   // Label 24098: @1769725
     /* 1769725 */   GIM_Try, /*On fail goto*//*Label 24099*/ GIMT_Encode4(1769811), // Rule ID 11668 //
     /* 1769730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1769741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1769744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1769747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1769750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769776 */     // MIs[0] policy
     /* 1769776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769786 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1769789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769810 */     // GIR_Coverage, 11668,
     /* 1769810 */     GIR_EraseRootFromParent_Done,
     /* 1769811 */   // Label 24099: @1769811
     /* 1769811 */   GIM_Try, /*On fail goto*//*Label 24100*/ GIMT_Encode4(1769897), // Rule ID 11669 //
     /* 1769816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1769827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1769830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1769833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1769836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1769839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769862 */     // MIs[0] policy
     /* 1769862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769872 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1769875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769896 */     // GIR_Coverage, 11669,
     /* 1769896 */     GIR_EraseRootFromParent_Done,
     /* 1769897 */   // Label 24100: @1769897
     /* 1769897 */   GIM_Try, /*On fail goto*//*Label 24101*/ GIMT_Encode4(1769983), // Rule ID 11672 //
     /* 1769902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1769913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1769916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1769919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1769922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1769932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1769944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769948 */     // MIs[0] policy
     /* 1769948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769958 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1769961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1769979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769982 */     // GIR_Coverage, 11672,
     /* 1769982 */     GIR_EraseRootFromParent_Done,
     /* 1769983 */   // Label 24101: @1769983
     /* 1769983 */   GIM_Try, /*On fail goto*//*Label 24102*/ GIMT_Encode4(1770069), // Rule ID 11673 //
     /* 1769988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1769999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1770002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1770005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1770008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770034 */     // MIs[0] policy
     /* 1770034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770044 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1770047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770068 */     // GIR_Coverage, 11673,
     /* 1770068 */     GIR_EraseRootFromParent_Done,
     /* 1770069 */   // Label 24102: @1770069
     /* 1770069 */   GIM_Try, /*On fail goto*//*Label 24103*/ GIMT_Encode4(1770155), // Rule ID 11676 //
     /* 1770074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1770085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1770088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1770091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1770094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770120 */     // MIs[0] policy
     /* 1770120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770130 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1770133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770154 */     // GIR_Coverage, 11676,
     /* 1770154 */     GIR_EraseRootFromParent_Done,
     /* 1770155 */   // Label 24103: @1770155
     /* 1770155 */   GIM_Try, /*On fail goto*//*Label 24104*/ GIMT_Encode4(1770241), // Rule ID 11677 //
     /* 1770160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1770171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1770174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1770177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1770180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770206 */     // MIs[0] policy
     /* 1770206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770216 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1770219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770240 */     // GIR_Coverage, 11677,
     /* 1770240 */     GIR_EraseRootFromParent_Done,
     /* 1770241 */   // Label 24104: @1770241
     /* 1770241 */   GIM_Try, /*On fail goto*//*Label 24105*/ GIMT_Encode4(1770327), // Rule ID 11680 //
     /* 1770246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1770257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1770260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1770263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1770266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770292 */     // MIs[0] policy
     /* 1770292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770302 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1770305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770326 */     // GIR_Coverage, 11680,
     /* 1770326 */     GIR_EraseRootFromParent_Done,
     /* 1770327 */   // Label 24105: @1770327
     /* 1770327 */   GIM_Try, /*On fail goto*//*Label 24106*/ GIMT_Encode4(1770413), // Rule ID 11681 //
     /* 1770332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1770343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1770346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1770349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1770352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770378 */     // MIs[0] policy
     /* 1770378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770388 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1770391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770412 */     // GIR_Coverage, 11681,
     /* 1770412 */     GIR_EraseRootFromParent_Done,
     /* 1770413 */   // Label 24106: @1770413
     /* 1770413 */   GIM_Try, /*On fail goto*//*Label 24107*/ GIMT_Encode4(1770499), // Rule ID 11684 //
     /* 1770418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1770429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1770432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1770435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1770438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770464 */     // MIs[0] policy
     /* 1770464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770474 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1770477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770498 */     // GIR_Coverage, 11684,
     /* 1770498 */     GIR_EraseRootFromParent_Done,
     /* 1770499 */   // Label 24107: @1770499
     /* 1770499 */   GIM_Try, /*On fail goto*//*Label 24108*/ GIMT_Encode4(1770585), // Rule ID 11685 //
     /* 1770504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1770515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1770518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1770521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1770524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770550 */     // MIs[0] policy
     /* 1770550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770560 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1770563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770584 */     // GIR_Coverage, 11685,
     /* 1770584 */     GIR_EraseRootFromParent_Done,
     /* 1770585 */   // Label 24108: @1770585
     /* 1770585 */   GIM_Try, /*On fail goto*//*Label 24109*/ GIMT_Encode4(1770671), // Rule ID 11688 //
     /* 1770590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1770601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1770604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1770607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1770610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770636 */     // MIs[0] policy
     /* 1770636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770646 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1770649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770670 */     // GIR_Coverage, 11688,
     /* 1770670 */     GIR_EraseRootFromParent_Done,
     /* 1770671 */   // Label 24109: @1770671
     /* 1770671 */   GIM_Try, /*On fail goto*//*Label 24110*/ GIMT_Encode4(1770757), // Rule ID 11689 //
     /* 1770676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1770687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1770690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1770693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1770696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770722 */     // MIs[0] policy
     /* 1770722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770732 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1770735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770756 */     // GIR_Coverage, 11689,
     /* 1770756 */     GIR_EraseRootFromParent_Done,
     /* 1770757 */   // Label 24110: @1770757
     /* 1770757 */   GIM_Try, /*On fail goto*//*Label 24111*/ GIMT_Encode4(1770843), // Rule ID 11692 //
     /* 1770762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1770773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1770776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1770779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1770782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770808 */     // MIs[0] policy
     /* 1770808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1770821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770842 */     // GIR_Coverage, 11692,
     /* 1770842 */     GIR_EraseRootFromParent_Done,
     /* 1770843 */   // Label 24111: @1770843
     /* 1770843 */   GIM_Try, /*On fail goto*//*Label 24112*/ GIMT_Encode4(1770929), // Rule ID 11693 //
     /* 1770848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1770859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1770862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1770865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1770868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770894 */     // MIs[0] policy
     /* 1770894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770904 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1770907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1770925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770928 */     // GIR_Coverage, 11693,
     /* 1770928 */     GIR_EraseRootFromParent_Done,
     /* 1770929 */   // Label 24112: @1770929
     /* 1770929 */   GIM_Try, /*On fail goto*//*Label 24113*/ GIMT_Encode4(1771015), // Rule ID 11696 //
     /* 1770934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1770945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1770948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1770951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1770954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770980 */     // MIs[0] policy
     /* 1770980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1770993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771014 */     // GIR_Coverage, 11696,
     /* 1771014 */     GIR_EraseRootFromParent_Done,
     /* 1771015 */   // Label 24113: @1771015
     /* 1771015 */   GIM_Try, /*On fail goto*//*Label 24114*/ GIMT_Encode4(1771101), // Rule ID 11697 //
     /* 1771020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1771031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1771034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1771037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1771040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771066 */     // MIs[0] policy
     /* 1771066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771076 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1771079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771100 */     // GIR_Coverage, 11697,
     /* 1771100 */     GIR_EraseRootFromParent_Done,
     /* 1771101 */   // Label 24114: @1771101
     /* 1771101 */   GIM_Try, /*On fail goto*//*Label 24115*/ GIMT_Encode4(1771187), // Rule ID 11700 //
     /* 1771106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1771109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1771126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771152 */     // MIs[0] policy
     /* 1771152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1771165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771186 */     // GIR_Coverage, 11700,
     /* 1771186 */     GIR_EraseRootFromParent_Done,
     /* 1771187 */   // Label 24115: @1771187
     /* 1771187 */   GIM_Try, /*On fail goto*//*Label 24116*/ GIMT_Encode4(1771273), // Rule ID 11701 //
     /* 1771192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1771195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1771203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1771206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1771209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1771212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771238 */     // MIs[0] policy
     /* 1771238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771248 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1771251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1771269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771272 */     // GIR_Coverage, 11701,
     /* 1771272 */     GIR_EraseRootFromParent_Done,
     /* 1771273 */   // Label 24116: @1771273
     /* 1771273 */   GIM_Try, /*On fail goto*//*Label 24117*/ GIMT_Encode4(1771359), // Rule ID 11704 //
     /* 1771278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1771289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1771292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1771295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1771298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1771301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771324 */     // MIs[0] policy
     /* 1771324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771334 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1771337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771358 */     // GIR_Coverage, 11704,
     /* 1771358 */     GIR_EraseRootFromParent_Done,
     /* 1771359 */   // Label 24117: @1771359
     /* 1771359 */   GIM_Try, /*On fail goto*//*Label 24118*/ GIMT_Encode4(1771445), // Rule ID 11705 //
     /* 1771364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1771375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1771378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1771381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1771384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1771387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771410 */     // MIs[0] policy
     /* 1771410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771420 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1771423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771444 */     // GIR_Coverage, 11705,
     /* 1771444 */     GIR_EraseRootFromParent_Done,
     /* 1771445 */   // Label 24118: @1771445
     /* 1771445 */   GIM_Try, /*On fail goto*//*Label 24119*/ GIMT_Encode4(1771531), // Rule ID 11708 //
     /* 1771450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1771461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1771464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1771467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1771470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1771473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771496 */     // MIs[0] policy
     /* 1771496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1771509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771530 */     // GIR_Coverage, 11708,
     /* 1771530 */     GIR_EraseRootFromParent_Done,
     /* 1771531 */   // Label 24119: @1771531
     /* 1771531 */   GIM_Try, /*On fail goto*//*Label 24120*/ GIMT_Encode4(1771617), // Rule ID 11709 //
     /* 1771536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1771547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1771550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1771553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1771556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1771559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1771578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771582 */     // MIs[0] policy
     /* 1771582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771592 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1771595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771616 */     // GIR_Coverage, 11709,
     /* 1771616 */     GIR_EraseRootFromParent_Done,
     /* 1771617 */   // Label 24120: @1771617
     /* 1771617 */   GIM_Try, /*On fail goto*//*Label 24121*/ GIMT_Encode4(1771703), // Rule ID 11712 //
     /* 1771622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1771633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1771636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1771639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1771642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1771645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1771652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771668 */     // MIs[0] policy
     /* 1771668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1771681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771702 */     // GIR_Coverage, 11712,
     /* 1771702 */     GIR_EraseRootFromParent_Done,
     /* 1771703 */   // Label 24121: @1771703
     /* 1771703 */   GIM_Try, /*On fail goto*//*Label 24122*/ GIMT_Encode4(1771789), // Rule ID 11713 //
     /* 1771708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1771719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1771722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1771725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1771728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1771731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1771738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1771750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771754 */     // MIs[0] policy
     /* 1771754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771764 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1771767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771788 */     // GIR_Coverage, 11713,
     /* 1771788 */     GIR_EraseRootFromParent_Done,
     /* 1771789 */   // Label 24122: @1771789
     /* 1771789 */   GIM_Try, /*On fail goto*//*Label 24123*/ GIMT_Encode4(1771875), // Rule ID 11716 //
     /* 1771794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1771805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1771808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1771811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1771814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771840 */     // MIs[0] policy
     /* 1771840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1771853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771874 */     // GIR_Coverage, 11716,
     /* 1771874 */     GIR_EraseRootFromParent_Done,
     /* 1771875 */   // Label 24123: @1771875
     /* 1771875 */   GIM_Try, /*On fail goto*//*Label 24124*/ GIMT_Encode4(1771961), // Rule ID 11717 //
     /* 1771880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1771891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1771894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1771897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1771900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1771910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1771922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771926 */     // MIs[0] policy
     /* 1771926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771936 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1771939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771960 */     // GIR_Coverage, 11717,
     /* 1771960 */     GIR_EraseRootFromParent_Done,
     /* 1771961 */   // Label 24124: @1771961
     /* 1771961 */   GIM_Try, /*On fail goto*//*Label 24125*/ GIMT_Encode4(1772047), // Rule ID 11720 //
     /* 1771966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1771974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1771977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1771980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1771983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1771986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1771989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1771996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772012 */     // MIs[0] policy
     /* 1772012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772022 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1772025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772046 */     // GIR_Coverage, 11720,
     /* 1772046 */     GIR_EraseRootFromParent_Done,
     /* 1772047 */   // Label 24125: @1772047
     /* 1772047 */   GIM_Try, /*On fail goto*//*Label 24126*/ GIMT_Encode4(1772133), // Rule ID 11721 //
     /* 1772052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1772063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1772066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1772069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1772072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772098 */     // MIs[0] policy
     /* 1772098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1772111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772132 */     // GIR_Coverage, 11721,
     /* 1772132 */     GIR_EraseRootFromParent_Done,
     /* 1772133 */   // Label 24126: @1772133
     /* 1772133 */   GIM_Try, /*On fail goto*//*Label 24127*/ GIMT_Encode4(1772219), // Rule ID 11724 //
     /* 1772138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1772149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1772152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1772155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1772158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772184 */     // MIs[0] policy
     /* 1772184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1772197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772218 */     // GIR_Coverage, 11724,
     /* 1772218 */     GIR_EraseRootFromParent_Done,
     /* 1772219 */   // Label 24127: @1772219
     /* 1772219 */   GIM_Try, /*On fail goto*//*Label 24128*/ GIMT_Encode4(1772305), // Rule ID 11725 //
     /* 1772224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1772235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1772238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1772241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1772244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772270 */     // MIs[0] policy
     /* 1772270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772280 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1772283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772304 */     // GIR_Coverage, 11725,
     /* 1772304 */     GIR_EraseRootFromParent_Done,
     /* 1772305 */   // Label 24128: @1772305
     /* 1772305 */   GIM_Try, /*On fail goto*//*Label 24129*/ GIMT_Encode4(1772391), // Rule ID 11728 //
     /* 1772310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1772321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1772324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1772327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1772330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772356 */     // MIs[0] policy
     /* 1772356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1772369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772390 */     // GIR_Coverage, 11728,
     /* 1772390 */     GIR_EraseRootFromParent_Done,
     /* 1772391 */   // Label 24129: @1772391
     /* 1772391 */   GIM_Try, /*On fail goto*//*Label 24130*/ GIMT_Encode4(1772477), // Rule ID 11729 //
     /* 1772396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1772407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1772410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1772413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1772416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1772419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772442 */     // MIs[0] policy
     /* 1772442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1772455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772476 */     // GIR_Coverage, 11729,
     /* 1772476 */     GIR_EraseRootFromParent_Done,
     /* 1772477 */   // Label 24130: @1772477
     /* 1772477 */   GIM_Try, /*On fail goto*//*Label 24131*/ GIMT_Encode4(1772563), // Rule ID 11732 //
     /* 1772482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1772493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1772496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1772499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1772502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772528 */     // MIs[0] policy
     /* 1772528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772538 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1772541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772562 */     // GIR_Coverage, 11732,
     /* 1772562 */     GIR_EraseRootFromParent_Done,
     /* 1772563 */   // Label 24131: @1772563
     /* 1772563 */   GIM_Try, /*On fail goto*//*Label 24132*/ GIMT_Encode4(1772649), // Rule ID 11733 //
     /* 1772568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1772579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1772582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1772585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1772588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772614 */     // MIs[0] policy
     /* 1772614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772624 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1772627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772648 */     // GIR_Coverage, 11733,
     /* 1772648 */     GIR_EraseRootFromParent_Done,
     /* 1772649 */   // Label 24132: @1772649
     /* 1772649 */   GIM_Try, /*On fail goto*//*Label 24133*/ GIMT_Encode4(1772735), // Rule ID 11736 //
     /* 1772654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1772665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1772668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1772671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1772674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772700 */     // MIs[0] policy
     /* 1772700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772710 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1772713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772734 */     // GIR_Coverage, 11736,
     /* 1772734 */     GIR_EraseRootFromParent_Done,
     /* 1772735 */   // Label 24133: @1772735
     /* 1772735 */   GIM_Try, /*On fail goto*//*Label 24134*/ GIMT_Encode4(1772821), // Rule ID 11737 //
     /* 1772740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1772751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1772754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1772757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1772760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772786 */     // MIs[0] policy
     /* 1772786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772796 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1772799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772820 */     // GIR_Coverage, 11737,
     /* 1772820 */     GIR_EraseRootFromParent_Done,
     /* 1772821 */   // Label 24134: @1772821
     /* 1772821 */   GIM_Try, /*On fail goto*//*Label 24135*/ GIMT_Encode4(1772907), // Rule ID 11740 //
     /* 1772826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1772829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1772837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1772840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1772843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1772846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772872 */     // MIs[0] policy
     /* 1772872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1772885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772906 */     // GIR_Coverage, 11740,
     /* 1772906 */     GIR_EraseRootFromParent_Done,
     /* 1772907 */   // Label 24135: @1772907
     /* 1772907 */   GIM_Try, /*On fail goto*//*Label 24136*/ GIMT_Encode4(1772993), // Rule ID 11741 //
     /* 1772912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1772915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1772920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1772923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1772926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1772929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1772932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772958 */     // MIs[0] policy
     /* 1772958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1772971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772992 */     // GIR_Coverage, 11741,
     /* 1772992 */     GIR_EraseRootFromParent_Done,
     /* 1772993 */   // Label 24136: @1772993
     /* 1772993 */   GIM_Try, /*On fail goto*//*Label 24137*/ GIMT_Encode4(1773079), // Rule ID 11744 //
     /* 1772998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1773018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773044 */     // MIs[0] policy
     /* 1773044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773054 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1773057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773078 */     // GIR_Coverage, 11744,
     /* 1773078 */     GIR_EraseRootFromParent_Done,
     /* 1773079 */   // Label 24137: @1773079
     /* 1773079 */   GIM_Try, /*On fail goto*//*Label 24138*/ GIMT_Encode4(1773165), // Rule ID 11745 //
     /* 1773084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1773104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773130 */     // MIs[0] policy
     /* 1773130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773140 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1773143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773164 */     // GIR_Coverage, 11745,
     /* 1773164 */     GIR_EraseRootFromParent_Done,
     /* 1773165 */   // Label 24138: @1773165
     /* 1773165 */   GIM_Try, /*On fail goto*//*Label 24139*/ GIMT_Encode4(1773251), // Rule ID 11748 //
     /* 1773170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1773190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773216 */     // MIs[0] policy
     /* 1773216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773226 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1773229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773250 */     // GIR_Coverage, 11748,
     /* 1773250 */     GIR_EraseRootFromParent_Done,
     /* 1773251 */   // Label 24139: @1773251
     /* 1773251 */   GIM_Try, /*On fail goto*//*Label 24140*/ GIMT_Encode4(1773337), // Rule ID 11749 //
     /* 1773256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1773267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1773270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1773273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1773276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773302 */     // MIs[0] policy
     /* 1773302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773312 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1773315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773336 */     // GIR_Coverage, 11749,
     /* 1773336 */     GIR_EraseRootFromParent_Done,
     /* 1773337 */   // Label 24140: @1773337
     /* 1773337 */   GIM_Try, /*On fail goto*//*Label 24141*/ GIMT_Encode4(1773423), // Rule ID 11752 //
     /* 1773342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773388 */     // MIs[0] policy
     /* 1773388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773398 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1773401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773422 */     // GIR_Coverage, 11752,
     /* 1773422 */     GIR_EraseRootFromParent_Done,
     /* 1773423 */   // Label 24141: @1773423
     /* 1773423 */   GIM_Try, /*On fail goto*//*Label 24142*/ GIMT_Encode4(1773509), // Rule ID 11753 //
     /* 1773428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1773439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1773442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1773445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773474 */     // MIs[0] policy
     /* 1773474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773484 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1773487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773508 */     // GIR_Coverage, 11753,
     /* 1773508 */     GIR_EraseRootFromParent_Done,
     /* 1773509 */   // Label 24142: @1773509
     /* 1773509 */   GIM_Try, /*On fail goto*//*Label 24143*/ GIMT_Encode4(1773595), // Rule ID 11756 //
     /* 1773514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1773525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1773528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1773531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773560 */     // MIs[0] policy
     /* 1773560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773570 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1773573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773594 */     // GIR_Coverage, 11756,
     /* 1773594 */     GIR_EraseRootFromParent_Done,
     /* 1773595 */   // Label 24143: @1773595
     /* 1773595 */   GIM_Try, /*On fail goto*//*Label 24144*/ GIMT_Encode4(1773681), // Rule ID 11757 //
     /* 1773600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1773611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1773614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1773617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773646 */     // MIs[0] policy
     /* 1773646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773656 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1773659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773680 */     // GIR_Coverage, 11757,
     /* 1773680 */     GIR_EraseRootFromParent_Done,
     /* 1773681 */   // Label 24144: @1773681
     /* 1773681 */   GIM_Try, /*On fail goto*//*Label 24145*/ GIMT_Encode4(1773767), // Rule ID 11760 //
     /* 1773686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1773697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1773700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1773703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773732 */     // MIs[0] policy
     /* 1773732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773742 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1773745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773766 */     // GIR_Coverage, 11760,
     /* 1773766 */     GIR_EraseRootFromParent_Done,
     /* 1773767 */   // Label 24145: @1773767
     /* 1773767 */   GIM_Try, /*On fail goto*//*Label 24146*/ GIMT_Encode4(1773853), // Rule ID 11761 //
     /* 1773772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1773783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1773786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1773789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773818 */     // MIs[0] policy
     /* 1773818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773828 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1773831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1773849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773852 */     // GIR_Coverage, 11761,
     /* 1773852 */     GIR_EraseRootFromParent_Done,
     /* 1773853 */   // Label 24146: @1773853
     /* 1773853 */   GIM_Try, /*On fail goto*//*Label 24147*/ GIMT_Encode4(1773939), // Rule ID 11764 //
     /* 1773858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1773869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1773872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1773875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1773878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773904 */     // MIs[0] policy
     /* 1773904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1773917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773938 */     // GIR_Coverage, 11764,
     /* 1773938 */     GIR_EraseRootFromParent_Done,
     /* 1773939 */   // Label 24147: @1773939
     /* 1773939 */   GIM_Try, /*On fail goto*//*Label 24148*/ GIMT_Encode4(1774025), // Rule ID 11765 //
     /* 1773944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1773952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1773955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1773958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1773961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1773964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1773967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1773974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1773982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1773986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773990 */     // MIs[0] policy
     /* 1773990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774000 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1774003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774024 */     // GIR_Coverage, 11765,
     /* 1774024 */     GIR_EraseRootFromParent_Done,
     /* 1774025 */   // Label 24148: @1774025
     /* 1774025 */   GIM_Try, /*On fail goto*//*Label 24149*/ GIMT_Encode4(1774111), // Rule ID 11768 //
     /* 1774030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774076 */     // MIs[0] policy
     /* 1774076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1774089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774110 */     // GIR_Coverage, 11768,
     /* 1774110 */     GIR_EraseRootFromParent_Done,
     /* 1774111 */   // Label 24149: @1774111
     /* 1774111 */   GIM_Try, /*On fail goto*//*Label 24150*/ GIMT_Encode4(1774197), // Rule ID 11769 //
     /* 1774116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1774127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1774130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1774133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774162 */     // MIs[0] policy
     /* 1774162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774172 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1774175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774196 */     // GIR_Coverage, 11769,
     /* 1774196 */     GIR_EraseRootFromParent_Done,
     /* 1774197 */   // Label 24150: @1774197
     /* 1774197 */   GIM_Try, /*On fail goto*//*Label 24151*/ GIMT_Encode4(1774283), // Rule ID 11772 //
     /* 1774202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774248 */     // MIs[0] policy
     /* 1774248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774258 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1774261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774282 */     // GIR_Coverage, 11772,
     /* 1774282 */     GIR_EraseRootFromParent_Done,
     /* 1774283 */   // Label 24151: @1774283
     /* 1774283 */   GIM_Try, /*On fail goto*//*Label 24152*/ GIMT_Encode4(1774369), // Rule ID 11773 //
     /* 1774288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1774299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1774302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1774305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774334 */     // MIs[0] policy
     /* 1774334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1774347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774368 */     // GIR_Coverage, 11773,
     /* 1774368 */     GIR_EraseRootFromParent_Done,
     /* 1774369 */   // Label 24152: @1774369
     /* 1774369 */   GIM_Try, /*On fail goto*//*Label 24153*/ GIMT_Encode4(1774455), // Rule ID 11776 //
     /* 1774374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774420 */     // MIs[0] policy
     /* 1774420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774430 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1774433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774454 */     // GIR_Coverage, 11776,
     /* 1774454 */     GIR_EraseRootFromParent_Done,
     /* 1774455 */   // Label 24153: @1774455
     /* 1774455 */   GIM_Try, /*On fail goto*//*Label 24154*/ GIMT_Encode4(1774541), // Rule ID 11777 //
     /* 1774460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1774471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1774474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1774477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774506 */     // MIs[0] policy
     /* 1774506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11184:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1774519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774540 */     // GIR_Coverage, 11777,
     /* 1774540 */     GIR_EraseRootFromParent_Done,
     /* 1774541 */   // Label 24154: @1774541
     /* 1774541 */   GIM_Try, /*On fail goto*//*Label 24155*/ GIMT_Encode4(1774627), // Rule ID 11780 //
     /* 1774546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1774557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1774560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1774563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774592 */     // MIs[0] policy
     /* 1774592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1774605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774626 */     // GIR_Coverage, 11780,
     /* 1774626 */     GIR_EraseRootFromParent_Done,
     /* 1774627 */   // Label 24155: @1774627
     /* 1774627 */   GIM_Try, /*On fail goto*//*Label 24156*/ GIMT_Encode4(1774713), // Rule ID 11781 //
     /* 1774632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1774643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1774646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1774649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774678 */     // MIs[0] policy
     /* 1774678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774688 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1774691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774712 */     // GIR_Coverage, 11781,
     /* 1774712 */     GIR_EraseRootFromParent_Done,
     /* 1774713 */   // Label 24156: @1774713
     /* 1774713 */   GIM_Try, /*On fail goto*//*Label 24157*/ GIMT_Encode4(1774799), // Rule ID 11784 //
     /* 1774718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1774729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1774732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1774735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774764 */     // MIs[0] policy
     /* 1774764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1774777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774798 */     // GIR_Coverage, 11784,
     /* 1774798 */     GIR_EraseRootFromParent_Done,
     /* 1774799 */   // Label 24157: @1774799
     /* 1774799 */   GIM_Try, /*On fail goto*//*Label 24158*/ GIMT_Encode4(1774885), // Rule ID 11785 //
     /* 1774804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1774815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1774818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1774821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774850 */     // MIs[0] policy
     /* 1774850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1774863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1774881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774884 */     // GIR_Coverage, 11785,
     /* 1774884 */     GIR_EraseRootFromParent_Done,
     /* 1774885 */   // Label 24158: @1774885
     /* 1774885 */   GIM_Try, /*On fail goto*//*Label 24159*/ GIMT_Encode4(1774971), // Rule ID 11788 //
     /* 1774890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1774901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1774904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1774907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774936 */     // MIs[0] policy
     /* 1774936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1774949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774970 */     // GIR_Coverage, 11788,
     /* 1774970 */     GIR_EraseRootFromParent_Done,
     /* 1774971 */   // Label 24159: @1774971
     /* 1774971 */   GIM_Try, /*On fail goto*//*Label 24160*/ GIMT_Encode4(1775057), // Rule ID 11789 //
     /* 1774976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1774984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1774987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1774990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1774993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775022 */     // MIs[0] policy
     /* 1775022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1775035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1775053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775056 */     // GIR_Coverage, 11789,
     /* 1775056 */     GIR_EraseRootFromParent_Done,
     /* 1775057 */   // Label 24160: @1775057
     /* 1775057 */   GIM_Try, /*On fail goto*//*Label 24161*/ GIMT_Encode4(1775143), // Rule ID 11792 //
     /* 1775062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775108 */     // MIs[0] policy
     /* 1775108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1775121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775142 */     // GIR_Coverage, 11792,
     /* 1775142 */     GIR_EraseRootFromParent_Done,
     /* 1775143 */   // Label 24161: @1775143
     /* 1775143 */   GIM_Try, /*On fail goto*//*Label 24162*/ GIMT_Encode4(1775229), // Rule ID 11793 //
     /* 1775148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1775159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1775162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1775165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775194 */     // MIs[0] policy
     /* 1775194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1775207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775228 */     // GIR_Coverage, 11793,
     /* 1775228 */     GIR_EraseRootFromParent_Done,
     /* 1775229 */   // Label 24162: @1775229
     /* 1775229 */   GIM_Try, /*On fail goto*//*Label 24163*/ GIMT_Encode4(1775315), // Rule ID 11796 //
     /* 1775234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775280 */     // MIs[0] policy
     /* 1775280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1775293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775314 */     // GIR_Coverage, 11796,
     /* 1775314 */     GIR_EraseRootFromParent_Done,
     /* 1775315 */   // Label 24163: @1775315
     /* 1775315 */   GIM_Try, /*On fail goto*//*Label 24164*/ GIMT_Encode4(1775401), // Rule ID 11797 //
     /* 1775320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1775331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1775334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1775337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775366 */     // MIs[0] policy
     /* 1775366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1775379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775400 */     // GIR_Coverage, 11797,
     /* 1775400 */     GIR_EraseRootFromParent_Done,
     /* 1775401 */   // Label 24164: @1775401
     /* 1775401 */   GIM_Try, /*On fail goto*//*Label 24165*/ GIMT_Encode4(1775487), // Rule ID 11800 //
     /* 1775406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775452 */     // MIs[0] policy
     /* 1775452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775462 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1775465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775486 */     // GIR_Coverage, 11800,
     /* 1775486 */     GIR_EraseRootFromParent_Done,
     /* 1775487 */   // Label 24165: @1775487
     /* 1775487 */   GIM_Try, /*On fail goto*//*Label 24166*/ GIMT_Encode4(1775573), // Rule ID 11801 //
     /* 1775492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1775503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1775506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1775509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1775515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775538 */     // MIs[0] policy
     /* 1775538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775548 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1775551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775572 */     // GIR_Coverage, 11801,
     /* 1775572 */     GIR_EraseRootFromParent_Done,
     /* 1775573 */   // Label 24166: @1775573
     /* 1775573 */   GIM_Try, /*On fail goto*//*Label 24167*/ GIMT_Encode4(1775659), // Rule ID 11804 //
     /* 1775578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1775589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1775592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1775595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775624 */     // MIs[0] policy
     /* 1775624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1775637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775658 */     // GIR_Coverage, 11804,
     /* 1775658 */     GIR_EraseRootFromParent_Done,
     /* 1775659 */   // Label 24167: @1775659
     /* 1775659 */   GIM_Try, /*On fail goto*//*Label 24168*/ GIMT_Encode4(1775745), // Rule ID 11805 //
     /* 1775664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1775675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1775678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1775681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1775694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1775702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775710 */     // MIs[0] policy
     /* 1775710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1775723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775744 */     // GIR_Coverage, 11805,
     /* 1775744 */     GIR_EraseRootFromParent_Done,
     /* 1775745 */   // Label 24168: @1775745
     /* 1775745 */   GIM_Try, /*On fail goto*//*Label 24169*/ GIMT_Encode4(1775831), // Rule ID 11808 //
     /* 1775750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1775761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1775764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1775767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775796 */     // MIs[0] policy
     /* 1775796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1775809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775830 */     // GIR_Coverage, 11808,
     /* 1775830 */     GIR_EraseRootFromParent_Done,
     /* 1775831 */   // Label 24169: @1775831
     /* 1775831 */   GIM_Try, /*On fail goto*//*Label 24170*/ GIMT_Encode4(1775917), // Rule ID 11809 //
     /* 1775836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1775847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1775850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1775853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1775859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1775866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1775874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775882 */     // MIs[0] policy
     /* 1775882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1775895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775916 */     // GIR_Coverage, 11809,
     /* 1775916 */     GIR_EraseRootFromParent_Done,
     /* 1775917 */   // Label 24170: @1775917
     /* 1775917 */   GIM_Try, /*On fail goto*//*Label 24171*/ GIMT_Encode4(1776003), // Rule ID 11812 //
     /* 1775922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1775930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1775933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1775936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1775939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1775945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1775952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1775960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775968 */     // MIs[0] policy
     /* 1775968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775978 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1775981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776002 */     // GIR_Coverage, 11812,
     /* 1776002 */     GIR_EraseRootFromParent_Done,
     /* 1776003 */   // Label 24171: @1776003
     /* 1776003 */   GIM_Try, /*On fail goto*//*Label 24172*/ GIMT_Encode4(1776089), // Rule ID 11813 //
     /* 1776008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1776019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1776022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1776025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776054 */     // MIs[0] policy
     /* 1776054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776064 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1776067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776088 */     // GIR_Coverage, 11813,
     /* 1776088 */     GIR_EraseRootFromParent_Done,
     /* 1776089 */   // Label 24172: @1776089
     /* 1776089 */   GIM_Try, /*On fail goto*//*Label 24173*/ GIMT_Encode4(1776175), // Rule ID 11816 //
     /* 1776094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776140 */     // MIs[0] policy
     /* 1776140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1776153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776174 */     // GIR_Coverage, 11816,
     /* 1776174 */     GIR_EraseRootFromParent_Done,
     /* 1776175 */   // Label 24173: @1776175
     /* 1776175 */   GIM_Try, /*On fail goto*//*Label 24174*/ GIMT_Encode4(1776261), // Rule ID 11817 //
     /* 1776180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1776191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1776194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1776197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776226 */     // MIs[0] policy
     /* 1776226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1776239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776260 */     // GIR_Coverage, 11817,
     /* 1776260 */     GIR_EraseRootFromParent_Done,
     /* 1776261 */   // Label 24174: @1776261
     /* 1776261 */   GIM_Try, /*On fail goto*//*Label 24175*/ GIMT_Encode4(1776347), // Rule ID 11820 //
     /* 1776266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776312 */     // MIs[0] policy
     /* 1776312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1776325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776346 */     // GIR_Coverage, 11820,
     /* 1776346 */     GIR_EraseRootFromParent_Done,
     /* 1776347 */   // Label 24175: @1776347
     /* 1776347 */   GIM_Try, /*On fail goto*//*Label 24176*/ GIMT_Encode4(1776433), // Rule ID 11821 //
     /* 1776352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1776363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1776366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1776369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776398 */     // MIs[0] policy
     /* 1776398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1776411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776432 */     // GIR_Coverage, 11821,
     /* 1776432 */     GIR_EraseRootFromParent_Done,
     /* 1776433 */   // Label 24176: @1776433
     /* 1776433 */   GIM_Try, /*On fail goto*//*Label 24177*/ GIMT_Encode4(1776519), // Rule ID 11824 //
     /* 1776438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1776449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1776452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1776455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776484 */     // MIs[0] policy
     /* 1776484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1776497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776518 */     // GIR_Coverage, 11824,
     /* 1776518 */     GIR_EraseRootFromParent_Done,
     /* 1776519 */   // Label 24177: @1776519
     /* 1776519 */   GIM_Try, /*On fail goto*//*Label 24178*/ GIMT_Encode4(1776605), // Rule ID 11825 //
     /* 1776524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1776535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1776538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1776541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776570 */     // MIs[0] policy
     /* 1776570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1776583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1776601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776604 */     // GIR_Coverage, 11825,
     /* 1776604 */     GIR_EraseRootFromParent_Done,
     /* 1776605 */   // Label 24178: @1776605
     /* 1776605 */   GIM_Try, /*On fail goto*//*Label 24179*/ GIMT_Encode4(1776691), // Rule ID 11828 //
     /* 1776610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1776621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1776624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1776627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776656 */     // MIs[0] policy
     /* 1776656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1776669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776690 */     // GIR_Coverage, 11828,
     /* 1776690 */     GIR_EraseRootFromParent_Done,
     /* 1776691 */   // Label 24179: @1776691
     /* 1776691 */   GIM_Try, /*On fail goto*//*Label 24180*/ GIMT_Encode4(1776777), // Rule ID 11829 //
     /* 1776696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1776699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1776707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1776710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1776713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1776719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776742 */     // MIs[0] policy
     /* 1776742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11184:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1776755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776776 */     // GIR_Coverage, 11829,
     /* 1776776 */     GIR_EraseRootFromParent_Done,
     /* 1776777 */   // Label 24180: @1776777
     /* 1776777 */   GIM_Try, /*On fail goto*//*Label 24181*/ GIMT_Encode4(1776863), // Rule ID 11832 //
     /* 1776782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1776793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1776796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1776799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776828 */     // MIs[0] policy
     /* 1776828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1776841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776862 */     // GIR_Coverage, 11832,
     /* 1776862 */     GIR_EraseRootFromParent_Done,
     /* 1776863 */   // Label 24181: @1776863
     /* 1776863 */   GIM_Try, /*On fail goto*//*Label 24182*/ GIMT_Encode4(1776949), // Rule ID 11833 //
     /* 1776868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1776871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1776879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1776882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1776885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1776891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776914 */     // MIs[0] policy
     /* 1776914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776924 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11184:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1776927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776948 */     // GIR_Coverage, 11833,
     /* 1776948 */     GIR_EraseRootFromParent_Done,
     /* 1776949 */   // Label 24182: @1776949
     /* 1776949 */   GIM_Try, /*On fail goto*//*Label 24183*/ GIMT_Encode4(1777035), // Rule ID 11836 //
     /* 1776954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1776957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1776962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1776965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1776968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1776971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777000 */     // MIs[0] policy
     /* 1777000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1777013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777034 */     // GIR_Coverage, 11836,
     /* 1777034 */     GIR_EraseRootFromParent_Done,
     /* 1777035 */   // Label 24183: @1777035
     /* 1777035 */   GIM_Try, /*On fail goto*//*Label 24184*/ GIMT_Encode4(1777121), // Rule ID 11837 //
     /* 1777040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1777048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1777051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1777054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1777057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777086 */     // MIs[0] policy
     /* 1777086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777096 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11184:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1777099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777120 */     // GIR_Coverage, 11837,
     /* 1777120 */     GIR_EraseRootFromParent_Done,
     /* 1777121 */   // Label 24184: @1777121
     /* 1777121 */   GIM_Try, /*On fail goto*//*Label 24185*/ GIMT_Encode4(1777207), // Rule ID 11840 //
     /* 1777126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1777146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777172 */     // MIs[0] policy
     /* 1777172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777182 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1777185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777206 */     // GIR_Coverage, 11840,
     /* 1777206 */     GIR_EraseRootFromParent_Done,
     /* 1777207 */   // Label 24185: @1777207
     /* 1777207 */   GIM_Try, /*On fail goto*//*Label 24186*/ GIMT_Encode4(1777293), // Rule ID 11841 //
     /* 1777212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1777223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1777226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1777229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1777232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777258 */     // MIs[0] policy
     /* 1777258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777268 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1777271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777292 */     // GIR_Coverage, 11841,
     /* 1777292 */     GIR_EraseRootFromParent_Done,
     /* 1777293 */   // Label 24186: @1777293
     /* 1777293 */   GIM_Try, /*On fail goto*//*Label 24187*/ GIMT_Encode4(1777379), // Rule ID 11844 //
     /* 1777298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1777318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777344 */     // MIs[0] policy
     /* 1777344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777354 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1777357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777378 */     // GIR_Coverage, 11844,
     /* 1777378 */     GIR_EraseRootFromParent_Done,
     /* 1777379 */   // Label 24187: @1777379
     /* 1777379 */   GIM_Try, /*On fail goto*//*Label 24188*/ GIMT_Encode4(1777465), // Rule ID 11845 //
     /* 1777384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1777395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1777398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1777401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1777404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777430 */     // MIs[0] policy
     /* 1777430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777440 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1777443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777464 */     // GIR_Coverage, 11845,
     /* 1777464 */     GIR_EraseRootFromParent_Done,
     /* 1777465 */   // Label 24188: @1777465
     /* 1777465 */   GIM_Try, /*On fail goto*//*Label 24189*/ GIMT_Encode4(1777551), // Rule ID 11848 //
     /* 1777470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1777481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1777484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1777487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1777490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777516 */     // MIs[0] policy
     /* 1777516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1777529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777550 */     // GIR_Coverage, 11848,
     /* 1777550 */     GIR_EraseRootFromParent_Done,
     /* 1777551 */   // Label 24189: @1777551
     /* 1777551 */   GIM_Try, /*On fail goto*//*Label 24190*/ GIMT_Encode4(1777637), // Rule ID 11849 //
     /* 1777556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1777567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1777570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1777573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1777576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777602 */     // MIs[0] policy
     /* 1777602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777612 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1777615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1777633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777636 */     // GIR_Coverage, 11849,
     /* 1777636 */     GIR_EraseRootFromParent_Done,
     /* 1777637 */   // Label 24190: @1777637
     /* 1777637 */   GIM_Try, /*On fail goto*//*Label 24191*/ GIMT_Encode4(1777723), // Rule ID 11852 //
     /* 1777642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1777653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1777656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1777659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1777662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777688 */     // MIs[0] policy
     /* 1777688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777698 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1777701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777722 */     // GIR_Coverage, 11852,
     /* 1777722 */     GIR_EraseRootFromParent_Done,
     /* 1777723 */   // Label 24191: @1777723
     /* 1777723 */   GIM_Try, /*On fail goto*//*Label 24192*/ GIMT_Encode4(1777809), // Rule ID 11853 //
     /* 1777728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1777739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1777742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1777745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1777748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1777751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777774 */     // MIs[0] policy
     /* 1777774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1777787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777808 */     // GIR_Coverage, 11853,
     /* 1777808 */     GIR_EraseRootFromParent_Done,
     /* 1777809 */   // Label 24192: @1777809
     /* 1777809 */   GIM_Try, /*On fail goto*//*Label 24193*/ GIMT_Encode4(1777895), // Rule ID 11856 //
     /* 1777814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1777825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1777828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1777831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1777834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777860 */     // MIs[0] policy
     /* 1777860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777870 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1777873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777894 */     // GIR_Coverage, 11856,
     /* 1777894 */     GIR_EraseRootFromParent_Done,
     /* 1777895 */   // Label 24193: @1777895
     /* 1777895 */   GIM_Try, /*On fail goto*//*Label 24194*/ GIMT_Encode4(1777981), // Rule ID 11857 //
     /* 1777900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1777911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1777914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1777917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1777920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1777930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1777942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777946 */     // MIs[0] policy
     /* 1777946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777956 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1777959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777980 */     // GIR_Coverage, 11857,
     /* 1777980 */     GIR_EraseRootFromParent_Done,
     /* 1777981 */   // Label 24194: @1777981
     /* 1777981 */   GIM_Try, /*On fail goto*//*Label 24195*/ GIMT_Encode4(1778067), // Rule ID 11860 //
     /* 1777986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1777997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1778006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778032 */     // MIs[0] policy
     /* 1778032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1778045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778066 */     // GIR_Coverage, 11860,
     /* 1778066 */     GIR_EraseRootFromParent_Done,
     /* 1778067 */   // Label 24195: @1778067
     /* 1778067 */   GIM_Try, /*On fail goto*//*Label 24196*/ GIMT_Encode4(1778153), // Rule ID 11861 //
     /* 1778072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1778092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778118 */     // MIs[0] policy
     /* 1778118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778128 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1778131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778152 */     // GIR_Coverage, 11861,
     /* 1778152 */     GIR_EraseRootFromParent_Done,
     /* 1778153 */   // Label 24196: @1778153
     /* 1778153 */   GIM_Try, /*On fail goto*//*Label 24197*/ GIMT_Encode4(1778239), // Rule ID 11864 //
     /* 1778158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1778178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778204 */     // MIs[0] policy
     /* 1778204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778214 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1778217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778238 */     // GIR_Coverage, 11864,
     /* 1778238 */     GIR_EraseRootFromParent_Done,
     /* 1778239 */   // Label 24197: @1778239
     /* 1778239 */   GIM_Try, /*On fail goto*//*Label 24198*/ GIMT_Encode4(1778325), // Rule ID 11865 //
     /* 1778244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1778255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1778258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1778261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1778264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778290 */     // MIs[0] policy
     /* 1778290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1778303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778324 */     // GIR_Coverage, 11865,
     /* 1778324 */     GIR_EraseRootFromParent_Done,
     /* 1778325 */   // Label 24198: @1778325
     /* 1778325 */   GIM_Try, /*On fail goto*//*Label 24199*/ GIMT_Encode4(1778411), // Rule ID 11868 //
     /* 1778330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1778350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778376 */     // MIs[0] policy
     /* 1778376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1778389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778410 */     // GIR_Coverage, 11868,
     /* 1778410 */     GIR_EraseRootFromParent_Done,
     /* 1778411 */   // Label 24199: @1778411
     /* 1778411 */   GIM_Try, /*On fail goto*//*Label 24200*/ GIMT_Encode4(1778497), // Rule ID 11869 //
     /* 1778416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1778427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1778430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1778433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1778436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778462 */     // MIs[0] policy
     /* 1778462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1778475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778496 */     // GIR_Coverage, 11869,
     /* 1778496 */     GIR_EraseRootFromParent_Done,
     /* 1778497 */   // Label 24200: @1778497
     /* 1778497 */   GIM_Try, /*On fail goto*//*Label 24201*/ GIMT_Encode4(1778583), // Rule ID 11872 //
     /* 1778502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1778513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1778516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1778519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1778522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778548 */     // MIs[0] policy
     /* 1778548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1778561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778582 */     // GIR_Coverage, 11872,
     /* 1778582 */     GIR_EraseRootFromParent_Done,
     /* 1778583 */   // Label 24201: @1778583
     /* 1778583 */   GIM_Try, /*On fail goto*//*Label 24202*/ GIMT_Encode4(1778669), // Rule ID 11873 //
     /* 1778588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1778599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1778602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1778605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1778608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778634 */     // MIs[0] policy
     /* 1778634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1778647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1778665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778668 */     // GIR_Coverage, 11873,
     /* 1778668 */     GIR_EraseRootFromParent_Done,
     /* 1778669 */   // Label 24202: @1778669
     /* 1778669 */   GIM_Try, /*On fail goto*//*Label 24203*/ GIMT_Encode4(1778755), // Rule ID 11876 //
     /* 1778674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1778677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1778685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1778688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1778691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1778694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778720 */     // MIs[0] policy
     /* 1778720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1778733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778754 */     // GIR_Coverage, 11876,
     /* 1778754 */     GIR_EraseRootFromParent_Done,
     /* 1778755 */   // Label 24203: @1778755
     /* 1778755 */   GIM_Try, /*On fail goto*//*Label 24204*/ GIMT_Encode4(1778841), // Rule ID 11877 //
     /* 1778760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1778771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1778774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1778777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1778780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778806 */     // MIs[0] policy
     /* 1778806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1778819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778840 */     // GIR_Coverage, 11877,
     /* 1778840 */     GIR_EraseRootFromParent_Done,
     /* 1778841 */   // Label 24204: @1778841
     /* 1778841 */   GIM_Try, /*On fail goto*//*Label 24205*/ GIMT_Encode4(1778927), // Rule ID 11880 //
     /* 1778846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1778857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1778860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1778863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1778866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1778869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1778876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778892 */     // MIs[0] policy
     /* 1778892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778902 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1778905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778926 */     // GIR_Coverage, 11880,
     /* 1778926 */     GIR_EraseRootFromParent_Done,
     /* 1778927 */   // Label 24205: @1778927
     /* 1778927 */   GIM_Try, /*On fail goto*//*Label 24206*/ GIMT_Encode4(1779013), // Rule ID 11881 //
     /* 1778932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1778943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1778946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1778949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1778952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1778955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1778962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1778974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778978 */     // MIs[0] policy
     /* 1778978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1778991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779012 */     // GIR_Coverage, 11881,
     /* 1779012 */     GIR_EraseRootFromParent_Done,
     /* 1779013 */   // Label 24206: @1779013
     /* 1779013 */   GIM_Try, /*On fail goto*//*Label 24207*/ GIMT_Encode4(1779099), // Rule ID 11884 //
     /* 1779018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1779038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779064 */     // MIs[0] policy
     /* 1779064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779074 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1779077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779098 */     // GIR_Coverage, 11884,
     /* 1779098 */     GIR_EraseRootFromParent_Done,
     /* 1779099 */   // Label 24207: @1779099
     /* 1779099 */   GIM_Try, /*On fail goto*//*Label 24208*/ GIMT_Encode4(1779185), // Rule ID 11885 //
     /* 1779104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1779115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1779118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1779121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1779124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779150 */     // MIs[0] policy
     /* 1779150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1779163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779184 */     // GIR_Coverage, 11885,
     /* 1779184 */     GIR_EraseRootFromParent_Done,
     /* 1779185 */   // Label 24208: @1779185
     /* 1779185 */   GIM_Try, /*On fail goto*//*Label 24209*/ GIMT_Encode4(1779271), // Rule ID 11888 //
     /* 1779190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1779210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779236 */     // MIs[0] policy
     /* 1779236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779246 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1779249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779270 */     // GIR_Coverage, 11888,
     /* 1779270 */     GIR_EraseRootFromParent_Done,
     /* 1779271 */   // Label 24209: @1779271
     /* 1779271 */   GIM_Try, /*On fail goto*//*Label 24210*/ GIMT_Encode4(1779357), // Rule ID 11889 //
     /* 1779276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1779287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1779290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1779293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1779296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1779299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779322 */     // MIs[0] policy
     /* 1779322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779332 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1779335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779356 */     // GIR_Coverage, 11889,
     /* 1779356 */     GIR_EraseRootFromParent_Done,
     /* 1779357 */   // Label 24210: @1779357
     /* 1779357 */   GIM_Try, /*On fail goto*//*Label 24211*/ GIMT_Encode4(1779443), // Rule ID 11892 //
     /* 1779362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1779382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779408 */     // MIs[0] policy
     /* 1779408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1779421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779442 */     // GIR_Coverage, 11892,
     /* 1779442 */     GIR_EraseRootFromParent_Done,
     /* 1779443 */   // Label 24211: @1779443
     /* 1779443 */   GIM_Try, /*On fail goto*//*Label 24212*/ GIMT_Encode4(1779529), // Rule ID 11893 //
     /* 1779448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1779459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1779462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1779465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1779468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779494 */     // MIs[0] policy
     /* 1779494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1779507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779528 */     // GIR_Coverage, 11893,
     /* 1779528 */     GIR_EraseRootFromParent_Done,
     /* 1779529 */   // Label 24212: @1779529
     /* 1779529 */   GIM_Try, /*On fail goto*//*Label 24213*/ GIMT_Encode4(1779615), // Rule ID 11896 //
     /* 1779534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1779545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1779548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1779551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1779554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779580 */     // MIs[0] policy
     /* 1779580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1779593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779614 */     // GIR_Coverage, 11896,
     /* 1779614 */     GIR_EraseRootFromParent_Done,
     /* 1779615 */   // Label 24213: @1779615
     /* 1779615 */   GIM_Try, /*On fail goto*//*Label 24214*/ GIMT_Encode4(1779701), // Rule ID 11897 //
     /* 1779620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1779631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1779634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1779637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1779640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1779650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1779662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779666 */     // MIs[0] policy
     /* 1779666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1779679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779700 */     // GIR_Coverage, 11897,
     /* 1779700 */     GIR_EraseRootFromParent_Done,
     /* 1779701 */   // Label 24214: @1779701
     /* 1779701 */   GIM_Try, /*On fail goto*//*Label 24215*/ GIMT_Encode4(1779787), // Rule ID 11900 //
     /* 1779706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1779717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1779720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1779723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1779726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779752 */     // MIs[0] policy
     /* 1779752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779762 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1779765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779786 */     // GIR_Coverage, 11900,
     /* 1779786 */     GIR_EraseRootFromParent_Done,
     /* 1779787 */   // Label 24215: @1779787
     /* 1779787 */   GIM_Try, /*On fail goto*//*Label 24216*/ GIMT_Encode4(1779873), // Rule ID 11901 //
     /* 1779792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1779803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1779806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1779809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1779812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1779815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1779822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1779834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779838 */     // MIs[0] policy
     /* 1779838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779848 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1779851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779872 */     // GIR_Coverage, 11901,
     /* 1779872 */     GIR_EraseRootFromParent_Done,
     /* 1779873 */   // Label 24216: @1779873
     /* 1779873 */   GIM_Try, /*On fail goto*//*Label 24217*/ GIMT_Encode4(1779959), // Rule ID 11904 //
     /* 1779878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1779889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1779892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1779895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1779898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779924 */     // MIs[0] policy
     /* 1779924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1779937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779958 */     // GIR_Coverage, 11904,
     /* 1779958 */     GIR_EraseRootFromParent_Done,
     /* 1779959 */   // Label 24217: @1779959
     /* 1779959 */   GIM_Try, /*On fail goto*//*Label 24218*/ GIMT_Encode4(1780045), // Rule ID 11905 //
     /* 1779964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1779972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1779975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1779978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1779981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1779984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780010 */     // MIs[0] policy
     /* 1780010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1780023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780044 */     // GIR_Coverage, 11905,
     /* 1780044 */     GIR_EraseRootFromParent_Done,
     /* 1780045 */   // Label 24218: @1780045
     /* 1780045 */   GIM_Try, /*On fail goto*//*Label 24219*/ GIMT_Encode4(1780131), // Rule ID 11908 //
     /* 1780050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1780070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780096 */     // MIs[0] policy
     /* 1780096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1780109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780130 */     // GIR_Coverage, 11908,
     /* 1780130 */     GIR_EraseRootFromParent_Done,
     /* 1780131 */   // Label 24219: @1780131
     /* 1780131 */   GIM_Try, /*On fail goto*//*Label 24220*/ GIMT_Encode4(1780217), // Rule ID 11909 //
     /* 1780136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1780147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1780150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1780153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1780156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780182 */     // MIs[0] policy
     /* 1780182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1780195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780216 */     // GIR_Coverage, 11909,
     /* 1780216 */     GIR_EraseRootFromParent_Done,
     /* 1780217 */   // Label 24220: @1780217
     /* 1780217 */   GIM_Try, /*On fail goto*//*Label 24221*/ GIMT_Encode4(1780303), // Rule ID 11912 //
     /* 1780222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1780242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780268 */     // MIs[0] policy
     /* 1780268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780278 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1780281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780302 */     // GIR_Coverage, 11912,
     /* 1780302 */     GIR_EraseRootFromParent_Done,
     /* 1780303 */   // Label 24221: @1780303
     /* 1780303 */   GIM_Try, /*On fail goto*//*Label 24222*/ GIMT_Encode4(1780389), // Rule ID 11913 //
     /* 1780308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1780319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1780322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1780325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1780328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780354 */     // MIs[0] policy
     /* 1780354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1780367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780388 */     // GIR_Coverage, 11913,
     /* 1780388 */     GIR_EraseRootFromParent_Done,
     /* 1780389 */   // Label 24222: @1780389
     /* 1780389 */   GIM_Try, /*On fail goto*//*Label 24223*/ GIMT_Encode4(1780475), // Rule ID 11916 //
     /* 1780394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1780414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780440 */     // MIs[0] policy
     /* 1780440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1780453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780474 */     // GIR_Coverage, 11916,
     /* 1780474 */     GIR_EraseRootFromParent_Done,
     /* 1780475 */   // Label 24223: @1780475
     /* 1780475 */   GIM_Try, /*On fail goto*//*Label 24224*/ GIMT_Encode4(1780561), // Rule ID 11917 //
     /* 1780480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1780491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1780494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1780497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1780500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1780503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780526 */     // MIs[0] policy
     /* 1780526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1780539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780560 */     // GIR_Coverage, 11917,
     /* 1780560 */     GIR_EraseRootFromParent_Done,
     /* 1780561 */   // Label 24224: @1780561
     /* 1780561 */   GIM_Try, /*On fail goto*//*Label 24225*/ GIMT_Encode4(1780647), // Rule ID 11920 //
     /* 1780566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1780577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1780580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1780583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1780586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780612 */     // MIs[0] policy
     /* 1780612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780622 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1780625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780646 */     // GIR_Coverage, 11920,
     /* 1780646 */     GIR_EraseRootFromParent_Done,
     /* 1780647 */   // Label 24225: @1780647
     /* 1780647 */   GIM_Try, /*On fail goto*//*Label 24226*/ GIMT_Encode4(1780733), // Rule ID 11921 //
     /* 1780652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1780663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1780666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1780669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1780672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780698 */     // MIs[0] policy
     /* 1780698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780708 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1780711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780732 */     // GIR_Coverage, 11921,
     /* 1780732 */     GIR_EraseRootFromParent_Done,
     /* 1780733 */   // Label 24226: @1780733
     /* 1780733 */   GIM_Try, /*On fail goto*//*Label 24227*/ GIMT_Encode4(1780819), // Rule ID 11924 //
     /* 1780738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1780741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1780749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1780752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1780755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1780758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780784 */     // MIs[0] policy
     /* 1780784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1780797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780818 */     // GIR_Coverage, 11924,
     /* 1780818 */     GIR_EraseRootFromParent_Done,
     /* 1780819 */   // Label 24227: @1780819
     /* 1780819 */   GIM_Try, /*On fail goto*//*Label 24228*/ GIMT_Encode4(1780905), // Rule ID 11925 //
     /* 1780824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1780827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1780835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1780838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1780841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1780844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780870 */     // MIs[0] policy
     /* 1780870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780880 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1780883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1780901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780904 */     // GIR_Coverage, 11925,
     /* 1780904 */     GIR_EraseRootFromParent_Done,
     /* 1780905 */   // Label 24228: @1780905
     /* 1780905 */   GIM_Try, /*On fail goto*//*Label 24229*/ GIMT_Encode4(1780991), // Rule ID 11928 //
     /* 1780910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1780918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1780921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1780924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1780927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1780930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1780933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1780940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1780948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1780952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780956 */     // MIs[0] policy
     /* 1780956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780966 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1780969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780990 */     // GIR_Coverage, 11928,
     /* 1780990 */     GIR_EraseRootFromParent_Done,
     /* 1780991 */   // Label 24229: @1780991
     /* 1780991 */   GIM_Try, /*On fail goto*//*Label 24230*/ GIMT_Encode4(1781077), // Rule ID 11929 //
     /* 1780996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1781007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1781010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1781013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781042 */     // MIs[0] policy
     /* 1781042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1781055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781076 */     // GIR_Coverage, 11929,
     /* 1781076 */     GIR_EraseRootFromParent_Done,
     /* 1781077 */   // Label 24230: @1781077
     /* 1781077 */   GIM_Try, /*On fail goto*//*Label 24231*/ GIMT_Encode4(1781163), // Rule ID 11932 //
     /* 1781082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781128 */     // MIs[0] policy
     /* 1781128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781138 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1781141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781162 */     // GIR_Coverage, 11932,
     /* 1781162 */     GIR_EraseRootFromParent_Done,
     /* 1781163 */   // Label 24231: @1781163
     /* 1781163 */   GIM_Try, /*On fail goto*//*Label 24232*/ GIMT_Encode4(1781249), // Rule ID 11933 //
     /* 1781168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1781179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1781182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1781185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781214 */     // MIs[0] policy
     /* 1781214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781224 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1781227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781248 */     // GIR_Coverage, 11933,
     /* 1781248 */     GIR_EraseRootFromParent_Done,
     /* 1781249 */   // Label 24232: @1781249
     /* 1781249 */   GIM_Try, /*On fail goto*//*Label 24233*/ GIMT_Encode4(1781335), // Rule ID 11936 //
     /* 1781254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781300 */     // MIs[0] policy
     /* 1781300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781310 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1781313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781334 */     // GIR_Coverage, 11936,
     /* 1781334 */     GIR_EraseRootFromParent_Done,
     /* 1781335 */   // Label 24233: @1781335
     /* 1781335 */   GIM_Try, /*On fail goto*//*Label 24234*/ GIMT_Encode4(1781421), // Rule ID 11937 //
     /* 1781340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1781351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1781354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1781357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781386 */     // MIs[0] policy
     /* 1781386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1781399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781420 */     // GIR_Coverage, 11937,
     /* 1781420 */     GIR_EraseRootFromParent_Done,
     /* 1781421 */   // Label 24234: @1781421
     /* 1781421 */   GIM_Try, /*On fail goto*//*Label 24235*/ GIMT_Encode4(1781507), // Rule ID 11940 //
     /* 1781426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1781440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1781443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781472 */     // MIs[0] policy
     /* 1781472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781482 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1781485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781506 */     // GIR_Coverage, 11940,
     /* 1781506 */     GIR_EraseRootFromParent_Done,
     /* 1781507 */   // Label 24235: @1781507
     /* 1781507 */   GIM_Try, /*On fail goto*//*Label 24236*/ GIMT_Encode4(1781593), // Rule ID 11941 //
     /* 1781512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1781523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1781526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1781529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781558 */     // MIs[0] policy
     /* 1781558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1781571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781592 */     // GIR_Coverage, 11941,
     /* 1781592 */     GIR_EraseRootFromParent_Done,
     /* 1781593 */   // Label 24236: @1781593
     /* 1781593 */   GIM_Try, /*On fail goto*//*Label 24237*/ GIMT_Encode4(1781679), // Rule ID 11944 //
     /* 1781598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1781609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1781612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1781615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781644 */     // MIs[0] policy
     /* 1781644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781654 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1781657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781678 */     // GIR_Coverage, 11944,
     /* 1781678 */     GIR_EraseRootFromParent_Done,
     /* 1781679 */   // Label 24237: @1781679
     /* 1781679 */   GIM_Try, /*On fail goto*//*Label 24238*/ GIMT_Encode4(1781765), // Rule ID 11945 //
     /* 1781684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1781695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1781698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1781701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781730 */     // MIs[0] policy
     /* 1781730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781740 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1781743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1781761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781764 */     // GIR_Coverage, 11945,
     /* 1781764 */     GIR_EraseRootFromParent_Done,
     /* 1781765 */   // Label 24238: @1781765
     /* 1781765 */   GIM_Try, /*On fail goto*//*Label 24239*/ GIMT_Encode4(1781851), // Rule ID 11948 //
     /* 1781770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1781781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1781784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1781787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781816 */     // MIs[0] policy
     /* 1781816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781826 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1781829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781850 */     // GIR_Coverage, 11948,
     /* 1781850 */     GIR_EraseRootFromParent_Done,
     /* 1781851 */   // Label 24239: @1781851
     /* 1781851 */   GIM_Try, /*On fail goto*//*Label 24240*/ GIMT_Encode4(1781937), // Rule ID 11949 //
     /* 1781856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1781867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1781870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1781873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781902 */     // MIs[0] policy
     /* 1781902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1781915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781936 */     // GIR_Coverage, 11949,
     /* 1781936 */     GIR_EraseRootFromParent_Done,
     /* 1781937 */   // Label 24240: @1781937
     /* 1781937 */   GIM_Try, /*On fail goto*//*Label 24241*/ GIMT_Encode4(1782023), // Rule ID 11952 //
     /* 1781942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1781950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1781953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1781956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1781959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781988 */     // MIs[0] policy
     /* 1781988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781998 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1782001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782022 */     // GIR_Coverage, 11952,
     /* 1782022 */     GIR_EraseRootFromParent_Done,
     /* 1782023 */   // Label 24241: @1782023
     /* 1782023 */   GIM_Try, /*On fail goto*//*Label 24242*/ GIMT_Encode4(1782109), // Rule ID 11953 //
     /* 1782028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1782039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1782042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1782045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782074 */     // MIs[0] policy
     /* 1782074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11182:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1782087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782108 */     // GIR_Coverage, 11953,
     /* 1782108 */     GIR_EraseRootFromParent_Done,
     /* 1782109 */   // Label 24242: @1782109
     /* 1782109 */   GIM_Try, /*On fail goto*//*Label 24243*/ GIMT_Encode4(1782195), // Rule ID 11956 //
     /* 1782114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782160 */     // MIs[0] policy
     /* 1782160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782170 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1782173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782194 */     // GIR_Coverage, 11956,
     /* 1782194 */     GIR_EraseRootFromParent_Done,
     /* 1782195 */   // Label 24243: @1782195
     /* 1782195 */   GIM_Try, /*On fail goto*//*Label 24244*/ GIMT_Encode4(1782281), // Rule ID 11957 //
     /* 1782200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1782211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1782214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1782217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782246 */     // MIs[0] policy
     /* 1782246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1782259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782280 */     // GIR_Coverage, 11957,
     /* 1782280 */     GIR_EraseRootFromParent_Done,
     /* 1782281 */   // Label 24244: @1782281
     /* 1782281 */   GIM_Try, /*On fail goto*//*Label 24245*/ GIMT_Encode4(1782367), // Rule ID 11960 //
     /* 1782286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782332 */     // MIs[0] policy
     /* 1782332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782342 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1782345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782366 */     // GIR_Coverage, 11960,
     /* 1782366 */     GIR_EraseRootFromParent_Done,
     /* 1782367 */   // Label 24245: @1782367
     /* 1782367 */   GIM_Try, /*On fail goto*//*Label 24246*/ GIMT_Encode4(1782453), // Rule ID 11961 //
     /* 1782372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1782383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1782386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1782389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782418 */     // MIs[0] policy
     /* 1782418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1782431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782452 */     // GIR_Coverage, 11961,
     /* 1782452 */     GIR_EraseRootFromParent_Done,
     /* 1782453 */   // Label 24246: @1782453
     /* 1782453 */   GIM_Try, /*On fail goto*//*Label 24247*/ GIMT_Encode4(1782539), // Rule ID 11964 //
     /* 1782458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1782461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1782469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1782472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1782475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782504 */     // MIs[0] policy
     /* 1782504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782514 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1782517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782538 */     // GIR_Coverage, 11964,
     /* 1782538 */     GIR_EraseRootFromParent_Done,
     /* 1782539 */   // Label 24247: @1782539
     /* 1782539 */   GIM_Try, /*On fail goto*//*Label 24248*/ GIMT_Encode4(1782625), // Rule ID 11965 //
     /* 1782544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1782547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1782555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1782558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1782561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782590 */     // MIs[0] policy
     /* 1782590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1782603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1782621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782624 */     // GIR_Coverage, 11965,
     /* 1782624 */     GIR_EraseRootFromParent_Done,
     /* 1782625 */   // Label 24248: @1782625
     /* 1782625 */   GIM_Try, /*On fail goto*//*Label 24249*/ GIMT_Encode4(1782711), // Rule ID 11968 //
     /* 1782630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1782641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1782644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1782647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1782653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1782660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782676 */     // MIs[0] policy
     /* 1782676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782686 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1782689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782710 */     // GIR_Coverage, 11968,
     /* 1782710 */     GIR_EraseRootFromParent_Done,
     /* 1782711 */   // Label 24249: @1782711
     /* 1782711 */   GIM_Try, /*On fail goto*//*Label 24250*/ GIMT_Encode4(1782797), // Rule ID 11969 //
     /* 1782716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1782727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1782730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1782733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1782739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1782746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1782754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782762 */     // MIs[0] policy
     /* 1782762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1782775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782796 */     // GIR_Coverage, 11969,
     /* 1782796 */     GIR_EraseRootFromParent_Done,
     /* 1782797 */   // Label 24250: @1782797
     /* 1782797 */   GIM_Try, /*On fail goto*//*Label 24251*/ GIMT_Encode4(1782883), // Rule ID 11972 //
     /* 1782802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1782813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1782816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1782819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1782825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782848 */     // MIs[0] policy
     /* 1782848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1782861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782882 */     // GIR_Coverage, 11972,
     /* 1782882 */     GIR_EraseRootFromParent_Done,
     /* 1782883 */   // Label 24251: @1782883
     /* 1782883 */   GIM_Try, /*On fail goto*//*Label 24252*/ GIMT_Encode4(1782969), // Rule ID 11973 //
     /* 1782888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1782899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1782902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1782905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1782911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1782918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1782926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782934 */     // MIs[0] policy
     /* 1782934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782944 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1782947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782968 */     // GIR_Coverage, 11973,
     /* 1782968 */     GIR_EraseRootFromParent_Done,
     /* 1782969 */   // Label 24252: @1782969
     /* 1782969 */   GIM_Try, /*On fail goto*//*Label 24253*/ GIMT_Encode4(1783055), // Rule ID 11976 //
     /* 1782974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1782982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1782985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1782988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1782991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1782997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783020 */     // MIs[0] policy
     /* 1783020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783030 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1783033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783054 */     // GIR_Coverage, 11976,
     /* 1783054 */     GIR_EraseRootFromParent_Done,
     /* 1783055 */   // Label 24253: @1783055
     /* 1783055 */   GIM_Try, /*On fail goto*//*Label 24254*/ GIMT_Encode4(1783141), // Rule ID 11977 //
     /* 1783060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1783071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783106 */     // MIs[0] policy
     /* 1783106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783116 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1783119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783140 */     // GIR_Coverage, 11977,
     /* 1783140 */     GIR_EraseRootFromParent_Done,
     /* 1783141 */   // Label 24254: @1783141
     /* 1783141 */   GIM_Try, /*On fail goto*//*Label 24255*/ GIMT_Encode4(1783227), // Rule ID 11980 //
     /* 1783146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783192 */     // MIs[0] policy
     /* 1783192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783202 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1783205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783226 */     // GIR_Coverage, 11980,
     /* 1783226 */     GIR_EraseRootFromParent_Done,
     /* 1783227 */   // Label 24255: @1783227
     /* 1783227 */   GIM_Try, /*On fail goto*//*Label 24256*/ GIMT_Encode4(1783313), // Rule ID 11981 //
     /* 1783232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1783243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1783246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1783249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783278 */     // MIs[0] policy
     /* 1783278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1783291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783312 */     // GIR_Coverage, 11981,
     /* 1783312 */     GIR_EraseRootFromParent_Done,
     /* 1783313 */   // Label 24256: @1783313
     /* 1783313 */   GIM_Try, /*On fail goto*//*Label 24257*/ GIMT_Encode4(1783399), // Rule ID 11984 //
     /* 1783318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783364 */     // MIs[0] policy
     /* 1783364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783374 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1783377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783398 */     // GIR_Coverage, 11984,
     /* 1783398 */     GIR_EraseRootFromParent_Done,
     /* 1783399 */   // Label 24257: @1783399
     /* 1783399 */   GIM_Try, /*On fail goto*//*Label 24258*/ GIMT_Encode4(1783485), // Rule ID 11985 //
     /* 1783404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1783415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1783418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1783421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783450 */     // MIs[0] policy
     /* 1783450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1783463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783484 */     // GIR_Coverage, 11985,
     /* 1783484 */     GIR_EraseRootFromParent_Done,
     /* 1783485 */   // Label 24258: @1783485
     /* 1783485 */   GIM_Try, /*On fail goto*//*Label 24259*/ GIMT_Encode4(1783571), // Rule ID 11988 //
     /* 1783490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1783501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1783504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1783507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783536 */     // MIs[0] policy
     /* 1783536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783546 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1783549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783570 */     // GIR_Coverage, 11988,
     /* 1783570 */     GIR_EraseRootFromParent_Done,
     /* 1783571 */   // Label 24259: @1783571
     /* 1783571 */   GIM_Try, /*On fail goto*//*Label 24260*/ GIMT_Encode4(1783657), // Rule ID 11989 //
     /* 1783576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1783587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1783590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1783593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783622 */     // MIs[0] policy
     /* 1783622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783632 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1783635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783656 */     // GIR_Coverage, 11989,
     /* 1783656 */     GIR_EraseRootFromParent_Done,
     /* 1783657 */   // Label 24260: @1783657
     /* 1783657 */   GIM_Try, /*On fail goto*//*Label 24261*/ GIMT_Encode4(1783743), // Rule ID 11992 //
     /* 1783662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1783673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1783676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1783679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783708 */     // MIs[0] policy
     /* 1783708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783718 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1783721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783742 */     // GIR_Coverage, 11992,
     /* 1783742 */     GIR_EraseRootFromParent_Done,
     /* 1783743 */   // Label 24261: @1783743
     /* 1783743 */   GIM_Try, /*On fail goto*//*Label 24262*/ GIMT_Encode4(1783829), // Rule ID 11993 //
     /* 1783748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1783759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1783762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1783765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783794 */     // MIs[0] policy
     /* 1783794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1783807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783828 */     // GIR_Coverage, 11993,
     /* 1783828 */     GIR_EraseRootFromParent_Done,
     /* 1783829 */   // Label 24262: @1783829
     /* 1783829 */   GIM_Try, /*On fail goto*//*Label 24263*/ GIMT_Encode4(1783915), // Rule ID 11996 //
     /* 1783834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1783845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1783848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1783851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783880 */     // MIs[0] policy
     /* 1783880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783890 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1783893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783914 */     // GIR_Coverage, 11996,
     /* 1783914 */     GIR_EraseRootFromParent_Done,
     /* 1783915 */   // Label 24263: @1783915
     /* 1783915 */   GIM_Try, /*On fail goto*//*Label 24264*/ GIMT_Encode4(1784001), // Rule ID 11997 //
     /* 1783920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1783928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1783931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1783934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1783937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783966 */     // MIs[0] policy
     /* 1783966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1783979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784000 */     // GIR_Coverage, 11997,
     /* 1784000 */     GIR_EraseRootFromParent_Done,
     /* 1784001 */   // Label 24264: @1784001
     /* 1784001 */   GIM_Try, /*On fail goto*//*Label 24265*/ GIMT_Encode4(1784087), // Rule ID 12000 //
     /* 1784006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784052 */     // MIs[0] policy
     /* 1784052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1784065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784086 */     // GIR_Coverage, 12000,
     /* 1784086 */     GIR_EraseRootFromParent_Done,
     /* 1784087 */   // Label 24265: @1784087
     /* 1784087 */   GIM_Try, /*On fail goto*//*Label 24266*/ GIMT_Encode4(1784173), // Rule ID 12001 //
     /* 1784092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1784106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1784109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784138 */     // MIs[0] policy
     /* 1784138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784148 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1784151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784172 */     // GIR_Coverage, 12001,
     /* 1784172 */     GIR_EraseRootFromParent_Done,
     /* 1784173 */   // Label 24266: @1784173
     /* 1784173 */   GIM_Try, /*On fail goto*//*Label 24267*/ GIMT_Encode4(1784259), // Rule ID 12004 //
     /* 1784178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784224 */     // MIs[0] policy
     /* 1784224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1784237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784258 */     // GIR_Coverage, 12004,
     /* 1784258 */     GIR_EraseRootFromParent_Done,
     /* 1784259 */   // Label 24267: @1784259
     /* 1784259 */   GIM_Try, /*On fail goto*//*Label 24268*/ GIMT_Encode4(1784345), // Rule ID 12005 //
     /* 1784264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1784275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1784278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1784281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784310 */     // MIs[0] policy
     /* 1784310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1784323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784344 */     // GIR_Coverage, 12005,
     /* 1784344 */     GIR_EraseRootFromParent_Done,
     /* 1784345 */   // Label 24268: @1784345
     /* 1784345 */   GIM_Try, /*On fail goto*//*Label 24269*/ GIMT_Encode4(1784431), // Rule ID 12008 //
     /* 1784350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784396 */     // MIs[0] policy
     /* 1784396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1784409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784430 */     // GIR_Coverage, 12008,
     /* 1784430 */     GIR_EraseRootFromParent_Done,
     /* 1784431 */   // Label 24269: @1784431
     /* 1784431 */   GIM_Try, /*On fail goto*//*Label 24270*/ GIMT_Encode4(1784517), // Rule ID 12009 //
     /* 1784436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1784447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1784450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1784453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784482 */     // MIs[0] policy
     /* 1784482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784492 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1784495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784516 */     // GIR_Coverage, 12009,
     /* 1784516 */     GIR_EraseRootFromParent_Done,
     /* 1784517 */   // Label 24270: @1784517
     /* 1784517 */   GIM_Try, /*On fail goto*//*Label 24271*/ GIMT_Encode4(1784603), // Rule ID 12012 //
     /* 1784522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1784525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1784533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1784536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1784539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784568 */     // MIs[0] policy
     /* 1784568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784578 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1784581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784602 */     // GIR_Coverage, 12012,
     /* 1784602 */     GIR_EraseRootFromParent_Done,
     /* 1784603 */   // Label 24271: @1784603
     /* 1784603 */   GIM_Try, /*On fail goto*//*Label 24272*/ GIMT_Encode4(1784689), // Rule ID 12013 //
     /* 1784608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1784611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1784616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1784619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1784622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1784625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784654 */     // MIs[0] policy
     /* 1784654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784664 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1784667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1784685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784688 */     // GIR_Coverage, 12013,
     /* 1784688 */     GIR_EraseRootFromParent_Done,
     /* 1784689 */   // Label 24272: @1784689
     /* 1784689 */   GIM_Try, /*On fail goto*//*Label 24273*/ GIMT_Encode4(1784775), // Rule ID 12016 //
     /* 1784694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1784705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1784708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1784711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1784714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784740 */     // MIs[0] policy
     /* 1784740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784750 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1784753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784774 */     // GIR_Coverage, 12016,
     /* 1784774 */     GIR_EraseRootFromParent_Done,
     /* 1784775 */   // Label 24273: @1784775
     /* 1784775 */   GIM_Try, /*On fail goto*//*Label 24274*/ GIMT_Encode4(1784861), // Rule ID 12017 //
     /* 1784780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1784791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1784794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1784797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1784800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1784803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784826 */     // MIs[0] policy
     /* 1784826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784836 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1784839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784860 */     // GIR_Coverage, 12017,
     /* 1784860 */     GIR_EraseRootFromParent_Done,
     /* 1784861 */   // Label 24274: @1784861
     /* 1784861 */   GIM_Try, /*On fail goto*//*Label 24275*/ GIMT_Encode4(1784947), // Rule ID 12020 //
     /* 1784866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1784877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1784880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1784883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1784886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784912 */     // MIs[0] policy
     /* 1784912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784922 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1784925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784946 */     // GIR_Coverage, 12020,
     /* 1784946 */     GIR_EraseRootFromParent_Done,
     /* 1784947 */   // Label 24275: @1784947
     /* 1784947 */   GIM_Try, /*On fail goto*//*Label 24276*/ GIMT_Encode4(1785033), // Rule ID 12021 //
     /* 1784952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1784963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1784966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1784969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1784972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1784975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1784982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1784994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784998 */     // MIs[0] policy
     /* 1784998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785008 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1785011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785032 */     // GIR_Coverage, 12021,
     /* 1785032 */     GIR_EraseRootFromParent_Done,
     /* 1785033 */   // Label 24276: @1785033
     /* 1785033 */   GIM_Try, /*On fail goto*//*Label 24277*/ GIMT_Encode4(1785119), // Rule ID 12024 //
     /* 1785038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1785058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785084 */     // MIs[0] policy
     /* 1785084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785094 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1785097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785118 */     // GIR_Coverage, 12024,
     /* 1785118 */     GIR_EraseRootFromParent_Done,
     /* 1785119 */   // Label 24277: @1785119
     /* 1785119 */   GIM_Try, /*On fail goto*//*Label 24278*/ GIMT_Encode4(1785205), // Rule ID 12025 //
     /* 1785124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1785135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1785138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1785141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1785144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785170 */     // MIs[0] policy
     /* 1785170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1785183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785204 */     // GIR_Coverage, 12025,
     /* 1785204 */     GIR_EraseRootFromParent_Done,
     /* 1785205 */   // Label 24278: @1785205
     /* 1785205 */   GIM_Try, /*On fail goto*//*Label 24279*/ GIMT_Encode4(1785291), // Rule ID 12028 //
     /* 1785210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1785230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785256 */     // MIs[0] policy
     /* 1785256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1785269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785290 */     // GIR_Coverage, 12028,
     /* 1785290 */     GIR_EraseRootFromParent_Done,
     /* 1785291 */   // Label 24279: @1785291
     /* 1785291 */   GIM_Try, /*On fail goto*//*Label 24280*/ GIMT_Encode4(1785377), // Rule ID 12029 //
     /* 1785296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1785307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1785310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1785313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1785316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785342 */     // MIs[0] policy
     /* 1785342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785352 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1785355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785376 */     // GIR_Coverage, 12029,
     /* 1785376 */     GIR_EraseRootFromParent_Done,
     /* 1785377 */   // Label 24280: @1785377
     /* 1785377 */   GIM_Try, /*On fail goto*//*Label 24281*/ GIMT_Encode4(1785463), // Rule ID 12032 //
     /* 1785382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1785402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785428 */     // MIs[0] policy
     /* 1785428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785438 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1785441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785462 */     // GIR_Coverage, 12032,
     /* 1785462 */     GIR_EraseRootFromParent_Done,
     /* 1785463 */   // Label 24281: @1785463
     /* 1785463 */   GIM_Try, /*On fail goto*//*Label 24282*/ GIMT_Encode4(1785549), // Rule ID 12033 //
     /* 1785468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1785479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1785482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1785485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1785488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785514 */     // MIs[0] policy
     /* 1785514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1785527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785548 */     // GIR_Coverage, 12033,
     /* 1785548 */     GIR_EraseRootFromParent_Done,
     /* 1785549 */   // Label 24282: @1785549
     /* 1785549 */   GIM_Try, /*On fail goto*//*Label 24283*/ GIMT_Encode4(1785635), // Rule ID 12036 //
     /* 1785554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1785565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1785568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1785571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1785574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785600 */     // MIs[0] policy
     /* 1785600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785610 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1785613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785634 */     // GIR_Coverage, 12036,
     /* 1785634 */     GIR_EraseRootFromParent_Done,
     /* 1785635 */   // Label 24283: @1785635
     /* 1785635 */   GIM_Try, /*On fail goto*//*Label 24284*/ GIMT_Encode4(1785721), // Rule ID 12037 //
     /* 1785640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1785651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1785654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1785657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1785660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785686 */     // MIs[0] policy
     /* 1785686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785696 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1785699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785720 */     // GIR_Coverage, 12037,
     /* 1785720 */     GIR_EraseRootFromParent_Done,
     /* 1785721 */   // Label 24284: @1785721
     /* 1785721 */   GIM_Try, /*On fail goto*//*Label 24285*/ GIMT_Encode4(1785807), // Rule ID 12040 //
     /* 1785726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1785737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1785740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1785743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1785746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785772 */     // MIs[0] policy
     /* 1785772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785782 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1785785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785806 */     // GIR_Coverage, 12040,
     /* 1785806 */     GIR_EraseRootFromParent_Done,
     /* 1785807 */   // Label 24285: @1785807
     /* 1785807 */   GIM_Try, /*On fail goto*//*Label 24286*/ GIMT_Encode4(1785893), // Rule ID 12041 //
     /* 1785812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1785823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1785826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1785829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1785832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785858 */     // MIs[0] policy
     /* 1785858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785868 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1785871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785892 */     // GIR_Coverage, 12041,
     /* 1785892 */     GIR_EraseRootFromParent_Done,
     /* 1785893 */   // Label 24286: @1785893
     /* 1785893 */   GIM_Try, /*On fail goto*//*Label 24287*/ GIMT_Encode4(1785979), // Rule ID 12044 //
     /* 1785898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1785909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1785912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1785915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1785918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785944 */     // MIs[0] policy
     /* 1785944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785954 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1785957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1785975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785978 */     // GIR_Coverage, 12044,
     /* 1785978 */     GIR_EraseRootFromParent_Done,
     /* 1785979 */   // Label 24287: @1785979
     /* 1785979 */   GIM_Try, /*On fail goto*//*Label 24288*/ GIMT_Encode4(1786065), // Rule ID 12045 //
     /* 1785984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1785995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1785998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1786001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1786004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786030 */     // MIs[0] policy
     /* 1786030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1786043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786064 */     // GIR_Coverage, 12045,
     /* 1786064 */     GIR_EraseRootFromParent_Done,
     /* 1786065 */   // Label 24288: @1786065
     /* 1786065 */   GIM_Try, /*On fail goto*//*Label 24289*/ GIMT_Encode4(1786151), // Rule ID 12048 //
     /* 1786070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1786090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786116 */     // MIs[0] policy
     /* 1786116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786126 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1786129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786150 */     // GIR_Coverage, 12048,
     /* 1786150 */     GIR_EraseRootFromParent_Done,
     /* 1786151 */   // Label 24289: @1786151
     /* 1786151 */   GIM_Try, /*On fail goto*//*Label 24290*/ GIMT_Encode4(1786237), // Rule ID 12049 //
     /* 1786156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1786167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1786170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1786173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1786176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786202 */     // MIs[0] policy
     /* 1786202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786212 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1786215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786236 */     // GIR_Coverage, 12049,
     /* 1786236 */     GIR_EraseRootFromParent_Done,
     /* 1786237 */   // Label 24290: @1786237
     /* 1786237 */   GIM_Try, /*On fail goto*//*Label 24291*/ GIMT_Encode4(1786323), // Rule ID 12052 //
     /* 1786242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1786245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1786262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786288 */     // MIs[0] policy
     /* 1786288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786298 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1786301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786322 */     // GIR_Coverage, 12052,
     /* 1786322 */     GIR_EraseRootFromParent_Done,
     /* 1786323 */   // Label 24291: @1786323
     /* 1786323 */   GIM_Try, /*On fail goto*//*Label 24292*/ GIMT_Encode4(1786409), // Rule ID 12053 //
     /* 1786328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1786331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1786339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1786342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1786345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1786348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786374 */     // MIs[0] policy
     /* 1786374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1786387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1786405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786408 */     // GIR_Coverage, 12053,
     /* 1786408 */     GIR_EraseRootFromParent_Done,
     /* 1786409 */   // Label 24292: @1786409
     /* 1786409 */   GIM_Try, /*On fail goto*//*Label 24293*/ GIMT_Encode4(1786495), // Rule ID 12056 //
     /* 1786414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1786434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786460 */     // MIs[0] policy
     /* 1786460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786470 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1786473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786494 */     // GIR_Coverage, 12056,
     /* 1786494 */     GIR_EraseRootFromParent_Done,
     /* 1786495 */   // Label 24293: @1786495
     /* 1786495 */   GIM_Try, /*On fail goto*//*Label 24294*/ GIMT_Encode4(1786581), // Rule ID 12057 //
     /* 1786500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1786511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1786514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1786517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1786520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1786523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786546 */     // MIs[0] policy
     /* 1786546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1786559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786580 */     // GIR_Coverage, 12057,
     /* 1786580 */     GIR_EraseRootFromParent_Done,
     /* 1786581 */   // Label 24294: @1786581
     /* 1786581 */   GIM_Try, /*On fail goto*//*Label 24295*/ GIMT_Encode4(1786667), // Rule ID 12060 //
     /* 1786586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1786597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1786600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1786603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1786606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1786609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1786616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786632 */     // MIs[0] policy
     /* 1786632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786642 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1786645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786666 */     // GIR_Coverage, 12060,
     /* 1786666 */     GIR_EraseRootFromParent_Done,
     /* 1786667 */   // Label 24295: @1786667
     /* 1786667 */   GIM_Try, /*On fail goto*//*Label 24296*/ GIMT_Encode4(1786753), // Rule ID 12061 //
     /* 1786672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1786683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1786686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1786689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1786692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1786695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1786702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1786714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786718 */     // MIs[0] policy
     /* 1786718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786728 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1786731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786752 */     // GIR_Coverage, 12061,
     /* 1786752 */     GIR_EraseRootFromParent_Done,
     /* 1786753 */   // Label 24296: @1786753
     /* 1786753 */   GIM_Try, /*On fail goto*//*Label 24297*/ GIMT_Encode4(1786839), // Rule ID 12064 //
     /* 1786758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1786769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1786772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1786775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1786778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1786781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786804 */     // MIs[0] policy
     /* 1786804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786814 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1786817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786838 */     // GIR_Coverage, 12064,
     /* 1786838 */     GIR_EraseRootFromParent_Done,
     /* 1786839 */   // Label 24297: @1786839
     /* 1786839 */   GIM_Try, /*On fail goto*//*Label 24298*/ GIMT_Encode4(1786925), // Rule ID 12065 //
     /* 1786844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1786855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1786858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1786861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1786864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1786867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1786874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1786886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786890 */     // MIs[0] policy
     /* 1786890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786900 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1786903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786924 */     // GIR_Coverage, 12065,
     /* 1786924 */     GIR_EraseRootFromParent_Done,
     /* 1786925 */   // Label 24298: @1786925
     /* 1786925 */   GIM_Try, /*On fail goto*//*Label 24299*/ GIMT_Encode4(1787011), // Rule ID 12068 //
     /* 1786930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1786938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1786941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1786944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1786947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1786950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1786960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1786972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786976 */     // MIs[0] policy
     /* 1786976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1786989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787010 */     // GIR_Coverage, 12068,
     /* 1787010 */     GIR_EraseRootFromParent_Done,
     /* 1787011 */   // Label 24299: @1787011
     /* 1787011 */   GIM_Try, /*On fail goto*//*Label 24300*/ GIMT_Encode4(1787097), // Rule ID 12069 //
     /* 1787016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1787027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1787030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1787033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1787036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787062 */     // MIs[0] policy
     /* 1787062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1787075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787096 */     // GIR_Coverage, 12069,
     /* 1787096 */     GIR_EraseRootFromParent_Done,
     /* 1787097 */   // Label 24300: @1787097
     /* 1787097 */   GIM_Try, /*On fail goto*//*Label 24301*/ GIMT_Encode4(1787183), // Rule ID 12072 //
     /* 1787102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1787122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787148 */     // MIs[0] policy
     /* 1787148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787158 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1787161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787182 */     // GIR_Coverage, 12072,
     /* 1787182 */     GIR_EraseRootFromParent_Done,
     /* 1787183 */   // Label 24301: @1787183
     /* 1787183 */   GIM_Try, /*On fail goto*//*Label 24302*/ GIMT_Encode4(1787269), // Rule ID 12073 //
     /* 1787188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1787199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1787202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1787205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1787208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787234 */     // MIs[0] policy
     /* 1787234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1787247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787268 */     // GIR_Coverage, 12073,
     /* 1787268 */     GIR_EraseRootFromParent_Done,
     /* 1787269 */   // Label 24302: @1787269
     /* 1787269 */   GIM_Try, /*On fail goto*//*Label 24303*/ GIMT_Encode4(1787355), // Rule ID 12076 //
     /* 1787274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1787294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787320 */     // MIs[0] policy
     /* 1787320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787330 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1787333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787354 */     // GIR_Coverage, 12076,
     /* 1787354 */     GIR_EraseRootFromParent_Done,
     /* 1787355 */   // Label 24303: @1787355
     /* 1787355 */   GIM_Try, /*On fail goto*//*Label 24304*/ GIMT_Encode4(1787441), // Rule ID 12077 //
     /* 1787360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1787371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1787374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1787377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1787380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787406 */     // MIs[0] policy
     /* 1787406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787416 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1787419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787440 */     // GIR_Coverage, 12077,
     /* 1787440 */     GIR_EraseRootFromParent_Done,
     /* 1787441 */   // Label 24304: @1787441
     /* 1787441 */   GIM_Try, /*On fail goto*//*Label 24305*/ GIMT_Encode4(1787527), // Rule ID 12080 //
     /* 1787446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1787457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1787460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1787463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1787466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787492 */     // MIs[0] policy
     /* 1787492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1787505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787526 */     // GIR_Coverage, 12080,
     /* 1787526 */     GIR_EraseRootFromParent_Done,
     /* 1787527 */   // Label 24305: @1787527
     /* 1787527 */   GIM_Try, /*On fail goto*//*Label 24306*/ GIMT_Encode4(1787613), // Rule ID 12081 //
     /* 1787532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1787543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1787546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1787549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1787552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1787555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787578 */     // MIs[0] policy
     /* 1787578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1787591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787612 */     // GIR_Coverage, 12081,
     /* 1787612 */     GIR_EraseRootFromParent_Done,
     /* 1787613 */   // Label 24306: @1787613
     /* 1787613 */   GIM_Try, /*On fail goto*//*Label 24307*/ GIMT_Encode4(1787699), // Rule ID 12084 //
     /* 1787618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1787629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1787632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1787635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1787638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787664 */     // MIs[0] policy
     /* 1787664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1787677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787698 */     // GIR_Coverage, 12084,
     /* 1787698 */     GIR_EraseRootFromParent_Done,
     /* 1787699 */   // Label 24307: @1787699
     /* 1787699 */   GIM_Try, /*On fail goto*//*Label 24308*/ GIMT_Encode4(1787785), // Rule ID 12085 //
     /* 1787704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1787715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1787718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1787721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1787724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787750 */     // MIs[0] policy
     /* 1787750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1787763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787784 */     // GIR_Coverage, 12085,
     /* 1787784 */     GIR_EraseRootFromParent_Done,
     /* 1787785 */   // Label 24308: @1787785
     /* 1787785 */   GIM_Try, /*On fail goto*//*Label 24309*/ GIMT_Encode4(1787871), // Rule ID 12088 //
     /* 1787790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1787801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1787804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1787807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1787810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787836 */     // MIs[0] policy
     /* 1787836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787846 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1787849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787870 */     // GIR_Coverage, 12088,
     /* 1787870 */     GIR_EraseRootFromParent_Done,
     /* 1787871 */   // Label 24309: @1787871
     /* 1787871 */   GIM_Try, /*On fail goto*//*Label 24310*/ GIMT_Encode4(1787957), // Rule ID 12089 //
     /* 1787876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1787887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1787890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1787893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1787896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787922 */     // MIs[0] policy
     /* 1787922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1787935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787956 */     // GIR_Coverage, 12089,
     /* 1787956 */     GIR_EraseRootFromParent_Done,
     /* 1787957 */   // Label 24310: @1787957
     /* 1787957 */   GIM_Try, /*On fail goto*//*Label 24311*/ GIMT_Encode4(1788043), // Rule ID 12092 //
     /* 1787962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1787965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1787970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1787973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1787976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1787979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1787982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788008 */     // MIs[0] policy
     /* 1788008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788018 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1788021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788042 */     // GIR_Coverage, 12092,
     /* 1788042 */     GIR_EraseRootFromParent_Done,
     /* 1788043 */   // Label 24311: @1788043
     /* 1788043 */   GIM_Try, /*On fail goto*//*Label 24312*/ GIMT_Encode4(1788129), // Rule ID 12093 //
     /* 1788048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1788059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1788062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1788065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1788068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788094 */     // MIs[0] policy
     /* 1788094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1788107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788128 */     // GIR_Coverage, 12093,
     /* 1788128 */     GIR_EraseRootFromParent_Done,
     /* 1788129 */   // Label 24312: @1788129
     /* 1788129 */   GIM_Try, /*On fail goto*//*Label 24313*/ GIMT_Encode4(1788215), // Rule ID 12096 //
     /* 1788134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1788154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788180 */     // MIs[0] policy
     /* 1788180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1788193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788214 */     // GIR_Coverage, 12096,
     /* 1788214 */     GIR_EraseRootFromParent_Done,
     /* 1788215 */   // Label 24313: @1788215
     /* 1788215 */   GIM_Try, /*On fail goto*//*Label 24314*/ GIMT_Encode4(1788301), // Rule ID 12097 //
     /* 1788220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1788231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1788234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1788237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1788240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788266 */     // MIs[0] policy
     /* 1788266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788276 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1788279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788300 */     // GIR_Coverage, 12097,
     /* 1788300 */     GIR_EraseRootFromParent_Done,
     /* 1788301 */   // Label 24314: @1788301
     /* 1788301 */   GIM_Try, /*On fail goto*//*Label 24315*/ GIMT_Encode4(1788387), // Rule ID 12100 //
     /* 1788306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1788326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788352 */     // MIs[0] policy
     /* 1788352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788362 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1788365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788386 */     // GIR_Coverage, 12100,
     /* 1788386 */     GIR_EraseRootFromParent_Done,
     /* 1788387 */   // Label 24315: @1788387
     /* 1788387 */   GIM_Try, /*On fail goto*//*Label 24316*/ GIMT_Encode4(1788473), // Rule ID 12101 //
     /* 1788392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1788395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1788403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1788406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1788409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1788412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788438 */     // MIs[0] policy
     /* 1788438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788448 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1788451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1788469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788472 */     // GIR_Coverage, 12101,
     /* 1788472 */     GIR_EraseRootFromParent_Done,
     /* 1788473 */   // Label 24316: @1788473
     /* 1788473 */   GIM_Try, /*On fail goto*//*Label 24317*/ GIMT_Encode4(1788559), // Rule ID 12104 //
     /* 1788478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1788489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1788492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1788495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788524 */     // MIs[0] policy
     /* 1788524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788534 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1788537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788558 */     // GIR_Coverage, 12104,
     /* 1788558 */     GIR_EraseRootFromParent_Done,
     /* 1788559 */   // Label 24317: @1788559
     /* 1788559 */   GIM_Try, /*On fail goto*//*Label 24318*/ GIMT_Encode4(1788645), // Rule ID 12105 //
     /* 1788564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1788575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1788578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1788581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1788587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788610 */     // MIs[0] policy
     /* 1788610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788620 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1788623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788644 */     // GIR_Coverage, 12105,
     /* 1788644 */     GIR_EraseRootFromParent_Done,
     /* 1788645 */   // Label 24318: @1788645
     /* 1788645 */   GIM_Try, /*On fail goto*//*Label 24319*/ GIMT_Encode4(1788731), // Rule ID 12108 //
     /* 1788650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1788661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1788664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1788667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788696 */     // MIs[0] policy
     /* 1788696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788706 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1788709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788730 */     // GIR_Coverage, 12108,
     /* 1788730 */     GIR_EraseRootFromParent_Done,
     /* 1788731 */   // Label 24319: @1788731
     /* 1788731 */   GIM_Try, /*On fail goto*//*Label 24320*/ GIMT_Encode4(1788817), // Rule ID 12109 //
     /* 1788736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1788747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1788750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1788753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788782 */     // MIs[0] policy
     /* 1788782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788792 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1788795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788816 */     // GIR_Coverage, 12109,
     /* 1788816 */     GIR_EraseRootFromParent_Done,
     /* 1788817 */   // Label 24320: @1788817
     /* 1788817 */   GIM_Try, /*On fail goto*//*Label 24321*/ GIMT_Encode4(1788903), // Rule ID 12112 //
     /* 1788822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1788833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1788836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1788839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1788842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788868 */     // MIs[0] policy
     /* 1788868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788878 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1788881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788902 */     // GIR_Coverage, 12112,
     /* 1788902 */     GIR_EraseRootFromParent_Done,
     /* 1788903 */   // Label 24321: @1788903
     /* 1788903 */   GIM_Try, /*On fail goto*//*Label 24322*/ GIMT_Encode4(1788989), // Rule ID 12113 //
     /* 1788908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1788916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1788919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1788922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1788925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1788928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1788938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1788946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1788950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788954 */     // MIs[0] policy
     /* 1788954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1788967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1788985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788988 */     // GIR_Coverage, 12113,
     /* 1788988 */     GIR_EraseRootFromParent_Done,
     /* 1788989 */   // Label 24322: @1788989
     /* 1788989 */   GIM_Try, /*On fail goto*//*Label 24323*/ GIMT_Encode4(1789075), // Rule ID 12116 //
     /* 1788994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789040 */     // MIs[0] policy
     /* 1789040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789050 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1789053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789074 */     // GIR_Coverage, 12116,
     /* 1789074 */     GIR_EraseRootFromParent_Done,
     /* 1789075 */   // Label 24323: @1789075
     /* 1789075 */   GIM_Try, /*On fail goto*//*Label 24324*/ GIMT_Encode4(1789161), // Rule ID 12117 //
     /* 1789080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789126 */     // MIs[0] policy
     /* 1789126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789136 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1789139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789160 */     // GIR_Coverage, 12117,
     /* 1789160 */     GIR_EraseRootFromParent_Done,
     /* 1789161 */   // Label 24324: @1789161
     /* 1789161 */   GIM_Try, /*On fail goto*//*Label 24325*/ GIMT_Encode4(1789247), // Rule ID 12120 //
     /* 1789166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789212 */     // MIs[0] policy
     /* 1789212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789222 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1789225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789246 */     // GIR_Coverage, 12120,
     /* 1789246 */     GIR_EraseRootFromParent_Done,
     /* 1789247 */   // Label 24325: @1789247
     /* 1789247 */   GIM_Try, /*On fail goto*//*Label 24326*/ GIMT_Encode4(1789333), // Rule ID 12121 //
     /* 1789252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1789263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1789266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1789269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789298 */     // MIs[0] policy
     /* 1789298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789308 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1789311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789332 */     // GIR_Coverage, 12121,
     /* 1789332 */     GIR_EraseRootFromParent_Done,
     /* 1789333 */   // Label 24326: @1789333
     /* 1789333 */   GIM_Try, /*On fail goto*//*Label 24327*/ GIMT_Encode4(1789419), // Rule ID 12124 //
     /* 1789338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789384 */     // MIs[0] policy
     /* 1789384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1789397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789418 */     // GIR_Coverage, 12124,
     /* 1789418 */     GIR_EraseRootFromParent_Done,
     /* 1789419 */   // Label 24327: @1789419
     /* 1789419 */   GIM_Try, /*On fail goto*//*Label 24328*/ GIMT_Encode4(1789505), // Rule ID 12125 //
     /* 1789424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1789435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1789438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1789441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789470 */     // MIs[0] policy
     /* 1789470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1789483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789504 */     // GIR_Coverage, 12125,
     /* 1789504 */     GIR_EraseRootFromParent_Done,
     /* 1789505 */   // Label 24328: @1789505
     /* 1789505 */   GIM_Try, /*On fail goto*//*Label 24329*/ GIMT_Encode4(1789591), // Rule ID 12128 //
     /* 1789510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1789521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1789524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1789527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789556 */     // MIs[0] policy
     /* 1789556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789566 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1789569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789590 */     // GIR_Coverage, 12128,
     /* 1789590 */     GIR_EraseRootFromParent_Done,
     /* 1789591 */   // Label 24329: @1789591
     /* 1789591 */   GIM_Try, /*On fail goto*//*Label 24330*/ GIMT_Encode4(1789677), // Rule ID 12129 //
     /* 1789596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1789607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1789610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1789613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789642 */     // MIs[0] policy
     /* 1789642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11516:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1789655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789676 */     // GIR_Coverage, 12129,
     /* 1789676 */     GIR_EraseRootFromParent_Done,
     /* 1789677 */   // Label 24330: @1789677
     /* 1789677 */   GIM_Try, /*On fail goto*//*Label 24331*/ GIMT_Encode4(1789763), // Rule ID 12132 //
     /* 1789682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1789693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1789696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1789699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789728 */     // MIs[0] policy
     /* 1789728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789738 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1789741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789762 */     // GIR_Coverage, 12132,
     /* 1789762 */     GIR_EraseRootFromParent_Done,
     /* 1789763 */   // Label 24331: @1789763
     /* 1789763 */   GIM_Try, /*On fail goto*//*Label 24332*/ GIMT_Encode4(1789849), // Rule ID 12133 //
     /* 1789768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1789779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1789782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1789785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789814 */     // MIs[0] policy
     /* 1789814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11516:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1789827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1789845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789848 */     // GIR_Coverage, 12133,
     /* 1789848 */     GIR_EraseRootFromParent_Done,
     /* 1789849 */   // Label 24332: @1789849
     /* 1789849 */   GIM_Try, /*On fail goto*//*Label 24333*/ GIMT_Encode4(1789935), // Rule ID 12136 //
     /* 1789854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1789865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1789868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1789871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789900 */     // MIs[0] policy
     /* 1789900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1789913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1789931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789934 */     // GIR_Coverage, 12136,
     /* 1789934 */     GIR_EraseRootFromParent_Done,
     /* 1789935 */   // Label 24333: @1789935
     /* 1789935 */   GIM_Try, /*On fail goto*//*Label 24334*/ GIMT_Encode4(1790021), // Rule ID 12137 //
     /* 1789940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1789948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1789951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1789954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1789957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789986 */     // MIs[0] policy
     /* 1789986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11516:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1789999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790020 */     // GIR_Coverage, 12137,
     /* 1790020 */     GIR_EraseRootFromParent_Done,
     /* 1790021 */   // Label 24334: @1790021
     /* 1790021 */   GIM_Try, /*On fail goto*//*Label 24335*/ GIMT_Encode4(1790107), // Rule ID 12140 //
     /* 1790026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1790029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790072 */     // MIs[0] policy
     /* 1790072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1790085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790106 */     // GIR_Coverage, 12140,
     /* 1790106 */     GIR_EraseRootFromParent_Done,
     /* 1790107 */   // Label 24335: @1790107
     /* 1790107 */   GIM_Try, /*On fail goto*//*Label 24336*/ GIMT_Encode4(1790193), // Rule ID 12141 //
     /* 1790112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1790115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1790123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1790126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1790129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790158 */     // MIs[0] policy
     /* 1790158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11516:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1790171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1790189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790192 */     // GIR_Coverage, 12141,
     /* 1790192 */     GIR_EraseRootFromParent_Done,
     /* 1790193 */   // Label 24336: @1790193
     /* 1790193 */   GIM_Try, /*On fail goto*//*Label 24337*/ GIMT_Encode4(1790279), // Rule ID 12144 //
     /* 1790198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790244 */     // MIs[0] policy
     /* 1790244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790254 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1790257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790278 */     // GIR_Coverage, 12144,
     /* 1790278 */     GIR_EraseRootFromParent_Done,
     /* 1790279 */   // Label 24337: @1790279
     /* 1790279 */   GIM_Try, /*On fail goto*//*Label 24338*/ GIMT_Encode4(1790365), // Rule ID 12145 //
     /* 1790284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1790295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1790298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1790301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790330 */     // MIs[0] policy
     /* 1790330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1790343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790364 */     // GIR_Coverage, 12145,
     /* 1790364 */     GIR_EraseRootFromParent_Done,
     /* 1790365 */   // Label 24338: @1790365
     /* 1790365 */   GIM_Try, /*On fail goto*//*Label 24339*/ GIMT_Encode4(1790451), // Rule ID 12148 //
     /* 1790370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790416 */     // MIs[0] policy
     /* 1790416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790426 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1790429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790450 */     // GIR_Coverage, 12148,
     /* 1790450 */     GIR_EraseRootFromParent_Done,
     /* 1790451 */   // Label 24339: @1790451
     /* 1790451 */   GIM_Try, /*On fail goto*//*Label 24340*/ GIMT_Encode4(1790537), // Rule ID 12149 //
     /* 1790456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1790467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1790470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1790473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1790479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790502 */     // MIs[0] policy
     /* 1790502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790512 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1790515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790536 */     // GIR_Coverage, 12149,
     /* 1790536 */     GIR_EraseRootFromParent_Done,
     /* 1790537 */   // Label 24340: @1790537
     /* 1790537 */   GIM_Try, /*On fail goto*//*Label 24341*/ GIMT_Encode4(1790623), // Rule ID 12152 //
     /* 1790542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1790553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1790556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1790559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1790565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1790572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790588 */     // MIs[0] policy
     /* 1790588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790598 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1790601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790622 */     // GIR_Coverage, 12152,
     /* 1790622 */     GIR_EraseRootFromParent_Done,
     /* 1790623 */   // Label 24341: @1790623
     /* 1790623 */   GIM_Try, /*On fail goto*//*Label 24342*/ GIMT_Encode4(1790709), // Rule ID 12153 //
     /* 1790628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1790639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1790642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1790645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1790651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1790658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1790666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790674 */     // MIs[0] policy
     /* 1790674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790684 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1790687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790708 */     // GIR_Coverage, 12153,
     /* 1790708 */     GIR_EraseRootFromParent_Done,
     /* 1790709 */   // Label 24342: @1790709
     /* 1790709 */   GIM_Try, /*On fail goto*//*Label 24343*/ GIMT_Encode4(1790795), // Rule ID 12156 //
     /* 1790714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1790725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1790728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1790731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790760 */     // MIs[0] policy
     /* 1790760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790770 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1790773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790794 */     // GIR_Coverage, 12156,
     /* 1790794 */     GIR_EraseRootFromParent_Done,
     /* 1790795 */   // Label 24343: @1790795
     /* 1790795 */   GIM_Try, /*On fail goto*//*Label 24344*/ GIMT_Encode4(1790881), // Rule ID 12157 //
     /* 1790800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1790811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1790814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1790817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1790830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1790838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790846 */     // MIs[0] policy
     /* 1790846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1790859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790880 */     // GIR_Coverage, 12157,
     /* 1790880 */     GIR_EraseRootFromParent_Done,
     /* 1790881 */   // Label 24344: @1790881
     /* 1790881 */   GIM_Try, /*On fail goto*//*Label 24345*/ GIMT_Encode4(1790967), // Rule ID 12160 //
     /* 1790886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1790897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1790900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1790903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1790916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1790924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790932 */     // MIs[0] policy
     /* 1790932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790942 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1790945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790966 */     // GIR_Coverage, 12160,
     /* 1790966 */     GIR_EraseRootFromParent_Done,
     /* 1790967 */   // Label 24345: @1790967
     /* 1790967 */   GIM_Try, /*On fail goto*//*Label 24346*/ GIMT_Encode4(1791053), // Rule ID 12161 //
     /* 1790972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1790980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1790983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1790986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1790989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1790995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791018 */     // MIs[0] policy
     /* 1791018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791028 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1791031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791052 */     // GIR_Coverage, 12161,
     /* 1791052 */     GIR_EraseRootFromParent_Done,
     /* 1791053 */   // Label 24346: @1791053
     /* 1791053 */   GIM_Try, /*On fail goto*//*Label 24347*/ GIMT_Encode4(1791139), // Rule ID 12164 //
     /* 1791058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791104 */     // MIs[0] policy
     /* 1791104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791114 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1791117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791138 */     // GIR_Coverage, 12164,
     /* 1791138 */     GIR_EraseRootFromParent_Done,
     /* 1791139 */   // Label 24347: @1791139
     /* 1791139 */   GIM_Try, /*On fail goto*//*Label 24348*/ GIMT_Encode4(1791225), // Rule ID 12165 //
     /* 1791144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1791155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1791158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1791161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791190 */     // MIs[0] policy
     /* 1791190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791200 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1791203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791224 */     // GIR_Coverage, 12165,
     /* 1791224 */     GIR_EraseRootFromParent_Done,
     /* 1791225 */   // Label 24348: @1791225
     /* 1791225 */   GIM_Try, /*On fail goto*//*Label 24349*/ GIMT_Encode4(1791311), // Rule ID 12168 //
     /* 1791230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791276 */     // MIs[0] policy
     /* 1791276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1791289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791310 */     // GIR_Coverage, 12168,
     /* 1791310 */     GIR_EraseRootFromParent_Done,
     /* 1791311 */   // Label 24349: @1791311
     /* 1791311 */   GIM_Try, /*On fail goto*//*Label 24350*/ GIMT_Encode4(1791397), // Rule ID 12169 //
     /* 1791316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1791327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1791330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1791333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791362 */     // MIs[0] policy
     /* 1791362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1791375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791396 */     // GIR_Coverage, 12169,
     /* 1791396 */     GIR_EraseRootFromParent_Done,
     /* 1791397 */   // Label 24350: @1791397
     /* 1791397 */   GIM_Try, /*On fail goto*//*Label 24351*/ GIMT_Encode4(1791483), // Rule ID 12172 //
     /* 1791402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791448 */     // MIs[0] policy
     /* 1791448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791458 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1791461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791482 */     // GIR_Coverage, 12172,
     /* 1791482 */     GIR_EraseRootFromParent_Done,
     /* 1791483 */   // Label 24351: @1791483
     /* 1791483 */   GIM_Try, /*On fail goto*//*Label 24352*/ GIMT_Encode4(1791569), // Rule ID 12173 //
     /* 1791488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1791499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1791502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1791505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791534 */     // MIs[0] policy
     /* 1791534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791544 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1791547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791568 */     // GIR_Coverage, 12173,
     /* 1791568 */     GIR_EraseRootFromParent_Done,
     /* 1791569 */   // Label 24352: @1791569
     /* 1791569 */   GIM_Try, /*On fail goto*//*Label 24353*/ GIMT_Encode4(1791655), // Rule ID 12176 //
     /* 1791574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1791585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1791588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1791591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791620 */     // MIs[0] policy
     /* 1791620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1791633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791654 */     // GIR_Coverage, 12176,
     /* 1791654 */     GIR_EraseRootFromParent_Done,
     /* 1791655 */   // Label 24353: @1791655
     /* 1791655 */   GIM_Try, /*On fail goto*//*Label 24354*/ GIMT_Encode4(1791741), // Rule ID 12177 //
     /* 1791660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1791671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1791674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1791677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791706 */     // MIs[0] policy
     /* 1791706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791716 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1791719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1791737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791740 */     // GIR_Coverage, 12177,
     /* 1791740 */     GIR_EraseRootFromParent_Done,
     /* 1791741 */   // Label 24354: @1791741
     /* 1791741 */   GIM_Try, /*On fail goto*//*Label 24355*/ GIMT_Encode4(1791827), // Rule ID 12180 //
     /* 1791746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1791749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1791757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1791760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1791763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791792 */     // MIs[0] policy
     /* 1791792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1791805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791826 */     // GIR_Coverage, 12180,
     /* 1791826 */     GIR_EraseRootFromParent_Done,
     /* 1791827 */   // Label 24355: @1791827
     /* 1791827 */   GIM_Try, /*On fail goto*//*Label 24356*/ GIMT_Encode4(1791913), // Rule ID 12181 //
     /* 1791832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1791835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1791843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1791846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1791849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1791855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791878 */     // MIs[0] policy
     /* 1791878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11516:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1791891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791912 */     // GIR_Coverage, 12181,
     /* 1791912 */     GIR_EraseRootFromParent_Done,
     /* 1791913 */   // Label 24356: @1791913
     /* 1791913 */   GIM_Try, /*On fail goto*//*Label 24357*/ GIMT_Encode4(1791999), // Rule ID 12184 //
     /* 1791918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1791921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1791926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1791929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1791932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1791935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1791941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791964 */     // MIs[0] policy
     /* 1791964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791974 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1791977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791998 */     // GIR_Coverage, 12184,
     /* 1791998 */     GIR_EraseRootFromParent_Done,
     /* 1791999 */   // Label 24357: @1791999
     /* 1791999 */   GIM_Try, /*On fail goto*//*Label 24358*/ GIMT_Encode4(1792085), // Rule ID 12185 //
     /* 1792004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1792015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1792018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1792021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792050 */     // MIs[0] policy
     /* 1792050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792060 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11516:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1792063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792084 */     // GIR_Coverage, 12185,
     /* 1792084 */     GIR_EraseRootFromParent_Done,
     /* 1792085 */   // Label 24358: @1792085
     /* 1792085 */   GIM_Try, /*On fail goto*//*Label 24359*/ GIMT_Encode4(1792171), // Rule ID 12188 //
     /* 1792090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792136 */     // MIs[0] policy
     /* 1792136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792146 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1792149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792170 */     // GIR_Coverage, 12188,
     /* 1792170 */     GIR_EraseRootFromParent_Done,
     /* 1792171 */   // Label 24359: @1792171
     /* 1792171 */   GIM_Try, /*On fail goto*//*Label 24360*/ GIMT_Encode4(1792257), // Rule ID 12189 //
     /* 1792176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1792184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1792187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1792190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1792193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792222 */     // MIs[0] policy
     /* 1792222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792232 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11516:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1792235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792256 */     // GIR_Coverage, 12189,
     /* 1792256 */     GIR_EraseRootFromParent_Done,
     /* 1792257 */   // Label 24360: @1792257
     /* 1792257 */   GIM_Try, /*On fail goto*//*Label 24361*/ GIMT_Encode4(1792343), // Rule ID 12192 //
     /* 1792262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1792282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792308 */     // MIs[0] policy
     /* 1792308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792318 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1792321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792342 */     // GIR_Coverage, 12192,
     /* 1792342 */     GIR_EraseRootFromParent_Done,
     /* 1792343 */   // Label 24361: @1792343
     /* 1792343 */   GIM_Try, /*On fail goto*//*Label 24362*/ GIMT_Encode4(1792429), // Rule ID 12193 //
     /* 1792348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1792359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1792362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1792365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1792368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792394 */     // MIs[0] policy
     /* 1792394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792404 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1792407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792428 */     // GIR_Coverage, 12193,
     /* 1792428 */     GIR_EraseRootFromParent_Done,
     /* 1792429 */   // Label 24362: @1792429
     /* 1792429 */   GIM_Try, /*On fail goto*//*Label 24363*/ GIMT_Encode4(1792515), // Rule ID 12196 //
     /* 1792434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1792445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1792448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1792451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1792454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792480 */     // MIs[0] policy
     /* 1792480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792490 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1792493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792514 */     // GIR_Coverage, 12196,
     /* 1792514 */     GIR_EraseRootFromParent_Done,
     /* 1792515 */   // Label 24363: @1792515
     /* 1792515 */   GIM_Try, /*On fail goto*//*Label 24364*/ GIMT_Encode4(1792601), // Rule ID 12197 //
     /* 1792520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1792531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1792534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1792537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1792540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792566 */     // MIs[0] policy
     /* 1792566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792576 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1792579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792600 */     // GIR_Coverage, 12197,
     /* 1792600 */     GIR_EraseRootFromParent_Done,
     /* 1792601 */   // Label 24364: @1792601
     /* 1792601 */   GIM_Try, /*On fail goto*//*Label 24365*/ GIMT_Encode4(1792687), // Rule ID 12200 //
     /* 1792606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1792617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1792620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1792623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1792626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792652 */     // MIs[0] policy
     /* 1792652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792662 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1792665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792686 */     // GIR_Coverage, 12200,
     /* 1792686 */     GIR_EraseRootFromParent_Done,
     /* 1792687 */   // Label 24365: @1792687
     /* 1792687 */   GIM_Try, /*On fail goto*//*Label 24366*/ GIMT_Encode4(1792773), // Rule ID 12201 //
     /* 1792692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1792703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1792706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1792709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1792712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792738 */     // MIs[0] policy
     /* 1792738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792748 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1792751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1792769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792772 */     // GIR_Coverage, 12201,
     /* 1792772 */     GIR_EraseRootFromParent_Done,
     /* 1792773 */   // Label 24366: @1792773
     /* 1792773 */   GIM_Try, /*On fail goto*//*Label 24367*/ GIMT_Encode4(1792859), // Rule ID 12204 //
     /* 1792778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1792789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1792792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1792795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1792798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792824 */     // MIs[0] policy
     /* 1792824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792834 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1792837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792858 */     // GIR_Coverage, 12204,
     /* 1792858 */     GIR_EraseRootFromParent_Done,
     /* 1792859 */   // Label 24367: @1792859
     /* 1792859 */   GIM_Try, /*On fail goto*//*Label 24368*/ GIMT_Encode4(1792945), // Rule ID 12205 //
     /* 1792864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1792875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1792878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1792881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1792884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1792887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792910 */     // MIs[0] policy
     /* 1792910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1792923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792944 */     // GIR_Coverage, 12205,
     /* 1792944 */     GIR_EraseRootFromParent_Done,
     /* 1792945 */   // Label 24368: @1792945
     /* 1792945 */   GIM_Try, /*On fail goto*//*Label 24369*/ GIMT_Encode4(1793031), // Rule ID 12208 //
     /* 1792950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1792961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1792964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1792967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1792970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1792980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1792992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792996 */     // MIs[0] policy
     /* 1792996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793006 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1793009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793030 */     // GIR_Coverage, 12208,
     /* 1793030 */     GIR_EraseRootFromParent_Done,
     /* 1793031 */   // Label 24369: @1793031
     /* 1793031 */   GIM_Try, /*On fail goto*//*Label 24370*/ GIMT_Encode4(1793117), // Rule ID 12209 //
     /* 1793036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1793053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1793056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793082 */     // MIs[0] policy
     /* 1793082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793092 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1793095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793116 */     // GIR_Coverage, 12209,
     /* 1793116 */     GIR_EraseRootFromParent_Done,
     /* 1793117 */   // Label 24370: @1793117
     /* 1793117 */   GIM_Try, /*On fail goto*//*Label 24371*/ GIMT_Encode4(1793203), // Rule ID 12212 //
     /* 1793122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1793142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793168 */     // MIs[0] policy
     /* 1793168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793178 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1793181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793202 */     // GIR_Coverage, 12212,
     /* 1793202 */     GIR_EraseRootFromParent_Done,
     /* 1793203 */   // Label 24371: @1793203
     /* 1793203 */   GIM_Try, /*On fail goto*//*Label 24372*/ GIMT_Encode4(1793289), // Rule ID 12213 //
     /* 1793208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1793219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1793222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1793225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1793228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793254 */     // MIs[0] policy
     /* 1793254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1793267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793288 */     // GIR_Coverage, 12213,
     /* 1793288 */     GIR_EraseRootFromParent_Done,
     /* 1793289 */   // Label 24372: @1793289
     /* 1793289 */   GIM_Try, /*On fail goto*//*Label 24373*/ GIMT_Encode4(1793375), // Rule ID 12216 //
     /* 1793294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793340 */     // MIs[0] policy
     /* 1793340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793350 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1793353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793374 */     // GIR_Coverage, 12216,
     /* 1793374 */     GIR_EraseRootFromParent_Done,
     /* 1793375 */   // Label 24373: @1793375
     /* 1793375 */   GIM_Try, /*On fail goto*//*Label 24374*/ GIMT_Encode4(1793461), // Rule ID 12217 //
     /* 1793380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1793391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1793394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793426 */     // MIs[0] policy
     /* 1793426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1793439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793460 */     // GIR_Coverage, 12217,
     /* 1793460 */     GIR_EraseRootFromParent_Done,
     /* 1793461 */   // Label 24374: @1793461
     /* 1793461 */   GIM_Try, /*On fail goto*//*Label 24375*/ GIMT_Encode4(1793547), // Rule ID 12220 //
     /* 1793466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1793483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1793486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793512 */     // MIs[0] policy
     /* 1793512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793522 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1793525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793546 */     // GIR_Coverage, 12220,
     /* 1793546 */     GIR_EraseRootFromParent_Done,
     /* 1793547 */   // Label 24375: @1793547
     /* 1793547 */   GIM_Try, /*On fail goto*//*Label 24376*/ GIMT_Encode4(1793633), // Rule ID 12221 //
     /* 1793552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1793569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1793572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793598 */     // MIs[0] policy
     /* 1793598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1793611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1793629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793632 */     // GIR_Coverage, 12221,
     /* 1793632 */     GIR_EraseRootFromParent_Done,
     /* 1793633 */   // Label 24376: @1793633
     /* 1793633 */   GIM_Try, /*On fail goto*//*Label 24377*/ GIMT_Encode4(1793719), // Rule ID 12224 //
     /* 1793638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1793649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1793652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1793655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1793658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793684 */     // MIs[0] policy
     /* 1793684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793694 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1793697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793718 */     // GIR_Coverage, 12224,
     /* 1793718 */     GIR_EraseRootFromParent_Done,
     /* 1793719 */   // Label 24377: @1793719
     /* 1793719 */   GIM_Try, /*On fail goto*//*Label 24378*/ GIMT_Encode4(1793805), // Rule ID 12225 //
     /* 1793724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1793735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1793738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1793741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1793744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793770 */     // MIs[0] policy
     /* 1793770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1793783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1793801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793804 */     // GIR_Coverage, 12225,
     /* 1793804 */     GIR_EraseRootFromParent_Done,
     /* 1793805 */   // Label 24378: @1793805
     /* 1793805 */   GIM_Try, /*On fail goto*//*Label 24379*/ GIMT_Encode4(1793891), // Rule ID 12228 //
     /* 1793810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1793813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1793821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1793824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1793827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1793830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793856 */     // MIs[0] policy
     /* 1793856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793866 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1793869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793890 */     // GIR_Coverage, 12228,
     /* 1793890 */     GIR_EraseRootFromParent_Done,
     /* 1793891 */   // Label 24379: @1793891
     /* 1793891 */   GIM_Try, /*On fail goto*//*Label 24380*/ GIMT_Encode4(1793977), // Rule ID 12229 //
     /* 1793896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1793899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1793907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1793910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1793913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1793916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793942 */     // MIs[0] policy
     /* 1793942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1793955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793976 */     // GIR_Coverage, 12229,
     /* 1793976 */     GIR_EraseRootFromParent_Done,
     /* 1793977 */   // Label 24380: @1793977
     /* 1793977 */   GIM_Try, /*On fail goto*//*Label 24381*/ GIMT_Encode4(1794063), // Rule ID 12232 //
     /* 1793982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1793993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1793996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1793999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1794002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794028 */     // MIs[0] policy
     /* 1794028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794038 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1794041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794062 */     // GIR_Coverage, 12232,
     /* 1794062 */     GIR_EraseRootFromParent_Done,
     /* 1794063 */   // Label 24381: @1794063
     /* 1794063 */   GIM_Try, /*On fail goto*//*Label 24382*/ GIMT_Encode4(1794149), // Rule ID 12233 //
     /* 1794068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1794079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1794082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1794088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794114 */     // MIs[0] policy
     /* 1794114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794124 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1794127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794148 */     // GIR_Coverage, 12233,
     /* 1794148 */     GIR_EraseRootFromParent_Done,
     /* 1794149 */   // Label 24382: @1794149
     /* 1794149 */   GIM_Try, /*On fail goto*//*Label 24383*/ GIMT_Encode4(1794235), // Rule ID 12236 //
     /* 1794154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794200 */     // MIs[0] policy
     /* 1794200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794210 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1794213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794234 */     // GIR_Coverage, 12236,
     /* 1794234 */     GIR_EraseRootFromParent_Done,
     /* 1794235 */   // Label 24383: @1794235
     /* 1794235 */   GIM_Try, /*On fail goto*//*Label 24384*/ GIMT_Encode4(1794321), // Rule ID 12237 //
     /* 1794240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1794251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1794254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794286 */     // MIs[0] policy
     /* 1794286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794296 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1794299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794320 */     // GIR_Coverage, 12237,
     /* 1794320 */     GIR_EraseRootFromParent_Done,
     /* 1794321 */   // Label 24384: @1794321
     /* 1794321 */   GIM_Try, /*On fail goto*//*Label 24385*/ GIMT_Encode4(1794407), // Rule ID 12240 //
     /* 1794326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1794346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794372 */     // MIs[0] policy
     /* 1794372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794382 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1794385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794406 */     // GIR_Coverage, 12240,
     /* 1794406 */     GIR_EraseRootFromParent_Done,
     /* 1794407 */   // Label 24385: @1794407
     /* 1794407 */   GIM_Try, /*On fail goto*//*Label 24386*/ GIMT_Encode4(1794493), // Rule ID 12241 //
     /* 1794412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1794423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1794426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1794429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1794432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1794435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794458 */     // MIs[0] policy
     /* 1794458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794468 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1794471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794492 */     // GIR_Coverage, 12241,
     /* 1794492 */     GIR_EraseRootFromParent_Done,
     /* 1794493 */   // Label 24386: @1794493
     /* 1794493 */   GIM_Try, /*On fail goto*//*Label 24387*/ GIMT_Encode4(1794579), // Rule ID 12244 //
     /* 1794498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1794509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1794512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1794518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794544 */     // MIs[0] policy
     /* 1794544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794554 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1794557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794578 */     // GIR_Coverage, 12244,
     /* 1794578 */     GIR_EraseRootFromParent_Done,
     /* 1794579 */   // Label 24387: @1794579
     /* 1794579 */   GIM_Try, /*On fail goto*//*Label 24388*/ GIMT_Encode4(1794665), // Rule ID 12245 //
     /* 1794584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1794595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1794598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1794604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794630 */     // MIs[0] policy
     /* 1794630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1794643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794664 */     // GIR_Coverage, 12245,
     /* 1794664 */     GIR_EraseRootFromParent_Done,
     /* 1794665 */   // Label 24388: @1794665
     /* 1794665 */   GIM_Try, /*On fail goto*//*Label 24389*/ GIMT_Encode4(1794751), // Rule ID 12248 //
     /* 1794670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1794681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1794684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1794687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1794690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794716 */     // MIs[0] policy
     /* 1794716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794726 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1794729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794750 */     // GIR_Coverage, 12248,
     /* 1794750 */     GIR_EraseRootFromParent_Done,
     /* 1794751 */   // Label 24389: @1794751
     /* 1794751 */   GIM_Try, /*On fail goto*//*Label 24390*/ GIMT_Encode4(1794837), // Rule ID 12249 //
     /* 1794756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1794767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1794770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1794773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1794776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794802 */     // MIs[0] policy
     /* 1794802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794812 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1794815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794836 */     // GIR_Coverage, 12249,
     /* 1794836 */     GIR_EraseRootFromParent_Done,
     /* 1794837 */   // Label 24390: @1794837
     /* 1794837 */   GIM_Try, /*On fail goto*//*Label 24391*/ GIMT_Encode4(1794923), // Rule ID 12252 //
     /* 1794842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1794853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1794856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1794859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1794862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794888 */     // MIs[0] policy
     /* 1794888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794898 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1794901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794922 */     // GIR_Coverage, 12252,
     /* 1794922 */     GIR_EraseRootFromParent_Done,
     /* 1794923 */   // Label 24391: @1794923
     /* 1794923 */   GIM_Try, /*On fail goto*//*Label 24392*/ GIMT_Encode4(1795009), // Rule ID 12253 //
     /* 1794928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1794936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1794939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1794942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1794945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1794948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794974 */     // MIs[0] policy
     /* 1794974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1794987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795008 */     // GIR_Coverage, 12253,
     /* 1795008 */     GIR_EraseRootFromParent_Done,
     /* 1795009 */   // Label 24392: @1795009
     /* 1795009 */   GIM_Try, /*On fail goto*//*Label 24393*/ GIMT_Encode4(1795095), // Rule ID 12256 //
     /* 1795014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795060 */     // MIs[0] policy
     /* 1795060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795070 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1795073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795094 */     // GIR_Coverage, 12256,
     /* 1795094 */     GIR_EraseRootFromParent_Done,
     /* 1795095 */   // Label 24393: @1795095
     /* 1795095 */   GIM_Try, /*On fail goto*//*Label 24394*/ GIMT_Encode4(1795181), // Rule ID 12257 //
     /* 1795100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1795111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1795114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795146 */     // MIs[0] policy
     /* 1795146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1795159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795180 */     // GIR_Coverage, 12257,
     /* 1795180 */     GIR_EraseRootFromParent_Done,
     /* 1795181 */   // Label 24394: @1795181
     /* 1795181 */   GIM_Try, /*On fail goto*//*Label 24395*/ GIMT_Encode4(1795267), // Rule ID 12260 //
     /* 1795186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795232 */     // MIs[0] policy
     /* 1795232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795242 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1795245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795266 */     // GIR_Coverage, 12260,
     /* 1795266 */     GIR_EraseRootFromParent_Done,
     /* 1795267 */   // Label 24395: @1795267
     /* 1795267 */   GIM_Try, /*On fail goto*//*Label 24396*/ GIMT_Encode4(1795353), // Rule ID 12261 //
     /* 1795272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1795283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1795286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795318 */     // MIs[0] policy
     /* 1795318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1795331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795352 */     // GIR_Coverage, 12261,
     /* 1795352 */     GIR_EraseRootFromParent_Done,
     /* 1795353 */   // Label 24396: @1795353
     /* 1795353 */   GIM_Try, /*On fail goto*//*Label 24397*/ GIMT_Encode4(1795439), // Rule ID 12264 //
     /* 1795358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1795378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795404 */     // MIs[0] policy
     /* 1795404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1795417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795438 */     // GIR_Coverage, 12264,
     /* 1795438 */     GIR_EraseRootFromParent_Done,
     /* 1795439 */   // Label 24397: @1795439
     /* 1795439 */   GIM_Try, /*On fail goto*//*Label 24398*/ GIMT_Encode4(1795525), // Rule ID 12265 //
     /* 1795444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1795461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1795464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795490 */     // MIs[0] policy
     /* 1795490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795500 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1795503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795524 */     // GIR_Coverage, 12265,
     /* 1795524 */     GIR_EraseRootFromParent_Done,
     /* 1795525 */   // Label 24398: @1795525
     /* 1795525 */   GIM_Try, /*On fail goto*//*Label 24399*/ GIMT_Encode4(1795611), // Rule ID 12268 //
     /* 1795530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1795541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1795544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1795547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1795550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795576 */     // MIs[0] policy
     /* 1795576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1795589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795610 */     // GIR_Coverage, 12268,
     /* 1795610 */     GIR_EraseRootFromParent_Done,
     /* 1795611 */   // Label 24399: @1795611
     /* 1795611 */   GIM_Try, /*On fail goto*//*Label 24400*/ GIMT_Encode4(1795697), // Rule ID 12269 //
     /* 1795616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1795619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1795627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1795630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1795633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1795636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795662 */     // MIs[0] policy
     /* 1795662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1795675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795696 */     // GIR_Coverage, 12269,
     /* 1795696 */     GIR_EraseRootFromParent_Done,
     /* 1795697 */   // Label 24400: @1795697
     /* 1795697 */   GIM_Try, /*On fail goto*//*Label 24401*/ GIMT_Encode4(1795783), // Rule ID 12272 //
     /* 1795702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1795713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1795716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1795719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1795722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795748 */     // MIs[0] policy
     /* 1795748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795758 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1795761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795782 */     // GIR_Coverage, 12272,
     /* 1795782 */     GIR_EraseRootFromParent_Done,
     /* 1795783 */   // Label 24401: @1795783
     /* 1795783 */   GIM_Try, /*On fail goto*//*Label 24402*/ GIMT_Encode4(1795869), // Rule ID 12273 //
     /* 1795788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1795791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1795799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1795802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1795805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1795808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795834 */     // MIs[0] policy
     /* 1795834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1795847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795868 */     // GIR_Coverage, 12273,
     /* 1795868 */     GIR_EraseRootFromParent_Done,
     /* 1795869 */   // Label 24402: @1795869
     /* 1795869 */   GIM_Try, /*On fail goto*//*Label 24403*/ GIMT_Encode4(1795955), // Rule ID 12276 //
     /* 1795874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1795877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1795885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1795888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1795891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1795894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795920 */     // MIs[0] policy
     /* 1795920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795930 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1795933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1795951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795954 */     // GIR_Coverage, 12276,
     /* 1795954 */     GIR_EraseRootFromParent_Done,
     /* 1795955 */   // Label 24403: @1795955
     /* 1795955 */   GIM_Try, /*On fail goto*//*Label 24404*/ GIMT_Encode4(1796041), // Rule ID 12277 //
     /* 1795960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1795963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1795968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1795971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1795974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1795977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1795980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796006 */     // MIs[0] policy
     /* 1796006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1796019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1796037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796040 */     // GIR_Coverage, 12277,
     /* 1796040 */     GIR_EraseRootFromParent_Done,
     /* 1796041 */   // Label 24404: @1796041
     /* 1796041 */   GIM_Try, /*On fail goto*//*Label 24405*/ GIMT_Encode4(1796127), // Rule ID 12280 //
     /* 1796046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796092 */     // MIs[0] policy
     /* 1796092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796102 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1796105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796126 */     // GIR_Coverage, 12280,
     /* 1796126 */     GIR_EraseRootFromParent_Done,
     /* 1796127 */   // Label 24405: @1796127
     /* 1796127 */   GIM_Try, /*On fail goto*//*Label 24406*/ GIMT_Encode4(1796213), // Rule ID 12281 //
     /* 1796132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1796143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1796146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1796149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796178 */     // MIs[0] policy
     /* 1796178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796188 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1796191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796212 */     // GIR_Coverage, 12281,
     /* 1796212 */     GIR_EraseRootFromParent_Done,
     /* 1796213 */   // Label 24406: @1796213
     /* 1796213 */   GIM_Try, /*On fail goto*//*Label 24407*/ GIMT_Encode4(1796299), // Rule ID 12284 //
     /* 1796218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796264 */     // MIs[0] policy
     /* 1796264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796274 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1796277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796298 */     // GIR_Coverage, 12284,
     /* 1796298 */     GIR_EraseRootFromParent_Done,
     /* 1796299 */   // Label 24407: @1796299
     /* 1796299 */   GIM_Try, /*On fail goto*//*Label 24408*/ GIMT_Encode4(1796385), // Rule ID 12285 //
     /* 1796304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1796315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1796318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796350 */     // MIs[0] policy
     /* 1796350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796360 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1796363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796384 */     // GIR_Coverage, 12285,
     /* 1796384 */     GIR_EraseRootFromParent_Done,
     /* 1796385 */   // Label 24408: @1796385
     /* 1796385 */   GIM_Try, /*On fail goto*//*Label 24409*/ GIMT_Encode4(1796471), // Rule ID 12288 //
     /* 1796390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796436 */     // MIs[0] policy
     /* 1796436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796446 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1796449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796470 */     // GIR_Coverage, 12288,
     /* 1796470 */     GIR_EraseRootFromParent_Done,
     /* 1796471 */   // Label 24409: @1796471
     /* 1796471 */   GIM_Try, /*On fail goto*//*Label 24410*/ GIMT_Encode4(1796557), // Rule ID 12289 //
     /* 1796476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1796487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1796490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796522 */     // MIs[0] policy
     /* 1796522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1796535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796556 */     // GIR_Coverage, 12289,
     /* 1796556 */     GIR_EraseRootFromParent_Done,
     /* 1796557 */   // Label 24410: @1796557
     /* 1796557 */   GIM_Try, /*On fail goto*//*Label 24411*/ GIMT_Encode4(1796643), // Rule ID 12292 //
     /* 1796562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1796573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1796576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1796579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796608 */     // MIs[0] policy
     /* 1796608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796618 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1796621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796642 */     // GIR_Coverage, 12292,
     /* 1796642 */     GIR_EraseRootFromParent_Done,
     /* 1796643 */   // Label 24411: @1796643
     /* 1796643 */   GIM_Try, /*On fail goto*//*Label 24412*/ GIMT_Encode4(1796729), // Rule ID 12293 //
     /* 1796648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1796659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1796662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1796665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796694 */     // MIs[0] policy
     /* 1796694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796704 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1796707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796728 */     // GIR_Coverage, 12293,
     /* 1796728 */     GIR_EraseRootFromParent_Done,
     /* 1796729 */   // Label 24412: @1796729
     /* 1796729 */   GIM_Try, /*On fail goto*//*Label 24413*/ GIMT_Encode4(1796815), // Rule ID 12296 //
     /* 1796734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1796745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1796748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1796751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796780 */     // MIs[0] policy
     /* 1796780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796790 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1796793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796814 */     // GIR_Coverage, 12296,
     /* 1796814 */     GIR_EraseRootFromParent_Done,
     /* 1796815 */   // Label 24413: @1796815
     /* 1796815 */   GIM_Try, /*On fail goto*//*Label 24414*/ GIMT_Encode4(1796901), // Rule ID 12297 //
     /* 1796820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1796831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1796834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1796837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796866 */     // MIs[0] policy
     /* 1796866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796876 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1796879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796900 */     // GIR_Coverage, 12297,
     /* 1796900 */     GIR_EraseRootFromParent_Done,
     /* 1796901 */   // Label 24414: @1796901
     /* 1796901 */   GIM_Try, /*On fail goto*//*Label 24415*/ GIMT_Encode4(1796987), // Rule ID 12300 //
     /* 1796906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1796914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1796917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1796920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1796923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796952 */     // MIs[0] policy
     /* 1796952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796962 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1796965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1796983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796986 */     // GIR_Coverage, 12300,
     /* 1796986 */     GIR_EraseRootFromParent_Done,
     /* 1796987 */   // Label 24415: @1796987
     /* 1796987 */   GIM_Try, /*On fail goto*//*Label 24416*/ GIMT_Encode4(1797073), // Rule ID 12301 //
     /* 1796992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1797003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1797006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797038 */     // MIs[0] policy
     /* 1797038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1797051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797072 */     // GIR_Coverage, 12301,
     /* 1797072 */     GIR_EraseRootFromParent_Done,
     /* 1797073 */   // Label 24416: @1797073
     /* 1797073 */   GIM_Try, /*On fail goto*//*Label 24417*/ GIMT_Encode4(1797159), // Rule ID 12304 //
     /* 1797078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797124 */     // MIs[0] policy
     /* 1797124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797134 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1797137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797158 */     // GIR_Coverage, 12304,
     /* 1797158 */     GIR_EraseRootFromParent_Done,
     /* 1797159 */   // Label 24417: @1797159
     /* 1797159 */   GIM_Try, /*On fail goto*//*Label 24418*/ GIMT_Encode4(1797245), // Rule ID 12305 //
     /* 1797164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1797175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1797178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1797181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797210 */     // MIs[0] policy
     /* 1797210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11514:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1797223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797244 */     // GIR_Coverage, 12305,
     /* 1797244 */     GIR_EraseRootFromParent_Done,
     /* 1797245 */   // Label 24418: @1797245
     /* 1797245 */   GIM_Try, /*On fail goto*//*Label 24419*/ GIMT_Encode4(1797331), // Rule ID 12308 //
     /* 1797250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797296 */     // MIs[0] policy
     /* 1797296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797306 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1797309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797330 */     // GIR_Coverage, 12308,
     /* 1797330 */     GIR_EraseRootFromParent_Done,
     /* 1797331 */   // Label 24419: @1797331
     /* 1797331 */   GIM_Try, /*On fail goto*//*Label 24420*/ GIMT_Encode4(1797417), // Rule ID 12309 //
     /* 1797336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1797347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1797350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797382 */     // MIs[0] policy
     /* 1797382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11514:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1797395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797416 */     // GIR_Coverage, 12309,
     /* 1797416 */     GIR_EraseRootFromParent_Done,
     /* 1797417 */   // Label 24420: @1797417
     /* 1797417 */   GIM_Try, /*On fail goto*//*Label 24421*/ GIMT_Encode4(1797503), // Rule ID 12312 //
     /* 1797422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797468 */     // MIs[0] policy
     /* 1797468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1797481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797502 */     // GIR_Coverage, 12312,
     /* 1797502 */     GIR_EraseRootFromParent_Done,
     /* 1797503 */   // Label 24421: @1797503
     /* 1797503 */   GIM_Try, /*On fail goto*//*Label 24422*/ GIMT_Encode4(1797589), // Rule ID 12313 //
     /* 1797508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797554 */     // MIs[0] policy
     /* 1797554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11514:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1797567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797588 */     // GIR_Coverage, 12313,
     /* 1797588 */     GIR_EraseRootFromParent_Done,
     /* 1797589 */   // Label 24422: @1797589
     /* 1797589 */   GIM_Try, /*On fail goto*//*Label 24423*/ GIMT_Encode4(1797675), // Rule ID 12316 //
     /* 1797594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1797597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1797611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797640 */     // MIs[0] policy
     /* 1797640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1797653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797674 */     // GIR_Coverage, 12316,
     /* 1797674 */     GIR_EraseRootFromParent_Done,
     /* 1797675 */   // Label 24423: @1797675
     /* 1797675 */   GIM_Try, /*On fail goto*//*Label 24424*/ GIMT_Encode4(1797761), // Rule ID 12317 //
     /* 1797680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1797683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1797697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797726 */     // MIs[0] policy
     /* 1797726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797736 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11514:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1797739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1797757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797760 */     // GIR_Coverage, 12317,
     /* 1797760 */     GIR_EraseRootFromParent_Done,
     /* 1797761 */   // Label 24424: @1797761
     /* 1797761 */   GIM_Try, /*On fail goto*//*Label 24425*/ GIMT_Encode4(1797847), // Rule ID 12320 //
     /* 1797766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1797777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1797780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1797783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1797789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797812 */     // MIs[0] policy
     /* 1797812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797822 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1797825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797846 */     // GIR_Coverage, 12320,
     /* 1797846 */     GIR_EraseRootFromParent_Done,
     /* 1797847 */   // Label 24425: @1797847
     /* 1797847 */   GIM_Try, /*On fail goto*//*Label 24426*/ GIMT_Encode4(1797933), // Rule ID 12321 //
     /* 1797852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1797863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1797866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1797869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1797875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797898 */     // MIs[0] policy
     /* 1797898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797908 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1797911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1797929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797932 */     // GIR_Coverage, 12321,
     /* 1797932 */     GIR_EraseRootFromParent_Done,
     /* 1797933 */   // Label 24426: @1797933
     /* 1797933 */   GIM_Try, /*On fail goto*//*Label 24427*/ GIMT_Encode4(1798019), // Rule ID 12324 //
     /* 1797938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1797946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1797949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1797952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1797955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1797961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1797968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797984 */     // MIs[0] policy
     /* 1797984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797994 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1797997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798018 */     // GIR_Coverage, 12324,
     /* 1798018 */     GIR_EraseRootFromParent_Done,
     /* 1798019 */   // Label 24427: @1798019
     /* 1798019 */   GIM_Try, /*On fail goto*//*Label 24428*/ GIMT_Encode4(1798105), // Rule ID 12325 //
     /* 1798024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1798035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1798038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1798041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798070 */     // MIs[0] policy
     /* 1798070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798080 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1798083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798104 */     // GIR_Coverage, 12325,
     /* 1798104 */     GIR_EraseRootFromParent_Done,
     /* 1798105 */   // Label 24428: @1798105
     /* 1798105 */   GIM_Try, /*On fail goto*//*Label 24429*/ GIMT_Encode4(1798191), // Rule ID 12328 //
     /* 1798110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798156 */     // MIs[0] policy
     /* 1798156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798166 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1798169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798190 */     // GIR_Coverage, 12328,
     /* 1798190 */     GIR_EraseRootFromParent_Done,
     /* 1798191 */   // Label 24429: @1798191
     /* 1798191 */   GIM_Try, /*On fail goto*//*Label 24430*/ GIMT_Encode4(1798277), // Rule ID 12329 //
     /* 1798196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1798207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1798210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1798213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1798219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798242 */     // MIs[0] policy
     /* 1798242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798252 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1798255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798276 */     // GIR_Coverage, 12329,
     /* 1798276 */     GIR_EraseRootFromParent_Done,
     /* 1798277 */   // Label 24430: @1798277
     /* 1798277 */   GIM_Try, /*On fail goto*//*Label 24431*/ GIMT_Encode4(1798363), // Rule ID 12332 //
     /* 1798282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798328 */     // MIs[0] policy
     /* 1798328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798338 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1798341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798362 */     // GIR_Coverage, 12332,
     /* 1798362 */     GIR_EraseRootFromParent_Done,
     /* 1798363 */   // Label 24431: @1798363
     /* 1798363 */   GIM_Try, /*On fail goto*//*Label 24432*/ GIMT_Encode4(1798449), // Rule ID 12333 //
     /* 1798368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1798385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798414 */     // MIs[0] policy
     /* 1798414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1798427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798448 */     // GIR_Coverage, 12333,
     /* 1798448 */     GIR_EraseRootFromParent_Done,
     /* 1798449 */   // Label 24432: @1798449
     /* 1798449 */   GIM_Try, /*On fail goto*//*Label 24433*/ GIMT_Encode4(1798535), // Rule ID 12336 //
     /* 1798454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798500 */     // MIs[0] policy
     /* 1798500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798510 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1798513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798534 */     // GIR_Coverage, 12336,
     /* 1798534 */     GIR_EraseRootFromParent_Done,
     /* 1798535 */   // Label 24433: @1798535
     /* 1798535 */   GIM_Try, /*On fail goto*//*Label 24434*/ GIMT_Encode4(1798621), // Rule ID 12337 //
     /* 1798540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1798551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1798554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1798557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1798563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798586 */     // MIs[0] policy
     /* 1798586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1798599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798620 */     // GIR_Coverage, 12337,
     /* 1798620 */     GIR_EraseRootFromParent_Done,
     /* 1798621 */   // Label 24434: @1798621
     /* 1798621 */   GIM_Try, /*On fail goto*//*Label 24435*/ GIMT_Encode4(1798707), // Rule ID 12340 //
     /* 1798626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1798643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798672 */     // MIs[0] policy
     /* 1798672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798682 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1798685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798706 */     // GIR_Coverage, 12340,
     /* 1798706 */     GIR_EraseRootFromParent_Done,
     /* 1798707 */   // Label 24435: @1798707
     /* 1798707 */   GIM_Try, /*On fail goto*//*Label 24436*/ GIMT_Encode4(1798793), // Rule ID 12341 //
     /* 1798712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1798723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1798726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1798729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1798735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798758 */     // MIs[0] policy
     /* 1798758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1798771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1798789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798792 */     // GIR_Coverage, 12341,
     /* 1798792 */     GIR_EraseRootFromParent_Done,
     /* 1798793 */   // Label 24436: @1798793
     /* 1798793 */   GIM_Try, /*On fail goto*//*Label 24437*/ GIMT_Encode4(1798879), // Rule ID 12344 //
     /* 1798798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1798809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1798812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798844 */     // MIs[0] policy
     /* 1798844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1798857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798878 */     // GIR_Coverage, 12344,
     /* 1798878 */     GIR_EraseRootFromParent_Done,
     /* 1798879 */   // Label 24437: @1798879
     /* 1798879 */   GIM_Try, /*On fail goto*//*Label 24438*/ GIMT_Encode4(1798965), // Rule ID 12345 //
     /* 1798884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1798895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1798898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798930 */     // MIs[0] policy
     /* 1798930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1798943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798964 */     // GIR_Coverage, 12345,
     /* 1798964 */     GIR_EraseRootFromParent_Done,
     /* 1798965 */   // Label 24438: @1798965
     /* 1798965 */   GIM_Try, /*On fail goto*//*Label 24439*/ GIMT_Encode4(1799051), // Rule ID 12348 //
     /* 1798970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1798978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1798981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1798984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1798987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799016 */     // MIs[0] policy
     /* 1799016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799026 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1799029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799050 */     // GIR_Coverage, 12348,
     /* 1799050 */     GIR_EraseRootFromParent_Done,
     /* 1799051 */   // Label 24439: @1799051
     /* 1799051 */   GIM_Try, /*On fail goto*//*Label 24440*/ GIMT_Encode4(1799137), // Rule ID 12349 //
     /* 1799056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1799073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799102 */     // MIs[0] policy
     /* 1799102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1799115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799136 */     // GIR_Coverage, 12349,
     /* 1799136 */     GIR_EraseRootFromParent_Done,
     /* 1799137 */   // Label 24440: @1799137
     /* 1799137 */   GIM_Try, /*On fail goto*//*Label 24441*/ GIMT_Encode4(1799223), // Rule ID 12352 //
     /* 1799142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799188 */     // MIs[0] policy
     /* 1799188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1799201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799222 */     // GIR_Coverage, 12352,
     /* 1799222 */     GIR_EraseRootFromParent_Done,
     /* 1799223 */   // Label 24441: @1799223
     /* 1799223 */   GIM_Try, /*On fail goto*//*Label 24442*/ GIMT_Encode4(1799309), // Rule ID 12353 //
     /* 1799228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1799239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1799242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1799245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799274 */     // MIs[0] policy
     /* 1799274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1799287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1799305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799308 */     // GIR_Coverage, 12353,
     /* 1799308 */     GIR_EraseRootFromParent_Done,
     /* 1799309 */   // Label 24442: @1799309
     /* 1799309 */   GIM_Try, /*On fail goto*//*Label 24443*/ GIMT_Encode4(1799395), // Rule ID 12356 //
     /* 1799314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799360 */     // MIs[0] policy
     /* 1799360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799370 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1799373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799394 */     // GIR_Coverage, 12356,
     /* 1799394 */     GIR_EraseRootFromParent_Done,
     /* 1799395 */   // Label 24443: @1799395
     /* 1799395 */   GIM_Try, /*On fail goto*//*Label 24444*/ GIMT_Encode4(1799481), // Rule ID 12357 //
     /* 1799400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1799411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1799414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1799417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799446 */     // MIs[0] policy
     /* 1799446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11514:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1799459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799480 */     // GIR_Coverage, 12357,
     /* 1799480 */     GIR_EraseRootFromParent_Done,
     /* 1799481 */   // Label 24444: @1799481
     /* 1799481 */   GIM_Try, /*On fail goto*//*Label 24445*/ GIMT_Encode4(1799567), // Rule ID 12360 //
     /* 1799486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799532 */     // MIs[0] policy
     /* 1799532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799542 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1799545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799566 */     // GIR_Coverage, 12360,
     /* 1799566 */     GIR_EraseRootFromParent_Done,
     /* 1799567 */   // Label 24445: @1799567
     /* 1799567 */   GIM_Try, /*On fail goto*//*Label 24446*/ GIMT_Encode4(1799653), // Rule ID 12361 //
     /* 1799572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1799583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1799586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1799589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799618 */     // MIs[0] policy
     /* 1799618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11514:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1799631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799652 */     // GIR_Coverage, 12361,
     /* 1799652 */     GIR_EraseRootFromParent_Done,
     /* 1799653 */   // Label 24446: @1799653
     /* 1799653 */   GIM_Try, /*On fail goto*//*Label 24447*/ GIMT_Encode4(1799739), // Rule ID 12364 //
     /* 1799658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1799661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1799669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1799672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1799675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1799678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799704 */     // MIs[0] policy
     /* 1799704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799714 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1799717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799738 */     // GIR_Coverage, 12364,
     /* 1799738 */     GIR_EraseRootFromParent_Done,
     /* 1799739 */   // Label 24447: @1799739
     /* 1799739 */   GIM_Try, /*On fail goto*//*Label 24448*/ GIMT_Encode4(1799825), // Rule ID 12365 //
     /* 1799744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1799747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1799752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1799755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1799758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1799761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1799764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1799786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799790 */     // MIs[0] policy
     /* 1799790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11514:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1799803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1799821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799824 */     // GIR_Coverage, 12365,
     /* 1799824 */     GIR_EraseRootFromParent_Done,
     /* 1799825 */   // Label 24448: @1799825
     /* 1799825 */   GIM_Try, /*On fail goto*//*Label 24449*/ GIMT_Encode4(1799911), // Rule ID 12368 //
     /* 1799830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1799841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1799844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1799847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1799850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799876 */     // MIs[0] policy
     /* 1799876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799886 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1799889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1799907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799910 */     // GIR_Coverage, 12368,
     /* 1799910 */     GIR_EraseRootFromParent_Done,
     /* 1799911 */   // Label 24449: @1799911
     /* 1799911 */   GIM_Try, /*On fail goto*//*Label 24450*/ GIMT_Encode4(1799997), // Rule ID 12369 //
     /* 1799916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1799924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1799927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1799930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1799933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1799936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799962 */     // MIs[0] policy
     /* 1799962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799972 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1799975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1799993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799996 */     // GIR_Coverage, 12369,
     /* 1799996 */     GIR_EraseRootFromParent_Done,
     /* 1799997 */   // Label 24450: @1799997
     /* 1799997 */   GIM_Try, /*On fail goto*//*Label 24451*/ GIMT_Encode4(1800083), // Rule ID 12372 //
     /* 1800002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1800022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800048 */     // MIs[0] policy
     /* 1800048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800058 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800082 */     // GIR_Coverage, 12372,
     /* 1800082 */     GIR_EraseRootFromParent_Done,
     /* 1800083 */   // Label 24451: @1800083
     /* 1800083 */   GIM_Try, /*On fail goto*//*Label 24452*/ GIMT_Encode4(1800169), // Rule ID 12373 //
     /* 1800088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1800099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1800102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1800105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1800108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800134 */     // MIs[0] policy
     /* 1800134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800168 */     // GIR_Coverage, 12373,
     /* 1800168 */     GIR_EraseRootFromParent_Done,
     /* 1800169 */   // Label 24452: @1800169
     /* 1800169 */   GIM_Try, /*On fail goto*//*Label 24453*/ GIMT_Encode4(1800255), // Rule ID 12376 //
     /* 1800174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1800194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800220 */     // MIs[0] policy
     /* 1800220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800230 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1800233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800254 */     // GIR_Coverage, 12376,
     /* 1800254 */     GIR_EraseRootFromParent_Done,
     /* 1800255 */   // Label 24453: @1800255
     /* 1800255 */   GIM_Try, /*On fail goto*//*Label 24454*/ GIMT_Encode4(1800341), // Rule ID 12377 //
     /* 1800260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1800271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1800274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1800277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1800280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800306 */     // MIs[0] policy
     /* 1800306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1800319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800340 */     // GIR_Coverage, 12377,
     /* 1800340 */     GIR_EraseRootFromParent_Done,
     /* 1800341 */   // Label 24454: @1800341
     /* 1800341 */   GIM_Try, /*On fail goto*//*Label 24455*/ GIMT_Encode4(1800427), // Rule ID 12380 //
     /* 1800346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1800366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800392 */     // MIs[0] policy
     /* 1800392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1800405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800426 */     // GIR_Coverage, 12380,
     /* 1800426 */     GIR_EraseRootFromParent_Done,
     /* 1800427 */   // Label 24455: @1800427
     /* 1800427 */   GIM_Try, /*On fail goto*//*Label 24456*/ GIMT_Encode4(1800513), // Rule ID 12381 //
     /* 1800432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1800443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1800446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1800449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1800452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800478 */     // MIs[0] policy
     /* 1800478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800488 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1800491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800512 */     // GIR_Coverage, 12381,
     /* 1800512 */     GIR_EraseRootFromParent_Done,
     /* 1800513 */   // Label 24456: @1800513
     /* 1800513 */   GIM_Try, /*On fail goto*//*Label 24457*/ GIMT_Encode4(1800599), // Rule ID 12384 //
     /* 1800518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1800529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1800532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1800535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1800538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800564 */     // MIs[0] policy
     /* 1800564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800574 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1800577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800598 */     // GIR_Coverage, 12384,
     /* 1800598 */     GIR_EraseRootFromParent_Done,
     /* 1800599 */   // Label 24457: @1800599
     /* 1800599 */   GIM_Try, /*On fail goto*//*Label 24458*/ GIMT_Encode4(1800685), // Rule ID 12385 //
     /* 1800604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1800615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1800618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1800621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1800624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800650 */     // MIs[0] policy
     /* 1800650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800660 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1800663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800684 */     // GIR_Coverage, 12385,
     /* 1800684 */     GIR_EraseRootFromParent_Done,
     /* 1800685 */   // Label 24458: @1800685
     /* 1800685 */   GIM_Try, /*On fail goto*//*Label 24459*/ GIMT_Encode4(1800771), // Rule ID 12388 //
     /* 1800690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1800701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1800704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1800707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1800710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1800713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800736 */     // MIs[0] policy
     /* 1800736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1800749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800770 */     // GIR_Coverage, 12388,
     /* 1800770 */     GIR_EraseRootFromParent_Done,
     /* 1800771 */   // Label 24459: @1800771
     /* 1800771 */   GIM_Try, /*On fail goto*//*Label 24460*/ GIMT_Encode4(1800857), // Rule ID 12389 //
     /* 1800776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1800787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1800790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1800793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1800796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1800799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800822 */     // MIs[0] policy
     /* 1800822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800832 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1800835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1800853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800856 */     // GIR_Coverage, 12389,
     /* 1800856 */     GIR_EraseRootFromParent_Done,
     /* 1800857 */   // Label 24460: @1800857
     /* 1800857 */   GIM_Try, /*On fail goto*//*Label 24461*/ GIMT_Encode4(1800943), // Rule ID 12392 //
     /* 1800862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1800873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1800876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1800879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1800882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800908 */     // MIs[0] policy
     /* 1800908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1800921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800942 */     // GIR_Coverage, 12392,
     /* 1800942 */     GIR_EraseRootFromParent_Done,
     /* 1800943 */   // Label 24461: @1800943
     /* 1800943 */   GIM_Try, /*On fail goto*//*Label 24462*/ GIMT_Encode4(1801029), // Rule ID 12393 //
     /* 1800948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1800956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1800959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1800962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1800965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1800968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800994 */     // MIs[0] policy
     /* 1800994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801004 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1801007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801028 */     // GIR_Coverage, 12393,
     /* 1801028 */     GIR_EraseRootFromParent_Done,
     /* 1801029 */   // Label 24462: @1801029
     /* 1801029 */   GIM_Try, /*On fail goto*//*Label 24463*/ GIMT_Encode4(1801115), // Rule ID 12396 //
     /* 1801034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1801054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801080 */     // MIs[0] policy
     /* 1801080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801090 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801114 */     // GIR_Coverage, 12396,
     /* 1801114 */     GIR_EraseRootFromParent_Done,
     /* 1801115 */   // Label 24463: @1801115
     /* 1801115 */   GIM_Try, /*On fail goto*//*Label 24464*/ GIMT_Encode4(1801201), // Rule ID 12397 //
     /* 1801120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1801131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1801134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1801137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1801140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801166 */     // MIs[0] policy
     /* 1801166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801200 */     // GIR_Coverage, 12397,
     /* 1801200 */     GIR_EraseRootFromParent_Done,
     /* 1801201 */   // Label 24464: @1801201
     /* 1801201 */   GIM_Try, /*On fail goto*//*Label 24465*/ GIMT_Encode4(1801287), // Rule ID 12400 //
     /* 1801206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1801226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801252 */     // MIs[0] policy
     /* 1801252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801286 */     // GIR_Coverage, 12400,
     /* 1801286 */     GIR_EraseRootFromParent_Done,
     /* 1801287 */   // Label 24465: @1801287
     /* 1801287 */   GIM_Try, /*On fail goto*//*Label 24466*/ GIMT_Encode4(1801373), // Rule ID 12401 //
     /* 1801292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1801303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1801306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1801309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1801312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801338 */     // MIs[0] policy
     /* 1801338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801372 */     // GIR_Coverage, 12401,
     /* 1801372 */     GIR_EraseRootFromParent_Done,
     /* 1801373 */   // Label 24466: @1801373
     /* 1801373 */   GIM_Try, /*On fail goto*//*Label 24467*/ GIMT_Encode4(1801459), // Rule ID 12404 //
     /* 1801378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1801398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801424 */     // MIs[0] policy
     /* 1801424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801458 */     // GIR_Coverage, 12404,
     /* 1801458 */     GIR_EraseRootFromParent_Done,
     /* 1801459 */   // Label 24467: @1801459
     /* 1801459 */   GIM_Try, /*On fail goto*//*Label 24468*/ GIMT_Encode4(1801545), // Rule ID 12405 //
     /* 1801464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1801475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1801478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1801481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1801484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801510 */     // MIs[0] policy
     /* 1801510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1801523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801544 */     // GIR_Coverage, 12405,
     /* 1801544 */     GIR_EraseRootFromParent_Done,
     /* 1801545 */   // Label 24468: @1801545
     /* 1801545 */   GIM_Try, /*On fail goto*//*Label 24469*/ GIMT_Encode4(1801631), // Rule ID 12408 //
     /* 1801550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1801561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1801564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1801567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1801570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801596 */     // MIs[0] policy
     /* 1801596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1801609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801630 */     // GIR_Coverage, 12408,
     /* 1801630 */     GIR_EraseRootFromParent_Done,
     /* 1801631 */   // Label 24469: @1801631
     /* 1801631 */   GIM_Try, /*On fail goto*//*Label 24470*/ GIMT_Encode4(1801717), // Rule ID 12409 //
     /* 1801636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1801647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1801650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1801653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1801656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801682 */     // MIs[0] policy
     /* 1801682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1801695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1801713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801716 */     // GIR_Coverage, 12409,
     /* 1801716 */     GIR_EraseRootFromParent_Done,
     /* 1801717 */   // Label 24470: @1801717
     /* 1801717 */   GIM_Try, /*On fail goto*//*Label 24471*/ GIMT_Encode4(1801803), // Rule ID 12412 //
     /* 1801722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1801725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1801733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1801736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1801739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1801742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801768 */     // MIs[0] policy
     /* 1801768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801778 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801802 */     // GIR_Coverage, 12412,
     /* 1801802 */     GIR_EraseRootFromParent_Done,
     /* 1801803 */   // Label 24471: @1801803
     /* 1801803 */   GIM_Try, /*On fail goto*//*Label 24472*/ GIMT_Encode4(1801889), // Rule ID 12413 //
     /* 1801808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1801811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1801819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1801822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1801825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1801828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801854 */     // MIs[0] policy
     /* 1801854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801864 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1801867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801888 */     // GIR_Coverage, 12413,
     /* 1801888 */     GIR_EraseRootFromParent_Done,
     /* 1801889 */   // Label 24472: @1801889
     /* 1801889 */   GIM_Try, /*On fail goto*//*Label 24473*/ GIMT_Encode4(1801975), // Rule ID 12416 //
     /* 1801894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1801897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1801905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1801908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1801911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1801914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801940 */     // MIs[0] policy
     /* 1801940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1801953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1801971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801974 */     // GIR_Coverage, 12416,
     /* 1801974 */     GIR_EraseRootFromParent_Done,
     /* 1801975 */   // Label 24473: @1801975
     /* 1801975 */   GIM_Try, /*On fail goto*//*Label 24474*/ GIMT_Encode4(1802061), // Rule ID 12417 //
     /* 1801980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1801983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1801988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1801991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1801994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1801997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1802000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802026 */     // MIs[0] policy
     /* 1802026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1802039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802060 */     // GIR_Coverage, 12417,
     /* 1802060 */     GIR_EraseRootFromParent_Done,
     /* 1802061 */   // Label 24474: @1802061
     /* 1802061 */   GIM_Try, /*On fail goto*//*Label 24475*/ GIMT_Encode4(1802147), // Rule ID 12420 //
     /* 1802066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1802086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802112 */     // MIs[0] policy
     /* 1802112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802122 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1802125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802146 */     // GIR_Coverage, 12420,
     /* 1802146 */     GIR_EraseRootFromParent_Done,
     /* 1802147 */   // Label 24475: @1802147
     /* 1802147 */   GIM_Try, /*On fail goto*//*Label 24476*/ GIMT_Encode4(1802233), // Rule ID 12421 //
     /* 1802152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1802163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1802166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1802169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1802172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802198 */     // MIs[0] policy
     /* 1802198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802208 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1802211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802232 */     // GIR_Coverage, 12421,
     /* 1802232 */     GIR_EraseRootFromParent_Done,
     /* 1802233 */   // Label 24476: @1802233
     /* 1802233 */   GIM_Try, /*On fail goto*//*Label 24477*/ GIMT_Encode4(1802319), // Rule ID 12424 //
     /* 1802238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1802258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802284 */     // MIs[0] policy
     /* 1802284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802318 */     // GIR_Coverage, 12424,
     /* 1802318 */     GIR_EraseRootFromParent_Done,
     /* 1802319 */   // Label 24477: @1802319
     /* 1802319 */   GIM_Try, /*On fail goto*//*Label 24478*/ GIMT_Encode4(1802405), // Rule ID 12425 //
     /* 1802324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1802335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1802338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1802341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1802344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802370 */     // MIs[0] policy
     /* 1802370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802380 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1802383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802404 */     // GIR_Coverage, 12425,
     /* 1802404 */     GIR_EraseRootFromParent_Done,
     /* 1802405 */   // Label 24478: @1802405
     /* 1802405 */   GIM_Try, /*On fail goto*//*Label 24479*/ GIMT_Encode4(1802491), // Rule ID 12428 //
     /* 1802410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802456 */     // MIs[0] policy
     /* 1802456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802466 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1802469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802490 */     // GIR_Coverage, 12428,
     /* 1802490 */     GIR_EraseRootFromParent_Done,
     /* 1802491 */   // Label 24479: @1802491
     /* 1802491 */   GIM_Try, /*On fail goto*//*Label 24480*/ GIMT_Encode4(1802577), // Rule ID 12429 //
     /* 1802496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1802507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1802510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1802513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802542 */     // MIs[0] policy
     /* 1802542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1802555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802576 */     // GIR_Coverage, 12429,
     /* 1802576 */     GIR_EraseRootFromParent_Done,
     /* 1802577 */   // Label 24480: @1802577
     /* 1802577 */   GIM_Try, /*On fail goto*//*Label 24481*/ GIMT_Encode4(1802663), // Rule ID 12432 //
     /* 1802582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1802593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1802596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1802599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802628 */     // MIs[0] policy
     /* 1802628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1802641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802662 */     // GIR_Coverage, 12432,
     /* 1802662 */     GIR_EraseRootFromParent_Done,
     /* 1802663 */   // Label 24481: @1802663
     /* 1802663 */   GIM_Try, /*On fail goto*//*Label 24482*/ GIMT_Encode4(1802749), // Rule ID 12433 //
     /* 1802668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1802679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1802682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1802685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802714 */     // MIs[0] policy
     /* 1802714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802724 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1802727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802748 */     // GIR_Coverage, 12433,
     /* 1802748 */     GIR_EraseRootFromParent_Done,
     /* 1802749 */   // Label 24482: @1802749
     /* 1802749 */   GIM_Try, /*On fail goto*//*Label 24483*/ GIMT_Encode4(1802835), // Rule ID 12436 //
     /* 1802754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1802765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1802768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1802771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802800 */     // MIs[0] policy
     /* 1802800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802810 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1802813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802834 */     // GIR_Coverage, 12436,
     /* 1802834 */     GIR_EraseRootFromParent_Done,
     /* 1802835 */   // Label 24483: @1802835
     /* 1802835 */   GIM_Try, /*On fail goto*//*Label 24484*/ GIMT_Encode4(1802921), // Rule ID 12437 //
     /* 1802840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1802851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1802854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1802857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802886 */     // MIs[0] policy
     /* 1802886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11656:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1802899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802920 */     // GIR_Coverage, 12437,
     /* 1802920 */     GIR_EraseRootFromParent_Done,
     /* 1802921 */   // Label 24484: @1802921
     /* 1802921 */   GIM_Try, /*On fail goto*//*Label 24485*/ GIMT_Encode4(1803007), // Rule ID 12440 //
     /* 1802926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1802934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1802937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1802940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1802943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802972 */     // MIs[0] policy
     /* 1802972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1802985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803006 */     // GIR_Coverage, 12440,
     /* 1803006 */     GIR_EraseRootFromParent_Done,
     /* 1803007 */   // Label 24485: @1803007
     /* 1803007 */   GIM_Try, /*On fail goto*//*Label 24486*/ GIMT_Encode4(1803093), // Rule ID 12441 //
     /* 1803012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1803023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1803026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1803029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803058 */     // MIs[0] policy
     /* 1803058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803092 */     // GIR_Coverage, 12441,
     /* 1803092 */     GIR_EraseRootFromParent_Done,
     /* 1803093 */   // Label 24486: @1803093
     /* 1803093 */   GIM_Try, /*On fail goto*//*Label 24487*/ GIMT_Encode4(1803179), // Rule ID 12444 //
     /* 1803098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803144 */     // MIs[0] policy
     /* 1803144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803154 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1803157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803178 */     // GIR_Coverage, 12444,
     /* 1803178 */     GIR_EraseRootFromParent_Done,
     /* 1803179 */   // Label 24487: @1803179
     /* 1803179 */   GIM_Try, /*On fail goto*//*Label 24488*/ GIMT_Encode4(1803265), // Rule ID 12445 //
     /* 1803184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1803195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1803198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1803201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1803207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803230 */     // MIs[0] policy
     /* 1803230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1803243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803264 */     // GIR_Coverage, 12445,
     /* 1803264 */     GIR_EraseRootFromParent_Done,
     /* 1803265 */   // Label 24488: @1803265
     /* 1803265 */   GIM_Try, /*On fail goto*//*Label 24489*/ GIMT_Encode4(1803351), // Rule ID 12448 //
     /* 1803270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803316 */     // MIs[0] policy
     /* 1803316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1803329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803350 */     // GIR_Coverage, 12448,
     /* 1803350 */     GIR_EraseRootFromParent_Done,
     /* 1803351 */   // Label 24489: @1803351
     /* 1803351 */   GIM_Try, /*On fail goto*//*Label 24490*/ GIMT_Encode4(1803437), // Rule ID 12449 //
     /* 1803356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1803367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1803370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1803373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1803379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803402 */     // MIs[0] policy
     /* 1803402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803412 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1803415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803436 */     // GIR_Coverage, 12449,
     /* 1803436 */     GIR_EraseRootFromParent_Done,
     /* 1803437 */   // Label 24490: @1803437
     /* 1803437 */   GIM_Try, /*On fail goto*//*Label 24491*/ GIMT_Encode4(1803523), // Rule ID 12452 //
     /* 1803442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1803453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1803456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1803459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803488 */     // MIs[0] policy
     /* 1803488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803522 */     // GIR_Coverage, 12452,
     /* 1803522 */     GIR_EraseRootFromParent_Done,
     /* 1803523 */   // Label 24491: @1803523
     /* 1803523 */   GIM_Try, /*On fail goto*//*Label 24492*/ GIMT_Encode4(1803609), // Rule ID 12453 //
     /* 1803528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1803539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1803542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1803545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803574 */     // MIs[0] policy
     /* 1803574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1803587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803608 */     // GIR_Coverage, 12453,
     /* 1803608 */     GIR_EraseRootFromParent_Done,
     /* 1803609 */   // Label 24492: @1803609
     /* 1803609 */   GIM_Try, /*On fail goto*//*Label 24493*/ GIMT_Encode4(1803695), // Rule ID 12456 //
     /* 1803614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1803625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1803628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1803631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803660 */     // MIs[0] policy
     /* 1803660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1803673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803694 */     // GIR_Coverage, 12456,
     /* 1803694 */     GIR_EraseRootFromParent_Done,
     /* 1803695 */   // Label 24493: @1803695
     /* 1803695 */   GIM_Try, /*On fail goto*//*Label 24494*/ GIMT_Encode4(1803781), // Rule ID 12457 //
     /* 1803700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1803711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1803714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1803717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803746 */     // MIs[0] policy
     /* 1803746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11656:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1803759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803780 */     // GIR_Coverage, 12457,
     /* 1803780 */     GIR_EraseRootFromParent_Done,
     /* 1803781 */   // Label 24494: @1803781
     /* 1803781 */   GIM_Try, /*On fail goto*//*Label 24495*/ GIMT_Encode4(1803867), // Rule ID 12460 //
     /* 1803786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1803797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1803800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1803803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803832 */     // MIs[0] policy
     /* 1803832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803842 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803866 */     // GIR_Coverage, 12460,
     /* 1803866 */     GIR_EraseRootFromParent_Done,
     /* 1803867 */   // Label 24495: @1803867
     /* 1803867 */   GIM_Try, /*On fail goto*//*Label 24496*/ GIMT_Encode4(1803953), // Rule ID 12461 //
     /* 1803872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1803883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1803886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1803889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803918 */     // MIs[0] policy
     /* 1803918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1803931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1803949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803952 */     // GIR_Coverage, 12461,
     /* 1803952 */     GIR_EraseRootFromParent_Done,
     /* 1803953 */   // Label 24496: @1803953
     /* 1803953 */   GIM_Try, /*On fail goto*//*Label 24497*/ GIMT_Encode4(1804039), // Rule ID 12464 //
     /* 1803958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1803966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1803969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1803972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1803975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804004 */     // MIs[0] policy
     /* 1804004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804038 */     // GIR_Coverage, 12464,
     /* 1804038 */     GIR_EraseRootFromParent_Done,
     /* 1804039 */   // Label 24497: @1804039
     /* 1804039 */   GIM_Try, /*On fail goto*//*Label 24498*/ GIMT_Encode4(1804125), // Rule ID 12465 //
     /* 1804044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1804055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1804058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1804061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804090 */     // MIs[0] policy
     /* 1804090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804124 */     // GIR_Coverage, 12465,
     /* 1804124 */     GIR_EraseRootFromParent_Done,
     /* 1804125 */   // Label 24498: @1804125
     /* 1804125 */   GIM_Try, /*On fail goto*//*Label 24499*/ GIMT_Encode4(1804211), // Rule ID 12468 //
     /* 1804130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804176 */     // MIs[0] policy
     /* 1804176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804210 */     // GIR_Coverage, 12468,
     /* 1804210 */     GIR_EraseRootFromParent_Done,
     /* 1804211 */   // Label 24499: @1804211
     /* 1804211 */   GIM_Try, /*On fail goto*//*Label 24500*/ GIMT_Encode4(1804297), // Rule ID 12469 //
     /* 1804216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1804227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1804230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1804233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804262 */     // MIs[0] policy
     /* 1804262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804296 */     // GIR_Coverage, 12469,
     /* 1804296 */     GIR_EraseRootFromParent_Done,
     /* 1804297 */   // Label 24500: @1804297
     /* 1804297 */   GIM_Try, /*On fail goto*//*Label 24501*/ GIMT_Encode4(1804383), // Rule ID 12472 //
     /* 1804302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804348 */     // MIs[0] policy
     /* 1804348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804358 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804382 */     // GIR_Coverage, 12472,
     /* 1804382 */     GIR_EraseRootFromParent_Done,
     /* 1804383 */   // Label 24501: @1804383
     /* 1804383 */   GIM_Try, /*On fail goto*//*Label 24502*/ GIMT_Encode4(1804469), // Rule ID 12473 //
     /* 1804388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1804399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1804402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1804405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804434 */     // MIs[0] policy
     /* 1804434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11656:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1804447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804468 */     // GIR_Coverage, 12473,
     /* 1804468 */     GIR_EraseRootFromParent_Done,
     /* 1804469 */   // Label 24502: @1804469
     /* 1804469 */   GIM_Try, /*On fail goto*//*Label 24503*/ GIMT_Encode4(1804555), // Rule ID 12476 //
     /* 1804474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1804491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804520 */     // MIs[0] policy
     /* 1804520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1804533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804554 */     // GIR_Coverage, 12476,
     /* 1804554 */     GIR_EraseRootFromParent_Done,
     /* 1804555 */   // Label 24503: @1804555
     /* 1804555 */   GIM_Try, /*On fail goto*//*Label 24504*/ GIMT_Encode4(1804641), // Rule ID 12477 //
     /* 1804560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1804571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1804574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1804577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804606 */     // MIs[0] policy
     /* 1804606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11656:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1804619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804640 */     // GIR_Coverage, 12477,
     /* 1804640 */     GIR_EraseRootFromParent_Done,
     /* 1804641 */   // Label 24504: @1804641
     /* 1804641 */   GIM_Try, /*On fail goto*//*Label 24505*/ GIMT_Encode4(1804727), // Rule ID 12480 //
     /* 1804646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1804657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1804660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1804663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804692 */     // MIs[0] policy
     /* 1804692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804726 */     // GIR_Coverage, 12480,
     /* 1804726 */     GIR_EraseRootFromParent_Done,
     /* 1804727 */   // Label 24505: @1804727
     /* 1804727 */   GIM_Try, /*On fail goto*//*Label 24506*/ GIMT_Encode4(1804813), // Rule ID 12481 //
     /* 1804732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1804743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1804746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1804749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804778 */     // MIs[0] policy
     /* 1804778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11656:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1804791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804812 */     // GIR_Coverage, 12481,
     /* 1804812 */     GIR_EraseRootFromParent_Done,
     /* 1804813 */   // Label 24506: @1804813
     /* 1804813 */   GIM_Try, /*On fail goto*//*Label 24507*/ GIMT_Encode4(1804899), // Rule ID 12484 //
     /* 1804818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1804821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1804829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1804832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1804835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1804838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804864 */     // MIs[0] policy
     /* 1804864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804898 */     // GIR_Coverage, 12484,
     /* 1804898 */     GIR_EraseRootFromParent_Done,
     /* 1804899 */   // Label 24507: @1804899
     /* 1804899 */   GIM_Try, /*On fail goto*//*Label 24508*/ GIMT_Encode4(1804985), // Rule ID 12485 //
     /* 1804904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1804907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1804912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1804915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1804918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1804921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1804924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1804946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804950 */     // MIs[0] policy
     /* 1804950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11656:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1804963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1804981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804984 */     // GIR_Coverage, 12485,
     /* 1804984 */     GIR_EraseRootFromParent_Done,
     /* 1804985 */   // Label 24508: @1804985
     /* 1804985 */   GIM_Try, /*On fail goto*//*Label 24509*/ GIMT_Encode4(1805071), // Rule ID 12488 //
     /* 1804990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1804998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1805010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805036 */     // MIs[0] policy
     /* 1805036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1805049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805070 */     // GIR_Coverage, 12488,
     /* 1805070 */     GIR_EraseRootFromParent_Done,
     /* 1805071 */   // Label 24509: @1805071
     /* 1805071 */   GIM_Try, /*On fail goto*//*Label 24510*/ GIMT_Encode4(1805157), // Rule ID 12489 //
     /* 1805076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1805087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1805090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1805093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1805096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805122 */     // MIs[0] policy
     /* 1805122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805132 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1805135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805156 */     // GIR_Coverage, 12489,
     /* 1805156 */     GIR_EraseRootFromParent_Done,
     /* 1805157 */   // Label 24510: @1805157
     /* 1805157 */   GIM_Try, /*On fail goto*//*Label 24511*/ GIMT_Encode4(1805243), // Rule ID 12492 //
     /* 1805162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1805182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805208 */     // MIs[0] policy
     /* 1805208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1805221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805242 */     // GIR_Coverage, 12492,
     /* 1805242 */     GIR_EraseRootFromParent_Done,
     /* 1805243 */   // Label 24511: @1805243
     /* 1805243 */   GIM_Try, /*On fail goto*//*Label 24512*/ GIMT_Encode4(1805329), // Rule ID 12493 //
     /* 1805248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1805259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1805262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1805265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1805268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805294 */     // MIs[0] policy
     /* 1805294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805304 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1805307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805328 */     // GIR_Coverage, 12493,
     /* 1805328 */     GIR_EraseRootFromParent_Done,
     /* 1805329 */   // Label 24512: @1805329
     /* 1805329 */   GIM_Try, /*On fail goto*//*Label 24513*/ GIMT_Encode4(1805415), // Rule ID 12496 //
     /* 1805334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1805354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805380 */     // MIs[0] policy
     /* 1805380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1805393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805414 */     // GIR_Coverage, 12496,
     /* 1805414 */     GIR_EraseRootFromParent_Done,
     /* 1805415 */   // Label 24513: @1805415
     /* 1805415 */   GIM_Try, /*On fail goto*//*Label 24514*/ GIMT_Encode4(1805501), // Rule ID 12497 //
     /* 1805420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1805431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1805434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1805437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1805440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805466 */     // MIs[0] policy
     /* 1805466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1805479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805500 */     // GIR_Coverage, 12497,
     /* 1805500 */     GIR_EraseRootFromParent_Done,
     /* 1805501 */   // Label 24514: @1805501
     /* 1805501 */   GIM_Try, /*On fail goto*//*Label 24515*/ GIMT_Encode4(1805587), // Rule ID 12500 //
     /* 1805506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1805523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1805526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805552 */     // MIs[0] policy
     /* 1805552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1805565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805586 */     // GIR_Coverage, 12500,
     /* 1805586 */     GIR_EraseRootFromParent_Done,
     /* 1805587 */   // Label 24515: @1805587
     /* 1805587 */   GIM_Try, /*On fail goto*//*Label 24516*/ GIMT_Encode4(1805673), // Rule ID 12501 //
     /* 1805592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1805603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1805606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1805609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1805612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805638 */     // MIs[0] policy
     /* 1805638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1805651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805672 */     // GIR_Coverage, 12501,
     /* 1805672 */     GIR_EraseRootFromParent_Done,
     /* 1805673 */   // Label 24516: @1805673
     /* 1805673 */   GIM_Try, /*On fail goto*//*Label 24517*/ GIMT_Encode4(1805759), // Rule ID 12504 //
     /* 1805678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1805689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1805692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1805695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1805698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805724 */     // MIs[0] policy
     /* 1805724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1805737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805758 */     // GIR_Coverage, 12504,
     /* 1805758 */     GIR_EraseRootFromParent_Done,
     /* 1805759 */   // Label 24517: @1805759
     /* 1805759 */   GIM_Try, /*On fail goto*//*Label 24518*/ GIMT_Encode4(1805845), // Rule ID 12505 //
     /* 1805764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1805775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1805778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1805781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1805784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805810 */     // MIs[0] policy
     /* 1805810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805820 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1805823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805844 */     // GIR_Coverage, 12505,
     /* 1805844 */     GIR_EraseRootFromParent_Done,
     /* 1805845 */   // Label 24518: @1805845
     /* 1805845 */   GIM_Try, /*On fail goto*//*Label 24519*/ GIMT_Encode4(1805931), // Rule ID 12508 //
     /* 1805850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1805861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1805864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1805867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1805870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1805873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805896 */     // MIs[0] policy
     /* 1805896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805906 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1805909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1805927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805930 */     // GIR_Coverage, 12508,
     /* 1805930 */     GIR_EraseRootFromParent_Done,
     /* 1805931 */   // Label 24519: @1805931
     /* 1805931 */   GIM_Try, /*On fail goto*//*Label 24520*/ GIMT_Encode4(1806017), // Rule ID 12509 //
     /* 1805936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1805944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1805947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1805950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1805953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1805956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1805959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805982 */     // MIs[0] policy
     /* 1805982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805992 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1805995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806016 */     // GIR_Coverage, 12509,
     /* 1806016 */     GIR_EraseRootFromParent_Done,
     /* 1806017 */   // Label 24520: @1806017
     /* 1806017 */   GIM_Try, /*On fail goto*//*Label 24521*/ GIMT_Encode4(1806103), // Rule ID 12512 //
     /* 1806022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1806042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806068 */     // MIs[0] policy
     /* 1806068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1806081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806102 */     // GIR_Coverage, 12512,
     /* 1806102 */     GIR_EraseRootFromParent_Done,
     /* 1806103 */   // Label 24521: @1806103
     /* 1806103 */   GIM_Try, /*On fail goto*//*Label 24522*/ GIMT_Encode4(1806189), // Rule ID 12513 //
     /* 1806108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1806119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1806122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1806125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1806128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806154 */     // MIs[0] policy
     /* 1806154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806164 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1806167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806188 */     // GIR_Coverage, 12513,
     /* 1806188 */     GIR_EraseRootFromParent_Done,
     /* 1806189 */   // Label 24522: @1806189
     /* 1806189 */   GIM_Try, /*On fail goto*//*Label 24523*/ GIMT_Encode4(1806275), // Rule ID 12516 //
     /* 1806194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1806214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806240 */     // MIs[0] policy
     /* 1806240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806274 */     // GIR_Coverage, 12516,
     /* 1806274 */     GIR_EraseRootFromParent_Done,
     /* 1806275 */   // Label 24523: @1806275
     /* 1806275 */   GIM_Try, /*On fail goto*//*Label 24524*/ GIMT_Encode4(1806361), // Rule ID 12517 //
     /* 1806280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1806291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1806294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1806297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1806300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806326 */     // MIs[0] policy
     /* 1806326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806360 */     // GIR_Coverage, 12517,
     /* 1806360 */     GIR_EraseRootFromParent_Done,
     /* 1806361 */   // Label 24524: @1806361
     /* 1806361 */   GIM_Try, /*On fail goto*//*Label 24525*/ GIMT_Encode4(1806447), // Rule ID 12520 //
     /* 1806366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1806386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806412 */     // MIs[0] policy
     /* 1806412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806446 */     // GIR_Coverage, 12520,
     /* 1806446 */     GIR_EraseRootFromParent_Done,
     /* 1806447 */   // Label 24525: @1806447
     /* 1806447 */   GIM_Try, /*On fail goto*//*Label 24526*/ GIMT_Encode4(1806533), // Rule ID 12521 //
     /* 1806452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1806463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1806466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1806469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1806472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806498 */     // MIs[0] policy
     /* 1806498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1806511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806532 */     // GIR_Coverage, 12521,
     /* 1806532 */     GIR_EraseRootFromParent_Done,
     /* 1806533 */   // Label 24526: @1806533
     /* 1806533 */   GIM_Try, /*On fail goto*//*Label 24527*/ GIMT_Encode4(1806619), // Rule ID 12524 //
     /* 1806538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1806549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1806552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1806555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1806558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806584 */     // MIs[0] policy
     /* 1806584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1806597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806618 */     // GIR_Coverage, 12524,
     /* 1806618 */     GIR_EraseRootFromParent_Done,
     /* 1806619 */   // Label 24527: @1806619
     /* 1806619 */   GIM_Try, /*On fail goto*//*Label 24528*/ GIMT_Encode4(1806705), // Rule ID 12525 //
     /* 1806624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1806635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1806638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1806641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1806644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806670 */     // MIs[0] policy
     /* 1806670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806680 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1806683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806704 */     // GIR_Coverage, 12525,
     /* 1806704 */     GIR_EraseRootFromParent_Done,
     /* 1806705 */   // Label 24528: @1806705
     /* 1806705 */   GIM_Try, /*On fail goto*//*Label 24529*/ GIMT_Encode4(1806791), // Rule ID 12528 //
     /* 1806710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1806721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1806724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1806727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1806730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806756 */     // MIs[0] policy
     /* 1806756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1806769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806790 */     // GIR_Coverage, 12528,
     /* 1806790 */     GIR_EraseRootFromParent_Done,
     /* 1806791 */   // Label 24529: @1806791
     /* 1806791 */   GIM_Try, /*On fail goto*//*Label 24530*/ GIMT_Encode4(1806877), // Rule ID 12529 //
     /* 1806796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1806807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1806810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1806813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1806816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806842 */     // MIs[0] policy
     /* 1806842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1806855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1806873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806876 */     // GIR_Coverage, 12529,
     /* 1806876 */     GIR_EraseRootFromParent_Done,
     /* 1806877 */   // Label 24530: @1806877
     /* 1806877 */   GIM_Try, /*On fail goto*//*Label 24531*/ GIMT_Encode4(1806963), // Rule ID 12532 //
     /* 1806882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1806885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1806893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1806896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1806899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1806902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806928 */     // MIs[0] policy
     /* 1806928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806938 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1806941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806962 */     // GIR_Coverage, 12532,
     /* 1806962 */     GIR_EraseRootFromParent_Done,
     /* 1806963 */   // Label 24531: @1806963
     /* 1806963 */   GIM_Try, /*On fail goto*//*Label 24532*/ GIMT_Encode4(1807049), // Rule ID 12533 //
     /* 1806968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1806971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1806976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1806979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1806982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1806985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1806988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807014 */     // MIs[0] policy
     /* 1807014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1807027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807048 */     // GIR_Coverage, 12533,
     /* 1807048 */     GIR_EraseRootFromParent_Done,
     /* 1807049 */   // Label 24532: @1807049
     /* 1807049 */   GIM_Try, /*On fail goto*//*Label 24533*/ GIMT_Encode4(1807135), // Rule ID 12536 //
     /* 1807054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1807074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807100 */     // MIs[0] policy
     /* 1807100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1807113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807134 */     // GIR_Coverage, 12536,
     /* 1807134 */     GIR_EraseRootFromParent_Done,
     /* 1807135 */   // Label 24533: @1807135
     /* 1807135 */   GIM_Try, /*On fail goto*//*Label 24534*/ GIMT_Encode4(1807221), // Rule ID 12537 //
     /* 1807140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1807151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1807154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1807157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1807160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807186 */     // MIs[0] policy
     /* 1807186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1807199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807220 */     // GIR_Coverage, 12537,
     /* 1807220 */     GIR_EraseRootFromParent_Done,
     /* 1807221 */   // Label 24534: @1807221
     /* 1807221 */   GIM_Try, /*On fail goto*//*Label 24535*/ GIMT_Encode4(1807307), // Rule ID 12540 //
     /* 1807226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1807246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807272 */     // MIs[0] policy
     /* 1807272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807306 */     // GIR_Coverage, 12540,
     /* 1807306 */     GIR_EraseRootFromParent_Done,
     /* 1807307 */   // Label 24535: @1807307
     /* 1807307 */   GIM_Try, /*On fail goto*//*Label 24536*/ GIMT_Encode4(1807393), // Rule ID 12541 //
     /* 1807312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1807323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1807326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1807329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1807332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807358 */     // MIs[0] policy
     /* 1807358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1807371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807392 */     // GIR_Coverage, 12541,
     /* 1807392 */     GIR_EraseRootFromParent_Done,
     /* 1807393 */   // Label 24536: @1807393
     /* 1807393 */   GIM_Try, /*On fail goto*//*Label 24537*/ GIMT_Encode4(1807479), // Rule ID 12544 //
     /* 1807398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1807401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1807418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807444 */     // MIs[0] policy
     /* 1807444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807478 */     // GIR_Coverage, 12544,
     /* 1807478 */     GIR_EraseRootFromParent_Done,
     /* 1807479 */   // Label 24537: @1807479
     /* 1807479 */   GIM_Try, /*On fail goto*//*Label 24538*/ GIMT_Encode4(1807565), // Rule ID 12545 //
     /* 1807484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1807487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1807495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1807498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1807501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1807504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807530 */     // MIs[0] policy
     /* 1807530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1807543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1807561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807564 */     // GIR_Coverage, 12545,
     /* 1807564 */     GIR_EraseRootFromParent_Done,
     /* 1807565 */   // Label 24538: @1807565
     /* 1807565 */   GIM_Try, /*On fail goto*//*Label 24539*/ GIMT_Encode4(1807651), // Rule ID 12548 //
     /* 1807570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1807581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1807584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1807587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807616 */     // MIs[0] policy
     /* 1807616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1807629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807650 */     // GIR_Coverage, 12548,
     /* 1807650 */     GIR_EraseRootFromParent_Done,
     /* 1807651 */   // Label 24539: @1807651
     /* 1807651 */   GIM_Try, /*On fail goto*//*Label 24540*/ GIMT_Encode4(1807737), // Rule ID 12549 //
     /* 1807656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1807667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1807670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1807673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807702 */     // MIs[0] policy
     /* 1807702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1807715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807736 */     // GIR_Coverage, 12549,
     /* 1807736 */     GIR_EraseRootFromParent_Done,
     /* 1807737 */   // Label 24540: @1807737
     /* 1807737 */   GIM_Try, /*On fail goto*//*Label 24541*/ GIMT_Encode4(1807823), // Rule ID 12552 //
     /* 1807742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1807753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1807756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1807759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807788 */     // MIs[0] policy
     /* 1807788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1807801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807822 */     // GIR_Coverage, 12552,
     /* 1807822 */     GIR_EraseRootFromParent_Done,
     /* 1807823 */   // Label 24541: @1807823
     /* 1807823 */   GIM_Try, /*On fail goto*//*Label 24542*/ GIMT_Encode4(1807909), // Rule ID 12553 //
     /* 1807828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1807839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1807842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1807845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807874 */     // MIs[0] policy
     /* 1807874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1807887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807908 */     // GIR_Coverage, 12553,
     /* 1807908 */     GIR_EraseRootFromParent_Done,
     /* 1807909 */   // Label 24542: @1807909
     /* 1807909 */   GIM_Try, /*On fail goto*//*Label 24543*/ GIMT_Encode4(1807995), // Rule ID 12556 //
     /* 1807914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1807922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1807925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1807928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1807931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807960 */     // MIs[0] policy
     /* 1807960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807970 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1807973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807994 */     // GIR_Coverage, 12556,
     /* 1807994 */     GIR_EraseRootFromParent_Done,
     /* 1807995 */   // Label 24543: @1807995
     /* 1807995 */   GIM_Try, /*On fail goto*//*Label 24544*/ GIMT_Encode4(1808081), // Rule ID 12557 //
     /* 1808000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1808011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1808014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808046 */     // MIs[0] policy
     /* 1808046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808056 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11660:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808080 */     // GIR_Coverage, 12557,
     /* 1808080 */     GIR_EraseRootFromParent_Done,
     /* 1808081 */   // Label 24544: @1808081
     /* 1808081 */   GIM_Try, /*On fail goto*//*Label 24545*/ GIMT_Encode4(1808167), // Rule ID 12560 //
     /* 1808086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808132 */     // MIs[0] policy
     /* 1808132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1808145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808166 */     // GIR_Coverage, 12560,
     /* 1808166 */     GIR_EraseRootFromParent_Done,
     /* 1808167 */   // Label 24545: @1808167
     /* 1808167 */   GIM_Try, /*On fail goto*//*Label 24546*/ GIMT_Encode4(1808253), // Rule ID 12561 //
     /* 1808172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1808183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1808186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1808189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808218 */     // MIs[0] policy
     /* 1808218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1808231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808252 */     // GIR_Coverage, 12561,
     /* 1808252 */     GIR_EraseRootFromParent_Done,
     /* 1808253 */   // Label 24546: @1808253
     /* 1808253 */   GIM_Try, /*On fail goto*//*Label 24547*/ GIMT_Encode4(1808339), // Rule ID 12564 //
     /* 1808258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808304 */     // MIs[0] policy
     /* 1808304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1808317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808338 */     // GIR_Coverage, 12564,
     /* 1808338 */     GIR_EraseRootFromParent_Done,
     /* 1808339 */   // Label 24547: @1808339
     /* 1808339 */   GIM_Try, /*On fail goto*//*Label 24548*/ GIMT_Encode4(1808425), // Rule ID 12565 //
     /* 1808344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1808355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1808358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1808361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1808367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808390 */     // MIs[0] policy
     /* 1808390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1808403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808424 */     // GIR_Coverage, 12565,
     /* 1808424 */     GIR_EraseRootFromParent_Done,
     /* 1808425 */   // Label 24548: @1808425
     /* 1808425 */   GIM_Try, /*On fail goto*//*Label 24549*/ GIMT_Encode4(1808511), // Rule ID 12568 //
     /* 1808430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1808447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808476 */     // MIs[0] policy
     /* 1808476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808486 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1808489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808510 */     // GIR_Coverage, 12568,
     /* 1808510 */     GIR_EraseRootFromParent_Done,
     /* 1808511 */   // Label 24549: @1808511
     /* 1808511 */   GIM_Try, /*On fail goto*//*Label 24550*/ GIMT_Encode4(1808597), // Rule ID 12569 //
     /* 1808516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1808527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1808530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1808533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1808539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808562 */     // MIs[0] policy
     /* 1808562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808572 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1808575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808596 */     // GIR_Coverage, 12569,
     /* 1808596 */     GIR_EraseRootFromParent_Done,
     /* 1808597 */   // Label 24550: @1808597
     /* 1808597 */   GIM_Try, /*On fail goto*//*Label 24551*/ GIMT_Encode4(1808683), // Rule ID 12572 //
     /* 1808602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1808613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1808616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1808619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808648 */     // MIs[0] policy
     /* 1808648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808658 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1808661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808682 */     // GIR_Coverage, 12572,
     /* 1808682 */     GIR_EraseRootFromParent_Done,
     /* 1808683 */   // Label 24551: @1808683
     /* 1808683 */   GIM_Try, /*On fail goto*//*Label 24552*/ GIMT_Encode4(1808769), // Rule ID 12573 //
     /* 1808688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1808699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1808702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1808705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808734 */     // MIs[0] policy
     /* 1808734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808744 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1808747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808768 */     // GIR_Coverage, 12573,
     /* 1808768 */     GIR_EraseRootFromParent_Done,
     /* 1808769 */   // Label 24552: @1808769
     /* 1808769 */   GIM_Try, /*On fail goto*//*Label 24553*/ GIMT_Encode4(1808855), // Rule ID 12576 //
     /* 1808774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1808785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1808788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1808791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808820 */     // MIs[0] policy
     /* 1808820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808854 */     // GIR_Coverage, 12576,
     /* 1808854 */     GIR_EraseRootFromParent_Done,
     /* 1808855 */   // Label 24553: @1808855
     /* 1808855 */   GIM_Try, /*On fail goto*//*Label 24554*/ GIMT_Encode4(1808941), // Rule ID 12577 //
     /* 1808860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1808871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1808874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1808877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808906 */     // MIs[0] policy
     /* 1808906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11660:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1808919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808940 */     // GIR_Coverage, 12577,
     /* 1808940 */     GIR_EraseRootFromParent_Done,
     /* 1808941 */   // Label 24554: @1808941
     /* 1808941 */   GIM_Try, /*On fail goto*//*Label 24555*/ GIMT_Encode4(1809027), // Rule ID 12580 //
     /* 1808946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1808954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1808957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1808960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1808963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808992 */     // MIs[0] policy
     /* 1808992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809026 */     // GIR_Coverage, 12580,
     /* 1809026 */     GIR_EraseRootFromParent_Done,
     /* 1809027 */   // Label 24555: @1809027
     /* 1809027 */   GIM_Try, /*On fail goto*//*Label 24556*/ GIMT_Encode4(1809113), // Rule ID 12581 //
     /* 1809032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1809043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1809046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809078 */     // MIs[0] policy
     /* 1809078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809112 */     // GIR_Coverage, 12581,
     /* 1809112 */     GIR_EraseRootFromParent_Done,
     /* 1809113 */   // Label 24556: @1809113
     /* 1809113 */   GIM_Try, /*On fail goto*//*Label 24557*/ GIMT_Encode4(1809199), // Rule ID 12584 //
     /* 1809118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809164 */     // MIs[0] policy
     /* 1809164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809198 */     // GIR_Coverage, 12584,
     /* 1809198 */     GIR_EraseRootFromParent_Done,
     /* 1809199 */   // Label 24557: @1809199
     /* 1809199 */   GIM_Try, /*On fail goto*//*Label 24558*/ GIMT_Encode4(1809285), // Rule ID 12585 //
     /* 1809204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1809215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1809218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1809221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809250 */     // MIs[0] policy
     /* 1809250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809284 */     // GIR_Coverage, 12585,
     /* 1809284 */     GIR_EraseRootFromParent_Done,
     /* 1809285 */   // Label 24558: @1809285
     /* 1809285 */   GIM_Try, /*On fail goto*//*Label 24559*/ GIMT_Encode4(1809371), // Rule ID 12588 //
     /* 1809290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809336 */     // MIs[0] policy
     /* 1809336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809346 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809370 */     // GIR_Coverage, 12588,
     /* 1809370 */     GIR_EraseRootFromParent_Done,
     /* 1809371 */   // Label 24559: @1809371
     /* 1809371 */   GIM_Try, /*On fail goto*//*Label 24560*/ GIMT_Encode4(1809457), // Rule ID 12589 //
     /* 1809376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1809387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1809390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1809393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1809399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1809406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1809410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809422 */     // MIs[0] policy
     /* 1809422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809432 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1809435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809456 */     // GIR_Coverage, 12589,
     /* 1809456 */     GIR_EraseRootFromParent_Done,
     /* 1809457 */   // Label 24560: @1809457
     /* 1809457 */   GIM_Try, /*On fail goto*//*Label 24561*/ GIMT_Encode4(1809543), // Rule ID 12592 //
     /* 1809462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1809473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1809476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809508 */     // MIs[0] policy
     /* 1809508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809542 */     // GIR_Coverage, 12592,
     /* 1809542 */     GIR_EraseRootFromParent_Done,
     /* 1809543 */   // Label 24561: @1809543
     /* 1809543 */   GIM_Try, /*On fail goto*//*Label 24562*/ GIMT_Encode4(1809629), // Rule ID 12593 //
     /* 1809548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1809551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1809559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1809562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809594 */     // MIs[0] policy
     /* 1809594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809604 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11660:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1809607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809628 */     // GIR_Coverage, 12593,
     /* 1809628 */     GIR_EraseRootFromParent_Done,
     /* 1809629 */   // Label 24562: @1809629
     /* 1809629 */   GIM_Try, /*On fail goto*//*Label 24563*/ GIMT_Encode4(1809715), // Rule ID 12596 //
     /* 1809634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1809645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1809648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1809651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809680 */     // MIs[0] policy
     /* 1809680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809714 */     // GIR_Coverage, 12596,
     /* 1809714 */     GIR_EraseRootFromParent_Done,
     /* 1809715 */   // Label 24563: @1809715
     /* 1809715 */   GIM_Try, /*On fail goto*//*Label 24564*/ GIMT_Encode4(1809801), // Rule ID 12597 //
     /* 1809720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1809723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1809731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1809734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1809737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1809750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809766 */     // MIs[0] policy
     /* 1809766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11660:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1809779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809800 */     // GIR_Coverage, 12597,
     /* 1809800 */     GIR_EraseRootFromParent_Done,
     /* 1809801 */   // Label 24564: @1809801
     /* 1809801 */   GIM_Try, /*On fail goto*//*Label 24565*/ GIMT_Encode4(1809887), // Rule ID 12600 //
     /* 1809806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1809817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1809820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1809823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809852 */     // MIs[0] policy
     /* 1809852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809886 */     // GIR_Coverage, 12600,
     /* 1809886 */     GIR_EraseRootFromParent_Done,
     /* 1809887 */   // Label 24565: @1809887
     /* 1809887 */   GIM_Try, /*On fail goto*//*Label 24566*/ GIMT_Encode4(1809973), // Rule ID 12601 //
     /* 1809892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1809895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1809903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1809906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1809909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1809912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1809922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1809926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1809930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1809934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809938 */     // MIs[0] policy
     /* 1809938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11660:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1809951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1809955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809972 */     // GIR_Coverage, 12601,
     /* 1809972 */     GIR_EraseRootFromParent_Done,
     /* 1809973 */   // Label 24566: @1809973
     /* 1809973 */   GIM_Try, /*On fail goto*//*Label 24567*/ GIMT_Encode4(1810059), // Rule ID 12604 //
     /* 1809978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1809981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1809986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1809989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1809992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1809995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1809998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810024 */     // MIs[0] policy
     /* 1810024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1810037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810058 */     // GIR_Coverage, 12604,
     /* 1810058 */     GIR_EraseRootFromParent_Done,
     /* 1810059 */   // Label 24567: @1810059
     /* 1810059 */   GIM_Try, /*On fail goto*//*Label 24568*/ GIMT_Encode4(1810145), // Rule ID 12605 //
     /* 1810064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1810067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1810072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1810075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1810078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1810081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1810084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1810106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810110 */     // MIs[0] policy
     /* 1810110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810120 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11660:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1810123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810144 */     // GIR_Coverage, 12605,
     /* 1810144 */     GIR_EraseRootFromParent_Done,
     /* 1810145 */   // Label 24568: @1810145
     /* 1810145 */   GIM_Try, /*On fail goto*//*Label 24569*/ GIMT_Encode4(1810231), // Rule ID 12608 //
     /* 1810150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1810170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810196 */     // MIs[0] policy
     /* 1810196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810206 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1810209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810230 */     // GIR_Coverage, 12608,
     /* 1810230 */     GIR_EraseRootFromParent_Done,
     /* 1810231 */   // Label 24569: @1810231
     /* 1810231 */   GIM_Try, /*On fail goto*//*Label 24570*/ GIMT_Encode4(1810317), // Rule ID 12609 //
     /* 1810236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1810247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1810250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1810253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1810256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810282 */     // MIs[0] policy
     /* 1810282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810292 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1810295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810316 */     // GIR_Coverage, 12609,
     /* 1810316 */     GIR_EraseRootFromParent_Done,
     /* 1810317 */   // Label 24570: @1810317
     /* 1810317 */   GIM_Try, /*On fail goto*//*Label 24571*/ GIMT_Encode4(1810403), // Rule ID 12612 //
     /* 1810322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1810342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810368 */     // MIs[0] policy
     /* 1810368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1810381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810402 */     // GIR_Coverage, 12612,
     /* 1810402 */     GIR_EraseRootFromParent_Done,
     /* 1810403 */   // Label 24571: @1810403
     /* 1810403 */   GIM_Try, /*On fail goto*//*Label 24572*/ GIMT_Encode4(1810489), // Rule ID 12613 //
     /* 1810408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1810419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1810422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1810425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1810428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810454 */     // MIs[0] policy
     /* 1810454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1810467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810488 */     // GIR_Coverage, 12613,
     /* 1810488 */     GIR_EraseRootFromParent_Done,
     /* 1810489 */   // Label 24572: @1810489
     /* 1810489 */   GIM_Try, /*On fail goto*//*Label 24573*/ GIMT_Encode4(1810575), // Rule ID 12616 //
     /* 1810494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1810511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1810514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810540 */     // MIs[0] policy
     /* 1810540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1810553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810574 */     // GIR_Coverage, 12616,
     /* 1810574 */     GIR_EraseRootFromParent_Done,
     /* 1810575 */   // Label 24573: @1810575
     /* 1810575 */   GIM_Try, /*On fail goto*//*Label 24574*/ GIMT_Encode4(1810661), // Rule ID 12617 //
     /* 1810580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1810591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1810594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1810597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1810600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1810603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810626 */     // MIs[0] policy
     /* 1810626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1810639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810660 */     // GIR_Coverage, 12617,
     /* 1810660 */     GIR_EraseRootFromParent_Done,
     /* 1810661 */   // Label 24574: @1810661
     /* 1810661 */   GIM_Try, /*On fail goto*//*Label 24575*/ GIMT_Encode4(1810747), // Rule ID 12620 //
     /* 1810666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1810677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1810680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1810683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1810686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810712 */     // MIs[0] policy
     /* 1810712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810722 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1810725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810746 */     // GIR_Coverage, 12620,
     /* 1810746 */     GIR_EraseRootFromParent_Done,
     /* 1810747 */   // Label 24575: @1810747
     /* 1810747 */   GIM_Try, /*On fail goto*//*Label 24576*/ GIMT_Encode4(1810833), // Rule ID 12621 //
     /* 1810752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1810763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1810766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1810769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1810772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810798 */     // MIs[0] policy
     /* 1810798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1810811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810832 */     // GIR_Coverage, 12621,
     /* 1810832 */     GIR_EraseRootFromParent_Done,
     /* 1810833 */   // Label 24576: @1810833
     /* 1810833 */   GIM_Try, /*On fail goto*//*Label 24577*/ GIMT_Encode4(1810919), // Rule ID 12624 //
     /* 1810838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1810849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1810852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1810855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1810858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1810861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810884 */     // MIs[0] policy
     /* 1810884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810894 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1810897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810918 */     // GIR_Coverage, 12624,
     /* 1810918 */     GIR_EraseRootFromParent_Done,
     /* 1810919 */   // Label 24577: @1810919
     /* 1810919 */   GIM_Try, /*On fail goto*//*Label 24578*/ GIMT_Encode4(1811005), // Rule ID 12625 //
     /* 1810924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1810932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1810935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1810938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1810941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1810944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1810947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810970 */     // MIs[0] policy
     /* 1810970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1810983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1810987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811004 */     // GIR_Coverage, 12625,
     /* 1811004 */     GIR_EraseRootFromParent_Done,
     /* 1811005 */   // Label 24578: @1811005
     /* 1811005 */   GIM_Try, /*On fail goto*//*Label 24579*/ GIMT_Encode4(1811091), // Rule ID 12628 //
     /* 1811010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1811030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811056 */     // MIs[0] policy
     /* 1811056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811066 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811090 */     // GIR_Coverage, 12628,
     /* 1811090 */     GIR_EraseRootFromParent_Done,
     /* 1811091 */   // Label 24579: @1811091
     /* 1811091 */   GIM_Try, /*On fail goto*//*Label 24580*/ GIMT_Encode4(1811177), // Rule ID 12629 //
     /* 1811096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1811113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1811116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811142 */     // MIs[0] policy
     /* 1811142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811152 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1811173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811176 */     // GIR_Coverage, 12629,
     /* 1811176 */     GIR_EraseRootFromParent_Done,
     /* 1811177 */   // Label 24580: @1811177
     /* 1811177 */   GIM_Try, /*On fail goto*//*Label 24581*/ GIMT_Encode4(1811263), // Rule ID 12632 //
     /* 1811182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1811202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811228 */     // MIs[0] policy
     /* 1811228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811238 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1811241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811262 */     // GIR_Coverage, 12632,
     /* 1811262 */     GIR_EraseRootFromParent_Done,
     /* 1811263 */   // Label 24581: @1811263
     /* 1811263 */   GIM_Try, /*On fail goto*//*Label 24582*/ GIMT_Encode4(1811349), // Rule ID 12633 //
     /* 1811268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1811279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1811282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1811285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1811288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1811291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811314 */     // MIs[0] policy
     /* 1811314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1811327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811348 */     // GIR_Coverage, 12633,
     /* 1811348 */     GIR_EraseRootFromParent_Done,
     /* 1811349 */   // Label 24582: @1811349
     /* 1811349 */   GIM_Try, /*On fail goto*//*Label 24583*/ GIMT_Encode4(1811435), // Rule ID 12636 //
     /* 1811354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1811374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811400 */     // MIs[0] policy
     /* 1811400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811434 */     // GIR_Coverage, 12636,
     /* 1811434 */     GIR_EraseRootFromParent_Done,
     /* 1811435 */   // Label 24583: @1811435
     /* 1811435 */   GIM_Try, /*On fail goto*//*Label 24584*/ GIMT_Encode4(1811521), // Rule ID 12637 //
     /* 1811440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1811451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1811454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1811457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1811460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1811470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811486 */     // MIs[0] policy
     /* 1811486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1811499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811520 */     // GIR_Coverage, 12637,
     /* 1811520 */     GIR_EraseRootFromParent_Done,
     /* 1811521 */   // Label 24584: @1811521
     /* 1811521 */   GIM_Try, /*On fail goto*//*Label 24585*/ GIMT_Encode4(1811607), // Rule ID 12640 //
     /* 1811526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1811543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1811546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811572 */     // MIs[0] policy
     /* 1811572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1811585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811606 */     // GIR_Coverage, 12640,
     /* 1811606 */     GIR_EraseRootFromParent_Done,
     /* 1811607 */   // Label 24585: @1811607
     /* 1811607 */   GIM_Try, /*On fail goto*//*Label 24586*/ GIMT_Encode4(1811693), // Rule ID 12641 //
     /* 1811612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1811629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1811632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1811654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811658 */     // MIs[0] policy
     /* 1811658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1811671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811692 */     // GIR_Coverage, 12641,
     /* 1811692 */     GIR_EraseRootFromParent_Done,
     /* 1811693 */   // Label 24586: @1811693
     /* 1811693 */   GIM_Try, /*On fail goto*//*Label 24587*/ GIMT_Encode4(1811779), // Rule ID 12644 //
     /* 1811698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1811709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1811712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1811715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1811718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811744 */     // MIs[0] policy
     /* 1811744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1811757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811778 */     // GIR_Coverage, 12644,
     /* 1811778 */     GIR_EraseRootFromParent_Done,
     /* 1811779 */   // Label 24587: @1811779
     /* 1811779 */   GIM_Try, /*On fail goto*//*Label 24588*/ GIMT_Encode4(1811865), // Rule ID 12645 //
     /* 1811784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1811795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1811798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1811801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1811804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811830 */     // MIs[0] policy
     /* 1811830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1811843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811864 */     // GIR_Coverage, 12645,
     /* 1811864 */     GIR_EraseRootFromParent_Done,
     /* 1811865 */   // Label 24588: @1811865
     /* 1811865 */   GIM_Try, /*On fail goto*//*Label 24589*/ GIMT_Encode4(1811951), // Rule ID 12648 //
     /* 1811870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1811881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1811884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1811887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1811890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811916 */     // MIs[0] policy
     /* 1811916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1811929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1811933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811950 */     // GIR_Coverage, 12648,
     /* 1811950 */     GIR_EraseRootFromParent_Done,
     /* 1811951 */   // Label 24589: @1811951
     /* 1811951 */   GIM_Try, /*On fail goto*//*Label 24590*/ GIMT_Encode4(1812037), // Rule ID 12649 //
     /* 1811956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1811964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1811967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1811970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1811973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1811976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812002 */     // MIs[0] policy
     /* 1812002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812036 */     // GIR_Coverage, 12649,
     /* 1812036 */     GIR_EraseRootFromParent_Done,
     /* 1812037 */   // Label 24590: @1812037
     /* 1812037 */   GIM_Try, /*On fail goto*//*Label 24591*/ GIMT_Encode4(1812123), // Rule ID 12652 //
     /* 1812042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1812062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812088 */     // MIs[0] policy
     /* 1812088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1812101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812122 */     // GIR_Coverage, 12652,
     /* 1812122 */     GIR_EraseRootFromParent_Done,
     /* 1812123 */   // Label 24591: @1812123
     /* 1812123 */   GIM_Try, /*On fail goto*//*Label 24592*/ GIMT_Encode4(1812209), // Rule ID 12653 //
     /* 1812128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1812139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1812142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1812145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1812148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812174 */     // MIs[0] policy
     /* 1812174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1812187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812208 */     // GIR_Coverage, 12653,
     /* 1812208 */     GIR_EraseRootFromParent_Done,
     /* 1812209 */   // Label 24592: @1812209
     /* 1812209 */   GIM_Try, /*On fail goto*//*Label 24593*/ GIMT_Encode4(1812295), // Rule ID 12656 //
     /* 1812214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1812234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812260 */     // MIs[0] policy
     /* 1812260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812294 */     // GIR_Coverage, 12656,
     /* 1812294 */     GIR_EraseRootFromParent_Done,
     /* 1812295 */   // Label 24593: @1812295
     /* 1812295 */   GIM_Try, /*On fail goto*//*Label 24594*/ GIMT_Encode4(1812381), // Rule ID 12657 //
     /* 1812300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1812311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1812314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1812317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1812320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1812330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812346 */     // MIs[0] policy
     /* 1812346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812356 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1812359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812380 */     // GIR_Coverage, 12657,
     /* 1812380 */     GIR_EraseRootFromParent_Done,
     /* 1812381 */   // Label 24594: @1812381
     /* 1812381 */   GIM_Try, /*On fail goto*//*Label 24595*/ GIMT_Encode4(1812467), // Rule ID 12660 //
     /* 1812386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1812406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812432 */     // MIs[0] policy
     /* 1812432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812442 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812466 */     // GIR_Coverage, 12660,
     /* 1812466 */     GIR_EraseRootFromParent_Done,
     /* 1812467 */   // Label 24595: @1812467
     /* 1812467 */   GIM_Try, /*On fail goto*//*Label 24596*/ GIMT_Encode4(1812553), // Rule ID 12661 //
     /* 1812472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1812489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1812492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1812514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812518 */     // MIs[0] policy
     /* 1812518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812528 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1812531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812552 */     // GIR_Coverage, 12661,
     /* 1812552 */     GIR_EraseRootFromParent_Done,
     /* 1812553 */   // Label 24596: @1812553
     /* 1812553 */   GIM_Try, /*On fail goto*//*Label 24597*/ GIMT_Encode4(1812639), // Rule ID 12664 //
     /* 1812558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1812561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1812569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1812572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1812575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1812578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812604 */     // MIs[0] policy
     /* 1812604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812638 */     // GIR_Coverage, 12664,
     /* 1812638 */     GIR_EraseRootFromParent_Done,
     /* 1812639 */   // Label 24597: @1812639
     /* 1812639 */   GIM_Try, /*On fail goto*//*Label 24598*/ GIMT_Encode4(1812725), // Rule ID 12665 //
     /* 1812644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1812647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1812655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1812658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1812661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1812664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812690 */     // MIs[0] policy
     /* 1812690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1812703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1812721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812724 */     // GIR_Coverage, 12665,
     /* 1812724 */     GIR_EraseRootFromParent_Done,
     /* 1812725 */   // Label 24598: @1812725
     /* 1812725 */   GIM_Try, /*On fail goto*//*Label 24599*/ GIMT_Encode4(1812811), // Rule ID 12668 //
     /* 1812730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1812741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1812744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1812747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812776 */     // MIs[0] policy
     /* 1812776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1812789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812810 */     // GIR_Coverage, 12668,
     /* 1812810 */     GIR_EraseRootFromParent_Done,
     /* 1812811 */   // Label 24599: @1812811
     /* 1812811 */   GIM_Try, /*On fail goto*//*Label 24600*/ GIMT_Encode4(1812897), // Rule ID 12669 //
     /* 1812816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1812827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1812830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1812833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1812836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812862 */     // MIs[0] policy
     /* 1812862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1812875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812896 */     // GIR_Coverage, 12669,
     /* 1812896 */     GIR_EraseRootFromParent_Done,
     /* 1812897 */   // Label 24600: @1812897
     /* 1812897 */   GIM_Try, /*On fail goto*//*Label 24601*/ GIMT_Encode4(1812983), // Rule ID 12672 //
     /* 1812902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1812913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1812916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1812919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1812922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812948 */     // MIs[0] policy
     /* 1812948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1812961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1812965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812982 */     // GIR_Coverage, 12672,
     /* 1812982 */     GIR_EraseRootFromParent_Done,
     /* 1812983 */   // Label 24601: @1812983
     /* 1812983 */   GIM_Try, /*On fail goto*//*Label 24602*/ GIMT_Encode4(1813069), // Rule ID 12673 //
     /* 1812988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1812996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1812999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1813005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813034 */     // MIs[0] policy
     /* 1813034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813068 */     // GIR_Coverage, 12673,
     /* 1813068 */     GIR_EraseRootFromParent_Done,
     /* 1813069 */   // Label 24602: @1813069
     /* 1813069 */   GIM_Try, /*On fail goto*//*Label 24603*/ GIMT_Encode4(1813155), // Rule ID 12676 //
     /* 1813074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813120 */     // MIs[0] policy
     /* 1813120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1813133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813154 */     // GIR_Coverage, 12676,
     /* 1813154 */     GIR_EraseRootFromParent_Done,
     /* 1813155 */   // Label 24603: @1813155
     /* 1813155 */   GIM_Try, /*On fail goto*//*Label 24604*/ GIMT_Encode4(1813241), // Rule ID 12677 //
     /* 1813160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1813177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813206 */     // MIs[0] policy
     /* 1813206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813216 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11658:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1813219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813240 */     // GIR_Coverage, 12677,
     /* 1813240 */     GIR_EraseRootFromParent_Done,
     /* 1813241 */   // Label 24604: @1813241
     /* 1813241 */   GIM_Try, /*On fail goto*//*Label 24605*/ GIMT_Encode4(1813327), // Rule ID 12680 //
     /* 1813246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1813263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813292 */     // MIs[0] policy
     /* 1813292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1813305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813326 */     // GIR_Coverage, 12680,
     /* 1813326 */     GIR_EraseRootFromParent_Done,
     /* 1813327 */   // Label 24605: @1813327
     /* 1813327 */   GIM_Try, /*On fail goto*//*Label 24606*/ GIMT_Encode4(1813413), // Rule ID 12681 //
     /* 1813332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1813343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1813346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1813349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1813362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813378 */     // MIs[0] policy
     /* 1813378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813388 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1813391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813412 */     // GIR_Coverage, 12681,
     /* 1813412 */     GIR_EraseRootFromParent_Done,
     /* 1813413 */   // Label 24606: @1813413
     /* 1813413 */   GIM_Try, /*On fail goto*//*Label 24607*/ GIMT_Encode4(1813499), // Rule ID 12684 //
     /* 1813418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1813435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813464 */     // MIs[0] policy
     /* 1813464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1813477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813498 */     // GIR_Coverage, 12684,
     /* 1813498 */     GIR_EraseRootFromParent_Done,
     /* 1813499 */   // Label 24607: @1813499
     /* 1813499 */   GIM_Try, /*On fail goto*//*Label 24608*/ GIMT_Encode4(1813585), // Rule ID 12685 //
     /* 1813504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1813515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1813518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1813521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1813527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1813534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1813542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813550 */     // MIs[0] policy
     /* 1813550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1813563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813584 */     // GIR_Coverage, 12685,
     /* 1813584 */     GIR_EraseRootFromParent_Done,
     /* 1813585 */   // Label 24608: @1813585
     /* 1813585 */   GIM_Try, /*On fail goto*//*Label 24609*/ GIMT_Encode4(1813671), // Rule ID 12688 //
     /* 1813590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1813601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1813604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1813607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1813613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813636 */     // MIs[0] policy
     /* 1813636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1813649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813670 */     // GIR_Coverage, 12688,
     /* 1813670 */     GIR_EraseRootFromParent_Done,
     /* 1813671 */   // Label 24609: @1813671
     /* 1813671 */   GIM_Try, /*On fail goto*//*Label 24610*/ GIMT_Encode4(1813757), // Rule ID 12689 //
     /* 1813676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1813687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1813690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1813693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1813699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1813706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1813710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1813714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813722 */     // MIs[0] policy
     /* 1813722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813732 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1813735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813756 */     // GIR_Coverage, 12689,
     /* 1813756 */     GIR_EraseRootFromParent_Done,
     /* 1813757 */   // Label 24610: @1813757
     /* 1813757 */   GIM_Try, /*On fail goto*//*Label 24611*/ GIMT_Encode4(1813843), // Rule ID 12692 //
     /* 1813762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1813773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1813776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1813779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813808 */     // MIs[0] policy
     /* 1813808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813842 */     // GIR_Coverage, 12692,
     /* 1813842 */     GIR_EraseRootFromParent_Done,
     /* 1813843 */   // Label 24611: @1813843
     /* 1813843 */   GIM_Try, /*On fail goto*//*Label 24612*/ GIMT_Encode4(1813929), // Rule ID 12693 //
     /* 1813848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1813859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1813862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1813865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1813868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813894 */     // MIs[0] policy
     /* 1813894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813904 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1813907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813928 */     // GIR_Coverage, 12693,
     /* 1813928 */     GIR_EraseRootFromParent_Done,
     /* 1813929 */   // Label 24612: @1813929
     /* 1813929 */   GIM_Try, /*On fail goto*//*Label 24613*/ GIMT_Encode4(1814015), // Rule ID 12696 //
     /* 1813934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1813942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1813945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1813948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1813951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1813954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813980 */     // MIs[0] policy
     /* 1813980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1813993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1813997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814014 */     // GIR_Coverage, 12696,
     /* 1814014 */     GIR_EraseRootFromParent_Done,
     /* 1814015 */   // Label 24613: @1814015
     /* 1814015 */   GIM_Try, /*On fail goto*//*Label 24614*/ GIMT_Encode4(1814101), // Rule ID 12697 //
     /* 1814020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1814031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1814034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1814037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814066 */     // MIs[0] policy
     /* 1814066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814076 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11658:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814100 */     // GIR_Coverage, 12697,
     /* 1814100 */     GIR_EraseRootFromParent_Done,
     /* 1814101 */   // Label 24614: @1814101
     /* 1814101 */   GIM_Try, /*On fail goto*//*Label 24615*/ GIMT_Encode4(1814187), // Rule ID 12700 //
     /* 1814106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1814117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1814120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814152 */     // MIs[0] policy
     /* 1814152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814186 */     // GIR_Coverage, 12700,
     /* 1814186 */     GIR_EraseRootFromParent_Done,
     /* 1814187 */   // Label 24615: @1814187
     /* 1814187 */   GIM_Try, /*On fail goto*//*Label 24616*/ GIMT_Encode4(1814273), // Rule ID 12701 //
     /* 1814192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1814203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1814206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1814209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814238 */     // MIs[0] policy
     /* 1814238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814272 */     // GIR_Coverage, 12701,
     /* 1814272 */     GIR_EraseRootFromParent_Done,
     /* 1814273 */   // Label 24616: @1814273
     /* 1814273 */   GIM_Try, /*On fail goto*//*Label 24617*/ GIMT_Encode4(1814359), // Rule ID 12704 //
     /* 1814278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1814295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814324 */     // MIs[0] policy
     /* 1814324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814358 */     // GIR_Coverage, 12704,
     /* 1814358 */     GIR_EraseRootFromParent_Done,
     /* 1814359 */   // Label 24617: @1814359
     /* 1814359 */   GIM_Try, /*On fail goto*//*Label 24618*/ GIMT_Encode4(1814445), // Rule ID 12705 //
     /* 1814364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1814375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1814378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1814381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814410 */     // MIs[0] policy
     /* 1814410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1814423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814444 */     // GIR_Coverage, 12705,
     /* 1814444 */     GIR_EraseRootFromParent_Done,
     /* 1814445 */   // Label 24618: @1814445
     /* 1814445 */   GIM_Try, /*On fail goto*//*Label 24619*/ GIMT_Encode4(1814531), // Rule ID 12708 //
     /* 1814450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1814461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1814464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1814467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814496 */     // MIs[0] policy
     /* 1814496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814530 */     // GIR_Coverage, 12708,
     /* 1814530 */     GIR_EraseRootFromParent_Done,
     /* 1814531 */   // Label 24619: @1814531
     /* 1814531 */   GIM_Try, /*On fail goto*//*Label 24620*/ GIMT_Encode4(1814617), // Rule ID 12709 //
     /* 1814536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1814547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1814550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1814553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814582 */     // MIs[0] policy
     /* 1814582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1814595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814616 */     // GIR_Coverage, 12709,
     /* 1814616 */     GIR_EraseRootFromParent_Done,
     /* 1814617 */   // Label 24620: @1814617
     /* 1814617 */   GIM_Try, /*On fail goto*//*Label 24621*/ GIMT_Encode4(1814703), // Rule ID 12712 //
     /* 1814622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1814625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1814633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1814636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1814639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814668 */     // MIs[0] policy
     /* 1814668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814702 */     // GIR_Coverage, 12712,
     /* 1814702 */     GIR_EraseRootFromParent_Done,
     /* 1814703 */   // Label 24621: @1814703
     /* 1814703 */   GIM_Try, /*On fail goto*//*Label 24622*/ GIMT_Encode4(1814789), // Rule ID 12713 //
     /* 1814708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1814711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1814719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1814722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1814725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1814731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814754 */     // MIs[0] policy
     /* 1814754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814764 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11658:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1814767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814788 */     // GIR_Coverage, 12713,
     /* 1814788 */     GIR_EraseRootFromParent_Done,
     /* 1814789 */   // Label 24622: @1814789
     /* 1814789 */   GIM_Try, /*On fail goto*//*Label 24623*/ GIMT_Encode4(1814875), // Rule ID 12716 //
     /* 1814794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1814797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1814805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1814808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1814811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814840 */     // MIs[0] policy
     /* 1814840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814874 */     // GIR_Coverage, 12716,
     /* 1814874 */     GIR_EraseRootFromParent_Done,
     /* 1814875 */   // Label 24623: @1814875
     /* 1814875 */   GIM_Try, /*On fail goto*//*Label 24624*/ GIMT_Encode4(1814961), // Rule ID 12717 //
     /* 1814880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1814883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1814891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1814894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1814897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1814900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1814903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814926 */     // MIs[0] policy
     /* 1814926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11658:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1814939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1814943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1814957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814960 */     // GIR_Coverage, 12717,
     /* 1814960 */     GIR_EraseRootFromParent_Done,
     /* 1814961 */   // Label 24624: @1814961
     /* 1814961 */   GIM_Try, /*On fail goto*//*Label 24625*/ GIMT_Encode4(1815047), // Rule ID 12720 //
     /* 1814966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1814969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1814974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1814977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1814980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1814983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1814986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1814989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815012 */     // MIs[0] policy
     /* 1815012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815022 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1815025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815046 */     // GIR_Coverage, 12720,
     /* 1815046 */     GIR_EraseRootFromParent_Done,
     /* 1815047 */   // Label 24625: @1815047
     /* 1815047 */   GIM_Try, /*On fail goto*//*Label 24626*/ GIMT_Encode4(1815133), // Rule ID 12721 //
     /* 1815052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1815063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1815066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1815069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815098 */     // MIs[0] policy
     /* 1815098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815108 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11658:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1815111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815132 */     // GIR_Coverage, 12721,
     /* 1815132 */     GIR_EraseRootFromParent_Done,
     /* 1815133 */   // Label 24626: @1815133
     /* 1815133 */   GIM_Try, /*On fail goto*//*Label 24627*/ GIMT_Encode4(1815219), // Rule ID 12724 //
     /* 1815138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1815141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1815149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1815152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1815158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815184 */     // MIs[0] policy
     /* 1815184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815218 */     // GIR_Coverage, 12724,
     /* 1815218 */     GIR_EraseRootFromParent_Done,
     /* 1815219 */   // Label 24627: @1815219
     /* 1815219 */   GIM_Try, /*On fail goto*//*Label 24628*/ GIMT_Encode4(1815305), // Rule ID 12725 //
     /* 1815224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1815227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1815232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1815235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1815238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1815241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1815244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815270 */     // MIs[0] policy
     /* 1815270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815280 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11658:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1815283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1815287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815304 */     // GIR_Coverage, 12725,
     /* 1815304 */     GIR_EraseRootFromParent_Done,
     /* 1815305 */   // Label 24628: @1815305
     /* 1815305 */   GIM_Try, /*On fail goto*//*Label 24629*/ GIMT_Encode4(1815391), // Rule ID 12728 //
     /* 1815310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1815321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1815324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1815327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1815330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815356 */     // MIs[0] policy
     /* 1815356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815366 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815390 */     // GIR_Coverage, 12728,
     /* 1815390 */     GIR_EraseRootFromParent_Done,
     /* 1815391 */   // Label 24629: @1815391
     /* 1815391 */   GIM_Try, /*On fail goto*//*Label 24630*/ GIMT_Encode4(1815477), // Rule ID 12729 //
     /* 1815396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1815407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1815410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1815413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1815416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815442 */     // MIs[0] policy
     /* 1815442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815476 */     // GIR_Coverage, 12729,
     /* 1815476 */     GIR_EraseRootFromParent_Done,
     /* 1815477 */   // Label 24630: @1815477
     /* 1815477 */   GIM_Try, /*On fail goto*//*Label 24631*/ GIMT_Encode4(1815563), // Rule ID 12732 //
     /* 1815482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1815493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1815496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1815499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1815502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815528 */     // MIs[0] policy
     /* 1815528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815538 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1815541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815562 */     // GIR_Coverage, 12732,
     /* 1815562 */     GIR_EraseRootFromParent_Done,
     /* 1815563 */   // Label 24631: @1815563
     /* 1815563 */   GIM_Try, /*On fail goto*//*Label 24632*/ GIMT_Encode4(1815649), // Rule ID 12733 //
     /* 1815568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1815579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1815582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1815585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1815588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815614 */     // MIs[0] policy
     /* 1815614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815624 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1815627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1815645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815648 */     // GIR_Coverage, 12733,
     /* 1815648 */     GIR_EraseRootFromParent_Done,
     /* 1815649 */   // Label 24632: @1815649
     /* 1815649 */   GIM_Try, /*On fail goto*//*Label 24633*/ GIMT_Encode4(1815735), // Rule ID 12736 //
     /* 1815654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1815665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1815668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1815671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1815674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815700 */     // MIs[0] policy
     /* 1815700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815710 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815734 */     // GIR_Coverage, 12736,
     /* 1815734 */     GIR_EraseRootFromParent_Done,
     /* 1815735 */   // Label 24633: @1815735
     /* 1815735 */   GIM_Try, /*On fail goto*//*Label 24634*/ GIMT_Encode4(1815821), // Rule ID 12737 //
     /* 1815740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1815751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1815754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1815757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1815760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1815763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815786 */     // MIs[0] policy
     /* 1815786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815796 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1815799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815820 */     // GIR_Coverage, 12737,
     /* 1815820 */     GIR_EraseRootFromParent_Done,
     /* 1815821 */   // Label 24634: @1815821
     /* 1815821 */   GIM_Try, /*On fail goto*//*Label 24635*/ GIMT_Encode4(1815907), // Rule ID 12740 //
     /* 1815826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1815837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1815840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1815843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1815846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815872 */     // MIs[0] policy
     /* 1815872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815882 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1815885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815906 */     // GIR_Coverage, 12740,
     /* 1815906 */     GIR_EraseRootFromParent_Done,
     /* 1815907 */   // Label 24635: @1815907
     /* 1815907 */   GIM_Try, /*On fail goto*//*Label 24636*/ GIMT_Encode4(1815993), // Rule ID 12741 //
     /* 1815912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1815923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1815926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1815929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1815932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1815942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1815954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815958 */     // MIs[0] policy
     /* 1815958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815968 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1815971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815992 */     // GIR_Coverage, 12741,
     /* 1815992 */     GIR_EraseRootFromParent_Done,
     /* 1815993 */   // Label 24636: @1815993
     /* 1815993 */   GIM_Try, /*On fail goto*//*Label 24637*/ GIMT_Encode4(1816079), // Rule ID 12744 //
     /* 1815998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1816009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1816012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1816015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1816018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816044 */     // MIs[0] policy
     /* 1816044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816078 */     // GIR_Coverage, 12744,
     /* 1816078 */     GIR_EraseRootFromParent_Done,
     /* 1816079 */   // Label 24637: @1816079
     /* 1816079 */   GIM_Try, /*On fail goto*//*Label 24638*/ GIMT_Encode4(1816165), // Rule ID 12745 //
     /* 1816084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1816095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1816098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1816101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1816104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816130 */     // MIs[0] policy
     /* 1816130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816140 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1816143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816164 */     // GIR_Coverage, 12745,
     /* 1816164 */     GIR_EraseRootFromParent_Done,
     /* 1816165 */   // Label 24638: @1816165
     /* 1816165 */   GIM_Try, /*On fail goto*//*Label 24639*/ GIMT_Encode4(1816251), // Rule ID 12748 //
     /* 1816170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1816181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1816184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1816187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1816190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816216 */     // MIs[0] policy
     /* 1816216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816250 */     // GIR_Coverage, 12748,
     /* 1816250 */     GIR_EraseRootFromParent_Done,
     /* 1816251 */   // Label 24639: @1816251
     /* 1816251 */   GIM_Try, /*On fail goto*//*Label 24640*/ GIMT_Encode4(1816337), // Rule ID 12749 //
     /* 1816256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1816267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1816270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1816273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1816276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816302 */     // MIs[0] policy
     /* 1816302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816336 */     // GIR_Coverage, 12749,
     /* 1816336 */     GIR_EraseRootFromParent_Done,
     /* 1816337 */   // Label 24640: @1816337
     /* 1816337 */   GIM_Try, /*On fail goto*//*Label 24641*/ GIMT_Encode4(1816423), // Rule ID 12752 //
     /* 1816342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1816353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1816356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1816359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1816362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816388 */     // MIs[0] policy
     /* 1816388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816422 */     // GIR_Coverage, 12752,
     /* 1816422 */     GIR_EraseRootFromParent_Done,
     /* 1816423 */   // Label 24641: @1816423
     /* 1816423 */   GIM_Try, /*On fail goto*//*Label 24642*/ GIMT_Encode4(1816509), // Rule ID 12753 //
     /* 1816428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1816439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1816442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1816445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1816448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816474 */     // MIs[0] policy
     /* 1816474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816508 */     // GIR_Coverage, 12753,
     /* 1816508 */     GIR_EraseRootFromParent_Done,
     /* 1816509 */   // Label 24642: @1816509
     /* 1816509 */   GIM_Try, /*On fail goto*//*Label 24643*/ GIMT_Encode4(1816595), // Rule ID 12756 //
     /* 1816514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1816525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1816528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1816531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1816534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816560 */     // MIs[0] policy
     /* 1816560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816594 */     // GIR_Coverage, 12756,
     /* 1816594 */     GIR_EraseRootFromParent_Done,
     /* 1816595 */   // Label 24643: @1816595
     /* 1816595 */   GIM_Try, /*On fail goto*//*Label 24644*/ GIMT_Encode4(1816681), // Rule ID 12757 //
     /* 1816600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1816611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1816614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1816617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1816620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816646 */     // MIs[0] policy
     /* 1816646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1816677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816680 */     // GIR_Coverage, 12757,
     /* 1816680 */     GIR_EraseRootFromParent_Done,
     /* 1816681 */   // Label 24644: @1816681
     /* 1816681 */   GIM_Try, /*On fail goto*//*Label 24645*/ GIMT_Encode4(1816767), // Rule ID 12760 //
     /* 1816686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1816689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1816697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1816700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1816703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1816706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816732 */     // MIs[0] policy
     /* 1816732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816766 */     // GIR_Coverage, 12760,
     /* 1816766 */     GIR_EraseRootFromParent_Done,
     /* 1816767 */   // Label 24645: @1816767
     /* 1816767 */   GIM_Try, /*On fail goto*//*Label 24646*/ GIMT_Encode4(1816853), // Rule ID 12761 //
     /* 1816772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1816775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1816783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1816786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1816789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1816792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816818 */     // MIs[0] policy
     /* 1816818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1816831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816852 */     // GIR_Coverage, 12761,
     /* 1816852 */     GIR_EraseRootFromParent_Done,
     /* 1816853 */   // Label 24646: @1816853
     /* 1816853 */   GIM_Try, /*On fail goto*//*Label 24647*/ GIMT_Encode4(1816939), // Rule ID 12764 //
     /* 1816858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1816869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1816872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1816875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1816878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816904 */     // MIs[0] policy
     /* 1816904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1816917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816938 */     // GIR_Coverage, 12764,
     /* 1816938 */     GIR_EraseRootFromParent_Done,
     /* 1816939 */   // Label 24647: @1816939
     /* 1816939 */   GIM_Try, /*On fail goto*//*Label 24648*/ GIMT_Encode4(1817025), // Rule ID 12765 //
     /* 1816944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1816955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1816958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1816961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1816964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1816967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1816974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1816986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816990 */     // MIs[0] policy
     /* 1816990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817000 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817024 */     // GIR_Coverage, 12765,
     /* 1817024 */     GIR_EraseRootFromParent_Done,
     /* 1817025 */   // Label 24648: @1817025
     /* 1817025 */   GIM_Try, /*On fail goto*//*Label 24649*/ GIMT_Encode4(1817111), // Rule ID 12768 //
     /* 1817030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1817041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1817044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1817050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817076 */     // MIs[0] policy
     /* 1817076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817110 */     // GIR_Coverage, 12768,
     /* 1817110 */     GIR_EraseRootFromParent_Done,
     /* 1817111 */   // Label 24649: @1817111
     /* 1817111 */   GIM_Try, /*On fail goto*//*Label 24650*/ GIMT_Encode4(1817197), // Rule ID 12769 //
     /* 1817116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1817127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1817130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1817133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1817136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817162 */     // MIs[0] policy
     /* 1817162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817172 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817196 */     // GIR_Coverage, 12769,
     /* 1817196 */     GIR_EraseRootFromParent_Done,
     /* 1817197 */   // Label 24650: @1817197
     /* 1817197 */   GIM_Try, /*On fail goto*//*Label 24651*/ GIMT_Encode4(1817283), // Rule ID 12772 //
     /* 1817202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1817213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1817216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1817219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1817222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1817225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817248 */     // MIs[0] policy
     /* 1817248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817258 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817282 */     // GIR_Coverage, 12772,
     /* 1817282 */     GIR_EraseRootFromParent_Done,
     /* 1817283 */   // Label 24651: @1817283
     /* 1817283 */   GIM_Try, /*On fail goto*//*Label 24652*/ GIMT_Encode4(1817369), // Rule ID 12773 //
     /* 1817288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1817299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1817302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1817305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1817308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1817311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817334 */     // MIs[0] policy
     /* 1817334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817368 */     // GIR_Coverage, 12773,
     /* 1817368 */     GIR_EraseRootFromParent_Done,
     /* 1817369 */   // Label 24652: @1817369
     /* 1817369 */   GIM_Try, /*On fail goto*//*Label 24653*/ GIMT_Encode4(1817455), // Rule ID 12776 //
     /* 1817374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1817391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1817394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817420 */     // MIs[0] policy
     /* 1817420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817454 */     // GIR_Coverage, 12776,
     /* 1817454 */     GIR_EraseRootFromParent_Done,
     /* 1817455 */   // Label 24653: @1817455
     /* 1817455 */   GIM_Try, /*On fail goto*//*Label 24654*/ GIMT_Encode4(1817541), // Rule ID 12777 //
     /* 1817460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1817471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1817474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1817477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1817480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817506 */     // MIs[0] policy
     /* 1817506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817540 */     // GIR_Coverage, 12777,
     /* 1817540 */     GIR_EraseRootFromParent_Done,
     /* 1817541 */   // Label 24654: @1817541
     /* 1817541 */   GIM_Try, /*On fail goto*//*Label 24655*/ GIMT_Encode4(1817627), // Rule ID 12780 //
     /* 1817546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1817557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1817560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1817563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1817566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817592 */     // MIs[0] policy
     /* 1817592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817626 */     // GIR_Coverage, 12780,
     /* 1817626 */     GIR_EraseRootFromParent_Done,
     /* 1817627 */   // Label 24655: @1817627
     /* 1817627 */   GIM_Try, /*On fail goto*//*Label 24656*/ GIMT_Encode4(1817713), // Rule ID 12781 //
     /* 1817632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1817643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1817646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1817649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1817652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1817662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1817674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817678 */     // MIs[0] policy
     /* 1817678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1817691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817712 */     // GIR_Coverage, 12781,
     /* 1817712 */     GIR_EraseRootFromParent_Done,
     /* 1817713 */   // Label 24656: @1817713
     /* 1817713 */   GIM_Try, /*On fail goto*//*Label 24657*/ GIMT_Encode4(1817799), // Rule ID 12784 //
     /* 1817718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1817729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1817732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1817735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1817738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817764 */     // MIs[0] policy
     /* 1817764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817798 */     // GIR_Coverage, 12784,
     /* 1817798 */     GIR_EraseRootFromParent_Done,
     /* 1817799 */   // Label 24657: @1817799
     /* 1817799 */   GIM_Try, /*On fail goto*//*Label 24658*/ GIMT_Encode4(1817885), // Rule ID 12785 //
     /* 1817804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1817815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1817818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1817821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1817824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1817827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1817834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1817846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817850 */     // MIs[0] policy
     /* 1817850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817860 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1817863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817884 */     // GIR_Coverage, 12785,
     /* 1817884 */     GIR_EraseRootFromParent_Done,
     /* 1817885 */   // Label 24658: @1817885
     /* 1817885 */   GIM_Try, /*On fail goto*//*Label 24659*/ GIMT_Encode4(1817971), // Rule ID 12788 //
     /* 1817890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1817901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1817904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1817907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1817910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817936 */     // MIs[0] policy
     /* 1817936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1817949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817970 */     // GIR_Coverage, 12788,
     /* 1817970 */     GIR_EraseRootFromParent_Done,
     /* 1817971 */   // Label 24659: @1817971
     /* 1817971 */   GIM_Try, /*On fail goto*//*Label 24660*/ GIMT_Encode4(1818057), // Rule ID 12789 //
     /* 1817976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1817984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1817987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1817990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1817993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1817996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818022 */     // MIs[0] policy
     /* 1818022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818056 */     // GIR_Coverage, 12789,
     /* 1818056 */     GIR_EraseRootFromParent_Done,
     /* 1818057 */   // Label 24660: @1818057
     /* 1818057 */   GIM_Try, /*On fail goto*//*Label 24661*/ GIMT_Encode4(1818143), // Rule ID 12792 //
     /* 1818062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1818079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1818082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818108 */     // MIs[0] policy
     /* 1818108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818142 */     // GIR_Coverage, 12792,
     /* 1818142 */     GIR_EraseRootFromParent_Done,
     /* 1818143 */   // Label 24661: @1818143
     /* 1818143 */   GIM_Try, /*On fail goto*//*Label 24662*/ GIMT_Encode4(1818229), // Rule ID 12793 //
     /* 1818148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1818159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1818162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1818165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1818168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818194 */     // MIs[0] policy
     /* 1818194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818204 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818228 */     // GIR_Coverage, 12793,
     /* 1818228 */     GIR_EraseRootFromParent_Done,
     /* 1818229 */   // Label 24662: @1818229
     /* 1818229 */   GIM_Try, /*On fail goto*//*Label 24663*/ GIMT_Encode4(1818315), // Rule ID 12796 //
     /* 1818234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1818251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1818254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818280 */     // MIs[0] policy
     /* 1818280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818290 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818314 */     // GIR_Coverage, 12796,
     /* 1818314 */     GIR_EraseRootFromParent_Done,
     /* 1818315 */   // Label 24663: @1818315
     /* 1818315 */   GIM_Try, /*On fail goto*//*Label 24664*/ GIMT_Encode4(1818401), // Rule ID 12797 //
     /* 1818320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1818331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1818334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1818337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1818340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818366 */     // MIs[0] policy
     /* 1818366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818400 */     // GIR_Coverage, 12797,
     /* 1818400 */     GIR_EraseRootFromParent_Done,
     /* 1818401 */   // Label 24664: @1818401
     /* 1818401 */   GIM_Try, /*On fail goto*//*Label 24665*/ GIMT_Encode4(1818487), // Rule ID 12800 //
     /* 1818406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1818409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1818423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1818426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818452 */     // MIs[0] policy
     /* 1818452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818486 */     // GIR_Coverage, 12800,
     /* 1818486 */     GIR_EraseRootFromParent_Done,
     /* 1818487 */   // Label 24665: @1818487
     /* 1818487 */   GIM_Try, /*On fail goto*//*Label 24666*/ GIMT_Encode4(1818573), // Rule ID 12801 //
     /* 1818492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1818495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1818503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1818506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1818509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1818512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1818515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818538 */     // MIs[0] policy
     /* 1818538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818548 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1818551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818572 */     // GIR_Coverage, 12801,
     /* 1818572 */     GIR_EraseRootFromParent_Done,
     /* 1818573 */   // Label 24666: @1818573
     /* 1818573 */   GIM_Try, /*On fail goto*//*Label 24667*/ GIMT_Encode4(1818659), // Rule ID 12804 //
     /* 1818578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1818581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1818589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1818592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1818595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1818598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818624 */     // MIs[0] policy
     /* 1818624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818658 */     // GIR_Coverage, 12804,
     /* 1818658 */     GIR_EraseRootFromParent_Done,
     /* 1818659 */   // Label 24667: @1818659
     /* 1818659 */   GIM_Try, /*On fail goto*//*Label 24668*/ GIMT_Encode4(1818745), // Rule ID 12805 //
     /* 1818664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1818667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1818675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1818678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1818681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1818684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818710 */     // MIs[0] policy
     /* 1818710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1818723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818744 */     // GIR_Coverage, 12805,
     /* 1818744 */     GIR_EraseRootFromParent_Done,
     /* 1818745 */   // Label 24668: @1818745
     /* 1818745 */   GIM_Try, /*On fail goto*//*Label 24669*/ GIMT_Encode4(1818831), // Rule ID 12808 //
     /* 1818750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1818753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1818761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1818764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1818767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1818770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818796 */     // MIs[0] policy
     /* 1818796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818830 */     // GIR_Coverage, 12808,
     /* 1818830 */     GIR_EraseRootFromParent_Done,
     /* 1818831 */   // Label 24669: @1818831
     /* 1818831 */   GIM_Try, /*On fail goto*//*Label 24670*/ GIMT_Encode4(1818917), // Rule ID 12809 //
     /* 1818836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1818839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1818847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1818850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1818853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1818856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818882 */     // MIs[0] policy
     /* 1818882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818892 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1818895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1818913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818916 */     // GIR_Coverage, 12809,
     /* 1818916 */     GIR_EraseRootFromParent_Done,
     /* 1818917 */   // Label 24670: @1818917
     /* 1818917 */   GIM_Try, /*On fail goto*//*Label 24671*/ GIMT_Encode4(1819003), // Rule ID 12812 //
     /* 1818922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1818930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1818933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1818936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1818939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1818942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1818945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1818952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1818960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1818964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818968 */     // MIs[0] policy
     /* 1818968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818978 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1818981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819002 */     // GIR_Coverage, 12812,
     /* 1819002 */     GIR_EraseRootFromParent_Done,
     /* 1819003 */   // Label 24671: @1819003
     /* 1819003 */   GIM_Try, /*On fail goto*//*Label 24672*/ GIMT_Encode4(1819089), // Rule ID 12813 //
     /* 1819008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1819019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1819022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1819028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819054 */     // MIs[0] policy
     /* 1819054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1819067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819088 */     // GIR_Coverage, 12813,
     /* 1819088 */     GIR_EraseRootFromParent_Done,
     /* 1819089 */   // Label 24672: @1819089
     /* 1819089 */   GIM_Try, /*On fail goto*//*Label 24673*/ GIMT_Encode4(1819175), // Rule ID 12816 //
     /* 1819094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819140 */     // MIs[0] policy
     /* 1819140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819150 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819174 */     // GIR_Coverage, 12816,
     /* 1819174 */     GIR_EraseRootFromParent_Done,
     /* 1819175 */   // Label 24673: @1819175
     /* 1819175 */   GIM_Try, /*On fail goto*//*Label 24674*/ GIMT_Encode4(1819261), // Rule ID 12817 //
     /* 1819180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1819191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1819194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1819200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819226 */     // MIs[0] policy
     /* 1819226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819236 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819260 */     // GIR_Coverage, 12817,
     /* 1819260 */     GIR_EraseRootFromParent_Done,
     /* 1819261 */   // Label 24674: @1819261
     /* 1819261 */   GIM_Try, /*On fail goto*//*Label 24675*/ GIMT_Encode4(1819347), // Rule ID 12820 //
     /* 1819266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819312 */     // MIs[0] policy
     /* 1819312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819322 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819346 */     // GIR_Coverage, 12820,
     /* 1819346 */     GIR_EraseRootFromParent_Done,
     /* 1819347 */   // Label 24675: @1819347
     /* 1819347 */   GIM_Try, /*On fail goto*//*Label 24676*/ GIMT_Encode4(1819433), // Rule ID 12821 //
     /* 1819352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1819363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1819366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1819372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819398 */     // MIs[0] policy
     /* 1819398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819408 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819432 */     // GIR_Coverage, 12821,
     /* 1819432 */     GIR_EraseRootFromParent_Done,
     /* 1819433 */   // Label 24676: @1819433
     /* 1819433 */   GIM_Try, /*On fail goto*//*Label 24677*/ GIMT_Encode4(1819519), // Rule ID 12824 //
     /* 1819438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1819449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1819452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1819458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819484 */     // MIs[0] policy
     /* 1819484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819518 */     // GIR_Coverage, 12824,
     /* 1819518 */     GIR_EraseRootFromParent_Done,
     /* 1819519 */   // Label 24677: @1819519
     /* 1819519 */   GIM_Try, /*On fail goto*//*Label 24678*/ GIMT_Encode4(1819605), // Rule ID 12825 //
     /* 1819524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1819535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1819538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1819544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819570 */     // MIs[0] policy
     /* 1819570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819580 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1819583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819604 */     // GIR_Coverage, 12825,
     /* 1819604 */     GIR_EraseRootFromParent_Done,
     /* 1819605 */   // Label 24678: @1819605
     /* 1819605 */   GIM_Try, /*On fail goto*//*Label 24679*/ GIMT_Encode4(1819691), // Rule ID 12828 //
     /* 1819610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1819621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1819624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1819630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819656 */     // MIs[0] policy
     /* 1819656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819690 */     // GIR_Coverage, 12828,
     /* 1819690 */     GIR_EraseRootFromParent_Done,
     /* 1819691 */   // Label 24679: @1819691
     /* 1819691 */   GIM_Try, /*On fail goto*//*Label 24680*/ GIMT_Encode4(1819777), // Rule ID 12829 //
     /* 1819696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1819707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1819710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1819716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819742 */     // MIs[0] policy
     /* 1819742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819752 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1819773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819776 */     // GIR_Coverage, 12829,
     /* 1819776 */     GIR_EraseRootFromParent_Done,
     /* 1819777 */   // Label 24680: @1819777
     /* 1819777 */   GIM_Try, /*On fail goto*//*Label 24681*/ GIMT_Encode4(1819863), // Rule ID 12832 //
     /* 1819782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1819793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1819796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1819802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819828 */     // MIs[0] policy
     /* 1819828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819838 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819862 */     // GIR_Coverage, 12832,
     /* 1819862 */     GIR_EraseRootFromParent_Done,
     /* 1819863 */   // Label 24681: @1819863
     /* 1819863 */   GIM_Try, /*On fail goto*//*Label 24682*/ GIMT_Encode4(1819949), // Rule ID 12833 //
     /* 1819868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1819879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1819882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1819885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1819888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819914 */     // MIs[0] policy
     /* 1819914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819924 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1819927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819948 */     // GIR_Coverage, 12833,
     /* 1819948 */     GIR_EraseRootFromParent_Done,
     /* 1819949 */   // Label 24682: @1819949
     /* 1819949 */   GIM_Try, /*On fail goto*//*Label 24683*/ GIMT_Encode4(1820035), // Rule ID 12836 //
     /* 1819954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1819962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1819965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1819968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1819974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820000 */     // MIs[0] policy
     /* 1820000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820010 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820034 */     // GIR_Coverage, 12836,
     /* 1820034 */     GIR_EraseRootFromParent_Done,
     /* 1820035 */   // Label 24683: @1820035
     /* 1820035 */   GIM_Try, /*On fail goto*//*Label 24684*/ GIMT_Encode4(1820121), // Rule ID 12837 //
     /* 1820040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1820051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1820054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1820060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820086 */     // MIs[0] policy
     /* 1820086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820096 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11411:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820120 */     // GIR_Coverage, 12837,
     /* 1820120 */     GIR_EraseRootFromParent_Done,
     /* 1820121 */   // Label 24684: @1820121
     /* 1820121 */   GIM_Try, /*On fail goto*//*Label 24685*/ GIMT_Encode4(1820207), // Rule ID 12840 //
     /* 1820126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820172 */     // MIs[0] policy
     /* 1820172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820206 */     // GIR_Coverage, 12840,
     /* 1820206 */     GIR_EraseRootFromParent_Done,
     /* 1820207 */   // Label 24685: @1820207
     /* 1820207 */   GIM_Try, /*On fail goto*//*Label 24686*/ GIMT_Encode4(1820293), // Rule ID 12841 //
     /* 1820212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1820223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1820226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1820232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820258 */     // MIs[0] policy
     /* 1820258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11411:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820292 */     // GIR_Coverage, 12841,
     /* 1820292 */     GIR_EraseRootFromParent_Done,
     /* 1820293 */   // Label 24686: @1820293
     /* 1820293 */   GIM_Try, /*On fail goto*//*Label 24687*/ GIMT_Encode4(1820379), // Rule ID 12844 //
     /* 1820298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820344 */     // MIs[0] policy
     /* 1820344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820378 */     // GIR_Coverage, 12844,
     /* 1820378 */     GIR_EraseRootFromParent_Done,
     /* 1820379 */   // Label 24687: @1820379
     /* 1820379 */   GIM_Try, /*On fail goto*//*Label 24688*/ GIMT_Encode4(1820465), // Rule ID 12845 //
     /* 1820384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1820395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1820398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1820404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820430 */     // MIs[0] policy
     /* 1820430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11411:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820464 */     // GIR_Coverage, 12845,
     /* 1820464 */     GIR_EraseRootFromParent_Done,
     /* 1820465 */   // Label 24688: @1820465
     /* 1820465 */   GIM_Try, /*On fail goto*//*Label 24689*/ GIMT_Encode4(1820551), // Rule ID 12848 //
     /* 1820470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1820473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1820481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1820484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1820490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820516 */     // MIs[0] policy
     /* 1820516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820550 */     // GIR_Coverage, 12848,
     /* 1820550 */     GIR_EraseRootFromParent_Done,
     /* 1820551 */   // Label 24689: @1820551
     /* 1820551 */   GIM_Try, /*On fail goto*//*Label 24690*/ GIMT_Encode4(1820637), // Rule ID 12849 //
     /* 1820556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1820559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1820567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1820570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1820576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820602 */     // MIs[0] policy
     /* 1820602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820612 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11411:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1820615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1820633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820636 */     // GIR_Coverage, 12849,
     /* 1820636 */     GIR_EraseRootFromParent_Done,
     /* 1820637 */   // Label 24690: @1820637
     /* 1820637 */   GIM_Try, /*On fail goto*//*Label 24691*/ GIMT_Encode4(1820723), // Rule ID 12852 //
     /* 1820642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1820653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1820656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1820662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1820665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1820672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820688 */     // MIs[0] policy
     /* 1820688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1820701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820722 */     // GIR_Coverage, 12852,
     /* 1820722 */     GIR_EraseRootFromParent_Done,
     /* 1820723 */   // Label 24691: @1820723
     /* 1820723 */   GIM_Try, /*On fail goto*//*Label 24692*/ GIMT_Encode4(1820809), // Rule ID 12853 //
     /* 1820728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1820739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1820742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1820748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1820751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1820758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1820770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820774 */     // MIs[0] policy
     /* 1820774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1820787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820808 */     // GIR_Coverage, 12853,
     /* 1820808 */     GIR_EraseRootFromParent_Done,
     /* 1820809 */   // Label 24692: @1820809
     /* 1820809 */   GIM_Try, /*On fail goto*//*Label 24693*/ GIMT_Encode4(1820895), // Rule ID 12856 //
     /* 1820814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1820825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1820828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1820834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1820837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1820844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820860 */     // MIs[0] policy
     /* 1820860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1820873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820894 */     // GIR_Coverage, 12856,
     /* 1820894 */     GIR_EraseRootFromParent_Done,
     /* 1820895 */   // Label 24693: @1820895
     /* 1820895 */   GIM_Try, /*On fail goto*//*Label 24694*/ GIMT_Encode4(1820981), // Rule ID 12857 //
     /* 1820900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1820911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1820914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1820920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1820923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1820930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1820942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820946 */     // MIs[0] policy
     /* 1820946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820956 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1820959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820980 */     // GIR_Coverage, 12857,
     /* 1820980 */     GIR_EraseRootFromParent_Done,
     /* 1820981 */   // Label 24694: @1820981
     /* 1820981 */   GIM_Try, /*On fail goto*//*Label 24695*/ GIMT_Encode4(1821067), // Rule ID 12860 //
     /* 1820986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1820994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1820997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821032 */     // MIs[0] policy
     /* 1821032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821042 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821066 */     // GIR_Coverage, 12860,
     /* 1821066 */     GIR_EraseRootFromParent_Done,
     /* 1821067 */   // Label 24695: @1821067
     /* 1821067 */   GIM_Try, /*On fail goto*//*Label 24696*/ GIMT_Encode4(1821153), // Rule ID 12861 //
     /* 1821072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821118 */     // MIs[0] policy
     /* 1821118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821128 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821152 */     // GIR_Coverage, 12861,
     /* 1821152 */     GIR_EraseRootFromParent_Done,
     /* 1821153 */   // Label 24696: @1821153
     /* 1821153 */   GIM_Try, /*On fail goto*//*Label 24697*/ GIMT_Encode4(1821239), // Rule ID 12864 //
     /* 1821158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821204 */     // MIs[0] policy
     /* 1821204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821238 */     // GIR_Coverage, 12864,
     /* 1821238 */     GIR_EraseRootFromParent_Done,
     /* 1821239 */   // Label 24697: @1821239
     /* 1821239 */   GIM_Try, /*On fail goto*//*Label 24698*/ GIMT_Encode4(1821325), // Rule ID 12865 //
     /* 1821244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1821255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1821258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1821264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821290 */     // MIs[0] policy
     /* 1821290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821300 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821324 */     // GIR_Coverage, 12865,
     /* 1821324 */     GIR_EraseRootFromParent_Done,
     /* 1821325 */   // Label 24698: @1821325
     /* 1821325 */   GIM_Try, /*On fail goto*//*Label 24699*/ GIMT_Encode4(1821411), // Rule ID 12868 //
     /* 1821330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821376 */     // MIs[0] policy
     /* 1821376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821410 */     // GIR_Coverage, 12868,
     /* 1821410 */     GIR_EraseRootFromParent_Done,
     /* 1821411 */   // Label 24699: @1821411
     /* 1821411 */   GIM_Try, /*On fail goto*//*Label 24700*/ GIMT_Encode4(1821497), // Rule ID 12869 //
     /* 1821416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1821427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1821430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1821436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821462 */     // MIs[0] policy
     /* 1821462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821472 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821496 */     // GIR_Coverage, 12869,
     /* 1821496 */     GIR_EraseRootFromParent_Done,
     /* 1821497 */   // Label 24700: @1821497
     /* 1821497 */   GIM_Try, /*On fail goto*//*Label 24701*/ GIMT_Encode4(1821583), // Rule ID 12872 //
     /* 1821502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1821513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1821516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1821522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821548 */     // MIs[0] policy
     /* 1821548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821582 */     // GIR_Coverage, 12872,
     /* 1821582 */     GIR_EraseRootFromParent_Done,
     /* 1821583 */   // Label 24701: @1821583
     /* 1821583 */   GIM_Try, /*On fail goto*//*Label 24702*/ GIMT_Encode4(1821669), // Rule ID 12873 //
     /* 1821588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1821599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1821602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1821608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1821630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821634 */     // MIs[0] policy
     /* 1821634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821644 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1821647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821668 */     // GIR_Coverage, 12873,
     /* 1821668 */     GIR_EraseRootFromParent_Done,
     /* 1821669 */   // Label 24702: @1821669
     /* 1821669 */   GIM_Try, /*On fail goto*//*Label 24703*/ GIMT_Encode4(1821755), // Rule ID 12876 //
     /* 1821674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1821685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1821688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1821694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821720 */     // MIs[0] policy
     /* 1821720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821754 */     // GIR_Coverage, 12876,
     /* 1821754 */     GIR_EraseRootFromParent_Done,
     /* 1821755 */   // Label 24703: @1821755
     /* 1821755 */   GIM_Try, /*On fail goto*//*Label 24704*/ GIMT_Encode4(1821841), // Rule ID 12877 //
     /* 1821760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1821771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1821774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1821780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821806 */     // MIs[0] policy
     /* 1821806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1821819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821840 */     // GIR_Coverage, 12877,
     /* 1821840 */     GIR_EraseRootFromParent_Done,
     /* 1821841 */   // Label 24704: @1821841
     /* 1821841 */   GIM_Try, /*On fail goto*//*Label 24705*/ GIMT_Encode4(1821927), // Rule ID 12880 //
     /* 1821846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1821857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1821860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1821866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821892 */     // MIs[0] policy
     /* 1821892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821926 */     // GIR_Coverage, 12880,
     /* 1821926 */     GIR_EraseRootFromParent_Done,
     /* 1821927 */   // Label 24705: @1821927
     /* 1821927 */   GIM_Try, /*On fail goto*//*Label 24706*/ GIMT_Encode4(1822013), // Rule ID 12881 //
     /* 1821932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1821940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1821943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1821946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1821952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821978 */     // MIs[0] policy
     /* 1821978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821988 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1821991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822012 */     // GIR_Coverage, 12881,
     /* 1822012 */     GIR_EraseRootFromParent_Done,
     /* 1822013 */   // Label 24706: @1822013
     /* 1822013 */   GIM_Try, /*On fail goto*//*Label 24707*/ GIMT_Encode4(1822099), // Rule ID 12884 //
     /* 1822018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822064 */     // MIs[0] policy
     /* 1822064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822074 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822098 */     // GIR_Coverage, 12884,
     /* 1822098 */     GIR_EraseRootFromParent_Done,
     /* 1822099 */   // Label 24707: @1822099
     /* 1822099 */   GIM_Try, /*On fail goto*//*Label 24708*/ GIMT_Encode4(1822185), // Rule ID 12885 //
     /* 1822104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1822115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1822118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1822124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822150 */     // MIs[0] policy
     /* 1822150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822160 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822184 */     // GIR_Coverage, 12885,
     /* 1822184 */     GIR_EraseRootFromParent_Done,
     /* 1822185 */   // Label 24708: @1822185
     /* 1822185 */   GIM_Try, /*On fail goto*//*Label 24709*/ GIMT_Encode4(1822271), // Rule ID 12888 //
     /* 1822190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822236 */     // MIs[0] policy
     /* 1822236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822270 */     // GIR_Coverage, 12888,
     /* 1822270 */     GIR_EraseRootFromParent_Done,
     /* 1822271 */   // Label 24709: @1822271
     /* 1822271 */   GIM_Try, /*On fail goto*//*Label 24710*/ GIMT_Encode4(1822357), // Rule ID 12889 //
     /* 1822276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1822287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1822290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1822296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822322 */     // MIs[0] policy
     /* 1822322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11411:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1822335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822356 */     // GIR_Coverage, 12889,
     /* 1822356 */     GIR_EraseRootFromParent_Done,
     /* 1822357 */   // Label 24710: @1822357
     /* 1822357 */   GIM_Try, /*On fail goto*//*Label 24711*/ GIMT_Encode4(1822443), // Rule ID 12892 //
     /* 1822362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822408 */     // MIs[0] policy
     /* 1822408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822442 */     // GIR_Coverage, 12892,
     /* 1822442 */     GIR_EraseRootFromParent_Done,
     /* 1822443 */   // Label 24711: @1822443
     /* 1822443 */   GIM_Try, /*On fail goto*//*Label 24712*/ GIMT_Encode4(1822529), // Rule ID 12893 //
     /* 1822448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1822459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1822462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1822468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822494 */     // MIs[0] policy
     /* 1822494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822504 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11411:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1822507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822528 */     // GIR_Coverage, 12893,
     /* 1822528 */     GIR_EraseRootFromParent_Done,
     /* 1822529 */   // Label 24712: @1822529
     /* 1822529 */   GIM_Try, /*On fail goto*//*Label 24713*/ GIMT_Encode4(1822615), // Rule ID 12896 //
     /* 1822534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1822537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1822545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1822548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1822554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822580 */     // MIs[0] policy
     /* 1822580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822614 */     // GIR_Coverage, 12896,
     /* 1822614 */     GIR_EraseRootFromParent_Done,
     /* 1822615 */   // Label 24713: @1822615
     /* 1822615 */   GIM_Try, /*On fail goto*//*Label 24714*/ GIMT_Encode4(1822701), // Rule ID 12897 //
     /* 1822620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1822623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1822628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1822631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1822634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1822640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822666 */     // MIs[0] policy
     /* 1822666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11411:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1822679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1822697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822700 */     // GIR_Coverage, 12897,
     /* 1822700 */     GIR_EraseRootFromParent_Done,
     /* 1822701 */   // Label 24714: @1822701
     /* 1822701 */   GIM_Try, /*On fail goto*//*Label 24715*/ GIMT_Encode4(1822787), // Rule ID 12900 //
     /* 1822706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1822717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1822720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1822723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1822726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1822729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822752 */     // MIs[0] policy
     /* 1822752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822762 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1822765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822786 */     // GIR_Coverage, 12900,
     /* 1822786 */     GIR_EraseRootFromParent_Done,
     /* 1822787 */   // Label 24715: @1822787
     /* 1822787 */   GIM_Try, /*On fail goto*//*Label 24716*/ GIMT_Encode4(1822873), // Rule ID 12901 //
     /* 1822792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1822803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1822806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1822809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1822812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1822815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822838 */     // MIs[0] policy
     /* 1822838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822848 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1822851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822872 */     // GIR_Coverage, 12901,
     /* 1822872 */     GIR_EraseRootFromParent_Done,
     /* 1822873 */   // Label 24716: @1822873
     /* 1822873 */   GIM_Try, /*On fail goto*//*Label 24717*/ GIMT_Encode4(1822959), // Rule ID 12904 //
     /* 1822878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1822889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1822892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1822895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1822898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822924 */     // MIs[0] policy
     /* 1822924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1822937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822958 */     // GIR_Coverage, 12904,
     /* 1822958 */     GIR_EraseRootFromParent_Done,
     /* 1822959 */   // Label 24717: @1822959
     /* 1822959 */   GIM_Try, /*On fail goto*//*Label 24718*/ GIMT_Encode4(1823045), // Rule ID 12905 //
     /* 1822964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1822975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1822978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1822981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1822984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1822987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1822994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1822998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823010 */     // MIs[0] policy
     /* 1823010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823020 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823044 */     // GIR_Coverage, 12905,
     /* 1823044 */     GIR_EraseRootFromParent_Done,
     /* 1823045 */   // Label 24718: @1823045
     /* 1823045 */   GIM_Try, /*On fail goto*//*Label 24719*/ GIMT_Encode4(1823131), // Rule ID 12908 //
     /* 1823050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1823067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823096 */     // MIs[0] policy
     /* 1823096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823130 */     // GIR_Coverage, 12908,
     /* 1823130 */     GIR_EraseRootFromParent_Done,
     /* 1823131 */   // Label 24719: @1823131
     /* 1823131 */   GIM_Try, /*On fail goto*//*Label 24720*/ GIMT_Encode4(1823217), // Rule ID 12909 //
     /* 1823136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1823147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1823150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1823153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1823156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823182 */     // MIs[0] policy
     /* 1823182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823192 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823216 */     // GIR_Coverage, 12909,
     /* 1823216 */     GIR_EraseRootFromParent_Done,
     /* 1823217 */   // Label 24720: @1823217
     /* 1823217 */   GIM_Try, /*On fail goto*//*Label 24721*/ GIMT_Encode4(1823303), // Rule ID 12912 //
     /* 1823222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1823239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823268 */     // MIs[0] policy
     /* 1823268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823302 */     // GIR_Coverage, 12912,
     /* 1823302 */     GIR_EraseRootFromParent_Done,
     /* 1823303 */   // Label 24721: @1823303
     /* 1823303 */   GIM_Try, /*On fail goto*//*Label 24722*/ GIMT_Encode4(1823389), // Rule ID 12913 //
     /* 1823308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1823319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1823322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1823325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1823328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823354 */     // MIs[0] policy
     /* 1823354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823364 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1823367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823388 */     // GIR_Coverage, 12913,
     /* 1823388 */     GIR_EraseRootFromParent_Done,
     /* 1823389 */   // Label 24722: @1823389
     /* 1823389 */   GIM_Try, /*On fail goto*//*Label 24723*/ GIMT_Encode4(1823475), // Rule ID 12916 //
     /* 1823394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1823411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823440 */     // MIs[0] policy
     /* 1823440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823450 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823474 */     // GIR_Coverage, 12916,
     /* 1823474 */     GIR_EraseRootFromParent_Done,
     /* 1823475 */   // Label 24723: @1823475
     /* 1823475 */   GIM_Try, /*On fail goto*//*Label 24724*/ GIMT_Encode4(1823561), // Rule ID 12917 //
     /* 1823480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1823491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1823494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1823497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1823500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823526 */     // MIs[0] policy
     /* 1823526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823536 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823560 */     // GIR_Coverage, 12917,
     /* 1823560 */     GIR_EraseRootFromParent_Done,
     /* 1823561 */   // Label 24724: @1823561
     /* 1823561 */   GIM_Try, /*On fail goto*//*Label 24725*/ GIMT_Encode4(1823647), // Rule ID 12920 //
     /* 1823566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1823577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1823580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1823583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1823586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823612 */     // MIs[0] policy
     /* 1823612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823646 */     // GIR_Coverage, 12920,
     /* 1823646 */     GIR_EraseRootFromParent_Done,
     /* 1823647 */   // Label 24725: @1823647
     /* 1823647 */   GIM_Try, /*On fail goto*//*Label 24726*/ GIMT_Encode4(1823733), // Rule ID 12921 //
     /* 1823652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1823663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1823666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1823669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1823672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823698 */     // MIs[0] policy
     /* 1823698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823708 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1823711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823732 */     // GIR_Coverage, 12921,
     /* 1823732 */     GIR_EraseRootFromParent_Done,
     /* 1823733 */   // Label 24726: @1823733
     /* 1823733 */   GIM_Try, /*On fail goto*//*Label 24727*/ GIMT_Encode4(1823819), // Rule ID 12924 //
     /* 1823738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1823749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1823752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1823755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1823758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823784 */     // MIs[0] policy
     /* 1823784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823794 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1823797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823818 */     // GIR_Coverage, 12924,
     /* 1823818 */     GIR_EraseRootFromParent_Done,
     /* 1823819 */   // Label 24727: @1823819
     /* 1823819 */   GIM_Try, /*On fail goto*//*Label 24728*/ GIMT_Encode4(1823905), // Rule ID 12925 //
     /* 1823824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1823835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1823838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1823841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1823844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823870 */     // MIs[0] policy
     /* 1823870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823880 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1823883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823904 */     // GIR_Coverage, 12925,
     /* 1823904 */     GIR_EraseRootFromParent_Done,
     /* 1823905 */   // Label 24728: @1823905
     /* 1823905 */   GIM_Try, /*On fail goto*//*Label 24729*/ GIMT_Encode4(1823991), // Rule ID 12928 //
     /* 1823910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1823921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1823924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1823927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1823930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823956 */     // MIs[0] policy
     /* 1823956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1823969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1823987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823990 */     // GIR_Coverage, 12928,
     /* 1823990 */     GIR_EraseRootFromParent_Done,
     /* 1823991 */   // Label 24729: @1823991
     /* 1823991 */   GIM_Try, /*On fail goto*//*Label 24730*/ GIMT_Encode4(1824077), // Rule ID 12929 //
     /* 1823996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1824007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1824010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1824013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1824016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824042 */     // MIs[0] policy
     /* 1824042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824076 */     // GIR_Coverage, 12929,
     /* 1824076 */     GIR_EraseRootFromParent_Done,
     /* 1824077 */   // Label 24730: @1824077
     /* 1824077 */   GIM_Try, /*On fail goto*//*Label 24731*/ GIMT_Encode4(1824163), // Rule ID 12932 //
     /* 1824082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1824099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824128 */     // MIs[0] policy
     /* 1824128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824138 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824162 */     // GIR_Coverage, 12932,
     /* 1824162 */     GIR_EraseRootFromParent_Done,
     /* 1824163 */   // Label 24731: @1824163
     /* 1824163 */   GIM_Try, /*On fail goto*//*Label 24732*/ GIMT_Encode4(1824249), // Rule ID 12933 //
     /* 1824168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1824179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1824182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1824185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1824188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824214 */     // MIs[0] policy
     /* 1824214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824224 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824248 */     // GIR_Coverage, 12933,
     /* 1824248 */     GIR_EraseRootFromParent_Done,
     /* 1824249 */   // Label 24732: @1824249
     /* 1824249 */   GIM_Try, /*On fail goto*//*Label 24733*/ GIMT_Encode4(1824335), // Rule ID 12936 //
     /* 1824254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1824257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1824271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824300 */     // MIs[0] policy
     /* 1824300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824310 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824334 */     // GIR_Coverage, 12936,
     /* 1824334 */     GIR_EraseRootFromParent_Done,
     /* 1824335 */   // Label 24733: @1824335
     /* 1824335 */   GIM_Try, /*On fail goto*//*Label 24734*/ GIMT_Encode4(1824421), // Rule ID 12937 //
     /* 1824340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1824343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1824351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1824354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1824357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1824360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824386 */     // MIs[0] policy
     /* 1824386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824396 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1824399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1824417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824420 */     // GIR_Coverage, 12937,
     /* 1824420 */     GIR_EraseRootFromParent_Done,
     /* 1824421 */   // Label 24734: @1824421
     /* 1824421 */   GIM_Try, /*On fail goto*//*Label 24735*/ GIMT_Encode4(1824507), // Rule ID 12940 //
     /* 1824426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1824440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1824443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1824446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1824449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824472 */     // MIs[0] policy
     /* 1824472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1824485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824506 */     // GIR_Coverage, 12940,
     /* 1824506 */     GIR_EraseRootFromParent_Done,
     /* 1824507 */   // Label 24735: @1824507
     /* 1824507 */   GIM_Try, /*On fail goto*//*Label 24736*/ GIMT_Encode4(1824593), // Rule ID 12941 //
     /* 1824512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1824523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1824526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1824529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1824532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1824535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824558 */     // MIs[0] policy
     /* 1824558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824568 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1824571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824592 */     // GIR_Coverage, 12941,
     /* 1824592 */     GIR_EraseRootFromParent_Done,
     /* 1824593 */   // Label 24736: @1824593
     /* 1824593 */   GIM_Try, /*On fail goto*//*Label 24737*/ GIMT_Encode4(1824679), // Rule ID 12944 //
     /* 1824598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1824609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1824612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1824615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1824618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1824621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1824628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824644 */     // MIs[0] policy
     /* 1824644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824654 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1824657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824678 */     // GIR_Coverage, 12944,
     /* 1824678 */     GIR_EraseRootFromParent_Done,
     /* 1824679 */   // Label 24737: @1824679
     /* 1824679 */   GIM_Try, /*On fail goto*//*Label 24738*/ GIMT_Encode4(1824765), // Rule ID 12945 //
     /* 1824684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1824695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1824698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1824701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1824704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1824707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1824714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1824726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824730 */     // MIs[0] policy
     /* 1824730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824740 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1824743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824764 */     // GIR_Coverage, 12945,
     /* 1824764 */     GIR_EraseRootFromParent_Done,
     /* 1824765 */   // Label 24738: @1824765
     /* 1824765 */   GIM_Try, /*On fail goto*//*Label 24739*/ GIMT_Encode4(1824851), // Rule ID 12948 //
     /* 1824770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1824781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1824784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1824787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1824790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1824793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1824800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824816 */     // MIs[0] policy
     /* 1824816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824826 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1824829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824850 */     // GIR_Coverage, 12948,
     /* 1824850 */     GIR_EraseRootFromParent_Done,
     /* 1824851 */   // Label 24739: @1824851
     /* 1824851 */   GIM_Try, /*On fail goto*//*Label 24740*/ GIMT_Encode4(1824937), // Rule ID 12949 //
     /* 1824856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1824867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1824870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1824873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1824876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1824879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1824886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1824898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824902 */     // MIs[0] policy
     /* 1824902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824912 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1824915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824936 */     // GIR_Coverage, 12949,
     /* 1824936 */     GIR_EraseRootFromParent_Done,
     /* 1824937 */   // Label 24740: @1824937
     /* 1824937 */   GIM_Try, /*On fail goto*//*Label 24741*/ GIMT_Encode4(1825023), // Rule ID 12952 //
     /* 1824942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1824950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1824953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1824956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1824959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1824962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1824972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1824984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824988 */     // MIs[0] policy
     /* 1824988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824998 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825022 */     // GIR_Coverage, 12952,
     /* 1825022 */     GIR_EraseRootFromParent_Done,
     /* 1825023 */   // Label 24741: @1825023
     /* 1825023 */   GIM_Try, /*On fail goto*//*Label 24742*/ GIMT_Encode4(1825109), // Rule ID 12953 //
     /* 1825028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1825039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1825042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1825045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1825048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825074 */     // MIs[0] policy
     /* 1825074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825084 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825108 */     // GIR_Coverage, 12953,
     /* 1825108 */     GIR_EraseRootFromParent_Done,
     /* 1825109 */   // Label 24742: @1825109
     /* 1825109 */   GIM_Try, /*On fail goto*//*Label 24743*/ GIMT_Encode4(1825195), // Rule ID 12956 //
     /* 1825114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1825131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825160 */     // MIs[0] policy
     /* 1825160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825170 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825194 */     // GIR_Coverage, 12956,
     /* 1825194 */     GIR_EraseRootFromParent_Done,
     /* 1825195 */   // Label 24743: @1825195
     /* 1825195 */   GIM_Try, /*On fail goto*//*Label 24744*/ GIMT_Encode4(1825281), // Rule ID 12957 //
     /* 1825200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1825211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1825214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1825217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1825220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825246 */     // MIs[0] policy
     /* 1825246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825256 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825280 */     // GIR_Coverage, 12957,
     /* 1825280 */     GIR_EraseRootFromParent_Done,
     /* 1825281 */   // Label 24744: @1825281
     /* 1825281 */   GIM_Try, /*On fail goto*//*Label 24745*/ GIMT_Encode4(1825367), // Rule ID 12960 //
     /* 1825286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1825303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825332 */     // MIs[0] policy
     /* 1825332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825366 */     // GIR_Coverage, 12960,
     /* 1825366 */     GIR_EraseRootFromParent_Done,
     /* 1825367 */   // Label 24745: @1825367
     /* 1825367 */   GIM_Try, /*On fail goto*//*Label 24746*/ GIMT_Encode4(1825453), // Rule ID 12961 //
     /* 1825372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1825383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1825386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1825389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1825392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825418 */     // MIs[0] policy
     /* 1825418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825428 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825452 */     // GIR_Coverage, 12961,
     /* 1825452 */     GIR_EraseRootFromParent_Done,
     /* 1825453 */   // Label 24746: @1825453
     /* 1825453 */   GIM_Try, /*On fail goto*//*Label 24747*/ GIMT_Encode4(1825539), // Rule ID 12964 //
     /* 1825458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1825469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1825472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1825475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1825478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825504 */     // MIs[0] policy
     /* 1825504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825538 */     // GIR_Coverage, 12964,
     /* 1825538 */     GIR_EraseRootFromParent_Done,
     /* 1825539 */   // Label 24747: @1825539
     /* 1825539 */   GIM_Try, /*On fail goto*//*Label 24748*/ GIMT_Encode4(1825625), // Rule ID 12965 //
     /* 1825544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1825555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1825558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1825561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1825564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825590 */     // MIs[0] policy
     /* 1825590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1825603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825624 */     // GIR_Coverage, 12965,
     /* 1825624 */     GIR_EraseRootFromParent_Done,
     /* 1825625 */   // Label 24748: @1825625
     /* 1825625 */   GIM_Try, /*On fail goto*//*Label 24749*/ GIMT_Encode4(1825711), // Rule ID 12968 //
     /* 1825630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1825641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1825644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1825647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1825650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825676 */     // MIs[0] policy
     /* 1825676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825710 */     // GIR_Coverage, 12968,
     /* 1825710 */     GIR_EraseRootFromParent_Done,
     /* 1825711 */   // Label 24749: @1825711
     /* 1825711 */   GIM_Try, /*On fail goto*//*Label 24750*/ GIMT_Encode4(1825797), // Rule ID 12969 //
     /* 1825716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1825727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1825730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1825733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1825736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825762 */     // MIs[0] policy
     /* 1825762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825772 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1825775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825796 */     // GIR_Coverage, 12969,
     /* 1825796 */     GIR_EraseRootFromParent_Done,
     /* 1825797 */   // Label 24750: @1825797
     /* 1825797 */   GIM_Try, /*On fail goto*//*Label 24751*/ GIMT_Encode4(1825883), // Rule ID 12972 //
     /* 1825802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1825813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1825816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1825819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1825822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825848 */     // MIs[0] policy
     /* 1825848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825858 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825882 */     // GIR_Coverage, 12972,
     /* 1825882 */     GIR_EraseRootFromParent_Done,
     /* 1825883 */   // Label 24751: @1825883
     /* 1825883 */   GIM_Try, /*On fail goto*//*Label 24752*/ GIMT_Encode4(1825969), // Rule ID 12973 //
     /* 1825888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1825899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1825902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1825905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1825908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825934 */     // MIs[0] policy
     /* 1825934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1825947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825968 */     // GIR_Coverage, 12973,
     /* 1825968 */     GIR_EraseRootFromParent_Done,
     /* 1825969 */   // Label 24752: @1825969
     /* 1825969 */   GIM_Try, /*On fail goto*//*Label 24753*/ GIMT_Encode4(1826055), // Rule ID 12976 //
     /* 1825974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1825977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1825982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1825985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1825988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1825991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1825994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1825997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826020 */     // MIs[0] policy
     /* 1826020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826054 */     // GIR_Coverage, 12976,
     /* 1826054 */     GIR_EraseRootFromParent_Done,
     /* 1826055 */   // Label 24753: @1826055
     /* 1826055 */   GIM_Try, /*On fail goto*//*Label 24754*/ GIMT_Encode4(1826141), // Rule ID 12977 //
     /* 1826060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1826071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1826077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826106 */     // MIs[0] policy
     /* 1826106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1826119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826140 */     // GIR_Coverage, 12977,
     /* 1826140 */     GIR_EraseRootFromParent_Done,
     /* 1826141 */   // Label 24754: @1826141
     /* 1826141 */   GIM_Try, /*On fail goto*//*Label 24755*/ GIMT_Encode4(1826227), // Rule ID 12980 //
     /* 1826146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1826163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826192 */     // MIs[0] policy
     /* 1826192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826202 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826226 */     // GIR_Coverage, 12980,
     /* 1826226 */     GIR_EraseRootFromParent_Done,
     /* 1826227 */   // Label 24755: @1826227
     /* 1826227 */   GIM_Try, /*On fail goto*//*Label 24756*/ GIMT_Encode4(1826313), // Rule ID 12981 //
     /* 1826232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1826243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1826246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1826249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1826252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826278 */     // MIs[0] policy
     /* 1826278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826288 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1826291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826312 */     // GIR_Coverage, 12981,
     /* 1826312 */     GIR_EraseRootFromParent_Done,
     /* 1826313 */   // Label 24756: @1826313
     /* 1826313 */   GIM_Try, /*On fail goto*//*Label 24757*/ GIMT_Encode4(1826399), // Rule ID 12984 //
     /* 1826318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1826335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826364 */     // MIs[0] policy
     /* 1826364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826398 */     // GIR_Coverage, 12984,
     /* 1826398 */     GIR_EraseRootFromParent_Done,
     /* 1826399 */   // Label 24757: @1826399
     /* 1826399 */   GIM_Try, /*On fail goto*//*Label 24758*/ GIMT_Encode4(1826485), // Rule ID 12985 //
     /* 1826404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1826407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1826415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1826418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1826421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1826424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826450 */     // MIs[0] policy
     /* 1826450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826460 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1826463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1826481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826484 */     // GIR_Coverage, 12985,
     /* 1826484 */     GIR_EraseRootFromParent_Done,
     /* 1826485 */   // Label 24758: @1826485
     /* 1826485 */   GIM_Try, /*On fail goto*//*Label 24759*/ GIMT_Encode4(1826571), // Rule ID 12988 //
     /* 1826490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1826501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1826504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1826510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1826513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826536 */     // MIs[0] policy
     /* 1826536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1826549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826570 */     // GIR_Coverage, 12988,
     /* 1826570 */     GIR_EraseRootFromParent_Done,
     /* 1826571 */   // Label 24759: @1826571
     /* 1826571 */   GIM_Try, /*On fail goto*//*Label 24760*/ GIMT_Encode4(1826657), // Rule ID 12989 //
     /* 1826576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1826587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1826590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1826596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1826599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826622 */     // MIs[0] policy
     /* 1826622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826632 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1826635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826656 */     // GIR_Coverage, 12989,
     /* 1826656 */     GIR_EraseRootFromParent_Done,
     /* 1826657 */   // Label 24760: @1826657
     /* 1826657 */   GIM_Try, /*On fail goto*//*Label 24761*/ GIMT_Encode4(1826743), // Rule ID 12992 //
     /* 1826662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1826673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1826676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1826682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826708 */     // MIs[0] policy
     /* 1826708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826718 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1826721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826742 */     // GIR_Coverage, 12992,
     /* 1826742 */     GIR_EraseRootFromParent_Done,
     /* 1826743 */   // Label 24761: @1826743
     /* 1826743 */   GIM_Try, /*On fail goto*//*Label 24762*/ GIMT_Encode4(1826829), // Rule ID 12993 //
     /* 1826748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1826759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1826762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1826768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826794 */     // MIs[0] policy
     /* 1826794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826804 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1826807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826828 */     // GIR_Coverage, 12993,
     /* 1826828 */     GIR_EraseRootFromParent_Done,
     /* 1826829 */   // Label 24762: @1826829
     /* 1826829 */   GIM_Try, /*On fail goto*//*Label 24763*/ GIMT_Encode4(1826915), // Rule ID 12996 //
     /* 1826834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1826845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1826848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1826851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1826854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826880 */     // MIs[0] policy
     /* 1826880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826890 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1826893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826914 */     // GIR_Coverage, 12996,
     /* 1826914 */     GIR_EraseRootFromParent_Done,
     /* 1826915 */   // Label 24763: @1826915
     /* 1826915 */   GIM_Try, /*On fail goto*//*Label 24764*/ GIMT_Encode4(1827001), // Rule ID 12997 //
     /* 1826920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1826928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1826931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1826934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1826937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1826940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1826950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1826958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1826962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826966 */     // MIs[0] policy
     /* 1826966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826976 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1826979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1826997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827000 */     // GIR_Coverage, 12997,
     /* 1827000 */     GIR_EraseRootFromParent_Done,
     /* 1827001 */   // Label 24764: @1827001
     /* 1827001 */   GIM_Try, /*On fail goto*//*Label 24765*/ GIMT_Encode4(1827087), // Rule ID 13000 //
     /* 1827006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827052 */     // MIs[0] policy
     /* 1827052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827062 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827086 */     // GIR_Coverage, 13000,
     /* 1827086 */     GIR_EraseRootFromParent_Done,
     /* 1827087 */   // Label 24765: @1827087
     /* 1827087 */   GIM_Try, /*On fail goto*//*Label 24766*/ GIMT_Encode4(1827173), // Rule ID 13001 //
     /* 1827092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1827106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1827112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827138 */     // MIs[0] policy
     /* 1827138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827148 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1827151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827172 */     // GIR_Coverage, 13001,
     /* 1827172 */     GIR_EraseRootFromParent_Done,
     /* 1827173 */   // Label 24766: @1827173
     /* 1827173 */   GIM_Try, /*On fail goto*//*Label 24767*/ GIMT_Encode4(1827259), // Rule ID 13004 //
     /* 1827178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827224 */     // MIs[0] policy
     /* 1827224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827258 */     // GIR_Coverage, 13004,
     /* 1827258 */     GIR_EraseRootFromParent_Done,
     /* 1827259 */   // Label 24767: @1827259
     /* 1827259 */   GIM_Try, /*On fail goto*//*Label 24768*/ GIMT_Encode4(1827345), // Rule ID 13005 //
     /* 1827264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1827275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1827278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1827284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827310 */     // MIs[0] policy
     /* 1827310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827320 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827344 */     // GIR_Coverage, 13005,
     /* 1827344 */     GIR_EraseRootFromParent_Done,
     /* 1827345 */   // Label 24768: @1827345
     /* 1827345 */   GIM_Try, /*On fail goto*//*Label 24769*/ GIMT_Encode4(1827431), // Rule ID 13008 //
     /* 1827350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827396 */     // MIs[0] policy
     /* 1827396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827430 */     // GIR_Coverage, 13008,
     /* 1827430 */     GIR_EraseRootFromParent_Done,
     /* 1827431 */   // Label 24769: @1827431
     /* 1827431 */   GIM_Try, /*On fail goto*//*Label 24770*/ GIMT_Encode4(1827517), // Rule ID 13009 //
     /* 1827436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1827447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1827450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1827456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827482 */     // MIs[0] policy
     /* 1827482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827492 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1827495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827516 */     // GIR_Coverage, 13009,
     /* 1827516 */     GIR_EraseRootFromParent_Done,
     /* 1827517 */   // Label 24770: @1827517
     /* 1827517 */   GIM_Try, /*On fail goto*//*Label 24771*/ GIMT_Encode4(1827603), // Rule ID 13012 //
     /* 1827522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1827533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1827536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1827542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827568 */     // MIs[0] policy
     /* 1827568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827578 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827602 */     // GIR_Coverage, 13012,
     /* 1827602 */     GIR_EraseRootFromParent_Done,
     /* 1827603 */   // Label 24771: @1827603
     /* 1827603 */   GIM_Try, /*On fail goto*//*Label 24772*/ GIMT_Encode4(1827689), // Rule ID 13013 //
     /* 1827608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1827619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1827622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1827628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827654 */     // MIs[0] policy
     /* 1827654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11490:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827688 */     // GIR_Coverage, 13013,
     /* 1827688 */     GIR_EraseRootFromParent_Done,
     /* 1827689 */   // Label 24772: @1827689
     /* 1827689 */   GIM_Try, /*On fail goto*//*Label 24773*/ GIMT_Encode4(1827775), // Rule ID 13016 //
     /* 1827694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1827705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1827708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1827714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827740 */     // MIs[0] policy
     /* 1827740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827774 */     // GIR_Coverage, 13016,
     /* 1827774 */     GIR_EraseRootFromParent_Done,
     /* 1827775 */   // Label 24773: @1827775
     /* 1827775 */   GIM_Try, /*On fail goto*//*Label 24774*/ GIMT_Encode4(1827861), // Rule ID 13017 //
     /* 1827780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1827791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1827794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1827800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827826 */     // MIs[0] policy
     /* 1827826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827836 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11490:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1827857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827860 */     // GIR_Coverage, 13017,
     /* 1827860 */     GIR_EraseRootFromParent_Done,
     /* 1827861 */   // Label 24774: @1827861
     /* 1827861 */   GIM_Try, /*On fail goto*//*Label 24775*/ GIMT_Encode4(1827947), // Rule ID 13020 //
     /* 1827866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1827877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1827880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1827886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827912 */     // MIs[0] policy
     /* 1827912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1827925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1827943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827946 */     // GIR_Coverage, 13020,
     /* 1827946 */     GIR_EraseRootFromParent_Done,
     /* 1827947 */   // Label 24775: @1827947
     /* 1827947 */   GIM_Try, /*On fail goto*//*Label 24776*/ GIMT_Encode4(1828033), // Rule ID 13021 //
     /* 1827952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1827960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1827963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1827966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1827972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827998 */     // MIs[0] policy
     /* 1827998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828032 */     // GIR_Coverage, 13021,
     /* 1828032 */     GIR_EraseRootFromParent_Done,
     /* 1828033 */   // Label 24776: @1828033
     /* 1828033 */   GIM_Try, /*On fail goto*//*Label 24777*/ GIMT_Encode4(1828119), // Rule ID 13024 //
     /* 1828038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1828041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828084 */     // MIs[0] policy
     /* 1828084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828118 */     // GIR_Coverage, 13024,
     /* 1828118 */     GIR_EraseRootFromParent_Done,
     /* 1828119 */   // Label 24777: @1828119
     /* 1828119 */   GIM_Try, /*On fail goto*//*Label 24778*/ GIMT_Encode4(1828205), // Rule ID 13025 //
     /* 1828124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1828127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1828135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1828138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1828144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828170 */     // MIs[0] policy
     /* 1828170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828180 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1828183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1828201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828204 */     // GIR_Coverage, 13025,
     /* 1828204 */     GIR_EraseRootFromParent_Done,
     /* 1828205 */   // Label 24778: @1828205
     /* 1828205 */   GIM_Try, /*On fail goto*//*Label 24779*/ GIMT_Encode4(1828291), // Rule ID 13028 //
     /* 1828210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828256 */     // MIs[0] policy
     /* 1828256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828290 */     // GIR_Coverage, 13028,
     /* 1828290 */     GIR_EraseRootFromParent_Done,
     /* 1828291 */   // Label 24779: @1828291
     /* 1828291 */   GIM_Try, /*On fail goto*//*Label 24780*/ GIMT_Encode4(1828377), // Rule ID 13029 //
     /* 1828296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1828307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1828310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1828316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828342 */     // MIs[0] policy
     /* 1828342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828376 */     // GIR_Coverage, 13029,
     /* 1828376 */     GIR_EraseRootFromParent_Done,
     /* 1828377 */   // Label 24780: @1828377
     /* 1828377 */   GIM_Try, /*On fail goto*//*Label 24781*/ GIMT_Encode4(1828463), // Rule ID 13032 //
     /* 1828382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828428 */     // MIs[0] policy
     /* 1828428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828438 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1828441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828462 */     // GIR_Coverage, 13032,
     /* 1828462 */     GIR_EraseRootFromParent_Done,
     /* 1828463 */   // Label 24781: @1828463
     /* 1828463 */   GIM_Try, /*On fail goto*//*Label 24782*/ GIMT_Encode4(1828549), // Rule ID 13033 //
     /* 1828468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1828479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1828482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1828488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1828491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828514 */     // MIs[0] policy
     /* 1828514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828524 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1828527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828548 */     // GIR_Coverage, 13033,
     /* 1828548 */     GIR_EraseRootFromParent_Done,
     /* 1828549 */   // Label 24782: @1828549
     /* 1828549 */   GIM_Try, /*On fail goto*//*Label 24783*/ GIMT_Encode4(1828635), // Rule ID 13036 //
     /* 1828554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1828565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1828568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1828574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1828577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1828584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828600 */     // MIs[0] policy
     /* 1828600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828610 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1828613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828634 */     // GIR_Coverage, 13036,
     /* 1828634 */     GIR_EraseRootFromParent_Done,
     /* 1828635 */   // Label 24783: @1828635
     /* 1828635 */   GIM_Try, /*On fail goto*//*Label 24784*/ GIMT_Encode4(1828721), // Rule ID 13037 //
     /* 1828640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1828651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1828654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1828660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1828663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1828670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1828682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828686 */     // MIs[0] policy
     /* 1828686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1828699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828720 */     // GIR_Coverage, 13037,
     /* 1828720 */     GIR_EraseRootFromParent_Done,
     /* 1828721 */   // Label 24784: @1828721
     /* 1828721 */   GIM_Try, /*On fail goto*//*Label 24785*/ GIMT_Encode4(1828807), // Rule ID 13040 //
     /* 1828726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1828737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1828740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1828746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828772 */     // MIs[0] policy
     /* 1828772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828806 */     // GIR_Coverage, 13040,
     /* 1828806 */     GIR_EraseRootFromParent_Done,
     /* 1828807 */   // Label 24785: @1828807
     /* 1828807 */   GIM_Try, /*On fail goto*//*Label 24786*/ GIMT_Encode4(1828893), // Rule ID 13041 //
     /* 1828812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1828823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1828826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1828832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1828842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1828854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828858 */     // MIs[0] policy
     /* 1828858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1828871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828892 */     // GIR_Coverage, 13041,
     /* 1828892 */     GIR_EraseRootFromParent_Done,
     /* 1828893 */   // Label 24786: @1828893
     /* 1828893 */   GIM_Try, /*On fail goto*//*Label 24787*/ GIMT_Encode4(1828979), // Rule ID 13044 //
     /* 1828898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1828909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1828912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1828918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1828921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1828928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1828940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828944 */     // MIs[0] policy
     /* 1828944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828954 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1828957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828978 */     // GIR_Coverage, 13044,
     /* 1828978 */     GIR_EraseRootFromParent_Done,
     /* 1828979 */   // Label 24787: @1828979
     /* 1828979 */   GIM_Try, /*On fail goto*//*Label 24788*/ GIMT_Encode4(1829065), // Rule ID 13045 //
     /* 1828984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1828992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1828995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1828998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1829004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829030 */     // MIs[0] policy
     /* 1829030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829040 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829064 */     // GIR_Coverage, 13045,
     /* 1829064 */     GIR_EraseRootFromParent_Done,
     /* 1829065 */   // Label 24788: @1829065
     /* 1829065 */   GIM_Try, /*On fail goto*//*Label 24789*/ GIMT_Encode4(1829151), // Rule ID 13048 //
     /* 1829070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829116 */     // MIs[0] policy
     /* 1829116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829126 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829150 */     // GIR_Coverage, 13048,
     /* 1829150 */     GIR_EraseRootFromParent_Done,
     /* 1829151 */   // Label 24789: @1829151
     /* 1829151 */   GIM_Try, /*On fail goto*//*Label 24790*/ GIMT_Encode4(1829237), // Rule ID 13049 //
     /* 1829156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1829167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1829170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1829176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829202 */     // MIs[0] policy
     /* 1829202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829212 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829236 */     // GIR_Coverage, 13049,
     /* 1829236 */     GIR_EraseRootFromParent_Done,
     /* 1829237 */   // Label 24790: @1829237
     /* 1829237 */   GIM_Try, /*On fail goto*//*Label 24791*/ GIMT_Encode4(1829323), // Rule ID 13052 //
     /* 1829242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829288 */     // MIs[0] policy
     /* 1829288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829322 */     // GIR_Coverage, 13052,
     /* 1829322 */     GIR_EraseRootFromParent_Done,
     /* 1829323 */   // Label 24791: @1829323
     /* 1829323 */   GIM_Try, /*On fail goto*//*Label 24792*/ GIMT_Encode4(1829409), // Rule ID 13053 //
     /* 1829328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1829339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1829342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1829348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829374 */     // MIs[0] policy
     /* 1829374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829408 */     // GIR_Coverage, 13053,
     /* 1829408 */     GIR_EraseRootFromParent_Done,
     /* 1829409 */   // Label 24792: @1829409
     /* 1829409 */   GIM_Try, /*On fail goto*//*Label 24793*/ GIMT_Encode4(1829495), // Rule ID 13056 //
     /* 1829414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829460 */     // MIs[0] policy
     /* 1829460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829494 */     // GIR_Coverage, 13056,
     /* 1829494 */     GIR_EraseRootFromParent_Done,
     /* 1829495 */   // Label 24793: @1829495
     /* 1829495 */   GIM_Try, /*On fail goto*//*Label 24794*/ GIMT_Encode4(1829581), // Rule ID 13057 //
     /* 1829500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1829511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1829514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1829520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829546 */     // MIs[0] policy
     /* 1829546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829580 */     // GIR_Coverage, 13057,
     /* 1829580 */     GIR_EraseRootFromParent_Done,
     /* 1829581 */   // Label 24794: @1829581
     /* 1829581 */   GIM_Try, /*On fail goto*//*Label 24795*/ GIMT_Encode4(1829667), // Rule ID 13060 //
     /* 1829586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1829597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1829600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1829606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829632 */     // MIs[0] policy
     /* 1829632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829666 */     // GIR_Coverage, 13060,
     /* 1829666 */     GIR_EraseRootFromParent_Done,
     /* 1829667 */   // Label 24795: @1829667
     /* 1829667 */   GIM_Try, /*On fail goto*//*Label 24796*/ GIMT_Encode4(1829753), // Rule ID 13061 //
     /* 1829672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1829683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1829686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1829692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829718 */     // MIs[0] policy
     /* 1829718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1829731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829752 */     // GIR_Coverage, 13061,
     /* 1829752 */     GIR_EraseRootFromParent_Done,
     /* 1829753 */   // Label 24796: @1829753
     /* 1829753 */   GIM_Try, /*On fail goto*//*Label 24797*/ GIMT_Encode4(1829839), // Rule ID 13064 //
     /* 1829758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1829761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1829769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1829772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1829778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829804 */     // MIs[0] policy
     /* 1829804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829838 */     // GIR_Coverage, 13064,
     /* 1829838 */     GIR_EraseRootFromParent_Done,
     /* 1829839 */   // Label 24797: @1829839
     /* 1829839 */   GIM_Try, /*On fail goto*//*Label 24798*/ GIMT_Encode4(1829925), // Rule ID 13065 //
     /* 1829844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1829847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1829855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1829858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1829864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1829867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829890 */     // MIs[0] policy
     /* 1829890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1829903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829924 */     // GIR_Coverage, 13065,
     /* 1829924 */     GIR_EraseRootFromParent_Done,
     /* 1829925 */   // Label 24798: @1829925
     /* 1829925 */   GIM_Try, /*On fail goto*//*Label 24799*/ GIMT_Encode4(1830011), // Rule ID 13068 //
     /* 1829930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1829933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1829938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1829941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1829944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1829950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1829953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829976 */     // MIs[0] policy
     /* 1829976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1829989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830010 */     // GIR_Coverage, 13068,
     /* 1830010 */     GIR_EraseRootFromParent_Done,
     /* 1830011 */   // Label 24799: @1830011
     /* 1830011 */   GIM_Try, /*On fail goto*//*Label 24800*/ GIMT_Encode4(1830097), // Rule ID 13069 //
     /* 1830016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1830027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1830030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1830036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830062 */     // MIs[0] policy
     /* 1830062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830072 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1830075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830096 */     // GIR_Coverage, 13069,
     /* 1830096 */     GIR_EraseRootFromParent_Done,
     /* 1830097 */   // Label 24800: @1830097
     /* 1830097 */   GIM_Try, /*On fail goto*//*Label 24801*/ GIMT_Encode4(1830183), // Rule ID 13072 //
     /* 1830102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830148 */     // MIs[0] policy
     /* 1830148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830182 */     // GIR_Coverage, 13072,
     /* 1830182 */     GIR_EraseRootFromParent_Done,
     /* 1830183 */   // Label 24801: @1830183
     /* 1830183 */   GIM_Try, /*On fail goto*//*Label 24802*/ GIMT_Encode4(1830269), // Rule ID 13073 //
     /* 1830188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1830196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1830199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1830202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1830208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830234 */     // MIs[0] policy
     /* 1830234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830244 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1830247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830268 */     // GIR_Coverage, 13073,
     /* 1830268 */     GIR_EraseRootFromParent_Done,
     /* 1830269 */   // Label 24802: @1830269
     /* 1830269 */   GIM_Try, /*On fail goto*//*Label 24803*/ GIMT_Encode4(1830355), // Rule ID 13076 //
     /* 1830274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1830291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830320 */     // MIs[0] policy
     /* 1830320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830330 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1830333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830354 */     // GIR_Coverage, 13076,
     /* 1830354 */     GIR_EraseRootFromParent_Done,
     /* 1830355 */   // Label 24803: @1830355
     /* 1830355 */   GIM_Try, /*On fail goto*//*Label 24804*/ GIMT_Encode4(1830441), // Rule ID 13077 //
     /* 1830360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1830371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1830374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1830377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1830380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830406 */     // MIs[0] policy
     /* 1830406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830416 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1830419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830440 */     // GIR_Coverage, 13077,
     /* 1830440 */     GIR_EraseRootFromParent_Done,
     /* 1830441 */   // Label 24804: @1830441
     /* 1830441 */   GIM_Try, /*On fail goto*//*Label 24805*/ GIMT_Encode4(1830527), // Rule ID 13080 //
     /* 1830446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1830457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1830460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1830463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1830466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830492 */     // MIs[0] policy
     /* 1830492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830526 */     // GIR_Coverage, 13080,
     /* 1830526 */     GIR_EraseRootFromParent_Done,
     /* 1830527 */   // Label 24805: @1830527
     /* 1830527 */   GIM_Try, /*On fail goto*//*Label 24806*/ GIMT_Encode4(1830613), // Rule ID 13081 //
     /* 1830532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1830543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1830546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1830549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1830552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830578 */     // MIs[0] policy
     /* 1830578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830588 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830612 */     // GIR_Coverage, 13081,
     /* 1830612 */     GIR_EraseRootFromParent_Done,
     /* 1830613 */   // Label 24806: @1830613
     /* 1830613 */   GIM_Try, /*On fail goto*//*Label 24807*/ GIMT_Encode4(1830699), // Rule ID 13084 //
     /* 1830618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1830629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1830632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1830635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1830638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830664 */     // MIs[0] policy
     /* 1830664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830674 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1830677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830698 */     // GIR_Coverage, 13084,
     /* 1830698 */     GIR_EraseRootFromParent_Done,
     /* 1830699 */   // Label 24807: @1830699
     /* 1830699 */   GIM_Try, /*On fail goto*//*Label 24808*/ GIMT_Encode4(1830785), // Rule ID 13085 //
     /* 1830704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1830715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1830718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1830721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1830724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830750 */     // MIs[0] policy
     /* 1830750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830760 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1830763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1830781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830784 */     // GIR_Coverage, 13085,
     /* 1830784 */     GIR_EraseRootFromParent_Done,
     /* 1830785 */   // Label 24808: @1830785
     /* 1830785 */   GIM_Try, /*On fail goto*//*Label 24809*/ GIMT_Encode4(1830871), // Rule ID 13088 //
     /* 1830790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1830801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1830804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1830807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1830810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830836 */     // MIs[0] policy
     /* 1830836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830870 */     // GIR_Coverage, 13088,
     /* 1830870 */     GIR_EraseRootFromParent_Done,
     /* 1830871 */   // Label 24809: @1830871
     /* 1830871 */   GIM_Try, /*On fail goto*//*Label 24810*/ GIMT_Encode4(1830957), // Rule ID 13089 //
     /* 1830876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1830887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1830890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1830893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1830896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1830899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830922 */     // MIs[0] policy
     /* 1830922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830932 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1830935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830956 */     // GIR_Coverage, 13089,
     /* 1830956 */     GIR_EraseRootFromParent_Done,
     /* 1830957 */   // Label 24810: @1830957
     /* 1830957 */   GIM_Try, /*On fail goto*//*Label 24811*/ GIMT_Encode4(1831043), // Rule ID 13092 //
     /* 1830962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1830973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1830976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1830979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1830982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1830992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1830996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831008 */     // MIs[0] policy
     /* 1831008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831042 */     // GIR_Coverage, 13092,
     /* 1831042 */     GIR_EraseRootFromParent_Done,
     /* 1831043 */   // Label 24811: @1831043
     /* 1831043 */   GIM_Try, /*On fail goto*//*Label 24812*/ GIMT_Encode4(1831129), // Rule ID 13093 //
     /* 1831048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1831059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1831062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1831065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1831068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831094 */     // MIs[0] policy
     /* 1831094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831104 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831128 */     // GIR_Coverage, 13093,
     /* 1831128 */     GIR_EraseRootFromParent_Done,
     /* 1831129 */   // Label 24812: @1831129
     /* 1831129 */   GIM_Try, /*On fail goto*//*Label 24813*/ GIMT_Encode4(1831215), // Rule ID 13096 //
     /* 1831134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1831151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831180 */     // MIs[0] policy
     /* 1831180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831214 */     // GIR_Coverage, 13096,
     /* 1831214 */     GIR_EraseRootFromParent_Done,
     /* 1831215 */   // Label 24813: @1831215
     /* 1831215 */   GIM_Try, /*On fail goto*//*Label 24814*/ GIMT_Encode4(1831301), // Rule ID 13097 //
     /* 1831220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1831231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1831234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1831237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1831240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831266 */     // MIs[0] policy
     /* 1831266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1831279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831300 */     // GIR_Coverage, 13097,
     /* 1831300 */     GIR_EraseRootFromParent_Done,
     /* 1831301 */   // Label 24814: @1831301
     /* 1831301 */   GIM_Try, /*On fail goto*//*Label 24815*/ GIMT_Encode4(1831387), // Rule ID 13100 //
     /* 1831306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1831323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831352 */     // MIs[0] policy
     /* 1831352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831362 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831386 */     // GIR_Coverage, 13100,
     /* 1831386 */     GIR_EraseRootFromParent_Done,
     /* 1831387 */   // Label 24815: @1831387
     /* 1831387 */   GIM_Try, /*On fail goto*//*Label 24816*/ GIMT_Encode4(1831473), // Rule ID 13101 //
     /* 1831392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1831403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1831406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1831409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1831412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831438 */     // MIs[0] policy
     /* 1831438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831448 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831472 */     // GIR_Coverage, 13101,
     /* 1831472 */     GIR_EraseRootFromParent_Done,
     /* 1831473 */   // Label 24816: @1831473
     /* 1831473 */   GIM_Try, /*On fail goto*//*Label 24817*/ GIMT_Encode4(1831559), // Rule ID 13104 //
     /* 1831478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1831489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1831492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1831495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1831498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831524 */     // MIs[0] policy
     /* 1831524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831558 */     // GIR_Coverage, 13104,
     /* 1831558 */     GIR_EraseRootFromParent_Done,
     /* 1831559 */   // Label 24817: @1831559
     /* 1831559 */   GIM_Try, /*On fail goto*//*Label 24818*/ GIMT_Encode4(1831645), // Rule ID 13105 //
     /* 1831564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1831575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1831578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1831581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1831584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831610 */     // MIs[0] policy
     /* 1831610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831644 */     // GIR_Coverage, 13105,
     /* 1831644 */     GIR_EraseRootFromParent_Done,
     /* 1831645 */   // Label 24818: @1831645
     /* 1831645 */   GIM_Try, /*On fail goto*//*Label 24819*/ GIMT_Encode4(1831731), // Rule ID 13108 //
     /* 1831650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1831661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1831664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1831667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1831670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831696 */     // MIs[0] policy
     /* 1831696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831706 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831730 */     // GIR_Coverage, 13108,
     /* 1831730 */     GIR_EraseRootFromParent_Done,
     /* 1831731 */   // Label 24819: @1831731
     /* 1831731 */   GIM_Try, /*On fail goto*//*Label 24820*/ GIMT_Encode4(1831817), // Rule ID 13109 //
     /* 1831736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1831747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1831750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1831753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1831756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831782 */     // MIs[0] policy
     /* 1831782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1831813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831816 */     // GIR_Coverage, 13109,
     /* 1831816 */     GIR_EraseRootFromParent_Done,
     /* 1831817 */   // Label 24820: @1831817
     /* 1831817 */   GIM_Try, /*On fail goto*//*Label 24821*/ GIMT_Encode4(1831903), // Rule ID 13112 //
     /* 1831822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1831825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1831833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1831836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1831839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1831842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831868 */     // MIs[0] policy
     /* 1831868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831878 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831902 */     // GIR_Coverage, 13112,
     /* 1831902 */     GIR_EraseRootFromParent_Done,
     /* 1831903 */   // Label 24821: @1831903
     /* 1831903 */   GIM_Try, /*On fail goto*//*Label 24822*/ GIMT_Encode4(1831989), // Rule ID 13113 //
     /* 1831908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1831919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1831922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1831925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1831928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831954 */     // MIs[0] policy
     /* 1831954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1831967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831988 */     // GIR_Coverage, 13113,
     /* 1831988 */     GIR_EraseRootFromParent_Done,
     /* 1831989 */   // Label 24822: @1831989
     /* 1831989 */   GIM_Try, /*On fail goto*//*Label 24823*/ GIMT_Encode4(1832075), // Rule ID 13116 //
     /* 1831994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1832011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832040 */     // MIs[0] policy
     /* 1832040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832074 */     // GIR_Coverage, 13116,
     /* 1832074 */     GIR_EraseRootFromParent_Done,
     /* 1832075 */   // Label 24823: @1832075
     /* 1832075 */   GIM_Try, /*On fail goto*//*Label 24824*/ GIMT_Encode4(1832161), // Rule ID 13117 //
     /* 1832080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1832097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832126 */     // MIs[0] policy
     /* 1832126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832136 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832160 */     // GIR_Coverage, 13117,
     /* 1832160 */     GIR_EraseRootFromParent_Done,
     /* 1832161 */   // Label 24824: @1832161
     /* 1832161 */   GIM_Try, /*On fail goto*//*Label 24825*/ GIMT_Encode4(1832247), // Rule ID 13120 //
     /* 1832166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1832183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832212 */     // MIs[0] policy
     /* 1832212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832222 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832246 */     // GIR_Coverage, 13120,
     /* 1832246 */     GIR_EraseRootFromParent_Done,
     /* 1832247 */   // Label 24825: @1832247
     /* 1832247 */   GIM_Try, /*On fail goto*//*Label 24826*/ GIMT_Encode4(1832333), // Rule ID 13121 //
     /* 1832252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1832263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1832266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1832269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1832272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832298 */     // MIs[0] policy
     /* 1832298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832308 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832332 */     // GIR_Coverage, 13121,
     /* 1832332 */     GIR_EraseRootFromParent_Done,
     /* 1832333 */   // Label 24826: @1832333
     /* 1832333 */   GIM_Try, /*On fail goto*//*Label 24827*/ GIMT_Encode4(1832419), // Rule ID 13124 //
     /* 1832338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1832355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832384 */     // MIs[0] policy
     /* 1832384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832394 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832418 */     // GIR_Coverage, 13124,
     /* 1832418 */     GIR_EraseRootFromParent_Done,
     /* 1832419 */   // Label 24827: @1832419
     /* 1832419 */   GIM_Try, /*On fail goto*//*Label 24828*/ GIMT_Encode4(1832505), // Rule ID 13125 //
     /* 1832424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1832435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1832438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1832441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1832444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1832447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832470 */     // MIs[0] policy
     /* 1832470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832480 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832504 */     // GIR_Coverage, 13125,
     /* 1832504 */     GIR_EraseRootFromParent_Done,
     /* 1832505 */   // Label 24828: @1832505
     /* 1832505 */   GIM_Try, /*On fail goto*//*Label 24829*/ GIMT_Encode4(1832591), // Rule ID 13128 //
     /* 1832510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1832521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1832524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1832527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1832530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832556 */     // MIs[0] policy
     /* 1832556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832590 */     // GIR_Coverage, 13128,
     /* 1832590 */     GIR_EraseRootFromParent_Done,
     /* 1832591 */   // Label 24829: @1832591
     /* 1832591 */   GIM_Try, /*On fail goto*//*Label 24830*/ GIMT_Encode4(1832677), // Rule ID 13129 //
     /* 1832596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1832607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1832610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1832613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1832616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1832626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1832638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832642 */     // MIs[0] policy
     /* 1832642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832652 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1832655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832676 */     // GIR_Coverage, 13129,
     /* 1832676 */     GIR_EraseRootFromParent_Done,
     /* 1832677 */   // Label 24830: @1832677
     /* 1832677 */   GIM_Try, /*On fail goto*//*Label 24831*/ GIMT_Encode4(1832763), // Rule ID 13132 //
     /* 1832682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1832693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1832696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1832699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1832702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832728 */     // MIs[0] policy
     /* 1832728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832762 */     // GIR_Coverage, 13132,
     /* 1832762 */     GIR_EraseRootFromParent_Done,
     /* 1832763 */   // Label 24831: @1832763
     /* 1832763 */   GIM_Try, /*On fail goto*//*Label 24832*/ GIMT_Encode4(1832849), // Rule ID 13133 //
     /* 1832768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1832779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1832782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1832785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1832788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1832798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1832810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832814 */     // MIs[0] policy
     /* 1832814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832824 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1832827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832848 */     // GIR_Coverage, 13133,
     /* 1832848 */     GIR_EraseRootFromParent_Done,
     /* 1832849 */   // Label 24832: @1832849
     /* 1832849 */   GIM_Try, /*On fail goto*//*Label 24833*/ GIMT_Encode4(1832935), // Rule ID 13136 //
     /* 1832854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1832865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1832868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1832871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1832874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832900 */     // MIs[0] policy
     /* 1832900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832934 */     // GIR_Coverage, 13136,
     /* 1832934 */     GIR_EraseRootFromParent_Done,
     /* 1832935 */   // Label 24833: @1832935
     /* 1832935 */   GIM_Try, /*On fail goto*//*Label 24834*/ GIMT_Encode4(1833021), // Rule ID 13137 //
     /* 1832940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1832948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1832951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1832954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1832957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1832960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1832963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1832970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1832982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832986 */     // MIs[0] policy
     /* 1832986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832996 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1832999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833020 */     // GIR_Coverage, 13137,
     /* 1833020 */     GIR_EraseRootFromParent_Done,
     /* 1833021 */   // Label 24834: @1833021
     /* 1833021 */   GIM_Try, /*On fail goto*//*Label 24835*/ GIMT_Encode4(1833107), // Rule ID 13140 //
     /* 1833026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1833043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833072 */     // MIs[0] policy
     /* 1833072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833106 */     // GIR_Coverage, 13140,
     /* 1833106 */     GIR_EraseRootFromParent_Done,
     /* 1833107 */   // Label 24835: @1833107
     /* 1833107 */   GIM_Try, /*On fail goto*//*Label 24836*/ GIMT_Encode4(1833193), // Rule ID 13141 //
     /* 1833112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1833123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1833126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1833129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1833132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833158 */     // MIs[0] policy
     /* 1833158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833192 */     // GIR_Coverage, 13141,
     /* 1833192 */     GIR_EraseRootFromParent_Done,
     /* 1833193 */   // Label 24836: @1833193
     /* 1833193 */   GIM_Try, /*On fail goto*//*Label 24837*/ GIMT_Encode4(1833279), // Rule ID 13144 //
     /* 1833198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1833215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833244 */     // MIs[0] policy
     /* 1833244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833278 */     // GIR_Coverage, 13144,
     /* 1833278 */     GIR_EraseRootFromParent_Done,
     /* 1833279 */   // Label 24837: @1833279
     /* 1833279 */   GIM_Try, /*On fail goto*//*Label 24838*/ GIMT_Encode4(1833365), // Rule ID 13145 //
     /* 1833284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1833295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1833298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1833301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1833304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833330 */     // MIs[0] policy
     /* 1833330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833340 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833364 */     // GIR_Coverage, 13145,
     /* 1833364 */     GIR_EraseRootFromParent_Done,
     /* 1833365 */   // Label 24838: @1833365
     /* 1833365 */   GIM_Try, /*On fail goto*//*Label 24839*/ GIMT_Encode4(1833451), // Rule ID 13148 //
     /* 1833370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1833387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833416 */     // MIs[0] policy
     /* 1833416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833450 */     // GIR_Coverage, 13148,
     /* 1833450 */     GIR_EraseRootFromParent_Done,
     /* 1833451 */   // Label 24839: @1833451
     /* 1833451 */   GIM_Try, /*On fail goto*//*Label 24840*/ GIMT_Encode4(1833537), // Rule ID 13149 //
     /* 1833456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1833467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1833470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1833473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1833476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833502 */     // MIs[0] policy
     /* 1833502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833512 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1833533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833536 */     // GIR_Coverage, 13149,
     /* 1833536 */     GIR_EraseRootFromParent_Done,
     /* 1833537 */   // Label 24840: @1833537
     /* 1833537 */   GIM_Try, /*On fail goto*//*Label 24841*/ GIMT_Encode4(1833623), // Rule ID 13152 //
     /* 1833542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1833553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1833556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1833559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1833562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1833565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833588 */     // MIs[0] policy
     /* 1833588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833622 */     // GIR_Coverage, 13152,
     /* 1833622 */     GIR_EraseRootFromParent_Done,
     /* 1833623 */   // Label 24841: @1833623
     /* 1833623 */   GIM_Try, /*On fail goto*//*Label 24842*/ GIMT_Encode4(1833709), // Rule ID 13153 //
     /* 1833628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1833639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1833642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1833645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1833648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1833651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833674 */     // MIs[0] policy
     /* 1833674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1833687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833708 */     // GIR_Coverage, 13153,
     /* 1833708 */     GIR_EraseRootFromParent_Done,
     /* 1833709 */   // Label 24842: @1833709
     /* 1833709 */   GIM_Try, /*On fail goto*//*Label 24843*/ GIMT_Encode4(1833795), // Rule ID 13156 //
     /* 1833714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1833725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1833728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1833731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1833734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833760 */     // MIs[0] policy
     /* 1833760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833794 */     // GIR_Coverage, 13156,
     /* 1833794 */     GIR_EraseRootFromParent_Done,
     /* 1833795 */   // Label 24843: @1833795
     /* 1833795 */   GIM_Try, /*On fail goto*//*Label 24844*/ GIMT_Encode4(1833881), // Rule ID 13157 //
     /* 1833800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1833811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1833814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1833817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1833820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1833823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833846 */     // MIs[0] policy
     /* 1833846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833856 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1833859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833880 */     // GIR_Coverage, 13157,
     /* 1833880 */     GIR_EraseRootFromParent_Done,
     /* 1833881 */   // Label 24844: @1833881
     /* 1833881 */   GIM_Try, /*On fail goto*//*Label 24845*/ GIMT_Encode4(1833967), // Rule ID 13160 //
     /* 1833886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1833889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1833897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1833900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1833903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1833906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833932 */     // MIs[0] policy
     /* 1833932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1833945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1833963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833966 */     // GIR_Coverage, 13160,
     /* 1833966 */     GIR_EraseRootFromParent_Done,
     /* 1833967 */   // Label 24845: @1833967
     /* 1833967 */   GIM_Try, /*On fail goto*//*Label 24846*/ GIMT_Encode4(1834053), // Rule ID 13161 //
     /* 1833972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1833975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1833980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1833983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1833986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1833989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1833992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834018 */     // MIs[0] policy
     /* 1834018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1834031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834052 */     // GIR_Coverage, 13161,
     /* 1834052 */     GIR_EraseRootFromParent_Done,
     /* 1834053 */   // Label 24846: @1834053
     /* 1834053 */   GIM_Try, /*On fail goto*//*Label 24847*/ GIMT_Encode4(1834139), // Rule ID 13164 //
     /* 1834058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834104 */     // MIs[0] policy
     /* 1834104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834114 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1834117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834138 */     // GIR_Coverage, 13164,
     /* 1834138 */     GIR_EraseRootFromParent_Done,
     /* 1834139 */   // Label 24847: @1834139
     /* 1834139 */   GIM_Try, /*On fail goto*//*Label 24848*/ GIMT_Encode4(1834225), // Rule ID 13165 //
     /* 1834144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1834155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1834158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1834164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834190 */     // MIs[0] policy
     /* 1834190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1834203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834224 */     // GIR_Coverage, 13165,
     /* 1834224 */     GIR_EraseRootFromParent_Done,
     /* 1834225 */   // Label 24848: @1834225
     /* 1834225 */   GIM_Try, /*On fail goto*//*Label 24849*/ GIMT_Encode4(1834311), // Rule ID 13168 //
     /* 1834230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834276 */     // MIs[0] policy
     /* 1834276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834310 */     // GIR_Coverage, 13168,
     /* 1834310 */     GIR_EraseRootFromParent_Done,
     /* 1834311 */   // Label 24849: @1834311
     /* 1834311 */   GIM_Try, /*On fail goto*//*Label 24850*/ GIMT_Encode4(1834397), // Rule ID 13169 //
     /* 1834316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1834327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1834330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1834336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834362 */     // MIs[0] policy
     /* 1834362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834372 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834396 */     // GIR_Coverage, 13169,
     /* 1834396 */     GIR_EraseRootFromParent_Done,
     /* 1834397 */   // Label 24850: @1834397
     /* 1834397 */   GIM_Try, /*On fail goto*//*Label 24851*/ GIMT_Encode4(1834483), // Rule ID 13172 //
     /* 1834402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834448 */     // MIs[0] policy
     /* 1834448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834482 */     // GIR_Coverage, 13172,
     /* 1834482 */     GIR_EraseRootFromParent_Done,
     /* 1834483 */   // Label 24851: @1834483
     /* 1834483 */   GIM_Try, /*On fail goto*//*Label 24852*/ GIMT_Encode4(1834569), // Rule ID 13173 //
     /* 1834488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1834499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1834502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1834508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834534 */     // MIs[0] policy
     /* 1834534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1834565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834568 */     // GIR_Coverage, 13173,
     /* 1834568 */     GIR_EraseRootFromParent_Done,
     /* 1834569 */   // Label 24852: @1834569
     /* 1834569 */   GIM_Try, /*On fail goto*//*Label 24853*/ GIMT_Encode4(1834655), // Rule ID 13176 //
     /* 1834574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1834585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1834588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1834594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834620 */     // MIs[0] policy
     /* 1834620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834654 */     // GIR_Coverage, 13176,
     /* 1834654 */     GIR_EraseRootFromParent_Done,
     /* 1834655 */   // Label 24853: @1834655
     /* 1834655 */   GIM_Try, /*On fail goto*//*Label 24854*/ GIMT_Encode4(1834741), // Rule ID 13177 //
     /* 1834660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1834671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1834674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1834680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834706 */     // MIs[0] policy
     /* 1834706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1834719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834740 */     // GIR_Coverage, 13177,
     /* 1834740 */     GIR_EraseRootFromParent_Done,
     /* 1834741 */   // Label 24854: @1834741
     /* 1834741 */   GIM_Try, /*On fail goto*//*Label 24855*/ GIMT_Encode4(1834827), // Rule ID 13180 //
     /* 1834746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1834757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1834760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1834766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834792 */     // MIs[0] policy
     /* 1834792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834826 */     // GIR_Coverage, 13180,
     /* 1834826 */     GIR_EraseRootFromParent_Done,
     /* 1834827 */   // Label 24855: @1834827
     /* 1834827 */   GIM_Try, /*On fail goto*//*Label 24856*/ GIMT_Encode4(1834913), // Rule ID 13181 //
     /* 1834832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1834843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1834846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1834849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1834852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834878 */     // MIs[0] policy
     /* 1834878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834888 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1834909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834912 */     // GIR_Coverage, 13181,
     /* 1834912 */     GIR_EraseRootFromParent_Done,
     /* 1834913 */   // Label 24856: @1834913
     /* 1834913 */   GIM_Try, /*On fail goto*//*Label 24857*/ GIMT_Encode4(1834999), // Rule ID 13184 //
     /* 1834918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1834926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1834929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1834932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1834935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1834938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1834941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1834948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1834956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1834960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834964 */     // MIs[0] policy
     /* 1834964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1834977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834998 */     // GIR_Coverage, 13184,
     /* 1834998 */     GIR_EraseRootFromParent_Done,
     /* 1834999 */   // Label 24857: @1834999
     /* 1834999 */   GIM_Try, /*On fail goto*//*Label 24858*/ GIMT_Encode4(1835085), // Rule ID 13185 //
     /* 1835004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1835024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835050 */     // MIs[0] policy
     /* 1835050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1835063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835084 */     // GIR_Coverage, 13185,
     /* 1835084 */     GIR_EraseRootFromParent_Done,
     /* 1835085 */   // Label 24858: @1835085
     /* 1835085 */   GIM_Try, /*On fail goto*//*Label 24859*/ GIMT_Encode4(1835171), // Rule ID 13188 //
     /* 1835090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835136 */     // MIs[0] policy
     /* 1835136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835146 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835170 */     // GIR_Coverage, 13188,
     /* 1835170 */     GIR_EraseRootFromParent_Done,
     /* 1835171 */   // Label 24859: @1835171
     /* 1835171 */   GIM_Try, /*On fail goto*//*Label 24860*/ GIMT_Encode4(1835257), // Rule ID 13189 //
     /* 1835176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1835187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1835190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1835196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1835199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835222 */     // MIs[0] policy
     /* 1835222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835256 */     // GIR_Coverage, 13189,
     /* 1835256 */     GIR_EraseRootFromParent_Done,
     /* 1835257 */   // Label 24860: @1835257
     /* 1835257 */   GIM_Try, /*On fail goto*//*Label 24861*/ GIMT_Encode4(1835343), // Rule ID 13192 //
     /* 1835262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835308 */     // MIs[0] policy
     /* 1835308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835342 */     // GIR_Coverage, 13192,
     /* 1835342 */     GIR_EraseRootFromParent_Done,
     /* 1835343 */   // Label 24861: @1835343
     /* 1835343 */   GIM_Try, /*On fail goto*//*Label 24862*/ GIMT_Encode4(1835429), // Rule ID 13193 //
     /* 1835348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1835359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1835362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1835368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835394 */     // MIs[0] policy
     /* 1835394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835404 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835428 */     // GIR_Coverage, 13193,
     /* 1835428 */     GIR_EraseRootFromParent_Done,
     /* 1835429 */   // Label 24862: @1835429
     /* 1835429 */   GIM_Try, /*On fail goto*//*Label 24863*/ GIMT_Encode4(1835515), // Rule ID 13196 //
     /* 1835434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1835448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1835454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835480 */     // MIs[0] policy
     /* 1835480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835514 */     // GIR_Coverage, 13196,
     /* 1835514 */     GIR_EraseRootFromParent_Done,
     /* 1835515 */   // Label 24863: @1835515
     /* 1835515 */   GIM_Try, /*On fail goto*//*Label 24864*/ GIMT_Encode4(1835601), // Rule ID 13197 //
     /* 1835520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1835531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1835534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1835540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835566 */     // MIs[0] policy
     /* 1835566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835600 */     // GIR_Coverage, 13197,
     /* 1835600 */     GIR_EraseRootFromParent_Done,
     /* 1835601 */   // Label 24864: @1835601
     /* 1835601 */   GIM_Try, /*On fail goto*//*Label 24865*/ GIMT_Encode4(1835687), // Rule ID 13200 //
     /* 1835606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1835609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1835617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1835620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1835626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835652 */     // MIs[0] policy
     /* 1835652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835662 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835686 */     // GIR_Coverage, 13200,
     /* 1835686 */     GIR_EraseRootFromParent_Done,
     /* 1835687 */   // Label 24865: @1835687
     /* 1835687 */   GIM_Try, /*On fail goto*//*Label 24866*/ GIMT_Encode4(1835773), // Rule ID 13201 //
     /* 1835692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1835695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1835703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1835706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1835712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835738 */     // MIs[0] policy
     /* 1835738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1835751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835772 */     // GIR_Coverage, 13201,
     /* 1835772 */     GIR_EraseRootFromParent_Done,
     /* 1835773 */   // Label 24866: @1835773
     /* 1835773 */   GIM_Try, /*On fail goto*//*Label 24867*/ GIMT_Encode4(1835859), // Rule ID 13204 //
     /* 1835778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1835789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1835792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1835798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1835801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1835808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835824 */     // MIs[0] policy
     /* 1835824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1835837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835858 */     // GIR_Coverage, 13204,
     /* 1835858 */     GIR_EraseRootFromParent_Done,
     /* 1835859 */   // Label 24867: @1835859
     /* 1835859 */   GIM_Try, /*On fail goto*//*Label 24868*/ GIMT_Encode4(1835945), // Rule ID 13205 //
     /* 1835864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1835875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1835878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1835884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1835887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1835894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1835906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835910 */     // MIs[0] policy
     /* 1835910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835920 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1835923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835944 */     // GIR_Coverage, 13205,
     /* 1835944 */     GIR_EraseRootFromParent_Done,
     /* 1835945 */   // Label 24868: @1835945
     /* 1835945 */   GIM_Try, /*On fail goto*//*Label 24869*/ GIMT_Encode4(1836031), // Rule ID 13208 //
     /* 1835950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1835958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1835961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1835964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1835970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1835973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1835980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1835984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1835992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835996 */     // MIs[0] policy
     /* 1835996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836006 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836030 */     // GIR_Coverage, 13208,
     /* 1836030 */     GIR_EraseRootFromParent_Done,
     /* 1836031 */   // Label 24869: @1836031
     /* 1836031 */   GIM_Try, /*On fail goto*//*Label 24870*/ GIMT_Encode4(1836117), // Rule ID 13209 //
     /* 1836036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1836047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1836050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1836056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836082 */     // MIs[0] policy
     /* 1836082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836116 */     // GIR_Coverage, 13209,
     /* 1836116 */     GIR_EraseRootFromParent_Done,
     /* 1836117 */   // Label 24870: @1836117
     /* 1836117 */   GIM_Try, /*On fail goto*//*Label 24871*/ GIMT_Encode4(1836203), // Rule ID 13212 //
     /* 1836122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836168 */     // MIs[0] policy
     /* 1836168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836178 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836202 */     // GIR_Coverage, 13212,
     /* 1836202 */     GIR_EraseRootFromParent_Done,
     /* 1836203 */   // Label 24871: @1836203
     /* 1836203 */   GIM_Try, /*On fail goto*//*Label 24872*/ GIMT_Encode4(1836289), // Rule ID 13213 //
     /* 1836208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1836219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1836222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1836228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1836231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836254 */     // MIs[0] policy
     /* 1836254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836264 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836288 */     // GIR_Coverage, 13213,
     /* 1836288 */     GIR_EraseRootFromParent_Done,
     /* 1836289 */   // Label 24872: @1836289
     /* 1836289 */   GIM_Try, /*On fail goto*//*Label 24873*/ GIMT_Encode4(1836375), // Rule ID 13216 //
     /* 1836294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836340 */     // MIs[0] policy
     /* 1836340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836374 */     // GIR_Coverage, 13216,
     /* 1836374 */     GIR_EraseRootFromParent_Done,
     /* 1836375 */   // Label 24873: @1836375
     /* 1836375 */   GIM_Try, /*On fail goto*//*Label 24874*/ GIMT_Encode4(1836461), // Rule ID 13217 //
     /* 1836380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1836391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1836394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1836400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836426 */     // MIs[0] policy
     /* 1836426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836436 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836460 */     // GIR_Coverage, 13217,
     /* 1836460 */     GIR_EraseRootFromParent_Done,
     /* 1836461 */   // Label 24874: @1836461
     /* 1836461 */   GIM_Try, /*On fail goto*//*Label 24875*/ GIMT_Encode4(1836547), // Rule ID 13220 //
     /* 1836466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1836486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836512 */     // MIs[0] policy
     /* 1836512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836522 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836546 */     // GIR_Coverage, 13220,
     /* 1836546 */     GIR_EraseRootFromParent_Done,
     /* 1836547 */   // Label 24875: @1836547
     /* 1836547 */   GIM_Try, /*On fail goto*//*Label 24876*/ GIMT_Encode4(1836633), // Rule ID 13221 //
     /* 1836552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1836563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1836566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1836572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836598 */     // MIs[0] policy
     /* 1836598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836608 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1836611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836632 */     // GIR_Coverage, 13221,
     /* 1836632 */     GIR_EraseRootFromParent_Done,
     /* 1836633 */   // Label 24876: @1836633
     /* 1836633 */   GIM_Try, /*On fail goto*//*Label 24877*/ GIMT_Encode4(1836719), // Rule ID 13224 //
     /* 1836638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1836649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1836652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1836658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836684 */     // MIs[0] policy
     /* 1836684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836718 */     // GIR_Coverage, 13224,
     /* 1836718 */     GIR_EraseRootFromParent_Done,
     /* 1836719 */   // Label 24877: @1836719
     /* 1836719 */   GIM_Try, /*On fail goto*//*Label 24878*/ GIMT_Encode4(1836805), // Rule ID 13225 //
     /* 1836724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1836735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1836738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1836744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1836754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1836766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836770 */     // MIs[0] policy
     /* 1836770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836780 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1836783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836804 */     // GIR_Coverage, 13225,
     /* 1836804 */     GIR_EraseRootFromParent_Done,
     /* 1836805 */   // Label 24878: @1836805
     /* 1836805 */   GIM_Try, /*On fail goto*//*Label 24879*/ GIMT_Encode4(1836891), // Rule ID 13228 //
     /* 1836810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1836821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1836824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1836830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836856 */     // MIs[0] policy
     /* 1836856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836890 */     // GIR_Coverage, 13228,
     /* 1836890 */     GIR_EraseRootFromParent_Done,
     /* 1836891 */   // Label 24879: @1836891
     /* 1836891 */   GIM_Try, /*On fail goto*//*Label 24880*/ GIMT_Encode4(1836977), // Rule ID 13229 //
     /* 1836896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1836907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1836910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1836916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836942 */     // MIs[0] policy
     /* 1836942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1836955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836976 */     // GIR_Coverage, 13229,
     /* 1836976 */     GIR_EraseRootFromParent_Done,
     /* 1836977 */   // Label 24880: @1836977
     /* 1836977 */   GIM_Try, /*On fail goto*//*Label 24881*/ GIMT_Encode4(1837063), // Rule ID 13232 //
     /* 1836982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1836990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1836993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1836996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837028 */     // MIs[0] policy
     /* 1837028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837038 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837062 */     // GIR_Coverage, 13232,
     /* 1837062 */     GIR_EraseRootFromParent_Done,
     /* 1837063 */   // Label 24881: @1837063
     /* 1837063 */   GIM_Try, /*On fail goto*//*Label 24882*/ GIMT_Encode4(1837149), // Rule ID 13233 //
     /* 1837068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837114 */     // MIs[0] policy
     /* 1837114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837124 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837148 */     // GIR_Coverage, 13233,
     /* 1837148 */     GIR_EraseRootFromParent_Done,
     /* 1837149 */   // Label 24882: @1837149
     /* 1837149 */   GIM_Try, /*On fail goto*//*Label 24883*/ GIMT_Encode4(1837235), // Rule ID 13236 //
     /* 1837154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837200 */     // MIs[0] policy
     /* 1837200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837234 */     // GIR_Coverage, 13236,
     /* 1837234 */     GIR_EraseRootFromParent_Done,
     /* 1837235 */   // Label 24883: @1837235
     /* 1837235 */   GIM_Try, /*On fail goto*//*Label 24884*/ GIMT_Encode4(1837321), // Rule ID 13237 //
     /* 1837240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1837251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1837254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1837260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837286 */     // MIs[0] policy
     /* 1837286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837296 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837320 */     // GIR_Coverage, 13237,
     /* 1837320 */     GIR_EraseRootFromParent_Done,
     /* 1837321 */   // Label 24884: @1837321
     /* 1837321 */   GIM_Try, /*On fail goto*//*Label 24885*/ GIMT_Encode4(1837407), // Rule ID 13240 //
     /* 1837326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837372 */     // MIs[0] policy
     /* 1837372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837406 */     // GIR_Coverage, 13240,
     /* 1837406 */     GIR_EraseRootFromParent_Done,
     /* 1837407 */   // Label 24885: @1837407
     /* 1837407 */   GIM_Try, /*On fail goto*//*Label 24886*/ GIMT_Encode4(1837493), // Rule ID 13241 //
     /* 1837412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1837423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1837426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1837432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1837435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837458 */     // MIs[0] policy
     /* 1837458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837468 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1837471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837492 */     // GIR_Coverage, 13241,
     /* 1837492 */     GIR_EraseRootFromParent_Done,
     /* 1837493 */   // Label 24886: @1837493
     /* 1837493 */   GIM_Try, /*On fail goto*//*Label 24887*/ GIMT_Encode4(1837579), // Rule ID 13244 //
     /* 1837498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1837518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837544 */     // MIs[0] policy
     /* 1837544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837578 */     // GIR_Coverage, 13244,
     /* 1837578 */     GIR_EraseRootFromParent_Done,
     /* 1837579 */   // Label 24887: @1837579
     /* 1837579 */   GIM_Try, /*On fail goto*//*Label 24888*/ GIMT_Encode4(1837665), // Rule ID 13245 //
     /* 1837584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1837595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1837598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1837604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837630 */     // MIs[0] policy
     /* 1837630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837640 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1837643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837664 */     // GIR_Coverage, 13245,
     /* 1837664 */     GIR_EraseRootFromParent_Done,
     /* 1837665 */   // Label 24888: @1837665
     /* 1837665 */   GIM_Try, /*On fail goto*//*Label 24889*/ GIMT_Encode4(1837751), // Rule ID 13248 //
     /* 1837670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1837673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1837681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1837684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1837690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837716 */     // MIs[0] policy
     /* 1837716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837750 */     // GIR_Coverage, 13248,
     /* 1837750 */     GIR_EraseRootFromParent_Done,
     /* 1837751 */   // Label 24889: @1837751
     /* 1837751 */   GIM_Try, /*On fail goto*//*Label 24890*/ GIMT_Encode4(1837837), // Rule ID 13249 //
     /* 1837756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1837759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1837764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1837767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1837770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1837776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837802 */     // MIs[0] policy
     /* 1837802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837812 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1837815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1837833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837836 */     // GIR_Coverage, 13249,
     /* 1837836 */     GIR_EraseRootFromParent_Done,
     /* 1837837 */   // Label 24890: @1837837
     /* 1837837 */   GIM_Try, /*On fail goto*//*Label 24891*/ GIMT_Encode4(1837923), // Rule ID 13252 //
     /* 1837842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1837853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1837856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1837859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1837862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1837865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837888 */     // MIs[0] policy
     /* 1837888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837898 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1837901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837922 */     // GIR_Coverage, 13252,
     /* 1837922 */     GIR_EraseRootFromParent_Done,
     /* 1837923 */   // Label 24891: @1837923
     /* 1837923 */   GIM_Try, /*On fail goto*//*Label 24892*/ GIMT_Encode4(1838009), // Rule ID 13253 //
     /* 1837928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1837939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1837942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1837945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1837948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1837951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1837958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1837970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837974 */     // MIs[0] policy
     /* 1837974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837984 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1837987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838008 */     // GIR_Coverage, 13253,
     /* 1838008 */     GIR_EraseRootFromParent_Done,
     /* 1838009 */   // Label 24892: @1838009
     /* 1838009 */   GIM_Try, /*On fail goto*//*Label 24893*/ GIMT_Encode4(1838095), // Rule ID 13256 //
     /* 1838014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1838031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838060 */     // MIs[0] policy
     /* 1838060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838070 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838094 */     // GIR_Coverage, 13256,
     /* 1838094 */     GIR_EraseRootFromParent_Done,
     /* 1838095 */   // Label 24893: @1838095
     /* 1838095 */   GIM_Try, /*On fail goto*//*Label 24894*/ GIMT_Encode4(1838181), // Rule ID 13257 //
     /* 1838100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1838111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1838114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1838117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1838120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838146 */     // MIs[0] policy
     /* 1838146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838156 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838180 */     // GIR_Coverage, 13257,
     /* 1838180 */     GIR_EraseRootFromParent_Done,
     /* 1838181 */   // Label 24894: @1838181
     /* 1838181 */   GIM_Try, /*On fail goto*//*Label 24895*/ GIMT_Encode4(1838267), // Rule ID 13260 //
     /* 1838186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1838203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838232 */     // MIs[0] policy
     /* 1838232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838242 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838266 */     // GIR_Coverage, 13260,
     /* 1838266 */     GIR_EraseRootFromParent_Done,
     /* 1838267 */   // Label 24895: @1838267
     /* 1838267 */   GIM_Try, /*On fail goto*//*Label 24896*/ GIMT_Encode4(1838353), // Rule ID 13261 //
     /* 1838272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1838283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1838286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1838289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1838292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838318 */     // MIs[0] policy
     /* 1838318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838328 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838352 */     // GIR_Coverage, 13261,
     /* 1838352 */     GIR_EraseRootFromParent_Done,
     /* 1838353 */   // Label 24896: @1838353
     /* 1838353 */   GIM_Try, /*On fail goto*//*Label 24897*/ GIMT_Encode4(1838439), // Rule ID 13264 //
     /* 1838358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1838375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838404 */     // MIs[0] policy
     /* 1838404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838438 */     // GIR_Coverage, 13264,
     /* 1838438 */     GIR_EraseRootFromParent_Done,
     /* 1838439 */   // Label 24897: @1838439
     /* 1838439 */   GIM_Try, /*On fail goto*//*Label 24898*/ GIMT_Encode4(1838525), // Rule ID 13265 //
     /* 1838444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1838461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1838464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838490 */     // MIs[0] policy
     /* 1838490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838500 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1838503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838524 */     // GIR_Coverage, 13265,
     /* 1838524 */     GIR_EraseRootFromParent_Done,
     /* 1838525 */   // Label 24898: @1838525
     /* 1838525 */   GIM_Try, /*On fail goto*//*Label 24899*/ GIMT_Encode4(1838611), // Rule ID 13268 //
     /* 1838530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1838541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1838544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1838547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1838550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838576 */     // MIs[0] policy
     /* 1838576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838610 */     // GIR_Coverage, 13268,
     /* 1838610 */     GIR_EraseRootFromParent_Done,
     /* 1838611 */   // Label 24899: @1838611
     /* 1838611 */   GIM_Try, /*On fail goto*//*Label 24900*/ GIMT_Encode4(1838697), // Rule ID 13269 //
     /* 1838616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1838627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1838630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1838633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1838636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838662 */     // MIs[0] policy
     /* 1838662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838672 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1838693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838696 */     // GIR_Coverage, 13269,
     /* 1838696 */     GIR_EraseRootFromParent_Done,
     /* 1838697 */   // Label 24900: @1838697
     /* 1838697 */   GIM_Try, /*On fail goto*//*Label 24901*/ GIMT_Encode4(1838783), // Rule ID 13272 //
     /* 1838702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1838713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1838716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1838719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1838722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838748 */     // MIs[0] policy
     /* 1838748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838782 */     // GIR_Coverage, 13272,
     /* 1838782 */     GIR_EraseRootFromParent_Done,
     /* 1838783 */   // Label 24901: @1838783
     /* 1838783 */   GIM_Try, /*On fail goto*//*Label 24902*/ GIMT_Encode4(1838869), // Rule ID 13273 //
     /* 1838788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1838799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1838802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1838805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1838808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838834 */     // MIs[0] policy
     /* 1838834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1838847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838868 */     // GIR_Coverage, 13273,
     /* 1838868 */     GIR_EraseRootFromParent_Done,
     /* 1838869 */   // Label 24902: @1838869
     /* 1838869 */   GIM_Try, /*On fail goto*//*Label 24903*/ GIMT_Encode4(1838955), // Rule ID 13276 //
     /* 1838874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1838885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1838888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1838891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1838894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838920 */     // MIs[0] policy
     /* 1838920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838930 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1838933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838954 */     // GIR_Coverage, 13276,
     /* 1838954 */     GIR_EraseRootFromParent_Done,
     /* 1838955 */   // Label 24903: @1838955
     /* 1838955 */   GIM_Try, /*On fail goto*//*Label 24904*/ GIMT_Encode4(1839041), // Rule ID 13277 //
     /* 1838960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1838971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1838974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1838977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1838980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839006 */     // MIs[0] policy
     /* 1839006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839016 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839040 */     // GIR_Coverage, 13277,
     /* 1839040 */     GIR_EraseRootFromParent_Done,
     /* 1839041 */   // Label 24904: @1839041
     /* 1839041 */   GIM_Try, /*On fail goto*//*Label 24905*/ GIMT_Encode4(1839127), // Rule ID 13280 //
     /* 1839046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1839063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839092 */     // MIs[0] policy
     /* 1839092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839126 */     // GIR_Coverage, 13280,
     /* 1839126 */     GIR_EraseRootFromParent_Done,
     /* 1839127 */   // Label 24905: @1839127
     /* 1839127 */   GIM_Try, /*On fail goto*//*Label 24906*/ GIMT_Encode4(1839213), // Rule ID 13281 //
     /* 1839132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1839149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1839152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839178 */     // MIs[0] policy
     /* 1839178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839188 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839212 */     // GIR_Coverage, 13281,
     /* 1839212 */     GIR_EraseRootFromParent_Done,
     /* 1839213 */   // Label 24906: @1839213
     /* 1839213 */   GIM_Try, /*On fail goto*//*Label 24907*/ GIMT_Encode4(1839299), // Rule ID 13284 //
     /* 1839218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1839235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839264 */     // MIs[0] policy
     /* 1839264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839298 */     // GIR_Coverage, 13284,
     /* 1839298 */     GIR_EraseRootFromParent_Done,
     /* 1839299 */   // Label 24907: @1839299
     /* 1839299 */   GIM_Try, /*On fail goto*//*Label 24908*/ GIMT_Encode4(1839385), // Rule ID 13285 //
     /* 1839304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1839315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1839318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1839321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1839324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839350 */     // MIs[0] policy
     /* 1839350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1839381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839384 */     // GIR_Coverage, 13285,
     /* 1839384 */     GIR_EraseRootFromParent_Done,
     /* 1839385 */   // Label 24908: @1839385
     /* 1839385 */   GIM_Try, /*On fail goto*//*Label 24909*/ GIMT_Encode4(1839471), // Rule ID 13288 //
     /* 1839390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1839393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1839407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839436 */     // MIs[0] policy
     /* 1839436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839470 */     // GIR_Coverage, 13288,
     /* 1839470 */     GIR_EraseRootFromParent_Done,
     /* 1839471 */   // Label 24909: @1839471
     /* 1839471 */   GIM_Try, /*On fail goto*//*Label 24910*/ GIMT_Encode4(1839557), // Rule ID 13289 //
     /* 1839476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1839479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1839487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1839490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1839493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1839496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839522 */     // MIs[0] policy
     /* 1839522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839532 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1839535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1839553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839556 */     // GIR_Coverage, 13289,
     /* 1839556 */     GIR_EraseRootFromParent_Done,
     /* 1839557 */   // Label 24910: @1839557
     /* 1839557 */   GIM_Try, /*On fail goto*//*Label 24911*/ GIMT_Encode4(1839643), // Rule ID 13292 //
     /* 1839562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1839573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1839576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1839579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1839582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839608 */     // MIs[0] policy
     /* 1839608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1839621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839642 */     // GIR_Coverage, 13292,
     /* 1839642 */     GIR_EraseRootFromParent_Done,
     /* 1839643 */   // Label 24911: @1839643
     /* 1839643 */   GIM_Try, /*On fail goto*//*Label 24912*/ GIMT_Encode4(1839729), // Rule ID 13293 //
     /* 1839648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1839659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1839662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1839665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1839668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839694 */     // MIs[0] policy
     /* 1839694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1839707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839728 */     // GIR_Coverage, 13293,
     /* 1839728 */     GIR_EraseRootFromParent_Done,
     /* 1839729 */   // Label 24912: @1839729
     /* 1839729 */   GIM_Try, /*On fail goto*//*Label 24913*/ GIMT_Encode4(1839815), // Rule ID 13296 //
     /* 1839734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1839745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1839748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1839751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1839754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839780 */     // MIs[0] policy
     /* 1839780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1839793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839814 */     // GIR_Coverage, 13296,
     /* 1839814 */     GIR_EraseRootFromParent_Done,
     /* 1839815 */   // Label 24913: @1839815
     /* 1839815 */   GIM_Try, /*On fail goto*//*Label 24914*/ GIMT_Encode4(1839901), // Rule ID 13297 //
     /* 1839820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1839831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1839834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1839837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1839840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839866 */     // MIs[0] policy
     /* 1839866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1839879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839900 */     // GIR_Coverage, 13297,
     /* 1839900 */     GIR_EraseRootFromParent_Done,
     /* 1839901 */   // Label 24914: @1839901
     /* 1839901 */   GIM_Try, /*On fail goto*//*Label 24915*/ GIMT_Encode4(1839987), // Rule ID 13300 //
     /* 1839906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1839914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1839917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1839920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1839923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1839926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1839929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839952 */     // MIs[0] policy
     /* 1839952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839962 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1839965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839986 */     // GIR_Coverage, 13300,
     /* 1839986 */     GIR_EraseRootFromParent_Done,
     /* 1839987 */   // Label 24915: @1839987
     /* 1839987 */   GIM_Try, /*On fail goto*//*Label 24916*/ GIMT_Encode4(1840073), // Rule ID 13301 //
     /* 1839992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1840003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1840006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1840009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1840012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1840015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840038 */     // MIs[0] policy
     /* 1840038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840048 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1840069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840072 */     // GIR_Coverage, 13301,
     /* 1840072 */     GIR_EraseRootFromParent_Done,
     /* 1840073 */   // Label 24916: @1840073
     /* 1840073 */   GIM_Try, /*On fail goto*//*Label 24917*/ GIMT_Encode4(1840159), // Rule ID 13304 //
     /* 1840078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840124 */     // MIs[0] policy
     /* 1840124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840158 */     // GIR_Coverage, 13304,
     /* 1840158 */     GIR_EraseRootFromParent_Done,
     /* 1840159 */   // Label 24917: @1840159
     /* 1840159 */   GIM_Try, /*On fail goto*//*Label 24918*/ GIMT_Encode4(1840245), // Rule ID 13305 //
     /* 1840164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1840175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1840178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840210 */     // MIs[0] policy
     /* 1840210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840244 */     // GIR_Coverage, 13305,
     /* 1840244 */     GIR_EraseRootFromParent_Done,
     /* 1840245 */   // Label 24918: @1840245
     /* 1840245 */   GIM_Try, /*On fail goto*//*Label 24919*/ GIMT_Encode4(1840331), // Rule ID 13308 //
     /* 1840250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840296 */     // MIs[0] policy
     /* 1840296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840330 */     // GIR_Coverage, 13308,
     /* 1840330 */     GIR_EraseRootFromParent_Done,
     /* 1840331 */   // Label 24919: @1840331
     /* 1840331 */   GIM_Try, /*On fail goto*//*Label 24920*/ GIMT_Encode4(1840417), // Rule ID 13309 //
     /* 1840336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1840347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1840350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840382 */     // MIs[0] policy
     /* 1840382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840416 */     // GIR_Coverage, 13309,
     /* 1840416 */     GIR_EraseRootFromParent_Done,
     /* 1840417 */   // Label 24920: @1840417
     /* 1840417 */   GIM_Try, /*On fail goto*//*Label 24921*/ GIMT_Encode4(1840503), // Rule ID 13312 //
     /* 1840422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1840439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1840442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840468 */     // MIs[0] policy
     /* 1840468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840478 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840502 */     // GIR_Coverage, 13312,
     /* 1840502 */     GIR_EraseRootFromParent_Done,
     /* 1840503 */   // Label 24921: @1840503
     /* 1840503 */   GIM_Try, /*On fail goto*//*Label 24922*/ GIMT_Encode4(1840589), // Rule ID 13313 //
     /* 1840508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1840519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1840522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1840525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1840528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1840531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840554 */     // MIs[0] policy
     /* 1840554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840564 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840588 */     // GIR_Coverage, 13313,
     /* 1840588 */     GIR_EraseRootFromParent_Done,
     /* 1840589 */   // Label 24922: @1840589
     /* 1840589 */   GIM_Try, /*On fail goto*//*Label 24923*/ GIMT_Encode4(1840675), // Rule ID 13316 //
     /* 1840594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1840605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1840608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1840611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1840614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840640 */     // MIs[0] policy
     /* 1840640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840674 */     // GIR_Coverage, 13316,
     /* 1840674 */     GIR_EraseRootFromParent_Done,
     /* 1840675 */   // Label 24923: @1840675
     /* 1840675 */   GIM_Try, /*On fail goto*//*Label 24924*/ GIMT_Encode4(1840761), // Rule ID 13317 //
     /* 1840680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1840691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1840694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1840697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1840700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840726 */     // MIs[0] policy
     /* 1840726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1840739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840760 */     // GIR_Coverage, 13317,
     /* 1840760 */     GIR_EraseRootFromParent_Done,
     /* 1840761 */   // Label 24924: @1840761
     /* 1840761 */   GIM_Try, /*On fail goto*//*Label 24925*/ GIMT_Encode4(1840847), // Rule ID 13320 //
     /* 1840766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1840777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1840780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1840783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1840786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840812 */     // MIs[0] policy
     /* 1840812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840846 */     // GIR_Coverage, 13320,
     /* 1840846 */     GIR_EraseRootFromParent_Done,
     /* 1840847 */   // Label 24925: @1840847
     /* 1840847 */   GIM_Try, /*On fail goto*//*Label 24926*/ GIMT_Encode4(1840933), // Rule ID 13321 //
     /* 1840852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1840863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1840866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1840869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1840872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840898 */     // MIs[0] policy
     /* 1840898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1840911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840932 */     // GIR_Coverage, 13321,
     /* 1840932 */     GIR_EraseRootFromParent_Done,
     /* 1840933 */   // Label 24926: @1840933
     /* 1840933 */   GIM_Try, /*On fail goto*//*Label 24927*/ GIMT_Encode4(1841019), // Rule ID 13324 //
     /* 1840938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1840946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1840949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1840952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1840955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1840958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840984 */     // MIs[0] policy
     /* 1840984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840994 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1840997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841018 */     // GIR_Coverage, 13324,
     /* 1841018 */     GIR_EraseRootFromParent_Done,
     /* 1841019 */   // Label 24927: @1841019
     /* 1841019 */   GIM_Try, /*On fail goto*//*Label 24928*/ GIMT_Encode4(1841105), // Rule ID 13325 //
     /* 1841024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1841035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1841038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1841041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1841044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1841047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841070 */     // MIs[0] policy
     /* 1841070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841080 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841104 */     // GIR_Coverage, 13325,
     /* 1841104 */     GIR_EraseRootFromParent_Done,
     /* 1841105 */   // Label 24928: @1841105
     /* 1841105 */   GIM_Try, /*On fail goto*//*Label 24929*/ GIMT_Encode4(1841191), // Rule ID 13328 //
     /* 1841110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1841127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841156 */     // MIs[0] policy
     /* 1841156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841190 */     // GIR_Coverage, 13328,
     /* 1841190 */     GIR_EraseRootFromParent_Done,
     /* 1841191 */   // Label 24929: @1841191
     /* 1841191 */   GIM_Try, /*On fail goto*//*Label 24930*/ GIMT_Encode4(1841277), // Rule ID 13329 //
     /* 1841196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1841207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1841210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1841213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1841216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841242 */     // MIs[0] policy
     /* 1841242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1841255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841276 */     // GIR_Coverage, 13329,
     /* 1841276 */     GIR_EraseRootFromParent_Done,
     /* 1841277 */   // Label 24930: @1841277
     /* 1841277 */   GIM_Try, /*On fail goto*//*Label 24931*/ GIMT_Encode4(1841363), // Rule ID 13332 //
     /* 1841282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1841299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841328 */     // MIs[0] policy
     /* 1841328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841338 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841362 */     // GIR_Coverage, 13332,
     /* 1841362 */     GIR_EraseRootFromParent_Done,
     /* 1841363 */   // Label 24931: @1841363
     /* 1841363 */   GIM_Try, /*On fail goto*//*Label 24932*/ GIMT_Encode4(1841449), // Rule ID 13333 //
     /* 1841368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1841385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1841388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841414 */     // MIs[0] policy
     /* 1841414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841424 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1841427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841448 */     // GIR_Coverage, 13333,
     /* 1841448 */     GIR_EraseRootFromParent_Done,
     /* 1841449 */   // Label 24932: @1841449
     /* 1841449 */   GIM_Try, /*On fail goto*//*Label 24933*/ GIMT_Encode4(1841535), // Rule ID 13336 //
     /* 1841454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1841457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1841471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1841474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841500 */     // MIs[0] policy
     /* 1841500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841534 */     // GIR_Coverage, 13336,
     /* 1841534 */     GIR_EraseRootFromParent_Done,
     /* 1841535 */   // Label 24933: @1841535
     /* 1841535 */   GIM_Try, /*On fail goto*//*Label 24934*/ GIMT_Encode4(1841621), // Rule ID 13337 //
     /* 1841540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1841543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1841557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1841560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841586 */     // MIs[0] policy
     /* 1841586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1841599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1841617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841620 */     // GIR_Coverage, 13337,
     /* 1841620 */     GIR_EraseRootFromParent_Done,
     /* 1841621 */   // Label 24934: @1841621
     /* 1841621 */   GIM_Try, /*On fail goto*//*Label 24935*/ GIMT_Encode4(1841707), // Rule ID 13340 //
     /* 1841626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1841637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1841640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1841646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841672 */     // MIs[0] policy
     /* 1841672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841682 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1841685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841706 */     // GIR_Coverage, 13340,
     /* 1841706 */     GIR_EraseRootFromParent_Done,
     /* 1841707 */   // Label 24935: @1841707
     /* 1841707 */   GIM_Try, /*On fail goto*//*Label 24936*/ GIMT_Encode4(1841793), // Rule ID 13341 //
     /* 1841712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1841723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1841726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1841732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841758 */     // MIs[0] policy
     /* 1841758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841768 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1841771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841792 */     // GIR_Coverage, 13341,
     /* 1841792 */     GIR_EraseRootFromParent_Done,
     /* 1841793 */   // Label 24936: @1841793
     /* 1841793 */   GIM_Try, /*On fail goto*//*Label 24937*/ GIMT_Encode4(1841879), // Rule ID 13344 //
     /* 1841798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1841809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1841812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1841818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841844 */     // MIs[0] policy
     /* 1841844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841854 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1841857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841878 */     // GIR_Coverage, 13344,
     /* 1841878 */     GIR_EraseRootFromParent_Done,
     /* 1841879 */   // Label 24937: @1841879
     /* 1841879 */   GIM_Try, /*On fail goto*//*Label 24938*/ GIMT_Encode4(1841965), // Rule ID 13345 //
     /* 1841884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1841895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1841898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1841904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841930 */     // MIs[0] policy
     /* 1841930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841940 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1841943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841964 */     // GIR_Coverage, 13345,
     /* 1841964 */     GIR_EraseRootFromParent_Done,
     /* 1841965 */   // Label 24938: @1841965
     /* 1841965 */   GIM_Try, /*On fail goto*//*Label 24939*/ GIMT_Encode4(1842051), // Rule ID 13348 //
     /* 1841970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1841978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1841981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1841984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1841990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842016 */     // MIs[0] policy
     /* 1842016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842050 */     // GIR_Coverage, 13348,
     /* 1842050 */     GIR_EraseRootFromParent_Done,
     /* 1842051 */   // Label 24939: @1842051
     /* 1842051 */   GIM_Try, /*On fail goto*//*Label 24940*/ GIMT_Encode4(1842137), // Rule ID 13349 //
     /* 1842056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1842067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1842070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1842076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842102 */     // MIs[0] policy
     /* 1842102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842112 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842136 */     // GIR_Coverage, 13349,
     /* 1842136 */     GIR_EraseRootFromParent_Done,
     /* 1842137 */   // Label 24940: @1842137
     /* 1842137 */   GIM_Try, /*On fail goto*//*Label 24941*/ GIMT_Encode4(1842223), // Rule ID 13352 //
     /* 1842142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842188 */     // MIs[0] policy
     /* 1842188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842222 */     // GIR_Coverage, 13352,
     /* 1842222 */     GIR_EraseRootFromParent_Done,
     /* 1842223 */   // Label 24941: @1842223
     /* 1842223 */   GIM_Try, /*On fail goto*//*Label 24942*/ GIMT_Encode4(1842309), // Rule ID 13353 //
     /* 1842228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1842239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1842242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842274 */     // MIs[0] policy
     /* 1842274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1842287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842308 */     // GIR_Coverage, 13353,
     /* 1842308 */     GIR_EraseRootFromParent_Done,
     /* 1842309 */   // Label 24942: @1842309
     /* 1842309 */   GIM_Try, /*On fail goto*//*Label 24943*/ GIMT_Encode4(1842395), // Rule ID 13356 //
     /* 1842314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842360 */     // MIs[0] policy
     /* 1842360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842370 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842394 */     // GIR_Coverage, 13356,
     /* 1842394 */     GIR_EraseRootFromParent_Done,
     /* 1842395 */   // Label 24943: @1842395
     /* 1842395 */   GIM_Try, /*On fail goto*//*Label 24944*/ GIMT_Encode4(1842481), // Rule ID 13357 //
     /* 1842400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1842411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1842414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842446 */     // MIs[0] policy
     /* 1842446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842456 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842480 */     // GIR_Coverage, 13357,
     /* 1842480 */     GIR_EraseRootFromParent_Done,
     /* 1842481 */   // Label 24944: @1842481
     /* 1842481 */   GIM_Try, /*On fail goto*//*Label 24945*/ GIMT_Encode4(1842567), // Rule ID 13360 //
     /* 1842486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1842506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842532 */     // MIs[0] policy
     /* 1842532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842542 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842566 */     // GIR_Coverage, 13360,
     /* 1842566 */     GIR_EraseRootFromParent_Done,
     /* 1842567 */   // Label 24945: @1842567
     /* 1842567 */   GIM_Try, /*On fail goto*//*Label 24946*/ GIMT_Encode4(1842653), // Rule ID 13361 //
     /* 1842572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1842592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842618 */     // MIs[0] policy
     /* 1842618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842628 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1842631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1842649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842652 */     // GIR_Coverage, 13361,
     /* 1842652 */     GIR_EraseRootFromParent_Done,
     /* 1842653 */   // Label 24946: @1842653
     /* 1842653 */   GIM_Try, /*On fail goto*//*Label 24947*/ GIMT_Encode4(1842739), // Rule ID 13364 //
     /* 1842658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1842669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1842672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1842678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842704 */     // MIs[0] policy
     /* 1842704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842714 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1842717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842738 */     // GIR_Coverage, 13364,
     /* 1842738 */     GIR_EraseRootFromParent_Done,
     /* 1842739 */   // Label 24947: @1842739
     /* 1842739 */   GIM_Try, /*On fail goto*//*Label 24948*/ GIMT_Encode4(1842825), // Rule ID 13365 //
     /* 1842744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1842755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1842758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1842764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842790 */     // MIs[0] policy
     /* 1842790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842800 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11488:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1842803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842824 */     // GIR_Coverage, 13365,
     /* 1842824 */     GIR_EraseRootFromParent_Done,
     /* 1842825 */   // Label 24948: @1842825
     /* 1842825 */   GIM_Try, /*On fail goto*//*Label 24949*/ GIMT_Encode4(1842911), // Rule ID 13368 //
     /* 1842830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1842841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1842844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1842850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842876 */     // MIs[0] policy
     /* 1842876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1842889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842910 */     // GIR_Coverage, 13368,
     /* 1842910 */     GIR_EraseRootFromParent_Done,
     /* 1842911 */   // Label 24949: @1842911
     /* 1842911 */   GIM_Try, /*On fail goto*//*Label 24950*/ GIMT_Encode4(1842997), // Rule ID 13369 //
     /* 1842916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1842924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1842927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1842930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1842936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842962 */     // MIs[0] policy
     /* 1842962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842972 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11488:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1842975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842996 */     // GIR_Coverage, 13369,
     /* 1842996 */     GIR_EraseRootFromParent_Done,
     /* 1842997 */   // Label 24950: @1842997
     /* 1842997 */   GIM_Try, /*On fail goto*//*Label 24951*/ GIMT_Encode4(1843083), // Rule ID 13372 //
     /* 1843002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843048 */     // MIs[0] policy
     /* 1843048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843082 */     // GIR_Coverage, 13372,
     /* 1843082 */     GIR_EraseRootFromParent_Done,
     /* 1843083 */   // Label 24951: @1843083
     /* 1843083 */   GIM_Try, /*On fail goto*//*Label 24952*/ GIMT_Encode4(1843169), // Rule ID 13373 //
     /* 1843088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1843099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1843102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843134 */     // MIs[0] policy
     /* 1843134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843168 */     // GIR_Coverage, 13373,
     /* 1843168 */     GIR_EraseRootFromParent_Done,
     /* 1843169 */   // Label 24952: @1843169
     /* 1843169 */   GIM_Try, /*On fail goto*//*Label 24953*/ GIMT_Encode4(1843255), // Rule ID 13376 //
     /* 1843174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1843177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843220 */     // MIs[0] policy
     /* 1843220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843254 */     // GIR_Coverage, 13376,
     /* 1843254 */     GIR_EraseRootFromParent_Done,
     /* 1843255 */   // Label 24953: @1843255
     /* 1843255 */   GIM_Try, /*On fail goto*//*Label 24954*/ GIMT_Encode4(1843341), // Rule ID 13377 //
     /* 1843260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1843263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1843280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843306 */     // MIs[0] policy
     /* 1843306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1843319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1843337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843340 */     // GIR_Coverage, 13377,
     /* 1843340 */     GIR_EraseRootFromParent_Done,
     /* 1843341 */   // Label 24954: @1843341
     /* 1843341 */   GIM_Try, /*On fail goto*//*Label 24955*/ GIMT_Encode4(1843427), // Rule ID 13380 //
     /* 1843346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843392 */     // MIs[0] policy
     /* 1843392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843426 */     // GIR_Coverage, 13380,
     /* 1843426 */     GIR_EraseRootFromParent_Done,
     /* 1843427 */   // Label 24955: @1843427
     /* 1843427 */   GIM_Try, /*On fail goto*//*Label 24956*/ GIMT_Encode4(1843513), // Rule ID 13381 //
     /* 1843432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1843443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1843446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1843452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843478 */     // MIs[0] policy
     /* 1843478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843488 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843512 */     // GIR_Coverage, 13381,
     /* 1843512 */     GIR_EraseRootFromParent_Done,
     /* 1843513 */   // Label 24956: @1843513
     /* 1843513 */   GIM_Try, /*On fail goto*//*Label 24957*/ GIMT_Encode4(1843599), // Rule ID 13384 //
     /* 1843518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1843529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1843532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1843538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1843541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843564 */     // MIs[0] policy
     /* 1843564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843574 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1843577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843598 */     // GIR_Coverage, 13384,
     /* 1843598 */     GIR_EraseRootFromParent_Done,
     /* 1843599 */   // Label 24957: @1843599
     /* 1843599 */   GIM_Try, /*On fail goto*//*Label 24958*/ GIMT_Encode4(1843685), // Rule ID 13385 //
     /* 1843604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1843615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1843618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1843624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1843627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843650 */     // MIs[0] policy
     /* 1843650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843660 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1843663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843684 */     // GIR_Coverage, 13385,
     /* 1843684 */     GIR_EraseRootFromParent_Done,
     /* 1843685 */   // Label 24958: @1843685
     /* 1843685 */   GIM_Try, /*On fail goto*//*Label 24959*/ GIMT_Encode4(1843771), // Rule ID 13388 //
     /* 1843690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1843701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1843704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1843710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1843713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843736 */     // MIs[0] policy
     /* 1843736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843746 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1843749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843770 */     // GIR_Coverage, 13388,
     /* 1843770 */     GIR_EraseRootFromParent_Done,
     /* 1843771 */   // Label 24959: @1843771
     /* 1843771 */   GIM_Try, /*On fail goto*//*Label 24960*/ GIMT_Encode4(1843857), // Rule ID 13389 //
     /* 1843776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1843787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1843790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1843796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1843799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843822 */     // MIs[0] policy
     /* 1843822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843832 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1843835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1843853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843856 */     // GIR_Coverage, 13389,
     /* 1843856 */     GIR_EraseRootFromParent_Done,
     /* 1843857 */   // Label 24960: @1843857
     /* 1843857 */   GIM_Try, /*On fail goto*//*Label 24961*/ GIMT_Encode4(1843943), // Rule ID 13392 //
     /* 1843862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1843873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1843876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1843882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843908 */     // MIs[0] policy
     /* 1843908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1843921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843942 */     // GIR_Coverage, 13392,
     /* 1843942 */     GIR_EraseRootFromParent_Done,
     /* 1843943 */   // Label 24961: @1843943
     /* 1843943 */   GIM_Try, /*On fail goto*//*Label 24962*/ GIMT_Encode4(1844029), // Rule ID 13393 //
     /* 1843948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1843956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1843959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1843962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1843968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843994 */     // MIs[0] policy
     /* 1843994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844004 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844028 */     // GIR_Coverage, 13393,
     /* 1844028 */     GIR_EraseRootFromParent_Done,
     /* 1844029 */   // Label 24962: @1844029
     /* 1844029 */   GIM_Try, /*On fail goto*//*Label 24963*/ GIMT_Encode4(1844115), // Rule ID 13396 //
     /* 1844034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844080 */     // MIs[0] policy
     /* 1844080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844090 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844114 */     // GIR_Coverage, 13396,
     /* 1844114 */     GIR_EraseRootFromParent_Done,
     /* 1844115 */   // Label 24963: @1844115
     /* 1844115 */   GIM_Try, /*On fail goto*//*Label 24964*/ GIMT_Encode4(1844201), // Rule ID 13397 //
     /* 1844120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1844140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844166 */     // MIs[0] policy
     /* 1844166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844176 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844200 */     // GIR_Coverage, 13397,
     /* 1844200 */     GIR_EraseRootFromParent_Done,
     /* 1844201 */   // Label 24964: @1844201
     /* 1844201 */   GIM_Try, /*On fail goto*//*Label 24965*/ GIMT_Encode4(1844287), // Rule ID 13400 //
     /* 1844206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844252 */     // MIs[0] policy
     /* 1844252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844286 */     // GIR_Coverage, 13400,
     /* 1844286 */     GIR_EraseRootFromParent_Done,
     /* 1844287 */   // Label 24965: @1844287
     /* 1844287 */   GIM_Try, /*On fail goto*//*Label 24966*/ GIMT_Encode4(1844373), // Rule ID 13401 //
     /* 1844292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1844312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844338 */     // MIs[0] policy
     /* 1844338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844348 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1844369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844372 */     // GIR_Coverage, 13401,
     /* 1844372 */     GIR_EraseRootFromParent_Done,
     /* 1844373 */   // Label 24966: @1844373
     /* 1844373 */   GIM_Try, /*On fail goto*//*Label 24967*/ GIMT_Encode4(1844459), // Rule ID 13404 //
     /* 1844378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844424 */     // MIs[0] policy
     /* 1844424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844458 */     // GIR_Coverage, 13404,
     /* 1844458 */     GIR_EraseRootFromParent_Done,
     /* 1844459 */   // Label 24967: @1844459
     /* 1844459 */   GIM_Try, /*On fail goto*//*Label 24968*/ GIMT_Encode4(1844545), // Rule ID 13405 //
     /* 1844464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1844475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1844478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1844484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844510 */     // MIs[0] policy
     /* 1844510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844544 */     // GIR_Coverage, 13405,
     /* 1844544 */     GIR_EraseRootFromParent_Done,
     /* 1844545 */   // Label 24968: @1844545
     /* 1844545 */   GIM_Try, /*On fail goto*//*Label 24969*/ GIMT_Encode4(1844631), // Rule ID 13408 //
     /* 1844550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1844570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844596 */     // MIs[0] policy
     /* 1844596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844630 */     // GIR_Coverage, 13408,
     /* 1844630 */     GIR_EraseRootFromParent_Done,
     /* 1844631 */   // Label 24969: @1844631
     /* 1844631 */   GIM_Try, /*On fail goto*//*Label 24970*/ GIMT_Encode4(1844717), // Rule ID 13409 //
     /* 1844636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1844647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1844650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1844656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844682 */     // MIs[0] policy
     /* 1844682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844692 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1844695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844716 */     // GIR_Coverage, 13409,
     /* 1844716 */     GIR_EraseRootFromParent_Done,
     /* 1844717 */   // Label 24970: @1844717
     /* 1844717 */   GIM_Try, /*On fail goto*//*Label 24971*/ GIMT_Encode4(1844803), // Rule ID 13412 //
     /* 1844722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1844742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844768 */     // MIs[0] policy
     /* 1844768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844802 */     // GIR_Coverage, 13412,
     /* 1844802 */     GIR_EraseRootFromParent_Done,
     /* 1844803 */   // Label 24971: @1844803
     /* 1844803 */   GIM_Try, /*On fail goto*//*Label 24972*/ GIMT_Encode4(1844889), // Rule ID 13413 //
     /* 1844808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1844819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1844822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1844828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844854 */     // MIs[0] policy
     /* 1844854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1844867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1844885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844888 */     // GIR_Coverage, 13413,
     /* 1844888 */     GIR_EraseRootFromParent_Done,
     /* 1844889 */   // Label 24972: @1844889
     /* 1844889 */   GIM_Try, /*On fail goto*//*Label 24973*/ GIMT_Encode4(1844975), // Rule ID 13416 //
     /* 1844894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1844897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1844905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1844908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1844911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1844914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1844917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1844932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844940 */     // MIs[0] policy
     /* 1844940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1844953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1844971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844974 */     // GIR_Coverage, 13416,
     /* 1844974 */     GIR_EraseRootFromParent_Done,
     /* 1844975 */   // Label 24973: @1844975
     /* 1844975 */   GIM_Try, /*On fail goto*//*Label 24974*/ GIMT_Encode4(1845061), // Rule ID 13417 //
     /* 1844980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1844983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1844988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1844991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1844994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1844997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1845000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845026 */     // MIs[0] policy
     /* 1845026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845036 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1845039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845060 */     // GIR_Coverage, 13417,
     /* 1845060 */     GIR_EraseRootFromParent_Done,
     /* 1845061 */   // Label 24974: @1845061
     /* 1845061 */   GIM_Try, /*On fail goto*//*Label 24975*/ GIMT_Encode4(1845147), // Rule ID 13420 //
     /* 1845066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845112 */     // MIs[0] policy
     /* 1845112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845122 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845146 */     // GIR_Coverage, 13420,
     /* 1845146 */     GIR_EraseRootFromParent_Done,
     /* 1845147 */   // Label 24975: @1845147
     /* 1845147 */   GIM_Try, /*On fail goto*//*Label 24976*/ GIMT_Encode4(1845233), // Rule ID 13421 //
     /* 1845152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1845163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1845166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1845172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845198 */     // MIs[0] policy
     /* 1845198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845208 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1845211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845232 */     // GIR_Coverage, 13421,
     /* 1845232 */     GIR_EraseRootFromParent_Done,
     /* 1845233 */   // Label 24976: @1845233
     /* 1845233 */   GIM_Try, /*On fail goto*//*Label 24977*/ GIMT_Encode4(1845319), // Rule ID 13424 //
     /* 1845238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1845241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1845255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845284 */     // MIs[0] policy
     /* 1845284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845318 */     // GIR_Coverage, 13424,
     /* 1845318 */     GIR_EraseRootFromParent_Done,
     /* 1845319 */   // Label 24977: @1845319
     /* 1845319 */   GIM_Try, /*On fail goto*//*Label 24978*/ GIMT_Encode4(1845405), // Rule ID 13425 //
     /* 1845324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1845327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1845332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1845335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1845338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1845341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1845344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1845362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845370 */     // MIs[0] policy
     /* 1845370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845380 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1845383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1845401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845404 */     // GIR_Coverage, 13425,
     /* 1845404 */     GIR_EraseRootFromParent_Done,
     /* 1845405 */   // Label 24978: @1845405
     /* 1845405 */   GIM_Try, /*On fail goto*//*Label 24979*/ GIMT_Encode4(1845491), // Rule ID 13428 //
     /* 1845410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845456 */     // MIs[0] policy
     /* 1845456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845466 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1845469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845490 */     // GIR_Coverage, 13428,
     /* 1845490 */     GIR_EraseRootFromParent_Done,
     /* 1845491 */   // Label 24979: @1845491
     /* 1845491 */   GIM_Try, /*On fail goto*//*Label 24980*/ GIMT_Encode4(1845577), // Rule ID 13429 //
     /* 1845496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1845507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1845510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1845513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1845516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845542 */     // MIs[0] policy
     /* 1845542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1845555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845576 */     // GIR_Coverage, 13429,
     /* 1845576 */     GIR_EraseRootFromParent_Done,
     /* 1845577 */   // Label 24980: @1845577
     /* 1845577 */   GIM_Try, /*On fail goto*//*Label 24981*/ GIMT_Encode4(1845663), // Rule ID 13432 //
     /* 1845582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1845593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1845596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1845599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1845602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845628 */     // MIs[0] policy
     /* 1845628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1845641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845662 */     // GIR_Coverage, 13432,
     /* 1845662 */     GIR_EraseRootFromParent_Done,
     /* 1845663 */   // Label 24981: @1845663
     /* 1845663 */   GIM_Try, /*On fail goto*//*Label 24982*/ GIMT_Encode4(1845749), // Rule ID 13433 //
     /* 1845668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1845679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1845682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1845685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1845688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845714 */     // MIs[0] policy
     /* 1845714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845724 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1845727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845748 */     // GIR_Coverage, 13433,
     /* 1845748 */     GIR_EraseRootFromParent_Done,
     /* 1845749 */   // Label 24982: @1845749
     /* 1845749 */   GIM_Try, /*On fail goto*//*Label 24983*/ GIMT_Encode4(1845835), // Rule ID 13436 //
     /* 1845754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1845765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1845768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1845771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1845774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845800 */     // MIs[0] policy
     /* 1845800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845810 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1845813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845834 */     // GIR_Coverage, 13436,
     /* 1845834 */     GIR_EraseRootFromParent_Done,
     /* 1845835 */   // Label 24983: @1845835
     /* 1845835 */   GIM_Try, /*On fail goto*//*Label 24984*/ GIMT_Encode4(1845921), // Rule ID 13437 //
     /* 1845840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1845851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1845854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1845857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1845860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845886 */     // MIs[0] policy
     /* 1845886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1845899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845920 */     // GIR_Coverage, 13437,
     /* 1845920 */     GIR_EraseRootFromParent_Done,
     /* 1845921 */   // Label 24984: @1845921
     /* 1845921 */   GIM_Try, /*On fail goto*//*Label 24985*/ GIMT_Encode4(1846007), // Rule ID 13440 //
     /* 1845926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1845934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1845937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1845940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1845943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1845946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845972 */     // MIs[0] policy
     /* 1845972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1845985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846006 */     // GIR_Coverage, 13440,
     /* 1846006 */     GIR_EraseRootFromParent_Done,
     /* 1846007 */   // Label 24985: @1846007
     /* 1846007 */   GIM_Try, /*On fail goto*//*Label 24986*/ GIMT_Encode4(1846093), // Rule ID 13441 //
     /* 1846012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1846023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1846026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1846029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1846032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846058 */     // MIs[0] policy
     /* 1846058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846068 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846092 */     // GIR_Coverage, 13441,
     /* 1846092 */     GIR_EraseRootFromParent_Done,
     /* 1846093 */   // Label 24986: @1846093
     /* 1846093 */   GIM_Try, /*On fail goto*//*Label 24987*/ GIMT_Encode4(1846179), // Rule ID 13444 //
     /* 1846098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1846115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846144 */     // MIs[0] policy
     /* 1846144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846154 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1846157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846178 */     // GIR_Coverage, 13444,
     /* 1846178 */     GIR_EraseRootFromParent_Done,
     /* 1846179 */   // Label 24987: @1846179
     /* 1846179 */   GIM_Try, /*On fail goto*//*Label 24988*/ GIMT_Encode4(1846265), // Rule ID 13445 //
     /* 1846184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1846195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1846198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1846201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1846204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1846207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846230 */     // MIs[0] policy
     /* 1846230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1846243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846264 */     // GIR_Coverage, 13445,
     /* 1846264 */     GIR_EraseRootFromParent_Done,
     /* 1846265 */   // Label 24988: @1846265
     /* 1846265 */   GIM_Try, /*On fail goto*//*Label 24989*/ GIMT_Encode4(1846351), // Rule ID 13448 //
     /* 1846270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1846287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846316 */     // MIs[0] policy
     /* 1846316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846326 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1846329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846350 */     // GIR_Coverage, 13448,
     /* 1846350 */     GIR_EraseRootFromParent_Done,
     /* 1846351 */   // Label 24989: @1846351
     /* 1846351 */   GIM_Try, /*On fail goto*//*Label 24990*/ GIMT_Encode4(1846437), // Rule ID 13449 //
     /* 1846356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1846367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1846370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1846373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1846376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1846379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846402 */     // MIs[0] policy
     /* 1846402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846412 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1846415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846436 */     // GIR_Coverage, 13449,
     /* 1846436 */     GIR_EraseRootFromParent_Done,
     /* 1846437 */   // Label 24990: @1846437
     /* 1846437 */   GIM_Try, /*On fail goto*//*Label 24991*/ GIMT_Encode4(1846523), // Rule ID 13452 //
     /* 1846442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1846459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846488 */     // MIs[0] policy
     /* 1846488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846522 */     // GIR_Coverage, 13452,
     /* 1846522 */     GIR_EraseRootFromParent_Done,
     /* 1846523 */   // Label 24991: @1846523
     /* 1846523 */   GIM_Try, /*On fail goto*//*Label 24992*/ GIMT_Encode4(1846609), // Rule ID 13453 //
     /* 1846528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1846539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1846542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1846545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1846548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846574 */     // MIs[0] policy
     /* 1846574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846584 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1846587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846608 */     // GIR_Coverage, 13453,
     /* 1846608 */     GIR_EraseRootFromParent_Done,
     /* 1846609 */   // Label 24992: @1846609
     /* 1846609 */   GIM_Try, /*On fail goto*//*Label 24993*/ GIMT_Encode4(1846695), // Rule ID 13456 //
     /* 1846614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1846625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1846628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1846631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1846634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846660 */     // MIs[0] policy
     /* 1846660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1846673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846694 */     // GIR_Coverage, 13456,
     /* 1846694 */     GIR_EraseRootFromParent_Done,
     /* 1846695 */   // Label 24993: @1846695
     /* 1846695 */   GIM_Try, /*On fail goto*//*Label 24994*/ GIMT_Encode4(1846781), // Rule ID 13457 //
     /* 1846700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1846711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1846714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1846717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1846720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846746 */     // MIs[0] policy
     /* 1846746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1846759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846780 */     // GIR_Coverage, 13457,
     /* 1846780 */     GIR_EraseRootFromParent_Done,
     /* 1846781 */   // Label 24994: @1846781
     /* 1846781 */   GIM_Try, /*On fail goto*//*Label 24995*/ GIMT_Encode4(1846867), // Rule ID 13460 //
     /* 1846786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1846797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1846800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1846803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1846806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846832 */     // MIs[0] policy
     /* 1846832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846842 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846866 */     // GIR_Coverage, 13460,
     /* 1846866 */     GIR_EraseRootFromParent_Done,
     /* 1846867 */   // Label 24995: @1846867
     /* 1846867 */   GIM_Try, /*On fail goto*//*Label 24996*/ GIMT_Encode4(1846953), // Rule ID 13461 //
     /* 1846872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1846883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1846886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1846889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1846892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846918 */     // MIs[0] policy
     /* 1846918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1846931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1846949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846952 */     // GIR_Coverage, 13461,
     /* 1846952 */     GIR_EraseRootFromParent_Done,
     /* 1846953 */   // Label 24996: @1846953
     /* 1846953 */   GIM_Try, /*On fail goto*//*Label 24997*/ GIMT_Encode4(1847039), // Rule ID 13464 //
     /* 1846958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1846966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1846969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1846972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1846975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1846978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847004 */     // MIs[0] policy
     /* 1847004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847014 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847038 */     // GIR_Coverage, 13464,
     /* 1847038 */     GIR_EraseRootFromParent_Done,
     /* 1847039 */   // Label 24997: @1847039
     /* 1847039 */   GIM_Try, /*On fail goto*//*Label 24998*/ GIMT_Encode4(1847125), // Rule ID 13465 //
     /* 1847044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1847055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1847058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1847061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1847064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847090 */     // MIs[0] policy
     /* 1847090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847124 */     // GIR_Coverage, 13465,
     /* 1847124 */     GIR_EraseRootFromParent_Done,
     /* 1847125 */   // Label 24998: @1847125
     /* 1847125 */   GIM_Try, /*On fail goto*//*Label 24999*/ GIMT_Encode4(1847211), // Rule ID 13468 //
     /* 1847130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1847147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847176 */     // MIs[0] policy
     /* 1847176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847186 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847210 */     // GIR_Coverage, 13468,
     /* 1847210 */     GIR_EraseRootFromParent_Done,
     /* 1847211 */   // Label 24999: @1847211
     /* 1847211 */   GIM_Try, /*On fail goto*//*Label 25000*/ GIMT_Encode4(1847297), // Rule ID 13469 //
     /* 1847216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1847227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1847230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1847233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1847236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847262 */     // MIs[0] policy
     /* 1847262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847296 */     // GIR_Coverage, 13469,
     /* 1847296 */     GIR_EraseRootFromParent_Done,
     /* 1847297 */   // Label 25000: @1847297
     /* 1847297 */   GIM_Try, /*On fail goto*//*Label 25001*/ GIMT_Encode4(1847383), // Rule ID 13472 //
     /* 1847302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1847319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847348 */     // MIs[0] policy
     /* 1847348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847358 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847382 */     // GIR_Coverage, 13472,
     /* 1847382 */     GIR_EraseRootFromParent_Done,
     /* 1847383 */   // Label 25001: @1847383
     /* 1847383 */   GIM_Try, /*On fail goto*//*Label 25002*/ GIMT_Encode4(1847469), // Rule ID 13473 //
     /* 1847388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1847399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1847402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1847405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1847408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847434 */     // MIs[0] policy
     /* 1847434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1847447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847468 */     // GIR_Coverage, 13473,
     /* 1847468 */     GIR_EraseRootFromParent_Done,
     /* 1847469 */   // Label 25002: @1847469
     /* 1847469 */   GIM_Try, /*On fail goto*//*Label 25003*/ GIMT_Encode4(1847555), // Rule ID 13476 //
     /* 1847474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1847485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1847488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1847491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1847494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847520 */     // MIs[0] policy
     /* 1847520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1847533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847554 */     // GIR_Coverage, 13476,
     /* 1847554 */     GIR_EraseRootFromParent_Done,
     /* 1847555 */   // Label 25003: @1847555
     /* 1847555 */   GIM_Try, /*On fail goto*//*Label 25004*/ GIMT_Encode4(1847641), // Rule ID 13477 //
     /* 1847560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1847571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1847574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1847577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1847580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847606 */     // MIs[0] policy
     /* 1847606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1847619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847640 */     // GIR_Coverage, 13477,
     /* 1847640 */     GIR_EraseRootFromParent_Done,
     /* 1847641 */   // Label 25004: @1847641
     /* 1847641 */   GIM_Try, /*On fail goto*//*Label 25005*/ GIMT_Encode4(1847727), // Rule ID 13480 //
     /* 1847646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1847657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1847660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1847663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1847666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847692 */     // MIs[0] policy
     /* 1847692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847726 */     // GIR_Coverage, 13480,
     /* 1847726 */     GIR_EraseRootFromParent_Done,
     /* 1847727 */   // Label 25005: @1847727
     /* 1847727 */   GIM_Try, /*On fail goto*//*Label 25006*/ GIMT_Encode4(1847813), // Rule ID 13481 //
     /* 1847732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1847743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1847746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1847749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1847752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847778 */     // MIs[0] policy
     /* 1847778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1847791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847812 */     // GIR_Coverage, 13481,
     /* 1847812 */     GIR_EraseRootFromParent_Done,
     /* 1847813 */   // Label 25006: @1847813
     /* 1847813 */   GIM_Try, /*On fail goto*//*Label 25007*/ GIMT_Encode4(1847899), // Rule ID 13484 //
     /* 1847818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1847821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1847829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1847832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1847835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1847838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847864 */     // MIs[0] policy
     /* 1847864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847898 */     // GIR_Coverage, 13484,
     /* 1847898 */     GIR_EraseRootFromParent_Done,
     /* 1847899 */   // Label 25007: @1847899
     /* 1847899 */   GIM_Try, /*On fail goto*//*Label 25008*/ GIMT_Encode4(1847985), // Rule ID 13485 //
     /* 1847904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1847907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1847915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1847918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1847921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1847924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847950 */     // MIs[0] policy
     /* 1847950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1847963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1847981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847984 */     // GIR_Coverage, 13485,
     /* 1847984 */     GIR_EraseRootFromParent_Done,
     /* 1847985 */   // Label 25008: @1847985
     /* 1847985 */   GIM_Try, /*On fail goto*//*Label 25009*/ GIMT_Encode4(1848071), // Rule ID 13488 //
     /* 1847990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1847998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848036 */     // MIs[0] policy
     /* 1848036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848046 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1848049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848070 */     // GIR_Coverage, 13488,
     /* 1848070 */     GIR_EraseRootFromParent_Done,
     /* 1848071 */   // Label 25009: @1848071
     /* 1848071 */   GIM_Try, /*On fail goto*//*Label 25010*/ GIMT_Encode4(1848157), // Rule ID 13489 //
     /* 1848076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1848087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1848090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1848096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848122 */     // MIs[0] policy
     /* 1848122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848132 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1848135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848156 */     // GIR_Coverage, 13489,
     /* 1848156 */     GIR_EraseRootFromParent_Done,
     /* 1848157 */   // Label 25010: @1848157
     /* 1848157 */   GIM_Try, /*On fail goto*//*Label 25011*/ GIMT_Encode4(1848243), // Rule ID 13492 //
     /* 1848162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848208 */     // MIs[0] policy
     /* 1848208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848218 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1848221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848242 */     // GIR_Coverage, 13492,
     /* 1848242 */     GIR_EraseRootFromParent_Done,
     /* 1848243 */   // Label 25011: @1848243
     /* 1848243 */   GIM_Try, /*On fail goto*//*Label 25012*/ GIMT_Encode4(1848329), // Rule ID 13493 //
     /* 1848248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1848259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1848262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1848268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848294 */     // MIs[0] policy
     /* 1848294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848304 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1848307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848328 */     // GIR_Coverage, 13493,
     /* 1848328 */     GIR_EraseRootFromParent_Done,
     /* 1848329 */   // Label 25012: @1848329
     /* 1848329 */   GIM_Try, /*On fail goto*//*Label 25013*/ GIMT_Encode4(1848415), // Rule ID 13496 //
     /* 1848334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848380 */     // MIs[0] policy
     /* 1848380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1848393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848414 */     // GIR_Coverage, 13496,
     /* 1848414 */     GIR_EraseRootFromParent_Done,
     /* 1848415 */   // Label 25013: @1848415
     /* 1848415 */   GIM_Try, /*On fail goto*//*Label 25014*/ GIMT_Encode4(1848501), // Rule ID 13497 //
     /* 1848420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1848431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1848434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1848440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848466 */     // MIs[0] policy
     /* 1848466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11652:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1848479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848500 */     // GIR_Coverage, 13497,
     /* 1848500 */     GIR_EraseRootFromParent_Done,
     /* 1848501 */   // Label 25014: @1848501
     /* 1848501 */   GIM_Try, /*On fail goto*//*Label 25015*/ GIMT_Encode4(1848587), // Rule ID 13500 //
     /* 1848506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1848517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1848520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1848526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848552 */     // MIs[0] policy
     /* 1848552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848562 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1848565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848586 */     // GIR_Coverage, 13500,
     /* 1848586 */     GIR_EraseRootFromParent_Done,
     /* 1848587 */   // Label 25015: @1848587
     /* 1848587 */   GIM_Try, /*On fail goto*//*Label 25016*/ GIMT_Encode4(1848673), // Rule ID 13501 //
     /* 1848592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1848603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1848606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1848612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848638 */     // MIs[0] policy
     /* 1848638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1848651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848672 */     // GIR_Coverage, 13501,
     /* 1848672 */     GIR_EraseRootFromParent_Done,
     /* 1848673 */   // Label 25016: @1848673
     /* 1848673 */   GIM_Try, /*On fail goto*//*Label 25017*/ GIMT_Encode4(1848759), // Rule ID 13504 //
     /* 1848678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1848689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1848692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1848698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848724 */     // MIs[0] policy
     /* 1848724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1848737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848758 */     // GIR_Coverage, 13504,
     /* 1848758 */     GIR_EraseRootFromParent_Done,
     /* 1848759 */   // Label 25017: @1848759
     /* 1848759 */   GIM_Try, /*On fail goto*//*Label 25018*/ GIMT_Encode4(1848845), // Rule ID 13505 //
     /* 1848764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1848775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1848778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1848784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848810 */     // MIs[0] policy
     /* 1848810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848820 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1848823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848844 */     // GIR_Coverage, 13505,
     /* 1848844 */     GIR_EraseRootFromParent_Done,
     /* 1848845 */   // Label 25018: @1848845
     /* 1848845 */   GIM_Try, /*On fail goto*//*Label 25019*/ GIMT_Encode4(1848931), // Rule ID 13508 //
     /* 1848850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1848861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1848864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1848870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1848873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848896 */     // MIs[0] policy
     /* 1848896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848906 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1848909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1848927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848930 */     // GIR_Coverage, 13508,
     /* 1848930 */     GIR_EraseRootFromParent_Done,
     /* 1848931 */   // Label 25019: @1848931
     /* 1848931 */   GIM_Try, /*On fail goto*//*Label 25020*/ GIMT_Encode4(1849017), // Rule ID 13509 //
     /* 1848936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1848944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1848947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1848950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1848956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1848959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848982 */     // MIs[0] policy
     /* 1848982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848992 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1848995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849016 */     // GIR_Coverage, 13509,
     /* 1849016 */     GIR_EraseRootFromParent_Done,
     /* 1849017 */   // Label 25020: @1849017
     /* 1849017 */   GIM_Try, /*On fail goto*//*Label 25021*/ GIMT_Encode4(1849103), // Rule ID 13512 //
     /* 1849022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849068 */     // MIs[0] policy
     /* 1849068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849078 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1849081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849102 */     // GIR_Coverage, 13512,
     /* 1849102 */     GIR_EraseRootFromParent_Done,
     /* 1849103 */   // Label 25021: @1849103
     /* 1849103 */   GIM_Try, /*On fail goto*//*Label 25022*/ GIMT_Encode4(1849189), // Rule ID 13513 //
     /* 1849108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1849119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1849122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1849128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849154 */     // MIs[0] policy
     /* 1849154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849164 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1849167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849188 */     // GIR_Coverage, 13513,
     /* 1849188 */     GIR_EraseRootFromParent_Done,
     /* 1849189 */   // Label 25022: @1849189
     /* 1849189 */   GIM_Try, /*On fail goto*//*Label 25023*/ GIMT_Encode4(1849275), // Rule ID 13516 //
     /* 1849194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849240 */     // MIs[0] policy
     /* 1849240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849274 */     // GIR_Coverage, 13516,
     /* 1849274 */     GIR_EraseRootFromParent_Done,
     /* 1849275 */   // Label 25023: @1849275
     /* 1849275 */   GIM_Try, /*On fail goto*//*Label 25024*/ GIMT_Encode4(1849361), // Rule ID 13517 //
     /* 1849280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1849291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1849294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1849300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849326 */     // MIs[0] policy
     /* 1849326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11652:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849360 */     // GIR_Coverage, 13517,
     /* 1849360 */     GIR_EraseRootFromParent_Done,
     /* 1849361 */   // Label 25024: @1849361
     /* 1849361 */   GIM_Try, /*On fail goto*//*Label 25025*/ GIMT_Encode4(1849447), // Rule ID 13520 //
     /* 1849366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849412 */     // MIs[0] policy
     /* 1849412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849446 */     // GIR_Coverage, 13520,
     /* 1849446 */     GIR_EraseRootFromParent_Done,
     /* 1849447 */   // Label 25025: @1849447
     /* 1849447 */   GIM_Try, /*On fail goto*//*Label 25026*/ GIMT_Encode4(1849533), // Rule ID 13521 //
     /* 1849452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1849463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1849466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1849472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849498 */     // MIs[0] policy
     /* 1849498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1849511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849532 */     // GIR_Coverage, 13521,
     /* 1849532 */     GIR_EraseRootFromParent_Done,
     /* 1849533 */   // Label 25026: @1849533
     /* 1849533 */   GIM_Try, /*On fail goto*//*Label 25027*/ GIMT_Encode4(1849619), // Rule ID 13524 //
     /* 1849538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1849549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1849552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1849558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849584 */     // MIs[0] policy
     /* 1849584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1849597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849618 */     // GIR_Coverage, 13524,
     /* 1849618 */     GIR_EraseRootFromParent_Done,
     /* 1849619 */   // Label 25027: @1849619
     /* 1849619 */   GIM_Try, /*On fail goto*//*Label 25028*/ GIMT_Encode4(1849705), // Rule ID 13525 //
     /* 1849624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1849635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1849638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1849644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849670 */     // MIs[0] policy
     /* 1849670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849680 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1849683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849704 */     // GIR_Coverage, 13525,
     /* 1849704 */     GIR_EraseRootFromParent_Done,
     /* 1849705 */   // Label 25028: @1849705
     /* 1849705 */   GIM_Try, /*On fail goto*//*Label 25029*/ GIMT_Encode4(1849791), // Rule ID 13528 //
     /* 1849710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1849721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1849724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1849730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849756 */     // MIs[0] policy
     /* 1849756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1849769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849790 */     // GIR_Coverage, 13528,
     /* 1849790 */     GIR_EraseRootFromParent_Done,
     /* 1849791 */   // Label 25029: @1849791
     /* 1849791 */   GIM_Try, /*On fail goto*//*Label 25030*/ GIMT_Encode4(1849877), // Rule ID 13529 //
     /* 1849796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1849807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1849810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1849816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849842 */     // MIs[0] policy
     /* 1849842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1849855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1849873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849876 */     // GIR_Coverage, 13529,
     /* 1849876 */     GIR_EraseRootFromParent_Done,
     /* 1849877 */   // Label 25030: @1849877
     /* 1849877 */   GIM_Try, /*On fail goto*//*Label 25031*/ GIMT_Encode4(1849963), // Rule ID 13532 //
     /* 1849882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1849885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1849893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1849896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1849899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1849902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849928 */     // MIs[0] policy
     /* 1849928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849938 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1849941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1849959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849962 */     // GIR_Coverage, 13532,
     /* 1849962 */     GIR_EraseRootFromParent_Done,
     /* 1849963 */   // Label 25031: @1849963
     /* 1849963 */   GIM_Try, /*On fail goto*//*Label 25032*/ GIMT_Encode4(1850049), // Rule ID 13533 //
     /* 1849968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1849971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1849976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1849979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1849982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1849988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850014 */     // MIs[0] policy
     /* 1850014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11652:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1850027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850048 */     // GIR_Coverage, 13533,
     /* 1850048 */     GIR_EraseRootFromParent_Done,
     /* 1850049 */   // Label 25032: @1850049
     /* 1850049 */   GIM_Try, /*On fail goto*//*Label 25033*/ GIMT_Encode4(1850135), // Rule ID 13536 //
     /* 1850054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850100 */     // MIs[0] policy
     /* 1850100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1850113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850134 */     // GIR_Coverage, 13536,
     /* 1850134 */     GIR_EraseRootFromParent_Done,
     /* 1850135 */   // Label 25033: @1850135
     /* 1850135 */   GIM_Try, /*On fail goto*//*Label 25034*/ GIMT_Encode4(1850221), // Rule ID 13537 //
     /* 1850140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1850151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1850154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1850160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850186 */     // MIs[0] policy
     /* 1850186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11652:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1850199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850220 */     // GIR_Coverage, 13537,
     /* 1850220 */     GIR_EraseRootFromParent_Done,
     /* 1850221 */   // Label 25034: @1850221
     /* 1850221 */   GIM_Try, /*On fail goto*//*Label 25035*/ GIMT_Encode4(1850307), // Rule ID 13540 //
     /* 1850226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850272 */     // MIs[0] policy
     /* 1850272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850306 */     // GIR_Coverage, 13540,
     /* 1850306 */     GIR_EraseRootFromParent_Done,
     /* 1850307 */   // Label 25035: @1850307
     /* 1850307 */   GIM_Try, /*On fail goto*//*Label 25036*/ GIMT_Encode4(1850393), // Rule ID 13541 //
     /* 1850312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1850323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1850326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1850332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850358 */     // MIs[0] policy
     /* 1850358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11652:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1850371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850392 */     // GIR_Coverage, 13541,
     /* 1850392 */     GIR_EraseRootFromParent_Done,
     /* 1850393 */   // Label 25036: @1850393
     /* 1850393 */   GIM_Try, /*On fail goto*//*Label 25037*/ GIMT_Encode4(1850479), // Rule ID 13544 //
     /* 1850398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1850401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1850415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850444 */     // MIs[0] policy
     /* 1850444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850478 */     // GIR_Coverage, 13544,
     /* 1850478 */     GIR_EraseRootFromParent_Done,
     /* 1850479 */   // Label 25037: @1850479
     /* 1850479 */   GIM_Try, /*On fail goto*//*Label 25038*/ GIMT_Encode4(1850565), // Rule ID 13545 //
     /* 1850484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1850487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1850492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1850495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1850498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1850501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1850504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1850522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850530 */     // MIs[0] policy
     /* 1850530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11652:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1850543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1850561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850564 */     // GIR_Coverage, 13545,
     /* 1850564 */     GIR_EraseRootFromParent_Done,
     /* 1850565 */   // Label 25038: @1850565
     /* 1850565 */   GIM_Try, /*On fail goto*//*Label 25039*/ GIMT_Encode4(1850651), // Rule ID 13548 //
     /* 1850570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1850581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1850584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1850587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1850590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850616 */     // MIs[0] policy
     /* 1850616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1850629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850650 */     // GIR_Coverage, 13548,
     /* 1850650 */     GIR_EraseRootFromParent_Done,
     /* 1850651 */   // Label 25039: @1850651
     /* 1850651 */   GIM_Try, /*On fail goto*//*Label 25040*/ GIMT_Encode4(1850737), // Rule ID 13549 //
     /* 1850656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1850667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1850670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1850673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1850676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850702 */     // MIs[0] policy
     /* 1850702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1850715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850736 */     // GIR_Coverage, 13549,
     /* 1850736 */     GIR_EraseRootFromParent_Done,
     /* 1850737 */   // Label 25040: @1850737
     /* 1850737 */   GIM_Try, /*On fail goto*//*Label 25041*/ GIMT_Encode4(1850823), // Rule ID 13552 //
     /* 1850742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1850753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1850756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1850759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1850762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850788 */     // MIs[0] policy
     /* 1850788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1850801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850822 */     // GIR_Coverage, 13552,
     /* 1850822 */     GIR_EraseRootFromParent_Done,
     /* 1850823 */   // Label 25041: @1850823
     /* 1850823 */   GIM_Try, /*On fail goto*//*Label 25042*/ GIMT_Encode4(1850909), // Rule ID 13553 //
     /* 1850828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1850839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1850842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1850845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1850848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850874 */     // MIs[0] policy
     /* 1850874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1850887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850908 */     // GIR_Coverage, 13553,
     /* 1850908 */     GIR_EraseRootFromParent_Done,
     /* 1850909 */   // Label 25042: @1850909
     /* 1850909 */   GIM_Try, /*On fail goto*//*Label 25043*/ GIMT_Encode4(1850995), // Rule ID 13556 //
     /* 1850914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1850922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1850925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1850928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1850931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1850934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850960 */     // MIs[0] policy
     /* 1850960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850970 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1850973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850994 */     // GIR_Coverage, 13556,
     /* 1850994 */     GIR_EraseRootFromParent_Done,
     /* 1850995 */   // Label 25043: @1850995
     /* 1850995 */   GIM_Try, /*On fail goto*//*Label 25044*/ GIMT_Encode4(1851081), // Rule ID 13557 //
     /* 1851000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1851011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1851014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1851017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1851020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851046 */     // MIs[0] policy
     /* 1851046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851056 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851080 */     // GIR_Coverage, 13557,
     /* 1851080 */     GIR_EraseRootFromParent_Done,
     /* 1851081 */   // Label 25044: @1851081
     /* 1851081 */   GIM_Try, /*On fail goto*//*Label 25045*/ GIMT_Encode4(1851167), // Rule ID 13560 //
     /* 1851086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1851103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851132 */     // MIs[0] policy
     /* 1851132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1851145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851166 */     // GIR_Coverage, 13560,
     /* 1851166 */     GIR_EraseRootFromParent_Done,
     /* 1851167 */   // Label 25045: @1851167
     /* 1851167 */   GIM_Try, /*On fail goto*//*Label 25046*/ GIMT_Encode4(1851253), // Rule ID 13561 //
     /* 1851172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1851183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1851186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1851189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1851192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851218 */     // MIs[0] policy
     /* 1851218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1851231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851252 */     // GIR_Coverage, 13561,
     /* 1851252 */     GIR_EraseRootFromParent_Done,
     /* 1851253 */   // Label 25046: @1851253
     /* 1851253 */   GIM_Try, /*On fail goto*//*Label 25047*/ GIMT_Encode4(1851339), // Rule ID 13564 //
     /* 1851258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851304 */     // MIs[0] policy
     /* 1851304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851314 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1851317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851338 */     // GIR_Coverage, 13564,
     /* 1851338 */     GIR_EraseRootFromParent_Done,
     /* 1851339 */   // Label 25047: @1851339
     /* 1851339 */   GIM_Try, /*On fail goto*//*Label 25048*/ GIMT_Encode4(1851425), // Rule ID 13565 //
     /* 1851344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1851355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1851358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1851361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1851364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1851367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851390 */     // MIs[0] policy
     /* 1851390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1851403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851424 */     // GIR_Coverage, 13565,
     /* 1851424 */     GIR_EraseRootFromParent_Done,
     /* 1851425 */   // Label 25048: @1851425
     /* 1851425 */   GIM_Try, /*On fail goto*//*Label 25049*/ GIMT_Encode4(1851511), // Rule ID 13568 //
     /* 1851430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1851447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1851450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851476 */     // MIs[0] policy
     /* 1851476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851486 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1851489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851510 */     // GIR_Coverage, 13568,
     /* 1851510 */     GIR_EraseRootFromParent_Done,
     /* 1851511 */   // Label 25049: @1851511
     /* 1851511 */   GIM_Try, /*On fail goto*//*Label 25050*/ GIMT_Encode4(1851597), // Rule ID 13569 //
     /* 1851516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1851527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1851530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1851533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1851536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1851539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851562 */     // MIs[0] policy
     /* 1851562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851572 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1851575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851596 */     // GIR_Coverage, 13569,
     /* 1851596 */     GIR_EraseRootFromParent_Done,
     /* 1851597 */   // Label 25050: @1851597
     /* 1851597 */   GIM_Try, /*On fail goto*//*Label 25051*/ GIMT_Encode4(1851683), // Rule ID 13572 //
     /* 1851602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1851613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1851616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1851619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1851622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851648 */     // MIs[0] policy
     /* 1851648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851658 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1851661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851682 */     // GIR_Coverage, 13572,
     /* 1851682 */     GIR_EraseRootFromParent_Done,
     /* 1851683 */   // Label 25051: @1851683
     /* 1851683 */   GIM_Try, /*On fail goto*//*Label 25052*/ GIMT_Encode4(1851769), // Rule ID 13573 //
     /* 1851688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1851699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1851702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1851705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1851708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851734 */     // MIs[0] policy
     /* 1851734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851744 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1851747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851768 */     // GIR_Coverage, 13573,
     /* 1851768 */     GIR_EraseRootFromParent_Done,
     /* 1851769 */   // Label 25052: @1851769
     /* 1851769 */   GIM_Try, /*On fail goto*//*Label 25053*/ GIMT_Encode4(1851855), // Rule ID 13576 //
     /* 1851774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1851785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1851788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1851791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1851794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851820 */     // MIs[0] policy
     /* 1851820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851854 */     // GIR_Coverage, 13576,
     /* 1851854 */     GIR_EraseRootFromParent_Done,
     /* 1851855 */   // Label 25053: @1851855
     /* 1851855 */   GIM_Try, /*On fail goto*//*Label 25054*/ GIMT_Encode4(1851941), // Rule ID 13577 //
     /* 1851860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1851871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1851874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1851877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1851880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851906 */     // MIs[0] policy
     /* 1851906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1851919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851940 */     // GIR_Coverage, 13577,
     /* 1851940 */     GIR_EraseRootFromParent_Done,
     /* 1851941 */   // Label 25054: @1851941
     /* 1851941 */   GIM_Try, /*On fail goto*//*Label 25055*/ GIMT_Encode4(1852027), // Rule ID 13580 //
     /* 1851946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1851954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1851957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1851960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1851963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1851966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851992 */     // MIs[0] policy
     /* 1851992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852026 */     // GIR_Coverage, 13580,
     /* 1852026 */     GIR_EraseRootFromParent_Done,
     /* 1852027 */   // Label 25055: @1852027
     /* 1852027 */   GIM_Try, /*On fail goto*//*Label 25056*/ GIMT_Encode4(1852113), // Rule ID 13581 //
     /* 1852032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1852043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1852046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1852049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1852052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852078 */     // MIs[0] policy
     /* 1852078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852112 */     // GIR_Coverage, 13581,
     /* 1852112 */     GIR_EraseRootFromParent_Done,
     /* 1852113 */   // Label 25056: @1852113
     /* 1852113 */   GIM_Try, /*On fail goto*//*Label 25057*/ GIMT_Encode4(1852199), // Rule ID 13584 //
     /* 1852118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1852135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852164 */     // MIs[0] policy
     /* 1852164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852198 */     // GIR_Coverage, 13584,
     /* 1852198 */     GIR_EraseRootFromParent_Done,
     /* 1852199 */   // Label 25057: @1852199
     /* 1852199 */   GIM_Try, /*On fail goto*//*Label 25058*/ GIMT_Encode4(1852285), // Rule ID 13585 //
     /* 1852204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1852215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1852218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1852221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1852224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852250 */     // MIs[0] policy
     /* 1852250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852260 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852284 */     // GIR_Coverage, 13585,
     /* 1852284 */     GIR_EraseRootFromParent_Done,
     /* 1852285 */   // Label 25058: @1852285
     /* 1852285 */   GIM_Try, /*On fail goto*//*Label 25059*/ GIMT_Encode4(1852371), // Rule ID 13588 //
     /* 1852290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1852307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852336 */     // MIs[0] policy
     /* 1852336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852346 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852370 */     // GIR_Coverage, 13588,
     /* 1852370 */     GIR_EraseRootFromParent_Done,
     /* 1852371 */   // Label 25059: @1852371
     /* 1852371 */   GIM_Try, /*On fail goto*//*Label 25060*/ GIMT_Encode4(1852457), // Rule ID 13589 //
     /* 1852376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1852387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1852390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1852393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1852396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852422 */     // MIs[0] policy
     /* 1852422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852432 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1852435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852456 */     // GIR_Coverage, 13589,
     /* 1852456 */     GIR_EraseRootFromParent_Done,
     /* 1852457 */   // Label 25060: @1852457
     /* 1852457 */   GIM_Try, /*On fail goto*//*Label 25061*/ GIMT_Encode4(1852543), // Rule ID 13592 //
     /* 1852462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1852473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1852476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1852479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1852482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852508 */     // MIs[0] policy
     /* 1852508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852542 */     // GIR_Coverage, 13592,
     /* 1852542 */     GIR_EraseRootFromParent_Done,
     /* 1852543 */   // Label 25061: @1852543
     /* 1852543 */   GIM_Try, /*On fail goto*//*Label 25062*/ GIMT_Encode4(1852629), // Rule ID 13593 //
     /* 1852548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1852551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1852559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1852562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1852565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1852568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852594 */     // MIs[0] policy
     /* 1852594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852604 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1852607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852628 */     // GIR_Coverage, 13593,
     /* 1852628 */     GIR_EraseRootFromParent_Done,
     /* 1852629 */   // Label 25062: @1852629
     /* 1852629 */   GIM_Try, /*On fail goto*//*Label 25063*/ GIMT_Encode4(1852715), // Rule ID 13596 //
     /* 1852634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1852645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1852648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1852651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1852654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852680 */     // MIs[0] policy
     /* 1852680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852714 */     // GIR_Coverage, 13596,
     /* 1852714 */     GIR_EraseRootFromParent_Done,
     /* 1852715 */   // Label 25063: @1852715
     /* 1852715 */   GIM_Try, /*On fail goto*//*Label 25064*/ GIMT_Encode4(1852801), // Rule ID 13597 //
     /* 1852720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1852723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1852731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1852734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1852737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1852740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852766 */     // MIs[0] policy
     /* 1852766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1852779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852800 */     // GIR_Coverage, 13597,
     /* 1852800 */     GIR_EraseRootFromParent_Done,
     /* 1852801 */   // Label 25064: @1852801
     /* 1852801 */   GIM_Try, /*On fail goto*//*Label 25065*/ GIMT_Encode4(1852887), // Rule ID 13600 //
     /* 1852806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1852817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1852820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1852823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1852826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852852 */     // MIs[0] policy
     /* 1852852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852862 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852886 */     // GIR_Coverage, 13600,
     /* 1852886 */     GIR_EraseRootFromParent_Done,
     /* 1852887 */   // Label 25065: @1852887
     /* 1852887 */   GIM_Try, /*On fail goto*//*Label 25066*/ GIMT_Encode4(1852973), // Rule ID 13601 //
     /* 1852892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1852895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1852903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1852906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1852909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1852912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852938 */     // MIs[0] policy
     /* 1852938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1852951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1852969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852972 */     // GIR_Coverage, 13601,
     /* 1852972 */     GIR_EraseRootFromParent_Done,
     /* 1852973 */   // Label 25066: @1852973
     /* 1852973 */   GIM_Try, /*On fail goto*//*Label 25067*/ GIMT_Encode4(1853059), // Rule ID 13604 //
     /* 1852978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1852981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1852986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1852989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1852992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1852995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1852998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853024 */     // MIs[0] policy
     /* 1853024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1853037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853058 */     // GIR_Coverage, 13604,
     /* 1853058 */     GIR_EraseRootFromParent_Done,
     /* 1853059 */   // Label 25067: @1853059
     /* 1853059 */   GIM_Try, /*On fail goto*//*Label 25068*/ GIMT_Encode4(1853145), // Rule ID 13605 //
     /* 1853064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1853075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1853078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1853081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1853084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853110 */     // MIs[0] policy
     /* 1853110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853120 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1853123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853144 */     // GIR_Coverage, 13605,
     /* 1853144 */     GIR_EraseRootFromParent_Done,
     /* 1853145 */   // Label 25068: @1853145
     /* 1853145 */   GIM_Try, /*On fail goto*//*Label 25069*/ GIMT_Encode4(1853231), // Rule ID 13608 //
     /* 1853150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853196 */     // MIs[0] policy
     /* 1853196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853206 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1853209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853230 */     // GIR_Coverage, 13608,
     /* 1853230 */     GIR_EraseRootFromParent_Done,
     /* 1853231 */   // Label 25069: @1853231
     /* 1853231 */   GIM_Try, /*On fail goto*//*Label 25070*/ GIMT_Encode4(1853317), // Rule ID 13609 //
     /* 1853236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1853247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1853250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1853256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853282 */     // MIs[0] policy
     /* 1853282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853292 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1853295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853316 */     // GIR_Coverage, 13609,
     /* 1853316 */     GIR_EraseRootFromParent_Done,
     /* 1853317 */   // Label 25070: @1853317
     /* 1853317 */   GIM_Try, /*On fail goto*//*Label 25071*/ GIMT_Encode4(1853403), // Rule ID 13612 //
     /* 1853322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853368 */     // MIs[0] policy
     /* 1853368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1853381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853402 */     // GIR_Coverage, 13612,
     /* 1853402 */     GIR_EraseRootFromParent_Done,
     /* 1853403 */   // Label 25071: @1853403
     /* 1853403 */   GIM_Try, /*On fail goto*//*Label 25072*/ GIMT_Encode4(1853489), // Rule ID 13613 //
     /* 1853408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1853419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1853422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1853428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853454 */     // MIs[0] policy
     /* 1853454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1853467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853488 */     // GIR_Coverage, 13613,
     /* 1853488 */     GIR_EraseRootFromParent_Done,
     /* 1853489 */   // Label 25072: @1853489
     /* 1853489 */   GIM_Try, /*On fail goto*//*Label 25073*/ GIMT_Encode4(1853575), // Rule ID 13616 //
     /* 1853494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1853505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1853508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1853514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853540 */     // MIs[0] policy
     /* 1853540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1853553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853574 */     // GIR_Coverage, 13616,
     /* 1853574 */     GIR_EraseRootFromParent_Done,
     /* 1853575 */   // Label 25073: @1853575
     /* 1853575 */   GIM_Try, /*On fail goto*//*Label 25074*/ GIMT_Encode4(1853661), // Rule ID 13617 //
     /* 1853580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1853591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1853594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1853600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853626 */     // MIs[0] policy
     /* 1853626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11648:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1853639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853660 */     // GIR_Coverage, 13617,
     /* 1853660 */     GIR_EraseRootFromParent_Done,
     /* 1853661 */   // Label 25074: @1853661
     /* 1853661 */   GIM_Try, /*On fail goto*//*Label 25075*/ GIMT_Encode4(1853747), // Rule ID 13620 //
     /* 1853666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1853677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1853680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1853686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853712 */     // MIs[0] policy
     /* 1853712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853722 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1853725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853746 */     // GIR_Coverage, 13620,
     /* 1853746 */     GIR_EraseRootFromParent_Done,
     /* 1853747 */   // Label 25075: @1853747
     /* 1853747 */   GIM_Try, /*On fail goto*//*Label 25076*/ GIMT_Encode4(1853833), // Rule ID 13621 //
     /* 1853752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1853763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1853766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1853772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853798 */     // MIs[0] policy
     /* 1853798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853808 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1853811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853832 */     // GIR_Coverage, 13621,
     /* 1853832 */     GIR_EraseRootFromParent_Done,
     /* 1853833 */   // Label 25076: @1853833
     /* 1853833 */   GIM_Try, /*On fail goto*//*Label 25077*/ GIMT_Encode4(1853919), // Rule ID 13624 //
     /* 1853838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1853849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1853852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1853858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1853861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853884 */     // MIs[0] policy
     /* 1853884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853894 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1853897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1853915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853918 */     // GIR_Coverage, 13624,
     /* 1853918 */     GIR_EraseRootFromParent_Done,
     /* 1853919 */   // Label 25077: @1853919
     /* 1853919 */   GIM_Try, /*On fail goto*//*Label 25078*/ GIMT_Encode4(1854005), // Rule ID 13625 //
     /* 1853924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1853932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1853935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1853938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1853944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1853947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853970 */     // MIs[0] policy
     /* 1853970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1853983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854004 */     // GIR_Coverage, 13625,
     /* 1854004 */     GIR_EraseRootFromParent_Done,
     /* 1854005 */   // Label 25078: @1854005
     /* 1854005 */   GIM_Try, /*On fail goto*//*Label 25079*/ GIMT_Encode4(1854091), // Rule ID 13628 //
     /* 1854010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854056 */     // MIs[0] policy
     /* 1854056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854066 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854090 */     // GIR_Coverage, 13628,
     /* 1854090 */     GIR_EraseRootFromParent_Done,
     /* 1854091 */   // Label 25079: @1854091
     /* 1854091 */   GIM_Try, /*On fail goto*//*Label 25080*/ GIMT_Encode4(1854177), // Rule ID 13629 //
     /* 1854096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1854107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1854110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1854116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1854119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854142 */     // MIs[0] policy
     /* 1854142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854152 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854176 */     // GIR_Coverage, 13629,
     /* 1854176 */     GIR_EraseRootFromParent_Done,
     /* 1854177 */   // Label 25080: @1854177
     /* 1854177 */   GIM_Try, /*On fail goto*//*Label 25081*/ GIMT_Encode4(1854263), // Rule ID 13632 //
     /* 1854182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854228 */     // MIs[0] policy
     /* 1854228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854238 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1854241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854262 */     // GIR_Coverage, 13632,
     /* 1854262 */     GIR_EraseRootFromParent_Done,
     /* 1854263 */   // Label 25081: @1854263
     /* 1854263 */   GIM_Try, /*On fail goto*//*Label 25082*/ GIMT_Encode4(1854349), // Rule ID 13633 //
     /* 1854268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1854279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1854282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1854288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854314 */     // MIs[0] policy
     /* 1854314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854324 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1854327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854348 */     // GIR_Coverage, 13633,
     /* 1854348 */     GIR_EraseRootFromParent_Done,
     /* 1854349 */   // Label 25082: @1854349
     /* 1854349 */   GIM_Try, /*On fail goto*//*Label 25083*/ GIMT_Encode4(1854435), // Rule ID 13636 //
     /* 1854354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854400 */     // MIs[0] policy
     /* 1854400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854434 */     // GIR_Coverage, 13636,
     /* 1854434 */     GIR_EraseRootFromParent_Done,
     /* 1854435 */   // Label 25083: @1854435
     /* 1854435 */   GIM_Try, /*On fail goto*//*Label 25084*/ GIMT_Encode4(1854521), // Rule ID 13637 //
     /* 1854440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1854451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1854454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1854460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854486 */     // MIs[0] policy
     /* 1854486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854496 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11648:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1854499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854520 */     // GIR_Coverage, 13637,
     /* 1854520 */     GIR_EraseRootFromParent_Done,
     /* 1854521 */   // Label 25084: @1854521
     /* 1854521 */   GIM_Try, /*On fail goto*//*Label 25085*/ GIMT_Encode4(1854607), // Rule ID 13640 //
     /* 1854526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1854537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1854540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1854546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854572 */     // MIs[0] policy
     /* 1854572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1854585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854606 */     // GIR_Coverage, 13640,
     /* 1854606 */     GIR_EraseRootFromParent_Done,
     /* 1854607 */   // Label 25085: @1854607
     /* 1854607 */   GIM_Try, /*On fail goto*//*Label 25086*/ GIMT_Encode4(1854693), // Rule ID 13641 //
     /* 1854612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1854623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1854626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1854632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854658 */     // MIs[0] policy
     /* 1854658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1854671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854692 */     // GIR_Coverage, 13641,
     /* 1854692 */     GIR_EraseRootFromParent_Done,
     /* 1854693 */   // Label 25086: @1854693
     /* 1854693 */   GIM_Try, /*On fail goto*//*Label 25087*/ GIMT_Encode4(1854779), // Rule ID 13644 //
     /* 1854698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1854709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1854712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1854718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854744 */     // MIs[0] policy
     /* 1854744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1854757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854778 */     // GIR_Coverage, 13644,
     /* 1854778 */     GIR_EraseRootFromParent_Done,
     /* 1854779 */   // Label 25087: @1854779
     /* 1854779 */   GIM_Try, /*On fail goto*//*Label 25088*/ GIMT_Encode4(1854865), // Rule ID 13645 //
     /* 1854784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1854795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1854798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1854804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854830 */     // MIs[0] policy
     /* 1854830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1854843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854864 */     // GIR_Coverage, 13645,
     /* 1854864 */     GIR_EraseRootFromParent_Done,
     /* 1854865 */   // Label 25088: @1854865
     /* 1854865 */   GIM_Try, /*On fail goto*//*Label 25089*/ GIMT_Encode4(1854951), // Rule ID 13648 //
     /* 1854870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1854881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1854884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1854890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854916 */     // MIs[0] policy
     /* 1854916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1854929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1854947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854950 */     // GIR_Coverage, 13648,
     /* 1854950 */     GIR_EraseRootFromParent_Done,
     /* 1854951 */   // Label 25089: @1854951
     /* 1854951 */   GIM_Try, /*On fail goto*//*Label 25090*/ GIMT_Encode4(1855037), // Rule ID 13649 //
     /* 1854956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1854964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1854967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1854970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1854976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1854979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855002 */     // MIs[0] policy
     /* 1855002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855012 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855036 */     // GIR_Coverage, 13649,
     /* 1855036 */     GIR_EraseRootFromParent_Done,
     /* 1855037 */   // Label 25090: @1855037
     /* 1855037 */   GIM_Try, /*On fail goto*//*Label 25091*/ GIMT_Encode4(1855123), // Rule ID 13652 //
     /* 1855042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855088 */     // MIs[0] policy
     /* 1855088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1855101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855122 */     // GIR_Coverage, 13652,
     /* 1855122 */     GIR_EraseRootFromParent_Done,
     /* 1855123 */   // Label 25091: @1855123
     /* 1855123 */   GIM_Try, /*On fail goto*//*Label 25092*/ GIMT_Encode4(1855209), // Rule ID 13653 //
     /* 1855128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1855139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1855142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1855148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855174 */     // MIs[0] policy
     /* 1855174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11648:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1855187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855208 */     // GIR_Coverage, 13653,
     /* 1855208 */     GIR_EraseRootFromParent_Done,
     /* 1855209 */   // Label 25092: @1855209
     /* 1855209 */   GIM_Try, /*On fail goto*//*Label 25093*/ GIMT_Encode4(1855295), // Rule ID 13656 //
     /* 1855214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855260 */     // MIs[0] policy
     /* 1855260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855270 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855294 */     // GIR_Coverage, 13656,
     /* 1855294 */     GIR_EraseRootFromParent_Done,
     /* 1855295 */   // Label 25093: @1855295
     /* 1855295 */   GIM_Try, /*On fail goto*//*Label 25094*/ GIMT_Encode4(1855381), // Rule ID 13657 //
     /* 1855300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1855311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1855314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1855320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855346 */     // MIs[0] policy
     /* 1855346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855356 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11648:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1855359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855380 */     // GIR_Coverage, 13657,
     /* 1855380 */     GIR_EraseRootFromParent_Done,
     /* 1855381 */   // Label 25094: @1855381
     /* 1855381 */   GIM_Try, /*On fail goto*//*Label 25095*/ GIMT_Encode4(1855467), // Rule ID 13660 //
     /* 1855386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855432 */     // MIs[0] policy
     /* 1855432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855442 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855466 */     // GIR_Coverage, 13660,
     /* 1855466 */     GIR_EraseRootFromParent_Done,
     /* 1855467 */   // Label 25095: @1855467
     /* 1855467 */   GIM_Try, /*On fail goto*//*Label 25096*/ GIMT_Encode4(1855553), // Rule ID 13661 //
     /* 1855472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1855483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1855486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1855492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855518 */     // MIs[0] policy
     /* 1855518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855528 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11648:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1855531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855552 */     // GIR_Coverage, 13661,
     /* 1855552 */     GIR_EraseRootFromParent_Done,
     /* 1855553 */   // Label 25096: @1855553
     /* 1855553 */   GIM_Try, /*On fail goto*//*Label 25097*/ GIMT_Encode4(1855639), // Rule ID 13664 //
     /* 1855558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1855561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1855569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1855572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1855578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855604 */     // MIs[0] policy
     /* 1855604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855638 */     // GIR_Coverage, 13664,
     /* 1855638 */     GIR_EraseRootFromParent_Done,
     /* 1855639 */   // Label 25097: @1855639
     /* 1855639 */   GIM_Try, /*On fail goto*//*Label 25098*/ GIMT_Encode4(1855725), // Rule ID 13665 //
     /* 1855644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1855647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1855652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1855655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1855658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1855664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855690 */     // MIs[0] policy
     /* 1855690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11648:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1855703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1855721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855724 */     // GIR_Coverage, 13665,
     /* 1855724 */     GIR_EraseRootFromParent_Done,
     /* 1855725 */   // Label 25098: @1855725
     /* 1855725 */   GIM_Try, /*On fail goto*//*Label 25099*/ GIMT_Encode4(1855811), // Rule ID 13668 //
     /* 1855730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1855741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1855744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1855747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1855750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855776 */     // MIs[0] policy
     /* 1855776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855786 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1855789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855810 */     // GIR_Coverage, 13668,
     /* 1855810 */     GIR_EraseRootFromParent_Done,
     /* 1855811 */   // Label 25099: @1855811
     /* 1855811 */   GIM_Try, /*On fail goto*//*Label 25100*/ GIMT_Encode4(1855897), // Rule ID 13669 //
     /* 1855816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1855827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1855830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1855833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1855836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855862 */     // MIs[0] policy
     /* 1855862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1855875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855896 */     // GIR_Coverage, 13669,
     /* 1855896 */     GIR_EraseRootFromParent_Done,
     /* 1855897 */   // Label 25100: @1855897
     /* 1855897 */   GIM_Try, /*On fail goto*//*Label 25101*/ GIMT_Encode4(1855983), // Rule ID 13672 //
     /* 1855902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1855913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1855916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1855919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1855922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855948 */     // MIs[0] policy
     /* 1855948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855958 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1855961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855982 */     // GIR_Coverage, 13672,
     /* 1855982 */     GIR_EraseRootFromParent_Done,
     /* 1855983 */   // Label 25101: @1855983
     /* 1855983 */   GIM_Try, /*On fail goto*//*Label 25102*/ GIMT_Encode4(1856069), // Rule ID 13673 //
     /* 1855988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1855996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1855999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1856002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1856005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1856008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856034 */     // MIs[0] policy
     /* 1856034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856068 */     // GIR_Coverage, 13673,
     /* 1856068 */     GIR_EraseRootFromParent_Done,
     /* 1856069 */   // Label 25102: @1856069
     /* 1856069 */   GIM_Try, /*On fail goto*//*Label 25103*/ GIMT_Encode4(1856155), // Rule ID 13676 //
     /* 1856074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1856091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856120 */     // MIs[0] policy
     /* 1856120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1856133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856154 */     // GIR_Coverage, 13676,
     /* 1856154 */     GIR_EraseRootFromParent_Done,
     /* 1856155 */   // Label 25103: @1856155
     /* 1856155 */   GIM_Try, /*On fail goto*//*Label 25104*/ GIMT_Encode4(1856241), // Rule ID 13677 //
     /* 1856160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1856171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1856174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1856177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1856180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856206 */     // MIs[0] policy
     /* 1856206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856216 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1856219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856240 */     // GIR_Coverage, 13677,
     /* 1856240 */     GIR_EraseRootFromParent_Done,
     /* 1856241 */   // Label 25104: @1856241
     /* 1856241 */   GIM_Try, /*On fail goto*//*Label 25105*/ GIMT_Encode4(1856327), // Rule ID 13680 //
     /* 1856246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1856263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856292 */     // MIs[0] policy
     /* 1856292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856302 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1856305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856326 */     // GIR_Coverage, 13680,
     /* 1856326 */     GIR_EraseRootFromParent_Done,
     /* 1856327 */   // Label 25105: @1856327
     /* 1856327 */   GIM_Try, /*On fail goto*//*Label 25106*/ GIMT_Encode4(1856413), // Rule ID 13681 //
     /* 1856332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1856343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1856346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1856349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1856352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856378 */     // MIs[0] policy
     /* 1856378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856388 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1856391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856412 */     // GIR_Coverage, 13681,
     /* 1856412 */     GIR_EraseRootFromParent_Done,
     /* 1856413 */   // Label 25106: @1856413
     /* 1856413 */   GIM_Try, /*On fail goto*//*Label 25107*/ GIMT_Encode4(1856499), // Rule ID 13684 //
     /* 1856418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1856435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856464 */     // MIs[0] policy
     /* 1856464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856474 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1856477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856498 */     // GIR_Coverage, 13684,
     /* 1856498 */     GIR_EraseRootFromParent_Done,
     /* 1856499 */   // Label 25107: @1856499
     /* 1856499 */   GIM_Try, /*On fail goto*//*Label 25108*/ GIMT_Encode4(1856585), // Rule ID 13685 //
     /* 1856504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1856515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1856518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1856521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1856524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856550 */     // MIs[0] policy
     /* 1856550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1856563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856584 */     // GIR_Coverage, 13685,
     /* 1856584 */     GIR_EraseRootFromParent_Done,
     /* 1856585 */   // Label 25108: @1856585
     /* 1856585 */   GIM_Try, /*On fail goto*//*Label 25109*/ GIMT_Encode4(1856671), // Rule ID 13688 //
     /* 1856590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1856601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1856604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1856607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1856610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1856613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856636 */     // MIs[0] policy
     /* 1856636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856646 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1856649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856670 */     // GIR_Coverage, 13688,
     /* 1856670 */     GIR_EraseRootFromParent_Done,
     /* 1856671 */   // Label 25109: @1856671
     /* 1856671 */   GIM_Try, /*On fail goto*//*Label 25110*/ GIMT_Encode4(1856757), // Rule ID 13689 //
     /* 1856676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1856687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1856690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1856693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1856696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1856699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856722 */     // MIs[0] policy
     /* 1856722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856732 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1856735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856756 */     // GIR_Coverage, 13689,
     /* 1856756 */     GIR_EraseRootFromParent_Done,
     /* 1856757 */   // Label 25110: @1856757
     /* 1856757 */   GIM_Try, /*On fail goto*//*Label 25111*/ GIMT_Encode4(1856843), // Rule ID 13692 //
     /* 1856762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1856773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1856776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1856779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1856782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856808 */     // MIs[0] policy
     /* 1856808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856818 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856842 */     // GIR_Coverage, 13692,
     /* 1856842 */     GIR_EraseRootFromParent_Done,
     /* 1856843 */   // Label 25111: @1856843
     /* 1856843 */   GIM_Try, /*On fail goto*//*Label 25112*/ GIMT_Encode4(1856929), // Rule ID 13693 //
     /* 1856848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1856859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1856862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1856865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1856868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856894 */     // MIs[0] policy
     /* 1856894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856904 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1856907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856928 */     // GIR_Coverage, 13693,
     /* 1856928 */     GIR_EraseRootFromParent_Done,
     /* 1856929 */   // Label 25112: @1856929
     /* 1856929 */   GIM_Try, /*On fail goto*//*Label 25113*/ GIMT_Encode4(1857015), // Rule ID 13696 //
     /* 1856934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1856942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1856945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1856948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1856951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1856954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856980 */     // MIs[0] policy
     /* 1856980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1856993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857014 */     // GIR_Coverage, 13696,
     /* 1857014 */     GIR_EraseRootFromParent_Done,
     /* 1857015 */   // Label 25113: @1857015
     /* 1857015 */   GIM_Try, /*On fail goto*//*Label 25114*/ GIMT_Encode4(1857101), // Rule ID 13697 //
     /* 1857020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1857031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1857034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1857037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857066 */     // MIs[0] policy
     /* 1857066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857076 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857100 */     // GIR_Coverage, 13697,
     /* 1857100 */     GIR_EraseRootFromParent_Done,
     /* 1857101 */   // Label 25114: @1857101
     /* 1857101 */   GIM_Try, /*On fail goto*//*Label 25115*/ GIMT_Encode4(1857187), // Rule ID 13700 //
     /* 1857106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1857123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857152 */     // MIs[0] policy
     /* 1857152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857186 */     // GIR_Coverage, 13700,
     /* 1857186 */     GIR_EraseRootFromParent_Done,
     /* 1857187 */   // Label 25115: @1857187
     /* 1857187 */   GIM_Try, /*On fail goto*//*Label 25116*/ GIMT_Encode4(1857273), // Rule ID 13701 //
     /* 1857192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1857203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1857206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1857209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1857212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857238 */     // MIs[0] policy
     /* 1857238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857248 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857272 */     // GIR_Coverage, 13701,
     /* 1857272 */     GIR_EraseRootFromParent_Done,
     /* 1857273 */   // Label 25116: @1857273
     /* 1857273 */   GIM_Try, /*On fail goto*//*Label 25117*/ GIMT_Encode4(1857359), // Rule ID 13704 //
     /* 1857278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1857295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857324 */     // MIs[0] policy
     /* 1857324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857358 */     // GIR_Coverage, 13704,
     /* 1857358 */     GIR_EraseRootFromParent_Done,
     /* 1857359 */   // Label 25117: @1857359
     /* 1857359 */   GIM_Try, /*On fail goto*//*Label 25118*/ GIMT_Encode4(1857445), // Rule ID 13705 //
     /* 1857364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1857375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1857378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1857381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1857384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857410 */     // MIs[0] policy
     /* 1857410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857420 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1857423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857444 */     // GIR_Coverage, 13705,
     /* 1857444 */     GIR_EraseRootFromParent_Done,
     /* 1857445 */   // Label 25118: @1857445
     /* 1857445 */   GIM_Try, /*On fail goto*//*Label 25119*/ GIMT_Encode4(1857531), // Rule ID 13708 //
     /* 1857450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1857467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1857470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857496 */     // MIs[0] policy
     /* 1857496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857530 */     // GIR_Coverage, 13708,
     /* 1857530 */     GIR_EraseRootFromParent_Done,
     /* 1857531 */   // Label 25119: @1857531
     /* 1857531 */   GIM_Try, /*On fail goto*//*Label 25120*/ GIMT_Encode4(1857617), // Rule ID 13709 //
     /* 1857536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1857547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1857550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1857553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1857556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1857559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1857566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1857570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1857578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857582 */     // MIs[0] policy
     /* 1857582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1857595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857616 */     // GIR_Coverage, 13709,
     /* 1857616 */     GIR_EraseRootFromParent_Done,
     /* 1857617 */   // Label 25120: @1857617
     /* 1857617 */   GIM_Try, /*On fail goto*//*Label 25121*/ GIMT_Encode4(1857703), // Rule ID 13712 //
     /* 1857622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1857625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1857633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1857636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1857639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1857642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857668 */     // MIs[0] policy
     /* 1857668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857678 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857702 */     // GIR_Coverage, 13712,
     /* 1857702 */     GIR_EraseRootFromParent_Done,
     /* 1857703 */   // Label 25121: @1857703
     /* 1857703 */   GIM_Try, /*On fail goto*//*Label 25122*/ GIMT_Encode4(1857789), // Rule ID 13713 //
     /* 1857708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1857711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1857719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1857722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1857725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1857728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857754 */     // MIs[0] policy
     /* 1857754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857764 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1857767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857788 */     // GIR_Coverage, 13713,
     /* 1857788 */     GIR_EraseRootFromParent_Done,
     /* 1857789 */   // Label 25122: @1857789
     /* 1857789 */   GIM_Try, /*On fail goto*//*Label 25123*/ GIMT_Encode4(1857875), // Rule ID 13716 //
     /* 1857794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1857797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1857805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1857808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1857811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1857814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857840 */     // MIs[0] policy
     /* 1857840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857850 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857874 */     // GIR_Coverage, 13716,
     /* 1857874 */     GIR_EraseRootFromParent_Done,
     /* 1857875 */   // Label 25123: @1857875
     /* 1857875 */   GIM_Try, /*On fail goto*//*Label 25124*/ GIMT_Encode4(1857961), // Rule ID 13717 //
     /* 1857880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1857883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1857891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1857894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1857897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1857900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1857910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1857914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857926 */     // MIs[0] policy
     /* 1857926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1857939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1857943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857960 */     // GIR_Coverage, 13717,
     /* 1857960 */     GIR_EraseRootFromParent_Done,
     /* 1857961 */   // Label 25124: @1857961
     /* 1857961 */   GIM_Try, /*On fail goto*//*Label 25125*/ GIMT_Encode4(1858047), // Rule ID 13720 //
     /* 1857966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1857969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1857974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1857977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1857980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1857983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1857986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1857996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858012 */     // MIs[0] policy
     /* 1858012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858022 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1858025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858046 */     // GIR_Coverage, 13720,
     /* 1858046 */     GIR_EraseRootFromParent_Done,
     /* 1858047 */   // Label 25125: @1858047
     /* 1858047 */   GIM_Try, /*On fail goto*//*Label 25126*/ GIMT_Encode4(1858133), // Rule ID 13721 //
     /* 1858052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1858063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1858066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1858069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1858072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858098 */     // MIs[0] policy
     /* 1858098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858108 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1858111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858132 */     // GIR_Coverage, 13721,
     /* 1858132 */     GIR_EraseRootFromParent_Done,
     /* 1858133 */   // Label 25126: @1858133
     /* 1858133 */   GIM_Try, /*On fail goto*//*Label 25127*/ GIMT_Encode4(1858219), // Rule ID 13724 //
     /* 1858138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1858141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1858155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858184 */     // MIs[0] policy
     /* 1858184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858218 */     // GIR_Coverage, 13724,
     /* 1858218 */     GIR_EraseRootFromParent_Done,
     /* 1858219 */   // Label 25127: @1858219
     /* 1858219 */   GIM_Try, /*On fail goto*//*Label 25128*/ GIMT_Encode4(1858305), // Rule ID 13725 //
     /* 1858224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1858227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1858235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1858238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1858241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1858244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1858254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1858258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858270 */     // MIs[0] policy
     /* 1858270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858280 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1858283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858304 */     // GIR_Coverage, 13725,
     /* 1858304 */     GIR_EraseRootFromParent_Done,
     /* 1858305 */   // Label 25128: @1858305
     /* 1858305 */   GIM_Try, /*On fail goto*//*Label 25129*/ GIMT_Encode4(1858391), // Rule ID 13728 //
     /* 1858310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858356 */     // MIs[0] policy
     /* 1858356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1858369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858390 */     // GIR_Coverage, 13728,
     /* 1858390 */     GIR_EraseRootFromParent_Done,
     /* 1858391 */   // Label 25129: @1858391
     /* 1858391 */   GIM_Try, /*On fail goto*//*Label 25130*/ GIMT_Encode4(1858477), // Rule ID 13729 //
     /* 1858396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1858407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1858410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1858416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858442 */     // MIs[0] policy
     /* 1858442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1858455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858476 */     // GIR_Coverage, 13729,
     /* 1858476 */     GIR_EraseRootFromParent_Done,
     /* 1858477 */   // Label 25130: @1858477
     /* 1858477 */   GIM_Try, /*On fail goto*//*Label 25131*/ GIMT_Encode4(1858563), // Rule ID 13732 //
     /* 1858482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1858493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1858496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1858502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858528 */     // MIs[0] policy
     /* 1858528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858538 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1858541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858562 */     // GIR_Coverage, 13732,
     /* 1858562 */     GIR_EraseRootFromParent_Done,
     /* 1858563 */   // Label 25131: @1858563
     /* 1858563 */   GIM_Try, /*On fail goto*//*Label 25132*/ GIMT_Encode4(1858649), // Rule ID 13733 //
     /* 1858568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1858579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1858582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1858588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858614 */     // MIs[0] policy
     /* 1858614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858624 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1858627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858648 */     // GIR_Coverage, 13733,
     /* 1858648 */     GIR_EraseRootFromParent_Done,
     /* 1858649 */   // Label 25132: @1858649
     /* 1858649 */   GIM_Try, /*On fail goto*//*Label 25133*/ GIMT_Encode4(1858735), // Rule ID 13736 //
     /* 1858654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1858665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1858668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1858674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858700 */     // MIs[0] policy
     /* 1858700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1858713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858734 */     // GIR_Coverage, 13736,
     /* 1858734 */     GIR_EraseRootFromParent_Done,
     /* 1858735 */   // Label 25133: @1858735
     /* 1858735 */   GIM_Try, /*On fail goto*//*Label 25134*/ GIMT_Encode4(1858821), // Rule ID 13737 //
     /* 1858740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1858751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1858754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1858760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858786 */     // MIs[0] policy
     /* 1858786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858796 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11650:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1858799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858820 */     // GIR_Coverage, 13737,
     /* 1858820 */     GIR_EraseRootFromParent_Done,
     /* 1858821 */   // Label 25134: @1858821
     /* 1858821 */   GIM_Try, /*On fail goto*//*Label 25135*/ GIMT_Encode4(1858907), // Rule ID 13740 //
     /* 1858826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1858837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1858840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1858843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1858846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858872 */     // MIs[0] policy
     /* 1858872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858882 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1858885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858906 */     // GIR_Coverage, 13740,
     /* 1858906 */     GIR_EraseRootFromParent_Done,
     /* 1858907 */   // Label 25135: @1858907
     /* 1858907 */   GIM_Try, /*On fail goto*//*Label 25136*/ GIMT_Encode4(1858993), // Rule ID 13741 //
     /* 1858912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1858920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1858923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1858926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1858929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1858932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1858950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858958 */     // MIs[0] policy
     /* 1858958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1858971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1858975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858992 */     // GIR_Coverage, 13741,
     /* 1858992 */     GIR_EraseRootFromParent_Done,
     /* 1858993 */   // Label 25136: @1858993
     /* 1858993 */   GIM_Try, /*On fail goto*//*Label 25137*/ GIMT_Encode4(1859079), // Rule ID 13744 //
     /* 1858998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859044 */     // MIs[0] policy
     /* 1859044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859078 */     // GIR_Coverage, 13744,
     /* 1859078 */     GIR_EraseRootFromParent_Done,
     /* 1859079 */   // Label 25137: @1859079
     /* 1859079 */   GIM_Try, /*On fail goto*//*Label 25138*/ GIMT_Encode4(1859165), // Rule ID 13745 //
     /* 1859084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1859104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859130 */     // MIs[0] policy
     /* 1859130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859164 */     // GIR_Coverage, 13745,
     /* 1859164 */     GIR_EraseRootFromParent_Done,
     /* 1859165 */   // Label 25138: @1859165
     /* 1859165 */   GIM_Try, /*On fail goto*//*Label 25139*/ GIMT_Encode4(1859251), // Rule ID 13748 //
     /* 1859170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859216 */     // MIs[0] policy
     /* 1859216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859226 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1859229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859250 */     // GIR_Coverage, 13748,
     /* 1859250 */     GIR_EraseRootFromParent_Done,
     /* 1859251 */   // Label 25139: @1859251
     /* 1859251 */   GIM_Try, /*On fail goto*//*Label 25140*/ GIMT_Encode4(1859337), // Rule ID 13749 //
     /* 1859256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1859276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859302 */     // MIs[0] policy
     /* 1859302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859312 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1859315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859336 */     // GIR_Coverage, 13749,
     /* 1859336 */     GIR_EraseRootFromParent_Done,
     /* 1859337 */   // Label 25140: @1859337
     /* 1859337 */   GIM_Try, /*On fail goto*//*Label 25141*/ GIMT_Encode4(1859423), // Rule ID 13752 //
     /* 1859342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859388 */     // MIs[0] policy
     /* 1859388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859398 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859422 */     // GIR_Coverage, 13752,
     /* 1859422 */     GIR_EraseRootFromParent_Done,
     /* 1859423 */   // Label 25141: @1859423
     /* 1859423 */   GIM_Try, /*On fail goto*//*Label 25142*/ GIMT_Encode4(1859509), // Rule ID 13753 //
     /* 1859428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1859439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1859442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1859448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1859451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859474 */     // MIs[0] policy
     /* 1859474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859484 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1859487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859508 */     // GIR_Coverage, 13753,
     /* 1859508 */     GIR_EraseRootFromParent_Done,
     /* 1859509 */   // Label 25142: @1859509
     /* 1859509 */   GIM_Try, /*On fail goto*//*Label 25143*/ GIMT_Encode4(1859595), // Rule ID 13756 //
     /* 1859514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1859525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1859528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1859534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859560 */     // MIs[0] policy
     /* 1859560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1859573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859594 */     // GIR_Coverage, 13756,
     /* 1859594 */     GIR_EraseRootFromParent_Done,
     /* 1859595 */   // Label 25143: @1859595
     /* 1859595 */   GIM_Try, /*On fail goto*//*Label 25144*/ GIMT_Encode4(1859681), // Rule ID 13757 //
     /* 1859600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1859611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1859614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1859620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1859623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1859630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859646 */     // MIs[0] policy
     /* 1859646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11650:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1859659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859680 */     // GIR_Coverage, 13757,
     /* 1859680 */     GIR_EraseRootFromParent_Done,
     /* 1859681 */   // Label 25144: @1859681
     /* 1859681 */   GIM_Try, /*On fail goto*//*Label 25145*/ GIMT_Encode4(1859767), // Rule ID 13760 //
     /* 1859686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1859697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1859700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1859706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859732 */     // MIs[0] policy
     /* 1859732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1859745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859766 */     // GIR_Coverage, 13760,
     /* 1859766 */     GIR_EraseRootFromParent_Done,
     /* 1859767 */   // Label 25145: @1859767
     /* 1859767 */   GIM_Try, /*On fail goto*//*Label 25146*/ GIMT_Encode4(1859853), // Rule ID 13761 //
     /* 1859772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1859783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1859786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1859792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1859814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859818 */     // MIs[0] policy
     /* 1859818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1859831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859852 */     // GIR_Coverage, 13761,
     /* 1859852 */     GIR_EraseRootFromParent_Done,
     /* 1859853 */   // Label 25146: @1859853
     /* 1859853 */   GIM_Try, /*On fail goto*//*Label 25147*/ GIMT_Encode4(1859939), // Rule ID 13764 //
     /* 1859858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1859869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1859872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1859875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1859878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859904 */     // MIs[0] policy
     /* 1859904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859914 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1859917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1859921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859938 */     // GIR_Coverage, 13764,
     /* 1859938 */     GIR_EraseRootFromParent_Done,
     /* 1859939 */   // Label 25147: @1859939
     /* 1859939 */   GIM_Try, /*On fail goto*//*Label 25148*/ GIMT_Encode4(1860025), // Rule ID 13765 //
     /* 1859944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1859952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1859955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1859958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1859961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1859964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1859982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859990 */     // MIs[0] policy
     /* 1859990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860000 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860024 */     // GIR_Coverage, 13765,
     /* 1860024 */     GIR_EraseRootFromParent_Done,
     /* 1860025 */   // Label 25148: @1860025
     /* 1860025 */   GIM_Try, /*On fail goto*//*Label 25149*/ GIMT_Encode4(1860111), // Rule ID 13768 //
     /* 1860030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860076 */     // MIs[0] policy
     /* 1860076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860086 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860110 */     // GIR_Coverage, 13768,
     /* 1860110 */     GIR_EraseRootFromParent_Done,
     /* 1860111 */   // Label 25149: @1860111
     /* 1860111 */   GIM_Try, /*On fail goto*//*Label 25150*/ GIMT_Encode4(1860197), // Rule ID 13769 //
     /* 1860116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1860136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860162 */     // MIs[0] policy
     /* 1860162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1860193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860196 */     // GIR_Coverage, 13769,
     /* 1860196 */     GIR_EraseRootFromParent_Done,
     /* 1860197 */   // Label 25150: @1860197
     /* 1860197 */   GIM_Try, /*On fail goto*//*Label 25151*/ GIMT_Encode4(1860283), // Rule ID 13772 //
     /* 1860202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860248 */     // MIs[0] policy
     /* 1860248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860258 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860282 */     // GIR_Coverage, 13772,
     /* 1860282 */     GIR_EraseRootFromParent_Done,
     /* 1860283 */   // Label 25151: @1860283
     /* 1860283 */   GIM_Try, /*On fail goto*//*Label 25152*/ GIMT_Encode4(1860369), // Rule ID 13773 //
     /* 1860288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1860299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1860302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1860308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860334 */     // MIs[0] policy
     /* 1860334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860344 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11650:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1860347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860368 */     // GIR_Coverage, 13773,
     /* 1860368 */     GIR_EraseRootFromParent_Done,
     /* 1860369 */   // Label 25152: @1860369
     /* 1860369 */   GIM_Try, /*On fail goto*//*Label 25153*/ GIMT_Encode4(1860455), // Rule ID 13776 //
     /* 1860374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860420 */     // MIs[0] policy
     /* 1860420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860454 */     // GIR_Coverage, 13776,
     /* 1860454 */     GIR_EraseRootFromParent_Done,
     /* 1860455 */   // Label 25153: @1860455
     /* 1860455 */   GIM_Try, /*On fail goto*//*Label 25154*/ GIMT_Encode4(1860541), // Rule ID 13777 //
     /* 1860460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1860480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860506 */     // MIs[0] policy
     /* 1860506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11650:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1860519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860540 */     // GIR_Coverage, 13777,
     /* 1860540 */     GIR_EraseRootFromParent_Done,
     /* 1860541 */   // Label 25154: @1860541
     /* 1860541 */   GIM_Try, /*On fail goto*//*Label 25155*/ GIMT_Encode4(1860627), // Rule ID 13780 //
     /* 1860546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1860557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1860560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1860566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860592 */     // MIs[0] policy
     /* 1860592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860602 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860626 */     // GIR_Coverage, 13780,
     /* 1860626 */     GIR_EraseRootFromParent_Done,
     /* 1860627 */   // Label 25155: @1860627
     /* 1860627 */   GIM_Try, /*On fail goto*//*Label 25156*/ GIMT_Encode4(1860713), // Rule ID 13781 //
     /* 1860632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1860643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1860646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1860652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860678 */     // MIs[0] policy
     /* 1860678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860688 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11650:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1860691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860712 */     // GIR_Coverage, 13781,
     /* 1860712 */     GIR_EraseRootFromParent_Done,
     /* 1860713 */   // Label 25156: @1860713
     /* 1860713 */   GIM_Try, /*On fail goto*//*Label 25157*/ GIMT_Encode4(1860799), // Rule ID 13784 //
     /* 1860718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1860721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1860729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1860732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1860738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860764 */     // MIs[0] policy
     /* 1860764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860774 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860798 */     // GIR_Coverage, 13784,
     /* 1860798 */     GIR_EraseRootFromParent_Done,
     /* 1860799 */   // Label 25157: @1860799
     /* 1860799 */   GIM_Try, /*On fail goto*//*Label 25158*/ GIMT_Encode4(1860885), // Rule ID 13785 //
     /* 1860804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1860807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1860812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1860815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1860818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1860824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860850 */     // MIs[0] policy
     /* 1860850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860860 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11650:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1860863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860884 */     // GIR_Coverage, 13785,
     /* 1860884 */     GIR_EraseRootFromParent_Done,
     /* 1860885 */   // Label 25158: @1860885
     /* 1860885 */   GIM_Try, /*On fail goto*//*Label 25159*/ GIMT_Encode4(1860971), // Rule ID 13788 //
     /* 1860890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1860901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1860904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1860907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1860910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860936 */     // MIs[0] policy
     /* 1860936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1860949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1860953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860970 */     // GIR_Coverage, 13788,
     /* 1860970 */     GIR_EraseRootFromParent_Done,
     /* 1860971 */   // Label 25159: @1860971
     /* 1860971 */   GIM_Try, /*On fail goto*//*Label 25160*/ GIMT_Encode4(1861057), // Rule ID 13789 //
     /* 1860976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1860984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1860987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1860990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1860993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1860996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861022 */     // MIs[0] policy
     /* 1861022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861032 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1861035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861056 */     // GIR_Coverage, 13789,
     /* 1861056 */     GIR_EraseRootFromParent_Done,
     /* 1861057 */   // Label 25160: @1861057
     /* 1861057 */   GIM_Try, /*On fail goto*//*Label 25161*/ GIMT_Encode4(1861143), // Rule ID 13792 //
     /* 1861062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861108 */     // MIs[0] policy
     /* 1861108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861118 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861142 */     // GIR_Coverage, 13792,
     /* 1861142 */     GIR_EraseRootFromParent_Done,
     /* 1861143 */   // Label 25161: @1861143
     /* 1861143 */   GIM_Try, /*On fail goto*//*Label 25162*/ GIMT_Encode4(1861229), // Rule ID 13793 //
     /* 1861148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1861168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861194 */     // MIs[0] policy
     /* 1861194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861204 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861228 */     // GIR_Coverage, 13793,
     /* 1861228 */     GIR_EraseRootFromParent_Done,
     /* 1861229 */   // Label 25162: @1861229
     /* 1861229 */   GIM_Try, /*On fail goto*//*Label 25163*/ GIMT_Encode4(1861315), // Rule ID 13796 //
     /* 1861234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861280 */     // MIs[0] policy
     /* 1861280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861290 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1861293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861314 */     // GIR_Coverage, 13796,
     /* 1861314 */     GIR_EraseRootFromParent_Done,
     /* 1861315 */   // Label 25163: @1861315
     /* 1861315 */   GIM_Try, /*On fail goto*//*Label 25164*/ GIMT_Encode4(1861401), // Rule ID 13797 //
     /* 1861320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1861331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1861334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1861340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861366 */     // MIs[0] policy
     /* 1861366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861376 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11654:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1861379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861400 */     // GIR_Coverage, 13797,
     /* 1861400 */     GIR_EraseRootFromParent_Done,
     /* 1861401 */   // Label 25164: @1861401
     /* 1861401 */   GIM_Try, /*On fail goto*//*Label 25165*/ GIMT_Encode4(1861487), // Rule ID 13800 //
     /* 1861406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1861426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861452 */     // MIs[0] policy
     /* 1861452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1861465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861486 */     // GIR_Coverage, 13800,
     /* 1861486 */     GIR_EraseRootFromParent_Done,
     /* 1861487 */   // Label 25165: @1861487
     /* 1861487 */   GIM_Try, /*On fail goto*//*Label 25166*/ GIMT_Encode4(1861573), // Rule ID 13801 //
     /* 1861492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1861503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1861506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1861512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1861522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861538 */     // MIs[0] policy
     /* 1861538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1861551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861572 */     // GIR_Coverage, 13801,
     /* 1861572 */     GIR_EraseRootFromParent_Done,
     /* 1861573 */   // Label 25166: @1861573
     /* 1861573 */   GIM_Try, /*On fail goto*//*Label 25167*/ GIMT_Encode4(1861659), // Rule ID 13804 //
     /* 1861578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1861589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1861592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1861598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1861601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861624 */     // MIs[0] policy
     /* 1861624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1861637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861658 */     // GIR_Coverage, 13804,
     /* 1861658 */     GIR_EraseRootFromParent_Done,
     /* 1861659 */   // Label 25167: @1861659
     /* 1861659 */   GIM_Try, /*On fail goto*//*Label 25168*/ GIMT_Encode4(1861745), // Rule ID 13805 //
     /* 1861664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1861675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1861678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1861684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1861687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1861694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1861706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861710 */     // MIs[0] policy
     /* 1861710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861720 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1861723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861744 */     // GIR_Coverage, 13805,
     /* 1861744 */     GIR_EraseRootFromParent_Done,
     /* 1861745 */   // Label 25168: @1861745
     /* 1861745 */   GIM_Try, /*On fail goto*//*Label 25169*/ GIMT_Encode4(1861831), // Rule ID 13808 //
     /* 1861750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1861761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1861764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1861770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1861773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861796 */     // MIs[0] policy
     /* 1861796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861806 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1861809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861830 */     // GIR_Coverage, 13808,
     /* 1861830 */     GIR_EraseRootFromParent_Done,
     /* 1861831 */   // Label 25169: @1861831
     /* 1861831 */   GIM_Try, /*On fail goto*//*Label 25170*/ GIMT_Encode4(1861917), // Rule ID 13809 //
     /* 1861836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1861847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1861850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1861853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1861856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1861859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1861866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1861870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1861878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861882 */     // MIs[0] policy
     /* 1861882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861892 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1861895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861916 */     // GIR_Coverage, 13809,
     /* 1861916 */     GIR_EraseRootFromParent_Done,
     /* 1861917 */   // Label 25170: @1861917
     /* 1861917 */   GIM_Try, /*On fail goto*//*Label 25171*/ GIMT_Encode4(1862003), // Rule ID 13812 //
     /* 1861922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1861930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1861933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1861936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1861939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1861942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861968 */     // MIs[0] policy
     /* 1861968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861978 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1861981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1861985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862002 */     // GIR_Coverage, 13812,
     /* 1862002 */     GIR_EraseRootFromParent_Done,
     /* 1862003 */   // Label 25171: @1862003
     /* 1862003 */   GIM_Try, /*On fail goto*//*Label 25172*/ GIMT_Encode4(1862089), // Rule ID 13813 //
     /* 1862008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1862019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1862022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1862028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862054 */     // MIs[0] policy
     /* 1862054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862064 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1862067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862088 */     // GIR_Coverage, 13813,
     /* 1862088 */     GIR_EraseRootFromParent_Done,
     /* 1862089 */   // Label 25172: @1862089
     /* 1862089 */   GIM_Try, /*On fail goto*//*Label 25173*/ GIMT_Encode4(1862175), // Rule ID 13816 //
     /* 1862094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862140 */     // MIs[0] policy
     /* 1862140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862174 */     // GIR_Coverage, 13816,
     /* 1862174 */     GIR_EraseRootFromParent_Done,
     /* 1862175 */   // Label 25173: @1862175
     /* 1862175 */   GIM_Try, /*On fail goto*//*Label 25174*/ GIMT_Encode4(1862261), // Rule ID 13817 //
     /* 1862180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1862200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862226 */     // MIs[0] policy
     /* 1862226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862236 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11654:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862260 */     // GIR_Coverage, 13817,
     /* 1862260 */     GIR_EraseRootFromParent_Done,
     /* 1862261 */   // Label 25174: @1862261
     /* 1862261 */   GIM_Try, /*On fail goto*//*Label 25175*/ GIMT_Encode4(1862347), // Rule ID 13820 //
     /* 1862266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1862277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1862280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862312 */     // MIs[0] policy
     /* 1862312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862346 */     // GIR_Coverage, 13820,
     /* 1862346 */     GIR_EraseRootFromParent_Done,
     /* 1862347 */   // Label 25175: @1862347
     /* 1862347 */   GIM_Try, /*On fail goto*//*Label 25176*/ GIMT_Encode4(1862433), // Rule ID 13821 //
     /* 1862352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1862363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1862366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1862372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862398 */     // MIs[0] policy
     /* 1862398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1862411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862432 */     // GIR_Coverage, 13821,
     /* 1862432 */     GIR_EraseRootFromParent_Done,
     /* 1862433 */   // Label 25176: @1862433
     /* 1862433 */   GIM_Try, /*On fail goto*//*Label 25177*/ GIMT_Encode4(1862519), // Rule ID 13824 //
     /* 1862438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1862449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1862452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1862458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862484 */     // MIs[0] policy
     /* 1862484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862518 */     // GIR_Coverage, 13824,
     /* 1862518 */     GIR_EraseRootFromParent_Done,
     /* 1862519 */   // Label 25177: @1862519
     /* 1862519 */   GIM_Try, /*On fail goto*//*Label 25178*/ GIMT_Encode4(1862605), // Rule ID 13825 //
     /* 1862524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1862535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1862538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1862544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1862547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862570 */     // MIs[0] policy
     /* 1862570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862580 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1862583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862604 */     // GIR_Coverage, 13825,
     /* 1862604 */     GIR_EraseRootFromParent_Done,
     /* 1862605 */   // Label 25178: @1862605
     /* 1862605 */   GIM_Try, /*On fail goto*//*Label 25179*/ GIMT_Encode4(1862691), // Rule ID 13828 //
     /* 1862610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1862621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1862624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1862630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862656 */     // MIs[0] policy
     /* 1862656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1862669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862690 */     // GIR_Coverage, 13828,
     /* 1862690 */     GIR_EraseRootFromParent_Done,
     /* 1862691 */   // Label 25179: @1862691
     /* 1862691 */   GIM_Try, /*On fail goto*//*Label 25180*/ GIMT_Encode4(1862777), // Rule ID 13829 //
     /* 1862696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1862707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1862710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1862716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862742 */     // MIs[0] policy
     /* 1862742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862752 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1862755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862776 */     // GIR_Coverage, 13829,
     /* 1862776 */     GIR_EraseRootFromParent_Done,
     /* 1862777 */   // Label 25180: @1862777
     /* 1862777 */   GIM_Try, /*On fail goto*//*Label 25181*/ GIMT_Encode4(1862863), // Rule ID 13832 //
     /* 1862782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1862785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1862802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862828 */     // MIs[0] policy
     /* 1862828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862838 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862862 */     // GIR_Coverage, 13832,
     /* 1862862 */     GIR_EraseRootFromParent_Done,
     /* 1862863 */   // Label 25181: @1862863
     /* 1862863 */   GIM_Try, /*On fail goto*//*Label 25182*/ GIMT_Encode4(1862949), // Rule ID 13833 //
     /* 1862868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1862871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1862885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1862888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862914 */     // MIs[0] policy
     /* 1862914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11654:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1862927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1862931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862948 */     // GIR_Coverage, 13833,
     /* 1862948 */     GIR_EraseRootFromParent_Done,
     /* 1862949 */   // Label 25182: @1862949
     /* 1862949 */   GIM_Try, /*On fail goto*//*Label 25183*/ GIMT_Encode4(1863035), // Rule ID 13836 //
     /* 1862954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1862957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1862962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1862965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1862968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1862971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1862974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863000 */     // MIs[0] policy
     /* 1863000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1863013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863034 */     // GIR_Coverage, 13836,
     /* 1863034 */     GIR_EraseRootFromParent_Done,
     /* 1863035 */   // Label 25183: @1863035
     /* 1863035 */   GIM_Try, /*On fail goto*//*Label 25184*/ GIMT_Encode4(1863121), // Rule ID 13837 //
     /* 1863040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1863051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1863054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1863060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863086 */     // MIs[0] policy
     /* 1863086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863096 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11654:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1863099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863120 */     // GIR_Coverage, 13837,
     /* 1863120 */     GIR_EraseRootFromParent_Done,
     /* 1863121 */   // Label 25184: @1863121
     /* 1863121 */   GIM_Try, /*On fail goto*//*Label 25185*/ GIMT_Encode4(1863207), // Rule ID 13840 //
     /* 1863126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1863137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1863140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1863146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863172 */     // MIs[0] policy
     /* 1863172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863182 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863206 */     // GIR_Coverage, 13840,
     /* 1863206 */     GIR_EraseRootFromParent_Done,
     /* 1863207 */   // Label 25185: @1863207
     /* 1863207 */   GIM_Try, /*On fail goto*//*Label 25186*/ GIMT_Encode4(1863293), // Rule ID 13841 //
     /* 1863212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1863223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1863226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1863232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863258 */     // MIs[0] policy
     /* 1863258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863268 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11654:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1863271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863292 */     // GIR_Coverage, 13841,
     /* 1863292 */     GIR_EraseRootFromParent_Done,
     /* 1863293 */   // Label 25186: @1863293
     /* 1863293 */   GIM_Try, /*On fail goto*//*Label 25187*/ GIMT_Encode4(1863379), // Rule ID 13844 //
     /* 1863298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1863301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1863309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1863312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1863315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1863318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863344 */     // MIs[0] policy
     /* 1863344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863354 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863378 */     // GIR_Coverage, 13844,
     /* 1863378 */     GIR_EraseRootFromParent_Done,
     /* 1863379 */   // Label 25187: @1863379
     /* 1863379 */   GIM_Try, /*On fail goto*//*Label 25188*/ GIMT_Encode4(1863465), // Rule ID 13845 //
     /* 1863384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1863387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1863392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1863395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1863398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1863401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1863404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863430 */     // MIs[0] policy
     /* 1863430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863440 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11654:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1863443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1863447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863464 */     // GIR_Coverage, 13845,
     /* 1863464 */     GIR_EraseRootFromParent_Done,
     /* 1863465 */   // Label 25188: @1863465
     /* 1863465 */   GIM_Try, /*On fail goto*//*Label 25189*/ GIMT_Encode4(1863554), // Rule ID 14054 //
     /* 1863470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1863481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1863484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1863487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1863490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863516 */     // MIs[0] policy
     /* 1863516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863526 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1863529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863553 */     // GIR_Coverage, 14054,
     /* 1863553 */     GIR_EraseRootFromParent_Done,
     /* 1863554 */   // Label 25189: @1863554
     /* 1863554 */   GIM_Try, /*On fail goto*//*Label 25190*/ GIMT_Encode4(1863643), // Rule ID 14055 //
     /* 1863559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1863570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1863573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1863576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1863579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1863582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863605 */     // MIs[0] policy
     /* 1863605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863615 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1863618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863642 */     // GIR_Coverage, 14055,
     /* 1863642 */     GIR_EraseRootFromParent_Done,
     /* 1863643 */   // Label 25190: @1863643
     /* 1863643 */   GIM_Try, /*On fail goto*//*Label 25191*/ GIMT_Encode4(1863732), // Rule ID 14058 //
     /* 1863648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1863659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1863662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1863665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1863668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863694 */     // MIs[0] policy
     /* 1863694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863704 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1863707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863731 */     // GIR_Coverage, 14058,
     /* 1863731 */     GIR_EraseRootFromParent_Done,
     /* 1863732 */   // Label 25191: @1863732
     /* 1863732 */   GIM_Try, /*On fail goto*//*Label 25192*/ GIMT_Encode4(1863821), // Rule ID 14059 //
     /* 1863737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1863748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1863751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1863754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1863757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1863760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863783 */     // MIs[0] policy
     /* 1863783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863793 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1863796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863820 */     // GIR_Coverage, 14059,
     /* 1863820 */     GIR_EraseRootFromParent_Done,
     /* 1863821 */   // Label 25192: @1863821
     /* 1863821 */   GIM_Try, /*On fail goto*//*Label 25193*/ GIMT_Encode4(1863910), // Rule ID 14062 //
     /* 1863826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1863837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1863840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1863843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1863846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863872 */     // MIs[0] policy
     /* 1863872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863882 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1863885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863909 */     // GIR_Coverage, 14062,
     /* 1863909 */     GIR_EraseRootFromParent_Done,
     /* 1863910 */   // Label 25193: @1863910
     /* 1863910 */   GIM_Try, /*On fail goto*//*Label 25194*/ GIMT_Encode4(1863999), // Rule ID 14063 //
     /* 1863915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1863926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1863929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1863932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1863935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1863945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1863957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863961 */     // MIs[0] policy
     /* 1863961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863971 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1863974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863998 */     // GIR_Coverage, 14063,
     /* 1863998 */     GIR_EraseRootFromParent_Done,
     /* 1863999 */   // Label 25194: @1863999
     /* 1863999 */   GIM_Try, /*On fail goto*//*Label 25195*/ GIMT_Encode4(1864088), // Rule ID 14066 //
     /* 1864004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1864021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1864024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864050 */     // MIs[0] policy
     /* 1864050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864060 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864087 */     // GIR_Coverage, 14066,
     /* 1864087 */     GIR_EraseRootFromParent_Done,
     /* 1864088 */   // Label 25195: @1864088
     /* 1864088 */   GIM_Try, /*On fail goto*//*Label 25196*/ GIMT_Encode4(1864177), // Rule ID 14067 //
     /* 1864093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1864104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1864107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1864110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1864113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864139 */     // MIs[0] policy
     /* 1864139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864149 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1864152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864176 */     // GIR_Coverage, 14067,
     /* 1864176 */     GIR_EraseRootFromParent_Done,
     /* 1864177 */   // Label 25196: @1864177
     /* 1864177 */   GIM_Try, /*On fail goto*//*Label 25197*/ GIMT_Encode4(1864266), // Rule ID 14070 //
     /* 1864182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1864199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864228 */     // MIs[0] policy
     /* 1864228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864238 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864265 */     // GIR_Coverage, 14070,
     /* 1864265 */     GIR_EraseRootFromParent_Done,
     /* 1864266 */   // Label 25197: @1864266
     /* 1864266 */   GIM_Try, /*On fail goto*//*Label 25198*/ GIMT_Encode4(1864355), // Rule ID 14071 //
     /* 1864271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1864282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1864285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1864288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1864291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864317 */     // MIs[0] policy
     /* 1864317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864327 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864354 */     // GIR_Coverage, 14071,
     /* 1864354 */     GIR_EraseRootFromParent_Done,
     /* 1864355 */   // Label 25198: @1864355
     /* 1864355 */   GIM_Try, /*On fail goto*//*Label 25199*/ GIMT_Encode4(1864444), // Rule ID 14074 //
     /* 1864360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1864371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1864374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1864377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864406 */     // MIs[0] policy
     /* 1864406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864443 */     // GIR_Coverage, 14074,
     /* 1864443 */     GIR_EraseRootFromParent_Done,
     /* 1864444 */   // Label 25199: @1864444
     /* 1864444 */   GIM_Try, /*On fail goto*//*Label 25200*/ GIMT_Encode4(1864533), // Rule ID 14075 //
     /* 1864449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1864460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1864463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1864466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1864469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864495 */     // MIs[0] policy
     /* 1864495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864505 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1864508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864532 */     // GIR_Coverage, 14075,
     /* 1864532 */     GIR_EraseRootFromParent_Done,
     /* 1864533 */   // Label 25200: @1864533
     /* 1864533 */   GIM_Try, /*On fail goto*//*Label 25201*/ GIMT_Encode4(1864622), // Rule ID 14078 //
     /* 1864538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1864549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1864552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1864555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1864558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864584 */     // MIs[0] policy
     /* 1864584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864621 */     // GIR_Coverage, 14078,
     /* 1864621 */     GIR_EraseRootFromParent_Done,
     /* 1864622 */   // Label 25201: @1864622
     /* 1864622 */   GIM_Try, /*On fail goto*//*Label 25202*/ GIMT_Encode4(1864711), // Rule ID 14079 //
     /* 1864627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1864638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1864641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1864644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1864647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864673 */     // MIs[0] policy
     /* 1864673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864683 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864710 */     // GIR_Coverage, 14079,
     /* 1864710 */     GIR_EraseRootFromParent_Done,
     /* 1864711 */   // Label 25202: @1864711
     /* 1864711 */   GIM_Try, /*On fail goto*//*Label 25203*/ GIMT_Encode4(1864800), // Rule ID 14082 //
     /* 1864716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1864727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1864730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1864733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1864736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864762 */     // MIs[0] policy
     /* 1864762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864772 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864799 */     // GIR_Coverage, 14082,
     /* 1864799 */     GIR_EraseRootFromParent_Done,
     /* 1864800 */   // Label 25203: @1864800
     /* 1864800 */   GIM_Try, /*On fail goto*//*Label 25204*/ GIMT_Encode4(1864889), // Rule ID 14083 //
     /* 1864805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1864816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1864819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1864822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1864825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864851 */     // MIs[0] policy
     /* 1864851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864861 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1864882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864888 */     // GIR_Coverage, 14083,
     /* 1864888 */     GIR_EraseRootFromParent_Done,
     /* 1864889 */   // Label 25204: @1864889
     /* 1864889 */   GIM_Try, /*On fail goto*//*Label 25205*/ GIMT_Encode4(1864978), // Rule ID 14086 //
     /* 1864894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1864905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1864908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1864911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1864914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864940 */     // MIs[0] policy
     /* 1864940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1864953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864977 */     // GIR_Coverage, 14086,
     /* 1864977 */     GIR_EraseRootFromParent_Done,
     /* 1864978 */   // Label 25205: @1864978
     /* 1864978 */   GIM_Try, /*On fail goto*//*Label 25206*/ GIMT_Encode4(1865067), // Rule ID 14087 //
     /* 1864983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1864994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1864997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1865000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1865003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865029 */     // MIs[0] policy
     /* 1865029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865039 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1865060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865066 */     // GIR_Coverage, 14087,
     /* 1865066 */     GIR_EraseRootFromParent_Done,
     /* 1865067 */   // Label 25206: @1865067
     /* 1865067 */   GIM_Try, /*On fail goto*//*Label 25207*/ GIMT_Encode4(1865156), // Rule ID 14090 //
     /* 1865072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1865075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1865083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1865086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1865089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1865092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865118 */     // MIs[0] policy
     /* 1865118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865128 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865155 */     // GIR_Coverage, 14090,
     /* 1865155 */     GIR_EraseRootFromParent_Done,
     /* 1865156 */   // Label 25207: @1865156
     /* 1865156 */   GIM_Try, /*On fail goto*//*Label 25208*/ GIMT_Encode4(1865245), // Rule ID 14091 //
     /* 1865161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1865164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1865172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1865175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1865178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1865181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865207 */     // MIs[0] policy
     /* 1865207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865217 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1865220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1865238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865244 */     // GIR_Coverage, 14091,
     /* 1865244 */     GIR_EraseRootFromParent_Done,
     /* 1865245 */   // Label 25208: @1865245
     /* 1865245 */   GIM_Try, /*On fail goto*//*Label 25209*/ GIMT_Encode4(1865334), // Rule ID 14094 //
     /* 1865250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1865261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1865264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865296 */     // MIs[0] policy
     /* 1865296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865306 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865333 */     // GIR_Coverage, 14094,
     /* 1865333 */     GIR_EraseRootFromParent_Done,
     /* 1865334 */   // Label 25209: @1865334
     /* 1865334 */   GIM_Try, /*On fail goto*//*Label 25210*/ GIMT_Encode4(1865423), // Rule ID 14095 //
     /* 1865339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1865350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1865353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1865356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1865359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865385 */     // MIs[0] policy
     /* 1865385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865395 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865422 */     // GIR_Coverage, 14095,
     /* 1865422 */     GIR_EraseRootFromParent_Done,
     /* 1865423 */   // Label 25210: @1865423
     /* 1865423 */   GIM_Try, /*On fail goto*//*Label 25211*/ GIMT_Encode4(1865512), // Rule ID 14098 //
     /* 1865428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1865439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1865442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1865445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865474 */     // MIs[0] policy
     /* 1865474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865484 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1865487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865511 */     // GIR_Coverage, 14098,
     /* 1865511 */     GIR_EraseRootFromParent_Done,
     /* 1865512 */   // Label 25211: @1865512
     /* 1865512 */   GIM_Try, /*On fail goto*//*Label 25212*/ GIMT_Encode4(1865601), // Rule ID 14099 //
     /* 1865517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1865528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1865531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1865534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1865537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1865540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865563 */     // MIs[0] policy
     /* 1865563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865573 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1865576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865600 */     // GIR_Coverage, 14099,
     /* 1865600 */     GIR_EraseRootFromParent_Done,
     /* 1865601 */   // Label 25212: @1865601
     /* 1865601 */   GIM_Try, /*On fail goto*//*Label 25213*/ GIMT_Encode4(1865690), // Rule ID 14102 //
     /* 1865606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1865617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1865620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1865623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1865626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1865629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865652 */     // MIs[0] policy
     /* 1865652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865662 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1865665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865689 */     // GIR_Coverage, 14102,
     /* 1865689 */     GIR_EraseRootFromParent_Done,
     /* 1865690 */   // Label 25213: @1865690
     /* 1865690 */   GIM_Try, /*On fail goto*//*Label 25214*/ GIMT_Encode4(1865779), // Rule ID 14103 //
     /* 1865695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1865706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1865709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1865712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1865715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1865718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1865725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1865737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865741 */     // MIs[0] policy
     /* 1865741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865751 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1865754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865778 */     // GIR_Coverage, 14103,
     /* 1865778 */     GIR_EraseRootFromParent_Done,
     /* 1865779 */   // Label 25214: @1865779
     /* 1865779 */   GIM_Try, /*On fail goto*//*Label 25215*/ GIMT_Encode4(1865868), // Rule ID 14106 //
     /* 1865784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1865795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1865798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1865801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1865804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865830 */     // MIs[0] policy
     /* 1865830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865840 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865867 */     // GIR_Coverage, 14106,
     /* 1865867 */     GIR_EraseRootFromParent_Done,
     /* 1865868 */   // Label 25215: @1865868
     /* 1865868 */   GIM_Try, /*On fail goto*//*Label 25216*/ GIMT_Encode4(1865957), // Rule ID 14107 //
     /* 1865873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1865884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1865887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1865890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1865893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1865903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1865915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865919 */     // MIs[0] policy
     /* 1865919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1865932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865956 */     // GIR_Coverage, 14107,
     /* 1865956 */     GIR_EraseRootFromParent_Done,
     /* 1865957 */   // Label 25216: @1865957
     /* 1865957 */   GIM_Try, /*On fail goto*//*Label 25217*/ GIMT_Encode4(1866046), // Rule ID 14110 //
     /* 1865962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1865970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1865973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1865976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1865979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1865982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1865985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1865992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1865996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866008 */     // MIs[0] policy
     /* 1866008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866045 */     // GIR_Coverage, 14110,
     /* 1866045 */     GIR_EraseRootFromParent_Done,
     /* 1866046 */   // Label 25217: @1866046
     /* 1866046 */   GIM_Try, /*On fail goto*//*Label 25218*/ GIMT_Encode4(1866135), // Rule ID 14111 //
     /* 1866051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1866062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1866065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1866068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1866071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866097 */     // MIs[0] policy
     /* 1866097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866107 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866134 */     // GIR_Coverage, 14111,
     /* 1866134 */     GIR_EraseRootFromParent_Done,
     /* 1866135 */   // Label 25218: @1866135
     /* 1866135 */   GIM_Try, /*On fail goto*//*Label 25219*/ GIMT_Encode4(1866224), // Rule ID 14114 //
     /* 1866140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1866151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1866154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1866157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1866160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866186 */     // MIs[0] policy
     /* 1866186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866196 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866223 */     // GIR_Coverage, 14114,
     /* 1866223 */     GIR_EraseRootFromParent_Done,
     /* 1866224 */   // Label 25219: @1866224
     /* 1866224 */   GIM_Try, /*On fail goto*//*Label 25220*/ GIMT_Encode4(1866313), // Rule ID 14115 //
     /* 1866229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1866240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1866243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1866246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1866249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866275 */     // MIs[0] policy
     /* 1866275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866285 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866312 */     // GIR_Coverage, 14115,
     /* 1866312 */     GIR_EraseRootFromParent_Done,
     /* 1866313 */   // Label 25220: @1866313
     /* 1866313 */   GIM_Try, /*On fail goto*//*Label 25221*/ GIMT_Encode4(1866402), // Rule ID 14118 //
     /* 1866318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866364 */     // MIs[0] policy
     /* 1866364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866401 */     // GIR_Coverage, 14118,
     /* 1866401 */     GIR_EraseRootFromParent_Done,
     /* 1866402 */   // Label 25221: @1866402
     /* 1866402 */   GIM_Try, /*On fail goto*//*Label 25222*/ GIMT_Encode4(1866491), // Rule ID 14119 //
     /* 1866407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1866418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1866421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1866424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1866427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866453 */     // MIs[0] policy
     /* 1866453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866490 */     // GIR_Coverage, 14119,
     /* 1866490 */     GIR_EraseRootFromParent_Done,
     /* 1866491 */   // Label 25222: @1866491
     /* 1866491 */   GIM_Try, /*On fail goto*//*Label 25223*/ GIMT_Encode4(1866580), // Rule ID 14122 //
     /* 1866496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1866513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1866516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866542 */     // MIs[0] policy
     /* 1866542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866552 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866579 */     // GIR_Coverage, 14122,
     /* 1866579 */     GIR_EraseRootFromParent_Done,
     /* 1866580 */   // Label 25223: @1866580
     /* 1866580 */   GIM_Try, /*On fail goto*//*Label 25224*/ GIMT_Encode4(1866669), // Rule ID 14123 //
     /* 1866585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1866596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1866599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1866602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1866605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1866608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866631 */     // MIs[0] policy
     /* 1866631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866641 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1866644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866668 */     // GIR_Coverage, 14123,
     /* 1866668 */     GIR_EraseRootFromParent_Done,
     /* 1866669 */   // Label 25224: @1866669
     /* 1866669 */   GIM_Try, /*On fail goto*//*Label 25225*/ GIMT_Encode4(1866758), // Rule ID 14126 //
     /* 1866674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1866685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1866688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1866691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1866694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866720 */     // MIs[0] policy
     /* 1866720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866730 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866757 */     // GIR_Coverage, 14126,
     /* 1866757 */     GIR_EraseRootFromParent_Done,
     /* 1866758 */   // Label 25225: @1866758
     /* 1866758 */   GIM_Try, /*On fail goto*//*Label 25226*/ GIMT_Encode4(1866847), // Rule ID 14127 //
     /* 1866763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1866774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1866777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1866780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1866783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866809 */     // MIs[0] policy
     /* 1866809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866819 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1866822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866846 */     // GIR_Coverage, 14127,
     /* 1866846 */     GIR_EraseRootFromParent_Done,
     /* 1866847 */   // Label 25226: @1866847
     /* 1866847 */   GIM_Try, /*On fail goto*//*Label 25227*/ GIMT_Encode4(1866936), // Rule ID 14130 //
     /* 1866852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1866855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1866863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1866866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1866869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1866872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866898 */     // MIs[0] policy
     /* 1866898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1866911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1866929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866935 */     // GIR_Coverage, 14130,
     /* 1866935 */     GIR_EraseRootFromParent_Done,
     /* 1866936 */   // Label 25227: @1866936
     /* 1866936 */   GIM_Try, /*On fail goto*//*Label 25228*/ GIMT_Encode4(1867025), // Rule ID 14131 //
     /* 1866941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1866944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1866949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1866952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1866955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1866958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1866961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866987 */     // MIs[0] policy
     /* 1866987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1867000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867024 */     // GIR_Coverage, 14131,
     /* 1867024 */     GIR_EraseRootFromParent_Done,
     /* 1867025 */   // Label 25228: @1867025
     /* 1867025 */   GIM_Try, /*On fail goto*//*Label 25229*/ GIMT_Encode4(1867114), // Rule ID 14134 //
     /* 1867030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1867041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1867044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1867047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1867050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867076 */     // MIs[0] policy
     /* 1867076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867086 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867113 */     // GIR_Coverage, 14134,
     /* 1867113 */     GIR_EraseRootFromParent_Done,
     /* 1867114 */   // Label 25229: @1867114
     /* 1867114 */   GIM_Try, /*On fail goto*//*Label 25230*/ GIMT_Encode4(1867203), // Rule ID 14135 //
     /* 1867119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1867130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1867133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1867136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1867139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867165 */     // MIs[0] policy
     /* 1867165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867175 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1867178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867202 */     // GIR_Coverage, 14135,
     /* 1867202 */     GIR_EraseRootFromParent_Done,
     /* 1867203 */   // Label 25230: @1867203
     /* 1867203 */   GIM_Try, /*On fail goto*//*Label 25231*/ GIMT_Encode4(1867292), // Rule ID 14138 //
     /* 1867208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1867211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1867225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1867228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867254 */     // MIs[0] policy
     /* 1867254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867264 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867291 */     // GIR_Coverage, 14138,
     /* 1867291 */     GIR_EraseRootFromParent_Done,
     /* 1867292 */   // Label 25231: @1867292
     /* 1867292 */   GIM_Try, /*On fail goto*//*Label 25232*/ GIMT_Encode4(1867381), // Rule ID 14139 //
     /* 1867297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1867300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1867308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1867311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1867314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1867317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867343 */     // MIs[0] policy
     /* 1867343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867353 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1867356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1867374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867380 */     // GIR_Coverage, 14139,
     /* 1867380 */     GIR_EraseRootFromParent_Done,
     /* 1867381 */   // Label 25232: @1867381
     /* 1867381 */   GIM_Try, /*On fail goto*//*Label 25233*/ GIMT_Encode4(1867470), // Rule ID 14142 //
     /* 1867386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867432 */     // MIs[0] policy
     /* 1867432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1867445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867469 */     // GIR_Coverage, 14142,
     /* 1867469 */     GIR_EraseRootFromParent_Done,
     /* 1867470 */   // Label 25233: @1867470
     /* 1867470 */   GIM_Try, /*On fail goto*//*Label 25234*/ GIMT_Encode4(1867559), // Rule ID 14143 //
     /* 1867475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1867486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1867489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1867492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867521 */     // MIs[0] policy
     /* 1867521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867531 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1867534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867558 */     // GIR_Coverage, 14143,
     /* 1867558 */     GIR_EraseRootFromParent_Done,
     /* 1867559 */   // Label 25234: @1867559
     /* 1867559 */   GIM_Try, /*On fail goto*//*Label 25235*/ GIMT_Encode4(1867648), // Rule ID 14146 //
     /* 1867564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1867575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1867578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1867581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867610 */     // MIs[0] policy
     /* 1867610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867620 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1867623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867647 */     // GIR_Coverage, 14146,
     /* 1867647 */     GIR_EraseRootFromParent_Done,
     /* 1867648 */   // Label 25235: @1867648
     /* 1867648 */   GIM_Try, /*On fail goto*//*Label 25236*/ GIMT_Encode4(1867737), // Rule ID 14147 //
     /* 1867653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1867664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1867667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1867670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1867676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867699 */     // MIs[0] policy
     /* 1867699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867709 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1867712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867736 */     // GIR_Coverage, 14147,
     /* 1867736 */     GIR_EraseRootFromParent_Done,
     /* 1867737 */   // Label 25236: @1867737
     /* 1867737 */   GIM_Try, /*On fail goto*//*Label 25237*/ GIMT_Encode4(1867826), // Rule ID 14150 //
     /* 1867742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1867753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1867756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1867759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867788 */     // MIs[0] policy
     /* 1867788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867798 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1867801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867825 */     // GIR_Coverage, 14150,
     /* 1867825 */     GIR_EraseRootFromParent_Done,
     /* 1867826 */   // Label 25237: @1867826
     /* 1867826 */   GIM_Try, /*On fail goto*//*Label 25238*/ GIMT_Encode4(1867915), // Rule ID 14151 //
     /* 1867831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1867842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1867845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1867848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1867851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867877 */     // MIs[0] policy
     /* 1867877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867887 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1867890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867914 */     // GIR_Coverage, 14151,
     /* 1867914 */     GIR_EraseRootFromParent_Done,
     /* 1867915 */   // Label 25238: @1867915
     /* 1867915 */   GIM_Try, /*On fail goto*//*Label 25239*/ GIMT_Encode4(1868004), // Rule ID 14154 //
     /* 1867920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1867928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1867931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1867934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1867937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1867940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1867943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1867950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1867958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1867962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867966 */     // MIs[0] policy
     /* 1867966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1867979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868003 */     // GIR_Coverage, 14154,
     /* 1868003 */     GIR_EraseRootFromParent_Done,
     /* 1868004 */   // Label 25239: @1868004
     /* 1868004 */   GIM_Try, /*On fail goto*//*Label 25240*/ GIMT_Encode4(1868093), // Rule ID 14155 //
     /* 1868009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1868020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1868023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1868026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868055 */     // MIs[0] policy
     /* 1868055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868065 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1868068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868092 */     // GIR_Coverage, 14155,
     /* 1868092 */     GIR_EraseRootFromParent_Done,
     /* 1868093 */   // Label 25240: @1868093
     /* 1868093 */   GIM_Try, /*On fail goto*//*Label 25241*/ GIMT_Encode4(1868182), // Rule ID 14158 //
     /* 1868098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868144 */     // MIs[0] policy
     /* 1868144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868181 */     // GIR_Coverage, 14158,
     /* 1868181 */     GIR_EraseRootFromParent_Done,
     /* 1868182 */   // Label 25241: @1868182
     /* 1868182 */   GIM_Try, /*On fail goto*//*Label 25242*/ GIMT_Encode4(1868271), // Rule ID 14159 //
     /* 1868187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1868198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1868201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1868204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868233 */     // MIs[0] policy
     /* 1868233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868243 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868270 */     // GIR_Coverage, 14159,
     /* 1868270 */     GIR_EraseRootFromParent_Done,
     /* 1868271 */   // Label 25242: @1868271
     /* 1868271 */   GIM_Try, /*On fail goto*//*Label 25243*/ GIMT_Encode4(1868360), // Rule ID 14162 //
     /* 1868276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868322 */     // MIs[0] policy
     /* 1868322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868332 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868359 */     // GIR_Coverage, 14162,
     /* 1868359 */     GIR_EraseRootFromParent_Done,
     /* 1868360 */   // Label 25243: @1868360
     /* 1868360 */   GIM_Try, /*On fail goto*//*Label 25244*/ GIMT_Encode4(1868449), // Rule ID 14163 //
     /* 1868365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1868376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1868379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1868382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868411 */     // MIs[0] policy
     /* 1868411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868421 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1868424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868448 */     // GIR_Coverage, 14163,
     /* 1868448 */     GIR_EraseRootFromParent_Done,
     /* 1868449 */   // Label 25244: @1868449
     /* 1868449 */   GIM_Try, /*On fail goto*//*Label 25245*/ GIMT_Encode4(1868538), // Rule ID 14166 //
     /* 1868454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1868465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1868468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1868471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868500 */     // MIs[0] policy
     /* 1868500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868537 */     // GIR_Coverage, 14166,
     /* 1868537 */     GIR_EraseRootFromParent_Done,
     /* 1868538 */   // Label 25245: @1868538
     /* 1868538 */   GIM_Try, /*On fail goto*//*Label 25246*/ GIMT_Encode4(1868627), // Rule ID 14167 //
     /* 1868543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1868554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1868557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1868560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868589 */     // MIs[0] policy
     /* 1868589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868599 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11534:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868626 */     // GIR_Coverage, 14167,
     /* 1868626 */     GIR_EraseRootFromParent_Done,
     /* 1868627 */   // Label 25246: @1868627
     /* 1868627 */   GIM_Try, /*On fail goto*//*Label 25247*/ GIMT_Encode4(1868716), // Rule ID 14170 //
     /* 1868632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1868643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1868646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1868649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868678 */     // MIs[0] policy
     /* 1868678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868688 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868715 */     // GIR_Coverage, 14170,
     /* 1868715 */     GIR_EraseRootFromParent_Done,
     /* 1868716 */   // Label 25247: @1868716
     /* 1868716 */   GIM_Try, /*On fail goto*//*Label 25248*/ GIMT_Encode4(1868805), // Rule ID 14171 //
     /* 1868721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1868732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1868735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1868738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868767 */     // MIs[0] policy
     /* 1868767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868777 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11534:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1868798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868804 */     // GIR_Coverage, 14171,
     /* 1868804 */     GIR_EraseRootFromParent_Done,
     /* 1868805 */   // Label 25248: @1868805
     /* 1868805 */   GIM_Try, /*On fail goto*//*Label 25249*/ GIMT_Encode4(1868894), // Rule ID 14174 //
     /* 1868810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1868821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1868824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1868827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868856 */     // MIs[0] policy
     /* 1868856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868893 */     // GIR_Coverage, 14174,
     /* 1868893 */     GIR_EraseRootFromParent_Done,
     /* 1868894 */   // Label 25249: @1868894
     /* 1868894 */   GIM_Try, /*On fail goto*//*Label 25250*/ GIMT_Encode4(1868983), // Rule ID 14175 //
     /* 1868899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1868910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1868913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1868916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868945 */     // MIs[0] policy
     /* 1868945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868955 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11534:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1868958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868982 */     // GIR_Coverage, 14175,
     /* 1868982 */     GIR_EraseRootFromParent_Done,
     /* 1868983 */   // Label 25250: @1868983
     /* 1868983 */   GIM_Try, /*On fail goto*//*Label 25251*/ GIMT_Encode4(1869072), // Rule ID 14178 //
     /* 1868988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1868991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1868996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1868999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869034 */     // MIs[0] policy
     /* 1869034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869044 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869071 */     // GIR_Coverage, 14178,
     /* 1869071 */     GIR_EraseRootFromParent_Done,
     /* 1869072 */   // Label 25251: @1869072
     /* 1869072 */   GIM_Try, /*On fail goto*//*Label 25252*/ GIMT_Encode4(1869161), // Rule ID 14179 //
     /* 1869077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1869080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1869088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1869091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1869094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869123 */     // MIs[0] policy
     /* 1869123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869133 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11534:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1869136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1869154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869160 */     // GIR_Coverage, 14179,
     /* 1869160 */     GIR_EraseRootFromParent_Done,
     /* 1869161 */   // Label 25252: @1869161
     /* 1869161 */   GIM_Try, /*On fail goto*//*Label 25253*/ GIMT_Encode4(1869250), // Rule ID 14182 //
     /* 1869166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869212 */     // MIs[0] policy
     /* 1869212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869222 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869249 */     // GIR_Coverage, 14182,
     /* 1869249 */     GIR_EraseRootFromParent_Done,
     /* 1869250 */   // Label 25253: @1869250
     /* 1869250 */   GIM_Try, /*On fail goto*//*Label 25254*/ GIMT_Encode4(1869339), // Rule ID 14183 //
     /* 1869255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1869266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1869269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1869272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869301 */     // MIs[0] policy
     /* 1869301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869338 */     // GIR_Coverage, 14183,
     /* 1869338 */     GIR_EraseRootFromParent_Done,
     /* 1869339 */   // Label 25254: @1869339
     /* 1869339 */   GIM_Try, /*On fail goto*//*Label 25255*/ GIMT_Encode4(1869428), // Rule ID 14186 //
     /* 1869344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869390 */     // MIs[0] policy
     /* 1869390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869400 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869427 */     // GIR_Coverage, 14186,
     /* 1869427 */     GIR_EraseRootFromParent_Done,
     /* 1869428 */   // Label 25255: @1869428
     /* 1869428 */   GIM_Try, /*On fail goto*//*Label 25256*/ GIMT_Encode4(1869517), // Rule ID 14187 //
     /* 1869433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1869444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1869447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1869450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1869456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869479 */     // MIs[0] policy
     /* 1869479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869489 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869516 */     // GIR_Coverage, 14187,
     /* 1869516 */     GIR_EraseRootFromParent_Done,
     /* 1869517 */   // Label 25256: @1869517
     /* 1869517 */   GIM_Try, /*On fail goto*//*Label 25257*/ GIMT_Encode4(1869606), // Rule ID 14190 //
     /* 1869522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1869533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1869536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1869539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1869545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1869552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869568 */     // MIs[0] policy
     /* 1869568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869578 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1869581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869605 */     // GIR_Coverage, 14190,
     /* 1869605 */     GIR_EraseRootFromParent_Done,
     /* 1869606 */   // Label 25257: @1869606
     /* 1869606 */   GIM_Try, /*On fail goto*//*Label 25258*/ GIMT_Encode4(1869695), // Rule ID 14191 //
     /* 1869611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1869622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1869625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1869628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1869634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1869641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1869649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869657 */     // MIs[0] policy
     /* 1869657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869667 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1869670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869694 */     // GIR_Coverage, 14191,
     /* 1869694 */     GIR_EraseRootFromParent_Done,
     /* 1869695 */   // Label 25258: @1869695
     /* 1869695 */   GIM_Try, /*On fail goto*//*Label 25259*/ GIMT_Encode4(1869784), // Rule ID 14194 //
     /* 1869700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1869711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1869714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1869717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869746 */     // MIs[0] policy
     /* 1869746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869756 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869783 */     // GIR_Coverage, 14194,
     /* 1869783 */     GIR_EraseRootFromParent_Done,
     /* 1869784 */   // Label 25259: @1869784
     /* 1869784 */   GIM_Try, /*On fail goto*//*Label 25260*/ GIMT_Encode4(1869873), // Rule ID 14195 //
     /* 1869789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1869800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1869803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1869806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1869819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1869827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869835 */     // MIs[0] policy
     /* 1869835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869845 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1869848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869872 */     // GIR_Coverage, 14195,
     /* 1869872 */     GIR_EraseRootFromParent_Done,
     /* 1869873 */   // Label 25260: @1869873
     /* 1869873 */   GIM_Try, /*On fail goto*//*Label 25261*/ GIMT_Encode4(1869962), // Rule ID 14198 //
     /* 1869878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1869889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1869892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1869895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1869916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869924 */     // MIs[0] policy
     /* 1869924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1869937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869961 */     // GIR_Coverage, 14198,
     /* 1869961 */     GIR_EraseRootFromParent_Done,
     /* 1869962 */   // Label 25261: @1869962
     /* 1869962 */   GIM_Try, /*On fail goto*//*Label 25262*/ GIMT_Encode4(1870051), // Rule ID 14199 //
     /* 1869967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1869975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1869978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1869981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1869984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1869990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1869997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870013 */     // MIs[0] policy
     /* 1870013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870023 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870050 */     // GIR_Coverage, 14199,
     /* 1870050 */     GIR_EraseRootFromParent_Done,
     /* 1870051 */   // Label 25262: @1870051
     /* 1870051 */   GIM_Try, /*On fail goto*//*Label 25263*/ GIMT_Encode4(1870140), // Rule ID 14202 //
     /* 1870056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1870067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1870070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870102 */     // MIs[0] policy
     /* 1870102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870112 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870139 */     // GIR_Coverage, 14202,
     /* 1870139 */     GIR_EraseRootFromParent_Done,
     /* 1870140 */   // Label 25263: @1870140
     /* 1870140 */   GIM_Try, /*On fail goto*//*Label 25264*/ GIMT_Encode4(1870229), // Rule ID 14203 //
     /* 1870145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1870156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1870159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1870162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870191 */     // MIs[0] policy
     /* 1870191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870201 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870228 */     // GIR_Coverage, 14203,
     /* 1870228 */     GIR_EraseRootFromParent_Done,
     /* 1870229 */   // Label 25264: @1870229
     /* 1870229 */   GIM_Try, /*On fail goto*//*Label 25265*/ GIMT_Encode4(1870318), // Rule ID 14206 //
     /* 1870234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870280 */     // MIs[0] policy
     /* 1870280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870317 */     // GIR_Coverage, 14206,
     /* 1870317 */     GIR_EraseRootFromParent_Done,
     /* 1870318 */   // Label 25265: @1870318
     /* 1870318 */   GIM_Try, /*On fail goto*//*Label 25266*/ GIMT_Encode4(1870407), // Rule ID 14207 //
     /* 1870323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1870334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1870337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1870340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870369 */     // MIs[0] policy
     /* 1870369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870406 */     // GIR_Coverage, 14207,
     /* 1870406 */     GIR_EraseRootFromParent_Done,
     /* 1870407 */   // Label 25266: @1870407
     /* 1870407 */   GIM_Try, /*On fail goto*//*Label 25267*/ GIMT_Encode4(1870496), // Rule ID 14210 //
     /* 1870412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870458 */     // MIs[0] policy
     /* 1870458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870495 */     // GIR_Coverage, 14210,
     /* 1870495 */     GIR_EraseRootFromParent_Done,
     /* 1870496 */   // Label 25267: @1870496
     /* 1870496 */   GIM_Try, /*On fail goto*//*Label 25268*/ GIMT_Encode4(1870585), // Rule ID 14211 //
     /* 1870501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1870512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1870515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1870518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870547 */     // MIs[0] policy
     /* 1870547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870557 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1870560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870584 */     // GIR_Coverage, 14211,
     /* 1870584 */     GIR_EraseRootFromParent_Done,
     /* 1870585 */   // Label 25268: @1870585
     /* 1870585 */   GIM_Try, /*On fail goto*//*Label 25269*/ GIMT_Encode4(1870674), // Rule ID 14214 //
     /* 1870590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1870601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1870604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1870607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870636 */     // MIs[0] policy
     /* 1870636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870673 */     // GIR_Coverage, 14214,
     /* 1870673 */     GIR_EraseRootFromParent_Done,
     /* 1870674 */   // Label 25269: @1870674
     /* 1870674 */   GIM_Try, /*On fail goto*//*Label 25270*/ GIMT_Encode4(1870763), // Rule ID 14215 //
     /* 1870679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1870690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1870693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1870696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870725 */     // MIs[0] policy
     /* 1870725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870735 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1870738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870762 */     // GIR_Coverage, 14215,
     /* 1870762 */     GIR_EraseRootFromParent_Done,
     /* 1870763 */   // Label 25270: @1870763
     /* 1870763 */   GIM_Try, /*On fail goto*//*Label 25271*/ GIMT_Encode4(1870852), // Rule ID 14218 //
     /* 1870768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1870771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1870779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1870782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1870785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870814 */     // MIs[0] policy
     /* 1870814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870851 */     // GIR_Coverage, 14218,
     /* 1870851 */     GIR_EraseRootFromParent_Done,
     /* 1870852 */   // Label 25271: @1870852
     /* 1870852 */   GIM_Try, /*On fail goto*//*Label 25272*/ GIMT_Encode4(1870941), // Rule ID 14219 //
     /* 1870857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1870860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1870868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1870871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1870874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870903 */     // MIs[0] policy
     /* 1870903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11534:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1870916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870940 */     // GIR_Coverage, 14219,
     /* 1870940 */     GIR_EraseRootFromParent_Done,
     /* 1870941 */   // Label 25272: @1870941
     /* 1870941 */   GIM_Try, /*On fail goto*//*Label 25273*/ GIMT_Encode4(1871030), // Rule ID 14222 //
     /* 1870946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1870949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1870954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1870957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1870960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1870963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1870969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870992 */     // MIs[0] policy
     /* 1870992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871002 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871029 */     // GIR_Coverage, 14222,
     /* 1871029 */     GIR_EraseRootFromParent_Done,
     /* 1871030 */   // Label 25273: @1871030
     /* 1871030 */   GIM_Try, /*On fail goto*//*Label 25274*/ GIMT_Encode4(1871119), // Rule ID 14223 //
     /* 1871035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1871046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1871049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1871052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871081 */     // MIs[0] policy
     /* 1871081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871091 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11534:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1871094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871118 */     // GIR_Coverage, 14223,
     /* 1871118 */     GIR_EraseRootFromParent_Done,
     /* 1871119 */   // Label 25274: @1871119
     /* 1871119 */   GIM_Try, /*On fail goto*//*Label 25275*/ GIMT_Encode4(1871208), // Rule ID 14226 //
     /* 1871124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1871127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871170 */     // MIs[0] policy
     /* 1871170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871207 */     // GIR_Coverage, 14226,
     /* 1871207 */     GIR_EraseRootFromParent_Done,
     /* 1871208 */   // Label 25275: @1871208
     /* 1871208 */   GIM_Try, /*On fail goto*//*Label 25276*/ GIMT_Encode4(1871297), // Rule ID 14227 //
     /* 1871213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1871216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1871221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1871224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1871227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1871230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871259 */     // MIs[0] policy
     /* 1871259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11534:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1871272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1871290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871296 */     // GIR_Coverage, 14227,
     /* 1871296 */     GIR_EraseRootFromParent_Done,
     /* 1871297 */   // Label 25276: @1871297
     /* 1871297 */   GIM_Try, /*On fail goto*//*Label 25277*/ GIMT_Encode4(1871386), // Rule ID 14318 //
     /* 1871302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1871322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871348 */     // MIs[0] policy
     /* 1871348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871358 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1871361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871385 */     // GIR_Coverage, 14318,
     /* 1871385 */     GIR_EraseRootFromParent_Done,
     /* 1871386 */   // Label 25277: @1871386
     /* 1871386 */   GIM_Try, /*On fail goto*//*Label 25278*/ GIMT_Encode4(1871475), // Rule ID 14319 //
     /* 1871391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1871402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1871405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1871408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1871411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871437 */     // MIs[0] policy
     /* 1871437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871447 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1871450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871474 */     // GIR_Coverage, 14319,
     /* 1871474 */     GIR_EraseRootFromParent_Done,
     /* 1871475 */   // Label 25278: @1871475
     /* 1871475 */   GIM_Try, /*On fail goto*//*Label 25279*/ GIMT_Encode4(1871564), // Rule ID 14322 //
     /* 1871480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1871491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1871494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1871497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1871500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871526 */     // MIs[0] policy
     /* 1871526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871536 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1871539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871563 */     // GIR_Coverage, 14322,
     /* 1871563 */     GIR_EraseRootFromParent_Done,
     /* 1871564 */   // Label 25279: @1871564
     /* 1871564 */   GIM_Try, /*On fail goto*//*Label 25280*/ GIMT_Encode4(1871653), // Rule ID 14323 //
     /* 1871569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1871580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1871583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1871586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1871589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1871592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871615 */     // MIs[0] policy
     /* 1871615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871625 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1871628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871652 */     // GIR_Coverage, 14323,
     /* 1871652 */     GIR_EraseRootFromParent_Done,
     /* 1871653 */   // Label 25280: @1871653
     /* 1871653 */   GIM_Try, /*On fail goto*//*Label 25281*/ GIMT_Encode4(1871742), // Rule ID 14326 //
     /* 1871658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1871669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1871672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1871675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1871678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871704 */     // MIs[0] policy
     /* 1871704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871714 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1871717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871741 */     // GIR_Coverage, 14326,
     /* 1871741 */     GIR_EraseRootFromParent_Done,
     /* 1871742 */   // Label 25281: @1871742
     /* 1871742 */   GIM_Try, /*On fail goto*//*Label 25282*/ GIMT_Encode4(1871831), // Rule ID 14327 //
     /* 1871747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1871758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1871761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1871764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1871767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871793 */     // MIs[0] policy
     /* 1871793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871803 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1871806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1871824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871830 */     // GIR_Coverage, 14327,
     /* 1871830 */     GIR_EraseRootFromParent_Done,
     /* 1871831 */   // Label 25282: @1871831
     /* 1871831 */   GIM_Try, /*On fail goto*//*Label 25283*/ GIMT_Encode4(1871920), // Rule ID 14330 //
     /* 1871836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1871847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1871850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1871853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1871856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871882 */     // MIs[0] policy
     /* 1871882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1871895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871919 */     // GIR_Coverage, 14330,
     /* 1871919 */     GIR_EraseRootFromParent_Done,
     /* 1871920 */   // Label 25283: @1871920
     /* 1871920 */   GIM_Try, /*On fail goto*//*Label 25284*/ GIMT_Encode4(1872009), // Rule ID 14331 //
     /* 1871925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1871936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1871939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1871942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1871945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1871948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1871955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1871967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871971 */     // MIs[0] policy
     /* 1871971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871981 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1871984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872008 */     // GIR_Coverage, 14331,
     /* 1872008 */     GIR_EraseRootFromParent_Done,
     /* 1872009 */   // Label 25284: @1872009
     /* 1872009 */   GIM_Try, /*On fail goto*//*Label 25285*/ GIMT_Encode4(1872098), // Rule ID 14334 //
     /* 1872014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1872025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1872028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1872031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1872034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872060 */     // MIs[0] policy
     /* 1872060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872097 */     // GIR_Coverage, 14334,
     /* 1872097 */     GIR_EraseRootFromParent_Done,
     /* 1872098 */   // Label 25285: @1872098
     /* 1872098 */   GIM_Try, /*On fail goto*//*Label 25286*/ GIMT_Encode4(1872187), // Rule ID 14335 //
     /* 1872103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1872114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1872117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1872120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1872123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872149 */     // MIs[0] policy
     /* 1872149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872159 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872186 */     // GIR_Coverage, 14335,
     /* 1872186 */     GIR_EraseRootFromParent_Done,
     /* 1872187 */   // Label 25286: @1872187
     /* 1872187 */   GIM_Try, /*On fail goto*//*Label 25287*/ GIMT_Encode4(1872276), // Rule ID 14338 //
     /* 1872192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1872212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872238 */     // MIs[0] policy
     /* 1872238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872248 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872275 */     // GIR_Coverage, 14338,
     /* 1872275 */     GIR_EraseRootFromParent_Done,
     /* 1872276 */   // Label 25287: @1872276
     /* 1872276 */   GIM_Try, /*On fail goto*//*Label 25288*/ GIMT_Encode4(1872365), // Rule ID 14339 //
     /* 1872281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1872292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1872295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1872298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1872301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872327 */     // MIs[0] policy
     /* 1872327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872337 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1872340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872364 */     // GIR_Coverage, 14339,
     /* 1872364 */     GIR_EraseRootFromParent_Done,
     /* 1872365 */   // Label 25288: @1872365
     /* 1872365 */   GIM_Try, /*On fail goto*//*Label 25289*/ GIMT_Encode4(1872454), // Rule ID 14342 //
     /* 1872370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1872390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872416 */     // MIs[0] policy
     /* 1872416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872453 */     // GIR_Coverage, 14342,
     /* 1872453 */     GIR_EraseRootFromParent_Done,
     /* 1872454 */   // Label 25289: @1872454
     /* 1872454 */   GIM_Try, /*On fail goto*//*Label 25290*/ GIMT_Encode4(1872543), // Rule ID 14343 //
     /* 1872459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1872470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1872473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1872476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1872479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872505 */     // MIs[0] policy
     /* 1872505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872515 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872542 */     // GIR_Coverage, 14343,
     /* 1872542 */     GIR_EraseRootFromParent_Done,
     /* 1872543 */   // Label 25290: @1872543
     /* 1872543 */   GIM_Try, /*On fail goto*//*Label 25291*/ GIMT_Encode4(1872632), // Rule ID 14346 //
     /* 1872548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1872559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1872562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1872565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1872568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872594 */     // MIs[0] policy
     /* 1872594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872631 */     // GIR_Coverage, 14346,
     /* 1872631 */     GIR_EraseRootFromParent_Done,
     /* 1872632 */   // Label 25291: @1872632
     /* 1872632 */   GIM_Try, /*On fail goto*//*Label 25292*/ GIMT_Encode4(1872721), // Rule ID 14347 //
     /* 1872637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1872648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1872651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1872654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1872657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872683 */     // MIs[0] policy
     /* 1872683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872693 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1872714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872720 */     // GIR_Coverage, 14347,
     /* 1872720 */     GIR_EraseRootFromParent_Done,
     /* 1872721 */   // Label 25292: @1872721
     /* 1872721 */   GIM_Try, /*On fail goto*//*Label 25293*/ GIMT_Encode4(1872810), // Rule ID 14350 //
     /* 1872726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1872737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1872740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1872743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1872746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872772 */     // MIs[0] policy
     /* 1872772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872782 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872809 */     // GIR_Coverage, 14350,
     /* 1872809 */     GIR_EraseRootFromParent_Done,
     /* 1872810 */   // Label 25293: @1872810
     /* 1872810 */   GIM_Try, /*On fail goto*//*Label 25294*/ GIMT_Encode4(1872899), // Rule ID 14351 //
     /* 1872815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1872826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1872829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1872832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1872835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872861 */     // MIs[0] policy
     /* 1872861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872871 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872898 */     // GIR_Coverage, 14351,
     /* 1872898 */     GIR_EraseRootFromParent_Done,
     /* 1872899 */   // Label 25294: @1872899
     /* 1872899 */   GIM_Try, /*On fail goto*//*Label 25295*/ GIMT_Encode4(1872988), // Rule ID 14354 //
     /* 1872904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1872907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1872915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1872918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1872921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1872924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872950 */     // MIs[0] policy
     /* 1872950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872960 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1872963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872987 */     // GIR_Coverage, 14354,
     /* 1872987 */     GIR_EraseRootFromParent_Done,
     /* 1872988 */   // Label 25295: @1872988
     /* 1872988 */   GIM_Try, /*On fail goto*//*Label 25296*/ GIMT_Encode4(1873077), // Rule ID 14355 //
     /* 1872993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1872996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1873004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1873007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1873010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1873013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873039 */     // MIs[0] policy
     /* 1873039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873049 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1873052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1873070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873076 */     // GIR_Coverage, 14355,
     /* 1873076 */     GIR_EraseRootFromParent_Done,
     /* 1873077 */   // Label 25296: @1873077
     /* 1873077 */   GIM_Try, /*On fail goto*//*Label 25297*/ GIMT_Encode4(1873166), // Rule ID 14358 //
     /* 1873082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1873102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873128 */     // MIs[0] policy
     /* 1873128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873165 */     // GIR_Coverage, 14358,
     /* 1873165 */     GIR_EraseRootFromParent_Done,
     /* 1873166 */   // Label 25297: @1873166
     /* 1873166 */   GIM_Try, /*On fail goto*//*Label 25298*/ GIMT_Encode4(1873255), // Rule ID 14359 //
     /* 1873171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1873182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1873185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1873188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1873191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873217 */     // MIs[0] policy
     /* 1873217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873227 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873254 */     // GIR_Coverage, 14359,
     /* 1873254 */     GIR_EraseRootFromParent_Done,
     /* 1873255 */   // Label 25298: @1873255
     /* 1873255 */   GIM_Try, /*On fail goto*//*Label 25299*/ GIMT_Encode4(1873344), // Rule ID 14362 //
     /* 1873260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1873280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873306 */     // MIs[0] policy
     /* 1873306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873343 */     // GIR_Coverage, 14362,
     /* 1873343 */     GIR_EraseRootFromParent_Done,
     /* 1873344 */   // Label 25299: @1873344
     /* 1873344 */   GIM_Try, /*On fail goto*//*Label 25300*/ GIMT_Encode4(1873433), // Rule ID 14363 //
     /* 1873349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1873360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1873363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1873366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1873369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873395 */     // MIs[0] policy
     /* 1873395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873405 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873432 */     // GIR_Coverage, 14363,
     /* 1873432 */     GIR_EraseRootFromParent_Done,
     /* 1873433 */   // Label 25300: @1873433
     /* 1873433 */   GIM_Try, /*On fail goto*//*Label 25301*/ GIMT_Encode4(1873522), // Rule ID 14366 //
     /* 1873438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1873449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1873452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1873455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1873458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1873461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1873468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873484 */     // MIs[0] policy
     /* 1873484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873494 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1873497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873521 */     // GIR_Coverage, 14366,
     /* 1873521 */     GIR_EraseRootFromParent_Done,
     /* 1873522 */   // Label 25301: @1873522
     /* 1873522 */   GIM_Try, /*On fail goto*//*Label 25302*/ GIMT_Encode4(1873611), // Rule ID 14367 //
     /* 1873527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1873538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1873541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1873544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1873547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1873550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1873557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1873569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873573 */     // MIs[0] policy
     /* 1873573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873583 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1873586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873610 */     // GIR_Coverage, 14367,
     /* 1873610 */     GIR_EraseRootFromParent_Done,
     /* 1873611 */   // Label 25302: @1873611
     /* 1873611 */   GIM_Try, /*On fail goto*//*Label 25303*/ GIMT_Encode4(1873700), // Rule ID 14370 //
     /* 1873616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1873627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1873630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1873633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1873636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873662 */     // MIs[0] policy
     /* 1873662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873699 */     // GIR_Coverage, 14370,
     /* 1873699 */     GIR_EraseRootFromParent_Done,
     /* 1873700 */   // Label 25303: @1873700
     /* 1873700 */   GIM_Try, /*On fail goto*//*Label 25304*/ GIMT_Encode4(1873789), // Rule ID 14371 //
     /* 1873705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1873716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1873719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1873722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1873725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1873735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1873747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873751 */     // MIs[0] policy
     /* 1873751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873761 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1873764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873788 */     // GIR_Coverage, 14371,
     /* 1873788 */     GIR_EraseRootFromParent_Done,
     /* 1873789 */   // Label 25304: @1873789
     /* 1873789 */   GIM_Try, /*On fail goto*//*Label 25305*/ GIMT_Encode4(1873878), // Rule ID 14374 //
     /* 1873794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1873805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1873808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1873811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1873814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873840 */     // MIs[0] policy
     /* 1873840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873850 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873877 */     // GIR_Coverage, 14374,
     /* 1873877 */     GIR_EraseRootFromParent_Done,
     /* 1873878 */   // Label 25305: @1873878
     /* 1873878 */   GIM_Try, /*On fail goto*//*Label 25306*/ GIMT_Encode4(1873967), // Rule ID 14375 //
     /* 1873883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1873894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1873897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1873900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1873903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1873906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1873913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1873925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873929 */     // MIs[0] policy
     /* 1873929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873939 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1873942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873966 */     // GIR_Coverage, 14375,
     /* 1873966 */     GIR_EraseRootFromParent_Done,
     /* 1873967 */   // Label 25306: @1873967
     /* 1873967 */   GIM_Try, /*On fail goto*//*Label 25307*/ GIMT_Encode4(1874056), // Rule ID 14378 //
     /* 1873972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1873980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1873983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1873986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1873989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1873992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1873995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874018 */     // MIs[0] policy
     /* 1874018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874028 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874055 */     // GIR_Coverage, 14378,
     /* 1874055 */     GIR_EraseRootFromParent_Done,
     /* 1874056 */   // Label 25307: @1874056
     /* 1874056 */   GIM_Try, /*On fail goto*//*Label 25308*/ GIMT_Encode4(1874145), // Rule ID 14379 //
     /* 1874061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1874072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1874075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1874078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1874081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874107 */     // MIs[0] policy
     /* 1874107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874117 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874144 */     // GIR_Coverage, 14379,
     /* 1874144 */     GIR_EraseRootFromParent_Done,
     /* 1874145 */   // Label 25308: @1874145
     /* 1874145 */   GIM_Try, /*On fail goto*//*Label 25309*/ GIMT_Encode4(1874234), // Rule ID 14382 //
     /* 1874150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1874170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874196 */     // MIs[0] policy
     /* 1874196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874233 */     // GIR_Coverage, 14382,
     /* 1874233 */     GIR_EraseRootFromParent_Done,
     /* 1874234 */   // Label 25309: @1874234
     /* 1874234 */   GIM_Try, /*On fail goto*//*Label 25310*/ GIMT_Encode4(1874323), // Rule ID 14383 //
     /* 1874239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1874250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1874253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1874256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1874259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874285 */     // MIs[0] policy
     /* 1874285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874322 */     // GIR_Coverage, 14383,
     /* 1874322 */     GIR_EraseRootFromParent_Done,
     /* 1874323 */   // Label 25310: @1874323
     /* 1874323 */   GIM_Try, /*On fail goto*//*Label 25311*/ GIMT_Encode4(1874412), // Rule ID 14386 //
     /* 1874328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1874348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874374 */     // MIs[0] policy
     /* 1874374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874411 */     // GIR_Coverage, 14386,
     /* 1874411 */     GIR_EraseRootFromParent_Done,
     /* 1874412 */   // Label 25311: @1874412
     /* 1874412 */   GIM_Try, /*On fail goto*//*Label 25312*/ GIMT_Encode4(1874501), // Rule ID 14387 //
     /* 1874417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1874428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1874431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1874434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1874437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874463 */     // MIs[0] policy
     /* 1874463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874473 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874500 */     // GIR_Coverage, 14387,
     /* 1874500 */     GIR_EraseRootFromParent_Done,
     /* 1874501 */   // Label 25312: @1874501
     /* 1874501 */   GIM_Try, /*On fail goto*//*Label 25313*/ GIMT_Encode4(1874590), // Rule ID 14390 //
     /* 1874506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1874517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1874520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1874523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1874526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874552 */     // MIs[0] policy
     /* 1874552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874589 */     // GIR_Coverage, 14390,
     /* 1874589 */     GIR_EraseRootFromParent_Done,
     /* 1874590 */   // Label 25313: @1874590
     /* 1874590 */   GIM_Try, /*On fail goto*//*Label 25314*/ GIMT_Encode4(1874679), // Rule ID 14391 //
     /* 1874595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1874606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1874609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1874612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1874615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874641 */     // MIs[0] policy
     /* 1874641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874651 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1874654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874678 */     // GIR_Coverage, 14391,
     /* 1874678 */     GIR_EraseRootFromParent_Done,
     /* 1874679 */   // Label 25314: @1874679
     /* 1874679 */   GIM_Try, /*On fail goto*//*Label 25315*/ GIMT_Encode4(1874768), // Rule ID 14394 //
     /* 1874684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1874687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1874695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1874698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1874701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1874704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1874707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874730 */     // MIs[0] policy
     /* 1874730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874740 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874767 */     // GIR_Coverage, 14394,
     /* 1874767 */     GIR_EraseRootFromParent_Done,
     /* 1874768 */   // Label 25315: @1874768
     /* 1874768 */   GIM_Try, /*On fail goto*//*Label 25316*/ GIMT_Encode4(1874857), // Rule ID 14395 //
     /* 1874773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1874776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1874784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1874787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1874790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1874793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1874796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874819 */     // MIs[0] policy
     /* 1874819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874829 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1874832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874856 */     // GIR_Coverage, 14395,
     /* 1874856 */     GIR_EraseRootFromParent_Done,
     /* 1874857 */   // Label 25316: @1874857
     /* 1874857 */   GIM_Try, /*On fail goto*//*Label 25317*/ GIMT_Encode4(1874946), // Rule ID 14398 //
     /* 1874862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1874865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1874873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1874876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1874879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1874882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874908 */     // MIs[0] policy
     /* 1874908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1874921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874945 */     // GIR_Coverage, 14398,
     /* 1874945 */     GIR_EraseRootFromParent_Done,
     /* 1874946 */   // Label 25317: @1874946
     /* 1874946 */   GIM_Try, /*On fail goto*//*Label 25318*/ GIMT_Encode4(1875035), // Rule ID 14399 //
     /* 1874951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1874954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1874959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1874962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1874965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1874968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1874971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1874974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874997 */     // MIs[0] policy
     /* 1874997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875007 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1875010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875034 */     // GIR_Coverage, 14399,
     /* 1875034 */     GIR_EraseRootFromParent_Done,
     /* 1875035 */   // Label 25318: @1875035
     /* 1875035 */   GIM_Try, /*On fail goto*//*Label 25319*/ GIMT_Encode4(1875124), // Rule ID 14402 //
     /* 1875040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1875043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1875051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1875054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1875057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1875060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875086 */     // MIs[0] policy
     /* 1875086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875096 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875123 */     // GIR_Coverage, 14402,
     /* 1875123 */     GIR_EraseRootFromParent_Done,
     /* 1875124 */   // Label 25319: @1875124
     /* 1875124 */   GIM_Try, /*On fail goto*//*Label 25320*/ GIMT_Encode4(1875213), // Rule ID 14403 //
     /* 1875129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1875132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1875140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1875143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1875146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1875149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875175 */     // MIs[0] policy
     /* 1875175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875185 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1875188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1875206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875212 */     // GIR_Coverage, 14403,
     /* 1875212 */     GIR_EraseRootFromParent_Done,
     /* 1875213 */   // Label 25320: @1875213
     /* 1875213 */   GIM_Try, /*On fail goto*//*Label 25321*/ GIMT_Encode4(1875302), // Rule ID 14406 //
     /* 1875218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875264 */     // MIs[0] policy
     /* 1875264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1875277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875301 */     // GIR_Coverage, 14406,
     /* 1875301 */     GIR_EraseRootFromParent_Done,
     /* 1875302 */   // Label 25321: @1875302
     /* 1875302 */   GIM_Try, /*On fail goto*//*Label 25322*/ GIMT_Encode4(1875391), // Rule ID 14407 //
     /* 1875307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1875318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1875321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1875324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875353 */     // MIs[0] policy
     /* 1875353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875363 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1875366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875390 */     // GIR_Coverage, 14407,
     /* 1875390 */     GIR_EraseRootFromParent_Done,
     /* 1875391 */   // Label 25322: @1875391
     /* 1875391 */   GIM_Try, /*On fail goto*//*Label 25323*/ GIMT_Encode4(1875480), // Rule ID 14410 //
     /* 1875396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875442 */     // MIs[0] policy
     /* 1875442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875479 */     // GIR_Coverage, 14410,
     /* 1875479 */     GIR_EraseRootFromParent_Done,
     /* 1875480 */   // Label 25323: @1875480
     /* 1875480 */   GIM_Try, /*On fail goto*//*Label 25324*/ GIMT_Encode4(1875569), // Rule ID 14411 //
     /* 1875485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1875496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1875499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1875502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875531 */     // MIs[0] policy
     /* 1875531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875541 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875568 */     // GIR_Coverage, 14411,
     /* 1875568 */     GIR_EraseRootFromParent_Done,
     /* 1875569 */   // Label 25324: @1875569
     /* 1875569 */   GIM_Try, /*On fail goto*//*Label 25325*/ GIMT_Encode4(1875658), // Rule ID 14414 //
     /* 1875574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1875585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1875588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1875591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875620 */     // MIs[0] policy
     /* 1875620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875630 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1875633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875657 */     // GIR_Coverage, 14414,
     /* 1875657 */     GIR_EraseRootFromParent_Done,
     /* 1875658 */   // Label 25325: @1875658
     /* 1875658 */   GIM_Try, /*On fail goto*//*Label 25326*/ GIMT_Encode4(1875747), // Rule ID 14415 //
     /* 1875663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1875674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1875677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1875680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875709 */     // MIs[0] policy
     /* 1875709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875719 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1875722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1875740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875746 */     // GIR_Coverage, 14415,
     /* 1875746 */     GIR_EraseRootFromParent_Done,
     /* 1875747 */   // Label 25326: @1875747
     /* 1875747 */   GIM_Try, /*On fail goto*//*Label 25327*/ GIMT_Encode4(1875836), // Rule ID 14418 //
     /* 1875752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1875763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1875766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1875769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875798 */     // MIs[0] policy
     /* 1875798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875808 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875835 */     // GIR_Coverage, 14418,
     /* 1875835 */     GIR_EraseRootFromParent_Done,
     /* 1875836 */   // Label 25327: @1875836
     /* 1875836 */   GIM_Try, /*On fail goto*//*Label 25328*/ GIMT_Encode4(1875925), // Rule ID 14419 //
     /* 1875841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1875852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1875855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1875858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1875861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1875864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875887 */     // MIs[0] policy
     /* 1875887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875897 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1875900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875924 */     // GIR_Coverage, 14419,
     /* 1875924 */     GIR_EraseRootFromParent_Done,
     /* 1875925 */   // Label 25328: @1875925
     /* 1875925 */   GIM_Try, /*On fail goto*//*Label 25329*/ GIMT_Encode4(1876014), // Rule ID 14422 //
     /* 1875930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1875938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1875941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1875944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1875947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1875950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1875960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1875968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1875972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875976 */     // MIs[0] policy
     /* 1875976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875986 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1875989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876013 */     // GIR_Coverage, 14422,
     /* 1876013 */     GIR_EraseRootFromParent_Done,
     /* 1876014 */   // Label 25329: @1876014
     /* 1876014 */   GIM_Try, /*On fail goto*//*Label 25330*/ GIMT_Encode4(1876103), // Rule ID 14423 //
     /* 1876019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1876030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1876033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1876036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876065 */     // MIs[0] policy
     /* 1876065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876075 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876102 */     // GIR_Coverage, 14423,
     /* 1876102 */     GIR_EraseRootFromParent_Done,
     /* 1876103 */   // Label 25330: @1876103
     /* 1876103 */   GIM_Try, /*On fail goto*//*Label 25331*/ GIMT_Encode4(1876192), // Rule ID 14426 //
     /* 1876108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876154 */     // MIs[0] policy
     /* 1876154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876164 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876191 */     // GIR_Coverage, 14426,
     /* 1876191 */     GIR_EraseRootFromParent_Done,
     /* 1876192 */   // Label 25331: @1876192
     /* 1876192 */   GIM_Try, /*On fail goto*//*Label 25332*/ GIMT_Encode4(1876281), // Rule ID 14427 //
     /* 1876197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1876208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1876211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1876214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876243 */     // MIs[0] policy
     /* 1876243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876253 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1876256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876280 */     // GIR_Coverage, 14427,
     /* 1876280 */     GIR_EraseRootFromParent_Done,
     /* 1876281 */   // Label 25332: @1876281
     /* 1876281 */   GIM_Try, /*On fail goto*//*Label 25333*/ GIMT_Encode4(1876370), // Rule ID 14430 //
     /* 1876286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876332 */     // MIs[0] policy
     /* 1876332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876342 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876369 */     // GIR_Coverage, 14430,
     /* 1876369 */     GIR_EraseRootFromParent_Done,
     /* 1876370 */   // Label 25333: @1876370
     /* 1876370 */   GIM_Try, /*On fail goto*//*Label 25334*/ GIMT_Encode4(1876459), // Rule ID 14431 //
     /* 1876375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1876386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1876389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1876392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876421 */     // MIs[0] policy
     /* 1876421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876431 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876458 */     // GIR_Coverage, 14431,
     /* 1876458 */     GIR_EraseRootFromParent_Done,
     /* 1876459 */   // Label 25334: @1876459
     /* 1876459 */   GIM_Try, /*On fail goto*//*Label 25335*/ GIMT_Encode4(1876548), // Rule ID 14434 //
     /* 1876464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1876475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1876478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1876481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876510 */     // MIs[0] policy
     /* 1876510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876547 */     // GIR_Coverage, 14434,
     /* 1876547 */     GIR_EraseRootFromParent_Done,
     /* 1876548 */   // Label 25335: @1876548
     /* 1876548 */   GIM_Try, /*On fail goto*//*Label 25336*/ GIMT_Encode4(1876637), // Rule ID 14435 //
     /* 1876553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1876564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1876567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1876570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876599 */     // MIs[0] policy
     /* 1876599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876609 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1876630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876636 */     // GIR_Coverage, 14435,
     /* 1876636 */     GIR_EraseRootFromParent_Done,
     /* 1876637 */   // Label 25336: @1876637
     /* 1876637 */   GIM_Try, /*On fail goto*//*Label 25337*/ GIMT_Encode4(1876726), // Rule ID 14438 //
     /* 1876642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1876653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1876656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1876659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876688 */     // MIs[0] policy
     /* 1876688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876725 */     // GIR_Coverage, 14438,
     /* 1876725 */     GIR_EraseRootFromParent_Done,
     /* 1876726 */   // Label 25337: @1876726
     /* 1876726 */   GIM_Try, /*On fail goto*//*Label 25338*/ GIMT_Encode4(1876815), // Rule ID 14439 //
     /* 1876731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1876742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1876745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1876748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876777 */     // MIs[0] policy
     /* 1876777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1876808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876814 */     // GIR_Coverage, 14439,
     /* 1876814 */     GIR_EraseRootFromParent_Done,
     /* 1876815 */   // Label 25338: @1876815
     /* 1876815 */   GIM_Try, /*On fail goto*//*Label 25339*/ GIMT_Encode4(1876904), // Rule ID 14442 //
     /* 1876820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1876823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1876831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1876834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1876837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876866 */     // MIs[0] policy
     /* 1876866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876903 */     // GIR_Coverage, 14442,
     /* 1876903 */     GIR_EraseRootFromParent_Done,
     /* 1876904 */   // Label 25339: @1876904
     /* 1876904 */   GIM_Try, /*On fail goto*//*Label 25340*/ GIMT_Encode4(1876993), // Rule ID 14443 //
     /* 1876909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1876912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1876917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1876920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1876923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1876926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876955 */     // MIs[0] policy
     /* 1876955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876965 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1876968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876992 */     // GIR_Coverage, 14443,
     /* 1876992 */     GIR_EraseRootFromParent_Done,
     /* 1876993 */   // Label 25340: @1876993
     /* 1876993 */   GIM_Try, /*On fail goto*//*Label 25341*/ GIMT_Encode4(1877082), // Rule ID 14446 //
     /* 1876998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877044 */     // MIs[0] policy
     /* 1877044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877054 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877081 */     // GIR_Coverage, 14446,
     /* 1877081 */     GIR_EraseRootFromParent_Done,
     /* 1877082 */   // Label 25341: @1877082
     /* 1877082 */   GIM_Try, /*On fail goto*//*Label 25342*/ GIMT_Encode4(1877171), // Rule ID 14447 //
     /* 1877087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1877098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1877101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1877104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877133 */     // MIs[0] policy
     /* 1877133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877143 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877170 */     // GIR_Coverage, 14447,
     /* 1877170 */     GIR_EraseRootFromParent_Done,
     /* 1877171 */   // Label 25342: @1877171
     /* 1877171 */   GIM_Try, /*On fail goto*//*Label 25343*/ GIMT_Encode4(1877260), // Rule ID 14450 //
     /* 1877176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877222 */     // MIs[0] policy
     /* 1877222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877232 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877259 */     // GIR_Coverage, 14450,
     /* 1877259 */     GIR_EraseRootFromParent_Done,
     /* 1877260 */   // Label 25343: @1877260
     /* 1877260 */   GIM_Try, /*On fail goto*//*Label 25344*/ GIMT_Encode4(1877349), // Rule ID 14451 //
     /* 1877265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1877276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1877279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1877282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877311 */     // MIs[0] policy
     /* 1877311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877321 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877348 */     // GIR_Coverage, 14451,
     /* 1877348 */     GIR_EraseRootFromParent_Done,
     /* 1877349 */   // Label 25344: @1877349
     /* 1877349 */   GIM_Try, /*On fail goto*//*Label 25345*/ GIMT_Encode4(1877438), // Rule ID 14454 //
     /* 1877354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877400 */     // MIs[0] policy
     /* 1877400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877410 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877437 */     // GIR_Coverage, 14454,
     /* 1877437 */     GIR_EraseRootFromParent_Done,
     /* 1877438 */   // Label 25345: @1877438
     /* 1877438 */   GIM_Try, /*On fail goto*//*Label 25346*/ GIMT_Encode4(1877527), // Rule ID 14455 //
     /* 1877443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1877454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1877457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1877460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1877466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877489 */     // MIs[0] policy
     /* 1877489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877499 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877526 */     // GIR_Coverage, 14455,
     /* 1877526 */     GIR_EraseRootFromParent_Done,
     /* 1877527 */   // Label 25346: @1877527
     /* 1877527 */   GIM_Try, /*On fail goto*//*Label 25347*/ GIMT_Encode4(1877616), // Rule ID 14458 //
     /* 1877532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1877543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1877546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1877549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877578 */     // MIs[0] policy
     /* 1877578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877588 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877615 */     // GIR_Coverage, 14458,
     /* 1877615 */     GIR_EraseRootFromParent_Done,
     /* 1877616 */   // Label 25347: @1877616
     /* 1877616 */   GIM_Try, /*On fail goto*//*Label 25348*/ GIMT_Encode4(1877705), // Rule ID 14459 //
     /* 1877621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1877632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1877635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1877638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1877651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1877659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877667 */     // MIs[0] policy
     /* 1877667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877677 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1877680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877704 */     // GIR_Coverage, 14459,
     /* 1877704 */     GIR_EraseRootFromParent_Done,
     /* 1877705 */   // Label 25348: @1877705
     /* 1877705 */   GIM_Try, /*On fail goto*//*Label 25349*/ GIMT_Encode4(1877794), // Rule ID 14462 //
     /* 1877710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1877721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1877724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1877727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877756 */     // MIs[0] policy
     /* 1877756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877793 */     // GIR_Coverage, 14462,
     /* 1877793 */     GIR_EraseRootFromParent_Done,
     /* 1877794 */   // Label 25349: @1877794
     /* 1877794 */   GIM_Try, /*On fail goto*//*Label 25350*/ GIMT_Encode4(1877883), // Rule ID 14463 //
     /* 1877799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1877810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1877813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1877816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1877822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1877829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1877837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877845 */     // MIs[0] policy
     /* 1877845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877855 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1877858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877882 */     // GIR_Coverage, 14463,
     /* 1877882 */     GIR_EraseRootFromParent_Done,
     /* 1877883 */   // Label 25350: @1877883
     /* 1877883 */   GIM_Try, /*On fail goto*//*Label 25351*/ GIMT_Encode4(1877972), // Rule ID 14466 //
     /* 1877888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1877899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1877902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1877905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1877911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1877918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1877926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877934 */     // MIs[0] policy
     /* 1877934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877944 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1877947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877971 */     // GIR_Coverage, 14466,
     /* 1877971 */     GIR_EraseRootFromParent_Done,
     /* 1877972 */   // Label 25351: @1877972
     /* 1877972 */   GIM_Try, /*On fail goto*//*Label 25352*/ GIMT_Encode4(1878061), // Rule ID 14467 //
     /* 1877977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1877985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1877988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1877991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1877994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878023 */     // MIs[0] policy
     /* 1878023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878033 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878060 */     // GIR_Coverage, 14467,
     /* 1878060 */     GIR_EraseRootFromParent_Done,
     /* 1878061 */   // Label 25352: @1878061
     /* 1878061 */   GIM_Try, /*On fail goto*//*Label 25353*/ GIMT_Encode4(1878150), // Rule ID 14470 //
     /* 1878066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878112 */     // MIs[0] policy
     /* 1878112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878149 */     // GIR_Coverage, 14470,
     /* 1878149 */     GIR_EraseRootFromParent_Done,
     /* 1878150 */   // Label 25353: @1878150
     /* 1878150 */   GIM_Try, /*On fail goto*//*Label 25354*/ GIMT_Encode4(1878239), // Rule ID 14471 //
     /* 1878155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1878166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1878169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1878172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878201 */     // MIs[0] policy
     /* 1878201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878238 */     // GIR_Coverage, 14471,
     /* 1878238 */     GIR_EraseRootFromParent_Done,
     /* 1878239 */   // Label 25354: @1878239
     /* 1878239 */   GIM_Try, /*On fail goto*//*Label 25355*/ GIMT_Encode4(1878328), // Rule ID 14474 //
     /* 1878244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878290 */     // MIs[0] policy
     /* 1878290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878300 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878327 */     // GIR_Coverage, 14474,
     /* 1878327 */     GIR_EraseRootFromParent_Done,
     /* 1878328 */   // Label 25355: @1878328
     /* 1878328 */   GIM_Try, /*On fail goto*//*Label 25356*/ GIMT_Encode4(1878417), // Rule ID 14475 //
     /* 1878333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1878344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1878347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1878350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878379 */     // MIs[0] policy
     /* 1878379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878389 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878416 */     // GIR_Coverage, 14475,
     /* 1878416 */     GIR_EraseRootFromParent_Done,
     /* 1878417 */   // Label 25356: @1878417
     /* 1878417 */   GIM_Try, /*On fail goto*//*Label 25357*/ GIMT_Encode4(1878506), // Rule ID 14478 //
     /* 1878422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1878439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878468 */     // MIs[0] policy
     /* 1878468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878505 */     // GIR_Coverage, 14478,
     /* 1878505 */     GIR_EraseRootFromParent_Done,
     /* 1878506 */   // Label 25357: @1878506
     /* 1878506 */   GIM_Try, /*On fail goto*//*Label 25358*/ GIMT_Encode4(1878595), // Rule ID 14479 //
     /* 1878511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1878522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1878525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1878528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878557 */     // MIs[0] policy
     /* 1878557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878567 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1878570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878594 */     // GIR_Coverage, 14479,
     /* 1878594 */     GIR_EraseRootFromParent_Done,
     /* 1878595 */   // Label 25358: @1878595
     /* 1878595 */   GIM_Try, /*On fail goto*//*Label 25359*/ GIMT_Encode4(1878684), // Rule ID 14482 //
     /* 1878600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1878611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1878614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1878617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1878623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878646 */     // MIs[0] policy
     /* 1878646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878656 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878683 */     // GIR_Coverage, 14482,
     /* 1878683 */     GIR_EraseRootFromParent_Done,
     /* 1878684 */   // Label 25359: @1878684
     /* 1878684 */   GIM_Try, /*On fail goto*//*Label 25360*/ GIMT_Encode4(1878773), // Rule ID 14483 //
     /* 1878689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1878692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1878700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1878703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1878706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1878712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878735 */     // MIs[0] policy
     /* 1878735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878745 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1878748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878772 */     // GIR_Coverage, 14483,
     /* 1878772 */     GIR_EraseRootFromParent_Done,
     /* 1878773 */   // Label 25360: @1878773
     /* 1878773 */   GIM_Try, /*On fail goto*//*Label 25361*/ GIMT_Encode4(1878862), // Rule ID 14486 //
     /* 1878778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1878789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1878792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1878795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878824 */     // MIs[0] policy
     /* 1878824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878861 */     // GIR_Coverage, 14486,
     /* 1878861 */     GIR_EraseRootFromParent_Done,
     /* 1878862 */   // Label 25361: @1878862
     /* 1878862 */   GIM_Try, /*On fail goto*//*Label 25362*/ GIMT_Encode4(1878951), // Rule ID 14487 //
     /* 1878867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1878870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1878878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1878881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1878884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1878890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878913 */     // MIs[0] policy
     /* 1878913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878923 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1878926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878950 */     // GIR_Coverage, 14487,
     /* 1878950 */     GIR_EraseRootFromParent_Done,
     /* 1878951 */   // Label 25362: @1878951
     /* 1878951 */   GIM_Try, /*On fail goto*//*Label 25363*/ GIMT_Encode4(1879040), // Rule ID 14490 //
     /* 1878956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1878964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1878967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1878970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1878973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879002 */     // MIs[0] policy
     /* 1879002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879012 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879039 */     // GIR_Coverage, 14490,
     /* 1879039 */     GIR_EraseRootFromParent_Done,
     /* 1879040 */   // Label 25363: @1879040
     /* 1879040 */   GIM_Try, /*On fail goto*//*Label 25364*/ GIMT_Encode4(1879129), // Rule ID 14491 //
     /* 1879045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1879048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1879053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1879056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1879059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1879062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879091 */     // MIs[0] policy
     /* 1879091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879101 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1879104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879128 */     // GIR_Coverage, 14491,
     /* 1879128 */     GIR_EraseRootFromParent_Done,
     /* 1879129 */   // Label 25364: @1879129
     /* 1879129 */   GIM_Try, /*On fail goto*//*Label 25365*/ GIMT_Encode4(1879218), // Rule ID 14582 //
     /* 1879134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1879154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879180 */     // MIs[0] policy
     /* 1879180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879190 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1879193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879217 */     // GIR_Coverage, 14582,
     /* 1879217 */     GIR_EraseRootFromParent_Done,
     /* 1879218 */   // Label 25365: @1879218
     /* 1879218 */   GIM_Try, /*On fail goto*//*Label 25366*/ GIMT_Encode4(1879307), // Rule ID 14583 //
     /* 1879223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1879234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1879237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1879240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1879243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879269 */     // MIs[0] policy
     /* 1879269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879279 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1879282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879306 */     // GIR_Coverage, 14583,
     /* 1879306 */     GIR_EraseRootFromParent_Done,
     /* 1879307 */   // Label 25366: @1879307
     /* 1879307 */   GIM_Try, /*On fail goto*//*Label 25367*/ GIMT_Encode4(1879396), // Rule ID 14586 //
     /* 1879312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1879332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879358 */     // MIs[0] policy
     /* 1879358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879395 */     // GIR_Coverage, 14586,
     /* 1879395 */     GIR_EraseRootFromParent_Done,
     /* 1879396 */   // Label 25367: @1879396
     /* 1879396 */   GIM_Try, /*On fail goto*//*Label 25368*/ GIMT_Encode4(1879485), // Rule ID 14587 //
     /* 1879401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1879412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1879415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1879418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1879421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879447 */     // MIs[0] policy
     /* 1879447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879457 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879484 */     // GIR_Coverage, 14587,
     /* 1879484 */     GIR_EraseRootFromParent_Done,
     /* 1879485 */   // Label 25368: @1879485
     /* 1879485 */   GIM_Try, /*On fail goto*//*Label 25369*/ GIMT_Encode4(1879574), // Rule ID 14590 //
     /* 1879490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1879501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1879504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1879507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1879510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879536 */     // MIs[0] policy
     /* 1879536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879546 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1879549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879573 */     // GIR_Coverage, 14590,
     /* 1879573 */     GIR_EraseRootFromParent_Done,
     /* 1879574 */   // Label 25369: @1879574
     /* 1879574 */   GIM_Try, /*On fail goto*//*Label 25370*/ GIMT_Encode4(1879663), // Rule ID 14591 //
     /* 1879579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1879590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1879593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1879596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1879599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879625 */     // MIs[0] policy
     /* 1879625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879635 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1879638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1879656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879662 */     // GIR_Coverage, 14591,
     /* 1879662 */     GIR_EraseRootFromParent_Done,
     /* 1879663 */   // Label 25370: @1879663
     /* 1879663 */   GIM_Try, /*On fail goto*//*Label 25371*/ GIMT_Encode4(1879752), // Rule ID 14594 //
     /* 1879668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1879679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1879682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1879685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1879688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879714 */     // MIs[0] policy
     /* 1879714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879751 */     // GIR_Coverage, 14594,
     /* 1879751 */     GIR_EraseRootFromParent_Done,
     /* 1879752 */   // Label 25371: @1879752
     /* 1879752 */   GIM_Try, /*On fail goto*//*Label 25372*/ GIMT_Encode4(1879841), // Rule ID 14595 //
     /* 1879757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1879768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1879771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1879774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1879777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1879780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879803 */     // MIs[0] policy
     /* 1879803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879813 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1879816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879840 */     // GIR_Coverage, 14595,
     /* 1879840 */     GIR_EraseRootFromParent_Done,
     /* 1879841 */   // Label 25372: @1879841
     /* 1879841 */   GIM_Try, /*On fail goto*//*Label 25373*/ GIMT_Encode4(1879930), // Rule ID 14598 //
     /* 1879846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1879857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1879860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1879863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1879866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879892 */     // MIs[0] policy
     /* 1879892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879902 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1879905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879929 */     // GIR_Coverage, 14598,
     /* 1879929 */     GIR_EraseRootFromParent_Done,
     /* 1879930 */   // Label 25373: @1879930
     /* 1879930 */   GIM_Try, /*On fail goto*//*Label 25374*/ GIMT_Encode4(1880019), // Rule ID 14599 //
     /* 1879935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1879946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1879949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1879952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1879955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1879965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1879977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879981 */     // MIs[0] policy
     /* 1879981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879991 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1879994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880018 */     // GIR_Coverage, 14599,
     /* 1880018 */     GIR_EraseRootFromParent_Done,
     /* 1880019 */   // Label 25374: @1880019
     /* 1880019 */   GIM_Try, /*On fail goto*//*Label 25375*/ GIMT_Encode4(1880108), // Rule ID 14602 //
     /* 1880024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880070 */     // MIs[0] policy
     /* 1880070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880080 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880107 */     // GIR_Coverage, 14602,
     /* 1880107 */     GIR_EraseRootFromParent_Done,
     /* 1880108 */   // Label 25375: @1880108
     /* 1880108 */   GIM_Try, /*On fail goto*//*Label 25376*/ GIMT_Encode4(1880197), // Rule ID 14603 //
     /* 1880113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1880124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1880127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1880130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1880133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880159 */     // MIs[0] policy
     /* 1880159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880169 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1880172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880196 */     // GIR_Coverage, 14603,
     /* 1880196 */     GIR_EraseRootFromParent_Done,
     /* 1880197 */   // Label 25376: @1880197
     /* 1880197 */   GIM_Try, /*On fail goto*//*Label 25377*/ GIMT_Encode4(1880286), // Rule ID 14606 //
     /* 1880202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1880222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880248 */     // MIs[0] policy
     /* 1880248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880285 */     // GIR_Coverage, 14606,
     /* 1880285 */     GIR_EraseRootFromParent_Done,
     /* 1880286 */   // Label 25377: @1880286
     /* 1880286 */   GIM_Try, /*On fail goto*//*Label 25378*/ GIMT_Encode4(1880375), // Rule ID 14607 //
     /* 1880291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1880302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1880305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1880308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1880311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880337 */     // MIs[0] policy
     /* 1880337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880347 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880374 */     // GIR_Coverage, 14607,
     /* 1880374 */     GIR_EraseRootFromParent_Done,
     /* 1880375 */   // Label 25378: @1880375
     /* 1880375 */   GIM_Try, /*On fail goto*//*Label 25379*/ GIMT_Encode4(1880464), // Rule ID 14610 //
     /* 1880380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1880400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880426 */     // MIs[0] policy
     /* 1880426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880436 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880463 */     // GIR_Coverage, 14610,
     /* 1880463 */     GIR_EraseRootFromParent_Done,
     /* 1880464 */   // Label 25379: @1880464
     /* 1880464 */   GIM_Try, /*On fail goto*//*Label 25380*/ GIMT_Encode4(1880553), // Rule ID 14611 //
     /* 1880469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1880480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1880483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1880486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1880489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880515 */     // MIs[0] policy
     /* 1880515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880525 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880552 */     // GIR_Coverage, 14611,
     /* 1880552 */     GIR_EraseRootFromParent_Done,
     /* 1880553 */   // Label 25380: @1880553
     /* 1880553 */   GIM_Try, /*On fail goto*//*Label 25381*/ GIMT_Encode4(1880642), // Rule ID 14614 //
     /* 1880558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1880569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1880572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1880575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1880578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880604 */     // MIs[0] policy
     /* 1880604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880614 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880641 */     // GIR_Coverage, 14614,
     /* 1880641 */     GIR_EraseRootFromParent_Done,
     /* 1880642 */   // Label 25381: @1880642
     /* 1880642 */   GIM_Try, /*On fail goto*//*Label 25382*/ GIMT_Encode4(1880731), // Rule ID 14615 //
     /* 1880647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1880658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1880661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1880664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1880667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880693 */     // MIs[0] policy
     /* 1880693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880703 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1880724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880730 */     // GIR_Coverage, 14615,
     /* 1880730 */     GIR_EraseRootFromParent_Done,
     /* 1880731 */   // Label 25382: @1880731
     /* 1880731 */   GIM_Try, /*On fail goto*//*Label 25383*/ GIMT_Encode4(1880820), // Rule ID 14618 //
     /* 1880736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1880739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1880747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1880750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1880753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1880756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880782 */     // MIs[0] policy
     /* 1880782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880819 */     // GIR_Coverage, 14618,
     /* 1880819 */     GIR_EraseRootFromParent_Done,
     /* 1880820 */   // Label 25383: @1880820
     /* 1880820 */   GIM_Try, /*On fail goto*//*Label 25384*/ GIMT_Encode4(1880909), // Rule ID 14619 //
     /* 1880825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1880828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1880836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1880839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1880842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1880845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880871 */     // MIs[0] policy
     /* 1880871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880881 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1880884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880908 */     // GIR_Coverage, 14619,
     /* 1880908 */     GIR_EraseRootFromParent_Done,
     /* 1880909 */   // Label 25384: @1880909
     /* 1880909 */   GIM_Try, /*On fail goto*//*Label 25385*/ GIMT_Encode4(1880998), // Rule ID 14622 //
     /* 1880914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1880925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1880928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1880931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1880934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1880937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1880944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1880956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880960 */     // MIs[0] policy
     /* 1880960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880970 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1880973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880997 */     // GIR_Coverage, 14622,
     /* 1880997 */     GIR_EraseRootFromParent_Done,
     /* 1880998 */   // Label 25385: @1880998
     /* 1880998 */   GIM_Try, /*On fail goto*//*Label 25386*/ GIMT_Encode4(1881087), // Rule ID 14623 //
     /* 1881003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1881014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1881017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1881020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1881023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881049 */     // MIs[0] policy
     /* 1881049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881086 */     // GIR_Coverage, 14623,
     /* 1881086 */     GIR_EraseRootFromParent_Done,
     /* 1881087 */   // Label 25386: @1881087
     /* 1881087 */   GIM_Try, /*On fail goto*//*Label 25387*/ GIMT_Encode4(1881176), // Rule ID 14626 //
     /* 1881092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881138 */     // MIs[0] policy
     /* 1881138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881148 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881175 */     // GIR_Coverage, 14626,
     /* 1881175 */     GIR_EraseRootFromParent_Done,
     /* 1881176 */   // Label 25387: @1881176
     /* 1881176 */   GIM_Try, /*On fail goto*//*Label 25388*/ GIMT_Encode4(1881265), // Rule ID 14627 //
     /* 1881181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1881192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1881195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1881198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1881201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881227 */     // MIs[0] policy
     /* 1881227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881237 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881264 */     // GIR_Coverage, 14627,
     /* 1881264 */     GIR_EraseRootFromParent_Done,
     /* 1881265 */   // Label 25388: @1881265
     /* 1881265 */   GIM_Try, /*On fail goto*//*Label 25389*/ GIMT_Encode4(1881354), // Rule ID 14630 //
     /* 1881270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1881290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881316 */     // MIs[0] policy
     /* 1881316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881353 */     // GIR_Coverage, 14630,
     /* 1881353 */     GIR_EraseRootFromParent_Done,
     /* 1881354 */   // Label 25389: @1881354
     /* 1881354 */   GIM_Try, /*On fail goto*//*Label 25390*/ GIMT_Encode4(1881443), // Rule ID 14631 //
     /* 1881359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1881370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1881373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1881376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1881379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1881382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881405 */     // MIs[0] policy
     /* 1881405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881415 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881442 */     // GIR_Coverage, 14631,
     /* 1881442 */     GIR_EraseRootFromParent_Done,
     /* 1881443 */   // Label 25390: @1881443
     /* 1881443 */   GIM_Try, /*On fail goto*//*Label 25391*/ GIMT_Encode4(1881532), // Rule ID 14634 //
     /* 1881448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1881459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1881462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1881465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1881468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881494 */     // MIs[0] policy
     /* 1881494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881531 */     // GIR_Coverage, 14634,
     /* 1881531 */     GIR_EraseRootFromParent_Done,
     /* 1881532 */   // Label 25391: @1881532
     /* 1881532 */   GIM_Try, /*On fail goto*//*Label 25392*/ GIMT_Encode4(1881621), // Rule ID 14635 //
     /* 1881537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1881548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1881551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1881554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1881557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1881567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1881579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881583 */     // MIs[0] policy
     /* 1881583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881593 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1881596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881620 */     // GIR_Coverage, 14635,
     /* 1881620 */     GIR_EraseRootFromParent_Done,
     /* 1881621 */   // Label 25392: @1881621
     /* 1881621 */   GIM_Try, /*On fail goto*//*Label 25393*/ GIMT_Encode4(1881710), // Rule ID 14638 //
     /* 1881626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1881637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1881640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1881643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1881646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881672 */     // MIs[0] policy
     /* 1881672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881682 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881709 */     // GIR_Coverage, 14638,
     /* 1881709 */     GIR_EraseRootFromParent_Done,
     /* 1881710 */   // Label 25393: @1881710
     /* 1881710 */   GIM_Try, /*On fail goto*//*Label 25394*/ GIMT_Encode4(1881799), // Rule ID 14639 //
     /* 1881715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1881726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1881729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1881732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1881735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1881738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1881745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1881757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881761 */     // MIs[0] policy
     /* 1881761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1881774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881798 */     // GIR_Coverage, 14639,
     /* 1881798 */     GIR_EraseRootFromParent_Done,
     /* 1881799 */   // Label 25394: @1881799
     /* 1881799 */   GIM_Try, /*On fail goto*//*Label 25395*/ GIMT_Encode4(1881888), // Rule ID 14642 //
     /* 1881804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1881815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1881818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1881821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1881824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881850 */     // MIs[0] policy
     /* 1881850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881860 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881887 */     // GIR_Coverage, 14642,
     /* 1881887 */     GIR_EraseRootFromParent_Done,
     /* 1881888 */   // Label 25395: @1881888
     /* 1881888 */   GIM_Try, /*On fail goto*//*Label 25396*/ GIMT_Encode4(1881977), // Rule ID 14643 //
     /* 1881893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1881904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1881907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1881910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1881913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1881916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1881923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1881935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881939 */     // MIs[0] policy
     /* 1881939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881949 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1881952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881976 */     // GIR_Coverage, 14643,
     /* 1881976 */     GIR_EraseRootFromParent_Done,
     /* 1881977 */   // Label 25396: @1881977
     /* 1881977 */   GIM_Try, /*On fail goto*//*Label 25397*/ GIMT_Encode4(1882066), // Rule ID 14646 //
     /* 1881982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1881990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1881993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1881996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1881999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882028 */     // MIs[0] policy
     /* 1882028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882038 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882065 */     // GIR_Coverage, 14646,
     /* 1882065 */     GIR_EraseRootFromParent_Done,
     /* 1882066 */   // Label 25397: @1882066
     /* 1882066 */   GIM_Try, /*On fail goto*//*Label 25398*/ GIMT_Encode4(1882155), // Rule ID 14647 //
     /* 1882071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1882082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1882085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1882088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1882091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882117 */     // MIs[0] policy
     /* 1882117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882154 */     // GIR_Coverage, 14647,
     /* 1882154 */     GIR_EraseRootFromParent_Done,
     /* 1882155 */   // Label 25398: @1882155
     /* 1882155 */   GIM_Try, /*On fail goto*//*Label 25399*/ GIMT_Encode4(1882244), // Rule ID 14650 //
     /* 1882160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1882180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882206 */     // MIs[0] policy
     /* 1882206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882243 */     // GIR_Coverage, 14650,
     /* 1882243 */     GIR_EraseRootFromParent_Done,
     /* 1882244 */   // Label 25399: @1882244
     /* 1882244 */   GIM_Try, /*On fail goto*//*Label 25400*/ GIMT_Encode4(1882333), // Rule ID 14651 //
     /* 1882249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1882260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1882263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1882266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1882269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882295 */     // MIs[0] policy
     /* 1882295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882305 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882332 */     // GIR_Coverage, 14651,
     /* 1882332 */     GIR_EraseRootFromParent_Done,
     /* 1882333 */   // Label 25400: @1882333
     /* 1882333 */   GIM_Try, /*On fail goto*//*Label 25401*/ GIMT_Encode4(1882422), // Rule ID 14654 //
     /* 1882338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1882358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882384 */     // MIs[0] policy
     /* 1882384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882394 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882421 */     // GIR_Coverage, 14654,
     /* 1882421 */     GIR_EraseRootFromParent_Done,
     /* 1882422 */   // Label 25401: @1882422
     /* 1882422 */   GIM_Try, /*On fail goto*//*Label 25402*/ GIMT_Encode4(1882511), // Rule ID 14655 //
     /* 1882427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1882438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1882441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1882444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1882447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882473 */     // MIs[0] policy
     /* 1882473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882483 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1882504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882510 */     // GIR_Coverage, 14655,
     /* 1882510 */     GIR_EraseRootFromParent_Done,
     /* 1882511 */   // Label 25402: @1882511
     /* 1882511 */   GIM_Try, /*On fail goto*//*Label 25403*/ GIMT_Encode4(1882600), // Rule ID 14658 //
     /* 1882516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1882527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1882530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1882533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1882536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1882539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882562 */     // MIs[0] policy
     /* 1882562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882572 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882599 */     // GIR_Coverage, 14658,
     /* 1882599 */     GIR_EraseRootFromParent_Done,
     /* 1882600 */   // Label 25403: @1882600
     /* 1882600 */   GIM_Try, /*On fail goto*//*Label 25404*/ GIMT_Encode4(1882689), // Rule ID 14659 //
     /* 1882605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1882616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1882619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1882622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1882625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1882628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882651 */     // MIs[0] policy
     /* 1882651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882661 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1882664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882688 */     // GIR_Coverage, 14659,
     /* 1882688 */     GIR_EraseRootFromParent_Done,
     /* 1882689 */   // Label 25404: @1882689
     /* 1882689 */   GIM_Try, /*On fail goto*//*Label 25405*/ GIMT_Encode4(1882778), // Rule ID 14662 //
     /* 1882694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1882705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1882708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1882711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1882714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882740 */     // MIs[0] policy
     /* 1882740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882750 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882777 */     // GIR_Coverage, 14662,
     /* 1882777 */     GIR_EraseRootFromParent_Done,
     /* 1882778 */   // Label 25405: @1882778
     /* 1882778 */   GIM_Try, /*On fail goto*//*Label 25406*/ GIMT_Encode4(1882867), // Rule ID 14663 //
     /* 1882783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1882794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1882797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1882800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1882803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1882806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882829 */     // MIs[0] policy
     /* 1882829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882839 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1882842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882866 */     // GIR_Coverage, 14663,
     /* 1882866 */     GIR_EraseRootFromParent_Done,
     /* 1882867 */   // Label 25406: @1882867
     /* 1882867 */   GIM_Try, /*On fail goto*//*Label 25407*/ GIMT_Encode4(1882956), // Rule ID 14666 //
     /* 1882872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1882875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1882883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1882886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1882889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1882892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882918 */     // MIs[0] policy
     /* 1882918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882928 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1882931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882955 */     // GIR_Coverage, 14666,
     /* 1882955 */     GIR_EraseRootFromParent_Done,
     /* 1882956 */   // Label 25407: @1882956
     /* 1882956 */   GIM_Try, /*On fail goto*//*Label 25408*/ GIMT_Encode4(1883045), // Rule ID 14667 //
     /* 1882961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1882969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1882972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1882975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1882978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1882981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883007 */     // MIs[0] policy
     /* 1883007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883017 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1883020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883044 */     // GIR_Coverage, 14667,
     /* 1883044 */     GIR_EraseRootFromParent_Done,
     /* 1883045 */   // Label 25408: @1883045
     /* 1883045 */   GIM_Try, /*On fail goto*//*Label 25409*/ GIMT_Encode4(1883134), // Rule ID 14670 //
     /* 1883050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883096 */     // MIs[0] policy
     /* 1883096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883106 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1883109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883133 */     // GIR_Coverage, 14670,
     /* 1883133 */     GIR_EraseRootFromParent_Done,
     /* 1883134 */   // Label 25409: @1883134
     /* 1883134 */   GIM_Try, /*On fail goto*//*Label 25410*/ GIMT_Encode4(1883223), // Rule ID 14671 //
     /* 1883139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1883150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1883153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1883156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883185 */     // MIs[0] policy
     /* 1883185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883195 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1883198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883222 */     // GIR_Coverage, 14671,
     /* 1883222 */     GIR_EraseRootFromParent_Done,
     /* 1883223 */   // Label 25410: @1883223
     /* 1883223 */   GIM_Try, /*On fail goto*//*Label 25411*/ GIMT_Encode4(1883312), // Rule ID 14674 //
     /* 1883228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883274 */     // MIs[0] policy
     /* 1883274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883284 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883311 */     // GIR_Coverage, 14674,
     /* 1883311 */     GIR_EraseRootFromParent_Done,
     /* 1883312 */   // Label 25411: @1883312
     /* 1883312 */   GIM_Try, /*On fail goto*//*Label 25412*/ GIMT_Encode4(1883401), // Rule ID 14675 //
     /* 1883317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1883328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1883331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1883334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883363 */     // MIs[0] policy
     /* 1883363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883373 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883400 */     // GIR_Coverage, 14675,
     /* 1883400 */     GIR_EraseRootFromParent_Done,
     /* 1883401 */   // Label 25412: @1883401
     /* 1883401 */   GIM_Try, /*On fail goto*//*Label 25413*/ GIMT_Encode4(1883490), // Rule ID 14678 //
     /* 1883406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883452 */     // MIs[0] policy
     /* 1883452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883462 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883489 */     // GIR_Coverage, 14678,
     /* 1883489 */     GIR_EraseRootFromParent_Done,
     /* 1883490 */   // Label 25413: @1883490
     /* 1883490 */   GIM_Try, /*On fail goto*//*Label 25414*/ GIMT_Encode4(1883579), // Rule ID 14679 //
     /* 1883495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1883506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1883509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1883512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883541 */     // MIs[0] policy
     /* 1883541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883551 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1883572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883578 */     // GIR_Coverage, 14679,
     /* 1883578 */     GIR_EraseRootFromParent_Done,
     /* 1883579 */   // Label 25414: @1883579
     /* 1883579 */   GIM_Try, /*On fail goto*//*Label 25415*/ GIMT_Encode4(1883668), // Rule ID 14682 //
     /* 1883584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1883595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1883598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1883601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883630 */     // MIs[0] policy
     /* 1883630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883640 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883667 */     // GIR_Coverage, 14682,
     /* 1883667 */     GIR_EraseRootFromParent_Done,
     /* 1883668 */   // Label 25415: @1883668
     /* 1883668 */   GIM_Try, /*On fail goto*//*Label 25416*/ GIMT_Encode4(1883757), // Rule ID 14683 //
     /* 1883673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1883684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1883687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1883690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883719 */     // MIs[0] policy
     /* 1883719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883729 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1883732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883756 */     // GIR_Coverage, 14683,
     /* 1883756 */     GIR_EraseRootFromParent_Done,
     /* 1883757 */   // Label 25416: @1883757
     /* 1883757 */   GIM_Try, /*On fail goto*//*Label 25417*/ GIMT_Encode4(1883846), // Rule ID 14686 //
     /* 1883762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1883773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1883776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1883779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883808 */     // MIs[0] policy
     /* 1883808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883818 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883845 */     // GIR_Coverage, 14686,
     /* 1883845 */     GIR_EraseRootFromParent_Done,
     /* 1883846 */   // Label 25417: @1883846
     /* 1883846 */   GIM_Try, /*On fail goto*//*Label 25418*/ GIMT_Encode4(1883935), // Rule ID 14687 //
     /* 1883851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1883862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1883865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1883868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1883871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883897 */     // MIs[0] policy
     /* 1883897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883907 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883934 */     // GIR_Coverage, 14687,
     /* 1883934 */     GIR_EraseRootFromParent_Done,
     /* 1883935 */   // Label 25418: @1883935
     /* 1883935 */   GIM_Try, /*On fail goto*//*Label 25419*/ GIMT_Encode4(1884024), // Rule ID 14690 //
     /* 1883940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1883948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1883951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1883954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1883957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1883960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1883963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1883970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1883978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1883982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883986 */     // MIs[0] policy
     /* 1883986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883996 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1883999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884023 */     // GIR_Coverage, 14690,
     /* 1884023 */     GIR_EraseRootFromParent_Done,
     /* 1884024 */   // Label 25419: @1884024
     /* 1884024 */   GIM_Try, /*On fail goto*//*Label 25420*/ GIMT_Encode4(1884113), // Rule ID 14691 //
     /* 1884029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1884040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1884043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1884046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884075 */     // MIs[0] policy
     /* 1884075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884085 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1884088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884112 */     // GIR_Coverage, 14691,
     /* 1884112 */     GIR_EraseRootFromParent_Done,
     /* 1884113 */   // Label 25420: @1884113
     /* 1884113 */   GIM_Try, /*On fail goto*//*Label 25421*/ GIMT_Encode4(1884202), // Rule ID 14694 //
     /* 1884118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884164 */     // MIs[0] policy
     /* 1884164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884174 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884201 */     // GIR_Coverage, 14694,
     /* 1884201 */     GIR_EraseRootFromParent_Done,
     /* 1884202 */   // Label 25421: @1884202
     /* 1884202 */   GIM_Try, /*On fail goto*//*Label 25422*/ GIMT_Encode4(1884291), // Rule ID 14695 //
     /* 1884207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1884218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1884221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1884224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884253 */     // MIs[0] policy
     /* 1884253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884263 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11620:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884290 */     // GIR_Coverage, 14695,
     /* 1884290 */     GIR_EraseRootFromParent_Done,
     /* 1884291 */   // Label 25422: @1884291
     /* 1884291 */   GIM_Try, /*On fail goto*//*Label 25423*/ GIMT_Encode4(1884380), // Rule ID 14698 //
     /* 1884296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884342 */     // MIs[0] policy
     /* 1884342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884379 */     // GIR_Coverage, 14698,
     /* 1884379 */     GIR_EraseRootFromParent_Done,
     /* 1884380 */   // Label 25423: @1884380
     /* 1884380 */   GIM_Try, /*On fail goto*//*Label 25424*/ GIMT_Encode4(1884469), // Rule ID 14699 //
     /* 1884385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1884396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1884399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1884402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884431 */     // MIs[0] policy
     /* 1884431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884441 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11620:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884468 */     // GIR_Coverage, 14699,
     /* 1884468 */     GIR_EraseRootFromParent_Done,
     /* 1884469 */   // Label 25424: @1884469
     /* 1884469 */   GIM_Try, /*On fail goto*//*Label 25425*/ GIMT_Encode4(1884558), // Rule ID 14702 //
     /* 1884474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1884485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1884488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1884491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884520 */     // MIs[0] policy
     /* 1884520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884530 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884557 */     // GIR_Coverage, 14702,
     /* 1884557 */     GIR_EraseRootFromParent_Done,
     /* 1884558 */   // Label 25425: @1884558
     /* 1884558 */   GIM_Try, /*On fail goto*//*Label 25426*/ GIMT_Encode4(1884647), // Rule ID 14703 //
     /* 1884563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1884574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1884577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1884580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884609 */     // MIs[0] policy
     /* 1884609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884619 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11620:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1884640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884646 */     // GIR_Coverage, 14703,
     /* 1884646 */     GIR_EraseRootFromParent_Done,
     /* 1884647 */   // Label 25426: @1884647
     /* 1884647 */   GIM_Try, /*On fail goto*//*Label 25427*/ GIMT_Encode4(1884736), // Rule ID 14706 //
     /* 1884652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1884655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1884663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1884666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1884669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884698 */     // MIs[0] policy
     /* 1884698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884735 */     // GIR_Coverage, 14706,
     /* 1884735 */     GIR_EraseRootFromParent_Done,
     /* 1884736 */   // Label 25427: @1884736
     /* 1884736 */   GIM_Try, /*On fail goto*//*Label 25428*/ GIMT_Encode4(1884825), // Rule ID 14707 //
     /* 1884741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1884744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1884752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1884755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1884758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884787 */     // MIs[0] policy
     /* 1884787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884797 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11620:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1884800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884824 */     // GIR_Coverage, 14707,
     /* 1884824 */     GIR_EraseRootFromParent_Done,
     /* 1884825 */   // Label 25428: @1884825
     /* 1884825 */   GIM_Try, /*On fail goto*//*Label 25429*/ GIMT_Encode4(1884914), // Rule ID 14710 //
     /* 1884830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1884841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1884844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1884847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1884853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1884860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884876 */     // MIs[0] policy
     /* 1884876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1884889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884913 */     // GIR_Coverage, 14710,
     /* 1884913 */     GIR_EraseRootFromParent_Done,
     /* 1884914 */   // Label 25429: @1884914
     /* 1884914 */   GIM_Try, /*On fail goto*//*Label 25430*/ GIMT_Encode4(1885003), // Rule ID 14711 //
     /* 1884919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1884927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1884930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1884933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1884936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1884942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1884949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1884957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884965 */     // MIs[0] policy
     /* 1884965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884975 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1884978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885002 */     // GIR_Coverage, 14711,
     /* 1885002 */     GIR_EraseRootFromParent_Done,
     /* 1885003 */   // Label 25430: @1885003
     /* 1885003 */   GIM_Try, /*On fail goto*//*Label 25431*/ GIMT_Encode4(1885092), // Rule ID 14714 //
     /* 1885008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885054 */     // MIs[0] policy
     /* 1885054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885064 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885091 */     // GIR_Coverage, 14714,
     /* 1885091 */     GIR_EraseRootFromParent_Done,
     /* 1885092 */   // Label 25431: @1885092
     /* 1885092 */   GIM_Try, /*On fail goto*//*Label 25432*/ GIMT_Encode4(1885181), // Rule ID 14715 //
     /* 1885097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1885108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1885111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1885114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885143 */     // MIs[0] policy
     /* 1885143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885153 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885180 */     // GIR_Coverage, 14715,
     /* 1885180 */     GIR_EraseRootFromParent_Done,
     /* 1885181 */   // Label 25432: @1885181
     /* 1885181 */   GIM_Try, /*On fail goto*//*Label 25433*/ GIMT_Encode4(1885270), // Rule ID 14718 //
     /* 1885186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885232 */     // MIs[0] policy
     /* 1885232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885242 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885269 */     // GIR_Coverage, 14718,
     /* 1885269 */     GIR_EraseRootFromParent_Done,
     /* 1885270 */   // Label 25433: @1885270
     /* 1885270 */   GIM_Try, /*On fail goto*//*Label 25434*/ GIMT_Encode4(1885359), // Rule ID 14719 //
     /* 1885275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1885286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1885289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1885292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1885298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885321 */     // MIs[0] policy
     /* 1885321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885331 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885358 */     // GIR_Coverage, 14719,
     /* 1885358 */     GIR_EraseRootFromParent_Done,
     /* 1885359 */   // Label 25434: @1885359
     /* 1885359 */   GIM_Try, /*On fail goto*//*Label 25435*/ GIMT_Encode4(1885448), // Rule ID 14722 //
     /* 1885364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885410 */     // MIs[0] policy
     /* 1885410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885420 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885447 */     // GIR_Coverage, 14722,
     /* 1885447 */     GIR_EraseRootFromParent_Done,
     /* 1885448 */   // Label 25435: @1885448
     /* 1885448 */   GIM_Try, /*On fail goto*//*Label 25436*/ GIMT_Encode4(1885537), // Rule ID 14723 //
     /* 1885453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1885464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1885467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1885470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885499 */     // MIs[0] policy
     /* 1885499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885509 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885536 */     // GIR_Coverage, 14723,
     /* 1885536 */     GIR_EraseRootFromParent_Done,
     /* 1885537 */   // Label 25436: @1885537
     /* 1885537 */   GIM_Try, /*On fail goto*//*Label 25437*/ GIMT_Encode4(1885626), // Rule ID 14726 //
     /* 1885542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1885553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1885556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1885559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885588 */     // MIs[0] policy
     /* 1885588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885598 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885625 */     // GIR_Coverage, 14726,
     /* 1885625 */     GIR_EraseRootFromParent_Done,
     /* 1885626 */   // Label 25437: @1885626
     /* 1885626 */   GIM_Try, /*On fail goto*//*Label 25438*/ GIMT_Encode4(1885715), // Rule ID 14727 //
     /* 1885631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1885642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1885645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1885648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1885654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1885661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1885669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885677 */     // MIs[0] policy
     /* 1885677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885687 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1885690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885714 */     // GIR_Coverage, 14727,
     /* 1885714 */     GIR_EraseRootFromParent_Done,
     /* 1885715 */   // Label 25438: @1885715
     /* 1885715 */   GIM_Try, /*On fail goto*//*Label 25439*/ GIMT_Encode4(1885804), // Rule ID 14730 //
     /* 1885720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1885731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1885734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1885737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885766 */     // MIs[0] policy
     /* 1885766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885803 */     // GIR_Coverage, 14730,
     /* 1885803 */     GIR_EraseRootFromParent_Done,
     /* 1885804 */   // Label 25439: @1885804
     /* 1885804 */   GIM_Try, /*On fail goto*//*Label 25440*/ GIMT_Encode4(1885893), // Rule ID 14731 //
     /* 1885809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1885820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1885823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1885826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1885832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1885839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1885847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885855 */     // MIs[0] policy
     /* 1885855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885865 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1885868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885892 */     // GIR_Coverage, 14731,
     /* 1885892 */     GIR_EraseRootFromParent_Done,
     /* 1885893 */   // Label 25440: @1885893
     /* 1885893 */   GIM_Try, /*On fail goto*//*Label 25441*/ GIMT_Encode4(1885982), // Rule ID 14734 //
     /* 1885898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1885909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1885912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1885915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1885921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1885928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1885936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885944 */     // MIs[0] policy
     /* 1885944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1885957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885981 */     // GIR_Coverage, 14734,
     /* 1885981 */     GIR_EraseRootFromParent_Done,
     /* 1885982 */   // Label 25441: @1885982
     /* 1885982 */   GIM_Try, /*On fail goto*//*Label 25442*/ GIMT_Encode4(1886071), // Rule ID 14735 //
     /* 1885987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1885995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1885998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1886001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1886004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886033 */     // MIs[0] policy
     /* 1886033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886070 */     // GIR_Coverage, 14735,
     /* 1886070 */     GIR_EraseRootFromParent_Done,
     /* 1886071 */   // Label 25442: @1886071
     /* 1886071 */   GIM_Try, /*On fail goto*//*Label 25443*/ GIMT_Encode4(1886160), // Rule ID 14738 //
     /* 1886076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886122 */     // MIs[0] policy
     /* 1886122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886132 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886159 */     // GIR_Coverage, 14738,
     /* 1886159 */     GIR_EraseRootFromParent_Done,
     /* 1886160 */   // Label 25443: @1886160
     /* 1886160 */   GIM_Try, /*On fail goto*//*Label 25444*/ GIMT_Encode4(1886249), // Rule ID 14739 //
     /* 1886165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1886176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1886179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1886182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886211 */     // MIs[0] policy
     /* 1886211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886221 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886248 */     // GIR_Coverage, 14739,
     /* 1886248 */     GIR_EraseRootFromParent_Done,
     /* 1886249 */   // Label 25444: @1886249
     /* 1886249 */   GIM_Try, /*On fail goto*//*Label 25445*/ GIMT_Encode4(1886338), // Rule ID 14742 //
     /* 1886254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886300 */     // MIs[0] policy
     /* 1886300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886310 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886337 */     // GIR_Coverage, 14742,
     /* 1886337 */     GIR_EraseRootFromParent_Done,
     /* 1886338 */   // Label 25445: @1886338
     /* 1886338 */   GIM_Try, /*On fail goto*//*Label 25446*/ GIMT_Encode4(1886427), // Rule ID 14743 //
     /* 1886343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1886354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1886357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1886360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886389 */     // MIs[0] policy
     /* 1886389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886399 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1886420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886426 */     // GIR_Coverage, 14743,
     /* 1886426 */     GIR_EraseRootFromParent_Done,
     /* 1886427 */   // Label 25446: @1886427
     /* 1886427 */   GIM_Try, /*On fail goto*//*Label 25447*/ GIMT_Encode4(1886516), // Rule ID 14746 //
     /* 1886432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1886443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1886446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1886449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886478 */     // MIs[0] policy
     /* 1886478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886488 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886515 */     // GIR_Coverage, 14746,
     /* 1886515 */     GIR_EraseRootFromParent_Done,
     /* 1886516 */   // Label 25447: @1886516
     /* 1886516 */   GIM_Try, /*On fail goto*//*Label 25448*/ GIMT_Encode4(1886605), // Rule ID 14747 //
     /* 1886521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1886532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1886535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1886538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1886544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886567 */     // MIs[0] policy
     /* 1886567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886577 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11620:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1886580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886604 */     // GIR_Coverage, 14747,
     /* 1886604 */     GIR_EraseRootFromParent_Done,
     /* 1886605 */   // Label 25448: @1886605
     /* 1886605 */   GIM_Try, /*On fail goto*//*Label 25449*/ GIMT_Encode4(1886694), // Rule ID 14750 //
     /* 1886610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1886621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1886624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1886627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886656 */     // MIs[0] policy
     /* 1886656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886666 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886693 */     // GIR_Coverage, 14750,
     /* 1886693 */     GIR_EraseRootFromParent_Done,
     /* 1886694 */   // Label 25449: @1886694
     /* 1886694 */   GIM_Try, /*On fail goto*//*Label 25450*/ GIMT_Encode4(1886783), // Rule ID 14751 //
     /* 1886699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1886710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1886713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1886716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1886722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886745 */     // MIs[0] policy
     /* 1886745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886755 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11620:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1886758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886782 */     // GIR_Coverage, 14751,
     /* 1886782 */     GIR_EraseRootFromParent_Done,
     /* 1886783 */   // Label 25450: @1886783
     /* 1886783 */   GIM_Try, /*On fail goto*//*Label 25451*/ GIMT_Encode4(1886872), // Rule ID 14754 //
     /* 1886788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1886791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1886799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1886802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1886805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886834 */     // MIs[0] policy
     /* 1886834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886844 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886871 */     // GIR_Coverage, 14754,
     /* 1886871 */     GIR_EraseRootFromParent_Done,
     /* 1886872 */   // Label 25451: @1886872
     /* 1886872 */   GIM_Try, /*On fail goto*//*Label 25452*/ GIMT_Encode4(1886961), // Rule ID 14755 //
     /* 1886877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1886880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1886885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1886888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1886891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1886894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886923 */     // MIs[0] policy
     /* 1886923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886933 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11620:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1886936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886960 */     // GIR_Coverage, 14755,
     /* 1886960 */     GIR_EraseRootFromParent_Done,
     /* 1886961 */   // Label 25452: @1886961
     /* 1886961 */   GIM_Try, /*On fail goto*//*Label 25453*/ GIMT_Encode4(1887050), // Rule ID 14758 //
     /* 1886966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1886977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1886980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1886983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1886986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1886989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1886996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887012 */     // MIs[0] policy
     /* 1887012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887022 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1887025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887049 */     // GIR_Coverage, 14758,
     /* 1887049 */     GIR_EraseRootFromParent_Done,
     /* 1887050 */   // Label 25453: @1887050
     /* 1887050 */   GIM_Try, /*On fail goto*//*Label 25454*/ GIMT_Encode4(1887139), // Rule ID 14759 //
     /* 1887055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1887066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1887069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1887072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1887075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887101 */     // MIs[0] policy
     /* 1887101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887111 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1887114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887138 */     // GIR_Coverage, 14759,
     /* 1887138 */     GIR_EraseRootFromParent_Done,
     /* 1887139 */   // Label 25454: @1887139
     /* 1887139 */   GIM_Try, /*On fail goto*//*Label 25455*/ GIMT_Encode4(1887228), // Rule ID 14762 //
     /* 1887144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887190 */     // MIs[0] policy
     /* 1887190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887227 */     // GIR_Coverage, 14762,
     /* 1887227 */     GIR_EraseRootFromParent_Done,
     /* 1887228 */   // Label 25455: @1887228
     /* 1887228 */   GIM_Try, /*On fail goto*//*Label 25456*/ GIMT_Encode4(1887317), // Rule ID 14763 //
     /* 1887233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1887244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1887247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1887250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1887253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887279 */     // MIs[0] policy
     /* 1887279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887289 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887316 */     // GIR_Coverage, 14763,
     /* 1887316 */     GIR_EraseRootFromParent_Done,
     /* 1887317 */   // Label 25456: @1887317
     /* 1887317 */   GIM_Try, /*On fail goto*//*Label 25457*/ GIMT_Encode4(1887406), // Rule ID 14766 //
     /* 1887322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1887342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887368 */     // MIs[0] policy
     /* 1887368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887378 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887405 */     // GIR_Coverage, 14766,
     /* 1887405 */     GIR_EraseRootFromParent_Done,
     /* 1887406 */   // Label 25457: @1887406
     /* 1887406 */   GIM_Try, /*On fail goto*//*Label 25458*/ GIMT_Encode4(1887495), // Rule ID 14767 //
     /* 1887411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1887422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1887425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1887428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1887431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887457 */     // MIs[0] policy
     /* 1887457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887467 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1887488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887494 */     // GIR_Coverage, 14767,
     /* 1887494 */     GIR_EraseRootFromParent_Done,
     /* 1887495 */   // Label 25458: @1887495
     /* 1887495 */   GIM_Try, /*On fail goto*//*Label 25459*/ GIMT_Encode4(1887584), // Rule ID 14770 //
     /* 1887500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1887511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1887514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1887517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1887520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887546 */     // MIs[0] policy
     /* 1887546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887556 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887583 */     // GIR_Coverage, 14770,
     /* 1887583 */     GIR_EraseRootFromParent_Done,
     /* 1887584 */   // Label 25459: @1887584
     /* 1887584 */   GIM_Try, /*On fail goto*//*Label 25460*/ GIMT_Encode4(1887673), // Rule ID 14771 //
     /* 1887589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1887600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1887603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1887606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1887609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887635 */     // MIs[0] policy
     /* 1887635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887645 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1887648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887672 */     // GIR_Coverage, 14771,
     /* 1887672 */     GIR_EraseRootFromParent_Done,
     /* 1887673 */   // Label 25460: @1887673
     /* 1887673 */   GIM_Try, /*On fail goto*//*Label 25461*/ GIMT_Encode4(1887762), // Rule ID 14774 //
     /* 1887678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1887689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1887692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1887695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1887698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887724 */     // MIs[0] policy
     /* 1887724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887761 */     // GIR_Coverage, 14774,
     /* 1887761 */     GIR_EraseRootFromParent_Done,
     /* 1887762 */   // Label 25461: @1887762
     /* 1887762 */   GIM_Try, /*On fail goto*//*Label 25462*/ GIMT_Encode4(1887851), // Rule ID 14775 //
     /* 1887767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1887778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1887781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1887784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1887787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887813 */     // MIs[0] policy
     /* 1887813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887823 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887850 */     // GIR_Coverage, 14775,
     /* 1887850 */     GIR_EraseRootFromParent_Done,
     /* 1887851 */   // Label 25462: @1887851
     /* 1887851 */   GIM_Try, /*On fail goto*//*Label 25463*/ GIMT_Encode4(1887940), // Rule ID 14778 //
     /* 1887856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1887867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1887870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1887873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1887876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887902 */     // MIs[0] policy
     /* 1887902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1887915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887939 */     // GIR_Coverage, 14778,
     /* 1887939 */     GIR_EraseRootFromParent_Done,
     /* 1887940 */   // Label 25463: @1887940
     /* 1887940 */   GIM_Try, /*On fail goto*//*Label 25464*/ GIMT_Encode4(1888029), // Rule ID 14779 //
     /* 1887945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1887956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1887959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1887962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1887965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1887968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1887975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1887987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887991 */     // MIs[0] policy
     /* 1887991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888001 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1888004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888028 */     // GIR_Coverage, 14779,
     /* 1888028 */     GIR_EraseRootFromParent_Done,
     /* 1888029 */   // Label 25464: @1888029
     /* 1888029 */   GIM_Try, /*On fail goto*//*Label 25465*/ GIMT_Encode4(1888118), // Rule ID 14782 //
     /* 1888034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888080 */     // MIs[0] policy
     /* 1888080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888117 */     // GIR_Coverage, 14782,
     /* 1888117 */     GIR_EraseRootFromParent_Done,
     /* 1888118 */   // Label 25465: @1888118
     /* 1888118 */   GIM_Try, /*On fail goto*//*Label 25466*/ GIMT_Encode4(1888207), // Rule ID 14783 //
     /* 1888123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1888134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1888137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1888140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1888143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888169 */     // MIs[0] policy
     /* 1888169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888179 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888206 */     // GIR_Coverage, 14783,
     /* 1888206 */     GIR_EraseRootFromParent_Done,
     /* 1888207 */   // Label 25466: @1888207
     /* 1888207 */   GIM_Try, /*On fail goto*//*Label 25467*/ GIMT_Encode4(1888296), // Rule ID 14786 //
     /* 1888212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888258 */     // MIs[0] policy
     /* 1888258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888295 */     // GIR_Coverage, 14786,
     /* 1888295 */     GIR_EraseRootFromParent_Done,
     /* 1888296 */   // Label 25467: @1888296
     /* 1888296 */   GIM_Try, /*On fail goto*//*Label 25468*/ GIMT_Encode4(1888385), // Rule ID 14787 //
     /* 1888301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888347 */     // MIs[0] policy
     /* 1888347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888357 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888378 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888384 */     // GIR_Coverage, 14787,
     /* 1888384 */     GIR_EraseRootFromParent_Done,
     /* 1888385 */   // Label 25468: @1888385
     /* 1888385 */   GIM_Try, /*On fail goto*//*Label 25469*/ GIMT_Encode4(1888474), // Rule ID 14790 //
     /* 1888390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888436 */     // MIs[0] policy
     /* 1888436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888446 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888473 */     // GIR_Coverage, 14790,
     /* 1888473 */     GIR_EraseRootFromParent_Done,
     /* 1888474 */   // Label 25469: @1888474
     /* 1888474 */   GIM_Try, /*On fail goto*//*Label 25470*/ GIMT_Encode4(1888563), // Rule ID 14791 //
     /* 1888479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888525 */     // MIs[0] policy
     /* 1888525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888535 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888556 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888562 */     // GIR_Coverage, 14791,
     /* 1888562 */     GIR_EraseRootFromParent_Done,
     /* 1888563 */   // Label 25470: @1888563
     /* 1888563 */   GIM_Try, /*On fail goto*//*Label 25471*/ GIMT_Encode4(1888652), // Rule ID 14794 //
     /* 1888568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1888571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1888579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1888582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1888585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1888588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888614 */     // MIs[0] policy
     /* 1888614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888624 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888651 */     // GIR_Coverage, 14794,
     /* 1888651 */     GIR_EraseRootFromParent_Done,
     /* 1888652 */   // Label 25471: @1888652
     /* 1888652 */   GIM_Try, /*On fail goto*//*Label 25472*/ GIMT_Encode4(1888741), // Rule ID 14795 //
     /* 1888657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1888660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1888668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1888671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1888674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1888677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888703 */     // MIs[0] policy
     /* 1888703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1888716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888740 */     // GIR_Coverage, 14795,
     /* 1888740 */     GIR_EraseRootFromParent_Done,
     /* 1888741 */   // Label 25472: @1888741
     /* 1888741 */   GIM_Try, /*On fail goto*//*Label 25473*/ GIMT_Encode4(1888830), // Rule ID 14798 //
     /* 1888746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1888757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1888760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1888763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1888766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1888769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1888776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888792 */     // MIs[0] policy
     /* 1888792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888802 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1888805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888829 */     // GIR_Coverage, 14798,
     /* 1888829 */     GIR_EraseRootFromParent_Done,
     /* 1888830 */   // Label 25473: @1888830
     /* 1888830 */   GIM_Try, /*On fail goto*//*Label 25474*/ GIMT_Encode4(1888919), // Rule ID 14799 //
     /* 1888835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1888838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1888846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1888849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1888852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1888855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1888858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1888865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1888877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888881 */     // MIs[0] policy
     /* 1888881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888891 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1888894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1888912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888918 */     // GIR_Coverage, 14799,
     /* 1888918 */     GIR_EraseRootFromParent_Done,
     /* 1888919 */   // Label 25474: @1888919
     /* 1888919 */   GIM_Try, /*On fail goto*//*Label 25475*/ GIMT_Encode4(1889008), // Rule ID 14802 //
     /* 1888924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1888927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1888935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1888938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1888941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1888944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1888947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1888954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1888966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888970 */     // MIs[0] policy
     /* 1888970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888980 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1888983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889007 */     // GIR_Coverage, 14802,
     /* 1889007 */     GIR_EraseRootFromParent_Done,
     /* 1889008 */   // Label 25475: @1889008
     /* 1889008 */   GIM_Try, /*On fail goto*//*Label 25476*/ GIMT_Encode4(1889097), // Rule ID 14803 //
     /* 1889013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1889024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1889027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1889030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1889033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889059 */     // MIs[0] policy
     /* 1889059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889069 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889096 */     // GIR_Coverage, 14803,
     /* 1889096 */     GIR_EraseRootFromParent_Done,
     /* 1889097 */   // Label 25476: @1889097
     /* 1889097 */   GIM_Try, /*On fail goto*//*Label 25477*/ GIMT_Encode4(1889186), // Rule ID 14806 //
     /* 1889102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889148 */     // MIs[0] policy
     /* 1889148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889158 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889185 */     // GIR_Coverage, 14806,
     /* 1889185 */     GIR_EraseRootFromParent_Done,
     /* 1889186 */   // Label 25477: @1889186
     /* 1889186 */   GIM_Try, /*On fail goto*//*Label 25478*/ GIMT_Encode4(1889275), // Rule ID 14807 //
     /* 1889191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1889202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1889205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1889208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1889211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1889214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889237 */     // MIs[0] policy
     /* 1889237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889247 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1889268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889274 */     // GIR_Coverage, 14807,
     /* 1889274 */     GIR_EraseRootFromParent_Done,
     /* 1889275 */   // Label 25478: @1889275
     /* 1889275 */   GIM_Try, /*On fail goto*//*Label 25479*/ GIMT_Encode4(1889364), // Rule ID 14810 //
     /* 1889280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889326 */     // MIs[0] policy
     /* 1889326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889336 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889363 */     // GIR_Coverage, 14810,
     /* 1889363 */     GIR_EraseRootFromParent_Done,
     /* 1889364 */   // Label 25479: @1889364
     /* 1889364 */   GIM_Try, /*On fail goto*//*Label 25480*/ GIMT_Encode4(1889453), // Rule ID 14811 //
     /* 1889369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889415 */     // MIs[0] policy
     /* 1889415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889425 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889448 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889452 */     // GIR_Coverage, 14811,
     /* 1889452 */     GIR_EraseRootFromParent_Done,
     /* 1889453 */   // Label 25480: @1889453
     /* 1889453 */   GIM_Try, /*On fail goto*//*Label 25481*/ GIMT_Encode4(1889542), // Rule ID 14814 //
     /* 1889458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1889478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889504 */     // MIs[0] policy
     /* 1889504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889514 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889537 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889541 */     // GIR_Coverage, 14814,
     /* 1889541 */     GIR_EraseRootFromParent_Done,
     /* 1889542 */   // Label 25481: @1889542
     /* 1889542 */   GIM_Try, /*On fail goto*//*Label 25482*/ GIMT_Encode4(1889631), // Rule ID 14815 //
     /* 1889547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1889567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889593 */     // MIs[0] policy
     /* 1889593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889603 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1889606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889630 */     // GIR_Coverage, 14815,
     /* 1889630 */     GIR_EraseRootFromParent_Done,
     /* 1889631 */   // Label 25482: @1889631
     /* 1889631 */   GIM_Try, /*On fail goto*//*Label 25483*/ GIMT_Encode4(1889720), // Rule ID 14818 //
     /* 1889636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1889647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1889650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1889653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1889656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889682 */     // MIs[0] policy
     /* 1889682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889692 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889719 */     // GIR_Coverage, 14818,
     /* 1889719 */     GIR_EraseRootFromParent_Done,
     /* 1889720 */   // Label 25483: @1889720
     /* 1889720 */   GIM_Try, /*On fail goto*//*Label 25484*/ GIMT_Encode4(1889809), // Rule ID 14819 //
     /* 1889725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1889736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1889739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1889742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1889745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889771 */     // MIs[0] policy
     /* 1889771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889781 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1889784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889808 */     // GIR_Coverage, 14819,
     /* 1889808 */     GIR_EraseRootFromParent_Done,
     /* 1889809 */   // Label 25484: @1889809
     /* 1889809 */   GIM_Try, /*On fail goto*//*Label 25485*/ GIMT_Encode4(1889898), // Rule ID 14822 //
     /* 1889814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1889825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1889828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1889831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1889834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889860 */     // MIs[0] policy
     /* 1889860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889870 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889897 */     // GIR_Coverage, 14822,
     /* 1889897 */     GIR_EraseRootFromParent_Done,
     /* 1889898 */   // Label 25485: @1889898
     /* 1889898 */   GIM_Try, /*On fail goto*//*Label 25486*/ GIMT_Encode4(1889987), // Rule ID 14823 //
     /* 1889903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1889906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1889911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1889914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1889917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1889920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1889923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889949 */     // MIs[0] policy
     /* 1889949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889959 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1889962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1889985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889986 */     // GIR_Coverage, 14823,
     /* 1889986 */     GIR_EraseRootFromParent_Done,
     /* 1889987 */   // Label 25486: @1889987
     /* 1889987 */   GIM_Try, /*On fail goto*//*Label 25487*/ GIMT_Encode4(1890076), // Rule ID 14826 //
     /* 1889992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1889995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890038 */     // MIs[0] policy
     /* 1890038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890048 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890075 */     // GIR_Coverage, 14826,
     /* 1890075 */     GIR_EraseRootFromParent_Done,
     /* 1890076 */   // Label 25487: @1890076
     /* 1890076 */   GIM_Try, /*On fail goto*//*Label 25488*/ GIMT_Encode4(1890165), // Rule ID 14827 //
     /* 1890081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890127 */     // MIs[0] policy
     /* 1890127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890137 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890164 */     // GIR_Coverage, 14827,
     /* 1890164 */     GIR_EraseRootFromParent_Done,
     /* 1890165 */   // Label 25488: @1890165
     /* 1890165 */   GIM_Try, /*On fail goto*//*Label 25489*/ GIMT_Encode4(1890254), // Rule ID 14830 //
     /* 1890170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890216 */     // MIs[0] policy
     /* 1890216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890226 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890253 */     // GIR_Coverage, 14830,
     /* 1890253 */     GIR_EraseRootFromParent_Done,
     /* 1890254 */   // Label 25489: @1890254
     /* 1890254 */   GIM_Try, /*On fail goto*//*Label 25490*/ GIMT_Encode4(1890343), // Rule ID 14831 //
     /* 1890259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890305 */     // MIs[0] policy
     /* 1890305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890315 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890342 */     // GIR_Coverage, 14831,
     /* 1890342 */     GIR_EraseRootFromParent_Done,
     /* 1890343 */   // Label 25490: @1890343
     /* 1890343 */   GIM_Try, /*On fail goto*//*Label 25491*/ GIMT_Encode4(1890432), // Rule ID 14834 //
     /* 1890348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890394 */     // MIs[0] policy
     /* 1890394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890404 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890431 */     // GIR_Coverage, 14834,
     /* 1890431 */     GIR_EraseRootFromParent_Done,
     /* 1890432 */   // Label 25491: @1890432
     /* 1890432 */   GIM_Try, /*On fail goto*//*Label 25492*/ GIMT_Encode4(1890521), // Rule ID 14835 //
     /* 1890437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890483 */     // MIs[0] policy
     /* 1890483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1890496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890514 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890520 */     // GIR_Coverage, 14835,
     /* 1890520 */     GIR_EraseRootFromParent_Done,
     /* 1890521 */   // Label 25492: @1890521
     /* 1890521 */   GIM_Try, /*On fail goto*//*Label 25493*/ GIMT_Encode4(1890610), // Rule ID 14838 //
     /* 1890526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1890537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1890540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1890543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1890546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890572 */     // MIs[0] policy
     /* 1890572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890582 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890609 */     // GIR_Coverage, 14838,
     /* 1890609 */     GIR_EraseRootFromParent_Done,
     /* 1890610 */   // Label 25493: @1890610
     /* 1890610 */   GIM_Try, /*On fail goto*//*Label 25494*/ GIMT_Encode4(1890699), // Rule ID 14839 //
     /* 1890615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1890626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1890629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1890632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1890635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890661 */     // MIs[0] policy
     /* 1890661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890671 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1890674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890692 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890698 */     // GIR_Coverage, 14839,
     /* 1890698 */     GIR_EraseRootFromParent_Done,
     /* 1890699 */   // Label 25494: @1890699
     /* 1890699 */   GIM_Try, /*On fail goto*//*Label 25495*/ GIMT_Encode4(1890788), // Rule ID 14842 //
     /* 1890704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1890707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1890715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1890718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1890721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1890724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890750 */     // MIs[0] policy
     /* 1890750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890760 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890787 */     // GIR_Coverage, 14842,
     /* 1890787 */     GIR_EraseRootFromParent_Done,
     /* 1890788 */   // Label 25495: @1890788
     /* 1890788 */   GIM_Try, /*On fail goto*//*Label 25496*/ GIMT_Encode4(1890877), // Rule ID 14843 //
     /* 1890793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1890796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1890804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1890807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1890810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1890813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890839 */     // MIs[0] policy
     /* 1890839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890849 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1890852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890870 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890876 */     // GIR_Coverage, 14843,
     /* 1890876 */     GIR_EraseRootFromParent_Done,
     /* 1890877 */   // Label 25496: @1890877
     /* 1890877 */   GIM_Try, /*On fail goto*//*Label 25497*/ GIMT_Encode4(1890966), // Rule ID 14846 //
     /* 1890882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1890885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1890893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1890896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1890899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1890902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1890905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1890924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890928 */     // MIs[0] policy
     /* 1890928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890938 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1890941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1890959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890961 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1890964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890965 */     // GIR_Coverage, 14846,
     /* 1890965 */     GIR_EraseRootFromParent_Done,
     /* 1890966 */   // Label 25497: @1890966
     /* 1890966 */   GIM_Try, /*On fail goto*//*Label 25498*/ GIMT_Encode4(1891055), // Rule ID 14847 //
     /* 1890971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1890974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1890979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1890982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1890985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1890988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1890991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1890994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891017 */     // MIs[0] policy
     /* 1891017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891027 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1891030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891048 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891054 */     // GIR_Coverage, 14847,
     /* 1891054 */     GIR_EraseRootFromParent_Done,
     /* 1891055 */   // Label 25498: @1891055
     /* 1891055 */   GIM_Try, /*On fail goto*//*Label 25499*/ GIMT_Encode4(1891144), // Rule ID 14850 //
     /* 1891060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891106 */     // MIs[0] policy
     /* 1891106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891143 */     // GIR_Coverage, 14850,
     /* 1891143 */     GIR_EraseRootFromParent_Done,
     /* 1891144 */   // Label 25499: @1891144
     /* 1891144 */   GIM_Try, /*On fail goto*//*Label 25500*/ GIMT_Encode4(1891233), // Rule ID 14851 //
     /* 1891149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1891160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1891163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1891166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891195 */     // MIs[0] policy
     /* 1891195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891205 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891226 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891232 */     // GIR_Coverage, 14851,
     /* 1891232 */     GIR_EraseRootFromParent_Done,
     /* 1891233 */   // Label 25500: @1891233
     /* 1891233 */   GIM_Try, /*On fail goto*//*Label 25501*/ GIMT_Encode4(1891322), // Rule ID 14854 //
     /* 1891238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891284 */     // MIs[0] policy
     /* 1891284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891321 */     // GIR_Coverage, 14854,
     /* 1891321 */     GIR_EraseRootFromParent_Done,
     /* 1891322 */   // Label 25501: @1891322
     /* 1891322 */   GIM_Try, /*On fail goto*//*Label 25502*/ GIMT_Encode4(1891411), // Rule ID 14855 //
     /* 1891327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1891338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1891341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1891344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891373 */     // MIs[0] policy
     /* 1891373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891383 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1891404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891406 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891410 */     // GIR_Coverage, 14855,
     /* 1891410 */     GIR_EraseRootFromParent_Done,
     /* 1891411 */   // Label 25502: @1891411
     /* 1891411 */   GIM_Try, /*On fail goto*//*Label 25503*/ GIMT_Encode4(1891500), // Rule ID 14858 //
     /* 1891416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891462 */     // MIs[0] policy
     /* 1891462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891499 */     // GIR_Coverage, 14858,
     /* 1891499 */     GIR_EraseRootFromParent_Done,
     /* 1891500 */   // Label 25503: @1891500
     /* 1891500 */   GIM_Try, /*On fail goto*//*Label 25504*/ GIMT_Encode4(1891589), // Rule ID 14859 //
     /* 1891505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1891516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1891519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1891522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891551 */     // MIs[0] policy
     /* 1891551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891561 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1891564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891588 */     // GIR_Coverage, 14859,
     /* 1891588 */     GIR_EraseRootFromParent_Done,
     /* 1891589 */   // Label 25504: @1891589
     /* 1891589 */   GIM_Try, /*On fail goto*//*Label 25505*/ GIMT_Encode4(1891678), // Rule ID 14862 //
     /* 1891594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1891605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1891608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1891611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891640 */     // MIs[0] policy
     /* 1891640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891650 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891677 */     // GIR_Coverage, 14862,
     /* 1891677 */     GIR_EraseRootFromParent_Done,
     /* 1891678 */   // Label 25505: @1891678
     /* 1891678 */   GIM_Try, /*On fail goto*//*Label 25506*/ GIMT_Encode4(1891767), // Rule ID 14863 //
     /* 1891683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1891694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1891697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1891700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891729 */     // MIs[0] policy
     /* 1891729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891739 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891766 */     // GIR_Coverage, 14863,
     /* 1891766 */     GIR_EraseRootFromParent_Done,
     /* 1891767 */   // Label 25506: @1891767
     /* 1891767 */   GIM_Try, /*On fail goto*//*Label 25507*/ GIMT_Encode4(1891856), // Rule ID 14866 //
     /* 1891772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1891783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1891786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1891789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891818 */     // MIs[0] policy
     /* 1891818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891828 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891855 */     // GIR_Coverage, 14866,
     /* 1891855 */     GIR_EraseRootFromParent_Done,
     /* 1891856 */   // Label 25507: @1891856
     /* 1891856 */   GIM_Try, /*On fail goto*//*Label 25508*/ GIMT_Encode4(1891945), // Rule ID 14867 //
     /* 1891861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1891864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1891872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1891875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1891878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891907 */     // MIs[0] policy
     /* 1891907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891917 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1891920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1891943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891944 */     // GIR_Coverage, 14867,
     /* 1891944 */     GIR_EraseRootFromParent_Done,
     /* 1891945 */   // Label 25508: @1891945
     /* 1891945 */   GIM_Try, /*On fail goto*//*Label 25509*/ GIMT_Encode4(1892034), // Rule ID 14870 //
     /* 1891950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1891953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1891958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1891961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1891964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1891967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1891992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891996 */     // MIs[0] policy
     /* 1891996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892006 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892033 */     // GIR_Coverage, 14870,
     /* 1892033 */     GIR_EraseRootFromParent_Done,
     /* 1892034 */   // Label 25509: @1892034
     /* 1892034 */   GIM_Try, /*On fail goto*//*Label 25510*/ GIMT_Encode4(1892123), // Rule ID 14871 //
     /* 1892039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1892050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1892053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1892056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892085 */     // MIs[0] policy
     /* 1892085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892095 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11618:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892122 */     // GIR_Coverage, 14871,
     /* 1892122 */     GIR_EraseRootFromParent_Done,
     /* 1892123 */   // Label 25510: @1892123
     /* 1892123 */   GIM_Try, /*On fail goto*//*Label 25511*/ GIMT_Encode4(1892212), // Rule ID 14874 //
     /* 1892128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892174 */     // MIs[0] policy
     /* 1892174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892211 */     // GIR_Coverage, 14874,
     /* 1892211 */     GIR_EraseRootFromParent_Done,
     /* 1892212 */   // Label 25511: @1892212
     /* 1892212 */   GIM_Try, /*On fail goto*//*Label 25512*/ GIMT_Encode4(1892301), // Rule ID 14875 //
     /* 1892217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1892228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1892231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1892234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892263 */     // MIs[0] policy
     /* 1892263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892273 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11618:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892300 */     // GIR_Coverage, 14875,
     /* 1892300 */     GIR_EraseRootFromParent_Done,
     /* 1892301 */   // Label 25512: @1892301
     /* 1892301 */   GIM_Try, /*On fail goto*//*Label 25513*/ GIMT_Encode4(1892390), // Rule ID 14878 //
     /* 1892306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892352 */     // MIs[0] policy
     /* 1892352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892362 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892385 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892389 */     // GIR_Coverage, 14878,
     /* 1892389 */     GIR_EraseRootFromParent_Done,
     /* 1892390 */   // Label 25513: @1892390
     /* 1892390 */   GIM_Try, /*On fail goto*//*Label 25514*/ GIMT_Encode4(1892479), // Rule ID 14879 //
     /* 1892395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1892406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1892409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1892412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892441 */     // MIs[0] policy
     /* 1892441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892451 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11618:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892478 */     // GIR_Coverage, 14879,
     /* 1892478 */     GIR_EraseRootFromParent_Done,
     /* 1892479 */   // Label 25514: @1892479
     /* 1892479 */   GIM_Try, /*On fail goto*//*Label 25515*/ GIMT_Encode4(1892568), // Rule ID 14882 //
     /* 1892484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1892487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892530 */     // MIs[0] policy
     /* 1892530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892567 */     // GIR_Coverage, 14882,
     /* 1892567 */     GIR_EraseRootFromParent_Done,
     /* 1892568 */   // Label 25515: @1892568
     /* 1892568 */   GIM_Try, /*On fail goto*//*Label 25516*/ GIMT_Encode4(1892657), // Rule ID 14883 //
     /* 1892573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1892576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1892584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1892587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1892590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1892596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1892603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1892611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892619 */     // MIs[0] policy
     /* 1892619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892629 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11618:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1892632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892656 */     // GIR_Coverage, 14883,
     /* 1892656 */     GIR_EraseRootFromParent_Done,
     /* 1892657 */   // Label 25516: @1892657
     /* 1892657 */   GIM_Try, /*On fail goto*//*Label 25517*/ GIMT_Encode4(1892746), // Rule ID 14886 //
     /* 1892662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1892673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1892676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1892679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892708 */     // MIs[0] policy
     /* 1892708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892718 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1892721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892745 */     // GIR_Coverage, 14886,
     /* 1892745 */     GIR_EraseRootFromParent_Done,
     /* 1892746 */   // Label 25517: @1892746
     /* 1892746 */   GIM_Try, /*On fail goto*//*Label 25518*/ GIMT_Encode4(1892835), // Rule ID 14887 //
     /* 1892751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1892762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1892765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1892768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892797 */     // MIs[0] policy
     /* 1892797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892807 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1892810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892828 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892834 */     // GIR_Coverage, 14887,
     /* 1892834 */     GIR_EraseRootFromParent_Done,
     /* 1892835 */   // Label 25518: @1892835
     /* 1892835 */   GIM_Try, /*On fail goto*//*Label 25519*/ GIMT_Encode4(1892924), // Rule ID 14890 //
     /* 1892840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1892843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1892851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1892854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1892857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1892863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892886 */     // MIs[0] policy
     /* 1892886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892896 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1892899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1892917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1892922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892923 */     // GIR_Coverage, 14890,
     /* 1892923 */     GIR_EraseRootFromParent_Done,
     /* 1892924 */   // Label 25519: @1892924
     /* 1892924 */   GIM_Try, /*On fail goto*//*Label 25520*/ GIMT_Encode4(1893013), // Rule ID 14891 //
     /* 1892929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1892932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1892937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1892940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1892943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1892946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1892952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1892971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892975 */     // MIs[0] policy
     /* 1892975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892985 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1892988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893006 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893012 */     // GIR_Coverage, 14891,
     /* 1893012 */     GIR_EraseRootFromParent_Done,
     /* 1893013 */   // Label 25520: @1893013
     /* 1893013 */   GIM_Try, /*On fail goto*//*Label 25521*/ GIMT_Encode4(1893102), // Rule ID 14894 //
     /* 1893018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893064 */     // MIs[0] policy
     /* 1893064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893074 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893101 */     // GIR_Coverage, 14894,
     /* 1893101 */     GIR_EraseRootFromParent_Done,
     /* 1893102 */   // Label 25521: @1893102
     /* 1893102 */   GIM_Try, /*On fail goto*//*Label 25522*/ GIMT_Encode4(1893191), // Rule ID 14895 //
     /* 1893107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1893118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1893121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1893124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1893130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893153 */     // MIs[0] policy
     /* 1893153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893163 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1893184 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893190 */     // GIR_Coverage, 14895,
     /* 1893190 */     GIR_EraseRootFromParent_Done,
     /* 1893191 */   // Label 25522: @1893191
     /* 1893191 */   GIM_Try, /*On fail goto*//*Label 25523*/ GIMT_Encode4(1893280), // Rule ID 14898 //
     /* 1893196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893242 */     // MIs[0] policy
     /* 1893242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893279 */     // GIR_Coverage, 14898,
     /* 1893279 */     GIR_EraseRootFromParent_Done,
     /* 1893280 */   // Label 25523: @1893280
     /* 1893280 */   GIM_Try, /*On fail goto*//*Label 25524*/ GIMT_Encode4(1893369), // Rule ID 14899 //
     /* 1893285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1893296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1893299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1893302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893331 */     // MIs[0] policy
     /* 1893331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893341 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893362 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893368 */     // GIR_Coverage, 14899,
     /* 1893368 */     GIR_EraseRootFromParent_Done,
     /* 1893369 */   // Label 25524: @1893369
     /* 1893369 */   GIM_Try, /*On fail goto*//*Label 25525*/ GIMT_Encode4(1893458), // Rule ID 14902 //
     /* 1893374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893420 */     // MIs[0] policy
     /* 1893420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893430 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893457 */     // GIR_Coverage, 14902,
     /* 1893457 */     GIR_EraseRootFromParent_Done,
     /* 1893458 */   // Label 25525: @1893458
     /* 1893458 */   GIM_Try, /*On fail goto*//*Label 25526*/ GIMT_Encode4(1893547), // Rule ID 14903 //
     /* 1893463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1893474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1893477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1893480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1893486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893509 */     // MIs[0] policy
     /* 1893509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893519 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893540 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893546 */     // GIR_Coverage, 14903,
     /* 1893546 */     GIR_EraseRootFromParent_Done,
     /* 1893547 */   // Label 25526: @1893547
     /* 1893547 */   GIM_Try, /*On fail goto*//*Label 25527*/ GIMT_Encode4(1893636), // Rule ID 14906 //
     /* 1893552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1893563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1893566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1893569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893598 */     // MIs[0] policy
     /* 1893598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893635 */     // GIR_Coverage, 14906,
     /* 1893635 */     GIR_EraseRootFromParent_Done,
     /* 1893636 */   // Label 25527: @1893636
     /* 1893636 */   GIM_Try, /*On fail goto*//*Label 25528*/ GIMT_Encode4(1893725), // Rule ID 14907 //
     /* 1893641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1893652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1893655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1893658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1893664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893687 */     // MIs[0] policy
     /* 1893687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893697 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1893700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893718 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893724 */     // GIR_Coverage, 14907,
     /* 1893724 */     GIR_EraseRootFromParent_Done,
     /* 1893725 */   // Label 25528: @1893725
     /* 1893725 */   GIM_Try, /*On fail goto*//*Label 25529*/ GIMT_Encode4(1893814), // Rule ID 14910 //
     /* 1893730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1893741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1893744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1893747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893776 */     // MIs[0] policy
     /* 1893776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893813 */     // GIR_Coverage, 14910,
     /* 1893813 */     GIR_EraseRootFromParent_Done,
     /* 1893814 */   // Label 25529: @1893814
     /* 1893814 */   GIM_Try, /*On fail goto*//*Label 25530*/ GIMT_Encode4(1893903), // Rule ID 14911 //
     /* 1893819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1893822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1893830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1893833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1893836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1893839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1893849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1893857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893865 */     // MIs[0] policy
     /* 1893865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1893878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893902 */     // GIR_Coverage, 14911,
     /* 1893902 */     GIR_EraseRootFromParent_Done,
     /* 1893903 */   // Label 25530: @1893903
     /* 1893903 */   GIM_Try, /*On fail goto*//*Label 25531*/ GIMT_Encode4(1893992), // Rule ID 14914 //
     /* 1893908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1893911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1893916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1893919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1893922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1893925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1893950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893954 */     // MIs[0] policy
     /* 1893954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893964 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1893967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1893990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893991 */     // GIR_Coverage, 14914,
     /* 1893991 */     GIR_EraseRootFromParent_Done,
     /* 1893992 */   // Label 25531: @1893992
     /* 1893992 */   GIM_Try, /*On fail goto*//*Label 25532*/ GIMT_Encode4(1894081), // Rule ID 14915 //
     /* 1893997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1894008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1894011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1894014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894043 */     // MIs[0] policy
     /* 1894043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894053 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894080 */     // GIR_Coverage, 14915,
     /* 1894080 */     GIR_EraseRootFromParent_Done,
     /* 1894081 */   // Label 25532: @1894081
     /* 1894081 */   GIM_Try, /*On fail goto*//*Label 25533*/ GIMT_Encode4(1894170), // Rule ID 14918 //
     /* 1894086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1894089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894132 */     // MIs[0] policy
     /* 1894132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894169 */     // GIR_Coverage, 14918,
     /* 1894169 */     GIR_EraseRootFromParent_Done,
     /* 1894170 */   // Label 25533: @1894170
     /* 1894170 */   GIM_Try, /*On fail goto*//*Label 25534*/ GIMT_Encode4(1894259), // Rule ID 14919 //
     /* 1894175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1894178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1894186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1894189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1894192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894221 */     // MIs[0] policy
     /* 1894221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894231 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894258 */     // GIR_Coverage, 14919,
     /* 1894258 */     GIR_EraseRootFromParent_Done,
     /* 1894259 */   // Label 25534: @1894259
     /* 1894259 */   GIM_Try, /*On fail goto*//*Label 25535*/ GIMT_Encode4(1894348), // Rule ID 14922 //
     /* 1894264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894310 */     // MIs[0] policy
     /* 1894310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894347 */     // GIR_Coverage, 14922,
     /* 1894347 */     GIR_EraseRootFromParent_Done,
     /* 1894348 */   // Label 25535: @1894348
     /* 1894348 */   GIM_Try, /*On fail goto*//*Label 25536*/ GIMT_Encode4(1894437), // Rule ID 14923 //
     /* 1894353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1894364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1894367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1894370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894399 */     // MIs[0] policy
     /* 1894399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894409 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11618:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1894412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894436 */     // GIR_Coverage, 14923,
     /* 1894436 */     GIR_EraseRootFromParent_Done,
     /* 1894437 */   // Label 25536: @1894437
     /* 1894437 */   GIM_Try, /*On fail goto*//*Label 25537*/ GIMT_Encode4(1894526), // Rule ID 14926 //
     /* 1894442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894488 */     // MIs[0] policy
     /* 1894488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894525 */     // GIR_Coverage, 14926,
     /* 1894525 */     GIR_EraseRootFromParent_Done,
     /* 1894526 */   // Label 25537: @1894526
     /* 1894526 */   GIM_Try, /*On fail goto*//*Label 25538*/ GIMT_Encode4(1894615), // Rule ID 14927 //
     /* 1894531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1894542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1894545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1894548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894577 */     // MIs[0] policy
     /* 1894577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894587 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11618:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1894590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894614 */     // GIR_Coverage, 14927,
     /* 1894614 */     GIR_EraseRootFromParent_Done,
     /* 1894615 */   // Label 25538: @1894615
     /* 1894615 */   GIM_Try, /*On fail goto*//*Label 25539*/ GIMT_Encode4(1894704), // Rule ID 14930 //
     /* 1894620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1894623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1894631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1894634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1894637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1894640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894666 */     // MIs[0] policy
     /* 1894666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894703 */     // GIR_Coverage, 14930,
     /* 1894703 */     GIR_EraseRootFromParent_Done,
     /* 1894704 */   // Label 25539: @1894704
     /* 1894704 */   GIM_Try, /*On fail goto*//*Label 25540*/ GIMT_Encode4(1894793), // Rule ID 14931 //
     /* 1894709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1894712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1894717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1894720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1894723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1894726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1894729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1894751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894755 */     // MIs[0] policy
     /* 1894755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894765 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11618:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1894768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894788 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1894791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894792 */     // GIR_Coverage, 14931,
     /* 1894792 */     GIR_EraseRootFromParent_Done,
     /* 1894793 */   // Label 25540: @1894793
     /* 1894793 */   GIM_Try, /*On fail goto*//*Label 25541*/ GIMT_Encode4(1894879), // Rule ID 19172 //
     /* 1894798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1894801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1894809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1894812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1894815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1894818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1894821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894844 */     // MIs[0] policy
     /* 1894844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894854 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1894857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894878 */     // GIR_Coverage, 19172,
     /* 1894878 */     GIR_EraseRootFromParent_Done,
     /* 1894879 */   // Label 25541: @1894879
     /* 1894879 */   GIM_Try, /*On fail goto*//*Label 25542*/ GIMT_Encode4(1894965), // Rule ID 19173 //
     /* 1894884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1894887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1894895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1894898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1894901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1894904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1894907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894930 */     // MIs[0] policy
     /* 1894930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894940 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1894943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894964 */     // GIR_Coverage, 19173,
     /* 1894964 */     GIR_EraseRootFromParent_Done,
     /* 1894965 */   // Label 25542: @1894965
     /* 1894965 */   GIM_Try, /*On fail goto*//*Label 25543*/ GIMT_Encode4(1895051), // Rule ID 19176 //
     /* 1894970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1894973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1894978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1894981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1894984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1894987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1894990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895016 */     // MIs[0] policy
     /* 1895016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895026 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1895029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895050 */     // GIR_Coverage, 19176,
     /* 1895050 */     GIR_EraseRootFromParent_Done,
     /* 1895051 */   // Label 25543: @1895051
     /* 1895051 */   GIM_Try, /*On fail goto*//*Label 25544*/ GIMT_Encode4(1895137), // Rule ID 19177 //
     /* 1895056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1895067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1895070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1895073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1895076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895102 */     // MIs[0] policy
     /* 1895102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895112 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1895115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895136 */     // GIR_Coverage, 19177,
     /* 1895136 */     GIR_EraseRootFromParent_Done,
     /* 1895137 */   // Label 25544: @1895137
     /* 1895137 */   GIM_Try, /*On fail goto*//*Label 25545*/ GIMT_Encode4(1895223), // Rule ID 19180 //
     /* 1895142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1895162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895188 */     // MIs[0] policy
     /* 1895188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895198 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1895201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895222 */     // GIR_Coverage, 19180,
     /* 1895222 */     GIR_EraseRootFromParent_Done,
     /* 1895223 */   // Label 25545: @1895223
     /* 1895223 */   GIM_Try, /*On fail goto*//*Label 25546*/ GIMT_Encode4(1895309), // Rule ID 19181 //
     /* 1895228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1895239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1895242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1895245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1895248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895274 */     // MIs[0] policy
     /* 1895274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895284 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1895287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895308 */     // GIR_Coverage, 19181,
     /* 1895308 */     GIR_EraseRootFromParent_Done,
     /* 1895309 */   // Label 25546: @1895309
     /* 1895309 */   GIM_Try, /*On fail goto*//*Label 25547*/ GIMT_Encode4(1895395), // Rule ID 19184 //
     /* 1895314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1895334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895360 */     // MIs[0] policy
     /* 1895360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895370 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1895373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895394 */     // GIR_Coverage, 19184,
     /* 1895394 */     GIR_EraseRootFromParent_Done,
     /* 1895395 */   // Label 25547: @1895395
     /* 1895395 */   GIM_Try, /*On fail goto*//*Label 25548*/ GIMT_Encode4(1895481), // Rule ID 19185 //
     /* 1895400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1895411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1895414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1895417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1895420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895446 */     // MIs[0] policy
     /* 1895446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895456 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1895459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895480 */     // GIR_Coverage, 19185,
     /* 1895480 */     GIR_EraseRootFromParent_Done,
     /* 1895481 */   // Label 25548: @1895481
     /* 1895481 */   GIM_Try, /*On fail goto*//*Label 25549*/ GIMT_Encode4(1895567), // Rule ID 19188 //
     /* 1895486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1895503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1895506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895532 */     // MIs[0] policy
     /* 1895532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895542 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1895545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895566 */     // GIR_Coverage, 19188,
     /* 1895566 */     GIR_EraseRootFromParent_Done,
     /* 1895567 */   // Label 25549: @1895567
     /* 1895567 */   GIM_Try, /*On fail goto*//*Label 25550*/ GIMT_Encode4(1895653), // Rule ID 19189 //
     /* 1895572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1895583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1895586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1895589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1895592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895618 */     // MIs[0] policy
     /* 1895618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895628 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1895631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895652 */     // GIR_Coverage, 19189,
     /* 1895652 */     GIR_EraseRootFromParent_Done,
     /* 1895653 */   // Label 25550: @1895653
     /* 1895653 */   GIM_Try, /*On fail goto*//*Label 25551*/ GIMT_Encode4(1895739), // Rule ID 19192 //
     /* 1895658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1895661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1895669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1895672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1895675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1895678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895704 */     // MIs[0] policy
     /* 1895704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895714 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1895717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895738 */     // GIR_Coverage, 19192,
     /* 1895738 */     GIR_EraseRootFromParent_Done,
     /* 1895739 */   // Label 25551: @1895739
     /* 1895739 */   GIM_Try, /*On fail goto*//*Label 25552*/ GIMT_Encode4(1895825), // Rule ID 19193 //
     /* 1895744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1895747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1895755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1895758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1895761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1895764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895790 */     // MIs[0] policy
     /* 1895790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895800 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1895803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895824 */     // GIR_Coverage, 19193,
     /* 1895824 */     GIR_EraseRootFromParent_Done,
     /* 1895825 */   // Label 25552: @1895825
     /* 1895825 */   GIM_Try, /*On fail goto*//*Label 25553*/ GIMT_Encode4(1895911), // Rule ID 19196 //
     /* 1895830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1895841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1895844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1895847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1895850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1895860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895876 */     // MIs[0] policy
     /* 1895876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895886 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1895889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895910 */     // GIR_Coverage, 19196,
     /* 1895910 */     GIR_EraseRootFromParent_Done,
     /* 1895911 */   // Label 25553: @1895911
     /* 1895911 */   GIM_Try, /*On fail goto*//*Label 25554*/ GIMT_Encode4(1895997), // Rule ID 19197 //
     /* 1895916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1895919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1895924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1895927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1895930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1895933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1895936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1895946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895962 */     // MIs[0] policy
     /* 1895962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895972 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1895975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1895993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895996 */     // GIR_Coverage, 19197,
     /* 1895996 */     GIR_EraseRootFromParent_Done,
     /* 1895997 */   // Label 25554: @1895997
     /* 1895997 */   GIM_Try, /*On fail goto*//*Label 25555*/ GIMT_Encode4(1896083), // Rule ID 19200 //
     /* 1896002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1896022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896048 */     // MIs[0] policy
     /* 1896048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896058 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1896061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896082 */     // GIR_Coverage, 19200,
     /* 1896082 */     GIR_EraseRootFromParent_Done,
     /* 1896083 */   // Label 25555: @1896083
     /* 1896083 */   GIM_Try, /*On fail goto*//*Label 25556*/ GIMT_Encode4(1896169), // Rule ID 19201 //
     /* 1896088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1896099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1896102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1896105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1896108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896134 */     // MIs[0] policy
     /* 1896134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896144 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1896147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896168 */     // GIR_Coverage, 19201,
     /* 1896168 */     GIR_EraseRootFromParent_Done,
     /* 1896169 */   // Label 25556: @1896169
     /* 1896169 */   GIM_Try, /*On fail goto*//*Label 25557*/ GIMT_Encode4(1896255), // Rule ID 19204 //
     /* 1896174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1896194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896220 */     // MIs[0] policy
     /* 1896220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896230 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1896233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896254 */     // GIR_Coverage, 19204,
     /* 1896254 */     GIR_EraseRootFromParent_Done,
     /* 1896255 */   // Label 25557: @1896255
     /* 1896255 */   GIM_Try, /*On fail goto*//*Label 25558*/ GIMT_Encode4(1896341), // Rule ID 19205 //
     /* 1896260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1896271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1896274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1896277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1896280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1896283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896306 */     // MIs[0] policy
     /* 1896306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896316 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1896319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896340 */     // GIR_Coverage, 19205,
     /* 1896340 */     GIR_EraseRootFromParent_Done,
     /* 1896341 */   // Label 25558: @1896341
     /* 1896341 */   GIM_Try, /*On fail goto*//*Label 25559*/ GIMT_Encode4(1896427), // Rule ID 19208 //
     /* 1896346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1896366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896392 */     // MIs[0] policy
     /* 1896392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896402 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1896405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896426 */     // GIR_Coverage, 19208,
     /* 1896426 */     GIR_EraseRootFromParent_Done,
     /* 1896427 */   // Label 25559: @1896427
     /* 1896427 */   GIM_Try, /*On fail goto*//*Label 25560*/ GIMT_Encode4(1896513), // Rule ID 19209 //
     /* 1896432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1896443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1896446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1896449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1896452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896478 */     // MIs[0] policy
     /* 1896478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896488 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1896491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896512 */     // GIR_Coverage, 19209,
     /* 1896512 */     GIR_EraseRootFromParent_Done,
     /* 1896513 */   // Label 25560: @1896513
     /* 1896513 */   GIM_Try, /*On fail goto*//*Label 25561*/ GIMT_Encode4(1896599), // Rule ID 19212 //
     /* 1896518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1896529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1896532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1896535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1896538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896564 */     // MIs[0] policy
     /* 1896564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896574 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1896577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896598 */     // GIR_Coverage, 19212,
     /* 1896598 */     GIR_EraseRootFromParent_Done,
     /* 1896599 */   // Label 25561: @1896599
     /* 1896599 */   GIM_Try, /*On fail goto*//*Label 25562*/ GIMT_Encode4(1896685), // Rule ID 19213 //
     /* 1896604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1896615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1896618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1896621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1896624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1896627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1896634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1896646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896650 */     // MIs[0] policy
     /* 1896650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896660 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1896663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896684 */     // GIR_Coverage, 19213,
     /* 1896684 */     GIR_EraseRootFromParent_Done,
     /* 1896685 */   // Label 25562: @1896685
     /* 1896685 */   GIM_Try, /*On fail goto*//*Label 25563*/ GIMT_Encode4(1896771), // Rule ID 19216 //
     /* 1896690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1896701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1896704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1896707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1896710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896736 */     // MIs[0] policy
     /* 1896736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896746 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1896749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896770 */     // GIR_Coverage, 19216,
     /* 1896770 */     GIR_EraseRootFromParent_Done,
     /* 1896771 */   // Label 25563: @1896771
     /* 1896771 */   GIM_Try, /*On fail goto*//*Label 25564*/ GIMT_Encode4(1896857), // Rule ID 19217 //
     /* 1896776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1896787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1896790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1896793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1896796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1896799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1896806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1896818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896822 */     // MIs[0] policy
     /* 1896822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896832 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1896835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896856 */     // GIR_Coverage, 19217,
     /* 1896856 */     GIR_EraseRootFromParent_Done,
     /* 1896857 */   // Label 25564: @1896857
     /* 1896857 */   GIM_Try, /*On fail goto*//*Label 25565*/ GIMT_Encode4(1896943), // Rule ID 19220 //
     /* 1896862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1896865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1896873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1896876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1896879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1896882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896908 */     // MIs[0] policy
     /* 1896908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896918 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1896921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896942 */     // GIR_Coverage, 19220,
     /* 1896942 */     GIR_EraseRootFromParent_Done,
     /* 1896943 */   // Label 25565: @1896943
     /* 1896943 */   GIM_Try, /*On fail goto*//*Label 25566*/ GIMT_Encode4(1897029), // Rule ID 19221 //
     /* 1896948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1896951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1896956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1896959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1896962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1896965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1896968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1896978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1896990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896994 */     // MIs[0] policy
     /* 1896994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897004 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1897007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897028 */     // GIR_Coverage, 19221,
     /* 1897028 */     GIR_EraseRootFromParent_Done,
     /* 1897029 */   // Label 25566: @1897029
     /* 1897029 */   GIM_Try, /*On fail goto*//*Label 25567*/ GIMT_Encode4(1897115), // Rule ID 19224 //
     /* 1897034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1897054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897080 */     // MIs[0] policy
     /* 1897080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897090 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1897093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897114 */     // GIR_Coverage, 19224,
     /* 1897114 */     GIR_EraseRootFromParent_Done,
     /* 1897115 */   // Label 25567: @1897115
     /* 1897115 */   GIM_Try, /*On fail goto*//*Label 25568*/ GIMT_Encode4(1897201), // Rule ID 19225 //
     /* 1897120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1897131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1897134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1897137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1897140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897166 */     // MIs[0] policy
     /* 1897166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897176 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1897179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897200 */     // GIR_Coverage, 19225,
     /* 1897200 */     GIR_EraseRootFromParent_Done,
     /* 1897201 */   // Label 25568: @1897201
     /* 1897201 */   GIM_Try, /*On fail goto*//*Label 25569*/ GIMT_Encode4(1897287), // Rule ID 19228 //
     /* 1897206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1897209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1897226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897252 */     // MIs[0] policy
     /* 1897252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897262 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1897265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897286 */     // GIR_Coverage, 19228,
     /* 1897286 */     GIR_EraseRootFromParent_Done,
     /* 1897287 */   // Label 25569: @1897287
     /* 1897287 */   GIM_Try, /*On fail goto*//*Label 25570*/ GIMT_Encode4(1897373), // Rule ID 19229 //
     /* 1897292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1897295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1897303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1897306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1897309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1897312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897338 */     // MIs[0] policy
     /* 1897338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897348 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1897351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1897369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897372 */     // GIR_Coverage, 19229,
     /* 1897372 */     GIR_EraseRootFromParent_Done,
     /* 1897373 */   // Label 25570: @1897373
     /* 1897373 */   GIM_Try, /*On fail goto*//*Label 25571*/ GIMT_Encode4(1897459), // Rule ID 19232 //
     /* 1897378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897424 */     // MIs[0] policy
     /* 1897424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897434 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1897437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897458 */     // GIR_Coverage, 19232,
     /* 1897458 */     GIR_EraseRootFromParent_Done,
     /* 1897459 */   // Label 25571: @1897459
     /* 1897459 */   GIM_Try, /*On fail goto*//*Label 25572*/ GIMT_Encode4(1897545), // Rule ID 19233 //
     /* 1897464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1897475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1897478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1897481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897510 */     // MIs[0] policy
     /* 1897510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897520 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1897523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897544 */     // GIR_Coverage, 19233,
     /* 1897544 */     GIR_EraseRootFromParent_Done,
     /* 1897545 */   // Label 25572: @1897545
     /* 1897545 */   GIM_Try, /*On fail goto*//*Label 25573*/ GIMT_Encode4(1897631), // Rule ID 19236 //
     /* 1897550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1897561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1897564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1897567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897596 */     // MIs[0] policy
     /* 1897596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897606 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1897609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897630 */     // GIR_Coverage, 19236,
     /* 1897630 */     GIR_EraseRootFromParent_Done,
     /* 1897631 */   // Label 25573: @1897631
     /* 1897631 */   GIM_Try, /*On fail goto*//*Label 25574*/ GIMT_Encode4(1897717), // Rule ID 19237 //
     /* 1897636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1897647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1897650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1897653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1897659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897682 */     // MIs[0] policy
     /* 1897682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897692 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1897695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897716 */     // GIR_Coverage, 19237,
     /* 1897716 */     GIR_EraseRootFromParent_Done,
     /* 1897717 */   // Label 25574: @1897717
     /* 1897717 */   GIM_Try, /*On fail goto*//*Label 25575*/ GIMT_Encode4(1897803), // Rule ID 19240 //
     /* 1897722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1897725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1897733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1897736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1897739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897768 */     // MIs[0] policy
     /* 1897768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897778 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1897781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897802 */     // GIR_Coverage, 19240,
     /* 1897802 */     GIR_EraseRootFromParent_Done,
     /* 1897803 */   // Label 25575: @1897803
     /* 1897803 */   GIM_Try, /*On fail goto*//*Label 25576*/ GIMT_Encode4(1897889), // Rule ID 19241 //
     /* 1897808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1897819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1897822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1897825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1897831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897854 */     // MIs[0] policy
     /* 1897854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897864 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1897867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897888 */     // GIR_Coverage, 19241,
     /* 1897888 */     GIR_EraseRootFromParent_Done,
     /* 1897889 */   // Label 25576: @1897889
     /* 1897889 */   GIM_Try, /*On fail goto*//*Label 25577*/ GIMT_Encode4(1897975), // Rule ID 19244 //
     /* 1897894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1897905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1897908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1897911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1897924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1897932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897940 */     // MIs[0] policy
     /* 1897940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897950 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1897953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897974 */     // GIR_Coverage, 19244,
     /* 1897974 */     GIR_EraseRootFromParent_Done,
     /* 1897975 */   // Label 25577: @1897975
     /* 1897975 */   GIM_Try, /*On fail goto*//*Label 25578*/ GIMT_Encode4(1898061), // Rule ID 19245 //
     /* 1897980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1897988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1897991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1897994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1897997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898026 */     // MIs[0] policy
     /* 1898026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898036 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11213:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1898039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898060 */     // GIR_Coverage, 19245,
     /* 1898060 */     GIR_EraseRootFromParent_Done,
     /* 1898061 */   // Label 25578: @1898061
     /* 1898061 */   GIM_Try, /*On fail goto*//*Label 25579*/ GIMT_Encode4(1898147), // Rule ID 19248 //
     /* 1898066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898112 */     // MIs[0] policy
     /* 1898112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898122 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1898125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898146 */     // GIR_Coverage, 19248,
     /* 1898146 */     GIR_EraseRootFromParent_Done,
     /* 1898147 */   // Label 25579: @1898147
     /* 1898147 */   GIM_Try, /*On fail goto*//*Label 25580*/ GIMT_Encode4(1898233), // Rule ID 19249 //
     /* 1898152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1898155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1898163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1898166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1898169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898198 */     // MIs[0] policy
     /* 1898198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898208 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1898211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898232 */     // GIR_Coverage, 19249,
     /* 1898232 */     GIR_EraseRootFromParent_Done,
     /* 1898233 */   // Label 25580: @1898233
     /* 1898233 */   GIM_Try, /*On fail goto*//*Label 25581*/ GIMT_Encode4(1898319), // Rule ID 19252 //
     /* 1898238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1898241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898284 */     // MIs[0] policy
     /* 1898284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898294 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1898297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898318 */     // GIR_Coverage, 19252,
     /* 1898318 */     GIR_EraseRootFromParent_Done,
     /* 1898319 */   // Label 25581: @1898319
     /* 1898319 */   GIM_Try, /*On fail goto*//*Label 25582*/ GIMT_Encode4(1898405), // Rule ID 19253 //
     /* 1898324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1898327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1898335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1898338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1898341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898370 */     // MIs[0] policy
     /* 1898370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898380 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1898383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898404 */     // GIR_Coverage, 19253,
     /* 1898404 */     GIR_EraseRootFromParent_Done,
     /* 1898405 */   // Label 25582: @1898405
     /* 1898405 */   GIM_Try, /*On fail goto*//*Label 25583*/ GIMT_Encode4(1898491), // Rule ID 19256 //
     /* 1898410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898456 */     // MIs[0] policy
     /* 1898456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898466 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1898469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898490 */     // GIR_Coverage, 19256,
     /* 1898490 */     GIR_EraseRootFromParent_Done,
     /* 1898491 */   // Label 25583: @1898491
     /* 1898491 */   GIM_Try, /*On fail goto*//*Label 25584*/ GIMT_Encode4(1898577), // Rule ID 19257 //
     /* 1898496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1898507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1898510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1898513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898542 */     // MIs[0] policy
     /* 1898542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1898555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898576 */     // GIR_Coverage, 19257,
     /* 1898576 */     GIR_EraseRootFromParent_Done,
     /* 1898577 */   // Label 25584: @1898577
     /* 1898577 */   GIM_Try, /*On fail goto*//*Label 25585*/ GIMT_Encode4(1898663), // Rule ID 19260 //
     /* 1898582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1898593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1898596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1898599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1898605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898628 */     // MIs[0] policy
     /* 1898628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898638 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1898641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898662 */     // GIR_Coverage, 19260,
     /* 1898662 */     GIR_EraseRootFromParent_Done,
     /* 1898663 */   // Label 25585: @1898663
     /* 1898663 */   GIM_Try, /*On fail goto*//*Label 25586*/ GIMT_Encode4(1898749), // Rule ID 19261 //
     /* 1898668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1898679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1898682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1898685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1898691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898714 */     // MIs[0] policy
     /* 1898714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898724 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1898727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898748 */     // GIR_Coverage, 19261,
     /* 1898748 */     GIR_EraseRootFromParent_Done,
     /* 1898749 */   // Label 25586: @1898749
     /* 1898749 */   GIM_Try, /*On fail goto*//*Label 25587*/ GIMT_Encode4(1898835), // Rule ID 19264 //
     /* 1898754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1898765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1898768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1898771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1898777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898800 */     // MIs[0] policy
     /* 1898800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898810 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1898813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898834 */     // GIR_Coverage, 19264,
     /* 1898834 */     GIR_EraseRootFromParent_Done,
     /* 1898835 */   // Label 25587: @1898835
     /* 1898835 */   GIM_Try, /*On fail goto*//*Label 25588*/ GIMT_Encode4(1898921), // Rule ID 19265 //
     /* 1898840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1898851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1898854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1898857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1898860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1898863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1898882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898886 */     // MIs[0] policy
     /* 1898886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898896 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1898899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898920 */     // GIR_Coverage, 19265,
     /* 1898920 */     GIR_EraseRootFromParent_Done,
     /* 1898921 */   // Label 25588: @1898921
     /* 1898921 */   GIM_Try, /*On fail goto*//*Label 25589*/ GIMT_Encode4(1899007), // Rule ID 19268 //
     /* 1898926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1898934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1898937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1898940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1898943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1898946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1898968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898972 */     // MIs[0] policy
     /* 1898972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898982 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1898985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899006 */     // GIR_Coverage, 19268,
     /* 1899006 */     GIR_EraseRootFromParent_Done,
     /* 1899007 */   // Label 25589: @1899007
     /* 1899007 */   GIM_Try, /*On fail goto*//*Label 25590*/ GIMT_Encode4(1899093), // Rule ID 19269 //
     /* 1899012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1899023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1899026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1899029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899058 */     // MIs[0] policy
     /* 1899058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899068 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1899071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899092 */     // GIR_Coverage, 19269,
     /* 1899092 */     GIR_EraseRootFromParent_Done,
     /* 1899093 */   // Label 25590: @1899093
     /* 1899093 */   GIM_Try, /*On fail goto*//*Label 25591*/ GIMT_Encode4(1899179), // Rule ID 19272 //
     /* 1899098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899144 */     // MIs[0] policy
     /* 1899144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899154 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1899157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899178 */     // GIR_Coverage, 19272,
     /* 1899178 */     GIR_EraseRootFromParent_Done,
     /* 1899179 */   // Label 25591: @1899179
     /* 1899179 */   GIM_Try, /*On fail goto*//*Label 25592*/ GIMT_Encode4(1899265), // Rule ID 19273 //
     /* 1899184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1899195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1899198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1899201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899230 */     // MIs[0] policy
     /* 1899230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899240 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1899243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899264 */     // GIR_Coverage, 19273,
     /* 1899264 */     GIR_EraseRootFromParent_Done,
     /* 1899265 */   // Label 25592: @1899265
     /* 1899265 */   GIM_Try, /*On fail goto*//*Label 25593*/ GIMT_Encode4(1899351), // Rule ID 19276 //
     /* 1899270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899316 */     // MIs[0] policy
     /* 1899316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899326 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1899329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899350 */     // GIR_Coverage, 19276,
     /* 1899350 */     GIR_EraseRootFromParent_Done,
     /* 1899351 */   // Label 25593: @1899351
     /* 1899351 */   GIM_Try, /*On fail goto*//*Label 25594*/ GIMT_Encode4(1899437), // Rule ID 19277 //
     /* 1899356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1899367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1899370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1899373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1899376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1899398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899402 */     // MIs[0] policy
     /* 1899402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899412 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1899415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899436 */     // GIR_Coverage, 19277,
     /* 1899436 */     GIR_EraseRootFromParent_Done,
     /* 1899437 */   // Label 25594: @1899437
     /* 1899437 */   GIM_Try, /*On fail goto*//*Label 25595*/ GIMT_Encode4(1899523), // Rule ID 19280 //
     /* 1899442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1899453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1899456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1899459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899488 */     // MIs[0] policy
     /* 1899488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899498 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1899501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899522 */     // GIR_Coverage, 19280,
     /* 1899522 */     GIR_EraseRootFromParent_Done,
     /* 1899523 */   // Label 25595: @1899523
     /* 1899523 */   GIM_Try, /*On fail goto*//*Label 25596*/ GIMT_Encode4(1899609), // Rule ID 19281 //
     /* 1899528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1899539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1899542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1899545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899574 */     // MIs[0] policy
     /* 1899574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899584 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1899587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899608 */     // GIR_Coverage, 19281,
     /* 1899608 */     GIR_EraseRootFromParent_Done,
     /* 1899609 */   // Label 25596: @1899609
     /* 1899609 */   GIM_Try, /*On fail goto*//*Label 25597*/ GIMT_Encode4(1899695), // Rule ID 19284 //
     /* 1899614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1899625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1899628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1899631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899660 */     // MIs[0] policy
     /* 1899660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899670 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1899673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899694 */     // GIR_Coverage, 19284,
     /* 1899694 */     GIR_EraseRootFromParent_Done,
     /* 1899695 */   // Label 25597: @1899695
     /* 1899695 */   GIM_Try, /*On fail goto*//*Label 25598*/ GIMT_Encode4(1899781), // Rule ID 19285 //
     /* 1899700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1899711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1899714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1899717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899746 */     // MIs[0] policy
     /* 1899746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899756 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1899759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899780 */     // GIR_Coverage, 19285,
     /* 1899780 */     GIR_EraseRootFromParent_Done,
     /* 1899781 */   // Label 25598: @1899781
     /* 1899781 */   GIM_Try, /*On fail goto*//*Label 25599*/ GIMT_Encode4(1899867), // Rule ID 19288 //
     /* 1899786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1899797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1899800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1899803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899832 */     // MIs[0] policy
     /* 1899832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899842 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1899845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899866 */     // GIR_Coverage, 19288,
     /* 1899866 */     GIR_EraseRootFromParent_Done,
     /* 1899867 */   // Label 25599: @1899867
     /* 1899867 */   GIM_Try, /*On fail goto*//*Label 25600*/ GIMT_Encode4(1899953), // Rule ID 19289 //
     /* 1899872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1899880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1899883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1899886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1899889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1899892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1899914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899918 */     // MIs[0] policy
     /* 1899918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899928 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1899931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899952 */     // GIR_Coverage, 19289,
     /* 1899952 */     GIR_EraseRootFromParent_Done,
     /* 1899953 */   // Label 25600: @1899953
     /* 1899953 */   GIM_Try, /*On fail goto*//*Label 25601*/ GIMT_Encode4(1900039), // Rule ID 19292 //
     /* 1899958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1899966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1899969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1899972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1899975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1899978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1899981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900004 */     // MIs[0] policy
     /* 1900004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900014 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1900017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900038 */     // GIR_Coverage, 19292,
     /* 1900038 */     GIR_EraseRootFromParent_Done,
     /* 1900039 */   // Label 25601: @1900039
     /* 1900039 */   GIM_Try, /*On fail goto*//*Label 25602*/ GIMT_Encode4(1900125), // Rule ID 19293 //
     /* 1900044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1900055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1900058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1900061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1900064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900090 */     // MIs[0] policy
     /* 1900090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900100 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1900103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900124 */     // GIR_Coverage, 19293,
     /* 1900124 */     GIR_EraseRootFromParent_Done,
     /* 1900125 */   // Label 25602: @1900125
     /* 1900125 */   GIM_Try, /*On fail goto*//*Label 25603*/ GIMT_Encode4(1900211), // Rule ID 19296 //
     /* 1900130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1900150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900176 */     // MIs[0] policy
     /* 1900176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900186 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1900189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900210 */     // GIR_Coverage, 19296,
     /* 1900210 */     GIR_EraseRootFromParent_Done,
     /* 1900211 */   // Label 25603: @1900211
     /* 1900211 */   GIM_Try, /*On fail goto*//*Label 25604*/ GIMT_Encode4(1900297), // Rule ID 19297 //
     /* 1900216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1900227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1900230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1900233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1900236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900262 */     // MIs[0] policy
     /* 1900262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900272 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1900275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900296 */     // GIR_Coverage, 19297,
     /* 1900296 */     GIR_EraseRootFromParent_Done,
     /* 1900297 */   // Label 25604: @1900297
     /* 1900297 */   GIM_Try, /*On fail goto*//*Label 25605*/ GIMT_Encode4(1900383), // Rule ID 19300 //
     /* 1900302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1900322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900348 */     // MIs[0] policy
     /* 1900348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900358 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1900361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900382 */     // GIR_Coverage, 19300,
     /* 1900382 */     GIR_EraseRootFromParent_Done,
     /* 1900383 */   // Label 25605: @1900383
     /* 1900383 */   GIM_Try, /*On fail goto*//*Label 25606*/ GIMT_Encode4(1900469), // Rule ID 19301 //
     /* 1900388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1900399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1900402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1900405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1900408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900434 */     // MIs[0] policy
     /* 1900434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900444 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1900447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900468 */     // GIR_Coverage, 19301,
     /* 1900468 */     GIR_EraseRootFromParent_Done,
     /* 1900469 */   // Label 25606: @1900469
     /* 1900469 */   GIM_Try, /*On fail goto*//*Label 25607*/ GIMT_Encode4(1900555), // Rule ID 19304 //
     /* 1900474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1900485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1900488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1900491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1900494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900520 */     // MIs[0] policy
     /* 1900520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900530 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1900533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900554 */     // GIR_Coverage, 19304,
     /* 1900554 */     GIR_EraseRootFromParent_Done,
     /* 1900555 */   // Label 25607: @1900555
     /* 1900555 */   GIM_Try, /*On fail goto*//*Label 25608*/ GIMT_Encode4(1900641), // Rule ID 19305 //
     /* 1900560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1900563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1900571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1900574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1900577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1900580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900606 */     // MIs[0] policy
     /* 1900606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900616 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1900619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900640 */     // GIR_Coverage, 19305,
     /* 1900640 */     GIR_EraseRootFromParent_Done,
     /* 1900641 */   // Label 25608: @1900641
     /* 1900641 */   GIM_Try, /*On fail goto*//*Label 25609*/ GIMT_Encode4(1900727), // Rule ID 19308 //
     /* 1900646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1900657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1900660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1900663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1900666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900692 */     // MIs[0] policy
     /* 1900692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900702 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1900705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900726 */     // GIR_Coverage, 19308,
     /* 1900726 */     GIR_EraseRootFromParent_Done,
     /* 1900727 */   // Label 25609: @1900727
     /* 1900727 */   GIM_Try, /*On fail goto*//*Label 25610*/ GIMT_Encode4(1900813), // Rule ID 19309 //
     /* 1900732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1900743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1900746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1900749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1900752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900778 */     // MIs[0] policy
     /* 1900778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900788 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1900791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900812 */     // GIR_Coverage, 19309,
     /* 1900812 */     GIR_EraseRootFromParent_Done,
     /* 1900813 */   // Label 25610: @1900813
     /* 1900813 */   GIM_Try, /*On fail goto*//*Label 25611*/ GIMT_Encode4(1900899), // Rule ID 19312 //
     /* 1900818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1900829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1900832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1900835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1900838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900864 */     // MIs[0] policy
     /* 1900864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900874 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1900877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900898 */     // GIR_Coverage, 19312,
     /* 1900898 */     GIR_EraseRootFromParent_Done,
     /* 1900899 */   // Label 25611: @1900899
     /* 1900899 */   GIM_Try, /*On fail goto*//*Label 25612*/ GIMT_Encode4(1900985), // Rule ID 19313 //
     /* 1900904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1900915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1900918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1900921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1900924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1900927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1900934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1900946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900950 */     // MIs[0] policy
     /* 1900950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900960 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1900963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900984 */     // GIR_Coverage, 19313,
     /* 1900984 */     GIR_EraseRootFromParent_Done,
     /* 1900985 */   // Label 25612: @1900985
     /* 1900985 */   GIM_Try, /*On fail goto*//*Label 25613*/ GIMT_Encode4(1901071), // Rule ID 19316 //
     /* 1900990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1900993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1900998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1901010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901036 */     // MIs[0] policy
     /* 1901036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901046 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1901049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901070 */     // GIR_Coverage, 19316,
     /* 1901070 */     GIR_EraseRootFromParent_Done,
     /* 1901071 */   // Label 25613: @1901071
     /* 1901071 */   GIM_Try, /*On fail goto*//*Label 25614*/ GIMT_Encode4(1901157), // Rule ID 19317 //
     /* 1901076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1901087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1901090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1901093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1901096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901122 */     // MIs[0] policy
     /* 1901122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901132 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1901135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901156 */     // GIR_Coverage, 19317,
     /* 1901156 */     GIR_EraseRootFromParent_Done,
     /* 1901157 */   // Label 25614: @1901157
     /* 1901157 */   GIM_Try, /*On fail goto*//*Label 25615*/ GIMT_Encode4(1901243), // Rule ID 19320 //
     /* 1901162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1901182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901208 */     // MIs[0] policy
     /* 1901208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901218 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1901221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901242 */     // GIR_Coverage, 19320,
     /* 1901242 */     GIR_EraseRootFromParent_Done,
     /* 1901243 */   // Label 25615: @1901243
     /* 1901243 */   GIM_Try, /*On fail goto*//*Label 25616*/ GIMT_Encode4(1901329), // Rule ID 19321 //
     /* 1901248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1901259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1901262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1901265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1901268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901294 */     // MIs[0] policy
     /* 1901294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901304 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1901307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901328 */     // GIR_Coverage, 19321,
     /* 1901328 */     GIR_EraseRootFromParent_Done,
     /* 1901329 */   // Label 25616: @1901329
     /* 1901329 */   GIM_Try, /*On fail goto*//*Label 25617*/ GIMT_Encode4(1901415), // Rule ID 19324 //
     /* 1901334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1901354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901380 */     // MIs[0] policy
     /* 1901380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901390 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1901393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901414 */     // GIR_Coverage, 19324,
     /* 1901414 */     GIR_EraseRootFromParent_Done,
     /* 1901415 */   // Label 25617: @1901415
     /* 1901415 */   GIM_Try, /*On fail goto*//*Label 25618*/ GIMT_Encode4(1901501), // Rule ID 19325 //
     /* 1901420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1901431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1901434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1901437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1901440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1901443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901466 */     // MIs[0] policy
     /* 1901466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901476 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1901479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901500 */     // GIR_Coverage, 19325,
     /* 1901500 */     GIR_EraseRootFromParent_Done,
     /* 1901501 */   // Label 25618: @1901501
     /* 1901501 */   GIM_Try, /*On fail goto*//*Label 25619*/ GIMT_Encode4(1901587), // Rule ID 19328 //
     /* 1901506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1901517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1901520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1901523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1901526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901552 */     // MIs[0] policy
     /* 1901552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901562 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1901565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901586 */     // GIR_Coverage, 19328,
     /* 1901586 */     GIR_EraseRootFromParent_Done,
     /* 1901587 */   // Label 25619: @1901587
     /* 1901587 */   GIM_Try, /*On fail goto*//*Label 25620*/ GIMT_Encode4(1901673), // Rule ID 19329 //
     /* 1901592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1901603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1901606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1901609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1901612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1901622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1901634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901638 */     // MIs[0] policy
     /* 1901638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901648 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1901651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901672 */     // GIR_Coverage, 19329,
     /* 1901672 */     GIR_EraseRootFromParent_Done,
     /* 1901673 */   // Label 25620: @1901673
     /* 1901673 */   GIM_Try, /*On fail goto*//*Label 25621*/ GIMT_Encode4(1901759), // Rule ID 19332 //
     /* 1901678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1901689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1901692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1901695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1901698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901724 */     // MIs[0] policy
     /* 1901724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901734 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1901737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901758 */     // GIR_Coverage, 19332,
     /* 1901758 */     GIR_EraseRootFromParent_Done,
     /* 1901759 */   // Label 25621: @1901759
     /* 1901759 */   GIM_Try, /*On fail goto*//*Label 25622*/ GIMT_Encode4(1901845), // Rule ID 19333 //
     /* 1901764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1901775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1901778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1901781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1901784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1901794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1901806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901810 */     // MIs[0] policy
     /* 1901810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901820 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1901823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901844 */     // GIR_Coverage, 19333,
     /* 1901844 */     GIR_EraseRootFromParent_Done,
     /* 1901845 */   // Label 25622: @1901845
     /* 1901845 */   GIM_Try, /*On fail goto*//*Label 25623*/ GIMT_Encode4(1901931), // Rule ID 19336 //
     /* 1901850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1901861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1901864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1901867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1901870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901896 */     // MIs[0] policy
     /* 1901896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901906 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1901909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901930 */     // GIR_Coverage, 19336,
     /* 1901930 */     GIR_EraseRootFromParent_Done,
     /* 1901931 */   // Label 25623: @1901931
     /* 1901931 */   GIM_Try, /*On fail goto*//*Label 25624*/ GIMT_Encode4(1902017), // Rule ID 19337 //
     /* 1901936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1901944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1901947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1901950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1901953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1901956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1901959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901982 */     // MIs[0] policy
     /* 1901982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901992 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1901995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902016 */     // GIR_Coverage, 19337,
     /* 1902016 */     GIR_EraseRootFromParent_Done,
     /* 1902017 */   // Label 25624: @1902017
     /* 1902017 */   GIM_Try, /*On fail goto*//*Label 25625*/ GIMT_Encode4(1902103), // Rule ID 19340 //
     /* 1902022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1902042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902068 */     // MIs[0] policy
     /* 1902068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902078 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1902081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902102 */     // GIR_Coverage, 19340,
     /* 1902102 */     GIR_EraseRootFromParent_Done,
     /* 1902103 */   // Label 25625: @1902103
     /* 1902103 */   GIM_Try, /*On fail goto*//*Label 25626*/ GIMT_Encode4(1902189), // Rule ID 19341 //
     /* 1902108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1902119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1902122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1902125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1902128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902154 */     // MIs[0] policy
     /* 1902154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902164 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1902167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902188 */     // GIR_Coverage, 19341,
     /* 1902188 */     GIR_EraseRootFromParent_Done,
     /* 1902189 */   // Label 25626: @1902189
     /* 1902189 */   GIM_Try, /*On fail goto*//*Label 25627*/ GIMT_Encode4(1902275), // Rule ID 19344 //
     /* 1902194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1902214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902240 */     // MIs[0] policy
     /* 1902240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902250 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1902253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902274 */     // GIR_Coverage, 19344,
     /* 1902274 */     GIR_EraseRootFromParent_Done,
     /* 1902275 */   // Label 25627: @1902275
     /* 1902275 */   GIM_Try, /*On fail goto*//*Label 25628*/ GIMT_Encode4(1902361), // Rule ID 19345 //
     /* 1902280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1902291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1902294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1902297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1902300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902326 */     // MIs[0] policy
     /* 1902326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902336 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1902339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902360 */     // GIR_Coverage, 19345,
     /* 1902360 */     GIR_EraseRootFromParent_Done,
     /* 1902361 */   // Label 25628: @1902361
     /* 1902361 */   GIM_Try, /*On fail goto*//*Label 25629*/ GIMT_Encode4(1902447), // Rule ID 19348 //
     /* 1902366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1902369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1902386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902412 */     // MIs[0] policy
     /* 1902412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902422 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1902425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902446 */     // GIR_Coverage, 19348,
     /* 1902446 */     GIR_EraseRootFromParent_Done,
     /* 1902447 */   // Label 25629: @1902447
     /* 1902447 */   GIM_Try, /*On fail goto*//*Label 25630*/ GIMT_Encode4(1902533), // Rule ID 19349 //
     /* 1902452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1902463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1902466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1902469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1902472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902498 */     // MIs[0] policy
     /* 1902498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902508 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1902511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902532 */     // GIR_Coverage, 19349,
     /* 1902532 */     GIR_EraseRootFromParent_Done,
     /* 1902533 */   // Label 25630: @1902533
     /* 1902533 */   GIM_Try, /*On fail goto*//*Label 25631*/ GIMT_Encode4(1902619), // Rule ID 19352 //
     /* 1902538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1902549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1902552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1902555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902584 */     // MIs[0] policy
     /* 1902584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902594 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1902597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902618 */     // GIR_Coverage, 19352,
     /* 1902618 */     GIR_EraseRootFromParent_Done,
     /* 1902619 */   // Label 25631: @1902619
     /* 1902619 */   GIM_Try, /*On fail goto*//*Label 25632*/ GIMT_Encode4(1902705), // Rule ID 19353 //
     /* 1902624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1902635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1902638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1902641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902670 */     // MIs[0] policy
     /* 1902670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902680 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1902683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902704 */     // GIR_Coverage, 19353,
     /* 1902704 */     GIR_EraseRootFromParent_Done,
     /* 1902705 */   // Label 25632: @1902705
     /* 1902705 */   GIM_Try, /*On fail goto*//*Label 25633*/ GIMT_Encode4(1902791), // Rule ID 19356 //
     /* 1902710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1902721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1902724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1902727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902756 */     // MIs[0] policy
     /* 1902756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902766 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1902769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902790 */     // GIR_Coverage, 19356,
     /* 1902790 */     GIR_EraseRootFromParent_Done,
     /* 1902791 */   // Label 25633: @1902791
     /* 1902791 */   GIM_Try, /*On fail goto*//*Label 25634*/ GIMT_Encode4(1902877), // Rule ID 19357 //
     /* 1902796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1902807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1902810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1902813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1902819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902842 */     // MIs[0] policy
     /* 1902842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902852 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1902855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902876 */     // GIR_Coverage, 19357,
     /* 1902876 */     GIR_EraseRootFromParent_Done,
     /* 1902877 */   // Label 25634: @1902877
     /* 1902877 */   GIM_Try, /*On fail goto*//*Label 25635*/ GIMT_Encode4(1902963), // Rule ID 19360 //
     /* 1902882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1902893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1902896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1902899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902928 */     // MIs[0] policy
     /* 1902928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902938 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1902941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902962 */     // GIR_Coverage, 19360,
     /* 1902962 */     GIR_EraseRootFromParent_Done,
     /* 1902963 */   // Label 25635: @1902963
     /* 1902963 */   GIM_Try, /*On fail goto*//*Label 25636*/ GIMT_Encode4(1903049), // Rule ID 19361 //
     /* 1902968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1902976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1902979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1902982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1902985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903014 */     // MIs[0] policy
     /* 1903014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903024 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1903027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903048 */     // GIR_Coverage, 19361,
     /* 1903048 */     GIR_EraseRootFromParent_Done,
     /* 1903049 */   // Label 25636: @1903049
     /* 1903049 */   GIM_Try, /*On fail goto*//*Label 25637*/ GIMT_Encode4(1903135), // Rule ID 19364 //
     /* 1903054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903100 */     // MIs[0] policy
     /* 1903100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903110 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1903113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903134 */     // GIR_Coverage, 19364,
     /* 1903134 */     GIR_EraseRootFromParent_Done,
     /* 1903135 */   // Label 25637: @1903135
     /* 1903135 */   GIM_Try, /*On fail goto*//*Label 25638*/ GIMT_Encode4(1903221), // Rule ID 19365 //
     /* 1903140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1903151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1903154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1903157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903186 */     // MIs[0] policy
     /* 1903186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903196 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11210:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1903199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903220 */     // GIR_Coverage, 19365,
     /* 1903220 */     GIR_EraseRootFromParent_Done,
     /* 1903221 */   // Label 25638: @1903221
     /* 1903221 */   GIM_Try, /*On fail goto*//*Label 25639*/ GIMT_Encode4(1903307), // Rule ID 19368 //
     /* 1903226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903272 */     // MIs[0] policy
     /* 1903272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903282 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1903285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903306 */     // GIR_Coverage, 19368,
     /* 1903306 */     GIR_EraseRootFromParent_Done,
     /* 1903307 */   // Label 25639: @1903307
     /* 1903307 */   GIM_Try, /*On fail goto*//*Label 25640*/ GIMT_Encode4(1903393), // Rule ID 19369 //
     /* 1903312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1903323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1903326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1903329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903358 */     // MIs[0] policy
     /* 1903358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903368 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1903371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903392 */     // GIR_Coverage, 19369,
     /* 1903392 */     GIR_EraseRootFromParent_Done,
     /* 1903393 */   // Label 25640: @1903393
     /* 1903393 */   GIM_Try, /*On fail goto*//*Label 25641*/ GIMT_Encode4(1903479), // Rule ID 19372 //
     /* 1903398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903444 */     // MIs[0] policy
     /* 1903444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903454 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1903457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903478 */     // GIR_Coverage, 19372,
     /* 1903478 */     GIR_EraseRootFromParent_Done,
     /* 1903479 */   // Label 25641: @1903479
     /* 1903479 */   GIM_Try, /*On fail goto*//*Label 25642*/ GIMT_Encode4(1903565), // Rule ID 19373 //
     /* 1903484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1903495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1903498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1903501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903530 */     // MIs[0] policy
     /* 1903530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903540 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1903543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903564 */     // GIR_Coverage, 19373,
     /* 1903564 */     GIR_EraseRootFromParent_Done,
     /* 1903565 */   // Label 25642: @1903565
     /* 1903565 */   GIM_Try, /*On fail goto*//*Label 25643*/ GIMT_Encode4(1903651), // Rule ID 19376 //
     /* 1903570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1903581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1903584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1903587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1903600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903616 */     // MIs[0] policy
     /* 1903616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903626 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1903629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903650 */     // GIR_Coverage, 19376,
     /* 1903650 */     GIR_EraseRootFromParent_Done,
     /* 1903651 */   // Label 25643: @1903651
     /* 1903651 */   GIM_Try, /*On fail goto*//*Label 25644*/ GIMT_Encode4(1903737), // Rule ID 19377 //
     /* 1903656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1903667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1903670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1903673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1903686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903702 */     // MIs[0] policy
     /* 1903702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903712 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1903715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903736 */     // GIR_Coverage, 19377,
     /* 1903736 */     GIR_EraseRootFromParent_Done,
     /* 1903737 */   // Label 25644: @1903737
     /* 1903737 */   GIM_Try, /*On fail goto*//*Label 25645*/ GIMT_Encode4(1903823), // Rule ID 19380 //
     /* 1903742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1903753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1903756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1903759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1903772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903788 */     // MIs[0] policy
     /* 1903788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903798 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1903801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903822 */     // GIR_Coverage, 19380,
     /* 1903822 */     GIR_EraseRootFromParent_Done,
     /* 1903823 */   // Label 25645: @1903823
     /* 1903823 */   GIM_Try, /*On fail goto*//*Label 25646*/ GIMT_Encode4(1903909), // Rule ID 19381 //
     /* 1903828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1903839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1903842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1903845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1903858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903874 */     // MIs[0] policy
     /* 1903874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903884 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1903887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903908 */     // GIR_Coverage, 19381,
     /* 1903908 */     GIR_EraseRootFromParent_Done,
     /* 1903909 */   // Label 25646: @1903909
     /* 1903909 */   GIM_Try, /*On fail goto*//*Label 25647*/ GIMT_Encode4(1903995), // Rule ID 19384 //
     /* 1903914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1903922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1903925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1903928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1903931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1903934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1903937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1903956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903960 */     // MIs[0] policy
     /* 1903960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903970 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1903973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903994 */     // GIR_Coverage, 19384,
     /* 1903994 */     GIR_EraseRootFromParent_Done,
     /* 1903995 */   // Label 25647: @1903995
     /* 1903995 */   GIM_Try, /*On fail goto*//*Label 25648*/ GIMT_Encode4(1904081), // Rule ID 19385 //
     /* 1904000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1904011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1904014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1904017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1904020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1904023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1904042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904046 */     // MIs[0] policy
     /* 1904046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904056 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1904059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904080 */     // GIR_Coverage, 19385,
     /* 1904080 */     GIR_EraseRootFromParent_Done,
     /* 1904081 */   // Label 25648: @1904081
     /* 1904081 */   GIM_Try, /*On fail goto*//*Label 25649*/ GIMT_Encode4(1904167), // Rule ID 19388 //
     /* 1904086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904132 */     // MIs[0] policy
     /* 1904132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904142 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1904145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904166 */     // GIR_Coverage, 19388,
     /* 1904166 */     GIR_EraseRootFromParent_Done,
     /* 1904167 */   // Label 25649: @1904167
     /* 1904167 */   GIM_Try, /*On fail goto*//*Label 25650*/ GIMT_Encode4(1904253), // Rule ID 19389 //
     /* 1904172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1904183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1904186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1904189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904218 */     // MIs[0] policy
     /* 1904218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904228 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1904231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904252 */     // GIR_Coverage, 19389,
     /* 1904252 */     GIR_EraseRootFromParent_Done,
     /* 1904253 */   // Label 25650: @1904253
     /* 1904253 */   GIM_Try, /*On fail goto*//*Label 25651*/ GIMT_Encode4(1904339), // Rule ID 19392 //
     /* 1904258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904304 */     // MIs[0] policy
     /* 1904304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904314 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1904317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904338 */     // GIR_Coverage, 19392,
     /* 1904338 */     GIR_EraseRootFromParent_Done,
     /* 1904339 */   // Label 25651: @1904339
     /* 1904339 */   GIM_Try, /*On fail goto*//*Label 25652*/ GIMT_Encode4(1904425), // Rule ID 19393 //
     /* 1904344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1904355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1904358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1904361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904390 */     // MIs[0] policy
     /* 1904390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904400 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1904403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904424 */     // GIR_Coverage, 19393,
     /* 1904424 */     GIR_EraseRootFromParent_Done,
     /* 1904425 */   // Label 25652: @1904425
     /* 1904425 */   GIM_Try, /*On fail goto*//*Label 25653*/ GIMT_Encode4(1904511), // Rule ID 19396 //
     /* 1904430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1904441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1904444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1904447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904476 */     // MIs[0] policy
     /* 1904476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904486 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1904489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904510 */     // GIR_Coverage, 19396,
     /* 1904510 */     GIR_EraseRootFromParent_Done,
     /* 1904511 */   // Label 25653: @1904511
     /* 1904511 */   GIM_Try, /*On fail goto*//*Label 25654*/ GIMT_Encode4(1904597), // Rule ID 19397 //
     /* 1904516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1904527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1904530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1904533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1904536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1904558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904562 */     // MIs[0] policy
     /* 1904562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904572 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1904575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904596 */     // GIR_Coverage, 19397,
     /* 1904596 */     GIR_EraseRootFromParent_Done,
     /* 1904597 */   // Label 25654: @1904597
     /* 1904597 */   GIM_Try, /*On fail goto*//*Label 25655*/ GIMT_Encode4(1904683), // Rule ID 19400 //
     /* 1904602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1904613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1904616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1904619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904648 */     // MIs[0] policy
     /* 1904648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904658 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1904661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904682 */     // GIR_Coverage, 19400,
     /* 1904682 */     GIR_EraseRootFromParent_Done,
     /* 1904683 */   // Label 25655: @1904683
     /* 1904683 */   GIM_Try, /*On fail goto*//*Label 25656*/ GIMT_Encode4(1904769), // Rule ID 19401 //
     /* 1904688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1904691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1904699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1904702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1904705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904734 */     // MIs[0] policy
     /* 1904734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904744 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1904747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904768 */     // GIR_Coverage, 19401,
     /* 1904768 */     GIR_EraseRootFromParent_Done,
     /* 1904769 */   // Label 25656: @1904769
     /* 1904769 */   GIM_Try, /*On fail goto*//*Label 25657*/ GIMT_Encode4(1904855), // Rule ID 19404 //
     /* 1904774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1904785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1904788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1904791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904820 */     // MIs[0] policy
     /* 1904820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904830 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1904833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904854 */     // GIR_Coverage, 19404,
     /* 1904854 */     GIR_EraseRootFromParent_Done,
     /* 1904855 */   // Label 25657: @1904855
     /* 1904855 */   GIM_Try, /*On fail goto*//*Label 25658*/ GIMT_Encode4(1904941), // Rule ID 19405 //
     /* 1904860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1904863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1904871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1904874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1904877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904906 */     // MIs[0] policy
     /* 1904906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904916 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1904919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904940 */     // GIR_Coverage, 19405,
     /* 1904940 */     GIR_EraseRootFromParent_Done,
     /* 1904941 */   // Label 25658: @1904941
     /* 1904941 */   GIM_Try, /*On fail goto*//*Label 25659*/ GIMT_Encode4(1905027), // Rule ID 19408 //
     /* 1904946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1904954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1904957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1904960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1904963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1904966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1904976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1904984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1904988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904992 */     // MIs[0] policy
     /* 1904992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905002 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1905005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905026 */     // GIR_Coverage, 19408,
     /* 1905026 */     GIR_EraseRootFromParent_Done,
     /* 1905027 */   // Label 25659: @1905027
     /* 1905027 */   GIM_Try, /*On fail goto*//*Label 25660*/ GIMT_Encode4(1905113), // Rule ID 19409 //
     /* 1905032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1905040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1905043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1905046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1905049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1905052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1905074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905078 */     // MIs[0] policy
     /* 1905078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905088 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1905091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905112 */     // GIR_Coverage, 19409,
     /* 1905112 */     GIR_EraseRootFromParent_Done,
     /* 1905113 */   // Label 25660: @1905113
     /* 1905113 */   GIM_Try, /*On fail goto*//*Label 25661*/ GIMT_Encode4(1905199), // Rule ID 19412 //
     /* 1905118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1905138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905164 */     // MIs[0] policy
     /* 1905164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905174 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1905177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905198 */     // GIR_Coverage, 19412,
     /* 1905198 */     GIR_EraseRootFromParent_Done,
     /* 1905199 */   // Label 25661: @1905199
     /* 1905199 */   GIM_Try, /*On fail goto*//*Label 25662*/ GIMT_Encode4(1905285), // Rule ID 19413 //
     /* 1905204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1905215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1905218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1905221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1905224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905250 */     // MIs[0] policy
     /* 1905250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905260 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1905263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905284 */     // GIR_Coverage, 19413,
     /* 1905284 */     GIR_EraseRootFromParent_Done,
     /* 1905285 */   // Label 25662: @1905285
     /* 1905285 */   GIM_Try, /*On fail goto*//*Label 25663*/ GIMT_Encode4(1905371), // Rule ID 19416 //
     /* 1905290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1905310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905336 */     // MIs[0] policy
     /* 1905336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905346 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1905349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905370 */     // GIR_Coverage, 19416,
     /* 1905370 */     GIR_EraseRootFromParent_Done,
     /* 1905371 */   // Label 25663: @1905371
     /* 1905371 */   GIM_Try, /*On fail goto*//*Label 25664*/ GIMT_Encode4(1905457), // Rule ID 19417 //
     /* 1905376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1905387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1905390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1905393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1905396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905422 */     // MIs[0] policy
     /* 1905422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905432 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1905435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905456 */     // GIR_Coverage, 19417,
     /* 1905456 */     GIR_EraseRootFromParent_Done,
     /* 1905457 */   // Label 25664: @1905457
     /* 1905457 */   GIM_Try, /*On fail goto*//*Label 25665*/ GIMT_Encode4(1905543), // Rule ID 19420 //
     /* 1905462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1905473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1905476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1905479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1905482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905508 */     // MIs[0] policy
     /* 1905508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905518 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1905521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905542 */     // GIR_Coverage, 19420,
     /* 1905542 */     GIR_EraseRootFromParent_Done,
     /* 1905543 */   // Label 25665: @1905543
     /* 1905543 */   GIM_Try, /*On fail goto*//*Label 25666*/ GIMT_Encode4(1905629), // Rule ID 19421 //
     /* 1905548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1905559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1905562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1905565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1905568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1905571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905594 */     // MIs[0] policy
     /* 1905594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905604 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1905607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905628 */     // GIR_Coverage, 19421,
     /* 1905628 */     GIR_EraseRootFromParent_Done,
     /* 1905629 */   // Label 25666: @1905629
     /* 1905629 */   GIM_Try, /*On fail goto*//*Label 25667*/ GIMT_Encode4(1905715), // Rule ID 19424 //
     /* 1905634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1905645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1905648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1905651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1905654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905680 */     // MIs[0] policy
     /* 1905680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905690 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1905693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905714 */     // GIR_Coverage, 19424,
     /* 1905714 */     GIR_EraseRootFromParent_Done,
     /* 1905715 */   // Label 25667: @1905715
     /* 1905715 */   GIM_Try, /*On fail goto*//*Label 25668*/ GIMT_Encode4(1905801), // Rule ID 19425 //
     /* 1905720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1905731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1905734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1905737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1905740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905766 */     // MIs[0] policy
     /* 1905766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905776 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1905779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905800 */     // GIR_Coverage, 19425,
     /* 1905800 */     GIR_EraseRootFromParent_Done,
     /* 1905801 */   // Label 25668: @1905801
     /* 1905801 */   GIM_Try, /*On fail goto*//*Label 25669*/ GIMT_Encode4(1905887), // Rule ID 19428 //
     /* 1905806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1905823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905852 */     // MIs[0] policy
     /* 1905852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905862 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1905865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905886 */     // GIR_Coverage, 19428,
     /* 1905886 */     GIR_EraseRootFromParent_Done,
     /* 1905887 */   // Label 25669: @1905887
     /* 1905887 */   GIM_Try, /*On fail goto*//*Label 25670*/ GIMT_Encode4(1905973), // Rule ID 19429 //
     /* 1905892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1905903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1905906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1905909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1905912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1905922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1905934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905938 */     // MIs[0] policy
     /* 1905938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905948 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1905951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905972 */     // GIR_Coverage, 19429,
     /* 1905972 */     GIR_EraseRootFromParent_Done,
     /* 1905973 */   // Label 25670: @1905973
     /* 1905973 */   GIM_Try, /*On fail goto*//*Label 25671*/ GIMT_Encode4(1906059), // Rule ID 19432 //
     /* 1905978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1905986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1905989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1905992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1905995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1905998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906024 */     // MIs[0] policy
     /* 1906024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906034 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1906037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906058 */     // GIR_Coverage, 19432,
     /* 1906058 */     GIR_EraseRootFromParent_Done,
     /* 1906059 */   // Label 25671: @1906059
     /* 1906059 */   GIM_Try, /*On fail goto*//*Label 25672*/ GIMT_Encode4(1906145), // Rule ID 19433 //
     /* 1906064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1906075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1906078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1906081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1906084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906110 */     // MIs[0] policy
     /* 1906110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906120 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1906123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906144 */     // GIR_Coverage, 19433,
     /* 1906144 */     GIR_EraseRootFromParent_Done,
     /* 1906145 */   // Label 25672: @1906145
     /* 1906145 */   GIM_Try, /*On fail goto*//*Label 25673*/ GIMT_Encode4(1906231), // Rule ID 19436 //
     /* 1906150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1906170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906196 */     // MIs[0] policy
     /* 1906196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906206 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1906209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906230 */     // GIR_Coverage, 19436,
     /* 1906230 */     GIR_EraseRootFromParent_Done,
     /* 1906231 */   // Label 25673: @1906231
     /* 1906231 */   GIM_Try, /*On fail goto*//*Label 25674*/ GIMT_Encode4(1906317), // Rule ID 19437 //
     /* 1906236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1906247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1906250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1906253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1906256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906282 */     // MIs[0] policy
     /* 1906282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906292 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1906295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906316 */     // GIR_Coverage, 19437,
     /* 1906316 */     GIR_EraseRootFromParent_Done,
     /* 1906317 */   // Label 25674: @1906317
     /* 1906317 */   GIM_Try, /*On fail goto*//*Label 25675*/ GIMT_Encode4(1906403), // Rule ID 19440 //
     /* 1906322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1906342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906368 */     // MIs[0] policy
     /* 1906368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906378 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1906381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906402 */     // GIR_Coverage, 19440,
     /* 1906402 */     GIR_EraseRootFromParent_Done,
     /* 1906403 */   // Label 25675: @1906403
     /* 1906403 */   GIM_Try, /*On fail goto*//*Label 25676*/ GIMT_Encode4(1906489), // Rule ID 19441 //
     /* 1906408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1906419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1906422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1906425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1906428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1906431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906454 */     // MIs[0] policy
     /* 1906454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906464 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1906467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906488 */     // GIR_Coverage, 19441,
     /* 1906488 */     GIR_EraseRootFromParent_Done,
     /* 1906489 */   // Label 25676: @1906489
     /* 1906489 */   GIM_Try, /*On fail goto*//*Label 25677*/ GIMT_Encode4(1906575), // Rule ID 19444 //
     /* 1906494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1906505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1906508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1906511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1906514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1906517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906540 */     // MIs[0] policy
     /* 1906540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906550 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1906553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906574 */     // GIR_Coverage, 19444,
     /* 1906574 */     GIR_EraseRootFromParent_Done,
     /* 1906575 */   // Label 25677: @1906575
     /* 1906575 */   GIM_Try, /*On fail goto*//*Label 25678*/ GIMT_Encode4(1906661), // Rule ID 19445 //
     /* 1906580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1906591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1906594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1906597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1906600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1906603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906626 */     // MIs[0] policy
     /* 1906626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906636 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1906639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906660 */     // GIR_Coverage, 19445,
     /* 1906660 */     GIR_EraseRootFromParent_Done,
     /* 1906661 */   // Label 25678: @1906661
     /* 1906661 */   GIM_Try, /*On fail goto*//*Label 25679*/ GIMT_Encode4(1906747), // Rule ID 19448 //
     /* 1906666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1906677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1906680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1906683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1906686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906712 */     // MIs[0] policy
     /* 1906712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906722 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1906725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906746 */     // GIR_Coverage, 19448,
     /* 1906746 */     GIR_EraseRootFromParent_Done,
     /* 1906747 */   // Label 25679: @1906747
     /* 1906747 */   GIM_Try, /*On fail goto*//*Label 25680*/ GIMT_Encode4(1906833), // Rule ID 19449 //
     /* 1906752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1906763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1906766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1906769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1906772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1906782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1906794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906798 */     // MIs[0] policy
     /* 1906798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906808 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1906811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906832 */     // GIR_Coverage, 19449,
     /* 1906832 */     GIR_EraseRootFromParent_Done,
     /* 1906833 */   // Label 25680: @1906833
     /* 1906833 */   GIM_Try, /*On fail goto*//*Label 25681*/ GIMT_Encode4(1906919), // Rule ID 19452 //
     /* 1906838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1906849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1906852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1906855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1906858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906884 */     // MIs[0] policy
     /* 1906884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906894 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1906897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906918 */     // GIR_Coverage, 19452,
     /* 1906918 */     GIR_EraseRootFromParent_Done,
     /* 1906919 */   // Label 25681: @1906919
     /* 1906919 */   GIM_Try, /*On fail goto*//*Label 25682*/ GIMT_Encode4(1907005), // Rule ID 19453 //
     /* 1906924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1906932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1906935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1906938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1906941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1906944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906970 */     // MIs[0] policy
     /* 1906970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906980 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1906983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907004 */     // GIR_Coverage, 19453,
     /* 1907004 */     GIR_EraseRootFromParent_Done,
     /* 1907005 */   // Label 25682: @1907005
     /* 1907005 */   GIM_Try, /*On fail goto*//*Label 25683*/ GIMT_Encode4(1907091), // Rule ID 19456 //
     /* 1907010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1907030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907056 */     // MIs[0] policy
     /* 1907056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907066 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1907069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907090 */     // GIR_Coverage, 19456,
     /* 1907090 */     GIR_EraseRootFromParent_Done,
     /* 1907091 */   // Label 25683: @1907091
     /* 1907091 */   GIM_Try, /*On fail goto*//*Label 25684*/ GIMT_Encode4(1907177), // Rule ID 19457 //
     /* 1907096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1907107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1907110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1907113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1907116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907142 */     // MIs[0] policy
     /* 1907142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907152 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1907155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907176 */     // GIR_Coverage, 19457,
     /* 1907176 */     GIR_EraseRootFromParent_Done,
     /* 1907177 */   // Label 25684: @1907177
     /* 1907177 */   GIM_Try, /*On fail goto*//*Label 25685*/ GIMT_Encode4(1907263), // Rule ID 19460 //
     /* 1907182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1907202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907228 */     // MIs[0] policy
     /* 1907228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907238 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1907241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907262 */     // GIR_Coverage, 19460,
     /* 1907262 */     GIR_EraseRootFromParent_Done,
     /* 1907263 */   // Label 25685: @1907263
     /* 1907263 */   GIM_Try, /*On fail goto*//*Label 25686*/ GIMT_Encode4(1907349), // Rule ID 19461 //
     /* 1907268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1907279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1907282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1907285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1907288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907314 */     // MIs[0] policy
     /* 1907314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1907327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907348 */     // GIR_Coverage, 19461,
     /* 1907348 */     GIR_EraseRootFromParent_Done,
     /* 1907349 */   // Label 25686: @1907349
     /* 1907349 */   GIM_Try, /*On fail goto*//*Label 25687*/ GIMT_Encode4(1907435), // Rule ID 19464 //
     /* 1907354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1907374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907400 */     // MIs[0] policy
     /* 1907400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907410 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1907413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907434 */     // GIR_Coverage, 19464,
     /* 1907434 */     GIR_EraseRootFromParent_Done,
     /* 1907435 */   // Label 25687: @1907435
     /* 1907435 */   GIM_Try, /*On fail goto*//*Label 25688*/ GIMT_Encode4(1907521), // Rule ID 19465 //
     /* 1907440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1907451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1907454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1907457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1907460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907486 */     // MIs[0] policy
     /* 1907486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907496 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1907499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907520 */     // GIR_Coverage, 19465,
     /* 1907520 */     GIR_EraseRootFromParent_Done,
     /* 1907521 */   // Label 25688: @1907521
     /* 1907521 */   GIM_Try, /*On fail goto*//*Label 25689*/ GIMT_Encode4(1907607), // Rule ID 19468 //
     /* 1907526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1907537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1907540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1907543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1907546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907572 */     // MIs[0] policy
     /* 1907572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907582 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1907585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907606 */     // GIR_Coverage, 19468,
     /* 1907606 */     GIR_EraseRootFromParent_Done,
     /* 1907607 */   // Label 25689: @1907607
     /* 1907607 */   GIM_Try, /*On fail goto*//*Label 25690*/ GIMT_Encode4(1907693), // Rule ID 19469 //
     /* 1907612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1907623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1907626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1907629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1907632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907658 */     // MIs[0] policy
     /* 1907658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907668 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1907671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907692 */     // GIR_Coverage, 19469,
     /* 1907692 */     GIR_EraseRootFromParent_Done,
     /* 1907693 */   // Label 25690: @1907693
     /* 1907693 */   GIM_Try, /*On fail goto*//*Label 25691*/ GIMT_Encode4(1907779), // Rule ID 19472 //
     /* 1907698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1907709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1907712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1907715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1907721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907744 */     // MIs[0] policy
     /* 1907744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907754 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1907757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907778 */     // GIR_Coverage, 19472,
     /* 1907778 */     GIR_EraseRootFromParent_Done,
     /* 1907779 */   // Label 25691: @1907779
     /* 1907779 */   GIM_Try, /*On fail goto*//*Label 25692*/ GIMT_Encode4(1907865), // Rule ID 19473 //
     /* 1907784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1907795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1907798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1907801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1907807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907830 */     // MIs[0] policy
     /* 1907830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907840 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1907843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907864 */     // GIR_Coverage, 19473,
     /* 1907864 */     GIR_EraseRootFromParent_Done,
     /* 1907865 */   // Label 25692: @1907865
     /* 1907865 */   GIM_Try, /*On fail goto*//*Label 25693*/ GIMT_Encode4(1907951), // Rule ID 19476 //
     /* 1907870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1907881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1907884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1907887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907916 */     // MIs[0] policy
     /* 1907916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907926 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1907929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907950 */     // GIR_Coverage, 19476,
     /* 1907950 */     GIR_EraseRootFromParent_Done,
     /* 1907951 */   // Label 25693: @1907951
     /* 1907951 */   GIM_Try, /*On fail goto*//*Label 25694*/ GIMT_Encode4(1908037), // Rule ID 19477 //
     /* 1907956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1907964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1907967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1907970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1907973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908002 */     // MIs[0] policy
     /* 1908002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908012 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1908015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908036 */     // GIR_Coverage, 19477,
     /* 1908036 */     GIR_EraseRootFromParent_Done,
     /* 1908037 */   // Label 25694: @1908037
     /* 1908037 */   GIM_Try, /*On fail goto*//*Label 25695*/ GIMT_Encode4(1908123), // Rule ID 19480 //
     /* 1908042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908088 */     // MIs[0] policy
     /* 1908088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908098 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1908101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908122 */     // GIR_Coverage, 19480,
     /* 1908122 */     GIR_EraseRootFromParent_Done,
     /* 1908123 */   // Label 25695: @1908123
     /* 1908123 */   GIM_Try, /*On fail goto*//*Label 25696*/ GIMT_Encode4(1908209), // Rule ID 19481 //
     /* 1908128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1908139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1908142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1908145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908174 */     // MIs[0] policy
     /* 1908174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908184 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1908187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908208 */     // GIR_Coverage, 19481,
     /* 1908208 */     GIR_EraseRootFromParent_Done,
     /* 1908209 */   // Label 25696: @1908209
     /* 1908209 */   GIM_Try, /*On fail goto*//*Label 25697*/ GIMT_Encode4(1908295), // Rule ID 19484 //
     /* 1908214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908260 */     // MIs[0] policy
     /* 1908260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908270 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1908273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908294 */     // GIR_Coverage, 19484,
     /* 1908294 */     GIR_EraseRootFromParent_Done,
     /* 1908295 */   // Label 25697: @1908295
     /* 1908295 */   GIM_Try, /*On fail goto*//*Label 25698*/ GIMT_Encode4(1908381), // Rule ID 19485 //
     /* 1908300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1908311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1908314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1908317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908346 */     // MIs[0] policy
     /* 1908346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908356 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11266:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1908359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908380 */     // GIR_Coverage, 19485,
     /* 1908380 */     GIR_EraseRootFromParent_Done,
     /* 1908381 */   // Label 25698: @1908381
     /* 1908381 */   GIM_Try, /*On fail goto*//*Label 25699*/ GIMT_Encode4(1908467), // Rule ID 19488 //
     /* 1908386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908432 */     // MIs[0] policy
     /* 1908432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908442 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1908445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908466 */     // GIR_Coverage, 19488,
     /* 1908466 */     GIR_EraseRootFromParent_Done,
     /* 1908467 */   // Label 25699: @1908467
     /* 1908467 */   GIM_Try, /*On fail goto*//*Label 25700*/ GIMT_Encode4(1908553), // Rule ID 19489 //
     /* 1908472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1908483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1908486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1908489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908518 */     // MIs[0] policy
     /* 1908518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908528 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11266:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1908531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908552 */     // GIR_Coverage, 19489,
     /* 1908552 */     GIR_EraseRootFromParent_Done,
     /* 1908553 */   // Label 25700: @1908553
     /* 1908553 */   GIM_Try, /*On fail goto*//*Label 25701*/ GIMT_Encode4(1908639), // Rule ID 19492 //
     /* 1908558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1908575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908604 */     // MIs[0] policy
     /* 1908604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908614 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1908617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908638 */     // GIR_Coverage, 19492,
     /* 1908638 */     GIR_EraseRootFromParent_Done,
     /* 1908639 */   // Label 25701: @1908639
     /* 1908639 */   GIM_Try, /*On fail goto*//*Label 25702*/ GIMT_Encode4(1908725), // Rule ID 19493 //
     /* 1908644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1908655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1908658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1908661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908690 */     // MIs[0] policy
     /* 1908690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908700 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11266:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1908703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908724 */     // GIR_Coverage, 19493,
     /* 1908724 */     GIR_EraseRootFromParent_Done,
     /* 1908725 */   // Label 25702: @1908725
     /* 1908725 */   GIM_Try, /*On fail goto*//*Label 25703*/ GIMT_Encode4(1908811), // Rule ID 19496 //
     /* 1908730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1908741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1908744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1908747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1908760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908776 */     // MIs[0] policy
     /* 1908776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908786 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1908789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908810 */     // GIR_Coverage, 19496,
     /* 1908810 */     GIR_EraseRootFromParent_Done,
     /* 1908811 */   // Label 25703: @1908811
     /* 1908811 */   GIM_Try, /*On fail goto*//*Label 25704*/ GIMT_Encode4(1908897), // Rule ID 19497 //
     /* 1908816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1908827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1908830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1908833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1908846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908862 */     // MIs[0] policy
     /* 1908862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908872 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1908875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908896 */     // GIR_Coverage, 19497,
     /* 1908896 */     GIR_EraseRootFromParent_Done,
     /* 1908897 */   // Label 25704: @1908897
     /* 1908897 */   GIM_Try, /*On fail goto*//*Label 25705*/ GIMT_Encode4(1908983), // Rule ID 19500 //
     /* 1908902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1908913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1908916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1908919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1908922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1908925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1908944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908948 */     // MIs[0] policy
     /* 1908948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908958 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1908961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908982 */     // GIR_Coverage, 19500,
     /* 1908982 */     GIR_EraseRootFromParent_Done,
     /* 1908983 */   // Label 25705: @1908983
     /* 1908983 */   GIM_Try, /*On fail goto*//*Label 25706*/ GIMT_Encode4(1909069), // Rule ID 19501 //
     /* 1908988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1908996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1908999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1909002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1909005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909034 */     // MIs[0] policy
     /* 1909034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909044 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1909047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909068 */     // GIR_Coverage, 19501,
     /* 1909068 */     GIR_EraseRootFromParent_Done,
     /* 1909069 */   // Label 25706: @1909069
     /* 1909069 */   GIM_Try, /*On fail goto*//*Label 25707*/ GIMT_Encode4(1909155), // Rule ID 19504 //
     /* 1909074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909120 */     // MIs[0] policy
     /* 1909120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909130 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1909133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909154 */     // GIR_Coverage, 19504,
     /* 1909154 */     GIR_EraseRootFromParent_Done,
     /* 1909155 */   // Label 25707: @1909155
     /* 1909155 */   GIM_Try, /*On fail goto*//*Label 25708*/ GIMT_Encode4(1909241), // Rule ID 19505 //
     /* 1909160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1909171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1909174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1909177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1909180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1909183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1909202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909206 */     // MIs[0] policy
     /* 1909206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909216 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1909219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909240 */     // GIR_Coverage, 19505,
     /* 1909240 */     GIR_EraseRootFromParent_Done,
     /* 1909241 */   // Label 25708: @1909241
     /* 1909241 */   GIM_Try, /*On fail goto*//*Label 25709*/ GIMT_Encode4(1909327), // Rule ID 19508 //
     /* 1909246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909292 */     // MIs[0] policy
     /* 1909292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909302 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1909305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909326 */     // GIR_Coverage, 19508,
     /* 1909326 */     GIR_EraseRootFromParent_Done,
     /* 1909327 */   // Label 25709: @1909327
     /* 1909327 */   GIM_Try, /*On fail goto*//*Label 25710*/ GIMT_Encode4(1909413), // Rule ID 19509 //
     /* 1909332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1909343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1909346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1909349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909378 */     // MIs[0] policy
     /* 1909378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909388 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1909391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909412 */     // GIR_Coverage, 19509,
     /* 1909412 */     GIR_EraseRootFromParent_Done,
     /* 1909413 */   // Label 25710: @1909413
     /* 1909413 */   GIM_Try, /*On fail goto*//*Label 25711*/ GIMT_Encode4(1909499), // Rule ID 19512 //
     /* 1909418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909464 */     // MIs[0] policy
     /* 1909464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909474 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1909477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909498 */     // GIR_Coverage, 19512,
     /* 1909498 */     GIR_EraseRootFromParent_Done,
     /* 1909499 */   // Label 25711: @1909499
     /* 1909499 */   GIM_Try, /*On fail goto*//*Label 25712*/ GIMT_Encode4(1909585), // Rule ID 19513 //
     /* 1909504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1909515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1909518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1909521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909550 */     // MIs[0] policy
     /* 1909550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909560 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1909563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909584 */     // GIR_Coverage, 19513,
     /* 1909584 */     GIR_EraseRootFromParent_Done,
     /* 1909585 */   // Label 25712: @1909585
     /* 1909585 */   GIM_Try, /*On fail goto*//*Label 25713*/ GIMT_Encode4(1909671), // Rule ID 19516 //
     /* 1909590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1909601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1909604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1909607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909636 */     // MIs[0] policy
     /* 1909636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909646 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1909649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909670 */     // GIR_Coverage, 19516,
     /* 1909670 */     GIR_EraseRootFromParent_Done,
     /* 1909671 */   // Label 25713: @1909671
     /* 1909671 */   GIM_Try, /*On fail goto*//*Label 25714*/ GIMT_Encode4(1909757), // Rule ID 19517 //
     /* 1909676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1909687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1909690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1909693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1909696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1909699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1909706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1909714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1909718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909722 */     // MIs[0] policy
     /* 1909722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909732 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1909735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909756 */     // GIR_Coverage, 19517,
     /* 1909756 */     GIR_EraseRootFromParent_Done,
     /* 1909757 */   // Label 25714: @1909757
     /* 1909757 */   GIM_Try, /*On fail goto*//*Label 25715*/ GIMT_Encode4(1909843), // Rule ID 19520 //
     /* 1909762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1909765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1909773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1909776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1909779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909808 */     // MIs[0] policy
     /* 1909808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909818 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1909821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909842 */     // GIR_Coverage, 19520,
     /* 1909842 */     GIR_EraseRootFromParent_Done,
     /* 1909843 */   // Label 25715: @1909843
     /* 1909843 */   GIM_Try, /*On fail goto*//*Label 25716*/ GIMT_Encode4(1909929), // Rule ID 19521 //
     /* 1909848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1909851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1909859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1909862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1909865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909894 */     // MIs[0] policy
     /* 1909894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11266:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1909907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909928 */     // GIR_Coverage, 19521,
     /* 1909928 */     GIR_EraseRootFromParent_Done,
     /* 1909929 */   // Label 25716: @1909929
     /* 1909929 */   GIM_Try, /*On fail goto*//*Label 25717*/ GIMT_Encode4(1910015), // Rule ID 19524 //
     /* 1909934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1909937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1909942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1909945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1909948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1909951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1909954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1909964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1909972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1909976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909980 */     // MIs[0] policy
     /* 1909980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909990 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1909993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910014 */     // GIR_Coverage, 19524,
     /* 1910014 */     GIR_EraseRootFromParent_Done,
     /* 1910015 */   // Label 25717: @1910015
     /* 1910015 */   GIM_Try, /*On fail goto*//*Label 25718*/ GIMT_Encode4(1910101), // Rule ID 19525 //
     /* 1910020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1910031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1910034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1910037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910066 */     // MIs[0] policy
     /* 1910066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910076 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11266:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1910079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910100 */     // GIR_Coverage, 19525,
     /* 1910100 */     GIR_EraseRootFromParent_Done,
     /* 1910101 */   // Label 25718: @1910101
     /* 1910101 */   GIM_Try, /*On fail goto*//*Label 25719*/ GIMT_Encode4(1910187), // Rule ID 19528 //
     /* 1910106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910152 */     // MIs[0] policy
     /* 1910152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910162 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1910165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910186 */     // GIR_Coverage, 19528,
     /* 1910186 */     GIR_EraseRootFromParent_Done,
     /* 1910187 */   // Label 25719: @1910187
     /* 1910187 */   GIM_Try, /*On fail goto*//*Label 25720*/ GIMT_Encode4(1910273), // Rule ID 19529 //
     /* 1910192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1910195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1910200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1910203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1910206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1910209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1910212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1910234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910238 */     // MIs[0] policy
     /* 1910238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910248 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11266:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1910251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910272 */     // GIR_Coverage, 19529,
     /* 1910272 */     GIR_EraseRootFromParent_Done,
     /* 1910273 */   // Label 25720: @1910273
     /* 1910273 */   GIM_Try, /*On fail goto*//*Label 25721*/ GIMT_Encode4(1910359), // Rule ID 19532 //
     /* 1910278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1910298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910324 */     // MIs[0] policy
     /* 1910324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910334 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1910337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910358 */     // GIR_Coverage, 19532,
     /* 1910358 */     GIR_EraseRootFromParent_Done,
     /* 1910359 */   // Label 25721: @1910359
     /* 1910359 */   GIM_Try, /*On fail goto*//*Label 25722*/ GIMT_Encode4(1910445), // Rule ID 19533 //
     /* 1910364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1910375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1910378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1910381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1910384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910410 */     // MIs[0] policy
     /* 1910410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910420 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1910423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910444 */     // GIR_Coverage, 19533,
     /* 1910444 */     GIR_EraseRootFromParent_Done,
     /* 1910445 */   // Label 25722: @1910445
     /* 1910445 */   GIM_Try, /*On fail goto*//*Label 25723*/ GIMT_Encode4(1910531), // Rule ID 19536 //
     /* 1910450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1910461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1910464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1910467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1910470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910496 */     // MIs[0] policy
     /* 1910496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910506 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1910509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910530 */     // GIR_Coverage, 19536,
     /* 1910530 */     GIR_EraseRootFromParent_Done,
     /* 1910531 */   // Label 25723: @1910531
     /* 1910531 */   GIM_Try, /*On fail goto*//*Label 25724*/ GIMT_Encode4(1910617), // Rule ID 19537 //
     /* 1910536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1910547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1910550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1910553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1910556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910582 */     // MIs[0] policy
     /* 1910582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910592 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1910595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910616 */     // GIR_Coverage, 19537,
     /* 1910616 */     GIR_EraseRootFromParent_Done,
     /* 1910617 */   // Label 25724: @1910617
     /* 1910617 */   GIM_Try, /*On fail goto*//*Label 25725*/ GIMT_Encode4(1910703), // Rule ID 19540 //
     /* 1910622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1910633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1910636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1910639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1910642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910668 */     // MIs[0] policy
     /* 1910668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910678 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1910681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910702 */     // GIR_Coverage, 19540,
     /* 1910702 */     GIR_EraseRootFromParent_Done,
     /* 1910703 */   // Label 25725: @1910703
     /* 1910703 */   GIM_Try, /*On fail goto*//*Label 25726*/ GIMT_Encode4(1910789), // Rule ID 19541 //
     /* 1910708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1910719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1910722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1910725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1910728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1910731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910754 */     // MIs[0] policy
     /* 1910754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910764 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1910767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910788 */     // GIR_Coverage, 19541,
     /* 1910788 */     GIR_EraseRootFromParent_Done,
     /* 1910789 */   // Label 25726: @1910789
     /* 1910789 */   GIM_Try, /*On fail goto*//*Label 25727*/ GIMT_Encode4(1910875), // Rule ID 19544 //
     /* 1910794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1910805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1910808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1910811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1910814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910840 */     // MIs[0] policy
     /* 1910840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910850 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1910853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910874 */     // GIR_Coverage, 19544,
     /* 1910874 */     GIR_EraseRootFromParent_Done,
     /* 1910875 */   // Label 25727: @1910875
     /* 1910875 */   GIM_Try, /*On fail goto*//*Label 25728*/ GIMT_Encode4(1910961), // Rule ID 19545 //
     /* 1910880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1910891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1910894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1910897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1910900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1910922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910926 */     // MIs[0] policy
     /* 1910926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910936 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1910939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910960 */     // GIR_Coverage, 19545,
     /* 1910960 */     GIR_EraseRootFromParent_Done,
     /* 1910961 */   // Label 25728: @1910961
     /* 1910961 */   GIM_Try, /*On fail goto*//*Label 25729*/ GIMT_Encode4(1911047), // Rule ID 19548 //
     /* 1910966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1910974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1910977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1910980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1910983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1910986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1910996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911012 */     // MIs[0] policy
     /* 1911012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911022 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1911025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911046 */     // GIR_Coverage, 19548,
     /* 1911046 */     GIR_EraseRootFromParent_Done,
     /* 1911047 */   // Label 25729: @1911047
     /* 1911047 */   GIM_Try, /*On fail goto*//*Label 25730*/ GIMT_Encode4(1911133), // Rule ID 19549 //
     /* 1911052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1911063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1911066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1911069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1911072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911098 */     // MIs[0] policy
     /* 1911098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911108 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1911111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911132 */     // GIR_Coverage, 19549,
     /* 1911132 */     GIR_EraseRootFromParent_Done,
     /* 1911133 */   // Label 25730: @1911133
     /* 1911133 */   GIM_Try, /*On fail goto*//*Label 25731*/ GIMT_Encode4(1911219), // Rule ID 19552 //
     /* 1911138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1911158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911184 */     // MIs[0] policy
     /* 1911184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911194 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1911197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911218 */     // GIR_Coverage, 19552,
     /* 1911218 */     GIR_EraseRootFromParent_Done,
     /* 1911219 */   // Label 25731: @1911219
     /* 1911219 */   GIM_Try, /*On fail goto*//*Label 25732*/ GIMT_Encode4(1911305), // Rule ID 19553 //
     /* 1911224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1911235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1911238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1911241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1911244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911270 */     // MIs[0] policy
     /* 1911270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911280 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1911283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911304 */     // GIR_Coverage, 19553,
     /* 1911304 */     GIR_EraseRootFromParent_Done,
     /* 1911305 */   // Label 25732: @1911305
     /* 1911305 */   GIM_Try, /*On fail goto*//*Label 25733*/ GIMT_Encode4(1911391), // Rule ID 19556 //
     /* 1911310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1911330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911356 */     // MIs[0] policy
     /* 1911356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911366 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1911369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911390 */     // GIR_Coverage, 19556,
     /* 1911390 */     GIR_EraseRootFromParent_Done,
     /* 1911391 */   // Label 25733: @1911391
     /* 1911391 */   GIM_Try, /*On fail goto*//*Label 25734*/ GIMT_Encode4(1911477), // Rule ID 19557 //
     /* 1911396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1911407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1911410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1911413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1911416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911442 */     // MIs[0] policy
     /* 1911442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911452 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1911455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911476 */     // GIR_Coverage, 19557,
     /* 1911476 */     GIR_EraseRootFromParent_Done,
     /* 1911477 */   // Label 25734: @1911477
     /* 1911477 */   GIM_Try, /*On fail goto*//*Label 25735*/ GIMT_Encode4(1911563), // Rule ID 19560 //
     /* 1911482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1911493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1911496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1911499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1911502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1911505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911528 */     // MIs[0] policy
     /* 1911528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911538 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1911541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911562 */     // GIR_Coverage, 19560,
     /* 1911562 */     GIR_EraseRootFromParent_Done,
     /* 1911563 */   // Label 25735: @1911563
     /* 1911563 */   GIM_Try, /*On fail goto*//*Label 25736*/ GIMT_Encode4(1911649), // Rule ID 19561 //
     /* 1911568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1911579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1911582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1911585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1911588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1911591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911614 */     // MIs[0] policy
     /* 1911614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911624 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1911627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911648 */     // GIR_Coverage, 19561,
     /* 1911648 */     GIR_EraseRootFromParent_Done,
     /* 1911649 */   // Label 25736: @1911649
     /* 1911649 */   GIM_Try, /*On fail goto*//*Label 25737*/ GIMT_Encode4(1911735), // Rule ID 19564 //
     /* 1911654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1911665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1911668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1911671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1911674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1911677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1911684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911700 */     // MIs[0] policy
     /* 1911700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911710 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1911713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911734 */     // GIR_Coverage, 19564,
     /* 1911734 */     GIR_EraseRootFromParent_Done,
     /* 1911735 */   // Label 25737: @1911735
     /* 1911735 */   GIM_Try, /*On fail goto*//*Label 25738*/ GIMT_Encode4(1911821), // Rule ID 19565 //
     /* 1911740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1911751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1911754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1911757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1911760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1911763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1911770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911786 */     // MIs[0] policy
     /* 1911786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911796 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1911799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911820 */     // GIR_Coverage, 19565,
     /* 1911820 */     GIR_EraseRootFromParent_Done,
     /* 1911821 */   // Label 25738: @1911821
     /* 1911821 */   GIM_Try, /*On fail goto*//*Label 25739*/ GIMT_Encode4(1911907), // Rule ID 19568 //
     /* 1911826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1911829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1911837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1911840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1911843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1911846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911872 */     // MIs[0] policy
     /* 1911872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911882 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1911885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911906 */     // GIR_Coverage, 19568,
     /* 1911906 */     GIR_EraseRootFromParent_Done,
     /* 1911907 */   // Label 25739: @1911907
     /* 1911907 */   GIM_Try, /*On fail goto*//*Label 25740*/ GIMT_Encode4(1911993), // Rule ID 19569 //
     /* 1911912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1911920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1911923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1911926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1911929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1911932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911958 */     // MIs[0] policy
     /* 1911958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911968 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1911971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911992 */     // GIR_Coverage, 19569,
     /* 1911992 */     GIR_EraseRootFromParent_Done,
     /* 1911993 */   // Label 25740: @1911993
     /* 1911993 */   GIM_Try, /*On fail goto*//*Label 25741*/ GIMT_Encode4(1912079), // Rule ID 19572 //
     /* 1911998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1912018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912044 */     // MIs[0] policy
     /* 1912044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912054 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1912057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912078 */     // GIR_Coverage, 19572,
     /* 1912078 */     GIR_EraseRootFromParent_Done,
     /* 1912079 */   // Label 25741: @1912079
     /* 1912079 */   GIM_Try, /*On fail goto*//*Label 25742*/ GIMT_Encode4(1912165), // Rule ID 19573 //
     /* 1912084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1912095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1912098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1912101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1912104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912130 */     // MIs[0] policy
     /* 1912130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912140 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1912143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912164 */     // GIR_Coverage, 19573,
     /* 1912164 */     GIR_EraseRootFromParent_Done,
     /* 1912165 */   // Label 25742: @1912165
     /* 1912165 */   GIM_Try, /*On fail goto*//*Label 25743*/ GIMT_Encode4(1912251), // Rule ID 19576 //
     /* 1912170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1912190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912216 */     // MIs[0] policy
     /* 1912216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912226 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1912229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912250 */     // GIR_Coverage, 19576,
     /* 1912250 */     GIR_EraseRootFromParent_Done,
     /* 1912251 */   // Label 25743: @1912251
     /* 1912251 */   GIM_Try, /*On fail goto*//*Label 25744*/ GIMT_Encode4(1912337), // Rule ID 19577 //
     /* 1912256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1912267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1912270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1912273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1912276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912302 */     // MIs[0] policy
     /* 1912302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1912315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912336 */     // GIR_Coverage, 19577,
     /* 1912336 */     GIR_EraseRootFromParent_Done,
     /* 1912337 */   // Label 25744: @1912337
     /* 1912337 */   GIM_Try, /*On fail goto*//*Label 25745*/ GIMT_Encode4(1912423), // Rule ID 19580 //
     /* 1912342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1912362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912388 */     // MIs[0] policy
     /* 1912388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912398 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1912401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912422 */     // GIR_Coverage, 19580,
     /* 1912422 */     GIR_EraseRootFromParent_Done,
     /* 1912423 */   // Label 25745: @1912423
     /* 1912423 */   GIM_Try, /*On fail goto*//*Label 25746*/ GIMT_Encode4(1912509), // Rule ID 19581 //
     /* 1912428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1912439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1912442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1912445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1912448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912474 */     // MIs[0] policy
     /* 1912474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912484 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1912487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912508 */     // GIR_Coverage, 19581,
     /* 1912508 */     GIR_EraseRootFromParent_Done,
     /* 1912509 */   // Label 25746: @1912509
     /* 1912509 */   GIM_Try, /*On fail goto*//*Label 25747*/ GIMT_Encode4(1912595), // Rule ID 19584 //
     /* 1912514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1912525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1912528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1912531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1912534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912560 */     // MIs[0] policy
     /* 1912560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912570 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1912573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912594 */     // GIR_Coverage, 19584,
     /* 1912594 */     GIR_EraseRootFromParent_Done,
     /* 1912595 */   // Label 25747: @1912595
     /* 1912595 */   GIM_Try, /*On fail goto*//*Label 25748*/ GIMT_Encode4(1912681), // Rule ID 19585 //
     /* 1912600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1912611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1912614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1912617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1912620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912646 */     // MIs[0] policy
     /* 1912646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912656 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1912659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912680 */     // GIR_Coverage, 19585,
     /* 1912680 */     GIR_EraseRootFromParent_Done,
     /* 1912681 */   // Label 25748: @1912681
     /* 1912681 */   GIM_Try, /*On fail goto*//*Label 25749*/ GIMT_Encode4(1912767), // Rule ID 19588 //
     /* 1912686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1912697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1912700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1912703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1912706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912732 */     // MIs[0] policy
     /* 1912732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912742 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1912745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912766 */     // GIR_Coverage, 19588,
     /* 1912766 */     GIR_EraseRootFromParent_Done,
     /* 1912767 */   // Label 25749: @1912767
     /* 1912767 */   GIM_Try, /*On fail goto*//*Label 25750*/ GIMT_Encode4(1912853), // Rule ID 19589 //
     /* 1912772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1912783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1912786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1912789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1912792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912818 */     // MIs[0] policy
     /* 1912818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912828 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1912831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912852 */     // GIR_Coverage, 19589,
     /* 1912852 */     GIR_EraseRootFromParent_Done,
     /* 1912853 */   // Label 25750: @1912853
     /* 1912853 */   GIM_Try, /*On fail goto*//*Label 25751*/ GIMT_Encode4(1912939), // Rule ID 19592 //
     /* 1912858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1912869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1912872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1912875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912904 */     // MIs[0] policy
     /* 1912904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912914 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1912917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912938 */     // GIR_Coverage, 19592,
     /* 1912938 */     GIR_EraseRootFromParent_Done,
     /* 1912939 */   // Label 25751: @1912939
     /* 1912939 */   GIM_Try, /*On fail goto*//*Label 25752*/ GIMT_Encode4(1913025), // Rule ID 19593 //
     /* 1912944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1912952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1912955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1912958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1912961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912990 */     // MIs[0] policy
     /* 1912990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913000 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1913003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913024 */     // GIR_Coverage, 19593,
     /* 1913024 */     GIR_EraseRootFromParent_Done,
     /* 1913025 */   // Label 25752: @1913025
     /* 1913025 */   GIM_Try, /*On fail goto*//*Label 25753*/ GIMT_Encode4(1913111), // Rule ID 19596 //
     /* 1913030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913076 */     // MIs[0] policy
     /* 1913076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913086 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1913089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913110 */     // GIR_Coverage, 19596,
     /* 1913110 */     GIR_EraseRootFromParent_Done,
     /* 1913111 */   // Label 25753: @1913111
     /* 1913111 */   GIM_Try, /*On fail goto*//*Label 25754*/ GIMT_Encode4(1913197), // Rule ID 19597 //
     /* 1913116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1913127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1913130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1913133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913162 */     // MIs[0] policy
     /* 1913162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913172 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1913175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913196 */     // GIR_Coverage, 19597,
     /* 1913196 */     GIR_EraseRootFromParent_Done,
     /* 1913197 */   // Label 25754: @1913197
     /* 1913197 */   GIM_Try, /*On fail goto*//*Label 25755*/ GIMT_Encode4(1913283), // Rule ID 19600 //
     /* 1913202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913248 */     // MIs[0] policy
     /* 1913248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913258 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1913261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913282 */     // GIR_Coverage, 19600,
     /* 1913282 */     GIR_EraseRootFromParent_Done,
     /* 1913283 */   // Label 25755: @1913283
     /* 1913283 */   GIM_Try, /*On fail goto*//*Label 25756*/ GIMT_Encode4(1913369), // Rule ID 19601 //
     /* 1913288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1913299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1913302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1913305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913334 */     // MIs[0] policy
     /* 1913334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913344 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1913347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913368 */     // GIR_Coverage, 19601,
     /* 1913368 */     GIR_EraseRootFromParent_Done,
     /* 1913369 */   // Label 25756: @1913369
     /* 1913369 */   GIM_Try, /*On fail goto*//*Label 25757*/ GIMT_Encode4(1913455), // Rule ID 19604 //
     /* 1913374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913420 */     // MIs[0] policy
     /* 1913420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913430 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1913433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913454 */     // GIR_Coverage, 19604,
     /* 1913454 */     GIR_EraseRootFromParent_Done,
     /* 1913455 */   // Label 25757: @1913455
     /* 1913455 */   GIM_Try, /*On fail goto*//*Label 25758*/ GIMT_Encode4(1913541), // Rule ID 19605 //
     /* 1913460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1913471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1913474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1913477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913506 */     // MIs[0] policy
     /* 1913506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913516 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11268:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1913519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913540 */     // GIR_Coverage, 19605,
     /* 1913540 */     GIR_EraseRootFromParent_Done,
     /* 1913541 */   // Label 25758: @1913541
     /* 1913541 */   GIM_Try, /*On fail goto*//*Label 25759*/ GIMT_Encode4(1913627), // Rule ID 19608 //
     /* 1913546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1913557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1913560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1913563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913592 */     // MIs[0] policy
     /* 1913592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913602 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1913605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913626 */     // GIR_Coverage, 19608,
     /* 1913626 */     GIR_EraseRootFromParent_Done,
     /* 1913627 */   // Label 25759: @1913627
     /* 1913627 */   GIM_Try, /*On fail goto*//*Label 25760*/ GIMT_Encode4(1913713), // Rule ID 19609 //
     /* 1913632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1913643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1913646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1913649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913678 */     // MIs[0] policy
     /* 1913678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913688 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11268:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1913691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913712 */     // GIR_Coverage, 19609,
     /* 1913712 */     GIR_EraseRootFromParent_Done,
     /* 1913713 */   // Label 25760: @1913713
     /* 1913713 */   GIM_Try, /*On fail goto*//*Label 25761*/ GIMT_Encode4(1913799), // Rule ID 19612 //
     /* 1913718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1913729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1913732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1913735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913764 */     // MIs[0] policy
     /* 1913764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913774 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1913777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913798 */     // GIR_Coverage, 19612,
     /* 1913798 */     GIR_EraseRootFromParent_Done,
     /* 1913799 */   // Label 25761: @1913799
     /* 1913799 */   GIM_Try, /*On fail goto*//*Label 25762*/ GIMT_Encode4(1913885), // Rule ID 19613 //
     /* 1913804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1913815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1913818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1913821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1913827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1913834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1913842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913850 */     // MIs[0] policy
     /* 1913850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913860 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11268:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1913863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913884 */     // GIR_Coverage, 19613,
     /* 1913884 */     GIR_EraseRootFromParent_Done,
     /* 1913885 */   // Label 25762: @1913885
     /* 1913885 */   GIM_Try, /*On fail goto*//*Label 25763*/ GIMT_Encode4(1913971), // Rule ID 19616 //
     /* 1913890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1913893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1913901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1913904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1913907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1913932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913936 */     // MIs[0] policy
     /* 1913936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913946 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1913949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1913967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913970 */     // GIR_Coverage, 19616,
     /* 1913970 */     GIR_EraseRootFromParent_Done,
     /* 1913971 */   // Label 25763: @1913971
     /* 1913971 */   GIM_Try, /*On fail goto*//*Label 25764*/ GIMT_Encode4(1914057), // Rule ID 19617 //
     /* 1913976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1913979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1913984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1913987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1913990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1913993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1913996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914022 */     // MIs[0] policy
     /* 1914022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914032 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1914035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914056 */     // GIR_Coverage, 19617,
     /* 1914056 */     GIR_EraseRootFromParent_Done,
     /* 1914057 */   // Label 25764: @1914057
     /* 1914057 */   GIM_Try, /*On fail goto*//*Label 25765*/ GIMT_Encode4(1914143), // Rule ID 19620 //
     /* 1914062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914108 */     // MIs[0] policy
     /* 1914108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914118 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1914121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914142 */     // GIR_Coverage, 19620,
     /* 1914142 */     GIR_EraseRootFromParent_Done,
     /* 1914143 */   // Label 25765: @1914143
     /* 1914143 */   GIM_Try, /*On fail goto*//*Label 25766*/ GIMT_Encode4(1914229), // Rule ID 19621 //
     /* 1914148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1914159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1914162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1914165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914194 */     // MIs[0] policy
     /* 1914194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914204 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1914207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914228 */     // GIR_Coverage, 19621,
     /* 1914228 */     GIR_EraseRootFromParent_Done,
     /* 1914229 */   // Label 25766: @1914229
     /* 1914229 */   GIM_Try, /*On fail goto*//*Label 25767*/ GIMT_Encode4(1914315), // Rule ID 19624 //
     /* 1914234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1914237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914280 */     // MIs[0] policy
     /* 1914280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914290 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1914293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914314 */     // GIR_Coverage, 19624,
     /* 1914314 */     GIR_EraseRootFromParent_Done,
     /* 1914315 */   // Label 25767: @1914315
     /* 1914315 */   GIM_Try, /*On fail goto*//*Label 25768*/ GIMT_Encode4(1914401), // Rule ID 19625 //
     /* 1914320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1914323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1914331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1914334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1914337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1914340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1914343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1914362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914366 */     // MIs[0] policy
     /* 1914366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914376 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1914379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914400 */     // GIR_Coverage, 19625,
     /* 1914400 */     GIR_EraseRootFromParent_Done,
     /* 1914401 */   // Label 25768: @1914401
     /* 1914401 */   GIM_Try, /*On fail goto*//*Label 25769*/ GIMT_Encode4(1914487), // Rule ID 19628 //
     /* 1914406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914452 */     // MIs[0] policy
     /* 1914452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914462 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1914465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914486 */     // GIR_Coverage, 19628,
     /* 1914486 */     GIR_EraseRootFromParent_Done,
     /* 1914487 */   // Label 25769: @1914487
     /* 1914487 */   GIM_Try, /*On fail goto*//*Label 25770*/ GIMT_Encode4(1914573), // Rule ID 19629 //
     /* 1914492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1914503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1914506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1914509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914538 */     // MIs[0] policy
     /* 1914538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914548 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1914551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914572 */     // GIR_Coverage, 19629,
     /* 1914572 */     GIR_EraseRootFromParent_Done,
     /* 1914573 */   // Label 25770: @1914573
     /* 1914573 */   GIM_Try, /*On fail goto*//*Label 25771*/ GIMT_Encode4(1914659), // Rule ID 19632 //
     /* 1914578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1914589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1914592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1914595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914624 */     // MIs[0] policy
     /* 1914624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914634 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1914637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914658 */     // GIR_Coverage, 19632,
     /* 1914658 */     GIR_EraseRootFromParent_Done,
     /* 1914659 */   // Label 25771: @1914659
     /* 1914659 */   GIM_Try, /*On fail goto*//*Label 25772*/ GIMT_Encode4(1914745), // Rule ID 19633 //
     /* 1914664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1914675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1914678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1914681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1914687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1914694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1914702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914710 */     // MIs[0] policy
     /* 1914710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914720 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1914723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914744 */     // GIR_Coverage, 19633,
     /* 1914744 */     GIR_EraseRootFromParent_Done,
     /* 1914745 */   // Label 25772: @1914745
     /* 1914745 */   GIM_Try, /*On fail goto*//*Label 25773*/ GIMT_Encode4(1914831), // Rule ID 19636 //
     /* 1914750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1914753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1914761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1914764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1914767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914796 */     // MIs[0] policy
     /* 1914796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914806 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1914809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914830 */     // GIR_Coverage, 19636,
     /* 1914830 */     GIR_EraseRootFromParent_Done,
     /* 1914831 */   // Label 25773: @1914831
     /* 1914831 */   GIM_Try, /*On fail goto*//*Label 25774*/ GIMT_Encode4(1914917), // Rule ID 19637 //
     /* 1914836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1914839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1914847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1914850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1914853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1914859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1914866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1914874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1914878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914882 */     // MIs[0] policy
     /* 1914882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914892 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1914895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914916 */     // GIR_Coverage, 19637,
     /* 1914916 */     GIR_EraseRootFromParent_Done,
     /* 1914917 */   // Label 25774: @1914917
     /* 1914917 */   GIM_Try, /*On fail goto*//*Label 25775*/ GIMT_Encode4(1915003), // Rule ID 19640 //
     /* 1914922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1914925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1914930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1914933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1914936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1914939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1914952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1914960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1914964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914968 */     // MIs[0] policy
     /* 1914968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914978 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1914981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1914985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915002 */     // GIR_Coverage, 19640,
     /* 1915002 */     GIR_EraseRootFromParent_Done,
     /* 1915003 */   // Label 25775: @1915003
     /* 1915003 */   GIM_Try, /*On fail goto*//*Label 25776*/ GIMT_Encode4(1915089), // Rule ID 19641 //
     /* 1915008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1915019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1915022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1915025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915054 */     // MIs[0] policy
     /* 1915054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915064 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11268:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1915067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915088 */     // GIR_Coverage, 19641,
     /* 1915088 */     GIR_EraseRootFromParent_Done,
     /* 1915089 */   // Label 25776: @1915089
     /* 1915089 */   GIM_Try, /*On fail goto*//*Label 25777*/ GIMT_Encode4(1915175), // Rule ID 19644 //
     /* 1915094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915140 */     // MIs[0] policy
     /* 1915140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915150 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1915153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915174 */     // GIR_Coverage, 19644,
     /* 1915174 */     GIR_EraseRootFromParent_Done,
     /* 1915175 */   // Label 25777: @1915175
     /* 1915175 */   GIM_Try, /*On fail goto*//*Label 25778*/ GIMT_Encode4(1915261), // Rule ID 19645 //
     /* 1915180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1915191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1915194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1915197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915226 */     // MIs[0] policy
     /* 1915226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915236 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11268:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1915239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915260 */     // GIR_Coverage, 19645,
     /* 1915260 */     GIR_EraseRootFromParent_Done,
     /* 1915261 */   // Label 25778: @1915261
     /* 1915261 */   GIM_Try, /*On fail goto*//*Label 25779*/ GIMT_Encode4(1915347), // Rule ID 19648 //
     /* 1915266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1915269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915312 */     // MIs[0] policy
     /* 1915312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915322 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1915325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915346 */     // GIR_Coverage, 19648,
     /* 1915346 */     GIR_EraseRootFromParent_Done,
     /* 1915347 */   // Label 25779: @1915347
     /* 1915347 */   GIM_Try, /*On fail goto*//*Label 25780*/ GIMT_Encode4(1915433), // Rule ID 19649 //
     /* 1915352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1915355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1915360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1915363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1915366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1915369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1915382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1915390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1915394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915398 */     // MIs[0] policy
     /* 1915398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915408 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11268:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1915411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915432 */     // GIR_Coverage, 19649,
     /* 1915432 */     GIR_EraseRootFromParent_Done,
     /* 1915433 */   // Label 25780: @1915433
     /* 1915433 */   GIM_Try, /*On fail goto*//*Label 25781*/ GIMT_Encode4(1915519), // Rule ID 19652 //
     /* 1915438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1915458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915484 */     // MIs[0] policy
     /* 1915484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915494 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1915497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915518 */     // GIR_Coverage, 19652,
     /* 1915518 */     GIR_EraseRootFromParent_Done,
     /* 1915519 */   // Label 25781: @1915519
     /* 1915519 */   GIM_Try, /*On fail goto*//*Label 25782*/ GIMT_Encode4(1915605), // Rule ID 19653 //
     /* 1915524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1915527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1915535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1915538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1915541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1915544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915570 */     // MIs[0] policy
     /* 1915570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915580 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1915583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915604 */     // GIR_Coverage, 19653,
     /* 1915604 */     GIR_EraseRootFromParent_Done,
     /* 1915605 */   // Label 25782: @1915605
     /* 1915605 */   GIM_Try, /*On fail goto*//*Label 25783*/ GIMT_Encode4(1915691), // Rule ID 19656 //
     /* 1915610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1915621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1915624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1915627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1915630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915656 */     // MIs[0] policy
     /* 1915656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915666 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1915669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915690 */     // GIR_Coverage, 19656,
     /* 1915690 */     GIR_EraseRootFromParent_Done,
     /* 1915691 */   // Label 25783: @1915691
     /* 1915691 */   GIM_Try, /*On fail goto*//*Label 25784*/ GIMT_Encode4(1915777), // Rule ID 19657 //
     /* 1915696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1915699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1915707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1915710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1915713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1915716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915742 */     // MIs[0] policy
     /* 1915742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915752 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1915755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915776 */     // GIR_Coverage, 19657,
     /* 1915776 */     GIR_EraseRootFromParent_Done,
     /* 1915777 */   // Label 25784: @1915777
     /* 1915777 */   GIM_Try, /*On fail goto*//*Label 25785*/ GIMT_Encode4(1915863), // Rule ID 19660 //
     /* 1915782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1915785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1915793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1915796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1915799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1915802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915828 */     // MIs[0] policy
     /* 1915828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915838 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1915841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915862 */     // GIR_Coverage, 19660,
     /* 1915862 */     GIR_EraseRootFromParent_Done,
     /* 1915863 */   // Label 25785: @1915863
     /* 1915863 */   GIM_Try, /*On fail goto*//*Label 25786*/ GIMT_Encode4(1915949), // Rule ID 19661 //
     /* 1915868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1915871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1915879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1915882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1915885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1915888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915914 */     // MIs[0] policy
     /* 1915914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915924 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1915927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1915931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915948 */     // GIR_Coverage, 19661,
     /* 1915948 */     GIR_EraseRootFromParent_Done,
     /* 1915949 */   // Label 25786: @1915949
     /* 1915949 */   GIM_Try, /*On fail goto*//*Label 25787*/ GIMT_Encode4(1916035), // Rule ID 19664 //
     /* 1915954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1915957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1915962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1915965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1915968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1915971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1915974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916000 */     // MIs[0] policy
     /* 1916000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916010 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1916013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916034 */     // GIR_Coverage, 19664,
     /* 1916034 */     GIR_EraseRootFromParent_Done,
     /* 1916035 */   // Label 25787: @1916035
     /* 1916035 */   GIM_Try, /*On fail goto*//*Label 25788*/ GIMT_Encode4(1916121), // Rule ID 19665 //
     /* 1916040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1916051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1916054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1916057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1916060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916086 */     // MIs[0] policy
     /* 1916086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916096 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1916099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916120 */     // GIR_Coverage, 19665,
     /* 1916120 */     GIR_EraseRootFromParent_Done,
     /* 1916121 */   // Label 25788: @1916121
     /* 1916121 */   GIM_Try, /*On fail goto*//*Label 25789*/ GIMT_Encode4(1916207), // Rule ID 19668 //
     /* 1916126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1916146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916172 */     // MIs[0] policy
     /* 1916172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916182 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1916185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916206 */     // GIR_Coverage, 19668,
     /* 1916206 */     GIR_EraseRootFromParent_Done,
     /* 1916207 */   // Label 25789: @1916207
     /* 1916207 */   GIM_Try, /*On fail goto*//*Label 25790*/ GIMT_Encode4(1916293), // Rule ID 19669 //
     /* 1916212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1916215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1916223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1916226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1916229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1916232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1916235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916258 */     // MIs[0] policy
     /* 1916258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916268 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1916271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916292 */     // GIR_Coverage, 19669,
     /* 1916292 */     GIR_EraseRootFromParent_Done,
     /* 1916293 */   // Label 25790: @1916293
     /* 1916293 */   GIM_Try, /*On fail goto*//*Label 25791*/ GIMT_Encode4(1916379), // Rule ID 19672 //
     /* 1916298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1916301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1916318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916344 */     // MIs[0] policy
     /* 1916344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916354 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1916357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916378 */     // GIR_Coverage, 19672,
     /* 1916378 */     GIR_EraseRootFromParent_Done,
     /* 1916379 */   // Label 25791: @1916379
     /* 1916379 */   GIM_Try, /*On fail goto*//*Label 25792*/ GIMT_Encode4(1916465), // Rule ID 19673 //
     /* 1916384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1916387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1916395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1916398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1916401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1916404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1916407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1916414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1916426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916430 */     // MIs[0] policy
     /* 1916430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916440 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1916443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1916461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916464 */     // GIR_Coverage, 19673,
     /* 1916464 */     GIR_EraseRootFromParent_Done,
     /* 1916465 */   // Label 25792: @1916465
     /* 1916465 */   GIM_Try, /*On fail goto*//*Label 25793*/ GIMT_Encode4(1916551), // Rule ID 19676 //
     /* 1916470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1916490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916516 */     // MIs[0] policy
     /* 1916516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916526 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1916529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916550 */     // GIR_Coverage, 19676,
     /* 1916550 */     GIR_EraseRootFromParent_Done,
     /* 1916551 */   // Label 25793: @1916551
     /* 1916551 */   GIM_Try, /*On fail goto*//*Label 25794*/ GIMT_Encode4(1916637), // Rule ID 19677 //
     /* 1916556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1916576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916602 */     // MIs[0] policy
     /* 1916602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916612 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1916615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916636 */     // GIR_Coverage, 19677,
     /* 1916636 */     GIR_EraseRootFromParent_Done,
     /* 1916637 */   // Label 25794: @1916637
     /* 1916637 */   GIM_Try, /*On fail goto*//*Label 25795*/ GIMT_Encode4(1916723), // Rule ID 19680 //
     /* 1916642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1916653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1916656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1916659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1916662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1916665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916688 */     // MIs[0] policy
     /* 1916688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916698 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1916701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916722 */     // GIR_Coverage, 19680,
     /* 1916722 */     GIR_EraseRootFromParent_Done,
     /* 1916723 */   // Label 25795: @1916723
     /* 1916723 */   GIM_Try, /*On fail goto*//*Label 25796*/ GIMT_Encode4(1916809), // Rule ID 19681 //
     /* 1916728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1916739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1916742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1916745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1916748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1916751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916774 */     // MIs[0] policy
     /* 1916774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916784 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1916787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916808 */     // GIR_Coverage, 19681,
     /* 1916808 */     GIR_EraseRootFromParent_Done,
     /* 1916809 */   // Label 25796: @1916809
     /* 1916809 */   GIM_Try, /*On fail goto*//*Label 25797*/ GIMT_Encode4(1916895), // Rule ID 19684 //
     /* 1916814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1916817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1916825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1916828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1916831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1916834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1916837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916860 */     // MIs[0] policy
     /* 1916860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916870 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1916873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916894 */     // GIR_Coverage, 19684,
     /* 1916894 */     GIR_EraseRootFromParent_Done,
     /* 1916895 */   // Label 25797: @1916895
     /* 1916895 */   GIM_Try, /*On fail goto*//*Label 25798*/ GIMT_Encode4(1916981), // Rule ID 19685 //
     /* 1916900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1916903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1916911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1916914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1916917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1916920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1916923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916946 */     // MIs[0] policy
     /* 1916946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916956 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1916959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1916963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916980 */     // GIR_Coverage, 19685,
     /* 1916980 */     GIR_EraseRootFromParent_Done,
     /* 1916981 */   // Label 25798: @1916981
     /* 1916981 */   GIM_Try, /*On fail goto*//*Label 25799*/ GIMT_Encode4(1917067), // Rule ID 19688 //
     /* 1916986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1916989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1916994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1916997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1917006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917032 */     // MIs[0] policy
     /* 1917032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917042 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1917045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917066 */     // GIR_Coverage, 19688,
     /* 1917066 */     GIR_EraseRootFromParent_Done,
     /* 1917067 */   // Label 25799: @1917067
     /* 1917067 */   GIM_Try, /*On fail goto*//*Label 25800*/ GIMT_Encode4(1917153), // Rule ID 19689 //
     /* 1917072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1917083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1917086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1917089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1917092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917118 */     // MIs[0] policy
     /* 1917118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917128 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1917131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917152 */     // GIR_Coverage, 19689,
     /* 1917152 */     GIR_EraseRootFromParent_Done,
     /* 1917153 */   // Label 25800: @1917153
     /* 1917153 */   GIM_Try, /*On fail goto*//*Label 25801*/ GIMT_Encode4(1917239), // Rule ID 19692 //
     /* 1917158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1917178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917204 */     // MIs[0] policy
     /* 1917204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917214 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1917217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917238 */     // GIR_Coverage, 19692,
     /* 1917238 */     GIR_EraseRootFromParent_Done,
     /* 1917239 */   // Label 25801: @1917239
     /* 1917239 */   GIM_Try, /*On fail goto*//*Label 25802*/ GIMT_Encode4(1917325), // Rule ID 19693 //
     /* 1917244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1917264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917290 */     // MIs[0] policy
     /* 1917290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917300 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1917303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917324 */     // GIR_Coverage, 19693,
     /* 1917324 */     GIR_EraseRootFromParent_Done,
     /* 1917325 */   // Label 25802: @1917325
     /* 1917325 */   GIM_Try, /*On fail goto*//*Label 25803*/ GIMT_Encode4(1917411), // Rule ID 19696 //
     /* 1917330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1917333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1917350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917376 */     // MIs[0] policy
     /* 1917376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917386 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1917389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917410 */     // GIR_Coverage, 19696,
     /* 1917410 */     GIR_EraseRootFromParent_Done,
     /* 1917411 */   // Label 25803: @1917411
     /* 1917411 */   GIM_Try, /*On fail goto*//*Label 25804*/ GIMT_Encode4(1917497), // Rule ID 19697 //
     /* 1917416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1917419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1917436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917462 */     // MIs[0] policy
     /* 1917462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917472 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1917475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917496 */     // GIR_Coverage, 19697,
     /* 1917496 */     GIR_EraseRootFromParent_Done,
     /* 1917497 */   // Label 25804: @1917497
     /* 1917497 */   GIM_Try, /*On fail goto*//*Label 25805*/ GIMT_Encode4(1917583), // Rule ID 19700 //
     /* 1917502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1917522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917548 */     // MIs[0] policy
     /* 1917548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917558 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1917561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917582 */     // GIR_Coverage, 19700,
     /* 1917582 */     GIR_EraseRootFromParent_Done,
     /* 1917583 */   // Label 25805: @1917583
     /* 1917583 */   GIM_Try, /*On fail goto*//*Label 25806*/ GIMT_Encode4(1917669), // Rule ID 19701 //
     /* 1917588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1917591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1917608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917634 */     // MIs[0] policy
     /* 1917634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917644 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1917647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917668 */     // GIR_Coverage, 19701,
     /* 1917668 */     GIR_EraseRootFromParent_Done,
     /* 1917669 */   // Label 25806: @1917669
     /* 1917669 */   GIM_Try, /*On fail goto*//*Label 25807*/ GIMT_Encode4(1917755), // Rule ID 19704 //
     /* 1917674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1917685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1917688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1917691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1917694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917720 */     // MIs[0] policy
     /* 1917720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917730 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1917733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917754 */     // GIR_Coverage, 19704,
     /* 1917754 */     GIR_EraseRootFromParent_Done,
     /* 1917755 */   // Label 25807: @1917755
     /* 1917755 */   GIM_Try, /*On fail goto*//*Label 25808*/ GIMT_Encode4(1917841), // Rule ID 19705 //
     /* 1917760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1917763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1917771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1917774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1917777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1917780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917806 */     // MIs[0] policy
     /* 1917806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917816 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1917819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917840 */     // GIR_Coverage, 19705,
     /* 1917840 */     GIR_EraseRootFromParent_Done,
     /* 1917841 */   // Label 25808: @1917841
     /* 1917841 */   GIM_Try, /*On fail goto*//*Label 25809*/ GIMT_Encode4(1917927), // Rule ID 19708 //
     /* 1917846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1917849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1917857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1917860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1917863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1917866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917892 */     // MIs[0] policy
     /* 1917892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917902 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1917905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917926 */     // GIR_Coverage, 19708,
     /* 1917926 */     GIR_EraseRootFromParent_Done,
     /* 1917927 */   // Label 25809: @1917927
     /* 1917927 */   GIM_Try, /*On fail goto*//*Label 25810*/ GIMT_Encode4(1918013), // Rule ID 19709 //
     /* 1917932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1917935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1917940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1917943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1917946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1917949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1917952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917978 */     // MIs[0] policy
     /* 1917978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917988 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1917991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1917995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918012 */     // GIR_Coverage, 19709,
     /* 1918012 */     GIR_EraseRootFromParent_Done,
     /* 1918013 */   // Label 25810: @1918013
     /* 1918013 */   GIM_Try, /*On fail goto*//*Label 25811*/ GIMT_Encode4(1918099), // Rule ID 19712 //
     /* 1918018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918064 */     // MIs[0] policy
     /* 1918064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918074 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1918077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918098 */     // GIR_Coverage, 19712,
     /* 1918098 */     GIR_EraseRootFromParent_Done,
     /* 1918099 */   // Label 25811: @1918099
     /* 1918099 */   GIM_Try, /*On fail goto*//*Label 25812*/ GIMT_Encode4(1918185), // Rule ID 19713 //
     /* 1918104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918150 */     // MIs[0] policy
     /* 1918150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918160 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1918163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918184 */     // GIR_Coverage, 19713,
     /* 1918184 */     GIR_EraseRootFromParent_Done,
     /* 1918185 */   // Label 25812: @1918185
     /* 1918185 */   GIM_Try, /*On fail goto*//*Label 25813*/ GIMT_Encode4(1918271), // Rule ID 19716 //
     /* 1918190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918236 */     // MIs[0] policy
     /* 1918236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918246 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1918249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918270 */     // GIR_Coverage, 19716,
     /* 1918270 */     GIR_EraseRootFromParent_Done,
     /* 1918271 */   // Label 25813: @1918271
     /* 1918271 */   GIM_Try, /*On fail goto*//*Label 25814*/ GIMT_Encode4(1918357), // Rule ID 19717 //
     /* 1918276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918322 */     // MIs[0] policy
     /* 1918322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918332 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1918335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918356 */     // GIR_Coverage, 19717,
     /* 1918356 */     GIR_EraseRootFromParent_Done,
     /* 1918357 */   // Label 25814: @1918357
     /* 1918357 */   GIM_Try, /*On fail goto*//*Label 25815*/ GIMT_Encode4(1918443), // Rule ID 19720 //
     /* 1918362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1918365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918408 */     // MIs[0] policy
     /* 1918408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918418 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1918421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918442 */     // GIR_Coverage, 19720,
     /* 1918442 */     GIR_EraseRootFromParent_Done,
     /* 1918443 */   // Label 25815: @1918443
     /* 1918443 */   GIM_Try, /*On fail goto*//*Label 25816*/ GIMT_Encode4(1918529), // Rule ID 19721 //
     /* 1918448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1918451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918494 */     // MIs[0] policy
     /* 1918494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918504 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1918507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918528 */     // GIR_Coverage, 19721,
     /* 1918528 */     GIR_EraseRootFromParent_Done,
     /* 1918529 */   // Label 25816: @1918529
     /* 1918529 */   GIM_Try, /*On fail goto*//*Label 25817*/ GIMT_Encode4(1918615), // Rule ID 19724 //
     /* 1918534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1918537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1918545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1918548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1918551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918580 */     // MIs[0] policy
     /* 1918580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918590 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1918593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918614 */     // GIR_Coverage, 19724,
     /* 1918614 */     GIR_EraseRootFromParent_Done,
     /* 1918615 */   // Label 25817: @1918615
     /* 1918615 */   GIM_Try, /*On fail goto*//*Label 25818*/ GIMT_Encode4(1918701), // Rule ID 19725 //
     /* 1918620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1918623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1918631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1918634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1918637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1918640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1918662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918666 */     // MIs[0] policy
     /* 1918666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918676 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11270:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1918679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918700 */     // GIR_Coverage, 19725,
     /* 1918700 */     GIR_EraseRootFromParent_Done,
     /* 1918701 */   // Label 25818: @1918701
     /* 1918701 */   GIM_Try, /*On fail goto*//*Label 25819*/ GIMT_Encode4(1918787), // Rule ID 19728 //
     /* 1918706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1918709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1918717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1918720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1918723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918752 */     // MIs[0] policy
     /* 1918752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918762 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1918765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918786 */     // GIR_Coverage, 19728,
     /* 1918786 */     GIR_EraseRootFromParent_Done,
     /* 1918787 */   // Label 25819: @1918787
     /* 1918787 */   GIM_Try, /*On fail goto*//*Label 25820*/ GIMT_Encode4(1918873), // Rule ID 19729 //
     /* 1918792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1918795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1918803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1918806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1918809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1918834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918838 */     // MIs[0] policy
     /* 1918838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918848 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11270:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1918851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918872 */     // GIR_Coverage, 19729,
     /* 1918872 */     GIR_EraseRootFromParent_Done,
     /* 1918873 */   // Label 25820: @1918873
     /* 1918873 */   GIM_Try, /*On fail goto*//*Label 25821*/ GIMT_Encode4(1918959), // Rule ID 19732 //
     /* 1918878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1918881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1918889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1918892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1918895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1918920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918924 */     // MIs[0] policy
     /* 1918924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918934 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1918937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1918941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1918955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918958 */     // GIR_Coverage, 19732,
     /* 1918958 */     GIR_EraseRootFromParent_Done,
     /* 1918959 */   // Label 25821: @1918959
     /* 1918959 */   GIM_Try, /*On fail goto*//*Label 25822*/ GIMT_Encode4(1919045), // Rule ID 19733 //
     /* 1918964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1918967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1918972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1918975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1918978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1918981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1919006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919010 */     // MIs[0] policy
     /* 1919010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919020 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11270:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1919023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919044 */     // GIR_Coverage, 19733,
     /* 1919044 */     GIR_EraseRootFromParent_Done,
     /* 1919045 */   // Label 25822: @1919045
     /* 1919045 */   GIM_Try, /*On fail goto*//*Label 25823*/ GIMT_Encode4(1919131), // Rule ID 19736 //
     /* 1919050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1919061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1919064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1919067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919096 */     // MIs[0] policy
     /* 1919096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919106 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1919109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919130 */     // GIR_Coverage, 19736,
     /* 1919130 */     GIR_EraseRootFromParent_Done,
     /* 1919131 */   // Label 25823: @1919131
     /* 1919131 */   GIM_Try, /*On fail goto*//*Label 25824*/ GIMT_Encode4(1919217), // Rule ID 19737 //
     /* 1919136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1919147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1919150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1919153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919182 */     // MIs[0] policy
     /* 1919182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919192 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1919195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919216 */     // GIR_Coverage, 19737,
     /* 1919216 */     GIR_EraseRootFromParent_Done,
     /* 1919217 */   // Label 25824: @1919217
     /* 1919217 */   GIM_Try, /*On fail goto*//*Label 25825*/ GIMT_Encode4(1919303), // Rule ID 19740 //
     /* 1919222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1919233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1919236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1919239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919268 */     // MIs[0] policy
     /* 1919268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919278 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1919281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919302 */     // GIR_Coverage, 19740,
     /* 1919302 */     GIR_EraseRootFromParent_Done,
     /* 1919303 */   // Label 25825: @1919303
     /* 1919303 */   GIM_Try, /*On fail goto*//*Label 25826*/ GIMT_Encode4(1919389), // Rule ID 19741 //
     /* 1919308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1919319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1919322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1919325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919354 */     // MIs[0] policy
     /* 1919354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919364 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1919367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919388 */     // GIR_Coverage, 19741,
     /* 1919388 */     GIR_EraseRootFromParent_Done,
     /* 1919389 */   // Label 25826: @1919389
     /* 1919389 */   GIM_Try, /*On fail goto*//*Label 25827*/ GIMT_Encode4(1919475), // Rule ID 19744 //
     /* 1919394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1919397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1919405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1919408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1919411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919440 */     // MIs[0] policy
     /* 1919440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919450 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1919453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919474 */     // GIR_Coverage, 19744,
     /* 1919474 */     GIR_EraseRootFromParent_Done,
     /* 1919475 */   // Label 25827: @1919475
     /* 1919475 */   GIM_Try, /*On fail goto*//*Label 25828*/ GIMT_Encode4(1919561), // Rule ID 19745 //
     /* 1919480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1919483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1919491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1919494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1919497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1919500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1919522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919526 */     // MIs[0] policy
     /* 1919526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919536 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1919539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919560 */     // GIR_Coverage, 19745,
     /* 1919560 */     GIR_EraseRootFromParent_Done,
     /* 1919561 */   // Label 25828: @1919561
     /* 1919561 */   GIM_Try, /*On fail goto*//*Label 25829*/ GIMT_Encode4(1919647), // Rule ID 19748 //
     /* 1919566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1919577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1919580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1919583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919612 */     // MIs[0] policy
     /* 1919612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919622 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1919625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919646 */     // GIR_Coverage, 19748,
     /* 1919646 */     GIR_EraseRootFromParent_Done,
     /* 1919647 */   // Label 25829: @1919647
     /* 1919647 */   GIM_Try, /*On fail goto*//*Label 25830*/ GIMT_Encode4(1919733), // Rule ID 19749 //
     /* 1919652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1919655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1919663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1919666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1919669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919698 */     // MIs[0] policy
     /* 1919698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919708 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1919711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919732 */     // GIR_Coverage, 19749,
     /* 1919732 */     GIR_EraseRootFromParent_Done,
     /* 1919733 */   // Label 25830: @1919733
     /* 1919733 */   GIM_Try, /*On fail goto*//*Label 25831*/ GIMT_Encode4(1919819), // Rule ID 19752 //
     /* 1919738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1919749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1919752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1919755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919784 */     // MIs[0] policy
     /* 1919784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919794 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1919797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919818 */     // GIR_Coverage, 19752,
     /* 1919818 */     GIR_EraseRootFromParent_Done,
     /* 1919819 */   // Label 25831: @1919819
     /* 1919819 */   GIM_Try, /*On fail goto*//*Label 25832*/ GIMT_Encode4(1919905), // Rule ID 19753 //
     /* 1919824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1919827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1919835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1919838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1919841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1919847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919870 */     // MIs[0] policy
     /* 1919870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919880 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1919883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919904 */     // GIR_Coverage, 19753,
     /* 1919904 */     GIR_EraseRootFromParent_Done,
     /* 1919905 */   // Label 25832: @1919905
     /* 1919905 */   GIM_Try, /*On fail goto*//*Label 25833*/ GIMT_Encode4(1919991), // Rule ID 19756 //
     /* 1919910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1919913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1919918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1919921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1919924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1919927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1919952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919956 */     // MIs[0] policy
     /* 1919956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919966 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1919969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1919973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919990 */     // GIR_Coverage, 19756,
     /* 1919990 */     GIR_EraseRootFromParent_Done,
     /* 1919991 */   // Label 25833: @1919991
     /* 1919991 */   GIM_Try, /*On fail goto*//*Label 25834*/ GIMT_Encode4(1920077), // Rule ID 19757 //
     /* 1919996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1919999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1920007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1920010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1920013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1920038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920042 */     // MIs[0] policy
     /* 1920042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920052 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1920055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920076 */     // GIR_Coverage, 19757,
     /* 1920076 */     GIR_EraseRootFromParent_Done,
     /* 1920077 */   // Label 25834: @1920077
     /* 1920077 */   GIM_Try, /*On fail goto*//*Label 25835*/ GIMT_Encode4(1920163), // Rule ID 19760 //
     /* 1920082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1920093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1920096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1920099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920128 */     // MIs[0] policy
     /* 1920128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920138 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1920141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920162 */     // GIR_Coverage, 19760,
     /* 1920162 */     GIR_EraseRootFromParent_Done,
     /* 1920163 */   // Label 25835: @1920163
     /* 1920163 */   GIM_Try, /*On fail goto*//*Label 25836*/ GIMT_Encode4(1920249), // Rule ID 19761 //
     /* 1920168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1920179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1920182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1920185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920214 */     // MIs[0] policy
     /* 1920214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920224 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11270:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1920227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920248 */     // GIR_Coverage, 19761,
     /* 1920248 */     GIR_EraseRootFromParent_Done,
     /* 1920249 */   // Label 25836: @1920249
     /* 1920249 */   GIM_Try, /*On fail goto*//*Label 25837*/ GIMT_Encode4(1920335), // Rule ID 19764 //
     /* 1920254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1920265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1920268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1920271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920300 */     // MIs[0] policy
     /* 1920300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920310 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1920313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920334 */     // GIR_Coverage, 19764,
     /* 1920334 */     GIR_EraseRootFromParent_Done,
     /* 1920335 */   // Label 25837: @1920335
     /* 1920335 */   GIM_Try, /*On fail goto*//*Label 25838*/ GIMT_Encode4(1920421), // Rule ID 19765 //
     /* 1920340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1920351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1920354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1920357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920386 */     // MIs[0] policy
     /* 1920386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920396 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11270:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1920399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920420 */     // GIR_Coverage, 19765,
     /* 1920420 */     GIR_EraseRootFromParent_Done,
     /* 1920421 */   // Label 25838: @1920421
     /* 1920421 */   GIM_Try, /*On fail goto*//*Label 25839*/ GIMT_Encode4(1920507), // Rule ID 19768 //
     /* 1920426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1920429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1920437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1920440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1920443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920472 */     // MIs[0] policy
     /* 1920472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920482 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1920485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920506 */     // GIR_Coverage, 19768,
     /* 1920506 */     GIR_EraseRootFromParent_Done,
     /* 1920507 */   // Label 25839: @1920507
     /* 1920507 */   GIM_Try, /*On fail goto*//*Label 25840*/ GIMT_Encode4(1920593), // Rule ID 19769 //
     /* 1920512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1920515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1920520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1920523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1920526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1920529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1920554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920558 */     // MIs[0] policy
     /* 1920558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920568 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11270:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1920571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1920575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1920589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920592 */     // GIR_Coverage, 19769,
     /* 1920592 */     GIR_EraseRootFromParent_Done,
     /* 1920593 */   // Label 25840: @1920593
     /* 1920593 */   GIM_Try, /*On fail goto*//*Label 25841*/ GIMT_Encode4(1920679), // Rule ID 23610 //
     /* 1920598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1920609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1920612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1920615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1920621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920644 */     // MIs[0] policy
     /* 1920644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920654 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1920657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920678 */     // GIR_Coverage, 23610,
     /* 1920678 */     GIR_EraseRootFromParent_Done,
     /* 1920679 */   // Label 25841: @1920679
     /* 1920679 */   GIM_Try, /*On fail goto*//*Label 25842*/ GIMT_Encode4(1920765), // Rule ID 23611 //
     /* 1920684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1920695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1920698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1920701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1920707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920730 */     // MIs[0] policy
     /* 1920730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920740 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1920743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920764 */     // GIR_Coverage, 23611,
     /* 1920764 */     GIR_EraseRootFromParent_Done,
     /* 1920765 */   // Label 25842: @1920765
     /* 1920765 */   GIM_Try, /*On fail goto*//*Label 25843*/ GIMT_Encode4(1920851), // Rule ID 23614 //
     /* 1920770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1920781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1920784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1920787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920816 */     // MIs[0] policy
     /* 1920816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920826 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1920829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920850 */     // GIR_Coverage, 23614,
     /* 1920850 */     GIR_EraseRootFromParent_Done,
     /* 1920851 */   // Label 25843: @1920851
     /* 1920851 */   GIM_Try, /*On fail goto*//*Label 25844*/ GIMT_Encode4(1920937), // Rule ID 23615 //
     /* 1920856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1920867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1920870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1920873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1920879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920902 */     // MIs[0] policy
     /* 1920902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920912 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1920915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920936 */     // GIR_Coverage, 23615,
     /* 1920936 */     GIR_EraseRootFromParent_Done,
     /* 1920937 */   // Label 25844: @1920937
     /* 1920937 */   GIM_Try, /*On fail goto*//*Label 25845*/ GIMT_Encode4(1921023), // Rule ID 23618 //
     /* 1920942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1920950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1920953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1920956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1920959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1920972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1920980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920988 */     // MIs[0] policy
     /* 1920988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920998 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921022 */     // GIR_Coverage, 23618,
     /* 1921022 */     GIR_EraseRootFromParent_Done,
     /* 1921023 */   // Label 25845: @1921023
     /* 1921023 */   GIM_Try, /*On fail goto*//*Label 25846*/ GIMT_Encode4(1921109), // Rule ID 23619 //
     /* 1921028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1921039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1921042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1921045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921074 */     // MIs[0] policy
     /* 1921074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921084 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921108 */     // GIR_Coverage, 23619,
     /* 1921108 */     GIR_EraseRootFromParent_Done,
     /* 1921109 */   // Label 25846: @1921109
     /* 1921109 */   GIM_Try, /*On fail goto*//*Label 25847*/ GIMT_Encode4(1921195), // Rule ID 23622 //
     /* 1921114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921160 */     // MIs[0] policy
     /* 1921160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921170 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921194 */     // GIR_Coverage, 23622,
     /* 1921194 */     GIR_EraseRootFromParent_Done,
     /* 1921195 */   // Label 25847: @1921195
     /* 1921195 */   GIM_Try, /*On fail goto*//*Label 25848*/ GIMT_Encode4(1921281), // Rule ID 23623 //
     /* 1921200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1921211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1921214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1921217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921246 */     // MIs[0] policy
     /* 1921246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921256 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1921259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921280 */     // GIR_Coverage, 23623,
     /* 1921280 */     GIR_EraseRootFromParent_Done,
     /* 1921281 */   // Label 25848: @1921281
     /* 1921281 */   GIM_Try, /*On fail goto*//*Label 25849*/ GIMT_Encode4(1921367), // Rule ID 23626 //
     /* 1921286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1921297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1921300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1921303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921332 */     // MIs[0] policy
     /* 1921332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921342 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921366 */     // GIR_Coverage, 23626,
     /* 1921366 */     GIR_EraseRootFromParent_Done,
     /* 1921367 */   // Label 25849: @1921367
     /* 1921367 */   GIM_Try, /*On fail goto*//*Label 25850*/ GIMT_Encode4(1921453), // Rule ID 23627 //
     /* 1921372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1921383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1921386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1921389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921418 */     // MIs[0] policy
     /* 1921418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921428 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921452 */     // GIR_Coverage, 23627,
     /* 1921452 */     GIR_EraseRootFromParent_Done,
     /* 1921453 */   // Label 25850: @1921453
     /* 1921453 */   GIM_Try, /*On fail goto*//*Label 25851*/ GIMT_Encode4(1921539), // Rule ID 23630 //
     /* 1921458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1921469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1921472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1921475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921504 */     // MIs[0] policy
     /* 1921504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921538 */     // GIR_Coverage, 23630,
     /* 1921538 */     GIR_EraseRootFromParent_Done,
     /* 1921539 */   // Label 25851: @1921539
     /* 1921539 */   GIM_Try, /*On fail goto*//*Label 25852*/ GIMT_Encode4(1921625), // Rule ID 23631 //
     /* 1921544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1921555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1921558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1921561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921590 */     // MIs[0] policy
     /* 1921590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921600 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1921603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921624 */     // GIR_Coverage, 23631,
     /* 1921624 */     GIR_EraseRootFromParent_Done,
     /* 1921625 */   // Label 25852: @1921625
     /* 1921625 */   GIM_Try, /*On fail goto*//*Label 25853*/ GIMT_Encode4(1921711), // Rule ID 23634 //
     /* 1921630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1921641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1921644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1921647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921676 */     // MIs[0] policy
     /* 1921676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921686 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1921689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921710 */     // GIR_Coverage, 23634,
     /* 1921710 */     GIR_EraseRootFromParent_Done,
     /* 1921711 */   // Label 25853: @1921711
     /* 1921711 */   GIM_Try, /*On fail goto*//*Label 25854*/ GIMT_Encode4(1921797), // Rule ID 23635 //
     /* 1921716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1921727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1921730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1921733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921762 */     // MIs[0] policy
     /* 1921762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921772 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1921775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921796 */     // GIR_Coverage, 23635,
     /* 1921796 */     GIR_EraseRootFromParent_Done,
     /* 1921797 */   // Label 25854: @1921797
     /* 1921797 */   GIM_Try, /*On fail goto*//*Label 25855*/ GIMT_Encode4(1921883), // Rule ID 23638 //
     /* 1921802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1921813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1921816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1921819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921848 */     // MIs[0] policy
     /* 1921848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1921861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921882 */     // GIR_Coverage, 23638,
     /* 1921882 */     GIR_EraseRootFromParent_Done,
     /* 1921883 */   // Label 25855: @1921883
     /* 1921883 */   GIM_Try, /*On fail goto*//*Label 25856*/ GIMT_Encode4(1921969), // Rule ID 23639 //
     /* 1921888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1921899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1921902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1921905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921934 */     // MIs[0] policy
     /* 1921934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921944 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1921947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1921965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921968 */     // GIR_Coverage, 23639,
     /* 1921968 */     GIR_EraseRootFromParent_Done,
     /* 1921969 */   // Label 25856: @1921969
     /* 1921969 */   GIM_Try, /*On fail goto*//*Label 25857*/ GIMT_Encode4(1922055), // Rule ID 23642 //
     /* 1921974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1921982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1921985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1921988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1921991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922020 */     // MIs[0] policy
     /* 1922020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922054 */     // GIR_Coverage, 23642,
     /* 1922054 */     GIR_EraseRootFromParent_Done,
     /* 1922055 */   // Label 25857: @1922055
     /* 1922055 */   GIM_Try, /*On fail goto*//*Label 25858*/ GIMT_Encode4(1922141), // Rule ID 23643 //
     /* 1922060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922106 */     // MIs[0] policy
     /* 1922106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922116 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922140 */     // GIR_Coverage, 23643,
     /* 1922140 */     GIR_EraseRootFromParent_Done,
     /* 1922141 */   // Label 25858: @1922141
     /* 1922141 */   GIM_Try, /*On fail goto*//*Label 25859*/ GIMT_Encode4(1922227), // Rule ID 23646 //
     /* 1922146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1922149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922192 */     // MIs[0] policy
     /* 1922192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922202 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922226 */     // GIR_Coverage, 23646,
     /* 1922226 */     GIR_EraseRootFromParent_Done,
     /* 1922227 */   // Label 25859: @1922227
     /* 1922227 */   GIM_Try, /*On fail goto*//*Label 25860*/ GIMT_Encode4(1922313), // Rule ID 23647 //
     /* 1922232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1922235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1922243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1922246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1922249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922278 */     // MIs[0] policy
     /* 1922278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922288 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1922291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1922309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922312 */     // GIR_Coverage, 23647,
     /* 1922312 */     GIR_EraseRootFromParent_Done,
     /* 1922313 */   // Label 25860: @1922313
     /* 1922313 */   GIM_Try, /*On fail goto*//*Label 25861*/ GIMT_Encode4(1922399), // Rule ID 23650 //
     /* 1922318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1922329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1922332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1922335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1922341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922364 */     // MIs[0] policy
     /* 1922364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922374 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922398 */     // GIR_Coverage, 23650,
     /* 1922398 */     GIR_EraseRootFromParent_Done,
     /* 1922399 */   // Label 25861: @1922399
     /* 1922399 */   GIM_Try, /*On fail goto*//*Label 25862*/ GIMT_Encode4(1922485), // Rule ID 23651 //
     /* 1922404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1922415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1922418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1922421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1922427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922450 */     // MIs[0] policy
     /* 1922450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922460 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922484 */     // GIR_Coverage, 23651,
     /* 1922484 */     GIR_EraseRootFromParent_Done,
     /* 1922485 */   // Label 25862: @1922485
     /* 1922485 */   GIM_Try, /*On fail goto*//*Label 25863*/ GIMT_Encode4(1922571), // Rule ID 23654 //
     /* 1922490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1922501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1922504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1922507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1922513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1922520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922536 */     // MIs[0] policy
     /* 1922536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922546 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1922549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922570 */     // GIR_Coverage, 23654,
     /* 1922570 */     GIR_EraseRootFromParent_Done,
     /* 1922571 */   // Label 25863: @1922571
     /* 1922571 */   GIM_Try, /*On fail goto*//*Label 25864*/ GIMT_Encode4(1922657), // Rule ID 23655 //
     /* 1922576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1922587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1922590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1922593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1922599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1922606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1922614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922622 */     // MIs[0] policy
     /* 1922622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922632 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1922635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922656 */     // GIR_Coverage, 23655,
     /* 1922656 */     GIR_EraseRootFromParent_Done,
     /* 1922657 */   // Label 25864: @1922657
     /* 1922657 */   GIM_Try, /*On fail goto*//*Label 25865*/ GIMT_Encode4(1922743), // Rule ID 23658 //
     /* 1922662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1922673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1922676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1922679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1922685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1922692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922708 */     // MIs[0] policy
     /* 1922708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922718 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1922721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922742 */     // GIR_Coverage, 23658,
     /* 1922742 */     GIR_EraseRootFromParent_Done,
     /* 1922743 */   // Label 25865: @1922743
     /* 1922743 */   GIM_Try, /*On fail goto*//*Label 25866*/ GIMT_Encode4(1922829), // Rule ID 23659 //
     /* 1922748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1922759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1922762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1922765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1922771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1922778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1922786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922794 */     // MIs[0] policy
     /* 1922794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922804 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1922807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922828 */     // GIR_Coverage, 23659,
     /* 1922828 */     GIR_EraseRootFromParent_Done,
     /* 1922829 */   // Label 25866: @1922829
     /* 1922829 */   GIM_Try, /*On fail goto*//*Label 25867*/ GIMT_Encode4(1922915), // Rule ID 23662 //
     /* 1922834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1922845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1922848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1922851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922880 */     // MIs[0] policy
     /* 1922880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922890 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922914 */     // GIR_Coverage, 23662,
     /* 1922914 */     GIR_EraseRootFromParent_Done,
     /* 1922915 */   // Label 25867: @1922915
     /* 1922915 */   GIM_Try, /*On fail goto*//*Label 25868*/ GIMT_Encode4(1923001), // Rule ID 23663 //
     /* 1922920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1922928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1922931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1922934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1922937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1922950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1922958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922966 */     // MIs[0] policy
     /* 1922966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1922979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1922983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923000 */     // GIR_Coverage, 23663,
     /* 1923000 */     GIR_EraseRootFromParent_Done,
     /* 1923001 */   // Label 25868: @1923001
     /* 1923001 */   GIM_Try, /*On fail goto*//*Label 25869*/ GIMT_Encode4(1923087), // Rule ID 23666 //
     /* 1923006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923052 */     // MIs[0] policy
     /* 1923052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923062 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923086 */     // GIR_Coverage, 23666,
     /* 1923086 */     GIR_EraseRootFromParent_Done,
     /* 1923087 */   // Label 25869: @1923087
     /* 1923087 */   GIM_Try, /*On fail goto*//*Label 25870*/ GIMT_Encode4(1923173), // Rule ID 23667 //
     /* 1923092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1923106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1923109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923138 */     // MIs[0] policy
     /* 1923138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923148 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923172 */     // GIR_Coverage, 23667,
     /* 1923172 */     GIR_EraseRootFromParent_Done,
     /* 1923173 */   // Label 25870: @1923173
     /* 1923173 */   GIM_Try, /*On fail goto*//*Label 25871*/ GIMT_Encode4(1923259), // Rule ID 23670 //
     /* 1923178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923224 */     // MIs[0] policy
     /* 1923224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923234 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923258 */     // GIR_Coverage, 23670,
     /* 1923258 */     GIR_EraseRootFromParent_Done,
     /* 1923259 */   // Label 25871: @1923259
     /* 1923259 */   GIM_Try, /*On fail goto*//*Label 25872*/ GIMT_Encode4(1923345), // Rule ID 23671 //
     /* 1923264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1923275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1923278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1923281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923310 */     // MIs[0] policy
     /* 1923310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923320 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923344 */     // GIR_Coverage, 23671,
     /* 1923344 */     GIR_EraseRootFromParent_Done,
     /* 1923345 */   // Label 25872: @1923345
     /* 1923345 */   GIM_Try, /*On fail goto*//*Label 25873*/ GIMT_Encode4(1923431), // Rule ID 23674 //
     /* 1923350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923396 */     // MIs[0] policy
     /* 1923396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923430 */     // GIR_Coverage, 23674,
     /* 1923430 */     GIR_EraseRootFromParent_Done,
     /* 1923431 */   // Label 25873: @1923431
     /* 1923431 */   GIM_Try, /*On fail goto*//*Label 25874*/ GIMT_Encode4(1923517), // Rule ID 23675 //
     /* 1923436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1923447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1923450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1923453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1923459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923482 */     // MIs[0] policy
     /* 1923482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923516 */     // GIR_Coverage, 23675,
     /* 1923516 */     GIR_EraseRootFromParent_Done,
     /* 1923517 */   // Label 25874: @1923517
     /* 1923517 */   GIM_Try, /*On fail goto*//*Label 25875*/ GIMT_Encode4(1923603), // Rule ID 23678 //
     /* 1923522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1923533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1923536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1923539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923568 */     // MIs[0] policy
     /* 1923568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923578 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923602 */     // GIR_Coverage, 23678,
     /* 1923602 */     GIR_EraseRootFromParent_Done,
     /* 1923603 */   // Label 25875: @1923603
     /* 1923603 */   GIM_Try, /*On fail goto*//*Label 25876*/ GIMT_Encode4(1923689), // Rule ID 23679 //
     /* 1923608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1923619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1923622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1923625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923654 */     // MIs[0] policy
     /* 1923654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923664 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1923667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923688 */     // GIR_Coverage, 23679,
     /* 1923688 */     GIR_EraseRootFromParent_Done,
     /* 1923689 */   // Label 25876: @1923689
     /* 1923689 */   GIM_Try, /*On fail goto*//*Label 25877*/ GIMT_Encode4(1923775), // Rule ID 23682 //
     /* 1923694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1923705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1923708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1923711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923740 */     // MIs[0] policy
     /* 1923740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923774 */     // GIR_Coverage, 23682,
     /* 1923774 */     GIR_EraseRootFromParent_Done,
     /* 1923775 */   // Label 25877: @1923775
     /* 1923775 */   GIM_Try, /*On fail goto*//*Label 25878*/ GIMT_Encode4(1923861), // Rule ID 23683 //
     /* 1923780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1923791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1923794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1923797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923826 */     // MIs[0] policy
     /* 1923826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923836 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1923839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923860 */     // GIR_Coverage, 23683,
     /* 1923860 */     GIR_EraseRootFromParent_Done,
     /* 1923861 */   // Label 25878: @1923861
     /* 1923861 */   GIM_Try, /*On fail goto*//*Label 25879*/ GIMT_Encode4(1923947), // Rule ID 23686 //
     /* 1923866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1923869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1923877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1923880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1923883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1923889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923912 */     // MIs[0] policy
     /* 1923912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923922 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1923925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1923929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1923943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923946 */     // GIR_Coverage, 23686,
     /* 1923946 */     GIR_EraseRootFromParent_Done,
     /* 1923947 */   // Label 25879: @1923947
     /* 1923947 */   GIM_Try, /*On fail goto*//*Label 25880*/ GIMT_Encode4(1924033), // Rule ID 23687 //
     /* 1923952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1923955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1923960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1923963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1923966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1923969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1923975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923998 */     // MIs[0] policy
     /* 1923998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924008 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1924011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924032 */     // GIR_Coverage, 23687,
     /* 1924032 */     GIR_EraseRootFromParent_Done,
     /* 1924033 */   // Label 25880: @1924033
     /* 1924033 */   GIM_Try, /*On fail goto*//*Label 25881*/ GIMT_Encode4(1924119), // Rule ID 23690 //
     /* 1924038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924084 */     // MIs[0] policy
     /* 1924084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924094 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924118 */     // GIR_Coverage, 23690,
     /* 1924118 */     GIR_EraseRootFromParent_Done,
     /* 1924119 */   // Label 25881: @1924119
     /* 1924119 */   GIM_Try, /*On fail goto*//*Label 25882*/ GIMT_Encode4(1924205), // Rule ID 23691 //
     /* 1924124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1924135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1924138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1924141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924170 */     // MIs[0] policy
     /* 1924170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924180 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1924183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924204 */     // GIR_Coverage, 23691,
     /* 1924204 */     GIR_EraseRootFromParent_Done,
     /* 1924205 */   // Label 25882: @1924205
     /* 1924205 */   GIM_Try, /*On fail goto*//*Label 25883*/ GIMT_Encode4(1924291), // Rule ID 23694 //
     /* 1924210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924256 */     // MIs[0] policy
     /* 1924256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924266 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924290 */     // GIR_Coverage, 23694,
     /* 1924290 */     GIR_EraseRootFromParent_Done,
     /* 1924291 */   // Label 25883: @1924291
     /* 1924291 */   GIM_Try, /*On fail goto*//*Label 25884*/ GIMT_Encode4(1924377), // Rule ID 23695 //
     /* 1924296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1924304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1924307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1924310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1924313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924342 */     // MIs[0] policy
     /* 1924342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924352 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1924355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924376 */     // GIR_Coverage, 23695,
     /* 1924376 */     GIR_EraseRootFromParent_Done,
     /* 1924377 */   // Label 25884: @1924377
     /* 1924377 */   GIM_Try, /*On fail goto*//*Label 25885*/ GIMT_Encode4(1924463), // Rule ID 23786 //
     /* 1924382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924428 */     // MIs[0] policy
     /* 1924428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924438 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1924441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924462 */     // GIR_Coverage, 23786,
     /* 1924462 */     GIR_EraseRootFromParent_Done,
     /* 1924463 */   // Label 25885: @1924463
     /* 1924463 */   GIM_Try, /*On fail goto*//*Label 25886*/ GIMT_Encode4(1924549), // Rule ID 23787 //
     /* 1924468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1924479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1924482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1924485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924514 */     // MIs[0] policy
     /* 1924514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924524 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1924527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924548 */     // GIR_Coverage, 23787,
     /* 1924548 */     GIR_EraseRootFromParent_Done,
     /* 1924549 */   // Label 25886: @1924549
     /* 1924549 */   GIM_Try, /*On fail goto*//*Label 25887*/ GIMT_Encode4(1924635), // Rule ID 23790 //
     /* 1924554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1924565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1924568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1924571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924600 */     // MIs[0] policy
     /* 1924600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924610 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1924613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924634 */     // GIR_Coverage, 23790,
     /* 1924634 */     GIR_EraseRootFromParent_Done,
     /* 1924635 */   // Label 25887: @1924635
     /* 1924635 */   GIM_Try, /*On fail goto*//*Label 25888*/ GIMT_Encode4(1924721), // Rule ID 23791 //
     /* 1924640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1924651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1924654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1924657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924686 */     // MIs[0] policy
     /* 1924686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924696 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1924699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924720 */     // GIR_Coverage, 23791,
     /* 1924720 */     GIR_EraseRootFromParent_Done,
     /* 1924721 */   // Label 25888: @1924721
     /* 1924721 */   GIM_Try, /*On fail goto*//*Label 25889*/ GIMT_Encode4(1924807), // Rule ID 23794 //
     /* 1924726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1924737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1924740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1924743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924772 */     // MIs[0] policy
     /* 1924772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924782 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1924785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924806 */     // GIR_Coverage, 23794,
     /* 1924806 */     GIR_EraseRootFromParent_Done,
     /* 1924807 */   // Label 25889: @1924807
     /* 1924807 */   GIM_Try, /*On fail goto*//*Label 25890*/ GIMT_Encode4(1924893), // Rule ID 23795 //
     /* 1924812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1924823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1924826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1924829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924858 */     // MIs[0] policy
     /* 1924858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924868 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1924871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1924889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924892 */     // GIR_Coverage, 23795,
     /* 1924892 */     GIR_EraseRootFromParent_Done,
     /* 1924893 */   // Label 25890: @1924893
     /* 1924893 */   GIM_Try, /*On fail goto*//*Label 25891*/ GIMT_Encode4(1924979), // Rule ID 23798 //
     /* 1924898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1924909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1924912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1924915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1924921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1924928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1924936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924944 */     // MIs[0] policy
     /* 1924944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924954 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1924957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1924961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924978 */     // GIR_Coverage, 23798,
     /* 1924978 */     GIR_EraseRootFromParent_Done,
     /* 1924979 */   // Label 25891: @1924979
     /* 1924979 */   GIM_Try, /*On fail goto*//*Label 25892*/ GIMT_Encode4(1925065), // Rule ID 23799 //
     /* 1924984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1924992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1924995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1924998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1925001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925030 */     // MIs[0] policy
     /* 1925030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1925043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925064 */     // GIR_Coverage, 23799,
     /* 1925064 */     GIR_EraseRootFromParent_Done,
     /* 1925065 */   // Label 25892: @1925065
     /* 1925065 */   GIM_Try, /*On fail goto*//*Label 25893*/ GIMT_Encode4(1925151), // Rule ID 23802 //
     /* 1925070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925116 */     // MIs[0] policy
     /* 1925116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925126 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925150 */     // GIR_Coverage, 23802,
     /* 1925150 */     GIR_EraseRootFromParent_Done,
     /* 1925151 */   // Label 25893: @1925151
     /* 1925151 */   GIM_Try, /*On fail goto*//*Label 25894*/ GIMT_Encode4(1925237), // Rule ID 23803 //
     /* 1925156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1925167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1925170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1925173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925202 */     // MIs[0] policy
     /* 1925202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925236 */     // GIR_Coverage, 23803,
     /* 1925236 */     GIR_EraseRootFromParent_Done,
     /* 1925237 */   // Label 25894: @1925237
     /* 1925237 */   GIM_Try, /*On fail goto*//*Label 25895*/ GIMT_Encode4(1925323), // Rule ID 23806 //
     /* 1925242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925288 */     // MIs[0] policy
     /* 1925288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925298 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925322 */     // GIR_Coverage, 23806,
     /* 1925322 */     GIR_EraseRootFromParent_Done,
     /* 1925323 */   // Label 25895: @1925323
     /* 1925323 */   GIM_Try, /*On fail goto*//*Label 25896*/ GIMT_Encode4(1925409), // Rule ID 23807 //
     /* 1925328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1925339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1925342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1925345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925374 */     // MIs[0] policy
     /* 1925374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925384 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1925387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925408 */     // GIR_Coverage, 23807,
     /* 1925408 */     GIR_EraseRootFromParent_Done,
     /* 1925409 */   // Label 25896: @1925409
     /* 1925409 */   GIM_Try, /*On fail goto*//*Label 25897*/ GIMT_Encode4(1925495), // Rule ID 23810 //
     /* 1925414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925460 */     // MIs[0] policy
     /* 1925460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925494 */     // GIR_Coverage, 23810,
     /* 1925494 */     GIR_EraseRootFromParent_Done,
     /* 1925495 */   // Label 25897: @1925495
     /* 1925495 */   GIM_Try, /*On fail goto*//*Label 25898*/ GIMT_Encode4(1925581), // Rule ID 23811 //
     /* 1925500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1925511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1925514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1925517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925546 */     // MIs[0] policy
     /* 1925546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925556 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925580 */     // GIR_Coverage, 23811,
     /* 1925580 */     GIR_EraseRootFromParent_Done,
     /* 1925581 */   // Label 25898: @1925581
     /* 1925581 */   GIM_Try, /*On fail goto*//*Label 25899*/ GIMT_Encode4(1925667), // Rule ID 23814 //
     /* 1925586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1925597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1925600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1925603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925632 */     // MIs[0] policy
     /* 1925632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925666 */     // GIR_Coverage, 23814,
     /* 1925666 */     GIR_EraseRootFromParent_Done,
     /* 1925667 */   // Label 25899: @1925667
     /* 1925667 */   GIM_Try, /*On fail goto*//*Label 25900*/ GIMT_Encode4(1925753), // Rule ID 23815 //
     /* 1925672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1925683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1925686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1925689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925718 */     // MIs[0] policy
     /* 1925718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925728 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925752 */     // GIR_Coverage, 23815,
     /* 1925752 */     GIR_EraseRootFromParent_Done,
     /* 1925753 */   // Label 25900: @1925753
     /* 1925753 */   GIM_Try, /*On fail goto*//*Label 25901*/ GIMT_Encode4(1925839), // Rule ID 23818 //
     /* 1925758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1925775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925804 */     // MIs[0] policy
     /* 1925804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925838 */     // GIR_Coverage, 23818,
     /* 1925838 */     GIR_EraseRootFromParent_Done,
     /* 1925839 */   // Label 25901: @1925839
     /* 1925839 */   GIM_Try, /*On fail goto*//*Label 25902*/ GIMT_Encode4(1925925), // Rule ID 23819 //
     /* 1925844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1925855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1925858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1925861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925890 */     // MIs[0] policy
     /* 1925890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1925921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925924 */     // GIR_Coverage, 23819,
     /* 1925924 */     GIR_EraseRootFromParent_Done,
     /* 1925925 */   // Label 25902: @1925925
     /* 1925925 */   GIM_Try, /*On fail goto*//*Label 25903*/ GIMT_Encode4(1926011), // Rule ID 23822 //
     /* 1925930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1925933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1925938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1925941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1925944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1925947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925976 */     // MIs[0] policy
     /* 1925976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925986 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1925989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1925993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926010 */     // GIR_Coverage, 23822,
     /* 1926010 */     GIR_EraseRootFromParent_Done,
     /* 1926011 */   // Label 25903: @1926011
     /* 1926011 */   GIM_Try, /*On fail goto*//*Label 25904*/ GIMT_Encode4(1926097), // Rule ID 23823 //
     /* 1926016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1926019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1926033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926062 */     // MIs[0] policy
     /* 1926062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926072 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1926075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926096 */     // GIR_Coverage, 23823,
     /* 1926096 */     GIR_EraseRootFromParent_Done,
     /* 1926097 */   // Label 25904: @1926097
     /* 1926097 */   GIM_Try, /*On fail goto*//*Label 25905*/ GIMT_Encode4(1926183), // Rule ID 23826 //
     /* 1926102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926148 */     // MIs[0] policy
     /* 1926148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926158 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926182 */     // GIR_Coverage, 23826,
     /* 1926182 */     GIR_EraseRootFromParent_Done,
     /* 1926183 */   // Label 25905: @1926183
     /* 1926183 */   GIM_Try, /*On fail goto*//*Label 25906*/ GIMT_Encode4(1926269), // Rule ID 23827 //
     /* 1926188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1926199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1926202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1926205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926234 */     // MIs[0] policy
     /* 1926234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926268 */     // GIR_Coverage, 23827,
     /* 1926268 */     GIR_EraseRootFromParent_Done,
     /* 1926269 */   // Label 25906: @1926269
     /* 1926269 */   GIM_Try, /*On fail goto*//*Label 25907*/ GIMT_Encode4(1926355), // Rule ID 23830 //
     /* 1926274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926320 */     // MIs[0] policy
     /* 1926320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926330 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926354 */     // GIR_Coverage, 23830,
     /* 1926354 */     GIR_EraseRootFromParent_Done,
     /* 1926355 */   // Label 25907: @1926355
     /* 1926355 */   GIM_Try, /*On fail goto*//*Label 25908*/ GIMT_Encode4(1926441), // Rule ID 23831 //
     /* 1926360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1926371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1926374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1926377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926406 */     // MIs[0] policy
     /* 1926406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926416 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926440 */     // GIR_Coverage, 23831,
     /* 1926440 */     GIR_EraseRootFromParent_Done,
     /* 1926441 */   // Label 25908: @1926441
     /* 1926441 */   GIM_Try, /*On fail goto*//*Label 25909*/ GIMT_Encode4(1926527), // Rule ID 23834 //
     /* 1926446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1926457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1926460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1926463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1926469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926492 */     // MIs[0] policy
     /* 1926492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926502 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1926505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926526 */     // GIR_Coverage, 23834,
     /* 1926526 */     GIR_EraseRootFromParent_Done,
     /* 1926527 */   // Label 25909: @1926527
     /* 1926527 */   GIM_Try, /*On fail goto*//*Label 25910*/ GIMT_Encode4(1926613), // Rule ID 23835 //
     /* 1926532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1926543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1926546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1926549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1926555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926578 */     // MIs[0] policy
     /* 1926578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926588 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1926591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926612 */     // GIR_Coverage, 23835,
     /* 1926612 */     GIR_EraseRootFromParent_Done,
     /* 1926613 */   // Label 25910: @1926613
     /* 1926613 */   GIM_Try, /*On fail goto*//*Label 25911*/ GIMT_Encode4(1926699), // Rule ID 23838 //
     /* 1926618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1926629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1926632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1926635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926664 */     // MIs[0] policy
     /* 1926664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926674 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926698 */     // GIR_Coverage, 23838,
     /* 1926698 */     GIR_EraseRootFromParent_Done,
     /* 1926699 */   // Label 25911: @1926699
     /* 1926699 */   GIM_Try, /*On fail goto*//*Label 25912*/ GIMT_Encode4(1926785), // Rule ID 23839 //
     /* 1926704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1926715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1926718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1926721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1926734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1926742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926750 */     // MIs[0] policy
     /* 1926750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1926763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926784 */     // GIR_Coverage, 23839,
     /* 1926784 */     GIR_EraseRootFromParent_Done,
     /* 1926785 */   // Label 25912: @1926785
     /* 1926785 */   GIM_Try, /*On fail goto*//*Label 25913*/ GIMT_Encode4(1926871), // Rule ID 23842 //
     /* 1926790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1926801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1926804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1926807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926836 */     // MIs[0] policy
     /* 1926836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926870 */     // GIR_Coverage, 23842,
     /* 1926870 */     GIR_EraseRootFromParent_Done,
     /* 1926871 */   // Label 25913: @1926871
     /* 1926871 */   GIM_Try, /*On fail goto*//*Label 25914*/ GIMT_Encode4(1926957), // Rule ID 23843 //
     /* 1926876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1926887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1926890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1926893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1926899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1926906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1926914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926922 */     // MIs[0] policy
     /* 1926922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926932 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1926935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1926939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926956 */     // GIR_Coverage, 23843,
     /* 1926956 */     GIR_EraseRootFromParent_Done,
     /* 1926957 */   // Label 25914: @1926957
     /* 1926957 */   GIM_Try, /*On fail goto*//*Label 25915*/ GIMT_Encode4(1927043), // Rule ID 23846 //
     /* 1926962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1926970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1926973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1926976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1926979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1926985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1926992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1926996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927008 */     // MIs[0] policy
     /* 1927008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927018 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927042 */     // GIR_Coverage, 23846,
     /* 1927042 */     GIR_EraseRootFromParent_Done,
     /* 1927043 */   // Label 25915: @1927043
     /* 1927043 */   GIM_Try, /*On fail goto*//*Label 25916*/ GIMT_Encode4(1927129), // Rule ID 23847 //
     /* 1927048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1927059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1927062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1927065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927094 */     // MIs[0] policy
     /* 1927094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927104 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927128 */     // GIR_Coverage, 23847,
     /* 1927128 */     GIR_EraseRootFromParent_Done,
     /* 1927129 */   // Label 25916: @1927129
     /* 1927129 */   GIM_Try, /*On fail goto*//*Label 25917*/ GIMT_Encode4(1927215), // Rule ID 23850 //
     /* 1927134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927180 */     // MIs[0] policy
     /* 1927180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927214 */     // GIR_Coverage, 23850,
     /* 1927214 */     GIR_EraseRootFromParent_Done,
     /* 1927215 */   // Label 25917: @1927215
     /* 1927215 */   GIM_Try, /*On fail goto*//*Label 25918*/ GIMT_Encode4(1927301), // Rule ID 23851 //
     /* 1927220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1927231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1927234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1927237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927266 */     // MIs[0] policy
     /* 1927266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927300 */     // GIR_Coverage, 23851,
     /* 1927300 */     GIR_EraseRootFromParent_Done,
     /* 1927301 */   // Label 25918: @1927301
     /* 1927301 */   GIM_Try, /*On fail goto*//*Label 25919*/ GIMT_Encode4(1927387), // Rule ID 23854 //
     /* 1927306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927352 */     // MIs[0] policy
     /* 1927352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927362 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927386 */     // GIR_Coverage, 23854,
     /* 1927386 */     GIR_EraseRootFromParent_Done,
     /* 1927387 */   // Label 25919: @1927387
     /* 1927387 */   GIM_Try, /*On fail goto*//*Label 25920*/ GIMT_Encode4(1927473), // Rule ID 23855 //
     /* 1927392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1927403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1927406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1927409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927438 */     // MIs[0] policy
     /* 1927438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927472 */     // GIR_Coverage, 23855,
     /* 1927472 */     GIR_EraseRootFromParent_Done,
     /* 1927473 */   // Label 25920: @1927473
     /* 1927473 */   GIM_Try, /*On fail goto*//*Label 25921*/ GIMT_Encode4(1927559), // Rule ID 23858 //
     /* 1927478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1927489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1927492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1927495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927524 */     // MIs[0] policy
     /* 1927524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927558 */     // GIR_Coverage, 23858,
     /* 1927558 */     GIR_EraseRootFromParent_Done,
     /* 1927559 */   // Label 25921: @1927559
     /* 1927559 */   GIM_Try, /*On fail goto*//*Label 25922*/ GIMT_Encode4(1927645), // Rule ID 23859 //
     /* 1927564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1927575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1927578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1927581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927610 */     // MIs[0] policy
     /* 1927610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1927623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1927641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927644 */     // GIR_Coverage, 23859,
     /* 1927644 */     GIR_EraseRootFromParent_Done,
     /* 1927645 */   // Label 25922: @1927645
     /* 1927645 */   GIM_Try, /*On fail goto*//*Label 25923*/ GIMT_Encode4(1927731), // Rule ID 23862 //
     /* 1927650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1927653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1927661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1927664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1927667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927696 */     // MIs[0] policy
     /* 1927696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927730 */     // GIR_Coverage, 23862,
     /* 1927730 */     GIR_EraseRootFromParent_Done,
     /* 1927731 */   // Label 25923: @1927731
     /* 1927731 */   GIM_Try, /*On fail goto*//*Label 25924*/ GIMT_Encode4(1927817), // Rule ID 23863 //
     /* 1927736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1927739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1927747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1927750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1927753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1927759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927782 */     // MIs[0] policy
     /* 1927782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1927795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927816 */     // GIR_Coverage, 23863,
     /* 1927816 */     GIR_EraseRootFromParent_Done,
     /* 1927817 */   // Label 25924: @1927817
     /* 1927817 */   GIM_Try, /*On fail goto*//*Label 25925*/ GIMT_Encode4(1927903), // Rule ID 23866 //
     /* 1927822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1927825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1927833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1927836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1927839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927868 */     // MIs[0] policy
     /* 1927868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927878 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927902 */     // GIR_Coverage, 23866,
     /* 1927902 */     GIR_EraseRootFromParent_Done,
     /* 1927903 */   // Label 25925: @1927903
     /* 1927903 */   GIM_Try, /*On fail goto*//*Label 25926*/ GIMT_Encode4(1927989), // Rule ID 23867 //
     /* 1927908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1927911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1927916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1927919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1927922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1927925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1927931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927954 */     // MIs[0] policy
     /* 1927954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1927967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1927971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927988 */     // GIR_Coverage, 23867,
     /* 1927988 */     GIR_EraseRootFromParent_Done,
     /* 1927989 */   // Label 25926: @1927989
     /* 1927989 */   GIM_Try, /*On fail goto*//*Label 25927*/ GIMT_Encode4(1928075), // Rule ID 23870 //
     /* 1927994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1927997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928040 */     // MIs[0] policy
     /* 1928040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928050 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928074 */     // GIR_Coverage, 23870,
     /* 1928074 */     GIR_EraseRootFromParent_Done,
     /* 1928075 */   // Label 25927: @1928075
     /* 1928075 */   GIM_Try, /*On fail goto*//*Label 25928*/ GIMT_Encode4(1928161), // Rule ID 23871 //
     /* 1928080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1928088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928126 */     // MIs[0] policy
     /* 1928126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928136 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1928139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1928143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928160 */     // GIR_Coverage, 23871,
     /* 1928160 */     GIR_EraseRootFromParent_Done,
     /* 1928161 */   // Label 25928: @1928161
     /* 1928161 */   GIM_Try, /*On fail goto*//*Label 25929*/ GIMT_Encode4(1928247), // Rule ID 23962 //
     /* 1928166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928212 */     // MIs[0] policy
     /* 1928212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928222 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1928225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928246 */     // GIR_Coverage, 23962,
     /* 1928246 */     GIR_EraseRootFromParent_Done,
     /* 1928247 */   // Label 25929: @1928247
     /* 1928247 */   GIM_Try, /*On fail goto*//*Label 25930*/ GIMT_Encode4(1928333), // Rule ID 23963 //
     /* 1928252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1928263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1928266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1928269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928298 */     // MIs[0] policy
     /* 1928298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928308 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1928311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928332 */     // GIR_Coverage, 23963,
     /* 1928332 */     GIR_EraseRootFromParent_Done,
     /* 1928333 */   // Label 25930: @1928333
     /* 1928333 */   GIM_Try, /*On fail goto*//*Label 25931*/ GIMT_Encode4(1928419), // Rule ID 23966 //
     /* 1928338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928384 */     // MIs[0] policy
     /* 1928384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928394 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928418 */     // GIR_Coverage, 23966,
     /* 1928418 */     GIR_EraseRootFromParent_Done,
     /* 1928419 */   // Label 25931: @1928419
     /* 1928419 */   GIM_Try, /*On fail goto*//*Label 25932*/ GIMT_Encode4(1928505), // Rule ID 23967 //
     /* 1928424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1928435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1928438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1928441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928470 */     // MIs[0] policy
     /* 1928470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928480 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928504 */     // GIR_Coverage, 23967,
     /* 1928504 */     GIR_EraseRootFromParent_Done,
     /* 1928505 */   // Label 25932: @1928505
     /* 1928505 */   GIM_Try, /*On fail goto*//*Label 25933*/ GIMT_Encode4(1928591), // Rule ID 23970 //
     /* 1928510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1928521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1928524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1928527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928556 */     // MIs[0] policy
     /* 1928556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928566 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1928569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928590 */     // GIR_Coverage, 23970,
     /* 1928590 */     GIR_EraseRootFromParent_Done,
     /* 1928591 */   // Label 25933: @1928591
     /* 1928591 */   GIM_Try, /*On fail goto*//*Label 25934*/ GIMT_Encode4(1928677), // Rule ID 23971 //
     /* 1928596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1928607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1928610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1928613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928642 */     // MIs[0] policy
     /* 1928642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928652 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1928655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1928673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928676 */     // GIR_Coverage, 23971,
     /* 1928676 */     GIR_EraseRootFromParent_Done,
     /* 1928677 */   // Label 25934: @1928677
     /* 1928677 */   GIM_Try, /*On fail goto*//*Label 25935*/ GIMT_Encode4(1928763), // Rule ID 23974 //
     /* 1928682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1928693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1928696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1928699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928728 */     // MIs[0] policy
     /* 1928728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928738 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928762 */     // GIR_Coverage, 23974,
     /* 1928762 */     GIR_EraseRootFromParent_Done,
     /* 1928763 */   // Label 25935: @1928763
     /* 1928763 */   GIM_Try, /*On fail goto*//*Label 25936*/ GIMT_Encode4(1928849), // Rule ID 23975 //
     /* 1928768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1928779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1928782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1928785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1928791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928814 */     // MIs[0] policy
     /* 1928814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928824 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1928827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928848 */     // GIR_Coverage, 23975,
     /* 1928848 */     GIR_EraseRootFromParent_Done,
     /* 1928849 */   // Label 25936: @1928849
     /* 1928849 */   GIM_Try, /*On fail goto*//*Label 25937*/ GIMT_Encode4(1928935), // Rule ID 23978 //
     /* 1928854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1928865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1928868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1928871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928900 */     // MIs[0] policy
     /* 1928900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928910 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1928913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928934 */     // GIR_Coverage, 23978,
     /* 1928934 */     GIR_EraseRootFromParent_Done,
     /* 1928935 */   // Label 25937: @1928935
     /* 1928935 */   GIM_Try, /*On fail goto*//*Label 25938*/ GIMT_Encode4(1929021), // Rule ID 23979 //
     /* 1928940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1928948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1928951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1928954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1928957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1928970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1928978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928986 */     // MIs[0] policy
     /* 1928986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1928999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929020 */     // GIR_Coverage, 23979,
     /* 1929020 */     GIR_EraseRootFromParent_Done,
     /* 1929021 */   // Label 25938: @1929021
     /* 1929021 */   GIM_Try, /*On fail goto*//*Label 25939*/ GIMT_Encode4(1929107), // Rule ID 23982 //
     /* 1929026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929072 */     // MIs[0] policy
     /* 1929072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929082 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929106 */     // GIR_Coverage, 23982,
     /* 1929106 */     GIR_EraseRootFromParent_Done,
     /* 1929107 */   // Label 25939: @1929107
     /* 1929107 */   GIM_Try, /*On fail goto*//*Label 25940*/ GIMT_Encode4(1929193), // Rule ID 23983 //
     /* 1929112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929158 */     // MIs[0] policy
     /* 1929158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1929171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929192 */     // GIR_Coverage, 23983,
     /* 1929192 */     GIR_EraseRootFromParent_Done,
     /* 1929193 */   // Label 25940: @1929193
     /* 1929193 */   GIM_Try, /*On fail goto*//*Label 25941*/ GIMT_Encode4(1929279), // Rule ID 23986 //
     /* 1929198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929244 */     // MIs[0] policy
     /* 1929244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929254 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929278 */     // GIR_Coverage, 23986,
     /* 1929278 */     GIR_EraseRootFromParent_Done,
     /* 1929279 */   // Label 25941: @1929279
     /* 1929279 */   GIM_Try, /*On fail goto*//*Label 25942*/ GIMT_Encode4(1929365), // Rule ID 23987 //
     /* 1929284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1929295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1929298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1929301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929330 */     // MIs[0] policy
     /* 1929330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929364 */     // GIR_Coverage, 23987,
     /* 1929364 */     GIR_EraseRootFromParent_Done,
     /* 1929365 */   // Label 25942: @1929365
     /* 1929365 */   GIM_Try, /*On fail goto*//*Label 25943*/ GIMT_Encode4(1929451), // Rule ID 23990 //
     /* 1929370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929416 */     // MIs[0] policy
     /* 1929416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929426 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929450 */     // GIR_Coverage, 23990,
     /* 1929450 */     GIR_EraseRootFromParent_Done,
     /* 1929451 */   // Label 25943: @1929451
     /* 1929451 */   GIM_Try, /*On fail goto*//*Label 25944*/ GIMT_Encode4(1929537), // Rule ID 23991 //
     /* 1929456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929502 */     // MIs[0] policy
     /* 1929502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929512 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929536 */     // GIR_Coverage, 23991,
     /* 1929536 */     GIR_EraseRootFromParent_Done,
     /* 1929537 */   // Label 25944: @1929537
     /* 1929537 */   GIM_Try, /*On fail goto*//*Label 25945*/ GIMT_Encode4(1929623), // Rule ID 23994 //
     /* 1929542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1929553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1929556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1929559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929588 */     // MIs[0] policy
     /* 1929588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929598 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929622 */     // GIR_Coverage, 23994,
     /* 1929622 */     GIR_EraseRootFromParent_Done,
     /* 1929623 */   // Label 25945: @1929623
     /* 1929623 */   GIM_Try, /*On fail goto*//*Label 25946*/ GIMT_Encode4(1929709), // Rule ID 23995 //
     /* 1929628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1929639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1929642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1929645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929674 */     // MIs[0] policy
     /* 1929674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929708 */     // GIR_Coverage, 23995,
     /* 1929708 */     GIR_EraseRootFromParent_Done,
     /* 1929709 */   // Label 25946: @1929709
     /* 1929709 */   GIM_Try, /*On fail goto*//*Label 25947*/ GIMT_Encode4(1929795), // Rule ID 23998 //
     /* 1929714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1929717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1929725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1929728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1929731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929760 */     // MIs[0] policy
     /* 1929760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929770 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929794 */     // GIR_Coverage, 23998,
     /* 1929794 */     GIR_EraseRootFromParent_Done,
     /* 1929795 */   // Label 25947: @1929795
     /* 1929795 */   GIM_Try, /*On fail goto*//*Label 25948*/ GIMT_Encode4(1929881), // Rule ID 23999 //
     /* 1929800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1929803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1929811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1929814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1929817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929846 */     // MIs[0] policy
     /* 1929846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1929859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929880 */     // GIR_Coverage, 23999,
     /* 1929880 */     GIR_EraseRootFromParent_Done,
     /* 1929881 */   // Label 25948: @1929881
     /* 1929881 */   GIM_Try, /*On fail goto*//*Label 25949*/ GIMT_Encode4(1929967), // Rule ID 24002 //
     /* 1929886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1929889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1929897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1929900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1929903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1929909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1929916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1929924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929932 */     // MIs[0] policy
     /* 1929932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929942 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1929945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1929963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929966 */     // GIR_Coverage, 24002,
     /* 1929966 */     GIR_EraseRootFromParent_Done,
     /* 1929967 */   // Label 25949: @1929967
     /* 1929967 */   GIM_Try, /*On fail goto*//*Label 25950*/ GIMT_Encode4(1930053), // Rule ID 24003 //
     /* 1929972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1929975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1929980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1929983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1929986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1929989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1929995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930018 */     // MIs[0] policy
     /* 1930018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930052 */     // GIR_Coverage, 24003,
     /* 1930052 */     GIR_EraseRootFromParent_Done,
     /* 1930053 */   // Label 25950: @1930053
     /* 1930053 */   GIM_Try, /*On fail goto*//*Label 25951*/ GIMT_Encode4(1930139), // Rule ID 24006 //
     /* 1930058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930104 */     // MIs[0] policy
     /* 1930104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930114 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930138 */     // GIR_Coverage, 24006,
     /* 1930138 */     GIR_EraseRootFromParent_Done,
     /* 1930139 */   // Label 25951: @1930139
     /* 1930139 */   GIM_Try, /*On fail goto*//*Label 25952*/ GIMT_Encode4(1930225), // Rule ID 24007 //
     /* 1930144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1930155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1930158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1930161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930190 */     // MIs[0] policy
     /* 1930190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930200 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930224 */     // GIR_Coverage, 24007,
     /* 1930224 */     GIR_EraseRootFromParent_Done,
     /* 1930225 */   // Label 25952: @1930225
     /* 1930225 */   GIM_Try, /*On fail goto*//*Label 25953*/ GIMT_Encode4(1930311), // Rule ID 24010 //
     /* 1930230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930276 */     // MIs[0] policy
     /* 1930276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930286 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930310 */     // GIR_Coverage, 24010,
     /* 1930310 */     GIR_EraseRootFromParent_Done,
     /* 1930311 */   // Label 25953: @1930311
     /* 1930311 */   GIM_Try, /*On fail goto*//*Label 25954*/ GIMT_Encode4(1930397), // Rule ID 24011 //
     /* 1930316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1930327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1930330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1930333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1930339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930362 */     // MIs[0] policy
     /* 1930362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930372 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1930393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930396 */     // GIR_Coverage, 24011,
     /* 1930396 */     GIR_EraseRootFromParent_Done,
     /* 1930397 */   // Label 25954: @1930397
     /* 1930397 */   GIM_Try, /*On fail goto*//*Label 25955*/ GIMT_Encode4(1930483), // Rule ID 24014 //
     /* 1930402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930448 */     // MIs[0] policy
     /* 1930448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930482 */     // GIR_Coverage, 24014,
     /* 1930482 */     GIR_EraseRootFromParent_Done,
     /* 1930483 */   // Label 25955: @1930483
     /* 1930483 */   GIM_Try, /*On fail goto*//*Label 25956*/ GIMT_Encode4(1930569), // Rule ID 24015 //
     /* 1930488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930534 */     // MIs[0] policy
     /* 1930534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930568 */     // GIR_Coverage, 24015,
     /* 1930568 */     GIR_EraseRootFromParent_Done,
     /* 1930569 */   // Label 25956: @1930569
     /* 1930569 */   GIM_Try, /*On fail goto*//*Label 25957*/ GIMT_Encode4(1930655), // Rule ID 24018 //
     /* 1930574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1930585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1930588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1930591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930620 */     // MIs[0] policy
     /* 1930620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930630 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930654 */     // GIR_Coverage, 24018,
     /* 1930654 */     GIR_EraseRootFromParent_Done,
     /* 1930655 */   // Label 25957: @1930655
     /* 1930655 */   GIM_Try, /*On fail goto*//*Label 25958*/ GIMT_Encode4(1930741), // Rule ID 24019 //
     /* 1930660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1930671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1930674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1930677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930706 */     // MIs[0] policy
     /* 1930706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930716 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1930719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930740 */     // GIR_Coverage, 24019,
     /* 1930740 */     GIR_EraseRootFromParent_Done,
     /* 1930741 */   // Label 25958: @1930741
     /* 1930741 */   GIM_Try, /*On fail goto*//*Label 25959*/ GIMT_Encode4(1930827), // Rule ID 24022 //
     /* 1930746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1930757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1930760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1930763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930792 */     // MIs[0] policy
     /* 1930792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930826 */     // GIR_Coverage, 24022,
     /* 1930826 */     GIR_EraseRootFromParent_Done,
     /* 1930827 */   // Label 25959: @1930827
     /* 1930827 */   GIM_Try, /*On fail goto*//*Label 25960*/ GIMT_Encode4(1930913), // Rule ID 24023 //
     /* 1930832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1930835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1930843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1930846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1930849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930878 */     // MIs[0] policy
     /* 1930878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930888 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1930891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930912 */     // GIR_Coverage, 24023,
     /* 1930912 */     GIR_EraseRootFromParent_Done,
     /* 1930913 */   // Label 25960: @1930913
     /* 1930913 */   GIM_Try, /*On fail goto*//*Label 25961*/ GIMT_Encode4(1930999), // Rule ID 24026 //
     /* 1930918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1930921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1930926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1930929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1930932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1930935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1930941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930964 */     // MIs[0] policy
     /* 1930964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1930977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1930981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930998 */     // GIR_Coverage, 24026,
     /* 1930998 */     GIR_EraseRootFromParent_Done,
     /* 1930999 */   // Label 25961: @1930999
     /* 1930999 */   GIM_Try, /*On fail goto*//*Label 25962*/ GIMT_Encode4(1931085), // Rule ID 24027 //
     /* 1931004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1931015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1931018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1931021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931050 */     // MIs[0] policy
     /* 1931050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931084 */     // GIR_Coverage, 24027,
     /* 1931084 */     GIR_EraseRootFromParent_Done,
     /* 1931085 */   // Label 25962: @1931085
     /* 1931085 */   GIM_Try, /*On fail goto*//*Label 25963*/ GIMT_Encode4(1931171), // Rule ID 24030 //
     /* 1931090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931136 */     // MIs[0] policy
     /* 1931136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931146 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931170 */     // GIR_Coverage, 24030,
     /* 1931170 */     GIR_EraseRootFromParent_Done,
     /* 1931171 */   // Label 25963: @1931171
     /* 1931171 */   GIM_Try, /*On fail goto*//*Label 25964*/ GIMT_Encode4(1931257), // Rule ID 24031 //
     /* 1931176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1931187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1931190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1931193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931222 */     // MIs[0] policy
     /* 1931222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931232 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931256 */     // GIR_Coverage, 24031,
     /* 1931256 */     GIR_EraseRootFromParent_Done,
     /* 1931257 */   // Label 25964: @1931257
     /* 1931257 */   GIM_Try, /*On fail goto*//*Label 25965*/ GIMT_Encode4(1931343), // Rule ID 24034 //
     /* 1931262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931308 */     // MIs[0] policy
     /* 1931308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931342 */     // GIR_Coverage, 24034,
     /* 1931342 */     GIR_EraseRootFromParent_Done,
     /* 1931343 */   // Label 25965: @1931343
     /* 1931343 */   GIM_Try, /*On fail goto*//*Label 25966*/ GIMT_Encode4(1931429), // Rule ID 24035 //
     /* 1931348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1931351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931394 */     // MIs[0] policy
     /* 1931394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931404 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931428 */     // GIR_Coverage, 24035,
     /* 1931428 */     GIR_EraseRootFromParent_Done,
     /* 1931429 */   // Label 25966: @1931429
     /* 1931429 */   GIM_Try, /*On fail goto*//*Label 25967*/ GIMT_Encode4(1931515), // Rule ID 24038 //
     /* 1931434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931480 */     // MIs[0] policy
     /* 1931480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931490 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931514 */     // GIR_Coverage, 24038,
     /* 1931514 */     GIR_EraseRootFromParent_Done,
     /* 1931515 */   // Label 25967: @1931515
     /* 1931515 */   GIM_Try, /*On fail goto*//*Label 25968*/ GIMT_Encode4(1931601), // Rule ID 24039 //
     /* 1931520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931566 */     // MIs[0] policy
     /* 1931566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1931579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931600 */     // GIR_Coverage, 24039,
     /* 1931600 */     GIR_EraseRootFromParent_Done,
     /* 1931601 */   // Label 25968: @1931601
     /* 1931601 */   GIM_Try, /*On fail goto*//*Label 25969*/ GIMT_Encode4(1931687), // Rule ID 24042 //
     /* 1931606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1931617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1931620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1931623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931652 */     // MIs[0] policy
     /* 1931652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931662 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931686 */     // GIR_Coverage, 24042,
     /* 1931686 */     GIR_EraseRootFromParent_Done,
     /* 1931687 */   // Label 25969: @1931687
     /* 1931687 */   GIM_Try, /*On fail goto*//*Label 25970*/ GIMT_Encode4(1931773), // Rule ID 24043 //
     /* 1931692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1931703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1931706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1931709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931738 */     // MIs[0] policy
     /* 1931738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931748 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1931751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931772 */     // GIR_Coverage, 24043,
     /* 1931772 */     GIR_EraseRootFromParent_Done,
     /* 1931773 */   // Label 25970: @1931773
     /* 1931773 */   GIM_Try, /*On fail goto*//*Label 25971*/ GIMT_Encode4(1931859), // Rule ID 24046 //
     /* 1931778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1931781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1931789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1931792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1931795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931824 */     // MIs[0] policy
     /* 1931824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931834 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931858 */     // GIR_Coverage, 24046,
     /* 1931858 */     GIR_EraseRootFromParent_Done,
     /* 1931859 */   // Label 25971: @1931859
     /* 1931859 */   GIM_Try, /*On fail goto*//*Label 25972*/ GIMT_Encode4(1931945), // Rule ID 24047 //
     /* 1931864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1931867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1931872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1931875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1931878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1931881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931910 */     // MIs[0] policy
     /* 1931910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1931923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1931927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931944 */     // GIR_Coverage, 24047,
     /* 1931944 */     GIR_EraseRootFromParent_Done,
     /* 1931945 */   // Label 25972: @1931945
     /* 1931945 */   GIM_Try, /*On fail goto*//*Label 25973*/ GIMT_Encode4(1932031), // Rule ID 24050 //
     /* 1931950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1931953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1931958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1931961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1931964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1931967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1931973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931996 */     // MIs[0] policy
     /* 1931996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932006 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1932009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932030 */     // GIR_Coverage, 24050,
     /* 1932030 */     GIR_EraseRootFromParent_Done,
     /* 1932031 */   // Label 25973: @1932031
     /* 1932031 */   GIM_Try, /*On fail goto*//*Label 25974*/ GIMT_Encode4(1932117), // Rule ID 24051 //
     /* 1932036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1932047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1932050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1932053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932082 */     // MIs[0] policy
     /* 1932082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932092 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1932095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932116 */     // GIR_Coverage, 24051,
     /* 1932116 */     GIR_EraseRootFromParent_Done,
     /* 1932117 */   // Label 25974: @1932117
     /* 1932117 */   GIM_Try, /*On fail goto*//*Label 25975*/ GIMT_Encode4(1932203), // Rule ID 24054 //
     /* 1932122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932168 */     // MIs[0] policy
     /* 1932168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932178 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932202 */     // GIR_Coverage, 24054,
     /* 1932202 */     GIR_EraseRootFromParent_Done,
     /* 1932203 */   // Label 25975: @1932203
     /* 1932203 */   GIM_Try, /*On fail goto*//*Label 25976*/ GIMT_Encode4(1932289), // Rule ID 24055 //
     /* 1932208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1932219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1932222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1932225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932254 */     // MIs[0] policy
     /* 1932254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932264 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932288 */     // GIR_Coverage, 24055,
     /* 1932288 */     GIR_EraseRootFromParent_Done,
     /* 1932289 */   // Label 25976: @1932289
     /* 1932289 */   GIM_Try, /*On fail goto*//*Label 25977*/ GIMT_Encode4(1932375), // Rule ID 24058 //
     /* 1932294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932340 */     // MIs[0] policy
     /* 1932340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932350 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932374 */     // GIR_Coverage, 24058,
     /* 1932374 */     GIR_EraseRootFromParent_Done,
     /* 1932375 */   // Label 25977: @1932375
     /* 1932375 */   GIM_Try, /*On fail goto*//*Label 25978*/ GIMT_Encode4(1932461), // Rule ID 24059 //
     /* 1932380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1932391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1932394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1932397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932426 */     // MIs[0] policy
     /* 1932426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932436 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1932457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932460 */     // GIR_Coverage, 24059,
     /* 1932460 */     GIR_EraseRootFromParent_Done,
     /* 1932461 */   // Label 25978: @1932461
     /* 1932461 */   GIM_Try, /*On fail goto*//*Label 25979*/ GIMT_Encode4(1932547), // Rule ID 24062 //
     /* 1932466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1932477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1932480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1932483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932512 */     // MIs[0] policy
     /* 1932512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932522 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932546 */     // GIR_Coverage, 24062,
     /* 1932546 */     GIR_EraseRootFromParent_Done,
     /* 1932547 */   // Label 25979: @1932547
     /* 1932547 */   GIM_Try, /*On fail goto*//*Label 25980*/ GIMT_Encode4(1932633), // Rule ID 24063 //
     /* 1932552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1932563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1932566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1932569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932598 */     // MIs[0] policy
     /* 1932598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932608 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1932611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932632 */     // GIR_Coverage, 24063,
     /* 1932632 */     GIR_EraseRootFromParent_Done,
     /* 1932633 */   // Label 25980: @1932633
     /* 1932633 */   GIM_Try, /*On fail goto*//*Label 25981*/ GIMT_Encode4(1932719), // Rule ID 24066 //
     /* 1932638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1932649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1932652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1932655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932684 */     // MIs[0] policy
     /* 1932684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932718 */     // GIR_Coverage, 24066,
     /* 1932718 */     GIR_EraseRootFromParent_Done,
     /* 1932719 */   // Label 25981: @1932719
     /* 1932719 */   GIM_Try, /*On fail goto*//*Label 25982*/ GIMT_Encode4(1932805), // Rule ID 24067 //
     /* 1932724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1932735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1932738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1932741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932770 */     // MIs[0] policy
     /* 1932770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932804 */     // GIR_Coverage, 24067,
     /* 1932804 */     GIR_EraseRootFromParent_Done,
     /* 1932805 */   // Label 25982: @1932805
     /* 1932805 */   GIM_Try, /*On fail goto*//*Label 25983*/ GIMT_Encode4(1932891), // Rule ID 24070 //
     /* 1932810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1932821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1932824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1932827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932856 */     // MIs[0] policy
     /* 1932856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932890 */     // GIR_Coverage, 24070,
     /* 1932890 */     GIR_EraseRootFromParent_Done,
     /* 1932891 */   // Label 25983: @1932891
     /* 1932891 */   GIM_Try, /*On fail goto*//*Label 25984*/ GIMT_Encode4(1932977), // Rule ID 24071 //
     /* 1932896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1932899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1932907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1932910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1932913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932942 */     // MIs[0] policy
     /* 1932942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1932955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1932959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932976 */     // GIR_Coverage, 24071,
     /* 1932976 */     GIR_EraseRootFromParent_Done,
     /* 1932977 */   // Label 25984: @1932977
     /* 1932977 */   GIM_Try, /*On fail goto*//*Label 25985*/ GIMT_Encode4(1933063), // Rule ID 24074 //
     /* 1932982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1932985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1932990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1932993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1932996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1932999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933028 */     // MIs[0] policy
     /* 1933028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933038 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933062 */     // GIR_Coverage, 24074,
     /* 1933062 */     GIR_EraseRootFromParent_Done,
     /* 1933063 */   // Label 25985: @1933063
     /* 1933063 */   GIM_Try, /*On fail goto*//*Label 25986*/ GIMT_Encode4(1933149), // Rule ID 24075 //
     /* 1933068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1933079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1933082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1933085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933114 */     // MIs[0] policy
     /* 1933114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11546:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933148 */     // GIR_Coverage, 24075,
     /* 1933148 */     GIR_EraseRootFromParent_Done,
     /* 1933149 */   // Label 25986: @1933149
     /* 1933149 */   GIM_Try, /*On fail goto*//*Label 25987*/ GIMT_Encode4(1933235), // Rule ID 24078 //
     /* 1933154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933200 */     // MIs[0] policy
     /* 1933200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933210 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933234 */     // GIR_Coverage, 24078,
     /* 1933234 */     GIR_EraseRootFromParent_Done,
     /* 1933235 */   // Label 25987: @1933235
     /* 1933235 */   GIM_Try, /*On fail goto*//*Label 25988*/ GIMT_Encode4(1933321), // Rule ID 24079 //
     /* 1933240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1933251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1933254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1933257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933286 */     // MIs[0] policy
     /* 1933286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933296 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11546:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933320 */     // GIR_Coverage, 24079,
     /* 1933320 */     GIR_EraseRootFromParent_Done,
     /* 1933321 */   // Label 25988: @1933321
     /* 1933321 */   GIM_Try, /*On fail goto*//*Label 25989*/ GIMT_Encode4(1933407), // Rule ID 24082 //
     /* 1933326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933372 */     // MIs[0] policy
     /* 1933372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933406 */     // GIR_Coverage, 24082,
     /* 1933406 */     GIR_EraseRootFromParent_Done,
     /* 1933407 */   // Label 25989: @1933407
     /* 1933407 */   GIM_Try, /*On fail goto*//*Label 25990*/ GIMT_Encode4(1933493), // Rule ID 24083 //
     /* 1933412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1933423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1933426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1933429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933458 */     // MIs[0] policy
     /* 1933458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11546:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933492 */     // GIR_Coverage, 24083,
     /* 1933492 */     GIR_EraseRootFromParent_Done,
     /* 1933493 */   // Label 25990: @1933493
     /* 1933493 */   GIM_Try, /*On fail goto*//*Label 25991*/ GIMT_Encode4(1933579), // Rule ID 24086 //
     /* 1933498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1933501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1933509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1933512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1933515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933544 */     // MIs[0] policy
     /* 1933544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933554 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933578 */     // GIR_Coverage, 24086,
     /* 1933578 */     GIR_EraseRootFromParent_Done,
     /* 1933579 */   // Label 25991: @1933579
     /* 1933579 */   GIM_Try, /*On fail goto*//*Label 25992*/ GIMT_Encode4(1933665), // Rule ID 24087 //
     /* 1933584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1933587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1933595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1933598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1933601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1933607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1933614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1933622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933630 */     // MIs[0] policy
     /* 1933630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11546:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1933643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933664 */     // GIR_Coverage, 24087,
     /* 1933664 */     GIR_EraseRootFromParent_Done,
     /* 1933665 */   // Label 25992: @1933665
     /* 1933665 */   GIM_Try, /*On fail goto*//*Label 25993*/ GIMT_Encode4(1933751), // Rule ID 24090 //
     /* 1933670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1933681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1933684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1933687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1933693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933716 */     // MIs[0] policy
     /* 1933716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933726 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1933729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933750 */     // GIR_Coverage, 24090,
     /* 1933750 */     GIR_EraseRootFromParent_Done,
     /* 1933751 */   // Label 25993: @1933751
     /* 1933751 */   GIM_Try, /*On fail goto*//*Label 25994*/ GIMT_Encode4(1933837), // Rule ID 24091 //
     /* 1933756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1933767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1933770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1933773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1933779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933802 */     // MIs[0] policy
     /* 1933802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933812 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1933815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933836 */     // GIR_Coverage, 24091,
     /* 1933836 */     GIR_EraseRootFromParent_Done,
     /* 1933837 */   // Label 25994: @1933837
     /* 1933837 */   GIM_Try, /*On fail goto*//*Label 25995*/ GIMT_Encode4(1933923), // Rule ID 24094 //
     /* 1933842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1933845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1933853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1933856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1933859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1933865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933888 */     // MIs[0] policy
     /* 1933888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933898 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1933901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1933919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933922 */     // GIR_Coverage, 24094,
     /* 1933922 */     GIR_EraseRootFromParent_Done,
     /* 1933923 */   // Label 25995: @1933923
     /* 1933923 */   GIM_Try, /*On fail goto*//*Label 25996*/ GIMT_Encode4(1934009), // Rule ID 24095 //
     /* 1933928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1933931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1933936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1933939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1933942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1933945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1933951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933974 */     // MIs[0] policy
     /* 1933974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933984 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1933987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1933991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934008 */     // GIR_Coverage, 24095,
     /* 1934008 */     GIR_EraseRootFromParent_Done,
     /* 1934009 */   // Label 25996: @1934009
     /* 1934009 */   GIM_Try, /*On fail goto*//*Label 25997*/ GIMT_Encode4(1934095), // Rule ID 24098 //
     /* 1934014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934060 */     // MIs[0] policy
     /* 1934060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934070 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934094 */     // GIR_Coverage, 24098,
     /* 1934094 */     GIR_EraseRootFromParent_Done,
     /* 1934095 */   // Label 25997: @1934095
     /* 1934095 */   GIM_Try, /*On fail goto*//*Label 25998*/ GIMT_Encode4(1934181), // Rule ID 24099 //
     /* 1934100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1934111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1934114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1934117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1934123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934146 */     // MIs[0] policy
     /* 1934146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934156 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1934177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934180 */     // GIR_Coverage, 24099,
     /* 1934180 */     GIR_EraseRootFromParent_Done,
     /* 1934181 */   // Label 25998: @1934181
     /* 1934181 */   GIM_Try, /*On fail goto*//*Label 25999*/ GIMT_Encode4(1934267), // Rule ID 24102 //
     /* 1934186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934232 */     // MIs[0] policy
     /* 1934232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934266 */     // GIR_Coverage, 24102,
     /* 1934266 */     GIR_EraseRootFromParent_Done,
     /* 1934267 */   // Label 25999: @1934267
     /* 1934267 */   GIM_Try, /*On fail goto*//*Label 26000*/ GIMT_Encode4(1934353), // Rule ID 24103 //
     /* 1934272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1934283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1934286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1934289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934318 */     // MIs[0] policy
     /* 1934318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934328 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934352 */     // GIR_Coverage, 24103,
     /* 1934352 */     GIR_EraseRootFromParent_Done,
     /* 1934353 */   // Label 26000: @1934353
     /* 1934353 */   GIM_Try, /*On fail goto*//*Label 26001*/ GIMT_Encode4(1934439), // Rule ID 24106 //
     /* 1934358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934404 */     // MIs[0] policy
     /* 1934404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934414 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934438 */     // GIR_Coverage, 24106,
     /* 1934438 */     GIR_EraseRootFromParent_Done,
     /* 1934439 */   // Label 26001: @1934439
     /* 1934439 */   GIM_Try, /*On fail goto*//*Label 26002*/ GIMT_Encode4(1934525), // Rule ID 24107 //
     /* 1934444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1934455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1934458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1934461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1934467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934490 */     // MIs[0] policy
     /* 1934490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934500 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934524 */     // GIR_Coverage, 24107,
     /* 1934524 */     GIR_EraseRootFromParent_Done,
     /* 1934525 */   // Label 26002: @1934525
     /* 1934525 */   GIM_Try, /*On fail goto*//*Label 26003*/ GIMT_Encode4(1934611), // Rule ID 24110 //
     /* 1934530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1934541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1934544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1934547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934576 */     // MIs[0] policy
     /* 1934576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934586 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934610 */     // GIR_Coverage, 24110,
     /* 1934610 */     GIR_EraseRootFromParent_Done,
     /* 1934611 */   // Label 26003: @1934611
     /* 1934611 */   GIM_Try, /*On fail goto*//*Label 26004*/ GIMT_Encode4(1934697), // Rule ID 24111 //
     /* 1934616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1934627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1934630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1934633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1934639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934662 */     // MIs[0] policy
     /* 1934662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934672 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1934675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934696 */     // GIR_Coverage, 24111,
     /* 1934696 */     GIR_EraseRootFromParent_Done,
     /* 1934697 */   // Label 26004: @1934697
     /* 1934697 */   GIM_Try, /*On fail goto*//*Label 26005*/ GIMT_Encode4(1934783), // Rule ID 24114 //
     /* 1934702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1934713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1934716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1934719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934748 */     // MIs[0] policy
     /* 1934748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934782 */     // GIR_Coverage, 24114,
     /* 1934782 */     GIR_EraseRootFromParent_Done,
     /* 1934783 */   // Label 26005: @1934783
     /* 1934783 */   GIM_Try, /*On fail goto*//*Label 26006*/ GIMT_Encode4(1934869), // Rule ID 24115 //
     /* 1934788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1934799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1934802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1934805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1934818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1934826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934834 */     // MIs[0] policy
     /* 1934834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1934847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934868 */     // GIR_Coverage, 24115,
     /* 1934868 */     GIR_EraseRootFromParent_Done,
     /* 1934869 */   // Label 26006: @1934869
     /* 1934869 */   GIM_Try, /*On fail goto*//*Label 26007*/ GIMT_Encode4(1934955), // Rule ID 24118 //
     /* 1934874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1934877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1934885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1934888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1934891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934920 */     // MIs[0] policy
     /* 1934920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934930 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1934933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934954 */     // GIR_Coverage, 24118,
     /* 1934954 */     GIR_EraseRootFromParent_Done,
     /* 1934955 */   // Label 26007: @1934955
     /* 1934955 */   GIM_Try, /*On fail goto*//*Label 26008*/ GIMT_Encode4(1935041), // Rule ID 24119 //
     /* 1934960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1934963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1934968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1934971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1934974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1934977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935006 */     // MIs[0] policy
     /* 1935006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935040 */     // GIR_Coverage, 24119,
     /* 1935040 */     GIR_EraseRootFromParent_Done,
     /* 1935041 */   // Label 26008: @1935041
     /* 1935041 */   GIM_Try, /*On fail goto*//*Label 26009*/ GIMT_Encode4(1935127), // Rule ID 24122 //
     /* 1935046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1935049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935092 */     // MIs[0] policy
     /* 1935092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935126 */     // GIR_Coverage, 24122,
     /* 1935126 */     GIR_EraseRootFromParent_Done,
     /* 1935127 */   // Label 26009: @1935127
     /* 1935127 */   GIM_Try, /*On fail goto*//*Label 26010*/ GIMT_Encode4(1935213), // Rule ID 24123 //
     /* 1935132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1935135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1935143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1935146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1935149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935178 */     // MIs[0] policy
     /* 1935178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935188 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935212 */     // GIR_Coverage, 24123,
     /* 1935212 */     GIR_EraseRootFromParent_Done,
     /* 1935213 */   // Label 26010: @1935213
     /* 1935213 */   GIM_Try, /*On fail goto*//*Label 26011*/ GIMT_Encode4(1935299), // Rule ID 24126 //
     /* 1935218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935264 */     // MIs[0] policy
     /* 1935264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935274 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935298 */     // GIR_Coverage, 24126,
     /* 1935298 */     GIR_EraseRootFromParent_Done,
     /* 1935299 */   // Label 26011: @1935299
     /* 1935299 */   GIM_Try, /*On fail goto*//*Label 26012*/ GIMT_Encode4(1935385), // Rule ID 24127 //
     /* 1935304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1935315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1935318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1935321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935350 */     // MIs[0] policy
     /* 1935350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11546:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1935363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935384 */     // GIR_Coverage, 24127,
     /* 1935384 */     GIR_EraseRootFromParent_Done,
     /* 1935385 */   // Label 26012: @1935385
     /* 1935385 */   GIM_Try, /*On fail goto*//*Label 26013*/ GIMT_Encode4(1935471), // Rule ID 24130 //
     /* 1935390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935436 */     // MIs[0] policy
     /* 1935436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935446 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935470 */     // GIR_Coverage, 24130,
     /* 1935470 */     GIR_EraseRootFromParent_Done,
     /* 1935471 */   // Label 26013: @1935471
     /* 1935471 */   GIM_Try, /*On fail goto*//*Label 26014*/ GIMT_Encode4(1935557), // Rule ID 24131 //
     /* 1935476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1935487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1935490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1935493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935522 */     // MIs[0] policy
     /* 1935522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935532 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11546:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1935535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935556 */     // GIR_Coverage, 24131,
     /* 1935556 */     GIR_EraseRootFromParent_Done,
     /* 1935557 */   // Label 26014: @1935557
     /* 1935557 */   GIM_Try, /*On fail goto*//*Label 26015*/ GIMT_Encode4(1935643), // Rule ID 24134 //
     /* 1935562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1935565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1935573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1935576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1935579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935608 */     // MIs[0] policy
     /* 1935608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935642 */     // GIR_Coverage, 24134,
     /* 1935642 */     GIR_EraseRootFromParent_Done,
     /* 1935643 */   // Label 26015: @1935643
     /* 1935643 */   GIM_Try, /*On fail goto*//*Label 26016*/ GIMT_Encode4(1935729), // Rule ID 24135 //
     /* 1935648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1935651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1935656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1935659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1935662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1935665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935694 */     // MIs[0] policy
     /* 1935694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935704 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11546:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1935707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935728 */     // GIR_Coverage, 24135,
     /* 1935728 */     GIR_EraseRootFromParent_Done,
     /* 1935729 */   // Label 26016: @1935729
     /* 1935729 */   GIM_Try, /*On fail goto*//*Label 26017*/ GIMT_Encode4(1935815), // Rule ID 24138 //
     /* 1935734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1935737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1935745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1935748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1935751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1935757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935780 */     // MIs[0] policy
     /* 1935780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935790 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1935793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935814 */     // GIR_Coverage, 24138,
     /* 1935814 */     GIR_EraseRootFromParent_Done,
     /* 1935815 */   // Label 26017: @1935815
     /* 1935815 */   GIM_Try, /*On fail goto*//*Label 26018*/ GIMT_Encode4(1935901), // Rule ID 24139 //
     /* 1935820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1935823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1935831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1935834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1935837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1935843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935866 */     // MIs[0] policy
     /* 1935866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935876 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1935879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935900 */     // GIR_Coverage, 24139,
     /* 1935900 */     GIR_EraseRootFromParent_Done,
     /* 1935901 */   // Label 26018: @1935901
     /* 1935901 */   GIM_Try, /*On fail goto*//*Label 26019*/ GIMT_Encode4(1935987), // Rule ID 24142 //
     /* 1935906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1935909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1935914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1935917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1935920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1935923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1935948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935952 */     // MIs[0] policy
     /* 1935952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935962 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1935965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1935969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935986 */     // GIR_Coverage, 24142,
     /* 1935986 */     GIR_EraseRootFromParent_Done,
     /* 1935987 */   // Label 26019: @1935987
     /* 1935987 */   GIM_Try, /*On fail goto*//*Label 26020*/ GIMT_Encode4(1936073), // Rule ID 24143 //
     /* 1935992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1935995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1936003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1936006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1936009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936038 */     // MIs[0] policy
     /* 1936038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936048 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936072 */     // GIR_Coverage, 24143,
     /* 1936072 */     GIR_EraseRootFromParent_Done,
     /* 1936073 */   // Label 26020: @1936073
     /* 1936073 */   GIM_Try, /*On fail goto*//*Label 26021*/ GIMT_Encode4(1936159), // Rule ID 24146 //
     /* 1936078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1936081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936124 */     // MIs[0] policy
     /* 1936124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936134 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936158 */     // GIR_Coverage, 24146,
     /* 1936158 */     GIR_EraseRootFromParent_Done,
     /* 1936159 */   // Label 26021: @1936159
     /* 1936159 */   GIM_Try, /*On fail goto*//*Label 26022*/ GIMT_Encode4(1936245), // Rule ID 24147 //
     /* 1936164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1936167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1936175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1936178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1936181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936210 */     // MIs[0] policy
     /* 1936210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936220 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1936223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936244 */     // GIR_Coverage, 24147,
     /* 1936244 */     GIR_EraseRootFromParent_Done,
     /* 1936245 */   // Label 26022: @1936245
     /* 1936245 */   GIM_Try, /*On fail goto*//*Label 26023*/ GIMT_Encode4(1936331), // Rule ID 24150 //
     /* 1936250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1936253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936296 */     // MIs[0] policy
     /* 1936296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936306 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936330 */     // GIR_Coverage, 24150,
     /* 1936330 */     GIR_EraseRootFromParent_Done,
     /* 1936331 */   // Label 26023: @1936331
     /* 1936331 */   GIM_Try, /*On fail goto*//*Label 26024*/ GIMT_Encode4(1936417), // Rule ID 24151 //
     /* 1936336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1936339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1936347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1936350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1936353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936382 */     // MIs[0] policy
     /* 1936382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936392 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936416 */     // GIR_Coverage, 24151,
     /* 1936416 */     GIR_EraseRootFromParent_Done,
     /* 1936417 */   // Label 26024: @1936417
     /* 1936417 */   GIM_Try, /*On fail goto*//*Label 26025*/ GIMT_Encode4(1936503), // Rule ID 24154 //
     /* 1936422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1936425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936468 */     // MIs[0] policy
     /* 1936468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936478 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936502 */     // GIR_Coverage, 24154,
     /* 1936502 */     GIR_EraseRootFromParent_Done,
     /* 1936503 */   // Label 26025: @1936503
     /* 1936503 */   GIM_Try, /*On fail goto*//*Label 26026*/ GIMT_Encode4(1936589), // Rule ID 24155 //
     /* 1936508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1936511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1936519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1936522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1936525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936554 */     // MIs[0] policy
     /* 1936554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936588 */     // GIR_Coverage, 24155,
     /* 1936588 */     GIR_EraseRootFromParent_Done,
     /* 1936589 */   // Label 26026: @1936589
     /* 1936589 */   GIM_Try, /*On fail goto*//*Label 26027*/ GIMT_Encode4(1936675), // Rule ID 24158 //
     /* 1936594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1936597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1936605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1936608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1936611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936640 */     // MIs[0] policy
     /* 1936640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936650 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936674 */     // GIR_Coverage, 24158,
     /* 1936674 */     GIR_EraseRootFromParent_Done,
     /* 1936675 */   // Label 26027: @1936675
     /* 1936675 */   GIM_Try, /*On fail goto*//*Label 26028*/ GIMT_Encode4(1936761), // Rule ID 24159 //
     /* 1936680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1936683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1936691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1936694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1936697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936726 */     // MIs[0] policy
     /* 1936726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936736 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1936739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936760 */     // GIR_Coverage, 24159,
     /* 1936760 */     GIR_EraseRootFromParent_Done,
     /* 1936761 */   // Label 26028: @1936761
     /* 1936761 */   GIM_Try, /*On fail goto*//*Label 26029*/ GIMT_Encode4(1936847), // Rule ID 24162 //
     /* 1936766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1936769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1936777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1936780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1936783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936812 */     // MIs[0] policy
     /* 1936812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936822 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1936825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936846 */     // GIR_Coverage, 24162,
     /* 1936846 */     GIR_EraseRootFromParent_Done,
     /* 1936847 */   // Label 26029: @1936847
     /* 1936847 */   GIM_Try, /*On fail goto*//*Label 26030*/ GIMT_Encode4(1936933), // Rule ID 24163 //
     /* 1936852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1936855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1936863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1936866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1936869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936898 */     // MIs[0] policy
     /* 1936898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936908 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1936911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1936915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936932 */     // GIR_Coverage, 24163,
     /* 1936932 */     GIR_EraseRootFromParent_Done,
     /* 1936933 */   // Label 26030: @1936933
     /* 1936933 */   GIM_Try, /*On fail goto*//*Label 26031*/ GIMT_Encode4(1937019), // Rule ID 24166 //
     /* 1936938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1936941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1936946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1936949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1936952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1936955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1936961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1936980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936984 */     // MIs[0] policy
     /* 1936984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936994 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1936997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937018 */     // GIR_Coverage, 24166,
     /* 1937018 */     GIR_EraseRootFromParent_Done,
     /* 1937019 */   // Label 26031: @1937019
     /* 1937019 */   GIM_Try, /*On fail goto*//*Label 26032*/ GIMT_Encode4(1937105), // Rule ID 24167 //
     /* 1937024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1937027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1937035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1937038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1937041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937070 */     // MIs[0] policy
     /* 1937070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937080 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937104 */     // GIR_Coverage, 24167,
     /* 1937104 */     GIR_EraseRootFromParent_Done,
     /* 1937105 */   // Label 26032: @1937105
     /* 1937105 */   GIM_Try, /*On fail goto*//*Label 26033*/ GIMT_Encode4(1937191), // Rule ID 24170 //
     /* 1937110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1937113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937156 */     // MIs[0] policy
     /* 1937156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937166 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937190 */     // GIR_Coverage, 24170,
     /* 1937190 */     GIR_EraseRootFromParent_Done,
     /* 1937191 */   // Label 26033: @1937191
     /* 1937191 */   GIM_Try, /*On fail goto*//*Label 26034*/ GIMT_Encode4(1937277), // Rule ID 24171 //
     /* 1937196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1937199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1937207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1937210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1937213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1937219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937242 */     // MIs[0] policy
     /* 1937242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937252 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937276 */     // GIR_Coverage, 24171,
     /* 1937276 */     GIR_EraseRootFromParent_Done,
     /* 1937277 */   // Label 26034: @1937277
     /* 1937277 */   GIM_Try, /*On fail goto*//*Label 26035*/ GIMT_Encode4(1937363), // Rule ID 24174 //
     /* 1937282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1937285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937328 */     // MIs[0] policy
     /* 1937328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937338 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937362 */     // GIR_Coverage, 24174,
     /* 1937362 */     GIR_EraseRootFromParent_Done,
     /* 1937363 */   // Label 26035: @1937363
     /* 1937363 */   GIM_Try, /*On fail goto*//*Label 26036*/ GIMT_Encode4(1937449), // Rule ID 24175 //
     /* 1937368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1937371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1937379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1937382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1937385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937414 */     // MIs[0] policy
     /* 1937414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937424 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937448 */     // GIR_Coverage, 24175,
     /* 1937448 */     GIR_EraseRootFromParent_Done,
     /* 1937449 */   // Label 26036: @1937449
     /* 1937449 */   GIM_Try, /*On fail goto*//*Label 26037*/ GIMT_Encode4(1937535), // Rule ID 24178 //
     /* 1937454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1937457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1937465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1937468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1937471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937500 */     // MIs[0] policy
     /* 1937500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937510 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937534 */     // GIR_Coverage, 24178,
     /* 1937534 */     GIR_EraseRootFromParent_Done,
     /* 1937535 */   // Label 26037: @1937535
     /* 1937535 */   GIM_Try, /*On fail goto*//*Label 26038*/ GIMT_Encode4(1937621), // Rule ID 24179 //
     /* 1937540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1937543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1937551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1937554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1937557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1937570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1937578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937586 */     // MIs[0] policy
     /* 1937586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937596 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1937599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937620 */     // GIR_Coverage, 24179,
     /* 1937620 */     GIR_EraseRootFromParent_Done,
     /* 1937621 */   // Label 26038: @1937621
     /* 1937621 */   GIM_Try, /*On fail goto*//*Label 26039*/ GIMT_Encode4(1937707), // Rule ID 24182 //
     /* 1937626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1937629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1937637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1937640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1937643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937672 */     // MIs[0] policy
     /* 1937672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937682 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937706 */     // GIR_Coverage, 24182,
     /* 1937706 */     GIR_EraseRootFromParent_Done,
     /* 1937707 */   // Label 26039: @1937707
     /* 1937707 */   GIM_Try, /*On fail goto*//*Label 26040*/ GIMT_Encode4(1937793), // Rule ID 24183 //
     /* 1937712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1937715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1937723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1937726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1937729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1937735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1937742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1937750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937758 */     // MIs[0] policy
     /* 1937758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937768 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1937771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937792 */     // GIR_Coverage, 24183,
     /* 1937792 */     GIR_EraseRootFromParent_Done,
     /* 1937793 */   // Label 26040: @1937793
     /* 1937793 */   GIM_Try, /*On fail goto*//*Label 26041*/ GIMT_Encode4(1937879), // Rule ID 24186 //
     /* 1937798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1937801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1937809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1937812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1937815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937844 */     // MIs[0] policy
     /* 1937844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937854 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937878 */     // GIR_Coverage, 24186,
     /* 1937878 */     GIR_EraseRootFromParent_Done,
     /* 1937879 */   // Label 26041: @1937879
     /* 1937879 */   GIM_Try, /*On fail goto*//*Label 26042*/ GIMT_Encode4(1937965), // Rule ID 24187 //
     /* 1937884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1937887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1937895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1937898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1937901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1937926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937930 */     // MIs[0] policy
     /* 1937930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937940 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1937943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1937947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937964 */     // GIR_Coverage, 24187,
     /* 1937964 */     GIR_EraseRootFromParent_Done,
     /* 1937965 */   // Label 26042: @1937965
     /* 1937965 */   GIM_Try, /*On fail goto*//*Label 26043*/ GIMT_Encode4(1938051), // Rule ID 24190 //
     /* 1937970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1937973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1937978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1937981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1937984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1937987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938016 */     // MIs[0] policy
     /* 1938016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938026 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938050 */     // GIR_Coverage, 24190,
     /* 1938050 */     GIR_EraseRootFromParent_Done,
     /* 1938051 */   // Label 26043: @1938051
     /* 1938051 */   GIM_Try, /*On fail goto*//*Label 26044*/ GIMT_Encode4(1938137), // Rule ID 24191 //
     /* 1938056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1938059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1938067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1938070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1938073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938102 */     // MIs[0] policy
     /* 1938102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938112 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1938115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938136 */     // GIR_Coverage, 24191,
     /* 1938136 */     GIR_EraseRootFromParent_Done,
     /* 1938137 */   // Label 26044: @1938137
     /* 1938137 */   GIM_Try, /*On fail goto*//*Label 26045*/ GIMT_Encode4(1938223), // Rule ID 24194 //
     /* 1938142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1938145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938188 */     // MIs[0] policy
     /* 1938188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938198 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938222 */     // GIR_Coverage, 24194,
     /* 1938222 */     GIR_EraseRootFromParent_Done,
     /* 1938223 */   // Label 26045: @1938223
     /* 1938223 */   GIM_Try, /*On fail goto*//*Label 26046*/ GIMT_Encode4(1938309), // Rule ID 24195 //
     /* 1938228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1938231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1938236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1938239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1938242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1938245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938274 */     // MIs[0] policy
     /* 1938274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938284 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1938287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1938305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938308 */     // GIR_Coverage, 24195,
     /* 1938308 */     GIR_EraseRootFromParent_Done,
     /* 1938309 */   // Label 26046: @1938309
     /* 1938309 */   GIM_Try, /*On fail goto*//*Label 26047*/ GIMT_Encode4(1938395), // Rule ID 24258 //
     /* 1938314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1938317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938360 */     // MIs[0] policy
     /* 1938360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938370 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1938373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938394 */     // GIR_Coverage, 24258,
     /* 1938394 */     GIR_EraseRootFromParent_Done,
     /* 1938395 */   // Label 26047: @1938395
     /* 1938395 */   GIM_Try, /*On fail goto*//*Label 26048*/ GIMT_Encode4(1938481), // Rule ID 24259 //
     /* 1938400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1938403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1938411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1938414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1938417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938446 */     // MIs[0] policy
     /* 1938446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938456 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1938459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938480 */     // GIR_Coverage, 24259,
     /* 1938480 */     GIR_EraseRootFromParent_Done,
     /* 1938481 */   // Label 26048: @1938481
     /* 1938481 */   GIM_Try, /*On fail goto*//*Label 26049*/ GIMT_Encode4(1938567), // Rule ID 24262 //
     /* 1938486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1938489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1938497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1938500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1938503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938532 */     // MIs[0] policy
     /* 1938532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938542 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1938545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938566 */     // GIR_Coverage, 24262,
     /* 1938566 */     GIR_EraseRootFromParent_Done,
     /* 1938567 */   // Label 26049: @1938567
     /* 1938567 */   GIM_Try, /*On fail goto*//*Label 26050*/ GIMT_Encode4(1938653), // Rule ID 24263 //
     /* 1938572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1938575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1938583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1938586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1938589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938618 */     // MIs[0] policy
     /* 1938618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938628 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1938631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938652 */     // GIR_Coverage, 24263,
     /* 1938652 */     GIR_EraseRootFromParent_Done,
     /* 1938653 */   // Label 26050: @1938653
     /* 1938653 */   GIM_Try, /*On fail goto*//*Label 26051*/ GIMT_Encode4(1938739), // Rule ID 24266 //
     /* 1938658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1938661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1938669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1938672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1938675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938704 */     // MIs[0] policy
     /* 1938704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938714 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1938717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938738 */     // GIR_Coverage, 24266,
     /* 1938738 */     GIR_EraseRootFromParent_Done,
     /* 1938739 */   // Label 26051: @1938739
     /* 1938739 */   GIM_Try, /*On fail goto*//*Label 26052*/ GIMT_Encode4(1938825), // Rule ID 24267 //
     /* 1938744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1938747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1938755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1938758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1938761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1938767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938790 */     // MIs[0] policy
     /* 1938790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938800 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1938803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938824 */     // GIR_Coverage, 24267,
     /* 1938824 */     GIR_EraseRootFromParent_Done,
     /* 1938825 */   // Label 26052: @1938825
     /* 1938825 */   GIM_Try, /*On fail goto*//*Label 26053*/ GIMT_Encode4(1938911), // Rule ID 24270 //
     /* 1938830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1938833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1938841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1938844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1938847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938876 */     // MIs[0] policy
     /* 1938876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938886 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1938889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938910 */     // GIR_Coverage, 24270,
     /* 1938910 */     GIR_EraseRootFromParent_Done,
     /* 1938911 */   // Label 26053: @1938911
     /* 1938911 */   GIM_Try, /*On fail goto*//*Label 26054*/ GIMT_Encode4(1938997), // Rule ID 24271 //
     /* 1938916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1938919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1938924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1938927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1938930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1938933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1938946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1938954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1938958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938962 */     // MIs[0] policy
     /* 1938962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938972 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1938975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1938979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938996 */     // GIR_Coverage, 24271,
     /* 1938996 */     GIR_EraseRootFromParent_Done,
     /* 1938997 */   // Label 26054: @1938997
     /* 1938997 */   GIM_Try, /*On fail goto*//*Label 26055*/ GIMT_Encode4(1939083), // Rule ID 24274 //
     /* 1939002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1939005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939048 */     // MIs[0] policy
     /* 1939048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939058 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939082 */     // GIR_Coverage, 24274,
     /* 1939082 */     GIR_EraseRootFromParent_Done,
     /* 1939083 */   // Label 26055: @1939083
     /* 1939083 */   GIM_Try, /*On fail goto*//*Label 26056*/ GIMT_Encode4(1939169), // Rule ID 24275 //
     /* 1939088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1939091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1939099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1939102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1939105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939134 */     // MIs[0] policy
     /* 1939134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939144 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939168 */     // GIR_Coverage, 24275,
     /* 1939168 */     GIR_EraseRootFromParent_Done,
     /* 1939169 */   // Label 26056: @1939169
     /* 1939169 */   GIM_Try, /*On fail goto*//*Label 26057*/ GIMT_Encode4(1939255), // Rule ID 24278 //
     /* 1939174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1939177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939220 */     // MIs[0] policy
     /* 1939220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939230 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939254 */     // GIR_Coverage, 24278,
     /* 1939254 */     GIR_EraseRootFromParent_Done,
     /* 1939255 */   // Label 26057: @1939255
     /* 1939255 */   GIM_Try, /*On fail goto*//*Label 26058*/ GIMT_Encode4(1939341), // Rule ID 24279 //
     /* 1939260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1939263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1939271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1939274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1939277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939306 */     // MIs[0] policy
     /* 1939306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939316 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1939319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939340 */     // GIR_Coverage, 24279,
     /* 1939340 */     GIR_EraseRootFromParent_Done,
     /* 1939341 */   // Label 26058: @1939341
     /* 1939341 */   GIM_Try, /*On fail goto*//*Label 26059*/ GIMT_Encode4(1939427), // Rule ID 24282 //
     /* 1939346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1939349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939392 */     // MIs[0] policy
     /* 1939392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939402 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939426 */     // GIR_Coverage, 24282,
     /* 1939426 */     GIR_EraseRootFromParent_Done,
     /* 1939427 */   // Label 26059: @1939427
     /* 1939427 */   GIM_Try, /*On fail goto*//*Label 26060*/ GIMT_Encode4(1939513), // Rule ID 24283 //
     /* 1939432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1939435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1939443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1939446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1939449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939478 */     // MIs[0] policy
     /* 1939478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939488 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939512 */     // GIR_Coverage, 24283,
     /* 1939512 */     GIR_EraseRootFromParent_Done,
     /* 1939513 */   // Label 26060: @1939513
     /* 1939513 */   GIM_Try, /*On fail goto*//*Label 26061*/ GIMT_Encode4(1939599), // Rule ID 24286 //
     /* 1939518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1939521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1939529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1939532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1939535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939564 */     // MIs[0] policy
     /* 1939564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1939577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939598 */     // GIR_Coverage, 24286,
     /* 1939598 */     GIR_EraseRootFromParent_Done,
     /* 1939599 */   // Label 26061: @1939599
     /* 1939599 */   GIM_Try, /*On fail goto*//*Label 26062*/ GIMT_Encode4(1939685), // Rule ID 24287 //
     /* 1939604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1939607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1939615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1939618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1939621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1939627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939650 */     // MIs[0] policy
     /* 1939650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939660 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1939663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939684 */     // GIR_Coverage, 24287,
     /* 1939684 */     GIR_EraseRootFromParent_Done,
     /* 1939685 */   // Label 26062: @1939685
     /* 1939685 */   GIM_Try, /*On fail goto*//*Label 26063*/ GIMT_Encode4(1939771), // Rule ID 24290 //
     /* 1939690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1939693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1939701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1939704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1939707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1939713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939736 */     // MIs[0] policy
     /* 1939736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939746 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1939749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939770 */     // GIR_Coverage, 24290,
     /* 1939770 */     GIR_EraseRootFromParent_Done,
     /* 1939771 */   // Label 26063: @1939771
     /* 1939771 */   GIM_Try, /*On fail goto*//*Label 26064*/ GIMT_Encode4(1939857), // Rule ID 24291 //
     /* 1939776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1939779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1939787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1939790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1939793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1939799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939822 */     // MIs[0] policy
     /* 1939822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939832 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1939835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1939853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939856 */     // GIR_Coverage, 24291,
     /* 1939856 */     GIR_EraseRootFromParent_Done,
     /* 1939857 */   // Label 26064: @1939857
     /* 1939857 */   GIM_Try, /*On fail goto*//*Label 26065*/ GIMT_Encode4(1939943), // Rule ID 24294 //
     /* 1939862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1939865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1939873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1939876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1939879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939908 */     // MIs[0] policy
     /* 1939908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939918 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1939921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1939925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1939939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939942 */     // GIR_Coverage, 24294,
     /* 1939942 */     GIR_EraseRootFromParent_Done,
     /* 1939943 */   // Label 26065: @1939943
     /* 1939943 */   GIM_Try, /*On fail goto*//*Label 26066*/ GIMT_Encode4(1940029), // Rule ID 24295 //
     /* 1939948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1939951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1939956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1939959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1939962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1939965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1939968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1939990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939994 */     // MIs[0] policy
     /* 1939994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940004 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940028 */     // GIR_Coverage, 24295,
     /* 1940028 */     GIR_EraseRootFromParent_Done,
     /* 1940029 */   // Label 26066: @1940029
     /* 1940029 */   GIM_Try, /*On fail goto*//*Label 26067*/ GIMT_Encode4(1940115), // Rule ID 24298 //
     /* 1940034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1940037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940080 */     // MIs[0] policy
     /* 1940080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940090 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940114 */     // GIR_Coverage, 24298,
     /* 1940114 */     GIR_EraseRootFromParent_Done,
     /* 1940115 */   // Label 26067: @1940115
     /* 1940115 */   GIM_Try, /*On fail goto*//*Label 26068*/ GIMT_Encode4(1940201), // Rule ID 24299 //
     /* 1940120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1940123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1940131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1940134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1940137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940166 */     // MIs[0] policy
     /* 1940166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940176 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940200 */     // GIR_Coverage, 24299,
     /* 1940200 */     GIR_EraseRootFromParent_Done,
     /* 1940201 */   // Label 26068: @1940201
     /* 1940201 */   GIM_Try, /*On fail goto*//*Label 26069*/ GIMT_Encode4(1940287), // Rule ID 24302 //
     /* 1940206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1940209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940252 */     // MIs[0] policy
     /* 1940252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940262 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940286 */     // GIR_Coverage, 24302,
     /* 1940286 */     GIR_EraseRootFromParent_Done,
     /* 1940287 */   // Label 26069: @1940287
     /* 1940287 */   GIM_Try, /*On fail goto*//*Label 26070*/ GIMT_Encode4(1940373), // Rule ID 24303 //
     /* 1940292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1940295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1940303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1940306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1940309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1940315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940338 */     // MIs[0] policy
     /* 1940338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940348 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940372 */     // GIR_Coverage, 24303,
     /* 1940372 */     GIR_EraseRootFromParent_Done,
     /* 1940373 */   // Label 26070: @1940373
     /* 1940373 */   GIM_Try, /*On fail goto*//*Label 26071*/ GIMT_Encode4(1940459), // Rule ID 24306 //
     /* 1940378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1940381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940424 */     // MIs[0] policy
     /* 1940424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940434 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940458 */     // GIR_Coverage, 24306,
     /* 1940458 */     GIR_EraseRootFromParent_Done,
     /* 1940459 */   // Label 26071: @1940459
     /* 1940459 */   GIM_Try, /*On fail goto*//*Label 26072*/ GIMT_Encode4(1940545), // Rule ID 24307 //
     /* 1940464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1940467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1940475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1940478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1940481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1940494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1940502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940510 */     // MIs[0] policy
     /* 1940510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940520 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1940523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940544 */     // GIR_Coverage, 24307,
     /* 1940544 */     GIR_EraseRootFromParent_Done,
     /* 1940545 */   // Label 26072: @1940545
     /* 1940545 */   GIM_Try, /*On fail goto*//*Label 26073*/ GIMT_Encode4(1940631), // Rule ID 24310 //
     /* 1940550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1940553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1940561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1940564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1940567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940596 */     // MIs[0] policy
     /* 1940596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940606 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940630 */     // GIR_Coverage, 24310,
     /* 1940630 */     GIR_EraseRootFromParent_Done,
     /* 1940631 */   // Label 26073: @1940631
     /* 1940631 */   GIM_Try, /*On fail goto*//*Label 26074*/ GIMT_Encode4(1940717), // Rule ID 24311 //
     /* 1940636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1940639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1940647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1940650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1940653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1940666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1940674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940682 */     // MIs[0] policy
     /* 1940682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940692 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1940695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940716 */     // GIR_Coverage, 24311,
     /* 1940716 */     GIR_EraseRootFromParent_Done,
     /* 1940717 */   // Label 26074: @1940717
     /* 1940717 */   GIM_Try, /*On fail goto*//*Label 26075*/ GIMT_Encode4(1940803), // Rule ID 24314 //
     /* 1940722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1940725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1940733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1940736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1940739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1940742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940768 */     // MIs[0] policy
     /* 1940768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940778 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940802 */     // GIR_Coverage, 24314,
     /* 1940802 */     GIR_EraseRootFromParent_Done,
     /* 1940803 */   // Label 26075: @1940803
     /* 1940803 */   GIM_Try, /*On fail goto*//*Label 26076*/ GIMT_Encode4(1940889), // Rule ID 24315 //
     /* 1940808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1940811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1940816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1940819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1940822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1940825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1940828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1940838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1940846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1940850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940854 */     // MIs[0] policy
     /* 1940854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940864 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1940867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1940871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1940885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940888 */     // GIR_Coverage, 24315,
     /* 1940888 */     GIR_EraseRootFromParent_Done,
     /* 1940889 */   // Label 26076: @1940889
     /* 1940889 */   GIM_Try, /*On fail goto*//*Label 26077*/ GIMT_Encode4(1940975), // Rule ID 24378 //
     /* 1940894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1940897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1940905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1940908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1940911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1940914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1940917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1940936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940940 */     // MIs[0] policy
     /* 1940940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940950 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1940953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940974 */     // GIR_Coverage, 24378,
     /* 1940974 */     GIR_EraseRootFromParent_Done,
     /* 1940975 */   // Label 26077: @1940975
     /* 1940975 */   GIM_Try, /*On fail goto*//*Label 26078*/ GIMT_Encode4(1941061), // Rule ID 24379 //
     /* 1940980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1940983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1940988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1940991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1940994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1940997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941026 */     // MIs[0] policy
     /* 1941026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941036 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1941039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941060 */     // GIR_Coverage, 24379,
     /* 1941060 */     GIR_EraseRootFromParent_Done,
     /* 1941061 */   // Label 26078: @1941061
     /* 1941061 */   GIM_Try, /*On fail goto*//*Label 26079*/ GIMT_Encode4(1941147), // Rule ID 24382 //
     /* 1941066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941112 */     // MIs[0] policy
     /* 1941112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941122 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1941125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941146 */     // GIR_Coverage, 24382,
     /* 1941146 */     GIR_EraseRootFromParent_Done,
     /* 1941147 */   // Label 26079: @1941147
     /* 1941147 */   GIM_Try, /*On fail goto*//*Label 26080*/ GIMT_Encode4(1941233), // Rule ID 24383 //
     /* 1941152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1941163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1941166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1941169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941198 */     // MIs[0] policy
     /* 1941198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941208 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1941211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941232 */     // GIR_Coverage, 24383,
     /* 1941232 */     GIR_EraseRootFromParent_Done,
     /* 1941233 */   // Label 26080: @1941233
     /* 1941233 */   GIM_Try, /*On fail goto*//*Label 26081*/ GIMT_Encode4(1941319), // Rule ID 24386 //
     /* 1941238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941284 */     // MIs[0] policy
     /* 1941284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941294 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1941297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941318 */     // GIR_Coverage, 24386,
     /* 1941318 */     GIR_EraseRootFromParent_Done,
     /* 1941319 */   // Label 26081: @1941319
     /* 1941319 */   GIM_Try, /*On fail goto*//*Label 26082*/ GIMT_Encode4(1941405), // Rule ID 24387 //
     /* 1941324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1941335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1941338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1941341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941370 */     // MIs[0] policy
     /* 1941370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941380 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1941383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941404 */     // GIR_Coverage, 24387,
     /* 1941404 */     GIR_EraseRootFromParent_Done,
     /* 1941405 */   // Label 26082: @1941405
     /* 1941405 */   GIM_Try, /*On fail goto*//*Label 26083*/ GIMT_Encode4(1941491), // Rule ID 24390 //
     /* 1941410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941456 */     // MIs[0] policy
     /* 1941456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941466 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1941469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941490 */     // GIR_Coverage, 24390,
     /* 1941490 */     GIR_EraseRootFromParent_Done,
     /* 1941491 */   // Label 26083: @1941491
     /* 1941491 */   GIM_Try, /*On fail goto*//*Label 26084*/ GIMT_Encode4(1941577), // Rule ID 24391 //
     /* 1941496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1941499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1941507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1941510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1941513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1941519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941542 */     // MIs[0] policy
     /* 1941542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941552 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11274:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1941555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941576 */     // GIR_Coverage, 24391,
     /* 1941576 */     GIR_EraseRootFromParent_Done,
     /* 1941577 */   // Label 26084: @1941577
     /* 1941577 */   GIM_Try, /*On fail goto*//*Label 26085*/ GIMT_Encode4(1941663), // Rule ID 24394 //
     /* 1941582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1941585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1941593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1941596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1941599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941628 */     // MIs[0] policy
     /* 1941628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941638 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1941641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941662 */     // GIR_Coverage, 24394,
     /* 1941662 */     GIR_EraseRootFromParent_Done,
     /* 1941663 */   // Label 26085: @1941663
     /* 1941663 */   GIM_Try, /*On fail goto*//*Label 26086*/ GIMT_Encode4(1941749), // Rule ID 24395 //
     /* 1941668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1941671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1941679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1941682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1941685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1941688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1941691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1941710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941714 */     // MIs[0] policy
     /* 1941714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941724 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11274:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1941727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941748 */     // GIR_Coverage, 24395,
     /* 1941748 */     GIR_EraseRootFromParent_Done,
     /* 1941749 */   // Label 26086: @1941749
     /* 1941749 */   GIM_Try, /*On fail goto*//*Label 26087*/ GIMT_Encode4(1941835), // Rule ID 24398 //
     /* 1941754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1941757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1941765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1941768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1941771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1941796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941800 */     // MIs[0] policy
     /* 1941800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941810 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1941813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941834 */     // GIR_Coverage, 24398,
     /* 1941834 */     GIR_EraseRootFromParent_Done,
     /* 1941835 */   // Label 26087: @1941835
     /* 1941835 */   GIM_Try, /*On fail goto*//*Label 26088*/ GIMT_Encode4(1941921), // Rule ID 24399 //
     /* 1941840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1941843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1941851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1941854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1941857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1941860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1941882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941886 */     // MIs[0] policy
     /* 1941886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941896 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11274:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1941899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941920 */     // GIR_Coverage, 24399,
     /* 1941920 */     GIR_EraseRootFromParent_Done,
     /* 1941921 */   // Label 26088: @1941921
     /* 1941921 */   GIM_Try, /*On fail goto*//*Label 26089*/ GIMT_Encode4(1942007), // Rule ID 24402 //
     /* 1941926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1941929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1941934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1941937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1941940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1941943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1941946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1941968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941972 */     // MIs[0] policy
     /* 1941972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941982 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1941985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942006 */     // GIR_Coverage, 24402,
     /* 1942006 */     GIR_EraseRootFromParent_Done,
     /* 1942007 */   // Label 26089: @1942007
     /* 1942007 */   GIM_Try, /*On fail goto*//*Label 26090*/ GIMT_Encode4(1942093), // Rule ID 24403 //
     /* 1942012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1942023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1942026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1942029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942058 */     // MIs[0] policy
     /* 1942058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942068 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1942071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942092 */     // GIR_Coverage, 24403,
     /* 1942092 */     GIR_EraseRootFromParent_Done,
     /* 1942093 */   // Label 26090: @1942093
     /* 1942093 */   GIM_Try, /*On fail goto*//*Label 26091*/ GIMT_Encode4(1942179), // Rule ID 24406 //
     /* 1942098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942144 */     // MIs[0] policy
     /* 1942144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942154 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1942157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942178 */     // GIR_Coverage, 24406,
     /* 1942178 */     GIR_EraseRootFromParent_Done,
     /* 1942179 */   // Label 26091: @1942179
     /* 1942179 */   GIM_Try, /*On fail goto*//*Label 26092*/ GIMT_Encode4(1942265), // Rule ID 24407 //
     /* 1942184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1942195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1942198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1942201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942230 */     // MIs[0] policy
     /* 1942230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942240 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1942243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942264 */     // GIR_Coverage, 24407,
     /* 1942264 */     GIR_EraseRootFromParent_Done,
     /* 1942265 */   // Label 26092: @1942265
     /* 1942265 */   GIM_Try, /*On fail goto*//*Label 26093*/ GIMT_Encode4(1942351), // Rule ID 24410 //
     /* 1942270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1942273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942316 */     // MIs[0] policy
     /* 1942316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942326 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1942329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942350 */     // GIR_Coverage, 24410,
     /* 1942350 */     GIR_EraseRootFromParent_Done,
     /* 1942351 */   // Label 26093: @1942351
     /* 1942351 */   GIM_Try, /*On fail goto*//*Label 26094*/ GIMT_Encode4(1942437), // Rule ID 24411 //
     /* 1942356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1942359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1942376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1942398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942402 */     // MIs[0] policy
     /* 1942402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942412 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1942415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942436 */     // GIR_Coverage, 24411,
     /* 1942436 */     GIR_EraseRootFromParent_Done,
     /* 1942437 */   // Label 26094: @1942437
     /* 1942437 */   GIM_Try, /*On fail goto*//*Label 26095*/ GIMT_Encode4(1942523), // Rule ID 24414 //
     /* 1942442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942488 */     // MIs[0] policy
     /* 1942488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942498 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1942501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942522 */     // GIR_Coverage, 24414,
     /* 1942522 */     GIR_EraseRootFromParent_Done,
     /* 1942523 */   // Label 26095: @1942523
     /* 1942523 */   GIM_Try, /*On fail goto*//*Label 26096*/ GIMT_Encode4(1942609), // Rule ID 24415 //
     /* 1942528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942574 */     // MIs[0] policy
     /* 1942574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942584 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1942587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942608 */     // GIR_Coverage, 24415,
     /* 1942608 */     GIR_EraseRootFromParent_Done,
     /* 1942609 */   // Label 26096: @1942609
     /* 1942609 */   GIM_Try, /*On fail goto*//*Label 26097*/ GIMT_Encode4(1942695), // Rule ID 24418 //
     /* 1942614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1942625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1942628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1942631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942660 */     // MIs[0] policy
     /* 1942660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942670 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1942673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942694 */     // GIR_Coverage, 24418,
     /* 1942694 */     GIR_EraseRootFromParent_Done,
     /* 1942695 */   // Label 26097: @1942695
     /* 1942695 */   GIM_Try, /*On fail goto*//*Label 26098*/ GIMT_Encode4(1942781), // Rule ID 24419 //
     /* 1942700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1942711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1942714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1942717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942746 */     // MIs[0] policy
     /* 1942746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942756 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1942759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942780 */     // GIR_Coverage, 24419,
     /* 1942780 */     GIR_EraseRootFromParent_Done,
     /* 1942781 */   // Label 26098: @1942781
     /* 1942781 */   GIM_Try, /*On fail goto*//*Label 26099*/ GIMT_Encode4(1942867), // Rule ID 24422 //
     /* 1942786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1942789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1942797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1942800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1942803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942832 */     // MIs[0] policy
     /* 1942832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942842 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1942845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942866 */     // GIR_Coverage, 24422,
     /* 1942866 */     GIR_EraseRootFromParent_Done,
     /* 1942867 */   // Label 26099: @1942867
     /* 1942867 */   GIM_Try, /*On fail goto*//*Label 26100*/ GIMT_Encode4(1942953), // Rule ID 24423 //
     /* 1942872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1942875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1942883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1942886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1942889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1942892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1942914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942918 */     // MIs[0] policy
     /* 1942918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942928 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1942931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942952 */     // GIR_Coverage, 24423,
     /* 1942952 */     GIR_EraseRootFromParent_Done,
     /* 1942953 */   // Label 26100: @1942953
     /* 1942953 */   GIM_Try, /*On fail goto*//*Label 26101*/ GIMT_Encode4(1943039), // Rule ID 24426 //
     /* 1942958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1942961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1942966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1942969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1942972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1942975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1942978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943004 */     // MIs[0] policy
     /* 1943004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1943017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943038 */     // GIR_Coverage, 24426,
     /* 1943038 */     GIR_EraseRootFromParent_Done,
     /* 1943039 */   // Label 26101: @1943039
     /* 1943039 */   GIM_Try, /*On fail goto*//*Label 26102*/ GIMT_Encode4(1943125), // Rule ID 24427 //
     /* 1943044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1943055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1943058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1943061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1943074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1943082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943090 */     // MIs[0] policy
     /* 1943090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11274:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1943103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943124 */     // GIR_Coverage, 24427,
     /* 1943124 */     GIR_EraseRootFromParent_Done,
     /* 1943125 */   // Label 26102: @1943125
     /* 1943125 */   GIM_Try, /*On fail goto*//*Label 26103*/ GIMT_Encode4(1943211), // Rule ID 24430 //
     /* 1943130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943176 */     // MIs[0] policy
     /* 1943176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943186 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1943189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943210 */     // GIR_Coverage, 24430,
     /* 1943210 */     GIR_EraseRootFromParent_Done,
     /* 1943211 */   // Label 26103: @1943211
     /* 1943211 */   GIM_Try, /*On fail goto*//*Label 26104*/ GIMT_Encode4(1943297), // Rule ID 24431 //
     /* 1943216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943262 */     // MIs[0] policy
     /* 1943262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943272 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11274:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1943275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943296 */     // GIR_Coverage, 24431,
     /* 1943296 */     GIR_EraseRootFromParent_Done,
     /* 1943297 */   // Label 26104: @1943297
     /* 1943297 */   GIM_Try, /*On fail goto*//*Label 26105*/ GIMT_Encode4(1943383), // Rule ID 24434 //
     /* 1943302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1943305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943348 */     // MIs[0] policy
     /* 1943348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943358 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1943361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943382 */     // GIR_Coverage, 24434,
     /* 1943382 */     GIR_EraseRootFromParent_Done,
     /* 1943383 */   // Label 26105: @1943383
     /* 1943383 */   GIM_Try, /*On fail goto*//*Label 26106*/ GIMT_Encode4(1943469), // Rule ID 24435 //
     /* 1943388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1943391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1943396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1943430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943434 */     // MIs[0] policy
     /* 1943434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943444 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11274:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1943447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943468 */     // GIR_Coverage, 24435,
     /* 1943468 */     GIR_EraseRootFromParent_Done,
     /* 1943469 */   // Label 26106: @1943469
     /* 1943469 */   GIM_Try, /*On fail goto*//*Label 26107*/ GIMT_Encode4(1943555), // Rule ID 24438 //
     /* 1943474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1943485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1943488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1943491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943520 */     // MIs[0] policy
     /* 1943520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943530 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1943533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943554 */     // GIR_Coverage, 24438,
     /* 1943554 */     GIR_EraseRootFromParent_Done,
     /* 1943555 */   // Label 26107: @1943555
     /* 1943555 */   GIM_Try, /*On fail goto*//*Label 26108*/ GIMT_Encode4(1943641), // Rule ID 24439 //
     /* 1943560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1943563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1943571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1943574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1943577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943606 */     // MIs[0] policy
     /* 1943606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943616 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1943619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943640 */     // GIR_Coverage, 24439,
     /* 1943640 */     GIR_EraseRootFromParent_Done,
     /* 1943641 */   // Label 26108: @1943641
     /* 1943641 */   GIM_Try, /*On fail goto*//*Label 26109*/ GIMT_Encode4(1943727), // Rule ID 24442 //
     /* 1943646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1943657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1943660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1943663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943692 */     // MIs[0] policy
     /* 1943692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943702 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1943705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943726 */     // GIR_Coverage, 24442,
     /* 1943726 */     GIR_EraseRootFromParent_Done,
     /* 1943727 */   // Label 26109: @1943727
     /* 1943727 */   GIM_Try, /*On fail goto*//*Label 26110*/ GIMT_Encode4(1943813), // Rule ID 24443 //
     /* 1943732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1943735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1943743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1943746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1943749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1943752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1943774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943778 */     // MIs[0] policy
     /* 1943778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943788 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1943791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943812 */     // GIR_Coverage, 24443,
     /* 1943812 */     GIR_EraseRootFromParent_Done,
     /* 1943813 */   // Label 26110: @1943813
     /* 1943813 */   GIM_Try, /*On fail goto*//*Label 26111*/ GIMT_Encode4(1943899), // Rule ID 24446 //
     /* 1943818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1943821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1943829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1943832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1943835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943864 */     // MIs[0] policy
     /* 1943864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943874 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1943877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943898 */     // GIR_Coverage, 24446,
     /* 1943898 */     GIR_EraseRootFromParent_Done,
     /* 1943899 */   // Label 26111: @1943899
     /* 1943899 */   GIM_Try, /*On fail goto*//*Label 26112*/ GIMT_Encode4(1943985), // Rule ID 24447 //
     /* 1943904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1943907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1943915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1943918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1943921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1943946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943950 */     // MIs[0] policy
     /* 1943950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943960 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1943963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1943981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943984 */     // GIR_Coverage, 24447,
     /* 1943984 */     GIR_EraseRootFromParent_Done,
     /* 1943985 */   // Label 26112: @1943985
     /* 1943985 */   GIM_Try, /*On fail goto*//*Label 26113*/ GIMT_Encode4(1944071), // Rule ID 24450 //
     /* 1943990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1943993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1943998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944036 */     // MIs[0] policy
     /* 1944036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944046 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1944049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944070 */     // GIR_Coverage, 24450,
     /* 1944070 */     GIR_EraseRootFromParent_Done,
     /* 1944071 */   // Label 26113: @1944071
     /* 1944071 */   GIM_Try, /*On fail goto*//*Label 26114*/ GIMT_Encode4(1944157), // Rule ID 24451 //
     /* 1944076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944122 */     // MIs[0] policy
     /* 1944122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944132 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11272:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1944135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944156 */     // GIR_Coverage, 24451,
     /* 1944156 */     GIR_EraseRootFromParent_Done,
     /* 1944157 */   // Label 26114: @1944157
     /* 1944157 */   GIM_Try, /*On fail goto*//*Label 26115*/ GIMT_Encode4(1944243), // Rule ID 24454 //
     /* 1944162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1944165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944208 */     // MIs[0] policy
     /* 1944208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944218 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1944221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944242 */     // GIR_Coverage, 24454,
     /* 1944242 */     GIR_EraseRootFromParent_Done,
     /* 1944243 */   // Label 26115: @1944243
     /* 1944243 */   GIM_Try, /*On fail goto*//*Label 26116*/ GIMT_Encode4(1944329), // Rule ID 24455 //
     /* 1944248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1944251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1944290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944294 */     // MIs[0] policy
     /* 1944294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944304 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11272:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1944307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944328 */     // GIR_Coverage, 24455,
     /* 1944328 */     GIR_EraseRootFromParent_Done,
     /* 1944329 */   // Label 26116: @1944329
     /* 1944329 */   GIM_Try, /*On fail goto*//*Label 26117*/ GIMT_Encode4(1944415), // Rule ID 24458 //
     /* 1944334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1944337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1944376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944380 */     // MIs[0] policy
     /* 1944380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944390 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1944393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944414 */     // GIR_Coverage, 24458,
     /* 1944414 */     GIR_EraseRootFromParent_Done,
     /* 1944415 */   // Label 26117: @1944415
     /* 1944415 */   GIM_Try, /*On fail goto*//*Label 26118*/ GIMT_Encode4(1944501), // Rule ID 24459 //
     /* 1944420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1944423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1944462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944466 */     // MIs[0] policy
     /* 1944466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944476 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11272:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1944479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944500 */     // GIR_Coverage, 24459,
     /* 1944500 */     GIR_EraseRootFromParent_Done,
     /* 1944501 */   // Label 26118: @1944501
     /* 1944501 */   GIM_Try, /*On fail goto*//*Label 26119*/ GIMT_Encode4(1944587), // Rule ID 24462 //
     /* 1944506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1944517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1944520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1944523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944552 */     // MIs[0] policy
     /* 1944552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944562 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1944565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944586 */     // GIR_Coverage, 24462,
     /* 1944586 */     GIR_EraseRootFromParent_Done,
     /* 1944587 */   // Label 26119: @1944587
     /* 1944587 */   GIM_Try, /*On fail goto*//*Label 26120*/ GIMT_Encode4(1944673), // Rule ID 24463 //
     /* 1944592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1944603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1944606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1944609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1944622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1944630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944638 */     // MIs[0] policy
     /* 1944638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944648 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1944651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944672 */     // GIR_Coverage, 24463,
     /* 1944672 */     GIR_EraseRootFromParent_Done,
     /* 1944673 */   // Label 26120: @1944673
     /* 1944673 */   GIM_Try, /*On fail goto*//*Label 26121*/ GIMT_Encode4(1944759), // Rule ID 24466 //
     /* 1944678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1944689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1944692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1944695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1944701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944724 */     // MIs[0] policy
     /* 1944724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944734 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1944737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944758 */     // GIR_Coverage, 24466,
     /* 1944758 */     GIR_EraseRootFromParent_Done,
     /* 1944759 */   // Label 26121: @1944759
     /* 1944759 */   GIM_Try, /*On fail goto*//*Label 26122*/ GIMT_Encode4(1944845), // Rule ID 24467 //
     /* 1944764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1944775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1944778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1944781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1944787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1944794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1944802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944810 */     // MIs[0] policy
     /* 1944810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944820 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1944823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944844 */     // GIR_Coverage, 24467,
     /* 1944844 */     GIR_EraseRootFromParent_Done,
     /* 1944845 */   // Label 26122: @1944845
     /* 1944845 */   GIM_Try, /*On fail goto*//*Label 26123*/ GIMT_Encode4(1944931), // Rule ID 24470 //
     /* 1944850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1944853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1944861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1944864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1944867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1944873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944896 */     // MIs[0] policy
     /* 1944896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944906 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1944909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944930 */     // GIR_Coverage, 24470,
     /* 1944930 */     GIR_EraseRootFromParent_Done,
     /* 1944931 */   // Label 26123: @1944931
     /* 1944931 */   GIM_Try, /*On fail goto*//*Label 26124*/ GIMT_Encode4(1945017), // Rule ID 24471 //
     /* 1944936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1944939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1944944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1944947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1944950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1944953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1944956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1944959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1944966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1944974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1944978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944982 */     // MIs[0] policy
     /* 1944982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944992 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1944995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945016 */     // GIR_Coverage, 24471,
     /* 1945016 */     GIR_EraseRootFromParent_Done,
     /* 1945017 */   // Label 26124: @1945017
     /* 1945017 */   GIM_Try, /*On fail goto*//*Label 26125*/ GIMT_Encode4(1945103), // Rule ID 24474 //
     /* 1945022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1945033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1945036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1945039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945068 */     // MIs[0] policy
     /* 1945068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945078 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1945081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945102 */     // GIR_Coverage, 24474,
     /* 1945102 */     GIR_EraseRootFromParent_Done,
     /* 1945103 */   // Label 26125: @1945103
     /* 1945103 */   GIM_Try, /*On fail goto*//*Label 26126*/ GIMT_Encode4(1945189), // Rule ID 24475 //
     /* 1945108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1945119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1945122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1945125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945154 */     // MIs[0] policy
     /* 1945154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945164 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1945167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945188 */     // GIR_Coverage, 24475,
     /* 1945188 */     GIR_EraseRootFromParent_Done,
     /* 1945189 */   // Label 26126: @1945189
     /* 1945189 */   GIM_Try, /*On fail goto*//*Label 26127*/ GIMT_Encode4(1945275), // Rule ID 24478 //
     /* 1945194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1945205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1945208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1945211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945240 */     // MIs[0] policy
     /* 1945240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945250 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1945253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945274 */     // GIR_Coverage, 24478,
     /* 1945274 */     GIR_EraseRootFromParent_Done,
     /* 1945275 */   // Label 26127: @1945275
     /* 1945275 */   GIM_Try, /*On fail goto*//*Label 26128*/ GIMT_Encode4(1945361), // Rule ID 24479 //
     /* 1945280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1945291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1945294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1945297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945326 */     // MIs[0] policy
     /* 1945326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945336 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1945339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945360 */     // GIR_Coverage, 24479,
     /* 1945360 */     GIR_EraseRootFromParent_Done,
     /* 1945361 */   // Label 26128: @1945361
     /* 1945361 */   GIM_Try, /*On fail goto*//*Label 26129*/ GIMT_Encode4(1945447), // Rule ID 24482 //
     /* 1945366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1945369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1945377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1945380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1945383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945412 */     // MIs[0] policy
     /* 1945412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945422 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1945425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945446 */     // GIR_Coverage, 24482,
     /* 1945446 */     GIR_EraseRootFromParent_Done,
     /* 1945447 */   // Label 26129: @1945447
     /* 1945447 */   GIM_Try, /*On fail goto*//*Label 26130*/ GIMT_Encode4(1945533), // Rule ID 24483 //
     /* 1945452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1945455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1945463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1945466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1945469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1945494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945498 */     // MIs[0] policy
     /* 1945498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945508 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1945511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1945529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945532 */     // GIR_Coverage, 24483,
     /* 1945532 */     GIR_EraseRootFromParent_Done,
     /* 1945533 */   // Label 26130: @1945533
     /* 1945533 */   GIM_Try, /*On fail goto*//*Label 26131*/ GIMT_Encode4(1945619), // Rule ID 24486 //
     /* 1945538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1945541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1945549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1945552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1945555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945584 */     // MIs[0] policy
     /* 1945584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945594 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1945597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945618 */     // GIR_Coverage, 24486,
     /* 1945618 */     GIR_EraseRootFromParent_Done,
     /* 1945619 */   // Label 26131: @1945619
     /* 1945619 */   GIM_Try, /*On fail goto*//*Label 26132*/ GIMT_Encode4(1945705), // Rule ID 24487 //
     /* 1945624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1945627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1945635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1945638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1945641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1945647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945670 */     // MIs[0] policy
     /* 1945670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945680 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11272:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1945683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945704 */     // GIR_Coverage, 24487,
     /* 1945704 */     GIR_EraseRootFromParent_Done,
     /* 1945705 */   // Label 26132: @1945705
     /* 1945705 */   GIM_Try, /*On fail goto*//*Label 26133*/ GIMT_Encode4(1945791), // Rule ID 24490 //
     /* 1945710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1945713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1945721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1945724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1945727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945756 */     // MIs[0] policy
     /* 1945756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945766 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1945769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945790 */     // GIR_Coverage, 24490,
     /* 1945790 */     GIR_EraseRootFromParent_Done,
     /* 1945791 */   // Label 26133: @1945791
     /* 1945791 */   GIM_Try, /*On fail goto*//*Label 26134*/ GIMT_Encode4(1945877), // Rule ID 24491 //
     /* 1945796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1945799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1945807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1945810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1945813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1945819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945842 */     // MIs[0] policy
     /* 1945842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11272:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1945855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945876 */     // GIR_Coverage, 24491,
     /* 1945876 */     GIR_EraseRootFromParent_Done,
     /* 1945877 */   // Label 26134: @1945877
     /* 1945877 */   GIM_Try, /*On fail goto*//*Label 26135*/ GIMT_Encode4(1945963), // Rule ID 24494 //
     /* 1945882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1945885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1945893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1945896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1945899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1945924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945928 */     // MIs[0] policy
     /* 1945928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945938 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1945941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1945959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945962 */     // GIR_Coverage, 24494,
     /* 1945962 */     GIR_EraseRootFromParent_Done,
     /* 1945963 */   // Label 26135: @1945963
     /* 1945963 */   GIM_Try, /*On fail goto*//*Label 26136*/ GIMT_Encode4(1946049), // Rule ID 24495 //
     /* 1945968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1945971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1945976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1945979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1945982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1945985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1946010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946014 */     // MIs[0] policy
     /* 1946014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946024 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11272:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1946027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946048 */     // GIR_Coverage, 24495,
     /* 1946048 */     GIR_EraseRootFromParent_Done,
     /* 1946049 */   // Label 26136: @1946049
     /* 1946049 */   GIM_Try, /*On fail goto*//*Label 26137*/ GIMT_Encode4(1946135), // Rule ID 24498 //
     /* 1946054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1946065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1946068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1946071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1946074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946100 */     // MIs[0] policy
     /* 1946100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946110 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1946113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946134 */     // GIR_Coverage, 24498,
     /* 1946134 */     GIR_EraseRootFromParent_Done,
     /* 1946135 */   // Label 26137: @1946135
     /* 1946135 */   GIM_Try, /*On fail goto*//*Label 26138*/ GIMT_Encode4(1946221), // Rule ID 24499 //
     /* 1946140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1946151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1946154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1946157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1946160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946186 */     // MIs[0] policy
     /* 1946186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946196 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1946199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946220 */     // GIR_Coverage, 24499,
     /* 1946220 */     GIR_EraseRootFromParent_Done,
     /* 1946221 */   // Label 26138: @1946221
     /* 1946221 */   GIM_Try, /*On fail goto*//*Label 26139*/ GIMT_Encode4(1946307), // Rule ID 24502 //
     /* 1946226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1946237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1946240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1946243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1946246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946272 */     // MIs[0] policy
     /* 1946272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946282 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1946285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946306 */     // GIR_Coverage, 24502,
     /* 1946306 */     GIR_EraseRootFromParent_Done,
     /* 1946307 */   // Label 26139: @1946307
     /* 1946307 */   GIM_Try, /*On fail goto*//*Label 26140*/ GIMT_Encode4(1946393), // Rule ID 24503 //
     /* 1946312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1946323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1946326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1946329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1946332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946358 */     // MIs[0] policy
     /* 1946358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946368 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1946371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946392 */     // GIR_Coverage, 24503,
     /* 1946392 */     GIR_EraseRootFromParent_Done,
     /* 1946393 */   // Label 26140: @1946393
     /* 1946393 */   GIM_Try, /*On fail goto*//*Label 26141*/ GIMT_Encode4(1946479), // Rule ID 24506 //
     /* 1946398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1946409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1946412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1946415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1946418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946444 */     // MIs[0] policy
     /* 1946444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946454 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1946457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946478 */     // GIR_Coverage, 24506,
     /* 1946478 */     GIR_EraseRootFromParent_Done,
     /* 1946479 */   // Label 26141: @1946479
     /* 1946479 */   GIM_Try, /*On fail goto*//*Label 26142*/ GIMT_Encode4(1946565), // Rule ID 24507 //
     /* 1946484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1946495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1946498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1946501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1946504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946530 */     // MIs[0] policy
     /* 1946530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946540 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1946543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1946561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946564 */     // GIR_Coverage, 24507,
     /* 1946564 */     GIR_EraseRootFromParent_Done,
     /* 1946565 */   // Label 26142: @1946565
     /* 1946565 */   GIM_Try, /*On fail goto*//*Label 26143*/ GIMT_Encode4(1946651), // Rule ID 24510 //
     /* 1946570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1946581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1946584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1946587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1946590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946616 */     // MIs[0] policy
     /* 1946616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1946629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946650 */     // GIR_Coverage, 24510,
     /* 1946650 */     GIR_EraseRootFromParent_Done,
     /* 1946651 */   // Label 26143: @1946651
     /* 1946651 */   GIM_Try, /*On fail goto*//*Label 26144*/ GIMT_Encode4(1946737), // Rule ID 24511 //
     /* 1946656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1946667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1946670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1946673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1946676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946702 */     // MIs[0] policy
     /* 1946702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1946715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946736 */     // GIR_Coverage, 24511,
     /* 1946736 */     GIR_EraseRootFromParent_Done,
     /* 1946737 */   // Label 26144: @1946737
     /* 1946737 */   GIM_Try, /*On fail goto*//*Label 26145*/ GIMT_Encode4(1946823), // Rule ID 24514 //
     /* 1946742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1946753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1946756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1946759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1946762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946788 */     // MIs[0] policy
     /* 1946788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946798 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1946801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946822 */     // GIR_Coverage, 24514,
     /* 1946822 */     GIR_EraseRootFromParent_Done,
     /* 1946823 */   // Label 26145: @1946823
     /* 1946823 */   GIM_Try, /*On fail goto*//*Label 26146*/ GIMT_Encode4(1946909), // Rule ID 24515 //
     /* 1946828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1946839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1946842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1946845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1946848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946874 */     // MIs[0] policy
     /* 1946874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1946887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1946905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946908 */     // GIR_Coverage, 24515,
     /* 1946908 */     GIR_EraseRootFromParent_Done,
     /* 1946909 */   // Label 26146: @1946909
     /* 1946909 */   GIM_Try, /*On fail goto*//*Label 26147*/ GIMT_Encode4(1946995), // Rule ID 24518 //
     /* 1946914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1946922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1946925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1946928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1946931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1946934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1946937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1946944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1946956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946960 */     // MIs[0] policy
     /* 1946960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946970 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1946973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946994 */     // GIR_Coverage, 24518,
     /* 1946994 */     GIR_EraseRootFromParent_Done,
     /* 1946995 */   // Label 26147: @1946995
     /* 1946995 */   GIM_Try, /*On fail goto*//*Label 26148*/ GIMT_Encode4(1947081), // Rule ID 24519 //
     /* 1947000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1947020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947046 */     // MIs[0] policy
     /* 1947046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947056 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1947059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947080 */     // GIR_Coverage, 24519,
     /* 1947080 */     GIR_EraseRootFromParent_Done,
     /* 1947081 */   // Label 26148: @1947081
     /* 1947081 */   GIM_Try, /*On fail goto*//*Label 26149*/ GIMT_Encode4(1947167), // Rule ID 24522 //
     /* 1947086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1947097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1947100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1947103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1947106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947132 */     // MIs[0] policy
     /* 1947132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947142 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1947145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947166 */     // GIR_Coverage, 24522,
     /* 1947166 */     GIR_EraseRootFromParent_Done,
     /* 1947167 */   // Label 26149: @1947167
     /* 1947167 */   GIM_Try, /*On fail goto*//*Label 26150*/ GIMT_Encode4(1947253), // Rule ID 24523 //
     /* 1947172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1947183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1947186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1947189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1947192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1947195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947218 */     // MIs[0] policy
     /* 1947218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947228 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11520:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1947231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947252 */     // GIR_Coverage, 24523,
     /* 1947252 */     GIR_EraseRootFromParent_Done,
     /* 1947253 */   // Label 26150: @1947253
     /* 1947253 */   GIM_Try, /*On fail goto*//*Label 26151*/ GIMT_Encode4(1947339), // Rule ID 24526 //
     /* 1947258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947304 */     // MIs[0] policy
     /* 1947304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1947317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947338 */     // GIR_Coverage, 24526,
     /* 1947338 */     GIR_EraseRootFromParent_Done,
     /* 1947339 */   // Label 26151: @1947339
     /* 1947339 */   GIM_Try, /*On fail goto*//*Label 26152*/ GIMT_Encode4(1947425), // Rule ID 24527 //
     /* 1947344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1947355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1947358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1947361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947390 */     // MIs[0] policy
     /* 1947390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1947403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947424 */     // GIR_Coverage, 24527,
     /* 1947424 */     GIR_EraseRootFromParent_Done,
     /* 1947425 */   // Label 26152: @1947425
     /* 1947425 */   GIM_Try, /*On fail goto*//*Label 26153*/ GIMT_Encode4(1947511), // Rule ID 24530 //
     /* 1947430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1947441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1947444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1947447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1947450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947476 */     // MIs[0] policy
     /* 1947476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1947489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947510 */     // GIR_Coverage, 24530,
     /* 1947510 */     GIR_EraseRootFromParent_Done,
     /* 1947511 */   // Label 26153: @1947511
     /* 1947511 */   GIM_Try, /*On fail goto*//*Label 26154*/ GIMT_Encode4(1947597), // Rule ID 24531 //
     /* 1947516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1947527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1947530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1947533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1947536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947562 */     // MIs[0] policy
     /* 1947562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1947575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947596 */     // GIR_Coverage, 24531,
     /* 1947596 */     GIR_EraseRootFromParent_Done,
     /* 1947597 */   // Label 26154: @1947597
     /* 1947597 */   GIM_Try, /*On fail goto*//*Label 26155*/ GIMT_Encode4(1947683), // Rule ID 24534 //
     /* 1947602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1947605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1947613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1947616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1947619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1947622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947648 */     // MIs[0] policy
     /* 1947648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947658 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1947661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947682 */     // GIR_Coverage, 24534,
     /* 1947682 */     GIR_EraseRootFromParent_Done,
     /* 1947683 */   // Label 26155: @1947683
     /* 1947683 */   GIM_Try, /*On fail goto*//*Label 26156*/ GIMT_Encode4(1947769), // Rule ID 24535 //
     /* 1947688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1947691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1947699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1947702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1947705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1947708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947734 */     // MIs[0] policy
     /* 1947734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947744 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1947747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947768 */     // GIR_Coverage, 24535,
     /* 1947768 */     GIR_EraseRootFromParent_Done,
     /* 1947769 */   // Label 26156: @1947769
     /* 1947769 */   GIM_Try, /*On fail goto*//*Label 26157*/ GIMT_Encode4(1947855), // Rule ID 24538 //
     /* 1947774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1947785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1947788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1947791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1947794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1947797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947820 */     // MIs[0] policy
     /* 1947820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947830 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1947833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947854 */     // GIR_Coverage, 24538,
     /* 1947854 */     GIR_EraseRootFromParent_Done,
     /* 1947855 */   // Label 26157: @1947855
     /* 1947855 */   GIM_Try, /*On fail goto*//*Label 26158*/ GIMT_Encode4(1947941), // Rule ID 24539 //
     /* 1947860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1947871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1947874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1947877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1947880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1947883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1947890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1947902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947906 */     // MIs[0] policy
     /* 1947906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947916 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1947919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947940 */     // GIR_Coverage, 24539,
     /* 1947940 */     GIR_EraseRootFromParent_Done,
     /* 1947941 */   // Label 26158: @1947941
     /* 1947941 */   GIM_Try, /*On fail goto*//*Label 26159*/ GIMT_Encode4(1948027), // Rule ID 24542 //
     /* 1947946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1947954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1947957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1947960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1947963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1947966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1947969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1947976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1947988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947992 */     // MIs[0] policy
     /* 1947992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948002 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1948005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948026 */     // GIR_Coverage, 24542,
     /* 1948026 */     GIR_EraseRootFromParent_Done,
     /* 1948027 */   // Label 26159: @1948027
     /* 1948027 */   GIM_Try, /*On fail goto*//*Label 26160*/ GIMT_Encode4(1948113), // Rule ID 24543 //
     /* 1948032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1948043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1948046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1948049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1948052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948078 */     // MIs[0] policy
     /* 1948078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948088 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1948091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948112 */     // GIR_Coverage, 24543,
     /* 1948112 */     GIR_EraseRootFromParent_Done,
     /* 1948113 */   // Label 26160: @1948113
     /* 1948113 */   GIM_Try, /*On fail goto*//*Label 26161*/ GIMT_Encode4(1948199), // Rule ID 24546 //
     /* 1948118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1948129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1948132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1948135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1948138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1948141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948164 */     // MIs[0] policy
     /* 1948164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948174 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1948177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948198 */     // GIR_Coverage, 24546,
     /* 1948198 */     GIR_EraseRootFromParent_Done,
     /* 1948199 */   // Label 26161: @1948199
     /* 1948199 */   GIM_Try, /*On fail goto*//*Label 26162*/ GIMT_Encode4(1948285), // Rule ID 24547 //
     /* 1948204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1948215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1948218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1948221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1948224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1948227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948250 */     // MIs[0] policy
     /* 1948250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948260 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1948263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948284 */     // GIR_Coverage, 24547,
     /* 1948284 */     GIR_EraseRootFromParent_Done,
     /* 1948285 */   // Label 26162: @1948285
     /* 1948285 */   GIM_Try, /*On fail goto*//*Label 26163*/ GIMT_Encode4(1948371), // Rule ID 24550 //
     /* 1948290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948336 */     // MIs[0] policy
     /* 1948336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1948349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948370 */     // GIR_Coverage, 24550,
     /* 1948370 */     GIR_EraseRootFromParent_Done,
     /* 1948371 */   // Label 26163: @1948371
     /* 1948371 */   GIM_Try, /*On fail goto*//*Label 26164*/ GIMT_Encode4(1948457), // Rule ID 24551 //
     /* 1948376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1948387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1948390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1948393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948422 */     // MIs[0] policy
     /* 1948422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948432 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1948435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948456 */     // GIR_Coverage, 24551,
     /* 1948456 */     GIR_EraseRootFromParent_Done,
     /* 1948457 */   // Label 26164: @1948457
     /* 1948457 */   GIM_Try, /*On fail goto*//*Label 26165*/ GIMT_Encode4(1948543), // Rule ID 24554 //
     /* 1948462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1948473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1948476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1948479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1948482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948508 */     // MIs[0] policy
     /* 1948508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948518 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1948521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948542 */     // GIR_Coverage, 24554,
     /* 1948542 */     GIR_EraseRootFromParent_Done,
     /* 1948543 */   // Label 26165: @1948543
     /* 1948543 */   GIM_Try, /*On fail goto*//*Label 26166*/ GIMT_Encode4(1948629), // Rule ID 24555 //
     /* 1948548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1948559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1948562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1948565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1948568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948594 */     // MIs[0] policy
     /* 1948594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948604 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1948607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948628 */     // GIR_Coverage, 24555,
     /* 1948628 */     GIR_EraseRootFromParent_Done,
     /* 1948629 */   // Label 26166: @1948629
     /* 1948629 */   GIM_Try, /*On fail goto*//*Label 26167*/ GIMT_Encode4(1948715), // Rule ID 24558 //
     /* 1948634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1948645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1948648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1948651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1948654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948680 */     // MIs[0] policy
     /* 1948680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948690 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1948693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948714 */     // GIR_Coverage, 24558,
     /* 1948714 */     GIR_EraseRootFromParent_Done,
     /* 1948715 */   // Label 26167: @1948715
     /* 1948715 */   GIM_Try, /*On fail goto*//*Label 26168*/ GIMT_Encode4(1948801), // Rule ID 24559 //
     /* 1948720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1948731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1948734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1948737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1948740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1948750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948766 */     // MIs[0] policy
     /* 1948766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1948779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948800 */     // GIR_Coverage, 24559,
     /* 1948800 */     GIR_EraseRootFromParent_Done,
     /* 1948801 */   // Label 26168: @1948801
     /* 1948801 */   GIM_Try, /*On fail goto*//*Label 26169*/ GIMT_Encode4(1948887), // Rule ID 24562 //
     /* 1948806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1948817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1948820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1948823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1948826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948852 */     // MIs[0] policy
     /* 1948852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1948865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948886 */     // GIR_Coverage, 24562,
     /* 1948886 */     GIR_EraseRootFromParent_Done,
     /* 1948887 */   // Label 26169: @1948887
     /* 1948887 */   GIM_Try, /*On fail goto*//*Label 26170*/ GIMT_Encode4(1948973), // Rule ID 24563 //
     /* 1948892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1948903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1948906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1948909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1948912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948938 */     // MIs[0] policy
     /* 1948938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948948 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1948951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948972 */     // GIR_Coverage, 24563,
     /* 1948972 */     GIR_EraseRootFromParent_Done,
     /* 1948973 */   // Label 26170: @1948973
     /* 1948973 */   GIM_Try, /*On fail goto*//*Label 26171*/ GIMT_Encode4(1949059), // Rule ID 24566 //
     /* 1948978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1948986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1948989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1948992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1948995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1948998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949024 */     // MIs[0] policy
     /* 1949024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949034 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1949037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949058 */     // GIR_Coverage, 24566,
     /* 1949058 */     GIR_EraseRootFromParent_Done,
     /* 1949059 */   // Label 26171: @1949059
     /* 1949059 */   GIM_Try, /*On fail goto*//*Label 26172*/ GIMT_Encode4(1949145), // Rule ID 24567 //
     /* 1949064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1949084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949110 */     // MIs[0] policy
     /* 1949110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949120 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1949123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949144 */     // GIR_Coverage, 24567,
     /* 1949144 */     GIR_EraseRootFromParent_Done,
     /* 1949145 */   // Label 26172: @1949145
     /* 1949145 */   GIM_Try, /*On fail goto*//*Label 26173*/ GIMT_Encode4(1949231), // Rule ID 24570 //
     /* 1949150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1949170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949196 */     // MIs[0] policy
     /* 1949196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949206 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1949209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949230 */     // GIR_Coverage, 24570,
     /* 1949230 */     GIR_EraseRootFromParent_Done,
     /* 1949231 */   // Label 26173: @1949231
     /* 1949231 */   GIM_Try, /*On fail goto*//*Label 26174*/ GIMT_Encode4(1949317), // Rule ID 24571 //
     /* 1949236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1949256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949282 */     // MIs[0] policy
     /* 1949282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949292 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1949295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949316 */     // GIR_Coverage, 24571,
     /* 1949316 */     GIR_EraseRootFromParent_Done,
     /* 1949317 */   // Label 26174: @1949317
     /* 1949317 */   GIM_Try, /*On fail goto*//*Label 26175*/ GIMT_Encode4(1949403), // Rule ID 24574 //
     /* 1949322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1949342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949368 */     // MIs[0] policy
     /* 1949368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1949381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949402 */     // GIR_Coverage, 24574,
     /* 1949402 */     GIR_EraseRootFromParent_Done,
     /* 1949403 */   // Label 26175: @1949403
     /* 1949403 */   GIM_Try, /*On fail goto*//*Label 26176*/ GIMT_Encode4(1949489), // Rule ID 24575 //
     /* 1949408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1949419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1949422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1949425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1949428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1949431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949454 */     // MIs[0] policy
     /* 1949454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1949467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949488 */     // GIR_Coverage, 24575,
     /* 1949488 */     GIR_EraseRootFromParent_Done,
     /* 1949489 */   // Label 26176: @1949489
     /* 1949489 */   GIM_Try, /*On fail goto*//*Label 26177*/ GIMT_Encode4(1949575), // Rule ID 24578 //
     /* 1949494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1949505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1949508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1949511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1949514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949540 */     // MIs[0] policy
     /* 1949540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949550 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1949553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949574 */     // GIR_Coverage, 24578,
     /* 1949574 */     GIR_EraseRootFromParent_Done,
     /* 1949575 */   // Label 26177: @1949575
     /* 1949575 */   GIM_Try, /*On fail goto*//*Label 26178*/ GIMT_Encode4(1949661), // Rule ID 24579 //
     /* 1949580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1949591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1949594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1949597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1949600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949626 */     // MIs[0] policy
     /* 1949626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1949639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949660 */     // GIR_Coverage, 24579,
     /* 1949660 */     GIR_EraseRootFromParent_Done,
     /* 1949661 */   // Label 26178: @1949661
     /* 1949661 */   GIM_Try, /*On fail goto*//*Label 26179*/ GIMT_Encode4(1949747), // Rule ID 24582 //
     /* 1949666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1949669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1949677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1949680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1949683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1949686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949712 */     // MIs[0] policy
     /* 1949712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949722 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1949725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949746 */     // GIR_Coverage, 24582,
     /* 1949746 */     GIR_EraseRootFromParent_Done,
     /* 1949747 */   // Label 26179: @1949747
     /* 1949747 */   GIM_Try, /*On fail goto*//*Label 26180*/ GIMT_Encode4(1949833), // Rule ID 24583 //
     /* 1949752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1949755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1949760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1949763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1949766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1949769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1949772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949798 */     // MIs[0] policy
     /* 1949798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949808 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1949811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1949829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949832 */     // GIR_Coverage, 24583,
     /* 1949832 */     GIR_EraseRootFromParent_Done,
     /* 1949833 */   // Label 26180: @1949833
     /* 1949833 */   GIM_Try, /*On fail goto*//*Label 26181*/ GIMT_Encode4(1949919), // Rule ID 24586 //
     /* 1949838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1949849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1949852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1949855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1949858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949884 */     // MIs[0] policy
     /* 1949884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949894 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1949897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949918 */     // GIR_Coverage, 24586,
     /* 1949918 */     GIR_EraseRootFromParent_Done,
     /* 1949919 */   // Label 26181: @1949919
     /* 1949919 */   GIM_Try, /*On fail goto*//*Label 26182*/ GIMT_Encode4(1950005), // Rule ID 24587 //
     /* 1949924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1949932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1949935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1949938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1949941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1949944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1949947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1949954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1949966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949970 */     // MIs[0] policy
     /* 1949970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949980 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1949983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950004 */     // GIR_Coverage, 24587,
     /* 1950004 */     GIR_EraseRootFromParent_Done,
     /* 1950005 */   // Label 26182: @1950005
     /* 1950005 */   GIM_Try, /*On fail goto*//*Label 26183*/ GIMT_Encode4(1950091), // Rule ID 24590 //
     /* 1950010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950056 */     // MIs[0] policy
     /* 1950056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950066 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950090 */     // GIR_Coverage, 24590,
     /* 1950090 */     GIR_EraseRootFromParent_Done,
     /* 1950091 */   // Label 26183: @1950091
     /* 1950091 */   GIM_Try, /*On fail goto*//*Label 26184*/ GIMT_Encode4(1950177), // Rule ID 24591 //
     /* 1950096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1950107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1950110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1950113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950142 */     // MIs[0] policy
     /* 1950142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950152 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950176 */     // GIR_Coverage, 24591,
     /* 1950176 */     GIR_EraseRootFromParent_Done,
     /* 1950177 */   // Label 26184: @1950177
     /* 1950177 */   GIM_Try, /*On fail goto*//*Label 26185*/ GIMT_Encode4(1950263), // Rule ID 24594 //
     /* 1950182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950228 */     // MIs[0] policy
     /* 1950228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950238 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950262 */     // GIR_Coverage, 24594,
     /* 1950262 */     GIR_EraseRootFromParent_Done,
     /* 1950263 */   // Label 26185: @1950263
     /* 1950263 */   GIM_Try, /*On fail goto*//*Label 26186*/ GIMT_Encode4(1950349), // Rule ID 24595 //
     /* 1950268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1950279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1950282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1950285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950314 */     // MIs[0] policy
     /* 1950314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950324 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950348 */     // GIR_Coverage, 24595,
     /* 1950348 */     GIR_EraseRootFromParent_Done,
     /* 1950349 */   // Label 26186: @1950349
     /* 1950349 */   GIM_Try, /*On fail goto*//*Label 26187*/ GIMT_Encode4(1950435), // Rule ID 24598 //
     /* 1950354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950400 */     // MIs[0] policy
     /* 1950400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950410 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950434 */     // GIR_Coverage, 24598,
     /* 1950434 */     GIR_EraseRootFromParent_Done,
     /* 1950435 */   // Label 26187: @1950435
     /* 1950435 */   GIM_Try, /*On fail goto*//*Label 26188*/ GIMT_Encode4(1950521), // Rule ID 24599 //
     /* 1950440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1950451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1950454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1950457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950486 */     // MIs[0] policy
     /* 1950486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950496 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1950499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950520 */     // GIR_Coverage, 24599,
     /* 1950520 */     GIR_EraseRootFromParent_Done,
     /* 1950521 */   // Label 26188: @1950521
     /* 1950521 */   GIM_Try, /*On fail goto*//*Label 26189*/ GIMT_Encode4(1950607), // Rule ID 24602 //
     /* 1950526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1950537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1950540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1950543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950572 */     // MIs[0] policy
     /* 1950572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950582 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950606 */     // GIR_Coverage, 24602,
     /* 1950606 */     GIR_EraseRootFromParent_Done,
     /* 1950607 */   // Label 26189: @1950607
     /* 1950607 */   GIM_Try, /*On fail goto*//*Label 26190*/ GIMT_Encode4(1950693), // Rule ID 24603 //
     /* 1950612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1950623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1950626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1950629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950658 */     // MIs[0] policy
     /* 1950658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950668 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1950689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950692 */     // GIR_Coverage, 24603,
     /* 1950692 */     GIR_EraseRootFromParent_Done,
     /* 1950693 */   // Label 26190: @1950693
     /* 1950693 */   GIM_Try, /*On fail goto*//*Label 26191*/ GIMT_Encode4(1950779), // Rule ID 24606 //
     /* 1950698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950744 */     // MIs[0] policy
     /* 1950744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950778 */     // GIR_Coverage, 24606,
     /* 1950778 */     GIR_EraseRootFromParent_Done,
     /* 1950779 */   // Label 26191: @1950779
     /* 1950779 */   GIM_Try, /*On fail goto*//*Label 26192*/ GIMT_Encode4(1950865), // Rule ID 24607 //
     /* 1950784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950830 */     // MIs[0] policy
     /* 1950830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1950843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950864 */     // GIR_Coverage, 24607,
     /* 1950864 */     GIR_EraseRootFromParent_Done,
     /* 1950865 */   // Label 26192: @1950865
     /* 1950865 */   GIM_Try, /*On fail goto*//*Label 26193*/ GIMT_Encode4(1950951), // Rule ID 24610 //
     /* 1950870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1950873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1950881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1950884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1950887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1950890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950916 */     // MIs[0] policy
     /* 1950916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1950929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1950947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950950 */     // GIR_Coverage, 24610,
     /* 1950950 */     GIR_EraseRootFromParent_Done,
     /* 1950951 */   // Label 26193: @1950951
     /* 1950951 */   GIM_Try, /*On fail goto*//*Label 26194*/ GIMT_Encode4(1951037), // Rule ID 24611 //
     /* 1950956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1950964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1950967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1950970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1950973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1950976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1950998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951002 */     // MIs[0] policy
     /* 1951002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951012 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11522:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951036 */     // GIR_Coverage, 24611,
     /* 1951036 */     GIR_EraseRootFromParent_Done,
     /* 1951037 */   // Label 26194: @1951037
     /* 1951037 */   GIM_Try, /*On fail goto*//*Label 26195*/ GIMT_Encode4(1951123), // Rule ID 24614 //
     /* 1951042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951088 */     // MIs[0] policy
     /* 1951088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951098 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951122 */     // GIR_Coverage, 24614,
     /* 1951122 */     GIR_EraseRootFromParent_Done,
     /* 1951123 */   // Label 26195: @1951123
     /* 1951123 */   GIM_Try, /*On fail goto*//*Label 26196*/ GIMT_Encode4(1951209), // Rule ID 24615 //
     /* 1951128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1951139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1951142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1951145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951174 */     // MIs[0] policy
     /* 1951174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1951205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951208 */     // GIR_Coverage, 24615,
     /* 1951208 */     GIR_EraseRootFromParent_Done,
     /* 1951209 */   // Label 26196: @1951209
     /* 1951209 */   GIM_Try, /*On fail goto*//*Label 26197*/ GIMT_Encode4(1951295), // Rule ID 24618 //
     /* 1951214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951260 */     // MIs[0] policy
     /* 1951260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951294 */     // GIR_Coverage, 24618,
     /* 1951294 */     GIR_EraseRootFromParent_Done,
     /* 1951295 */   // Label 26197: @1951295
     /* 1951295 */   GIM_Try, /*On fail goto*//*Label 26198*/ GIMT_Encode4(1951381), // Rule ID 24619 //
     /* 1951300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1951311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1951314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1951317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951346 */     // MIs[0] policy
     /* 1951346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951356 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951380 */     // GIR_Coverage, 24619,
     /* 1951380 */     GIR_EraseRootFromParent_Done,
     /* 1951381 */   // Label 26198: @1951381
     /* 1951381 */   GIM_Try, /*On fail goto*//*Label 26199*/ GIMT_Encode4(1951467), // Rule ID 24622 //
     /* 1951386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1951389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951432 */     // MIs[0] policy
     /* 1951432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951466 */     // GIR_Coverage, 24622,
     /* 1951466 */     GIR_EraseRootFromParent_Done,
     /* 1951467 */   // Label 26199: @1951467
     /* 1951467 */   GIM_Try, /*On fail goto*//*Label 26200*/ GIMT_Encode4(1951553), // Rule ID 24623 //
     /* 1951472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1951475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951518 */     // MIs[0] policy
     /* 1951518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951528 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1951531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951552 */     // GIR_Coverage, 24623,
     /* 1951552 */     GIR_EraseRootFromParent_Done,
     /* 1951553 */   // Label 26200: @1951553
     /* 1951553 */   GIM_Try, /*On fail goto*//*Label 26201*/ GIMT_Encode4(1951639), // Rule ID 24626 //
     /* 1951558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1951569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1951572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1951575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951604 */     // MIs[0] policy
     /* 1951604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951614 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1951617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951638 */     // GIR_Coverage, 24626,
     /* 1951638 */     GIR_EraseRootFromParent_Done,
     /* 1951639 */   // Label 26201: @1951639
     /* 1951639 */   GIM_Try, /*On fail goto*//*Label 26202*/ GIMT_Encode4(1951725), // Rule ID 24627 //
     /* 1951644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1951655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1951658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1951661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951690 */     // MIs[0] policy
     /* 1951690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951700 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1951703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951724 */     // GIR_Coverage, 24627,
     /* 1951724 */     GIR_EraseRootFromParent_Done,
     /* 1951725 */   // Label 26202: @1951725
     /* 1951725 */   GIM_Try, /*On fail goto*//*Label 26203*/ GIMT_Encode4(1951811), // Rule ID 24630 //
     /* 1951730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1951741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1951744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1951747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1951753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951776 */     // MIs[0] policy
     /* 1951776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951786 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1951789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951810 */     // GIR_Coverage, 24630,
     /* 1951810 */     GIR_EraseRootFromParent_Done,
     /* 1951811 */   // Label 26203: @1951811
     /* 1951811 */   GIM_Try, /*On fail goto*//*Label 26204*/ GIMT_Encode4(1951897), // Rule ID 24631 //
     /* 1951816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1951827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1951830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1951833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1951836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1951839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951862 */     // MIs[0] policy
     /* 1951862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951872 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1951875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951896 */     // GIR_Coverage, 24631,
     /* 1951896 */     GIR_EraseRootFromParent_Done,
     /* 1951897 */   // Label 26204: @1951897
     /* 1951897 */   GIM_Try, /*On fail goto*//*Label 26205*/ GIMT_Encode4(1951983), // Rule ID 24634 //
     /* 1951902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1951905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1951913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1951916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1951919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1951922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1951925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1951944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951948 */     // MIs[0] policy
     /* 1951948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951958 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1951961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1951979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951982 */     // GIR_Coverage, 24634,
     /* 1951982 */     GIR_EraseRootFromParent_Done,
     /* 1951983 */   // Label 26205: @1951983
     /* 1951983 */   GIM_Try, /*On fail goto*//*Label 26206*/ GIMT_Encode4(1952069), // Rule ID 24635 //
     /* 1951988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1951991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1951996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1951999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1952002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1952005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1952011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952034 */     // MIs[0] policy
     /* 1952034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952044 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1952065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952068 */     // GIR_Coverage, 24635,
     /* 1952068 */     GIR_EraseRootFromParent_Done,
     /* 1952069 */   // Label 26206: @1952069
     /* 1952069 */   GIM_Try, /*On fail goto*//*Label 26207*/ GIMT_Encode4(1952155), // Rule ID 24638 //
     /* 1952074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952120 */     // MIs[0] policy
     /* 1952120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952154 */     // GIR_Coverage, 24638,
     /* 1952154 */     GIR_EraseRootFromParent_Done,
     /* 1952155 */   // Label 26207: @1952155
     /* 1952155 */   GIM_Try, /*On fail goto*//*Label 26208*/ GIMT_Encode4(1952241), // Rule ID 24639 //
     /* 1952160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1952171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1952174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1952177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952206 */     // MIs[0] policy
     /* 1952206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952240 */     // GIR_Coverage, 24639,
     /* 1952240 */     GIR_EraseRootFromParent_Done,
     /* 1952241 */   // Label 26208: @1952241
     /* 1952241 */   GIM_Try, /*On fail goto*//*Label 26209*/ GIMT_Encode4(1952327), // Rule ID 24642 //
     /* 1952246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952292 */     // MIs[0] policy
     /* 1952292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952302 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952326 */     // GIR_Coverage, 24642,
     /* 1952326 */     GIR_EraseRootFromParent_Done,
     /* 1952327 */   // Label 26209: @1952327
     /* 1952327 */   GIM_Try, /*On fail goto*//*Label 26210*/ GIMT_Encode4(1952413), // Rule ID 24643 //
     /* 1952332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1952343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1952346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1952349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952378 */     // MIs[0] policy
     /* 1952378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952388 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952412 */     // GIR_Coverage, 24643,
     /* 1952412 */     GIR_EraseRootFromParent_Done,
     /* 1952413 */   // Label 26210: @1952413
     /* 1952413 */   GIM_Try, /*On fail goto*//*Label 26211*/ GIMT_Encode4(1952499), // Rule ID 24646 //
     /* 1952418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952464 */     // MIs[0] policy
     /* 1952464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952474 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952498 */     // GIR_Coverage, 24646,
     /* 1952498 */     GIR_EraseRootFromParent_Done,
     /* 1952499 */   // Label 26211: @1952499
     /* 1952499 */   GIM_Try, /*On fail goto*//*Label 26212*/ GIMT_Encode4(1952585), // Rule ID 24647 //
     /* 1952504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1952515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1952518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1952521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1952527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952550 */     // MIs[0] policy
     /* 1952550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1952581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952584 */     // GIR_Coverage, 24647,
     /* 1952584 */     GIR_EraseRootFromParent_Done,
     /* 1952585 */   // Label 26212: @1952585
     /* 1952585 */   GIM_Try, /*On fail goto*//*Label 26213*/ GIMT_Encode4(1952671), // Rule ID 24650 //
     /* 1952590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952636 */     // MIs[0] policy
     /* 1952636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952670 */     // GIR_Coverage, 24650,
     /* 1952670 */     GIR_EraseRootFromParent_Done,
     /* 1952671 */   // Label 26213: @1952671
     /* 1952671 */   GIM_Try, /*On fail goto*//*Label 26214*/ GIMT_Encode4(1952757), // Rule ID 24651 //
     /* 1952676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952722 */     // MIs[0] policy
     /* 1952722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952756 */     // GIR_Coverage, 24651,
     /* 1952756 */     GIR_EraseRootFromParent_Done,
     /* 1952757 */   // Label 26214: @1952757
     /* 1952757 */   GIM_Try, /*On fail goto*//*Label 26215*/ GIMT_Encode4(1952843), // Rule ID 24654 //
     /* 1952762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952808 */     // MIs[0] policy
     /* 1952808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952818 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952842 */     // GIR_Coverage, 24654,
     /* 1952842 */     GIR_EraseRootFromParent_Done,
     /* 1952843 */   // Label 26215: @1952843
     /* 1952843 */   GIM_Try, /*On fail goto*//*Label 26216*/ GIMT_Encode4(1952929), // Rule ID 24655 //
     /* 1952848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1952851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952894 */     // MIs[0] policy
     /* 1952894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952904 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952928 */     // GIR_Coverage, 24655,
     /* 1952928 */     GIR_EraseRootFromParent_Done,
     /* 1952929 */   // Label 26216: @1952929
     /* 1952929 */   GIM_Try, /*On fail goto*//*Label 26217*/ GIMT_Encode4(1953015), // Rule ID 24658 //
     /* 1952934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1952937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1952945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1952948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1952951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1952957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952980 */     // MIs[0] policy
     /* 1952980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952990 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1952993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953014 */     // GIR_Coverage, 24658,
     /* 1953014 */     GIR_EraseRootFromParent_Done,
     /* 1953015 */   // Label 26217: @1953015
     /* 1953015 */   GIM_Try, /*On fail goto*//*Label 26218*/ GIMT_Encode4(1953101), // Rule ID 24659 //
     /* 1953020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953066 */     // MIs[0] policy
     /* 1953066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953076 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953100 */     // GIR_Coverage, 24659,
     /* 1953100 */     GIR_EraseRootFromParent_Done,
     /* 1953101 */   // Label 26218: @1953101
     /* 1953101 */   GIM_Try, /*On fail goto*//*Label 26219*/ GIMT_Encode4(1953187), // Rule ID 24662 //
     /* 1953106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953152 */     // MIs[0] policy
     /* 1953152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953162 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953186 */     // GIR_Coverage, 24662,
     /* 1953186 */     GIR_EraseRootFromParent_Done,
     /* 1953187 */   // Label 26219: @1953187
     /* 1953187 */   GIM_Try, /*On fail goto*//*Label 26220*/ GIMT_Encode4(1953273), // Rule ID 24663 //
     /* 1953192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953238 */     // MIs[0] policy
     /* 1953238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953248 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953272 */     // GIR_Coverage, 24663,
     /* 1953272 */     GIR_EraseRootFromParent_Done,
     /* 1953273 */   // Label 26220: @1953273
     /* 1953273 */   GIM_Try, /*On fail goto*//*Label 26221*/ GIMT_Encode4(1953359), // Rule ID 24666 //
     /* 1953278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953324 */     // MIs[0] policy
     /* 1953324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953334 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953358 */     // GIR_Coverage, 24666,
     /* 1953358 */     GIR_EraseRootFromParent_Done,
     /* 1953359 */   // Label 26221: @1953359
     /* 1953359 */   GIM_Try, /*On fail goto*//*Label 26222*/ GIMT_Encode4(1953445), // Rule ID 24667 //
     /* 1953364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953410 */     // MIs[0] policy
     /* 1953410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953444 */     // GIR_Coverage, 24667,
     /* 1953444 */     GIR_EraseRootFromParent_Done,
     /* 1953445 */   // Label 26222: @1953445
     /* 1953445 */   GIM_Try, /*On fail goto*//*Label 26223*/ GIMT_Encode4(1953531), // Rule ID 24670 //
     /* 1953450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1953453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953496 */     // MIs[0] policy
     /* 1953496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953506 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953530 */     // GIR_Coverage, 24670,
     /* 1953530 */     GIR_EraseRootFromParent_Done,
     /* 1953531 */   // Label 26223: @1953531
     /* 1953531 */   GIM_Try, /*On fail goto*//*Label 26224*/ GIMT_Encode4(1953617), // Rule ID 24671 //
     /* 1953536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1953539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953582 */     // MIs[0] policy
     /* 1953582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953592 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953616 */     // GIR_Coverage, 24671,
     /* 1953616 */     GIR_EraseRootFromParent_Done,
     /* 1953617 */   // Label 26224: @1953617
     /* 1953617 */   GIM_Try, /*On fail goto*//*Label 26225*/ GIMT_Encode4(1953703), // Rule ID 24762 //
     /* 1953622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1953633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1953636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1953639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1953642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953668 */     // MIs[0] policy
     /* 1953668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953678 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1953681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953702 */     // GIR_Coverage, 24762,
     /* 1953702 */     GIR_EraseRootFromParent_Done,
     /* 1953703 */   // Label 26225: @1953703
     /* 1953703 */   GIM_Try, /*On fail goto*//*Label 26226*/ GIMT_Encode4(1953789), // Rule ID 24763 //
     /* 1953708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1953719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1953722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1953725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1953728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953754 */     // MIs[0] policy
     /* 1953754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1953767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953788 */     // GIR_Coverage, 24763,
     /* 1953788 */     GIR_EraseRootFromParent_Done,
     /* 1953789 */   // Label 26226: @1953789
     /* 1953789 */   GIM_Try, /*On fail goto*//*Label 26227*/ GIMT_Encode4(1953875), // Rule ID 24766 //
     /* 1953794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1953805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1953808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1953811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1953814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953840 */     // MIs[0] policy
     /* 1953840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953850 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1953853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953874 */     // GIR_Coverage, 24766,
     /* 1953874 */     GIR_EraseRootFromParent_Done,
     /* 1953875 */   // Label 26227: @1953875
     /* 1953875 */   GIM_Try, /*On fail goto*//*Label 26228*/ GIMT_Encode4(1953961), // Rule ID 24767 //
     /* 1953880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1953883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1953891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1953894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1953897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1953900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953926 */     // MIs[0] policy
     /* 1953926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953936 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1953939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1953957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953960 */     // GIR_Coverage, 24767,
     /* 1953960 */     GIR_EraseRootFromParent_Done,
     /* 1953961 */   // Label 26228: @1953961
     /* 1953961 */   GIM_Try, /*On fail goto*//*Label 26229*/ GIMT_Encode4(1954047), // Rule ID 24770 //
     /* 1953966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1953969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1953974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1953977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1953980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1953983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1953986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954012 */     // MIs[0] policy
     /* 1954012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954022 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1954025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954046 */     // GIR_Coverage, 24770,
     /* 1954046 */     GIR_EraseRootFromParent_Done,
     /* 1954047 */   // Label 26229: @1954047
     /* 1954047 */   GIM_Try, /*On fail goto*//*Label 26230*/ GIMT_Encode4(1954133), // Rule ID 24771 //
     /* 1954052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1954063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1954066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1954069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954098 */     // MIs[0] policy
     /* 1954098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954108 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1954111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954132 */     // GIR_Coverage, 24771,
     /* 1954132 */     GIR_EraseRootFromParent_Done,
     /* 1954133 */   // Label 26230: @1954133
     /* 1954133 */   GIM_Try, /*On fail goto*//*Label 26231*/ GIMT_Encode4(1954219), // Rule ID 24774 //
     /* 1954138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954184 */     // MIs[0] policy
     /* 1954184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1954197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954218 */     // GIR_Coverage, 24774,
     /* 1954218 */     GIR_EraseRootFromParent_Done,
     /* 1954219 */   // Label 26231: @1954219
     /* 1954219 */   GIM_Try, /*On fail goto*//*Label 26232*/ GIMT_Encode4(1954305), // Rule ID 24775 //
     /* 1954224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954270 */     // MIs[0] policy
     /* 1954270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954280 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1954283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954304 */     // GIR_Coverage, 24775,
     /* 1954304 */     GIR_EraseRootFromParent_Done,
     /* 1954305 */   // Label 26232: @1954305
     /* 1954305 */   GIM_Try, /*On fail goto*//*Label 26233*/ GIMT_Encode4(1954391), // Rule ID 24778 //
     /* 1954310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954356 */     // MIs[0] policy
     /* 1954356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1954369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954390 */     // GIR_Coverage, 24778,
     /* 1954390 */     GIR_EraseRootFromParent_Done,
     /* 1954391 */   // Label 26233: @1954391
     /* 1954391 */   GIM_Try, /*On fail goto*//*Label 26234*/ GIMT_Encode4(1954477), // Rule ID 24779 //
     /* 1954396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954442 */     // MIs[0] policy
     /* 1954442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954452 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1954455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954476 */     // GIR_Coverage, 24779,
     /* 1954476 */     GIR_EraseRootFromParent_Done,
     /* 1954477 */   // Label 26234: @1954477
     /* 1954477 */   GIM_Try, /*On fail goto*//*Label 26235*/ GIMT_Encode4(1954563), // Rule ID 24782 //
     /* 1954482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954528 */     // MIs[0] policy
     /* 1954528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1954541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954562 */     // GIR_Coverage, 24782,
     /* 1954562 */     GIR_EraseRootFromParent_Done,
     /* 1954563 */   // Label 26235: @1954563
     /* 1954563 */   GIM_Try, /*On fail goto*//*Label 26236*/ GIMT_Encode4(1954649), // Rule ID 24783 //
     /* 1954568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1954579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1954582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1954585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1954588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954614 */     // MIs[0] policy
     /* 1954614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954624 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1954627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1954645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954648 */     // GIR_Coverage, 24783,
     /* 1954648 */     GIR_EraseRootFromParent_Done,
     /* 1954649 */   // Label 26236: @1954649
     /* 1954649 */   GIM_Try, /*On fail goto*//*Label 26237*/ GIMT_Encode4(1954735), // Rule ID 24786 //
     /* 1954654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1954665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1954668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1954671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954700 */     // MIs[0] policy
     /* 1954700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954710 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1954713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954734 */     // GIR_Coverage, 24786,
     /* 1954734 */     GIR_EraseRootFromParent_Done,
     /* 1954735 */   // Label 26237: @1954735
     /* 1954735 */   GIM_Try, /*On fail goto*//*Label 26238*/ GIMT_Encode4(1954821), // Rule ID 24787 //
     /* 1954740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1954751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1954754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1954757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954786 */     // MIs[0] policy
     /* 1954786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11524:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1954799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1954817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954820 */     // GIR_Coverage, 24787,
     /* 1954820 */     GIR_EraseRootFromParent_Done,
     /* 1954821 */   // Label 26238: @1954821
     /* 1954821 */   GIM_Try, /*On fail goto*//*Label 26239*/ GIMT_Encode4(1954907), // Rule ID 24790 //
     /* 1954826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1954829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954872 */     // MIs[0] policy
     /* 1954872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954882 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1954885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954906 */     // GIR_Coverage, 24790,
     /* 1954906 */     GIR_EraseRootFromParent_Done,
     /* 1954907 */   // Label 26239: @1954907
     /* 1954907 */   GIM_Try, /*On fail goto*//*Label 26240*/ GIMT_Encode4(1954993), // Rule ID 24791 //
     /* 1954912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1954915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1954920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954958 */     // MIs[0] policy
     /* 1954958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1954971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954992 */     // GIR_Coverage, 24791,
     /* 1954992 */     GIR_EraseRootFromParent_Done,
     /* 1954993 */   // Label 26240: @1954993
     /* 1954993 */   GIM_Try, /*On fail goto*//*Label 26241*/ GIMT_Encode4(1955079), // Rule ID 24794 //
     /* 1954998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1955018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955044 */     // MIs[0] policy
     /* 1955044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1955057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955078 */     // GIR_Coverage, 24794,
     /* 1955078 */     GIR_EraseRootFromParent_Done,
     /* 1955079 */   // Label 26241: @1955079
     /* 1955079 */   GIM_Try, /*On fail goto*//*Label 26242*/ GIMT_Encode4(1955165), // Rule ID 24795 //
     /* 1955084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1955095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1955098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1955101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1955104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955130 */     // MIs[0] policy
     /* 1955130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1955143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1955161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955164 */     // GIR_Coverage, 24795,
     /* 1955164 */     GIR_EraseRootFromParent_Done,
     /* 1955165 */   // Label 26242: @1955165
     /* 1955165 */   GIM_Try, /*On fail goto*//*Label 26243*/ GIMT_Encode4(1955251), // Rule ID 24798 //
     /* 1955170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1955173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955216 */     // MIs[0] policy
     /* 1955216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1955229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955250 */     // GIR_Coverage, 24798,
     /* 1955250 */     GIR_EraseRootFromParent_Done,
     /* 1955251 */   // Label 26243: @1955251
     /* 1955251 */   GIM_Try, /*On fail goto*//*Label 26244*/ GIMT_Encode4(1955337), // Rule ID 24799 //
     /* 1955256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1955259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1955267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1955270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1955273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955302 */     // MIs[0] policy
     /* 1955302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955312 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1955315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1955333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955336 */     // GIR_Coverage, 24799,
     /* 1955336 */     GIR_EraseRootFromParent_Done,
     /* 1955337 */   // Label 26244: @1955337
     /* 1955337 */   GIM_Try, /*On fail goto*//*Label 26245*/ GIMT_Encode4(1955423), // Rule ID 24802 //
     /* 1955342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955388 */     // MIs[0] policy
     /* 1955388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1955401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955422 */     // GIR_Coverage, 24802,
     /* 1955422 */     GIR_EraseRootFromParent_Done,
     /* 1955423 */   // Label 26245: @1955423
     /* 1955423 */   GIM_Try, /*On fail goto*//*Label 26246*/ GIMT_Encode4(1955509), // Rule ID 24803 //
     /* 1955428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1955439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1955442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1955445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955474 */     // MIs[0] policy
     /* 1955474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1955487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955508 */     // GIR_Coverage, 24803,
     /* 1955508 */     GIR_EraseRootFromParent_Done,
     /* 1955509 */   // Label 26246: @1955509
     /* 1955509 */   GIM_Try, /*On fail goto*//*Label 26247*/ GIMT_Encode4(1955595), // Rule ID 24806 //
     /* 1955514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1955528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1955531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1955534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955560 */     // MIs[0] policy
     /* 1955560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955570 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1955573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955594 */     // GIR_Coverage, 24806,
     /* 1955594 */     GIR_EraseRootFromParent_Done,
     /* 1955595 */   // Label 26247: @1955595
     /* 1955595 */   GIM_Try, /*On fail goto*//*Label 26248*/ GIMT_Encode4(1955681), // Rule ID 24807 //
     /* 1955600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1955611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1955614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1955617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1955620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955646 */     // MIs[0] policy
     /* 1955646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1955659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1955677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955680 */     // GIR_Coverage, 24807,
     /* 1955680 */     GIR_EraseRootFromParent_Done,
     /* 1955681 */   // Label 26248: @1955681
     /* 1955681 */   GIM_Try, /*On fail goto*//*Label 26249*/ GIMT_Encode4(1955767), // Rule ID 24810 //
     /* 1955686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1955697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1955700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1955703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955732 */     // MIs[0] policy
     /* 1955732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1955745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955766 */     // GIR_Coverage, 24810,
     /* 1955766 */     GIR_EraseRootFromParent_Done,
     /* 1955767 */   // Label 26249: @1955767
     /* 1955767 */   GIM_Try, /*On fail goto*//*Label 26250*/ GIMT_Encode4(1955853), // Rule ID 24811 //
     /* 1955772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1955783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1955786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1955789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1955792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955818 */     // MIs[0] policy
     /* 1955818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955828 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1955831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955852 */     // GIR_Coverage, 24811,
     /* 1955852 */     GIR_EraseRootFromParent_Done,
     /* 1955853 */   // Label 26250: @1955853
     /* 1955853 */   GIM_Try, /*On fail goto*//*Label 26251*/ GIMT_Encode4(1955939), // Rule ID 24814 //
     /* 1955858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1955861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1955869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1955872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1955875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955904 */     // MIs[0] policy
     /* 1955904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955914 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1955917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955938 */     // GIR_Coverage, 24814,
     /* 1955938 */     GIR_EraseRootFromParent_Done,
     /* 1955939 */   // Label 26251: @1955939
     /* 1955939 */   GIM_Try, /*On fail goto*//*Label 26252*/ GIMT_Encode4(1956025), // Rule ID 24815 //
     /* 1955944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1955947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1955955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1955958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1955961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1955964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955990 */     // MIs[0] policy
     /* 1955990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956000 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1956003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956024 */     // GIR_Coverage, 24815,
     /* 1956024 */     GIR_EraseRootFromParent_Done,
     /* 1956025 */   // Label 26252: @1956025
     /* 1956025 */   GIM_Try, /*On fail goto*//*Label 26253*/ GIMT_Encode4(1956111), // Rule ID 24818 //
     /* 1956030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956076 */     // MIs[0] policy
     /* 1956076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956086 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1956089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956110 */     // GIR_Coverage, 24818,
     /* 1956110 */     GIR_EraseRootFromParent_Done,
     /* 1956111 */   // Label 26253: @1956111
     /* 1956111 */   GIM_Try, /*On fail goto*//*Label 26254*/ GIMT_Encode4(1956197), // Rule ID 24819 //
     /* 1956116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1956127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1956130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1956133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1956136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1956139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956162 */     // MIs[0] policy
     /* 1956162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1956175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956196 */     // GIR_Coverage, 24819,
     /* 1956196 */     GIR_EraseRootFromParent_Done,
     /* 1956197 */   // Label 26254: @1956197
     /* 1956197 */   GIM_Try, /*On fail goto*//*Label 26255*/ GIMT_Encode4(1956283), // Rule ID 24822 //
     /* 1956202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956248 */     // MIs[0] policy
     /* 1956248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1956261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956282 */     // GIR_Coverage, 24822,
     /* 1956282 */     GIR_EraseRootFromParent_Done,
     /* 1956283 */   // Label 26255: @1956283
     /* 1956283 */   GIM_Try, /*On fail goto*//*Label 26256*/ GIMT_Encode4(1956369), // Rule ID 24823 //
     /* 1956288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1956299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1956302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1956305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956334 */     // MIs[0] policy
     /* 1956334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1956347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956368 */     // GIR_Coverage, 24823,
     /* 1956368 */     GIR_EraseRootFromParent_Done,
     /* 1956369 */   // Label 26256: @1956369
     /* 1956369 */   GIM_Try, /*On fail goto*//*Label 26257*/ GIMT_Encode4(1956455), // Rule ID 24826 //
     /* 1956374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956420 */     // MIs[0] policy
     /* 1956420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1956433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956454 */     // GIR_Coverage, 24826,
     /* 1956454 */     GIR_EraseRootFromParent_Done,
     /* 1956455 */   // Label 26257: @1956455
     /* 1956455 */   GIM_Try, /*On fail goto*//*Label 26258*/ GIMT_Encode4(1956541), // Rule ID 24827 //
     /* 1956460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1956471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1956474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1956477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956506 */     // MIs[0] policy
     /* 1956506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1956519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956540 */     // GIR_Coverage, 24827,
     /* 1956540 */     GIR_EraseRootFromParent_Done,
     /* 1956541 */   // Label 26258: @1956541
     /* 1956541 */   GIM_Try, /*On fail goto*//*Label 26259*/ GIMT_Encode4(1956627), // Rule ID 24830 //
     /* 1956546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1956549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1956557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1956560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1956563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1956566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956592 */     // MIs[0] policy
     /* 1956592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1956605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956626 */     // GIR_Coverage, 24830,
     /* 1956626 */     GIR_EraseRootFromParent_Done,
     /* 1956627 */   // Label 26259: @1956627
     /* 1956627 */   GIM_Try, /*On fail goto*//*Label 26260*/ GIMT_Encode4(1956713), // Rule ID 24831 //
     /* 1956632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1956635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1956643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1956646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1956649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1956652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1956655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1956662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1956670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956678 */     // MIs[0] policy
     /* 1956678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956688 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1956691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956712 */     // GIR_Coverage, 24831,
     /* 1956712 */     GIR_EraseRootFromParent_Done,
     /* 1956713 */   // Label 26260: @1956713
     /* 1956713 */   GIM_Try, /*On fail goto*//*Label 26261*/ GIMT_Encode4(1956799), // Rule ID 24834 //
     /* 1956718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1956721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1956729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1956732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1956735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1956738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956764 */     // MIs[0] policy
     /* 1956764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956774 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1956777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956798 */     // GIR_Coverage, 24834,
     /* 1956798 */     GIR_EraseRootFromParent_Done,
     /* 1956799 */   // Label 26261: @1956799
     /* 1956799 */   GIM_Try, /*On fail goto*//*Label 26262*/ GIMT_Encode4(1956885), // Rule ID 24835 //
     /* 1956804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1956807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1956815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1956818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1956821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1956824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956850 */     // MIs[0] policy
     /* 1956850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1956863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956884 */     // GIR_Coverage, 24835,
     /* 1956884 */     GIR_EraseRootFromParent_Done,
     /* 1956885 */   // Label 26262: @1956885
     /* 1956885 */   GIM_Try, /*On fail goto*//*Label 26263*/ GIMT_Encode4(1956971), // Rule ID 24838 //
     /* 1956890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1956893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1956901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1956904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1956907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1956920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1956928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956936 */     // MIs[0] policy
     /* 1956936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1956949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956970 */     // GIR_Coverage, 24838,
     /* 1956970 */     GIR_EraseRootFromParent_Done,
     /* 1956971 */   // Label 26263: @1956971
     /* 1956971 */   GIM_Try, /*On fail goto*//*Label 26264*/ GIMT_Encode4(1957057), // Rule ID 24839 //
     /* 1956976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1956979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1956987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1956990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1956993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957022 */     // MIs[0] policy
     /* 1957022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1957035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957056 */     // GIR_Coverage, 24839,
     /* 1957056 */     GIR_EraseRootFromParent_Done,
     /* 1957057 */   // Label 26264: @1957057
     /* 1957057 */   GIM_Try, /*On fail goto*//*Label 26265*/ GIMT_Encode4(1957143), // Rule ID 24842 //
     /* 1957062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1957065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957108 */     // MIs[0] policy
     /* 1957108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1957121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957142 */     // GIR_Coverage, 24842,
     /* 1957142 */     GIR_EraseRootFromParent_Done,
     /* 1957143 */   // Label 26265: @1957143
     /* 1957143 */   GIM_Try, /*On fail goto*//*Label 26266*/ GIMT_Encode4(1957229), // Rule ID 24843 //
     /* 1957148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1957151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1957159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1957162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1957165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957194 */     // MIs[0] policy
     /* 1957194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1957207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957228 */     // GIR_Coverage, 24843,
     /* 1957228 */     GIR_EraseRootFromParent_Done,
     /* 1957229 */   // Label 26266: @1957229
     /* 1957229 */   GIM_Try, /*On fail goto*//*Label 26267*/ GIMT_Encode4(1957315), // Rule ID 24846 //
     /* 1957234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1957237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957280 */     // MIs[0] policy
     /* 1957280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957290 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1957293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957314 */     // GIR_Coverage, 24846,
     /* 1957314 */     GIR_EraseRootFromParent_Done,
     /* 1957315 */   // Label 26267: @1957315
     /* 1957315 */   GIM_Try, /*On fail goto*//*Label 26268*/ GIMT_Encode4(1957401), // Rule ID 24847 //
     /* 1957320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1957323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1957331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1957334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1957337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1957340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957366 */     // MIs[0] policy
     /* 1957366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957376 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1957379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957400 */     // GIR_Coverage, 24847,
     /* 1957400 */     GIR_EraseRootFromParent_Done,
     /* 1957401 */   // Label 26268: @1957401
     /* 1957401 */   GIM_Try, /*On fail goto*//*Label 26269*/ GIMT_Encode4(1957487), // Rule ID 24850 //
     /* 1957406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1957409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1957417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1957420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1957423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957452 */     // MIs[0] policy
     /* 1957452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957462 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1957465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957486 */     // GIR_Coverage, 24850,
     /* 1957486 */     GIR_EraseRootFromParent_Done,
     /* 1957487 */   // Label 26269: @1957487
     /* 1957487 */   GIM_Try, /*On fail goto*//*Label 26270*/ GIMT_Encode4(1957573), // Rule ID 24851 //
     /* 1957492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1957495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1957503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1957506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1957509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957538 */     // MIs[0] policy
     /* 1957538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957548 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1957551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957572 */     // GIR_Coverage, 24851,
     /* 1957572 */     GIR_EraseRootFromParent_Done,
     /* 1957573 */   // Label 26270: @1957573
     /* 1957573 */   GIM_Try, /*On fail goto*//*Label 26271*/ GIMT_Encode4(1957659), // Rule ID 24854 //
     /* 1957578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1957581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1957589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1957592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1957595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1957598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957624 */     // MIs[0] policy
     /* 1957624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957634 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1957637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957658 */     // GIR_Coverage, 24854,
     /* 1957658 */     GIR_EraseRootFromParent_Done,
     /* 1957659 */   // Label 26271: @1957659
     /* 1957659 */   GIM_Try, /*On fail goto*//*Label 26272*/ GIMT_Encode4(1957745), // Rule ID 24855 //
     /* 1957664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1957667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1957675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1957678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1957681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1957684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1957687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957710 */     // MIs[0] policy
     /* 1957710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957720 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1957723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957744 */     // GIR_Coverage, 24855,
     /* 1957744 */     GIR_EraseRootFromParent_Done,
     /* 1957745 */   // Label 26272: @1957745
     /* 1957745 */   GIM_Try, /*On fail goto*//*Label 26273*/ GIMT_Encode4(1957831), // Rule ID 24858 //
     /* 1957750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1957753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1957761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1957764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1957767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957796 */     // MIs[0] policy
     /* 1957796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957806 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1957809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957830 */     // GIR_Coverage, 24858,
     /* 1957830 */     GIR_EraseRootFromParent_Done,
     /* 1957831 */   // Label 26273: @1957831
     /* 1957831 */   GIM_Try, /*On fail goto*//*Label 26274*/ GIMT_Encode4(1957917), // Rule ID 24859 //
     /* 1957836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1957839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1957847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1957850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1957853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957882 */     // MIs[0] policy
     /* 1957882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957892 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11520:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1957895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957916 */     // GIR_Coverage, 24859,
     /* 1957916 */     GIR_EraseRootFromParent_Done,
     /* 1957917 */   // Label 26274: @1957917
     /* 1957917 */   GIM_Try, /*On fail goto*//*Label 26275*/ GIMT_Encode4(1958003), // Rule ID 24862 //
     /* 1957922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1957925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1957930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1957933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1957936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1957939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1957942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1957952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957968 */     // MIs[0] policy
     /* 1957968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957978 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1957981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958002 */     // GIR_Coverage, 24862,
     /* 1958002 */     GIR_EraseRootFromParent_Done,
     /* 1958003 */   // Label 26275: @1958003
     /* 1958003 */   GIM_Try, /*On fail goto*//*Label 26276*/ GIMT_Encode4(1958089), // Rule ID 24863 //
     /* 1958008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1958011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1958019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1958022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1958025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1958028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958054 */     // MIs[0] policy
     /* 1958054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958064 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11520:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1958067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958088 */     // GIR_Coverage, 24863,
     /* 1958088 */     GIR_EraseRootFromParent_Done,
     /* 1958089 */   // Label 26276: @1958089
     /* 1958089 */   GIM_Try, /*On fail goto*//*Label 26277*/ GIMT_Encode4(1958175), // Rule ID 24866 //
     /* 1958094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1958097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1958114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958140 */     // MIs[0] policy
     /* 1958140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958150 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1958153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958174 */     // GIR_Coverage, 24866,
     /* 1958174 */     GIR_EraseRootFromParent_Done,
     /* 1958175 */   // Label 26277: @1958175
     /* 1958175 */   GIM_Try, /*On fail goto*//*Label 26278*/ GIMT_Encode4(1958261), // Rule ID 24867 //
     /* 1958180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1958183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1958191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1958194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1958197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1958200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958226 */     // MIs[0] policy
     /* 1958226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958236 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11520:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1958239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958260 */     // GIR_Coverage, 24867,
     /* 1958260 */     GIR_EraseRootFromParent_Done,
     /* 1958261 */   // Label 26278: @1958261
     /* 1958261 */   GIM_Try, /*On fail goto*//*Label 26279*/ GIMT_Encode4(1958347), // Rule ID 24870 //
     /* 1958266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1958269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958312 */     // MIs[0] policy
     /* 1958312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958322 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958346 */     // GIR_Coverage, 24870,
     /* 1958346 */     GIR_EraseRootFromParent_Done,
     /* 1958347 */   // Label 26279: @1958347
     /* 1958347 */   GIM_Try, /*On fail goto*//*Label 26280*/ GIMT_Encode4(1958433), // Rule ID 24871 //
     /* 1958352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1958355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1958369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958398 */     // MIs[0] policy
     /* 1958398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958408 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1958411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958432 */     // GIR_Coverage, 24871,
     /* 1958432 */     GIR_EraseRootFromParent_Done,
     /* 1958433 */   // Label 26280: @1958433
     /* 1958433 */   GIM_Try, /*On fail goto*//*Label 26281*/ GIMT_Encode4(1958519), // Rule ID 24874 //
     /* 1958438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1958441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1958449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1958452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1958455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1958458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1958461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958484 */     // MIs[0] policy
     /* 1958484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958494 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1958497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958518 */     // GIR_Coverage, 24874,
     /* 1958518 */     GIR_EraseRootFromParent_Done,
     /* 1958519 */   // Label 26281: @1958519
     /* 1958519 */   GIM_Try, /*On fail goto*//*Label 26282*/ GIMT_Encode4(1958605), // Rule ID 24875 //
     /* 1958524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1958527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1958535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1958538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1958541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1958544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1958547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958570 */     // MIs[0] policy
     /* 1958570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958580 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1958583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958604 */     // GIR_Coverage, 24875,
     /* 1958604 */     GIR_EraseRootFromParent_Done,
     /* 1958605 */   // Label 26282: @1958605
     /* 1958605 */   GIM_Try, /*On fail goto*//*Label 26283*/ GIMT_Encode4(1958691), // Rule ID 24878 //
     /* 1958610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1958613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1958621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1958624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1958627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1958630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1958633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1958640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958656 */     // MIs[0] policy
     /* 1958656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958666 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1958669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958690 */     // GIR_Coverage, 24878,
     /* 1958690 */     GIR_EraseRootFromParent_Done,
     /* 1958691 */   // Label 26283: @1958691
     /* 1958691 */   GIM_Try, /*On fail goto*//*Label 26284*/ GIMT_Encode4(1958777), // Rule ID 24879 //
     /* 1958696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1958699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1958707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1958710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1958713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1958716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1958719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1958726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958742 */     // MIs[0] policy
     /* 1958742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958752 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1958755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1958773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958776 */     // GIR_Coverage, 24879,
     /* 1958776 */     GIR_EraseRootFromParent_Done,
     /* 1958777 */   // Label 26284: @1958777
     /* 1958777 */   GIM_Try, /*On fail goto*//*Label 26285*/ GIMT_Encode4(1958863), // Rule ID 24882 //
     /* 1958782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1958785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1958793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1958796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1958799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1958802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958828 */     // MIs[0] policy
     /* 1958828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958838 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1958841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958862 */     // GIR_Coverage, 24882,
     /* 1958862 */     GIR_EraseRootFromParent_Done,
     /* 1958863 */   // Label 26285: @1958863
     /* 1958863 */   GIM_Try, /*On fail goto*//*Label 26286*/ GIMT_Encode4(1958949), // Rule ID 24883 //
     /* 1958868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1958871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1958879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1958882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1958885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1958888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958914 */     // MIs[0] policy
     /* 1958914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1958927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1958945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958948 */     // GIR_Coverage, 24883,
     /* 1958948 */     GIR_EraseRootFromParent_Done,
     /* 1958949 */   // Label 26286: @1958949
     /* 1958949 */   GIM_Try, /*On fail goto*//*Label 26287*/ GIMT_Encode4(1959035), // Rule ID 24886 //
     /* 1958954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1958957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1958962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1958965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1958968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1958971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1958974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959000 */     // MIs[0] policy
     /* 1959000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959010 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1959013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959034 */     // GIR_Coverage, 24886,
     /* 1959034 */     GIR_EraseRootFromParent_Done,
     /* 1959035 */   // Label 26287: @1959035
     /* 1959035 */   GIM_Try, /*On fail goto*//*Label 26288*/ GIMT_Encode4(1959121), // Rule ID 24887 //
     /* 1959040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1959043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1959051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1959054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1959057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1959060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959086 */     // MIs[0] policy
     /* 1959086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959096 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1959099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959120 */     // GIR_Coverage, 24887,
     /* 1959120 */     GIR_EraseRootFromParent_Done,
     /* 1959121 */   // Label 26288: @1959121
     /* 1959121 */   GIM_Try, /*On fail goto*//*Label 26289*/ GIMT_Encode4(1959207), // Rule ID 24890 //
     /* 1959126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1959129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1959137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1959140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1959143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1959146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959172 */     // MIs[0] policy
     /* 1959172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1959185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959206 */     // GIR_Coverage, 24890,
     /* 1959206 */     GIR_EraseRootFromParent_Done,
     /* 1959207 */   // Label 26289: @1959207
     /* 1959207 */   GIM_Try, /*On fail goto*//*Label 26290*/ GIMT_Encode4(1959293), // Rule ID 24891 //
     /* 1959212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1959215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1959223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1959226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1959229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1959232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959258 */     // MIs[0] policy
     /* 1959258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959268 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1959271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1959289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959292 */     // GIR_Coverage, 24891,
     /* 1959292 */     GIR_EraseRootFromParent_Done,
     /* 1959293 */   // Label 26290: @1959293
     /* 1959293 */   GIM_Try, /*On fail goto*//*Label 26291*/ GIMT_Encode4(1959379), // Rule ID 24894 //
     /* 1959298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1959301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1959309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1959312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1959315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1959318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959344 */     // MIs[0] policy
     /* 1959344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959354 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1959357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959378 */     // GIR_Coverage, 24894,
     /* 1959378 */     GIR_EraseRootFromParent_Done,
     /* 1959379 */   // Label 26291: @1959379
     /* 1959379 */   GIM_Try, /*On fail goto*//*Label 26292*/ GIMT_Encode4(1959465), // Rule ID 24895 //
     /* 1959384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1959387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1959395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1959398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1959401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1959404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959430 */     // MIs[0] policy
     /* 1959430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959440 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11520:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1959443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959464 */     // GIR_Coverage, 24895,
     /* 1959464 */     GIR_EraseRootFromParent_Done,
     /* 1959465 */   // Label 26292: @1959465
     /* 1959465 */   GIM_Try, /*On fail goto*//*Label 26293*/ GIMT_Encode4(1959551), // Rule ID 24898 //
     /* 1959470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1959473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1959481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1959484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1959487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1959490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959516 */     // MIs[0] policy
     /* 1959516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959526 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1959529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959550 */     // GIR_Coverage, 24898,
     /* 1959550 */     GIR_EraseRootFromParent_Done,
     /* 1959551 */   // Label 26293: @1959551
     /* 1959551 */   GIM_Try, /*On fail goto*//*Label 26294*/ GIMT_Encode4(1959637), // Rule ID 24899 //
     /* 1959556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1959559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1959567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1959570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1959573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1959576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959602 */     // MIs[0] policy
     /* 1959602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959612 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11520:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1959615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959636 */     // GIR_Coverage, 24899,
     /* 1959636 */     GIR_EraseRootFromParent_Done,
     /* 1959637 */   // Label 26294: @1959637
     /* 1959637 */   GIM_Try, /*On fail goto*//*Label 26295*/ GIMT_Encode4(1959723), // Rule ID 24902 //
     /* 1959642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1959645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1959653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1959656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1959659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1959662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959688 */     // MIs[0] policy
     /* 1959688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959698 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1959701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959722 */     // GIR_Coverage, 24902,
     /* 1959722 */     GIR_EraseRootFromParent_Done,
     /* 1959723 */   // Label 26295: @1959723
     /* 1959723 */   GIM_Try, /*On fail goto*//*Label 26296*/ GIMT_Encode4(1959809), // Rule ID 24903 //
     /* 1959728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1959731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1959736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1959739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1959742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1959745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1959748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959774 */     // MIs[0] policy
     /* 1959774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959784 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11520:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1959787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1959805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959808 */     // GIR_Coverage, 24903,
     /* 1959808 */     GIR_EraseRootFromParent_Done,
     /* 1959809 */   // Label 26296: @1959809
     /* 1959809 */   GIM_Try, /*On fail goto*//*Label 26297*/ GIMT_Encode4(1959895), // Rule ID 24906 //
     /* 1959814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1959817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1959825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1959828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1959831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1959834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959860 */     // MIs[0] policy
     /* 1959860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959870 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1959873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959894 */     // GIR_Coverage, 24906,
     /* 1959894 */     GIR_EraseRootFromParent_Done,
     /* 1959895 */   // Label 26297: @1959895
     /* 1959895 */   GIM_Try, /*On fail goto*//*Label 26298*/ GIMT_Encode4(1959981), // Rule ID 24907 //
     /* 1959900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1959903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1959911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1959914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1959917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1959920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1959942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959946 */     // MIs[0] policy
     /* 1959946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959956 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1959959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959980 */     // GIR_Coverage, 24907,
     /* 1959980 */     GIR_EraseRootFromParent_Done,
     /* 1959981 */   // Label 26298: @1959981
     /* 1959981 */   GIM_Try, /*On fail goto*//*Label 26299*/ GIMT_Encode4(1960067), // Rule ID 24910 //
     /* 1959986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1959989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1959994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1959997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960032 */     // MIs[0] policy
     /* 1960032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960042 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960066 */     // GIR_Coverage, 24910,
     /* 1960066 */     GIR_EraseRootFromParent_Done,
     /* 1960067 */   // Label 26299: @1960067
     /* 1960067 */   GIM_Try, /*On fail goto*//*Label 26300*/ GIMT_Encode4(1960153), // Rule ID 24911 //
     /* 1960072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1960075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1960083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1960086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1960089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960118 */     // MIs[0] policy
     /* 1960118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960128 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960152 */     // GIR_Coverage, 24911,
     /* 1960152 */     GIR_EraseRootFromParent_Done,
     /* 1960153 */   // Label 26300: @1960153
     /* 1960153 */   GIM_Try, /*On fail goto*//*Label 26301*/ GIMT_Encode4(1960239), // Rule ID 24914 //
     /* 1960158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1960161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960204 */     // MIs[0] policy
     /* 1960204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960214 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960238 */     // GIR_Coverage, 24914,
     /* 1960238 */     GIR_EraseRootFromParent_Done,
     /* 1960239 */   // Label 26301: @1960239
     /* 1960239 */   GIM_Try, /*On fail goto*//*Label 26302*/ GIMT_Encode4(1960325), // Rule ID 24915 //
     /* 1960244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1960247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1960255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1960258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960290 */     // MIs[0] policy
     /* 1960290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960300 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1960303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960324 */     // GIR_Coverage, 24915,
     /* 1960324 */     GIR_EraseRootFromParent_Done,
     /* 1960325 */   // Label 26302: @1960325
     /* 1960325 */   GIM_Try, /*On fail goto*//*Label 26303*/ GIMT_Encode4(1960411), // Rule ID 24918 //
     /* 1960330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1960333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960376 */     // MIs[0] policy
     /* 1960376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960386 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960410 */     // GIR_Coverage, 24918,
     /* 1960410 */     GIR_EraseRootFromParent_Done,
     /* 1960411 */   // Label 26303: @1960411
     /* 1960411 */   GIM_Try, /*On fail goto*//*Label 26304*/ GIMT_Encode4(1960497), // Rule ID 24919 //
     /* 1960416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1960419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1960427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1960430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1960433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960462 */     // MIs[0] policy
     /* 1960462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960472 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11522:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960496 */     // GIR_Coverage, 24919,
     /* 1960496 */     GIR_EraseRootFromParent_Done,
     /* 1960497 */   // Label 26304: @1960497
     /* 1960497 */   GIM_Try, /*On fail goto*//*Label 26305*/ GIMT_Encode4(1960583), // Rule ID 24922 //
     /* 1960502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1960505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1960513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1960516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960548 */     // MIs[0] policy
     /* 1960548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960558 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960582 */     // GIR_Coverage, 24922,
     /* 1960582 */     GIR_EraseRootFromParent_Done,
     /* 1960583 */   // Label 26305: @1960583
     /* 1960583 */   GIM_Try, /*On fail goto*//*Label 26306*/ GIMT_Encode4(1960669), // Rule ID 24923 //
     /* 1960588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1960591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1960599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1960602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960634 */     // MIs[0] policy
     /* 1960634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960644 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11522:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960668 */     // GIR_Coverage, 24923,
     /* 1960668 */     GIR_EraseRootFromParent_Done,
     /* 1960669 */   // Label 26306: @1960669
     /* 1960669 */   GIM_Try, /*On fail goto*//*Label 26307*/ GIMT_Encode4(1960755), // Rule ID 24926 //
     /* 1960674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1960677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1960685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1960688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1960691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960720 */     // MIs[0] policy
     /* 1960720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960730 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960754 */     // GIR_Coverage, 24926,
     /* 1960754 */     GIR_EraseRootFromParent_Done,
     /* 1960755 */   // Label 26307: @1960755
     /* 1960755 */   GIM_Try, /*On fail goto*//*Label 26308*/ GIMT_Encode4(1960841), // Rule ID 24927 //
     /* 1960760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1960763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1960771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1960774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1960777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960806 */     // MIs[0] policy
     /* 1960806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11522:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1960819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1960837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960840 */     // GIR_Coverage, 24927,
     /* 1960840 */     GIR_EraseRootFromParent_Done,
     /* 1960841 */   // Label 26308: @1960841
     /* 1960841 */   GIM_Try, /*On fail goto*//*Label 26309*/ GIMT_Encode4(1960927), // Rule ID 24930 //
     /* 1960846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1960849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1960857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1960860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1960863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960892 */     // MIs[0] policy
     /* 1960892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960902 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1960905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960926 */     // GIR_Coverage, 24930,
     /* 1960926 */     GIR_EraseRootFromParent_Done,
     /* 1960927 */   // Label 26309: @1960927
     /* 1960927 */   GIM_Try, /*On fail goto*//*Label 26310*/ GIMT_Encode4(1961013), // Rule ID 24931 //
     /* 1960932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1960935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1960940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1960943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1960946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1960949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1960952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1960974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960978 */     // MIs[0] policy
     /* 1960978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960988 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1960991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961012 */     // GIR_Coverage, 24931,
     /* 1961012 */     GIR_EraseRootFromParent_Done,
     /* 1961013 */   // Label 26310: @1961013
     /* 1961013 */   GIM_Try, /*On fail goto*//*Label 26311*/ GIMT_Encode4(1961099), // Rule ID 24934 //
     /* 1961018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1961021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961064 */     // MIs[0] policy
     /* 1961064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961074 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961098 */     // GIR_Coverage, 24934,
     /* 1961098 */     GIR_EraseRootFromParent_Done,
     /* 1961099 */   // Label 26311: @1961099
     /* 1961099 */   GIM_Try, /*On fail goto*//*Label 26312*/ GIMT_Encode4(1961185), // Rule ID 24935 //
     /* 1961104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1961107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1961121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961150 */     // MIs[0] policy
     /* 1961150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961160 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961184 */     // GIR_Coverage, 24935,
     /* 1961184 */     GIR_EraseRootFromParent_Done,
     /* 1961185 */   // Label 26312: @1961185
     /* 1961185 */   GIM_Try, /*On fail goto*//*Label 26313*/ GIMT_Encode4(1961271), // Rule ID 24938 //
     /* 1961190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1961193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961236 */     // MIs[0] policy
     /* 1961236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961246 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961270 */     // GIR_Coverage, 24938,
     /* 1961270 */     GIR_EraseRootFromParent_Done,
     /* 1961271 */   // Label 26313: @1961271
     /* 1961271 */   GIM_Try, /*On fail goto*//*Label 26314*/ GIMT_Encode4(1961357), // Rule ID 24939 //
     /* 1961276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1961279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1961293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961322 */     // MIs[0] policy
     /* 1961322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961332 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1961353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961356 */     // GIR_Coverage, 24939,
     /* 1961356 */     GIR_EraseRootFromParent_Done,
     /* 1961357 */   // Label 26314: @1961357
     /* 1961357 */   GIM_Try, /*On fail goto*//*Label 26315*/ GIMT_Encode4(1961443), // Rule ID 24942 //
     /* 1961362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1961365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961408 */     // MIs[0] policy
     /* 1961408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961418 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961442 */     // GIR_Coverage, 24942,
     /* 1961442 */     GIR_EraseRootFromParent_Done,
     /* 1961443 */   // Label 26315: @1961443
     /* 1961443 */   GIM_Try, /*On fail goto*//*Label 26316*/ GIMT_Encode4(1961529), // Rule ID 24943 //
     /* 1961448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1961451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1961459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1961462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1961465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961494 */     // MIs[0] policy
     /* 1961494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961504 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961528 */     // GIR_Coverage, 24943,
     /* 1961528 */     GIR_EraseRootFromParent_Done,
     /* 1961529 */   // Label 26316: @1961529
     /* 1961529 */   GIM_Try, /*On fail goto*//*Label 26317*/ GIMT_Encode4(1961615), // Rule ID 24946 //
     /* 1961534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1961537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1961545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1961548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1961551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961580 */     // MIs[0] policy
     /* 1961580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961590 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961614 */     // GIR_Coverage, 24946,
     /* 1961614 */     GIR_EraseRootFromParent_Done,
     /* 1961615 */   // Label 26317: @1961615
     /* 1961615 */   GIM_Try, /*On fail goto*//*Label 26318*/ GIMT_Encode4(1961701), // Rule ID 24947 //
     /* 1961620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1961623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1961631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1961634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1961637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961666 */     // MIs[0] policy
     /* 1961666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961676 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1961679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961700 */     // GIR_Coverage, 24947,
     /* 1961700 */     GIR_EraseRootFromParent_Done,
     /* 1961701 */   // Label 26318: @1961701
     /* 1961701 */   GIM_Try, /*On fail goto*//*Label 26319*/ GIMT_Encode4(1961787), // Rule ID 24950 //
     /* 1961706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1961709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1961717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1961720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1961723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961752 */     // MIs[0] policy
     /* 1961752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961762 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961786 */     // GIR_Coverage, 24950,
     /* 1961786 */     GIR_EraseRootFromParent_Done,
     /* 1961787 */   // Label 26319: @1961787
     /* 1961787 */   GIM_Try, /*On fail goto*//*Label 26320*/ GIMT_Encode4(1961873), // Rule ID 24951 //
     /* 1961792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1961795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1961803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1961806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1961809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961838 */     // MIs[0] policy
     /* 1961838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961848 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1961851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1961869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961872 */     // GIR_Coverage, 24951,
     /* 1961872 */     GIR_EraseRootFromParent_Done,
     /* 1961873 */   // Label 26320: @1961873
     /* 1961873 */   GIM_Try, /*On fail goto*//*Label 26321*/ GIMT_Encode4(1961959), // Rule ID 24954 //
     /* 1961878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1961881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1961889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1961892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1961895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961924 */     // MIs[0] policy
     /* 1961924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961934 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1961937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1961955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961958 */     // GIR_Coverage, 24954,
     /* 1961958 */     GIR_EraseRootFromParent_Done,
     /* 1961959 */   // Label 26321: @1961959
     /* 1961959 */   GIM_Try, /*On fail goto*//*Label 26322*/ GIMT_Encode4(1962045), // Rule ID 24955 //
     /* 1961964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1961967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1961972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1961975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1961978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1961981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962010 */     // MIs[0] policy
     /* 1962010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962020 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11522:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1962023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962044 */     // GIR_Coverage, 24955,
     /* 1962044 */     GIR_EraseRootFromParent_Done,
     /* 1962045 */   // Label 26322: @1962045
     /* 1962045 */   GIM_Try, /*On fail goto*//*Label 26323*/ GIMT_Encode4(1962131), // Rule ID 24958 //
     /* 1962050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1962053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962096 */     // MIs[0] policy
     /* 1962096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962106 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962130 */     // GIR_Coverage, 24958,
     /* 1962130 */     GIR_EraseRootFromParent_Done,
     /* 1962131 */   // Label 26323: @1962131
     /* 1962131 */   GIM_Try, /*On fail goto*//*Label 26324*/ GIMT_Encode4(1962217), // Rule ID 24959 //
     /* 1962136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1962139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1962147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1962150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1962153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962182 */     // MIs[0] policy
     /* 1962182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962192 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11522:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1962195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962216 */     // GIR_Coverage, 24959,
     /* 1962216 */     GIR_EraseRootFromParent_Done,
     /* 1962217 */   // Label 26324: @1962217
     /* 1962217 */   GIM_Try, /*On fail goto*//*Label 26325*/ GIMT_Encode4(1962303), // Rule ID 24962 //
     /* 1962222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1962225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962268 */     // MIs[0] policy
     /* 1962268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962278 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962302 */     // GIR_Coverage, 24962,
     /* 1962302 */     GIR_EraseRootFromParent_Done,
     /* 1962303 */   // Label 26325: @1962303
     /* 1962303 */   GIM_Try, /*On fail goto*//*Label 26326*/ GIMT_Encode4(1962389), // Rule ID 24963 //
     /* 1962308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1962311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1962316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1962319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1962322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1962325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962354 */     // MIs[0] policy
     /* 1962354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962364 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11522:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1962367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1962385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962388 */     // GIR_Coverage, 24963,
     /* 1962388 */     GIR_EraseRootFromParent_Done,
     /* 1962389 */   // Label 26326: @1962389
     /* 1962389 */   GIM_Try, /*On fail goto*//*Label 26327*/ GIMT_Encode4(1962475), // Rule ID 25026 //
     /* 1962394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /* 1962397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962440 */     // MIs[0] policy
     /* 1962440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962450 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1962453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962474 */     // GIR_Coverage, 25026,
     /* 1962474 */     GIR_EraseRootFromParent_Done,
     /* 1962475 */   // Label 26327: @1962475
     /* 1962475 */   GIM_Try, /*On fail goto*//*Label 26328*/ GIMT_Encode4(1962561), // Rule ID 25027 //
     /* 1962480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /* 1962483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1962491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1962494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962526 */     // MIs[0] policy
     /* 1962526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962536 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1962539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962560 */     // GIR_Coverage, 25027,
     /* 1962560 */     GIR_EraseRootFromParent_Done,
     /* 1962561 */   // Label 26328: @1962561
     /* 1962561 */   GIM_Try, /*On fail goto*//*Label 26329*/ GIMT_Encode4(1962647), // Rule ID 25030 //
     /* 1962566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /* 1962569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1962577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1962580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1962583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1962586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962612 */     // MIs[0] policy
     /* 1962612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962622 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1962625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962646 */     // GIR_Coverage, 25030,
     /* 1962646 */     GIR_EraseRootFromParent_Done,
     /* 1962647 */   // Label 26329: @1962647
     /* 1962647 */   GIM_Try, /*On fail goto*//*Label 26330*/ GIMT_Encode4(1962733), // Rule ID 25031 //
     /* 1962652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /* 1962655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1962663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1962666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1962669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1962672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962698 */     // MIs[0] policy
     /* 1962698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962708 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1962711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962732 */     // GIR_Coverage, 25031,
     /* 1962732 */     GIR_EraseRootFromParent_Done,
     /* 1962733 */   // Label 26330: @1962733
     /* 1962733 */   GIM_Try, /*On fail goto*//*Label 26331*/ GIMT_Encode4(1962819), // Rule ID 25034 //
     /* 1962738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1962741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962784 */     // MIs[0] policy
     /* 1962784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962794 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1962797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962818 */     // GIR_Coverage, 25034,
     /* 1962818 */     GIR_EraseRootFromParent_Done,
     /* 1962819 */   // Label 26331: @1962819
     /* 1962819 */   GIM_Try, /*On fail goto*//*Label 26332*/ GIMT_Encode4(1962905), // Rule ID 25035 //
     /* 1962824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1962827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1962844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962870 */     // MIs[0] policy
     /* 1962870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962880 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1962883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962904 */     // GIR_Coverage, 25035,
     /* 1962904 */     GIR_EraseRootFromParent_Done,
     /* 1962905 */   // Label 26332: @1962905
     /* 1962905 */   GIM_Try, /*On fail goto*//*Label 26333*/ GIMT_Encode4(1962991), // Rule ID 25038 //
     /* 1962910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /* 1962913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1962918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1962921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1962924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1962927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1962930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962956 */     // MIs[0] policy
     /* 1962956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962966 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1962969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962990 */     // GIR_Coverage, 25038,
     /* 1962990 */     GIR_EraseRootFromParent_Done,
     /* 1962991 */   // Label 26333: @1962991
     /* 1962991 */   GIM_Try, /*On fail goto*//*Label 26334*/ GIMT_Encode4(1963077), // Rule ID 25039 //
     /* 1962996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /* 1962999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1963007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1963010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1963013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1963016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963042 */     // MIs[0] policy
     /* 1963042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963052 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11524:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1963055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963076 */     // GIR_Coverage, 25039,
     /* 1963076 */     GIR_EraseRootFromParent_Done,
     /* 1963077 */   // Label 26334: @1963077
     /* 1963077 */   GIM_Try, /*On fail goto*//*Label 26335*/ GIMT_Encode4(1963163), // Rule ID 25042 //
     /* 1963082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1963085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1963093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1963096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963128 */     // MIs[0] policy
     /* 1963128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963138 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1963141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963162 */     // GIR_Coverage, 25042,
     /* 1963162 */     GIR_EraseRootFromParent_Done,
     /* 1963163 */   // Label 26335: @1963163
     /* 1963163 */   GIM_Try, /*On fail goto*//*Label 26336*/ GIMT_Encode4(1963249), // Rule ID 25043 //
     /* 1963168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1963171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1963179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1963182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1963188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963214 */     // MIs[0] policy
     /* 1963214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11524:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1963227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963248 */     // GIR_Coverage, 25043,
     /* 1963248 */     GIR_EraseRootFromParent_Done,
     /* 1963249 */   // Label 26336: @1963249
     /* 1963249 */   GIM_Try, /*On fail goto*//*Label 26337*/ GIMT_Encode4(1963335), // Rule ID 25046 //
     /* 1963254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1963257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963300 */     // MIs[0] policy
     /* 1963300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963310 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1963313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963334 */     // GIR_Coverage, 25046,
     /* 1963334 */     GIR_EraseRootFromParent_Done,
     /* 1963335 */   // Label 26337: @1963335
     /* 1963335 */   GIM_Try, /*On fail goto*//*Label 26338*/ GIMT_Encode4(1963421), // Rule ID 25047 //
     /* 1963340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1963343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1963360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963386 */     // MIs[0] policy
     /* 1963386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963396 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11524:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1963399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963420 */     // GIR_Coverage, 25047,
     /* 1963420 */     GIR_EraseRootFromParent_Done,
     /* 1963421 */   // Label 26338: @1963421
     /* 1963421 */   GIM_Try, /*On fail goto*//*Label 26339*/ GIMT_Encode4(1963507), // Rule ID 25050 //
     /* 1963426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /* 1963429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1963443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1963446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963472 */     // MIs[0] policy
     /* 1963472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963482 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1963485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963506 */     // GIR_Coverage, 25050,
     /* 1963506 */     GIR_EraseRootFromParent_Done,
     /* 1963507 */   // Label 26339: @1963507
     /* 1963507 */   GIM_Try, /*On fail goto*//*Label 26340*/ GIMT_Encode4(1963593), // Rule ID 25051 //
     /* 1963512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /* 1963515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1963523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1963526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1963529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1963532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963558 */     // MIs[0] policy
     /* 1963558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963568 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1963571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963592 */     // GIR_Coverage, 25051,
     /* 1963592 */     GIR_EraseRootFromParent_Done,
     /* 1963593 */   // Label 26340: @1963593
     /* 1963593 */   GIM_Try, /*On fail goto*//*Label 26341*/ GIMT_Encode4(1963679), // Rule ID 25054 //
     /* 1963598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /* 1963601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1963609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1963612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1963615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1963618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963644 */     // MIs[0] policy
     /* 1963644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963654 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1963657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963678 */     // GIR_Coverage, 25054,
     /* 1963678 */     GIR_EraseRootFromParent_Done,
     /* 1963679 */   // Label 26341: @1963679
     /* 1963679 */   GIM_Try, /*On fail goto*//*Label 26342*/ GIMT_Encode4(1963765), // Rule ID 25055 //
     /* 1963684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /* 1963687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1963695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1963698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1963701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1963704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1963707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963730 */     // MIs[0] policy
     /* 1963730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963740 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1963743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963764 */     // GIR_Coverage, 25055,
     /* 1963764 */     GIR_EraseRootFromParent_Done,
     /* 1963765 */   // Label 26342: @1963765
     /* 1963765 */   GIM_Try, /*On fail goto*//*Label 26343*/ GIMT_Encode4(1963851), // Rule ID 25058 //
     /* 1963770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode0),
     /* 1963773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1963781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1963784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1963787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1963790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963816 */     // MIs[0] policy
     /* 1963816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963826 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1963829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963850 */     // GIR_Coverage, 25058,
     /* 1963850 */     GIR_EraseRootFromParent_Done,
     /* 1963851 */   // Label 26343: @1963851
     /* 1963851 */   GIM_Try, /*On fail goto*//*Label 26344*/ GIMT_Encode4(1963937), // Rule ID 25059 //
     /* 1963856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16Minimal_HwMode1),
     /* 1963859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1963867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1963870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1963873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1963876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1963879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963902 */     // MIs[0] policy
     /* 1963902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963912 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1963915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1963933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963936 */     // GIR_Coverage, 25059,
     /* 1963936 */     GIR_EraseRootFromParent_Done,
     /* 1963937 */   // Label 26344: @1963937
     /* 1963937 */   GIM_Try, /*On fail goto*//*Label 26345*/ GIMT_Encode4(1964023), // Rule ID 25062 //
     /* 1963942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1963945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1963950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1963953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1963956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1963959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1963962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963988 */     // MIs[0] policy
     /* 1963988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963998 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1964001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964022 */     // GIR_Coverage, 25062,
     /* 1964022 */     GIR_EraseRootFromParent_Done,
     /* 1964023 */   // Label 26345: @1964023
     /* 1964023 */   GIM_Try, /*On fail goto*//*Label 26346*/ GIMT_Encode4(1964109), // Rule ID 25063 //
     /* 1964028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1964031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1964039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1964042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1964045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964074 */     // MIs[0] policy
     /* 1964074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964084 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1964087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964108 */     // GIR_Coverage, 25063,
     /* 1964108 */     GIR_EraseRootFromParent_Done,
     /* 1964109 */   // Label 26346: @1964109
     /* 1964109 */   GIM_Try, /*On fail goto*//*Label 26347*/ GIMT_Encode4(1964195), // Rule ID 25066 //
     /* 1964114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1964117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964160 */     // MIs[0] policy
     /* 1964160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964170 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1964173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964194 */     // GIR_Coverage, 25066,
     /* 1964194 */     GIR_EraseRootFromParent_Done,
     /* 1964195 */   // Label 26347: @1964195
     /* 1964195 */   GIM_Try, /*On fail goto*//*Label 26348*/ GIMT_Encode4(1964281), // Rule ID 25067 //
     /* 1964200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1964203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1964211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1964214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1964217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964246 */     // MIs[0] policy
     /* 1964246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964256 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1964259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964280 */     // GIR_Coverage, 25067,
     /* 1964280 */     GIR_EraseRootFromParent_Done,
     /* 1964281 */   // Label 26348: @1964281
     /* 1964281 */   GIM_Try, /*On fail goto*//*Label 26349*/ GIMT_Encode4(1964367), // Rule ID 25070 //
     /* 1964286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1964289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964332 */     // MIs[0] policy
     /* 1964332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964342 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1964345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964366 */     // GIR_Coverage, 25070,
     /* 1964366 */     GIR_EraseRootFromParent_Done,
     /* 1964367 */   // Label 26349: @1964367
     /* 1964367 */   GIM_Try, /*On fail goto*//*Label 26350*/ GIMT_Encode4(1964453), // Rule ID 25071 //
     /* 1964372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1964375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1964383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1964386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1964389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1964392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1964395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964418 */     // MIs[0] policy
     /* 1964418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964428 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1964431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1964449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964452 */     // GIR_Coverage, 25071,
     /* 1964452 */     GIR_EraseRootFromParent_Done,
     /* 1964453 */   // Label 26350: @1964453
     /* 1964453 */   GIM_Try, /*On fail goto*//*Label 26351*/ GIMT_Encode4(1964539), // Rule ID 25074 //
     /* 1964458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1964461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1964475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1964478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964504 */     // MIs[0] policy
     /* 1964504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964514 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1964517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964538 */     // GIR_Coverage, 25074,
     /* 1964538 */     GIR_EraseRootFromParent_Done,
     /* 1964539 */   // Label 26351: @1964539
     /* 1964539 */   GIM_Try, /*On fail goto*//*Label 26352*/ GIMT_Encode4(1964625), // Rule ID 25075 //
     /* 1964544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1964547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1964561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1964564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964590 */     // MIs[0] policy
     /* 1964590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964600 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11524:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1964603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964624 */     // GIR_Coverage, 25075,
     /* 1964624 */     GIR_EraseRootFromParent_Done,
     /* 1964625 */   // Label 26352: @1964625
     /* 1964625 */   GIM_Try, /*On fail goto*//*Label 26353*/ GIMT_Encode4(1964711), // Rule ID 25078 //
     /* 1964630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1964633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1964641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1964644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1964647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964676 */     // MIs[0] policy
     /* 1964676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964686 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1964689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964710 */     // GIR_Coverage, 25078,
     /* 1964710 */     GIR_EraseRootFromParent_Done,
     /* 1964711 */   // Label 26353: @1964711
     /* 1964711 */   GIM_Try, /*On fail goto*//*Label 26354*/ GIMT_Encode4(1964797), // Rule ID 25079 //
     /* 1964716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1964719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1964727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1964730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1964733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1964736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964762 */     // MIs[0] policy
     /* 1964762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964772 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11524:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1964775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964796 */     // GIR_Coverage, 25079,
     /* 1964796 */     GIR_EraseRootFromParent_Done,
     /* 1964797 */   // Label 26354: @1964797
     /* 1964797 */   GIM_Try, /*On fail goto*//*Label 26355*/ GIMT_Encode4(1964883), // Rule ID 25082 //
     /* 1964802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1964805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964848 */     // MIs[0] policy
     /* 1964848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964858 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1964861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964882 */     // GIR_Coverage, 25082,
     /* 1964882 */     GIR_EraseRootFromParent_Done,
     /* 1964883 */   // Label 26355: @1964883
     /* 1964883 */   GIM_Try, /*On fail goto*//*Label 26356*/ GIMT_Encode4(1964969), // Rule ID 25083 //
     /* 1964888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1964891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1964896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1964908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964934 */     // MIs[0] policy
     /* 1964934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964944 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11524:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1964947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964968 */     // GIR_Coverage, 25083,
     /* 1964968 */     GIR_EraseRootFromParent_Done,
     /* 1964969 */   // Label 26356: @1964969
     /* 1964969 */   GIM_Try, /*On fail goto*//*Label 26357*/ GIMT_Encode4(1965055), // Rule ID 60970 //
     /* 1964974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1964977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1964982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1964985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1964988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1964991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1964994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965020 */     // MIs[0] policy
     /* 1965020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1965033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965054 */     // GIR_Coverage, 60970,
     /* 1965054 */     GIR_EraseRootFromParent_Done,
     /* 1965055 */   // Label 26357: @1965055
     /* 1965055 */   GIM_Try, /*On fail goto*//*Label 26358*/ GIMT_Encode4(1965141), // Rule ID 60971 //
     /* 1965060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1965071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1965074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1965077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1965080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965106 */     // MIs[0] policy
     /* 1965106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1965119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965140 */     // GIR_Coverage, 60971,
     /* 1965140 */     GIR_EraseRootFromParent_Done,
     /* 1965141 */   // Label 26358: @1965141
     /* 1965141 */   GIM_Try, /*On fail goto*//*Label 26359*/ GIMT_Encode4(1965227), // Rule ID 60974 //
     /* 1965146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1965166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965192 */     // MIs[0] policy
     /* 1965192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965202 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1965205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965226 */     // GIR_Coverage, 60974,
     /* 1965226 */     GIR_EraseRootFromParent_Done,
     /* 1965227 */   // Label 26359: @1965227
     /* 1965227 */   GIM_Try, /*On fail goto*//*Label 26360*/ GIMT_Encode4(1965313), // Rule ID 60975 //
     /* 1965232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1965243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1965246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1965249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1965252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965278 */     // MIs[0] policy
     /* 1965278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965288 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1965291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965312 */     // GIR_Coverage, 60975,
     /* 1965312 */     GIR_EraseRootFromParent_Done,
     /* 1965313 */   // Label 26360: @1965313
     /* 1965313 */   GIM_Try, /*On fail goto*//*Label 26361*/ GIMT_Encode4(1965399), // Rule ID 60978 //
     /* 1965318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1965338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965364 */     // MIs[0] policy
     /* 1965364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965374 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1965377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965398 */     // GIR_Coverage, 60978,
     /* 1965398 */     GIR_EraseRootFromParent_Done,
     /* 1965399 */   // Label 26361: @1965399
     /* 1965399 */   GIM_Try, /*On fail goto*//*Label 26362*/ GIMT_Encode4(1965485), // Rule ID 60979 //
     /* 1965404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1965415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1965418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1965421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1965424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965450 */     // MIs[0] policy
     /* 1965450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965460 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1965463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965484 */     // GIR_Coverage, 60979,
     /* 1965484 */     GIR_EraseRootFromParent_Done,
     /* 1965485 */   // Label 26362: @1965485
     /* 1965485 */   GIM_Try, /*On fail goto*//*Label 26363*/ GIMT_Encode4(1965571), // Rule ID 60982 //
     /* 1965490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1965510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965536 */     // MIs[0] policy
     /* 1965536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1965549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965570 */     // GIR_Coverage, 60982,
     /* 1965570 */     GIR_EraseRootFromParent_Done,
     /* 1965571 */   // Label 26363: @1965571
     /* 1965571 */   GIM_Try, /*On fail goto*//*Label 26364*/ GIMT_Encode4(1965657), // Rule ID 60983 //
     /* 1965576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1965587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1965590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1965593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1965596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965622 */     // MIs[0] policy
     /* 1965622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965632 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1965635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965656 */     // GIR_Coverage, 60983,
     /* 1965656 */     GIR_EraseRootFromParent_Done,
     /* 1965657 */   // Label 26364: @1965657
     /* 1965657 */   GIM_Try, /*On fail goto*//*Label 26365*/ GIMT_Encode4(1965743), // Rule ID 60986 //
     /* 1965662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1965673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1965676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1965679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1965682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1965685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965708 */     // MIs[0] policy
     /* 1965708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965718 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1965721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965742 */     // GIR_Coverage, 60986,
     /* 1965742 */     GIR_EraseRootFromParent_Done,
     /* 1965743 */   // Label 26365: @1965743
     /* 1965743 */   GIM_Try, /*On fail goto*//*Label 26366*/ GIMT_Encode4(1965829), // Rule ID 60987 //
     /* 1965748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1965759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1965762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1965765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1965768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1965771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965794 */     // MIs[0] policy
     /* 1965794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965804 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1965807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965828 */     // GIR_Coverage, 60987,
     /* 1965828 */     GIR_EraseRootFromParent_Done,
     /* 1965829 */   // Label 26366: @1965829
     /* 1965829 */   GIM_Try, /*On fail goto*//*Label 26367*/ GIMT_Encode4(1965915), // Rule ID 60990 //
     /* 1965834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1965837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1965845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1965848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1965851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1965854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1965857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965880 */     // MIs[0] policy
     /* 1965880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965890 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1965893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965914 */     // GIR_Coverage, 60990,
     /* 1965914 */     GIR_EraseRootFromParent_Done,
     /* 1965915 */   // Label 26367: @1965915
     /* 1965915 */   GIM_Try, /*On fail goto*//*Label 26368*/ GIMT_Encode4(1966001), // Rule ID 60991 //
     /* 1965920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1965923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1965928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1965931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1965934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1965937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1965940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1965943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965966 */     // MIs[0] policy
     /* 1965966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965976 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1965979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1965997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966000 */     // GIR_Coverage, 60991,
     /* 1966000 */     GIR_EraseRootFromParent_Done,
     /* 1966001 */   // Label 26368: @1966001
     /* 1966001 */   GIM_Try, /*On fail goto*//*Label 26369*/ GIMT_Encode4(1966087), // Rule ID 60994 //
     /* 1966006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966052 */     // MIs[0] policy
     /* 1966052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966062 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1966065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966086 */     // GIR_Coverage, 60994,
     /* 1966086 */     GIR_EraseRootFromParent_Done,
     /* 1966087 */   // Label 26369: @1966087
     /* 1966087 */   GIM_Try, /*On fail goto*//*Label 26370*/ GIMT_Encode4(1966173), // Rule ID 60995 //
     /* 1966092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1966103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1966106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966138 */     // MIs[0] policy
     /* 1966138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1966151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966172 */     // GIR_Coverage, 60995,
     /* 1966172 */     GIR_EraseRootFromParent_Done,
     /* 1966173 */   // Label 26370: @1966173
     /* 1966173 */   GIM_Try, /*On fail goto*//*Label 26371*/ GIMT_Encode4(1966259), // Rule ID 60998 //
     /* 1966178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966224 */     // MIs[0] policy
     /* 1966224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966258 */     // GIR_Coverage, 60998,
     /* 1966258 */     GIR_EraseRootFromParent_Done,
     /* 1966259 */   // Label 26371: @1966259
     /* 1966259 */   GIM_Try, /*On fail goto*//*Label 26372*/ GIMT_Encode4(1966345), // Rule ID 60999 //
     /* 1966264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1966275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1966278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1966281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1966284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966310 */     // MIs[0] policy
     /* 1966310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966344 */     // GIR_Coverage, 60999,
     /* 1966344 */     GIR_EraseRootFromParent_Done,
     /* 1966345 */   // Label 26372: @1966345
     /* 1966345 */   GIM_Try, /*On fail goto*//*Label 26373*/ GIMT_Encode4(1966431), // Rule ID 61002 //
     /* 1966350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966396 */     // MIs[0] policy
     /* 1966396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966430 */     // GIR_Coverage, 61002,
     /* 1966430 */     GIR_EraseRootFromParent_Done,
     /* 1966431 */   // Label 26373: @1966431
     /* 1966431 */   GIM_Try, /*On fail goto*//*Label 26374*/ GIMT_Encode4(1966517), // Rule ID 61003 //
     /* 1966436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1966447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1966450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1966453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1966456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1966466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966482 */     // MIs[0] policy
     /* 1966482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1966495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966516 */     // GIR_Coverage, 61003,
     /* 1966516 */     GIR_EraseRootFromParent_Done,
     /* 1966517 */   // Label 26374: @1966517
     /* 1966517 */   GIM_Try, /*On fail goto*//*Label 26375*/ GIMT_Encode4(1966603), // Rule ID 61006 //
     /* 1966522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1966533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1966536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1966539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1966542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966568 */     // MIs[0] policy
     /* 1966568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966578 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1966581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966602 */     // GIR_Coverage, 61006,
     /* 1966602 */     GIR_EraseRootFromParent_Done,
     /* 1966603 */   // Label 26375: @1966603
     /* 1966603 */   GIM_Try, /*On fail goto*//*Label 26376*/ GIMT_Encode4(1966689), // Rule ID 61007 //
     /* 1966608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1966619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1966622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1966625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1966628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1966650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966654 */     // MIs[0] policy
     /* 1966654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966664 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1966667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966688 */     // GIR_Coverage, 61007,
     /* 1966688 */     GIR_EraseRootFromParent_Done,
     /* 1966689 */   // Label 26376: @1966689
     /* 1966689 */   GIM_Try, /*On fail goto*//*Label 26377*/ GIMT_Encode4(1966775), // Rule ID 61010 //
     /* 1966694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1966705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1966708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1966711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1966714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966740 */     // MIs[0] policy
     /* 1966740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1966753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966774 */     // GIR_Coverage, 61010,
     /* 1966774 */     GIR_EraseRootFromParent_Done,
     /* 1966775 */   // Label 26377: @1966775
     /* 1966775 */   GIM_Try, /*On fail goto*//*Label 26378*/ GIMT_Encode4(1966861), // Rule ID 61011 //
     /* 1966780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1966791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1966794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1966797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1966800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1966803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966826 */     // MIs[0] policy
     /* 1966826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966836 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1966839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966860 */     // GIR_Coverage, 61011,
     /* 1966860 */     GIR_EraseRootFromParent_Done,
     /* 1966861 */   // Label 26378: @1966861
     /* 1966861 */   GIM_Try, /*On fail goto*//*Label 26379*/ GIMT_Encode4(1966947), // Rule ID 61014 //
     /* 1966866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1966869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1966877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1966880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1966883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1966886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966912 */     // MIs[0] policy
     /* 1966912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966922 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1966925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1966943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966946 */     // GIR_Coverage, 61014,
     /* 1966946 */     GIR_EraseRootFromParent_Done,
     /* 1966947 */   // Label 26379: @1966947
     /* 1966947 */   GIM_Try, /*On fail goto*//*Label 26380*/ GIMT_Encode4(1967033), // Rule ID 61015 //
     /* 1966952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1966955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1966960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1966963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1966966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1966969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1966972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966998 */     // MIs[0] policy
     /* 1966998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1967011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967032 */     // GIR_Coverage, 61015,
     /* 1967032 */     GIR_EraseRootFromParent_Done,
     /* 1967033 */   // Label 26380: @1967033
     /* 1967033 */   GIM_Try, /*On fail goto*//*Label 26381*/ GIMT_Encode4(1967119), // Rule ID 61018 //
     /* 1967038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967084 */     // MIs[0] policy
     /* 1967084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1967097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967118 */     // GIR_Coverage, 61018,
     /* 1967118 */     GIR_EraseRootFromParent_Done,
     /* 1967119 */   // Label 26381: @1967119
     /* 1967119 */   GIM_Try, /*On fail goto*//*Label 26382*/ GIMT_Encode4(1967205), // Rule ID 61019 //
     /* 1967124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1967135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1967138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1967154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967170 */     // MIs[0] policy
     /* 1967170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967180 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1967183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967204 */     // GIR_Coverage, 61019,
     /* 1967204 */     GIR_EraseRootFromParent_Done,
     /* 1967205 */   // Label 26382: @1967205
     /* 1967205 */   GIM_Try, /*On fail goto*//*Label 26383*/ GIMT_Encode4(1967291), // Rule ID 61022 //
     /* 1967210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1967230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967256 */     // MIs[0] policy
     /* 1967256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967266 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967290 */     // GIR_Coverage, 61022,
     /* 1967290 */     GIR_EraseRootFromParent_Done,
     /* 1967291 */   // Label 26383: @1967291
     /* 1967291 */   GIM_Try, /*On fail goto*//*Label 26384*/ GIMT_Encode4(1967377), // Rule ID 61023 //
     /* 1967296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1967307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1967310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1967313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1967316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1967326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1967338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967342 */     // MIs[0] policy
     /* 1967342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1967355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967376 */     // GIR_Coverage, 61023,
     /* 1967376 */     GIR_EraseRootFromParent_Done,
     /* 1967377 */   // Label 26384: @1967377
     /* 1967377 */   GIM_Try, /*On fail goto*//*Label 26385*/ GIMT_Encode4(1967463), // Rule ID 61026 //
     /* 1967382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1967402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967428 */     // MIs[0] policy
     /* 1967428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967438 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967462 */     // GIR_Coverage, 61026,
     /* 1967462 */     GIR_EraseRootFromParent_Done,
     /* 1967463 */   // Label 26385: @1967463
     /* 1967463 */   GIM_Try, /*On fail goto*//*Label 26386*/ GIMT_Encode4(1967549), // Rule ID 61027 //
     /* 1967468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1967479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1967482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1967485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1967488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1967498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1967502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1967510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967514 */     // MIs[0] policy
     /* 1967514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967524 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1967527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967548 */     // GIR_Coverage, 61027,
     /* 1967548 */     GIR_EraseRootFromParent_Done,
     /* 1967549 */   // Label 26386: @1967549
     /* 1967549 */   GIM_Try, /*On fail goto*//*Label 26387*/ GIMT_Encode4(1967635), // Rule ID 61030 //
     /* 1967554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1967565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1967568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1967571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967600 */     // MIs[0] policy
     /* 1967600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967610 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1967613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967634 */     // GIR_Coverage, 61030,
     /* 1967634 */     GIR_EraseRootFromParent_Done,
     /* 1967635 */   // Label 26387: @1967635
     /* 1967635 */   GIM_Try, /*On fail goto*//*Label 26388*/ GIMT_Encode4(1967721), // Rule ID 61031 //
     /* 1967640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1967651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1967654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1967657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967686 */     // MIs[0] policy
     /* 1967686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1967699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967720 */     // GIR_Coverage, 61031,
     /* 1967720 */     GIR_EraseRootFromParent_Done,
     /* 1967721 */   // Label 26388: @1967721
     /* 1967721 */   GIM_Try, /*On fail goto*//*Label 26389*/ GIMT_Encode4(1967807), // Rule ID 61038 //
     /* 1967726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1967737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1967740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1967743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967772 */     // MIs[0] policy
     /* 1967772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967782 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1967785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967806 */     // GIR_Coverage, 61038,
     /* 1967806 */     GIR_EraseRootFromParent_Done,
     /* 1967807 */   // Label 26389: @1967807
     /* 1967807 */   GIM_Try, /*On fail goto*//*Label 26390*/ GIMT_Encode4(1967893), // Rule ID 61039 //
     /* 1967812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1967823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1967826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1967829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1967832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967858 */     // MIs[0] policy
     /* 1967858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967868 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1967871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967892 */     // GIR_Coverage, 61039,
     /* 1967892 */     GIR_EraseRootFromParent_Done,
     /* 1967893 */   // Label 26390: @1967893
     /* 1967893 */   GIM_Try, /*On fail goto*//*Label 26391*/ GIMT_Encode4(1967979), // Rule ID 61046 //
     /* 1967898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1967901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1967909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1967912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1967915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1967918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1967940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967944 */     // MIs[0] policy
     /* 1967944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967954 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1967957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967978 */     // GIR_Coverage, 61046,
     /* 1967978 */     GIR_EraseRootFromParent_Done,
     /* 1967979 */   // Label 26391: @1967979
     /* 1967979 */   GIM_Try, /*On fail goto*//*Label 26392*/ GIMT_Encode4(1968065), // Rule ID 61047 //
     /* 1967984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1967987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1967992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1967995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1967998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1968001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968030 */     // MIs[0] policy
     /* 1968030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11666:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968064 */     // GIR_Coverage, 61047,
     /* 1968064 */     GIR_EraseRootFromParent_Done,
     /* 1968065 */   // Label 26392: @1968065
     /* 1968065 */   GIM_Try, /*On fail goto*//*Label 26393*/ GIMT_Encode4(1968151), // Rule ID 61054 //
     /* 1968070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1968087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968116 */     // MIs[0] policy
     /* 1968116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968126 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1968129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968150 */     // GIR_Coverage, 61054,
     /* 1968150 */     GIR_EraseRootFromParent_Done,
     /* 1968151 */   // Label 26393: @1968151
     /* 1968151 */   GIM_Try, /*On fail goto*//*Label 26394*/ GIMT_Encode4(1968237), // Rule ID 61055 //
     /* 1968156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1968173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968202 */     // MIs[0] policy
     /* 1968202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1968215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968236 */     // GIR_Coverage, 61055,
     /* 1968236 */     GIR_EraseRootFromParent_Done,
     /* 1968237 */   // Label 26394: @1968237
     /* 1968237 */   GIM_Try, /*On fail goto*//*Label 26395*/ GIMT_Encode4(1968323), // Rule ID 61062 //
     /* 1968242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968288 */     // MIs[0] policy
     /* 1968288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968298 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1968301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968322 */     // GIR_Coverage, 61062,
     /* 1968322 */     GIR_EraseRootFromParent_Done,
     /* 1968323 */   // Label 26395: @1968323
     /* 1968323 */   GIM_Try, /*On fail goto*//*Label 26396*/ GIMT_Encode4(1968409), // Rule ID 61063 //
     /* 1968328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968374 */     // MIs[0] policy
     /* 1968374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1968387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968408 */     // GIR_Coverage, 61063,
     /* 1968408 */     GIR_EraseRootFromParent_Done,
     /* 1968409 */   // Label 26396: @1968409
     /* 1968409 */   GIM_Try, /*On fail goto*//*Label 26397*/ GIMT_Encode4(1968495), // Rule ID 61070 //
     /* 1968414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968460 */     // MIs[0] policy
     /* 1968460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968470 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1968473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968494 */     // GIR_Coverage, 61070,
     /* 1968494 */     GIR_EraseRootFromParent_Done,
     /* 1968495 */   // Label 26397: @1968495
     /* 1968495 */   GIM_Try, /*On fail goto*//*Label 26398*/ GIMT_Encode4(1968581), // Rule ID 61071 //
     /* 1968500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968546 */     // MIs[0] policy
     /* 1968546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1968559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968580 */     // GIR_Coverage, 61071,
     /* 1968580 */     GIR_EraseRootFromParent_Done,
     /* 1968581 */   // Label 26398: @1968581
     /* 1968581 */   GIM_Try, /*On fail goto*//*Label 26399*/ GIMT_Encode4(1968667), // Rule ID 61078 //
     /* 1968586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1968597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1968600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1968603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968632 */     // MIs[0] policy
     /* 1968632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968642 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1968645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968666 */     // GIR_Coverage, 61078,
     /* 1968666 */     GIR_EraseRootFromParent_Done,
     /* 1968667 */   // Label 26399: @1968667
     /* 1968667 */   GIM_Try, /*On fail goto*//*Label 26400*/ GIMT_Encode4(1968753), // Rule ID 61079 //
     /* 1968672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1968683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1968686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1968689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1968695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968718 */     // MIs[0] policy
     /* 1968718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968728 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1968731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968752 */     // GIR_Coverage, 61079,
     /* 1968752 */     GIR_EraseRootFromParent_Done,
     /* 1968753 */   // Label 26400: @1968753
     /* 1968753 */   GIM_Try, /*On fail goto*//*Label 26401*/ GIMT_Encode4(1968839), // Rule ID 61086 //
     /* 1968758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1968769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1968772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1968775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968804 */     // MIs[0] policy
     /* 1968804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968838 */     // GIR_Coverage, 61086,
     /* 1968838 */     GIR_EraseRootFromParent_Done,
     /* 1968839 */   // Label 26401: @1968839
     /* 1968839 */   GIM_Try, /*On fail goto*//*Label 26402*/ GIMT_Encode4(1968925), // Rule ID 61087 //
     /* 1968844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1968847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1968855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1968858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1968861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1968864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1968867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1968874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968890 */     // MIs[0] policy
     /* 1968890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11666:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1968903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968924 */     // GIR_Coverage, 61087,
     /* 1968924 */     GIR_EraseRootFromParent_Done,
     /* 1968925 */   // Label 26402: @1968925
     /* 1968925 */   GIM_Try, /*On fail goto*//*Label 26403*/ GIMT_Encode4(1969011), // Rule ID 61094 //
     /* 1968930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1968933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1968938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1968941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1968944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1968947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1968950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1968953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1968968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1968972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968976 */     // MIs[0] policy
     /* 1968976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1968989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969010 */     // GIR_Coverage, 61094,
     /* 1969010 */     GIR_EraseRootFromParent_Done,
     /* 1969011 */   // Label 26403: @1969011
     /* 1969011 */   GIM_Try, /*On fail goto*//*Label 26404*/ GIMT_Encode4(1969097), // Rule ID 61095 //
     /* 1969016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1969027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1969030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1969033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969062 */     // MIs[0] policy
     /* 1969062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969096 */     // GIR_Coverage, 61095,
     /* 1969096 */     GIR_EraseRootFromParent_Done,
     /* 1969097 */   // Label 26404: @1969097
     /* 1969097 */   GIM_Try, /*On fail goto*//*Label 26405*/ GIMT_Encode4(1969183), // Rule ID 61102 //
     /* 1969102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1969119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969148 */     // MIs[0] policy
     /* 1969148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969182 */     // GIR_Coverage, 61102,
     /* 1969182 */     GIR_EraseRootFromParent_Done,
     /* 1969183 */   // Label 26405: @1969183
     /* 1969183 */   GIM_Try, /*On fail goto*//*Label 26406*/ GIMT_Encode4(1969269), // Rule ID 61103 //
     /* 1969188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1969205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969234 */     // MIs[0] policy
     /* 1969234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969244 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969268 */     // GIR_Coverage, 61103,
     /* 1969268 */     GIR_EraseRootFromParent_Done,
     /* 1969269 */   // Label 26406: @1969269
     /* 1969269 */   GIM_Try, /*On fail goto*//*Label 26407*/ GIMT_Encode4(1969355), // Rule ID 61110 //
     /* 1969274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1969291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969320 */     // MIs[0] policy
     /* 1969320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969354 */     // GIR_Coverage, 61110,
     /* 1969354 */     GIR_EraseRootFromParent_Done,
     /* 1969355 */   // Label 26407: @1969355
     /* 1969355 */   GIM_Try, /*On fail goto*//*Label 26408*/ GIMT_Encode4(1969441), // Rule ID 61111 //
     /* 1969360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1969377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969406 */     // MIs[0] policy
     /* 1969406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969416 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1969419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969440 */     // GIR_Coverage, 61111,
     /* 1969440 */     GIR_EraseRootFromParent_Done,
     /* 1969441 */   // Label 26408: @1969441
     /* 1969441 */   GIM_Try, /*On fail goto*//*Label 26409*/ GIMT_Encode4(1969527), // Rule ID 61118 //
     /* 1969446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1969457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1969460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1969463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969492 */     // MIs[0] policy
     /* 1969492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969526 */     // GIR_Coverage, 61118,
     /* 1969526 */     GIR_EraseRootFromParent_Done,
     /* 1969527 */   // Label 26409: @1969527
     /* 1969527 */   GIM_Try, /*On fail goto*//*Label 26410*/ GIMT_Encode4(1969613), // Rule ID 61119 //
     /* 1969532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1969543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1969546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1969549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1969555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1969562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969578 */     // MIs[0] policy
     /* 1969578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969588 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11666:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1969591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969612 */     // GIR_Coverage, 61119,
     /* 1969612 */     GIR_EraseRootFromParent_Done,
     /* 1969613 */   // Label 26410: @1969613
     /* 1969613 */   GIM_Try, /*On fail goto*//*Label 26411*/ GIMT_Encode4(1969699), // Rule ID 61126 //
     /* 1969618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1969629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1969632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1969635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969664 */     // MIs[0] policy
     /* 1969664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969698 */     // GIR_Coverage, 61126,
     /* 1969698 */     GIR_EraseRootFromParent_Done,
     /* 1969699 */   // Label 26411: @1969699
     /* 1969699 */   GIM_Try, /*On fail goto*//*Label 26412*/ GIMT_Encode4(1969785), // Rule ID 61127 //
     /* 1969704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1969715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1969718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1969721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1969742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969750 */     // MIs[0] policy
     /* 1969750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11666:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1969763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969784 */     // GIR_Coverage, 61127,
     /* 1969784 */     GIR_EraseRootFromParent_Done,
     /* 1969785 */   // Label 26412: @1969785
     /* 1969785 */   GIM_Try, /*On fail goto*//*Label 26413*/ GIMT_Encode4(1969871), // Rule ID 61134 //
     /* 1969790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1969807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969836 */     // MIs[0] policy
     /* 1969836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969870 */     // GIR_Coverage, 61134,
     /* 1969870 */     GIR_EraseRootFromParent_Done,
     /* 1969871 */   // Label 26413: @1969871
     /* 1969871 */   GIM_Try, /*On fail goto*//*Label 26414*/ GIMT_Encode4(1969957), // Rule ID 61135 //
     /* 1969876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1969879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1969893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1969896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1969918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969922 */     // MIs[0] policy
     /* 1969922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11666:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1969935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969956 */     // GIR_Coverage, 61135,
     /* 1969956 */     GIR_EraseRootFromParent_Done,
     /* 1969957 */   // Label 26414: @1969957
     /* 1969957 */   GIM_Try, /*On fail goto*//*Label 26415*/ GIMT_Encode4(1970043), // Rule ID 61142 //
     /* 1969962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1969965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1969970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1969973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1969976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1969979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1969982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970008 */     // MIs[0] policy
     /* 1970008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970018 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1970021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970042 */     // GIR_Coverage, 61142,
     /* 1970042 */     GIR_EraseRootFromParent_Done,
     /* 1970043 */   // Label 26415: @1970043
     /* 1970043 */   GIM_Try, /*On fail goto*//*Label 26416*/ GIMT_Encode4(1970129), // Rule ID 61143 //
     /* 1970048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1970051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1970056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1970065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970094 */     // MIs[0] policy
     /* 1970094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970104 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11666:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1970107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1970125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970128 */     // GIR_Coverage, 61143,
     /* 1970128 */     GIR_EraseRootFromParent_Done,
     /* 1970129 */   // Label 26416: @1970129
     /* 1970129 */   GIM_Try, /*On fail goto*//*Label 26417*/ GIMT_Encode4(1970215), // Rule ID 61150 //
     /* 1970134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1970154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970180 */     // MIs[0] policy
     /* 1970180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1970193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970214 */     // GIR_Coverage, 61150,
     /* 1970214 */     GIR_EraseRootFromParent_Done,
     /* 1970215 */   // Label 26417: @1970215
     /* 1970215 */   GIM_Try, /*On fail goto*//*Label 26418*/ GIMT_Encode4(1970301), // Rule ID 61151 //
     /* 1970220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1970240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970266 */     // MIs[0] policy
     /* 1970266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1970279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970300 */     // GIR_Coverage, 61151,
     /* 1970300 */     GIR_EraseRootFromParent_Done,
     /* 1970301 */   // Label 26418: @1970301
     /* 1970301 */   GIM_Try, /*On fail goto*//*Label 26419*/ GIMT_Encode4(1970387), // Rule ID 61154 //
     /* 1970306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1970326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970352 */     // MIs[0] policy
     /* 1970352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970362 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1970365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970386 */     // GIR_Coverage, 61154,
     /* 1970386 */     GIR_EraseRootFromParent_Done,
     /* 1970387 */   // Label 26419: @1970387
     /* 1970387 */   GIM_Try, /*On fail goto*//*Label 26420*/ GIMT_Encode4(1970473), // Rule ID 61155 //
     /* 1970392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1970403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1970406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1970409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1970412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1970422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1970434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970438 */     // MIs[0] policy
     /* 1970438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1970451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970472 */     // GIR_Coverage, 61155,
     /* 1970472 */     GIR_EraseRootFromParent_Done,
     /* 1970473 */   // Label 26420: @1970473
     /* 1970473 */   GIM_Try, /*On fail goto*//*Label 26421*/ GIMT_Encode4(1970559), // Rule ID 61158 //
     /* 1970478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1970495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1970498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970524 */     // MIs[0] policy
     /* 1970524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970534 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1970537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970558 */     // GIR_Coverage, 61158,
     /* 1970558 */     GIR_EraseRootFromParent_Done,
     /* 1970559 */   // Label 26421: @1970559
     /* 1970559 */   GIM_Try, /*On fail goto*//*Label 26422*/ GIMT_Encode4(1970645), // Rule ID 61159 //
     /* 1970564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1970575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1970578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1970581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1970584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1970594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1970606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970610 */     // MIs[0] policy
     /* 1970610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970620 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1970623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970644 */     // GIR_Coverage, 61159,
     /* 1970644 */     GIR_EraseRootFromParent_Done,
     /* 1970645 */   // Label 26422: @1970645
     /* 1970645 */   GIM_Try, /*On fail goto*//*Label 26423*/ GIMT_Encode4(1970731), // Rule ID 61162 //
     /* 1970650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1970667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1970670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970696 */     // MIs[0] policy
     /* 1970696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970706 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1970709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970730 */     // GIR_Coverage, 61162,
     /* 1970730 */     GIR_EraseRootFromParent_Done,
     /* 1970731 */   // Label 26423: @1970731
     /* 1970731 */   GIM_Try, /*On fail goto*//*Label 26424*/ GIMT_Encode4(1970817), // Rule ID 61163 //
     /* 1970736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1970753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1970756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970782 */     // MIs[0] policy
     /* 1970782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970792 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1970795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970816 */     // GIR_Coverage, 61163,
     /* 1970816 */     GIR_EraseRootFromParent_Done,
     /* 1970817 */   // Label 26424: @1970817
     /* 1970817 */   GIM_Try, /*On fail goto*//*Label 26425*/ GIMT_Encode4(1970903), // Rule ID 61166 //
     /* 1970822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970868 */     // MIs[0] policy
     /* 1970868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970878 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1970881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970902 */     // GIR_Coverage, 61166,
     /* 1970902 */     GIR_EraseRootFromParent_Done,
     /* 1970903 */   // Label 26425: @1970903
     /* 1970903 */   GIM_Try, /*On fail goto*//*Label 26426*/ GIMT_Encode4(1970989), // Rule ID 61167 //
     /* 1970908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1970911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1970916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1970919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1970922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1970925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970954 */     // MIs[0] policy
     /* 1970954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1970967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970988 */     // GIR_Coverage, 61167,
     /* 1970988 */     GIR_EraseRootFromParent_Done,
     /* 1970989 */   // Label 26426: @1970989
     /* 1970989 */   GIM_Try, /*On fail goto*//*Label 26427*/ GIMT_Encode4(1971075), // Rule ID 61170 //
     /* 1970994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1970997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971040 */     // MIs[0] policy
     /* 1971040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971050 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1971053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971074 */     // GIR_Coverage, 61170,
     /* 1971074 */     GIR_EraseRootFromParent_Done,
     /* 1971075 */   // Label 26427: @1971075
     /* 1971075 */   GIM_Try, /*On fail goto*//*Label 26428*/ GIMT_Encode4(1971161), // Rule ID 61171 //
     /* 1971080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971126 */     // MIs[0] policy
     /* 1971126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1971139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971160 */     // GIR_Coverage, 61171,
     /* 1971160 */     GIR_EraseRootFromParent_Done,
     /* 1971161 */   // Label 26428: @1971161
     /* 1971161 */   GIM_Try, /*On fail goto*//*Label 26429*/ GIMT_Encode4(1971247), // Rule ID 61174 //
     /* 1971166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971212 */     // MIs[0] policy
     /* 1971212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971222 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1971225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971246 */     // GIR_Coverage, 61174,
     /* 1971246 */     GIR_EraseRootFromParent_Done,
     /* 1971247 */   // Label 26429: @1971247
     /* 1971247 */   GIM_Try, /*On fail goto*//*Label 26430*/ GIMT_Encode4(1971333), // Rule ID 61175 //
     /* 1971252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971298 */     // MIs[0] policy
     /* 1971298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971308 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1971311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971332 */     // GIR_Coverage, 61175,
     /* 1971332 */     GIR_EraseRootFromParent_Done,
     /* 1971333 */   // Label 26430: @1971333
     /* 1971333 */   GIM_Try, /*On fail goto*//*Label 26431*/ GIMT_Encode4(1971419), // Rule ID 61178 //
     /* 1971338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971384 */     // MIs[0] policy
     /* 1971384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1971397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971418 */     // GIR_Coverage, 61178,
     /* 1971418 */     GIR_EraseRootFromParent_Done,
     /* 1971419 */   // Label 26431: @1971419
     /* 1971419 */   GIM_Try, /*On fail goto*//*Label 26432*/ GIMT_Encode4(1971505), // Rule ID 61179 //
     /* 1971424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1971432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1971435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1971438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1971441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1971454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1971462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971470 */     // MIs[0] policy
     /* 1971470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971480 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11169:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1971483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971504 */     // GIR_Coverage, 61179,
     /* 1971504 */     GIR_EraseRootFromParent_Done,
     /* 1971505 */   // Label 26432: @1971505
     /* 1971505 */   GIM_Try, /*On fail goto*//*Label 26433*/ GIMT_Encode4(1971591), // Rule ID 61182 //
     /* 1971510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1971530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971556 */     // MIs[0] policy
     /* 1971556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1971569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971590 */     // GIR_Coverage, 61182,
     /* 1971590 */     GIR_EraseRootFromParent_Done,
     /* 1971591 */   // Label 26433: @1971591
     /* 1971591 */   GIM_Try, /*On fail goto*//*Label 26434*/ GIMT_Encode4(1971677), // Rule ID 61183 //
     /* 1971596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1971616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971642 */     // MIs[0] policy
     /* 1971642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1971655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971676 */     // GIR_Coverage, 61183,
     /* 1971676 */     GIR_EraseRootFromParent_Done,
     /* 1971677 */   // Label 26434: @1971677
     /* 1971677 */   GIM_Try, /*On fail goto*//*Label 26435*/ GIMT_Encode4(1971763), // Rule ID 61186 //
     /* 1971682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1971702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971728 */     // MIs[0] policy
     /* 1971728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971738 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1971741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971762 */     // GIR_Coverage, 61186,
     /* 1971762 */     GIR_EraseRootFromParent_Done,
     /* 1971763 */   // Label 26435: @1971763
     /* 1971763 */   GIM_Try, /*On fail goto*//*Label 26436*/ GIMT_Encode4(1971849), // Rule ID 61187 //
     /* 1971768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1971779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1971782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1971785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1971788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971814 */     // MIs[0] policy
     /* 1971814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1971827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971848 */     // GIR_Coverage, 61187,
     /* 1971848 */     GIR_EraseRootFromParent_Done,
     /* 1971849 */   // Label 26436: @1971849
     /* 1971849 */   GIM_Try, /*On fail goto*//*Label 26437*/ GIMT_Encode4(1971935), // Rule ID 61190 //
     /* 1971854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1971857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1971874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971900 */     // MIs[0] policy
     /* 1971900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971910 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1971913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971934 */     // GIR_Coverage, 61190,
     /* 1971934 */     GIR_EraseRootFromParent_Done,
     /* 1971935 */   // Label 26437: @1971935
     /* 1971935 */   GIM_Try, /*On fail goto*//*Label 26438*/ GIMT_Encode4(1972021), // Rule ID 61191 //
     /* 1971940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1971943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1971948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1971951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1971954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1971957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1971960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1971970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1971982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971986 */     // MIs[0] policy
     /* 1971986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1971999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972020 */     // GIR_Coverage, 61191,
     /* 1972020 */     GIR_EraseRootFromParent_Done,
     /* 1972021 */   // Label 26438: @1972021
     /* 1972021 */   GIM_Try, /*On fail goto*//*Label 26439*/ GIMT_Encode4(1972107), // Rule ID 61194 //
     /* 1972026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1972046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972072 */     // MIs[0] policy
     /* 1972072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972082 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1972085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972106 */     // GIR_Coverage, 61194,
     /* 1972106 */     GIR_EraseRootFromParent_Done,
     /* 1972107 */   // Label 26439: @1972107
     /* 1972107 */   GIM_Try, /*On fail goto*//*Label 26440*/ GIMT_Encode4(1972193), // Rule ID 61195 //
     /* 1972112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1972132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972158 */     // MIs[0] policy
     /* 1972158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1972171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972192 */     // GIR_Coverage, 61195,
     /* 1972192 */     GIR_EraseRootFromParent_Done,
     /* 1972193 */   // Label 26440: @1972193
     /* 1972193 */   GIM_Try, /*On fail goto*//*Label 26441*/ GIMT_Encode4(1972279), // Rule ID 61198 //
     /* 1972198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972244 */     // MIs[0] policy
     /* 1972244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972254 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1972257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972278 */     // GIR_Coverage, 61198,
     /* 1972278 */     GIR_EraseRootFromParent_Done,
     /* 1972279 */   // Label 26441: @1972279
     /* 1972279 */   GIM_Try, /*On fail goto*//*Label 26442*/ GIMT_Encode4(1972365), // Rule ID 61199 //
     /* 1972284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1972295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1972298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1972301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972330 */     // MIs[0] policy
     /* 1972330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11171:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1972343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972364 */     // GIR_Coverage, 61199,
     /* 1972364 */     GIR_EraseRootFromParent_Done,
     /* 1972365 */   // Label 26442: @1972365
     /* 1972365 */   GIM_Try, /*On fail goto*//*Label 26443*/ GIMT_Encode4(1972451), // Rule ID 61202 //
     /* 1972370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972416 */     // MIs[0] policy
     /* 1972416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1972429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972450 */     // GIR_Coverage, 61202,
     /* 1972450 */     GIR_EraseRootFromParent_Done,
     /* 1972451 */   // Label 26443: @1972451
     /* 1972451 */   GIM_Try, /*On fail goto*//*Label 26444*/ GIMT_Encode4(1972537), // Rule ID 61203 //
     /* 1972456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1972467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1972470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1972473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1972479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972502 */     // MIs[0] policy
     /* 1972502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972512 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11171:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1972515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972536 */     // GIR_Coverage, 61203,
     /* 1972536 */     GIR_EraseRootFromParent_Done,
     /* 1972537 */   // Label 26444: @1972537
     /* 1972537 */   GIM_Try, /*On fail goto*//*Label 26445*/ GIMT_Encode4(1972623), // Rule ID 61206 //
     /* 1972542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1972553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1972556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1972559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972588 */     // MIs[0] policy
     /* 1972588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1972601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972622 */     // GIR_Coverage, 61206,
     /* 1972622 */     GIR_EraseRootFromParent_Done,
     /* 1972623 */   // Label 26445: @1972623
     /* 1972623 */   GIM_Try, /*On fail goto*//*Label 26446*/ GIMT_Encode4(1972709), // Rule ID 61207 //
     /* 1972628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1972639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1972642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1972645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972674 */     // MIs[0] policy
     /* 1972674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11171:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1972687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972708 */     // GIR_Coverage, 61207,
     /* 1972708 */     GIR_EraseRootFromParent_Done,
     /* 1972709 */   // Label 26446: @1972709
     /* 1972709 */   GIM_Try, /*On fail goto*//*Label 26447*/ GIMT_Encode4(1972795), // Rule ID 61210 //
     /* 1972714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1972717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972760 */     // MIs[0] policy
     /* 1972760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1972773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972794 */     // GIR_Coverage, 61210,
     /* 1972794 */     GIR_EraseRootFromParent_Done,
     /* 1972795 */   // Label 26447: @1972795
     /* 1972795 */   GIM_Try, /*On fail goto*//*Label 26448*/ GIMT_Encode4(1972881), // Rule ID 61211 //
     /* 1972800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1972803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1972808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1972811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1972814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1972817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972846 */     // MIs[0] policy
     /* 1972846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11171:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1972859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1972877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972880 */     // GIR_Coverage, 61211,
     /* 1972880 */     GIR_EraseRootFromParent_Done,
     /* 1972881 */   // Label 26448: @1972881
     /* 1972881 */   GIM_Try, /*On fail goto*//*Label 26449*/ GIMT_Encode4(1972967), // Rule ID 61214 //
     /* 1972886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1972897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1972900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1972903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1972906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1972916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1972928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972932 */     // MIs[0] policy
     /* 1972932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972942 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1972945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972966 */     // GIR_Coverage, 61214,
     /* 1972966 */     GIR_EraseRootFromParent_Done,
     /* 1972967 */   // Label 26449: @1972967
     /* 1972967 */   GIM_Try, /*On fail goto*//*Label 26450*/ GIMT_Encode4(1973053), // Rule ID 61215 //
     /* 1972972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1972983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1972986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1972989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1972992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1972995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973018 */     // MIs[0] policy
     /* 1973018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973028 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1973031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973052 */     // GIR_Coverage, 61215,
     /* 1973052 */     GIR_EraseRootFromParent_Done,
     /* 1973053 */   // Label 26450: @1973053
     /* 1973053 */   GIM_Try, /*On fail goto*//*Label 26451*/ GIMT_Encode4(1973139), // Rule ID 61218 //
     /* 1973058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1973078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973104 */     // MIs[0] policy
     /* 1973104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973138 */     // GIR_Coverage, 61218,
     /* 1973138 */     GIR_EraseRootFromParent_Done,
     /* 1973139 */   // Label 26451: @1973139
     /* 1973139 */   GIM_Try, /*On fail goto*//*Label 26452*/ GIMT_Encode4(1973225), // Rule ID 61219 //
     /* 1973144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1973155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1973158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1973161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1973164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973190 */     // MIs[0] policy
     /* 1973190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973224 */     // GIR_Coverage, 61219,
     /* 1973224 */     GIR_EraseRootFromParent_Done,
     /* 1973225 */   // Label 26452: @1973225
     /* 1973225 */   GIM_Try, /*On fail goto*//*Label 26453*/ GIMT_Encode4(1973311), // Rule ID 61222 //
     /* 1973230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1973250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973276 */     // MIs[0] policy
     /* 1973276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973286 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973310 */     // GIR_Coverage, 61222,
     /* 1973310 */     GIR_EraseRootFromParent_Done,
     /* 1973311 */   // Label 26453: @1973311
     /* 1973311 */   GIM_Try, /*On fail goto*//*Label 26454*/ GIMT_Encode4(1973397), // Rule ID 61223 //
     /* 1973316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1973327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1973330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1973333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1973336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973362 */     // MIs[0] policy
     /* 1973362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973372 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973396 */     // GIR_Coverage, 61223,
     /* 1973396 */     GIR_EraseRootFromParent_Done,
     /* 1973397 */   // Label 26454: @1973397
     /* 1973397 */   GIM_Try, /*On fail goto*//*Label 26455*/ GIMT_Encode4(1973483), // Rule ID 61226 //
     /* 1973402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1973413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1973416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1973419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1973422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973448 */     // MIs[0] policy
     /* 1973448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973458 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973482 */     // GIR_Coverage, 61226,
     /* 1973482 */     GIR_EraseRootFromParent_Done,
     /* 1973483 */   // Label 26455: @1973483
     /* 1973483 */   GIM_Try, /*On fail goto*//*Label 26456*/ GIMT_Encode4(1973569), // Rule ID 61227 //
     /* 1973488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1973499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1973502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1973505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1973508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973534 */     // MIs[0] policy
     /* 1973534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1973547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973568 */     // GIR_Coverage, 61227,
     /* 1973568 */     GIR_EraseRootFromParent_Done,
     /* 1973569 */   // Label 26456: @1973569
     /* 1973569 */   GIM_Try, /*On fail goto*//*Label 26457*/ GIMT_Encode4(1973655), // Rule ID 61230 //
     /* 1973574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1973585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1973588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1973591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1973594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973620 */     // MIs[0] policy
     /* 1973620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973630 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973654 */     // GIR_Coverage, 61230,
     /* 1973654 */     GIR_EraseRootFromParent_Done,
     /* 1973655 */   // Label 26457: @1973655
     /* 1973655 */   GIM_Try, /*On fail goto*//*Label 26458*/ GIMT_Encode4(1973741), // Rule ID 61231 //
     /* 1973660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1973671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1973674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1973677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1973680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973706 */     // MIs[0] policy
     /* 1973706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1973737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973740 */     // GIR_Coverage, 61231,
     /* 1973740 */     GIR_EraseRootFromParent_Done,
     /* 1973741 */   // Label 26458: @1973741
     /* 1973741 */   GIM_Try, /*On fail goto*//*Label 26459*/ GIMT_Encode4(1973827), // Rule ID 61234 //
     /* 1973746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1973757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1973760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1973763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1973766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973792 */     // MIs[0] policy
     /* 1973792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973826 */     // GIR_Coverage, 61234,
     /* 1973826 */     GIR_EraseRootFromParent_Done,
     /* 1973827 */   // Label 26459: @1973827
     /* 1973827 */   GIM_Try, /*On fail goto*//*Label 26460*/ GIMT_Encode4(1973913), // Rule ID 61235 //
     /* 1973832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1973843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1973846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1973849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1973852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973878 */     // MIs[0] policy
     /* 1973878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1973891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973912 */     // GIR_Coverage, 61235,
     /* 1973912 */     GIR_EraseRootFromParent_Done,
     /* 1973913 */   // Label 26460: @1973913
     /* 1973913 */   GIM_Try, /*On fail goto*//*Label 26461*/ GIMT_Encode4(1973999), // Rule ID 61238 //
     /* 1973918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1973929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1973932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1973935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1973938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973964 */     // MIs[0] policy
     /* 1973964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1973977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973998 */     // GIR_Coverage, 61238,
     /* 1973998 */     GIR_EraseRootFromParent_Done,
     /* 1973999 */   // Label 26461: @1973999
     /* 1973999 */   GIM_Try, /*On fail goto*//*Label 26462*/ GIMT_Encode4(1974085), // Rule ID 61239 //
     /* 1974004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1974018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1974021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1974024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974050 */     // MIs[0] policy
     /* 1974050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974084 */     // GIR_Coverage, 61239,
     /* 1974084 */     GIR_EraseRootFromParent_Done,
     /* 1974085 */   // Label 26462: @1974085
     /* 1974085 */   GIM_Try, /*On fail goto*//*Label 26463*/ GIMT_Encode4(1974171), // Rule ID 61242 //
     /* 1974090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1974110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974136 */     // MIs[0] policy
     /* 1974136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974170 */     // GIR_Coverage, 61242,
     /* 1974170 */     GIR_EraseRootFromParent_Done,
     /* 1974171 */   // Label 26463: @1974171
     /* 1974171 */   GIM_Try, /*On fail goto*//*Label 26464*/ GIMT_Encode4(1974257), // Rule ID 61243 //
     /* 1974176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1974187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1974190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1974193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1974196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974222 */     // MIs[0] policy
     /* 1974222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974256 */     // GIR_Coverage, 61243,
     /* 1974256 */     GIR_EraseRootFromParent_Done,
     /* 1974257 */   // Label 26464: @1974257
     /* 1974257 */   GIM_Try, /*On fail goto*//*Label 26465*/ GIMT_Encode4(1974343), // Rule ID 61246 //
     /* 1974262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1974273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1974276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1974279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1974282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974308 */     // MIs[0] policy
     /* 1974308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974342 */     // GIR_Coverage, 61246,
     /* 1974342 */     GIR_EraseRootFromParent_Done,
     /* 1974343 */   // Label 26465: @1974343
     /* 1974343 */   GIM_Try, /*On fail goto*//*Label 26466*/ GIMT_Encode4(1974429), // Rule ID 61247 //
     /* 1974348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1974359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1974362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1974365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1974368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974394 */     // MIs[0] policy
     /* 1974394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974428 */     // GIR_Coverage, 61247,
     /* 1974428 */     GIR_EraseRootFromParent_Done,
     /* 1974429 */   // Label 26466: @1974429
     /* 1974429 */   GIM_Try, /*On fail goto*//*Label 26467*/ GIMT_Encode4(1974515), // Rule ID 61250 //
     /* 1974434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1974448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1974451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1974454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974480 */     // MIs[0] policy
     /* 1974480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974514 */     // GIR_Coverage, 61250,
     /* 1974514 */     GIR_EraseRootFromParent_Done,
     /* 1974515 */   // Label 26467: @1974515
     /* 1974515 */   GIM_Try, /*On fail goto*//*Label 26468*/ GIMT_Encode4(1974601), // Rule ID 61251 //
     /* 1974520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1974531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1974534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1974537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1974540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974566 */     // MIs[0] policy
     /* 1974566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1974579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1974597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974600 */     // GIR_Coverage, 61251,
     /* 1974600 */     GIR_EraseRootFromParent_Done,
     /* 1974601 */   // Label 26468: @1974601
     /* 1974601 */   GIM_Try, /*On fail goto*//*Label 26469*/ GIMT_Encode4(1974687), // Rule ID 61254 //
     /* 1974606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1974617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1974620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1974623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1974626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1974629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1974636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974652 */     // MIs[0] policy
     /* 1974652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974662 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1974665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974686 */     // GIR_Coverage, 61254,
     /* 1974686 */     GIR_EraseRootFromParent_Done,
     /* 1974687 */   // Label 26469: @1974687
     /* 1974687 */   GIM_Try, /*On fail goto*//*Label 26470*/ GIMT_Encode4(1974773), // Rule ID 61255 //
     /* 1974692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1974703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1974706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1974709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1974712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1974715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1974722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1974734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974738 */     // MIs[0] policy
     /* 1974738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1974751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974772 */     // GIR_Coverage, 61255,
     /* 1974772 */     GIR_EraseRootFromParent_Done,
     /* 1974773 */   // Label 26470: @1974773
     /* 1974773 */   GIM_Try, /*On fail goto*//*Label 26471*/ GIMT_Encode4(1974859), // Rule ID 61258 //
     /* 1974778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1974789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1974792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1974795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1974798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1974801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1974808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974824 */     // MIs[0] policy
     /* 1974824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1974837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974858 */     // GIR_Coverage, 61258,
     /* 1974858 */     GIR_EraseRootFromParent_Done,
     /* 1974859 */   // Label 26471: @1974859
     /* 1974859 */   GIM_Try, /*On fail goto*//*Label 26472*/ GIMT_Encode4(1974945), // Rule ID 61259 //
     /* 1974864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1974875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1974878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1974881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1974884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1974887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1974894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1974906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974910 */     // MIs[0] policy
     /* 1974910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974920 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1974923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974944 */     // GIR_Coverage, 61259,
     /* 1974944 */     GIR_EraseRootFromParent_Done,
     /* 1974945 */   // Label 26472: @1974945
     /* 1974945 */   GIM_Try, /*On fail goto*//*Label 26473*/ GIMT_Encode4(1975031), // Rule ID 61262 //
     /* 1974950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1974958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1974961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1974964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1974967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1974970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1974973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1974980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1974992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974996 */     // MIs[0] policy
     /* 1974996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975006 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975030 */     // GIR_Coverage, 61262,
     /* 1975030 */     GIR_EraseRootFromParent_Done,
     /* 1975031 */   // Label 26473: @1975031
     /* 1975031 */   GIM_Try, /*On fail goto*//*Label 26474*/ GIMT_Encode4(1975117), // Rule ID 61263 //
     /* 1975036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1975047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1975050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1975053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1975056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1975059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975082 */     // MIs[0] policy
     /* 1975082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975116 */     // GIR_Coverage, 61263,
     /* 1975116 */     GIR_EraseRootFromParent_Done,
     /* 1975117 */   // Label 26474: @1975117
     /* 1975117 */   GIM_Try, /*On fail goto*//*Label 26475*/ GIMT_Encode4(1975203), // Rule ID 61266 //
     /* 1975122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1975142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975168 */     // MIs[0] policy
     /* 1975168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975202 */     // GIR_Coverage, 61266,
     /* 1975202 */     GIR_EraseRootFromParent_Done,
     /* 1975203 */   // Label 26475: @1975203
     /* 1975203 */   GIM_Try, /*On fail goto*//*Label 26476*/ GIMT_Encode4(1975289), // Rule ID 61267 //
     /* 1975208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1975219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1975222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1975225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1975228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975254 */     // MIs[0] policy
     /* 1975254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975288 */     // GIR_Coverage, 61267,
     /* 1975288 */     GIR_EraseRootFromParent_Done,
     /* 1975289 */   // Label 26476: @1975289
     /* 1975289 */   GIM_Try, /*On fail goto*//*Label 26477*/ GIMT_Encode4(1975375), // Rule ID 61270 //
     /* 1975294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1975305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1975308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1975311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1975314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975340 */     // MIs[0] policy
     /* 1975340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975374 */     // GIR_Coverage, 61270,
     /* 1975374 */     GIR_EraseRootFromParent_Done,
     /* 1975375 */   // Label 26477: @1975375
     /* 1975375 */   GIM_Try, /*On fail goto*//*Label 26478*/ GIMT_Encode4(1975461), // Rule ID 61271 //
     /* 1975380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1975391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1975394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1975397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1975400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975426 */     // MIs[0] policy
     /* 1975426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975460 */     // GIR_Coverage, 61271,
     /* 1975460 */     GIR_EraseRootFromParent_Done,
     /* 1975461 */   // Label 26478: @1975461
     /* 1975461 */   GIM_Try, /*On fail goto*//*Label 26479*/ GIMT_Encode4(1975547), // Rule ID 61274 //
     /* 1975466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1975477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1975480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1975483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1975486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975512 */     // MIs[0] policy
     /* 1975512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975522 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975546 */     // GIR_Coverage, 61274,
     /* 1975546 */     GIR_EraseRootFromParent_Done,
     /* 1975547 */   // Label 26479: @1975547
     /* 1975547 */   GIM_Try, /*On fail goto*//*Label 26480*/ GIMT_Encode4(1975633), // Rule ID 61275 //
     /* 1975552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1975563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1975566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1975569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1975572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975598 */     // MIs[0] policy
     /* 1975598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1975611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975632 */     // GIR_Coverage, 61275,
     /* 1975632 */     GIR_EraseRootFromParent_Done,
     /* 1975633 */   // Label 26480: @1975633
     /* 1975633 */   GIM_Try, /*On fail goto*//*Label 26481*/ GIMT_Encode4(1975719), // Rule ID 61278 //
     /* 1975638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1975649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1975652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1975655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1975658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975684 */     // MIs[0] policy
     /* 1975684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975718 */     // GIR_Coverage, 61278,
     /* 1975718 */     GIR_EraseRootFromParent_Done,
     /* 1975719 */   // Label 26481: @1975719
     /* 1975719 */   GIM_Try, /*On fail goto*//*Label 26482*/ GIMT_Encode4(1975805), // Rule ID 61279 //
     /* 1975724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1975735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1975738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1975741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1975744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975770 */     // MIs[0] policy
     /* 1975770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1975783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975804 */     // GIR_Coverage, 61279,
     /* 1975804 */     GIR_EraseRootFromParent_Done,
     /* 1975805 */   // Label 26482: @1975805
     /* 1975805 */   GIM_Try, /*On fail goto*//*Label 26483*/ GIMT_Encode4(1975891), // Rule ID 61282 //
     /* 1975810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1975821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1975824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1975827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1975830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975856 */     // MIs[0] policy
     /* 1975856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975890 */     // GIR_Coverage, 61282,
     /* 1975890 */     GIR_EraseRootFromParent_Done,
     /* 1975891 */   // Label 26483: @1975891
     /* 1975891 */   GIM_Try, /*On fail goto*//*Label 26484*/ GIMT_Encode4(1975977), // Rule ID 61283 //
     /* 1975896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1975907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1975910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1975913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1975916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975942 */     // MIs[0] policy
     /* 1975942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1975955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975976 */     // GIR_Coverage, 61283,
     /* 1975976 */     GIR_EraseRootFromParent_Done,
     /* 1975977 */   // Label 26484: @1975977
     /* 1975977 */   GIM_Try, /*On fail goto*//*Label 26485*/ GIMT_Encode4(1976063), // Rule ID 61286 //
     /* 1975982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1975990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1975993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1975996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1975999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1976002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976028 */     // MIs[0] policy
     /* 1976028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976062 */     // GIR_Coverage, 61286,
     /* 1976062 */     GIR_EraseRootFromParent_Done,
     /* 1976063 */   // Label 26485: @1976063
     /* 1976063 */   GIM_Try, /*On fail goto*//*Label 26486*/ GIMT_Encode4(1976149), // Rule ID 61287 //
     /* 1976068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1976088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976114 */     // MIs[0] policy
     /* 1976114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976148 */     // GIR_Coverage, 61287,
     /* 1976148 */     GIR_EraseRootFromParent_Done,
     /* 1976149 */   // Label 26486: @1976149
     /* 1976149 */   GIM_Try, /*On fail goto*//*Label 26487*/ GIMT_Encode4(1976235), // Rule ID 61290 //
     /* 1976154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1976174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976200 */     // MIs[0] policy
     /* 1976200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976234 */     // GIR_Coverage, 61290,
     /* 1976234 */     GIR_EraseRootFromParent_Done,
     /* 1976235 */   // Label 26487: @1976235
     /* 1976235 */   GIM_Try, /*On fail goto*//*Label 26488*/ GIMT_Encode4(1976321), // Rule ID 61291 //
     /* 1976240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1976251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1976254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1976257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1976260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976286 */     // MIs[0] policy
     /* 1976286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1976299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976320 */     // GIR_Coverage, 61291,
     /* 1976320 */     GIR_EraseRootFromParent_Done,
     /* 1976321 */   // Label 26488: @1976321
     /* 1976321 */   GIM_Try, /*On fail goto*//*Label 26489*/ GIMT_Encode4(1976407), // Rule ID 61294 //
     /* 1976326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1976346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976372 */     // MIs[0] policy
     /* 1976372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976406 */     // GIR_Coverage, 61294,
     /* 1976406 */     GIR_EraseRootFromParent_Done,
     /* 1976407 */   // Label 26489: @1976407
     /* 1976407 */   GIM_Try, /*On fail goto*//*Label 26490*/ GIMT_Encode4(1976493), // Rule ID 61295 //
     /* 1976412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1976423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1976426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1976429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1976432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976458 */     // MIs[0] policy
     /* 1976458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1976471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976492 */     // GIR_Coverage, 61295,
     /* 1976492 */     GIR_EraseRootFromParent_Done,
     /* 1976493 */   // Label 26490: @1976493
     /* 1976493 */   GIM_Try, /*On fail goto*//*Label 26491*/ GIMT_Encode4(1976579), // Rule ID 61298 //
     /* 1976498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1976509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1976512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1976515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1976518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976544 */     // MIs[0] policy
     /* 1976544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976578 */     // GIR_Coverage, 61298,
     /* 1976578 */     GIR_EraseRootFromParent_Done,
     /* 1976579 */   // Label 26491: @1976579
     /* 1976579 */   GIM_Try, /*On fail goto*//*Label 26492*/ GIMT_Encode4(1976665), // Rule ID 61299 //
     /* 1976584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1976595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1976598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1976601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1976604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976630 */     // MIs[0] policy
     /* 1976630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1976643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1976661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976664 */     // GIR_Coverage, 61299,
     /* 1976664 */     GIR_EraseRootFromParent_Done,
     /* 1976665 */   // Label 26492: @1976665
     /* 1976665 */   GIM_Try, /*On fail goto*//*Label 26493*/ GIMT_Encode4(1976751), // Rule ID 61302 //
     /* 1976670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1976681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1976684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1976687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976716 */     // MIs[0] policy
     /* 1976716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1976729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976750 */     // GIR_Coverage, 61302,
     /* 1976750 */     GIR_EraseRootFromParent_Done,
     /* 1976751 */   // Label 26493: @1976751
     /* 1976751 */   GIM_Try, /*On fail goto*//*Label 26494*/ GIMT_Encode4(1976837), // Rule ID 61303 //
     /* 1976756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1976767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1976770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1976773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1976779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976802 */     // MIs[0] policy
     /* 1976802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1976815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976836 */     // GIR_Coverage, 61303,
     /* 1976836 */     GIR_EraseRootFromParent_Done,
     /* 1976837 */   // Label 26494: @1976837
     /* 1976837 */   GIM_Try, /*On fail goto*//*Label 26495*/ GIMT_Encode4(1976923), // Rule ID 61306 //
     /* 1976842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1976853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1976856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1976859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1976862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976888 */     // MIs[0] policy
     /* 1976888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976898 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1976901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976922 */     // GIR_Coverage, 61306,
     /* 1976922 */     GIR_EraseRootFromParent_Done,
     /* 1976923 */   // Label 26495: @1976923
     /* 1976923 */   GIM_Try, /*On fail goto*//*Label 26496*/ GIMT_Encode4(1977009), // Rule ID 61307 //
     /* 1976928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1976936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1976939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1976942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1976945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1976948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1976951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1976958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1976966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1976970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976974 */     // MIs[0] policy
     /* 1976974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976984 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1976987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977008 */     // GIR_Coverage, 61307,
     /* 1977008 */     GIR_EraseRootFromParent_Done,
     /* 1977009 */   // Label 26496: @1977009
     /* 1977009 */   GIM_Try, /*On fail goto*//*Label 26497*/ GIMT_Encode4(1977095), // Rule ID 61310 //
     /* 1977014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977060 */     // MIs[0] policy
     /* 1977060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977070 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977094 */     // GIR_Coverage, 61310,
     /* 1977094 */     GIR_EraseRootFromParent_Done,
     /* 1977095 */   // Label 26497: @1977095
     /* 1977095 */   GIM_Try, /*On fail goto*//*Label 26498*/ GIMT_Encode4(1977181), // Rule ID 61311 //
     /* 1977100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1977111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1977114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1977117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977146 */     // MIs[0] policy
     /* 1977146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977180 */     // GIR_Coverage, 61311,
     /* 1977180 */     GIR_EraseRootFromParent_Done,
     /* 1977181 */   // Label 26498: @1977181
     /* 1977181 */   GIM_Try, /*On fail goto*//*Label 26499*/ GIMT_Encode4(1977267), // Rule ID 61314 //
     /* 1977186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977232 */     // MIs[0] policy
     /* 1977232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977242 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977266 */     // GIR_Coverage, 61314,
     /* 1977266 */     GIR_EraseRootFromParent_Done,
     /* 1977267 */   // Label 26499: @1977267
     /* 1977267 */   GIM_Try, /*On fail goto*//*Label 26500*/ GIMT_Encode4(1977353), // Rule ID 61315 //
     /* 1977272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1977283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1977286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1977289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977318 */     // MIs[0] policy
     /* 1977318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1977331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977352 */     // GIR_Coverage, 61315,
     /* 1977352 */     GIR_EraseRootFromParent_Done,
     /* 1977353 */   // Label 26500: @1977353
     /* 1977353 */   GIM_Try, /*On fail goto*//*Label 26501*/ GIMT_Encode4(1977439), // Rule ID 61318 //
     /* 1977358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977404 */     // MIs[0] policy
     /* 1977404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977414 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977438 */     // GIR_Coverage, 61318,
     /* 1977438 */     GIR_EraseRootFromParent_Done,
     /* 1977439 */   // Label 26501: @1977439
     /* 1977439 */   GIM_Try, /*On fail goto*//*Label 26502*/ GIMT_Encode4(1977525), // Rule ID 61319 //
     /* 1977444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1977455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1977458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1977461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977490 */     // MIs[0] policy
     /* 1977490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977524 */     // GIR_Coverage, 61319,
     /* 1977524 */     GIR_EraseRootFromParent_Done,
     /* 1977525 */   // Label 26502: @1977525
     /* 1977525 */   GIM_Try, /*On fail goto*//*Label 26503*/ GIMT_Encode4(1977611), // Rule ID 61322 //
     /* 1977530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1977541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1977544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1977547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977576 */     // MIs[0] policy
     /* 1977576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977610 */     // GIR_Coverage, 61322,
     /* 1977610 */     GIR_EraseRootFromParent_Done,
     /* 1977611 */   // Label 26503: @1977611
     /* 1977611 */   GIM_Try, /*On fail goto*//*Label 26504*/ GIMT_Encode4(1977697), // Rule ID 61323 //
     /* 1977616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1977627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1977630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1977633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977662 */     // MIs[0] policy
     /* 1977662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1977675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977696 */     // GIR_Coverage, 61323,
     /* 1977696 */     GIR_EraseRootFromParent_Done,
     /* 1977697 */   // Label 26504: @1977697
     /* 1977697 */   GIM_Try, /*On fail goto*//*Label 26505*/ GIMT_Encode4(1977783), // Rule ID 61326 //
     /* 1977702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1977713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1977716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1977719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977748 */     // MIs[0] policy
     /* 1977748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1977761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977782 */     // GIR_Coverage, 61326,
     /* 1977782 */     GIR_EraseRootFromParent_Done,
     /* 1977783 */   // Label 26505: @1977783
     /* 1977783 */   GIM_Try, /*On fail goto*//*Label 26506*/ GIMT_Encode4(1977869), // Rule ID 61327 //
     /* 1977788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1977799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1977802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1977805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977834 */     // MIs[0] policy
     /* 1977834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11159:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1977847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977868 */     // GIR_Coverage, 61327,
     /* 1977868 */     GIR_EraseRootFromParent_Done,
     /* 1977869 */   // Label 26506: @1977869
     /* 1977869 */   GIM_Try, /*On fail goto*//*Label 26507*/ GIMT_Encode4(1977955), // Rule ID 61330 //
     /* 1977874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1977885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1977888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1977891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977920 */     // MIs[0] policy
     /* 1977920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1977933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1977951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977954 */     // GIR_Coverage, 61330,
     /* 1977954 */     GIR_EraseRootFromParent_Done,
     /* 1977955 */   // Label 26507: @1977955
     /* 1977955 */   GIM_Try, /*On fail goto*//*Label 26508*/ GIMT_Encode4(1978041), // Rule ID 61331 //
     /* 1977960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1977968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1977971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1977974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1977977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978006 */     // MIs[0] policy
     /* 1978006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978040 */     // GIR_Coverage, 61331,
     /* 1978040 */     GIR_EraseRootFromParent_Done,
     /* 1978041 */   // Label 26508: @1978041
     /* 1978041 */   GIM_Try, /*On fail goto*//*Label 26509*/ GIMT_Encode4(1978127), // Rule ID 61334 //
     /* 1978046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978092 */     // MIs[0] policy
     /* 1978092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978126 */     // GIR_Coverage, 61334,
     /* 1978126 */     GIR_EraseRootFromParent_Done,
     /* 1978127 */   // Label 26509: @1978127
     /* 1978127 */   GIM_Try, /*On fail goto*//*Label 26510*/ GIMT_Encode4(1978213), // Rule ID 61335 //
     /* 1978132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1978143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1978146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1978149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978178 */     // MIs[0] policy
     /* 1978178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978212 */     // GIR_Coverage, 61335,
     /* 1978212 */     GIR_EraseRootFromParent_Done,
     /* 1978213 */   // Label 26510: @1978213
     /* 1978213 */   GIM_Try, /*On fail goto*//*Label 26511*/ GIMT_Encode4(1978299), // Rule ID 61338 //
     /* 1978218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978264 */     // MIs[0] policy
     /* 1978264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978298 */     // GIR_Coverage, 61338,
     /* 1978298 */     GIR_EraseRootFromParent_Done,
     /* 1978299 */   // Label 26511: @1978299
     /* 1978299 */   GIM_Try, /*On fail goto*//*Label 26512*/ GIMT_Encode4(1978385), // Rule ID 61339 //
     /* 1978304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1978315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1978318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1978321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978350 */     // MIs[0] policy
     /* 1978350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1978363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1978381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978384 */     // GIR_Coverage, 61339,
     /* 1978384 */     GIR_EraseRootFromParent_Done,
     /* 1978385 */   // Label 26512: @1978385
     /* 1978385 */   GIM_Try, /*On fail goto*//*Label 26513*/ GIMT_Encode4(1978471), // Rule ID 61342 //
     /* 1978390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978436 */     // MIs[0] policy
     /* 1978436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978446 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1978449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978470 */     // GIR_Coverage, 61342,
     /* 1978470 */     GIR_EraseRootFromParent_Done,
     /* 1978471 */   // Label 26513: @1978471
     /* 1978471 */   GIM_Try, /*On fail goto*//*Label 26514*/ GIMT_Encode4(1978557), // Rule ID 61343 //
     /* 1978476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1978487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1978490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1978493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1978499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978522 */     // MIs[0] policy
     /* 1978522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1978535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978556 */     // GIR_Coverage, 61343,
     /* 1978556 */     GIR_EraseRootFromParent_Done,
     /* 1978557 */   // Label 26514: @1978557
     /* 1978557 */   GIM_Try, /*On fail goto*//*Label 26515*/ GIMT_Encode4(1978643), // Rule ID 61346 //
     /* 1978562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1978573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1978576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1978579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1978585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1978592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978608 */     // MIs[0] policy
     /* 1978608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1978621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978642 */     // GIR_Coverage, 61346,
     /* 1978642 */     GIR_EraseRootFromParent_Done,
     /* 1978643 */   // Label 26515: @1978643
     /* 1978643 */   GIM_Try, /*On fail goto*//*Label 26516*/ GIMT_Encode4(1978729), // Rule ID 61347 //
     /* 1978648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1978659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1978662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1978665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1978671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1978678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1978686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978694 */     // MIs[0] policy
     /* 1978694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978704 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1978707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978728 */     // GIR_Coverage, 61347,
     /* 1978728 */     GIR_EraseRootFromParent_Done,
     /* 1978729 */   // Label 26516: @1978729
     /* 1978729 */   GIM_Try, /*On fail goto*//*Label 26517*/ GIMT_Encode4(1978815), // Rule ID 61350 //
     /* 1978734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1978745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1978748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1978751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1978757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1978764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978780 */     // MIs[0] policy
     /* 1978780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978790 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1978793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978814 */     // GIR_Coverage, 61350,
     /* 1978814 */     GIR_EraseRootFromParent_Done,
     /* 1978815 */   // Label 26517: @1978815
     /* 1978815 */   GIM_Try, /*On fail goto*//*Label 26518*/ GIMT_Encode4(1978901), // Rule ID 61351 //
     /* 1978820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1978831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1978834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1978837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1978843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1978850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1978858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978866 */     // MIs[0] policy
     /* 1978866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978876 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1978879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978900 */     // GIR_Coverage, 61351,
     /* 1978900 */     GIR_EraseRootFromParent_Done,
     /* 1978901 */   // Label 26518: @1978901
     /* 1978901 */   GIM_Try, /*On fail goto*//*Label 26519*/ GIMT_Encode4(1978987), // Rule ID 61354 //
     /* 1978906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1978914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1978917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1978920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1978923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1978936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1978944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978952 */     // MIs[0] policy
     /* 1978952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1978965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978986 */     // GIR_Coverage, 61354,
     /* 1978986 */     GIR_EraseRootFromParent_Done,
     /* 1978987 */   // Label 26519: @1978987
     /* 1978987 */   GIM_Try, /*On fail goto*//*Label 26520*/ GIMT_Encode4(1979073), // Rule ID 61355 //
     /* 1978992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979038 */     // MIs[0] policy
     /* 1979038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979072 */     // GIR_Coverage, 61355,
     /* 1979072 */     GIR_EraseRootFromParent_Done,
     /* 1979073 */   // Label 26520: @1979073
     /* 1979073 */   GIM_Try, /*On fail goto*//*Label 26521*/ GIMT_Encode4(1979159), // Rule ID 61358 //
     /* 1979078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979124 */     // MIs[0] policy
     /* 1979124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979158 */     // GIR_Coverage, 61358,
     /* 1979158 */     GIR_EraseRootFromParent_Done,
     /* 1979159 */   // Label 26521: @1979159
     /* 1979159 */   GIM_Try, /*On fail goto*//*Label 26522*/ GIMT_Encode4(1979245), // Rule ID 61359 //
     /* 1979164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1979175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1979178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1979181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979210 */     // MIs[0] policy
     /* 1979210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979220 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979244 */     // GIR_Coverage, 61359,
     /* 1979244 */     GIR_EraseRootFromParent_Done,
     /* 1979245 */   // Label 26522: @1979245
     /* 1979245 */   GIM_Try, /*On fail goto*//*Label 26523*/ GIMT_Encode4(1979331), // Rule ID 61362 //
     /* 1979250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979296 */     // MIs[0] policy
     /* 1979296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979306 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979330 */     // GIR_Coverage, 61362,
     /* 1979330 */     GIR_EraseRootFromParent_Done,
     /* 1979331 */   // Label 26523: @1979331
     /* 1979331 */   GIM_Try, /*On fail goto*//*Label 26524*/ GIMT_Encode4(1979417), // Rule ID 61363 //
     /* 1979336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1979347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1979350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1979353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979382 */     // MIs[0] policy
     /* 1979382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979416 */     // GIR_Coverage, 61363,
     /* 1979416 */     GIR_EraseRootFromParent_Done,
     /* 1979417 */   // Label 26524: @1979417
     /* 1979417 */   GIM_Try, /*On fail goto*//*Label 26525*/ GIMT_Encode4(1979503), // Rule ID 61366 //
     /* 1979422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979468 */     // MIs[0] policy
     /* 1979468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979478 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979502 */     // GIR_Coverage, 61366,
     /* 1979502 */     GIR_EraseRootFromParent_Done,
     /* 1979503 */   // Label 26525: @1979503
     /* 1979503 */   GIM_Try, /*On fail goto*//*Label 26526*/ GIMT_Encode4(1979589), // Rule ID 61367 //
     /* 1979508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1979519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1979522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1979525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1979531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979554 */     // MIs[0] policy
     /* 1979554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979588 */     // GIR_Coverage, 61367,
     /* 1979588 */     GIR_EraseRootFromParent_Done,
     /* 1979589 */   // Label 26526: @1979589
     /* 1979589 */   GIM_Try, /*On fail goto*//*Label 26527*/ GIMT_Encode4(1979675), // Rule ID 61370 //
     /* 1979594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1979605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1979608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1979611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979640 */     // MIs[0] policy
     /* 1979640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979674 */     // GIR_Coverage, 61370,
     /* 1979674 */     GIR_EraseRootFromParent_Done,
     /* 1979675 */   // Label 26527: @1979675
     /* 1979675 */   GIM_Try, /*On fail goto*//*Label 26528*/ GIMT_Encode4(1979761), // Rule ID 61371 //
     /* 1979680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1979691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1979694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1979697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979726 */     // MIs[0] policy
     /* 1979726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1979739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979760 */     // GIR_Coverage, 61371,
     /* 1979760 */     GIR_EraseRootFromParent_Done,
     /* 1979761 */   // Label 26528: @1979761
     /* 1979761 */   GIM_Try, /*On fail goto*//*Label 26529*/ GIMT_Encode4(1979847), // Rule ID 61374 //
     /* 1979766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1979777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1979780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1979783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979812 */     // MIs[0] policy
     /* 1979812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979822 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979846 */     // GIR_Coverage, 61374,
     /* 1979846 */     GIR_EraseRootFromParent_Done,
     /* 1979847 */   // Label 26529: @1979847
     /* 1979847 */   GIM_Try, /*On fail goto*//*Label 26530*/ GIMT_Encode4(1979933), // Rule ID 61375 //
     /* 1979852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1979863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1979866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1979869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979898 */     // MIs[0] policy
     /* 1979898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1979911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979932 */     // GIR_Coverage, 61375,
     /* 1979932 */     GIR_EraseRootFromParent_Done,
     /* 1979933 */   // Label 26530: @1979933
     /* 1979933 */   GIM_Try, /*On fail goto*//*Label 26531*/ GIMT_Encode4(1980019), // Rule ID 61378 //
     /* 1979938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1979946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1979949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1979952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1979955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1979961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979984 */     // MIs[0] policy
     /* 1979984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1979997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980018 */     // GIR_Coverage, 61378,
     /* 1980018 */     GIR_EraseRootFromParent_Done,
     /* 1980019 */   // Label 26531: @1980019
     /* 1980019 */   GIM_Try, /*On fail goto*//*Label 26532*/ GIMT_Encode4(1980105), // Rule ID 61379 //
     /* 1980024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980070 */     // MIs[0] policy
     /* 1980070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1980083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980104 */     // GIR_Coverage, 61379,
     /* 1980104 */     GIR_EraseRootFromParent_Done,
     /* 1980105 */   // Label 26532: @1980105
     /* 1980105 */   GIM_Try, /*On fail goto*//*Label 26533*/ GIMT_Encode4(1980191), // Rule ID 61382 //
     /* 1980110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980156 */     // MIs[0] policy
     /* 1980156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980166 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980190 */     // GIR_Coverage, 61382,
     /* 1980190 */     GIR_EraseRootFromParent_Done,
     /* 1980191 */   // Label 26533: @1980191
     /* 1980191 */   GIM_Try, /*On fail goto*//*Label 26534*/ GIMT_Encode4(1980277), // Rule ID 61383 //
     /* 1980196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1980207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1980210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1980213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980242 */     // MIs[0] policy
     /* 1980242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1980255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980276 */     // GIR_Coverage, 61383,
     /* 1980276 */     GIR_EraseRootFromParent_Done,
     /* 1980277 */   // Label 26534: @1980277
     /* 1980277 */   GIM_Try, /*On fail goto*//*Label 26535*/ GIMT_Encode4(1980363), // Rule ID 61386 //
     /* 1980282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980328 */     // MIs[0] policy
     /* 1980328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980362 */     // GIR_Coverage, 61386,
     /* 1980362 */     GIR_EraseRootFromParent_Done,
     /* 1980363 */   // Label 26535: @1980363
     /* 1980363 */   GIM_Try, /*On fail goto*//*Label 26536*/ GIMT_Encode4(1980449), // Rule ID 61387 //
     /* 1980368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1980376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1980379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1980382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1980385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980414 */     // MIs[0] policy
     /* 1980414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11159:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1980427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980448 */     // GIR_Coverage, 61387,
     /* 1980448 */     GIR_EraseRootFromParent_Done,
     /* 1980449 */   // Label 26536: @1980449
     /* 1980449 */   GIM_Try, /*On fail goto*//*Label 26537*/ GIMT_Encode4(1980535), // Rule ID 61566 //
     /* 1980454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1980465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1980468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1980471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1980474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1980477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980500 */     // MIs[0] policy
     /* 1980500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980510 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1980513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980534 */     // GIR_Coverage, 61566,
     /* 1980534 */     GIR_EraseRootFromParent_Done,
     /* 1980535 */   // Label 26537: @1980535
     /* 1980535 */   GIM_Try, /*On fail goto*//*Label 26538*/ GIMT_Encode4(1980621), // Rule ID 61567 //
     /* 1980540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1980551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1980554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1980557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1980560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1980563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980586 */     // MIs[0] policy
     /* 1980586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1980599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980620 */     // GIR_Coverage, 61567,
     /* 1980620 */     GIR_EraseRootFromParent_Done,
     /* 1980621 */   // Label 26538: @1980621
     /* 1980621 */   GIM_Try, /*On fail goto*//*Label 26539*/ GIMT_Encode4(1980707), // Rule ID 61570 //
     /* 1980626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1980637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1980640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1980643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1980646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980672 */     // MIs[0] policy
     /* 1980672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1980685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980706 */     // GIR_Coverage, 61570,
     /* 1980706 */     GIR_EraseRootFromParent_Done,
     /* 1980707 */   // Label 26539: @1980707
     /* 1980707 */   GIM_Try, /*On fail goto*//*Label 26540*/ GIMT_Encode4(1980793), // Rule ID 61571 //
     /* 1980712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1980723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1980726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1980729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1980732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980758 */     // MIs[0] policy
     /* 1980758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1980771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980792 */     // GIR_Coverage, 61571,
     /* 1980792 */     GIR_EraseRootFromParent_Done,
     /* 1980793 */   // Label 26540: @1980793
     /* 1980793 */   GIM_Try, /*On fail goto*//*Label 26541*/ GIMT_Encode4(1980879), // Rule ID 61574 //
     /* 1980798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1980809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1980812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1980815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1980818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980844 */     // MIs[0] policy
     /* 1980844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980854 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1980857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980878 */     // GIR_Coverage, 61574,
     /* 1980878 */     GIR_EraseRootFromParent_Done,
     /* 1980879 */   // Label 26541: @1980879
     /* 1980879 */   GIM_Try, /*On fail goto*//*Label 26542*/ GIMT_Encode4(1980965), // Rule ID 61575 //
     /* 1980884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1980895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1980898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1980901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1980904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1980914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1980926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980930 */     // MIs[0] policy
     /* 1980930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980940 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1980943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1980961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980964 */     // GIR_Coverage, 61575,
     /* 1980964 */     GIR_EraseRootFromParent_Done,
     /* 1980965 */   // Label 26542: @1980965
     /* 1980965 */   GIM_Try, /*On fail goto*//*Label 26543*/ GIMT_Encode4(1981051), // Rule ID 61578 //
     /* 1980970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1980981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1980984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1980987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1980990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1980993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981016 */     // MIs[0] policy
     /* 1981016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981050 */     // GIR_Coverage, 61578,
     /* 1981050 */     GIR_EraseRootFromParent_Done,
     /* 1981051 */   // Label 26543: @1981051
     /* 1981051 */   GIM_Try, /*On fail goto*//*Label 26544*/ GIMT_Encode4(1981137), // Rule ID 61579 //
     /* 1981056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1981067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1981070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1981073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1981076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981102 */     // MIs[0] policy
     /* 1981102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981112 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1981115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981136 */     // GIR_Coverage, 61579,
     /* 1981136 */     GIR_EraseRootFromParent_Done,
     /* 1981137 */   // Label 26544: @1981137
     /* 1981137 */   GIM_Try, /*On fail goto*//*Label 26545*/ GIMT_Encode4(1981223), // Rule ID 61582 //
     /* 1981142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1981162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981188 */     // MIs[0] policy
     /* 1981188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981198 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981222 */     // GIR_Coverage, 61582,
     /* 1981222 */     GIR_EraseRootFromParent_Done,
     /* 1981223 */   // Label 26545: @1981223
     /* 1981223 */   GIM_Try, /*On fail goto*//*Label 26546*/ GIMT_Encode4(1981309), // Rule ID 61583 //
     /* 1981228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1981239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1981242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1981245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1981248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981274 */     // MIs[0] policy
     /* 1981274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981308 */     // GIR_Coverage, 61583,
     /* 1981308 */     GIR_EraseRootFromParent_Done,
     /* 1981309 */   // Label 26546: @1981309
     /* 1981309 */   GIM_Try, /*On fail goto*//*Label 26547*/ GIMT_Encode4(1981395), // Rule ID 61586 //
     /* 1981314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1981334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981360 */     // MIs[0] policy
     /* 1981360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981394 */     // GIR_Coverage, 61586,
     /* 1981394 */     GIR_EraseRootFromParent_Done,
     /* 1981395 */   // Label 26547: @1981395
     /* 1981395 */   GIM_Try, /*On fail goto*//*Label 26548*/ GIMT_Encode4(1981481), // Rule ID 61587 //
     /* 1981400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1981411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1981414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1981417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1981420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981446 */     // MIs[0] policy
     /* 1981446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1981459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981480 */     // GIR_Coverage, 61587,
     /* 1981480 */     GIR_EraseRootFromParent_Done,
     /* 1981481 */   // Label 26548: @1981481
     /* 1981481 */   GIM_Try, /*On fail goto*//*Label 26549*/ GIMT_Encode4(1981567), // Rule ID 61590 //
     /* 1981486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1981497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1981500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1981503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1981506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981532 */     // MIs[0] policy
     /* 1981532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981542 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981566 */     // GIR_Coverage, 61590,
     /* 1981566 */     GIR_EraseRootFromParent_Done,
     /* 1981567 */   // Label 26549: @1981567
     /* 1981567 */   GIM_Try, /*On fail goto*//*Label 26550*/ GIMT_Encode4(1981653), // Rule ID 61591 //
     /* 1981572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1981583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1981586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1981589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1981592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981618 */     // MIs[0] policy
     /* 1981618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981628 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981652 */     // GIR_Coverage, 61591,
     /* 1981652 */     GIR_EraseRootFromParent_Done,
     /* 1981653 */   // Label 26550: @1981653
     /* 1981653 */   GIM_Try, /*On fail goto*//*Label 26551*/ GIMT_Encode4(1981739), // Rule ID 61594 //
     /* 1981658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1981669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1981672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1981675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1981678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981704 */     // MIs[0] policy
     /* 1981704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981738 */     // GIR_Coverage, 61594,
     /* 1981738 */     GIR_EraseRootFromParent_Done,
     /* 1981739 */   // Label 26551: @1981739
     /* 1981739 */   GIM_Try, /*On fail goto*//*Label 26552*/ GIMT_Encode4(1981825), // Rule ID 61595 //
     /* 1981744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1981755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1981758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1981761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1981764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981790 */     // MIs[0] policy
     /* 1981790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1981821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981824 */     // GIR_Coverage, 61595,
     /* 1981824 */     GIR_EraseRootFromParent_Done,
     /* 1981825 */   // Label 26552: @1981825
     /* 1981825 */   GIM_Try, /*On fail goto*//*Label 26553*/ GIMT_Encode4(1981911), // Rule ID 61598 //
     /* 1981830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1981841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1981844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1981847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1981850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981876 */     // MIs[0] policy
     /* 1981876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981910 */     // GIR_Coverage, 61598,
     /* 1981910 */     GIR_EraseRootFromParent_Done,
     /* 1981911 */   // Label 26553: @1981911
     /* 1981911 */   GIM_Try, /*On fail goto*//*Label 26554*/ GIMT_Encode4(1981997), // Rule ID 61599 //
     /* 1981916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1981927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1981930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1981933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1981936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981962 */     // MIs[0] policy
     /* 1981962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981972 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1981975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1981993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981996 */     // GIR_Coverage, 61599,
     /* 1981996 */     GIR_EraseRootFromParent_Done,
     /* 1981997 */   // Label 26554: @1981997
     /* 1981997 */   GIM_Try, /*On fail goto*//*Label 26555*/ GIMT_Encode4(1982083), // Rule ID 61602 //
     /* 1982002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1982022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982048 */     // MIs[0] policy
     /* 1982048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982082 */     // GIR_Coverage, 61602,
     /* 1982082 */     GIR_EraseRootFromParent_Done,
     /* 1982083 */   // Label 26555: @1982083
     /* 1982083 */   GIM_Try, /*On fail goto*//*Label 26556*/ GIMT_Encode4(1982169), // Rule ID 61603 //
     /* 1982088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1982105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1982108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982134 */     // MIs[0] policy
     /* 1982134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1982147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1982165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982168 */     // GIR_Coverage, 61603,
     /* 1982168 */     GIR_EraseRootFromParent_Done,
     /* 1982169 */   // Label 26556: @1982169
     /* 1982169 */   GIM_Try, /*On fail goto*//*Label 26557*/ GIMT_Encode4(1982255), // Rule ID 61606 //
     /* 1982174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1982194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982220 */     // MIs[0] policy
     /* 1982220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982254 */     // GIR_Coverage, 61606,
     /* 1982254 */     GIR_EraseRootFromParent_Done,
     /* 1982255 */   // Label 26557: @1982255
     /* 1982255 */   GIM_Try, /*On fail goto*//*Label 26558*/ GIMT_Encode4(1982341), // Rule ID 61607 //
     /* 1982260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1982271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1982274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1982277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1982280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982306 */     // MIs[0] policy
     /* 1982306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982316 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982340 */     // GIR_Coverage, 61607,
     /* 1982340 */     GIR_EraseRootFromParent_Done,
     /* 1982341 */   // Label 26558: @1982341
     /* 1982341 */   GIM_Try, /*On fail goto*//*Label 26559*/ GIMT_Encode4(1982427), // Rule ID 61610 //
     /* 1982346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1982366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982392 */     // MIs[0] policy
     /* 1982392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982426 */     // GIR_Coverage, 61610,
     /* 1982426 */     GIR_EraseRootFromParent_Done,
     /* 1982427 */   // Label 26559: @1982427
     /* 1982427 */   GIM_Try, /*On fail goto*//*Label 26560*/ GIMT_Encode4(1982513), // Rule ID 61611 //
     /* 1982432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1982443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1982446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1982449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1982452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1982455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982478 */     // MIs[0] policy
     /* 1982478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982488 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982512 */     // GIR_Coverage, 61611,
     /* 1982512 */     GIR_EraseRootFromParent_Done,
     /* 1982513 */   // Label 26560: @1982513
     /* 1982513 */   GIM_Try, /*On fail goto*//*Label 26561*/ GIMT_Encode4(1982599), // Rule ID 61614 //
     /* 1982518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1982529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1982532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1982535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1982538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1982541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1982548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982564 */     // MIs[0] policy
     /* 1982564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982574 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1982577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982598 */     // GIR_Coverage, 61614,
     /* 1982598 */     GIR_EraseRootFromParent_Done,
     /* 1982599 */   // Label 26561: @1982599
     /* 1982599 */   GIM_Try, /*On fail goto*//*Label 26562*/ GIMT_Encode4(1982685), // Rule ID 61615 //
     /* 1982604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1982615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1982618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1982621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1982624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1982627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1982634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1982646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982650 */     // MIs[0] policy
     /* 1982650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1982663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982684 */     // GIR_Coverage, 61615,
     /* 1982684 */     GIR_EraseRootFromParent_Done,
     /* 1982685 */   // Label 26562: @1982685
     /* 1982685 */   GIM_Try, /*On fail goto*//*Label 26563*/ GIMT_Encode4(1982771), // Rule ID 61618 //
     /* 1982690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1982701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1982704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1982707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1982710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982736 */     // MIs[0] policy
     /* 1982736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982770 */     // GIR_Coverage, 61618,
     /* 1982770 */     GIR_EraseRootFromParent_Done,
     /* 1982771 */   // Label 26563: @1982771
     /* 1982771 */   GIM_Try, /*On fail goto*//*Label 26564*/ GIMT_Encode4(1982857), // Rule ID 61619 //
     /* 1982776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1982787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1982790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1982793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1982796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1982806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1982818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982822 */     // MIs[0] policy
     /* 1982822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1982835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982856 */     // GIR_Coverage, 61619,
     /* 1982856 */     GIR_EraseRootFromParent_Done,
     /* 1982857 */   // Label 26564: @1982857
     /* 1982857 */   GIM_Try, /*On fail goto*//*Label 26565*/ GIMT_Encode4(1982943), // Rule ID 61622 //
     /* 1982862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1982873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1982876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1982879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1982882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982908 */     // MIs[0] policy
     /* 1982908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1982921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982942 */     // GIR_Coverage, 61622,
     /* 1982942 */     GIR_EraseRootFromParent_Done,
     /* 1982943 */   // Label 26565: @1982943
     /* 1982943 */   GIM_Try, /*On fail goto*//*Label 26566*/ GIMT_Encode4(1983029), // Rule ID 61623 //
     /* 1982948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1982956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1982959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1982962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1982965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1982968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1982971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1982978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1982990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982994 */     // MIs[0] policy
     /* 1982994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983028 */     // GIR_Coverage, 61623,
     /* 1983028 */     GIR_EraseRootFromParent_Done,
     /* 1983029 */   // Label 26566: @1983029
     /* 1983029 */   GIM_Try, /*On fail goto*//*Label 26567*/ GIMT_Encode4(1983115), // Rule ID 61626 //
     /* 1983034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1983054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983080 */     // MIs[0] policy
     /* 1983080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983114 */     // GIR_Coverage, 61626,
     /* 1983114 */     GIR_EraseRootFromParent_Done,
     /* 1983115 */   // Label 26567: @1983115
     /* 1983115 */   GIM_Try, /*On fail goto*//*Label 26568*/ GIMT_Encode4(1983201), // Rule ID 61627 //
     /* 1983120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1983131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1983134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1983137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1983140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983166 */     // MIs[0] policy
     /* 1983166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983200 */     // GIR_Coverage, 61627,
     /* 1983200 */     GIR_EraseRootFromParent_Done,
     /* 1983201 */   // Label 26568: @1983201
     /* 1983201 */   GIM_Try, /*On fail goto*//*Label 26569*/ GIMT_Encode4(1983287), // Rule ID 61630 //
     /* 1983206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1983226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983252 */     // MIs[0] policy
     /* 1983252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983286 */     // GIR_Coverage, 61630,
     /* 1983286 */     GIR_EraseRootFromParent_Done,
     /* 1983287 */   // Label 26569: @1983287
     /* 1983287 */   GIM_Try, /*On fail goto*//*Label 26570*/ GIMT_Encode4(1983373), // Rule ID 61631 //
     /* 1983292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1983303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1983306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1983309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1983312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983338 */     // MIs[0] policy
     /* 1983338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983372 */     // GIR_Coverage, 61631,
     /* 1983372 */     GIR_EraseRootFromParent_Done,
     /* 1983373 */   // Label 26570: @1983373
     /* 1983373 */   GIM_Try, /*On fail goto*//*Label 26571*/ GIMT_Encode4(1983459), // Rule ID 61634 //
     /* 1983378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1983398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983424 */     // MIs[0] policy
     /* 1983424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983458 */     // GIR_Coverage, 61634,
     /* 1983458 */     GIR_EraseRootFromParent_Done,
     /* 1983459 */   // Label 26571: @1983459
     /* 1983459 */   GIM_Try, /*On fail goto*//*Label 26572*/ GIMT_Encode4(1983545), // Rule ID 61635 //
     /* 1983464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1983475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1983478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1983481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1983484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983510 */     // MIs[0] policy
     /* 1983510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983544 */     // GIR_Coverage, 61635,
     /* 1983544 */     GIR_EraseRootFromParent_Done,
     /* 1983545 */   // Label 26572: @1983545
     /* 1983545 */   GIM_Try, /*On fail goto*//*Label 26573*/ GIMT_Encode4(1983631), // Rule ID 61638 //
     /* 1983550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1983561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1983564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1983567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1983570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983596 */     // MIs[0] policy
     /* 1983596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983630 */     // GIR_Coverage, 61638,
     /* 1983630 */     GIR_EraseRootFromParent_Done,
     /* 1983631 */   // Label 26573: @1983631
     /* 1983631 */   GIM_Try, /*On fail goto*//*Label 26574*/ GIMT_Encode4(1983717), // Rule ID 61639 //
     /* 1983636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1983647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1983650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1983653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1983656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983682 */     // MIs[0] policy
     /* 1983682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1983695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1983713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983716 */     // GIR_Coverage, 61639,
     /* 1983716 */     GIR_EraseRootFromParent_Done,
     /* 1983717 */   // Label 26574: @1983717
     /* 1983717 */   GIM_Try, /*On fail goto*//*Label 26575*/ GIMT_Encode4(1983803), // Rule ID 61642 //
     /* 1983722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1983733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1983736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1983739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1983742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1983745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983768 */     // MIs[0] policy
     /* 1983768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983802 */     // GIR_Coverage, 61642,
     /* 1983802 */     GIR_EraseRootFromParent_Done,
     /* 1983803 */   // Label 26575: @1983803
     /* 1983803 */   GIM_Try, /*On fail goto*//*Label 26576*/ GIMT_Encode4(1983889), // Rule ID 61643 //
     /* 1983808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1983819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1983822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1983825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1983828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1983831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983854 */     // MIs[0] policy
     /* 1983854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1983867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983888 */     // GIR_Coverage, 61643,
     /* 1983888 */     GIR_EraseRootFromParent_Done,
     /* 1983889 */   // Label 26576: @1983889
     /* 1983889 */   GIM_Try, /*On fail goto*//*Label 26577*/ GIMT_Encode4(1983975), // Rule ID 61646 //
     /* 1983894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1983905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1983908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1983911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1983914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1983917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983940 */     // MIs[0] policy
     /* 1983940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1983953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983974 */     // GIR_Coverage, 61646,
     /* 1983974 */     GIR_EraseRootFromParent_Done,
     /* 1983975 */   // Label 26577: @1983975
     /* 1983975 */   GIM_Try, /*On fail goto*//*Label 26578*/ GIMT_Encode4(1984061), // Rule ID 61647 //
     /* 1983980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1983988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1983991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1983994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1983997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1984000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984026 */     // MIs[0] policy
     /* 1984026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1984039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984060 */     // GIR_Coverage, 61647,
     /* 1984060 */     GIR_EraseRootFromParent_Done,
     /* 1984061 */   // Label 26578: @1984061
     /* 1984061 */   GIM_Try, /*On fail goto*//*Label 26579*/ GIMT_Encode4(1984147), // Rule ID 61650 //
     /* 1984066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1984086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984112 */     // MIs[0] policy
     /* 1984112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984146 */     // GIR_Coverage, 61650,
     /* 1984146 */     GIR_EraseRootFromParent_Done,
     /* 1984147 */   // Label 26579: @1984147
     /* 1984147 */   GIM_Try, /*On fail goto*//*Label 26580*/ GIMT_Encode4(1984233), // Rule ID 61651 //
     /* 1984152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1984163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1984166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1984169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1984172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984198 */     // MIs[0] policy
     /* 1984198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1984211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984232 */     // GIR_Coverage, 61651,
     /* 1984232 */     GIR_EraseRootFromParent_Done,
     /* 1984233 */   // Label 26580: @1984233
     /* 1984233 */   GIM_Try, /*On fail goto*//*Label 26581*/ GIMT_Encode4(1984319), // Rule ID 61654 //
     /* 1984238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984284 */     // MIs[0] policy
     /* 1984284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1984297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984318 */     // GIR_Coverage, 61654,
     /* 1984318 */     GIR_EraseRootFromParent_Done,
     /* 1984319 */   // Label 26581: @1984319
     /* 1984319 */   GIM_Try, /*On fail goto*//*Label 26582*/ GIMT_Encode4(1984405), // Rule ID 61655 //
     /* 1984324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1984335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1984338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1984341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984370 */     // MIs[0] policy
     /* 1984370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984380 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1984383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984404 */     // GIR_Coverage, 61655,
     /* 1984404 */     GIR_EraseRootFromParent_Done,
     /* 1984405 */   // Label 26582: @1984405
     /* 1984405 */   GIM_Try, /*On fail goto*//*Label 26583*/ GIMT_Encode4(1984491), // Rule ID 61658 //
     /* 1984410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984456 */     // MIs[0] policy
     /* 1984456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984490 */     // GIR_Coverage, 61658,
     /* 1984490 */     GIR_EraseRootFromParent_Done,
     /* 1984491 */   // Label 26583: @1984491
     /* 1984491 */   GIM_Try, /*On fail goto*//*Label 26584*/ GIMT_Encode4(1984577), // Rule ID 61659 //
     /* 1984496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1984507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1984510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1984513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984542 */     // MIs[0] policy
     /* 1984542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984576 */     // GIR_Coverage, 61659,
     /* 1984576 */     GIR_EraseRootFromParent_Done,
     /* 1984577 */   // Label 26584: @1984577
     /* 1984577 */   GIM_Try, /*On fail goto*//*Label 26585*/ GIMT_Encode4(1984663), // Rule ID 61662 //
     /* 1984582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1984593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1984596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1984599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984628 */     // MIs[0] policy
     /* 1984628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984638 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1984641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984662 */     // GIR_Coverage, 61662,
     /* 1984662 */     GIR_EraseRootFromParent_Done,
     /* 1984663 */   // Label 26585: @1984663
     /* 1984663 */   GIM_Try, /*On fail goto*//*Label 26586*/ GIMT_Encode4(1984749), // Rule ID 61663 //
     /* 1984668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1984679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1984682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1984685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984714 */     // MIs[0] policy
     /* 1984714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984724 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1984727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1984745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984748 */     // GIR_Coverage, 61663,
     /* 1984748 */     GIR_EraseRootFromParent_Done,
     /* 1984749 */   // Label 26586: @1984749
     /* 1984749 */   GIM_Try, /*On fail goto*//*Label 26587*/ GIMT_Encode4(1984835), // Rule ID 61666 //
     /* 1984754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1984765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1984768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1984771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984800 */     // MIs[0] policy
     /* 1984800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984834 */     // GIR_Coverage, 61666,
     /* 1984834 */     GIR_EraseRootFromParent_Done,
     /* 1984835 */   // Label 26587: @1984835
     /* 1984835 */   GIM_Try, /*On fail goto*//*Label 26588*/ GIMT_Encode4(1984921), // Rule ID 61667 //
     /* 1984840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1984851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1984854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1984857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1984860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1984863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984886 */     // MIs[0] policy
     /* 1984886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1984899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984920 */     // GIR_Coverage, 61667,
     /* 1984920 */     GIR_EraseRootFromParent_Done,
     /* 1984921 */   // Label 26588: @1984921
     /* 1984921 */   GIM_Try, /*On fail goto*//*Label 26589*/ GIMT_Encode4(1985007), // Rule ID 61670 //
     /* 1984926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1984934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1984937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1984940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1984943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1984946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1984956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1984964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1984968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984972 */     // MIs[0] policy
     /* 1984972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1984985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985006 */     // GIR_Coverage, 61670,
     /* 1985006 */     GIR_EraseRootFromParent_Done,
     /* 1985007 */   // Label 26589: @1985007
     /* 1985007 */   GIM_Try, /*On fail goto*//*Label 26590*/ GIMT_Encode4(1985093), // Rule ID 61671 //
     /* 1985012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1985023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1985026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985058 */     // MIs[0] policy
     /* 1985058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985092 */     // GIR_Coverage, 61671,
     /* 1985092 */     GIR_EraseRootFromParent_Done,
     /* 1985093 */   // Label 26590: @1985093
     /* 1985093 */   GIM_Try, /*On fail goto*//*Label 26591*/ GIMT_Encode4(1985179), // Rule ID 61674 //
     /* 1985098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985144 */     // MIs[0] policy
     /* 1985144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985154 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985178 */     // GIR_Coverage, 61674,
     /* 1985178 */     GIR_EraseRootFromParent_Done,
     /* 1985179 */   // Label 26591: @1985179
     /* 1985179 */   GIM_Try, /*On fail goto*//*Label 26592*/ GIMT_Encode4(1985265), // Rule ID 61675 //
     /* 1985184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1985195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1985198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1985201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985230 */     // MIs[0] policy
     /* 1985230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1985243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985264 */     // GIR_Coverage, 61675,
     /* 1985264 */     GIR_EraseRootFromParent_Done,
     /* 1985265 */   // Label 26592: @1985265
     /* 1985265 */   GIM_Try, /*On fail goto*//*Label 26593*/ GIMT_Encode4(1985351), // Rule ID 61678 //
     /* 1985270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985316 */     // MIs[0] policy
     /* 1985316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985350 */     // GIR_Coverage, 61678,
     /* 1985350 */     GIR_EraseRootFromParent_Done,
     /* 1985351 */   // Label 26593: @1985351
     /* 1985351 */   GIM_Try, /*On fail goto*//*Label 26594*/ GIMT_Encode4(1985437), // Rule ID 61679 //
     /* 1985356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1985367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1985370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1985373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985402 */     // MIs[0] policy
     /* 1985402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11526:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985436 */     // GIR_Coverage, 61679,
     /* 1985436 */     GIR_EraseRootFromParent_Done,
     /* 1985437 */   // Label 26594: @1985437
     /* 1985437 */   GIM_Try, /*On fail goto*//*Label 26595*/ GIMT_Encode4(1985523), // Rule ID 61682 //
     /* 1985442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1985453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1985456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985488 */     // MIs[0] policy
     /* 1985488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985522 */     // GIR_Coverage, 61682,
     /* 1985522 */     GIR_EraseRootFromParent_Done,
     /* 1985523 */   // Label 26595: @1985523
     /* 1985523 */   GIM_Try, /*On fail goto*//*Label 26596*/ GIMT_Encode4(1985609), // Rule ID 61683 //
     /* 1985528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1985539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1985542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1985545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985574 */     // MIs[0] policy
     /* 1985574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11526:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985608 */     // GIR_Coverage, 61683,
     /* 1985608 */     GIR_EraseRootFromParent_Done,
     /* 1985609 */   // Label 26596: @1985609
     /* 1985609 */   GIM_Try, /*On fail goto*//*Label 26597*/ GIMT_Encode4(1985695), // Rule ID 61686 //
     /* 1985614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1985625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1985628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1985631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985660 */     // MIs[0] policy
     /* 1985660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985694 */     // GIR_Coverage, 61686,
     /* 1985694 */     GIR_EraseRootFromParent_Done,
     /* 1985695 */   // Label 26597: @1985695
     /* 1985695 */   GIM_Try, /*On fail goto*//*Label 26598*/ GIMT_Encode4(1985781), // Rule ID 61687 //
     /* 1985700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1985711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1985714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1985717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985746 */     // MIs[0] policy
     /* 1985746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11526:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1985777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985780 */     // GIR_Coverage, 61687,
     /* 1985780 */     GIR_EraseRootFromParent_Done,
     /* 1985781 */   // Label 26598: @1985781
     /* 1985781 */   GIM_Try, /*On fail goto*//*Label 26599*/ GIMT_Encode4(1985867), // Rule ID 61690 //
     /* 1985786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1985797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1985800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1985803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985832 */     // MIs[0] policy
     /* 1985832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985842 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985866 */     // GIR_Coverage, 61690,
     /* 1985866 */     GIR_EraseRootFromParent_Done,
     /* 1985867 */   // Label 26599: @1985867
     /* 1985867 */   GIM_Try, /*On fail goto*//*Label 26600*/ GIMT_Encode4(1985953), // Rule ID 61691 //
     /* 1985872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1985883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1985886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1985889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985918 */     // MIs[0] policy
     /* 1985918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11526:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1985931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985952 */     // GIR_Coverage, 61691,
     /* 1985952 */     GIR_EraseRootFromParent_Done,
     /* 1985953 */   // Label 26600: @1985953
     /* 1985953 */   GIM_Try, /*On fail goto*//*Label 26601*/ GIMT_Encode4(1986039), // Rule ID 61694 //
     /* 1985958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1985966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1985969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1985972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1985975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1985981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1985988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1985992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1985996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986004 */     // MIs[0] policy
     /* 1986004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986038 */     // GIR_Coverage, 61694,
     /* 1986038 */     GIR_EraseRootFromParent_Done,
     /* 1986039 */   // Label 26601: @1986039
     /* 1986039 */   GIM_Try, /*On fail goto*//*Label 26602*/ GIMT_Encode4(1986125), // Rule ID 61695 //
     /* 1986044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1986061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986090 */     // MIs[0] policy
     /* 1986090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986100 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986124 */     // GIR_Coverage, 61695,
     /* 1986124 */     GIR_EraseRootFromParent_Done,
     /* 1986125 */   // Label 26602: @1986125
     /* 1986125 */   GIM_Try, /*On fail goto*//*Label 26603*/ GIMT_Encode4(1986211), // Rule ID 61698 //
     /* 1986130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986176 */     // MIs[0] policy
     /* 1986176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986186 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986210 */     // GIR_Coverage, 61698,
     /* 1986210 */     GIR_EraseRootFromParent_Done,
     /* 1986211 */   // Label 26603: @1986211
     /* 1986211 */   GIM_Try, /*On fail goto*//*Label 26604*/ GIMT_Encode4(1986297), // Rule ID 61699 //
     /* 1986216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1986227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1986230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1986233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986262 */     // MIs[0] policy
     /* 1986262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986272 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986296 */     // GIR_Coverage, 61699,
     /* 1986296 */     GIR_EraseRootFromParent_Done,
     /* 1986297 */   // Label 26604: @1986297
     /* 1986297 */   GIM_Try, /*On fail goto*//*Label 26605*/ GIMT_Encode4(1986383), // Rule ID 61702 //
     /* 1986302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986348 */     // MIs[0] policy
     /* 1986348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986358 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986382 */     // GIR_Coverage, 61702,
     /* 1986382 */     GIR_EraseRootFromParent_Done,
     /* 1986383 */   // Label 26605: @1986383
     /* 1986383 */   GIM_Try, /*On fail goto*//*Label 26606*/ GIMT_Encode4(1986469), // Rule ID 61703 //
     /* 1986388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1986399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1986402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1986405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1986411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986434 */     // MIs[0] policy
     /* 1986434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986444 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986468 */     // GIR_Coverage, 61703,
     /* 1986468 */     GIR_EraseRootFromParent_Done,
     /* 1986469 */   // Label 26606: @1986469
     /* 1986469 */   GIM_Try, /*On fail goto*//*Label 26607*/ GIMT_Encode4(1986555), // Rule ID 61706 //
     /* 1986474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1986485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1986488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986520 */     // MIs[0] policy
     /* 1986520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986554 */     // GIR_Coverage, 61706,
     /* 1986554 */     GIR_EraseRootFromParent_Done,
     /* 1986555 */   // Label 26607: @1986555
     /* 1986555 */   GIM_Try, /*On fail goto*//*Label 26608*/ GIMT_Encode4(1986641), // Rule ID 61707 //
     /* 1986560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1986571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1986574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1986577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986606 */     // MIs[0] policy
     /* 1986606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1986619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986640 */     // GIR_Coverage, 61707,
     /* 1986640 */     GIR_EraseRootFromParent_Done,
     /* 1986641 */   // Label 26608: @1986641
     /* 1986641 */   GIM_Try, /*On fail goto*//*Label 26609*/ GIMT_Encode4(1986727), // Rule ID 61710 //
     /* 1986646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1986657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1986660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1986663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986692 */     // MIs[0] policy
     /* 1986692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986726 */     // GIR_Coverage, 61710,
     /* 1986726 */     GIR_EraseRootFromParent_Done,
     /* 1986727 */   // Label 26609: @1986727
     /* 1986727 */   GIM_Try, /*On fail goto*//*Label 26610*/ GIMT_Encode4(1986813), // Rule ID 61711 //
     /* 1986732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1986743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1986746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1986749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1986762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1986770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986778 */     // MIs[0] policy
     /* 1986778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986788 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1986791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986812 */     // GIR_Coverage, 61711,
     /* 1986812 */     GIR_EraseRootFromParent_Done,
     /* 1986813 */   // Label 26610: @1986813
     /* 1986813 */   GIM_Try, /*On fail goto*//*Label 26611*/ GIMT_Encode4(1986899), // Rule ID 61714 //
     /* 1986818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1986829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1986832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1986835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986864 */     // MIs[0] policy
     /* 1986864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986874 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986898 */     // GIR_Coverage, 61714,
     /* 1986898 */     GIR_EraseRootFromParent_Done,
     /* 1986899 */   // Label 26611: @1986899
     /* 1986899 */   GIM_Try, /*On fail goto*//*Label 26612*/ GIMT_Encode4(1986985), // Rule ID 61715 //
     /* 1986904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1986915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1986918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1986921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1986927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1986934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1986942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986950 */     // MIs[0] policy
     /* 1986950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1986963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986984 */     // GIR_Coverage, 61715,
     /* 1986984 */     GIR_EraseRootFromParent_Done,
     /* 1986985 */   // Label 26612: @1986985
     /* 1986985 */   GIM_Try, /*On fail goto*//*Label 26613*/ GIMT_Encode4(1987071), // Rule ID 61718 //
     /* 1986990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1986998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987036 */     // MIs[0] policy
     /* 1987036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987070 */     // GIR_Coverage, 61718,
     /* 1987070 */     GIR_EraseRootFromParent_Done,
     /* 1987071 */   // Label 26613: @1987071
     /* 1987071 */   GIM_Try, /*On fail goto*//*Label 26614*/ GIMT_Encode4(1987157), // Rule ID 61719 //
     /* 1987076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987122 */     // MIs[0] policy
     /* 1987122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987156 */     // GIR_Coverage, 61719,
     /* 1987156 */     GIR_EraseRootFromParent_Done,
     /* 1987157 */   // Label 26614: @1987157
     /* 1987157 */   GIM_Try, /*On fail goto*//*Label 26615*/ GIMT_Encode4(1987243), // Rule ID 61722 //
     /* 1987162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987208 */     // MIs[0] policy
     /* 1987208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987242 */     // GIR_Coverage, 61722,
     /* 1987242 */     GIR_EraseRootFromParent_Done,
     /* 1987243 */   // Label 26615: @1987243
     /* 1987243 */   GIM_Try, /*On fail goto*//*Label 26616*/ GIMT_Encode4(1987329), // Rule ID 61723 //
     /* 1987248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1987259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1987262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1987265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987294 */     // MIs[0] policy
     /* 1987294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987304 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987328 */     // GIR_Coverage, 61723,
     /* 1987328 */     GIR_EraseRootFromParent_Done,
     /* 1987329 */   // Label 26616: @1987329
     /* 1987329 */   GIM_Try, /*On fail goto*//*Label 26617*/ GIMT_Encode4(1987415), // Rule ID 61726 //
     /* 1987334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987380 */     // MIs[0] policy
     /* 1987380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987414 */     // GIR_Coverage, 61726,
     /* 1987414 */     GIR_EraseRootFromParent_Done,
     /* 1987415 */   // Label 26617: @1987415
     /* 1987415 */   GIM_Try, /*On fail goto*//*Label 26618*/ GIMT_Encode4(1987501), // Rule ID 61727 //
     /* 1987420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1987431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1987434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1987437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987466 */     // MIs[0] policy
     /* 1987466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1987497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987500 */     // GIR_Coverage, 61727,
     /* 1987500 */     GIR_EraseRootFromParent_Done,
     /* 1987501 */   // Label 26618: @1987501
     /* 1987501 */   GIM_Try, /*On fail goto*//*Label 26619*/ GIMT_Encode4(1987587), // Rule ID 61730 //
     /* 1987506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1987517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1987520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987552 */     // MIs[0] policy
     /* 1987552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987586 */     // GIR_Coverage, 61730,
     /* 1987586 */     GIR_EraseRootFromParent_Done,
     /* 1987587 */   // Label 26619: @1987587
     /* 1987587 */   GIM_Try, /*On fail goto*//*Label 26620*/ GIMT_Encode4(1987673), // Rule ID 61731 //
     /* 1987592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1987603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1987606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1987609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1987615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987638 */     // MIs[0] policy
     /* 1987638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11526:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1987651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987672 */     // GIR_Coverage, 61731,
     /* 1987672 */     GIR_EraseRootFromParent_Done,
     /* 1987673 */   // Label 26620: @1987673
     /* 1987673 */   GIM_Try, /*On fail goto*//*Label 26621*/ GIMT_Encode4(1987759), // Rule ID 61734 //
     /* 1987678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1987689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1987692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1987695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987724 */     // MIs[0] policy
     /* 1987724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987758 */     // GIR_Coverage, 61734,
     /* 1987758 */     GIR_EraseRootFromParent_Done,
     /* 1987759 */   // Label 26621: @1987759
     /* 1987759 */   GIM_Try, /*On fail goto*//*Label 26622*/ GIMT_Encode4(1987845), // Rule ID 61735 //
     /* 1987764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1987775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1987778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1987781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987810 */     // MIs[0] policy
     /* 1987810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987820 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11526:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1987823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987844 */     // GIR_Coverage, 61735,
     /* 1987844 */     GIR_EraseRootFromParent_Done,
     /* 1987845 */   // Label 26622: @1987845
     /* 1987845 */   GIM_Try, /*On fail goto*//*Label 26623*/ GIMT_Encode4(1987931), // Rule ID 61738 //
     /* 1987850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1987861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1987864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1987867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987896 */     // MIs[0] policy
     /* 1987896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987906 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1987927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987930 */     // GIR_Coverage, 61738,
     /* 1987930 */     GIR_EraseRootFromParent_Done,
     /* 1987931 */   // Label 26623: @1987931
     /* 1987931 */   GIM_Try, /*On fail goto*//*Label 26624*/ GIMT_Encode4(1988017), // Rule ID 61739 //
     /* 1987936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1987944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1987947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1987950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1987953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987982 */     // MIs[0] policy
     /* 1987982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987992 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11526:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1987995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988016 */     // GIR_Coverage, 61739,
     /* 1988016 */     GIR_EraseRootFromParent_Done,
     /* 1988017 */   // Label 26624: @1988017
     /* 1988017 */   GIM_Try, /*On fail goto*//*Label 26625*/ GIMT_Encode4(1988103), // Rule ID 61826 //
     /* 1988022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1988042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988068 */     // MIs[0] policy
     /* 1988068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988078 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1988081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988102 */     // GIR_Coverage, 61826,
     /* 1988102 */     GIR_EraseRootFromParent_Done,
     /* 1988103 */   // Label 26625: @1988103
     /* 1988103 */   GIM_Try, /*On fail goto*//*Label 26626*/ GIMT_Encode4(1988189), // Rule ID 61827 //
     /* 1988108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1988119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1988122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1988125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1988128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988154 */     // MIs[0] policy
     /* 1988154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1988167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988188 */     // GIR_Coverage, 61827,
     /* 1988188 */     GIR_EraseRootFromParent_Done,
     /* 1988189 */   // Label 26626: @1988189
     /* 1988189 */   GIM_Try, /*On fail goto*//*Label 26627*/ GIMT_Encode4(1988275), // Rule ID 61830 //
     /* 1988194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1988214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988240 */     // MIs[0] policy
     /* 1988240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988250 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988274 */     // GIR_Coverage, 61830,
     /* 1988274 */     GIR_EraseRootFromParent_Done,
     /* 1988275 */   // Label 26627: @1988275
     /* 1988275 */   GIM_Try, /*On fail goto*//*Label 26628*/ GIMT_Encode4(1988361), // Rule ID 61831 //
     /* 1988280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1988291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1988294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1988297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1988300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988326 */     // MIs[0] policy
     /* 1988326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988336 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988360 */     // GIR_Coverage, 61831,
     /* 1988360 */     GIR_EraseRootFromParent_Done,
     /* 1988361 */   // Label 26628: @1988361
     /* 1988361 */   GIM_Try, /*On fail goto*//*Label 26629*/ GIMT_Encode4(1988447), // Rule ID 61834 //
     /* 1988366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1988386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988412 */     // MIs[0] policy
     /* 1988412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988422 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988446 */     // GIR_Coverage, 61834,
     /* 1988446 */     GIR_EraseRootFromParent_Done,
     /* 1988447 */   // Label 26629: @1988447
     /* 1988447 */   GIM_Try, /*On fail goto*//*Label 26630*/ GIMT_Encode4(1988533), // Rule ID 61835 //
     /* 1988452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1988463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1988466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1988469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1988472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988498 */     // MIs[0] policy
     /* 1988498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1988529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988532 */     // GIR_Coverage, 61835,
     /* 1988532 */     GIR_EraseRootFromParent_Done,
     /* 1988533 */   // Label 26630: @1988533
     /* 1988533 */   GIM_Try, /*On fail goto*//*Label 26631*/ GIMT_Encode4(1988619), // Rule ID 61838 //
     /* 1988538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1988549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1988552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1988555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1988558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988584 */     // MIs[0] policy
     /* 1988584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988618 */     // GIR_Coverage, 61838,
     /* 1988618 */     GIR_EraseRootFromParent_Done,
     /* 1988619 */   // Label 26631: @1988619
     /* 1988619 */   GIM_Try, /*On fail goto*//*Label 26632*/ GIMT_Encode4(1988705), // Rule ID 61839 //
     /* 1988624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1988635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1988638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1988641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1988644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988670 */     // MIs[0] policy
     /* 1988670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988680 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1988683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988704 */     // GIR_Coverage, 61839,
     /* 1988704 */     GIR_EraseRootFromParent_Done,
     /* 1988705 */   // Label 26632: @1988705
     /* 1988705 */   GIM_Try, /*On fail goto*//*Label 26633*/ GIMT_Encode4(1988791), // Rule ID 61842 //
     /* 1988710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1988721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1988724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1988727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1988730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988756 */     // MIs[0] policy
     /* 1988756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988766 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988790 */     // GIR_Coverage, 61842,
     /* 1988790 */     GIR_EraseRootFromParent_Done,
     /* 1988791 */   // Label 26633: @1988791
     /* 1988791 */   GIM_Try, /*On fail goto*//*Label 26634*/ GIMT_Encode4(1988877), // Rule ID 61843 //
     /* 1988796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1988807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1988810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1988813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1988816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988842 */     // MIs[0] policy
     /* 1988842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1988873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988876 */     // GIR_Coverage, 61843,
     /* 1988876 */     GIR_EraseRootFromParent_Done,
     /* 1988877 */   // Label 26634: @1988877
     /* 1988877 */   GIM_Try, /*On fail goto*//*Label 26635*/ GIMT_Encode4(1988963), // Rule ID 61846 //
     /* 1988882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1988893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1988896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1988899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1988902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1988924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988928 */     // MIs[0] policy
     /* 1988928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988938 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1988941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988962 */     // GIR_Coverage, 61846,
     /* 1988962 */     GIR_EraseRootFromParent_Done,
     /* 1988963 */   // Label 26635: @1988963
     /* 1988963 */   GIM_Try, /*On fail goto*//*Label 26636*/ GIMT_Encode4(1989049), // Rule ID 61847 //
     /* 1988968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1988979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1988982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1988985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1988988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1988991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1988998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989014 */     // MIs[0] policy
     /* 1989014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1989027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989048 */     // GIR_Coverage, 61847,
     /* 1989048 */     GIR_EraseRootFromParent_Done,
     /* 1989049 */   // Label 26636: @1989049
     /* 1989049 */   GIM_Try, /*On fail goto*//*Label 26637*/ GIMT_Encode4(1989135), // Rule ID 61850 //
     /* 1989054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989100 */     // MIs[0] policy
     /* 1989100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989134 */     // GIR_Coverage, 61850,
     /* 1989134 */     GIR_EraseRootFromParent_Done,
     /* 1989135 */   // Label 26637: @1989135
     /* 1989135 */   GIM_Try, /*On fail goto*//*Label 26638*/ GIMT_Encode4(1989221), // Rule ID 61851 //
     /* 1989140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1989151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1989154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989186 */     // MIs[0] policy
     /* 1989186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989220 */     // GIR_Coverage, 61851,
     /* 1989220 */     GIR_EraseRootFromParent_Done,
     /* 1989221 */   // Label 26638: @1989221
     /* 1989221 */   GIM_Try, /*On fail goto*//*Label 26639*/ GIMT_Encode4(1989307), // Rule ID 61854 //
     /* 1989226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1989246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989272 */     // MIs[0] policy
     /* 1989272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989282 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989306 */     // GIR_Coverage, 61854,
     /* 1989306 */     GIR_EraseRootFromParent_Done,
     /* 1989307 */   // Label 26639: @1989307
     /* 1989307 */   GIM_Try, /*On fail goto*//*Label 26640*/ GIMT_Encode4(1989393), // Rule ID 61855 //
     /* 1989312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1989323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1989326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1989329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1989332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989358 */     // MIs[0] policy
     /* 1989358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1989389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989392 */     // GIR_Coverage, 61855,
     /* 1989392 */     GIR_EraseRootFromParent_Done,
     /* 1989393 */   // Label 26640: @1989393
     /* 1989393 */   GIM_Try, /*On fail goto*//*Label 26641*/ GIMT_Encode4(1989479), // Rule ID 61858 //
     /* 1989398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1989418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989444 */     // MIs[0] policy
     /* 1989444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989454 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989478 */     // GIR_Coverage, 61858,
     /* 1989478 */     GIR_EraseRootFromParent_Done,
     /* 1989479 */   // Label 26641: @1989479
     /* 1989479 */   GIM_Try, /*On fail goto*//*Label 26642*/ GIMT_Encode4(1989565), // Rule ID 61859 //
     /* 1989484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1989501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1989504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1989507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989530 */     // MIs[0] policy
     /* 1989530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989564 */     // GIR_Coverage, 61859,
     /* 1989564 */     GIR_EraseRootFromParent_Done,
     /* 1989565 */   // Label 26642: @1989565
     /* 1989565 */   GIM_Try, /*On fail goto*//*Label 26643*/ GIMT_Encode4(1989651), // Rule ID 61862 //
     /* 1989570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1989581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1989584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1989587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1989590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989616 */     // MIs[0] policy
     /* 1989616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989650 */     // GIR_Coverage, 61862,
     /* 1989650 */     GIR_EraseRootFromParent_Done,
     /* 1989651 */   // Label 26643: @1989651
     /* 1989651 */   GIM_Try, /*On fail goto*//*Label 26644*/ GIMT_Encode4(1989737), // Rule ID 61863 //
     /* 1989656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1989667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1989670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1989673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1989676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1989679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989702 */     // MIs[0] policy
     /* 1989702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1989715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1989733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989736 */     // GIR_Coverage, 61863,
     /* 1989736 */     GIR_EraseRootFromParent_Done,
     /* 1989737 */   // Label 26644: @1989737
     /* 1989737 */   GIM_Try, /*On fail goto*//*Label 26645*/ GIMT_Encode4(1989823), // Rule ID 61866 //
     /* 1989742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1989753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1989756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1989759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1989762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989788 */     // MIs[0] policy
     /* 1989788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989798 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1989801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989822 */     // GIR_Coverage, 61866,
     /* 1989822 */     GIR_EraseRootFromParent_Done,
     /* 1989823 */   // Label 26645: @1989823
     /* 1989823 */   GIM_Try, /*On fail goto*//*Label 26646*/ GIMT_Encode4(1989909), // Rule ID 61867 //
     /* 1989828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1989831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1989839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1989842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1989845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1989848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989874 */     // MIs[0] policy
     /* 1989874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989884 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1989887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989908 */     // GIR_Coverage, 61867,
     /* 1989908 */     GIR_EraseRootFromParent_Done,
     /* 1989909 */   // Label 26646: @1989909
     /* 1989909 */   GIM_Try, /*On fail goto*//*Label 26647*/ GIMT_Encode4(1989995), // Rule ID 61870 //
     /* 1989914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1989917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1989922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1989925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1989928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1989931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1989934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1989937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1989944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989960 */     // MIs[0] policy
     /* 1989960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989970 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1989973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1989977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1989991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989994 */     // GIR_Coverage, 61870,
     /* 1989994 */     GIR_EraseRootFromParent_Done,
     /* 1989995 */   // Label 26647: @1989995
     /* 1989995 */   GIM_Try, /*On fail goto*//*Label 26648*/ GIMT_Encode4(1990081), // Rule ID 61871 //
     /* 1990000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1990011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1990014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1990017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1990020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990046 */     // MIs[0] policy
     /* 1990046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990056 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990080 */     // GIR_Coverage, 61871,
     /* 1990080 */     GIR_EraseRootFromParent_Done,
     /* 1990081 */   // Label 26648: @1990081
     /* 1990081 */   GIM_Try, /*On fail goto*//*Label 26649*/ GIMT_Encode4(1990167), // Rule ID 61874 //
     /* 1990086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990132 */     // MIs[0] policy
     /* 1990132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990142 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990166 */     // GIR_Coverage, 61874,
     /* 1990166 */     GIR_EraseRootFromParent_Done,
     /* 1990167 */   // Label 26649: @1990167
     /* 1990167 */   GIM_Try, /*On fail goto*//*Label 26650*/ GIMT_Encode4(1990253), // Rule ID 61875 //
     /* 1990172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1990183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1990186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1990189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990218 */     // MIs[0] policy
     /* 1990218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990228 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1990249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990252 */     // GIR_Coverage, 61875,
     /* 1990252 */     GIR_EraseRootFromParent_Done,
     /* 1990253 */   // Label 26650: @1990253
     /* 1990253 */   GIM_Try, /*On fail goto*//*Label 26651*/ GIMT_Encode4(1990339), // Rule ID 61878 //
     /* 1990258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1990278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990304 */     // MIs[0] policy
     /* 1990304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990314 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990338 */     // GIR_Coverage, 61878,
     /* 1990338 */     GIR_EraseRootFromParent_Done,
     /* 1990339 */   // Label 26651: @1990339
     /* 1990339 */   GIM_Try, /*On fail goto*//*Label 26652*/ GIMT_Encode4(1990425), // Rule ID 61879 //
     /* 1990344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1990355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1990358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1990361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1990364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990390 */     // MIs[0] policy
     /* 1990390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990424 */     // GIR_Coverage, 61879,
     /* 1990424 */     GIR_EraseRootFromParent_Done,
     /* 1990425 */   // Label 26652: @1990425
     /* 1990425 */   GIM_Try, /*On fail goto*//*Label 26653*/ GIMT_Encode4(1990511), // Rule ID 61882 //
     /* 1990430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1990447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1990450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990476 */     // MIs[0] policy
     /* 1990476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990486 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990510 */     // GIR_Coverage, 61882,
     /* 1990510 */     GIR_EraseRootFromParent_Done,
     /* 1990511 */   // Label 26653: @1990511
     /* 1990511 */   GIM_Try, /*On fail goto*//*Label 26654*/ GIMT_Encode4(1990597), // Rule ID 61883 //
     /* 1990516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1990527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1990530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1990533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1990536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990562 */     // MIs[0] policy
     /* 1990562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1990575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990596 */     // GIR_Coverage, 61883,
     /* 1990596 */     GIR_EraseRootFromParent_Done,
     /* 1990597 */   // Label 26654: @1990597
     /* 1990597 */   GIM_Try, /*On fail goto*//*Label 26655*/ GIMT_Encode4(1990683), // Rule ID 61886 //
     /* 1990602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1990613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1990616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1990619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1990622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990648 */     // MIs[0] policy
     /* 1990648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990658 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990682 */     // GIR_Coverage, 61886,
     /* 1990682 */     GIR_EraseRootFromParent_Done,
     /* 1990683 */   // Label 26655: @1990683
     /* 1990683 */   GIM_Try, /*On fail goto*//*Label 26656*/ GIMT_Encode4(1990769), // Rule ID 61887 //
     /* 1990688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1990699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1990702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1990705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1990708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990734 */     // MIs[0] policy
     /* 1990734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990744 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1990747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1990765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990768 */     // GIR_Coverage, 61887,
     /* 1990768 */     GIR_EraseRootFromParent_Done,
     /* 1990769 */   // Label 26656: @1990769
     /* 1990769 */   GIM_Try, /*On fail goto*//*Label 26657*/ GIMT_Encode4(1990855), // Rule ID 61890 //
     /* 1990774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1990791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1990794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990820 */     // MIs[0] policy
     /* 1990820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990854 */     // GIR_Coverage, 61890,
     /* 1990854 */     GIR_EraseRootFromParent_Done,
     /* 1990855 */   // Label 26657: @1990855
     /* 1990855 */   GIM_Try, /*On fail goto*//*Label 26658*/ GIMT_Encode4(1990941), // Rule ID 61891 //
     /* 1990860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1990863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1990877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1990880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990906 */     // MIs[0] policy
     /* 1990906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1990919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1990923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990940 */     // GIR_Coverage, 61891,
     /* 1990940 */     GIR_EraseRootFromParent_Done,
     /* 1990941 */   // Label 26658: @1990941
     /* 1990941 */   GIM_Try, /*On fail goto*//*Label 26659*/ GIMT_Encode4(1991027), // Rule ID 61894 //
     /* 1990946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1990949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1990954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1990957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1990960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1990963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1990966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990992 */     // MIs[0] policy
     /* 1990992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991026 */     // GIR_Coverage, 61894,
     /* 1991026 */     GIR_EraseRootFromParent_Done,
     /* 1991027 */   // Label 26659: @1991027
     /* 1991027 */   GIM_Try, /*On fail goto*//*Label 26660*/ GIMT_Encode4(1991113), // Rule ID 61895 //
     /* 1991032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1991049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1991052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991078 */     // MIs[0] policy
     /* 1991078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991112 */     // GIR_Coverage, 61895,
     /* 1991112 */     GIR_EraseRootFromParent_Done,
     /* 1991113 */   // Label 26660: @1991113
     /* 1991113 */   GIM_Try, /*On fail goto*//*Label 26661*/ GIMT_Encode4(1991199), // Rule ID 61898 //
     /* 1991118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1991138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991164 */     // MIs[0] policy
     /* 1991164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991174 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991198 */     // GIR_Coverage, 61898,
     /* 1991198 */     GIR_EraseRootFromParent_Done,
     /* 1991199 */   // Label 26661: @1991199
     /* 1991199 */   GIM_Try, /*On fail goto*//*Label 26662*/ GIMT_Encode4(1991285), // Rule ID 61899 //
     /* 1991204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1991221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1991224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991250 */     // MIs[0] policy
     /* 1991250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991260 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991284 */     // GIR_Coverage, 61899,
     /* 1991284 */     GIR_EraseRootFromParent_Done,
     /* 1991285 */   // Label 26662: @1991285
     /* 1991285 */   GIM_Try, /*On fail goto*//*Label 26663*/ GIMT_Encode4(1991371), // Rule ID 61902 //
     /* 1991290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1991310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991336 */     // MIs[0] policy
     /* 1991336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991346 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991370 */     // GIR_Coverage, 61902,
     /* 1991370 */     GIR_EraseRootFromParent_Done,
     /* 1991371 */   // Label 26663: @1991371
     /* 1991371 */   GIM_Try, /*On fail goto*//*Label 26664*/ GIMT_Encode4(1991457), // Rule ID 61903 //
     /* 1991376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1991387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1991390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1991393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1991396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1991399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991422 */     // MIs[0] policy
     /* 1991422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1991435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991456 */     // GIR_Coverage, 61903,
     /* 1991456 */     GIR_EraseRootFromParent_Done,
     /* 1991457 */   // Label 26664: @1991457
     /* 1991457 */   GIM_Try, /*On fail goto*//*Label 26665*/ GIMT_Encode4(1991543), // Rule ID 61906 //
     /* 1991462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1991473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1991476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1991479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1991482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991508 */     // MIs[0] policy
     /* 1991508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991518 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991542 */     // GIR_Coverage, 61906,
     /* 1991542 */     GIR_EraseRootFromParent_Done,
     /* 1991543 */   // Label 26665: @1991543
     /* 1991543 */   GIM_Try, /*On fail goto*//*Label 26666*/ GIMT_Encode4(1991629), // Rule ID 61907 //
     /* 1991548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1991559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1991562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1991565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1991568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991594 */     // MIs[0] policy
     /* 1991594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1991607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991628 */     // GIR_Coverage, 61907,
     /* 1991628 */     GIR_EraseRootFromParent_Done,
     /* 1991629 */   // Label 26666: @1991629
     /* 1991629 */   GIM_Try, /*On fail goto*//*Label 26667*/ GIMT_Encode4(1991715), // Rule ID 61910 //
     /* 1991634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1991645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1991648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1991651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1991654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991680 */     // MIs[0] policy
     /* 1991680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991714 */     // GIR_Coverage, 61910,
     /* 1991714 */     GIR_EraseRootFromParent_Done,
     /* 1991715 */   // Label 26667: @1991715
     /* 1991715 */   GIM_Try, /*On fail goto*//*Label 26668*/ GIMT_Encode4(1991801), // Rule ID 61911 //
     /* 1991720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1991731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1991734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1991737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1991740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991766 */     // MIs[0] policy
     /* 1991766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1991779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1991797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991800 */     // GIR_Coverage, 61911,
     /* 1991800 */     GIR_EraseRootFromParent_Done,
     /* 1991801 */   // Label 26668: @1991801
     /* 1991801 */   GIM_Try, /*On fail goto*//*Label 26669*/ GIMT_Encode4(1991887), // Rule ID 61914 //
     /* 1991806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1991817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1991820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1991823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991852 */     // MIs[0] policy
     /* 1991852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991862 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1991865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991886 */     // GIR_Coverage, 61914,
     /* 1991886 */     GIR_EraseRootFromParent_Done,
     /* 1991887 */   // Label 26669: @1991887
     /* 1991887 */   GIM_Try, /*On fail goto*//*Label 26670*/ GIMT_Encode4(1991973), // Rule ID 61915 //
     /* 1991892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1991895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1991903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1991906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1991909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1991912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1991915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991938 */     // MIs[0] policy
     /* 1991938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991948 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1991951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1991955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1991969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991972 */     // GIR_Coverage, 61915,
     /* 1991972 */     GIR_EraseRootFromParent_Done,
     /* 1991973 */   // Label 26670: @1991973
     /* 1991973 */   GIM_Try, /*On fail goto*//*Label 26671*/ GIMT_Encode4(1992059), // Rule ID 61918 //
     /* 1991978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1991981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1991986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1991989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1991992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1991995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1991998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992024 */     // MIs[0] policy
     /* 1992024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992034 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992058 */     // GIR_Coverage, 61918,
     /* 1992058 */     GIR_EraseRootFromParent_Done,
     /* 1992059 */   // Label 26671: @1992059
     /* 1992059 */   GIM_Try, /*On fail goto*//*Label 26672*/ GIMT_Encode4(1992145), // Rule ID 61919 //
     /* 1992064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1992075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1992078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1992081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992110 */     // MIs[0] policy
     /* 1992110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992120 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992144 */     // GIR_Coverage, 61919,
     /* 1992144 */     GIR_EraseRootFromParent_Done,
     /* 1992145 */   // Label 26672: @1992145
     /* 1992145 */   GIM_Try, /*On fail goto*//*Label 26673*/ GIMT_Encode4(1992231), // Rule ID 61922 //
     /* 1992150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992196 */     // MIs[0] policy
     /* 1992196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992206 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992230 */     // GIR_Coverage, 61922,
     /* 1992230 */     GIR_EraseRootFromParent_Done,
     /* 1992231 */   // Label 26673: @1992231
     /* 1992231 */   GIM_Try, /*On fail goto*//*Label 26674*/ GIMT_Encode4(1992317), // Rule ID 61923 //
     /* 1992236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1992247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1992250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992282 */     // MIs[0] policy
     /* 1992282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992292 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992316 */     // GIR_Coverage, 61923,
     /* 1992316 */     GIR_EraseRootFromParent_Done,
     /* 1992317 */   // Label 26674: @1992317
     /* 1992317 */   GIM_Try, /*On fail goto*//*Label 26675*/ GIMT_Encode4(1992403), // Rule ID 61926 //
     /* 1992322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992368 */     // MIs[0] policy
     /* 1992368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992378 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992402 */     // GIR_Coverage, 61926,
     /* 1992402 */     GIR_EraseRootFromParent_Done,
     /* 1992403 */   // Label 26675: @1992403
     /* 1992403 */   GIM_Try, /*On fail goto*//*Label 26676*/ GIMT_Encode4(1992489), // Rule ID 61927 //
     /* 1992408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1992419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1992422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1992425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992454 */     // MIs[0] policy
     /* 1992454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992464 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1992467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992488 */     // GIR_Coverage, 61927,
     /* 1992488 */     GIR_EraseRootFromParent_Done,
     /* 1992489 */   // Label 26676: @1992489
     /* 1992489 */   GIM_Try, /*On fail goto*//*Label 26677*/ GIMT_Encode4(1992575), // Rule ID 61930 //
     /* 1992494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1992511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992540 */     // MIs[0] policy
     /* 1992540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992550 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992574 */     // GIR_Coverage, 61930,
     /* 1992574 */     GIR_EraseRootFromParent_Done,
     /* 1992575 */   // Label 26677: @1992575
     /* 1992575 */   GIM_Try, /*On fail goto*//*Label 26678*/ GIMT_Encode4(1992661), // Rule ID 61931 //
     /* 1992580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1992591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1992594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1992597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1992603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992626 */     // MIs[0] policy
     /* 1992626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1992657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992660 */     // GIR_Coverage, 61931,
     /* 1992660 */     GIR_EraseRootFromParent_Done,
     /* 1992661 */   // Label 26678: @1992661
     /* 1992661 */   GIM_Try, /*On fail goto*//*Label 26679*/ GIMT_Encode4(1992747), // Rule ID 61934 //
     /* 1992666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1992677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1992680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1992683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992712 */     // MIs[0] policy
     /* 1992712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992746 */     // GIR_Coverage, 61934,
     /* 1992746 */     GIR_EraseRootFromParent_Done,
     /* 1992747 */   // Label 26679: @1992747
     /* 1992747 */   GIM_Try, /*On fail goto*//*Label 26680*/ GIMT_Encode4(1992833), // Rule ID 61935 //
     /* 1992752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1992763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1992766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1992769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1992775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992798 */     // MIs[0] policy
     /* 1992798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992808 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1992811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992832 */     // GIR_Coverage, 61935,
     /* 1992832 */     GIR_EraseRootFromParent_Done,
     /* 1992833 */   // Label 26680: @1992833
     /* 1992833 */   GIM_Try, /*On fail goto*//*Label 26681*/ GIMT_Encode4(1992919), // Rule ID 61938 //
     /* 1992838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1992841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1992849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1992852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1992855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1992858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992884 */     // MIs[0] policy
     /* 1992884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992894 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1992897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1992915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992918 */     // GIR_Coverage, 61938,
     /* 1992918 */     GIR_EraseRootFromParent_Done,
     /* 1992919 */   // Label 26681: @1992919
     /* 1992919 */   GIM_Try, /*On fail goto*//*Label 26682*/ GIMT_Encode4(1993005), // Rule ID 61939 //
     /* 1992924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1992927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1992932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1992935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1992938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1992941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1992944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992970 */     // MIs[0] policy
     /* 1992970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11528:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1992983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1992987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993004 */     // GIR_Coverage, 61939,
     /* 1993004 */     GIR_EraseRootFromParent_Done,
     /* 1993005 */   // Label 26682: @1993005
     /* 1993005 */   GIM_Try, /*On fail goto*//*Label 26683*/ GIMT_Encode4(1993091), // Rule ID 61942 //
     /* 1993010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993056 */     // MIs[0] policy
     /* 1993056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993066 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993090 */     // GIR_Coverage, 61942,
     /* 1993090 */     GIR_EraseRootFromParent_Done,
     /* 1993091 */   // Label 26683: @1993091
     /* 1993091 */   GIM_Try, /*On fail goto*//*Label 26684*/ GIMT_Encode4(1993177), // Rule ID 61943 //
     /* 1993096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1993107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1993110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1993113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993142 */     // MIs[0] policy
     /* 1993142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11528:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1993173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993176 */     // GIR_Coverage, 61943,
     /* 1993176 */     GIR_EraseRootFromParent_Done,
     /* 1993177 */   // Label 26684: @1993177
     /* 1993177 */   GIM_Try, /*On fail goto*//*Label 26685*/ GIMT_Encode4(1993263), // Rule ID 61946 //
     /* 1993182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993228 */     // MIs[0] policy
     /* 1993228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993238 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993262 */     // GIR_Coverage, 61946,
     /* 1993262 */     GIR_EraseRootFromParent_Done,
     /* 1993263 */   // Label 26685: @1993263
     /* 1993263 */   GIM_Try, /*On fail goto*//*Label 26686*/ GIMT_Encode4(1993349), // Rule ID 61947 //
     /* 1993268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1993285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1993291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993314 */     // MIs[0] policy
     /* 1993314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11528:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993348 */     // GIR_Coverage, 61947,
     /* 1993348 */     GIR_EraseRootFromParent_Done,
     /* 1993349 */   // Label 26686: @1993349
     /* 1993349 */   GIM_Try, /*On fail goto*//*Label 26687*/ GIMT_Encode4(1993435), // Rule ID 61950 //
     /* 1993354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993400 */     // MIs[0] policy
     /* 1993400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993410 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993434 */     // GIR_Coverage, 61950,
     /* 1993434 */     GIR_EraseRootFromParent_Done,
     /* 1993435 */   // Label 26687: @1993435
     /* 1993435 */   GIM_Try, /*On fail goto*//*Label 26688*/ GIMT_Encode4(1993521), // Rule ID 61951 //
     /* 1993440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1993451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1993454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1993457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1993463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993486 */     // MIs[0] policy
     /* 1993486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11528:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1993499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1993517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993520 */     // GIR_Coverage, 61951,
     /* 1993520 */     GIR_EraseRootFromParent_Done,
     /* 1993521 */   // Label 26688: @1993521
     /* 1993521 */   GIM_Try, /*On fail goto*//*Label 26689*/ GIMT_Encode4(1993607), // Rule ID 61954 //
     /* 1993526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1993537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1993540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1993543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993572 */     // MIs[0] policy
     /* 1993572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993582 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1993585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993606 */     // GIR_Coverage, 61954,
     /* 1993606 */     GIR_EraseRootFromParent_Done,
     /* 1993607 */   // Label 26689: @1993607
     /* 1993607 */   GIM_Try, /*On fail goto*//*Label 26690*/ GIMT_Encode4(1993693), // Rule ID 61955 //
     /* 1993612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1993623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1993626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1993629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993658 */     // MIs[0] policy
     /* 1993658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993668 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1993671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993692 */     // GIR_Coverage, 61955,
     /* 1993692 */     GIR_EraseRootFromParent_Done,
     /* 1993693 */   // Label 26690: @1993693
     /* 1993693 */   GIM_Try, /*On fail goto*//*Label 26691*/ GIMT_Encode4(1993779), // Rule ID 61958 //
     /* 1993698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1993709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1993712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1993715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993744 */     // MIs[0] policy
     /* 1993744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993754 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1993757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993778 */     // GIR_Coverage, 61958,
     /* 1993778 */     GIR_EraseRootFromParent_Done,
     /* 1993779 */   // Label 26691: @1993779
     /* 1993779 */   GIM_Try, /*On fail goto*//*Label 26692*/ GIMT_Encode4(1993865), // Rule ID 61959 //
     /* 1993784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1993795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1993798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1993801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993830 */     // MIs[0] policy
     /* 1993830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993840 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1993843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993864 */     // GIR_Coverage, 61959,
     /* 1993864 */     GIR_EraseRootFromParent_Done,
     /* 1993865 */   // Label 26692: @1993865
     /* 1993865 */   GIM_Try, /*On fail goto*//*Label 26693*/ GIMT_Encode4(1993951), // Rule ID 61962 //
     /* 1993870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1993873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1993881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1993884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1993887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1993890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1993893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1993900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993916 */     // MIs[0] policy
     /* 1993916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993926 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1993929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1993933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1993947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993950 */     // GIR_Coverage, 61962,
     /* 1993950 */     GIR_EraseRootFromParent_Done,
     /* 1993951 */   // Label 26693: @1993951
     /* 1993951 */   GIM_Try, /*On fail goto*//*Label 26694*/ GIMT_Encode4(1994037), // Rule ID 61963 //
     /* 1993956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1993959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1993964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1993967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1993970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1993973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1993976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1993979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1993986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994002 */     // MIs[0] policy
     /* 1994002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1994033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994036 */     // GIR_Coverage, 61963,
     /* 1994036 */     GIR_EraseRootFromParent_Done,
     /* 1994037 */   // Label 26694: @1994037
     /* 1994037 */   GIM_Try, /*On fail goto*//*Label 26695*/ GIMT_Encode4(1994123), // Rule ID 61966 //
     /* 1994042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994088 */     // MIs[0] policy
     /* 1994088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994098 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994122 */     // GIR_Coverage, 61966,
     /* 1994122 */     GIR_EraseRootFromParent_Done,
     /* 1994123 */   // Label 26695: @1994123
     /* 1994123 */   GIM_Try, /*On fail goto*//*Label 26696*/ GIMT_Encode4(1994209), // Rule ID 61967 //
     /* 1994128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1994139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1994142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1994145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994174 */     // MIs[0] policy
     /* 1994174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994208 */     // GIR_Coverage, 61967,
     /* 1994208 */     GIR_EraseRootFromParent_Done,
     /* 1994209 */   // Label 26696: @1994209
     /* 1994209 */   GIM_Try, /*On fail goto*//*Label 26697*/ GIMT_Encode4(1994295), // Rule ID 61970 //
     /* 1994214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994260 */     // MIs[0] policy
     /* 1994260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994270 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994294 */     // GIR_Coverage, 61970,
     /* 1994294 */     GIR_EraseRootFromParent_Done,
     /* 1994295 */   // Label 26697: @1994295
     /* 1994295 */   GIM_Try, /*On fail goto*//*Label 26698*/ GIMT_Encode4(1994381), // Rule ID 61971 //
     /* 1994300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1994311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1994314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1994317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994346 */     // MIs[0] policy
     /* 1994346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994356 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994380 */     // GIR_Coverage, 61971,
     /* 1994380 */     GIR_EraseRootFromParent_Done,
     /* 1994381 */   // Label 26698: @1994381
     /* 1994381 */   GIM_Try, /*On fail goto*//*Label 26699*/ GIMT_Encode4(1994467), // Rule ID 61974 //
     /* 1994386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994432 */     // MIs[0] policy
     /* 1994432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994442 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994466 */     // GIR_Coverage, 61974,
     /* 1994466 */     GIR_EraseRootFromParent_Done,
     /* 1994467 */   // Label 26699: @1994467
     /* 1994467 */   GIM_Try, /*On fail goto*//*Label 26700*/ GIMT_Encode4(1994553), // Rule ID 61975 //
     /* 1994472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1994483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1994486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1994489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994518 */     // MIs[0] policy
     /* 1994518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994528 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1994549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994552 */     // GIR_Coverage, 61975,
     /* 1994552 */     GIR_EraseRootFromParent_Done,
     /* 1994553 */   // Label 26700: @1994553
     /* 1994553 */   GIM_Try, /*On fail goto*//*Label 26701*/ GIMT_Encode4(1994639), // Rule ID 61978 //
     /* 1994558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1994575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994604 */     // MIs[0] policy
     /* 1994604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994614 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994638 */     // GIR_Coverage, 61978,
     /* 1994638 */     GIR_EraseRootFromParent_Done,
     /* 1994639 */   // Label 26701: @1994639
     /* 1994639 */   GIM_Try, /*On fail goto*//*Label 26702*/ GIMT_Encode4(1994725), // Rule ID 61979 //
     /* 1994644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1994661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994690 */     // MIs[0] policy
     /* 1994690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1994703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994724 */     // GIR_Coverage, 61979,
     /* 1994724 */     GIR_EraseRootFromParent_Done,
     /* 1994725 */   // Label 26702: @1994725
     /* 1994725 */   GIM_Try, /*On fail goto*//*Label 26703*/ GIMT_Encode4(1994811), // Rule ID 61982 //
     /* 1994730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1994747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994776 */     // MIs[0] policy
     /* 1994776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994810 */     // GIR_Coverage, 61982,
     /* 1994810 */     GIR_EraseRootFromParent_Done,
     /* 1994811 */   // Label 26703: @1994811
     /* 1994811 */   GIM_Try, /*On fail goto*//*Label 26704*/ GIMT_Encode4(1994897), // Rule ID 61983 //
     /* 1994816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1994833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1994836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994862 */     // MIs[0] policy
     /* 1994862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1994875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994896 */     // GIR_Coverage, 61983,
     /* 1994896 */     GIR_EraseRootFromParent_Done,
     /* 1994897 */   // Label 26704: @1994897
     /* 1994897 */   GIM_Try, /*On fail goto*//*Label 26705*/ GIMT_Encode4(1994983), // Rule ID 61986 //
     /* 1994902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1994905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1994919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1994922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994948 */     // MIs[0] policy
     /* 1994948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1994961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1994965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994982 */     // GIR_Coverage, 61986,
     /* 1994982 */     GIR_EraseRootFromParent_Done,
     /* 1994983 */   // Label 26705: @1994983
     /* 1994983 */   GIM_Try, /*On fail goto*//*Label 26706*/ GIMT_Encode4(1995069), // Rule ID 61987 //
     /* 1994988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1994991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1994996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1995002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1995005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995034 */     // MIs[0] policy
     /* 1995034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995068 */     // GIR_Coverage, 61987,
     /* 1995068 */     GIR_EraseRootFromParent_Done,
     /* 1995069 */   // Label 26706: @1995069
     /* 1995069 */   GIM_Try, /*On fail goto*//*Label 26707*/ GIMT_Encode4(1995155), // Rule ID 61990 //
     /* 1995074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995120 */     // MIs[0] policy
     /* 1995120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995154 */     // GIR_Coverage, 61990,
     /* 1995154 */     GIR_EraseRootFromParent_Done,
     /* 1995155 */   // Label 26707: @1995155
     /* 1995155 */   GIM_Try, /*On fail goto*//*Label 26708*/ GIMT_Encode4(1995241), // Rule ID 61991 //
     /* 1995160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1995171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1995174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1995177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995206 */     // MIs[0] policy
     /* 1995206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995216 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11528:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1995219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995240 */     // GIR_Coverage, 61991,
     /* 1995240 */     GIR_EraseRootFromParent_Done,
     /* 1995241 */   // Label 26708: @1995241
     /* 1995241 */   GIM_Try, /*On fail goto*//*Label 26709*/ GIMT_Encode4(1995327), // Rule ID 61994 //
     /* 1995246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995292 */     // MIs[0] policy
     /* 1995292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995326 */     // GIR_Coverage, 61994,
     /* 1995326 */     GIR_EraseRootFromParent_Done,
     /* 1995327 */   // Label 26709: @1995327
     /* 1995327 */   GIM_Try, /*On fail goto*//*Label 26710*/ GIMT_Encode4(1995413), // Rule ID 61995 //
     /* 1995332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1995343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1995346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1995349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1995362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1995370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995378 */     // MIs[0] policy
     /* 1995378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995388 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11528:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1995391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995412 */     // GIR_Coverage, 61995,
     /* 1995412 */     GIR_EraseRootFromParent_Done,
     /* 1995413 */   // Label 26710: @1995413
     /* 1995413 */   GIM_Try, /*On fail goto*//*Label 26711*/ GIMT_Encode4(1995499), // Rule ID 61998 //
     /* 1995418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1995421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1995438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995464 */     // MIs[0] policy
     /* 1995464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995474 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995498 */     // GIR_Coverage, 61998,
     /* 1995498 */     GIR_EraseRootFromParent_Done,
     /* 1995499 */   // Label 26711: @1995499
     /* 1995499 */   GIM_Try, /*On fail goto*//*Label 26712*/ GIMT_Encode4(1995585), // Rule ID 61999 //
     /* 1995504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1995507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1995512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1995515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1995518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1995521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1995524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1995534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1995542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1995546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995550 */     // MIs[0] policy
     /* 1995550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11528:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1995563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1995567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995584 */     // GIR_Coverage, 61999,
     /* 1995584 */     GIR_EraseRootFromParent_Done,
     /* 1995585 */   // Label 26712: @1995585
     /* 1995585 */   GIM_Try, /*On fail goto*//*Label 26713*/ GIMT_Encode4(1995671), // Rule ID 62604 //
     /* 1995590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1995601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1995604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1995607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1995610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995636 */     // MIs[0] policy
     /* 1995636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995646 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1995649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995670 */     // GIR_Coverage, 62604,
     /* 1995670 */     GIR_EraseRootFromParent_Done,
     /* 1995671 */   // Label 26713: @1995671
     /* 1995671 */   GIM_Try, /*On fail goto*//*Label 26714*/ GIMT_Encode4(1995757), // Rule ID 62605 //
     /* 1995676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1995679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1995687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1995690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1995693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1995696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995722 */     // MIs[0] policy
     /* 1995722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1995735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995756 */     // GIR_Coverage, 62605,
     /* 1995756 */     GIR_EraseRootFromParent_Done,
     /* 1995757 */   // Label 26714: @1995757
     /* 1995757 */   GIM_Try, /*On fail goto*//*Label 26715*/ GIMT_Encode4(1995843), // Rule ID 62608 //
     /* 1995762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1995779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1995782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995808 */     // MIs[0] policy
     /* 1995808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1995821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995842 */     // GIR_Coverage, 62608,
     /* 1995842 */     GIR_EraseRootFromParent_Done,
     /* 1995843 */   // Label 26715: @1995843
     /* 1995843 */   GIM_Try, /*On fail goto*//*Label 26716*/ GIMT_Encode4(1995929), // Rule ID 62609 //
     /* 1995848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1995851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1995865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1995868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1995871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1995874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995894 */     // MIs[0] policy
     /* 1995894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1995904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1995907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995928 */     // GIR_Coverage, 62609,
     /* 1995928 */     GIR_EraseRootFromParent_Done,
     /* 1995929 */   // Label 26716: @1995929
     /* 1995929 */   GIM_Try, /*On fail goto*//*Label 26717*/ GIMT_Encode4(1996015), // Rule ID 62612 //
     /* 1995934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1995937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1995942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1995945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1995948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1995951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1995954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1995957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1995960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1995964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1995976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995980 */     // MIs[0] policy
     /* 1995980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1995983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1995990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1995993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996014 */     // GIR_Coverage, 62612,
     /* 1996014 */     GIR_EraseRootFromParent_Done,
     /* 1996015 */   // Label 26717: @1996015
     /* 1996015 */   GIM_Try, /*On fail goto*//*Label 26718*/ GIMT_Encode4(1996101), // Rule ID 62613 //
     /* 1996020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1996037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996066 */     // MIs[0] policy
     /* 1996066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1996079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996100 */     // GIR_Coverage, 62613,
     /* 1996100 */     GIR_EraseRootFromParent_Done,
     /* 1996101 */   // Label 26718: @1996101
     /* 1996101 */   GIM_Try, /*On fail goto*//*Label 26719*/ GIMT_Encode4(1996187), // Rule ID 62616 //
     /* 1996106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1996123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996152 */     // MIs[0] policy
     /* 1996152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996162 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 1996165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996186 */     // GIR_Coverage, 62616,
     /* 1996186 */     GIR_EraseRootFromParent_Done,
     /* 1996187 */   // Label 26719: @1996187
     /* 1996187 */   GIM_Try, /*On fail goto*//*Label 26720*/ GIMT_Encode4(1996273), // Rule ID 62617 //
     /* 1996192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1996209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996238 */     // MIs[0] policy
     /* 1996238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 1996251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996272 */     // GIR_Coverage, 62617,
     /* 1996272 */     GIR_EraseRootFromParent_Done,
     /* 1996273 */   // Label 26720: @1996273
     /* 1996273 */   GIM_Try, /*On fail goto*//*Label 26721*/ GIMT_Encode4(1996359), // Rule ID 62620 //
     /* 1996278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1996295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996324 */     // MIs[0] policy
     /* 1996324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 1996337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996358 */     // GIR_Coverage, 62620,
     /* 1996358 */     GIR_EraseRootFromParent_Done,
     /* 1996359 */   // Label 26721: @1996359
     /* 1996359 */   GIM_Try, /*On fail goto*//*Label 26722*/ GIMT_Encode4(1996445), // Rule ID 62621 //
     /* 1996364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1996375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1996378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1996381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1996384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1996387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1996394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996410 */     // MIs[0] policy
     /* 1996410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 1996423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996444 */     // GIR_Coverage, 62621,
     /* 1996444 */     GIR_EraseRootFromParent_Done,
     /* 1996445 */   // Label 26722: @1996445
     /* 1996445 */   GIM_Try, /*On fail goto*//*Label 26723*/ GIMT_Encode4(1996531), // Rule ID 62624 //
     /* 1996450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996496 */     // MIs[0] policy
     /* 1996496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 1996509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996530 */     // GIR_Coverage, 62624,
     /* 1996530 */     GIR_EraseRootFromParent_Done,
     /* 1996531 */   // Label 26723: @1996531
     /* 1996531 */   GIM_Try, /*On fail goto*//*Label 26724*/ GIMT_Encode4(1996617), // Rule ID 62625 //
     /* 1996536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1996547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1996550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1996556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996582 */     // MIs[0] policy
     /* 1996582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996592 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 1996595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996616 */     // GIR_Coverage, 62625,
     /* 1996616 */     GIR_EraseRootFromParent_Done,
     /* 1996617 */   // Label 26724: @1996617
     /* 1996617 */   GIM_Try, /*On fail goto*//*Label 26725*/ GIMT_Encode4(1996703), // Rule ID 62628 //
     /* 1996622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996668 */     // MIs[0] policy
     /* 1996668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 1996681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996702 */     // GIR_Coverage, 62628,
     /* 1996702 */     GIR_EraseRootFromParent_Done,
     /* 1996703 */   // Label 26725: @1996703
     /* 1996703 */   GIM_Try, /*On fail goto*//*Label 26726*/ GIMT_Encode4(1996789), // Rule ID 62629 //
     /* 1996708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1996728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996754 */     // MIs[0] policy
     /* 1996754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 1996767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996788 */     // GIR_Coverage, 62629,
     /* 1996788 */     GIR_EraseRootFromParent_Done,
     /* 1996789 */   // Label 26726: @1996789
     /* 1996789 */   GIM_Try, /*On fail goto*//*Label 26727*/ GIMT_Encode4(1996875), // Rule ID 62632 //
     /* 1996794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996840 */     // MIs[0] policy
     /* 1996840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1996850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 1996853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996874 */     // GIR_Coverage, 62632,
     /* 1996874 */     GIR_EraseRootFromParent_Done,
     /* 1996875 */   // Label 26727: @1996875
     /* 1996875 */   GIM_Try, /*On fail goto*//*Label 26728*/ GIMT_Encode4(1996961), // Rule ID 62633 //
     /* 1996880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1996883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1996891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1996894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1996897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1996900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1996906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1996910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1996918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996926 */     // MIs[0] policy
     /* 1996926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1996929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996936 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1996936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 1996939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1996959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996960 */     // GIR_Coverage, 62633,
     /* 1996960 */     GIR_EraseRootFromParent_Done,
     /* 1996961 */   // Label 26728: @1996961
     /* 1996961 */   GIM_Try, /*On fail goto*//*Label 26729*/ GIMT_Encode4(1997047), // Rule ID 62636 //
     /* 1996966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1996969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1996974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1996977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1996980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1996983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1996986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1996992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1996996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997012 */     // MIs[0] policy
     /* 1997012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 1997025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997046 */     // GIR_Coverage, 62636,
     /* 1997046 */     GIR_EraseRootFromParent_Done,
     /* 1997047 */   // Label 26729: @1997047
     /* 1997047 */   GIM_Try, /*On fail goto*//*Label 26730*/ GIMT_Encode4(1997133), // Rule ID 62637 //
     /* 1997052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997098 */     // MIs[0] policy
     /* 1997098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997108 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 1997111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997132 */     // GIR_Coverage, 62637,
     /* 1997132 */     GIR_EraseRootFromParent_Done,
     /* 1997133 */   // Label 26730: @1997133
     /* 1997133 */   GIM_Try, /*On fail goto*//*Label 26731*/ GIMT_Encode4(1997219), // Rule ID 62640 //
     /* 1997138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1997155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997184 */     // MIs[0] policy
     /* 1997184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 1997197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997218 */     // GIR_Coverage, 62640,
     /* 1997218 */     GIR_EraseRootFromParent_Done,
     /* 1997219 */   // Label 26731: @1997219
     /* 1997219 */   GIM_Try, /*On fail goto*//*Label 26732*/ GIMT_Encode4(1997305), // Rule ID 62641 //
     /* 1997224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1997232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1997235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1997238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1997241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1997244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1997247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1997254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1997262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997270 */     // MIs[0] policy
     /* 1997270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997280 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 1997283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997304 */     // GIR_Coverage, 62641,
     /* 1997304 */     GIR_EraseRootFromParent_Done,
     /* 1997305 */   // Label 26732: @1997305
     /* 1997305 */   GIM_Try, /*On fail goto*//*Label 26733*/ GIMT_Encode4(1997391), // Rule ID 62644 //
     /* 1997310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1997327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997356 */     // MIs[0] policy
     /* 1997356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 1997369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997390 */     // GIR_Coverage, 62644,
     /* 1997390 */     GIR_EraseRootFromParent_Done,
     /* 1997391 */   // Label 26733: @1997391
     /* 1997391 */   GIM_Try, /*On fail goto*//*Label 26734*/ GIMT_Encode4(1997477), // Rule ID 62645 //
     /* 1997396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1997407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1997410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1997413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1997416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997442 */     // MIs[0] policy
     /* 1997442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997452 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 1997455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997476 */     // GIR_Coverage, 62645,
     /* 1997476 */     GIR_EraseRootFromParent_Done,
     /* 1997477 */   // Label 26734: @1997477
     /* 1997477 */   GIM_Try, /*On fail goto*//*Label 26735*/ GIMT_Encode4(1997563), // Rule ID 62648 //
     /* 1997482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1997499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997528 */     // MIs[0] policy
     /* 1997528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997538 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 1997541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997562 */     // GIR_Coverage, 62648,
     /* 1997562 */     GIR_EraseRootFromParent_Done,
     /* 1997563 */   // Label 26735: @1997563
     /* 1997563 */   GIM_Try, /*On fail goto*//*Label 26736*/ GIMT_Encode4(1997649), // Rule ID 62649 //
     /* 1997568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1997585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1997588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997614 */     // MIs[0] policy
     /* 1997614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 1997627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997648 */     // GIR_Coverage, 62649,
     /* 1997648 */     GIR_EraseRootFromParent_Done,
     /* 1997649 */   // Label 26736: @1997649
     /* 1997649 */   GIM_Try, /*On fail goto*//*Label 26737*/ GIMT_Encode4(1997735), // Rule ID 62652 //
     /* 1997654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1997671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997700 */     // MIs[0] policy
     /* 1997700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 1997713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997734 */     // GIR_Coverage, 62652,
     /* 1997734 */     GIR_EraseRootFromParent_Done,
     /* 1997735 */   // Label 26737: @1997735
     /* 1997735 */   GIM_Try, /*On fail goto*//*Label 26738*/ GIMT_Encode4(1997821), // Rule ID 62653 //
     /* 1997740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1997751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1997754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1997757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1997760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1997770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997786 */     // MIs[0] policy
     /* 1997786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997796 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 1997799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997820 */     // GIR_Coverage, 62653,
     /* 1997820 */     GIR_EraseRootFromParent_Done,
     /* 1997821 */   // Label 26738: @1997821
     /* 1997821 */   GIM_Try, /*On fail goto*//*Label 26739*/ GIMT_Encode4(1997907), // Rule ID 62656 //
     /* 1997826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1997829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1997843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1997852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997872 */     // MIs[0] policy
     /* 1997872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1997882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 1997885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997906 */     // GIR_Coverage, 62656,
     /* 1997906 */     GIR_EraseRootFromParent_Done,
     /* 1997907 */   // Label 26739: @1997907
     /* 1997907 */   GIM_Try, /*On fail goto*//*Label 26740*/ GIMT_Encode4(1997993), // Rule ID 62657 //
     /* 1997912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1997915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1997920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1997923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1997926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1997929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1997932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1997935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1997938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1997942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997958 */     // MIs[0] policy
     /* 1997958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1997961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997968 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1997968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 1997971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1997991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997992 */     // GIR_Coverage, 62657,
     /* 1997992 */     GIR_EraseRootFromParent_Done,
     /* 1997993 */   // Label 26740: @1997993
     /* 1997993 */   GIM_Try, /*On fail goto*//*Label 26741*/ GIMT_Encode4(1998079), // Rule ID 62660 //
     /* 1997998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1998015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998044 */     // MIs[0] policy
     /* 1998044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998054 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 1998057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998078 */     // GIR_Coverage, 62660,
     /* 1998078 */     GIR_EraseRootFromParent_Done,
     /* 1998079 */   // Label 26741: @1998079
     /* 1998079 */   GIM_Try, /*On fail goto*//*Label 26742*/ GIMT_Encode4(1998165), // Rule ID 62661 //
     /* 1998084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1998101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998130 */     // MIs[0] policy
     /* 1998130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998140 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 1998143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998164 */     // GIR_Coverage, 62661,
     /* 1998164 */     GIR_EraseRootFromParent_Done,
     /* 1998165 */   // Label 26742: @1998165
     /* 1998165 */   GIM_Try, /*On fail goto*//*Label 26743*/ GIMT_Encode4(1998251), // Rule ID 62664 //
     /* 1998170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998216 */     // MIs[0] policy
     /* 1998216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 1998229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998250 */     // GIR_Coverage, 62664,
     /* 1998250 */     GIR_EraseRootFromParent_Done,
     /* 1998251 */   // Label 26743: @1998251
     /* 1998251 */   GIM_Try, /*On fail goto*//*Label 26744*/ GIMT_Encode4(1998337), // Rule ID 62665 //
     /* 1998256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1998267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1998270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1998276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998302 */     // MIs[0] policy
     /* 1998302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998312 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 1998315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998336 */     // GIR_Coverage, 62665,
     /* 1998336 */     GIR_EraseRootFromParent_Done,
     /* 1998337 */   // Label 26744: @1998337
     /* 1998337 */   GIM_Try, /*On fail goto*//*Label 26745*/ GIMT_Encode4(1998423), // Rule ID 62668 //
     /* 1998342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998388 */     // MIs[0] policy
     /* 1998388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998398 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 1998401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998422 */     // GIR_Coverage, 62668,
     /* 1998422 */     GIR_EraseRootFromParent_Done,
     /* 1998423 */   // Label 26745: @1998423
     /* 1998423 */   GIM_Try, /*On fail goto*//*Label 26746*/ GIMT_Encode4(1998509), // Rule ID 62669 //
     /* 1998428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1998448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998474 */     // MIs[0] policy
     /* 1998474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 1998487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998508 */     // GIR_Coverage, 62669,
     /* 1998508 */     GIR_EraseRootFromParent_Done,
     /* 1998509 */   // Label 26746: @1998509
     /* 1998509 */   GIM_Try, /*On fail goto*//*Label 26747*/ GIMT_Encode4(1998595), // Rule ID 62672 //
     /* 1998514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998560 */     // MIs[0] policy
     /* 1998560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 1998573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998594 */     // GIR_Coverage, 62672,
     /* 1998594 */     GIR_EraseRootFromParent_Done,
     /* 1998595 */   // Label 26747: @1998595
     /* 1998595 */   GIM_Try, /*On fail goto*//*Label 26748*/ GIMT_Encode4(1998681), // Rule ID 62673 //
     /* 1998600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1998611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1998614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1998620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1998630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998646 */     // MIs[0] policy
     /* 1998646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998656 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 1998659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998680 */     // GIR_Coverage, 62673,
     /* 1998680 */     GIR_EraseRootFromParent_Done,
     /* 1998681 */   // Label 26748: @1998681
     /* 1998681 */   GIM_Try, /*On fail goto*//*Label 26749*/ GIMT_Encode4(1998767), // Rule ID 62676 //
     /* 1998686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998732 */     // MIs[0] policy
     /* 1998732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 1998745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998766 */     // GIR_Coverage, 62676,
     /* 1998766 */     GIR_EraseRootFromParent_Done,
     /* 1998767 */   // Label 26749: @1998767
     /* 1998767 */   GIM_Try, /*On fail goto*//*Label 26750*/ GIMT_Encode4(1998853), // Rule ID 62677 //
     /* 1998772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1998783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1998786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1998792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1998795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1998802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998818 */     // MIs[0] policy
     /* 1998818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998828 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1998828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 1998831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998852 */     // GIR_Coverage, 62677,
     /* 1998852 */     GIR_EraseRootFromParent_Done,
     /* 1998853 */   // Label 26750: @1998853
     /* 1998853 */   GIM_Try, /*On fail goto*//*Label 26751*/ GIMT_Encode4(1998939), // Rule ID 62680 //
     /* 1998858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1998861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1998875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1998884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998904 */     // MIs[0] policy
     /* 1998904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1998914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 1998917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1998937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998938 */     // GIR_Coverage, 62680,
     /* 1998938 */     GIR_EraseRootFromParent_Done,
     /* 1998939 */   // Label 26751: @1998939
     /* 1998939 */   GIM_Try, /*On fail goto*//*Label 26752*/ GIMT_Encode4(1999025), // Rule ID 62681 //
     /* 1998944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1998947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1998952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1998955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1998958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1998961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1998964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1998967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1998970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1998974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1998982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1998986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998990 */     // MIs[0] policy
     /* 1998990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1998993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 1999003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999024 */     // GIR_Coverage, 62681,
     /* 1999024 */     GIR_EraseRootFromParent_Done,
     /* 1999025 */   // Label 26752: @1999025
     /* 1999025 */   GIM_Try, /*On fail goto*//*Label 26753*/ GIMT_Encode4(1999111), // Rule ID 62684 //
     /* 1999030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999076 */     // MIs[0] policy
     /* 1999076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 1999089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999110 */     // GIR_Coverage, 62684,
     /* 1999110 */     GIR_EraseRootFromParent_Done,
     /* 1999111 */   // Label 26753: @1999111
     /* 1999111 */   GIM_Try, /*On fail goto*//*Label 26754*/ GIMT_Encode4(1999197), // Rule ID 62685 //
     /* 1999116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1999133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999162 */     // MIs[0] policy
     /* 1999162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999172 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 1999175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999196 */     // GIR_Coverage, 62685,
     /* 1999196 */     GIR_EraseRootFromParent_Done,
     /* 1999197 */   // Label 26754: @1999197
     /* 1999197 */   GIM_Try, /*On fail goto*//*Label 26755*/ GIMT_Encode4(1999283), // Rule ID 62688 //
     /* 1999202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999248 */     // MIs[0] policy
     /* 1999248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 1999261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999282 */     // GIR_Coverage, 62688,
     /* 1999282 */     GIR_EraseRootFromParent_Done,
     /* 1999283 */   // Label 26755: @1999283
     /* 1999283 */   GIM_Try, /*On fail goto*//*Label 26756*/ GIMT_Encode4(1999369), // Rule ID 62689 //
     /* 1999288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1999305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1999308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999334 */     // MIs[0] policy
     /* 1999334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 1999347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999368 */     // GIR_Coverage, 62689,
     /* 1999368 */     GIR_EraseRootFromParent_Done,
     /* 1999369 */   // Label 26756: @1999369
     /* 1999369 */   GIM_Try, /*On fail goto*//*Label 26757*/ GIMT_Encode4(1999455), // Rule ID 62692 //
     /* 1999374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999420 */     // MIs[0] policy
     /* 1999420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 1999433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999454 */     // GIR_Coverage, 62692,
     /* 1999454 */     GIR_EraseRootFromParent_Done,
     /* 1999455 */   // Label 26757: @1999455
     /* 1999455 */   GIM_Try, /*On fail goto*//*Label 26758*/ GIMT_Encode4(1999541), // Rule ID 62693 //
     /* 1999460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1999471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1999474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1999477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1999480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1999490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999506 */     // MIs[0] policy
     /* 1999506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 1999519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999540 */     // GIR_Coverage, 62693,
     /* 1999540 */     GIR_EraseRootFromParent_Done,
     /* 1999541 */   // Label 26758: @1999541
     /* 1999541 */   GIM_Try, /*On fail goto*//*Label 26759*/ GIMT_Encode4(1999627), // Rule ID 62696 //
     /* 1999546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1999563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999592 */     // MIs[0] policy
     /* 1999592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 1999605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999626 */     // GIR_Coverage, 62696,
     /* 1999626 */     GIR_EraseRootFromParent_Done,
     /* 1999627 */   // Label 26759: @1999627
     /* 1999627 */   GIM_Try, /*On fail goto*//*Label 26760*/ GIMT_Encode4(1999713), // Rule ID 62697 //
     /* 1999632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1999643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1999646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1999649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1999652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1999662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999678 */     // MIs[0] policy
     /* 1999678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999688 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 1999691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999712 */     // GIR_Coverage, 62697,
     /* 1999712 */     GIR_EraseRootFromParent_Done,
     /* 1999713 */   // Label 26760: @1999713
     /* 1999713 */   GIM_Try, /*On fail goto*//*Label 26761*/ GIMT_Encode4(1999799), // Rule ID 62700 //
     /* 1999718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1999735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999764 */     // MIs[0] policy
     /* 1999764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 1999777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999798 */     // GIR_Coverage, 62700,
     /* 1999798 */     GIR_EraseRootFromParent_Done,
     /* 1999799 */   // Label 26761: @1999799
     /* 1999799 */   GIM_Try, /*On fail goto*//*Label 26762*/ GIMT_Encode4(1999885), // Rule ID 62701 //
     /* 1999804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1999815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1999818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1999821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1999824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1999827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1999830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1999834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999850 */     // MIs[0] policy
     /* 1999850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999860 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1999860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 1999863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999884 */     // GIR_Coverage, 62701,
     /* 1999884 */     GIR_EraseRootFromParent_Done,
     /* 1999885 */   // Label 26762: @1999885
     /* 1999885 */   GIM_Try, /*On fail goto*//*Label 26763*/ GIMT_Encode4(1999971), // Rule ID 62704 //
     /* 1999890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1999893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1999907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1999916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1999928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999936 */     // MIs[0] policy
     /* 1999936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1999939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1999946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 1999949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1999969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999970 */     // GIR_Coverage, 62704,
     /* 1999970 */     GIR_EraseRootFromParent_Done,
     /* 1999971 */   // Label 26763: @1999971
     /* 1999971 */   GIM_Try, /*On fail goto*//*Label 26764*/ GIMT_Encode4(2000057), // Rule ID 62705 //
     /* 1999976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1999979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1999984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1999987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1999990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1999993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1999996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000022 */     // MIs[0] policy
     /* 2000022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000032 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 2000035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000056 */     // GIR_Coverage, 62705,
     /* 2000056 */     GIR_EraseRootFromParent_Done,
     /* 2000057 */   // Label 26764: @2000057
     /* 2000057 */   GIM_Try, /*On fail goto*//*Label 26765*/ GIMT_Encode4(2000143), // Rule ID 62708 //
     /* 2000062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000108 */     // MIs[0] policy
     /* 2000108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 2000121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000142 */     // GIR_Coverage, 62708,
     /* 2000142 */     GIR_EraseRootFromParent_Done,
     /* 2000143 */   // Label 26765: @2000143
     /* 2000143 */   GIM_Try, /*On fail goto*//*Label 26766*/ GIMT_Encode4(2000229), // Rule ID 62709 //
     /* 2000148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000194 */     // MIs[0] policy
     /* 2000194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 2000207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000228 */     // GIR_Coverage, 62709,
     /* 2000228 */     GIR_EraseRootFromParent_Done,
     /* 2000229 */   // Label 26766: @2000229
     /* 2000229 */   GIM_Try, /*On fail goto*//*Label 26767*/ GIMT_Encode4(2000315), // Rule ID 62712 //
     /* 2000234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000280 */     // MIs[0] policy
     /* 2000280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 2000293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000314 */     // GIR_Coverage, 62712,
     /* 2000314 */     GIR_EraseRootFromParent_Done,
     /* 2000315 */   // Label 26767: @2000315
     /* 2000315 */   GIM_Try, /*On fail goto*//*Label 26768*/ GIMT_Encode4(2000401), // Rule ID 62713 //
     /* 2000320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2000331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2000334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2000340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2000343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2000350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2000362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000366 */     // MIs[0] policy
     /* 2000366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 2000379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000400 */     // GIR_Coverage, 62713,
     /* 2000400 */     GIR_EraseRootFromParent_Done,
     /* 2000401 */   // Label 26768: @2000401
     /* 2000401 */   GIM_Try, /*On fail goto*//*Label 26769*/ GIMT_Encode4(2000487), // Rule ID 62716 //
     /* 2000406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000452 */     // MIs[0] policy
     /* 2000452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000462 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 2000465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000486 */     // GIR_Coverage, 62716,
     /* 2000486 */     GIR_EraseRootFromParent_Done,
     /* 2000487 */   // Label 26769: @2000487
     /* 2000487 */   GIM_Try, /*On fail goto*//*Label 26770*/ GIMT_Encode4(2000573), // Rule ID 62717 //
     /* 2000492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2000503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2000506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2000512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2000515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2000522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000538 */     // MIs[0] policy
     /* 2000538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000548 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 2000551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000572 */     // GIR_Coverage, 62717,
     /* 2000572 */     GIR_EraseRootFromParent_Done,
     /* 2000573 */   // Label 26770: @2000573
     /* 2000573 */   GIM_Try, /*On fail goto*//*Label 26771*/ GIMT_Encode4(2000659), // Rule ID 62720 //
     /* 2000578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000624 */     // MIs[0] policy
     /* 2000624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 2000637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000658 */     // GIR_Coverage, 62720,
     /* 2000658 */     GIR_EraseRootFromParent_Done,
     /* 2000659 */   // Label 26771: @2000659
     /* 2000659 */   GIM_Try, /*On fail goto*//*Label 26772*/ GIMT_Encode4(2000745), // Rule ID 62721 //
     /* 2000664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 2000672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2000675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2000678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2000684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2000687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2000694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000710 */     // MIs[0] policy
     /* 2000710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000720 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 2000723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000744 */     // GIR_Coverage, 62721,
     /* 2000744 */     GIR_EraseRootFromParent_Done,
     /* 2000745 */   // Label 26772: @2000745
     /* 2000745 */   GIM_Try, /*On fail goto*//*Label 26773*/ GIMT_Encode4(2000831), // Rule ID 62724 //
     /* 2000750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2000758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000796 */     // MIs[0] policy
     /* 2000796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000806 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 2000809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000830 */     // GIR_Coverage, 62724,
     /* 2000830 */     GIR_EraseRootFromParent_Done,
     /* 2000831 */   // Label 26773: @2000831
     /* 2000831 */   GIM_Try, /*On fail goto*//*Label 26774*/ GIMT_Encode4(2000917), // Rule ID 62725 //
     /* 2000836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2000839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2000844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2000847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2000850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2000853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2000856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2000862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000882 */     // MIs[0] policy
     /* 2000882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000892 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2000892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 2000895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2000915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000916 */     // GIR_Coverage, 62725,
     /* 2000916 */     GIR_EraseRootFromParent_Done,
     /* 2000917 */   // Label 26774: @2000917
     /* 2000917 */   GIM_Try, /*On fail goto*//*Label 26775*/ GIMT_Encode4(2001003), // Rule ID 62728 //
     /* 2000922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2000925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2000930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2000939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2000942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2000948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2000960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000968 */     // MIs[0] policy
     /* 2000968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2000971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2000978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 2000981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001002 */     // GIR_Coverage, 62728,
     /* 2001002 */     GIR_EraseRootFromParent_Done,
     /* 2001003 */   // Label 26775: @2001003
     /* 2001003 */   GIM_Try, /*On fail goto*//*Label 26776*/ GIMT_Encode4(2001089), // Rule ID 62729 //
     /* 2001008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001054 */     // MIs[0] policy
     /* 2001054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001064 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 2001067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001088 */     // GIR_Coverage, 62729,
     /* 2001088 */     GIR_EraseRootFromParent_Done,
     /* 2001089 */   // Label 26776: @2001089
     /* 2001089 */   GIM_Try, /*On fail goto*//*Label 26777*/ GIMT_Encode4(2001175), // Rule ID 62732 //
     /* 2001094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001140 */     // MIs[0] policy
     /* 2001140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 2001153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001174 */     // GIR_Coverage, 62732,
     /* 2001174 */     GIR_EraseRootFromParent_Done,
     /* 2001175 */   // Label 26777: @2001175
     /* 2001175 */   GIM_Try, /*On fail goto*//*Label 26778*/ GIMT_Encode4(2001261), // Rule ID 62733 //
     /* 2001180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001226 */     // MIs[0] policy
     /* 2001226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11134:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 2001239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001260 */     // GIR_Coverage, 62733,
     /* 2001260 */     GIR_EraseRootFromParent_Done,
     /* 2001261 */   // Label 26778: @2001261
     /* 2001261 */   GIM_Try, /*On fail goto*//*Label 26779*/ GIMT_Encode4(2001347), // Rule ID 62736 //
     /* 2001266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001312 */     // MIs[0] policy
     /* 2001312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 2001325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001346 */     // GIR_Coverage, 62736,
     /* 2001346 */     GIR_EraseRootFromParent_Done,
     /* 2001347 */   // Label 26779: @2001347
     /* 2001347 */   GIM_Try, /*On fail goto*//*Label 26780*/ GIMT_Encode4(2001433), // Rule ID 62737 //
     /* 2001352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2001363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2001366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2001372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2001382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001398 */     // MIs[0] policy
     /* 2001398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11134:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 2001411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001432 */     // GIR_Coverage, 62737,
     /* 2001432 */     GIR_EraseRootFromParent_Done,
     /* 2001433 */   // Label 26780: @2001433
     /* 2001433 */   GIM_Try, /*On fail goto*//*Label 26781*/ GIMT_Encode4(2001519), // Rule ID 62740 //
     /* 2001438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 2001441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2001455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001484 */     // MIs[0] policy
     /* 2001484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 2001497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001518 */     // GIR_Coverage, 62740,
     /* 2001518 */     GIR_EraseRootFromParent_Done,
     /* 2001519 */   // Label 26781: @2001519
     /* 2001519 */   GIM_Try, /*On fail goto*//*Label 26782*/ GIMT_Encode4(2001605), // Rule ID 62741 //
     /* 2001524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 2001527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 2001532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2001535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2001538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2001541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2001544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2001547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2001554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2001562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001570 */     // MIs[0] policy
     /* 2001570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11134:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 2001583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001604 */     // GIR_Coverage, 62741,
     /* 2001604 */     GIR_EraseRootFromParent_Done,
     /* 2001605 */   // Label 26782: @2001605
     /* 2001605 */   GIM_Try, /*On fail goto*//*Label 26783*/ GIMT_Encode4(2001691), // Rule ID 65153 //
     /* 2001610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2001613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2001627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2001633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001656 */     // MIs[0] policy
     /* 2001656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001666 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2001669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001690 */     // GIR_Coverage, 65153,
     /* 2001690 */     GIR_EraseRootFromParent_Done,
     /* 2001691 */   // Label 26783: @2001691
     /* 2001691 */   GIM_Try, /*On fail goto*//*Label 26784*/ GIMT_Encode4(2001777), // Rule ID 65154 //
     /* 2001696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2001699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2001707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2001710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2001713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2001716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2001719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001742 */     // MIs[0] policy
     /* 2001742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_MF2_MASK),
     /* 2001755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001776 */     // GIR_Coverage, 65154,
     /* 2001776 */     GIR_EraseRootFromParent_Done,
     /* 2001777 */   // Label 26784: @2001777
     /* 2001777 */   GIM_Try, /*On fail goto*//*Label 26785*/ GIMT_Encode4(2001863), // Rule ID 65157 //
     /* 2001782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2001785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2001799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001828 */     // MIs[0] policy
     /* 2001828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2001838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2001841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001862 */     // GIR_Coverage, 65157,
     /* 2001862 */     GIR_EraseRootFromParent_Done,
     /* 2001863 */   // Label 26785: @2001863
     /* 2001863 */   GIM_Try, /*On fail goto*//*Label 26786*/ GIMT_Encode4(2001949), // Rule ID 65158 //
     /* 2001868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2001871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2001885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2001888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2001894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001914 */     // MIs[0] policy
     /* 2001914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2001917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2001924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2001927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2001947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001948 */     // GIR_Coverage, 65158,
     /* 2001948 */     GIR_EraseRootFromParent_Done,
     /* 2001949 */   // Label 26786: @2001949
     /* 2001949 */   GIM_Try, /*On fail goto*//*Label 26787*/ GIMT_Encode4(2002035), // Rule ID 65161 //
     /* 2001954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2001957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2001962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2001965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2001968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2001971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2001974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2001980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2001984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002000 */     // MIs[0] policy
     /* 2002000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002010 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002034 */     // GIR_Coverage, 65161,
     /* 2002034 */     GIR_EraseRootFromParent_Done,
     /* 2002035 */   // Label 26787: @2002035
     /* 2002035 */   GIM_Try, /*On fail goto*//*Label 26788*/ GIMT_Encode4(2002121), // Rule ID 65162 //
     /* 2002040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2002051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2002054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2002057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2002060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002086 */     // MIs[0] policy
     /* 2002086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002120 */     // GIR_Coverage, 65162,
     /* 2002120 */     GIR_EraseRootFromParent_Done,
     /* 2002121 */   // Label 26788: @2002121
     /* 2002121 */   GIM_Try, /*On fail goto*//*Label 26789*/ GIMT_Encode4(2002207), // Rule ID 65165 //
     /* 2002126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2002143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002172 */     // MIs[0] policy
     /* 2002172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002182 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002206 */     // GIR_Coverage, 65165,
     /* 2002206 */     GIR_EraseRootFromParent_Done,
     /* 2002207 */   // Label 26789: @2002207
     /* 2002207 */   GIM_Try, /*On fail goto*//*Label 26790*/ GIMT_Encode4(2002293), // Rule ID 65166 //
     /* 2002212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2002223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2002226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2002229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2002232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002258 */     // MIs[0] policy
     /* 2002258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002268 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002292 */     // GIR_Coverage, 65166,
     /* 2002292 */     GIR_EraseRootFromParent_Done,
     /* 2002293 */   // Label 26790: @2002293
     /* 2002293 */   GIM_Try, /*On fail goto*//*Label 26791*/ GIMT_Encode4(2002379), // Rule ID 65169 //
     /* 2002298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2002301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2002315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002344 */     // MIs[0] policy
     /* 2002344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002354 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2002357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002378 */     // GIR_Coverage, 65169,
     /* 2002378 */     GIR_EraseRootFromParent_Done,
     /* 2002379 */   // Label 26791: @2002379
     /* 2002379 */   GIM_Try, /*On fail goto*//*Label 26792*/ GIMT_Encode4(2002465), // Rule ID 65170 //
     /* 2002384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2002387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2002395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2002398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2002401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2002404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2002414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002430 */     // MIs[0] policy
     /* 2002430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002440 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2002443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002464 */     // GIR_Coverage, 65170,
     /* 2002464 */     GIR_EraseRootFromParent_Done,
     /* 2002465 */   // Label 26792: @2002465
     /* 2002465 */   GIM_Try, /*On fail goto*//*Label 26793*/ GIMT_Encode4(2002551), // Rule ID 65173 //
     /* 2002470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2002473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002516 */     // MIs[0] policy
     /* 2002516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2002529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002550 */     // GIR_Coverage, 65173,
     /* 2002550 */     GIR_EraseRootFromParent_Done,
     /* 2002551 */   // Label 26793: @2002551
     /* 2002551 */   GIM_Try, /*On fail goto*//*Label 26794*/ GIMT_Encode4(2002637), // Rule ID 65174 //
     /* 2002556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2002559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2002576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002602 */     // MIs[0] policy
     /* 2002602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002612 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M1_MASK),
     /* 2002615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002636 */     // GIR_Coverage, 65174,
     /* 2002636 */     GIR_EraseRootFromParent_Done,
     /* 2002637 */   // Label 26794: @2002637
     /* 2002637 */   GIM_Try, /*On fail goto*//*Label 26795*/ GIMT_Encode4(2002723), // Rule ID 65177 //
     /* 2002642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2002645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2002653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2002656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2002659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2002662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002688 */     // MIs[0] policy
     /* 2002688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002722 */     // GIR_Coverage, 65177,
     /* 2002722 */     GIR_EraseRootFromParent_Done,
     /* 2002723 */   // Label 26795: @2002723
     /* 2002723 */   GIM_Try, /*On fail goto*//*Label 26796*/ GIMT_Encode4(2002809), // Rule ID 65178 //
     /* 2002728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2002731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2002739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2002742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2002745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2002748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2002758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2002770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002774 */     // MIs[0] policy
     /* 2002774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M2_MASK),
     /* 2002787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002808 */     // GIR_Coverage, 65178,
     /* 2002808 */     GIR_EraseRootFromParent_Done,
     /* 2002809 */   // Label 26796: @2002809
     /* 2002809 */   GIM_Try, /*On fail goto*//*Label 26797*/ GIMT_Encode4(2002895), // Rule ID 65181 //
     /* 2002814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2002817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2002825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2002828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2002831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2002834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2002840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002860 */     // MIs[0] policy
     /* 2002860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002870 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2002870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002894 */     // GIR_Coverage, 65181,
     /* 2002894 */     GIR_EraseRootFromParent_Done,
     /* 2002895 */   // Label 26797: @2002895
     /* 2002895 */   GIM_Try, /*On fail goto*//*Label 26798*/ GIMT_Encode4(2002981), // Rule ID 65182 //
     /* 2002900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2002903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2002911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2002914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2002917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2002920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2002926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2002930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002946 */     // MIs[0] policy
     /* 2002946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2002949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002956 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11027:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2002956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M4_MASK),
     /* 2002959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2002977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2002979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002980 */     // GIR_Coverage, 65182,
     /* 2002980 */     GIR_EraseRootFromParent_Done,
     /* 2002981 */   // Label 26798: @2002981
     /* 2002981 */   GIM_Try, /*On fail goto*//*Label 26799*/ GIMT_Encode4(2003067), // Rule ID 65185 //
     /* 2002986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2002989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2002994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2002997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2003000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003032 */     // MIs[0] policy
     /* 2003032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003042 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2003045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003066 */     // GIR_Coverage, 65185,
     /* 2003066 */     GIR_EraseRootFromParent_Done,
     /* 2003067 */   // Label 26799: @2003067
     /* 2003067 */   GIM_Try, /*On fail goto*//*Label 26800*/ GIMT_Encode4(2003153), // Rule ID 65186 //
     /* 2003072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2003075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dots_mask),
     /* 2003080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2003083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2003086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2003092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003118 */     // MIs[0] policy
     /* 2003118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003128 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11027:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTS_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTS_VV_M8_MASK),
     /* 2003131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2003149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003152 */     // GIR_Coverage, 65186,
     /* 2003152 */     GIR_EraseRootFromParent_Done,
     /* 2003153 */   // Label 26800: @2003153
     /* 2003153 */   GIM_Try, /*On fail goto*//*Label 26801*/ GIMT_Encode4(2003239), // Rule ID 65189 //
     /* 2003158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2003175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003204 */     // MIs[0] policy
     /* 2003204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2003217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003238 */     // GIR_Coverage, 65189,
     /* 2003238 */     GIR_EraseRootFromParent_Done,
     /* 2003239 */   // Label 26801: @2003239
     /* 2003239 */   GIM_Try, /*On fail goto*//*Label 26802*/ GIMT_Encode4(2003325), // Rule ID 65190 //
     /* 2003244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2003255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2003258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2003261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2003264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2003267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003290 */     // MIs[0] policy
     /* 2003290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_MF2_MASK),
     /* 2003303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003324 */     // GIR_Coverage, 65190,
     /* 2003324 */     GIR_EraseRootFromParent_Done,
     /* 2003325 */   // Label 26802: @2003325
     /* 2003325 */   GIM_Try, /*On fail goto*//*Label 26803*/ GIMT_Encode4(2003411), // Rule ID 65193 //
     /* 2003330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003376 */     // MIs[0] policy
     /* 2003376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003386 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2003389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003410 */     // GIR_Coverage, 65193,
     /* 2003410 */     GIR_EraseRootFromParent_Done,
     /* 2003411 */   // Label 26803: @2003411
     /* 2003411 */   GIM_Try, /*On fail goto*//*Label 26804*/ GIMT_Encode4(2003497), // Rule ID 65194 //
     /* 2003416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2003433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2003436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003462 */     // MIs[0] policy
     /* 2003462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003472 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11031:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2003475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003496 */     // GIR_Coverage, 65194,
     /* 2003496 */     GIR_EraseRootFromParent_Done,
     /* 2003497 */   // Label 26804: @2003497
     /* 2003497 */   GIM_Try, /*On fail goto*//*Label 26805*/ GIMT_Encode4(2003583), // Rule ID 65197 //
     /* 2003502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2003519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2003522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003548 */     // MIs[0] policy
     /* 2003548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003558 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2003561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003582 */     // GIR_Coverage, 65197,
     /* 2003582 */     GIR_EraseRootFromParent_Done,
     /* 2003583 */   // Label 26805: @2003583
     /* 2003583 */   GIM_Try, /*On fail goto*//*Label 26806*/ GIMT_Encode4(2003669), // Rule ID 65198 //
     /* 2003588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2003599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2003602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2003605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2003608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2003618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003634 */     // MIs[0] policy
     /* 2003634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2003647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003668 */     // GIR_Coverage, 65198,
     /* 2003668 */     GIR_EraseRootFromParent_Done,
     /* 2003669 */   // Label 26806: @2003669
     /* 2003669 */   GIM_Try, /*On fail goto*//*Label 26807*/ GIMT_Encode4(2003755), // Rule ID 65201 //
     /* 2003674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2003685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2003688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2003691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2003694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003720 */     // MIs[0] policy
     /* 2003720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003730 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2003733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003754 */     // GIR_Coverage, 65201,
     /* 2003754 */     GIR_EraseRootFromParent_Done,
     /* 2003755 */   // Label 26807: @2003755
     /* 2003755 */   GIM_Try, /*On fail goto*//*Label 26808*/ GIMT_Encode4(2003841), // Rule ID 65202 //
     /* 2003760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2003771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2003774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2003777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2003780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2003790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003806 */     // MIs[0] policy
     /* 2003806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2003819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003840 */     // GIR_Coverage, 65202,
     /* 2003840 */     GIR_EraseRootFromParent_Done,
     /* 2003841 */   // Label 26808: @2003841
     /* 2003841 */   GIM_Try, /*On fail goto*//*Label 26809*/ GIMT_Encode4(2003927), // Rule ID 65205 //
     /* 2003846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2003849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2003857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2003860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2003863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2003866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2003872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003892 */     // MIs[0] policy
     /* 2003892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003902 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2003902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2003905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2003925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003926 */     // GIR_Coverage, 65205,
     /* 2003926 */     GIR_EraseRootFromParent_Done,
     /* 2003927 */   // Label 26809: @2003927
     /* 2003927 */   GIM_Try, /*On fail goto*//*Label 26810*/ GIMT_Encode4(2004013), // Rule ID 65206 //
     /* 2003932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2003935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2003940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2003943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2003946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2003949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2003952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2003958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2003962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003978 */     // MIs[0] policy
     /* 2003978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2003981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2003988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2003991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004012 */     // GIR_Coverage, 65206,
     /* 2004012 */     GIR_EraseRootFromParent_Done,
     /* 2004013 */   // Label 26810: @2004013
     /* 2004013 */   GIM_Try, /*On fail goto*//*Label 26811*/ GIMT_Encode4(2004099), // Rule ID 65209 //
     /* 2004018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2004035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2004038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004064 */     // MIs[0] policy
     /* 2004064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2004077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004098 */     // GIR_Coverage, 65209,
     /* 2004098 */     GIR_EraseRootFromParent_Done,
     /* 2004099 */   // Label 26811: @2004099
     /* 2004099 */   GIM_Try, /*On fail goto*//*Label 26812*/ GIMT_Encode4(2004185), // Rule ID 65210 //
     /* 2004104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2004121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2004124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004150 */     // MIs[0] policy
     /* 2004150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004160 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11031:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M1_MASK),
     /* 2004163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004184 */     // GIR_Coverage, 65210,
     /* 2004184 */     GIR_EraseRootFromParent_Done,
     /* 2004185 */   // Label 26812: @2004185
     /* 2004185 */   GIM_Try, /*On fail goto*//*Label 26813*/ GIMT_Encode4(2004271), // Rule ID 65213 //
     /* 2004190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2004207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2004210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004236 */     // MIs[0] policy
     /* 2004236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004270 */     // GIR_Coverage, 65213,
     /* 2004270 */     GIR_EraseRootFromParent_Done,
     /* 2004271 */   // Label 26813: @2004271
     /* 2004271 */   GIM_Try, /*On fail goto*//*Label 26814*/ GIMT_Encode4(2004357), // Rule ID 65214 //
     /* 2004276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2004287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2004290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2004293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2004296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2004306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2004318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004322 */     // MIs[0] policy
     /* 2004322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11031:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M2_MASK),
     /* 2004335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004356 */     // GIR_Coverage, 65214,
     /* 2004356 */     GIR_EraseRootFromParent_Done,
     /* 2004357 */   // Label 26814: @2004357
     /* 2004357 */   GIM_Try, /*On fail goto*//*Label 26815*/ GIMT_Encode4(2004443), // Rule ID 65217 //
     /* 2004362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2004379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2004382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004408 */     // MIs[0] policy
     /* 2004408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004442 */     // GIR_Coverage, 65217,
     /* 2004442 */     GIR_EraseRootFromParent_Done,
     /* 2004443 */   // Label 26815: @2004443
     /* 2004443 */   GIM_Try, /*On fail goto*//*Label 26816*/ GIMT_Encode4(2004529), // Rule ID 65218 //
     /* 2004448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2004459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2004462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2004465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2004468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2004478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004494 */     // MIs[0] policy
     /* 2004494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004504 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11031:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M4_MASK),
     /* 2004507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004528 */     // GIR_Coverage, 65218,
     /* 2004528 */     GIR_EraseRootFromParent_Done,
     /* 2004529 */   // Label 26816: @2004529
     /* 2004529 */   GIM_Try, /*On fail goto*//*Label 26817*/ GIMT_Encode4(2004615), // Rule ID 65221 //
     /* 2004534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2004537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2004545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2004548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2004551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2004554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004580 */     // MIs[0] policy
     /* 2004580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2004593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004614 */     // GIR_Coverage, 65221,
     /* 2004614 */     GIR_EraseRootFromParent_Done,
     /* 2004615 */   // Label 26817: @2004615
     /* 2004615 */   GIM_Try, /*On fail goto*//*Label 26818*/ GIMT_Encode4(2004701), // Rule ID 65222 //
     /* 2004620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2004623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotu_mask),
     /* 2004628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2004631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2004634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2004637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2004640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2004650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004666 */     // MIs[0] policy
     /* 2004666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11031:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTU_VV_M8_MASK),
     /* 2004679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2004697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004700 */     // GIR_Coverage, 65222,
     /* 2004700 */     GIR_EraseRootFromParent_Done,
     /* 2004701 */   // Label 26818: @2004701
     /* 2004701 */   GIM_Try, /*On fail goto*//*Label 26819*/ GIMT_Encode4(2004787), // Rule ID 65225 //
     /* 2004706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2004714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2004717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2004720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2004723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2004726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004752 */     // MIs[0] policy
     /* 2004752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004762 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2004765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004786 */     // GIR_Coverage, 65225,
     /* 2004786 */     GIR_EraseRootFromParent_Done,
     /* 2004787 */   // Label 26819: @2004787
     /* 2004787 */   GIM_Try, /*On fail goto*//*Label 26820*/ GIMT_Encode4(2004873), // Rule ID 65226 //
     /* 2004792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2004800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2004803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2004806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2004809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2004812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004838 */     // MIs[0] policy
     /* 2004838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004848 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_MF2_MASK),
     /* 2004851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004872 */     // GIR_Coverage, 65226,
     /* 2004872 */     GIR_EraseRootFromParent_Done,
     /* 2004873 */   // Label 26820: @2004873
     /* 2004873 */   GIM_Try, /*On fail goto*//*Label 26821*/ GIMT_Encode4(2004959), // Rule ID 65229 //
     /* 2004878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2004886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2004895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2004898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2004904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004924 */     // MIs[0] policy
     /* 2004924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2004927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2004937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2004957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004958 */     // GIR_Coverage, 65229,
     /* 2004958 */     GIR_EraseRootFromParent_Done,
     /* 2004959 */   // Label 26821: @2004959
     /* 2004959 */   GIM_Try, /*On fail goto*//*Label 26822*/ GIMT_Encode4(2005045), // Rule ID 65230 //
     /* 2004964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2004972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2004975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2004978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2004981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2004984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2004990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005010 */     // MIs[0] policy
     /* 2005010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005044 */     // GIR_Coverage, 65230,
     /* 2005044 */     GIR_EraseRootFromParent_Done,
     /* 2005045 */   // Label 26822: @2005045
     /* 2005045 */   GIM_Try, /*On fail goto*//*Label 26823*/ GIMT_Encode4(2005131), // Rule ID 65233 //
     /* 2005050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005096 */     // MIs[0] policy
     /* 2005096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005130 */     // GIR_Coverage, 65233,
     /* 2005130 */     GIR_EraseRootFromParent_Done,
     /* 2005131 */   // Label 26823: @2005131
     /* 2005131 */   GIM_Try, /*On fail goto*//*Label 26824*/ GIMT_Encode4(2005217), // Rule ID 65234 //
     /* 2005136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2005147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2005150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2005153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2005156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005182 */     // MIs[0] policy
     /* 2005182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005216 */     // GIR_Coverage, 65234,
     /* 2005216 */     GIR_EraseRootFromParent_Done,
     /* 2005217 */   // Label 26824: @2005217
     /* 2005217 */   GIM_Try, /*On fail goto*//*Label 26825*/ GIMT_Encode4(2005303), // Rule ID 65237 //
     /* 2005222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2005239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005268 */     // MIs[0] policy
     /* 2005268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005302 */     // GIR_Coverage, 65237,
     /* 2005302 */     GIR_EraseRootFromParent_Done,
     /* 2005303 */   // Label 26825: @2005303
     /* 2005303 */   GIM_Try, /*On fail goto*//*Label 26826*/ GIMT_Encode4(2005389), // Rule ID 65238 //
     /* 2005308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2005319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2005322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2005325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2005328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005354 */     // MIs[0] policy
     /* 2005354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005388 */     // GIR_Coverage, 65238,
     /* 2005388 */     GIR_EraseRootFromParent_Done,
     /* 2005389 */   // Label 26826: @2005389
     /* 2005389 */   GIM_Try, /*On fail goto*//*Label 26827*/ GIMT_Encode4(2005475), // Rule ID 65241 //
     /* 2005394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2005411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005440 */     // MIs[0] policy
     /* 2005440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005450 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2005453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005474 */     // GIR_Coverage, 65241,
     /* 2005474 */     GIR_EraseRootFromParent_Done,
     /* 2005475 */   // Label 26827: @2005475
     /* 2005475 */   GIM_Try, /*On fail goto*//*Label 26828*/ GIMT_Encode4(2005561), // Rule ID 65242 //
     /* 2005480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2005491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2005494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2005497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2005500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2005503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2005510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2005522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005526 */     // MIs[0] policy
     /* 2005526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2005539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005560 */     // GIR_Coverage, 65242,
     /* 2005560 */     GIR_EraseRootFromParent_Done,
     /* 2005561 */   // Label 26828: @2005561
     /* 2005561 */   GIM_Try, /*On fail goto*//*Label 26829*/ GIMT_Encode4(2005647), // Rule ID 65245 //
     /* 2005566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2005569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2005586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005612 */     // MIs[0] policy
     /* 2005612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005646 */     // GIR_Coverage, 65245,
     /* 2005646 */     GIR_EraseRootFromParent_Done,
     /* 2005647 */   // Label 26829: @2005647
     /* 2005647 */   GIM_Try, /*On fail goto*//*Label 26830*/ GIMT_Encode4(2005733), // Rule ID 65246 //
     /* 2005652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2005655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2005663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2005666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2005672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005698 */     // MIs[0] policy
     /* 2005698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005708 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M1_MASK),
     /* 2005711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005732 */     // GIR_Coverage, 65246,
     /* 2005732 */     GIR_EraseRootFromParent_Done,
     /* 2005733 */   // Label 26830: @2005733
     /* 2005733 */   GIM_Try, /*On fail goto*//*Label 26831*/ GIMT_Encode4(2005819), // Rule ID 65249 //
     /* 2005738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2005741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2005749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2005752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2005755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2005758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005784 */     // MIs[0] policy
     /* 2005784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005818 */     // GIR_Coverage, 65249,
     /* 2005818 */     GIR_EraseRootFromParent_Done,
     /* 2005819 */   // Label 26831: @2005819
     /* 2005819 */   GIM_Try, /*On fail goto*//*Label 26832*/ GIMT_Encode4(2005905), // Rule ID 65250 //
     /* 2005824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2005827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2005835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2005838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2005841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2005844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2005850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2005854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2005866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005870 */     // MIs[0] policy
     /* 2005870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M2_MASK),
     /* 2005883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005904 */     // GIR_Coverage, 65250,
     /* 2005904 */     GIR_EraseRootFromParent_Done,
     /* 2005905 */   // Label 26832: @2005905
     /* 2005905 */   GIM_Try, /*On fail goto*//*Label 26833*/ GIMT_Encode4(2005991), // Rule ID 65253 //
     /* 2005910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2005913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2005918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2005921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2005924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2005927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2005930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2005936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2005940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2005952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005956 */     // MIs[0] policy
     /* 2005956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2005959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2005969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2005973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2005977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2005987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2005989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005990 */     // GIR_Coverage, 65253,
     /* 2005990 */     GIR_EraseRootFromParent_Done,
     /* 2005991 */   // Label 26833: @2005991
     /* 2005991 */   GIM_Try, /*On fail goto*//*Label 26834*/ GIMT_Encode4(2006077), // Rule ID 65254 //
     /* 2005996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2005999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2006007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2006010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2006013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2006016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006042 */     // MIs[0] policy
     /* 2006042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006052 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11029:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M4_MASK),
     /* 2006055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006076 */     // GIR_Coverage, 65254,
     /* 2006076 */     GIR_EraseRootFromParent_Done,
     /* 2006077 */   // Label 26834: @2006077
     /* 2006077 */   GIM_Try, /*On fail goto*//*Label 26835*/ GIMT_Encode4(2006163), // Rule ID 65257 //
     /* 2006082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 2006108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006128 */     // MIs[0] policy
     /* 2006128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006138 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006162 */     // GIR_Coverage, 65257,
     /* 2006162 */     GIR_EraseRootFromParent_Done,
     /* 2006163 */   // Label 26835: @2006163
     /* 2006163 */   GIM_Try, /*On fail goto*//*Label 26836*/ GIMT_Encode4(2006249), // Rule ID 65258 //
     /* 2006168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vd4dotsu_mask),
     /* 2006176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2006179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2006182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2006185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2006188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 2006194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006214 */     // MIs[0] policy
     /* 2006214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 2006217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006224 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11029:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VD4DOTSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VD4DOTSU_VV_M8_MASK),
     /* 2006227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 2006247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006248 */     // GIR_Coverage, 65258,
     /* 2006248 */     GIR_EraseRootFromParent_Done,
     /* 2006249 */   // Label 26836: @2006249
     /* 2006249 */   GIM_Try, /*On fail goto*//*Label 26837*/ GIMT_Encode4(2006338), // Rule ID 2784 //
     /* 2006254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006300 */     // MIs[0] round
     /* 2006300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006310 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2006313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006337 */     // GIR_Coverage, 2784,
     /* 2006337 */     GIR_EraseRootFromParent_Done,
     /* 2006338 */   // Label 26837: @2006338
     /* 2006338 */   GIM_Try, /*On fail goto*//*Label 26838*/ GIMT_Encode4(2006427), // Rule ID 2785 //
     /* 2006343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2006360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006389 */     // MIs[0] round
     /* 2006389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006399 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 2006402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006426 */     // GIR_Coverage, 2785,
     /* 2006426 */     GIR_EraseRootFromParent_Done,
     /* 2006427 */   // Label 26838: @2006427
     /* 2006427 */   GIM_Try, /*On fail goto*//*Label 26839*/ GIMT_Encode4(2006516), // Rule ID 22830 //
     /* 2006432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2006449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006478 */     // MIs[0] round
     /* 2006478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006488 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2006491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006515 */     // GIR_Coverage, 22830,
     /* 2006515 */     GIR_EraseRootFromParent_Done,
     /* 2006516 */   // Label 26839: @2006516
     /* 2006516 */   GIM_Try, /*On fail goto*//*Label 26840*/ GIMT_Encode4(2006605), // Rule ID 22831 //
     /* 2006521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2006538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006567 */     // MIs[0] round
     /* 2006567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006577 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 2006580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006604 */     // GIR_Coverage, 22831,
     /* 2006604 */     GIR_EraseRootFromParent_Done,
     /* 2006605 */   // Label 26840: @2006605
     /* 2006605 */   GIM_Try, /*On fail goto*//*Label 26841*/ GIMT_Encode4(2006694), // Rule ID 22834 //
     /* 2006610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2006627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006656 */     // MIs[0] round
     /* 2006656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006666 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2006669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006693 */     // GIR_Coverage, 22834,
     /* 2006693 */     GIR_EraseRootFromParent_Done,
     /* 2006694 */   // Label 26841: @2006694
     /* 2006694 */   GIM_Try, /*On fail goto*//*Label 26842*/ GIMT_Encode4(2006783), // Rule ID 22835 //
     /* 2006699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2006702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2006716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006745 */     // MIs[0] round
     /* 2006745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006755 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 2006758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006782 */     // GIR_Coverage, 22835,
     /* 2006782 */     GIR_EraseRootFromParent_Done,
     /* 2006783 */   // Label 26842: @2006783
     /* 2006783 */   GIM_Try, /*On fail goto*//*Label 26843*/ GIMT_Encode4(2006872), // Rule ID 22838 //
     /* 2006788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2006791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006834 */     // MIs[0] round
     /* 2006834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006844 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2006844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2006847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006871 */     // GIR_Coverage, 22838,
     /* 2006871 */     GIR_EraseRootFromParent_Done,
     /* 2006872 */   // Label 26843: @2006872
     /* 2006872 */   GIM_Try, /*On fail goto*//*Label 26844*/ GIMT_Encode4(2006961), // Rule ID 22839 //
     /* 2006877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2006880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2006888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2006891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2006894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2006897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2006900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006923 */     // MIs[0] round
     /* 2006923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006933 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2006933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 2006936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2006940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2006944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2006956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2006959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006960 */     // GIR_Coverage, 22839,
     /* 2006960 */     GIR_EraseRootFromParent_Done,
     /* 2006961 */   // Label 26844: @2006961
     /* 2006961 */   GIM_Try, /*On fail goto*//*Label 26845*/ GIMT_Encode4(2007050), // Rule ID 22842 //
     /* 2006966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2006969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2006974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2006983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2006986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007012 */     // MIs[0] round
     /* 2007012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007022 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2007025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007049 */     // GIR_Coverage, 22842,
     /* 2007049 */     GIR_EraseRootFromParent_Done,
     /* 2007050 */   // Label 26845: @2007050
     /* 2007050 */   GIM_Try, /*On fail goto*//*Label 26846*/ GIMT_Encode4(2007139), // Rule ID 22843 //
     /* 2007055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2007072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2007078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007101 */     // MIs[0] round
     /* 2007101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007111 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 2007114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007138 */     // GIR_Coverage, 22843,
     /* 2007138 */     GIR_EraseRootFromParent_Done,
     /* 2007139 */   // Label 26846: @2007139
     /* 2007139 */   GIM_Try, /*On fail goto*//*Label 26847*/ GIMT_Encode4(2007228), // Rule ID 22846 //
     /* 2007144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2007147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2007161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007190 */     // MIs[0] round
     /* 2007190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007200 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2007203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007227 */     // GIR_Coverage, 22846,
     /* 2007227 */     GIR_EraseRootFromParent_Done,
     /* 2007228 */   // Label 26847: @2007228
     /* 2007228 */   GIM_Try, /*On fail goto*//*Label 26848*/ GIMT_Encode4(2007317), // Rule ID 22847 //
     /* 2007233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2007236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2007244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2007247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2007250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2007253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2007256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007279 */     // MIs[0] round
     /* 2007279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007289 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 2007292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2007312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007316 */     // GIR_Coverage, 22847,
     /* 2007316 */     GIR_EraseRootFromParent_Done,
     /* 2007317 */   // Label 26848: @2007317
     /* 2007317 */   GIM_Try, /*On fail goto*//*Label 26849*/ GIMT_Encode4(2007406), // Rule ID 22850 //
     /* 2007322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007368 */     // MIs[0] round
     /* 2007368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007378 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2007381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007405 */     // GIR_Coverage, 22850,
     /* 2007405 */     GIR_EraseRootFromParent_Done,
     /* 2007406 */   // Label 26849: @2007406
     /* 2007406 */   GIM_Try, /*On fail goto*//*Label 26850*/ GIMT_Encode4(2007495), // Rule ID 22851 //
     /* 2007411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007457 */     // MIs[0] round
     /* 2007457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007467 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 2007470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007494 */     // GIR_Coverage, 22851,
     /* 2007494 */     GIR_EraseRootFromParent_Done,
     /* 2007495 */   // Label 26850: @2007495
     /* 2007495 */   GIM_Try, /*On fail goto*//*Label 26851*/ GIMT_Encode4(2007584), // Rule ID 22854 //
     /* 2007500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007546 */     // MIs[0] round
     /* 2007546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007556 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2007559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007583 */     // GIR_Coverage, 22854,
     /* 2007583 */     GIR_EraseRootFromParent_Done,
     /* 2007584 */   // Label 26851: @2007584
     /* 2007584 */   GIM_Try, /*On fail goto*//*Label 26852*/ GIMT_Encode4(2007673), // Rule ID 22855 //
     /* 2007589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007635 */     // MIs[0] round
     /* 2007635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007645 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 2007648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007672 */     // GIR_Coverage, 22855,
     /* 2007672 */     GIR_EraseRootFromParent_Done,
     /* 2007673 */   // Label 26852: @2007673
     /* 2007673 */   GIM_Try, /*On fail goto*//*Label 26853*/ GIMT_Encode4(2007762), // Rule ID 22858 //
     /* 2007678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2007681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2007695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2007701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007724 */     // MIs[0] round
     /* 2007724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007734 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2007737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007761 */     // GIR_Coverage, 22858,
     /* 2007761 */     GIR_EraseRootFromParent_Done,
     /* 2007762 */   // Label 26853: @2007762
     /* 2007762 */   GIM_Try, /*On fail goto*//*Label 26854*/ GIMT_Encode4(2007851), // Rule ID 22859 //
     /* 2007767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2007770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2007778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2007781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2007784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2007787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2007790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007813 */     // MIs[0] round
     /* 2007813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007823 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11258:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2007823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 2007826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007850 */     // GIR_Coverage, 22859,
     /* 2007850 */     GIR_EraseRootFromParent_Done,
     /* 2007851 */   // Label 26854: @2007851
     /* 2007851 */   GIM_Try, /*On fail goto*//*Label 26855*/ GIMT_Encode4(2007940), // Rule ID 22862 //
     /* 2007856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2007859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2007873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007902 */     // MIs[0] round
     /* 2007902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007912 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2007912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2007915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2007919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2007923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2007938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007939 */     // GIR_Coverage, 22862,
     /* 2007939 */     GIR_EraseRootFromParent_Done,
     /* 2007940 */   // Label 26855: @2007940
     /* 2007940 */   GIM_Try, /*On fail goto*//*Label 26856*/ GIMT_Encode4(2008029), // Rule ID 22863 //
     /* 2007945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2007948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2007953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2007956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2007959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2007962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2007965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2007975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2007987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007991 */     // MIs[0] round
     /* 2007991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008001 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 2008004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008028 */     // GIR_Coverage, 22863,
     /* 2008028 */     GIR_EraseRootFromParent_Done,
     /* 2008029 */   // Label 26856: @2008029
     /* 2008029 */   GIM_Try, /*On fail goto*//*Label 26857*/ GIMT_Encode4(2008118), // Rule ID 22866 //
     /* 2008034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008080 */     // MIs[0] round
     /* 2008080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008090 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2008093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008117 */     // GIR_Coverage, 22866,
     /* 2008117 */     GIR_EraseRootFromParent_Done,
     /* 2008118 */   // Label 26857: @2008118
     /* 2008118 */   GIM_Try, /*On fail goto*//*Label 26858*/ GIMT_Encode4(2008207), // Rule ID 22867 //
     /* 2008123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2008140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008169 */     // MIs[0] round
     /* 2008169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008179 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 2008182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008206 */     // GIR_Coverage, 22867,
     /* 2008206 */     GIR_EraseRootFromParent_Done,
     /* 2008207 */   // Label 26858: @2008207
     /* 2008207 */   GIM_Try, /*On fail goto*//*Label 26859*/ GIMT_Encode4(2008296), // Rule ID 22870 //
     /* 2008212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2008215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008258 */     // MIs[0] round
     /* 2008258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008268 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2008271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008295 */     // GIR_Coverage, 22870,
     /* 2008295 */     GIR_EraseRootFromParent_Done,
     /* 2008296 */   // Label 26859: @2008296
     /* 2008296 */   GIM_Try, /*On fail goto*//*Label 26860*/ GIMT_Encode4(2008385), // Rule ID 22871 //
     /* 2008301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2008304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2008312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2008315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2008321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008347 */     // MIs[0] round
     /* 2008347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008357 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11258:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 2008360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008384 */     // GIR_Coverage, 22871,
     /* 2008384 */     GIR_EraseRootFromParent_Done,
     /* 2008385 */   // Label 26860: @2008385
     /* 2008385 */   GIM_Try, /*On fail goto*//*Label 26861*/ GIMT_Encode4(2008474), // Rule ID 22874 //
     /* 2008390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2008393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008436 */     // MIs[0] round
     /* 2008436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008446 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2008449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008473 */     // GIR_Coverage, 22874,
     /* 2008473 */     GIR_EraseRootFromParent_Done,
     /* 2008474 */   // Label 26861: @2008474
     /* 2008474 */   GIM_Try, /*On fail goto*//*Label 26862*/ GIMT_Encode4(2008563), // Rule ID 22875 //
     /* 2008479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2008482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008525 */     // MIs[0] round
     /* 2008525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008535 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 2008538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008562 */     // GIR_Coverage, 22875,
     /* 2008562 */     GIR_EraseRootFromParent_Done,
     /* 2008563 */   // Label 26862: @2008563
     /* 2008563 */   GIM_Try, /*On fail goto*//*Label 26863*/ GIMT_Encode4(2008652), // Rule ID 22878 //
     /* 2008568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2008571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2008585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008614 */     // MIs[0] round
     /* 2008614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008624 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2008627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008651 */     // GIR_Coverage, 22878,
     /* 2008651 */     GIR_EraseRootFromParent_Done,
     /* 2008652 */   // Label 26863: @2008652
     /* 2008652 */   GIM_Try, /*On fail goto*//*Label 26864*/ GIMT_Encode4(2008741), // Rule ID 22879 //
     /* 2008657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2008660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2008674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008703 */     // MIs[0] round
     /* 2008703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008713 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 2008716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008740 */     // GIR_Coverage, 22879,
     /* 2008740 */     GIR_EraseRootFromParent_Done,
     /* 2008741 */   // Label 26864: @2008741
     /* 2008741 */   GIM_Try, /*On fail goto*//*Label 26865*/ GIMT_Encode4(2008830), // Rule ID 22882 //
     /* 2008746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2008749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2008763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008792 */     // MIs[0] round
     /* 2008792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008802 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2008805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008829 */     // GIR_Coverage, 22882,
     /* 2008829 */     GIR_EraseRootFromParent_Done,
     /* 2008830 */   // Label 26865: @2008830
     /* 2008830 */   GIM_Try, /*On fail goto*//*Label 26866*/ GIMT_Encode4(2008919), // Rule ID 22883 //
     /* 2008835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2008838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 2008843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2008846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2008849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2008852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2008855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008881 */     // MIs[0] round
     /* 2008881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008891 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11258:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2008891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 2008894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2008917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008918 */     // GIR_Coverage, 22883,
     /* 2008918 */     GIR_EraseRootFromParent_Done,
     /* 2008919 */   // Label 26866: @2008919
     /* 2008919 */   GIM_Try, /*On fail goto*//*Label 26867*/ GIMT_Encode4(2009008), // Rule ID 22886 //
     /* 2008924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2008927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2008932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2008935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2008938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2008941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2008944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008970 */     // MIs[0] round
     /* 2008970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008980 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2008980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2008983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2008987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2008991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009007 */     // GIR_Coverage, 22886,
     /* 2009007 */     GIR_EraseRootFromParent_Done,
     /* 2009008 */   // Label 26867: @2009008
     /* 2009008 */   GIM_Try, /*On fail goto*//*Label 26868*/ GIMT_Encode4(2009097), // Rule ID 22887 //
     /* 2009013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009059 */     // MIs[0] round
     /* 2009059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009069 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 2009072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009096 */     // GIR_Coverage, 22887,
     /* 2009096 */     GIR_EraseRootFromParent_Done,
     /* 2009097 */   // Label 26868: @2009097
     /* 2009097 */   GIM_Try, /*On fail goto*//*Label 26869*/ GIMT_Encode4(2009186), // Rule ID 22890 //
     /* 2009102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009148 */     // MIs[0] round
     /* 2009148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009158 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2009161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009185 */     // GIR_Coverage, 22890,
     /* 2009185 */     GIR_EraseRootFromParent_Done,
     /* 2009186 */   // Label 26869: @2009186
     /* 2009186 */   GIM_Try, /*On fail goto*//*Label 26870*/ GIMT_Encode4(2009275), // Rule ID 22891 //
     /* 2009191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009237 */     // MIs[0] round
     /* 2009237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009247 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 2009250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009274 */     // GIR_Coverage, 22891,
     /* 2009274 */     GIR_EraseRootFromParent_Done,
     /* 2009275 */   // Label 26870: @2009275
     /* 2009275 */   GIM_Try, /*On fail goto*//*Label 26871*/ GIMT_Encode4(2009364), // Rule ID 22894 //
     /* 2009280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2009283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009326 */     // MIs[0] round
     /* 2009326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009336 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2009339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009363 */     // GIR_Coverage, 22894,
     /* 2009363 */     GIR_EraseRootFromParent_Done,
     /* 2009364 */   // Label 26871: @2009364
     /* 2009364 */   GIM_Try, /*On fail goto*//*Label 26872*/ GIMT_Encode4(2009453), // Rule ID 22895 //
     /* 2009369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2009372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009415 */     // MIs[0] round
     /* 2009415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009425 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 2009428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009452 */     // GIR_Coverage, 22895,
     /* 2009452 */     GIR_EraseRootFromParent_Done,
     /* 2009453 */   // Label 26872: @2009453
     /* 2009453 */   GIM_Try, /*On fail goto*//*Label 26873*/ GIMT_Encode4(2009542), // Rule ID 22898 //
     /* 2009458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2009475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009504 */     // MIs[0] round
     /* 2009504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009514 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2009517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009541 */     // GIR_Coverage, 22898,
     /* 2009541 */     GIR_EraseRootFromParent_Done,
     /* 2009542 */   // Label 26873: @2009542
     /* 2009542 */   GIM_Try, /*On fail goto*//*Label 26874*/ GIMT_Encode4(2009631), // Rule ID 22899 //
     /* 2009547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2009550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2009558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2009561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2009564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2009567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009593 */     // MIs[0] round
     /* 2009593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009603 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 2009606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009630 */     // GIR_Coverage, 22899,
     /* 2009630 */     GIR_EraseRootFromParent_Done,
     /* 2009631 */   // Label 26874: @2009631
     /* 2009631 */   GIM_Try, /*On fail goto*//*Label 26875*/ GIMT_Encode4(2009720), // Rule ID 22902 //
     /* 2009636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2009639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2009653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009682 */     // MIs[0] round
     /* 2009682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009692 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2009695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009719 */     // GIR_Coverage, 22902,
     /* 2009719 */     GIR_EraseRootFromParent_Done,
     /* 2009720 */   // Label 26875: @2009720
     /* 2009720 */   GIM_Try, /*On fail goto*//*Label 26876*/ GIMT_Encode4(2009809), // Rule ID 22903 //
     /* 2009725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2009728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2009736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2009739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2009742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2009745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009771 */     // MIs[0] round
     /* 2009771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009781 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 2009784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009808 */     // GIR_Coverage, 22903,
     /* 2009808 */     GIR_EraseRootFromParent_Done,
     /* 2009809 */   // Label 26876: @2009809
     /* 2009809 */   GIM_Try, /*On fail goto*//*Label 26877*/ GIMT_Encode4(2009898), // Rule ID 22906 //
     /* 2009814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2009817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2009831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009860 */     // MIs[0] round
     /* 2009860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009870 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2009870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2009873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009897 */     // GIR_Coverage, 22906,
     /* 2009897 */     GIR_EraseRootFromParent_Done,
     /* 2009898 */   // Label 26877: @2009898
     /* 2009898 */   GIM_Try, /*On fail goto*//*Label 26878*/ GIMT_Encode4(2009987), // Rule ID 22907 //
     /* 2009903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2009906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2009911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2009914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2009917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2009920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2009923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009949 */     // MIs[0] round
     /* 2009949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009959 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2009959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 2009962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2009966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2009970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2009982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2009985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009986 */     // GIR_Coverage, 22907,
     /* 2009986 */     GIR_EraseRootFromParent_Done,
     /* 2009987 */   // Label 26878: @2009987
     /* 2009987 */   GIM_Try, /*On fail goto*//*Label 26879*/ GIMT_Encode4(2010076), // Rule ID 22910 //
     /* 2009992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2009995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2010009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010038 */     // MIs[0] round
     /* 2010038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010048 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2010051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010075 */     // GIR_Coverage, 22910,
     /* 2010075 */     GIR_EraseRootFromParent_Done,
     /* 2010076 */   // Label 26879: @2010076
     /* 2010076 */   GIM_Try, /*On fail goto*//*Label 26880*/ GIMT_Encode4(2010165), // Rule ID 22911 //
     /* 2010081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2010098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010127 */     // MIs[0] round
     /* 2010127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010137 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 2010140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010164 */     // GIR_Coverage, 22911,
     /* 2010164 */     GIR_EraseRootFromParent_Done,
     /* 2010165 */   // Label 26880: @2010165
     /* 2010165 */   GIM_Try, /*On fail goto*//*Label 26881*/ GIMT_Encode4(2010254), // Rule ID 22914 //
     /* 2010170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2010187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010216 */     // MIs[0] round
     /* 2010216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010226 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2010229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010253 */     // GIR_Coverage, 22914,
     /* 2010253 */     GIR_EraseRootFromParent_Done,
     /* 2010254 */   // Label 26881: @2010254
     /* 2010254 */   GIM_Try, /*On fail goto*//*Label 26882*/ GIMT_Encode4(2010343), // Rule ID 22915 //
     /* 2010259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2010276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010305 */     // MIs[0] round
     /* 2010305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010315 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 2010318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010342 */     // GIR_Coverage, 22915,
     /* 2010342 */     GIR_EraseRootFromParent_Done,
     /* 2010343 */   // Label 26882: @2010343
     /* 2010343 */   GIM_Try, /*On fail goto*//*Label 26883*/ GIMT_Encode4(2010432), // Rule ID 22918 //
     /* 2010348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2010351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2010365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2010371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010394 */     // MIs[0] round
     /* 2010394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010404 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2010407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010431 */     // GIR_Coverage, 22918,
     /* 2010431 */     GIR_EraseRootFromParent_Done,
     /* 2010432 */   // Label 26883: @2010432
     /* 2010432 */   GIM_Try, /*On fail goto*//*Label 26884*/ GIMT_Encode4(2010521), // Rule ID 22919 //
     /* 2010437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2010440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2010454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2010457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2010460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010483 */     // MIs[0] round
     /* 2010483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010493 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11260:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 2010496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010520 */     // GIR_Coverage, 22919,
     /* 2010520 */     GIR_EraseRootFromParent_Done,
     /* 2010521 */   // Label 26884: @2010521
     /* 2010521 */   GIM_Try, /*On fail goto*//*Label 26885*/ GIMT_Encode4(2010610), // Rule ID 22922 //
     /* 2010526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2010543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010572 */     // MIs[0] round
     /* 2010572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010582 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2010585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010609 */     // GIR_Coverage, 22922,
     /* 2010609 */     GIR_EraseRootFromParent_Done,
     /* 2010610 */   // Label 26885: @2010610
     /* 2010610 */   GIM_Try, /*On fail goto*//*Label 26886*/ GIMT_Encode4(2010699), // Rule ID 22923 //
     /* 2010615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2010632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010661 */     // MIs[0] round
     /* 2010661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010671 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 2010674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010698 */     // GIR_Coverage, 22923,
     /* 2010698 */     GIR_EraseRootFromParent_Done,
     /* 2010699 */   // Label 26886: @2010699
     /* 2010699 */   GIM_Try, /*On fail goto*//*Label 26887*/ GIMT_Encode4(2010788), // Rule ID 22926 //
     /* 2010704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2010721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010750 */     // MIs[0] round
     /* 2010750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010760 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2010763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010787 */     // GIR_Coverage, 22926,
     /* 2010787 */     GIR_EraseRootFromParent_Done,
     /* 2010788 */   // Label 26887: @2010788
     /* 2010788 */   GIM_Try, /*On fail goto*//*Label 26888*/ GIMT_Encode4(2010877), // Rule ID 22927 //
     /* 2010793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2010810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2010831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010839 */     // MIs[0] round
     /* 2010839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010849 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2010849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 2010852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010876 */     // GIR_Coverage, 22927,
     /* 2010876 */     GIR_EraseRootFromParent_Done,
     /* 2010877 */   // Label 26888: @2010877
     /* 2010877 */   GIM_Try, /*On fail goto*//*Label 26889*/ GIMT_Encode4(2010966), // Rule ID 22930 //
     /* 2010882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2010885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2010899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2010920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010928 */     // MIs[0] round
     /* 2010928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010938 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2010938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2010941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2010945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2010949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2010964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010965 */     // GIR_Coverage, 22930,
     /* 2010965 */     GIR_EraseRootFromParent_Done,
     /* 2010966 */   // Label 26889: @2010966
     /* 2010966 */   GIM_Try, /*On fail goto*//*Label 26890*/ GIMT_Encode4(2011055), // Rule ID 22931 //
     /* 2010971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2010974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2010979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2010988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2010991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011017 */     // MIs[0] round
     /* 2011017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011027 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11260:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 2011030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2011050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011054 */     // GIR_Coverage, 22931,
     /* 2011054 */     GIR_EraseRootFromParent_Done,
     /* 2011055 */   // Label 26890: @2011055
     /* 2011055 */   GIM_Try, /*On fail goto*//*Label 26891*/ GIMT_Encode4(2011144), // Rule ID 22934 //
     /* 2011060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2011077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011106 */     // MIs[0] round
     /* 2011106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011116 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2011119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011143 */     // GIR_Coverage, 22934,
     /* 2011143 */     GIR_EraseRootFromParent_Done,
     /* 2011144 */   // Label 26891: @2011144
     /* 2011144 */   GIM_Try, /*On fail goto*//*Label 26892*/ GIMT_Encode4(2011233), // Rule ID 22935 //
     /* 2011149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2011166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011195 */     // MIs[0] round
     /* 2011195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011205 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 2011208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011232 */     // GIR_Coverage, 22935,
     /* 2011232 */     GIR_EraseRootFromParent_Done,
     /* 2011233 */   // Label 26892: @2011233
     /* 2011233 */   GIM_Try, /*On fail goto*//*Label 26893*/ GIMT_Encode4(2011322), // Rule ID 22938 //
     /* 2011238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2011255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011284 */     // MIs[0] round
     /* 2011284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011294 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2011297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011321 */     // GIR_Coverage, 22938,
     /* 2011321 */     GIR_EraseRootFromParent_Done,
     /* 2011322 */   // Label 26893: @2011322
     /* 2011322 */   GIM_Try, /*On fail goto*//*Label 26894*/ GIMT_Encode4(2011411), // Rule ID 22939 //
     /* 2011327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2011344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2011350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011373 */     // MIs[0] round
     /* 2011373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011383 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2011386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011410 */     // GIR_Coverage, 22939,
     /* 2011410 */     GIR_EraseRootFromParent_Done,
     /* 2011411 */   // Label 26894: @2011411
     /* 2011411 */   GIM_Try, /*On fail goto*//*Label 26895*/ GIMT_Encode4(2011500), // Rule ID 22942 //
     /* 2011416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2011419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2011433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011462 */     // MIs[0] round
     /* 2011462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011472 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2011475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011499 */     // GIR_Coverage, 22942,
     /* 2011499 */     GIR_EraseRootFromParent_Done,
     /* 2011500 */   // Label 26895: @2011500
     /* 2011500 */   GIM_Try, /*On fail goto*//*Label 26896*/ GIMT_Encode4(2011589), // Rule ID 22943 //
     /* 2011505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2011508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2011513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2011522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011551 */     // MIs[0] round
     /* 2011551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011561 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11260:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2011564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2011584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011588 */     // GIR_Coverage, 22943,
     /* 2011588 */     GIR_EraseRootFromParent_Done,
     /* 2011589 */   // Label 26896: @2011589
     /* 2011589 */   GIM_Try, /*On fail goto*//*Label 26897*/ GIMT_Encode4(2011678), // Rule ID 23066 //
     /* 2011594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2011597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2011611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011640 */     // MIs[0] round
     /* 2011640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2011653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011677 */     // GIR_Coverage, 23066,
     /* 2011677 */     GIR_EraseRootFromParent_Done,
     /* 2011678 */   // Label 26897: @2011678
     /* 2011678 */   GIM_Try, /*On fail goto*//*Label 26898*/ GIMT_Encode4(2011767), // Rule ID 23067 //
     /* 2011683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2011686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2011700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011729 */     // MIs[0] round
     /* 2011729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011739 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2011742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011766 */     // GIR_Coverage, 23067,
     /* 2011766 */     GIR_EraseRootFromParent_Done,
     /* 2011767 */   // Label 26898: @2011767
     /* 2011767 */   GIM_Try, /*On fail goto*//*Label 26899*/ GIMT_Encode4(2011856), // Rule ID 23070 //
     /* 2011772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2011775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2011789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011818 */     // MIs[0] round
     /* 2011818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011828 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2011828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2011831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011855 */     // GIR_Coverage, 23070,
     /* 2011855 */     GIR_EraseRootFromParent_Done,
     /* 2011856 */   // Label 26899: @2011856
     /* 2011856 */   GIM_Try, /*On fail goto*//*Label 26900*/ GIMT_Encode4(2011945), // Rule ID 23071 //
     /* 2011861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2011864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2011872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2011875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2011878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2011881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2011884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011907 */     // MIs[0] round
     /* 2011907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011917 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2011917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2011920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2011924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2011928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2011943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011944 */     // GIR_Coverage, 23071,
     /* 2011944 */     GIR_EraseRootFromParent_Done,
     /* 2011945 */   // Label 26900: @2011945
     /* 2011945 */   GIM_Try, /*On fail goto*//*Label 26901*/ GIMT_Encode4(2012034), // Rule ID 23074 //
     /* 2011950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2011953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2011958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2011961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2011964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2011967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2011970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2011973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2011980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2011992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011996 */     // MIs[0] round
     /* 2011996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012006 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2012009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012033 */     // GIR_Coverage, 23074,
     /* 2012033 */     GIR_EraseRootFromParent_Done,
     /* 2012034 */   // Label 26901: @2012034
     /* 2012034 */   GIM_Try, /*On fail goto*//*Label 26902*/ GIMT_Encode4(2012123), // Rule ID 23075 //
     /* 2012039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2012042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2012056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2012062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012085 */     // MIs[0] round
     /* 2012085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012095 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2012098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012122 */     // GIR_Coverage, 23075,
     /* 2012122 */     GIR_EraseRootFromParent_Done,
     /* 2012123 */   // Label 26902: @2012123
     /* 2012123 */   GIM_Try, /*On fail goto*//*Label 26903*/ GIMT_Encode4(2012212), // Rule ID 23078 //
     /* 2012128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012174 */     // MIs[0] round
     /* 2012174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2012187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012211 */     // GIR_Coverage, 23078,
     /* 2012211 */     GIR_EraseRootFromParent_Done,
     /* 2012212 */   // Label 26903: @2012212
     /* 2012212 */   GIM_Try, /*On fail goto*//*Label 26904*/ GIMT_Encode4(2012301), // Rule ID 23079 //
     /* 2012217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2012234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012263 */     // MIs[0] round
     /* 2012263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012273 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2012276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012300 */     // GIR_Coverage, 23079,
     /* 2012300 */     GIR_EraseRootFromParent_Done,
     /* 2012301 */   // Label 26904: @2012301
     /* 2012301 */   GIM_Try, /*On fail goto*//*Label 26905*/ GIMT_Encode4(2012390), // Rule ID 23082 //
     /* 2012306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2012309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2012323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012352 */     // MIs[0] round
     /* 2012352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012362 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2012365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012389 */     // GIR_Coverage, 23082,
     /* 2012389 */     GIR_EraseRootFromParent_Done,
     /* 2012390 */   // Label 26905: @2012390
     /* 2012390 */   GIM_Try, /*On fail goto*//*Label 26906*/ GIMT_Encode4(2012479), // Rule ID 23083 //
     /* 2012395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2012398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2012406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2012409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2012412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2012415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012441 */     // MIs[0] round
     /* 2012441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012451 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2012454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012478 */     // GIR_Coverage, 23083,
     /* 2012478 */     GIR_EraseRootFromParent_Done,
     /* 2012479 */   // Label 26906: @2012479
     /* 2012479 */   GIM_Try, /*On fail goto*//*Label 26907*/ GIMT_Encode4(2012568), // Rule ID 23086 //
     /* 2012484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2012501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012530 */     // MIs[0] round
     /* 2012530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012540 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2012543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012567 */     // GIR_Coverage, 23086,
     /* 2012567 */     GIR_EraseRootFromParent_Done,
     /* 2012568 */   // Label 26907: @2012568
     /* 2012568 */   GIM_Try, /*On fail goto*//*Label 26908*/ GIMT_Encode4(2012657), // Rule ID 23087 //
     /* 2012573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2012590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012619 */     // MIs[0] round
     /* 2012619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012629 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2012632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012656 */     // GIR_Coverage, 23087,
     /* 2012656 */     GIR_EraseRootFromParent_Done,
     /* 2012657 */   // Label 26908: @2012657
     /* 2012657 */   GIM_Try, /*On fail goto*//*Label 26909*/ GIMT_Encode4(2012746), // Rule ID 23090 //
     /* 2012662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2012679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012708 */     // MIs[0] round
     /* 2012708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012718 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2012721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012745 */     // GIR_Coverage, 23090,
     /* 2012745 */     GIR_EraseRootFromParent_Done,
     /* 2012746 */   // Label 26909: @2012746
     /* 2012746 */   GIM_Try, /*On fail goto*//*Label 26910*/ GIMT_Encode4(2012835), // Rule ID 23091 //
     /* 2012751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2012768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012797 */     // MIs[0] round
     /* 2012797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012807 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2012810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012834 */     // GIR_Coverage, 23091,
     /* 2012834 */     GIR_EraseRootFromParent_Done,
     /* 2012835 */   // Label 26910: @2012835
     /* 2012835 */   GIM_Try, /*On fail goto*//*Label 26911*/ GIMT_Encode4(2012924), // Rule ID 23094 //
     /* 2012840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2012843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2012857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2012863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012886 */     // MIs[0] round
     /* 2012886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012896 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2012896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2012899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2012922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012923 */     // GIR_Coverage, 23094,
     /* 2012923 */     GIR_EraseRootFromParent_Done,
     /* 2012924 */   // Label 26911: @2012924
     /* 2012924 */   GIM_Try, /*On fail goto*//*Label 26912*/ GIMT_Encode4(2013013), // Rule ID 23095 //
     /* 2012929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2012932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2012937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2012940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2012943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2012946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2012949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2012952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2012959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2012971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012975 */     // MIs[0] round
     /* 2012975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012985 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11314:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2012985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2012988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2012992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2012996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013012 */     // GIR_Coverage, 23095,
     /* 2013012 */     GIR_EraseRootFromParent_Done,
     /* 2013013 */   // Label 26912: @2013013
     /* 2013013 */   GIM_Try, /*On fail goto*//*Label 26913*/ GIMT_Encode4(2013102), // Rule ID 23098 //
     /* 2013018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013064 */     // MIs[0] round
     /* 2013064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013074 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2013077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013101 */     // GIR_Coverage, 23098,
     /* 2013101 */     GIR_EraseRootFromParent_Done,
     /* 2013102 */   // Label 26913: @2013102
     /* 2013102 */   GIM_Try, /*On fail goto*//*Label 26914*/ GIMT_Encode4(2013191), // Rule ID 23099 //
     /* 2013107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2013124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013153 */     // MIs[0] round
     /* 2013153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013163 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2013166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013190 */     // GIR_Coverage, 23099,
     /* 2013190 */     GIR_EraseRootFromParent_Done,
     /* 2013191 */   // Label 26914: @2013191
     /* 2013191 */   GIM_Try, /*On fail goto*//*Label 26915*/ GIMT_Encode4(2013280), // Rule ID 23102 //
     /* 2013196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013242 */     // MIs[0] round
     /* 2013242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013252 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2013255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013279 */     // GIR_Coverage, 23102,
     /* 2013279 */     GIR_EraseRootFromParent_Done,
     /* 2013280 */   // Label 26915: @2013280
     /* 2013280 */   GIM_Try, /*On fail goto*//*Label 26916*/ GIMT_Encode4(2013369), // Rule ID 23103 //
     /* 2013285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2013302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2013323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013331 */     // MIs[0] round
     /* 2013331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013341 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2013344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013368 */     // GIR_Coverage, 23103,
     /* 2013368 */     GIR_EraseRootFromParent_Done,
     /* 2013369 */   // Label 26916: @2013369
     /* 2013369 */   GIM_Try, /*On fail goto*//*Label 26917*/ GIMT_Encode4(2013458), // Rule ID 23106 //
     /* 2013374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2013391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013420 */     // MIs[0] round
     /* 2013420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013430 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2013433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013457 */     // GIR_Coverage, 23106,
     /* 2013457 */     GIR_EraseRootFromParent_Done,
     /* 2013458 */   // Label 26917: @2013458
     /* 2013458 */   GIM_Try, /*On fail goto*//*Label 26918*/ GIMT_Encode4(2013547), // Rule ID 23107 //
     /* 2013463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2013466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2013471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2013480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2013486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013509 */     // MIs[0] round
     /* 2013509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013519 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11314:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2013522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013546 */     // GIR_Coverage, 23107,
     /* 2013546 */     GIR_EraseRootFromParent_Done,
     /* 2013547 */   // Label 26918: @2013547
     /* 2013547 */   GIM_Try, /*On fail goto*//*Label 26919*/ GIMT_Encode4(2013636), // Rule ID 23110 //
     /* 2013552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013598 */     // MIs[0] round
     /* 2013598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013608 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2013611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013635 */     // GIR_Coverage, 23110,
     /* 2013635 */     GIR_EraseRootFromParent_Done,
     /* 2013636 */   // Label 26919: @2013636
     /* 2013636 */   GIM_Try, /*On fail goto*//*Label 26920*/ GIMT_Encode4(2013725), // Rule ID 23111 //
     /* 2013641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013687 */     // MIs[0] round
     /* 2013687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013697 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2013700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013724 */     // GIR_Coverage, 23111,
     /* 2013724 */     GIR_EraseRootFromParent_Done,
     /* 2013725 */   // Label 26920: @2013725
     /* 2013725 */   GIM_Try, /*On fail goto*//*Label 26921*/ GIMT_Encode4(2013814), // Rule ID 23114 //
     /* 2013730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2013733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013776 */     // MIs[0] round
     /* 2013776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013786 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2013789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013813 */     // GIR_Coverage, 23114,
     /* 2013813 */     GIR_EraseRootFromParent_Done,
     /* 2013814 */   // Label 26921: @2013814
     /* 2013814 */   GIM_Try, /*On fail goto*//*Label 26922*/ GIMT_Encode4(2013903), // Rule ID 23115 //
     /* 2013819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2013822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2013830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2013833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2013839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013865 */     // MIs[0] round
     /* 2013865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013875 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2013875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2013878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2013898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013902 */     // GIR_Coverage, 23115,
     /* 2013902 */     GIR_EraseRootFromParent_Done,
     /* 2013903 */   // Label 26922: @2013903
     /* 2013903 */   GIM_Try, /*On fail goto*//*Label 26923*/ GIMT_Encode4(2013992), // Rule ID 23118 //
     /* 2013908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2013911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2013916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2013919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2013922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2013925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2013928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013954 */     // MIs[0] round
     /* 2013954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013964 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2013964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2013967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2013971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2013975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2013987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2013990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013991 */     // GIR_Coverage, 23118,
     /* 2013991 */     GIR_EraseRootFromParent_Done,
     /* 2013992 */   // Label 26923: @2013992
     /* 2013992 */   GIM_Try, /*On fail goto*//*Label 26924*/ GIMT_Encode4(2014081), // Rule ID 23119 //
     /* 2013997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014043 */     // MIs[0] round
     /* 2014043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014053 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2014056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014080 */     // GIR_Coverage, 23119,
     /* 2014080 */     GIR_EraseRootFromParent_Done,
     /* 2014081 */   // Label 26924: @2014081
     /* 2014081 */   GIM_Try, /*On fail goto*//*Label 26925*/ GIMT_Encode4(2014170), // Rule ID 23122 //
     /* 2014086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014132 */     // MIs[0] round
     /* 2014132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2014145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014169 */     // GIR_Coverage, 23122,
     /* 2014169 */     GIR_EraseRootFromParent_Done,
     /* 2014170 */   // Label 26925: @2014170
     /* 2014170 */   GIM_Try, /*On fail goto*//*Label 26926*/ GIMT_Encode4(2014259), // Rule ID 23123 //
     /* 2014175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2014192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014221 */     // MIs[0] round
     /* 2014221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014231 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2014234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014258 */     // GIR_Coverage, 23123,
     /* 2014258 */     GIR_EraseRootFromParent_Done,
     /* 2014259 */   // Label 26926: @2014259
     /* 2014259 */   GIM_Try, /*On fail goto*//*Label 26927*/ GIMT_Encode4(2014348), // Rule ID 23126 //
     /* 2014264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014310 */     // MIs[0] round
     /* 2014310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014320 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2014323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014347 */     // GIR_Coverage, 23126,
     /* 2014347 */     GIR_EraseRootFromParent_Done,
     /* 2014348 */   // Label 26927: @2014348
     /* 2014348 */   GIM_Try, /*On fail goto*//*Label 26928*/ GIMT_Encode4(2014437), // Rule ID 23127 //
     /* 2014353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2014356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014399 */     // MIs[0] round
     /* 2014399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014409 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2014412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2014432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014436 */     // GIR_Coverage, 23127,
     /* 2014436 */     GIR_EraseRootFromParent_Done,
     /* 2014437 */   // Label 26928: @2014437
     /* 2014437 */   GIM_Try, /*On fail goto*//*Label 26929*/ GIMT_Encode4(2014526), // Rule ID 23130 //
     /* 2014442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2014459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014488 */     // MIs[0] round
     /* 2014488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014498 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2014501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014525 */     // GIR_Coverage, 23130,
     /* 2014525 */     GIR_EraseRootFromParent_Done,
     /* 2014526 */   // Label 26929: @2014526
     /* 2014526 */   GIM_Try, /*On fail goto*//*Label 26930*/ GIMT_Encode4(2014615), // Rule ID 23131 //
     /* 2014531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2014548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014577 */     // MIs[0] round
     /* 2014577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014587 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2014590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014614 */     // GIR_Coverage, 23131,
     /* 2014614 */     GIR_EraseRootFromParent_Done,
     /* 2014615 */   // Label 26930: @2014615
     /* 2014615 */   GIM_Try, /*On fail goto*//*Label 26931*/ GIMT_Encode4(2014704), // Rule ID 23134 //
     /* 2014620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014666 */     // MIs[0] round
     /* 2014666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014676 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2014679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014703 */     // GIR_Coverage, 23134,
     /* 2014703 */     GIR_EraseRootFromParent_Done,
     /* 2014704 */   // Label 26931: @2014704
     /* 2014704 */   GIM_Try, /*On fail goto*//*Label 26932*/ GIMT_Encode4(2014793), // Rule ID 23135 //
     /* 2014709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014755 */     // MIs[0] round
     /* 2014755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014765 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2014768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014792 */     // GIR_Coverage, 23135,
     /* 2014792 */     GIR_EraseRootFromParent_Done,
     /* 2014793 */   // Label 26932: @2014793
     /* 2014793 */   GIM_Try, /*On fail goto*//*Label 26933*/ GIMT_Encode4(2014882), // Rule ID 23138 //
     /* 2014798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2014801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2014815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2014821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014844 */     // MIs[0] round
     /* 2014844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014854 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2014854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2014857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014881 */     // GIR_Coverage, 23138,
     /* 2014881 */     GIR_EraseRootFromParent_Done,
     /* 2014882 */   // Label 26933: @2014882
     /* 2014882 */   GIM_Try, /*On fail goto*//*Label 26934*/ GIMT_Encode4(2014971), // Rule ID 23139 //
     /* 2014887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2014890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2014898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2014901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2014904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2014907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2014910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014933 */     // MIs[0] round
     /* 2014933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014943 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11312:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2014943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2014946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2014950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2014954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2014969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014970 */     // GIR_Coverage, 23139,
     /* 2014970 */     GIR_EraseRootFromParent_Done,
     /* 2014971 */   // Label 26934: @2014971
     /* 2014971 */   GIM_Try, /*On fail goto*//*Label 26935*/ GIMT_Encode4(2015060), // Rule ID 23142 //
     /* 2014976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2014979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2014984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2014987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2014990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2014993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2014996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015022 */     // MIs[0] round
     /* 2015022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015032 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2015035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015059 */     // GIR_Coverage, 23142,
     /* 2015059 */     GIR_EraseRootFromParent_Done,
     /* 2015060 */   // Label 26935: @2015060
     /* 2015060 */   GIM_Try, /*On fail goto*//*Label 26936*/ GIMT_Encode4(2015149), // Rule ID 23143 //
     /* 2015065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2015082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015111 */     // MIs[0] round
     /* 2015111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015121 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2015124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015148 */     // GIR_Coverage, 23143,
     /* 2015148 */     GIR_EraseRootFromParent_Done,
     /* 2015149 */   // Label 26936: @2015149
     /* 2015149 */   GIM_Try, /*On fail goto*//*Label 26937*/ GIMT_Encode4(2015238), // Rule ID 23146 //
     /* 2015154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015200 */     // MIs[0] round
     /* 2015200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015210 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2015213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015237 */     // GIR_Coverage, 23146,
     /* 2015237 */     GIR_EraseRootFromParent_Done,
     /* 2015238 */   // Label 26937: @2015238
     /* 2015238 */   GIM_Try, /*On fail goto*//*Label 26938*/ GIMT_Encode4(2015327), // Rule ID 23147 //
     /* 2015243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015289 */     // MIs[0] round
     /* 2015289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015299 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2015302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015326 */     // GIR_Coverage, 23147,
     /* 2015326 */     GIR_EraseRootFromParent_Done,
     /* 2015327 */   // Label 26938: @2015327
     /* 2015327 */   GIM_Try, /*On fail goto*//*Label 26939*/ GIMT_Encode4(2015416), // Rule ID 23150 //
     /* 2015332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2015335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015378 */     // MIs[0] round
     /* 2015378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015388 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2015388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2015391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015415 */     // GIR_Coverage, 23150,
     /* 2015415 */     GIR_EraseRootFromParent_Done,
     /* 2015416 */   // Label 26939: @2015416
     /* 2015416 */   GIM_Try, /*On fail goto*//*Label 26940*/ GIMT_Encode4(2015505), // Rule ID 23151 //
     /* 2015421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2015424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2015429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2015432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2015435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2015441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015467 */     // MIs[0] round
     /* 2015467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015477 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11312:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2015477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2015480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2015484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2015488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2015503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015504 */     // GIR_Coverage, 23151,
     /* 2015504 */     GIR_EraseRootFromParent_Done,
     /* 2015505 */   // Label 26940: @2015505
     /* 2015505 */   GIM_Reject,
     /* 2015506 */ // Label 19884: @2015506
     /* 2015506 */ GIM_Try, /*On fail goto*//*Label 26941*/ GIMT_Encode4(2205991),
     /* 2015511 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 2015514 */   GIM_Try, /*On fail goto*//*Label 26942*/ GIMT_Encode4(2015616), // Rule ID 15986 //
     /* 2015519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2015530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2015533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2015536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015569 */     // MIs[1] Operand 1
     /* 2015569 */     // No operand predicates
     /* 2015569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015573 */     // MIs[0] round
     /* 2015573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015576 */     // MIs[0] policy
     /* 2015576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015588 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2015591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015615 */     // GIR_Coverage, 15986,
     /* 2015615 */     GIR_EraseRootFromParent_Done,
     /* 2015616 */   // Label 26942: @2015616
     /* 2015616 */   GIM_Try, /*On fail goto*//*Label 26943*/ GIMT_Encode4(2015718), // Rule ID 15987 //
     /* 2015621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2015632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2015635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2015638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015671 */     // MIs[1] Operand 1
     /* 2015671 */     // No operand predicates
     /* 2015671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015675 */     // MIs[0] round
     /* 2015675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015678 */     // MIs[0] policy
     /* 2015678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015690 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2015693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015717 */     // GIR_Coverage, 15987,
     /* 2015717 */     GIR_EraseRootFromParent_Done,
     /* 2015718 */   // Label 26943: @2015718
     /* 2015718 */   GIM_Try, /*On fail goto*//*Label 26944*/ GIMT_Encode4(2015820), // Rule ID 15990 //
     /* 2015723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2015734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2015737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2015740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015773 */     // MIs[1] Operand 1
     /* 2015773 */     // No operand predicates
     /* 2015773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015777 */     // MIs[0] round
     /* 2015777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015780 */     // MIs[0] policy
     /* 2015780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015792 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2015795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015819 */     // GIR_Coverage, 15990,
     /* 2015819 */     GIR_EraseRootFromParent_Done,
     /* 2015820 */   // Label 26944: @2015820
     /* 2015820 */   GIM_Try, /*On fail goto*//*Label 26945*/ GIMT_Encode4(2015922), // Rule ID 15991 //
     /* 2015825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2015836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2015839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2015842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015875 */     // MIs[1] Operand 1
     /* 2015875 */     // No operand predicates
     /* 2015875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015879 */     // MIs[0] round
     /* 2015879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015882 */     // MIs[0] policy
     /* 2015882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015894 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2015897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2015918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015921 */     // GIR_Coverage, 15991,
     /* 2015921 */     GIR_EraseRootFromParent_Done,
     /* 2015922 */   // Label 26945: @2015922
     /* 2015922 */   GIM_Try, /*On fail goto*//*Label 26946*/ GIMT_Encode4(2016024), // Rule ID 15994 //
     /* 2015927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2015935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2015938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2015941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2015944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015977 */     // MIs[1] Operand 1
     /* 2015977 */     // No operand predicates
     /* 2015977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015981 */     // MIs[0] round
     /* 2015981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015984 */     // MIs[0] policy
     /* 2015984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015996 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2015999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016023 */     // GIR_Coverage, 15994,
     /* 2016023 */     GIR_EraseRootFromParent_Done,
     /* 2016024 */   // Label 26946: @2016024
     /* 2016024 */   GIM_Try, /*On fail goto*//*Label 26947*/ GIMT_Encode4(2016126), // Rule ID 15995 //
     /* 2016029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2016040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2016043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2016046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016079 */     // MIs[1] Operand 1
     /* 2016079 */     // No operand predicates
     /* 2016079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016083 */     // MIs[0] round
     /* 2016083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016086 */     // MIs[0] policy
     /* 2016086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016098 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016125 */     // GIR_Coverage, 15995,
     /* 2016125 */     GIR_EraseRootFromParent_Done,
     /* 2016126 */   // Label 26947: @2016126
     /* 2016126 */   GIM_Try, /*On fail goto*//*Label 26948*/ GIMT_Encode4(2016228), // Rule ID 15998 //
     /* 2016131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2016142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2016145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016181 */     // MIs[1] Operand 1
     /* 2016181 */     // No operand predicates
     /* 2016181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016185 */     // MIs[0] round
     /* 2016185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016188 */     // MIs[0] policy
     /* 2016188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016200 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016227 */     // GIR_Coverage, 15998,
     /* 2016227 */     GIR_EraseRootFromParent_Done,
     /* 2016228 */   // Label 26948: @2016228
     /* 2016228 */   GIM_Try, /*On fail goto*//*Label 26949*/ GIMT_Encode4(2016330), // Rule ID 15999 //
     /* 2016233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2016244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2016247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016283 */     // MIs[1] Operand 1
     /* 2016283 */     // No operand predicates
     /* 2016283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016287 */     // MIs[0] round
     /* 2016287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016290 */     // MIs[0] policy
     /* 2016290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016302 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2016305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016329 */     // GIR_Coverage, 15999,
     /* 2016329 */     GIR_EraseRootFromParent_Done,
     /* 2016330 */   // Label 26949: @2016330
     /* 2016330 */   GIM_Try, /*On fail goto*//*Label 26950*/ GIMT_Encode4(2016432), // Rule ID 16002 //
     /* 2016335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2016346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2016349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016385 */     // MIs[1] Operand 1
     /* 2016385 */     // No operand predicates
     /* 2016385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016389 */     // MIs[0] round
     /* 2016389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016392 */     // MIs[0] policy
     /* 2016392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016404 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016431 */     // GIR_Coverage, 16002,
     /* 2016431 */     GIR_EraseRootFromParent_Done,
     /* 2016432 */   // Label 26950: @2016432
     /* 2016432 */   GIM_Try, /*On fail goto*//*Label 26951*/ GIMT_Encode4(2016534), // Rule ID 16003 //
     /* 2016437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2016448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2016451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016487 */     // MIs[1] Operand 1
     /* 2016487 */     // No operand predicates
     /* 2016487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016491 */     // MIs[0] round
     /* 2016491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016494 */     // MIs[0] policy
     /* 2016494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2016530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016533 */     // GIR_Coverage, 16003,
     /* 2016533 */     GIR_EraseRootFromParent_Done,
     /* 2016534 */   // Label 26951: @2016534
     /* 2016534 */   GIM_Try, /*On fail goto*//*Label 26952*/ GIMT_Encode4(2016636), // Rule ID 16006 //
     /* 2016539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2016550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2016553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2016556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016589 */     // MIs[1] Operand 1
     /* 2016589 */     // No operand predicates
     /* 2016589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016593 */     // MIs[0] round
     /* 2016593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016596 */     // MIs[0] policy
     /* 2016596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016608 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016635 */     // GIR_Coverage, 16006,
     /* 2016635 */     GIR_EraseRootFromParent_Done,
     /* 2016636 */   // Label 26952: @2016636
     /* 2016636 */   GIM_Try, /*On fail goto*//*Label 26953*/ GIMT_Encode4(2016738), // Rule ID 16007 //
     /* 2016641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2016652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2016655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2016658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016691 */     // MIs[1] Operand 1
     /* 2016691 */     // No operand predicates
     /* 2016691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016695 */     // MIs[0] round
     /* 2016695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016698 */     // MIs[0] policy
     /* 2016698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016710 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2016713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016737 */     // GIR_Coverage, 16007,
     /* 2016737 */     GIR_EraseRootFromParent_Done,
     /* 2016738 */   // Label 26953: @2016738
     /* 2016738 */   GIM_Try, /*On fail goto*//*Label 26954*/ GIMT_Encode4(2016840), // Rule ID 16010 //
     /* 2016743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2016754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2016757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2016760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016793 */     // MIs[1] Operand 1
     /* 2016793 */     // No operand predicates
     /* 2016793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016797 */     // MIs[0] round
     /* 2016797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016800 */     // MIs[0] policy
     /* 2016800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2016815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016839 */     // GIR_Coverage, 16010,
     /* 2016839 */     GIR_EraseRootFromParent_Done,
     /* 2016840 */   // Label 26954: @2016840
     /* 2016840 */   GIM_Try, /*On fail goto*//*Label 26955*/ GIMT_Encode4(2016942), // Rule ID 16011 //
     /* 2016845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2016856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2016859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2016862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016895 */     // MIs[1] Operand 1
     /* 2016895 */     // No operand predicates
     /* 2016895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016899 */     // MIs[0] round
     /* 2016899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016902 */     // MIs[0] policy
     /* 2016902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016914 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2016917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016941 */     // GIR_Coverage, 16011,
     /* 2016941 */     GIR_EraseRootFromParent_Done,
     /* 2016942 */   // Label 26955: @2016942
     /* 2016942 */   GIM_Try, /*On fail goto*//*Label 26956*/ GIMT_Encode4(2017044), // Rule ID 16014 //
     /* 2016947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2016955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2016958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2016961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2016964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016997 */     // MIs[1] Operand 1
     /* 2016997 */     // No operand predicates
     /* 2016997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017001 */     // MIs[0] round
     /* 2017001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017004 */     // MIs[0] policy
     /* 2017004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017043 */     // GIR_Coverage, 16014,
     /* 2017043 */     GIR_EraseRootFromParent_Done,
     /* 2017044 */   // Label 26956: @2017044
     /* 2017044 */   GIM_Try, /*On fail goto*//*Label 26957*/ GIMT_Encode4(2017146), // Rule ID 16015 //
     /* 2017049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2017060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2017063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2017066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2017072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017099 */     // MIs[1] Operand 1
     /* 2017099 */     // No operand predicates
     /* 2017099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017103 */     // MIs[0] round
     /* 2017103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017106 */     // MIs[0] policy
     /* 2017106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017118 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017145 */     // GIR_Coverage, 16015,
     /* 2017145 */     GIR_EraseRootFromParent_Done,
     /* 2017146 */   // Label 26957: @2017146
     /* 2017146 */   GIM_Try, /*On fail goto*//*Label 26958*/ GIMT_Encode4(2017248), // Rule ID 16018 //
     /* 2017151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017201 */     // MIs[1] Operand 1
     /* 2017201 */     // No operand predicates
     /* 2017201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017205 */     // MIs[0] round
     /* 2017205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017208 */     // MIs[0] policy
     /* 2017208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017247 */     // GIR_Coverage, 16018,
     /* 2017247 */     GIR_EraseRootFromParent_Done,
     /* 2017248 */   // Label 26958: @2017248
     /* 2017248 */   GIM_Try, /*On fail goto*//*Label 26959*/ GIMT_Encode4(2017350), // Rule ID 16019 //
     /* 2017253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2017264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2017267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017303 */     // MIs[1] Operand 1
     /* 2017303 */     // No operand predicates
     /* 2017303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017307 */     // MIs[0] round
     /* 2017307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017310 */     // MIs[0] policy
     /* 2017310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2017346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017349 */     // GIR_Coverage, 16019,
     /* 2017349 */     GIR_EraseRootFromParent_Done,
     /* 2017350 */   // Label 26959: @2017350
     /* 2017350 */   GIM_Try, /*On fail goto*//*Label 26960*/ GIMT_Encode4(2017452), // Rule ID 16022 //
     /* 2017355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2017358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017405 */     // MIs[1] Operand 1
     /* 2017405 */     // No operand predicates
     /* 2017405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017409 */     // MIs[0] round
     /* 2017409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017412 */     // MIs[0] policy
     /* 2017412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017451 */     // GIR_Coverage, 16022,
     /* 2017451 */     GIR_EraseRootFromParent_Done,
     /* 2017452 */   // Label 26960: @2017452
     /* 2017452 */   GIM_Try, /*On fail goto*//*Label 26961*/ GIMT_Encode4(2017554), // Rule ID 16023 //
     /* 2017457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2017460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2017468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2017471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2017474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017507 */     // MIs[1] Operand 1
     /* 2017507 */     // No operand predicates
     /* 2017507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017511 */     // MIs[0] round
     /* 2017511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017514 */     // MIs[0] policy
     /* 2017514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2017529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2017550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017553 */     // GIR_Coverage, 16023,
     /* 2017553 */     GIR_EraseRootFromParent_Done,
     /* 2017554 */   // Label 26961: @2017554
     /* 2017554 */   GIM_Try, /*On fail goto*//*Label 26962*/ GIMT_Encode4(2017656), // Rule ID 16026 //
     /* 2017559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2017570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2017573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2017576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017609 */     // MIs[1] Operand 1
     /* 2017609 */     // No operand predicates
     /* 2017609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017613 */     // MIs[0] round
     /* 2017613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017616 */     // MIs[0] policy
     /* 2017616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017628 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2017631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017655 */     // GIR_Coverage, 16026,
     /* 2017655 */     GIR_EraseRootFromParent_Done,
     /* 2017656 */   // Label 26962: @2017656
     /* 2017656 */   GIM_Try, /*On fail goto*//*Label 26963*/ GIMT_Encode4(2017758), // Rule ID 16027 //
     /* 2017661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2017672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2017675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2017678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017711 */     // MIs[1] Operand 1
     /* 2017711 */     // No operand predicates
     /* 2017711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017715 */     // MIs[0] round
     /* 2017715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017718 */     // MIs[0] policy
     /* 2017718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2017733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017757 */     // GIR_Coverage, 16027,
     /* 2017757 */     GIR_EraseRootFromParent_Done,
     /* 2017758 */   // Label 26963: @2017758
     /* 2017758 */   GIM_Try, /*On fail goto*//*Label 26964*/ GIMT_Encode4(2017860), // Rule ID 16030 //
     /* 2017763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2017774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2017777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2017780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2017786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017813 */     // MIs[1] Operand 1
     /* 2017813 */     // No operand predicates
     /* 2017813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017817 */     // MIs[0] round
     /* 2017817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017820 */     // MIs[0] policy
     /* 2017820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017832 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2017835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017859 */     // GIR_Coverage, 16030,
     /* 2017859 */     GIR_EraseRootFromParent_Done,
     /* 2017860 */   // Label 26964: @2017860
     /* 2017860 */   GIM_Try, /*On fail goto*//*Label 26965*/ GIMT_Encode4(2017962), // Rule ID 16031 //
     /* 2017865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2017876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2017879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2017882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2017888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017915 */     // MIs[1] Operand 1
     /* 2017915 */     // No operand predicates
     /* 2017915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017919 */     // MIs[0] round
     /* 2017919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017922 */     // MIs[0] policy
     /* 2017922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017934 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2017937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017961 */     // GIR_Coverage, 16031,
     /* 2017961 */     GIR_EraseRootFromParent_Done,
     /* 2017962 */   // Label 26965: @2017962
     /* 2017962 */   GIM_Try, /*On fail goto*//*Label 26966*/ GIMT_Encode4(2018064), // Rule ID 16034 //
     /* 2017967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2017975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2017978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2017981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2017984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2017990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2017997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018017 */     // MIs[1] Operand 1
     /* 2018017 */     // No operand predicates
     /* 2018017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018021 */     // MIs[0] round
     /* 2018021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018024 */     // MIs[0] policy
     /* 2018024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018036 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018063 */     // GIR_Coverage, 16034,
     /* 2018063 */     GIR_EraseRootFromParent_Done,
     /* 2018064 */   // Label 26966: @2018064
     /* 2018064 */   GIM_Try, /*On fail goto*//*Label 26967*/ GIMT_Encode4(2018166), // Rule ID 16035 //
     /* 2018069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2018080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2018083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2018086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2018092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018119 */     // MIs[1] Operand 1
     /* 2018119 */     // No operand predicates
     /* 2018119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018123 */     // MIs[0] round
     /* 2018123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018126 */     // MIs[0] policy
     /* 2018126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018138 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2018162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018165 */     // GIR_Coverage, 16035,
     /* 2018165 */     GIR_EraseRootFromParent_Done,
     /* 2018166 */   // Label 26967: @2018166
     /* 2018166 */   GIM_Try, /*On fail goto*//*Label 26968*/ GIMT_Encode4(2018268), // Rule ID 16038 //
     /* 2018171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018221 */     // MIs[1] Operand 1
     /* 2018221 */     // No operand predicates
     /* 2018221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018225 */     // MIs[0] round
     /* 2018225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018228 */     // MIs[0] policy
     /* 2018228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018267 */     // GIR_Coverage, 16038,
     /* 2018267 */     GIR_EraseRootFromParent_Done,
     /* 2018268 */   // Label 26968: @2018268
     /* 2018268 */   GIM_Try, /*On fail goto*//*Label 26969*/ GIMT_Encode4(2018370), // Rule ID 16039 //
     /* 2018273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2018290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018323 */     // MIs[1] Operand 1
     /* 2018323 */     // No operand predicates
     /* 2018323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018327 */     // MIs[0] round
     /* 2018327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018330 */     // MIs[0] policy
     /* 2018330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018369 */     // GIR_Coverage, 16039,
     /* 2018369 */     GIR_EraseRootFromParent_Done,
     /* 2018370 */   // Label 26969: @2018370
     /* 2018370 */   GIM_Try, /*On fail goto*//*Label 26970*/ GIMT_Encode4(2018472), // Rule ID 16042 //
     /* 2018375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018425 */     // MIs[1] Operand 1
     /* 2018425 */     // No operand predicates
     /* 2018425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018429 */     // MIs[0] round
     /* 2018429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018432 */     // MIs[0] policy
     /* 2018432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018444 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018471 */     // GIR_Coverage, 16042,
     /* 2018471 */     GIR_EraseRootFromParent_Done,
     /* 2018472 */   // Label 26970: @2018472
     /* 2018472 */   GIM_Try, /*On fail goto*//*Label 26971*/ GIMT_Encode4(2018574), // Rule ID 16043 //
     /* 2018477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2018494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018527 */     // MIs[1] Operand 1
     /* 2018527 */     // No operand predicates
     /* 2018527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018531 */     // MIs[0] round
     /* 2018531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018534 */     // MIs[0] policy
     /* 2018534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2018549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018573 */     // GIR_Coverage, 16043,
     /* 2018573 */     GIR_EraseRootFromParent_Done,
     /* 2018574 */   // Label 26971: @2018574
     /* 2018574 */   GIM_Try, /*On fail goto*//*Label 26972*/ GIMT_Encode4(2018676), // Rule ID 16046 //
     /* 2018579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2018590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2018593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2018596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018629 */     // MIs[1] Operand 1
     /* 2018629 */     // No operand predicates
     /* 2018629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018633 */     // MIs[0] round
     /* 2018633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018636 */     // MIs[0] policy
     /* 2018636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018648 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018675 */     // GIR_Coverage, 16046,
     /* 2018675 */     GIR_EraseRootFromParent_Done,
     /* 2018676 */   // Label 26972: @2018676
     /* 2018676 */   GIM_Try, /*On fail goto*//*Label 26973*/ GIMT_Encode4(2018778), // Rule ID 16047 //
     /* 2018681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2018692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2018695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2018698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2018704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2018711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018731 */     // MIs[1] Operand 1
     /* 2018731 */     // No operand predicates
     /* 2018731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018735 */     // MIs[0] round
     /* 2018735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018738 */     // MIs[0] policy
     /* 2018738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018750 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2018753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018777 */     // GIR_Coverage, 16047,
     /* 2018777 */     GIR_EraseRootFromParent_Done,
     /* 2018778 */   // Label 26973: @2018778
     /* 2018778 */   GIM_Try, /*On fail goto*//*Label 26974*/ GIMT_Encode4(2018880), // Rule ID 16050 //
     /* 2018783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2018794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2018797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018833 */     // MIs[1] Operand 1
     /* 2018833 */     // No operand predicates
     /* 2018833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018837 */     // MIs[0] round
     /* 2018837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018840 */     // MIs[0] policy
     /* 2018840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018879 */     // GIR_Coverage, 16050,
     /* 2018879 */     GIR_EraseRootFromParent_Done,
     /* 2018880 */   // Label 26974: @2018880
     /* 2018880 */   GIM_Try, /*On fail goto*//*Label 26975*/ GIMT_Encode4(2018982), // Rule ID 16051 //
     /* 2018885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2018896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2018899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018935 */     // MIs[1] Operand 1
     /* 2018935 */     // No operand predicates
     /* 2018935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018939 */     // MIs[0] round
     /* 2018939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018942 */     // MIs[0] policy
     /* 2018942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2018957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018981 */     // GIR_Coverage, 16051,
     /* 2018981 */     GIR_EraseRootFromParent_Done,
     /* 2018982 */   // Label 26975: @2018982
     /* 2018982 */   GIM_Try, /*On fail goto*//*Label 26976*/ GIMT_Encode4(2019084), // Rule ID 16054 //
     /* 2018987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2018995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2018998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019037 */     // MIs[1] Operand 1
     /* 2019037 */     // No operand predicates
     /* 2019037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019041 */     // MIs[0] round
     /* 2019041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019044 */     // MIs[0] policy
     /* 2019044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019056 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019083 */     // GIR_Coverage, 16054,
     /* 2019083 */     GIR_EraseRootFromParent_Done,
     /* 2019084 */   // Label 26976: @2019084
     /* 2019084 */   GIM_Try, /*On fail goto*//*Label 26977*/ GIMT_Encode4(2019186), // Rule ID 16055 //
     /* 2019089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2019106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019139 */     // MIs[1] Operand 1
     /* 2019139 */     // No operand predicates
     /* 2019139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019143 */     // MIs[0] round
     /* 2019143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019146 */     // MIs[0] policy
     /* 2019146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019185 */     // GIR_Coverage, 16055,
     /* 2019185 */     GIR_EraseRootFromParent_Done,
     /* 2019186 */   // Label 26977: @2019186
     /* 2019186 */   GIM_Try, /*On fail goto*//*Label 26978*/ GIMT_Encode4(2019288), // Rule ID 16058 //
     /* 2019191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2019194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019241 */     // MIs[1] Operand 1
     /* 2019241 */     // No operand predicates
     /* 2019241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019245 */     // MIs[0] round
     /* 2019245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019248 */     // MIs[0] policy
     /* 2019248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019260 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019287 */     // GIR_Coverage, 16058,
     /* 2019287 */     GIR_EraseRootFromParent_Done,
     /* 2019288 */   // Label 26978: @2019288
     /* 2019288 */   GIM_Try, /*On fail goto*//*Label 26979*/ GIMT_Encode4(2019390), // Rule ID 16059 //
     /* 2019293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2019296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2019304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2019307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2019310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2019316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019343 */     // MIs[1] Operand 1
     /* 2019343 */     // No operand predicates
     /* 2019343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019347 */     // MIs[0] round
     /* 2019347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019350 */     // MIs[0] policy
     /* 2019350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019362 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019389 */     // GIR_Coverage, 16059,
     /* 2019389 */     GIR_EraseRootFromParent_Done,
     /* 2019390 */   // Label 26979: @2019390
     /* 2019390 */   GIM_Try, /*On fail goto*//*Label 26980*/ GIMT_Encode4(2019492), // Rule ID 16062 //
     /* 2019395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2019398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019445 */     // MIs[1] Operand 1
     /* 2019445 */     // No operand predicates
     /* 2019445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019449 */     // MIs[0] round
     /* 2019449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019452 */     // MIs[0] policy
     /* 2019452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019491 */     // GIR_Coverage, 16062,
     /* 2019491 */     GIR_EraseRootFromParent_Done,
     /* 2019492 */   // Label 26980: @2019492
     /* 2019492 */   GIM_Try, /*On fail goto*//*Label 26981*/ GIMT_Encode4(2019594), // Rule ID 16063 //
     /* 2019497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2019500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2019508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2019511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019547 */     // MIs[1] Operand 1
     /* 2019547 */     // No operand predicates
     /* 2019547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019551 */     // MIs[0] round
     /* 2019551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019554 */     // MIs[0] policy
     /* 2019554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2019569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019593 */     // GIR_Coverage, 16063,
     /* 2019593 */     GIR_EraseRootFromParent_Done,
     /* 2019594 */   // Label 26981: @2019594
     /* 2019594 */   GIM_Try, /*On fail goto*//*Label 26982*/ GIMT_Encode4(2019696), // Rule ID 16066 //
     /* 2019599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2019602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2019610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2019613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2019616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019649 */     // MIs[1] Operand 1
     /* 2019649 */     // No operand predicates
     /* 2019649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019653 */     // MIs[0] round
     /* 2019653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019656 */     // MIs[0] policy
     /* 2019656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019668 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019695 */     // GIR_Coverage, 16066,
     /* 2019695 */     GIR_EraseRootFromParent_Done,
     /* 2019696 */   // Label 26982: @2019696
     /* 2019696 */   GIM_Try, /*On fail goto*//*Label 26983*/ GIMT_Encode4(2019798), // Rule ID 16067 //
     /* 2019701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2019704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2019712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2019715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2019718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019751 */     // MIs[1] Operand 1
     /* 2019751 */     // No operand predicates
     /* 2019751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019755 */     // MIs[0] round
     /* 2019755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019758 */     // MIs[0] policy
     /* 2019758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2019773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019797 */     // GIR_Coverage, 16067,
     /* 2019797 */     GIR_EraseRootFromParent_Done,
     /* 2019798 */   // Label 26983: @2019798
     /* 2019798 */   GIM_Try, /*On fail goto*//*Label 26984*/ GIMT_Encode4(2019900), // Rule ID 16070 //
     /* 2019803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2019806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2019814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2019817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2019820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019853 */     // MIs[1] Operand 1
     /* 2019853 */     // No operand predicates
     /* 2019853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019857 */     // MIs[0] round
     /* 2019857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019860 */     // MIs[0] policy
     /* 2019860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019872 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019899 */     // GIR_Coverage, 16070,
     /* 2019899 */     GIR_EraseRootFromParent_Done,
     /* 2019900 */   // Label 26984: @2019900
     /* 2019900 */   GIM_Try, /*On fail goto*//*Label 26985*/ GIMT_Encode4(2020002), // Rule ID 16071 //
     /* 2019905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2019908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2019913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2019916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2019919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2019922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2019935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019955 */     // MIs[1] Operand 1
     /* 2019955 */     // No operand predicates
     /* 2019955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019959 */     // MIs[0] round
     /* 2019959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019962 */     // MIs[0] policy
     /* 2019962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2019977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2019998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020001 */     // GIR_Coverage, 16071,
     /* 2020001 */     GIR_EraseRootFromParent_Done,
     /* 2020002 */   // Label 26985: @2020002
     /* 2020002 */   GIM_Try, /*On fail goto*//*Label 26986*/ GIMT_Encode4(2020104), // Rule ID 16250 //
     /* 2020007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2020024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020057 */     // MIs[1] Operand 1
     /* 2020057 */     // No operand predicates
     /* 2020057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020061 */     // MIs[0] round
     /* 2020061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020064 */     // MIs[0] policy
     /* 2020064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020076 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2020079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020103 */     // GIR_Coverage, 16250,
     /* 2020103 */     GIR_EraseRootFromParent_Done,
     /* 2020104 */   // Label 26986: @2020104
     /* 2020104 */   GIM_Try, /*On fail goto*//*Label 26987*/ GIMT_Encode4(2020206), // Rule ID 16251 //
     /* 2020109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2020120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2020123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2020126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020159 */     // MIs[1] Operand 1
     /* 2020159 */     // No operand predicates
     /* 2020159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020163 */     // MIs[0] round
     /* 2020163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020166 */     // MIs[0] policy
     /* 2020166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020178 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2020181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020205 */     // GIR_Coverage, 16251,
     /* 2020205 */     GIR_EraseRootFromParent_Done,
     /* 2020206 */   // Label 26987: @2020206
     /* 2020206 */   GIM_Try, /*On fail goto*//*Label 26988*/ GIMT_Encode4(2020308), // Rule ID 16254 //
     /* 2020211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2020222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2020225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2020228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020261 */     // MIs[1] Operand 1
     /* 2020261 */     // No operand predicates
     /* 2020261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020265 */     // MIs[0] round
     /* 2020265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020268 */     // MIs[0] policy
     /* 2020268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020280 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020307 */     // GIR_Coverage, 16254,
     /* 2020307 */     GIR_EraseRootFromParent_Done,
     /* 2020308 */   // Label 26988: @2020308
     /* 2020308 */   GIM_Try, /*On fail goto*//*Label 26989*/ GIMT_Encode4(2020410), // Rule ID 16255 //
     /* 2020313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2020324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2020327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2020330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020363 */     // MIs[1] Operand 1
     /* 2020363 */     // No operand predicates
     /* 2020363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020367 */     // MIs[0] round
     /* 2020367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020370 */     // MIs[0] policy
     /* 2020370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020409 */     // GIR_Coverage, 16255,
     /* 2020409 */     GIR_EraseRootFromParent_Done,
     /* 2020410 */   // Label 26989: @2020410
     /* 2020410 */   GIM_Try, /*On fail goto*//*Label 26990*/ GIMT_Encode4(2020512), // Rule ID 16258 //
     /* 2020415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2020426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2020429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2020432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020465 */     // MIs[1] Operand 1
     /* 2020465 */     // No operand predicates
     /* 2020465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020469 */     // MIs[0] round
     /* 2020469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020472 */     // MIs[0] policy
     /* 2020472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020484 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2020487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020511 */     // GIR_Coverage, 16258,
     /* 2020511 */     GIR_EraseRootFromParent_Done,
     /* 2020512 */   // Label 26990: @2020512
     /* 2020512 */   GIM_Try, /*On fail goto*//*Label 26991*/ GIMT_Encode4(2020614), // Rule ID 16259 //
     /* 2020517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2020528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2020531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2020534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020567 */     // MIs[1] Operand 1
     /* 2020567 */     // No operand predicates
     /* 2020567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020571 */     // MIs[0] round
     /* 2020571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020574 */     // MIs[0] policy
     /* 2020574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020586 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2020589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2020610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020613 */     // GIR_Coverage, 16259,
     /* 2020613 */     GIR_EraseRootFromParent_Done,
     /* 2020614 */   // Label 26991: @2020614
     /* 2020614 */   GIM_Try, /*On fail goto*//*Label 26992*/ GIMT_Encode4(2020716), // Rule ID 16262 //
     /* 2020619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2020630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2020633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2020636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020669 */     // MIs[1] Operand 1
     /* 2020669 */     // No operand predicates
     /* 2020669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020673 */     // MIs[0] round
     /* 2020673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020676 */     // MIs[0] policy
     /* 2020676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020688 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020715 */     // GIR_Coverage, 16262,
     /* 2020715 */     GIR_EraseRootFromParent_Done,
     /* 2020716 */   // Label 26992: @2020716
     /* 2020716 */   GIM_Try, /*On fail goto*//*Label 26993*/ GIMT_Encode4(2020818), // Rule ID 16263 //
     /* 2020721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2020732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2020735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2020738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020771 */     // MIs[1] Operand 1
     /* 2020771 */     // No operand predicates
     /* 2020771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020775 */     // MIs[0] round
     /* 2020775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020778 */     // MIs[0] policy
     /* 2020778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2020793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020817 */     // GIR_Coverage, 16263,
     /* 2020817 */     GIR_EraseRootFromParent_Done,
     /* 2020818 */   // Label 26993: @2020818
     /* 2020818 */   GIM_Try, /*On fail goto*//*Label 26994*/ GIMT_Encode4(2020920), // Rule ID 16266 //
     /* 2020823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2020826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2020834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2020837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2020840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2020843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020873 */     // MIs[1] Operand 1
     /* 2020873 */     // No operand predicates
     /* 2020873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020877 */     // MIs[0] round
     /* 2020877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020880 */     // MIs[0] policy
     /* 2020880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020892 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2020895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2020901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2020904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020919 */     // GIR_Coverage, 16266,
     /* 2020919 */     GIR_EraseRootFromParent_Done,
     /* 2020920 */   // Label 26994: @2020920
     /* 2020920 */   GIM_Try, /*On fail goto*//*Label 26995*/ GIMT_Encode4(2021022), // Rule ID 16267 //
     /* 2020925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2020928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2020933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2020936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2020939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2020942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2020945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2020967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2020971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2020975 */     // MIs[1] Operand 1
     /* 2020975 */     // No operand predicates
     /* 2020975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020979 */     // MIs[0] round
     /* 2020979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020982 */     // MIs[0] policy
     /* 2020982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2020987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020994 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2020997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021021 */     // GIR_Coverage, 16267,
     /* 2021021 */     GIR_EraseRootFromParent_Done,
     /* 2021022 */   // Label 26995: @2021022
     /* 2021022 */   GIM_Try, /*On fail goto*//*Label 26996*/ GIMT_Encode4(2021124), // Rule ID 16270 //
     /* 2021027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021077 */     // MIs[1] Operand 1
     /* 2021077 */     // No operand predicates
     /* 2021077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021081 */     // MIs[0] round
     /* 2021081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021084 */     // MIs[0] policy
     /* 2021084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021096 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021123 */     // GIR_Coverage, 16270,
     /* 2021123 */     GIR_EraseRootFromParent_Done,
     /* 2021124 */   // Label 26996: @2021124
     /* 2021124 */   GIM_Try, /*On fail goto*//*Label 26997*/ GIMT_Encode4(2021226), // Rule ID 16271 //
     /* 2021129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2021146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021179 */     // MIs[1] Operand 1
     /* 2021179 */     // No operand predicates
     /* 2021179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021183 */     // MIs[0] round
     /* 2021183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021186 */     // MIs[0] policy
     /* 2021186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021198 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2021201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021225 */     // GIR_Coverage, 16271,
     /* 2021225 */     GIR_EraseRootFromParent_Done,
     /* 2021226 */   // Label 26997: @2021226
     /* 2021226 */   GIM_Try, /*On fail goto*//*Label 26998*/ GIMT_Encode4(2021328), // Rule ID 16274 //
     /* 2021231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2021248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021281 */     // MIs[1] Operand 1
     /* 2021281 */     // No operand predicates
     /* 2021281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021285 */     // MIs[0] round
     /* 2021285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021288 */     // MIs[0] policy
     /* 2021288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021327 */     // GIR_Coverage, 16274,
     /* 2021327 */     GIR_EraseRootFromParent_Done,
     /* 2021328 */   // Label 26998: @2021328
     /* 2021328 */   GIM_Try, /*On fail goto*//*Label 26999*/ GIMT_Encode4(2021430), // Rule ID 16275 //
     /* 2021333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2021344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2021347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2021350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021383 */     // MIs[1] Operand 1
     /* 2021383 */     // No operand predicates
     /* 2021383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021387 */     // MIs[0] round
     /* 2021387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021390 */     // MIs[0] policy
     /* 2021390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021402 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2021426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021429 */     // GIR_Coverage, 16275,
     /* 2021429 */     GIR_EraseRootFromParent_Done,
     /* 2021430 */   // Label 26999: @2021430
     /* 2021430 */   GIM_Try, /*On fail goto*//*Label 27000*/ GIMT_Encode4(2021532), // Rule ID 16278 //
     /* 2021435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2021446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2021449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2021452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021485 */     // MIs[1] Operand 1
     /* 2021485 */     // No operand predicates
     /* 2021485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021489 */     // MIs[0] round
     /* 2021489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021492 */     // MIs[0] policy
     /* 2021492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021504 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021531 */     // GIR_Coverage, 16278,
     /* 2021531 */     GIR_EraseRootFromParent_Done,
     /* 2021532 */   // Label 27000: @2021532
     /* 2021532 */   GIM_Try, /*On fail goto*//*Label 27001*/ GIMT_Encode4(2021634), // Rule ID 16279 //
     /* 2021537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2021548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2021551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2021554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021587 */     // MIs[1] Operand 1
     /* 2021587 */     // No operand predicates
     /* 2021587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021591 */     // MIs[0] round
     /* 2021591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021594 */     // MIs[0] policy
     /* 2021594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021633 */     // GIR_Coverage, 16279,
     /* 2021633 */     GIR_EraseRootFromParent_Done,
     /* 2021634 */   // Label 27001: @2021634
     /* 2021634 */   GIM_Try, /*On fail goto*//*Label 27002*/ GIMT_Encode4(2021736), // Rule ID 16282 //
     /* 2021639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2021642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2021656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021689 */     // MIs[1] Operand 1
     /* 2021689 */     // No operand predicates
     /* 2021689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021693 */     // MIs[0] round
     /* 2021693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021696 */     // MIs[0] policy
     /* 2021696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021735 */     // GIR_Coverage, 16282,
     /* 2021735 */     GIR_EraseRootFromParent_Done,
     /* 2021736 */   // Label 27002: @2021736
     /* 2021736 */   GIM_Try, /*On fail goto*//*Label 27003*/ GIMT_Encode4(2021838), // Rule ID 16283 //
     /* 2021741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2021744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2021758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021791 */     // MIs[1] Operand 1
     /* 2021791 */     // No operand predicates
     /* 2021791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021795 */     // MIs[0] round
     /* 2021795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021798 */     // MIs[0] policy
     /* 2021798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021837 */     // GIR_Coverage, 16283,
     /* 2021837 */     GIR_EraseRootFromParent_Done,
     /* 2021838 */   // Label 27003: @2021838
     /* 2021838 */   GIM_Try, /*On fail goto*//*Label 27004*/ GIMT_Encode4(2021940), // Rule ID 16286 //
     /* 2021843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2021846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2021854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2021857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2021860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2021863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021893 */     // MIs[1] Operand 1
     /* 2021893 */     // No operand predicates
     /* 2021893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021897 */     // MIs[0] round
     /* 2021897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021900 */     // MIs[0] policy
     /* 2021900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2021905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021912 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2021915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2021921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2021924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2021936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021939 */     // GIR_Coverage, 16286,
     /* 2021939 */     GIR_EraseRootFromParent_Done,
     /* 2021940 */   // Label 27004: @2021940
     /* 2021940 */   GIM_Try, /*On fail goto*//*Label 27005*/ GIMT_Encode4(2022042), // Rule ID 16287 //
     /* 2021945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2021948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2021953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2021956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2021959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2021962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2021965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2021987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2021991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2021995 */     // MIs[1] Operand 1
     /* 2021995 */     // No operand predicates
     /* 2021995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021999 */     // MIs[0] round
     /* 2021999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022002 */     // MIs[0] policy
     /* 2022002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2022017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2022038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022041 */     // GIR_Coverage, 16287,
     /* 2022041 */     GIR_EraseRootFromParent_Done,
     /* 2022042 */   // Label 27005: @2022042
     /* 2022042 */   GIM_Try, /*On fail goto*//*Label 27006*/ GIMT_Encode4(2022144), // Rule ID 16290 //
     /* 2022047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2022058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2022061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2022064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022097 */     // MIs[1] Operand 1
     /* 2022097 */     // No operand predicates
     /* 2022097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022101 */     // MIs[0] round
     /* 2022101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022104 */     // MIs[0] policy
     /* 2022104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022116 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022143 */     // GIR_Coverage, 16290,
     /* 2022143 */     GIR_EraseRootFromParent_Done,
     /* 2022144 */   // Label 27006: @2022144
     /* 2022144 */   GIM_Try, /*On fail goto*//*Label 27007*/ GIMT_Encode4(2022246), // Rule ID 16291 //
     /* 2022149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2022160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2022163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2022166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022199 */     // MIs[1] Operand 1
     /* 2022199 */     // No operand predicates
     /* 2022199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022203 */     // MIs[0] round
     /* 2022203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022206 */     // MIs[0] policy
     /* 2022206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022245 */     // GIR_Coverage, 16291,
     /* 2022245 */     GIR_EraseRootFromParent_Done,
     /* 2022246 */   // Label 27007: @2022246
     /* 2022246 */   GIM_Try, /*On fail goto*//*Label 27008*/ GIMT_Encode4(2022348), // Rule ID 16294 //
     /* 2022251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2022262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2022265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2022268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022301 */     // MIs[1] Operand 1
     /* 2022301 */     // No operand predicates
     /* 2022301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022305 */     // MIs[0] round
     /* 2022305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022308 */     // MIs[0] policy
     /* 2022308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022320 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022347 */     // GIR_Coverage, 16294,
     /* 2022347 */     GIR_EraseRootFromParent_Done,
     /* 2022348 */   // Label 27008: @2022348
     /* 2022348 */   GIM_Try, /*On fail goto*//*Label 27009*/ GIMT_Encode4(2022450), // Rule ID 16295 //
     /* 2022353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2022364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2022367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2022370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2022376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022403 */     // MIs[1] Operand 1
     /* 2022403 */     // No operand predicates
     /* 2022403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022407 */     // MIs[0] round
     /* 2022407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022410 */     // MIs[0] policy
     /* 2022410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022422 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022449 */     // GIR_Coverage, 16295,
     /* 2022449 */     GIR_EraseRootFromParent_Done,
     /* 2022450 */   // Label 27009: @2022450
     /* 2022450 */   GIM_Try, /*On fail goto*//*Label 27010*/ GIMT_Encode4(2022552), // Rule ID 16298 //
     /* 2022455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2022466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2022469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2022472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2022478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022505 */     // MIs[1] Operand 1
     /* 2022505 */     // No operand predicates
     /* 2022505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022509 */     // MIs[0] round
     /* 2022509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022512 */     // MIs[0] policy
     /* 2022512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022524 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2022527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022551 */     // GIR_Coverage, 16298,
     /* 2022551 */     GIR_EraseRootFromParent_Done,
     /* 2022552 */   // Label 27010: @2022552
     /* 2022552 */   GIM_Try, /*On fail goto*//*Label 27011*/ GIMT_Encode4(2022654), // Rule ID 16299 //
     /* 2022557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2022568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2022571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2022574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2022580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022607 */     // MIs[1] Operand 1
     /* 2022607 */     // No operand predicates
     /* 2022607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022611 */     // MIs[0] round
     /* 2022611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022614 */     // MIs[0] policy
     /* 2022614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022626 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2022629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022653 */     // GIR_Coverage, 16299,
     /* 2022653 */     GIR_EraseRootFromParent_Done,
     /* 2022654 */   // Label 27011: @2022654
     /* 2022654 */   GIM_Try, /*On fail goto*//*Label 27012*/ GIMT_Encode4(2022756), // Rule ID 16302 //
     /* 2022659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2022670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2022673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2022676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022709 */     // MIs[1] Operand 1
     /* 2022709 */     // No operand predicates
     /* 2022709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022713 */     // MIs[0] round
     /* 2022713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022716 */     // MIs[0] policy
     /* 2022716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022755 */     // GIR_Coverage, 16302,
     /* 2022755 */     GIR_EraseRootFromParent_Done,
     /* 2022756 */   // Label 27012: @2022756
     /* 2022756 */   GIM_Try, /*On fail goto*//*Label 27013*/ GIMT_Encode4(2022858), // Rule ID 16303 //
     /* 2022761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2022772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2022775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2022778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022811 */     // MIs[1] Operand 1
     /* 2022811 */     // No operand predicates
     /* 2022811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022815 */     // MIs[0] round
     /* 2022815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022818 */     // MIs[0] policy
     /* 2022818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2022833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022857 */     // GIR_Coverage, 16303,
     /* 2022857 */     GIR_EraseRootFromParent_Done,
     /* 2022858 */   // Label 27013: @2022858
     /* 2022858 */   GIM_Try, /*On fail goto*//*Label 27014*/ GIMT_Encode4(2022960), // Rule ID 16306 //
     /* 2022863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2022874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2022877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2022880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2022883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2022905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2022909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2022913 */     // MIs[1] Operand 1
     /* 2022913 */     // No operand predicates
     /* 2022913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022917 */     // MIs[0] round
     /* 2022917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022920 */     // MIs[0] policy
     /* 2022920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2022925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022932 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2022935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2022944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022959 */     // GIR_Coverage, 16306,
     /* 2022959 */     GIR_EraseRootFromParent_Done,
     /* 2022960 */   // Label 27014: @2022960
     /* 2022960 */   GIM_Try, /*On fail goto*//*Label 27015*/ GIMT_Encode4(2023062), // Rule ID 16307 //
     /* 2022965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2022973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2022976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2022979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2022982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2022985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2022988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023015 */     // MIs[1] Operand 1
     /* 2023015 */     // No operand predicates
     /* 2023015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023019 */     // MIs[0] round
     /* 2023019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023022 */     // MIs[0] policy
     /* 2023022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023061 */     // GIR_Coverage, 16307,
     /* 2023061 */     GIR_EraseRootFromParent_Done,
     /* 2023062 */   // Label 27015: @2023062
     /* 2023062 */   GIM_Try, /*On fail goto*//*Label 27016*/ GIMT_Encode4(2023164), // Rule ID 16310 //
     /* 2023067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2023078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2023081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2023084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2023090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023117 */     // MIs[1] Operand 1
     /* 2023117 */     // No operand predicates
     /* 2023117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023121 */     // MIs[0] round
     /* 2023121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023124 */     // MIs[0] policy
     /* 2023124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023136 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023163 */     // GIR_Coverage, 16310,
     /* 2023163 */     GIR_EraseRootFromParent_Done,
     /* 2023164 */   // Label 27016: @2023164
     /* 2023164 */   GIM_Try, /*On fail goto*//*Label 27017*/ GIMT_Encode4(2023266), // Rule ID 16311 //
     /* 2023169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2023180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2023183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2023186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2023192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023219 */     // MIs[1] Operand 1
     /* 2023219 */     // No operand predicates
     /* 2023219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023223 */     // MIs[0] round
     /* 2023223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023226 */     // MIs[0] policy
     /* 2023226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023238 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023265 */     // GIR_Coverage, 16311,
     /* 2023265 */     GIR_EraseRootFromParent_Done,
     /* 2023266 */   // Label 27017: @2023266
     /* 2023266 */   GIM_Try, /*On fail goto*//*Label 27018*/ GIMT_Encode4(2023368), // Rule ID 16314 //
     /* 2023271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2023288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023321 */     // MIs[1] Operand 1
     /* 2023321 */     // No operand predicates
     /* 2023321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023325 */     // MIs[0] round
     /* 2023325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023328 */     // MIs[0] policy
     /* 2023328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023367 */     // GIR_Coverage, 16314,
     /* 2023367 */     GIR_EraseRootFromParent_Done,
     /* 2023368 */   // Label 27018: @2023368
     /* 2023368 */   GIM_Try, /*On fail goto*//*Label 27019*/ GIMT_Encode4(2023470), // Rule ID 16315 //
     /* 2023373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2023384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2023387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2023390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023423 */     // MIs[1] Operand 1
     /* 2023423 */     // No operand predicates
     /* 2023423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023427 */     // MIs[0] round
     /* 2023427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023430 */     // MIs[0] policy
     /* 2023430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023469 */     // GIR_Coverage, 16315,
     /* 2023469 */     GIR_EraseRootFromParent_Done,
     /* 2023470 */   // Label 27019: @2023470
     /* 2023470 */   GIM_Try, /*On fail goto*//*Label 27020*/ GIMT_Encode4(2023572), // Rule ID 16318 //
     /* 2023475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2023486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2023489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2023492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023525 */     // MIs[1] Operand 1
     /* 2023525 */     // No operand predicates
     /* 2023525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023529 */     // MIs[0] round
     /* 2023529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023532 */     // MIs[0] policy
     /* 2023532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023544 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023571 */     // GIR_Coverage, 16318,
     /* 2023571 */     GIR_EraseRootFromParent_Done,
     /* 2023572 */   // Label 27020: @2023572
     /* 2023572 */   GIM_Try, /*On fail goto*//*Label 27021*/ GIMT_Encode4(2023674), // Rule ID 16319 //
     /* 2023577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2023588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2023591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2023594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2023600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2023607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2023615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023627 */     // MIs[1] Operand 1
     /* 2023627 */     // No operand predicates
     /* 2023627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023631 */     // MIs[0] round
     /* 2023631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023634 */     // MIs[0] policy
     /* 2023634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2023649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023673 */     // GIR_Coverage, 16319,
     /* 2023673 */     GIR_EraseRootFromParent_Done,
     /* 2023674 */   // Label 27021: @2023674
     /* 2023674 */   GIM_Try, /*On fail goto*//*Label 27022*/ GIMT_Encode4(2023776), // Rule ID 16322 //
     /* 2023679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2023690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2023693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2023696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023729 */     // MIs[1] Operand 1
     /* 2023729 */     // No operand predicates
     /* 2023729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023733 */     // MIs[0] round
     /* 2023733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023736 */     // MIs[0] policy
     /* 2023736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023748 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023775 */     // GIR_Coverage, 16322,
     /* 2023775 */     GIR_EraseRootFromParent_Done,
     /* 2023776 */   // Label 27022: @2023776
     /* 2023776 */   GIM_Try, /*On fail goto*//*Label 27023*/ GIMT_Encode4(2023878), // Rule ID 16323 //
     /* 2023781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2023792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2023795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2023798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2023801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2023804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2023811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2023819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023831 */     // MIs[1] Operand 1
     /* 2023831 */     // No operand predicates
     /* 2023831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023835 */     // MIs[0] round
     /* 2023835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023838 */     // MIs[0] policy
     /* 2023838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023850 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2023853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2023874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023877 */     // GIR_Coverage, 16323,
     /* 2023877 */     GIR_EraseRootFromParent_Done,
     /* 2023878 */   // Label 27023: @2023878
     /* 2023878 */   GIM_Try, /*On fail goto*//*Label 27024*/ GIMT_Encode4(2023980), // Rule ID 16326 //
     /* 2023883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2023886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2023894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2023897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2023900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2023903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2023913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2023921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2023925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2023929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2023933 */     // MIs[1] Operand 1
     /* 2023933 */     // No operand predicates
     /* 2023933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023937 */     // MIs[0] round
     /* 2023937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023940 */     // MIs[0] policy
     /* 2023940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2023945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023952 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2023955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2023964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2023976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023979 */     // GIR_Coverage, 16326,
     /* 2023979 */     GIR_EraseRootFromParent_Done,
     /* 2023980 */   // Label 27024: @2023980
     /* 2023980 */   GIM_Try, /*On fail goto*//*Label 27025*/ GIMT_Encode4(2024082), // Rule ID 16327 //
     /* 2023985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2023988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2023993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2023996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2023999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2024002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024035 */     // MIs[1] Operand 1
     /* 2024035 */     // No operand predicates
     /* 2024035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024039 */     // MIs[0] round
     /* 2024039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024042 */     // MIs[0] policy
     /* 2024042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2024057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024081 */     // GIR_Coverage, 16327,
     /* 2024081 */     GIR_EraseRootFromParent_Done,
     /* 2024082 */   // Label 27025: @2024082
     /* 2024082 */   GIM_Try, /*On fail goto*//*Label 27026*/ GIMT_Encode4(2024184), // Rule ID 16330 //
     /* 2024087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2024098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2024101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2024104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024137 */     // MIs[1] Operand 1
     /* 2024137 */     // No operand predicates
     /* 2024137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024141 */     // MIs[0] round
     /* 2024141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024144 */     // MIs[0] policy
     /* 2024144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024156 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024183 */     // GIR_Coverage, 16330,
     /* 2024183 */     GIR_EraseRootFromParent_Done,
     /* 2024184 */   // Label 27026: @2024184
     /* 2024184 */   GIM_Try, /*On fail goto*//*Label 27027*/ GIMT_Encode4(2024286), // Rule ID 16331 //
     /* 2024189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2024200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2024203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2024206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2024219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2024227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024239 */     // MIs[1] Operand 1
     /* 2024239 */     // No operand predicates
     /* 2024239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024243 */     // MIs[0] round
     /* 2024243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024246 */     // MIs[0] policy
     /* 2024246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024258 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2024261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024285 */     // GIR_Coverage, 16331,
     /* 2024285 */     GIR_EraseRootFromParent_Done,
     /* 2024286 */   // Label 27027: @2024286
     /* 2024286 */   GIM_Try, /*On fail goto*//*Label 27028*/ GIMT_Encode4(2024388), // Rule ID 16334 //
     /* 2024291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2024302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2024305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2024308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024341 */     // MIs[1] Operand 1
     /* 2024341 */     // No operand predicates
     /* 2024341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024345 */     // MIs[0] round
     /* 2024345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024348 */     // MIs[0] policy
     /* 2024348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024360 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024387 */     // GIR_Coverage, 16334,
     /* 2024387 */     GIR_EraseRootFromParent_Done,
     /* 2024388 */   // Label 27028: @2024388
     /* 2024388 */   GIM_Try, /*On fail goto*//*Label 27029*/ GIMT_Encode4(2024490), // Rule ID 16335 //
     /* 2024393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2024401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2024404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2024407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2024410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2024423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2024431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024443 */     // MIs[1] Operand 1
     /* 2024443 */     // No operand predicates
     /* 2024443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024447 */     // MIs[0] round
     /* 2024447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024450 */     // MIs[0] policy
     /* 2024450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024462 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2024465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024489 */     // GIR_Coverage, 16335,
     /* 2024489 */     GIR_EraseRootFromParent_Done,
     /* 2024490 */   // Label 27029: @2024490
     /* 2024490 */   GIM_Try, /*On fail goto*//*Label 27030*/ GIMT_Encode4(2024595), // Rule ID 16458 //
     /* 2024495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2024506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2024509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2024512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024545 */     // MIs[1] Operand 1
     /* 2024545 */     // No operand predicates
     /* 2024545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024549 */     // MIs[0] round
     /* 2024549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024552 */     // MIs[0] policy
     /* 2024552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2024567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2024593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024594 */     // GIR_Coverage, 16458,
     /* 2024594 */     GIR_EraseRootFromParent_Done,
     /* 2024595 */   // Label 27030: @2024595
     /* 2024595 */   GIM_Try, /*On fail goto*//*Label 27031*/ GIMT_Encode4(2024700), // Rule ID 16459 //
     /* 2024600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2024611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2024614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2024617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024646 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024650 */     // MIs[1] Operand 1
     /* 2024650 */     // No operand predicates
     /* 2024650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024654 */     // MIs[0] round
     /* 2024654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024657 */     // MIs[0] policy
     /* 2024657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024669 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2024672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2024698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024699 */     // GIR_Coverage, 16459,
     /* 2024699 */     GIR_EraseRootFromParent_Done,
     /* 2024700 */   // Label 27031: @2024700
     /* 2024700 */   GIM_Try, /*On fail goto*//*Label 27032*/ GIMT_Encode4(2024805), // Rule ID 16462 //
     /* 2024705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2024716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2024719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2024722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024755 */     // MIs[1] Operand 1
     /* 2024755 */     // No operand predicates
     /* 2024755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024759 */     // MIs[0] round
     /* 2024759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024762 */     // MIs[0] policy
     /* 2024762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024774 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2024777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2024803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024804 */     // GIR_Coverage, 16462,
     /* 2024804 */     GIR_EraseRootFromParent_Done,
     /* 2024805 */   // Label 27032: @2024805
     /* 2024805 */   GIM_Try, /*On fail goto*//*Label 27033*/ GIMT_Encode4(2024910), // Rule ID 16463 //
     /* 2024810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2024821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2024824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2024827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2024830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024860 */     // MIs[1] Operand 1
     /* 2024860 */     // No operand predicates
     /* 2024860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024864 */     // MIs[0] round
     /* 2024864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024867 */     // MIs[0] policy
     /* 2024867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024879 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2024882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2024908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024909 */     // GIR_Coverage, 16463,
     /* 2024909 */     GIR_EraseRootFromParent_Done,
     /* 2024910 */   // Label 27033: @2024910
     /* 2024910 */   GIM_Try, /*On fail goto*//*Label 27034*/ GIMT_Encode4(2025015), // Rule ID 16466 //
     /* 2024915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2024923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2024926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2024929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2024932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2024935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2024957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2024961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2024965 */     // MIs[1] Operand 1
     /* 2024965 */     // No operand predicates
     /* 2024965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024969 */     // MIs[0] round
     /* 2024969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024972 */     // MIs[0] policy
     /* 2024972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2024977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024984 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2024987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2024996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025014 */     // GIR_Coverage, 16466,
     /* 2025014 */     GIR_EraseRootFromParent_Done,
     /* 2025015 */   // Label 27034: @2025015
     /* 2025015 */   GIM_Try, /*On fail goto*//*Label 27035*/ GIMT_Encode4(2025120), // Rule ID 16467 //
     /* 2025020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2025031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2025034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2025037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025070 */     // MIs[1] Operand 1
     /* 2025070 */     // No operand predicates
     /* 2025070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025074 */     // MIs[0] round
     /* 2025074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025077 */     // MIs[0] policy
     /* 2025077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025089 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2025092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025119 */     // GIR_Coverage, 16467,
     /* 2025119 */     GIR_EraseRootFromParent_Done,
     /* 2025120 */   // Label 27035: @2025120
     /* 2025120 */   GIM_Try, /*On fail goto*//*Label 27036*/ GIMT_Encode4(2025225), // Rule ID 16470 //
     /* 2025125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025175 */     // MIs[1] Operand 1
     /* 2025175 */     // No operand predicates
     /* 2025175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025179 */     // MIs[0] round
     /* 2025179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025182 */     // MIs[0] policy
     /* 2025182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025194 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2025197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025224 */     // GIR_Coverage, 16470,
     /* 2025224 */     GIR_EraseRootFromParent_Done,
     /* 2025225 */   // Label 27036: @2025225
     /* 2025225 */   GIM_Try, /*On fail goto*//*Label 27037*/ GIMT_Encode4(2025330), // Rule ID 16471 //
     /* 2025230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2025241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2025244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025280 */     // MIs[1] Operand 1
     /* 2025280 */     // No operand predicates
     /* 2025280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025284 */     // MIs[0] round
     /* 2025284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025287 */     // MIs[0] policy
     /* 2025287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025299 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2025302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025329 */     // GIR_Coverage, 16471,
     /* 2025329 */     GIR_EraseRootFromParent_Done,
     /* 2025330 */   // Label 27037: @2025330
     /* 2025330 */   GIM_Try, /*On fail goto*//*Label 27038*/ GIMT_Encode4(2025435), // Rule ID 16474 //
     /* 2025335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2025346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2025349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025385 */     // MIs[1] Operand 1
     /* 2025385 */     // No operand predicates
     /* 2025385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025389 */     // MIs[0] round
     /* 2025389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025392 */     // MIs[0] policy
     /* 2025392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025404 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2025407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025434 */     // GIR_Coverage, 16474,
     /* 2025434 */     GIR_EraseRootFromParent_Done,
     /* 2025435 */   // Label 27038: @2025435
     /* 2025435 */   GIM_Try, /*On fail goto*//*Label 27039*/ GIMT_Encode4(2025540), // Rule ID 16475 //
     /* 2025440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2025451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2025454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025486 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025490 */     // MIs[1] Operand 1
     /* 2025490 */     // No operand predicates
     /* 2025490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025494 */     // MIs[0] round
     /* 2025494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025497 */     // MIs[0] policy
     /* 2025497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025509 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2025512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025539 */     // GIR_Coverage, 16475,
     /* 2025539 */     GIR_EraseRootFromParent_Done,
     /* 2025540 */   // Label 27039: @2025540
     /* 2025540 */   GIM_Try, /*On fail goto*//*Label 27040*/ GIMT_Encode4(2025645), // Rule ID 16478 //
     /* 2025545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2025556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2025559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2025562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2025568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025595 */     // MIs[1] Operand 1
     /* 2025595 */     // No operand predicates
     /* 2025595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025599 */     // MIs[0] round
     /* 2025599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025602 */     // MIs[0] policy
     /* 2025602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025614 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2025617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025644 */     // GIR_Coverage, 16478,
     /* 2025644 */     GIR_EraseRootFromParent_Done,
     /* 2025645 */   // Label 27040: @2025645
     /* 2025645 */   GIM_Try, /*On fail goto*//*Label 27041*/ GIMT_Encode4(2025750), // Rule ID 16479 //
     /* 2025650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2025661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2025664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2025667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2025673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025700 */     // MIs[1] Operand 1
     /* 2025700 */     // No operand predicates
     /* 2025700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025704 */     // MIs[0] round
     /* 2025704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025707 */     // MIs[0] policy
     /* 2025707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025719 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2025722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025749 */     // GIR_Coverage, 16479,
     /* 2025749 */     GIR_EraseRootFromParent_Done,
     /* 2025750 */   // Label 27041: @2025750
     /* 2025750 */   GIM_Try, /*On fail goto*//*Label 27042*/ GIMT_Encode4(2025855), // Rule ID 16482 //
     /* 2025755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2025766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2025769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2025772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025805 */     // MIs[1] Operand 1
     /* 2025805 */     // No operand predicates
     /* 2025805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025809 */     // MIs[0] round
     /* 2025809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025812 */     // MIs[0] policy
     /* 2025812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025824 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2025827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025854 */     // GIR_Coverage, 16482,
     /* 2025854 */     GIR_EraseRootFromParent_Done,
     /* 2025855 */   // Label 27042: @2025855
     /* 2025855 */   GIM_Try, /*On fail goto*//*Label 27043*/ GIMT_Encode4(2025960), // Rule ID 16483 //
     /* 2025860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2025871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2025874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2025877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2025880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2025883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2025902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2025906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2025910 */     // MIs[1] Operand 1
     /* 2025910 */     // No operand predicates
     /* 2025910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025914 */     // MIs[0] round
     /* 2025914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025917 */     // MIs[0] policy
     /* 2025917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2025922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025929 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2025932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2025941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2025958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025959 */     // GIR_Coverage, 16483,
     /* 2025959 */     GIR_EraseRootFromParent_Done,
     /* 2025960 */   // Label 27043: @2025960
     /* 2025960 */   GIM_Try, /*On fail goto*//*Label 27044*/ GIMT_Encode4(2026065), // Rule ID 16486 //
     /* 2025965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2025973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2025976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2025979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2025982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2025985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2025988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2025995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2025999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026015 */     // MIs[1] Operand 1
     /* 2026015 */     // No operand predicates
     /* 2026015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026019 */     // MIs[0] round
     /* 2026019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026022 */     // MIs[0] policy
     /* 2026022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026064 */     // GIR_Coverage, 16486,
     /* 2026064 */     GIR_EraseRootFromParent_Done,
     /* 2026065 */   // Label 27044: @2026065
     /* 2026065 */   GIM_Try, /*On fail goto*//*Label 27045*/ GIMT_Encode4(2026170), // Rule ID 16487 //
     /* 2026070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2026081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2026084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2026087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026120 */     // MIs[1] Operand 1
     /* 2026120 */     // No operand predicates
     /* 2026120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026124 */     // MIs[0] round
     /* 2026124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026127 */     // MIs[0] policy
     /* 2026127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026139 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026169 */     // GIR_Coverage, 16487,
     /* 2026169 */     GIR_EraseRootFromParent_Done,
     /* 2026170 */   // Label 27045: @2026170
     /* 2026170 */   GIM_Try, /*On fail goto*//*Label 27046*/ GIMT_Encode4(2026275), // Rule ID 16490 //
     /* 2026175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2026192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026225 */     // MIs[1] Operand 1
     /* 2026225 */     // No operand predicates
     /* 2026225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026229 */     // MIs[0] round
     /* 2026229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026232 */     // MIs[0] policy
     /* 2026232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026244 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2026247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026274 */     // GIR_Coverage, 16490,
     /* 2026274 */     GIR_EraseRootFromParent_Done,
     /* 2026275 */   // Label 27046: @2026275
     /* 2026275 */   GIM_Try, /*On fail goto*//*Label 27047*/ GIMT_Encode4(2026380), // Rule ID 16491 //
     /* 2026280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2026291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2026294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2026297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026330 */     // MIs[1] Operand 1
     /* 2026330 */     // No operand predicates
     /* 2026330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026334 */     // MIs[0] round
     /* 2026334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026337 */     // MIs[0] policy
     /* 2026337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026349 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2026352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026379 */     // GIR_Coverage, 16491,
     /* 2026379 */     GIR_EraseRootFromParent_Done,
     /* 2026380 */   // Label 27047: @2026380
     /* 2026380 */   GIM_Try, /*On fail goto*//*Label 27048*/ GIMT_Encode4(2026485), // Rule ID 16494 //
     /* 2026385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026435 */     // MIs[1] Operand 1
     /* 2026435 */     // No operand predicates
     /* 2026435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026439 */     // MIs[0] round
     /* 2026439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026442 */     // MIs[0] policy
     /* 2026442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026454 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2026457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026484 */     // GIR_Coverage, 16494,
     /* 2026484 */     GIR_EraseRootFromParent_Done,
     /* 2026485 */   // Label 27048: @2026485
     /* 2026485 */   GIM_Try, /*On fail goto*//*Label 27049*/ GIMT_Encode4(2026590), // Rule ID 16495 //
     /* 2026490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2026501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2026504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026540 */     // MIs[1] Operand 1
     /* 2026540 */     // No operand predicates
     /* 2026540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026544 */     // MIs[0] round
     /* 2026544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026547 */     // MIs[0] policy
     /* 2026547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026559 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2026562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026589 */     // GIR_Coverage, 16495,
     /* 2026589 */     GIR_EraseRootFromParent_Done,
     /* 2026590 */   // Label 27049: @2026590
     /* 2026590 */   GIM_Try, /*On fail goto*//*Label 27050*/ GIMT_Encode4(2026695), // Rule ID 16498 //
     /* 2026595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2026606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2026609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2026612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026645 */     // MIs[1] Operand 1
     /* 2026645 */     // No operand predicates
     /* 2026645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026649 */     // MIs[0] round
     /* 2026649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026652 */     // MIs[0] policy
     /* 2026652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026664 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2026667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026694 */     // GIR_Coverage, 16498,
     /* 2026694 */     GIR_EraseRootFromParent_Done,
     /* 2026695 */   // Label 27050: @2026695
     /* 2026695 */   GIM_Try, /*On fail goto*//*Label 27051*/ GIMT_Encode4(2026800), // Rule ID 16499 //
     /* 2026700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2026711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2026714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2026717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026750 */     // MIs[1] Operand 1
     /* 2026750 */     // No operand predicates
     /* 2026750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026754 */     // MIs[0] round
     /* 2026754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026757 */     // MIs[0] policy
     /* 2026757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026769 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2026772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2026793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026799 */     // GIR_Coverage, 16499,
     /* 2026799 */     GIR_EraseRootFromParent_Done,
     /* 2026800 */   // Label 27051: @2026800
     /* 2026800 */   GIM_Try, /*On fail goto*//*Label 27052*/ GIMT_Encode4(2026905), // Rule ID 16502 //
     /* 2026805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2026808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2026816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2026819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2026822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2026825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026855 */     // MIs[1] Operand 1
     /* 2026855 */     // No operand predicates
     /* 2026855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026859 */     // MIs[0] round
     /* 2026859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026862 */     // MIs[0] policy
     /* 2026862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026874 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2026903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026904 */     // GIR_Coverage, 16502,
     /* 2026904 */     GIR_EraseRootFromParent_Done,
     /* 2026905 */   // Label 27052: @2026905
     /* 2026905 */   GIM_Try, /*On fail goto*//*Label 27053*/ GIMT_Encode4(2027010), // Rule ID 16503 //
     /* 2026910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2026913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2026918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2026921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2026924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2026927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2026930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2026933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2026940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2026948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2026952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2026956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2026960 */     // MIs[1] Operand 1
     /* 2026960 */     // No operand predicates
     /* 2026960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026964 */     // MIs[0] round
     /* 2026964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026967 */     // MIs[0] policy
     /* 2026967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2026972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026979 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2026982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2026991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027009 */     // GIR_Coverage, 16503,
     /* 2027009 */     GIR_EraseRootFromParent_Done,
     /* 2027010 */   // Label 27053: @2027010
     /* 2027010 */   GIM_Try, /*On fail goto*//*Label 27054*/ GIMT_Encode4(2027115), // Rule ID 16506 //
     /* 2027015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2027026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2027029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027065 */     // MIs[1] Operand 1
     /* 2027065 */     // No operand predicates
     /* 2027065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027069 */     // MIs[0] round
     /* 2027069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027072 */     // MIs[0] policy
     /* 2027072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2027087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027114 */     // GIR_Coverage, 16506,
     /* 2027114 */     GIR_EraseRootFromParent_Done,
     /* 2027115 */   // Label 27054: @2027115
     /* 2027115 */   GIM_Try, /*On fail goto*//*Label 27055*/ GIMT_Encode4(2027220), // Rule ID 16507 //
     /* 2027120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2027131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2027134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2027137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027170 */     // MIs[1] Operand 1
     /* 2027170 */     // No operand predicates
     /* 2027170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027174 */     // MIs[0] round
     /* 2027174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027177 */     // MIs[0] policy
     /* 2027177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027189 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2027192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027219 */     // GIR_Coverage, 16507,
     /* 2027219 */     GIR_EraseRootFromParent_Done,
     /* 2027220 */   // Label 27055: @2027220
     /* 2027220 */   GIM_Try, /*On fail goto*//*Label 27056*/ GIMT_Encode4(2027325), // Rule ID 16510 //
     /* 2027225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2027242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027275 */     // MIs[1] Operand 1
     /* 2027275 */     // No operand predicates
     /* 2027275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027279 */     // MIs[0] round
     /* 2027279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027282 */     // MIs[0] policy
     /* 2027282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027324 */     // GIR_Coverage, 16510,
     /* 2027324 */     GIR_EraseRootFromParent_Done,
     /* 2027325 */   // Label 27056: @2027325
     /* 2027325 */   GIM_Try, /*On fail goto*//*Label 27057*/ GIMT_Encode4(2027430), // Rule ID 16511 //
     /* 2027330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2027341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2027344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2027347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2027360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2027364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027380 */     // MIs[1] Operand 1
     /* 2027380 */     // No operand predicates
     /* 2027380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027384 */     // MIs[0] round
     /* 2027384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027387 */     // MIs[0] policy
     /* 2027387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2027402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027429 */     // GIR_Coverage, 16511,
     /* 2027429 */     GIR_EraseRootFromParent_Done,
     /* 2027430 */   // Label 27057: @2027430
     /* 2027430 */   GIM_Try, /*On fail goto*//*Label 27058*/ GIMT_Encode4(2027535), // Rule ID 16514 //
     /* 2027435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2027438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2027446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2027449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2027452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027485 */     // MIs[1] Operand 1
     /* 2027485 */     // No operand predicates
     /* 2027485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027489 */     // MIs[0] round
     /* 2027489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027492 */     // MIs[0] policy
     /* 2027492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027504 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027534 */     // GIR_Coverage, 16514,
     /* 2027534 */     GIR_EraseRootFromParent_Done,
     /* 2027535 */   // Label 27058: @2027535
     /* 2027535 */   GIM_Try, /*On fail goto*//*Label 27059*/ GIMT_Encode4(2027640), // Rule ID 16515 //
     /* 2027540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2027543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2027548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2027551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2027554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2027557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2027563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2027570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2027574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027590 */     // MIs[1] Operand 1
     /* 2027590 */     // No operand predicates
     /* 2027590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027594 */     // MIs[0] round
     /* 2027594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027597 */     // MIs[0] policy
     /* 2027597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2027612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2027633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027639 */     // GIR_Coverage, 16515,
     /* 2027639 */     GIR_EraseRootFromParent_Done,
     /* 2027640 */   // Label 27059: @2027640
     /* 2027640 */   GIM_Try, /*On fail goto*//*Label 27060*/ GIMT_Encode4(2027745), // Rule ID 16638 //
     /* 2027645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2027653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2027656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2027659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2027662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027695 */     // MIs[1] Operand 1
     /* 2027695 */     // No operand predicates
     /* 2027695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027699 */     // MIs[0] round
     /* 2027699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027702 */     // MIs[0] policy
     /* 2027702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027714 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2027717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027744 */     // GIR_Coverage, 16638,
     /* 2027744 */     GIR_EraseRootFromParent_Done,
     /* 2027745 */   // Label 27060: @2027745
     /* 2027745 */   GIM_Try, /*On fail goto*//*Label 27061*/ GIMT_Encode4(2027850), // Rule ID 16639 //
     /* 2027750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2027758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2027761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2027764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2027767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027800 */     // MIs[1] Operand 1
     /* 2027800 */     // No operand predicates
     /* 2027800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027804 */     // MIs[0] round
     /* 2027804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027807 */     // MIs[0] policy
     /* 2027807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027819 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2027822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027849 */     // GIR_Coverage, 16639,
     /* 2027849 */     GIR_EraseRootFromParent_Done,
     /* 2027850 */   // Label 27061: @2027850
     /* 2027850 */   GIM_Try, /*On fail goto*//*Label 27062*/ GIMT_Encode4(2027955), // Rule ID 16642 //
     /* 2027855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2027863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2027866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2027869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2027872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2027897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2027901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2027905 */     // MIs[1] Operand 1
     /* 2027905 */     // No operand predicates
     /* 2027905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027909 */     // MIs[0] round
     /* 2027909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027912 */     // MIs[0] policy
     /* 2027912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2027917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027924 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2027927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2027936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2027953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027954 */     // GIR_Coverage, 16642,
     /* 2027954 */     GIR_EraseRootFromParent_Done,
     /* 2027955 */   // Label 27062: @2027955
     /* 2027955 */   GIM_Try, /*On fail goto*//*Label 27063*/ GIMT_Encode4(2028060), // Rule ID 16643 //
     /* 2027960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2027968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2027971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2027974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2027977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028010 */     // MIs[1] Operand 1
     /* 2028010 */     // No operand predicates
     /* 2028010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028014 */     // MIs[0] round
     /* 2028014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028017 */     // MIs[0] policy
     /* 2028017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028029 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2028032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028059 */     // GIR_Coverage, 16643,
     /* 2028059 */     GIR_EraseRootFromParent_Done,
     /* 2028060 */   // Label 27063: @2028060
     /* 2028060 */   GIM_Try, /*On fail goto*//*Label 27064*/ GIMT_Encode4(2028165), // Rule ID 16646 //
     /* 2028065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028115 */     // MIs[1] Operand 1
     /* 2028115 */     // No operand predicates
     /* 2028115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028119 */     // MIs[0] round
     /* 2028119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028122 */     // MIs[0] policy
     /* 2028122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028134 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2028137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028164 */     // GIR_Coverage, 16646,
     /* 2028164 */     GIR_EraseRootFromParent_Done,
     /* 2028165 */   // Label 27064: @2028165
     /* 2028165 */   GIM_Try, /*On fail goto*//*Label 27065*/ GIMT_Encode4(2028270), // Rule ID 16647 //
     /* 2028170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2028181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2028184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028220 */     // MIs[1] Operand 1
     /* 2028220 */     // No operand predicates
     /* 2028220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028224 */     // MIs[0] round
     /* 2028224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028227 */     // MIs[0] policy
     /* 2028227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028239 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2028242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028269 */     // GIR_Coverage, 16647,
     /* 2028269 */     GIR_EraseRootFromParent_Done,
     /* 2028270 */   // Label 27065: @2028270
     /* 2028270 */   GIM_Try, /*On fail goto*//*Label 27066*/ GIMT_Encode4(2028375), // Rule ID 16650 //
     /* 2028275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2028292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028325 */     // MIs[1] Operand 1
     /* 2028325 */     // No operand predicates
     /* 2028325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028329 */     // MIs[0] round
     /* 2028329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028332 */     // MIs[0] policy
     /* 2028332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2028347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028374 */     // GIR_Coverage, 16650,
     /* 2028374 */     GIR_EraseRootFromParent_Done,
     /* 2028375 */   // Label 27066: @2028375
     /* 2028375 */   GIM_Try, /*On fail goto*//*Label 27067*/ GIMT_Encode4(2028480), // Rule ID 16651 //
     /* 2028380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2028397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028430 */     // MIs[1] Operand 1
     /* 2028430 */     // No operand predicates
     /* 2028430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028434 */     // MIs[0] round
     /* 2028434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028437 */     // MIs[0] policy
     /* 2028437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028449 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2028452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028479 */     // GIR_Coverage, 16651,
     /* 2028479 */     GIR_EraseRootFromParent_Done,
     /* 2028480 */   // Label 27067: @2028480
     /* 2028480 */   GIM_Try, /*On fail goto*//*Label 27068*/ GIMT_Encode4(2028585), // Rule ID 16654 //
     /* 2028485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2028496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2028499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2028502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2028515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028535 */     // MIs[1] Operand 1
     /* 2028535 */     // No operand predicates
     /* 2028535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028539 */     // MIs[0] round
     /* 2028539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028542 */     // MIs[0] policy
     /* 2028542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028554 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2028557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028584 */     // GIR_Coverage, 16654,
     /* 2028584 */     GIR_EraseRootFromParent_Done,
     /* 2028585 */   // Label 27068: @2028585
     /* 2028585 */   GIM_Try, /*On fail goto*//*Label 27069*/ GIMT_Encode4(2028690), // Rule ID 16655 //
     /* 2028590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2028601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2028604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2028607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2028620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028640 */     // MIs[1] Operand 1
     /* 2028640 */     // No operand predicates
     /* 2028640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028644 */     // MIs[0] round
     /* 2028644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028647 */     // MIs[0] policy
     /* 2028647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028659 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2028662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028689 */     // GIR_Coverage, 16655,
     /* 2028689 */     GIR_EraseRootFromParent_Done,
     /* 2028690 */   // Label 27069: @2028690
     /* 2028690 */   GIM_Try, /*On fail goto*//*Label 27070*/ GIMT_Encode4(2028795), // Rule ID 16658 //
     /* 2028695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2028706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2028709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2028712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2028718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028745 */     // MIs[1] Operand 1
     /* 2028745 */     // No operand predicates
     /* 2028745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028749 */     // MIs[0] round
     /* 2028749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028752 */     // MIs[0] policy
     /* 2028752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028764 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2028767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028794 */     // GIR_Coverage, 16658,
     /* 2028794 */     GIR_EraseRootFromParent_Done,
     /* 2028795 */   // Label 27070: @2028795
     /* 2028795 */   GIM_Try, /*On fail goto*//*Label 27071*/ GIMT_Encode4(2028900), // Rule ID 16659 //
     /* 2028800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2028811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2028814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2028817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2028823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2028830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2028834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2028838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028850 */     // MIs[1] Operand 1
     /* 2028850 */     // No operand predicates
     /* 2028850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028854 */     // MIs[0] round
     /* 2028854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028857 */     // MIs[0] policy
     /* 2028857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028869 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2028872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2028898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028899 */     // GIR_Coverage, 16659,
     /* 2028899 */     GIR_EraseRootFromParent_Done,
     /* 2028900 */   // Label 27071: @2028900
     /* 2028900 */   GIM_Try, /*On fail goto*//*Label 27072*/ GIMT_Encode4(2029005), // Rule ID 16662 //
     /* 2028905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2028913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2028916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2028919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2028922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2028947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2028951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2028955 */     // MIs[1] Operand 1
     /* 2028955 */     // No operand predicates
     /* 2028955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028959 */     // MIs[0] round
     /* 2028959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028962 */     // MIs[0] policy
     /* 2028962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2028967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028974 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2028977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2028986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029004 */     // GIR_Coverage, 16662,
     /* 2029004 */     GIR_EraseRootFromParent_Done,
     /* 2029005 */   // Label 27072: @2029005
     /* 2029005 */   GIM_Try, /*On fail goto*//*Label 27073*/ GIMT_Encode4(2029110), // Rule ID 16663 //
     /* 2029010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2029021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2029024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2029027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029060 */     // MIs[1] Operand 1
     /* 2029060 */     // No operand predicates
     /* 2029060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029064 */     // MIs[0] round
     /* 2029064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029067 */     // MIs[0] policy
     /* 2029067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029079 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2029082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029109 */     // GIR_Coverage, 16663,
     /* 2029109 */     GIR_EraseRootFromParent_Done,
     /* 2029110 */   // Label 27073: @2029110
     /* 2029110 */   GIM_Try, /*On fail goto*//*Label 27074*/ GIMT_Encode4(2029215), // Rule ID 16666 //
     /* 2029115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029165 */     // MIs[1] Operand 1
     /* 2029165 */     // No operand predicates
     /* 2029165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029169 */     // MIs[0] round
     /* 2029169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029172 */     // MIs[0] policy
     /* 2029172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029184 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2029187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029214 */     // GIR_Coverage, 16666,
     /* 2029214 */     GIR_EraseRootFromParent_Done,
     /* 2029215 */   // Label 27074: @2029215
     /* 2029215 */   GIM_Try, /*On fail goto*//*Label 27075*/ GIMT_Encode4(2029320), // Rule ID 16667 //
     /* 2029220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2029231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2029234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2029237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2029243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029270 */     // MIs[1] Operand 1
     /* 2029270 */     // No operand predicates
     /* 2029270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029274 */     // MIs[0] round
     /* 2029274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029277 */     // MIs[0] policy
     /* 2029277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029289 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2029292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029319 */     // GIR_Coverage, 16667,
     /* 2029319 */     GIR_EraseRootFromParent_Done,
     /* 2029320 */   // Label 27075: @2029320
     /* 2029320 */   GIM_Try, /*On fail goto*//*Label 27076*/ GIMT_Encode4(2029425), // Rule ID 16670 //
     /* 2029325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2029342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029375 */     // MIs[1] Operand 1
     /* 2029375 */     // No operand predicates
     /* 2029375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029379 */     // MIs[0] round
     /* 2029379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029382 */     // MIs[0] policy
     /* 2029382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2029397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029424 */     // GIR_Coverage, 16670,
     /* 2029424 */     GIR_EraseRootFromParent_Done,
     /* 2029425 */   // Label 27076: @2029425
     /* 2029425 */   GIM_Try, /*On fail goto*//*Label 27077*/ GIMT_Encode4(2029530), // Rule ID 16671 //
     /* 2029430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2029441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2029444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2029447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2029453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029480 */     // MIs[1] Operand 1
     /* 2029480 */     // No operand predicates
     /* 2029480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029484 */     // MIs[0] round
     /* 2029484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029487 */     // MIs[0] policy
     /* 2029487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029499 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2029502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029529 */     // GIR_Coverage, 16671,
     /* 2029529 */     GIR_EraseRootFromParent_Done,
     /* 2029530 */   // Label 27077: @2029530
     /* 2029530 */   GIM_Try, /*On fail goto*//*Label 27078*/ GIMT_Encode4(2029635), // Rule ID 16674 //
     /* 2029535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2029546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2029549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2029552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029585 */     // MIs[1] Operand 1
     /* 2029585 */     // No operand predicates
     /* 2029585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029589 */     // MIs[0] round
     /* 2029589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029592 */     // MIs[0] policy
     /* 2029592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029604 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2029607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029634 */     // GIR_Coverage, 16674,
     /* 2029634 */     GIR_EraseRootFromParent_Done,
     /* 2029635 */   // Label 27078: @2029635
     /* 2029635 */   GIM_Try, /*On fail goto*//*Label 27079*/ GIMT_Encode4(2029740), // Rule ID 16675 //
     /* 2029640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2029651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2029654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2029657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029690 */     // MIs[1] Operand 1
     /* 2029690 */     // No operand predicates
     /* 2029690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029694 */     // MIs[0] round
     /* 2029694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029697 */     // MIs[0] policy
     /* 2029697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029709 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2029712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029739 */     // GIR_Coverage, 16675,
     /* 2029739 */     GIR_EraseRootFromParent_Done,
     /* 2029740 */   // Label 27079: @2029740
     /* 2029740 */   GIM_Try, /*On fail goto*//*Label 27080*/ GIMT_Encode4(2029845), // Rule ID 16678 //
     /* 2029745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2029756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2029759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2029762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029795 */     // MIs[1] Operand 1
     /* 2029795 */     // No operand predicates
     /* 2029795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029799 */     // MIs[0] round
     /* 2029799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029802 */     // MIs[0] policy
     /* 2029802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2029817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029844 */     // GIR_Coverage, 16678,
     /* 2029844 */     GIR_EraseRootFromParent_Done,
     /* 2029845 */   // Label 27080: @2029845
     /* 2029845 */   GIM_Try, /*On fail goto*//*Label 27081*/ GIMT_Encode4(2029950), // Rule ID 16679 //
     /* 2029850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2029861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2029864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2029867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2029896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2029900 */     // MIs[1] Operand 1
     /* 2029900 */     // No operand predicates
     /* 2029900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029904 */     // MIs[0] round
     /* 2029904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029907 */     // MIs[0] policy
     /* 2029907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2029912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029919 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2029922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2029931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2029948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029949 */     // GIR_Coverage, 16679,
     /* 2029949 */     GIR_EraseRootFromParent_Done,
     /* 2029950 */   // Label 27081: @2029950
     /* 2029950 */   GIM_Try, /*On fail goto*//*Label 27082*/ GIMT_Encode4(2030055), // Rule ID 16682 //
     /* 2029955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2029958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2029963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2029966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2029969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2029972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2029978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2029985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2029993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2029997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030005 */     // MIs[1] Operand 1
     /* 2030005 */     // No operand predicates
     /* 2030005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030009 */     // MIs[0] round
     /* 2030009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030012 */     // MIs[0] policy
     /* 2030012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2030027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030054 */     // GIR_Coverage, 16682,
     /* 2030054 */     GIR_EraseRootFromParent_Done,
     /* 2030055 */   // Label 27082: @2030055
     /* 2030055 */   GIM_Try, /*On fail goto*//*Label 27083*/ GIMT_Encode4(2030160), // Rule ID 16683 //
     /* 2030060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2030077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030110 */     // MIs[1] Operand 1
     /* 2030110 */     // No operand predicates
     /* 2030110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030114 */     // MIs[0] round
     /* 2030114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030117 */     // MIs[0] policy
     /* 2030117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030129 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2030132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030159 */     // GIR_Coverage, 16683,
     /* 2030159 */     GIR_EraseRootFromParent_Done,
     /* 2030160 */   // Label 27083: @2030160
     /* 2030160 */   GIM_Try, /*On fail goto*//*Label 27084*/ GIMT_Encode4(2030265), // Rule ID 16686 //
     /* 2030165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030215 */     // MIs[1] Operand 1
     /* 2030215 */     // No operand predicates
     /* 2030215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030219 */     // MIs[0] round
     /* 2030219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030222 */     // MIs[0] policy
     /* 2030222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030234 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2030237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030264 */     // GIR_Coverage, 16686,
     /* 2030264 */     GIR_EraseRootFromParent_Done,
     /* 2030265 */   // Label 27084: @2030265
     /* 2030265 */   GIM_Try, /*On fail goto*//*Label 27085*/ GIMT_Encode4(2030370), // Rule ID 16687 //
     /* 2030270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030320 */     // MIs[1] Operand 1
     /* 2030320 */     // No operand predicates
     /* 2030320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030324 */     // MIs[0] round
     /* 2030324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030327 */     // MIs[0] policy
     /* 2030327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030339 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2030342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030369 */     // GIR_Coverage, 16687,
     /* 2030369 */     GIR_EraseRootFromParent_Done,
     /* 2030370 */   // Label 27085: @2030370
     /* 2030370 */   GIM_Try, /*On fail goto*//*Label 27086*/ GIMT_Encode4(2030475), // Rule ID 16690 //
     /* 2030375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030425 */     // MIs[1] Operand 1
     /* 2030425 */     // No operand predicates
     /* 2030425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030429 */     // MIs[0] round
     /* 2030429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030432 */     // MIs[0] policy
     /* 2030432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030474 */     // GIR_Coverage, 16690,
     /* 2030474 */     GIR_EraseRootFromParent_Done,
     /* 2030475 */   // Label 27086: @2030475
     /* 2030475 */   GIM_Try, /*On fail goto*//*Label 27087*/ GIMT_Encode4(2030580), // Rule ID 16691 //
     /* 2030480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030530 */     // MIs[1] Operand 1
     /* 2030530 */     // No operand predicates
     /* 2030530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030534 */     // MIs[0] round
     /* 2030534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030537 */     // MIs[0] policy
     /* 2030537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2030552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030579 */     // GIR_Coverage, 16691,
     /* 2030579 */     GIR_EraseRootFromParent_Done,
     /* 2030580 */   // Label 27087: @2030580
     /* 2030580 */   GIM_Try, /*On fail goto*//*Label 27088*/ GIMT_Encode4(2030685), // Rule ID 16694 //
     /* 2030585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2030588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2030602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030635 */     // MIs[1] Operand 1
     /* 2030635 */     // No operand predicates
     /* 2030635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030639 */     // MIs[0] round
     /* 2030639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030642 */     // MIs[0] policy
     /* 2030642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2030657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030684 */     // GIR_Coverage, 16694,
     /* 2030684 */     GIR_EraseRootFromParent_Done,
     /* 2030685 */   // Label 27088: @2030685
     /* 2030685 */   GIM_Try, /*On fail goto*//*Label 27089*/ GIMT_Encode4(2030790), // Rule ID 16695 //
     /* 2030690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2030693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2030698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2030707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2030732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2030736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2030740 */     // MIs[1] Operand 1
     /* 2030740 */     // No operand predicates
     /* 2030740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030744 */     // MIs[0] round
     /* 2030744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030747 */     // MIs[0] policy
     /* 2030747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2030752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030759 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2030762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2030771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2030788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030789 */     // GIR_Coverage, 16695,
     /* 2030789 */     GIR_EraseRootFromParent_Done,
     /* 2030790 */   // Label 27089: @2030790
     /* 2030790 */   GIM_Try, /*On fail goto*//*Label 27090*/ GIMT_Encode4(2030877), // Rule ID 2766 //
     /* 2030795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2030798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2030803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2030812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030826 */     // MIs[0] passthru
     /* 2030826 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2030831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030839 */     // MIs[0] round
     /* 2030839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030842 */     // MIs[0] policy
     /* 2030842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030852 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2030855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030876 */     // GIR_Coverage, 2766,
     /* 2030876 */     GIR_EraseRootFromParent_Done,
     /* 2030877 */   // Label 27090: @2030877
     /* 2030877 */   GIM_Try, /*On fail goto*//*Label 27091*/ GIMT_Encode4(2030964), // Rule ID 2767 //
     /* 2030882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2030885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2030890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2030893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2030896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2030899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2030902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030913 */     // MIs[0] passthru
     /* 2030913 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2030918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2030922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030926 */     // MIs[0] round
     /* 2030926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030929 */     // MIs[0] policy
     /* 2030929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030939 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2030942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2030960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030963 */     // GIR_Coverage, 2767,
     /* 2030963 */     GIR_EraseRootFromParent_Done,
     /* 2030964 */   // Label 27091: @2030964
     /* 2030964 */   GIM_Try, /*On fail goto*//*Label 27092*/ GIMT_Encode4(2031051), // Rule ID 17146 //
     /* 2030969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2030972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2030977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2030980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2030983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2030986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2030996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031000 */     // MIs[0] passthru
     /* 2031000 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031013 */     // MIs[0] round
     /* 2031013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031016 */     // MIs[0] policy
     /* 2031016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031026 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2031029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031050 */     // GIR_Coverage, 17146,
     /* 2031050 */     GIR_EraseRootFromParent_Done,
     /* 2031051 */   // Label 27092: @2031051
     /* 2031051 */   GIM_Try, /*On fail goto*//*Label 27093*/ GIMT_Encode4(2031138), // Rule ID 17147 //
     /* 2031056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2031067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2031070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2031073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031087 */     // MIs[0] passthru
     /* 2031087 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031100 */     // MIs[0] round
     /* 2031100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031103 */     // MIs[0] policy
     /* 2031103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031113 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2031116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031137 */     // GIR_Coverage, 17147,
     /* 2031137 */     GIR_EraseRootFromParent_Done,
     /* 2031138 */   // Label 27093: @2031138
     /* 2031138 */   GIM_Try, /*On fail goto*//*Label 27094*/ GIMT_Encode4(2031225), // Rule ID 17156 //
     /* 2031143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2031160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031174 */     // MIs[0] passthru
     /* 2031174 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031187 */     // MIs[0] round
     /* 2031187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031190 */     // MIs[0] policy
     /* 2031190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031200 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2031203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031224 */     // GIR_Coverage, 17156,
     /* 2031224 */     GIR_EraseRootFromParent_Done,
     /* 2031225 */   // Label 27094: @2031225
     /* 2031225 */   GIM_Try, /*On fail goto*//*Label 27095*/ GIMT_Encode4(2031312), // Rule ID 17157 //
     /* 2031230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2031241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2031244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2031247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031261 */     // MIs[0] passthru
     /* 2031261 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031274 */     // MIs[0] round
     /* 2031274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031277 */     // MIs[0] policy
     /* 2031277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031287 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2031290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031311 */     // GIR_Coverage, 17157,
     /* 2031311 */     GIR_EraseRootFromParent_Done,
     /* 2031312 */   // Label 27095: @2031312
     /* 2031312 */   GIM_Try, /*On fail goto*//*Label 27096*/ GIMT_Encode4(2031399), // Rule ID 17166 //
     /* 2031317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2031334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031348 */     // MIs[0] passthru
     /* 2031348 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031361 */     // MIs[0] round
     /* 2031361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031364 */     // MIs[0] policy
     /* 2031364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031374 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2031377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031398 */     // GIR_Coverage, 17166,
     /* 2031398 */     GIR_EraseRootFromParent_Done,
     /* 2031399 */   // Label 27096: @2031399
     /* 2031399 */   GIM_Try, /*On fail goto*//*Label 27097*/ GIMT_Encode4(2031486), // Rule ID 17167 //
     /* 2031404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2031415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2031418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2031421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2031431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031435 */     // MIs[0] passthru
     /* 2031435 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031448 */     // MIs[0] round
     /* 2031448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031451 */     // MIs[0] policy
     /* 2031451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031461 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2031464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031485 */     // GIR_Coverage, 17167,
     /* 2031485 */     GIR_EraseRootFromParent_Done,
     /* 2031486 */   // Label 27097: @2031486
     /* 2031486 */   GIM_Try, /*On fail goto*//*Label 27098*/ GIMT_Encode4(2031573), // Rule ID 17176 //
     /* 2031491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2031494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2031502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2031505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2031508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2031511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031522 */     // MIs[0] passthru
     /* 2031522 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031535 */     // MIs[0] round
     /* 2031535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031538 */     // MIs[0] policy
     /* 2031538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031548 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2031551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031572 */     // GIR_Coverage, 17176,
     /* 2031572 */     GIR_EraseRootFromParent_Done,
     /* 2031573 */   // Label 27098: @2031573
     /* 2031573 */   GIM_Try, /*On fail goto*//*Label 27099*/ GIMT_Encode4(2031660), // Rule ID 17177 //
     /* 2031578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2031581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2031589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2031592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2031595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2031598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031609 */     // MIs[0] passthru
     /* 2031609 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2031618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031622 */     // MIs[0] round
     /* 2031622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031625 */     // MIs[0] policy
     /* 2031625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031635 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2031638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031659 */     // GIR_Coverage, 17177,
     /* 2031659 */     GIR_EraseRootFromParent_Done,
     /* 2031660 */   // Label 27099: @2031660
     /* 2031660 */   GIM_Try, /*On fail goto*//*Label 27100*/ GIMT_Encode4(2031747), // Rule ID 17186 //
     /* 2031665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2031668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2031676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2031679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2031682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031696 */     // MIs[0] passthru
     /* 2031696 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031709 */     // MIs[0] round
     /* 2031709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031712 */     // MIs[0] policy
     /* 2031712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031722 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2031725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031746 */     // GIR_Coverage, 17186,
     /* 2031746 */     GIR_EraseRootFromParent_Done,
     /* 2031747 */   // Label 27100: @2031747
     /* 2031747 */   GIM_Try, /*On fail goto*//*Label 27101*/ GIMT_Encode4(2031834), // Rule ID 17187 //
     /* 2031752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2031755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2031763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2031766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2031769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031783 */     // MIs[0] passthru
     /* 2031783 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031796 */     // MIs[0] round
     /* 2031796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031799 */     // MIs[0] policy
     /* 2031799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031809 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2031812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031833 */     // GIR_Coverage, 17187,
     /* 2031833 */     GIR_EraseRootFromParent_Done,
     /* 2031834 */   // Label 27101: @2031834
     /* 2031834 */   GIM_Try, /*On fail goto*//*Label 27102*/ GIMT_Encode4(2031921), // Rule ID 17196 //
     /* 2031839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2031842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2031850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2031853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2031856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031870 */     // MIs[0] passthru
     /* 2031870 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031883 */     // MIs[0] round
     /* 2031883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031886 */     // MIs[0] policy
     /* 2031886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031896 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2031899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2031917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031920 */     // GIR_Coverage, 17196,
     /* 2031920 */     GIR_EraseRootFromParent_Done,
     /* 2031921 */   // Label 27102: @2031921
     /* 2031921 */   GIM_Try, /*On fail goto*//*Label 27103*/ GIMT_Encode4(2032008), // Rule ID 17197 //
     /* 2031926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2031929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2031934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2031937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2031940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2031943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2031953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2031957 */     // MIs[0] passthru
     /* 2031957 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2031962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031970 */     // MIs[0] round
     /* 2031970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031973 */     // MIs[0] policy
     /* 2031973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031983 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2031986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032007 */     // GIR_Coverage, 17197,
     /* 2032007 */     GIR_EraseRootFromParent_Done,
     /* 2032008 */   // Label 27103: @2032008
     /* 2032008 */   GIM_Try, /*On fail goto*//*Label 27104*/ GIMT_Encode4(2032095), // Rule ID 17206 //
     /* 2032013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2032024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2032027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2032030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032044 */     // MIs[0] passthru
     /* 2032044 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032057 */     // MIs[0] round
     /* 2032057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032060 */     // MIs[0] policy
     /* 2032060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032070 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2032073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032094 */     // GIR_Coverage, 17206,
     /* 2032094 */     GIR_EraseRootFromParent_Done,
     /* 2032095 */   // Label 27104: @2032095
     /* 2032095 */   GIM_Try, /*On fail goto*//*Label 27105*/ GIMT_Encode4(2032182), // Rule ID 17207 //
     /* 2032100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2032111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2032114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2032117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032131 */     // MIs[0] passthru
     /* 2032131 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032144 */     // MIs[0] round
     /* 2032144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032147 */     // MIs[0] policy
     /* 2032147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032157 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2032160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032181 */     // GIR_Coverage, 17207,
     /* 2032181 */     GIR_EraseRootFromParent_Done,
     /* 2032182 */   // Label 27105: @2032182
     /* 2032182 */   GIM_Try, /*On fail goto*//*Label 27106*/ GIMT_Encode4(2032269), // Rule ID 17216 //
     /* 2032187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2032190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2032198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2032201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2032204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032218 */     // MIs[0] passthru
     /* 2032218 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032231 */     // MIs[0] round
     /* 2032231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032234 */     // MIs[0] policy
     /* 2032234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032244 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2032247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032268 */     // GIR_Coverage, 17216,
     /* 2032268 */     GIR_EraseRootFromParent_Done,
     /* 2032269 */   // Label 27106: @2032269
     /* 2032269 */   GIM_Try, /*On fail goto*//*Label 27107*/ GIMT_Encode4(2032356), // Rule ID 17217 //
     /* 2032274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2032277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2032282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2032285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2032288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2032291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2032301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2032305 */     // MIs[0] passthru
     /* 2032305 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032318 */     // MIs[0] round
     /* 2032318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032321 */     // MIs[0] policy
     /* 2032321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032331 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2032334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032355 */     // GIR_Coverage, 17217,
     /* 2032355 */     GIR_EraseRootFromParent_Done,
     /* 2032356 */   // Label 27107: @2032356
     /* 2032356 */   GIM_Try, /*On fail goto*//*Label 27108*/ GIMT_Encode4(2032443), // Rule ID 17262 //
     /* 2032361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2032378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032392 */     // MIs[0] passthru
     /* 2032392 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032405 */     // MIs[0] round
     /* 2032405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032408 */     // MIs[0] policy
     /* 2032408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032418 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2032421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032442 */     // GIR_Coverage, 17262,
     /* 2032442 */     GIR_EraseRootFromParent_Done,
     /* 2032443 */   // Label 27108: @2032443
     /* 2032443 */   GIM_Try, /*On fail goto*//*Label 27109*/ GIMT_Encode4(2032530), // Rule ID 17263 //
     /* 2032448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2032465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032479 */     // MIs[0] passthru
     /* 2032479 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032492 */     // MIs[0] round
     /* 2032492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032495 */     // MIs[0] policy
     /* 2032495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032505 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2032508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032529 */     // GIR_Coverage, 17263,
     /* 2032529 */     GIR_EraseRootFromParent_Done,
     /* 2032530 */   // Label 27109: @2032530
     /* 2032530 */   GIM_Try, /*On fail goto*//*Label 27110*/ GIMT_Encode4(2032617), // Rule ID 17272 //
     /* 2032535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2032552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032566 */     // MIs[0] passthru
     /* 2032566 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032579 */     // MIs[0] round
     /* 2032579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032582 */     // MIs[0] policy
     /* 2032582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032592 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2032595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032616 */     // GIR_Coverage, 17272,
     /* 2032616 */     GIR_EraseRootFromParent_Done,
     /* 2032617 */   // Label 27110: @2032617
     /* 2032617 */   GIM_Try, /*On fail goto*//*Label 27111*/ GIMT_Encode4(2032704), // Rule ID 17273 //
     /* 2032622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2032639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032653 */     // MIs[0] passthru
     /* 2032653 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032666 */     // MIs[0] round
     /* 2032666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032669 */     // MIs[0] policy
     /* 2032669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032679 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2032682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032703 */     // GIR_Coverage, 17273,
     /* 2032703 */     GIR_EraseRootFromParent_Done,
     /* 2032704 */   // Label 27111: @2032704
     /* 2032704 */   GIM_Try, /*On fail goto*//*Label 27112*/ GIMT_Encode4(2032791), // Rule ID 17282 //
     /* 2032709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2032720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2032723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2032726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032740 */     // MIs[0] passthru
     /* 2032740 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032753 */     // MIs[0] round
     /* 2032753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032756 */     // MIs[0] policy
     /* 2032756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032766 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2032769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032790 */     // GIR_Coverage, 17282,
     /* 2032790 */     GIR_EraseRootFromParent_Done,
     /* 2032791 */   // Label 27112: @2032791
     /* 2032791 */   GIM_Try, /*On fail goto*//*Label 27113*/ GIMT_Encode4(2032878), // Rule ID 17283 //
     /* 2032796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2032807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2032810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2032813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032827 */     // MIs[0] passthru
     /* 2032827 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032840 */     // MIs[0] round
     /* 2032840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032843 */     // MIs[0] policy
     /* 2032843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032853 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2032856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032877 */     // GIR_Coverage, 17283,
     /* 2032877 */     GIR_EraseRootFromParent_Done,
     /* 2032878 */   // Label 27113: @2032878
     /* 2032878 */   GIM_Try, /*On fail goto*//*Label 27114*/ GIMT_Encode4(2032965), // Rule ID 17292 //
     /* 2032883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2032886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2032894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2032897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2032900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2032914 */     // MIs[0] passthru
     /* 2032914 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2032919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032927 */     // MIs[0] round
     /* 2032927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032930 */     // MIs[0] policy
     /* 2032930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032940 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2032943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032964 */     // GIR_Coverage, 17292,
     /* 2032964 */     GIR_EraseRootFromParent_Done,
     /* 2032965 */   // Label 27114: @2032965
     /* 2032965 */   GIM_Try, /*On fail goto*//*Label 27115*/ GIMT_Encode4(2033052), // Rule ID 17293 //
     /* 2032970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2032973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2032978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2032981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2032984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2032987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2032997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033001 */     // MIs[0] passthru
     /* 2033001 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033014 */     // MIs[0] round
     /* 2033014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033017 */     // MIs[0] policy
     /* 2033017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033027 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2033030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033051 */     // GIR_Coverage, 17293,
     /* 2033051 */     GIR_EraseRootFromParent_Done,
     /* 2033052 */   // Label 27115: @2033052
     /* 2033052 */   GIM_Try, /*On fail goto*//*Label 27116*/ GIMT_Encode4(2033139), // Rule ID 17302 //
     /* 2033057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2033060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033088 */     // MIs[0] passthru
     /* 2033088 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033101 */     // MIs[0] round
     /* 2033101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033104 */     // MIs[0] policy
     /* 2033104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033114 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2033117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033138 */     // GIR_Coverage, 17302,
     /* 2033138 */     GIR_EraseRootFromParent_Done,
     /* 2033139 */   // Label 27116: @2033139
     /* 2033139 */   GIM_Try, /*On fail goto*//*Label 27117*/ GIMT_Encode4(2033226), // Rule ID 17303 //
     /* 2033144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2033147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2033155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2033158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033175 */     // MIs[0] passthru
     /* 2033175 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033188 */     // MIs[0] round
     /* 2033188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033191 */     // MIs[0] policy
     /* 2033191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033201 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2033204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033225 */     // GIR_Coverage, 17303,
     /* 2033225 */     GIR_EraseRootFromParent_Done,
     /* 2033226 */   // Label 27117: @2033226
     /* 2033226 */   GIM_Try, /*On fail goto*//*Label 27118*/ GIMT_Encode4(2033313), // Rule ID 17312 //
     /* 2033231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2033248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033262 */     // MIs[0] passthru
     /* 2033262 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033275 */     // MIs[0] round
     /* 2033275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033278 */     // MIs[0] policy
     /* 2033278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033288 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2033291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033312 */     // GIR_Coverage, 17312,
     /* 2033312 */     GIR_EraseRootFromParent_Done,
     /* 2033313 */   // Label 27118: @2033313
     /* 2033313 */   GIM_Try, /*On fail goto*//*Label 27119*/ GIMT_Encode4(2033400), // Rule ID 17313 //
     /* 2033318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2033329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2033332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2033335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033349 */     // MIs[0] passthru
     /* 2033349 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033362 */     // MIs[0] round
     /* 2033362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033365 */     // MIs[0] policy
     /* 2033365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033375 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2033378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033399 */     // GIR_Coverage, 17313,
     /* 2033399 */     GIR_EraseRootFromParent_Done,
     /* 2033400 */   // Label 27119: @2033400
     /* 2033400 */   GIM_Try, /*On fail goto*//*Label 27120*/ GIMT_Encode4(2033487), // Rule ID 17322 //
     /* 2033405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2033422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033436 */     // MIs[0] passthru
     /* 2033436 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033449 */     // MIs[0] round
     /* 2033449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033452 */     // MIs[0] policy
     /* 2033452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033462 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2033465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033486 */     // GIR_Coverage, 17322,
     /* 2033486 */     GIR_EraseRootFromParent_Done,
     /* 2033487 */   // Label 27120: @2033487
     /* 2033487 */   GIM_Try, /*On fail goto*//*Label 27121*/ GIMT_Encode4(2033574), // Rule ID 17323 //
     /* 2033492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2033503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2033506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2033509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2033512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033523 */     // MIs[0] passthru
     /* 2033523 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033536 */     // MIs[0] round
     /* 2033536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033539 */     // MIs[0] policy
     /* 2033539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033549 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2033552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033573 */     // GIR_Coverage, 17323,
     /* 2033573 */     GIR_EraseRootFromParent_Done,
     /* 2033574 */   // Label 27121: @2033574
     /* 2033574 */   GIM_Try, /*On fail goto*//*Label 27122*/ GIMT_Encode4(2033661), // Rule ID 17332 //
     /* 2033579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2033590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2033593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2033596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033610 */     // MIs[0] passthru
     /* 2033610 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033623 */     // MIs[0] round
     /* 2033623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033626 */     // MIs[0] policy
     /* 2033626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033636 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2033639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033660 */     // GIR_Coverage, 17332,
     /* 2033660 */     GIR_EraseRootFromParent_Done,
     /* 2033661 */   // Label 27122: @2033661
     /* 2033661 */   GIM_Try, /*On fail goto*//*Label 27123*/ GIMT_Encode4(2033748), // Rule ID 17333 //
     /* 2033666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2033677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2033680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2033683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2033686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033697 */     // MIs[0] passthru
     /* 2033697 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033710 */     // MIs[0] round
     /* 2033710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033713 */     // MIs[0] policy
     /* 2033713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033723 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2033726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033747 */     // GIR_Coverage, 17333,
     /* 2033747 */     GIR_EraseRootFromParent_Done,
     /* 2033748 */   // Label 27123: @2033748
     /* 2033748 */   GIM_Try, /*On fail goto*//*Label 27124*/ GIMT_Encode4(2033835), // Rule ID 17342 //
     /* 2033753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2033756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2033764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2033767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2033770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033784 */     // MIs[0] passthru
     /* 2033784 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033797 */     // MIs[0] round
     /* 2033797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033800 */     // MIs[0] policy
     /* 2033800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033810 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2033813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033834 */     // GIR_Coverage, 17342,
     /* 2033834 */     GIR_EraseRootFromParent_Done,
     /* 2033835 */   // Label 27124: @2033835
     /* 2033835 */   GIM_Try, /*On fail goto*//*Label 27125*/ GIMT_Encode4(2033922), // Rule ID 17343 //
     /* 2033840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2033843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2033848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2033851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2033854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2033857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033871 */     // MIs[0] passthru
     /* 2033871 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2033876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033884 */     // MIs[0] round
     /* 2033884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033887 */     // MIs[0] policy
     /* 2033887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033897 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2033900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2033918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033921 */     // GIR_Coverage, 17343,
     /* 2033921 */     GIR_EraseRootFromParent_Done,
     /* 2033922 */   // Label 27125: @2033922
     /* 2033922 */   GIM_Try, /*On fail goto*//*Label 27126*/ GIMT_Encode4(2034013), // Rule ID 2724 //
     /* 2033927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2033935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2033938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2033941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2033944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2033947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2033950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2033957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2033969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033973 */     // MIs[0] round
     /* 2033973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033976 */     // MIs[0] policy
     /* 2033976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033986 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2033989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034012 */     // GIR_Coverage, 2724,
     /* 2034012 */     GIR_EraseRootFromParent_Done,
     /* 2034013 */   // Label 27126: @2034013
     /* 2034013 */   GIM_Try, /*On fail goto*//*Label 27127*/ GIMT_Encode4(2034104), // Rule ID 2725 //
     /* 2034018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2034029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2034032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2034035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2034038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034064 */     // MIs[0] round
     /* 2034064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034067 */     // MIs[0] policy
     /* 2034067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034077 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2034080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034103 */     // GIR_Coverage, 2725,
     /* 2034103 */     GIR_EraseRootFromParent_Done,
     /* 2034104 */   // Label 27127: @2034104
     /* 2034104 */   GIM_Try, /*On fail goto*//*Label 27128*/ GIMT_Encode4(2034195), // Rule ID 2768 //
     /* 2034109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2034112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034155 */     // MIs[0] round
     /* 2034155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034158 */     // MIs[0] policy
     /* 2034158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034168 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2034171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034194 */     // GIR_Coverage, 2768,
     /* 2034194 */     GIR_EraseRootFromParent_Done,
     /* 2034195 */   // Label 27128: @2034195
     /* 2034195 */   GIM_Try, /*On fail goto*//*Label 27129*/ GIMT_Encode4(2034286), // Rule ID 2769 //
     /* 2034200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2034203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2034208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2034211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2034214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2034217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034246 */     // MIs[0] round
     /* 2034246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034249 */     // MIs[0] policy
     /* 2034249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034259 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2034262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034285 */     // GIR_Coverage, 2769,
     /* 2034285 */     GIR_EraseRootFromParent_Done,
     /* 2034286 */   // Label 27129: @2034286
     /* 2034286 */   GIM_Try, /*On fail goto*//*Label 27130*/ GIMT_Encode4(2034377), // Rule ID 2776 //
     /* 2034291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2034294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2034299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034337 */     // MIs[0] round
     /* 2034337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034340 */     // MIs[0] policy
     /* 2034340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034350 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2034353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2034357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034376 */     // GIR_Coverage, 2776,
     /* 2034376 */     GIR_EraseRootFromParent_Done,
     /* 2034377 */   // Label 27130: @2034377
     /* 2034377 */   GIM_Try, /*On fail goto*//*Label 27131*/ GIMT_Encode4(2034468), // Rule ID 2777 //
     /* 2034382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2034385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2034390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034428 */     // MIs[0] round
     /* 2034428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034431 */     // MIs[0] policy
     /* 2034431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034441 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2034444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2034448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034467 */     // GIR_Coverage, 2777,
     /* 2034467 */     GIR_EraseRootFromParent_Done,
     /* 2034468 */   // Label 27131: @2034468
     /* 2034468 */   GIM_Try, /*On fail goto*//*Label 27132*/ GIMT_Encode4(2034559), // Rule ID 14934 //
     /* 2034473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2034484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2034487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2034490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2034493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034519 */     // MIs[0] round
     /* 2034519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034522 */     // MIs[0] policy
     /* 2034522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034532 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2034535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034558 */     // GIR_Coverage, 14934,
     /* 2034558 */     GIR_EraseRootFromParent_Done,
     /* 2034559 */   // Label 27132: @2034559
     /* 2034559 */   GIM_Try, /*On fail goto*//*Label 27133*/ GIMT_Encode4(2034650), // Rule ID 14935 //
     /* 2034564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2034575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2034578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2034581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2034584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034610 */     // MIs[0] round
     /* 2034610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034613 */     // MIs[0] policy
     /* 2034613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034623 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2034626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034649 */     // GIR_Coverage, 14935,
     /* 2034649 */     GIR_EraseRootFromParent_Done,
     /* 2034650 */   // Label 27133: @2034650
     /* 2034650 */   GIM_Try, /*On fail goto*//*Label 27134*/ GIMT_Encode4(2034741), // Rule ID 14938 //
     /* 2034655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2034666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2034669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2034672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2034675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034701 */     // MIs[0] round
     /* 2034701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034704 */     // MIs[0] policy
     /* 2034704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034714 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2034717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034740 */     // GIR_Coverage, 14938,
     /* 2034740 */     GIR_EraseRootFromParent_Done,
     /* 2034741 */   // Label 27134: @2034741
     /* 2034741 */   GIM_Try, /*On fail goto*//*Label 27135*/ GIMT_Encode4(2034832), // Rule ID 14939 //
     /* 2034746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2034757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2034760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2034763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2034766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034792 */     // MIs[0] round
     /* 2034792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034795 */     // MIs[0] policy
     /* 2034795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034805 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2034808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2034828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034831 */     // GIR_Coverage, 14939,
     /* 2034831 */     GIR_EraseRootFromParent_Done,
     /* 2034832 */   // Label 27135: @2034832
     /* 2034832 */   GIM_Try, /*On fail goto*//*Label 27136*/ GIMT_Encode4(2034923), // Rule ID 14942 //
     /* 2034837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034883 */     // MIs[0] round
     /* 2034883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034886 */     // MIs[0] policy
     /* 2034886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2034899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2034919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034922 */     // GIR_Coverage, 14942,
     /* 2034922 */     GIR_EraseRootFromParent_Done,
     /* 2034923 */   // Label 27136: @2034923
     /* 2034923 */   GIM_Try, /*On fail goto*//*Label 27137*/ GIMT_Encode4(2035014), // Rule ID 14943 //
     /* 2034928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2034936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2034939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2034942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2034945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2034948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2034951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2034958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2034970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034974 */     // MIs[0] round
     /* 2034974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034977 */     // MIs[0] policy
     /* 2034977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034987 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2034990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035013 */     // GIR_Coverage, 14943,
     /* 2035013 */     GIR_EraseRootFromParent_Done,
     /* 2035014 */   // Label 27137: @2035014
     /* 2035014 */   GIM_Try, /*On fail goto*//*Label 27138*/ GIMT_Encode4(2035105), // Rule ID 14946 //
     /* 2035019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2035039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035065 */     // MIs[0] round
     /* 2035065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035068 */     // MIs[0] policy
     /* 2035068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035078 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035104 */     // GIR_Coverage, 14946,
     /* 2035104 */     GIR_EraseRootFromParent_Done,
     /* 2035105 */   // Label 27138: @2035105
     /* 2035105 */   GIM_Try, /*On fail goto*//*Label 27139*/ GIMT_Encode4(2035196), // Rule ID 14947 //
     /* 2035110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2035130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035156 */     // MIs[0] round
     /* 2035156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035159 */     // MIs[0] policy
     /* 2035159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035169 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035195 */     // GIR_Coverage, 14947,
     /* 2035195 */     GIR_EraseRootFromParent_Done,
     /* 2035196 */   // Label 27139: @2035196
     /* 2035196 */   GIM_Try, /*On fail goto*//*Label 27140*/ GIMT_Encode4(2035287), // Rule ID 14950 //
     /* 2035201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2035212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2035215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2035218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035247 */     // MIs[0] round
     /* 2035247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035250 */     // MIs[0] policy
     /* 2035250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035286 */     // GIR_Coverage, 14950,
     /* 2035286 */     GIR_EraseRootFromParent_Done,
     /* 2035287 */   // Label 27140: @2035287
     /* 2035287 */   GIM_Try, /*On fail goto*//*Label 27141*/ GIMT_Encode4(2035378), // Rule ID 14951 //
     /* 2035292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2035303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2035306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2035309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2035312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035338 */     // MIs[0] round
     /* 2035338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035341 */     // MIs[0] policy
     /* 2035341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2035354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035377 */     // GIR_Coverage, 14951,
     /* 2035377 */     GIR_EraseRootFromParent_Done,
     /* 2035378 */   // Label 27141: @2035378
     /* 2035378 */   GIM_Try, /*On fail goto*//*Label 27142*/ GIMT_Encode4(2035469), // Rule ID 14954 //
     /* 2035383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2035394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2035397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2035400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2035403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035429 */     // MIs[0] round
     /* 2035429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035432 */     // MIs[0] policy
     /* 2035432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035468 */     // GIR_Coverage, 14954,
     /* 2035468 */     GIR_EraseRootFromParent_Done,
     /* 2035469 */   // Label 27142: @2035469
     /* 2035469 */   GIM_Try, /*On fail goto*//*Label 27143*/ GIMT_Encode4(2035560), // Rule ID 14955 //
     /* 2035474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2035485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2035488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2035491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2035494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035520 */     // MIs[0] round
     /* 2035520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035523 */     // MIs[0] policy
     /* 2035523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035533 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035559 */     // GIR_Coverage, 14955,
     /* 2035559 */     GIR_EraseRootFromParent_Done,
     /* 2035560 */   // Label 27143: @2035560
     /* 2035560 */   GIM_Try, /*On fail goto*//*Label 27144*/ GIMT_Encode4(2035651), // Rule ID 14958 //
     /* 2035565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2035576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2035579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2035582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2035585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035611 */     // MIs[0] round
     /* 2035611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035614 */     // MIs[0] policy
     /* 2035614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035650 */     // GIR_Coverage, 14958,
     /* 2035650 */     GIR_EraseRootFromParent_Done,
     /* 2035651 */   // Label 27144: @2035651
     /* 2035651 */   GIM_Try, /*On fail goto*//*Label 27145*/ GIMT_Encode4(2035742), // Rule ID 14959 //
     /* 2035656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2035667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2035670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2035673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2035676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035702 */     // MIs[0] round
     /* 2035702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035705 */     // MIs[0] policy
     /* 2035705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035715 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035741 */     // GIR_Coverage, 14959,
     /* 2035741 */     GIR_EraseRootFromParent_Done,
     /* 2035742 */   // Label 27145: @2035742
     /* 2035742 */   GIM_Try, /*On fail goto*//*Label 27146*/ GIMT_Encode4(2035833), // Rule ID 14962 //
     /* 2035747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2035758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2035761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2035764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2035767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035793 */     // MIs[0] round
     /* 2035793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035796 */     // MIs[0] policy
     /* 2035796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035832 */     // GIR_Coverage, 14962,
     /* 2035832 */     GIR_EraseRootFromParent_Done,
     /* 2035833 */   // Label 27146: @2035833
     /* 2035833 */   GIM_Try, /*On fail goto*//*Label 27147*/ GIMT_Encode4(2035924), // Rule ID 14963 //
     /* 2035838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2035849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2035852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2035855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2035858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035884 */     // MIs[0] round
     /* 2035884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035887 */     // MIs[0] policy
     /* 2035887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035897 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2035920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035923 */     // GIR_Coverage, 14963,
     /* 2035923 */     GIR_EraseRootFromParent_Done,
     /* 2035924 */   // Label 27147: @2035924
     /* 2035924 */   GIM_Try, /*On fail goto*//*Label 27148*/ GIMT_Encode4(2036015), // Rule ID 14966 //
     /* 2035929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2035932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2035937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2035940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2035943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2035946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2035949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035975 */     // MIs[0] round
     /* 2035975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035978 */     // MIs[0] policy
     /* 2035978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2035991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036014 */     // GIR_Coverage, 14966,
     /* 2036014 */     GIR_EraseRootFromParent_Done,
     /* 2036015 */   // Label 27148: @2036015
     /* 2036015 */   GIM_Try, /*On fail goto*//*Label 27149*/ GIMT_Encode4(2036106), // Rule ID 14967 //
     /* 2036020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2036023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2036031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2036034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2036037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2036040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036066 */     // MIs[0] round
     /* 2036066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036069 */     // MIs[0] policy
     /* 2036069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036079 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2036082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036105 */     // GIR_Coverage, 14967,
     /* 2036105 */     GIR_EraseRootFromParent_Done,
     /* 2036106 */   // Label 27149: @2036106
     /* 2036106 */   GIM_Try, /*On fail goto*//*Label 27150*/ GIMT_Encode4(2036197), // Rule ID 14970 //
     /* 2036111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2036128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2036131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036157 */     // MIs[0] round
     /* 2036157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036160 */     // MIs[0] policy
     /* 2036160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036170 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036196 */     // GIR_Coverage, 14970,
     /* 2036196 */     GIR_EraseRootFromParent_Done,
     /* 2036197 */   // Label 27150: @2036197
     /* 2036197 */   GIM_Try, /*On fail goto*//*Label 27151*/ GIMT_Encode4(2036288), // Rule ID 14971 //
     /* 2036202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2036219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2036222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036248 */     // MIs[0] round
     /* 2036248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036251 */     // MIs[0] policy
     /* 2036251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036261 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036287 */     // GIR_Coverage, 14971,
     /* 2036287 */     GIR_EraseRootFromParent_Done,
     /* 2036288 */   // Label 27151: @2036288
     /* 2036288 */   GIM_Try, /*On fail goto*//*Label 27152*/ GIMT_Encode4(2036379), // Rule ID 14974 //
     /* 2036293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2036304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2036307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2036310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2036313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2036316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036339 */     // MIs[0] round
     /* 2036339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036342 */     // MIs[0] policy
     /* 2036342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036352 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036378 */     // GIR_Coverage, 14974,
     /* 2036378 */     GIR_EraseRootFromParent_Done,
     /* 2036379 */   // Label 27152: @2036379
     /* 2036379 */   GIM_Try, /*On fail goto*//*Label 27153*/ GIMT_Encode4(2036470), // Rule ID 14975 //
     /* 2036384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2036395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2036398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2036401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2036404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2036407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036430 */     // MIs[0] round
     /* 2036430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036433 */     // MIs[0] policy
     /* 2036433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036443 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036469 */     // GIR_Coverage, 14975,
     /* 2036469 */     GIR_EraseRootFromParent_Done,
     /* 2036470 */   // Label 27153: @2036470
     /* 2036470 */   GIM_Try, /*On fail goto*//*Label 27154*/ GIMT_Encode4(2036561), // Rule ID 14978 //
     /* 2036475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2036486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2036489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2036492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2036495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2036498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036521 */     // MIs[0] round
     /* 2036521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036524 */     // MIs[0] policy
     /* 2036524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036534 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2036537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036560 */     // GIR_Coverage, 14978,
     /* 2036560 */     GIR_EraseRootFromParent_Done,
     /* 2036561 */   // Label 27154: @2036561
     /* 2036561 */   GIM_Try, /*On fail goto*//*Label 27155*/ GIMT_Encode4(2036652), // Rule ID 14979 //
     /* 2036566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2036577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2036580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2036583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2036586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2036589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2036596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2036608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036612 */     // MIs[0] round
     /* 2036612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036615 */     // MIs[0] policy
     /* 2036615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036625 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2036628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036651 */     // GIR_Coverage, 14979,
     /* 2036651 */     GIR_EraseRootFromParent_Done,
     /* 2036652 */   // Label 27155: @2036652
     /* 2036652 */   GIM_Try, /*On fail goto*//*Label 27156*/ GIMT_Encode4(2036743), // Rule ID 14982 //
     /* 2036657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2036668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2036671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2036674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2036677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036703 */     // MIs[0] round
     /* 2036703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036706 */     // MIs[0] policy
     /* 2036706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036742 */     // GIR_Coverage, 14982,
     /* 2036742 */     GIR_EraseRootFromParent_Done,
     /* 2036743 */   // Label 27156: @2036743
     /* 2036743 */   GIM_Try, /*On fail goto*//*Label 27157*/ GIMT_Encode4(2036834), // Rule ID 14983 //
     /* 2036748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2036759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2036762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2036765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2036768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036794 */     // MIs[0] round
     /* 2036794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036797 */     // MIs[0] policy
     /* 2036797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2036810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036833 */     // GIR_Coverage, 14983,
     /* 2036833 */     GIR_EraseRootFromParent_Done,
     /* 2036834 */   // Label 27157: @2036834
     /* 2036834 */   GIM_Try, /*On fail goto*//*Label 27158*/ GIMT_Encode4(2036925), // Rule ID 14986 //
     /* 2036839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2036850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2036853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2036856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2036859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036885 */     // MIs[0] round
     /* 2036885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036888 */     // MIs[0] policy
     /* 2036888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036924 */     // GIR_Coverage, 14986,
     /* 2036924 */     GIR_EraseRootFromParent_Done,
     /* 2036925 */   // Label 27158: @2036925
     /* 2036925 */   GIM_Try, /*On fail goto*//*Label 27159*/ GIMT_Encode4(2037016), // Rule ID 14987 //
     /* 2036930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2036938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2036941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2036944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2036947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2036950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2036960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2036972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036976 */     // MIs[0] round
     /* 2036976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036979 */     // MIs[0] policy
     /* 2036979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036989 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2036992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037015 */     // GIR_Coverage, 14987,
     /* 2037015 */     GIR_EraseRootFromParent_Done,
     /* 2037016 */   // Label 27159: @2037016
     /* 2037016 */   GIM_Try, /*On fail goto*//*Label 27160*/ GIMT_Encode4(2037107), // Rule ID 14990 //
     /* 2037021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2037041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037067 */     // MIs[0] round
     /* 2037067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037070 */     // MIs[0] policy
     /* 2037070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037080 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037106 */     // GIR_Coverage, 14990,
     /* 2037106 */     GIR_EraseRootFromParent_Done,
     /* 2037107 */   // Label 27160: @2037107
     /* 2037107 */   GIM_Try, /*On fail goto*//*Label 27161*/ GIMT_Encode4(2037198), // Rule ID 14991 //
     /* 2037112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2037132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037158 */     // MIs[0] round
     /* 2037158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037161 */     // MIs[0] policy
     /* 2037161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037171 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037197 */     // GIR_Coverage, 14991,
     /* 2037197 */     GIR_EraseRootFromParent_Done,
     /* 2037198 */   // Label 27161: @2037198
     /* 2037198 */   GIM_Try, /*On fail goto*//*Label 27162*/ GIMT_Encode4(2037289), // Rule ID 14994 //
     /* 2037203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2037220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037249 */     // MIs[0] round
     /* 2037249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037252 */     // MIs[0] policy
     /* 2037252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037288 */     // GIR_Coverage, 14994,
     /* 2037288 */     GIR_EraseRootFromParent_Done,
     /* 2037289 */   // Label 27162: @2037289
     /* 2037289 */   GIM_Try, /*On fail goto*//*Label 27163*/ GIMT_Encode4(2037380), // Rule ID 14995 //
     /* 2037294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2037311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2037314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037340 */     // MIs[0] round
     /* 2037340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037343 */     // MIs[0] policy
     /* 2037343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037353 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037379 */     // GIR_Coverage, 14995,
     /* 2037379 */     GIR_EraseRootFromParent_Done,
     /* 2037380 */   // Label 27163: @2037380
     /* 2037380 */   GIM_Try, /*On fail goto*//*Label 27164*/ GIMT_Encode4(2037471), // Rule ID 14998 //
     /* 2037385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2037402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037431 */     // MIs[0] round
     /* 2037431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037434 */     // MIs[0] policy
     /* 2037434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037470 */     // GIR_Coverage, 14998,
     /* 2037470 */     GIR_EraseRootFromParent_Done,
     /* 2037471 */   // Label 27164: @2037471
     /* 2037471 */   GIM_Try, /*On fail goto*//*Label 27165*/ GIMT_Encode4(2037562), // Rule ID 14999 //
     /* 2037476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2037487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2037490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2037493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2037496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037522 */     // MIs[0] round
     /* 2037522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037525 */     // MIs[0] policy
     /* 2037525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037535 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037561 */     // GIR_Coverage, 14999,
     /* 2037561 */     GIR_EraseRootFromParent_Done,
     /* 2037562 */   // Label 27165: @2037562
     /* 2037562 */   GIM_Try, /*On fail goto*//*Label 27166*/ GIMT_Encode4(2037653), // Rule ID 15002 //
     /* 2037567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2037578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2037581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2037584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2037587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037613 */     // MIs[0] round
     /* 2037613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037616 */     // MIs[0] policy
     /* 2037616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037652 */     // GIR_Coverage, 15002,
     /* 2037652 */     GIR_EraseRootFromParent_Done,
     /* 2037653 */   // Label 27166: @2037653
     /* 2037653 */   GIM_Try, /*On fail goto*//*Label 27167*/ GIMT_Encode4(2037744), // Rule ID 15003 //
     /* 2037658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2037669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2037672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2037675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2037678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037704 */     // MIs[0] round
     /* 2037704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037707 */     // MIs[0] policy
     /* 2037707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037717 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2037720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2037740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037743 */     // GIR_Coverage, 15003,
     /* 2037743 */     GIR_EraseRootFromParent_Done,
     /* 2037744 */   // Label 27167: @2037744
     /* 2037744 */   GIM_Try, /*On fail goto*//*Label 27168*/ GIMT_Encode4(2037835), // Rule ID 15006 //
     /* 2037749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2037752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2037760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2037763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2037766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2037769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2037772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037795 */     // MIs[0] round
     /* 2037795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037798 */     // MIs[0] policy
     /* 2037798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2037831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037834 */     // GIR_Coverage, 15006,
     /* 2037834 */     GIR_EraseRootFromParent_Done,
     /* 2037835 */   // Label 27168: @2037835
     /* 2037835 */   GIM_Try, /*On fail goto*//*Label 27169*/ GIMT_Encode4(2037926), // Rule ID 15007 //
     /* 2037840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2037843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2037851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2037854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2037857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2037860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2037863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037886 */     // MIs[0] round
     /* 2037886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037889 */     // MIs[0] policy
     /* 2037889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037899 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2037902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2037922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037925 */     // GIR_Coverage, 15007,
     /* 2037925 */     GIR_EraseRootFromParent_Done,
     /* 2037926 */   // Label 27169: @2037926
     /* 2037926 */   GIM_Try, /*On fail goto*//*Label 27170*/ GIMT_Encode4(2038017), // Rule ID 15010 //
     /* 2037931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2037934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2037939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2037942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2037945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2037948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2037951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2037954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037977 */     // MIs[0] round
     /* 2037977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037980 */     // MIs[0] policy
     /* 2037980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037990 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2037993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038016 */     // GIR_Coverage, 15010,
     /* 2038016 */     GIR_EraseRootFromParent_Done,
     /* 2038017 */   // Label 27170: @2038017
     /* 2038017 */   GIM_Try, /*On fail goto*//*Label 27171*/ GIMT_Encode4(2038108), // Rule ID 15011 //
     /* 2038022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2038039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2038042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038068 */     // MIs[0] round
     /* 2038068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038071 */     // MIs[0] policy
     /* 2038071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038081 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2038084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038107 */     // GIR_Coverage, 15011,
     /* 2038107 */     GIR_EraseRootFromParent_Done,
     /* 2038108 */   // Label 27171: @2038108
     /* 2038108 */   GIM_Try, /*On fail goto*//*Label 27172*/ GIMT_Encode4(2038199), // Rule ID 15014 //
     /* 2038113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2038130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2038133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038159 */     // MIs[0] round
     /* 2038159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038162 */     // MIs[0] policy
     /* 2038162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038172 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038198 */     // GIR_Coverage, 15014,
     /* 2038198 */     GIR_EraseRootFromParent_Done,
     /* 2038199 */   // Label 27172: @2038199
     /* 2038199 */   GIM_Try, /*On fail goto*//*Label 27173*/ GIMT_Encode4(2038290), // Rule ID 15015 //
     /* 2038204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2038221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2038224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038250 */     // MIs[0] round
     /* 2038250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038253 */     // MIs[0] policy
     /* 2038253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038263 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2038266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038289 */     // GIR_Coverage, 15015,
     /* 2038289 */     GIR_EraseRootFromParent_Done,
     /* 2038290 */   // Label 27173: @2038290
     /* 2038290 */   GIM_Try, /*On fail goto*//*Label 27174*/ GIMT_Encode4(2038381), // Rule ID 15018 //
     /* 2038295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2038306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2038309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2038312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038341 */     // MIs[0] round
     /* 2038341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038344 */     // MIs[0] policy
     /* 2038344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038354 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2038357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038380 */     // GIR_Coverage, 15018,
     /* 2038380 */     GIR_EraseRootFromParent_Done,
     /* 2038381 */   // Label 27174: @2038381
     /* 2038381 */   GIM_Try, /*On fail goto*//*Label 27175*/ GIMT_Encode4(2038472), // Rule ID 15019 //
     /* 2038386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2038397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2038400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2038403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038432 */     // MIs[0] round
     /* 2038432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038435 */     // MIs[0] policy
     /* 2038435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038445 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2038448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038471 */     // GIR_Coverage, 15019,
     /* 2038471 */     GIR_EraseRootFromParent_Done,
     /* 2038472 */   // Label 27175: @2038472
     /* 2038472 */   GIM_Try, /*On fail goto*//*Label 27176*/ GIMT_Encode4(2038563), // Rule ID 15022 //
     /* 2038477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2038488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2038491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2038494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038523 */     // MIs[0] round
     /* 2038523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038526 */     // MIs[0] policy
     /* 2038526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038536 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2038539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038562 */     // GIR_Coverage, 15022,
     /* 2038562 */     GIR_EraseRootFromParent_Done,
     /* 2038563 */   // Label 27176: @2038563
     /* 2038563 */   GIM_Try, /*On fail goto*//*Label 27177*/ GIMT_Encode4(2038654), // Rule ID 15023 //
     /* 2038568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2038579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2038582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2038585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038614 */     // MIs[0] round
     /* 2038614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038617 */     // MIs[0] policy
     /* 2038617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038627 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2038630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038653 */     // GIR_Coverage, 15023,
     /* 2038653 */     GIR_EraseRootFromParent_Done,
     /* 2038654 */   // Label 27177: @2038654
     /* 2038654 */   GIM_Try, /*On fail goto*//*Label 27178*/ GIMT_Encode4(2038745), // Rule ID 15026 //
     /* 2038659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2038670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2038673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2038676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038705 */     // MIs[0] round
     /* 2038705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038708 */     // MIs[0] policy
     /* 2038708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2038721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038744 */     // GIR_Coverage, 15026,
     /* 2038744 */     GIR_EraseRootFromParent_Done,
     /* 2038745 */   // Label 27178: @2038745
     /* 2038745 */   GIM_Try, /*On fail goto*//*Label 27179*/ GIMT_Encode4(2038836), // Rule ID 15027 //
     /* 2038750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2038761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2038764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2038767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038796 */     // MIs[0] round
     /* 2038796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038799 */     // MIs[0] policy
     /* 2038799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038809 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2038812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2038832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038835 */     // GIR_Coverage, 15027,
     /* 2038835 */     GIR_EraseRootFromParent_Done,
     /* 2038836 */   // Label 27179: @2038836
     /* 2038836 */   GIM_Try, /*On fail goto*//*Label 27180*/ GIMT_Encode4(2038927), // Rule ID 15030 //
     /* 2038841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2038852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2038855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038887 */     // MIs[0] round
     /* 2038887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038890 */     // MIs[0] policy
     /* 2038890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038900 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2038903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2038923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038926 */     // GIR_Coverage, 15030,
     /* 2038926 */     GIR_EraseRootFromParent_Done,
     /* 2038927 */   // Label 27180: @2038927
     /* 2038927 */   GIM_Try, /*On fail goto*//*Label 27181*/ GIMT_Encode4(2039018), // Rule ID 15031 //
     /* 2038932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2038940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2038943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2038946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2038949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2038955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2038962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2038970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038978 */     // MIs[0] round
     /* 2038978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038981 */     // MIs[0] policy
     /* 2038981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038991 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2038994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039017 */     // GIR_Coverage, 15031,
     /* 2039017 */     GIR_EraseRootFromParent_Done,
     /* 2039018 */   // Label 27181: @2039018
     /* 2039018 */   GIM_Try, /*On fail goto*//*Label 27182*/ GIMT_Encode4(2039109), // Rule ID 15034 //
     /* 2039023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039069 */     // MIs[0] round
     /* 2039069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039072 */     // MIs[0] policy
     /* 2039072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039082 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039108 */     // GIR_Coverage, 15034,
     /* 2039108 */     GIR_EraseRootFromParent_Done,
     /* 2039109 */   // Label 27182: @2039109
     /* 2039109 */   GIM_Try, /*On fail goto*//*Label 27183*/ GIMT_Encode4(2039200), // Rule ID 15035 //
     /* 2039114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039160 */     // MIs[0] round
     /* 2039160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039163 */     // MIs[0] policy
     /* 2039163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039173 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039199 */     // GIR_Coverage, 15035,
     /* 2039199 */     GIR_EraseRootFromParent_Done,
     /* 2039200 */   // Label 27183: @2039200
     /* 2039200 */   GIM_Try, /*On fail goto*//*Label 27184*/ GIMT_Encode4(2039291), // Rule ID 15038 //
     /* 2039205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039251 */     // MIs[0] round
     /* 2039251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039254 */     // MIs[0] policy
     /* 2039254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039290 */     // GIR_Coverage, 15038,
     /* 2039290 */     GIR_EraseRootFromParent_Done,
     /* 2039291 */   // Label 27184: @2039291
     /* 2039291 */   GIM_Try, /*On fail goto*//*Label 27185*/ GIMT_Encode4(2039382), // Rule ID 15039 //
     /* 2039296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2039310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2039313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039342 */     // MIs[0] round
     /* 2039342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039345 */     // MIs[0] policy
     /* 2039345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039355 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2039358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039381 */     // GIR_Coverage, 15039,
     /* 2039381 */     GIR_EraseRootFromParent_Done,
     /* 2039382 */   // Label 27185: @2039382
     /* 2039382 */   GIM_Try, /*On fail goto*//*Label 27186*/ GIMT_Encode4(2039473), // Rule ID 15042 //
     /* 2039387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039433 */     // MIs[0] round
     /* 2039433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039436 */     // MIs[0] policy
     /* 2039436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039446 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039472 */     // GIR_Coverage, 15042,
     /* 2039472 */     GIR_EraseRootFromParent_Done,
     /* 2039473 */   // Label 27186: @2039473
     /* 2039473 */   GIM_Try, /*On fail goto*//*Label 27187*/ GIMT_Encode4(2039564), // Rule ID 15043 //
     /* 2039478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2039489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2039492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2039495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039524 */     // MIs[0] round
     /* 2039524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039527 */     // MIs[0] policy
     /* 2039527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039537 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11141:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039563 */     // GIR_Coverage, 15043,
     /* 2039563 */     GIR_EraseRootFromParent_Done,
     /* 2039564 */   // Label 27187: @2039564
     /* 2039564 */   GIM_Try, /*On fail goto*//*Label 27188*/ GIMT_Encode4(2039655), // Rule ID 15046 //
     /* 2039569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2039580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2039583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2039586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039615 */     // MIs[0] round
     /* 2039615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039618 */     // MIs[0] policy
     /* 2039618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039654 */     // GIR_Coverage, 15046,
     /* 2039654 */     GIR_EraseRootFromParent_Done,
     /* 2039655 */   // Label 27188: @2039655
     /* 2039655 */   GIM_Try, /*On fail goto*//*Label 27189*/ GIMT_Encode4(2039746), // Rule ID 15047 //
     /* 2039660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2039671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2039674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2039677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039706 */     // MIs[0] round
     /* 2039706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039709 */     // MIs[0] policy
     /* 2039709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039719 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039745 */     // GIR_Coverage, 15047,
     /* 2039745 */     GIR_EraseRootFromParent_Done,
     /* 2039746 */   // Label 27189: @2039746
     /* 2039746 */   GIM_Try, /*On fail goto*//*Label 27190*/ GIMT_Encode4(2039837), // Rule ID 15050 //
     /* 2039751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2039762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2039765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2039768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039797 */     // MIs[0] round
     /* 2039797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039800 */     // MIs[0] policy
     /* 2039800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039810 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039836 */     // GIR_Coverage, 15050,
     /* 2039836 */     GIR_EraseRootFromParent_Done,
     /* 2039837 */   // Label 27190: @2039837
     /* 2039837 */   GIM_Try, /*On fail goto*//*Label 27191*/ GIMT_Encode4(2039928), // Rule ID 15051 //
     /* 2039842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2039853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2039856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2039859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039888 */     // MIs[0] round
     /* 2039888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039891 */     // MIs[0] policy
     /* 2039891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039901 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2039924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039927 */     // GIR_Coverage, 15051,
     /* 2039927 */     GIR_EraseRootFromParent_Done,
     /* 2039928 */   // Label 27191: @2039928
     /* 2039928 */   GIM_Try, /*On fail goto*//*Label 27192*/ GIMT_Encode4(2040019), // Rule ID 15054 //
     /* 2039933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2039936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2039941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2039944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2039947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2039950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2039953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039979 */     // MIs[0] round
     /* 2039979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039982 */     // MIs[0] policy
     /* 2039982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039992 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2039995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040018 */     // GIR_Coverage, 15054,
     /* 2040018 */     GIR_EraseRootFromParent_Done,
     /* 2040019 */   // Label 27192: @2040019
     /* 2040019 */   GIM_Try, /*On fail goto*//*Label 27193*/ GIMT_Encode4(2040110), // Rule ID 15055 //
     /* 2040024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2040027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2040035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2040038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2040041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040070 */     // MIs[0] round
     /* 2040070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040073 */     // MIs[0] policy
     /* 2040073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040083 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2040086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040109 */     // GIR_Coverage, 15055,
     /* 2040109 */     GIR_EraseRootFromParent_Done,
     /* 2040110 */   // Label 27193: @2040110
     /* 2040110 */   GIM_Try, /*On fail goto*//*Label 27194*/ GIMT_Encode4(2040201), // Rule ID 15058 //
     /* 2040115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040161 */     // MIs[0] round
     /* 2040161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040164 */     // MIs[0] policy
     /* 2040164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040174 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040200 */     // GIR_Coverage, 15058,
     /* 2040200 */     GIR_EraseRootFromParent_Done,
     /* 2040201 */   // Label 27194: @2040201
     /* 2040201 */   GIM_Try, /*On fail goto*//*Label 27195*/ GIMT_Encode4(2040292), // Rule ID 15059 //
     /* 2040206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040252 */     // MIs[0] round
     /* 2040252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040255 */     // MIs[0] policy
     /* 2040255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040265 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040291 */     // GIR_Coverage, 15059,
     /* 2040291 */     GIR_EraseRootFromParent_Done,
     /* 2040292 */   // Label 27195: @2040292
     /* 2040292 */   GIM_Try, /*On fail goto*//*Label 27196*/ GIMT_Encode4(2040383), // Rule ID 15062 //
     /* 2040297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040343 */     // MIs[0] round
     /* 2040343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040346 */     // MIs[0] policy
     /* 2040346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040382 */     // GIR_Coverage, 15062,
     /* 2040382 */     GIR_EraseRootFromParent_Done,
     /* 2040383 */   // Label 27196: @2040383
     /* 2040383 */   GIM_Try, /*On fail goto*//*Label 27197*/ GIMT_Encode4(2040474), // Rule ID 15063 //
     /* 2040388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2040399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2040402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2040405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2040411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040434 */     // MIs[0] round
     /* 2040434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040437 */     // MIs[0] policy
     /* 2040437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040447 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040473 */     // GIR_Coverage, 15063,
     /* 2040473 */     GIR_EraseRootFromParent_Done,
     /* 2040474 */   // Label 27197: @2040474
     /* 2040474 */   GIM_Try, /*On fail goto*//*Label 27198*/ GIMT_Encode4(2040565), // Rule ID 15066 //
     /* 2040479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2040490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2040493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2040496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2040502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040525 */     // MIs[0] round
     /* 2040525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040528 */     // MIs[0] policy
     /* 2040528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040538 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2040541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040564 */     // GIR_Coverage, 15066,
     /* 2040564 */     GIR_EraseRootFromParent_Done,
     /* 2040565 */   // Label 27198: @2040565
     /* 2040565 */   GIM_Try, /*On fail goto*//*Label 27199*/ GIMT_Encode4(2040656), // Rule ID 15067 //
     /* 2040570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2040581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2040584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2040587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2040593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2040600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2040608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040616 */     // MIs[0] round
     /* 2040616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040619 */     // MIs[0] policy
     /* 2040619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040629 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2040632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040655 */     // GIR_Coverage, 15067,
     /* 2040655 */     GIR_EraseRootFromParent_Done,
     /* 2040656 */   // Label 27199: @2040656
     /* 2040656 */   GIM_Try, /*On fail goto*//*Label 27200*/ GIMT_Encode4(2040747), // Rule ID 15070 //
     /* 2040661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2040672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2040675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2040678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040707 */     // MIs[0] round
     /* 2040707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040710 */     // MIs[0] policy
     /* 2040710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040746 */     // GIR_Coverage, 15070,
     /* 2040746 */     GIR_EraseRootFromParent_Done,
     /* 2040747 */   // Label 27200: @2040747
     /* 2040747 */   GIM_Try, /*On fail goto*//*Label 27201*/ GIMT_Encode4(2040838), // Rule ID 15071 //
     /* 2040752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2040763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2040766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2040769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040798 */     // MIs[0] round
     /* 2040798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040801 */     // MIs[0] policy
     /* 2040801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040811 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2040814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040837 */     // GIR_Coverage, 15071,
     /* 2040837 */     GIR_EraseRootFromParent_Done,
     /* 2040838 */   // Label 27201: @2040838
     /* 2040838 */   GIM_Try, /*On fail goto*//*Label 27202*/ GIMT_Encode4(2040929), // Rule ID 15074 //
     /* 2040843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2040854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2040857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2040860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2040863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040889 */     // MIs[0] round
     /* 2040889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040892 */     // MIs[0] policy
     /* 2040892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040928 */     // GIR_Coverage, 15074,
     /* 2040928 */     GIR_EraseRootFromParent_Done,
     /* 2040929 */   // Label 27202: @2040929
     /* 2040929 */   GIM_Try, /*On fail goto*//*Label 27203*/ GIMT_Encode4(2041020), // Rule ID 15075 //
     /* 2040934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2040942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2040945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2040948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2040951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2040954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2040964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2040972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2040976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040980 */     // MIs[0] round
     /* 2040980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040983 */     // MIs[0] policy
     /* 2040983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040993 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2040996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041019 */     // GIR_Coverage, 15075,
     /* 2041019 */     GIR_EraseRootFromParent_Done,
     /* 2041020 */   // Label 27203: @2041020
     /* 2041020 */   GIM_Try, /*On fail goto*//*Label 27204*/ GIMT_Encode4(2041111), // Rule ID 15078 //
     /* 2041025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041071 */     // MIs[0] round
     /* 2041071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041074 */     // MIs[0] policy
     /* 2041074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041110 */     // GIR_Coverage, 15078,
     /* 2041110 */     GIR_EraseRootFromParent_Done,
     /* 2041111 */   // Label 27204: @2041111
     /* 2041111 */   GIM_Try, /*On fail goto*//*Label 27205*/ GIMT_Encode4(2041202), // Rule ID 15079 //
     /* 2041116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041162 */     // MIs[0] round
     /* 2041162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041165 */     // MIs[0] policy
     /* 2041165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041175 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041201 */     // GIR_Coverage, 15079,
     /* 2041201 */     GIR_EraseRootFromParent_Done,
     /* 2041202 */   // Label 27205: @2041202
     /* 2041202 */   GIM_Try, /*On fail goto*//*Label 27206*/ GIMT_Encode4(2041293), // Rule ID 15082 //
     /* 2041207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041253 */     // MIs[0] round
     /* 2041253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041256 */     // MIs[0] policy
     /* 2041256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041292 */     // GIR_Coverage, 15082,
     /* 2041292 */     GIR_EraseRootFromParent_Done,
     /* 2041293 */   // Label 27206: @2041293
     /* 2041293 */   GIM_Try, /*On fail goto*//*Label 27207*/ GIMT_Encode4(2041384), // Rule ID 15083 //
     /* 2041298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2041309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2041312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2041315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041344 */     // MIs[0] round
     /* 2041344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041347 */     // MIs[0] policy
     /* 2041347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041357 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041383 */     // GIR_Coverage, 15083,
     /* 2041383 */     GIR_EraseRootFromParent_Done,
     /* 2041384 */   // Label 27207: @2041384
     /* 2041384 */   GIM_Try, /*On fail goto*//*Label 27208*/ GIMT_Encode4(2041475), // Rule ID 15086 //
     /* 2041389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041435 */     // MIs[0] round
     /* 2041435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041438 */     // MIs[0] policy
     /* 2041438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041474 */     // GIR_Coverage, 15086,
     /* 2041474 */     GIR_EraseRootFromParent_Done,
     /* 2041475 */   // Label 27208: @2041475
     /* 2041475 */   GIM_Try, /*On fail goto*//*Label 27209*/ GIMT_Encode4(2041566), // Rule ID 15087 //
     /* 2041480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2041491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2041494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2041497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041526 */     // MIs[0] round
     /* 2041526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041529 */     // MIs[0] policy
     /* 2041529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041539 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041565 */     // GIR_Coverage, 15087,
     /* 2041565 */     GIR_EraseRootFromParent_Done,
     /* 2041566 */   // Label 27209: @2041566
     /* 2041566 */   GIM_Try, /*On fail goto*//*Label 27210*/ GIMT_Encode4(2041657), // Rule ID 15090 //
     /* 2041571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2041582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2041585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2041588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041617 */     // MIs[0] round
     /* 2041617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041620 */     // MIs[0] policy
     /* 2041620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041656 */     // GIR_Coverage, 15090,
     /* 2041656 */     GIR_EraseRootFromParent_Done,
     /* 2041657 */   // Label 27210: @2041657
     /* 2041657 */   GIM_Try, /*On fail goto*//*Label 27211*/ GIMT_Encode4(2041748), // Rule ID 15091 //
     /* 2041662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2041673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2041676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2041679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041708 */     // MIs[0] round
     /* 2041708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041711 */     // MIs[0] policy
     /* 2041711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041721 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2041724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2041744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041747 */     // GIR_Coverage, 15091,
     /* 2041747 */     GIR_EraseRootFromParent_Done,
     /* 2041748 */   // Label 27211: @2041748
     /* 2041748 */   GIM_Try, /*On fail goto*//*Label 27212*/ GIMT_Encode4(2041839), // Rule ID 15094 //
     /* 2041753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2041756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2041764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2041767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2041770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2041776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041799 */     // MIs[0] round
     /* 2041799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041802 */     // MIs[0] policy
     /* 2041802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041838 */     // GIR_Coverage, 15094,
     /* 2041838 */     GIR_EraseRootFromParent_Done,
     /* 2041839 */   // Label 27212: @2041839
     /* 2041839 */   GIM_Try, /*On fail goto*//*Label 27213*/ GIMT_Encode4(2041930), // Rule ID 15095 //
     /* 2041844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2041847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2041855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2041858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2041861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2041864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2041867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041890 */     // MIs[0] round
     /* 2041890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041893 */     // MIs[0] policy
     /* 2041893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041903 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2041906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2041926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041929 */     // GIR_Coverage, 15095,
     /* 2041929 */     GIR_EraseRootFromParent_Done,
     /* 2041930 */   // Label 27213: @2041930
     /* 2041930 */   GIM_Try, /*On fail goto*//*Label 27214*/ GIMT_Encode4(2042021), // Rule ID 15098 //
     /* 2041935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2041938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2041943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2041946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2041949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2041952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2041955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2041958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2041977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041981 */     // MIs[0] round
     /* 2041981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041984 */     // MIs[0] policy
     /* 2041984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041994 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2041997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042020 */     // GIR_Coverage, 15098,
     /* 2042020 */     GIR_EraseRootFromParent_Done,
     /* 2042021 */   // Label 27214: @2042021
     /* 2042021 */   GIM_Try, /*On fail goto*//*Label 27215*/ GIMT_Encode4(2042112), // Rule ID 15099 //
     /* 2042026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042072 */     // MIs[0] round
     /* 2042072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042075 */     // MIs[0] policy
     /* 2042075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042085 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2042088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042111 */     // GIR_Coverage, 15099,
     /* 2042111 */     GIR_EraseRootFromParent_Done,
     /* 2042112 */   // Label 27215: @2042112
     /* 2042112 */   GIM_Try, /*On fail goto*//*Label 27216*/ GIMT_Encode4(2042203), // Rule ID 15102 //
     /* 2042117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2042137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042163 */     // MIs[0] round
     /* 2042163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042166 */     // MIs[0] policy
     /* 2042166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042202 */     // GIR_Coverage, 15102,
     /* 2042202 */     GIR_EraseRootFromParent_Done,
     /* 2042203 */   // Label 27216: @2042203
     /* 2042203 */   GIM_Try, /*On fail goto*//*Label 27217*/ GIMT_Encode4(2042294), // Rule ID 15103 //
     /* 2042208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2042216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2042228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2042250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042254 */     // MIs[0] round
     /* 2042254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042257 */     // MIs[0] policy
     /* 2042257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042267 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2042270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042293 */     // GIR_Coverage, 15103,
     /* 2042293 */     GIR_EraseRootFromParent_Done,
     /* 2042294 */   // Label 27217: @2042294
     /* 2042294 */   GIM_Try, /*On fail goto*//*Label 27218*/ GIMT_Encode4(2042385), // Rule ID 15106 //
     /* 2042299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2042319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042345 */     // MIs[0] round
     /* 2042345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042348 */     // MIs[0] policy
     /* 2042348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042358 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2042361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042384 */     // GIR_Coverage, 15106,
     /* 2042384 */     GIR_EraseRootFromParent_Done,
     /* 2042385 */   // Label 27218: @2042385
     /* 2042385 */   GIM_Try, /*On fail goto*//*Label 27219*/ GIMT_Encode4(2042476), // Rule ID 15107 //
     /* 2042390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2042401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2042404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2042407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2042410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042436 */     // MIs[0] round
     /* 2042436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042439 */     // MIs[0] policy
     /* 2042439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042449 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2042452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042475 */     // GIR_Coverage, 15107,
     /* 2042475 */     GIR_EraseRootFromParent_Done,
     /* 2042476 */   // Label 27219: @2042476
     /* 2042476 */   GIM_Try, /*On fail goto*//*Label 27220*/ GIMT_Encode4(2042567), // Rule ID 15110 //
     /* 2042481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2042492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2042495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2042498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2042501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042527 */     // MIs[0] round
     /* 2042527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042530 */     // MIs[0] policy
     /* 2042530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042540 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2042543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042566 */     // GIR_Coverage, 15110,
     /* 2042566 */     GIR_EraseRootFromParent_Done,
     /* 2042567 */   // Label 27220: @2042567
     /* 2042567 */   GIM_Try, /*On fail goto*//*Label 27221*/ GIMT_Encode4(2042658), // Rule ID 15111 //
     /* 2042572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2042583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2042586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2042589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2042592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042618 */     // MIs[0] round
     /* 2042618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042621 */     // MIs[0] policy
     /* 2042621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042631 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2042634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042657 */     // GIR_Coverage, 15111,
     /* 2042657 */     GIR_EraseRootFromParent_Done,
     /* 2042658 */   // Label 27221: @2042658
     /* 2042658 */   GIM_Try, /*On fail goto*//*Label 27222*/ GIMT_Encode4(2042749), // Rule ID 15114 //
     /* 2042663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2042674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2042677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2042680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2042683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042709 */     // MIs[0] round
     /* 2042709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042712 */     // MIs[0] policy
     /* 2042712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042722 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2042725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042748 */     // GIR_Coverage, 15114,
     /* 2042748 */     GIR_EraseRootFromParent_Done,
     /* 2042749 */   // Label 27222: @2042749
     /* 2042749 */   GIM_Try, /*On fail goto*//*Label 27223*/ GIMT_Encode4(2042840), // Rule ID 15115 //
     /* 2042754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2042765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2042768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2042771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2042774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042800 */     // MIs[0] round
     /* 2042800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042803 */     // MIs[0] policy
     /* 2042803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042813 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2042816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2042836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042839 */     // GIR_Coverage, 15115,
     /* 2042839 */     GIR_EraseRootFromParent_Done,
     /* 2042840 */   // Label 27223: @2042840
     /* 2042840 */   GIM_Try, /*On fail goto*//*Label 27224*/ GIMT_Encode4(2042931), // Rule ID 15118 //
     /* 2042845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2042856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2042859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2042862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2042865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042891 */     // MIs[0] round
     /* 2042891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042894 */     // MIs[0] policy
     /* 2042894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2042907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2042927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042930 */     // GIR_Coverage, 15118,
     /* 2042930 */     GIR_EraseRootFromParent_Done,
     /* 2042931 */   // Label 27224: @2042931
     /* 2042931 */   GIM_Try, /*On fail goto*//*Label 27225*/ GIMT_Encode4(2043022), // Rule ID 15119 //
     /* 2042936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2042944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2042947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2042950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2042953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2042956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2042959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2042966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2042978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042982 */     // MIs[0] round
     /* 2042982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042985 */     // MIs[0] policy
     /* 2042985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042995 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2042998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043021 */     // GIR_Coverage, 15119,
     /* 2043021 */     GIR_EraseRootFromParent_Done,
     /* 2043022 */   // Label 27225: @2043022
     /* 2043022 */   GIM_Try, /*On fail goto*//*Label 27226*/ GIMT_Encode4(2043113), // Rule ID 15122 //
     /* 2043027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043073 */     // MIs[0] round
     /* 2043073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043076 */     // MIs[0] policy
     /* 2043076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043112 */     // GIR_Coverage, 15122,
     /* 2043112 */     GIR_EraseRootFromParent_Done,
     /* 2043113 */   // Label 27226: @2043113
     /* 2043113 */   GIM_Try, /*On fail goto*//*Label 27227*/ GIMT_Encode4(2043204), // Rule ID 15123 //
     /* 2043118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2043138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043164 */     // MIs[0] round
     /* 2043164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043167 */     // MIs[0] policy
     /* 2043167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043177 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043203 */     // GIR_Coverage, 15123,
     /* 2043203 */     GIR_EraseRootFromParent_Done,
     /* 2043204 */   // Label 27227: @2043204
     /* 2043204 */   GIM_Try, /*On fail goto*//*Label 27228*/ GIMT_Encode4(2043295), // Rule ID 15126 //
     /* 2043209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043255 */     // MIs[0] round
     /* 2043255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043258 */     // MIs[0] policy
     /* 2043258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043268 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043294 */     // GIR_Coverage, 15126,
     /* 2043294 */     GIR_EraseRootFromParent_Done,
     /* 2043295 */   // Label 27228: @2043295
     /* 2043295 */   GIM_Try, /*On fail goto*//*Label 27229*/ GIMT_Encode4(2043386), // Rule ID 15127 //
     /* 2043300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2043311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2043314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2043317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2043320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043346 */     // MIs[0] round
     /* 2043346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043349 */     // MIs[0] policy
     /* 2043349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043359 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2043362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043385 */     // GIR_Coverage, 15127,
     /* 2043385 */     GIR_EraseRootFromParent_Done,
     /* 2043386 */   // Label 27229: @2043386
     /* 2043386 */   GIM_Try, /*On fail goto*//*Label 27230*/ GIMT_Encode4(2043477), // Rule ID 15130 //
     /* 2043391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2043411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043437 */     // MIs[0] round
     /* 2043437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043440 */     // MIs[0] policy
     /* 2043440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043476 */     // GIR_Coverage, 15130,
     /* 2043476 */     GIR_EraseRootFromParent_Done,
     /* 2043477 */   // Label 27230: @2043477
     /* 2043477 */   GIM_Try, /*On fail goto*//*Label 27231*/ GIMT_Encode4(2043568), // Rule ID 15131 //
     /* 2043482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2043493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2043496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2043499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2043502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043528 */     // MIs[0] round
     /* 2043528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043531 */     // MIs[0] policy
     /* 2043531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043541 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043567 */     // GIR_Coverage, 15131,
     /* 2043567 */     GIR_EraseRootFromParent_Done,
     /* 2043568 */   // Label 27231: @2043568
     /* 2043568 */   GIM_Try, /*On fail goto*//*Label 27232*/ GIMT_Encode4(2043659), // Rule ID 15134 //
     /* 2043573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2043584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2043587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2043590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2043593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043619 */     // MIs[0] round
     /* 2043619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043622 */     // MIs[0] policy
     /* 2043622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043658 */     // GIR_Coverage, 15134,
     /* 2043658 */     GIR_EraseRootFromParent_Done,
     /* 2043659 */   // Label 27232: @2043659
     /* 2043659 */   GIM_Try, /*On fail goto*//*Label 27233*/ GIMT_Encode4(2043750), // Rule ID 15135 //
     /* 2043664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2043675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2043678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2043681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2043684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043710 */     // MIs[0] round
     /* 2043710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043713 */     // MIs[0] policy
     /* 2043713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043723 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043749 */     // GIR_Coverage, 15135,
     /* 2043749 */     GIR_EraseRootFromParent_Done,
     /* 2043750 */   // Label 27233: @2043750
     /* 2043750 */   GIM_Try, /*On fail goto*//*Label 27234*/ GIMT_Encode4(2043841), // Rule ID 15138 //
     /* 2043755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2043766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2043769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2043772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2043775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043801 */     // MIs[0] round
     /* 2043801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043804 */     // MIs[0] policy
     /* 2043804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043840 */     // GIR_Coverage, 15138,
     /* 2043840 */     GIR_EraseRootFromParent_Done,
     /* 2043841 */   // Label 27234: @2043841
     /* 2043841 */   GIM_Try, /*On fail goto*//*Label 27235*/ GIMT_Encode4(2043932), // Rule ID 15139 //
     /* 2043846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2043857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2043860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2043863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2043866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043892 */     // MIs[0] round
     /* 2043892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043895 */     // MIs[0] policy
     /* 2043895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043905 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2043928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043931 */     // GIR_Coverage, 15139,
     /* 2043931 */     GIR_EraseRootFromParent_Done,
     /* 2043932 */   // Label 27235: @2043932
     /* 2043932 */   GIM_Try, /*On fail goto*//*Label 27236*/ GIMT_Encode4(2044023), // Rule ID 15142 //
     /* 2043937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2043940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2043945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2043948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2043951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2043954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2043957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043983 */     // MIs[0] round
     /* 2043983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043986 */     // MIs[0] policy
     /* 2043986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2043999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044022 */     // GIR_Coverage, 15142,
     /* 2044022 */     GIR_EraseRootFromParent_Done,
     /* 2044023 */   // Label 27236: @2044023
     /* 2044023 */   GIM_Try, /*On fail goto*//*Label 27237*/ GIMT_Encode4(2044114), // Rule ID 15143 //
     /* 2044028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2044031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2044039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2044042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2044045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2044048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044074 */     // MIs[0] round
     /* 2044074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044077 */     // MIs[0] policy
     /* 2044077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044087 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2044090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044113 */     // GIR_Coverage, 15143,
     /* 2044113 */     GIR_EraseRootFromParent_Done,
     /* 2044114 */   // Label 27237: @2044114
     /* 2044114 */   GIM_Try, /*On fail goto*//*Label 27238*/ GIMT_Encode4(2044205), // Rule ID 15146 //
     /* 2044119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2044139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044165 */     // MIs[0] round
     /* 2044165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044168 */     // MIs[0] policy
     /* 2044168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044178 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044204 */     // GIR_Coverage, 15146,
     /* 2044204 */     GIR_EraseRootFromParent_Done,
     /* 2044205 */   // Label 27238: @2044205
     /* 2044205 */   GIM_Try, /*On fail goto*//*Label 27239*/ GIMT_Encode4(2044296), // Rule ID 15147 //
     /* 2044210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2044230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044256 */     // MIs[0] round
     /* 2044256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044259 */     // MIs[0] policy
     /* 2044259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044269 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044295 */     // GIR_Coverage, 15147,
     /* 2044295 */     GIR_EraseRootFromParent_Done,
     /* 2044296 */   // Label 27239: @2044296
     /* 2044296 */   GIM_Try, /*On fail goto*//*Label 27240*/ GIMT_Encode4(2044387), // Rule ID 15150 //
     /* 2044301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2044321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044347 */     // MIs[0] round
     /* 2044347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044350 */     // MIs[0] policy
     /* 2044350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044360 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044386 */     // GIR_Coverage, 15150,
     /* 2044386 */     GIR_EraseRootFromParent_Done,
     /* 2044387 */   // Label 27240: @2044387
     /* 2044387 */   GIM_Try, /*On fail goto*//*Label 27241*/ GIMT_Encode4(2044478), // Rule ID 15151 //
     /* 2044392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2044403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2044406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2044409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2044412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2044415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044438 */     // MIs[0] round
     /* 2044438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044441 */     // MIs[0] policy
     /* 2044441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044451 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044477 */     // GIR_Coverage, 15151,
     /* 2044477 */     GIR_EraseRootFromParent_Done,
     /* 2044478 */   // Label 27241: @2044478
     /* 2044478 */   GIM_Try, /*On fail goto*//*Label 27242*/ GIMT_Encode4(2044569), // Rule ID 15154 //
     /* 2044483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2044494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2044497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2044500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2044503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2044506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044529 */     // MIs[0] round
     /* 2044529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044532 */     // MIs[0] policy
     /* 2044532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044542 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2044545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044568 */     // GIR_Coverage, 15154,
     /* 2044568 */     GIR_EraseRootFromParent_Done,
     /* 2044569 */   // Label 27242: @2044569
     /* 2044569 */   GIM_Try, /*On fail goto*//*Label 27243*/ GIMT_Encode4(2044660), // Rule ID 15155 //
     /* 2044574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2044585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2044588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2044591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2044594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2044597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2044604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2044616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044620 */     // MIs[0] round
     /* 2044620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044623 */     // MIs[0] policy
     /* 2044623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044633 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2044636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044659 */     // GIR_Coverage, 15155,
     /* 2044659 */     GIR_EraseRootFromParent_Done,
     /* 2044660 */   // Label 27243: @2044660
     /* 2044660 */   GIM_Try, /*On fail goto*//*Label 27244*/ GIMT_Encode4(2044751), // Rule ID 15158 //
     /* 2044665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2044676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2044679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2044682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2044685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044711 */     // MIs[0] round
     /* 2044711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044714 */     // MIs[0] policy
     /* 2044714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044750 */     // GIR_Coverage, 15158,
     /* 2044750 */     GIR_EraseRootFromParent_Done,
     /* 2044751 */   // Label 27244: @2044751
     /* 2044751 */   GIM_Try, /*On fail goto*//*Label 27245*/ GIMT_Encode4(2044842), // Rule ID 15159 //
     /* 2044756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2044767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2044770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2044773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2044776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044802 */     // MIs[0] round
     /* 2044802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044805 */     // MIs[0] policy
     /* 2044805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044815 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2044818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044841 */     // GIR_Coverage, 15159,
     /* 2044841 */     GIR_EraseRootFromParent_Done,
     /* 2044842 */   // Label 27245: @2044842
     /* 2044842 */   GIM_Try, /*On fail goto*//*Label 27246*/ GIMT_Encode4(2044933), // Rule ID 15162 //
     /* 2044847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2044858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2044861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2044864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2044867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044893 */     // MIs[0] round
     /* 2044893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044896 */     // MIs[0] policy
     /* 2044896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044906 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2044909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044932 */     // GIR_Coverage, 15162,
     /* 2044932 */     GIR_EraseRootFromParent_Done,
     /* 2044933 */   // Label 27246: @2044933
     /* 2044933 */   GIM_Try, /*On fail goto*//*Label 27247*/ GIMT_Encode4(2045024), // Rule ID 15163 //
     /* 2044938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2044946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2044949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2044952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2044955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2044958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2044968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2044980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044984 */     // MIs[0] round
     /* 2044984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044987 */     // MIs[0] policy
     /* 2044987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044997 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045023 */     // GIR_Coverage, 15163,
     /* 2045023 */     GIR_EraseRootFromParent_Done,
     /* 2045024 */   // Label 27247: @2045024
     /* 2045024 */   GIM_Try, /*On fail goto*//*Label 27248*/ GIMT_Encode4(2045115), // Rule ID 15166 //
     /* 2045029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2045049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045075 */     // MIs[0] round
     /* 2045075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045078 */     // MIs[0] policy
     /* 2045078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045088 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045114 */     // GIR_Coverage, 15166,
     /* 2045114 */     GIR_EraseRootFromParent_Done,
     /* 2045115 */   // Label 27248: @2045115
     /* 2045115 */   GIM_Try, /*On fail goto*//*Label 27249*/ GIMT_Encode4(2045206), // Rule ID 15167 //
     /* 2045120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2045140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045166 */     // MIs[0] round
     /* 2045166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045169 */     // MIs[0] policy
     /* 2045169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045179 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045205 */     // GIR_Coverage, 15167,
     /* 2045205 */     GIR_EraseRootFromParent_Done,
     /* 2045206 */   // Label 27249: @2045206
     /* 2045206 */   GIM_Try, /*On fail goto*//*Label 27250*/ GIMT_Encode4(2045297), // Rule ID 15170 //
     /* 2045211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2045231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045257 */     // MIs[0] round
     /* 2045257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045260 */     // MIs[0] policy
     /* 2045260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045296 */     // GIR_Coverage, 15170,
     /* 2045296 */     GIR_EraseRootFromParent_Done,
     /* 2045297 */   // Label 27250: @2045297
     /* 2045297 */   GIM_Try, /*On fail goto*//*Label 27251*/ GIMT_Encode4(2045388), // Rule ID 15171 //
     /* 2045302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2045313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2045316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2045319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2045322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045348 */     // MIs[0] round
     /* 2045348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045351 */     // MIs[0] policy
     /* 2045351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045387 */     // GIR_Coverage, 15171,
     /* 2045387 */     GIR_EraseRootFromParent_Done,
     /* 2045388 */   // Label 27251: @2045388
     /* 2045388 */   GIM_Try, /*On fail goto*//*Label 27252*/ GIMT_Encode4(2045479), // Rule ID 15174 //
     /* 2045393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2045413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045439 */     // MIs[0] round
     /* 2045439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045442 */     // MIs[0] policy
     /* 2045442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045478 */     // GIR_Coverage, 15174,
     /* 2045478 */     GIR_EraseRootFromParent_Done,
     /* 2045479 */   // Label 27252: @2045479
     /* 2045479 */   GIM_Try, /*On fail goto*//*Label 27253*/ GIMT_Encode4(2045570), // Rule ID 15175 //
     /* 2045484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2045495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2045498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2045501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2045504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045530 */     // MIs[0] round
     /* 2045530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045533 */     // MIs[0] policy
     /* 2045533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045543 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2045546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045569 */     // GIR_Coverage, 15175,
     /* 2045569 */     GIR_EraseRootFromParent_Done,
     /* 2045570 */   // Label 27253: @2045570
     /* 2045570 */   GIM_Try, /*On fail goto*//*Label 27254*/ GIMT_Encode4(2045661), // Rule ID 15178 //
     /* 2045575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2045586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2045589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2045592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2045595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045621 */     // MIs[0] round
     /* 2045621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045624 */     // MIs[0] policy
     /* 2045624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045660 */     // GIR_Coverage, 15178,
     /* 2045660 */     GIR_EraseRootFromParent_Done,
     /* 2045661 */   // Label 27254: @2045661
     /* 2045661 */   GIM_Try, /*On fail goto*//*Label 27255*/ GIMT_Encode4(2045752), // Rule ID 15179 //
     /* 2045666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2045677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2045680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2045683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2045686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045712 */     // MIs[0] round
     /* 2045712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045715 */     // MIs[0] policy
     /* 2045715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045725 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2045728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2045748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045751 */     // GIR_Coverage, 15179,
     /* 2045751 */     GIR_EraseRootFromParent_Done,
     /* 2045752 */   // Label 27255: @2045752
     /* 2045752 */   GIM_Try, /*On fail goto*//*Label 27256*/ GIMT_Encode4(2045843), // Rule ID 15182 //
     /* 2045757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2045760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2045768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2045771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2045774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2045777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045803 */     // MIs[0] round
     /* 2045803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045806 */     // MIs[0] policy
     /* 2045806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045842 */     // GIR_Coverage, 15182,
     /* 2045842 */     GIR_EraseRootFromParent_Done,
     /* 2045843 */   // Label 27256: @2045843
     /* 2045843 */   GIM_Try, /*On fail goto*//*Label 27257*/ GIMT_Encode4(2045934), // Rule ID 15183 //
     /* 2045848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2045851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2045859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2045862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2045865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2045868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2045871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045894 */     // MIs[0] round
     /* 2045894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045897 */     // MIs[0] policy
     /* 2045897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045907 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2045910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2045930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045933 */     // GIR_Coverage, 15183,
     /* 2045933 */     GIR_EraseRootFromParent_Done,
     /* 2045934 */   // Label 27257: @2045934
     /* 2045934 */   GIM_Try, /*On fail goto*//*Label 27258*/ GIMT_Encode4(2046025), // Rule ID 15186 //
     /* 2045939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2045942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2045947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2045950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2045953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2045956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2045959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2045962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045985 */     // MIs[0] round
     /* 2045985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045988 */     // MIs[0] policy
     /* 2045988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045998 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046024 */     // GIR_Coverage, 15186,
     /* 2046024 */     GIR_EraseRootFromParent_Done,
     /* 2046025 */   // Label 27258: @2046025
     /* 2046025 */   GIM_Try, /*On fail goto*//*Label 27259*/ GIMT_Encode4(2046116), // Rule ID 15187 //
     /* 2046030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2046041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2046044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2046047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2046050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046076 */     // MIs[0] round
     /* 2046076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046079 */     // MIs[0] policy
     /* 2046079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046089 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2046092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046115 */     // GIR_Coverage, 15187,
     /* 2046115 */     GIR_EraseRootFromParent_Done,
     /* 2046116 */   // Label 27259: @2046116
     /* 2046116 */   GIM_Try, /*On fail goto*//*Label 27260*/ GIMT_Encode4(2046207), // Rule ID 15190 //
     /* 2046121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2046141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046167 */     // MIs[0] round
     /* 2046167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046170 */     // MIs[0] policy
     /* 2046170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046180 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046206 */     // GIR_Coverage, 15190,
     /* 2046206 */     GIR_EraseRootFromParent_Done,
     /* 2046207 */   // Label 27260: @2046207
     /* 2046207 */   GIM_Try, /*On fail goto*//*Label 27261*/ GIMT_Encode4(2046298), // Rule ID 15191 //
     /* 2046212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2046232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046258 */     // MIs[0] round
     /* 2046258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046261 */     // MIs[0] policy
     /* 2046261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046271 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2046274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046297 */     // GIR_Coverage, 15191,
     /* 2046297 */     GIR_EraseRootFromParent_Done,
     /* 2046298 */   // Label 27261: @2046298
     /* 2046298 */   GIM_Try, /*On fail goto*//*Label 27262*/ GIMT_Encode4(2046389), // Rule ID 15194 //
     /* 2046303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046349 */     // MIs[0] round
     /* 2046349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046352 */     // MIs[0] policy
     /* 2046352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046362 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2046365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046388 */     // GIR_Coverage, 15194,
     /* 2046388 */     GIR_EraseRootFromParent_Done,
     /* 2046389 */   // Label 27262: @2046389
     /* 2046389 */   GIM_Try, /*On fail goto*//*Label 27263*/ GIMT_Encode4(2046480), // Rule ID 15195 //
     /* 2046394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2046405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2046408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2046411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046440 */     // MIs[0] round
     /* 2046440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046443 */     // MIs[0] policy
     /* 2046443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046453 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2046456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046479 */     // GIR_Coverage, 15195,
     /* 2046479 */     GIR_EraseRootFromParent_Done,
     /* 2046480 */   // Label 27263: @2046480
     /* 2046480 */   GIM_Try, /*On fail goto*//*Label 27264*/ GIMT_Encode4(2046571), // Rule ID 15198 //
     /* 2046485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2046496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2046499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2046502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046531 */     // MIs[0] round
     /* 2046531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046534 */     // MIs[0] policy
     /* 2046534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046544 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2046547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046570 */     // GIR_Coverage, 15198,
     /* 2046570 */     GIR_EraseRootFromParent_Done,
     /* 2046571 */   // Label 27264: @2046571
     /* 2046571 */   GIM_Try, /*On fail goto*//*Label 27265*/ GIMT_Encode4(2046662), // Rule ID 15199 //
     /* 2046576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2046587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2046590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2046593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046622 */     // MIs[0] round
     /* 2046622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046625 */     // MIs[0] policy
     /* 2046625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046635 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2046638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046661 */     // GIR_Coverage, 15199,
     /* 2046661 */     GIR_EraseRootFromParent_Done,
     /* 2046662 */   // Label 27265: @2046662
     /* 2046662 */   GIM_Try, /*On fail goto*//*Label 27266*/ GIMT_Encode4(2046753), // Rule ID 15202 //
     /* 2046667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2046678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2046681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2046684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046713 */     // MIs[0] round
     /* 2046713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046716 */     // MIs[0] policy
     /* 2046716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2046729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046752 */     // GIR_Coverage, 15202,
     /* 2046752 */     GIR_EraseRootFromParent_Done,
     /* 2046753 */   // Label 27266: @2046753
     /* 2046753 */   GIM_Try, /*On fail goto*//*Label 27267*/ GIMT_Encode4(2046844), // Rule ID 15203 //
     /* 2046758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2046769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2046772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2046775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046804 */     // MIs[0] round
     /* 2046804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046807 */     // MIs[0] policy
     /* 2046807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046817 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2046820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2046840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046843 */     // GIR_Coverage, 15203,
     /* 2046843 */     GIR_EraseRootFromParent_Done,
     /* 2046844 */   // Label 27267: @2046844
     /* 2046844 */   GIM_Try, /*On fail goto*//*Label 27268*/ GIMT_Encode4(2046935), // Rule ID 15206 //
     /* 2046849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2046860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2046863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2046866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046895 */     // MIs[0] round
     /* 2046895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046898 */     // MIs[0] policy
     /* 2046898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2046911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2046931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046934 */     // GIR_Coverage, 15206,
     /* 2046934 */     GIR_EraseRootFromParent_Done,
     /* 2046935 */   // Label 27268: @2046935
     /* 2046935 */   GIM_Try, /*On fail goto*//*Label 27269*/ GIMT_Encode4(2047026), // Rule ID 15207 //
     /* 2046940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2046948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2046951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2046954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2046957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2046963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2046970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2046978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046986 */     // MIs[0] round
     /* 2046986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046989 */     // MIs[0] policy
     /* 2046989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046999 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2047002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047025 */     // GIR_Coverage, 15207,
     /* 2047025 */     GIR_EraseRootFromParent_Done,
     /* 2047026 */   // Label 27269: @2047026
     /* 2047026 */   GIM_Try, /*On fail goto*//*Label 27270*/ GIMT_Encode4(2047117), // Rule ID 15210 //
     /* 2047031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047077 */     // MIs[0] round
     /* 2047077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047080 */     // MIs[0] policy
     /* 2047080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047090 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047116 */     // GIR_Coverage, 15210,
     /* 2047116 */     GIR_EraseRootFromParent_Done,
     /* 2047117 */   // Label 27270: @2047117
     /* 2047117 */   GIM_Try, /*On fail goto*//*Label 27271*/ GIMT_Encode4(2047208), // Rule ID 15211 //
     /* 2047122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047168 */     // MIs[0] round
     /* 2047168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047171 */     // MIs[0] policy
     /* 2047171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047181 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047207 */     // GIR_Coverage, 15211,
     /* 2047207 */     GIR_EraseRootFromParent_Done,
     /* 2047208 */   // Label 27271: @2047208
     /* 2047208 */   GIM_Try, /*On fail goto*//*Label 27272*/ GIMT_Encode4(2047299), // Rule ID 15214 //
     /* 2047213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047259 */     // MIs[0] round
     /* 2047259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047262 */     // MIs[0] policy
     /* 2047262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047298 */     // GIR_Coverage, 15214,
     /* 2047298 */     GIR_EraseRootFromParent_Done,
     /* 2047299 */   // Label 27272: @2047299
     /* 2047299 */   GIM_Try, /*On fail goto*//*Label 27273*/ GIMT_Encode4(2047390), // Rule ID 15215 //
     /* 2047304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2047315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2047318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2047321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047350 */     // MIs[0] round
     /* 2047350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047353 */     // MIs[0] policy
     /* 2047353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047363 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2047366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047389 */     // GIR_Coverage, 15215,
     /* 2047389 */     GIR_EraseRootFromParent_Done,
     /* 2047390 */   // Label 27273: @2047390
     /* 2047390 */   GIM_Try, /*On fail goto*//*Label 27274*/ GIMT_Encode4(2047481), // Rule ID 15218 //
     /* 2047395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047441 */     // MIs[0] round
     /* 2047441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047444 */     // MIs[0] policy
     /* 2047444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047454 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047480 */     // GIR_Coverage, 15218,
     /* 2047480 */     GIR_EraseRootFromParent_Done,
     /* 2047481 */   // Label 27274: @2047481
     /* 2047481 */   GIM_Try, /*On fail goto*//*Label 27275*/ GIMT_Encode4(2047572), // Rule ID 15219 //
     /* 2047486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2047497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2047500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2047503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047532 */     // MIs[0] round
     /* 2047532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047535 */     // MIs[0] policy
     /* 2047535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047545 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047571 */     // GIR_Coverage, 15219,
     /* 2047571 */     GIR_EraseRootFromParent_Done,
     /* 2047572 */   // Label 27275: @2047572
     /* 2047572 */   GIM_Try, /*On fail goto*//*Label 27276*/ GIMT_Encode4(2047663), // Rule ID 15222 //
     /* 2047577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2047588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2047591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2047594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047623 */     // MIs[0] round
     /* 2047623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047626 */     // MIs[0] policy
     /* 2047626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047636 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047662 */     // GIR_Coverage, 15222,
     /* 2047662 */     GIR_EraseRootFromParent_Done,
     /* 2047663 */   // Label 27276: @2047663
     /* 2047663 */   GIM_Try, /*On fail goto*//*Label 27277*/ GIMT_Encode4(2047754), // Rule ID 15223 //
     /* 2047668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2047679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2047682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2047685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047714 */     // MIs[0] round
     /* 2047714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047717 */     // MIs[0] policy
     /* 2047717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047727 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047753 */     // GIR_Coverage, 15223,
     /* 2047753 */     GIR_EraseRootFromParent_Done,
     /* 2047754 */   // Label 27277: @2047754
     /* 2047754 */   GIM_Try, /*On fail goto*//*Label 27278*/ GIMT_Encode4(2047845), // Rule ID 15226 //
     /* 2047759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2047770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2047773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2047776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047805 */     // MIs[0] round
     /* 2047805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047808 */     // MIs[0] policy
     /* 2047808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047844 */     // GIR_Coverage, 15226,
     /* 2047844 */     GIR_EraseRootFromParent_Done,
     /* 2047845 */   // Label 27278: @2047845
     /* 2047845 */   GIM_Try, /*On fail goto*//*Label 27279*/ GIMT_Encode4(2047936), // Rule ID 15227 //
     /* 2047850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2047861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2047864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2047867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047896 */     // MIs[0] round
     /* 2047896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047899 */     // MIs[0] policy
     /* 2047899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047909 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2047912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2047932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047935 */     // GIR_Coverage, 15227,
     /* 2047935 */     GIR_EraseRootFromParent_Done,
     /* 2047936 */   // Label 27279: @2047936
     /* 2047936 */   GIM_Try, /*On fail goto*//*Label 27280*/ GIMT_Encode4(2048027), // Rule ID 15230 //
     /* 2047941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2047944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2047949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2047952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2047955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2047958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2047961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047987 */     // MIs[0] round
     /* 2047987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047990 */     // MIs[0] policy
     /* 2047990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048026 */     // GIR_Coverage, 15230,
     /* 2048026 */     GIR_EraseRootFromParent_Done,
     /* 2048027 */   // Label 27280: @2048027
     /* 2048027 */   GIM_Try, /*On fail goto*//*Label 27281*/ GIMT_Encode4(2048118), // Rule ID 15231 //
     /* 2048032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2048035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2048043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2048046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2048049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048078 */     // MIs[0] round
     /* 2048078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048081 */     // MIs[0] policy
     /* 2048081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048091 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2048094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048117 */     // GIR_Coverage, 15231,
     /* 2048117 */     GIR_EraseRootFromParent_Done,
     /* 2048118 */   // Label 27281: @2048118
     /* 2048118 */   GIM_Try, /*On fail goto*//*Label 27282*/ GIMT_Encode4(2048209), // Rule ID 15234 //
     /* 2048123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048169 */     // MIs[0] round
     /* 2048169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048172 */     // MIs[0] policy
     /* 2048172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048208 */     // GIR_Coverage, 15234,
     /* 2048208 */     GIR_EraseRootFromParent_Done,
     /* 2048209 */   // Label 27282: @2048209
     /* 2048209 */   GIM_Try, /*On fail goto*//*Label 27283*/ GIMT_Encode4(2048300), // Rule ID 15235 //
     /* 2048214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048260 */     // MIs[0] round
     /* 2048260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048263 */     // MIs[0] policy
     /* 2048263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048273 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048299 */     // GIR_Coverage, 15235,
     /* 2048299 */     GIR_EraseRootFromParent_Done,
     /* 2048300 */   // Label 27283: @2048300
     /* 2048300 */   GIM_Try, /*On fail goto*//*Label 27284*/ GIMT_Encode4(2048391), // Rule ID 15238 //
     /* 2048305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048351 */     // MIs[0] round
     /* 2048351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048354 */     // MIs[0] policy
     /* 2048354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048364 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048390 */     // GIR_Coverage, 15238,
     /* 2048390 */     GIR_EraseRootFromParent_Done,
     /* 2048391 */   // Label 27284: @2048391
     /* 2048391 */   GIM_Try, /*On fail goto*//*Label 27285*/ GIMT_Encode4(2048482), // Rule ID 15239 //
     /* 2048396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2048407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2048410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2048413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2048419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048442 */     // MIs[0] round
     /* 2048442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048445 */     // MIs[0] policy
     /* 2048445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048455 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048481 */     // GIR_Coverage, 15239,
     /* 2048481 */     GIR_EraseRootFromParent_Done,
     /* 2048482 */   // Label 27285: @2048482
     /* 2048482 */   GIM_Try, /*On fail goto*//*Label 27286*/ GIMT_Encode4(2048573), // Rule ID 15242 //
     /* 2048487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2048498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2048501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2048504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2048510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048533 */     // MIs[0] round
     /* 2048533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048536 */     // MIs[0] policy
     /* 2048536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048546 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2048549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048572 */     // GIR_Coverage, 15242,
     /* 2048572 */     GIR_EraseRootFromParent_Done,
     /* 2048573 */   // Label 27286: @2048573
     /* 2048573 */   GIM_Try, /*On fail goto*//*Label 27287*/ GIMT_Encode4(2048664), // Rule ID 15243 //
     /* 2048578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2048589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2048592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2048595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2048601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2048608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2048616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048624 */     // MIs[0] round
     /* 2048624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048627 */     // MIs[0] policy
     /* 2048627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048637 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2048640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048663 */     // GIR_Coverage, 15243,
     /* 2048663 */     GIR_EraseRootFromParent_Done,
     /* 2048664 */   // Label 27287: @2048664
     /* 2048664 */   GIM_Try, /*On fail goto*//*Label 27288*/ GIMT_Encode4(2048755), // Rule ID 15246 //
     /* 2048669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2048680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2048683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2048686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048715 */     // MIs[0] round
     /* 2048715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048718 */     // MIs[0] policy
     /* 2048718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048754 */     // GIR_Coverage, 15246,
     /* 2048754 */     GIR_EraseRootFromParent_Done,
     /* 2048755 */   // Label 27288: @2048755
     /* 2048755 */   GIM_Try, /*On fail goto*//*Label 27289*/ GIMT_Encode4(2048846), // Rule ID 15247 //
     /* 2048760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2048771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2048774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2048777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048806 */     // MIs[0] round
     /* 2048806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048809 */     // MIs[0] policy
     /* 2048809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2048822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048845 */     // GIR_Coverage, 15247,
     /* 2048845 */     GIR_EraseRootFromParent_Done,
     /* 2048846 */   // Label 27289: @2048846
     /* 2048846 */   GIM_Try, /*On fail goto*//*Label 27290*/ GIMT_Encode4(2048937), // Rule ID 15250 //
     /* 2048851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2048862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2048865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2048868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2048871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048897 */     // MIs[0] round
     /* 2048897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048900 */     // MIs[0] policy
     /* 2048900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048910 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2048913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048936 */     // GIR_Coverage, 15250,
     /* 2048936 */     GIR_EraseRootFromParent_Done,
     /* 2048937 */   // Label 27290: @2048937
     /* 2048937 */   GIM_Try, /*On fail goto*//*Label 27291*/ GIMT_Encode4(2049028), // Rule ID 15251 //
     /* 2048942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2048950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2048953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2048956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2048959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2048962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2048972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2048980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2048984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048988 */     // MIs[0] round
     /* 2048988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048991 */     // MIs[0] policy
     /* 2048991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049001 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049027 */     // GIR_Coverage, 15251,
     /* 2049027 */     GIR_EraseRootFromParent_Done,
     /* 2049028 */   // Label 27291: @2049028
     /* 2049028 */   GIM_Try, /*On fail goto*//*Label 27292*/ GIMT_Encode4(2049119), // Rule ID 15254 //
     /* 2049033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049079 */     // MIs[0] round
     /* 2049079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049082 */     // MIs[0] policy
     /* 2049082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049118 */     // GIR_Coverage, 15254,
     /* 2049118 */     GIR_EraseRootFromParent_Done,
     /* 2049119 */   // Label 27292: @2049119
     /* 2049119 */   GIM_Try, /*On fail goto*//*Label 27293*/ GIMT_Encode4(2049210), // Rule ID 15255 //
     /* 2049124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049170 */     // MIs[0] round
     /* 2049170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049173 */     // MIs[0] policy
     /* 2049173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049183 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049209 */     // GIR_Coverage, 15255,
     /* 2049209 */     GIR_EraseRootFromParent_Done,
     /* 2049210 */   // Label 27293: @2049210
     /* 2049210 */   GIM_Try, /*On fail goto*//*Label 27294*/ GIMT_Encode4(2049301), // Rule ID 15258 //
     /* 2049215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049261 */     // MIs[0] round
     /* 2049261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049264 */     // MIs[0] policy
     /* 2049264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049274 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049300 */     // GIR_Coverage, 15258,
     /* 2049300 */     GIR_EraseRootFromParent_Done,
     /* 2049301 */   // Label 27294: @2049301
     /* 2049301 */   GIM_Try, /*On fail goto*//*Label 27295*/ GIMT_Encode4(2049392), // Rule ID 15259 //
     /* 2049306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2049317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2049320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2049323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049352 */     // MIs[0] round
     /* 2049352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049355 */     // MIs[0] policy
     /* 2049355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049365 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049391 */     // GIR_Coverage, 15259,
     /* 2049391 */     GIR_EraseRootFromParent_Done,
     /* 2049392 */   // Label 27295: @2049392
     /* 2049392 */   GIM_Try, /*On fail goto*//*Label 27296*/ GIMT_Encode4(2049483), // Rule ID 15262 //
     /* 2049397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049443 */     // MIs[0] round
     /* 2049443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049446 */     // MIs[0] policy
     /* 2049446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049456 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049482 */     // GIR_Coverage, 15262,
     /* 2049482 */     GIR_EraseRootFromParent_Done,
     /* 2049483 */   // Label 27296: @2049483
     /* 2049483 */   GIM_Try, /*On fail goto*//*Label 27297*/ GIMT_Encode4(2049574), // Rule ID 15263 //
     /* 2049488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2049499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2049502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2049505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049534 */     // MIs[0] round
     /* 2049534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049537 */     // MIs[0] policy
     /* 2049537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049547 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2049550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049573 */     // GIR_Coverage, 15263,
     /* 2049573 */     GIR_EraseRootFromParent_Done,
     /* 2049574 */   // Label 27297: @2049574
     /* 2049574 */   GIM_Try, /*On fail goto*//*Label 27298*/ GIMT_Encode4(2049665), // Rule ID 15266 //
     /* 2049579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2049590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2049593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2049596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049625 */     // MIs[0] round
     /* 2049625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049628 */     // MIs[0] policy
     /* 2049628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049638 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049664 */     // GIR_Coverage, 15266,
     /* 2049664 */     GIR_EraseRootFromParent_Done,
     /* 2049665 */   // Label 27298: @2049665
     /* 2049665 */   GIM_Try, /*On fail goto*//*Label 27299*/ GIMT_Encode4(2049756), // Rule ID 15267 //
     /* 2049670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2049681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2049684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2049687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049716 */     // MIs[0] round
     /* 2049716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049719 */     // MIs[0] policy
     /* 2049719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049729 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2049732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2049752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049755 */     // GIR_Coverage, 15267,
     /* 2049755 */     GIR_EraseRootFromParent_Done,
     /* 2049756 */   // Label 27299: @2049756
     /* 2049756 */   GIM_Try, /*On fail goto*//*Label 27300*/ GIMT_Encode4(2049847), // Rule ID 15270 //
     /* 2049761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2049764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2049772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2049775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2049778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2049784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049807 */     // MIs[0] round
     /* 2049807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049810 */     // MIs[0] policy
     /* 2049810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049820 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049846 */     // GIR_Coverage, 15270,
     /* 2049846 */     GIR_EraseRootFromParent_Done,
     /* 2049847 */   // Label 27300: @2049847
     /* 2049847 */   GIM_Try, /*On fail goto*//*Label 27301*/ GIMT_Encode4(2049938), // Rule ID 15271 //
     /* 2049852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2049855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2049863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2049866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2049869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2049872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2049875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049898 */     // MIs[0] round
     /* 2049898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049901 */     // MIs[0] policy
     /* 2049901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049911 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2049914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2049934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049937 */     // GIR_Coverage, 15271,
     /* 2049937 */     GIR_EraseRootFromParent_Done,
     /* 2049938 */   // Label 27301: @2049938
     /* 2049938 */   GIM_Try, /*On fail goto*//*Label 27302*/ GIMT_Encode4(2050029), // Rule ID 15274 //
     /* 2049943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2049946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2049951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2049954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2049957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2049960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2049963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2049966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2049985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049989 */     // MIs[0] round
     /* 2049989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049992 */     // MIs[0] policy
     /* 2049992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050002 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050028 */     // GIR_Coverage, 15274,
     /* 2050028 */     GIR_EraseRootFromParent_Done,
     /* 2050029 */   // Label 27302: @2050029
     /* 2050029 */   GIM_Try, /*On fail goto*//*Label 27303*/ GIMT_Encode4(2050120), // Rule ID 15275 //
     /* 2050034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2050051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050080 */     // MIs[0] round
     /* 2050080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050083 */     // MIs[0] policy
     /* 2050083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050093 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2050096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050119 */     // GIR_Coverage, 15275,
     /* 2050119 */     GIR_EraseRootFromParent_Done,
     /* 2050120 */   // Label 27303: @2050120
     /* 2050120 */   GIM_Try, /*On fail goto*//*Label 27304*/ GIMT_Encode4(2050211), // Rule ID 15278 //
     /* 2050125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2050145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050171 */     // MIs[0] round
     /* 2050171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050174 */     // MIs[0] policy
     /* 2050174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050210 */     // GIR_Coverage, 15278,
     /* 2050210 */     GIR_EraseRootFromParent_Done,
     /* 2050211 */   // Label 27304: @2050211
     /* 2050211 */   GIM_Try, /*On fail goto*//*Label 27305*/ GIMT_Encode4(2050302), // Rule ID 15279 //
     /* 2050216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2050224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2050236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2050258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050262 */     // MIs[0] round
     /* 2050262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050265 */     // MIs[0] policy
     /* 2050265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050275 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11163:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2050278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050301 */     // GIR_Coverage, 15279,
     /* 2050301 */     GIR_EraseRootFromParent_Done,
     /* 2050302 */   // Label 27305: @2050302
     /* 2050302 */   GIM_Try, /*On fail goto*//*Label 27306*/ GIMT_Encode4(2050393), // Rule ID 15282 //
     /* 2050307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2050327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050353 */     // MIs[0] round
     /* 2050353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050356 */     // MIs[0] policy
     /* 2050356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050366 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2050369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050392 */     // GIR_Coverage, 15282,
     /* 2050392 */     GIR_EraseRootFromParent_Done,
     /* 2050393 */   // Label 27306: @2050393
     /* 2050393 */   GIM_Try, /*On fail goto*//*Label 27307*/ GIMT_Encode4(2050484), // Rule ID 15283 //
     /* 2050398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2050409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2050412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2050415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2050418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050444 */     // MIs[0] round
     /* 2050444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050447 */     // MIs[0] policy
     /* 2050447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050457 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2050460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050483 */     // GIR_Coverage, 15283,
     /* 2050483 */     GIR_EraseRootFromParent_Done,
     /* 2050484 */   // Label 27307: @2050484
     /* 2050484 */   GIM_Try, /*On fail goto*//*Label 27308*/ GIMT_Encode4(2050575), // Rule ID 15286 //
     /* 2050489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2050500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2050503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2050506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2050509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050535 */     // MIs[0] round
     /* 2050535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050538 */     // MIs[0] policy
     /* 2050538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050548 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2050551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050574 */     // GIR_Coverage, 15286,
     /* 2050574 */     GIR_EraseRootFromParent_Done,
     /* 2050575 */   // Label 27308: @2050575
     /* 2050575 */   GIM_Try, /*On fail goto*//*Label 27309*/ GIMT_Encode4(2050666), // Rule ID 15287 //
     /* 2050580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2050591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2050594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2050597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2050600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050626 */     // MIs[0] round
     /* 2050626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050629 */     // MIs[0] policy
     /* 2050629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050639 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2050642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050665 */     // GIR_Coverage, 15287,
     /* 2050665 */     GIR_EraseRootFromParent_Done,
     /* 2050666 */   // Label 27309: @2050666
     /* 2050666 */   GIM_Try, /*On fail goto*//*Label 27310*/ GIMT_Encode4(2050757), // Rule ID 15290 //
     /* 2050671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2050682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2050685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2050688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2050691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050717 */     // MIs[0] round
     /* 2050717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050720 */     // MIs[0] policy
     /* 2050720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050730 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2050733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050756 */     // GIR_Coverage, 15290,
     /* 2050756 */     GIR_EraseRootFromParent_Done,
     /* 2050757 */   // Label 27310: @2050757
     /* 2050757 */   GIM_Try, /*On fail goto*//*Label 27311*/ GIMT_Encode4(2050848), // Rule ID 15291 //
     /* 2050762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2050773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2050776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2050779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2050782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050808 */     // MIs[0] round
     /* 2050808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050811 */     // MIs[0] policy
     /* 2050811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050821 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2050824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2050844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050847 */     // GIR_Coverage, 15291,
     /* 2050847 */     GIR_EraseRootFromParent_Done,
     /* 2050848 */   // Label 27311: @2050848
     /* 2050848 */   GIM_Try, /*On fail goto*//*Label 27312*/ GIMT_Encode4(2050939), // Rule ID 15294 //
     /* 2050853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2050864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2050867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2050870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2050873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050899 */     // MIs[0] round
     /* 2050899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050902 */     // MIs[0] policy
     /* 2050902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050912 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2050915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2050935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050938 */     // GIR_Coverage, 15294,
     /* 2050938 */     GIR_EraseRootFromParent_Done,
     /* 2050939 */   // Label 27312: @2050939
     /* 2050939 */   GIM_Try, /*On fail goto*//*Label 27313*/ GIMT_Encode4(2051030), // Rule ID 15295 //
     /* 2050944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2050952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2050955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2050958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2050961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2050964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2050967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2050974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2050986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050990 */     // MIs[0] round
     /* 2050990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050993 */     // MIs[0] policy
     /* 2050993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051003 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2051006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051029 */     // GIR_Coverage, 15295,
     /* 2051029 */     GIR_EraseRootFromParent_Done,
     /* 2051030 */   // Label 27313: @2051030
     /* 2051030 */   GIM_Try, /*On fail goto*//*Label 27314*/ GIMT_Encode4(2051121), // Rule ID 15298 //
     /* 2051035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051081 */     // MIs[0] round
     /* 2051081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051084 */     // MIs[0] policy
     /* 2051084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051094 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051120 */     // GIR_Coverage, 15298,
     /* 2051120 */     GIR_EraseRootFromParent_Done,
     /* 2051121 */   // Label 27314: @2051121
     /* 2051121 */   GIM_Try, /*On fail goto*//*Label 27315*/ GIMT_Encode4(2051212), // Rule ID 15299 //
     /* 2051126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2051146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051172 */     // MIs[0] round
     /* 2051172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051175 */     // MIs[0] policy
     /* 2051175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051185 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051211 */     // GIR_Coverage, 15299,
     /* 2051211 */     GIR_EraseRootFromParent_Done,
     /* 2051212 */   // Label 27315: @2051212
     /* 2051212 */   GIM_Try, /*On fail goto*//*Label 27316*/ GIMT_Encode4(2051303), // Rule ID 15302 //
     /* 2051217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051263 */     // MIs[0] round
     /* 2051263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051266 */     // MIs[0] policy
     /* 2051266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051276 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051302 */     // GIR_Coverage, 15302,
     /* 2051302 */     GIR_EraseRootFromParent_Done,
     /* 2051303 */   // Label 27316: @2051303
     /* 2051303 */   GIM_Try, /*On fail goto*//*Label 27317*/ GIMT_Encode4(2051394), // Rule ID 15303 //
     /* 2051308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2051319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2051322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2051325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2051328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051354 */     // MIs[0] round
     /* 2051354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051357 */     // MIs[0] policy
     /* 2051357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051367 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2051370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051393 */     // GIR_Coverage, 15303,
     /* 2051393 */     GIR_EraseRootFromParent_Done,
     /* 2051394 */   // Label 27317: @2051394
     /* 2051394 */   GIM_Try, /*On fail goto*//*Label 27318*/ GIMT_Encode4(2051485), // Rule ID 15306 //
     /* 2051399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2051419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051445 */     // MIs[0] round
     /* 2051445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051448 */     // MIs[0] policy
     /* 2051448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051458 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051484 */     // GIR_Coverage, 15306,
     /* 2051484 */     GIR_EraseRootFromParent_Done,
     /* 2051485 */   // Label 27318: @2051485
     /* 2051485 */   GIM_Try, /*On fail goto*//*Label 27319*/ GIMT_Encode4(2051576), // Rule ID 15307 //
     /* 2051490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2051501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2051504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2051507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2051510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051536 */     // MIs[0] round
     /* 2051536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051539 */     // MIs[0] policy
     /* 2051539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051549 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051575 */     // GIR_Coverage, 15307,
     /* 2051575 */     GIR_EraseRootFromParent_Done,
     /* 2051576 */   // Label 27319: @2051576
     /* 2051576 */   GIM_Try, /*On fail goto*//*Label 27320*/ GIMT_Encode4(2051667), // Rule ID 15310 //
     /* 2051581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2051592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2051595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2051598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2051601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051627 */     // MIs[0] round
     /* 2051627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051630 */     // MIs[0] policy
     /* 2051630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051666 */     // GIR_Coverage, 15310,
     /* 2051666 */     GIR_EraseRootFromParent_Done,
     /* 2051667 */   // Label 27320: @2051667
     /* 2051667 */   GIM_Try, /*On fail goto*//*Label 27321*/ GIMT_Encode4(2051758), // Rule ID 15311 //
     /* 2051672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2051683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2051686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2051689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2051692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051718 */     // MIs[0] round
     /* 2051718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051721 */     // MIs[0] policy
     /* 2051721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051731 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051757 */     // GIR_Coverage, 15311,
     /* 2051757 */     GIR_EraseRootFromParent_Done,
     /* 2051758 */   // Label 27321: @2051758
     /* 2051758 */   GIM_Try, /*On fail goto*//*Label 27322*/ GIMT_Encode4(2051849), // Rule ID 15314 //
     /* 2051763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2051774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2051777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2051780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2051783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051809 */     // MIs[0] round
     /* 2051809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051812 */     // MIs[0] policy
     /* 2051812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051822 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051848 */     // GIR_Coverage, 15314,
     /* 2051848 */     GIR_EraseRootFromParent_Done,
     /* 2051849 */   // Label 27322: @2051849
     /* 2051849 */   GIM_Try, /*On fail goto*//*Label 27323*/ GIMT_Encode4(2051940), // Rule ID 15315 //
     /* 2051854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2051865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2051868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2051871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2051874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051900 */     // MIs[0] round
     /* 2051900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051903 */     // MIs[0] policy
     /* 2051903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051913 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2051916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2051936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051939 */     // GIR_Coverage, 15315,
     /* 2051939 */     GIR_EraseRootFromParent_Done,
     /* 2051940 */   // Label 27323: @2051940
     /* 2051940 */   GIM_Try, /*On fail goto*//*Label 27324*/ GIMT_Encode4(2052031), // Rule ID 15318 //
     /* 2051945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2051948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2051953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2051956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2051959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2051962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2051965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051991 */     // MIs[0] round
     /* 2051991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051994 */     // MIs[0] policy
     /* 2051994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052030 */     // GIR_Coverage, 15318,
     /* 2052030 */     GIR_EraseRootFromParent_Done,
     /* 2052031 */   // Label 27324: @2052031
     /* 2052031 */   GIM_Try, /*On fail goto*//*Label 27325*/ GIMT_Encode4(2052122), // Rule ID 15319 //
     /* 2052036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2052039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2052047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2052050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2052053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2052056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052082 */     // MIs[0] round
     /* 2052082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052085 */     // MIs[0] policy
     /* 2052085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052095 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2052098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052121 */     // GIR_Coverage, 15319,
     /* 2052121 */     GIR_EraseRootFromParent_Done,
     /* 2052122 */   // Label 27325: @2052122
     /* 2052122 */   GIM_Try, /*On fail goto*//*Label 27326*/ GIMT_Encode4(2052213), // Rule ID 15322 //
     /* 2052127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2052147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052173 */     // MIs[0] round
     /* 2052173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052176 */     // MIs[0] policy
     /* 2052176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052212 */     // GIR_Coverage, 15322,
     /* 2052212 */     GIR_EraseRootFromParent_Done,
     /* 2052213 */   // Label 27326: @2052213
     /* 2052213 */   GIM_Try, /*On fail goto*//*Label 27327*/ GIMT_Encode4(2052304), // Rule ID 15323 //
     /* 2052218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2052238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052264 */     // MIs[0] round
     /* 2052264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052267 */     // MIs[0] policy
     /* 2052267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052277 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052303 */     // GIR_Coverage, 15323,
     /* 2052303 */     GIR_EraseRootFromParent_Done,
     /* 2052304 */   // Label 27327: @2052304
     /* 2052304 */   GIM_Try, /*On fail goto*//*Label 27328*/ GIMT_Encode4(2052395), // Rule ID 15326 //
     /* 2052309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2052329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052355 */     // MIs[0] round
     /* 2052355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052358 */     // MIs[0] policy
     /* 2052358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052368 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052394 */     // GIR_Coverage, 15326,
     /* 2052394 */     GIR_EraseRootFromParent_Done,
     /* 2052395 */   // Label 27328: @2052395
     /* 2052395 */   GIM_Try, /*On fail goto*//*Label 27329*/ GIMT_Encode4(2052486), // Rule ID 15327 //
     /* 2052400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2052411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2052414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2052417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2052420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2052423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052446 */     // MIs[0] round
     /* 2052446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052449 */     // MIs[0] policy
     /* 2052449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052459 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052485 */     // GIR_Coverage, 15327,
     /* 2052485 */     GIR_EraseRootFromParent_Done,
     /* 2052486 */   // Label 27329: @2052486
     /* 2052486 */   GIM_Try, /*On fail goto*//*Label 27330*/ GIMT_Encode4(2052577), // Rule ID 15330 //
     /* 2052491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2052502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2052505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2052508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2052511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2052514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052537 */     // MIs[0] round
     /* 2052537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052540 */     // MIs[0] policy
     /* 2052540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052550 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2052553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052576 */     // GIR_Coverage, 15330,
     /* 2052576 */     GIR_EraseRootFromParent_Done,
     /* 2052577 */   // Label 27330: @2052577
     /* 2052577 */   GIM_Try, /*On fail goto*//*Label 27331*/ GIMT_Encode4(2052668), // Rule ID 15331 //
     /* 2052582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2052593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2052596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2052599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2052602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2052605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2052612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2052624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052628 */     // MIs[0] round
     /* 2052628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052631 */     // MIs[0] policy
     /* 2052631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052641 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2052644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052667 */     // GIR_Coverage, 15331,
     /* 2052667 */     GIR_EraseRootFromParent_Done,
     /* 2052668 */   // Label 27331: @2052668
     /* 2052668 */   GIM_Try, /*On fail goto*//*Label 27332*/ GIMT_Encode4(2052759), // Rule ID 15334 //
     /* 2052673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2052684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2052687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2052690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2052693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052719 */     // MIs[0] round
     /* 2052719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052722 */     // MIs[0] policy
     /* 2052722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052758 */     // GIR_Coverage, 15334,
     /* 2052758 */     GIR_EraseRootFromParent_Done,
     /* 2052759 */   // Label 27332: @2052759
     /* 2052759 */   GIM_Try, /*On fail goto*//*Label 27333*/ GIMT_Encode4(2052850), // Rule ID 15335 //
     /* 2052764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2052775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2052778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2052781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2052784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052810 */     // MIs[0] round
     /* 2052810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052813 */     // MIs[0] policy
     /* 2052813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2052826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052849 */     // GIR_Coverage, 15335,
     /* 2052849 */     GIR_EraseRootFromParent_Done,
     /* 2052850 */   // Label 27333: @2052850
     /* 2052850 */   GIM_Try, /*On fail goto*//*Label 27334*/ GIMT_Encode4(2052941), // Rule ID 15338 //
     /* 2052855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2052866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2052869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2052872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2052875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052901 */     // MIs[0] round
     /* 2052901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052904 */     // MIs[0] policy
     /* 2052904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052914 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2052917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052940 */     // GIR_Coverage, 15338,
     /* 2052940 */     GIR_EraseRootFromParent_Done,
     /* 2052941 */   // Label 27334: @2052941
     /* 2052941 */   GIM_Try, /*On fail goto*//*Label 27335*/ GIMT_Encode4(2053032), // Rule ID 15339 //
     /* 2052946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2052954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2052957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2052960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2052963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2052966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2052976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2052988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052992 */     // MIs[0] round
     /* 2052992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052995 */     // MIs[0] policy
     /* 2052995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053005 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053031 */     // GIR_Coverage, 15339,
     /* 2053031 */     GIR_EraseRootFromParent_Done,
     /* 2053032 */   // Label 27335: @2053032
     /* 2053032 */   GIM_Try, /*On fail goto*//*Label 27336*/ GIMT_Encode4(2053123), // Rule ID 15342 //
     /* 2053037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2053057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053083 */     // MIs[0] round
     /* 2053083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053086 */     // MIs[0] policy
     /* 2053086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053122 */     // GIR_Coverage, 15342,
     /* 2053122 */     GIR_EraseRootFromParent_Done,
     /* 2053123 */   // Label 27336: @2053123
     /* 2053123 */   GIM_Try, /*On fail goto*//*Label 27337*/ GIMT_Encode4(2053214), // Rule ID 15343 //
     /* 2053128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2053148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053174 */     // MIs[0] round
     /* 2053174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053177 */     // MIs[0] policy
     /* 2053177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053187 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053213 */     // GIR_Coverage, 15343,
     /* 2053213 */     GIR_EraseRootFromParent_Done,
     /* 2053214 */   // Label 27337: @2053214
     /* 2053214 */   GIM_Try, /*On fail goto*//*Label 27338*/ GIMT_Encode4(2053305), // Rule ID 15346 //
     /* 2053219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2053239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053265 */     // MIs[0] round
     /* 2053265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053268 */     // MIs[0] policy
     /* 2053268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053304 */     // GIR_Coverage, 15346,
     /* 2053304 */     GIR_EraseRootFromParent_Done,
     /* 2053305 */   // Label 27338: @2053305
     /* 2053305 */   GIM_Try, /*On fail goto*//*Label 27339*/ GIMT_Encode4(2053396), // Rule ID 15347 //
     /* 2053310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2053321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2053324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2053327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2053330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053356 */     // MIs[0] round
     /* 2053356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053359 */     // MIs[0] policy
     /* 2053359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053369 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053395 */     // GIR_Coverage, 15347,
     /* 2053395 */     GIR_EraseRootFromParent_Done,
     /* 2053396 */   // Label 27339: @2053396
     /* 2053396 */   GIM_Try, /*On fail goto*//*Label 27340*/ GIMT_Encode4(2053487), // Rule ID 15350 //
     /* 2053401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2053421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053447 */     // MIs[0] round
     /* 2053447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053450 */     // MIs[0] policy
     /* 2053450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053486 */     // GIR_Coverage, 15350,
     /* 2053486 */     GIR_EraseRootFromParent_Done,
     /* 2053487 */   // Label 27340: @2053487
     /* 2053487 */   GIM_Try, /*On fail goto*//*Label 27341*/ GIMT_Encode4(2053578), // Rule ID 15351 //
     /* 2053492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2053503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2053506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2053509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2053512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053538 */     // MIs[0] round
     /* 2053538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053541 */     // MIs[0] policy
     /* 2053541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2053554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053577 */     // GIR_Coverage, 15351,
     /* 2053577 */     GIR_EraseRootFromParent_Done,
     /* 2053578 */   // Label 27341: @2053578
     /* 2053578 */   GIM_Try, /*On fail goto*//*Label 27342*/ GIMT_Encode4(2053669), // Rule ID 15354 //
     /* 2053583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2053594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2053597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2053600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2053603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053629 */     // MIs[0] round
     /* 2053629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053632 */     // MIs[0] policy
     /* 2053632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053668 */     // GIR_Coverage, 15354,
     /* 2053668 */     GIR_EraseRootFromParent_Done,
     /* 2053669 */   // Label 27342: @2053669
     /* 2053669 */   GIM_Try, /*On fail goto*//*Label 27343*/ GIMT_Encode4(2053760), // Rule ID 15355 //
     /* 2053674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2053685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2053688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2053691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2053694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053720 */     // MIs[0] round
     /* 2053720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053723 */     // MIs[0] policy
     /* 2053723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053733 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2053736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2053756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053759 */     // GIR_Coverage, 15355,
     /* 2053759 */     GIR_EraseRootFromParent_Done,
     /* 2053760 */   // Label 27343: @2053760
     /* 2053760 */   GIM_Try, /*On fail goto*//*Label 27344*/ GIMT_Encode4(2053851), // Rule ID 15358 //
     /* 2053765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2053768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2053776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2053779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2053782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2053785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053811 */     // MIs[0] round
     /* 2053811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053814 */     // MIs[0] policy
     /* 2053814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053850 */     // GIR_Coverage, 15358,
     /* 2053850 */     GIR_EraseRootFromParent_Done,
     /* 2053851 */   // Label 27344: @2053851
     /* 2053851 */   GIM_Try, /*On fail goto*//*Label 27345*/ GIMT_Encode4(2053942), // Rule ID 15359 //
     /* 2053856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2053859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2053867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2053870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2053873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2053876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2053879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053902 */     // MIs[0] round
     /* 2053902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053905 */     // MIs[0] policy
     /* 2053905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2053918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2053938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053941 */     // GIR_Coverage, 15359,
     /* 2053941 */     GIR_EraseRootFromParent_Done,
     /* 2053942 */   // Label 27345: @2053942
     /* 2053942 */   GIM_Try, /*On fail goto*//*Label 27346*/ GIMT_Encode4(2054033), // Rule ID 15362 //
     /* 2053947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2053950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2053955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2053958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2053961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2053964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2053967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2053970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053993 */     // MIs[0] round
     /* 2053993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053996 */     // MIs[0] policy
     /* 2053996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054006 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054032 */     // GIR_Coverage, 15362,
     /* 2054032 */     GIR_EraseRootFromParent_Done,
     /* 2054033 */   // Label 27346: @2054033
     /* 2054033 */   GIM_Try, /*On fail goto*//*Label 27347*/ GIMT_Encode4(2054124), // Rule ID 15363 //
     /* 2054038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2054049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2054052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2054055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2054058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054084 */     // MIs[0] round
     /* 2054084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054087 */     // MIs[0] policy
     /* 2054087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054097 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2054100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054123 */     // GIR_Coverage, 15363,
     /* 2054123 */     GIR_EraseRootFromParent_Done,
     /* 2054124 */   // Label 27347: @2054124
     /* 2054124 */   GIM_Try, /*On fail goto*//*Label 27348*/ GIMT_Encode4(2054215), // Rule ID 15366 //
     /* 2054129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2054149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054175 */     // MIs[0] round
     /* 2054175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054178 */     // MIs[0] policy
     /* 2054178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054188 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054214 */     // GIR_Coverage, 15366,
     /* 2054214 */     GIR_EraseRootFromParent_Done,
     /* 2054215 */   // Label 27348: @2054215
     /* 2054215 */   GIM_Try, /*On fail goto*//*Label 27349*/ GIMT_Encode4(2054306), // Rule ID 15367 //
     /* 2054220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2054240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054266 */     // MIs[0] round
     /* 2054266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054269 */     // MIs[0] policy
     /* 2054269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054279 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2054282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054305 */     // GIR_Coverage, 15367,
     /* 2054305 */     GIR_EraseRootFromParent_Done,
     /* 2054306 */   // Label 27349: @2054306
     /* 2054306 */   GIM_Try, /*On fail goto*//*Label 27350*/ GIMT_Encode4(2054397), // Rule ID 15370 //
     /* 2054311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054357 */     // MIs[0] round
     /* 2054357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054360 */     // MIs[0] policy
     /* 2054360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054370 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2054373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054396 */     // GIR_Coverage, 15370,
     /* 2054396 */     GIR_EraseRootFromParent_Done,
     /* 2054397 */   // Label 27350: @2054397
     /* 2054397 */   GIM_Try, /*On fail goto*//*Label 27351*/ GIMT_Encode4(2054488), // Rule ID 15371 //
     /* 2054402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2054413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2054416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2054419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054448 */     // MIs[0] round
     /* 2054448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054451 */     // MIs[0] policy
     /* 2054451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054461 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2054464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054487 */     // GIR_Coverage, 15371,
     /* 2054487 */     GIR_EraseRootFromParent_Done,
     /* 2054488 */   // Label 27351: @2054488
     /* 2054488 */   GIM_Try, /*On fail goto*//*Label 27352*/ GIMT_Encode4(2054579), // Rule ID 15374 //
     /* 2054493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2054504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2054507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2054510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054539 */     // MIs[0] round
     /* 2054539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054542 */     // MIs[0] policy
     /* 2054542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2054555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054578 */     // GIR_Coverage, 15374,
     /* 2054578 */     GIR_EraseRootFromParent_Done,
     /* 2054579 */   // Label 27352: @2054579
     /* 2054579 */   GIM_Try, /*On fail goto*//*Label 27353*/ GIMT_Encode4(2054670), // Rule ID 15375 //
     /* 2054584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2054595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2054598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2054601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054630 */     // MIs[0] round
     /* 2054630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054633 */     // MIs[0] policy
     /* 2054633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054643 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2054646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054669 */     // GIR_Coverage, 15375,
     /* 2054669 */     GIR_EraseRootFromParent_Done,
     /* 2054670 */   // Label 27353: @2054670
     /* 2054670 */   GIM_Try, /*On fail goto*//*Label 27354*/ GIMT_Encode4(2054761), // Rule ID 15378 //
     /* 2054675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2054686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2054689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2054692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054721 */     // MIs[0] round
     /* 2054721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054724 */     // MIs[0] policy
     /* 2054724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054734 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2054737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054760 */     // GIR_Coverage, 15378,
     /* 2054760 */     GIR_EraseRootFromParent_Done,
     /* 2054761 */   // Label 27354: @2054761
     /* 2054761 */   GIM_Try, /*On fail goto*//*Label 27355*/ GIMT_Encode4(2054852), // Rule ID 15379 //
     /* 2054766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2054777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2054780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2054783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054812 */     // MIs[0] round
     /* 2054812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054815 */     // MIs[0] policy
     /* 2054815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054825 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2054828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2054848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054851 */     // GIR_Coverage, 15379,
     /* 2054851 */     GIR_EraseRootFromParent_Done,
     /* 2054852 */   // Label 27355: @2054852
     /* 2054852 */   GIM_Try, /*On fail goto*//*Label 27356*/ GIMT_Encode4(2054943), // Rule ID 15382 //
     /* 2054857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2054868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2054871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2054874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054903 */     // MIs[0] round
     /* 2054903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054906 */     // MIs[0] policy
     /* 2054906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054916 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2054919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2054939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054942 */     // GIR_Coverage, 15382,
     /* 2054942 */     GIR_EraseRootFromParent_Done,
     /* 2054943 */   // Label 27356: @2054943
     /* 2054943 */   GIM_Try, /*On fail goto*//*Label 27357*/ GIMT_Encode4(2055034), // Rule ID 15383 //
     /* 2054948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2054956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2054959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2054962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2054965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2054971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2054978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2054986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054994 */     // MIs[0] round
     /* 2054994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054997 */     // MIs[0] policy
     /* 2054997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055007 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2055010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055033 */     // GIR_Coverage, 15383,
     /* 2055033 */     GIR_EraseRootFromParent_Done,
     /* 2055034 */   // Label 27357: @2055034
     /* 2055034 */   GIM_Try, /*On fail goto*//*Label 27358*/ GIMT_Encode4(2055125), // Rule ID 15386 //
     /* 2055039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055085 */     // MIs[0] round
     /* 2055085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055088 */     // MIs[0] policy
     /* 2055088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055124 */     // GIR_Coverage, 15386,
     /* 2055124 */     GIR_EraseRootFromParent_Done,
     /* 2055125 */   // Label 27358: @2055125
     /* 2055125 */   GIM_Try, /*On fail goto*//*Label 27359*/ GIMT_Encode4(2055216), // Rule ID 15387 //
     /* 2055130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055176 */     // MIs[0] round
     /* 2055176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055179 */     // MIs[0] policy
     /* 2055179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055189 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055215 */     // GIR_Coverage, 15387,
     /* 2055215 */     GIR_EraseRootFromParent_Done,
     /* 2055216 */   // Label 27359: @2055216
     /* 2055216 */   GIM_Try, /*On fail goto*//*Label 27360*/ GIMT_Encode4(2055307), // Rule ID 15390 //
     /* 2055221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055267 */     // MIs[0] round
     /* 2055267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055270 */     // MIs[0] policy
     /* 2055270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055306 */     // GIR_Coverage, 15390,
     /* 2055306 */     GIR_EraseRootFromParent_Done,
     /* 2055307 */   // Label 27360: @2055307
     /* 2055307 */   GIM_Try, /*On fail goto*//*Label 27361*/ GIMT_Encode4(2055398), // Rule ID 15391 //
     /* 2055312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2055323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2055326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2055329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055358 */     // MIs[0] round
     /* 2055358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055361 */     // MIs[0] policy
     /* 2055361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055371 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2055374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055397 */     // GIR_Coverage, 15391,
     /* 2055397 */     GIR_EraseRootFromParent_Done,
     /* 2055398 */   // Label 27361: @2055398
     /* 2055398 */   GIM_Try, /*On fail goto*//*Label 27362*/ GIMT_Encode4(2055489), // Rule ID 15394 //
     /* 2055403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055449 */     // MIs[0] round
     /* 2055449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055452 */     // MIs[0] policy
     /* 2055452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055462 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055488 */     // GIR_Coverage, 15394,
     /* 2055488 */     GIR_EraseRootFromParent_Done,
     /* 2055489 */   // Label 27362: @2055489
     /* 2055489 */   GIM_Try, /*On fail goto*//*Label 27363*/ GIMT_Encode4(2055580), // Rule ID 15395 //
     /* 2055494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2055505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2055508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2055511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055540 */     // MIs[0] round
     /* 2055540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055543 */     // MIs[0] policy
     /* 2055543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055553 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11161:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055579 */     // GIR_Coverage, 15395,
     /* 2055579 */     GIR_EraseRootFromParent_Done,
     /* 2055580 */   // Label 27363: @2055580
     /* 2055580 */   GIM_Try, /*On fail goto*//*Label 27364*/ GIMT_Encode4(2055671), // Rule ID 15398 //
     /* 2055585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2055596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2055599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2055602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055631 */     // MIs[0] round
     /* 2055631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055634 */     // MIs[0] policy
     /* 2055634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055670 */     // GIR_Coverage, 15398,
     /* 2055670 */     GIR_EraseRootFromParent_Done,
     /* 2055671 */   // Label 27364: @2055671
     /* 2055671 */   GIM_Try, /*On fail goto*//*Label 27365*/ GIMT_Encode4(2055762), // Rule ID 15399 //
     /* 2055676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2055687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2055690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2055693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055722 */     // MIs[0] round
     /* 2055722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055725 */     // MIs[0] policy
     /* 2055725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055735 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055761 */     // GIR_Coverage, 15399,
     /* 2055761 */     GIR_EraseRootFromParent_Done,
     /* 2055762 */   // Label 27365: @2055762
     /* 2055762 */   GIM_Try, /*On fail goto*//*Label 27366*/ GIMT_Encode4(2055853), // Rule ID 15402 //
     /* 2055767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2055778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2055781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2055784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055813 */     // MIs[0] round
     /* 2055813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055816 */     // MIs[0] policy
     /* 2055816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055852 */     // GIR_Coverage, 15402,
     /* 2055852 */     GIR_EraseRootFromParent_Done,
     /* 2055853 */   // Label 27366: @2055853
     /* 2055853 */   GIM_Try, /*On fail goto*//*Label 27367*/ GIMT_Encode4(2055944), // Rule ID 15403 //
     /* 2055858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2055869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2055872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2055875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055904 */     // MIs[0] round
     /* 2055904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055907 */     // MIs[0] policy
     /* 2055907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055917 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2055920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2055940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055943 */     // GIR_Coverage, 15403,
     /* 2055943 */     GIR_EraseRootFromParent_Done,
     /* 2055944 */   // Label 27367: @2055944
     /* 2055944 */   GIM_Try, /*On fail goto*//*Label 27368*/ GIMT_Encode4(2056035), // Rule ID 15406 //
     /* 2055949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2055952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2055957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2055960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2055963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2055966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2055969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055995 */     // MIs[0] round
     /* 2055995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055998 */     // MIs[0] policy
     /* 2055998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056034 */     // GIR_Coverage, 15406,
     /* 2056034 */     GIR_EraseRootFromParent_Done,
     /* 2056035 */   // Label 27368: @2056035
     /* 2056035 */   GIM_Try, /*On fail goto*//*Label 27369*/ GIMT_Encode4(2056126), // Rule ID 15407 //
     /* 2056040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2056043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2056051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2056054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2056057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056086 */     // MIs[0] round
     /* 2056086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056089 */     // MIs[0] policy
     /* 2056089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056099 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2056102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2056122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056125 */     // GIR_Coverage, 15407,
     /* 2056125 */     GIR_EraseRootFromParent_Done,
     /* 2056126 */   // Label 27369: @2056126
     /* 2056126 */   GIM_Try, /*On fail goto*//*Label 27370*/ GIMT_Encode4(2056217), // Rule ID 15410 //
     /* 2056131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056177 */     // MIs[0] round
     /* 2056177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056180 */     // MIs[0] policy
     /* 2056180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056190 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056216 */     // GIR_Coverage, 15410,
     /* 2056216 */     GIR_EraseRootFromParent_Done,
     /* 2056217 */   // Label 27370: @2056217
     /* 2056217 */   GIM_Try, /*On fail goto*//*Label 27371*/ GIMT_Encode4(2056308), // Rule ID 15411 //
     /* 2056222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056268 */     // MIs[0] round
     /* 2056268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056271 */     // MIs[0] policy
     /* 2056271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056281 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056307 */     // GIR_Coverage, 15411,
     /* 2056307 */     GIR_EraseRootFromParent_Done,
     /* 2056308 */   // Label 27371: @2056308
     /* 2056308 */   GIM_Try, /*On fail goto*//*Label 27372*/ GIMT_Encode4(2056399), // Rule ID 15414 //
     /* 2056313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056359 */     // MIs[0] round
     /* 2056359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056362 */     // MIs[0] policy
     /* 2056362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056372 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056398 */     // GIR_Coverage, 15414,
     /* 2056398 */     GIR_EraseRootFromParent_Done,
     /* 2056399 */   // Label 27372: @2056399
     /* 2056399 */   GIM_Try, /*On fail goto*//*Label 27373*/ GIMT_Encode4(2056490), // Rule ID 15415 //
     /* 2056404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056450 */     // MIs[0] round
     /* 2056450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056453 */     // MIs[0] policy
     /* 2056453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056463 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056489 */     // GIR_Coverage, 15415,
     /* 2056489 */     GIR_EraseRootFromParent_Done,
     /* 2056490 */   // Label 27373: @2056490
     /* 2056490 */   GIM_Try, /*On fail goto*//*Label 27374*/ GIMT_Encode4(2056581), // Rule ID 15418 //
     /* 2056495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2056506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2056509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2056512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2056518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056541 */     // MIs[0] round
     /* 2056541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056544 */     // MIs[0] policy
     /* 2056544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056554 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2056557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056580 */     // GIR_Coverage, 15418,
     /* 2056580 */     GIR_EraseRootFromParent_Done,
     /* 2056581 */   // Label 27374: @2056581
     /* 2056581 */   GIM_Try, /*On fail goto*//*Label 27375*/ GIMT_Encode4(2056672), // Rule ID 15419 //
     /* 2056586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2056597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2056600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2056603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2056609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2056616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2056624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056632 */     // MIs[0] round
     /* 2056632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056635 */     // MIs[0] policy
     /* 2056635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056645 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2056648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056671 */     // GIR_Coverage, 15419,
     /* 2056671 */     GIR_EraseRootFromParent_Done,
     /* 2056672 */   // Label 27375: @2056672
     /* 2056672 */   GIM_Try, /*On fail goto*//*Label 27376*/ GIMT_Encode4(2056763), // Rule ID 15422 //
     /* 2056677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2056688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2056691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2056694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056723 */     // MIs[0] round
     /* 2056723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056726 */     // MIs[0] policy
     /* 2056726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056762 */     // GIR_Coverage, 15422,
     /* 2056762 */     GIR_EraseRootFromParent_Done,
     /* 2056763 */   // Label 27376: @2056763
     /* 2056763 */   GIM_Try, /*On fail goto*//*Label 27377*/ GIMT_Encode4(2056854), // Rule ID 15423 //
     /* 2056768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2056779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2056782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2056785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056814 */     // MIs[0] round
     /* 2056814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056817 */     // MIs[0] policy
     /* 2056817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2056830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056853 */     // GIR_Coverage, 15423,
     /* 2056853 */     GIR_EraseRootFromParent_Done,
     /* 2056854 */   // Label 27377: @2056854
     /* 2056854 */   GIM_Try, /*On fail goto*//*Label 27378*/ GIMT_Encode4(2056945), // Rule ID 15426 //
     /* 2056859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2056870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2056873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2056876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2056879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056905 */     // MIs[0] round
     /* 2056905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056908 */     // MIs[0] policy
     /* 2056908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2056921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056944 */     // GIR_Coverage, 15426,
     /* 2056944 */     GIR_EraseRootFromParent_Done,
     /* 2056945 */   // Label 27378: @2056945
     /* 2056945 */   GIM_Try, /*On fail goto*//*Label 27379*/ GIMT_Encode4(2057036), // Rule ID 15427 //
     /* 2056950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2056958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2056961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2056964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2056967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2056970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2056980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2056988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2056992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056996 */     // MIs[0] round
     /* 2056996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056999 */     // MIs[0] policy
     /* 2056999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057009 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057035 */     // GIR_Coverage, 15427,
     /* 2057035 */     GIR_EraseRootFromParent_Done,
     /* 2057036 */   // Label 27379: @2057036
     /* 2057036 */   GIM_Try, /*On fail goto*//*Label 27380*/ GIMT_Encode4(2057127), // Rule ID 15430 //
     /* 2057041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057087 */     // MIs[0] round
     /* 2057087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057090 */     // MIs[0] policy
     /* 2057090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057100 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057126 */     // GIR_Coverage, 15430,
     /* 2057126 */     GIR_EraseRootFromParent_Done,
     /* 2057127 */   // Label 27380: @2057127
     /* 2057127 */   GIM_Try, /*On fail goto*//*Label 27381*/ GIMT_Encode4(2057218), // Rule ID 15431 //
     /* 2057132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057178 */     // MIs[0] round
     /* 2057178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057181 */     // MIs[0] policy
     /* 2057181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057191 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057217 */     // GIR_Coverage, 15431,
     /* 2057217 */     GIR_EraseRootFromParent_Done,
     /* 2057218 */   // Label 27381: @2057218
     /* 2057218 */   GIM_Try, /*On fail goto*//*Label 27382*/ GIMT_Encode4(2057309), // Rule ID 15434 //
     /* 2057223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057269 */     // MIs[0] round
     /* 2057269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057272 */     // MIs[0] policy
     /* 2057272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057308 */     // GIR_Coverage, 15434,
     /* 2057308 */     GIR_EraseRootFromParent_Done,
     /* 2057309 */   // Label 27382: @2057309
     /* 2057309 */   GIM_Try, /*On fail goto*//*Label 27383*/ GIMT_Encode4(2057400), // Rule ID 15435 //
     /* 2057314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057360 */     // MIs[0] round
     /* 2057360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057363 */     // MIs[0] policy
     /* 2057363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057399 */     // GIR_Coverage, 15435,
     /* 2057399 */     GIR_EraseRootFromParent_Done,
     /* 2057400 */   // Label 27383: @2057400
     /* 2057400 */   GIM_Try, /*On fail goto*//*Label 27384*/ GIMT_Encode4(2057491), // Rule ID 15438 //
     /* 2057405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057451 */     // MIs[0] round
     /* 2057451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057454 */     // MIs[0] policy
     /* 2057454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057490 */     // GIR_Coverage, 15438,
     /* 2057490 */     GIR_EraseRootFromParent_Done,
     /* 2057491 */   // Label 27384: @2057491
     /* 2057491 */   GIM_Try, /*On fail goto*//*Label 27385*/ GIMT_Encode4(2057582), // Rule ID 15439 //
     /* 2057496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2057507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2057510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2057513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057542 */     // MIs[0] round
     /* 2057542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057545 */     // MIs[0] policy
     /* 2057545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2057558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057581 */     // GIR_Coverage, 15439,
     /* 2057581 */     GIR_EraseRootFromParent_Done,
     /* 2057582 */   // Label 27385: @2057582
     /* 2057582 */   GIM_Try, /*On fail goto*//*Label 27386*/ GIMT_Encode4(2057673), // Rule ID 15442 //
     /* 2057587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2057598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2057601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2057604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057633 */     // MIs[0] round
     /* 2057633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057636 */     // MIs[0] policy
     /* 2057636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057672 */     // GIR_Coverage, 15442,
     /* 2057672 */     GIR_EraseRootFromParent_Done,
     /* 2057673 */   // Label 27386: @2057673
     /* 2057673 */   GIM_Try, /*On fail goto*//*Label 27387*/ GIMT_Encode4(2057764), // Rule ID 15443 //
     /* 2057678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2057689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2057692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2057695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057724 */     // MIs[0] round
     /* 2057724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057727 */     // MIs[0] policy
     /* 2057727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057737 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2057740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057763 */     // GIR_Coverage, 15443,
     /* 2057763 */     GIR_EraseRootFromParent_Done,
     /* 2057764 */   // Label 27387: @2057764
     /* 2057764 */   GIM_Try, /*On fail goto*//*Label 27388*/ GIMT_Encode4(2057855), // Rule ID 15446 //
     /* 2057769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2057772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2057780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2057783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2057786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2057792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057815 */     // MIs[0] round
     /* 2057815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057818 */     // MIs[0] policy
     /* 2057818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057828 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057854 */     // GIR_Coverage, 15446,
     /* 2057854 */     GIR_EraseRootFromParent_Done,
     /* 2057855 */   // Label 27388: @2057855
     /* 2057855 */   GIM_Try, /*On fail goto*//*Label 27389*/ GIMT_Encode4(2057946), // Rule ID 15447 //
     /* 2057860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2057863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2057871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2057874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2057877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2057880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2057883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057906 */     // MIs[0] round
     /* 2057906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057909 */     // MIs[0] policy
     /* 2057909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057919 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2057922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2057942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057945 */     // GIR_Coverage, 15447,
     /* 2057945 */     GIR_EraseRootFromParent_Done,
     /* 2057946 */   // Label 27389: @2057946
     /* 2057946 */   GIM_Try, /*On fail goto*//*Label 27390*/ GIMT_Encode4(2058037), // Rule ID 15450 //
     /* 2057951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2057954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2057959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2057962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2057965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2057968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2057971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2057993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057997 */     // MIs[0] round
     /* 2057997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058000 */     // MIs[0] policy
     /* 2058000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058036 */     // GIR_Coverage, 15450,
     /* 2058036 */     GIR_EraseRootFromParent_Done,
     /* 2058037 */   // Label 27390: @2058037
     /* 2058037 */   GIM_Try, /*On fail goto*//*Label 27391*/ GIMT_Encode4(2058128), // Rule ID 15451 //
     /* 2058042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2058053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2058056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2058059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058088 */     // MIs[0] round
     /* 2058088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058091 */     // MIs[0] policy
     /* 2058091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058101 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2058104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058127 */     // GIR_Coverage, 15451,
     /* 2058127 */     GIR_EraseRootFromParent_Done,
     /* 2058128 */   // Label 27391: @2058128
     /* 2058128 */   GIM_Try, /*On fail goto*//*Label 27392*/ GIMT_Encode4(2058219), // Rule ID 15454 //
     /* 2058133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2058136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2058144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2058147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2058150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058179 */     // MIs[0] round
     /* 2058179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058182 */     // MIs[0] policy
     /* 2058182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058192 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058218 */     // GIR_Coverage, 15454,
     /* 2058218 */     GIR_EraseRootFromParent_Done,
     /* 2058219 */   // Label 27392: @2058219
     /* 2058219 */   GIM_Try, /*On fail goto*//*Label 27393*/ GIMT_Encode4(2058310), // Rule ID 15455 //
     /* 2058224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2058227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2058232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2058235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2058238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2058241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058270 */     // MIs[0] round
     /* 2058270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058273 */     // MIs[0] policy
     /* 2058273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058283 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11161:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2058286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2058306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058309 */     // GIR_Coverage, 15455,
     /* 2058309 */     GIR_EraseRootFromParent_Done,
     /* 2058310 */   // Label 27393: @2058310
     /* 2058310 */   GIM_Try, /*On fail goto*//*Label 27394*/ GIMT_Encode4(2058401), // Rule ID 15458 //
     /* 2058315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2058335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058361 */     // MIs[0] round
     /* 2058361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058364 */     // MIs[0] policy
     /* 2058364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058374 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2058377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058400 */     // GIR_Coverage, 15458,
     /* 2058400 */     GIR_EraseRootFromParent_Done,
     /* 2058401 */   // Label 27394: @2058401
     /* 2058401 */   GIM_Try, /*On fail goto*//*Label 27395*/ GIMT_Encode4(2058492), // Rule ID 15459 //
     /* 2058406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2058426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058452 */     // MIs[0] round
     /* 2058452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058455 */     // MIs[0] policy
     /* 2058455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058465 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2058468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058491 */     // GIR_Coverage, 15459,
     /* 2058491 */     GIR_EraseRootFromParent_Done,
     /* 2058492 */   // Label 27395: @2058492
     /* 2058492 */   GIM_Try, /*On fail goto*//*Label 27396*/ GIMT_Encode4(2058583), // Rule ID 15462 //
     /* 2058497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2058517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058543 */     // MIs[0] round
     /* 2058543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058546 */     // MIs[0] policy
     /* 2058546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058556 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2058559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058582 */     // GIR_Coverage, 15462,
     /* 2058582 */     GIR_EraseRootFromParent_Done,
     /* 2058583 */   // Label 27396: @2058583
     /* 2058583 */   GIM_Try, /*On fail goto*//*Label 27397*/ GIMT_Encode4(2058674), // Rule ID 15463 //
     /* 2058588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2058608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058634 */     // MIs[0] round
     /* 2058634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058637 */     // MIs[0] policy
     /* 2058637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058647 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2058650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058673 */     // GIR_Coverage, 15463,
     /* 2058673 */     GIR_EraseRootFromParent_Done,
     /* 2058674 */   // Label 27397: @2058674
     /* 2058674 */   GIM_Try, /*On fail goto*//*Label 27398*/ GIMT_Encode4(2058765), // Rule ID 15466 //
     /* 2058679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2058690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2058693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2058696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2058699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058725 */     // MIs[0] round
     /* 2058725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058728 */     // MIs[0] policy
     /* 2058728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058738 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2058741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058764 */     // GIR_Coverage, 15466,
     /* 2058764 */     GIR_EraseRootFromParent_Done,
     /* 2058765 */   // Label 27398: @2058765
     /* 2058765 */   GIM_Try, /*On fail goto*//*Label 27399*/ GIMT_Encode4(2058856), // Rule ID 15467 //
     /* 2058770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2058781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2058784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2058787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2058790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058816 */     // MIs[0] round
     /* 2058816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058819 */     // MIs[0] policy
     /* 2058819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058829 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2058832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058855 */     // GIR_Coverage, 15467,
     /* 2058855 */     GIR_EraseRootFromParent_Done,
     /* 2058856 */   // Label 27399: @2058856
     /* 2058856 */   GIM_Try, /*On fail goto*//*Label 27400*/ GIMT_Encode4(2058947), // Rule ID 15470 //
     /* 2058861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2058872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2058875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2058878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2058881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058907 */     // MIs[0] round
     /* 2058907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058910 */     // MIs[0] policy
     /* 2058910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2058923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2058943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058946 */     // GIR_Coverage, 15470,
     /* 2058946 */     GIR_EraseRootFromParent_Done,
     /* 2058947 */   // Label 27400: @2058947
     /* 2058947 */   GIM_Try, /*On fail goto*//*Label 27401*/ GIMT_Encode4(2059038), // Rule ID 15471 //
     /* 2058952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2058960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2058963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2058966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2058969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2058972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058998 */     // MIs[0] round
     /* 2058998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059001 */     // MIs[0] policy
     /* 2059001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059011 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2059014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059037 */     // GIR_Coverage, 15471,
     /* 2059037 */     GIR_EraseRootFromParent_Done,
     /* 2059038 */   // Label 27401: @2059038
     /* 2059038 */   GIM_Try, /*On fail goto*//*Label 27402*/ GIMT_Encode4(2059129), // Rule ID 15474 //
     /* 2059043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059089 */     // MIs[0] round
     /* 2059089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059092 */     // MIs[0] policy
     /* 2059092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059102 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059128 */     // GIR_Coverage, 15474,
     /* 2059128 */     GIR_EraseRootFromParent_Done,
     /* 2059129 */   // Label 27402: @2059129
     /* 2059129 */   GIM_Try, /*On fail goto*//*Label 27403*/ GIMT_Encode4(2059220), // Rule ID 15475 //
     /* 2059134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2059154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059180 */     // MIs[0] round
     /* 2059180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059183 */     // MIs[0] policy
     /* 2059183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059193 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059219 */     // GIR_Coverage, 15475,
     /* 2059219 */     GIR_EraseRootFromParent_Done,
     /* 2059220 */   // Label 27403: @2059220
     /* 2059220 */   GIM_Try, /*On fail goto*//*Label 27404*/ GIMT_Encode4(2059311), // Rule ID 15478 //
     /* 2059225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059271 */     // MIs[0] round
     /* 2059271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059274 */     // MIs[0] policy
     /* 2059274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059310 */     // GIR_Coverage, 15478,
     /* 2059310 */     GIR_EraseRootFromParent_Done,
     /* 2059311 */   // Label 27404: @2059311
     /* 2059311 */   GIM_Try, /*On fail goto*//*Label 27405*/ GIMT_Encode4(2059402), // Rule ID 15479 //
     /* 2059316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2059336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059362 */     // MIs[0] round
     /* 2059362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059365 */     // MIs[0] policy
     /* 2059365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059375 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2059378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059401 */     // GIR_Coverage, 15479,
     /* 2059401 */     GIR_EraseRootFromParent_Done,
     /* 2059402 */   // Label 27405: @2059402
     /* 2059402 */   GIM_Try, /*On fail goto*//*Label 27406*/ GIMT_Encode4(2059493), // Rule ID 15482 //
     /* 2059407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2059427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059453 */     // MIs[0] round
     /* 2059453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059456 */     // MIs[0] policy
     /* 2059456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059466 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059492 */     // GIR_Coverage, 15482,
     /* 2059492 */     GIR_EraseRootFromParent_Done,
     /* 2059493 */   // Label 27406: @2059493
     /* 2059493 */   GIM_Try, /*On fail goto*//*Label 27407*/ GIMT_Encode4(2059584), // Rule ID 15483 //
     /* 2059498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2059518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059544 */     // MIs[0] round
     /* 2059544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059547 */     // MIs[0] policy
     /* 2059547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059557 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059583 */     // GIR_Coverage, 15483,
     /* 2059583 */     GIR_EraseRootFromParent_Done,
     /* 2059584 */   // Label 27407: @2059584
     /* 2059584 */   GIM_Try, /*On fail goto*//*Label 27408*/ GIMT_Encode4(2059675), // Rule ID 15486 //
     /* 2059589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2059606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2059609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059635 */     // MIs[0] round
     /* 2059635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059638 */     // MIs[0] policy
     /* 2059638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059648 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059674 */     // GIR_Coverage, 15486,
     /* 2059674 */     GIR_EraseRootFromParent_Done,
     /* 2059675 */   // Label 27408: @2059675
     /* 2059675 */   GIM_Try, /*On fail goto*//*Label 27409*/ GIMT_Encode4(2059766), // Rule ID 15487 //
     /* 2059680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2059697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2059700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059726 */     // MIs[0] round
     /* 2059726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059729 */     // MIs[0] policy
     /* 2059729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059739 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059765 */     // GIR_Coverage, 15487,
     /* 2059765 */     GIR_EraseRootFromParent_Done,
     /* 2059766 */   // Label 27409: @2059766
     /* 2059766 */   GIM_Try, /*On fail goto*//*Label 27410*/ GIMT_Encode4(2059857), // Rule ID 15490 //
     /* 2059771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2059782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2059785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2059788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2059791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059817 */     // MIs[0] round
     /* 2059817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059820 */     // MIs[0] policy
     /* 2059820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059830 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059856 */     // GIR_Coverage, 15490,
     /* 2059856 */     GIR_EraseRootFromParent_Done,
     /* 2059857 */   // Label 27410: @2059857
     /* 2059857 */   GIM_Try, /*On fail goto*//*Label 27411*/ GIMT_Encode4(2059948), // Rule ID 15491 //
     /* 2059862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2059873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2059876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2059879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2059882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059908 */     // MIs[0] round
     /* 2059908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059911 */     // MIs[0] policy
     /* 2059911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059921 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2059924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059947 */     // GIR_Coverage, 15491,
     /* 2059947 */     GIR_EraseRootFromParent_Done,
     /* 2059948 */   // Label 27411: @2059948
     /* 2059948 */   GIM_Try, /*On fail goto*//*Label 27412*/ GIMT_Encode4(2060039), // Rule ID 15494 //
     /* 2059953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2059956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2059961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2059964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2059967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2059970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2059973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059999 */     // MIs[0] round
     /* 2059999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060002 */     // MIs[0] policy
     /* 2060002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060038 */     // GIR_Coverage, 15494,
     /* 2060038 */     GIR_EraseRootFromParent_Done,
     /* 2060039 */   // Label 27412: @2060039
     /* 2060039 */   GIM_Try, /*On fail goto*//*Label 27413*/ GIMT_Encode4(2060130), // Rule ID 15495 //
     /* 2060044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2060047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2060055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2060058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2060061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2060064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2060067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060090 */     // MIs[0] round
     /* 2060090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060093 */     // MIs[0] policy
     /* 2060093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060103 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2060106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2060126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060129 */     // GIR_Coverage, 15495,
     /* 2060129 */     GIR_EraseRootFromParent_Done,
     /* 2060130 */   // Label 27413: @2060130
     /* 2060130 */   GIM_Try, /*On fail goto*//*Label 27414*/ GIMT_Encode4(2060221), // Rule ID 15498 //
     /* 2060135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2060155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060181 */     // MIs[0] round
     /* 2060181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060184 */     // MIs[0] policy
     /* 2060184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060194 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060220 */     // GIR_Coverage, 15498,
     /* 2060220 */     GIR_EraseRootFromParent_Done,
     /* 2060221 */   // Label 27414: @2060221
     /* 2060221 */   GIM_Try, /*On fail goto*//*Label 27415*/ GIMT_Encode4(2060312), // Rule ID 15499 //
     /* 2060226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2060246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060272 */     // MIs[0] round
     /* 2060272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060275 */     // MIs[0] policy
     /* 2060275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060285 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060311 */     // GIR_Coverage, 15499,
     /* 2060311 */     GIR_EraseRootFromParent_Done,
     /* 2060312 */   // Label 27415: @2060312
     /* 2060312 */   GIM_Try, /*On fail goto*//*Label 27416*/ GIMT_Encode4(2060403), // Rule ID 15502 //
     /* 2060317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2060337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060363 */     // MIs[0] round
     /* 2060363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060366 */     // MIs[0] policy
     /* 2060366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060402 */     // GIR_Coverage, 15502,
     /* 2060402 */     GIR_EraseRootFromParent_Done,
     /* 2060403 */   // Label 27416: @2060403
     /* 2060403 */   GIM_Try, /*On fail goto*//*Label 27417*/ GIMT_Encode4(2060494), // Rule ID 15503 //
     /* 2060408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2060428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060454 */     // MIs[0] round
     /* 2060454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060457 */     // MIs[0] policy
     /* 2060457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060467 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060493 */     // GIR_Coverage, 15503,
     /* 2060493 */     GIR_EraseRootFromParent_Done,
     /* 2060494 */   // Label 27417: @2060494
     /* 2060494 */   GIM_Try, /*On fail goto*//*Label 27418*/ GIMT_Encode4(2060585), // Rule ID 15506 //
     /* 2060499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2060519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060545 */     // MIs[0] round
     /* 2060545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060548 */     // MIs[0] policy
     /* 2060548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060558 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2060561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060584 */     // GIR_Coverage, 15506,
     /* 2060584 */     GIR_EraseRootFromParent_Done,
     /* 2060585 */   // Label 27418: @2060585
     /* 2060585 */   GIM_Try, /*On fail goto*//*Label 27419*/ GIMT_Encode4(2060676), // Rule ID 15507 //
     /* 2060590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2060610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060636 */     // MIs[0] round
     /* 2060636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060639 */     // MIs[0] policy
     /* 2060639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060649 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2060652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060675 */     // GIR_Coverage, 15507,
     /* 2060675 */     GIR_EraseRootFromParent_Done,
     /* 2060676 */   // Label 27419: @2060676
     /* 2060676 */   GIM_Try, /*On fail goto*//*Label 27420*/ GIMT_Encode4(2060767), // Rule ID 15510 //
     /* 2060681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2060698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2060701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060727 */     // MIs[0] round
     /* 2060727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060730 */     // MIs[0] policy
     /* 2060730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060766 */     // GIR_Coverage, 15510,
     /* 2060766 */     GIR_EraseRootFromParent_Done,
     /* 2060767 */   // Label 27420: @2060767
     /* 2060767 */   GIM_Try, /*On fail goto*//*Label 27421*/ GIMT_Encode4(2060858), // Rule ID 15511 //
     /* 2060772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2060789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2060792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060818 */     // MIs[0] round
     /* 2060818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060821 */     // MIs[0] policy
     /* 2060821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060831 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2060834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060857 */     // GIR_Coverage, 15511,
     /* 2060857 */     GIR_EraseRootFromParent_Done,
     /* 2060858 */   // Label 27421: @2060858
     /* 2060858 */   GIM_Try, /*On fail goto*//*Label 27422*/ GIMT_Encode4(2060949), // Rule ID 15514 //
     /* 2060863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2060874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2060877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2060880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2060883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060909 */     // MIs[0] round
     /* 2060909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060912 */     // MIs[0] policy
     /* 2060912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060922 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2060925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060948 */     // GIR_Coverage, 15514,
     /* 2060948 */     GIR_EraseRootFromParent_Done,
     /* 2060949 */   // Label 27422: @2060949
     /* 2060949 */   GIM_Try, /*On fail goto*//*Label 27423*/ GIMT_Encode4(2061040), // Rule ID 15515 //
     /* 2060954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2060962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2060965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2060968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2060971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2060974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061000 */     // MIs[0] round
     /* 2061000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061003 */     // MIs[0] policy
     /* 2061003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061013 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061039 */     // GIR_Coverage, 15515,
     /* 2061039 */     GIR_EraseRootFromParent_Done,
     /* 2061040 */   // Label 27423: @2061040
     /* 2061040 */   GIM_Try, /*On fail goto*//*Label 27424*/ GIMT_Encode4(2061131), // Rule ID 15518 //
     /* 2061045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2061065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061091 */     // MIs[0] round
     /* 2061091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061094 */     // MIs[0] policy
     /* 2061094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061104 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061130 */     // GIR_Coverage, 15518,
     /* 2061130 */     GIR_EraseRootFromParent_Done,
     /* 2061131 */   // Label 27424: @2061131
     /* 2061131 */   GIM_Try, /*On fail goto*//*Label 27425*/ GIMT_Encode4(2061222), // Rule ID 15519 //
     /* 2061136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2061156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061182 */     // MIs[0] round
     /* 2061182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061185 */     // MIs[0] policy
     /* 2061185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061195 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061221 */     // GIR_Coverage, 15519,
     /* 2061221 */     GIR_EraseRootFromParent_Done,
     /* 2061222 */   // Label 27425: @2061222
     /* 2061222 */   GIM_Try, /*On fail goto*//*Label 27426*/ GIMT_Encode4(2061313), // Rule ID 15522 //
     /* 2061227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2061247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061273 */     // MIs[0] round
     /* 2061273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061276 */     // MIs[0] policy
     /* 2061276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061312 */     // GIR_Coverage, 15522,
     /* 2061312 */     GIR_EraseRootFromParent_Done,
     /* 2061313 */   // Label 27426: @2061313
     /* 2061313 */   GIM_Try, /*On fail goto*//*Label 27427*/ GIMT_Encode4(2061404), // Rule ID 15523 //
     /* 2061318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2061338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061364 */     // MIs[0] round
     /* 2061364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061367 */     // MIs[0] policy
     /* 2061367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061377 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061403 */     // GIR_Coverage, 15523,
     /* 2061403 */     GIR_EraseRootFromParent_Done,
     /* 2061404 */   // Label 27427: @2061404
     /* 2061404 */   GIM_Try, /*On fail goto*//*Label 27428*/ GIMT_Encode4(2061495), // Rule ID 15526 //
     /* 2061409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061455 */     // MIs[0] round
     /* 2061455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061458 */     // MIs[0] policy
     /* 2061458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061494 */     // GIR_Coverage, 15526,
     /* 2061494 */     GIR_EraseRootFromParent_Done,
     /* 2061495 */   // Label 27428: @2061495
     /* 2061495 */   GIM_Try, /*On fail goto*//*Label 27429*/ GIMT_Encode4(2061586), // Rule ID 15527 //
     /* 2061500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2061520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061546 */     // MIs[0] round
     /* 2061546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061549 */     // MIs[0] policy
     /* 2061549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061559 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2061562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061585 */     // GIR_Coverage, 15527,
     /* 2061585 */     GIR_EraseRootFromParent_Done,
     /* 2061586 */   // Label 27429: @2061586
     /* 2061586 */   GIM_Try, /*On fail goto*//*Label 27430*/ GIMT_Encode4(2061677), // Rule ID 15530 //
     /* 2061591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2061608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2061611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061637 */     // MIs[0] round
     /* 2061637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061640 */     // MIs[0] policy
     /* 2061640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061676 */     // GIR_Coverage, 15530,
     /* 2061676 */     GIR_EraseRootFromParent_Done,
     /* 2061677 */   // Label 27430: @2061677
     /* 2061677 */   GIM_Try, /*On fail goto*//*Label 27431*/ GIMT_Encode4(2061768), // Rule ID 15531 //
     /* 2061682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2061699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2061702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061728 */     // MIs[0] round
     /* 2061728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061731 */     // MIs[0] policy
     /* 2061731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2061744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061767 */     // GIR_Coverage, 15531,
     /* 2061767 */     GIR_EraseRootFromParent_Done,
     /* 2061768 */   // Label 27431: @2061768
     /* 2061768 */   GIM_Try, /*On fail goto*//*Label 27432*/ GIMT_Encode4(2061859), // Rule ID 15534 //
     /* 2061773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2061776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2061784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2061787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2061790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2061793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2061796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061819 */     // MIs[0] round
     /* 2061819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061822 */     // MIs[0] policy
     /* 2061822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061832 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061858 */     // GIR_Coverage, 15534,
     /* 2061858 */     GIR_EraseRootFromParent_Done,
     /* 2061859 */   // Label 27432: @2061859
     /* 2061859 */   GIM_Try, /*On fail goto*//*Label 27433*/ GIMT_Encode4(2061950), // Rule ID 15535 //
     /* 2061864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2061867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2061875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2061878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2061881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2061884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2061887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061910 */     // MIs[0] round
     /* 2061910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061913 */     // MIs[0] policy
     /* 2061913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061923 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2061926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061949 */     // GIR_Coverage, 15535,
     /* 2061949 */     GIR_EraseRootFromParent_Done,
     /* 2061950 */   // Label 27433: @2061950
     /* 2061950 */   GIM_Try, /*On fail goto*//*Label 27434*/ GIMT_Encode4(2062041), // Rule ID 15538 //
     /* 2061955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2061958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2061963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2061966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2061969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2061972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2061975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062001 */     // MIs[0] round
     /* 2062001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062004 */     // MIs[0] policy
     /* 2062004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062014 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062040 */     // GIR_Coverage, 15538,
     /* 2062040 */     GIR_EraseRootFromParent_Done,
     /* 2062041 */   // Label 27434: @2062041
     /* 2062041 */   GIM_Try, /*On fail goto*//*Label 27435*/ GIMT_Encode4(2062132), // Rule ID 15539 //
     /* 2062046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2062057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2062060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2062063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2062066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062092 */     // MIs[0] round
     /* 2062092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062095 */     // MIs[0] policy
     /* 2062095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062105 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2062108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062131 */     // GIR_Coverage, 15539,
     /* 2062131 */     GIR_EraseRootFromParent_Done,
     /* 2062132 */   // Label 27435: @2062132
     /* 2062132 */   GIM_Try, /*On fail goto*//*Label 27436*/ GIMT_Encode4(2062223), // Rule ID 15542 //
     /* 2062137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2062140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062183 */     // MIs[0] round
     /* 2062183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062186 */     // MIs[0] policy
     /* 2062186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062196 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062222 */     // GIR_Coverage, 15542,
     /* 2062222 */     GIR_EraseRootFromParent_Done,
     /* 2062223 */   // Label 27436: @2062223
     /* 2062223 */   GIM_Try, /*On fail goto*//*Label 27437*/ GIMT_Encode4(2062314), // Rule ID 15543 //
     /* 2062228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2062231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062274 */     // MIs[0] round
     /* 2062274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062277 */     // MIs[0] policy
     /* 2062277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062287 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2062290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062313 */     // GIR_Coverage, 15543,
     /* 2062313 */     GIR_EraseRootFromParent_Done,
     /* 2062314 */   // Label 27437: @2062314
     /* 2062314 */   GIM_Try, /*On fail goto*//*Label 27438*/ GIMT_Encode4(2062405), // Rule ID 15546 //
     /* 2062319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062365 */     // MIs[0] round
     /* 2062365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062368 */     // MIs[0] policy
     /* 2062368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062378 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2062381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062404 */     // GIR_Coverage, 15546,
     /* 2062404 */     GIR_EraseRootFromParent_Done,
     /* 2062405 */   // Label 27438: @2062405
     /* 2062405 */   GIM_Try, /*On fail goto*//*Label 27439*/ GIMT_Encode4(2062496), // Rule ID 15547 //
     /* 2062410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2062421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2062424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2062427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062456 */     // MIs[0] round
     /* 2062456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062459 */     // MIs[0] policy
     /* 2062459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062469 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2062472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062495 */     // GIR_Coverage, 15547,
     /* 2062495 */     GIR_EraseRootFromParent_Done,
     /* 2062496 */   // Label 27439: @2062496
     /* 2062496 */   GIM_Try, /*On fail goto*//*Label 27440*/ GIMT_Encode4(2062587), // Rule ID 15550 //
     /* 2062501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2062512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2062515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2062518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062547 */     // MIs[0] round
     /* 2062547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062550 */     // MIs[0] policy
     /* 2062550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062560 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2062563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062586 */     // GIR_Coverage, 15550,
     /* 2062586 */     GIR_EraseRootFromParent_Done,
     /* 2062587 */   // Label 27440: @2062587
     /* 2062587 */   GIM_Try, /*On fail goto*//*Label 27441*/ GIMT_Encode4(2062678), // Rule ID 15551 //
     /* 2062592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2062603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2062606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2062609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062638 */     // MIs[0] round
     /* 2062638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062641 */     // MIs[0] policy
     /* 2062641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062651 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2062654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062677 */     // GIR_Coverage, 15551,
     /* 2062677 */     GIR_EraseRootFromParent_Done,
     /* 2062678 */   // Label 27441: @2062678
     /* 2062678 */   GIM_Try, /*On fail goto*//*Label 27442*/ GIMT_Encode4(2062769), // Rule ID 15554 //
     /* 2062683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2062694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2062697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2062700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062729 */     // MIs[0] round
     /* 2062729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062732 */     // MIs[0] policy
     /* 2062732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062742 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2062745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062768 */     // GIR_Coverage, 15554,
     /* 2062768 */     GIR_EraseRootFromParent_Done,
     /* 2062769 */   // Label 27442: @2062769
     /* 2062769 */   GIM_Try, /*On fail goto*//*Label 27443*/ GIMT_Encode4(2062860), // Rule ID 15555 //
     /* 2062774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2062785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2062788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2062791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062820 */     // MIs[0] round
     /* 2062820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062823 */     // MIs[0] policy
     /* 2062823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062833 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2062836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2062856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062859 */     // GIR_Coverage, 15555,
     /* 2062859 */     GIR_EraseRootFromParent_Done,
     /* 2062860 */   // Label 27443: @2062860
     /* 2062860 */   GIM_Try, /*On fail goto*//*Label 27444*/ GIMT_Encode4(2062951), // Rule ID 15558 //
     /* 2062865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2062868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2062876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2062879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2062882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062911 */     // MIs[0] round
     /* 2062911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062914 */     // MIs[0] policy
     /* 2062914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062924 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2062927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2062947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062950 */     // GIR_Coverage, 15558,
     /* 2062950 */     GIR_EraseRootFromParent_Done,
     /* 2062951 */   // Label 27444: @2062951
     /* 2062951 */   GIM_Try, /*On fail goto*//*Label 27445*/ GIMT_Encode4(2063042), // Rule ID 15559 //
     /* 2062956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2062959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2062964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2062967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2062970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2062973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063002 */     // MIs[0] round
     /* 2063002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063005 */     // MIs[0] policy
     /* 2063005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063015 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2063018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063041 */     // GIR_Coverage, 15559,
     /* 2063041 */     GIR_EraseRootFromParent_Done,
     /* 2063042 */   // Label 27445: @2063042
     /* 2063042 */   GIM_Try, /*On fail goto*//*Label 27446*/ GIMT_Encode4(2063133), // Rule ID 15562 //
     /* 2063047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063093 */     // MIs[0] round
     /* 2063093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063096 */     // MIs[0] policy
     /* 2063096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063106 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063132 */     // GIR_Coverage, 15562,
     /* 2063132 */     GIR_EraseRootFromParent_Done,
     /* 2063133 */   // Label 27446: @2063133
     /* 2063133 */   GIM_Try, /*On fail goto*//*Label 27447*/ GIMT_Encode4(2063224), // Rule ID 15563 //
     /* 2063138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2063149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2063152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2063155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063184 */     // MIs[0] round
     /* 2063184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063187 */     // MIs[0] policy
     /* 2063187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063197 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063223 */     // GIR_Coverage, 15563,
     /* 2063223 */     GIR_EraseRootFromParent_Done,
     /* 2063224 */   // Label 27447: @2063224
     /* 2063224 */   GIM_Try, /*On fail goto*//*Label 27448*/ GIMT_Encode4(2063315), // Rule ID 15566 //
     /* 2063229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063275 */     // MIs[0] round
     /* 2063275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063278 */     // MIs[0] policy
     /* 2063278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063288 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063314 */     // GIR_Coverage, 15566,
     /* 2063314 */     GIR_EraseRootFromParent_Done,
     /* 2063315 */   // Label 27448: @2063315
     /* 2063315 */   GIM_Try, /*On fail goto*//*Label 27449*/ GIMT_Encode4(2063406), // Rule ID 15567 //
     /* 2063320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2063331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2063334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2063337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063366 */     // MIs[0] round
     /* 2063366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063369 */     // MIs[0] policy
     /* 2063369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063379 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2063382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063405 */     // GIR_Coverage, 15567,
     /* 2063405 */     GIR_EraseRootFromParent_Done,
     /* 2063406 */   // Label 27449: @2063406
     /* 2063406 */   GIM_Try, /*On fail goto*//*Label 27450*/ GIMT_Encode4(2063497), // Rule ID 15570 //
     /* 2063411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063457 */     // MIs[0] round
     /* 2063457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063460 */     // MIs[0] policy
     /* 2063460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063470 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063496 */     // GIR_Coverage, 15570,
     /* 2063496 */     GIR_EraseRootFromParent_Done,
     /* 2063497 */   // Label 27450: @2063497
     /* 2063497 */   GIM_Try, /*On fail goto*//*Label 27451*/ GIMT_Encode4(2063588), // Rule ID 15571 //
     /* 2063502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2063513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2063516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2063519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063548 */     // MIs[0] round
     /* 2063548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063551 */     // MIs[0] policy
     /* 2063551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063561 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11139:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063587 */     // GIR_Coverage, 15571,
     /* 2063587 */     GIR_EraseRootFromParent_Done,
     /* 2063588 */   // Label 27451: @2063588
     /* 2063588 */   GIM_Try, /*On fail goto*//*Label 27452*/ GIMT_Encode4(2063679), // Rule ID 15574 //
     /* 2063593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2063604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2063607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2063610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063639 */     // MIs[0] round
     /* 2063639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063642 */     // MIs[0] policy
     /* 2063642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063678 */     // GIR_Coverage, 15574,
     /* 2063678 */     GIR_EraseRootFromParent_Done,
     /* 2063679 */   // Label 27452: @2063679
     /* 2063679 */   GIM_Try, /*On fail goto*//*Label 27453*/ GIMT_Encode4(2063770), // Rule ID 15575 //
     /* 2063684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2063695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2063698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2063701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063730 */     // MIs[0] round
     /* 2063730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063733 */     // MIs[0] policy
     /* 2063733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063743 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063769 */     // GIR_Coverage, 15575,
     /* 2063769 */     GIR_EraseRootFromParent_Done,
     /* 2063770 */   // Label 27453: @2063770
     /* 2063770 */   GIM_Try, /*On fail goto*//*Label 27454*/ GIMT_Encode4(2063861), // Rule ID 15578 //
     /* 2063775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2063786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2063789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2063792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063821 */     // MIs[0] round
     /* 2063821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063824 */     // MIs[0] policy
     /* 2063824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063860 */     // GIR_Coverage, 15578,
     /* 2063860 */     GIR_EraseRootFromParent_Done,
     /* 2063861 */   // Label 27454: @2063861
     /* 2063861 */   GIM_Try, /*On fail goto*//*Label 27455*/ GIMT_Encode4(2063952), // Rule ID 15579 //
     /* 2063866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2063877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2063880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2063883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063912 */     // MIs[0] round
     /* 2063912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063915 */     // MIs[0] policy
     /* 2063915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2063928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2063948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063951 */     // GIR_Coverage, 15579,
     /* 2063951 */     GIR_EraseRootFromParent_Done,
     /* 2063952 */   // Label 27455: @2063952
     /* 2063952 */   GIM_Try, /*On fail goto*//*Label 27456*/ GIMT_Encode4(2064043), // Rule ID 15582 //
     /* 2063957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2063960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2063965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2063968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2063971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2063974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064003 */     // MIs[0] round
     /* 2064003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064006 */     // MIs[0] policy
     /* 2064006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064016 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064042 */     // GIR_Coverage, 15582,
     /* 2064042 */     GIR_EraseRootFromParent_Done,
     /* 2064043 */   // Label 27456: @2064043
     /* 2064043 */   GIM_Try, /*On fail goto*//*Label 27457*/ GIMT_Encode4(2064134), // Rule ID 15583 //
     /* 2064048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2064051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2064059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2064062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2064065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064094 */     // MIs[0] round
     /* 2064094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064097 */     // MIs[0] policy
     /* 2064097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064107 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2064110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2064130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064133 */     // GIR_Coverage, 15583,
     /* 2064133 */     GIR_EraseRootFromParent_Done,
     /* 2064134 */   // Label 27457: @2064134
     /* 2064134 */   GIM_Try, /*On fail goto*//*Label 27458*/ GIMT_Encode4(2064225), // Rule ID 15586 //
     /* 2064139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064185 */     // MIs[0] round
     /* 2064185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064188 */     // MIs[0] policy
     /* 2064188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064224 */     // GIR_Coverage, 15586,
     /* 2064224 */     GIR_EraseRootFromParent_Done,
     /* 2064225 */   // Label 27458: @2064225
     /* 2064225 */   GIM_Try, /*On fail goto*//*Label 27459*/ GIMT_Encode4(2064316), // Rule ID 15587 //
     /* 2064230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2064241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2064244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2064247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064276 */     // MIs[0] round
     /* 2064276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064279 */     // MIs[0] policy
     /* 2064279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064289 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064315 */     // GIR_Coverage, 15587,
     /* 2064315 */     GIR_EraseRootFromParent_Done,
     /* 2064316 */   // Label 27459: @2064316
     /* 2064316 */   GIM_Try, /*On fail goto*//*Label 27460*/ GIMT_Encode4(2064407), // Rule ID 15590 //
     /* 2064321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064367 */     // MIs[0] round
     /* 2064367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064370 */     // MIs[0] policy
     /* 2064370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064380 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064406 */     // GIR_Coverage, 15590,
     /* 2064406 */     GIR_EraseRootFromParent_Done,
     /* 2064407 */   // Label 27460: @2064407
     /* 2064407 */   GIM_Try, /*On fail goto*//*Label 27461*/ GIMT_Encode4(2064498), // Rule ID 15591 //
     /* 2064412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2064423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2064426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2064429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2064435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064458 */     // MIs[0] round
     /* 2064458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064461 */     // MIs[0] policy
     /* 2064461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064471 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064497 */     // GIR_Coverage, 15591,
     /* 2064497 */     GIR_EraseRootFromParent_Done,
     /* 2064498 */   // Label 27461: @2064498
     /* 2064498 */   GIM_Try, /*On fail goto*//*Label 27462*/ GIMT_Encode4(2064589), // Rule ID 15594 //
     /* 2064503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2064514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2064517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2064520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2064526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064549 */     // MIs[0] round
     /* 2064549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064552 */     // MIs[0] policy
     /* 2064552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064562 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2064565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064588 */     // GIR_Coverage, 15594,
     /* 2064588 */     GIR_EraseRootFromParent_Done,
     /* 2064589 */   // Label 27462: @2064589
     /* 2064589 */   GIM_Try, /*On fail goto*//*Label 27463*/ GIMT_Encode4(2064680), // Rule ID 15595 //
     /* 2064594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2064605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2064608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2064611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2064617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2064624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2064632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064640 */     // MIs[0] round
     /* 2064640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064643 */     // MIs[0] policy
     /* 2064643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064653 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2064656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064679 */     // GIR_Coverage, 15595,
     /* 2064679 */     GIR_EraseRootFromParent_Done,
     /* 2064680 */   // Label 27463: @2064680
     /* 2064680 */   GIM_Try, /*On fail goto*//*Label 27464*/ GIMT_Encode4(2064771), // Rule ID 15598 //
     /* 2064685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2064696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2064699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2064702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064731 */     // MIs[0] round
     /* 2064731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064734 */     // MIs[0] policy
     /* 2064734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064770 */     // GIR_Coverage, 15598,
     /* 2064770 */     GIR_EraseRootFromParent_Done,
     /* 2064771 */   // Label 27464: @2064771
     /* 2064771 */   GIM_Try, /*On fail goto*//*Label 27465*/ GIMT_Encode4(2064862), // Rule ID 15599 //
     /* 2064776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2064787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2064790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2064793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2064806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2064814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064822 */     // MIs[0] round
     /* 2064822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064825 */     // MIs[0] policy
     /* 2064825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064835 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2064838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064861 */     // GIR_Coverage, 15599,
     /* 2064861 */     GIR_EraseRootFromParent_Done,
     /* 2064862 */   // Label 27465: @2064862
     /* 2064862 */   GIM_Try, /*On fail goto*//*Label 27466*/ GIMT_Encode4(2064953), // Rule ID 15602 //
     /* 2064867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2064878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2064881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2064884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2064887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2064909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064913 */     // MIs[0] round
     /* 2064913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064916 */     // MIs[0] policy
     /* 2064916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064926 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2064929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064952 */     // GIR_Coverage, 15602,
     /* 2064952 */     GIR_EraseRootFromParent_Done,
     /* 2064953 */   // Label 27466: @2064953
     /* 2064953 */   GIM_Try, /*On fail goto*//*Label 27467*/ GIMT_Encode4(2065044), // Rule ID 15603 //
     /* 2064958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2064966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2064969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2064972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2064975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2064978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2064981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2064988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2064996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065004 */     // MIs[0] round
     /* 2065004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065007 */     // MIs[0] policy
     /* 2065007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065017 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065043 */     // GIR_Coverage, 15603,
     /* 2065043 */     GIR_EraseRootFromParent_Done,
     /* 2065044 */   // Label 27467: @2065044
     /* 2065044 */   GIM_Try, /*On fail goto*//*Label 27468*/ GIMT_Encode4(2065135), // Rule ID 15606 //
     /* 2065049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065095 */     // MIs[0] round
     /* 2065095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065098 */     // MIs[0] policy
     /* 2065098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065108 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065134 */     // GIR_Coverage, 15606,
     /* 2065134 */     GIR_EraseRootFromParent_Done,
     /* 2065135 */   // Label 27468: @2065135
     /* 2065135 */   GIM_Try, /*On fail goto*//*Label 27469*/ GIMT_Encode4(2065226), // Rule ID 15607 //
     /* 2065140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2065151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2065154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2065157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065186 */     // MIs[0] round
     /* 2065186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065189 */     // MIs[0] policy
     /* 2065189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065199 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065225 */     // GIR_Coverage, 15607,
     /* 2065225 */     GIR_EraseRootFromParent_Done,
     /* 2065226 */   // Label 27469: @2065226
     /* 2065226 */   GIM_Try, /*On fail goto*//*Label 27470*/ GIMT_Encode4(2065317), // Rule ID 15610 //
     /* 2065231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065277 */     // MIs[0] round
     /* 2065277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065280 */     // MIs[0] policy
     /* 2065280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065316 */     // GIR_Coverage, 15610,
     /* 2065316 */     GIR_EraseRootFromParent_Done,
     /* 2065317 */   // Label 27470: @2065317
     /* 2065317 */   GIM_Try, /*On fail goto*//*Label 27471*/ GIMT_Encode4(2065408), // Rule ID 15611 //
     /* 2065322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2065333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2065336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2065339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065368 */     // MIs[0] round
     /* 2065368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065371 */     // MIs[0] policy
     /* 2065371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065381 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065407 */     // GIR_Coverage, 15611,
     /* 2065407 */     GIR_EraseRootFromParent_Done,
     /* 2065408 */   // Label 27471: @2065408
     /* 2065408 */   GIM_Try, /*On fail goto*//*Label 27472*/ GIMT_Encode4(2065499), // Rule ID 15614 //
     /* 2065413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065459 */     // MIs[0] round
     /* 2065459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065462 */     // MIs[0] policy
     /* 2065462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065472 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065498 */     // GIR_Coverage, 15614,
     /* 2065498 */     GIR_EraseRootFromParent_Done,
     /* 2065499 */   // Label 27472: @2065499
     /* 2065499 */   GIM_Try, /*On fail goto*//*Label 27473*/ GIMT_Encode4(2065590), // Rule ID 15615 //
     /* 2065504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2065515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2065518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2065521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065550 */     // MIs[0] round
     /* 2065550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065553 */     // MIs[0] policy
     /* 2065553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065563 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2065566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065589 */     // GIR_Coverage, 15615,
     /* 2065589 */     GIR_EraseRootFromParent_Done,
     /* 2065590 */   // Label 27473: @2065590
     /* 2065590 */   GIM_Try, /*On fail goto*//*Label 27474*/ GIMT_Encode4(2065681), // Rule ID 15618 //
     /* 2065595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2065606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2065609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2065612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065641 */     // MIs[0] round
     /* 2065641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065644 */     // MIs[0] policy
     /* 2065644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065654 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065680 */     // GIR_Coverage, 15618,
     /* 2065680 */     GIR_EraseRootFromParent_Done,
     /* 2065681 */   // Label 27474: @2065681
     /* 2065681 */   GIM_Try, /*On fail goto*//*Label 27475*/ GIMT_Encode4(2065772), // Rule ID 15619 //
     /* 2065686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2065697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2065700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2065703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065732 */     // MIs[0] round
     /* 2065732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065735 */     // MIs[0] policy
     /* 2065735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065745 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2065748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2065768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065771 */     // GIR_Coverage, 15619,
     /* 2065771 */     GIR_EraseRootFromParent_Done,
     /* 2065772 */   // Label 27475: @2065772
     /* 2065772 */   GIM_Try, /*On fail goto*//*Label 27476*/ GIMT_Encode4(2065863), // Rule ID 15622 //
     /* 2065777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2065780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2065788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2065791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2065794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2065800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065823 */     // MIs[0] round
     /* 2065823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065826 */     // MIs[0] policy
     /* 2065826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065862 */     // GIR_Coverage, 15622,
     /* 2065862 */     GIR_EraseRootFromParent_Done,
     /* 2065863 */   // Label 27476: @2065863
     /* 2065863 */   GIM_Try, /*On fail goto*//*Label 27477*/ GIMT_Encode4(2065954), // Rule ID 15623 //
     /* 2065868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2065871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2065879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2065882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2065885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2065888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2065891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2065910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065914 */     // MIs[0] round
     /* 2065914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065917 */     // MIs[0] policy
     /* 2065917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065927 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2065930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065953 */     // GIR_Coverage, 15623,
     /* 2065953 */     GIR_EraseRootFromParent_Done,
     /* 2065954 */   // Label 27477: @2065954
     /* 2065954 */   GIM_Try, /*On fail goto*//*Label 27478*/ GIMT_Encode4(2066045), // Rule ID 15626 //
     /* 2065959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2065962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2065967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2065970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2065973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2065976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2065979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2065982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066005 */     // MIs[0] round
     /* 2066005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066008 */     // MIs[0] policy
     /* 2066008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066044 */     // GIR_Coverage, 15626,
     /* 2066044 */     GIR_EraseRootFromParent_Done,
     /* 2066045 */   // Label 27478: @2066045
     /* 2066045 */   GIM_Try, /*On fail goto*//*Label 27479*/ GIMT_Encode4(2066136), // Rule ID 15627 //
     /* 2066050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2066061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2066064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2066067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066096 */     // MIs[0] round
     /* 2066096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066099 */     // MIs[0] policy
     /* 2066099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066109 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2066112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066135 */     // GIR_Coverage, 15627,
     /* 2066135 */     GIR_EraseRootFromParent_Done,
     /* 2066136 */   // Label 27479: @2066136
     /* 2066136 */   GIM_Try, /*On fail goto*//*Label 27480*/ GIMT_Encode4(2066227), // Rule ID 15630 //
     /* 2066141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2066144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2066161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066187 */     // MIs[0] round
     /* 2066187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066190 */     // MIs[0] policy
     /* 2066190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066226 */     // GIR_Coverage, 15630,
     /* 2066226 */     GIR_EraseRootFromParent_Done,
     /* 2066227 */   // Label 27480: @2066227
     /* 2066227 */   GIM_Try, /*On fail goto*//*Label 27481*/ GIMT_Encode4(2066318), // Rule ID 15631 //
     /* 2066232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2066240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2066243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2066246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2066249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2066252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2066274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066278 */     // MIs[0] round
     /* 2066278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066281 */     // MIs[0] policy
     /* 2066281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066291 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2066294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066317 */     // GIR_Coverage, 15631,
     /* 2066317 */     GIR_EraseRootFromParent_Done,
     /* 2066318 */   // Label 27481: @2066318
     /* 2066318 */   GIM_Try, /*On fail goto*//*Label 27482*/ GIMT_Encode4(2066412), // Rule ID 15634 //
     /* 2066323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2066343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066369 */     // MIs[0] round
     /* 2066369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066372 */     // MIs[0] policy
     /* 2066372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066382 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2066385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066411 */     // GIR_Coverage, 15634,
     /* 2066411 */     GIR_EraseRootFromParent_Done,
     /* 2066412 */   // Label 27482: @2066412
     /* 2066412 */   GIM_Try, /*On fail goto*//*Label 27483*/ GIMT_Encode4(2066506), // Rule ID 15635 //
     /* 2066417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2066428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2066431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2066434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2066437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066463 */     // MIs[0] round
     /* 2066463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066466 */     // MIs[0] policy
     /* 2066466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066476 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2066479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066505 */     // GIR_Coverage, 15635,
     /* 2066505 */     GIR_EraseRootFromParent_Done,
     /* 2066506 */   // Label 27483: @2066506
     /* 2066506 */   GIM_Try, /*On fail goto*//*Label 27484*/ GIMT_Encode4(2066600), // Rule ID 15638 //
     /* 2066511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2066522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2066525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2066528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2066531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066557 */     // MIs[0] round
     /* 2066557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066560 */     // MIs[0] policy
     /* 2066560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066570 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2066573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066599 */     // GIR_Coverage, 15638,
     /* 2066599 */     GIR_EraseRootFromParent_Done,
     /* 2066600 */   // Label 27484: @2066600
     /* 2066600 */   GIM_Try, /*On fail goto*//*Label 27485*/ GIMT_Encode4(2066694), // Rule ID 15639 //
     /* 2066605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2066616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2066619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2066622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2066625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066651 */     // MIs[0] round
     /* 2066651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066654 */     // MIs[0] policy
     /* 2066654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066664 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2066667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066693 */     // GIR_Coverage, 15639,
     /* 2066693 */     GIR_EraseRootFromParent_Done,
     /* 2066694 */   // Label 27485: @2066694
     /* 2066694 */   GIM_Try, /*On fail goto*//*Label 27486*/ GIMT_Encode4(2066788), // Rule ID 15642 //
     /* 2066699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2066710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2066713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2066716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2066719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066745 */     // MIs[0] round
     /* 2066745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066748 */     // MIs[0] policy
     /* 2066748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066758 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2066761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066787 */     // GIR_Coverage, 15642,
     /* 2066787 */     GIR_EraseRootFromParent_Done,
     /* 2066788 */   // Label 27486: @2066788
     /* 2066788 */   GIM_Try, /*On fail goto*//*Label 27487*/ GIMT_Encode4(2066882), // Rule ID 15643 //
     /* 2066793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2066804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2066807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2066810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2066813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066839 */     // MIs[0] round
     /* 2066839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066842 */     // MIs[0] policy
     /* 2066842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066852 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2066855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2066875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066881 */     // GIR_Coverage, 15643,
     /* 2066881 */     GIR_EraseRootFromParent_Done,
     /* 2066882 */   // Label 27487: @2066882
     /* 2066882 */   GIM_Try, /*On fail goto*//*Label 27488*/ GIMT_Encode4(2066976), // Rule ID 15646 //
     /* 2066887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2066898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2066901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2066904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2066907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2066910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2066917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2066929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066933 */     // MIs[0] round
     /* 2066933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066936 */     // MIs[0] policy
     /* 2066936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2066949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2066974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066975 */     // GIR_Coverage, 15646,
     /* 2066975 */     GIR_EraseRootFromParent_Done,
     /* 2066976 */   // Label 27488: @2066976
     /* 2066976 */   GIM_Try, /*On fail goto*//*Label 27489*/ GIMT_Encode4(2067070), // Rule ID 15647 //
     /* 2066981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2066989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2066992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2066995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2066998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2067001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067027 */     // MIs[0] round
     /* 2067027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067030 */     // MIs[0] policy
     /* 2067030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2067043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067069 */     // GIR_Coverage, 15647,
     /* 2067069 */     GIR_EraseRootFromParent_Done,
     /* 2067070 */   // Label 27489: @2067070
     /* 2067070 */   GIM_Try, /*On fail goto*//*Label 27490*/ GIMT_Encode4(2067164), // Rule ID 15650 //
     /* 2067075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067121 */     // MIs[0] round
     /* 2067121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067124 */     // MIs[0] policy
     /* 2067124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067134 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067163 */     // GIR_Coverage, 15650,
     /* 2067163 */     GIR_EraseRootFromParent_Done,
     /* 2067164 */   // Label 27490: @2067164
     /* 2067164 */   GIM_Try, /*On fail goto*//*Label 27491*/ GIMT_Encode4(2067258), // Rule ID 15651 //
     /* 2067169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2067180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2067183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2067186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2067189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067215 */     // MIs[0] round
     /* 2067215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067218 */     // MIs[0] policy
     /* 2067218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067228 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067257 */     // GIR_Coverage, 15651,
     /* 2067257 */     GIR_EraseRootFromParent_Done,
     /* 2067258 */   // Label 27491: @2067258
     /* 2067258 */   GIM_Try, /*On fail goto*//*Label 27492*/ GIMT_Encode4(2067352), // Rule ID 15654 //
     /* 2067263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067309 */     // MIs[0] round
     /* 2067309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067312 */     // MIs[0] policy
     /* 2067312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067322 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067351 */     // GIR_Coverage, 15654,
     /* 2067351 */     GIR_EraseRootFromParent_Done,
     /* 2067352 */   // Label 27492: @2067352
     /* 2067352 */   GIM_Try, /*On fail goto*//*Label 27493*/ GIMT_Encode4(2067446), // Rule ID 15655 //
     /* 2067357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2067368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2067371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2067374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2067377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067403 */     // MIs[0] round
     /* 2067403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067406 */     // MIs[0] policy
     /* 2067406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2067419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067445 */     // GIR_Coverage, 15655,
     /* 2067445 */     GIR_EraseRootFromParent_Done,
     /* 2067446 */   // Label 27493: @2067446
     /* 2067446 */   GIM_Try, /*On fail goto*//*Label 27494*/ GIMT_Encode4(2067540), // Rule ID 15658 //
     /* 2067451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2067462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2067465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2067468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2067471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067497 */     // MIs[0] round
     /* 2067497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067500 */     // MIs[0] policy
     /* 2067500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067539 */     // GIR_Coverage, 15658,
     /* 2067539 */     GIR_EraseRootFromParent_Done,
     /* 2067540 */   // Label 27494: @2067540
     /* 2067540 */   GIM_Try, /*On fail goto*//*Label 27495*/ GIMT_Encode4(2067634), // Rule ID 15659 //
     /* 2067545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2067556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2067559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2067562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2067565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067591 */     // MIs[0] round
     /* 2067591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067594 */     // MIs[0] policy
     /* 2067594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067604 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067633 */     // GIR_Coverage, 15659,
     /* 2067633 */     GIR_EraseRootFromParent_Done,
     /* 2067634 */   // Label 27495: @2067634
     /* 2067634 */   GIM_Try, /*On fail goto*//*Label 27496*/ GIMT_Encode4(2067728), // Rule ID 15662 //
     /* 2067639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2067650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2067653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2067656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2067659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067685 */     // MIs[0] round
     /* 2067685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067688 */     // MIs[0] policy
     /* 2067688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067727 */     // GIR_Coverage, 15662,
     /* 2067727 */     GIR_EraseRootFromParent_Done,
     /* 2067728 */   // Label 27496: @2067728
     /* 2067728 */   GIM_Try, /*On fail goto*//*Label 27497*/ GIMT_Encode4(2067822), // Rule ID 15663 //
     /* 2067733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2067744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2067747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2067750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2067753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067779 */     // MIs[0] round
     /* 2067779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067782 */     // MIs[0] policy
     /* 2067782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067792 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067821 */     // GIR_Coverage, 15663,
     /* 2067821 */     GIR_EraseRootFromParent_Done,
     /* 2067822 */   // Label 27497: @2067822
     /* 2067822 */   GIM_Try, /*On fail goto*//*Label 27498*/ GIMT_Encode4(2067916), // Rule ID 15666 //
     /* 2067827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2067838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2067841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2067844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2067847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067873 */     // MIs[0] round
     /* 2067873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067876 */     // MIs[0] policy
     /* 2067876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2067909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2067914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067915 */     // GIR_Coverage, 15666,
     /* 2067915 */     GIR_EraseRootFromParent_Done,
     /* 2067916 */   // Label 27498: @2067916
     /* 2067916 */   GIM_Try, /*On fail goto*//*Label 27499*/ GIMT_Encode4(2068010), // Rule ID 15667 //
     /* 2067921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2067929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2067932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2067935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2067938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2067941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067967 */     // MIs[0] round
     /* 2067967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067970 */     // MIs[0] policy
     /* 2067970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067980 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2067983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068009 */     // GIR_Coverage, 15667,
     /* 2068009 */     GIR_EraseRootFromParent_Done,
     /* 2068010 */   // Label 27499: @2068010
     /* 2068010 */   GIM_Try, /*On fail goto*//*Label 27500*/ GIMT_Encode4(2068104), // Rule ID 15670 //
     /* 2068015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2068026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2068029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2068035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068061 */     // MIs[0] round
     /* 2068061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068064 */     // MIs[0] policy
     /* 2068064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068103 */     // GIR_Coverage, 15670,
     /* 2068103 */     GIR_EraseRootFromParent_Done,
     /* 2068104 */   // Label 27500: @2068104
     /* 2068104 */   GIM_Try, /*On fail goto*//*Label 27501*/ GIMT_Encode4(2068198), // Rule ID 15671 //
     /* 2068109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2068120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2068123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2068126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2068129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068155 */     // MIs[0] round
     /* 2068155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068158 */     // MIs[0] policy
     /* 2068158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068168 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068197 */     // GIR_Coverage, 15671,
     /* 2068197 */     GIR_EraseRootFromParent_Done,
     /* 2068198 */   // Label 27501: @2068198
     /* 2068198 */   GIM_Try, /*On fail goto*//*Label 27502*/ GIMT_Encode4(2068292), // Rule ID 15674 //
     /* 2068203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2068223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068249 */     // MIs[0] round
     /* 2068249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068252 */     // MIs[0] policy
     /* 2068252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068262 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068291 */     // GIR_Coverage, 15674,
     /* 2068291 */     GIR_EraseRootFromParent_Done,
     /* 2068292 */   // Label 27502: @2068292
     /* 2068292 */   GIM_Try, /*On fail goto*//*Label 27503*/ GIMT_Encode4(2068386), // Rule ID 15675 //
     /* 2068297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2068308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2068311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2068314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2068317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068343 */     // MIs[0] round
     /* 2068343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068346 */     // MIs[0] policy
     /* 2068346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068385 */     // GIR_Coverage, 15675,
     /* 2068385 */     GIR_EraseRootFromParent_Done,
     /* 2068386 */   // Label 27503: @2068386
     /* 2068386 */   GIM_Try, /*On fail goto*//*Label 27504*/ GIMT_Encode4(2068480), // Rule ID 15678 //
     /* 2068391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2068411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068437 */     // MIs[0] round
     /* 2068437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068440 */     // MIs[0] policy
     /* 2068440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068450 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2068453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068479 */     // GIR_Coverage, 15678,
     /* 2068479 */     GIR_EraseRootFromParent_Done,
     /* 2068480 */   // Label 27504: @2068480
     /* 2068480 */   GIM_Try, /*On fail goto*//*Label 27505*/ GIMT_Encode4(2068574), // Rule ID 15679 //
     /* 2068485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2068496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2068499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2068502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2068505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2068508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068531 */     // MIs[0] round
     /* 2068531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068534 */     // MIs[0] policy
     /* 2068534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068544 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2068547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068573 */     // GIR_Coverage, 15679,
     /* 2068573 */     GIR_EraseRootFromParent_Done,
     /* 2068574 */   // Label 27505: @2068574
     /* 2068574 */   GIM_Try, /*On fail goto*//*Label 27506*/ GIMT_Encode4(2068668), // Rule ID 15682 //
     /* 2068579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2068590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2068593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2068596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2068599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068625 */     // MIs[0] round
     /* 2068625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068628 */     // MIs[0] policy
     /* 2068628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068638 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068667 */     // GIR_Coverage, 15682,
     /* 2068667 */     GIR_EraseRootFromParent_Done,
     /* 2068668 */   // Label 27506: @2068668
     /* 2068668 */   GIM_Try, /*On fail goto*//*Label 27507*/ GIMT_Encode4(2068762), // Rule ID 15683 //
     /* 2068673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2068684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2068687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2068690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2068693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2068703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2068715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068719 */     // MIs[0] round
     /* 2068719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068722 */     // MIs[0] policy
     /* 2068722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068732 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2068735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068761 */     // GIR_Coverage, 15683,
     /* 2068761 */     GIR_EraseRootFromParent_Done,
     /* 2068762 */   // Label 27507: @2068762
     /* 2068762 */   GIM_Try, /*On fail goto*//*Label 27508*/ GIMT_Encode4(2068856), // Rule ID 15686 //
     /* 2068767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2068778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2068781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2068784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2068787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068813 */     // MIs[0] round
     /* 2068813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068816 */     // MIs[0] policy
     /* 2068816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068855 */     // GIR_Coverage, 15686,
     /* 2068855 */     GIR_EraseRootFromParent_Done,
     /* 2068856 */   // Label 27508: @2068856
     /* 2068856 */   GIM_Try, /*On fail goto*//*Label 27509*/ GIMT_Encode4(2068950), // Rule ID 15687 //
     /* 2068861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2068872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2068875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2068878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2068881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2068884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2068891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2068903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068907 */     // MIs[0] round
     /* 2068907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068910 */     // MIs[0] policy
     /* 2068910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2068923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2068948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068949 */     // GIR_Coverage, 15687,
     /* 2068949 */     GIR_EraseRootFromParent_Done,
     /* 2068950 */   // Label 27509: @2068950
     /* 2068950 */   GIM_Try, /*On fail goto*//*Label 27510*/ GIMT_Encode4(2069044), // Rule ID 15690 //
     /* 2068955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2068963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2068966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2068969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2068972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2068975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2068978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2068985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2068997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069001 */     // MIs[0] round
     /* 2069001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069004 */     // MIs[0] policy
     /* 2069004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069014 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069043 */     // GIR_Coverage, 15690,
     /* 2069043 */     GIR_EraseRootFromParent_Done,
     /* 2069044 */   // Label 27510: @2069044
     /* 2069044 */   GIM_Try, /*On fail goto*//*Label 27511*/ GIMT_Encode4(2069138), // Rule ID 15691 //
     /* 2069049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2069060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2069063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2069066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2069069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069095 */     // MIs[0] round
     /* 2069095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069098 */     // MIs[0] policy
     /* 2069098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069108 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069137 */     // GIR_Coverage, 15691,
     /* 2069137 */     GIR_EraseRootFromParent_Done,
     /* 2069138 */   // Label 27511: @2069138
     /* 2069138 */   GIM_Try, /*On fail goto*//*Label 27512*/ GIMT_Encode4(2069232), // Rule ID 15694 //
     /* 2069143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069189 */     // MIs[0] round
     /* 2069189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069192 */     // MIs[0] policy
     /* 2069192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069231 */     // GIR_Coverage, 15694,
     /* 2069231 */     GIR_EraseRootFromParent_Done,
     /* 2069232 */   // Label 27512: @2069232
     /* 2069232 */   GIM_Try, /*On fail goto*//*Label 27513*/ GIMT_Encode4(2069326), // Rule ID 15695 //
     /* 2069237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2069248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2069251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2069254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2069257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2069260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069283 */     // MIs[0] round
     /* 2069283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069286 */     // MIs[0] policy
     /* 2069286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2069299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069325 */     // GIR_Coverage, 15695,
     /* 2069325 */     GIR_EraseRootFromParent_Done,
     /* 2069326 */   // Label 27513: @2069326
     /* 2069326 */   GIM_Try, /*On fail goto*//*Label 27514*/ GIMT_Encode4(2069420), // Rule ID 15698 //
     /* 2069331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069377 */     // MIs[0] round
     /* 2069377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069380 */     // MIs[0] policy
     /* 2069380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069419 */     // GIR_Coverage, 15698,
     /* 2069419 */     GIR_EraseRootFromParent_Done,
     /* 2069420 */   // Label 27514: @2069420
     /* 2069420 */   GIM_Try, /*On fail goto*//*Label 27515*/ GIMT_Encode4(2069514), // Rule ID 15699 //
     /* 2069425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2069436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2069439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2069442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2069445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069471 */     // MIs[0] round
     /* 2069471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069474 */     // MIs[0] policy
     /* 2069474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2069487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069513 */     // GIR_Coverage, 15699,
     /* 2069513 */     GIR_EraseRootFromParent_Done,
     /* 2069514 */   // Label 27515: @2069514
     /* 2069514 */   GIM_Try, /*On fail goto*//*Label 27516*/ GIMT_Encode4(2069608), // Rule ID 15702 //
     /* 2069519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2069530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2069533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2069536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2069539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069565 */     // MIs[0] round
     /* 2069565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069568 */     // MIs[0] policy
     /* 2069568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069578 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069607 */     // GIR_Coverage, 15702,
     /* 2069607 */     GIR_EraseRootFromParent_Done,
     /* 2069608 */   // Label 27516: @2069608
     /* 2069608 */   GIM_Try, /*On fail goto*//*Label 27517*/ GIMT_Encode4(2069702), // Rule ID 15703 //
     /* 2069613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2069624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2069627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2069630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2069633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069659 */     // MIs[0] round
     /* 2069659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069662 */     // MIs[0] policy
     /* 2069662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069672 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2069675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2069695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069701 */     // GIR_Coverage, 15703,
     /* 2069701 */     GIR_EraseRootFromParent_Done,
     /* 2069702 */   // Label 27517: @2069702
     /* 2069702 */   GIM_Try, /*On fail goto*//*Label 27518*/ GIMT_Encode4(2069796), // Rule ID 15706 //
     /* 2069707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2069718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2069721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2069724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2069730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069753 */     // MIs[0] round
     /* 2069753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069756 */     // MIs[0] policy
     /* 2069756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069766 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2069769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069795 */     // GIR_Coverage, 15706,
     /* 2069795 */     GIR_EraseRootFromParent_Done,
     /* 2069796 */   // Label 27518: @2069796
     /* 2069796 */   GIM_Try, /*On fail goto*//*Label 27519*/ GIMT_Encode4(2069890), // Rule ID 15707 //
     /* 2069801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2069812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2069815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2069818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2069824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069847 */     // MIs[0] round
     /* 2069847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069850 */     // MIs[0] policy
     /* 2069850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069860 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2069863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069889 */     // GIR_Coverage, 15707,
     /* 2069889 */     GIR_EraseRootFromParent_Done,
     /* 2069890 */   // Label 27519: @2069890
     /* 2069890 */   GIM_Try, /*On fail goto*//*Label 27520*/ GIMT_Encode4(2069984), // Rule ID 15710 //
     /* 2069895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2069906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2069909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2069912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2069918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069941 */     // MIs[0] round
     /* 2069941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069944 */     // MIs[0] policy
     /* 2069944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069954 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2069957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2069982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069983 */     // GIR_Coverage, 15710,
     /* 2069983 */     GIR_EraseRootFromParent_Done,
     /* 2069984 */   // Label 27520: @2069984
     /* 2069984 */   GIM_Try, /*On fail goto*//*Label 27521*/ GIMT_Encode4(2070078), // Rule ID 15711 //
     /* 2069989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2069997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2070000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2070003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2070006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070035 */     // MIs[0] round
     /* 2070035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070038 */     // MIs[0] policy
     /* 2070038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070048 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070077 */     // GIR_Coverage, 15711,
     /* 2070077 */     GIR_EraseRootFromParent_Done,
     /* 2070078 */   // Label 27521: @2070078
     /* 2070078 */   GIM_Try, /*On fail goto*//*Label 27522*/ GIMT_Encode4(2070172), // Rule ID 15714 //
     /* 2070083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070129 */     // MIs[0] round
     /* 2070129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070132 */     // MIs[0] policy
     /* 2070132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070142 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070171 */     // GIR_Coverage, 15714,
     /* 2070171 */     GIR_EraseRootFromParent_Done,
     /* 2070172 */   // Label 27522: @2070172
     /* 2070172 */   GIM_Try, /*On fail goto*//*Label 27523*/ GIMT_Encode4(2070266), // Rule ID 15715 //
     /* 2070177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2070188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2070191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2070194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070223 */     // MIs[0] round
     /* 2070223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070226 */     // MIs[0] policy
     /* 2070226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070236 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070265 */     // GIR_Coverage, 15715,
     /* 2070265 */     GIR_EraseRootFromParent_Done,
     /* 2070266 */   // Label 27523: @2070266
     /* 2070266 */   GIM_Try, /*On fail goto*//*Label 27524*/ GIMT_Encode4(2070360), // Rule ID 15718 //
     /* 2070271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070317 */     // MIs[0] round
     /* 2070317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070320 */     // MIs[0] policy
     /* 2070320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070330 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070359 */     // GIR_Coverage, 15718,
     /* 2070359 */     GIR_EraseRootFromParent_Done,
     /* 2070360 */   // Label 27524: @2070360
     /* 2070360 */   GIM_Try, /*On fail goto*//*Label 27525*/ GIMT_Encode4(2070454), // Rule ID 15719 //
     /* 2070365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2070376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2070379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2070382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070411 */     // MIs[0] round
     /* 2070411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070414 */     // MIs[0] policy
     /* 2070414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2070427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070453 */     // GIR_Coverage, 15719,
     /* 2070453 */     GIR_EraseRootFromParent_Done,
     /* 2070454 */   // Label 27525: @2070454
     /* 2070454 */   GIM_Try, /*On fail goto*//*Label 27526*/ GIMT_Encode4(2070548), // Rule ID 15722 //
     /* 2070459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2070470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2070473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2070476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070505 */     // MIs[0] round
     /* 2070505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070508 */     // MIs[0] policy
     /* 2070508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070547 */     // GIR_Coverage, 15722,
     /* 2070547 */     GIR_EraseRootFromParent_Done,
     /* 2070548 */   // Label 27526: @2070548
     /* 2070548 */   GIM_Try, /*On fail goto*//*Label 27527*/ GIMT_Encode4(2070642), // Rule ID 15723 //
     /* 2070553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2070564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2070567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2070570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070599 */     // MIs[0] round
     /* 2070599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070602 */     // MIs[0] policy
     /* 2070602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070612 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070641 */     // GIR_Coverage, 15723,
     /* 2070641 */     GIR_EraseRootFromParent_Done,
     /* 2070642 */   // Label 27527: @2070642
     /* 2070642 */   GIM_Try, /*On fail goto*//*Label 27528*/ GIMT_Encode4(2070736), // Rule ID 15726 //
     /* 2070647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2070658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2070661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2070664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070693 */     // MIs[0] round
     /* 2070693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070696 */     // MIs[0] policy
     /* 2070696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070706 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070735 */     // GIR_Coverage, 15726,
     /* 2070735 */     GIR_EraseRootFromParent_Done,
     /* 2070736 */   // Label 27528: @2070736
     /* 2070736 */   GIM_Try, /*On fail goto*//*Label 27529*/ GIMT_Encode4(2070830), // Rule ID 15727 //
     /* 2070741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2070752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2070755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2070758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2070764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070787 */     // MIs[0] round
     /* 2070787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070790 */     // MIs[0] policy
     /* 2070790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070800 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2070803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070829 */     // GIR_Coverage, 15727,
     /* 2070829 */     GIR_EraseRootFromParent_Done,
     /* 2070830 */   // Label 27529: @2070830
     /* 2070830 */   GIM_Try, /*On fail goto*//*Label 27530*/ GIMT_Encode4(2070924), // Rule ID 15730 //
     /* 2070835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2070846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2070849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2070852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070881 */     // MIs[0] round
     /* 2070881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070884 */     // MIs[0] policy
     /* 2070884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070894 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2070897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2070917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2070922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070923 */     // GIR_Coverage, 15730,
     /* 2070923 */     GIR_EraseRootFromParent_Done,
     /* 2070924 */   // Label 27530: @2070924
     /* 2070924 */   GIM_Try, /*On fail goto*//*Label 27531*/ GIMT_Encode4(2071018), // Rule ID 15731 //
     /* 2070929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2070937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2070940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2070943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2070946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2070959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2070967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070975 */     // MIs[0] round
     /* 2070975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070978 */     // MIs[0] policy
     /* 2070978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070988 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11562:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2070991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071017 */     // GIR_Coverage, 15731,
     /* 2071017 */     GIR_EraseRootFromParent_Done,
     /* 2071018 */   // Label 27531: @2071018
     /* 2071018 */   GIM_Try, /*On fail goto*//*Label 27532*/ GIMT_Encode4(2071112), // Rule ID 15734 //
     /* 2071023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071069 */     // MIs[0] round
     /* 2071069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071072 */     // MIs[0] policy
     /* 2071072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071082 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071111 */     // GIR_Coverage, 15734,
     /* 2071111 */     GIR_EraseRootFromParent_Done,
     /* 2071112 */   // Label 27532: @2071112
     /* 2071112 */   GIM_Try, /*On fail goto*//*Label 27533*/ GIMT_Encode4(2071206), // Rule ID 15735 //
     /* 2071117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2071128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2071131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2071134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071163 */     // MIs[0] round
     /* 2071163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071166 */     // MIs[0] policy
     /* 2071166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11562:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2071199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071205 */     // GIR_Coverage, 15735,
     /* 2071205 */     GIR_EraseRootFromParent_Done,
     /* 2071206 */   // Label 27533: @2071206
     /* 2071206 */   GIM_Try, /*On fail goto*//*Label 27534*/ GIMT_Encode4(2071300), // Rule ID 15738 //
     /* 2071211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071257 */     // MIs[0] round
     /* 2071257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071260 */     // MIs[0] policy
     /* 2071260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071270 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071299 */     // GIR_Coverage, 15738,
     /* 2071299 */     GIR_EraseRootFromParent_Done,
     /* 2071300 */   // Label 27534: @2071300
     /* 2071300 */   GIM_Try, /*On fail goto*//*Label 27535*/ GIMT_Encode4(2071394), // Rule ID 15739 //
     /* 2071305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2071316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2071319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2071322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071351 */     // MIs[0] round
     /* 2071351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071354 */     // MIs[0] policy
     /* 2071354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11562:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2071367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2071387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071393 */     // GIR_Coverage, 15739,
     /* 2071393 */     GIR_EraseRootFromParent_Done,
     /* 2071394 */   // Label 27535: @2071394
     /* 2071394 */   GIM_Try, /*On fail goto*//*Label 27536*/ GIMT_Encode4(2071488), // Rule ID 15742 //
     /* 2071399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071445 */     // MIs[0] round
     /* 2071445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071448 */     // MIs[0] policy
     /* 2071448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071458 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2071461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071487 */     // GIR_Coverage, 15742,
     /* 2071487 */     GIR_EraseRootFromParent_Done,
     /* 2071488 */   // Label 27536: @2071488
     /* 2071488 */   GIM_Try, /*On fail goto*//*Label 27537*/ GIMT_Encode4(2071582), // Rule ID 15743 //
     /* 2071493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2071504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2071507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2071510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2071516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071539 */     // MIs[0] round
     /* 2071539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071542 */     // MIs[0] policy
     /* 2071542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2071555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071581 */     // GIR_Coverage, 15743,
     /* 2071581 */     GIR_EraseRootFromParent_Done,
     /* 2071582 */   // Label 27537: @2071582
     /* 2071582 */   GIM_Try, /*On fail goto*//*Label 27538*/ GIMT_Encode4(2071676), // Rule ID 15746 //
     /* 2071587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2071598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2071601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2071604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2071610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071633 */     // MIs[0] round
     /* 2071633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071636 */     // MIs[0] policy
     /* 2071636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2071649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071675 */     // GIR_Coverage, 15746,
     /* 2071675 */     GIR_EraseRootFromParent_Done,
     /* 2071676 */   // Label 27538: @2071676
     /* 2071676 */   GIM_Try, /*On fail goto*//*Label 27539*/ GIMT_Encode4(2071770), // Rule ID 15747 //
     /* 2071681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2071692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2071695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2071698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2071704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071727 */     // MIs[0] round
     /* 2071727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071730 */     // MIs[0] policy
     /* 2071730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071740 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2071743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071769 */     // GIR_Coverage, 15747,
     /* 2071769 */     GIR_EraseRootFromParent_Done,
     /* 2071770 */   // Label 27539: @2071770
     /* 2071770 */   GIM_Try, /*On fail goto*//*Label 27540*/ GIMT_Encode4(2071864), // Rule ID 15750 //
     /* 2071775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2071786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2071789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2071792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2071798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071821 */     // MIs[0] round
     /* 2071821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071824 */     // MIs[0] policy
     /* 2071824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071834 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2071837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071863 */     // GIR_Coverage, 15750,
     /* 2071863 */     GIR_EraseRootFromParent_Done,
     /* 2071864 */   // Label 27540: @2071864
     /* 2071864 */   GIM_Try, /*On fail goto*//*Label 27541*/ GIMT_Encode4(2071958), // Rule ID 15751 //
     /* 2071869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2071880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2071883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2071886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2071892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071915 */     // MIs[0] round
     /* 2071915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071918 */     // MIs[0] policy
     /* 2071918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071928 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2071931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071953 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2071956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071957 */     // GIR_Coverage, 15751,
     /* 2071957 */     GIR_EraseRootFromParent_Done,
     /* 2071958 */   // Label 27541: @2071958
     /* 2071958 */   GIM_Try, /*On fail goto*//*Label 27542*/ GIMT_Encode4(2072052), // Rule ID 15754 //
     /* 2071963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2071971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2071974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2071977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2071980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2071993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2071997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072009 */     // MIs[0] round
     /* 2072009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072012 */     // MIs[0] policy
     /* 2072012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072022 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072047 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072051 */     // GIR_Coverage, 15754,
     /* 2072051 */     GIR_EraseRootFromParent_Done,
     /* 2072052 */   // Label 27542: @2072052
     /* 2072052 */   GIM_Try, /*On fail goto*//*Label 27543*/ GIMT_Encode4(2072146), // Rule ID 15755 //
     /* 2072057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2072068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2072071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2072074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072103 */     // MIs[0] round
     /* 2072103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072106 */     // MIs[0] policy
     /* 2072106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072145 */     // GIR_Coverage, 15755,
     /* 2072145 */     GIR_EraseRootFromParent_Done,
     /* 2072146 */   // Label 27543: @2072146
     /* 2072146 */   GIM_Try, /*On fail goto*//*Label 27544*/ GIMT_Encode4(2072240), // Rule ID 15758 //
     /* 2072151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072197 */     // MIs[0] round
     /* 2072197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072200 */     // MIs[0] policy
     /* 2072200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072210 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072239 */     // GIR_Coverage, 15758,
     /* 2072239 */     GIR_EraseRootFromParent_Done,
     /* 2072240 */   // Label 27544: @2072240
     /* 2072240 */   GIM_Try, /*On fail goto*//*Label 27545*/ GIMT_Encode4(2072334), // Rule ID 15759 //
     /* 2072245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2072256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2072259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2072262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072291 */     // MIs[0] round
     /* 2072291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072294 */     // MIs[0] policy
     /* 2072294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072333 */     // GIR_Coverage, 15759,
     /* 2072333 */     GIR_EraseRootFromParent_Done,
     /* 2072334 */   // Label 27545: @2072334
     /* 2072334 */   GIM_Try, /*On fail goto*//*Label 27546*/ GIMT_Encode4(2072428), // Rule ID 15762 //
     /* 2072339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072385 */     // MIs[0] round
     /* 2072385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072388 */     // MIs[0] policy
     /* 2072388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072398 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072427 */     // GIR_Coverage, 15762,
     /* 2072427 */     GIR_EraseRootFromParent_Done,
     /* 2072428 */   // Label 27546: @2072428
     /* 2072428 */   GIM_Try, /*On fail goto*//*Label 27547*/ GIMT_Encode4(2072522), // Rule ID 15763 //
     /* 2072433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2072444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2072447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2072450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2072456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072479 */     // MIs[0] round
     /* 2072479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072482 */     // MIs[0] policy
     /* 2072482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072492 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072521 */     // GIR_Coverage, 15763,
     /* 2072521 */     GIR_EraseRootFromParent_Done,
     /* 2072522 */   // Label 27547: @2072522
     /* 2072522 */   GIM_Try, /*On fail goto*//*Label 27548*/ GIMT_Encode4(2072616), // Rule ID 15766 //
     /* 2072527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2072538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2072541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2072544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072573 */     // MIs[0] round
     /* 2072573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072576 */     // MIs[0] policy
     /* 2072576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072586 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072615 */     // GIR_Coverage, 15766,
     /* 2072615 */     GIR_EraseRootFromParent_Done,
     /* 2072616 */   // Label 27548: @2072616
     /* 2072616 */   GIM_Try, /*On fail goto*//*Label 27549*/ GIMT_Encode4(2072710), // Rule ID 15767 //
     /* 2072621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2072632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2072635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2072638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2072651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2072659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072667 */     // MIs[0] round
     /* 2072667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072670 */     // MIs[0] policy
     /* 2072670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2072683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072709 */     // GIR_Coverage, 15767,
     /* 2072709 */     GIR_EraseRootFromParent_Done,
     /* 2072710 */   // Label 27549: @2072710
     /* 2072710 */   GIM_Try, /*On fail goto*//*Label 27550*/ GIMT_Encode4(2072804), // Rule ID 15770 //
     /* 2072715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2072726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2072729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2072732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072761 */     // MIs[0] round
     /* 2072761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072764 */     // MIs[0] policy
     /* 2072764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072803 */     // GIR_Coverage, 15770,
     /* 2072803 */     GIR_EraseRootFromParent_Done,
     /* 2072804 */   // Label 27550: @2072804
     /* 2072804 */   GIM_Try, /*On fail goto*//*Label 27551*/ GIMT_Encode4(2072898), // Rule ID 15771 //
     /* 2072809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2072820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2072823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2072826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2072829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2072839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2072847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072855 */     // MIs[0] round
     /* 2072855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072858 */     // MIs[0] policy
     /* 2072858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2072871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072897 */     // GIR_Coverage, 15771,
     /* 2072897 */     GIR_EraseRootFromParent_Done,
     /* 2072898 */   // Label 27551: @2072898
     /* 2072898 */   GIM_Try, /*On fail goto*//*Label 27552*/ GIMT_Encode4(2072992), // Rule ID 15774 //
     /* 2072903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2072911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2072914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2072917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2072920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2072923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2072926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2072933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2072941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2072945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072949 */     // MIs[0] round
     /* 2072949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072952 */     // MIs[0] policy
     /* 2072952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2072965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2072990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072991 */     // GIR_Coverage, 15774,
     /* 2072991 */     GIR_EraseRootFromParent_Done,
     /* 2072992 */   // Label 27552: @2072992
     /* 2072992 */   GIM_Try, /*On fail goto*//*Label 27553*/ GIMT_Encode4(2073086), // Rule ID 15775 //
     /* 2072997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2073008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2073011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2073014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073043 */     // MIs[0] round
     /* 2073043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073046 */     // MIs[0] policy
     /* 2073046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073056 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2073059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073085 */     // GIR_Coverage, 15775,
     /* 2073085 */     GIR_EraseRootFromParent_Done,
     /* 2073086 */   // Label 27553: @2073086
     /* 2073086 */   GIM_Try, /*On fail goto*//*Label 27554*/ GIMT_Encode4(2073180), // Rule ID 15778 //
     /* 2073091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073137 */     // MIs[0] round
     /* 2073137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073140 */     // MIs[0] policy
     /* 2073140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2073153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073179 */     // GIR_Coverage, 15778,
     /* 2073179 */     GIR_EraseRootFromParent_Done,
     /* 2073180 */   // Label 27554: @2073180
     /* 2073180 */   GIM_Try, /*On fail goto*//*Label 27555*/ GIMT_Encode4(2073274), // Rule ID 15779 //
     /* 2073185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073231 */     // MIs[0] round
     /* 2073231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073234 */     // MIs[0] policy
     /* 2073234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2073247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073273 */     // GIR_Coverage, 15779,
     /* 2073273 */     GIR_EraseRootFromParent_Done,
     /* 2073274 */   // Label 27555: @2073274
     /* 2073274 */   GIM_Try, /*On fail goto*//*Label 27556*/ GIMT_Encode4(2073368), // Rule ID 15782 //
     /* 2073279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2073290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2073293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2073296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2073299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073325 */     // MIs[0] round
     /* 2073325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073328 */     // MIs[0] policy
     /* 2073328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073363 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073367 */     // GIR_Coverage, 15782,
     /* 2073367 */     GIR_EraseRootFromParent_Done,
     /* 2073368 */   // Label 27556: @2073368
     /* 2073368 */   GIM_Try, /*On fail goto*//*Label 27557*/ GIMT_Encode4(2073462), // Rule ID 15783 //
     /* 2073373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2073384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2073387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2073390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2073393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2073396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073419 */     // MIs[0] round
     /* 2073419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073422 */     // MIs[0] policy
     /* 2073422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2073435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073461 */     // GIR_Coverage, 15783,
     /* 2073461 */     GIR_EraseRootFromParent_Done,
     /* 2073462 */   // Label 27557: @2073462
     /* 2073462 */   GIM_Try, /*On fail goto*//*Label 27558*/ GIMT_Encode4(2073556), // Rule ID 15786 //
     /* 2073467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2073478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2073481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2073484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2073487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073513 */     // MIs[0] round
     /* 2073513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073516 */     // MIs[0] policy
     /* 2073516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073526 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2073529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073555 */     // GIR_Coverage, 15786,
     /* 2073555 */     GIR_EraseRootFromParent_Done,
     /* 2073556 */   // Label 27558: @2073556
     /* 2073556 */   GIM_Try, /*On fail goto*//*Label 27559*/ GIMT_Encode4(2073650), // Rule ID 15787 //
     /* 2073561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2073572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2073575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2073578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2073581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2073584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073607 */     // MIs[0] round
     /* 2073607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073610 */     // MIs[0] policy
     /* 2073610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073620 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2073623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073649 */     // GIR_Coverage, 15787,
     /* 2073649 */     GIR_EraseRootFromParent_Done,
     /* 2073650 */   // Label 27559: @2073650
     /* 2073650 */   GIM_Try, /*On fail goto*//*Label 27560*/ GIMT_Encode4(2073744), // Rule ID 15790 //
     /* 2073655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2073666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2073669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2073672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2073675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073701 */     // MIs[0] round
     /* 2073701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073704 */     // MIs[0] policy
     /* 2073704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073714 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2073717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073739 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073743 */     // GIR_Coverage, 15790,
     /* 2073743 */     GIR_EraseRootFromParent_Done,
     /* 2073744 */   // Label 27560: @2073744
     /* 2073744 */   GIM_Try, /*On fail goto*//*Label 27561*/ GIMT_Encode4(2073838), // Rule ID 15791 //
     /* 2073749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2073760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2073763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2073766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2073769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073795 */     // MIs[0] round
     /* 2073795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073798 */     // MIs[0] policy
     /* 2073798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073808 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2073811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073837 */     // GIR_Coverage, 15791,
     /* 2073837 */     GIR_EraseRootFromParent_Done,
     /* 2073838 */   // Label 27561: @2073838
     /* 2073838 */   GIM_Try, /*On fail goto*//*Label 27562*/ GIMT_Encode4(2073932), // Rule ID 15794 //
     /* 2073843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2073846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2073863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073889 */     // MIs[0] round
     /* 2073889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073892 */     // MIs[0] policy
     /* 2073892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2073905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2073930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073931 */     // GIR_Coverage, 15794,
     /* 2073931 */     GIR_EraseRootFromParent_Done,
     /* 2073932 */   // Label 27562: @2073932
     /* 2073932 */   GIM_Try, /*On fail goto*//*Label 27563*/ GIMT_Encode4(2074026), // Rule ID 15795 //
     /* 2073937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2073940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2073945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2073957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2073979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073983 */     // MIs[0] round
     /* 2073983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073986 */     // MIs[0] policy
     /* 2073986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073996 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11562:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2073999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074021 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074025 */     // GIR_Coverage, 15795,
     /* 2074025 */     GIR_EraseRootFromParent_Done,
     /* 2074026 */   // Label 27563: @2074026
     /* 2074026 */   GIM_Try, /*On fail goto*//*Label 27564*/ GIMT_Encode4(2074120), // Rule ID 15798 //
     /* 2074031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074077 */     // MIs[0] round
     /* 2074077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074080 */     // MIs[0] policy
     /* 2074080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2074093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074119 */     // GIR_Coverage, 15798,
     /* 2074119 */     GIR_EraseRootFromParent_Done,
     /* 2074120 */   // Label 27564: @2074120
     /* 2074120 */   GIM_Try, /*On fail goto*//*Label 27565*/ GIMT_Encode4(2074214), // Rule ID 15799 //
     /* 2074125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074171 */     // MIs[0] round
     /* 2074171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074174 */     // MIs[0] policy
     /* 2074174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074184 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11562:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2074187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074213 */     // GIR_Coverage, 15799,
     /* 2074213 */     GIR_EraseRootFromParent_Done,
     /* 2074214 */   // Label 27565: @2074214
     /* 2074214 */   GIM_Try, /*On fail goto*//*Label 27566*/ GIMT_Encode4(2074308), // Rule ID 15802 //
     /* 2074219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074265 */     // MIs[0] round
     /* 2074265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074268 */     // MIs[0] policy
     /* 2074268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074278 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2074281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074307 */     // GIR_Coverage, 15802,
     /* 2074307 */     GIR_EraseRootFromParent_Done,
     /* 2074308 */   // Label 27566: @2074308
     /* 2074308 */   GIM_Try, /*On fail goto*//*Label 27567*/ GIMT_Encode4(2074402), // Rule ID 15803 //
     /* 2074313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2074324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2074327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2074330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074359 */     // MIs[0] round
     /* 2074359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074362 */     // MIs[0] policy
     /* 2074362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074372 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11562:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2074375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074401 */     // GIR_Coverage, 15803,
     /* 2074401 */     GIR_EraseRootFromParent_Done,
     /* 2074402 */   // Label 27567: @2074402
     /* 2074402 */   GIM_Try, /*On fail goto*//*Label 27568*/ GIMT_Encode4(2074496), // Rule ID 15806 //
     /* 2074407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2074410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2074427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074453 */     // MIs[0] round
     /* 2074453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074456 */     // MIs[0] policy
     /* 2074456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074466 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2074469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074495 */     // GIR_Coverage, 15806,
     /* 2074495 */     GIR_EraseRootFromParent_Done,
     /* 2074496 */   // Label 27568: @2074496
     /* 2074496 */   GIM_Try, /*On fail goto*//*Label 27569*/ GIMT_Encode4(2074590), // Rule ID 15807 //
     /* 2074501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2074504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2074509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2074512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2074515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2074518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2074521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2074543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074547 */     // MIs[0] round
     /* 2074547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074550 */     // MIs[0] policy
     /* 2074550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11562:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2074563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2074588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074589 */     // GIR_Coverage, 15807,
     /* 2074589 */     GIR_EraseRootFromParent_Done,
     /* 2074590 */   // Label 27569: @2074590
     /* 2074590 */   GIM_Try, /*On fail goto*//*Label 27570*/ GIMT_Encode4(2074681), // Rule ID 15810 //
     /* 2074595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2074606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2074609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2074612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2074615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074641 */     // MIs[0] round
     /* 2074641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074644 */     // MIs[0] policy
     /* 2074644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074654 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2074657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074680 */     // GIR_Coverage, 15810,
     /* 2074680 */     GIR_EraseRootFromParent_Done,
     /* 2074681 */   // Label 27570: @2074681
     /* 2074681 */   GIM_Try, /*On fail goto*//*Label 27571*/ GIMT_Encode4(2074772), // Rule ID 15811 //
     /* 2074686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2074697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2074700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2074703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2074706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2074709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074732 */     // MIs[0] round
     /* 2074732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074735 */     // MIs[0] policy
     /* 2074735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074745 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2074748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074771 */     // GIR_Coverage, 15811,
     /* 2074771 */     GIR_EraseRootFromParent_Done,
     /* 2074772 */   // Label 27571: @2074772
     /* 2074772 */   GIM_Try, /*On fail goto*//*Label 27572*/ GIMT_Encode4(2074863), // Rule ID 15814 //
     /* 2074777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2074788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2074791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2074794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2074797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074823 */     // MIs[0] round
     /* 2074823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074826 */     // MIs[0] policy
     /* 2074826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074836 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2074839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074862 */     // GIR_Coverage, 15814,
     /* 2074862 */     GIR_EraseRootFromParent_Done,
     /* 2074863 */   // Label 27572: @2074863
     /* 2074863 */   GIM_Try, /*On fail goto*//*Label 27573*/ GIMT_Encode4(2074954), // Rule ID 15815 //
     /* 2074868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2074879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2074882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2074885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2074888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074914 */     // MIs[0] round
     /* 2074914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074917 */     // MIs[0] policy
     /* 2074917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074927 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2074930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2074950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074953 */     // GIR_Coverage, 15815,
     /* 2074953 */     GIR_EraseRootFromParent_Done,
     /* 2074954 */   // Label 27573: @2074954
     /* 2074954 */   GIM_Try, /*On fail goto*//*Label 27574*/ GIMT_Encode4(2075045), // Rule ID 15818 //
     /* 2074959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2074967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2074970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2074973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2074976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2074979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2074989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2074997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075005 */     // MIs[0] round
     /* 2075005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075008 */     // MIs[0] policy
     /* 2075008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075018 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075044 */     // GIR_Coverage, 15818,
     /* 2075044 */     GIR_EraseRootFromParent_Done,
     /* 2075045 */   // Label 27574: @2075045
     /* 2075045 */   GIM_Try, /*On fail goto*//*Label 27575*/ GIMT_Encode4(2075136), // Rule ID 15819 //
     /* 2075050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2075061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2075064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2075067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2075070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075096 */     // MIs[0] round
     /* 2075096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075099 */     // MIs[0] policy
     /* 2075099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075109 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075135 */     // GIR_Coverage, 15819,
     /* 2075135 */     GIR_EraseRootFromParent_Done,
     /* 2075136 */   // Label 27575: @2075136
     /* 2075136 */   GIM_Try, /*On fail goto*//*Label 27576*/ GIMT_Encode4(2075227), // Rule ID 15822 //
     /* 2075141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2075158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075187 */     // MIs[0] round
     /* 2075187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075190 */     // MIs[0] policy
     /* 2075190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075200 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075226 */     // GIR_Coverage, 15822,
     /* 2075226 */     GIR_EraseRootFromParent_Done,
     /* 2075227 */   // Label 27576: @2075227
     /* 2075227 */   GIM_Try, /*On fail goto*//*Label 27577*/ GIMT_Encode4(2075318), // Rule ID 15823 //
     /* 2075232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2075249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2075252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075278 */     // MIs[0] round
     /* 2075278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075281 */     // MIs[0] policy
     /* 2075281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075291 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2075294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075317 */     // GIR_Coverage, 15823,
     /* 2075317 */     GIR_EraseRootFromParent_Done,
     /* 2075318 */   // Label 27577: @2075318
     /* 2075318 */   GIM_Try, /*On fail goto*//*Label 27578*/ GIMT_Encode4(2075409), // Rule ID 15826 //
     /* 2075323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2075340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075369 */     // MIs[0] round
     /* 2075369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075372 */     // MIs[0] policy
     /* 2075372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075408 */     // GIR_Coverage, 15826,
     /* 2075408 */     GIR_EraseRootFromParent_Done,
     /* 2075409 */   // Label 27578: @2075409
     /* 2075409 */   GIM_Try, /*On fail goto*//*Label 27579*/ GIMT_Encode4(2075500), // Rule ID 15827 //
     /* 2075414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2075425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2075428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2075431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2075434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075460 */     // MIs[0] round
     /* 2075460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075463 */     // MIs[0] policy
     /* 2075463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075473 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075499 */     // GIR_Coverage, 15827,
     /* 2075499 */     GIR_EraseRootFromParent_Done,
     /* 2075500 */   // Label 27579: @2075500
     /* 2075500 */   GIM_Try, /*On fail goto*//*Label 27580*/ GIMT_Encode4(2075591), // Rule ID 15830 //
     /* 2075505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2075516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2075519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2075522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2075525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075551 */     // MIs[0] round
     /* 2075551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075554 */     // MIs[0] policy
     /* 2075554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075564 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2075587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075590 */     // GIR_Coverage, 15830,
     /* 2075590 */     GIR_EraseRootFromParent_Done,
     /* 2075591 */   // Label 27580: @2075591
     /* 2075591 */   GIM_Try, /*On fail goto*//*Label 27581*/ GIMT_Encode4(2075682), // Rule ID 15831 //
     /* 2075596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2075607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2075610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2075613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2075616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075642 */     // MIs[0] round
     /* 2075642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075645 */     // MIs[0] policy
     /* 2075645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075655 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2075658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2075678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075681 */     // GIR_Coverage, 15831,
     /* 2075681 */     GIR_EraseRootFromParent_Done,
     /* 2075682 */   // Label 27581: @2075682
     /* 2075682 */   GIM_Try, /*On fail goto*//*Label 27582*/ GIMT_Encode4(2075773), // Rule ID 15834 //
     /* 2075687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2075698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2075701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2075704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2075707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075733 */     // MIs[0] round
     /* 2075733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075736 */     // MIs[0] policy
     /* 2075736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075746 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2075749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075772 */     // GIR_Coverage, 15834,
     /* 2075772 */     GIR_EraseRootFromParent_Done,
     /* 2075773 */   // Label 27582: @2075773
     /* 2075773 */   GIM_Try, /*On fail goto*//*Label 27583*/ GIMT_Encode4(2075864), // Rule ID 15835 //
     /* 2075778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2075789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2075792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2075795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2075798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075824 */     // MIs[0] round
     /* 2075824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075827 */     // MIs[0] policy
     /* 2075827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075837 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2075840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075863 */     // GIR_Coverage, 15835,
     /* 2075863 */     GIR_EraseRootFromParent_Done,
     /* 2075864 */   // Label 27583: @2075864
     /* 2075864 */   GIM_Try, /*On fail goto*//*Label 27584*/ GIMT_Encode4(2075955), // Rule ID 15838 //
     /* 2075869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2075880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2075883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2075886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2075889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075915 */     // MIs[0] round
     /* 2075915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075918 */     // MIs[0] policy
     /* 2075918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075928 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2075931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2075951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075954 */     // GIR_Coverage, 15838,
     /* 2075954 */     GIR_EraseRootFromParent_Done,
     /* 2075955 */   // Label 27584: @2075955
     /* 2075955 */   GIM_Try, /*On fail goto*//*Label 27585*/ GIMT_Encode4(2076046), // Rule ID 15839 //
     /* 2075960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2075968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2075971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2075974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2075977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2075980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076006 */     // MIs[0] round
     /* 2076006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076009 */     // MIs[0] policy
     /* 2076009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076019 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076045 */     // GIR_Coverage, 15839,
     /* 2076045 */     GIR_EraseRootFromParent_Done,
     /* 2076046 */   // Label 27585: @2076046
     /* 2076046 */   GIM_Try, /*On fail goto*//*Label 27586*/ GIMT_Encode4(2076137), // Rule ID 15842 //
     /* 2076051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076097 */     // MIs[0] round
     /* 2076097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076100 */     // MIs[0] policy
     /* 2076100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076136 */     // GIR_Coverage, 15842,
     /* 2076136 */     GIR_EraseRootFromParent_Done,
     /* 2076137 */   // Label 27586: @2076137
     /* 2076137 */   GIM_Try, /*On fail goto*//*Label 27587*/ GIMT_Encode4(2076228), // Rule ID 15843 //
     /* 2076142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2076162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076188 */     // MIs[0] round
     /* 2076188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076191 */     // MIs[0] policy
     /* 2076191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076201 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076227 */     // GIR_Coverage, 15843,
     /* 2076227 */     GIR_EraseRootFromParent_Done,
     /* 2076228 */   // Label 27587: @2076228
     /* 2076228 */   GIM_Try, /*On fail goto*//*Label 27588*/ GIMT_Encode4(2076319), // Rule ID 15846 //
     /* 2076233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2076236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2076250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076279 */     // MIs[0] round
     /* 2076279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076282 */     // MIs[0] policy
     /* 2076282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076318 */     // GIR_Coverage, 15846,
     /* 2076318 */     GIR_EraseRootFromParent_Done,
     /* 2076319 */   // Label 27588: @2076319
     /* 2076319 */   GIM_Try, /*On fail goto*//*Label 27589*/ GIMT_Encode4(2076410), // Rule ID 15847 //
     /* 2076324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2076327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2076335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2076338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2076341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2076344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076370 */     // MIs[0] round
     /* 2076370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076373 */     // MIs[0] policy
     /* 2076373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076383 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2076386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2076406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076409 */     // GIR_Coverage, 15847,
     /* 2076409 */     GIR_EraseRootFromParent_Done,
     /* 2076410 */   // Label 27589: @2076410
     /* 2076410 */   GIM_Try, /*On fail goto*//*Label 27590*/ GIMT_Encode4(2076501), // Rule ID 15850 //
     /* 2076415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2076426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2076429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2076432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2076435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076461 */     // MIs[0] round
     /* 2076461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076464 */     // MIs[0] policy
     /* 2076464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076474 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2076477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076500 */     // GIR_Coverage, 15850,
     /* 2076500 */     GIR_EraseRootFromParent_Done,
     /* 2076501 */   // Label 27590: @2076501
     /* 2076501 */   GIM_Try, /*On fail goto*//*Label 27591*/ GIMT_Encode4(2076592), // Rule ID 15851 //
     /* 2076506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2076517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2076520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2076523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2076526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2076529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076552 */     // MIs[0] round
     /* 2076552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076555 */     // MIs[0] policy
     /* 2076555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076565 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2076568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076591 */     // GIR_Coverage, 15851,
     /* 2076591 */     GIR_EraseRootFromParent_Done,
     /* 2076592 */   // Label 27591: @2076592
     /* 2076592 */   GIM_Try, /*On fail goto*//*Label 27592*/ GIMT_Encode4(2076683), // Rule ID 15854 //
     /* 2076597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2076608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2076611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2076614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2076617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2076620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076643 */     // MIs[0] round
     /* 2076643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076646 */     // MIs[0] policy
     /* 2076646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2076659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076682 */     // GIR_Coverage, 15854,
     /* 2076682 */     GIR_EraseRootFromParent_Done,
     /* 2076683 */   // Label 27592: @2076683
     /* 2076683 */   GIM_Try, /*On fail goto*//*Label 27593*/ GIMT_Encode4(2076774), // Rule ID 15855 //
     /* 2076688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2076699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2076702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2076705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2076708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2076711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2076718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2076730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076734 */     // MIs[0] round
     /* 2076734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076737 */     // MIs[0] policy
     /* 2076737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076747 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2076750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076773 */     // GIR_Coverage, 15855,
     /* 2076773 */     GIR_EraseRootFromParent_Done,
     /* 2076774 */   // Label 27593: @2076774
     /* 2076774 */   GIM_Try, /*On fail goto*//*Label 27594*/ GIMT_Encode4(2076865), // Rule ID 15858 //
     /* 2076779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2076790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2076793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2076796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2076799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2076802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2076809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076825 */     // MIs[0] round
     /* 2076825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076828 */     // MIs[0] policy
     /* 2076828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076838 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2076841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076864 */     // GIR_Coverage, 15858,
     /* 2076864 */     GIR_EraseRootFromParent_Done,
     /* 2076865 */   // Label 27594: @2076865
     /* 2076865 */   GIM_Try, /*On fail goto*//*Label 27595*/ GIMT_Encode4(2076956), // Rule ID 15859 //
     /* 2076870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2076881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2076884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2076887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2076890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2076893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2076900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2076912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076916 */     // MIs[0] round
     /* 2076916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076919 */     // MIs[0] policy
     /* 2076919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076929 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2076932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076955 */     // GIR_Coverage, 15859,
     /* 2076955 */     GIR_EraseRootFromParent_Done,
     /* 2076956 */   // Label 27595: @2076956
     /* 2076956 */   GIM_Try, /*On fail goto*//*Label 27596*/ GIMT_Encode4(2077047), // Rule ID 15862 //
     /* 2076961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2076969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2076972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2076975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2076978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2076981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2076991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2076999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077007 */     // MIs[0] round
     /* 2077007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077010 */     // MIs[0] policy
     /* 2077010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077046 */     // GIR_Coverage, 15862,
     /* 2077046 */     GIR_EraseRootFromParent_Done,
     /* 2077047 */   // Label 27596: @2077047
     /* 2077047 */   GIM_Try, /*On fail goto*//*Label 27597*/ GIMT_Encode4(2077138), // Rule ID 15863 //
     /* 2077052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2077063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2077066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2077069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2077072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077098 */     // MIs[0] round
     /* 2077098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077101 */     // MIs[0] policy
     /* 2077101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077111 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077137 */     // GIR_Coverage, 15863,
     /* 2077137 */     GIR_EraseRootFromParent_Done,
     /* 2077138 */   // Label 27597: @2077138
     /* 2077138 */   GIM_Try, /*On fail goto*//*Label 27598*/ GIMT_Encode4(2077229), // Rule ID 15866 //
     /* 2077143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2077154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2077157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2077160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2077163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077189 */     // MIs[0] round
     /* 2077189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077192 */     // MIs[0] policy
     /* 2077192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077202 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077228 */     // GIR_Coverage, 15866,
     /* 2077228 */     GIR_EraseRootFromParent_Done,
     /* 2077229 */   // Label 27598: @2077229
     /* 2077229 */   GIM_Try, /*On fail goto*//*Label 27599*/ GIMT_Encode4(2077320), // Rule ID 15867 //
     /* 2077234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2077245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2077248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2077251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2077254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077280 */     // MIs[0] round
     /* 2077280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077283 */     // MIs[0] policy
     /* 2077283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077293 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077319 */     // GIR_Coverage, 15867,
     /* 2077319 */     GIR_EraseRootFromParent_Done,
     /* 2077320 */   // Label 27599: @2077320
     /* 2077320 */   GIM_Try, /*On fail goto*//*Label 27600*/ GIMT_Encode4(2077411), // Rule ID 15870 //
     /* 2077325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2077342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077371 */     // MIs[0] round
     /* 2077371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077374 */     // MIs[0] policy
     /* 2077374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077384 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077410 */     // GIR_Coverage, 15870,
     /* 2077410 */     GIR_EraseRootFromParent_Done,
     /* 2077411 */   // Label 27600: @2077411
     /* 2077411 */   GIM_Try, /*On fail goto*//*Label 27601*/ GIMT_Encode4(2077502), // Rule ID 15871 //
     /* 2077416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2077427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2077430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2077433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2077436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077462 */     // MIs[0] round
     /* 2077462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077465 */     // MIs[0] policy
     /* 2077465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077475 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077501 */     // GIR_Coverage, 15871,
     /* 2077501 */     GIR_EraseRootFromParent_Done,
     /* 2077502 */   // Label 27601: @2077502
     /* 2077502 */   GIM_Try, /*On fail goto*//*Label 27602*/ GIMT_Encode4(2077593), // Rule ID 15874 //
     /* 2077507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2077518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2077521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2077524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2077527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077553 */     // MIs[0] round
     /* 2077553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077556 */     // MIs[0] policy
     /* 2077556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077592 */     // GIR_Coverage, 15874,
     /* 2077592 */     GIR_EraseRootFromParent_Done,
     /* 2077593 */   // Label 27602: @2077593
     /* 2077593 */   GIM_Try, /*On fail goto*//*Label 27603*/ GIMT_Encode4(2077684), // Rule ID 15875 //
     /* 2077598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2077609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2077612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2077615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2077618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2077621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077644 */     // MIs[0] round
     /* 2077644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077647 */     // MIs[0] policy
     /* 2077647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2077660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077683 */     // GIR_Coverage, 15875,
     /* 2077683 */     GIR_EraseRootFromParent_Done,
     /* 2077684 */   // Label 27603: @2077684
     /* 2077684 */   GIM_Try, /*On fail goto*//*Label 27604*/ GIMT_Encode4(2077775), // Rule ID 15878 //
     /* 2077689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2077700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2077703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2077706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2077709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077735 */     // MIs[0] round
     /* 2077735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077738 */     // MIs[0] policy
     /* 2077738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077774 */     // GIR_Coverage, 15878,
     /* 2077774 */     GIR_EraseRootFromParent_Done,
     /* 2077775 */   // Label 27604: @2077775
     /* 2077775 */   GIM_Try, /*On fail goto*//*Label 27605*/ GIMT_Encode4(2077866), // Rule ID 15879 //
     /* 2077780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2077791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2077794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2077797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2077800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077826 */     // MIs[0] round
     /* 2077826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077829 */     // MIs[0] policy
     /* 2077829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077839 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2077842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077865 */     // GIR_Coverage, 15879,
     /* 2077865 */     GIR_EraseRootFromParent_Done,
     /* 2077866 */   // Label 27605: @2077866
     /* 2077866 */   GIM_Try, /*On fail goto*//*Label 27606*/ GIMT_Encode4(2077957), // Rule ID 15882 //
     /* 2077871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2077882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2077885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2077888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2077891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077917 */     // MIs[0] round
     /* 2077917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077920 */     // MIs[0] policy
     /* 2077920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077930 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2077933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077956 */     // GIR_Coverage, 15882,
     /* 2077956 */     GIR_EraseRootFromParent_Done,
     /* 2077957 */   // Label 27606: @2077957
     /* 2077957 */   GIM_Try, /*On fail goto*//*Label 27607*/ GIMT_Encode4(2078048), // Rule ID 15883 //
     /* 2077962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2077970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2077973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2077976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2077979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2077982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078008 */     // MIs[0] round
     /* 2078008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078011 */     // MIs[0] policy
     /* 2078011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078021 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078047 */     // GIR_Coverage, 15883,
     /* 2078047 */     GIR_EraseRootFromParent_Done,
     /* 2078048 */   // Label 27607: @2078048
     /* 2078048 */   GIM_Try, /*On fail goto*//*Label 27608*/ GIMT_Encode4(2078139), // Rule ID 15886 //
     /* 2078053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2078073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078099 */     // MIs[0] round
     /* 2078099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078102 */     // MIs[0] policy
     /* 2078102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078138 */     // GIR_Coverage, 15886,
     /* 2078138 */     GIR_EraseRootFromParent_Done,
     /* 2078139 */   // Label 27608: @2078139
     /* 2078139 */   GIM_Try, /*On fail goto*//*Label 27609*/ GIMT_Encode4(2078230), // Rule ID 15887 //
     /* 2078144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2078164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078190 */     // MIs[0] round
     /* 2078190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078193 */     // MIs[0] policy
     /* 2078193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2078206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078229 */     // GIR_Coverage, 15887,
     /* 2078229 */     GIR_EraseRootFromParent_Done,
     /* 2078230 */   // Label 27609: @2078230
     /* 2078230 */   GIM_Try, /*On fail goto*//*Label 27610*/ GIMT_Encode4(2078321), // Rule ID 15890 //
     /* 2078235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2078255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078281 */     // MIs[0] round
     /* 2078281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078284 */     // MIs[0] policy
     /* 2078284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078320 */     // GIR_Coverage, 15890,
     /* 2078320 */     GIR_EraseRootFromParent_Done,
     /* 2078321 */   // Label 27610: @2078321
     /* 2078321 */   GIM_Try, /*On fail goto*//*Label 27611*/ GIMT_Encode4(2078412), // Rule ID 15891 //
     /* 2078326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2078337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2078340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2078343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2078346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078372 */     // MIs[0] round
     /* 2078372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078375 */     // MIs[0] policy
     /* 2078375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078385 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2078388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078411 */     // GIR_Coverage, 15891,
     /* 2078411 */     GIR_EraseRootFromParent_Done,
     /* 2078412 */   // Label 27611: @2078412
     /* 2078412 */   GIM_Try, /*On fail goto*//*Label 27612*/ GIMT_Encode4(2078503), // Rule ID 15894 //
     /* 2078417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2078437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078463 */     // MIs[0] round
     /* 2078463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078466 */     // MIs[0] policy
     /* 2078466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078502 */     // GIR_Coverage, 15894,
     /* 2078502 */     GIR_EraseRootFromParent_Done,
     /* 2078503 */   // Label 27612: @2078503
     /* 2078503 */   GIM_Try, /*On fail goto*//*Label 27613*/ GIMT_Encode4(2078594), // Rule ID 15895 //
     /* 2078508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2078519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2078522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2078525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2078528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078554 */     // MIs[0] round
     /* 2078554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078557 */     // MIs[0] policy
     /* 2078557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078567 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2078570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078593 */     // GIR_Coverage, 15895,
     /* 2078593 */     GIR_EraseRootFromParent_Done,
     /* 2078594 */   // Label 27613: @2078594
     /* 2078594 */   GIM_Try, /*On fail goto*//*Label 27614*/ GIMT_Encode4(2078685), // Rule ID 15898 //
     /* 2078599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2078610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2078613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2078616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078645 */     // MIs[0] round
     /* 2078645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078648 */     // MIs[0] policy
     /* 2078648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078658 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2078661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078684 */     // GIR_Coverage, 15898,
     /* 2078684 */     GIR_EraseRootFromParent_Done,
     /* 2078685 */   // Label 27614: @2078685
     /* 2078685 */   GIM_Try, /*On fail goto*//*Label 27615*/ GIMT_Encode4(2078776), // Rule ID 15899 //
     /* 2078690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2078701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2078704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2078707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2078713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078736 */     // MIs[0] round
     /* 2078736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078739 */     // MIs[0] policy
     /* 2078739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078749 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2078752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078775 */     // GIR_Coverage, 15899,
     /* 2078775 */     GIR_EraseRootFromParent_Done,
     /* 2078776 */   // Label 27615: @2078776
     /* 2078776 */   GIM_Try, /*On fail goto*//*Label 27616*/ GIMT_Encode4(2078867), // Rule ID 15902 //
     /* 2078781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2078792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2078795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2078798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078827 */     // MIs[0] round
     /* 2078827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078830 */     // MIs[0] policy
     /* 2078830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078840 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2078843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078866 */     // GIR_Coverage, 15902,
     /* 2078866 */     GIR_EraseRootFromParent_Done,
     /* 2078867 */   // Label 27616: @2078867
     /* 2078867 */   GIM_Try, /*On fail goto*//*Label 27617*/ GIMT_Encode4(2078958), // Rule ID 15903 //
     /* 2078872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2078883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2078886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2078889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078918 */     // MIs[0] round
     /* 2078918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078921 */     // MIs[0] policy
     /* 2078921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078931 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2078934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2078954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078957 */     // GIR_Coverage, 15903,
     /* 2078957 */     GIR_EraseRootFromParent_Done,
     /* 2078958 */   // Label 27617: @2078958
     /* 2078958 */   GIM_Try, /*On fail goto*//*Label 27618*/ GIMT_Encode4(2079049), // Rule ID 15906 //
     /* 2078963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2078971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2078974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2078977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2078980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2078993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2078997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079009 */     // MIs[0] round
     /* 2079009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079012 */     // MIs[0] policy
     /* 2079012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079022 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079048 */     // GIR_Coverage, 15906,
     /* 2079048 */     GIR_EraseRootFromParent_Done,
     /* 2079049 */   // Label 27618: @2079049
     /* 2079049 */   GIM_Try, /*On fail goto*//*Label 27619*/ GIMT_Encode4(2079140), // Rule ID 15907 //
     /* 2079054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2079065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2079068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2079071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079100 */     // MIs[0] round
     /* 2079100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079103 */     // MIs[0] policy
     /* 2079103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079113 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079139 */     // GIR_Coverage, 15907,
     /* 2079139 */     GIR_EraseRootFromParent_Done,
     /* 2079140 */   // Label 27619: @2079140
     /* 2079140 */   GIM_Try, /*On fail goto*//*Label 27620*/ GIMT_Encode4(2079231), // Rule ID 15910 //
     /* 2079145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2079156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2079159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079191 */     // MIs[0] round
     /* 2079191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079194 */     // MIs[0] policy
     /* 2079194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079204 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079230 */     // GIR_Coverage, 15910,
     /* 2079230 */     GIR_EraseRootFromParent_Done,
     /* 2079231 */   // Label 27620: @2079231
     /* 2079231 */   GIM_Try, /*On fail goto*//*Label 27621*/ GIMT_Encode4(2079322), // Rule ID 15911 //
     /* 2079236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2079247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2079250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079282 */     // MIs[0] round
     /* 2079282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079285 */     // MIs[0] policy
     /* 2079285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079295 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2079298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079321 */     // GIR_Coverage, 15911,
     /* 2079321 */     GIR_EraseRootFromParent_Done,
     /* 2079322 */   // Label 27621: @2079322
     /* 2079322 */   GIM_Try, /*On fail goto*//*Label 27622*/ GIMT_Encode4(2079413), // Rule ID 15914 //
     /* 2079327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079373 */     // MIs[0] round
     /* 2079373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079376 */     // MIs[0] policy
     /* 2079376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079412 */     // GIR_Coverage, 15914,
     /* 2079412 */     GIR_EraseRootFromParent_Done,
     /* 2079413 */   // Label 27622: @2079413
     /* 2079413 */   GIM_Try, /*On fail goto*//*Label 27623*/ GIMT_Encode4(2079504), // Rule ID 15915 //
     /* 2079418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2079429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2079432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079464 */     // MIs[0] round
     /* 2079464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079467 */     // MIs[0] policy
     /* 2079467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079477 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079503 */     // GIR_Coverage, 15915,
     /* 2079503 */     GIR_EraseRootFromParent_Done,
     /* 2079504 */   // Label 27623: @2079504
     /* 2079504 */   GIM_Try, /*On fail goto*//*Label 27624*/ GIMT_Encode4(2079595), // Rule ID 15918 //
     /* 2079509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2079520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2079523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2079526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079555 */     // MIs[0] round
     /* 2079555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079558 */     // MIs[0] policy
     /* 2079558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079594 */     // GIR_Coverage, 15918,
     /* 2079594 */     GIR_EraseRootFromParent_Done,
     /* 2079595 */   // Label 27624: @2079595
     /* 2079595 */   GIM_Try, /*On fail goto*//*Label 27625*/ GIMT_Encode4(2079686), // Rule ID 15919 //
     /* 2079600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2079611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2079614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2079617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079646 */     // MIs[0] round
     /* 2079646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079649 */     // MIs[0] policy
     /* 2079649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079659 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2079662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2079682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079685 */     // GIR_Coverage, 15919,
     /* 2079685 */     GIR_EraseRootFromParent_Done,
     /* 2079686 */   // Label 27625: @2079686
     /* 2079686 */   GIM_Try, /*On fail goto*//*Label 27626*/ GIMT_Encode4(2079777), // Rule ID 15922 //
     /* 2079691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2079702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2079705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2079708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079737 */     // MIs[0] round
     /* 2079737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079740 */     // MIs[0] policy
     /* 2079740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2079753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079776 */     // GIR_Coverage, 15922,
     /* 2079776 */     GIR_EraseRootFromParent_Done,
     /* 2079777 */   // Label 27626: @2079777
     /* 2079777 */   GIM_Try, /*On fail goto*//*Label 27627*/ GIMT_Encode4(2079868), // Rule ID 15923 //
     /* 2079782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2079793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2079796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2079799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079828 */     // MIs[0] round
     /* 2079828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079831 */     // MIs[0] policy
     /* 2079831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079841 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11602:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2079844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079867 */     // GIR_Coverage, 15923,
     /* 2079867 */     GIR_EraseRootFromParent_Done,
     /* 2079868 */   // Label 27627: @2079868
     /* 2079868 */   GIM_Try, /*On fail goto*//*Label 27628*/ GIMT_Encode4(2079959), // Rule ID 15926 //
     /* 2079873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2079884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2079887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2079890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079919 */     // MIs[0] round
     /* 2079919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079922 */     // MIs[0] policy
     /* 2079922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2079935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2079955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079958 */     // GIR_Coverage, 15926,
     /* 2079958 */     GIR_EraseRootFromParent_Done,
     /* 2079959 */   // Label 27628: @2079959
     /* 2079959 */   GIM_Try, /*On fail goto*//*Label 27629*/ GIMT_Encode4(2080050), // Rule ID 15927 //
     /* 2079964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2079972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2079975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2079978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2079981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080010 */     // MIs[0] round
     /* 2080010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080013 */     // MIs[0] policy
     /* 2080013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080023 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080049 */     // GIR_Coverage, 15927,
     /* 2080049 */     GIR_EraseRootFromParent_Done,
     /* 2080050 */   // Label 27629: @2080050
     /* 2080050 */   GIM_Try, /*On fail goto*//*Label 27630*/ GIMT_Encode4(2080141), // Rule ID 15930 //
     /* 2080055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2080066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2080069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080101 */     // MIs[0] round
     /* 2080101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080104 */     // MIs[0] policy
     /* 2080104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080114 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080140 */     // GIR_Coverage, 15930,
     /* 2080140 */     GIR_EraseRootFromParent_Done,
     /* 2080141 */   // Label 27630: @2080141
     /* 2080141 */   GIM_Try, /*On fail goto*//*Label 27631*/ GIMT_Encode4(2080232), // Rule ID 15931 //
     /* 2080146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2080157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2080160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080192 */     // MIs[0] round
     /* 2080192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080195 */     // MIs[0] policy
     /* 2080195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080205 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2080228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080231 */     // GIR_Coverage, 15931,
     /* 2080231 */     GIR_EraseRootFromParent_Done,
     /* 2080232 */   // Label 27631: @2080232
     /* 2080232 */   GIM_Try, /*On fail goto*//*Label 27632*/ GIMT_Encode4(2080323), // Rule ID 15934 //
     /* 2080237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2080240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080283 */     // MIs[0] round
     /* 2080283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080286 */     // MIs[0] policy
     /* 2080286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080296 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080322 */     // GIR_Coverage, 15934,
     /* 2080322 */     GIR_EraseRootFromParent_Done,
     /* 2080323 */   // Label 27632: @2080323
     /* 2080323 */   GIM_Try, /*On fail goto*//*Label 27633*/ GIMT_Encode4(2080414), // Rule ID 15935 //
     /* 2080328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2080331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2080339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2080342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2080345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080374 */     // MIs[0] round
     /* 2080374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080377 */     // MIs[0] policy
     /* 2080377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080387 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2080390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2080410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080413 */     // GIR_Coverage, 15935,
     /* 2080413 */     GIR_EraseRootFromParent_Done,
     /* 2080414 */   // Label 27633: @2080414
     /* 2080414 */   GIM_Try, /*On fail goto*//*Label 27634*/ GIMT_Encode4(2080505), // Rule ID 15938 //
     /* 2080419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2080436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080465 */     // MIs[0] round
     /* 2080465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080468 */     // MIs[0] policy
     /* 2080468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080478 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2080481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080504 */     // GIR_Coverage, 15938,
     /* 2080504 */     GIR_EraseRootFromParent_Done,
     /* 2080505 */   // Label 27634: @2080505
     /* 2080505 */   GIM_Try, /*On fail goto*//*Label 27635*/ GIMT_Encode4(2080596), // Rule ID 15939 //
     /* 2080510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2080527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080556 */     // MIs[0] round
     /* 2080556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080559 */     // MIs[0] policy
     /* 2080559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080569 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2080572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080595 */     // GIR_Coverage, 15939,
     /* 2080595 */     GIR_EraseRootFromParent_Done,
     /* 2080596 */   // Label 27635: @2080596
     /* 2080596 */   GIM_Try, /*On fail goto*//*Label 27636*/ GIMT_Encode4(2080687), // Rule ID 15942 //
     /* 2080601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2080612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2080615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2080618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2080624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080647 */     // MIs[0] round
     /* 2080647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080650 */     // MIs[0] policy
     /* 2080650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080660 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2080663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080686 */     // GIR_Coverage, 15942,
     /* 2080686 */     GIR_EraseRootFromParent_Done,
     /* 2080687 */   // Label 27636: @2080687
     /* 2080687 */   GIM_Try, /*On fail goto*//*Label 27637*/ GIMT_Encode4(2080778), // Rule ID 15943 //
     /* 2080692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2080703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2080706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2080709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2080715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080738 */     // MIs[0] round
     /* 2080738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080741 */     // MIs[0] policy
     /* 2080741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080751 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2080754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080777 */     // GIR_Coverage, 15943,
     /* 2080777 */     GIR_EraseRootFromParent_Done,
     /* 2080778 */   // Label 27637: @2080778
     /* 2080778 */   GIM_Try, /*On fail goto*//*Label 27638*/ GIMT_Encode4(2080869), // Rule ID 15946 //
     /* 2080783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2080794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2080797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2080800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2080806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080829 */     // MIs[0] round
     /* 2080829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080832 */     // MIs[0] policy
     /* 2080832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080842 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2080845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080868 */     // GIR_Coverage, 15946,
     /* 2080868 */     GIR_EraseRootFromParent_Done,
     /* 2080869 */   // Label 27638: @2080869
     /* 2080869 */   GIM_Try, /*On fail goto*//*Label 27639*/ GIMT_Encode4(2080960), // Rule ID 15947 //
     /* 2080874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2080885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2080888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2080891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2080894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2080897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2080904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2080916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080920 */     // MIs[0] round
     /* 2080920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080923 */     // MIs[0] policy
     /* 2080923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080933 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2080936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080959 */     // GIR_Coverage, 15947,
     /* 2080959 */     GIR_EraseRootFromParent_Done,
     /* 2080960 */   // Label 27639: @2080960
     /* 2080960 */   GIM_Try, /*On fail goto*//*Label 27640*/ GIMT_Encode4(2081051), // Rule ID 15950 //
     /* 2080965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2080973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2080976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2080979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2080982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2080985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081011 */     // MIs[0] round
     /* 2081011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081014 */     // MIs[0] policy
     /* 2081014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081024 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081050 */     // GIR_Coverage, 15950,
     /* 2081050 */     GIR_EraseRootFromParent_Done,
     /* 2081051 */   // Label 27640: @2081051
     /* 2081051 */   GIM_Try, /*On fail goto*//*Label 27641*/ GIMT_Encode4(2081142), // Rule ID 15951 //
     /* 2081056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2081067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2081070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2081073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081102 */     // MIs[0] round
     /* 2081102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081105 */     // MIs[0] policy
     /* 2081105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081115 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081141 */     // GIR_Coverage, 15951,
     /* 2081141 */     GIR_EraseRootFromParent_Done,
     /* 2081142 */   // Label 27641: @2081142
     /* 2081142 */   GIM_Try, /*On fail goto*//*Label 27642*/ GIMT_Encode4(2081233), // Rule ID 15954 //
     /* 2081147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081193 */     // MIs[0] round
     /* 2081193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081196 */     // MIs[0] policy
     /* 2081196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081206 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081232 */     // GIR_Coverage, 15954,
     /* 2081232 */     GIR_EraseRootFromParent_Done,
     /* 2081233 */   // Label 27642: @2081233
     /* 2081233 */   GIM_Try, /*On fail goto*//*Label 27643*/ GIMT_Encode4(2081324), // Rule ID 15955 //
     /* 2081238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2081255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081284 */     // MIs[0] round
     /* 2081284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081287 */     // MIs[0] policy
     /* 2081287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081297 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081323 */     // GIR_Coverage, 15955,
     /* 2081323 */     GIR_EraseRootFromParent_Done,
     /* 2081324 */   // Label 27643: @2081324
     /* 2081324 */   GIM_Try, /*On fail goto*//*Label 27644*/ GIMT_Encode4(2081415), // Rule ID 15958 //
     /* 2081329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081375 */     // MIs[0] round
     /* 2081375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081378 */     // MIs[0] policy
     /* 2081378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081414 */     // GIR_Coverage, 15958,
     /* 2081414 */     GIR_EraseRootFromParent_Done,
     /* 2081415 */   // Label 27644: @2081415
     /* 2081415 */   GIM_Try, /*On fail goto*//*Label 27645*/ GIMT_Encode4(2081506), // Rule ID 15959 //
     /* 2081420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2081431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2081434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2081437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2081443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081466 */     // MIs[0] round
     /* 2081466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081469 */     // MIs[0] policy
     /* 2081469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081479 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081505 */     // GIR_Coverage, 15959,
     /* 2081505 */     GIR_EraseRootFromParent_Done,
     /* 2081506 */   // Label 27645: @2081506
     /* 2081506 */   GIM_Try, /*On fail goto*//*Label 27646*/ GIMT_Encode4(2081597), // Rule ID 15962 //
     /* 2081511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2081528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081557 */     // MIs[0] round
     /* 2081557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081560 */     // MIs[0] policy
     /* 2081560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081596 */     // GIR_Coverage, 15962,
     /* 2081596 */     GIR_EraseRootFromParent_Done,
     /* 2081597 */   // Label 27646: @2081597
     /* 2081597 */   GIM_Try, /*On fail goto*//*Label 27647*/ GIMT_Encode4(2081688), // Rule ID 15963 //
     /* 2081602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2081619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081648 */     // MIs[0] round
     /* 2081648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081651 */     // MIs[0] policy
     /* 2081651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2081664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081687 */     // GIR_Coverage, 15963,
     /* 2081687 */     GIR_EraseRootFromParent_Done,
     /* 2081688 */   // Label 27647: @2081688
     /* 2081688 */   GIM_Try, /*On fail goto*//*Label 27648*/ GIMT_Encode4(2081779), // Rule ID 15966 //
     /* 2081693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2081704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2081707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2081710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081739 */     // MIs[0] round
     /* 2081739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081742 */     // MIs[0] policy
     /* 2081742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081752 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081778 */     // GIR_Coverage, 15966,
     /* 2081778 */     GIR_EraseRootFromParent_Done,
     /* 2081779 */   // Label 27648: @2081779
     /* 2081779 */   GIM_Try, /*On fail goto*//*Label 27649*/ GIMT_Encode4(2081870), // Rule ID 15967 //
     /* 2081784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2081795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2081798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2081801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081830 */     // MIs[0] round
     /* 2081830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081833 */     // MIs[0] policy
     /* 2081833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081843 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2081846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081869 */     // GIR_Coverage, 15967,
     /* 2081869 */     GIR_EraseRootFromParent_Done,
     /* 2081870 */   // Label 27649: @2081870
     /* 2081870 */   GIM_Try, /*On fail goto*//*Label 27650*/ GIMT_Encode4(2081961), // Rule ID 15970 //
     /* 2081875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2081886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2081889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2081892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2081895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2081917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081921 */     // MIs[0] round
     /* 2081921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081924 */     // MIs[0] policy
     /* 2081924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081934 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2081937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081960 */     // GIR_Coverage, 15970,
     /* 2081960 */     GIR_EraseRootFromParent_Done,
     /* 2081961 */   // Label 27650: @2081961
     /* 2081961 */   GIM_Try, /*On fail goto*//*Label 27651*/ GIMT_Encode4(2082052), // Rule ID 15971 //
     /* 2081966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2081974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2081977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2081980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2081983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2081986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2081996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082012 */     // MIs[0] round
     /* 2082012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082015 */     // MIs[0] policy
     /* 2082015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082025 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082051 */     // GIR_Coverage, 15971,
     /* 2082051 */     GIR_EraseRootFromParent_Done,
     /* 2082052 */   // Label 27651: @2082052
     /* 2082052 */   GIM_Try, /*On fail goto*//*Label 27652*/ GIMT_Encode4(2082143), // Rule ID 15974 //
     /* 2082057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2082068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2082071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2082074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082103 */     // MIs[0] round
     /* 2082103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082106 */     // MIs[0] policy
     /* 2082106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082142 */     // GIR_Coverage, 15974,
     /* 2082142 */     GIR_EraseRootFromParent_Done,
     /* 2082143 */   // Label 27652: @2082143
     /* 2082143 */   GIM_Try, /*On fail goto*//*Label 27653*/ GIMT_Encode4(2082234), // Rule ID 15975 //
     /* 2082148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2082159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2082162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2082165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082194 */     // MIs[0] round
     /* 2082194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082197 */     // MIs[0] policy
     /* 2082197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082207 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2082210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082233 */     // GIR_Coverage, 15975,
     /* 2082233 */     GIR_EraseRootFromParent_Done,
     /* 2082234 */   // Label 27653: @2082234
     /* 2082234 */   GIM_Try, /*On fail goto*//*Label 27654*/ GIMT_Encode4(2082325), // Rule ID 15978 //
     /* 2082239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082285 */     // MIs[0] round
     /* 2082285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082288 */     // MIs[0] policy
     /* 2082288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082298 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082324 */     // GIR_Coverage, 15978,
     /* 2082324 */     GIR_EraseRootFromParent_Done,
     /* 2082325 */   // Label 27654: @2082325
     /* 2082325 */   GIM_Try, /*On fail goto*//*Label 27655*/ GIMT_Encode4(2082416), // Rule ID 15979 //
     /* 2082330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2082341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2082344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2082347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082376 */     // MIs[0] round
     /* 2082376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082379 */     // MIs[0] policy
     /* 2082379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082389 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2082392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082415 */     // GIR_Coverage, 15979,
     /* 2082415 */     GIR_EraseRootFromParent_Done,
     /* 2082416 */   // Label 27655: @2082416
     /* 2082416 */   GIM_Try, /*On fail goto*//*Label 27656*/ GIMT_Encode4(2082507), // Rule ID 15982 //
     /* 2082421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2082424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2082435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082467 */     // MIs[0] round
     /* 2082467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082470 */     // MIs[0] policy
     /* 2082470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082480 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082506 */     // GIR_Coverage, 15982,
     /* 2082506 */     GIR_EraseRootFromParent_Done,
     /* 2082507 */   // Label 27656: @2082507
     /* 2082507 */   GIM_Try, /*On fail goto*//*Label 27657*/ GIMT_Encode4(2082598), // Rule ID 15983 //
     /* 2082512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2082515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2082520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2082523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2082526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2082542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082558 */     // MIs[0] round
     /* 2082558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082561 */     // MIs[0] policy
     /* 2082561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082571 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2082574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2082594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082597 */     // GIR_Coverage, 15983,
     /* 2082597 */     GIR_EraseRootFromParent_Done,
     /* 2082598 */   // Label 27657: @2082598
     /* 2082598 */   GIM_Try, /*On fail goto*//*Label 27658*/ GIMT_Encode4(2082689), // Rule ID 16074 //
     /* 2082603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2082614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2082617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2082620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2082623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2082626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082649 */     // MIs[0] round
     /* 2082649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082652 */     // MIs[0] policy
     /* 2082652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082662 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2082665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082688 */     // GIR_Coverage, 16074,
     /* 2082688 */     GIR_EraseRootFromParent_Done,
     /* 2082689 */   // Label 27658: @2082689
     /* 2082689 */   GIM_Try, /*On fail goto*//*Label 27659*/ GIMT_Encode4(2082780), // Rule ID 16075 //
     /* 2082694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2082705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2082708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2082711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2082714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2082717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082740 */     // MIs[0] round
     /* 2082740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082743 */     // MIs[0] policy
     /* 2082743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082753 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2082756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082779 */     // GIR_Coverage, 16075,
     /* 2082779 */     GIR_EraseRootFromParent_Done,
     /* 2082780 */   // Label 27659: @2082780
     /* 2082780 */   GIM_Try, /*On fail goto*//*Label 27660*/ GIMT_Encode4(2082871), // Rule ID 16078 //
     /* 2082785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2082796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2082799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2082802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2082805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082831 */     // MIs[0] round
     /* 2082831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082834 */     // MIs[0] policy
     /* 2082834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082844 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2082847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082870 */     // GIR_Coverage, 16078,
     /* 2082870 */     GIR_EraseRootFromParent_Done,
     /* 2082871 */   // Label 27660: @2082871
     /* 2082871 */   GIM_Try, /*On fail goto*//*Label 27661*/ GIMT_Encode4(2082962), // Rule ID 16079 //
     /* 2082876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2082887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2082890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2082893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2082896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082922 */     // MIs[0] round
     /* 2082922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082925 */     // MIs[0] policy
     /* 2082925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082935 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2082938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082961 */     // GIR_Coverage, 16079,
     /* 2082961 */     GIR_EraseRootFromParent_Done,
     /* 2082962 */   // Label 27661: @2082962
     /* 2082962 */   GIM_Try, /*On fail goto*//*Label 27662*/ GIMT_Encode4(2083053), // Rule ID 16082 //
     /* 2082967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2082975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2082978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2082981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2082984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2082987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083013 */     // MIs[0] round
     /* 2083013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083016 */     // MIs[0] policy
     /* 2083016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083052 */     // GIR_Coverage, 16082,
     /* 2083052 */     GIR_EraseRootFromParent_Done,
     /* 2083053 */   // Label 27662: @2083053
     /* 2083053 */   GIM_Try, /*On fail goto*//*Label 27663*/ GIMT_Encode4(2083144), // Rule ID 16083 //
     /* 2083058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2083069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2083072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2083075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2083078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083104 */     // MIs[0] round
     /* 2083104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083107 */     // MIs[0] policy
     /* 2083107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083117 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083143 */     // GIR_Coverage, 16083,
     /* 2083143 */     GIR_EraseRootFromParent_Done,
     /* 2083144 */   // Label 27663: @2083144
     /* 2083144 */   GIM_Try, /*On fail goto*//*Label 27664*/ GIMT_Encode4(2083235), // Rule ID 16086 //
     /* 2083149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083195 */     // MIs[0] round
     /* 2083195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083198 */     // MIs[0] policy
     /* 2083198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083208 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083234 */     // GIR_Coverage, 16086,
     /* 2083234 */     GIR_EraseRootFromParent_Done,
     /* 2083235 */   // Label 27664: @2083235
     /* 2083235 */   GIM_Try, /*On fail goto*//*Label 27665*/ GIMT_Encode4(2083326), // Rule ID 16087 //
     /* 2083240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2083257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2083260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083286 */     // MIs[0] round
     /* 2083286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083289 */     // MIs[0] policy
     /* 2083289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083299 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2083302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083325 */     // GIR_Coverage, 16087,
     /* 2083325 */     GIR_EraseRootFromParent_Done,
     /* 2083326 */   // Label 27665: @2083326
     /* 2083326 */   GIM_Try, /*On fail goto*//*Label 27666*/ GIMT_Encode4(2083417), // Rule ID 16090 //
     /* 2083331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2083351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083377 */     // MIs[0] round
     /* 2083377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083380 */     // MIs[0] policy
     /* 2083380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083390 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083416 */     // GIR_Coverage, 16090,
     /* 2083416 */     GIR_EraseRootFromParent_Done,
     /* 2083417 */   // Label 27666: @2083417
     /* 2083417 */   GIM_Try, /*On fail goto*//*Label 27667*/ GIMT_Encode4(2083508), // Rule ID 16091 //
     /* 2083422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2083439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2083442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083468 */     // MIs[0] round
     /* 2083468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083471 */     // MIs[0] policy
     /* 2083471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083481 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083507 */     // GIR_Coverage, 16091,
     /* 2083507 */     GIR_EraseRootFromParent_Done,
     /* 2083508 */   // Label 27667: @2083508
     /* 2083508 */   GIM_Try, /*On fail goto*//*Label 27668*/ GIMT_Encode4(2083599), // Rule ID 16094 //
     /* 2083513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2083527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2083530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2083533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083559 */     // MIs[0] round
     /* 2083559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083562 */     // MIs[0] policy
     /* 2083562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083598 */     // GIR_Coverage, 16094,
     /* 2083598 */     GIR_EraseRootFromParent_Done,
     /* 2083599 */   // Label 27668: @2083599
     /* 2083599 */   GIM_Try, /*On fail goto*//*Label 27669*/ GIMT_Encode4(2083690), // Rule ID 16095 //
     /* 2083604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2083615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2083618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2083621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2083624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083650 */     // MIs[0] round
     /* 2083650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083653 */     // MIs[0] policy
     /* 2083653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083663 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2083666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2083686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083689 */     // GIR_Coverage, 16095,
     /* 2083689 */     GIR_EraseRootFromParent_Done,
     /* 2083690 */   // Label 27669: @2083690
     /* 2083690 */   GIM_Try, /*On fail goto*//*Label 27670*/ GIMT_Encode4(2083781), // Rule ID 16098 //
     /* 2083695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2083706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2083709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2083712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2083715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083741 */     // MIs[0] round
     /* 2083741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083744 */     // MIs[0] policy
     /* 2083744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083754 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2083757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083780 */     // GIR_Coverage, 16098,
     /* 2083780 */     GIR_EraseRootFromParent_Done,
     /* 2083781 */   // Label 27670: @2083781
     /* 2083781 */   GIM_Try, /*On fail goto*//*Label 27671*/ GIMT_Encode4(2083872), // Rule ID 16099 //
     /* 2083786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2083797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2083800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2083803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2083806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083832 */     // MIs[0] round
     /* 2083832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083835 */     // MIs[0] policy
     /* 2083835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083845 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2083848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083871 */     // GIR_Coverage, 16099,
     /* 2083871 */     GIR_EraseRootFromParent_Done,
     /* 2083872 */   // Label 27671: @2083872
     /* 2083872 */   GIM_Try, /*On fail goto*//*Label 27672*/ GIMT_Encode4(2083963), // Rule ID 16102 //
     /* 2083877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2083888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2083891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2083894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2083897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083923 */     // MIs[0] round
     /* 2083923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083926 */     // MIs[0] policy
     /* 2083926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2083939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083962 */     // GIR_Coverage, 16102,
     /* 2083962 */     GIR_EraseRootFromParent_Done,
     /* 2083963 */   // Label 27672: @2083963
     /* 2083963 */   GIM_Try, /*On fail goto*//*Label 27673*/ GIMT_Encode4(2084054), // Rule ID 16103 //
     /* 2083968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2083976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2083979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2083982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2083985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2083988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084014 */     // MIs[0] round
     /* 2084014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084017 */     // MIs[0] policy
     /* 2084017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084027 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084053 */     // GIR_Coverage, 16103,
     /* 2084053 */     GIR_EraseRootFromParent_Done,
     /* 2084054 */   // Label 27673: @2084054
     /* 2084054 */   GIM_Try, /*On fail goto*//*Label 27674*/ GIMT_Encode4(2084145), // Rule ID 16106 //
     /* 2084059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084105 */     // MIs[0] round
     /* 2084105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084108 */     // MIs[0] policy
     /* 2084108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084118 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084144 */     // GIR_Coverage, 16106,
     /* 2084144 */     GIR_EraseRootFromParent_Done,
     /* 2084145 */   // Label 27674: @2084145
     /* 2084145 */   GIM_Try, /*On fail goto*//*Label 27675*/ GIMT_Encode4(2084236), // Rule ID 16107 //
     /* 2084150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2084167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2084170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084196 */     // MIs[0] round
     /* 2084196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084199 */     // MIs[0] policy
     /* 2084199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084209 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084235 */     // GIR_Coverage, 16107,
     /* 2084235 */     GIR_EraseRootFromParent_Done,
     /* 2084236 */   // Label 27675: @2084236
     /* 2084236 */   GIM_Try, /*On fail goto*//*Label 27676*/ GIMT_Encode4(2084327), // Rule ID 16110 //
     /* 2084241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2084244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2084261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084287 */     // MIs[0] round
     /* 2084287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084290 */     // MIs[0] policy
     /* 2084290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084326 */     // GIR_Coverage, 16110,
     /* 2084326 */     GIR_EraseRootFromParent_Done,
     /* 2084327 */   // Label 27676: @2084327
     /* 2084327 */   GIM_Try, /*On fail goto*//*Label 27677*/ GIMT_Encode4(2084418), // Rule ID 16111 //
     /* 2084332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2084335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2084343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2084346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2084352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084378 */     // MIs[0] round
     /* 2084378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084381 */     // MIs[0] policy
     /* 2084381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2084394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2084414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084417 */     // GIR_Coverage, 16111,
     /* 2084417 */     GIR_EraseRootFromParent_Done,
     /* 2084418 */   // Label 27677: @2084418
     /* 2084418 */   GIM_Try, /*On fail goto*//*Label 27678*/ GIMT_Encode4(2084509), // Rule ID 16114 //
     /* 2084423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2084440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2084443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084469 */     // MIs[0] round
     /* 2084469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084472 */     // MIs[0] policy
     /* 2084472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2084485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084508 */     // GIR_Coverage, 16114,
     /* 2084508 */     GIR_EraseRootFromParent_Done,
     /* 2084509 */   // Label 27678: @2084509
     /* 2084509 */   GIM_Try, /*On fail goto*//*Label 27679*/ GIMT_Encode4(2084600), // Rule ID 16115 //
     /* 2084514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2084525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2084528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2084531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2084534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084560 */     // MIs[0] round
     /* 2084560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084563 */     // MIs[0] policy
     /* 2084563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084573 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2084576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084599 */     // GIR_Coverage, 16115,
     /* 2084599 */     GIR_EraseRootFromParent_Done,
     /* 2084600 */   // Label 27679: @2084600
     /* 2084600 */   GIM_Try, /*On fail goto*//*Label 27680*/ GIMT_Encode4(2084691), // Rule ID 16118 //
     /* 2084605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2084616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2084619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2084622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2084625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2084628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084651 */     // MIs[0] round
     /* 2084651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084654 */     // MIs[0] policy
     /* 2084654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084664 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2084667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084690 */     // GIR_Coverage, 16118,
     /* 2084690 */     GIR_EraseRootFromParent_Done,
     /* 2084691 */   // Label 27680: @2084691
     /* 2084691 */   GIM_Try, /*On fail goto*//*Label 27681*/ GIMT_Encode4(2084782), // Rule ID 16119 //
     /* 2084696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2084707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2084710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2084713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2084716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2084719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084742 */     // MIs[0] round
     /* 2084742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084745 */     // MIs[0] policy
     /* 2084745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084755 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2084758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084781 */     // GIR_Coverage, 16119,
     /* 2084781 */     GIR_EraseRootFromParent_Done,
     /* 2084782 */   // Label 27681: @2084782
     /* 2084782 */   GIM_Try, /*On fail goto*//*Label 27682*/ GIMT_Encode4(2084873), // Rule ID 16122 //
     /* 2084787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2084798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2084801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2084804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2084807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2084810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2084817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084833 */     // MIs[0] round
     /* 2084833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084836 */     // MIs[0] policy
     /* 2084836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084846 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2084849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084872 */     // GIR_Coverage, 16122,
     /* 2084872 */     GIR_EraseRootFromParent_Done,
     /* 2084873 */   // Label 27682: @2084873
     /* 2084873 */   GIM_Try, /*On fail goto*//*Label 27683*/ GIMT_Encode4(2084964), // Rule ID 16123 //
     /* 2084878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2084889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2084892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2084895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2084898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2084901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2084908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084924 */     // MIs[0] round
     /* 2084924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084927 */     // MIs[0] policy
     /* 2084927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084937 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2084940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2084960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084963 */     // GIR_Coverage, 16123,
     /* 2084963 */     GIR_EraseRootFromParent_Done,
     /* 2084964 */   // Label 27683: @2084964
     /* 2084964 */   GIM_Try, /*On fail goto*//*Label 27684*/ GIMT_Encode4(2085055), // Rule ID 16126 //
     /* 2084969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2084977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2084980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2084983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2084986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2084989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085015 */     // MIs[0] round
     /* 2085015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085018 */     // MIs[0] policy
     /* 2085018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085054 */     // GIR_Coverage, 16126,
     /* 2085054 */     GIR_EraseRootFromParent_Done,
     /* 2085055 */   // Label 27684: @2085055
     /* 2085055 */   GIM_Try, /*On fail goto*//*Label 27685*/ GIMT_Encode4(2085146), // Rule ID 16127 //
     /* 2085060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2085071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2085074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2085077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2085080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085106 */     // MIs[0] round
     /* 2085106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085109 */     // MIs[0] policy
     /* 2085109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085119 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085145 */     // GIR_Coverage, 16127,
     /* 2085145 */     GIR_EraseRootFromParent_Done,
     /* 2085146 */   // Label 27685: @2085146
     /* 2085146 */   GIM_Try, /*On fail goto*//*Label 27686*/ GIMT_Encode4(2085237), // Rule ID 16130 //
     /* 2085151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085197 */     // MIs[0] round
     /* 2085197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085200 */     // MIs[0] policy
     /* 2085200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085210 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085236 */     // GIR_Coverage, 16130,
     /* 2085236 */     GIR_EraseRootFromParent_Done,
     /* 2085237 */   // Label 27686: @2085237
     /* 2085237 */   GIM_Try, /*On fail goto*//*Label 27687*/ GIMT_Encode4(2085328), // Rule ID 16131 //
     /* 2085242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2085253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2085256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2085262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085288 */     // MIs[0] round
     /* 2085288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085291 */     // MIs[0] policy
     /* 2085291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085301 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085327 */     // GIR_Coverage, 16131,
     /* 2085327 */     GIR_EraseRootFromParent_Done,
     /* 2085328 */   // Label 27687: @2085328
     /* 2085328 */   GIM_Try, /*On fail goto*//*Label 27688*/ GIMT_Encode4(2085419), // Rule ID 16134 //
     /* 2085333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2085353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085379 */     // MIs[0] round
     /* 2085379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085382 */     // MIs[0] policy
     /* 2085382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085418 */     // GIR_Coverage, 16134,
     /* 2085418 */     GIR_EraseRootFromParent_Done,
     /* 2085419 */   // Label 27688: @2085419
     /* 2085419 */   GIM_Try, /*On fail goto*//*Label 27689*/ GIMT_Encode4(2085510), // Rule ID 16135 //
     /* 2085424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2085435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2085438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2085444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085470 */     // MIs[0] round
     /* 2085470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085473 */     // MIs[0] policy
     /* 2085473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085483 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2085506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085509 */     // GIR_Coverage, 16135,
     /* 2085509 */     GIR_EraseRootFromParent_Done,
     /* 2085510 */   // Label 27689: @2085510
     /* 2085510 */   GIM_Try, /*On fail goto*//*Label 27690*/ GIMT_Encode4(2085601), // Rule ID 16138 //
     /* 2085515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2085526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2085529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2085535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085561 */     // MIs[0] round
     /* 2085561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085564 */     // MIs[0] policy
     /* 2085564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085600 */     // GIR_Coverage, 16138,
     /* 2085600 */     GIR_EraseRootFromParent_Done,
     /* 2085601 */   // Label 27690: @2085601
     /* 2085601 */   GIM_Try, /*On fail goto*//*Label 27691*/ GIMT_Encode4(2085692), // Rule ID 16139 //
     /* 2085606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2085617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2085620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2085623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2085626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085652 */     // MIs[0] round
     /* 2085652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085655 */     // MIs[0] policy
     /* 2085655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2085668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085691 */     // GIR_Coverage, 16139,
     /* 2085691 */     GIR_EraseRootFromParent_Done,
     /* 2085692 */   // Label 27691: @2085692
     /* 2085692 */   GIM_Try, /*On fail goto*//*Label 27692*/ GIMT_Encode4(2085783), // Rule ID 16142 //
     /* 2085697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2085708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2085711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2085717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085743 */     // MIs[0] round
     /* 2085743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085746 */     // MIs[0] policy
     /* 2085746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085782 */     // GIR_Coverage, 16142,
     /* 2085782 */     GIR_EraseRootFromParent_Done,
     /* 2085783 */   // Label 27692: @2085783
     /* 2085783 */   GIM_Try, /*On fail goto*//*Label 27693*/ GIMT_Encode4(2085874), // Rule ID 16143 //
     /* 2085788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2085799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2085802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2085805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2085808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085834 */     // MIs[0] round
     /* 2085834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085837 */     // MIs[0] policy
     /* 2085837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085847 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2085850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085873 */     // GIR_Coverage, 16143,
     /* 2085873 */     GIR_EraseRootFromParent_Done,
     /* 2085874 */   // Label 27693: @2085874
     /* 2085874 */   GIM_Try, /*On fail goto*//*Label 27694*/ GIMT_Encode4(2085965), // Rule ID 16146 //
     /* 2085879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2085890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2085893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2085896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2085899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2085909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085925 */     // MIs[0] round
     /* 2085925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085928 */     // MIs[0] policy
     /* 2085928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085938 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2085941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085964 */     // GIR_Coverage, 16146,
     /* 2085964 */     GIR_EraseRootFromParent_Done,
     /* 2085965 */   // Label 27694: @2085965
     /* 2085965 */   GIM_Try, /*On fail goto*//*Label 27695*/ GIMT_Encode4(2086056), // Rule ID 16147 //
     /* 2085970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2085978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2085981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2085984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2085987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2085990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086016 */     // MIs[0] round
     /* 2086016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086019 */     // MIs[0] policy
     /* 2086019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086029 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2086052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086055 */     // GIR_Coverage, 16147,
     /* 2086055 */     GIR_EraseRootFromParent_Done,
     /* 2086056 */   // Label 27695: @2086056
     /* 2086056 */   GIM_Try, /*On fail goto*//*Label 27696*/ GIMT_Encode4(2086147), // Rule ID 16150 //
     /* 2086061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2086081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086107 */     // MIs[0] round
     /* 2086107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086110 */     // MIs[0] policy
     /* 2086110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086146 */     // GIR_Coverage, 16150,
     /* 2086146 */     GIR_EraseRootFromParent_Done,
     /* 2086147 */   // Label 27696: @2086147
     /* 2086147 */   GIM_Try, /*On fail goto*//*Label 27697*/ GIMT_Encode4(2086238), // Rule ID 16151 //
     /* 2086152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2086163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2086166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2086169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2086172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086198 */     // MIs[0] round
     /* 2086198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086201 */     // MIs[0] policy
     /* 2086201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086211 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2086214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086237 */     // GIR_Coverage, 16151,
     /* 2086237 */     GIR_EraseRootFromParent_Done,
     /* 2086238 */   // Label 27697: @2086238
     /* 2086238 */   GIM_Try, /*On fail goto*//*Label 27698*/ GIMT_Encode4(2086329), // Rule ID 16154 //
     /* 2086243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2086263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086289 */     // MIs[0] round
     /* 2086289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086292 */     // MIs[0] policy
     /* 2086292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086328 */     // GIR_Coverage, 16154,
     /* 2086328 */     GIR_EraseRootFromParent_Done,
     /* 2086329 */   // Label 27698: @2086329
     /* 2086329 */   GIM_Try, /*On fail goto*//*Label 27699*/ GIMT_Encode4(2086420), // Rule ID 16155 //
     /* 2086334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2086345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2086348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2086351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2086354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086380 */     // MIs[0] round
     /* 2086380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086383 */     // MIs[0] policy
     /* 2086383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086393 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2086396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086419 */     // GIR_Coverage, 16155,
     /* 2086419 */     GIR_EraseRootFromParent_Done,
     /* 2086420 */   // Label 27699: @2086420
     /* 2086420 */   GIM_Try, /*On fail goto*//*Label 27700*/ GIMT_Encode4(2086511), // Rule ID 16158 //
     /* 2086425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2086428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2086445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086471 */     // MIs[0] round
     /* 2086471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086474 */     // MIs[0] policy
     /* 2086474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086510 */     // GIR_Coverage, 16158,
     /* 2086510 */     GIR_EraseRootFromParent_Done,
     /* 2086511 */   // Label 27700: @2086511
     /* 2086511 */   GIM_Try, /*On fail goto*//*Label 27701*/ GIMT_Encode4(2086602), // Rule ID 16159 //
     /* 2086516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2086519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2086527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2086530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2086533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2086536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2086546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086562 */     // MIs[0] round
     /* 2086562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086565 */     // MIs[0] policy
     /* 2086565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086575 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2086578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2086598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086601 */     // GIR_Coverage, 16159,
     /* 2086601 */     GIR_EraseRootFromParent_Done,
     /* 2086602 */   // Label 27701: @2086602
     /* 2086602 */   GIM_Try, /*On fail goto*//*Label 27702*/ GIMT_Encode4(2086693), // Rule ID 16162 //
     /* 2086607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2086618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2086621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2086624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086653 */     // MIs[0] round
     /* 2086653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086656 */     // MIs[0] policy
     /* 2086656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086666 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2086669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086692 */     // GIR_Coverage, 16162,
     /* 2086692 */     GIR_EraseRootFromParent_Done,
     /* 2086693 */   // Label 27702: @2086693
     /* 2086693 */   GIM_Try, /*On fail goto*//*Label 27703*/ GIMT_Encode4(2086784), // Rule ID 16163 //
     /* 2086698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2086709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2086712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2086715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2086718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086744 */     // MIs[0] round
     /* 2086744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086747 */     // MIs[0] policy
     /* 2086747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086757 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2086760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086783 */     // GIR_Coverage, 16163,
     /* 2086783 */     GIR_EraseRootFromParent_Done,
     /* 2086784 */   // Label 27703: @2086784
     /* 2086784 */   GIM_Try, /*On fail goto*//*Label 27704*/ GIMT_Encode4(2086875), // Rule ID 16166 //
     /* 2086789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2086800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2086803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2086806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086835 */     // MIs[0] round
     /* 2086835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086838 */     // MIs[0] policy
     /* 2086838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086848 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2086851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086874 */     // GIR_Coverage, 16166,
     /* 2086874 */     GIR_EraseRootFromParent_Done,
     /* 2086875 */   // Label 27704: @2086875
     /* 2086875 */   GIM_Try, /*On fail goto*//*Label 27705*/ GIMT_Encode4(2086966), // Rule ID 16167 //
     /* 2086880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2086891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2086894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2086897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2086900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2086922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086926 */     // MIs[0] round
     /* 2086926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086929 */     // MIs[0] policy
     /* 2086929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086939 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2086942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086965 */     // GIR_Coverage, 16167,
     /* 2086965 */     GIR_EraseRootFromParent_Done,
     /* 2086966 */   // Label 27705: @2086966
     /* 2086966 */   GIM_Try, /*On fail goto*//*Label 27706*/ GIMT_Encode4(2087057), // Rule ID 16170 //
     /* 2086971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2086979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2086982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2086985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2086988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2086991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087017 */     // MIs[0] round
     /* 2087017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087020 */     // MIs[0] policy
     /* 2087020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087030 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087056 */     // GIR_Coverage, 16170,
     /* 2087056 */     GIR_EraseRootFromParent_Done,
     /* 2087057 */   // Label 27706: @2087057
     /* 2087057 */   GIM_Try, /*On fail goto*//*Label 27707*/ GIMT_Encode4(2087148), // Rule ID 16171 //
     /* 2087062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2087073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2087076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2087079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087108 */     // MIs[0] round
     /* 2087108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087111 */     // MIs[0] policy
     /* 2087111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087121 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087147 */     // GIR_Coverage, 16171,
     /* 2087147 */     GIR_EraseRootFromParent_Done,
     /* 2087148 */   // Label 27707: @2087148
     /* 2087148 */   GIM_Try, /*On fail goto*//*Label 27708*/ GIMT_Encode4(2087239), // Rule ID 16174 //
     /* 2087153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087199 */     // MIs[0] round
     /* 2087199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087202 */     // MIs[0] policy
     /* 2087202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087212 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087238 */     // GIR_Coverage, 16174,
     /* 2087238 */     GIR_EraseRootFromParent_Done,
     /* 2087239 */   // Label 27708: @2087239
     /* 2087239 */   GIM_Try, /*On fail goto*//*Label 27709*/ GIMT_Encode4(2087330), // Rule ID 16175 //
     /* 2087244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2087255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2087258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087290 */     // MIs[0] round
     /* 2087290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087293 */     // MIs[0] policy
     /* 2087293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087303 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2087306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087329 */     // GIR_Coverage, 16175,
     /* 2087329 */     GIR_EraseRootFromParent_Done,
     /* 2087330 */   // Label 27709: @2087330
     /* 2087330 */   GIM_Try, /*On fail goto*//*Label 27710*/ GIMT_Encode4(2087421), // Rule ID 16178 //
     /* 2087335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087381 */     // MIs[0] round
     /* 2087381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087384 */     // MIs[0] policy
     /* 2087384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087394 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087420 */     // GIR_Coverage, 16178,
     /* 2087420 */     GIR_EraseRootFromParent_Done,
     /* 2087421 */   // Label 27710: @2087421
     /* 2087421 */   GIM_Try, /*On fail goto*//*Label 27711*/ GIMT_Encode4(2087512), // Rule ID 16179 //
     /* 2087426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2087437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2087440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2087443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087472 */     // MIs[0] round
     /* 2087472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087475 */     // MIs[0] policy
     /* 2087475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087485 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087511 */     // GIR_Coverage, 16179,
     /* 2087511 */     GIR_EraseRootFromParent_Done,
     /* 2087512 */   // Label 27711: @2087512
     /* 2087512 */   GIM_Try, /*On fail goto*//*Label 27712*/ GIMT_Encode4(2087603), // Rule ID 16182 //
     /* 2087517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2087534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087563 */     // MIs[0] round
     /* 2087563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087566 */     // MIs[0] policy
     /* 2087566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087576 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087602 */     // GIR_Coverage, 16182,
     /* 2087602 */     GIR_EraseRootFromParent_Done,
     /* 2087603 */   // Label 27712: @2087603
     /* 2087603 */   GIM_Try, /*On fail goto*//*Label 27713*/ GIMT_Encode4(2087694), // Rule ID 16183 //
     /* 2087608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2087625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087654 */     // MIs[0] round
     /* 2087654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087657 */     // MIs[0] policy
     /* 2087657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087667 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2087670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087693 */     // GIR_Coverage, 16183,
     /* 2087693 */     GIR_EraseRootFromParent_Done,
     /* 2087694 */   // Label 27713: @2087694
     /* 2087694 */   GIM_Try, /*On fail goto*//*Label 27714*/ GIMT_Encode4(2087785), // Rule ID 16186 //
     /* 2087699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2087710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2087713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2087716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087745 */     // MIs[0] round
     /* 2087745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087748 */     // MIs[0] policy
     /* 2087748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2087761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087784 */     // GIR_Coverage, 16186,
     /* 2087784 */     GIR_EraseRootFromParent_Done,
     /* 2087785 */   // Label 27714: @2087785
     /* 2087785 */   GIM_Try, /*On fail goto*//*Label 27715*/ GIMT_Encode4(2087876), // Rule ID 16187 //
     /* 2087790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2087801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2087804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2087807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087836 */     // MIs[0] round
     /* 2087836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087839 */     // MIs[0] policy
     /* 2087839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087849 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11600:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2087852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087875 */     // GIR_Coverage, 16187,
     /* 2087875 */     GIR_EraseRootFromParent_Done,
     /* 2087876 */   // Label 27715: @2087876
     /* 2087876 */   GIM_Try, /*On fail goto*//*Label 27716*/ GIMT_Encode4(2087967), // Rule ID 16190 //
     /* 2087881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2087892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2087895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2087898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087927 */     // MIs[0] round
     /* 2087927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087930 */     // MIs[0] policy
     /* 2087930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2087943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087966 */     // GIR_Coverage, 16190,
     /* 2087966 */     GIR_EraseRootFromParent_Done,
     /* 2087967 */   // Label 27716: @2087967
     /* 2087967 */   GIM_Try, /*On fail goto*//*Label 27717*/ GIMT_Encode4(2088058), // Rule ID 16191 //
     /* 2087972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2087980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2087983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2087986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2087989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088018 */     // MIs[0] round
     /* 2088018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088021 */     // MIs[0] policy
     /* 2088021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088031 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2088054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088057 */     // GIR_Coverage, 16191,
     /* 2088057 */     GIR_EraseRootFromParent_Done,
     /* 2088058 */   // Label 27717: @2088058
     /* 2088058 */   GIM_Try, /*On fail goto*//*Label 27718*/ GIMT_Encode4(2088149), // Rule ID 16194 //
     /* 2088063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088109 */     // MIs[0] round
     /* 2088109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088112 */     // MIs[0] policy
     /* 2088112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088148 */     // GIR_Coverage, 16194,
     /* 2088148 */     GIR_EraseRootFromParent_Done,
     /* 2088149 */   // Label 27718: @2088149
     /* 2088149 */   GIM_Try, /*On fail goto*//*Label 27719*/ GIMT_Encode4(2088240), // Rule ID 16195 //
     /* 2088154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2088165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2088168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2088171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088200 */     // MIs[0] round
     /* 2088200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088203 */     // MIs[0] policy
     /* 2088203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088213 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2088236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088239 */     // GIR_Coverage, 16195,
     /* 2088239 */     GIR_EraseRootFromParent_Done,
     /* 2088240 */   // Label 27719: @2088240
     /* 2088240 */   GIM_Try, /*On fail goto*//*Label 27720*/ GIMT_Encode4(2088331), // Rule ID 16198 //
     /* 2088245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2088248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088291 */     // MIs[0] round
     /* 2088291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088294 */     // MIs[0] policy
     /* 2088294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088304 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088330 */     // GIR_Coverage, 16198,
     /* 2088330 */     GIR_EraseRootFromParent_Done,
     /* 2088331 */   // Label 27720: @2088331
     /* 2088331 */   GIM_Try, /*On fail goto*//*Label 27721*/ GIMT_Encode4(2088422), // Rule ID 16199 //
     /* 2088336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2088339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2088347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2088350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2088353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088382 */     // MIs[0] round
     /* 2088382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088385 */     // MIs[0] policy
     /* 2088385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088395 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2088398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2088418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088421 */     // GIR_Coverage, 16199,
     /* 2088421 */     GIR_EraseRootFromParent_Done,
     /* 2088422 */   // Label 27721: @2088422
     /* 2088422 */   GIM_Try, /*On fail goto*//*Label 27722*/ GIMT_Encode4(2088513), // Rule ID 16202 //
     /* 2088427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2088444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088473 */     // MIs[0] round
     /* 2088473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088476 */     // MIs[0] policy
     /* 2088476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088486 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2088489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088512 */     // GIR_Coverage, 16202,
     /* 2088512 */     GIR_EraseRootFromParent_Done,
     /* 2088513 */   // Label 27722: @2088513
     /* 2088513 */   GIM_Try, /*On fail goto*//*Label 27723*/ GIMT_Encode4(2088604), // Rule ID 16203 //
     /* 2088518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2088535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088564 */     // MIs[0] round
     /* 2088564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088567 */     // MIs[0] policy
     /* 2088567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2088580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088603 */     // GIR_Coverage, 16203,
     /* 2088603 */     GIR_EraseRootFromParent_Done,
     /* 2088604 */   // Label 27723: @2088604
     /* 2088604 */   GIM_Try, /*On fail goto*//*Label 27724*/ GIMT_Encode4(2088695), // Rule ID 16206 //
     /* 2088609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2088620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2088623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2088626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2088632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088655 */     // MIs[0] round
     /* 2088655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088658 */     // MIs[0] policy
     /* 2088658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2088671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088694 */     // GIR_Coverage, 16206,
     /* 2088694 */     GIR_EraseRootFromParent_Done,
     /* 2088695 */   // Label 27724: @2088695
     /* 2088695 */   GIM_Try, /*On fail goto*//*Label 27725*/ GIMT_Encode4(2088786), // Rule ID 16207 //
     /* 2088700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2088711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2088714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2088717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2088723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088746 */     // MIs[0] round
     /* 2088746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088749 */     // MIs[0] policy
     /* 2088749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088759 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2088762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088785 */     // GIR_Coverage, 16207,
     /* 2088785 */     GIR_EraseRootFromParent_Done,
     /* 2088786 */   // Label 27725: @2088786
     /* 2088786 */   GIM_Try, /*On fail goto*//*Label 27726*/ GIMT_Encode4(2088877), // Rule ID 16210 //
     /* 2088791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2088802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2088805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2088808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2088814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2088821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088837 */     // MIs[0] round
     /* 2088837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088840 */     // MIs[0] policy
     /* 2088840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088850 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2088853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088876 */     // GIR_Coverage, 16210,
     /* 2088876 */     GIR_EraseRootFromParent_Done,
     /* 2088877 */   // Label 27726: @2088877
     /* 2088877 */   GIM_Try, /*On fail goto*//*Label 27727*/ GIMT_Encode4(2088968), // Rule ID 16211 //
     /* 2088882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2088893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2088896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2088899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2088905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2088912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088928 */     // MIs[0] round
     /* 2088928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088931 */     // MIs[0] policy
     /* 2088931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088941 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2088944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088967 */     // GIR_Coverage, 16211,
     /* 2088967 */     GIR_EraseRootFromParent_Done,
     /* 2088968 */   // Label 27727: @2088968
     /* 2088968 */   GIM_Try, /*On fail goto*//*Label 27728*/ GIMT_Encode4(2089059), // Rule ID 16214 //
     /* 2088973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2088981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2088984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2088987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2088990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089019 */     // MIs[0] round
     /* 2089019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089022 */     // MIs[0] policy
     /* 2089022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089058 */     // GIR_Coverage, 16214,
     /* 2089058 */     GIR_EraseRootFromParent_Done,
     /* 2089059 */   // Label 27728: @2089059
     /* 2089059 */   GIM_Try, /*On fail goto*//*Label 27729*/ GIMT_Encode4(2089150), // Rule ID 16215 //
     /* 2089064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2089075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2089078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2089081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089110 */     // MIs[0] round
     /* 2089110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089113 */     // MIs[0] policy
     /* 2089113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089149 */     // GIR_Coverage, 16215,
     /* 2089149 */     GIR_EraseRootFromParent_Done,
     /* 2089150 */   // Label 27729: @2089150
     /* 2089150 */   GIM_Try, /*On fail goto*//*Label 27730*/ GIMT_Encode4(2089241), // Rule ID 16218 //
     /* 2089155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089201 */     // MIs[0] round
     /* 2089201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089204 */     // MIs[0] policy
     /* 2089204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089214 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089240 */     // GIR_Coverage, 16218,
     /* 2089240 */     GIR_EraseRootFromParent_Done,
     /* 2089241 */   // Label 27730: @2089241
     /* 2089241 */   GIM_Try, /*On fail goto*//*Label 27731*/ GIMT_Encode4(2089332), // Rule ID 16219 //
     /* 2089246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2089263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089292 */     // MIs[0] round
     /* 2089292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089295 */     // MIs[0] policy
     /* 2089295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089305 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089331 */     // GIR_Coverage, 16219,
     /* 2089331 */     GIR_EraseRootFromParent_Done,
     /* 2089332 */   // Label 27731: @2089332
     /* 2089332 */   GIM_Try, /*On fail goto*//*Label 27732*/ GIMT_Encode4(2089423), // Rule ID 16222 //
     /* 2089337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089383 */     // MIs[0] round
     /* 2089383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089386 */     // MIs[0] policy
     /* 2089386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089396 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089422 */     // GIR_Coverage, 16222,
     /* 2089422 */     GIR_EraseRootFromParent_Done,
     /* 2089423 */   // Label 27732: @2089423
     /* 2089423 */   GIM_Try, /*On fail goto*//*Label 27733*/ GIMT_Encode4(2089514), // Rule ID 16223 //
     /* 2089428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2089439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2089442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2089445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2089451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089474 */     // MIs[0] round
     /* 2089474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089477 */     // MIs[0] policy
     /* 2089477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089487 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089513 */     // GIR_Coverage, 16223,
     /* 2089513 */     GIR_EraseRootFromParent_Done,
     /* 2089514 */   // Label 27733: @2089514
     /* 2089514 */   GIM_Try, /*On fail goto*//*Label 27734*/ GIMT_Encode4(2089605), // Rule ID 16226 //
     /* 2089519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2089536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089565 */     // MIs[0] round
     /* 2089565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089568 */     // MIs[0] policy
     /* 2089568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089604 */     // GIR_Coverage, 16226,
     /* 2089604 */     GIR_EraseRootFromParent_Done,
     /* 2089605 */   // Label 27734: @2089605
     /* 2089605 */   GIM_Try, /*On fail goto*//*Label 27735*/ GIMT_Encode4(2089696), // Rule ID 16227 //
     /* 2089610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2089621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2089624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2089627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089656 */     // MIs[0] round
     /* 2089656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089659 */     // MIs[0] policy
     /* 2089659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2089672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089695 */     // GIR_Coverage, 16227,
     /* 2089695 */     GIR_EraseRootFromParent_Done,
     /* 2089696 */   // Label 27735: @2089696
     /* 2089696 */   GIM_Try, /*On fail goto*//*Label 27736*/ GIMT_Encode4(2089787), // Rule ID 16230 //
     /* 2089701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2089718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089747 */     // MIs[0] round
     /* 2089747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089750 */     // MIs[0] policy
     /* 2089750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089786 */     // GIR_Coverage, 16230,
     /* 2089786 */     GIR_EraseRootFromParent_Done,
     /* 2089787 */   // Label 27736: @2089787
     /* 2089787 */   GIM_Try, /*On fail goto*//*Label 27737*/ GIMT_Encode4(2089878), // Rule ID 16231 //
     /* 2089792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2089803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2089806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2089809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089838 */     // MIs[0] round
     /* 2089838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089841 */     // MIs[0] policy
     /* 2089841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2089854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089877 */     // GIR_Coverage, 16231,
     /* 2089877 */     GIR_EraseRootFromParent_Done,
     /* 2089878 */   // Label 27737: @2089878
     /* 2089878 */   GIM_Try, /*On fail goto*//*Label 27738*/ GIMT_Encode4(2089969), // Rule ID 16234 //
     /* 2089883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2089894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2089897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2089900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2089913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089929 */     // MIs[0] round
     /* 2089929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089932 */     // MIs[0] policy
     /* 2089932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089942 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2089945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089968 */     // GIR_Coverage, 16234,
     /* 2089968 */     GIR_EraseRootFromParent_Done,
     /* 2089969 */   // Label 27738: @2089969
     /* 2089969 */   GIM_Try, /*On fail goto*//*Label 27739*/ GIMT_Encode4(2090060), // Rule ID 16235 //
     /* 2089974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2089982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2089985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2089988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2089991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090020 */     // MIs[0] round
     /* 2090020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090023 */     // MIs[0] policy
     /* 2090023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090033 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090059 */     // GIR_Coverage, 16235,
     /* 2090059 */     GIR_EraseRootFromParent_Done,
     /* 2090060 */   // Label 27739: @2090060
     /* 2090060 */   GIM_Try, /*On fail goto*//*Label 27740*/ GIMT_Encode4(2090151), // Rule ID 16238 //
     /* 2090065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2090076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2090079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090111 */     // MIs[0] round
     /* 2090111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090114 */     // MIs[0] policy
     /* 2090114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090150 */     // GIR_Coverage, 16238,
     /* 2090150 */     GIR_EraseRootFromParent_Done,
     /* 2090151 */   // Label 27740: @2090151
     /* 2090151 */   GIM_Try, /*On fail goto*//*Label 27741*/ GIMT_Encode4(2090242), // Rule ID 16239 //
     /* 2090156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2090167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2090170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090202 */     // MIs[0] round
     /* 2090202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090205 */     // MIs[0] policy
     /* 2090205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090215 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2090218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090241 */     // GIR_Coverage, 16239,
     /* 2090241 */     GIR_EraseRootFromParent_Done,
     /* 2090242 */   // Label 27741: @2090242
     /* 2090242 */   GIM_Try, /*On fail goto*//*Label 27742*/ GIMT_Encode4(2090333), // Rule ID 16242 //
     /* 2090247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090293 */     // MIs[0] round
     /* 2090293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090296 */     // MIs[0] policy
     /* 2090296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090306 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090332 */     // GIR_Coverage, 16242,
     /* 2090332 */     GIR_EraseRootFromParent_Done,
     /* 2090333 */   // Label 27742: @2090333
     /* 2090333 */   GIM_Try, /*On fail goto*//*Label 27743*/ GIMT_Encode4(2090424), // Rule ID 16243 //
     /* 2090338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2090349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2090352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090384 */     // MIs[0] round
     /* 2090384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090387 */     // MIs[0] policy
     /* 2090387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090397 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2090400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090423 */     // GIR_Coverage, 16243,
     /* 2090423 */     GIR_EraseRootFromParent_Done,
     /* 2090424 */   // Label 27743: @2090424
     /* 2090424 */   GIM_Try, /*On fail goto*//*Label 27744*/ GIMT_Encode4(2090515), // Rule ID 16246 //
     /* 2090429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2090432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090475 */     // MIs[0] round
     /* 2090475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090478 */     // MIs[0] policy
     /* 2090478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090488 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090514 */     // GIR_Coverage, 16246,
     /* 2090514 */     GIR_EraseRootFromParent_Done,
     /* 2090515 */   // Label 27744: @2090515
     /* 2090515 */   GIM_Try, /*On fail goto*//*Label 27745*/ GIMT_Encode4(2090606), // Rule ID 16247 //
     /* 2090520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2090523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2090528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2090531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2090534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2090550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090566 */     // MIs[0] round
     /* 2090566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090569 */     // MIs[0] policy
     /* 2090569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090579 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2090582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2090602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090605 */     // GIR_Coverage, 16247,
     /* 2090605 */     GIR_EraseRootFromParent_Done,
     /* 2090606 */   // Label 27745: @2090606
     /* 2090606 */   GIM_Try, /*On fail goto*//*Label 27746*/ GIMT_Encode4(2090700), // Rule ID 16338 //
     /* 2090611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2090619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2090622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2090625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2090628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2090631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090657 */     // MIs[0] round
     /* 2090657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090660 */     // MIs[0] policy
     /* 2090660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090670 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2090673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090699 */     // GIR_Coverage, 16338,
     /* 2090699 */     GIR_EraseRootFromParent_Done,
     /* 2090700 */   // Label 27746: @2090700
     /* 2090700 */   GIM_Try, /*On fail goto*//*Label 27747*/ GIMT_Encode4(2090794), // Rule ID 16339 //
     /* 2090705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2090713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2090716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2090719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2090722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2090725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090751 */     // MIs[0] round
     /* 2090751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090754 */     // MIs[0] policy
     /* 2090754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090764 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2090767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090793 */     // GIR_Coverage, 16339,
     /* 2090793 */     GIR_EraseRootFromParent_Done,
     /* 2090794 */   // Label 27747: @2090794
     /* 2090794 */   GIM_Try, /*On fail goto*//*Label 27748*/ GIMT_Encode4(2090888), // Rule ID 16342 //
     /* 2090799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2090807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2090810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2090813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2090816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2090819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090845 */     // MIs[0] round
     /* 2090845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090848 */     // MIs[0] policy
     /* 2090848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090858 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2090861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090887 */     // GIR_Coverage, 16342,
     /* 2090887 */     GIR_EraseRootFromParent_Done,
     /* 2090888 */   // Label 27748: @2090888
     /* 2090888 */   GIM_Try, /*On fail goto*//*Label 27749*/ GIMT_Encode4(2090982), // Rule ID 16343 //
     /* 2090893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2090896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2090901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2090904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2090907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2090910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2090913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090939 */     // MIs[0] round
     /* 2090939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090942 */     // MIs[0] policy
     /* 2090942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090952 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2090955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2090975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090981 */     // GIR_Coverage, 16343,
     /* 2090981 */     GIR_EraseRootFromParent_Done,
     /* 2090982 */   // Label 27749: @2090982
     /* 2090982 */   GIM_Try, /*On fail goto*//*Label 27750*/ GIMT_Encode4(2091076), // Rule ID 16346 //
     /* 2090987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2090990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2090995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2090998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2091001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2091007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091033 */     // MIs[0] round
     /* 2091033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091036 */     // MIs[0] policy
     /* 2091036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2091049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091075 */     // GIR_Coverage, 16346,
     /* 2091075 */     GIR_EraseRootFromParent_Done,
     /* 2091076 */   // Label 27750: @2091076
     /* 2091076 */   GIM_Try, /*On fail goto*//*Label 27751*/ GIMT_Encode4(2091170), // Rule ID 16347 //
     /* 2091081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2091092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2091095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2091101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091127 */     // MIs[0] round
     /* 2091127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091130 */     // MIs[0] policy
     /* 2091130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091140 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2091143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091169 */     // GIR_Coverage, 16347,
     /* 2091169 */     GIR_EraseRootFromParent_Done,
     /* 2091170 */   // Label 27751: @2091170
     /* 2091170 */   GIM_Try, /*On fail goto*//*Label 27752*/ GIMT_Encode4(2091264), // Rule ID 16350 //
     /* 2091175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2091195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091221 */     // MIs[0] round
     /* 2091221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091224 */     // MIs[0] policy
     /* 2091224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2091237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091263 */     // GIR_Coverage, 16350,
     /* 2091263 */     GIR_EraseRootFromParent_Done,
     /* 2091264 */   // Label 27752: @2091264
     /* 2091264 */   GIM_Try, /*On fail goto*//*Label 27753*/ GIMT_Encode4(2091358), // Rule ID 16351 //
     /* 2091269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2091280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2091283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2091289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091315 */     // MIs[0] round
     /* 2091315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091318 */     // MIs[0] policy
     /* 2091318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091328 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2091331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091357 */     // GIR_Coverage, 16351,
     /* 2091357 */     GIR_EraseRootFromParent_Done,
     /* 2091358 */   // Label 27753: @2091358
     /* 2091358 */   GIM_Try, /*On fail goto*//*Label 27754*/ GIMT_Encode4(2091452), // Rule ID 16354 //
     /* 2091363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2091374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2091377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2091383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091409 */     // MIs[0] round
     /* 2091409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091412 */     // MIs[0] policy
     /* 2091412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091422 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2091425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091451 */     // GIR_Coverage, 16354,
     /* 2091451 */     GIR_EraseRootFromParent_Done,
     /* 2091452 */   // Label 27754: @2091452
     /* 2091452 */   GIM_Try, /*On fail goto*//*Label 27755*/ GIMT_Encode4(2091546), // Rule ID 16355 //
     /* 2091457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2091468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2091471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2091477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091503 */     // MIs[0] round
     /* 2091503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091506 */     // MIs[0] policy
     /* 2091506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091516 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2091519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091545 */     // GIR_Coverage, 16355,
     /* 2091545 */     GIR_EraseRootFromParent_Done,
     /* 2091546 */   // Label 27755: @2091546
     /* 2091546 */   GIM_Try, /*On fail goto*//*Label 27756*/ GIMT_Encode4(2091640), // Rule ID 16358 //
     /* 2091551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2091562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2091565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2091568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2091571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2091574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2091581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091597 */     // MIs[0] round
     /* 2091597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091600 */     // MIs[0] policy
     /* 2091600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091610 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2091613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091639 */     // GIR_Coverage, 16358,
     /* 2091639 */     GIR_EraseRootFromParent_Done,
     /* 2091640 */   // Label 27756: @2091640
     /* 2091640 */   GIM_Try, /*On fail goto*//*Label 27757*/ GIMT_Encode4(2091734), // Rule ID 16359 //
     /* 2091645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2091656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2091659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2091662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2091665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2091668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2091675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2091683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091691 */     // MIs[0] round
     /* 2091691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091694 */     // MIs[0] policy
     /* 2091694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091704 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2091707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2091727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091733 */     // GIR_Coverage, 16359,
     /* 2091733 */     GIR_EraseRootFromParent_Done,
     /* 2091734 */   // Label 27757: @2091734
     /* 2091734 */   GIM_Try, /*On fail goto*//*Label 27758*/ GIMT_Encode4(2091828), // Rule ID 16362 //
     /* 2091739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2091750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2091753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2091759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091785 */     // MIs[0] round
     /* 2091785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091788 */     // MIs[0] policy
     /* 2091788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091798 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2091801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091827 */     // GIR_Coverage, 16362,
     /* 2091827 */     GIR_EraseRootFromParent_Done,
     /* 2091828 */   // Label 27758: @2091828
     /* 2091828 */   GIM_Try, /*On fail goto*//*Label 27759*/ GIMT_Encode4(2091922), // Rule ID 16363 //
     /* 2091833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2091836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2091844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2091847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2091853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091879 */     // MIs[0] round
     /* 2091879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091882 */     // MIs[0] policy
     /* 2091882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091892 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2091895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2091920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091921 */     // GIR_Coverage, 16363,
     /* 2091921 */     GIR_EraseRootFromParent_Done,
     /* 2091922 */   // Label 27759: @2091922
     /* 2091922 */   GIM_Try, /*On fail goto*//*Label 27760*/ GIMT_Encode4(2092016), // Rule ID 16366 //
     /* 2091927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2091930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2091935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2091938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2091941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2091944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2091947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091973 */     // MIs[0] round
     /* 2091973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091976 */     // MIs[0] policy
     /* 2091976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091986 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2091989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092015 */     // GIR_Coverage, 16366,
     /* 2092015 */     GIR_EraseRootFromParent_Done,
     /* 2092016 */   // Label 27760: @2092016
     /* 2092016 */   GIM_Try, /*On fail goto*//*Label 27761*/ GIMT_Encode4(2092110), // Rule ID 16367 //
     /* 2092021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2092032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2092035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2092038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2092041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092067 */     // MIs[0] round
     /* 2092067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092070 */     // MIs[0] policy
     /* 2092070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092080 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092109 */     // GIR_Coverage, 16367,
     /* 2092109 */     GIR_EraseRootFromParent_Done,
     /* 2092110 */   // Label 27761: @2092110
     /* 2092110 */   GIM_Try, /*On fail goto*//*Label 27762*/ GIMT_Encode4(2092204), // Rule ID 16370 //
     /* 2092115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2092126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2092129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092161 */     // MIs[0] round
     /* 2092161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092164 */     // MIs[0] policy
     /* 2092164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092203 */     // GIR_Coverage, 16370,
     /* 2092203 */     GIR_EraseRootFromParent_Done,
     /* 2092204 */   // Label 27762: @2092204
     /* 2092204 */   GIM_Try, /*On fail goto*//*Label 27763*/ GIMT_Encode4(2092298), // Rule ID 16371 //
     /* 2092209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2092220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2092223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2092229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092255 */     // MIs[0] round
     /* 2092255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092258 */     // MIs[0] policy
     /* 2092258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092297 */     // GIR_Coverage, 16371,
     /* 2092297 */     GIR_EraseRootFromParent_Done,
     /* 2092298 */   // Label 27763: @2092298
     /* 2092298 */   GIM_Try, /*On fail goto*//*Label 27764*/ GIMT_Encode4(2092392), // Rule ID 16374 //
     /* 2092303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092349 */     // MIs[0] round
     /* 2092349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092352 */     // MIs[0] policy
     /* 2092352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2092365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092391 */     // GIR_Coverage, 16374,
     /* 2092391 */     GIR_EraseRootFromParent_Done,
     /* 2092392 */   // Label 27764: @2092392
     /* 2092392 */   GIM_Try, /*On fail goto*//*Label 27765*/ GIMT_Encode4(2092486), // Rule ID 16375 //
     /* 2092397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2092408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2092411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2092417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092443 */     // MIs[0] round
     /* 2092443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092446 */     // MIs[0] policy
     /* 2092446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092456 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2092459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092485 */     // GIR_Coverage, 16375,
     /* 2092485 */     GIR_EraseRootFromParent_Done,
     /* 2092486 */   // Label 27765: @2092486
     /* 2092486 */   GIM_Try, /*On fail goto*//*Label 27766*/ GIMT_Encode4(2092580), // Rule ID 16378 //
     /* 2092491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2092494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2092502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2092505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2092508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2092511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092537 */     // MIs[0] round
     /* 2092537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092540 */     // MIs[0] policy
     /* 2092540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092550 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2092553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092579 */     // GIR_Coverage, 16378,
     /* 2092579 */     GIR_EraseRootFromParent_Done,
     /* 2092580 */   // Label 27766: @2092580
     /* 2092580 */   GIM_Try, /*On fail goto*//*Label 27767*/ GIMT_Encode4(2092674), // Rule ID 16379 //
     /* 2092585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2092588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2092596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2092599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2092602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2092605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092631 */     // MIs[0] round
     /* 2092631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092634 */     // MIs[0] policy
     /* 2092634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2092647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092673 */     // GIR_Coverage, 16379,
     /* 2092673 */     GIR_EraseRootFromParent_Done,
     /* 2092674 */   // Label 27767: @2092674
     /* 2092674 */   GIM_Try, /*On fail goto*//*Label 27768*/ GIMT_Encode4(2092768), // Rule ID 16382 //
     /* 2092679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2092682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2092690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2092693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2092696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2092699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092725 */     // MIs[0] round
     /* 2092725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092728 */     // MIs[0] policy
     /* 2092728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092767 */     // GIR_Coverage, 16382,
     /* 2092767 */     GIR_EraseRootFromParent_Done,
     /* 2092768 */   // Label 27768: @2092768
     /* 2092768 */   GIM_Try, /*On fail goto*//*Label 27769*/ GIMT_Encode4(2092862), // Rule ID 16383 //
     /* 2092773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2092776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2092784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2092787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2092790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2092793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2092796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092819 */     // MIs[0] round
     /* 2092819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092822 */     // MIs[0] policy
     /* 2092822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092832 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2092835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092861 */     // GIR_Coverage, 16383,
     /* 2092861 */     GIR_EraseRootFromParent_Done,
     /* 2092862 */   // Label 27769: @2092862
     /* 2092862 */   GIM_Try, /*On fail goto*//*Label 27770*/ GIMT_Encode4(2092956), // Rule ID 16386 //
     /* 2092867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2092870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2092878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2092881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2092884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2092887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092913 */     // MIs[0] round
     /* 2092913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092916 */     // MIs[0] policy
     /* 2092916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092926 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2092929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2092954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092955 */     // GIR_Coverage, 16386,
     /* 2092955 */     GIR_EraseRootFromParent_Done,
     /* 2092956 */   // Label 27770: @2092956
     /* 2092956 */   GIM_Try, /*On fail goto*//*Label 27771*/ GIMT_Encode4(2093050), // Rule ID 16387 //
     /* 2092961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2092964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2092969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2092972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2092975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2092978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2092981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2092991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2092995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093007 */     // MIs[0] round
     /* 2093007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093010 */     // MIs[0] policy
     /* 2093010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2093023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093049 */     // GIR_Coverage, 16387,
     /* 2093049 */     GIR_EraseRootFromParent_Done,
     /* 2093050 */   // Label 27771: @2093050
     /* 2093050 */   GIM_Try, /*On fail goto*//*Label 27772*/ GIMT_Encode4(2093144), // Rule ID 16390 //
     /* 2093055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093101 */     // MIs[0] round
     /* 2093101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093104 */     // MIs[0] policy
     /* 2093104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2093117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093143 */     // GIR_Coverage, 16390,
     /* 2093143 */     GIR_EraseRootFromParent_Done,
     /* 2093144 */   // Label 27772: @2093144
     /* 2093144 */   GIM_Try, /*On fail goto*//*Label 27773*/ GIMT_Encode4(2093238), // Rule ID 16391 //
     /* 2093149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2093160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2093163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2093169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2093179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2093191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093195 */     // MIs[0] round
     /* 2093195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093198 */     // MIs[0] policy
     /* 2093198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093208 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2093211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093237 */     // GIR_Coverage, 16391,
     /* 2093237 */     GIR_EraseRootFromParent_Done,
     /* 2093238 */   // Label 27773: @2093238
     /* 2093238 */   GIM_Try, /*On fail goto*//*Label 27774*/ GIMT_Encode4(2093332), // Rule ID 16394 //
     /* 2093243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2093246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093289 */     // MIs[0] round
     /* 2093289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093292 */     // MIs[0] policy
     /* 2093292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093331 */     // GIR_Coverage, 16394,
     /* 2093331 */     GIR_EraseRootFromParent_Done,
     /* 2093332 */   // Label 27774: @2093332
     /* 2093332 */   GIM_Try, /*On fail goto*//*Label 27775*/ GIMT_Encode4(2093426), // Rule ID 16395 //
     /* 2093337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2093340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2093348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2093351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2093357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093383 */     // MIs[0] round
     /* 2093383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093386 */     // MIs[0] policy
     /* 2093386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2093399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093425 */     // GIR_Coverage, 16395,
     /* 2093425 */     GIR_EraseRootFromParent_Done,
     /* 2093426 */   // Label 27775: @2093426
     /* 2093426 */   GIM_Try, /*On fail goto*//*Label 27776*/ GIMT_Encode4(2093520), // Rule ID 16398 //
     /* 2093431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2093442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2093445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093477 */     // MIs[0] round
     /* 2093477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093480 */     // MIs[0] policy
     /* 2093480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2093493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093519 */     // GIR_Coverage, 16398,
     /* 2093519 */     GIR_EraseRootFromParent_Done,
     /* 2093520 */   // Label 27776: @2093520
     /* 2093520 */   GIM_Try, /*On fail goto*//*Label 27777*/ GIMT_Encode4(2093614), // Rule ID 16399 //
     /* 2093525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2093536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2093539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093571 */     // MIs[0] round
     /* 2093571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093574 */     // MIs[0] policy
     /* 2093574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093584 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2093587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093613 */     // GIR_Coverage, 16399,
     /* 2093613 */     GIR_EraseRootFromParent_Done,
     /* 2093614 */   // Label 27777: @2093614
     /* 2093614 */   GIM_Try, /*On fail goto*//*Label 27778*/ GIMT_Encode4(2093708), // Rule ID 16402 //
     /* 2093619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2093630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2093633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2093636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093665 */     // MIs[0] round
     /* 2093665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093668 */     // MIs[0] policy
     /* 2093668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093678 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2093681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093707 */     // GIR_Coverage, 16402,
     /* 2093707 */     GIR_EraseRootFromParent_Done,
     /* 2093708 */   // Label 27778: @2093708
     /* 2093708 */   GIM_Try, /*On fail goto*//*Label 27779*/ GIMT_Encode4(2093802), // Rule ID 16403 //
     /* 2093713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2093724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2093727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2093730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093759 */     // MIs[0] round
     /* 2093759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093762 */     // MIs[0] policy
     /* 2093762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093772 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2093775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093801 */     // GIR_Coverage, 16403,
     /* 2093801 */     GIR_EraseRootFromParent_Done,
     /* 2093802 */   // Label 27779: @2093802
     /* 2093802 */   GIM_Try, /*On fail goto*//*Label 27780*/ GIMT_Encode4(2093896), // Rule ID 16406 //
     /* 2093807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2093818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2093821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2093824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2093827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093853 */     // MIs[0] round
     /* 2093853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093856 */     // MIs[0] policy
     /* 2093856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093866 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2093869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093895 */     // GIR_Coverage, 16406,
     /* 2093895 */     GIR_EraseRootFromParent_Done,
     /* 2093896 */   // Label 27780: @2093896
     /* 2093896 */   GIM_Try, /*On fail goto*//*Label 27781*/ GIMT_Encode4(2093990), // Rule ID 16407 //
     /* 2093901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2093904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2093909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2093912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2093915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2093918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2093943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093947 */     // MIs[0] round
     /* 2093947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093950 */     // MIs[0] policy
     /* 2093950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093960 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2093963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2093983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2093988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093989 */     // GIR_Coverage, 16407,
     /* 2093989 */     GIR_EraseRootFromParent_Done,
     /* 2093990 */   // Label 27781: @2093990
     /* 2093990 */   GIM_Try, /*On fail goto*//*Label 27782*/ GIMT_Encode4(2094084), // Rule ID 16410 //
     /* 2093995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2093998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2094006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2094009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094041 */     // MIs[0] round
     /* 2094041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094044 */     // MIs[0] policy
     /* 2094044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094054 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2094057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094083 */     // GIR_Coverage, 16410,
     /* 2094083 */     GIR_EraseRootFromParent_Done,
     /* 2094084 */   // Label 27782: @2094084
     /* 2094084 */   GIM_Try, /*On fail goto*//*Label 27783*/ GIMT_Encode4(2094178), // Rule ID 16411 //
     /* 2094089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2094100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2094103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094135 */     // MIs[0] round
     /* 2094135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094138 */     // MIs[0] policy
     /* 2094138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094148 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11486:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2094151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094177 */     // GIR_Coverage, 16411,
     /* 2094177 */     GIR_EraseRootFromParent_Done,
     /* 2094178 */   // Label 27783: @2094178
     /* 2094178 */   GIM_Try, /*On fail goto*//*Label 27784*/ GIMT_Encode4(2094272), // Rule ID 16414 //
     /* 2094183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2094194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2094197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094229 */     // MIs[0] round
     /* 2094229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094232 */     // MIs[0] policy
     /* 2094232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094242 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2094245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094271 */     // GIR_Coverage, 16414,
     /* 2094271 */     GIR_EraseRootFromParent_Done,
     /* 2094272 */   // Label 27784: @2094272
     /* 2094272 */   GIM_Try, /*On fail goto*//*Label 27785*/ GIMT_Encode4(2094366), // Rule ID 16415 //
     /* 2094277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2094288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2094291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094323 */     // MIs[0] round
     /* 2094323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094326 */     // MIs[0] policy
     /* 2094326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094336 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2094339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094365 */     // GIR_Coverage, 16415,
     /* 2094365 */     GIR_EraseRootFromParent_Done,
     /* 2094366 */   // Label 27785: @2094366
     /* 2094366 */   GIM_Try, /*On fail goto*//*Label 27786*/ GIMT_Encode4(2094460), // Rule ID 16418 //
     /* 2094371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2094382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2094385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094417 */     // MIs[0] round
     /* 2094417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094420 */     // MIs[0] policy
     /* 2094420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094430 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2094433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094459 */     // GIR_Coverage, 16418,
     /* 2094459 */     GIR_EraseRootFromParent_Done,
     /* 2094460 */   // Label 27786: @2094460
     /* 2094460 */   GIM_Try, /*On fail goto*//*Label 27787*/ GIMT_Encode4(2094554), // Rule ID 16419 //
     /* 2094465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2094476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2094479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094511 */     // MIs[0] round
     /* 2094511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094514 */     // MIs[0] policy
     /* 2094514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094524 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2094527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2094547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094553 */     // GIR_Coverage, 16419,
     /* 2094553 */     GIR_EraseRootFromParent_Done,
     /* 2094554 */   // Label 27787: @2094554
     /* 2094554 */   GIM_Try, /*On fail goto*//*Label 27788*/ GIMT_Encode4(2094648), // Rule ID 16422 //
     /* 2094559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2094570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2094573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2094576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094605 */     // MIs[0] round
     /* 2094605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094608 */     // MIs[0] policy
     /* 2094608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094618 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2094621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094647 */     // GIR_Coverage, 16422,
     /* 2094647 */     GIR_EraseRootFromParent_Done,
     /* 2094648 */   // Label 27788: @2094648
     /* 2094648 */   GIM_Try, /*On fail goto*//*Label 27789*/ GIMT_Encode4(2094742), // Rule ID 16423 //
     /* 2094653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2094664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2094667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2094670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094699 */     // MIs[0] round
     /* 2094699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094702 */     // MIs[0] policy
     /* 2094702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094712 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2094715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094741 */     // GIR_Coverage, 16423,
     /* 2094741 */     GIR_EraseRootFromParent_Done,
     /* 2094742 */   // Label 27789: @2094742
     /* 2094742 */   GIM_Try, /*On fail goto*//*Label 27790*/ GIMT_Encode4(2094836), // Rule ID 16426 //
     /* 2094747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2094758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2094761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2094764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094793 */     // MIs[0] round
     /* 2094793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094796 */     // MIs[0] policy
     /* 2094796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094806 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2094809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094835 */     // GIR_Coverage, 16426,
     /* 2094835 */     GIR_EraseRootFromParent_Done,
     /* 2094836 */   // Label 27790: @2094836
     /* 2094836 */   GIM_Try, /*On fail goto*//*Label 27791*/ GIMT_Encode4(2094930), // Rule ID 16427 //
     /* 2094841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2094844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2094852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2094855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2094858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094887 */     // MIs[0] round
     /* 2094887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094890 */     // MIs[0] policy
     /* 2094890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2094903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2094928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094929 */     // GIR_Coverage, 16427,
     /* 2094929 */     GIR_EraseRootFromParent_Done,
     /* 2094930 */   // Label 27791: @2094930
     /* 2094930 */   GIM_Try, /*On fail goto*//*Label 27792*/ GIMT_Encode4(2095024), // Rule ID 16430 //
     /* 2094935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2094938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2094943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2094946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2094949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2094952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2094977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094981 */     // MIs[0] round
     /* 2094981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094984 */     // MIs[0] policy
     /* 2094984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2094997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095023 */     // GIR_Coverage, 16430,
     /* 2095023 */     GIR_EraseRootFromParent_Done,
     /* 2095024 */   // Label 27792: @2095024
     /* 2095024 */   GIM_Try, /*On fail goto*//*Label 27793*/ GIMT_Encode4(2095118), // Rule ID 16431 //
     /* 2095029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2095040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2095043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2095046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095075 */     // MIs[0] round
     /* 2095075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095078 */     // MIs[0] policy
     /* 2095078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095088 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11486:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095117 */     // GIR_Coverage, 16431,
     /* 2095117 */     GIR_EraseRootFromParent_Done,
     /* 2095118 */   // Label 27793: @2095118
     /* 2095118 */   GIM_Try, /*On fail goto*//*Label 27794*/ GIMT_Encode4(2095212), // Rule ID 16434 //
     /* 2095123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2095134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2095137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095169 */     // MIs[0] round
     /* 2095169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095172 */     // MIs[0] policy
     /* 2095172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095211 */     // GIR_Coverage, 16434,
     /* 2095211 */     GIR_EraseRootFromParent_Done,
     /* 2095212 */   // Label 27794: @2095212
     /* 2095212 */   GIM_Try, /*On fail goto*//*Label 27795*/ GIMT_Encode4(2095306), // Rule ID 16435 //
     /* 2095217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2095228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2095231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095263 */     // MIs[0] round
     /* 2095263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095266 */     // MIs[0] policy
     /* 2095266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095276 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095305 */     // GIR_Coverage, 16435,
     /* 2095305 */     GIR_EraseRootFromParent_Done,
     /* 2095306 */   // Label 27795: @2095306
     /* 2095306 */   GIM_Try, /*On fail goto*//*Label 27796*/ GIMT_Encode4(2095400), // Rule ID 16438 //
     /* 2095311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2095314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2095322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2095325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095357 */     // MIs[0] round
     /* 2095357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095360 */     // MIs[0] policy
     /* 2095360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095370 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2095373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095399 */     // GIR_Coverage, 16438,
     /* 2095399 */     GIR_EraseRootFromParent_Done,
     /* 2095400 */   // Label 27796: @2095400
     /* 2095400 */   GIM_Try, /*On fail goto*//*Label 27797*/ GIMT_Encode4(2095494), // Rule ID 16439 //
     /* 2095405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2095408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2095416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2095419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095451 */     // MIs[0] round
     /* 2095451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095454 */     // MIs[0] policy
     /* 2095454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2095467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095493 */     // GIR_Coverage, 16439,
     /* 2095493 */     GIR_EraseRootFromParent_Done,
     /* 2095494 */   // Label 27797: @2095494
     /* 2095494 */   GIM_Try, /*On fail goto*//*Label 27798*/ GIMT_Encode4(2095588), // Rule ID 16442 //
     /* 2095499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2095502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2095516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095545 */     // MIs[0] round
     /* 2095545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095548 */     // MIs[0] policy
     /* 2095548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095558 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2095561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095587 */     // GIR_Coverage, 16442,
     /* 2095587 */     GIR_EraseRootFromParent_Done,
     /* 2095588 */   // Label 27798: @2095588
     /* 2095588 */   GIM_Try, /*On fail goto*//*Label 27799*/ GIMT_Encode4(2095682), // Rule ID 16443 //
     /* 2095593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2095596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2095604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2095607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2095610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2095616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095639 */     // MIs[0] round
     /* 2095639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095642 */     // MIs[0] policy
     /* 2095642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2095655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095681 */     // GIR_Coverage, 16443,
     /* 2095681 */     GIR_EraseRootFromParent_Done,
     /* 2095682 */   // Label 27799: @2095682
     /* 2095682 */   GIM_Try, /*On fail goto*//*Label 27800*/ GIMT_Encode4(2095776), // Rule ID 16446 //
     /* 2095687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2095690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2095698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2095701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2095704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095733 */     // MIs[0] round
     /* 2095733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095736 */     // MIs[0] policy
     /* 2095736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095746 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095775 */     // GIR_Coverage, 16446,
     /* 2095775 */     GIR_EraseRootFromParent_Done,
     /* 2095776 */   // Label 27800: @2095776
     /* 2095776 */   GIM_Try, /*On fail goto*//*Label 27801*/ GIMT_Encode4(2095870), // Rule ID 16447 //
     /* 2095781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2095784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2095792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2095795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2095798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2095811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2095815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095827 */     // MIs[0] round
     /* 2095827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095830 */     // MIs[0] policy
     /* 2095830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11486:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2095843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095869 */     // GIR_Coverage, 16447,
     /* 2095869 */     GIR_EraseRootFromParent_Done,
     /* 2095870 */   // Label 27801: @2095870
     /* 2095870 */   GIM_Try, /*On fail goto*//*Label 27802*/ GIMT_Encode4(2095964), // Rule ID 16450 //
     /* 2095875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2095878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2095886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2095889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2095892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2095917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095921 */     // MIs[0] round
     /* 2095921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095924 */     // MIs[0] policy
     /* 2095924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2095937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2095962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095963 */     // GIR_Coverage, 16450,
     /* 2095963 */     GIR_EraseRootFromParent_Done,
     /* 2095964 */   // Label 27802: @2095964
     /* 2095964 */   GIM_Try, /*On fail goto*//*Label 27803*/ GIMT_Encode4(2096058), // Rule ID 16451 //
     /* 2095969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2095972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2095977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2095980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2095983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2095986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096015 */     // MIs[0] round
     /* 2096015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096018 */     // MIs[0] policy
     /* 2096018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11486:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2096031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096057 */     // GIR_Coverage, 16451,
     /* 2096057 */     GIR_EraseRootFromParent_Done,
     /* 2096058 */   // Label 27803: @2096058
     /* 2096058 */   GIM_Try, /*On fail goto*//*Label 27804*/ GIMT_Encode4(2096152), // Rule ID 16454 //
     /* 2096063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2096066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2096080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2096083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096109 */     // MIs[0] round
     /* 2096109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096112 */     // MIs[0] policy
     /* 2096112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096122 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2096125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096151 */     // GIR_Coverage, 16454,
     /* 2096151 */     GIR_EraseRootFromParent_Done,
     /* 2096152 */   // Label 27804: @2096152
     /* 2096152 */   GIM_Try, /*On fail goto*//*Label 27805*/ GIMT_Encode4(2096246), // Rule ID 16455 //
     /* 2096157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2096160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2096165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2096168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2096171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2096174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2096177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2096187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2096191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2096199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096203 */     // MIs[0] round
     /* 2096203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096206 */     // MIs[0] policy
     /* 2096206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11486:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2096219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096245 */     // GIR_Coverage, 16455,
     /* 2096245 */     GIR_EraseRootFromParent_Done,
     /* 2096246 */   // Label 27805: @2096246
     /* 2096246 */   GIM_Try, /*On fail goto*//*Label 27806*/ GIMT_Encode4(2096340), // Rule ID 16518 //
     /* 2096251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2096271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096297 */     // MIs[0] round
     /* 2096297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096300 */     // MIs[0] policy
     /* 2096300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096310 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2096313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096339 */     // GIR_Coverage, 16518,
     /* 2096339 */     GIR_EraseRootFromParent_Done,
     /* 2096340 */   // Label 27806: @2096340
     /* 2096340 */   GIM_Try, /*On fail goto*//*Label 27807*/ GIMT_Encode4(2096434), // Rule ID 16519 //
     /* 2096345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2096356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2096359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2096365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096391 */     // MIs[0] round
     /* 2096391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096394 */     // MIs[0] policy
     /* 2096394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096404 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2096407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096433 */     // GIR_Coverage, 16519,
     /* 2096433 */     GIR_EraseRootFromParent_Done,
     /* 2096434 */   // Label 27807: @2096434
     /* 2096434 */   GIM_Try, /*On fail goto*//*Label 27808*/ GIMT_Encode4(2096528), // Rule ID 16522 //
     /* 2096439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2096450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2096453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2096456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2096459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096485 */     // MIs[0] round
     /* 2096485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096488 */     // MIs[0] policy
     /* 2096488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096498 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2096501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096527 */     // GIR_Coverage, 16522,
     /* 2096527 */     GIR_EraseRootFromParent_Done,
     /* 2096528 */   // Label 27808: @2096528
     /* 2096528 */   GIM_Try, /*On fail goto*//*Label 27809*/ GIMT_Encode4(2096622), // Rule ID 16523 //
     /* 2096533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2096544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2096547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2096550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2096553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096579 */     // MIs[0] round
     /* 2096579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096582 */     // MIs[0] policy
     /* 2096582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2096595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096621 */     // GIR_Coverage, 16523,
     /* 2096621 */     GIR_EraseRootFromParent_Done,
     /* 2096622 */   // Label 27809: @2096622
     /* 2096622 */   GIM_Try, /*On fail goto*//*Label 27810*/ GIMT_Encode4(2096716), // Rule ID 16526 //
     /* 2096627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2096638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2096641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2096644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2096647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096673 */     // MIs[0] round
     /* 2096673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096676 */     // MIs[0] policy
     /* 2096676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096686 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2096689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096715 */     // GIR_Coverage, 16526,
     /* 2096715 */     GIR_EraseRootFromParent_Done,
     /* 2096716 */   // Label 27810: @2096716
     /* 2096716 */   GIM_Try, /*On fail goto*//*Label 27811*/ GIMT_Encode4(2096810), // Rule ID 16527 //
     /* 2096721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2096732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2096735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2096738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2096741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096767 */     // MIs[0] round
     /* 2096767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096770 */     // MIs[0] policy
     /* 2096770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096780 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2096783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096809 */     // GIR_Coverage, 16527,
     /* 2096809 */     GIR_EraseRootFromParent_Done,
     /* 2096810 */   // Label 27811: @2096810
     /* 2096810 */   GIM_Try, /*On fail goto*//*Label 27812*/ GIMT_Encode4(2096904), // Rule ID 16530 //
     /* 2096815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2096818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2096826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2096829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2096832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2096835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096861 */     // MIs[0] round
     /* 2096861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096864 */     // MIs[0] policy
     /* 2096864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2096877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096903 */     // GIR_Coverage, 16530,
     /* 2096903 */     GIR_EraseRootFromParent_Done,
     /* 2096904 */   // Label 27812: @2096904
     /* 2096904 */   GIM_Try, /*On fail goto*//*Label 27813*/ GIMT_Encode4(2096998), // Rule ID 16531 //
     /* 2096909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2096912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2096917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2096920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2096923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2096926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2096929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2096947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096955 */     // MIs[0] round
     /* 2096955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096958 */     // MIs[0] policy
     /* 2096958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096968 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2096971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2096991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2096996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096997 */     // GIR_Coverage, 16531,
     /* 2096997 */     GIR_EraseRootFromParent_Done,
     /* 2096998 */   // Label 27813: @2096998
     /* 2096998 */   GIM_Try, /*On fail goto*//*Label 27814*/ GIMT_Encode4(2097092), // Rule ID 16534 //
     /* 2097003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2097023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097049 */     // MIs[0] round
     /* 2097049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097052 */     // MIs[0] policy
     /* 2097052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097062 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2097065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097091 */     // GIR_Coverage, 16534,
     /* 2097091 */     GIR_EraseRootFromParent_Done,
     /* 2097092 */   // Label 27814: @2097092
     /* 2097092 */   GIM_Try, /*On fail goto*//*Label 27815*/ GIMT_Encode4(2097186), // Rule ID 16535 //
     /* 2097097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2097108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2097111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2097117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097143 */     // MIs[0] round
     /* 2097143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097146 */     // MIs[0] policy
     /* 2097146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097156 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2097159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097185 */     // GIR_Coverage, 16535,
     /* 2097185 */     GIR_EraseRootFromParent_Done,
     /* 2097186 */   // Label 27815: @2097186
     /* 2097186 */   GIM_Try, /*On fail goto*//*Label 27816*/ GIMT_Encode4(2097280), // Rule ID 16538 //
     /* 2097191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2097202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2097205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2097211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097237 */     // MIs[0] round
     /* 2097237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097240 */     // MIs[0] policy
     /* 2097240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097250 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2097253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097279 */     // GIR_Coverage, 16538,
     /* 2097279 */     GIR_EraseRootFromParent_Done,
     /* 2097280 */   // Label 27816: @2097280
     /* 2097280 */   GIM_Try, /*On fail goto*//*Label 27817*/ GIMT_Encode4(2097374), // Rule ID 16539 //
     /* 2097285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2097296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2097299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2097305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097331 */     // MIs[0] round
     /* 2097331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097334 */     // MIs[0] policy
     /* 2097334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097344 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2097347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2097367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097373 */     // GIR_Coverage, 16539,
     /* 2097373 */     GIR_EraseRootFromParent_Done,
     /* 2097374 */   // Label 27817: @2097374
     /* 2097374 */   GIM_Try, /*On fail goto*//*Label 27818*/ GIMT_Encode4(2097468), // Rule ID 16542 //
     /* 2097379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2097399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097425 */     // MIs[0] round
     /* 2097425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097428 */     // MIs[0] policy
     /* 2097428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2097441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097467 */     // GIR_Coverage, 16542,
     /* 2097467 */     GIR_EraseRootFromParent_Done,
     /* 2097468 */   // Label 27818: @2097468
     /* 2097468 */   GIM_Try, /*On fail goto*//*Label 27819*/ GIMT_Encode4(2097562), // Rule ID 16543 //
     /* 2097473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2097484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2097487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2097490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2097493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097519 */     // MIs[0] round
     /* 2097519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097522 */     // MIs[0] policy
     /* 2097522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097532 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2097535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097561 */     // GIR_Coverage, 16543,
     /* 2097561 */     GIR_EraseRootFromParent_Done,
     /* 2097562 */   // Label 27819: @2097562
     /* 2097562 */   GIM_Try, /*On fail goto*//*Label 27820*/ GIMT_Encode4(2097656), // Rule ID 16546 //
     /* 2097567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2097578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2097581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2097584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2097587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097613 */     // MIs[0] round
     /* 2097613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097616 */     // MIs[0] policy
     /* 2097616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2097629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097655 */     // GIR_Coverage, 16546,
     /* 2097655 */     GIR_EraseRootFromParent_Done,
     /* 2097656 */   // Label 27820: @2097656
     /* 2097656 */   GIM_Try, /*On fail goto*//*Label 27821*/ GIMT_Encode4(2097750), // Rule ID 16547 //
     /* 2097661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2097672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2097675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2097678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2097681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2097684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097707 */     // MIs[0] round
     /* 2097707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097710 */     // MIs[0] policy
     /* 2097710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2097723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097749 */     // GIR_Coverage, 16547,
     /* 2097749 */     GIR_EraseRootFromParent_Done,
     /* 2097750 */   // Label 27821: @2097750
     /* 2097750 */   GIM_Try, /*On fail goto*//*Label 27822*/ GIMT_Encode4(2097844), // Rule ID 16550 //
     /* 2097755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2097766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2097769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2097772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2097775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097801 */     // MIs[0] round
     /* 2097801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097804 */     // MIs[0] policy
     /* 2097804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2097817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097843 */     // GIR_Coverage, 16550,
     /* 2097843 */     GIR_EraseRootFromParent_Done,
     /* 2097844 */   // Label 27822: @2097844
     /* 2097844 */   GIM_Try, /*On fail goto*//*Label 27823*/ GIMT_Encode4(2097938), // Rule ID 16551 //
     /* 2097849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2097852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2097860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2097863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2097866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2097869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097895 */     // MIs[0] round
     /* 2097895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097898 */     // MIs[0] policy
     /* 2097898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2097911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2097936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097937 */     // GIR_Coverage, 16551,
     /* 2097937 */     GIR_EraseRootFromParent_Done,
     /* 2097938 */   // Label 27823: @2097938
     /* 2097938 */   GIM_Try, /*On fail goto*//*Label 27824*/ GIMT_Encode4(2098032), // Rule ID 16554 //
     /* 2097943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2097946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2097951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2097954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2097957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2097960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2097963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097989 */     // MIs[0] round
     /* 2097989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097992 */     // MIs[0] policy
     /* 2097992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098027 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098031 */     // GIR_Coverage, 16554,
     /* 2098031 */     GIR_EraseRootFromParent_Done,
     /* 2098032 */   // Label 27824: @2098032
     /* 2098032 */   GIM_Try, /*On fail goto*//*Label 27825*/ GIMT_Encode4(2098126), // Rule ID 16555 //
     /* 2098037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2098048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2098051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2098057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098083 */     // MIs[0] round
     /* 2098083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098086 */     // MIs[0] policy
     /* 2098086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098125 */     // GIR_Coverage, 16555,
     /* 2098125 */     GIR_EraseRootFromParent_Done,
     /* 2098126 */   // Label 27825: @2098126
     /* 2098126 */   GIM_Try, /*On fail goto*//*Label 27826*/ GIMT_Encode4(2098220), // Rule ID 16558 //
     /* 2098131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2098134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2098142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2098145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2098151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098177 */     // MIs[0] round
     /* 2098177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098180 */     // MIs[0] policy
     /* 2098180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098190 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098219 */     // GIR_Coverage, 16558,
     /* 2098219 */     GIR_EraseRootFromParent_Done,
     /* 2098220 */   // Label 27826: @2098220
     /* 2098220 */   GIM_Try, /*On fail goto*//*Label 27827*/ GIMT_Encode4(2098314), // Rule ID 16559 //
     /* 2098225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2098228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2098236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2098239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2098245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098271 */     // MIs[0] round
     /* 2098271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098274 */     // MIs[0] policy
     /* 2098274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098313 */     // GIR_Coverage, 16559,
     /* 2098313 */     GIR_EraseRootFromParent_Done,
     /* 2098314 */   // Label 27827: @2098314
     /* 2098314 */   GIM_Try, /*On fail goto*//*Label 27828*/ GIMT_Encode4(2098408), // Rule ID 16562 //
     /* 2098319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2098339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098365 */     // MIs[0] round
     /* 2098365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098368 */     // MIs[0] policy
     /* 2098368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098407 */     // GIR_Coverage, 16562,
     /* 2098407 */     GIR_EraseRootFromParent_Done,
     /* 2098408 */   // Label 27828: @2098408
     /* 2098408 */   GIM_Try, /*On fail goto*//*Label 27829*/ GIMT_Encode4(2098502), // Rule ID 16563 //
     /* 2098413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2098424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2098427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2098430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2098433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098459 */     // MIs[0] round
     /* 2098459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098462 */     // MIs[0] policy
     /* 2098462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098472 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2098475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098501 */     // GIR_Coverage, 16563,
     /* 2098501 */     GIR_EraseRootFromParent_Done,
     /* 2098502 */   // Label 27829: @2098502
     /* 2098502 */   GIM_Try, /*On fail goto*//*Label 27830*/ GIMT_Encode4(2098596), // Rule ID 16566 //
     /* 2098507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2098518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2098521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2098524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2098527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098553 */     // MIs[0] round
     /* 2098553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098556 */     // MIs[0] policy
     /* 2098556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2098569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098595 */     // GIR_Coverage, 16566,
     /* 2098595 */     GIR_EraseRootFromParent_Done,
     /* 2098596 */   // Label 27830: @2098596
     /* 2098596 */   GIM_Try, /*On fail goto*//*Label 27831*/ GIMT_Encode4(2098690), // Rule ID 16567 //
     /* 2098601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2098612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2098615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2098618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2098621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098647 */     // MIs[0] round
     /* 2098647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098650 */     // MIs[0] policy
     /* 2098650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098660 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2098663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098689 */     // GIR_Coverage, 16567,
     /* 2098689 */     GIR_EraseRootFromParent_Done,
     /* 2098690 */   // Label 27831: @2098690
     /* 2098690 */   GIM_Try, /*On fail goto*//*Label 27832*/ GIMT_Encode4(2098784), // Rule ID 16570 //
     /* 2098695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2098706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2098709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2098712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2098715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098741 */     // MIs[0] round
     /* 2098741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098744 */     // MIs[0] policy
     /* 2098744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098783 */     // GIR_Coverage, 16570,
     /* 2098783 */     GIR_EraseRootFromParent_Done,
     /* 2098784 */   // Label 27832: @2098784
     /* 2098784 */   GIM_Try, /*On fail goto*//*Label 27833*/ GIMT_Encode4(2098878), // Rule ID 16571 //
     /* 2098789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2098800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2098803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2098806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2098809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098835 */     // MIs[0] round
     /* 2098835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098838 */     // MIs[0] policy
     /* 2098838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2098851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098877 */     // GIR_Coverage, 16571,
     /* 2098877 */     GIR_EraseRootFromParent_Done,
     /* 2098878 */   // Label 27833: @2098878
     /* 2098878 */   GIM_Try, /*On fail goto*//*Label 27834*/ GIMT_Encode4(2098972), // Rule ID 16574 //
     /* 2098883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2098886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2098894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2098897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2098900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2098903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098929 */     // MIs[0] round
     /* 2098929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098932 */     // MIs[0] policy
     /* 2098932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098942 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2098945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2098970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098971 */     // GIR_Coverage, 16574,
     /* 2098971 */     GIR_EraseRootFromParent_Done,
     /* 2098972 */   // Label 27834: @2098972
     /* 2098972 */   GIM_Try, /*On fail goto*//*Label 27835*/ GIMT_Encode4(2099066), // Rule ID 16575 //
     /* 2098977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2098980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2098985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2098988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2098991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2098994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2098997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2099007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2099015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099023 */     // MIs[0] round
     /* 2099023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099026 */     // MIs[0] policy
     /* 2099026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099036 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2099039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099065 */     // GIR_Coverage, 16575,
     /* 2099065 */     GIR_EraseRootFromParent_Done,
     /* 2099066 */   // Label 27835: @2099066
     /* 2099066 */   GIM_Try, /*On fail goto*//*Label 27836*/ GIMT_Encode4(2099160), // Rule ID 16578 //
     /* 2099071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2099082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2099085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2099088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099117 */     // MIs[0] round
     /* 2099117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099120 */     // MIs[0] policy
     /* 2099120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099130 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2099133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099159 */     // GIR_Coverage, 16578,
     /* 2099159 */     GIR_EraseRootFromParent_Done,
     /* 2099160 */   // Label 27836: @2099160
     /* 2099160 */   GIM_Try, /*On fail goto*//*Label 27837*/ GIMT_Encode4(2099254), // Rule ID 16579 //
     /* 2099165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2099176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2099179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2099182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099211 */     // MIs[0] round
     /* 2099211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099214 */     // MIs[0] policy
     /* 2099214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099224 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2099227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099253 */     // GIR_Coverage, 16579,
     /* 2099253 */     GIR_EraseRootFromParent_Done,
     /* 2099254 */   // Label 27837: @2099254
     /* 2099254 */   GIM_Try, /*On fail goto*//*Label 27838*/ GIMT_Encode4(2099348), // Rule ID 16582 //
     /* 2099259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2099270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2099273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099305 */     // MIs[0] round
     /* 2099305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099308 */     // MIs[0] policy
     /* 2099308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099318 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2099321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099347 */     // GIR_Coverage, 16582,
     /* 2099347 */     GIR_EraseRootFromParent_Done,
     /* 2099348 */   // Label 27838: @2099348
     /* 2099348 */   GIM_Try, /*On fail goto*//*Label 27839*/ GIMT_Encode4(2099442), // Rule ID 16583 //
     /* 2099353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2099364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2099367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099399 */     // MIs[0] round
     /* 2099399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099402 */     // MIs[0] policy
     /* 2099402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099412 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2099415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099437 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099441 */     // GIR_Coverage, 16583,
     /* 2099441 */     GIR_EraseRootFromParent_Done,
     /* 2099442 */   // Label 27839: @2099442
     /* 2099442 */   GIM_Try, /*On fail goto*//*Label 27840*/ GIMT_Encode4(2099536), // Rule ID 16586 //
     /* 2099447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2099458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2099461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2099464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099493 */     // MIs[0] round
     /* 2099493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099496 */     // MIs[0] policy
     /* 2099496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099506 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2099509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099535 */     // GIR_Coverage, 16586,
     /* 2099535 */     GIR_EraseRootFromParent_Done,
     /* 2099536 */   // Label 27840: @2099536
     /* 2099536 */   GIM_Try, /*On fail goto*//*Label 27841*/ GIMT_Encode4(2099630), // Rule ID 16587 //
     /* 2099541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2099552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2099555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2099558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099587 */     // MIs[0] round
     /* 2099587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099590 */     // MIs[0] policy
     /* 2099590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099600 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2099603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099629 */     // GIR_Coverage, 16587,
     /* 2099629 */     GIR_EraseRootFromParent_Done,
     /* 2099630 */   // Label 27841: @2099630
     /* 2099630 */   GIM_Try, /*On fail goto*//*Label 27842*/ GIMT_Encode4(2099724), // Rule ID 16590 //
     /* 2099635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2099646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2099649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2099652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099681 */     // MIs[0] round
     /* 2099681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099684 */     // MIs[0] policy
     /* 2099684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099694 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2099697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099723 */     // GIR_Coverage, 16590,
     /* 2099723 */     GIR_EraseRootFromParent_Done,
     /* 2099724 */   // Label 27842: @2099724
     /* 2099724 */   GIM_Try, /*On fail goto*//*Label 27843*/ GIMT_Encode4(2099818), // Rule ID 16591 //
     /* 2099729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2099740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2099743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2099746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099775 */     // MIs[0] round
     /* 2099775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099778 */     // MIs[0] policy
     /* 2099778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2099791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099817 */     // GIR_Coverage, 16591,
     /* 2099817 */     GIR_EraseRootFromParent_Done,
     /* 2099818 */   // Label 27843: @2099818
     /* 2099818 */   GIM_Try, /*On fail goto*//*Label 27844*/ GIMT_Encode4(2099912), // Rule ID 16594 //
     /* 2099823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2099826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2099834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2099837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2099840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099869 */     // MIs[0] round
     /* 2099869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099872 */     // MIs[0] policy
     /* 2099872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099882 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2099885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2099910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099911 */     // GIR_Coverage, 16594,
     /* 2099911 */     GIR_EraseRootFromParent_Done,
     /* 2099912 */   // Label 27844: @2099912
     /* 2099912 */   GIM_Try, /*On fail goto*//*Label 27845*/ GIMT_Encode4(2100006), // Rule ID 16595 //
     /* 2099917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2099920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2099925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2099928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2099931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2099934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2099940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2099955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2099959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099963 */     // MIs[0] round
     /* 2099963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099966 */     // MIs[0] policy
     /* 2099966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099976 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2099979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2099999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100005 */     // GIR_Coverage, 16595,
     /* 2100005 */     GIR_EraseRootFromParent_Done,
     /* 2100006 */   // Label 27845: @2100006
     /* 2100006 */   GIM_Try, /*On fail goto*//*Label 27846*/ GIMT_Encode4(2100100), // Rule ID 16598 //
     /* 2100011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2100022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2100025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100057 */     // MIs[0] round
     /* 2100057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100060 */     // MIs[0] policy
     /* 2100060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100070 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2100073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100099 */     // GIR_Coverage, 16598,
     /* 2100099 */     GIR_EraseRootFromParent_Done,
     /* 2100100 */   // Label 27846: @2100100
     /* 2100100 */   GIM_Try, /*On fail goto*//*Label 27847*/ GIMT_Encode4(2100194), // Rule ID 16599 //
     /* 2100105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2100116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2100119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100151 */     // MIs[0] round
     /* 2100151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100154 */     // MIs[0] policy
     /* 2100154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100164 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2100167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2100187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100189 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100193 */     // GIR_Coverage, 16599,
     /* 2100193 */     GIR_EraseRootFromParent_Done,
     /* 2100194 */   // Label 27847: @2100194
     /* 2100194 */   GIM_Try, /*On fail goto*//*Label 27848*/ GIMT_Encode4(2100288), // Rule ID 16602 //
     /* 2100199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100245 */     // MIs[0] round
     /* 2100245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100248 */     // MIs[0] policy
     /* 2100248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100258 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2100261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100287 */     // GIR_Coverage, 16602,
     /* 2100287 */     GIR_EraseRootFromParent_Done,
     /* 2100288 */   // Label 27848: @2100288
     /* 2100288 */   GIM_Try, /*On fail goto*//*Label 27849*/ GIMT_Encode4(2100382), // Rule ID 16603 //
     /* 2100293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2100304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2100307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2100310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2100316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100339 */     // MIs[0] round
     /* 2100339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100342 */     // MIs[0] policy
     /* 2100342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100352 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2100355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100381 */     // GIR_Coverage, 16603,
     /* 2100381 */     GIR_EraseRootFromParent_Done,
     /* 2100382 */   // Label 27849: @2100382
     /* 2100382 */   GIM_Try, /*On fail goto*//*Label 27850*/ GIMT_Encode4(2100476), // Rule ID 16606 //
     /* 2100387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2100404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100433 */     // MIs[0] round
     /* 2100433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100436 */     // MIs[0] policy
     /* 2100436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100446 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2100449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100471 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100475 */     // GIR_Coverage, 16606,
     /* 2100475 */     GIR_EraseRootFromParent_Done,
     /* 2100476 */   // Label 27850: @2100476
     /* 2100476 */   GIM_Try, /*On fail goto*//*Label 27851*/ GIMT_Encode4(2100570), // Rule ID 16607 //
     /* 2100481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2100492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2100495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2100498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2100504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100527 */     // MIs[0] round
     /* 2100527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100530 */     // MIs[0] policy
     /* 2100530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2100543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100569 */     // GIR_Coverage, 16607,
     /* 2100569 */     GIR_EraseRootFromParent_Done,
     /* 2100570 */   // Label 27851: @2100570
     /* 2100570 */   GIM_Try, /*On fail goto*//*Label 27852*/ GIMT_Encode4(2100664), // Rule ID 16610 //
     /* 2100575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2100586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2100589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2100592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100621 */     // MIs[0] round
     /* 2100621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100624 */     // MIs[0] policy
     /* 2100624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100634 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2100637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100663 */     // GIR_Coverage, 16610,
     /* 2100663 */     GIR_EraseRootFromParent_Done,
     /* 2100664 */   // Label 27852: @2100664
     /* 2100664 */   GIM_Try, /*On fail goto*//*Label 27853*/ GIMT_Encode4(2100758), // Rule ID 16611 //
     /* 2100669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2100680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2100683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2100686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2100699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2100703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100715 */     // MIs[0] round
     /* 2100715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100718 */     // MIs[0] policy
     /* 2100718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100728 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2100731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100757 */     // GIR_Coverage, 16611,
     /* 2100757 */     GIR_EraseRootFromParent_Done,
     /* 2100758 */   // Label 27853: @2100758
     /* 2100758 */   GIM_Try, /*On fail goto*//*Label 27854*/ GIMT_Encode4(2100852), // Rule ID 16614 //
     /* 2100763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2100774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2100777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2100780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100809 */     // MIs[0] round
     /* 2100809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100812 */     // MIs[0] policy
     /* 2100812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2100825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100851 */     // GIR_Coverage, 16614,
     /* 2100851 */     GIR_EraseRootFromParent_Done,
     /* 2100852 */   // Label 27854: @2100852
     /* 2100852 */   GIM_Try, /*On fail goto*//*Label 27855*/ GIMT_Encode4(2100946), // Rule ID 16615 //
     /* 2100857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2100860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2100868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2100871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2100874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100903 */     // MIs[0] round
     /* 2100903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100906 */     // MIs[0] policy
     /* 2100906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2100919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2100944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100945 */     // GIR_Coverage, 16615,
     /* 2100945 */     GIR_EraseRootFromParent_Done,
     /* 2100946 */   // Label 27855: @2100946
     /* 2100946 */   GIM_Try, /*On fail goto*//*Label 27856*/ GIMT_Encode4(2101040), // Rule ID 16618 //
     /* 2100951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2100954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2100959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2100962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2100965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2100968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2100971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2100993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100997 */     // MIs[0] round
     /* 2100997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101000 */     // MIs[0] policy
     /* 2101000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101039 */     // GIR_Coverage, 16618,
     /* 2101039 */     GIR_EraseRootFromParent_Done,
     /* 2101040 */   // Label 27856: @2101040
     /* 2101040 */   GIM_Try, /*On fail goto*//*Label 27857*/ GIMT_Encode4(2101134), // Rule ID 16619 //
     /* 2101045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2101048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2101056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2101059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2101062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2101068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101091 */     // MIs[0] round
     /* 2101091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101094 */     // MIs[0] policy
     /* 2101094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101104 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101133 */     // GIR_Coverage, 16619,
     /* 2101133 */     GIR_EraseRootFromParent_Done,
     /* 2101134 */   // Label 27857: @2101134
     /* 2101134 */   GIM_Try, /*On fail goto*//*Label 27858*/ GIMT_Encode4(2101228), // Rule ID 16622 //
     /* 2101139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2101150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2101153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101185 */     // MIs[0] round
     /* 2101185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101188 */     // MIs[0] policy
     /* 2101188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101198 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101227 */     // GIR_Coverage, 16622,
     /* 2101227 */     GIR_EraseRootFromParent_Done,
     /* 2101228 */   // Label 27858: @2101228
     /* 2101228 */   GIM_Try, /*On fail goto*//*Label 27859*/ GIMT_Encode4(2101322), // Rule ID 16623 //
     /* 2101233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2101244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2101247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2101250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101279 */     // MIs[0] round
     /* 2101279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101282 */     // MIs[0] policy
     /* 2101282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101292 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2101295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101317 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101321 */     // GIR_Coverage, 16623,
     /* 2101321 */     GIR_EraseRootFromParent_Done,
     /* 2101322 */   // Label 27859: @2101322
     /* 2101322 */   GIM_Try, /*On fail goto*//*Label 27860*/ GIMT_Encode4(2101416), // Rule ID 16626 //
     /* 2101327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101373 */     // MIs[0] round
     /* 2101373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101376 */     // MIs[0] policy
     /* 2101376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101386 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101415 */     // GIR_Coverage, 16626,
     /* 2101415 */     GIR_EraseRootFromParent_Done,
     /* 2101416 */   // Label 27860: @2101416
     /* 2101416 */   GIM_Try, /*On fail goto*//*Label 27861*/ GIMT_Encode4(2101510), // Rule ID 16627 //
     /* 2101421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2101432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2101435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101467 */     // MIs[0] round
     /* 2101467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101470 */     // MIs[0] policy
     /* 2101470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2101483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101509 */     // GIR_Coverage, 16627,
     /* 2101509 */     GIR_EraseRootFromParent_Done,
     /* 2101510 */   // Label 27861: @2101510
     /* 2101510 */   GIM_Try, /*On fail goto*//*Label 27862*/ GIMT_Encode4(2101604), // Rule ID 16630 //
     /* 2101515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2101526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2101529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2101532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101561 */     // MIs[0] round
     /* 2101561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101564 */     // MIs[0] policy
     /* 2101564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2101577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101603 */     // GIR_Coverage, 16630,
     /* 2101603 */     GIR_EraseRootFromParent_Done,
     /* 2101604 */   // Label 27862: @2101604
     /* 2101604 */   GIM_Try, /*On fail goto*//*Label 27863*/ GIMT_Encode4(2101698), // Rule ID 16631 //
     /* 2101609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2101620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2101623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2101626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101655 */     // MIs[0] round
     /* 2101655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101658 */     // MIs[0] policy
     /* 2101658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2101671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101697 */     // GIR_Coverage, 16631,
     /* 2101697 */     GIR_EraseRootFromParent_Done,
     /* 2101698 */   // Label 27863: @2101698
     /* 2101698 */   GIM_Try, /*On fail goto*//*Label 27864*/ GIMT_Encode4(2101792), // Rule ID 16634 //
     /* 2101703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2101706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2101714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2101717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2101720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101749 */     // MIs[0] round
     /* 2101749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101752 */     // MIs[0] policy
     /* 2101752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101762 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101791 */     // GIR_Coverage, 16634,
     /* 2101791 */     GIR_EraseRootFromParent_Done,
     /* 2101792 */   // Label 27864: @2101792
     /* 2101792 */   GIM_Try, /*On fail goto*//*Label 27865*/ GIMT_Encode4(2101886), // Rule ID 16635 //
     /* 2101797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2101800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2101805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2101808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2101811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2101814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2101839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101843 */     // MIs[0] round
     /* 2101843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101846 */     // MIs[0] policy
     /* 2101846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101856 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2101859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2101884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101885 */     // GIR_Coverage, 16635,
     /* 2101885 */     GIR_EraseRootFromParent_Done,
     /* 2101886 */   // Label 27865: @2101886
     /* 2101886 */   GIM_Try, /*On fail goto*//*Label 27866*/ GIMT_Encode4(2101977), // Rule ID 16698 //
     /* 2101891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2101894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2101899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2101902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2101905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2101908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2101911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101937 */     // MIs[0] round
     /* 2101937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101940 */     // MIs[0] policy
     /* 2101940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101950 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2101953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101976 */     // GIR_Coverage, 16698,
     /* 2101976 */     GIR_EraseRootFromParent_Done,
     /* 2101977 */   // Label 27866: @2101977
     /* 2101977 */   GIM_Try, /*On fail goto*//*Label 27867*/ GIMT_Encode4(2102068), // Rule ID 16699 //
     /* 2101982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2101985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2101990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2101993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2101996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2101999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2102002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102028 */     // MIs[0] round
     /* 2102028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102031 */     // MIs[0] policy
     /* 2102031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102041 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2102044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102067 */     // GIR_Coverage, 16699,
     /* 2102067 */     GIR_EraseRootFromParent_Done,
     /* 2102068 */   // Label 27867: @2102068
     /* 2102068 */   GIM_Try, /*On fail goto*//*Label 27868*/ GIMT_Encode4(2102159), // Rule ID 16702 //
     /* 2102073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2102084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2102087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2102090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2102093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102119 */     // MIs[0] round
     /* 2102119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102122 */     // MIs[0] policy
     /* 2102122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102132 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2102135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102158 */     // GIR_Coverage, 16702,
     /* 2102158 */     GIR_EraseRootFromParent_Done,
     /* 2102159 */   // Label 27868: @2102159
     /* 2102159 */   GIM_Try, /*On fail goto*//*Label 27869*/ GIMT_Encode4(2102250), // Rule ID 16703 //
     /* 2102164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2102175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2102178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2102181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2102184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102210 */     // MIs[0] round
     /* 2102210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102213 */     // MIs[0] policy
     /* 2102213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102223 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2102226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102249 */     // GIR_Coverage, 16703,
     /* 2102249 */     GIR_EraseRootFromParent_Done,
     /* 2102250 */   // Label 27869: @2102250
     /* 2102250 */   GIM_Try, /*On fail goto*//*Label 27870*/ GIMT_Encode4(2102341), // Rule ID 16706 //
     /* 2102255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2102272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102301 */     // MIs[0] round
     /* 2102301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102304 */     // MIs[0] policy
     /* 2102304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102314 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2102317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102340 */     // GIR_Coverage, 16706,
     /* 2102340 */     GIR_EraseRootFromParent_Done,
     /* 2102341 */   // Label 27870: @2102341
     /* 2102341 */   GIM_Try, /*On fail goto*//*Label 27871*/ GIMT_Encode4(2102432), // Rule ID 16707 //
     /* 2102346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2102363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2102366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102392 */     // MIs[0] round
     /* 2102392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102395 */     // MIs[0] policy
     /* 2102395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102405 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2102408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102431 */     // GIR_Coverage, 16707,
     /* 2102431 */     GIR_EraseRootFromParent_Done,
     /* 2102432 */   // Label 27871: @2102432
     /* 2102432 */   GIM_Try, /*On fail goto*//*Label 27872*/ GIMT_Encode4(2102523), // Rule ID 16710 //
     /* 2102437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2102448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2102451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2102454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2102457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102483 */     // MIs[0] round
     /* 2102483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102486 */     // MIs[0] policy
     /* 2102486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102496 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2102499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102522 */     // GIR_Coverage, 16710,
     /* 2102522 */     GIR_EraseRootFromParent_Done,
     /* 2102523 */   // Label 27872: @2102523
     /* 2102523 */   GIM_Try, /*On fail goto*//*Label 27873*/ GIMT_Encode4(2102614), // Rule ID 16711 //
     /* 2102528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2102539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2102542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2102545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2102548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102574 */     // MIs[0] round
     /* 2102574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102577 */     // MIs[0] policy
     /* 2102577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102587 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2102590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102613 */     // GIR_Coverage, 16711,
     /* 2102613 */     GIR_EraseRootFromParent_Done,
     /* 2102614 */   // Label 27873: @2102614
     /* 2102614 */   GIM_Try, /*On fail goto*//*Label 27874*/ GIMT_Encode4(2102705), // Rule ID 16714 //
     /* 2102619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2102630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2102633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2102636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2102639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102665 */     // MIs[0] round
     /* 2102665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102668 */     // MIs[0] policy
     /* 2102668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102678 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2102681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102704 */     // GIR_Coverage, 16714,
     /* 2102704 */     GIR_EraseRootFromParent_Done,
     /* 2102705 */   // Label 27874: @2102705
     /* 2102705 */   GIM_Try, /*On fail goto*//*Label 27875*/ GIMT_Encode4(2102796), // Rule ID 16715 //
     /* 2102710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2102721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2102724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2102727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2102730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102756 */     // MIs[0] round
     /* 2102756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102759 */     // MIs[0] policy
     /* 2102759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102769 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2102772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102795 */     // GIR_Coverage, 16715,
     /* 2102795 */     GIR_EraseRootFromParent_Done,
     /* 2102796 */   // Label 27875: @2102796
     /* 2102796 */   GIM_Try, /*On fail goto*//*Label 27876*/ GIMT_Encode4(2102887), // Rule ID 16718 //
     /* 2102801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2102804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2102812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2102815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2102818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2102821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102847 */     // MIs[0] round
     /* 2102847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102850 */     // MIs[0] policy
     /* 2102850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102860 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2102863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102886 */     // GIR_Coverage, 16718,
     /* 2102886 */     GIR_EraseRootFromParent_Done,
     /* 2102887 */   // Label 27876: @2102887
     /* 2102887 */   GIM_Try, /*On fail goto*//*Label 27877*/ GIMT_Encode4(2102978), // Rule ID 16719 //
     /* 2102892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2102895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2102903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2102906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2102909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2102912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102938 */     // MIs[0] round
     /* 2102938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102941 */     // MIs[0] policy
     /* 2102941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102951 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2102954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102977 */     // GIR_Coverage, 16719,
     /* 2102977 */     GIR_EraseRootFromParent_Done,
     /* 2102978 */   // Label 27877: @2102978
     /* 2102978 */   GIM_Try, /*On fail goto*//*Label 27878*/ GIMT_Encode4(2103069), // Rule ID 16722 //
     /* 2102983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2102991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2102994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2102997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2103003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103029 */     // MIs[0] round
     /* 2103029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103032 */     // MIs[0] policy
     /* 2103032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103042 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2103045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103068 */     // GIR_Coverage, 16722,
     /* 2103068 */     GIR_EraseRootFromParent_Done,
     /* 2103069 */   // Label 27878: @2103069
     /* 2103069 */   GIM_Try, /*On fail goto*//*Label 27879*/ GIMT_Encode4(2103160), // Rule ID 16723 //
     /* 2103074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2103085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2103088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2103091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2103094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103120 */     // MIs[0] round
     /* 2103120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103123 */     // MIs[0] policy
     /* 2103123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103133 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2103136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103159 */     // GIR_Coverage, 16723,
     /* 2103159 */     GIR_EraseRootFromParent_Done,
     /* 2103160 */   // Label 27879: @2103160
     /* 2103160 */   GIM_Try, /*On fail goto*//*Label 27880*/ GIMT_Encode4(2103251), // Rule ID 16726 //
     /* 2103165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2103176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2103179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2103185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103211 */     // MIs[0] round
     /* 2103211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103214 */     // MIs[0] policy
     /* 2103214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103224 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2103227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103250 */     // GIR_Coverage, 16726,
     /* 2103250 */     GIR_EraseRootFromParent_Done,
     /* 2103251 */   // Label 27880: @2103251
     /* 2103251 */   GIM_Try, /*On fail goto*//*Label 27881*/ GIMT_Encode4(2103342), // Rule ID 16727 //
     /* 2103256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2103267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2103270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2103273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2103276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103302 */     // MIs[0] round
     /* 2103302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103305 */     // MIs[0] policy
     /* 2103305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103315 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2103318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103341 */     // GIR_Coverage, 16727,
     /* 2103341 */     GIR_EraseRootFromParent_Done,
     /* 2103342 */   // Label 27881: @2103342
     /* 2103342 */   GIM_Try, /*On fail goto*//*Label 27882*/ GIMT_Encode4(2103433), // Rule ID 16730 //
     /* 2103347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2103367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103393 */     // MIs[0] round
     /* 2103393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103396 */     // MIs[0] policy
     /* 2103396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103406 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2103409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103432 */     // GIR_Coverage, 16730,
     /* 2103432 */     GIR_EraseRootFromParent_Done,
     /* 2103433 */   // Label 27882: @2103433
     /* 2103433 */   GIM_Try, /*On fail goto*//*Label 27883*/ GIMT_Encode4(2103524), // Rule ID 16731 //
     /* 2103438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2103458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103484 */     // MIs[0] round
     /* 2103484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103487 */     // MIs[0] policy
     /* 2103487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103497 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2103500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103523 */     // GIR_Coverage, 16731,
     /* 2103523 */     GIR_EraseRootFromParent_Done,
     /* 2103524 */   // Label 27883: @2103524
     /* 2103524 */   GIM_Try, /*On fail goto*//*Label 27884*/ GIMT_Encode4(2103615), // Rule ID 16734 //
     /* 2103529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2103540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2103543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2103546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2103549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103575 */     // MIs[0] round
     /* 2103575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103578 */     // MIs[0] policy
     /* 2103578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103588 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2103591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103614 */     // GIR_Coverage, 16734,
     /* 2103614 */     GIR_EraseRootFromParent_Done,
     /* 2103615 */   // Label 27884: @2103615
     /* 2103615 */   GIM_Try, /*On fail goto*//*Label 27885*/ GIMT_Encode4(2103706), // Rule ID 16735 //
     /* 2103620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2103631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2103634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2103637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2103640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103666 */     // MIs[0] round
     /* 2103666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103669 */     // MIs[0] policy
     /* 2103669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103679 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2103682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103705 */     // GIR_Coverage, 16735,
     /* 2103705 */     GIR_EraseRootFromParent_Done,
     /* 2103706 */   // Label 27885: @2103706
     /* 2103706 */   GIM_Try, /*On fail goto*//*Label 27886*/ GIMT_Encode4(2103797), // Rule ID 16738 //
     /* 2103711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2103722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2103725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2103728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2103731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103757 */     // MIs[0] round
     /* 2103757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103760 */     // MIs[0] policy
     /* 2103760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103770 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2103773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103796 */     // GIR_Coverage, 16738,
     /* 2103796 */     GIR_EraseRootFromParent_Done,
     /* 2103797 */   // Label 27886: @2103797
     /* 2103797 */   GIM_Try, /*On fail goto*//*Label 27887*/ GIMT_Encode4(2103888), // Rule ID 16739 //
     /* 2103802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2103813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2103816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2103819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2103822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103848 */     // MIs[0] round
     /* 2103848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103851 */     // MIs[0] policy
     /* 2103851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103861 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2103864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103887 */     // GIR_Coverage, 16739,
     /* 2103887 */     GIR_EraseRootFromParent_Done,
     /* 2103888 */   // Label 27887: @2103888
     /* 2103888 */   GIM_Try, /*On fail goto*//*Label 27888*/ GIMT_Encode4(2103979), // Rule ID 16742 //
     /* 2103893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2103904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2103907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2103910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2103913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103939 */     // MIs[0] round
     /* 2103939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103942 */     // MIs[0] policy
     /* 2103942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103952 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2103955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103978 */     // GIR_Coverage, 16742,
     /* 2103978 */     GIR_EraseRootFromParent_Done,
     /* 2103979 */   // Label 27888: @2103979
     /* 2103979 */   GIM_Try, /*On fail goto*//*Label 27889*/ GIMT_Encode4(2104070), // Rule ID 16743 //
     /* 2103984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2103992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2103995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2103998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2104001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2104004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2104007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104030 */     // MIs[0] round
     /* 2104030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104033 */     // MIs[0] policy
     /* 2104033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104043 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2104046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2104066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104069 */     // GIR_Coverage, 16743,
     /* 2104069 */     GIR_EraseRootFromParent_Done,
     /* 2104070 */   // Label 27889: @2104070
     /* 2104070 */   GIM_Try, /*On fail goto*//*Label 27890*/ GIMT_Encode4(2104161), // Rule ID 16746 //
     /* 2104075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2104086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2104089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2104092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2104095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104121 */     // MIs[0] round
     /* 2104121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104124 */     // MIs[0] policy
     /* 2104124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104134 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2104137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104160 */     // GIR_Coverage, 16746,
     /* 2104160 */     GIR_EraseRootFromParent_Done,
     /* 2104161 */   // Label 27890: @2104161
     /* 2104161 */   GIM_Try, /*On fail goto*//*Label 27891*/ GIMT_Encode4(2104252), // Rule ID 16747 //
     /* 2104166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2104177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2104180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2104183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2104186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104212 */     // MIs[0] round
     /* 2104212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104215 */     // MIs[0] policy
     /* 2104215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104225 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2104228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104251 */     // GIR_Coverage, 16747,
     /* 2104251 */     GIR_EraseRootFromParent_Done,
     /* 2104252 */   // Label 27891: @2104252
     /* 2104252 */   GIM_Try, /*On fail goto*//*Label 27892*/ GIMT_Encode4(2104343), // Rule ID 16750 //
     /* 2104257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2104268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2104271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2104274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2104277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104303 */     // MIs[0] round
     /* 2104303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104306 */     // MIs[0] policy
     /* 2104306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104316 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2104319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104342 */     // GIR_Coverage, 16750,
     /* 2104342 */     GIR_EraseRootFromParent_Done,
     /* 2104343 */   // Label 27892: @2104343
     /* 2104343 */   GIM_Try, /*On fail goto*//*Label 27893*/ GIMT_Encode4(2104434), // Rule ID 16751 //
     /* 2104348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2104359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2104362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2104365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2104368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104394 */     // MIs[0] round
     /* 2104394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104397 */     // MIs[0] policy
     /* 2104397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104407 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2104410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104433 */     // GIR_Coverage, 16751,
     /* 2104433 */     GIR_EraseRootFromParent_Done,
     /* 2104434 */   // Label 27893: @2104434
     /* 2104434 */   GIM_Try, /*On fail goto*//*Label 27894*/ GIMT_Encode4(2104525), // Rule ID 16754 //
     /* 2104439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2104450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2104453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2104456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2104459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104485 */     // MIs[0] round
     /* 2104485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104488 */     // MIs[0] policy
     /* 2104488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104498 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2104501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104524 */     // GIR_Coverage, 16754,
     /* 2104524 */     GIR_EraseRootFromParent_Done,
     /* 2104525 */   // Label 27894: @2104525
     /* 2104525 */   GIM_Try, /*On fail goto*//*Label 27895*/ GIMT_Encode4(2104616), // Rule ID 16755 //
     /* 2104530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2104541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2104544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2104547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2104550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104576 */     // MIs[0] round
     /* 2104576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104579 */     // MIs[0] policy
     /* 2104579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104589 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2104592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104615 */     // GIR_Coverage, 16755,
     /* 2104615 */     GIR_EraseRootFromParent_Done,
     /* 2104616 */   // Label 27895: @2104616
     /* 2104616 */   GIM_Try, /*On fail goto*//*Label 27896*/ GIMT_Encode4(2104707), // Rule ID 16758 //
     /* 2104621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2104624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2104632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2104635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2104638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104667 */     // MIs[0] round
     /* 2104667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104670 */     // MIs[0] policy
     /* 2104670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104680 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2104683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104706 */     // GIR_Coverage, 16758,
     /* 2104706 */     GIR_EraseRootFromParent_Done,
     /* 2104707 */   // Label 27896: @2104707
     /* 2104707 */   GIM_Try, /*On fail goto*//*Label 27897*/ GIMT_Encode4(2104798), // Rule ID 16759 //
     /* 2104712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2104715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2104723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2104726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2104729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104758 */     // MIs[0] round
     /* 2104758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104761 */     // MIs[0] policy
     /* 2104761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104771 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2104774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104797 */     // GIR_Coverage, 16759,
     /* 2104797 */     GIR_EraseRootFromParent_Done,
     /* 2104798 */   // Label 27897: @2104798
     /* 2104798 */   GIM_Try, /*On fail goto*//*Label 27898*/ GIMT_Encode4(2104889), // Rule ID 16762 //
     /* 2104803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2104806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2104814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2104817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2104820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104849 */     // MIs[0] round
     /* 2104849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104852 */     // MIs[0] policy
     /* 2104852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104862 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2104865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104888 */     // GIR_Coverage, 16762,
     /* 2104888 */     GIR_EraseRootFromParent_Done,
     /* 2104889 */   // Label 27898: @2104889
     /* 2104889 */   GIM_Try, /*On fail goto*//*Label 27899*/ GIMT_Encode4(2104980), // Rule ID 16763 //
     /* 2104894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2104897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2104905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2104908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2104911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2104914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2104936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104940 */     // MIs[0] round
     /* 2104940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104943 */     // MIs[0] policy
     /* 2104943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104953 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2104956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104979 */     // GIR_Coverage, 16763,
     /* 2104979 */     GIR_EraseRootFromParent_Done,
     /* 2104980 */   // Label 27899: @2104980
     /* 2104980 */   GIM_Try, /*On fail goto*//*Label 27900*/ GIMT_Encode4(2105071), // Rule ID 16766 //
     /* 2104985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2104988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2104993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2104996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2104999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105031 */     // MIs[0] round
     /* 2105031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105034 */     // MIs[0] policy
     /* 2105034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105044 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2105047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105070 */     // GIR_Coverage, 16766,
     /* 2105070 */     GIR_EraseRootFromParent_Done,
     /* 2105071 */   // Label 27900: @2105071
     /* 2105071 */   GIM_Try, /*On fail goto*//*Label 27901*/ GIMT_Encode4(2105162), // Rule ID 16767 //
     /* 2105076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2105087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2105090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105122 */     // MIs[0] round
     /* 2105122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105125 */     // MIs[0] policy
     /* 2105125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105135 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2105138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105161 */     // GIR_Coverage, 16767,
     /* 2105161 */     GIR_EraseRootFromParent_Done,
     /* 2105162 */   // Label 27901: @2105162
     /* 2105162 */   GIM_Try, /*On fail goto*//*Label 27902*/ GIMT_Encode4(2105253), // Rule ID 16770 //
     /* 2105167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2105178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2105181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2105184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105213 */     // MIs[0] round
     /* 2105213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105216 */     // MIs[0] policy
     /* 2105216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105226 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2105229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105252 */     // GIR_Coverage, 16770,
     /* 2105252 */     GIR_EraseRootFromParent_Done,
     /* 2105253 */   // Label 27902: @2105253
     /* 2105253 */   GIM_Try, /*On fail goto*//*Label 27903*/ GIMT_Encode4(2105344), // Rule ID 16771 //
     /* 2105258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2105269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2105272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2105275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105304 */     // MIs[0] round
     /* 2105304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105307 */     // MIs[0] policy
     /* 2105307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105317 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2105320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105343 */     // GIR_Coverage, 16771,
     /* 2105343 */     GIR_EraseRootFromParent_Done,
     /* 2105344 */   // Label 27903: @2105344
     /* 2105344 */   GIM_Try, /*On fail goto*//*Label 27904*/ GIMT_Encode4(2105435), // Rule ID 16774 //
     /* 2105349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2105352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105395 */     // MIs[0] round
     /* 2105395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105398 */     // MIs[0] policy
     /* 2105398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2105411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105434 */     // GIR_Coverage, 16774,
     /* 2105434 */     GIR_EraseRootFromParent_Done,
     /* 2105435 */   // Label 27904: @2105435
     /* 2105435 */   GIM_Try, /*On fail goto*//*Label 27905*/ GIMT_Encode4(2105526), // Rule ID 16775 //
     /* 2105440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2105443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2105451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2105454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2105460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2105482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105486 */     // MIs[0] round
     /* 2105486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105489 */     // MIs[0] policy
     /* 2105489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105499 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2105502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105525 */     // GIR_Coverage, 16775,
     /* 2105525 */     GIR_EraseRootFromParent_Done,
     /* 2105526 */   // Label 27905: @2105526
     /* 2105526 */   GIM_Try, /*On fail goto*//*Label 27906*/ GIMT_Encode4(2105617), // Rule ID 16778 //
     /* 2105531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2105534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2105542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2105545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2105548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105577 */     // MIs[0] round
     /* 2105577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105580 */     // MIs[0] policy
     /* 2105580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105590 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2105593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105616 */     // GIR_Coverage, 16778,
     /* 2105616 */     GIR_EraseRootFromParent_Done,
     /* 2105617 */   // Label 27906: @2105617
     /* 2105617 */   GIM_Try, /*On fail goto*//*Label 27907*/ GIMT_Encode4(2105708), // Rule ID 16779 //
     /* 2105622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2105625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2105633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2105636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2105639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2105642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2105664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105668 */     // MIs[0] round
     /* 2105668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105671 */     // MIs[0] policy
     /* 2105671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105681 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2105684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2105704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105707 */     // GIR_Coverage, 16779,
     /* 2105707 */     GIR_EraseRootFromParent_Done,
     /* 2105708 */   // Label 27907: @2105708
     /* 2105708 */   GIM_Try, /*On fail goto*//*Label 27908*/ GIMT_Encode4(2105799), // Rule ID 16782 //
     /* 2105713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2105724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2105727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2105730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105759 */     // MIs[0] round
     /* 2105759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105762 */     // MIs[0] policy
     /* 2105762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105772 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2105775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105798 */     // GIR_Coverage, 16782,
     /* 2105798 */     GIR_EraseRootFromParent_Done,
     /* 2105799 */   // Label 27908: @2105799
     /* 2105799 */   GIM_Try, /*On fail goto*//*Label 27909*/ GIMT_Encode4(2105890), // Rule ID 16783 //
     /* 2105804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2105815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2105818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2105821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105850 */     // MIs[0] round
     /* 2105850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105853 */     // MIs[0] policy
     /* 2105853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105863 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2105866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105889 */     // GIR_Coverage, 16783,
     /* 2105889 */     GIR_EraseRootFromParent_Done,
     /* 2105890 */   // Label 27909: @2105890
     /* 2105890 */   GIM_Try, /*On fail goto*//*Label 27910*/ GIMT_Encode4(2105981), // Rule ID 16786 //
     /* 2105895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2105898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2105906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2105909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2105912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2105918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105941 */     // MIs[0] round
     /* 2105941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105944 */     // MIs[0] policy
     /* 2105944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105954 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2105957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105980 */     // GIR_Coverage, 16786,
     /* 2105980 */     GIR_EraseRootFromParent_Done,
     /* 2105981 */   // Label 27910: @2105981
     /* 2105981 */   GIM_Try, /*On fail goto*//*Label 27911*/ GIMT_Encode4(2106072), // Rule ID 16787 //
     /* 2105986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2105989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2105994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2105997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2106000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2106003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106032 */     // MIs[0] round
     /* 2106032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106035 */     // MIs[0] policy
     /* 2106035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106045 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2106048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106071 */     // GIR_Coverage, 16787,
     /* 2106071 */     GIR_EraseRootFromParent_Done,
     /* 2106072 */   // Label 27911: @2106072
     /* 2106072 */   GIM_Try, /*On fail goto*//*Label 27912*/ GIMT_Encode4(2106163), // Rule ID 16790 //
     /* 2106077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2106080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2106088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2106091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2106094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2106100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106123 */     // MIs[0] round
     /* 2106123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106126 */     // MIs[0] policy
     /* 2106126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106136 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2106139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106162 */     // GIR_Coverage, 16790,
     /* 2106162 */     GIR_EraseRootFromParent_Done,
     /* 2106163 */   // Label 27912: @2106163
     /* 2106163 */   GIM_Try, /*On fail goto*//*Label 27913*/ GIMT_Encode4(2106254), // Rule ID 16791 //
     /* 2106168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2106171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2106179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2106182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2106185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2106191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106214 */     // MIs[0] round
     /* 2106214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106217 */     // MIs[0] policy
     /* 2106217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106227 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2106230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106253 */     // GIR_Coverage, 16791,
     /* 2106253 */     GIR_EraseRootFromParent_Done,
     /* 2106254 */   // Label 27913: @2106254
     /* 2106254 */   GIM_Try, /*On fail goto*//*Label 27914*/ GIMT_Encode4(2106345), // Rule ID 16794 //
     /* 2106259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2106276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106305 */     // MIs[0] round
     /* 2106305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106308 */     // MIs[0] policy
     /* 2106308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106318 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2106321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106344 */     // GIR_Coverage, 16794,
     /* 2106344 */     GIR_EraseRootFromParent_Done,
     /* 2106345 */   // Label 27914: @2106345
     /* 2106345 */   GIM_Try, /*On fail goto*//*Label 27915*/ GIMT_Encode4(2106436), // Rule ID 16795 //
     /* 2106350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2106367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106396 */     // MIs[0] round
     /* 2106396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106399 */     // MIs[0] policy
     /* 2106399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106409 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2106412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106435 */     // GIR_Coverage, 16795,
     /* 2106435 */     GIR_EraseRootFromParent_Done,
     /* 2106436 */   // Label 27915: @2106436
     /* 2106436 */   GIM_Try, /*On fail goto*//*Label 27916*/ GIMT_Encode4(2106527), // Rule ID 16798 //
     /* 2106441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2106452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2106455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2106458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106487 */     // MIs[0] round
     /* 2106487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106490 */     // MIs[0] policy
     /* 2106490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106500 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2106503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106526 */     // GIR_Coverage, 16798,
     /* 2106526 */     GIR_EraseRootFromParent_Done,
     /* 2106527 */   // Label 27916: @2106527
     /* 2106527 */   GIM_Try, /*On fail goto*//*Label 27917*/ GIMT_Encode4(2106618), // Rule ID 16799 //
     /* 2106532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2106543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2106546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2106549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106578 */     // MIs[0] round
     /* 2106578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106581 */     // MIs[0] policy
     /* 2106581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106591 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2106594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106617 */     // GIR_Coverage, 16799,
     /* 2106617 */     GIR_EraseRootFromParent_Done,
     /* 2106618 */   // Label 27917: @2106618
     /* 2106618 */   GIM_Try, /*On fail goto*//*Label 27918*/ GIMT_Encode4(2106709), // Rule ID 16802 //
     /* 2106623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2106626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2106634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2106637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2106640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106669 */     // MIs[0] round
     /* 2106669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106672 */     // MIs[0] policy
     /* 2106672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106682 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2106685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106708 */     // GIR_Coverage, 16802,
     /* 2106708 */     GIR_EraseRootFromParent_Done,
     /* 2106709 */   // Label 27918: @2106709
     /* 2106709 */   GIM_Try, /*On fail goto*//*Label 27919*/ GIMT_Encode4(2106800), // Rule ID 16803 //
     /* 2106714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2106717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2106725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2106728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2106731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106760 */     // MIs[0] round
     /* 2106760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106763 */     // MIs[0] policy
     /* 2106763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106773 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2106776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106799 */     // GIR_Coverage, 16803,
     /* 2106799 */     GIR_EraseRootFromParent_Done,
     /* 2106800 */   // Label 27919: @2106800
     /* 2106800 */   GIM_Try, /*On fail goto*//*Label 27920*/ GIMT_Encode4(2106891), // Rule ID 16806 //
     /* 2106805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2106808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2106816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2106819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2106822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106851 */     // MIs[0] round
     /* 2106851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106854 */     // MIs[0] policy
     /* 2106854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106864 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2106867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106890 */     // GIR_Coverage, 16806,
     /* 2106890 */     GIR_EraseRootFromParent_Done,
     /* 2106891 */   // Label 27920: @2106891
     /* 2106891 */   GIM_Try, /*On fail goto*//*Label 27921*/ GIMT_Encode4(2106982), // Rule ID 16807 //
     /* 2106896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2106899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2106907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2106910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2106913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2106916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2106938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106942 */     // MIs[0] round
     /* 2106942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106945 */     // MIs[0] policy
     /* 2106945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106955 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11186:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2106958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2106978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106981 */     // GIR_Coverage, 16807,
     /* 2106981 */     GIR_EraseRootFromParent_Done,
     /* 2106982 */   // Label 27921: @2106982
     /* 2106982 */   GIM_Try, /*On fail goto*//*Label 27922*/ GIMT_Encode4(2107073), // Rule ID 16810 //
     /* 2106987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2106990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2106995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2106998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2107004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107033 */     // MIs[0] round
     /* 2107033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107036 */     // MIs[0] policy
     /* 2107036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107046 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2107049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107072 */     // GIR_Coverage, 16810,
     /* 2107072 */     GIR_EraseRootFromParent_Done,
     /* 2107073 */   // Label 27922: @2107073
     /* 2107073 */   GIM_Try, /*On fail goto*//*Label 27923*/ GIMT_Encode4(2107164), // Rule ID 16811 //
     /* 2107078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2107089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2107095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107124 */     // MIs[0] round
     /* 2107124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107127 */     // MIs[0] policy
     /* 2107127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107137 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11186:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2107140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107163 */     // GIR_Coverage, 16811,
     /* 2107163 */     GIR_EraseRootFromParent_Done,
     /* 2107164 */   // Label 27923: @2107164
     /* 2107164 */   GIM_Try, /*On fail goto*//*Label 27924*/ GIMT_Encode4(2107255), // Rule ID 16814 //
     /* 2107169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2107172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2107186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107215 */     // MIs[0] round
     /* 2107215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107218 */     // MIs[0] policy
     /* 2107218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107228 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2107231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107254 */     // GIR_Coverage, 16814,
     /* 2107254 */     GIR_EraseRootFromParent_Done,
     /* 2107255 */   // Label 27924: @2107255
     /* 2107255 */   GIM_Try, /*On fail goto*//*Label 27925*/ GIMT_Encode4(2107346), // Rule ID 16815 //
     /* 2107260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2107263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2107268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2107277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2107280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2107302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107306 */     // MIs[0] round
     /* 2107306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107309 */     // MIs[0] policy
     /* 2107309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107319 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11186:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2107322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2107342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107345 */     // GIR_Coverage, 16815,
     /* 2107345 */     GIR_EraseRootFromParent_Done,
     /* 2107346 */   // Label 27925: @2107346
     /* 2107346 */   GIM_Try, /*On fail goto*//*Label 27926*/ GIMT_Encode4(2107437), // Rule ID 16818 //
     /* 2107351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2107362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2107365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107397 */     // MIs[0] round
     /* 2107397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107400 */     // MIs[0] policy
     /* 2107400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107410 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2107413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107436 */     // GIR_Coverage, 16818,
     /* 2107436 */     GIR_EraseRootFromParent_Done,
     /* 2107437 */   // Label 27926: @2107437
     /* 2107437 */   GIM_Try, /*On fail goto*//*Label 27927*/ GIMT_Encode4(2107528), // Rule ID 16819 //
     /* 2107442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2107453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2107456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107488 */     // MIs[0] round
     /* 2107488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107491 */     // MIs[0] policy
     /* 2107491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107501 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2107504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107527 */     // GIR_Coverage, 16819,
     /* 2107527 */     GIR_EraseRootFromParent_Done,
     /* 2107528 */   // Label 27927: @2107528
     /* 2107528 */   GIM_Try, /*On fail goto*//*Label 27928*/ GIMT_Encode4(2107619), // Rule ID 16822 //
     /* 2107533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2107544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2107547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2107550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2107553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107579 */     // MIs[0] round
     /* 2107579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107582 */     // MIs[0] policy
     /* 2107582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107592 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2107595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107618 */     // GIR_Coverage, 16822,
     /* 2107618 */     GIR_EraseRootFromParent_Done,
     /* 2107619 */   // Label 27928: @2107619
     /* 2107619 */   GIM_Try, /*On fail goto*//*Label 27929*/ GIMT_Encode4(2107710), // Rule ID 16823 //
     /* 2107624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2107635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2107638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2107641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2107644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107670 */     // MIs[0] round
     /* 2107670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107673 */     // MIs[0] policy
     /* 2107673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107683 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2107686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107709 */     // GIR_Coverage, 16823,
     /* 2107709 */     GIR_EraseRootFromParent_Done,
     /* 2107710 */   // Label 27929: @2107710
     /* 2107710 */   GIM_Try, /*On fail goto*//*Label 27930*/ GIMT_Encode4(2107801), // Rule ID 16826 //
     /* 2107715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2107718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2107726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2107729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2107732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2107735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107761 */     // MIs[0] round
     /* 2107761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107764 */     // MIs[0] policy
     /* 2107764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107774 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2107777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107800 */     // GIR_Coverage, 16826,
     /* 2107800 */     GIR_EraseRootFromParent_Done,
     /* 2107801 */   // Label 27930: @2107801
     /* 2107801 */   GIM_Try, /*On fail goto*//*Label 27931*/ GIMT_Encode4(2107892), // Rule ID 16827 //
     /* 2107806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2107809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2107817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2107820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2107823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2107826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107852 */     // MIs[0] round
     /* 2107852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107855 */     // MIs[0] policy
     /* 2107855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107865 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2107868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107891 */     // GIR_Coverage, 16827,
     /* 2107891 */     GIR_EraseRootFromParent_Done,
     /* 2107892 */   // Label 27931: @2107892
     /* 2107892 */   GIM_Try, /*On fail goto*//*Label 27932*/ GIMT_Encode4(2107983), // Rule ID 16830 //
     /* 2107897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2107900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2107908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2107911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2107914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2107917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107943 */     // MIs[0] round
     /* 2107943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107946 */     // MIs[0] policy
     /* 2107946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107956 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2107959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107982 */     // GIR_Coverage, 16830,
     /* 2107982 */     GIR_EraseRootFromParent_Done,
     /* 2107983 */   // Label 27932: @2107983
     /* 2107983 */   GIM_Try, /*On fail goto*//*Label 27933*/ GIMT_Encode4(2108074), // Rule ID 16831 //
     /* 2107988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2107991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2107996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2107999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2108002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2108005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2108008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108034 */     // MIs[0] round
     /* 2108034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108037 */     // MIs[0] policy
     /* 2108037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108047 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2108050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108073 */     // GIR_Coverage, 16831,
     /* 2108073 */     GIR_EraseRootFromParent_Done,
     /* 2108074 */   // Label 27933: @2108074
     /* 2108074 */   GIM_Try, /*On fail goto*//*Label 27934*/ GIMT_Encode4(2108165), // Rule ID 16834 //
     /* 2108079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2108082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108125 */     // MIs[0] round
     /* 2108125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108128 */     // MIs[0] policy
     /* 2108128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108138 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2108141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108164 */     // GIR_Coverage, 16834,
     /* 2108164 */     GIR_EraseRootFromParent_Done,
     /* 2108165 */   // Label 27934: @2108165
     /* 2108165 */   GIM_Try, /*On fail goto*//*Label 27935*/ GIMT_Encode4(2108256), // Rule ID 16835 //
     /* 2108170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2108173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2108181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2108184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108216 */     // MIs[0] round
     /* 2108216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108219 */     // MIs[0] policy
     /* 2108219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108229 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2108232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108255 */     // GIR_Coverage, 16835,
     /* 2108255 */     GIR_EraseRootFromParent_Done,
     /* 2108256 */   // Label 27935: @2108256
     /* 2108256 */   GIM_Try, /*On fail goto*//*Label 27936*/ GIMT_Encode4(2108347), // Rule ID 16838 //
     /* 2108261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2108264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2108278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2108281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108307 */     // MIs[0] round
     /* 2108307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108310 */     // MIs[0] policy
     /* 2108310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108320 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2108323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108346 */     // GIR_Coverage, 16838,
     /* 2108346 */     GIR_EraseRootFromParent_Done,
     /* 2108347 */   // Label 27936: @2108347
     /* 2108347 */   GIM_Try, /*On fail goto*//*Label 27937*/ GIMT_Encode4(2108438), // Rule ID 16839 //
     /* 2108352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2108355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2108369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2108372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108398 */     // MIs[0] round
     /* 2108398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108401 */     // MIs[0] policy
     /* 2108401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108411 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2108414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2108434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108437 */     // GIR_Coverage, 16839,
     /* 2108437 */     GIR_EraseRootFromParent_Done,
     /* 2108438 */   // Label 27937: @2108438
     /* 2108438 */   GIM_Try, /*On fail goto*//*Label 27938*/ GIMT_Encode4(2108529), // Rule ID 16842 //
     /* 2108443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2108454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2108457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2108460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2108463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108489 */     // MIs[0] round
     /* 2108489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108492 */     // MIs[0] policy
     /* 2108492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108502 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2108505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108528 */     // GIR_Coverage, 16842,
     /* 2108528 */     GIR_EraseRootFromParent_Done,
     /* 2108529 */   // Label 27938: @2108529
     /* 2108529 */   GIM_Try, /*On fail goto*//*Label 27939*/ GIMT_Encode4(2108620), // Rule ID 16843 //
     /* 2108534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2108545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2108548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2108551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2108554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108580 */     // MIs[0] round
     /* 2108580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108583 */     // MIs[0] policy
     /* 2108583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108593 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2108596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108619 */     // GIR_Coverage, 16843,
     /* 2108619 */     GIR_EraseRootFromParent_Done,
     /* 2108620 */   // Label 27939: @2108620
     /* 2108620 */   GIM_Try, /*On fail goto*//*Label 27940*/ GIMT_Encode4(2108711), // Rule ID 16846 //
     /* 2108625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2108636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2108639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2108642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2108645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2108648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108671 */     // MIs[0] round
     /* 2108671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108674 */     // MIs[0] policy
     /* 2108674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108684 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2108687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108710 */     // GIR_Coverage, 16846,
     /* 2108710 */     GIR_EraseRootFromParent_Done,
     /* 2108711 */   // Label 27940: @2108711
     /* 2108711 */   GIM_Try, /*On fail goto*//*Label 27941*/ GIMT_Encode4(2108802), // Rule ID 16847 //
     /* 2108716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2108727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2108730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2108733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2108736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2108739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108762 */     // MIs[0] round
     /* 2108762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108765 */     // MIs[0] policy
     /* 2108765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108775 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2108778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108801 */     // GIR_Coverage, 16847,
     /* 2108801 */     GIR_EraseRootFromParent_Done,
     /* 2108802 */   // Label 27941: @2108802
     /* 2108802 */   GIM_Try, /*On fail goto*//*Label 27942*/ GIMT_Encode4(2108893), // Rule ID 16850 //
     /* 2108807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2108810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2108818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2108821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2108824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2108827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2108830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108853 */     // MIs[0] round
     /* 2108853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108856 */     // MIs[0] policy
     /* 2108856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108866 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2108869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108892 */     // GIR_Coverage, 16850,
     /* 2108892 */     GIR_EraseRootFromParent_Done,
     /* 2108893 */   // Label 27942: @2108893
     /* 2108893 */   GIM_Try, /*On fail goto*//*Label 27943*/ GIMT_Encode4(2108984), // Rule ID 16851 //
     /* 2108898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2108901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2108909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2108912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2108915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2108918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2108921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108944 */     // MIs[0] round
     /* 2108944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108947 */     // MIs[0] policy
     /* 2108947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108957 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2108960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108983 */     // GIR_Coverage, 16851,
     /* 2108983 */     GIR_EraseRootFromParent_Done,
     /* 2108984 */   // Label 27943: @2108984
     /* 2108984 */   GIM_Try, /*On fail goto*//*Label 27944*/ GIMT_Encode4(2109075), // Rule ID 16854 //
     /* 2108989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2108992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2108997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2109006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2109009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109035 */     // MIs[0] round
     /* 2109035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109038 */     // MIs[0] policy
     /* 2109038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109048 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2109051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109074 */     // GIR_Coverage, 16854,
     /* 2109074 */     GIR_EraseRootFromParent_Done,
     /* 2109075 */   // Label 27944: @2109075
     /* 2109075 */   GIM_Try, /*On fail goto*//*Label 27945*/ GIMT_Encode4(2109166), // Rule ID 16855 //
     /* 2109080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2109097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2109100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109126 */     // MIs[0] round
     /* 2109126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109129 */     // MIs[0] policy
     /* 2109129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109139 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2109142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109165 */     // GIR_Coverage, 16855,
     /* 2109165 */     GIR_EraseRootFromParent_Done,
     /* 2109166 */   // Label 27945: @2109166
     /* 2109166 */   GIM_Try, /*On fail goto*//*Label 27946*/ GIMT_Encode4(2109257), // Rule ID 16858 //
     /* 2109171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109217 */     // MIs[0] round
     /* 2109217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109220 */     // MIs[0] policy
     /* 2109220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109230 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2109233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109256 */     // GIR_Coverage, 16858,
     /* 2109256 */     GIR_EraseRootFromParent_Done,
     /* 2109257 */   // Label 27946: @2109257
     /* 2109257 */   GIM_Try, /*On fail goto*//*Label 27947*/ GIMT_Encode4(2109348), // Rule ID 16859 //
     /* 2109262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109308 */     // MIs[0] round
     /* 2109308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109311 */     // MIs[0] policy
     /* 2109311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109321 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2109324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109347 */     // GIR_Coverage, 16859,
     /* 2109347 */     GIR_EraseRootFromParent_Done,
     /* 2109348 */   // Label 27947: @2109348
     /* 2109348 */   GIM_Try, /*On fail goto*//*Label 27948*/ GIMT_Encode4(2109439), // Rule ID 16862 //
     /* 2109353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2109356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2109370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2109373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109399 */     // MIs[0] round
     /* 2109399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109402 */     // MIs[0] policy
     /* 2109402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109412 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2109415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109438 */     // GIR_Coverage, 16862,
     /* 2109438 */     GIR_EraseRootFromParent_Done,
     /* 2109439 */   // Label 27948: @2109439
     /* 2109439 */   GIM_Try, /*On fail goto*//*Label 27949*/ GIMT_Encode4(2109530), // Rule ID 16863 //
     /* 2109444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2109447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2109461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2109464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109490 */     // MIs[0] round
     /* 2109490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109493 */     // MIs[0] policy
     /* 2109493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109503 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2109506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109529 */     // GIR_Coverage, 16863,
     /* 2109529 */     GIR_EraseRootFromParent_Done,
     /* 2109530 */   // Label 27949: @2109530
     /* 2109530 */   GIM_Try, /*On fail goto*//*Label 27950*/ GIMT_Encode4(2109621), // Rule ID 16866 //
     /* 2109535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2109538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2109546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2109549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2109552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2109555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109581 */     // MIs[0] round
     /* 2109581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109584 */     // MIs[0] policy
     /* 2109584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109594 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2109597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109620 */     // GIR_Coverage, 16866,
     /* 2109620 */     GIR_EraseRootFromParent_Done,
     /* 2109621 */   // Label 27950: @2109621
     /* 2109621 */   GIM_Try, /*On fail goto*//*Label 27951*/ GIMT_Encode4(2109712), // Rule ID 16867 //
     /* 2109626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2109629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2109637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2109640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2109643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2109646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109672 */     // MIs[0] round
     /* 2109672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109675 */     // MIs[0] policy
     /* 2109675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109685 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2109688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109711 */     // GIR_Coverage, 16867,
     /* 2109711 */     GIR_EraseRootFromParent_Done,
     /* 2109712 */   // Label 27951: @2109712
     /* 2109712 */   GIM_Try, /*On fail goto*//*Label 27952*/ GIMT_Encode4(2109803), // Rule ID 16870 //
     /* 2109717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2109720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2109728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2109731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2109734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2109737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109763 */     // MIs[0] round
     /* 2109763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109766 */     // MIs[0] policy
     /* 2109766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109776 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2109779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109802 */     // GIR_Coverage, 16870,
     /* 2109802 */     GIR_EraseRootFromParent_Done,
     /* 2109803 */   // Label 27952: @2109803
     /* 2109803 */   GIM_Try, /*On fail goto*//*Label 27953*/ GIMT_Encode4(2109894), // Rule ID 16871 //
     /* 2109808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2109811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2109819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2109822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2109825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2109828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109854 */     // MIs[0] round
     /* 2109854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109857 */     // MIs[0] policy
     /* 2109857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109867 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2109870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109893 */     // GIR_Coverage, 16871,
     /* 2109893 */     GIR_EraseRootFromParent_Done,
     /* 2109894 */   // Label 27953: @2109894
     /* 2109894 */   GIM_Try, /*On fail goto*//*Label 27954*/ GIMT_Encode4(2109985), // Rule ID 16874 //
     /* 2109899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2109902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2109910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2109913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2109916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2109919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109945 */     // MIs[0] round
     /* 2109945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109948 */     // MIs[0] policy
     /* 2109948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109958 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2109961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2109981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109984 */     // GIR_Coverage, 16874,
     /* 2109984 */     GIR_EraseRootFromParent_Done,
     /* 2109985 */   // Label 27954: @2109985
     /* 2109985 */   GIM_Try, /*On fail goto*//*Label 27955*/ GIMT_Encode4(2110076), // Rule ID 16875 //
     /* 2109990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2109993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2109998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2110007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2110010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110036 */     // MIs[0] round
     /* 2110036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110039 */     // MIs[0] policy
     /* 2110039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110049 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2110052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2110072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110075 */     // GIR_Coverage, 16875,
     /* 2110075 */     GIR_EraseRootFromParent_Done,
     /* 2110076 */   // Label 27955: @2110076
     /* 2110076 */   GIM_Try, /*On fail goto*//*Label 27956*/ GIMT_Encode4(2110167), // Rule ID 16878 //
     /* 2110081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2110092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2110095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110127 */     // MIs[0] round
     /* 2110127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110130 */     // MIs[0] policy
     /* 2110130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110140 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2110143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110166 */     // GIR_Coverage, 16878,
     /* 2110166 */     GIR_EraseRootFromParent_Done,
     /* 2110167 */   // Label 27956: @2110167
     /* 2110167 */   GIM_Try, /*On fail goto*//*Label 27957*/ GIMT_Encode4(2110258), // Rule ID 16879 //
     /* 2110172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2110183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2110186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2110189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110218 */     // MIs[0] round
     /* 2110218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110221 */     // MIs[0] policy
     /* 2110221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110231 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2110234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110257 */     // GIR_Coverage, 16879,
     /* 2110257 */     GIR_EraseRootFromParent_Done,
     /* 2110258 */   // Label 27957: @2110258
     /* 2110258 */   GIM_Try, /*On fail goto*//*Label 27958*/ GIMT_Encode4(2110349), // Rule ID 16882 //
     /* 2110263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2110274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2110277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110309 */     // MIs[0] round
     /* 2110309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110312 */     // MIs[0] policy
     /* 2110312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110322 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2110325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110348 */     // GIR_Coverage, 16882,
     /* 2110348 */     GIR_EraseRootFromParent_Done,
     /* 2110349 */   // Label 27958: @2110349
     /* 2110349 */   GIM_Try, /*On fail goto*//*Label 27959*/ GIMT_Encode4(2110440), // Rule ID 16883 //
     /* 2110354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2110365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2110368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2110371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110400 */     // MIs[0] round
     /* 2110400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110403 */     // MIs[0] policy
     /* 2110403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110413 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2110416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110439 */     // GIR_Coverage, 16883,
     /* 2110439 */     GIR_EraseRootFromParent_Done,
     /* 2110440 */   // Label 27959: @2110440
     /* 2110440 */   GIM_Try, /*On fail goto*//*Label 27960*/ GIMT_Encode4(2110531), // Rule ID 16886 //
     /* 2110445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2110448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2110456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2110459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2110462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110491 */     // MIs[0] round
     /* 2110491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110494 */     // MIs[0] policy
     /* 2110494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110504 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2110507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110530 */     // GIR_Coverage, 16886,
     /* 2110530 */     GIR_EraseRootFromParent_Done,
     /* 2110531 */   // Label 27960: @2110531
     /* 2110531 */   GIM_Try, /*On fail goto*//*Label 27961*/ GIMT_Encode4(2110622), // Rule ID 16887 //
     /* 2110536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2110539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2110547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2110550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2110553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110582 */     // MIs[0] round
     /* 2110582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110585 */     // MIs[0] policy
     /* 2110585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110595 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2110598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110621 */     // GIR_Coverage, 16887,
     /* 2110621 */     GIR_EraseRootFromParent_Done,
     /* 2110622 */   // Label 27961: @2110622
     /* 2110622 */   GIM_Try, /*On fail goto*//*Label 27962*/ GIMT_Encode4(2110713), // Rule ID 16890 //
     /* 2110627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2110630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2110638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2110641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2110644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110673 */     // MIs[0] round
     /* 2110673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110676 */     // MIs[0] policy
     /* 2110676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110686 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2110689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110712 */     // GIR_Coverage, 16890,
     /* 2110712 */     GIR_EraseRootFromParent_Done,
     /* 2110713 */   // Label 27962: @2110713
     /* 2110713 */   GIM_Try, /*On fail goto*//*Label 27963*/ GIMT_Encode4(2110804), // Rule ID 16891 //
     /* 2110718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2110721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2110729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2110732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2110735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110764 */     // MIs[0] round
     /* 2110764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110767 */     // MIs[0] policy
     /* 2110767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110777 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11278:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2110780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110803 */     // GIR_Coverage, 16891,
     /* 2110803 */     GIR_EraseRootFromParent_Done,
     /* 2110804 */   // Label 27963: @2110804
     /* 2110804 */   GIM_Try, /*On fail goto*//*Label 27964*/ GIMT_Encode4(2110895), // Rule ID 16894 //
     /* 2110809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2110812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2110820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2110823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2110826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110855 */     // MIs[0] round
     /* 2110855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110858 */     // MIs[0] policy
     /* 2110858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110868 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2110871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110894 */     // GIR_Coverage, 16894,
     /* 2110894 */     GIR_EraseRootFromParent_Done,
     /* 2110895 */   // Label 27964: @2110895
     /* 2110895 */   GIM_Try, /*On fail goto*//*Label 27965*/ GIMT_Encode4(2110986), // Rule ID 16895 //
     /* 2110900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2110903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2110911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2110914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2110917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110946 */     // MIs[0] round
     /* 2110946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110949 */     // MIs[0] policy
     /* 2110949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110959 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11278:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2110962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110985 */     // GIR_Coverage, 16895,
     /* 2110985 */     GIR_EraseRootFromParent_Done,
     /* 2110986 */   // Label 27965: @2110986
     /* 2110986 */   GIM_Try, /*On fail goto*//*Label 27966*/ GIMT_Encode4(2111077), // Rule ID 16898 //
     /* 2110991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2110994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2110999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111037 */     // MIs[0] round
     /* 2111037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111040 */     // MIs[0] policy
     /* 2111040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2111053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111076 */     // GIR_Coverage, 16898,
     /* 2111076 */     GIR_EraseRootFromParent_Done,
     /* 2111077 */   // Label 27966: @2111077
     /* 2111077 */   GIM_Try, /*On fail goto*//*Label 27967*/ GIMT_Encode4(2111168), // Rule ID 16899 //
     /* 2111082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2111085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2111102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2111124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111128 */     // MIs[0] round
     /* 2111128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111131 */     // MIs[0] policy
     /* 2111131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111141 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11278:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2111144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2111164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111167 */     // GIR_Coverage, 16899,
     /* 2111167 */     GIR_EraseRootFromParent_Done,
     /* 2111168 */   // Label 27967: @2111168
     /* 2111168 */   GIM_Try, /*On fail goto*//*Label 27968*/ GIMT_Encode4(2111259), // Rule ID 16902 //
     /* 2111173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2111184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2111187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2111190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111219 */     // MIs[0] round
     /* 2111219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111222 */     // MIs[0] policy
     /* 2111222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111232 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2111235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111258 */     // GIR_Coverage, 16902,
     /* 2111258 */     GIR_EraseRootFromParent_Done,
     /* 2111259 */   // Label 27968: @2111259
     /* 2111259 */   GIM_Try, /*On fail goto*//*Label 27969*/ GIMT_Encode4(2111350), // Rule ID 16903 //
     /* 2111264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2111275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2111278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2111281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111310 */     // MIs[0] round
     /* 2111310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111313 */     // MIs[0] policy
     /* 2111313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111323 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2111326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111349 */     // GIR_Coverage, 16903,
     /* 2111349 */     GIR_EraseRootFromParent_Done,
     /* 2111350 */   // Label 27969: @2111350
     /* 2111350 */   GIM_Try, /*On fail goto*//*Label 27970*/ GIMT_Encode4(2111441), // Rule ID 16906 //
     /* 2111355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2111366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2111369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111401 */     // MIs[0] round
     /* 2111401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111404 */     // MIs[0] policy
     /* 2111404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111414 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2111417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111440 */     // GIR_Coverage, 16906,
     /* 2111440 */     GIR_EraseRootFromParent_Done,
     /* 2111441 */   // Label 27970: @2111441
     /* 2111441 */   GIM_Try, /*On fail goto*//*Label 27971*/ GIMT_Encode4(2111532), // Rule ID 16907 //
     /* 2111446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2111457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2111460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2111463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111492 */     // MIs[0] round
     /* 2111492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111495 */     // MIs[0] policy
     /* 2111495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111505 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2111508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111531 */     // GIR_Coverage, 16907,
     /* 2111531 */     GIR_EraseRootFromParent_Done,
     /* 2111532 */   // Label 27971: @2111532
     /* 2111532 */   GIM_Try, /*On fail goto*//*Label 27972*/ GIMT_Encode4(2111623), // Rule ID 16910 //
     /* 2111537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2111540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2111548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2111551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2111554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2111560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111583 */     // MIs[0] round
     /* 2111583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111586 */     // MIs[0] policy
     /* 2111586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111596 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2111599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111622 */     // GIR_Coverage, 16910,
     /* 2111622 */     GIR_EraseRootFromParent_Done,
     /* 2111623 */   // Label 27972: @2111623
     /* 2111623 */   GIM_Try, /*On fail goto*//*Label 27973*/ GIMT_Encode4(2111714), // Rule ID 16911 //
     /* 2111628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2111631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2111639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2111642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2111645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2111648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2111651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2111670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111674 */     // MIs[0] round
     /* 2111674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111677 */     // MIs[0] policy
     /* 2111677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111687 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2111690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111713 */     // GIR_Coverage, 16911,
     /* 2111713 */     GIR_EraseRootFromParent_Done,
     /* 2111714 */   // Label 27973: @2111714
     /* 2111714 */   GIM_Try, /*On fail goto*//*Label 27974*/ GIMT_Encode4(2111805), // Rule ID 16914 //
     /* 2111719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2111722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2111730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2111733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2111736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111765 */     // MIs[0] round
     /* 2111765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111768 */     // MIs[0] policy
     /* 2111768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111778 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2111781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111804 */     // GIR_Coverage, 16914,
     /* 2111804 */     GIR_EraseRootFromParent_Done,
     /* 2111805 */   // Label 27974: @2111805
     /* 2111805 */   GIM_Try, /*On fail goto*//*Label 27975*/ GIMT_Encode4(2111896), // Rule ID 16915 //
     /* 2111810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2111813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2111821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2111824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2111827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111856 */     // MIs[0] round
     /* 2111856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111859 */     // MIs[0] policy
     /* 2111859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111869 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2111872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111895 */     // GIR_Coverage, 16915,
     /* 2111895 */     GIR_EraseRootFromParent_Done,
     /* 2111896 */   // Label 27975: @2111896
     /* 2111896 */   GIM_Try, /*On fail goto*//*Label 27976*/ GIMT_Encode4(2111987), // Rule ID 16918 //
     /* 2111901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2111904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2111909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2111912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2111915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2111918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2111921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2111943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111947 */     // MIs[0] round
     /* 2111947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111950 */     // MIs[0] policy
     /* 2111950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111960 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2111963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111986 */     // GIR_Coverage, 16918,
     /* 2111986 */     GIR_EraseRootFromParent_Done,
     /* 2111987 */   // Label 27976: @2111987
     /* 2111987 */   GIM_Try, /*On fail goto*//*Label 27977*/ GIMT_Encode4(2112078), // Rule ID 16919 //
     /* 2111992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2111995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2112009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112038 */     // MIs[0] round
     /* 2112038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112041 */     // MIs[0] policy
     /* 2112041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112051 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2112054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112077 */     // GIR_Coverage, 16919,
     /* 2112077 */     GIR_EraseRootFromParent_Done,
     /* 2112078 */   // Label 27977: @2112078
     /* 2112078 */   GIM_Try, /*On fail goto*//*Label 27978*/ GIMT_Encode4(2112169), // Rule ID 16922 //
     /* 2112083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2112086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2112100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112129 */     // MIs[0] round
     /* 2112129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112132 */     // MIs[0] policy
     /* 2112132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112142 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2112145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112168 */     // GIR_Coverage, 16922,
     /* 2112168 */     GIR_EraseRootFromParent_Done,
     /* 2112169 */   // Label 27978: @2112169
     /* 2112169 */   GIM_Try, /*On fail goto*//*Label 27979*/ GIMT_Encode4(2112260), // Rule ID 16923 //
     /* 2112174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2112177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2112185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2112188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2112191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2112194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2112197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2112216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112220 */     // MIs[0] round
     /* 2112220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112223 */     // MIs[0] policy
     /* 2112223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112233 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2112236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112259 */     // GIR_Coverage, 16923,
     /* 2112259 */     GIR_EraseRootFromParent_Done,
     /* 2112260 */   // Label 27979: @2112260
     /* 2112260 */   GIM_Try, /*On fail goto*//*Label 27980*/ GIMT_Encode4(2112351), // Rule ID 16926 //
     /* 2112265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2112276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2112279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2112282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112311 */     // MIs[0] round
     /* 2112311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112314 */     // MIs[0] policy
     /* 2112314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112324 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2112327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112350 */     // GIR_Coverage, 16926,
     /* 2112350 */     GIR_EraseRootFromParent_Done,
     /* 2112351 */   // Label 27980: @2112351
     /* 2112351 */   GIM_Try, /*On fail goto*//*Label 27981*/ GIMT_Encode4(2112442), // Rule ID 16927 //
     /* 2112356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2112359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2112367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2112370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2112373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112402 */     // MIs[0] round
     /* 2112402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112405 */     // MIs[0] policy
     /* 2112405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112415 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11278:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2112418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112441 */     // GIR_Coverage, 16927,
     /* 2112441 */     GIR_EraseRootFromParent_Done,
     /* 2112442 */   // Label 27981: @2112442
     /* 2112442 */   GIM_Try, /*On fail goto*//*Label 27982*/ GIMT_Encode4(2112533), // Rule ID 16930 //
     /* 2112447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2112458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2112461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2112464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112493 */     // MIs[0] round
     /* 2112493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112496 */     // MIs[0] policy
     /* 2112496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112506 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2112509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112532 */     // GIR_Coverage, 16930,
     /* 2112532 */     GIR_EraseRootFromParent_Done,
     /* 2112533 */   // Label 27982: @2112533
     /* 2112533 */   GIM_Try, /*On fail goto*//*Label 27983*/ GIMT_Encode4(2112624), // Rule ID 16931 //
     /* 2112538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2112541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2112549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2112552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2112555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112584 */     // MIs[0] round
     /* 2112584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112587 */     // MIs[0] policy
     /* 2112587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112597 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11278:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2112600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112623 */     // GIR_Coverage, 16931,
     /* 2112623 */     GIR_EraseRootFromParent_Done,
     /* 2112624 */   // Label 27983: @2112624
     /* 2112624 */   GIM_Try, /*On fail goto*//*Label 27984*/ GIMT_Encode4(2112715), // Rule ID 16934 //
     /* 2112629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2112632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2112640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2112643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2112646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112675 */     // MIs[0] round
     /* 2112675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112678 */     // MIs[0] policy
     /* 2112678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112688 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2112691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112714 */     // GIR_Coverage, 16934,
     /* 2112714 */     GIR_EraseRootFromParent_Done,
     /* 2112715 */   // Label 27984: @2112715
     /* 2112715 */   GIM_Try, /*On fail goto*//*Label 27985*/ GIMT_Encode4(2112806), // Rule ID 16935 //
     /* 2112720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2112723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2112728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2112731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2112734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2112737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2112740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2112762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112766 */     // MIs[0] round
     /* 2112766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112769 */     // MIs[0] policy
     /* 2112769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112779 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11278:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2112782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2112802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112805 */     // GIR_Coverage, 16935,
     /* 2112805 */     GIR_EraseRootFromParent_Done,
     /* 2112806 */   // Label 27985: @2112806
     /* 2112806 */   GIM_Try, /*On fail goto*//*Label 27986*/ GIMT_Encode4(2112897), // Rule ID 16938 //
     /* 2112811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2112814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2112819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2112822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2112825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2112828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112857 */     // MIs[0] round
     /* 2112857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112860 */     // MIs[0] policy
     /* 2112860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112870 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2112873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112896 */     // GIR_Coverage, 16938,
     /* 2112896 */     GIR_EraseRootFromParent_Done,
     /* 2112897 */   // Label 27986: @2112897
     /* 2112897 */   GIM_Try, /*On fail goto*//*Label 27987*/ GIMT_Encode4(2112988), // Rule ID 16939 //
     /* 2112902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2112905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2112910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2112913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2112916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2112919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112948 */     // MIs[0] round
     /* 2112948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112951 */     // MIs[0] policy
     /* 2112951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112961 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2112964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112987 */     // GIR_Coverage, 16939,
     /* 2112987 */     GIR_EraseRootFromParent_Done,
     /* 2112988 */   // Label 27987: @2112988
     /* 2112988 */   GIM_Try, /*On fail goto*//*Label 27988*/ GIMT_Encode4(2113079), // Rule ID 16942 //
     /* 2112993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2112996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2113004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2113007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113039 */     // MIs[0] round
     /* 2113039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113042 */     // MIs[0] policy
     /* 2113042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2113055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113078 */     // GIR_Coverage, 16942,
     /* 2113078 */     GIR_EraseRootFromParent_Done,
     /* 2113079 */   // Label 27988: @2113079
     /* 2113079 */   GIM_Try, /*On fail goto*//*Label 27989*/ GIMT_Encode4(2113170), // Rule ID 16943 //
     /* 2113084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2113095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2113098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2113101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113130 */     // MIs[0] round
     /* 2113130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113133 */     // MIs[0] policy
     /* 2113133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113143 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2113146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113169 */     // GIR_Coverage, 16943,
     /* 2113169 */     GIR_EraseRootFromParent_Done,
     /* 2113170 */   // Label 27989: @2113170
     /* 2113170 */   GIM_Try, /*On fail goto*//*Label 27990*/ GIMT_Encode4(2113261), // Rule ID 16946 //
     /* 2113175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2113178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2113192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113221 */     // MIs[0] round
     /* 2113221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113224 */     // MIs[0] policy
     /* 2113224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113234 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2113237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113260 */     // GIR_Coverage, 16946,
     /* 2113260 */     GIR_EraseRootFromParent_Done,
     /* 2113261 */   // Label 27990: @2113261
     /* 2113261 */   GIM_Try, /*On fail goto*//*Label 27991*/ GIMT_Encode4(2113352), // Rule ID 16947 //
     /* 2113266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2113269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2113283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113312 */     // MIs[0] round
     /* 2113312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113315 */     // MIs[0] policy
     /* 2113315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113325 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2113328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113351 */     // GIR_Coverage, 16947,
     /* 2113351 */     GIR_EraseRootFromParent_Done,
     /* 2113352 */   // Label 27991: @2113352
     /* 2113352 */   GIM_Try, /*On fail goto*//*Label 27992*/ GIMT_Encode4(2113443), // Rule ID 16950 //
     /* 2113357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2113368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2113371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2113374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113403 */     // MIs[0] round
     /* 2113403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113406 */     // MIs[0] policy
     /* 2113406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113416 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2113419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113442 */     // GIR_Coverage, 16950,
     /* 2113442 */     GIR_EraseRootFromParent_Done,
     /* 2113443 */   // Label 27992: @2113443
     /* 2113443 */   GIM_Try, /*On fail goto*//*Label 27993*/ GIMT_Encode4(2113534), // Rule ID 16951 //
     /* 2113448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2113459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2113462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2113465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113494 */     // MIs[0] round
     /* 2113494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113497 */     // MIs[0] policy
     /* 2113497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113507 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11264:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2113510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113533 */     // GIR_Coverage, 16951,
     /* 2113533 */     GIR_EraseRootFromParent_Done,
     /* 2113534 */   // Label 27993: @2113534
     /* 2113534 */   GIM_Try, /*On fail goto*//*Label 27994*/ GIMT_Encode4(2113625), // Rule ID 16954 //
     /* 2113539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2113542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2113550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2113553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2113556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113585 */     // MIs[0] round
     /* 2113585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113588 */     // MIs[0] policy
     /* 2113588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113598 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2113601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113624 */     // GIR_Coverage, 16954,
     /* 2113624 */     GIR_EraseRootFromParent_Done,
     /* 2113625 */   // Label 27994: @2113625
     /* 2113625 */   GIM_Try, /*On fail goto*//*Label 27995*/ GIMT_Encode4(2113716), // Rule ID 16955 //
     /* 2113630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2113633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2113641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2113644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2113647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113676 */     // MIs[0] round
     /* 2113676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113679 */     // MIs[0] policy
     /* 2113679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113689 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11264:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2113692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113715 */     // GIR_Coverage, 16955,
     /* 2113715 */     GIR_EraseRootFromParent_Done,
     /* 2113716 */   // Label 27995: @2113716
     /* 2113716 */   GIM_Try, /*On fail goto*//*Label 27996*/ GIMT_Encode4(2113807), // Rule ID 16958 //
     /* 2113721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2113724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2113732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2113735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2113738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113767 */     // MIs[0] round
     /* 2113767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113770 */     // MIs[0] policy
     /* 2113770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113780 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2113783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113806 */     // GIR_Coverage, 16958,
     /* 2113806 */     GIR_EraseRootFromParent_Done,
     /* 2113807 */   // Label 27996: @2113807
     /* 2113807 */   GIM_Try, /*On fail goto*//*Label 27997*/ GIMT_Encode4(2113898), // Rule ID 16959 //
     /* 2113812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2113815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2113823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2113826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2113829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2113832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2113854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113858 */     // MIs[0] round
     /* 2113858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113861 */     // MIs[0] policy
     /* 2113861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113871 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11264:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2113874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2113894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113897 */     // GIR_Coverage, 16959,
     /* 2113897 */     GIR_EraseRootFromParent_Done,
     /* 2113898 */   // Label 27997: @2113898
     /* 2113898 */   GIM_Try, /*On fail goto*//*Label 27998*/ GIMT_Encode4(2113989), // Rule ID 16962 //
     /* 2113903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2113906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2113911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2113914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2113917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2113920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2113933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113949 */     // MIs[0] round
     /* 2113949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113952 */     // MIs[0] policy
     /* 2113952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113962 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2113965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113988 */     // GIR_Coverage, 16962,
     /* 2113988 */     GIR_EraseRootFromParent_Done,
     /* 2113989 */   // Label 27998: @2113989
     /* 2113989 */   GIM_Try, /*On fail goto*//*Label 27999*/ GIMT_Encode4(2114080), // Rule ID 16963 //
     /* 2113994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2113997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2114005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2114008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2114011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114040 */     // MIs[0] round
     /* 2114040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114043 */     // MIs[0] policy
     /* 2114043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114053 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2114056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114079 */     // GIR_Coverage, 16963,
     /* 2114079 */     GIR_EraseRootFromParent_Done,
     /* 2114080 */   // Label 27999: @2114080
     /* 2114080 */   GIM_Try, /*On fail goto*//*Label 28000*/ GIMT_Encode4(2114171), // Rule ID 16966 //
     /* 2114085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2114096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2114099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114131 */     // MIs[0] round
     /* 2114131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114134 */     // MIs[0] policy
     /* 2114134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114144 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2114147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114170 */     // GIR_Coverage, 16966,
     /* 2114170 */     GIR_EraseRootFromParent_Done,
     /* 2114171 */   // Label 28000: @2114171
     /* 2114171 */   GIM_Try, /*On fail goto*//*Label 28001*/ GIMT_Encode4(2114262), // Rule ID 16967 //
     /* 2114176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2114187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2114190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2114193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114222 */     // MIs[0] round
     /* 2114222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114225 */     // MIs[0] policy
     /* 2114225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114235 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2114238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114261 */     // GIR_Coverage, 16967,
     /* 2114261 */     GIR_EraseRootFromParent_Done,
     /* 2114262 */   // Label 28001: @2114262
     /* 2114262 */   GIM_Try, /*On fail goto*//*Label 28002*/ GIMT_Encode4(2114353), // Rule ID 16970 //
     /* 2114267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2114270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2114278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2114281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2114284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2114290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114313 */     // MIs[0] round
     /* 2114313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114316 */     // MIs[0] policy
     /* 2114316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114326 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2114329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114352 */     // GIR_Coverage, 16970,
     /* 2114352 */     GIR_EraseRootFromParent_Done,
     /* 2114353 */   // Label 28002: @2114353
     /* 2114353 */   GIM_Try, /*On fail goto*//*Label 28003*/ GIMT_Encode4(2114444), // Rule ID 16971 //
     /* 2114358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2114361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2114369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2114372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2114375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2114378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2114381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2114400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114404 */     // MIs[0] round
     /* 2114404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114407 */     // MIs[0] policy
     /* 2114407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114417 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2114420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114443 */     // GIR_Coverage, 16971,
     /* 2114443 */     GIR_EraseRootFromParent_Done,
     /* 2114444 */   // Label 28003: @2114444
     /* 2114444 */   GIM_Try, /*On fail goto*//*Label 28004*/ GIMT_Encode4(2114535), // Rule ID 16974 //
     /* 2114449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2114460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2114463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114495 */     // MIs[0] round
     /* 2114495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114498 */     // MIs[0] policy
     /* 2114498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114508 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2114511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114534 */     // GIR_Coverage, 16974,
     /* 2114534 */     GIR_EraseRootFromParent_Done,
     /* 2114535 */   // Label 28004: @2114535
     /* 2114535 */   GIM_Try, /*On fail goto*//*Label 28005*/ GIMT_Encode4(2114626), // Rule ID 16975 //
     /* 2114540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2114551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2114554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114586 */     // MIs[0] round
     /* 2114586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114589 */     // MIs[0] policy
     /* 2114589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114599 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2114602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114625 */     // GIR_Coverage, 16975,
     /* 2114625 */     GIR_EraseRootFromParent_Done,
     /* 2114626 */   // Label 28005: @2114626
     /* 2114626 */   GIM_Try, /*On fail goto*//*Label 28006*/ GIMT_Encode4(2114717), // Rule ID 16978 //
     /* 2114631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2114642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2114645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2114648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114677 */     // MIs[0] round
     /* 2114677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114680 */     // MIs[0] policy
     /* 2114680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114690 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2114693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114716 */     // GIR_Coverage, 16978,
     /* 2114716 */     GIR_EraseRootFromParent_Done,
     /* 2114717 */   // Label 28006: @2114717
     /* 2114717 */   GIM_Try, /*On fail goto*//*Label 28007*/ GIMT_Encode4(2114808), // Rule ID 16979 //
     /* 2114722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2114733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2114736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2114739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114768 */     // MIs[0] round
     /* 2114768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114771 */     // MIs[0] policy
     /* 2114771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114781 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2114784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114807 */     // GIR_Coverage, 16979,
     /* 2114807 */     GIR_EraseRootFromParent_Done,
     /* 2114808 */   // Label 28007: @2114808
     /* 2114808 */   GIM_Try, /*On fail goto*//*Label 28008*/ GIMT_Encode4(2114899), // Rule ID 16982 //
     /* 2114813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2114816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2114824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2114827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2114830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114859 */     // MIs[0] round
     /* 2114859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114862 */     // MIs[0] policy
     /* 2114862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114872 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2114875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114898 */     // GIR_Coverage, 16982,
     /* 2114898 */     GIR_EraseRootFromParent_Done,
     /* 2114899 */   // Label 28008: @2114899
     /* 2114899 */   GIM_Try, /*On fail goto*//*Label 28009*/ GIMT_Encode4(2114990), // Rule ID 16983 //
     /* 2114904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2114907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2114912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2114915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2114918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2114921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2114924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2114946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114950 */     // MIs[0] round
     /* 2114950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114953 */     // MIs[0] policy
     /* 2114953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114963 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2114966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114989 */     // GIR_Coverage, 16983,
     /* 2114989 */     GIR_EraseRootFromParent_Done,
     /* 2114990 */   // Label 28009: @2114990
     /* 2114990 */   GIM_Try, /*On fail goto*//*Label 28010*/ GIMT_Encode4(2115081), // Rule ID 16986 //
     /* 2114995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2114998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115041 */     // MIs[0] round
     /* 2115041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115044 */     // MIs[0] policy
     /* 2115044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115054 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2115057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115080 */     // GIR_Coverage, 16986,
     /* 2115080 */     GIR_EraseRootFromParent_Done,
     /* 2115081 */   // Label 28010: @2115081
     /* 2115081 */   GIM_Try, /*On fail goto*//*Label 28011*/ GIMT_Encode4(2115172), // Rule ID 16987 //
     /* 2115086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115132 */     // MIs[0] round
     /* 2115132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115135 */     // MIs[0] policy
     /* 2115135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115145 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11264:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2115148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115171 */     // GIR_Coverage, 16987,
     /* 2115171 */     GIR_EraseRootFromParent_Done,
     /* 2115172 */   // Label 28011: @2115172
     /* 2115172 */   GIM_Try, /*On fail goto*//*Label 28012*/ GIMT_Encode4(2115263), // Rule ID 16990 //
     /* 2115177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115223 */     // MIs[0] round
     /* 2115223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115226 */     // MIs[0] policy
     /* 2115226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115236 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2115239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115262 */     // GIR_Coverage, 16990,
     /* 2115262 */     GIR_EraseRootFromParent_Done,
     /* 2115263 */   // Label 28012: @2115263
     /* 2115263 */   GIM_Try, /*On fail goto*//*Label 28013*/ GIMT_Encode4(2115354), // Rule ID 16991 //
     /* 2115268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115314 */     // MIs[0] round
     /* 2115314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115317 */     // MIs[0] policy
     /* 2115317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115327 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11264:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2115330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115353 */     // GIR_Coverage, 16991,
     /* 2115353 */     GIR_EraseRootFromParent_Done,
     /* 2115354 */   // Label 28013: @2115354
     /* 2115354 */   GIM_Try, /*On fail goto*//*Label 28014*/ GIMT_Encode4(2115445), // Rule ID 16994 //
     /* 2115359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2115362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115405 */     // MIs[0] round
     /* 2115405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115408 */     // MIs[0] policy
     /* 2115408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115418 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2115421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115444 */     // GIR_Coverage, 16994,
     /* 2115444 */     GIR_EraseRootFromParent_Done,
     /* 2115445 */   // Label 28014: @2115445
     /* 2115445 */   GIM_Try, /*On fail goto*//*Label 28015*/ GIMT_Encode4(2115536), // Rule ID 16995 //
     /* 2115450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2115453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2115458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2115470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2115492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115496 */     // MIs[0] round
     /* 2115496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115499 */     // MIs[0] policy
     /* 2115499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115509 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11264:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2115512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2115532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115535 */     // GIR_Coverage, 16995,
     /* 2115535 */     GIR_EraseRootFromParent_Done,
     /* 2115536 */   // Label 28015: @2115536
     /* 2115536 */   GIM_Try, /*On fail goto*//*Label 28016*/ GIMT_Encode4(2115627), // Rule ID 16998 //
     /* 2115541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2115552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2115555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2115558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2115561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2115564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115587 */     // MIs[0] round
     /* 2115587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115590 */     // MIs[0] policy
     /* 2115590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115600 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2115603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115626 */     // GIR_Coverage, 16998,
     /* 2115626 */     GIR_EraseRootFromParent_Done,
     /* 2115627 */   // Label 28016: @2115627
     /* 2115627 */   GIM_Try, /*On fail goto*//*Label 28017*/ GIMT_Encode4(2115718), // Rule ID 16999 //
     /* 2115632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2115643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2115646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2115649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2115652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2115655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115678 */     // MIs[0] round
     /* 2115678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115681 */     // MIs[0] policy
     /* 2115681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115691 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2115694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115717 */     // GIR_Coverage, 16999,
     /* 2115717 */     GIR_EraseRootFromParent_Done,
     /* 2115718 */   // Label 28017: @2115718
     /* 2115718 */   GIM_Try, /*On fail goto*//*Label 28018*/ GIMT_Encode4(2115809), // Rule ID 17002 //
     /* 2115723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2115734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2115737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2115740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2115743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115769 */     // MIs[0] round
     /* 2115769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115772 */     // MIs[0] policy
     /* 2115772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2115785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115808 */     // GIR_Coverage, 17002,
     /* 2115808 */     GIR_EraseRootFromParent_Done,
     /* 2115809 */   // Label 28018: @2115809
     /* 2115809 */   GIM_Try, /*On fail goto*//*Label 28019*/ GIMT_Encode4(2115900), // Rule ID 17003 //
     /* 2115814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2115825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2115828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2115831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2115834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115860 */     // MIs[0] round
     /* 2115860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115863 */     // MIs[0] policy
     /* 2115863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115873 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2115876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115899 */     // GIR_Coverage, 17003,
     /* 2115899 */     GIR_EraseRootFromParent_Done,
     /* 2115900 */   // Label 28019: @2115900
     /* 2115900 */   GIM_Try, /*On fail goto*//*Label 28020*/ GIMT_Encode4(2115991), // Rule ID 17006 //
     /* 2115905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2115913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2115916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2115922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2115925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115951 */     // MIs[0] round
     /* 2115951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115954 */     // MIs[0] policy
     /* 2115954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115964 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2115967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115990 */     // GIR_Coverage, 17006,
     /* 2115990 */     GIR_EraseRootFromParent_Done,
     /* 2115991 */   // Label 28020: @2115991
     /* 2115991 */   GIM_Try, /*On fail goto*//*Label 28021*/ GIMT_Encode4(2116082), // Rule ID 17007 //
     /* 2115996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2116007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2116010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2116013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2116016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116042 */     // MIs[0] round
     /* 2116042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116045 */     // MIs[0] policy
     /* 2116045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116055 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2116058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116081 */     // GIR_Coverage, 17007,
     /* 2116081 */     GIR_EraseRootFromParent_Done,
     /* 2116082 */   // Label 28021: @2116082
     /* 2116082 */   GIM_Try, /*On fail goto*//*Label 28022*/ GIMT_Encode4(2116173), // Rule ID 17010 //
     /* 2116087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2116104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2116107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116133 */     // MIs[0] round
     /* 2116133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116136 */     // MIs[0] policy
     /* 2116136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116146 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2116149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116172 */     // GIR_Coverage, 17010,
     /* 2116172 */     GIR_EraseRootFromParent_Done,
     /* 2116173 */   // Label 28022: @2116173
     /* 2116173 */   GIM_Try, /*On fail goto*//*Label 28023*/ GIMT_Encode4(2116264), // Rule ID 17011 //
     /* 2116178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2116195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2116198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116224 */     // MIs[0] round
     /* 2116224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116227 */     // MIs[0] policy
     /* 2116227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116237 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2116240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116263 */     // GIR_Coverage, 17011,
     /* 2116263 */     GIR_EraseRootFromParent_Done,
     /* 2116264 */   // Label 28023: @2116264
     /* 2116264 */   GIM_Try, /*On fail goto*//*Label 28024*/ GIMT_Encode4(2116355), // Rule ID 17014 //
     /* 2116269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2116286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2116289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116315 */     // MIs[0] round
     /* 2116315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116318 */     // MIs[0] policy
     /* 2116318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116328 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2116331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116354 */     // GIR_Coverage, 17014,
     /* 2116354 */     GIR_EraseRootFromParent_Done,
     /* 2116355 */   // Label 28024: @2116355
     /* 2116355 */   GIM_Try, /*On fail goto*//*Label 28025*/ GIMT_Encode4(2116446), // Rule ID 17015 //
     /* 2116360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2116377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2116380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116406 */     // MIs[0] round
     /* 2116406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116409 */     // MIs[0] policy
     /* 2116409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116419 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2116422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116445 */     // GIR_Coverage, 17015,
     /* 2116445 */     GIR_EraseRootFromParent_Done,
     /* 2116446 */   // Label 28025: @2116446
     /* 2116446 */   GIM_Try, /*On fail goto*//*Label 28026*/ GIMT_Encode4(2116537), // Rule ID 17018 //
     /* 2116451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2116462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2116465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2116468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2116471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116497 */     // MIs[0] round
     /* 2116497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116500 */     // MIs[0] policy
     /* 2116500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116510 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2116513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116536 */     // GIR_Coverage, 17018,
     /* 2116536 */     GIR_EraseRootFromParent_Done,
     /* 2116537 */   // Label 28026: @2116537
     /* 2116537 */   GIM_Try, /*On fail goto*//*Label 28027*/ GIMT_Encode4(2116628), // Rule ID 17019 //
     /* 2116542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2116553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2116556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2116559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2116562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116588 */     // MIs[0] round
     /* 2116588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116591 */     // MIs[0] policy
     /* 2116591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116601 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2116604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116627 */     // GIR_Coverage, 17019,
     /* 2116627 */     GIR_EraseRootFromParent_Done,
     /* 2116628 */   // Label 28027: @2116628
     /* 2116628 */   GIM_Try, /*On fail goto*//*Label 28028*/ GIMT_Encode4(2116719), // Rule ID 17022 //
     /* 2116633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2116650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2116653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116679 */     // MIs[0] round
     /* 2116679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116682 */     // MIs[0] policy
     /* 2116682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116692 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2116695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116718 */     // GIR_Coverage, 17022,
     /* 2116718 */     GIR_EraseRootFromParent_Done,
     /* 2116719 */   // Label 28028: @2116719
     /* 2116719 */   GIM_Try, /*On fail goto*//*Label 28029*/ GIMT_Encode4(2116810), // Rule ID 17023 //
     /* 2116724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2116741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2116744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116770 */     // MIs[0] round
     /* 2116770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116773 */     // MIs[0] policy
     /* 2116773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116783 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2116786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116809 */     // GIR_Coverage, 17023,
     /* 2116809 */     GIR_EraseRootFromParent_Done,
     /* 2116810 */   // Label 28029: @2116810
     /* 2116810 */   GIM_Try, /*On fail goto*//*Label 28030*/ GIMT_Encode4(2116901), // Rule ID 17026 //
     /* 2116815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2116832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2116835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116861 */     // MIs[0] round
     /* 2116861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116864 */     // MIs[0] policy
     /* 2116864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116874 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2116877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116900 */     // GIR_Coverage, 17026,
     /* 2116900 */     GIR_EraseRootFromParent_Done,
     /* 2116901 */   // Label 28030: @2116901
     /* 2116901 */   GIM_Try, /*On fail goto*//*Label 28031*/ GIMT_Encode4(2116992), // Rule ID 17027 //
     /* 2116906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2116914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2116923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2116926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116952 */     // MIs[0] round
     /* 2116952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116955 */     // MIs[0] policy
     /* 2116955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116965 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2116968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116991 */     // GIR_Coverage, 17027,
     /* 2116991 */     GIR_EraseRootFromParent_Done,
     /* 2116992 */   // Label 28031: @2116992
     /* 2116992 */   GIM_Try, /*On fail goto*//*Label 28032*/ GIMT_Encode4(2117083), // Rule ID 17030 //
     /* 2116997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2117017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117043 */     // MIs[0] round
     /* 2117043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117046 */     // MIs[0] policy
     /* 2117046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117056 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2117059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117082 */     // GIR_Coverage, 17030,
     /* 2117082 */     GIR_EraseRootFromParent_Done,
     /* 2117083 */   // Label 28032: @2117083
     /* 2117083 */   GIM_Try, /*On fail goto*//*Label 28033*/ GIMT_Encode4(2117174), // Rule ID 17031 //
     /* 2117088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2117105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2117108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117134 */     // MIs[0] round
     /* 2117134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117137 */     // MIs[0] policy
     /* 2117137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117147 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2117150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117173 */     // GIR_Coverage, 17031,
     /* 2117173 */     GIR_EraseRootFromParent_Done,
     /* 2117174 */   // Label 28033: @2117174
     /* 2117174 */   GIM_Try, /*On fail goto*//*Label 28034*/ GIMT_Encode4(2117265), // Rule ID 17034 //
     /* 2117179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117225 */     // MIs[0] round
     /* 2117225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117228 */     // MIs[0] policy
     /* 2117228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117238 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2117241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117264 */     // GIR_Coverage, 17034,
     /* 2117264 */     GIR_EraseRootFromParent_Done,
     /* 2117265 */   // Label 28034: @2117265
     /* 2117265 */   GIM_Try, /*On fail goto*//*Label 28035*/ GIMT_Encode4(2117356), // Rule ID 17035 //
     /* 2117270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117316 */     // MIs[0] round
     /* 2117316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117319 */     // MIs[0] policy
     /* 2117319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117329 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2117332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117355 */     // GIR_Coverage, 17035,
     /* 2117355 */     GIR_EraseRootFromParent_Done,
     /* 2117356 */   // Label 28035: @2117356
     /* 2117356 */   GIM_Try, /*On fail goto*//*Label 28036*/ GIMT_Encode4(2117447), // Rule ID 17038 //
     /* 2117361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117407 */     // MIs[0] round
     /* 2117407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117410 */     // MIs[0] policy
     /* 2117410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2117423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117446 */     // GIR_Coverage, 17038,
     /* 2117446 */     GIR_EraseRootFromParent_Done,
     /* 2117447 */   // Label 28036: @2117447
     /* 2117447 */   GIM_Try, /*On fail goto*//*Label 28037*/ GIMT_Encode4(2117538), // Rule ID 17039 //
     /* 2117452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117498 */     // MIs[0] round
     /* 2117498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117501 */     // MIs[0] policy
     /* 2117501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117511 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11280:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2117514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117537 */     // GIR_Coverage, 17039,
     /* 2117537 */     GIR_EraseRootFromParent_Done,
     /* 2117538 */   // Label 28037: @2117538
     /* 2117538 */   GIM_Try, /*On fail goto*//*Label 28038*/ GIMT_Encode4(2117629), // Rule ID 17042 //
     /* 2117543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2117554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2117557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2117560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117589 */     // MIs[0] round
     /* 2117589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117592 */     // MIs[0] policy
     /* 2117592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117602 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2117605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117628 */     // GIR_Coverage, 17042,
     /* 2117628 */     GIR_EraseRootFromParent_Done,
     /* 2117629 */   // Label 28038: @2117629
     /* 2117629 */   GIM_Try, /*On fail goto*//*Label 28039*/ GIMT_Encode4(2117720), // Rule ID 17043 //
     /* 2117634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2117645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2117648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2117651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2117664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117680 */     // MIs[0] round
     /* 2117680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117683 */     // MIs[0] policy
     /* 2117683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117693 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2117696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117719 */     // GIR_Coverage, 17043,
     /* 2117719 */     GIR_EraseRootFromParent_Done,
     /* 2117720 */   // Label 28039: @2117720
     /* 2117720 */   GIM_Try, /*On fail goto*//*Label 28040*/ GIMT_Encode4(2117811), // Rule ID 17046 //
     /* 2117725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2117736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2117739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2117742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117771 */     // MIs[0] round
     /* 2117771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117774 */     // MIs[0] policy
     /* 2117774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117784 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2117787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117810 */     // GIR_Coverage, 17046,
     /* 2117810 */     GIR_EraseRootFromParent_Done,
     /* 2117811 */   // Label 28040: @2117811
     /* 2117811 */   GIM_Try, /*On fail goto*//*Label 28041*/ GIMT_Encode4(2117902), // Rule ID 17047 //
     /* 2117816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2117819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2117827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2117830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2117833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2117846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2117854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117862 */     // MIs[0] round
     /* 2117862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117865 */     // MIs[0] policy
     /* 2117865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117875 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2117878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117901 */     // GIR_Coverage, 17047,
     /* 2117901 */     GIR_EraseRootFromParent_Done,
     /* 2117902 */   // Label 28041: @2117902
     /* 2117902 */   GIM_Try, /*On fail goto*//*Label 28042*/ GIMT_Encode4(2117993), // Rule ID 17050 //
     /* 2117907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2117910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2117915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2117918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2117921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2117924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2117927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2117930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2117945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2117949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117953 */     // MIs[0] round
     /* 2117953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117956 */     // MIs[0] policy
     /* 2117956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117966 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2117969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117992 */     // GIR_Coverage, 17050,
     /* 2117992 */     GIR_EraseRootFromParent_Done,
     /* 2117993 */   // Label 28042: @2117993
     /* 2117993 */   GIM_Try, /*On fail goto*//*Label 28043*/ GIMT_Encode4(2118084), // Rule ID 17051 //
     /* 2117998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2118009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2118012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2118015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2118018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2118040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118044 */     // MIs[0] round
     /* 2118044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118047 */     // MIs[0] policy
     /* 2118047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118057 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2118060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118083 */     // GIR_Coverage, 17051,
     /* 2118083 */     GIR_EraseRootFromParent_Done,
     /* 2118084 */   // Label 28043: @2118084
     /* 2118084 */   GIM_Try, /*On fail goto*//*Label 28044*/ GIMT_Encode4(2118175), // Rule ID 17054 //
     /* 2118089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118135 */     // MIs[0] round
     /* 2118135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118138 */     // MIs[0] policy
     /* 2118138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118148 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2118151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118174 */     // GIR_Coverage, 17054,
     /* 2118174 */     GIR_EraseRootFromParent_Done,
     /* 2118175 */   // Label 28044: @2118175
     /* 2118175 */   GIM_Try, /*On fail goto*//*Label 28045*/ GIMT_Encode4(2118266), // Rule ID 17055 //
     /* 2118180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2118197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118226 */     // MIs[0] round
     /* 2118226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118229 */     // MIs[0] policy
     /* 2118229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118239 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11280:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2118242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118265 */     // GIR_Coverage, 17055,
     /* 2118265 */     GIR_EraseRootFromParent_Done,
     /* 2118266 */   // Label 28045: @2118266
     /* 2118266 */   GIM_Try, /*On fail goto*//*Label 28046*/ GIMT_Encode4(2118357), // Rule ID 17058 //
     /* 2118271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118317 */     // MIs[0] round
     /* 2118317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118320 */     // MIs[0] policy
     /* 2118320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118330 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2118333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118356 */     // GIR_Coverage, 17058,
     /* 2118356 */     GIR_EraseRootFromParent_Done,
     /* 2118357 */   // Label 28046: @2118357
     /* 2118357 */   GIM_Try, /*On fail goto*//*Label 28047*/ GIMT_Encode4(2118448), // Rule ID 17059 //
     /* 2118362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2118373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2118376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118408 */     // MIs[0] round
     /* 2118408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118411 */     // MIs[0] policy
     /* 2118411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118421 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11280:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2118424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118447 */     // GIR_Coverage, 17059,
     /* 2118447 */     GIR_EraseRootFromParent_Done,
     /* 2118448 */   // Label 28047: @2118448
     /* 2118448 */   GIM_Try, /*On fail goto*//*Label 28048*/ GIMT_Encode4(2118539), // Rule ID 17062 //
     /* 2118453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2118464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2118467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118499 */     // MIs[0] round
     /* 2118499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118502 */     // MIs[0] policy
     /* 2118502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118512 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2118515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118538 */     // GIR_Coverage, 17062,
     /* 2118538 */     GIR_EraseRootFromParent_Done,
     /* 2118539 */   // Label 28048: @2118539
     /* 2118539 */   GIM_Try, /*On fail goto*//*Label 28049*/ GIMT_Encode4(2118630), // Rule ID 17063 //
     /* 2118544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2118555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2118558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118590 */     // MIs[0] round
     /* 2118590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118593 */     // MIs[0] policy
     /* 2118593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118603 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11280:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2118606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118629 */     // GIR_Coverage, 17063,
     /* 2118629 */     GIR_EraseRootFromParent_Done,
     /* 2118630 */   // Label 28049: @2118630
     /* 2118630 */   GIM_Try, /*On fail goto*//*Label 28050*/ GIMT_Encode4(2118721), // Rule ID 17066 //
     /* 2118635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2118638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2118646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2118649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2118652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118681 */     // MIs[0] round
     /* 2118681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118684 */     // MIs[0] policy
     /* 2118684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118694 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2118697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118720 */     // GIR_Coverage, 17066,
     /* 2118720 */     GIR_EraseRootFromParent_Done,
     /* 2118721 */   // Label 28050: @2118721
     /* 2118721 */   GIM_Try, /*On fail goto*//*Label 28051*/ GIMT_Encode4(2118812), // Rule ID 17067 //
     /* 2118726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2118729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2118734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2118737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2118740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2118743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2118746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2118768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118772 */     // MIs[0] round
     /* 2118772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118775 */     // MIs[0] policy
     /* 2118775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118785 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11280:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2118788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118811 */     // GIR_Coverage, 17067,
     /* 2118811 */     GIR_EraseRootFromParent_Done,
     /* 2118812 */   // Label 28051: @2118812
     /* 2118812 */   GIM_Try, /*On fail goto*//*Label 28052*/ GIMT_Encode4(2118903), // Rule ID 17070 //
     /* 2118817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2118820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2118825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2118828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2118831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2118834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2118837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118863 */     // MIs[0] round
     /* 2118863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118866 */     // MIs[0] policy
     /* 2118866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118876 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2118879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118902 */     // GIR_Coverage, 17070,
     /* 2118902 */     GIR_EraseRootFromParent_Done,
     /* 2118903 */   // Label 28052: @2118903
     /* 2118903 */   GIM_Try, /*On fail goto*//*Label 28053*/ GIMT_Encode4(2118994), // Rule ID 17071 //
     /* 2118908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2118911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2118916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2118919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2118922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2118925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2118928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118954 */     // MIs[0] round
     /* 2118954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118957 */     // MIs[0] policy
     /* 2118957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118967 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2118970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118993 */     // GIR_Coverage, 17071,
     /* 2118993 */     GIR_EraseRootFromParent_Done,
     /* 2118994 */   // Label 28053: @2118994
     /* 2118994 */   GIM_Try, /*On fail goto*//*Label 28054*/ GIMT_Encode4(2119085), // Rule ID 17074 //
     /* 2118999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119045 */     // MIs[0] round
     /* 2119045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119048 */     // MIs[0] policy
     /* 2119048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119058 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2119061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119084 */     // GIR_Coverage, 17074,
     /* 2119084 */     GIR_EraseRootFromParent_Done,
     /* 2119085 */   // Label 28054: @2119085
     /* 2119085 */   GIM_Try, /*On fail goto*//*Label 28055*/ GIMT_Encode4(2119176), // Rule ID 17075 //
     /* 2119090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2119101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2119104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2119107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2119110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119136 */     // MIs[0] round
     /* 2119136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119139 */     // MIs[0] policy
     /* 2119139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119149 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2119152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119175 */     // GIR_Coverage, 17075,
     /* 2119175 */     GIR_EraseRootFromParent_Done,
     /* 2119176 */   // Label 28055: @2119176
     /* 2119176 */   GIM_Try, /*On fail goto*//*Label 28056*/ GIMT_Encode4(2119267), // Rule ID 17078 //
     /* 2119181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119227 */     // MIs[0] round
     /* 2119227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119230 */     // MIs[0] policy
     /* 2119230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119240 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2119243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119266 */     // GIR_Coverage, 17078,
     /* 2119266 */     GIR_EraseRootFromParent_Done,
     /* 2119267 */   // Label 28056: @2119267
     /* 2119267 */   GIM_Try, /*On fail goto*//*Label 28057*/ GIMT_Encode4(2119358), // Rule ID 17079 //
     /* 2119272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2119283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2119286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2119289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2119292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119318 */     // MIs[0] round
     /* 2119318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119321 */     // MIs[0] policy
     /* 2119321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119331 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2119334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119357 */     // GIR_Coverage, 17079,
     /* 2119357 */     GIR_EraseRootFromParent_Done,
     /* 2119358 */   // Label 28057: @2119358
     /* 2119358 */   GIM_Try, /*On fail goto*//*Label 28058*/ GIMT_Encode4(2119449), // Rule ID 17082 //
     /* 2119363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2119380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2119383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119409 */     // MIs[0] round
     /* 2119409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119412 */     // MIs[0] policy
     /* 2119412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119422 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2119425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119448 */     // GIR_Coverage, 17082,
     /* 2119448 */     GIR_EraseRootFromParent_Done,
     /* 2119449 */   // Label 28058: @2119449
     /* 2119449 */   GIM_Try, /*On fail goto*//*Label 28059*/ GIMT_Encode4(2119540), // Rule ID 17083 //
     /* 2119454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2119471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2119474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119500 */     // MIs[0] round
     /* 2119500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119503 */     // MIs[0] policy
     /* 2119503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119513 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2119516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119539 */     // GIR_Coverage, 17083,
     /* 2119539 */     GIR_EraseRootFromParent_Done,
     /* 2119540 */   // Label 28059: @2119540
     /* 2119540 */   GIM_Try, /*On fail goto*//*Label 28060*/ GIMT_Encode4(2119631), // Rule ID 17086 //
     /* 2119545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2119548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2119556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2119559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2119562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2119565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2119568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119591 */     // MIs[0] round
     /* 2119591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119594 */     // MIs[0] policy
     /* 2119594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119604 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2119607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119630 */     // GIR_Coverage, 17086,
     /* 2119630 */     GIR_EraseRootFromParent_Done,
     /* 2119631 */   // Label 28060: @2119631
     /* 2119631 */   GIM_Try, /*On fail goto*//*Label 28061*/ GIMT_Encode4(2119722), // Rule ID 17087 //
     /* 2119636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2119639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2119647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2119650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2119653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2119656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2119659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119682 */     // MIs[0] round
     /* 2119682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119685 */     // MIs[0] policy
     /* 2119685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119695 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2119698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2119718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119721 */     // GIR_Coverage, 17087,
     /* 2119721 */     GIR_EraseRootFromParent_Done,
     /* 2119722 */   // Label 28061: @2119722
     /* 2119722 */   GIM_Try, /*On fail goto*//*Label 28062*/ GIMT_Encode4(2119813), // Rule ID 17090 //
     /* 2119727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2119738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2119741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2119744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2119747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119773 */     // MIs[0] round
     /* 2119773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119776 */     // MIs[0] policy
     /* 2119776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119786 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2119789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119812 */     // GIR_Coverage, 17090,
     /* 2119812 */     GIR_EraseRootFromParent_Done,
     /* 2119813 */   // Label 28062: @2119813
     /* 2119813 */   GIM_Try, /*On fail goto*//*Label 28063*/ GIMT_Encode4(2119904), // Rule ID 17091 //
     /* 2119818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2119821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2119829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2119832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2119835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2119838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119864 */     // MIs[0] round
     /* 2119864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119867 */     // MIs[0] policy
     /* 2119867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119877 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2119880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119903 */     // GIR_Coverage, 17091,
     /* 2119903 */     GIR_EraseRootFromParent_Done,
     /* 2119904 */   // Label 28063: @2119904
     /* 2119904 */   GIM_Try, /*On fail goto*//*Label 28064*/ GIMT_Encode4(2119995), // Rule ID 17094 //
     /* 2119909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2119912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2119917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2119920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2119923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2119926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2119929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119955 */     // MIs[0] round
     /* 2119955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119958 */     // MIs[0] policy
     /* 2119958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119968 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2119971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119994 */     // GIR_Coverage, 17094,
     /* 2119994 */     GIR_EraseRootFromParent_Done,
     /* 2119995 */   // Label 28064: @2119995
     /* 2119995 */   GIM_Try, /*On fail goto*//*Label 28065*/ GIMT_Encode4(2120086), // Rule ID 17095 //
     /* 2120000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2120011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2120014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2120020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120046 */     // MIs[0] round
     /* 2120046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120049 */     // MIs[0] policy
     /* 2120049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120059 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2120062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120085 */     // GIR_Coverage, 17095,
     /* 2120085 */     GIR_EraseRootFromParent_Done,
     /* 2120086 */   // Label 28065: @2120086
     /* 2120086 */   GIM_Try, /*On fail goto*//*Label 28066*/ GIMT_Encode4(2120177), // Rule ID 17098 //
     /* 2120091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120137 */     // MIs[0] round
     /* 2120137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120140 */     // MIs[0] policy
     /* 2120140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120150 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2120153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120176 */     // GIR_Coverage, 17098,
     /* 2120176 */     GIR_EraseRootFromParent_Done,
     /* 2120177 */   // Label 28066: @2120177
     /* 2120177 */   GIM_Try, /*On fail goto*//*Label 28067*/ GIMT_Encode4(2120268), // Rule ID 17099 //
     /* 2120182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2120193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2120196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2120199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2120202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2120212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120228 */     // MIs[0] round
     /* 2120228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120231 */     // MIs[0] policy
     /* 2120231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120241 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2120244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120267 */     // GIR_Coverage, 17099,
     /* 2120267 */     GIR_EraseRootFromParent_Done,
     /* 2120268 */   // Label 28067: @2120268
     /* 2120268 */   GIM_Try, /*On fail goto*//*Label 28068*/ GIMT_Encode4(2120359), // Rule ID 17102 //
     /* 2120273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2120276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120319 */     // MIs[0] round
     /* 2120319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120322 */     // MIs[0] policy
     /* 2120322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120332 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2120335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120358 */     // GIR_Coverage, 17102,
     /* 2120358 */     GIR_EraseRootFromParent_Done,
     /* 2120359 */   // Label 28068: @2120359
     /* 2120359 */   GIM_Try, /*On fail goto*//*Label 28069*/ GIMT_Encode4(2120450), // Rule ID 17103 //
     /* 2120364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2120367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2120375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2120378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2120381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2120384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2120387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2120394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2120398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2120406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120410 */     // MIs[0] round
     /* 2120410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120413 */     // MIs[0] policy
     /* 2120413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120423 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2120426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120449 */     // GIR_Coverage, 17103,
     /* 2120449 */     GIR_EraseRootFromParent_Done,
     /* 2120450 */   // Label 28069: @2120450
     /* 2120450 */   GIM_Try, /*On fail goto*//*Label 28070*/ GIMT_Encode4(2120541), // Rule ID 17106 //
     /* 2120455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2120466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2120472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120501 */     // MIs[0] round
     /* 2120501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120504 */     // MIs[0] policy
     /* 2120504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120514 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2120517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120540 */     // GIR_Coverage, 17106,
     /* 2120540 */     GIR_EraseRootFromParent_Done,
     /* 2120541 */   // Label 28070: @2120541
     /* 2120541 */   GIM_Try, /*On fail goto*//*Label 28071*/ GIMT_Encode4(2120632), // Rule ID 17107 //
     /* 2120546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2120557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2120563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120592 */     // MIs[0] round
     /* 2120592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120595 */     // MIs[0] policy
     /* 2120595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120605 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2120608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120631 */     // GIR_Coverage, 17107,
     /* 2120631 */     GIR_EraseRootFromParent_Done,
     /* 2120632 */   // Label 28071: @2120632
     /* 2120632 */   GIM_Try, /*On fail goto*//*Label 28072*/ GIMT_Encode4(2120723), // Rule ID 17110 //
     /* 2120637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2120648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2120651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2120654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120683 */     // MIs[0] round
     /* 2120683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120686 */     // MIs[0] policy
     /* 2120686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120696 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2120699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120722 */     // GIR_Coverage, 17110,
     /* 2120722 */     GIR_EraseRootFromParent_Done,
     /* 2120723 */   // Label 28072: @2120723
     /* 2120723 */   GIM_Try, /*On fail goto*//*Label 28073*/ GIMT_Encode4(2120814), // Rule ID 17111 //
     /* 2120728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2120739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2120742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2120745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120774 */     // MIs[0] round
     /* 2120774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120777 */     // MIs[0] policy
     /* 2120777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120787 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11316:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2120790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120813 */     // GIR_Coverage, 17111,
     /* 2120813 */     GIR_EraseRootFromParent_Done,
     /* 2120814 */   // Label 28073: @2120814
     /* 2120814 */   GIM_Try, /*On fail goto*//*Label 28074*/ GIMT_Encode4(2120905), // Rule ID 17114 //
     /* 2120819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2120822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2120830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2120833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2120836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120865 */     // MIs[0] round
     /* 2120865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120868 */     // MIs[0] policy
     /* 2120868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120878 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2120881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120904 */     // GIR_Coverage, 17114,
     /* 2120904 */     GIR_EraseRootFromParent_Done,
     /* 2120905 */   // Label 28074: @2120905
     /* 2120905 */   GIM_Try, /*On fail goto*//*Label 28075*/ GIMT_Encode4(2120996), // Rule ID 17115 //
     /* 2120910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2120913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2120918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2120921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2120924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2120927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2120940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2120944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120956 */     // MIs[0] round
     /* 2120956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120959 */     // MIs[0] policy
     /* 2120959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120969 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2120972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120995 */     // GIR_Coverage, 17115,
     /* 2120995 */     GIR_EraseRootFromParent_Done,
     /* 2120996 */   // Label 28075: @2120996
     /* 2120996 */   GIM_Try, /*On fail goto*//*Label 28076*/ GIMT_Encode4(2121087), // Rule ID 17118 //
     /* 2121001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121047 */     // MIs[0] round
     /* 2121047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121050 */     // MIs[0] policy
     /* 2121050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121060 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2121063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121086 */     // GIR_Coverage, 17118,
     /* 2121086 */     GIR_EraseRootFromParent_Done,
     /* 2121087 */   // Label 28076: @2121087
     /* 2121087 */   GIM_Try, /*On fail goto*//*Label 28077*/ GIMT_Encode4(2121178), // Rule ID 17119 //
     /* 2121092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121138 */     // MIs[0] round
     /* 2121138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121141 */     // MIs[0] policy
     /* 2121141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121151 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2121154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121177 */     // GIR_Coverage, 17119,
     /* 2121177 */     GIR_EraseRootFromParent_Done,
     /* 2121178 */   // Label 28077: @2121178
     /* 2121178 */   GIM_Try, /*On fail goto*//*Label 28078*/ GIMT_Encode4(2121269), // Rule ID 17122 //
     /* 2121183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2121186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121229 */     // MIs[0] round
     /* 2121229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121232 */     // MIs[0] policy
     /* 2121232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121242 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2121245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121268 */     // GIR_Coverage, 17122,
     /* 2121268 */     GIR_EraseRootFromParent_Done,
     /* 2121269 */   // Label 28078: @2121269
     /* 2121269 */   GIM_Try, /*On fail goto*//*Label 28079*/ GIMT_Encode4(2121360), // Rule ID 17123 //
     /* 2121274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2121277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121320 */     // MIs[0] round
     /* 2121320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121323 */     // MIs[0] policy
     /* 2121323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121333 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2121336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121359 */     // GIR_Coverage, 17123,
     /* 2121359 */     GIR_EraseRootFromParent_Done,
     /* 2121360 */   // Label 28079: @2121360
     /* 2121360 */   GIM_Try, /*On fail goto*//*Label 28080*/ GIMT_Encode4(2121451), // Rule ID 17126 //
     /* 2121365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2121376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2121379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121411 */     // MIs[0] round
     /* 2121411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121414 */     // MIs[0] policy
     /* 2121414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121424 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2121427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121450 */     // GIR_Coverage, 17126,
     /* 2121450 */     GIR_EraseRootFromParent_Done,
     /* 2121451 */   // Label 28080: @2121451
     /* 2121451 */   GIM_Try, /*On fail goto*//*Label 28081*/ GIMT_Encode4(2121542), // Rule ID 17127 //
     /* 2121456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2121467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2121470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2121473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2121479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2121486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121502 */     // MIs[0] round
     /* 2121502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121505 */     // MIs[0] policy
     /* 2121505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121515 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11316:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2121518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121541 */     // GIR_Coverage, 17127,
     /* 2121541 */     GIR_EraseRootFromParent_Done,
     /* 2121542 */   // Label 28081: @2121542
     /* 2121542 */   GIM_Try, /*On fail goto*//*Label 28082*/ GIMT_Encode4(2121633), // Rule ID 17130 //
     /* 2121547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2121558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2121561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2121564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121593 */     // MIs[0] round
     /* 2121593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121596 */     // MIs[0] policy
     /* 2121596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121606 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2121609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121632 */     // GIR_Coverage, 17130,
     /* 2121632 */     GIR_EraseRootFromParent_Done,
     /* 2121633 */   // Label 28082: @2121633
     /* 2121633 */   GIM_Try, /*On fail goto*//*Label 28083*/ GIMT_Encode4(2121724), // Rule ID 17131 //
     /* 2121638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2121649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2121652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2121655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2121661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121684 */     // MIs[0] round
     /* 2121684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121687 */     // MIs[0] policy
     /* 2121687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121697 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11316:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2121700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121723 */     // GIR_Coverage, 17131,
     /* 2121723 */     GIR_EraseRootFromParent_Done,
     /* 2121724 */   // Label 28083: @2121724
     /* 2121724 */   GIM_Try, /*On fail goto*//*Label 28084*/ GIMT_Encode4(2121815), // Rule ID 17134 //
     /* 2121729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2121740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2121743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2121746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121775 */     // MIs[0] round
     /* 2121775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121778 */     // MIs[0] policy
     /* 2121778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121788 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2121791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121814 */     // GIR_Coverage, 17134,
     /* 2121814 */     GIR_EraseRootFromParent_Done,
     /* 2121815 */   // Label 28084: @2121815
     /* 2121815 */   GIM_Try, /*On fail goto*//*Label 28085*/ GIMT_Encode4(2121906), // Rule ID 17135 //
     /* 2121820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2121823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2121831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2121834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2121837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121866 */     // MIs[0] round
     /* 2121866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121869 */     // MIs[0] policy
     /* 2121869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121879 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11316:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2121882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121905 */     // GIR_Coverage, 17135,
     /* 2121905 */     GIR_EraseRootFromParent_Done,
     /* 2121906 */   // Label 28085: @2121906
     /* 2121906 */   GIM_Try, /*On fail goto*//*Label 28086*/ GIMT_Encode4(2121997), // Rule ID 17138 //
     /* 2121911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2121914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2121919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2121922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2121925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2121928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121957 */     // MIs[0] round
     /* 2121957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121960 */     // MIs[0] policy
     /* 2121960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121970 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2121973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121996 */     // GIR_Coverage, 17138,
     /* 2121996 */     GIR_EraseRootFromParent_Done,
     /* 2121997 */   // Label 28086: @2121997
     /* 2121997 */   GIM_Try, /*On fail goto*//*Label 28087*/ GIMT_Encode4(2122088), // Rule ID 17139 //
     /* 2122002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2122010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122048 */     // MIs[0] round
     /* 2122048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122051 */     // MIs[0] policy
     /* 2122051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122061 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11316:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2122064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122087 */     // GIR_Coverage, 17139,
     /* 2122087 */     GIR_EraseRootFromParent_Done,
     /* 2122088 */   // Label 28087: @2122088
     /* 2122088 */   GIM_Try, /*On fail goto*//*Label 28088*/ GIMT_Encode4(2122179), // Rule ID 17148 //
     /* 2122093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122139 */     // MIs[0] round
     /* 2122139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122142 */     // MIs[0] policy
     /* 2122142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122152 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2122155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122178 */     // GIR_Coverage, 17148,
     /* 2122178 */     GIR_EraseRootFromParent_Done,
     /* 2122179 */   // Label 28088: @2122179
     /* 2122179 */   GIM_Try, /*On fail goto*//*Label 28089*/ GIMT_Encode4(2122270), // Rule ID 17149 //
     /* 2122184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2122195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2122198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2122201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122230 */     // MIs[0] round
     /* 2122230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122233 */     // MIs[0] policy
     /* 2122233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122243 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2122246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122269 */     // GIR_Coverage, 17149,
     /* 2122269 */     GIR_EraseRootFromParent_Done,
     /* 2122270 */   // Label 28089: @2122270
     /* 2122270 */   GIM_Try, /*On fail goto*//*Label 28090*/ GIMT_Encode4(2122361), // Rule ID 17158 //
     /* 2122275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2122286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2122289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122321 */     // MIs[0] round
     /* 2122321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122324 */     // MIs[0] policy
     /* 2122324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122334 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2122337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122360 */     // GIR_Coverage, 17158,
     /* 2122360 */     GIR_EraseRootFromParent_Done,
     /* 2122361 */   // Label 28090: @2122361
     /* 2122361 */   GIM_Try, /*On fail goto*//*Label 28091*/ GIMT_Encode4(2122452), // Rule ID 17159 //
     /* 2122366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2122377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2122380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2122383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2122386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122412 */     // MIs[0] round
     /* 2122412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122415 */     // MIs[0] policy
     /* 2122415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122425 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2122428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122451 */     // GIR_Coverage, 17159,
     /* 2122451 */     GIR_EraseRootFromParent_Done,
     /* 2122452 */   // Label 28091: @2122452
     /* 2122452 */   GIM_Try, /*On fail goto*//*Label 28092*/ GIMT_Encode4(2122543), // Rule ID 17168 //
     /* 2122457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2122468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2122471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2122477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122503 */     // MIs[0] round
     /* 2122503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122506 */     // MIs[0] policy
     /* 2122506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122516 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2122519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122542 */     // GIR_Coverage, 17168,
     /* 2122542 */     GIR_EraseRootFromParent_Done,
     /* 2122543 */   // Label 28092: @2122543
     /* 2122543 */   GIM_Try, /*On fail goto*//*Label 28093*/ GIMT_Encode4(2122634), // Rule ID 17169 //
     /* 2122548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2122559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2122562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2122565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2122568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122594 */     // MIs[0] round
     /* 2122594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122597 */     // MIs[0] policy
     /* 2122597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122607 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2122610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122633 */     // GIR_Coverage, 17169,
     /* 2122633 */     GIR_EraseRootFromParent_Done,
     /* 2122634 */   // Label 28093: @2122634
     /* 2122634 */   GIM_Try, /*On fail goto*//*Label 28094*/ GIMT_Encode4(2122725), // Rule ID 17178 //
     /* 2122639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2122642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2122650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2122653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2122656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2122659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2122662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122685 */     // MIs[0] round
     /* 2122685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122688 */     // MIs[0] policy
     /* 2122688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122698 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2122701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122724 */     // GIR_Coverage, 17178,
     /* 2122724 */     GIR_EraseRootFromParent_Done,
     /* 2122725 */   // Label 28094: @2122725
     /* 2122725 */   GIM_Try, /*On fail goto*//*Label 28095*/ GIMT_Encode4(2122816), // Rule ID 17179 //
     /* 2122730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2122733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2122741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2122744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2122747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2122750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2122753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122776 */     // MIs[0] round
     /* 2122776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122779 */     // MIs[0] policy
     /* 2122779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122789 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2122792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122815 */     // GIR_Coverage, 17179,
     /* 2122815 */     GIR_EraseRootFromParent_Done,
     /* 2122816 */   // Label 28095: @2122816
     /* 2122816 */   GIM_Try, /*On fail goto*//*Label 28096*/ GIMT_Encode4(2122907), // Rule ID 17188 //
     /* 2122821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2122824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2122832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2122835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2122838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2122841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122867 */     // MIs[0] round
     /* 2122867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122870 */     // MIs[0] policy
     /* 2122870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122880 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2122883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122906 */     // GIR_Coverage, 17188,
     /* 2122906 */     GIR_EraseRootFromParent_Done,
     /* 2122907 */   // Label 28096: @2122907
     /* 2122907 */   GIM_Try, /*On fail goto*//*Label 28097*/ GIMT_Encode4(2122998), // Rule ID 17189 //
     /* 2122912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2122915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2122920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2122923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2122926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2122929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2122932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122958 */     // MIs[0] round
     /* 2122958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122961 */     // MIs[0] policy
     /* 2122961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122971 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2122974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122997 */     // GIR_Coverage, 17189,
     /* 2122997 */     GIR_EraseRootFromParent_Done,
     /* 2122998 */   // Label 28097: @2122998
     /* 2122998 */   GIM_Try, /*On fail goto*//*Label 28098*/ GIMT_Encode4(2123089), // Rule ID 17198 //
     /* 2123003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123049 */     // MIs[0] round
     /* 2123049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123052 */     // MIs[0] policy
     /* 2123052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123062 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2123065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123088 */     // GIR_Coverage, 17198,
     /* 2123088 */     GIR_EraseRootFromParent_Done,
     /* 2123089 */   // Label 28098: @2123089
     /* 2123089 */   GIM_Try, /*On fail goto*//*Label 28099*/ GIMT_Encode4(2123180), // Rule ID 17199 //
     /* 2123094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2123105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2123108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2123111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123140 */     // MIs[0] round
     /* 2123140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123143 */     // MIs[0] policy
     /* 2123143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123153 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2123156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123179 */     // GIR_Coverage, 17199,
     /* 2123179 */     GIR_EraseRootFromParent_Done,
     /* 2123180 */   // Label 28099: @2123180
     /* 2123180 */   GIM_Try, /*On fail goto*//*Label 28100*/ GIMT_Encode4(2123271), // Rule ID 17208 //
     /* 2123185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2123202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123231 */     // MIs[0] round
     /* 2123231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123234 */     // MIs[0] policy
     /* 2123234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123244 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2123247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123270 */     // GIR_Coverage, 17208,
     /* 2123270 */     GIR_EraseRootFromParent_Done,
     /* 2123271 */   // Label 28100: @2123271
     /* 2123271 */   GIM_Try, /*On fail goto*//*Label 28101*/ GIMT_Encode4(2123362), // Rule ID 17209 //
     /* 2123276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2123287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2123290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2123293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2123296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123322 */     // MIs[0] round
     /* 2123322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123325 */     // MIs[0] policy
     /* 2123325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123335 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2123338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123361 */     // GIR_Coverage, 17209,
     /* 2123361 */     GIR_EraseRootFromParent_Done,
     /* 2123362 */   // Label 28101: @2123362
     /* 2123362 */   GIM_Try, /*On fail goto*//*Label 28102*/ GIMT_Encode4(2123453), // Rule ID 17218 //
     /* 2123367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2123370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2123378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2123381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2123384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123413 */     // MIs[0] round
     /* 2123413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123416 */     // MIs[0] policy
     /* 2123416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123426 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2123429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123452 */     // GIR_Coverage, 17218,
     /* 2123452 */     GIR_EraseRootFromParent_Done,
     /* 2123453 */   // Label 28102: @2123453
     /* 2123453 */   GIM_Try, /*On fail goto*//*Label 28103*/ GIMT_Encode4(2123544), // Rule ID 17219 //
     /* 2123458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2123461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2123469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2123472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2123475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2123478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2123488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2123496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2123500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123504 */     // MIs[0] round
     /* 2123504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123507 */     // MIs[0] policy
     /* 2123507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123517 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2123520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123543 */     // GIR_Coverage, 17219,
     /* 2123543 */     GIR_EraseRootFromParent_Done,
     /* 2123544 */   // Label 28103: @2123544
     /* 2123544 */   GIM_Try, /*On fail goto*//*Label 28104*/ GIMT_Encode4(2123635), // Rule ID 17222 //
     /* 2123549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2123560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2123563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2123566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123595 */     // MIs[0] round
     /* 2123595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123598 */     // MIs[0] policy
     /* 2123598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2123611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123634 */     // GIR_Coverage, 17222,
     /* 2123634 */     GIR_EraseRootFromParent_Done,
     /* 2123635 */   // Label 28104: @2123635
     /* 2123635 */   GIM_Try, /*On fail goto*//*Label 28105*/ GIMT_Encode4(2123726), // Rule ID 17223 //
     /* 2123640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2123651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2123654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2123657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123686 */     // MIs[0] round
     /* 2123686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123689 */     // MIs[0] policy
     /* 2123689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123699 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2123702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123725 */     // GIR_Coverage, 17223,
     /* 2123725 */     GIR_EraseRootFromParent_Done,
     /* 2123726 */   // Label 28105: @2123726
     /* 2123726 */   GIM_Try, /*On fail goto*//*Label 28106*/ GIMT_Encode4(2123817), // Rule ID 17226 //
     /* 2123731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2123742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2123745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2123748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123777 */     // MIs[0] round
     /* 2123777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123780 */     // MIs[0] policy
     /* 2123780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123790 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2123793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123816 */     // GIR_Coverage, 17226,
     /* 2123816 */     GIR_EraseRootFromParent_Done,
     /* 2123817 */   // Label 28106: @2123817
     /* 2123817 */   GIM_Try, /*On fail goto*//*Label 28107*/ GIMT_Encode4(2123908), // Rule ID 17227 //
     /* 2123822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2123825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2123833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2123836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2123839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123868 */     // MIs[0] round
     /* 2123868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123871 */     // MIs[0] policy
     /* 2123871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123881 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11282:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2123884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123907 */     // GIR_Coverage, 17227,
     /* 2123907 */     GIR_EraseRootFromParent_Done,
     /* 2123908 */   // Label 28107: @2123908
     /* 2123908 */   GIM_Try, /*On fail goto*//*Label 28108*/ GIMT_Encode4(2123999), // Rule ID 17230 //
     /* 2123913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2123916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2123921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2123924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2123927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2123930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2123933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2123955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123959 */     // MIs[0] round
     /* 2123959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123962 */     // MIs[0] policy
     /* 2123962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123972 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2123975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123998 */     // GIR_Coverage, 17230,
     /* 2123998 */     GIR_EraseRootFromParent_Done,
     /* 2123999 */   // Label 28108: @2123999
     /* 2123999 */   GIM_Try, /*On fail goto*//*Label 28109*/ GIMT_Encode4(2124090), // Rule ID 17231 //
     /* 2124004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2124021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124050 */     // MIs[0] round
     /* 2124050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124053 */     // MIs[0] policy
     /* 2124053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124063 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2124066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124089 */     // GIR_Coverage, 17231,
     /* 2124089 */     GIR_EraseRootFromParent_Done,
     /* 2124090 */   // Label 28109: @2124090
     /* 2124090 */   GIM_Try, /*On fail goto*//*Label 28110*/ GIMT_Encode4(2124181), // Rule ID 17234 //
     /* 2124095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124141 */     // MIs[0] round
     /* 2124141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124144 */     // MIs[0] policy
     /* 2124144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124154 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2124157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124180 */     // GIR_Coverage, 17234,
     /* 2124180 */     GIR_EraseRootFromParent_Done,
     /* 2124181 */   // Label 28110: @2124181
     /* 2124181 */   GIM_Try, /*On fail goto*//*Label 28111*/ GIMT_Encode4(2124272), // Rule ID 17235 //
     /* 2124186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124232 */     // MIs[0] round
     /* 2124232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124235 */     // MIs[0] policy
     /* 2124235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124245 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2124248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124271 */     // GIR_Coverage, 17235,
     /* 2124271 */     GIR_EraseRootFromParent_Done,
     /* 2124272 */   // Label 28111: @2124272
     /* 2124272 */   GIM_Try, /*On fail goto*//*Label 28112*/ GIMT_Encode4(2124363), // Rule ID 17238 //
     /* 2124277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2124280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124323 */     // MIs[0] round
     /* 2124323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124326 */     // MIs[0] policy
     /* 2124326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124336 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2124339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124362 */     // GIR_Coverage, 17238,
     /* 2124362 */     GIR_EraseRootFromParent_Done,
     /* 2124363 */   // Label 28112: @2124363
     /* 2124363 */   GIM_Try, /*On fail goto*//*Label 28113*/ GIMT_Encode4(2124454), // Rule ID 17239 //
     /* 2124368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2124371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2124388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2124410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124414 */     // MIs[0] round
     /* 2124414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124417 */     // MIs[0] policy
     /* 2124417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124427 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2124430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124453 */     // GIR_Coverage, 17239,
     /* 2124453 */     GIR_EraseRootFromParent_Done,
     /* 2124454 */   // Label 28113: @2124454
     /* 2124454 */   GIM_Try, /*On fail goto*//*Label 28114*/ GIMT_Encode4(2124545), // Rule ID 17242 //
     /* 2124459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2124462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2124470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2124473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2124476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124505 */     // MIs[0] round
     /* 2124505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124508 */     // MIs[0] policy
     /* 2124508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124518 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2124521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124544 */     // GIR_Coverage, 17242,
     /* 2124544 */     GIR_EraseRootFromParent_Done,
     /* 2124545 */   // Label 28114: @2124545
     /* 2124545 */   GIM_Try, /*On fail goto*//*Label 28115*/ GIMT_Encode4(2124636), // Rule ID 17243 //
     /* 2124550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2124553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2124561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2124564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2124567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2124573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2124580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2124588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124596 */     // MIs[0] round
     /* 2124596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124599 */     // MIs[0] policy
     /* 2124599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124609 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11282:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2124612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124635 */     // GIR_Coverage, 17243,
     /* 2124635 */     GIR_EraseRootFromParent_Done,
     /* 2124636 */   // Label 28115: @2124636
     /* 2124636 */   GIM_Try, /*On fail goto*//*Label 28116*/ GIMT_Encode4(2124727), // Rule ID 17246 //
     /* 2124641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2124644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2124652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2124655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2124658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124687 */     // MIs[0] round
     /* 2124687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124690 */     // MIs[0] policy
     /* 2124690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124700 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2124703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124726 */     // GIR_Coverage, 17246,
     /* 2124726 */     GIR_EraseRootFromParent_Done,
     /* 2124727 */   // Label 28116: @2124727
     /* 2124727 */   GIM_Try, /*On fail goto*//*Label 28117*/ GIMT_Encode4(2124818), // Rule ID 17247 //
     /* 2124732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2124735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2124743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2124746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2124749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124778 */     // MIs[0] round
     /* 2124778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124781 */     // MIs[0] policy
     /* 2124781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124791 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11282:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2124794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124817 */     // GIR_Coverage, 17247,
     /* 2124817 */     GIR_EraseRootFromParent_Done,
     /* 2124818 */   // Label 28117: @2124818
     /* 2124818 */   GIM_Try, /*On fail goto*//*Label 28118*/ GIMT_Encode4(2124909), // Rule ID 17250 //
     /* 2124823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2124826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2124834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2124837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2124840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124869 */     // MIs[0] round
     /* 2124869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124872 */     // MIs[0] policy
     /* 2124872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124882 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2124885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124908 */     // GIR_Coverage, 17250,
     /* 2124908 */     GIR_EraseRootFromParent_Done,
     /* 2124909 */   // Label 28118: @2124909
     /* 2124909 */   GIM_Try, /*On fail goto*//*Label 28119*/ GIMT_Encode4(2125000), // Rule ID 17251 //
     /* 2124914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2124917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2124922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2124925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2124928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2124931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2124934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2124956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124960 */     // MIs[0] round
     /* 2124960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124963 */     // MIs[0] policy
     /* 2124963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124973 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11282:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2124976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124999 */     // GIR_Coverage, 17251,
     /* 2124999 */     GIR_EraseRootFromParent_Done,
     /* 2125000 */   // Label 28119: @2125000
     /* 2125000 */   GIM_Try, /*On fail goto*//*Label 28120*/ GIMT_Encode4(2125091), // Rule ID 17254 //
     /* 2125005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2125008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125051 */     // MIs[0] round
     /* 2125051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125054 */     // MIs[0] policy
     /* 2125054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125064 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2125067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125090 */     // GIR_Coverage, 17254,
     /* 2125090 */     GIR_EraseRootFromParent_Done,
     /* 2125091 */   // Label 28120: @2125091
     /* 2125091 */   GIM_Try, /*On fail goto*//*Label 28121*/ GIMT_Encode4(2125182), // Rule ID 17255 //
     /* 2125096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2125099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2125104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125142 */     // MIs[0] round
     /* 2125142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125145 */     // MIs[0] policy
     /* 2125145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125155 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11282:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2125158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125181 */     // GIR_Coverage, 17255,
     /* 2125181 */     GIR_EraseRootFromParent_Done,
     /* 2125182 */   // Label 28121: @2125182
     /* 2125182 */   GIM_Try, /*On fail goto*//*Label 28122*/ GIMT_Encode4(2125273), // Rule ID 17264 //
     /* 2125187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2125207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125233 */     // MIs[0] round
     /* 2125233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125236 */     // MIs[0] policy
     /* 2125236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125246 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2125249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125272 */     // GIR_Coverage, 17264,
     /* 2125272 */     GIR_EraseRootFromParent_Done,
     /* 2125273 */   // Label 28122: @2125273
     /* 2125273 */   GIM_Try, /*On fail goto*//*Label 28123*/ GIMT_Encode4(2125364), // Rule ID 17265 //
     /* 2125278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2125298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125324 */     // MIs[0] round
     /* 2125324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125327 */     // MIs[0] policy
     /* 2125327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125337 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2125340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125363 */     // GIR_Coverage, 17265,
     /* 2125363 */     GIR_EraseRootFromParent_Done,
     /* 2125364 */   // Label 28123: @2125364
     /* 2125364 */   GIM_Try, /*On fail goto*//*Label 28124*/ GIMT_Encode4(2125455), // Rule ID 17274 //
     /* 2125369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2125389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125415 */     // MIs[0] round
     /* 2125415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125418 */     // MIs[0] policy
     /* 2125418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125428 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2125431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125454 */     // GIR_Coverage, 17274,
     /* 2125454 */     GIR_EraseRootFromParent_Done,
     /* 2125455 */   // Label 28124: @2125455
     /* 2125455 */   GIM_Try, /*On fail goto*//*Label 28125*/ GIMT_Encode4(2125546), // Rule ID 17275 //
     /* 2125460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2125471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2125474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2125477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2125480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125506 */     // MIs[0] round
     /* 2125506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125509 */     // MIs[0] policy
     /* 2125509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125519 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2125522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125545 */     // GIR_Coverage, 17275,
     /* 2125545 */     GIR_EraseRootFromParent_Done,
     /* 2125546 */   // Label 28125: @2125546
     /* 2125546 */   GIM_Try, /*On fail goto*//*Label 28126*/ GIMT_Encode4(2125637), // Rule ID 17284 //
     /* 2125551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2125562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2125565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2125568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2125571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125597 */     // MIs[0] round
     /* 2125597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125600 */     // MIs[0] policy
     /* 2125600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125610 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2125613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125636 */     // GIR_Coverage, 17284,
     /* 2125636 */     GIR_EraseRootFromParent_Done,
     /* 2125637 */   // Label 28126: @2125637
     /* 2125637 */   GIM_Try, /*On fail goto*//*Label 28127*/ GIMT_Encode4(2125728), // Rule ID 17285 //
     /* 2125642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2125653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2125656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2125659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2125662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2125672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125688 */     // MIs[0] round
     /* 2125688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125691 */     // MIs[0] policy
     /* 2125691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125701 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2125704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125727 */     // GIR_Coverage, 17285,
     /* 2125727 */     GIR_EraseRootFromParent_Done,
     /* 2125728 */   // Label 28127: @2125728
     /* 2125728 */   GIM_Try, /*On fail goto*//*Label 28128*/ GIMT_Encode4(2125819), // Rule ID 17294 //
     /* 2125733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2125744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2125747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2125750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2125753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125779 */     // MIs[0] round
     /* 2125779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125782 */     // MIs[0] policy
     /* 2125782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125792 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2125795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125818 */     // GIR_Coverage, 17294,
     /* 2125818 */     GIR_EraseRootFromParent_Done,
     /* 2125819 */   // Label 28128: @2125819
     /* 2125819 */   GIM_Try, /*On fail goto*//*Label 28129*/ GIMT_Encode4(2125910), // Rule ID 17295 //
     /* 2125824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2125827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2125835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2125838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2125841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2125844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125870 */     // MIs[0] round
     /* 2125870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125873 */     // MIs[0] policy
     /* 2125873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125883 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2125886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125909 */     // GIR_Coverage, 17295,
     /* 2125909 */     GIR_EraseRootFromParent_Done,
     /* 2125910 */   // Label 28129: @2125910
     /* 2125910 */   GIM_Try, /*On fail goto*//*Label 28130*/ GIMT_Encode4(2126001), // Rule ID 17304 //
     /* 2125915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2125918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2125923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2125926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2125929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2125932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2125935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2125938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125961 */     // MIs[0] round
     /* 2125961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125964 */     // MIs[0] policy
     /* 2125964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125974 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2125977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126000 */     // GIR_Coverage, 17304,
     /* 2126000 */     GIR_EraseRootFromParent_Done,
     /* 2126001 */   // Label 28130: @2126001
     /* 2126001 */   GIM_Try, /*On fail goto*//*Label 28131*/ GIMT_Encode4(2126092), // Rule ID 17305 //
     /* 2126006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2126017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2126020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2126023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2126026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126052 */     // MIs[0] round
     /* 2126052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126055 */     // MIs[0] policy
     /* 2126055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126065 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2126068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126091 */     // GIR_Coverage, 17305,
     /* 2126091 */     GIR_EraseRootFromParent_Done,
     /* 2126092 */   // Label 28131: @2126092
     /* 2126092 */   GIM_Try, /*On fail goto*//*Label 28132*/ GIMT_Encode4(2126183), // Rule ID 17314 //
     /* 2126097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126143 */     // MIs[0] round
     /* 2126143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126146 */     // MIs[0] policy
     /* 2126146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126156 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2126159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126182 */     // GIR_Coverage, 17314,
     /* 2126182 */     GIR_EraseRootFromParent_Done,
     /* 2126183 */   // Label 28132: @2126183
     /* 2126183 */   GIM_Try, /*On fail goto*//*Label 28133*/ GIMT_Encode4(2126274), // Rule ID 17315 //
     /* 2126188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2126208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126234 */     // MIs[0] round
     /* 2126234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126237 */     // MIs[0] policy
     /* 2126237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126247 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2126250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126273 */     // GIR_Coverage, 17315,
     /* 2126273 */     GIR_EraseRootFromParent_Done,
     /* 2126274 */   // Label 28133: @2126274
     /* 2126274 */   GIM_Try, /*On fail goto*//*Label 28134*/ GIMT_Encode4(2126365), // Rule ID 17324 //
     /* 2126279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126325 */     // MIs[0] round
     /* 2126325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126328 */     // MIs[0] policy
     /* 2126328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126338 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2126341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126364 */     // GIR_Coverage, 17324,
     /* 2126364 */     GIR_EraseRootFromParent_Done,
     /* 2126365 */   // Label 28134: @2126365
     /* 2126365 */   GIM_Try, /*On fail goto*//*Label 28135*/ GIMT_Encode4(2126456), // Rule ID 17325 //
     /* 2126370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2126381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2126384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2126387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2126390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126416 */     // MIs[0] round
     /* 2126416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126419 */     // MIs[0] policy
     /* 2126419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126429 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2126432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126455 */     // GIR_Coverage, 17325,
     /* 2126455 */     GIR_EraseRootFromParent_Done,
     /* 2126456 */   // Label 28135: @2126456
     /* 2126456 */   GIM_Try, /*On fail goto*//*Label 28136*/ GIMT_Encode4(2126547), // Rule ID 17334 //
     /* 2126461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2126472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2126475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2126478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2126481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126507 */     // MIs[0] round
     /* 2126507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126510 */     // MIs[0] policy
     /* 2126510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126520 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2126523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126546 */     // GIR_Coverage, 17334,
     /* 2126546 */     GIR_EraseRootFromParent_Done,
     /* 2126547 */   // Label 28136: @2126547
     /* 2126547 */   GIM_Try, /*On fail goto*//*Label 28137*/ GIMT_Encode4(2126638), // Rule ID 17335 //
     /* 2126552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2126563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2126566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2126569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2126572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126598 */     // MIs[0] round
     /* 2126598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126601 */     // MIs[0] policy
     /* 2126601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126611 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2126614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126637 */     // GIR_Coverage, 17335,
     /* 2126637 */     GIR_EraseRootFromParent_Done,
     /* 2126638 */   // Label 28137: @2126638
     /* 2126638 */   GIM_Try, /*On fail goto*//*Label 28138*/ GIMT_Encode4(2126729), // Rule ID 17344 //
     /* 2126643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2126646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2126654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2126657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2126660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2126663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126689 */     // MIs[0] round
     /* 2126689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126692 */     // MIs[0] policy
     /* 2126692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126702 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2126705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126728 */     // GIR_Coverage, 17344,
     /* 2126728 */     GIR_EraseRootFromParent_Done,
     /* 2126729 */   // Label 28138: @2126729
     /* 2126729 */   GIM_Try, /*On fail goto*//*Label 28139*/ GIMT_Encode4(2126820), // Rule ID 17345 //
     /* 2126734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2126737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2126745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2126748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2126751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2126754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126780 */     // MIs[0] round
     /* 2126780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126783 */     // MIs[0] policy
     /* 2126783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126793 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2126796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126819 */     // GIR_Coverage, 17345,
     /* 2126819 */     GIR_EraseRootFromParent_Done,
     /* 2126820 */   // Label 28139: @2126820
     /* 2126820 */   GIM_Try, /*On fail goto*//*Label 28140*/ GIMT_Encode4(2126911), // Rule ID 17348 //
     /* 2126825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2126828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2126836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2126839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2126842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126871 */     // MIs[0] round
     /* 2126871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126874 */     // MIs[0] policy
     /* 2126874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126884 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2126887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126910 */     // GIR_Coverage, 17348,
     /* 2126910 */     GIR_EraseRootFromParent_Done,
     /* 2126911 */   // Label 28140: @2126911
     /* 2126911 */   GIM_Try, /*On fail goto*//*Label 28141*/ GIMT_Encode4(2127002), // Rule ID 17349 //
     /* 2126916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2126919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2126924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2126927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2126930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2126933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126962 */     // MIs[0] round
     /* 2126962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126965 */     // MIs[0] policy
     /* 2126965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126975 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2126978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127001 */     // GIR_Coverage, 17349,
     /* 2127001 */     GIR_EraseRootFromParent_Done,
     /* 2127002 */   // Label 28141: @2127002
     /* 2127002 */   GIM_Try, /*On fail goto*//*Label 28142*/ GIMT_Encode4(2127093), // Rule ID 17352 //
     /* 2127007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127053 */     // MIs[0] round
     /* 2127053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127056 */     // MIs[0] policy
     /* 2127056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127066 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2127069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127092 */     // GIR_Coverage, 17352,
     /* 2127092 */     GIR_EraseRootFromParent_Done,
     /* 2127093 */   // Label 28142: @2127093
     /* 2127093 */   GIM_Try, /*On fail goto*//*Label 28143*/ GIMT_Encode4(2127184), // Rule ID 17353 //
     /* 2127098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2127109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2127112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2127115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127144 */     // MIs[0] round
     /* 2127144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127147 */     // MIs[0] policy
     /* 2127147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127157 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11318:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2127160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127183 */     // GIR_Coverage, 17353,
     /* 2127183 */     GIR_EraseRootFromParent_Done,
     /* 2127184 */   // Label 28143: @2127184
     /* 2127184 */   GIM_Try, /*On fail goto*//*Label 28144*/ GIMT_Encode4(2127275), // Rule ID 17356 //
     /* 2127189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127235 */     // MIs[0] round
     /* 2127235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127238 */     // MIs[0] policy
     /* 2127238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127248 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2127251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127274 */     // GIR_Coverage, 17356,
     /* 2127274 */     GIR_EraseRootFromParent_Done,
     /* 2127275 */   // Label 28144: @2127275
     /* 2127275 */   GIM_Try, /*On fail goto*//*Label 28145*/ GIMT_Encode4(2127366), // Rule ID 17357 //
     /* 2127280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127326 */     // MIs[0] round
     /* 2127326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127329 */     // MIs[0] policy
     /* 2127329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127339 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2127342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127365 */     // GIR_Coverage, 17357,
     /* 2127365 */     GIR_EraseRootFromParent_Done,
     /* 2127366 */   // Label 28145: @2127366
     /* 2127366 */   GIM_Try, /*On fail goto*//*Label 28146*/ GIMT_Encode4(2127457), // Rule ID 17360 //
     /* 2127371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127417 */     // MIs[0] round
     /* 2127417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127420 */     // MIs[0] policy
     /* 2127420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127430 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2127433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127456 */     // GIR_Coverage, 17360,
     /* 2127456 */     GIR_EraseRootFromParent_Done,
     /* 2127457 */   // Label 28146: @2127457
     /* 2127457 */   GIM_Try, /*On fail goto*//*Label 28147*/ GIMT_Encode4(2127548), // Rule ID 17361 //
     /* 2127462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127508 */     // MIs[0] round
     /* 2127508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127511 */     // MIs[0] policy
     /* 2127511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127521 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2127524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127547 */     // GIR_Coverage, 17361,
     /* 2127547 */     GIR_EraseRootFromParent_Done,
     /* 2127548 */   // Label 28147: @2127548
     /* 2127548 */   GIM_Try, /*On fail goto*//*Label 28148*/ GIMT_Encode4(2127639), // Rule ID 17364 //
     /* 2127553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2127556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2127564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2127567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2127570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2127576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127599 */     // MIs[0] round
     /* 2127599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127602 */     // MIs[0] policy
     /* 2127602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127612 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2127615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127638 */     // GIR_Coverage, 17364,
     /* 2127638 */     GIR_EraseRootFromParent_Done,
     /* 2127639 */   // Label 28148: @2127639
     /* 2127639 */   GIM_Try, /*On fail goto*//*Label 28149*/ GIMT_Encode4(2127730), // Rule ID 17365 //
     /* 2127644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2127647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2127655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2127658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2127661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2127664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2127667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127690 */     // MIs[0] round
     /* 2127690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127693 */     // MIs[0] policy
     /* 2127693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127703 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2127706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127729 */     // GIR_Coverage, 17365,
     /* 2127729 */     GIR_EraseRootFromParent_Done,
     /* 2127730 */   // Label 28149: @2127730
     /* 2127730 */   GIM_Try, /*On fail goto*//*Label 28150*/ GIMT_Encode4(2127821), // Rule ID 17368 //
     /* 2127735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2127738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2127746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2127749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2127752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127781 */     // MIs[0] round
     /* 2127781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127784 */     // MIs[0] policy
     /* 2127784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127794 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2127797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127820 */     // GIR_Coverage, 17368,
     /* 2127820 */     GIR_EraseRootFromParent_Done,
     /* 2127821 */   // Label 28150: @2127821
     /* 2127821 */   GIM_Try, /*On fail goto*//*Label 28151*/ GIMT_Encode4(2127912), // Rule ID 17369 //
     /* 2127826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2127829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2127837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2127840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2127843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2127849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2127856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2127864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127872 */     // MIs[0] round
     /* 2127872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127875 */     // MIs[0] policy
     /* 2127875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127885 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11318:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2127888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127911 */     // GIR_Coverage, 17369,
     /* 2127911 */     GIR_EraseRootFromParent_Done,
     /* 2127912 */   // Label 28151: @2127912
     /* 2127912 */   GIM_Try, /*On fail goto*//*Label 28152*/ GIMT_Encode4(2128003), // Rule ID 17372 //
     /* 2127917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2127920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2127925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2127928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2127931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2127934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127963 */     // MIs[0] round
     /* 2127963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127966 */     // MIs[0] policy
     /* 2127966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127976 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2127979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128002 */     // GIR_Coverage, 17372,
     /* 2128002 */     GIR_EraseRootFromParent_Done,
     /* 2128003 */   // Label 28152: @2128003
     /* 2128003 */   GIM_Try, /*On fail goto*//*Label 28153*/ GIMT_Encode4(2128094), // Rule ID 17373 //
     /* 2128008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2128019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2128022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2128025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2128038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2128046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128054 */     // MIs[0] round
     /* 2128054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128057 */     // MIs[0] policy
     /* 2128057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128067 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11318:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2128070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128093 */     // GIR_Coverage, 17373,
     /* 2128093 */     GIR_EraseRootFromParent_Done,
     /* 2128094 */   // Label 28153: @2128094
     /* 2128094 */   GIM_Try, /*On fail goto*//*Label 28154*/ GIMT_Encode4(2128185), // Rule ID 17376 //
     /* 2128099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128145 */     // MIs[0] round
     /* 2128145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128148 */     // MIs[0] policy
     /* 2128148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128158 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2128161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128184 */     // GIR_Coverage, 17376,
     /* 2128184 */     GIR_EraseRootFromParent_Done,
     /* 2128185 */   // Label 28154: @2128185
     /* 2128185 */   GIM_Try, /*On fail goto*//*Label 28155*/ GIMT_Encode4(2128276), // Rule ID 17377 //
     /* 2128190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2128201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2128204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2128207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2128220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2128228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128236 */     // MIs[0] round
     /* 2128236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128239 */     // MIs[0] policy
     /* 2128239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128249 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11318:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2128252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128275 */     // GIR_Coverage, 17377,
     /* 2128275 */     GIR_EraseRootFromParent_Done,
     /* 2128276 */   // Label 28155: @2128276
     /* 2128276 */   GIM_Try, /*On fail goto*//*Label 28156*/ GIMT_Encode4(2128367), // Rule ID 17380 //
     /* 2128281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2128284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128327 */     // MIs[0] round
     /* 2128327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128330 */     // MIs[0] policy
     /* 2128330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128340 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2128343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128366 */     // GIR_Coverage, 17380,
     /* 2128366 */     GIR_EraseRootFromParent_Done,
     /* 2128367 */   // Label 28156: @2128367
     /* 2128367 */   GIM_Try, /*On fail goto*//*Label 28157*/ GIMT_Encode4(2128458), // Rule ID 17381 //
     /* 2128372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2128375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2128380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128418 */     // MIs[0] round
     /* 2128418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128421 */     // MIs[0] policy
     /* 2128421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128431 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11318:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2128434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128457 */     // GIR_Coverage, 17381,
     /* 2128457 */     GIR_EraseRootFromParent_Done,
     /* 2128458 */   // Label 28157: @2128458
     /* 2128458 */   GIM_Try, /*On fail goto*//*Label 28158*/ GIMT_Encode4(2128549), // Rule ID 17384 //
     /* 2128463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2128474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2128477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2128480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2128483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128509 */     // MIs[0] round
     /* 2128509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128512 */     // MIs[0] policy
     /* 2128512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128522 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2128525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128548 */     // GIR_Coverage, 17384,
     /* 2128548 */     GIR_EraseRootFromParent_Done,
     /* 2128549 */   // Label 28158: @2128549
     /* 2128549 */   GIM_Try, /*On fail goto*//*Label 28159*/ GIMT_Encode4(2128640), // Rule ID 17385 //
     /* 2128554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2128565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2128568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2128571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2128574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128600 */     // MIs[0] round
     /* 2128600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128603 */     // MIs[0] policy
     /* 2128603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128613 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2128616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128639 */     // GIR_Coverage, 17385,
     /* 2128639 */     GIR_EraseRootFromParent_Done,
     /* 2128640 */   // Label 28159: @2128640
     /* 2128640 */   GIM_Try, /*On fail goto*//*Label 28160*/ GIMT_Encode4(2128731), // Rule ID 17388 //
     /* 2128645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2128656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2128659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2128662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2128665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128691 */     // MIs[0] round
     /* 2128691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128694 */     // MIs[0] policy
     /* 2128694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128704 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2128707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128730 */     // GIR_Coverage, 17388,
     /* 2128730 */     GIR_EraseRootFromParent_Done,
     /* 2128731 */   // Label 28160: @2128731
     /* 2128731 */   GIM_Try, /*On fail goto*//*Label 28161*/ GIMT_Encode4(2128822), // Rule ID 17389 //
     /* 2128736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2128747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2128750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2128753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2128756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128782 */     // MIs[0] round
     /* 2128782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128785 */     // MIs[0] policy
     /* 2128785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128795 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2128798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128821 */     // GIR_Coverage, 17389,
     /* 2128821 */     GIR_EraseRootFromParent_Done,
     /* 2128822 */   // Label 28161: @2128822
     /* 2128822 */   GIM_Try, /*On fail goto*//*Label 28162*/ GIMT_Encode4(2128913), // Rule ID 17392 //
     /* 2128827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2128830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2128838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2128841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2128844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2128847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128873 */     // MIs[0] round
     /* 2128873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128876 */     // MIs[0] policy
     /* 2128876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128886 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2128889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128912 */     // GIR_Coverage, 17392,
     /* 2128912 */     GIR_EraseRootFromParent_Done,
     /* 2128913 */   // Label 28162: @2128913
     /* 2128913 */   GIM_Try, /*On fail goto*//*Label 28163*/ GIMT_Encode4(2129004), // Rule ID 17393 //
     /* 2128918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2128921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2128926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2128929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2128932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2128935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2128938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128964 */     // MIs[0] round
     /* 2128964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128967 */     // MIs[0] policy
     /* 2128967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128977 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2128980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129003 */     // GIR_Coverage, 17393,
     /* 2129003 */     GIR_EraseRootFromParent_Done,
     /* 2129004 */   // Label 28163: @2129004
     /* 2129004 */   GIM_Try, /*On fail goto*//*Label 28164*/ GIMT_Encode4(2129095), // Rule ID 17396 //
     /* 2129009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2129020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2129023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2129026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129055 */     // MIs[0] round
     /* 2129055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129058 */     // MIs[0] policy
     /* 2129058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129068 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2129071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129094 */     // GIR_Coverage, 17396,
     /* 2129094 */     GIR_EraseRootFromParent_Done,
     /* 2129095 */   // Label 28164: @2129095
     /* 2129095 */   GIM_Try, /*On fail goto*//*Label 28165*/ GIMT_Encode4(2129186), // Rule ID 17397 //
     /* 2129100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2129111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2129114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2129117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2129120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129146 */     // MIs[0] round
     /* 2129146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129149 */     // MIs[0] policy
     /* 2129149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129159 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2129162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129185 */     // GIR_Coverage, 17397,
     /* 2129185 */     GIR_EraseRootFromParent_Done,
     /* 2129186 */   // Label 28165: @2129186
     /* 2129186 */   GIM_Try, /*On fail goto*//*Label 28166*/ GIMT_Encode4(2129277), // Rule ID 17400 //
     /* 2129191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2129194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2129211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129237 */     // MIs[0] round
     /* 2129237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129240 */     // MIs[0] policy
     /* 2129240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129250 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2129253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129276 */     // GIR_Coverage, 17400,
     /* 2129276 */     GIR_EraseRootFromParent_Done,
     /* 2129277 */   // Label 28166: @2129277
     /* 2129277 */   GIM_Try, /*On fail goto*//*Label 28167*/ GIMT_Encode4(2129368), // Rule ID 17401 //
     /* 2129282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2129285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2129293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2129296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2129299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2129302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2129305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129328 */     // MIs[0] round
     /* 2129328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129331 */     // MIs[0] policy
     /* 2129331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129341 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2129344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129367 */     // GIR_Coverage, 17401,
     /* 2129367 */     GIR_EraseRootFromParent_Done,
     /* 2129368 */   // Label 28167: @2129368
     /* 2129368 */   GIM_Try, /*On fail goto*//*Label 28168*/ GIMT_Encode4(2129459), // Rule ID 17404 //
     /* 2129373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2129376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2129393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129419 */     // MIs[0] round
     /* 2129419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129422 */     // MIs[0] policy
     /* 2129422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129432 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2129435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129458 */     // GIR_Coverage, 17404,
     /* 2129458 */     GIR_EraseRootFromParent_Done,
     /* 2129459 */   // Label 28168: @2129459
     /* 2129459 */   GIM_Try, /*On fail goto*//*Label 28169*/ GIMT_Encode4(2129550), // Rule ID 17405 //
     /* 2129464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2129467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2129484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129510 */     // MIs[0] round
     /* 2129510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129513 */     // MIs[0] policy
     /* 2129513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129523 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2129526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129549 */     // GIR_Coverage, 17405,
     /* 2129549 */     GIR_EraseRootFromParent_Done,
     /* 2129550 */   // Label 28169: @2129550
     /* 2129550 */   GIM_Try, /*On fail goto*//*Label 28170*/ GIMT_Encode4(2129641), // Rule ID 17408 //
     /* 2129555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2129566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2129569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2129572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2129575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129601 */     // MIs[0] round
     /* 2129601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129604 */     // MIs[0] policy
     /* 2129604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129614 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2129617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129640 */     // GIR_Coverage, 17408,
     /* 2129640 */     GIR_EraseRootFromParent_Done,
     /* 2129641 */   // Label 28170: @2129641
     /* 2129641 */   GIM_Try, /*On fail goto*//*Label 28171*/ GIMT_Encode4(2129732), // Rule ID 17409 //
     /* 2129646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2129657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2129660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2129663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2129666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129692 */     // MIs[0] round
     /* 2129692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129695 */     // MIs[0] policy
     /* 2129695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129705 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2129708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129731 */     // GIR_Coverage, 17409,
     /* 2129731 */     GIR_EraseRootFromParent_Done,
     /* 2129732 */   // Label 28171: @2129732
     /* 2129732 */   GIM_Try, /*On fail goto*//*Label 28172*/ GIMT_Encode4(2129823), // Rule ID 17412 //
     /* 2129737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2129748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2129751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2129754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2129757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129783 */     // MIs[0] round
     /* 2129783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129786 */     // MIs[0] policy
     /* 2129786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129796 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2129799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129822 */     // GIR_Coverage, 17412,
     /* 2129822 */     GIR_EraseRootFromParent_Done,
     /* 2129823 */   // Label 28172: @2129823
     /* 2129823 */   GIM_Try, /*On fail goto*//*Label 28173*/ GIMT_Encode4(2129914), // Rule ID 17413 //
     /* 2129828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2129839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2129842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2129845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2129848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129874 */     // MIs[0] round
     /* 2129874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129877 */     // MIs[0] policy
     /* 2129877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129887 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2129890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129913 */     // GIR_Coverage, 17413,
     /* 2129913 */     GIR_EraseRootFromParent_Done,
     /* 2129914 */   // Label 28173: @2129914
     /* 2129914 */   GIM_Try, /*On fail goto*//*Label 28174*/ GIMT_Encode4(2130005), // Rule ID 17416 //
     /* 2129919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2129927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2129930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2129933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2129936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2129939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2129942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129965 */     // MIs[0] round
     /* 2129965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129968 */     // MIs[0] policy
     /* 2129968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129978 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2129981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130004 */     // GIR_Coverage, 17416,
     /* 2130004 */     GIR_EraseRootFromParent_Done,
     /* 2130005 */   // Label 28174: @2130005
     /* 2130005 */   GIM_Try, /*On fail goto*//*Label 28175*/ GIMT_Encode4(2130096), // Rule ID 17417 //
     /* 2130010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2130013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2130021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2130024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2130027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2130030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2130033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130056 */     // MIs[0] round
     /* 2130056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130059 */     // MIs[0] policy
     /* 2130059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130069 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2130072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130095 */     // GIR_Coverage, 17417,
     /* 2130095 */     GIR_EraseRootFromParent_Done,
     /* 2130096 */   // Label 28175: @2130096
     /* 2130096 */   GIM_Try, /*On fail goto*//*Label 28176*/ GIMT_Encode4(2130187), // Rule ID 17420 //
     /* 2130101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2130112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2130115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2130118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130147 */     // MIs[0] round
     /* 2130147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130150 */     // MIs[0] policy
     /* 2130150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130160 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2130163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130186 */     // GIR_Coverage, 17420,
     /* 2130186 */     GIR_EraseRootFromParent_Done,
     /* 2130187 */   // Label 28176: @2130187
     /* 2130187 */   GIM_Try, /*On fail goto*//*Label 28177*/ GIMT_Encode4(2130278), // Rule ID 17421 //
     /* 2130192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2130203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2130206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2130209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2130212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130238 */     // MIs[0] round
     /* 2130238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130241 */     // MIs[0] policy
     /* 2130241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130251 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2130254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130277 */     // GIR_Coverage, 17421,
     /* 2130277 */     GIR_EraseRootFromParent_Done,
     /* 2130278 */   // Label 28177: @2130278
     /* 2130278 */   GIM_Try, /*On fail goto*//*Label 28178*/ GIMT_Encode4(2130369), // Rule ID 17424 //
     /* 2130283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2130294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2130297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2130300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130329 */     // MIs[0] round
     /* 2130329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130332 */     // MIs[0] policy
     /* 2130332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130342 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2130345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130368 */     // GIR_Coverage, 17424,
     /* 2130368 */     GIR_EraseRootFromParent_Done,
     /* 2130369 */   // Label 28178: @2130369
     /* 2130369 */   GIM_Try, /*On fail goto*//*Label 28179*/ GIMT_Encode4(2130460), // Rule ID 17425 //
     /* 2130374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2130385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2130388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2130391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2130394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130420 */     // MIs[0] round
     /* 2130420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130423 */     // MIs[0] policy
     /* 2130423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130433 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2130436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130459 */     // GIR_Coverage, 17425,
     /* 2130459 */     GIR_EraseRootFromParent_Done,
     /* 2130460 */   // Label 28179: @2130460
     /* 2130460 */   GIM_Try, /*On fail goto*//*Label 28180*/ GIMT_Encode4(2130551), // Rule ID 17428 //
     /* 2130465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2130476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2130479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2130482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2130485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130511 */     // MIs[0] round
     /* 2130511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130514 */     // MIs[0] policy
     /* 2130514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130524 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2130527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130550 */     // GIR_Coverage, 17428,
     /* 2130550 */     GIR_EraseRootFromParent_Done,
     /* 2130551 */   // Label 28180: @2130551
     /* 2130551 */   GIM_Try, /*On fail goto*//*Label 28181*/ GIMT_Encode4(2130642), // Rule ID 17429 //
     /* 2130556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2130567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2130570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2130573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2130576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130602 */     // MIs[0] round
     /* 2130602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130605 */     // MIs[0] policy
     /* 2130605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130615 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2130618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130641 */     // GIR_Coverage, 17429,
     /* 2130641 */     GIR_EraseRootFromParent_Done,
     /* 2130642 */   // Label 28181: @2130642
     /* 2130642 */   GIM_Try, /*On fail goto*//*Label 28182*/ GIMT_Encode4(2130733), // Rule ID 17432 //
     /* 2130647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2130650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2130658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2130661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2130664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2130667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130693 */     // MIs[0] round
     /* 2130693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130696 */     // MIs[0] policy
     /* 2130696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130706 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2130709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130732 */     // GIR_Coverage, 17432,
     /* 2130732 */     GIR_EraseRootFromParent_Done,
     /* 2130733 */   // Label 28182: @2130733
     /* 2130733 */   GIM_Try, /*On fail goto*//*Label 28183*/ GIMT_Encode4(2130824), // Rule ID 17433 //
     /* 2130738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2130741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2130749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2130752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2130755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2130758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130784 */     // MIs[0] round
     /* 2130784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130787 */     // MIs[0] policy
     /* 2130787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130797 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2130800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130823 */     // GIR_Coverage, 17433,
     /* 2130823 */     GIR_EraseRootFromParent_Done,
     /* 2130824 */   // Label 28183: @2130824
     /* 2130824 */   GIM_Try, /*On fail goto*//*Label 28184*/ GIMT_Encode4(2130915), // Rule ID 17436 //
     /* 2130829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2130832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2130840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2130843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2130846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2130849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130875 */     // MIs[0] round
     /* 2130875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130878 */     // MIs[0] policy
     /* 2130878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130888 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2130891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130914 */     // GIR_Coverage, 17436,
     /* 2130914 */     GIR_EraseRootFromParent_Done,
     /* 2130915 */   // Label 28184: @2130915
     /* 2130915 */   GIM_Try, /*On fail goto*//*Label 28185*/ GIMT_Encode4(2131006), // Rule ID 17437 //
     /* 2130920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2130923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2130928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2130931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2130934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2130937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2130940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130966 */     // MIs[0] round
     /* 2130966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130969 */     // MIs[0] policy
     /* 2130969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130979 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2130982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131005 */     // GIR_Coverage, 17437,
     /* 2131005 */     GIR_EraseRootFromParent_Done,
     /* 2131006 */   // Label 28185: @2131006
     /* 2131006 */   GIM_Try, /*On fail goto*//*Label 28186*/ GIMT_Encode4(2131097), // Rule ID 17440 //
     /* 2131011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2131014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2131022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2131025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2131028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2131031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131057 */     // MIs[0] round
     /* 2131057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131060 */     // MIs[0] policy
     /* 2131060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131070 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2131073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131096 */     // GIR_Coverage, 17440,
     /* 2131096 */     GIR_EraseRootFromParent_Done,
     /* 2131097 */   // Label 28186: @2131097
     /* 2131097 */   GIM_Try, /*On fail goto*//*Label 28187*/ GIMT_Encode4(2131188), // Rule ID 17441 //
     /* 2131102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2131105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2131113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2131116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2131119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2131122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131148 */     // MIs[0] round
     /* 2131148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131151 */     // MIs[0] policy
     /* 2131151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131161 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2131164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2131184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131187 */     // GIR_Coverage, 17441,
     /* 2131187 */     GIR_EraseRootFromParent_Done,
     /* 2131188 */   // Label 28187: @2131188
     /* 2131188 */   GIM_Try, /*On fail goto*//*Label 28188*/ GIMT_Encode4(2131279), // Rule ID 17444 //
     /* 2131193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2131204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131239 */     // MIs[0] round
     /* 2131239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131242 */     // MIs[0] policy
     /* 2131242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131252 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2131255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131278 */     // GIR_Coverage, 17444,
     /* 2131278 */     GIR_EraseRootFromParent_Done,
     /* 2131279 */   // Label 28188: @2131279
     /* 2131279 */   GIM_Try, /*On fail goto*//*Label 28189*/ GIMT_Encode4(2131370), // Rule ID 17445 //
     /* 2131284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2131295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2131298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2131301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131330 */     // MIs[0] round
     /* 2131330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131333 */     // MIs[0] policy
     /* 2131333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131343 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2131346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131369 */     // GIR_Coverage, 17445,
     /* 2131369 */     GIR_EraseRootFromParent_Done,
     /* 2131370 */   // Label 28189: @2131370
     /* 2131370 */   GIM_Try, /*On fail goto*//*Label 28190*/ GIMT_Encode4(2131461), // Rule ID 17448 //
     /* 2131375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2131386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2131389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131421 */     // MIs[0] round
     /* 2131421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131424 */     // MIs[0] policy
     /* 2131424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131434 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2131437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131460 */     // GIR_Coverage, 17448,
     /* 2131460 */     GIR_EraseRootFromParent_Done,
     /* 2131461 */   // Label 28190: @2131461
     /* 2131461 */   GIM_Try, /*On fail goto*//*Label 28191*/ GIMT_Encode4(2131552), // Rule ID 17449 //
     /* 2131466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2131477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2131480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131512 */     // MIs[0] round
     /* 2131512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131515 */     // MIs[0] policy
     /* 2131515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131525 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2131528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131551 */     // GIR_Coverage, 17449,
     /* 2131551 */     GIR_EraseRootFromParent_Done,
     /* 2131552 */   // Label 28191: @2131552
     /* 2131552 */   GIM_Try, /*On fail goto*//*Label 28192*/ GIMT_Encode4(2131643), // Rule ID 17452 //
     /* 2131557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2131560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2131568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2131571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2131574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131603 */     // MIs[0] round
     /* 2131603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131606 */     // MIs[0] policy
     /* 2131606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131616 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2131619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131642 */     // GIR_Coverage, 17452,
     /* 2131642 */     GIR_EraseRootFromParent_Done,
     /* 2131643 */   // Label 28192: @2131643
     /* 2131643 */   GIM_Try, /*On fail goto*//*Label 28193*/ GIMT_Encode4(2131734), // Rule ID 17453 //
     /* 2131648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2131651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2131659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2131662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2131665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131694 */     // MIs[0] round
     /* 2131694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131697 */     // MIs[0] policy
     /* 2131697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131707 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2131710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131733 */     // GIR_Coverage, 17453,
     /* 2131733 */     GIR_EraseRootFromParent_Done,
     /* 2131734 */   // Label 28193: @2131734
     /* 2131734 */   GIM_Try, /*On fail goto*//*Label 28194*/ GIMT_Encode4(2131825), // Rule ID 17456 //
     /* 2131739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2131742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2131750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2131753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2131756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131785 */     // MIs[0] round
     /* 2131785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131788 */     // MIs[0] policy
     /* 2131788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131798 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2131801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131824 */     // GIR_Coverage, 17456,
     /* 2131824 */     GIR_EraseRootFromParent_Done,
     /* 2131825 */   // Label 28194: @2131825
     /* 2131825 */   GIM_Try, /*On fail goto*//*Label 28195*/ GIMT_Encode4(2131916), // Rule ID 17457 //
     /* 2131830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2131833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2131841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2131844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2131847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2131850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2131872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131876 */     // MIs[0] round
     /* 2131876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131879 */     // MIs[0] policy
     /* 2131879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131889 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2131892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131915 */     // GIR_Coverage, 17457,
     /* 2131915 */     GIR_EraseRootFromParent_Done,
     /* 2131916 */   // Label 28195: @2131916
     /* 2131916 */   GIM_Try, /*On fail goto*//*Label 28196*/ GIMT_Encode4(2132007), // Rule ID 17460 //
     /* 2131921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2131924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2131929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2131932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2131935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2131938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2131941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2131963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131967 */     // MIs[0] round
     /* 2131967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131970 */     // MIs[0] policy
     /* 2131970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131980 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2131983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132006 */     // GIR_Coverage, 17460,
     /* 2132006 */     GIR_EraseRootFromParent_Done,
     /* 2132007 */   // Label 28196: @2132007
     /* 2132007 */   GIM_Try, /*On fail goto*//*Label 28197*/ GIMT_Encode4(2132098), // Rule ID 17461 //
     /* 2132012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2132023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2132026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2132029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132058 */     // MIs[0] round
     /* 2132058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132061 */     // MIs[0] policy
     /* 2132061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132071 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2132074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132097 */     // GIR_Coverage, 17461,
     /* 2132097 */     GIR_EraseRootFromParent_Done,
     /* 2132098 */   // Label 28197: @2132098
     /* 2132098 */   GIM_Try, /*On fail goto*//*Label 28198*/ GIMT_Encode4(2132189), // Rule ID 17464 //
     /* 2132103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2132106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2132114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132149 */     // MIs[0] round
     /* 2132149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132152 */     // MIs[0] policy
     /* 2132152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132162 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2132165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132188 */     // GIR_Coverage, 17464,
     /* 2132188 */     GIR_EraseRootFromParent_Done,
     /* 2132189 */   // Label 28198: @2132189
     /* 2132189 */   GIM_Try, /*On fail goto*//*Label 28199*/ GIMT_Encode4(2132280), // Rule ID 17465 //
     /* 2132194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2132197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2132205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2132208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2132211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2132214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2132236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132240 */     // MIs[0] round
     /* 2132240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132243 */     // MIs[0] policy
     /* 2132243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132253 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2132256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2132276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132279 */     // GIR_Coverage, 17465,
     /* 2132279 */     GIR_EraseRootFromParent_Done,
     /* 2132280 */   // Label 28199: @2132280
     /* 2132280 */   GIM_Try, /*On fail goto*//*Label 28200*/ GIMT_Encode4(2132371), // Rule ID 17468 //
     /* 2132285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2132296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2132299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2132302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132331 */     // MIs[0] round
     /* 2132331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132334 */     // MIs[0] policy
     /* 2132334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132344 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2132347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132370 */     // GIR_Coverage, 17468,
     /* 2132370 */     GIR_EraseRootFromParent_Done,
     /* 2132371 */   // Label 28200: @2132371
     /* 2132371 */   GIM_Try, /*On fail goto*//*Label 28201*/ GIMT_Encode4(2132462), // Rule ID 17469 //
     /* 2132376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2132387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2132390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2132393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132422 */     // MIs[0] round
     /* 2132422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132425 */     // MIs[0] policy
     /* 2132425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132435 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2132438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132461 */     // GIR_Coverage, 17469,
     /* 2132461 */     GIR_EraseRootFromParent_Done,
     /* 2132462 */   // Label 28201: @2132462
     /* 2132462 */   GIM_Try, /*On fail goto*//*Label 28202*/ GIMT_Encode4(2132553), // Rule ID 17472 //
     /* 2132467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2132478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2132481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2132484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2132490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132513 */     // MIs[0] round
     /* 2132513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132516 */     // MIs[0] policy
     /* 2132516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132526 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2132529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132552 */     // GIR_Coverage, 17472,
     /* 2132552 */     GIR_EraseRootFromParent_Done,
     /* 2132553 */   // Label 28202: @2132553
     /* 2132553 */   GIM_Try, /*On fail goto*//*Label 28203*/ GIMT_Encode4(2132644), // Rule ID 17473 //
     /* 2132558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2132569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2132572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2132575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2132581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132604 */     // MIs[0] round
     /* 2132604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132607 */     // MIs[0] policy
     /* 2132607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132617 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2132620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132643 */     // GIR_Coverage, 17473,
     /* 2132643 */     GIR_EraseRootFromParent_Done,
     /* 2132644 */   // Label 28203: @2132644
     /* 2132644 */   GIM_Try, /*On fail goto*//*Label 28204*/ GIMT_Encode4(2132735), // Rule ID 17476 //
     /* 2132649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2132652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2132660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2132663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2132666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2132672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132695 */     // MIs[0] round
     /* 2132695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132698 */     // MIs[0] policy
     /* 2132698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132708 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2132711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132734 */     // GIR_Coverage, 17476,
     /* 2132734 */     GIR_EraseRootFromParent_Done,
     /* 2132735 */   // Label 28204: @2132735
     /* 2132735 */   GIM_Try, /*On fail goto*//*Label 28205*/ GIMT_Encode4(2132826), // Rule ID 17477 //
     /* 2132740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2132743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2132751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2132754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2132757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2132763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132786 */     // MIs[0] round
     /* 2132786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132789 */     // MIs[0] policy
     /* 2132789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132799 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2132802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132825 */     // GIR_Coverage, 17477,
     /* 2132825 */     GIR_EraseRootFromParent_Done,
     /* 2132826 */   // Label 28205: @2132826
     /* 2132826 */   GIM_Try, /*On fail goto*//*Label 28206*/ GIMT_Encode4(2132917), // Rule ID 17480 //
     /* 2132831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2132834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2132842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2132845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2132848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132877 */     // MIs[0] round
     /* 2132877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132880 */     // MIs[0] policy
     /* 2132880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132890 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2132893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132916 */     // GIR_Coverage, 17480,
     /* 2132916 */     GIR_EraseRootFromParent_Done,
     /* 2132917 */   // Label 28206: @2132917
     /* 2132917 */   GIM_Try, /*On fail goto*//*Label 28207*/ GIMT_Encode4(2133008), // Rule ID 17481 //
     /* 2132922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2132925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2132930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2132933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2132936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2132939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2132942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2132964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132968 */     // MIs[0] round
     /* 2132968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132971 */     // MIs[0] policy
     /* 2132971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132981 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2132984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133007 */     // GIR_Coverage, 17481,
     /* 2133007 */     GIR_EraseRootFromParent_Done,
     /* 2133008 */   // Label 28207: @2133008
     /* 2133008 */   GIM_Try, /*On fail goto*//*Label 28208*/ GIMT_Encode4(2133099), // Rule ID 17484 //
     /* 2133013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2133030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133059 */     // MIs[0] round
     /* 2133059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133062 */     // MIs[0] policy
     /* 2133062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133072 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2133075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133098 */     // GIR_Coverage, 17484,
     /* 2133098 */     GIR_EraseRootFromParent_Done,
     /* 2133099 */   // Label 28208: @2133099
     /* 2133099 */   GIM_Try, /*On fail goto*//*Label 28209*/ GIMT_Encode4(2133190), // Rule ID 17485 //
     /* 2133104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2133121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133150 */     // MIs[0] round
     /* 2133150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133153 */     // MIs[0] policy
     /* 2133153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133163 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2133166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133189 */     // GIR_Coverage, 17485,
     /* 2133189 */     GIR_EraseRootFromParent_Done,
     /* 2133190 */   // Label 28209: @2133190
     /* 2133190 */   GIM_Try, /*On fail goto*//*Label 28210*/ GIMT_Encode4(2133281), // Rule ID 17488 //
     /* 2133195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2133198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2133212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133241 */     // MIs[0] round
     /* 2133241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133244 */     // MIs[0] policy
     /* 2133244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133254 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2133257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133280 */     // GIR_Coverage, 17488,
     /* 2133280 */     GIR_EraseRootFromParent_Done,
     /* 2133281 */   // Label 28210: @2133281
     /* 2133281 */   GIM_Try, /*On fail goto*//*Label 28211*/ GIMT_Encode4(2133372), // Rule ID 17489 //
     /* 2133286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2133289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2133303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133332 */     // MIs[0] round
     /* 2133332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133335 */     // MIs[0] policy
     /* 2133335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133345 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2133348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133371 */     // GIR_Coverage, 17489,
     /* 2133371 */     GIR_EraseRootFromParent_Done,
     /* 2133372 */   // Label 28211: @2133372
     /* 2133372 */   GIM_Try, /*On fail goto*//*Label 28212*/ GIMT_Encode4(2133463), // Rule ID 17492 //
     /* 2133377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2133394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133423 */     // MIs[0] round
     /* 2133423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133426 */     // MIs[0] policy
     /* 2133426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133436 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2133439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133462 */     // GIR_Coverage, 17492,
     /* 2133462 */     GIR_EraseRootFromParent_Done,
     /* 2133463 */   // Label 28212: @2133463
     /* 2133463 */   GIM_Try, /*On fail goto*//*Label 28213*/ GIMT_Encode4(2133554), // Rule ID 17493 //
     /* 2133468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2133485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133514 */     // MIs[0] round
     /* 2133514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133517 */     // MIs[0] policy
     /* 2133517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133527 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2133530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133553 */     // GIR_Coverage, 17493,
     /* 2133553 */     GIR_EraseRootFromParent_Done,
     /* 2133554 */   // Label 28213: @2133554
     /* 2133554 */   GIM_Try, /*On fail goto*//*Label 28214*/ GIMT_Encode4(2133645), // Rule ID 17496 //
     /* 2133559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2133570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2133573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2133576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133605 */     // MIs[0] round
     /* 2133605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133608 */     // MIs[0] policy
     /* 2133608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133618 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2133621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133644 */     // GIR_Coverage, 17496,
     /* 2133644 */     GIR_EraseRootFromParent_Done,
     /* 2133645 */   // Label 28214: @2133645
     /* 2133645 */   GIM_Try, /*On fail goto*//*Label 28215*/ GIMT_Encode4(2133736), // Rule ID 17497 //
     /* 2133650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2133661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2133664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2133667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133696 */     // MIs[0] round
     /* 2133696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133699 */     // MIs[0] policy
     /* 2133699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133709 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2133712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133735 */     // GIR_Coverage, 17497,
     /* 2133735 */     GIR_EraseRootFromParent_Done,
     /* 2133736 */   // Label 28215: @2133736
     /* 2133736 */   GIM_Try, /*On fail goto*//*Label 28216*/ GIMT_Encode4(2133827), // Rule ID 17500 //
     /* 2133741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2133744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2133752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2133755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2133758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133787 */     // MIs[0] round
     /* 2133787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133790 */     // MIs[0] policy
     /* 2133790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133800 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2133803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133826 */     // GIR_Coverage, 17500,
     /* 2133826 */     GIR_EraseRootFromParent_Done,
     /* 2133827 */   // Label 28216: @2133827
     /* 2133827 */   GIM_Try, /*On fail goto*//*Label 28217*/ GIMT_Encode4(2133918), // Rule ID 17501 //
     /* 2133832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2133835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2133840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2133843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2133846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2133849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2133852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2133874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133878 */     // MIs[0] round
     /* 2133878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133881 */     // MIs[0] policy
     /* 2133881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133891 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2133894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2133914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133917 */     // GIR_Coverage, 17501,
     /* 2133917 */     GIR_EraseRootFromParent_Done,
     /* 2133918 */   // Label 28217: @2133918
     /* 2133918 */   GIM_Try, /*On fail goto*//*Label 28218*/ GIMT_Encode4(2134009), // Rule ID 17504 //
     /* 2133923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2133926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2133931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2133934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2133937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2133940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2133943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2133946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133969 */     // MIs[0] round
     /* 2133969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133972 */     // MIs[0] policy
     /* 2133972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133982 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2133985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134008 */     // GIR_Coverage, 17504,
     /* 2134008 */     GIR_EraseRootFromParent_Done,
     /* 2134009 */   // Label 28218: @2134009
     /* 2134009 */   GIM_Try, /*On fail goto*//*Label 28219*/ GIMT_Encode4(2134100), // Rule ID 17505 //
     /* 2134014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2134025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2134028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2134031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2134034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134060 */     // MIs[0] round
     /* 2134060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134063 */     // MIs[0] policy
     /* 2134063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134073 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2134076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134099 */     // GIR_Coverage, 17505,
     /* 2134099 */     GIR_EraseRootFromParent_Done,
     /* 2134100 */   // Label 28219: @2134100
     /* 2134100 */   GIM_Try, /*On fail goto*//*Label 28220*/ GIMT_Encode4(2134191), // Rule ID 17508 //
     /* 2134105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134151 */     // MIs[0] round
     /* 2134151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134154 */     // MIs[0] policy
     /* 2134154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134164 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2134167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134190 */     // GIR_Coverage, 17508,
     /* 2134190 */     GIR_EraseRootFromParent_Done,
     /* 2134191 */   // Label 28220: @2134191
     /* 2134191 */   GIM_Try, /*On fail goto*//*Label 28221*/ GIMT_Encode4(2134282), // Rule ID 17509 //
     /* 2134196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134242 */     // MIs[0] round
     /* 2134242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134245 */     // MIs[0] policy
     /* 2134245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134255 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2134258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134281 */     // GIR_Coverage, 17509,
     /* 2134281 */     GIR_EraseRootFromParent_Done,
     /* 2134282 */   // Label 28221: @2134282
     /* 2134282 */   GIM_Try, /*On fail goto*//*Label 28222*/ GIMT_Encode4(2134373), // Rule ID 17512 //
     /* 2134287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134333 */     // MIs[0] round
     /* 2134333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134336 */     // MIs[0] policy
     /* 2134336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134346 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2134349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134372 */     // GIR_Coverage, 17512,
     /* 2134372 */     GIR_EraseRootFromParent_Done,
     /* 2134373 */   // Label 28222: @2134373
     /* 2134373 */   GIM_Try, /*On fail goto*//*Label 28223*/ GIMT_Encode4(2134464), // Rule ID 17513 //
     /* 2134378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134424 */     // MIs[0] round
     /* 2134424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134427 */     // MIs[0] policy
     /* 2134427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134437 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2134440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134463 */     // GIR_Coverage, 17513,
     /* 2134463 */     GIR_EraseRootFromParent_Done,
     /* 2134464 */   // Label 28223: @2134464
     /* 2134464 */   GIM_Try, /*On fail goto*//*Label 28224*/ GIMT_Encode4(2134555), // Rule ID 17516 //
     /* 2134469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2134480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2134483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2134486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2134489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134515 */     // MIs[0] round
     /* 2134515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134518 */     // MIs[0] policy
     /* 2134518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134528 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2134531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134554 */     // GIR_Coverage, 17516,
     /* 2134554 */     GIR_EraseRootFromParent_Done,
     /* 2134555 */   // Label 28224: @2134555
     /* 2134555 */   GIM_Try, /*On fail goto*//*Label 28225*/ GIMT_Encode4(2134646), // Rule ID 17517 //
     /* 2134560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2134571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2134574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2134577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2134580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134606 */     // MIs[0] round
     /* 2134606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134609 */     // MIs[0] policy
     /* 2134609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134619 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2134622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134645 */     // GIR_Coverage, 17517,
     /* 2134645 */     GIR_EraseRootFromParent_Done,
     /* 2134646 */   // Label 28225: @2134646
     /* 2134646 */   GIM_Try, /*On fail goto*//*Label 28226*/ GIMT_Encode4(2134737), // Rule ID 17520 //
     /* 2134651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2134662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2134665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2134668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2134671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134697 */     // MIs[0] round
     /* 2134697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134700 */     // MIs[0] policy
     /* 2134700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134710 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2134713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134736 */     // GIR_Coverage, 17520,
     /* 2134736 */     GIR_EraseRootFromParent_Done,
     /* 2134737 */   // Label 28226: @2134737
     /* 2134737 */   GIM_Try, /*On fail goto*//*Label 28227*/ GIMT_Encode4(2134828), // Rule ID 17521 //
     /* 2134742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2134753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2134756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2134759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2134762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134788 */     // MIs[0] round
     /* 2134788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134791 */     // MIs[0] policy
     /* 2134791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134801 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2134804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134827 */     // GIR_Coverage, 17521,
     /* 2134827 */     GIR_EraseRootFromParent_Done,
     /* 2134828 */   // Label 28227: @2134828
     /* 2134828 */   GIM_Try, /*On fail goto*//*Label 28228*/ GIMT_Encode4(2134919), // Rule ID 17524 //
     /* 2134833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2134844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2134853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134879 */     // MIs[0] round
     /* 2134879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134882 */     // MIs[0] policy
     /* 2134882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134892 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2134895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134918 */     // GIR_Coverage, 17524,
     /* 2134918 */     GIR_EraseRootFromParent_Done,
     /* 2134919 */   // Label 28228: @2134919
     /* 2134919 */   GIM_Try, /*On fail goto*//*Label 28229*/ GIMT_Encode4(2135010), // Rule ID 17525 //
     /* 2134924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2134932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2134935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2134944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134970 */     // MIs[0] round
     /* 2134970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134973 */     // MIs[0] policy
     /* 2134973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134983 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2134986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135009 */     // GIR_Coverage, 17525,
     /* 2135009 */     GIR_EraseRootFromParent_Done,
     /* 2135010 */   // Label 28229: @2135010
     /* 2135010 */   GIM_Try, /*On fail goto*//*Label 28230*/ GIMT_Encode4(2135101), // Rule ID 17528 //
     /* 2135015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135061 */     // MIs[0] round
     /* 2135061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135064 */     // MIs[0] policy
     /* 2135064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135074 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2135077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135100 */     // GIR_Coverage, 17528,
     /* 2135100 */     GIR_EraseRootFromParent_Done,
     /* 2135101 */   // Label 28230: @2135101
     /* 2135101 */   GIM_Try, /*On fail goto*//*Label 28231*/ GIMT_Encode4(2135192), // Rule ID 17529 //
     /* 2135106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135152 */     // MIs[0] round
     /* 2135152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135155 */     // MIs[0] policy
     /* 2135155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135165 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2135168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135191 */     // GIR_Coverage, 17529,
     /* 2135191 */     GIR_EraseRootFromParent_Done,
     /* 2135192 */   // Label 28231: @2135192
     /* 2135192 */   GIM_Try, /*On fail goto*//*Label 28232*/ GIMT_Encode4(2135283), // Rule ID 17532 //
     /* 2135197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135243 */     // MIs[0] round
     /* 2135243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135246 */     // MIs[0] policy
     /* 2135246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135256 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2135259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135282 */     // GIR_Coverage, 17532,
     /* 2135282 */     GIR_EraseRootFromParent_Done,
     /* 2135283 */   // Label 28232: @2135283
     /* 2135283 */   GIM_Try, /*On fail goto*//*Label 28233*/ GIMT_Encode4(2135374), // Rule ID 17533 //
     /* 2135288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135334 */     // MIs[0] round
     /* 2135334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135337 */     // MIs[0] policy
     /* 2135337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135347 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2135350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135373 */     // GIR_Coverage, 17533,
     /* 2135373 */     GIR_EraseRootFromParent_Done,
     /* 2135374 */   // Label 28233: @2135374
     /* 2135374 */   GIM_Try, /*On fail goto*//*Label 28234*/ GIMT_Encode4(2135465), // Rule ID 17536 //
     /* 2135379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135425 */     // MIs[0] round
     /* 2135425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135428 */     // MIs[0] policy
     /* 2135428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135438 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2135441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135464 */     // GIR_Coverage, 17536,
     /* 2135464 */     GIR_EraseRootFromParent_Done,
     /* 2135465 */   // Label 28234: @2135465
     /* 2135465 */   GIM_Try, /*On fail goto*//*Label 28235*/ GIMT_Encode4(2135556), // Rule ID 17537 //
     /* 2135470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135516 */     // MIs[0] round
     /* 2135516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135519 */     // MIs[0] policy
     /* 2135519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135529 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2135532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135555 */     // GIR_Coverage, 17537,
     /* 2135555 */     GIR_EraseRootFromParent_Done,
     /* 2135556 */   // Label 28235: @2135556
     /* 2135556 */   GIM_Try, /*On fail goto*//*Label 28236*/ GIMT_Encode4(2135647), // Rule ID 17540 //
     /* 2135561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2135572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2135575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2135578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2135581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135607 */     // MIs[0] round
     /* 2135607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135610 */     // MIs[0] policy
     /* 2135610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2135623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135646 */     // GIR_Coverage, 17540,
     /* 2135646 */     GIR_EraseRootFromParent_Done,
     /* 2135647 */   // Label 28236: @2135647
     /* 2135647 */   GIM_Try, /*On fail goto*//*Label 28237*/ GIMT_Encode4(2135738), // Rule ID 17541 //
     /* 2135652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2135663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2135666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2135669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2135672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135698 */     // MIs[0] round
     /* 2135698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135701 */     // MIs[0] policy
     /* 2135701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135711 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2135714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135737 */     // GIR_Coverage, 17541,
     /* 2135737 */     GIR_EraseRootFromParent_Done,
     /* 2135738 */   // Label 28237: @2135738
     /* 2135738 */   GIM_Try, /*On fail goto*//*Label 28238*/ GIMT_Encode4(2135829), // Rule ID 17544 //
     /* 2135743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2135754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2135757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2135760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2135763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135789 */     // MIs[0] round
     /* 2135789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135792 */     // MIs[0] policy
     /* 2135792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135802 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2135805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135828 */     // GIR_Coverage, 17544,
     /* 2135828 */     GIR_EraseRootFromParent_Done,
     /* 2135829 */   // Label 28238: @2135829
     /* 2135829 */   GIM_Try, /*On fail goto*//*Label 28239*/ GIMT_Encode4(2135920), // Rule ID 17545 //
     /* 2135834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2135845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2135848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2135851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2135854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135880 */     // MIs[0] round
     /* 2135880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135883 */     // MIs[0] policy
     /* 2135883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135893 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2135896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135919 */     // GIR_Coverage, 17545,
     /* 2135919 */     GIR_EraseRootFromParent_Done,
     /* 2135920 */   // Label 28239: @2135920
     /* 2135920 */   GIM_Try, /*On fail goto*//*Label 28240*/ GIMT_Encode4(2136011), // Rule ID 17548 //
     /* 2135925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2135933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2135936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2135939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2135942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2135945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135971 */     // MIs[0] round
     /* 2135971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135974 */     // MIs[0] policy
     /* 2135974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135984 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2135987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2135991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136010 */     // GIR_Coverage, 17548,
     /* 2136010 */     GIR_EraseRootFromParent_Done,
     /* 2136011 */   // Label 28240: @2136011
     /* 2136011 */   GIM_Try, /*On fail goto*//*Label 28241*/ GIMT_Encode4(2136102), // Rule ID 17549 //
     /* 2136016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2136027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2136030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2136033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2136036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136062 */     // MIs[0] round
     /* 2136062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136065 */     // MIs[0] policy
     /* 2136065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136075 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2136078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136101 */     // GIR_Coverage, 17549,
     /* 2136101 */     GIR_EraseRootFromParent_Done,
     /* 2136102 */   // Label 28241: @2136102
     /* 2136102 */   GIM_Try, /*On fail goto*//*Label 28242*/ GIMT_Encode4(2136193), // Rule ID 17552 //
     /* 2136107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136153 */     // MIs[0] round
     /* 2136153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136156 */     // MIs[0] policy
     /* 2136156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136166 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2136169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136192 */     // GIR_Coverage, 17552,
     /* 2136192 */     GIR_EraseRootFromParent_Done,
     /* 2136193 */   // Label 28242: @2136193
     /* 2136193 */   GIM_Try, /*On fail goto*//*Label 28243*/ GIMT_Encode4(2136284), // Rule ID 17553 //
     /* 2136198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136244 */     // MIs[0] round
     /* 2136244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136247 */     // MIs[0] policy
     /* 2136247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136257 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2136260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136283 */     // GIR_Coverage, 17553,
     /* 2136283 */     GIR_EraseRootFromParent_Done,
     /* 2136284 */   // Label 28243: @2136284
     /* 2136284 */   GIM_Try, /*On fail goto*//*Label 28244*/ GIMT_Encode4(2136375), // Rule ID 17556 //
     /* 2136289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136335 */     // MIs[0] round
     /* 2136335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136338 */     // MIs[0] policy
     /* 2136338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136348 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2136351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136374 */     // GIR_Coverage, 17556,
     /* 2136374 */     GIR_EraseRootFromParent_Done,
     /* 2136375 */   // Label 28244: @2136375
     /* 2136375 */   GIM_Try, /*On fail goto*//*Label 28245*/ GIMT_Encode4(2136466), // Rule ID 17557 //
     /* 2136380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136426 */     // MIs[0] round
     /* 2136426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136429 */     // MIs[0] policy
     /* 2136429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136439 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2136442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136465 */     // GIR_Coverage, 17557,
     /* 2136465 */     GIR_EraseRootFromParent_Done,
     /* 2136466 */   // Label 28245: @2136466
     /* 2136466 */   GIM_Try, /*On fail goto*//*Label 28246*/ GIMT_Encode4(2136557), // Rule ID 17560 //
     /* 2136471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2136488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2136491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136517 */     // MIs[0] round
     /* 2136517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136520 */     // MIs[0] policy
     /* 2136520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136530 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2136533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136556 */     // GIR_Coverage, 17560,
     /* 2136556 */     GIR_EraseRootFromParent_Done,
     /* 2136557 */   // Label 28246: @2136557
     /* 2136557 */   GIM_Try, /*On fail goto*//*Label 28247*/ GIMT_Encode4(2136648), // Rule ID 17561 //
     /* 2136562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2136579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2136582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136608 */     // MIs[0] round
     /* 2136608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136611 */     // MIs[0] policy
     /* 2136611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136621 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2136624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136647 */     // GIR_Coverage, 17561,
     /* 2136647 */     GIR_EraseRootFromParent_Done,
     /* 2136648 */   // Label 28247: @2136648
     /* 2136648 */   GIM_Try, /*On fail goto*//*Label 28248*/ GIMT_Encode4(2136739), // Rule ID 17564 //
     /* 2136653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2136656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2136664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2136667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2136670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136699 */     // MIs[0] round
     /* 2136699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136702 */     // MIs[0] policy
     /* 2136702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136712 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2136715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136738 */     // GIR_Coverage, 17564,
     /* 2136738 */     GIR_EraseRootFromParent_Done,
     /* 2136739 */   // Label 28248: @2136739
     /* 2136739 */   GIM_Try, /*On fail goto*//*Label 28249*/ GIMT_Encode4(2136830), // Rule ID 17565 //
     /* 2136744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2136747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2136755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2136758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2136761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136790 */     // MIs[0] round
     /* 2136790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136793 */     // MIs[0] policy
     /* 2136793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136803 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2136806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136829 */     // GIR_Coverage, 17565,
     /* 2136829 */     GIR_EraseRootFromParent_Done,
     /* 2136830 */   // Label 28249: @2136830
     /* 2136830 */   GIM_Try, /*On fail goto*//*Label 28250*/ GIMT_Encode4(2136921), // Rule ID 17568 //
     /* 2136835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2136838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2136846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136881 */     // MIs[0] round
     /* 2136881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136884 */     // MIs[0] policy
     /* 2136884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136894 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2136897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136920 */     // GIR_Coverage, 17568,
     /* 2136920 */     GIR_EraseRootFromParent_Done,
     /* 2136921 */   // Label 28250: @2136921
     /* 2136921 */   GIM_Try, /*On fail goto*//*Label 28251*/ GIMT_Encode4(2137012), // Rule ID 17569 //
     /* 2136926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2136929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2136934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2136937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2136943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2136946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136972 */     // MIs[0] round
     /* 2136972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136975 */     // MIs[0] policy
     /* 2136975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136985 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2136988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2136992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137011 */     // GIR_Coverage, 17569,
     /* 2137011 */     GIR_EraseRootFromParent_Done,
     /* 2137012 */   // Label 28251: @2137012
     /* 2137012 */   GIM_Try, /*On fail goto*//*Label 28252*/ GIMT_Encode4(2137103), // Rule ID 17572 //
     /* 2137017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137063 */     // MIs[0] round
     /* 2137063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137066 */     // MIs[0] policy
     /* 2137066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137076 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2137079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137102 */     // GIR_Coverage, 17572,
     /* 2137102 */     GIR_EraseRootFromParent_Done,
     /* 2137103 */   // Label 28252: @2137103
     /* 2137103 */   GIM_Try, /*On fail goto*//*Label 28253*/ GIMT_Encode4(2137194), // Rule ID 17573 //
     /* 2137108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2137125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137154 */     // MIs[0] round
     /* 2137154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137157 */     // MIs[0] policy
     /* 2137157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137167 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2137170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137193 */     // GIR_Coverage, 17573,
     /* 2137193 */     GIR_EraseRootFromParent_Done,
     /* 2137194 */   // Label 28253: @2137194
     /* 2137194 */   GIM_Try, /*On fail goto*//*Label 28254*/ GIMT_Encode4(2137285), // Rule ID 17576 //
     /* 2137199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137245 */     // MIs[0] round
     /* 2137245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137248 */     // MIs[0] policy
     /* 2137248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137258 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2137261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137284 */     // GIR_Coverage, 17576,
     /* 2137284 */     GIR_EraseRootFromParent_Done,
     /* 2137285 */   // Label 28254: @2137285
     /* 2137285 */   GIM_Try, /*On fail goto*//*Label 28255*/ GIMT_Encode4(2137376), // Rule ID 17577 //
     /* 2137290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2137307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137336 */     // MIs[0] round
     /* 2137336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137339 */     // MIs[0] policy
     /* 2137339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137349 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2137352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137375 */     // GIR_Coverage, 17577,
     /* 2137375 */     GIR_EraseRootFromParent_Done,
     /* 2137376 */   // Label 28255: @2137376
     /* 2137376 */   GIM_Try, /*On fail goto*//*Label 28256*/ GIMT_Encode4(2137467), // Rule ID 17580 //
     /* 2137381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137427 */     // MIs[0] round
     /* 2137427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137430 */     // MIs[0] policy
     /* 2137430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137440 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2137443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137466 */     // GIR_Coverage, 17580,
     /* 2137466 */     GIR_EraseRootFromParent_Done,
     /* 2137467 */   // Label 28256: @2137467
     /* 2137467 */   GIM_Try, /*On fail goto*//*Label 28257*/ GIMT_Encode4(2137558), // Rule ID 17581 //
     /* 2137472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2137489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2137492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137518 */     // MIs[0] round
     /* 2137518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137521 */     // MIs[0] policy
     /* 2137521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137531 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2137534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137557 */     // GIR_Coverage, 17581,
     /* 2137557 */     GIR_EraseRootFromParent_Done,
     /* 2137558 */   // Label 28257: @2137558
     /* 2137558 */   GIM_Try, /*On fail goto*//*Label 28258*/ GIMT_Encode4(2137649), // Rule ID 17584 //
     /* 2137563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2137566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2137574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2137577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2137580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137609 */     // MIs[0] round
     /* 2137609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137612 */     // MIs[0] policy
     /* 2137612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137622 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2137625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137648 */     // GIR_Coverage, 17584,
     /* 2137648 */     GIR_EraseRootFromParent_Done,
     /* 2137649 */   // Label 28258: @2137649
     /* 2137649 */   GIM_Try, /*On fail goto*//*Label 28259*/ GIMT_Encode4(2137740), // Rule ID 17585 //
     /* 2137654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2137657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2137665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2137668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2137671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2137674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137700 */     // MIs[0] round
     /* 2137700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137703 */     // MIs[0] policy
     /* 2137703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137713 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2137716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137739 */     // GIR_Coverage, 17585,
     /* 2137739 */     GIR_EraseRootFromParent_Done,
     /* 2137740 */   // Label 28259: @2137740
     /* 2137740 */   GIM_Try, /*On fail goto*//*Label 28260*/ GIMT_Encode4(2137831), // Rule ID 17588 //
     /* 2137745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2137756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2137759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2137762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137791 */     // MIs[0] round
     /* 2137791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137794 */     // MIs[0] policy
     /* 2137794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137804 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2137807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137830 */     // GIR_Coverage, 17588,
     /* 2137830 */     GIR_EraseRootFromParent_Done,
     /* 2137831 */   // Label 28260: @2137831
     /* 2137831 */   GIM_Try, /*On fail goto*//*Label 28261*/ GIMT_Encode4(2137922), // Rule ID 17589 //
     /* 2137836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2137847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2137850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2137853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137882 */     // MIs[0] round
     /* 2137882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137885 */     // MIs[0] policy
     /* 2137885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137895 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2137898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137921 */     // GIR_Coverage, 17589,
     /* 2137921 */     GIR_EraseRootFromParent_Done,
     /* 2137922 */   // Label 28261: @2137922
     /* 2137922 */   GIM_Try, /*On fail goto*//*Label 28262*/ GIMT_Encode4(2138013), // Rule ID 17592 //
     /* 2137927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2137935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2137938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2137941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2137944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2137947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2137950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2137957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2137965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137973 */     // MIs[0] round
     /* 2137973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137976 */     // MIs[0] policy
     /* 2137976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137986 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2137989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2137993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138012 */     // GIR_Coverage, 17592,
     /* 2138012 */     GIR_EraseRootFromParent_Done,
     /* 2138013 */   // Label 28262: @2138013
     /* 2138013 */   GIM_Try, /*On fail goto*//*Label 28263*/ GIMT_Encode4(2138104), // Rule ID 17593 //
     /* 2138018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2138029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2138032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2138035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138064 */     // MIs[0] round
     /* 2138064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138067 */     // MIs[0] policy
     /* 2138067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138077 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2138080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138103 */     // GIR_Coverage, 17593,
     /* 2138103 */     GIR_EraseRootFromParent_Done,
     /* 2138104 */   // Label 28263: @2138104
     /* 2138104 */   GIM_Try, /*On fail goto*//*Label 28264*/ GIMT_Encode4(2138195), // Rule ID 17596 //
     /* 2138109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2138126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138155 */     // MIs[0] round
     /* 2138155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138158 */     // MIs[0] policy
     /* 2138158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138168 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2138171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138194 */     // GIR_Coverage, 17596,
     /* 2138194 */     GIR_EraseRootFromParent_Done,
     /* 2138195 */   // Label 28264: @2138195
     /* 2138195 */   GIM_Try, /*On fail goto*//*Label 28265*/ GIMT_Encode4(2138286), // Rule ID 17597 //
     /* 2138200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2138217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2138220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138246 */     // MIs[0] round
     /* 2138246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138249 */     // MIs[0] policy
     /* 2138249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138259 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2138262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138285 */     // GIR_Coverage, 17597,
     /* 2138285 */     GIR_EraseRootFromParent_Done,
     /* 2138286 */   // Label 28265: @2138286
     /* 2138286 */   GIM_Try, /*On fail goto*//*Label 28266*/ GIMT_Encode4(2138377), // Rule ID 17600 //
     /* 2138291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138337 */     // MIs[0] round
     /* 2138337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138340 */     // MIs[0] policy
     /* 2138340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138350 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2138353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138376 */     // GIR_Coverage, 17600,
     /* 2138376 */     GIR_EraseRootFromParent_Done,
     /* 2138377 */   // Label 28266: @2138377
     /* 2138377 */   GIM_Try, /*On fail goto*//*Label 28267*/ GIMT_Encode4(2138468), // Rule ID 17601 //
     /* 2138382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2138399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138428 */     // MIs[0] round
     /* 2138428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138431 */     // MIs[0] policy
     /* 2138431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138441 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2138444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138467 */     // GIR_Coverage, 17601,
     /* 2138467 */     GIR_EraseRootFromParent_Done,
     /* 2138468 */   // Label 28267: @2138468
     /* 2138468 */   GIM_Try, /*On fail goto*//*Label 28268*/ GIMT_Encode4(2138559), // Rule ID 17604 //
     /* 2138473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2138484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2138487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2138490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138519 */     // MIs[0] round
     /* 2138519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138522 */     // MIs[0] policy
     /* 2138522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138532 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2138535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138558 */     // GIR_Coverage, 17604,
     /* 2138558 */     GIR_EraseRootFromParent_Done,
     /* 2138559 */   // Label 28268: @2138559
     /* 2138559 */   GIM_Try, /*On fail goto*//*Label 28269*/ GIMT_Encode4(2138650), // Rule ID 17605 //
     /* 2138564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2138575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2138578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2138581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138610 */     // MIs[0] round
     /* 2138610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138613 */     // MIs[0] policy
     /* 2138613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138623 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2138626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138649 */     // GIR_Coverage, 17605,
     /* 2138649 */     GIR_EraseRootFromParent_Done,
     /* 2138650 */   // Label 28269: @2138650
     /* 2138650 */   GIM_Try, /*On fail goto*//*Label 28270*/ GIMT_Encode4(2138741), // Rule ID 17608 //
     /* 2138655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2138666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2138669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2138672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138701 */     // MIs[0] round
     /* 2138701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138704 */     // MIs[0] policy
     /* 2138704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138714 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2138717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138740 */     // GIR_Coverage, 17608,
     /* 2138740 */     GIR_EraseRootFromParent_Done,
     /* 2138741 */   // Label 28270: @2138741
     /* 2138741 */   GIM_Try, /*On fail goto*//*Label 28271*/ GIMT_Encode4(2138832), // Rule ID 17609 //
     /* 2138746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2138757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2138760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2138763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2138766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138792 */     // MIs[0] round
     /* 2138792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138795 */     // MIs[0] policy
     /* 2138795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138805 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2138808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138831 */     // GIR_Coverage, 17609,
     /* 2138831 */     GIR_EraseRootFromParent_Done,
     /* 2138832 */   // Label 28271: @2138832
     /* 2138832 */   GIM_Try, /*On fail goto*//*Label 28272*/ GIMT_Encode4(2138923), // Rule ID 17612 //
     /* 2138837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2138840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2138848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2138857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2138879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138883 */     // MIs[0] round
     /* 2138883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138886 */     // MIs[0] policy
     /* 2138886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138896 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2138899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138922 */     // GIR_Coverage, 17612,
     /* 2138922 */     GIR_EraseRootFromParent_Done,
     /* 2138923 */   // Label 28272: @2138923
     /* 2138923 */   GIM_Try, /*On fail goto*//*Label 28273*/ GIMT_Encode4(2139014), // Rule ID 17613 //
     /* 2138928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2138931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2138936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2138939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2138945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2138948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2138970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138974 */     // MIs[0] round
     /* 2138974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138977 */     // MIs[0] policy
     /* 2138977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138987 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2138990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2138994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139013 */     // GIR_Coverage, 17613,
     /* 2139013 */     GIR_EraseRootFromParent_Done,
     /* 2139014 */   // Label 28273: @2139014
     /* 2139014 */   GIM_Try, /*On fail goto*//*Label 28274*/ GIMT_Encode4(2139105), // Rule ID 17616 //
     /* 2139019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139065 */     // MIs[0] round
     /* 2139065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139068 */     // MIs[0] policy
     /* 2139068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139078 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2139081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139104 */     // GIR_Coverage, 17616,
     /* 2139104 */     GIR_EraseRootFromParent_Done,
     /* 2139105 */   // Label 28274: @2139105
     /* 2139105 */   GIM_Try, /*On fail goto*//*Label 28275*/ GIMT_Encode4(2139196), // Rule ID 17617 //
     /* 2139110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2139127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139156 */     // MIs[0] round
     /* 2139156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139159 */     // MIs[0] policy
     /* 2139159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139169 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2139172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139195 */     // GIR_Coverage, 17617,
     /* 2139195 */     GIR_EraseRootFromParent_Done,
     /* 2139196 */   // Label 28275: @2139196
     /* 2139196 */   GIM_Try, /*On fail goto*//*Label 28276*/ GIMT_Encode4(2139287), // Rule ID 17620 //
     /* 2139201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2139218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139247 */     // MIs[0] round
     /* 2139247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139250 */     // MIs[0] policy
     /* 2139250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139260 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2139263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139286 */     // GIR_Coverage, 17620,
     /* 2139286 */     GIR_EraseRootFromParent_Done,
     /* 2139287 */   // Label 28276: @2139287
     /* 2139287 */   GIM_Try, /*On fail goto*//*Label 28277*/ GIMT_Encode4(2139378), // Rule ID 17621 //
     /* 2139292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2139300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2139309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2139312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139338 */     // MIs[0] round
     /* 2139338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139341 */     // MIs[0] policy
     /* 2139341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139351 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2139354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139377 */     // GIR_Coverage, 17621,
     /* 2139377 */     GIR_EraseRootFromParent_Done,
     /* 2139378 */   // Label 28277: @2139378
     /* 2139378 */   GIM_Try, /*On fail goto*//*Label 28278*/ GIMT_Encode4(2139469), // Rule ID 17624 //
     /* 2139383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139429 */     // MIs[0] round
     /* 2139429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139432 */     // MIs[0] policy
     /* 2139432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139442 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2139445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139468 */     // GIR_Coverage, 17624,
     /* 2139468 */     GIR_EraseRootFromParent_Done,
     /* 2139469 */   // Label 28278: @2139469
     /* 2139469 */   GIM_Try, /*On fail goto*//*Label 28279*/ GIMT_Encode4(2139560), // Rule ID 17625 //
     /* 2139474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139520 */     // MIs[0] round
     /* 2139520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139523 */     // MIs[0] policy
     /* 2139523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139533 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2139536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139559 */     // GIR_Coverage, 17625,
     /* 2139559 */     GIR_EraseRootFromParent_Done,
     /* 2139560 */   // Label 28279: @2139560
     /* 2139560 */   GIM_Try, /*On fail goto*//*Label 28280*/ GIMT_Encode4(2139651), // Rule ID 17628 //
     /* 2139565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2139576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2139579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2139582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139611 */     // MIs[0] round
     /* 2139611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139614 */     // MIs[0] policy
     /* 2139614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139624 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2139627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139650 */     // GIR_Coverage, 17628,
     /* 2139650 */     GIR_EraseRootFromParent_Done,
     /* 2139651 */   // Label 28280: @2139651
     /* 2139651 */   GIM_Try, /*On fail goto*//*Label 28281*/ GIMT_Encode4(2139742), // Rule ID 17629 //
     /* 2139656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2139667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2139670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2139673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139702 */     // MIs[0] round
     /* 2139702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139705 */     // MIs[0] policy
     /* 2139705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139715 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2139718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139741 */     // GIR_Coverage, 17629,
     /* 2139741 */     GIR_EraseRootFromParent_Done,
     /* 2139742 */   // Label 28281: @2139742
     /* 2139742 */   GIM_Try, /*On fail goto*//*Label 28282*/ GIMT_Encode4(2139833), // Rule ID 17632 //
     /* 2139747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2139758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2139761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2139764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139793 */     // MIs[0] round
     /* 2139793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139796 */     // MIs[0] policy
     /* 2139796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139806 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2139809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139832 */     // GIR_Coverage, 17632,
     /* 2139832 */     GIR_EraseRootFromParent_Done,
     /* 2139833 */   // Label 28282: @2139833
     /* 2139833 */   GIM_Try, /*On fail goto*//*Label 28283*/ GIMT_Encode4(2139924), // Rule ID 17633 //
     /* 2139838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2139849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2139852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2139855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2139858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2139880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139884 */     // MIs[0] round
     /* 2139884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139887 */     // MIs[0] policy
     /* 2139887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139897 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2139900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139923 */     // GIR_Coverage, 17633,
     /* 2139923 */     GIR_EraseRootFromParent_Done,
     /* 2139924 */   // Label 28283: @2139924
     /* 2139924 */   GIM_Try, /*On fail goto*//*Label 28284*/ GIMT_Encode4(2140015), // Rule ID 17636 //
     /* 2139929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2139937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2139940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2139943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2139946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2139949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2139971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139975 */     // MIs[0] round
     /* 2139975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139978 */     // MIs[0] policy
     /* 2139978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139988 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2139991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2139995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140014 */     // GIR_Coverage, 17636,
     /* 2140014 */     GIR_EraseRootFromParent_Done,
     /* 2140015 */   // Label 28284: @2140015
     /* 2140015 */   GIM_Try, /*On fail goto*//*Label 28285*/ GIMT_Encode4(2140106), // Rule ID 17637 //
     /* 2140020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2140031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140066 */     // MIs[0] round
     /* 2140066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140069 */     // MIs[0] policy
     /* 2140069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140079 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11250:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2140082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140105 */     // GIR_Coverage, 17637,
     /* 2140105 */     GIR_EraseRootFromParent_Done,
     /* 2140106 */   // Label 28285: @2140106
     /* 2140106 */   GIM_Try, /*On fail goto*//*Label 28286*/ GIMT_Encode4(2140197), // Rule ID 17640 //
     /* 2140111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140157 */     // MIs[0] round
     /* 2140157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140160 */     // MIs[0] policy
     /* 2140160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140170 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2140173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140196 */     // GIR_Coverage, 17640,
     /* 2140196 */     GIR_EraseRootFromParent_Done,
     /* 2140197 */   // Label 28286: @2140197
     /* 2140197 */   GIM_Try, /*On fail goto*//*Label 28287*/ GIMT_Encode4(2140288), // Rule ID 17641 //
     /* 2140202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2140222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2140244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140248 */     // MIs[0] round
     /* 2140248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140251 */     // MIs[0] policy
     /* 2140251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140261 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2140264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140287 */     // GIR_Coverage, 17641,
     /* 2140287 */     GIR_EraseRootFromParent_Done,
     /* 2140288 */   // Label 28287: @2140288
     /* 2140288 */   GIM_Try, /*On fail goto*//*Label 28288*/ GIMT_Encode4(2140379), // Rule ID 17644 //
     /* 2140293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2140313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2140335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140339 */     // MIs[0] round
     /* 2140339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140342 */     // MIs[0] policy
     /* 2140342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140352 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2140355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140378 */     // GIR_Coverage, 17644,
     /* 2140378 */     GIR_EraseRootFromParent_Done,
     /* 2140379 */   // Label 28288: @2140379
     /* 2140379 */   GIM_Try, /*On fail goto*//*Label 28289*/ GIMT_Encode4(2140470), // Rule ID 17645 //
     /* 2140384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2140404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2140426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140430 */     // MIs[0] round
     /* 2140430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140433 */     // MIs[0] policy
     /* 2140433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140443 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2140446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140469 */     // GIR_Coverage, 17645,
     /* 2140469 */     GIR_EraseRootFromParent_Done,
     /* 2140470 */   // Label 28289: @2140470
     /* 2140470 */   GIM_Try, /*On fail goto*//*Label 28290*/ GIMT_Encode4(2140561), // Rule ID 17648 //
     /* 2140475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2140486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2140489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2140492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140521 */     // MIs[0] round
     /* 2140521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140524 */     // MIs[0] policy
     /* 2140524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140534 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2140537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140560 */     // GIR_Coverage, 17648,
     /* 2140560 */     GIR_EraseRootFromParent_Done,
     /* 2140561 */   // Label 28290: @2140561
     /* 2140561 */   GIM_Try, /*On fail goto*//*Label 28291*/ GIMT_Encode4(2140652), // Rule ID 17649 //
     /* 2140566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2140577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2140580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2140583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140612 */     // MIs[0] round
     /* 2140612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140615 */     // MIs[0] policy
     /* 2140615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140625 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2140628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140651 */     // GIR_Coverage, 17649,
     /* 2140651 */     GIR_EraseRootFromParent_Done,
     /* 2140652 */   // Label 28291: @2140652
     /* 2140652 */   GIM_Try, /*On fail goto*//*Label 28292*/ GIMT_Encode4(2140743), // Rule ID 17652 //
     /* 2140657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2140668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2140671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2140674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2140680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140703 */     // MIs[0] round
     /* 2140703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140706 */     // MIs[0] policy
     /* 2140706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140716 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2140719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140742 */     // GIR_Coverage, 17652,
     /* 2140742 */     GIR_EraseRootFromParent_Done,
     /* 2140743 */   // Label 28292: @2140743
     /* 2140743 */   GIM_Try, /*On fail goto*//*Label 28293*/ GIMT_Encode4(2140834), // Rule ID 17653 //
     /* 2140748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2140759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2140762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2140765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2140771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140794 */     // MIs[0] round
     /* 2140794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140797 */     // MIs[0] policy
     /* 2140797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140807 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2140810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140833 */     // GIR_Coverage, 17653,
     /* 2140833 */     GIR_EraseRootFromParent_Done,
     /* 2140834 */   // Label 28293: @2140834
     /* 2140834 */   GIM_Try, /*On fail goto*//*Label 28294*/ GIMT_Encode4(2140925), // Rule ID 17656 //
     /* 2140839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2140850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2140853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2140856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2140862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140885 */     // MIs[0] round
     /* 2140885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140888 */     // MIs[0] policy
     /* 2140888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140898 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2140901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140924 */     // GIR_Coverage, 17656,
     /* 2140924 */     GIR_EraseRootFromParent_Done,
     /* 2140925 */   // Label 28294: @2140925
     /* 2140925 */   GIM_Try, /*On fail goto*//*Label 28295*/ GIMT_Encode4(2141016), // Rule ID 17657 //
     /* 2140930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2140938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2140941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2140944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2140947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2140950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2140953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2140972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140976 */     // MIs[0] round
     /* 2140976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140979 */     // MIs[0] policy
     /* 2140979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140989 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2140992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2140996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141015 */     // GIR_Coverage, 17657,
     /* 2141015 */     GIR_EraseRootFromParent_Done,
     /* 2141016 */   // Label 28295: @2141016
     /* 2141016 */   GIM_Try, /*On fail goto*//*Label 28296*/ GIMT_Encode4(2141107), // Rule ID 17660 //
     /* 2141021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141067 */     // MIs[0] round
     /* 2141067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141070 */     // MIs[0] policy
     /* 2141070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141080 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2141083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141106 */     // GIR_Coverage, 17660,
     /* 2141106 */     GIR_EraseRootFromParent_Done,
     /* 2141107 */   // Label 28296: @2141107
     /* 2141107 */   GIM_Try, /*On fail goto*//*Label 28297*/ GIMT_Encode4(2141198), // Rule ID 17661 //
     /* 2141112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141158 */     // MIs[0] round
     /* 2141158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141161 */     // MIs[0] policy
     /* 2141161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141171 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2141174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141197 */     // GIR_Coverage, 17661,
     /* 2141197 */     GIR_EraseRootFromParent_Done,
     /* 2141198 */   // Label 28297: @2141198
     /* 2141198 */   GIM_Try, /*On fail goto*//*Label 28298*/ GIMT_Encode4(2141289), // Rule ID 17664 //
     /* 2141203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141249 */     // MIs[0] round
     /* 2141249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141252 */     // MIs[0] policy
     /* 2141252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141262 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2141265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141288 */     // GIR_Coverage, 17664,
     /* 2141288 */     GIR_EraseRootFromParent_Done,
     /* 2141289 */   // Label 28298: @2141289
     /* 2141289 */   GIM_Try, /*On fail goto*//*Label 28299*/ GIMT_Encode4(2141380), // Rule ID 17665 //
     /* 2141294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141340 */     // MIs[0] round
     /* 2141340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141343 */     // MIs[0] policy
     /* 2141343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141353 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2141356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141379 */     // GIR_Coverage, 17665,
     /* 2141379 */     GIR_EraseRootFromParent_Done,
     /* 2141380 */   // Label 28299: @2141380
     /* 2141380 */   GIM_Try, /*On fail goto*//*Label 28300*/ GIMT_Encode4(2141471), // Rule ID 17668 //
     /* 2141385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141431 */     // MIs[0] round
     /* 2141431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141434 */     // MIs[0] policy
     /* 2141434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141444 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2141447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141470 */     // GIR_Coverage, 17668,
     /* 2141470 */     GIR_EraseRootFromParent_Done,
     /* 2141471 */   // Label 28300: @2141471
     /* 2141471 */   GIM_Try, /*On fail goto*//*Label 28301*/ GIMT_Encode4(2141562), // Rule ID 17669 //
     /* 2141476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2141496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2141518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141522 */     // MIs[0] round
     /* 2141522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141525 */     // MIs[0] policy
     /* 2141525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141535 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2141538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141561 */     // GIR_Coverage, 17669,
     /* 2141561 */     GIR_EraseRootFromParent_Done,
     /* 2141562 */   // Label 28301: @2141562
     /* 2141562 */   GIM_Try, /*On fail goto*//*Label 28302*/ GIMT_Encode4(2141653), // Rule ID 17672 //
     /* 2141567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2141578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2141581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2141584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141613 */     // MIs[0] round
     /* 2141613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141616 */     // MIs[0] policy
     /* 2141616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141626 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2141629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141652 */     // GIR_Coverage, 17672,
     /* 2141652 */     GIR_EraseRootFromParent_Done,
     /* 2141653 */   // Label 28302: @2141653
     /* 2141653 */   GIM_Try, /*On fail goto*//*Label 28303*/ GIMT_Encode4(2141744), // Rule ID 17673 //
     /* 2141658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2141661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2141669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2141672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2141675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141704 */     // MIs[0] round
     /* 2141704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141707 */     // MIs[0] policy
     /* 2141707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141717 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2141720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141743 */     // GIR_Coverage, 17673,
     /* 2141743 */     GIR_EraseRootFromParent_Done,
     /* 2141744 */   // Label 28303: @2141744
     /* 2141744 */   GIM_Try, /*On fail goto*//*Label 28304*/ GIMT_Encode4(2141835), // Rule ID 17676 //
     /* 2141749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2141760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141795 */     // MIs[0] round
     /* 2141795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141798 */     // MIs[0] policy
     /* 2141798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141808 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2141811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141834 */     // GIR_Coverage, 17676,
     /* 2141834 */     GIR_EraseRootFromParent_Done,
     /* 2141835 */   // Label 28304: @2141835
     /* 2141835 */   GIM_Try, /*On fail goto*//*Label 28305*/ GIMT_Encode4(2141926), // Rule ID 17677 //
     /* 2141840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2141843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2141851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141886 */     // MIs[0] round
     /* 2141886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141889 */     // MIs[0] policy
     /* 2141889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141899 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2141902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141925 */     // GIR_Coverage, 17677,
     /* 2141925 */     GIR_EraseRootFromParent_Done,
     /* 2141926 */   // Label 28305: @2141926
     /* 2141926 */   GIM_Try, /*On fail goto*//*Label 28306*/ GIMT_Encode4(2142017), // Rule ID 17680 //
     /* 2141931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2141939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2141942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2141945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2141948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2141951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2141973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141977 */     // MIs[0] round
     /* 2141977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141980 */     // MIs[0] policy
     /* 2141980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141990 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2141993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2141997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142016 */     // GIR_Coverage, 17680,
     /* 2142016 */     GIR_EraseRootFromParent_Done,
     /* 2142017 */   // Label 28306: @2142017
     /* 2142017 */   GIM_Try, /*On fail goto*//*Label 28307*/ GIMT_Encode4(2142108), // Rule ID 17681 //
     /* 2142022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2142030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2142033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2142036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2142039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2142042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2142064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142068 */     // MIs[0] round
     /* 2142068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142071 */     // MIs[0] policy
     /* 2142071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142081 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2142084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142107 */     // GIR_Coverage, 17681,
     /* 2142107 */     GIR_EraseRootFromParent_Done,
     /* 2142108 */   // Label 28307: @2142108
     /* 2142108 */   GIM_Try, /*On fail goto*//*Label 28308*/ GIMT_Encode4(2142199), // Rule ID 17684 //
     /* 2142113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2142130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142159 */     // MIs[0] round
     /* 2142159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142162 */     // MIs[0] policy
     /* 2142162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142172 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2142175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142198 */     // GIR_Coverage, 17684,
     /* 2142198 */     GIR_EraseRootFromParent_Done,
     /* 2142199 */   // Label 28308: @2142199
     /* 2142199 */   GIM_Try, /*On fail goto*//*Label 28309*/ GIMT_Encode4(2142290), // Rule ID 17685 //
     /* 2142204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2142221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142250 */     // MIs[0] round
     /* 2142250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142253 */     // MIs[0] policy
     /* 2142253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142263 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2142266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142289 */     // GIR_Coverage, 17685,
     /* 2142289 */     GIR_EraseRootFromParent_Done,
     /* 2142290 */   // Label 28309: @2142290
     /* 2142290 */   GIM_Try, /*On fail goto*//*Label 28310*/ GIMT_Encode4(2142381), // Rule ID 17688 //
     /* 2142295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2142309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2142312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142341 */     // MIs[0] round
     /* 2142341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142344 */     // MIs[0] policy
     /* 2142344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142354 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2142357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142380 */     // GIR_Coverage, 17688,
     /* 2142380 */     GIR_EraseRootFromParent_Done,
     /* 2142381 */   // Label 28310: @2142381
     /* 2142381 */   GIM_Try, /*On fail goto*//*Label 28311*/ GIMT_Encode4(2142472), // Rule ID 17689 //
     /* 2142386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2142400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2142403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142432 */     // MIs[0] round
     /* 2142432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142435 */     // MIs[0] policy
     /* 2142435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142445 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2142448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142471 */     // GIR_Coverage, 17689,
     /* 2142471 */     GIR_EraseRootFromParent_Done,
     /* 2142472 */   // Label 28311: @2142472
     /* 2142472 */   GIM_Try, /*On fail goto*//*Label 28312*/ GIMT_Encode4(2142563), // Rule ID 17692 //
     /* 2142477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2142497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142523 */     // MIs[0] round
     /* 2142523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142526 */     // MIs[0] policy
     /* 2142526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142536 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2142539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142562 */     // GIR_Coverage, 17692,
     /* 2142562 */     GIR_EraseRootFromParent_Done,
     /* 2142563 */   // Label 28312: @2142563
     /* 2142563 */   GIM_Try, /*On fail goto*//*Label 28313*/ GIMT_Encode4(2142654), // Rule ID 17693 //
     /* 2142568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2142579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2142582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2142585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2142588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2142598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142614 */     // MIs[0] round
     /* 2142614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142617 */     // MIs[0] policy
     /* 2142617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142627 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2142630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142653 */     // GIR_Coverage, 17693,
     /* 2142653 */     GIR_EraseRootFromParent_Done,
     /* 2142654 */   // Label 28313: @2142654
     /* 2142654 */   GIM_Try, /*On fail goto*//*Label 28314*/ GIMT_Encode4(2142745), // Rule ID 17696 //
     /* 2142659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2142670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2142673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2142676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2142679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142705 */     // MIs[0] round
     /* 2142705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142708 */     // MIs[0] policy
     /* 2142708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142718 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2142721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142744 */     // GIR_Coverage, 17696,
     /* 2142744 */     GIR_EraseRootFromParent_Done,
     /* 2142745 */   // Label 28314: @2142745
     /* 2142745 */   GIM_Try, /*On fail goto*//*Label 28315*/ GIMT_Encode4(2142836), // Rule ID 17697 //
     /* 2142750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2142761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2142764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2142767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2142770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2142780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2142792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142796 */     // MIs[0] round
     /* 2142796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142799 */     // MIs[0] policy
     /* 2142799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142809 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2142812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142835 */     // GIR_Coverage, 17697,
     /* 2142835 */     GIR_EraseRootFromParent_Done,
     /* 2142836 */   // Label 28315: @2142836
     /* 2142836 */   GIM_Try, /*On fail goto*//*Label 28316*/ GIMT_Encode4(2142927), // Rule ID 17700 //
     /* 2142841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2142844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2142852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2142855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2142858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2142861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2142864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142887 */     // MIs[0] round
     /* 2142887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142890 */     // MIs[0] policy
     /* 2142890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142900 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2142903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142926 */     // GIR_Coverage, 17700,
     /* 2142926 */     GIR_EraseRootFromParent_Done,
     /* 2142927 */   // Label 28316: @2142927
     /* 2142927 */   GIM_Try, /*On fail goto*//*Label 28317*/ GIMT_Encode4(2143018), // Rule ID 17701 //
     /* 2142932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2142935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2142940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2142943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2142946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2142949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2142952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2142955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2142974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142978 */     // MIs[0] round
     /* 2142978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142981 */     // MIs[0] policy
     /* 2142981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142991 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2142994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2142998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143017 */     // GIR_Coverage, 17701,
     /* 2143017 */     GIR_EraseRootFromParent_Done,
     /* 2143018 */   // Label 28317: @2143018
     /* 2143018 */   GIM_Try, /*On fail goto*//*Label 28318*/ GIMT_Encode4(2143109), // Rule ID 17704 //
     /* 2143023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2143043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143069 */     // MIs[0] round
     /* 2143069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143072 */     // MIs[0] policy
     /* 2143072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143082 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2143085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143108 */     // GIR_Coverage, 17704,
     /* 2143108 */     GIR_EraseRootFromParent_Done,
     /* 2143109 */   // Label 28318: @2143109
     /* 2143109 */   GIM_Try, /*On fail goto*//*Label 28319*/ GIMT_Encode4(2143200), // Rule ID 17705 //
     /* 2143114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2143131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2143134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143160 */     // MIs[0] round
     /* 2143160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143163 */     // MIs[0] policy
     /* 2143163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143173 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2143176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143199 */     // GIR_Coverage, 17705,
     /* 2143199 */     GIR_EraseRootFromParent_Done,
     /* 2143200 */   // Label 28319: @2143200
     /* 2143200 */   GIM_Try, /*On fail goto*//*Label 28320*/ GIMT_Encode4(2143291), // Rule ID 17708 //
     /* 2143205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2143222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2143225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143251 */     // MIs[0] round
     /* 2143251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143254 */     // MIs[0] policy
     /* 2143254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2143267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143290 */     // GIR_Coverage, 17708,
     /* 2143290 */     GIR_EraseRootFromParent_Done,
     /* 2143291 */   // Label 28320: @2143291
     /* 2143291 */   GIM_Try, /*On fail goto*//*Label 28321*/ GIMT_Encode4(2143382), // Rule ID 17709 //
     /* 2143296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2143307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2143310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2143313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2143316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143342 */     // MIs[0] round
     /* 2143342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143345 */     // MIs[0] policy
     /* 2143345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143355 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2143358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143381 */     // GIR_Coverage, 17709,
     /* 2143381 */     GIR_EraseRootFromParent_Done,
     /* 2143382 */   // Label 28321: @2143382
     /* 2143382 */   GIM_Try, /*On fail goto*//*Label 28322*/ GIMT_Encode4(2143473), // Rule ID 17712 //
     /* 2143387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143433 */     // MIs[0] round
     /* 2143433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143436 */     // MIs[0] policy
     /* 2143436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143446 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2143449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143472 */     // GIR_Coverage, 17712,
     /* 2143472 */     GIR_EraseRootFromParent_Done,
     /* 2143473 */   // Label 28322: @2143473
     /* 2143473 */   GIM_Try, /*On fail goto*//*Label 28323*/ GIMT_Encode4(2143564), // Rule ID 17713 //
     /* 2143478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2143489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2143492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2143495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143524 */     // MIs[0] round
     /* 2143524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143527 */     // MIs[0] policy
     /* 2143527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143537 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2143540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143563 */     // GIR_Coverage, 17713,
     /* 2143563 */     GIR_EraseRootFromParent_Done,
     /* 2143564 */   // Label 28323: @2143564
     /* 2143564 */   GIM_Try, /*On fail goto*//*Label 28324*/ GIMT_Encode4(2143655), // Rule ID 17716 //
     /* 2143569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2143572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2143580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2143586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2143589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143615 */     // MIs[0] round
     /* 2143615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143618 */     // MIs[0] policy
     /* 2143618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143628 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2143631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143654 */     // GIR_Coverage, 17716,
     /* 2143654 */     GIR_EraseRootFromParent_Done,
     /* 2143655 */   // Label 28324: @2143655
     /* 2143655 */   GIM_Try, /*On fail goto*//*Label 28325*/ GIMT_Encode4(2143746), // Rule ID 17717 //
     /* 2143660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2143663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2143671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2143674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2143677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2143680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143706 */     // MIs[0] round
     /* 2143706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143709 */     // MIs[0] policy
     /* 2143709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143719 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2143722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143745 */     // GIR_Coverage, 17717,
     /* 2143745 */     GIR_EraseRootFromParent_Done,
     /* 2143746 */   // Label 28325: @2143746
     /* 2143746 */   GIM_Try, /*On fail goto*//*Label 28326*/ GIMT_Encode4(2143837), // Rule ID 17720 //
     /* 2143751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2143754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2143762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2143765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2143768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143797 */     // MIs[0] round
     /* 2143797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143800 */     // MIs[0] policy
     /* 2143800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143810 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2143813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143836 */     // GIR_Coverage, 17720,
     /* 2143836 */     GIR_EraseRootFromParent_Done,
     /* 2143837 */   // Label 28326: @2143837
     /* 2143837 */   GIM_Try, /*On fail goto*//*Label 28327*/ GIMT_Encode4(2143928), // Rule ID 17721 //
     /* 2143842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2143845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2143853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2143856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2143859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143888 */     // MIs[0] round
     /* 2143888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143891 */     // MIs[0] policy
     /* 2143891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143901 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2143904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143927 */     // GIR_Coverage, 17721,
     /* 2143927 */     GIR_EraseRootFromParent_Done,
     /* 2143928 */   // Label 28327: @2143928
     /* 2143928 */   GIM_Try, /*On fail goto*//*Label 28328*/ GIMT_Encode4(2144019), // Rule ID 17724 //
     /* 2143933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2143936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2143941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2143944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2143947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2143950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2143953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143979 */     // MIs[0] round
     /* 2143979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143982 */     // MIs[0] policy
     /* 2143982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143992 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2143995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2143999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144018 */     // GIR_Coverage, 17724,
     /* 2144018 */     GIR_EraseRootFromParent_Done,
     /* 2144019 */   // Label 28328: @2144019
     /* 2144019 */   GIM_Try, /*On fail goto*//*Label 28329*/ GIMT_Encode4(2144110), // Rule ID 17725 //
     /* 2144024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2144035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2144038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2144041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144070 */     // MIs[0] round
     /* 2144070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144073 */     // MIs[0] policy
     /* 2144073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144083 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11306:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2144086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144109 */     // GIR_Coverage, 17725,
     /* 2144109 */     GIR_EraseRootFromParent_Done,
     /* 2144110 */   // Label 28329: @2144110
     /* 2144110 */   GIM_Try, /*On fail goto*//*Label 28330*/ GIMT_Encode4(2144201), // Rule ID 17728 //
     /* 2144115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144161 */     // MIs[0] round
     /* 2144161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144164 */     // MIs[0] policy
     /* 2144164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144174 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2144177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144200 */     // GIR_Coverage, 17728,
     /* 2144200 */     GIR_EraseRootFromParent_Done,
     /* 2144201 */   // Label 28330: @2144201
     /* 2144201 */   GIM_Try, /*On fail goto*//*Label 28331*/ GIMT_Encode4(2144292), // Rule ID 17729 //
     /* 2144206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2144217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2144220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2144223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144252 */     // MIs[0] round
     /* 2144252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144255 */     // MIs[0] policy
     /* 2144255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144265 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2144268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144291 */     // GIR_Coverage, 17729,
     /* 2144291 */     GIR_EraseRootFromParent_Done,
     /* 2144292 */   // Label 28331: @2144292
     /* 2144292 */   GIM_Try, /*On fail goto*//*Label 28332*/ GIMT_Encode4(2144383), // Rule ID 17732 //
     /* 2144297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2144308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144343 */     // MIs[0] round
     /* 2144343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144346 */     // MIs[0] policy
     /* 2144346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144356 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2144359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144382 */     // GIR_Coverage, 17732,
     /* 2144382 */     GIR_EraseRootFromParent_Done,
     /* 2144383 */   // Label 28332: @2144383
     /* 2144383 */   GIM_Try, /*On fail goto*//*Label 28333*/ GIMT_Encode4(2144474), // Rule ID 17733 //
     /* 2144388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2144399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2144405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144434 */     // MIs[0] round
     /* 2144434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144437 */     // MIs[0] policy
     /* 2144437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144447 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2144450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144473 */     // GIR_Coverage, 17733,
     /* 2144473 */     GIR_EraseRootFromParent_Done,
     /* 2144474 */   // Label 28333: @2144474
     /* 2144474 */   GIM_Try, /*On fail goto*//*Label 28334*/ GIMT_Encode4(2144565), // Rule ID 17736 //
     /* 2144479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2144482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2144490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2144493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2144496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144525 */     // MIs[0] round
     /* 2144525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144528 */     // MIs[0] policy
     /* 2144528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144538 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2144541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144564 */     // GIR_Coverage, 17736,
     /* 2144564 */     GIR_EraseRootFromParent_Done,
     /* 2144565 */   // Label 28334: @2144565
     /* 2144565 */   GIM_Try, /*On fail goto*//*Label 28335*/ GIMT_Encode4(2144656), // Rule ID 17737 //
     /* 2144570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2144573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2144581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2144584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2144587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2144590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2144612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144616 */     // MIs[0] round
     /* 2144616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144619 */     // MIs[0] policy
     /* 2144619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144629 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2144632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144655 */     // GIR_Coverage, 17737,
     /* 2144655 */     GIR_EraseRootFromParent_Done,
     /* 2144656 */   // Label 28335: @2144656
     /* 2144656 */   GIM_Try, /*On fail goto*//*Label 28336*/ GIMT_Encode4(2144747), // Rule ID 17740 //
     /* 2144661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2144664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2144672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2144675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2144678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144707 */     // MIs[0] round
     /* 2144707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144710 */     // MIs[0] policy
     /* 2144710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144720 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2144723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144746 */     // GIR_Coverage, 17740,
     /* 2144746 */     GIR_EraseRootFromParent_Done,
     /* 2144747 */   // Label 28336: @2144747
     /* 2144747 */   GIM_Try, /*On fail goto*//*Label 28337*/ GIMT_Encode4(2144838), // Rule ID 17741 //
     /* 2144752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2144755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2144763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2144766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2144769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144798 */     // MIs[0] round
     /* 2144798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144801 */     // MIs[0] policy
     /* 2144801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144811 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11306:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2144814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144837 */     // GIR_Coverage, 17741,
     /* 2144837 */     GIR_EraseRootFromParent_Done,
     /* 2144838 */   // Label 28337: @2144838
     /* 2144838 */   GIM_Try, /*On fail goto*//*Label 28338*/ GIMT_Encode4(2144929), // Rule ID 17744 //
     /* 2144843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2144846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2144854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2144857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2144860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144889 */     // MIs[0] round
     /* 2144889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144892 */     // MIs[0] policy
     /* 2144892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144902 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2144905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2144909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144928 */     // GIR_Coverage, 17744,
     /* 2144928 */     GIR_EraseRootFromParent_Done,
     /* 2144929 */   // Label 28338: @2144929
     /* 2144929 */   GIM_Try, /*On fail goto*//*Label 28339*/ GIMT_Encode4(2145020), // Rule ID 17745 //
     /* 2144934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2144937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2144942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2144945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2144948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2144951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2144954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144980 */     // MIs[0] round
     /* 2144980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144983 */     // MIs[0] policy
     /* 2144983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144993 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11306:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2144996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145019 */     // GIR_Coverage, 17745,
     /* 2145019 */     GIR_EraseRootFromParent_Done,
     /* 2145020 */   // Label 28339: @2145020
     /* 2145020 */   GIM_Try, /*On fail goto*//*Label 28340*/ GIMT_Encode4(2145111), // Rule ID 17748 //
     /* 2145025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145071 */     // MIs[0] round
     /* 2145071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145074 */     // MIs[0] policy
     /* 2145074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145084 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2145087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145110 */     // GIR_Coverage, 17748,
     /* 2145110 */     GIR_EraseRootFromParent_Done,
     /* 2145111 */   // Label 28340: @2145111
     /* 2145111 */   GIM_Try, /*On fail goto*//*Label 28341*/ GIMT_Encode4(2145202), // Rule ID 17749 //
     /* 2145116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2145127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2145130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2145133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2145146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2145154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145162 */     // MIs[0] round
     /* 2145162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145165 */     // MIs[0] policy
     /* 2145165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145175 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11306:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2145178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145201 */     // GIR_Coverage, 17749,
     /* 2145201 */     GIR_EraseRootFromParent_Done,
     /* 2145202 */   // Label 28341: @2145202
     /* 2145202 */   GIM_Try, /*On fail goto*//*Label 28342*/ GIMT_Encode4(2145293), // Rule ID 17752 //
     /* 2145207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2145210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145253 */     // MIs[0] round
     /* 2145253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145256 */     // MIs[0] policy
     /* 2145256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145266 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2145269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145292 */     // GIR_Coverage, 17752,
     /* 2145292 */     GIR_EraseRootFromParent_Done,
     /* 2145293 */   // Label 28342: @2145293
     /* 2145293 */   GIM_Try, /*On fail goto*//*Label 28343*/ GIMT_Encode4(2145384), // Rule ID 17753 //
     /* 2145298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2145301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2145306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2145309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2145312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2145315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2145318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2145321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2145328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2145332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2145336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2145340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145344 */     // MIs[0] round
     /* 2145344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145347 */     // MIs[0] policy
     /* 2145347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145357 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11306:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2145360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2145364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145383 */     // GIR_Coverage, 17753,
     /* 2145383 */     GIR_EraseRootFromParent_Done,
     /* 2145384 */   // Label 28343: @2145384
     /* 2145384 */   GIM_Try, /*On fail goto*//*Label 28344*/ GIMT_Encode4(2145475), // Rule ID 17756 //
     /* 2145389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145435 */     // MIs[0] round
     /* 2145435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145438 */     // MIs[0] policy
     /* 2145438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145448 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2145451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145474 */     // GIR_Coverage, 17756,
     /* 2145474 */     GIR_EraseRootFromParent_Done,
     /* 2145475 */   // Label 28344: @2145475
     /* 2145475 */   GIM_Try, /*On fail goto*//*Label 28345*/ GIMT_Encode4(2145566), // Rule ID 17757 //
     /* 2145480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145526 */     // MIs[0] round
     /* 2145526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145529 */     // MIs[0] policy
     /* 2145529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145539 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2145542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145565 */     // GIR_Coverage, 17757,
     /* 2145565 */     GIR_EraseRootFromParent_Done,
     /* 2145566 */   // Label 28345: @2145566
     /* 2145566 */   GIM_Try, /*On fail goto*//*Label 28346*/ GIMT_Encode4(2145657), // Rule ID 17760 //
     /* 2145571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2145582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2145585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2145591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145617 */     // MIs[0] round
     /* 2145617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145620 */     // MIs[0] policy
     /* 2145620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145630 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2145633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145656 */     // GIR_Coverage, 17760,
     /* 2145656 */     GIR_EraseRootFromParent_Done,
     /* 2145657 */   // Label 28346: @2145657
     /* 2145657 */   GIM_Try, /*On fail goto*//*Label 28347*/ GIMT_Encode4(2145748), // Rule ID 17761 //
     /* 2145662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2145665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2145673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2145676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2145682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145708 */     // MIs[0] round
     /* 2145708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145711 */     // MIs[0] policy
     /* 2145711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145721 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2145724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145747 */     // GIR_Coverage, 17761,
     /* 2145747 */     GIR_EraseRootFromParent_Done,
     /* 2145748 */   // Label 28347: @2145748
     /* 2145748 */   GIM_Try, /*On fail goto*//*Label 28348*/ GIMT_Encode4(2145839), // Rule ID 17764 //
     /* 2145753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2145764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2145767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2145770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2145773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145799 */     // MIs[0] round
     /* 2145799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145802 */     // MIs[0] policy
     /* 2145802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145812 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2145815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145838 */     // GIR_Coverage, 17764,
     /* 2145838 */     GIR_EraseRootFromParent_Done,
     /* 2145839 */   // Label 28348: @2145839
     /* 2145839 */   GIM_Try, /*On fail goto*//*Label 28349*/ GIMT_Encode4(2145930), // Rule ID 17765 //
     /* 2145844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2145855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2145858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2145861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2145864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145890 */     // MIs[0] round
     /* 2145890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145893 */     // MIs[0] policy
     /* 2145893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145903 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2145906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145929 */     // GIR_Coverage, 17765,
     /* 2145929 */     GIR_EraseRootFromParent_Done,
     /* 2145930 */   // Label 28349: @2145930
     /* 2145930 */   GIM_Try, /*On fail goto*//*Label 28350*/ GIMT_Encode4(2146021), // Rule ID 17768 //
     /* 2145935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2145943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2145946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2145949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2145952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2145955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145981 */     // MIs[0] round
     /* 2145981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145984 */     // MIs[0] policy
     /* 2145984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145994 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2145997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146020 */     // GIR_Coverage, 17768,
     /* 2146020 */     GIR_EraseRootFromParent_Done,
     /* 2146021 */   // Label 28350: @2146021
     /* 2146021 */   GIM_Try, /*On fail goto*//*Label 28351*/ GIMT_Encode4(2146112), // Rule ID 17769 //
     /* 2146026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2146037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2146040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2146043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2146046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2146049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146072 */     // MIs[0] round
     /* 2146072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146075 */     // MIs[0] policy
     /* 2146075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146085 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2146088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146111 */     // GIR_Coverage, 17769,
     /* 2146111 */     GIR_EraseRootFromParent_Done,
     /* 2146112 */   // Label 28351: @2146112
     /* 2146112 */   GIM_Try, /*On fail goto*//*Label 28352*/ GIMT_Encode4(2146203), // Rule ID 17772 //
     /* 2146117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2146120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2146134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2146137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146163 */     // MIs[0] round
     /* 2146163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146166 */     // MIs[0] policy
     /* 2146166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146176 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2146179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146202 */     // GIR_Coverage, 17772,
     /* 2146202 */     GIR_EraseRootFromParent_Done,
     /* 2146203 */   // Label 28352: @2146203
     /* 2146203 */   GIM_Try, /*On fail goto*//*Label 28353*/ GIMT_Encode4(2146294), // Rule ID 17773 //
     /* 2146208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2146211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2146219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2146222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2146225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2146228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2146231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2146238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2146250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146254 */     // MIs[0] round
     /* 2146254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146257 */     // MIs[0] policy
     /* 2146257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146267 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2146270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2146290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146293 */     // GIR_Coverage, 17773,
     /* 2146293 */     GIR_EraseRootFromParent_Done,
     /* 2146294 */   // Label 28353: @2146294
     /* 2146294 */   GIM_Try, /*On fail goto*//*Label 28354*/ GIMT_Encode4(2146385), // Rule ID 17776 //
     /* 2146299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146345 */     // MIs[0] round
     /* 2146345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146348 */     // MIs[0] policy
     /* 2146348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146358 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2146361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146384 */     // GIR_Coverage, 17776,
     /* 2146384 */     GIR_EraseRootFromParent_Done,
     /* 2146385 */   // Label 28354: @2146385
     /* 2146385 */   GIM_Try, /*On fail goto*//*Label 28355*/ GIMT_Encode4(2146476), // Rule ID 17777 //
     /* 2146390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146436 */     // MIs[0] round
     /* 2146436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146439 */     // MIs[0] policy
     /* 2146439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146449 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2146452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146475 */     // GIR_Coverage, 17777,
     /* 2146475 */     GIR_EraseRootFromParent_Done,
     /* 2146476 */   // Label 28355: @2146476
     /* 2146476 */   GIM_Try, /*On fail goto*//*Label 28356*/ GIMT_Encode4(2146567), // Rule ID 17780 //
     /* 2146481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2146492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2146495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146527 */     // MIs[0] round
     /* 2146527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146530 */     // MIs[0] policy
     /* 2146530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146540 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2146543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146566 */     // GIR_Coverage, 17780,
     /* 2146566 */     GIR_EraseRootFromParent_Done,
     /* 2146567 */   // Label 28356: @2146567
     /* 2146567 */   GIM_Try, /*On fail goto*//*Label 28357*/ GIMT_Encode4(2146658), // Rule ID 17781 //
     /* 2146572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2146583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2146586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146618 */     // MIs[0] round
     /* 2146618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146621 */     // MIs[0] policy
     /* 2146621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146631 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2146634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146657 */     // GIR_Coverage, 17781,
     /* 2146657 */     GIR_EraseRootFromParent_Done,
     /* 2146658 */   // Label 28357: @2146658
     /* 2146658 */   GIM_Try, /*On fail goto*//*Label 28358*/ GIMT_Encode4(2146749), // Rule ID 17784 //
     /* 2146663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2146674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2146677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2146680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2146683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2146686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146709 */     // MIs[0] round
     /* 2146709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146712 */     // MIs[0] policy
     /* 2146712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146722 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2146725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146748 */     // GIR_Coverage, 17784,
     /* 2146748 */     GIR_EraseRootFromParent_Done,
     /* 2146749 */   // Label 28358: @2146749
     /* 2146749 */   GIM_Try, /*On fail goto*//*Label 28359*/ GIMT_Encode4(2146840), // Rule ID 17785 //
     /* 2146754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2146765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2146768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2146771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2146774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2146777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146800 */     // MIs[0] round
     /* 2146800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146803 */     // MIs[0] policy
     /* 2146803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146813 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2146816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146839 */     // GIR_Coverage, 17785,
     /* 2146839 */     GIR_EraseRootFromParent_Done,
     /* 2146840 */   // Label 28359: @2146840
     /* 2146840 */   GIM_Try, /*On fail goto*//*Label 28360*/ GIMT_Encode4(2146931), // Rule ID 17788 //
     /* 2146845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2146856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2146859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2146862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2146865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146891 */     // MIs[0] round
     /* 2146891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146894 */     // MIs[0] policy
     /* 2146894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146904 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2146907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146930 */     // GIR_Coverage, 17788,
     /* 2146930 */     GIR_EraseRootFromParent_Done,
     /* 2146931 */   // Label 28360: @2146931
     /* 2146931 */   GIM_Try, /*On fail goto*//*Label 28361*/ GIMT_Encode4(2147022), // Rule ID 17789 //
     /* 2146936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2146944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2146947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2146950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2146953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2146956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146982 */     // MIs[0] round
     /* 2146982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146985 */     // MIs[0] policy
     /* 2146985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146995 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2146998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147021 */     // GIR_Coverage, 17789,
     /* 2147021 */     GIR_EraseRootFromParent_Done,
     /* 2147022 */   // Label 28361: @2147022
     /* 2147022 */   GIM_Try, /*On fail goto*//*Label 28362*/ GIMT_Encode4(2147113), // Rule ID 17792 //
     /* 2147027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2147038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2147041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147073 */     // MIs[0] round
     /* 2147073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147076 */     // MIs[0] policy
     /* 2147076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147086 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2147089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147112 */     // GIR_Coverage, 17792,
     /* 2147112 */     GIR_EraseRootFromParent_Done,
     /* 2147113 */   // Label 28362: @2147113
     /* 2147113 */   GIM_Try, /*On fail goto*//*Label 28363*/ GIMT_Encode4(2147204), // Rule ID 17793 //
     /* 2147118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2147129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2147132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2147135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2147138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147164 */     // MIs[0] round
     /* 2147164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147167 */     // MIs[0] policy
     /* 2147167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147177 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2147180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147203 */     // GIR_Coverage, 17793,
     /* 2147203 */     GIR_EraseRootFromParent_Done,
     /* 2147204 */   // Label 28363: @2147204
     /* 2147204 */   GIM_Try, /*On fail goto*//*Label 28364*/ GIMT_Encode4(2147295), // Rule ID 17796 //
     /* 2147209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2147220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2147229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147255 */     // MIs[0] round
     /* 2147255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147258 */     // MIs[0] policy
     /* 2147258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147268 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2147271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147294 */     // GIR_Coverage, 17796,
     /* 2147294 */     GIR_EraseRootFromParent_Done,
     /* 2147295 */   // Label 28364: @2147295
     /* 2147295 */   GIM_Try, /*On fail goto*//*Label 28365*/ GIMT_Encode4(2147386), // Rule ID 17797 //
     /* 2147300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2147303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2147311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2147320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147346 */     // MIs[0] round
     /* 2147346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147349 */     // MIs[0] policy
     /* 2147349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147359 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2147362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147385 */     // GIR_Coverage, 17797,
     /* 2147385 */     GIR_EraseRootFromParent_Done,
     /* 2147386 */   // Label 28365: @2147386
     /* 2147386 */   GIM_Try, /*On fail goto*//*Label 28366*/ GIMT_Encode4(2147477), // Rule ID 17800 //
     /* 2147391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147437 */     // MIs[0] round
     /* 2147437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147440 */     // MIs[0] policy
     /* 2147440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147450 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2147453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147476 */     // GIR_Coverage, 17800,
     /* 2147476 */     GIR_EraseRootFromParent_Done,
     /* 2147477 */   // Label 28366: @2147477
     /* 2147477 */   GIM_Try, /*On fail goto*//*Label 28367*/ GIMT_Encode4(2147568), // Rule ID 17801 //
     /* 2147482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147528 */     // MIs[0] round
     /* 2147528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147531 */     // MIs[0] policy
     /* 2147531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147541 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2147544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147567 */     // GIR_Coverage, 17801,
     /* 2147567 */     GIR_EraseRootFromParent_Done,
     /* 2147568 */   // Label 28367: @2147568
     /* 2147568 */   GIM_Try, /*On fail goto*//*Label 28368*/ GIMT_Encode4(2147659), // Rule ID 17804 //
     /* 2147573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2147584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2147587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2147590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2147593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147619 */     // MIs[0] round
     /* 2147619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147622 */     // MIs[0] policy
     /* 2147622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147632 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2147635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147658 */     // GIR_Coverage, 17804,
     /* 2147658 */     GIR_EraseRootFromParent_Done,
     /* 2147659 */   // Label 28368: @2147659
     /* 2147659 */   GIM_Try, /*On fail goto*//*Label 28369*/ GIMT_Encode4(2147750), // Rule ID 17805 //
     /* 2147664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2147675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2147678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2147681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2147684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147710 */     // MIs[0] round
     /* 2147710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147713 */     // MIs[0] policy
     /* 2147713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147723 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2147726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147749 */     // GIR_Coverage, 17805,
     /* 2147749 */     GIR_EraseRootFromParent_Done,
     /* 2147750 */   // Label 28369: @2147750
     /* 2147750 */   GIM_Try, /*On fail goto*//*Label 28370*/ GIMT_Encode4(2147841), // Rule ID 17808 //
     /* 2147755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2147766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2147769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2147772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2147775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147801 */     // MIs[0] round
     /* 2147801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147804 */     // MIs[0] policy
     /* 2147804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147814 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2147817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147840 */     // GIR_Coverage, 17808,
     /* 2147840 */     GIR_EraseRootFromParent_Done,
     /* 2147841 */   // Label 28370: @2147841
     /* 2147841 */   GIM_Try, /*On fail goto*//*Label 28371*/ GIMT_Encode4(2147932), // Rule ID 17809 //
     /* 2147846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2147857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2147860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2147863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2147866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147892 */     // MIs[0] round
     /* 2147892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147895 */     // MIs[0] policy
     /* 2147895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147905 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2147908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147931 */     // GIR_Coverage, 17809,
     /* 2147931 */     GIR_EraseRootFromParent_Done,
     /* 2147932 */   // Label 28371: @2147932
     /* 2147932 */   GIM_Try, /*On fail goto*//*Label 28372*/ GIMT_Encode4(2148023), // Rule ID 17812 //
     /* 2147937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2147945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2147948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2147951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2147957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2147960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147983 */     // MIs[0] round
     /* 2147983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147986 */     // MIs[0] policy
     /* 2147986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147996 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2147999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148022 */     // GIR_Coverage, 17812,
     /* 2148022 */     GIR_EraseRootFromParent_Done,
     /* 2148023 */   // Label 28372: @2148023
     /* 2148023 */   GIM_Try, /*On fail goto*//*Label 28373*/ GIMT_Encode4(2148114), // Rule ID 17813 //
     /* 2148028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2148039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2148042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2148048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148074 */     // MIs[0] round
     /* 2148074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148077 */     // MIs[0] policy
     /* 2148077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148087 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2148090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148113 */     // GIR_Coverage, 17813,
     /* 2148113 */     GIR_EraseRootFromParent_Done,
     /* 2148114 */   // Label 28373: @2148114
     /* 2148114 */   GIM_Try, /*On fail goto*//*Label 28374*/ GIMT_Encode4(2148205), // Rule ID 17816 //
     /* 2148119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2148130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2148133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2148139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148165 */     // MIs[0] round
     /* 2148165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148168 */     // MIs[0] policy
     /* 2148168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148178 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2148181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148204 */     // GIR_Coverage, 17816,
     /* 2148204 */     GIR_EraseRootFromParent_Done,
     /* 2148205 */   // Label 28374: @2148205
     /* 2148205 */   GIM_Try, /*On fail goto*//*Label 28375*/ GIMT_Encode4(2148296), // Rule ID 17817 //
     /* 2148210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2148221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2148224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2148230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148256 */     // MIs[0] round
     /* 2148256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148259 */     // MIs[0] policy
     /* 2148259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148269 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2148272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148295 */     // GIR_Coverage, 17817,
     /* 2148295 */     GIR_EraseRootFromParent_Done,
     /* 2148296 */   // Label 28375: @2148296
     /* 2148296 */   GIM_Try, /*On fail goto*//*Label 28376*/ GIMT_Encode4(2148387), // Rule ID 17820 //
     /* 2148301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148347 */     // MIs[0] round
     /* 2148347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148350 */     // MIs[0] policy
     /* 2148350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148360 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2148363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148386 */     // GIR_Coverage, 17820,
     /* 2148386 */     GIR_EraseRootFromParent_Done,
     /* 2148387 */   // Label 28376: @2148387
     /* 2148387 */   GIM_Try, /*On fail goto*//*Label 28377*/ GIMT_Encode4(2148478), // Rule ID 17821 //
     /* 2148392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148438 */     // MIs[0] round
     /* 2148438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148441 */     // MIs[0] policy
     /* 2148441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148451 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2148454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148477 */     // GIR_Coverage, 17821,
     /* 2148477 */     GIR_EraseRootFromParent_Done,
     /* 2148478 */   // Label 28377: @2148478
     /* 2148478 */   GIM_Try, /*On fail goto*//*Label 28378*/ GIMT_Encode4(2148569), // Rule ID 17824 //
     /* 2148483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2148494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2148497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2148503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148529 */     // MIs[0] round
     /* 2148529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148532 */     // MIs[0] policy
     /* 2148532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148542 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2148545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148568 */     // GIR_Coverage, 17824,
     /* 2148568 */     GIR_EraseRootFromParent_Done,
     /* 2148569 */   // Label 28378: @2148569
     /* 2148569 */   GIM_Try, /*On fail goto*//*Label 28379*/ GIMT_Encode4(2148660), // Rule ID 17825 //
     /* 2148574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2148585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2148588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2148594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148620 */     // MIs[0] round
     /* 2148620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148623 */     // MIs[0] policy
     /* 2148623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148633 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2148636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148659 */     // GIR_Coverage, 17825,
     /* 2148659 */     GIR_EraseRootFromParent_Done,
     /* 2148660 */   // Label 28379: @2148660
     /* 2148660 */   GIM_Try, /*On fail goto*//*Label 28380*/ GIMT_Encode4(2148751), // Rule ID 17828 //
     /* 2148665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2148676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2148679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2148685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148711 */     // MIs[0] round
     /* 2148711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148714 */     // MIs[0] policy
     /* 2148714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148724 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2148727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148750 */     // GIR_Coverage, 17828,
     /* 2148750 */     GIR_EraseRootFromParent_Done,
     /* 2148751 */   // Label 28380: @2148751
     /* 2148751 */   GIM_Try, /*On fail goto*//*Label 28381*/ GIMT_Encode4(2148842), // Rule ID 17829 //
     /* 2148756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2148767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2148770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2148776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148802 */     // MIs[0] round
     /* 2148802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148805 */     // MIs[0] policy
     /* 2148805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148815 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2148818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148841 */     // GIR_Coverage, 17829,
     /* 2148841 */     GIR_EraseRootFromParent_Done,
     /* 2148842 */   // Label 28381: @2148842
     /* 2148842 */   GIM_Try, /*On fail goto*//*Label 28382*/ GIMT_Encode4(2148933), // Rule ID 17832 //
     /* 2148847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2148850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2148858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2148861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2148867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2148885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148893 */     // MIs[0] round
     /* 2148893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148896 */     // MIs[0] policy
     /* 2148896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148906 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2148909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148932 */     // GIR_Coverage, 17832,
     /* 2148932 */     GIR_EraseRootFromParent_Done,
     /* 2148933 */   // Label 28382: @2148933
     /* 2148933 */   GIM_Try, /*On fail goto*//*Label 28383*/ GIMT_Encode4(2149024), // Rule ID 17833 //
     /* 2148938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2148941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2148946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2148949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2148952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2148958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2148976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148984 */     // MIs[0] round
     /* 2148984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148987 */     // MIs[0] policy
     /* 2148987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148997 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2149000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149023 */     // GIR_Coverage, 17833,
     /* 2149023 */     GIR_EraseRootFromParent_Done,
     /* 2149024 */   // Label 28383: @2149024
     /* 2149024 */   GIM_Try, /*On fail goto*//*Label 28384*/ GIMT_Encode4(2149115), // Rule ID 17836 //
     /* 2149029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2149040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2149043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2149049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149075 */     // MIs[0] round
     /* 2149075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149078 */     // MIs[0] policy
     /* 2149078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149088 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2149091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149114 */     // GIR_Coverage, 17836,
     /* 2149114 */     GIR_EraseRootFromParent_Done,
     /* 2149115 */   // Label 28384: @2149115
     /* 2149115 */   GIM_Try, /*On fail goto*//*Label 28385*/ GIMT_Encode4(2149206), // Rule ID 17837 //
     /* 2149120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2149131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2149134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2149140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149166 */     // MIs[0] round
     /* 2149166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149169 */     // MIs[0] policy
     /* 2149169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149179 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2149182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149205 */     // GIR_Coverage, 17837,
     /* 2149205 */     GIR_EraseRootFromParent_Done,
     /* 2149206 */   // Label 28385: @2149206
     /* 2149206 */   GIM_Try, /*On fail goto*//*Label 28386*/ GIMT_Encode4(2149297), // Rule ID 17840 //
     /* 2149211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2149222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2149231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149257 */     // MIs[0] round
     /* 2149257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149260 */     // MIs[0] policy
     /* 2149260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149270 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2149273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149296 */     // GIR_Coverage, 17840,
     /* 2149296 */     GIR_EraseRootFromParent_Done,
     /* 2149297 */   // Label 28386: @2149297
     /* 2149297 */   GIM_Try, /*On fail goto*//*Label 28387*/ GIMT_Encode4(2149388), // Rule ID 17841 //
     /* 2149302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2149313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2149322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149348 */     // MIs[0] round
     /* 2149348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149351 */     // MIs[0] policy
     /* 2149351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149361 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2149364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149387 */     // GIR_Coverage, 17841,
     /* 2149387 */     GIR_EraseRootFromParent_Done,
     /* 2149388 */   // Label 28387: @2149388
     /* 2149388 */   GIM_Try, /*On fail goto*//*Label 28388*/ GIMT_Encode4(2149479), // Rule ID 17844 //
     /* 2149393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149439 */     // MIs[0] round
     /* 2149439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149442 */     // MIs[0] policy
     /* 2149442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149452 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2149455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149478 */     // GIR_Coverage, 17844,
     /* 2149478 */     GIR_EraseRootFromParent_Done,
     /* 2149479 */   // Label 28388: @2149479
     /* 2149479 */   GIM_Try, /*On fail goto*//*Label 28389*/ GIMT_Encode4(2149570), // Rule ID 17845 //
     /* 2149484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149530 */     // MIs[0] round
     /* 2149530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149533 */     // MIs[0] policy
     /* 2149533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149543 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2149546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149569 */     // GIR_Coverage, 17845,
     /* 2149569 */     GIR_EraseRootFromParent_Done,
     /* 2149570 */   // Label 28389: @2149570
     /* 2149570 */   GIM_Try, /*On fail goto*//*Label 28390*/ GIMT_Encode4(2149661), // Rule ID 17848 //
     /* 2149575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2149586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2149589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2149595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149621 */     // MIs[0] round
     /* 2149621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149624 */     // MIs[0] policy
     /* 2149624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149634 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2149637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149660 */     // GIR_Coverage, 17848,
     /* 2149660 */     GIR_EraseRootFromParent_Done,
     /* 2149661 */   // Label 28390: @2149661
     /* 2149661 */   GIM_Try, /*On fail goto*//*Label 28391*/ GIMT_Encode4(2149752), // Rule ID 17849 //
     /* 2149666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2149677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2149680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2149686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149712 */     // MIs[0] round
     /* 2149712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149715 */     // MIs[0] policy
     /* 2149715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149725 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2149728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149751 */     // GIR_Coverage, 17849,
     /* 2149751 */     GIR_EraseRootFromParent_Done,
     /* 2149752 */   // Label 28391: @2149752
     /* 2149752 */   GIM_Try, /*On fail goto*//*Label 28392*/ GIMT_Encode4(2149843), // Rule ID 17852 //
     /* 2149757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2149768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2149771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2149777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149803 */     // MIs[0] round
     /* 2149803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149806 */     // MIs[0] policy
     /* 2149806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149816 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2149819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149842 */     // GIR_Coverage, 17852,
     /* 2149842 */     GIR_EraseRootFromParent_Done,
     /* 2149843 */   // Label 28392: @2149843
     /* 2149843 */   GIM_Try, /*On fail goto*//*Label 28393*/ GIMT_Encode4(2149934), // Rule ID 17853 //
     /* 2149848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2149859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2149862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2149868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149894 */     // MIs[0] round
     /* 2149894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149897 */     // MIs[0] policy
     /* 2149897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149907 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2149910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149933 */     // GIR_Coverage, 17853,
     /* 2149933 */     GIR_EraseRootFromParent_Done,
     /* 2149934 */   // Label 28393: @2149934
     /* 2149934 */   GIM_Try, /*On fail goto*//*Label 28394*/ GIMT_Encode4(2150025), // Rule ID 17856 //
     /* 2149939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2149947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2149950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2149959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149985 */     // MIs[0] round
     /* 2149985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149988 */     // MIs[0] policy
     /* 2149988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149998 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2150001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150024 */     // GIR_Coverage, 17856,
     /* 2150024 */     GIR_EraseRootFromParent_Done,
     /* 2150025 */   // Label 28394: @2150025
     /* 2150025 */   GIM_Try, /*On fail goto*//*Label 28395*/ GIMT_Encode4(2150116), // Rule ID 17857 //
     /* 2150030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2150041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2150044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2150047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2150050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2150053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2150068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150076 */     // MIs[0] round
     /* 2150076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150079 */     // MIs[0] policy
     /* 2150079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150089 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2150092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150115 */     // GIR_Coverage, 17857,
     /* 2150115 */     GIR_EraseRootFromParent_Done,
     /* 2150116 */   // Label 28395: @2150116
     /* 2150116 */   GIM_Try, /*On fail goto*//*Label 28396*/ GIMT_Encode4(2150207), // Rule ID 17860 //
     /* 2150121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2150132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2150135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2150141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150167 */     // MIs[0] round
     /* 2150167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150170 */     // MIs[0] policy
     /* 2150170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150180 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2150183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150206 */     // GIR_Coverage, 17860,
     /* 2150206 */     GIR_EraseRootFromParent_Done,
     /* 2150207 */   // Label 28396: @2150207
     /* 2150207 */   GIM_Try, /*On fail goto*//*Label 28397*/ GIMT_Encode4(2150298), // Rule ID 17861 //
     /* 2150212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2150223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2150226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2150232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2150242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2150254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150258 */     // MIs[0] round
     /* 2150258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150261 */     // MIs[0] policy
     /* 2150261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150271 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2150274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150297 */     // GIR_Coverage, 17861,
     /* 2150297 */     GIR_EraseRootFromParent_Done,
     /* 2150298 */   // Label 28397: @2150298
     /* 2150298 */   GIM_Try, /*On fail goto*//*Label 28398*/ GIMT_Encode4(2150389), // Rule ID 17864 //
     /* 2150303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150349 */     // MIs[0] round
     /* 2150349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150352 */     // MIs[0] policy
     /* 2150352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150362 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2150365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150388 */     // GIR_Coverage, 17864,
     /* 2150388 */     GIR_EraseRootFromParent_Done,
     /* 2150389 */   // Label 28398: @2150389
     /* 2150389 */   GIM_Try, /*On fail goto*//*Label 28399*/ GIMT_Encode4(2150480), // Rule ID 17865 //
     /* 2150394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150440 */     // MIs[0] round
     /* 2150440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150443 */     // MIs[0] policy
     /* 2150443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150453 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2150456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150479 */     // GIR_Coverage, 17865,
     /* 2150479 */     GIR_EraseRootFromParent_Done,
     /* 2150480 */   // Label 28399: @2150480
     /* 2150480 */   GIM_Try, /*On fail goto*//*Label 28400*/ GIMT_Encode4(2150571), // Rule ID 17868 //
     /* 2150485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2150496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2150499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2150505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150531 */     // MIs[0] round
     /* 2150531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150534 */     // MIs[0] policy
     /* 2150534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150544 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2150547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150570 */     // GIR_Coverage, 17868,
     /* 2150570 */     GIR_EraseRootFromParent_Done,
     /* 2150571 */   // Label 28400: @2150571
     /* 2150571 */   GIM_Try, /*On fail goto*//*Label 28401*/ GIMT_Encode4(2150662), // Rule ID 17869 //
     /* 2150576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2150584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2150587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2150590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2150596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150622 */     // MIs[0] round
     /* 2150622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150625 */     // MIs[0] policy
     /* 2150625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150635 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2150638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150661 */     // GIR_Coverage, 17869,
     /* 2150661 */     GIR_EraseRootFromParent_Done,
     /* 2150662 */   // Label 28401: @2150662
     /* 2150662 */   GIM_Try, /*On fail goto*//*Label 28402*/ GIMT_Encode4(2150753), // Rule ID 17872 //
     /* 2150667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2150675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2150678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2150681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2150684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2150687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150713 */     // MIs[0] round
     /* 2150713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150716 */     // MIs[0] policy
     /* 2150716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150726 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2150729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150752 */     // GIR_Coverage, 17872,
     /* 2150752 */     GIR_EraseRootFromParent_Done,
     /* 2150753 */   // Label 28402: @2150753
     /* 2150753 */   GIM_Try, /*On fail goto*//*Label 28403*/ GIMT_Encode4(2150844), // Rule ID 17873 //
     /* 2150758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2150766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2150769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2150772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2150775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2150778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150804 */     // MIs[0] round
     /* 2150804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150807 */     // MIs[0] policy
     /* 2150807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150817 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2150820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150843 */     // GIR_Coverage, 17873,
     /* 2150843 */     GIR_EraseRootFromParent_Done,
     /* 2150844 */   // Label 28403: @2150844
     /* 2150844 */   GIM_Try, /*On fail goto*//*Label 28404*/ GIMT_Encode4(2150935), // Rule ID 17876 //
     /* 2150849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2150857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2150860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2150863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2150866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2150869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150895 */     // MIs[0] round
     /* 2150895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150898 */     // MIs[0] policy
     /* 2150898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150908 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2150911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150934 */     // GIR_Coverage, 17876,
     /* 2150934 */     GIR_EraseRootFromParent_Done,
     /* 2150935 */   // Label 28404: @2150935
     /* 2150935 */   GIM_Try, /*On fail goto*//*Label 28405*/ GIMT_Encode4(2151026), // Rule ID 17877 //
     /* 2150940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2150948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2150951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2150954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2150957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2150960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150986 */     // MIs[0] round
     /* 2150986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150989 */     // MIs[0] policy
     /* 2150989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150999 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2151002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151025 */     // GIR_Coverage, 17877,
     /* 2151025 */     GIR_EraseRootFromParent_Done,
     /* 2151026 */   // Label 28405: @2151026
     /* 2151026 */   GIM_Try, /*On fail goto*//*Label 28406*/ GIMT_Encode4(2151117), // Rule ID 17880 //
     /* 2151031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2151042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2151045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2151048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2151051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151077 */     // MIs[0] round
     /* 2151077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151080 */     // MIs[0] policy
     /* 2151080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151090 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2151093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151116 */     // GIR_Coverage, 17880,
     /* 2151116 */     GIR_EraseRootFromParent_Done,
     /* 2151117 */   // Label 28406: @2151117
     /* 2151117 */   GIM_Try, /*On fail goto*//*Label 28407*/ GIMT_Encode4(2151208), // Rule ID 17881 //
     /* 2151122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2151133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2151136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2151139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2151142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151168 */     // MIs[0] round
     /* 2151168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151171 */     // MIs[0] policy
     /* 2151171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151181 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2151184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151207 */     // GIR_Coverage, 17881,
     /* 2151207 */     GIR_EraseRootFromParent_Done,
     /* 2151208 */   // Label 28407: @2151208
     /* 2151208 */   GIM_Try, /*On fail goto*//*Label 28408*/ GIMT_Encode4(2151299), // Rule ID 17884 //
     /* 2151213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2151224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2151227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2151230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2151233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151259 */     // MIs[0] round
     /* 2151259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151262 */     // MIs[0] policy
     /* 2151262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151272 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2151275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151298 */     // GIR_Coverage, 17884,
     /* 2151298 */     GIR_EraseRootFromParent_Done,
     /* 2151299 */   // Label 28408: @2151299
     /* 2151299 */   GIM_Try, /*On fail goto*//*Label 28409*/ GIMT_Encode4(2151390), // Rule ID 17885 //
     /* 2151304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2151315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2151318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2151321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2151324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151350 */     // MIs[0] round
     /* 2151350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151353 */     // MIs[0] policy
     /* 2151353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151363 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2151366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151389 */     // GIR_Coverage, 17885,
     /* 2151389 */     GIR_EraseRootFromParent_Done,
     /* 2151390 */   // Label 28409: @2151390
     /* 2151390 */   GIM_Try, /*On fail goto*//*Label 28410*/ GIMT_Encode4(2151481), // Rule ID 17888 //
     /* 2151395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151441 */     // MIs[0] round
     /* 2151441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151444 */     // MIs[0] policy
     /* 2151444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2151457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151480 */     // GIR_Coverage, 17888,
     /* 2151480 */     GIR_EraseRootFromParent_Done,
     /* 2151481 */   // Label 28410: @2151481
     /* 2151481 */   GIM_Try, /*On fail goto*//*Label 28411*/ GIMT_Encode4(2151572), // Rule ID 17889 //
     /* 2151486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151532 */     // MIs[0] round
     /* 2151532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151535 */     // MIs[0] policy
     /* 2151535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151545 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2151548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151571 */     // GIR_Coverage, 17889,
     /* 2151571 */     GIR_EraseRootFromParent_Done,
     /* 2151572 */   // Label 28411: @2151572
     /* 2151572 */   GIM_Try, /*On fail goto*//*Label 28412*/ GIMT_Encode4(2151663), // Rule ID 17892 //
     /* 2151577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2151580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2151588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2151591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2151594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2151597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151623 */     // MIs[0] round
     /* 2151623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151626 */     // MIs[0] policy
     /* 2151626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151636 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2151639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151662 */     // GIR_Coverage, 17892,
     /* 2151662 */     GIR_EraseRootFromParent_Done,
     /* 2151663 */   // Label 28412: @2151663
     /* 2151663 */   GIM_Try, /*On fail goto*//*Label 28413*/ GIMT_Encode4(2151754), // Rule ID 17893 //
     /* 2151668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2151679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2151682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2151685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2151688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151714 */     // MIs[0] round
     /* 2151714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151717 */     // MIs[0] policy
     /* 2151717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2151730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151753 */     // GIR_Coverage, 17893,
     /* 2151753 */     GIR_EraseRootFromParent_Done,
     /* 2151754 */   // Label 28413: @2151754
     /* 2151754 */   GIM_Try, /*On fail goto*//*Label 28414*/ GIMT_Encode4(2151845), // Rule ID 17896 //
     /* 2151759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2151770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2151773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2151776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2151779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151805 */     // MIs[0] round
     /* 2151805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151808 */     // MIs[0] policy
     /* 2151808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151818 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2151821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151844 */     // GIR_Coverage, 17896,
     /* 2151844 */     GIR_EraseRootFromParent_Done,
     /* 2151845 */   // Label 28414: @2151845
     /* 2151845 */   GIM_Try, /*On fail goto*//*Label 28415*/ GIMT_Encode4(2151936), // Rule ID 17897 //
     /* 2151850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2151861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2151864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2151867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2151870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151896 */     // MIs[0] round
     /* 2151896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151899 */     // MIs[0] policy
     /* 2151899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151909 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2151912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151935 */     // GIR_Coverage, 17897,
     /* 2151935 */     GIR_EraseRootFromParent_Done,
     /* 2151936 */   // Label 28415: @2151936
     /* 2151936 */   GIM_Try, /*On fail goto*//*Label 28416*/ GIMT_Encode4(2152027), // Rule ID 17900 //
     /* 2151941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2151949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2151952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2151955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2151958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2151961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2151964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151987 */     // MIs[0] round
     /* 2151987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151990 */     // MIs[0] policy
     /* 2151990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152000 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2152003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152026 */     // GIR_Coverage, 17900,
     /* 2152026 */     GIR_EraseRootFromParent_Done,
     /* 2152027 */   // Label 28416: @2152027
     /* 2152027 */   GIM_Try, /*On fail goto*//*Label 28417*/ GIMT_Encode4(2152118), // Rule ID 17901 //
     /* 2152032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2152043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2152046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2152049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2152052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152078 */     // MIs[0] round
     /* 2152078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152081 */     // MIs[0] policy
     /* 2152081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152091 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2152094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152117 */     // GIR_Coverage, 17901,
     /* 2152117 */     GIR_EraseRootFromParent_Done,
     /* 2152118 */   // Label 28417: @2152118
     /* 2152118 */   GIM_Try, /*On fail goto*//*Label 28418*/ GIMT_Encode4(2152209), // Rule ID 17904 //
     /* 2152123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2152126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2152134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2152137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2152140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2152143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2152146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152169 */     // MIs[0] round
     /* 2152169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152172 */     // MIs[0] policy
     /* 2152172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152182 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2152185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152208 */     // GIR_Coverage, 17904,
     /* 2152208 */     GIR_EraseRootFromParent_Done,
     /* 2152209 */   // Label 28418: @2152209
     /* 2152209 */   GIM_Try, /*On fail goto*//*Label 28419*/ GIMT_Encode4(2152300), // Rule ID 17905 //
     /* 2152214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2152217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2152225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2152228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2152231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2152234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2152237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152260 */     // MIs[0] round
     /* 2152260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152263 */     // MIs[0] policy
     /* 2152263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152273 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2152276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2152296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152299 */     // GIR_Coverage, 17905,
     /* 2152299 */     GIR_EraseRootFromParent_Done,
     /* 2152300 */   // Label 28419: @2152300
     /* 2152300 */   GIM_Try, /*On fail goto*//*Label 28420*/ GIMT_Encode4(2152391), // Rule ID 17908 //
     /* 2152305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152351 */     // MIs[0] round
     /* 2152351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152354 */     // MIs[0] policy
     /* 2152354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152364 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2152367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152390 */     // GIR_Coverage, 17908,
     /* 2152390 */     GIR_EraseRootFromParent_Done,
     /* 2152391 */   // Label 28420: @2152391
     /* 2152391 */   GIM_Try, /*On fail goto*//*Label 28421*/ GIMT_Encode4(2152482), // Rule ID 17909 //
     /* 2152396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152442 */     // MIs[0] round
     /* 2152442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152445 */     // MIs[0] policy
     /* 2152445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152455 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2152458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152481 */     // GIR_Coverage, 17909,
     /* 2152481 */     GIR_EraseRootFromParent_Done,
     /* 2152482 */   // Label 28421: @2152482
     /* 2152482 */   GIM_Try, /*On fail goto*//*Label 28422*/ GIMT_Encode4(2152573), // Rule ID 17912 //
     /* 2152487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2152498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2152501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2152504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2152507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152533 */     // MIs[0] round
     /* 2152533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152536 */     // MIs[0] policy
     /* 2152536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152546 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2152549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152572 */     // GIR_Coverage, 17912,
     /* 2152572 */     GIR_EraseRootFromParent_Done,
     /* 2152573 */   // Label 28422: @2152573
     /* 2152573 */   GIM_Try, /*On fail goto*//*Label 28423*/ GIMT_Encode4(2152664), // Rule ID 17913 //
     /* 2152578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2152589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2152592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2152595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2152598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152624 */     // MIs[0] round
     /* 2152624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152627 */     // MIs[0] policy
     /* 2152627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152637 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2152640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152663 */     // GIR_Coverage, 17913,
     /* 2152663 */     GIR_EraseRootFromParent_Done,
     /* 2152664 */   // Label 28423: @2152664
     /* 2152664 */   GIM_Try, /*On fail goto*//*Label 28424*/ GIMT_Encode4(2152755), // Rule ID 17916 //
     /* 2152669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2152680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2152683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2152686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2152689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152715 */     // MIs[0] round
     /* 2152715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152718 */     // MIs[0] policy
     /* 2152718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152728 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2152731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152754 */     // GIR_Coverage, 17916,
     /* 2152754 */     GIR_EraseRootFromParent_Done,
     /* 2152755 */   // Label 28424: @2152755
     /* 2152755 */   GIM_Try, /*On fail goto*//*Label 28425*/ GIMT_Encode4(2152846), // Rule ID 17917 //
     /* 2152760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2152771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2152774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2152777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2152780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152806 */     // MIs[0] round
     /* 2152806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152809 */     // MIs[0] policy
     /* 2152809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152819 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2152822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152845 */     // GIR_Coverage, 17917,
     /* 2152845 */     GIR_EraseRootFromParent_Done,
     /* 2152846 */   // Label 28425: @2152846
     /* 2152846 */   GIM_Try, /*On fail goto*//*Label 28426*/ GIMT_Encode4(2152937), // Rule ID 17920 //
     /* 2152851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2152854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2152862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2152865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2152868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2152871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152897 */     // MIs[0] round
     /* 2152897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152900 */     // MIs[0] policy
     /* 2152900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152910 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2152913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152936 */     // GIR_Coverage, 17920,
     /* 2152936 */     GIR_EraseRootFromParent_Done,
     /* 2152937 */   // Label 28426: @2152937
     /* 2152937 */   GIM_Try, /*On fail goto*//*Label 28427*/ GIMT_Encode4(2153028), // Rule ID 17921 //
     /* 2152942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2152945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2152950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2152953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2152956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2152959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2152962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152988 */     // MIs[0] round
     /* 2152988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152991 */     // MIs[0] policy
     /* 2152991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153001 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2153004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153027 */     // GIR_Coverage, 17921,
     /* 2153027 */     GIR_EraseRootFromParent_Done,
     /* 2153028 */   // Label 28427: @2153028
     /* 2153028 */   GIM_Try, /*On fail goto*//*Label 28428*/ GIMT_Encode4(2153119), // Rule ID 17924 //
     /* 2153033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2153044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2153047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2153050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2153053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153079 */     // MIs[0] round
     /* 2153079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153082 */     // MIs[0] policy
     /* 2153082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153092 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2153095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153118 */     // GIR_Coverage, 17924,
     /* 2153118 */     GIR_EraseRootFromParent_Done,
     /* 2153119 */   // Label 28428: @2153119
     /* 2153119 */   GIM_Try, /*On fail goto*//*Label 28429*/ GIMT_Encode4(2153210), // Rule ID 17925 //
     /* 2153124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2153135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2153138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2153141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2153144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2153154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2153166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153170 */     // MIs[0] round
     /* 2153170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153173 */     // MIs[0] policy
     /* 2153173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153183 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2153186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153209 */     // GIR_Coverage, 17925,
     /* 2153209 */     GIR_EraseRootFromParent_Done,
     /* 2153210 */   // Label 28429: @2153210
     /* 2153210 */   GIM_Try, /*On fail goto*//*Label 28430*/ GIMT_Encode4(2153301), // Rule ID 17928 //
     /* 2153215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2153218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2153226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2153229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2153232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2153235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153261 */     // MIs[0] round
     /* 2153261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153264 */     // MIs[0] policy
     /* 2153264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153274 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2153277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153300 */     // GIR_Coverage, 17928,
     /* 2153300 */     GIR_EraseRootFromParent_Done,
     /* 2153301 */   // Label 28430: @2153301
     /* 2153301 */   GIM_Try, /*On fail goto*//*Label 28431*/ GIMT_Encode4(2153392), // Rule ID 17929 //
     /* 2153306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2153309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2153317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2153320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2153323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2153326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153352 */     // MIs[0] round
     /* 2153352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153355 */     // MIs[0] policy
     /* 2153355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153365 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2153368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153391 */     // GIR_Coverage, 17929,
     /* 2153391 */     GIR_EraseRootFromParent_Done,
     /* 2153392 */   // Label 28431: @2153392
     /* 2153392 */   GIM_Try, /*On fail goto*//*Label 28432*/ GIMT_Encode4(2153483), // Rule ID 17932 //
     /* 2153397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153443 */     // MIs[0] round
     /* 2153443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153446 */     // MIs[0] policy
     /* 2153446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153456 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2153459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153482 */     // GIR_Coverage, 17932,
     /* 2153482 */     GIR_EraseRootFromParent_Done,
     /* 2153483 */   // Label 28432: @2153483
     /* 2153483 */   GIM_Try, /*On fail goto*//*Label 28433*/ GIMT_Encode4(2153574), // Rule ID 17933 //
     /* 2153488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153534 */     // MIs[0] round
     /* 2153534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153537 */     // MIs[0] policy
     /* 2153537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153547 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2153550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153573 */     // GIR_Coverage, 17933,
     /* 2153573 */     GIR_EraseRootFromParent_Done,
     /* 2153574 */   // Label 28433: @2153574
     /* 2153574 */   GIM_Try, /*On fail goto*//*Label 28434*/ GIMT_Encode4(2153665), // Rule ID 17936 //
     /* 2153579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2153590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2153593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2153599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153625 */     // MIs[0] round
     /* 2153625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153628 */     // MIs[0] policy
     /* 2153628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153638 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2153641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153664 */     // GIR_Coverage, 17936,
     /* 2153664 */     GIR_EraseRootFromParent_Done,
     /* 2153665 */   // Label 28434: @2153665
     /* 2153665 */   GIM_Try, /*On fail goto*//*Label 28435*/ GIMT_Encode4(2153756), // Rule ID 17937 //
     /* 2153670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2153681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2153684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2153690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153716 */     // MIs[0] round
     /* 2153716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153719 */     // MIs[0] policy
     /* 2153719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153729 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2153732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153755 */     // GIR_Coverage, 17937,
     /* 2153755 */     GIR_EraseRootFromParent_Done,
     /* 2153756 */   // Label 28435: @2153756
     /* 2153756 */   GIM_Try, /*On fail goto*//*Label 28436*/ GIMT_Encode4(2153847), // Rule ID 17940 //
     /* 2153761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2153772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2153775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2153781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153807 */     // MIs[0] round
     /* 2153807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153810 */     // MIs[0] policy
     /* 2153810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153820 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2153823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153846 */     // GIR_Coverage, 17940,
     /* 2153846 */     GIR_EraseRootFromParent_Done,
     /* 2153847 */   // Label 28436: @2153847
     /* 2153847 */   GIM_Try, /*On fail goto*//*Label 28437*/ GIMT_Encode4(2153938), // Rule ID 17941 //
     /* 2153852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2153863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2153866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2153872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153898 */     // MIs[0] round
     /* 2153898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153901 */     // MIs[0] policy
     /* 2153901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153911 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2153914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153937 */     // GIR_Coverage, 17941,
     /* 2153937 */     GIR_EraseRootFromParent_Done,
     /* 2153938 */   // Label 28437: @2153938
     /* 2153938 */   GIM_Try, /*On fail goto*//*Label 28438*/ GIMT_Encode4(2154029), // Rule ID 17944 //
     /* 2153943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2153951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2153954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2153957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2153963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153989 */     // MIs[0] round
     /* 2153989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153992 */     // MIs[0] policy
     /* 2153992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154002 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2154005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154028 */     // GIR_Coverage, 17944,
     /* 2154028 */     GIR_EraseRootFromParent_Done,
     /* 2154029 */   // Label 28438: @2154029
     /* 2154029 */   GIM_Try, /*On fail goto*//*Label 28439*/ GIMT_Encode4(2154120), // Rule ID 17945 //
     /* 2154034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2154045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2154048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2154054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154080 */     // MIs[0] round
     /* 2154080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154083 */     // MIs[0] policy
     /* 2154083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154093 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11242:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2154096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154119 */     // GIR_Coverage, 17945,
     /* 2154119 */     GIR_EraseRootFromParent_Done,
     /* 2154120 */   // Label 28439: @2154120
     /* 2154120 */   GIM_Try, /*On fail goto*//*Label 28440*/ GIMT_Encode4(2154211), // Rule ID 17948 //
     /* 2154125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2154136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2154139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2154145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154171 */     // MIs[0] round
     /* 2154171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154174 */     // MIs[0] policy
     /* 2154174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2154187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154210 */     // GIR_Coverage, 17948,
     /* 2154210 */     GIR_EraseRootFromParent_Done,
     /* 2154211 */   // Label 28440: @2154211
     /* 2154211 */   GIM_Try, /*On fail goto*//*Label 28441*/ GIMT_Encode4(2154302), // Rule ID 17949 //
     /* 2154216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2154227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2154230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2154236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2154239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154262 */     // MIs[0] round
     /* 2154262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154265 */     // MIs[0] policy
     /* 2154265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154275 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2154278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154301 */     // GIR_Coverage, 17949,
     /* 2154301 */     GIR_EraseRootFromParent_Done,
     /* 2154302 */   // Label 28441: @2154302
     /* 2154302 */   GIM_Try, /*On fail goto*//*Label 28442*/ GIMT_Encode4(2154393), // Rule ID 17952 //
     /* 2154307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154353 */     // MIs[0] round
     /* 2154353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154356 */     // MIs[0] policy
     /* 2154356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154366 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2154369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154392 */     // GIR_Coverage, 17952,
     /* 2154392 */     GIR_EraseRootFromParent_Done,
     /* 2154393 */   // Label 28442: @2154393
     /* 2154393 */   GIM_Try, /*On fail goto*//*Label 28443*/ GIMT_Encode4(2154484), // Rule ID 17953 //
     /* 2154398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154444 */     // MIs[0] round
     /* 2154444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154447 */     // MIs[0] policy
     /* 2154447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154457 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2154460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154483 */     // GIR_Coverage, 17953,
     /* 2154483 */     GIR_EraseRootFromParent_Done,
     /* 2154484 */   // Label 28443: @2154484
     /* 2154484 */   GIM_Try, /*On fail goto*//*Label 28444*/ GIMT_Encode4(2154575), // Rule ID 17956 //
     /* 2154489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2154500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2154503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2154509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154535 */     // MIs[0] round
     /* 2154535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154538 */     // MIs[0] policy
     /* 2154538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154548 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2154551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154574 */     // GIR_Coverage, 17956,
     /* 2154574 */     GIR_EraseRootFromParent_Done,
     /* 2154575 */   // Label 28444: @2154575
     /* 2154575 */   GIM_Try, /*On fail goto*//*Label 28445*/ GIMT_Encode4(2154666), // Rule ID 17957 //
     /* 2154580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2154591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2154594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2154600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154626 */     // MIs[0] round
     /* 2154626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154629 */     // MIs[0] policy
     /* 2154629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154639 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2154642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154665 */     // GIR_Coverage, 17957,
     /* 2154665 */     GIR_EraseRootFromParent_Done,
     /* 2154666 */   // Label 28445: @2154666
     /* 2154666 */   GIM_Try, /*On fail goto*//*Label 28446*/ GIMT_Encode4(2154757), // Rule ID 17960 //
     /* 2154671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2154682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2154685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2154691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2154694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154717 */     // MIs[0] round
     /* 2154717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154720 */     // MIs[0] policy
     /* 2154720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154730 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2154733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154756 */     // GIR_Coverage, 17960,
     /* 2154756 */     GIR_EraseRootFromParent_Done,
     /* 2154757 */   // Label 28446: @2154757
     /* 2154757 */   GIM_Try, /*On fail goto*//*Label 28447*/ GIMT_Encode4(2154848), // Rule ID 17961 //
     /* 2154762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2154773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2154776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2154782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2154785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154808 */     // MIs[0] round
     /* 2154808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154811 */     // MIs[0] policy
     /* 2154811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154821 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2154824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154847 */     // GIR_Coverage, 17961,
     /* 2154847 */     GIR_EraseRootFromParent_Done,
     /* 2154848 */   // Label 28447: @2154848
     /* 2154848 */   GIM_Try, /*On fail goto*//*Label 28448*/ GIMT_Encode4(2154939), // Rule ID 17964 //
     /* 2154853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2154864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2154867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2154873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2154876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154899 */     // MIs[0] round
     /* 2154899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154902 */     // MIs[0] policy
     /* 2154902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154912 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2154915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154938 */     // GIR_Coverage, 17964,
     /* 2154938 */     GIR_EraseRootFromParent_Done,
     /* 2154939 */   // Label 28448: @2154939
     /* 2154939 */   GIM_Try, /*On fail goto*//*Label 28449*/ GIMT_Encode4(2155030), // Rule ID 17965 //
     /* 2154944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2154952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2154955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2154958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2154964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2154967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154990 */     // MIs[0] round
     /* 2154990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154993 */     // MIs[0] policy
     /* 2154993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155003 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2155006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155029 */     // GIR_Coverage, 17965,
     /* 2155029 */     GIR_EraseRootFromParent_Done,
     /* 2155030 */   // Label 28449: @2155030
     /* 2155030 */   GIM_Try, /*On fail goto*//*Label 28450*/ GIMT_Encode4(2155121), // Rule ID 17968 //
     /* 2155035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2155046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2155049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2155055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155081 */     // MIs[0] round
     /* 2155081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155084 */     // MIs[0] policy
     /* 2155084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2155097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155120 */     // GIR_Coverage, 17968,
     /* 2155120 */     GIR_EraseRootFromParent_Done,
     /* 2155121 */   // Label 28450: @2155121
     /* 2155121 */   GIM_Try, /*On fail goto*//*Label 28451*/ GIMT_Encode4(2155212), // Rule ID 17969 //
     /* 2155126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2155137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2155140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2155146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155172 */     // MIs[0] round
     /* 2155172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155175 */     // MIs[0] policy
     /* 2155175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155185 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2155188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155211 */     // GIR_Coverage, 17969,
     /* 2155211 */     GIR_EraseRootFromParent_Done,
     /* 2155212 */   // Label 28451: @2155212
     /* 2155212 */   GIM_Try, /*On fail goto*//*Label 28452*/ GIMT_Encode4(2155303), // Rule ID 17972 //
     /* 2155217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2155228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2155231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2155237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155263 */     // MIs[0] round
     /* 2155263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155266 */     // MIs[0] policy
     /* 2155266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155276 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2155279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155302 */     // GIR_Coverage, 17972,
     /* 2155302 */     GIR_EraseRootFromParent_Done,
     /* 2155303 */   // Label 28452: @2155303
     /* 2155303 */   GIM_Try, /*On fail goto*//*Label 28453*/ GIMT_Encode4(2155394), // Rule ID 17973 //
     /* 2155308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2155319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2155322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2155328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155354 */     // MIs[0] round
     /* 2155354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155357 */     // MIs[0] policy
     /* 2155357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155367 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2155370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155393 */     // GIR_Coverage, 17973,
     /* 2155393 */     GIR_EraseRootFromParent_Done,
     /* 2155394 */   // Label 28453: @2155394
     /* 2155394 */   GIM_Try, /*On fail goto*//*Label 28454*/ GIMT_Encode4(2155485), // Rule ID 17976 //
     /* 2155399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155445 */     // MIs[0] round
     /* 2155445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155448 */     // MIs[0] policy
     /* 2155448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155458 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2155461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155484 */     // GIR_Coverage, 17976,
     /* 2155484 */     GIR_EraseRootFromParent_Done,
     /* 2155485 */   // Label 28454: @2155485
     /* 2155485 */   GIM_Try, /*On fail goto*//*Label 28455*/ GIMT_Encode4(2155576), // Rule ID 17977 //
     /* 2155490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155536 */     // MIs[0] round
     /* 2155536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155539 */     // MIs[0] policy
     /* 2155539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155549 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2155552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155575 */     // GIR_Coverage, 17977,
     /* 2155575 */     GIR_EraseRootFromParent_Done,
     /* 2155576 */   // Label 28455: @2155576
     /* 2155576 */   GIM_Try, /*On fail goto*//*Label 28456*/ GIMT_Encode4(2155667), // Rule ID 17980 //
     /* 2155581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2155592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2155595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2155601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155627 */     // MIs[0] round
     /* 2155627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155630 */     // MIs[0] policy
     /* 2155630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155640 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2155643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155666 */     // GIR_Coverage, 17980,
     /* 2155666 */     GIR_EraseRootFromParent_Done,
     /* 2155667 */   // Label 28456: @2155667
     /* 2155667 */   GIM_Try, /*On fail goto*//*Label 28457*/ GIMT_Encode4(2155758), // Rule ID 17981 //
     /* 2155672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2155683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2155686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2155692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155718 */     // MIs[0] round
     /* 2155718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155721 */     // MIs[0] policy
     /* 2155721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155731 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11242:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2155734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155757 */     // GIR_Coverage, 17981,
     /* 2155757 */     GIR_EraseRootFromParent_Done,
     /* 2155758 */   // Label 28457: @2155758
     /* 2155758 */   GIM_Try, /*On fail goto*//*Label 28458*/ GIMT_Encode4(2155849), // Rule ID 17984 //
     /* 2155763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2155774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2155777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2155783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155809 */     // MIs[0] round
     /* 2155809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155812 */     // MIs[0] policy
     /* 2155812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155822 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2155825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155848 */     // GIR_Coverage, 17984,
     /* 2155848 */     GIR_EraseRootFromParent_Done,
     /* 2155849 */   // Label 28458: @2155849
     /* 2155849 */   GIM_Try, /*On fail goto*//*Label 28459*/ GIMT_Encode4(2155940), // Rule ID 17985 //
     /* 2155854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2155865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2155868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2155874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155900 */     // MIs[0] round
     /* 2155900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155903 */     // MIs[0] policy
     /* 2155903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155913 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11242:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2155916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155939 */     // GIR_Coverage, 17985,
     /* 2155939 */     GIR_EraseRootFromParent_Done,
     /* 2155940 */   // Label 28459: @2155940
     /* 2155940 */   GIM_Try, /*On fail goto*//*Label 28460*/ GIMT_Encode4(2156031), // Rule ID 17988 //
     /* 2155945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2155953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2155956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2155959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2155965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155991 */     // MIs[0] round
     /* 2155991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155994 */     // MIs[0] policy
     /* 2155994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156004 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2156007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156030 */     // GIR_Coverage, 17988,
     /* 2156030 */     GIR_EraseRootFromParent_Done,
     /* 2156031 */   // Label 28460: @2156031
     /* 2156031 */   GIM_Try, /*On fail goto*//*Label 28461*/ GIMT_Encode4(2156122), // Rule ID 17989 //
     /* 2156036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2156044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2156047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2156050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2156053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2156056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2156066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2156074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2156078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156082 */     // MIs[0] round
     /* 2156082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156085 */     // MIs[0] policy
     /* 2156085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156095 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11242:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2156098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156121 */     // GIR_Coverage, 17989,
     /* 2156121 */     GIR_EraseRootFromParent_Done,
     /* 2156122 */   // Label 28461: @2156122
     /* 2156122 */   GIM_Try, /*On fail goto*//*Label 28462*/ GIMT_Encode4(2156213), // Rule ID 17992 //
     /* 2156127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2156138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2156141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2156144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2156147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156173 */     // MIs[0] round
     /* 2156173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156176 */     // MIs[0] policy
     /* 2156176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156186 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2156189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156212 */     // GIR_Coverage, 17992,
     /* 2156212 */     GIR_EraseRootFromParent_Done,
     /* 2156213 */   // Label 28462: @2156213
     /* 2156213 */   GIM_Try, /*On fail goto*//*Label 28463*/ GIMT_Encode4(2156304), // Rule ID 17993 //
     /* 2156218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2156229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2156232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2156235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2156238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156264 */     // MIs[0] round
     /* 2156264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156267 */     // MIs[0] policy
     /* 2156267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156277 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2156280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156303 */     // GIR_Coverage, 17993,
     /* 2156303 */     GIR_EraseRootFromParent_Done,
     /* 2156304 */   // Label 28463: @2156304
     /* 2156304 */   GIM_Try, /*On fail goto*//*Label 28464*/ GIMT_Encode4(2156395), // Rule ID 17996 //
     /* 2156309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156355 */     // MIs[0] round
     /* 2156355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156358 */     // MIs[0] policy
     /* 2156358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156368 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2156371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156394 */     // GIR_Coverage, 17996,
     /* 2156394 */     GIR_EraseRootFromParent_Done,
     /* 2156395 */   // Label 28464: @2156395
     /* 2156395 */   GIM_Try, /*On fail goto*//*Label 28465*/ GIMT_Encode4(2156486), // Rule ID 17997 //
     /* 2156400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156446 */     // MIs[0] round
     /* 2156446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156449 */     // MIs[0] policy
     /* 2156449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156459 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2156462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156485 */     // GIR_Coverage, 17997,
     /* 2156485 */     GIR_EraseRootFromParent_Done,
     /* 2156486 */   // Label 28465: @2156486
     /* 2156486 */   GIM_Try, /*On fail goto*//*Label 28466*/ GIMT_Encode4(2156577), // Rule ID 18000 //
     /* 2156491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2156502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2156505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2156508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2156511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156537 */     // MIs[0] round
     /* 2156537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156540 */     // MIs[0] policy
     /* 2156540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156550 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2156553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156576 */     // GIR_Coverage, 18000,
     /* 2156576 */     GIR_EraseRootFromParent_Done,
     /* 2156577 */   // Label 28466: @2156577
     /* 2156577 */   GIM_Try, /*On fail goto*//*Label 28467*/ GIMT_Encode4(2156668), // Rule ID 18001 //
     /* 2156582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2156593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2156596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2156599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2156602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156628 */     // MIs[0] round
     /* 2156628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156631 */     // MIs[0] policy
     /* 2156631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156641 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2156644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156667 */     // GIR_Coverage, 18001,
     /* 2156667 */     GIR_EraseRootFromParent_Done,
     /* 2156668 */   // Label 28467: @2156668
     /* 2156668 */   GIM_Try, /*On fail goto*//*Label 28468*/ GIMT_Encode4(2156759), // Rule ID 18004 //
     /* 2156673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2156684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2156687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2156690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2156693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156719 */     // MIs[0] round
     /* 2156719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156722 */     // MIs[0] policy
     /* 2156722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156732 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2156735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156758 */     // GIR_Coverage, 18004,
     /* 2156758 */     GIR_EraseRootFromParent_Done,
     /* 2156759 */   // Label 28468: @2156759
     /* 2156759 */   GIM_Try, /*On fail goto*//*Label 28469*/ GIMT_Encode4(2156850), // Rule ID 18005 //
     /* 2156764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2156775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2156778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2156781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2156784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156810 */     // MIs[0] round
     /* 2156810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156813 */     // MIs[0] policy
     /* 2156813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156823 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2156826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156849 */     // GIR_Coverage, 18005,
     /* 2156849 */     GIR_EraseRootFromParent_Done,
     /* 2156850 */   // Label 28469: @2156850
     /* 2156850 */   GIM_Try, /*On fail goto*//*Label 28470*/ GIMT_Encode4(2156941), // Rule ID 18008 //
     /* 2156855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2156866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2156875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156901 */     // MIs[0] round
     /* 2156901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156904 */     // MIs[0] policy
     /* 2156904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156914 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2156917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156940 */     // GIR_Coverage, 18008,
     /* 2156940 */     GIR_EraseRootFromParent_Done,
     /* 2156941 */   // Label 28470: @2156941
     /* 2156941 */   GIM_Try, /*On fail goto*//*Label 28471*/ GIMT_Encode4(2157032), // Rule ID 18009 //
     /* 2156946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2156954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2156957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2156966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156992 */     // MIs[0] round
     /* 2156992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156995 */     // MIs[0] policy
     /* 2156995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157005 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2157008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157031 */     // GIR_Coverage, 18009,
     /* 2157031 */     GIR_EraseRootFromParent_Done,
     /* 2157032 */   // Label 28471: @2157032
     /* 2157032 */   GIM_Try, /*On fail goto*//*Label 28472*/ GIMT_Encode4(2157123), // Rule ID 18012 //
     /* 2157037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2157040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2157048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2157051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2157054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2157057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157083 */     // MIs[0] round
     /* 2157083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157086 */     // MIs[0] policy
     /* 2157086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157096 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2157099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157122 */     // GIR_Coverage, 18012,
     /* 2157122 */     GIR_EraseRootFromParent_Done,
     /* 2157123 */   // Label 28472: @2157123
     /* 2157123 */   GIM_Try, /*On fail goto*//*Label 28473*/ GIMT_Encode4(2157214), // Rule ID 18013 //
     /* 2157128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2157131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2157139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2157142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2157145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2157148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2157151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2157158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2157170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157174 */     // MIs[0] round
     /* 2157174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157177 */     // MIs[0] policy
     /* 2157177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157187 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2157190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2157210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157213 */     // GIR_Coverage, 18013,
     /* 2157213 */     GIR_EraseRootFromParent_Done,
     /* 2157214 */   // Label 28473: @2157214
     /* 2157214 */   GIM_Try, /*On fail goto*//*Label 28474*/ GIMT_Encode4(2157305), // Rule ID 18016 //
     /* 2157219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2157230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2157239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157265 */     // MIs[0] round
     /* 2157265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157268 */     // MIs[0] policy
     /* 2157268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157278 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2157281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157304 */     // GIR_Coverage, 18016,
     /* 2157304 */     GIR_EraseRootFromParent_Done,
     /* 2157305 */   // Label 28474: @2157305
     /* 2157305 */   GIM_Try, /*On fail goto*//*Label 28475*/ GIMT_Encode4(2157396), // Rule ID 18017 //
     /* 2157310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2157321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2157330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157356 */     // MIs[0] round
     /* 2157356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157359 */     // MIs[0] policy
     /* 2157359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157369 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2157372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157395 */     // GIR_Coverage, 18017,
     /* 2157395 */     GIR_EraseRootFromParent_Done,
     /* 2157396 */   // Label 28475: @2157396
     /* 2157396 */   GIM_Try, /*On fail goto*//*Label 28476*/ GIMT_Encode4(2157487), // Rule ID 18020 //
     /* 2157401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157447 */     // MIs[0] round
     /* 2157447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157450 */     // MIs[0] policy
     /* 2157450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157460 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2157463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157486 */     // GIR_Coverage, 18020,
     /* 2157486 */     GIR_EraseRootFromParent_Done,
     /* 2157487 */   // Label 28476: @2157487
     /* 2157487 */   GIM_Try, /*On fail goto*//*Label 28477*/ GIMT_Encode4(2157578), // Rule ID 18021 //
     /* 2157492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157538 */     // MIs[0] round
     /* 2157538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157541 */     // MIs[0] policy
     /* 2157541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157551 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2157554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157577 */     // GIR_Coverage, 18021,
     /* 2157577 */     GIR_EraseRootFromParent_Done,
     /* 2157578 */   // Label 28477: @2157578
     /* 2157578 */   GIM_Try, /*On fail goto*//*Label 28478*/ GIMT_Encode4(2157669), // Rule ID 18024 //
     /* 2157583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2157594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2157597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2157600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2157603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2157606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157629 */     // MIs[0] round
     /* 2157629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157632 */     // MIs[0] policy
     /* 2157632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157642 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2157645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157668 */     // GIR_Coverage, 18024,
     /* 2157668 */     GIR_EraseRootFromParent_Done,
     /* 2157669 */   // Label 28478: @2157669
     /* 2157669 */   GIM_Try, /*On fail goto*//*Label 28479*/ GIMT_Encode4(2157760), // Rule ID 18025 //
     /* 2157674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2157685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2157688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2157691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2157694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2157697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157720 */     // MIs[0] round
     /* 2157720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157723 */     // MIs[0] policy
     /* 2157723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157733 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2157736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157759 */     // GIR_Coverage, 18025,
     /* 2157759 */     GIR_EraseRootFromParent_Done,
     /* 2157760 */   // Label 28479: @2157760
     /* 2157760 */   GIM_Try, /*On fail goto*//*Label 28480*/ GIMT_Encode4(2157851), // Rule ID 18028 //
     /* 2157765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2157776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2157785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157811 */     // MIs[0] round
     /* 2157811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157814 */     // MIs[0] policy
     /* 2157814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2157827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157850 */     // GIR_Coverage, 18028,
     /* 2157850 */     GIR_EraseRootFromParent_Done,
     /* 2157851 */   // Label 28480: @2157851
     /* 2157851 */   GIM_Try, /*On fail goto*//*Label 28481*/ GIMT_Encode4(2157942), // Rule ID 18029 //
     /* 2157856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2157867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2157876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157902 */     // MIs[0] round
     /* 2157902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157905 */     // MIs[0] policy
     /* 2157905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157915 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2157918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157941 */     // GIR_Coverage, 18029,
     /* 2157941 */     GIR_EraseRootFromParent_Done,
     /* 2157942 */   // Label 28481: @2157942
     /* 2157942 */   GIM_Try, /*On fail goto*//*Label 28482*/ GIMT_Encode4(2158033), // Rule ID 18032 //
     /* 2157947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2157955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2157958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2157961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2157964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2157967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157993 */     // MIs[0] round
     /* 2157993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157996 */     // MIs[0] policy
     /* 2157996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158006 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2158009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158032 */     // GIR_Coverage, 18032,
     /* 2158032 */     GIR_EraseRootFromParent_Done,
     /* 2158033 */   // Label 28482: @2158033
     /* 2158033 */   GIM_Try, /*On fail goto*//*Label 28483*/ GIMT_Encode4(2158124), // Rule ID 18033 //
     /* 2158038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2158049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2158052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2158055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2158058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158084 */     // MIs[0] round
     /* 2158084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158087 */     // MIs[0] policy
     /* 2158087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158097 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2158100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158123 */     // GIR_Coverage, 18033,
     /* 2158123 */     GIR_EraseRootFromParent_Done,
     /* 2158124 */   // Label 28483: @2158124
     /* 2158124 */   GIM_Try, /*On fail goto*//*Label 28484*/ GIMT_Encode4(2158215), // Rule ID 18036 //
     /* 2158129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2158140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2158143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2158146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2158149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158175 */     // MIs[0] round
     /* 2158175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158178 */     // MIs[0] policy
     /* 2158178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158188 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2158191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158214 */     // GIR_Coverage, 18036,
     /* 2158214 */     GIR_EraseRootFromParent_Done,
     /* 2158215 */   // Label 28484: @2158215
     /* 2158215 */   GIM_Try, /*On fail goto*//*Label 28485*/ GIMT_Encode4(2158306), // Rule ID 18037 //
     /* 2158220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2158223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2158231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2158234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2158237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2158240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2158243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158266 */     // MIs[0] round
     /* 2158266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158269 */     // MIs[0] policy
     /* 2158269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158279 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2158282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158305 */     // GIR_Coverage, 18037,
     /* 2158305 */     GIR_EraseRootFromParent_Done,
     /* 2158306 */   // Label 28485: @2158306
     /* 2158306 */   GIM_Try, /*On fail goto*//*Label 28486*/ GIMT_Encode4(2158397), // Rule ID 18040 //
     /* 2158311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158357 */     // MIs[0] round
     /* 2158357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158360 */     // MIs[0] policy
     /* 2158360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2158373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158396 */     // GIR_Coverage, 18040,
     /* 2158396 */     GIR_EraseRootFromParent_Done,
     /* 2158397 */   // Label 28486: @2158397
     /* 2158397 */   GIM_Try, /*On fail goto*//*Label 28487*/ GIMT_Encode4(2158488), // Rule ID 18041 //
     /* 2158402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158448 */     // MIs[0] round
     /* 2158448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158451 */     // MIs[0] policy
     /* 2158451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158461 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2158464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158487 */     // GIR_Coverage, 18041,
     /* 2158487 */     GIR_EraseRootFromParent_Done,
     /* 2158488 */   // Label 28487: @2158488
     /* 2158488 */   GIM_Try, /*On fail goto*//*Label 28488*/ GIMT_Encode4(2158579), // Rule ID 18044 //
     /* 2158493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2158504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2158507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2158510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2158513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158539 */     // MIs[0] round
     /* 2158539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158542 */     // MIs[0] policy
     /* 2158542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158552 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2158555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158578 */     // GIR_Coverage, 18044,
     /* 2158578 */     GIR_EraseRootFromParent_Done,
     /* 2158579 */   // Label 28488: @2158579
     /* 2158579 */   GIM_Try, /*On fail goto*//*Label 28489*/ GIMT_Encode4(2158670), // Rule ID 18045 //
     /* 2158584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2158595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2158598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2158601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2158604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158630 */     // MIs[0] round
     /* 2158630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158633 */     // MIs[0] policy
     /* 2158633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158643 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2158646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158669 */     // GIR_Coverage, 18045,
     /* 2158669 */     GIR_EraseRootFromParent_Done,
     /* 2158670 */   // Label 28489: @2158670
     /* 2158670 */   GIM_Try, /*On fail goto*//*Label 28490*/ GIMT_Encode4(2158761), // Rule ID 18048 //
     /* 2158675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2158686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2158695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158721 */     // MIs[0] round
     /* 2158721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158724 */     // MIs[0] policy
     /* 2158724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158734 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2158737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158760 */     // GIR_Coverage, 18048,
     /* 2158760 */     GIR_EraseRootFromParent_Done,
     /* 2158761 */   // Label 28490: @2158761
     /* 2158761 */   GIM_Try, /*On fail goto*//*Label 28491*/ GIMT_Encode4(2158852), // Rule ID 18049 //
     /* 2158766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2158777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2158786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158812 */     // MIs[0] round
     /* 2158812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158815 */     // MIs[0] policy
     /* 2158815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158825 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2158828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158851 */     // GIR_Coverage, 18049,
     /* 2158851 */     GIR_EraseRootFromParent_Done,
     /* 2158852 */   // Label 28491: @2158852
     /* 2158852 */   GIM_Try, /*On fail goto*//*Label 28492*/ GIMT_Encode4(2158943), // Rule ID 18052 //
     /* 2158857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2158868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2158871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2158877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158903 */     // MIs[0] round
     /* 2158903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158906 */     // MIs[0] policy
     /* 2158906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158916 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2158919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158942 */     // GIR_Coverage, 18052,
     /* 2158942 */     GIR_EraseRootFromParent_Done,
     /* 2158943 */   // Label 28492: @2158943
     /* 2158943 */   GIM_Try, /*On fail goto*//*Label 28493*/ GIMT_Encode4(2159034), // Rule ID 18053 //
     /* 2158948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2158956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2158959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2158962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2158968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158994 */     // MIs[0] round
     /* 2158994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158997 */     // MIs[0] policy
     /* 2158997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159007 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2159010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159033 */     // GIR_Coverage, 18053,
     /* 2159033 */     GIR_EraseRootFromParent_Done,
     /* 2159034 */   // Label 28493: @2159034
     /* 2159034 */   GIM_Try, /*On fail goto*//*Label 28494*/ GIMT_Encode4(2159125), // Rule ID 18056 //
     /* 2159039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2159050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2159053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2159059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159085 */     // MIs[0] round
     /* 2159085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159088 */     // MIs[0] policy
     /* 2159088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159098 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2159101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159124 */     // GIR_Coverage, 18056,
     /* 2159124 */     GIR_EraseRootFromParent_Done,
     /* 2159125 */   // Label 28494: @2159125
     /* 2159125 */   GIM_Try, /*On fail goto*//*Label 28495*/ GIMT_Encode4(2159216), // Rule ID 18057 //
     /* 2159130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2159141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2159144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2159150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159176 */     // MIs[0] round
     /* 2159176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159179 */     // MIs[0] policy
     /* 2159179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159189 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2159192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159215 */     // GIR_Coverage, 18057,
     /* 2159215 */     GIR_EraseRootFromParent_Done,
     /* 2159216 */   // Label 28495: @2159216
     /* 2159216 */   GIM_Try, /*On fail goto*//*Label 28496*/ GIMT_Encode4(2159307), // Rule ID 18060 //
     /* 2159221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2159232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2159235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2159241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159267 */     // MIs[0] round
     /* 2159267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159270 */     // MIs[0] policy
     /* 2159270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159280 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2159283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159306 */     // GIR_Coverage, 18060,
     /* 2159306 */     GIR_EraseRootFromParent_Done,
     /* 2159307 */   // Label 28496: @2159307
     /* 2159307 */   GIM_Try, /*On fail goto*//*Label 28497*/ GIMT_Encode4(2159398), // Rule ID 18061 //
     /* 2159312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2159323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2159326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2159332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159358 */     // MIs[0] round
     /* 2159358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159361 */     // MIs[0] policy
     /* 2159361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159371 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2159374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159397 */     // GIR_Coverage, 18061,
     /* 2159397 */     GIR_EraseRootFromParent_Done,
     /* 2159398 */   // Label 28497: @2159398
     /* 2159398 */   GIM_Try, /*On fail goto*//*Label 28498*/ GIMT_Encode4(2159489), // Rule ID 18064 //
     /* 2159403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159449 */     // MIs[0] round
     /* 2159449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159452 */     // MIs[0] policy
     /* 2159452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2159465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159488 */     // GIR_Coverage, 18064,
     /* 2159488 */     GIR_EraseRootFromParent_Done,
     /* 2159489 */   // Label 28498: @2159489
     /* 2159489 */   GIM_Try, /*On fail goto*//*Label 28499*/ GIMT_Encode4(2159580), // Rule ID 18065 //
     /* 2159494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159540 */     // MIs[0] round
     /* 2159540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159543 */     // MIs[0] policy
     /* 2159543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159553 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11215:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2159556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159579 */     // GIR_Coverage, 18065,
     /* 2159579 */     GIR_EraseRootFromParent_Done,
     /* 2159580 */   // Label 28499: @2159580
     /* 2159580 */   GIM_Try, /*On fail goto*//*Label 28500*/ GIMT_Encode4(2159671), // Rule ID 18068 //
     /* 2159585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2159596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2159599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2159605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159631 */     // MIs[0] round
     /* 2159631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159634 */     // MIs[0] policy
     /* 2159634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159644 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2159647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159670 */     // GIR_Coverage, 18068,
     /* 2159670 */     GIR_EraseRootFromParent_Done,
     /* 2159671 */   // Label 28500: @2159671
     /* 2159671 */   GIM_Try, /*On fail goto*//*Label 28501*/ GIMT_Encode4(2159762), // Rule ID 18069 //
     /* 2159676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2159687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2159690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2159696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159722 */     // MIs[0] round
     /* 2159722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159725 */     // MIs[0] policy
     /* 2159725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159735 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2159738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159761 */     // GIR_Coverage, 18069,
     /* 2159761 */     GIR_EraseRootFromParent_Done,
     /* 2159762 */   // Label 28501: @2159762
     /* 2159762 */   GIM_Try, /*On fail goto*//*Label 28502*/ GIMT_Encode4(2159853), // Rule ID 18072 //
     /* 2159767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2159778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2159781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2159787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159813 */     // MIs[0] round
     /* 2159813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159816 */     // MIs[0] policy
     /* 2159816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159826 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2159829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159852 */     // GIR_Coverage, 18072,
     /* 2159852 */     GIR_EraseRootFromParent_Done,
     /* 2159853 */   // Label 28502: @2159853
     /* 2159853 */   GIM_Try, /*On fail goto*//*Label 28503*/ GIMT_Encode4(2159944), // Rule ID 18073 //
     /* 2159858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2159869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2159872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2159878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159904 */     // MIs[0] round
     /* 2159904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159907 */     // MIs[0] policy
     /* 2159907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159917 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2159920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159943 */     // GIR_Coverage, 18073,
     /* 2159943 */     GIR_EraseRootFromParent_Done,
     /* 2159944 */   // Label 28503: @2159944
     /* 2159944 */   GIM_Try, /*On fail goto*//*Label 28504*/ GIMT_Encode4(2160035), // Rule ID 18076 //
     /* 2159949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2159957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2159960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2159963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2159969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159995 */     // MIs[0] round
     /* 2159995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159998 */     // MIs[0] policy
     /* 2159998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160008 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2160011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160034 */     // GIR_Coverage, 18076,
     /* 2160034 */     GIR_EraseRootFromParent_Done,
     /* 2160035 */   // Label 28504: @2160035
     /* 2160035 */   GIM_Try, /*On fail goto*//*Label 28505*/ GIMT_Encode4(2160126), // Rule ID 18077 //
     /* 2160040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2160051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2160054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2160060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160086 */     // MIs[0] round
     /* 2160086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160089 */     // MIs[0] policy
     /* 2160089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160099 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2160102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160125 */     // GIR_Coverage, 18077,
     /* 2160125 */     GIR_EraseRootFromParent_Done,
     /* 2160126 */   // Label 28505: @2160126
     /* 2160126 */   GIM_Try, /*On fail goto*//*Label 28506*/ GIMT_Encode4(2160217), // Rule ID 18080 //
     /* 2160131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2160142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2160145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2160151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160177 */     // MIs[0] round
     /* 2160177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160180 */     // MIs[0] policy
     /* 2160180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160190 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2160193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160216 */     // GIR_Coverage, 18080,
     /* 2160216 */     GIR_EraseRootFromParent_Done,
     /* 2160217 */   // Label 28506: @2160217
     /* 2160217 */   GIM_Try, /*On fail goto*//*Label 28507*/ GIMT_Encode4(2160308), // Rule ID 18081 //
     /* 2160222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2160233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2160236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2160242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160268 */     // MIs[0] round
     /* 2160268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160271 */     // MIs[0] policy
     /* 2160271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160281 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2160284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160307 */     // GIR_Coverage, 18081,
     /* 2160307 */     GIR_EraseRootFromParent_Done,
     /* 2160308 */   // Label 28507: @2160308
     /* 2160308 */   GIM_Try, /*On fail goto*//*Label 28508*/ GIMT_Encode4(2160399), // Rule ID 18084 //
     /* 2160313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160359 */     // MIs[0] round
     /* 2160359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160362 */     // MIs[0] policy
     /* 2160362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160372 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2160375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160398 */     // GIR_Coverage, 18084,
     /* 2160398 */     GIR_EraseRootFromParent_Done,
     /* 2160399 */   // Label 28508: @2160399
     /* 2160399 */   GIM_Try, /*On fail goto*//*Label 28509*/ GIMT_Encode4(2160490), // Rule ID 18085 //
     /* 2160404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160450 */     // MIs[0] round
     /* 2160450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160453 */     // MIs[0] policy
     /* 2160453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160463 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2160466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160489 */     // GIR_Coverage, 18085,
     /* 2160489 */     GIR_EraseRootFromParent_Done,
     /* 2160490 */   // Label 28509: @2160490
     /* 2160490 */   GIM_Try, /*On fail goto*//*Label 28510*/ GIMT_Encode4(2160581), // Rule ID 18088 //
     /* 2160495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2160506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2160509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2160515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160541 */     // MIs[0] round
     /* 2160541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160544 */     // MIs[0] policy
     /* 2160544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160554 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2160557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160580 */     // GIR_Coverage, 18088,
     /* 2160580 */     GIR_EraseRootFromParent_Done,
     /* 2160581 */   // Label 28510: @2160581
     /* 2160581 */   GIM_Try, /*On fail goto*//*Label 28511*/ GIMT_Encode4(2160672), // Rule ID 18089 //
     /* 2160586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2160597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2160600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2160606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160632 */     // MIs[0] round
     /* 2160632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160635 */     // MIs[0] policy
     /* 2160635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160645 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2160648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160671 */     // GIR_Coverage, 18089,
     /* 2160671 */     GIR_EraseRootFromParent_Done,
     /* 2160672 */   // Label 28511: @2160672
     /* 2160672 */   GIM_Try, /*On fail goto*//*Label 28512*/ GIMT_Encode4(2160763), // Rule ID 18092 //
     /* 2160677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2160688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2160691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2160697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160723 */     // MIs[0] round
     /* 2160723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160726 */     // MIs[0] policy
     /* 2160726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160736 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2160739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160762 */     // GIR_Coverage, 18092,
     /* 2160762 */     GIR_EraseRootFromParent_Done,
     /* 2160763 */   // Label 28512: @2160763
     /* 2160763 */   GIM_Try, /*On fail goto*//*Label 28513*/ GIMT_Encode4(2160854), // Rule ID 18093 //
     /* 2160768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2160779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2160782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2160788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160814 */     // MIs[0] round
     /* 2160814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160817 */     // MIs[0] policy
     /* 2160817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160827 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2160830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160853 */     // GIR_Coverage, 18093,
     /* 2160853 */     GIR_EraseRootFromParent_Done,
     /* 2160854 */   // Label 28513: @2160854
     /* 2160854 */   GIM_Try, /*On fail goto*//*Label 28514*/ GIMT_Encode4(2160945), // Rule ID 18096 //
     /* 2160859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2160870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2160873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2160879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160905 */     // MIs[0] round
     /* 2160905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160908 */     // MIs[0] policy
     /* 2160908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160918 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2160921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160944 */     // GIR_Coverage, 18096,
     /* 2160944 */     GIR_EraseRootFromParent_Done,
     /* 2160945 */   // Label 28514: @2160945
     /* 2160945 */   GIM_Try, /*On fail goto*//*Label 28515*/ GIMT_Encode4(2161036), // Rule ID 18097 //
     /* 2160950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2160958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2160961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2160964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2160970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160996 */     // MIs[0] round
     /* 2160996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160999 */     // MIs[0] policy
     /* 2160999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161009 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2161012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161035 */     // GIR_Coverage, 18097,
     /* 2161035 */     GIR_EraseRootFromParent_Done,
     /* 2161036 */   // Label 28515: @2161036
     /* 2161036 */   GIM_Try, /*On fail goto*//*Label 28516*/ GIMT_Encode4(2161127), // Rule ID 18100 //
     /* 2161041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2161052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2161055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2161061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161087 */     // MIs[0] round
     /* 2161087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161090 */     // MIs[0] policy
     /* 2161090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2161103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161126 */     // GIR_Coverage, 18100,
     /* 2161126 */     GIR_EraseRootFromParent_Done,
     /* 2161127 */   // Label 28516: @2161127
     /* 2161127 */   GIM_Try, /*On fail goto*//*Label 28517*/ GIMT_Encode4(2161218), // Rule ID 18101 //
     /* 2161132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2161143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2161146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2161152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2161162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2161174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161178 */     // MIs[0] round
     /* 2161178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161181 */     // MIs[0] policy
     /* 2161181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161191 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2161194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161217 */     // GIR_Coverage, 18101,
     /* 2161217 */     GIR_EraseRootFromParent_Done,
     /* 2161218 */   // Label 28517: @2161218
     /* 2161218 */   GIM_Try, /*On fail goto*//*Label 28518*/ GIMT_Encode4(2161309), // Rule ID 18104 //
     /* 2161223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2161234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2161237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2161243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161269 */     // MIs[0] round
     /* 2161269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161272 */     // MIs[0] policy
     /* 2161272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161282 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2161285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161308 */     // GIR_Coverage, 18104,
     /* 2161308 */     GIR_EraseRootFromParent_Done,
     /* 2161309 */   // Label 28518: @2161309
     /* 2161309 */   GIM_Try, /*On fail goto*//*Label 28519*/ GIMT_Encode4(2161400), // Rule ID 18105 //
     /* 2161314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2161325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2161328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2161334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161360 */     // MIs[0] round
     /* 2161360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161363 */     // MIs[0] policy
     /* 2161363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161373 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2161376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161399 */     // GIR_Coverage, 18105,
     /* 2161399 */     GIR_EraseRootFromParent_Done,
     /* 2161400 */   // Label 28519: @2161400
     /* 2161400 */   GIM_Try, /*On fail goto*//*Label 28520*/ GIMT_Encode4(2161491), // Rule ID 18108 //
     /* 2161405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161451 */     // MIs[0] round
     /* 2161451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161454 */     // MIs[0] policy
     /* 2161454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161464 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2161467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161490 */     // GIR_Coverage, 18108,
     /* 2161490 */     GIR_EraseRootFromParent_Done,
     /* 2161491 */   // Label 28520: @2161491
     /* 2161491 */   GIM_Try, /*On fail goto*//*Label 28521*/ GIMT_Encode4(2161582), // Rule ID 18109 //
     /* 2161496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2161504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161542 */     // MIs[0] round
     /* 2161542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161545 */     // MIs[0] policy
     /* 2161545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161555 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2161558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161581 */     // GIR_Coverage, 18109,
     /* 2161581 */     GIR_EraseRootFromParent_Done,
     /* 2161582 */   // Label 28521: @2161582
     /* 2161582 */   GIM_Try, /*On fail goto*//*Label 28522*/ GIMT_Encode4(2161673), // Rule ID 18112 //
     /* 2161587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2161598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2161601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2161604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2161607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161633 */     // MIs[0] round
     /* 2161633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161636 */     // MIs[0] policy
     /* 2161636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161646 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2161649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161672 */     // GIR_Coverage, 18112,
     /* 2161672 */     GIR_EraseRootFromParent_Done,
     /* 2161673 */   // Label 28522: @2161673
     /* 2161673 */   GIM_Try, /*On fail goto*//*Label 28523*/ GIMT_Encode4(2161764), // Rule ID 18113 //
     /* 2161678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2161689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2161692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2161695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2161698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161724 */     // MIs[0] round
     /* 2161724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161727 */     // MIs[0] policy
     /* 2161727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161737 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2161740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161763 */     // GIR_Coverage, 18113,
     /* 2161763 */     GIR_EraseRootFromParent_Done,
     /* 2161764 */   // Label 28523: @2161764
     /* 2161764 */   GIM_Try, /*On fail goto*//*Label 28524*/ GIMT_Encode4(2161855), // Rule ID 18116 //
     /* 2161769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2161780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2161783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2161786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2161789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161815 */     // MIs[0] round
     /* 2161815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161818 */     // MIs[0] policy
     /* 2161818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161828 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2161831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161854 */     // GIR_Coverage, 18116,
     /* 2161854 */     GIR_EraseRootFromParent_Done,
     /* 2161855 */   // Label 28524: @2161855
     /* 2161855 */   GIM_Try, /*On fail goto*//*Label 28525*/ GIMT_Encode4(2161946), // Rule ID 18117 //
     /* 2161860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2161871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2161874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2161877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2161880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161906 */     // MIs[0] round
     /* 2161906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161909 */     // MIs[0] policy
     /* 2161909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161919 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2161922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161945 */     // GIR_Coverage, 18117,
     /* 2161945 */     GIR_EraseRootFromParent_Done,
     /* 2161946 */   // Label 28525: @2161946
     /* 2161946 */   GIM_Try, /*On fail goto*//*Label 28526*/ GIMT_Encode4(2162037), // Rule ID 18120 //
     /* 2161951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2161959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2161962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2161965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2161968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2161971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161997 */     // MIs[0] round
     /* 2161997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162000 */     // MIs[0] policy
     /* 2162000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162010 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2162013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162036 */     // GIR_Coverage, 18120,
     /* 2162036 */     GIR_EraseRootFromParent_Done,
     /* 2162037 */   // Label 28526: @2162037
     /* 2162037 */   GIM_Try, /*On fail goto*//*Label 28527*/ GIMT_Encode4(2162128), // Rule ID 18121 //
     /* 2162042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2162053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2162056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2162059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2162062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162088 */     // MIs[0] round
     /* 2162088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162091 */     // MIs[0] policy
     /* 2162091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162101 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2162104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162127 */     // GIR_Coverage, 18121,
     /* 2162127 */     GIR_EraseRootFromParent_Done,
     /* 2162128 */   // Label 28527: @2162128
     /* 2162128 */   GIM_Try, /*On fail goto*//*Label 28528*/ GIMT_Encode4(2162219), // Rule ID 18124 //
     /* 2162133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2162144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2162147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2162150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2162153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162179 */     // MIs[0] round
     /* 2162179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162182 */     // MIs[0] policy
     /* 2162182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162192 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2162195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162218 */     // GIR_Coverage, 18124,
     /* 2162218 */     GIR_EraseRootFromParent_Done,
     /* 2162219 */   // Label 28528: @2162219
     /* 2162219 */   GIM_Try, /*On fail goto*//*Label 28529*/ GIMT_Encode4(2162310), // Rule ID 18125 //
     /* 2162224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2162235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2162238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2162241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2162244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162270 */     // MIs[0] round
     /* 2162270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162273 */     // MIs[0] policy
     /* 2162273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162283 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2162286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162309 */     // GIR_Coverage, 18125,
     /* 2162309 */     GIR_EraseRootFromParent_Done,
     /* 2162310 */   // Label 28529: @2162310
     /* 2162310 */   GIM_Try, /*On fail goto*//*Label 28530*/ GIMT_Encode4(2162401), // Rule ID 18128 //
     /* 2162315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2162318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162361 */     // MIs[0] round
     /* 2162361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162364 */     // MIs[0] policy
     /* 2162364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162374 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2162377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162400 */     // GIR_Coverage, 18128,
     /* 2162400 */     GIR_EraseRootFromParent_Done,
     /* 2162401 */   // Label 28530: @2162401
     /* 2162401 */   GIM_Try, /*On fail goto*//*Label 28531*/ GIMT_Encode4(2162492), // Rule ID 18129 //
     /* 2162406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162452 */     // MIs[0] round
     /* 2162452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162455 */     // MIs[0] policy
     /* 2162455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162465 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2162468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162491 */     // GIR_Coverage, 18129,
     /* 2162491 */     GIR_EraseRootFromParent_Done,
     /* 2162492 */   // Label 28531: @2162492
     /* 2162492 */   GIM_Try, /*On fail goto*//*Label 28532*/ GIMT_Encode4(2162583), // Rule ID 18132 //
     /* 2162497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2162508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2162511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2162514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2162517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162543 */     // MIs[0] round
     /* 2162543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162546 */     // MIs[0] policy
     /* 2162546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162556 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2162559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162582 */     // GIR_Coverage, 18132,
     /* 2162582 */     GIR_EraseRootFromParent_Done,
     /* 2162583 */   // Label 28532: @2162583
     /* 2162583 */   GIM_Try, /*On fail goto*//*Label 28533*/ GIMT_Encode4(2162674), // Rule ID 18133 //
     /* 2162588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2162591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2162599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2162602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2162605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2162608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162634 */     // MIs[0] round
     /* 2162634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162637 */     // MIs[0] policy
     /* 2162637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162647 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2162650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162673 */     // GIR_Coverage, 18133,
     /* 2162673 */     GIR_EraseRootFromParent_Done,
     /* 2162674 */   // Label 28533: @2162674
     /* 2162674 */   GIM_Try, /*On fail goto*//*Label 28534*/ GIMT_Encode4(2162765), // Rule ID 18136 //
     /* 2162679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2162690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2162693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2162696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2162699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162725 */     // MIs[0] round
     /* 2162725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162728 */     // MIs[0] policy
     /* 2162728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162738 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2162741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162764 */     // GIR_Coverage, 18136,
     /* 2162764 */     GIR_EraseRootFromParent_Done,
     /* 2162765 */   // Label 28534: @2162765
     /* 2162765 */   GIM_Try, /*On fail goto*//*Label 28535*/ GIMT_Encode4(2162856), // Rule ID 18137 //
     /* 2162770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2162781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2162784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2162787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2162790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162816 */     // MIs[0] round
     /* 2162816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162819 */     // MIs[0] policy
     /* 2162819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162829 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2162832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162855 */     // GIR_Coverage, 18137,
     /* 2162855 */     GIR_EraseRootFromParent_Done,
     /* 2162856 */   // Label 28535: @2162856
     /* 2162856 */   GIM_Try, /*On fail goto*//*Label 28536*/ GIMT_Encode4(2162947), // Rule ID 18140 //
     /* 2162861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2162872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2162875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2162878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2162881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2162884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162907 */     // MIs[0] round
     /* 2162907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162910 */     // MIs[0] policy
     /* 2162910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162920 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2162923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162946 */     // GIR_Coverage, 18140,
     /* 2162946 */     GIR_EraseRootFromParent_Done,
     /* 2162947 */   // Label 28536: @2162947
     /* 2162947 */   GIM_Try, /*On fail goto*//*Label 28537*/ GIMT_Encode4(2163038), // Rule ID 18141 //
     /* 2162952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2162960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2162963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2162966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2162969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2162972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2162975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162998 */     // MIs[0] round
     /* 2162998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163001 */     // MIs[0] policy
     /* 2163001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163011 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2163014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163037 */     // GIR_Coverage, 18141,
     /* 2163037 */     GIR_EraseRootFromParent_Done,
     /* 2163038 */   // Label 28537: @2163038
     /* 2163038 */   GIM_Try, /*On fail goto*//*Label 28538*/ GIMT_Encode4(2163129), // Rule ID 18144 //
     /* 2163043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2163046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2163054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2163057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2163060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2163063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2163066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163089 */     // MIs[0] round
     /* 2163089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163092 */     // MIs[0] policy
     /* 2163092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163102 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2163105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163128 */     // GIR_Coverage, 18144,
     /* 2163128 */     GIR_EraseRootFromParent_Done,
     /* 2163129 */   // Label 28538: @2163129
     /* 2163129 */   GIM_Try, /*On fail goto*//*Label 28539*/ GIMT_Encode4(2163220), // Rule ID 18145 //
     /* 2163134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2163137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2163145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2163148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2163151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2163154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2163157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163180 */     // MIs[0] round
     /* 2163180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163183 */     // MIs[0] policy
     /* 2163183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163193 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2163196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2163216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163219 */     // GIR_Coverage, 18145,
     /* 2163219 */     GIR_EraseRootFromParent_Done,
     /* 2163220 */   // Label 28539: @2163220
     /* 2163220 */   GIM_Try, /*On fail goto*//*Label 28540*/ GIMT_Encode4(2163311), // Rule ID 18148 //
     /* 2163225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2163236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2163239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2163242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2163245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163271 */     // MIs[0] round
     /* 2163271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163274 */     // MIs[0] policy
     /* 2163274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163284 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2163287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163310 */     // GIR_Coverage, 18148,
     /* 2163310 */     GIR_EraseRootFromParent_Done,
     /* 2163311 */   // Label 28540: @2163311
     /* 2163311 */   GIM_Try, /*On fail goto*//*Label 28541*/ GIMT_Encode4(2163402), // Rule ID 18149 //
     /* 2163316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2163327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2163330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2163333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2163336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163362 */     // MIs[0] round
     /* 2163362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163365 */     // MIs[0] policy
     /* 2163365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163375 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2163378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163401 */     // GIR_Coverage, 18149,
     /* 2163401 */     GIR_EraseRootFromParent_Done,
     /* 2163402 */   // Label 28541: @2163402
     /* 2163402 */   GIM_Try, /*On fail goto*//*Label 28542*/ GIMT_Encode4(2163493), // Rule ID 18152 //
     /* 2163407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163453 */     // MIs[0] round
     /* 2163453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163456 */     // MIs[0] policy
     /* 2163456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163466 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2163469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163492 */     // GIR_Coverage, 18152,
     /* 2163492 */     GIR_EraseRootFromParent_Done,
     /* 2163493 */   // Label 28542: @2163493
     /* 2163493 */   GIM_Try, /*On fail goto*//*Label 28543*/ GIMT_Encode4(2163584), // Rule ID 18153 //
     /* 2163498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163544 */     // MIs[0] round
     /* 2163544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163547 */     // MIs[0] policy
     /* 2163547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163557 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2163560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163583 */     // GIR_Coverage, 18153,
     /* 2163583 */     GIR_EraseRootFromParent_Done,
     /* 2163584 */   // Label 28543: @2163584
     /* 2163584 */   GIM_Try, /*On fail goto*//*Label 28544*/ GIMT_Encode4(2163675), // Rule ID 18156 //
     /* 2163589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2163600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2163603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2163606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2163609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163635 */     // MIs[0] round
     /* 2163635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163638 */     // MIs[0] policy
     /* 2163638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163648 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2163651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163674 */     // GIR_Coverage, 18156,
     /* 2163674 */     GIR_EraseRootFromParent_Done,
     /* 2163675 */   // Label 28544: @2163675
     /* 2163675 */   GIM_Try, /*On fail goto*//*Label 28545*/ GIMT_Encode4(2163766), // Rule ID 18157 //
     /* 2163680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2163691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2163694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2163697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2163700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163726 */     // MIs[0] round
     /* 2163726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163729 */     // MIs[0] policy
     /* 2163729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163739 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2163742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163765 */     // GIR_Coverage, 18157,
     /* 2163765 */     GIR_EraseRootFromParent_Done,
     /* 2163766 */   // Label 28545: @2163766
     /* 2163766 */   GIM_Try, /*On fail goto*//*Label 28546*/ GIMT_Encode4(2163857), // Rule ID 18160 //
     /* 2163771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2163774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2163782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2163785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2163788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2163791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163817 */     // MIs[0] round
     /* 2163817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163820 */     // MIs[0] policy
     /* 2163820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163830 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2163833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163856 */     // GIR_Coverage, 18160,
     /* 2163856 */     GIR_EraseRootFromParent_Done,
     /* 2163857 */   // Label 28546: @2163857
     /* 2163857 */   GIM_Try, /*On fail goto*//*Label 28547*/ GIMT_Encode4(2163948), // Rule ID 18161 //
     /* 2163862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2163865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2163873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2163876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2163879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2163882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163908 */     // MIs[0] round
     /* 2163908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163911 */     // MIs[0] policy
     /* 2163911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163921 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2163924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163947 */     // GIR_Coverage, 18161,
     /* 2163947 */     GIR_EraseRootFromParent_Done,
     /* 2163948 */   // Label 28547: @2163948
     /* 2163948 */   GIM_Try, /*On fail goto*//*Label 28548*/ GIMT_Encode4(2164039), // Rule ID 18164 //
     /* 2163953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2163956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2163961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2163964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2163967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2163970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2163973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163999 */     // MIs[0] round
     /* 2163999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164002 */     // MIs[0] policy
     /* 2164002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164012 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2164015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164038 */     // GIR_Coverage, 18164,
     /* 2164038 */     GIR_EraseRootFromParent_Done,
     /* 2164039 */   // Label 28548: @2164039
     /* 2164039 */   GIM_Try, /*On fail goto*//*Label 28549*/ GIMT_Encode4(2164130), // Rule ID 18165 //
     /* 2164044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2164055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2164058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2164061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2164064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2164074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2164086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164090 */     // MIs[0] round
     /* 2164090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164093 */     // MIs[0] policy
     /* 2164093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164103 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2164106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164129 */     // GIR_Coverage, 18165,
     /* 2164129 */     GIR_EraseRootFromParent_Done,
     /* 2164130 */   // Label 28549: @2164130
     /* 2164130 */   GIM_Try, /*On fail goto*//*Label 28550*/ GIMT_Encode4(2164221), // Rule ID 18168 //
     /* 2164135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2164146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2164149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2164152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2164155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164181 */     // MIs[0] round
     /* 2164181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164184 */     // MIs[0] policy
     /* 2164184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164194 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2164197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164220 */     // GIR_Coverage, 18168,
     /* 2164220 */     GIR_EraseRootFromParent_Done,
     /* 2164221 */   // Label 28550: @2164221
     /* 2164221 */   GIM_Try, /*On fail goto*//*Label 28551*/ GIMT_Encode4(2164312), // Rule ID 18169 //
     /* 2164226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2164229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2164237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2164240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2164243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2164246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2164249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2164256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2164268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164272 */     // MIs[0] round
     /* 2164272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164275 */     // MIs[0] policy
     /* 2164275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164285 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2164288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164311 */     // GIR_Coverage, 18169,
     /* 2164311 */     GIR_EraseRootFromParent_Done,
     /* 2164312 */   // Label 28551: @2164312
     /* 2164312 */   GIM_Try, /*On fail goto*//*Label 28552*/ GIMT_Encode4(2164403), // Rule ID 18172 //
     /* 2164317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164363 */     // MIs[0] round
     /* 2164363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164366 */     // MIs[0] policy
     /* 2164366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164376 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2164379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164402 */     // GIR_Coverage, 18172,
     /* 2164402 */     GIR_EraseRootFromParent_Done,
     /* 2164403 */   // Label 28552: @2164403
     /* 2164403 */   GIM_Try, /*On fail goto*//*Label 28553*/ GIMT_Encode4(2164494), // Rule ID 18173 //
     /* 2164408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164454 */     // MIs[0] round
     /* 2164454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164457 */     // MIs[0] policy
     /* 2164457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164467 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2164470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164493 */     // GIR_Coverage, 18173,
     /* 2164493 */     GIR_EraseRootFromParent_Done,
     /* 2164494 */   // Label 28553: @2164494
     /* 2164494 */   GIM_Try, /*On fail goto*//*Label 28554*/ GIMT_Encode4(2164585), // Rule ID 18176 //
     /* 2164499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2164510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2164513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2164519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164545 */     // MIs[0] round
     /* 2164545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164548 */     // MIs[0] policy
     /* 2164548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164558 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2164561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164584 */     // GIR_Coverage, 18176,
     /* 2164584 */     GIR_EraseRootFromParent_Done,
     /* 2164585 */   // Label 28554: @2164585
     /* 2164585 */   GIM_Try, /*On fail goto*//*Label 28555*/ GIMT_Encode4(2164676), // Rule ID 18177 //
     /* 2164590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2164601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2164604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2164610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164636 */     // MIs[0] round
     /* 2164636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164639 */     // MIs[0] policy
     /* 2164639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164649 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2164652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164675 */     // GIR_Coverage, 18177,
     /* 2164675 */     GIR_EraseRootFromParent_Done,
     /* 2164676 */   // Label 28555: @2164676
     /* 2164676 */   GIM_Try, /*On fail goto*//*Label 28556*/ GIMT_Encode4(2164767), // Rule ID 18180 //
     /* 2164681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2164692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2164695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2164701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164727 */     // MIs[0] round
     /* 2164727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164730 */     // MIs[0] policy
     /* 2164730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164740 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2164743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164766 */     // GIR_Coverage, 18180,
     /* 2164766 */     GIR_EraseRootFromParent_Done,
     /* 2164767 */   // Label 28556: @2164767
     /* 2164767 */   GIM_Try, /*On fail goto*//*Label 28557*/ GIMT_Encode4(2164858), // Rule ID 18181 //
     /* 2164772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2164783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2164786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2164792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164818 */     // MIs[0] round
     /* 2164818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164821 */     // MIs[0] policy
     /* 2164821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164831 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2164834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164857 */     // GIR_Coverage, 18181,
     /* 2164857 */     GIR_EraseRootFromParent_Done,
     /* 2164858 */   // Label 28557: @2164858
     /* 2164858 */   GIM_Try, /*On fail goto*//*Label 28558*/ GIMT_Encode4(2164949), // Rule ID 18184 //
     /* 2164863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2164874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2164877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2164883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164909 */     // MIs[0] round
     /* 2164909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164912 */     // MIs[0] policy
     /* 2164912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164922 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2164925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164948 */     // GIR_Coverage, 18184,
     /* 2164948 */     GIR_EraseRootFromParent_Done,
     /* 2164949 */   // Label 28558: @2164949
     /* 2164949 */   GIM_Try, /*On fail goto*//*Label 28559*/ GIMT_Encode4(2165040), // Rule ID 18185 //
     /* 2164954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2164962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2164965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2164968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2164974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165000 */     // MIs[0] round
     /* 2165000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165003 */     // MIs[0] policy
     /* 2165003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165013 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11246:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2165016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165039 */     // GIR_Coverage, 18185,
     /* 2165039 */     GIR_EraseRootFromParent_Done,
     /* 2165040 */   // Label 28559: @2165040
     /* 2165040 */   GIM_Try, /*On fail goto*//*Label 28560*/ GIMT_Encode4(2165131), // Rule ID 18188 //
     /* 2165045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2165056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2165059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2165065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165091 */     // MIs[0] round
     /* 2165091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165094 */     // MIs[0] policy
     /* 2165094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2165107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165130 */     // GIR_Coverage, 18188,
     /* 2165130 */     GIR_EraseRootFromParent_Done,
     /* 2165131 */   // Label 28560: @2165131
     /* 2165131 */   GIM_Try, /*On fail goto*//*Label 28561*/ GIMT_Encode4(2165222), // Rule ID 18189 //
     /* 2165136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2165139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2165147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2165150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2165156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2165159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165182 */     // MIs[0] round
     /* 2165182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165185 */     // MIs[0] policy
     /* 2165185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165195 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2165198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165221 */     // GIR_Coverage, 18189,
     /* 2165221 */     GIR_EraseRootFromParent_Done,
     /* 2165222 */   // Label 28561: @2165222
     /* 2165222 */   GIM_Try, /*On fail goto*//*Label 28562*/ GIMT_Encode4(2165313), // Rule ID 18192 //
     /* 2165227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2165230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2165238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2165247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165273 */     // MIs[0] round
     /* 2165273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165276 */     // MIs[0] policy
     /* 2165276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165286 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2165289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165312 */     // GIR_Coverage, 18192,
     /* 2165312 */     GIR_EraseRootFromParent_Done,
     /* 2165313 */   // Label 28562: @2165313
     /* 2165313 */   GIM_Try, /*On fail goto*//*Label 28563*/ GIMT_Encode4(2165404), // Rule ID 18193 //
     /* 2165318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2165329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2165338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165364 */     // MIs[0] round
     /* 2165364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165367 */     // MIs[0] policy
     /* 2165367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165377 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2165380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165403 */     // GIR_Coverage, 18193,
     /* 2165403 */     GIR_EraseRootFromParent_Done,
     /* 2165404 */   // Label 28563: @2165404
     /* 2165404 */   GIM_Try, /*On fail goto*//*Label 28564*/ GIMT_Encode4(2165495), // Rule ID 18196 //
     /* 2165409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165455 */     // MIs[0] round
     /* 2165455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165458 */     // MIs[0] policy
     /* 2165458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165468 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2165471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165494 */     // GIR_Coverage, 18196,
     /* 2165494 */     GIR_EraseRootFromParent_Done,
     /* 2165495 */   // Label 28564: @2165495
     /* 2165495 */   GIM_Try, /*On fail goto*//*Label 28565*/ GIMT_Encode4(2165586), // Rule ID 18197 //
     /* 2165500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165546 */     // MIs[0] round
     /* 2165546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165549 */     // MIs[0] policy
     /* 2165549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165559 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2165562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165585 */     // GIR_Coverage, 18197,
     /* 2165585 */     GIR_EraseRootFromParent_Done,
     /* 2165586 */   // Label 28565: @2165586
     /* 2165586 */   GIM_Try, /*On fail goto*//*Label 28566*/ GIMT_Encode4(2165677), // Rule ID 18200 //
     /* 2165591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2165602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2165605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2165611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2165614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165637 */     // MIs[0] round
     /* 2165637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165640 */     // MIs[0] policy
     /* 2165640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165650 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2165653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165676 */     // GIR_Coverage, 18200,
     /* 2165676 */     GIR_EraseRootFromParent_Done,
     /* 2165677 */   // Label 28566: @2165677
     /* 2165677 */   GIM_Try, /*On fail goto*//*Label 28567*/ GIMT_Encode4(2165768), // Rule ID 18201 //
     /* 2165682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2165693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2165696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2165702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2165705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165728 */     // MIs[0] round
     /* 2165728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165731 */     // MIs[0] policy
     /* 2165731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165741 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2165744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165767 */     // GIR_Coverage, 18201,
     /* 2165767 */     GIR_EraseRootFromParent_Done,
     /* 2165768 */   // Label 28567: @2165768
     /* 2165768 */   GIM_Try, /*On fail goto*//*Label 28568*/ GIMT_Encode4(2165859), // Rule ID 18204 //
     /* 2165773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2165784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2165787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2165793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2165796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165819 */     // MIs[0] round
     /* 2165819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165822 */     // MIs[0] policy
     /* 2165822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165832 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2165835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165858 */     // GIR_Coverage, 18204,
     /* 2165858 */     GIR_EraseRootFromParent_Done,
     /* 2165859 */   // Label 28568: @2165859
     /* 2165859 */   GIM_Try, /*On fail goto*//*Label 28569*/ GIMT_Encode4(2165950), // Rule ID 18205 //
     /* 2165864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2165875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2165878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2165884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2165887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165910 */     // MIs[0] round
     /* 2165910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165913 */     // MIs[0] policy
     /* 2165913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165923 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2165926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165949 */     // GIR_Coverage, 18205,
     /* 2165949 */     GIR_EraseRootFromParent_Done,
     /* 2165950 */   // Label 28569: @2165950
     /* 2165950 */   GIM_Try, /*On fail goto*//*Label 28570*/ GIMT_Encode4(2166041), // Rule ID 18208 //
     /* 2165955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2165963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2165966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2165969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2165975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166001 */     // MIs[0] round
     /* 2166001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166004 */     // MIs[0] policy
     /* 2166004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166014 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2166017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166040 */     // GIR_Coverage, 18208,
     /* 2166040 */     GIR_EraseRootFromParent_Done,
     /* 2166041 */   // Label 28570: @2166041
     /* 2166041 */   GIM_Try, /*On fail goto*//*Label 28571*/ GIMT_Encode4(2166132), // Rule ID 18209 //
     /* 2166046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2166057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2166060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2166066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166092 */     // MIs[0] round
     /* 2166092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166095 */     // MIs[0] policy
     /* 2166095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166105 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2166108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166131 */     // GIR_Coverage, 18209,
     /* 2166131 */     GIR_EraseRootFromParent_Done,
     /* 2166132 */   // Label 28571: @2166132
     /* 2166132 */   GIM_Try, /*On fail goto*//*Label 28572*/ GIMT_Encode4(2166223), // Rule ID 18212 //
     /* 2166137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2166148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2166151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2166157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166183 */     // MIs[0] round
     /* 2166183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166186 */     // MIs[0] policy
     /* 2166186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166196 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2166199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166222 */     // GIR_Coverage, 18212,
     /* 2166222 */     GIR_EraseRootFromParent_Done,
     /* 2166223 */   // Label 28572: @2166223
     /* 2166223 */   GIM_Try, /*On fail goto*//*Label 28573*/ GIMT_Encode4(2166314), // Rule ID 18213 //
     /* 2166228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2166239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2166242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2166248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166274 */     // MIs[0] round
     /* 2166274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166277 */     // MIs[0] policy
     /* 2166277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166287 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2166290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166313 */     // GIR_Coverage, 18213,
     /* 2166313 */     GIR_EraseRootFromParent_Done,
     /* 2166314 */   // Label 28573: @2166314
     /* 2166314 */   GIM_Try, /*On fail goto*//*Label 28574*/ GIMT_Encode4(2166405), // Rule ID 18216 //
     /* 2166319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166365 */     // MIs[0] round
     /* 2166365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166368 */     // MIs[0] policy
     /* 2166368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166378 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2166381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166404 */     // GIR_Coverage, 18216,
     /* 2166404 */     GIR_EraseRootFromParent_Done,
     /* 2166405 */   // Label 28574: @2166405
     /* 2166405 */   GIM_Try, /*On fail goto*//*Label 28575*/ GIMT_Encode4(2166496), // Rule ID 18217 //
     /* 2166410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166456 */     // MIs[0] round
     /* 2166456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166459 */     // MIs[0] policy
     /* 2166459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166469 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2166472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166495 */     // GIR_Coverage, 18217,
     /* 2166495 */     GIR_EraseRootFromParent_Done,
     /* 2166496 */   // Label 28575: @2166496
     /* 2166496 */   GIM_Try, /*On fail goto*//*Label 28576*/ GIMT_Encode4(2166587), // Rule ID 18220 //
     /* 2166501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2166512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2166515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2166521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166547 */     // MIs[0] round
     /* 2166547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166550 */     // MIs[0] policy
     /* 2166550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166560 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2166563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166586 */     // GIR_Coverage, 18220,
     /* 2166586 */     GIR_EraseRootFromParent_Done,
     /* 2166587 */   // Label 28576: @2166587
     /* 2166587 */   GIM_Try, /*On fail goto*//*Label 28577*/ GIMT_Encode4(2166678), // Rule ID 18221 //
     /* 2166592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2166603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2166606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2166612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166638 */     // MIs[0] round
     /* 2166638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166641 */     // MIs[0] policy
     /* 2166641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166651 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2166654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166677 */     // GIR_Coverage, 18221,
     /* 2166677 */     GIR_EraseRootFromParent_Done,
     /* 2166678 */   // Label 28577: @2166678
     /* 2166678 */   GIM_Try, /*On fail goto*//*Label 28578*/ GIMT_Encode4(2166769), // Rule ID 18224 //
     /* 2166683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2166694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2166697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2166703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166729 */     // MIs[0] round
     /* 2166729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166732 */     // MIs[0] policy
     /* 2166732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166742 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2166745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166768 */     // GIR_Coverage, 18224,
     /* 2166768 */     GIR_EraseRootFromParent_Done,
     /* 2166769 */   // Label 28578: @2166769
     /* 2166769 */   GIM_Try, /*On fail goto*//*Label 28579*/ GIMT_Encode4(2166860), // Rule ID 18225 //
     /* 2166774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2166785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2166788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2166794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166820 */     // MIs[0] round
     /* 2166820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166823 */     // MIs[0] policy
     /* 2166823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166833 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2166836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166859 */     // GIR_Coverage, 18225,
     /* 2166859 */     GIR_EraseRootFromParent_Done,
     /* 2166860 */   // Label 28579: @2166860
     /* 2166860 */   GIM_Try, /*On fail goto*//*Label 28580*/ GIMT_Encode4(2166951), // Rule ID 18228 //
     /* 2166865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2166876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2166879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2166885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166911 */     // MIs[0] round
     /* 2166911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166914 */     // MIs[0] policy
     /* 2166914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166924 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2166927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166950 */     // GIR_Coverage, 18228,
     /* 2166950 */     GIR_EraseRootFromParent_Done,
     /* 2166951 */   // Label 28580: @2166951
     /* 2166951 */   GIM_Try, /*On fail goto*//*Label 28581*/ GIMT_Encode4(2167042), // Rule ID 18229 //
     /* 2166956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2166964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2166967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2166970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2166976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167002 */     // MIs[0] round
     /* 2167002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167005 */     // MIs[0] policy
     /* 2167005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167015 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2167018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167041 */     // GIR_Coverage, 18229,
     /* 2167041 */     GIR_EraseRootFromParent_Done,
     /* 2167042 */   // Label 28581: @2167042
     /* 2167042 */   GIM_Try, /*On fail goto*//*Label 28582*/ GIMT_Encode4(2167133), // Rule ID 18232 //
     /* 2167047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2167058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2167061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2167064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2167067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167093 */     // MIs[0] round
     /* 2167093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167096 */     // MIs[0] policy
     /* 2167096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167106 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2167109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167132 */     // GIR_Coverage, 18232,
     /* 2167132 */     GIR_EraseRootFromParent_Done,
     /* 2167133 */   // Label 28582: @2167133
     /* 2167133 */   GIM_Try, /*On fail goto*//*Label 28583*/ GIMT_Encode4(2167224), // Rule ID 18233 //
     /* 2167138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2167149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2167152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2167155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2167158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167184 */     // MIs[0] round
     /* 2167184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167187 */     // MIs[0] policy
     /* 2167187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167197 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2167200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167223 */     // GIR_Coverage, 18233,
     /* 2167223 */     GIR_EraseRootFromParent_Done,
     /* 2167224 */   // Label 28583: @2167224
     /* 2167224 */   GIM_Try, /*On fail goto*//*Label 28584*/ GIMT_Encode4(2167315), // Rule ID 18236 //
     /* 2167229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2167240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2167243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2167246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2167249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167275 */     // MIs[0] round
     /* 2167275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167278 */     // MIs[0] policy
     /* 2167278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167288 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2167291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167314 */     // GIR_Coverage, 18236,
     /* 2167314 */     GIR_EraseRootFromParent_Done,
     /* 2167315 */   // Label 28584: @2167315
     /* 2167315 */   GIM_Try, /*On fail goto*//*Label 28585*/ GIMT_Encode4(2167406), // Rule ID 18237 //
     /* 2167320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2167331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2167334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2167337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2167340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167366 */     // MIs[0] round
     /* 2167366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167369 */     // MIs[0] policy
     /* 2167369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167379 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2167382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167405 */     // GIR_Coverage, 18237,
     /* 2167405 */     GIR_EraseRootFromParent_Done,
     /* 2167406 */   // Label 28585: @2167406
     /* 2167406 */   GIM_Try, /*On fail goto*//*Label 28586*/ GIMT_Encode4(2167497), // Rule ID 18240 //
     /* 2167411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167457 */     // MIs[0] round
     /* 2167457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167460 */     // MIs[0] policy
     /* 2167460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167470 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2167473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167496 */     // GIR_Coverage, 18240,
     /* 2167496 */     GIR_EraseRootFromParent_Done,
     /* 2167497 */   // Label 28586: @2167497
     /* 2167497 */   GIM_Try, /*On fail goto*//*Label 28587*/ GIMT_Encode4(2167588), // Rule ID 18241 //
     /* 2167502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167548 */     // MIs[0] round
     /* 2167548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167551 */     // MIs[0] policy
     /* 2167551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167561 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2167564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167587 */     // GIR_Coverage, 18241,
     /* 2167587 */     GIR_EraseRootFromParent_Done,
     /* 2167588 */   // Label 28587: @2167588
     /* 2167588 */   GIM_Try, /*On fail goto*//*Label 28588*/ GIMT_Encode4(2167679), // Rule ID 18244 //
     /* 2167593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2167604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2167607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2167610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2167613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167639 */     // MIs[0] round
     /* 2167639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167642 */     // MIs[0] policy
     /* 2167642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167652 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2167655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167678 */     // GIR_Coverage, 18244,
     /* 2167678 */     GIR_EraseRootFromParent_Done,
     /* 2167679 */   // Label 28588: @2167679
     /* 2167679 */   GIM_Try, /*On fail goto*//*Label 28589*/ GIMT_Encode4(2167770), // Rule ID 18245 //
     /* 2167684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2167695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2167698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2167701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2167704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167730 */     // MIs[0] round
     /* 2167730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167733 */     // MIs[0] policy
     /* 2167733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167743 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2167746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167769 */     // GIR_Coverage, 18245,
     /* 2167769 */     GIR_EraseRootFromParent_Done,
     /* 2167770 */   // Label 28589: @2167770
     /* 2167770 */   GIM_Try, /*On fail goto*//*Label 28590*/ GIMT_Encode4(2167861), // Rule ID 18248 //
     /* 2167775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2167786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2167789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2167792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2167795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167821 */     // MIs[0] round
     /* 2167821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167824 */     // MIs[0] policy
     /* 2167824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167834 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2167837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167860 */     // GIR_Coverage, 18248,
     /* 2167860 */     GIR_EraseRootFromParent_Done,
     /* 2167861 */   // Label 28590: @2167861
     /* 2167861 */   GIM_Try, /*On fail goto*//*Label 28591*/ GIMT_Encode4(2167952), // Rule ID 18249 //
     /* 2167866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2167877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2167880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2167883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2167886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167912 */     // MIs[0] round
     /* 2167912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167915 */     // MIs[0] policy
     /* 2167915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167925 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2167928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167951 */     // GIR_Coverage, 18249,
     /* 2167951 */     GIR_EraseRootFromParent_Done,
     /* 2167952 */   // Label 28591: @2167952
     /* 2167952 */   GIM_Try, /*On fail goto*//*Label 28592*/ GIMT_Encode4(2168043), // Rule ID 18252 //
     /* 2167957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2167965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2167968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2167971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2167974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2167977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168003 */     // MIs[0] round
     /* 2168003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168006 */     // MIs[0] policy
     /* 2168006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168016 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2168019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168042 */     // GIR_Coverage, 18252,
     /* 2168042 */     GIR_EraseRootFromParent_Done,
     /* 2168043 */   // Label 28592: @2168043
     /* 2168043 */   GIM_Try, /*On fail goto*//*Label 28593*/ GIMT_Encode4(2168134), // Rule ID 18253 //
     /* 2168048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2168051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2168059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2168062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2168065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2168068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2168071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2168078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2168090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168094 */     // MIs[0] round
     /* 2168094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168097 */     // MIs[0] policy
     /* 2168097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168107 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2168110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2168130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168133 */     // GIR_Coverage, 18253,
     /* 2168133 */     GIR_EraseRootFromParent_Done,
     /* 2168134 */   // Label 28593: @2168134
     /* 2168134 */   GIM_Try, /*On fail goto*//*Label 28594*/ GIMT_Encode4(2168225), // Rule ID 18256 //
     /* 2168139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2168150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2168153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2168156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2168159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168185 */     // MIs[0] round
     /* 2168185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168188 */     // MIs[0] policy
     /* 2168188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168198 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2168201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168224 */     // GIR_Coverage, 18256,
     /* 2168224 */     GIR_EraseRootFromParent_Done,
     /* 2168225 */   // Label 28594: @2168225
     /* 2168225 */   GIM_Try, /*On fail goto*//*Label 28595*/ GIMT_Encode4(2168316), // Rule ID 18257 //
     /* 2168230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2168241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2168244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2168247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2168250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168276 */     // MIs[0] round
     /* 2168276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168279 */     // MIs[0] policy
     /* 2168279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168289 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2168292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168315 */     // GIR_Coverage, 18257,
     /* 2168315 */     GIR_EraseRootFromParent_Done,
     /* 2168316 */   // Label 28595: @2168316
     /* 2168316 */   GIM_Try, /*On fail goto*//*Label 28596*/ GIMT_Encode4(2168407), // Rule ID 18260 //
     /* 2168321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168367 */     // MIs[0] round
     /* 2168367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168370 */     // MIs[0] policy
     /* 2168370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168380 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2168383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168406 */     // GIR_Coverage, 18260,
     /* 2168406 */     GIR_EraseRootFromParent_Done,
     /* 2168407 */   // Label 28596: @2168407
     /* 2168407 */   GIM_Try, /*On fail goto*//*Label 28597*/ GIMT_Encode4(2168498), // Rule ID 18261 //
     /* 2168412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168458 */     // MIs[0] round
     /* 2168458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168461 */     // MIs[0] policy
     /* 2168461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168471 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2168474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168497 */     // GIR_Coverage, 18261,
     /* 2168497 */     GIR_EraseRootFromParent_Done,
     /* 2168498 */   // Label 28597: @2168498
     /* 2168498 */   GIM_Try, /*On fail goto*//*Label 28598*/ GIMT_Encode4(2168589), // Rule ID 18264 //
     /* 2168503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2168514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2168517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2168520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2168523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2168526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168549 */     // MIs[0] round
     /* 2168549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168552 */     // MIs[0] policy
     /* 2168552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168562 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2168565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168588 */     // GIR_Coverage, 18264,
     /* 2168588 */     GIR_EraseRootFromParent_Done,
     /* 2168589 */   // Label 28598: @2168589
     /* 2168589 */   GIM_Try, /*On fail goto*//*Label 28599*/ GIMT_Encode4(2168680), // Rule ID 18265 //
     /* 2168594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2168605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2168608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2168611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2168614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2168617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168640 */     // MIs[0] round
     /* 2168640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168643 */     // MIs[0] policy
     /* 2168643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168653 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2168656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168679 */     // GIR_Coverage, 18265,
     /* 2168679 */     GIR_EraseRootFromParent_Done,
     /* 2168680 */   // Label 28599: @2168680
     /* 2168680 */   GIM_Try, /*On fail goto*//*Label 28600*/ GIMT_Encode4(2168771), // Rule ID 18268 //
     /* 2168685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2168696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2168699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2168702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2168705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168731 */     // MIs[0] round
     /* 2168731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168734 */     // MIs[0] policy
     /* 2168734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168744 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2168747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168770 */     // GIR_Coverage, 18268,
     /* 2168770 */     GIR_EraseRootFromParent_Done,
     /* 2168771 */   // Label 28600: @2168771
     /* 2168771 */   GIM_Try, /*On fail goto*//*Label 28601*/ GIMT_Encode4(2168862), // Rule ID 18269 //
     /* 2168776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2168787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2168790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2168793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2168796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168822 */     // MIs[0] round
     /* 2168822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168825 */     // MIs[0] policy
     /* 2168825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168835 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2168838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168861 */     // GIR_Coverage, 18269,
     /* 2168861 */     GIR_EraseRootFromParent_Done,
     /* 2168862 */   // Label 28601: @2168862
     /* 2168862 */   GIM_Try, /*On fail goto*//*Label 28602*/ GIMT_Encode4(2168953), // Rule ID 18272 //
     /* 2168867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2168878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2168881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2168884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2168887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168913 */     // MIs[0] round
     /* 2168913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168916 */     // MIs[0] policy
     /* 2168916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168926 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2168929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168952 */     // GIR_Coverage, 18272,
     /* 2168952 */     GIR_EraseRootFromParent_Done,
     /* 2168953 */   // Label 28602: @2168953
     /* 2168953 */   GIM_Try, /*On fail goto*//*Label 28603*/ GIMT_Encode4(2169044), // Rule ID 18273 //
     /* 2168958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2168966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2168969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2168972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2168975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2168978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169004 */     // MIs[0] round
     /* 2169004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169007 */     // MIs[0] policy
     /* 2169007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169017 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2169020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169043 */     // GIR_Coverage, 18273,
     /* 2169043 */     GIR_EraseRootFromParent_Done,
     /* 2169044 */   // Label 28603: @2169044
     /* 2169044 */   GIM_Try, /*On fail goto*//*Label 28604*/ GIMT_Encode4(2169135), // Rule ID 18276 //
     /* 2169049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2169060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2169063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2169066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2169069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169095 */     // MIs[0] round
     /* 2169095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169098 */     // MIs[0] policy
     /* 2169098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169108 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2169111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169134 */     // GIR_Coverage, 18276,
     /* 2169134 */     GIR_EraseRootFromParent_Done,
     /* 2169135 */   // Label 28604: @2169135
     /* 2169135 */   GIM_Try, /*On fail goto*//*Label 28605*/ GIMT_Encode4(2169226), // Rule ID 18277 //
     /* 2169140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2169151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2169154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2169157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2169160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2169163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169186 */     // MIs[0] round
     /* 2169186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169189 */     // MIs[0] policy
     /* 2169189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169199 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2169202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169225 */     // GIR_Coverage, 18277,
     /* 2169225 */     GIR_EraseRootFromParent_Done,
     /* 2169226 */   // Label 28605: @2169226
     /* 2169226 */   GIM_Try, /*On fail goto*//*Label 28606*/ GIMT_Encode4(2169317), // Rule ID 18280 //
     /* 2169231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2169242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2169245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2169248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2169251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169277 */     // MIs[0] round
     /* 2169277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169280 */     // MIs[0] policy
     /* 2169280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169290 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2169293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169316 */     // GIR_Coverage, 18280,
     /* 2169316 */     GIR_EraseRootFromParent_Done,
     /* 2169317 */   // Label 28606: @2169317
     /* 2169317 */   GIM_Try, /*On fail goto*//*Label 28607*/ GIMT_Encode4(2169408), // Rule ID 18281 //
     /* 2169322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2169333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2169336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2169339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2169342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169368 */     // MIs[0] round
     /* 2169368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169371 */     // MIs[0] policy
     /* 2169371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169381 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2169384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169407 */     // GIR_Coverage, 18281,
     /* 2169407 */     GIR_EraseRootFromParent_Done,
     /* 2169408 */   // Label 28607: @2169408
     /* 2169408 */   GIM_Try, /*On fail goto*//*Label 28608*/ GIMT_Encode4(2169499), // Rule ID 18284 //
     /* 2169413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169459 */     // MIs[0] round
     /* 2169459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169462 */     // MIs[0] policy
     /* 2169462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169472 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2169475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169498 */     // GIR_Coverage, 18284,
     /* 2169498 */     GIR_EraseRootFromParent_Done,
     /* 2169499 */   // Label 28608: @2169499
     /* 2169499 */   GIM_Try, /*On fail goto*//*Label 28609*/ GIMT_Encode4(2169590), // Rule ID 18285 //
     /* 2169504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169550 */     // MIs[0] round
     /* 2169550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169553 */     // MIs[0] policy
     /* 2169553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169563 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2169566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169589 */     // GIR_Coverage, 18285,
     /* 2169589 */     GIR_EraseRootFromParent_Done,
     /* 2169590 */   // Label 28609: @2169590
     /* 2169590 */   GIM_Try, /*On fail goto*//*Label 28610*/ GIMT_Encode4(2169681), // Rule ID 18288 //
     /* 2169595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2169606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2169609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2169612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2169615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169641 */     // MIs[0] round
     /* 2169641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169644 */     // MIs[0] policy
     /* 2169644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169654 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2169657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169680 */     // GIR_Coverage, 18288,
     /* 2169680 */     GIR_EraseRootFromParent_Done,
     /* 2169681 */   // Label 28610: @2169681
     /* 2169681 */   GIM_Try, /*On fail goto*//*Label 28611*/ GIMT_Encode4(2169772), // Rule ID 18289 //
     /* 2169686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2169697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2169700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2169703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2169706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169732 */     // MIs[0] round
     /* 2169732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169735 */     // MIs[0] policy
     /* 2169735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169745 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2169748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169771 */     // GIR_Coverage, 18289,
     /* 2169771 */     GIR_EraseRootFromParent_Done,
     /* 2169772 */   // Label 28611: @2169772
     /* 2169772 */   GIM_Try, /*On fail goto*//*Label 28612*/ GIMT_Encode4(2169863), // Rule ID 18292 //
     /* 2169777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2169788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2169791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2169797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169823 */     // MIs[0] round
     /* 2169823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169826 */     // MIs[0] policy
     /* 2169826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169836 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2169839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169862 */     // GIR_Coverage, 18292,
     /* 2169862 */     GIR_EraseRootFromParent_Done,
     /* 2169863 */   // Label 28612: @2169863
     /* 2169863 */   GIM_Try, /*On fail goto*//*Label 28613*/ GIMT_Encode4(2169954), // Rule ID 18293 //
     /* 2169868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2169879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2169882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2169888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169914 */     // MIs[0] round
     /* 2169914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169917 */     // MIs[0] policy
     /* 2169917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169927 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2169930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169953 */     // GIR_Coverage, 18293,
     /* 2169953 */     GIR_EraseRootFromParent_Done,
     /* 2169954 */   // Label 28613: @2169954
     /* 2169954 */   GIM_Try, /*On fail goto*//*Label 28614*/ GIMT_Encode4(2170045), // Rule ID 18296 //
     /* 2169959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2169967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2169970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2169973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2169979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170005 */     // MIs[0] round
     /* 2170005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170008 */     // MIs[0] policy
     /* 2170008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170018 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2170021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170044 */     // GIR_Coverage, 18296,
     /* 2170044 */     GIR_EraseRootFromParent_Done,
     /* 2170045 */   // Label 28614: @2170045
     /* 2170045 */   GIM_Try, /*On fail goto*//*Label 28615*/ GIMT_Encode4(2170136), // Rule ID 18297 //
     /* 2170050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2170061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2170064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2170070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170096 */     // MIs[0] round
     /* 2170096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170099 */     // MIs[0] policy
     /* 2170099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170109 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2170112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170135 */     // GIR_Coverage, 18297,
     /* 2170135 */     GIR_EraseRootFromParent_Done,
     /* 2170136 */   // Label 28615: @2170136
     /* 2170136 */   GIM_Try, /*On fail goto*//*Label 28616*/ GIMT_Encode4(2170227), // Rule ID 18300 //
     /* 2170141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2170152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2170155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2170161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170187 */     // MIs[0] round
     /* 2170187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170190 */     // MIs[0] policy
     /* 2170190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170200 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2170203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170226 */     // GIR_Coverage, 18300,
     /* 2170226 */     GIR_EraseRootFromParent_Done,
     /* 2170227 */   // Label 28616: @2170227
     /* 2170227 */   GIM_Try, /*On fail goto*//*Label 28617*/ GIMT_Encode4(2170318), // Rule ID 18301 //
     /* 2170232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2170243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2170246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2170252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170278 */     // MIs[0] round
     /* 2170278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170281 */     // MIs[0] policy
     /* 2170281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170291 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2170294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170317 */     // GIR_Coverage, 18301,
     /* 2170317 */     GIR_EraseRootFromParent_Done,
     /* 2170318 */   // Label 28617: @2170318
     /* 2170318 */   GIM_Try, /*On fail goto*//*Label 28618*/ GIMT_Encode4(2170409), // Rule ID 18304 //
     /* 2170323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170369 */     // MIs[0] round
     /* 2170369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170372 */     // MIs[0] policy
     /* 2170372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170382 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2170385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170408 */     // GIR_Coverage, 18304,
     /* 2170408 */     GIR_EraseRootFromParent_Done,
     /* 2170409 */   // Label 28618: @2170409
     /* 2170409 */   GIM_Try, /*On fail goto*//*Label 28619*/ GIMT_Encode4(2170500), // Rule ID 18305 //
     /* 2170414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170460 */     // MIs[0] round
     /* 2170460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170463 */     // MIs[0] policy
     /* 2170463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170473 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2170476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170499 */     // GIR_Coverage, 18305,
     /* 2170499 */     GIR_EraseRootFromParent_Done,
     /* 2170500 */   // Label 28619: @2170500
     /* 2170500 */   GIM_Try, /*On fail goto*//*Label 28620*/ GIMT_Encode4(2170591), // Rule ID 18308 //
     /* 2170505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2170516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2170519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2170525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170551 */     // MIs[0] round
     /* 2170551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170554 */     // MIs[0] policy
     /* 2170554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170564 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2170567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170590 */     // GIR_Coverage, 18308,
     /* 2170590 */     GIR_EraseRootFromParent_Done,
     /* 2170591 */   // Label 28620: @2170591
     /* 2170591 */   GIM_Try, /*On fail goto*//*Label 28621*/ GIMT_Encode4(2170682), // Rule ID 18309 //
     /* 2170596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2170607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2170610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2170616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170642 */     // MIs[0] round
     /* 2170642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170645 */     // MIs[0] policy
     /* 2170645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170655 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2170658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170681 */     // GIR_Coverage, 18309,
     /* 2170681 */     GIR_EraseRootFromParent_Done,
     /* 2170682 */   // Label 28621: @2170682
     /* 2170682 */   GIM_Try, /*On fail goto*//*Label 28622*/ GIMT_Encode4(2170773), // Rule ID 18312 //
     /* 2170687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2170698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2170701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2170707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170733 */     // MIs[0] round
     /* 2170733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170736 */     // MIs[0] policy
     /* 2170736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170746 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2170749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170772 */     // GIR_Coverage, 18312,
     /* 2170772 */     GIR_EraseRootFromParent_Done,
     /* 2170773 */   // Label 28622: @2170773
     /* 2170773 */   GIM_Try, /*On fail goto*//*Label 28623*/ GIMT_Encode4(2170864), // Rule ID 18313 //
     /* 2170778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2170789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2170792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2170798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170824 */     // MIs[0] round
     /* 2170824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170827 */     // MIs[0] policy
     /* 2170827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170837 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2170840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170863 */     // GIR_Coverage, 18313,
     /* 2170863 */     GIR_EraseRootFromParent_Done,
     /* 2170864 */   // Label 28623: @2170864
     /* 2170864 */   GIM_Try, /*On fail goto*//*Label 28624*/ GIMT_Encode4(2170955), // Rule ID 18316 //
     /* 2170869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2170880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2170883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2170889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170915 */     // MIs[0] round
     /* 2170915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170918 */     // MIs[0] policy
     /* 2170918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170928 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2170931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170954 */     // GIR_Coverage, 18316,
     /* 2170954 */     GIR_EraseRootFromParent_Done,
     /* 2170955 */   // Label 28624: @2170955
     /* 2170955 */   GIM_Try, /*On fail goto*//*Label 28625*/ GIMT_Encode4(2171046), // Rule ID 18317 //
     /* 2170960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2170968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2170971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2170974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2170980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171006 */     // MIs[0] round
     /* 2171006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171009 */     // MIs[0] policy
     /* 2171009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171019 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2171022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171045 */     // GIR_Coverage, 18317,
     /* 2171045 */     GIR_EraseRootFromParent_Done,
     /* 2171046 */   // Label 28625: @2171046
     /* 2171046 */   GIM_Try, /*On fail goto*//*Label 28626*/ GIMT_Encode4(2171137), // Rule ID 18320 //
     /* 2171051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2171062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2171065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2171071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171097 */     // MIs[0] round
     /* 2171097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171100 */     // MIs[0] policy
     /* 2171100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171110 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2171113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171136 */     // GIR_Coverage, 18320,
     /* 2171136 */     GIR_EraseRootFromParent_Done,
     /* 2171137 */   // Label 28626: @2171137
     /* 2171137 */   GIM_Try, /*On fail goto*//*Label 28627*/ GIMT_Encode4(2171228), // Rule ID 18321 //
     /* 2171142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2171153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2171156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2171162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171188 */     // MIs[0] round
     /* 2171188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171191 */     // MIs[0] policy
     /* 2171191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171201 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2171204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171227 */     // GIR_Coverage, 18321,
     /* 2171227 */     GIR_EraseRootFromParent_Done,
     /* 2171228 */   // Label 28627: @2171228
     /* 2171228 */   GIM_Try, /*On fail goto*//*Label 28628*/ GIMT_Encode4(2171319), // Rule ID 18324 //
     /* 2171233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2171236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2171244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2171247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2171253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2171256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171279 */     // MIs[0] round
     /* 2171279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171282 */     // MIs[0] policy
     /* 2171282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171292 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2171295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171318 */     // GIR_Coverage, 18324,
     /* 2171318 */     GIR_EraseRootFromParent_Done,
     /* 2171319 */   // Label 28628: @2171319
     /* 2171319 */   GIM_Try, /*On fail goto*//*Label 28629*/ GIMT_Encode4(2171410), // Rule ID 18325 //
     /* 2171324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2171335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2171338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2171344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2171347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171370 */     // MIs[0] round
     /* 2171370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171373 */     // MIs[0] policy
     /* 2171373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171383 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2171386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171409 */     // GIR_Coverage, 18325,
     /* 2171409 */     GIR_EraseRootFromParent_Done,
     /* 2171410 */   // Label 28629: @2171410
     /* 2171410 */   GIM_Try, /*On fail goto*//*Label 28630*/ GIMT_Encode4(2171501), // Rule ID 18328 //
     /* 2171415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2171435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171461 */     // MIs[0] round
     /* 2171461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171464 */     // MIs[0] policy
     /* 2171464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2171477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171500 */     // GIR_Coverage, 18328,
     /* 2171500 */     GIR_EraseRootFromParent_Done,
     /* 2171501 */   // Label 28630: @2171501
     /* 2171501 */   GIM_Try, /*On fail goto*//*Label 28631*/ GIMT_Encode4(2171592), // Rule ID 18329 //
     /* 2171506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2171526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171552 */     // MIs[0] round
     /* 2171552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171555 */     // MIs[0] policy
     /* 2171555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171565 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2171568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171591 */     // GIR_Coverage, 18329,
     /* 2171591 */     GIR_EraseRootFromParent_Done,
     /* 2171592 */   // Label 28631: @2171592
     /* 2171592 */   GIM_Try, /*On fail goto*//*Label 28632*/ GIMT_Encode4(2171683), // Rule ID 18332 //
     /* 2171597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2171608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2171611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2171617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171643 */     // MIs[0] round
     /* 2171643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171646 */     // MIs[0] policy
     /* 2171646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171656 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2171659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171682 */     // GIR_Coverage, 18332,
     /* 2171682 */     GIR_EraseRootFromParent_Done,
     /* 2171683 */   // Label 28632: @2171683
     /* 2171683 */   GIM_Try, /*On fail goto*//*Label 28633*/ GIMT_Encode4(2171774), // Rule ID 18333 //
     /* 2171688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2171699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2171702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2171708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171734 */     // MIs[0] round
     /* 2171734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171737 */     // MIs[0] policy
     /* 2171737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171747 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2171750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171773 */     // GIR_Coverage, 18333,
     /* 2171773 */     GIR_EraseRootFromParent_Done,
     /* 2171774 */   // Label 28633: @2171774
     /* 2171774 */   GIM_Try, /*On fail goto*//*Label 28634*/ GIMT_Encode4(2171865), // Rule ID 18336 //
     /* 2171779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2171790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2171793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2171799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171825 */     // MIs[0] round
     /* 2171825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171828 */     // MIs[0] policy
     /* 2171828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171838 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2171841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171864 */     // GIR_Coverage, 18336,
     /* 2171864 */     GIR_EraseRootFromParent_Done,
     /* 2171865 */   // Label 28634: @2171865
     /* 2171865 */   GIM_Try, /*On fail goto*//*Label 28635*/ GIMT_Encode4(2171956), // Rule ID 18337 //
     /* 2171870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2171881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2171884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2171890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171916 */     // MIs[0] round
     /* 2171916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171919 */     // MIs[0] policy
     /* 2171919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171929 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2171932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171955 */     // GIR_Coverage, 18337,
     /* 2171955 */     GIR_EraseRootFromParent_Done,
     /* 2171956 */   // Label 28635: @2171956
     /* 2171956 */   GIM_Try, /*On fail goto*//*Label 28636*/ GIMT_Encode4(2172047), // Rule ID 18340 //
     /* 2171961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2171964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2171969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2171972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2171975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2171981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172007 */     // MIs[0] round
     /* 2172007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172010 */     // MIs[0] policy
     /* 2172010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172020 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2172023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172046 */     // GIR_Coverage, 18340,
     /* 2172046 */     GIR_EraseRootFromParent_Done,
     /* 2172047 */   // Label 28636: @2172047
     /* 2172047 */   GIM_Try, /*On fail goto*//*Label 28637*/ GIMT_Encode4(2172138), // Rule ID 18341 //
     /* 2172052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2172063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2172066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2172072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2172082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2172094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172098 */     // MIs[0] round
     /* 2172098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172101 */     // MIs[0] policy
     /* 2172101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172111 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2172114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172137 */     // GIR_Coverage, 18341,
     /* 2172137 */     GIR_EraseRootFromParent_Done,
     /* 2172138 */   // Label 28637: @2172138
     /* 2172138 */   GIM_Try, /*On fail goto*//*Label 28638*/ GIMT_Encode4(2172229), // Rule ID 18344 //
     /* 2172143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2172154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2172157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2172163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172189 */     // MIs[0] round
     /* 2172189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172192 */     // MIs[0] policy
     /* 2172192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172202 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2172205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172228 */     // GIR_Coverage, 18344,
     /* 2172228 */     GIR_EraseRootFromParent_Done,
     /* 2172229 */   // Label 28638: @2172229
     /* 2172229 */   GIM_Try, /*On fail goto*//*Label 28639*/ GIMT_Encode4(2172320), // Rule ID 18345 //
     /* 2172234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2172245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2172248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2172254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2172264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2172276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172280 */     // MIs[0] round
     /* 2172280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172283 */     // MIs[0] policy
     /* 2172283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172293 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2172296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172319 */     // GIR_Coverage, 18345,
     /* 2172319 */     GIR_EraseRootFromParent_Done,
     /* 2172320 */   // Label 28639: @2172320
     /* 2172320 */   GIM_Try, /*On fail goto*//*Label 28640*/ GIMT_Encode4(2172411), // Rule ID 18348 //
     /* 2172325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172371 */     // MIs[0] round
     /* 2172371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172374 */     // MIs[0] policy
     /* 2172374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172384 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2172387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172410 */     // GIR_Coverage, 18348,
     /* 2172410 */     GIR_EraseRootFromParent_Done,
     /* 2172411 */   // Label 28640: @2172411
     /* 2172411 */   GIM_Try, /*On fail goto*//*Label 28641*/ GIMT_Encode4(2172502), // Rule ID 18349 //
     /* 2172416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2172424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172462 */     // MIs[0] round
     /* 2172462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172465 */     // MIs[0] policy
     /* 2172465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172475 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2172478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172501 */     // GIR_Coverage, 18349,
     /* 2172501 */     GIR_EraseRootFromParent_Done,
     /* 2172502 */   // Label 28641: @2172502
     /* 2172502 */   GIM_Try, /*On fail goto*//*Label 28642*/ GIMT_Encode4(2172593), // Rule ID 18352 //
     /* 2172507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2172518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2172521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2172524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2172527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172553 */     // MIs[0] round
     /* 2172553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172556 */     // MIs[0] policy
     /* 2172556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172566 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2172569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172592 */     // GIR_Coverage, 18352,
     /* 2172592 */     GIR_EraseRootFromParent_Done,
     /* 2172593 */   // Label 28642: @2172593
     /* 2172593 */   GIM_Try, /*On fail goto*//*Label 28643*/ GIMT_Encode4(2172684), // Rule ID 18353 //
     /* 2172598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2172609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2172612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2172615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2172618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172644 */     // MIs[0] round
     /* 2172644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172647 */     // MIs[0] policy
     /* 2172647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172657 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2172660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172683 */     // GIR_Coverage, 18353,
     /* 2172683 */     GIR_EraseRootFromParent_Done,
     /* 2172684 */   // Label 28643: @2172684
     /* 2172684 */   GIM_Try, /*On fail goto*//*Label 28644*/ GIMT_Encode4(2172775), // Rule ID 18356 //
     /* 2172689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2172700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2172703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2172706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2172709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172735 */     // MIs[0] round
     /* 2172735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172738 */     // MIs[0] policy
     /* 2172738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172748 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2172751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172774 */     // GIR_Coverage, 18356,
     /* 2172774 */     GIR_EraseRootFromParent_Done,
     /* 2172775 */   // Label 28644: @2172775
     /* 2172775 */   GIM_Try, /*On fail goto*//*Label 28645*/ GIMT_Encode4(2172866), // Rule ID 18357 //
     /* 2172780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2172791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2172794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2172797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2172800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172826 */     // MIs[0] round
     /* 2172826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172829 */     // MIs[0] policy
     /* 2172829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172839 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2172842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172865 */     // GIR_Coverage, 18357,
     /* 2172865 */     GIR_EraseRootFromParent_Done,
     /* 2172866 */   // Label 28645: @2172866
     /* 2172866 */   GIM_Try, /*On fail goto*//*Label 28646*/ GIMT_Encode4(2172957), // Rule ID 18360 //
     /* 2172871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2172882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2172885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2172888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2172891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172917 */     // MIs[0] round
     /* 2172917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172920 */     // MIs[0] policy
     /* 2172920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172930 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2172933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172956 */     // GIR_Coverage, 18360,
     /* 2172956 */     GIR_EraseRootFromParent_Done,
     /* 2172957 */   // Label 28646: @2172957
     /* 2172957 */   GIM_Try, /*On fail goto*//*Label 28647*/ GIMT_Encode4(2173048), // Rule ID 18361 //
     /* 2172962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2172970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2172973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2172976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2172979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2172982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173008 */     // MIs[0] round
     /* 2173008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173011 */     // MIs[0] policy
     /* 2173011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173021 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2173024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173047 */     // GIR_Coverage, 18361,
     /* 2173047 */     GIR_EraseRootFromParent_Done,
     /* 2173048 */   // Label 28647: @2173048
     /* 2173048 */   GIM_Try, /*On fail goto*//*Label 28648*/ GIMT_Encode4(2173139), // Rule ID 18364 //
     /* 2173053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2173064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2173067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2173070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2173073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173099 */     // MIs[0] round
     /* 2173099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173102 */     // MIs[0] policy
     /* 2173102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173112 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2173115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173138 */     // GIR_Coverage, 18364,
     /* 2173138 */     GIR_EraseRootFromParent_Done,
     /* 2173139 */   // Label 28648: @2173139
     /* 2173139 */   GIM_Try, /*On fail goto*//*Label 28649*/ GIMT_Encode4(2173230), // Rule ID 18365 //
     /* 2173144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2173155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2173158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2173161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2173164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173190 */     // MIs[0] round
     /* 2173190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173193 */     // MIs[0] policy
     /* 2173193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173203 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2173206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173229 */     // GIR_Coverage, 18365,
     /* 2173229 */     GIR_EraseRootFromParent_Done,
     /* 2173230 */   // Label 28649: @2173230
     /* 2173230 */   GIM_Try, /*On fail goto*//*Label 28650*/ GIMT_Encode4(2173321), // Rule ID 18368 //
     /* 2173235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2173238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2173246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2173252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2173255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173281 */     // MIs[0] round
     /* 2173281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173284 */     // MIs[0] policy
     /* 2173284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173294 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2173297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173320 */     // GIR_Coverage, 18368,
     /* 2173320 */     GIR_EraseRootFromParent_Done,
     /* 2173321 */   // Label 28650: @2173321
     /* 2173321 */   GIM_Try, /*On fail goto*//*Label 28651*/ GIMT_Encode4(2173412), // Rule ID 18369 //
     /* 2173326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2173337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2173343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2173346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173372 */     // MIs[0] round
     /* 2173372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173375 */     // MIs[0] policy
     /* 2173375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173385 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2173388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173411 */     // GIR_Coverage, 18369,
     /* 2173411 */     GIR_EraseRootFromParent_Done,
     /* 2173412 */   // Label 28651: @2173412
     /* 2173412 */   GIM_Try, /*On fail goto*//*Label 28652*/ GIMT_Encode4(2173503), // Rule ID 18372 //
     /* 2173417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2173437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173463 */     // MIs[0] round
     /* 2173463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173466 */     // MIs[0] policy
     /* 2173466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173476 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2173479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173502 */     // GIR_Coverage, 18372,
     /* 2173502 */     GIR_EraseRootFromParent_Done,
     /* 2173503 */   // Label 28652: @2173503
     /* 2173503 */   GIM_Try, /*On fail goto*//*Label 28653*/ GIMT_Encode4(2173594), // Rule ID 18373 //
     /* 2173508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2173528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173554 */     // MIs[0] round
     /* 2173554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173557 */     // MIs[0] policy
     /* 2173557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173567 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2173570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173593 */     // GIR_Coverage, 18373,
     /* 2173593 */     GIR_EraseRootFromParent_Done,
     /* 2173594 */   // Label 28653: @2173594
     /* 2173594 */   GIM_Try, /*On fail goto*//*Label 28654*/ GIMT_Encode4(2173685), // Rule ID 18376 //
     /* 2173599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2173610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2173613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2173616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2173619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173645 */     // MIs[0] round
     /* 2173645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173648 */     // MIs[0] policy
     /* 2173648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173658 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2173661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173684 */     // GIR_Coverage, 18376,
     /* 2173684 */     GIR_EraseRootFromParent_Done,
     /* 2173685 */   // Label 28654: @2173685
     /* 2173685 */   GIM_Try, /*On fail goto*//*Label 28655*/ GIMT_Encode4(2173776), // Rule ID 18377 //
     /* 2173690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2173701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2173704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2173707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2173710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173736 */     // MIs[0] round
     /* 2173736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173739 */     // MIs[0] policy
     /* 2173739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173749 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2173752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173775 */     // GIR_Coverage, 18377,
     /* 2173775 */     GIR_EraseRootFromParent_Done,
     /* 2173776 */   // Label 28655: @2173776
     /* 2173776 */   GIM_Try, /*On fail goto*//*Label 28656*/ GIMT_Encode4(2173867), // Rule ID 18380 //
     /* 2173781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2173792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2173795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2173798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2173801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2173804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173827 */     // MIs[0] round
     /* 2173827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173830 */     // MIs[0] policy
     /* 2173830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173840 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2173843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173866 */     // GIR_Coverage, 18380,
     /* 2173866 */     GIR_EraseRootFromParent_Done,
     /* 2173867 */   // Label 28656: @2173867
     /* 2173867 */   GIM_Try, /*On fail goto*//*Label 28657*/ GIMT_Encode4(2173958), // Rule ID 18381 //
     /* 2173872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2173883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2173886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2173889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2173892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2173895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173918 */     // MIs[0] round
     /* 2173918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173921 */     // MIs[0] policy
     /* 2173921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173931 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2173934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173957 */     // GIR_Coverage, 18381,
     /* 2173957 */     GIR_EraseRootFromParent_Done,
     /* 2173958 */   // Label 28657: @2173958
     /* 2173958 */   GIM_Try, /*On fail goto*//*Label 28658*/ GIMT_Encode4(2174049), // Rule ID 18384 //
     /* 2173963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2173971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2173974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2173977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2173980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2173983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2173986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174009 */     // MIs[0] round
     /* 2174009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174012 */     // MIs[0] policy
     /* 2174012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174022 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2174025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174048 */     // GIR_Coverage, 18384,
     /* 2174048 */     GIR_EraseRootFromParent_Done,
     /* 2174049 */   // Label 28658: @2174049
     /* 2174049 */   GIM_Try, /*On fail goto*//*Label 28659*/ GIMT_Encode4(2174140), // Rule ID 18385 //
     /* 2174054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2174057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2174065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2174068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2174071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2174074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2174077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174100 */     // MIs[0] round
     /* 2174100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174103 */     // MIs[0] policy
     /* 2174103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174113 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2174116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2174136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174139 */     // GIR_Coverage, 18385,
     /* 2174139 */     GIR_EraseRootFromParent_Done,
     /* 2174140 */   // Label 28659: @2174140
     /* 2174140 */   GIM_Try, /*On fail goto*//*Label 28660*/ GIMT_Encode4(2174231), // Rule ID 18388 //
     /* 2174145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2174156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2174159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2174162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2174165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174191 */     // MIs[0] round
     /* 2174191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174194 */     // MIs[0] policy
     /* 2174194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174204 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2174207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174230 */     // GIR_Coverage, 18388,
     /* 2174230 */     GIR_EraseRootFromParent_Done,
     /* 2174231 */   // Label 28660: @2174231
     /* 2174231 */   GIM_Try, /*On fail goto*//*Label 28661*/ GIMT_Encode4(2174322), // Rule ID 18389 //
     /* 2174236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2174247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2174250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2174253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2174256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174282 */     // MIs[0] round
     /* 2174282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174285 */     // MIs[0] policy
     /* 2174285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174295 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2174298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174321 */     // GIR_Coverage, 18389,
     /* 2174321 */     GIR_EraseRootFromParent_Done,
     /* 2174322 */   // Label 28661: @2174322
     /* 2174322 */   GIM_Try, /*On fail goto*//*Label 28662*/ GIMT_Encode4(2174413), // Rule ID 18392 //
     /* 2174327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174373 */     // MIs[0] round
     /* 2174373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174376 */     // MIs[0] policy
     /* 2174376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174386 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2174389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174412 */     // GIR_Coverage, 18392,
     /* 2174412 */     GIR_EraseRootFromParent_Done,
     /* 2174413 */   // Label 28662: @2174413
     /* 2174413 */   GIM_Try, /*On fail goto*//*Label 28663*/ GIMT_Encode4(2174504), // Rule ID 18393 //
     /* 2174418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174464 */     // MIs[0] round
     /* 2174464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174467 */     // MIs[0] policy
     /* 2174467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2174480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174503 */     // GIR_Coverage, 18393,
     /* 2174503 */     GIR_EraseRootFromParent_Done,
     /* 2174504 */   // Label 28663: @2174504
     /* 2174504 */   GIM_Try, /*On fail goto*//*Label 28664*/ GIMT_Encode4(2174595), // Rule ID 18396 //
     /* 2174509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2174520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2174523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2174526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2174529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174555 */     // MIs[0] round
     /* 2174555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174558 */     // MIs[0] policy
     /* 2174558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174568 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2174571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174594 */     // GIR_Coverage, 18396,
     /* 2174594 */     GIR_EraseRootFromParent_Done,
     /* 2174595 */   // Label 28664: @2174595
     /* 2174595 */   GIM_Try, /*On fail goto*//*Label 28665*/ GIMT_Encode4(2174686), // Rule ID 18397 //
     /* 2174600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2174611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2174614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2174617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2174620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174646 */     // MIs[0] round
     /* 2174646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174649 */     // MIs[0] policy
     /* 2174649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174659 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2174662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174685 */     // GIR_Coverage, 18397,
     /* 2174685 */     GIR_EraseRootFromParent_Done,
     /* 2174686 */   // Label 28665: @2174686
     /* 2174686 */   GIM_Try, /*On fail goto*//*Label 28666*/ GIMT_Encode4(2174777), // Rule ID 18400 //
     /* 2174691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2174694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2174702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2174705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2174708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2174711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174737 */     // MIs[0] round
     /* 2174737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174740 */     // MIs[0] policy
     /* 2174740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174750 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2174753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174776 */     // GIR_Coverage, 18400,
     /* 2174776 */     GIR_EraseRootFromParent_Done,
     /* 2174777 */   // Label 28666: @2174777
     /* 2174777 */   GIM_Try, /*On fail goto*//*Label 28667*/ GIMT_Encode4(2174868), // Rule ID 18401 //
     /* 2174782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2174785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2174793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2174796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2174799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2174802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174828 */     // MIs[0] round
     /* 2174828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174831 */     // MIs[0] policy
     /* 2174831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174841 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2174844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174867 */     // GIR_Coverage, 18401,
     /* 2174867 */     GIR_EraseRootFromParent_Done,
     /* 2174868 */   // Label 28667: @2174868
     /* 2174868 */   GIM_Try, /*On fail goto*//*Label 28668*/ GIMT_Encode4(2174959), // Rule ID 18404 //
     /* 2174873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2174876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2174884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2174887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2174890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2174893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174919 */     // MIs[0] round
     /* 2174919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174922 */     // MIs[0] policy
     /* 2174922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174932 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2174935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174958 */     // GIR_Coverage, 18404,
     /* 2174958 */     GIR_EraseRootFromParent_Done,
     /* 2174959 */   // Label 28668: @2174959
     /* 2174959 */   GIM_Try, /*On fail goto*//*Label 28669*/ GIMT_Encode4(2175050), // Rule ID 18405 //
     /* 2174964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2174967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2174972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2174975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2174978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2174981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2174984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2175006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175010 */     // MIs[0] round
     /* 2175010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175013 */     // MIs[0] policy
     /* 2175013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175023 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2175026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175049 */     // GIR_Coverage, 18405,
     /* 2175049 */     GIR_EraseRootFromParent_Done,
     /* 2175050 */   // Label 28669: @2175050
     /* 2175050 */   GIM_Try, /*On fail goto*//*Label 28670*/ GIMT_Encode4(2175141), // Rule ID 18408 //
     /* 2175055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2175066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2175069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2175072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2175075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175101 */     // MIs[0] round
     /* 2175101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175104 */     // MIs[0] policy
     /* 2175104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175114 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2175117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175140 */     // GIR_Coverage, 18408,
     /* 2175140 */     GIR_EraseRootFromParent_Done,
     /* 2175141 */   // Label 28670: @2175141
     /* 2175141 */   GIM_Try, /*On fail goto*//*Label 28671*/ GIMT_Encode4(2175232), // Rule ID 18409 //
     /* 2175146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2175157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2175160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2175163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2175166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2175169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2175176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2175188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175192 */     // MIs[0] round
     /* 2175192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175195 */     // MIs[0] policy
     /* 2175195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175205 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2175208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175231 */     // GIR_Coverage, 18409,
     /* 2175231 */     GIR_EraseRootFromParent_Done,
     /* 2175232 */   // Label 28671: @2175232
     /* 2175232 */   GIM_Try, /*On fail goto*//*Label 28672*/ GIMT_Encode4(2175323), // Rule ID 18412 //
     /* 2175237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2175248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2175257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175283 */     // MIs[0] round
     /* 2175283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175286 */     // MIs[0] policy
     /* 2175286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175296 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2175299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175322 */     // GIR_Coverage, 18412,
     /* 2175322 */     GIR_EraseRootFromParent_Done,
     /* 2175323 */   // Label 28672: @2175323
     /* 2175323 */   GIM_Try, /*On fail goto*//*Label 28673*/ GIMT_Encode4(2175414), // Rule ID 18413 //
     /* 2175328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2175339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2175348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175374 */     // MIs[0] round
     /* 2175374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175377 */     // MIs[0] policy
     /* 2175377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175387 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2175390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175413 */     // GIR_Coverage, 18413,
     /* 2175413 */     GIR_EraseRootFromParent_Done,
     /* 2175414 */   // Label 28673: @2175414
     /* 2175414 */   GIM_Try, /*On fail goto*//*Label 28674*/ GIMT_Encode4(2175505), // Rule ID 18416 //
     /* 2175419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2175439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175465 */     // MIs[0] round
     /* 2175465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175468 */     // MIs[0] policy
     /* 2175468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175478 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2175481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175504 */     // GIR_Coverage, 18416,
     /* 2175504 */     GIR_EraseRootFromParent_Done,
     /* 2175505 */   // Label 28674: @2175505
     /* 2175505 */   GIM_Try, /*On fail goto*//*Label 28675*/ GIMT_Encode4(2175596), // Rule ID 18417 //
     /* 2175510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2175530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175556 */     // MIs[0] round
     /* 2175556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175559 */     // MIs[0] policy
     /* 2175559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175569 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2175572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175595 */     // GIR_Coverage, 18417,
     /* 2175595 */     GIR_EraseRootFromParent_Done,
     /* 2175596 */   // Label 28675: @2175596
     /* 2175596 */   GIM_Try, /*On fail goto*//*Label 28676*/ GIMT_Encode4(2175687), // Rule ID 18420 //
     /* 2175601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2175612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2175615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2175621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175647 */     // MIs[0] round
     /* 2175647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175650 */     // MIs[0] policy
     /* 2175650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175660 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2175663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175686 */     // GIR_Coverage, 18420,
     /* 2175686 */     GIR_EraseRootFromParent_Done,
     /* 2175687 */   // Label 28676: @2175687
     /* 2175687 */   GIM_Try, /*On fail goto*//*Label 28677*/ GIMT_Encode4(2175778), // Rule ID 18421 //
     /* 2175692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2175703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2175706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2175712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175738 */     // MIs[0] round
     /* 2175738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175741 */     // MIs[0] policy
     /* 2175741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175751 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2175754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175777 */     // GIR_Coverage, 18421,
     /* 2175777 */     GIR_EraseRootFromParent_Done,
     /* 2175778 */   // Label 28677: @2175778
     /* 2175778 */   GIM_Try, /*On fail goto*//*Label 28678*/ GIMT_Encode4(2175869), // Rule ID 18424 //
     /* 2175783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2175794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2175797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2175803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175829 */     // MIs[0] round
     /* 2175829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175832 */     // MIs[0] policy
     /* 2175832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175842 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2175845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175868 */     // GIR_Coverage, 18424,
     /* 2175868 */     GIR_EraseRootFromParent_Done,
     /* 2175869 */   // Label 28678: @2175869
     /* 2175869 */   GIM_Try, /*On fail goto*//*Label 28679*/ GIMT_Encode4(2175960), // Rule ID 18425 //
     /* 2175874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2175885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2175888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2175894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175920 */     // MIs[0] round
     /* 2175920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175923 */     // MIs[0] policy
     /* 2175923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175933 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11244:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2175936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175959 */     // GIR_Coverage, 18425,
     /* 2175959 */     GIR_EraseRootFromParent_Done,
     /* 2175960 */   // Label 28679: @2175960
     /* 2175960 */   GIM_Try, /*On fail goto*//*Label 28680*/ GIMT_Encode4(2176051), // Rule ID 18428 //
     /* 2175965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2175973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2175976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2175979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2175985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176011 */     // MIs[0] round
     /* 2176011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176014 */     // MIs[0] policy
     /* 2176014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2176027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176050 */     // GIR_Coverage, 18428,
     /* 2176050 */     GIR_EraseRootFromParent_Done,
     /* 2176051 */   // Label 28680: @2176051
     /* 2176051 */   GIM_Try, /*On fail goto*//*Label 28681*/ GIMT_Encode4(2176142), // Rule ID 18429 //
     /* 2176056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2176067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2176070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2176076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2176079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176102 */     // MIs[0] round
     /* 2176102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176105 */     // MIs[0] policy
     /* 2176105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176115 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2176118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176141 */     // GIR_Coverage, 18429,
     /* 2176141 */     GIR_EraseRootFromParent_Done,
     /* 2176142 */   // Label 28681: @2176142
     /* 2176142 */   GIM_Try, /*On fail goto*//*Label 28682*/ GIMT_Encode4(2176233), // Rule ID 18432 //
     /* 2176147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2176150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2176158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2176161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2176167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176193 */     // MIs[0] round
     /* 2176193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176196 */     // MIs[0] policy
     /* 2176196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176206 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2176209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176232 */     // GIR_Coverage, 18432,
     /* 2176232 */     GIR_EraseRootFromParent_Done,
     /* 2176233 */   // Label 28682: @2176233
     /* 2176233 */   GIM_Try, /*On fail goto*//*Label 28683*/ GIMT_Encode4(2176324), // Rule ID 18433 //
     /* 2176238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2176241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2176249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2176252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2176255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2176258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2176261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2176268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2176276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2176280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176284 */     // MIs[0] round
     /* 2176284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176287 */     // MIs[0] policy
     /* 2176287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176297 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2176300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176323 */     // GIR_Coverage, 18433,
     /* 2176323 */     GIR_EraseRootFromParent_Done,
     /* 2176324 */   // Label 28683: @2176324
     /* 2176324 */   GIM_Try, /*On fail goto*//*Label 28684*/ GIMT_Encode4(2176415), // Rule ID 18436 //
     /* 2176329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176375 */     // MIs[0] round
     /* 2176375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176378 */     // MIs[0] policy
     /* 2176378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176388 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2176391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176414 */     // GIR_Coverage, 18436,
     /* 2176414 */     GIR_EraseRootFromParent_Done,
     /* 2176415 */   // Label 28684: @2176415
     /* 2176415 */   GIM_Try, /*On fail goto*//*Label 28685*/ GIMT_Encode4(2176506), // Rule ID 18437 //
     /* 2176420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176466 */     // MIs[0] round
     /* 2176466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176469 */     // MIs[0] policy
     /* 2176469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176479 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2176482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176505 */     // GIR_Coverage, 18437,
     /* 2176505 */     GIR_EraseRootFromParent_Done,
     /* 2176506 */   // Label 28685: @2176506
     /* 2176506 */   GIM_Try, /*On fail goto*//*Label 28686*/ GIMT_Encode4(2176597), // Rule ID 18440 //
     /* 2176511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2176522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2176525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2176531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2176534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176557 */     // MIs[0] round
     /* 2176557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176560 */     // MIs[0] policy
     /* 2176560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176570 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2176573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176596 */     // GIR_Coverage, 18440,
     /* 2176596 */     GIR_EraseRootFromParent_Done,
     /* 2176597 */   // Label 28686: @2176597
     /* 2176597 */   GIM_Try, /*On fail goto*//*Label 28687*/ GIMT_Encode4(2176688), // Rule ID 18441 //
     /* 2176602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2176613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2176616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2176622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2176625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176648 */     // MIs[0] round
     /* 2176648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176651 */     // MIs[0] policy
     /* 2176651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176661 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2176664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176687 */     // GIR_Coverage, 18441,
     /* 2176687 */     GIR_EraseRootFromParent_Done,
     /* 2176688 */   // Label 28687: @2176688
     /* 2176688 */   GIM_Try, /*On fail goto*//*Label 28688*/ GIMT_Encode4(2176779), // Rule ID 18444 //
     /* 2176693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2176704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2176707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2176713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2176716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176739 */     // MIs[0] round
     /* 2176739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176742 */     // MIs[0] policy
     /* 2176742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176752 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2176755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176778 */     // GIR_Coverage, 18444,
     /* 2176778 */     GIR_EraseRootFromParent_Done,
     /* 2176779 */   // Label 28688: @2176779
     /* 2176779 */   GIM_Try, /*On fail goto*//*Label 28689*/ GIMT_Encode4(2176870), // Rule ID 18445 //
     /* 2176784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2176795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2176798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2176804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2176807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176830 */     // MIs[0] round
     /* 2176830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176833 */     // MIs[0] policy
     /* 2176833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176843 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2176846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176869 */     // GIR_Coverage, 18445,
     /* 2176869 */     GIR_EraseRootFromParent_Done,
     /* 2176870 */   // Label 28689: @2176870
     /* 2176870 */   GIM_Try, /*On fail goto*//*Label 28690*/ GIMT_Encode4(2176961), // Rule ID 18448 //
     /* 2176875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2176886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2176889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2176895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176921 */     // MIs[0] round
     /* 2176921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176924 */     // MIs[0] policy
     /* 2176924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176934 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2176937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176960 */     // GIR_Coverage, 18448,
     /* 2176960 */     GIR_EraseRootFromParent_Done,
     /* 2176961 */   // Label 28690: @2176961
     /* 2176961 */   GIM_Try, /*On fail goto*//*Label 28691*/ GIMT_Encode4(2177052), // Rule ID 18449 //
     /* 2176966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2176974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2176977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2176980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2176986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177012 */     // MIs[0] round
     /* 2177012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177015 */     // MIs[0] policy
     /* 2177015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177025 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2177028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177051 */     // GIR_Coverage, 18449,
     /* 2177051 */     GIR_EraseRootFromParent_Done,
     /* 2177052 */   // Label 28691: @2177052
     /* 2177052 */   GIM_Try, /*On fail goto*//*Label 28692*/ GIMT_Encode4(2177143), // Rule ID 18452 //
     /* 2177057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2177068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2177071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2177077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177103 */     // MIs[0] round
     /* 2177103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177106 */     // MIs[0] policy
     /* 2177106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177116 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2177119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177142 */     // GIR_Coverage, 18452,
     /* 2177142 */     GIR_EraseRootFromParent_Done,
     /* 2177143 */   // Label 28692: @2177143
     /* 2177143 */   GIM_Try, /*On fail goto*//*Label 28693*/ GIMT_Encode4(2177234), // Rule ID 18453 //
     /* 2177148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2177159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2177162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2177168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177194 */     // MIs[0] round
     /* 2177194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177197 */     // MIs[0] policy
     /* 2177197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177207 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2177210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177233 */     // GIR_Coverage, 18453,
     /* 2177233 */     GIR_EraseRootFromParent_Done,
     /* 2177234 */   // Label 28693: @2177234
     /* 2177234 */   GIM_Try, /*On fail goto*//*Label 28694*/ GIMT_Encode4(2177325), // Rule ID 18456 //
     /* 2177239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2177242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2177250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2177259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177285 */     // MIs[0] round
     /* 2177285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177288 */     // MIs[0] policy
     /* 2177288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177298 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2177301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177324 */     // GIR_Coverage, 18456,
     /* 2177324 */     GIR_EraseRootFromParent_Done,
     /* 2177325 */   // Label 28694: @2177325
     /* 2177325 */   GIM_Try, /*On fail goto*//*Label 28695*/ GIMT_Encode4(2177416), // Rule ID 18457 //
     /* 2177330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2177341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2177350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177376 */     // MIs[0] round
     /* 2177376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177379 */     // MIs[0] policy
     /* 2177379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177389 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2177392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177415 */     // GIR_Coverage, 18457,
     /* 2177415 */     GIR_EraseRootFromParent_Done,
     /* 2177416 */   // Label 28695: @2177416
     /* 2177416 */   GIM_Try, /*On fail goto*//*Label 28696*/ GIMT_Encode4(2177507), // Rule ID 18460 //
     /* 2177421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2177435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2177441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177467 */     // MIs[0] round
     /* 2177467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177470 */     // MIs[0] policy
     /* 2177470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177480 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2177483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177506 */     // GIR_Coverage, 18460,
     /* 2177506 */     GIR_EraseRootFromParent_Done,
     /* 2177507 */   // Label 28696: @2177507
     /* 2177507 */   GIM_Try, /*On fail goto*//*Label 28697*/ GIMT_Encode4(2177598), // Rule ID 18461 //
     /* 2177512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2177526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2177532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177558 */     // MIs[0] round
     /* 2177558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177561 */     // MIs[0] policy
     /* 2177561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177571 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11244:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2177574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177597 */     // GIR_Coverage, 18461,
     /* 2177597 */     GIR_EraseRootFromParent_Done,
     /* 2177598 */   // Label 28697: @2177598
     /* 2177598 */   GIM_Try, /*On fail goto*//*Label 28698*/ GIMT_Encode4(2177689), // Rule ID 18464 //
     /* 2177603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2177614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2177617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2177623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177649 */     // MIs[0] round
     /* 2177649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177652 */     // MIs[0] policy
     /* 2177652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177662 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2177665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177688 */     // GIR_Coverage, 18464,
     /* 2177688 */     GIR_EraseRootFromParent_Done,
     /* 2177689 */   // Label 28698: @2177689
     /* 2177689 */   GIM_Try, /*On fail goto*//*Label 28699*/ GIMT_Encode4(2177780), // Rule ID 18465 //
     /* 2177694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2177705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2177708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2177714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177740 */     // MIs[0] round
     /* 2177740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177743 */     // MIs[0] policy
     /* 2177743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177753 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11244:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2177756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177779 */     // GIR_Coverage, 18465,
     /* 2177779 */     GIR_EraseRootFromParent_Done,
     /* 2177780 */   // Label 28699: @2177780
     /* 2177780 */   GIM_Try, /*On fail goto*//*Label 28700*/ GIMT_Encode4(2177871), // Rule ID 18468 //
     /* 2177785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2177796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2177799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2177805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177831 */     // MIs[0] round
     /* 2177831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177834 */     // MIs[0] policy
     /* 2177834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177844 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2177847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177870 */     // GIR_Coverage, 18468,
     /* 2177870 */     GIR_EraseRootFromParent_Done,
     /* 2177871 */   // Label 28700: @2177871
     /* 2177871 */   GIM_Try, /*On fail goto*//*Label 28701*/ GIMT_Encode4(2177962), // Rule ID 18469 //
     /* 2177876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2177884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2177887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2177890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2177896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177922 */     // MIs[0] round
     /* 2177922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177925 */     // MIs[0] policy
     /* 2177925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177935 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11244:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2177938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177961 */     // GIR_Coverage, 18469,
     /* 2177961 */     GIR_EraseRootFromParent_Done,
     /* 2177962 */   // Label 28701: @2177962
     /* 2177962 */   GIM_Try, /*On fail goto*//*Label 28702*/ GIMT_Encode4(2178053), // Rule ID 18472 //
     /* 2177967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2177970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2177975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2177978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2177981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2177984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2177987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2177990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178013 */     // MIs[0] round
     /* 2178013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178016 */     // MIs[0] policy
     /* 2178016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178026 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2178029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178052 */     // GIR_Coverage, 18472,
     /* 2178052 */     GIR_EraseRootFromParent_Done,
     /* 2178053 */   // Label 28702: @2178053
     /* 2178053 */   GIM_Try, /*On fail goto*//*Label 28703*/ GIMT_Encode4(2178144), // Rule ID 18473 //
     /* 2178058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2178069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2178072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2178075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2178078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178104 */     // MIs[0] round
     /* 2178104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178107 */     // MIs[0] policy
     /* 2178107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178117 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2178120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178143 */     // GIR_Coverage, 18473,
     /* 2178143 */     GIR_EraseRootFromParent_Done,
     /* 2178144 */   // Label 28703: @2178144
     /* 2178144 */   GIM_Try, /*On fail goto*//*Label 28704*/ GIMT_Encode4(2178235), // Rule ID 18476 //
     /* 2178149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2178160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2178163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2178166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2178169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178195 */     // MIs[0] round
     /* 2178195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178198 */     // MIs[0] policy
     /* 2178198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178208 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2178211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178234 */     // GIR_Coverage, 18476,
     /* 2178234 */     GIR_EraseRootFromParent_Done,
     /* 2178235 */   // Label 28704: @2178235
     /* 2178235 */   GIM_Try, /*On fail goto*//*Label 28705*/ GIMT_Encode4(2178326), // Rule ID 18477 //
     /* 2178240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2178251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2178254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2178257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2178260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178286 */     // MIs[0] round
     /* 2178286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178289 */     // MIs[0] policy
     /* 2178289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178299 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2178302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178325 */     // GIR_Coverage, 18477,
     /* 2178325 */     GIR_EraseRootFromParent_Done,
     /* 2178326 */   // Label 28705: @2178326
     /* 2178326 */   GIM_Try, /*On fail goto*//*Label 28706*/ GIMT_Encode4(2178417), // Rule ID 18480 //
     /* 2178331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2178342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2178345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178377 */     // MIs[0] round
     /* 2178377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178380 */     // MIs[0] policy
     /* 2178380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178390 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2178393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178416 */     // GIR_Coverage, 18480,
     /* 2178416 */     GIR_EraseRootFromParent_Done,
     /* 2178417 */   // Label 28706: @2178417
     /* 2178417 */   GIM_Try, /*On fail goto*//*Label 28707*/ GIMT_Encode4(2178508), // Rule ID 18481 //
     /* 2178422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2178433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2178436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178468 */     // MIs[0] round
     /* 2178468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178471 */     // MIs[0] policy
     /* 2178471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178481 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2178484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178507 */     // GIR_Coverage, 18481,
     /* 2178507 */     GIR_EraseRootFromParent_Done,
     /* 2178508 */   // Label 28707: @2178508
     /* 2178508 */   GIM_Try, /*On fail goto*//*Label 28708*/ GIMT_Encode4(2178599), // Rule ID 18484 //
     /* 2178513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2178516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2178524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2178527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2178530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2178533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178559 */     // MIs[0] round
     /* 2178559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178562 */     // MIs[0] policy
     /* 2178562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178572 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2178575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178598 */     // GIR_Coverage, 18484,
     /* 2178598 */     GIR_EraseRootFromParent_Done,
     /* 2178599 */   // Label 28708: @2178599
     /* 2178599 */   GIM_Try, /*On fail goto*//*Label 28709*/ GIMT_Encode4(2178690), // Rule ID 18485 //
     /* 2178604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2178607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2178615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2178618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2178621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2178624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178650 */     // MIs[0] round
     /* 2178650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178653 */     // MIs[0] policy
     /* 2178653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178663 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2178666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178689 */     // GIR_Coverage, 18485,
     /* 2178689 */     GIR_EraseRootFromParent_Done,
     /* 2178690 */   // Label 28709: @2178690
     /* 2178690 */   GIM_Try, /*On fail goto*//*Label 28710*/ GIMT_Encode4(2178781), // Rule ID 18488 //
     /* 2178695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2178698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2178706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2178709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2178712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2178715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178741 */     // MIs[0] round
     /* 2178741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178744 */     // MIs[0] policy
     /* 2178744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178754 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2178757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178780 */     // GIR_Coverage, 18488,
     /* 2178780 */     GIR_EraseRootFromParent_Done,
     /* 2178781 */   // Label 28710: @2178781
     /* 2178781 */   GIM_Try, /*On fail goto*//*Label 28711*/ GIMT_Encode4(2178872), // Rule ID 18489 //
     /* 2178786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2178789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2178797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2178800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2178803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2178806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178832 */     // MIs[0] round
     /* 2178832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178835 */     // MIs[0] policy
     /* 2178835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178845 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2178848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178871 */     // GIR_Coverage, 18489,
     /* 2178871 */     GIR_EraseRootFromParent_Done,
     /* 2178872 */   // Label 28711: @2178872
     /* 2178872 */   GIM_Try, /*On fail goto*//*Label 28712*/ GIMT_Encode4(2178963), // Rule ID 18492 //
     /* 2178877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2178880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2178888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2178891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2178894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2178897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178923 */     // MIs[0] round
     /* 2178923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178926 */     // MIs[0] policy
     /* 2178926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178936 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2178939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2178959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178962 */     // GIR_Coverage, 18492,
     /* 2178962 */     GIR_EraseRootFromParent_Done,
     /* 2178963 */   // Label 28712: @2178963
     /* 2178963 */   GIM_Try, /*On fail goto*//*Label 28713*/ GIMT_Encode4(2179054), // Rule ID 18493 //
     /* 2178968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2178971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2178976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2178979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2178982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2178985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2178988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179014 */     // MIs[0] round
     /* 2179014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179017 */     // MIs[0] policy
     /* 2179017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179027 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2179030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2179050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179053 */     // GIR_Coverage, 18493,
     /* 2179053 */     GIR_EraseRootFromParent_Done,
     /* 2179054 */   // Label 28713: @2179054
     /* 2179054 */   GIM_Try, /*On fail goto*//*Label 28714*/ GIMT_Encode4(2179145), // Rule ID 18496 //
     /* 2179059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2179070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2179073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2179076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179105 */     // MIs[0] round
     /* 2179105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179108 */     // MIs[0] policy
     /* 2179108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179118 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2179121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179144 */     // GIR_Coverage, 18496,
     /* 2179144 */     GIR_EraseRootFromParent_Done,
     /* 2179145 */   // Label 28714: @2179145
     /* 2179145 */   GIM_Try, /*On fail goto*//*Label 28715*/ GIMT_Encode4(2179236), // Rule ID 18497 //
     /* 2179150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2179161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2179164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2179167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179196 */     // MIs[0] round
     /* 2179196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179199 */     // MIs[0] policy
     /* 2179199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179209 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2179212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179235 */     // GIR_Coverage, 18497,
     /* 2179235 */     GIR_EraseRootFromParent_Done,
     /* 2179236 */   // Label 28715: @2179236
     /* 2179236 */   GIM_Try, /*On fail goto*//*Label 28716*/ GIMT_Encode4(2179327), // Rule ID 18500 //
     /* 2179241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2179252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2179255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2179258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2179261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2179264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179287 */     // MIs[0] round
     /* 2179287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179290 */     // MIs[0] policy
     /* 2179290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179300 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2179303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179326 */     // GIR_Coverage, 18500,
     /* 2179326 */     GIR_EraseRootFromParent_Done,
     /* 2179327 */   // Label 28716: @2179327
     /* 2179327 */   GIM_Try, /*On fail goto*//*Label 28717*/ GIMT_Encode4(2179418), // Rule ID 18501 //
     /* 2179332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2179343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2179346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2179349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2179352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2179355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179378 */     // MIs[0] round
     /* 2179378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179381 */     // MIs[0] policy
     /* 2179381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179391 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2179394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179417 */     // GIR_Coverage, 18501,
     /* 2179417 */     GIR_EraseRootFromParent_Done,
     /* 2179418 */   // Label 28717: @2179418
     /* 2179418 */   GIM_Try, /*On fail goto*//*Label 28718*/ GIMT_Encode4(2179509), // Rule ID 18504 //
     /* 2179423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2179426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2179434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2179437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2179440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2179443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2179446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179469 */     // MIs[0] round
     /* 2179469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179472 */     // MIs[0] policy
     /* 2179472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179482 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2179485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179508 */     // GIR_Coverage, 18504,
     /* 2179508 */     GIR_EraseRootFromParent_Done,
     /* 2179509 */   // Label 28718: @2179509
     /* 2179509 */   GIM_Try, /*On fail goto*//*Label 28719*/ GIMT_Encode4(2179600), // Rule ID 18505 //
     /* 2179514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2179517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2179525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2179528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2179531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2179534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2179537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179560 */     // MIs[0] round
     /* 2179560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179563 */     // MIs[0] policy
     /* 2179563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179573 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2179576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179599 */     // GIR_Coverage, 18505,
     /* 2179599 */     GIR_EraseRootFromParent_Done,
     /* 2179600 */   // Label 28719: @2179600
     /* 2179600 */   GIM_Try, /*On fail goto*//*Label 28720*/ GIMT_Encode4(2179691), // Rule ID 18508 //
     /* 2179605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2179616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2179619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2179622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2179625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179651 */     // MIs[0] round
     /* 2179651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179654 */     // MIs[0] policy
     /* 2179654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179664 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2179667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179690 */     // GIR_Coverage, 18508,
     /* 2179690 */     GIR_EraseRootFromParent_Done,
     /* 2179691 */   // Label 28720: @2179691
     /* 2179691 */   GIM_Try, /*On fail goto*//*Label 28721*/ GIMT_Encode4(2179782), // Rule ID 18509 //
     /* 2179696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2179699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2179707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2179710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2179713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2179716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179742 */     // MIs[0] round
     /* 2179742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179745 */     // MIs[0] policy
     /* 2179745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179755 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2179758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179781 */     // GIR_Coverage, 18509,
     /* 2179781 */     GIR_EraseRootFromParent_Done,
     /* 2179782 */   // Label 28721: @2179782
     /* 2179782 */   GIM_Try, /*On fail goto*//*Label 28722*/ GIMT_Encode4(2179873), // Rule ID 18512 //
     /* 2179787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2179798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2179801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2179804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2179807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179833 */     // MIs[0] round
     /* 2179833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179836 */     // MIs[0] policy
     /* 2179836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179846 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2179849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179872 */     // GIR_Coverage, 18512,
     /* 2179872 */     GIR_EraseRootFromParent_Done,
     /* 2179873 */   // Label 28722: @2179873
     /* 2179873 */   GIM_Try, /*On fail goto*//*Label 28723*/ GIMT_Encode4(2179964), // Rule ID 18513 //
     /* 2179878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2179881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2179889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2179892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2179895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2179898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179924 */     // MIs[0] round
     /* 2179924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179927 */     // MIs[0] policy
     /* 2179927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179937 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2179940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179963 */     // GIR_Coverage, 18513,
     /* 2179963 */     GIR_EraseRootFromParent_Done,
     /* 2179964 */   // Label 28723: @2179964
     /* 2179964 */   GIM_Try, /*On fail goto*//*Label 28724*/ GIMT_Encode4(2180055), // Rule ID 18516 //
     /* 2179969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2179972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2179977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2179980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2179983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2179986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2179989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2179992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180015 */     // MIs[0] round
     /* 2180015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180018 */     // MIs[0] policy
     /* 2180018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180028 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2180031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180054 */     // GIR_Coverage, 18516,
     /* 2180054 */     GIR_EraseRootFromParent_Done,
     /* 2180055 */   // Label 28724: @2180055
     /* 2180055 */   GIM_Try, /*On fail goto*//*Label 28725*/ GIMT_Encode4(2180146), // Rule ID 18517 //
     /* 2180060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2180063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2180071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2180074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2180077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2180080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180106 */     // MIs[0] round
     /* 2180106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180109 */     // MIs[0] policy
     /* 2180109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180119 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2180122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180145 */     // GIR_Coverage, 18517,
     /* 2180145 */     GIR_EraseRootFromParent_Done,
     /* 2180146 */   // Label 28725: @2180146
     /* 2180146 */   GIM_Try, /*On fail goto*//*Label 28726*/ GIMT_Encode4(2180237), // Rule ID 18520 //
     /* 2180151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2180168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2180171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180197 */     // MIs[0] round
     /* 2180197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180200 */     // MIs[0] policy
     /* 2180200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180210 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2180213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180236 */     // GIR_Coverage, 18520,
     /* 2180236 */     GIR_EraseRootFromParent_Done,
     /* 2180237 */   // Label 28726: @2180237
     /* 2180237 */   GIM_Try, /*On fail goto*//*Label 28727*/ GIMT_Encode4(2180328), // Rule ID 18521 //
     /* 2180242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2180259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2180262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180288 */     // MIs[0] round
     /* 2180288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180291 */     // MIs[0] policy
     /* 2180291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180301 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2180304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180327 */     // GIR_Coverage, 18521,
     /* 2180327 */     GIR_EraseRootFromParent_Done,
     /* 2180328 */   // Label 28727: @2180328
     /* 2180328 */   GIM_Try, /*On fail goto*//*Label 28728*/ GIMT_Encode4(2180419), // Rule ID 18524 //
     /* 2180333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2180350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2180353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180379 */     // MIs[0] round
     /* 2180379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180382 */     // MIs[0] policy
     /* 2180382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180392 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2180395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180418 */     // GIR_Coverage, 18524,
     /* 2180418 */     GIR_EraseRootFromParent_Done,
     /* 2180419 */   // Label 28728: @2180419
     /* 2180419 */   GIM_Try, /*On fail goto*//*Label 28729*/ GIMT_Encode4(2180510), // Rule ID 18525 //
     /* 2180424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2180441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2180444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180470 */     // MIs[0] round
     /* 2180470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180473 */     // MIs[0] policy
     /* 2180473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180483 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2180486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180509 */     // GIR_Coverage, 18525,
     /* 2180509 */     GIR_EraseRootFromParent_Done,
     /* 2180510 */   // Label 28729: @2180510
     /* 2180510 */   GIM_Try, /*On fail goto*//*Label 28730*/ GIMT_Encode4(2180601), // Rule ID 18528 //
     /* 2180515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2180518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2180526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2180529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2180532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2180535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180561 */     // MIs[0] round
     /* 2180561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180564 */     // MIs[0] policy
     /* 2180564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180574 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2180577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180600 */     // GIR_Coverage, 18528,
     /* 2180600 */     GIR_EraseRootFromParent_Done,
     /* 2180601 */   // Label 28730: @2180601
     /* 2180601 */   GIM_Try, /*On fail goto*//*Label 28731*/ GIMT_Encode4(2180692), // Rule ID 18529 //
     /* 2180606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2180609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2180617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2180620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2180623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2180626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180652 */     // MIs[0] round
     /* 2180652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180655 */     // MIs[0] policy
     /* 2180655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180665 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2180668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2180688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180691 */     // GIR_Coverage, 18529,
     /* 2180691 */     GIR_EraseRootFromParent_Done,
     /* 2180692 */   // Label 28731: @2180692
     /* 2180692 */   GIM_Try, /*On fail goto*//*Label 28732*/ GIMT_Encode4(2180783), // Rule ID 18532 //
     /* 2180697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2180708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2180711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2180717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180743 */     // MIs[0] round
     /* 2180743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180746 */     // MIs[0] policy
     /* 2180746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180756 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2180759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180782 */     // GIR_Coverage, 18532,
     /* 2180782 */     GIR_EraseRootFromParent_Done,
     /* 2180783 */   // Label 28732: @2180783
     /* 2180783 */   GIM_Try, /*On fail goto*//*Label 28733*/ GIMT_Encode4(2180874), // Rule ID 18533 //
     /* 2180788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2180799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2180802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2180808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180834 */     // MIs[0] round
     /* 2180834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180837 */     // MIs[0] policy
     /* 2180837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180847 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2180850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180873 */     // GIR_Coverage, 18533,
     /* 2180873 */     GIR_EraseRootFromParent_Done,
     /* 2180874 */   // Label 28733: @2180874
     /* 2180874 */   GIM_Try, /*On fail goto*//*Label 28734*/ GIMT_Encode4(2180965), // Rule ID 18536 //
     /* 2180879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2180882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2180890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2180893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2180899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180925 */     // MIs[0] round
     /* 2180925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180928 */     // MIs[0] policy
     /* 2180928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180938 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2180941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180964 */     // GIR_Coverage, 18536,
     /* 2180964 */     GIR_EraseRootFromParent_Done,
     /* 2180965 */   // Label 28734: @2180965
     /* 2180965 */   GIM_Try, /*On fail goto*//*Label 28735*/ GIMT_Encode4(2181056), // Rule ID 18537 //
     /* 2180970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2180973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2180978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2180981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2180984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2180990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181016 */     // MIs[0] round
     /* 2181016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181019 */     // MIs[0] policy
     /* 2181019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181029 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2181032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181055 */     // GIR_Coverage, 18537,
     /* 2181055 */     GIR_EraseRootFromParent_Done,
     /* 2181056 */   // Label 28735: @2181056
     /* 2181056 */   GIM_Try, /*On fail goto*//*Label 28736*/ GIMT_Encode4(2181147), // Rule ID 18540 //
     /* 2181061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2181072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181107 */     // MIs[0] round
     /* 2181107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181110 */     // MIs[0] policy
     /* 2181110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181120 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2181123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181146 */     // GIR_Coverage, 18540,
     /* 2181146 */     GIR_EraseRootFromParent_Done,
     /* 2181147 */   // Label 28736: @2181147
     /* 2181147 */   GIM_Try, /*On fail goto*//*Label 28737*/ GIMT_Encode4(2181238), // Rule ID 18541 //
     /* 2181152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2181163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181198 */     // MIs[0] round
     /* 2181198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181201 */     // MIs[0] policy
     /* 2181201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181211 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2181214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181237 */     // GIR_Coverage, 18541,
     /* 2181237 */     GIR_EraseRootFromParent_Done,
     /* 2181238 */   // Label 28737: @2181238
     /* 2181238 */   GIM_Try, /*On fail goto*//*Label 28738*/ GIMT_Encode4(2181329), // Rule ID 18544 //
     /* 2181243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2181254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2181257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181289 */     // MIs[0] round
     /* 2181289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181292 */     // MIs[0] policy
     /* 2181292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181302 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2181305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181328 */     // GIR_Coverage, 18544,
     /* 2181328 */     GIR_EraseRootFromParent_Done,
     /* 2181329 */   // Label 28738: @2181329
     /* 2181329 */   GIM_Try, /*On fail goto*//*Label 28739*/ GIMT_Encode4(2181420), // Rule ID 18545 //
     /* 2181334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2181345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2181348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181380 */     // MIs[0] round
     /* 2181380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181383 */     // MIs[0] policy
     /* 2181383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181393 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2181396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181419 */     // GIR_Coverage, 18545,
     /* 2181419 */     GIR_EraseRootFromParent_Done,
     /* 2181420 */   // Label 28739: @2181420
     /* 2181420 */   GIM_Try, /*On fail goto*//*Label 28740*/ GIMT_Encode4(2181511), // Rule ID 18548 //
     /* 2181425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2181428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2181436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2181439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2181445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181471 */     // MIs[0] round
     /* 2181471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181474 */     // MIs[0] policy
     /* 2181474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181484 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2181487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181510 */     // GIR_Coverage, 18548,
     /* 2181510 */     GIR_EraseRootFromParent_Done,
     /* 2181511 */   // Label 28740: @2181511
     /* 2181511 */   GIM_Try, /*On fail goto*//*Label 28741*/ GIMT_Encode4(2181602), // Rule ID 18549 //
     /* 2181516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2181519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2181527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2181530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2181533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2181536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2181554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181562 */     // MIs[0] round
     /* 2181562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181565 */     // MIs[0] policy
     /* 2181565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181575 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2181578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181601 */     // GIR_Coverage, 18549,
     /* 2181601 */     GIR_EraseRootFromParent_Done,
     /* 2181602 */   // Label 28741: @2181602
     /* 2181602 */   GIM_Try, /*On fail goto*//*Label 28742*/ GIMT_Encode4(2181693), // Rule ID 18552 //
     /* 2181607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2181610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2181618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2181621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2181627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181653 */     // MIs[0] round
     /* 2181653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181656 */     // MIs[0] policy
     /* 2181656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181666 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2181669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181692 */     // GIR_Coverage, 18552,
     /* 2181692 */     GIR_EraseRootFromParent_Done,
     /* 2181693 */   // Label 28742: @2181693
     /* 2181693 */   GIM_Try, /*On fail goto*//*Label 28743*/ GIMT_Encode4(2181784), // Rule ID 18553 //
     /* 2181698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2181701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2181709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2181712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2181715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2181718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2181736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181744 */     // MIs[0] round
     /* 2181744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181747 */     // MIs[0] policy
     /* 2181747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181757 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2181760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2181780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181783 */     // GIR_Coverage, 18553,
     /* 2181783 */     GIR_EraseRootFromParent_Done,
     /* 2181784 */   // Label 28743: @2181784
     /* 2181784 */   GIM_Try, /*On fail goto*//*Label 28744*/ GIMT_Encode4(2181875), // Rule ID 18556 //
     /* 2181789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2181800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2181803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2181809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181835 */     // MIs[0] round
     /* 2181835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181838 */     // MIs[0] policy
     /* 2181838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181848 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2181851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181874 */     // GIR_Coverage, 18556,
     /* 2181874 */     GIR_EraseRootFromParent_Done,
     /* 2181875 */   // Label 28744: @2181875
     /* 2181875 */   GIM_Try, /*On fail goto*//*Label 28745*/ GIMT_Encode4(2181966), // Rule ID 18557 //
     /* 2181880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2181883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2181891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2181894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2181900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2181918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181926 */     // MIs[0] round
     /* 2181926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181929 */     // MIs[0] policy
     /* 2181929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181939 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2181942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181965 */     // GIR_Coverage, 18557,
     /* 2181965 */     GIR_EraseRootFromParent_Done,
     /* 2181966 */   // Label 28745: @2181966
     /* 2181966 */   GIM_Try, /*On fail goto*//*Label 28746*/ GIMT_Encode4(2182057), // Rule ID 18560 //
     /* 2181971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2181974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2181979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2181982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2181985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2181988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2181991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2181994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182017 */     // MIs[0] round
     /* 2182017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182020 */     // MIs[0] policy
     /* 2182020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182030 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2182033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182056 */     // GIR_Coverage, 18560,
     /* 2182056 */     GIR_EraseRootFromParent_Done,
     /* 2182057 */   // Label 28746: @2182057
     /* 2182057 */   GIM_Try, /*On fail goto*//*Label 28747*/ GIMT_Encode4(2182148), // Rule ID 18561 //
     /* 2182062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2182073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2182076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2182082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182108 */     // MIs[0] round
     /* 2182108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182111 */     // MIs[0] policy
     /* 2182111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182121 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2182124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182147 */     // GIR_Coverage, 18561,
     /* 2182147 */     GIR_EraseRootFromParent_Done,
     /* 2182148 */   // Label 28747: @2182148
     /* 2182148 */   GIM_Try, /*On fail goto*//*Label 28748*/ GIMT_Encode4(2182239), // Rule ID 18564 //
     /* 2182153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2182156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2182164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2182167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2182173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2182176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182199 */     // MIs[0] round
     /* 2182199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182202 */     // MIs[0] policy
     /* 2182202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182212 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2182215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182238 */     // GIR_Coverage, 18564,
     /* 2182238 */     GIR_EraseRootFromParent_Done,
     /* 2182239 */   // Label 28748: @2182239
     /* 2182239 */   GIM_Try, /*On fail goto*//*Label 28749*/ GIMT_Encode4(2182330), // Rule ID 18565 //
     /* 2182244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2182247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2182255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2182258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2182264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2182267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182290 */     // MIs[0] round
     /* 2182290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182293 */     // MIs[0] policy
     /* 2182293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182303 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2182306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182329 */     // GIR_Coverage, 18565,
     /* 2182329 */     GIR_EraseRootFromParent_Done,
     /* 2182330 */   // Label 28749: @2182330
     /* 2182330 */   GIM_Try, /*On fail goto*//*Label 28750*/ GIMT_Encode4(2182421), // Rule ID 18568 //
     /* 2182335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182381 */     // MIs[0] round
     /* 2182381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182384 */     // MIs[0] policy
     /* 2182384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182394 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2182397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182420 */     // GIR_Coverage, 18568,
     /* 2182420 */     GIR_EraseRootFromParent_Done,
     /* 2182421 */   // Label 28750: @2182421
     /* 2182421 */   GIM_Try, /*On fail goto*//*Label 28751*/ GIMT_Encode4(2182512), // Rule ID 18569 //
     /* 2182426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182472 */     // MIs[0] round
     /* 2182472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182475 */     // MIs[0] policy
     /* 2182475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182485 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2182488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182511 */     // GIR_Coverage, 18569,
     /* 2182511 */     GIR_EraseRootFromParent_Done,
     /* 2182512 */   // Label 28751: @2182512
     /* 2182512 */   GIM_Try, /*On fail goto*//*Label 28752*/ GIMT_Encode4(2182603), // Rule ID 18572 //
     /* 2182517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2182528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2182531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2182537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182563 */     // MIs[0] round
     /* 2182563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182566 */     // MIs[0] policy
     /* 2182566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182576 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2182579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182602 */     // GIR_Coverage, 18572,
     /* 2182602 */     GIR_EraseRootFromParent_Done,
     /* 2182603 */   // Label 28752: @2182603
     /* 2182603 */   GIM_Try, /*On fail goto*//*Label 28753*/ GIMT_Encode4(2182694), // Rule ID 18573 //
     /* 2182608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2182619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2182622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2182628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182654 */     // MIs[0] round
     /* 2182654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182657 */     // MIs[0] policy
     /* 2182657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182667 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2182670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182693 */     // GIR_Coverage, 18573,
     /* 2182693 */     GIR_EraseRootFromParent_Done,
     /* 2182694 */   // Label 28753: @2182694
     /* 2182694 */   GIM_Try, /*On fail goto*//*Label 28754*/ GIMT_Encode4(2182785), // Rule ID 18576 //
     /* 2182699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2182702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2182710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2182713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2182719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182745 */     // MIs[0] round
     /* 2182745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182748 */     // MIs[0] policy
     /* 2182748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182758 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2182761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182784 */     // GIR_Coverage, 18576,
     /* 2182784 */     GIR_EraseRootFromParent_Done,
     /* 2182785 */   // Label 28754: @2182785
     /* 2182785 */   GIM_Try, /*On fail goto*//*Label 28755*/ GIMT_Encode4(2182876), // Rule ID 18577 //
     /* 2182790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2182793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2182801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2182804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2182807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2182810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2182813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2182828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182836 */     // MIs[0] round
     /* 2182836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182839 */     // MIs[0] policy
     /* 2182839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182849 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2182852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182875 */     // GIR_Coverage, 18577,
     /* 2182875 */     GIR_EraseRootFromParent_Done,
     /* 2182876 */   // Label 28755: @2182876
     /* 2182876 */   GIM_Try, /*On fail goto*//*Label 28756*/ GIMT_Encode4(2182967), // Rule ID 18580 //
     /* 2182881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2182884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2182892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2182895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2182898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2182901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2182919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182927 */     // MIs[0] round
     /* 2182927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182930 */     // MIs[0] policy
     /* 2182930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182940 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2182943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2182963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182966 */     // GIR_Coverage, 18580,
     /* 2182966 */     GIR_EraseRootFromParent_Done,
     /* 2182967 */   // Label 28756: @2182967
     /* 2182967 */   GIM_Try, /*On fail goto*//*Label 28757*/ GIMT_Encode4(2183058), // Rule ID 18581 //
     /* 2182972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2182975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2182980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2182983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2182986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2182989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2182992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183018 */     // MIs[0] round
     /* 2183018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183021 */     // MIs[0] policy
     /* 2183021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183031 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2183034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183057 */     // GIR_Coverage, 18581,
     /* 2183057 */     GIR_EraseRootFromParent_Done,
     /* 2183058 */   // Label 28757: @2183058
     /* 2183058 */   GIM_Try, /*On fail goto*//*Label 28758*/ GIMT_Encode4(2183149), // Rule ID 18584 //
     /* 2183063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2183083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183109 */     // MIs[0] round
     /* 2183109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183112 */     // MIs[0] policy
     /* 2183112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183122 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2183125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183148 */     // GIR_Coverage, 18584,
     /* 2183148 */     GIR_EraseRootFromParent_Done,
     /* 2183149 */   // Label 28758: @2183149
     /* 2183149 */   GIM_Try, /*On fail goto*//*Label 28759*/ GIMT_Encode4(2183240), // Rule ID 18585 //
     /* 2183154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2183174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183200 */     // MIs[0] round
     /* 2183200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183203 */     // MIs[0] policy
     /* 2183203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183213 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2183216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183239 */     // GIR_Coverage, 18585,
     /* 2183239 */     GIR_EraseRootFromParent_Done,
     /* 2183240 */   // Label 28759: @2183240
     /* 2183240 */   GIM_Try, /*On fail goto*//*Label 28760*/ GIMT_Encode4(2183331), // Rule ID 18588 //
     /* 2183245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2183248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2183265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183291 */     // MIs[0] round
     /* 2183291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183294 */     // MIs[0] policy
     /* 2183294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183304 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2183307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183330 */     // GIR_Coverage, 18588,
     /* 2183330 */     GIR_EraseRootFromParent_Done,
     /* 2183331 */   // Label 28760: @2183331
     /* 2183331 */   GIM_Try, /*On fail goto*//*Label 28761*/ GIMT_Encode4(2183422), // Rule ID 18589 //
     /* 2183336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2183339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2183344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2183347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2183350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2183353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2183356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2183374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183382 */     // MIs[0] round
     /* 2183382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183385 */     // MIs[0] policy
     /* 2183385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183395 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2183398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2183418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183421 */     // GIR_Coverage, 18589,
     /* 2183421 */     GIR_EraseRootFromParent_Done,
     /* 2183422 */   // Label 28761: @2183422
     /* 2183422 */   GIM_Try, /*On fail goto*//*Label 28762*/ GIMT_Encode4(2183513), // Rule ID 18592 //
     /* 2183427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2183438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2183441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2183444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2183447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183473 */     // MIs[0] round
     /* 2183473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183476 */     // MIs[0] policy
     /* 2183476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183486 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2183489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183512 */     // GIR_Coverage, 18592,
     /* 2183512 */     GIR_EraseRootFromParent_Done,
     /* 2183513 */   // Label 28762: @2183513
     /* 2183513 */   GIM_Try, /*On fail goto*//*Label 28763*/ GIMT_Encode4(2183604), // Rule ID 18593 //
     /* 2183518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2183529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2183532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2183535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2183538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183564 */     // MIs[0] round
     /* 2183564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183567 */     // MIs[0] policy
     /* 2183567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183577 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2183580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183603 */     // GIR_Coverage, 18593,
     /* 2183603 */     GIR_EraseRootFromParent_Done,
     /* 2183604 */   // Label 28763: @2183604
     /* 2183604 */   GIM_Try, /*On fail goto*//*Label 28764*/ GIMT_Encode4(2183695), // Rule ID 18596 //
     /* 2183609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2183620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2183623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2183626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2183629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183655 */     // MIs[0] round
     /* 2183655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183658 */     // MIs[0] policy
     /* 2183658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183668 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2183671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183694 */     // GIR_Coverage, 18596,
     /* 2183694 */     GIR_EraseRootFromParent_Done,
     /* 2183695 */   // Label 28764: @2183695
     /* 2183695 */   GIM_Try, /*On fail goto*//*Label 28765*/ GIMT_Encode4(2183786), // Rule ID 18597 //
     /* 2183700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2183703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2183711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2183714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2183717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2183720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183746 */     // MIs[0] round
     /* 2183746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183749 */     // MIs[0] policy
     /* 2183749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183759 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2183762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183785 */     // GIR_Coverage, 18597,
     /* 2183785 */     GIR_EraseRootFromParent_Done,
     /* 2183786 */   // Label 28765: @2183786
     /* 2183786 */   GIM_Try, /*On fail goto*//*Label 28766*/ GIMT_Encode4(2183877), // Rule ID 18600 //
     /* 2183791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2183794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2183802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2183805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2183808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2183811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183837 */     // MIs[0] round
     /* 2183837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183840 */     // MIs[0] policy
     /* 2183840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183850 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2183853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183876 */     // GIR_Coverage, 18600,
     /* 2183876 */     GIR_EraseRootFromParent_Done,
     /* 2183877 */   // Label 28766: @2183877
     /* 2183877 */   GIM_Try, /*On fail goto*//*Label 28767*/ GIMT_Encode4(2183968), // Rule ID 18601 //
     /* 2183882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2183885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2183893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2183896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2183899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2183902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183928 */     // MIs[0] round
     /* 2183928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183931 */     // MIs[0] policy
     /* 2183931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183941 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2183944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183967 */     // GIR_Coverage, 18601,
     /* 2183967 */     GIR_EraseRootFromParent_Done,
     /* 2183968 */   // Label 28767: @2183968
     /* 2183968 */   GIM_Try, /*On fail goto*//*Label 28768*/ GIMT_Encode4(2184059), // Rule ID 18604 //
     /* 2183973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2183976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2183981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2183984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2183987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2183990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2183993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184019 */     // MIs[0] round
     /* 2184019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184022 */     // MIs[0] policy
     /* 2184022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184032 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2184035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184058 */     // GIR_Coverage, 18604,
     /* 2184058 */     GIR_EraseRootFromParent_Done,
     /* 2184059 */   // Label 28768: @2184059
     /* 2184059 */   GIM_Try, /*On fail goto*//*Label 28769*/ GIMT_Encode4(2184150), // Rule ID 18605 //
     /* 2184064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2184075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2184078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2184081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184110 */     // MIs[0] round
     /* 2184110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184113 */     // MIs[0] policy
     /* 2184113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184123 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2184126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184149 */     // GIR_Coverage, 18605,
     /* 2184149 */     GIR_EraseRootFromParent_Done,
     /* 2184150 */   // Label 28769: @2184150
     /* 2184150 */   GIM_Try, /*On fail goto*//*Label 28770*/ GIMT_Encode4(2184241), // Rule ID 18608 //
     /* 2184155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2184158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2184172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184201 */     // MIs[0] round
     /* 2184201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184204 */     // MIs[0] policy
     /* 2184204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184214 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2184217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184240 */     // GIR_Coverage, 18608,
     /* 2184240 */     GIR_EraseRootFromParent_Done,
     /* 2184241 */   // Label 28770: @2184241
     /* 2184241 */   GIM_Try, /*On fail goto*//*Label 28771*/ GIMT_Encode4(2184332), // Rule ID 18609 //
     /* 2184246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2184249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2184263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2184266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184292 */     // MIs[0] round
     /* 2184292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184295 */     // MIs[0] policy
     /* 2184295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184305 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2184308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184331 */     // GIR_Coverage, 18609,
     /* 2184331 */     GIR_EraseRootFromParent_Done,
     /* 2184332 */   // Label 28771: @2184332
     /* 2184332 */   GIM_Try, /*On fail goto*//*Label 28772*/ GIMT_Encode4(2184423), // Rule ID 18612 //
     /* 2184337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2184340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2184354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2184357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184383 */     // MIs[0] round
     /* 2184383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184386 */     // MIs[0] policy
     /* 2184386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184396 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2184399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184422 */     // GIR_Coverage, 18612,
     /* 2184422 */     GIR_EraseRootFromParent_Done,
     /* 2184423 */   // Label 28772: @2184423
     /* 2184423 */   GIM_Try, /*On fail goto*//*Label 28773*/ GIMT_Encode4(2184514), // Rule ID 18613 //
     /* 2184428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2184431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2184439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2184442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2184445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2184448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184474 */     // MIs[0] round
     /* 2184474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184477 */     // MIs[0] policy
     /* 2184477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184487 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2184490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2184510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184513 */     // GIR_Coverage, 18613,
     /* 2184513 */     GIR_EraseRootFromParent_Done,
     /* 2184514 */   // Label 28773: @2184514
     /* 2184514 */   GIM_Try, /*On fail goto*//*Label 28774*/ GIMT_Encode4(2184605), // Rule ID 18616 //
     /* 2184519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2184530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2184533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2184536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2184539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184565 */     // MIs[0] round
     /* 2184565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184568 */     // MIs[0] policy
     /* 2184568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184578 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2184581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184604 */     // GIR_Coverage, 18616,
     /* 2184604 */     GIR_EraseRootFromParent_Done,
     /* 2184605 */   // Label 28774: @2184605
     /* 2184605 */   GIM_Try, /*On fail goto*//*Label 28775*/ GIMT_Encode4(2184696), // Rule ID 18617 //
     /* 2184610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2184621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2184624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2184627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2184630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184656 */     // MIs[0] round
     /* 2184656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184659 */     // MIs[0] policy
     /* 2184659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184669 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2184672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184695 */     // GIR_Coverage, 18617,
     /* 2184695 */     GIR_EraseRootFromParent_Done,
     /* 2184696 */   // Label 28775: @2184696
     /* 2184696 */   GIM_Try, /*On fail goto*//*Label 28776*/ GIMT_Encode4(2184787), // Rule ID 18620 //
     /* 2184701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2184712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2184715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2184718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2184721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2184724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184747 */     // MIs[0] round
     /* 2184747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184750 */     // MIs[0] policy
     /* 2184750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184760 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2184763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184786 */     // GIR_Coverage, 18620,
     /* 2184786 */     GIR_EraseRootFromParent_Done,
     /* 2184787 */   // Label 28776: @2184787
     /* 2184787 */   GIM_Try, /*On fail goto*//*Label 28777*/ GIMT_Encode4(2184878), // Rule ID 18621 //
     /* 2184792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2184803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2184806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2184809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2184812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2184815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184838 */     // MIs[0] round
     /* 2184838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184841 */     // MIs[0] policy
     /* 2184841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184851 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2184854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184877 */     // GIR_Coverage, 18621,
     /* 2184877 */     GIR_EraseRootFromParent_Done,
     /* 2184878 */   // Label 28777: @2184878
     /* 2184878 */   GIM_Try, /*On fail goto*//*Label 28778*/ GIMT_Encode4(2184969), // Rule ID 18624 //
     /* 2184883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2184886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2184894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2184897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2184900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2184903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2184906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2184913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184929 */     // MIs[0] round
     /* 2184929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184932 */     // MIs[0] policy
     /* 2184932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184942 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2184945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184968 */     // GIR_Coverage, 18624,
     /* 2184968 */     GIR_EraseRootFromParent_Done,
     /* 2184969 */   // Label 28778: @2184969
     /* 2184969 */   GIM_Try, /*On fail goto*//*Label 28779*/ GIMT_Encode4(2185060), // Rule ID 18625 //
     /* 2184974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2184977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2184982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2184985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2184988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2184991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2184994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2184997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185020 */     // MIs[0] round
     /* 2185020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185023 */     // MIs[0] policy
     /* 2185023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185033 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2185036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185059 */     // GIR_Coverage, 18625,
     /* 2185059 */     GIR_EraseRootFromParent_Done,
     /* 2185060 */   // Label 28779: @2185060
     /* 2185060 */   GIM_Try, /*On fail goto*//*Label 28780*/ GIMT_Encode4(2185151), // Rule ID 18628 //
     /* 2185065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185111 */     // MIs[0] round
     /* 2185111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185114 */     // MIs[0] policy
     /* 2185114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2185127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185150 */     // GIR_Coverage, 18628,
     /* 2185150 */     GIR_EraseRootFromParent_Done,
     /* 2185151 */   // Label 28780: @2185151
     /* 2185151 */   GIM_Try, /*On fail goto*//*Label 28781*/ GIMT_Encode4(2185242), // Rule ID 18629 //
     /* 2185156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2185167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2185170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185202 */     // MIs[0] round
     /* 2185202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185205 */     // MIs[0] policy
     /* 2185205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185215 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2185218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185241 */     // GIR_Coverage, 18629,
     /* 2185241 */     GIR_EraseRootFromParent_Done,
     /* 2185242 */   // Label 28781: @2185242
     /* 2185242 */   GIM_Try, /*On fail goto*//*Label 28782*/ GIMT_Encode4(2185333), // Rule ID 18632 //
     /* 2185247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185293 */     // MIs[0] round
     /* 2185293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185296 */     // MIs[0] policy
     /* 2185296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185306 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2185309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185332 */     // GIR_Coverage, 18632,
     /* 2185332 */     GIR_EraseRootFromParent_Done,
     /* 2185333 */   // Label 28782: @2185333
     /* 2185333 */   GIM_Try, /*On fail goto*//*Label 28783*/ GIMT_Encode4(2185424), // Rule ID 18633 //
     /* 2185338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2185349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2185352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185384 */     // MIs[0] round
     /* 2185384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185387 */     // MIs[0] policy
     /* 2185387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185397 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2185400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185423 */     // GIR_Coverage, 18633,
     /* 2185423 */     GIR_EraseRootFromParent_Done,
     /* 2185424 */   // Label 28783: @2185424
     /* 2185424 */   GIM_Try, /*On fail goto*//*Label 28784*/ GIMT_Encode4(2185515), // Rule ID 18636 //
     /* 2185429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2185432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2185440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2185443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2185446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2185449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185475 */     // MIs[0] round
     /* 2185475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185478 */     // MIs[0] policy
     /* 2185478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185488 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2185491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185514 */     // GIR_Coverage, 18636,
     /* 2185514 */     GIR_EraseRootFromParent_Done,
     /* 2185515 */   // Label 28784: @2185515
     /* 2185515 */   GIM_Try, /*On fail goto*//*Label 28785*/ GIMT_Encode4(2185606), // Rule ID 18637 //
     /* 2185520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2185523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2185531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2185534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2185537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2185540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185566 */     // MIs[0] round
     /* 2185566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185569 */     // MIs[0] policy
     /* 2185569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185579 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2185582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185605 */     // GIR_Coverage, 18637,
     /* 2185605 */     GIR_EraseRootFromParent_Done,
     /* 2185606 */   // Label 28785: @2185606
     /* 2185606 */   GIM_Try, /*On fail goto*//*Label 28786*/ GIMT_Encode4(2185697), // Rule ID 18640 //
     /* 2185611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2185614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2185622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2185625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2185628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2185631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185657 */     // MIs[0] round
     /* 2185657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185660 */     // MIs[0] policy
     /* 2185660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185670 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2185673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185696 */     // GIR_Coverage, 18640,
     /* 2185696 */     GIR_EraseRootFromParent_Done,
     /* 2185697 */   // Label 28786: @2185697
     /* 2185697 */   GIM_Try, /*On fail goto*//*Label 28787*/ GIMT_Encode4(2185788), // Rule ID 18641 //
     /* 2185702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2185705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2185713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2185716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2185719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2185722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185748 */     // MIs[0] round
     /* 2185748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185751 */     // MIs[0] policy
     /* 2185751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185761 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2185764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185787 */     // GIR_Coverage, 18641,
     /* 2185787 */     GIR_EraseRootFromParent_Done,
     /* 2185788 */   // Label 28787: @2185788
     /* 2185788 */   GIM_Try, /*On fail goto*//*Label 28788*/ GIMT_Encode4(2185879), // Rule ID 18644 //
     /* 2185793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2185796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2185804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2185807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2185810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2185813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185839 */     // MIs[0] round
     /* 2185839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185842 */     // MIs[0] policy
     /* 2185842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2185855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185878 */     // GIR_Coverage, 18644,
     /* 2185878 */     GIR_EraseRootFromParent_Done,
     /* 2185879 */   // Label 28788: @2185879
     /* 2185879 */   GIM_Try, /*On fail goto*//*Label 28789*/ GIMT_Encode4(2185970), // Rule ID 18645 //
     /* 2185884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2185887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2185895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2185898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2185901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2185904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185930 */     // MIs[0] round
     /* 2185930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185933 */     // MIs[0] policy
     /* 2185933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185943 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2185946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2185966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185969 */     // GIR_Coverage, 18645,
     /* 2185969 */     GIR_EraseRootFromParent_Done,
     /* 2185970 */   // Label 28789: @2185970
     /* 2185970 */   GIM_Try, /*On fail goto*//*Label 28790*/ GIMT_Encode4(2186061), // Rule ID 18648 //
     /* 2185975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2185978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2185983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2185986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2185989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2185992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2185995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186021 */     // MIs[0] round
     /* 2186021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186024 */     // MIs[0] policy
     /* 2186024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186034 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2186037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186060 */     // GIR_Coverage, 18648,
     /* 2186060 */     GIR_EraseRootFromParent_Done,
     /* 2186061 */   // Label 28790: @2186061
     /* 2186061 */   GIM_Try, /*On fail goto*//*Label 28791*/ GIMT_Encode4(2186152), // Rule ID 18649 //
     /* 2186066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2186069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2186077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2186080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2186083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2186086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186112 */     // MIs[0] round
     /* 2186112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186115 */     // MIs[0] policy
     /* 2186115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186125 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2186128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2186148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186151 */     // GIR_Coverage, 18649,
     /* 2186151 */     GIR_EraseRootFromParent_Done,
     /* 2186152 */   // Label 28791: @2186152
     /* 2186152 */   GIM_Try, /*On fail goto*//*Label 28792*/ GIMT_Encode4(2186243), // Rule ID 18652 //
     /* 2186157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2186168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2186171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2186177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186203 */     // MIs[0] round
     /* 2186203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186206 */     // MIs[0] policy
     /* 2186206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186216 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2186219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186242 */     // GIR_Coverage, 18652,
     /* 2186242 */     GIR_EraseRootFromParent_Done,
     /* 2186243 */   // Label 28792: @2186243
     /* 2186243 */   GIM_Try, /*On fail goto*//*Label 28793*/ GIMT_Encode4(2186334), // Rule ID 18653 //
     /* 2186248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2186259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2186262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2186268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186294 */     // MIs[0] round
     /* 2186294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186297 */     // MIs[0] policy
     /* 2186297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186307 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2186310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186333 */     // GIR_Coverage, 18653,
     /* 2186333 */     GIR_EraseRootFromParent_Done,
     /* 2186334 */   // Label 28793: @2186334
     /* 2186334 */   GIM_Try, /*On fail goto*//*Label 28794*/ GIMT_Encode4(2186425), // Rule ID 18656 //
     /* 2186339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2186350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2186353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186385 */     // MIs[0] round
     /* 2186385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186388 */     // MIs[0] policy
     /* 2186388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186398 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2186401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186424 */     // GIR_Coverage, 18656,
     /* 2186424 */     GIR_EraseRootFromParent_Done,
     /* 2186425 */   // Label 28794: @2186425
     /* 2186425 */   GIM_Try, /*On fail goto*//*Label 28795*/ GIMT_Encode4(2186516), // Rule ID 18657 //
     /* 2186430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2186441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2186444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186476 */     // MIs[0] round
     /* 2186476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186479 */     // MIs[0] policy
     /* 2186479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186489 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2186492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186515 */     // GIR_Coverage, 18657,
     /* 2186515 */     GIR_EraseRootFromParent_Done,
     /* 2186516 */   // Label 28795: @2186516
     /* 2186516 */   GIM_Try, /*On fail goto*//*Label 28796*/ GIMT_Encode4(2186607), // Rule ID 18660 //
     /* 2186521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2186532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2186535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2186541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186567 */     // MIs[0] round
     /* 2186567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186570 */     // MIs[0] policy
     /* 2186570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186580 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2186583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186606 */     // GIR_Coverage, 18660,
     /* 2186606 */     GIR_EraseRootFromParent_Done,
     /* 2186607 */   // Label 28796: @2186607
     /* 2186607 */   GIM_Try, /*On fail goto*//*Label 28797*/ GIMT_Encode4(2186698), // Rule ID 18661 //
     /* 2186612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2186615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2186623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2186626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2186632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186658 */     // MIs[0] round
     /* 2186658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186661 */     // MIs[0] policy
     /* 2186661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186671 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2186674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186697 */     // GIR_Coverage, 18661,
     /* 2186697 */     GIR_EraseRootFromParent_Done,
     /* 2186698 */   // Label 28797: @2186698
     /* 2186698 */   GIM_Try, /*On fail goto*//*Label 28798*/ GIMT_Encode4(2186789), // Rule ID 18664 //
     /* 2186703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2186706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2186714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2186717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2186723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186749 */     // MIs[0] round
     /* 2186749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186752 */     // MIs[0] policy
     /* 2186752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186762 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2186765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186788 */     // GIR_Coverage, 18664,
     /* 2186788 */     GIR_EraseRootFromParent_Done,
     /* 2186789 */   // Label 28798: @2186789
     /* 2186789 */   GIM_Try, /*On fail goto*//*Label 28799*/ GIMT_Encode4(2186880), // Rule ID 18665 //
     /* 2186794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2186797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2186805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2186808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2186814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186840 */     // MIs[0] round
     /* 2186840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186843 */     // MIs[0] policy
     /* 2186843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186853 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11248:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2186856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186879 */     // GIR_Coverage, 18665,
     /* 2186879 */     GIR_EraseRootFromParent_Done,
     /* 2186880 */   // Label 28799: @2186880
     /* 2186880 */   GIM_Try, /*On fail goto*//*Label 28800*/ GIMT_Encode4(2186971), // Rule ID 18668 //
     /* 2186885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2186888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2186896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2186899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2186905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186931 */     // MIs[0] round
     /* 2186931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186934 */     // MIs[0] policy
     /* 2186934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186944 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2186947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186970 */     // GIR_Coverage, 18668,
     /* 2186970 */     GIR_EraseRootFromParent_Done,
     /* 2186971 */   // Label 28800: @2186971
     /* 2186971 */   GIM_Try, /*On fail goto*//*Label 28801*/ GIMT_Encode4(2187062), // Rule ID 18669 //
     /* 2186976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2186979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2186984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2186987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2186990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2186996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187022 */     // MIs[0] round
     /* 2187022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187025 */     // MIs[0] policy
     /* 2187025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187035 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2187038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187061 */     // GIR_Coverage, 18669,
     /* 2187061 */     GIR_EraseRootFromParent_Done,
     /* 2187062 */   // Label 28801: @2187062
     /* 2187062 */   GIM_Try, /*On fail goto*//*Label 28802*/ GIMT_Encode4(2187153), // Rule ID 18672 //
     /* 2187067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2187070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2187087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187113 */     // MIs[0] round
     /* 2187113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187116 */     // MIs[0] policy
     /* 2187116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187126 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2187129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187152 */     // GIR_Coverage, 18672,
     /* 2187152 */     GIR_EraseRootFromParent_Done,
     /* 2187153 */   // Label 28802: @2187153
     /* 2187153 */   GIM_Try, /*On fail goto*//*Label 28803*/ GIMT_Encode4(2187244), // Rule ID 18673 //
     /* 2187158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2187161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2187169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2187172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2187175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2187178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2187196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187204 */     // MIs[0] round
     /* 2187204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187207 */     // MIs[0] policy
     /* 2187207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187217 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2187220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2187240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187243 */     // GIR_Coverage, 18673,
     /* 2187243 */     GIR_EraseRootFromParent_Done,
     /* 2187244 */   // Label 28803: @2187244
     /* 2187244 */   GIM_Try, /*On fail goto*//*Label 28804*/ GIMT_Encode4(2187335), // Rule ID 18676 //
     /* 2187249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2187260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2187263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187295 */     // MIs[0] round
     /* 2187295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187298 */     // MIs[0] policy
     /* 2187298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187308 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2187311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187334 */     // GIR_Coverage, 18676,
     /* 2187334 */     GIR_EraseRootFromParent_Done,
     /* 2187335 */   // Label 28804: @2187335
     /* 2187335 */   GIM_Try, /*On fail goto*//*Label 28805*/ GIMT_Encode4(2187426), // Rule ID 18677 //
     /* 2187340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2187351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2187354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2187360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187386 */     // MIs[0] round
     /* 2187386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187389 */     // MIs[0] policy
     /* 2187389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187399 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2187402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187425 */     // GIR_Coverage, 18677,
     /* 2187425 */     GIR_EraseRootFromParent_Done,
     /* 2187426 */   // Label 28805: @2187426
     /* 2187426 */   GIM_Try, /*On fail goto*//*Label 28806*/ GIMT_Encode4(2187517), // Rule ID 18680 //
     /* 2187431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2187442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2187445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2187451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2187454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187477 */     // MIs[0] round
     /* 2187477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187480 */     // MIs[0] policy
     /* 2187480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187490 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2187493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187516 */     // GIR_Coverage, 18680,
     /* 2187516 */     GIR_EraseRootFromParent_Done,
     /* 2187517 */   // Label 28806: @2187517
     /* 2187517 */   GIM_Try, /*On fail goto*//*Label 28807*/ GIMT_Encode4(2187608), // Rule ID 18681 //
     /* 2187522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2187533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2187536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2187542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2187545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187568 */     // MIs[0] round
     /* 2187568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187571 */     // MIs[0] policy
     /* 2187571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187581 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2187584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187607 */     // GIR_Coverage, 18681,
     /* 2187607 */     GIR_EraseRootFromParent_Done,
     /* 2187608 */   // Label 28807: @2187608
     /* 2187608 */   GIM_Try, /*On fail goto*//*Label 28808*/ GIMT_Encode4(2187699), // Rule ID 18684 //
     /* 2187613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2187616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2187624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2187627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2187633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2187636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187659 */     // MIs[0] round
     /* 2187659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187662 */     // MIs[0] policy
     /* 2187662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187672 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2187675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187698 */     // GIR_Coverage, 18684,
     /* 2187698 */     GIR_EraseRootFromParent_Done,
     /* 2187699 */   // Label 28808: @2187699
     /* 2187699 */   GIM_Try, /*On fail goto*//*Label 28809*/ GIMT_Encode4(2187790), // Rule ID 18685 //
     /* 2187704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2187707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2187715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2187718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2187721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2187724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2187727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2187742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187750 */     // MIs[0] round
     /* 2187750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187753 */     // MIs[0] policy
     /* 2187753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187763 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2187766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187789 */     // GIR_Coverage, 18685,
     /* 2187789 */     GIR_EraseRootFromParent_Done,
     /* 2187790 */   // Label 28809: @2187790
     /* 2187790 */   GIM_Try, /*On fail goto*//*Label 28810*/ GIMT_Encode4(2187881), // Rule ID 18688 //
     /* 2187795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2187806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2187809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2187815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187841 */     // MIs[0] round
     /* 2187841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187844 */     // MIs[0] policy
     /* 2187844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2187857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187880 */     // GIR_Coverage, 18688,
     /* 2187880 */     GIR_EraseRootFromParent_Done,
     /* 2187881 */   // Label 28810: @2187881
     /* 2187881 */   GIM_Try, /*On fail goto*//*Label 28811*/ GIMT_Encode4(2187972), // Rule ID 18689 //
     /* 2187886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2187889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2187897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2187900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2187906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187932 */     // MIs[0] round
     /* 2187932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187935 */     // MIs[0] policy
     /* 2187935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187945 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2187948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187971 */     // GIR_Coverage, 18689,
     /* 2187971 */     GIR_EraseRootFromParent_Done,
     /* 2187972 */   // Label 28811: @2187972
     /* 2187972 */   GIM_Try, /*On fail goto*//*Label 28812*/ GIMT_Encode4(2188063), // Rule ID 18692 //
     /* 2187977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2187980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2187985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2187988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2187991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2187997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188023 */     // MIs[0] round
     /* 2188023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188026 */     // MIs[0] policy
     /* 2188026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188036 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2188039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188062 */     // GIR_Coverage, 18692,
     /* 2188062 */     GIR_EraseRootFromParent_Done,
     /* 2188063 */   // Label 28812: @2188063
     /* 2188063 */   GIM_Try, /*On fail goto*//*Label 28813*/ GIMT_Encode4(2188154), // Rule ID 18693 //
     /* 2188068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2188079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2188082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188114 */     // MIs[0] round
     /* 2188114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188117 */     // MIs[0] policy
     /* 2188117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188127 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2188130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188153 */     // GIR_Coverage, 18693,
     /* 2188153 */     GIR_EraseRootFromParent_Done,
     /* 2188154 */   // Label 28813: @2188154
     /* 2188154 */   GIM_Try, /*On fail goto*//*Label 28814*/ GIMT_Encode4(2188245), // Rule ID 18696 //
     /* 2188159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2188162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2188179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188205 */     // MIs[0] round
     /* 2188205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188208 */     // MIs[0] policy
     /* 2188208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188218 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2188221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188244 */     // GIR_Coverage, 18696,
     /* 2188244 */     GIR_EraseRootFromParent_Done,
     /* 2188245 */   // Label 28814: @2188245
     /* 2188245 */   GIM_Try, /*On fail goto*//*Label 28815*/ GIMT_Encode4(2188336), // Rule ID 18697 //
     /* 2188250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2188253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2188267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2188270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2188288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188296 */     // MIs[0] round
     /* 2188296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188299 */     // MIs[0] policy
     /* 2188299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188309 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2188312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188335 */     // GIR_Coverage, 18697,
     /* 2188335 */     GIR_EraseRootFromParent_Done,
     /* 2188336 */   // Label 28815: @2188336
     /* 2188336 */   GIM_Try, /*On fail goto*//*Label 28816*/ GIMT_Encode4(2188427), // Rule ID 18700 //
     /* 2188341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2188361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188387 */     // MIs[0] round
     /* 2188387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188390 */     // MIs[0] policy
     /* 2188390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188400 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2188403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188426 */     // GIR_Coverage, 18700,
     /* 2188426 */     GIR_EraseRootFromParent_Done,
     /* 2188427 */   // Label 28816: @2188427
     /* 2188427 */   GIM_Try, /*On fail goto*//*Label 28817*/ GIMT_Encode4(2188518), // Rule ID 18701 //
     /* 2188432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2188452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188478 */     // MIs[0] round
     /* 2188478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188481 */     // MIs[0] policy
     /* 2188481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188491 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2188494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188517 */     // GIR_Coverage, 18701,
     /* 2188517 */     GIR_EraseRootFromParent_Done,
     /* 2188518 */   // Label 28817: @2188518
     /* 2188518 */   GIM_Try, /*On fail goto*//*Label 28818*/ GIMT_Encode4(2188609), // Rule ID 18704 //
     /* 2188523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2188534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2188537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2188543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188569 */     // MIs[0] round
     /* 2188569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188572 */     // MIs[0] policy
     /* 2188572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188582 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2188585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188608 */     // GIR_Coverage, 18704,
     /* 2188608 */     GIR_EraseRootFromParent_Done,
     /* 2188609 */   // Label 28818: @2188609
     /* 2188609 */   GIM_Try, /*On fail goto*//*Label 28819*/ GIMT_Encode4(2188700), // Rule ID 18705 //
     /* 2188614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2188625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2188628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2188634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188660 */     // MIs[0] round
     /* 2188660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188663 */     // MIs[0] policy
     /* 2188663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188673 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2188676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188699 */     // GIR_Coverage, 18705,
     /* 2188699 */     GIR_EraseRootFromParent_Done,
     /* 2188700 */   // Label 28819: @2188700
     /* 2188700 */   GIM_Try, /*On fail goto*//*Label 28820*/ GIMT_Encode4(2188791), // Rule ID 18708 //
     /* 2188705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2188708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2188716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2188719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2188725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188751 */     // MIs[0] round
     /* 2188751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188754 */     // MIs[0] policy
     /* 2188754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188764 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2188767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188790 */     // GIR_Coverage, 18708,
     /* 2188790 */     GIR_EraseRootFromParent_Done,
     /* 2188791 */   // Label 28820: @2188791
     /* 2188791 */   GIM_Try, /*On fail goto*//*Label 28821*/ GIMT_Encode4(2188882), // Rule ID 18709 //
     /* 2188796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2188799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2188804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2188807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2188810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2188813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2188816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2188834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188842 */     // MIs[0] round
     /* 2188842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188845 */     // MIs[0] policy
     /* 2188845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188855 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2188858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2188878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188881 */     // GIR_Coverage, 18709,
     /* 2188881 */     GIR_EraseRootFromParent_Done,
     /* 2188882 */   // Label 28821: @2188882
     /* 2188882 */   GIM_Try, /*On fail goto*//*Label 28822*/ GIMT_Encode4(2188973), // Rule ID 18712 //
     /* 2188887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2188890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2188895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2188898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2188901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2188904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2188907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2188910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188933 */     // MIs[0] round
     /* 2188933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188936 */     // MIs[0] policy
     /* 2188936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188946 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2188949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188972 */     // GIR_Coverage, 18712,
     /* 2188972 */     GIR_EraseRootFromParent_Done,
     /* 2188973 */   // Label 28822: @2188973
     /* 2188973 */   GIM_Try, /*On fail goto*//*Label 28823*/ GIMT_Encode4(2189064), // Rule ID 18713 //
     /* 2188978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2188981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2188986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2188989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2188992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2188995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2188998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189024 */     // MIs[0] round
     /* 2189024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189027 */     // MIs[0] policy
     /* 2189027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189037 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2189040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189063 */     // GIR_Coverage, 18713,
     /* 2189063 */     GIR_EraseRootFromParent_Done,
     /* 2189064 */   // Label 28823: @2189064
     /* 2189064 */   GIM_Try, /*On fail goto*//*Label 28824*/ GIMT_Encode4(2189155), // Rule ID 18716 //
     /* 2189069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2189086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189115 */     // MIs[0] round
     /* 2189115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189118 */     // MIs[0] policy
     /* 2189118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189128 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2189131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189154 */     // GIR_Coverage, 18716,
     /* 2189154 */     GIR_EraseRootFromParent_Done,
     /* 2189155 */   // Label 28824: @2189155
     /* 2189155 */   GIM_Try, /*On fail goto*//*Label 28825*/ GIMT_Encode4(2189246), // Rule ID 18717 //
     /* 2189160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2189177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189206 */     // MIs[0] round
     /* 2189206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189209 */     // MIs[0] policy
     /* 2189209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189219 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2189222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189245 */     // GIR_Coverage, 18717,
     /* 2189245 */     GIR_EraseRootFromParent_Done,
     /* 2189246 */   // Label 28825: @2189246
     /* 2189246 */   GIM_Try, /*On fail goto*//*Label 28826*/ GIMT_Encode4(2189337), // Rule ID 18720 //
     /* 2189251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2189268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189297 */     // MIs[0] round
     /* 2189297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189300 */     // MIs[0] policy
     /* 2189300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189310 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2189313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189336 */     // GIR_Coverage, 18720,
     /* 2189336 */     GIR_EraseRootFromParent_Done,
     /* 2189337 */   // Label 28826: @2189337
     /* 2189337 */   GIM_Try, /*On fail goto*//*Label 28827*/ GIMT_Encode4(2189428), // Rule ID 18721 //
     /* 2189342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2189359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189388 */     // MIs[0] round
     /* 2189388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189391 */     // MIs[0] policy
     /* 2189391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189401 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2189404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189427 */     // GIR_Coverage, 18721,
     /* 2189427 */     GIR_EraseRootFromParent_Done,
     /* 2189428 */   // Label 28827: @2189428
     /* 2189428 */   GIM_Try, /*On fail goto*//*Label 28828*/ GIMT_Encode4(2189519), // Rule ID 18724 //
     /* 2189433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2189450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189479 */     // MIs[0] round
     /* 2189479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189482 */     // MIs[0] policy
     /* 2189482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189492 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2189495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189518 */     // GIR_Coverage, 18724,
     /* 2189518 */     GIR_EraseRootFromParent_Done,
     /* 2189519 */   // Label 28828: @2189519
     /* 2189519 */   GIM_Try, /*On fail goto*//*Label 28829*/ GIMT_Encode4(2189610), // Rule ID 18725 //
     /* 2189524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2189541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189570 */     // MIs[0] round
     /* 2189570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189573 */     // MIs[0] policy
     /* 2189573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189583 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2189586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189609 */     // GIR_Coverage, 18725,
     /* 2189609 */     GIR_EraseRootFromParent_Done,
     /* 2189610 */   // Label 28829: @2189610
     /* 2189610 */   GIM_Try, /*On fail goto*//*Label 28830*/ GIMT_Encode4(2189701), // Rule ID 18728 //
     /* 2189615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2189632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2189635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189661 */     // MIs[0] round
     /* 2189661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189664 */     // MIs[0] policy
     /* 2189664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189674 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2189677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189700 */     // GIR_Coverage, 18728,
     /* 2189700 */     GIR_EraseRootFromParent_Done,
     /* 2189701 */   // Label 28830: @2189701
     /* 2189701 */   GIM_Try, /*On fail goto*//*Label 28831*/ GIMT_Encode4(2189792), // Rule ID 18729 //
     /* 2189706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2189723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2189726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189752 */     // MIs[0] round
     /* 2189752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189755 */     // MIs[0] policy
     /* 2189755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189765 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2189768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189791 */     // GIR_Coverage, 18729,
     /* 2189791 */     GIR_EraseRootFromParent_Done,
     /* 2189792 */   // Label 28831: @2189792
     /* 2189792 */   GIM_Try, /*On fail goto*//*Label 28832*/ GIMT_Encode4(2189883), // Rule ID 18732 //
     /* 2189797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2189800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2189808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2189811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2189814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2189817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189843 */     // MIs[0] round
     /* 2189843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189846 */     // MIs[0] policy
     /* 2189846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189856 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2189859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189882 */     // GIR_Coverage, 18732,
     /* 2189882 */     GIR_EraseRootFromParent_Done,
     /* 2189883 */   // Label 28832: @2189883
     /* 2189883 */   GIM_Try, /*On fail goto*//*Label 28833*/ GIMT_Encode4(2189974), // Rule ID 18733 //
     /* 2189888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2189891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2189899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2189902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2189905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2189908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189934 */     // MIs[0] round
     /* 2189934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189937 */     // MIs[0] policy
     /* 2189937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189947 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2189950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189973 */     // GIR_Coverage, 18733,
     /* 2189973 */     GIR_EraseRootFromParent_Done,
     /* 2189974 */   // Label 28833: @2189974
     /* 2189974 */   GIM_Try, /*On fail goto*//*Label 28834*/ GIMT_Encode4(2190065), // Rule ID 18736 //
     /* 2189979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2189982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2189987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2189990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2189993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2189996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2189999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190025 */     // MIs[0] round
     /* 2190025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190028 */     // MIs[0] policy
     /* 2190028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190038 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2190041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190064 */     // GIR_Coverage, 18736,
     /* 2190064 */     GIR_EraseRootFromParent_Done,
     /* 2190065 */   // Label 28834: @2190065
     /* 2190065 */   GIM_Try, /*On fail goto*//*Label 28835*/ GIMT_Encode4(2190156), // Rule ID 18737 //
     /* 2190070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2190081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2190084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2190087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190116 */     // MIs[0] round
     /* 2190116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190119 */     // MIs[0] policy
     /* 2190119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190129 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2190132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190155 */     // GIR_Coverage, 18737,
     /* 2190155 */     GIR_EraseRootFromParent_Done,
     /* 2190156 */   // Label 28835: @2190156
     /* 2190156 */   GIM_Try, /*On fail goto*//*Label 28836*/ GIMT_Encode4(2190247), // Rule ID 18740 //
     /* 2190161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2190178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190207 */     // MIs[0] round
     /* 2190207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190210 */     // MIs[0] policy
     /* 2190210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190220 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2190223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190246 */     // GIR_Coverage, 18740,
     /* 2190246 */     GIR_EraseRootFromParent_Done,
     /* 2190247 */   // Label 28836: @2190247
     /* 2190247 */   GIM_Try, /*On fail goto*//*Label 28837*/ GIMT_Encode4(2190338), // Rule ID 18741 //
     /* 2190252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2190269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190298 */     // MIs[0] round
     /* 2190298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190301 */     // MIs[0] policy
     /* 2190301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190311 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2190314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190337 */     // GIR_Coverage, 18741,
     /* 2190337 */     GIR_EraseRootFromParent_Done,
     /* 2190338 */   // Label 28837: @2190338
     /* 2190338 */   GIM_Try, /*On fail goto*//*Label 28838*/ GIMT_Encode4(2190429), // Rule ID 18744 //
     /* 2190343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190389 */     // MIs[0] round
     /* 2190389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190392 */     // MIs[0] policy
     /* 2190392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190402 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2190405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190428 */     // GIR_Coverage, 18744,
     /* 2190428 */     GIR_EraseRootFromParent_Done,
     /* 2190429 */   // Label 28838: @2190429
     /* 2190429 */   GIM_Try, /*On fail goto*//*Label 28839*/ GIMT_Encode4(2190520), // Rule ID 18745 //
     /* 2190434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2190451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190480 */     // MIs[0] round
     /* 2190480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190483 */     // MIs[0] policy
     /* 2190483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190493 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2190496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190519 */     // GIR_Coverage, 18745,
     /* 2190519 */     GIR_EraseRootFromParent_Done,
     /* 2190520 */   // Label 28839: @2190520
     /* 2190520 */   GIM_Try, /*On fail goto*//*Label 28840*/ GIMT_Encode4(2190611), // Rule ID 18748 //
     /* 2190525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2190536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2190539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2190545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190571 */     // MIs[0] round
     /* 2190571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190574 */     // MIs[0] policy
     /* 2190574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190584 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2190587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190610 */     // GIR_Coverage, 18748,
     /* 2190610 */     GIR_EraseRootFromParent_Done,
     /* 2190611 */   // Label 28840: @2190611
     /* 2190611 */   GIM_Try, /*On fail goto*//*Label 28841*/ GIMT_Encode4(2190702), // Rule ID 18749 //
     /* 2190616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2190627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2190630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2190636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190662 */     // MIs[0] round
     /* 2190662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190665 */     // MIs[0] policy
     /* 2190665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190675 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2190678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190701 */     // GIR_Coverage, 18749,
     /* 2190701 */     GIR_EraseRootFromParent_Done,
     /* 2190702 */   // Label 28841: @2190702
     /* 2190702 */   GIM_Try, /*On fail goto*//*Label 28842*/ GIMT_Encode4(2190793), // Rule ID 18752 //
     /* 2190707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2190718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2190721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2190727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190753 */     // MIs[0] round
     /* 2190753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190756 */     // MIs[0] policy
     /* 2190756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190766 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2190769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190792 */     // GIR_Coverage, 18752,
     /* 2190792 */     GIR_EraseRootFromParent_Done,
     /* 2190793 */   // Label 28842: @2190793
     /* 2190793 */   GIM_Try, /*On fail goto*//*Label 28843*/ GIMT_Encode4(2190884), // Rule ID 18753 //
     /* 2190798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2190809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2190812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2190818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190844 */     // MIs[0] round
     /* 2190844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190847 */     // MIs[0] policy
     /* 2190847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190857 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11300:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2190860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190883 */     // GIR_Coverage, 18753,
     /* 2190883 */     GIR_EraseRootFromParent_Done,
     /* 2190884 */   // Label 28843: @2190884
     /* 2190884 */   GIM_Try, /*On fail goto*//*Label 28844*/ GIMT_Encode4(2190975), // Rule ID 18756 //
     /* 2190889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2190892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2190900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2190903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2190909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2190927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190935 */     // MIs[0] round
     /* 2190935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190938 */     // MIs[0] policy
     /* 2190938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190948 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2190951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190974 */     // GIR_Coverage, 18756,
     /* 2190974 */     GIR_EraseRootFromParent_Done,
     /* 2190975 */   // Label 28844: @2190975
     /* 2190975 */   GIM_Try, /*On fail goto*//*Label 28845*/ GIMT_Encode4(2191066), // Rule ID 18757 //
     /* 2190980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2190983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2190988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2190991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2190994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2190997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2191000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191026 */     // MIs[0] round
     /* 2191026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191029 */     // MIs[0] policy
     /* 2191029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191039 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2191042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191065 */     // GIR_Coverage, 18757,
     /* 2191065 */     GIR_EraseRootFromParent_Done,
     /* 2191066 */   // Label 28845: @2191066
     /* 2191066 */   GIM_Try, /*On fail goto*//*Label 28846*/ GIMT_Encode4(2191157), // Rule ID 18760 //
     /* 2191071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191117 */     // MIs[0] round
     /* 2191117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191120 */     // MIs[0] policy
     /* 2191120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191130 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2191133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191156 */     // GIR_Coverage, 18760,
     /* 2191156 */     GIR_EraseRootFromParent_Done,
     /* 2191157 */   // Label 28846: @2191157
     /* 2191157 */   GIM_Try, /*On fail goto*//*Label 28847*/ GIMT_Encode4(2191248), // Rule ID 18761 //
     /* 2191162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2191173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2191176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2191182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191208 */     // MIs[0] round
     /* 2191208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191211 */     // MIs[0] policy
     /* 2191211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191221 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2191224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191247 */     // GIR_Coverage, 18761,
     /* 2191247 */     GIR_EraseRootFromParent_Done,
     /* 2191248 */   // Label 28847: @2191248
     /* 2191248 */   GIM_Try, /*On fail goto*//*Label 28848*/ GIMT_Encode4(2191339), // Rule ID 18764 //
     /* 2191253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2191256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2191264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2191267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191299 */     // MIs[0] round
     /* 2191299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191302 */     // MIs[0] policy
     /* 2191302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191312 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2191315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191338 */     // GIR_Coverage, 18764,
     /* 2191338 */     GIR_EraseRootFromParent_Done,
     /* 2191339 */   // Label 28848: @2191339
     /* 2191339 */   GIM_Try, /*On fail goto*//*Label 28849*/ GIMT_Encode4(2191430), // Rule ID 18765 //
     /* 2191344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2191347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2191355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2191358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2191361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2191364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2191374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2191382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191390 */     // MIs[0] round
     /* 2191390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191393 */     // MIs[0] policy
     /* 2191393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191403 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2191406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2191426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191429 */     // GIR_Coverage, 18765,
     /* 2191429 */     GIR_EraseRootFromParent_Done,
     /* 2191430 */   // Label 28849: @2191430
     /* 2191430 */   GIM_Try, /*On fail goto*//*Label 28850*/ GIMT_Encode4(2191521), // Rule ID 18768 //
     /* 2191435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2191446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2191449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2191455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191481 */     // MIs[0] round
     /* 2191481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191484 */     // MIs[0] policy
     /* 2191484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191494 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2191497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191520 */     // GIR_Coverage, 18768,
     /* 2191520 */     GIR_EraseRootFromParent_Done,
     /* 2191521 */   // Label 28850: @2191521
     /* 2191521 */   GIM_Try, /*On fail goto*//*Label 28851*/ GIMT_Encode4(2191612), // Rule ID 18769 //
     /* 2191526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2191537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2191540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2191546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191572 */     // MIs[0] round
     /* 2191572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191575 */     // MIs[0] policy
     /* 2191575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191585 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11300:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2191588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191611 */     // GIR_Coverage, 18769,
     /* 2191611 */     GIR_EraseRootFromParent_Done,
     /* 2191612 */   // Label 28851: @2191612
     /* 2191612 */   GIM_Try, /*On fail goto*//*Label 28852*/ GIMT_Encode4(2191703), // Rule ID 18772 //
     /* 2191617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2191628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2191631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2191637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191663 */     // MIs[0] round
     /* 2191663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191666 */     // MIs[0] policy
     /* 2191666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191676 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2191679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191702 */     // GIR_Coverage, 18772,
     /* 2191702 */     GIR_EraseRootFromParent_Done,
     /* 2191703 */   // Label 28852: @2191703
     /* 2191703 */   GIM_Try, /*On fail goto*//*Label 28853*/ GIMT_Encode4(2191794), // Rule ID 18773 //
     /* 2191708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2191719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2191722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2191728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191754 */     // MIs[0] round
     /* 2191754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191757 */     // MIs[0] policy
     /* 2191757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191767 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11300:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2191770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191793 */     // GIR_Coverage, 18773,
     /* 2191793 */     GIR_EraseRootFromParent_Done,
     /* 2191794 */   // Label 28853: @2191794
     /* 2191794 */   GIM_Try, /*On fail goto*//*Label 28854*/ GIMT_Encode4(2191885), // Rule ID 18776 //
     /* 2191799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2191810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2191813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2191819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191845 */     // MIs[0] round
     /* 2191845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191848 */     // MIs[0] policy
     /* 2191848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191858 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2191861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191884 */     // GIR_Coverage, 18776,
     /* 2191884 */     GIR_EraseRootFromParent_Done,
     /* 2191885 */   // Label 28854: @2191885
     /* 2191885 */   GIM_Try, /*On fail goto*//*Label 28855*/ GIMT_Encode4(2191976), // Rule ID 18777 //
     /* 2191890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2191893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2191901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2191904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2191910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2191920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191936 */     // MIs[0] round
     /* 2191936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191939 */     // MIs[0] policy
     /* 2191939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191949 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11300:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2191952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2191956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2191972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191975 */     // GIR_Coverage, 18777,
     /* 2191975 */     GIR_EraseRootFromParent_Done,
     /* 2191976 */   // Label 28855: @2191976
     /* 2191976 */   GIM_Try, /*On fail goto*//*Label 28856*/ GIMT_Encode4(2192067), // Rule ID 18780 //
     /* 2191981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2191984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2191989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2191992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2191995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2191998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2192001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192027 */     // MIs[0] round
     /* 2192027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192030 */     // MIs[0] policy
     /* 2192030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192040 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2192043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192066 */     // GIR_Coverage, 18780,
     /* 2192066 */     GIR_EraseRootFromParent_Done,
     /* 2192067 */   // Label 28856: @2192067
     /* 2192067 */   GIM_Try, /*On fail goto*//*Label 28857*/ GIMT_Encode4(2192158), // Rule ID 18781 //
     /* 2192072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2192075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2192080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2192083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2192086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2192092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192118 */     // MIs[0] round
     /* 2192118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192121 */     // MIs[0] policy
     /* 2192121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192131 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11300:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2192134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2192154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192157 */     // GIR_Coverage, 18781,
     /* 2192157 */     GIR_EraseRootFromParent_Done,
     /* 2192158 */   // Label 28857: @2192158
     /* 2192158 */   GIM_Try, /*On fail goto*//*Label 28858*/ GIMT_Encode4(2192249), // Rule ID 18784 //
     /* 2192163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192209 */     // MIs[0] round
     /* 2192209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192212 */     // MIs[0] policy
     /* 2192212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192222 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2192225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192248 */     // GIR_Coverage, 18784,
     /* 2192248 */     GIR_EraseRootFromParent_Done,
     /* 2192249 */   // Label 28858: @2192249
     /* 2192249 */   GIM_Try, /*On fail goto*//*Label 28859*/ GIMT_Encode4(2192340), // Rule ID 18785 //
     /* 2192254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2192265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2192268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2192271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2192274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2192277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192300 */     // MIs[0] round
     /* 2192300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192303 */     // MIs[0] policy
     /* 2192303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192313 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2192316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192339 */     // GIR_Coverage, 18785,
     /* 2192339 */     GIR_EraseRootFromParent_Done,
     /* 2192340 */   // Label 28859: @2192340
     /* 2192340 */   GIM_Try, /*On fail goto*//*Label 28860*/ GIMT_Encode4(2192431), // Rule ID 18788 //
     /* 2192345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192391 */     // MIs[0] round
     /* 2192391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192394 */     // MIs[0] policy
     /* 2192394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192404 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2192407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192430 */     // GIR_Coverage, 18788,
     /* 2192430 */     GIR_EraseRootFromParent_Done,
     /* 2192431 */   // Label 28860: @2192431
     /* 2192431 */   GIM_Try, /*On fail goto*//*Label 28861*/ GIMT_Encode4(2192522), // Rule ID 18789 //
     /* 2192436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2192447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2192450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2192453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2192456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2192459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192482 */     // MIs[0] round
     /* 2192482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192485 */     // MIs[0] policy
     /* 2192485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192495 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2192498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192521 */     // GIR_Coverage, 18789,
     /* 2192521 */     GIR_EraseRootFromParent_Done,
     /* 2192522 */   // Label 28861: @2192522
     /* 2192522 */   GIM_Try, /*On fail goto*//*Label 28862*/ GIMT_Encode4(2192613), // Rule ID 18792 //
     /* 2192527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2192538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2192541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2192544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2192547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192573 */     // MIs[0] round
     /* 2192573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192576 */     // MIs[0] policy
     /* 2192576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192586 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2192589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192612 */     // GIR_Coverage, 18792,
     /* 2192612 */     GIR_EraseRootFromParent_Done,
     /* 2192613 */   // Label 28862: @2192613
     /* 2192613 */   GIM_Try, /*On fail goto*//*Label 28863*/ GIMT_Encode4(2192704), // Rule ID 18793 //
     /* 2192618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2192629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2192632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2192635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2192638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192664 */     // MIs[0] round
     /* 2192664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192667 */     // MIs[0] policy
     /* 2192667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192677 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2192680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192703 */     // GIR_Coverage, 18793,
     /* 2192703 */     GIR_EraseRootFromParent_Done,
     /* 2192704 */   // Label 28863: @2192704
     /* 2192704 */   GIM_Try, /*On fail goto*//*Label 28864*/ GIMT_Encode4(2192795), // Rule ID 18796 //
     /* 2192709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2192720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2192723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2192726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2192729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192755 */     // MIs[0] round
     /* 2192755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192758 */     // MIs[0] policy
     /* 2192758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192768 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2192771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192794 */     // GIR_Coverage, 18796,
     /* 2192794 */     GIR_EraseRootFromParent_Done,
     /* 2192795 */   // Label 28864: @2192795
     /* 2192795 */   GIM_Try, /*On fail goto*//*Label 28865*/ GIMT_Encode4(2192886), // Rule ID 18797 //
     /* 2192800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2192811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2192814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2192817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2192820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2192830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192846 */     // MIs[0] round
     /* 2192846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192849 */     // MIs[0] policy
     /* 2192849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192859 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2192862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192885 */     // GIR_Coverage, 18797,
     /* 2192885 */     GIR_EraseRootFromParent_Done,
     /* 2192886 */   // Label 28865: @2192886
     /* 2192886 */   GIM_Try, /*On fail goto*//*Label 28866*/ GIMT_Encode4(2192977), // Rule ID 18800 //
     /* 2192891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2192894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2192902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2192905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2192908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2192911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2192914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2192921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192937 */     // MIs[0] round
     /* 2192937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192940 */     // MIs[0] policy
     /* 2192940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192950 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2192953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2192957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2192973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192976 */     // GIR_Coverage, 18800,
     /* 2192976 */     GIR_EraseRootFromParent_Done,
     /* 2192977 */   // Label 28866: @2192977
     /* 2192977 */   GIM_Try, /*On fail goto*//*Label 28867*/ GIMT_Encode4(2193068), // Rule ID 18801 //
     /* 2192982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2192985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2192990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2192993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2192996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2192999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2193002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2193005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193028 */     // MIs[0] round
     /* 2193028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193031 */     // MIs[0] policy
     /* 2193031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193041 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2193044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193067 */     // GIR_Coverage, 18801,
     /* 2193067 */     GIR_EraseRootFromParent_Done,
     /* 2193068 */   // Label 28867: @2193068
     /* 2193068 */   GIM_Try, /*On fail goto*//*Label 28868*/ GIMT_Encode4(2193159), // Rule ID 18804 //
     /* 2193073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193119 */     // MIs[0] round
     /* 2193119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193122 */     // MIs[0] policy
     /* 2193122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193132 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2193135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193158 */     // GIR_Coverage, 18804,
     /* 2193158 */     GIR_EraseRootFromParent_Done,
     /* 2193159 */   // Label 28868: @2193159
     /* 2193159 */   GIM_Try, /*On fail goto*//*Label 28869*/ GIMT_Encode4(2193250), // Rule ID 18805 //
     /* 2193164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2193175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2193178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2193181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2193184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193210 */     // MIs[0] round
     /* 2193210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193213 */     // MIs[0] policy
     /* 2193213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193223 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2193226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193249 */     // GIR_Coverage, 18805,
     /* 2193249 */     GIR_EraseRootFromParent_Done,
     /* 2193250 */   // Label 28869: @2193250
     /* 2193250 */   GIM_Try, /*On fail goto*//*Label 28870*/ GIMT_Encode4(2193341), // Rule ID 18808 //
     /* 2193255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193301 */     // MIs[0] round
     /* 2193301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193304 */     // MIs[0] policy
     /* 2193304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193314 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2193317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193340 */     // GIR_Coverage, 18808,
     /* 2193340 */     GIR_EraseRootFromParent_Done,
     /* 2193341 */   // Label 28870: @2193341
     /* 2193341 */   GIM_Try, /*On fail goto*//*Label 28871*/ GIMT_Encode4(2193432), // Rule ID 18809 //
     /* 2193346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2193357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2193360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2193363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2193366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2193369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2193376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193392 */     // MIs[0] round
     /* 2193392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193395 */     // MIs[0] policy
     /* 2193395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193405 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2193408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193431 */     // GIR_Coverage, 18809,
     /* 2193431 */     GIR_EraseRootFromParent_Done,
     /* 2193432 */   // Label 28871: @2193432
     /* 2193432 */   GIM_Try, /*On fail goto*//*Label 28872*/ GIMT_Encode4(2193523), // Rule ID 18812 //
     /* 2193437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2193448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2193451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2193454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2193457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193483 */     // MIs[0] round
     /* 2193483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193486 */     // MIs[0] policy
     /* 2193486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193496 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2193499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193522 */     // GIR_Coverage, 18812,
     /* 2193522 */     GIR_EraseRootFromParent_Done,
     /* 2193523 */   // Label 28872: @2193523
     /* 2193523 */   GIM_Try, /*On fail goto*//*Label 28873*/ GIMT_Encode4(2193614), // Rule ID 18813 //
     /* 2193528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2193539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2193542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2193545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2193548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2193551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2193558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2193570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193574 */     // MIs[0] round
     /* 2193574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193577 */     // MIs[0] policy
     /* 2193577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193587 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2193590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193613 */     // GIR_Coverage, 18813,
     /* 2193613 */     GIR_EraseRootFromParent_Done,
     /* 2193614 */   // Label 28873: @2193614
     /* 2193614 */   GIM_Try, /*On fail goto*//*Label 28874*/ GIMT_Encode4(2193705), // Rule ID 18816 //
     /* 2193619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2193622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2193630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2193633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2193636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2193639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193665 */     // MIs[0] round
     /* 2193665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193668 */     // MIs[0] policy
     /* 2193668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193678 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2193681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193704 */     // GIR_Coverage, 18816,
     /* 2193704 */     GIR_EraseRootFromParent_Done,
     /* 2193705 */   // Label 28874: @2193705
     /* 2193705 */   GIM_Try, /*On fail goto*//*Label 28875*/ GIMT_Encode4(2193796), // Rule ID 18817 //
     /* 2193710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2193713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2193721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2193724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2193727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2193730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2193733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2193740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2193744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2193752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193756 */     // MIs[0] round
     /* 2193756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193759 */     // MIs[0] policy
     /* 2193759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193769 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2193772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2193792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193795 */     // GIR_Coverage, 18817,
     /* 2193795 */     GIR_EraseRootFromParent_Done,
     /* 2193796 */   // Label 28875: @2193796
     /* 2193796 */   GIM_Try, /*On fail goto*//*Label 28876*/ GIMT_Encode4(2193887), // Rule ID 18820 //
     /* 2193801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2193812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2193815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2193821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2193827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193847 */     // MIs[0] round
     /* 2193847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193850 */     // MIs[0] policy
     /* 2193850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193860 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2193860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2193863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193886 */     // GIR_Coverage, 18820,
     /* 2193886 */     GIR_EraseRootFromParent_Done,
     /* 2193887 */   // Label 28876: @2193887
     /* 2193887 */   GIM_Try, /*On fail goto*//*Label 28877*/ GIMT_Encode4(2193978), // Rule ID 18821 //
     /* 2193892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2193895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2193903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2193906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2193909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2193912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2193915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2193918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2193922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2193930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2193934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2193938 */     // MIs[0] round
     /* 2193938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193941 */     // MIs[0] policy
     /* 2193941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2193944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2193951 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2193951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2193954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2193956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2193958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2193960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2193962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2193964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2193966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2193971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2193974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2193976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193977 */     // GIR_Coverage, 18821,
     /* 2193977 */     GIR_EraseRootFromParent_Done,
     /* 2193978 */   // Label 28877: @2193978
     /* 2193978 */   GIM_Try, /*On fail goto*//*Label 28878*/ GIMT_Encode4(2194069), // Rule ID 18824 //
     /* 2193983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2193986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2193991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2193994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2193997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194029 */     // MIs[0] round
     /* 2194029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194032 */     // MIs[0] policy
     /* 2194032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194042 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2194045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194068 */     // GIR_Coverage, 18824,
     /* 2194068 */     GIR_EraseRootFromParent_Done,
     /* 2194069 */   // Label 28878: @2194069
     /* 2194069 */   GIM_Try, /*On fail goto*//*Label 28879*/ GIMT_Encode4(2194160), // Rule ID 18825 //
     /* 2194074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2194085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2194088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2194094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194120 */     // MIs[0] round
     /* 2194120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194123 */     // MIs[0] policy
     /* 2194123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194133 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11308:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2194136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194159 */     // GIR_Coverage, 18825,
     /* 2194159 */     GIR_EraseRootFromParent_Done,
     /* 2194160 */   // Label 28879: @2194160
     /* 2194160 */   GIM_Try, /*On fail goto*//*Label 28880*/ GIMT_Encode4(2194251), // Rule ID 18828 //
     /* 2194165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194211 */     // MIs[0] round
     /* 2194211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194214 */     // MIs[0] policy
     /* 2194214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2194227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194250 */     // GIR_Coverage, 18828,
     /* 2194250 */     GIR_EraseRootFromParent_Done,
     /* 2194251 */   // Label 28880: @2194251
     /* 2194251 */   GIM_Try, /*On fail goto*//*Label 28881*/ GIMT_Encode4(2194342), // Rule ID 18829 //
     /* 2194256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2194267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2194270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2194276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2194279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194302 */     // MIs[0] round
     /* 2194302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194305 */     // MIs[0] policy
     /* 2194305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194315 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2194318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194341 */     // GIR_Coverage, 18829,
     /* 2194341 */     GIR_EraseRootFromParent_Done,
     /* 2194342 */   // Label 28881: @2194342
     /* 2194342 */   GIM_Try, /*On fail goto*//*Label 28882*/ GIMT_Encode4(2194433), // Rule ID 18832 //
     /* 2194347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194393 */     // MIs[0] round
     /* 2194393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194396 */     // MIs[0] policy
     /* 2194396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194406 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2194409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194432 */     // GIR_Coverage, 18832,
     /* 2194432 */     GIR_EraseRootFromParent_Done,
     /* 2194433 */   // Label 28882: @2194433
     /* 2194433 */   GIM_Try, /*On fail goto*//*Label 28883*/ GIMT_Encode4(2194524), // Rule ID 18833 //
     /* 2194438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2194449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2194452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2194458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2194461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2194468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194484 */     // MIs[0] round
     /* 2194484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194487 */     // MIs[0] policy
     /* 2194487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194497 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2194500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194523 */     // GIR_Coverage, 18833,
     /* 2194523 */     GIR_EraseRootFromParent_Done,
     /* 2194524 */   // Label 28883: @2194524
     /* 2194524 */   GIM_Try, /*On fail goto*//*Label 28884*/ GIMT_Encode4(2194615), // Rule ID 18836 //
     /* 2194529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2194532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2194540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2194543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2194549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2194552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194575 */     // MIs[0] round
     /* 2194575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194578 */     // MIs[0] policy
     /* 2194578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194588 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2194591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194614 */     // GIR_Coverage, 18836,
     /* 2194614 */     GIR_EraseRootFromParent_Done,
     /* 2194615 */   // Label 28884: @2194615
     /* 2194615 */   GIM_Try, /*On fail goto*//*Label 28885*/ GIMT_Encode4(2194706), // Rule ID 18837 //
     /* 2194620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2194623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2194631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2194634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2194637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2194640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2194643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2194650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2194654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2194658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2194662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194666 */     // MIs[0] round
     /* 2194666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194669 */     // MIs[0] policy
     /* 2194669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194679 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2194682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194705 */     // GIR_Coverage, 18837,
     /* 2194705 */     GIR_EraseRootFromParent_Done,
     /* 2194706 */   // Label 28885: @2194706
     /* 2194706 */   GIM_Try, /*On fail goto*//*Label 28886*/ GIMT_Encode4(2194797), // Rule ID 18840 //
     /* 2194711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2194722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2194725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2194731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194757 */     // MIs[0] round
     /* 2194757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194760 */     // MIs[0] policy
     /* 2194760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194770 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2194773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194796 */     // GIR_Coverage, 18840,
     /* 2194796 */     GIR_EraseRootFromParent_Done,
     /* 2194797 */   // Label 28886: @2194797
     /* 2194797 */   GIM_Try, /*On fail goto*//*Label 28887*/ GIMT_Encode4(2194888), // Rule ID 18841 //
     /* 2194802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2194813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2194816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2194822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2194825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2194828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2194832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194848 */     // MIs[0] round
     /* 2194848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194851 */     // MIs[0] policy
     /* 2194851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194861 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11308:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2194861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2194864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194887 */     // GIR_Coverage, 18841,
     /* 2194887 */     GIR_EraseRootFromParent_Done,
     /* 2194888 */   // Label 28887: @2194888
     /* 2194888 */   GIM_Try, /*On fail goto*//*Label 28888*/ GIMT_Encode4(2194979), // Rule ID 18844 //
     /* 2194893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2194896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2194904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2194907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2194910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2194913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2194916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2194919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2194923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2194927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2194931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2194939 */     // MIs[0] round
     /* 2194939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194942 */     // MIs[0] policy
     /* 2194942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2194945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2194952 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2194952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2194955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2194959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2194961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2194963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2194965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2194967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2194972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2194977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194978 */     // GIR_Coverage, 18844,
     /* 2194978 */     GIR_EraseRootFromParent_Done,
     /* 2194979 */   // Label 28888: @2194979
     /* 2194979 */   GIM_Try, /*On fail goto*//*Label 28889*/ GIMT_Encode4(2195070), // Rule ID 18845 //
     /* 2194984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2194987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2194992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2194995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2194998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2195004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195030 */     // MIs[0] round
     /* 2195030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195033 */     // MIs[0] policy
     /* 2195033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195043 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11308:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2195046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195069 */     // GIR_Coverage, 18845,
     /* 2195069 */     GIR_EraseRootFromParent_Done,
     /* 2195070 */   // Label 28889: @2195070
     /* 2195070 */   GIM_Try, /*On fail goto*//*Label 28890*/ GIMT_Encode4(2195161), // Rule ID 18848 //
     /* 2195075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195121 */     // MIs[0] round
     /* 2195121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195124 */     // MIs[0] policy
     /* 2195124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195134 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2195137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195160 */     // GIR_Coverage, 18848,
     /* 2195160 */     GIR_EraseRootFromParent_Done,
     /* 2195161 */   // Label 28890: @2195161
     /* 2195161 */   GIM_Try, /*On fail goto*//*Label 28891*/ GIMT_Encode4(2195252), // Rule ID 18849 //
     /* 2195166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2195177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2195180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2195186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2195196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195212 */     // MIs[0] round
     /* 2195212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195215 */     // MIs[0] policy
     /* 2195215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195225 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11308:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2195228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195251 */     // GIR_Coverage, 18849,
     /* 2195251 */     GIR_EraseRootFromParent_Done,
     /* 2195252 */   // Label 28891: @2195252
     /* 2195252 */   GIM_Try, /*On fail goto*//*Label 28892*/ GIMT_Encode4(2195343), // Rule ID 18852 //
     /* 2195257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2195260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195303 */     // MIs[0] round
     /* 2195303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195306 */     // MIs[0] policy
     /* 2195306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195316 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2195319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195342 */     // GIR_Coverage, 18852,
     /* 2195342 */     GIR_EraseRootFromParent_Done,
     /* 2195343 */   // Label 28892: @2195343
     /* 2195343 */   GIM_Try, /*On fail goto*//*Label 28893*/ GIMT_Encode4(2195434), // Rule ID 18853 //
     /* 2195348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2195351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2195356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2195359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2195362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2195365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2195368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2195371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2195378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2195382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2195386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195394 */     // MIs[0] round
     /* 2195394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195397 */     // MIs[0] policy
     /* 2195397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195407 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11308:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2195410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195433 */     // GIR_Coverage, 18853,
     /* 2195433 */     GIR_EraseRootFromParent_Done,
     /* 2195434 */   // Label 28893: @2195434
     /* 2195434 */   GIM_Try, /*On fail goto*//*Label 28894*/ GIMT_Encode4(2195525), // Rule ID 18856 //
     /* 2195439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2195450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2195453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2195456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2195459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195485 */     // MIs[0] round
     /* 2195485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195488 */     // MIs[0] policy
     /* 2195488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195498 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2195501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195524 */     // GIR_Coverage, 18856,
     /* 2195524 */     GIR_EraseRootFromParent_Done,
     /* 2195525 */   // Label 28894: @2195525
     /* 2195525 */   GIM_Try, /*On fail goto*//*Label 28895*/ GIMT_Encode4(2195616), // Rule ID 18857 //
     /* 2195530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2195541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2195544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2195547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2195550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2195553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195576 */     // MIs[0] round
     /* 2195576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195579 */     // MIs[0] policy
     /* 2195579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195589 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2195592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195615 */     // GIR_Coverage, 18857,
     /* 2195615 */     GIR_EraseRootFromParent_Done,
     /* 2195616 */   // Label 28895: @2195616
     /* 2195616 */   GIM_Try, /*On fail goto*//*Label 28896*/ GIMT_Encode4(2195707), // Rule ID 18860 //
     /* 2195621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2195632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2195635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2195638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2195641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195667 */     // MIs[0] round
     /* 2195667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195670 */     // MIs[0] policy
     /* 2195670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195680 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2195683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195706 */     // GIR_Coverage, 18860,
     /* 2195706 */     GIR_EraseRootFromParent_Done,
     /* 2195707 */   // Label 28896: @2195707
     /* 2195707 */   GIM_Try, /*On fail goto*//*Label 28897*/ GIMT_Encode4(2195798), // Rule ID 18861 //
     /* 2195712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2195723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2195726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2195729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2195732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2195735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2195742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195758 */     // MIs[0] round
     /* 2195758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195761 */     // MIs[0] policy
     /* 2195761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195771 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2195774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195797 */     // GIR_Coverage, 18861,
     /* 2195797 */     GIR_EraseRootFromParent_Done,
     /* 2195798 */   // Label 28897: @2195798
     /* 2195798 */   GIM_Try, /*On fail goto*//*Label 28898*/ GIMT_Encode4(2195889), // Rule ID 18864 //
     /* 2195803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2195814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2195817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2195820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2195823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2195829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195849 */     // MIs[0] round
     /* 2195849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195852 */     // MIs[0] policy
     /* 2195852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195862 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2195862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2195865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195888 */     // GIR_Coverage, 18864,
     /* 2195888 */     GIR_EraseRootFromParent_Done,
     /* 2195889 */   // Label 28898: @2195889
     /* 2195889 */   GIM_Try, /*On fail goto*//*Label 28899*/ GIMT_Encode4(2195980), // Rule ID 18865 //
     /* 2195894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2195897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2195905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2195908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2195911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2195914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2195917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2195920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2195924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2195940 */     // MIs[0] round
     /* 2195940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2195943 */     // MIs[0] policy
     /* 2195943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2195946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2195953 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2195953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2195956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2195960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2195962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2195964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2195966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2195968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2195973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2195978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195979 */     // GIR_Coverage, 18865,
     /* 2195979 */     GIR_EraseRootFromParent_Done,
     /* 2195980 */   // Label 28899: @2195980
     /* 2195980 */   GIM_Try, /*On fail goto*//*Label 28900*/ GIMT_Encode4(2196071), // Rule ID 18868 //
     /* 2195985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2195988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2195993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2195996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2195999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196031 */     // MIs[0] round
     /* 2196031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196034 */     // MIs[0] policy
     /* 2196034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196044 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2196047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196070 */     // GIR_Coverage, 18868,
     /* 2196070 */     GIR_EraseRootFromParent_Done,
     /* 2196071 */   // Label 28900: @2196071
     /* 2196071 */   GIM_Try, /*On fail goto*//*Label 28901*/ GIMT_Encode4(2196162), // Rule ID 18869 //
     /* 2196076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2196087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2196090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2196093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2196096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196122 */     // MIs[0] round
     /* 2196122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196125 */     // MIs[0] policy
     /* 2196125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196135 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2196138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196161 */     // GIR_Coverage, 18869,
     /* 2196161 */     GIR_EraseRootFromParent_Done,
     /* 2196162 */   // Label 28901: @2196162
     /* 2196162 */   GIM_Try, /*On fail goto*//*Label 28902*/ GIMT_Encode4(2196253), // Rule ID 18872 //
     /* 2196167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2196170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196213 */     // MIs[0] round
     /* 2196213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196216 */     // MIs[0] policy
     /* 2196216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196226 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2196229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196252 */     // GIR_Coverage, 18872,
     /* 2196252 */     GIR_EraseRootFromParent_Done,
     /* 2196253 */   // Label 28902: @2196253
     /* 2196253 */   GIM_Try, /*On fail goto*//*Label 28903*/ GIMT_Encode4(2196344), // Rule ID 18873 //
     /* 2196258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2196261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2196269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2196272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2196275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2196278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2196281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196304 */     // MIs[0] round
     /* 2196304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196307 */     // MIs[0] policy
     /* 2196307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196317 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2196320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196343 */     // GIR_Coverage, 18873,
     /* 2196343 */     GIR_EraseRootFromParent_Done,
     /* 2196344 */   // Label 28903: @2196344
     /* 2196344 */   GIM_Try, /*On fail goto*//*Label 28904*/ GIMT_Encode4(2196435), // Rule ID 18876 //
     /* 2196349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2196360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2196363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2196369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196395 */     // MIs[0] round
     /* 2196395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196398 */     // MIs[0] policy
     /* 2196398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196408 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2196411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196434 */     // GIR_Coverage, 18876,
     /* 2196434 */     GIR_EraseRootFromParent_Done,
     /* 2196435 */   // Label 28904: @2196435
     /* 2196435 */   GIM_Try, /*On fail goto*//*Label 28905*/ GIMT_Encode4(2196526), // Rule ID 18877 //
     /* 2196440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2196443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2196451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2196454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2196457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2196460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2196463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2196470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196486 */     // MIs[0] round
     /* 2196486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196489 */     // MIs[0] policy
     /* 2196489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196499 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2196502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196525 */     // GIR_Coverage, 18877,
     /* 2196525 */     GIR_EraseRootFromParent_Done,
     /* 2196526 */   // Label 28905: @2196526
     /* 2196526 */   GIM_Try, /*On fail goto*//*Label 28906*/ GIMT_Encode4(2196617), // Rule ID 18880 //
     /* 2196531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2196542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2196545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2196548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2196551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196577 */     // MIs[0] round
     /* 2196577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196580 */     // MIs[0] policy
     /* 2196580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196590 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2196593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196616 */     // GIR_Coverage, 18880,
     /* 2196616 */     GIR_EraseRootFromParent_Done,
     /* 2196617 */   // Label 28906: @2196617
     /* 2196617 */   GIM_Try, /*On fail goto*//*Label 28907*/ GIMT_Encode4(2196708), // Rule ID 18881 //
     /* 2196622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2196625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2196633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2196636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2196639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2196642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2196645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2196652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196668 */     // MIs[0] round
     /* 2196668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196671 */     // MIs[0] policy
     /* 2196671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196681 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2196684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196707 */     // GIR_Coverage, 18881,
     /* 2196707 */     GIR_EraseRootFromParent_Done,
     /* 2196708 */   // Label 28907: @2196708
     /* 2196708 */   GIM_Try, /*On fail goto*//*Label 28908*/ GIMT_Encode4(2196799), // Rule ID 18884 //
     /* 2196713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2196724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2196727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2196730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2196733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196759 */     // MIs[0] round
     /* 2196759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196762 */     // MIs[0] policy
     /* 2196762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196772 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2196775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196798 */     // GIR_Coverage, 18884,
     /* 2196798 */     GIR_EraseRootFromParent_Done,
     /* 2196799 */   // Label 28908: @2196799
     /* 2196799 */   GIM_Try, /*On fail goto*//*Label 28909*/ GIMT_Encode4(2196890), // Rule ID 18885 //
     /* 2196804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2196807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2196815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2196818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2196821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2196824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2196827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2196830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2196834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196850 */     // MIs[0] round
     /* 2196850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196853 */     // MIs[0] policy
     /* 2196853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196863 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2196863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2196866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196889 */     // GIR_Coverage, 18885,
     /* 2196889 */     GIR_EraseRootFromParent_Done,
     /* 2196890 */   // Label 28909: @2196890
     /* 2196890 */   GIM_Try, /*On fail goto*//*Label 28910*/ GIMT_Encode4(2196981), // Rule ID 18888 //
     /* 2196895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2196898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2196906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2196909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2196912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2196915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2196918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2196921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2196925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2196941 */     // MIs[0] round
     /* 2196941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2196944 */     // MIs[0] policy
     /* 2196944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2196947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2196954 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2196954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2196957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2196961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2196963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2196965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2196967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2196969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2196974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2196979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196980 */     // GIR_Coverage, 18888,
     /* 2196980 */     GIR_EraseRootFromParent_Done,
     /* 2196981 */   // Label 28910: @2196981
     /* 2196981 */   GIM_Try, /*On fail goto*//*Label 28911*/ GIMT_Encode4(2197072), // Rule ID 18889 //
     /* 2196986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2196989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2196994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2196997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2197000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2197003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2197006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197032 */     // MIs[0] round
     /* 2197032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197035 */     // MIs[0] policy
     /* 2197035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197045 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2197048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197071 */     // GIR_Coverage, 18889,
     /* 2197071 */     GIR_EraseRootFromParent_Done,
     /* 2197072 */   // Label 28911: @2197072
     /* 2197072 */   GIM_Try, /*On fail goto*//*Label 28912*/ GIMT_Encode4(2197163), // Rule ID 18892 //
     /* 2197077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197123 */     // MIs[0] round
     /* 2197123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197126 */     // MIs[0] policy
     /* 2197126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197136 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2197139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197162 */     // GIR_Coverage, 18892,
     /* 2197162 */     GIR_EraseRootFromParent_Done,
     /* 2197163 */   // Label 28912: @2197163
     /* 2197163 */   GIM_Try, /*On fail goto*//*Label 28913*/ GIMT_Encode4(2197254), // Rule ID 18893 //
     /* 2197168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2197179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2197182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2197188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2197191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197214 */     // MIs[0] round
     /* 2197214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197217 */     // MIs[0] policy
     /* 2197217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197227 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2197230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197253 */     // GIR_Coverage, 18893,
     /* 2197253 */     GIR_EraseRootFromParent_Done,
     /* 2197254 */   // Label 28913: @2197254
     /* 2197254 */   GIM_Try, /*On fail goto*//*Label 28914*/ GIMT_Encode4(2197345), // Rule ID 18896 //
     /* 2197259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197305 */     // MIs[0] round
     /* 2197305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197308 */     // MIs[0] policy
     /* 2197308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197318 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2197321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197344 */     // GIR_Coverage, 18896,
     /* 2197344 */     GIR_EraseRootFromParent_Done,
     /* 2197345 */   // Label 28914: @2197345
     /* 2197345 */   GIM_Try, /*On fail goto*//*Label 28915*/ GIMT_Encode4(2197436), // Rule ID 18897 //
     /* 2197350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2197361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2197364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2197370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2197373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2197380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197396 */     // MIs[0] round
     /* 2197396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197399 */     // MIs[0] policy
     /* 2197399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197409 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11304:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2197412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197435 */     // GIR_Coverage, 18897,
     /* 2197435 */     GIR_EraseRootFromParent_Done,
     /* 2197436 */   // Label 28915: @2197436
     /* 2197436 */   GIM_Try, /*On fail goto*//*Label 28916*/ GIMT_Encode4(2197527), // Rule ID 18900 //
     /* 2197441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2197452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2197455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2197461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197487 */     // MIs[0] round
     /* 2197487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197490 */     // MIs[0] policy
     /* 2197490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197500 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2197503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197526 */     // GIR_Coverage, 18900,
     /* 2197526 */     GIR_EraseRootFromParent_Done,
     /* 2197527 */   // Label 28916: @2197527
     /* 2197527 */   GIM_Try, /*On fail goto*//*Label 28917*/ GIMT_Encode4(2197618), // Rule ID 18901 //
     /* 2197532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2197543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2197546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2197552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2197555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2197562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197578 */     // MIs[0] round
     /* 2197578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197581 */     // MIs[0] policy
     /* 2197581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197591 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2197594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197617 */     // GIR_Coverage, 18901,
     /* 2197617 */     GIR_EraseRootFromParent_Done,
     /* 2197618 */   // Label 28917: @2197618
     /* 2197618 */   GIM_Try, /*On fail goto*//*Label 28918*/ GIMT_Encode4(2197709), // Rule ID 18904 //
     /* 2197623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2197634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2197637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2197643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197669 */     // MIs[0] round
     /* 2197669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197672 */     // MIs[0] policy
     /* 2197672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197682 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2197685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197708 */     // GIR_Coverage, 18904,
     /* 2197708 */     GIR_EraseRootFromParent_Done,
     /* 2197709 */   // Label 28918: @2197709
     /* 2197709 */   GIM_Try, /*On fail goto*//*Label 28919*/ GIMT_Encode4(2197800), // Rule ID 18905 //
     /* 2197714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2197725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2197728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2197734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2197737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2197744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197760 */     // MIs[0] round
     /* 2197760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197763 */     // MIs[0] policy
     /* 2197763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197773 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2197776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197799 */     // GIR_Coverage, 18905,
     /* 2197799 */     GIR_EraseRootFromParent_Done,
     /* 2197800 */   // Label 28919: @2197800
     /* 2197800 */   GIM_Try, /*On fail goto*//*Label 28920*/ GIMT_Encode4(2197891), // Rule ID 18908 //
     /* 2197805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2197808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2197816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2197819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2197825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2197828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2197831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197851 */     // MIs[0] round
     /* 2197851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197854 */     // MIs[0] policy
     /* 2197854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197864 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2197864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2197867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197890 */     // GIR_Coverage, 18908,
     /* 2197890 */     GIR_EraseRootFromParent_Done,
     /* 2197891 */   // Label 28920: @2197891
     /* 2197891 */   GIM_Try, /*On fail goto*//*Label 28921*/ GIMT_Encode4(2197982), // Rule ID 18909 //
     /* 2197896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2197899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2197907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2197910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2197913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2197916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2197919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2197922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2197926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2197934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2197942 */     // MIs[0] round
     /* 2197942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2197945 */     // MIs[0] policy
     /* 2197945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2197948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2197955 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2197955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2197958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2197962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2197964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2197966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2197968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2197970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2197975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2197980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197981 */     // GIR_Coverage, 18909,
     /* 2197981 */     GIR_EraseRootFromParent_Done,
     /* 2197982 */   // Label 28921: @2197982
     /* 2197982 */   GIM_Try, /*On fail goto*//*Label 28922*/ GIMT_Encode4(2198073), // Rule ID 18912 //
     /* 2197987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2197990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2197995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2197998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198033 */     // MIs[0] round
     /* 2198033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198036 */     // MIs[0] policy
     /* 2198036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198046 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2198049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198072 */     // GIR_Coverage, 18912,
     /* 2198072 */     GIR_EraseRootFromParent_Done,
     /* 2198073 */   // Label 28922: @2198073
     /* 2198073 */   GIM_Try, /*On fail goto*//*Label 28923*/ GIMT_Encode4(2198164), // Rule ID 18913 //
     /* 2198078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2198089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2198092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2198098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198124 */     // MIs[0] round
     /* 2198124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198127 */     // MIs[0] policy
     /* 2198127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198137 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11304:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2198140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198163 */     // GIR_Coverage, 18913,
     /* 2198163 */     GIR_EraseRootFromParent_Done,
     /* 2198164 */   // Label 28923: @2198164
     /* 2198164 */   GIM_Try, /*On fail goto*//*Label 28924*/ GIMT_Encode4(2198255), // Rule ID 18916 //
     /* 2198169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198215 */     // MIs[0] round
     /* 2198215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198218 */     // MIs[0] policy
     /* 2198218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198228 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2198231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198254 */     // GIR_Coverage, 18916,
     /* 2198254 */     GIR_EraseRootFromParent_Done,
     /* 2198255 */   // Label 28924: @2198255
     /* 2198255 */   GIM_Try, /*On fail goto*//*Label 28925*/ GIMT_Encode4(2198346), // Rule ID 18917 //
     /* 2198260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2198271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2198274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2198280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2198290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198306 */     // MIs[0] round
     /* 2198306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198309 */     // MIs[0] policy
     /* 2198309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198319 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11304:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2198322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198345 */     // GIR_Coverage, 18917,
     /* 2198345 */     GIR_EraseRootFromParent_Done,
     /* 2198346 */   // Label 28925: @2198346
     /* 2198346 */   GIM_Try, /*On fail goto*//*Label 28926*/ GIMT_Encode4(2198437), // Rule ID 18920 //
     /* 2198351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2198362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2198365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2198371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198397 */     // MIs[0] round
     /* 2198397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198400 */     // MIs[0] policy
     /* 2198400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198410 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2198413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198436 */     // GIR_Coverage, 18920,
     /* 2198436 */     GIR_EraseRootFromParent_Done,
     /* 2198437 */   // Label 28926: @2198437
     /* 2198437 */   GIM_Try, /*On fail goto*//*Label 28927*/ GIMT_Encode4(2198528), // Rule ID 18921 //
     /* 2198442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2198453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2198456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2198462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2198465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2198472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198488 */     // MIs[0] round
     /* 2198488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198491 */     // MIs[0] policy
     /* 2198491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198501 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11304:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2198504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198527 */     // GIR_Coverage, 18921,
     /* 2198527 */     GIR_EraseRootFromParent_Done,
     /* 2198528 */   // Label 28927: @2198528
     /* 2198528 */   GIM_Try, /*On fail goto*//*Label 28928*/ GIMT_Encode4(2198619), // Rule ID 18924 //
     /* 2198533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2198536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2198544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2198547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2198553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198579 */     // MIs[0] round
     /* 2198579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198582 */     // MIs[0] policy
     /* 2198582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198592 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2198595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198618 */     // GIR_Coverage, 18924,
     /* 2198618 */     GIR_EraseRootFromParent_Done,
     /* 2198619 */   // Label 28928: @2198619
     /* 2198619 */   GIM_Try, /*On fail goto*//*Label 28929*/ GIMT_Encode4(2198710), // Rule ID 18925 //
     /* 2198624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2198627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2198632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2198635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2198638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2198641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2198644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2198647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2198654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2198658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2198662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2198666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198670 */     // MIs[0] round
     /* 2198670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198673 */     // MIs[0] policy
     /* 2198673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198683 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11304:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2198686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198709 */     // GIR_Coverage, 18925,
     /* 2198709 */     GIR_EraseRootFromParent_Done,
     /* 2198710 */   // Label 28929: @2198710
     /* 2198710 */   GIM_Try, /*On fail goto*//*Label 28930*/ GIMT_Encode4(2198801), // Rule ID 18928 //
     /* 2198715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2198723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2198726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2198729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2198732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2198735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198761 */     // MIs[0] round
     /* 2198761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198764 */     // MIs[0] policy
     /* 2198764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198774 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2198777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198800 */     // GIR_Coverage, 18928,
     /* 2198800 */     GIR_EraseRootFromParent_Done,
     /* 2198801 */   // Label 28930: @2198801
     /* 2198801 */   GIM_Try, /*On fail goto*//*Label 28931*/ GIMT_Encode4(2198892), // Rule ID 18929 //
     /* 2198806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2198814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2198817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2198820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2198823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2198826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2198829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2198832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198852 */     // MIs[0] round
     /* 2198852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198855 */     // MIs[0] policy
     /* 2198855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198865 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2198865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2198868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198891 */     // GIR_Coverage, 18929,
     /* 2198891 */     GIR_EraseRootFromParent_Done,
     /* 2198892 */   // Label 28931: @2198892
     /* 2198892 */   GIM_Try, /*On fail goto*//*Label 28932*/ GIMT_Encode4(2198983), // Rule ID 18932 //
     /* 2198897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2198900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2198905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2198908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2198911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2198914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2198917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2198920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2198923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2198927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2198943 */     // MIs[0] round
     /* 2198943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2198946 */     // MIs[0] policy
     /* 2198946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2198949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2198956 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2198956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2198959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2198963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2198965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2198967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2198969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2198971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2198976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2198981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198982 */     // GIR_Coverage, 18932,
     /* 2198982 */     GIR_EraseRootFromParent_Done,
     /* 2198983 */   // Label 28932: @2198983
     /* 2198983 */   GIM_Try, /*On fail goto*//*Label 28933*/ GIMT_Encode4(2199074), // Rule ID 18933 //
     /* 2198988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2198991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2198996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2198999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2199002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2199005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2199008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199034 */     // MIs[0] round
     /* 2199034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199037 */     // MIs[0] policy
     /* 2199037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199047 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2199050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199073 */     // GIR_Coverage, 18933,
     /* 2199073 */     GIR_EraseRootFromParent_Done,
     /* 2199074 */   // Label 28933: @2199074
     /* 2199074 */   GIM_Try, /*On fail goto*//*Label 28934*/ GIMT_Encode4(2199165), // Rule ID 18936 //
     /* 2199079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199125 */     // MIs[0] round
     /* 2199125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199128 */     // MIs[0] policy
     /* 2199128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199138 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2199141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199164 */     // GIR_Coverage, 18936,
     /* 2199164 */     GIR_EraseRootFromParent_Done,
     /* 2199165 */   // Label 28934: @2199165
     /* 2199165 */   GIM_Try, /*On fail goto*//*Label 28935*/ GIMT_Encode4(2199256), // Rule ID 18937 //
     /* 2199170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2199181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2199184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2199187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2199190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2199193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199216 */     // MIs[0] round
     /* 2199216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199219 */     // MIs[0] policy
     /* 2199219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199229 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2199232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199255 */     // GIR_Coverage, 18937,
     /* 2199255 */     GIR_EraseRootFromParent_Done,
     /* 2199256 */   // Label 28935: @2199256
     /* 2199256 */   GIM_Try, /*On fail goto*//*Label 28936*/ GIMT_Encode4(2199347), // Rule ID 18940 //
     /* 2199261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199307 */     // MIs[0] round
     /* 2199307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199310 */     // MIs[0] policy
     /* 2199310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199320 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2199323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199346 */     // GIR_Coverage, 18940,
     /* 2199346 */     GIR_EraseRootFromParent_Done,
     /* 2199347 */   // Label 28936: @2199347
     /* 2199347 */   GIM_Try, /*On fail goto*//*Label 28937*/ GIMT_Encode4(2199438), // Rule ID 18941 //
     /* 2199352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2199363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2199366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2199369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2199372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2199375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2199382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199398 */     // MIs[0] round
     /* 2199398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199401 */     // MIs[0] policy
     /* 2199401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199411 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2199414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199437 */     // GIR_Coverage, 18941,
     /* 2199437 */     GIR_EraseRootFromParent_Done,
     /* 2199438 */   // Label 28937: @2199438
     /* 2199438 */   GIM_Try, /*On fail goto*//*Label 28938*/ GIMT_Encode4(2199529), // Rule ID 18944 //
     /* 2199443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2199446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2199454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2199457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2199460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2199463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2199466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199489 */     // MIs[0] round
     /* 2199489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199492 */     // MIs[0] policy
     /* 2199492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199502 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2199505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199528 */     // GIR_Coverage, 18944,
     /* 2199528 */     GIR_EraseRootFromParent_Done,
     /* 2199529 */   // Label 28938: @2199529
     /* 2199529 */   GIM_Try, /*On fail goto*//*Label 28939*/ GIMT_Encode4(2199620), // Rule ID 18945 //
     /* 2199534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2199537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2199545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2199548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2199551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2199554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2199557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2199564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199580 */     // MIs[0] round
     /* 2199580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199583 */     // MIs[0] policy
     /* 2199583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199593 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2199596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199619 */     // GIR_Coverage, 18945,
     /* 2199619 */     GIR_EraseRootFromParent_Done,
     /* 2199620 */   // Label 28939: @2199620
     /* 2199620 */   GIM_Try, /*On fail goto*//*Label 28940*/ GIMT_Encode4(2199711), // Rule ID 18948 //
     /* 2199625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2199628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2199636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2199639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2199642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2199645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199671 */     // MIs[0] round
     /* 2199671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199674 */     // MIs[0] policy
     /* 2199674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199684 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2199687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199710 */     // GIR_Coverage, 18948,
     /* 2199710 */     GIR_EraseRootFromParent_Done,
     /* 2199711 */   // Label 28940: @2199711
     /* 2199711 */   GIM_Try, /*On fail goto*//*Label 28941*/ GIMT_Encode4(2199802), // Rule ID 18949 //
     /* 2199716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2199719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2199727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2199730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2199733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2199736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2199739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2199746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199762 */     // MIs[0] round
     /* 2199762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199765 */     // MIs[0] policy
     /* 2199765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199775 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2199778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199801 */     // GIR_Coverage, 18949,
     /* 2199801 */     GIR_EraseRootFromParent_Done,
     /* 2199802 */   // Label 28941: @2199802
     /* 2199802 */   GIM_Try, /*On fail goto*//*Label 28942*/ GIMT_Encode4(2199893), // Rule ID 18952 //
     /* 2199807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2199810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2199818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2199821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2199824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2199827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2199833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199853 */     // MIs[0] round
     /* 2199853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199856 */     // MIs[0] policy
     /* 2199856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199866 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2199866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2199869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199892 */     // GIR_Coverage, 18952,
     /* 2199892 */     GIR_EraseRootFromParent_Done,
     /* 2199893 */   // Label 28942: @2199893
     /* 2199893 */   GIM_Try, /*On fail goto*//*Label 28943*/ GIMT_Encode4(2199984), // Rule ID 18953 //
     /* 2199898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2199901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2199909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2199912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2199915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2199918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2199921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2199924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2199928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2199944 */     // MIs[0] round
     /* 2199944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2199947 */     // MIs[0] policy
     /* 2199947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2199950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2199957 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2199957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2199960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2199964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2199966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2199968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2199970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2199972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2199977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2199982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199983 */     // GIR_Coverage, 18953,
     /* 2199983 */     GIR_EraseRootFromParent_Done,
     /* 2199984 */   // Label 28943: @2199984
     /* 2199984 */   GIM_Try, /*On fail goto*//*Label 28944*/ GIMT_Encode4(2200075), // Rule ID 18956 //
     /* 2199989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2199992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2199997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200035 */     // MIs[0] round
     /* 2200035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200038 */     // MIs[0] policy
     /* 2200038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200048 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2200051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200074 */     // GIR_Coverage, 18956,
     /* 2200074 */     GIR_EraseRootFromParent_Done,
     /* 2200075 */   // Label 28944: @2200075
     /* 2200075 */   GIM_Try, /*On fail goto*//*Label 28945*/ GIMT_Encode4(2200166), // Rule ID 18957 //
     /* 2200080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2200091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2200094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2200097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2200100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200126 */     // MIs[0] round
     /* 2200126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200129 */     // MIs[0] policy
     /* 2200129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200139 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2200142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200165 */     // GIR_Coverage, 18957,
     /* 2200165 */     GIR_EraseRootFromParent_Done,
     /* 2200166 */   // Label 28945: @2200166
     /* 2200166 */   GIM_Try, /*On fail goto*//*Label 28946*/ GIMT_Encode4(2200257), // Rule ID 18960 //
     /* 2200171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2200174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200217 */     // MIs[0] round
     /* 2200217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200220 */     // MIs[0] policy
     /* 2200220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200230 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2200233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200256 */     // GIR_Coverage, 18960,
     /* 2200256 */     GIR_EraseRootFromParent_Done,
     /* 2200257 */   // Label 28946: @2200257
     /* 2200257 */   GIM_Try, /*On fail goto*//*Label 28947*/ GIMT_Encode4(2200348), // Rule ID 18961 //
     /* 2200262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2200265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2200273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2200276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2200279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2200282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2200292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200308 */     // MIs[0] round
     /* 2200308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200311 */     // MIs[0] policy
     /* 2200311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200321 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2200324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200347 */     // GIR_Coverage, 18961,
     /* 2200347 */     GIR_EraseRootFromParent_Done,
     /* 2200348 */   // Label 28947: @2200348
     /* 2200348 */   GIM_Try, /*On fail goto*//*Label 28948*/ GIMT_Encode4(2200439), // Rule ID 18964 //
     /* 2200353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2200364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2200367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2200373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200399 */     // MIs[0] round
     /* 2200399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200402 */     // MIs[0] policy
     /* 2200402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200412 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2200415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200438 */     // GIR_Coverage, 18964,
     /* 2200438 */     GIR_EraseRootFromParent_Done,
     /* 2200439 */   // Label 28948: @2200439
     /* 2200439 */   GIM_Try, /*On fail goto*//*Label 28949*/ GIMT_Encode4(2200530), // Rule ID 18965 //
     /* 2200444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2200455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2200458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2200464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2200467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200490 */     // MIs[0] round
     /* 2200490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200493 */     // MIs[0] policy
     /* 2200493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200503 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2200506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200529 */     // GIR_Coverage, 18965,
     /* 2200529 */     GIR_EraseRootFromParent_Done,
     /* 2200530 */   // Label 28949: @2200530
     /* 2200530 */   GIM_Try, /*On fail goto*//*Label 28950*/ GIMT_Encode4(2200621), // Rule ID 18968 //
     /* 2200535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2200546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2200549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2200555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200581 */     // MIs[0] round
     /* 2200581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200584 */     // MIs[0] policy
     /* 2200584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200594 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2200597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200620 */     // GIR_Coverage, 18968,
     /* 2200620 */     GIR_EraseRootFromParent_Done,
     /* 2200621 */   // Label 28950: @2200621
     /* 2200621 */   GIM_Try, /*On fail goto*//*Label 28951*/ GIMT_Encode4(2200712), // Rule ID 18969 //
     /* 2200626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2200637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2200640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2200646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2200649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2200656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200672 */     // MIs[0] round
     /* 2200672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200675 */     // MIs[0] policy
     /* 2200675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200685 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11310:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2200688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200711 */     // GIR_Coverage, 18969,
     /* 2200711 */     GIR_EraseRootFromParent_Done,
     /* 2200712 */   // Label 28951: @2200712
     /* 2200712 */   GIM_Try, /*On fail goto*//*Label 28952*/ GIMT_Encode4(2200803), // Rule ID 18972 //
     /* 2200717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2200728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2200731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2200737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200763 */     // MIs[0] round
     /* 2200763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200766 */     // MIs[0] policy
     /* 2200766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200776 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2200779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200802 */     // GIR_Coverage, 18972,
     /* 2200802 */     GIR_EraseRootFromParent_Done,
     /* 2200803 */   // Label 28952: @2200803
     /* 2200803 */   GIM_Try, /*On fail goto*//*Label 28953*/ GIMT_Encode4(2200894), // Rule ID 18973 //
     /* 2200808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2200819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2200822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2200828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2200831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2200834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2200838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200854 */     // MIs[0] round
     /* 2200854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200857 */     // MIs[0] policy
     /* 2200857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200867 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2200867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2200870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200893 */     // GIR_Coverage, 18973,
     /* 2200893 */     GIR_EraseRootFromParent_Done,
     /* 2200894 */   // Label 28953: @2200894
     /* 2200894 */   GIM_Try, /*On fail goto*//*Label 28954*/ GIMT_Encode4(2200985), // Rule ID 18976 //
     /* 2200899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2200902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2200910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2200913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2200916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2200919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2200922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2200925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2200929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2200937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2200945 */     // MIs[0] round
     /* 2200945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2200948 */     // MIs[0] policy
     /* 2200948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2200951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2200958 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2200958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2200961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2200965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2200967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2200969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2200971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2200973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2200978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2200983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200984 */     // GIR_Coverage, 18976,
     /* 2200984 */     GIR_EraseRootFromParent_Done,
     /* 2200985 */   // Label 28954: @2200985
     /* 2200985 */   GIM_Try, /*On fail goto*//*Label 28955*/ GIMT_Encode4(2201076), // Rule ID 18977 //
     /* 2200990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2200993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2200998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2201001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2201004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2201010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201036 */     // MIs[0] round
     /* 2201036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201039 */     // MIs[0] policy
     /* 2201039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201049 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2201052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201075 */     // GIR_Coverage, 18977,
     /* 2201075 */     GIR_EraseRootFromParent_Done,
     /* 2201076 */   // Label 28955: @2201076
     /* 2201076 */   GIM_Try, /*On fail goto*//*Label 28956*/ GIMT_Encode4(2201167), // Rule ID 18980 //
     /* 2201081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2201084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201127 */     // MIs[0] round
     /* 2201127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201130 */     // MIs[0] policy
     /* 2201130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201140 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2201143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201166 */     // GIR_Coverage, 18980,
     /* 2201166 */     GIR_EraseRootFromParent_Done,
     /* 2201167 */   // Label 28956: @2201167
     /* 2201167 */   GIM_Try, /*On fail goto*//*Label 28957*/ GIMT_Encode4(2201258), // Rule ID 18981 //
     /* 2201172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2201175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2201183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2201186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2201189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2201192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2201195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2201210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201218 */     // MIs[0] round
     /* 2201218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201221 */     // MIs[0] policy
     /* 2201221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201231 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2201234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201257 */     // GIR_Coverage, 18981,
     /* 2201257 */     GIR_EraseRootFromParent_Done,
     /* 2201258 */   // Label 28957: @2201258
     /* 2201258 */   GIM_Try, /*On fail goto*//*Label 28958*/ GIMT_Encode4(2201349), // Rule ID 18984 //
     /* 2201263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201309 */     // MIs[0] round
     /* 2201309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201312 */     // MIs[0] policy
     /* 2201312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201322 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2201325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201348 */     // GIR_Coverage, 18984,
     /* 2201348 */     GIR_EraseRootFromParent_Done,
     /* 2201349 */   // Label 28958: @2201349
     /* 2201349 */   GIM_Try, /*On fail goto*//*Label 28959*/ GIMT_Encode4(2201440), // Rule ID 18985 //
     /* 2201354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2201365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2201368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2201374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2201377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2201384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201400 */     // MIs[0] round
     /* 2201400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201403 */     // MIs[0] policy
     /* 2201403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201413 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11310:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2201416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201439 */     // GIR_Coverage, 18985,
     /* 2201439 */     GIR_EraseRootFromParent_Done,
     /* 2201440 */   // Label 28959: @2201440
     /* 2201440 */   GIM_Try, /*On fail goto*//*Label 28960*/ GIMT_Encode4(2201531), // Rule ID 18988 //
     /* 2201445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2201456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2201459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2201465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201491 */     // MIs[0] round
     /* 2201491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201494 */     // MIs[0] policy
     /* 2201494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2201507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201530 */     // GIR_Coverage, 18988,
     /* 2201530 */     GIR_EraseRootFromParent_Done,
     /* 2201531 */   // Label 28960: @2201531
     /* 2201531 */   GIM_Try, /*On fail goto*//*Label 28961*/ GIMT_Encode4(2201622), // Rule ID 18989 //
     /* 2201536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2201547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2201550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2201556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2201559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2201566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201582 */     // MIs[0] round
     /* 2201582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201585 */     // MIs[0] policy
     /* 2201585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201595 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11310:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2201598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201621 */     // GIR_Coverage, 18989,
     /* 2201621 */     GIR_EraseRootFromParent_Done,
     /* 2201622 */   // Label 28961: @2201622
     /* 2201622 */   GIM_Try, /*On fail goto*//*Label 28962*/ GIMT_Encode4(2201713), // Rule ID 18992 //
     /* 2201627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2201638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2201641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2201647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201673 */     // MIs[0] round
     /* 2201673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201676 */     // MIs[0] policy
     /* 2201676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201686 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2201689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201712 */     // GIR_Coverage, 18992,
     /* 2201712 */     GIR_EraseRootFromParent_Done,
     /* 2201713 */   // Label 28962: @2201713
     /* 2201713 */   GIM_Try, /*On fail goto*//*Label 28963*/ GIMT_Encode4(2201804), // Rule ID 18993 //
     /* 2201718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2201729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2201732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2201738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2201741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2201748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2201760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201764 */     // MIs[0] round
     /* 2201764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201767 */     // MIs[0] policy
     /* 2201767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201777 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11310:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2201780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201803 */     // GIR_Coverage, 18993,
     /* 2201803 */     GIR_EraseRootFromParent_Done,
     /* 2201804 */   // Label 28963: @2201804
     /* 2201804 */   GIM_Try, /*On fail goto*//*Label 28964*/ GIMT_Encode4(2201895), // Rule ID 18996 //
     /* 2201809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2201812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2201820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2201823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2201829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2201835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201855 */     // MIs[0] round
     /* 2201855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201858 */     // MIs[0] policy
     /* 2201858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201868 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2201868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2201871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201894 */     // GIR_Coverage, 18996,
     /* 2201894 */     GIR_EraseRootFromParent_Done,
     /* 2201895 */   // Label 28964: @2201895
     /* 2201895 */   GIM_Try, /*On fail goto*//*Label 28965*/ GIMT_Encode4(2201986), // Rule ID 18997 //
     /* 2201900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2201903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2201908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2201911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2201914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2201917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2201920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2201923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2201926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2201930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2201934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2201938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2201942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2201946 */     // MIs[0] round
     /* 2201946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2201949 */     // MIs[0] policy
     /* 2201949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2201952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2201959 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11310:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2201959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2201962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2201966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2201968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2201970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2201972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2201974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2201979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2201982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2201984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201985 */     // GIR_Coverage, 18997,
     /* 2201985 */     GIR_EraseRootFromParent_Done,
     /* 2201986 */   // Label 28965: @2201986
     /* 2201986 */   GIM_Try, /*On fail goto*//*Label 28966*/ GIMT_Encode4(2202077), // Rule ID 64355 //
     /* 2201991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2201994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2201999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202037 */     // MIs[0] round
     /* 2202037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202040 */     // MIs[0] policy
     /* 2202040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202050 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2202053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202076 */     // GIR_Coverage, 64355,
     /* 2202076 */     GIR_EraseRootFromParent_Done,
     /* 2202077 */   // Label 28966: @2202077
     /* 2202077 */   GIM_Try, /*On fail goto*//*Label 28967*/ GIMT_Encode4(2202168), // Rule ID 64356 //
     /* 2202082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202128 */     // MIs[0] round
     /* 2202128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202131 */     // MIs[0] policy
     /* 2202131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202141 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2202144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202167 */     // GIR_Coverage, 64356,
     /* 2202167 */     GIR_EraseRootFromParent_Done,
     /* 2202168 */   // Label 28967: @2202168
     /* 2202168 */   GIM_Try, /*On fail goto*//*Label 28968*/ GIMT_Encode4(2202259), // Rule ID 64359 //
     /* 2202173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2202184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2202187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2202190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202219 */     // MIs[0] round
     /* 2202219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202222 */     // MIs[0] policy
     /* 2202222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202232 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2202235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202258 */     // GIR_Coverage, 64359,
     /* 2202258 */     GIR_EraseRootFromParent_Done,
     /* 2202259 */   // Label 28968: @2202259
     /* 2202259 */   GIM_Try, /*On fail goto*//*Label 28969*/ GIMT_Encode4(2202350), // Rule ID 64360 //
     /* 2202264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2202275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2202278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2202281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2202287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202310 */     // MIs[0] round
     /* 2202310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202313 */     // MIs[0] policy
     /* 2202313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202323 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2202326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202349 */     // GIR_Coverage, 64360,
     /* 2202349 */     GIR_EraseRootFromParent_Done,
     /* 2202350 */   // Label 28969: @2202350
     /* 2202350 */   GIM_Try, /*On fail goto*//*Label 28970*/ GIMT_Encode4(2202441), // Rule ID 64363 //
     /* 2202355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2202366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2202369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2202372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202401 */     // MIs[0] round
     /* 2202401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202404 */     // MIs[0] policy
     /* 2202404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202414 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2202417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202440 */     // GIR_Coverage, 64363,
     /* 2202440 */     GIR_EraseRootFromParent_Done,
     /* 2202441 */   // Label 28970: @2202441
     /* 2202441 */   GIM_Try, /*On fail goto*//*Label 28971*/ GIMT_Encode4(2202532), // Rule ID 64364 //
     /* 2202446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2202457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2202460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2202463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2202469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202492 */     // MIs[0] round
     /* 2202492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202495 */     // MIs[0] policy
     /* 2202495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202505 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2202508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202531 */     // GIR_Coverage, 64364,
     /* 2202531 */     GIR_EraseRootFromParent_Done,
     /* 2202532 */   // Label 28971: @2202532
     /* 2202532 */   GIM_Try, /*On fail goto*//*Label 28972*/ GIMT_Encode4(2202623), // Rule ID 64367 //
     /* 2202537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2202548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2202551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2202554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202583 */     // MIs[0] round
     /* 2202583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202586 */     // MIs[0] policy
     /* 2202586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202596 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2202599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202622 */     // GIR_Coverage, 64367,
     /* 2202622 */     GIR_EraseRootFromParent_Done,
     /* 2202623 */   // Label 28972: @2202623
     /* 2202623 */   GIM_Try, /*On fail goto*//*Label 28973*/ GIMT_Encode4(2202714), // Rule ID 64368 //
     /* 2202628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2202639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2202642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2202645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2202651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2202666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202674 */     // MIs[0] round
     /* 2202674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202677 */     // MIs[0] policy
     /* 2202677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202687 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11099:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2202690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202713 */     // GIR_Coverage, 64368,
     /* 2202713 */     GIR_EraseRootFromParent_Done,
     /* 2202714 */   // Label 28973: @2202714
     /* 2202714 */   GIM_Try, /*On fail goto*//*Label 28974*/ GIMT_Encode4(2202805), // Rule ID 64371 //
     /* 2202719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2202730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2202733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2202736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2202742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2202749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202765 */     // MIs[0] round
     /* 2202765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202768 */     // MIs[0] policy
     /* 2202768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202778 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2202781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202804 */     // GIR_Coverage, 64371,
     /* 2202804 */     GIR_EraseRootFromParent_Done,
     /* 2202805 */   // Label 28974: @2202805
     /* 2202805 */   GIM_Try, /*On fail goto*//*Label 28975*/ GIMT_Encode4(2202896), // Rule ID 64372 //
     /* 2202810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2202818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2202821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2202824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2202827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2202833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2202836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2202840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2202848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202856 */     // MIs[0] round
     /* 2202856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202859 */     // MIs[0] policy
     /* 2202859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202869 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2202869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2202872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202895 */     // GIR_Coverage, 64372,
     /* 2202895 */     GIR_EraseRootFromParent_Done,
     /* 2202896 */   // Label 28975: @2202896
     /* 2202896 */   GIM_Try, /*On fail goto*//*Label 28976*/ GIMT_Encode4(2202987), // Rule ID 64375 //
     /* 2202901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2202904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2202909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2202912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2202915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2202918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2202921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2202924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2202927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2202931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2202943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2202947 */     // MIs[0] round
     /* 2202947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2202950 */     // MIs[0] policy
     /* 2202950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2202953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2202960 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2202960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2202963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2202967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2202969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2202971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2202973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2202975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2202980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2202985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202986 */     // GIR_Coverage, 64375,
     /* 2202986 */     GIR_EraseRootFromParent_Done,
     /* 2202987 */   // Label 28976: @2202987
     /* 2202987 */   GIM_Try, /*On fail goto*//*Label 28977*/ GIMT_Encode4(2203078), // Rule ID 64376 //
     /* 2202992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2202995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2203003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2203006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2203009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203038 */     // MIs[0] round
     /* 2203038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203041 */     // MIs[0] policy
     /* 2203041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203051 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2203054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203077 */     // GIR_Coverage, 64376,
     /* 2203077 */     GIR_EraseRootFromParent_Done,
     /* 2203078 */   // Label 28977: @2203078
     /* 2203078 */   GIM_Try, /*On fail goto*//*Label 28978*/ GIMT_Encode4(2203169), // Rule ID 64379 //
     /* 2203083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2203094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2203097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203129 */     // MIs[0] round
     /* 2203129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203132 */     // MIs[0] policy
     /* 2203132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203142 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2203145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203168 */     // GIR_Coverage, 64379,
     /* 2203168 */     GIR_EraseRootFromParent_Done,
     /* 2203169 */   // Label 28978: @2203169
     /* 2203169 */   GIM_Try, /*On fail goto*//*Label 28979*/ GIMT_Encode4(2203260), // Rule ID 64380 //
     /* 2203174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2203185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2203188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2203191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2203197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203220 */     // MIs[0] round
     /* 2203220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203223 */     // MIs[0] policy
     /* 2203223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203233 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2203236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203259 */     // GIR_Coverage, 64380,
     /* 2203259 */     GIR_EraseRootFromParent_Done,
     /* 2203260 */   // Label 28979: @2203260
     /* 2203260 */   GIM_Try, /*On fail goto*//*Label 28980*/ GIMT_Encode4(2203351), // Rule ID 64383 //
     /* 2203265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2203276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2203279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203311 */     // MIs[0] round
     /* 2203311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203314 */     // MIs[0] policy
     /* 2203314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203324 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2203327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203350 */     // GIR_Coverage, 64383,
     /* 2203350 */     GIR_EraseRootFromParent_Done,
     /* 2203351 */   // Label 28980: @2203351
     /* 2203351 */   GIM_Try, /*On fail goto*//*Label 28981*/ GIMT_Encode4(2203442), // Rule ID 64384 //
     /* 2203356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2203367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2203370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2203373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2203379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203402 */     // MIs[0] round
     /* 2203402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203405 */     // MIs[0] policy
     /* 2203405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203415 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2203418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203441 */     // GIR_Coverage, 64384,
     /* 2203441 */     GIR_EraseRootFromParent_Done,
     /* 2203442 */   // Label 28981: @2203442
     /* 2203442 */   GIM_Try, /*On fail goto*//*Label 28982*/ GIMT_Encode4(2203533), // Rule ID 64387 //
     /* 2203447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203493 */     // MIs[0] round
     /* 2203493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203496 */     // MIs[0] policy
     /* 2203496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203506 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2203509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203532 */     // GIR_Coverage, 64387,
     /* 2203532 */     GIR_EraseRootFromParent_Done,
     /* 2203533 */   // Label 28982: @2203533
     /* 2203533 */   GIM_Try, /*On fail goto*//*Label 28983*/ GIMT_Encode4(2203624), // Rule ID 64388 //
     /* 2203538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2203549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2203552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2203555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2203561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203584 */     // MIs[0] round
     /* 2203584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203587 */     // MIs[0] policy
     /* 2203587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203597 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2203600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203623 */     // GIR_Coverage, 64388,
     /* 2203623 */     GIR_EraseRootFromParent_Done,
     /* 2203624 */   // Label 28983: @2203624
     /* 2203624 */   GIM_Try, /*On fail goto*//*Label 28984*/ GIMT_Encode4(2203715), // Rule ID 64391 //
     /* 2203629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2203632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2203640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2203643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2203646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203675 */     // MIs[0] round
     /* 2203675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203678 */     // MIs[0] policy
     /* 2203678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2203691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203714 */     // GIR_Coverage, 64391,
     /* 2203714 */     GIR_EraseRootFromParent_Done,
     /* 2203715 */   // Label 28984: @2203715
     /* 2203715 */   GIM_Try, /*On fail goto*//*Label 28985*/ GIMT_Encode4(2203806), // Rule ID 64392 //
     /* 2203720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2203723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2203728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2203731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2203734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2203737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2203743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2203750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2203758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203766 */     // MIs[0] round
     /* 2203766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203769 */     // MIs[0] policy
     /* 2203769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203779 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2203782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203805 */     // GIR_Coverage, 64392,
     /* 2203805 */     GIR_EraseRootFromParent_Done,
     /* 2203806 */   // Label 28985: @2203806
     /* 2203806 */   GIM_Try, /*On fail goto*//*Label 28986*/ GIMT_Encode4(2203897), // Rule ID 65105 //
     /* 2203811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2203814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2203819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2203822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2203825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2203828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2203837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203857 */     // MIs[0] round
     /* 2203857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203860 */     // MIs[0] policy
     /* 2203860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203870 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2203870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2203873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203896 */     // GIR_Coverage, 65105,
     /* 2203896 */     GIR_EraseRootFromParent_Done,
     /* 2203897 */   // Label 28986: @2203897
     /* 2203897 */   GIM_Try, /*On fail goto*//*Label 28987*/ GIMT_Encode4(2203988), // Rule ID 65106 //
     /* 2203902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2203905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2203910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2203913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2203916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2203919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2203922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2203925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2203928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2203932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2203944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2203948 */     // MIs[0] round
     /* 2203948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2203951 */     // MIs[0] policy
     /* 2203951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2203954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2203961 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11036:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2203961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF4_MASK),
     /* 2203964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2203968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2203970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2203972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2203974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2203976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2203981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2203986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203987 */     // GIR_Coverage, 65106,
     /* 2203987 */     GIR_EraseRootFromParent_Done,
     /* 2203988 */   // Label 28987: @2203988
     /* 2203988 */   GIM_Try, /*On fail goto*//*Label 28988*/ GIMT_Encode4(2204079), // Rule ID 65109 //
     /* 2203993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2203996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2204004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2204007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2204010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204039 */     // MIs[0] round
     /* 2204039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204042 */     // MIs[0] policy
     /* 2204042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204052 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2204055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204078 */     // GIR_Coverage, 65109,
     /* 2204078 */     GIR_EraseRootFromParent_Done,
     /* 2204079 */   // Label 28988: @2204079
     /* 2204079 */   GIM_Try, /*On fail goto*//*Label 28989*/ GIMT_Encode4(2204170), // Rule ID 65110 //
     /* 2204084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2204095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2204098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2204101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2204107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204130 */     // MIs[0] round
     /* 2204130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204133 */     // MIs[0] policy
     /* 2204133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204143 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_MF2_MASK),
     /* 2204146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204169 */     // GIR_Coverage, 65110,
     /* 2204169 */     GIR_EraseRootFromParent_Done,
     /* 2204170 */   // Label 28989: @2204170
     /* 2204170 */   GIM_Try, /*On fail goto*//*Label 28990*/ GIMT_Encode4(2204261), // Rule ID 65113 //
     /* 2204175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2204186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2204189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2204192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204221 */     // MIs[0] round
     /* 2204221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204224 */     // MIs[0] policy
     /* 2204224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204234 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2204237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204260 */     // GIR_Coverage, 65113,
     /* 2204260 */     GIR_EraseRootFromParent_Done,
     /* 2204261 */   // Label 28990: @2204261
     /* 2204261 */   GIM_Try, /*On fail goto*//*Label 28991*/ GIMT_Encode4(2204352), // Rule ID 65114 //
     /* 2204266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2204277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2204280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2204283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2204289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204312 */     // MIs[0] round
     /* 2204312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204315 */     // MIs[0] policy
     /* 2204315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204325 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11036:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M1_MASK),
     /* 2204328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204351 */     // GIR_Coverage, 65114,
     /* 2204351 */     GIR_EraseRootFromParent_Done,
     /* 2204352 */   // Label 28991: @2204352
     /* 2204352 */   GIM_Try, /*On fail goto*//*Label 28992*/ GIMT_Encode4(2204443), // Rule ID 65117 //
     /* 2204357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2204368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2204371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2204374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204403 */     // MIs[0] round
     /* 2204403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204406 */     // MIs[0] policy
     /* 2204406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204416 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2204419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204442 */     // GIR_Coverage, 65117,
     /* 2204442 */     GIR_EraseRootFromParent_Done,
     /* 2204443 */   // Label 28992: @2204443
     /* 2204443 */   GIM_Try, /*On fail goto*//*Label 28993*/ GIMT_Encode4(2204534), // Rule ID 65118 //
     /* 2204448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2204459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2204462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2204465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2204471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2204478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204494 */     // MIs[0] round
     /* 2204494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204497 */     // MIs[0] policy
     /* 2204497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204507 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M2_MASK),
     /* 2204510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204533 */     // GIR_Coverage, 65118,
     /* 2204533 */     GIR_EraseRootFromParent_Done,
     /* 2204534 */   // Label 28993: @2204534
     /* 2204534 */   GIM_Try, /*On fail goto*//*Label 28994*/ GIMT_Encode4(2204625), // Rule ID 65121 //
     /* 2204539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2204550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2204553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2204556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2204562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2204569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204585 */     // MIs[0] round
     /* 2204585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204588 */     // MIs[0] policy
     /* 2204588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204598 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11036:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2204601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204624 */     // GIR_Coverage, 65121,
     /* 2204624 */     GIR_EraseRootFromParent_Done,
     /* 2204625 */   // Label 28994: @2204625
     /* 2204625 */   GIM_Try, /*On fail goto*//*Label 28995*/ GIMT_Encode4(2204716), // Rule ID 65122 //
     /* 2204630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2204641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2204644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2204647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2204653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2204660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204676 */     // MIs[0] round
     /* 2204676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204679 */     // MIs[0] policy
     /* 2204679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204689 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11036:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M4_MASK),
     /* 2204692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204715 */     // GIR_Coverage, 65122,
     /* 2204715 */     GIR_EraseRootFromParent_Done,
     /* 2204716 */   // Label 28995: @2204716
     /* 2204716 */   GIM_Try, /*On fail goto*//*Label 28996*/ GIMT_Encode4(2204807), // Rule ID 65125 //
     /* 2204721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2204732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2204735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2204738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2204744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2204751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204767 */     // MIs[0] round
     /* 2204767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204770 */     // MIs[0] policy
     /* 2204770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204780 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11036:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2204783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204806 */     // GIR_Coverage, 65125,
     /* 2204806 */     GIR_EraseRootFromParent_Done,
     /* 2204807 */   // Label 28996: @2204807
     /* 2204807 */   GIM_Try, /*On fail goto*//*Label 28997*/ GIMT_Encode4(2204898), // Rule ID 65126 //
     /* 2204812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadt_mask),
     /* 2204820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2204823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2204826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2204829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2204835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2204838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2204842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204858 */     // MIs[0] round
     /* 2204858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204861 */     // MIs[0] policy
     /* 2204861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204871 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11036:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADT_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2204871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADT_VFPR16_M8_MASK),
     /* 2204874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204897 */     // GIR_Coverage, 65126,
     /* 2204897 */     GIR_EraseRootFromParent_Done,
     /* 2204898 */   // Label 28997: @2204898
     /* 2204898 */   GIM_Try, /*On fail goto*//*Label 28998*/ GIMT_Encode4(2204989), // Rule ID 65129 //
     /* 2204903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2204906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2204911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2204914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2204917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2204920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2204923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2204926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2204929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2204933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2204945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2204949 */     // MIs[0] round
     /* 2204949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2204952 */     // MIs[0] policy
     /* 2204952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2204955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2204962 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2204962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2204965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2204969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2204971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2204973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2204975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2204977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2204982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2204987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204988 */     // GIR_Coverage, 65129,
     /* 2204988 */     GIR_EraseRootFromParent_Done,
     /* 2204989 */   // Label 28998: @2204989
     /* 2204989 */   GIM_Try, /*On fail goto*//*Label 28999*/ GIMT_Encode4(2205080), // Rule ID 65130 //
     /* 2204994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2204997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2205005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2205008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2205011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2205017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205040 */     // MIs[0] round
     /* 2205040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205043 */     // MIs[0] policy
     /* 2205043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205053 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11034:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF4_MASK),
     /* 2205056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205079 */     // GIR_Coverage, 65130,
     /* 2205079 */     GIR_EraseRootFromParent_Done,
     /* 2205080 */   // Label 28999: @2205080
     /* 2205080 */   GIM_Try, /*On fail goto*//*Label 29000*/ GIMT_Encode4(2205171), // Rule ID 65133 //
     /* 2205085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2205096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2205099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2205102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205131 */     // MIs[0] round
     /* 2205131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205134 */     // MIs[0] policy
     /* 2205134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205144 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2205147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205170 */     // GIR_Coverage, 65133,
     /* 2205170 */     GIR_EraseRootFromParent_Done,
     /* 2205171 */   // Label 29000: @2205171
     /* 2205171 */   GIM_Try, /*On fail goto*//*Label 29001*/ GIMT_Encode4(2205262), // Rule ID 65134 //
     /* 2205176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2205187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2205190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2205193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2205199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205222 */     // MIs[0] round
     /* 2205222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205225 */     // MIs[0] policy
     /* 2205225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205235 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_MF2_MASK),
     /* 2205238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205261 */     // GIR_Coverage, 65134,
     /* 2205261 */     GIR_EraseRootFromParent_Done,
     /* 2205262 */   // Label 29001: @2205262
     /* 2205262 */   GIM_Try, /*On fail goto*//*Label 29002*/ GIMT_Encode4(2205353), // Rule ID 65137 //
     /* 2205267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2205278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2205281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2205284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205313 */     // MIs[0] round
     /* 2205313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205316 */     // MIs[0] policy
     /* 2205316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205326 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2205329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205352 */     // GIR_Coverage, 65137,
     /* 2205352 */     GIR_EraseRootFromParent_Done,
     /* 2205353 */   // Label 29002: @2205353
     /* 2205353 */   GIM_Try, /*On fail goto*//*Label 29003*/ GIMT_Encode4(2205444), // Rule ID 65138 //
     /* 2205358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2205369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2205372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2205375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2205381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2205388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205404 */     // MIs[0] round
     /* 2205404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205407 */     // MIs[0] policy
     /* 2205407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205417 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11034:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M1_MASK),
     /* 2205420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205443 */     // GIR_Coverage, 65138,
     /* 2205443 */     GIR_EraseRootFromParent_Done,
     /* 2205444 */   // Label 29003: @2205444
     /* 2205444 */   GIM_Try, /*On fail goto*//*Label 29004*/ GIMT_Encode4(2205535), // Rule ID 65141 //
     /* 2205449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2205460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2205463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2205466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2205472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2205479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205495 */     // MIs[0] round
     /* 2205495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205498 */     // MIs[0] policy
     /* 2205498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205508 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11034:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2205511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205534 */     // GIR_Coverage, 65141,
     /* 2205534 */     GIR_EraseRootFromParent_Done,
     /* 2205535 */   // Label 29004: @2205535
     /* 2205535 */   GIM_Try, /*On fail goto*//*Label 29005*/ GIMT_Encode4(2205626), // Rule ID 65142 //
     /* 2205540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2205551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2205554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2205557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2205563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2205570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2205578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205586 */     // MIs[0] round
     /* 2205586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205589 */     // MIs[0] policy
     /* 2205589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205599 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11034:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M2_MASK),
     /* 2205602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205625 */     // GIR_Coverage, 65142,
     /* 2205625 */     GIR_EraseRootFromParent_Done,
     /* 2205626 */   // Label 29005: @2205626
     /* 2205626 */   GIM_Try, /*On fail goto*//*Label 29006*/ GIMT_Encode4(2205717), // Rule ID 65145 //
     /* 2205631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2205642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2205645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2205648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2205654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205677 */     // MIs[0] round
     /* 2205677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205680 */     // MIs[0] policy
     /* 2205680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205690 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11034:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2205693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205716 */     // GIR_Coverage, 65145,
     /* 2205716 */     GIR_EraseRootFromParent_Done,
     /* 2205717 */   // Label 29006: @2205717
     /* 2205717 */   GIM_Try, /*On fail goto*//*Label 29007*/ GIMT_Encode4(2205808), // Rule ID 65146 //
     /* 2205722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2205733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2205736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2205739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2205745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2205752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2205760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205768 */     // MIs[0] round
     /* 2205768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205771 */     // MIs[0] policy
     /* 2205771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205781 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11034:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M4_MASK),
     /* 2205784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205807 */     // GIR_Coverage, 65146,
     /* 2205807 */     GIR_EraseRootFromParent_Done,
     /* 2205808 */   // Label 29007: @2205808
     /* 2205808 */   GIM_Try, /*On fail goto*//*Label 29008*/ GIMT_Encode4(2205899), // Rule ID 65149 //
     /* 2205813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2205824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2205827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2205830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2205836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2205839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205859 */     // MIs[0] round
     /* 2205859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205862 */     // MIs[0] policy
     /* 2205862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205872 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11034:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2205872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2205875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205898 */     // GIR_Coverage, 65149,
     /* 2205898 */     GIR_EraseRootFromParent_Done,
     /* 2205899 */   // Label 29008: @2205899
     /* 2205899 */   GIM_Try, /*On fail goto*//*Label 29009*/ GIMT_Encode4(2205990), // Rule ID 65150 //
     /* 2205904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_nds_vfpmadb_mask),
     /* 2205912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2205915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2205918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2205921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2205924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2205927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2205930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2205934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2205942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2205946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2205950 */     // MIs[0] round
     /* 2205950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2205953 */     // MIs[0] policy
     /* 2205953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2205956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2205963 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11034:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoNDS_VFPMADB_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2205963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoNDS_VFPMADB_VFPR16_M8_MASK),
     /* 2205966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2205970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2205972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2205974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2205976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2205978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2205983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2205986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2205988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205989 */     // GIR_Coverage, 65150,
     /* 2205989 */     GIR_EraseRootFromParent_Done,
     /* 2205990 */   // Label 29009: @2205990
     /* 2205990 */   GIM_Reject,
     /* 2205991 */ // Label 26941: @2205991
     /* 2205991 */ GIM_Reject,
     /* 2205992 */ // Label 38: @2205992
     /* 2205992 */ GIM_Try, /*On fail goto*//*Label 29010*/ GIMT_Encode4(2206044),
     /* 2205997 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 2206000 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::riscv_pause),
     /* 2206005 */   GIM_Try, /*On fail goto*//*Label 29011*/ GIMT_Encode4(2206024), // Rule ID 295 //
     /* 2206010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode0),
     /* 2206013 */     // (intrinsic_void 11039:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2206013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2206016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2206019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2206022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206023 */     // GIR_Coverage, 295,
     /* 2206023 */     GIR_EraseRootFromParent_Done,
     /* 2206024 */   // Label 29011: @2206024
     /* 2206024 */   GIM_Try, /*On fail goto*//*Label 29012*/ GIMT_Encode4(2206043), // Rule ID 296 //
     /* 2206029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZihintpause_HwMode1),
     /* 2206032 */     // (intrinsic_void 11039:{ *:[iPTR] })  =>  (FENCE 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2206032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /* 2206035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2206038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2206041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206042 */     // GIR_Coverage, 296,
     /* 2206042 */     GIR_EraseRootFromParent_Done,
     /* 2206043 */   // Label 29012: @2206043
     /* 2206043 */   GIM_Reject,
     /* 2206044 */ // Label 29010: @2206044
     /* 2206044 */ GIM_Try, /*On fail goto*//*Label 29013*/ GIMT_Encode4(2206127), // Rule ID 41 //
     /* 2206049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2206052 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 2206055 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 2206060 */   // MIs[0] Operand 1
     /* 2206060 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 2206064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRX5RegClassID),
     /* 2206068 */   // MIs[0] ptr
     /* 2206068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRJALRRegClassID),
     /* 2206076 */   // MIs[0] accessinfo
     /* 2206076 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 2206079 */   // (intrinsic_void 195:{ *:[iPTR] }, X5:{ *:[i64] }, GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 2206079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 2206083 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X5), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206089 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X5
     /* 2206093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 2206096 */   GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 2206098 */   GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 2206100 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X1*/0,
     /* 2206103 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X6*/1,
     /* 2206106 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X7*/2,
     /* 2206109 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X28*/3,
     /* 2206112 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X29*/4,
     /* 2206115 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X30*/5,
     /* 2206118 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X31*/6,
     /* 2206121 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2206126 */   // GIR_Coverage, 41,
     /* 2206126 */   GIR_EraseRootFromParent_Done,
     /* 2206127 */ // Label 29013: @2206127
     /* 2206127 */ GIM_Try, /*On fail goto*//*Label 29014*/ GIMT_Encode4(2207032),
     /* 2206132 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 2206135 */   GIM_Try, /*On fail goto*//*Label 29015*/ GIMT_Encode4(2206207), // Rule ID 629 //
     /* 2206140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i32),
     /* 2206148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206161 */     // MIs[0] addr
     /* 2206161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206177 */     // MIs[0] ordering
     /* 2206177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206180 */     // (intrinsic_w_chain:{ *:[i32] } 11020:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2206186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206188 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206193 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206195 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206197 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206199 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206206 */     // GIR_Coverage, 629,
     /* 2206206 */     GIR_EraseRootFromParent_Done,
     /* 2206207 */   // Label 29015: @2206207
     /* 2206207 */   GIM_Try, /*On fail goto*//*Label 29016*/ GIMT_Encode4(2206279), // Rule ID 630 //
     /* 2206212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i32),
     /* 2206220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206233 */     // MIs[0] addr
     /* 2206233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206249 */     // MIs[0] ordering
     /* 2206249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206252 */     // (intrinsic_w_chain:{ *:[i32] } 11006:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2206258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206260 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206265 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206267 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206269 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206271 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206278 */     // GIR_Coverage, 630,
     /* 2206278 */     GIR_EraseRootFromParent_Done,
     /* 2206279 */   // Label 29016: @2206279
     /* 2206279 */   GIM_Try, /*On fail goto*//*Label 29017*/ GIMT_Encode4(2206351), // Rule ID 631 //
     /* 2206284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i32),
     /* 2206292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206305 */     // MIs[0] addr
     /* 2206305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206321 */     // MIs[0] ordering
     /* 2206321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206324 */     // (intrinsic_w_chain:{ *:[i32] } 11014:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2206330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206332 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206337 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206339 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206341 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206343 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206350 */     // GIR_Coverage, 631,
     /* 2206350 */     GIR_EraseRootFromParent_Done,
     /* 2206351 */   // Label 29017: @2206351
     /* 2206351 */   GIM_Try, /*On fail goto*//*Label 29018*/ GIMT_Encode4(2206423), // Rule ID 632 //
     /* 2206356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i32),
     /* 2206364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206377 */     // MIs[0] addr
     /* 2206377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206393 */     // MIs[0] ordering
     /* 2206393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206396 */     // (intrinsic_w_chain:{ *:[i32] } 11012:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2206402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206404 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206409 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206411 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206413 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206415 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206422 */     // GIR_Coverage, 632,
     /* 2206422 */     GIR_EraseRootFromParent_Done,
     /* 2206423 */   // Label 29018: @2206423
     /* 2206423 */   GIM_Try, /*On fail goto*//*Label 29019*/ GIMT_Encode4(2206503), // Rule ID 635 //
     /* 2206428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i32),
     /* 2206436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206449 */     // MIs[0] addr
     /* 2206449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206465 */     // MIs[0] ordering
     /* 2206465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206468 */     // (intrinsic_w_chain:{ *:[i32] } 11016:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206468 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2206471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2206477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206479 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206484 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206489 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206491 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206493 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206495 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206502 */     // GIR_Coverage, 635,
     /* 2206502 */     GIR_EraseRootFromParent_Done,
     /* 2206503 */   // Label 29019: @2206503
     /* 2206503 */   GIM_Try, /*On fail goto*//*Label 29020*/ GIMT_Encode4(2206583), // Rule ID 636 //
     /* 2206508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2206511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i32),
     /* 2206516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2206519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2206522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2206525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206529 */     // MIs[0] addr
     /* 2206529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206545 */     // MIs[0] ordering
     /* 2206545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206548 */     // (intrinsic_w_chain:{ *:[i32] } 11018:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2206548 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2206551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2206557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206559 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206564 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206569 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206571 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206573 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206575 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206582 */     // GIR_Coverage, 636,
     /* 2206582 */     GIR_EraseRootFromParent_Done,
     /* 2206583 */   // Label 29020: @2206583
     /* 2206583 */   GIM_Try, /*On fail goto*//*Label 29021*/ GIMT_Encode4(2206655), // Rule ID 642 //
     /* 2206588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i64),
     /* 2206596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206609 */     // MIs[0] addr
     /* 2206609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206625 */     // MIs[0] ordering
     /* 2206625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206628 */     // (intrinsic_w_chain:{ *:[i64] } 11021:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2206634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206636 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206641 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206643 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206645 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206647 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206654 */     // GIR_Coverage, 642,
     /* 2206654 */     GIR_EraseRootFromParent_Done,
     /* 2206655 */   // Label 29021: @2206655
     /* 2206655 */   GIM_Try, /*On fail goto*//*Label 29022*/ GIMT_Encode4(2206727), // Rule ID 643 //
     /* 2206660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i64),
     /* 2206668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206681 */     // MIs[0] addr
     /* 2206681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206697 */     // MIs[0] ordering
     /* 2206697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206700 */     // (intrinsic_w_chain:{ *:[i64] } 11007:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2206706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206708 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206713 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206715 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206717 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206719 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206726 */     // GIR_Coverage, 643,
     /* 2206726 */     GIR_EraseRootFromParent_Done,
     /* 2206727 */   // Label 29022: @2206727
     /* 2206727 */   GIM_Try, /*On fail goto*//*Label 29023*/ GIMT_Encode4(2206799), // Rule ID 644 //
     /* 2206732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i64),
     /* 2206740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206753 */     // MIs[0] addr
     /* 2206753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206769 */     // MIs[0] ordering
     /* 2206769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206772 */     // (intrinsic_w_chain:{ *:[i64] } 11015:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2206778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206780 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206785 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206787 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206789 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206791 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206798 */     // GIR_Coverage, 644,
     /* 2206798 */     GIR_EraseRootFromParent_Done,
     /* 2206799 */   // Label 29023: @2206799
     /* 2206799 */   GIM_Try, /*On fail goto*//*Label 29024*/ GIMT_Encode4(2206871), // Rule ID 645 //
     /* 2206804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i64),
     /* 2206812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206825 */     // MIs[0] addr
     /* 2206825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206841 */     // MIs[0] ordering
     /* 2206841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206844 */     // (intrinsic_w_chain:{ *:[i64] } 11013:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2206850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206852 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206857 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206859 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206861 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206863 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206870 */     // GIR_Coverage, 645,
     /* 2206870 */     GIR_EraseRootFromParent_Done,
     /* 2206871 */   // Label 29024: @2206871
     /* 2206871 */   GIM_Try, /*On fail goto*//*Label 29025*/ GIMT_Encode4(2206951), // Rule ID 648 //
     /* 2206876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i64),
     /* 2206884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206897 */     // MIs[0] addr
     /* 2206897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206913 */     // MIs[0] ordering
     /* 2206913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206916 */     // (intrinsic_w_chain:{ *:[i64] } 11017:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206916 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2206919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2206922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2206925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2206927 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206932 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2206937 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2206939 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2206941 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2206943 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2206945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2206949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206950 */     // GIR_Coverage, 648,
     /* 2206950 */     GIR_EraseRootFromParent_Done,
     /* 2206951 */   // Label 29025: @2206951
     /* 2206951 */   GIM_Try, /*On fail goto*//*Label 29026*/ GIMT_Encode4(2207031), // Rule ID 649 //
     /* 2206956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2206959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i64),
     /* 2206964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2206967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2206970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2206973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206977 */     // MIs[0] addr
     /* 2206977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2206981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2206993 */     // MIs[0] ordering
     /* 2206993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2206996 */     // (intrinsic_w_chain:{ *:[i64] } 11019:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2206996 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2206999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2207005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207007 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207012 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207017 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207019 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207021 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207023 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2207025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207030 */     // GIR_Coverage, 649,
     /* 2207030 */     GIR_EraseRootFromParent_Done,
     /* 2207031 */   // Label 29026: @2207031
     /* 2207031 */   GIM_Reject,
     /* 2207032 */ // Label 29014: @2207032
     /* 2207032 */ GIM_Try, /*On fail goto*//*Label 29027*/ GIMT_Encode4(2207559),
     /* 2207037 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 2207040 */   GIM_Try, /*On fail goto*//*Label 29028*/ GIMT_Encode4(2207129), // Rule ID 633 //
     /* 2207045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i32),
     /* 2207053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207069 */     // MIs[0] addr
     /* 2207069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207089 */     // MIs[0] ordering
     /* 2207089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207092 */     // (intrinsic_w_chain:{ *:[i32] } 11008:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2207092 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2207101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207103 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207108 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207113 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207115 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207117 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207119 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207121 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207128 */     // GIR_Coverage, 633,
     /* 2207128 */     GIR_EraseRootFromParent_Done,
     /* 2207129 */   // Label 29028: @2207129
     /* 2207129 */   GIM_Try, /*On fail goto*//*Label 29029*/ GIMT_Encode4(2207218), // Rule ID 634 //
     /* 2207134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i32),
     /* 2207142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207158 */     // MIs[0] addr
     /* 2207158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207178 */     // MIs[0] ordering
     /* 2207178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207181 */     // (intrinsic_w_chain:{ *:[i32] } 11010:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2207181 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2207190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207192 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207197 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207202 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207204 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207206 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207208 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207210 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207217 */     // GIR_Coverage, 634,
     /* 2207217 */     GIR_EraseRootFromParent_Done,
     /* 2207218 */   // Label 29029: @2207218
     /* 2207218 */   GIM_Try, /*On fail goto*//*Label 29030*/ GIMT_Encode4(2207307), // Rule ID 646 //
     /* 2207223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i64),
     /* 2207231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207247 */     // MIs[0] addr
     /* 2207247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207267 */     // MIs[0] ordering
     /* 2207267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207270 */     // (intrinsic_w_chain:{ *:[i64] } 11009:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2207270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2207279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207281 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207286 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207291 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207293 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207295 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207297 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207299 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207306 */     // GIR_Coverage, 646,
     /* 2207306 */     GIR_EraseRootFromParent_Done,
     /* 2207307 */   // Label 29030: @2207307
     /* 2207307 */   GIM_Try, /*On fail goto*//*Label 29031*/ GIMT_Encode4(2207396), // Rule ID 647 //
     /* 2207312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i64),
     /* 2207320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207336 */     // MIs[0] addr
     /* 2207336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207356 */     // MIs[0] ordering
     /* 2207356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207359 */     // (intrinsic_w_chain:{ *:[i64] } 11011:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2207359 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2207362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2207368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207370 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207375 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207380 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207382 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2207384 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2207386 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2207388 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207395 */     // GIR_Coverage, 647,
     /* 2207395 */     GIR_EraseRootFromParent_Done,
     /* 2207396 */   // Label 29031: @2207396
     /* 2207396 */   GIM_Try, /*On fail goto*//*Label 29032*/ GIMT_Encode4(2207477), // Rule ID 665 //
     /* 2207401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2207404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i32),
     /* 2207409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2207412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2207415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2207418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2207421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207425 */     // MIs[0] addr
     /* 2207425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207445 */     // MIs[0] ordering
     /* 2207445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207448 */     // (intrinsic_w_chain:{ *:[i32] } 11022:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2207448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2207454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207456 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207461 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207463 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2207465 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2207467 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2207469 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207476 */     // GIR_Coverage, 665,
     /* 2207476 */     GIR_EraseRootFromParent_Done,
     /* 2207477 */   // Label 29032: @2207477
     /* 2207477 */   GIM_Try, /*On fail goto*//*Label 29033*/ GIMT_Encode4(2207558), // Rule ID 666 //
     /* 2207482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2207485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i64),
     /* 2207490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2207493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2207496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2207499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2207502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207506 */     // MIs[0] addr
     /* 2207506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2207510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2207526 */     // MIs[0] ordering
     /* 2207526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2207529 */     // (intrinsic_w_chain:{ *:[i64] } 11023:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2207529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2207532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2207535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2207537 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2207542 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2207544 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2207546 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2207548 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2207550 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2207552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2207556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207557 */     // GIR_Coverage, 666,
     /* 2207557 */     GIR_EraseRootFromParent_Done,
     /* 2207558 */   // Label 29033: @2207558
     /* 2207558 */   GIM_Reject,
     /* 2207559 */ // Label 29027: @2207559
     /* 2207559 */ GIM_Reject,
     /* 2207560 */ // Label 39: @2207560
     /* 2207560 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(32), /*)*//*default:*//*Label 29049*/ GIMT_Encode4(2210680),
     /* 2207571 */ /*GILLT_nxv1s16*//*Label 29034*/ GIMT_Encode4(2207671),
     /* 2207575 */ /*GILLT_nxv1s32*//*Label 29035*/ GIMT_Encode4(2207775),
     /* 2207579 */ /*GILLT_nxv1s64*//*Label 29036*/ GIMT_Encode4(2207992), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207591 */ /*GILLT_nxv2s16*//*Label 29037*/ GIMT_Encode4(2208317),
     /* 2207595 */ /*GILLT_nxv2s32*//*Label 29038*/ GIMT_Encode4(2208421),
     /* 2207599 */ /*GILLT_nxv2s64*//*Label 29039*/ GIMT_Encode4(2208638), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207611 */ /*GILLT_nxv4s16*//*Label 29040*/ GIMT_Encode4(2208963),
     /* 2207615 */ /*GILLT_nxv4s32*//*Label 29041*/ GIMT_Encode4(2209067),
     /* 2207619 */ /*GILLT_nxv4s64*//*Label 29042*/ GIMT_Encode4(2209284), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207631 */ /*GILLT_nxv8s16*//*Label 29043*/ GIMT_Encode4(2209609),
     /* 2207635 */ /*GILLT_nxv8s32*//*Label 29044*/ GIMT_Encode4(2209713),
     /* 2207639 */ /*GILLT_nxv8s64*//*Label 29045*/ GIMT_Encode4(2209930), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207651 */ /*GILLT_nxv16s16*//*Label 29046*/ GIMT_Encode4(2210255),
     /* 2207655 */ /*GILLT_nxv16s32*//*Label 29047*/ GIMT_Encode4(2210359), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2207667 */ /*GILLT_nxv32s16*//*Label 29048*/ GIMT_Encode4(2210576),
     /* 2207671 */ // Label 29034: @2207671
     /* 2207671 */ GIM_Try, /*On fail goto*//*Label 29050*/ GIMT_Encode4(2207774),
     /* 2207676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2207679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207687 */   GIM_Try, /*On fail goto*//*Label 29051*/ GIMT_Encode4(2207730), // Rule ID 47484 //
     /* 2207692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207695 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2207698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2207712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207729 */     // GIR_Coverage, 47484,
     /* 2207729 */     GIR_EraseRootFromParent_Done,
     /* 2207730 */   // Label 29051: @2207730
     /* 2207730 */   GIM_Try, /*On fail goto*//*Label 29052*/ GIMT_Encode4(2207773), // Rule ID 47485 //
     /* 2207735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207738 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2207741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2207755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207772 */     // GIR_Coverage, 47485,
     /* 2207772 */     GIR_EraseRootFromParent_Done,
     /* 2207773 */   // Label 29052: @2207773
     /* 2207773 */   GIM_Reject,
     /* 2207774 */ // Label 29050: @2207774
     /* 2207774 */ GIM_Reject,
     /* 2207775 */ // Label 29035: @2207775
     /* 2207775 */ GIM_Try, /*On fail goto*//*Label 29053*/ GIMT_Encode4(2207829), // Rule ID 47508 //
     /* 2207780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2207786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207794 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207794 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2207797 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207801 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2207811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207816 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207828 */   // GIR_Coverage, 47508,
     /* 2207828 */   GIR_EraseRootFromParent_Done,
     /* 2207829 */ // Label 29053: @2207829
     /* 2207829 */ GIM_Try, /*On fail goto*//*Label 29054*/ GIMT_Encode4(2207883), // Rule ID 47509 //
     /* 2207834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2207840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207848 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2207851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2207865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207870 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207881 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207882 */   // GIR_Coverage, 47509,
     /* 2207882 */   GIR_EraseRootFromParent_Done,
     /* 2207883 */ // Label 29054: @2207883
     /* 2207883 */ GIM_Try, /*On fail goto*//*Label 29055*/ GIMT_Encode4(2207937), // Rule ID 47574 //
     /* 2207888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2207894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207902 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2207905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2207919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207924 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207936 */   // GIR_Coverage, 47574,
     /* 2207936 */   GIR_EraseRootFromParent_Done,
     /* 2207937 */ // Label 29055: @2207937
     /* 2207937 */ GIM_Try, /*On fail goto*//*Label 29056*/ GIMT_Encode4(2207991), // Rule ID 47575 //
     /* 2207942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2207948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207956 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2207959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2207973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207978 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2207980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2207986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207990 */   // GIR_Coverage, 47575,
     /* 2207990 */   GIR_EraseRootFromParent_Done,
     /* 2207991 */ // Label 29056: @2207991
     /* 2207991 */ GIM_Reject,
     /* 2207992 */ // Label 29036: @2207992
     /* 2207992 */ GIM_Try, /*On fail goto*//*Label 29057*/ GIMT_Encode4(2208046), // Rule ID 47528 //
     /* 2207997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2208003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208011 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208011 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208014 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208018 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208033 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208045 */   // GIR_Coverage, 47528,
     /* 2208045 */   GIR_EraseRootFromParent_Done,
     /* 2208046 */ // Label 29057: @2208046
     /* 2208046 */ GIM_Try, /*On fail goto*//*Label 29058*/ GIMT_Encode4(2208100), // Rule ID 47529 //
     /* 2208051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2208057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208065 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208087 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208099 */   // GIR_Coverage, 47529,
     /* 2208099 */   GIR_EraseRootFromParent_Done,
     /* 2208100 */ // Label 29058: @2208100
     /* 2208100 */ GIM_Try, /*On fail goto*//*Label 29059*/ GIMT_Encode4(2208154), // Rule ID 47594 //
     /* 2208105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208119 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208141 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208152 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208153 */   // GIR_Coverage, 47594,
     /* 2208153 */   GIR_EraseRootFromParent_Done,
     /* 2208154 */ // Label 29059: @2208154
     /* 2208154 */ GIM_Try, /*On fail goto*//*Label 29060*/ GIMT_Encode4(2208208), // Rule ID 47595 //
     /* 2208159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2208165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208173 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208195 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208207 */   // GIR_Coverage, 47595,
     /* 2208207 */   GIR_EraseRootFromParent_Done,
     /* 2208208 */ // Label 29060: @2208208
     /* 2208208 */ GIM_Try, /*On fail goto*//*Label 29061*/ GIMT_Encode4(2208262), // Rule ID 47628 //
     /* 2208213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208227 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2208244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208249 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208261 */   // GIR_Coverage, 47628,
     /* 2208261 */   GIR_EraseRootFromParent_Done,
     /* 2208262 */ // Label 29061: @2208262
     /* 2208262 */ GIM_Try, /*On fail goto*//*Label 29062*/ GIMT_Encode4(2208316), // Rule ID 47629 //
     /* 2208267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2208273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208281 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2208284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2208298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208303 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208314 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208315 */   // GIR_Coverage, 47629,
     /* 2208315 */   GIR_EraseRootFromParent_Done,
     /* 2208316 */ // Label 29062: @2208316
     /* 2208316 */ GIM_Reject,
     /* 2208317 */ // Label 29037: @2208317
     /* 2208317 */ GIM_Try, /*On fail goto*//*Label 29063*/ GIMT_Encode4(2208420),
     /* 2208322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208333 */   GIM_Try, /*On fail goto*//*Label 29064*/ GIMT_Encode4(2208376), // Rule ID 47488 //
     /* 2208338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208341 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208375 */     // GIR_Coverage, 47488,
     /* 2208375 */     GIR_EraseRootFromParent_Done,
     /* 2208376 */   // Label 29064: @2208376
     /* 2208376 */   GIM_Try, /*On fail goto*//*Label 29065*/ GIMT_Encode4(2208419), // Rule ID 47489 //
     /* 2208381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208384 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2208387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2208401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208418 */     // GIR_Coverage, 47489,
     /* 2208418 */     GIR_EraseRootFromParent_Done,
     /* 2208419 */   // Label 29065: @2208419
     /* 2208419 */   GIM_Reject,
     /* 2208420 */ // Label 29063: @2208420
     /* 2208420 */ GIM_Reject,
     /* 2208421 */ // Label 29038: @2208421
     /* 2208421 */ GIM_Try, /*On fail goto*//*Label 29066*/ GIMT_Encode4(2208475), // Rule ID 47512 //
     /* 2208426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208440 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208462 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208473 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208474 */   // GIR_Coverage, 47512,
     /* 2208474 */   GIR_EraseRootFromParent_Done,
     /* 2208475 */ // Label 29066: @2208475
     /* 2208475 */ GIM_Try, /*On fail goto*//*Label 29067*/ GIMT_Encode4(2208529), // Rule ID 47513 //
     /* 2208480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208494 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208494 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208497 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208501 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2208511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208516 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208528 */   // GIR_Coverage, 47513,
     /* 2208528 */   GIR_EraseRootFromParent_Done,
     /* 2208529 */ // Label 29067: @2208529
     /* 2208529 */ GIM_Try, /*On fail goto*//*Label 29068*/ GIMT_Encode4(2208583), // Rule ID 47578 //
     /* 2208534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208548 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208570 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208582 */   // GIR_Coverage, 47578,
     /* 2208582 */   GIR_EraseRootFromParent_Done,
     /* 2208583 */ // Label 29068: @2208583
     /* 2208583 */ GIM_Try, /*On fail goto*//*Label 29069*/ GIMT_Encode4(2208637), // Rule ID 47579 //
     /* 2208588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208602 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2208619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208624 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208636 */   // GIR_Coverage, 47579,
     /* 2208636 */   GIR_EraseRootFromParent_Done,
     /* 2208637 */ // Label 29069: @2208637
     /* 2208637 */ GIM_Reject,
     /* 2208638 */ // Label 29039: @2208638
     /* 2208638 */ GIM_Try, /*On fail goto*//*Label 29070*/ GIMT_Encode4(2208692), // Rule ID 47532 //
     /* 2208643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208657 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208657 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208660 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208664 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2208674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208679 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208690 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208691 */   // GIR_Coverage, 47532,
     /* 2208691 */   GIR_EraseRootFromParent_Done,
     /* 2208692 */ // Label 29070: @2208692
     /* 2208692 */ GIM_Try, /*On fail goto*//*Label 29071*/ GIMT_Encode4(2208746), // Rule ID 47533 //
     /* 2208697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208711 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208711 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208714 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208718 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2208728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208733 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208744 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208745 */   // GIR_Coverage, 47533,
     /* 2208745 */   GIR_EraseRootFromParent_Done,
     /* 2208746 */ // Label 29071: @2208746
     /* 2208746 */ GIM_Try, /*On fail goto*//*Label 29072*/ GIMT_Encode4(2208800), // Rule ID 47598 //
     /* 2208751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208765 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2208782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208784 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208787 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208798 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208799 */   // GIR_Coverage, 47598,
     /* 2208799 */   GIR_EraseRootFromParent_Done,
     /* 2208800 */ // Label 29072: @2208800
     /* 2208800 */ GIM_Try, /*On fail goto*//*Label 29073*/ GIMT_Encode4(2208854), // Rule ID 47599 //
     /* 2208805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2208811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208819 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2208836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208841 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208852 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208853 */   // GIR_Coverage, 47599,
     /* 2208853 */   GIR_EraseRootFromParent_Done,
     /* 2208854 */ // Label 29073: @2208854
     /* 2208854 */ GIM_Try, /*On fail goto*//*Label 29074*/ GIMT_Encode4(2208908), // Rule ID 47632 //
     /* 2208859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208873 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2208890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208895 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208907 */   // GIR_Coverage, 47632,
     /* 2208907 */   GIR_EraseRootFromParent_Done,
     /* 2208908 */ // Label 29074: @2208908
     /* 2208908 */ GIM_Try, /*On fail goto*//*Label 29075*/ GIMT_Encode4(2208962), // Rule ID 47633 //
     /* 2208913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2208919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208927 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2208944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208949 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2208951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208960 */   GIR_RootConstrainSelectedInstOperands,
     /* 2208961 */   // GIR_Coverage, 47633,
     /* 2208961 */   GIR_EraseRootFromParent_Done,
     /* 2208962 */ // Label 29075: @2208962
     /* 2208962 */ GIM_Reject,
     /* 2208963 */ // Label 29040: @2208963
     /* 2208963 */ GIM_Try, /*On fail goto*//*Label 29076*/ GIMT_Encode4(2209066),
     /* 2208968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208979 */   GIM_Try, /*On fail goto*//*Label 29077*/ GIMT_Encode4(2209022), // Rule ID 47492 //
     /* 2208984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208987 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2208990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2209004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209021 */     // GIR_Coverage, 47492,
     /* 2209021 */     GIR_EraseRootFromParent_Done,
     /* 2209022 */   // Label 29077: @2209022
     /* 2209022 */   GIM_Try, /*On fail goto*//*Label 29078*/ GIMT_Encode4(2209065), // Rule ID 47493 //
     /* 2209027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209030 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2209047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209064 */     // GIR_Coverage, 47493,
     /* 2209064 */     GIR_EraseRootFromParent_Done,
     /* 2209065 */   // Label 29078: @2209065
     /* 2209065 */   GIM_Reject,
     /* 2209066 */ // Label 29076: @2209066
     /* 2209066 */ GIM_Reject,
     /* 2209067 */ // Label 29041: @2209067
     /* 2209067 */ GIM_Try, /*On fail goto*//*Label 29079*/ GIMT_Encode4(2209121), // Rule ID 47516 //
     /* 2209072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209086 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209098 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209108 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209119 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209120 */   // GIR_Coverage, 47516,
     /* 2209120 */   GIR_EraseRootFromParent_Done,
     /* 2209121 */ // Label 29079: @2209121
     /* 2209121 */ GIM_Try, /*On fail goto*//*Label 29080*/ GIMT_Encode4(2209175), // Rule ID 47517 //
     /* 2209126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209140 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209140 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209143 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209147 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209162 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209174 */   // GIR_Coverage, 47517,
     /* 2209174 */   GIR_EraseRootFromParent_Done,
     /* 2209175 */ // Label 29080: @2209175
     /* 2209175 */ GIM_Try, /*On fail goto*//*Label 29081*/ GIMT_Encode4(2209229), // Rule ID 47582 //
     /* 2209180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209194 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209216 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209227 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209228 */   // GIR_Coverage, 47582,
     /* 2209228 */   GIR_EraseRootFromParent_Done,
     /* 2209229 */ // Label 29081: @2209229
     /* 2209229 */ GIM_Try, /*On fail goto*//*Label 29082*/ GIMT_Encode4(2209283), // Rule ID 47583 //
     /* 2209234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209248 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2209265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209270 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209282 */   // GIR_Coverage, 47583,
     /* 2209282 */   GIR_EraseRootFromParent_Done,
     /* 2209283 */ // Label 29082: @2209283
     /* 2209283 */ GIM_Reject,
     /* 2209284 */ // Label 29042: @2209284
     /* 2209284 */ GIM_Try, /*On fail goto*//*Label 29083*/ GIMT_Encode4(2209338), // Rule ID 47536 //
     /* 2209289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209303 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209325 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209337 */   // GIR_Coverage, 47536,
     /* 2209337 */   GIR_EraseRootFromParent_Done,
     /* 2209338 */ // Label 29083: @2209338
     /* 2209338 */ GIM_Try, /*On fail goto*//*Label 29084*/ GIMT_Encode4(2209392), // Rule ID 47537 //
     /* 2209343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209357 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209376 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209379 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209391 */   // GIR_Coverage, 47537,
     /* 2209391 */   GIR_EraseRootFromParent_Done,
     /* 2209392 */ // Label 29084: @2209392
     /* 2209392 */ GIM_Try, /*On fail goto*//*Label 29085*/ GIMT_Encode4(2209446), // Rule ID 47602 //
     /* 2209397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209411 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209433 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209445 */   // GIR_Coverage, 47602,
     /* 2209445 */   GIR_EraseRootFromParent_Done,
     /* 2209446 */ // Label 29085: @2209446
     /* 2209446 */ GIM_Try, /*On fail goto*//*Label 29086*/ GIMT_Encode4(2209500), // Rule ID 47603 //
     /* 2209451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209465 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209487 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209498 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209499 */   // GIR_Coverage, 47603,
     /* 2209499 */   GIR_EraseRootFromParent_Done,
     /* 2209500 */ // Label 29086: @2209500
     /* 2209500 */ GIM_Try, /*On fail goto*//*Label 29087*/ GIMT_Encode4(2209554), // Rule ID 47636 //
     /* 2209505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209519 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2209536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209541 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209553 */   // GIR_Coverage, 47636,
     /* 2209553 */   GIR_EraseRootFromParent_Done,
     /* 2209554 */ // Label 29087: @2209554
     /* 2209554 */ GIM_Try, /*On fail goto*//*Label 29088*/ GIMT_Encode4(2209608), // Rule ID 47637 //
     /* 2209559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209573 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2209590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209595 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209607 */   // GIR_Coverage, 47637,
     /* 2209607 */   GIR_EraseRootFromParent_Done,
     /* 2209608 */ // Label 29088: @2209608
     /* 2209608 */ GIM_Reject,
     /* 2209609 */ // Label 29043: @2209609
     /* 2209609 */ GIM_Try, /*On fail goto*//*Label 29089*/ GIMT_Encode4(2209712),
     /* 2209614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2209617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209625 */   GIM_Try, /*On fail goto*//*Label 29090*/ GIMT_Encode4(2209668), // Rule ID 47496 //
     /* 2209630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209633 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2209636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209667 */     // GIR_Coverage, 47496,
     /* 2209667 */     GIR_EraseRootFromParent_Done,
     /* 2209668 */   // Label 29090: @2209668
     /* 2209668 */   GIM_Try, /*On fail goto*//*Label 29091*/ GIMT_Encode4(2209711), // Rule ID 47497 //
     /* 2209673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209676 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2209679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2209693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209710 */     // GIR_Coverage, 47497,
     /* 2209710 */     GIR_EraseRootFromParent_Done,
     /* 2209711 */   // Label 29091: @2209711
     /* 2209711 */   GIM_Reject,
     /* 2209712 */ // Label 29089: @2209712
     /* 2209712 */ GIM_Reject,
     /* 2209713 */ // Label 29044: @2209713
     /* 2209713 */ GIM_Try, /*On fail goto*//*Label 29092*/ GIMT_Encode4(2209767), // Rule ID 47520 //
     /* 2209718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2209724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209732 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2209735 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209739 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209751 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209754 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209765 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209766 */   // GIR_Coverage, 47520,
     /* 2209766 */   GIR_EraseRootFromParent_Done,
     /* 2209767 */ // Label 29092: @2209767
     /* 2209767 */ GIM_Try, /*On fail goto*//*Label 29093*/ GIMT_Encode4(2209821), // Rule ID 47521 //
     /* 2209772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2209778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209786 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209786 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2209789 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209793 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2209803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209805 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209808 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209820 */   // GIR_Coverage, 47521,
     /* 2209820 */   GIR_EraseRootFromParent_Done,
     /* 2209821 */ // Label 29093: @2209821
     /* 2209821 */ GIM_Try, /*On fail goto*//*Label 29094*/ GIMT_Encode4(2209875), // Rule ID 47586 //
     /* 2209826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2209832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209840 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2209843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209859 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209862 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209873 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209874 */   // GIR_Coverage, 47586,
     /* 2209874 */   GIR_EraseRootFromParent_Done,
     /* 2209875 */ // Label 29094: @2209875
     /* 2209875 */ GIM_Try, /*On fail goto*//*Label 29095*/ GIMT_Encode4(2209929), // Rule ID 47587 //
     /* 2209880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2209886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209894 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2209897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2209911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209916 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209927 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209928 */   // GIR_Coverage, 47587,
     /* 2209928 */   GIR_EraseRootFromParent_Done,
     /* 2209929 */ // Label 29095: @2209929
     /* 2209929 */ GIM_Reject,
     /* 2209930 */ // Label 29045: @2209930
     /* 2209930 */ GIM_Try, /*On fail goto*//*Label 29096*/ GIMT_Encode4(2209984), // Rule ID 47540 //
     /* 2209935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2209941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209949 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209949 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2209952 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209956 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2209966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209971 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2209973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2209979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2209983 */   // GIR_Coverage, 47540,
     /* 2209983 */   GIR_EraseRootFromParent_Done,
     /* 2209984 */ // Label 29096: @2209984
     /* 2209984 */ GIM_Try, /*On fail goto*//*Label 29097*/ GIMT_Encode4(2210038), // Rule ID 47541 //
     /* 2209989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2209995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2209999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210003 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210022 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210025 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210036 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210037 */   // GIR_Coverage, 47541,
     /* 2210037 */   GIR_EraseRootFromParent_Done,
     /* 2210038 */ // Label 29097: @2210038
     /* 2210038 */ GIM_Try, /*On fail goto*//*Label 29098*/ GIMT_Encode4(2210092), // Rule ID 47606 //
     /* 2210043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210057 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210079 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210091 */   // GIR_Coverage, 47606,
     /* 2210091 */   GIR_EraseRootFromParent_Done,
     /* 2210092 */ // Label 29098: @2210092
     /* 2210092 */ GIM_Try, /*On fail goto*//*Label 29099*/ GIMT_Encode4(2210146), // Rule ID 47607 //
     /* 2210097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210111 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210145 */   // GIR_Coverage, 47607,
     /* 2210145 */   GIR_EraseRootFromParent_Done,
     /* 2210146 */ // Label 29099: @2210146
     /* 2210146 */ GIM_Try, /*On fail goto*//*Label 29100*/ GIMT_Encode4(2210200), // Rule ID 47640 //
     /* 2210151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2210154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210165 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2210182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210187 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210199 */   // GIR_Coverage, 47640,
     /* 2210199 */   GIR_EraseRootFromParent_Done,
     /* 2210200 */ // Label 29100: @2210200
     /* 2210200 */ GIM_Try, /*On fail goto*//*Label 29101*/ GIMT_Encode4(2210254), // Rule ID 47641 //
     /* 2210205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2210208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210219 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2210222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2210236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210241 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210253 */   // GIR_Coverage, 47641,
     /* 2210253 */   GIR_EraseRootFromParent_Done,
     /* 2210254 */ // Label 29101: @2210254
     /* 2210254 */ GIM_Reject,
     /* 2210255 */ // Label 29046: @2210255
     /* 2210255 */ GIM_Try, /*On fail goto*//*Label 29102*/ GIMT_Encode4(2210358),
     /* 2210260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210271 */   GIM_Try, /*On fail goto*//*Label 29103*/ GIMT_Encode4(2210314), // Rule ID 47500 //
     /* 2210276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210279 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2210282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210313 */     // GIR_Coverage, 47500,
     /* 2210313 */     GIR_EraseRootFromParent_Done,
     /* 2210314 */   // Label 29103: @2210314
     /* 2210314 */   GIM_Try, /*On fail goto*//*Label 29104*/ GIMT_Encode4(2210357), // Rule ID 47501 //
     /* 2210319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210322 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2210325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2210339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210356 */     // GIR_Coverage, 47501,
     /* 2210356 */     GIR_EraseRootFromParent_Done,
     /* 2210357 */   // Label 29104: @2210357
     /* 2210357 */   GIM_Reject,
     /* 2210358 */ // Label 29102: @2210358
     /* 2210358 */ GIM_Reject,
     /* 2210359 */ // Label 29047: @2210359
     /* 2210359 */ GIM_Try, /*On fail goto*//*Label 29105*/ GIMT_Encode4(2210413), // Rule ID 47524 //
     /* 2210364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2210370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210378 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210400 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210412 */   // GIR_Coverage, 47524,
     /* 2210412 */   GIR_EraseRootFromParent_Done,
     /* 2210413 */ // Label 29105: @2210413
     /* 2210413 */ GIM_Try, /*On fail goto*//*Label 29106*/ GIMT_Encode4(2210467), // Rule ID 47525 //
     /* 2210418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2210424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210432 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210454 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210466 */   // GIR_Coverage, 47525,
     /* 2210466 */   GIR_EraseRootFromParent_Done,
     /* 2210467 */ // Label 29106: @2210467
     /* 2210467 */ GIM_Try, /*On fail goto*//*Label 29107*/ GIMT_Encode4(2210521), // Rule ID 47590 //
     /* 2210472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210486 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210508 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210520 */   // GIR_Coverage, 47590,
     /* 2210520 */   GIR_EraseRootFromParent_Done,
     /* 2210521 */ // Label 29107: @2210521
     /* 2210521 */ GIM_Try, /*On fail goto*//*Label 29108*/ GIMT_Encode4(2210575), // Rule ID 47591 //
     /* 2210526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2210532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210540 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2210543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2210557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210562 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2210574 */   // GIR_Coverage, 47591,
     /* 2210574 */   GIR_EraseRootFromParent_Done,
     /* 2210575 */ // Label 29108: @2210575
     /* 2210575 */ GIM_Reject,
     /* 2210576 */ // Label 29048: @2210576
     /* 2210576 */ GIM_Try, /*On fail goto*//*Label 29109*/ GIMT_Encode4(2210679),
     /* 2210581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2210584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2210588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210592 */   GIM_Try, /*On fail goto*//*Label 29110*/ GIMT_Encode4(2210635), // Rule ID 47504 //
     /* 2210597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210600 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2210603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210634 */     // GIR_Coverage, 47504,
     /* 2210634 */     GIR_EraseRootFromParent_Done,
     /* 2210635 */   // Label 29110: @2210635
     /* 2210635 */   GIM_Try, /*On fail goto*//*Label 29111*/ GIMT_Encode4(2210678), // Rule ID 47505 //
     /* 2210640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210643 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2210646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2210660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2210667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210677 */     // GIR_Coverage, 47505,
     /* 2210677 */     GIR_EraseRootFromParent_Done,
     /* 2210678 */   // Label 29111: @2210678
     /* 2210678 */   GIM_Reject,
     /* 2210679 */ // Label 29109: @2210679
     /* 2210679 */ GIM_Reject,
     /* 2210680 */ // Label 29049: @2210680
     /* 2210680 */ GIM_Reject,
     /* 2210681 */ // Label 40: @2210681
     /* 2210681 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29129*/ GIMT_Encode4(2214155),
     /* 2210692 */ /*GILLT_s32*//*Label 29112*/ GIMT_Encode4(2210808),
     /* 2210696 */ /*GILLT_s64*//*Label 29113*/ GIMT_Encode4(2210982), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210708 */ /*GILLT_nxv1s16*//*Label 29114*/ GIMT_Encode4(2211146),
     /* 2210712 */ /*GILLT_nxv1s32*//*Label 29115*/ GIMT_Encode4(2211250),
     /* 2210716 */ /*GILLT_nxv1s64*//*Label 29116*/ GIMT_Encode4(2211467), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210728 */ /*GILLT_nxv2s16*//*Label 29117*/ GIMT_Encode4(2211792),
     /* 2210732 */ /*GILLT_nxv2s32*//*Label 29118*/ GIMT_Encode4(2211896),
     /* 2210736 */ /*GILLT_nxv2s64*//*Label 29119*/ GIMT_Encode4(2212113), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210748 */ /*GILLT_nxv4s16*//*Label 29120*/ GIMT_Encode4(2212438),
     /* 2210752 */ /*GILLT_nxv4s32*//*Label 29121*/ GIMT_Encode4(2212542),
     /* 2210756 */ /*GILLT_nxv4s64*//*Label 29122*/ GIMT_Encode4(2212759), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210768 */ /*GILLT_nxv8s16*//*Label 29123*/ GIMT_Encode4(2213084),
     /* 2210772 */ /*GILLT_nxv8s32*//*Label 29124*/ GIMT_Encode4(2213188),
     /* 2210776 */ /*GILLT_nxv8s64*//*Label 29125*/ GIMT_Encode4(2213405), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210788 */ /*GILLT_nxv16s16*//*Label 29126*/ GIMT_Encode4(2213730),
     /* 2210792 */ /*GILLT_nxv16s32*//*Label 29127*/ GIMT_Encode4(2213834), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2210804 */ /*GILLT_nxv32s16*//*Label 29128*/ GIMT_Encode4(2214051),
     /* 2210808 */ // Label 29112: @2210808
     /* 2210808 */ GIM_Try, /*On fail goto*//*Label 29130*/ GIMT_Encode4(2210981),
     /* 2210813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2210816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210824 */   GIM_Try, /*On fail goto*//*Label 29131*/ GIMT_Encode4(2210866), // Rule ID 65387 //
     /* 2210829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode1),
     /* 2210832 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2210832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2210835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2210839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210844 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2210848 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2210851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2210856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2210864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210865 */     // GIR_Coverage, 65387,
     /* 2210865 */     GIR_EraseRootFromParent_Done,
     /* 2210866 */   // Label 29131: @2210866
     /* 2210866 */   GIM_Try, /*On fail goto*//*Label 29132*/ GIMT_Encode4(2210908), // Rule ID 65389 //
     /* 2210871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2210874 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2210874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2210877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2210881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2210890 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2210893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2210898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2210906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210907 */     // GIR_Coverage, 65389,
     /* 2210907 */     GIR_EraseRootFromParent_Done,
     /* 2210908 */   // Label 29132: @2210908
     /* 2210908 */   GIM_Try, /*On fail goto*//*Label 29133*/ GIMT_Encode4(2210950), // Rule ID 65390 //
     /* 2210913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode1),
     /* 2210916 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2210916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2210919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2210923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2210932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2210935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2210940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2210948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210949 */     // GIR_Coverage, 65390,
     /* 2210949 */     GIR_EraseRootFromParent_Done,
     /* 2210950 */   // Label 29133: @2210950
     /* 2210950 */   GIM_Try, /*On fail goto*//*Label 29134*/ GIMT_Encode4(2210965), // Rule ID 65392 //
     /* 2210955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2210958 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2210958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2210963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210964 */     // GIR_Coverage, 65392,
     /* 2210964 */     GIR_Done,
     /* 2210965 */   // Label 29134: @2210965
     /* 2210965 */   GIM_Try, /*On fail goto*//*Label 29135*/ GIMT_Encode4(2210980), // Rule ID 65393 //
     /* 2210970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2210973 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2210973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2210978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210979 */     // GIR_Coverage, 65393,
     /* 2210979 */     GIR_Done,
     /* 2210980 */   // Label 29135: @2210980
     /* 2210980 */   GIM_Reject,
     /* 2210981 */ // Label 29130: @2210981
     /* 2210981 */ GIM_Reject,
     /* 2210982 */ // Label 29113: @2210982
     /* 2210982 */ GIM_Try, /*On fail goto*//*Label 29136*/ GIMT_Encode4(2211013), // Rule ID 65377 //
     /* 2210987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2210990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2210993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2210997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211001 */   // (sext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i32] }:$src, 0:{ *:[i64] })
     /* 2211001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2211004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211006 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2211008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2211011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211012 */   // GIR_Coverage, 65377,
     /* 2211012 */   GIR_EraseRootFromParent_Done,
     /* 2211013 */ // Label 29136: @2211013
     /* 2211013 */ GIM_Try, /*On fail goto*//*Label 29137*/ GIMT_Encode4(2211066), // Rule ID 65386 //
     /* 2211018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode0),
     /* 2211021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211032 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2211032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211044 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211048 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2211051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2211064 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211065 */   // GIR_Coverage, 65386,
     /* 2211065 */   GIR_EraseRootFromParent_Done,
     /* 2211066 */ // Label 29137: @2211066
     /* 2211066 */ GIM_Try, /*On fail goto*//*Label 29138*/ GIMT_Encode4(2211119), // Rule ID 65388 //
     /* 2211071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2211074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211085 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2211085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2211088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2211092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2211101 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2211104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2211109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2211117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211118 */   // GIR_Coverage, 65388,
     /* 2211118 */   GIR_EraseRootFromParent_Done,
     /* 2211119 */ // Label 29138: @2211119
     /* 2211119 */ GIM_Try, /*On fail goto*//*Label 29139*/ GIMT_Encode4(2211145), // Rule ID 65394 //
     /* 2211124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2211127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2211130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2211138 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2211138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2211143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211144 */   // GIR_Coverage, 65394,
     /* 2211144 */   GIR_Done,
     /* 2211145 */ // Label 29139: @2211145
     /* 2211145 */ GIM_Reject,
     /* 2211146 */ // Label 29114: @2211146
     /* 2211146 */ GIM_Try, /*On fail goto*//*Label 29140*/ GIMT_Encode4(2211249),
     /* 2211151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211162 */   GIM_Try, /*On fail goto*//*Label 29141*/ GIMT_Encode4(2211205), // Rule ID 47542 //
     /* 2211167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211170 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2211187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211204 */     // GIR_Coverage, 47542,
     /* 2211204 */     GIR_EraseRootFromParent_Done,
     /* 2211205 */   // Label 29141: @2211205
     /* 2211205 */   GIM_Try, /*On fail goto*//*Label 29142*/ GIMT_Encode4(2211248), // Rule ID 47543 //
     /* 2211210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211213 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2211216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2211230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211247 */     // GIR_Coverage, 47543,
     /* 2211247 */     GIR_EraseRootFromParent_Done,
     /* 2211248 */   // Label 29142: @2211248
     /* 2211248 */   GIM_Reject,
     /* 2211249 */ // Label 29140: @2211249
     /* 2211249 */ GIM_Reject,
     /* 2211250 */ // Label 29115: @2211250
     /* 2211250 */ GIM_Try, /*On fail goto*//*Label 29143*/ GIMT_Encode4(2211304), // Rule ID 47554 //
     /* 2211255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211269 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211291 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211303 */   // GIR_Coverage, 47554,
     /* 2211303 */   GIR_EraseRootFromParent_Done,
     /* 2211304 */ // Label 29143: @2211304
     /* 2211304 */ GIM_Try, /*On fail goto*//*Label 29144*/ GIMT_Encode4(2211358), // Rule ID 47555 //
     /* 2211309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211323 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211323 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211326 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211330 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211345 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211357 */   // GIR_Coverage, 47555,
     /* 2211357 */   GIR_EraseRootFromParent_Done,
     /* 2211358 */ // Label 29144: @2211358
     /* 2211358 */ GIM_Try, /*On fail goto*//*Label 29145*/ GIMT_Encode4(2211412), // Rule ID 47608 //
     /* 2211363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211377 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211377 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211380 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211384 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2211394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211399 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211410 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211411 */   // GIR_Coverage, 47608,
     /* 2211411 */   GIR_EraseRootFromParent_Done,
     /* 2211412 */ // Label 29145: @2211412
     /* 2211412 */ GIM_Try, /*On fail goto*//*Label 29146*/ GIMT_Encode4(2211466), // Rule ID 47609 //
     /* 2211417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211431 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211431 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2211434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211438 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2211448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211453 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211464 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211465 */   // GIR_Coverage, 47609,
     /* 2211465 */   GIR_EraseRootFromParent_Done,
     /* 2211466 */ // Label 29146: @2211466
     /* 2211466 */ GIM_Reject,
     /* 2211467 */ // Label 29116: @2211467
     /* 2211467 */ GIM_Try, /*On fail goto*//*Label 29147*/ GIMT_Encode4(2211521), // Rule ID 47564 //
     /* 2211472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211486 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211508 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211520 */   // GIR_Coverage, 47564,
     /* 2211520 */   GIR_EraseRootFromParent_Done,
     /* 2211521 */ // Label 29147: @2211521
     /* 2211521 */ GIM_Try, /*On fail goto*//*Label 29148*/ GIMT_Encode4(2211575), // Rule ID 47565 //
     /* 2211526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2211532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211540 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211559 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211562 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211574 */   // GIR_Coverage, 47565,
     /* 2211574 */   GIR_EraseRootFromParent_Done,
     /* 2211575 */ // Label 29148: @2211575
     /* 2211575 */ GIM_Try, /*On fail goto*//*Label 29149*/ GIMT_Encode4(2211629), // Rule ID 47618 //
     /* 2211580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211594 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2211611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211616 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211627 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211628 */   // GIR_Coverage, 47618,
     /* 2211628 */   GIR_EraseRootFromParent_Done,
     /* 2211629 */ // Label 29149: @2211629
     /* 2211629 */ GIM_Try, /*On fail goto*//*Label 29150*/ GIMT_Encode4(2211683), // Rule ID 47619 //
     /* 2211634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2211640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211648 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2211665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211670 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211681 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211682 */   // GIR_Coverage, 47619,
     /* 2211682 */   GIR_EraseRootFromParent_Done,
     /* 2211683 */ // Label 29150: @2211683
     /* 2211683 */ GIM_Try, /*On fail goto*//*Label 29151*/ GIMT_Encode4(2211737), // Rule ID 47642 //
     /* 2211688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211702 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2211719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211724 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211736 */   // GIR_Coverage, 47642,
     /* 2211736 */   GIR_EraseRootFromParent_Done,
     /* 2211737 */ // Label 29151: @2211737
     /* 2211737 */ GIM_Try, /*On fail goto*//*Label 29152*/ GIMT_Encode4(2211791), // Rule ID 47643 //
     /* 2211742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2211748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211756 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2211759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2211773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211775 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211778 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211790 */   // GIR_Coverage, 47643,
     /* 2211790 */   GIR_EraseRootFromParent_Done,
     /* 2211791 */ // Label 29152: @2211791
     /* 2211791 */ GIM_Reject,
     /* 2211792 */ // Label 29117: @2211792
     /* 2211792 */ GIM_Try, /*On fail goto*//*Label 29153*/ GIMT_Encode4(2211895),
     /* 2211797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2211800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211808 */   GIM_Try, /*On fail goto*//*Label 29154*/ GIMT_Encode4(2211851), // Rule ID 47544 //
     /* 2211813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211816 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211850 */     // GIR_Coverage, 47544,
     /* 2211850 */     GIR_EraseRootFromParent_Done,
     /* 2211851 */   // Label 29154: @2211851
     /* 2211851 */   GIM_Try, /*On fail goto*//*Label 29155*/ GIMT_Encode4(2211894), // Rule ID 47545 //
     /* 2211856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211859 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2211862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2211876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211893 */     // GIR_Coverage, 47545,
     /* 2211893 */     GIR_EraseRootFromParent_Done,
     /* 2211894 */   // Label 29155: @2211894
     /* 2211894 */   GIM_Reject,
     /* 2211895 */ // Label 29153: @2211895
     /* 2211895 */ GIM_Reject,
     /* 2211896 */ // Label 29118: @2211896
     /* 2211896 */ GIM_Try, /*On fail goto*//*Label 29156*/ GIMT_Encode4(2211950), // Rule ID 47556 //
     /* 2211901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2211907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211915 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211915 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2211918 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211922 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211937 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211948 */   GIR_RootConstrainSelectedInstOperands,
     /* 2211949 */   // GIR_Coverage, 47556,
     /* 2211949 */   GIR_EraseRootFromParent_Done,
     /* 2211950 */ // Label 29156: @2211950
     /* 2211950 */ GIM_Try, /*On fail goto*//*Label 29157*/ GIMT_Encode4(2212004), // Rule ID 47557 //
     /* 2211955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2211961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2211969 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211969 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2211972 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211976 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2211986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211991 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2211993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212002 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212003 */   // GIR_Coverage, 47557,
     /* 2212003 */   GIR_EraseRootFromParent_Done,
     /* 2212004 */ // Label 29157: @2212004
     /* 2212004 */ GIM_Try, /*On fail goto*//*Label 29158*/ GIMT_Encode4(2212058), // Rule ID 47610 //
     /* 2212009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212023 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212042 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212045 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212056 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212057 */   // GIR_Coverage, 47610,
     /* 2212057 */   GIR_EraseRootFromParent_Done,
     /* 2212058 */ // Label 29158: @2212058
     /* 2212058 */ GIM_Try, /*On fail goto*//*Label 29159*/ GIMT_Encode4(2212112), // Rule ID 47611 //
     /* 2212063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212077 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2212080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212089 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2212094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212099 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212111 */   // GIR_Coverage, 47611,
     /* 2212111 */   GIR_EraseRootFromParent_Done,
     /* 2212112 */ // Label 29159: @2212112
     /* 2212112 */ GIM_Reject,
     /* 2212113 */ // Label 29119: @2212113
     /* 2212113 */ GIM_Try, /*On fail goto*//*Label 29160*/ GIMT_Encode4(2212167), // Rule ID 47566 //
     /* 2212118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212132 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212154 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212166 */   // GIR_Coverage, 47566,
     /* 2212166 */   GIR_EraseRootFromParent_Done,
     /* 2212167 */ // Label 29160: @2212167
     /* 2212167 */ GIM_Try, /*On fail goto*//*Label 29161*/ GIMT_Encode4(2212221), // Rule ID 47567 //
     /* 2212172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2212178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212186 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212186 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212189 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212193 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212205 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212208 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212220 */   // GIR_Coverage, 47567,
     /* 2212220 */   GIR_EraseRootFromParent_Done,
     /* 2212221 */ // Label 29161: @2212221
     /* 2212221 */ GIM_Try, /*On fail goto*//*Label 29162*/ GIMT_Encode4(2212275), // Rule ID 47620 //
     /* 2212226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212240 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212240 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212243 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212247 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212259 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212262 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212273 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212274 */   // GIR_Coverage, 47620,
     /* 2212274 */   GIR_EraseRootFromParent_Done,
     /* 2212275 */ // Label 29162: @2212275
     /* 2212275 */ GIM_Try, /*On fail goto*//*Label 29163*/ GIMT_Encode4(2212329), // Rule ID 47621 //
     /* 2212280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2212286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212294 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212316 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212327 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212328 */   // GIR_Coverage, 47621,
     /* 2212328 */   GIR_EraseRootFromParent_Done,
     /* 2212329 */ // Label 29163: @2212329
     /* 2212329 */ GIM_Try, /*On fail goto*//*Label 29164*/ GIMT_Encode4(2212383), // Rule ID 47644 //
     /* 2212334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212348 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2212365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212370 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212382 */   // GIR_Coverage, 47644,
     /* 2212382 */   GIR_EraseRootFromParent_Done,
     /* 2212383 */ // Label 29164: @2212383
     /* 2212383 */ GIM_Try, /*On fail goto*//*Label 29165*/ GIMT_Encode4(2212437), // Rule ID 47645 //
     /* 2212388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2212394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212402 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2212405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2212419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212424 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212436 */   // GIR_Coverage, 47645,
     /* 2212436 */   GIR_EraseRootFromParent_Done,
     /* 2212437 */ // Label 29165: @2212437
     /* 2212437 */ GIM_Reject,
     /* 2212438 */ // Label 29120: @2212438
     /* 2212438 */ GIM_Try, /*On fail goto*//*Label 29166*/ GIMT_Encode4(2212541),
     /* 2212443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212454 */   GIM_Try, /*On fail goto*//*Label 29167*/ GIMT_Encode4(2212497), // Rule ID 47546 //
     /* 2212459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212462 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212496 */     // GIR_Coverage, 47546,
     /* 2212496 */     GIR_EraseRootFromParent_Done,
     /* 2212497 */   // Label 29167: @2212497
     /* 2212497 */   GIM_Try, /*On fail goto*//*Label 29168*/ GIMT_Encode4(2212540), // Rule ID 47547 //
     /* 2212502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212505 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2212508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2212522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212539 */     // GIR_Coverage, 47547,
     /* 2212539 */     GIR_EraseRootFromParent_Done,
     /* 2212540 */   // Label 29168: @2212540
     /* 2212540 */   GIM_Reject,
     /* 2212541 */ // Label 29166: @2212541
     /* 2212541 */ GIM_Reject,
     /* 2212542 */ // Label 29121: @2212542
     /* 2212542 */ GIM_Try, /*On fail goto*//*Label 29169*/ GIMT_Encode4(2212596), // Rule ID 47558 //
     /* 2212547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212561 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212583 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212594 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212595 */   // GIR_Coverage, 47558,
     /* 2212595 */   GIR_EraseRootFromParent_Done,
     /* 2212596 */ // Label 29169: @2212596
     /* 2212596 */ GIM_Try, /*On fail goto*//*Label 29170*/ GIMT_Encode4(2212650), // Rule ID 47559 //
     /* 2212601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212615 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2212632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212637 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212649 */   // GIR_Coverage, 47559,
     /* 2212649 */   GIR_EraseRootFromParent_Done,
     /* 2212650 */ // Label 29170: @2212650
     /* 2212650 */ GIM_Try, /*On fail goto*//*Label 29171*/ GIMT_Encode4(2212704), // Rule ID 47612 //
     /* 2212655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212669 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212703 */   // GIR_Coverage, 47612,
     /* 2212703 */   GIR_EraseRootFromParent_Done,
     /* 2212704 */ // Label 29171: @2212704
     /* 2212704 */ GIM_Try, /*On fail goto*//*Label 29172*/ GIMT_Encode4(2212758), // Rule ID 47613 //
     /* 2212709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212723 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2212726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2212740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212745 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212757 */   // GIR_Coverage, 47613,
     /* 2212757 */   GIR_EraseRootFromParent_Done,
     /* 2212758 */ // Label 29172: @2212758
     /* 2212758 */ GIM_Reject,
     /* 2212759 */ // Label 29122: @2212759
     /* 2212759 */ GIM_Try, /*On fail goto*//*Label 29173*/ GIMT_Encode4(2212813), // Rule ID 47568 //
     /* 2212764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2212770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212778 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212778 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2212781 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212785 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2212795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212800 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212812 */   // GIR_Coverage, 47568,
     /* 2212812 */   GIR_EraseRootFromParent_Done,
     /* 2212813 */ // Label 29173: @2212813
     /* 2212813 */ GIM_Try, /*On fail goto*//*Label 29174*/ GIMT_Encode4(2212867), // Rule ID 47569 //
     /* 2212818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2212824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212832 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2212835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2212849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212854 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212865 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212866 */   // GIR_Coverage, 47569,
     /* 2212866 */   GIR_EraseRootFromParent_Done,
     /* 2212867 */ // Label 29174: @2212867
     /* 2212867 */ GIM_Try, /*On fail goto*//*Label 29175*/ GIMT_Encode4(2212921), // Rule ID 47622 //
     /* 2212872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212886 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2212889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2212903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212908 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212919 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212920 */   // GIR_Coverage, 47622,
     /* 2212920 */   GIR_EraseRootFromParent_Done,
     /* 2212921 */ // Label 29175: @2212921
     /* 2212921 */ GIM_Try, /*On fail goto*//*Label 29176*/ GIMT_Encode4(2212975), // Rule ID 47623 //
     /* 2212926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2212929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2212932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212940 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2212943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2212957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212962 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2212964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2212970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212973 */   GIR_RootConstrainSelectedInstOperands,
     /* 2212974 */   // GIR_Coverage, 47623,
     /* 2212974 */   GIR_EraseRootFromParent_Done,
     /* 2212975 */ // Label 29176: @2212975
     /* 2212975 */ GIM_Try, /*On fail goto*//*Label 29177*/ GIMT_Encode4(2213029), // Rule ID 47646 //
     /* 2212980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2212983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2212986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2212994 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2212997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2213011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213013 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213016 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213028 */   // GIR_Coverage, 47646,
     /* 2213028 */   GIR_EraseRootFromParent_Done,
     /* 2213029 */ // Label 29177: @2213029
     /* 2213029 */ GIM_Try, /*On fail goto*//*Label 29178*/ GIMT_Encode4(2213083), // Rule ID 47647 //
     /* 2213034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2213040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213048 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2213051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2213065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213070 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213081 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213082 */   // GIR_Coverage, 47647,
     /* 2213082 */   GIR_EraseRootFromParent_Done,
     /* 2213083 */ // Label 29178: @2213083
     /* 2213083 */ GIM_Reject,
     /* 2213084 */ // Label 29123: @2213084
     /* 2213084 */ GIM_Try, /*On fail goto*//*Label 29179*/ GIMT_Encode4(2213187),
     /* 2213089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213100 */   GIM_Try, /*On fail goto*//*Label 29180*/ GIMT_Encode4(2213143), // Rule ID 47548 //
     /* 2213105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213108 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213142 */     // GIR_Coverage, 47548,
     /* 2213142 */     GIR_EraseRootFromParent_Done,
     /* 2213143 */   // Label 29180: @2213143
     /* 2213143 */   GIM_Try, /*On fail goto*//*Label 29181*/ GIMT_Encode4(2213186), // Rule ID 47549 //
     /* 2213148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213151 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2213154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2213168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213185 */     // GIR_Coverage, 47549,
     /* 2213185 */     GIR_EraseRootFromParent_Done,
     /* 2213186 */   // Label 29181: @2213186
     /* 2213186 */   GIM_Reject,
     /* 2213187 */ // Label 29179: @2213187
     /* 2213187 */ GIM_Reject,
     /* 2213188 */ // Label 29124: @2213188
     /* 2213188 */ GIM_Try, /*On fail goto*//*Label 29182*/ GIMT_Encode4(2213242), // Rule ID 47560 //
     /* 2213193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213207 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213229 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213240 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213241 */   // GIR_Coverage, 47560,
     /* 2213241 */   GIR_EraseRootFromParent_Done,
     /* 2213242 */ // Label 29182: @2213242
     /* 2213242 */ GIM_Try, /*On fail goto*//*Label 29183*/ GIMT_Encode4(2213296), // Rule ID 47561 //
     /* 2213247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213261 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213283 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213294 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213295 */   // GIR_Coverage, 47561,
     /* 2213295 */   GIR_EraseRootFromParent_Done,
     /* 2213296 */ // Label 29183: @2213296
     /* 2213296 */ GIM_Try, /*On fail goto*//*Label 29184*/ GIMT_Encode4(2213350), // Rule ID 47614 //
     /* 2213301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213315 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213337 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213349 */   // GIR_Coverage, 47614,
     /* 2213349 */   GIR_EraseRootFromParent_Done,
     /* 2213350 */ // Label 29184: @2213350
     /* 2213350 */ GIM_Try, /*On fail goto*//*Label 29185*/ GIMT_Encode4(2213404), // Rule ID 47615 //
     /* 2213355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213369 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2213372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2213386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213391 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213402 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213403 */   // GIR_Coverage, 47615,
     /* 2213403 */   GIR_EraseRootFromParent_Done,
     /* 2213404 */ // Label 29185: @2213404
     /* 2213404 */ GIM_Reject,
     /* 2213405 */ // Label 29125: @2213405
     /* 2213405 */ GIM_Try, /*On fail goto*//*Label 29186*/ GIMT_Encode4(2213459), // Rule ID 47570 //
     /* 2213410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213424 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213446 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213457 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213458 */   // GIR_Coverage, 47570,
     /* 2213458 */   GIR_EraseRootFromParent_Done,
     /* 2213459 */ // Label 29186: @2213459
     /* 2213459 */ GIM_Try, /*On fail goto*//*Label 29187*/ GIMT_Encode4(2213513), // Rule ID 47571 //
     /* 2213464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2213470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213478 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213500 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213512 */   // GIR_Coverage, 47571,
     /* 2213512 */   GIR_EraseRootFromParent_Done,
     /* 2213513 */ // Label 29187: @2213513
     /* 2213513 */ GIM_Try, /*On fail goto*//*Label 29188*/ GIMT_Encode4(2213567), // Rule ID 47624 //
     /* 2213518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213532 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2213549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213554 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213566 */   // GIR_Coverage, 47624,
     /* 2213566 */   GIR_EraseRootFromParent_Done,
     /* 2213567 */ // Label 29188: @2213567
     /* 2213567 */ GIM_Try, /*On fail goto*//*Label 29189*/ GIMT_Encode4(2213621), // Rule ID 47625 //
     /* 2213572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2213578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213586 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213586 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213593 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2213603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213608 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213620 */   // GIR_Coverage, 47625,
     /* 2213620 */   GIR_EraseRootFromParent_Done,
     /* 2213621 */ // Label 29189: @2213621
     /* 2213621 */ GIM_Try, /*On fail goto*//*Label 29190*/ GIMT_Encode4(2213675), // Rule ID 47648 //
     /* 2213626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2213629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213640 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2213657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213659 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213662 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213673 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213674 */   // GIR_Coverage, 47648,
     /* 2213674 */   GIR_EraseRootFromParent_Done,
     /* 2213675 */ // Label 29190: @2213675
     /* 2213675 */ GIM_Try, /*On fail goto*//*Label 29191*/ GIMT_Encode4(2213729), // Rule ID 47649 //
     /* 2213680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2213683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2213686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2213694 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2213697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2213711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213713 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213716 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2213724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213728 */   // GIR_Coverage, 47649,
     /* 2213728 */   GIR_EraseRootFromParent_Done,
     /* 2213729 */ // Label 29191: @2213729
     /* 2213729 */ GIM_Reject,
     /* 2213730 */ // Label 29126: @2213730
     /* 2213730 */ GIM_Try, /*On fail goto*//*Label 29192*/ GIMT_Encode4(2213833),
     /* 2213735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2213738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213746 */   GIM_Try, /*On fail goto*//*Label 29193*/ GIMT_Encode4(2213789), // Rule ID 47550 //
     /* 2213751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213754 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2213757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213788 */     // GIR_Coverage, 47550,
     /* 2213788 */     GIR_EraseRootFromParent_Done,
     /* 2213789 */   // Label 29193: @2213789
     /* 2213789 */   GIM_Try, /*On fail goto*//*Label 29194*/ GIMT_Encode4(2213832), // Rule ID 47551 //
     /* 2213794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213797 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2213800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2213814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213831 */     // GIR_Coverage, 47551,
     /* 2213831 */     GIR_EraseRootFromParent_Done,
     /* 2213832 */   // Label 29194: @2213832
     /* 2213832 */   GIM_Reject,
     /* 2213833 */ // Label 29192: @2213833
     /* 2213833 */ GIM_Reject,
     /* 2213834 */ // Label 29127: @2213834
     /* 2213834 */ GIM_Try, /*On fail goto*//*Label 29195*/ GIMT_Encode4(2213888), // Rule ID 47562 //
     /* 2213839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2213845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213853 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2213856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213887 */   // GIR_Coverage, 47562,
     /* 2213887 */   GIR_EraseRootFromParent_Done,
     /* 2213888 */ // Label 29195: @2213888
     /* 2213888 */ GIM_Try, /*On fail goto*//*Label 29196*/ GIMT_Encode4(2213942), // Rule ID 47563 //
     /* 2213893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2213899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213907 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2213910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2213924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213929 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213941 */   // GIR_Coverage, 47563,
     /* 2213941 */   GIR_EraseRootFromParent_Done,
     /* 2213942 */ // Label 29196: @2213942
     /* 2213942 */ GIM_Try, /*On fail goto*//*Label 29197*/ GIMT_Encode4(2213996), // Rule ID 47616 //
     /* 2213947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2213953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2213961 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213961 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2213964 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213968 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213973 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2213978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213983 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2213985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2213991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213994 */   GIR_RootConstrainSelectedInstOperands,
     /* 2213995 */   // GIR_Coverage, 47616,
     /* 2213995 */   GIR_EraseRootFromParent_Done,
     /* 2213996 */ // Label 29197: @2213996
     /* 2213996 */ GIM_Try, /*On fail goto*//*Label 29198*/ GIMT_Encode4(2214050), // Rule ID 47617 //
     /* 2214001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2214007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214015 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2214018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2214032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214034 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214037 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214048 */   GIR_RootConstrainSelectedInstOperands,
     /* 2214049 */   // GIR_Coverage, 47617,
     /* 2214049 */   GIR_EraseRootFromParent_Done,
     /* 2214050 */ // Label 29198: @2214050
     /* 2214050 */ GIM_Reject,
     /* 2214051 */ // Label 29128: @2214051
     /* 2214051 */ GIM_Try, /*On fail goto*//*Label 29199*/ GIMT_Encode4(2214154),
     /* 2214056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2214059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2214063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2214067 */   GIM_Try, /*On fail goto*//*Label 29200*/ GIMT_Encode4(2214110), // Rule ID 47552 //
     /* 2214072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214075 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214109 */     // GIR_Coverage, 47552,
     /* 2214109 */     GIR_EraseRootFromParent_Done,
     /* 2214110 */   // Label 29200: @2214110
     /* 2214110 */   GIM_Try, /*On fail goto*//*Label 29201*/ GIMT_Encode4(2214153), // Rule ID 47553 //
     /* 2214115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214118 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2214121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2214135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2214142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214152 */     // GIR_Coverage, 47553,
     /* 2214152 */     GIR_EraseRootFromParent_Done,
     /* 2214153 */   // Label 29201: @2214153
     /* 2214153 */   GIM_Reject,
     /* 2214154 */ // Label 29199: @2214154
     /* 2214154 */ GIM_Reject,
     /* 2214155 */ // Label 29129: @2214155
     /* 2214155 */ GIM_Reject,
     /* 2214156 */ // Label 41: @2214156
     /* 2214156 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 29204*/ GIMT_Encode4(2215198),
     /* 2214167 */ /*GILLT_s32*//*Label 29202*/ GIMT_Encode4(2214175),
     /* 2214171 */ /*GILLT_s64*//*Label 29203*/ GIMT_Encode4(2214833),
     /* 2214175 */ // Label 29202: @2214175
     /* 2214175 */ GIM_Try, /*On fail goto*//*Label 29205*/ GIMT_Encode4(2214832),
     /* 2214180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2214183 */   GIM_Try, /*On fail goto*//*Label 29206*/ GIMT_Encode4(2214219), // Rule ID 64468 //
     /* 2214188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2214191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214199 */     // MIs[0] Operand 2
     /* 2214199 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214210 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2214213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214218 */     // GIR_Coverage, 64468,
     /* 2214218 */     GIR_EraseRootFromParent_Done,
     /* 2214219 */   // Label 29206: @2214219
     /* 2214219 */   GIM_Try, /*On fail goto*//*Label 29207*/ GIMT_Encode4(2214255), // Rule ID 64470 //
     /* 2214224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2214227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214235 */     // MIs[0] Operand 2
     /* 2214235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214246 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2214249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214254 */     // GIR_Coverage, 64470,
     /* 2214254 */     GIR_EraseRootFromParent_Done,
     /* 2214255 */   // Label 29207: @2214255
     /* 2214255 */   GIM_Try, /*On fail goto*//*Label 29208*/ GIMT_Encode4(2214291), // Rule ID 2521 //
     /* 2214260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2214263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214271 */     // MIs[0] Operand 2
     /* 2214271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214282 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2214285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214290 */     // GIR_Coverage, 2521,
     /* 2214290 */     GIR_EraseRootFromParent_Done,
     /* 2214291 */   // Label 29208: @2214291
     /* 2214291 */   GIM_Try, /*On fail goto*//*Label 29209*/ GIMT_Encode4(2214327), // Rule ID 2523 //
     /* 2214296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2214299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214307 */     // MIs[0] Operand 2
     /* 2214307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214318 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2214318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2214321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214326 */     // GIR_Coverage, 2523,
     /* 2214326 */     GIR_EraseRootFromParent_Done,
     /* 2214327 */   // Label 29209: @2214327
     /* 2214327 */   GIM_Try, /*On fail goto*//*Label 29210*/ GIMT_Encode4(2214369), // Rule ID 62554 //
     /* 2214332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214343 */     // MIs[0] Operand 2
     /* 2214343 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214354 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2214364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214368 */     // GIR_Coverage, 62554,
     /* 2214368 */     GIR_EraseRootFromParent_Done,
     /* 2214369 */   // Label 29210: @2214369
     /* 2214369 */   GIM_Try, /*On fail goto*//*Label 29211*/ GIMT_Encode4(2214411), // Rule ID 62556 //
     /* 2214374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214385 */     // MIs[0] Operand 2
     /* 2214385 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214396 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2214406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214410 */     // GIR_Coverage, 62556,
     /* 2214410 */     GIR_EraseRootFromParent_Done,
     /* 2214411 */   // Label 29211: @2214411
     /* 2214411 */   GIM_Try, /*On fail goto*//*Label 29212*/ GIMT_Encode4(2214453), // Rule ID 62558 //
     /* 2214416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2214419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214427 */     // MIs[0] Operand 2
     /* 2214427 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214438 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2214441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214452 */     // GIR_Coverage, 62558,
     /* 2214452 */     GIR_EraseRootFromParent_Done,
     /* 2214453 */   // Label 29212: @2214453
     /* 2214453 */   GIM_Try, /*On fail goto*//*Label 29213*/ GIMT_Encode4(2214495), // Rule ID 64620 //
     /* 2214458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2214461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214469 */     // MIs[0] Operand 2
     /* 2214469 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214480 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i64] }, 0:{ *:[i64] })
     /* 2214480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2214490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214494 */     // GIR_Coverage, 64620,
     /* 2214494 */     GIR_EraseRootFromParent_Done,
     /* 2214495 */   // Label 29213: @2214495
     /* 2214495 */   GIM_Try, /*On fail goto*//*Label 29214*/ GIMT_Encode4(2214537), // Rule ID 64621 //
     /* 2214500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2214503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214511 */     // MIs[0] Operand 2
     /* 2214511 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214522 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2214532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214536 */     // GIR_Coverage, 64621,
     /* 2214536 */     GIR_EraseRootFromParent_Done,
     /* 2214537 */   // Label 29214: @2214537
     /* 2214537 */   GIM_Try, /*On fail goto*//*Label 29215*/ GIMT_Encode4(2214579), // Rule ID 64636 //
     /* 2214542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0),
     /* 2214545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214553 */     // MIs[0] Operand 2
     /* 2214553 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214564 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i64] }, 0:{ *:[i64] })
     /* 2214564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2214574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214578 */     // GIR_Coverage, 64636,
     /* 2214578 */     GIR_EraseRootFromParent_Done,
     /* 2214579 */   // Label 29215: @2214579
     /* 2214579 */   GIM_Try, /*On fail goto*//*Label 29216*/ GIMT_Encode4(2214621), // Rule ID 64637 //
     /* 2214584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1),
     /* 2214587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214595 */     // MIs[0] Operand 2
     /* 2214595 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214606 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 16:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2214616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214620 */     // GIR_Coverage, 64637,
     /* 2214620 */     GIR_EraseRootFromParent_Done,
     /* 2214621 */   // Label 29216: @2214621
     /* 2214621 */   GIM_Try, /*On fail goto*//*Label 29217*/ GIMT_Encode4(2214663), // Rule ID 64638 //
     /* 2214626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode0),
     /* 2214629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214637 */     // MIs[0] Operand 2
     /* 2214637 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214648 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i64] }, 0:{ *:[i64] })
     /* 2214648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2214658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214662 */     // GIR_Coverage, 64638,
     /* 2214662 */     GIR_EraseRootFromParent_Done,
     /* 2214663 */   // Label 29217: @2214663
     /* 2214663 */   GIM_Try, /*On fail goto*//*Label 29218*/ GIMT_Encode4(2214705), // Rule ID 64639 //
     /* 2214668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_NoStdExtZbb_HwMode1),
     /* 2214671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2214675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214679 */     // MIs[0] Operand 2
     /* 2214679 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214690 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (QC_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 8:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_EXT),
     /* 2214693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 2214700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214704 */     // GIR_Coverage, 64639,
     /* 2214704 */     GIR_EraseRootFromParent_Done,
     /* 2214705 */   // Label 29218: @2214705
     /* 2214705 */   GIM_Try, /*On fail goto*//*Label 29219*/ GIMT_Encode4(2214747), // Rule ID 65022 //
     /* 2214710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2214713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214721 */     // MIs[0] Operand 2
     /* 2214721 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214732 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2214735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2214742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214746 */     // GIR_Coverage, 65022,
     /* 2214746 */     GIR_EraseRootFromParent_Done,
     /* 2214747 */   // Label 29219: @2214747
     /* 2214747 */   GIM_Try, /*On fail goto*//*Label 29220*/ GIMT_Encode4(2214789), // Rule ID 65024 //
     /* 2214752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2214755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214763 */     // MIs[0] Operand 2
     /* 2214763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214774 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2214777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2214784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214788 */     // GIR_Coverage, 65024,
     /* 2214788 */     GIR_EraseRootFromParent_Done,
     /* 2214789 */   // Label 29220: @2214789
     /* 2214789 */   GIM_Try, /*On fail goto*//*Label 29221*/ GIMT_Encode4(2214831), // Rule ID 65026 //
     /* 2214794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode1),
     /* 2214797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214805 */     // MIs[0] Operand 2
     /* 2214805 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2214816 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2214816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2214819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214830 */     // GIR_Coverage, 65026,
     /* 2214830 */     GIR_EraseRootFromParent_Done,
     /* 2214831 */   // Label 29221: @2214831
     /* 2214831 */   GIM_Reject,
     /* 2214832 */ // Label 29205: @2214832
     /* 2214832 */ GIM_Reject,
     /* 2214833 */ // Label 29203: @2214833
     /* 2214833 */ GIM_Try, /*On fail goto*//*Label 29222*/ GIMT_Encode4(2215197),
     /* 2214838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2214841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2214849 */   GIM_Try, /*On fail goto*//*Label 29223*/ GIMT_Encode4(2214877), // Rule ID 64467 //
     /* 2214854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2214857 */     // MIs[0] Operand 2
     /* 2214857 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214868 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2214868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2214871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214876 */     // GIR_Coverage, 64467,
     /* 2214876 */     GIR_EraseRootFromParent_Done,
     /* 2214877 */   // Label 29223: @2214877
     /* 2214877 */   GIM_Try, /*On fail goto*//*Label 29224*/ GIMT_Encode4(2214905), // Rule ID 64469 //
     /* 2214882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2214885 */     // MIs[0] Operand 2
     /* 2214885 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214896 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2214896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2214899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214904 */     // GIR_Coverage, 64469,
     /* 2214904 */     GIR_EraseRootFromParent_Done,
     /* 2214905 */   // Label 29224: @2214905
     /* 2214905 */   GIM_Try, /*On fail goto*//*Label 29225*/ GIMT_Encode4(2214936), // Rule ID 262 //
     /* 2214910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2214913 */     // MIs[0] Operand 2
     /* 2214913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2214924 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2214924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2214927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2214934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214935 */     // GIR_Coverage, 262,
     /* 2214935 */     GIR_EraseRootFromParent_Done,
     /* 2214936 */   // Label 29225: @2214936
     /* 2214936 */   GIM_Try, /*On fail goto*//*Label 29226*/ GIMT_Encode4(2214964), // Rule ID 2520 //
     /* 2214941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2214944 */     // MIs[0] Operand 2
     /* 2214944 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2214955 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2214955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2214958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214963 */     // GIR_Coverage, 2520,
     /* 2214963 */     GIR_EraseRootFromParent_Done,
     /* 2214964 */   // Label 29226: @2214964
     /* 2214964 */   GIM_Try, /*On fail goto*//*Label 29227*/ GIMT_Encode4(2214992), // Rule ID 2522 //
     /* 2214969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2214972 */     // MIs[0] Operand 2
     /* 2214972 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2214983 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2214983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2214986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214991 */     // GIR_Coverage, 2522,
     /* 2214991 */     GIR_EraseRootFromParent_Done,
     /* 2214992 */   // Label 29227: @2214992
     /* 2214992 */   GIM_Try, /*On fail goto*//*Label 29228*/ GIMT_Encode4(2215026), // Rule ID 62553 //
     /* 2214997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215000 */     // MIs[0] Operand 2
     /* 2215000 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215011 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215025 */     // GIR_Coverage, 62553,
     /* 2215025 */     GIR_EraseRootFromParent_Done,
     /* 2215026 */   // Label 29228: @2215026
     /* 2215026 */   GIM_Try, /*On fail goto*//*Label 29229*/ GIMT_Encode4(2215060), // Rule ID 62555 //
     /* 2215031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215034 */     // MIs[0] Operand 2
     /* 2215034 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215045 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215059 */     // GIR_Coverage, 62555,
     /* 2215059 */     GIR_EraseRootFromParent_Done,
     /* 2215060 */   // Label 29229: @2215060
     /* 2215060 */   GIM_Try, /*On fail goto*//*Label 29230*/ GIMT_Encode4(2215094), // Rule ID 62557 //
     /* 2215065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2215068 */     // MIs[0] Operand 2
     /* 2215068 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215079 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2215082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215093 */     // GIR_Coverage, 62557,
     /* 2215093 */     GIR_EraseRootFromParent_Done,
     /* 2215094 */   // Label 29230: @2215094
     /* 2215094 */   GIM_Try, /*On fail goto*//*Label 29231*/ GIMT_Encode4(2215128), // Rule ID 65021 //
     /* 2215099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215102 */     // MIs[0] Operand 2
     /* 2215102 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2215113 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2215123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215127 */     // GIR_Coverage, 65021,
     /* 2215127 */     GIR_EraseRootFromParent_Done,
     /* 2215128 */   // Label 29231: @2215128
     /* 2215128 */   GIM_Try, /*On fail goto*//*Label 29232*/ GIMT_Encode4(2215162), // Rule ID 65023 //
     /* 2215133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215136 */     // MIs[0] Operand 2
     /* 2215136 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2215147 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2215157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215161 */     // GIR_Coverage, 65023,
     /* 2215161 */     GIR_EraseRootFromParent_Done,
     /* 2215162 */   // Label 29232: @2215162
     /* 2215162 */   GIM_Try, /*On fail goto*//*Label 29233*/ GIMT_Encode4(2215196), // Rule ID 65025 //
     /* 2215167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXAndesPerf_HwMode0),
     /* 2215170 */     // MIs[0] Operand 2
     /* 2215170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2215181 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (NDS_BFOS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2215181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::NDS_BFOS),
     /* 2215184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2215194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215195 */     // GIR_Coverage, 65025,
     /* 2215195 */     GIR_EraseRootFromParent_Done,
     /* 2215196 */   // Label 29233: @2215196
     /* 2215196 */   GIM_Reject,
     /* 2215197 */ // Label 29222: @2215197
     /* 2215197 */ GIM_Reject,
     /* 2215198 */ // Label 29204: @2215198
     /* 2215198 */ GIM_Reject,
     /* 2215199 */ // Label 42: @2215199
     /* 2215199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29251*/ GIMT_Encode4(2218885),
     /* 2215210 */ /*GILLT_s32*//*Label 29234*/ GIMT_Encode4(2215326),
     /* 2215214 */ /*GILLT_s64*//*Label 29235*/ GIMT_Encode4(2215622), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215226 */ /*GILLT_nxv1s16*//*Label 29236*/ GIMT_Encode4(2215876),
     /* 2215230 */ /*GILLT_nxv1s32*//*Label 29237*/ GIMT_Encode4(2215980),
     /* 2215234 */ /*GILLT_nxv1s64*//*Label 29238*/ GIMT_Encode4(2216197), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215246 */ /*GILLT_nxv2s16*//*Label 29239*/ GIMT_Encode4(2216522),
     /* 2215250 */ /*GILLT_nxv2s32*//*Label 29240*/ GIMT_Encode4(2216626),
     /* 2215254 */ /*GILLT_nxv2s64*//*Label 29241*/ GIMT_Encode4(2216843), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215266 */ /*GILLT_nxv4s16*//*Label 29242*/ GIMT_Encode4(2217168),
     /* 2215270 */ /*GILLT_nxv4s32*//*Label 29243*/ GIMT_Encode4(2217272),
     /* 2215274 */ /*GILLT_nxv4s64*//*Label 29244*/ GIMT_Encode4(2217489), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215286 */ /*GILLT_nxv8s16*//*Label 29245*/ GIMT_Encode4(2217814),
     /* 2215290 */ /*GILLT_nxv8s32*//*Label 29246*/ GIMT_Encode4(2217918),
     /* 2215294 */ /*GILLT_nxv8s64*//*Label 29247*/ GIMT_Encode4(2218135), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215306 */ /*GILLT_nxv16s16*//*Label 29248*/ GIMT_Encode4(2218460),
     /* 2215310 */ /*GILLT_nxv16s32*//*Label 29249*/ GIMT_Encode4(2218564), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2215322 */ /*GILLT_nxv32s16*//*Label 29250*/ GIMT_Encode4(2218781),
     /* 2215326 */ // Label 29234: @2215326
     /* 2215326 */ GIM_Try, /*On fail goto*//*Label 29252*/ GIMT_Encode4(2215621),
     /* 2215331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215342 */   GIM_Try, /*On fail goto*//*Label 29253*/ GIMT_Encode4(2215384), // Rule ID 65382 //
     /* 2215347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2215350 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2215350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2215353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215366 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2215369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215383 */     // GIR_Coverage, 65382,
     /* 2215383 */     GIR_EraseRootFromParent_Done,
     /* 2215384 */   // Label 29253: @2215384
     /* 2215384 */   GIM_Try, /*On fail goto*//*Label 29254*/ GIMT_Encode4(2215426), // Rule ID 65384 //
     /* 2215389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2215392 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2215392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215408 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215425 */     // GIR_Coverage, 65384,
     /* 2215425 */     GIR_EraseRootFromParent_Done,
     /* 2215426 */   // Label 29254: @2215426
     /* 2215426 */   GIM_Try, /*On fail goto*//*Label 29255*/ GIMT_Encode4(2215468), // Rule ID 65385 //
     /* 2215431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2215434 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2215434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2215437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215450 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215467 */     // GIR_Coverage, 65385,
     /* 2215467 */     GIR_EraseRootFromParent_Done,
     /* 2215468 */   // Label 29255: @2215468
     /* 2215468 */   GIM_Try, /*On fail goto*//*Label 29256*/ GIMT_Encode4(2215483), // Rule ID 65395 //
     /* 2215473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /* 2215476 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2215481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215482 */     // GIR_Coverage, 65395,
     /* 2215482 */     GIR_Done,
     /* 2215483 */   // Label 29256: @2215483
     /* 2215483 */   GIM_Try, /*On fail goto*//*Label 29257*/ GIMT_Encode4(2215498), // Rule ID 65396 //
     /* 2215488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /* 2215491 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2215496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215497 */     // GIR_Coverage, 65396,
     /* 2215497 */     GIR_Done,
     /* 2215498 */   // Label 29257: @2215498
     /* 2215498 */   GIM_Try, /*On fail goto*//*Label 29258*/ GIMT_Encode4(2215513), // Rule ID 65398 //
     /* 2215503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2215506 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2215511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215512 */     // GIR_Coverage, 65398,
     /* 2215512 */     GIR_Done,
     /* 2215513 */   // Label 29258: @2215513
     /* 2215513 */   GIM_Try, /*On fail goto*//*Label 29259*/ GIMT_Encode4(2215528), // Rule ID 65399 //
     /* 2215518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode1),
     /* 2215521 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2215521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2215526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215527 */     // GIR_Coverage, 65399,
     /* 2215527 */     GIR_Done,
     /* 2215528 */   // Label 29259: @2215528
     /* 2215528 */   GIM_Try, /*On fail goto*//*Label 29260*/ GIMT_Encode4(2215551), // Rule ID 65400 //
     /* 2215533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /* 2215536 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2215536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2215539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215550 */     // GIR_Coverage, 65400,
     /* 2215550 */     GIR_EraseRootFromParent_Done,
     /* 2215551 */   // Label 29260: @2215551
     /* 2215551 */   GIM_Try, /*On fail goto*//*Label 29261*/ GIMT_Encode4(2215574), // Rule ID 65401 //
     /* 2215556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /* 2215559 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2215559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2215562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215566 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215573 */     // GIR_Coverage, 65401,
     /* 2215573 */     GIR_EraseRootFromParent_Done,
     /* 2215574 */   // Label 29261: @2215574
     /* 2215574 */   GIM_Try, /*On fail goto*//*Label 29262*/ GIMT_Encode4(2215597), // Rule ID 65403 //
     /* 2215579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2215582 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2215582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2215585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215596 */     // GIR_Coverage, 65403,
     /* 2215596 */     GIR_EraseRootFromParent_Done,
     /* 2215597 */   // Label 29262: @2215597
     /* 2215597 */   GIM_Try, /*On fail goto*//*Label 29263*/ GIMT_Encode4(2215620), // Rule ID 65404 //
     /* 2215602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1),
     /* 2215605 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2215605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2215608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215619 */     // GIR_Coverage, 65404,
     /* 2215619 */     GIR_EraseRootFromParent_Done,
     /* 2215620 */   // Label 29263: @2215620
     /* 2215620 */   GIM_Reject,
     /* 2215621 */ // Label 29252: @2215621
     /* 2215621 */ GIM_Reject,
     /* 2215622 */ // Label 29235: @2215622
     /* 2215622 */ GIM_Try, /*On fail goto*//*Label 29264*/ GIMT_Encode4(2215675), // Rule ID 65380 //
     /* 2215627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2215630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2215633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215641 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i32] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 2215641 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215644 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215648 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215653 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215657 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2215660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 2215673 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215674 */   // GIR_Coverage, 65380,
     /* 2215674 */   GIR_EraseRootFromParent_Done,
     /* 2215675 */ // Label 29264: @2215675
     /* 2215675 */ GIM_Try, /*On fail goto*//*Label 29265*/ GIMT_Encode4(2215728), // Rule ID 65381 //
     /* 2215680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2215683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215694 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2215694 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215697 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215701 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215706 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215710 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2215713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2215726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215727 */   // GIR_Coverage, 65381,
     /* 2215727 */   GIR_EraseRootFromParent_Done,
     /* 2215728 */ // Label 29265: @2215728
     /* 2215728 */ GIM_Try, /*On fail goto*//*Label 29266*/ GIMT_Encode4(2215781), // Rule ID 65383 //
     /* 2215733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2215736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215747 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2215747 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2215750 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2215754 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215759 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2215763 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2215766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2215771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2215779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215780 */   // GIR_Coverage, 65383,
     /* 2215780 */   GIR_EraseRootFromParent_Done,
     /* 2215781 */ // Label 29266: @2215781
     /* 2215781 */ GIM_Try, /*On fail goto*//*Label 29267*/ GIMT_Encode4(2215815), // Rule ID 65391 //
     /* 2215786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2215789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2215792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215800 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i32] }:$src, X0:{ *:[i64] })
     /* 2215800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /* 2215803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2215807 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215814 */   // GIR_Coverage, 65391,
     /* 2215814 */   GIR_EraseRootFromParent_Done,
     /* 2215815 */ // Label 29267: @2215815
     /* 2215815 */ GIM_Try, /*On fail goto*//*Label 29268*/ GIMT_Encode4(2215841), // Rule ID 65397 //
     /* 2215820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2215823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215834 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2215834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2215839 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215840 */   // GIR_Coverage, 65397,
     /* 2215840 */   GIR_Done,
     /* 2215841 */ // Label 29268: @2215841
     /* 2215841 */ GIM_Try, /*On fail goto*//*Label 29269*/ GIMT_Encode4(2215875), // Rule ID 65402 //
     /* 2215846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2215849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2215852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2215860 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i64] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2215860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2215863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215865 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2215867 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2215873 */   GIR_RootConstrainSelectedInstOperands,
     /* 2215874 */   // GIR_Coverage, 65402,
     /* 2215874 */   GIR_EraseRootFromParent_Done,
     /* 2215875 */ // Label 29269: @2215875
     /* 2215875 */ GIM_Reject,
     /* 2215876 */ // Label 29236: @2215876
     /* 2215876 */ GIM_Try, /*On fail goto*//*Label 29270*/ GIMT_Encode4(2215979),
     /* 2215881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2215884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215892 */   GIM_Try, /*On fail goto*//*Label 29271*/ GIMT_Encode4(2215935), // Rule ID 45794 //
     /* 2215897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215900 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2215903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2215917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215934 */     // GIR_Coverage, 45794,
     /* 2215934 */     GIR_EraseRootFromParent_Done,
     /* 2215935 */   // Label 29271: @2215935
     /* 2215935 */   GIM_Try, /*On fail goto*//*Label 29272*/ GIMT_Encode4(2215978), // Rule ID 45795 //
     /* 2215940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215943 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2215946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2215960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2215967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215977 */     // GIR_Coverage, 45795,
     /* 2215977 */     GIR_EraseRootFromParent_Done,
     /* 2215978 */   // Label 29272: @2215978
     /* 2215978 */   GIM_Reject,
     /* 2215979 */ // Label 29270: @2215979
     /* 2215979 */ GIM_Reject,
     /* 2215980 */ // Label 29237: @2215980
     /* 2215980 */ GIM_Try, /*On fail goto*//*Label 29273*/ GIMT_Encode4(2216034), // Rule ID 47506 //
     /* 2215985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2215991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215999 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216021 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216033 */   // GIR_Coverage, 47506,
     /* 2216033 */   GIR_EraseRootFromParent_Done,
     /* 2216034 */ // Label 29273: @2216034
     /* 2216034 */ GIM_Try, /*On fail goto*//*Label 29274*/ GIMT_Encode4(2216088), // Rule ID 47507 //
     /* 2216039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216053 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216075 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216086 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216087 */   // GIR_Coverage, 47507,
     /* 2216087 */   GIR_EraseRootFromParent_Done,
     /* 2216088 */ // Label 29274: @2216088
     /* 2216088 */ GIM_Try, /*On fail goto*//*Label 29275*/ GIMT_Encode4(2216142), // Rule ID 47572 //
     /* 2216093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216107 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2216124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216129 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216141 */   // GIR_Coverage, 47572,
     /* 2216141 */   GIR_EraseRootFromParent_Done,
     /* 2216142 */ // Label 29275: @2216142
     /* 2216142 */ GIM_Try, /*On fail goto*//*Label 29276*/ GIMT_Encode4(2216196), // Rule ID 47573 //
     /* 2216147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216161 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2216164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2216178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216183 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216195 */   // GIR_Coverage, 47573,
     /* 2216195 */   GIR_EraseRootFromParent_Done,
     /* 2216196 */ // Label 29276: @2216196
     /* 2216196 */ GIM_Reject,
     /* 2216197 */ // Label 29238: @2216197
     /* 2216197 */ GIM_Try, /*On fail goto*//*Label 29277*/ GIMT_Encode4(2216251), // Rule ID 47526 //
     /* 2216202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2216208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216216 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216228 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216235 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216238 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216249 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216250 */   // GIR_Coverage, 47526,
     /* 2216250 */   GIR_EraseRootFromParent_Done,
     /* 2216251 */ // Label 29277: @2216251
     /* 2216251 */ GIM_Try, /*On fail goto*//*Label 29278*/ GIMT_Encode4(2216305), // Rule ID 47527 //
     /* 2216256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2216262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216270 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216292 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216303 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216304 */   // GIR_Coverage, 47527,
     /* 2216304 */   GIR_EraseRootFromParent_Done,
     /* 2216305 */ // Label 29278: @2216305
     /* 2216305 */ GIM_Try, /*On fail goto*//*Label 29279*/ GIMT_Encode4(2216359), // Rule ID 47592 //
     /* 2216310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216324 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216346 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216358 */   // GIR_Coverage, 47592,
     /* 2216358 */   GIR_EraseRootFromParent_Done,
     /* 2216359 */ // Label 29279: @2216359
     /* 2216359 */ GIM_Try, /*On fail goto*//*Label 29280*/ GIMT_Encode4(2216413), // Rule ID 47593 //
     /* 2216364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2216370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216378 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216400 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216412 */   // GIR_Coverage, 47593,
     /* 2216412 */   GIR_EraseRootFromParent_Done,
     /* 2216413 */ // Label 29280: @2216413
     /* 2216413 */ GIM_Try, /*On fail goto*//*Label 29281*/ GIMT_Encode4(2216467), // Rule ID 47626 //
     /* 2216418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216432 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2216449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216454 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216466 */   // GIR_Coverage, 47626,
     /* 2216466 */   GIR_EraseRootFromParent_Done,
     /* 2216467 */ // Label 29281: @2216467
     /* 2216467 */ GIM_Try, /*On fail goto*//*Label 29282*/ GIMT_Encode4(2216521), // Rule ID 47627 //
     /* 2216472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216486 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2216489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2216503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216505 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216508 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216520 */   // GIR_Coverage, 47627,
     /* 2216520 */   GIR_EraseRootFromParent_Done,
     /* 2216521 */ // Label 29282: @2216521
     /* 2216521 */ GIM_Reject,
     /* 2216522 */ // Label 29239: @2216522
     /* 2216522 */ GIM_Try, /*On fail goto*//*Label 29283*/ GIMT_Encode4(2216625),
     /* 2216527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2216530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216538 */   GIM_Try, /*On fail goto*//*Label 29284*/ GIMT_Encode4(2216581), // Rule ID 47486 //
     /* 2216543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216546 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2216549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216580 */     // GIR_Coverage, 47486,
     /* 2216580 */     GIR_EraseRootFromParent_Done,
     /* 2216581 */   // Label 29284: @2216581
     /* 2216581 */   GIM_Try, /*On fail goto*//*Label 29285*/ GIMT_Encode4(2216624), // Rule ID 47487 //
     /* 2216586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216589 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2216592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2216606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216623 */     // GIR_Coverage, 47487,
     /* 2216623 */     GIR_EraseRootFromParent_Done,
     /* 2216624 */   // Label 29285: @2216624
     /* 2216624 */   GIM_Reject,
     /* 2216625 */ // Label 29283: @2216625
     /* 2216625 */ GIM_Reject,
     /* 2216626 */ // Label 29240: @2216626
     /* 2216626 */ GIM_Try, /*On fail goto*//*Label 29286*/ GIMT_Encode4(2216680), // Rule ID 47510 //
     /* 2216631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2216637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216645 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2216648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216667 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216679 */   // GIR_Coverage, 47510,
     /* 2216679 */   GIR_EraseRootFromParent_Done,
     /* 2216680 */ // Label 29286: @2216680
     /* 2216680 */ GIM_Try, /*On fail goto*//*Label 29287*/ GIMT_Encode4(2216734), // Rule ID 47511 //
     /* 2216685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2216691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216699 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2216702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2216716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216721 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216733 */   // GIR_Coverage, 47511,
     /* 2216733 */   GIR_EraseRootFromParent_Done,
     /* 2216734 */ // Label 29287: @2216734
     /* 2216734 */ GIM_Try, /*On fail goto*//*Label 29288*/ GIMT_Encode4(2216788), // Rule ID 47576 //
     /* 2216739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2216745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216753 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2216756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216775 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216787 */   // GIR_Coverage, 47576,
     /* 2216787 */   GIR_EraseRootFromParent_Done,
     /* 2216788 */ // Label 29288: @2216788
     /* 2216788 */ GIM_Try, /*On fail goto*//*Label 29289*/ GIMT_Encode4(2216842), // Rule ID 47577 //
     /* 2216793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2216799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216807 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2216810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2216824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216826 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216829 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216840 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216841 */   // GIR_Coverage, 47577,
     /* 2216841 */   GIR_EraseRootFromParent_Done,
     /* 2216842 */ // Label 29289: @2216842
     /* 2216842 */ GIM_Reject,
     /* 2216843 */ // Label 29241: @2216843
     /* 2216843 */ GIM_Try, /*On fail goto*//*Label 29290*/ GIMT_Encode4(2216897), // Rule ID 47530 //
     /* 2216848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2216854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216862 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2216879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216881 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216884 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216896 */   // GIR_Coverage, 47530,
     /* 2216896 */   GIR_EraseRootFromParent_Done,
     /* 2216897 */ // Label 29290: @2216897
     /* 2216897 */ GIM_Try, /*On fail goto*//*Label 29291*/ GIMT_Encode4(2216951), // Rule ID 47531 //
     /* 2216902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2216905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2216908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216916 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2216933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216938 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2216946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2216950 */   // GIR_Coverage, 47531,
     /* 2216950 */   GIR_EraseRootFromParent_Done,
     /* 2216951 */ // Label 29291: @2216951
     /* 2216951 */ GIM_Try, /*On fail goto*//*Label 29292*/ GIMT_Encode4(2217005), // Rule ID 47596 //
     /* 2216956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2216959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2216962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2216966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216970 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2216973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2216987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216992 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2216994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217004 */   // GIR_Coverage, 47596,
     /* 2217004 */   GIR_EraseRootFromParent_Done,
     /* 2217005 */ // Label 29292: @2217005
     /* 2217005 */ GIM_Try, /*On fail goto*//*Label 29293*/ GIMT_Encode4(2217059), // Rule ID 47597 //
     /* 2217010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217024 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217046 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217057 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217058 */   // GIR_Coverage, 47597,
     /* 2217058 */   GIR_EraseRootFromParent_Done,
     /* 2217059 */ // Label 29293: @2217059
     /* 2217059 */ GIM_Try, /*On fail goto*//*Label 29294*/ GIMT_Encode4(2217113), // Rule ID 47630 //
     /* 2217064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217078 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2217095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217100 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217112 */   // GIR_Coverage, 47630,
     /* 2217112 */   GIR_EraseRootFromParent_Done,
     /* 2217113 */ // Label 29294: @2217113
     /* 2217113 */ GIM_Try, /*On fail goto*//*Label 29295*/ GIMT_Encode4(2217167), // Rule ID 47631 //
     /* 2217118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217132 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2217149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217151 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217154 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217165 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217166 */   // GIR_Coverage, 47631,
     /* 2217166 */   GIR_EraseRootFromParent_Done,
     /* 2217167 */ // Label 29295: @2217167
     /* 2217167 */ GIM_Reject,
     /* 2217168 */ // Label 29242: @2217168
     /* 2217168 */ GIM_Try, /*On fail goto*//*Label 29296*/ GIMT_Encode4(2217271),
     /* 2217173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217184 */   GIM_Try, /*On fail goto*//*Label 29297*/ GIMT_Encode4(2217227), // Rule ID 47490 //
     /* 2217189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217192 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2217195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217226 */     // GIR_Coverage, 47490,
     /* 2217226 */     GIR_EraseRootFromParent_Done,
     /* 2217227 */   // Label 29297: @2217227
     /* 2217227 */   GIM_Try, /*On fail goto*//*Label 29298*/ GIMT_Encode4(2217270), // Rule ID 47491 //
     /* 2217232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217235 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2217238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2217252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217269 */     // GIR_Coverage, 47491,
     /* 2217269 */     GIR_EraseRootFromParent_Done,
     /* 2217270 */   // Label 29298: @2217270
     /* 2217270 */   GIM_Reject,
     /* 2217271 */ // Label 29296: @2217271
     /* 2217271 */ GIM_Reject,
     /* 2217272 */ // Label 29243: @2217272
     /* 2217272 */ GIM_Try, /*On fail goto*//*Label 29299*/ GIMT_Encode4(2217326), // Rule ID 47514 //
     /* 2217277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217291 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217303 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217313 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217324 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217325 */   // GIR_Coverage, 47514,
     /* 2217325 */   GIR_EraseRootFromParent_Done,
     /* 2217326 */ // Label 29299: @2217326
     /* 2217326 */ GIM_Try, /*On fail goto*//*Label 29300*/ GIMT_Encode4(2217380), // Rule ID 47515 //
     /* 2217331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217345 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217367 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217378 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217379 */   // GIR_Coverage, 47515,
     /* 2217379 */   GIR_EraseRootFromParent_Done,
     /* 2217380 */ // Label 29300: @2217380
     /* 2217380 */ GIM_Try, /*On fail goto*//*Label 29301*/ GIMT_Encode4(2217434), // Rule ID 47580 //
     /* 2217385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217399 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217421 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217432 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217433 */   // GIR_Coverage, 47580,
     /* 2217433 */   GIR_EraseRootFromParent_Done,
     /* 2217434 */ // Label 29301: @2217434
     /* 2217434 */ GIM_Try, /*On fail goto*//*Label 29302*/ GIMT_Encode4(2217488), // Rule ID 47581 //
     /* 2217439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217453 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2217456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217465 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2217470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217472 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217475 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217486 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217487 */   // GIR_Coverage, 47581,
     /* 2217487 */   GIR_EraseRootFromParent_Done,
     /* 2217488 */ // Label 29302: @2217488
     /* 2217488 */ GIM_Reject,
     /* 2217489 */ // Label 29244: @2217489
     /* 2217489 */ GIM_Try, /*On fail goto*//*Label 29303*/ GIMT_Encode4(2217543), // Rule ID 47534 //
     /* 2217494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2217500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217508 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2217525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217530 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217542 */   // GIR_Coverage, 47534,
     /* 2217542 */   GIR_EraseRootFromParent_Done,
     /* 2217543 */ // Label 29303: @2217543
     /* 2217543 */ GIM_Try, /*On fail goto*//*Label 29304*/ GIMT_Encode4(2217597), // Rule ID 47535 //
     /* 2217548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2217554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217562 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217562 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217569 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2217579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217584 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217596 */   // GIR_Coverage, 47535,
     /* 2217596 */   GIR_EraseRootFromParent_Done,
     /* 2217597 */ // Label 29304: @2217597
     /* 2217597 */ GIM_Try, /*On fail goto*//*Label 29305*/ GIMT_Encode4(2217651), // Rule ID 47600 //
     /* 2217602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217616 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2217633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217638 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217650 */   // GIR_Coverage, 47600,
     /* 2217650 */   GIR_EraseRootFromParent_Done,
     /* 2217651 */ // Label 29305: @2217651
     /* 2217651 */ GIM_Try, /*On fail goto*//*Label 29306*/ GIMT_Encode4(2217705), // Rule ID 47601 //
     /* 2217656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2217662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217670 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217670 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217673 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217677 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2217687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217692 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217704 */   // GIR_Coverage, 47601,
     /* 2217704 */   GIR_EraseRootFromParent_Done,
     /* 2217705 */ // Label 29306: @2217705
     /* 2217705 */ GIM_Try, /*On fail goto*//*Label 29307*/ GIMT_Encode4(2217759), // Rule ID 47634 //
     /* 2217710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2217713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217724 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2217741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217746 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217757 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217758 */   // GIR_Coverage, 47634,
     /* 2217758 */   GIR_EraseRootFromParent_Done,
     /* 2217759 */ // Label 29307: @2217759
     /* 2217759 */ GIM_Try, /*On fail goto*//*Label 29308*/ GIMT_Encode4(2217813), // Rule ID 47635 //
     /* 2217764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2217767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217778 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217778 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2217781 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217785 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2217795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217797 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217800 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217812 */   // GIR_Coverage, 47635,
     /* 2217812 */   GIR_EraseRootFromParent_Done,
     /* 2217813 */ // Label 29308: @2217813
     /* 2217813 */ GIM_Reject,
     /* 2217814 */ // Label 29245: @2217814
     /* 2217814 */ GIM_Try, /*On fail goto*//*Label 29309*/ GIMT_Encode4(2217917),
     /* 2217819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2217822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217830 */   GIM_Try, /*On fail goto*//*Label 29310*/ GIMT_Encode4(2217873), // Rule ID 47494 //
     /* 2217835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217838 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2217841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217872 */     // GIR_Coverage, 47494,
     /* 2217872 */     GIR_EraseRootFromParent_Done,
     /* 2217873 */   // Label 29310: @2217873
     /* 2217873 */   GIM_Try, /*On fail goto*//*Label 29311*/ GIMT_Encode4(2217916), // Rule ID 47495 //
     /* 2217878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217881 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2217884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2217898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217915 */     // GIR_Coverage, 47495,
     /* 2217915 */     GIR_EraseRootFromParent_Done,
     /* 2217916 */   // Label 29311: @2217916
     /* 2217916 */   GIM_Reject,
     /* 2217917 */ // Label 29309: @2217917
     /* 2217917 */ GIM_Reject,
     /* 2217918 */ // Label 29246: @2217918
     /* 2217918 */ GIM_Try, /*On fail goto*//*Label 29312*/ GIMT_Encode4(2217972), // Rule ID 47518 //
     /* 2217923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2217929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217937 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217937 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2217940 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217944 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2217954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217956 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217959 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2217961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217970 */   GIR_RootConstrainSelectedInstOperands,
     /* 2217971 */   // GIR_Coverage, 47518,
     /* 2217971 */   GIR_EraseRootFromParent_Done,
     /* 2217972 */ // Label 29312: @2217972
     /* 2217972 */ GIM_Try, /*On fail goto*//*Label 29313*/ GIMT_Encode4(2218026), // Rule ID 47519 //
     /* 2217977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2217983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2217987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217991 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2217994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218013 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218024 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218025 */   // GIR_Coverage, 47519,
     /* 2218025 */   GIR_EraseRootFromParent_Done,
     /* 2218026 */ // Label 29313: @2218026
     /* 2218026 */ GIM_Try, /*On fail goto*//*Label 29314*/ GIMT_Encode4(2218080), // Rule ID 47584 //
     /* 2218031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218045 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218045 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218048 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218052 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218067 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218078 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218079 */   // GIR_Coverage, 47584,
     /* 2218079 */   GIR_EraseRootFromParent_Done,
     /* 2218080 */ // Label 29314: @2218080
     /* 2218080 */ GIM_Try, /*On fail goto*//*Label 29315*/ GIMT_Encode4(2218134), // Rule ID 47585 //
     /* 2218085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218099 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2218116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218121 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218133 */   // GIR_Coverage, 47585,
     /* 2218133 */   GIR_EraseRootFromParent_Done,
     /* 2218134 */ // Label 29315: @2218134
     /* 2218134 */ GIM_Reject,
     /* 2218135 */ // Label 29247: @2218135
     /* 2218135 */ GIM_Try, /*On fail goto*//*Label 29316*/ GIMT_Encode4(2218189), // Rule ID 47538 //
     /* 2218140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2218146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218154 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218176 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218188 */   // GIR_Coverage, 47538,
     /* 2218188 */   GIR_EraseRootFromParent_Done,
     /* 2218189 */ // Label 29316: @2218189
     /* 2218189 */ GIM_Try, /*On fail goto*//*Label 29317*/ GIMT_Encode4(2218243), // Rule ID 47539 //
     /* 2218194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2218200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218208 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218220 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218230 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218242 */   // GIR_Coverage, 47539,
     /* 2218242 */   GIR_EraseRootFromParent_Done,
     /* 2218243 */ // Label 29317: @2218243
     /* 2218243 */ GIM_Try, /*On fail goto*//*Label 29318*/ GIMT_Encode4(2218297), // Rule ID 47604 //
     /* 2218248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218262 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218284 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218296 */   // GIR_Coverage, 47604,
     /* 2218296 */   GIR_EraseRootFromParent_Done,
     /* 2218297 */ // Label 29318: @2218297
     /* 2218297 */ GIM_Try, /*On fail goto*//*Label 29319*/ GIMT_Encode4(2218351), // Rule ID 47605 //
     /* 2218302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218316 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218316 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218319 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218323 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218328 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218338 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218350 */   // GIR_Coverage, 47605,
     /* 2218350 */   GIR_EraseRootFromParent_Done,
     /* 2218351 */ // Label 29319: @2218351
     /* 2218351 */ GIM_Try, /*On fail goto*//*Label 29320*/ GIMT_Encode4(2218405), // Rule ID 47638 //
     /* 2218356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2218359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218370 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2218387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218392 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218404 */   // GIR_Coverage, 47638,
     /* 2218404 */   GIR_EraseRootFromParent_Done,
     /* 2218405 */ // Label 29320: @2218405
     /* 2218405 */ GIM_Try, /*On fail goto*//*Label 29321*/ GIMT_Encode4(2218459), // Rule ID 47639 //
     /* 2218410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2218413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218424 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2218441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218446 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218457 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218458 */   // GIR_Coverage, 47639,
     /* 2218458 */   GIR_EraseRootFromParent_Done,
     /* 2218459 */ // Label 29321: @2218459
     /* 2218459 */ GIM_Reject,
     /* 2218460 */ // Label 29248: @2218460
     /* 2218460 */ GIM_Try, /*On fail goto*//*Label 29322*/ GIMT_Encode4(2218563),
     /* 2218465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2218468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218476 */   GIM_Try, /*On fail goto*//*Label 29323*/ GIMT_Encode4(2218519), // Rule ID 47498 //
     /* 2218481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218484 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2218487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218518 */     // GIR_Coverage, 47498,
     /* 2218518 */     GIR_EraseRootFromParent_Done,
     /* 2218519 */   // Label 29323: @2218519
     /* 2218519 */   GIM_Try, /*On fail goto*//*Label 29324*/ GIMT_Encode4(2218562), // Rule ID 47499 //
     /* 2218524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218527 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2218530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2218544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218561 */     // GIR_Coverage, 47499,
     /* 2218561 */     GIR_EraseRootFromParent_Done,
     /* 2218562 */   // Label 29324: @2218562
     /* 2218562 */   GIM_Reject,
     /* 2218563 */ // Label 29322: @2218563
     /* 2218563 */ GIM_Reject,
     /* 2218564 */ // Label 29249: @2218564
     /* 2218564 */ GIM_Try, /*On fail goto*//*Label 29325*/ GIMT_Encode4(2218618), // Rule ID 47522 //
     /* 2218569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2218575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218583 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2218586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218605 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218616 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218617 */   // GIR_Coverage, 47522,
     /* 2218617 */   GIR_EraseRootFromParent_Done,
     /* 2218618 */ // Label 29325: @2218618
     /* 2218618 */ GIM_Try, /*On fail goto*//*Label 29326*/ GIMT_Encode4(2218672), // Rule ID 47523 //
     /* 2218623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2218629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218637 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218637 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2218640 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218644 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218656 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218659 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218671 */   // GIR_Coverage, 47523,
     /* 2218671 */   GIR_EraseRootFromParent_Done,
     /* 2218672 */ // Label 29326: @2218672
     /* 2218672 */ GIM_Try, /*On fail goto*//*Label 29327*/ GIMT_Encode4(2218726), // Rule ID 47588 //
     /* 2218677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2218683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218691 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218691 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2218694 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218698 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218713 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218725 */   // GIR_Coverage, 47588,
     /* 2218725 */   GIR_EraseRootFromParent_Done,
     /* 2218726 */ // Label 29327: @2218726
     /* 2218726 */ GIM_Try, /*On fail goto*//*Label 29328*/ GIMT_Encode4(2218780), // Rule ID 47589 //
     /* 2218731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2218737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218745 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2218748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2218762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218767 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218778 */   GIR_RootConstrainSelectedInstOperands,
     /* 2218779 */   // GIR_Coverage, 47589,
     /* 2218779 */   GIR_EraseRootFromParent_Done,
     /* 2218780 */ // Label 29328: @2218780
     /* 2218780 */ GIM_Reject,
     /* 2218781 */ // Label 29250: @2218781
     /* 2218781 */ GIM_Try, /*On fail goto*//*Label 29329*/ GIMT_Encode4(2218884),
     /* 2218786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2218789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218797 */   GIM_Try, /*On fail goto*//*Label 29330*/ GIMT_Encode4(2218840), // Rule ID 47502 //
     /* 2218802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218805 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2218808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218839 */     // GIR_Coverage, 47502,
     /* 2218839 */     GIR_EraseRootFromParent_Done,
     /* 2218840 */   // Label 29330: @2218840
     /* 2218840 */   GIM_Try, /*On fail goto*//*Label 29331*/ GIMT_Encode4(2218883), // Rule ID 47503 //
     /* 2218845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218848 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2218851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2218865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2218872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218882 */     // GIR_Coverage, 47503,
     /* 2218882 */     GIR_EraseRootFromParent_Done,
     /* 2218883 */   // Label 29331: @2218883
     /* 2218883 */   GIM_Reject,
     /* 2218884 */ // Label 29329: @2218884
     /* 2218884 */ GIM_Reject,
     /* 2218885 */ // Label 29251: @2218885
     /* 2218885 */ GIM_Reject,
     /* 2218886 */ // Label 43: @2218886
     /* 2218886 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29356*/ GIMT_Encode4(2227481),
     /* 2218897 */ /*GILLT_s32*//*Label 29332*/ GIMT_Encode4(2219021),
     /* 2218901 */ /*GILLT_s64*//*Label 29333*/ GIMT_Encode4(2219146), GIMT_Encode4(0),
     /* 2218909 */ /*GILLT_nxv1s8*//*Label 29334*/ GIMT_Encode4(2219491),
     /* 2218913 */ /*GILLT_nxv1s16*//*Label 29335*/ GIMT_Encode4(2219606),
     /* 2218917 */ /*GILLT_nxv1s32*//*Label 29336*/ GIMT_Encode4(2220085),
     /* 2218921 */ /*GILLT_nxv1s64*//*Label 29337*/ GIMT_Encode4(2220564), GIMT_Encode4(0),
     /* 2218929 */ /*GILLT_nxv2s8*//*Label 29338*/ GIMT_Encode4(2221043),
     /* 2218933 */ /*GILLT_nxv2s16*//*Label 29339*/ GIMT_Encode4(2221158),
     /* 2218937 */ /*GILLT_nxv2s32*//*Label 29340*/ GIMT_Encode4(2221637),
     /* 2218941 */ /*GILLT_nxv2s64*//*Label 29341*/ GIMT_Encode4(2222116), GIMT_Encode4(0),
     /* 2218949 */ /*GILLT_nxv4s8*//*Label 29342*/ GIMT_Encode4(2222595),
     /* 2218953 */ /*GILLT_nxv4s16*//*Label 29343*/ GIMT_Encode4(2222710),
     /* 2218957 */ /*GILLT_nxv4s32*//*Label 29344*/ GIMT_Encode4(2223189),
     /* 2218961 */ /*GILLT_nxv4s64*//*Label 29345*/ GIMT_Encode4(2223668), GIMT_Encode4(0),
     /* 2218969 */ /*GILLT_nxv8s8*//*Label 29346*/ GIMT_Encode4(2224147),
     /* 2218973 */ /*GILLT_nxv8s16*//*Label 29347*/ GIMT_Encode4(2224262),
     /* 2218977 */ /*GILLT_nxv8s32*//*Label 29348*/ GIMT_Encode4(2224741),
     /* 2218981 */ /*GILLT_nxv8s64*//*Label 29349*/ GIMT_Encode4(2225220), GIMT_Encode4(0),
     /* 2218989 */ /*GILLT_nxv16s8*//*Label 29350*/ GIMT_Encode4(2225699),
     /* 2218993 */ /*GILLT_nxv16s16*//*Label 29351*/ GIMT_Encode4(2225814),
     /* 2218997 */ /*GILLT_nxv16s32*//*Label 29352*/ GIMT_Encode4(2226293), GIMT_Encode4(0),
     /* 2219005 */ /*GILLT_nxv32s8*//*Label 29353*/ GIMT_Encode4(2226772),
     /* 2219009 */ /*GILLT_nxv32s16*//*Label 29354*/ GIMT_Encode4(2226887), GIMT_Encode4(0),
     /* 2219017 */ /*GILLT_nxv64s8*//*Label 29355*/ GIMT_Encode4(2227366),
     /* 2219021 */ // Label 29332: @2219021
     /* 2219021 */ GIM_Try, /*On fail goto*//*Label 29357*/ GIMT_Encode4(2219145),
     /* 2219026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2219029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2219032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219036 */   GIM_Try, /*On fail goto*//*Label 29358*/ GIMT_Encode4(2219073), // Rule ID 2477 //
     /* 2219041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /* 2219044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2219048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219055 */     // (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2)
     /* 2219055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2219058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219060 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219072 */     // GIR_Coverage, 2477,
     /* 2219072 */     GIR_EraseRootFromParent_Done,
     /* 2219073 */   // Label 29358: @2219073
     /* 2219073 */   GIM_Try, /*On fail goto*//*Label 29359*/ GIMT_Encode4(2219111), // Rule ID 97 //
     /* 2219078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2219081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219097 */     // MIs[1] Operand 1
     /* 2219097 */     // No operand predicates
     /* 2219097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219099 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219106 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219110 */     // GIR_Coverage, 97,
     /* 2219110 */     GIR_EraseRootFromParent_Done,
     /* 2219111 */   // Label 29359: @2219111
     /* 2219111 */   GIM_Try, /*On fail goto*//*Label 29360*/ GIMT_Encode4(2219144), // Rule ID 111 //
     /* 2219116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2219119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219130 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SLL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2219130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2219133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219143 */     // GIR_Coverage, 111,
     /* 2219143 */     GIR_EraseRootFromParent_Done,
     /* 2219144 */   // Label 29360: @2219144
     /* 2219144 */   GIM_Reject,
     /* 2219145 */ // Label 29357: @2219145
     /* 2219145 */ GIM_Reject,
     /* 2219146 */ // Label 29333: @2219146
     /* 2219146 */ GIM_Try, /*On fail goto*//*Label 29361*/ GIMT_Encode4(2219490),
     /* 2219151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219157 */   GIM_Try, /*On fail goto*//*Label 29362*/ GIMT_Encode4(2219251), // Rule ID 259 //
     /* 2219162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2219165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2219177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219190 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2219201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219213 */     // MIs[2] Operand 1
     /* 2219213 */     // No operand predicates
     /* 2219213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219215 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt))
     /* 2219215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2219218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2219231 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2219234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2219239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219244 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // shamt
     /* 2219249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219250 */     // GIR_Coverage, 259,
     /* 2219250 */     GIR_EraseRootFromParent_Done,
     /* 2219251 */   // Label 29362: @2219251
     /* 2219251 */   GIM_Try, /*On fail goto*//*Label 29363*/ GIMT_Encode4(2219323), // Rule ID 2617 //
     /* 2219256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2219259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2219271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219284 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2219295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219303 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219307 */     // MIs[2] Operand 1
     /* 2219307 */     // No operand predicates
     /* 2219307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219309 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SLLI_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2219309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /* 2219312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2219318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2219321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219322 */     // GIR_Coverage, 2617,
     /* 2219322 */     GIR_EraseRootFromParent_Done,
     /* 2219323 */   // Label 29363: @2219323
     /* 2219323 */   GIM_Try, /*On fail goto*//*Label 29364*/ GIMT_Encode4(2219364), // Rule ID 2476 //
     /* 2219328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /* 2219331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2219339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219346 */     // (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2)
     /* 2219346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2219349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2219357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219363 */     // GIR_Coverage, 2476,
     /* 2219363 */     GIR_EraseRootFromParent_Done,
     /* 2219364 */   // Label 29364: @2219364
     /* 2219364 */   GIM_Try, /*On fail goto*//*Label 29365*/ GIMT_Encode4(2219410), // Rule ID 274 //
     /* 2219369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2219372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2219392 */     // MIs[1] Operand 1
     /* 2219392 */     // No operand predicates
     /* 2219392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10031),
     /* 2219396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219398 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)<<P:Predicate_anonymous_10031>>  =>  (SLLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2219398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLIW),
     /* 2219401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219409 */     // GIR_Coverage, 274,
     /* 2219409 */     GIR_EraseRootFromParent_Done,
     /* 2219410 */   // Label 29365: @2219410
     /* 2219410 */   GIM_Try, /*On fail goto*//*Label 29366*/ GIMT_Encode4(2219452), // Rule ID 96 //
     /* 2219415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2219418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219438 */     // MIs[1] Operand 1
     /* 2219438 */     // No operand predicates
     /* 2219438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219440 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2219443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219451 */     // GIR_Coverage, 96,
     /* 2219451 */     GIR_EraseRootFromParent_Done,
     /* 2219452 */   // Label 29366: @2219452
     /* 2219452 */   GIM_Try, /*On fail goto*//*Label 29367*/ GIMT_Encode4(2219489), // Rule ID 110 //
     /* 2219457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2219460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219475 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2219475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2219478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219488 */     // GIR_Coverage, 110,
     /* 2219488 */     GIR_EraseRootFromParent_Done,
     /* 2219489 */   // Label 29367: @2219489
     /* 2219489 */   GIM_Reject,
     /* 2219490 */ // Label 29361: @2219490
     /* 2219490 */ GIM_Reject,
     /* 2219491 */ // Label 29334: @2219491
     /* 2219491 */ GIM_Try, /*On fail goto*//*Label 29368*/ GIMT_Encode4(2219605),
     /* 2219496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2219502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219514 */   GIM_Try, /*On fail goto*//*Label 29369*/ GIMT_Encode4(2219559), // Rule ID 48046 //
     /* 2219519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219522 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2219525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2219539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219558 */     // GIR_Coverage, 48046,
     /* 2219558 */     GIR_EraseRootFromParent_Done,
     /* 2219559 */   // Label 29369: @2219559
     /* 2219559 */   GIM_Try, /*On fail goto*//*Label 29370*/ GIMT_Encode4(2219604), // Rule ID 48047 //
     /* 2219564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219567 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2219570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2219584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219603 */     // GIR_Coverage, 48047,
     /* 2219603 */     GIR_EraseRootFromParent_Done,
     /* 2219604 */   // Label 29370: @2219604
     /* 2219604 */   GIM_Reject,
     /* 2219605 */ // Label 29368: @2219605
     /* 2219605 */ GIM_Reject,
     /* 2219606 */ // Label 29335: @2219606
     /* 2219606 */ GIM_Try, /*On fail goto*//*Label 29371*/ GIMT_Encode4(2220084),
     /* 2219611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2219614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2219617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219621 */   GIM_Try, /*On fail goto*//*Label 29372*/ GIMT_Encode4(2219710), // Rule ID 59534 //
     /* 2219626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2219629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219641 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2219643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2219656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219660 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2219662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219669 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2219686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2219695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2219699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219709 */     // GIR_Coverage, 59534,
     /* 2219709 */     GIR_EraseRootFromParent_Done,
     /* 2219710 */   // Label 29372: @2219710
     /* 2219710 */   GIM_Try, /*On fail goto*//*Label 29373*/ GIMT_Encode4(2219799), // Rule ID 59535 //
     /* 2219715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2219718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219730 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2219732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2219745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219749 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2219751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219758 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2219775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2219784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2219788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219798 */     // GIR_Coverage, 59535,
     /* 2219798 */     GIR_EraseRootFromParent_Done,
     /* 2219799 */   // Label 29373: @2219799
     /* 2219799 */   GIM_Try, /*On fail goto*//*Label 29374*/ GIMT_Encode4(2219888), // Rule ID 59536 //
     /* 2219804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2219807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219819 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2219821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219838 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2219840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219847 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2219864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2219873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2219877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219887 */     // GIR_Coverage, 59536,
     /* 2219887 */     GIR_EraseRootFromParent_Done,
     /* 2219888 */   // Label 29374: @2219888
     /* 2219888 */   GIM_Try, /*On fail goto*//*Label 29375*/ GIMT_Encode4(2219977), // Rule ID 59537 //
     /* 2219893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2219896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2219900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219908 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2219910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2219919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2219923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219927 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2219929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219934 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2219936 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2219953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2219962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2219966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219976 */     // GIR_Coverage, 59537,
     /* 2219976 */     GIR_EraseRootFromParent_Done,
     /* 2219977 */   // Label 29375: @2219977
     /* 2219977 */   GIM_Try, /*On fail goto*//*Label 29376*/ GIMT_Encode4(2220030), // Rule ID 48058 //
     /* 2219982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219993 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2219996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2220010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220029 */     // GIR_Coverage, 48058,
     /* 2220029 */     GIR_EraseRootFromParent_Done,
     /* 2220030 */   // Label 29376: @2220030
     /* 2220030 */   GIM_Try, /*On fail goto*//*Label 29377*/ GIMT_Encode4(2220083), // Rule ID 48059 //
     /* 2220035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220046 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2220063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220082 */     // GIR_Coverage, 48059,
     /* 2220082 */     GIR_EraseRootFromParent_Done,
     /* 2220083 */   // Label 29377: @2220083
     /* 2220083 */   GIM_Reject,
     /* 2220084 */ // Label 29371: @2220084
     /* 2220084 */ GIM_Reject,
     /* 2220085 */ // Label 29336: @2220085
     /* 2220085 */ GIM_Try, /*On fail goto*//*Label 29378*/ GIMT_Encode4(2220563),
     /* 2220090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2220096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220100 */   GIM_Try, /*On fail goto*//*Label 29379*/ GIMT_Encode4(2220189), // Rule ID 59582 //
     /* 2220105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220120 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220139 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220141 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220148 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220188 */     // GIR_Coverage, 59582,
     /* 2220188 */     GIR_EraseRootFromParent_Done,
     /* 2220189 */   // Label 29379: @2220189
     /* 2220189 */   GIM_Try, /*On fail goto*//*Label 29380*/ GIMT_Encode4(2220278), // Rule ID 59583 //
     /* 2220194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220209 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220228 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220237 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220277 */     // GIR_Coverage, 59583,
     /* 2220277 */     GIR_EraseRootFromParent_Done,
     /* 2220278 */   // Label 29380: @2220278
     /* 2220278 */   GIM_Try, /*On fail goto*//*Label 29381*/ GIMT_Encode4(2220367), // Rule ID 59584 //
     /* 2220283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2220286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220298 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220317 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220326 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220366 */     // GIR_Coverage, 59584,
     /* 2220366 */     GIR_EraseRootFromParent_Done,
     /* 2220367 */   // Label 29381: @2220367
     /* 2220367 */   GIM_Try, /*On fail goto*//*Label 29382*/ GIMT_Encode4(2220456), // Rule ID 59585 //
     /* 2220372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2220375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220387 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220406 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220415 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2220432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220455 */     // GIR_Coverage, 59585,
     /* 2220455 */     GIR_EraseRootFromParent_Done,
     /* 2220456 */   // Label 29382: @2220456
     /* 2220456 */   GIM_Try, /*On fail goto*//*Label 29383*/ GIMT_Encode4(2220509), // Rule ID 48066 //
     /* 2220461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220472 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2220489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220508 */     // GIR_Coverage, 48066,
     /* 2220508 */     GIR_EraseRootFromParent_Done,
     /* 2220509 */   // Label 29383: @2220509
     /* 2220509 */   GIM_Try, /*On fail goto*//*Label 29384*/ GIMT_Encode4(2220562), // Rule ID 48067 //
     /* 2220514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220525 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2220542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220561 */     // GIR_Coverage, 48067,
     /* 2220561 */     GIR_EraseRootFromParent_Done,
     /* 2220562 */   // Label 29384: @2220562
     /* 2220562 */   GIM_Reject,
     /* 2220563 */ // Label 29378: @2220563
     /* 2220563 */ GIM_Reject,
     /* 2220564 */ // Label 29337: @2220564
     /* 2220564 */ GIM_Try, /*On fail goto*//*Label 29385*/ GIMT_Encode4(2221042),
     /* 2220569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2220572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2220575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220579 */   GIM_Try, /*On fail goto*//*Label 29386*/ GIMT_Encode4(2220668), // Rule ID 59622 //
     /* 2220584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220599 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220618 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220627 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2220644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220667 */     // GIR_Coverage, 59622,
     /* 2220667 */     GIR_EraseRootFromParent_Done,
     /* 2220668 */   // Label 29386: @2220668
     /* 2220668 */   GIM_Try, /*On fail goto*//*Label 29387*/ GIMT_Encode4(2220757), // Rule ID 59623 //
     /* 2220673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220688 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2220703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220707 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220716 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2220733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220756 */     // GIR_Coverage, 59623,
     /* 2220756 */     GIR_EraseRootFromParent_Done,
     /* 2220757 */   // Label 29387: @2220757
     /* 2220757 */   GIM_Try, /*On fail goto*//*Label 29388*/ GIMT_Encode4(2220846), // Rule ID 59624 //
     /* 2220762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2220765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220777 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220796 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220805 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2220822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220845 */     // GIR_Coverage, 59624,
     /* 2220845 */     GIR_EraseRootFromParent_Done,
     /* 2220846 */   // Label 29388: @2220846
     /* 2220846 */   GIM_Try, /*On fail goto*//*Label 29389*/ GIMT_Encode4(2220935), // Rule ID 59625 //
     /* 2220851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2220854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2220858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220866 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2220868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2220877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2220881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220885 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2220887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2220894 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2220911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2220920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2220924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220934 */     // GIR_Coverage, 59625,
     /* 2220934 */     GIR_EraseRootFromParent_Done,
     /* 2220935 */   // Label 29389: @2220935
     /* 2220935 */   GIM_Try, /*On fail goto*//*Label 29390*/ GIMT_Encode4(2220988), // Rule ID 48082 //
     /* 2220940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2220943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220951 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2220968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220987 */     // GIR_Coverage, 48082,
     /* 2220987 */     GIR_EraseRootFromParent_Done,
     /* 2220988 */   // Label 29390: @2220988
     /* 2220988 */   GIM_Try, /*On fail goto*//*Label 29391*/ GIMT_Encode4(2221041), // Rule ID 48083 //
     /* 2220993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2220996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221004 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2221007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2221021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221040 */     // GIR_Coverage, 48083,
     /* 2221040 */     GIR_EraseRootFromParent_Done,
     /* 2221041 */   // Label 29391: @2221041
     /* 2221041 */   GIM_Reject,
     /* 2221042 */ // Label 29385: @2221042
     /* 2221042 */ GIM_Reject,
     /* 2221043 */ // Label 29338: @2221043
     /* 2221043 */ GIM_Try, /*On fail goto*//*Label 29392*/ GIMT_Encode4(2221157),
     /* 2221048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2221054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221066 */   GIM_Try, /*On fail goto*//*Label 29393*/ GIMT_Encode4(2221111), // Rule ID 48050 //
     /* 2221071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221074 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2221091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221110 */     // GIR_Coverage, 48050,
     /* 2221110 */     GIR_EraseRootFromParent_Done,
     /* 2221111 */   // Label 29393: @2221111
     /* 2221111 */   GIM_Try, /*On fail goto*//*Label 29394*/ GIMT_Encode4(2221156), // Rule ID 48051 //
     /* 2221116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221119 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2221122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2221136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221155 */     // GIR_Coverage, 48051,
     /* 2221155 */     GIR_EraseRootFromParent_Done,
     /* 2221156 */   // Label 29394: @2221156
     /* 2221156 */   GIM_Reject,
     /* 2221157 */ // Label 29392: @2221157
     /* 2221157 */ GIM_Reject,
     /* 2221158 */ // Label 29339: @2221158
     /* 2221158 */ GIM_Try, /*On fail goto*//*Label 29395*/ GIMT_Encode4(2221636),
     /* 2221163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2221169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221173 */   GIM_Try, /*On fail goto*//*Label 29396*/ GIMT_Encode4(2221262), // Rule ID 59542 //
     /* 2221178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221193 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221212 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221221 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221261 */     // GIR_Coverage, 59542,
     /* 2221261 */     GIR_EraseRootFromParent_Done,
     /* 2221262 */   // Label 29396: @2221262
     /* 2221262 */   GIM_Try, /*On fail goto*//*Label 29397*/ GIMT_Encode4(2221351), // Rule ID 59543 //
     /* 2221267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221282 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221301 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221308 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221310 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221350 */     // GIR_Coverage, 59543,
     /* 2221350 */     GIR_EraseRootFromParent_Done,
     /* 2221351 */   // Label 29397: @2221351
     /* 2221351 */   GIM_Try, /*On fail goto*//*Label 29398*/ GIMT_Encode4(2221440), // Rule ID 59544 //
     /* 2221356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221371 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221390 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221399 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221439 */     // GIR_Coverage, 59544,
     /* 2221439 */     GIR_EraseRootFromParent_Done,
     /* 2221440 */   // Label 29398: @2221440
     /* 2221440 */   GIM_Try, /*On fail goto*//*Label 29399*/ GIMT_Encode4(2221529), // Rule ID 59545 //
     /* 2221445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221460 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2221479 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221488 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2221505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221528 */     // GIR_Coverage, 59545,
     /* 2221528 */     GIR_EraseRootFromParent_Done,
     /* 2221529 */   // Label 29399: @2221529
     /* 2221529 */   GIM_Try, /*On fail goto*//*Label 29400*/ GIMT_Encode4(2221582), // Rule ID 48062 //
     /* 2221534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221545 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2221562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221581 */     // GIR_Coverage, 48062,
     /* 2221581 */     GIR_EraseRootFromParent_Done,
     /* 2221582 */   // Label 29400: @2221582
     /* 2221582 */   GIM_Try, /*On fail goto*//*Label 29401*/ GIMT_Encode4(2221635), // Rule ID 48063 //
     /* 2221587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221598 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2221601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2221615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221634 */     // GIR_Coverage, 48063,
     /* 2221634 */     GIR_EraseRootFromParent_Done,
     /* 2221635 */   // Label 29401: @2221635
     /* 2221635 */   GIM_Reject,
     /* 2221636 */ // Label 29395: @2221636
     /* 2221636 */ GIM_Reject,
     /* 2221637 */ // Label 29340: @2221637
     /* 2221637 */ GIM_Try, /*On fail goto*//*Label 29402*/ GIMT_Encode4(2222115),
     /* 2221642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2221645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2221648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221652 */   GIM_Try, /*On fail goto*//*Label 29403*/ GIMT_Encode4(2221741), // Rule ID 59590 //
     /* 2221657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221672 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221691 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221700 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2221703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221740 */     // GIR_Coverage, 59590,
     /* 2221740 */     GIR_EraseRootFromParent_Done,
     /* 2221741 */   // Label 29403: @2221741
     /* 2221741 */   GIM_Try, /*On fail goto*//*Label 29404*/ GIMT_Encode4(2221830), // Rule ID 59591 //
     /* 2221746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221761 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2221776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221780 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221789 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2221792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221829 */     // GIR_Coverage, 59591,
     /* 2221829 */     GIR_EraseRootFromParent_Done,
     /* 2221830 */   // Label 29404: @2221830
     /* 2221830 */   GIM_Try, /*On fail goto*//*Label 29405*/ GIMT_Encode4(2221919), // Rule ID 59592 //
     /* 2221835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2221838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221850 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221869 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221878 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2221881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221918 */     // GIR_Coverage, 59592,
     /* 2221918 */     GIR_EraseRootFromParent_Done,
     /* 2221919 */   // Label 29405: @2221919
     /* 2221919 */   GIM_Try, /*On fail goto*//*Label 29406*/ GIMT_Encode4(2222008), // Rule ID 59593 //
     /* 2221924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2221927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2221931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221939 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2221941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2221950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2221954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2221958 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2221960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2221967 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2221970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2221984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2221993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2221997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222007 */     // GIR_Coverage, 59593,
     /* 2222007 */     GIR_EraseRootFromParent_Done,
     /* 2222008 */   // Label 29406: @2222008
     /* 2222008 */   GIM_Try, /*On fail goto*//*Label 29407*/ GIMT_Encode4(2222061), // Rule ID 48078 //
     /* 2222013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222024 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2222041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222060 */     // GIR_Coverage, 48078,
     /* 2222060 */     GIR_EraseRootFromParent_Done,
     /* 2222061 */   // Label 29407: @2222061
     /* 2222061 */   GIM_Try, /*On fail goto*//*Label 29408*/ GIMT_Encode4(2222114), // Rule ID 48079 //
     /* 2222066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222077 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2222080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2222094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222113 */     // GIR_Coverage, 48079,
     /* 2222113 */     GIR_EraseRootFromParent_Done,
     /* 2222114 */   // Label 29408: @2222114
     /* 2222114 */   GIM_Reject,
     /* 2222115 */ // Label 29402: @2222115
     /* 2222115 */ GIM_Reject,
     /* 2222116 */ // Label 29341: @2222116
     /* 2222116 */ GIM_Try, /*On fail goto*//*Label 29409*/ GIMT_Encode4(2222594),
     /* 2222121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2222124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2222127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222131 */   GIM_Try, /*On fail goto*//*Label 29410*/ GIMT_Encode4(2222220), // Rule ID 59630 //
     /* 2222136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222151 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222170 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222179 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222219 */     // GIR_Coverage, 59630,
     /* 2222219 */     GIR_EraseRootFromParent_Done,
     /* 2222220 */   // Label 29410: @2222220
     /* 2222220 */   GIM_Try, /*On fail goto*//*Label 29411*/ GIMT_Encode4(2222309), // Rule ID 59631 //
     /* 2222225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222240 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222259 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222261 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222268 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222308 */     // GIR_Coverage, 59631,
     /* 2222308 */     GIR_EraseRootFromParent_Done,
     /* 2222309 */   // Label 29411: @2222309
     /* 2222309 */   GIM_Try, /*On fail goto*//*Label 29412*/ GIMT_Encode4(2222398), // Rule ID 59632 //
     /* 2222314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2222317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222329 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222344 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222348 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222350 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222357 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222397 */     // GIR_Coverage, 59632,
     /* 2222397 */     GIR_EraseRootFromParent_Done,
     /* 2222398 */   // Label 29412: @2222398
     /* 2222398 */   GIM_Try, /*On fail goto*//*Label 29413*/ GIMT_Encode4(2222487), // Rule ID 59633 //
     /* 2222403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2222406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222418 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2222437 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222446 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2222463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222486 */     // GIR_Coverage, 59633,
     /* 2222486 */     GIR_EraseRootFromParent_Done,
     /* 2222487 */   // Label 29413: @2222487
     /* 2222487 */   GIM_Try, /*On fail goto*//*Label 29414*/ GIMT_Encode4(2222540), // Rule ID 48122 //
     /* 2222492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2222495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222503 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2222520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222525 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222539 */     // GIR_Coverage, 48122,
     /* 2222539 */     GIR_EraseRootFromParent_Done,
     /* 2222540 */   // Label 29414: @2222540
     /* 2222540 */   GIM_Try, /*On fail goto*//*Label 29415*/ GIMT_Encode4(2222593), // Rule ID 48123 //
     /* 2222545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2222548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2222556 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2222559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2222573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2222588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222592 */     // GIR_Coverage, 48123,
     /* 2222592 */     GIR_EraseRootFromParent_Done,
     /* 2222593 */   // Label 29415: @2222593
     /* 2222593 */   GIM_Reject,
     /* 2222594 */ // Label 29409: @2222594
     /* 2222594 */ GIM_Reject,
     /* 2222595 */ // Label 29342: @2222595
     /* 2222595 */ GIM_Try, /*On fail goto*//*Label 29416*/ GIMT_Encode4(2222709),
     /* 2222600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2222606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222618 */   GIM_Try, /*On fail goto*//*Label 29417*/ GIMT_Encode4(2222663), // Rule ID 48054 //
     /* 2222623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222626 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2222629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2222643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222662 */     // GIR_Coverage, 48054,
     /* 2222662 */     GIR_EraseRootFromParent_Done,
     /* 2222663 */   // Label 29417: @2222663
     /* 2222663 */   GIM_Try, /*On fail goto*//*Label 29418*/ GIMT_Encode4(2222708), // Rule ID 48055 //
     /* 2222668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222671 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2222674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2222688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222707 */     // GIR_Coverage, 48055,
     /* 2222707 */     GIR_EraseRootFromParent_Done,
     /* 2222708 */   // Label 29418: @2222708
     /* 2222708 */   GIM_Reject,
     /* 2222709 */ // Label 29416: @2222709
     /* 2222709 */ GIM_Reject,
     /* 2222710 */ // Label 29343: @2222710
     /* 2222710 */ GIM_Try, /*On fail goto*//*Label 29419*/ GIMT_Encode4(2223188),
     /* 2222715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2222718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2222721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222725 */   GIM_Try, /*On fail goto*//*Label 29420*/ GIMT_Encode4(2222814), // Rule ID 59550 //
     /* 2222730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2222733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222745 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222764 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222766 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222773 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2222776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222813 */     // GIR_Coverage, 59550,
     /* 2222813 */     GIR_EraseRootFromParent_Done,
     /* 2222814 */   // Label 29420: @2222814
     /* 2222814 */   GIM_Try, /*On fail goto*//*Label 29421*/ GIMT_Encode4(2222903), // Rule ID 59551 //
     /* 2222819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2222822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222834 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2222849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222853 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222862 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2222865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222902 */     // GIR_Coverage, 59551,
     /* 2222902 */     GIR_EraseRootFromParent_Done,
     /* 2222903 */   // Label 29421: @2222903
     /* 2222903 */   GIM_Try, /*On fail goto*//*Label 29422*/ GIMT_Encode4(2222992), // Rule ID 59552 //
     /* 2222908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2222911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2222915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222923 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2222925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2222934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2222938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2222942 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2222944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2222951 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2222954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2222968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2222977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2222981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222991 */     // GIR_Coverage, 59552,
     /* 2222991 */     GIR_EraseRootFromParent_Done,
     /* 2222992 */   // Label 29422: @2222992
     /* 2222992 */   GIM_Try, /*On fail goto*//*Label 29423*/ GIMT_Encode4(2223081), // Rule ID 59553 //
     /* 2222997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223012 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223031 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223040 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2223057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223080 */     // GIR_Coverage, 59553,
     /* 2223080 */     GIR_EraseRootFromParent_Done,
     /* 2223081 */   // Label 29423: @2223081
     /* 2223081 */   GIM_Try, /*On fail goto*//*Label 29424*/ GIMT_Encode4(2223134), // Rule ID 48074 //
     /* 2223086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223097 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2223114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223133 */     // GIR_Coverage, 48074,
     /* 2223133 */     GIR_EraseRootFromParent_Done,
     /* 2223134 */   // Label 29424: @2223134
     /* 2223134 */   GIM_Try, /*On fail goto*//*Label 29425*/ GIMT_Encode4(2223187), // Rule ID 48075 //
     /* 2223139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223150 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2223167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223186 */     // GIR_Coverage, 48075,
     /* 2223186 */     GIR_EraseRootFromParent_Done,
     /* 2223187 */   // Label 29425: @2223187
     /* 2223187 */   GIM_Reject,
     /* 2223188 */ // Label 29419: @2223188
     /* 2223188 */ GIM_Reject,
     /* 2223189 */ // Label 29344: @2223189
     /* 2223189 */ GIM_Try, /*On fail goto*//*Label 29426*/ GIMT_Encode4(2223667),
     /* 2223194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2223200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223204 */   GIM_Try, /*On fail goto*//*Label 29427*/ GIMT_Encode4(2223293), // Rule ID 59598 //
     /* 2223209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223224 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223243 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223245 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223252 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223292 */     // GIR_Coverage, 59598,
     /* 2223292 */     GIR_EraseRootFromParent_Done,
     /* 2223293 */   // Label 29427: @2223293
     /* 2223293 */   GIM_Try, /*On fail goto*//*Label 29428*/ GIMT_Encode4(2223382), // Rule ID 59599 //
     /* 2223298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223313 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223332 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223341 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223381 */     // GIR_Coverage, 59599,
     /* 2223381 */     GIR_EraseRootFromParent_Done,
     /* 2223382 */   // Label 29428: @2223382
     /* 2223382 */   GIM_Try, /*On fail goto*//*Label 29429*/ GIMT_Encode4(2223471), // Rule ID 59600 //
     /* 2223387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2223390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223402 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223421 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223430 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223470 */     // GIR_Coverage, 59600,
     /* 2223470 */     GIR_EraseRootFromParent_Done,
     /* 2223471 */   // Label 29429: @2223471
     /* 2223471 */   GIM_Try, /*On fail goto*//*Label 29430*/ GIMT_Encode4(2223560), // Rule ID 59601 //
     /* 2223476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2223479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223491 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223510 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223519 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2223536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223559 */     // GIR_Coverage, 59601,
     /* 2223559 */     GIR_EraseRootFromParent_Done,
     /* 2223560 */   // Label 29430: @2223560
     /* 2223560 */   GIM_Try, /*On fail goto*//*Label 29431*/ GIMT_Encode4(2223613), // Rule ID 48110 //
     /* 2223565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223576 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2223593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223612 */     // GIR_Coverage, 48110,
     /* 2223612 */     GIR_EraseRootFromParent_Done,
     /* 2223613 */   // Label 29431: @2223613
     /* 2223613 */   GIM_Try, /*On fail goto*//*Label 29432*/ GIMT_Encode4(2223666), // Rule ID 48111 //
     /* 2223618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223629 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2223646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223665 */     // GIR_Coverage, 48111,
     /* 2223665 */     GIR_EraseRootFromParent_Done,
     /* 2223666 */   // Label 29432: @2223666
     /* 2223666 */   GIM_Reject,
     /* 2223667 */ // Label 29426: @2223667
     /* 2223667 */ GIM_Reject,
     /* 2223668 */ // Label 29345: @2223668
     /* 2223668 */ GIM_Try, /*On fail goto*//*Label 29433*/ GIMT_Encode4(2224146),
     /* 2223673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2223676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2223679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2223683 */   GIM_Try, /*On fail goto*//*Label 29434*/ GIMT_Encode4(2223772), // Rule ID 59638 //
     /* 2223688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2223691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223703 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223722 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223731 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2223734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2223748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223771 */     // GIR_Coverage, 59638,
     /* 2223771 */     GIR_EraseRootFromParent_Done,
     /* 2223772 */   // Label 29434: @2223772
     /* 2223772 */   GIM_Try, /*On fail goto*//*Label 29435*/ GIMT_Encode4(2223861), // Rule ID 59639 //
     /* 2223777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2223780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223792 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2223807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223811 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223813 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223820 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2223823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2223837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223860 */     // GIR_Coverage, 59639,
     /* 2223860 */     GIR_EraseRootFromParent_Done,
     /* 2223861 */   // Label 29435: @2223861
     /* 2223861 */   GIM_Try, /*On fail goto*//*Label 29436*/ GIMT_Encode4(2223950), // Rule ID 59640 //
     /* 2223866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2223869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223881 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223900 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223909 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2223912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2223926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2223935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2223939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223949 */     // GIR_Coverage, 59640,
     /* 2223949 */     GIR_EraseRootFromParent_Done,
     /* 2223950 */   // Label 29436: @2223950
     /* 2223950 */   GIM_Try, /*On fail goto*//*Label 29437*/ GIMT_Encode4(2224039), // Rule ID 59641 //
     /* 2223955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2223958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2223962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223970 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2223972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2223981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2223985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223989 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2223991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2223998 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224038 */     // GIR_Coverage, 59641,
     /* 2224038 */     GIR_EraseRootFromParent_Done,
     /* 2224039 */   // Label 29437: @2224039
     /* 2224039 */   GIM_Try, /*On fail goto*//*Label 29438*/ GIMT_Encode4(2224092), // Rule ID 48126 //
     /* 2224044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2224047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224055 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2224072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224091 */     // GIR_Coverage, 48126,
     /* 2224091 */     GIR_EraseRootFromParent_Done,
     /* 2224092 */   // Label 29438: @2224092
     /* 2224092 */   GIM_Try, /*On fail goto*//*Label 29439*/ GIMT_Encode4(2224145), // Rule ID 48127 //
     /* 2224097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2224100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224108 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2224125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224144 */     // GIR_Coverage, 48127,
     /* 2224144 */     GIR_EraseRootFromParent_Done,
     /* 2224145 */   // Label 29439: @2224145
     /* 2224145 */   GIM_Reject,
     /* 2224146 */ // Label 29433: @2224146
     /* 2224146 */ GIM_Reject,
     /* 2224147 */ // Label 29346: @2224147
     /* 2224147 */ GIM_Try, /*On fail goto*//*Label 29440*/ GIMT_Encode4(2224261),
     /* 2224152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2224158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224170 */   GIM_Try, /*On fail goto*//*Label 29441*/ GIMT_Encode4(2224215), // Rule ID 48070 //
     /* 2224175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224178 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224214 */     // GIR_Coverage, 48070,
     /* 2224214 */     GIR_EraseRootFromParent_Done,
     /* 2224215 */   // Label 29441: @2224215
     /* 2224215 */   GIM_Try, /*On fail goto*//*Label 29442*/ GIMT_Encode4(2224260), // Rule ID 48071 //
     /* 2224220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224223 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2224240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224259 */     // GIR_Coverage, 48071,
     /* 2224259 */     GIR_EraseRootFromParent_Done,
     /* 2224260 */   // Label 29442: @2224260
     /* 2224260 */   GIM_Reject,
     /* 2224261 */ // Label 29440: @2224261
     /* 2224261 */ GIM_Reject,
     /* 2224262 */ // Label 29347: @2224262
     /* 2224262 */ GIM_Try, /*On fail goto*//*Label 29443*/ GIMT_Encode4(2224740),
     /* 2224267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2224273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224277 */   GIM_Try, /*On fail goto*//*Label 29444*/ GIMT_Encode4(2224366), // Rule ID 59558 //
     /* 2224282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224297 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224316 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224325 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224365 */     // GIR_Coverage, 59558,
     /* 2224365 */     GIR_EraseRootFromParent_Done,
     /* 2224366 */   // Label 29444: @2224366
     /* 2224366 */   GIM_Try, /*On fail goto*//*Label 29445*/ GIMT_Encode4(2224455), // Rule ID 59559 //
     /* 2224371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224386 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224405 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224414 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224454 */     // GIR_Coverage, 59559,
     /* 2224454 */     GIR_EraseRootFromParent_Done,
     /* 2224455 */   // Label 29445: @2224455
     /* 2224455 */   GIM_Try, /*On fail goto*//*Label 29446*/ GIMT_Encode4(2224544), // Rule ID 59560 //
     /* 2224460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224475 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224494 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224503 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224543 */     // GIR_Coverage, 59560,
     /* 2224543 */     GIR_EraseRootFromParent_Done,
     /* 2224544 */   // Label 29446: @2224544
     /* 2224544 */   GIM_Try, /*On fail goto*//*Label 29447*/ GIMT_Encode4(2224633), // Rule ID 59561 //
     /* 2224549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224564 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224583 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224592 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2224609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224632 */     // GIR_Coverage, 59561,
     /* 2224632 */     GIR_EraseRootFromParent_Done,
     /* 2224633 */   // Label 29447: @2224633
     /* 2224633 */   GIM_Try, /*On fail goto*//*Label 29448*/ GIMT_Encode4(2224686), // Rule ID 48098 //
     /* 2224638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224649 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2224666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224685 */     // GIR_Coverage, 48098,
     /* 2224685 */     GIR_EraseRootFromParent_Done,
     /* 2224686 */   // Label 29448: @2224686
     /* 2224686 */   GIM_Try, /*On fail goto*//*Label 29449*/ GIMT_Encode4(2224739), // Rule ID 48099 //
     /* 2224691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224702 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2224719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224738 */     // GIR_Coverage, 48099,
     /* 2224738 */     GIR_EraseRootFromParent_Done,
     /* 2224739 */   // Label 29449: @2224739
     /* 2224739 */   GIM_Reject,
     /* 2224740 */ // Label 29443: @2224740
     /* 2224740 */ GIM_Reject,
     /* 2224741 */ // Label 29348: @2224741
     /* 2224741 */ GIM_Try, /*On fail goto*//*Label 29450*/ GIMT_Encode4(2225219),
     /* 2224746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2224749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2224752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224756 */   GIM_Try, /*On fail goto*//*Label 29451*/ GIMT_Encode4(2224845), // Rule ID 59606 //
     /* 2224761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224776 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224791 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224795 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224804 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2224807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224844 */     // GIR_Coverage, 59606,
     /* 2224844 */     GIR_EraseRootFromParent_Done,
     /* 2224845 */   // Label 29451: @2224845
     /* 2224845 */   GIM_Try, /*On fail goto*//*Label 29452*/ GIMT_Encode4(2224934), // Rule ID 59607 //
     /* 2224850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2224853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224865 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2224880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224884 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224893 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2224896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2224919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2224923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224933 */     // GIR_Coverage, 59607,
     /* 2224933 */     GIR_EraseRootFromParent_Done,
     /* 2224934 */   // Label 29452: @2224934
     /* 2224934 */   GIM_Try, /*On fail goto*//*Label 29453*/ GIMT_Encode4(2225023), // Rule ID 59608 //
     /* 2224939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2224942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2224946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224954 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2224956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2224965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2224969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224973 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2224975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2224982 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2224985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2224999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225022 */     // GIR_Coverage, 59608,
     /* 2225022 */     GIR_EraseRootFromParent_Done,
     /* 2225023 */   // Label 29453: @2225023
     /* 2225023 */   GIM_Try, /*On fail goto*//*Label 29454*/ GIMT_Encode4(2225112), // Rule ID 59609 //
     /* 2225028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225043 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2225062 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225071 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225111 */     // GIR_Coverage, 59609,
     /* 2225111 */     GIR_EraseRootFromParent_Done,
     /* 2225112 */   // Label 29454: @2225112
     /* 2225112 */   GIM_Try, /*On fail goto*//*Label 29455*/ GIMT_Encode4(2225165), // Rule ID 48114 //
     /* 2225117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225128 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2225145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225164 */     // GIR_Coverage, 48114,
     /* 2225164 */     GIR_EraseRootFromParent_Done,
     /* 2225165 */   // Label 29455: @2225165
     /* 2225165 */   GIM_Try, /*On fail goto*//*Label 29456*/ GIMT_Encode4(2225218), // Rule ID 48115 //
     /* 2225170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225181 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2225184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2225198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225217 */     // GIR_Coverage, 48115,
     /* 2225217 */     GIR_EraseRootFromParent_Done,
     /* 2225218 */   // Label 29456: @2225218
     /* 2225218 */   GIM_Reject,
     /* 2225219 */ // Label 29450: @2225219
     /* 2225219 */ GIM_Reject,
     /* 2225220 */ // Label 29349: @2225220
     /* 2225220 */ GIM_Try, /*On fail goto*//*Label 29457*/ GIMT_Encode4(2225698),
     /* 2225225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2225228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2225231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225235 */   GIM_Try, /*On fail goto*//*Label 29458*/ GIMT_Encode4(2225324), // Rule ID 59646 //
     /* 2225240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2225243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225255 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225274 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225283 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225323 */     // GIR_Coverage, 59646,
     /* 2225323 */     GIR_EraseRootFromParent_Done,
     /* 2225324 */   // Label 29458: @2225324
     /* 2225324 */   GIM_Try, /*On fail goto*//*Label 29459*/ GIMT_Encode4(2225413), // Rule ID 59647 //
     /* 2225329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2225332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225344 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225363 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225372 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225412 */     // GIR_Coverage, 59647,
     /* 2225412 */     GIR_EraseRootFromParent_Done,
     /* 2225413 */   // Label 29459: @2225413
     /* 2225413 */   GIM_Try, /*On fail goto*//*Label 29460*/ GIMT_Encode4(2225502), // Rule ID 59648 //
     /* 2225418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2225421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225433 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225452 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225454 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225461 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225501 */     // GIR_Coverage, 59648,
     /* 2225501 */     GIR_EraseRootFromParent_Done,
     /* 2225502 */   // Label 29460: @2225502
     /* 2225502 */   GIM_Try, /*On fail goto*//*Label 29461*/ GIMT_Encode4(2225591), // Rule ID 59649 //
     /* 2225507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2225510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225522 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2225541 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225550 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2225567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2225586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225590 */     // GIR_Coverage, 59649,
     /* 2225590 */     GIR_EraseRootFromParent_Done,
     /* 2225591 */   // Label 29461: @2225591
     /* 2225591 */   GIM_Try, /*On fail goto*//*Label 29462*/ GIMT_Encode4(2225644), // Rule ID 48130 //
     /* 2225596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2225599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225607 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2225624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225643 */     // GIR_Coverage, 48130,
     /* 2225643 */     GIR_EraseRootFromParent_Done,
     /* 2225644 */   // Label 29462: @2225644
     /* 2225644 */   GIM_Try, /*On fail goto*//*Label 29463*/ GIMT_Encode4(2225697), // Rule ID 48131 //
     /* 2225649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2225652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225660 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2225663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2225677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2225692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225696 */     // GIR_Coverage, 48131,
     /* 2225696 */     GIR_EraseRootFromParent_Done,
     /* 2225697 */   // Label 29463: @2225697
     /* 2225697 */   GIM_Reject,
     /* 2225698 */ // Label 29457: @2225698
     /* 2225698 */ GIM_Reject,
     /* 2225699 */ // Label 29350: @2225699
     /* 2225699 */ GIM_Try, /*On fail goto*//*Label 29464*/ GIMT_Encode4(2225813),
     /* 2225704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2225710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225718 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225722 */   GIM_Try, /*On fail goto*//*Label 29465*/ GIMT_Encode4(2225767), // Rule ID 48086 //
     /* 2225727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225730 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2225733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2225747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225766 */     // GIR_Coverage, 48086,
     /* 2225766 */     GIR_EraseRootFromParent_Done,
     /* 2225767 */   // Label 29465: @2225767
     /* 2225767 */   GIM_Try, /*On fail goto*//*Label 29466*/ GIMT_Encode4(2225812), // Rule ID 48087 //
     /* 2225772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225775 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2225778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2225792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225811 */     // GIR_Coverage, 48087,
     /* 2225811 */     GIR_EraseRootFromParent_Done,
     /* 2225812 */   // Label 29466: @2225812
     /* 2225812 */   GIM_Reject,
     /* 2225813 */ // Label 29464: @2225813
     /* 2225813 */ GIM_Reject,
     /* 2225814 */ // Label 29351: @2225814
     /* 2225814 */ GIM_Try, /*On fail goto*//*Label 29467*/ GIMT_Encode4(2226292),
     /* 2225819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2225822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2225825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225829 */   GIM_Try, /*On fail goto*//*Label 29468*/ GIMT_Encode4(2225918), // Rule ID 59566 //
     /* 2225834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2225837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225849 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225868 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225870 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225877 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2225880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225917 */     // GIR_Coverage, 59566,
     /* 2225917 */     GIR_EraseRootFromParent_Done,
     /* 2225918 */   // Label 29468: @2225918
     /* 2225918 */   GIM_Try, /*On fail goto*//*Label 29469*/ GIMT_Encode4(2226007), // Rule ID 59567 //
     /* 2225923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2225926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2225930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2225934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225938 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2225940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2225949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2225953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2225957 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2225959 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2225964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2225966 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2225969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2225983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2225992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2225996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226006 */     // GIR_Coverage, 59567,
     /* 2226006 */     GIR_EraseRootFromParent_Done,
     /* 2226007 */   // Label 29469: @2226007
     /* 2226007 */   GIM_Try, /*On fail goto*//*Label 29470*/ GIMT_Encode4(2226096), // Rule ID 59568 //
     /* 2226012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226027 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226046 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226055 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226095 */     // GIR_Coverage, 59568,
     /* 2226095 */     GIR_EraseRootFromParent_Done,
     /* 2226096 */   // Label 29470: @2226096
     /* 2226096 */   GIM_Try, /*On fail goto*//*Label 29471*/ GIMT_Encode4(2226185), // Rule ID 59569 //
     /* 2226101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226116 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2226135 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2226142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226144 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2226161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226184 */     // GIR_Coverage, 59569,
     /* 2226184 */     GIR_EraseRootFromParent_Done,
     /* 2226185 */   // Label 29471: @2226185
     /* 2226185 */   GIM_Try, /*On fail goto*//*Label 29472*/ GIMT_Encode4(2226238), // Rule ID 48102 //
     /* 2226190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226201 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226237 */     // GIR_Coverage, 48102,
     /* 2226237 */     GIR_EraseRootFromParent_Done,
     /* 2226238 */   // Label 29472: @2226238
     /* 2226238 */   GIM_Try, /*On fail goto*//*Label 29473*/ GIMT_Encode4(2226291), // Rule ID 48103 //
     /* 2226243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226254 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2226257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226290 */     // GIR_Coverage, 48103,
     /* 2226290 */     GIR_EraseRootFromParent_Done,
     /* 2226291 */   // Label 29473: @2226291
     /* 2226291 */   GIM_Reject,
     /* 2226292 */ // Label 29467: @2226292
     /* 2226292 */ GIM_Reject,
     /* 2226293 */ // Label 29352: @2226293
     /* 2226293 */ GIM_Try, /*On fail goto*//*Label 29474*/ GIMT_Encode4(2226771),
     /* 2226298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2226301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2226304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226308 */   GIM_Try, /*On fail goto*//*Label 29475*/ GIMT_Encode4(2226397), // Rule ID 59614 //
     /* 2226313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226328 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226347 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226356 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226396 */     // GIR_Coverage, 59614,
     /* 2226396 */     GIR_EraseRootFromParent_Done,
     /* 2226397 */   // Label 29475: @2226397
     /* 2226397 */   GIM_Try, /*On fail goto*//*Label 29476*/ GIMT_Encode4(2226486), // Rule ID 59615 //
     /* 2226402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226417 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226436 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226445 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226485 */     // GIR_Coverage, 59615,
     /* 2226485 */     GIR_EraseRootFromParent_Done,
     /* 2226486 */   // Label 29476: @2226486
     /* 2226486 */   GIM_Try, /*On fail goto*//*Label 29477*/ GIMT_Encode4(2226575), // Rule ID 59616 //
     /* 2226491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226506 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226525 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226534 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226574 */     // GIR_Coverage, 59616,
     /* 2226574 */     GIR_EraseRootFromParent_Done,
     /* 2226575 */   // Label 29477: @2226575
     /* 2226575 */   GIM_Try, /*On fail goto*//*Label 29478*/ GIMT_Encode4(2226664), // Rule ID 59617 //
     /* 2226580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226595 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2226614 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226623 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2226659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226663 */     // GIR_Coverage, 59617,
     /* 2226663 */     GIR_EraseRootFromParent_Done,
     /* 2226664 */   // Label 29478: @2226664
     /* 2226664 */   GIM_Try, /*On fail goto*//*Label 29479*/ GIMT_Encode4(2226717), // Rule ID 48118 //
     /* 2226669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226680 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2226697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226716 */     // GIR_Coverage, 48118,
     /* 2226716 */     GIR_EraseRootFromParent_Done,
     /* 2226717 */   // Label 29479: @2226717
     /* 2226717 */   GIM_Try, /*On fail goto*//*Label 29480*/ GIMT_Encode4(2226770), // Rule ID 48119 //
     /* 2226722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226733 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2226736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2226750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2226765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226769 */     // GIR_Coverage, 48119,
     /* 2226769 */     GIR_EraseRootFromParent_Done,
     /* 2226770 */   // Label 29480: @2226770
     /* 2226770 */   GIM_Reject,
     /* 2226771 */ // Label 29474: @2226771
     /* 2226771 */ GIM_Reject,
     /* 2226772 */ // Label 29353: @2226772
     /* 2226772 */ GIM_Try, /*On fail goto*//*Label 29481*/ GIMT_Encode4(2226886),
     /* 2226777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2226780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2226783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226795 */   GIM_Try, /*On fail goto*//*Label 29482*/ GIMT_Encode4(2226840), // Rule ID 48090 //
     /* 2226800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2226803 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2226806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226839 */     // GIR_Coverage, 48090,
     /* 2226839 */     GIR_EraseRootFromParent_Done,
     /* 2226840 */   // Label 29482: @2226840
     /* 2226840 */   GIM_Try, /*On fail goto*//*Label 29483*/ GIMT_Encode4(2226885), // Rule ID 48091 //
     /* 2226845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2226848 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2226848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2226851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2226865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2226872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2226874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226884 */     // GIR_Coverage, 48091,
     /* 2226884 */     GIR_EraseRootFromParent_Done,
     /* 2226885 */   // Label 29483: @2226885
     /* 2226885 */   GIM_Reject,
     /* 2226886 */ // Label 29481: @2226886
     /* 2226886 */ GIM_Reject,
     /* 2226887 */ // Label 29354: @2226887
     /* 2226887 */ GIM_Try, /*On fail goto*//*Label 29484*/ GIMT_Encode4(2227365),
     /* 2226892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2226895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2226898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2226902 */   GIM_Try, /*On fail goto*//*Label 29485*/ GIMT_Encode4(2226991), // Rule ID 59574 //
     /* 2226907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2226910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2226914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2226918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2226922 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2226924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2226933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2226937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2226941 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2226943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2226948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2226950 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2226950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2226953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2226957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2226967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2226976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2226980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2226983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2226989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2226990 */     // GIR_Coverage, 59574,
     /* 2226990 */     GIR_EraseRootFromParent_Done,
     /* 2226991 */   // Label 29485: @2226991
     /* 2226991 */   GIM_Try, /*On fail goto*//*Label 29486*/ GIMT_Encode4(2227080), // Rule ID 59575 //
     /* 2226996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2226999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227011 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2227026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227030 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227039 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227079 */     // GIR_Coverage, 59575,
     /* 2227079 */     GIR_EraseRootFromParent_Done,
     /* 2227080 */   // Label 29486: @2227080
     /* 2227080 */   GIM_Try, /*On fail goto*//*Label 29487*/ GIMT_Encode4(2227169), // Rule ID 59576 //
     /* 2227085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2227088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227100 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227119 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227128 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227168 */     // GIR_Coverage, 59576,
     /* 2227168 */     GIR_EraseRootFromParent_Done,
     /* 2227169 */   // Label 29487: @2227169
     /* 2227169 */   GIM_Try, /*On fail goto*//*Label 29488*/ GIMT_Encode4(2227258), // Rule ID 59577 //
     /* 2227174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2227177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227189 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2227191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2227204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2227208 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2227210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2227215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227217 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2227234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2227243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2227247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227257 */     // GIR_Coverage, 59577,
     /* 2227257 */     GIR_EraseRootFromParent_Done,
     /* 2227258 */   // Label 29488: @2227258
     /* 2227258 */   GIM_Try, /*On fail goto*//*Label 29489*/ GIMT_Encode4(2227311), // Rule ID 48106 //
     /* 2227263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227274 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227310 */     // GIR_Coverage, 48106,
     /* 2227310 */     GIR_EraseRootFromParent_Done,
     /* 2227311 */   // Label 29489: @2227311
     /* 2227311 */   GIM_Try, /*On fail goto*//*Label 29490*/ GIMT_Encode4(2227364), // Rule ID 48107 //
     /* 2227316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227327 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2227330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2227359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227363 */     // GIR_Coverage, 48107,
     /* 2227363 */     GIR_EraseRootFromParent_Done,
     /* 2227364 */   // Label 29490: @2227364
     /* 2227364 */   GIM_Reject,
     /* 2227365 */ // Label 29484: @2227365
     /* 2227365 */ GIM_Reject,
     /* 2227366 */ // Label 29355: @2227366
     /* 2227366 */ GIM_Try, /*On fail goto*//*Label 29491*/ GIMT_Encode4(2227480),
     /* 2227371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2227374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2227377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2227389 */   GIM_Try, /*On fail goto*//*Label 29492*/ GIMT_Encode4(2227434), // Rule ID 48094 //
     /* 2227394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2227397 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2227397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2227400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227433 */     // GIR_Coverage, 48094,
     /* 2227433 */     GIR_EraseRootFromParent_Done,
     /* 2227434 */   // Label 29492: @2227434
     /* 2227434 */   GIM_Try, /*On fail goto*//*Label 29493*/ GIMT_Encode4(2227479), // Rule ID 48095 //
     /* 2227439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2227442 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2227442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2227445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2227449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2227459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2227468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2227471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2227477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227478 */     // GIR_Coverage, 48095,
     /* 2227478 */     GIR_EraseRootFromParent_Done,
     /* 2227479 */   // Label 29493: @2227479
     /* 2227479 */   GIM_Reject,
     /* 2227480 */ // Label 29491: @2227480
     /* 2227480 */ GIM_Reject,
     /* 2227481 */ // Label 29356: @2227481
     /* 2227481 */ GIM_Reject,
     /* 2227482 */ // Label 44: @2227482
     /* 2227482 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29518*/ GIMT_Encode4(2230512),
     /* 2227493 */ /*GILLT_s32*//*Label 29494*/ GIMT_Encode4(2227617),
     /* 2227497 */ /*GILLT_s64*//*Label 29495*/ GIMT_Encode4(2227701), GIMT_Encode4(0),
     /* 2227505 */ /*GILLT_nxv1s8*//*Label 29496*/ GIMT_Encode4(2227982),
     /* 2227509 */ /*GILLT_nxv1s16*//*Label 29497*/ GIMT_Encode4(2228097),
     /* 2227513 */ /*GILLT_nxv1s32*//*Label 29498*/ GIMT_Encode4(2228212),
     /* 2227517 */ /*GILLT_nxv1s64*//*Label 29499*/ GIMT_Encode4(2228327), GIMT_Encode4(0),
     /* 2227525 */ /*GILLT_nxv2s8*//*Label 29500*/ GIMT_Encode4(2228442),
     /* 2227529 */ /*GILLT_nxv2s16*//*Label 29501*/ GIMT_Encode4(2228557),
     /* 2227533 */ /*GILLT_nxv2s32*//*Label 29502*/ GIMT_Encode4(2228672),
     /* 2227537 */ /*GILLT_nxv2s64*//*Label 29503*/ GIMT_Encode4(2228787), GIMT_Encode4(0),
     /* 2227545 */ /*GILLT_nxv4s8*//*Label 29504*/ GIMT_Encode4(2228902),
     /* 2227549 */ /*GILLT_nxv4s16*//*Label 29505*/ GIMT_Encode4(2229017),
     /* 2227553 */ /*GILLT_nxv4s32*//*Label 29506*/ GIMT_Encode4(2229132),
     /* 2227557 */ /*GILLT_nxv4s64*//*Label 29507*/ GIMT_Encode4(2229247), GIMT_Encode4(0),
     /* 2227565 */ /*GILLT_nxv8s8*//*Label 29508*/ GIMT_Encode4(2229362),
     /* 2227569 */ /*GILLT_nxv8s16*//*Label 29509*/ GIMT_Encode4(2229477),
     /* 2227573 */ /*GILLT_nxv8s32*//*Label 29510*/ GIMT_Encode4(2229592),
     /* 2227577 */ /*GILLT_nxv8s64*//*Label 29511*/ GIMT_Encode4(2229707), GIMT_Encode4(0),
     /* 2227585 */ /*GILLT_nxv16s8*//*Label 29512*/ GIMT_Encode4(2229822),
     /* 2227589 */ /*GILLT_nxv16s16*//*Label 29513*/ GIMT_Encode4(2229937),
     /* 2227593 */ /*GILLT_nxv16s32*//*Label 29514*/ GIMT_Encode4(2230052), GIMT_Encode4(0),
     /* 2227601 */ /*GILLT_nxv32s8*//*Label 29515*/ GIMT_Encode4(2230167),
     /* 2227605 */ /*GILLT_nxv32s16*//*Label 29516*/ GIMT_Encode4(2230282), GIMT_Encode4(0),
     /* 2227613 */ /*GILLT_nxv64s8*//*Label 29517*/ GIMT_Encode4(2230397),
     /* 2227617 */ // Label 29494: @2227617
     /* 2227617 */ GIM_Try, /*On fail goto*//*Label 29519*/ GIMT_Encode4(2227700),
     /* 2227622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2227625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227636 */   GIM_Try, /*On fail goto*//*Label 29520*/ GIMT_Encode4(2227670), // Rule ID 99 //
     /* 2227641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2227648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2227656 */     // MIs[1] Operand 1
     /* 2227656 */     // No operand predicates
     /* 2227656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2227658 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2227658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2227661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2227668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227669 */     // GIR_Coverage, 99,
     /* 2227669 */     GIR_EraseRootFromParent_Done,
     /* 2227670 */   // Label 29520: @2227670
     /* 2227670 */   GIM_Try, /*On fail goto*//*Label 29521*/ GIMT_Encode4(2227699), // Rule ID 113 //
     /* 2227675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2227685 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2227685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2227688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2227697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227698 */     // GIR_Coverage, 113,
     /* 2227698 */     GIR_EraseRootFromParent_Done,
     /* 2227699 */   // Label 29521: @2227699
     /* 2227699 */   GIM_Reject,
     /* 2227700 */ // Label 29519: @2227700
     /* 2227700 */ GIM_Reject,
     /* 2227701 */ // Label 29495: @2227701
     /* 2227701 */ GIM_Try, /*On fail goto*//*Label 29522*/ GIMT_Encode4(2227981),
     /* 2227706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2227712 */   GIM_Try, /*On fail goto*//*Label 29523*/ GIMT_Encode4(2227784), // Rule ID 263 //
     /* 2227717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2227720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2227732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2227740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227745 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2227756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227764 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2227768 */     // MIs[2] Operand 1
     /* 2227768 */     // No operand predicates
     /* 2227768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227770 */     // (srl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2227770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /* 2227773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2227779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2227782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227783 */     // GIR_Coverage, 263,
     /* 2227783 */     GIR_EraseRootFromParent_Done,
     /* 2227784 */   // Label 29523: @2227784
     /* 2227784 */   GIM_Try, /*On fail goto*//*Label 29524*/ GIMT_Encode4(2227829), // Rule ID 62568 //
     /* 2227789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2227792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2227804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2227812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10033),
     /* 2227816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2227818 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })<<P:Predicate_anonymous_10033>>  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2227818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2227821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2227827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227828 */     // GIR_Coverage, 62568,
     /* 2227828 */     GIR_EraseRootFromParent_Done,
     /* 2227829 */   // Label 29524: @2227829
     /* 2227829 */   GIM_Try, /*On fail goto*//*Label 29525*/ GIMT_Encode4(2227901), // Rule ID 275 //
     /* 2227834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2227837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2227845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2227849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2227853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227858 */     // MIs[1] Operand 2
     /* 2227858 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2227869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2227873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227877 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2227881 */     // MIs[2] Operand 1
     /* 2227881 */     // No operand predicates
     /* 2227881 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10033),
     /* 2227885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2227887 */     // (srl:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)<<P:Predicate_anonymous_10033>>  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2227887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2227890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2227896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2227899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227900 */     // GIR_Coverage, 275,
     /* 2227900 */     GIR_EraseRootFromParent_Done,
     /* 2227901 */   // Label 29525: @2227901
     /* 2227901 */   GIM_Try, /*On fail goto*//*Label 29526*/ GIMT_Encode4(2227943), // Rule ID 98 //
     /* 2227906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2227909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2227921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2227929 */     // MIs[1] Operand 1
     /* 2227929 */     // No operand predicates
     /* 2227929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2227931 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2227931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2227934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2227941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227942 */     // GIR_Coverage, 98,
     /* 2227942 */     GIR_EraseRootFromParent_Done,
     /* 2227943 */   // Label 29526: @2227943
     /* 2227943 */   GIM_Try, /*On fail goto*//*Label 29527*/ GIMT_Encode4(2227980), // Rule ID 112 //
     /* 2227948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2227951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2227966 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2227966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2227969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2227973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2227978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2227979 */     // GIR_Coverage, 112,
     /* 2227979 */     GIR_EraseRootFromParent_Done,
     /* 2227980 */   // Label 29527: @2227980
     /* 2227980 */   GIM_Reject,
     /* 2227981 */ // Label 29522: @2227981
     /* 2227981 */ GIM_Reject,
     /* 2227982 */ // Label 29496: @2227982
     /* 2227982 */ GIM_Try, /*On fail goto*//*Label 29528*/ GIMT_Encode4(2228096),
     /* 2227987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2227990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2227993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2227997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228005 */   GIM_Try, /*On fail goto*//*Label 29529*/ GIMT_Encode4(2228050), // Rule ID 48178 //
     /* 2228010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228013 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2228016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2228030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228049 */     // GIR_Coverage, 48178,
     /* 2228049 */     GIR_EraseRootFromParent_Done,
     /* 2228050 */   // Label 29529: @2228050
     /* 2228050 */   GIM_Try, /*On fail goto*//*Label 29530*/ GIMT_Encode4(2228095), // Rule ID 48179 //
     /* 2228055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228058 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2228061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2228075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228094 */     // GIR_Coverage, 48179,
     /* 2228094 */     GIR_EraseRootFromParent_Done,
     /* 2228095 */   // Label 29530: @2228095
     /* 2228095 */   GIM_Reject,
     /* 2228096 */ // Label 29528: @2228096
     /* 2228096 */ GIM_Reject,
     /* 2228097 */ // Label 29497: @2228097
     /* 2228097 */ GIM_Try, /*On fail goto*//*Label 29531*/ GIMT_Encode4(2228211),
     /* 2228102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2228105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2228108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228120 */   GIM_Try, /*On fail goto*//*Label 29532*/ GIMT_Encode4(2228165), // Rule ID 48190 //
     /* 2228125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228128 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2228131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228164 */     // GIR_Coverage, 48190,
     /* 2228164 */     GIR_EraseRootFromParent_Done,
     /* 2228165 */   // Label 29532: @2228165
     /* 2228165 */   GIM_Try, /*On fail goto*//*Label 29533*/ GIMT_Encode4(2228210), // Rule ID 48191 //
     /* 2228170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228173 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2228176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228209 */     // GIR_Coverage, 48191,
     /* 2228209 */     GIR_EraseRootFromParent_Done,
     /* 2228210 */   // Label 29533: @2228210
     /* 2228210 */   GIM_Reject,
     /* 2228211 */ // Label 29531: @2228211
     /* 2228211 */ GIM_Reject,
     /* 2228212 */ // Label 29498: @2228212
     /* 2228212 */ GIM_Try, /*On fail goto*//*Label 29534*/ GIMT_Encode4(2228326),
     /* 2228217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2228220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2228223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228235 */   GIM_Try, /*On fail goto*//*Label 29535*/ GIMT_Encode4(2228280), // Rule ID 48198 //
     /* 2228240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228243 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2228246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228279 */     // GIR_Coverage, 48198,
     /* 2228279 */     GIR_EraseRootFromParent_Done,
     /* 2228280 */   // Label 29535: @2228280
     /* 2228280 */   GIM_Try, /*On fail goto*//*Label 29536*/ GIMT_Encode4(2228325), // Rule ID 48199 //
     /* 2228285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228288 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2228291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228324 */     // GIR_Coverage, 48199,
     /* 2228324 */     GIR_EraseRootFromParent_Done,
     /* 2228325 */   // Label 29536: @2228325
     /* 2228325 */   GIM_Reject,
     /* 2228326 */ // Label 29534: @2228326
     /* 2228326 */ GIM_Reject,
     /* 2228327 */ // Label 29499: @2228327
     /* 2228327 */ GIM_Try, /*On fail goto*//*Label 29537*/ GIMT_Encode4(2228441),
     /* 2228332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2228335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2228338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228350 */   GIM_Try, /*On fail goto*//*Label 29538*/ GIMT_Encode4(2228395), // Rule ID 48214 //
     /* 2228355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2228358 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228394 */     // GIR_Coverage, 48214,
     /* 2228394 */     GIR_EraseRootFromParent_Done,
     /* 2228395 */   // Label 29538: @2228395
     /* 2228395 */   GIM_Try, /*On fail goto*//*Label 29539*/ GIMT_Encode4(2228440), // Rule ID 48215 //
     /* 2228400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2228403 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2228406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228439 */     // GIR_Coverage, 48215,
     /* 2228439 */     GIR_EraseRootFromParent_Done,
     /* 2228440 */   // Label 29539: @2228440
     /* 2228440 */   GIM_Reject,
     /* 2228441 */ // Label 29537: @2228441
     /* 2228441 */ GIM_Reject,
     /* 2228442 */ // Label 29500: @2228442
     /* 2228442 */ GIM_Try, /*On fail goto*//*Label 29540*/ GIMT_Encode4(2228556),
     /* 2228447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2228450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2228453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228465 */   GIM_Try, /*On fail goto*//*Label 29541*/ GIMT_Encode4(2228510), // Rule ID 48182 //
     /* 2228470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228473 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2228476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228509 */     // GIR_Coverage, 48182,
     /* 2228509 */     GIR_EraseRootFromParent_Done,
     /* 2228510 */   // Label 29541: @2228510
     /* 2228510 */   GIM_Try, /*On fail goto*//*Label 29542*/ GIMT_Encode4(2228555), // Rule ID 48183 //
     /* 2228515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228518 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2228521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2228535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228554 */     // GIR_Coverage, 48183,
     /* 2228554 */     GIR_EraseRootFromParent_Done,
     /* 2228555 */   // Label 29542: @2228555
     /* 2228555 */   GIM_Reject,
     /* 2228556 */ // Label 29540: @2228556
     /* 2228556 */ GIM_Reject,
     /* 2228557 */ // Label 29501: @2228557
     /* 2228557 */ GIM_Try, /*On fail goto*//*Label 29543*/ GIMT_Encode4(2228671),
     /* 2228562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2228565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2228568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228580 */   GIM_Try, /*On fail goto*//*Label 29544*/ GIMT_Encode4(2228625), // Rule ID 48194 //
     /* 2228585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228588 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228624 */     // GIR_Coverage, 48194,
     /* 2228624 */     GIR_EraseRootFromParent_Done,
     /* 2228625 */   // Label 29544: @2228625
     /* 2228625 */   GIM_Try, /*On fail goto*//*Label 29545*/ GIMT_Encode4(2228670), // Rule ID 48195 //
     /* 2228630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228633 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2228636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2228665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228669 */     // GIR_Coverage, 48195,
     /* 2228669 */     GIR_EraseRootFromParent_Done,
     /* 2228670 */   // Label 29545: @2228670
     /* 2228670 */   GIM_Reject,
     /* 2228671 */ // Label 29543: @2228671
     /* 2228671 */ GIM_Reject,
     /* 2228672 */ // Label 29502: @2228672
     /* 2228672 */ GIM_Try, /*On fail goto*//*Label 29546*/ GIMT_Encode4(2228786),
     /* 2228677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2228680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2228683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228695 */   GIM_Try, /*On fail goto*//*Label 29547*/ GIMT_Encode4(2228740), // Rule ID 48210 //
     /* 2228700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228703 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228739 */     // GIR_Coverage, 48210,
     /* 2228739 */     GIR_EraseRootFromParent_Done,
     /* 2228740 */   // Label 29547: @2228740
     /* 2228740 */   GIM_Try, /*On fail goto*//*Label 29548*/ GIMT_Encode4(2228785), // Rule ID 48211 //
     /* 2228745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228748 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2228751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2228765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2228780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228784 */     // GIR_Coverage, 48211,
     /* 2228784 */     GIR_EraseRootFromParent_Done,
     /* 2228785 */   // Label 29548: @2228785
     /* 2228785 */   GIM_Reject,
     /* 2228786 */ // Label 29546: @2228786
     /* 2228786 */ GIM_Reject,
     /* 2228787 */ // Label 29503: @2228787
     /* 2228787 */ GIM_Try, /*On fail goto*//*Label 29549*/ GIMT_Encode4(2228901),
     /* 2228792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2228795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2228798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2228810 */   GIM_Try, /*On fail goto*//*Label 29550*/ GIMT_Encode4(2228855), // Rule ID 48254 //
     /* 2228815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2228818 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2228821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2228835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228854 */     // GIR_Coverage, 48254,
     /* 2228854 */     GIR_EraseRootFromParent_Done,
     /* 2228855 */   // Label 29550: @2228855
     /* 2228855 */   GIM_Try, /*On fail goto*//*Label 29551*/ GIMT_Encode4(2228900), // Rule ID 48255 //
     /* 2228860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2228863 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2228866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2228880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2228895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228899 */     // GIR_Coverage, 48255,
     /* 2228899 */     GIR_EraseRootFromParent_Done,
     /* 2228900 */   // Label 29551: @2228900
     /* 2228900 */   GIM_Reject,
     /* 2228901 */ // Label 29549: @2228901
     /* 2228901 */ GIM_Reject,
     /* 2228902 */ // Label 29504: @2228902
     /* 2228902 */ GIM_Try, /*On fail goto*//*Label 29552*/ GIMT_Encode4(2229016),
     /* 2228907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2228910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2228913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2228925 */   GIM_Try, /*On fail goto*//*Label 29553*/ GIMT_Encode4(2228970), // Rule ID 48186 //
     /* 2228930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2228933 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2228933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2228936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2228957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2228959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2228968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2228969 */     // GIR_Coverage, 48186,
     /* 2228969 */     GIR_EraseRootFromParent_Done,
     /* 2228970 */   // Label 29553: @2228970
     /* 2228970 */   GIM_Try, /*On fail goto*//*Label 29554*/ GIMT_Encode4(2229015), // Rule ID 48187 //
     /* 2228975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2228978 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2228978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2228981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2228985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2228995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229014 */     // GIR_Coverage, 48187,
     /* 2229014 */     GIR_EraseRootFromParent_Done,
     /* 2229015 */   // Label 29554: @2229015
     /* 2229015 */   GIM_Reject,
     /* 2229016 */ // Label 29552: @2229016
     /* 2229016 */ GIM_Reject,
     /* 2229017 */ // Label 29505: @2229017
     /* 2229017 */ GIM_Try, /*On fail goto*//*Label 29555*/ GIMT_Encode4(2229131),
     /* 2229022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2229025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2229028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229040 */   GIM_Try, /*On fail goto*//*Label 29556*/ GIMT_Encode4(2229085), // Rule ID 48206 //
     /* 2229045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229048 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229084 */     // GIR_Coverage, 48206,
     /* 2229084 */     GIR_EraseRootFromParent_Done,
     /* 2229085 */   // Label 29556: @2229085
     /* 2229085 */   GIM_Try, /*On fail goto*//*Label 29557*/ GIMT_Encode4(2229130), // Rule ID 48207 //
     /* 2229090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229093 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2229096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229129 */     // GIR_Coverage, 48207,
     /* 2229129 */     GIR_EraseRootFromParent_Done,
     /* 2229130 */   // Label 29557: @2229130
     /* 2229130 */   GIM_Reject,
     /* 2229131 */ // Label 29555: @2229131
     /* 2229131 */ GIM_Reject,
     /* 2229132 */ // Label 29506: @2229132
     /* 2229132 */ GIM_Try, /*On fail goto*//*Label 29558*/ GIMT_Encode4(2229246),
     /* 2229137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2229140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2229143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229155 */   GIM_Try, /*On fail goto*//*Label 29559*/ GIMT_Encode4(2229200), // Rule ID 48242 //
     /* 2229160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229163 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229199 */     // GIR_Coverage, 48242,
     /* 2229199 */     GIR_EraseRootFromParent_Done,
     /* 2229200 */   // Label 29559: @2229200
     /* 2229200 */   GIM_Try, /*On fail goto*//*Label 29560*/ GIMT_Encode4(2229245), // Rule ID 48243 //
     /* 2229205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229208 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2229211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229244 */     // GIR_Coverage, 48243,
     /* 2229244 */     GIR_EraseRootFromParent_Done,
     /* 2229245 */   // Label 29560: @2229245
     /* 2229245 */   GIM_Reject,
     /* 2229246 */ // Label 29558: @2229246
     /* 2229246 */ GIM_Reject,
     /* 2229247 */ // Label 29507: @2229247
     /* 2229247 */ GIM_Try, /*On fail goto*//*Label 29561*/ GIMT_Encode4(2229361),
     /* 2229252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2229255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2229258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229270 */   GIM_Try, /*On fail goto*//*Label 29562*/ GIMT_Encode4(2229315), // Rule ID 48258 //
     /* 2229275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2229278 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229314 */     // GIR_Coverage, 48258,
     /* 2229314 */     GIR_EraseRootFromParent_Done,
     /* 2229315 */   // Label 29562: @2229315
     /* 2229315 */   GIM_Try, /*On fail goto*//*Label 29563*/ GIMT_Encode4(2229360), // Rule ID 48259 //
     /* 2229320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2229323 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2229326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229359 */     // GIR_Coverage, 48259,
     /* 2229359 */     GIR_EraseRootFromParent_Done,
     /* 2229360 */   // Label 29563: @2229360
     /* 2229360 */   GIM_Reject,
     /* 2229361 */ // Label 29561: @2229361
     /* 2229361 */ GIM_Reject,
     /* 2229362 */ // Label 29508: @2229362
     /* 2229362 */ GIM_Try, /*On fail goto*//*Label 29564*/ GIMT_Encode4(2229476),
     /* 2229367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2229370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2229373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2229385 */   GIM_Try, /*On fail goto*//*Label 29565*/ GIMT_Encode4(2229430), // Rule ID 48202 //
     /* 2229390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229393 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2229396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229429 */     // GIR_Coverage, 48202,
     /* 2229429 */     GIR_EraseRootFromParent_Done,
     /* 2229430 */   // Label 29565: @2229430
     /* 2229430 */   GIM_Try, /*On fail goto*//*Label 29566*/ GIMT_Encode4(2229475), // Rule ID 48203 //
     /* 2229435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229438 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2229441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2229455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229474 */     // GIR_Coverage, 48203,
     /* 2229474 */     GIR_EraseRootFromParent_Done,
     /* 2229475 */   // Label 29566: @2229475
     /* 2229475 */   GIM_Reject,
     /* 2229476 */ // Label 29564: @2229476
     /* 2229476 */ GIM_Reject,
     /* 2229477 */ // Label 29509: @2229477
     /* 2229477 */ GIM_Try, /*On fail goto*//*Label 29567*/ GIMT_Encode4(2229591),
     /* 2229482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2229485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2229488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229500 */   GIM_Try, /*On fail goto*//*Label 29568*/ GIMT_Encode4(2229545), // Rule ID 48230 //
     /* 2229505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229508 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2229511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229544 */     // GIR_Coverage, 48230,
     /* 2229544 */     GIR_EraseRootFromParent_Done,
     /* 2229545 */   // Label 29568: @2229545
     /* 2229545 */   GIM_Try, /*On fail goto*//*Label 29569*/ GIMT_Encode4(2229590), // Rule ID 48231 //
     /* 2229550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229553 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2229556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2229585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229589 */     // GIR_Coverage, 48231,
     /* 2229589 */     GIR_EraseRootFromParent_Done,
     /* 2229590 */   // Label 29569: @2229590
     /* 2229590 */   GIM_Reject,
     /* 2229591 */ // Label 29567: @2229591
     /* 2229591 */ GIM_Reject,
     /* 2229592 */ // Label 29510: @2229592
     /* 2229592 */ GIM_Try, /*On fail goto*//*Label 29570*/ GIMT_Encode4(2229706),
     /* 2229597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2229600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2229603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229615 */   GIM_Try, /*On fail goto*//*Label 29571*/ GIMT_Encode4(2229660), // Rule ID 48246 //
     /* 2229620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229623 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2229626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229659 */     // GIR_Coverage, 48246,
     /* 2229659 */     GIR_EraseRootFromParent_Done,
     /* 2229660 */   // Label 29571: @2229660
     /* 2229660 */   GIM_Try, /*On fail goto*//*Label 29572*/ GIMT_Encode4(2229705), // Rule ID 48247 //
     /* 2229665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229668 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2229671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2229700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229704 */     // GIR_Coverage, 48247,
     /* 2229704 */     GIR_EraseRootFromParent_Done,
     /* 2229705 */   // Label 29572: @2229705
     /* 2229705 */   GIM_Reject,
     /* 2229706 */ // Label 29570: @2229706
     /* 2229706 */ GIM_Reject,
     /* 2229707 */ // Label 29511: @2229707
     /* 2229707 */ GIM_Try, /*On fail goto*//*Label 29573*/ GIMT_Encode4(2229821),
     /* 2229712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2229715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2229718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2229730 */   GIM_Try, /*On fail goto*//*Label 29574*/ GIMT_Encode4(2229775), // Rule ID 48262 //
     /* 2229735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2229738 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2229755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229774 */     // GIR_Coverage, 48262,
     /* 2229774 */     GIR_EraseRootFromParent_Done,
     /* 2229775 */   // Label 29574: @2229775
     /* 2229775 */   GIM_Try, /*On fail goto*//*Label 29575*/ GIMT_Encode4(2229820), // Rule ID 48263 //
     /* 2229780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2229783 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2229786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2229800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2229815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229819 */     // GIR_Coverage, 48263,
     /* 2229819 */     GIR_EraseRootFromParent_Done,
     /* 2229820 */   // Label 29575: @2229820
     /* 2229820 */   GIM_Reject,
     /* 2229821 */ // Label 29573: @2229821
     /* 2229821 */ GIM_Reject,
     /* 2229822 */ // Label 29512: @2229822
     /* 2229822 */ GIM_Try, /*On fail goto*//*Label 29576*/ GIMT_Encode4(2229936),
     /* 2229827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2229830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2229833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2229845 */   GIM_Try, /*On fail goto*//*Label 29577*/ GIMT_Encode4(2229890), // Rule ID 48218 //
     /* 2229850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229853 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2229856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229889 */     // GIR_Coverage, 48218,
     /* 2229889 */     GIR_EraseRootFromParent_Done,
     /* 2229890 */   // Label 29577: @2229890
     /* 2229890 */   GIM_Try, /*On fail goto*//*Label 29578*/ GIMT_Encode4(2229935), // Rule ID 48219 //
     /* 2229895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2229898 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2229898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2229901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2229915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2229933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2229934 */     // GIR_Coverage, 48219,
     /* 2229934 */     GIR_EraseRootFromParent_Done,
     /* 2229935 */   // Label 29578: @2229935
     /* 2229935 */   GIM_Reject,
     /* 2229936 */ // Label 29576: @2229936
     /* 2229936 */ GIM_Reject,
     /* 2229937 */ // Label 29513: @2229937
     /* 2229937 */ GIM_Try, /*On fail goto*//*Label 29579*/ GIMT_Encode4(2230051),
     /* 2229942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2229945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2229948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2229960 */   GIM_Try, /*On fail goto*//*Label 29580*/ GIMT_Encode4(2230005), // Rule ID 48234 //
     /* 2229965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2229968 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2229968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2229971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2229975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2229985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2229992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2229994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2229997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230004 */     // GIR_Coverage, 48234,
     /* 2230004 */     GIR_EraseRootFromParent_Done,
     /* 2230005 */   // Label 29580: @2230005
     /* 2230005 */   GIM_Try, /*On fail goto*//*Label 29581*/ GIMT_Encode4(2230050), // Rule ID 48235 //
     /* 2230010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230013 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2230016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230049 */     // GIR_Coverage, 48235,
     /* 2230049 */     GIR_EraseRootFromParent_Done,
     /* 2230050 */   // Label 29581: @2230050
     /* 2230050 */   GIM_Reject,
     /* 2230051 */ // Label 29579: @2230051
     /* 2230051 */ GIM_Reject,
     /* 2230052 */ // Label 29514: @2230052
     /* 2230052 */ GIM_Try, /*On fail goto*//*Label 29582*/ GIMT_Encode4(2230166),
     /* 2230057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2230060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2230063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230075 */   GIM_Try, /*On fail goto*//*Label 29583*/ GIMT_Encode4(2230120), // Rule ID 48250 //
     /* 2230080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230083 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230119 */     // GIR_Coverage, 48250,
     /* 2230119 */     GIR_EraseRootFromParent_Done,
     /* 2230120 */   // Label 29583: @2230120
     /* 2230120 */   GIM_Try, /*On fail goto*//*Label 29584*/ GIMT_Encode4(2230165), // Rule ID 48251 //
     /* 2230125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230128 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2230131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2230160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230164 */     // GIR_Coverage, 48251,
     /* 2230164 */     GIR_EraseRootFromParent_Done,
     /* 2230165 */   // Label 29584: @2230165
     /* 2230165 */   GIM_Reject,
     /* 2230166 */ // Label 29582: @2230166
     /* 2230166 */ GIM_Reject,
     /* 2230167 */ // Label 29515: @2230167
     /* 2230167 */ GIM_Try, /*On fail goto*//*Label 29585*/ GIMT_Encode4(2230281),
     /* 2230172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2230175 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2230178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230186 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2230190 */   GIM_Try, /*On fail goto*//*Label 29586*/ GIMT_Encode4(2230235), // Rule ID 48222 //
     /* 2230195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230198 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230234 */     // GIR_Coverage, 48222,
     /* 2230234 */     GIR_EraseRootFromParent_Done,
     /* 2230235 */   // Label 29586: @2230235
     /* 2230235 */   GIM_Try, /*On fail goto*//*Label 29587*/ GIMT_Encode4(2230280), // Rule ID 48223 //
     /* 2230240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230243 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2230246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2230260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230279 */     // GIR_Coverage, 48223,
     /* 2230279 */     GIR_EraseRootFromParent_Done,
     /* 2230280 */   // Label 29587: @2230280
     /* 2230280 */   GIM_Reject,
     /* 2230281 */ // Label 29585: @2230281
     /* 2230281 */ GIM_Reject,
     /* 2230282 */ // Label 29516: @2230282
     /* 2230282 */ GIM_Try, /*On fail goto*//*Label 29588*/ GIMT_Encode4(2230396),
     /* 2230287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2230290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2230293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230305 */   GIM_Try, /*On fail goto*//*Label 29589*/ GIMT_Encode4(2230350), // Rule ID 48238 //
     /* 2230310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230313 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230349 */     // GIR_Coverage, 48238,
     /* 2230349 */     GIR_EraseRootFromParent_Done,
     /* 2230350 */   // Label 29589: @2230350
     /* 2230350 */   GIM_Try, /*On fail goto*//*Label 29590*/ GIMT_Encode4(2230395), // Rule ID 48239 //
     /* 2230355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230358 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2230361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2230390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230394 */     // GIR_Coverage, 48239,
     /* 2230394 */     GIR_EraseRootFromParent_Done,
     /* 2230395 */   // Label 29590: @2230395
     /* 2230395 */   GIM_Reject,
     /* 2230396 */ // Label 29588: @2230396
     /* 2230396 */ GIM_Reject,
     /* 2230397 */ // Label 29517: @2230397
     /* 2230397 */ GIM_Try, /*On fail goto*//*Label 29591*/ GIMT_Encode4(2230511),
     /* 2230402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2230405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2230408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2230420 */   GIM_Try, /*On fail goto*//*Label 29592*/ GIMT_Encode4(2230465), // Rule ID 48226 //
     /* 2230425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230428 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2230431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230464 */     // GIR_Coverage, 48226,
     /* 2230464 */     GIR_EraseRootFromParent_Done,
     /* 2230465 */   // Label 29592: @2230465
     /* 2230465 */   GIM_Try, /*On fail goto*//*Label 29593*/ GIMT_Encode4(2230510), // Rule ID 48227 //
     /* 2230470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230473 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2230476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2230490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230509 */     // GIR_Coverage, 48227,
     /* 2230509 */     GIR_EraseRootFromParent_Done,
     /* 2230510 */   // Label 29593: @2230510
     /* 2230510 */   GIM_Reject,
     /* 2230511 */ // Label 29591: @2230511
     /* 2230511 */ GIM_Reject,
     /* 2230512 */ // Label 29518: @2230512
     /* 2230512 */ GIM_Reject,
     /* 2230513 */ // Label 45: @2230513
     /* 2230513 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29618*/ GIMT_Encode4(2233451),
     /* 2230524 */ /*GILLT_s32*//*Label 29594*/ GIMT_Encode4(2230648),
     /* 2230528 */ /*GILLT_s64*//*Label 29595*/ GIMT_Encode4(2230732), GIMT_Encode4(0),
     /* 2230536 */ /*GILLT_nxv1s8*//*Label 29596*/ GIMT_Encode4(2230921),
     /* 2230540 */ /*GILLT_nxv1s16*//*Label 29597*/ GIMT_Encode4(2231036),
     /* 2230544 */ /*GILLT_nxv1s32*//*Label 29598*/ GIMT_Encode4(2231151),
     /* 2230548 */ /*GILLT_nxv1s64*//*Label 29599*/ GIMT_Encode4(2231266), GIMT_Encode4(0),
     /* 2230556 */ /*GILLT_nxv2s8*//*Label 29600*/ GIMT_Encode4(2231381),
     /* 2230560 */ /*GILLT_nxv2s16*//*Label 29601*/ GIMT_Encode4(2231496),
     /* 2230564 */ /*GILLT_nxv2s32*//*Label 29602*/ GIMT_Encode4(2231611),
     /* 2230568 */ /*GILLT_nxv2s64*//*Label 29603*/ GIMT_Encode4(2231726), GIMT_Encode4(0),
     /* 2230576 */ /*GILLT_nxv4s8*//*Label 29604*/ GIMT_Encode4(2231841),
     /* 2230580 */ /*GILLT_nxv4s16*//*Label 29605*/ GIMT_Encode4(2231956),
     /* 2230584 */ /*GILLT_nxv4s32*//*Label 29606*/ GIMT_Encode4(2232071),
     /* 2230588 */ /*GILLT_nxv4s64*//*Label 29607*/ GIMT_Encode4(2232186), GIMT_Encode4(0),
     /* 2230596 */ /*GILLT_nxv8s8*//*Label 29608*/ GIMT_Encode4(2232301),
     /* 2230600 */ /*GILLT_nxv8s16*//*Label 29609*/ GIMT_Encode4(2232416),
     /* 2230604 */ /*GILLT_nxv8s32*//*Label 29610*/ GIMT_Encode4(2232531),
     /* 2230608 */ /*GILLT_nxv8s64*//*Label 29611*/ GIMT_Encode4(2232646), GIMT_Encode4(0),
     /* 2230616 */ /*GILLT_nxv16s8*//*Label 29612*/ GIMT_Encode4(2232761),
     /* 2230620 */ /*GILLT_nxv16s16*//*Label 29613*/ GIMT_Encode4(2232876),
     /* 2230624 */ /*GILLT_nxv16s32*//*Label 29614*/ GIMT_Encode4(2232991), GIMT_Encode4(0),
     /* 2230632 */ /*GILLT_nxv32s8*//*Label 29615*/ GIMT_Encode4(2233106),
     /* 2230636 */ /*GILLT_nxv32s16*//*Label 29616*/ GIMT_Encode4(2233221), GIMT_Encode4(0),
     /* 2230644 */ /*GILLT_nxv64s8*//*Label 29617*/ GIMT_Encode4(2233336),
     /* 2230648 */ // Label 29594: @2230648
     /* 2230648 */ GIM_Try, /*On fail goto*//*Label 29619*/ GIMT_Encode4(2230731),
     /* 2230653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2230656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2230659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230667 */   GIM_Try, /*On fail goto*//*Label 29620*/ GIMT_Encode4(2230701), // Rule ID 101 //
     /* 2230672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2230679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2230687 */     // MIs[1] Operand 1
     /* 2230687 */     // No operand predicates
     /* 2230687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230689 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2230689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2230692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2230699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230700 */     // GIR_Coverage, 101,
     /* 2230700 */     GIR_EraseRootFromParent_Done,
     /* 2230701 */   // Label 29620: @2230701
     /* 2230701 */   GIM_Try, /*On fail goto*//*Label 29621*/ GIMT_Encode4(2230730), // Rule ID 115 //
     /* 2230706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2230709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2230716 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRA:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2230716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2230719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2230728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230729 */     // GIR_Coverage, 115,
     /* 2230729 */     GIR_EraseRootFromParent_Done,
     /* 2230730 */   // Label 29621: @2230730
     /* 2230730 */   GIM_Reject,
     /* 2230731 */ // Label 29619: @2230731
     /* 2230731 */ GIM_Reject,
     /* 2230732 */ // Label 29595: @2230732
     /* 2230732 */ GIM_Try, /*On fail goto*//*Label 29622*/ GIMT_Encode4(2230920),
     /* 2230737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2230740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2230743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230747 */   GIM_Try, /*On fail goto*//*Label 29623*/ GIMT_Encode4(2230784), // Rule ID 62567 //
     /* 2230752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2230755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2230763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2230767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2230771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230773 */     // (sra:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2230773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2230776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2230782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230783 */     // GIR_Coverage, 62567,
     /* 2230783 */     GIR_EraseRootFromParent_Done,
     /* 2230784 */   // Label 29623: @2230784
     /* 2230784 */   GIM_Try, /*On fail goto*//*Label 29624*/ GIMT_Encode4(2230848), // Rule ID 265 //
     /* 2230789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2230792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2230796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2230800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2230804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230809 */     // MIs[1] Operand 2
     /* 2230809 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2230820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2230824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2230832 */     // MIs[2] Operand 1
     /* 2230832 */     // No operand predicates
     /* 2230832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2230834 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2230834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2230837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2230843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2230846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230847 */     // GIR_Coverage, 265,
     /* 2230847 */     GIR_EraseRootFromParent_Done,
     /* 2230848 */   // Label 29624: @2230848
     /* 2230848 */   GIM_Try, /*On fail goto*//*Label 29625*/ GIMT_Encode4(2230886), // Rule ID 100 //
     /* 2230853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2230864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2230868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2230872 */     // MIs[1] Operand 1
     /* 2230872 */     // No operand predicates
     /* 2230872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2230874 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2230874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2230877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2230884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230885 */     // GIR_Coverage, 100,
     /* 2230885 */     GIR_EraseRootFromParent_Done,
     /* 2230886 */   // Label 29625: @2230886
     /* 2230886 */   GIM_Try, /*On fail goto*//*Label 29626*/ GIMT_Encode4(2230919), // Rule ID 114 //
     /* 2230891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2230905 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRA:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2230905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2230908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2230917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230918 */     // GIR_Coverage, 114,
     /* 2230918 */     GIR_EraseRootFromParent_Done,
     /* 2230919 */   // Label 29626: @2230919
     /* 2230919 */   GIM_Reject,
     /* 2230920 */ // Label 29622: @2230920
     /* 2230920 */ GIM_Reject,
     /* 2230921 */ // Label 29596: @2230921
     /* 2230921 */ GIM_Try, /*On fail goto*//*Label 29627*/ GIMT_Encode4(2231035),
     /* 2230926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2230929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2230932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2230936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2230940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2230944 */   GIM_Try, /*On fail goto*//*Label 29628*/ GIMT_Encode4(2230989), // Rule ID 48310 //
     /* 2230949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2230952 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2230952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2230955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2230959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2230969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2230976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2230978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2230981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2230987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2230988 */     // GIR_Coverage, 48310,
     /* 2230988 */     GIR_EraseRootFromParent_Done,
     /* 2230989 */   // Label 29628: @2230989
     /* 2230989 */   GIM_Try, /*On fail goto*//*Label 29629*/ GIMT_Encode4(2231034), // Rule ID 48311 //
     /* 2230994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2230997 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2230997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2231000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2231014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231033 */     // GIR_Coverage, 48311,
     /* 2231033 */     GIR_EraseRootFromParent_Done,
     /* 2231034 */   // Label 29629: @2231034
     /* 2231034 */   GIM_Reject,
     /* 2231035 */ // Label 29627: @2231035
     /* 2231035 */ GIM_Reject,
     /* 2231036 */ // Label 29597: @2231036
     /* 2231036 */ GIM_Try, /*On fail goto*//*Label 29630*/ GIMT_Encode4(2231150),
     /* 2231041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2231044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2231047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231059 */   GIM_Try, /*On fail goto*//*Label 29631*/ GIMT_Encode4(2231104), // Rule ID 48322 //
     /* 2231064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231067 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2231070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231103 */     // GIR_Coverage, 48322,
     /* 2231103 */     GIR_EraseRootFromParent_Done,
     /* 2231104 */   // Label 29631: @2231104
     /* 2231104 */   GIM_Try, /*On fail goto*//*Label 29632*/ GIMT_Encode4(2231149), // Rule ID 48323 //
     /* 2231109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231112 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2231115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231148 */     // GIR_Coverage, 48323,
     /* 2231148 */     GIR_EraseRootFromParent_Done,
     /* 2231149 */   // Label 29632: @2231149
     /* 2231149 */   GIM_Reject,
     /* 2231150 */ // Label 29630: @2231150
     /* 2231150 */ GIM_Reject,
     /* 2231151 */ // Label 29598: @2231151
     /* 2231151 */ GIM_Try, /*On fail goto*//*Label 29633*/ GIMT_Encode4(2231265),
     /* 2231156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2231159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2231162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231174 */   GIM_Try, /*On fail goto*//*Label 29634*/ GIMT_Encode4(2231219), // Rule ID 48330 //
     /* 2231179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231182 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2231185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231218 */     // GIR_Coverage, 48330,
     /* 2231218 */     GIR_EraseRootFromParent_Done,
     /* 2231219 */   // Label 29634: @2231219
     /* 2231219 */   GIM_Try, /*On fail goto*//*Label 29635*/ GIMT_Encode4(2231264), // Rule ID 48331 //
     /* 2231224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231227 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2231230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231263 */     // GIR_Coverage, 48331,
     /* 2231263 */     GIR_EraseRootFromParent_Done,
     /* 2231264 */   // Label 29635: @2231264
     /* 2231264 */   GIM_Reject,
     /* 2231265 */ // Label 29633: @2231265
     /* 2231265 */ GIM_Reject,
     /* 2231266 */ // Label 29599: @2231266
     /* 2231266 */ GIM_Try, /*On fail goto*//*Label 29636*/ GIMT_Encode4(2231380),
     /* 2231271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2231274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2231277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231289 */   GIM_Try, /*On fail goto*//*Label 29637*/ GIMT_Encode4(2231334), // Rule ID 48346 //
     /* 2231294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2231297 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2231300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231333 */     // GIR_Coverage, 48346,
     /* 2231333 */     GIR_EraseRootFromParent_Done,
     /* 2231334 */   // Label 29637: @2231334
     /* 2231334 */   GIM_Try, /*On fail goto*//*Label 29638*/ GIMT_Encode4(2231379), // Rule ID 48347 //
     /* 2231339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2231342 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2231345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231378 */     // GIR_Coverage, 48347,
     /* 2231378 */     GIR_EraseRootFromParent_Done,
     /* 2231379 */   // Label 29638: @2231379
     /* 2231379 */   GIM_Reject,
     /* 2231380 */ // Label 29636: @2231380
     /* 2231380 */ GIM_Reject,
     /* 2231381 */ // Label 29600: @2231381
     /* 2231381 */ GIM_Try, /*On fail goto*//*Label 29639*/ GIMT_Encode4(2231495),
     /* 2231386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2231389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2231392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231404 */   GIM_Try, /*On fail goto*//*Label 29640*/ GIMT_Encode4(2231449), // Rule ID 48314 //
     /* 2231409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231412 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2231415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231448 */     // GIR_Coverage, 48314,
     /* 2231448 */     GIR_EraseRootFromParent_Done,
     /* 2231449 */   // Label 29640: @2231449
     /* 2231449 */   GIM_Try, /*On fail goto*//*Label 29641*/ GIMT_Encode4(2231494), // Rule ID 48315 //
     /* 2231454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231457 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2231460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2231474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231493 */     // GIR_Coverage, 48315,
     /* 2231493 */     GIR_EraseRootFromParent_Done,
     /* 2231494 */   // Label 29641: @2231494
     /* 2231494 */   GIM_Reject,
     /* 2231495 */ // Label 29639: @2231495
     /* 2231495 */ GIM_Reject,
     /* 2231496 */ // Label 29601: @2231496
     /* 2231496 */ GIM_Try, /*On fail goto*//*Label 29642*/ GIMT_Encode4(2231610),
     /* 2231501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2231504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2231507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231519 */   GIM_Try, /*On fail goto*//*Label 29643*/ GIMT_Encode4(2231564), // Rule ID 48326 //
     /* 2231524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231527 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2231530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231563 */     // GIR_Coverage, 48326,
     /* 2231563 */     GIR_EraseRootFromParent_Done,
     /* 2231564 */   // Label 29643: @2231564
     /* 2231564 */   GIM_Try, /*On fail goto*//*Label 29644*/ GIMT_Encode4(2231609), // Rule ID 48327 //
     /* 2231569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231572 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2231575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231608 */     // GIR_Coverage, 48327,
     /* 2231608 */     GIR_EraseRootFromParent_Done,
     /* 2231609 */   // Label 29644: @2231609
     /* 2231609 */   GIM_Reject,
     /* 2231610 */ // Label 29642: @2231610
     /* 2231610 */ GIM_Reject,
     /* 2231611 */ // Label 29602: @2231611
     /* 2231611 */ GIM_Try, /*On fail goto*//*Label 29645*/ GIMT_Encode4(2231725),
     /* 2231616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2231619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2231622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231634 */   GIM_Try, /*On fail goto*//*Label 29646*/ GIMT_Encode4(2231679), // Rule ID 48342 //
     /* 2231639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231642 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2231645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231678 */     // GIR_Coverage, 48342,
     /* 2231678 */     GIR_EraseRootFromParent_Done,
     /* 2231679 */   // Label 29646: @2231679
     /* 2231679 */   GIM_Try, /*On fail goto*//*Label 29647*/ GIMT_Encode4(2231724), // Rule ID 48343 //
     /* 2231684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231687 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2231690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2231704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231723 */     // GIR_Coverage, 48343,
     /* 2231723 */     GIR_EraseRootFromParent_Done,
     /* 2231724 */   // Label 29647: @2231724
     /* 2231724 */   GIM_Reject,
     /* 2231725 */ // Label 29645: @2231725
     /* 2231725 */ GIM_Reject,
     /* 2231726 */ // Label 29603: @2231726
     /* 2231726 */ GIM_Try, /*On fail goto*//*Label 29648*/ GIMT_Encode4(2231840),
     /* 2231731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2231734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2231737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2231741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2231745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2231749 */   GIM_Try, /*On fail goto*//*Label 29649*/ GIMT_Encode4(2231794), // Rule ID 48386 //
     /* 2231754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2231757 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2231760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2231774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231793 */     // GIR_Coverage, 48386,
     /* 2231793 */     GIR_EraseRootFromParent_Done,
     /* 2231794 */   // Label 29649: @2231794
     /* 2231794 */   GIM_Try, /*On fail goto*//*Label 29650*/ GIMT_Encode4(2231839), // Rule ID 48387 //
     /* 2231799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2231802 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2231805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2231819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231838 */     // GIR_Coverage, 48387,
     /* 2231838 */     GIR_EraseRootFromParent_Done,
     /* 2231839 */   // Label 29650: @2231839
     /* 2231839 */   GIM_Reject,
     /* 2231840 */ // Label 29648: @2231840
     /* 2231840 */ GIM_Reject,
     /* 2231841 */ // Label 29604: @2231841
     /* 2231841 */ GIM_Try, /*On fail goto*//*Label 29651*/ GIMT_Encode4(2231955),
     /* 2231846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2231849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2231852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231864 */   GIM_Try, /*On fail goto*//*Label 29652*/ GIMT_Encode4(2231909), // Rule ID 48318 //
     /* 2231869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231872 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2231875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231908 */     // GIR_Coverage, 48318,
     /* 2231908 */     GIR_EraseRootFromParent_Done,
     /* 2231909 */   // Label 29652: @2231909
     /* 2231909 */   GIM_Try, /*On fail goto*//*Label 29653*/ GIMT_Encode4(2231954), // Rule ID 48319 //
     /* 2231914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231917 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2231920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2231934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2231941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2231953 */     // GIR_Coverage, 48319,
     /* 2231953 */     GIR_EraseRootFromParent_Done,
     /* 2231954 */   // Label 29653: @2231954
     /* 2231954 */   GIM_Reject,
     /* 2231955 */ // Label 29651: @2231955
     /* 2231955 */ GIM_Reject,
     /* 2231956 */ // Label 29605: @2231956
     /* 2231956 */ GIM_Try, /*On fail goto*//*Label 29654*/ GIMT_Encode4(2232070),
     /* 2231961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2231964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2231967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231979 */   GIM_Try, /*On fail goto*//*Label 29655*/ GIMT_Encode4(2232024), // Rule ID 48338 //
     /* 2231984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231987 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2231990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2231994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232023 */     // GIR_Coverage, 48338,
     /* 2232023 */     GIR_EraseRootFromParent_Done,
     /* 2232024 */   // Label 29655: @2232024
     /* 2232024 */   GIM_Try, /*On fail goto*//*Label 29656*/ GIMT_Encode4(2232069), // Rule ID 48339 //
     /* 2232029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232032 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2232035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232068 */     // GIR_Coverage, 48339,
     /* 2232068 */     GIR_EraseRootFromParent_Done,
     /* 2232069 */   // Label 29656: @2232069
     /* 2232069 */   GIM_Reject,
     /* 2232070 */ // Label 29654: @2232070
     /* 2232070 */ GIM_Reject,
     /* 2232071 */ // Label 29606: @2232071
     /* 2232071 */ GIM_Try, /*On fail goto*//*Label 29657*/ GIMT_Encode4(2232185),
     /* 2232076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2232079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2232082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232094 */   GIM_Try, /*On fail goto*//*Label 29658*/ GIMT_Encode4(2232139), // Rule ID 48374 //
     /* 2232099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232102 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232138 */     // GIR_Coverage, 48374,
     /* 2232138 */     GIR_EraseRootFromParent_Done,
     /* 2232139 */   // Label 29658: @2232139
     /* 2232139 */   GIM_Try, /*On fail goto*//*Label 29659*/ GIMT_Encode4(2232184), // Rule ID 48375 //
     /* 2232144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232147 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2232150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232183 */     // GIR_Coverage, 48375,
     /* 2232183 */     GIR_EraseRootFromParent_Done,
     /* 2232184 */   // Label 29659: @2232184
     /* 2232184 */   GIM_Reject,
     /* 2232185 */ // Label 29657: @2232185
     /* 2232185 */ GIM_Reject,
     /* 2232186 */ // Label 29607: @2232186
     /* 2232186 */ GIM_Try, /*On fail goto*//*Label 29660*/ GIMT_Encode4(2232300),
     /* 2232191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2232194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2232197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232209 */   GIM_Try, /*On fail goto*//*Label 29661*/ GIMT_Encode4(2232254), // Rule ID 48390 //
     /* 2232214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232217 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2232220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232253 */     // GIR_Coverage, 48390,
     /* 2232253 */     GIR_EraseRootFromParent_Done,
     /* 2232254 */   // Label 29661: @2232254
     /* 2232254 */   GIM_Try, /*On fail goto*//*Label 29662*/ GIMT_Encode4(2232299), // Rule ID 48391 //
     /* 2232259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232262 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2232265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232298 */     // GIR_Coverage, 48391,
     /* 2232298 */     GIR_EraseRootFromParent_Done,
     /* 2232299 */   // Label 29662: @2232299
     /* 2232299 */   GIM_Reject,
     /* 2232300 */ // Label 29660: @2232300
     /* 2232300 */ GIM_Reject,
     /* 2232301 */ // Label 29608: @2232301
     /* 2232301 */ GIM_Try, /*On fail goto*//*Label 29663*/ GIMT_Encode4(2232415),
     /* 2232306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2232309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2232312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232324 */   GIM_Try, /*On fail goto*//*Label 29664*/ GIMT_Encode4(2232369), // Rule ID 48334 //
     /* 2232329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232332 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2232335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232368 */     // GIR_Coverage, 48334,
     /* 2232368 */     GIR_EraseRootFromParent_Done,
     /* 2232369 */   // Label 29664: @2232369
     /* 2232369 */   GIM_Try, /*On fail goto*//*Label 29665*/ GIMT_Encode4(2232414), // Rule ID 48335 //
     /* 2232374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232377 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2232380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2232394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232413 */     // GIR_Coverage, 48335,
     /* 2232413 */     GIR_EraseRootFromParent_Done,
     /* 2232414 */   // Label 29665: @2232414
     /* 2232414 */   GIM_Reject,
     /* 2232415 */ // Label 29663: @2232415
     /* 2232415 */ GIM_Reject,
     /* 2232416 */ // Label 29609: @2232416
     /* 2232416 */ GIM_Try, /*On fail goto*//*Label 29666*/ GIMT_Encode4(2232530),
     /* 2232421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2232424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2232427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232439 */   GIM_Try, /*On fail goto*//*Label 29667*/ GIMT_Encode4(2232484), // Rule ID 48362 //
     /* 2232444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232447 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2232450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232483 */     // GIR_Coverage, 48362,
     /* 2232483 */     GIR_EraseRootFromParent_Done,
     /* 2232484 */   // Label 29667: @2232484
     /* 2232484 */   GIM_Try, /*On fail goto*//*Label 29668*/ GIMT_Encode4(2232529), // Rule ID 48363 //
     /* 2232489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232492 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2232495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232528 */     // GIR_Coverage, 48363,
     /* 2232528 */     GIR_EraseRootFromParent_Done,
     /* 2232529 */   // Label 29668: @2232529
     /* 2232529 */   GIM_Reject,
     /* 2232530 */ // Label 29666: @2232530
     /* 2232530 */ GIM_Reject,
     /* 2232531 */ // Label 29610: @2232531
     /* 2232531 */ GIM_Try, /*On fail goto*//*Label 29669*/ GIMT_Encode4(2232645),
     /* 2232536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2232539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2232542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232554 */   GIM_Try, /*On fail goto*//*Label 29670*/ GIMT_Encode4(2232599), // Rule ID 48378 //
     /* 2232559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232562 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2232565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232598 */     // GIR_Coverage, 48378,
     /* 2232598 */     GIR_EraseRootFromParent_Done,
     /* 2232599 */   // Label 29670: @2232599
     /* 2232599 */   GIM_Try, /*On fail goto*//*Label 29671*/ GIMT_Encode4(2232644), // Rule ID 48379 //
     /* 2232604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232607 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2232610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232643 */     // GIR_Coverage, 48379,
     /* 2232643 */     GIR_EraseRootFromParent_Done,
     /* 2232644 */   // Label 29671: @2232644
     /* 2232644 */   GIM_Reject,
     /* 2232645 */ // Label 29669: @2232645
     /* 2232645 */ GIM_Reject,
     /* 2232646 */ // Label 29611: @2232646
     /* 2232646 */ GIM_Try, /*On fail goto*//*Label 29672*/ GIMT_Encode4(2232760),
     /* 2232651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2232654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2232657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2232661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2232665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2232669 */   GIM_Try, /*On fail goto*//*Label 29673*/ GIMT_Encode4(2232714), // Rule ID 48394 //
     /* 2232674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232677 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2232680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2232694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232713 */     // GIR_Coverage, 48394,
     /* 2232713 */     GIR_EraseRootFromParent_Done,
     /* 2232714 */   // Label 29673: @2232714
     /* 2232714 */   GIM_Try, /*On fail goto*//*Label 29674*/ GIMT_Encode4(2232759), // Rule ID 48395 //
     /* 2232719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232722 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2232725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2232739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232758 */     // GIR_Coverage, 48395,
     /* 2232758 */     GIR_EraseRootFromParent_Done,
     /* 2232759 */   // Label 29674: @2232759
     /* 2232759 */   GIM_Reject,
     /* 2232760 */ // Label 29672: @2232760
     /* 2232760 */ GIM_Reject,
     /* 2232761 */ // Label 29612: @2232761
     /* 2232761 */ GIM_Try, /*On fail goto*//*Label 29675*/ GIMT_Encode4(2232875),
     /* 2232766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2232769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2232772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2232784 */   GIM_Try, /*On fail goto*//*Label 29676*/ GIMT_Encode4(2232829), // Rule ID 48350 //
     /* 2232789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232792 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2232795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232828 */     // GIR_Coverage, 48350,
     /* 2232828 */     GIR_EraseRootFromParent_Done,
     /* 2232829 */   // Label 29676: @2232829
     /* 2232829 */   GIM_Try, /*On fail goto*//*Label 29677*/ GIMT_Encode4(2232874), // Rule ID 48351 //
     /* 2232834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232837 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2232840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2232854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232873 */     // GIR_Coverage, 48351,
     /* 2232873 */     GIR_EraseRootFromParent_Done,
     /* 2232874 */   // Label 29677: @2232874
     /* 2232874 */   GIM_Reject,
     /* 2232875 */ // Label 29675: @2232875
     /* 2232875 */ GIM_Reject,
     /* 2232876 */ // Label 29613: @2232876
     /* 2232876 */ GIM_Try, /*On fail goto*//*Label 29678*/ GIMT_Encode4(2232990),
     /* 2232881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2232884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2232887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2232899 */   GIM_Try, /*On fail goto*//*Label 29679*/ GIMT_Encode4(2232944), // Rule ID 48366 //
     /* 2232904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232907 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2232910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232943 */     // GIR_Coverage, 48366,
     /* 2232943 */     GIR_EraseRootFromParent_Done,
     /* 2232944 */   // Label 29679: @2232944
     /* 2232944 */   GIM_Try, /*On fail goto*//*Label 29680*/ GIMT_Encode4(2232989), // Rule ID 48367 //
     /* 2232949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232952 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2232955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2232959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2232964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2232966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2232969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2232974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2232976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2232988 */     // GIR_Coverage, 48367,
     /* 2232988 */     GIR_EraseRootFromParent_Done,
     /* 2232989 */   // Label 29680: @2232989
     /* 2232989 */   GIM_Reject,
     /* 2232990 */ // Label 29678: @2232990
     /* 2232990 */ GIM_Reject,
     /* 2232991 */ // Label 29614: @2232991
     /* 2232991 */ GIM_Try, /*On fail goto*//*Label 29681*/ GIMT_Encode4(2233105),
     /* 2232996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2232999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2233002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233014 */   GIM_Try, /*On fail goto*//*Label 29682*/ GIMT_Encode4(2233059), // Rule ID 48382 //
     /* 2233019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233022 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233058 */     // GIR_Coverage, 48382,
     /* 2233058 */     GIR_EraseRootFromParent_Done,
     /* 2233059 */   // Label 29682: @2233059
     /* 2233059 */   GIM_Try, /*On fail goto*//*Label 29683*/ GIMT_Encode4(2233104), // Rule ID 48383 //
     /* 2233064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233067 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2233070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233103 */     // GIR_Coverage, 48383,
     /* 2233103 */     GIR_EraseRootFromParent_Done,
     /* 2233104 */   // Label 29683: @2233104
     /* 2233104 */   GIM_Reject,
     /* 2233105 */ // Label 29681: @2233105
     /* 2233105 */ GIM_Reject,
     /* 2233106 */ // Label 29615: @2233106
     /* 2233106 */ GIM_Try, /*On fail goto*//*Label 29684*/ GIMT_Encode4(2233220),
     /* 2233111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2233114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2233117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2233129 */   GIM_Try, /*On fail goto*//*Label 29685*/ GIMT_Encode4(2233174), // Rule ID 48354 //
     /* 2233134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233137 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2233140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233173 */     // GIR_Coverage, 48354,
     /* 2233173 */     GIR_EraseRootFromParent_Done,
     /* 2233174 */   // Label 29685: @2233174
     /* 2233174 */   GIM_Try, /*On fail goto*//*Label 29686*/ GIMT_Encode4(2233219), // Rule ID 48355 //
     /* 2233179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233182 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2233185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2233199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233218 */     // GIR_Coverage, 48355,
     /* 2233218 */     GIR_EraseRootFromParent_Done,
     /* 2233219 */   // Label 29686: @2233219
     /* 2233219 */   GIM_Reject,
     /* 2233220 */ // Label 29684: @2233220
     /* 2233220 */ GIM_Reject,
     /* 2233221 */ // Label 29616: @2233221
     /* 2233221 */ GIM_Try, /*On fail goto*//*Label 29687*/ GIMT_Encode4(2233335),
     /* 2233226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2233229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2233232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233244 */   GIM_Try, /*On fail goto*//*Label 29688*/ GIMT_Encode4(2233289), // Rule ID 48370 //
     /* 2233249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233252 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233288 */     // GIR_Coverage, 48370,
     /* 2233288 */     GIR_EraseRootFromParent_Done,
     /* 2233289 */   // Label 29688: @2233289
     /* 2233289 */   GIM_Try, /*On fail goto*//*Label 29689*/ GIMT_Encode4(2233334), // Rule ID 48371 //
     /* 2233294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233297 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2233300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233333 */     // GIR_Coverage, 48371,
     /* 2233333 */     GIR_EraseRootFromParent_Done,
     /* 2233334 */   // Label 29689: @2233334
     /* 2233334 */   GIM_Reject,
     /* 2233335 */ // Label 29687: @2233335
     /* 2233335 */ GIM_Reject,
     /* 2233336 */ // Label 29617: @2233336
     /* 2233336 */ GIM_Try, /*On fail goto*//*Label 29690*/ GIMT_Encode4(2233450),
     /* 2233341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2233344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2233347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2233359 */   GIM_Try, /*On fail goto*//*Label 29691*/ GIMT_Encode4(2233404), // Rule ID 48358 //
     /* 2233364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233367 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2233370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233403 */     // GIR_Coverage, 48358,
     /* 2233403 */     GIR_EraseRootFromParent_Done,
     /* 2233404 */   // Label 29691: @2233404
     /* 2233404 */   GIM_Try, /*On fail goto*//*Label 29692*/ GIMT_Encode4(2233449), // Rule ID 48359 //
     /* 2233409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233412 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2233415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2233429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233448 */     // GIR_Coverage, 48359,
     /* 2233448 */     GIR_EraseRootFromParent_Done,
     /* 2233449 */   // Label 29692: @2233449
     /* 2233449 */   GIM_Reject,
     /* 2233450 */ // Label 29690: @2233450
     /* 2233450 */ GIM_Reject,
     /* 2233451 */ // Label 29618: @2233451
     /* 2233451 */ GIM_Reject,
     /* 2233452 */ // Label 46: @2233452
     /* 2233452 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29717*/ GIMT_Encode4(2236391),
     /* 2233463 */ /*GILLT_s32*//*Label 29693*/ GIMT_Encode4(2233587),
     /* 2233467 */ /*GILLT_s64*//*Label 29694*/ GIMT_Encode4(2233724), GIMT_Encode4(0),
     /* 2233475 */ /*GILLT_nxv1s8*//*Label 29695*/ GIMT_Encode4(2233861),
     /* 2233479 */ /*GILLT_nxv1s16*//*Label 29696*/ GIMT_Encode4(2233976),
     /* 2233483 */ /*GILLT_nxv1s32*//*Label 29697*/ GIMT_Encode4(2234091),
     /* 2233487 */ /*GILLT_nxv1s64*//*Label 29698*/ GIMT_Encode4(2234206), GIMT_Encode4(0),
     /* 2233495 */ /*GILLT_nxv2s8*//*Label 29699*/ GIMT_Encode4(2234321),
     /* 2233499 */ /*GILLT_nxv2s16*//*Label 29700*/ GIMT_Encode4(2234436),
     /* 2233503 */ /*GILLT_nxv2s32*//*Label 29701*/ GIMT_Encode4(2234551),
     /* 2233507 */ /*GILLT_nxv2s64*//*Label 29702*/ GIMT_Encode4(2234666), GIMT_Encode4(0),
     /* 2233515 */ /*GILLT_nxv4s8*//*Label 29703*/ GIMT_Encode4(2234781),
     /* 2233519 */ /*GILLT_nxv4s16*//*Label 29704*/ GIMT_Encode4(2234896),
     /* 2233523 */ /*GILLT_nxv4s32*//*Label 29705*/ GIMT_Encode4(2235011),
     /* 2233527 */ /*GILLT_nxv4s64*//*Label 29706*/ GIMT_Encode4(2235126), GIMT_Encode4(0),
     /* 2233535 */ /*GILLT_nxv8s8*//*Label 29707*/ GIMT_Encode4(2235241),
     /* 2233539 */ /*GILLT_nxv8s16*//*Label 29708*/ GIMT_Encode4(2235356),
     /* 2233543 */ /*GILLT_nxv8s32*//*Label 29709*/ GIMT_Encode4(2235471),
     /* 2233547 */ /*GILLT_nxv8s64*//*Label 29710*/ GIMT_Encode4(2235586), GIMT_Encode4(0),
     /* 2233555 */ /*GILLT_nxv16s8*//*Label 29711*/ GIMT_Encode4(2235701),
     /* 2233559 */ /*GILLT_nxv16s16*//*Label 29712*/ GIMT_Encode4(2235816),
     /* 2233563 */ /*GILLT_nxv16s32*//*Label 29713*/ GIMT_Encode4(2235931), GIMT_Encode4(0),
     /* 2233571 */ /*GILLT_nxv32s8*//*Label 29714*/ GIMT_Encode4(2236046),
     /* 2233575 */ /*GILLT_nxv32s16*//*Label 29715*/ GIMT_Encode4(2236161), GIMT_Encode4(0),
     /* 2233583 */ /*GILLT_nxv64s8*//*Label 29716*/ GIMT_Encode4(2236276),
     /* 2233587 */ // Label 29693: @2233587
     /* 2233587 */ GIM_Try, /*On fail goto*//*Label 29718*/ GIMT_Encode4(2233723),
     /* 2233592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2233595 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2233598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233606 */   GIM_Try, /*On fail goto*//*Label 29719*/ GIMT_Encode4(2233640), // Rule ID 2459 //
     /* 2233611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2233614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2233626 */     // MIs[1] Operand 1
     /* 2233626 */     // No operand predicates
     /* 2233626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233628 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2233628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2233631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2233638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233639 */     // GIR_Coverage, 2459,
     /* 2233639 */     GIR_EraseRootFromParent_Done,
     /* 2233640 */   // Label 29719: @2233640
     /* 2233640 */   GIM_Try, /*On fail goto*//*Label 29720*/ GIMT_Encode4(2233674), // Rule ID 62550 //
     /* 2233645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2233648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2233660 */     // MIs[1] Operand 1
     /* 2233660 */     // No operand predicates
     /* 2233660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233662 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2233662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2233665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2233672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233673 */     // GIR_Coverage, 62550,
     /* 2233673 */     GIR_EraseRootFromParent_Done,
     /* 2233674 */   // Label 29720: @2233674
     /* 2233674 */   GIM_Try, /*On fail goto*//*Label 29721*/ GIMT_Encode4(2233703), // Rule ID 2457 //
     /* 2233679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2233682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2233689 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2233689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2233692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2233701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233702 */     // GIR_Coverage, 2457,
     /* 2233702 */     GIR_EraseRootFromParent_Done,
     /* 2233703 */   // Label 29721: @2233703
     /* 2233703 */   GIM_Try, /*On fail goto*//*Label 29722*/ GIMT_Encode4(2233722), // Rule ID 64444 //
     /* 2233708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2233711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233715 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2233715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2233720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233721 */     // GIR_Coverage, 64444,
     /* 2233721 */     GIR_Done,
     /* 2233722 */   // Label 29722: @2233722
     /* 2233722 */   GIM_Reject,
     /* 2233723 */ // Label 29718: @2233723
     /* 2233723 */ GIM_Reject,
     /* 2233724 */ // Label 29694: @2233724
     /* 2233724 */ GIM_Try, /*On fail goto*//*Label 29723*/ GIMT_Encode4(2233860),
     /* 2233729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2233732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2233735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233743 */   GIM_Try, /*On fail goto*//*Label 29724*/ GIMT_Encode4(2233777), // Rule ID 2458 //
     /* 2233748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2233751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2233763 */     // MIs[1] Operand 1
     /* 2233763 */     // No operand predicates
     /* 2233763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233765 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2233765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2233768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2233775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233776 */     // GIR_Coverage, 2458,
     /* 2233776 */     GIR_EraseRootFromParent_Done,
     /* 2233777 */   // Label 29724: @2233777
     /* 2233777 */   GIM_Try, /*On fail goto*//*Label 29725*/ GIMT_Encode4(2233811), // Rule ID 62549 //
     /* 2233782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2233785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2233789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2233793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2233797 */     // MIs[1] Operand 1
     /* 2233797 */     // No operand predicates
     /* 2233797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2233799 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2233799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2233802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2233809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233810 */     // GIR_Coverage, 62549,
     /* 2233810 */     GIR_EraseRootFromParent_Done,
     /* 2233811 */   // Label 29725: @2233811
     /* 2233811 */   GIM_Try, /*On fail goto*//*Label 29726*/ GIMT_Encode4(2233840), // Rule ID 2456 //
     /* 2233816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2233819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2233826 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2233826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2233829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2233838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233839 */     // GIR_Coverage, 2456,
     /* 2233839 */     GIR_EraseRootFromParent_Done,
     /* 2233840 */   // Label 29726: @2233840
     /* 2233840 */   GIM_Try, /*On fail goto*//*Label 29727*/ GIMT_Encode4(2233859), // Rule ID 64443 //
     /* 2233845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2233848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2233852 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2233852 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2233857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233858 */     // GIR_Coverage, 64443,
     /* 2233858 */     GIR_Done,
     /* 2233859 */   // Label 29727: @2233859
     /* 2233859 */   GIM_Reject,
     /* 2233860 */ // Label 29723: @2233860
     /* 2233860 */ GIM_Reject,
     /* 2233861 */ // Label 29695: @2233861
     /* 2233861 */ GIM_Try, /*On fail goto*//*Label 29728*/ GIMT_Encode4(2233975),
     /* 2233866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2233869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2233872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233884 */   GIM_Try, /*On fail goto*//*Label 29729*/ GIMT_Encode4(2233929), // Rule ID 59402 //
     /* 2233889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233892 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2233895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2233909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233928 */     // GIR_Coverage, 59402,
     /* 2233928 */     GIR_EraseRootFromParent_Done,
     /* 2233929 */   // Label 29729: @2233929
     /* 2233929 */   GIM_Try, /*On fail goto*//*Label 29730*/ GIMT_Encode4(2233974), // Rule ID 59403 //
     /* 2233934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233937 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2233940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2233944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2233949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2233951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2233954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2233959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2233961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2233973 */     // GIR_Coverage, 59403,
     /* 2233973 */     GIR_EraseRootFromParent_Done,
     /* 2233974 */   // Label 29730: @2233974
     /* 2233974 */   GIM_Reject,
     /* 2233975 */ // Label 29728: @2233975
     /* 2233975 */ GIM_Reject,
     /* 2233976 */ // Label 29696: @2233976
     /* 2233976 */ GIM_Try, /*On fail goto*//*Label 29731*/ GIMT_Encode4(2234090),
     /* 2233981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2233984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2233987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233991 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233995 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233999 */   GIM_Try, /*On fail goto*//*Label 29732*/ GIMT_Encode4(2234044), // Rule ID 59414 //
     /* 2234004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234007 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234043 */     // GIR_Coverage, 59414,
     /* 2234043 */     GIR_EraseRootFromParent_Done,
     /* 2234044 */   // Label 29732: @2234044
     /* 2234044 */   GIM_Try, /*On fail goto*//*Label 29733*/ GIMT_Encode4(2234089), // Rule ID 59415 //
     /* 2234049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234052 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2234055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234088 */     // GIR_Coverage, 59415,
     /* 2234088 */     GIR_EraseRootFromParent_Done,
     /* 2234089 */   // Label 29733: @2234089
     /* 2234089 */   GIM_Reject,
     /* 2234090 */ // Label 29731: @2234090
     /* 2234090 */ GIM_Reject,
     /* 2234091 */ // Label 29697: @2234091
     /* 2234091 */ GIM_Try, /*On fail goto*//*Label 29734*/ GIMT_Encode4(2234205),
     /* 2234096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2234099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2234102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234114 */   GIM_Try, /*On fail goto*//*Label 29735*/ GIMT_Encode4(2234159), // Rule ID 59422 //
     /* 2234119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234122 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2234125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234158 */     // GIR_Coverage, 59422,
     /* 2234158 */     GIR_EraseRootFromParent_Done,
     /* 2234159 */   // Label 29735: @2234159
     /* 2234159 */   GIM_Try, /*On fail goto*//*Label 29736*/ GIMT_Encode4(2234204), // Rule ID 59423 //
     /* 2234164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234167 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2234170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234203 */     // GIR_Coverage, 59423,
     /* 2234203 */     GIR_EraseRootFromParent_Done,
     /* 2234204 */   // Label 29736: @2234204
     /* 2234204 */   GIM_Reject,
     /* 2234205 */ // Label 29734: @2234205
     /* 2234205 */ GIM_Reject,
     /* 2234206 */ // Label 29698: @2234206
     /* 2234206 */ GIM_Try, /*On fail goto*//*Label 29737*/ GIMT_Encode4(2234320),
     /* 2234211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2234214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234229 */   GIM_Try, /*On fail goto*//*Label 29738*/ GIMT_Encode4(2234274), // Rule ID 59438 //
     /* 2234234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2234237 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2234240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234273 */     // GIR_Coverage, 59438,
     /* 2234273 */     GIR_EraseRootFromParent_Done,
     /* 2234274 */   // Label 29738: @2234274
     /* 2234274 */   GIM_Try, /*On fail goto*//*Label 29739*/ GIMT_Encode4(2234319), // Rule ID 59439 //
     /* 2234279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2234282 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2234285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234318 */     // GIR_Coverage, 59439,
     /* 2234318 */     GIR_EraseRootFromParent_Done,
     /* 2234319 */   // Label 29739: @2234319
     /* 2234319 */   GIM_Reject,
     /* 2234320 */ // Label 29737: @2234320
     /* 2234320 */ GIM_Reject,
     /* 2234321 */ // Label 29699: @2234321
     /* 2234321 */ GIM_Try, /*On fail goto*//*Label 29740*/ GIMT_Encode4(2234435),
     /* 2234326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2234329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2234332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234344 */   GIM_Try, /*On fail goto*//*Label 29741*/ GIMT_Encode4(2234389), // Rule ID 59406 //
     /* 2234349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234352 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2234355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234388 */     // GIR_Coverage, 59406,
     /* 2234388 */     GIR_EraseRootFromParent_Done,
     /* 2234389 */   // Label 29741: @2234389
     /* 2234389 */   GIM_Try, /*On fail goto*//*Label 29742*/ GIMT_Encode4(2234434), // Rule ID 59407 //
     /* 2234394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234397 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2234400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2234414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234433 */     // GIR_Coverage, 59407,
     /* 2234433 */     GIR_EraseRootFromParent_Done,
     /* 2234434 */   // Label 29742: @2234434
     /* 2234434 */   GIM_Reject,
     /* 2234435 */ // Label 29740: @2234435
     /* 2234435 */ GIM_Reject,
     /* 2234436 */ // Label 29700: @2234436
     /* 2234436 */ GIM_Try, /*On fail goto*//*Label 29743*/ GIMT_Encode4(2234550),
     /* 2234441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2234444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2234447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234459 */   GIM_Try, /*On fail goto*//*Label 29744*/ GIMT_Encode4(2234504), // Rule ID 59418 //
     /* 2234464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234467 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2234470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234503 */     // GIR_Coverage, 59418,
     /* 2234503 */     GIR_EraseRootFromParent_Done,
     /* 2234504 */   // Label 29744: @2234504
     /* 2234504 */   GIM_Try, /*On fail goto*//*Label 29745*/ GIMT_Encode4(2234549), // Rule ID 59419 //
     /* 2234509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234512 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2234515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234548 */     // GIR_Coverage, 59419,
     /* 2234548 */     GIR_EraseRootFromParent_Done,
     /* 2234549 */   // Label 29745: @2234549
     /* 2234549 */   GIM_Reject,
     /* 2234550 */ // Label 29743: @2234550
     /* 2234550 */ GIM_Reject,
     /* 2234551 */ // Label 29701: @2234551
     /* 2234551 */ GIM_Try, /*On fail goto*//*Label 29746*/ GIMT_Encode4(2234665),
     /* 2234556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2234559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2234562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234574 */   GIM_Try, /*On fail goto*//*Label 29747*/ GIMT_Encode4(2234619), // Rule ID 59434 //
     /* 2234579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234582 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2234585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234618 */     // GIR_Coverage, 59434,
     /* 2234618 */     GIR_EraseRootFromParent_Done,
     /* 2234619 */   // Label 29747: @2234619
     /* 2234619 */   GIM_Try, /*On fail goto*//*Label 29748*/ GIMT_Encode4(2234664), // Rule ID 59435 //
     /* 2234624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234627 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2234630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234663 */     // GIR_Coverage, 59435,
     /* 2234663 */     GIR_EraseRootFromParent_Done,
     /* 2234664 */   // Label 29748: @2234664
     /* 2234664 */   GIM_Reject,
     /* 2234665 */ // Label 29746: @2234665
     /* 2234665 */ GIM_Reject,
     /* 2234666 */ // Label 29702: @2234666
     /* 2234666 */ GIM_Try, /*On fail goto*//*Label 29749*/ GIMT_Encode4(2234780),
     /* 2234671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2234674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2234677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2234681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2234685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2234689 */   GIM_Try, /*On fail goto*//*Label 29750*/ GIMT_Encode4(2234734), // Rule ID 59478 //
     /* 2234694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2234697 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2234700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2234714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234733 */     // GIR_Coverage, 59478,
     /* 2234733 */     GIR_EraseRootFromParent_Done,
     /* 2234734 */   // Label 29750: @2234734
     /* 2234734 */   GIM_Try, /*On fail goto*//*Label 29751*/ GIMT_Encode4(2234779), // Rule ID 59479 //
     /* 2234739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2234742 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2234745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2234759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234778 */     // GIR_Coverage, 59479,
     /* 2234778 */     GIR_EraseRootFromParent_Done,
     /* 2234779 */   // Label 29751: @2234779
     /* 2234779 */   GIM_Reject,
     /* 2234780 */ // Label 29749: @2234780
     /* 2234780 */ GIM_Reject,
     /* 2234781 */ // Label 29703: @2234781
     /* 2234781 */ GIM_Try, /*On fail goto*//*Label 29752*/ GIMT_Encode4(2234895),
     /* 2234786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2234789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2234792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234804 */   GIM_Try, /*On fail goto*//*Label 29753*/ GIMT_Encode4(2234849), // Rule ID 59410 //
     /* 2234809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234812 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2234815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234848 */     // GIR_Coverage, 59410,
     /* 2234848 */     GIR_EraseRootFromParent_Done,
     /* 2234849 */   // Label 29753: @2234849
     /* 2234849 */   GIM_Try, /*On fail goto*//*Label 29754*/ GIMT_Encode4(2234894), // Rule ID 59411 //
     /* 2234854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234857 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2234860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2234874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234893 */     // GIR_Coverage, 59411,
     /* 2234893 */     GIR_EraseRootFromParent_Done,
     /* 2234894 */   // Label 29754: @2234894
     /* 2234894 */   GIM_Reject,
     /* 2234895 */ // Label 29752: @2234895
     /* 2234895 */ GIM_Reject,
     /* 2234896 */ // Label 29704: @2234896
     /* 2234896 */ GIM_Try, /*On fail goto*//*Label 29755*/ GIMT_Encode4(2235010),
     /* 2234901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2234904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2234907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234919 */   GIM_Try, /*On fail goto*//*Label 29756*/ GIMT_Encode4(2234964), // Rule ID 59430 //
     /* 2234924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234927 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2234930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2234963 */     // GIR_Coverage, 59430,
     /* 2234963 */     GIR_EraseRootFromParent_Done,
     /* 2234964 */   // Label 29756: @2234964
     /* 2234964 */   GIM_Try, /*On fail goto*//*Label 29757*/ GIMT_Encode4(2235009), // Rule ID 59431 //
     /* 2234969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234972 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2234975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2234979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2234984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2234986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2234989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2234994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2234996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235008 */     // GIR_Coverage, 59431,
     /* 2235008 */     GIR_EraseRootFromParent_Done,
     /* 2235009 */   // Label 29757: @2235009
     /* 2235009 */   GIM_Reject,
     /* 2235010 */ // Label 29755: @2235010
     /* 2235010 */ GIM_Reject,
     /* 2235011 */ // Label 29705: @2235011
     /* 2235011 */ GIM_Try, /*On fail goto*//*Label 29758*/ GIMT_Encode4(2235125),
     /* 2235016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2235019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2235022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235034 */   GIM_Try, /*On fail goto*//*Label 29759*/ GIMT_Encode4(2235079), // Rule ID 59466 //
     /* 2235039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235042 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235078 */     // GIR_Coverage, 59466,
     /* 2235078 */     GIR_EraseRootFromParent_Done,
     /* 2235079 */   // Label 29759: @2235079
     /* 2235079 */   GIM_Try, /*On fail goto*//*Label 29760*/ GIMT_Encode4(2235124), // Rule ID 59467 //
     /* 2235084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235087 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2235090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235123 */     // GIR_Coverage, 59467,
     /* 2235123 */     GIR_EraseRootFromParent_Done,
     /* 2235124 */   // Label 29760: @2235124
     /* 2235124 */   GIM_Reject,
     /* 2235125 */ // Label 29758: @2235125
     /* 2235125 */ GIM_Reject,
     /* 2235126 */ // Label 29706: @2235126
     /* 2235126 */ GIM_Try, /*On fail goto*//*Label 29761*/ GIMT_Encode4(2235240),
     /* 2235131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2235134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2235137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235149 */   GIM_Try, /*On fail goto*//*Label 29762*/ GIMT_Encode4(2235194), // Rule ID 59482 //
     /* 2235154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235157 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2235160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235193 */     // GIR_Coverage, 59482,
     /* 2235193 */     GIR_EraseRootFromParent_Done,
     /* 2235194 */   // Label 29762: @2235194
     /* 2235194 */   GIM_Try, /*On fail goto*//*Label 29763*/ GIMT_Encode4(2235239), // Rule ID 59483 //
     /* 2235199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235202 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2235205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235238 */     // GIR_Coverage, 59483,
     /* 2235238 */     GIR_EraseRootFromParent_Done,
     /* 2235239 */   // Label 29763: @2235239
     /* 2235239 */   GIM_Reject,
     /* 2235240 */ // Label 29761: @2235240
     /* 2235240 */ GIM_Reject,
     /* 2235241 */ // Label 29707: @2235241
     /* 2235241 */ GIM_Try, /*On fail goto*//*Label 29764*/ GIMT_Encode4(2235355),
     /* 2235246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2235249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2235252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235264 */   GIM_Try, /*On fail goto*//*Label 29765*/ GIMT_Encode4(2235309), // Rule ID 59426 //
     /* 2235269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235272 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2235275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235308 */     // GIR_Coverage, 59426,
     /* 2235308 */     GIR_EraseRootFromParent_Done,
     /* 2235309 */   // Label 29765: @2235309
     /* 2235309 */   GIM_Try, /*On fail goto*//*Label 29766*/ GIMT_Encode4(2235354), // Rule ID 59427 //
     /* 2235314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235317 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2235320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2235334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235353 */     // GIR_Coverage, 59427,
     /* 2235353 */     GIR_EraseRootFromParent_Done,
     /* 2235354 */   // Label 29766: @2235354
     /* 2235354 */   GIM_Reject,
     /* 2235355 */ // Label 29764: @2235355
     /* 2235355 */ GIM_Reject,
     /* 2235356 */ // Label 29708: @2235356
     /* 2235356 */ GIM_Try, /*On fail goto*//*Label 29767*/ GIMT_Encode4(2235470),
     /* 2235361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2235364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2235367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235379 */   GIM_Try, /*On fail goto*//*Label 29768*/ GIMT_Encode4(2235424), // Rule ID 59454 //
     /* 2235384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235387 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2235390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235423 */     // GIR_Coverage, 59454,
     /* 2235423 */     GIR_EraseRootFromParent_Done,
     /* 2235424 */   // Label 29768: @2235424
     /* 2235424 */   GIM_Try, /*On fail goto*//*Label 29769*/ GIMT_Encode4(2235469), // Rule ID 59455 //
     /* 2235429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235432 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2235435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235468 */     // GIR_Coverage, 59455,
     /* 2235468 */     GIR_EraseRootFromParent_Done,
     /* 2235469 */   // Label 29769: @2235469
     /* 2235469 */   GIM_Reject,
     /* 2235470 */ // Label 29767: @2235470
     /* 2235470 */ GIM_Reject,
     /* 2235471 */ // Label 29709: @2235471
     /* 2235471 */ GIM_Try, /*On fail goto*//*Label 29770*/ GIMT_Encode4(2235585),
     /* 2235476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2235479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2235482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235494 */   GIM_Try, /*On fail goto*//*Label 29771*/ GIMT_Encode4(2235539), // Rule ID 59470 //
     /* 2235499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235502 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2235505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235538 */     // GIR_Coverage, 59470,
     /* 2235538 */     GIR_EraseRootFromParent_Done,
     /* 2235539 */   // Label 29771: @2235539
     /* 2235539 */   GIM_Try, /*On fail goto*//*Label 29772*/ GIMT_Encode4(2235584), // Rule ID 59471 //
     /* 2235544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235547 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2235550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235583 */     // GIR_Coverage, 59471,
     /* 2235583 */     GIR_EraseRootFromParent_Done,
     /* 2235584 */   // Label 29772: @2235584
     /* 2235584 */   GIM_Reject,
     /* 2235585 */ // Label 29770: @2235585
     /* 2235585 */ GIM_Reject,
     /* 2235586 */ // Label 29710: @2235586
     /* 2235586 */ GIM_Try, /*On fail goto*//*Label 29773*/ GIMT_Encode4(2235700),
     /* 2235591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2235594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2235597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235609 */   GIM_Try, /*On fail goto*//*Label 29774*/ GIMT_Encode4(2235654), // Rule ID 59486 //
     /* 2235614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235617 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2235620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2235634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235653 */     // GIR_Coverage, 59486,
     /* 2235653 */     GIR_EraseRootFromParent_Done,
     /* 2235654 */   // Label 29774: @2235654
     /* 2235654 */   GIM_Try, /*On fail goto*//*Label 29775*/ GIMT_Encode4(2235699), // Rule ID 59487 //
     /* 2235659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235662 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2235665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2235679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235698 */     // GIR_Coverage, 59487,
     /* 2235698 */     GIR_EraseRootFromParent_Done,
     /* 2235699 */   // Label 29775: @2235699
     /* 2235699 */   GIM_Reject,
     /* 2235700 */ // Label 29773: @2235700
     /* 2235700 */ GIM_Reject,
     /* 2235701 */ // Label 29711: @2235701
     /* 2235701 */ GIM_Try, /*On fail goto*//*Label 29776*/ GIMT_Encode4(2235815),
     /* 2235706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2235709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2235712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235724 */   GIM_Try, /*On fail goto*//*Label 29777*/ GIMT_Encode4(2235769), // Rule ID 59442 //
     /* 2235729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235732 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2235735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235768 */     // GIR_Coverage, 59442,
     /* 2235768 */     GIR_EraseRootFromParent_Done,
     /* 2235769 */   // Label 29777: @2235769
     /* 2235769 */   GIM_Try, /*On fail goto*//*Label 29778*/ GIMT_Encode4(2235814), // Rule ID 59443 //
     /* 2235774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235777 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2235780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2235794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235813 */     // GIR_Coverage, 59443,
     /* 2235813 */     GIR_EraseRootFromParent_Done,
     /* 2235814 */   // Label 29778: @2235814
     /* 2235814 */   GIM_Reject,
     /* 2235815 */ // Label 29776: @2235815
     /* 2235815 */ GIM_Reject,
     /* 2235816 */ // Label 29712: @2235816
     /* 2235816 */ GIM_Try, /*On fail goto*//*Label 29779*/ GIMT_Encode4(2235930),
     /* 2235821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2235824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2235827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2235839 */   GIM_Try, /*On fail goto*//*Label 29780*/ GIMT_Encode4(2235884), // Rule ID 59458 //
     /* 2235844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235847 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2235850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235883 */     // GIR_Coverage, 59458,
     /* 2235883 */     GIR_EraseRootFromParent_Done,
     /* 2235884 */   // Label 29780: @2235884
     /* 2235884 */   GIM_Try, /*On fail goto*//*Label 29781*/ GIMT_Encode4(2235929), // Rule ID 59459 //
     /* 2235889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235892 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2235895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2235909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235928 */     // GIR_Coverage, 59459,
     /* 2235928 */     GIR_EraseRootFromParent_Done,
     /* 2235929 */   // Label 29781: @2235929
     /* 2235929 */   GIM_Reject,
     /* 2235930 */ // Label 29779: @2235930
     /* 2235930 */ GIM_Reject,
     /* 2235931 */ // Label 29713: @2235931
     /* 2235931 */ GIM_Try, /*On fail goto*//*Label 29782*/ GIMT_Encode4(2236045),
     /* 2235936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2235939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2235942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2235954 */   GIM_Try, /*On fail goto*//*Label 29783*/ GIMT_Encode4(2235999), // Rule ID 59474 //
     /* 2235959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235962 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2235965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2235969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2235974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2235976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2235979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2235984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2235986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2235988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2235998 */     // GIR_Coverage, 59474,
     /* 2235998 */     GIR_EraseRootFromParent_Done,
     /* 2235999 */   // Label 29783: @2235999
     /* 2235999 */   GIM_Try, /*On fail goto*//*Label 29784*/ GIMT_Encode4(2236044), // Rule ID 59475 //
     /* 2236004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236007 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2236010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236043 */     // GIR_Coverage, 59475,
     /* 2236043 */     GIR_EraseRootFromParent_Done,
     /* 2236044 */   // Label 29784: @2236044
     /* 2236044 */   GIM_Reject,
     /* 2236045 */ // Label 29782: @2236045
     /* 2236045 */ GIM_Reject,
     /* 2236046 */ // Label 29714: @2236046
     /* 2236046 */ GIM_Try, /*On fail goto*//*Label 29785*/ GIMT_Encode4(2236160),
     /* 2236051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2236054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2236057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2236069 */   GIM_Try, /*On fail goto*//*Label 29786*/ GIMT_Encode4(2236114), // Rule ID 59446 //
     /* 2236074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236077 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2236080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236113 */     // GIR_Coverage, 59446,
     /* 2236113 */     GIR_EraseRootFromParent_Done,
     /* 2236114 */   // Label 29786: @2236114
     /* 2236114 */   GIM_Try, /*On fail goto*//*Label 29787*/ GIMT_Encode4(2236159), // Rule ID 59447 //
     /* 2236119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236122 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2236125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2236139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236158 */     // GIR_Coverage, 59447,
     /* 2236158 */     GIR_EraseRootFromParent_Done,
     /* 2236159 */   // Label 29787: @2236159
     /* 2236159 */   GIM_Reject,
     /* 2236160 */ // Label 29785: @2236160
     /* 2236160 */ GIM_Reject,
     /* 2236161 */ // Label 29715: @2236161
     /* 2236161 */ GIM_Try, /*On fail goto*//*Label 29788*/ GIMT_Encode4(2236275),
     /* 2236166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2236169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2236172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236184 */   GIM_Try, /*On fail goto*//*Label 29789*/ GIMT_Encode4(2236229), // Rule ID 59462 //
     /* 2236189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236192 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2236195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236228 */     // GIR_Coverage, 59462,
     /* 2236228 */     GIR_EraseRootFromParent_Done,
     /* 2236229 */   // Label 29789: @2236229
     /* 2236229 */   GIM_Try, /*On fail goto*//*Label 29790*/ GIMT_Encode4(2236274), // Rule ID 59463 //
     /* 2236234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236237 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2236240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236273 */     // GIR_Coverage, 59463,
     /* 2236273 */     GIR_EraseRootFromParent_Done,
     /* 2236274 */   // Label 29790: @2236274
     /* 2236274 */   GIM_Reject,
     /* 2236275 */ // Label 29788: @2236275
     /* 2236275 */ GIM_Reject,
     /* 2236276 */ // Label 29716: @2236276
     /* 2236276 */ GIM_Try, /*On fail goto*//*Label 29791*/ GIMT_Encode4(2236390),
     /* 2236281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2236284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2236287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2236299 */   GIM_Try, /*On fail goto*//*Label 29792*/ GIMT_Encode4(2236344), // Rule ID 59450 //
     /* 2236304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236307 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2236310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236343 */     // GIR_Coverage, 59450,
     /* 2236343 */     GIR_EraseRootFromParent_Done,
     /* 2236344 */   // Label 29792: @2236344
     /* 2236344 */   GIM_Try, /*On fail goto*//*Label 29793*/ GIMT_Encode4(2236389), // Rule ID 59451 //
     /* 2236349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236352 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2236355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2236369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236388 */     // GIR_Coverage, 59451,
     /* 2236388 */     GIR_EraseRootFromParent_Done,
     /* 2236389 */   // Label 29793: @2236389
     /* 2236389 */   GIM_Reject,
     /* 2236390 */ // Label 29791: @2236390
     /* 2236390 */ GIM_Reject,
     /* 2236391 */ // Label 29717: @2236391
     /* 2236391 */ GIM_Reject,
     /* 2236392 */ // Label 47: @2236392
     /* 2236392 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29818*/ GIMT_Encode4(2239301),
     /* 2236403 */ /*GILLT_s32*//*Label 29794*/ GIMT_Encode4(2236527),
     /* 2236407 */ /*GILLT_s64*//*Label 29795*/ GIMT_Encode4(2236649), GIMT_Encode4(0),
     /* 2236415 */ /*GILLT_nxv1s8*//*Label 29796*/ GIMT_Encode4(2236771),
     /* 2236419 */ /*GILLT_nxv1s16*//*Label 29797*/ GIMT_Encode4(2236886),
     /* 2236423 */ /*GILLT_nxv1s32*//*Label 29798*/ GIMT_Encode4(2237001),
     /* 2236427 */ /*GILLT_nxv1s64*//*Label 29799*/ GIMT_Encode4(2237116), GIMT_Encode4(0),
     /* 2236435 */ /*GILLT_nxv2s8*//*Label 29800*/ GIMT_Encode4(2237231),
     /* 2236439 */ /*GILLT_nxv2s16*//*Label 29801*/ GIMT_Encode4(2237346),
     /* 2236443 */ /*GILLT_nxv2s32*//*Label 29802*/ GIMT_Encode4(2237461),
     /* 2236447 */ /*GILLT_nxv2s64*//*Label 29803*/ GIMT_Encode4(2237576), GIMT_Encode4(0),
     /* 2236455 */ /*GILLT_nxv4s8*//*Label 29804*/ GIMT_Encode4(2237691),
     /* 2236459 */ /*GILLT_nxv4s16*//*Label 29805*/ GIMT_Encode4(2237806),
     /* 2236463 */ /*GILLT_nxv4s32*//*Label 29806*/ GIMT_Encode4(2237921),
     /* 2236467 */ /*GILLT_nxv4s64*//*Label 29807*/ GIMT_Encode4(2238036), GIMT_Encode4(0),
     /* 2236475 */ /*GILLT_nxv8s8*//*Label 29808*/ GIMT_Encode4(2238151),
     /* 2236479 */ /*GILLT_nxv8s16*//*Label 29809*/ GIMT_Encode4(2238266),
     /* 2236483 */ /*GILLT_nxv8s32*//*Label 29810*/ GIMT_Encode4(2238381),
     /* 2236487 */ /*GILLT_nxv8s64*//*Label 29811*/ GIMT_Encode4(2238496), GIMT_Encode4(0),
     /* 2236495 */ /*GILLT_nxv16s8*//*Label 29812*/ GIMT_Encode4(2238611),
     /* 2236499 */ /*GILLT_nxv16s16*//*Label 29813*/ GIMT_Encode4(2238726),
     /* 2236503 */ /*GILLT_nxv16s32*//*Label 29814*/ GIMT_Encode4(2238841), GIMT_Encode4(0),
     /* 2236511 */ /*GILLT_nxv32s8*//*Label 29815*/ GIMT_Encode4(2238956),
     /* 2236515 */ /*GILLT_nxv32s16*//*Label 29816*/ GIMT_Encode4(2239071), GIMT_Encode4(0),
     /* 2236523 */ /*GILLT_nxv64s8*//*Label 29817*/ GIMT_Encode4(2239186),
     /* 2236527 */ // Label 29794: @2236527
     /* 2236527 */ GIM_Try, /*On fail goto*//*Label 29819*/ GIMT_Encode4(2236648),
     /* 2236532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2236535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2236538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236542 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236546 */   GIM_Try, /*On fail goto*//*Label 29820*/ GIMT_Encode4(2236582), // Rule ID 2461 //
     /* 2236551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2236554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2236562 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2236566 */     // MIs[1] Operand 1
     /* 2236566 */     // No operand predicates
     /* 2236566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236568 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2236568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2236571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236575 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2236580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236581 */     // GIR_Coverage, 2461,
     /* 2236581 */     GIR_EraseRootFromParent_Done,
     /* 2236582 */   // Label 29820: @2236582
     /* 2236582 */   GIM_Try, /*On fail goto*//*Label 29821*/ GIMT_Encode4(2236618), // Rule ID 62552 //
     /* 2236587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2236590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2236598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2236602 */     // MIs[1] Operand 1
     /* 2236602 */     // No operand predicates
     /* 2236602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236604 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2236604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2236607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236611 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2236616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236617 */     // GIR_Coverage, 62552,
     /* 2236617 */     GIR_EraseRootFromParent_Done,
     /* 2236618 */   // Label 29821: @2236618
     /* 2236618 */   GIM_Try, /*On fail goto*//*Label 29822*/ GIMT_Encode4(2236647), // Rule ID 2455 //
     /* 2236623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2236626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2236633 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2236633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2236636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2236645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236646 */     // GIR_Coverage, 2455,
     /* 2236646 */     GIR_EraseRootFromParent_Done,
     /* 2236647 */   // Label 29822: @2236647
     /* 2236647 */   GIM_Reject,
     /* 2236648 */ // Label 29819: @2236648
     /* 2236648 */ GIM_Reject,
     /* 2236649 */ // Label 29795: @2236649
     /* 2236649 */ GIM_Try, /*On fail goto*//*Label 29823*/ GIMT_Encode4(2236770),
     /* 2236654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2236657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2236660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2236668 */   GIM_Try, /*On fail goto*//*Label 29824*/ GIMT_Encode4(2236704), // Rule ID 2460 //
     /* 2236673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2236676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2236684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2236688 */     // MIs[1] Operand 1
     /* 2236688 */     // No operand predicates
     /* 2236688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236690 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2236690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2236693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236697 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2236702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236703 */     // GIR_Coverage, 2460,
     /* 2236703 */     GIR_EraseRootFromParent_Done,
     /* 2236704 */   // Label 29824: @2236704
     /* 2236704 */   GIM_Try, /*On fail goto*//*Label 29825*/ GIMT_Encode4(2236740), // Rule ID 62551 //
     /* 2236709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2236712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2236716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2236720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2236724 */     // MIs[1] Operand 1
     /* 2236724 */     // No operand predicates
     /* 2236724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2236726 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2236726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2236729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236733 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2236738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236739 */     // GIR_Coverage, 62551,
     /* 2236739 */     GIR_EraseRootFromParent_Done,
     /* 2236740 */   // Label 29825: @2236740
     /* 2236740 */   GIM_Try, /*On fail goto*//*Label 29826*/ GIMT_Encode4(2236769), // Rule ID 2454 //
     /* 2236745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2236748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2236755 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2236755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2236758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2236767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236768 */     // GIR_Coverage, 2454,
     /* 2236768 */     GIR_EraseRootFromParent_Done,
     /* 2236769 */   // Label 29826: @2236769
     /* 2236769 */   GIM_Reject,
     /* 2236770 */ // Label 29823: @2236770
     /* 2236770 */ GIM_Reject,
     /* 2236771 */ // Label 29796: @2236771
     /* 2236771 */ GIM_Try, /*On fail goto*//*Label 29827*/ GIMT_Encode4(2236885),
     /* 2236776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2236779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2236782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236794 */   GIM_Try, /*On fail goto*//*Label 29828*/ GIMT_Encode4(2236839), // Rule ID 59270 //
     /* 2236799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236802 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2236805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2236819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236838 */     // GIR_Coverage, 59270,
     /* 2236838 */     GIR_EraseRootFromParent_Done,
     /* 2236839 */   // Label 29828: @2236839
     /* 2236839 */   GIM_Try, /*On fail goto*//*Label 29829*/ GIMT_Encode4(2236884), // Rule ID 59271 //
     /* 2236844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236847 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2236850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2236864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236883 */     // GIR_Coverage, 59271,
     /* 2236883 */     GIR_EraseRootFromParent_Done,
     /* 2236884 */   // Label 29829: @2236884
     /* 2236884 */   GIM_Reject,
     /* 2236885 */ // Label 29827: @2236885
     /* 2236885 */ GIM_Reject,
     /* 2236886 */ // Label 29797: @2236886
     /* 2236886 */ GIM_Try, /*On fail goto*//*Label 29830*/ GIMT_Encode4(2237000),
     /* 2236891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2236894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2236897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236909 */   GIM_Try, /*On fail goto*//*Label 29831*/ GIMT_Encode4(2236954), // Rule ID 59282 //
     /* 2236914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236917 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2236920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2236934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236953 */     // GIR_Coverage, 59282,
     /* 2236953 */     GIR_EraseRootFromParent_Done,
     /* 2236954 */   // Label 29831: @2236954
     /* 2236954 */   GIM_Try, /*On fail goto*//*Label 29832*/ GIMT_Encode4(2236999), // Rule ID 59283 //
     /* 2236959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236962 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2236965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2236969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2236974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2236976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2236979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2236984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2236986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2236998 */     // GIR_Coverage, 59283,
     /* 2236998 */     GIR_EraseRootFromParent_Done,
     /* 2236999 */   // Label 29832: @2236999
     /* 2236999 */   GIM_Reject,
     /* 2237000 */ // Label 29830: @2237000
     /* 2237000 */ GIM_Reject,
     /* 2237001 */ // Label 29798: @2237001
     /* 2237001 */ GIM_Try, /*On fail goto*//*Label 29833*/ GIMT_Encode4(2237115),
     /* 2237006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2237009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2237012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237024 */   GIM_Try, /*On fail goto*//*Label 29834*/ GIMT_Encode4(2237069), // Rule ID 59290 //
     /* 2237029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237032 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2237035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237068 */     // GIR_Coverage, 59290,
     /* 2237068 */     GIR_EraseRootFromParent_Done,
     /* 2237069 */   // Label 29834: @2237069
     /* 2237069 */   GIM_Try, /*On fail goto*//*Label 29835*/ GIMT_Encode4(2237114), // Rule ID 59291 //
     /* 2237074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237077 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2237080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237113 */     // GIR_Coverage, 59291,
     /* 2237113 */     GIR_EraseRootFromParent_Done,
     /* 2237114 */   // Label 29835: @2237114
     /* 2237114 */   GIM_Reject,
     /* 2237115 */ // Label 29833: @2237115
     /* 2237115 */ GIM_Reject,
     /* 2237116 */ // Label 29799: @2237116
     /* 2237116 */ GIM_Try, /*On fail goto*//*Label 29836*/ GIMT_Encode4(2237230),
     /* 2237121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2237124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2237127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237139 */   GIM_Try, /*On fail goto*//*Label 29837*/ GIMT_Encode4(2237184), // Rule ID 59306 //
     /* 2237144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237147 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2237150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237183 */     // GIR_Coverage, 59306,
     /* 2237183 */     GIR_EraseRootFromParent_Done,
     /* 2237184 */   // Label 29837: @2237184
     /* 2237184 */   GIM_Try, /*On fail goto*//*Label 29838*/ GIMT_Encode4(2237229), // Rule ID 59307 //
     /* 2237189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237192 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2237195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237228 */     // GIR_Coverage, 59307,
     /* 2237228 */     GIR_EraseRootFromParent_Done,
     /* 2237229 */   // Label 29838: @2237229
     /* 2237229 */   GIM_Reject,
     /* 2237230 */ // Label 29836: @2237230
     /* 2237230 */ GIM_Reject,
     /* 2237231 */ // Label 29800: @2237231
     /* 2237231 */ GIM_Try, /*On fail goto*//*Label 29839*/ GIMT_Encode4(2237345),
     /* 2237236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2237239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2237242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237254 */   GIM_Try, /*On fail goto*//*Label 29840*/ GIMT_Encode4(2237299), // Rule ID 59274 //
     /* 2237259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237262 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2237265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237298 */     // GIR_Coverage, 59274,
     /* 2237298 */     GIR_EraseRootFromParent_Done,
     /* 2237299 */   // Label 29840: @2237299
     /* 2237299 */   GIM_Try, /*On fail goto*//*Label 29841*/ GIMT_Encode4(2237344), // Rule ID 59275 //
     /* 2237304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237307 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2237310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2237324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237343 */     // GIR_Coverage, 59275,
     /* 2237343 */     GIR_EraseRootFromParent_Done,
     /* 2237344 */   // Label 29841: @2237344
     /* 2237344 */   GIM_Reject,
     /* 2237345 */ // Label 29839: @2237345
     /* 2237345 */ GIM_Reject,
     /* 2237346 */ // Label 29801: @2237346
     /* 2237346 */ GIM_Try, /*On fail goto*//*Label 29842*/ GIMT_Encode4(2237460),
     /* 2237351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2237354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2237357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237369 */   GIM_Try, /*On fail goto*//*Label 29843*/ GIMT_Encode4(2237414), // Rule ID 59286 //
     /* 2237374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237377 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2237380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237413 */     // GIR_Coverage, 59286,
     /* 2237413 */     GIR_EraseRootFromParent_Done,
     /* 2237414 */   // Label 29843: @2237414
     /* 2237414 */   GIM_Try, /*On fail goto*//*Label 29844*/ GIMT_Encode4(2237459), // Rule ID 59287 //
     /* 2237419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237422 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2237425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237458 */     // GIR_Coverage, 59287,
     /* 2237458 */     GIR_EraseRootFromParent_Done,
     /* 2237459 */   // Label 29844: @2237459
     /* 2237459 */   GIM_Reject,
     /* 2237460 */ // Label 29842: @2237460
     /* 2237460 */ GIM_Reject,
     /* 2237461 */ // Label 29802: @2237461
     /* 2237461 */ GIM_Try, /*On fail goto*//*Label 29845*/ GIMT_Encode4(2237575),
     /* 2237466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2237469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237484 */   GIM_Try, /*On fail goto*//*Label 29846*/ GIMT_Encode4(2237529), // Rule ID 59302 //
     /* 2237489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237492 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237528 */     // GIR_Coverage, 59302,
     /* 2237528 */     GIR_EraseRootFromParent_Done,
     /* 2237529 */   // Label 29846: @2237529
     /* 2237529 */   GIM_Try, /*On fail goto*//*Label 29847*/ GIMT_Encode4(2237574), // Rule ID 59303 //
     /* 2237534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237537 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2237540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237573 */     // GIR_Coverage, 59303,
     /* 2237573 */     GIR_EraseRootFromParent_Done,
     /* 2237574 */   // Label 29847: @2237574
     /* 2237574 */   GIM_Reject,
     /* 2237575 */ // Label 29845: @2237575
     /* 2237575 */ GIM_Reject,
     /* 2237576 */ // Label 29803: @2237576
     /* 2237576 */ GIM_Try, /*On fail goto*//*Label 29848*/ GIMT_Encode4(2237690),
     /* 2237581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2237584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2237587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237599 */   GIM_Try, /*On fail goto*//*Label 29849*/ GIMT_Encode4(2237644), // Rule ID 59346 //
     /* 2237604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237607 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2237610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2237624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237643 */     // GIR_Coverage, 59346,
     /* 2237643 */     GIR_EraseRootFromParent_Done,
     /* 2237644 */   // Label 29849: @2237644
     /* 2237644 */   GIM_Try, /*On fail goto*//*Label 29850*/ GIMT_Encode4(2237689), // Rule ID 59347 //
     /* 2237649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237652 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2237655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2237669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237688 */     // GIR_Coverage, 59347,
     /* 2237688 */     GIR_EraseRootFromParent_Done,
     /* 2237689 */   // Label 29850: @2237689
     /* 2237689 */   GIM_Reject,
     /* 2237690 */ // Label 29848: @2237690
     /* 2237690 */ GIM_Reject,
     /* 2237691 */ // Label 29804: @2237691
     /* 2237691 */ GIM_Try, /*On fail goto*//*Label 29851*/ GIMT_Encode4(2237805),
     /* 2237696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2237699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2237702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237714 */   GIM_Try, /*On fail goto*//*Label 29852*/ GIMT_Encode4(2237759), // Rule ID 59278 //
     /* 2237719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237722 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2237725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237758 */     // GIR_Coverage, 59278,
     /* 2237758 */     GIR_EraseRootFromParent_Done,
     /* 2237759 */   // Label 29852: @2237759
     /* 2237759 */   GIM_Try, /*On fail goto*//*Label 29853*/ GIMT_Encode4(2237804), // Rule ID 59279 //
     /* 2237764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237767 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2237770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2237784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237803 */     // GIR_Coverage, 59279,
     /* 2237803 */     GIR_EraseRootFromParent_Done,
     /* 2237804 */   // Label 29853: @2237804
     /* 2237804 */   GIM_Reject,
     /* 2237805 */ // Label 29851: @2237805
     /* 2237805 */ GIM_Reject,
     /* 2237806 */ // Label 29805: @2237806
     /* 2237806 */ GIM_Try, /*On fail goto*//*Label 29854*/ GIMT_Encode4(2237920),
     /* 2237811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2237814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2237817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237829 */   GIM_Try, /*On fail goto*//*Label 29855*/ GIMT_Encode4(2237874), // Rule ID 59298 //
     /* 2237834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237837 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2237840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237873 */     // GIR_Coverage, 59298,
     /* 2237873 */     GIR_EraseRootFromParent_Done,
     /* 2237874 */   // Label 29855: @2237874
     /* 2237874 */   GIM_Try, /*On fail goto*//*Label 29856*/ GIMT_Encode4(2237919), // Rule ID 59299 //
     /* 2237879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237882 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2237885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2237899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237918 */     // GIR_Coverage, 59299,
     /* 2237918 */     GIR_EraseRootFromParent_Done,
     /* 2237919 */   // Label 29856: @2237919
     /* 2237919 */   GIM_Reject,
     /* 2237920 */ // Label 29854: @2237920
     /* 2237920 */ GIM_Reject,
     /* 2237921 */ // Label 29806: @2237921
     /* 2237921 */ GIM_Try, /*On fail goto*//*Label 29857*/ GIMT_Encode4(2238035),
     /* 2237926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2237929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2237932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237944 */   GIM_Try, /*On fail goto*//*Label 29858*/ GIMT_Encode4(2237989), // Rule ID 59334 //
     /* 2237949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237952 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2237955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2237959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2237964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2237966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2237969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2237974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2237976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2237988 */     // GIR_Coverage, 59334,
     /* 2237988 */     GIR_EraseRootFromParent_Done,
     /* 2237989 */   // Label 29858: @2237989
     /* 2237989 */   GIM_Try, /*On fail goto*//*Label 29859*/ GIMT_Encode4(2238034), // Rule ID 59335 //
     /* 2237994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237997 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2238000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238033 */     // GIR_Coverage, 59335,
     /* 2238033 */     GIR_EraseRootFromParent_Done,
     /* 2238034 */   // Label 29859: @2238034
     /* 2238034 */   GIM_Reject,
     /* 2238035 */ // Label 29857: @2238035
     /* 2238035 */ GIM_Reject,
     /* 2238036 */ // Label 29807: @2238036
     /* 2238036 */ GIM_Try, /*On fail goto*//*Label 29860*/ GIMT_Encode4(2238150),
     /* 2238041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2238044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2238047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238059 */   GIM_Try, /*On fail goto*//*Label 29861*/ GIMT_Encode4(2238104), // Rule ID 59350 //
     /* 2238064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238067 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238103 */     // GIR_Coverage, 59350,
     /* 2238103 */     GIR_EraseRootFromParent_Done,
     /* 2238104 */   // Label 29861: @2238104
     /* 2238104 */   GIM_Try, /*On fail goto*//*Label 29862*/ GIMT_Encode4(2238149), // Rule ID 59351 //
     /* 2238109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238112 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2238115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238148 */     // GIR_Coverage, 59351,
     /* 2238148 */     GIR_EraseRootFromParent_Done,
     /* 2238149 */   // Label 29862: @2238149
     /* 2238149 */   GIM_Reject,
     /* 2238150 */ // Label 29860: @2238150
     /* 2238150 */ GIM_Reject,
     /* 2238151 */ // Label 29808: @2238151
     /* 2238151 */ GIM_Try, /*On fail goto*//*Label 29863*/ GIMT_Encode4(2238265),
     /* 2238156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2238159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2238162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238174 */   GIM_Try, /*On fail goto*//*Label 29864*/ GIMT_Encode4(2238219), // Rule ID 59294 //
     /* 2238179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238182 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2238185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238218 */     // GIR_Coverage, 59294,
     /* 2238218 */     GIR_EraseRootFromParent_Done,
     /* 2238219 */   // Label 29864: @2238219
     /* 2238219 */   GIM_Try, /*On fail goto*//*Label 29865*/ GIMT_Encode4(2238264), // Rule ID 59295 //
     /* 2238224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238227 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2238230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2238244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238263 */     // GIR_Coverage, 59295,
     /* 2238263 */     GIR_EraseRootFromParent_Done,
     /* 2238264 */   // Label 29865: @2238264
     /* 2238264 */   GIM_Reject,
     /* 2238265 */ // Label 29863: @2238265
     /* 2238265 */ GIM_Reject,
     /* 2238266 */ // Label 29809: @2238266
     /* 2238266 */ GIM_Try, /*On fail goto*//*Label 29866*/ GIMT_Encode4(2238380),
     /* 2238271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2238274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2238277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238289 */   GIM_Try, /*On fail goto*//*Label 29867*/ GIMT_Encode4(2238334), // Rule ID 59322 //
     /* 2238294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238297 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238333 */     // GIR_Coverage, 59322,
     /* 2238333 */     GIR_EraseRootFromParent_Done,
     /* 2238334 */   // Label 29867: @2238334
     /* 2238334 */   GIM_Try, /*On fail goto*//*Label 29868*/ GIMT_Encode4(2238379), // Rule ID 59323 //
     /* 2238339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238342 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2238345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238378 */     // GIR_Coverage, 59323,
     /* 2238378 */     GIR_EraseRootFromParent_Done,
     /* 2238379 */   // Label 29868: @2238379
     /* 2238379 */   GIM_Reject,
     /* 2238380 */ // Label 29866: @2238380
     /* 2238380 */ GIM_Reject,
     /* 2238381 */ // Label 29810: @2238381
     /* 2238381 */ GIM_Try, /*On fail goto*//*Label 29869*/ GIMT_Encode4(2238495),
     /* 2238386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2238389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2238392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238404 */   GIM_Try, /*On fail goto*//*Label 29870*/ GIMT_Encode4(2238449), // Rule ID 59338 //
     /* 2238409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238412 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238448 */     // GIR_Coverage, 59338,
     /* 2238448 */     GIR_EraseRootFromParent_Done,
     /* 2238449 */   // Label 29870: @2238449
     /* 2238449 */   GIM_Try, /*On fail goto*//*Label 29871*/ GIMT_Encode4(2238494), // Rule ID 59339 //
     /* 2238454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238457 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2238460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238493 */     // GIR_Coverage, 59339,
     /* 2238493 */     GIR_EraseRootFromParent_Done,
     /* 2238494 */   // Label 29871: @2238494
     /* 2238494 */   GIM_Reject,
     /* 2238495 */ // Label 29869: @2238495
     /* 2238495 */ GIM_Reject,
     /* 2238496 */ // Label 29811: @2238496
     /* 2238496 */ GIM_Try, /*On fail goto*//*Label 29872*/ GIMT_Encode4(2238610),
     /* 2238501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2238504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2238507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238519 */   GIM_Try, /*On fail goto*//*Label 29873*/ GIMT_Encode4(2238564), // Rule ID 59354 //
     /* 2238524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238527 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2238530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2238544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238563 */     // GIR_Coverage, 59354,
     /* 2238563 */     GIR_EraseRootFromParent_Done,
     /* 2238564 */   // Label 29873: @2238564
     /* 2238564 */   GIM_Try, /*On fail goto*//*Label 29874*/ GIMT_Encode4(2238609), // Rule ID 59355 //
     /* 2238569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238572 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2238575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2238589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238608 */     // GIR_Coverage, 59355,
     /* 2238608 */     GIR_EraseRootFromParent_Done,
     /* 2238609 */   // Label 29874: @2238609
     /* 2238609 */   GIM_Reject,
     /* 2238610 */ // Label 29872: @2238610
     /* 2238610 */ GIM_Reject,
     /* 2238611 */ // Label 29812: @2238611
     /* 2238611 */ GIM_Try, /*On fail goto*//*Label 29875*/ GIMT_Encode4(2238725),
     /* 2238616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2238619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2238622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238634 */   GIM_Try, /*On fail goto*//*Label 29876*/ GIMT_Encode4(2238679), // Rule ID 59310 //
     /* 2238639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238642 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2238645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238678 */     // GIR_Coverage, 59310,
     /* 2238678 */     GIR_EraseRootFromParent_Done,
     /* 2238679 */   // Label 29876: @2238679
     /* 2238679 */   GIM_Try, /*On fail goto*//*Label 29877*/ GIMT_Encode4(2238724), // Rule ID 59311 //
     /* 2238684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238687 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2238690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2238704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238723 */     // GIR_Coverage, 59311,
     /* 2238723 */     GIR_EraseRootFromParent_Done,
     /* 2238724 */   // Label 29877: @2238724
     /* 2238724 */   GIM_Reject,
     /* 2238725 */ // Label 29875: @2238725
     /* 2238725 */ GIM_Reject,
     /* 2238726 */ // Label 29813: @2238726
     /* 2238726 */ GIM_Try, /*On fail goto*//*Label 29878*/ GIMT_Encode4(2238840),
     /* 2238731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2238734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2238737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238749 */   GIM_Try, /*On fail goto*//*Label 29879*/ GIMT_Encode4(2238794), // Rule ID 59326 //
     /* 2238754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238757 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2238760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238793 */     // GIR_Coverage, 59326,
     /* 2238793 */     GIR_EraseRootFromParent_Done,
     /* 2238794 */   // Label 29879: @2238794
     /* 2238794 */   GIM_Try, /*On fail goto*//*Label 29880*/ GIMT_Encode4(2238839), // Rule ID 59327 //
     /* 2238799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238802 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2238805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2238819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238838 */     // GIR_Coverage, 59327,
     /* 2238838 */     GIR_EraseRootFromParent_Done,
     /* 2238839 */   // Label 29880: @2238839
     /* 2238839 */   GIM_Reject,
     /* 2238840 */ // Label 29878: @2238840
     /* 2238840 */ GIM_Reject,
     /* 2238841 */ // Label 29814: @2238841
     /* 2238841 */ GIM_Try, /*On fail goto*//*Label 29881*/ GIMT_Encode4(2238955),
     /* 2238846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2238849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2238852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2238864 */   GIM_Try, /*On fail goto*//*Label 29882*/ GIMT_Encode4(2238909), // Rule ID 59342 //
     /* 2238869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238872 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2238875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2238889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238908 */     // GIR_Coverage, 59342,
     /* 2238908 */     GIR_EraseRootFromParent_Done,
     /* 2238909 */   // Label 29882: @2238909
     /* 2238909 */   GIM_Try, /*On fail goto*//*Label 29883*/ GIMT_Encode4(2238954), // Rule ID 59343 //
     /* 2238914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238917 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2238920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2238931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2238934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2238939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2238941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2238953 */     // GIR_Coverage, 59343,
     /* 2238953 */     GIR_EraseRootFromParent_Done,
     /* 2238954 */   // Label 29883: @2238954
     /* 2238954 */   GIM_Reject,
     /* 2238955 */ // Label 29881: @2238955
     /* 2238955 */ GIM_Reject,
     /* 2238956 */ // Label 29815: @2238956
     /* 2238956 */ GIM_Try, /*On fail goto*//*Label 29884*/ GIMT_Encode4(2239070),
     /* 2238961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2238964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2238967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2238979 */   GIM_Try, /*On fail goto*//*Label 29885*/ GIMT_Encode4(2239024), // Rule ID 59314 //
     /* 2238984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238987 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2238990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2238994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2238999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239023 */     // GIR_Coverage, 59314,
     /* 2239023 */     GIR_EraseRootFromParent_Done,
     /* 2239024 */   // Label 29885: @2239024
     /* 2239024 */   GIM_Try, /*On fail goto*//*Label 29886*/ GIMT_Encode4(2239069), // Rule ID 59315 //
     /* 2239029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239032 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2239035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2239049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239068 */     // GIR_Coverage, 59315,
     /* 2239068 */     GIR_EraseRootFromParent_Done,
     /* 2239069 */   // Label 29886: @2239069
     /* 2239069 */   GIM_Reject,
     /* 2239070 */ // Label 29884: @2239070
     /* 2239070 */ GIM_Reject,
     /* 2239071 */ // Label 29816: @2239071
     /* 2239071 */ GIM_Try, /*On fail goto*//*Label 29887*/ GIMT_Encode4(2239185),
     /* 2239076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2239079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2239082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239094 */   GIM_Try, /*On fail goto*//*Label 29888*/ GIMT_Encode4(2239139), // Rule ID 59330 //
     /* 2239099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239102 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239138 */     // GIR_Coverage, 59330,
     /* 2239138 */     GIR_EraseRootFromParent_Done,
     /* 2239139 */   // Label 29888: @2239139
     /* 2239139 */   GIM_Try, /*On fail goto*//*Label 29889*/ GIMT_Encode4(2239184), // Rule ID 59331 //
     /* 2239144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239147 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2239150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239183 */     // GIR_Coverage, 59331,
     /* 2239183 */     GIR_EraseRootFromParent_Done,
     /* 2239184 */   // Label 29889: @2239184
     /* 2239184 */   GIM_Reject,
     /* 2239185 */ // Label 29887: @2239185
     /* 2239185 */ GIM_Reject,
     /* 2239186 */ // Label 29817: @2239186
     /* 2239186 */ GIM_Try, /*On fail goto*//*Label 29890*/ GIMT_Encode4(2239300),
     /* 2239191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2239194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2239197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2239209 */   GIM_Try, /*On fail goto*//*Label 29891*/ GIMT_Encode4(2239254), // Rule ID 59318 //
     /* 2239214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239217 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2239220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239253 */     // GIR_Coverage, 59318,
     /* 2239253 */     GIR_EraseRootFromParent_Done,
     /* 2239254 */   // Label 29891: @2239254
     /* 2239254 */   GIM_Try, /*On fail goto*//*Label 29892*/ GIMT_Encode4(2239299), // Rule ID 59319 //
     /* 2239259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239262 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2239265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2239269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2239279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2239286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2239298 */     // GIR_Coverage, 59319,
     /* 2239298 */     GIR_EraseRootFromParent_Done,
     /* 2239299 */   // Label 29892: @2239299
     /* 2239299 */   GIM_Reject,
     /* 2239300 */ // Label 29890: @2239300
     /* 2239300 */ GIM_Reject,
     /* 2239301 */ // Label 29818: @2239301
     /* 2239301 */ GIM_Reject,
     /* 2239302 */ // Label 48: @2239302
     /* 2239302 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(33), /*)*//*default:*//*Label 29902*/ GIMT_Encode4(2265964),
     /* 2239313 */ /*GILLT_s32*//*Label 29893*/ GIMT_Encode4(2239433),
     /* 2239317 */ /*GILLT_s64*//*Label 29894*/ GIMT_Encode4(2242227),
     /* 2239321 */ /*GILLT_nxv1s1*//*Label 29895*/ GIMT_Encode4(2245021), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239341 */ /*GILLT_nxv2s1*//*Label 29896*/ GIMT_Encode4(2248862), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239361 */ /*GILLT_nxv4s1*//*Label 29897*/ GIMT_Encode4(2252703), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239381 */ /*GILLT_nxv8s1*//*Label 29898*/ GIMT_Encode4(2256544), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239401 */ /*GILLT_nxv16s1*//*Label 29899*/ GIMT_Encode4(2260385), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239417 */ /*GILLT_nxv32s1*//*Label 29900*/ GIMT_Encode4(2263266), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2239429 */ /*GILLT_nxv64s1*//*Label 29901*/ GIMT_Encode4(2265187),
     /* 2239433 */ // Label 29893: @2239433
     /* 2239433 */ GIM_Try, /*On fail goto*//*Label 29903*/ GIMT_Encode4(2239476), // Rule ID 165 //
     /* 2239438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239444 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239451 */   // MIs[0] Operand 1
     /* 2239451 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239460 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2239464 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] })
     /* 2239464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239469 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239474 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239475 */   // GIR_Coverage, 165,
     /* 2239475 */   GIR_EraseRootFromParent_Done,
     /* 2239476 */ // Label 29903: @2239476
     /* 2239476 */ GIM_Try, /*On fail goto*//*Label 29904*/ GIMT_Encode4(2239519), // Rule ID 65268 //
     /* 2239481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2239487 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2239490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239494 */   // MIs[0] Operand 1
     /* 2239494 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239503 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239507 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2239507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239512 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2239517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239518 */   // GIR_Coverage, 65268,
     /* 2239518 */   GIR_EraseRootFromParent_Done,
     /* 2239519 */ // Label 29904: @2239519
     /* 2239519 */ GIM_Try, /*On fail goto*//*Label 29905*/ GIMT_Encode4(2239565), // Rule ID 65274 //
     /* 2239524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2239530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2239533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239537 */   // MIs[0] Operand 1
     /* 2239537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239546 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239550 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2239550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2239553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239555 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2239561 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239564 */   // GIR_Coverage, 65274,
     /* 2239564 */   GIR_EraseRootFromParent_Done,
     /* 2239565 */ // Label 29905: @2239565
     /* 2239565 */ GIM_Try, /*On fail goto*//*Label 29906*/ GIMT_Encode4(2239608), // Rule ID 65304 //
     /* 2239570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239576 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239583 */   // MIs[0] Operand 1
     /* 2239583 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239592 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239596 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2239596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239601 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2239606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239607 */   // GIR_Coverage, 65304,
     /* 2239607 */   GIR_EraseRootFromParent_Done,
     /* 2239608 */ // Label 29906: @2239608
     /* 2239608 */ GIM_Try, /*On fail goto*//*Label 29907*/ GIMT_Encode4(2239654), // Rule ID 65310 //
     /* 2239613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239619 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239626 */   // MIs[0] Operand 1
     /* 2239626 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239635 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2239639 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2239639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2239642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239644 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2239650 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239652 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239653 */   // GIR_Coverage, 65310,
     /* 2239653 */   GIR_EraseRootFromParent_Done,
     /* 2239654 */ // Label 29907: @2239654
     /* 2239654 */ GIM_Try, /*On fail goto*//*Label 29908*/ GIMT_Encode4(2239707), // Rule ID 155 //
     /* 2239659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239665 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239672 */   // MIs[0] Operand 1
     /* 2239672 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2239685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239689 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2239693 */   // MIs[1] Operand 1
     /* 2239693 */   // No operand predicates
     /* 2239693 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239695 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2239695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2239698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239700 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239702 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2239705 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239706 */   // GIR_Coverage, 155,
     /* 2239706 */   GIR_EraseRootFromParent_Done,
     /* 2239707 */ // Label 29908: @2239707
     /* 2239707 */ GIM_Try, /*On fail goto*//*Label 29909*/ GIMT_Encode4(2239760), // Rule ID 159 //
     /* 2239712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2239718 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239725 */   // MIs[0] Operand 1
     /* 2239725 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2239730 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239734 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2239738 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239742 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2239746 */   // MIs[1] Operand 1
     /* 2239746 */   // No operand predicates
     /* 2239746 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239748 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2239748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239753 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239755 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2239758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239759 */   // GIR_Coverage, 159,
     /* 2239759 */   GIR_EraseRootFromParent_Done,
     /* 2239760 */ // Label 29909: @2239760
     /* 2239760 */ GIM_Try, /*On fail goto*//*Label 29910*/ GIMT_Encode4(2239813), // Rule ID 65260 //
     /* 2239765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2239771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239778 */   // MIs[0] Operand 1
     /* 2239778 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2239783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2239791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239795 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2239799 */   // MIs[1] Operand 1
     /* 2239799 */   // No operand predicates
     /* 2239799 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239801 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2239801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239806 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239808 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2239811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239812 */   // GIR_Coverage, 65260,
     /* 2239812 */   GIR_EraseRootFromParent_Done,
     /* 2239813 */ // Label 29910: @2239813
     /* 2239813 */ GIM_Try, /*On fail goto*//*Label 29911*/ GIMT_Encode4(2239866), // Rule ID 65264 //
     /* 2239818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2239824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239831 */   // MIs[0] Operand 1
     /* 2239831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239840 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2239844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239848 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2239852 */   // MIs[1] Operand 1
     /* 2239852 */   // No operand predicates
     /* 2239852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239854 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2239854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2239857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239859 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239861 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2239864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239865 */   // GIR_Coverage, 65264,
     /* 2239865 */   GIR_EraseRootFromParent_Done,
     /* 2239866 */ // Label 29911: @2239866
     /* 2239866 */ GIM_Try, /*On fail goto*//*Label 29912*/ GIMT_Encode4(2239943), // Rule ID 65270 //
     /* 2239871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2239877 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239884 */   // MIs[0] Operand 1
     /* 2239884 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239893 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2239897 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239901 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2239905 */   // MIs[1] Operand 1
     /* 2239905 */   // No operand predicates
     /* 2239905 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239907 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2239907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2239910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2239914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239919 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2239923 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2239928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2239930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2239933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2239938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2239941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239942 */   // GIR_Coverage, 65270,
     /* 2239942 */   GIR_EraseRootFromParent_Done,
     /* 2239943 */ // Label 29912: @2239943
     /* 2239943 */ GIM_Try, /*On fail goto*//*Label 29913*/ GIMT_Encode4(2240023), // Rule ID 65276 //
     /* 2239948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2239951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2239954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2239957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239961 */   // MIs[0] Operand 1
     /* 2239961 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2239970 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2239974 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2239978 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2239982 */   // MIs[1] Operand 1
     /* 2239982 */   // No operand predicates
     /* 2239982 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2239984 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2239984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2239987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2239991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2239996 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240000 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240012 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240021 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240022 */   // GIR_Coverage, 65276,
     /* 2240022 */   GIR_EraseRootFromParent_Done,
     /* 2240023 */ // Label 29913: @2240023
     /* 2240023 */ GIM_Try, /*On fail goto*//*Label 29914*/ GIMT_Encode4(2240100), // Rule ID 65280 //
     /* 2240028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240034 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240041 */   // MIs[0] Operand 1
     /* 2240041 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240046 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240050 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240054 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240058 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2240062 */   // MIs[1] Operand 1
     /* 2240062 */   // No operand predicates
     /* 2240062 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240064 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2240064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240076 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240080 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240099 */   // GIR_Coverage, 65280,
     /* 2240099 */   GIR_EraseRootFromParent_Done,
     /* 2240100 */ // Label 29914: @2240100
     /* 2240100 */ GIM_Try, /*On fail goto*//*Label 29915*/ GIMT_Encode4(2240177), // Rule ID 65284 //
     /* 2240105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240111 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240118 */   // MIs[0] Operand 1
     /* 2240118 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240127 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240131 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240135 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2240139 */   // MIs[1] Operand 1
     /* 2240139 */   // No operand predicates
     /* 2240139 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240141 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2240141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240153 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240157 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240176 */   // GIR_Coverage, 65284,
     /* 2240176 */   GIR_EraseRootFromParent_Done,
     /* 2240177 */ // Label 29915: @2240177
     /* 2240177 */ GIM_Try, /*On fail goto*//*Label 29916*/ GIMT_Encode4(2240252), // Rule ID 65288 //
     /* 2240182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240195 */   // MIs[0] Operand 1
     /* 2240195 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2240200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240204 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240208 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240212 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240216 */   // MIs[1] Operand 1
     /* 2240216 */   // No operand predicates
     /* 2240216 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240218 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240230 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240234 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240251 */   // GIR_Coverage, 65288,
     /* 2240251 */   GIR_EraseRootFromParent_Done,
     /* 2240252 */ // Label 29916: @2240252
     /* 2240252 */ GIM_Try, /*On fail goto*//*Label 29917*/ GIMT_Encode4(2240327), // Rule ID 65292 //
     /* 2240257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240270 */   // MIs[0] Operand 1
     /* 2240270 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2240275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240279 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240283 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240287 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240291 */   // MIs[1] Operand 1
     /* 2240291 */   // No operand predicates
     /* 2240291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240293 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240309 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240326 */   // GIR_Coverage, 65292,
     /* 2240326 */   GIR_EraseRootFromParent_Done,
     /* 2240327 */ // Label 29917: @2240327
     /* 2240327 */ GIM_Try, /*On fail goto*//*Label 29918*/ GIMT_Encode4(2240382), // Rule ID 65296 //
     /* 2240332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240345 */   // MIs[0] Operand 1
     /* 2240345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2240350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240362 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2240366 */   // MIs[1] Operand 1
     /* 2240366 */   // No operand predicates
     /* 2240366 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240368 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2240368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240373 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240375 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240381 */   // GIR_Coverage, 65296,
     /* 2240381 */   GIR_EraseRootFromParent_Done,
     /* 2240382 */ // Label 29918: @2240382
     /* 2240382 */ GIM_Try, /*On fail goto*//*Label 29919*/ GIMT_Encode4(2240437), // Rule ID 65300 //
     /* 2240387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2240393 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240400 */   // MIs[0] Operand 1
     /* 2240400 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2240405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240409 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240417 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2240421 */   // MIs[1] Operand 1
     /* 2240421 */   // No operand predicates
     /* 2240421 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240423 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2240423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240428 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240430 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240436 */   // GIR_Coverage, 65300,
     /* 2240436 */   GIR_EraseRootFromParent_Done,
     /* 2240437 */ // Label 29919: @2240437
     /* 2240437 */ GIM_Try, /*On fail goto*//*Label 29920*/ GIMT_Encode4(2240514), // Rule ID 65306 //
     /* 2240442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240448 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240455 */   // MIs[0] Operand 1
     /* 2240455 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2240460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240464 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240468 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240472 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240476 */   // MIs[1] Operand 1
     /* 2240476 */   // No operand predicates
     /* 2240476 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240478 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2240478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240490 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240494 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240506 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240512 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240513 */   // GIR_Coverage, 65306,
     /* 2240513 */   GIR_EraseRootFromParent_Done,
     /* 2240514 */ // Label 29920: @2240514
     /* 2240514 */ GIM_Try, /*On fail goto*//*Label 29921*/ GIMT_Encode4(2240594), // Rule ID 65312 //
     /* 2240519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240532 */   // MIs[0] Operand 1
     /* 2240532 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2240537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240541 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240545 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240549 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2240553 */   // MIs[1] Operand 1
     /* 2240553 */   // No operand predicates
     /* 2240553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240555 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2240555 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240558 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2240562 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240567 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240571 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2240576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2240581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240583 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2240589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240593 */   // GIR_Coverage, 65312,
     /* 2240593 */   GIR_EraseRootFromParent_Done,
     /* 2240594 */ // Label 29921: @2240594
     /* 2240594 */ GIM_Try, /*On fail goto*//*Label 29922*/ GIMT_Encode4(2240671), // Rule ID 65316 //
     /* 2240599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240612 */   // MIs[0] Operand 1
     /* 2240612 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240629 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2240633 */   // MIs[1] Operand 1
     /* 2240633 */   // No operand predicates
     /* 2240633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240635 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2240635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240647 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240651 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240670 */   // GIR_Coverage, 65316,
     /* 2240670 */   GIR_EraseRootFromParent_Done,
     /* 2240671 */ // Label 29922: @2240671
     /* 2240671 */ GIM_Try, /*On fail goto*//*Label 29923*/ GIMT_Encode4(2240748), // Rule ID 65320 //
     /* 2240676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240689 */   // MIs[0] Operand 1
     /* 2240689 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240706 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2240710 */   // MIs[1] Operand 1
     /* 2240710 */   // No operand predicates
     /* 2240710 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240712 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2240712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240724 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240728 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240746 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240747 */   // GIR_Coverage, 65320,
     /* 2240747 */   GIR_EraseRootFromParent_Done,
     /* 2240748 */ // Label 29923: @2240748
     /* 2240748 */ GIM_Try, /*On fail goto*//*Label 29924*/ GIMT_Encode4(2240823), // Rule ID 65324 //
     /* 2240753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240759 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240766 */   // MIs[0] Operand 1
     /* 2240766 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2240771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240775 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240779 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240783 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240787 */   // MIs[1] Operand 1
     /* 2240787 */   // No operand predicates
     /* 2240787 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240789 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240801 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240805 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240815 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240822 */   // GIR_Coverage, 65324,
     /* 2240822 */   GIR_EraseRootFromParent_Done,
     /* 2240823 */ // Label 29924: @2240823
     /* 2240823 */ GIM_Try, /*On fail goto*//*Label 29925*/ GIMT_Encode4(2240898), // Rule ID 65328 //
     /* 2240828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240834 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240841 */   // MIs[0] Operand 1
     /* 2240841 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2240846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240858 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2240862 */   // MIs[1] Operand 1
     /* 2240862 */   // No operand predicates
     /* 2240862 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240864 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2240864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2240867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2240876 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2240880 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2240883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2240885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2240888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240890 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2240893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2240896 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240897 */   // GIR_Coverage, 65328,
     /* 2240897 */   GIR_EraseRootFromParent_Done,
     /* 2240898 */ // Label 29925: @2240898
     /* 2240898 */ GIM_Try, /*On fail goto*//*Label 29926*/ GIMT_Encode4(2240953), // Rule ID 65332 //
     /* 2240903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240909 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240916 */   // MIs[0] Operand 1
     /* 2240916 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2240921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240925 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240929 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240933 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2240937 */   // MIs[1] Operand 1
     /* 2240937 */   // No operand predicates
     /* 2240937 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240939 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2240939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2240942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240944 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240946 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2240951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240952 */   // GIR_Coverage, 65332,
     /* 2240952 */   GIR_EraseRootFromParent_Done,
     /* 2240953 */ // Label 29926: @2240953
     /* 2240953 */ GIM_Try, /*On fail goto*//*Label 29927*/ GIMT_Encode4(2241008), // Rule ID 65336 //
     /* 2240958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2240961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2240964 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2240967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240971 */   // MIs[0] Operand 1
     /* 2240971 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2240976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2240980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2240984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2240988 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2240992 */   // MIs[1] Operand 1
     /* 2240992 */   // No operand predicates
     /* 2240992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2240994 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2240994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2240997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240999 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241001 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2241006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241007 */   // GIR_Coverage, 65336,
     /* 2241007 */   GIR_EraseRootFromParent_Done,
     /* 2241008 */ // Label 29927: @2241008
     /* 2241008 */ GIM_Try, /*On fail goto*//*Label 29928*/ GIMT_Encode4(2241050), // Rule ID 64456 //
     /* 2241013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2241016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241026 */   // MIs[0] Operand 1
     /* 2241026 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241035 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241039 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2241042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241044 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241046 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241048 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241049 */   // GIR_Coverage, 64456,
     /* 2241049 */   GIR_EraseRootFromParent_Done,
     /* 2241050 */ // Label 29928: @2241050
     /* 2241050 */ GIM_Try, /*On fail goto*//*Label 29929*/ GIMT_Encode4(2241092), // Rule ID 64458 //
     /* 2241055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2241058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241061 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241068 */   // MIs[0] Operand 1
     /* 2241068 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241077 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241081 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2241084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241086 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241088 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241090 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241091 */   // GIR_Coverage, 64458,
     /* 2241091 */   GIR_EraseRootFromParent_Done,
     /* 2241092 */ // Label 29929: @2241092
     /* 2241092 */ GIM_Try, /*On fail goto*//*Label 29930*/ GIMT_Encode4(2241134), // Rule ID 153 //
     /* 2241097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241103 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241110 */   // MIs[0] Operand 1
     /* 2241110 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2241115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241119 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241123 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241128 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241130 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241133 */   // GIR_Coverage, 153,
     /* 2241133 */   GIR_EraseRootFromParent_Done,
     /* 2241134 */ // Label 29930: @2241134
     /* 2241134 */ GIM_Try, /*On fail goto*//*Label 29931*/ GIMT_Encode4(2241176), // Rule ID 157 //
     /* 2241139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241152 */   // MIs[0] Operand 1
     /* 2241152 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241161 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241165 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241170 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241172 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241175 */   // GIR_Coverage, 157,
     /* 2241175 */   GIR_EraseRootFromParent_Done,
     /* 2241176 */ // Label 29931: @2241176
     /* 2241176 */ GIM_Try, /*On fail goto*//*Label 29932*/ GIMT_Encode4(2241218), // Rule ID 65262 //
     /* 2241181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241194 */   // MIs[0] Operand 1
     /* 2241194 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2241199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241203 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241207 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241212 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241214 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241216 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241217 */   // GIR_Coverage, 65262,
     /* 2241217 */   GIR_EraseRootFromParent_Done,
     /* 2241218 */ // Label 29932: @2241218
     /* 2241218 */ GIM_Try, /*On fail goto*//*Label 29933*/ GIMT_Encode4(2241260), // Rule ID 65266 //
     /* 2241223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241229 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241236 */   // MIs[0] Operand 1
     /* 2241236 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2241241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241245 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241249 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2241249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241254 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241256 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241258 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241259 */   // GIR_Coverage, 65266,
     /* 2241259 */   GIR_EraseRootFromParent_Done,
     /* 2241260 */ // Label 29933: @2241260
     /* 2241260 */ GIM_Try, /*On fail goto*//*Label 29934*/ GIMT_Encode4(2241326), // Rule ID 65272 //
     /* 2241265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241271 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241278 */   // MIs[0] Operand 1
     /* 2241278 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2241283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241287 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241291 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2241298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241303 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241307 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241324 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241325 */   // GIR_Coverage, 65272,
     /* 2241325 */   GIR_EraseRootFromParent_Done,
     /* 2241326 */ // Label 29934: @2241326
     /* 2241326 */ GIM_Try, /*On fail goto*//*Label 29935*/ GIMT_Encode4(2241395), // Rule ID 65278 //
     /* 2241331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241337 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241344 */   // MIs[0] Operand 1
     /* 2241344 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2241349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241353 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241357 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2241357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2241364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241369 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241373 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241384 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2241390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241394 */   // GIR_Coverage, 65278,
     /* 2241394 */   GIR_EraseRootFromParent_Done,
     /* 2241395 */ // Label 29935: @2241395
     /* 2241395 */ GIM_Try, /*On fail goto*//*Label 29936*/ GIMT_Encode4(2241437), // Rule ID 65282 //
     /* 2241400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241406 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241413 */   // MIs[0] Operand 1
     /* 2241413 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241422 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241426 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2241426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241433 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241436 */   // GIR_Coverage, 65282,
     /* 2241436 */   GIR_EraseRootFromParent_Done,
     /* 2241437 */ // Label 29936: @2241437
     /* 2241437 */ GIM_Try, /*On fail goto*//*Label 29937*/ GIMT_Encode4(2241479), // Rule ID 65286 //
     /* 2241442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241448 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241455 */   // MIs[0] Operand 1
     /* 2241455 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2241460 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241464 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241468 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2241468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241473 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241475 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241478 */   // GIR_Coverage, 65286,
     /* 2241478 */   GIR_EraseRootFromParent_Done,
     /* 2241479 */ // Label 29937: @2241479
     /* 2241479 */ GIM_Try, /*On fail goto*//*Label 29938*/ GIMT_Encode4(2241545), // Rule ID 65290 //
     /* 2241484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241497 */   // MIs[0] Operand 1
     /* 2241497 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2241502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241506 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241510 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241510 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241513 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241517 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241522 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241526 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241543 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241544 */   // GIR_Coverage, 65290,
     /* 2241544 */   GIR_EraseRootFromParent_Done,
     /* 2241545 */ // Label 29938: @2241545
     /* 2241545 */ GIM_Try, /*On fail goto*//*Label 29939*/ GIMT_Encode4(2241611), // Rule ID 65294 //
     /* 2241550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241563 */   // MIs[0] Operand 1
     /* 2241563 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241572 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241576 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241588 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241592 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241603 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241610 */   // GIR_Coverage, 65294,
     /* 2241610 */   GIR_EraseRootFromParent_Done,
     /* 2241611 */ // Label 29939: @2241611
     /* 2241611 */ GIM_Try, /*On fail goto*//*Label 29940*/ GIMT_Encode4(2241677), // Rule ID 65298 //
     /* 2241616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241622 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241629 */   // MIs[0] Operand 1
     /* 2241629 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241638 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241642 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2241642 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241645 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241649 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241654 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241658 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241676 */   // GIR_Coverage, 65298,
     /* 2241676 */   GIR_EraseRootFromParent_Done,
     /* 2241677 */ // Label 29940: @2241677
     /* 2241677 */ GIM_Try, /*On fail goto*//*Label 29941*/ GIMT_Encode4(2241743), // Rule ID 65302 //
     /* 2241682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2241688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2241691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241695 */   // MIs[0] Operand 1
     /* 2241695 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241704 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241708 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2241708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241720 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241724 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2241733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241741 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241742 */   // GIR_Coverage, 65302,
     /* 2241742 */   GIR_EraseRootFromParent_Done,
     /* 2241743 */ // Label 29941: @2241743
     /* 2241743 */ GIM_Try, /*On fail goto*//*Label 29942*/ GIMT_Encode4(2241809), // Rule ID 65308 //
     /* 2241748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241761 */   // MIs[0] Operand 1
     /* 2241761 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2241766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241770 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241774 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2241781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241786 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241790 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2241799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2241807 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241808 */   // GIR_Coverage, 65308,
     /* 2241808 */   GIR_EraseRootFromParent_Done,
     /* 2241809 */ // Label 29942: @2241809
     /* 2241809 */ GIM_Try, /*On fail goto*//*Label 29943*/ GIMT_Encode4(2241878), // Rule ID 65314 //
     /* 2241814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241820 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241827 */   // MIs[0] Operand 1
     /* 2241827 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2241832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241836 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241840 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2241840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2241847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2241852 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2241856 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2241860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2241862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241867 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2241873 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2241876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241877 */   // GIR_Coverage, 65314,
     /* 2241877 */   GIR_EraseRootFromParent_Done,
     /* 2241878 */ // Label 29943: @2241878
     /* 2241878 */ GIM_Try, /*On fail goto*//*Label 29944*/ GIMT_Encode4(2241920), // Rule ID 65318 //
     /* 2241883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241896 */   // MIs[0] Operand 1
     /* 2241896 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241905 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241909 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2241909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2241912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241914 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241916 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241919 */   // GIR_Coverage, 65318,
     /* 2241919 */   GIR_EraseRootFromParent_Done,
     /* 2241920 */ // Label 29944: @2241920
     /* 2241920 */ GIM_Try, /*On fail goto*//*Label 29945*/ GIMT_Encode4(2241962), // Rule ID 65322 //
     /* 2241925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241938 */   // MIs[0] Operand 1
     /* 2241938 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2241943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241947 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241951 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2241951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2241954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241956 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241958 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241960 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241961 */   // GIR_Coverage, 65322,
     /* 2241961 */   GIR_EraseRootFromParent_Done,
     /* 2241962 */ // Label 29945: @2241962
     /* 2241962 */ GIM_Try, /*On fail goto*//*Label 29946*/ GIMT_Encode4(2242028), // Rule ID 65326 //
     /* 2241967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2241970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2241973 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2241976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241980 */   // MIs[0] Operand 1
     /* 2241980 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2241985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241989 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2241993 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2241993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2241996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242005 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242009 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242027 */   // GIR_Coverage, 65326,
     /* 2242027 */   GIR_EraseRootFromParent_Done,
     /* 2242028 */ // Label 29946: @2242028
     /* 2242028 */ GIM_Try, /*On fail goto*//*Label 29947*/ GIMT_Encode4(2242094), // Rule ID 65330 //
     /* 2242033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242039 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242046 */   // MIs[0] Operand 1
     /* 2242046 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2242051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242055 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242059 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2242059 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242062 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242066 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242075 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242092 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242093 */   // GIR_Coverage, 65330,
     /* 2242093 */   GIR_EraseRootFromParent_Done,
     /* 2242094 */ // Label 29947: @2242094
     /* 2242094 */ GIM_Try, /*On fail goto*//*Label 29948*/ GIMT_Encode4(2242160), // Rule ID 65334 //
     /* 2242099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242105 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242112 */   // MIs[0] Operand 1
     /* 2242112 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242121 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242125 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242137 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242141 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242159 */   // GIR_Coverage, 65334,
     /* 2242159 */   GIR_EraseRootFromParent_Done,
     /* 2242160 */ // Label 29948: @2242160
     /* 2242160 */ GIM_Try, /*On fail goto*//*Label 29949*/ GIMT_Encode4(2242226), // Rule ID 65338 //
     /* 2242165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2242168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2242171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2242174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242178 */   // MIs[0] Operand 1
     /* 2242178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2242183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242191 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2242191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2242198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2242207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242224 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242225 */   // GIR_Coverage, 65338,
     /* 2242225 */   GIR_EraseRootFromParent_Done,
     /* 2242226 */ // Label 29949: @2242226
     /* 2242226 */ GIM_Reject,
     /* 2242227 */ // Label 29894: @2242227
     /* 2242227 */ GIM_Try, /*On fail goto*//*Label 29950*/ GIMT_Encode4(2242270), // Rule ID 164 //
     /* 2242232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242238 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242245 */   // MIs[0] Operand 1
     /* 2242245 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242254 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2242258 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] })
     /* 2242258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242263 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242269 */   // GIR_Coverage, 164,
     /* 2242269 */   GIR_EraseRootFromParent_Done,
     /* 2242270 */ // Label 29950: @2242270
     /* 2242270 */ GIM_Try, /*On fail goto*//*Label 29951*/ GIMT_Encode4(2242313), // Rule ID 65267 //
     /* 2242275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242281 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2242284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242288 */   // MIs[0] Operand 1
     /* 2242288 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242297 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242301 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2242301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242311 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242312 */   // GIR_Coverage, 65267,
     /* 2242312 */   GIR_EraseRootFromParent_Done,
     /* 2242313 */ // Label 29951: @2242313
     /* 2242313 */ GIM_Try, /*On fail goto*//*Label 29952*/ GIMT_Encode4(2242359), // Rule ID 65273 //
     /* 2242318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242324 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2242327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242331 */   // MIs[0] Operand 1
     /* 2242331 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242340 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242344 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2242344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242349 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242358 */   // GIR_Coverage, 65273,
     /* 2242358 */   GIR_EraseRootFromParent_Done,
     /* 2242359 */ // Label 29952: @2242359
     /* 2242359 */ GIM_Try, /*On fail goto*//*Label 29953*/ GIMT_Encode4(2242402), // Rule ID 65303 //
     /* 2242364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242377 */   // MIs[0] Operand 1
     /* 2242377 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242386 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242390 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2242390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242401 */   // GIR_Coverage, 65303,
     /* 2242401 */   GIR_EraseRootFromParent_Done,
     /* 2242402 */ // Label 29953: @2242402
     /* 2242402 */ GIM_Try, /*On fail goto*//*Label 29954*/ GIMT_Encode4(2242448), // Rule ID 65309 //
     /* 2242407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242413 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242420 */   // MIs[0] Operand 1
     /* 2242420 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242429 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2242433 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2242433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242444 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242447 */   // GIR_Coverage, 65309,
     /* 2242447 */   GIR_EraseRootFromParent_Done,
     /* 2242448 */ // Label 29954: @2242448
     /* 2242448 */ GIM_Try, /*On fail goto*//*Label 29955*/ GIMT_Encode4(2242501), // Rule ID 154 //
     /* 2242453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242466 */   // MIs[0] Operand 1
     /* 2242466 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2242471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242483 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2242487 */   // MIs[1] Operand 1
     /* 2242487 */   // No operand predicates
     /* 2242487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242489 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2242489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2242492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242494 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242496 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2242499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242500 */   // GIR_Coverage, 154,
     /* 2242500 */   GIR_EraseRootFromParent_Done,
     /* 2242501 */ // Label 29955: @2242501
     /* 2242501 */ GIM_Try, /*On fail goto*//*Label 29956*/ GIMT_Encode4(2242554), // Rule ID 158 //
     /* 2242506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242519 */   // MIs[0] Operand 1
     /* 2242519 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2242524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242528 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242536 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2242540 */   // MIs[1] Operand 1
     /* 2242540 */   // No operand predicates
     /* 2242540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242542 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2242542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242547 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242549 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2242552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242553 */   // GIR_Coverage, 158,
     /* 2242553 */   GIR_EraseRootFromParent_Done,
     /* 2242554 */ // Label 29956: @2242554
     /* 2242554 */ GIM_Try, /*On fail goto*//*Label 29957*/ GIMT_Encode4(2242607), // Rule ID 65259 //
     /* 2242559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242572 */   // MIs[0] Operand 1
     /* 2242572 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2242577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242589 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2242593 */   // MIs[1] Operand 1
     /* 2242593 */   // No operand predicates
     /* 2242593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242595 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2242595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242600 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242602 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2242605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242606 */   // GIR_Coverage, 65259,
     /* 2242606 */   GIR_EraseRootFromParent_Done,
     /* 2242607 */ // Label 29957: @2242607
     /* 2242607 */ GIM_Try, /*On fail goto*//*Label 29958*/ GIMT_Encode4(2242660), // Rule ID 65263 //
     /* 2242612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242625 */   // MIs[0] Operand 1
     /* 2242625 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2242630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242634 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242638 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242642 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2242646 */   // MIs[1] Operand 1
     /* 2242646 */   // No operand predicates
     /* 2242646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242648 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2242648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2242651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242653 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242655 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2242658 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242659 */   // GIR_Coverage, 65263,
     /* 2242659 */   GIR_EraseRootFromParent_Done,
     /* 2242660 */ // Label 29958: @2242660
     /* 2242660 */ GIM_Try, /*On fail goto*//*Label 29959*/ GIMT_Encode4(2242737), // Rule ID 65269 //
     /* 2242665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242671 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242678 */   // MIs[0] Operand 1
     /* 2242678 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242687 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242691 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242695 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2242699 */   // MIs[1] Operand 1
     /* 2242699 */   // No operand predicates
     /* 2242699 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242701 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2242701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2242708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242713 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242717 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2242722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242736 */   // GIR_Coverage, 65269,
     /* 2242736 */   GIR_EraseRootFromParent_Done,
     /* 2242737 */ // Label 29959: @2242737
     /* 2242737 */ GIM_Try, /*On fail goto*//*Label 29960*/ GIMT_Encode4(2242817), // Rule ID 65275 //
     /* 2242742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242755 */   // MIs[0] Operand 1
     /* 2242755 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242764 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242772 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2242776 */   // MIs[1] Operand 1
     /* 2242776 */   // No operand predicates
     /* 2242776 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242778 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2242778 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242781 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2242785 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242790 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242794 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2242799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2242804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242806 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2242812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242816 */   // GIR_Coverage, 65275,
     /* 2242816 */   GIR_EraseRootFromParent_Done,
     /* 2242817 */ // Label 29960: @2242817
     /* 2242817 */ GIM_Try, /*On fail goto*//*Label 29961*/ GIMT_Encode4(2242894), // Rule ID 65279 //
     /* 2242822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242835 */   // MIs[0] Operand 1
     /* 2242835 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2242840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242844 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242848 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242852 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2242856 */   // MIs[1] Operand 1
     /* 2242856 */   // No operand predicates
     /* 2242856 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242858 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2242858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2242865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242870 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242874 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2242879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242893 */   // GIR_Coverage, 65279,
     /* 2242893 */   GIR_EraseRootFromParent_Done,
     /* 2242894 */ // Label 29961: @2242894
     /* 2242894 */ GIM_Try, /*On fail goto*//*Label 29962*/ GIMT_Encode4(2242971), // Rule ID 65283 //
     /* 2242899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2242905 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242912 */   // MIs[0] Operand 1
     /* 2242912 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2242917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242921 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2242925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2242929 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2242933 */   // MIs[1] Operand 1
     /* 2242933 */   // No operand predicates
     /* 2242933 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2242935 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2242935 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2242938 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2242942 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2242947 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2242951 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2242956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2242958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2242961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2242966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2242969 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242970 */   // GIR_Coverage, 65283,
     /* 2242970 */   GIR_EraseRootFromParent_Done,
     /* 2242971 */ // Label 29962: @2242971
     /* 2242971 */ GIM_Try, /*On fail goto*//*Label 29963*/ GIMT_Encode4(2243046), // Rule ID 65287 //
     /* 2242976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2242979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2242982 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2242985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242989 */   // MIs[0] Operand 1
     /* 2242989 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2242998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243006 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243010 */   // MIs[1] Operand 1
     /* 2243010 */   // No operand predicates
     /* 2243010 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243012 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243024 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243028 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243045 */   // GIR_Coverage, 65287,
     /* 2243045 */   GIR_EraseRootFromParent_Done,
     /* 2243046 */ // Label 29963: @2243046
     /* 2243046 */ GIM_Try, /*On fail goto*//*Label 29964*/ GIMT_Encode4(2243121), // Rule ID 65291 //
     /* 2243051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243064 */   // MIs[0] Operand 1
     /* 2243064 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2243069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243081 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243085 */   // MIs[1] Operand 1
     /* 2243085 */   // No operand predicates
     /* 2243085 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243087 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243099 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243103 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243119 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243120 */   // GIR_Coverage, 65291,
     /* 2243120 */   GIR_EraseRootFromParent_Done,
     /* 2243121 */ // Label 29964: @2243121
     /* 2243121 */ GIM_Try, /*On fail goto*//*Label 29965*/ GIMT_Encode4(2243176), // Rule ID 65295 //
     /* 2243126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243132 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243139 */   // MIs[0] Operand 1
     /* 2243139 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2243144 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243148 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243152 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243156 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2243160 */   // MIs[1] Operand 1
     /* 2243160 */   // No operand predicates
     /* 2243160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243162 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2243162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243167 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243169 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243175 */   // GIR_Coverage, 65295,
     /* 2243175 */   GIR_EraseRootFromParent_Done,
     /* 2243176 */ // Label 29965: @2243176
     /* 2243176 */ GIM_Try, /*On fail goto*//*Label 29966*/ GIMT_Encode4(2243231), // Rule ID 65299 //
     /* 2243181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243194 */   // MIs[0] Operand 1
     /* 2243194 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2243199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243203 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243207 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243211 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2243215 */   // MIs[1] Operand 1
     /* 2243215 */   // No operand predicates
     /* 2243215 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243217 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2243217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243222 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243224 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243230 */   // GIR_Coverage, 65299,
     /* 2243230 */   GIR_EraseRootFromParent_Done,
     /* 2243231 */ // Label 29966: @2243231
     /* 2243231 */ GIM_Try, /*On fail goto*//*Label 29967*/ GIMT_Encode4(2243308), // Rule ID 65305 //
     /* 2243236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243249 */   // MIs[0] Operand 1
     /* 2243249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2243254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243266 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243270 */   // MIs[1] Operand 1
     /* 2243270 */   // No operand predicates
     /* 2243270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243272 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2243272 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243275 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243279 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243284 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243288 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243307 */   // GIR_Coverage, 65305,
     /* 2243307 */   GIR_EraseRootFromParent_Done,
     /* 2243308 */ // Label 29967: @2243308
     /* 2243308 */ GIM_Try, /*On fail goto*//*Label 29968*/ GIMT_Encode4(2243388), // Rule ID 65311 //
     /* 2243313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243319 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243326 */   // MIs[0] Operand 1
     /* 2243326 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243335 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243339 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243343 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2243347 */   // MIs[1] Operand 1
     /* 2243347 */   // No operand predicates
     /* 2243347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243349 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2243349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2243356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243361 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243365 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2243370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243377 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2243383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243387 */   // GIR_Coverage, 65311,
     /* 2243387 */   GIR_EraseRootFromParent_Done,
     /* 2243388 */ // Label 29968: @2243388
     /* 2243388 */ GIM_Try, /*On fail goto*//*Label 29969*/ GIMT_Encode4(2243465), // Rule ID 65315 //
     /* 2243393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243406 */   // MIs[0] Operand 1
     /* 2243406 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2243411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243415 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243419 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243423 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2243427 */   // MIs[1] Operand 1
     /* 2243427 */   // No operand predicates
     /* 2243427 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243429 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2243429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243441 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243445 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243463 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243464 */   // GIR_Coverage, 65315,
     /* 2243464 */   GIR_EraseRootFromParent_Done,
     /* 2243465 */ // Label 29969: @2243465
     /* 2243465 */ GIM_Try, /*On fail goto*//*Label 29970*/ GIMT_Encode4(2243542), // Rule ID 65319 //
     /* 2243470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243476 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243483 */   // MIs[0] Operand 1
     /* 2243483 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243492 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243496 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243500 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2243504 */   // MIs[1] Operand 1
     /* 2243504 */   // No operand predicates
     /* 2243504 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243506 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2243506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243518 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243522 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243541 */   // GIR_Coverage, 65319,
     /* 2243541 */   GIR_EraseRootFromParent_Done,
     /* 2243542 */ // Label 29970: @2243542
     /* 2243542 */ GIM_Try, /*On fail goto*//*Label 29971*/ GIMT_Encode4(2243617), // Rule ID 65323 //
     /* 2243547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243560 */   // MIs[0] Operand 1
     /* 2243560 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2243565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243569 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243573 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243577 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243581 */   // MIs[1] Operand 1
     /* 2243581 */   // No operand predicates
     /* 2243581 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243583 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243583 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243586 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243590 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243595 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243599 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243602 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243609 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243616 */   // GIR_Coverage, 65323,
     /* 2243616 */   GIR_EraseRootFromParent_Done,
     /* 2243617 */ // Label 29971: @2243617
     /* 2243617 */ GIM_Try, /*On fail goto*//*Label 29972*/ GIMT_Encode4(2243692), // Rule ID 65327 //
     /* 2243622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243635 */   // MIs[0] Operand 1
     /* 2243635 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2243640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243644 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243652 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2243656 */   // MIs[1] Operand 1
     /* 2243656 */   // No operand predicates
     /* 2243656 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243658 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2243658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2243661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2243670 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2243674 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2243677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2243679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2243682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2243687 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2243690 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243691 */   // GIR_Coverage, 65327,
     /* 2243691 */   GIR_EraseRootFromParent_Done,
     /* 2243692 */ // Label 29972: @2243692
     /* 2243692 */ GIM_Try, /*On fail goto*//*Label 29973*/ GIMT_Encode4(2243747), // Rule ID 65331 //
     /* 2243697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243703 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243710 */   // MIs[0] Operand 1
     /* 2243710 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2243715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243719 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243727 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2243731 */   // MIs[1] Operand 1
     /* 2243731 */   // No operand predicates
     /* 2243731 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243733 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2243733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2243736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243738 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243740 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243745 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243746 */   // GIR_Coverage, 65331,
     /* 2243746 */   GIR_EraseRootFromParent_Done,
     /* 2243747 */ // Label 29973: @2243747
     /* 2243747 */ GIM_Try, /*On fail goto*//*Label 29974*/ GIMT_Encode4(2243802), // Rule ID 65335 //
     /* 2243752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243758 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243765 */   // MIs[0] Operand 1
     /* 2243765 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2243770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243774 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2243778 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2243782 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2243786 */   // MIs[1] Operand 1
     /* 2243786 */   // No operand predicates
     /* 2243786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2243788 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2243788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2243791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243793 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243795 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2243800 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243801 */   // GIR_Coverage, 65335,
     /* 2243801 */   GIR_EraseRootFromParent_Done,
     /* 2243802 */ // Label 29974: @2243802
     /* 2243802 */ GIM_Try, /*On fail goto*//*Label 29975*/ GIMT_Encode4(2243844), // Rule ID 64455 //
     /* 2243807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2243810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243813 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243820 */   // MIs[0] Operand 1
     /* 2243820 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2243825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243829 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243833 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2243833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2243836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243838 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243840 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243842 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243843 */   // GIR_Coverage, 64455,
     /* 2243843 */   GIR_EraseRootFromParent_Done,
     /* 2243844 */ // Label 29975: @2243844
     /* 2243844 */ GIM_Try, /*On fail goto*//*Label 29976*/ GIMT_Encode4(2243886), // Rule ID 64457 //
     /* 2243849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2243852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243855 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243862 */   // MIs[0] Operand 1
     /* 2243862 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2243867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243871 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243875 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2243875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2243878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243880 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243882 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243885 */   // GIR_Coverage, 64457,
     /* 2243885 */   GIR_EraseRootFromParent_Done,
     /* 2243886 */ // Label 29976: @2243886
     /* 2243886 */ GIM_Try, /*On fail goto*//*Label 29977*/ GIMT_Encode4(2243928), // Rule ID 152 //
     /* 2243891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243897 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243904 */   // MIs[0] Operand 1
     /* 2243904 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243913 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243917 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2243917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2243920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243922 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243924 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243927 */   // GIR_Coverage, 152,
     /* 2243927 */   GIR_EraseRootFromParent_Done,
     /* 2243928 */ // Label 29977: @2243928
     /* 2243928 */ GIM_Try, /*On fail goto*//*Label 29978*/ GIMT_Encode4(2243970), // Rule ID 156 //
     /* 2243933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2243939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2243942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243946 */   // MIs[0] Operand 1
     /* 2243946 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2243951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243955 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243959 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2243959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2243962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243964 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243966 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243968 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243969 */   // GIR_Coverage, 156,
     /* 2243969 */   GIR_EraseRootFromParent_Done,
     /* 2243970 */ // Label 29978: @2243970
     /* 2243970 */ GIM_Try, /*On fail goto*//*Label 29979*/ GIMT_Encode4(2244012), // Rule ID 65261 //
     /* 2243975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2243978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2243981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2243984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243988 */   // MIs[0] Operand 1
     /* 2243988 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2243993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2243997 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244001 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244006 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244008 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244011 */   // GIR_Coverage, 65261,
     /* 2244011 */   GIR_EraseRootFromParent_Done,
     /* 2244012 */ // Label 29979: @2244012
     /* 2244012 */ GIM_Try, /*On fail goto*//*Label 29980*/ GIMT_Encode4(2244054), // Rule ID 65265 //
     /* 2244017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244030 */   // MIs[0] Operand 1
     /* 2244030 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2244035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244039 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244043 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2244043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244048 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244050 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244053 */   // GIR_Coverage, 65265,
     /* 2244053 */   GIR_EraseRootFromParent_Done,
     /* 2244054 */ // Label 29980: @2244054
     /* 2244054 */ GIM_Try, /*On fail goto*//*Label 29981*/ GIMT_Encode4(2244120), // Rule ID 65271 //
     /* 2244059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244072 */   // MIs[0] Operand 1
     /* 2244072 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2244077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244081 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244085 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2244092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244119 */   // GIR_Coverage, 65271,
     /* 2244119 */   GIR_EraseRootFromParent_Done,
     /* 2244120 */ // Label 29981: @2244120
     /* 2244120 */ GIM_Try, /*On fail goto*//*Label 29982*/ GIMT_Encode4(2244189), // Rule ID 65277 //
     /* 2244125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244138 */   // MIs[0] Operand 1
     /* 2244138 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2244143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244147 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244151 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2244151 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244154 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2244158 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244163 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244167 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244178 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2244184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244188 */   // GIR_Coverage, 65277,
     /* 2244188 */   GIR_EraseRootFromParent_Done,
     /* 2244189 */ // Label 29982: @2244189
     /* 2244189 */ GIM_Try, /*On fail goto*//*Label 29983*/ GIMT_Encode4(2244231), // Rule ID 65281 //
     /* 2244194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244200 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244207 */   // MIs[0] Operand 1
     /* 2244207 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244220 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2244220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244225 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244227 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244230 */   // GIR_Coverage, 65281,
     /* 2244230 */   GIR_EraseRootFromParent_Done,
     /* 2244231 */ // Label 29983: @2244231
     /* 2244231 */ GIM_Try, /*On fail goto*//*Label 29984*/ GIMT_Encode4(2244273), // Rule ID 65285 //
     /* 2244236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244249 */   // MIs[0] Operand 1
     /* 2244249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244262 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2244262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244267 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244269 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244272 */   // GIR_Coverage, 65285,
     /* 2244272 */   GIR_EraseRootFromParent_Done,
     /* 2244273 */ // Label 29984: @2244273
     /* 2244273 */ GIM_Try, /*On fail goto*//*Label 29985*/ GIMT_Encode4(2244339), // Rule ID 65289 //
     /* 2244278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244284 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244291 */   // MIs[0] Operand 1
     /* 2244291 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2244296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244300 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244304 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244316 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244320 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244337 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244338 */   // GIR_Coverage, 65289,
     /* 2244338 */   GIR_EraseRootFromParent_Done,
     /* 2244339 */ // Label 29985: @2244339
     /* 2244339 */ GIM_Try, /*On fail goto*//*Label 29986*/ GIMT_Encode4(2244405), // Rule ID 65293 //
     /* 2244344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244350 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244357 */   // MIs[0] Operand 1
     /* 2244357 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2244362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244366 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244370 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244382 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244386 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244404 */   // GIR_Coverage, 65293,
     /* 2244404 */   GIR_EraseRootFromParent_Done,
     /* 2244405 */ // Label 29986: @2244405
     /* 2244405 */ GIM_Try, /*On fail goto*//*Label 29987*/ GIMT_Encode4(2244471), // Rule ID 65297 //
     /* 2244410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244423 */   // MIs[0] Operand 1
     /* 2244423 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244436 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2244436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244448 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244452 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244470 */   // GIR_Coverage, 65297,
     /* 2244470 */   GIR_EraseRootFromParent_Done,
     /* 2244471 */ // Label 29987: @2244471
     /* 2244471 */ GIM_Try, /*On fail goto*//*Label 29988*/ GIMT_Encode4(2244537), // Rule ID 65301 //
     /* 2244476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2244482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2244485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244489 */   // MIs[0] Operand 1
     /* 2244489 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244502 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2244502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244514 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244518 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244529 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244536 */   // GIR_Coverage, 65301,
     /* 2244536 */   GIR_EraseRootFromParent_Done,
     /* 2244537 */ // Label 29988: @2244537
     /* 2244537 */ GIM_Try, /*On fail goto*//*Label 29989*/ GIMT_Encode4(2244603), // Rule ID 65307 //
     /* 2244542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244555 */   // MIs[0] Operand 1
     /* 2244555 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2244560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244564 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244568 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2244575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244580 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244584 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244588 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2244593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244595 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244601 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244602 */   // GIR_Coverage, 65307,
     /* 2244602 */   GIR_EraseRootFromParent_Done,
     /* 2244603 */ // Label 29989: @2244603
     /* 2244603 */ GIM_Try, /*On fail goto*//*Label 29990*/ GIMT_Encode4(2244672), // Rule ID 65313 //
     /* 2244608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244614 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244621 */   // MIs[0] Operand 1
     /* 2244621 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2244626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244630 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244634 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2244634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2244641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244646 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244650 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244661 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2244667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244671 */   // GIR_Coverage, 65313,
     /* 2244671 */   GIR_EraseRootFromParent_Done,
     /* 2244672 */ // Label 29990: @2244672
     /* 2244672 */ GIM_Try, /*On fail goto*//*Label 29991*/ GIMT_Encode4(2244714), // Rule ID 65317 //
     /* 2244677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244690 */   // MIs[0] Operand 1
     /* 2244690 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244703 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2244703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244708 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244710 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244713 */   // GIR_Coverage, 65317,
     /* 2244713 */   GIR_EraseRootFromParent_Done,
     /* 2244714 */ // Label 29991: @2244714
     /* 2244714 */ GIM_Try, /*On fail goto*//*Label 29992*/ GIMT_Encode4(2244756), // Rule ID 65321 //
     /* 2244719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244732 */   // MIs[0] Operand 1
     /* 2244732 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244741 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244745 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2244745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244750 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244752 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244754 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244755 */   // GIR_Coverage, 65321,
     /* 2244755 */   GIR_EraseRootFromParent_Done,
     /* 2244756 */ // Label 29992: @2244756
     /* 2244756 */ GIM_Try, /*On fail goto*//*Label 29993*/ GIMT_Encode4(2244822), // Rule ID 65325 //
     /* 2244761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244767 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244774 */   // MIs[0] Operand 1
     /* 2244774 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2244779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244783 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244787 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244803 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244821 */   // GIR_Coverage, 65325,
     /* 2244821 */   GIR_EraseRootFromParent_Done,
     /* 2244822 */ // Label 29993: @2244822
     /* 2244822 */ GIM_Try, /*On fail goto*//*Label 29994*/ GIMT_Encode4(2244888), // Rule ID 65329 //
     /* 2244827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244840 */   // MIs[0] Operand 1
     /* 2244840 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2244845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244849 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244853 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2244853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244865 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244869 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244887 */   // GIR_Coverage, 65329,
     /* 2244887 */   GIR_EraseRootFromParent_Done,
     /* 2244888 */ // Label 29994: @2244888
     /* 2244888 */ GIM_Try, /*On fail goto*//*Label 29995*/ GIMT_Encode4(2244954), // Rule ID 65333 //
     /* 2244893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244906 */   // MIs[0] Operand 1
     /* 2244906 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2244911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244915 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244919 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2244919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2244926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244931 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2244935 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2244939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2244941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2244944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2244949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2244952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244953 */   // GIR_Coverage, 65333,
     /* 2244953 */   GIR_EraseRootFromParent_Done,
     /* 2244954 */ // Label 29995: @2244954
     /* 2244954 */ GIM_Try, /*On fail goto*//*Label 29996*/ GIMT_Encode4(2245020), // Rule ID 65337 //
     /* 2244959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2244962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2244965 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2244968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244972 */   // MIs[0] Operand 1
     /* 2244972 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244981 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2244985 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2244985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2244988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2244992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2244997 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2245001 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2245005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2245007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2245010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2245015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2245018 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245019 */   // GIR_Coverage, 65337,
     /* 2245019 */   GIR_EraseRootFromParent_Done,
     /* 2245020 */ // Label 29996: @2245020
     /* 2245020 */ GIM_Reject,
     /* 2245021 */ // Label 29895: @2245021
     /* 2245021 */ GIM_Try, /*On fail goto*//*Label 29997*/ GIMT_Encode4(2245069), // Rule ID 45776 //
     /* 2245026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245039 */   // MIs[0] Operand 1
     /* 2245039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245052 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2245055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245057 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245068 */   // GIR_Coverage, 45776,
     /* 2245068 */   GIR_EraseRootFromParent_Done,
     /* 2245069 */ // Label 29997: @2245069
     /* 2245069 */ GIM_Try, /*On fail goto*//*Label 29998*/ GIMT_Encode4(2245117), // Rule ID 45777 //
     /* 2245074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245087 */   // MIs[0] Operand 1
     /* 2245087 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245096 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245100 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2245103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245105 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245107 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245116 */   // GIR_Coverage, 45777,
     /* 2245116 */   GIR_EraseRootFromParent_Done,
     /* 2245117 */ // Label 29998: @2245117
     /* 2245117 */ GIM_Try, /*On fail goto*//*Label 29999*/ GIMT_Encode4(2245165), // Rule ID 45778 //
     /* 2245122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245135 */   // MIs[0] Operand 1
     /* 2245135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245144 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245148 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2245151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245153 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245155 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245164 */   // GIR_Coverage, 45778,
     /* 2245164 */   GIR_EraseRootFromParent_Done,
     /* 2245165 */ // Label 29999: @2245165
     /* 2245165 */ GIM_Try, /*On fail goto*//*Label 30000*/ GIMT_Encode4(2245213), // Rule ID 45779 //
     /* 2245170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245183 */   // MIs[0] Operand 1
     /* 2245183 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2245188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245192 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245196 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2245199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245201 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245203 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245212 */   // GIR_Coverage, 45779,
     /* 2245212 */   GIR_EraseRootFromParent_Done,
     /* 2245213 */ // Label 30000: @2245213
     /* 2245213 */ GIM_Try, /*On fail goto*//*Label 30001*/ GIMT_Encode4(2245261), // Rule ID 48490 //
     /* 2245218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2245224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2245227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245231 */   // MIs[0] Operand 1
     /* 2245231 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245240 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245244 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2245244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2245247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245249 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245251 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245260 */   // GIR_Coverage, 48490,
     /* 2245260 */   GIR_EraseRootFromParent_Done,
     /* 2245261 */ // Label 30001: @2245261
     /* 2245261 */ GIM_Try, /*On fail goto*//*Label 30002*/ GIMT_Encode4(2245309), // Rule ID 48491 //
     /* 2245266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2245272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2245275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245279 */   // MIs[0] Operand 1
     /* 2245279 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245288 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245292 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2245292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2245295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245297 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245299 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245308 */   // GIR_Coverage, 48491,
     /* 2245308 */   GIR_EraseRootFromParent_Done,
     /* 2245309 */ // Label 30002: @2245309
     /* 2245309 */ GIM_Try, /*On fail goto*//*Label 30003*/ GIMT_Encode4(2245357), // Rule ID 48494 //
     /* 2245314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2245320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2245323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245327 */   // MIs[0] Operand 1
     /* 2245327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245340 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2245340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2245343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245345 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245347 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245356 */   // GIR_Coverage, 48494,
     /* 2245356 */   GIR_EraseRootFromParent_Done,
     /* 2245357 */ // Label 30003: @2245357
     /* 2245357 */ GIM_Try, /*On fail goto*//*Label 30004*/ GIMT_Encode4(2245405), // Rule ID 48495 //
     /* 2245362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2245368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2245371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245375 */   // MIs[0] Operand 1
     /* 2245375 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245384 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245388 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2245388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2245391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245393 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245395 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245404 */   // GIR_Coverage, 48495,
     /* 2245404 */   GIR_EraseRootFromParent_Done,
     /* 2245405 */ // Label 30004: @2245405
     /* 2245405 */ GIM_Try, /*On fail goto*//*Label 30005*/ GIMT_Encode4(2245453), // Rule ID 48502 //
     /* 2245410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2245416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2245419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245423 */   // MIs[0] Operand 1
     /* 2245423 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245436 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2245436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2245439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245441 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245443 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245452 */   // GIR_Coverage, 48502,
     /* 2245452 */   GIR_EraseRootFromParent_Done,
     /* 2245453 */ // Label 30005: @2245453
     /* 2245453 */ GIM_Try, /*On fail goto*//*Label 30006*/ GIMT_Encode4(2245501), // Rule ID 48503 //
     /* 2245458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2245461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2245464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2245467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245471 */   // MIs[0] Operand 1
     /* 2245471 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2245476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245480 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245484 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2245484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2245487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245489 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245491 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245500 */   // GIR_Coverage, 48503,
     /* 2245500 */   GIR_EraseRootFromParent_Done,
     /* 2245501 */ // Label 30006: @2245501
     /* 2245501 */ GIM_Try, /*On fail goto*//*Label 30007*/ GIMT_Encode4(2245549), // Rule ID 48528 //
     /* 2245506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245519 */   // MIs[0] Operand 1
     /* 2245519 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245528 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245532 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2245535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245537 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245539 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245548 */   // GIR_Coverage, 48528,
     /* 2245548 */   GIR_EraseRootFromParent_Done,
     /* 2245549 */ // Label 30007: @2245549
     /* 2245549 */ GIM_Try, /*On fail goto*//*Label 30008*/ GIMT_Encode4(2245597), // Rule ID 48529 //
     /* 2245554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245560 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245567 */   // MIs[0] Operand 1
     /* 2245567 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245576 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245580 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2245583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245585 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245587 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245596 */   // GIR_Coverage, 48529,
     /* 2245596 */   GIR_EraseRootFromParent_Done,
     /* 2245597 */ // Label 30008: @2245597
     /* 2245597 */ GIM_Try, /*On fail goto*//*Label 30009*/ GIMT_Encode4(2245645), // Rule ID 48534 //
     /* 2245602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2245608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2245611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245615 */   // MIs[0] Operand 1
     /* 2245615 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245624 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245628 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2245628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2245631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245633 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245635 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245644 */   // GIR_Coverage, 48534,
     /* 2245644 */   GIR_EraseRootFromParent_Done,
     /* 2245645 */ // Label 30009: @2245645
     /* 2245645 */ GIM_Try, /*On fail goto*//*Label 30010*/ GIMT_Encode4(2245693), // Rule ID 48535 //
     /* 2245650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2245656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2245659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245663 */   // MIs[0] Operand 1
     /* 2245663 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245676 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2245676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2245679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245681 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245683 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245692 */   // GIR_Coverage, 48535,
     /* 2245692 */   GIR_EraseRootFromParent_Done,
     /* 2245693 */ // Label 30010: @2245693
     /* 2245693 */ GIM_Try, /*On fail goto*//*Label 30011*/ GIMT_Encode4(2245741), // Rule ID 48538 //
     /* 2245698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2245704 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2245707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245711 */   // MIs[0] Operand 1
     /* 2245711 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245720 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245724 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2245724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2245727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245729 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245731 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245740 */   // GIR_Coverage, 48538,
     /* 2245740 */   GIR_EraseRootFromParent_Done,
     /* 2245741 */ // Label 30011: @2245741
     /* 2245741 */ GIM_Try, /*On fail goto*//*Label 30012*/ GIMT_Encode4(2245789), // Rule ID 48539 //
     /* 2245746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2245752 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2245755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245759 */   // MIs[0] Operand 1
     /* 2245759 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245768 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245772 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2245772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2245775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245777 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245779 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245787 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245788 */   // GIR_Coverage, 48539,
     /* 2245788 */   GIR_EraseRootFromParent_Done,
     /* 2245789 */ // Label 30012: @2245789
     /* 2245789 */ GIM_Try, /*On fail goto*//*Label 30013*/ GIMT_Encode4(2245837), // Rule ID 48546 //
     /* 2245794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2245800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2245803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245807 */   // MIs[0] Operand 1
     /* 2245807 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245816 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245820 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2245820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2245823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245825 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245827 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245836 */   // GIR_Coverage, 48546,
     /* 2245836 */   GIR_EraseRootFromParent_Done,
     /* 2245837 */ // Label 30013: @2245837
     /* 2245837 */ GIM_Try, /*On fail goto*//*Label 30014*/ GIMT_Encode4(2245885), // Rule ID 48547 //
     /* 2245842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2245845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2245848 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2245851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245855 */   // MIs[0] Operand 1
     /* 2245855 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2245860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245864 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245868 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2245868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2245871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245873 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245875 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245884 */   // GIR_Coverage, 48547,
     /* 2245884 */   GIR_EraseRootFromParent_Done,
     /* 2245885 */ // Label 30014: @2245885
     /* 2245885 */ GIM_Try, /*On fail goto*//*Label 30015*/ GIMT_Encode4(2245933), // Rule ID 48572 //
     /* 2245890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245896 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245903 */   // MIs[0] Operand 1
     /* 2245903 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2245908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245912 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245916 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2245919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245921 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245923 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245932 */   // GIR_Coverage, 48572,
     /* 2245932 */   GIR_EraseRootFromParent_Done,
     /* 2245933 */ // Label 30015: @2245933
     /* 2245933 */ GIM_Try, /*On fail goto*//*Label 30016*/ GIMT_Encode4(2245981), // Rule ID 48573 //
     /* 2245938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2245944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2245947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245951 */   // MIs[0] Operand 1
     /* 2245951 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2245956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245960 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245964 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2245967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245969 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245971 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245979 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245980 */   // GIR_Coverage, 48573,
     /* 2245980 */   GIR_EraseRootFromParent_Done,
     /* 2245981 */ // Label 30016: @2245981
     /* 2245981 */ GIM_Try, /*On fail goto*//*Label 30017*/ GIMT_Encode4(2246029), // Rule ID 48578 //
     /* 2245986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2245992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2245995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245999 */   // MIs[0] Operand 1
     /* 2245999 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246008 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246012 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246017 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246019 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246028 */   // GIR_Coverage, 48578,
     /* 2246028 */   GIR_EraseRootFromParent_Done,
     /* 2246029 */ // Label 30017: @2246029
     /* 2246029 */ GIM_Try, /*On fail goto*//*Label 30018*/ GIMT_Encode4(2246077), // Rule ID 48579 //
     /* 2246034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246047 */   // MIs[0] Operand 1
     /* 2246047 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246056 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246060 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246065 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246067 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246076 */   // GIR_Coverage, 48579,
     /* 2246076 */   GIR_EraseRootFromParent_Done,
     /* 2246077 */ // Label 30018: @2246077
     /* 2246077 */ GIM_Try, /*On fail goto*//*Label 30019*/ GIMT_Encode4(2246125), // Rule ID 48582 //
     /* 2246082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246088 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246095 */   // MIs[0] Operand 1
     /* 2246095 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246104 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246108 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246113 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246115 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246123 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246124 */   // GIR_Coverage, 48582,
     /* 2246124 */   GIR_EraseRootFromParent_Done,
     /* 2246125 */ // Label 30019: @2246125
     /* 2246125 */ GIM_Try, /*On fail goto*//*Label 30020*/ GIMT_Encode4(2246173), // Rule ID 48583 //
     /* 2246130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246136 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246143 */   // MIs[0] Operand 1
     /* 2246143 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246152 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246156 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246161 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246163 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246172 */   // GIR_Coverage, 48583,
     /* 2246172 */   GIR_EraseRootFromParent_Done,
     /* 2246173 */ // Label 30020: @2246173
     /* 2246173 */ GIM_Try, /*On fail goto*//*Label 30021*/ GIMT_Encode4(2246221), // Rule ID 48590 //
     /* 2246178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246184 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246191 */   // MIs[0] Operand 1
     /* 2246191 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246200 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246204 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2246207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246209 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246211 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246220 */   // GIR_Coverage, 48590,
     /* 2246220 */   GIR_EraseRootFromParent_Done,
     /* 2246221 */ // Label 30021: @2246221
     /* 2246221 */ GIM_Try, /*On fail goto*//*Label 30022*/ GIMT_Encode4(2246269), // Rule ID 48591 //
     /* 2246226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246232 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246239 */   // MIs[0] Operand 1
     /* 2246239 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2246244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246248 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246252 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2246255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246257 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246259 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246268 */   // GIR_Coverage, 48591,
     /* 2246268 */   GIR_EraseRootFromParent_Done,
     /* 2246269 */ // Label 30022: @2246269
     /* 2246269 */ GIM_Try, /*On fail goto*//*Label 30023*/ GIMT_Encode4(2246317), // Rule ID 48620 //
     /* 2246274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246280 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246287 */   // MIs[0] Operand 1
     /* 2246287 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246296 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246300 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246305 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246307 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246316 */   // GIR_Coverage, 48620,
     /* 2246316 */   GIR_EraseRootFromParent_Done,
     /* 2246317 */ // Label 30023: @2246317
     /* 2246317 */ GIM_Try, /*On fail goto*//*Label 30024*/ GIMT_Encode4(2246365), // Rule ID 48621 //
     /* 2246322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246335 */   // MIs[0] Operand 1
     /* 2246335 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246344 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246348 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2246351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246353 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246364 */   // GIR_Coverage, 48621,
     /* 2246364 */   GIR_EraseRootFromParent_Done,
     /* 2246365 */ // Label 30024: @2246365
     /* 2246365 */ GIM_Try, /*On fail goto*//*Label 30025*/ GIMT_Encode4(2246413), // Rule ID 48624 //
     /* 2246370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246376 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246383 */   // MIs[0] Operand 1
     /* 2246383 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246392 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246396 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246401 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246403 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246412 */   // GIR_Coverage, 48624,
     /* 2246412 */   GIR_EraseRootFromParent_Done,
     /* 2246413 */ // Label 30025: @2246413
     /* 2246413 */ GIM_Try, /*On fail goto*//*Label 30026*/ GIMT_Encode4(2246461), // Rule ID 48625 //
     /* 2246418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246424 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246431 */   // MIs[0] Operand 1
     /* 2246431 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246440 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246444 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2246447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246449 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246451 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246459 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246460 */   // GIR_Coverage, 48625,
     /* 2246460 */   GIR_EraseRootFromParent_Done,
     /* 2246461 */ // Label 30026: @2246461
     /* 2246461 */ GIM_Try, /*On fail goto*//*Label 30027*/ GIMT_Encode4(2246509), // Rule ID 48632 //
     /* 2246466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246472 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246479 */   // MIs[0] Operand 1
     /* 2246479 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246488 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246492 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2246495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246497 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246499 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246508 */   // GIR_Coverage, 48632,
     /* 2246508 */   GIR_EraseRootFromParent_Done,
     /* 2246509 */ // Label 30027: @2246509
     /* 2246509 */ GIM_Try, /*On fail goto*//*Label 30028*/ GIMT_Encode4(2246557), // Rule ID 48633 //
     /* 2246514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246520 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246527 */   // MIs[0] Operand 1
     /* 2246527 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2246532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246536 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246540 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2246543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246545 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246547 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246555 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246556 */   // GIR_Coverage, 48633,
     /* 2246556 */   GIR_EraseRootFromParent_Done,
     /* 2246557 */ // Label 30028: @2246557
     /* 2246557 */ GIM_Try, /*On fail goto*//*Label 30029*/ GIMT_Encode4(2246605), // Rule ID 48658 //
     /* 2246562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246568 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246575 */   // MIs[0] Operand 1
     /* 2246575 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246584 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246588 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2246591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246593 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246595 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246603 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246604 */   // GIR_Coverage, 48658,
     /* 2246604 */   GIR_EraseRootFromParent_Done,
     /* 2246605 */ // Label 30029: @2246605
     /* 2246605 */ GIM_Try, /*On fail goto*//*Label 30030*/ GIMT_Encode4(2246653), // Rule ID 48659 //
     /* 2246610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246616 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246623 */   // MIs[0] Operand 1
     /* 2246623 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246632 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246636 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2246639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246641 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246643 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246652 */   // GIR_Coverage, 48659,
     /* 2246652 */   GIR_EraseRootFromParent_Done,
     /* 2246653 */ // Label 30030: @2246653
     /* 2246653 */ GIM_Try, /*On fail goto*//*Label 30031*/ GIMT_Encode4(2246701), // Rule ID 48664 //
     /* 2246658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246671 */   // MIs[0] Operand 1
     /* 2246671 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246680 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246684 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2246687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246689 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246691 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246700 */   // GIR_Coverage, 48664,
     /* 2246700 */   GIR_EraseRootFromParent_Done,
     /* 2246701 */ // Label 30031: @2246701
     /* 2246701 */ GIM_Try, /*On fail goto*//*Label 30032*/ GIMT_Encode4(2246749), // Rule ID 48665 //
     /* 2246706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2246712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2246715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246719 */   // MIs[0] Operand 1
     /* 2246719 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246728 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246732 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2246735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246737 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246739 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246748 */   // GIR_Coverage, 48665,
     /* 2246748 */   GIR_EraseRootFromParent_Done,
     /* 2246749 */ // Label 30032: @2246749
     /* 2246749 */ GIM_Try, /*On fail goto*//*Label 30033*/ GIMT_Encode4(2246797), // Rule ID 48668 //
     /* 2246754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246760 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246767 */   // MIs[0] Operand 1
     /* 2246767 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246776 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246780 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2246783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246785 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246787 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246795 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246796 */   // GIR_Coverage, 48668,
     /* 2246796 */   GIR_EraseRootFromParent_Done,
     /* 2246797 */ // Label 30033: @2246797
     /* 2246797 */ GIM_Try, /*On fail goto*//*Label 30034*/ GIMT_Encode4(2246845), // Rule ID 48669 //
     /* 2246802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2246808 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2246811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246815 */   // MIs[0] Operand 1
     /* 2246815 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246824 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246828 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2246831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246833 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246835 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246843 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246844 */   // GIR_Coverage, 48669,
     /* 2246844 */   GIR_EraseRootFromParent_Done,
     /* 2246845 */ // Label 30034: @2246845
     /* 2246845 */ GIM_Try, /*On fail goto*//*Label 30035*/ GIMT_Encode4(2246893), // Rule ID 48676 //
     /* 2246850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246856 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246863 */   // MIs[0] Operand 1
     /* 2246863 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246872 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246876 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2246879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246881 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246883 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246891 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246892 */   // GIR_Coverage, 48676,
     /* 2246892 */   GIR_EraseRootFromParent_Done,
     /* 2246893 */ // Label 30035: @2246893
     /* 2246893 */ GIM_Try, /*On fail goto*//*Label 30036*/ GIMT_Encode4(2246941), // Rule ID 48677 //
     /* 2246898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2246904 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2246907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246911 */   // MIs[0] Operand 1
     /* 2246911 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2246916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246920 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246924 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2246927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246929 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246931 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246940 */   // GIR_Coverage, 48677,
     /* 2246940 */   GIR_EraseRootFromParent_Done,
     /* 2246941 */ // Label 30036: @2246941
     /* 2246941 */ GIM_Try, /*On fail goto*//*Label 30037*/ GIMT_Encode4(2246989), // Rule ID 48702 //
     /* 2246946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2246952 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2246955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246959 */   // MIs[0] Operand 1
     /* 2246959 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2246964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246968 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246972 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2246975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246977 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246979 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246987 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246988 */   // GIR_Coverage, 48702,
     /* 2246988 */   GIR_EraseRootFromParent_Done,
     /* 2246989 */ // Label 30037: @2246989
     /* 2246989 */ GIM_Try, /*On fail goto*//*Label 30038*/ GIMT_Encode4(2247037), // Rule ID 48703 //
     /* 2246994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247000 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247007 */   // MIs[0] Operand 1
     /* 2247007 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247016 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247020 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2247023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247025 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247027 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247035 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247036 */   // GIR_Coverage, 48703,
     /* 2247036 */   GIR_EraseRootFromParent_Done,
     /* 2247037 */ // Label 30038: @2247037
     /* 2247037 */ GIM_Try, /*On fail goto*//*Label 30039*/ GIMT_Encode4(2247085), // Rule ID 48708 //
     /* 2247042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247048 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247055 */   // MIs[0] Operand 1
     /* 2247055 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247064 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247068 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247073 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247075 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247084 */   // GIR_Coverage, 48708,
     /* 2247084 */   GIR_EraseRootFromParent_Done,
     /* 2247085 */ // Label 30039: @2247085
     /* 2247085 */ GIM_Try, /*On fail goto*//*Label 30040*/ GIMT_Encode4(2247133), // Rule ID 48709 //
     /* 2247090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247103 */   // MIs[0] Operand 1
     /* 2247103 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247112 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247116 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2247119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247121 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247131 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247132 */   // GIR_Coverage, 48709,
     /* 2247132 */   GIR_EraseRootFromParent_Done,
     /* 2247133 */ // Label 30040: @2247133
     /* 2247133 */ GIM_Try, /*On fail goto*//*Label 30041*/ GIMT_Encode4(2247181), // Rule ID 48712 //
     /* 2247138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247144 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247151 */   // MIs[0] Operand 1
     /* 2247151 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247160 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247164 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247169 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247171 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247179 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247180 */   // GIR_Coverage, 48712,
     /* 2247180 */   GIR_EraseRootFromParent_Done,
     /* 2247181 */ // Label 30041: @2247181
     /* 2247181 */ GIM_Try, /*On fail goto*//*Label 30042*/ GIMT_Encode4(2247229), // Rule ID 48713 //
     /* 2247186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247199 */   // MIs[0] Operand 1
     /* 2247199 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247208 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247212 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2247215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247217 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247219 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247227 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247228 */   // GIR_Coverage, 48713,
     /* 2247228 */   GIR_EraseRootFromParent_Done,
     /* 2247229 */ // Label 30042: @2247229
     /* 2247229 */ GIM_Try, /*On fail goto*//*Label 30043*/ GIMT_Encode4(2247277), // Rule ID 48720 //
     /* 2247234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247247 */   // MIs[0] Operand 1
     /* 2247247 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247256 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247260 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247265 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247267 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247275 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247276 */   // GIR_Coverage, 48720,
     /* 2247276 */   GIR_EraseRootFromParent_Done,
     /* 2247277 */ // Label 30043: @2247277
     /* 2247277 */ GIM_Try, /*On fail goto*//*Label 30044*/ GIMT_Encode4(2247325), // Rule ID 48721 //
     /* 2247282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247288 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247295 */   // MIs[0] Operand 1
     /* 2247295 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247304 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247308 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2247311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247313 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247315 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247324 */   // GIR_Coverage, 48721,
     /* 2247324 */   GIR_EraseRootFromParent_Done,
     /* 2247325 */ // Label 30044: @2247325
     /* 2247325 */ GIM_Try, /*On fail goto*//*Label 30045*/ GIMT_Encode4(2247373), // Rule ID 48746 //
     /* 2247330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247336 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247343 */   // MIs[0] Operand 1
     /* 2247343 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247352 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247356 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2247359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247361 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247371 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247372 */   // GIR_Coverage, 48746,
     /* 2247372 */   GIR_EraseRootFromParent_Done,
     /* 2247373 */ // Label 30045: @2247373
     /* 2247373 */ GIM_Try, /*On fail goto*//*Label 30046*/ GIMT_Encode4(2247421), // Rule ID 48747 //
     /* 2247378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247384 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247391 */   // MIs[0] Operand 1
     /* 2247391 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247400 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247404 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2247407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247409 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247420 */   // GIR_Coverage, 48747,
     /* 2247420 */   GIR_EraseRootFromParent_Done,
     /* 2247421 */ // Label 30046: @2247421
     /* 2247421 */ GIM_Try, /*On fail goto*//*Label 30047*/ GIMT_Encode4(2247469), // Rule ID 48752 //
     /* 2247426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247439 */   // MIs[0] Operand 1
     /* 2247439 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247448 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247452 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2247455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247457 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247459 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247467 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247468 */   // GIR_Coverage, 48752,
     /* 2247468 */   GIR_EraseRootFromParent_Done,
     /* 2247469 */ // Label 30047: @2247469
     /* 2247469 */ GIM_Try, /*On fail goto*//*Label 30048*/ GIMT_Encode4(2247517), // Rule ID 48753 //
     /* 2247474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247480 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247487 */   // MIs[0] Operand 1
     /* 2247487 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247496 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247500 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2247503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247505 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247507 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247516 */   // GIR_Coverage, 48753,
     /* 2247516 */   GIR_EraseRootFromParent_Done,
     /* 2247517 */ // Label 30048: @2247517
     /* 2247517 */ GIM_Try, /*On fail goto*//*Label 30049*/ GIMT_Encode4(2247565), // Rule ID 48756 //
     /* 2247522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247535 */   // MIs[0] Operand 1
     /* 2247535 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247544 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247548 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2247551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247553 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247555 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247564 */   // GIR_Coverage, 48756,
     /* 2247564 */   GIR_EraseRootFromParent_Done,
     /* 2247565 */ // Label 30049: @2247565
     /* 2247565 */ GIM_Try, /*On fail goto*//*Label 30050*/ GIMT_Encode4(2247613), // Rule ID 48757 //
     /* 2247570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247576 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247583 */   // MIs[0] Operand 1
     /* 2247583 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247592 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247596 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2247599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247601 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247603 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247611 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247612 */   // GIR_Coverage, 48757,
     /* 2247612 */   GIR_EraseRootFromParent_Done,
     /* 2247613 */ // Label 30050: @2247613
     /* 2247613 */ GIM_Try, /*On fail goto*//*Label 30051*/ GIMT_Encode4(2247661), // Rule ID 48764 //
     /* 2247618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2247621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247624 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247631 */   // MIs[0] Operand 1
     /* 2247631 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247640 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247644 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2247644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2247647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247649 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247651 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247660 */   // GIR_Coverage, 48764,
     /* 2247660 */   GIR_EraseRootFromParent_Done,
     /* 2247661 */ // Label 30051: @2247661
     /* 2247661 */ GIM_Try, /*On fail goto*//*Label 30052*/ GIMT_Encode4(2247709), // Rule ID 48765 //
     /* 2247666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2247669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2247672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2247675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247679 */   // MIs[0] Operand 1
     /* 2247679 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2247684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247688 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247692 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2247692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2247695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247697 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247699 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2247707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247708 */   // GIR_Coverage, 48765,
     /* 2247708 */   GIR_EraseRootFromParent_Done,
     /* 2247709 */ // Label 30052: @2247709
     /* 2247709 */ GIM_Try, /*On fail goto*//*Label 30053*/ GIMT_Encode4(2247757), // Rule ID 48790 //
     /* 2247714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247720 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247727 */   // MIs[0] Operand 1
     /* 2247727 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2247732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247736 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247740 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2247743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247745 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247747 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247756 */   // GIR_Coverage, 48790,
     /* 2247756 */   GIR_EraseRootFromParent_Done,
     /* 2247757 */ // Label 30053: @2247757
     /* 2247757 */ GIM_Try, /*On fail goto*//*Label 30054*/ GIMT_Encode4(2247805), // Rule ID 48791 //
     /* 2247762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2247768 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2247771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247775 */   // MIs[0] Operand 1
     /* 2247775 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2247780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247784 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247788 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2247791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247793 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247795 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247804 */   // GIR_Coverage, 48791,
     /* 2247804 */   GIR_EraseRootFromParent_Done,
     /* 2247805 */ // Label 30054: @2247805
     /* 2247805 */ GIM_Try, /*On fail goto*//*Label 30055*/ GIMT_Encode4(2247853), // Rule ID 48796 //
     /* 2247810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247823 */   // MIs[0] Operand 1
     /* 2247823 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2247828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247832 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247836 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2247839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247841 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247852 */   // GIR_Coverage, 48796,
     /* 2247852 */   GIR_EraseRootFromParent_Done,
     /* 2247853 */ // Label 30055: @2247853
     /* 2247853 */ GIM_Try, /*On fail goto*//*Label 30056*/ GIMT_Encode4(2247901), // Rule ID 48797 //
     /* 2247858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2247864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2247867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247871 */   // MIs[0] Operand 1
     /* 2247871 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2247876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247880 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247884 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2247887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247889 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247891 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247900 */   // GIR_Coverage, 48797,
     /* 2247900 */   GIR_EraseRootFromParent_Done,
     /* 2247901 */ // Label 30056: @2247901
     /* 2247901 */ GIM_Try, /*On fail goto*//*Label 30057*/ GIMT_Encode4(2247949), // Rule ID 48800 //
     /* 2247906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247912 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247919 */   // MIs[0] Operand 1
     /* 2247919 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2247924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247928 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247932 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2247935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247937 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247939 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247948 */   // GIR_Coverage, 48800,
     /* 2247948 */   GIR_EraseRootFromParent_Done,
     /* 2247949 */ // Label 30057: @2247949
     /* 2247949 */ GIM_Try, /*On fail goto*//*Label 30058*/ GIMT_Encode4(2247997), // Rule ID 48801 //
     /* 2247954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2247960 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2247963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247967 */   // MIs[0] Operand 1
     /* 2247967 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2247972 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247976 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247980 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2247983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247985 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247987 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247996 */   // GIR_Coverage, 48801,
     /* 2247996 */   GIR_EraseRootFromParent_Done,
     /* 2247997 */ // Label 30058: @2247997
     /* 2247997 */ GIM_Try, /*On fail goto*//*Label 30059*/ GIMT_Encode4(2248045), // Rule ID 48808 //
     /* 2248002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248008 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248015 */   // MIs[0] Operand 1
     /* 2248015 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248024 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248028 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248033 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248035 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248043 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248044 */   // GIR_Coverage, 48808,
     /* 2248044 */   GIR_EraseRootFromParent_Done,
     /* 2248045 */ // Label 30059: @2248045
     /* 2248045 */ GIM_Try, /*On fail goto*//*Label 30060*/ GIMT_Encode4(2248093), // Rule ID 48809 //
     /* 2248050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248056 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248063 */   // MIs[0] Operand 1
     /* 2248063 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248072 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248076 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2248079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248081 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248083 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248091 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248092 */   // GIR_Coverage, 48809,
     /* 2248092 */   GIR_EraseRootFromParent_Done,
     /* 2248093 */ // Label 30060: @2248093
     /* 2248093 */ GIM_Try, /*On fail goto*//*Label 30061*/ GIMT_Encode4(2248141), // Rule ID 48834 //
     /* 2248098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248111 */   // MIs[0] Operand 1
     /* 2248111 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248120 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248124 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2248127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248129 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248131 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248139 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248140 */   // GIR_Coverage, 48834,
     /* 2248140 */   GIR_EraseRootFromParent_Done,
     /* 2248141 */ // Label 30061: @2248141
     /* 2248141 */ GIM_Try, /*On fail goto*//*Label 30062*/ GIMT_Encode4(2248189), // Rule ID 48835 //
     /* 2248146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248159 */   // MIs[0] Operand 1
     /* 2248159 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248164 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248168 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248172 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2248175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248177 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248179 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248188 */   // GIR_Coverage, 48835,
     /* 2248188 */   GIR_EraseRootFromParent_Done,
     /* 2248189 */ // Label 30062: @2248189
     /* 2248189 */ GIM_Try, /*On fail goto*//*Label 30063*/ GIMT_Encode4(2248237), // Rule ID 48840 //
     /* 2248194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248200 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248207 */   // MIs[0] Operand 1
     /* 2248207 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248220 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2248223 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248225 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248227 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248236 */   // GIR_Coverage, 48840,
     /* 2248236 */   GIR_EraseRootFromParent_Done,
     /* 2248237 */ // Label 30063: @2248237
     /* 2248237 */ GIM_Try, /*On fail goto*//*Label 30064*/ GIMT_Encode4(2248285), // Rule ID 48841 //
     /* 2248242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248255 */   // MIs[0] Operand 1
     /* 2248255 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248260 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248264 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248268 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2248271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248273 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248275 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248283 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248284 */   // GIR_Coverage, 48841,
     /* 2248284 */   GIR_EraseRootFromParent_Done,
     /* 2248285 */ // Label 30064: @2248285
     /* 2248285 */ GIM_Try, /*On fail goto*//*Label 30065*/ GIMT_Encode4(2248333), // Rule ID 48844 //
     /* 2248290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248296 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248303 */   // MIs[0] Operand 1
     /* 2248303 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248312 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248316 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2248319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248321 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248323 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248332 */   // GIR_Coverage, 48844,
     /* 2248332 */   GIR_EraseRootFromParent_Done,
     /* 2248333 */ // Label 30065: @2248333
     /* 2248333 */ GIM_Try, /*On fail goto*//*Label 30066*/ GIMT_Encode4(2248381), // Rule ID 48845 //
     /* 2248338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248344 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248351 */   // MIs[0] Operand 1
     /* 2248351 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248360 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248364 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2248367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248369 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248371 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248380 */   // GIR_Coverage, 48845,
     /* 2248380 */   GIR_EraseRootFromParent_Done,
     /* 2248381 */ // Label 30066: @2248381
     /* 2248381 */ GIM_Try, /*On fail goto*//*Label 30067*/ GIMT_Encode4(2248429), // Rule ID 48852 //
     /* 2248386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248399 */   // MIs[0] Operand 1
     /* 2248399 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248408 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248412 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2248415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248417 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248419 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248428 */   // GIR_Coverage, 48852,
     /* 2248428 */   GIR_EraseRootFromParent_Done,
     /* 2248429 */ // Label 30067: @2248429
     /* 2248429 */ GIM_Try, /*On fail goto*//*Label 30068*/ GIMT_Encode4(2248477), // Rule ID 48853 //
     /* 2248434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248440 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248447 */   // MIs[0] Operand 1
     /* 2248447 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248456 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248460 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2248463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248465 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248467 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248476 */   // GIR_Coverage, 48853,
     /* 2248476 */   GIR_EraseRootFromParent_Done,
     /* 2248477 */ // Label 30068: @2248477
     /* 2248477 */ GIM_Try, /*On fail goto*//*Label 30069*/ GIMT_Encode4(2248525), // Rule ID 48878 //
     /* 2248482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248495 */   // MIs[0] Operand 1
     /* 2248495 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248504 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248508 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2248511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248513 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248515 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248524 */   // GIR_Coverage, 48878,
     /* 2248524 */   GIR_EraseRootFromParent_Done,
     /* 2248525 */ // Label 30069: @2248525
     /* 2248525 */ GIM_Try, /*On fail goto*//*Label 30070*/ GIMT_Encode4(2248573), // Rule ID 48879 //
     /* 2248530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2248536 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2248539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248543 */   // MIs[0] Operand 1
     /* 2248543 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248552 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248556 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2248559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248561 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248563 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248571 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248572 */   // GIR_Coverage, 48879,
     /* 2248572 */   GIR_EraseRootFromParent_Done,
     /* 2248573 */ // Label 30070: @2248573
     /* 2248573 */ GIM_Try, /*On fail goto*//*Label 30071*/ GIMT_Encode4(2248621), // Rule ID 48884 //
     /* 2248578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248584 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248591 */   // MIs[0] Operand 1
     /* 2248591 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248596 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248600 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248604 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2248607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248609 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248611 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248620 */   // GIR_Coverage, 48884,
     /* 2248620 */   GIR_EraseRootFromParent_Done,
     /* 2248621 */ // Label 30071: @2248621
     /* 2248621 */ GIM_Try, /*On fail goto*//*Label 30072*/ GIMT_Encode4(2248669), // Rule ID 48885 //
     /* 2248626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2248632 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2248635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248639 */   // MIs[0] Operand 1
     /* 2248639 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248648 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248652 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2248655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248657 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248659 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248668 */   // GIR_Coverage, 48885,
     /* 2248668 */   GIR_EraseRootFromParent_Done,
     /* 2248669 */ // Label 30072: @2248669
     /* 2248669 */ GIM_Try, /*On fail goto*//*Label 30073*/ GIMT_Encode4(2248717), // Rule ID 48888 //
     /* 2248674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248687 */   // MIs[0] Operand 1
     /* 2248687 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248696 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248700 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2248703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248705 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248707 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248716 */   // GIR_Coverage, 48888,
     /* 2248716 */   GIR_EraseRootFromParent_Done,
     /* 2248717 */ // Label 30073: @2248717
     /* 2248717 */ GIM_Try, /*On fail goto*//*Label 30074*/ GIMT_Encode4(2248765), // Rule ID 48889 //
     /* 2248722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2248728 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2248731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248735 */   // MIs[0] Operand 1
     /* 2248735 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248744 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248748 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2248751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248753 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248755 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248764 */   // GIR_Coverage, 48889,
     /* 2248764 */   GIR_EraseRootFromParent_Done,
     /* 2248765 */ // Label 30074: @2248765
     /* 2248765 */ GIM_Try, /*On fail goto*//*Label 30075*/ GIMT_Encode4(2248813), // Rule ID 48896 //
     /* 2248770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2248773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248783 */   // MIs[0] Operand 1
     /* 2248783 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248792 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248796 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2248796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2248799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248801 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248803 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248812 */   // GIR_Coverage, 48896,
     /* 2248812 */   GIR_EraseRootFromParent_Done,
     /* 2248813 */ // Label 30075: @2248813
     /* 2248813 */ GIM_Try, /*On fail goto*//*Label 30076*/ GIMT_Encode4(2248861), // Rule ID 48897 //
     /* 2248818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2248821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2248824 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2248827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248831 */   // MIs[0] Operand 1
     /* 2248831 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2248836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248840 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248844 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2248844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2248847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248849 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248851 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2248859 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248860 */   // GIR_Coverage, 48897,
     /* 2248860 */   GIR_EraseRootFromParent_Done,
     /* 2248861 */ // Label 30076: @2248861
     /* 2248861 */ GIM_Reject,
     /* 2248862 */ // Label 29896: @2248862
     /* 2248862 */ GIM_Try, /*On fail goto*//*Label 30077*/ GIMT_Encode4(2248910), // Rule ID 48486 //
     /* 2248867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2248873 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2248876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248880 */   // MIs[0] Operand 1
     /* 2248880 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2248885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248889 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248893 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2248896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248898 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248900 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248908 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248909 */   // GIR_Coverage, 48486,
     /* 2248909 */   GIR_EraseRootFromParent_Done,
     /* 2248910 */ // Label 30077: @2248910
     /* 2248910 */ GIM_Try, /*On fail goto*//*Label 30078*/ GIMT_Encode4(2248958), // Rule ID 48487 //
     /* 2248915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2248921 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2248924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248928 */   // MIs[0] Operand 1
     /* 2248928 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2248933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248937 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248941 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2248944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248946 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248948 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248956 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248957 */   // GIR_Coverage, 48487,
     /* 2248957 */   GIR_EraseRootFromParent_Done,
     /* 2248958 */ // Label 30078: @2248958
     /* 2248958 */ GIM_Try, /*On fail goto*//*Label 30079*/ GIMT_Encode4(2249006), // Rule ID 48492 //
     /* 2248963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2248969 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2248972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248976 */   // MIs[0] Operand 1
     /* 2248976 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2248981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248985 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248989 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2248992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248994 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248996 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249005 */   // GIR_Coverage, 48492,
     /* 2249005 */   GIR_EraseRootFromParent_Done,
     /* 2249006 */ // Label 30079: @2249006
     /* 2249006 */ GIM_Try, /*On fail goto*//*Label 30080*/ GIMT_Encode4(2249054), // Rule ID 48493 //
     /* 2249011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249024 */   // MIs[0] Operand 1
     /* 2249024 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249033 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249037 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2249040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249042 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249044 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249053 */   // GIR_Coverage, 48493,
     /* 2249053 */   GIR_EraseRootFromParent_Done,
     /* 2249054 */ // Label 30080: @2249054
     /* 2249054 */ GIM_Try, /*On fail goto*//*Label 30081*/ GIMT_Encode4(2249102), // Rule ID 48500 //
     /* 2249059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249072 */   // MIs[0] Operand 1
     /* 2249072 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249081 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249085 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2249088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249090 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249092 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249100 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249101 */   // GIR_Coverage, 48500,
     /* 2249101 */   GIR_EraseRootFromParent_Done,
     /* 2249102 */ // Label 30081: @2249102
     /* 2249102 */ GIM_Try, /*On fail goto*//*Label 30082*/ GIMT_Encode4(2249150), // Rule ID 48501 //
     /* 2249107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249113 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249120 */   // MIs[0] Operand 1
     /* 2249120 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249129 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249133 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2249136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249138 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249140 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249149 */   // GIR_Coverage, 48501,
     /* 2249149 */   GIR_EraseRootFromParent_Done,
     /* 2249150 */ // Label 30082: @2249150
     /* 2249150 */ GIM_Try, /*On fail goto*//*Label 30083*/ GIMT_Encode4(2249198), // Rule ID 48522 //
     /* 2249155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2249161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2249164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249168 */   // MIs[0] Operand 1
     /* 2249168 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249181 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2249184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249186 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249188 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249197 */   // GIR_Coverage, 48522,
     /* 2249197 */   GIR_EraseRootFromParent_Done,
     /* 2249198 */ // Label 30083: @2249198
     /* 2249198 */ GIM_Try, /*On fail goto*//*Label 30084*/ GIMT_Encode4(2249246), // Rule ID 48523 //
     /* 2249203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2249209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2249212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249216 */   // MIs[0] Operand 1
     /* 2249216 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249225 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249229 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2249232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249234 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249236 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249245 */   // GIR_Coverage, 48523,
     /* 2249245 */   GIR_EraseRootFromParent_Done,
     /* 2249246 */ // Label 30084: @2249246
     /* 2249246 */ GIM_Try, /*On fail goto*//*Label 30085*/ GIMT_Encode4(2249294), // Rule ID 48530 //
     /* 2249251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249264 */   // MIs[0] Operand 1
     /* 2249264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249273 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249277 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2249280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249282 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249284 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249292 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249293 */   // GIR_Coverage, 48530,
     /* 2249293 */   GIR_EraseRootFromParent_Done,
     /* 2249294 */ // Label 30085: @2249294
     /* 2249294 */ GIM_Try, /*On fail goto*//*Label 30086*/ GIMT_Encode4(2249342), // Rule ID 48531 //
     /* 2249299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249312 */   // MIs[0] Operand 1
     /* 2249312 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249321 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249325 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2249328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249330 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249332 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249341 */   // GIR_Coverage, 48531,
     /* 2249341 */   GIR_EraseRootFromParent_Done,
     /* 2249342 */ // Label 30086: @2249342
     /* 2249342 */ GIM_Try, /*On fail goto*//*Label 30087*/ GIMT_Encode4(2249390), // Rule ID 48536 //
     /* 2249347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249353 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249360 */   // MIs[0] Operand 1
     /* 2249360 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249369 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249373 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2249376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249378 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249380 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249389 */   // GIR_Coverage, 48536,
     /* 2249389 */   GIR_EraseRootFromParent_Done,
     /* 2249390 */ // Label 30087: @2249390
     /* 2249390 */ GIM_Try, /*On fail goto*//*Label 30088*/ GIMT_Encode4(2249438), // Rule ID 48537 //
     /* 2249395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249408 */   // MIs[0] Operand 1
     /* 2249408 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249417 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249421 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2249424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249426 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249428 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249437 */   // GIR_Coverage, 48537,
     /* 2249437 */   GIR_EraseRootFromParent_Done,
     /* 2249438 */ // Label 30088: @2249438
     /* 2249438 */ GIM_Try, /*On fail goto*//*Label 30089*/ GIMT_Encode4(2249486), // Rule ID 48544 //
     /* 2249443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249456 */   // MIs[0] Operand 1
     /* 2249456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249465 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249469 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2249472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249474 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249476 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249485 */   // GIR_Coverage, 48544,
     /* 2249485 */   GIR_EraseRootFromParent_Done,
     /* 2249486 */ // Label 30089: @2249486
     /* 2249486 */ GIM_Try, /*On fail goto*//*Label 30090*/ GIMT_Encode4(2249534), // Rule ID 48545 //
     /* 2249491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249504 */   // MIs[0] Operand 1
     /* 2249504 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249513 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249517 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2249520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249522 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249524 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249533 */   // GIR_Coverage, 48545,
     /* 2249533 */   GIR_EraseRootFromParent_Done,
     /* 2249534 */ // Label 30090: @2249534
     /* 2249534 */ GIM_Try, /*On fail goto*//*Label 30091*/ GIMT_Encode4(2249582), // Rule ID 48566 //
     /* 2249539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2249545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2249548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249552 */   // MIs[0] Operand 1
     /* 2249552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249565 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2249568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249570 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249572 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249581 */   // GIR_Coverage, 48566,
     /* 2249581 */   GIR_EraseRootFromParent_Done,
     /* 2249582 */ // Label 30091: @2249582
     /* 2249582 */ GIM_Try, /*On fail goto*//*Label 30092*/ GIMT_Encode4(2249630), // Rule ID 48567 //
     /* 2249587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2249593 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2249596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249600 */   // MIs[0] Operand 1
     /* 2249600 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249609 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249613 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2249616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249618 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249620 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249629 */   // GIR_Coverage, 48567,
     /* 2249629 */   GIR_EraseRootFromParent_Done,
     /* 2249630 */ // Label 30092: @2249630
     /* 2249630 */ GIM_Try, /*On fail goto*//*Label 30093*/ GIMT_Encode4(2249678), // Rule ID 48574 //
     /* 2249635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249648 */   // MIs[0] Operand 1
     /* 2249648 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249657 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249661 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2249664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249666 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249677 */   // GIR_Coverage, 48574,
     /* 2249677 */   GIR_EraseRootFromParent_Done,
     /* 2249678 */ // Label 30093: @2249678
     /* 2249678 */ GIM_Try, /*On fail goto*//*Label 30094*/ GIMT_Encode4(2249726), // Rule ID 48575 //
     /* 2249683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2249689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2249692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249696 */   // MIs[0] Operand 1
     /* 2249696 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249705 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249709 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2249712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249714 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249725 */   // GIR_Coverage, 48575,
     /* 2249725 */   GIR_EraseRootFromParent_Done,
     /* 2249726 */ // Label 30094: @2249726
     /* 2249726 */ GIM_Try, /*On fail goto*//*Label 30095*/ GIMT_Encode4(2249774), // Rule ID 48580 //
     /* 2249731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249737 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249744 */   // MIs[0] Operand 1
     /* 2249744 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249753 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249757 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2249760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249762 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249764 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249773 */   // GIR_Coverage, 48580,
     /* 2249773 */   GIR_EraseRootFromParent_Done,
     /* 2249774 */ // Label 30095: @2249774
     /* 2249774 */ GIM_Try, /*On fail goto*//*Label 30096*/ GIMT_Encode4(2249822), // Rule ID 48581 //
     /* 2249779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2249785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2249788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249792 */   // MIs[0] Operand 1
     /* 2249792 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249801 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249805 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2249808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249810 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249812 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249821 */   // GIR_Coverage, 48581,
     /* 2249821 */   GIR_EraseRootFromParent_Done,
     /* 2249822 */ // Label 30096: @2249822
     /* 2249822 */ GIM_Try, /*On fail goto*//*Label 30097*/ GIMT_Encode4(2249870), // Rule ID 48588 //
     /* 2249827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249840 */   // MIs[0] Operand 1
     /* 2249840 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249849 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249853 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2249856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249858 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249860 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249869 */   // GIR_Coverage, 48588,
     /* 2249869 */   GIR_EraseRootFromParent_Done,
     /* 2249870 */ // Label 30097: @2249870
     /* 2249870 */ GIM_Try, /*On fail goto*//*Label 30098*/ GIMT_Encode4(2249918), // Rule ID 48589 //
     /* 2249875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2249881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2249884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249888 */   // MIs[0] Operand 1
     /* 2249888 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249897 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249901 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2249904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249906 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249908 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249917 */   // GIR_Coverage, 48589,
     /* 2249917 */   GIR_EraseRootFromParent_Done,
     /* 2249918 */ // Label 30098: @2249918
     /* 2249918 */ GIM_Try, /*On fail goto*//*Label 30099*/ GIMT_Encode4(2249966), // Rule ID 48610 //
     /* 2249923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2249926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2249929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2249932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249936 */   // MIs[0] Operand 1
     /* 2249936 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249945 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249949 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2249949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2249952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249954 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249956 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2249964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249965 */   // GIR_Coverage, 48610,
     /* 2249965 */   GIR_EraseRootFromParent_Done,
     /* 2249966 */ // Label 30099: @2249966
     /* 2249966 */ GIM_Try, /*On fail goto*//*Label 30100*/ GIMT_Encode4(2250014), // Rule ID 48611 //
     /* 2249971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2249974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2249977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2249980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249984 */   // MIs[0] Operand 1
     /* 2249984 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249993 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249997 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2249997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250002 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250004 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250013 */   // GIR_Coverage, 48611,
     /* 2250013 */   GIR_EraseRootFromParent_Done,
     /* 2250014 */ // Label 30100: @2250014
     /* 2250014 */ GIM_Try, /*On fail goto*//*Label 30101*/ GIMT_Encode4(2250062), // Rule ID 48616 //
     /* 2250019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250032 */   // MIs[0] Operand 1
     /* 2250032 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250041 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250045 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250050 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250052 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250061 */   // GIR_Coverage, 48616,
     /* 2250061 */   GIR_EraseRootFromParent_Done,
     /* 2250062 */ // Label 30101: @2250062
     /* 2250062 */ GIM_Try, /*On fail goto*//*Label 30102*/ GIMT_Encode4(2250110), // Rule ID 48617 //
     /* 2250067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250073 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250080 */   // MIs[0] Operand 1
     /* 2250080 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250089 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250093 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2250096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250098 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250100 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250109 */   // GIR_Coverage, 48617,
     /* 2250109 */   GIR_EraseRootFromParent_Done,
     /* 2250110 */ // Label 30102: @2250110
     /* 2250110 */ GIM_Try, /*On fail goto*//*Label 30103*/ GIMT_Encode4(2250158), // Rule ID 48622 //
     /* 2250115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250128 */   // MIs[0] Operand 1
     /* 2250128 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250137 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250141 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250146 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250148 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250157 */   // GIR_Coverage, 48622,
     /* 2250157 */   GIR_EraseRootFromParent_Done,
     /* 2250158 */ // Label 30103: @2250158
     /* 2250158 */ GIM_Try, /*On fail goto*//*Label 30104*/ GIMT_Encode4(2250206), // Rule ID 48623 //
     /* 2250163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250176 */   // MIs[0] Operand 1
     /* 2250176 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250185 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250189 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2250192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250194 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250196 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250205 */   // GIR_Coverage, 48623,
     /* 2250205 */   GIR_EraseRootFromParent_Done,
     /* 2250206 */ // Label 30104: @2250206
     /* 2250206 */ GIM_Try, /*On fail goto*//*Label 30105*/ GIMT_Encode4(2250254), // Rule ID 48630 //
     /* 2250211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250224 */   // MIs[0] Operand 1
     /* 2250224 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250233 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250237 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250242 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250244 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250253 */   // GIR_Coverage, 48630,
     /* 2250253 */   GIR_EraseRootFromParent_Done,
     /* 2250254 */ // Label 30105: @2250254
     /* 2250254 */ GIM_Try, /*On fail goto*//*Label 30106*/ GIMT_Encode4(2250302), // Rule ID 48631 //
     /* 2250259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250265 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250272 */   // MIs[0] Operand 1
     /* 2250272 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250281 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250285 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2250288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250290 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250292 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250301 */   // GIR_Coverage, 48631,
     /* 2250301 */   GIR_EraseRootFromParent_Done,
     /* 2250302 */ // Label 30106: @2250302
     /* 2250302 */ GIM_Try, /*On fail goto*//*Label 30107*/ GIMT_Encode4(2250350), // Rule ID 48652 //
     /* 2250307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250313 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250320 */   // MIs[0] Operand 1
     /* 2250320 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250329 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250333 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250338 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250340 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250349 */   // GIR_Coverage, 48652,
     /* 2250349 */   GIR_EraseRootFromParent_Done,
     /* 2250350 */ // Label 30107: @2250350
     /* 2250350 */ GIM_Try, /*On fail goto*//*Label 30108*/ GIMT_Encode4(2250398), // Rule ID 48653 //
     /* 2250355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250361 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250368 */   // MIs[0] Operand 1
     /* 2250368 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250377 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250381 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2250384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250386 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250388 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250397 */   // GIR_Coverage, 48653,
     /* 2250397 */   GIR_EraseRootFromParent_Done,
     /* 2250398 */ // Label 30108: @2250398
     /* 2250398 */ GIM_Try, /*On fail goto*//*Label 30109*/ GIMT_Encode4(2250446), // Rule ID 48660 //
     /* 2250403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250416 */   // MIs[0] Operand 1
     /* 2250416 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250425 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250429 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250434 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250445 */   // GIR_Coverage, 48660,
     /* 2250445 */   GIR_EraseRootFromParent_Done,
     /* 2250446 */ // Label 30109: @2250446
     /* 2250446 */ GIM_Try, /*On fail goto*//*Label 30110*/ GIMT_Encode4(2250494), // Rule ID 48661 //
     /* 2250451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250464 */   // MIs[0] Operand 1
     /* 2250464 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250473 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250477 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250482 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250493 */   // GIR_Coverage, 48661,
     /* 2250493 */   GIR_EraseRootFromParent_Done,
     /* 2250494 */ // Label 30110: @2250494
     /* 2250494 */ GIM_Try, /*On fail goto*//*Label 30111*/ GIMT_Encode4(2250542), // Rule ID 48666 //
     /* 2250499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250512 */   // MIs[0] Operand 1
     /* 2250512 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250521 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250525 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2250528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250530 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250532 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250541 */   // GIR_Coverage, 48666,
     /* 2250541 */   GIR_EraseRootFromParent_Done,
     /* 2250542 */ // Label 30111: @2250542
     /* 2250542 */ GIM_Try, /*On fail goto*//*Label 30112*/ GIMT_Encode4(2250590), // Rule ID 48667 //
     /* 2250547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250560 */   // MIs[0] Operand 1
     /* 2250560 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250573 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2250576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250578 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250580 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250589 */   // GIR_Coverage, 48667,
     /* 2250589 */   GIR_EraseRootFromParent_Done,
     /* 2250590 */ // Label 30112: @2250590
     /* 2250590 */ GIM_Try, /*On fail goto*//*Label 30113*/ GIMT_Encode4(2250638), // Rule ID 48674 //
     /* 2250595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250608 */   // MIs[0] Operand 1
     /* 2250608 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250617 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250621 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2250621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2250624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250626 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250628 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250637 */   // GIR_Coverage, 48674,
     /* 2250637 */   GIR_EraseRootFromParent_Done,
     /* 2250638 */ // Label 30113: @2250638
     /* 2250638 */ GIM_Try, /*On fail goto*//*Label 30114*/ GIMT_Encode4(2250686), // Rule ID 48675 //
     /* 2250643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250649 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250656 */   // MIs[0] Operand 1
     /* 2250656 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250665 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250669 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2250669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2250672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250674 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250676 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2250684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250685 */   // GIR_Coverage, 48675,
     /* 2250685 */   GIR_EraseRootFromParent_Done,
     /* 2250686 */ // Label 30114: @2250686
     /* 2250686 */ GIM_Try, /*On fail goto*//*Label 30115*/ GIMT_Encode4(2250734), // Rule ID 48696 //
     /* 2250691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2250694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250697 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250704 */   // MIs[0] Operand 1
     /* 2250704 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250713 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250717 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2250717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2250720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250722 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250724 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250733 */   // GIR_Coverage, 48696,
     /* 2250733 */   GIR_EraseRootFromParent_Done,
     /* 2250734 */ // Label 30115: @2250734
     /* 2250734 */ GIM_Try, /*On fail goto*//*Label 30116*/ GIMT_Encode4(2250782), // Rule ID 48697 //
     /* 2250739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2250742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2250745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2250748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250752 */   // MIs[0] Operand 1
     /* 2250752 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250761 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2250765 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2250765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2250768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250770 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250772 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2250780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250781 */   // GIR_Coverage, 48697,
     /* 2250781 */   GIR_EraseRootFromParent_Done,
     /* 2250782 */ // Label 30116: @2250782
     /* 2250782 */ GIM_Try, /*On fail goto*//*Label 30117*/ GIMT_Encode4(2250830), // Rule ID 48704 //
     /* 2250787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250800 */   // MIs[0] Operand 1
     /* 2250800 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250809 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250813 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250818 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250820 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250829 */   // GIR_Coverage, 48704,
     /* 2250829 */   GIR_EraseRootFromParent_Done,
     /* 2250830 */ // Label 30117: @2250830
     /* 2250830 */ GIM_Try, /*On fail goto*//*Label 30118*/ GIMT_Encode4(2250878), // Rule ID 48705 //
     /* 2250835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2250841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2250844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250848 */   // MIs[0] Operand 1
     /* 2250848 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250857 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250861 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2250864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250866 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250868 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250877 */   // GIR_Coverage, 48705,
     /* 2250877 */   GIR_EraseRootFromParent_Done,
     /* 2250878 */ // Label 30118: @2250878
     /* 2250878 */ GIM_Try, /*On fail goto*//*Label 30119*/ GIMT_Encode4(2250926), // Rule ID 48710 //
     /* 2250883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250896 */   // MIs[0] Operand 1
     /* 2250896 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250905 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250909 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2250912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250914 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250916 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250925 */   // GIR_Coverage, 48710,
     /* 2250925 */   GIR_EraseRootFromParent_Done,
     /* 2250926 */ // Label 30119: @2250926
     /* 2250926 */ GIM_Try, /*On fail goto*//*Label 30120*/ GIMT_Encode4(2250974), // Rule ID 48711 //
     /* 2250931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2250937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2250940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250944 */   // MIs[0] Operand 1
     /* 2250944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250957 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2250960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250962 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250964 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250973 */   // GIR_Coverage, 48711,
     /* 2250973 */   GIR_EraseRootFromParent_Done,
     /* 2250974 */ // Label 30120: @2250974
     /* 2250974 */ GIM_Try, /*On fail goto*//*Label 30121*/ GIMT_Encode4(2251022), // Rule ID 48718 //
     /* 2250979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2250985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2250988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250992 */   // MIs[0] Operand 1
     /* 2250992 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251005 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251010 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251012 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251021 */   // GIR_Coverage, 48718,
     /* 2251021 */   GIR_EraseRootFromParent_Done,
     /* 2251022 */ // Label 30121: @2251022
     /* 2251022 */ GIM_Try, /*On fail goto*//*Label 30122*/ GIMT_Encode4(2251070), // Rule ID 48719 //
     /* 2251027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251040 */   // MIs[0] Operand 1
     /* 2251040 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251049 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251053 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2251056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251058 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251060 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251069 */   // GIR_Coverage, 48719,
     /* 2251069 */   GIR_EraseRootFromParent_Done,
     /* 2251070 */ // Label 30122: @2251070
     /* 2251070 */ GIM_Try, /*On fail goto*//*Label 30123*/ GIMT_Encode4(2251118), // Rule ID 48740 //
     /* 2251075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251081 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251088 */   // MIs[0] Operand 1
     /* 2251088 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251097 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251101 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251106 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251108 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251117 */   // GIR_Coverage, 48740,
     /* 2251117 */   GIR_EraseRootFromParent_Done,
     /* 2251118 */ // Label 30123: @2251118
     /* 2251118 */ GIM_Try, /*On fail goto*//*Label 30124*/ GIMT_Encode4(2251166), // Rule ID 48741 //
     /* 2251123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251136 */   // MIs[0] Operand 1
     /* 2251136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251145 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251149 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2251152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251154 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251156 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251165 */   // GIR_Coverage, 48741,
     /* 2251165 */   GIR_EraseRootFromParent_Done,
     /* 2251166 */ // Label 30124: @2251166
     /* 2251166 */ GIM_Try, /*On fail goto*//*Label 30125*/ GIMT_Encode4(2251214), // Rule ID 48748 //
     /* 2251171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251184 */   // MIs[0] Operand 1
     /* 2251184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251197 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251202 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251213 */   // GIR_Coverage, 48748,
     /* 2251213 */   GIR_EraseRootFromParent_Done,
     /* 2251214 */ // Label 30125: @2251214
     /* 2251214 */ GIM_Try, /*On fail goto*//*Label 30126*/ GIMT_Encode4(2251262), // Rule ID 48749 //
     /* 2251219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251232 */   // MIs[0] Operand 1
     /* 2251232 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251241 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251245 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251250 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251252 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251261 */   // GIR_Coverage, 48749,
     /* 2251261 */   GIR_EraseRootFromParent_Done,
     /* 2251262 */ // Label 30126: @2251262
     /* 2251262 */ GIM_Try, /*On fail goto*//*Label 30127*/ GIMT_Encode4(2251310), // Rule ID 48754 //
     /* 2251267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251280 */   // MIs[0] Operand 1
     /* 2251280 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251289 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251293 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251298 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251300 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251309 */   // GIR_Coverage, 48754,
     /* 2251309 */   GIR_EraseRootFromParent_Done,
     /* 2251310 */ // Label 30127: @2251310
     /* 2251310 */ GIM_Try, /*On fail goto*//*Label 30128*/ GIMT_Encode4(2251358), // Rule ID 48755 //
     /* 2251315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251328 */   // MIs[0] Operand 1
     /* 2251328 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251337 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251341 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251346 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251348 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251357 */   // GIR_Coverage, 48755,
     /* 2251357 */   GIR_EraseRootFromParent_Done,
     /* 2251358 */ // Label 30128: @2251358
     /* 2251358 */ GIM_Try, /*On fail goto*//*Label 30129*/ GIMT_Encode4(2251406), // Rule ID 48762 //
     /* 2251363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251376 */   // MIs[0] Operand 1
     /* 2251376 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251389 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251394 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251396 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251405 */   // GIR_Coverage, 48762,
     /* 2251405 */   GIR_EraseRootFromParent_Done,
     /* 2251406 */ // Label 30129: @2251406
     /* 2251406 */ GIM_Try, /*On fail goto*//*Label 30130*/ GIMT_Encode4(2251454), // Rule ID 48763 //
     /* 2251411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251424 */   // MIs[0] Operand 1
     /* 2251424 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251433 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251437 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251442 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251444 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251453 */   // GIR_Coverage, 48763,
     /* 2251453 */   GIR_EraseRootFromParent_Done,
     /* 2251454 */ // Label 30130: @2251454
     /* 2251454 */ GIM_Try, /*On fail goto*//*Label 30131*/ GIMT_Encode4(2251502), // Rule ID 48784 //
     /* 2251459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251472 */   // MIs[0] Operand 1
     /* 2251472 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251481 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251485 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2251488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251490 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251492 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251500 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251501 */   // GIR_Coverage, 48784,
     /* 2251501 */   GIR_EraseRootFromParent_Done,
     /* 2251502 */ // Label 30131: @2251502
     /* 2251502 */ GIM_Try, /*On fail goto*//*Label 30132*/ GIMT_Encode4(2251550), // Rule ID 48785 //
     /* 2251507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251520 */   // MIs[0] Operand 1
     /* 2251520 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251529 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251533 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2251536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251538 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251540 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251549 */   // GIR_Coverage, 48785,
     /* 2251549 */   GIR_EraseRootFromParent_Done,
     /* 2251550 */ // Label 30132: @2251550
     /* 2251550 */ GIM_Try, /*On fail goto*//*Label 30133*/ GIMT_Encode4(2251598), // Rule ID 48792 //
     /* 2251555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251568 */   // MIs[0] Operand 1
     /* 2251568 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251577 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251581 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251586 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251597 */   // GIR_Coverage, 48792,
     /* 2251597 */   GIR_EraseRootFromParent_Done,
     /* 2251598 */ // Label 30133: @2251598
     /* 2251598 */ GIM_Try, /*On fail goto*//*Label 30134*/ GIMT_Encode4(2251646), // Rule ID 48793 //
     /* 2251603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251616 */   // MIs[0] Operand 1
     /* 2251616 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251625 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251629 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2251632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251634 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251645 */   // GIR_Coverage, 48793,
     /* 2251645 */   GIR_EraseRootFromParent_Done,
     /* 2251646 */ // Label 30134: @2251646
     /* 2251646 */ GIM_Try, /*On fail goto*//*Label 30135*/ GIMT_Encode4(2251694), // Rule ID 48798 //
     /* 2251651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251664 */   // MIs[0] Operand 1
     /* 2251664 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251673 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251677 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251682 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251684 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251693 */   // GIR_Coverage, 48798,
     /* 2251693 */   GIR_EraseRootFromParent_Done,
     /* 2251694 */ // Label 30135: @2251694
     /* 2251694 */ GIM_Try, /*On fail goto*//*Label 30136*/ GIMT_Encode4(2251742), // Rule ID 48799 //
     /* 2251699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2251705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2251708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251712 */   // MIs[0] Operand 1
     /* 2251712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251725 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2251728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251730 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251732 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251741 */   // GIR_Coverage, 48799,
     /* 2251741 */   GIR_EraseRootFromParent_Done,
     /* 2251742 */ // Label 30136: @2251742
     /* 2251742 */ GIM_Try, /*On fail goto*//*Label 30137*/ GIMT_Encode4(2251790), // Rule ID 48806 //
     /* 2251747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251760 */   // MIs[0] Operand 1
     /* 2251760 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251769 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251773 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2251773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251778 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251780 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251789 */   // GIR_Coverage, 48806,
     /* 2251789 */   GIR_EraseRootFromParent_Done,
     /* 2251790 */ // Label 30137: @2251790
     /* 2251790 */ GIM_Try, /*On fail goto*//*Label 30138*/ GIMT_Encode4(2251838), // Rule ID 48807 //
     /* 2251795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2251801 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2251804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251808 */   // MIs[0] Operand 1
     /* 2251808 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251821 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2251821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2251824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251826 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251828 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2251836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251837 */   // GIR_Coverage, 48807,
     /* 2251837 */   GIR_EraseRootFromParent_Done,
     /* 2251838 */ // Label 30138: @2251838
     /* 2251838 */ GIM_Try, /*On fail goto*//*Label 30139*/ GIMT_Encode4(2251886), // Rule ID 48828 //
     /* 2251843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2251846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251856 */   // MIs[0] Operand 1
     /* 2251856 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251869 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2251869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2251872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251874 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251876 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251885 */   // GIR_Coverage, 48828,
     /* 2251885 */   GIR_EraseRootFromParent_Done,
     /* 2251886 */ // Label 30139: @2251886
     /* 2251886 */ GIM_Try, /*On fail goto*//*Label 30140*/ GIMT_Encode4(2251934), // Rule ID 48829 //
     /* 2251891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2251894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2251897 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2251900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251904 */   // MIs[0] Operand 1
     /* 2251904 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251913 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2251917 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2251917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2251920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251922 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251924 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2251932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251933 */   // GIR_Coverage, 48829,
     /* 2251933 */   GIR_EraseRootFromParent_Done,
     /* 2251934 */ // Label 30140: @2251934
     /* 2251934 */ GIM_Try, /*On fail goto*//*Label 30141*/ GIMT_Encode4(2251982), // Rule ID 48836 //
     /* 2251939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251952 */   // MIs[0] Operand 1
     /* 2251952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2251957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251965 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2251968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251970 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251972 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251981 */   // GIR_Coverage, 48836,
     /* 2251981 */   GIR_EraseRootFromParent_Done,
     /* 2251982 */ // Label 30141: @2251982
     /* 2251982 */ GIM_Try, /*On fail goto*//*Label 30142*/ GIMT_Encode4(2252030), // Rule ID 48837 //
     /* 2251987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2251993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2251996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252000 */   // MIs[0] Operand 1
     /* 2252000 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252009 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252013 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252018 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252020 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252029 */   // GIR_Coverage, 48837,
     /* 2252029 */   GIR_EraseRootFromParent_Done,
     /* 2252030 */ // Label 30142: @2252030
     /* 2252030 */ GIM_Try, /*On fail goto*//*Label 30143*/ GIMT_Encode4(2252078), // Rule ID 48842 //
     /* 2252035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252048 */   // MIs[0] Operand 1
     /* 2252048 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252057 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252061 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252066 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252077 */   // GIR_Coverage, 48842,
     /* 2252077 */   GIR_EraseRootFromParent_Done,
     /* 2252078 */ // Label 30143: @2252078
     /* 2252078 */ GIM_Try, /*On fail goto*//*Label 30144*/ GIMT_Encode4(2252126), // Rule ID 48843 //
     /* 2252083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252089 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252096 */   // MIs[0] Operand 1
     /* 2252096 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252105 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252109 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252114 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252116 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252124 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252125 */   // GIR_Coverage, 48843,
     /* 2252125 */   GIR_EraseRootFromParent_Done,
     /* 2252126 */ // Label 30144: @2252126
     /* 2252126 */ GIM_Try, /*On fail goto*//*Label 30145*/ GIMT_Encode4(2252174), // Rule ID 48850 //
     /* 2252131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252144 */   // MIs[0] Operand 1
     /* 2252144 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252153 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252157 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252162 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252164 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252173 */   // GIR_Coverage, 48850,
     /* 2252173 */   GIR_EraseRootFromParent_Done,
     /* 2252174 */ // Label 30145: @2252174
     /* 2252174 */ GIM_Try, /*On fail goto*//*Label 30146*/ GIMT_Encode4(2252222), // Rule ID 48851 //
     /* 2252179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252192 */   // MIs[0] Operand 1
     /* 2252192 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252205 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252212 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252221 */   // GIR_Coverage, 48851,
     /* 2252221 */   GIR_EraseRootFromParent_Done,
     /* 2252222 */ // Label 30146: @2252222
     /* 2252222 */ GIM_Try, /*On fail goto*//*Label 30147*/ GIMT_Encode4(2252270), // Rule ID 48872 //
     /* 2252227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252240 */   // MIs[0] Operand 1
     /* 2252240 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252249 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252253 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2252256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252258 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252260 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252269 */   // GIR_Coverage, 48872,
     /* 2252269 */   GIR_EraseRootFromParent_Done,
     /* 2252270 */ // Label 30147: @2252270
     /* 2252270 */ GIM_Try, /*On fail goto*//*Label 30148*/ GIMT_Encode4(2252318), // Rule ID 48873 //
     /* 2252275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252281 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252288 */   // MIs[0] Operand 1
     /* 2252288 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2252293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252297 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252301 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2252304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252308 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252317 */   // GIR_Coverage, 48873,
     /* 2252317 */   GIR_EraseRootFromParent_Done,
     /* 2252318 */ // Label 30148: @2252318
     /* 2252318 */ GIM_Try, /*On fail goto*//*Label 30149*/ GIMT_Encode4(2252366), // Rule ID 48880 //
     /* 2252323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252329 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252336 */   // MIs[0] Operand 1
     /* 2252336 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252345 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252349 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252354 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252356 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252365 */   // GIR_Coverage, 48880,
     /* 2252365 */   GIR_EraseRootFromParent_Done,
     /* 2252366 */ // Label 30149: @2252366
     /* 2252366 */ GIM_Try, /*On fail goto*//*Label 30150*/ GIMT_Encode4(2252414), // Rule ID 48881 //
     /* 2252371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2252377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2252380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252384 */   // MIs[0] Operand 1
     /* 2252384 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252397 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2252400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252402 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252404 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252412 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252413 */   // GIR_Coverage, 48881,
     /* 2252413 */   GIR_EraseRootFromParent_Done,
     /* 2252414 */ // Label 30150: @2252414
     /* 2252414 */ GIM_Try, /*On fail goto*//*Label 30151*/ GIMT_Encode4(2252462), // Rule ID 48886 //
     /* 2252419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252425 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252432 */   // MIs[0] Operand 1
     /* 2252432 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252441 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252445 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252450 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252452 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252461 */   // GIR_Coverage, 48886,
     /* 2252461 */   GIR_EraseRootFromParent_Done,
     /* 2252462 */ // Label 30151: @2252462
     /* 2252462 */ GIM_Try, /*On fail goto*//*Label 30152*/ GIMT_Encode4(2252510), // Rule ID 48887 //
     /* 2252467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2252473 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2252476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252480 */   // MIs[0] Operand 1
     /* 2252480 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252489 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252493 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2252496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252498 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252500 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252508 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252509 */   // GIR_Coverage, 48887,
     /* 2252509 */   GIR_EraseRootFromParent_Done,
     /* 2252510 */ // Label 30152: @2252510
     /* 2252510 */ GIM_Try, /*On fail goto*//*Label 30153*/ GIMT_Encode4(2252558), // Rule ID 48894 //
     /* 2252515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252521 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252528 */   // MIs[0] Operand 1
     /* 2252528 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252537 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252541 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252546 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252548 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252557 */   // GIR_Coverage, 48894,
     /* 2252557 */   GIR_EraseRootFromParent_Done,
     /* 2252558 */ // Label 30153: @2252558
     /* 2252558 */ GIM_Try, /*On fail goto*//*Label 30154*/ GIMT_Encode4(2252606), // Rule ID 48895 //
     /* 2252563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2252569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2252572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252576 */   // MIs[0] Operand 1
     /* 2252576 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252585 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252589 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2252592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252594 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252596 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252605 */   // GIR_Coverage, 48895,
     /* 2252605 */   GIR_EraseRootFromParent_Done,
     /* 2252606 */ // Label 30154: @2252606
     /* 2252606 */ GIM_Try, /*On fail goto*//*Label 30155*/ GIMT_Encode4(2252654), // Rule ID 48916 //
     /* 2252611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252624 */   // MIs[0] Operand 1
     /* 2252624 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252633 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252637 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2252637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2252640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252642 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252644 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252652 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252653 */   // GIR_Coverage, 48916,
     /* 2252653 */   GIR_EraseRootFromParent_Done,
     /* 2252654 */ // Label 30155: @2252654
     /* 2252654 */ GIM_Try, /*On fail goto*//*Label 30156*/ GIMT_Encode4(2252702), // Rule ID 48917 //
     /* 2252659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2252662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2252665 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2252668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252672 */   // MIs[0] Operand 1
     /* 2252672 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2252677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252681 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252685 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2252685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2252688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252690 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2252692 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2252694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2252700 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252701 */   // GIR_Coverage, 48917,
     /* 2252701 */   GIR_EraseRootFromParent_Done,
     /* 2252702 */ // Label 30156: @2252702
     /* 2252702 */ GIM_Reject,
     /* 2252703 */ // Label 29897: @2252703
     /* 2252703 */ GIM_Try, /*On fail goto*//*Label 30157*/ GIMT_Encode4(2252751), // Rule ID 48488 //
     /* 2252708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2252714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2252717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252721 */   // MIs[0] Operand 1
     /* 2252721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252734 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2252734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2252737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252739 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252741 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252750 */   // GIR_Coverage, 48488,
     /* 2252750 */   GIR_EraseRootFromParent_Done,
     /* 2252751 */ // Label 30157: @2252751
     /* 2252751 */ GIM_Try, /*On fail goto*//*Label 30158*/ GIMT_Encode4(2252799), // Rule ID 48489 //
     /* 2252756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2252762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2252765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252769 */   // MIs[0] Operand 1
     /* 2252769 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252778 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252782 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2252782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2252785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252787 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252789 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252798 */   // GIR_Coverage, 48489,
     /* 2252798 */   GIR_EraseRootFromParent_Done,
     /* 2252799 */ // Label 30158: @2252799
     /* 2252799 */ GIM_Try, /*On fail goto*//*Label 30159*/ GIMT_Encode4(2252847), // Rule ID 48498 //
     /* 2252804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2252810 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2252813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252817 */   // MIs[0] Operand 1
     /* 2252817 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252826 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252830 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2252830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2252833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252835 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252837 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252846 */   // GIR_Coverage, 48498,
     /* 2252846 */   GIR_EraseRootFromParent_Done,
     /* 2252847 */ // Label 30159: @2252847
     /* 2252847 */ GIM_Try, /*On fail goto*//*Label 30160*/ GIMT_Encode4(2252895), // Rule ID 48499 //
     /* 2252852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2252858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2252861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252865 */   // MIs[0] Operand 1
     /* 2252865 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252874 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252878 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2252878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2252881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252883 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252885 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2252893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252894 */   // GIR_Coverage, 48499,
     /* 2252894 */   GIR_EraseRootFromParent_Done,
     /* 2252895 */ // Label 30160: @2252895
     /* 2252895 */ GIM_Try, /*On fail goto*//*Label 30161*/ GIMT_Encode4(2252943), // Rule ID 48516 //
     /* 2252900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2252903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2252906 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2252909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252913 */   // MIs[0] Operand 1
     /* 2252913 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252926 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2252926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2252929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252931 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252933 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252942 */   // GIR_Coverage, 48516,
     /* 2252942 */   GIR_EraseRootFromParent_Done,
     /* 2252943 */ // Label 30161: @2252943
     /* 2252943 */ GIM_Try, /*On fail goto*//*Label 30162*/ GIMT_Encode4(2252991), // Rule ID 48517 //
     /* 2252948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2252951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2252954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2252957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2252961 */   // MIs[0] Operand 1
     /* 2252961 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2252966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252970 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2252974 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2252974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2252977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252979 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252981 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2252986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2252989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252990 */   // GIR_Coverage, 48517,
     /* 2252990 */   GIR_EraseRootFromParent_Done,
     /* 2252991 */ // Label 30162: @2252991
     /* 2252991 */ GIM_Try, /*On fail goto*//*Label 30163*/ GIMT_Encode4(2253039), // Rule ID 48524 //
     /* 2252996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2252999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253002 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253009 */   // MIs[0] Operand 1
     /* 2253009 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253018 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253022 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253027 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253029 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253038 */   // GIR_Coverage, 48524,
     /* 2253038 */   GIR_EraseRootFromParent_Done,
     /* 2253039 */ // Label 30163: @2253039
     /* 2253039 */ GIM_Try, /*On fail goto*//*Label 30164*/ GIMT_Encode4(2253087), // Rule ID 48525 //
     /* 2253044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253057 */   // MIs[0] Operand 1
     /* 2253057 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2253062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253066 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253070 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2253073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253075 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253077 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253086 */   // GIR_Coverage, 48525,
     /* 2253086 */   GIR_EraseRootFromParent_Done,
     /* 2253087 */ // Label 30164: @2253087
     /* 2253087 */ GIM_Try, /*On fail goto*//*Label 30165*/ GIMT_Encode4(2253135), // Rule ID 48532 //
     /* 2253092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253105 */   // MIs[0] Operand 1
     /* 2253105 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253114 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253118 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2253121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253125 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253134 */   // GIR_Coverage, 48532,
     /* 2253134 */   GIR_EraseRootFromParent_Done,
     /* 2253135 */ // Label 30165: @2253135
     /* 2253135 */ GIM_Try, /*On fail goto*//*Label 30166*/ GIMT_Encode4(2253183), // Rule ID 48533 //
     /* 2253140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253153 */   // MIs[0] Operand 1
     /* 2253153 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253162 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253166 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2253169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253171 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253173 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253182 */   // GIR_Coverage, 48533,
     /* 2253182 */   GIR_EraseRootFromParent_Done,
     /* 2253183 */ // Label 30166: @2253183
     /* 2253183 */ GIM_Try, /*On fail goto*//*Label 30167*/ GIMT_Encode4(2253231), // Rule ID 48542 //
     /* 2253188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253201 */   // MIs[0] Operand 1
     /* 2253201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253214 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2253217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253219 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253221 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253230 */   // GIR_Coverage, 48542,
     /* 2253230 */   GIR_EraseRootFromParent_Done,
     /* 2253231 */ // Label 30167: @2253231
     /* 2253231 */ GIM_Try, /*On fail goto*//*Label 30168*/ GIMT_Encode4(2253279), // Rule ID 48543 //
     /* 2253236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253249 */   // MIs[0] Operand 1
     /* 2253249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253262 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2253265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253267 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253269 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253278 */   // GIR_Coverage, 48543,
     /* 2253278 */   GIR_EraseRootFromParent_Done,
     /* 2253279 */ // Label 30168: @2253279
     /* 2253279 */ GIM_Try, /*On fail goto*//*Label 30169*/ GIMT_Encode4(2253327), // Rule ID 48560 //
     /* 2253284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253297 */   // MIs[0] Operand 1
     /* 2253297 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253306 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253310 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2253313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253315 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253317 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253326 */   // GIR_Coverage, 48560,
     /* 2253326 */   GIR_EraseRootFromParent_Done,
     /* 2253327 */ // Label 30169: @2253327
     /* 2253327 */ GIM_Try, /*On fail goto*//*Label 30170*/ GIMT_Encode4(2253375), // Rule ID 48561 //
     /* 2253332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253345 */   // MIs[0] Operand 1
     /* 2253345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253358 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2253361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253363 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253365 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253374 */   // GIR_Coverage, 48561,
     /* 2253374 */   GIR_EraseRootFromParent_Done,
     /* 2253375 */ // Label 30170: @2253375
     /* 2253375 */ GIM_Try, /*On fail goto*//*Label 30171*/ GIMT_Encode4(2253423), // Rule ID 48568 //
     /* 2253380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253393 */   // MIs[0] Operand 1
     /* 2253393 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253402 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253406 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2253409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253411 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253413 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253422 */   // GIR_Coverage, 48568,
     /* 2253422 */   GIR_EraseRootFromParent_Done,
     /* 2253423 */ // Label 30171: @2253423
     /* 2253423 */ GIM_Try, /*On fail goto*//*Label 30172*/ GIMT_Encode4(2253471), // Rule ID 48569 //
     /* 2253428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253441 */   // MIs[0] Operand 1
     /* 2253441 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2253446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253450 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253454 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2253457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253459 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253461 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253470 */   // GIR_Coverage, 48569,
     /* 2253470 */   GIR_EraseRootFromParent_Done,
     /* 2253471 */ // Label 30172: @2253471
     /* 2253471 */ GIM_Try, /*On fail goto*//*Label 30173*/ GIMT_Encode4(2253519), // Rule ID 48576 //
     /* 2253476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253489 */   // MIs[0] Operand 1
     /* 2253489 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253502 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2253505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253507 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253509 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253518 */   // GIR_Coverage, 48576,
     /* 2253518 */   GIR_EraseRootFromParent_Done,
     /* 2253519 */ // Label 30173: @2253519
     /* 2253519 */ GIM_Try, /*On fail goto*//*Label 30174*/ GIMT_Encode4(2253567), // Rule ID 48577 //
     /* 2253524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253537 */   // MIs[0] Operand 1
     /* 2253537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253550 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2253553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253555 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253557 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253566 */   // GIR_Coverage, 48577,
     /* 2253566 */   GIR_EraseRootFromParent_Done,
     /* 2253567 */ // Label 30174: @2253567
     /* 2253567 */ GIM_Try, /*On fail goto*//*Label 30175*/ GIMT_Encode4(2253615), // Rule ID 48586 //
     /* 2253572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253585 */   // MIs[0] Operand 1
     /* 2253585 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253594 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253598 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2253601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253603 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253605 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253614 */   // GIR_Coverage, 48586,
     /* 2253614 */   GIR_EraseRootFromParent_Done,
     /* 2253615 */ // Label 30175: @2253615
     /* 2253615 */ GIM_Try, /*On fail goto*//*Label 30176*/ GIMT_Encode4(2253663), // Rule ID 48587 //
     /* 2253620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253633 */   // MIs[0] Operand 1
     /* 2253633 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253642 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253646 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2253649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253651 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253653 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253662 */   // GIR_Coverage, 48587,
     /* 2253662 */   GIR_EraseRootFromParent_Done,
     /* 2253663 */ // Label 30176: @2253663
     /* 2253663 */ GIM_Try, /*On fail goto*//*Label 30177*/ GIMT_Encode4(2253711), // Rule ID 48604 //
     /* 2253668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253674 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253681 */   // MIs[0] Operand 1
     /* 2253681 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253690 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253694 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2253697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253699 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253701 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253710 */   // GIR_Coverage, 48604,
     /* 2253710 */   GIR_EraseRootFromParent_Done,
     /* 2253711 */ // Label 30177: @2253711
     /* 2253711 */ GIM_Try, /*On fail goto*//*Label 30178*/ GIMT_Encode4(2253759), // Rule ID 48605 //
     /* 2253716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2253722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2253725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253729 */   // MIs[0] Operand 1
     /* 2253729 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253738 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2253742 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2253745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253747 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253749 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253757 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253758 */   // GIR_Coverage, 48605,
     /* 2253758 */   GIR_EraseRootFromParent_Done,
     /* 2253759 */ // Label 30178: @2253759
     /* 2253759 */ GIM_Try, /*On fail goto*//*Label 30179*/ GIMT_Encode4(2253807), // Rule ID 48612 //
     /* 2253764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2253767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253777 */   // MIs[0] Operand 1
     /* 2253777 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253786 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253790 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2253793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253795 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253797 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253806 */   // GIR_Coverage, 48612,
     /* 2253806 */   GIR_EraseRootFromParent_Done,
     /* 2253807 */ // Label 30179: @2253807
     /* 2253807 */ GIM_Try, /*On fail goto*//*Label 30180*/ GIMT_Encode4(2253855), // Rule ID 48613 //
     /* 2253812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2253815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2253818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2253821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253825 */   // MIs[0] Operand 1
     /* 2253825 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2253830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253834 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2253838 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2253838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2253841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253845 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2253853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253854 */   // GIR_Coverage, 48613,
     /* 2253854 */   GIR_EraseRootFromParent_Done,
     /* 2253855 */ // Label 30180: @2253855
     /* 2253855 */ GIM_Try, /*On fail goto*//*Label 30181*/ GIMT_Encode4(2253903), // Rule ID 48618 //
     /* 2253860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253873 */   // MIs[0] Operand 1
     /* 2253873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2253878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253882 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253886 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2253886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2253889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253891 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253893 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253902 */   // GIR_Coverage, 48618,
     /* 2253902 */   GIR_EraseRootFromParent_Done,
     /* 2253903 */ // Label 30181: @2253903
     /* 2253903 */ GIM_Try, /*On fail goto*//*Label 30182*/ GIMT_Encode4(2253951), // Rule ID 48619 //
     /* 2253908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2253911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2253914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2253917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253921 */   // MIs[0] Operand 1
     /* 2253921 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2253926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253930 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253934 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2253934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2253937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253939 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253941 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2253949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253950 */   // GIR_Coverage, 48619,
     /* 2253950 */   GIR_EraseRootFromParent_Done,
     /* 2253951 */ // Label 30182: @2253951
     /* 2253951 */ GIM_Try, /*On fail goto*//*Label 30183*/ GIMT_Encode4(2253999), // Rule ID 48628 //
     /* 2253956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2253959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2253962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2253965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253969 */   // MIs[0] Operand 1
     /* 2253969 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2253974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253978 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253982 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2253985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253987 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2253989 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2253991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253998 */   // GIR_Coverage, 48628,
     /* 2253998 */   GIR_EraseRootFromParent_Done,
     /* 2253999 */ // Label 30183: @2253999
     /* 2253999 */ GIM_Try, /*On fail goto*//*Label 30184*/ GIMT_Encode4(2254047), // Rule ID 48629 //
     /* 2254004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254017 */   // MIs[0] Operand 1
     /* 2254017 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254026 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254030 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2254033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254035 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254037 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254046 */   // GIR_Coverage, 48629,
     /* 2254046 */   GIR_EraseRootFromParent_Done,
     /* 2254047 */ // Label 30184: @2254047
     /* 2254047 */ GIM_Try, /*On fail goto*//*Label 30185*/ GIMT_Encode4(2254095), // Rule ID 48646 //
     /* 2254052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254058 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254065 */   // MIs[0] Operand 1
     /* 2254065 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254074 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254078 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254083 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254085 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254094 */   // GIR_Coverage, 48646,
     /* 2254094 */   GIR_EraseRootFromParent_Done,
     /* 2254095 */ // Label 30185: @2254095
     /* 2254095 */ GIM_Try, /*On fail goto*//*Label 30186*/ GIMT_Encode4(2254143), // Rule ID 48647 //
     /* 2254100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254113 */   // MIs[0] Operand 1
     /* 2254113 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254122 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254126 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2254129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254131 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254133 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254142 */   // GIR_Coverage, 48647,
     /* 2254142 */   GIR_EraseRootFromParent_Done,
     /* 2254143 */ // Label 30186: @2254143
     /* 2254143 */ GIM_Try, /*On fail goto*//*Label 30187*/ GIMT_Encode4(2254191), // Rule ID 48654 //
     /* 2254148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254161 */   // MIs[0] Operand 1
     /* 2254161 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254170 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254174 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254179 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254181 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254190 */   // GIR_Coverage, 48654,
     /* 2254190 */   GIR_EraseRootFromParent_Done,
     /* 2254191 */ // Label 30187: @2254191
     /* 2254191 */ GIM_Try, /*On fail goto*//*Label 30188*/ GIMT_Encode4(2254239), // Rule ID 48655 //
     /* 2254196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254209 */   // MIs[0] Operand 1
     /* 2254209 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2254214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254218 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254222 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2254225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254227 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254229 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254238 */   // GIR_Coverage, 48655,
     /* 2254238 */   GIR_EraseRootFromParent_Done,
     /* 2254239 */ // Label 30188: @2254239
     /* 2254239 */ GIM_Try, /*On fail goto*//*Label 30189*/ GIMT_Encode4(2254287), // Rule ID 48662 //
     /* 2254244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254257 */   // MIs[0] Operand 1
     /* 2254257 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254270 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254275 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254277 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254286 */   // GIR_Coverage, 48662,
     /* 2254286 */   GIR_EraseRootFromParent_Done,
     /* 2254287 */ // Label 30189: @2254287
     /* 2254287 */ GIM_Try, /*On fail goto*//*Label 30190*/ GIMT_Encode4(2254335), // Rule ID 48663 //
     /* 2254292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254305 */   // MIs[0] Operand 1
     /* 2254305 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254314 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254318 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254323 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254325 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254334 */   // GIR_Coverage, 48663,
     /* 2254334 */   GIR_EraseRootFromParent_Done,
     /* 2254335 */ // Label 30190: @2254335
     /* 2254335 */ GIM_Try, /*On fail goto*//*Label 30191*/ GIMT_Encode4(2254383), // Rule ID 48672 //
     /* 2254340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254353 */   // MIs[0] Operand 1
     /* 2254353 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254362 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254366 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254371 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254373 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254382 */   // GIR_Coverage, 48672,
     /* 2254382 */   GIR_EraseRootFromParent_Done,
     /* 2254383 */ // Label 30191: @2254383
     /* 2254383 */ GIM_Try, /*On fail goto*//*Label 30192*/ GIMT_Encode4(2254431), // Rule ID 48673 //
     /* 2254388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254401 */   // MIs[0] Operand 1
     /* 2254401 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254410 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254414 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254419 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254421 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254429 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254430 */   // GIR_Coverage, 48673,
     /* 2254430 */   GIR_EraseRootFromParent_Done,
     /* 2254431 */ // Label 30192: @2254431
     /* 2254431 */ GIM_Try, /*On fail goto*//*Label 30193*/ GIMT_Encode4(2254479), // Rule ID 48690 //
     /* 2254436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254449 */   // MIs[0] Operand 1
     /* 2254449 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254458 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254462 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254467 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254469 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254478 */   // GIR_Coverage, 48690,
     /* 2254478 */   GIR_EraseRootFromParent_Done,
     /* 2254479 */ // Label 30193: @2254479
     /* 2254479 */ GIM_Try, /*On fail goto*//*Label 30194*/ GIMT_Encode4(2254527), // Rule ID 48691 //
     /* 2254484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254497 */   // MIs[0] Operand 1
     /* 2254497 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254506 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254510 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254515 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254517 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254525 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254526 */   // GIR_Coverage, 48691,
     /* 2254526 */   GIR_EraseRootFromParent_Done,
     /* 2254527 */ // Label 30194: @2254527
     /* 2254527 */ GIM_Try, /*On fail goto*//*Label 30195*/ GIMT_Encode4(2254575), // Rule ID 48698 //
     /* 2254532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254545 */   // MIs[0] Operand 1
     /* 2254545 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254554 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254558 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2254561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254563 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254565 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254574 */   // GIR_Coverage, 48698,
     /* 2254574 */   GIR_EraseRootFromParent_Done,
     /* 2254575 */ // Label 30195: @2254575
     /* 2254575 */ GIM_Try, /*On fail goto*//*Label 30196*/ GIMT_Encode4(2254623), // Rule ID 48699 //
     /* 2254580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254586 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254593 */   // MIs[0] Operand 1
     /* 2254593 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2254598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254602 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254606 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2254609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254611 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254613 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254621 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254622 */   // GIR_Coverage, 48699,
     /* 2254622 */   GIR_EraseRootFromParent_Done,
     /* 2254623 */ // Label 30196: @2254623
     /* 2254623 */ GIM_Try, /*On fail goto*//*Label 30197*/ GIMT_Encode4(2254671), // Rule ID 48706 //
     /* 2254628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254634 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254641 */   // MIs[0] Operand 1
     /* 2254641 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254650 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254654 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2254654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254659 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254661 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254670 */   // GIR_Coverage, 48706,
     /* 2254670 */   GIR_EraseRootFromParent_Done,
     /* 2254671 */ // Label 30197: @2254671
     /* 2254671 */ GIM_Try, /*On fail goto*//*Label 30198*/ GIMT_Encode4(2254719), // Rule ID 48707 //
     /* 2254676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2254682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2254685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254689 */   // MIs[0] Operand 1
     /* 2254689 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254698 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254702 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2254702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2254705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254707 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254709 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2254717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254718 */   // GIR_Coverage, 48707,
     /* 2254718 */   GIR_EraseRootFromParent_Done,
     /* 2254719 */ // Label 30198: @2254719
     /* 2254719 */ GIM_Try, /*On fail goto*//*Label 30199*/ GIMT_Encode4(2254767), // Rule ID 48716 //
     /* 2254724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254737 */   // MIs[0] Operand 1
     /* 2254737 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254746 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254750 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254755 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254757 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254765 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254766 */   // GIR_Coverage, 48716,
     /* 2254766 */   GIR_EraseRootFromParent_Done,
     /* 2254767 */ // Label 30199: @2254767
     /* 2254767 */ GIM_Try, /*On fail goto*//*Label 30200*/ GIMT_Encode4(2254815), // Rule ID 48717 //
     /* 2254772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2254778 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2254781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254785 */   // MIs[0] Operand 1
     /* 2254785 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254794 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254798 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2254801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254803 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254805 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254814 */   // GIR_Coverage, 48717,
     /* 2254814 */   GIR_EraseRootFromParent_Done,
     /* 2254815 */ // Label 30200: @2254815
     /* 2254815 */ GIM_Try, /*On fail goto*//*Label 30201*/ GIMT_Encode4(2254863), // Rule ID 48734 //
     /* 2254820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2254823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254833 */   // MIs[0] Operand 1
     /* 2254833 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254842 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254846 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254851 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254853 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254862 */   // GIR_Coverage, 48734,
     /* 2254862 */   GIR_EraseRootFromParent_Done,
     /* 2254863 */ // Label 30201: @2254863
     /* 2254863 */ GIM_Try, /*On fail goto*//*Label 30202*/ GIMT_Encode4(2254911), // Rule ID 48735 //
     /* 2254868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2254871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2254874 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2254877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254881 */   // MIs[0] Operand 1
     /* 2254881 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254890 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2254894 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2254897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254899 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254901 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254909 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254910 */   // GIR_Coverage, 48735,
     /* 2254910 */   GIR_EraseRootFromParent_Done,
     /* 2254911 */ // Label 30202: @2254911
     /* 2254911 */ GIM_Try, /*On fail goto*//*Label 30203*/ GIMT_Encode4(2254959), // Rule ID 48742 //
     /* 2254916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2254919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254922 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254929 */   // MIs[0] Operand 1
     /* 2254929 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254934 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254938 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254942 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2254945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254947 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254949 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254957 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254958 */   // GIR_Coverage, 48742,
     /* 2254958 */   GIR_EraseRootFromParent_Done,
     /* 2254959 */ // Label 30203: @2254959
     /* 2254959 */ GIM_Try, /*On fail goto*//*Label 30204*/ GIMT_Encode4(2255007), // Rule ID 48743 //
     /* 2254964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2254967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2254970 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2254973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254977 */   // MIs[0] Operand 1
     /* 2254977 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2254982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254986 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2254990 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2254993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254995 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2254997 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2254999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255005 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255006 */   // GIR_Coverage, 48743,
     /* 2255006 */   GIR_EraseRootFromParent_Done,
     /* 2255007 */ // Label 30204: @2255007
     /* 2255007 */ GIM_Try, /*On fail goto*//*Label 30205*/ GIMT_Encode4(2255055), // Rule ID 48750 //
     /* 2255012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255025 */   // MIs[0] Operand 1
     /* 2255025 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255034 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255038 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255043 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255045 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255054 */   // GIR_Coverage, 48750,
     /* 2255054 */   GIR_EraseRootFromParent_Done,
     /* 2255055 */ // Label 30205: @2255055
     /* 2255055 */ GIM_Try, /*On fail goto*//*Label 30206*/ GIMT_Encode4(2255103), // Rule ID 48751 //
     /* 2255060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255066 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255073 */   // MIs[0] Operand 1
     /* 2255073 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255082 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255086 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255091 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255093 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255101 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255102 */   // GIR_Coverage, 48751,
     /* 2255102 */   GIR_EraseRootFromParent_Done,
     /* 2255103 */ // Label 30206: @2255103
     /* 2255103 */ GIM_Try, /*On fail goto*//*Label 30207*/ GIMT_Encode4(2255151), // Rule ID 48760 //
     /* 2255108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255114 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255121 */   // MIs[0] Operand 1
     /* 2255121 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255126 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255130 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255134 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255139 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255141 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255149 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255150 */   // GIR_Coverage, 48760,
     /* 2255150 */   GIR_EraseRootFromParent_Done,
     /* 2255151 */ // Label 30207: @2255151
     /* 2255151 */ GIM_Try, /*On fail goto*//*Label 30208*/ GIMT_Encode4(2255199), // Rule ID 48761 //
     /* 2255156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255162 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255169 */   // MIs[0] Operand 1
     /* 2255169 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255178 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255182 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255187 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255189 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255198 */   // GIR_Coverage, 48761,
     /* 2255198 */   GIR_EraseRootFromParent_Done,
     /* 2255199 */ // Label 30208: @2255199
     /* 2255199 */ GIM_Try, /*On fail goto*//*Label 30209*/ GIMT_Encode4(2255247), // Rule ID 48778 //
     /* 2255204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255210 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255217 */   // MIs[0] Operand 1
     /* 2255217 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255226 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255230 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255235 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255237 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255245 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255246 */   // GIR_Coverage, 48778,
     /* 2255246 */   GIR_EraseRootFromParent_Done,
     /* 2255247 */ // Label 30209: @2255247
     /* 2255247 */ GIM_Try, /*On fail goto*//*Label 30210*/ GIMT_Encode4(2255295), // Rule ID 48779 //
     /* 2255252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255258 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255265 */   // MIs[0] Operand 1
     /* 2255265 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255274 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255278 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255283 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255285 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255293 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255294 */   // GIR_Coverage, 48779,
     /* 2255294 */   GIR_EraseRootFromParent_Done,
     /* 2255295 */ // Label 30210: @2255295
     /* 2255295 */ GIM_Try, /*On fail goto*//*Label 30211*/ GIMT_Encode4(2255343), // Rule ID 48786 //
     /* 2255300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255306 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255313 */   // MIs[0] Operand 1
     /* 2255313 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255322 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255326 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2255329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255331 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255333 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255341 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255342 */   // GIR_Coverage, 48786,
     /* 2255342 */   GIR_EraseRootFromParent_Done,
     /* 2255343 */ // Label 30211: @2255343
     /* 2255343 */ GIM_Try, /*On fail goto*//*Label 30212*/ GIMT_Encode4(2255391), // Rule ID 48787 //
     /* 2255348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255354 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255361 */   // MIs[0] Operand 1
     /* 2255361 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2255366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255370 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255374 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2255377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255379 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255381 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255389 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255390 */   // GIR_Coverage, 48787,
     /* 2255390 */   GIR_EraseRootFromParent_Done,
     /* 2255391 */ // Label 30212: @2255391
     /* 2255391 */ GIM_Try, /*On fail goto*//*Label 30213*/ GIMT_Encode4(2255439), // Rule ID 48794 //
     /* 2255396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255402 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255409 */   // MIs[0] Operand 1
     /* 2255409 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255418 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255422 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255427 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255437 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255438 */   // GIR_Coverage, 48794,
     /* 2255438 */   GIR_EraseRootFromParent_Done,
     /* 2255439 */ // Label 30213: @2255439
     /* 2255439 */ GIM_Try, /*On fail goto*//*Label 30214*/ GIMT_Encode4(2255487), // Rule ID 48795 //
     /* 2255444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255450 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255457 */   // MIs[0] Operand 1
     /* 2255457 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255466 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255470 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2255473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255475 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255477 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255486 */   // GIR_Coverage, 48795,
     /* 2255486 */   GIR_EraseRootFromParent_Done,
     /* 2255487 */ // Label 30214: @2255487
     /* 2255487 */ GIM_Try, /*On fail goto*//*Label 30215*/ GIMT_Encode4(2255535), // Rule ID 48804 //
     /* 2255492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255498 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255505 */   // MIs[0] Operand 1
     /* 2255505 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255514 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255518 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255523 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255525 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255534 */   // GIR_Coverage, 48804,
     /* 2255534 */   GIR_EraseRootFromParent_Done,
     /* 2255535 */ // Label 30215: @2255535
     /* 2255535 */ GIM_Try, /*On fail goto*//*Label 30216*/ GIMT_Encode4(2255583), // Rule ID 48805 //
     /* 2255540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255553 */   // MIs[0] Operand 1
     /* 2255553 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255562 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255566 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2255569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255571 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255573 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255582 */   // GIR_Coverage, 48805,
     /* 2255582 */   GIR_EraseRootFromParent_Done,
     /* 2255583 */ // Label 30216: @2255583
     /* 2255583 */ GIM_Try, /*On fail goto*//*Label 30217*/ GIMT_Encode4(2255631), // Rule ID 48822 //
     /* 2255588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255594 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255601 */   // MIs[0] Operand 1
     /* 2255601 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255610 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255614 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255619 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255621 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255629 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255630 */   // GIR_Coverage, 48822,
     /* 2255630 */   GIR_EraseRootFromParent_Done,
     /* 2255631 */ // Label 30217: @2255631
     /* 2255631 */ GIM_Try, /*On fail goto*//*Label 30218*/ GIMT_Encode4(2255679), // Rule ID 48823 //
     /* 2255636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255642 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255649 */   // MIs[0] Operand 1
     /* 2255649 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255658 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255662 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2255665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255667 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255669 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255678 */   // GIR_Coverage, 48823,
     /* 2255678 */   GIR_EraseRootFromParent_Done,
     /* 2255679 */ // Label 30218: @2255679
     /* 2255679 */ GIM_Try, /*On fail goto*//*Label 30219*/ GIMT_Encode4(2255727), // Rule ID 48830 //
     /* 2255684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2255687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255690 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255697 */   // MIs[0] Operand 1
     /* 2255697 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255706 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255710 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2255713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255715 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255717 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255725 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255726 */   // GIR_Coverage, 48830,
     /* 2255726 */   GIR_EraseRootFromParent_Done,
     /* 2255727 */ // Label 30219: @2255727
     /* 2255727 */ GIM_Try, /*On fail goto*//*Label 30220*/ GIMT_Encode4(2255775), // Rule ID 48831 //
     /* 2255732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2255735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2255738 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2255741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255745 */   // MIs[0] Operand 1
     /* 2255745 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2255750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255754 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2255758 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2255761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255763 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2255765 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2255767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255770 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255773 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255774 */   // GIR_Coverage, 48831,
     /* 2255774 */   GIR_EraseRootFromParent_Done,
     /* 2255775 */ // Label 30220: @2255775
     /* 2255775 */ GIM_Try, /*On fail goto*//*Label 30221*/ GIMT_Encode4(2255823), // Rule ID 48838 //
     /* 2255780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255786 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255793 */   // MIs[0] Operand 1
     /* 2255793 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255802 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255806 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2255806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2255809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255811 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255813 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255822 */   // GIR_Coverage, 48838,
     /* 2255822 */   GIR_EraseRootFromParent_Done,
     /* 2255823 */ // Label 30221: @2255823
     /* 2255823 */ GIM_Try, /*On fail goto*//*Label 30222*/ GIMT_Encode4(2255871), // Rule ID 48839 //
     /* 2255828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2255834 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2255837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255841 */   // MIs[0] Operand 1
     /* 2255841 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255850 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255854 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2255854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2255857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255859 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255861 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2255869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255870 */   // GIR_Coverage, 48839,
     /* 2255870 */   GIR_EraseRootFromParent_Done,
     /* 2255871 */ // Label 30222: @2255871
     /* 2255871 */ GIM_Try, /*On fail goto*//*Label 30223*/ GIMT_Encode4(2255919), // Rule ID 48848 //
     /* 2255876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255882 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255889 */   // MIs[0] Operand 1
     /* 2255889 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255898 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255902 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2255905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255907 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255909 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255917 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255918 */   // GIR_Coverage, 48848,
     /* 2255918 */   GIR_EraseRootFromParent_Done,
     /* 2255919 */ // Label 30223: @2255919
     /* 2255919 */ GIM_Try, /*On fail goto*//*Label 30224*/ GIMT_Encode4(2255967), // Rule ID 48849 //
     /* 2255924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2255927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2255930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2255933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255937 */   // MIs[0] Operand 1
     /* 2255937 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255946 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255950 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2255953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255955 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255957 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255966 */   // GIR_Coverage, 48849,
     /* 2255966 */   GIR_EraseRootFromParent_Done,
     /* 2255967 */ // Label 30224: @2255967
     /* 2255967 */ GIM_Try, /*On fail goto*//*Label 30225*/ GIMT_Encode4(2256015), // Rule ID 48866 //
     /* 2255972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2255975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2255978 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2255981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255985 */   // MIs[0] Operand 1
     /* 2255985 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2255990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255994 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255998 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256003 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256005 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256013 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256014 */   // GIR_Coverage, 48866,
     /* 2256014 */   GIR_EraseRootFromParent_Done,
     /* 2256015 */ // Label 30225: @2256015
     /* 2256015 */ GIM_Try, /*On fail goto*//*Label 30226*/ GIMT_Encode4(2256063), // Rule ID 48867 //
     /* 2256020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256026 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256033 */   // MIs[0] Operand 1
     /* 2256033 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256042 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256046 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256051 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256053 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256062 */   // GIR_Coverage, 48867,
     /* 2256062 */   GIR_EraseRootFromParent_Done,
     /* 2256063 */ // Label 30226: @2256063
     /* 2256063 */ GIM_Try, /*On fail goto*//*Label 30227*/ GIMT_Encode4(2256111), // Rule ID 48874 //
     /* 2256068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256081 */   // MIs[0] Operand 1
     /* 2256081 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256090 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256094 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256099 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256101 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256110 */   // GIR_Coverage, 48874,
     /* 2256110 */   GIR_EraseRootFromParent_Done,
     /* 2256111 */ // Label 30227: @2256111
     /* 2256111 */ GIM_Try, /*On fail goto*//*Label 30228*/ GIMT_Encode4(2256159), // Rule ID 48875 //
     /* 2256116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256122 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256129 */   // MIs[0] Operand 1
     /* 2256129 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2256134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256138 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256142 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256147 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256149 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256158 */   // GIR_Coverage, 48875,
     /* 2256158 */   GIR_EraseRootFromParent_Done,
     /* 2256159 */ // Label 30228: @2256159
     /* 2256159 */ GIM_Try, /*On fail goto*//*Label 30229*/ GIMT_Encode4(2256207), // Rule ID 48882 //
     /* 2256164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256170 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256177 */   // MIs[0] Operand 1
     /* 2256177 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256186 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256190 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256195 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256197 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256205 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256206 */   // GIR_Coverage, 48882,
     /* 2256206 */   GIR_EraseRootFromParent_Done,
     /* 2256207 */ // Label 30229: @2256207
     /* 2256207 */ GIM_Try, /*On fail goto*//*Label 30230*/ GIMT_Encode4(2256255), // Rule ID 48883 //
     /* 2256212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2256218 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2256221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256225 */   // MIs[0] Operand 1
     /* 2256225 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256234 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256238 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2256241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256243 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256245 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256254 */   // GIR_Coverage, 48883,
     /* 2256254 */   GIR_EraseRootFromParent_Done,
     /* 2256255 */ // Label 30230: @2256255
     /* 2256255 */ GIM_Try, /*On fail goto*//*Label 30231*/ GIMT_Encode4(2256303), // Rule ID 48892 //
     /* 2256260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256266 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256273 */   // MIs[0] Operand 1
     /* 2256273 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256282 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256286 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256291 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256293 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256302 */   // GIR_Coverage, 48892,
     /* 2256302 */   GIR_EraseRootFromParent_Done,
     /* 2256303 */ // Label 30231: @2256303
     /* 2256303 */ GIM_Try, /*On fail goto*//*Label 30232*/ GIMT_Encode4(2256351), // Rule ID 48893 //
     /* 2256308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256321 */   // MIs[0] Operand 1
     /* 2256321 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256330 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256334 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2256337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256339 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256341 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256350 */   // GIR_Coverage, 48893,
     /* 2256350 */   GIR_EraseRootFromParent_Done,
     /* 2256351 */ // Label 30232: @2256351
     /* 2256351 */ GIM_Try, /*On fail goto*//*Label 30233*/ GIMT_Encode4(2256399), // Rule ID 48910 //
     /* 2256356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256369 */   // MIs[0] Operand 1
     /* 2256369 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256374 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256378 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256382 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256387 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256389 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256398 */   // GIR_Coverage, 48910,
     /* 2256398 */   GIR_EraseRootFromParent_Done,
     /* 2256399 */ // Label 30233: @2256399
     /* 2256399 */ GIM_Try, /*On fail goto*//*Label 30234*/ GIMT_Encode4(2256447), // Rule ID 48911 //
     /* 2256404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256417 */   // MIs[0] Operand 1
     /* 2256417 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256426 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256430 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2256433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256435 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256437 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256446 */   // GIR_Coverage, 48911,
     /* 2256446 */   GIR_EraseRootFromParent_Done,
     /* 2256447 */ // Label 30234: @2256447
     /* 2256447 */ GIM_Try, /*On fail goto*//*Label 30235*/ GIMT_Encode4(2256495), // Rule ID 48918 //
     /* 2256452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256465 */   // MIs[0] Operand 1
     /* 2256465 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256474 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256478 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256483 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256485 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256494 */   // GIR_Coverage, 48918,
     /* 2256494 */   GIR_EraseRootFromParent_Done,
     /* 2256495 */ // Label 30235: @2256495
     /* 2256495 */ GIM_Try, /*On fail goto*//*Label 30236*/ GIMT_Encode4(2256543), // Rule ID 48919 //
     /* 2256500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256506 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256513 */   // MIs[0] Operand 1
     /* 2256513 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2256518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256522 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256526 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2256529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2256533 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2256535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256542 */   // GIR_Coverage, 48919,
     /* 2256542 */   GIR_EraseRootFromParent_Done,
     /* 2256543 */ // Label 30236: @2256543
     /* 2256543 */ GIM_Reject,
     /* 2256544 */ // Label 29898: @2256544
     /* 2256544 */ GIM_Try, /*On fail goto*//*Label 30237*/ GIMT_Encode4(2256592), // Rule ID 48496 //
     /* 2256549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2256555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2256558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256562 */   // MIs[0] Operand 1
     /* 2256562 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256571 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256575 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2256578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256580 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256582 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256591 */   // GIR_Coverage, 48496,
     /* 2256591 */   GIR_EraseRootFromParent_Done,
     /* 2256592 */ // Label 30237: @2256592
     /* 2256592 */ GIM_Try, /*On fail goto*//*Label 30238*/ GIMT_Encode4(2256640), // Rule ID 48497 //
     /* 2256597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2256603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2256606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256610 */   // MIs[0] Operand 1
     /* 2256610 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256619 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256623 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2256623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2256626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256628 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256630 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256638 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256639 */   // GIR_Coverage, 48497,
     /* 2256639 */   GIR_EraseRootFromParent_Done,
     /* 2256640 */ // Label 30238: @2256640
     /* 2256640 */ GIM_Try, /*On fail goto*//*Label 30239*/ GIMT_Encode4(2256688), // Rule ID 48510 //
     /* 2256645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2256651 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2256654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256658 */   // MIs[0] Operand 1
     /* 2256658 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256667 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256671 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2256674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256676 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256678 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256687 */   // GIR_Coverage, 48510,
     /* 2256687 */   GIR_EraseRootFromParent_Done,
     /* 2256688 */ // Label 30239: @2256688
     /* 2256688 */ GIM_Try, /*On fail goto*//*Label 30240*/ GIMT_Encode4(2256736), // Rule ID 48511 //
     /* 2256693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2256699 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2256702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256706 */   // MIs[0] Operand 1
     /* 2256706 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256715 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256719 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2256722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256724 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256726 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256735 */   // GIR_Coverage, 48511,
     /* 2256735 */   GIR_EraseRootFromParent_Done,
     /* 2256736 */ // Label 30240: @2256736
     /* 2256736 */ GIM_Try, /*On fail goto*//*Label 30241*/ GIMT_Encode4(2256784), // Rule ID 48518 //
     /* 2256741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2256747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2256750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256754 */   // MIs[0] Operand 1
     /* 2256754 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256763 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256767 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2256770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256772 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256774 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256782 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256783 */   // GIR_Coverage, 48518,
     /* 2256783 */   GIR_EraseRootFromParent_Done,
     /* 2256784 */ // Label 30241: @2256784
     /* 2256784 */ GIM_Try, /*On fail goto*//*Label 30242*/ GIMT_Encode4(2256832), // Rule ID 48519 //
     /* 2256789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2256795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2256798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256802 */   // MIs[0] Operand 1
     /* 2256802 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256811 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256815 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2256818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256820 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256822 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256831 */   // GIR_Coverage, 48519,
     /* 2256831 */   GIR_EraseRootFromParent_Done,
     /* 2256832 */ // Label 30242: @2256832
     /* 2256832 */ GIM_Try, /*On fail goto*//*Label 30243*/ GIMT_Encode4(2256880), // Rule ID 48526 //
     /* 2256837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2256840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2256843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2256846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256850 */   // MIs[0] Operand 1
     /* 2256850 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256859 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256863 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2256866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256868 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256870 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256879 */   // GIR_Coverage, 48526,
     /* 2256879 */   GIR_EraseRootFromParent_Done,
     /* 2256880 */ // Label 30243: @2256880
     /* 2256880 */ GIM_Try, /*On fail goto*//*Label 30244*/ GIMT_Encode4(2256928), // Rule ID 48527 //
     /* 2256885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2256888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2256891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2256894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256898 */   // MIs[0] Operand 1
     /* 2256898 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2256903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256907 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2256911 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2256914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256916 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256918 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256927 */   // GIR_Coverage, 48527,
     /* 2256927 */   GIR_EraseRootFromParent_Done,
     /* 2256928 */ // Label 30244: @2256928
     /* 2256928 */ GIM_Try, /*On fail goto*//*Label 30245*/ GIMT_Encode4(2256976), // Rule ID 48540 //
     /* 2256933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2256936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2256939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2256942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256946 */   // MIs[0] Operand 1
     /* 2256946 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2256951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256955 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256959 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2256959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2256962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256964 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256966 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2256974 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256975 */   // GIR_Coverage, 48540,
     /* 2256975 */   GIR_EraseRootFromParent_Done,
     /* 2256976 */ // Label 30245: @2256976
     /* 2256976 */ GIM_Try, /*On fail goto*//*Label 30246*/ GIMT_Encode4(2257024), // Rule ID 48541 //
     /* 2256981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2256984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2256987 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2256990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256994 */   // MIs[0] Operand 1
     /* 2256994 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2256999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257003 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257007 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2257010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257012 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257014 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257022 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257023 */   // GIR_Coverage, 48541,
     /* 2257023 */   GIR_EraseRootFromParent_Done,
     /* 2257024 */ // Label 30246: @2257024
     /* 2257024 */ GIM_Try, /*On fail goto*//*Label 30247*/ GIMT_Encode4(2257072), // Rule ID 48554 //
     /* 2257029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257035 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257042 */   // MIs[0] Operand 1
     /* 2257042 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257051 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257055 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257060 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257062 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257071 */   // GIR_Coverage, 48554,
     /* 2257071 */   GIR_EraseRootFromParent_Done,
     /* 2257072 */ // Label 30247: @2257072
     /* 2257072 */ GIM_Try, /*On fail goto*//*Label 30248*/ GIMT_Encode4(2257120), // Rule ID 48555 //
     /* 2257077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257083 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257090 */   // MIs[0] Operand 1
     /* 2257090 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257103 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2257106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257108 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257110 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257119 */   // GIR_Coverage, 48555,
     /* 2257119 */   GIR_EraseRootFromParent_Done,
     /* 2257120 */ // Label 30248: @2257120
     /* 2257120 */ GIM_Try, /*On fail goto*//*Label 30249*/ GIMT_Encode4(2257168), // Rule ID 48562 //
     /* 2257125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257138 */   // MIs[0] Operand 1
     /* 2257138 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257147 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257151 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2257154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257156 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257158 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257167 */   // GIR_Coverage, 48562,
     /* 2257167 */   GIR_EraseRootFromParent_Done,
     /* 2257168 */ // Label 30249: @2257168
     /* 2257168 */ GIM_Try, /*On fail goto*//*Label 30250*/ GIMT_Encode4(2257216), // Rule ID 48563 //
     /* 2257173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257186 */   // MIs[0] Operand 1
     /* 2257186 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257195 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257199 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2257202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257204 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257206 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257215 */   // GIR_Coverage, 48563,
     /* 2257215 */   GIR_EraseRootFromParent_Done,
     /* 2257216 */ // Label 30250: @2257216
     /* 2257216 */ GIM_Try, /*On fail goto*//*Label 30251*/ GIMT_Encode4(2257264), // Rule ID 48570 //
     /* 2257221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257234 */   // MIs[0] Operand 1
     /* 2257234 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257243 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257247 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2257250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257252 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257254 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257263 */   // GIR_Coverage, 48570,
     /* 2257263 */   GIR_EraseRootFromParent_Done,
     /* 2257264 */ // Label 30251: @2257264
     /* 2257264 */ GIM_Try, /*On fail goto*//*Label 30252*/ GIMT_Encode4(2257312), // Rule ID 48571 //
     /* 2257269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257275 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257282 */   // MIs[0] Operand 1
     /* 2257282 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2257287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257291 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257295 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2257298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257300 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257302 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257311 */   // GIR_Coverage, 48571,
     /* 2257311 */   GIR_EraseRootFromParent_Done,
     /* 2257312 */ // Label 30252: @2257312
     /* 2257312 */ GIM_Try, /*On fail goto*//*Label 30253*/ GIMT_Encode4(2257360), // Rule ID 48584 //
     /* 2257317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257330 */   // MIs[0] Operand 1
     /* 2257330 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257339 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257343 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257348 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257350 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257358 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257359 */   // GIR_Coverage, 48584,
     /* 2257359 */   GIR_EraseRootFromParent_Done,
     /* 2257360 */ // Label 30253: @2257360
     /* 2257360 */ GIM_Try, /*On fail goto*//*Label 30254*/ GIMT_Encode4(2257408), // Rule ID 48585 //
     /* 2257365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257378 */   // MIs[0] Operand 1
     /* 2257378 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257387 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257391 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257396 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257398 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257407 */   // GIR_Coverage, 48585,
     /* 2257407 */   GIR_EraseRootFromParent_Done,
     /* 2257408 */ // Label 30254: @2257408
     /* 2257408 */ GIM_Try, /*On fail goto*//*Label 30255*/ GIMT_Encode4(2257456), // Rule ID 48598 //
     /* 2257413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257426 */   // MIs[0] Operand 1
     /* 2257426 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257435 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257439 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257444 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257446 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257454 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257455 */   // GIR_Coverage, 48598,
     /* 2257455 */   GIR_EraseRootFromParent_Done,
     /* 2257456 */ // Label 30255: @2257456
     /* 2257456 */ GIM_Try, /*On fail goto*//*Label 30256*/ GIMT_Encode4(2257504), // Rule ID 48599 //
     /* 2257461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257467 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257474 */   // MIs[0] Operand 1
     /* 2257474 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257483 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257487 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257492 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257494 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257503 */   // GIR_Coverage, 48599,
     /* 2257503 */   GIR_EraseRootFromParent_Done,
     /* 2257504 */ // Label 30256: @2257504
     /* 2257504 */ GIM_Try, /*On fail goto*//*Label 30257*/ GIMT_Encode4(2257552), // Rule ID 48606 //
     /* 2257509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257522 */   // MIs[0] Operand 1
     /* 2257522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257531 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257535 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2257538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257542 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257551 */   // GIR_Coverage, 48606,
     /* 2257551 */   GIR_EraseRootFromParent_Done,
     /* 2257552 */ // Label 30257: @2257552
     /* 2257552 */ GIM_Try, /*On fail goto*//*Label 30258*/ GIMT_Encode4(2257600), // Rule ID 48607 //
     /* 2257557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257570 */   // MIs[0] Operand 1
     /* 2257570 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257583 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2257586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257590 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257599 */   // GIR_Coverage, 48607,
     /* 2257599 */   GIR_EraseRootFromParent_Done,
     /* 2257600 */ // Label 30258: @2257600
     /* 2257600 */ GIM_Try, /*On fail goto*//*Label 30259*/ GIMT_Encode4(2257648), // Rule ID 48614 //
     /* 2257605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257618 */   // MIs[0] Operand 1
     /* 2257618 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257627 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257631 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2257634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257638 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257647 */   // GIR_Coverage, 48614,
     /* 2257647 */   GIR_EraseRootFromParent_Done,
     /* 2257648 */ // Label 30259: @2257648
     /* 2257648 */ GIM_Try, /*On fail goto*//*Label 30260*/ GIMT_Encode4(2257696), // Rule ID 48615 //
     /* 2257653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2257656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257666 */   // MIs[0] Operand 1
     /* 2257666 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2257671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257675 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257679 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2257682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257684 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257686 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257695 */   // GIR_Coverage, 48615,
     /* 2257695 */   GIR_EraseRootFromParent_Done,
     /* 2257696 */ // Label 30260: @2257696
     /* 2257696 */ GIM_Try, /*On fail goto*//*Label 30261*/ GIMT_Encode4(2257744), // Rule ID 48626 //
     /* 2257701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257714 */   // MIs[0] Operand 1
     /* 2257714 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257723 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257727 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2257727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257732 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257734 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257742 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257743 */   // GIR_Coverage, 48626,
     /* 2257743 */   GIR_EraseRootFromParent_Done,
     /* 2257744 */ // Label 30261: @2257744
     /* 2257744 */ GIM_Try, /*On fail goto*//*Label 30262*/ GIMT_Encode4(2257792), // Rule ID 48627 //
     /* 2257749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2257755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2257758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257762 */   // MIs[0] Operand 1
     /* 2257762 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257771 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257775 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2257775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2257778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257780 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257782 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2257790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257791 */   // GIR_Coverage, 48627,
     /* 2257791 */   GIR_EraseRootFromParent_Done,
     /* 2257792 */ // Label 30262: @2257792
     /* 2257792 */ GIM_Try, /*On fail goto*//*Label 30263*/ GIMT_Encode4(2257840), // Rule ID 48640 //
     /* 2257797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257810 */   // MIs[0] Operand 1
     /* 2257810 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257819 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257823 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257828 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257830 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257839 */   // GIR_Coverage, 48640,
     /* 2257839 */   GIR_EraseRootFromParent_Done,
     /* 2257840 */ // Label 30263: @2257840
     /* 2257840 */ GIM_Try, /*On fail goto*//*Label 30264*/ GIMT_Encode4(2257888), // Rule ID 48641 //
     /* 2257845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257858 */   // MIs[0] Operand 1
     /* 2257858 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257867 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257871 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2257874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257876 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257878 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257887 */   // GIR_Coverage, 48641,
     /* 2257887 */   GIR_EraseRootFromParent_Done,
     /* 2257888 */ // Label 30264: @2257888
     /* 2257888 */ GIM_Try, /*On fail goto*//*Label 30265*/ GIMT_Encode4(2257936), // Rule ID 48648 //
     /* 2257893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2257896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257906 */   // MIs[0] Operand 1
     /* 2257906 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257915 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257919 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2257922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257924 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257926 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257935 */   // GIR_Coverage, 48648,
     /* 2257935 */   GIR_EraseRootFromParent_Done,
     /* 2257936 */ // Label 30265: @2257936
     /* 2257936 */ GIM_Try, /*On fail goto*//*Label 30266*/ GIMT_Encode4(2257984), // Rule ID 48649 //
     /* 2257941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2257944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257954 */   // MIs[0] Operand 1
     /* 2257954 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2257959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257963 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257967 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2257970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257972 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2257974 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2257976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257983 */   // GIR_Coverage, 48649,
     /* 2257983 */   GIR_EraseRootFromParent_Done,
     /* 2257984 */ // Label 30266: @2257984
     /* 2257984 */ GIM_Try, /*On fail goto*//*Label 30267*/ GIMT_Encode4(2258032), // Rule ID 48656 //
     /* 2257989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2257992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258002 */   // MIs[0] Operand 1
     /* 2258002 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258011 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258015 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258020 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258022 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258031 */   // GIR_Coverage, 48656,
     /* 2258031 */   GIR_EraseRootFromParent_Done,
     /* 2258032 */ // Label 30267: @2258032
     /* 2258032 */ GIM_Try, /*On fail goto*//*Label 30268*/ GIMT_Encode4(2258080), // Rule ID 48657 //
     /* 2258037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258043 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258050 */   // MIs[0] Operand 1
     /* 2258050 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2258055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258059 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258063 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2258066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258070 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258078 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258079 */   // GIR_Coverage, 48657,
     /* 2258079 */   GIR_EraseRootFromParent_Done,
     /* 2258080 */ // Label 30268: @2258080
     /* 2258080 */ GIM_Try, /*On fail goto*//*Label 30269*/ GIMT_Encode4(2258128), // Rule ID 48670 //
     /* 2258085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258098 */   // MIs[0] Operand 1
     /* 2258098 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258107 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258111 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258116 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258118 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258127 */   // GIR_Coverage, 48670,
     /* 2258127 */   GIR_EraseRootFromParent_Done,
     /* 2258128 */ // Label 30269: @2258128
     /* 2258128 */ GIM_Try, /*On fail goto*//*Label 30270*/ GIMT_Encode4(2258176), // Rule ID 48671 //
     /* 2258133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258139 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258146 */   // MIs[0] Operand 1
     /* 2258146 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258155 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258159 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258164 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258166 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258175 */   // GIR_Coverage, 48671,
     /* 2258175 */   GIR_EraseRootFromParent_Done,
     /* 2258176 */ // Label 30270: @2258176
     /* 2258176 */ GIM_Try, /*On fail goto*//*Label 30271*/ GIMT_Encode4(2258224), // Rule ID 48684 //
     /* 2258181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258194 */   // MIs[0] Operand 1
     /* 2258194 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258203 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258207 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258212 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258214 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258223 */   // GIR_Coverage, 48684,
     /* 2258223 */   GIR_EraseRootFromParent_Done,
     /* 2258224 */ // Label 30271: @2258224
     /* 2258224 */ GIM_Try, /*On fail goto*//*Label 30272*/ GIMT_Encode4(2258272), // Rule ID 48685 //
     /* 2258229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258242 */   // MIs[0] Operand 1
     /* 2258242 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258251 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258255 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258260 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258262 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258271 */   // GIR_Coverage, 48685,
     /* 2258271 */   GIR_EraseRootFromParent_Done,
     /* 2258272 */ // Label 30272: @2258272
     /* 2258272 */ GIM_Try, /*On fail goto*//*Label 30273*/ GIMT_Encode4(2258320), // Rule ID 48692 //
     /* 2258277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258283 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258290 */   // MIs[0] Operand 1
     /* 2258290 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258299 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258303 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258308 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258310 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258319 */   // GIR_Coverage, 48692,
     /* 2258319 */   GIR_EraseRootFromParent_Done,
     /* 2258320 */ // Label 30273: @2258320
     /* 2258320 */ GIM_Try, /*On fail goto*//*Label 30274*/ GIMT_Encode4(2258368), // Rule ID 48693 //
     /* 2258325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258338 */   // MIs[0] Operand 1
     /* 2258338 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258347 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258351 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258356 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258358 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258367 */   // GIR_Coverage, 48693,
     /* 2258367 */   GIR_EraseRootFromParent_Done,
     /* 2258368 */ // Label 30274: @2258368
     /* 2258368 */ GIM_Try, /*On fail goto*//*Label 30275*/ GIMT_Encode4(2258416), // Rule ID 48700 //
     /* 2258373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258379 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258386 */   // MIs[0] Operand 1
     /* 2258386 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258395 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258399 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2258402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258404 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258406 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258415 */   // GIR_Coverage, 48700,
     /* 2258415 */   GIR_EraseRootFromParent_Done,
     /* 2258416 */ // Label 30275: @2258416
     /* 2258416 */ GIM_Try, /*On fail goto*//*Label 30276*/ GIMT_Encode4(2258464), // Rule ID 48701 //
     /* 2258421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258434 */   // MIs[0] Operand 1
     /* 2258434 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2258439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258443 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258447 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2258450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258452 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258454 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258462 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258463 */   // GIR_Coverage, 48701,
     /* 2258463 */   GIR_EraseRootFromParent_Done,
     /* 2258464 */ // Label 30276: @2258464
     /* 2258464 */ GIM_Try, /*On fail goto*//*Label 30277*/ GIMT_Encode4(2258512), // Rule ID 48714 //
     /* 2258469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258475 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258482 */   // MIs[0] Operand 1
     /* 2258482 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258491 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258495 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258500 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258502 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258511 */   // GIR_Coverage, 48714,
     /* 2258511 */   GIR_EraseRootFromParent_Done,
     /* 2258512 */ // Label 30277: @2258512
     /* 2258512 */ GIM_Try, /*On fail goto*//*Label 30278*/ GIMT_Encode4(2258560), // Rule ID 48715 //
     /* 2258517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258523 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258530 */   // MIs[0] Operand 1
     /* 2258530 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258539 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258543 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2258546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258548 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258550 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258559 */   // GIR_Coverage, 48715,
     /* 2258559 */   GIR_EraseRootFromParent_Done,
     /* 2258560 */ // Label 30278: @2258560
     /* 2258560 */ GIM_Try, /*On fail goto*//*Label 30279*/ GIMT_Encode4(2258608), // Rule ID 48728 //
     /* 2258565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258578 */   // MIs[0] Operand 1
     /* 2258578 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258587 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258591 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258596 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258598 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258607 */   // GIR_Coverage, 48728,
     /* 2258607 */   GIR_EraseRootFromParent_Done,
     /* 2258608 */ // Label 30279: @2258608
     /* 2258608 */ GIM_Try, /*On fail goto*//*Label 30280*/ GIMT_Encode4(2258656), // Rule ID 48729 //
     /* 2258613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258619 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258626 */   // MIs[0] Operand 1
     /* 2258626 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258635 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258639 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2258642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258644 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258646 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258654 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258655 */   // GIR_Coverage, 48729,
     /* 2258655 */   GIR_EraseRootFromParent_Done,
     /* 2258656 */ // Label 30280: @2258656
     /* 2258656 */ GIM_Try, /*On fail goto*//*Label 30281*/ GIMT_Encode4(2258704), // Rule ID 48736 //
     /* 2258661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258667 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258674 */   // MIs[0] Operand 1
     /* 2258674 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258683 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258687 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258692 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258694 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258703 */   // GIR_Coverage, 48736,
     /* 2258703 */   GIR_EraseRootFromParent_Done,
     /* 2258704 */ // Label 30281: @2258704
     /* 2258704 */ GIM_Try, /*On fail goto*//*Label 30282*/ GIMT_Encode4(2258752), // Rule ID 48737 //
     /* 2258709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258715 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258722 */   // MIs[0] Operand 1
     /* 2258722 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258731 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258735 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2258738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258740 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258742 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258750 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258751 */   // GIR_Coverage, 48737,
     /* 2258751 */   GIR_EraseRootFromParent_Done,
     /* 2258752 */ // Label 30282: @2258752
     /* 2258752 */ GIM_Try, /*On fail goto*//*Label 30283*/ GIMT_Encode4(2258800), // Rule ID 48744 //
     /* 2258757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2258760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258770 */   // MIs[0] Operand 1
     /* 2258770 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258779 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258783 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2258786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258788 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258790 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258798 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258799 */   // GIR_Coverage, 48744,
     /* 2258799 */   GIR_EraseRootFromParent_Done,
     /* 2258800 */ // Label 30283: @2258800
     /* 2258800 */ GIM_Try, /*On fail goto*//*Label 30284*/ GIMT_Encode4(2258848), // Rule ID 48745 //
     /* 2258805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2258808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258811 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258818 */   // MIs[0] Operand 1
     /* 2258818 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2258823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258827 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258831 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2258834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258836 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2258838 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2258840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258847 */   // GIR_Coverage, 48745,
     /* 2258847 */   GIR_EraseRootFromParent_Done,
     /* 2258848 */ // Label 30284: @2258848
     /* 2258848 */ GIM_Try, /*On fail goto*//*Label 30285*/ GIMT_Encode4(2258896), // Rule ID 48758 //
     /* 2258853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258859 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258866 */   // MIs[0] Operand 1
     /* 2258866 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2258871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258875 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258879 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2258879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2258882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258884 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258886 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258894 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258895 */   // GIR_Coverage, 48758,
     /* 2258895 */   GIR_EraseRootFromParent_Done,
     /* 2258896 */ // Label 30285: @2258896
     /* 2258896 */ GIM_Try, /*On fail goto*//*Label 30286*/ GIMT_Encode4(2258944), // Rule ID 48759 //
     /* 2258901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2258904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2258907 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2258910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258914 */   // MIs[0] Operand 1
     /* 2258914 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2258919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258923 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258927 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2258927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2258930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258932 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258934 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2258942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258943 */   // GIR_Coverage, 48759,
     /* 2258943 */   GIR_EraseRootFromParent_Done,
     /* 2258944 */ // Label 30286: @2258944
     /* 2258944 */ GIM_Try, /*On fail goto*//*Label 30287*/ GIMT_Encode4(2258992), // Rule ID 48772 //
     /* 2258949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2258952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258955 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258962 */   // MIs[0] Operand 1
     /* 2258962 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2258967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258971 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258975 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2258978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258980 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258982 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258991 */   // GIR_Coverage, 48772,
     /* 2258991 */   GIR_EraseRootFromParent_Done,
     /* 2258992 */ // Label 30287: @2258992
     /* 2258992 */ GIM_Try, /*On fail goto*//*Label 30288*/ GIMT_Encode4(2259040), // Rule ID 48773 //
     /* 2258997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259010 */   // MIs[0] Operand 1
     /* 2259010 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259019 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259023 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259028 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259030 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259038 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259039 */   // GIR_Coverage, 48773,
     /* 2259039 */   GIR_EraseRootFromParent_Done,
     /* 2259040 */ // Label 30288: @2259040
     /* 2259040 */ GIM_Try, /*On fail goto*//*Label 30289*/ GIMT_Encode4(2259088), // Rule ID 48780 //
     /* 2259045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259051 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259058 */   // MIs[0] Operand 1
     /* 2259058 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259067 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259071 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259076 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259078 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259086 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259087 */   // GIR_Coverage, 48780,
     /* 2259087 */   GIR_EraseRootFromParent_Done,
     /* 2259088 */ // Label 30289: @2259088
     /* 2259088 */ GIM_Try, /*On fail goto*//*Label 30290*/ GIMT_Encode4(2259136), // Rule ID 48781 //
     /* 2259093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259099 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259106 */   // MIs[0] Operand 1
     /* 2259106 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259115 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259119 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259124 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259126 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259134 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259135 */   // GIR_Coverage, 48781,
     /* 2259135 */   GIR_EraseRootFromParent_Done,
     /* 2259136 */ // Label 30290: @2259136
     /* 2259136 */ GIM_Try, /*On fail goto*//*Label 30291*/ GIMT_Encode4(2259184), // Rule ID 48788 //
     /* 2259141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259154 */   // MIs[0] Operand 1
     /* 2259154 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259163 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259167 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2259170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259172 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259174 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259182 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259183 */   // GIR_Coverage, 48788,
     /* 2259183 */   GIR_EraseRootFromParent_Done,
     /* 2259184 */ // Label 30291: @2259184
     /* 2259184 */ GIM_Try, /*On fail goto*//*Label 30292*/ GIMT_Encode4(2259232), // Rule ID 48789 //
     /* 2259189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259195 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259202 */   // MIs[0] Operand 1
     /* 2259202 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2259207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259211 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259215 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2259218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259220 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259222 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259231 */   // GIR_Coverage, 48789,
     /* 2259231 */   GIR_EraseRootFromParent_Done,
     /* 2259232 */ // Label 30292: @2259232
     /* 2259232 */ GIM_Try, /*On fail goto*//*Label 30293*/ GIMT_Encode4(2259280), // Rule ID 48802 //
     /* 2259237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259243 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259250 */   // MIs[0] Operand 1
     /* 2259250 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259259 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259263 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259268 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259270 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259278 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259279 */   // GIR_Coverage, 48802,
     /* 2259279 */   GIR_EraseRootFromParent_Done,
     /* 2259280 */ // Label 30293: @2259280
     /* 2259280 */ GIM_Try, /*On fail goto*//*Label 30294*/ GIMT_Encode4(2259328), // Rule ID 48803 //
     /* 2259285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259291 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259298 */   // MIs[0] Operand 1
     /* 2259298 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259307 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259311 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2259314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259316 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259318 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259327 */   // GIR_Coverage, 48803,
     /* 2259327 */   GIR_EraseRootFromParent_Done,
     /* 2259328 */ // Label 30294: @2259328
     /* 2259328 */ GIM_Try, /*On fail goto*//*Label 30295*/ GIMT_Encode4(2259376), // Rule ID 48816 //
     /* 2259333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259339 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259346 */   // MIs[0] Operand 1
     /* 2259346 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259355 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259359 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259364 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259366 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259375 */   // GIR_Coverage, 48816,
     /* 2259375 */   GIR_EraseRootFromParent_Done,
     /* 2259376 */ // Label 30295: @2259376
     /* 2259376 */ GIM_Try, /*On fail goto*//*Label 30296*/ GIMT_Encode4(2259424), // Rule ID 48817 //
     /* 2259381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259387 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259394 */   // MIs[0] Operand 1
     /* 2259394 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259403 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259407 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2259410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259412 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259414 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259423 */   // GIR_Coverage, 48817,
     /* 2259423 */   GIR_EraseRootFromParent_Done,
     /* 2259424 */ // Label 30296: @2259424
     /* 2259424 */ GIM_Try, /*On fail goto*//*Label 30297*/ GIMT_Encode4(2259472), // Rule ID 48824 //
     /* 2259429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259442 */   // MIs[0] Operand 1
     /* 2259442 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259451 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259455 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259460 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259462 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259471 */   // GIR_Coverage, 48824,
     /* 2259471 */   GIR_EraseRootFromParent_Done,
     /* 2259472 */ // Label 30297: @2259472
     /* 2259472 */ GIM_Try, /*On fail goto*//*Label 30298*/ GIMT_Encode4(2259520), // Rule ID 48825 //
     /* 2259477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259490 */   // MIs[0] Operand 1
     /* 2259490 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259499 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259503 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2259506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259508 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259510 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259518 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259519 */   // GIR_Coverage, 48825,
     /* 2259519 */   GIR_EraseRootFromParent_Done,
     /* 2259520 */ // Label 30298: @2259520
     /* 2259520 */ GIM_Try, /*On fail goto*//*Label 30299*/ GIMT_Encode4(2259568), // Rule ID 48832 //
     /* 2259525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259538 */   // MIs[0] Operand 1
     /* 2259538 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259547 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259551 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2259554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259556 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259558 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259566 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259567 */   // GIR_Coverage, 48832,
     /* 2259567 */   GIR_EraseRootFromParent_Done,
     /* 2259568 */ // Label 30299: @2259568
     /* 2259568 */ GIM_Try, /*On fail goto*//*Label 30300*/ GIMT_Encode4(2259616), // Rule ID 48833 //
     /* 2259573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259579 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259586 */   // MIs[0] Operand 1
     /* 2259586 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2259591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259595 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259599 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2259602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259604 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2259606 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2259608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259614 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259615 */   // GIR_Coverage, 48833,
     /* 2259615 */   GIR_EraseRootFromParent_Done,
     /* 2259616 */ // Label 30300: @2259616
     /* 2259616 */ GIM_Try, /*On fail goto*//*Label 30301*/ GIMT_Encode4(2259664), // Rule ID 48846 //
     /* 2259621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259627 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259634 */   // MIs[0] Operand 1
     /* 2259634 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259643 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259647 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2259650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259652 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259654 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259662 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259663 */   // GIR_Coverage, 48846,
     /* 2259663 */   GIR_EraseRootFromParent_Done,
     /* 2259664 */ // Label 30301: @2259664
     /* 2259664 */ GIM_Try, /*On fail goto*//*Label 30302*/ GIMT_Encode4(2259712), // Rule ID 48847 //
     /* 2259669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2259675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2259678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259682 */   // MIs[0] Operand 1
     /* 2259682 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259691 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259695 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2259698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259700 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259702 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259711 */   // GIR_Coverage, 48847,
     /* 2259711 */   GIR_EraseRootFromParent_Done,
     /* 2259712 */ // Label 30302: @2259712
     /* 2259712 */ GIM_Try, /*On fail goto*//*Label 30303*/ GIMT_Encode4(2259760), // Rule ID 48860 //
     /* 2259717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259730 */   // MIs[0] Operand 1
     /* 2259730 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259739 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259743 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2259746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259748 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259750 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259759 */   // GIR_Coverage, 48860,
     /* 2259759 */   GIR_EraseRootFromParent_Done,
     /* 2259760 */ // Label 30303: @2259760
     /* 2259760 */ GIM_Try, /*On fail goto*//*Label 30304*/ GIMT_Encode4(2259808), // Rule ID 48861 //
     /* 2259765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2259771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2259774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259778 */   // MIs[0] Operand 1
     /* 2259778 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259787 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2259791 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2259794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259796 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259798 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259806 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259807 */   // GIR_Coverage, 48861,
     /* 2259807 */   GIR_EraseRootFromParent_Done,
     /* 2259808 */ // Label 30304: @2259808
     /* 2259808 */ GIM_Try, /*On fail goto*//*Label 30305*/ GIMT_Encode4(2259856), // Rule ID 48868 //
     /* 2259813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259826 */   // MIs[0] Operand 1
     /* 2259826 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259835 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259839 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2259842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259844 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259846 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259855 */   // GIR_Coverage, 48868,
     /* 2259855 */   GIR_EraseRootFromParent_Done,
     /* 2259856 */ // Label 30305: @2259856
     /* 2259856 */ GIM_Try, /*On fail goto*//*Label 30306*/ GIMT_Encode4(2259904), // Rule ID 48869 //
     /* 2259861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2259867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2259870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259874 */   // MIs[0] Operand 1
     /* 2259874 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259887 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2259890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259892 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259894 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259902 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259903 */   // GIR_Coverage, 48869,
     /* 2259903 */   GIR_EraseRootFromParent_Done,
     /* 2259904 */ // Label 30306: @2259904
     /* 2259904 */ GIM_Try, /*On fail goto*//*Label 30307*/ GIMT_Encode4(2259952), // Rule ID 48876 //
     /* 2259909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2259912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259915 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259922 */   // MIs[0] Operand 1
     /* 2259922 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259931 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259935 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2259935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2259938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259940 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259942 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259951 */   // GIR_Coverage, 48876,
     /* 2259951 */   GIR_EraseRootFromParent_Done,
     /* 2259952 */ // Label 30307: @2259952
     /* 2259952 */ GIM_Try, /*On fail goto*//*Label 30308*/ GIMT_Encode4(2260000), // Rule ID 48877 //
     /* 2259957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2259960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2259963 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2259966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259970 */   // MIs[0] Operand 1
     /* 2259970 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2259975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259979 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259983 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2259983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2259986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259988 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259990 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2259998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259999 */   // GIR_Coverage, 48877,
     /* 2259999 */   GIR_EraseRootFromParent_Done,
     /* 2260000 */ // Label 30308: @2260000
     /* 2260000 */ GIM_Try, /*On fail goto*//*Label 30309*/ GIMT_Encode4(2260048), // Rule ID 48890 //
     /* 2260005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260018 */   // MIs[0] Operand 1
     /* 2260018 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260027 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260031 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260036 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260038 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260047 */   // GIR_Coverage, 48890,
     /* 2260047 */   GIR_EraseRootFromParent_Done,
     /* 2260048 */ // Label 30309: @2260048
     /* 2260048 */ GIM_Try, /*On fail goto*//*Label 30310*/ GIMT_Encode4(2260096), // Rule ID 48891 //
     /* 2260053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2260059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2260062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260066 */   // MIs[0] Operand 1
     /* 2260066 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260075 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260079 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2260082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260084 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260086 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260094 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260095 */   // GIR_Coverage, 48891,
     /* 2260095 */   GIR_EraseRootFromParent_Done,
     /* 2260096 */ // Label 30310: @2260096
     /* 2260096 */ GIM_Try, /*On fail goto*//*Label 30311*/ GIMT_Encode4(2260144), // Rule ID 48904 //
     /* 2260101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260114 */   // MIs[0] Operand 1
     /* 2260114 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260123 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260127 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260132 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260134 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260143 */   // GIR_Coverage, 48904,
     /* 2260143 */   GIR_EraseRootFromParent_Done,
     /* 2260144 */ // Label 30311: @2260144
     /* 2260144 */ GIM_Try, /*On fail goto*//*Label 30312*/ GIMT_Encode4(2260192), // Rule ID 48905 //
     /* 2260149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2260155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2260158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260162 */   // MIs[0] Operand 1
     /* 2260162 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260167 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260171 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260175 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2260178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260180 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260182 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260190 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260191 */   // GIR_Coverage, 48905,
     /* 2260191 */   GIR_EraseRootFromParent_Done,
     /* 2260192 */ // Label 30312: @2260192
     /* 2260192 */ GIM_Try, /*On fail goto*//*Label 30313*/ GIMT_Encode4(2260240), // Rule ID 48912 //
     /* 2260197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260203 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260210 */   // MIs[0] Operand 1
     /* 2260210 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260215 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260219 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260223 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260228 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260230 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260235 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260238 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260239 */   // GIR_Coverage, 48912,
     /* 2260239 */   GIR_EraseRootFromParent_Done,
     /* 2260240 */ // Label 30313: @2260240
     /* 2260240 */ GIM_Try, /*On fail goto*//*Label 30314*/ GIMT_Encode4(2260288), // Rule ID 48913 //
     /* 2260245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2260251 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2260254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260258 */   // MIs[0] Operand 1
     /* 2260258 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260267 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260271 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2260274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260276 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260278 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260286 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260287 */   // GIR_Coverage, 48913,
     /* 2260287 */   GIR_EraseRootFromParent_Done,
     /* 2260288 */ // Label 30314: @2260288
     /* 2260288 */ GIM_Try, /*On fail goto*//*Label 30315*/ GIMT_Encode4(2260336), // Rule ID 48920 //
     /* 2260293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260299 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260306 */   // MIs[0] Operand 1
     /* 2260306 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260315 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260319 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260324 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260326 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260335 */   // GIR_Coverage, 48920,
     /* 2260335 */   GIR_EraseRootFromParent_Done,
     /* 2260336 */ // Label 30315: @2260336
     /* 2260336 */ GIM_Try, /*On fail goto*//*Label 30316*/ GIMT_Encode4(2260384), // Rule ID 48921 //
     /* 2260341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2260347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2260350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260354 */   // MIs[0] Operand 1
     /* 2260354 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2260359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260363 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260367 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2260370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260372 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2260374 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2260376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260383 */   // GIR_Coverage, 48921,
     /* 2260383 */   GIR_EraseRootFromParent_Done,
     /* 2260384 */ // Label 30316: @2260384
     /* 2260384 */ GIM_Reject,
     /* 2260385 */ // Label 29899: @2260385
     /* 2260385 */ GIM_Try, /*On fail goto*//*Label 30317*/ GIMT_Encode4(2260433), // Rule ID 48504 //
     /* 2260390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2260396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2260399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260403 */   // MIs[0] Operand 1
     /* 2260403 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260412 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260416 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2260419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260421 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260423 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260432 */   // GIR_Coverage, 48504,
     /* 2260432 */   GIR_EraseRootFromParent_Done,
     /* 2260433 */ // Label 30317: @2260433
     /* 2260433 */ GIM_Try, /*On fail goto*//*Label 30318*/ GIMT_Encode4(2260481), // Rule ID 48505 //
     /* 2260438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2260444 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2260447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260451 */   // MIs[0] Operand 1
     /* 2260451 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260460 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260464 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2260467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260469 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260471 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260480 */   // GIR_Coverage, 48505,
     /* 2260480 */   GIR_EraseRootFromParent_Done,
     /* 2260481 */ // Label 30318: @2260481
     /* 2260481 */ GIM_Try, /*On fail goto*//*Label 30319*/ GIMT_Encode4(2260529), // Rule ID 48512 //
     /* 2260486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2260492 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2260495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260499 */   // MIs[0] Operand 1
     /* 2260499 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260508 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260512 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2260515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260517 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260519 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260528 */   // GIR_Coverage, 48512,
     /* 2260528 */   GIR_EraseRootFromParent_Done,
     /* 2260529 */ // Label 30319: @2260529
     /* 2260529 */ GIM_Try, /*On fail goto*//*Label 30320*/ GIMT_Encode4(2260577), // Rule ID 48513 //
     /* 2260534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2260540 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2260543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260547 */   // MIs[0] Operand 1
     /* 2260547 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260556 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260560 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2260563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260565 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260567 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260575 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260576 */   // GIR_Coverage, 48513,
     /* 2260576 */   GIR_EraseRootFromParent_Done,
     /* 2260577 */ // Label 30320: @2260577
     /* 2260577 */ GIM_Try, /*On fail goto*//*Label 30321*/ GIMT_Encode4(2260625), // Rule ID 48520 //
     /* 2260582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2260588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2260591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260595 */   // MIs[0] Operand 1
     /* 2260595 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260604 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260608 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2260611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260613 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260615 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260623 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260624 */   // GIR_Coverage, 48520,
     /* 2260624 */   GIR_EraseRootFromParent_Done,
     /* 2260625 */ // Label 30321: @2260625
     /* 2260625 */ GIM_Try, /*On fail goto*//*Label 30322*/ GIMT_Encode4(2260673), // Rule ID 48521 //
     /* 2260630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2260636 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2260639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260643 */   // MIs[0] Operand 1
     /* 2260643 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2260648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260652 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260656 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2260659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260661 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260663 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260671 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260672 */   // GIR_Coverage, 48521,
     /* 2260672 */   GIR_EraseRootFromParent_Done,
     /* 2260673 */ // Label 30322: @2260673
     /* 2260673 */ GIM_Try, /*On fail goto*//*Label 30323*/ GIMT_Encode4(2260721), // Rule ID 48548 //
     /* 2260678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2260684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2260687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260691 */   // MIs[0] Operand 1
     /* 2260691 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260700 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260704 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2260707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260709 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260711 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260720 */   // GIR_Coverage, 48548,
     /* 2260720 */   GIR_EraseRootFromParent_Done,
     /* 2260721 */ // Label 30323: @2260721
     /* 2260721 */ GIM_Try, /*On fail goto*//*Label 30324*/ GIMT_Encode4(2260769), // Rule ID 48549 //
     /* 2260726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2260732 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2260735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260739 */   // MIs[0] Operand 1
     /* 2260739 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260752 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2260755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260757 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260759 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260768 */   // GIR_Coverage, 48549,
     /* 2260768 */   GIR_EraseRootFromParent_Done,
     /* 2260769 */ // Label 30324: @2260769
     /* 2260769 */ GIM_Try, /*On fail goto*//*Label 30325*/ GIMT_Encode4(2260817), // Rule ID 48556 //
     /* 2260774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2260780 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2260783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260787 */   // MIs[0] Operand 1
     /* 2260787 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260796 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260800 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2260803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260805 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260807 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260816 */   // GIR_Coverage, 48556,
     /* 2260816 */   GIR_EraseRootFromParent_Done,
     /* 2260817 */ // Label 30325: @2260817
     /* 2260817 */ GIM_Try, /*On fail goto*//*Label 30326*/ GIMT_Encode4(2260865), // Rule ID 48557 //
     /* 2260822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2260828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2260831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260835 */   // MIs[0] Operand 1
     /* 2260835 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260844 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2260848 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2260851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260853 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260855 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260863 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260864 */   // GIR_Coverage, 48557,
     /* 2260864 */   GIR_EraseRootFromParent_Done,
     /* 2260865 */ // Label 30326: @2260865
     /* 2260865 */ GIM_Try, /*On fail goto*//*Label 30327*/ GIMT_Encode4(2260913), // Rule ID 48564 //
     /* 2260870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2260876 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2260879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260883 */   // MIs[0] Operand 1
     /* 2260883 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260892 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260896 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2260899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260901 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260903 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260912 */   // GIR_Coverage, 48564,
     /* 2260912 */   GIR_EraseRootFromParent_Done,
     /* 2260913 */ // Label 30327: @2260913
     /* 2260913 */ GIM_Try, /*On fail goto*//*Label 30328*/ GIMT_Encode4(2260961), // Rule ID 48565 //
     /* 2260918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2260924 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2260927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260931 */   // MIs[0] Operand 1
     /* 2260931 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2260936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260940 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2260944 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2260947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260949 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260951 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2260960 */   // GIR_Coverage, 48565,
     /* 2260960 */   GIR_EraseRootFromParent_Done,
     /* 2260961 */ // Label 30328: @2260961
     /* 2260961 */ GIM_Try, /*On fail goto*//*Label 30329*/ GIMT_Encode4(2261009), // Rule ID 48592 //
     /* 2260966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2260972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2260975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260979 */   // MIs[0] Operand 1
     /* 2260979 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2260984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260988 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2260992 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2260995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260997 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260999 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261008 */   // GIR_Coverage, 48592,
     /* 2261008 */   GIR_EraseRootFromParent_Done,
     /* 2261009 */ // Label 30329: @2261009
     /* 2261009 */ GIM_Try, /*On fail goto*//*Label 30330*/ GIMT_Encode4(2261057), // Rule ID 48593 //
     /* 2261014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261027 */   // MIs[0] Operand 1
     /* 2261027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261040 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261045 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261047 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261056 */   // GIR_Coverage, 48593,
     /* 2261056 */   GIR_EraseRootFromParent_Done,
     /* 2261057 */ // Label 30330: @2261057
     /* 2261057 */ GIM_Try, /*On fail goto*//*Label 30331*/ GIMT_Encode4(2261105), // Rule ID 48600 //
     /* 2261062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261075 */   // MIs[0] Operand 1
     /* 2261075 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261088 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261093 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261095 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261104 */   // GIR_Coverage, 48600,
     /* 2261104 */   GIR_EraseRootFromParent_Done,
     /* 2261105 */ // Label 30331: @2261105
     /* 2261105 */ GIM_Try, /*On fail goto*//*Label 30332*/ GIMT_Encode4(2261153), // Rule ID 48601 //
     /* 2261110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261123 */   // MIs[0] Operand 1
     /* 2261123 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261132 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261136 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261141 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261143 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261152 */   // GIR_Coverage, 48601,
     /* 2261152 */   GIR_EraseRootFromParent_Done,
     /* 2261153 */ // Label 30332: @2261153
     /* 2261153 */ GIM_Try, /*On fail goto*//*Label 30333*/ GIMT_Encode4(2261201), // Rule ID 48608 //
     /* 2261158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261164 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261171 */   // MIs[0] Operand 1
     /* 2261171 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261180 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261184 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261189 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261191 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261200 */   // GIR_Coverage, 48608,
     /* 2261200 */   GIR_EraseRootFromParent_Done,
     /* 2261201 */ // Label 30333: @2261201
     /* 2261201 */ GIM_Try, /*On fail goto*//*Label 30334*/ GIMT_Encode4(2261249), // Rule ID 48609 //
     /* 2261206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261212 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261219 */   // MIs[0] Operand 1
     /* 2261219 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2261224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261228 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261232 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261237 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261239 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261248 */   // GIR_Coverage, 48609,
     /* 2261248 */   GIR_EraseRootFromParent_Done,
     /* 2261249 */ // Label 30334: @2261249
     /* 2261249 */ GIM_Try, /*On fail goto*//*Label 30335*/ GIMT_Encode4(2261297), // Rule ID 48634 //
     /* 2261254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261267 */   // MIs[0] Operand 1
     /* 2261267 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261280 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261285 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261287 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261296 */   // GIR_Coverage, 48634,
     /* 2261296 */   GIR_EraseRootFromParent_Done,
     /* 2261297 */ // Label 30335: @2261297
     /* 2261297 */ GIM_Try, /*On fail goto*//*Label 30336*/ GIMT_Encode4(2261345), // Rule ID 48635 //
     /* 2261302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261308 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261315 */   // MIs[0] Operand 1
     /* 2261315 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261324 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261328 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2261331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261333 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261335 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261344 */   // GIR_Coverage, 48635,
     /* 2261344 */   GIR_EraseRootFromParent_Done,
     /* 2261345 */ // Label 30336: @2261345
     /* 2261345 */ GIM_Try, /*On fail goto*//*Label 30337*/ GIMT_Encode4(2261393), // Rule ID 48642 //
     /* 2261350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261356 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261363 */   // MIs[0] Operand 1
     /* 2261363 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261372 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261376 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261381 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261383 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261392 */   // GIR_Coverage, 48642,
     /* 2261392 */   GIR_EraseRootFromParent_Done,
     /* 2261393 */ // Label 30337: @2261393
     /* 2261393 */ GIM_Try, /*On fail goto*//*Label 30338*/ GIMT_Encode4(2261441), // Rule ID 48643 //
     /* 2261398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261411 */   // MIs[0] Operand 1
     /* 2261411 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261424 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2261427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261429 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261431 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261440 */   // GIR_Coverage, 48643,
     /* 2261440 */   GIR_EraseRootFromParent_Done,
     /* 2261441 */ // Label 30338: @2261441
     /* 2261441 */ GIM_Try, /*On fail goto*//*Label 30339*/ GIMT_Encode4(2261489), // Rule ID 48650 //
     /* 2261446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261452 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261459 */   // MIs[0] Operand 1
     /* 2261459 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261468 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261472 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261477 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261479 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261488 */   // GIR_Coverage, 48650,
     /* 2261488 */   GIR_EraseRootFromParent_Done,
     /* 2261489 */ // Label 30339: @2261489
     /* 2261489 */ GIM_Try, /*On fail goto*//*Label 30340*/ GIMT_Encode4(2261537), // Rule ID 48651 //
     /* 2261494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261507 */   // MIs[0] Operand 1
     /* 2261507 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2261512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261516 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261520 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2261523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261525 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261527 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261536 */   // GIR_Coverage, 48651,
     /* 2261536 */   GIR_EraseRootFromParent_Done,
     /* 2261537 */ // Label 30340: @2261537
     /* 2261537 */ GIM_Try, /*On fail goto*//*Label 30341*/ GIMT_Encode4(2261585), // Rule ID 48678 //
     /* 2261542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261555 */   // MIs[0] Operand 1
     /* 2261555 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2261560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261564 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261568 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2261571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261573 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261575 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261584 */   // GIR_Coverage, 48678,
     /* 2261584 */   GIR_EraseRootFromParent_Done,
     /* 2261585 */ // Label 30341: @2261585
     /* 2261585 */ GIM_Try, /*On fail goto*//*Label 30342*/ GIMT_Encode4(2261633), // Rule ID 48679 //
     /* 2261590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261603 */   // MIs[0] Operand 1
     /* 2261603 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2261608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261616 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2261619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261621 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261623 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261632 */   // GIR_Coverage, 48679,
     /* 2261632 */   GIR_EraseRootFromParent_Done,
     /* 2261633 */ // Label 30342: @2261633
     /* 2261633 */ GIM_Try, /*On fail goto*//*Label 30343*/ GIMT_Encode4(2261681), // Rule ID 48686 //
     /* 2261638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261644 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261651 */   // MIs[0] Operand 1
     /* 2261651 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2261656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261664 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2261667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261669 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261671 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261680 */   // GIR_Coverage, 48686,
     /* 2261680 */   GIR_EraseRootFromParent_Done,
     /* 2261681 */ // Label 30343: @2261681
     /* 2261681 */ GIM_Try, /*On fail goto*//*Label 30344*/ GIMT_Encode4(2261729), // Rule ID 48687 //
     /* 2261686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261699 */   // MIs[0] Operand 1
     /* 2261699 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2261704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261708 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261712 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2261715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261717 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261719 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261728 */   // GIR_Coverage, 48687,
     /* 2261728 */   GIR_EraseRootFromParent_Done,
     /* 2261729 */ // Label 30344: @2261729
     /* 2261729 */ GIM_Try, /*On fail goto*//*Label 30345*/ GIMT_Encode4(2261777), // Rule ID 48694 //
     /* 2261734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261747 */   // MIs[0] Operand 1
     /* 2261747 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2261752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261756 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261760 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2261763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261765 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261767 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261775 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261776 */   // GIR_Coverage, 48694,
     /* 2261776 */   GIR_EraseRootFromParent_Done,
     /* 2261777 */ // Label 30345: @2261777
     /* 2261777 */ GIM_Try, /*On fail goto*//*Label 30346*/ GIMT_Encode4(2261825), // Rule ID 48695 //
     /* 2261782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2261788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2261791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261795 */   // MIs[0] Operand 1
     /* 2261795 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2261800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261804 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2261808 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2261811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261813 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261815 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261824 */   // GIR_Coverage, 48695,
     /* 2261824 */   GIR_EraseRootFromParent_Done,
     /* 2261825 */ // Label 30346: @2261825
     /* 2261825 */ GIM_Try, /*On fail goto*//*Label 30347*/ GIMT_Encode4(2261873), // Rule ID 48722 //
     /* 2261830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261843 */   // MIs[0] Operand 1
     /* 2261843 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2261848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261852 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261856 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2261859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261861 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261863 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261872 */   // GIR_Coverage, 48722,
     /* 2261872 */   GIR_EraseRootFromParent_Done,
     /* 2261873 */ // Label 30347: @2261873
     /* 2261873 */ GIM_Try, /*On fail goto*//*Label 30348*/ GIMT_Encode4(2261921), // Rule ID 48723 //
     /* 2261878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2261884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2261887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261891 */   // MIs[0] Operand 1
     /* 2261891 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2261896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261900 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261904 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2261907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261909 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261911 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261919 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261920 */   // GIR_Coverage, 48723,
     /* 2261920 */   GIR_EraseRootFromParent_Done,
     /* 2261921 */ // Label 30348: @2261921
     /* 2261921 */ GIM_Try, /*On fail goto*//*Label 30349*/ GIMT_Encode4(2261969), // Rule ID 48730 //
     /* 2261926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261932 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261939 */   // MIs[0] Operand 1
     /* 2261939 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2261944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261948 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261952 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2261955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261957 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2261959 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2261961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2261968 */   // GIR_Coverage, 48730,
     /* 2261968 */   GIR_EraseRootFromParent_Done,
     /* 2261969 */ // Label 30349: @2261969
     /* 2261969 */ GIM_Try, /*On fail goto*//*Label 30350*/ GIMT_Encode4(2262017), // Rule ID 48731 //
     /* 2261974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2261980 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2261983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261987 */   // MIs[0] Operand 1
     /* 2261987 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2261992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261996 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262000 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2262003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262005 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262007 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262015 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262016 */   // GIR_Coverage, 48731,
     /* 2262016 */   GIR_EraseRootFromParent_Done,
     /* 2262017 */ // Label 30350: @2262017
     /* 2262017 */ GIM_Try, /*On fail goto*//*Label 30351*/ GIMT_Encode4(2262065), // Rule ID 48738 //
     /* 2262022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262028 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262035 */   // MIs[0] Operand 1
     /* 2262035 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262044 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262048 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262053 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262055 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262064 */   // GIR_Coverage, 48738,
     /* 2262064 */   GIR_EraseRootFromParent_Done,
     /* 2262065 */ // Label 30351: @2262065
     /* 2262065 */ GIM_Try, /*On fail goto*//*Label 30352*/ GIMT_Encode4(2262113), // Rule ID 48739 //
     /* 2262070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262083 */   // MIs[0] Operand 1
     /* 2262083 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2262088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262092 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262096 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2262099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262101 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262103 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262112 */   // GIR_Coverage, 48739,
     /* 2262112 */   GIR_EraseRootFromParent_Done,
     /* 2262113 */ // Label 30352: @2262113
     /* 2262113 */ GIM_Try, /*On fail goto*//*Label 30353*/ GIMT_Encode4(2262161), // Rule ID 48766 //
     /* 2262118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262124 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262131 */   // MIs[0] Operand 1
     /* 2262131 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262140 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262144 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262149 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262151 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262159 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262160 */   // GIR_Coverage, 48766,
     /* 2262160 */   GIR_EraseRootFromParent_Done,
     /* 2262161 */ // Label 30353: @2262161
     /* 2262161 */ GIM_Try, /*On fail goto*//*Label 30354*/ GIMT_Encode4(2262209), // Rule ID 48767 //
     /* 2262166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262179 */   // MIs[0] Operand 1
     /* 2262179 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262188 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262192 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262197 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262199 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262208 */   // GIR_Coverage, 48767,
     /* 2262208 */   GIR_EraseRootFromParent_Done,
     /* 2262209 */ // Label 30354: @2262209
     /* 2262209 */ GIM_Try, /*On fail goto*//*Label 30355*/ GIMT_Encode4(2262257), // Rule ID 48774 //
     /* 2262214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262227 */   // MIs[0] Operand 1
     /* 2262227 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262236 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262240 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2262243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262245 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262247 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262256 */   // GIR_Coverage, 48774,
     /* 2262256 */   GIR_EraseRootFromParent_Done,
     /* 2262257 */ // Label 30355: @2262257
     /* 2262257 */ GIM_Try, /*On fail goto*//*Label 30356*/ GIMT_Encode4(2262305), // Rule ID 48775 //
     /* 2262262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262268 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262275 */   // MIs[0] Operand 1
     /* 2262275 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262284 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262288 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2262291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262293 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262295 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262303 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262304 */   // GIR_Coverage, 48775,
     /* 2262304 */   GIR_EraseRootFromParent_Done,
     /* 2262305 */ // Label 30356: @2262305
     /* 2262305 */ GIM_Try, /*On fail goto*//*Label 30357*/ GIMT_Encode4(2262353), // Rule ID 48782 //
     /* 2262310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262316 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262323 */   // MIs[0] Operand 1
     /* 2262323 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262332 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262336 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2262339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262341 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262343 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262352 */   // GIR_Coverage, 48782,
     /* 2262352 */   GIR_EraseRootFromParent_Done,
     /* 2262353 */ // Label 30357: @2262353
     /* 2262353 */ GIM_Try, /*On fail goto*//*Label 30358*/ GIMT_Encode4(2262401), // Rule ID 48783 //
     /* 2262358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262371 */   // MIs[0] Operand 1
     /* 2262371 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2262376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262380 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262384 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2262387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262389 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262391 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262399 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262400 */   // GIR_Coverage, 48783,
     /* 2262400 */   GIR_EraseRootFromParent_Done,
     /* 2262401 */ // Label 30358: @2262401
     /* 2262401 */ GIM_Try, /*On fail goto*//*Label 30359*/ GIMT_Encode4(2262449), // Rule ID 48810 //
     /* 2262406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262412 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262419 */   // MIs[0] Operand 1
     /* 2262419 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262424 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262428 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262432 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262437 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262439 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262447 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262448 */   // GIR_Coverage, 48810,
     /* 2262448 */   GIR_EraseRootFromParent_Done,
     /* 2262449 */ // Label 30359: @2262449
     /* 2262449 */ GIM_Try, /*On fail goto*//*Label 30360*/ GIMT_Encode4(2262497), // Rule ID 48811 //
     /* 2262454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262460 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262467 */   // MIs[0] Operand 1
     /* 2262467 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262476 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262480 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2262483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262485 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262487 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262495 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262496 */   // GIR_Coverage, 48811,
     /* 2262496 */   GIR_EraseRootFromParent_Done,
     /* 2262497 */ // Label 30360: @2262497
     /* 2262497 */ GIM_Try, /*On fail goto*//*Label 30361*/ GIMT_Encode4(2262545), // Rule ID 48818 //
     /* 2262502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262515 */   // MIs[0] Operand 1
     /* 2262515 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262524 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262528 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2262531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262533 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262535 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262543 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262544 */   // GIR_Coverage, 48818,
     /* 2262544 */   GIR_EraseRootFromParent_Done,
     /* 2262545 */ // Label 30361: @2262545
     /* 2262545 */ GIM_Try, /*On fail goto*//*Label 30362*/ GIMT_Encode4(2262593), // Rule ID 48819 //
     /* 2262550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262556 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262563 */   // MIs[0] Operand 1
     /* 2262563 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262572 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262576 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2262579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262581 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262583 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262591 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262592 */   // GIR_Coverage, 48819,
     /* 2262592 */   GIR_EraseRootFromParent_Done,
     /* 2262593 */ // Label 30362: @2262593
     /* 2262593 */ GIM_Try, /*On fail goto*//*Label 30363*/ GIMT_Encode4(2262641), // Rule ID 48826 //
     /* 2262598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262604 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262611 */   // MIs[0] Operand 1
     /* 2262611 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262620 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262624 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2262627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262629 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262631 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262636 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262639 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262640 */   // GIR_Coverage, 48826,
     /* 2262640 */   GIR_EraseRootFromParent_Done,
     /* 2262641 */ // Label 30363: @2262641
     /* 2262641 */ GIM_Try, /*On fail goto*//*Label 30364*/ GIMT_Encode4(2262689), // Rule ID 48827 //
     /* 2262646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262652 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262659 */   // MIs[0] Operand 1
     /* 2262659 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2262664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262668 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262672 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2262675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262677 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2262679 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2262681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262687 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262688 */   // GIR_Coverage, 48827,
     /* 2262688 */   GIR_EraseRootFromParent_Done,
     /* 2262689 */ // Label 30364: @2262689
     /* 2262689 */ GIM_Try, /*On fail goto*//*Label 30365*/ GIMT_Encode4(2262737), // Rule ID 48854 //
     /* 2262694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262700 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262707 */   // MIs[0] Operand 1
     /* 2262707 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2262712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262716 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262720 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2262723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262725 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262727 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262736 */   // GIR_Coverage, 48854,
     /* 2262736 */   GIR_EraseRootFromParent_Done,
     /* 2262737 */ // Label 30365: @2262737
     /* 2262737 */ GIM_Try, /*On fail goto*//*Label 30366*/ GIMT_Encode4(2262785), // Rule ID 48855 //
     /* 2262742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262748 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262755 */   // MIs[0] Operand 1
     /* 2262755 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2262760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262764 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262768 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2262771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262773 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262775 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262783 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262784 */   // GIR_Coverage, 48855,
     /* 2262784 */   GIR_EraseRootFromParent_Done,
     /* 2262785 */ // Label 30366: @2262785
     /* 2262785 */ GIM_Try, /*On fail goto*//*Label 30367*/ GIMT_Encode4(2262833), // Rule ID 48862 //
     /* 2262790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262796 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262803 */   // MIs[0] Operand 1
     /* 2262803 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2262808 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262812 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262816 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2262819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262821 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262823 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262831 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262832 */   // GIR_Coverage, 48862,
     /* 2262832 */   GIR_EraseRootFromParent_Done,
     /* 2262833 */ // Label 30367: @2262833
     /* 2262833 */ GIM_Try, /*On fail goto*//*Label 30368*/ GIMT_Encode4(2262881), // Rule ID 48863 //
     /* 2262838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2262844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2262847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262851 */   // MIs[0] Operand 1
     /* 2262851 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2262856 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262860 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262864 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2262867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262869 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262871 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262879 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262880 */   // GIR_Coverage, 48863,
     /* 2262880 */   GIR_EraseRootFromParent_Done,
     /* 2262881 */ // Label 30368: @2262881
     /* 2262881 */ GIM_Try, /*On fail goto*//*Label 30369*/ GIMT_Encode4(2262929), // Rule ID 48870 //
     /* 2262886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262892 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262899 */   // MIs[0] Operand 1
     /* 2262899 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2262904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262908 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262912 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2262915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262917 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262919 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262927 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262928 */   // GIR_Coverage, 48870,
     /* 2262928 */   GIR_EraseRootFromParent_Done,
     /* 2262929 */ // Label 30369: @2262929
     /* 2262929 */ GIM_Try, /*On fail goto*//*Label 30370*/ GIMT_Encode4(2262977), // Rule ID 48871 //
     /* 2262934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2262940 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2262943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262947 */   // MIs[0] Operand 1
     /* 2262947 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2262952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262956 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262960 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2262963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262965 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262967 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262975 */   GIR_RootConstrainSelectedInstOperands,
     /* 2262976 */   // GIR_Coverage, 48871,
     /* 2262976 */   GIR_EraseRootFromParent_Done,
     /* 2262977 */ // Label 30370: @2262977
     /* 2262977 */ GIM_Try, /*On fail goto*//*Label 30371*/ GIMT_Encode4(2263025), // Rule ID 48898 //
     /* 2262982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262988 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262995 */   // MIs[0] Operand 1
     /* 2262995 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263004 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263008 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263013 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263015 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263023 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263024 */   // GIR_Coverage, 48898,
     /* 2263024 */   GIR_EraseRootFromParent_Done,
     /* 2263025 */ // Label 30371: @2263025
     /* 2263025 */ GIM_Try, /*On fail goto*//*Label 30372*/ GIMT_Encode4(2263073), // Rule ID 48899 //
     /* 2263030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2263036 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2263039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263043 */   // MIs[0] Operand 1
     /* 2263043 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263052 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2263056 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2263059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263061 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263063 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263071 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263072 */   // GIR_Coverage, 48899,
     /* 2263072 */   GIR_EraseRootFromParent_Done,
     /* 2263073 */ // Label 30372: @2263073
     /* 2263073 */ GIM_Try, /*On fail goto*//*Label 30373*/ GIMT_Encode4(2263121), // Rule ID 48906 //
     /* 2263078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263084 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263091 */   // MIs[0] Operand 1
     /* 2263091 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263100 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263104 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263109 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263111 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263119 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263120 */   // GIR_Coverage, 48906,
     /* 2263120 */   GIR_EraseRootFromParent_Done,
     /* 2263121 */ // Label 30373: @2263121
     /* 2263121 */ GIM_Try, /*On fail goto*//*Label 30374*/ GIMT_Encode4(2263169), // Rule ID 48907 //
     /* 2263126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263132 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263139 */   // MIs[0] Operand 1
     /* 2263139 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263144 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263148 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263152 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263152 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2263155 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263157 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263159 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263164 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263167 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263168 */   // GIR_Coverage, 48907,
     /* 2263168 */   GIR_EraseRootFromParent_Done,
     /* 2263169 */ // Label 30374: @2263169
     /* 2263169 */ GIM_Try, /*On fail goto*//*Label 30375*/ GIMT_Encode4(2263217), // Rule ID 48914 //
     /* 2263174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263180 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263187 */   // MIs[0] Operand 1
     /* 2263187 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263196 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263200 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263205 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263207 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263215 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263216 */   // GIR_Coverage, 48914,
     /* 2263216 */   GIR_EraseRootFromParent_Done,
     /* 2263217 */ // Label 30375: @2263217
     /* 2263217 */ GIM_Try, /*On fail goto*//*Label 30376*/ GIMT_Encode4(2263265), // Rule ID 48915 //
     /* 2263222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263235 */   // MIs[0] Operand 1
     /* 2263235 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2263240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263244 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263248 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2263251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263253 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263255 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263263 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263264 */   // GIR_Coverage, 48915,
     /* 2263264 */   GIR_EraseRootFromParent_Done,
     /* 2263265 */ // Label 30376: @2263265
     /* 2263265 */ GIM_Reject,
     /* 2263266 */ // Label 29900: @2263266
     /* 2263266 */ GIM_Try, /*On fail goto*//*Label 30377*/ GIMT_Encode4(2263314), // Rule ID 48506 //
     /* 2263271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263277 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263284 */   // MIs[0] Operand 1
     /* 2263284 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2263289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263293 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263297 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2263300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263302 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263304 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263312 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263313 */   // GIR_Coverage, 48506,
     /* 2263313 */   GIR_EraseRootFromParent_Done,
     /* 2263314 */ // Label 30377: @2263314
     /* 2263314 */ GIM_Try, /*On fail goto*//*Label 30378*/ GIMT_Encode4(2263362), // Rule ID 48507 //
     /* 2263319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263332 */   // MIs[0] Operand 1
     /* 2263332 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2263337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263341 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263345 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2263348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263350 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263352 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263361 */   // GIR_Coverage, 48507,
     /* 2263361 */   GIR_EraseRootFromParent_Done,
     /* 2263362 */ // Label 30378: @2263362
     /* 2263362 */ GIM_Try, /*On fail goto*//*Label 30379*/ GIMT_Encode4(2263410), // Rule ID 48514 //
     /* 2263367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263373 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263380 */   // MIs[0] Operand 1
     /* 2263380 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2263385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263389 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263393 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2263396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263398 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263400 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263409 */   // GIR_Coverage, 48514,
     /* 2263409 */   GIR_EraseRootFromParent_Done,
     /* 2263410 */ // Label 30379: @2263410
     /* 2263410 */ GIM_Try, /*On fail goto*//*Label 30380*/ GIMT_Encode4(2263458), // Rule ID 48515 //
     /* 2263415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263428 */   // MIs[0] Operand 1
     /* 2263428 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2263433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263437 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263441 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2263444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263446 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263448 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263457 */   // GIR_Coverage, 48515,
     /* 2263457 */   GIR_EraseRootFromParent_Done,
     /* 2263458 */ // Label 30380: @2263458
     /* 2263458 */ GIM_Try, /*On fail goto*//*Label 30381*/ GIMT_Encode4(2263506), // Rule ID 48550 //
     /* 2263463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263476 */   // MIs[0] Operand 1
     /* 2263476 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2263481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263485 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263489 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2263492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263494 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263496 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263504 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263505 */   // GIR_Coverage, 48550,
     /* 2263505 */   GIR_EraseRootFromParent_Done,
     /* 2263506 */ // Label 30381: @2263506
     /* 2263506 */ GIM_Try, /*On fail goto*//*Label 30382*/ GIMT_Encode4(2263554), // Rule ID 48551 //
     /* 2263511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263517 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263524 */   // MIs[0] Operand 1
     /* 2263524 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2263529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263533 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263537 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2263540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263542 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263544 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263553 */   // GIR_Coverage, 48551,
     /* 2263553 */   GIR_EraseRootFromParent_Done,
     /* 2263554 */ // Label 30382: @2263554
     /* 2263554 */ GIM_Try, /*On fail goto*//*Label 30383*/ GIMT_Encode4(2263602), // Rule ID 48558 //
     /* 2263559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263572 */   // MIs[0] Operand 1
     /* 2263572 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2263577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263581 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263585 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2263588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263590 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263592 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263600 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263601 */   // GIR_Coverage, 48558,
     /* 2263601 */   GIR_EraseRootFromParent_Done,
     /* 2263602 */ // Label 30383: @2263602
     /* 2263602 */ GIM_Try, /*On fail goto*//*Label 30384*/ GIMT_Encode4(2263650), // Rule ID 48559 //
     /* 2263607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263613 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263620 */   // MIs[0] Operand 1
     /* 2263620 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2263625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263629 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263633 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2263636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263638 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263640 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263649 */   // GIR_Coverage, 48559,
     /* 2263649 */   GIR_EraseRootFromParent_Done,
     /* 2263650 */ // Label 30384: @2263650
     /* 2263650 */ GIM_Try, /*On fail goto*//*Label 30385*/ GIMT_Encode4(2263698), // Rule ID 48594 //
     /* 2263655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263661 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263668 */   // MIs[0] Operand 1
     /* 2263668 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2263673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263677 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263681 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2263684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263686 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263688 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263696 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263697 */   // GIR_Coverage, 48594,
     /* 2263697 */   GIR_EraseRootFromParent_Done,
     /* 2263698 */ // Label 30385: @2263698
     /* 2263698 */ GIM_Try, /*On fail goto*//*Label 30386*/ GIMT_Encode4(2263746), // Rule ID 48595 //
     /* 2263703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263709 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263716 */   // MIs[0] Operand 1
     /* 2263716 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2263721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263725 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263729 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2263732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263734 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263736 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263744 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263745 */   // GIR_Coverage, 48595,
     /* 2263745 */   GIR_EraseRootFromParent_Done,
     /* 2263746 */ // Label 30386: @2263746
     /* 2263746 */ GIM_Try, /*On fail goto*//*Label 30387*/ GIMT_Encode4(2263794), // Rule ID 48602 //
     /* 2263751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263764 */   // MIs[0] Operand 1
     /* 2263764 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2263769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263773 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263777 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2263780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263782 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263784 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263793 */   // GIR_Coverage, 48602,
     /* 2263793 */   GIR_EraseRootFromParent_Done,
     /* 2263794 */ // Label 30387: @2263794
     /* 2263794 */ GIM_Try, /*On fail goto*//*Label 30388*/ GIMT_Encode4(2263842), // Rule ID 48603 //
     /* 2263799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263805 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263812 */   // MIs[0] Operand 1
     /* 2263812 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2263817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263821 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263825 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2263828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263830 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263832 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263840 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263841 */   // GIR_Coverage, 48603,
     /* 2263841 */   GIR_EraseRootFromParent_Done,
     /* 2263842 */ // Label 30388: @2263842
     /* 2263842 */ GIM_Try, /*On fail goto*//*Label 30389*/ GIMT_Encode4(2263890), // Rule ID 48636 //
     /* 2263847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263860 */   // MIs[0] Operand 1
     /* 2263860 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2263865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263869 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263873 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2263876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263878 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263880 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263889 */   // GIR_Coverage, 48636,
     /* 2263889 */   GIR_EraseRootFromParent_Done,
     /* 2263890 */ // Label 30389: @2263890
     /* 2263890 */ GIM_Try, /*On fail goto*//*Label 30390*/ GIMT_Encode4(2263938), // Rule ID 48637 //
     /* 2263895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263901 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263908 */   // MIs[0] Operand 1
     /* 2263908 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2263913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263917 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263921 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2263924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263926 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263928 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263937 */   // GIR_Coverage, 48637,
     /* 2263937 */   GIR_EraseRootFromParent_Done,
     /* 2263938 */ // Label 30390: @2263938
     /* 2263938 */ GIM_Try, /*On fail goto*//*Label 30391*/ GIMT_Encode4(2263986), // Rule ID 48644 //
     /* 2263943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263949 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2263956 */   // MIs[0] Operand 1
     /* 2263956 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2263961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263965 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263969 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2263972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263974 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2263976 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2263978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263984 */   GIR_RootConstrainSelectedInstOperands,
     /* 2263985 */   // GIR_Coverage, 48644,
     /* 2263985 */   GIR_EraseRootFromParent_Done,
     /* 2263986 */ // Label 30391: @2263986
     /* 2263986 */ GIM_Try, /*On fail goto*//*Label 30392*/ GIMT_Encode4(2264034), // Rule ID 48645 //
     /* 2263991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263997 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264004 */   // MIs[0] Operand 1
     /* 2264004 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2264009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264013 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264017 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2264020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264022 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264024 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264033 */   // GIR_Coverage, 48645,
     /* 2264033 */   GIR_EraseRootFromParent_Done,
     /* 2264034 */ // Label 30392: @2264034
     /* 2264034 */ GIM_Try, /*On fail goto*//*Label 30393*/ GIMT_Encode4(2264082), // Rule ID 48680 //
     /* 2264039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264045 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264052 */   // MIs[0] Operand 1
     /* 2264052 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264061 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264065 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264070 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264072 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264081 */   // GIR_Coverage, 48680,
     /* 2264081 */   GIR_EraseRootFromParent_Done,
     /* 2264082 */ // Label 30393: @2264082
     /* 2264082 */ GIM_Try, /*On fail goto*//*Label 30394*/ GIMT_Encode4(2264130), // Rule ID 48681 //
     /* 2264087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264093 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264100 */   // MIs[0] Operand 1
     /* 2264100 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264109 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264113 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264118 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264120 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264128 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264129 */   // GIR_Coverage, 48681,
     /* 2264129 */   GIR_EraseRootFromParent_Done,
     /* 2264130 */ // Label 30394: @2264130
     /* 2264130 */ GIM_Try, /*On fail goto*//*Label 30395*/ GIMT_Encode4(2264178), // Rule ID 48688 //
     /* 2264135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264141 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264148 */   // MIs[0] Operand 1
     /* 2264148 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264157 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264161 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2264164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264166 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264168 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264176 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264177 */   // GIR_Coverage, 48688,
     /* 2264177 */   GIR_EraseRootFromParent_Done,
     /* 2264178 */ // Label 30395: @2264178
     /* 2264178 */ GIM_Try, /*On fail goto*//*Label 30396*/ GIMT_Encode4(2264226), // Rule ID 48689 //
     /* 2264183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264189 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264196 */   // MIs[0] Operand 1
     /* 2264196 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2264201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264205 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264209 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2264212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264214 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264216 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264224 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264225 */   // GIR_Coverage, 48689,
     /* 2264225 */   GIR_EraseRootFromParent_Done,
     /* 2264226 */ // Label 30396: @2264226
     /* 2264226 */ GIM_Try, /*On fail goto*//*Label 30397*/ GIMT_Encode4(2264274), // Rule ID 48724 //
     /* 2264231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264237 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264244 */   // MIs[0] Operand 1
     /* 2264244 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2264249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264253 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264257 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264262 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264264 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264273 */   // GIR_Coverage, 48724,
     /* 2264273 */   GIR_EraseRootFromParent_Done,
     /* 2264274 */ // Label 30397: @2264274
     /* 2264274 */ GIM_Try, /*On fail goto*//*Label 30398*/ GIMT_Encode4(2264322), // Rule ID 48725 //
     /* 2264279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264285 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264292 */   // MIs[0] Operand 1
     /* 2264292 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2264297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264301 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264305 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2264308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264310 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264312 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264320 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264321 */   // GIR_Coverage, 48725,
     /* 2264321 */   GIR_EraseRootFromParent_Done,
     /* 2264322 */ // Label 30398: @2264322
     /* 2264322 */ GIM_Try, /*On fail goto*//*Label 30399*/ GIMT_Encode4(2264370), // Rule ID 48732 //
     /* 2264327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264333 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264340 */   // MIs[0] Operand 1
     /* 2264340 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2264345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264349 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264353 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2264356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264358 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264360 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264368 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264369 */   // GIR_Coverage, 48732,
     /* 2264369 */   GIR_EraseRootFromParent_Done,
     /* 2264370 */ // Label 30399: @2264370
     /* 2264370 */ GIM_Try, /*On fail goto*//*Label 30400*/ GIMT_Encode4(2264418), // Rule ID 48733 //
     /* 2264375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264381 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264388 */   // MIs[0] Operand 1
     /* 2264388 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2264393 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264397 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264401 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2264404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264406 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264408 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264416 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264417 */   // GIR_Coverage, 48733,
     /* 2264417 */   GIR_EraseRootFromParent_Done,
     /* 2264418 */ // Label 30400: @2264418
     /* 2264418 */ GIM_Try, /*On fail goto*//*Label 30401*/ GIMT_Encode4(2264466), // Rule ID 48768 //
     /* 2264423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264429 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264436 */   // MIs[0] Operand 1
     /* 2264436 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2264441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264445 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264449 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2264452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264454 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264456 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264464 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264465 */   // GIR_Coverage, 48768,
     /* 2264465 */   GIR_EraseRootFromParent_Done,
     /* 2264466 */ // Label 30401: @2264466
     /* 2264466 */ GIM_Try, /*On fail goto*//*Label 30402*/ GIMT_Encode4(2264514), // Rule ID 48769 //
     /* 2264471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264477 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264484 */   // MIs[0] Operand 1
     /* 2264484 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2264489 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264493 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264497 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2264500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264502 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264504 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264512 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264513 */   // GIR_Coverage, 48769,
     /* 2264513 */   GIR_EraseRootFromParent_Done,
     /* 2264514 */ // Label 30402: @2264514
     /* 2264514 */ GIM_Try, /*On fail goto*//*Label 30403*/ GIMT_Encode4(2264562), // Rule ID 48776 //
     /* 2264519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264532 */   // MIs[0] Operand 1
     /* 2264532 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2264537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264541 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264545 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2264548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264550 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264552 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264560 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264561 */   // GIR_Coverage, 48776,
     /* 2264561 */   GIR_EraseRootFromParent_Done,
     /* 2264562 */ // Label 30403: @2264562
     /* 2264562 */ GIM_Try, /*On fail goto*//*Label 30404*/ GIMT_Encode4(2264610), // Rule ID 48777 //
     /* 2264567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264573 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264580 */   // MIs[0] Operand 1
     /* 2264580 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2264585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264589 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264593 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2264596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264598 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264600 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264608 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264609 */   // GIR_Coverage, 48777,
     /* 2264609 */   GIR_EraseRootFromParent_Done,
     /* 2264610 */ // Label 30404: @2264610
     /* 2264610 */ GIM_Try, /*On fail goto*//*Label 30405*/ GIMT_Encode4(2264658), // Rule ID 48812 //
     /* 2264615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264621 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264628 */   // MIs[0] Operand 1
     /* 2264628 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2264633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264637 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264641 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2264644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264646 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264648 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264656 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264657 */   // GIR_Coverage, 48812,
     /* 2264657 */   GIR_EraseRootFromParent_Done,
     /* 2264658 */ // Label 30405: @2264658
     /* 2264658 */ GIM_Try, /*On fail goto*//*Label 30406*/ GIMT_Encode4(2264706), // Rule ID 48813 //
     /* 2264663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264669 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264676 */   // MIs[0] Operand 1
     /* 2264676 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2264681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264685 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264689 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2264692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264694 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264696 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264704 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264705 */   // GIR_Coverage, 48813,
     /* 2264705 */   GIR_EraseRootFromParent_Done,
     /* 2264706 */ // Label 30406: @2264706
     /* 2264706 */ GIM_Try, /*On fail goto*//*Label 30407*/ GIMT_Encode4(2264754), // Rule ID 48820 //
     /* 2264711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264724 */   // MIs[0] Operand 1
     /* 2264724 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2264729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264733 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264737 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2264740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264742 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264744 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264753 */   // GIR_Coverage, 48820,
     /* 2264753 */   GIR_EraseRootFromParent_Done,
     /* 2264754 */ // Label 30407: @2264754
     /* 2264754 */ GIM_Try, /*On fail goto*//*Label 30408*/ GIMT_Encode4(2264802), // Rule ID 48821 //
     /* 2264759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264772 */   // MIs[0] Operand 1
     /* 2264772 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2264777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264781 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264785 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2264788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264790 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2264792 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264800 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264801 */   // GIR_Coverage, 48821,
     /* 2264801 */   GIR_EraseRootFromParent_Done,
     /* 2264802 */ // Label 30408: @2264802
     /* 2264802 */ GIM_Try, /*On fail goto*//*Label 30409*/ GIMT_Encode4(2264850), // Rule ID 48856 //
     /* 2264807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264813 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264820 */   // MIs[0] Operand 1
     /* 2264820 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2264825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264829 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264833 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2264836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264838 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264840 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264849 */   // GIR_Coverage, 48856,
     /* 2264849 */   GIR_EraseRootFromParent_Done,
     /* 2264850 */ // Label 30409: @2264850
     /* 2264850 */ GIM_Try, /*On fail goto*//*Label 30410*/ GIMT_Encode4(2264898), // Rule ID 48857 //
     /* 2264855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2264861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2264864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264868 */   // MIs[0] Operand 1
     /* 2264868 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2264873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264877 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2264881 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2264884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264886 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264888 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264896 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264897 */   // GIR_Coverage, 48857,
     /* 2264897 */   GIR_EraseRootFromParent_Done,
     /* 2264898 */ // Label 30410: @2264898
     /* 2264898 */ GIM_Try, /*On fail goto*//*Label 30411*/ GIMT_Encode4(2264946), // Rule ID 48864 //
     /* 2264903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264909 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264916 */   // MIs[0] Operand 1
     /* 2264916 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2264921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264925 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264929 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2264929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2264932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264934 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264936 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264944 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264945 */   // GIR_Coverage, 48864,
     /* 2264945 */   GIR_EraseRootFromParent_Done,
     /* 2264946 */ // Label 30411: @2264946
     /* 2264946 */ GIM_Try, /*On fail goto*//*Label 30412*/ GIMT_Encode4(2264994), // Rule ID 48865 //
     /* 2264951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2264957 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2264960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264964 */   // MIs[0] Operand 1
     /* 2264964 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2264969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264973 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2264977 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2264977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2264980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264982 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2264984 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2264986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264992 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264993 */   // GIR_Coverage, 48865,
     /* 2264993 */   GIR_EraseRootFromParent_Done,
     /* 2264994 */ // Label 30412: @2264994
     /* 2264994 */ GIM_Try, /*On fail goto*//*Label 30413*/ GIMT_Encode4(2265042), // Rule ID 48900 //
     /* 2264999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265012 */   // MIs[0] Operand 1
     /* 2265012 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265021 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265025 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265030 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265032 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265040 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265041 */   // GIR_Coverage, 48900,
     /* 2265041 */   GIR_EraseRootFromParent_Done,
     /* 2265042 */ // Label 30413: @2265042
     /* 2265042 */ GIM_Try, /*On fail goto*//*Label 30414*/ GIMT_Encode4(2265090), // Rule ID 48901 //
     /* 2265047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2265053 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2265056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265060 */   // MIs[0] Operand 1
     /* 2265060 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265069 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265073 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2265076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265078 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265080 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265089 */   // GIR_Coverage, 48901,
     /* 2265089 */   GIR_EraseRootFromParent_Done,
     /* 2265090 */ // Label 30414: @2265090
     /* 2265090 */ GIM_Try, /*On fail goto*//*Label 30415*/ GIMT_Encode4(2265138), // Rule ID 48908 //
     /* 2265095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265108 */   // MIs[0] Operand 1
     /* 2265108 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265117 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265121 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2265121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265126 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265128 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265136 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265137 */   // GIR_Coverage, 48908,
     /* 2265137 */   GIR_EraseRootFromParent_Done,
     /* 2265138 */ // Label 30415: @2265138
     /* 2265138 */ GIM_Try, /*On fail goto*//*Label 30416*/ GIMT_Encode4(2265186), // Rule ID 48909 //
     /* 2265143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2265149 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2265152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265156 */   // MIs[0] Operand 1
     /* 2265156 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265165 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265169 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2265169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265174 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265176 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265184 */   GIR_RootConstrainSelectedInstOperands,
     /* 2265185 */   // GIR_Coverage, 48909,
     /* 2265185 */   GIR_EraseRootFromParent_Done,
     /* 2265186 */ // Label 30416: @2265186
     /* 2265186 */ GIM_Reject,
     /* 2265187 */ // Label 29901: @2265187
     /* 2265187 */ GIM_Try, /*On fail goto*//*Label 30417*/ GIMT_Encode4(2265963),
     /* 2265192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2265195 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2265198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265202 */   GIM_Try, /*On fail goto*//*Label 30418*/ GIMT_Encode4(2265240), // Rule ID 48508 //
     /* 2265207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265210 */     // MIs[0] Operand 1
     /* 2265210 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2265215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265223 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2265226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265239 */     // GIR_Coverage, 48508,
     /* 2265239 */     GIR_EraseRootFromParent_Done,
     /* 2265240 */   // Label 30418: @2265240
     /* 2265240 */   GIM_Try, /*On fail goto*//*Label 30419*/ GIMT_Encode4(2265278), // Rule ID 48509 //
     /* 2265245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265248 */     // MIs[0] Operand 1
     /* 2265248 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2265253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265261 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2265264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265277 */     // GIR_Coverage, 48509,
     /* 2265277 */     GIR_EraseRootFromParent_Done,
     /* 2265278 */   // Label 30419: @2265278
     /* 2265278 */   GIM_Try, /*On fail goto*//*Label 30420*/ GIMT_Encode4(2265316), // Rule ID 48552 //
     /* 2265283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265286 */     // MIs[0] Operand 1
     /* 2265286 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2265291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265299 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2265302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265315 */     // GIR_Coverage, 48552,
     /* 2265315 */     GIR_EraseRootFromParent_Done,
     /* 2265316 */   // Label 30420: @2265316
     /* 2265316 */   GIM_Try, /*On fail goto*//*Label 30421*/ GIMT_Encode4(2265354), // Rule ID 48553 //
     /* 2265321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265324 */     // MIs[0] Operand 1
     /* 2265324 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2265329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265337 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2265340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265353 */     // GIR_Coverage, 48553,
     /* 2265353 */     GIR_EraseRootFromParent_Done,
     /* 2265354 */   // Label 30421: @2265354
     /* 2265354 */   GIM_Try, /*On fail goto*//*Label 30422*/ GIMT_Encode4(2265392), // Rule ID 48596 //
     /* 2265359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265362 */     // MIs[0] Operand 1
     /* 2265362 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2265367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265375 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265391 */     // GIR_Coverage, 48596,
     /* 2265391 */     GIR_EraseRootFromParent_Done,
     /* 2265392 */   // Label 30422: @2265392
     /* 2265392 */   GIM_Try, /*On fail goto*//*Label 30423*/ GIMT_Encode4(2265430), // Rule ID 48597 //
     /* 2265397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265400 */     // MIs[0] Operand 1
     /* 2265400 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2265405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265413 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265429 */     // GIR_Coverage, 48597,
     /* 2265429 */     GIR_EraseRootFromParent_Done,
     /* 2265430 */   // Label 30423: @2265430
     /* 2265430 */   GIM_Try, /*On fail goto*//*Label 30424*/ GIMT_Encode4(2265468), // Rule ID 48638 //
     /* 2265435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265438 */     // MIs[0] Operand 1
     /* 2265438 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265451 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265467 */     // GIR_Coverage, 48638,
     /* 2265467 */     GIR_EraseRootFromParent_Done,
     /* 2265468 */   // Label 30424: @2265468
     /* 2265468 */   GIM_Try, /*On fail goto*//*Label 30425*/ GIMT_Encode4(2265506), // Rule ID 48639 //
     /* 2265473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265476 */     // MIs[0] Operand 1
     /* 2265476 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2265481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265489 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2265492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265505 */     // GIR_Coverage, 48639,
     /* 2265505 */     GIR_EraseRootFromParent_Done,
     /* 2265506 */   // Label 30425: @2265506
     /* 2265506 */   GIM_Try, /*On fail goto*//*Label 30426*/ GIMT_Encode4(2265544), // Rule ID 48682 //
     /* 2265511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265514 */     // MIs[0] Operand 1
     /* 2265514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265527 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265543 */     // GIR_Coverage, 48682,
     /* 2265543 */     GIR_EraseRootFromParent_Done,
     /* 2265544 */   // Label 30426: @2265544
     /* 2265544 */   GIM_Try, /*On fail goto*//*Label 30427*/ GIMT_Encode4(2265582), // Rule ID 48683 //
     /* 2265549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265552 */     // MIs[0] Operand 1
     /* 2265552 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2265557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265565 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265581 */     // GIR_Coverage, 48683,
     /* 2265581 */     GIR_EraseRootFromParent_Done,
     /* 2265582 */   // Label 30427: @2265582
     /* 2265582 */   GIM_Try, /*On fail goto*//*Label 30428*/ GIMT_Encode4(2265620), // Rule ID 48726 //
     /* 2265587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265590 */     // MIs[0] Operand 1
     /* 2265590 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265603 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265619 */     // GIR_Coverage, 48726,
     /* 2265619 */     GIR_EraseRootFromParent_Done,
     /* 2265620 */   // Label 30428: @2265620
     /* 2265620 */   GIM_Try, /*On fail goto*//*Label 30429*/ GIMT_Encode4(2265658), // Rule ID 48727 //
     /* 2265625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265628 */     // MIs[0] Operand 1
     /* 2265628 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2265633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265641 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2265644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265657 */     // GIR_Coverage, 48727,
     /* 2265657 */     GIR_EraseRootFromParent_Done,
     /* 2265658 */   // Label 30429: @2265658
     /* 2265658 */   GIM_Try, /*On fail goto*//*Label 30430*/ GIMT_Encode4(2265696), // Rule ID 48770 //
     /* 2265663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265666 */     // MIs[0] Operand 1
     /* 2265666 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265679 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265695 */     // GIR_Coverage, 48770,
     /* 2265695 */     GIR_EraseRootFromParent_Done,
     /* 2265696 */   // Label 30430: @2265696
     /* 2265696 */   GIM_Try, /*On fail goto*//*Label 30431*/ GIMT_Encode4(2265734), // Rule ID 48771 //
     /* 2265701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265704 */     // MIs[0] Operand 1
     /* 2265704 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2265709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265717 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265733 */     // GIR_Coverage, 48771,
     /* 2265733 */     GIR_EraseRootFromParent_Done,
     /* 2265734 */   // Label 30431: @2265734
     /* 2265734 */   GIM_Try, /*On fail goto*//*Label 30432*/ GIMT_Encode4(2265772), // Rule ID 48814 //
     /* 2265739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265742 */     // MIs[0] Operand 1
     /* 2265742 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265755 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265771 */     // GIR_Coverage, 48814,
     /* 2265771 */     GIR_EraseRootFromParent_Done,
     /* 2265772 */   // Label 30432: @2265772
     /* 2265772 */   GIM_Try, /*On fail goto*//*Label 30433*/ GIMT_Encode4(2265810), // Rule ID 48815 //
     /* 2265777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265780 */     // MIs[0] Operand 1
     /* 2265780 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2265785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265793 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2265796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265809 */     // GIR_Coverage, 48815,
     /* 2265809 */     GIR_EraseRootFromParent_Done,
     /* 2265810 */   // Label 30433: @2265810
     /* 2265810 */   GIM_Try, /*On fail goto*//*Label 30434*/ GIMT_Encode4(2265848), // Rule ID 48858 //
     /* 2265815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265818 */     // MIs[0] Operand 1
     /* 2265818 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265831 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265847 */     // GIR_Coverage, 48858,
     /* 2265847 */     GIR_EraseRootFromParent_Done,
     /* 2265848 */   // Label 30434: @2265848
     /* 2265848 */   GIM_Try, /*On fail goto*//*Label 30435*/ GIMT_Encode4(2265886), // Rule ID 48859 //
     /* 2265853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265856 */     // MIs[0] Operand 1
     /* 2265856 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2265861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265869 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2265876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2265878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265885 */     // GIR_Coverage, 48859,
     /* 2265885 */     GIR_EraseRootFromParent_Done,
     /* 2265886 */   // Label 30435: @2265886
     /* 2265886 */   GIM_Try, /*On fail goto*//*Label 30436*/ GIMT_Encode4(2265924), // Rule ID 48902 //
     /* 2265891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265894 */     // MIs[0] Operand 1
     /* 2265894 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265907 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265923 */     // GIR_Coverage, 48902,
     /* 2265923 */     GIR_EraseRootFromParent_Done,
     /* 2265924 */   // Label 30436: @2265924
     /* 2265924 */   GIM_Try, /*On fail goto*//*Label 30437*/ GIMT_Encode4(2265962), // Rule ID 48903 //
     /* 2265929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265932 */     // MIs[0] Operand 1
     /* 2265932 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2265937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265945 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2265948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2265952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265961 */     // GIR_Coverage, 48903,
     /* 2265961 */     GIR_EraseRootFromParent_Done,
     /* 2265962 */   // Label 30437: @2265962
     /* 2265962 */   GIM_Reject,
     /* 2265963 */ // Label 30417: @2265963
     /* 2265963 */ GIM_Reject,
     /* 2265964 */ // Label 29902: @2265964
     /* 2265964 */ GIM_Reject,
     /* 2265965 */ // Label 49: @2265965
     /* 2265965 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(30), /*)*//*default:*//*Label 30446*/ GIMT_Encode4(2273426),
     /* 2265976 */ /*GILLT_s32*//*Label 30438*/ GIMT_Encode4(2266084),
     /* 2265980 */ /*GILLT_s64*//*Label 30439*/ GIMT_Encode4(2266841),
     /* 2265984 */ /*GILLT_nxv1s1*//*Label 30440*/ GIMT_Encode4(2267724), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266004 */ /*GILLT_nxv2s1*//*Label 30441*/ GIMT_Encode4(2268877), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266024 */ /*GILLT_nxv4s1*//*Label 30442*/ GIMT_Encode4(2270030), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266044 */ /*GILLT_nxv8s1*//*Label 30443*/ GIMT_Encode4(2271183), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266064 */ /*GILLT_nxv16s1*//*Label 30444*/ GIMT_Encode4(2272336), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2266080 */ /*GILLT_nxv32s1*//*Label 30445*/ GIMT_Encode4(2273105),
     /* 2266084 */ // Label 30438: @2266084
     /* 2266084 */ GIM_Try, /*On fail goto*//*Label 30447*/ GIMT_Encode4(2266126), // Rule ID 1362 //
     /* 2266089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2266092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266095 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266102 */   // MIs[0] Operand 1
     /* 2266102 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266111 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266115 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2266118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266120 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266122 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266124 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266125 */   // GIR_Coverage, 1362,
     /* 2266125 */   GIR_EraseRootFromParent_Done,
     /* 2266126 */ // Label 30447: @2266126
     /* 2266126 */ GIM_Try, /*On fail goto*//*Label 30448*/ GIMT_Encode4(2266168), // Rule ID 1366 //
     /* 2266131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2266134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266144 */   // MIs[0] Operand 1
     /* 2266144 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266153 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266157 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2266160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266162 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266164 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266167 */   // GIR_Coverage, 1366,
     /* 2266167 */   GIR_EraseRootFromParent_Done,
     /* 2266168 */ // Label 30448: @2266168
     /* 2266168 */ GIM_Try, /*On fail goto*//*Label 30449*/ GIMT_Encode4(2266210), // Rule ID 1410 //
     /* 2266173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2266176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266186 */   // MIs[0] Operand 1
     /* 2266186 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266195 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266199 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2266202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266204 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266206 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266208 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266209 */   // GIR_Coverage, 1410,
     /* 2266209 */   GIR_EraseRootFromParent_Done,
     /* 2266210 */ // Label 30449: @2266210
     /* 2266210 */ GIM_Try, /*On fail goto*//*Label 30450*/ GIMT_Encode4(2266252), // Rule ID 1414 //
     /* 2266215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2266218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266221 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266228 */   // MIs[0] Operand 1
     /* 2266228 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266237 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266241 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2266244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266246 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266248 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266251 */   // GIR_Coverage, 1414,
     /* 2266251 */   GIR_EraseRootFromParent_Done,
     /* 2266252 */ // Label 30450: @2266252
     /* 2266252 */ GIM_Try, /*On fail goto*//*Label 30451*/ GIMT_Encode4(2266294), // Rule ID 1426 //
     /* 2266257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2266260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266270 */   // MIs[0] Operand 1
     /* 2266270 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266279 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266283 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2266286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266288 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266290 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266292 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266293 */   // GIR_Coverage, 1426,
     /* 2266293 */   GIR_EraseRootFromParent_Done,
     /* 2266294 */ // Label 30451: @2266294
     /* 2266294 */ GIM_Try, /*On fail goto*//*Label 30452*/ GIMT_Encode4(2266336), // Rule ID 1430 //
     /* 2266299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2266302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266312 */   // MIs[0] Operand 1
     /* 2266312 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266321 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266325 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2266328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266330 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266332 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266335 */   // GIR_Coverage, 1430,
     /* 2266335 */   GIR_EraseRootFromParent_Done,
     /* 2266336 */ // Label 30452: @2266336
     /* 2266336 */ GIM_Try, /*On fail goto*//*Label 30453*/ GIMT_Encode4(2266378), // Rule ID 1742 //
     /* 2266341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2266344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266354 */   // MIs[0] Operand 1
     /* 2266354 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266363 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266367 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2266370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266372 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266374 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266376 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266377 */   // GIR_Coverage, 1742,
     /* 2266377 */   GIR_EraseRootFromParent_Done,
     /* 2266378 */ // Label 30453: @2266378
     /* 2266378 */ GIM_Try, /*On fail goto*//*Label 30454*/ GIMT_Encode4(2266420), // Rule ID 1746 //
     /* 2266383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2266386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266389 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266396 */   // MIs[0] Operand 1
     /* 2266396 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266401 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266405 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266409 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2266412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266414 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266416 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266418 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266419 */   // GIR_Coverage, 1746,
     /* 2266419 */   GIR_EraseRootFromParent_Done,
     /* 2266420 */ // Label 30454: @2266420
     /* 2266420 */ GIM_Try, /*On fail goto*//*Label 30455*/ GIMT_Encode4(2266462), // Rule ID 1784 //
     /* 2266425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2266428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266431 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266438 */   // MIs[0] Operand 1
     /* 2266438 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266447 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266451 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2266454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266456 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266458 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266461 */   // GIR_Coverage, 1784,
     /* 2266461 */   GIR_EraseRootFromParent_Done,
     /* 2266462 */ // Label 30455: @2266462
     /* 2266462 */ GIM_Try, /*On fail goto*//*Label 30456*/ GIMT_Encode4(2266504), // Rule ID 1792 //
     /* 2266467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2266470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266473 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266480 */   // MIs[0] Operand 1
     /* 2266480 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266489 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2266493 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2266496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266498 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266500 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266503 */   // GIR_Coverage, 1792,
     /* 2266503 */   GIR_EraseRootFromParent_Done,
     /* 2266504 */ // Label 30456: @2266504
     /* 2266504 */ GIM_Try, /*On fail goto*//*Label 30457*/ GIMT_Encode4(2266546), // Rule ID 1820 //
     /* 2266509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2266512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266522 */   // MIs[0] Operand 1
     /* 2266522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266531 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266535 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2266538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266542 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266545 */   // GIR_Coverage, 1820,
     /* 2266545 */   GIR_EraseRootFromParent_Done,
     /* 2266546 */ // Label 30457: @2266546
     /* 2266546 */ GIM_Try, /*On fail goto*//*Label 30458*/ GIMT_Encode4(2266588), // Rule ID 1828 //
     /* 2266551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2266554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2266560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266564 */   // MIs[0] Operand 1
     /* 2266564 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266573 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2266577 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2266577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2266580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266582 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266584 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266586 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266587 */   // GIR_Coverage, 1828,
     /* 2266587 */   GIR_EraseRootFromParent_Done,
     /* 2266588 */ // Label 30458: @2266588
     /* 2266588 */ GIM_Try, /*On fail goto*//*Label 30459*/ GIMT_Encode4(2266630), // Rule ID 2075 //
     /* 2266593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2266596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2266599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2266602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266606 */   // MIs[0] Operand 1
     /* 2266606 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2266615 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2266619 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2266619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2266622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266624 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266626 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266629 */   // GIR_Coverage, 2075,
     /* 2266629 */   GIR_EraseRootFromParent_Done,
     /* 2266630 */ // Label 30459: @2266630
     /* 2266630 */ GIM_Try, /*On fail goto*//*Label 30460*/ GIMT_Encode4(2266672), // Rule ID 2079 //
     /* 2266635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2266638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2266641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2266644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266648 */   // MIs[0] Operand 1
     /* 2266648 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2266657 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2266661 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2266661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2266664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266666 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266671 */   // GIR_Coverage, 2079,
     /* 2266671 */   GIR_EraseRootFromParent_Done,
     /* 2266672 */ // Label 30460: @2266672
     /* 2266672 */ GIM_Try, /*On fail goto*//*Label 30461*/ GIMT_Encode4(2266714), // Rule ID 2123 //
     /* 2266677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2266680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2266683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2266686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266690 */   // MIs[0] Operand 1
     /* 2266690 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2266699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2266703 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2266703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2266706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266708 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266710 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266713 */   // GIR_Coverage, 2123,
     /* 2266713 */   GIR_EraseRootFromParent_Done,
     /* 2266714 */ // Label 30461: @2266714
     /* 2266714 */ GIM_Try, /*On fail goto*//*Label 30462*/ GIMT_Encode4(2266756), // Rule ID 2127 //
     /* 2266719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2266722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2266725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2266728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266732 */   // MIs[0] Operand 1
     /* 2266732 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266737 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2266741 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2266745 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2266745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2266748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266750 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266752 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266754 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266755 */   // GIR_Coverage, 2127,
     /* 2266755 */   GIR_EraseRootFromParent_Done,
     /* 2266756 */ // Label 30462: @2266756
     /* 2266756 */ GIM_Try, /*On fail goto*//*Label 30463*/ GIMT_Encode4(2266798), // Rule ID 2139 //
     /* 2266761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2266764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2266767 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2266770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266774 */   // MIs[0] Operand 1
     /* 2266774 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2266783 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2266787 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2266787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2266790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266792 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266794 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266797 */   // GIR_Coverage, 2139,
     /* 2266797 */   GIR_EraseRootFromParent_Done,
     /* 2266798 */ // Label 30463: @2266798
     /* 2266798 */ GIM_Try, /*On fail goto*//*Label 30464*/ GIMT_Encode4(2266840), // Rule ID 2143 //
     /* 2266803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2266806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2266809 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2266812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266816 */   // MIs[0] Operand 1
     /* 2266816 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2266821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2266825 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2266829 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2266829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2266832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266834 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266836 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266839 */   // GIR_Coverage, 2143,
     /* 2266839 */   GIR_EraseRootFromParent_Done,
     /* 2266840 */ // Label 30464: @2266840
     /* 2266840 */ GIM_Reject,
     /* 2266841 */ // Label 30439: @2266841
     /* 2266841 */ GIM_Try, /*On fail goto*//*Label 30465*/ GIMT_Encode4(2266883), // Rule ID 1361 //
     /* 2266846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2266849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266852 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266859 */   // MIs[0] Operand 1
     /* 2266859 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266868 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266872 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2266875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266877 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266879 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266881 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266882 */   // GIR_Coverage, 1361,
     /* 2266882 */   GIR_EraseRootFromParent_Done,
     /* 2266883 */ // Label 30465: @2266883
     /* 2266883 */ GIM_Try, /*On fail goto*//*Label 30466*/ GIMT_Encode4(2266925), // Rule ID 1365 //
     /* 2266888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2266891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266894 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266901 */   // MIs[0] Operand 1
     /* 2266901 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2266906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266910 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266914 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2266917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266919 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266921 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266924 */   // GIR_Coverage, 1365,
     /* 2266924 */   GIR_EraseRootFromParent_Done,
     /* 2266925 */ // Label 30466: @2266925
     /* 2266925 */ GIM_Try, /*On fail goto*//*Label 30467*/ GIMT_Encode4(2266967), // Rule ID 1409 //
     /* 2266930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2266933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266943 */   // MIs[0] Operand 1
     /* 2266943 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2266956 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2266959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266961 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2266963 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2266965 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266966 */   // GIR_Coverage, 1409,
     /* 2266966 */   GIR_EraseRootFromParent_Done,
     /* 2266967 */ // Label 30467: @2266967
     /* 2266967 */ GIM_Try, /*On fail goto*//*Label 30468*/ GIMT_Encode4(2267009), // Rule ID 1413 //
     /* 2266972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2266975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266978 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2266981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266985 */   // MIs[0] Operand 1
     /* 2266985 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2266990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266994 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2266998 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2266998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2267001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267003 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267005 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267008 */   // GIR_Coverage, 1413,
     /* 2267008 */   GIR_EraseRootFromParent_Done,
     /* 2267009 */ // Label 30468: @2267009
     /* 2267009 */ GIM_Try, /*On fail goto*//*Label 30469*/ GIMT_Encode4(2267051), // Rule ID 1425 //
     /* 2267014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2267017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267027 */   // MIs[0] Operand 1
     /* 2267027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2267040 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2267043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267045 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267047 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267050 */   // GIR_Coverage, 1425,
     /* 2267050 */   GIR_EraseRootFromParent_Done,
     /* 2267051 */ // Label 30469: @2267051
     /* 2267051 */ GIM_Try, /*On fail goto*//*Label 30470*/ GIMT_Encode4(2267093), // Rule ID 1429 //
     /* 2267056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2267059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2267062 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2267065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267069 */   // MIs[0] Operand 1
     /* 2267069 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267078 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2267082 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2267082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2267085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267087 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267089 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267091 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267092 */   // GIR_Coverage, 1429,
     /* 2267092 */   GIR_EraseRootFromParent_Done,
     /* 2267093 */ // Label 30470: @2267093
     /* 2267093 */ GIM_Try, /*On fail goto*//*Label 30471*/ GIMT_Encode4(2267135), // Rule ID 1741 //
     /* 2267098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2267101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267111 */   // MIs[0] Operand 1
     /* 2267111 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267120 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267124 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2267127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267129 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267131 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267134 */   // GIR_Coverage, 1741,
     /* 2267134 */   GIR_EraseRootFromParent_Done,
     /* 2267135 */ // Label 30471: @2267135
     /* 2267135 */ GIM_Try, /*On fail goto*//*Label 30472*/ GIMT_Encode4(2267177), // Rule ID 1745 //
     /* 2267140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2267143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267153 */   // MIs[0] Operand 1
     /* 2267153 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267162 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267166 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2267169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267171 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267173 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267175 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267176 */   // GIR_Coverage, 1745,
     /* 2267176 */   GIR_EraseRootFromParent_Done,
     /* 2267177 */ // Label 30472: @2267177
     /* 2267177 */ GIM_Try, /*On fail goto*//*Label 30473*/ GIMT_Encode4(2267219), // Rule ID 1748 //
     /* 2267182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2267185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267188 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267195 */   // MIs[0] Operand 1
     /* 2267195 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267204 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267208 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_INX),
     /* 2267211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267213 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267215 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267217 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267218 */   // GIR_Coverage, 1748,
     /* 2267218 */   GIR_EraseRootFromParent_Done,
     /* 2267219 */ // Label 30473: @2267219
     /* 2267219 */ GIM_Try, /*On fail goto*//*Label 30474*/ GIMT_Encode4(2267261), // Rule ID 1783 //
     /* 2267224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2267227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267230 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267237 */   // MIs[0] Operand 1
     /* 2267237 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267246 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267250 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2267253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267255 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267257 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267260 */   // GIR_Coverage, 1783,
     /* 2267260 */   GIR_EraseRootFromParent_Done,
     /* 2267261 */ // Label 30474: @2267261
     /* 2267261 */ GIM_Try, /*On fail goto*//*Label 30475*/ GIMT_Encode4(2267303), // Rule ID 1791 //
     /* 2267266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2267269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267279 */   // MIs[0] Operand 1
     /* 2267279 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267288 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2267292 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2267295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267297 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267299 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267301 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267302 */   // GIR_Coverage, 1791,
     /* 2267302 */   GIR_EraseRootFromParent_Done,
     /* 2267303 */ // Label 30475: @2267303
     /* 2267303 */ GIM_Try, /*On fail goto*//*Label 30476*/ GIMT_Encode4(2267345), // Rule ID 1800 //
     /* 2267308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2267311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267321 */   // MIs[0] Operand 1
     /* 2267321 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267330 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267334 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_INX),
     /* 2267337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267339 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267341 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267344 */   // GIR_Coverage, 1800,
     /* 2267344 */   GIR_EraseRootFromParent_Done,
     /* 2267345 */ // Label 30476: @2267345
     /* 2267345 */ GIM_Try, /*On fail goto*//*Label 30477*/ GIMT_Encode4(2267387), // Rule ID 1804 //
     /* 2267350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2267353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267356 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267363 */   // MIs[0] Operand 1
     /* 2267363 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267372 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267376 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_INX),
     /* 2267379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267381 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267383 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267385 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267386 */   // GIR_Coverage, 1804,
     /* 2267386 */   GIR_EraseRootFromParent_Done,
     /* 2267387 */ // Label 30477: @2267387
     /* 2267387 */ GIM_Try, /*On fail goto*//*Label 30478*/ GIMT_Encode4(2267429), // Rule ID 1819 //
     /* 2267392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2267395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267405 */   // MIs[0] Operand 1
     /* 2267405 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267414 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267418 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2267421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267423 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267425 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267427 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267428 */   // GIR_Coverage, 1819,
     /* 2267428 */   GIR_EraseRootFromParent_Done,
     /* 2267429 */ // Label 30478: @2267429
     /* 2267429 */ GIM_Try, /*On fail goto*//*Label 30479*/ GIMT_Encode4(2267471), // Rule ID 1827 //
     /* 2267434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2267437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2267440 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2267443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267447 */   // MIs[0] Operand 1
     /* 2267447 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267456 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2267460 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2267460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2267463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267465 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267467 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267470 */   // GIR_Coverage, 1827,
     /* 2267470 */   GIR_EraseRootFromParent_Done,
     /* 2267471 */ // Label 30479: @2267471
     /* 2267471 */ GIM_Try, /*On fail goto*//*Label 30480*/ GIMT_Encode4(2267513), // Rule ID 2074 //
     /* 2267476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2267479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267489 */   // MIs[0] Operand 1
     /* 2267489 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267502 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2267505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267507 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267509 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267512 */   // GIR_Coverage, 2074,
     /* 2267512 */   GIR_EraseRootFromParent_Done,
     /* 2267513 */ // Label 30480: @2267513
     /* 2267513 */ GIM_Try, /*On fail goto*//*Label 30481*/ GIMT_Encode4(2267555), // Rule ID 2078 //
     /* 2267518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2267521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267524 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267531 */   // MIs[0] Operand 1
     /* 2267531 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267540 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267544 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2267547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267549 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267551 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267553 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267554 */   // GIR_Coverage, 2078,
     /* 2267554 */   GIR_EraseRootFromParent_Done,
     /* 2267555 */ // Label 30481: @2267555
     /* 2267555 */ GIM_Try, /*On fail goto*//*Label 30482*/ GIMT_Encode4(2267597), // Rule ID 2122 //
     /* 2267560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2267563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267566 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267573 */   // MIs[0] Operand 1
     /* 2267573 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267582 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267586 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2267589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267591 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267593 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267596 */   // GIR_Coverage, 2122,
     /* 2267596 */   GIR_EraseRootFromParent_Done,
     /* 2267597 */ // Label 30482: @2267597
     /* 2267597 */ GIM_Try, /*On fail goto*//*Label 30483*/ GIMT_Encode4(2267639), // Rule ID 2126 //
     /* 2267602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2267605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267615 */   // MIs[0] Operand 1
     /* 2267615 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2267620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267624 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267628 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2267631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267633 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267635 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267637 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267638 */   // GIR_Coverage, 2126,
     /* 2267638 */   GIR_EraseRootFromParent_Done,
     /* 2267639 */ // Label 30483: @2267639
     /* 2267639 */ GIM_Try, /*On fail goto*//*Label 30484*/ GIMT_Encode4(2267681), // Rule ID 2138 //
     /* 2267644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2267647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267650 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267657 */   // MIs[0] Operand 1
     /* 2267657 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267666 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2267670 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2267673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267675 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267677 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267680 */   // GIR_Coverage, 2138,
     /* 2267680 */   GIR_EraseRootFromParent_Done,
     /* 2267681 */ // Label 30484: @2267681
     /* 2267681 */ GIM_Try, /*On fail goto*//*Label 30485*/ GIMT_Encode4(2267723), // Rule ID 2142 //
     /* 2267686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2267689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2267692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2267695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2267699 */   // MIs[0] Operand 1
     /* 2267699 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2267704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267708 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2267712 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2267712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2267715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267717 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267719 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267721 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267722 */   // GIR_Coverage, 2142,
     /* 2267722 */   GIR_EraseRootFromParent_Done,
     /* 2267723 */ // Label 30485: @2267723
     /* 2267723 */ GIM_Reject,
     /* 2267724 */ // Label 30440: @2267724
     /* 2267724 */ GIM_Try, /*On fail goto*//*Label 30486*/ GIMT_Encode4(2267772), // Rule ID 57028 //
     /* 2267729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2267732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2267735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2267738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267742 */   // MIs[0] Operand 1
     /* 2267742 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267751 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267755 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2267755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2267758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267760 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267762 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267771 */   // GIR_Coverage, 57028,
     /* 2267771 */   GIR_EraseRootFromParent_Done,
     /* 2267772 */ // Label 30486: @2267772
     /* 2267772 */ GIM_Try, /*On fail goto*//*Label 30487*/ GIMT_Encode4(2267820), // Rule ID 57029 //
     /* 2267777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2267780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2267783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2267786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267790 */   // MIs[0] Operand 1
     /* 2267790 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267803 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2267803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2267806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267808 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267810 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267819 */   // GIR_Coverage, 57029,
     /* 2267819 */   GIR_EraseRootFromParent_Done,
     /* 2267820 */ // Label 30487: @2267820
     /* 2267820 */ GIM_Try, /*On fail goto*//*Label 30488*/ GIMT_Encode4(2267868), // Rule ID 57048 //
     /* 2267825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2267828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2267831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2267834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267838 */   // MIs[0] Operand 1
     /* 2267838 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267847 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267851 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2267851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2267854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267856 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267858 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267867 */   // GIR_Coverage, 57048,
     /* 2267867 */   GIR_EraseRootFromParent_Done,
     /* 2267868 */ // Label 30488: @2267868
     /* 2267868 */ GIM_Try, /*On fail goto*//*Label 30489*/ GIMT_Encode4(2267916), // Rule ID 57049 //
     /* 2267873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2267876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2267879 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2267882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267886 */   // MIs[0] Operand 1
     /* 2267886 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267895 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267899 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2267899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2267902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267904 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267906 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267914 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267915 */   // GIR_Coverage, 57049,
     /* 2267915 */   GIR_EraseRootFromParent_Done,
     /* 2267916 */ // Label 30489: @2267916
     /* 2267916 */ GIM_Try, /*On fail goto*//*Label 30490*/ GIMT_Encode4(2267964), // Rule ID 57078 //
     /* 2267921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2267924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2267927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2267930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267934 */   // MIs[0] Operand 1
     /* 2267934 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267943 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267947 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2267947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2267950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267952 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2267954 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2267956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267962 */   GIR_RootConstrainSelectedInstOperands,
     /* 2267963 */   // GIR_Coverage, 57078,
     /* 2267963 */   GIR_EraseRootFromParent_Done,
     /* 2267964 */ // Label 30490: @2267964
     /* 2267964 */ GIM_Try, /*On fail goto*//*Label 30491*/ GIMT_Encode4(2268012), // Rule ID 57079 //
     /* 2267969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2267972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2267975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2267978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267982 */   // MIs[0] Operand 1
     /* 2267982 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2267987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267991 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267995 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2267995 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2267998 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268000 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268002 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268011 */   // GIR_Coverage, 57079,
     /* 2268011 */   GIR_EraseRootFromParent_Done,
     /* 2268012 */ // Label 30491: @2268012
     /* 2268012 */ GIM_Try, /*On fail goto*//*Label 30492*/ GIMT_Encode4(2268060), // Rule ID 57328 //
     /* 2268017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268023 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268030 */   // MIs[0] Operand 1
     /* 2268030 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268039 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268043 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2268046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268048 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268050 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268059 */   // GIR_Coverage, 57328,
     /* 2268059 */   GIR_EraseRootFromParent_Done,
     /* 2268060 */ // Label 30492: @2268060
     /* 2268060 */ GIM_Try, /*On fail goto*//*Label 30493*/ GIMT_Encode4(2268108), // Rule ID 57329 //
     /* 2268065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268071 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268078 */   // MIs[0] Operand 1
     /* 2268078 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268087 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268091 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2268094 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268096 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268098 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268107 */   // GIR_Coverage, 57329,
     /* 2268107 */   GIR_EraseRootFromParent_Done,
     /* 2268108 */ // Label 30493: @2268108
     /* 2268108 */ GIM_Try, /*On fail goto*//*Label 30494*/ GIMT_Encode4(2268156), // Rule ID 57348 //
     /* 2268113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268116 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268119 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268126 */   // MIs[0] Operand 1
     /* 2268126 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268135 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268139 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2268139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2268142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268144 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268146 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268154 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268155 */   // GIR_Coverage, 57348,
     /* 2268155 */   GIR_EraseRootFromParent_Done,
     /* 2268156 */ // Label 30494: @2268156
     /* 2268156 */ GIM_Try, /*On fail goto*//*Label 30495*/ GIMT_Encode4(2268204), // Rule ID 57349 //
     /* 2268161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2268164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268167 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268174 */   // MIs[0] Operand 1
     /* 2268174 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268183 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268187 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2268187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2268190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268192 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268194 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268202 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268203 */   // GIR_Coverage, 57349,
     /* 2268203 */   GIR_EraseRootFromParent_Done,
     /* 2268204 */ // Label 30495: @2268204
     /* 2268204 */ GIM_Try, /*On fail goto*//*Label 30496*/ GIMT_Encode4(2268252), // Rule ID 57378 //
     /* 2268209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2268212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268215 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268222 */   // MIs[0] Operand 1
     /* 2268222 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268227 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268231 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268235 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2268235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2268238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268240 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268242 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268251 */   // GIR_Coverage, 57378,
     /* 2268251 */   GIR_EraseRootFromParent_Done,
     /* 2268252 */ // Label 30496: @2268252
     /* 2268252 */ GIM_Try, /*On fail goto*//*Label 30497*/ GIMT_Encode4(2268300), // Rule ID 57379 //
     /* 2268257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2268260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268263 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268270 */   // MIs[0] Operand 1
     /* 2268270 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2268275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268279 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268283 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2268283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2268286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268288 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268290 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268298 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268299 */   // GIR_Coverage, 57379,
     /* 2268299 */   GIR_EraseRootFromParent_Done,
     /* 2268300 */ // Label 30497: @2268300
     /* 2268300 */ GIM_Try, /*On fail goto*//*Label 30498*/ GIMT_Encode4(2268348), // Rule ID 57628 //
     /* 2268305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268318 */   // MIs[0] Operand 1
     /* 2268318 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268327 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268331 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2268334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268336 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268338 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268347 */   // GIR_Coverage, 57628,
     /* 2268347 */   GIR_EraseRootFromParent_Done,
     /* 2268348 */ // Label 30498: @2268348
     /* 2268348 */ GIM_Try, /*On fail goto*//*Label 30499*/ GIMT_Encode4(2268396), // Rule ID 57629 //
     /* 2268353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268366 */   // MIs[0] Operand 1
     /* 2268366 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268375 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268379 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2268382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268384 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268386 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268395 */   // GIR_Coverage, 57629,
     /* 2268395 */   GIR_EraseRootFromParent_Done,
     /* 2268396 */ // Label 30499: @2268396
     /* 2268396 */ GIM_Try, /*On fail goto*//*Label 30500*/ GIMT_Encode4(2268444), // Rule ID 57648 //
     /* 2268401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268414 */   // MIs[0] Operand 1
     /* 2268414 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268423 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268427 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2268427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2268430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268432 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268434 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268442 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268443 */   // GIR_Coverage, 57648,
     /* 2268443 */   GIR_EraseRootFromParent_Done,
     /* 2268444 */ // Label 30500: @2268444
     /* 2268444 */ GIM_Try, /*On fail goto*//*Label 30501*/ GIMT_Encode4(2268492), // Rule ID 57649 //
     /* 2268449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2268452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268455 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268462 */   // MIs[0] Operand 1
     /* 2268462 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268471 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268475 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2268475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2268478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268480 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268482 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268491 */   // GIR_Coverage, 57649,
     /* 2268491 */   GIR_EraseRootFromParent_Done,
     /* 2268492 */ // Label 30501: @2268492
     /* 2268492 */ GIM_Try, /*On fail goto*//*Label 30502*/ GIMT_Encode4(2268540), // Rule ID 57678 //
     /* 2268497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2268500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268503 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268510 */   // MIs[0] Operand 1
     /* 2268510 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268519 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268523 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2268523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2268526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268528 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268530 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268539 */   // GIR_Coverage, 57678,
     /* 2268539 */   GIR_EraseRootFromParent_Done,
     /* 2268540 */ // Label 30502: @2268540
     /* 2268540 */ GIM_Try, /*On fail goto*//*Label 30503*/ GIMT_Encode4(2268588), // Rule ID 57679 //
     /* 2268545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2268548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268551 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268558 */   // MIs[0] Operand 1
     /* 2268558 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2268563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268567 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268571 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2268571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2268574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268576 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268578 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268586 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268587 */   // GIR_Coverage, 57679,
     /* 2268587 */   GIR_EraseRootFromParent_Done,
     /* 2268588 */ // Label 30503: @2268588
     /* 2268588 */ GIM_Try, /*On fail goto*//*Label 30504*/ GIMT_Encode4(2268636), // Rule ID 57928 //
     /* 2268593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268606 */   // MIs[0] Operand 1
     /* 2268606 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268611 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268615 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268619 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2268622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268624 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268626 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268634 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268635 */   // GIR_Coverage, 57928,
     /* 2268635 */   GIR_EraseRootFromParent_Done,
     /* 2268636 */ // Label 30504: @2268636
     /* 2268636 */ GIM_Try, /*On fail goto*//*Label 30505*/ GIMT_Encode4(2268684), // Rule ID 57929 //
     /* 2268641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2268647 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2268650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268654 */   // MIs[0] Operand 1
     /* 2268654 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268663 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268667 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2268670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268672 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268674 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268683 */   // GIR_Coverage, 57929,
     /* 2268683 */   GIR_EraseRootFromParent_Done,
     /* 2268684 */ // Label 30505: @2268684
     /* 2268684 */ GIM_Try, /*On fail goto*//*Label 30506*/ GIMT_Encode4(2268732), // Rule ID 57948 //
     /* 2268689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268695 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268702 */   // MIs[0] Operand 1
     /* 2268702 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268707 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268711 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268715 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2268715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2268718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268720 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268722 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268731 */   // GIR_Coverage, 57948,
     /* 2268731 */   GIR_EraseRootFromParent_Done,
     /* 2268732 */ // Label 30506: @2268732
     /* 2268732 */ GIM_Try, /*On fail goto*//*Label 30507*/ GIMT_Encode4(2268780), // Rule ID 57949 //
     /* 2268737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2268740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2268743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2268746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268750 */   // MIs[0] Operand 1
     /* 2268750 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268759 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268763 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2268763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2268766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268768 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268770 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268778 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268779 */   // GIR_Coverage, 57949,
     /* 2268779 */   GIR_EraseRootFromParent_Done,
     /* 2268780 */ // Label 30507: @2268780
     /* 2268780 */ GIM_Try, /*On fail goto*//*Label 30508*/ GIMT_Encode4(2268828), // Rule ID 57978 //
     /* 2268785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2268788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268791 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268798 */   // MIs[0] Operand 1
     /* 2268798 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268807 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268811 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2268811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2268814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268816 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268818 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268827 */   // GIR_Coverage, 57978,
     /* 2268827 */   GIR_EraseRootFromParent_Done,
     /* 2268828 */ // Label 30508: @2268828
     /* 2268828 */ GIM_Try, /*On fail goto*//*Label 30509*/ GIMT_Encode4(2268876), // Rule ID 57979 //
     /* 2268833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2268836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2268839 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2268842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268846 */   // MIs[0] Operand 1
     /* 2268846 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2268851 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268855 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268859 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2268859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2268862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268864 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268866 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268874 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268875 */   // GIR_Coverage, 57979,
     /* 2268875 */   GIR_EraseRootFromParent_Done,
     /* 2268876 */ // Label 30509: @2268876
     /* 2268876 */ GIM_Reject,
     /* 2268877 */ // Label 30441: @2268877
     /* 2268877 */ GIM_Try, /*On fail goto*//*Label 30510*/ GIMT_Encode4(2268925), // Rule ID 57038 //
     /* 2268882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2268885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2268888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2268891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268895 */   // MIs[0] Operand 1
     /* 2268895 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268904 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268908 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2268908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2268911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268913 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268915 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268924 */   // GIR_Coverage, 57038,
     /* 2268924 */   GIR_EraseRootFromParent_Done,
     /* 2268925 */ // Label 30510: @2268925
     /* 2268925 */ GIM_Try, /*On fail goto*//*Label 30511*/ GIMT_Encode4(2268973), // Rule ID 57039 //
     /* 2268930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2268933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2268936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2268939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268943 */   // MIs[0] Operand 1
     /* 2268943 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268956 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2268956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2268959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268961 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2268963 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2268965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2268972 */   // GIR_Coverage, 57039,
     /* 2268972 */   GIR_EraseRootFromParent_Done,
     /* 2268973 */ // Label 30511: @2268973
     /* 2268973 */ GIM_Try, /*On fail goto*//*Label 30512*/ GIMT_Encode4(2269021), // Rule ID 57068 //
     /* 2268978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2268981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2268984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2268987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268991 */   // MIs[0] Operand 1
     /* 2268991 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2268996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269000 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269004 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2269007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269009 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269011 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269020 */   // GIR_Coverage, 57068,
     /* 2269020 */   GIR_EraseRootFromParent_Done,
     /* 2269021 */ // Label 30512: @2269021
     /* 2269021 */ GIM_Try, /*On fail goto*//*Label 30513*/ GIMT_Encode4(2269069), // Rule ID 57069 //
     /* 2269026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269039 */   // MIs[0] Operand 1
     /* 2269039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269052 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2269055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269057 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269068 */   // GIR_Coverage, 57069,
     /* 2269068 */   GIR_EraseRootFromParent_Done,
     /* 2269069 */ // Label 30513: @2269069
     /* 2269069 */ GIM_Try, /*On fail goto*//*Label 30514*/ GIMT_Encode4(2269117), // Rule ID 57148 //
     /* 2269074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269087 */   // MIs[0] Operand 1
     /* 2269087 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269096 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269100 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2269103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269105 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269107 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269116 */   // GIR_Coverage, 57148,
     /* 2269116 */   GIR_EraseRootFromParent_Done,
     /* 2269117 */ // Label 30514: @2269117
     /* 2269117 */ GIM_Try, /*On fail goto*//*Label 30515*/ GIMT_Encode4(2269165), // Rule ID 57149 //
     /* 2269122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269135 */   // MIs[0] Operand 1
     /* 2269135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2269140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269144 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269148 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2269151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269153 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269155 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269164 */   // GIR_Coverage, 57149,
     /* 2269164 */   GIR_EraseRootFromParent_Done,
     /* 2269165 */ // Label 30515: @2269165
     /* 2269165 */ GIM_Try, /*On fail goto*//*Label 30516*/ GIMT_Encode4(2269213), // Rule ID 57338 //
     /* 2269170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269183 */   // MIs[0] Operand 1
     /* 2269183 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269192 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269196 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2269199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269201 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269203 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269212 */   // GIR_Coverage, 57338,
     /* 2269212 */   GIR_EraseRootFromParent_Done,
     /* 2269213 */ // Label 30516: @2269213
     /* 2269213 */ GIM_Try, /*On fail goto*//*Label 30517*/ GIMT_Encode4(2269261), // Rule ID 57339 //
     /* 2269218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269231 */   // MIs[0] Operand 1
     /* 2269231 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269240 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269244 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2269247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269249 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269251 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269260 */   // GIR_Coverage, 57339,
     /* 2269260 */   GIR_EraseRootFromParent_Done,
     /* 2269261 */ // Label 30517: @2269261
     /* 2269261 */ GIM_Try, /*On fail goto*//*Label 30518*/ GIMT_Encode4(2269309), // Rule ID 57368 //
     /* 2269266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269279 */   // MIs[0] Operand 1
     /* 2269279 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269288 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269292 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2269295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269297 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269299 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269308 */   // GIR_Coverage, 57368,
     /* 2269308 */   GIR_EraseRootFromParent_Done,
     /* 2269309 */ // Label 30518: @2269309
     /* 2269309 */ GIM_Try, /*On fail goto*//*Label 30519*/ GIMT_Encode4(2269357), // Rule ID 57369 //
     /* 2269314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269327 */   // MIs[0] Operand 1
     /* 2269327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269340 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2269343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269345 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269347 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269356 */   // GIR_Coverage, 57369,
     /* 2269356 */   GIR_EraseRootFromParent_Done,
     /* 2269357 */ // Label 30519: @2269357
     /* 2269357 */ GIM_Try, /*On fail goto*//*Label 30520*/ GIMT_Encode4(2269405), // Rule ID 57448 //
     /* 2269362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269375 */   // MIs[0] Operand 1
     /* 2269375 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269384 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269388 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2269391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269393 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269395 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269404 */   // GIR_Coverage, 57448,
     /* 2269404 */   GIR_EraseRootFromParent_Done,
     /* 2269405 */ // Label 30520: @2269405
     /* 2269405 */ GIM_Try, /*On fail goto*//*Label 30521*/ GIMT_Encode4(2269453), // Rule ID 57449 //
     /* 2269410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269423 */   // MIs[0] Operand 1
     /* 2269423 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2269428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269436 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2269439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269441 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269443 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269452 */   // GIR_Coverage, 57449,
     /* 2269452 */   GIR_EraseRootFromParent_Done,
     /* 2269453 */ // Label 30521: @2269453
     /* 2269453 */ GIM_Try, /*On fail goto*//*Label 30522*/ GIMT_Encode4(2269501), // Rule ID 57638 //
     /* 2269458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269471 */   // MIs[0] Operand 1
     /* 2269471 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269480 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269484 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2269487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269489 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269491 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269500 */   // GIR_Coverage, 57638,
     /* 2269500 */   GIR_EraseRootFromParent_Done,
     /* 2269501 */ // Label 30522: @2269501
     /* 2269501 */ GIM_Try, /*On fail goto*//*Label 30523*/ GIMT_Encode4(2269549), // Rule ID 57639 //
     /* 2269506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269519 */   // MIs[0] Operand 1
     /* 2269519 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269528 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269532 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2269535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269537 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269539 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269548 */   // GIR_Coverage, 57639,
     /* 2269548 */   GIR_EraseRootFromParent_Done,
     /* 2269549 */ // Label 30523: @2269549
     /* 2269549 */ GIM_Try, /*On fail goto*//*Label 30524*/ GIMT_Encode4(2269597), // Rule ID 57668 //
     /* 2269554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269560 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269567 */   // MIs[0] Operand 1
     /* 2269567 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269576 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269580 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2269583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269585 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269587 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269596 */   // GIR_Coverage, 57668,
     /* 2269596 */   GIR_EraseRootFromParent_Done,
     /* 2269597 */ // Label 30524: @2269597
     /* 2269597 */ GIM_Try, /*On fail goto*//*Label 30525*/ GIMT_Encode4(2269645), // Rule ID 57669 //
     /* 2269602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269615 */   // MIs[0] Operand 1
     /* 2269615 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269624 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269628 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2269631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269633 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269635 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269644 */   // GIR_Coverage, 57669,
     /* 2269644 */   GIR_EraseRootFromParent_Done,
     /* 2269645 */ // Label 30525: @2269645
     /* 2269645 */ GIM_Try, /*On fail goto*//*Label 30526*/ GIMT_Encode4(2269693), // Rule ID 57748 //
     /* 2269650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269663 */   // MIs[0] Operand 1
     /* 2269663 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269676 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2269679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269681 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269683 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269692 */   // GIR_Coverage, 57748,
     /* 2269692 */   GIR_EraseRootFromParent_Done,
     /* 2269693 */ // Label 30526: @2269693
     /* 2269693 */ GIM_Try, /*On fail goto*//*Label 30527*/ GIMT_Encode4(2269741), // Rule ID 57749 //
     /* 2269698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269704 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269711 */   // MIs[0] Operand 1
     /* 2269711 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2269716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269720 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269724 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2269724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2269727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269729 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269731 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269740 */   // GIR_Coverage, 57749,
     /* 2269740 */   GIR_EraseRootFromParent_Done,
     /* 2269741 */ // Label 30527: @2269741
     /* 2269741 */ GIM_Try, /*On fail goto*//*Label 30528*/ GIMT_Encode4(2269789), // Rule ID 57938 //
     /* 2269746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2269749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269752 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269759 */   // MIs[0] Operand 1
     /* 2269759 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269768 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269772 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2269772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2269775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269777 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269779 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269787 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269788 */   // GIR_Coverage, 57938,
     /* 2269788 */   GIR_EraseRootFromParent_Done,
     /* 2269789 */ // Label 30528: @2269789
     /* 2269789 */ GIM_Try, /*On fail goto*//*Label 30529*/ GIMT_Encode4(2269837), // Rule ID 57939 //
     /* 2269794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2269797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2269800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2269803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269807 */   // MIs[0] Operand 1
     /* 2269807 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269816 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269820 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2269820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2269823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269825 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269827 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269836 */   // GIR_Coverage, 57939,
     /* 2269836 */   GIR_EraseRootFromParent_Done,
     /* 2269837 */ // Label 30529: @2269837
     /* 2269837 */ GIM_Try, /*On fail goto*//*Label 30530*/ GIMT_Encode4(2269885), // Rule ID 57968 //
     /* 2269842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2269845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269848 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269855 */   // MIs[0] Operand 1
     /* 2269855 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269864 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269868 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2269868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2269871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269873 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269875 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269884 */   // GIR_Coverage, 57968,
     /* 2269884 */   GIR_EraseRootFromParent_Done,
     /* 2269885 */ // Label 30530: @2269885
     /* 2269885 */ GIM_Try, /*On fail goto*//*Label 30531*/ GIMT_Encode4(2269933), // Rule ID 57969 //
     /* 2269890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2269893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2269896 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2269899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269903 */   // MIs[0] Operand 1
     /* 2269903 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269912 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269916 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2269916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2269919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269921 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269923 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269932 */   // GIR_Coverage, 57969,
     /* 2269932 */   GIR_EraseRootFromParent_Done,
     /* 2269933 */ // Label 30531: @2269933
     /* 2269933 */ GIM_Try, /*On fail goto*//*Label 30532*/ GIMT_Encode4(2269981), // Rule ID 58048 //
     /* 2269938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2269941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269951 */   // MIs[0] Operand 1
     /* 2269951 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2269956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269960 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2269964 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2269964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2269967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269969 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2269971 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2269973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269979 */   GIR_RootConstrainSelectedInstOperands,
     /* 2269980 */   // GIR_Coverage, 58048,
     /* 2269980 */   GIR_EraseRootFromParent_Done,
     /* 2269981 */ // Label 30532: @2269981
     /* 2269981 */ GIM_Try, /*On fail goto*//*Label 30533*/ GIMT_Encode4(2270029), // Rule ID 58049 //
     /* 2269986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2269989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2269992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2269995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269999 */   // MIs[0] Operand 1
     /* 2269999 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270008 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270012 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2270015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270017 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270019 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270028 */   // GIR_Coverage, 58049,
     /* 2270028 */   GIR_EraseRootFromParent_Done,
     /* 2270029 */ // Label 30533: @2270029
     /* 2270029 */ GIM_Reject,
     /* 2270030 */ // Label 30442: @2270030
     /* 2270030 */ GIM_Try, /*On fail goto*//*Label 30534*/ GIMT_Encode4(2270078), // Rule ID 57058 //
     /* 2270035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270048 */   // MIs[0] Operand 1
     /* 2270048 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270057 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270061 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2270064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270066 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270077 */   // GIR_Coverage, 57058,
     /* 2270077 */   GIR_EraseRootFromParent_Done,
     /* 2270078 */ // Label 30534: @2270078
     /* 2270078 */ GIM_Try, /*On fail goto*//*Label 30535*/ GIMT_Encode4(2270126), // Rule ID 57059 //
     /* 2270083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270089 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270096 */   // MIs[0] Operand 1
     /* 2270096 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270105 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270109 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2270112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270114 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270116 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270124 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270125 */   // GIR_Coverage, 57059,
     /* 2270125 */   GIR_EraseRootFromParent_Done,
     /* 2270126 */ // Label 30535: @2270126
     /* 2270126 */ GIM_Try, /*On fail goto*//*Label 30536*/ GIMT_Encode4(2270174), // Rule ID 57118 //
     /* 2270131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270144 */   // MIs[0] Operand 1
     /* 2270144 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270153 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270157 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2270160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270162 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270164 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270173 */   // GIR_Coverage, 57118,
     /* 2270173 */   GIR_EraseRootFromParent_Done,
     /* 2270174 */ // Label 30536: @2270174
     /* 2270174 */ GIM_Try, /*On fail goto*//*Label 30537*/ GIMT_Encode4(2270222), // Rule ID 57119 //
     /* 2270179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270192 */   // MIs[0] Operand 1
     /* 2270192 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270205 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2270208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270212 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270221 */   // GIR_Coverage, 57119,
     /* 2270221 */   GIR_EraseRootFromParent_Done,
     /* 2270222 */ // Label 30537: @2270222
     /* 2270222 */ GIM_Try, /*On fail goto*//*Label 30538*/ GIMT_Encode4(2270270), // Rule ID 57158 //
     /* 2270227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270240 */   // MIs[0] Operand 1
     /* 2270240 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270249 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270253 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2270256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270258 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270260 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270268 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270269 */   // GIR_Coverage, 57158,
     /* 2270269 */   GIR_EraseRootFromParent_Done,
     /* 2270270 */ // Label 30538: @2270270
     /* 2270270 */ GIM_Try, /*On fail goto*//*Label 30539*/ GIMT_Encode4(2270318), // Rule ID 57159 //
     /* 2270275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270281 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270288 */   // MIs[0] Operand 1
     /* 2270288 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2270293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270297 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270301 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2270304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270306 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270308 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270317 */   // GIR_Coverage, 57159,
     /* 2270317 */   GIR_EraseRootFromParent_Done,
     /* 2270318 */ // Label 30539: @2270318
     /* 2270318 */ GIM_Try, /*On fail goto*//*Label 30540*/ GIMT_Encode4(2270366), // Rule ID 57358 //
     /* 2270323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270329 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270336 */   // MIs[0] Operand 1
     /* 2270336 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270345 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270349 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2270352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270354 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270356 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270365 */   // GIR_Coverage, 57358,
     /* 2270365 */   GIR_EraseRootFromParent_Done,
     /* 2270366 */ // Label 30540: @2270366
     /* 2270366 */ GIM_Try, /*On fail goto*//*Label 30541*/ GIMT_Encode4(2270414), // Rule ID 57359 //
     /* 2270371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270384 */   // MIs[0] Operand 1
     /* 2270384 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270397 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2270400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270402 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270404 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270412 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270413 */   // GIR_Coverage, 57359,
     /* 2270413 */   GIR_EraseRootFromParent_Done,
     /* 2270414 */ // Label 30541: @2270414
     /* 2270414 */ GIM_Try, /*On fail goto*//*Label 30542*/ GIMT_Encode4(2270462), // Rule ID 57418 //
     /* 2270419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270425 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270432 */   // MIs[0] Operand 1
     /* 2270432 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270441 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270445 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2270448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270450 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270452 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270461 */   // GIR_Coverage, 57418,
     /* 2270461 */   GIR_EraseRootFromParent_Done,
     /* 2270462 */ // Label 30542: @2270462
     /* 2270462 */ GIM_Try, /*On fail goto*//*Label 30543*/ GIMT_Encode4(2270510), // Rule ID 57419 //
     /* 2270467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270473 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270480 */   // MIs[0] Operand 1
     /* 2270480 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270489 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270493 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2270496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270498 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270500 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270508 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270509 */   // GIR_Coverage, 57419,
     /* 2270509 */   GIR_EraseRootFromParent_Done,
     /* 2270510 */ // Label 30543: @2270510
     /* 2270510 */ GIM_Try, /*On fail goto*//*Label 30544*/ GIMT_Encode4(2270558), // Rule ID 57458 //
     /* 2270515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270521 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270528 */   // MIs[0] Operand 1
     /* 2270528 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270537 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270541 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2270544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270546 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270548 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270556 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270557 */   // GIR_Coverage, 57458,
     /* 2270557 */   GIR_EraseRootFromParent_Done,
     /* 2270558 */ // Label 30544: @2270558
     /* 2270558 */ GIM_Try, /*On fail goto*//*Label 30545*/ GIMT_Encode4(2270606), // Rule ID 57459 //
     /* 2270563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270576 */   // MIs[0] Operand 1
     /* 2270576 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2270581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270585 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270589 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2270592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270594 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270596 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270605 */   // GIR_Coverage, 57459,
     /* 2270605 */   GIR_EraseRootFromParent_Done,
     /* 2270606 */ // Label 30545: @2270606
     /* 2270606 */ GIM_Try, /*On fail goto*//*Label 30546*/ GIMT_Encode4(2270654), // Rule ID 57658 //
     /* 2270611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270617 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270624 */   // MIs[0] Operand 1
     /* 2270624 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270633 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270637 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2270640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270642 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270644 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270652 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270653 */   // GIR_Coverage, 57658,
     /* 2270653 */   GIR_EraseRootFromParent_Done,
     /* 2270654 */ // Label 30546: @2270654
     /* 2270654 */ GIM_Try, /*On fail goto*//*Label 30547*/ GIMT_Encode4(2270702), // Rule ID 57659 //
     /* 2270659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270665 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270672 */   // MIs[0] Operand 1
     /* 2270672 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270681 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270685 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2270688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270690 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270692 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270700 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270701 */   // GIR_Coverage, 57659,
     /* 2270701 */   GIR_EraseRootFromParent_Done,
     /* 2270702 */ // Label 30547: @2270702
     /* 2270702 */ GIM_Try, /*On fail goto*//*Label 30548*/ GIMT_Encode4(2270750), // Rule ID 57718 //
     /* 2270707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270713 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270720 */   // MIs[0] Operand 1
     /* 2270720 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270729 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270733 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2270733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2270736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270738 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270740 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270742 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270748 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270749 */   // GIR_Coverage, 57718,
     /* 2270749 */   GIR_EraseRootFromParent_Done,
     /* 2270750 */ // Label 30548: @2270750
     /* 2270750 */ GIM_Try, /*On fail goto*//*Label 30549*/ GIMT_Encode4(2270798), // Rule ID 57719 //
     /* 2270755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2270758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270761 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2270764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270768 */   // MIs[0] Operand 1
     /* 2270768 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270777 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270781 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2270781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2270784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270786 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270788 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270797 */   // GIR_Coverage, 57719,
     /* 2270797 */   GIR_EraseRootFromParent_Done,
     /* 2270798 */ // Label 30549: @2270798
     /* 2270798 */ GIM_Try, /*On fail goto*//*Label 30550*/ GIMT_Encode4(2270846), // Rule ID 57758 //
     /* 2270803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2270806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270809 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270816 */   // MIs[0] Operand 1
     /* 2270816 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270825 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270829 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2270829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2270832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270834 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270836 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270845 */   // GIR_Coverage, 57758,
     /* 2270845 */   GIR_EraseRootFromParent_Done,
     /* 2270846 */ // Label 30550: @2270846
     /* 2270846 */ GIM_Try, /*On fail goto*//*Label 30551*/ GIMT_Encode4(2270894), // Rule ID 57759 //
     /* 2270851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2270854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270857 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2270860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270864 */   // MIs[0] Operand 1
     /* 2270864 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2270869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270873 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270877 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2270877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2270880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270882 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270884 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270893 */   // GIR_Coverage, 57759,
     /* 2270893 */   GIR_EraseRootFromParent_Done,
     /* 2270894 */ // Label 30551: @2270894
     /* 2270894 */ GIM_Try, /*On fail goto*//*Label 30552*/ GIMT_Encode4(2270942), // Rule ID 57958 //
     /* 2270899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2270902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270905 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270912 */   // MIs[0] Operand 1
     /* 2270912 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270917 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270921 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270925 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2270925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2270928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270930 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270932 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270941 */   // GIR_Coverage, 57958,
     /* 2270941 */   GIR_EraseRootFromParent_Done,
     /* 2270942 */ // Label 30552: @2270942
     /* 2270942 */ GIM_Try, /*On fail goto*//*Label 30553*/ GIMT_Encode4(2270990), // Rule ID 57959 //
     /* 2270947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2270950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270953 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2270956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270960 */   // MIs[0] Operand 1
     /* 2270960 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2270965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270969 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270973 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2270973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2270976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270978 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2270980 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2270982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270988 */   GIR_RootConstrainSelectedInstOperands,
     /* 2270989 */   // GIR_Coverage, 57959,
     /* 2270989 */   GIR_EraseRootFromParent_Done,
     /* 2270990 */ // Label 30553: @2270990
     /* 2270990 */ GIM_Try, /*On fail goto*//*Label 30554*/ GIMT_Encode4(2271038), // Rule ID 58018 //
     /* 2270995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2270998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271001 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271008 */   // MIs[0] Operand 1
     /* 2271008 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271013 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271017 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271021 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2271024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271026 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271028 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271033 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271036 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271037 */   // GIR_Coverage, 58018,
     /* 2271037 */   GIR_EraseRootFromParent_Done,
     /* 2271038 */ // Label 30554: @2271038
     /* 2271038 */ GIM_Try, /*On fail goto*//*Label 30555*/ GIMT_Encode4(2271086), // Rule ID 58019 //
     /* 2271043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2271049 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2271052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271056 */   // MIs[0] Operand 1
     /* 2271056 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271065 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271069 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2271072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271074 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271076 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271085 */   // GIR_Coverage, 58019,
     /* 2271085 */   GIR_EraseRootFromParent_Done,
     /* 2271086 */ // Label 30555: @2271086
     /* 2271086 */ GIM_Try, /*On fail goto*//*Label 30556*/ GIMT_Encode4(2271134), // Rule ID 58058 //
     /* 2271091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271097 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271104 */   // MIs[0] Operand 1
     /* 2271104 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271113 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271117 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2271120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271122 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271124 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271133 */   // GIR_Coverage, 58058,
     /* 2271133 */   GIR_EraseRootFromParent_Done,
     /* 2271134 */ // Label 30556: @2271134
     /* 2271134 */ GIM_Try, /*On fail goto*//*Label 30557*/ GIMT_Encode4(2271182), // Rule ID 58059 //
     /* 2271139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2271145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2271148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271152 */   // MIs[0] Operand 1
     /* 2271152 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2271157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271161 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271165 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2271168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271170 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271172 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271181 */   // GIR_Coverage, 58059,
     /* 2271181 */   GIR_EraseRootFromParent_Done,
     /* 2271182 */ // Label 30557: @2271182
     /* 2271182 */ GIM_Reject,
     /* 2271183 */ // Label 30443: @2271183
     /* 2271183 */ GIM_Try, /*On fail goto*//*Label 30558*/ GIMT_Encode4(2271231), // Rule ID 57088 //
     /* 2271188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271201 */   // MIs[0] Operand 1
     /* 2271201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271214 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2271217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271219 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271221 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271230 */   // GIR_Coverage, 57088,
     /* 2271230 */   GIR_EraseRootFromParent_Done,
     /* 2271231 */ // Label 30558: @2271231
     /* 2271231 */ GIM_Try, /*On fail goto*//*Label 30559*/ GIMT_Encode4(2271279), // Rule ID 57089 //
     /* 2271236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271249 */   // MIs[0] Operand 1
     /* 2271249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271262 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2271265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271267 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271269 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271278 */   // GIR_Coverage, 57089,
     /* 2271278 */   GIR_EraseRootFromParent_Done,
     /* 2271279 */ // Label 30559: @2271279
     /* 2271279 */ GIM_Try, /*On fail goto*//*Label 30560*/ GIMT_Encode4(2271327), // Rule ID 57128 //
     /* 2271284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2271290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2271293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271297 */   // MIs[0] Operand 1
     /* 2271297 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271306 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271310 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2271313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271315 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271317 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271326 */   // GIR_Coverage, 57128,
     /* 2271326 */   GIR_EraseRootFromParent_Done,
     /* 2271327 */ // Label 30560: @2271327
     /* 2271327 */ GIM_Try, /*On fail goto*//*Label 30561*/ GIMT_Encode4(2271375), // Rule ID 57129 //
     /* 2271332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2271338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2271341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271345 */   // MIs[0] Operand 1
     /* 2271345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271358 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2271361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271363 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271365 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271374 */   // GIR_Coverage, 57129,
     /* 2271374 */   GIR_EraseRootFromParent_Done,
     /* 2271375 */ // Label 30561: @2271375
     /* 2271375 */ GIM_Try, /*On fail goto*//*Label 30562*/ GIMT_Encode4(2271423), // Rule ID 57168 //
     /* 2271380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2271386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2271389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271393 */   // MIs[0] Operand 1
     /* 2271393 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271402 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271406 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2271409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271411 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271413 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271422 */   // GIR_Coverage, 57168,
     /* 2271422 */   GIR_EraseRootFromParent_Done,
     /* 2271423 */ // Label 30562: @2271423
     /* 2271423 */ GIM_Try, /*On fail goto*//*Label 30563*/ GIMT_Encode4(2271471), // Rule ID 57169 //
     /* 2271428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2271434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2271437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271441 */   // MIs[0] Operand 1
     /* 2271441 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2271446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271450 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271454 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2271457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271459 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271461 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271470 */   // GIR_Coverage, 57169,
     /* 2271470 */   GIR_EraseRootFromParent_Done,
     /* 2271471 */ // Label 30563: @2271471
     /* 2271471 */ GIM_Try, /*On fail goto*//*Label 30564*/ GIMT_Encode4(2271519), // Rule ID 57388 //
     /* 2271476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271489 */   // MIs[0] Operand 1
     /* 2271489 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271502 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2271505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271507 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271509 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271518 */   // GIR_Coverage, 57388,
     /* 2271518 */   GIR_EraseRootFromParent_Done,
     /* 2271519 */ // Label 30564: @2271519
     /* 2271519 */ GIM_Try, /*On fail goto*//*Label 30565*/ GIMT_Encode4(2271567), // Rule ID 57389 //
     /* 2271524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271537 */   // MIs[0] Operand 1
     /* 2271537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271550 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2271553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271555 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271557 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271566 */   // GIR_Coverage, 57389,
     /* 2271566 */   GIR_EraseRootFromParent_Done,
     /* 2271567 */ // Label 30565: @2271567
     /* 2271567 */ GIM_Try, /*On fail goto*//*Label 30566*/ GIMT_Encode4(2271615), // Rule ID 57428 //
     /* 2271572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2271578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2271581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271585 */   // MIs[0] Operand 1
     /* 2271585 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271594 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271598 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2271601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271603 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271605 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271614 */   // GIR_Coverage, 57428,
     /* 2271614 */   GIR_EraseRootFromParent_Done,
     /* 2271615 */ // Label 30566: @2271615
     /* 2271615 */ GIM_Try, /*On fail goto*//*Label 30567*/ GIMT_Encode4(2271663), // Rule ID 57429 //
     /* 2271620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2271626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2271629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271633 */   // MIs[0] Operand 1
     /* 2271633 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271642 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271646 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2271649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271651 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271653 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271662 */   // GIR_Coverage, 57429,
     /* 2271662 */   GIR_EraseRootFromParent_Done,
     /* 2271663 */ // Label 30567: @2271663
     /* 2271663 */ GIM_Try, /*On fail goto*//*Label 30568*/ GIMT_Encode4(2271711), // Rule ID 57468 //
     /* 2271668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2271674 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2271677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271681 */   // MIs[0] Operand 1
     /* 2271681 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271690 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271694 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2271697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271699 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271701 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271710 */   // GIR_Coverage, 57468,
     /* 2271710 */   GIR_EraseRootFromParent_Done,
     /* 2271711 */ // Label 30568: @2271711
     /* 2271711 */ GIM_Try, /*On fail goto*//*Label 30569*/ GIMT_Encode4(2271759), // Rule ID 57469 //
     /* 2271716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2271719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2271722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2271725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271729 */   // MIs[0] Operand 1
     /* 2271729 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2271734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271738 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271742 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2271742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2271745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271747 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271749 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271757 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271758 */   // GIR_Coverage, 57469,
     /* 2271758 */   GIR_EraseRootFromParent_Done,
     /* 2271759 */ // Label 30569: @2271759
     /* 2271759 */ GIM_Try, /*On fail goto*//*Label 30570*/ GIMT_Encode4(2271807), // Rule ID 57688 //
     /* 2271764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2271767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271777 */   // MIs[0] Operand 1
     /* 2271777 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271786 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271790 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2271790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2271793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271795 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271797 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271806 */   // GIR_Coverage, 57688,
     /* 2271806 */   GIR_EraseRootFromParent_Done,
     /* 2271807 */ // Label 30570: @2271807
     /* 2271807 */ GIM_Try, /*On fail goto*//*Label 30571*/ GIMT_Encode4(2271855), // Rule ID 57689 //
     /* 2271812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2271815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2271821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271825 */   // MIs[0] Operand 1
     /* 2271825 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271834 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271838 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2271838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2271841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271845 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271854 */   // GIR_Coverage, 57689,
     /* 2271854 */   GIR_EraseRootFromParent_Done,
     /* 2271855 */ // Label 30571: @2271855
     /* 2271855 */ GIM_Try, /*On fail goto*//*Label 30572*/ GIMT_Encode4(2271903), // Rule ID 57728 //
     /* 2271860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2271863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2271866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2271869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271873 */   // MIs[0] Operand 1
     /* 2271873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271882 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271886 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2271886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2271889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271891 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271893 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271902 */   // GIR_Coverage, 57728,
     /* 2271902 */   GIR_EraseRootFromParent_Done,
     /* 2271903 */ // Label 30572: @2271903
     /* 2271903 */ GIM_Try, /*On fail goto*//*Label 30573*/ GIMT_Encode4(2271951), // Rule ID 57729 //
     /* 2271908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2271911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2271914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2271917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271921 */   // MIs[0] Operand 1
     /* 2271921 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271930 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271934 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2271934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2271937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271939 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271941 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271950 */   // GIR_Coverage, 57729,
     /* 2271950 */   GIR_EraseRootFromParent_Done,
     /* 2271951 */ // Label 30573: @2271951
     /* 2271951 */ GIM_Try, /*On fail goto*//*Label 30574*/ GIMT_Encode4(2271999), // Rule ID 57768 //
     /* 2271956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2271959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2271962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2271965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2271969 */   // MIs[0] Operand 1
     /* 2271969 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2271974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271978 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271982 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2271982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2271985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271987 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2271989 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2271991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2271998 */   // GIR_Coverage, 57768,
     /* 2271998 */   GIR_EraseRootFromParent_Done,
     /* 2271999 */ // Label 30574: @2271999
     /* 2271999 */ GIM_Try, /*On fail goto*//*Label 30575*/ GIMT_Encode4(2272047), // Rule ID 57769 //
     /* 2272004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272017 */   // MIs[0] Operand 1
     /* 2272017 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272026 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272030 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2272033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272035 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272037 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272046 */   // GIR_Coverage, 57769,
     /* 2272046 */   GIR_EraseRootFromParent_Done,
     /* 2272047 */ // Label 30575: @2272047
     /* 2272047 */ GIM_Try, /*On fail goto*//*Label 30576*/ GIMT_Encode4(2272095), // Rule ID 57988 //
     /* 2272052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272058 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272065 */   // MIs[0] Operand 1
     /* 2272065 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272074 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272078 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2272081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272083 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272085 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272094 */   // GIR_Coverage, 57988,
     /* 2272094 */   GIR_EraseRootFromParent_Done,
     /* 2272095 */ // Label 30576: @2272095
     /* 2272095 */ GIM_Try, /*On fail goto*//*Label 30577*/ GIMT_Encode4(2272143), // Rule ID 57989 //
     /* 2272100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2272106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2272109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272113 */   // MIs[0] Operand 1
     /* 2272113 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272122 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2272126 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2272129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272131 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272133 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272142 */   // GIR_Coverage, 57989,
     /* 2272142 */   GIR_EraseRootFromParent_Done,
     /* 2272143 */ // Label 30577: @2272143
     /* 2272143 */ GIM_Try, /*On fail goto*//*Label 30578*/ GIMT_Encode4(2272191), // Rule ID 58028 //
     /* 2272148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272161 */   // MIs[0] Operand 1
     /* 2272161 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272170 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272174 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272179 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272181 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272190 */   // GIR_Coverage, 58028,
     /* 2272190 */   GIR_EraseRootFromParent_Done,
     /* 2272191 */ // Label 30578: @2272191
     /* 2272191 */ GIM_Try, /*On fail goto*//*Label 30579*/ GIMT_Encode4(2272239), // Rule ID 58029 //
     /* 2272196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2272202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2272205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272209 */   // MIs[0] Operand 1
     /* 2272209 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272218 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272222 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272227 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272229 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272238 */   // GIR_Coverage, 58029,
     /* 2272238 */   GIR_EraseRootFromParent_Done,
     /* 2272239 */ // Label 30579: @2272239
     /* 2272239 */ GIM_Try, /*On fail goto*//*Label 30580*/ GIMT_Encode4(2272287), // Rule ID 58068 //
     /* 2272244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2272247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272257 */   // MIs[0] Operand 1
     /* 2272257 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272270 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2272270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2272273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272275 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272277 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272286 */   // GIR_Coverage, 58068,
     /* 2272286 */   GIR_EraseRootFromParent_Done,
     /* 2272287 */ // Label 30580: @2272287
     /* 2272287 */ GIM_Try, /*On fail goto*//*Label 30581*/ GIMT_Encode4(2272335), // Rule ID 58069 //
     /* 2272292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2272295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2272298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2272301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272305 */   // MIs[0] Operand 1
     /* 2272305 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272314 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272318 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2272318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2272321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272323 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272325 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272334 */   // GIR_Coverage, 58069,
     /* 2272334 */   GIR_EraseRootFromParent_Done,
     /* 2272335 */ // Label 30581: @2272335
     /* 2272335 */ GIM_Reject,
     /* 2272336 */ // Label 30444: @2272336
     /* 2272336 */ GIM_Try, /*On fail goto*//*Label 30582*/ GIMT_Encode4(2272384), // Rule ID 57098 //
     /* 2272341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272347 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272354 */   // MIs[0] Operand 1
     /* 2272354 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272359 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272363 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272367 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2272370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272372 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272374 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272382 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272383 */   // GIR_Coverage, 57098,
     /* 2272383 */   GIR_EraseRootFromParent_Done,
     /* 2272384 */ // Label 30582: @2272384
     /* 2272384 */ GIM_Try, /*On fail goto*//*Label 30583*/ GIMT_Encode4(2272432), // Rule ID 57099 //
     /* 2272389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272402 */   // MIs[0] Operand 1
     /* 2272402 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272411 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272415 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2272418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272420 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272422 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272430 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272431 */   // GIR_Coverage, 57099,
     /* 2272431 */   GIR_EraseRootFromParent_Done,
     /* 2272432 */ // Label 30583: @2272432
     /* 2272432 */ GIM_Try, /*On fail goto*//*Label 30584*/ GIMT_Encode4(2272480), // Rule ID 57138 //
     /* 2272437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2272443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2272446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272450 */   // MIs[0] Operand 1
     /* 2272450 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272459 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272463 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2272466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272468 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272470 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272479 */   // GIR_Coverage, 57138,
     /* 2272479 */   GIR_EraseRootFromParent_Done,
     /* 2272480 */ // Label 30584: @2272480
     /* 2272480 */ GIM_Try, /*On fail goto*//*Label 30585*/ GIMT_Encode4(2272528), // Rule ID 57139 //
     /* 2272485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2272491 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2272494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272498 */   // MIs[0] Operand 1
     /* 2272498 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2272503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272507 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272511 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2272514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272516 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272518 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272526 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272527 */   // GIR_Coverage, 57139,
     /* 2272527 */   GIR_EraseRootFromParent_Done,
     /* 2272528 */ // Label 30585: @2272528
     /* 2272528 */ GIM_Try, /*On fail goto*//*Label 30586*/ GIMT_Encode4(2272576), // Rule ID 57398 //
     /* 2272533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272546 */   // MIs[0] Operand 1
     /* 2272546 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272551 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272555 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272559 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2272562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272564 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272566 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272575 */   // GIR_Coverage, 57398,
     /* 2272575 */   GIR_EraseRootFromParent_Done,
     /* 2272576 */ // Label 30586: @2272576
     /* 2272576 */ GIM_Try, /*On fail goto*//*Label 30587*/ GIMT_Encode4(2272624), // Rule ID 57399 //
     /* 2272581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272587 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272594 */   // MIs[0] Operand 1
     /* 2272594 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272603 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272607 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2272610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272612 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272614 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272623 */   // GIR_Coverage, 57399,
     /* 2272623 */   GIR_EraseRootFromParent_Done,
     /* 2272624 */ // Label 30587: @2272624
     /* 2272624 */ GIM_Try, /*On fail goto*//*Label 30588*/ GIMT_Encode4(2272672), // Rule ID 57438 //
     /* 2272629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2272635 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2272638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272642 */   // MIs[0] Operand 1
     /* 2272642 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272655 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2272658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272660 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272662 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272670 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272671 */   // GIR_Coverage, 57438,
     /* 2272671 */   GIR_EraseRootFromParent_Done,
     /* 2272672 */ // Label 30588: @2272672
     /* 2272672 */ GIM_Try, /*On fail goto*//*Label 30589*/ GIMT_Encode4(2272720), // Rule ID 57439 //
     /* 2272677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2272683 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2272686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272690 */   // MIs[0] Operand 1
     /* 2272690 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2272695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272699 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272703 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2272706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272708 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272710 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272719 */   // GIR_Coverage, 57439,
     /* 2272719 */   GIR_EraseRootFromParent_Done,
     /* 2272720 */ // Label 30589: @2272720
     /* 2272720 */ GIM_Try, /*On fail goto*//*Label 30590*/ GIMT_Encode4(2272768), // Rule ID 57698 //
     /* 2272725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272731 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272738 */   // MIs[0] Operand 1
     /* 2272738 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272747 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272751 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2272754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272756 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272758 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272767 */   // GIR_Coverage, 57698,
     /* 2272767 */   GIR_EraseRootFromParent_Done,
     /* 2272768 */ // Label 30590: @2272768
     /* 2272768 */ GIM_Try, /*On fail goto*//*Label 30591*/ GIMT_Encode4(2272816), // Rule ID 57699 //
     /* 2272773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272779 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272786 */   // MIs[0] Operand 1
     /* 2272786 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272791 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272795 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272799 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2272802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272804 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272806 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272815 */   // GIR_Coverage, 57699,
     /* 2272815 */   GIR_EraseRootFromParent_Done,
     /* 2272816 */ // Label 30591: @2272816
     /* 2272816 */ GIM_Try, /*On fail goto*//*Label 30592*/ GIMT_Encode4(2272864), // Rule ID 57738 //
     /* 2272821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2272824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2272827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2272830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272834 */   // MIs[0] Operand 1
     /* 2272834 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272843 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272847 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2272847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2272850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272852 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272854 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272862 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272863 */   // GIR_Coverage, 57738,
     /* 2272863 */   GIR_EraseRootFromParent_Done,
     /* 2272864 */ // Label 30592: @2272864
     /* 2272864 */ GIM_Try, /*On fail goto*//*Label 30593*/ GIMT_Encode4(2272912), // Rule ID 57739 //
     /* 2272869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2272872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2272875 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2272878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272882 */   // MIs[0] Operand 1
     /* 2272882 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2272887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272891 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272895 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2272895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2272898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272900 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272902 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272910 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272911 */   // GIR_Coverage, 57739,
     /* 2272911 */   GIR_EraseRootFromParent_Done,
     /* 2272912 */ // Label 30593: @2272912
     /* 2272912 */ GIM_Try, /*On fail goto*//*Label 30594*/ GIMT_Encode4(2272960), // Rule ID 57998 //
     /* 2272917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2272920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272923 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272930 */   // MIs[0] Operand 1
     /* 2272930 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272939 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272943 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2272943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272948 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272950 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2272952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272958 */   GIR_RootConstrainSelectedInstOperands,
     /* 2272959 */   // GIR_Coverage, 57998,
     /* 2272959 */   GIR_EraseRootFromParent_Done,
     /* 2272960 */ // Label 30594: @2272960
     /* 2272960 */ GIM_Try, /*On fail goto*//*Label 30595*/ GIMT_Encode4(2273008), // Rule ID 57999 //
     /* 2272965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2272968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2272971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2272974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272978 */   // MIs[0] Operand 1
     /* 2272978 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2272983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272987 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2272991 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2272991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2272994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272996 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2272998 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273007 */   // GIR_Coverage, 57999,
     /* 2273007 */   GIR_EraseRootFromParent_Done,
     /* 2273008 */ // Label 30595: @2273008
     /* 2273008 */ GIM_Try, /*On fail goto*//*Label 30596*/ GIMT_Encode4(2273056), // Rule ID 58038 //
     /* 2273013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2273016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273026 */   // MIs[0] Operand 1
     /* 2273026 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273035 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273039 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2273039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273044 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273046 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273055 */   // GIR_Coverage, 58038,
     /* 2273055 */   GIR_EraseRootFromParent_Done,
     /* 2273056 */ // Label 30596: @2273056
     /* 2273056 */ GIM_Try, /*On fail goto*//*Label 30597*/ GIMT_Encode4(2273104), // Rule ID 58039 //
     /* 2273061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2273064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2273067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2273070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273074 */   // MIs[0] Operand 1
     /* 2273074 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273079 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273083 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273087 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2273087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273092 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273094 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273102 */   GIR_RootConstrainSelectedInstOperands,
     /* 2273103 */   // GIR_Coverage, 58039,
     /* 2273103 */   GIR_EraseRootFromParent_Done,
     /* 2273104 */ // Label 30597: @2273104
     /* 2273104 */ GIM_Reject,
     /* 2273105 */ // Label 30445: @2273105
     /* 2273105 */ GIM_Try, /*On fail goto*//*Label 30598*/ GIMT_Encode4(2273425),
     /* 2273110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2273113 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2273116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273120 */   GIM_Try, /*On fail goto*//*Label 30599*/ GIMT_Encode4(2273158), // Rule ID 57108 //
     /* 2273125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273128 */     // MIs[0] Operand 1
     /* 2273128 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273141 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2273144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273157 */     // GIR_Coverage, 57108,
     /* 2273157 */     GIR_EraseRootFromParent_Done,
     /* 2273158 */   // Label 30599: @2273158
     /* 2273158 */   GIM_Try, /*On fail goto*//*Label 30600*/ GIMT_Encode4(2273196), // Rule ID 57109 //
     /* 2273163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273166 */     // MIs[0] Operand 1
     /* 2273166 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2273171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273179 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2273182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273195 */     // GIR_Coverage, 57109,
     /* 2273195 */     GIR_EraseRootFromParent_Done,
     /* 2273196 */   // Label 30600: @2273196
     /* 2273196 */   GIM_Try, /*On fail goto*//*Label 30601*/ GIMT_Encode4(2273234), // Rule ID 57408 //
     /* 2273201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273204 */     // MIs[0] Operand 1
     /* 2273204 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273217 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273233 */     // GIR_Coverage, 57408,
     /* 2273233 */     GIR_EraseRootFromParent_Done,
     /* 2273234 */   // Label 30601: @2273234
     /* 2273234 */   GIM_Try, /*On fail goto*//*Label 30602*/ GIMT_Encode4(2273272), // Rule ID 57409 //
     /* 2273239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273242 */     // MIs[0] Operand 1
     /* 2273242 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2273247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273255 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2273258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273271 */     // GIR_Coverage, 57409,
     /* 2273271 */     GIR_EraseRootFromParent_Done,
     /* 2273272 */   // Label 30602: @2273272
     /* 2273272 */   GIM_Try, /*On fail goto*//*Label 30603*/ GIMT_Encode4(2273310), // Rule ID 57708 //
     /* 2273277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273280 */     // MIs[0] Operand 1
     /* 2273280 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273293 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273309 */     // GIR_Coverage, 57708,
     /* 2273309 */     GIR_EraseRootFromParent_Done,
     /* 2273310 */   // Label 30603: @2273310
     /* 2273310 */   GIM_Try, /*On fail goto*//*Label 30604*/ GIMT_Encode4(2273348), // Rule ID 57709 //
     /* 2273315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273318 */     // MIs[0] Operand 1
     /* 2273318 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2273323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273331 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2273334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273347 */     // GIR_Coverage, 57709,
     /* 2273347 */     GIR_EraseRootFromParent_Done,
     /* 2273348 */   // Label 30604: @2273348
     /* 2273348 */   GIM_Try, /*On fail goto*//*Label 30605*/ GIMT_Encode4(2273386), // Rule ID 58008 //
     /* 2273353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2273356 */     // MIs[0] Operand 1
     /* 2273356 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273369 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2273369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273385 */     // GIR_Coverage, 58008,
     /* 2273385 */     GIR_EraseRootFromParent_Done,
     /* 2273386 */   // Label 30605: @2273386
     /* 2273386 */   GIM_Try, /*On fail goto*//*Label 30606*/ GIMT_Encode4(2273424), // Rule ID 58009 //
     /* 2273391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2273394 */     // MIs[0] Operand 1
     /* 2273394 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2273399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2273407 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2273407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2273410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2273414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2273416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273423 */     // GIR_Coverage, 58009,
     /* 2273423 */     GIR_EraseRootFromParent_Done,
     /* 2273424 */   // Label 30606: @2273424
     /* 2273424 */   GIM_Reject,
     /* 2273425 */ // Label 30598: @2273425
     /* 2273425 */ GIM_Reject,
     /* 2273426 */ // Label 30446: @2273426
     /* 2273426 */ GIM_Reject,
     /* 2273427 */ // Label 50: @2273427
     /* 2273427 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30631*/ GIMT_Encode4(2279146),
     /* 2273438 */ /*GILLT_s32*//*Label 30607*/ GIMT_Encode4(2273562),
     /* 2273442 */ /*GILLT_s64*//*Label 30608*/ GIMT_Encode4(2274374), GIMT_Encode4(0),
     /* 2273450 */ /*GILLT_nxv1s8*//*Label 30609*/ GIMT_Encode4(2275186),
     /* 2273454 */ /*GILLT_nxv1s16*//*Label 30610*/ GIMT_Encode4(2275306),
     /* 2273458 */ /*GILLT_nxv1s32*//*Label 30611*/ GIMT_Encode4(2275514),
     /* 2273462 */ /*GILLT_nxv1s64*//*Label 30612*/ GIMT_Encode4(2275722), GIMT_Encode4(0),
     /* 2273470 */ /*GILLT_nxv2s8*//*Label 30613*/ GIMT_Encode4(2275930),
     /* 2273474 */ /*GILLT_nxv2s16*//*Label 30614*/ GIMT_Encode4(2276050),
     /* 2273478 */ /*GILLT_nxv2s32*//*Label 30615*/ GIMT_Encode4(2276258),
     /* 2273482 */ /*GILLT_nxv2s64*//*Label 30616*/ GIMT_Encode4(2276466), GIMT_Encode4(0),
     /* 2273490 */ /*GILLT_nxv4s8*//*Label 30617*/ GIMT_Encode4(2276674),
     /* 2273494 */ /*GILLT_nxv4s16*//*Label 30618*/ GIMT_Encode4(2276794),
     /* 2273498 */ /*GILLT_nxv4s32*//*Label 30619*/ GIMT_Encode4(2277002),
     /* 2273502 */ /*GILLT_nxv4s64*//*Label 30620*/ GIMT_Encode4(2277210), GIMT_Encode4(0),
     /* 2273510 */ /*GILLT_nxv8s8*//*Label 30621*/ GIMT_Encode4(2277418),
     /* 2273514 */ /*GILLT_nxv8s16*//*Label 30622*/ GIMT_Encode4(2277538),
     /* 2273518 */ /*GILLT_nxv8s32*//*Label 30623*/ GIMT_Encode4(2277746),
     /* 2273522 */ /*GILLT_nxv8s64*//*Label 30624*/ GIMT_Encode4(2277954), GIMT_Encode4(0),
     /* 2273530 */ /*GILLT_nxv16s8*//*Label 30625*/ GIMT_Encode4(2278162),
     /* 2273534 */ /*GILLT_nxv16s16*//*Label 30626*/ GIMT_Encode4(2278282),
     /* 2273538 */ /*GILLT_nxv16s32*//*Label 30627*/ GIMT_Encode4(2278490), GIMT_Encode4(0),
     /* 2273546 */ /*GILLT_nxv32s8*//*Label 30628*/ GIMT_Encode4(2278698),
     /* 2273550 */ /*GILLT_nxv32s16*//*Label 30629*/ GIMT_Encode4(2278818), GIMT_Encode4(0),
     /* 2273558 */ /*GILLT_nxv64s8*//*Label 30630*/ GIMT_Encode4(2279026),
     /* 2273562 */ // Label 30607: @2273562
     /* 2273562 */ GIM_Try, /*On fail goto*//*Label 30632*/ GIMT_Encode4(2274373),
     /* 2273567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2273570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2273573 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2273576 */   GIM_Try, /*On fail goto*//*Label 30633*/ GIMT_Encode4(2273654), // Rule ID 64656 //
     /* 2273581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2273584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2273592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2273596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2273600 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2273604 */     // MIs[1] Operand 1
     /* 2273604 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2273609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2273618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2273622 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2273626 */     // MIs[2] Operand 1
     /* 2273626 */     // No operand predicates
     /* 2273626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2273636 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2273636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2273639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2273641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2273643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2273647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2273650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2273652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273653 */     // GIR_Coverage, 64656,
     /* 2273653 */     GIR_EraseRootFromParent_Done,
     /* 2273654 */   // Label 30633: @2273654
     /* 2273654 */   GIM_Try, /*On fail goto*//*Label 30634*/ GIMT_Encode4(2273732), // Rule ID 64658 //
     /* 2273659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2273662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2273670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2273674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2273678 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2273682 */     // MIs[1] Operand 1
     /* 2273682 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2273687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2273696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2273700 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2273704 */     // MIs[2] Operand 1
     /* 2273704 */     // No operand predicates
     /* 2273704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2273714 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNEI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2273714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNEI),
     /* 2273717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2273719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2273721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2273725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2273728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2273730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273731 */     // GIR_Coverage, 64658,
     /* 2273731 */     GIR_EraseRootFromParent_Done,
     /* 2273732 */   // Label 30634: @2273732
     /* 2273732 */   GIM_Try, /*On fail goto*//*Label 30635*/ GIMT_Encode4(2273810), // Rule ID 64660 //
     /* 2273737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2273740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2273748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2273752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2273756 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2273760 */     // MIs[1] Operand 1
     /* 2273760 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2273765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2273774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2273778 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2273782 */     // MIs[2] Operand 1
     /* 2273782 */     // No operand predicates
     /* 2273782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2273792 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2273792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTI),
     /* 2273795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2273797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2273799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2273803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2273806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2273808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273809 */     // GIR_Coverage, 64660,
     /* 2273809 */     GIR_EraseRootFromParent_Done,
     /* 2273810 */   // Label 30635: @2273810
     /* 2273810 */   GIM_Try, /*On fail goto*//*Label 30636*/ GIMT_Encode4(2273888), // Rule ID 64662 //
     /* 2273815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2273818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2273826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2273830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2273834 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2273838 */     // MIs[1] Operand 1
     /* 2273838 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2273843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2273852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2273856 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2273860 */     // MIs[2] Operand 1
     /* 2273860 */     // No operand predicates
     /* 2273860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2273870 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTUI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2273870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTUI),
     /* 2273873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2273875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2273877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2273881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2273884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2273886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273887 */     // GIR_Coverage, 64662,
     /* 2273887 */     GIR_EraseRootFromParent_Done,
     /* 2273888 */   // Label 30636: @2273888
     /* 2273888 */   GIM_Try, /*On fail goto*//*Label 30637*/ GIMT_Encode4(2273929), // Rule ID 62579 //
     /* 2273893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2273896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2273900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2273904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2273908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2273912 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, 0:{ *:[i32] }, GPR:{ *:[i32] }:$b)  =>  (TH_MVNEZ:{ *:[i32] } GPR:{ *:[i32] }:$b, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2273912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2273915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2273917 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2273919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2273925 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2273927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273928 */     // GIR_Coverage, 62579,
     /* 2273928 */     GIR_EraseRootFromParent_Done,
     /* 2273929 */   // Label 30637: @2273929
     /* 2273929 */   GIM_Try, /*On fail goto*//*Label 30638*/ GIMT_Encode4(2273970), // Rule ID 62577 //
     /* 2273934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2273937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2273941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2273945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2273949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2273953 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2273953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2273956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2273958 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2273960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2273966 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2273968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273969 */     // GIR_Coverage, 62577,
     /* 2273969 */     GIR_EraseRootFromParent_Done,
     /* 2273970 */   // Label 30638: @2273970
     /* 2273970 */   GIM_Try, /*On fail goto*//*Label 30639*/ GIMT_Encode4(2274042), // Rule ID 64648 //
     /* 2273975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2273978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2273982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2273986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2273990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2273994 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2273998 */     // MIs[1] Operand 1
     /* 2273998 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2274003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274023 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVEQ:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQ),
     /* 2274026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274041 */     // GIR_Coverage, 64648,
     /* 2274041 */     GIR_EraseRootFromParent_Done,
     /* 2274042 */   // Label 30639: @2274042
     /* 2274042 */   GIM_Try, /*On fail goto*//*Label 30640*/ GIMT_Encode4(2274114), // Rule ID 64650 //
     /* 2274047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274066 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274070 */     // MIs[1] Operand 1
     /* 2274070 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2274075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274095 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVNE:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNE),
     /* 2274098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274113 */     // GIR_Coverage, 64650,
     /* 2274113 */     GIR_EraseRootFromParent_Done,
     /* 2274114 */   // Label 30640: @2274114
     /* 2274114 */   GIM_Try, /*On fail goto*//*Label 30641*/ GIMT_Encode4(2274186), // Rule ID 64652 //
     /* 2274119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274138 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274142 */     // MIs[1] Operand 1
     /* 2274142 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2274147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274167 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLT),
     /* 2274170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274185 */     // GIR_Coverage, 64652,
     /* 2274185 */     GIR_EraseRootFromParent_Done,
     /* 2274186 */   // Label 30641: @2274186
     /* 2274186 */   GIM_Try, /*On fail goto*//*Label 30642*/ GIMT_Encode4(2274258), // Rule ID 64654 //
     /* 2274191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2274210 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 2274214 */     // MIs[1] Operand 1
     /* 2274214 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2274219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274239 */     // (select:{ *:[i32] } (setcc:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i32] }:$rs3, GPRNoX0:{ *:[i32] }:$rd)  =>  (QC_MVLTU:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTU),
     /* 2274242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274257 */     // GIR_Coverage, 64654,
     /* 2274257 */     GIR_EraseRootFromParent_Done,
     /* 2274258 */   // Label 30642: @2274258
     /* 2274258 */   GIM_Try, /*On fail goto*//*Label 30643*/ GIMT_Encode4(2274295), // Rule ID 62575 //
     /* 2274263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2274266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274282 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$cond)
     /* 2274282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2274285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274287 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2274289 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2274291 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2274293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274294 */     // GIR_Coverage, 62575,
     /* 2274294 */     GIR_EraseRootFromParent_Done,
     /* 2274295 */   // Label 30643: @2274295
     /* 2274295 */   GIM_Try, /*On fail goto*//*Label 30644*/ GIMT_Encode4(2274335), // Rule ID 64646 //
     /* 2274300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode1),
     /* 2274303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274319 */     // (select:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs3)  =>  (QC_MVEQI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rd, GPRNoX0:{ *:[i32] }:$rs1, 0:{ *:[i32] }, GPRNoX0:{ *:[i32] }:$rs3)
     /* 2274319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2274322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2274326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2274331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2274333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274334 */     // GIR_Coverage, 64646,
     /* 2274334 */     GIR_EraseRootFromParent_Done,
     /* 2274335 */   // Label 30644: @2274335
     /* 2274335 */   GIM_Try, /*On fail goto*//*Label 30645*/ GIMT_Encode4(2274372), // Rule ID 64668 //
     /* 2274340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
     /* 2274343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274359 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /* 2274359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2274362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2274366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2274368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2274370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274371 */     // GIR_Coverage, 64668,
     /* 2274371 */     GIR_EraseRootFromParent_Done,
     /* 2274372 */   // Label 30645: @2274372
     /* 2274372 */   GIM_Reject,
     /* 2274373 */ // Label 30632: @2274373
     /* 2274373 */ GIM_Reject,
     /* 2274374 */ // Label 30608: @2274374
     /* 2274374 */ GIM_Try, /*On fail goto*//*Label 30646*/ GIMT_Encode4(2275185),
     /* 2274379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2274382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274385 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274388 */   GIM_Try, /*On fail goto*//*Label 30647*/ GIMT_Encode4(2274466), // Rule ID 64655 //
     /* 2274393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274412 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274416 */     // MIs[1] Operand 1
     /* 2274416 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2274421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274434 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274438 */     // MIs[2] Operand 1
     /* 2274438 */     // No operand predicates
     /* 2274438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274448 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVEQI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2274448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2274451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274465 */     // GIR_Coverage, 64655,
     /* 2274465 */     GIR_EraseRootFromParent_Done,
     /* 2274466 */   // Label 30647: @2274466
     /* 2274466 */   GIM_Try, /*On fail goto*//*Label 30648*/ GIMT_Encode4(2274544), // Rule ID 64657 //
     /* 2274471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274490 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274494 */     // MIs[1] Operand 1
     /* 2274494 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2274499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274512 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274516 */     // MIs[2] Operand 1
     /* 2274516 */     // No operand predicates
     /* 2274516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274526 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVNEI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2274526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNEI),
     /* 2274529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274543 */     // GIR_Coverage, 64657,
     /* 2274543 */     GIR_EraseRootFromParent_Done,
     /* 2274544 */   // Label 30648: @2274544
     /* 2274544 */   GIM_Try, /*On fail goto*//*Label 30649*/ GIMT_Encode4(2274622), // Rule ID 64659 //
     /* 2274549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274568 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274572 */     // MIs[1] Operand 1
     /* 2274572 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2274577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274590 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274594 */     // MIs[2] Operand 1
     /* 2274594 */     // No operand predicates
     /* 2274594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274604 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVLTI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2274604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTI),
     /* 2274607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274621 */     // GIR_Coverage, 64659,
     /* 2274621 */     GIR_EraseRootFromParent_Done,
     /* 2274622 */   // Label 30649: @2274622
     /* 2274622 */   GIM_Try, /*On fail goto*//*Label 30650*/ GIMT_Encode4(2274700), // Rule ID 64661 //
     /* 2274627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274646 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274650 */     // MIs[1] Operand 1
     /* 2274650 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2274655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 2274664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2274668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 2274672 */     // MIs[2] Operand 1
     /* 2274672 */     // No operand predicates
     /* 2274672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2274682 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVLTUI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$imm, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2274682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTUI),
     /* 2274685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 2274696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274699 */     // GIR_Coverage, 64661,
     /* 2274699 */     GIR_EraseRootFromParent_Done,
     /* 2274700 */   // Label 30650: @2274700
     /* 2274700 */   GIM_Try, /*On fail goto*//*Label 30651*/ GIMT_Encode4(2274741), // Rule ID 62578 //
     /* 2274705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2274708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2274720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274724 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, 0:{ *:[i64] }, GPR:{ *:[i64] }:$b)  =>  (TH_MVNEZ:{ *:[i64] } GPR:{ *:[i64] }:$b, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2274724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2274727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274729 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2274731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2274737 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2274739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274740 */     // GIR_Coverage, 62578,
     /* 2274740 */     GIR_EraseRootFromParent_Done,
     /* 2274741 */   // Label 30651: @2274741
     /* 2274741 */   GIM_Try, /*On fail goto*//*Label 30652*/ GIMT_Encode4(2274782), // Rule ID 62576 //
     /* 2274746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2274749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2274761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2274765 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, 0:{ *:[i64] })  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2274765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2274768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274770 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2274772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2274778 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2274780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274781 */     // GIR_Coverage, 62576,
     /* 2274781 */     GIR_EraseRootFromParent_Done,
     /* 2274782 */   // Label 30652: @2274782
     /* 2274782 */   GIM_Try, /*On fail goto*//*Label 30653*/ GIMT_Encode4(2274854), // Rule ID 64647 //
     /* 2274787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274806 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274810 */     // MIs[1] Operand 1
     /* 2274810 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2274815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274835 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVEQ:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2274835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQ),
     /* 2274838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274853 */     // GIR_Coverage, 64647,
     /* 2274853 */     GIR_EraseRootFromParent_Done,
     /* 2274854 */   // Label 30653: @2274854
     /* 2274854 */   GIM_Try, /*On fail goto*//*Label 30654*/ GIMT_Encode4(2274926), // Rule ID 64649 //
     /* 2274859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274882 */     // MIs[1] Operand 1
     /* 2274882 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2274887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274907 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETNE:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVNE:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2274907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVNE),
     /* 2274910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274925 */     // GIR_Coverage, 64649,
     /* 2274925 */     GIR_EraseRootFromParent_Done,
     /* 2274926 */   // Label 30654: @2274926
     /* 2274926 */   GIM_Try, /*On fail goto*//*Label 30655*/ GIMT_Encode4(2274998), // Rule ID 64651 //
     /* 2274931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2274934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2274942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2274946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2274950 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2274954 */     // MIs[1] Operand 1
     /* 2274954 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2274959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2274977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2274979 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETLT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVLT:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2274979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLT),
     /* 2274982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2274984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2274986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2274990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2274994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2274996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274997 */     // GIR_Coverage, 64651,
     /* 2274997 */     GIR_EraseRootFromParent_Done,
     /* 2274998 */   // Label 30655: @2274998
     /* 2274998 */   GIM_Try, /*On fail goto*//*Label 30656*/ GIMT_Encode4(2275070), // Rule ID 64653 //
     /* 2275003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2275006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2275014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 2275018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2275022 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 2275026 */     // MIs[1] Operand 1
     /* 2275026 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2275031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2275051 */     // (select:{ *:[i64] } (setcc:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, SETULT:{ *:[Other] }), GPRNoX0:{ *:[i64] }:$rs3, GPRNoX0:{ *:[i64] }:$rd)  =>  (QC_MVLTU:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rs2, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2275051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVLTU),
     /* 2275054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rd
     /* 2275058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /* 2275062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rs2
     /* 2275066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2275068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275069 */     // GIR_Coverage, 64653,
     /* 2275069 */     GIR_EraseRootFromParent_Done,
     /* 2275070 */   // Label 30656: @2275070
     /* 2275070 */   GIM_Try, /*On fail goto*//*Label 30657*/ GIMT_Encode4(2275107), // Rule ID 62574 //
     /* 2275075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2275078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275094 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b)  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b, GPR:{ *:[i64] }:$cond)
     /* 2275094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2275097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275099 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2275101 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2275103 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2275105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275106 */     // GIR_Coverage, 62574,
     /* 2275106 */     GIR_EraseRootFromParent_Done,
     /* 2275107 */   // Label 30657: @2275107
     /* 2275107 */   GIM_Try, /*On fail goto*//*Label 30658*/ GIMT_Encode4(2275147), // Rule ID 64645 //
     /* 2275112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcicm_IsRV32_HwMode0),
     /* 2275115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275131 */     // (select:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rs1, GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs3)  =>  (QC_MVEQI:{ *:[i64] } GPRNoX0:{ *:[i64] }:$rd, GPRNoX0:{ *:[i64] }:$rs1, 0:{ *:[i64] }, GPRNoX0:{ *:[i64] }:$rs3)
     /* 2275131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_MVEQI),
     /* 2275134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2275136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2275138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2275143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2275145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275146 */     // GIR_Coverage, 64645,
     /* 2275146 */     GIR_EraseRootFromParent_Done,
     /* 2275147 */   // Label 30658: @2275147
     /* 2275147 */   GIM_Try, /*On fail goto*//*Label 30659*/ GIMT_Encode4(2275184), // Rule ID 64667 //
     /* 2275152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
     /* 2275155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2275171 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
     /* 2275171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2275174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2275180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2275182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275183 */     // GIR_Coverage, 64667,
     /* 2275183 */     GIR_EraseRootFromParent_Done,
     /* 2275184 */   // Label 30659: @2275184
     /* 2275184 */   GIM_Reject,
     /* 2275185 */ // Label 30646: @2275185
     /* 2275185 */ GIM_Reject,
     /* 2275186 */ // Label 30609: @2275186
     /* 2275186 */ GIM_Try, /*On fail goto*//*Label 30660*/ GIMT_Encode4(2275305),
     /* 2275191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2275194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2275197 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2275200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2275204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2275208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275212 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275216 */   GIM_Try, /*On fail goto*//*Label 30661*/ GIMT_Encode4(2275260), // Rule ID 52238 //
     /* 2275221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275224 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2275227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2275241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275250 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275259 */     // GIR_Coverage, 52238,
     /* 2275259 */     GIR_EraseRootFromParent_Done,
     /* 2275260 */   // Label 30661: @2275260
     /* 2275260 */   GIM_Try, /*On fail goto*//*Label 30662*/ GIMT_Encode4(2275304), // Rule ID 52239 //
     /* 2275265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275268 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2275271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2275285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275294 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275303 */     // GIR_Coverage, 52239,
     /* 2275303 */     GIR_EraseRootFromParent_Done,
     /* 2275304 */   // Label 30662: @2275304
     /* 2275304 */   GIM_Reject,
     /* 2275305 */ // Label 30660: @2275305
     /* 2275305 */ GIM_Reject,
     /* 2275306 */ // Label 30610: @2275306
     /* 2275306 */ GIM_Try, /*On fail goto*//*Label 30663*/ GIMT_Encode4(2275513),
     /* 2275311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2275314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2275317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2275320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2275324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2275328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275332 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275336 */   GIM_Try, /*On fail goto*//*Label 30664*/ GIMT_Encode4(2275380), // Rule ID 52256 //
     /* 2275341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275344 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2275344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2275361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275370 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275379 */     // GIR_Coverage, 52256,
     /* 2275379 */     GIR_EraseRootFromParent_Done,
     /* 2275380 */   // Label 30664: @2275380
     /* 2275380 */   GIM_Try, /*On fail goto*//*Label 30665*/ GIMT_Encode4(2275424), // Rule ID 52257 //
     /* 2275385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275388 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2275388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2275405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275414 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275423 */     // GIR_Coverage, 52257,
     /* 2275423 */     GIR_EraseRootFromParent_Done,
     /* 2275424 */   // Label 30665: @2275424
     /* 2275424 */   GIM_Try, /*On fail goto*//*Label 30666*/ GIMT_Encode4(2275468), // Rule ID 58078 //
     /* 2275429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275432 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2275432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2275449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275458 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275467 */     // GIR_Coverage, 58078,
     /* 2275467 */     GIR_EraseRootFromParent_Done,
     /* 2275468 */   // Label 30666: @2275468
     /* 2275468 */   GIM_Try, /*On fail goto*//*Label 30667*/ GIMT_Encode4(2275512), // Rule ID 58079 //
     /* 2275473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275476 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2275476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2275493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275502 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275511 */     // GIR_Coverage, 58079,
     /* 2275511 */     GIR_EraseRootFromParent_Done,
     /* 2275512 */   // Label 30667: @2275512
     /* 2275512 */   GIM_Reject,
     /* 2275513 */ // Label 30663: @2275513
     /* 2275513 */ GIM_Reject,
     /* 2275514 */ // Label 30611: @2275514
     /* 2275514 */ GIM_Try, /*On fail goto*//*Label 30668*/ GIMT_Encode4(2275721),
     /* 2275519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2275522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2275525 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2275528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2275532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2275536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275540 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275544 */   GIM_Try, /*On fail goto*//*Label 30669*/ GIMT_Encode4(2275588), // Rule ID 52268 //
     /* 2275549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275552 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2275552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2275555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2275569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275578 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275587 */     // GIR_Coverage, 52268,
     /* 2275587 */     GIR_EraseRootFromParent_Done,
     /* 2275588 */   // Label 30669: @2275588
     /* 2275588 */   GIM_Try, /*On fail goto*//*Label 30670*/ GIMT_Encode4(2275632), // Rule ID 52269 //
     /* 2275593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275596 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2275596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2275599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2275613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275622 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275631 */     // GIR_Coverage, 52269,
     /* 2275631 */     GIR_EraseRootFromParent_Done,
     /* 2275632 */   // Label 30670: @2275632
     /* 2275632 */   GIM_Try, /*On fail goto*//*Label 30671*/ GIMT_Encode4(2275676), // Rule ID 58098 //
     /* 2275637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275640 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2275640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2275643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2275657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275666 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275675 */     // GIR_Coverage, 58098,
     /* 2275675 */     GIR_EraseRootFromParent_Done,
     /* 2275676 */   // Label 30671: @2275676
     /* 2275676 */   GIM_Try, /*On fail goto*//*Label 30672*/ GIMT_Encode4(2275720), // Rule ID 58099 //
     /* 2275681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275684 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2275684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2275687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2275701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275710 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275719 */     // GIR_Coverage, 58099,
     /* 2275719 */     GIR_EraseRootFromParent_Done,
     /* 2275720 */   // Label 30672: @2275720
     /* 2275720 */   GIM_Reject,
     /* 2275721 */ // Label 30668: @2275721
     /* 2275721 */ GIM_Reject,
     /* 2275722 */ // Label 30612: @2275722
     /* 2275722 */ GIM_Try, /*On fail goto*//*Label 30673*/ GIMT_Encode4(2275929),
     /* 2275727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2275730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2275733 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2275736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2275740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2275744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275752 */   GIM_Try, /*On fail goto*//*Label 30674*/ GIMT_Encode4(2275796), // Rule ID 52292 //
     /* 2275757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2275760 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2275760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2275763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2275777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275786 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275795 */     // GIR_Coverage, 52292,
     /* 2275795 */     GIR_EraseRootFromParent_Done,
     /* 2275796 */   // Label 30674: @2275796
     /* 2275796 */   GIM_Try, /*On fail goto*//*Label 30675*/ GIMT_Encode4(2275840), // Rule ID 52293 //
     /* 2275801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2275804 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2275804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2275807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2275821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275830 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275839 */     // GIR_Coverage, 52293,
     /* 2275839 */     GIR_EraseRootFromParent_Done,
     /* 2275840 */   // Label 30675: @2275840
     /* 2275840 */   GIM_Try, /*On fail goto*//*Label 30676*/ GIMT_Encode4(2275884), // Rule ID 58128 //
     /* 2275845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2275848 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2275848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2275851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2275865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275874 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275883 */     // GIR_Coverage, 58128,
     /* 2275883 */     GIR_EraseRootFromParent_Done,
     /* 2275884 */   // Label 30676: @2275884
     /* 2275884 */   GIM_Try, /*On fail goto*//*Label 30677*/ GIMT_Encode4(2275928), // Rule ID 58129 //
     /* 2275889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2275892 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2275892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2275895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2275909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275918 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275927 */     // GIR_Coverage, 58129,
     /* 2275927 */     GIR_EraseRootFromParent_Done,
     /* 2275928 */   // Label 30677: @2275928
     /* 2275928 */   GIM_Reject,
     /* 2275929 */ // Label 30673: @2275929
     /* 2275929 */ GIM_Reject,
     /* 2275930 */ // Label 30613: @2275930
     /* 2275930 */ GIM_Try, /*On fail goto*//*Label 30678*/ GIMT_Encode4(2276049),
     /* 2275935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2275938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2275941 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2275944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2275948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2275952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275956 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275960 */   GIM_Try, /*On fail goto*//*Label 30679*/ GIMT_Encode4(2276004), // Rule ID 52244 //
     /* 2275965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275968 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2275971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2275985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2275992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2275994 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2275996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276003 */     // GIR_Coverage, 52244,
     /* 2276003 */     GIR_EraseRootFromParent_Done,
     /* 2276004 */   // Label 30679: @2276004
     /* 2276004 */   GIM_Try, /*On fail goto*//*Label 30680*/ GIMT_Encode4(2276048), // Rule ID 52245 //
     /* 2276009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276012 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2276015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2276029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276038 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276047 */     // GIR_Coverage, 52245,
     /* 2276047 */     GIR_EraseRootFromParent_Done,
     /* 2276048 */   // Label 30680: @2276048
     /* 2276048 */   GIM_Reject,
     /* 2276049 */ // Label 30678: @2276049
     /* 2276049 */ GIM_Reject,
     /* 2276050 */ // Label 30614: @2276050
     /* 2276050 */ GIM_Try, /*On fail goto*//*Label 30681*/ GIMT_Encode4(2276257),
     /* 2276055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2276058 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2276061 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2276064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2276068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276076 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276080 */   GIM_Try, /*On fail goto*//*Label 30682*/ GIMT_Encode4(2276124), // Rule ID 52262 //
     /* 2276085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276088 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2276091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276114 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276123 */     // GIR_Coverage, 52262,
     /* 2276123 */     GIR_EraseRootFromParent_Done,
     /* 2276124 */   // Label 30682: @2276124
     /* 2276124 */   GIM_Try, /*On fail goto*//*Label 30683*/ GIMT_Encode4(2276168), // Rule ID 52263 //
     /* 2276129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276132 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2276135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276158 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276167 */     // GIR_Coverage, 52263,
     /* 2276167 */     GIR_EraseRootFromParent_Done,
     /* 2276168 */   // Label 30683: @2276168
     /* 2276168 */   GIM_Try, /*On fail goto*//*Label 30684*/ GIMT_Encode4(2276212), // Rule ID 58088 //
     /* 2276173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276176 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2276179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276202 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276211 */     // GIR_Coverage, 58088,
     /* 2276211 */     GIR_EraseRootFromParent_Done,
     /* 2276212 */   // Label 30684: @2276212
     /* 2276212 */   GIM_Try, /*On fail goto*//*Label 30685*/ GIMT_Encode4(2276256), // Rule ID 58089 //
     /* 2276217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276220 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2276223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276246 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276255 */     // GIR_Coverage, 58089,
     /* 2276255 */     GIR_EraseRootFromParent_Done,
     /* 2276256 */   // Label 30685: @2276256
     /* 2276256 */   GIM_Reject,
     /* 2276257 */ // Label 30681: @2276257
     /* 2276257 */ GIM_Reject,
     /* 2276258 */ // Label 30615: @2276258
     /* 2276258 */ GIM_Try, /*On fail goto*//*Label 30686*/ GIMT_Encode4(2276465),
     /* 2276263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2276266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2276269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2276272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2276276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276284 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276288 */   GIM_Try, /*On fail goto*//*Label 30687*/ GIMT_Encode4(2276332), // Rule ID 52286 //
     /* 2276293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276296 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2276299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276322 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276331 */     // GIR_Coverage, 52286,
     /* 2276331 */     GIR_EraseRootFromParent_Done,
     /* 2276332 */   // Label 30687: @2276332
     /* 2276332 */   GIM_Try, /*On fail goto*//*Label 30688*/ GIMT_Encode4(2276376), // Rule ID 52287 //
     /* 2276337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276340 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2276343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276366 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276375 */     // GIR_Coverage, 52287,
     /* 2276375 */     GIR_EraseRootFromParent_Done,
     /* 2276376 */   // Label 30688: @2276376
     /* 2276376 */   GIM_Try, /*On fail goto*//*Label 30689*/ GIMT_Encode4(2276420), // Rule ID 58118 //
     /* 2276381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276384 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2276384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2276387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276410 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276419 */     // GIR_Coverage, 58118,
     /* 2276419 */     GIR_EraseRootFromParent_Done,
     /* 2276420 */   // Label 30689: @2276420
     /* 2276420 */   GIM_Try, /*On fail goto*//*Label 30690*/ GIMT_Encode4(2276464), // Rule ID 58119 //
     /* 2276425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276428 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2276428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2276431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276454 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276463 */     // GIR_Coverage, 58119,
     /* 2276463 */     GIR_EraseRootFromParent_Done,
     /* 2276464 */   // Label 30690: @2276464
     /* 2276464 */   GIM_Reject,
     /* 2276465 */ // Label 30686: @2276465
     /* 2276465 */ GIM_Reject,
     /* 2276466 */ // Label 30616: @2276466
     /* 2276466 */ GIM_Try, /*On fail goto*//*Label 30691*/ GIMT_Encode4(2276673),
     /* 2276471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2276474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2276477 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2276480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2276484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276492 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276496 */   GIM_Try, /*On fail goto*//*Label 30692*/ GIMT_Encode4(2276540), // Rule ID 52352 //
     /* 2276501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2276504 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2276504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2276507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2276521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276530 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276539 */     // GIR_Coverage, 52352,
     /* 2276539 */     GIR_EraseRootFromParent_Done,
     /* 2276540 */   // Label 30692: @2276540
     /* 2276540 */   GIM_Try, /*On fail goto*//*Label 30693*/ GIMT_Encode4(2276584), // Rule ID 52353 //
     /* 2276545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2276548 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2276548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2276551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2276565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276574 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276583 */     // GIR_Coverage, 52353,
     /* 2276583 */     GIR_EraseRootFromParent_Done,
     /* 2276584 */   // Label 30693: @2276584
     /* 2276584 */   GIM_Try, /*On fail goto*//*Label 30694*/ GIMT_Encode4(2276628), // Rule ID 58198 //
     /* 2276589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2276592 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2276592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2276595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2276609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276618 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276627 */     // GIR_Coverage, 58198,
     /* 2276627 */     GIR_EraseRootFromParent_Done,
     /* 2276628 */   // Label 30694: @2276628
     /* 2276628 */   GIM_Try, /*On fail goto*//*Label 30695*/ GIMT_Encode4(2276672), // Rule ID 58199 //
     /* 2276633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2276636 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2276636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2276639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2276653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276662 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276671 */     // GIR_Coverage, 58199,
     /* 2276671 */     GIR_EraseRootFromParent_Done,
     /* 2276672 */   // Label 30695: @2276672
     /* 2276672 */   GIM_Reject,
     /* 2276673 */ // Label 30691: @2276673
     /* 2276673 */ GIM_Reject,
     /* 2276674 */ // Label 30617: @2276674
     /* 2276674 */ GIM_Try, /*On fail goto*//*Label 30696*/ GIMT_Encode4(2276793),
     /* 2276679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2276682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2276685 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2276688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2276692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276700 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276704 */   GIM_Try, /*On fail goto*//*Label 30697*/ GIMT_Encode4(2276748), // Rule ID 52250 //
     /* 2276709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276712 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2276715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276738 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276747 */     // GIR_Coverage, 52250,
     /* 2276747 */     GIR_EraseRootFromParent_Done,
     /* 2276748 */   // Label 30697: @2276748
     /* 2276748 */   GIM_Try, /*On fail goto*//*Label 30698*/ GIMT_Encode4(2276792), // Rule ID 52251 //
     /* 2276753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276756 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2276759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2276773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276782 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276791 */     // GIR_Coverage, 52251,
     /* 2276791 */     GIR_EraseRootFromParent_Done,
     /* 2276792 */   // Label 30698: @2276792
     /* 2276792 */   GIM_Reject,
     /* 2276793 */ // Label 30696: @2276793
     /* 2276793 */ GIM_Reject,
     /* 2276794 */ // Label 30618: @2276794
     /* 2276794 */ GIM_Try, /*On fail goto*//*Label 30699*/ GIMT_Encode4(2277001),
     /* 2276799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2276802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2276805 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2276808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2276812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2276816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276820 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276824 */   GIM_Try, /*On fail goto*//*Label 30700*/ GIMT_Encode4(2276868), // Rule ID 52280 //
     /* 2276829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276832 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2276835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276858 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276867 */     // GIR_Coverage, 52280,
     /* 2276867 */     GIR_EraseRootFromParent_Done,
     /* 2276868 */   // Label 30700: @2276868
     /* 2276868 */   GIM_Try, /*On fail goto*//*Label 30701*/ GIMT_Encode4(2276912), // Rule ID 52281 //
     /* 2276873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276876 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2276879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276902 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276911 */     // GIR_Coverage, 52281,
     /* 2276911 */     GIR_EraseRootFromParent_Done,
     /* 2276912 */   // Label 30701: @2276912
     /* 2276912 */   GIM_Try, /*On fail goto*//*Label 30702*/ GIMT_Encode4(2276956), // Rule ID 58108 //
     /* 2276917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276920 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2276920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2276923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276946 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276955 */     // GIR_Coverage, 58108,
     /* 2276955 */     GIR_EraseRootFromParent_Done,
     /* 2276956 */   // Label 30702: @2276956
     /* 2276956 */   GIM_Try, /*On fail goto*//*Label 30703*/ GIMT_Encode4(2277000), // Rule ID 58109 //
     /* 2276961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276964 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2276964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2276967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2276981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2276988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2276990 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2276992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276999 */     // GIR_Coverage, 58109,
     /* 2276999 */     GIR_EraseRootFromParent_Done,
     /* 2277000 */   // Label 30703: @2277000
     /* 2277000 */   GIM_Reject,
     /* 2277001 */ // Label 30699: @2277001
     /* 2277001 */ GIM_Reject,
     /* 2277002 */ // Label 30619: @2277002
     /* 2277002 */ GIM_Try, /*On fail goto*//*Label 30704*/ GIMT_Encode4(2277209),
     /* 2277007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2277010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2277013 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2277016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2277020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277028 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277032 */   GIM_Try, /*On fail goto*//*Label 30705*/ GIMT_Encode4(2277076), // Rule ID 52334 //
     /* 2277037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277040 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2277040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277066 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277075 */     // GIR_Coverage, 52334,
     /* 2277075 */     GIR_EraseRootFromParent_Done,
     /* 2277076 */   // Label 30705: @2277076
     /* 2277076 */   GIM_Try, /*On fail goto*//*Label 30706*/ GIMT_Encode4(2277120), // Rule ID 52335 //
     /* 2277081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277084 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2277084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277110 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277119 */     // GIR_Coverage, 52335,
     /* 2277119 */     GIR_EraseRootFromParent_Done,
     /* 2277120 */   // Label 30706: @2277120
     /* 2277120 */   GIM_Try, /*On fail goto*//*Label 30707*/ GIMT_Encode4(2277164), // Rule ID 58168 //
     /* 2277125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277128 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2277128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277154 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277163 */     // GIR_Coverage, 58168,
     /* 2277163 */     GIR_EraseRootFromParent_Done,
     /* 2277164 */   // Label 30707: @2277164
     /* 2277164 */   GIM_Try, /*On fail goto*//*Label 30708*/ GIMT_Encode4(2277208), // Rule ID 58169 //
     /* 2277169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277172 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2277172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2277175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277198 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277207 */     // GIR_Coverage, 58169,
     /* 2277207 */     GIR_EraseRootFromParent_Done,
     /* 2277208 */   // Label 30708: @2277208
     /* 2277208 */   GIM_Reject,
     /* 2277209 */ // Label 30704: @2277209
     /* 2277209 */ GIM_Reject,
     /* 2277210 */ // Label 30620: @2277210
     /* 2277210 */ GIM_Try, /*On fail goto*//*Label 30709*/ GIMT_Encode4(2277417),
     /* 2277215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2277218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2277221 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2277224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2277228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277236 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277240 */   GIM_Try, /*On fail goto*//*Label 30710*/ GIMT_Encode4(2277284), // Rule ID 52358 //
     /* 2277245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2277248 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2277248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2277251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277274 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277283 */     // GIR_Coverage, 52358,
     /* 2277283 */     GIR_EraseRootFromParent_Done,
     /* 2277284 */   // Label 30710: @2277284
     /* 2277284 */   GIM_Try, /*On fail goto*//*Label 30711*/ GIMT_Encode4(2277328), // Rule ID 52359 //
     /* 2277289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2277292 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2277292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2277295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277318 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277327 */     // GIR_Coverage, 52359,
     /* 2277327 */     GIR_EraseRootFromParent_Done,
     /* 2277328 */   // Label 30711: @2277328
     /* 2277328 */   GIM_Try, /*On fail goto*//*Label 30712*/ GIMT_Encode4(2277372), // Rule ID 58208 //
     /* 2277333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2277336 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2277336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2277339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277362 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277371 */     // GIR_Coverage, 58208,
     /* 2277371 */     GIR_EraseRootFromParent_Done,
     /* 2277372 */   // Label 30712: @2277372
     /* 2277372 */   GIM_Try, /*On fail goto*//*Label 30713*/ GIMT_Encode4(2277416), // Rule ID 58209 //
     /* 2277377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2277380 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2277380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2277383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277406 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277415 */     // GIR_Coverage, 58209,
     /* 2277415 */     GIR_EraseRootFromParent_Done,
     /* 2277416 */   // Label 30713: @2277416
     /* 2277416 */   GIM_Reject,
     /* 2277417 */ // Label 30709: @2277417
     /* 2277417 */ GIM_Reject,
     /* 2277418 */ // Label 30621: @2277418
     /* 2277418 */ GIM_Try, /*On fail goto*//*Label 30714*/ GIMT_Encode4(2277537),
     /* 2277423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2277426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2277429 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2277432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2277436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277444 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2277448 */   GIM_Try, /*On fail goto*//*Label 30715*/ GIMT_Encode4(2277492), // Rule ID 52274 //
     /* 2277453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277456 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2277459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2277473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277482 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277491 */     // GIR_Coverage, 52274,
     /* 2277491 */     GIR_EraseRootFromParent_Done,
     /* 2277492 */   // Label 30715: @2277492
     /* 2277492 */   GIM_Try, /*On fail goto*//*Label 30716*/ GIMT_Encode4(2277536), // Rule ID 52275 //
     /* 2277497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277500 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2277503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2277517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277526 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277535 */     // GIR_Coverage, 52275,
     /* 2277535 */     GIR_EraseRootFromParent_Done,
     /* 2277536 */   // Label 30716: @2277536
     /* 2277536 */   GIM_Reject,
     /* 2277537 */ // Label 30714: @2277537
     /* 2277537 */ GIM_Reject,
     /* 2277538 */ // Label 30622: @2277538
     /* 2277538 */ GIM_Try, /*On fail goto*//*Label 30717*/ GIMT_Encode4(2277745),
     /* 2277543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2277546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2277549 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2277552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2277556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277564 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277568 */   GIM_Try, /*On fail goto*//*Label 30718*/ GIMT_Encode4(2277612), // Rule ID 52316 //
     /* 2277573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277576 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2277576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2277579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277602 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277611 */     // GIR_Coverage, 52316,
     /* 2277611 */     GIR_EraseRootFromParent_Done,
     /* 2277612 */   // Label 30718: @2277612
     /* 2277612 */   GIM_Try, /*On fail goto*//*Label 30719*/ GIMT_Encode4(2277656), // Rule ID 52317 //
     /* 2277617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277620 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2277623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277646 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277655 */     // GIR_Coverage, 52317,
     /* 2277655 */     GIR_EraseRootFromParent_Done,
     /* 2277656 */   // Label 30719: @2277656
     /* 2277656 */   GIM_Try, /*On fail goto*//*Label 30720*/ GIMT_Encode4(2277700), // Rule ID 58138 //
     /* 2277661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277664 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2277664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2277667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277690 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277699 */     // GIR_Coverage, 58138,
     /* 2277699 */     GIR_EraseRootFromParent_Done,
     /* 2277700 */   // Label 30720: @2277700
     /* 2277700 */   GIM_Try, /*On fail goto*//*Label 30721*/ GIMT_Encode4(2277744), // Rule ID 58139 //
     /* 2277705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277708 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2277708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2277711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2277725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277734 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277743 */     // GIR_Coverage, 58139,
     /* 2277743 */     GIR_EraseRootFromParent_Done,
     /* 2277744 */   // Label 30721: @2277744
     /* 2277744 */   GIM_Reject,
     /* 2277745 */ // Label 30717: @2277745
     /* 2277745 */ GIM_Reject,
     /* 2277746 */ // Label 30623: @2277746
     /* 2277746 */ GIM_Try, /*On fail goto*//*Label 30722*/ GIMT_Encode4(2277953),
     /* 2277751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2277754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2277757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2277760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2277764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277772 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277776 */   GIM_Try, /*On fail goto*//*Label 30723*/ GIMT_Encode4(2277820), // Rule ID 52340 //
     /* 2277781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277784 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2277784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2277787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277810 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277819 */     // GIR_Coverage, 52340,
     /* 2277819 */     GIR_EraseRootFromParent_Done,
     /* 2277820 */   // Label 30723: @2277820
     /* 2277820 */   GIM_Try, /*On fail goto*//*Label 30724*/ GIMT_Encode4(2277864), // Rule ID 52341 //
     /* 2277825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277828 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2277828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2277831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277854 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277863 */     // GIR_Coverage, 52341,
     /* 2277863 */     GIR_EraseRootFromParent_Done,
     /* 2277864 */   // Label 30724: @2277864
     /* 2277864 */   GIM_Try, /*On fail goto*//*Label 30725*/ GIMT_Encode4(2277908), // Rule ID 58178 //
     /* 2277869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277872 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2277872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2277875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277898 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277907 */     // GIR_Coverage, 58178,
     /* 2277907 */     GIR_EraseRootFromParent_Done,
     /* 2277908 */   // Label 30725: @2277908
     /* 2277908 */   GIM_Try, /*On fail goto*//*Label 30726*/ GIMT_Encode4(2277952), // Rule ID 58179 //
     /* 2277913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277916 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2277916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2277919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2277933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2277940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2277942 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2277944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277951 */     // GIR_Coverage, 58179,
     /* 2277951 */     GIR_EraseRootFromParent_Done,
     /* 2277952 */   // Label 30726: @2277952
     /* 2277952 */   GIM_Reject,
     /* 2277953 */ // Label 30722: @2277953
     /* 2277953 */ GIM_Reject,
     /* 2277954 */ // Label 30624: @2277954
     /* 2277954 */ GIM_Try, /*On fail goto*//*Label 30727*/ GIMT_Encode4(2278161),
     /* 2277959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2277962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2277965 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2277968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2277972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2277976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277980 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277984 */   GIM_Try, /*On fail goto*//*Label 30728*/ GIMT_Encode4(2278028), // Rule ID 52364 //
     /* 2277989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2277992 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2277992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2277995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278018 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278027 */     // GIR_Coverage, 52364,
     /* 2278027 */     GIR_EraseRootFromParent_Done,
     /* 2278028 */   // Label 30728: @2278028
     /* 2278028 */   GIM_Try, /*On fail goto*//*Label 30729*/ GIMT_Encode4(2278072), // Rule ID 52365 //
     /* 2278033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2278036 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2278036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2278039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278062 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278071 */     // GIR_Coverage, 52365,
     /* 2278071 */     GIR_EraseRootFromParent_Done,
     /* 2278072 */   // Label 30729: @2278072
     /* 2278072 */   GIM_Try, /*On fail goto*//*Label 30730*/ GIMT_Encode4(2278116), // Rule ID 58218 //
     /* 2278077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2278080 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2278080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2278083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278106 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278115 */     // GIR_Coverage, 58218,
     /* 2278115 */     GIR_EraseRootFromParent_Done,
     /* 2278116 */   // Label 30730: @2278116
     /* 2278116 */   GIM_Try, /*On fail goto*//*Label 30731*/ GIMT_Encode4(2278160), // Rule ID 58219 //
     /* 2278121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2278124 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2278124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2278127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278150 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278159 */     // GIR_Coverage, 58219,
     /* 2278159 */     GIR_EraseRootFromParent_Done,
     /* 2278160 */   // Label 30731: @2278160
     /* 2278160 */   GIM_Reject,
     /* 2278161 */ // Label 30727: @2278161
     /* 2278161 */ GIM_Reject,
     /* 2278162 */ // Label 30625: @2278162
     /* 2278162 */ GIM_Try, /*On fail goto*//*Label 30732*/ GIMT_Encode4(2278281),
     /* 2278167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2278170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2278173 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2278176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2278180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278188 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278192 */   GIM_Try, /*On fail goto*//*Label 30733*/ GIMT_Encode4(2278236), // Rule ID 52298 //
     /* 2278197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278200 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2278203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2278217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278226 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278235 */     // GIR_Coverage, 52298,
     /* 2278235 */     GIR_EraseRootFromParent_Done,
     /* 2278236 */   // Label 30733: @2278236
     /* 2278236 */   GIM_Try, /*On fail goto*//*Label 30734*/ GIMT_Encode4(2278280), // Rule ID 52299 //
     /* 2278241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278244 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2278247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2278261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278270 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278279 */     // GIR_Coverage, 52299,
     /* 2278279 */     GIR_EraseRootFromParent_Done,
     /* 2278280 */   // Label 30734: @2278280
     /* 2278280 */   GIM_Reject,
     /* 2278281 */ // Label 30732: @2278281
     /* 2278281 */ GIM_Reject,
     /* 2278282 */ // Label 30626: @2278282
     /* 2278282 */ GIM_Try, /*On fail goto*//*Label 30735*/ GIMT_Encode4(2278489),
     /* 2278287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2278290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2278293 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2278296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2278300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278308 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278312 */   GIM_Try, /*On fail goto*//*Label 30736*/ GIMT_Encode4(2278356), // Rule ID 52322 //
     /* 2278317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278320 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278346 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278355 */     // GIR_Coverage, 52322,
     /* 2278355 */     GIR_EraseRootFromParent_Done,
     /* 2278356 */   // Label 30736: @2278356
     /* 2278356 */   GIM_Try, /*On fail goto*//*Label 30737*/ GIMT_Encode4(2278400), // Rule ID 52323 //
     /* 2278361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278364 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278390 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278399 */     // GIR_Coverage, 52323,
     /* 2278399 */     GIR_EraseRootFromParent_Done,
     /* 2278400 */   // Label 30737: @2278400
     /* 2278400 */   GIM_Try, /*On fail goto*//*Label 30738*/ GIMT_Encode4(2278444), // Rule ID 58148 //
     /* 2278405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278408 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278434 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278443 */     // GIR_Coverage, 58148,
     /* 2278443 */     GIR_EraseRootFromParent_Done,
     /* 2278444 */   // Label 30738: @2278444
     /* 2278444 */   GIM_Try, /*On fail goto*//*Label 30739*/ GIMT_Encode4(2278488), // Rule ID 58149 //
     /* 2278449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278452 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2278455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278478 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278487 */     // GIR_Coverage, 58149,
     /* 2278487 */     GIR_EraseRootFromParent_Done,
     /* 2278488 */   // Label 30739: @2278488
     /* 2278488 */   GIM_Reject,
     /* 2278489 */ // Label 30735: @2278489
     /* 2278489 */ GIM_Reject,
     /* 2278490 */ // Label 30627: @2278490
     /* 2278490 */ GIM_Try, /*On fail goto*//*Label 30740*/ GIMT_Encode4(2278697),
     /* 2278495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2278498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2278501 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2278504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2278508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278516 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278520 */   GIM_Try, /*On fail goto*//*Label 30741*/ GIMT_Encode4(2278564), // Rule ID 52346 //
     /* 2278525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278528 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2278528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2278531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278554 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278563 */     // GIR_Coverage, 52346,
     /* 2278563 */     GIR_EraseRootFromParent_Done,
     /* 2278564 */   // Label 30741: @2278564
     /* 2278564 */   GIM_Try, /*On fail goto*//*Label 30742*/ GIMT_Encode4(2278608), // Rule ID 52347 //
     /* 2278569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278572 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2278572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2278575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278598 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278607 */     // GIR_Coverage, 52347,
     /* 2278607 */     GIR_EraseRootFromParent_Done,
     /* 2278608 */   // Label 30742: @2278608
     /* 2278608 */   GIM_Try, /*On fail goto*//*Label 30743*/ GIMT_Encode4(2278652), // Rule ID 58188 //
     /* 2278613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278616 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2278616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2278619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278642 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278651 */     // GIR_Coverage, 58188,
     /* 2278651 */     GIR_EraseRootFromParent_Done,
     /* 2278652 */   // Label 30743: @2278652
     /* 2278652 */   GIM_Try, /*On fail goto*//*Label 30744*/ GIMT_Encode4(2278696), // Rule ID 58189 //
     /* 2278657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278660 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2278660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2278663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278686 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278695 */     // GIR_Coverage, 58189,
     /* 2278695 */     GIR_EraseRootFromParent_Done,
     /* 2278696 */   // Label 30744: @2278696
     /* 2278696 */   GIM_Reject,
     /* 2278697 */ // Label 30740: @2278697
     /* 2278697 */ GIM_Reject,
     /* 2278698 */ // Label 30628: @2278698
     /* 2278698 */ GIM_Try, /*On fail goto*//*Label 30745*/ GIMT_Encode4(2278817),
     /* 2278703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2278706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2278709 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2278712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2278716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278724 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2278728 */   GIM_Try, /*On fail goto*//*Label 30746*/ GIMT_Encode4(2278772), // Rule ID 52304 //
     /* 2278733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278736 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2278739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278762 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278771 */     // GIR_Coverage, 52304,
     /* 2278771 */     GIR_EraseRootFromParent_Done,
     /* 2278772 */   // Label 30746: @2278772
     /* 2278772 */   GIM_Try, /*On fail goto*//*Label 30747*/ GIMT_Encode4(2278816), // Rule ID 52305 //
     /* 2278777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278780 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2278783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2278797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278806 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278815 */     // GIR_Coverage, 52305,
     /* 2278815 */     GIR_EraseRootFromParent_Done,
     /* 2278816 */   // Label 30747: @2278816
     /* 2278816 */   GIM_Reject,
     /* 2278817 */ // Label 30745: @2278817
     /* 2278817 */ GIM_Reject,
     /* 2278818 */ // Label 30629: @2278818
     /* 2278818 */ GIM_Try, /*On fail goto*//*Label 30748*/ GIMT_Encode4(2279025),
     /* 2278823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2278826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2278829 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2278832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2278836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2278840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278844 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2278848 */   GIM_Try, /*On fail goto*//*Label 30749*/ GIMT_Encode4(2278892), // Rule ID 52328 //
     /* 2278853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278856 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2278859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278882 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278891 */     // GIR_Coverage, 52328,
     /* 2278891 */     GIR_EraseRootFromParent_Done,
     /* 2278892 */   // Label 30749: @2278892
     /* 2278892 */   GIM_Try, /*On fail goto*//*Label 30750*/ GIMT_Encode4(2278936), // Rule ID 52329 //
     /* 2278897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278900 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2278903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278926 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278935 */     // GIR_Coverage, 52329,
     /* 2278935 */     GIR_EraseRootFromParent_Done,
     /* 2278936 */   // Label 30750: @2278936
     /* 2278936 */   GIM_Try, /*On fail goto*//*Label 30751*/ GIMT_Encode4(2278980), // Rule ID 58158 //
     /* 2278941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278944 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2278944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2278947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2278961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2278968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2278970 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2278972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278979 */     // GIR_Coverage, 58158,
     /* 2278979 */     GIR_EraseRootFromParent_Done,
     /* 2278980 */   // Label 30751: @2278980
     /* 2278980 */   GIM_Try, /*On fail goto*//*Label 30752*/ GIMT_Encode4(2279024), // Rule ID 58159 //
     /* 2278985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278988 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2278988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2278991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279014 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279023 */     // GIR_Coverage, 58159,
     /* 2279023 */     GIR_EraseRootFromParent_Done,
     /* 2279024 */   // Label 30752: @2279024
     /* 2279024 */   GIM_Reject,
     /* 2279025 */ // Label 30748: @2279025
     /* 2279025 */ GIM_Reject,
     /* 2279026 */ // Label 30630: @2279026
     /* 2279026 */ GIM_Try, /*On fail goto*//*Label 30753*/ GIMT_Encode4(2279145),
     /* 2279031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /* 2279034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2279037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2279040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2279044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2279048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279052 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279056 */   GIM_Try, /*On fail goto*//*Label 30754*/ GIMT_Encode4(2279100), // Rule ID 52310 //
     /* 2279061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279064 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2279067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279090 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279099 */     // GIR_Coverage, 52310,
     /* 2279099 */     GIR_EraseRootFromParent_Done,
     /* 2279100 */   // Label 30754: @2279100
     /* 2279100 */   GIM_Try, /*On fail goto*//*Label 30755*/ GIMT_Encode4(2279144), // Rule ID 52311 //
     /* 2279105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279108 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2279111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2279125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2279132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2279134 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2279136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279143 */     // GIR_Coverage, 52311,
     /* 2279143 */     GIR_EraseRootFromParent_Done,
     /* 2279144 */   // Label 30755: @2279144
     /* 2279144 */   GIM_Reject,
     /* 2279145 */ // Label 30753: @2279145
     /* 2279145 */ GIM_Reject,
     /* 2279146 */ // Label 30631: @2279146
     /* 2279146 */ GIM_Reject,
     /* 2279147 */ // Label 51: @2279147
     /* 2279147 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30780*/ GIMT_Encode4(2281880),
     /* 2279158 */ /*GILLT_s32*//*Label 30756*/ GIMT_Encode4(2279282),
     /* 2279162 */ /*GILLT_s64*//*Label 30757*/ GIMT_Encode4(2279316), GIMT_Encode4(0),
     /* 2279170 */ /*GILLT_nxv1s8*//*Label 30758*/ GIMT_Encode4(2279350),
     /* 2279174 */ /*GILLT_nxv1s16*//*Label 30759*/ GIMT_Encode4(2279465),
     /* 2279178 */ /*GILLT_nxv1s32*//*Label 30760*/ GIMT_Encode4(2279580),
     /* 2279182 */ /*GILLT_nxv1s64*//*Label 30761*/ GIMT_Encode4(2279695), GIMT_Encode4(0),
     /* 2279190 */ /*GILLT_nxv2s8*//*Label 30762*/ GIMT_Encode4(2279810),
     /* 2279194 */ /*GILLT_nxv2s16*//*Label 30763*/ GIMT_Encode4(2279925),
     /* 2279198 */ /*GILLT_nxv2s32*//*Label 30764*/ GIMT_Encode4(2280040),
     /* 2279202 */ /*GILLT_nxv2s64*//*Label 30765*/ GIMT_Encode4(2280155), GIMT_Encode4(0),
     /* 2279210 */ /*GILLT_nxv4s8*//*Label 30766*/ GIMT_Encode4(2280270),
     /* 2279214 */ /*GILLT_nxv4s16*//*Label 30767*/ GIMT_Encode4(2280385),
     /* 2279218 */ /*GILLT_nxv4s32*//*Label 30768*/ GIMT_Encode4(2280500),
     /* 2279222 */ /*GILLT_nxv4s64*//*Label 30769*/ GIMT_Encode4(2280615), GIMT_Encode4(0),
     /* 2279230 */ /*GILLT_nxv8s8*//*Label 30770*/ GIMT_Encode4(2280730),
     /* 2279234 */ /*GILLT_nxv8s16*//*Label 30771*/ GIMT_Encode4(2280845),
     /* 2279238 */ /*GILLT_nxv8s32*//*Label 30772*/ GIMT_Encode4(2280960),
     /* 2279242 */ /*GILLT_nxv8s64*//*Label 30773*/ GIMT_Encode4(2281075), GIMT_Encode4(0),
     /* 2279250 */ /*GILLT_nxv16s8*//*Label 30774*/ GIMT_Encode4(2281190),
     /* 2279254 */ /*GILLT_nxv16s16*//*Label 30775*/ GIMT_Encode4(2281305),
     /* 2279258 */ /*GILLT_nxv16s32*//*Label 30776*/ GIMT_Encode4(2281420), GIMT_Encode4(0),
     /* 2279266 */ /*GILLT_nxv32s8*//*Label 30777*/ GIMT_Encode4(2281535),
     /* 2279270 */ /*GILLT_nxv32s16*//*Label 30778*/ GIMT_Encode4(2281650), GIMT_Encode4(0),
     /* 2279278 */ /*GILLT_nxv64s8*//*Label 30779*/ GIMT_Encode4(2281765),
     /* 2279282 */ // Label 30756: @2279282
     /* 2279282 */ GIM_Try, /*On fail goto*//*Label 30781*/ GIMT_Encode4(2279315), // Rule ID 302 //
     /* 2279287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2279290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2279293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2279296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279308 */   // (mulhu:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2279308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2279313 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279314 */   // GIR_Coverage, 302,
     /* 2279314 */   GIR_Done,
     /* 2279315 */ // Label 30781: @2279315
     /* 2279315 */ GIM_Reject,
     /* 2279316 */ // Label 30757: @2279316
     /* 2279316 */ GIM_Try, /*On fail goto*//*Label 30782*/ GIMT_Encode4(2279349), // Rule ID 301 //
     /* 2279321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2279324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2279327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2279330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2279342 */   // (mulhu:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2279342 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2279347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2279348 */   // GIR_Coverage, 301,
     /* 2279348 */   GIR_Done,
     /* 2279349 */ // Label 30782: @2279349
     /* 2279349 */ GIM_Reject,
     /* 2279350 */ // Label 30758: @2279350
     /* 2279350 */ GIM_Try, /*On fail goto*//*Label 30783*/ GIMT_Encode4(2279464),
     /* 2279355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2279358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2279361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279373 */   GIM_Try, /*On fail goto*//*Label 30784*/ GIMT_Encode4(2279418), // Rule ID 51014 //
     /* 2279378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279381 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2279384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2279398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279417 */     // GIR_Coverage, 51014,
     /* 2279417 */     GIR_EraseRootFromParent_Done,
     /* 2279418 */   // Label 30784: @2279418
     /* 2279418 */   GIM_Try, /*On fail goto*//*Label 30785*/ GIMT_Encode4(2279463), // Rule ID 51015 //
     /* 2279423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279426 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2279429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2279443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279462 */     // GIR_Coverage, 51015,
     /* 2279462 */     GIR_EraseRootFromParent_Done,
     /* 2279463 */   // Label 30785: @2279463
     /* 2279463 */   GIM_Reject,
     /* 2279464 */ // Label 30783: @2279464
     /* 2279464 */ GIM_Reject,
     /* 2279465 */ // Label 30759: @2279465
     /* 2279465 */ GIM_Try, /*On fail goto*//*Label 30786*/ GIMT_Encode4(2279579),
     /* 2279470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2279473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2279476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279488 */   GIM_Try, /*On fail goto*//*Label 30787*/ GIMT_Encode4(2279533), // Rule ID 51026 //
     /* 2279493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279496 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2279499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2279513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279532 */     // GIR_Coverage, 51026,
     /* 2279532 */     GIR_EraseRootFromParent_Done,
     /* 2279533 */   // Label 30787: @2279533
     /* 2279533 */   GIM_Try, /*On fail goto*//*Label 30788*/ GIMT_Encode4(2279578), // Rule ID 51027 //
     /* 2279538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279541 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2279544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2279558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279577 */     // GIR_Coverage, 51027,
     /* 2279577 */     GIR_EraseRootFromParent_Done,
     /* 2279578 */   // Label 30788: @2279578
     /* 2279578 */   GIM_Reject,
     /* 2279579 */ // Label 30786: @2279579
     /* 2279579 */ GIM_Reject,
     /* 2279580 */ // Label 30760: @2279580
     /* 2279580 */ GIM_Try, /*On fail goto*//*Label 30789*/ GIMT_Encode4(2279694),
     /* 2279585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2279588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2279591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279603 */   GIM_Try, /*On fail goto*//*Label 30790*/ GIMT_Encode4(2279648), // Rule ID 51034 //
     /* 2279608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279611 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2279614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2279628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279647 */     // GIR_Coverage, 51034,
     /* 2279647 */     GIR_EraseRootFromParent_Done,
     /* 2279648 */   // Label 30790: @2279648
     /* 2279648 */   GIM_Try, /*On fail goto*//*Label 30791*/ GIMT_Encode4(2279693), // Rule ID 51035 //
     /* 2279653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279656 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2279659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2279673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279692 */     // GIR_Coverage, 51035,
     /* 2279692 */     GIR_EraseRootFromParent_Done,
     /* 2279693 */   // Label 30791: @2279693
     /* 2279693 */   GIM_Reject,
     /* 2279694 */ // Label 30789: @2279694
     /* 2279694 */ GIM_Reject,
     /* 2279695 */ // Label 30761: @2279695
     /* 2279695 */ GIM_Try, /*On fail goto*//*Label 30792*/ GIMT_Encode4(2279809),
     /* 2279700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2279703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2279706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279718 */   GIM_Try, /*On fail goto*//*Label 30793*/ GIMT_Encode4(2279763), // Rule ID 51102 //
     /* 2279723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2279726 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2279729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2279743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279762 */     // GIR_Coverage, 51102,
     /* 2279762 */     GIR_EraseRootFromParent_Done,
     /* 2279763 */   // Label 30793: @2279763
     /* 2279763 */   GIM_Try, /*On fail goto*//*Label 30794*/ GIMT_Encode4(2279808), // Rule ID 51103 //
     /* 2279768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2279771 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2279774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2279788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279807 */     // GIR_Coverage, 51103,
     /* 2279807 */     GIR_EraseRootFromParent_Done,
     /* 2279808 */   // Label 30794: @2279808
     /* 2279808 */   GIM_Reject,
     /* 2279809 */ // Label 30792: @2279809
     /* 2279809 */ GIM_Reject,
     /* 2279810 */ // Label 30762: @2279810
     /* 2279810 */ GIM_Try, /*On fail goto*//*Label 30795*/ GIMT_Encode4(2279924),
     /* 2279815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2279818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2279821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279833 */   GIM_Try, /*On fail goto*//*Label 30796*/ GIMT_Encode4(2279878), // Rule ID 51018 //
     /* 2279838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279841 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2279844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2279858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279877 */     // GIR_Coverage, 51018,
     /* 2279877 */     GIR_EraseRootFromParent_Done,
     /* 2279878 */   // Label 30796: @2279878
     /* 2279878 */   GIM_Try, /*On fail goto*//*Label 30797*/ GIMT_Encode4(2279923), // Rule ID 51019 //
     /* 2279883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279886 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2279889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2279903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279922 */     // GIR_Coverage, 51019,
     /* 2279922 */     GIR_EraseRootFromParent_Done,
     /* 2279923 */   // Label 30797: @2279923
     /* 2279923 */   GIM_Reject,
     /* 2279924 */ // Label 30795: @2279924
     /* 2279924 */ GIM_Reject,
     /* 2279925 */ // Label 30763: @2279925
     /* 2279925 */ GIM_Try, /*On fail goto*//*Label 30798*/ GIMT_Encode4(2280039),
     /* 2279930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2279933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2279936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279948 */   GIM_Try, /*On fail goto*//*Label 30799*/ GIMT_Encode4(2279993), // Rule ID 51030 //
     /* 2279953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279956 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2279959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2279973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279992 */     // GIR_Coverage, 51030,
     /* 2279992 */     GIR_EraseRootFromParent_Done,
     /* 2279993 */   // Label 30799: @2279993
     /* 2279993 */   GIM_Try, /*On fail goto*//*Label 30800*/ GIMT_Encode4(2280038), // Rule ID 51031 //
     /* 2279998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280001 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2280004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2280018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280037 */     // GIR_Coverage, 51031,
     /* 2280037 */     GIR_EraseRootFromParent_Done,
     /* 2280038 */   // Label 30800: @2280038
     /* 2280038 */   GIM_Reject,
     /* 2280039 */ // Label 30798: @2280039
     /* 2280039 */ GIM_Reject,
     /* 2280040 */ // Label 30764: @2280040
     /* 2280040 */ GIM_Try, /*On fail goto*//*Label 30801*/ GIMT_Encode4(2280154),
     /* 2280045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2280048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2280051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280063 */   GIM_Try, /*On fail goto*//*Label 30802*/ GIMT_Encode4(2280108), // Rule ID 51046 //
     /* 2280068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280071 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2280074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280107 */     // GIR_Coverage, 51046,
     /* 2280107 */     GIR_EraseRootFromParent_Done,
     /* 2280108 */   // Label 30802: @2280108
     /* 2280108 */   GIM_Try, /*On fail goto*//*Label 30803*/ GIMT_Encode4(2280153), // Rule ID 51047 //
     /* 2280113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280116 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2280119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280152 */     // GIR_Coverage, 51047,
     /* 2280152 */     GIR_EraseRootFromParent_Done,
     /* 2280153 */   // Label 30803: @2280153
     /* 2280153 */   GIM_Reject,
     /* 2280154 */ // Label 30801: @2280154
     /* 2280154 */ GIM_Reject,
     /* 2280155 */ // Label 30765: @2280155
     /* 2280155 */ GIM_Try, /*On fail goto*//*Label 30804*/ GIMT_Encode4(2280269),
     /* 2280160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2280163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2280166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280178 */   GIM_Try, /*On fail goto*//*Label 30805*/ GIMT_Encode4(2280223), // Rule ID 51106 //
     /* 2280183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2280186 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2280189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2280203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280222 */     // GIR_Coverage, 51106,
     /* 2280222 */     GIR_EraseRootFromParent_Done,
     /* 2280223 */   // Label 30805: @2280223
     /* 2280223 */   GIM_Try, /*On fail goto*//*Label 30806*/ GIMT_Encode4(2280268), // Rule ID 51107 //
     /* 2280228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2280231 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2280234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2280248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280267 */     // GIR_Coverage, 51107,
     /* 2280267 */     GIR_EraseRootFromParent_Done,
     /* 2280268 */   // Label 30806: @2280268
     /* 2280268 */   GIM_Reject,
     /* 2280269 */ // Label 30804: @2280269
     /* 2280269 */ GIM_Reject,
     /* 2280270 */ // Label 30766: @2280270
     /* 2280270 */ GIM_Try, /*On fail goto*//*Label 30807*/ GIMT_Encode4(2280384),
     /* 2280275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2280278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2280281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280293 */   GIM_Try, /*On fail goto*//*Label 30808*/ GIMT_Encode4(2280338), // Rule ID 51022 //
     /* 2280298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280301 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2280304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2280318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280337 */     // GIR_Coverage, 51022,
     /* 2280337 */     GIR_EraseRootFromParent_Done,
     /* 2280338 */   // Label 30808: @2280338
     /* 2280338 */   GIM_Try, /*On fail goto*//*Label 30809*/ GIMT_Encode4(2280383), // Rule ID 51023 //
     /* 2280343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280346 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2280349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2280363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280382 */     // GIR_Coverage, 51023,
     /* 2280382 */     GIR_EraseRootFromParent_Done,
     /* 2280383 */   // Label 30809: @2280383
     /* 2280383 */   GIM_Reject,
     /* 2280384 */ // Label 30807: @2280384
     /* 2280384 */ GIM_Reject,
     /* 2280385 */ // Label 30767: @2280385
     /* 2280385 */ GIM_Try, /*On fail goto*//*Label 30810*/ GIMT_Encode4(2280499),
     /* 2280390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2280393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2280396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280408 */   GIM_Try, /*On fail goto*//*Label 30811*/ GIMT_Encode4(2280453), // Rule ID 51042 //
     /* 2280413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280416 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2280419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280452 */     // GIR_Coverage, 51042,
     /* 2280452 */     GIR_EraseRootFromParent_Done,
     /* 2280453 */   // Label 30811: @2280453
     /* 2280453 */   GIM_Try, /*On fail goto*//*Label 30812*/ GIMT_Encode4(2280498), // Rule ID 51043 //
     /* 2280458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280461 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2280464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280497 */     // GIR_Coverage, 51043,
     /* 2280497 */     GIR_EraseRootFromParent_Done,
     /* 2280498 */   // Label 30812: @2280498
     /* 2280498 */   GIM_Reject,
     /* 2280499 */ // Label 30810: @2280499
     /* 2280499 */ GIM_Reject,
     /* 2280500 */ // Label 30768: @2280500
     /* 2280500 */ GIM_Try, /*On fail goto*//*Label 30813*/ GIMT_Encode4(2280614),
     /* 2280505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2280508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2280511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280523 */   GIM_Try, /*On fail goto*//*Label 30814*/ GIMT_Encode4(2280568), // Rule ID 51074 //
     /* 2280528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280531 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2280534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2280548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280567 */     // GIR_Coverage, 51074,
     /* 2280567 */     GIR_EraseRootFromParent_Done,
     /* 2280568 */   // Label 30814: @2280568
     /* 2280568 */   GIM_Try, /*On fail goto*//*Label 30815*/ GIMT_Encode4(2280613), // Rule ID 51075 //
     /* 2280573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280576 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2280579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2280593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280612 */     // GIR_Coverage, 51075,
     /* 2280612 */     GIR_EraseRootFromParent_Done,
     /* 2280613 */   // Label 30815: @2280613
     /* 2280613 */   GIM_Reject,
     /* 2280614 */ // Label 30813: @2280614
     /* 2280614 */ GIM_Reject,
     /* 2280615 */ // Label 30769: @2280615
     /* 2280615 */ GIM_Try, /*On fail goto*//*Label 30816*/ GIMT_Encode4(2280729),
     /* 2280620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2280623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2280626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280634 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280638 */   GIM_Try, /*On fail goto*//*Label 30817*/ GIMT_Encode4(2280683), // Rule ID 51110 //
     /* 2280643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2280646 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2280649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2280663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280682 */     // GIR_Coverage, 51110,
     /* 2280682 */     GIR_EraseRootFromParent_Done,
     /* 2280683 */   // Label 30817: @2280683
     /* 2280683 */   GIM_Try, /*On fail goto*//*Label 30818*/ GIMT_Encode4(2280728), // Rule ID 51111 //
     /* 2280688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2280691 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2280694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2280708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280727 */     // GIR_Coverage, 51111,
     /* 2280727 */     GIR_EraseRootFromParent_Done,
     /* 2280728 */   // Label 30818: @2280728
     /* 2280728 */   GIM_Reject,
     /* 2280729 */ // Label 30816: @2280729
     /* 2280729 */ GIM_Reject,
     /* 2280730 */ // Label 30770: @2280730
     /* 2280730 */ GIM_Try, /*On fail goto*//*Label 30819*/ GIMT_Encode4(2280844),
     /* 2280735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2280738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2280741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2280753 */   GIM_Try, /*On fail goto*//*Label 30820*/ GIMT_Encode4(2280798), // Rule ID 51038 //
     /* 2280758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280761 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2280764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280797 */     // GIR_Coverage, 51038,
     /* 2280797 */     GIR_EraseRootFromParent_Done,
     /* 2280798 */   // Label 30820: @2280798
     /* 2280798 */   GIM_Try, /*On fail goto*//*Label 30821*/ GIMT_Encode4(2280843), // Rule ID 51039 //
     /* 2280803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280806 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2280809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2280823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280842 */     // GIR_Coverage, 51039,
     /* 2280842 */     GIR_EraseRootFromParent_Done,
     /* 2280843 */   // Label 30821: @2280843
     /* 2280843 */   GIM_Reject,
     /* 2280844 */ // Label 30819: @2280844
     /* 2280844 */ GIM_Reject,
     /* 2280845 */ // Label 30771: @2280845
     /* 2280845 */ GIM_Try, /*On fail goto*//*Label 30822*/ GIMT_Encode4(2280959),
     /* 2280850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2280853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2280856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280868 */   GIM_Try, /*On fail goto*//*Label 30823*/ GIMT_Encode4(2280913), // Rule ID 51062 //
     /* 2280873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280876 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2280879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2280893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280912 */     // GIR_Coverage, 51062,
     /* 2280912 */     GIR_EraseRootFromParent_Done,
     /* 2280913 */   // Label 30823: @2280913
     /* 2280913 */   GIM_Try, /*On fail goto*//*Label 30824*/ GIMT_Encode4(2280958), // Rule ID 51063 //
     /* 2280918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280921 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2280924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2280938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280957 */     // GIR_Coverage, 51063,
     /* 2280957 */     GIR_EraseRootFromParent_Done,
     /* 2280958 */   // Label 30824: @2280958
     /* 2280958 */   GIM_Reject,
     /* 2280959 */ // Label 30822: @2280959
     /* 2280959 */ GIM_Reject,
     /* 2280960 */ // Label 30772: @2280960
     /* 2280960 */ GIM_Try, /*On fail goto*//*Label 30825*/ GIMT_Encode4(2281074),
     /* 2280965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2280968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2280971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280983 */   GIM_Try, /*On fail goto*//*Label 30826*/ GIMT_Encode4(2281028), // Rule ID 51078 //
     /* 2280988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280991 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2280994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281027 */     // GIR_Coverage, 51078,
     /* 2281027 */     GIR_EraseRootFromParent_Done,
     /* 2281028 */   // Label 30826: @2281028
     /* 2281028 */   GIM_Try, /*On fail goto*//*Label 30827*/ GIMT_Encode4(2281073), // Rule ID 51079 //
     /* 2281033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281036 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2281039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281072 */     // GIR_Coverage, 51079,
     /* 2281072 */     GIR_EraseRootFromParent_Done,
     /* 2281073 */   // Label 30827: @2281073
     /* 2281073 */   GIM_Reject,
     /* 2281074 */ // Label 30825: @2281074
     /* 2281074 */ GIM_Reject,
     /* 2281075 */ // Label 30773: @2281075
     /* 2281075 */ GIM_Try, /*On fail goto*//*Label 30828*/ GIMT_Encode4(2281189),
     /* 2281080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2281083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2281086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281098 */   GIM_Try, /*On fail goto*//*Label 30829*/ GIMT_Encode4(2281143), // Rule ID 51114 //
     /* 2281103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2281106 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2281109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281142 */     // GIR_Coverage, 51114,
     /* 2281142 */     GIR_EraseRootFromParent_Done,
     /* 2281143 */   // Label 30829: @2281143
     /* 2281143 */   GIM_Try, /*On fail goto*//*Label 30830*/ GIMT_Encode4(2281188), // Rule ID 51115 //
     /* 2281148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2281151 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2281154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281187 */     // GIR_Coverage, 51115,
     /* 2281187 */     GIR_EraseRootFromParent_Done,
     /* 2281188 */   // Label 30830: @2281188
     /* 2281188 */   GIM_Reject,
     /* 2281189 */ // Label 30828: @2281189
     /* 2281189 */ GIM_Reject,
     /* 2281190 */ // Label 30774: @2281190
     /* 2281190 */ GIM_Try, /*On fail goto*//*Label 30831*/ GIMT_Encode4(2281304),
     /* 2281195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2281198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2281201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2281213 */   GIM_Try, /*On fail goto*//*Label 30832*/ GIMT_Encode4(2281258), // Rule ID 51050 //
     /* 2281218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281221 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2281224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2281238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281257 */     // GIR_Coverage, 51050,
     /* 2281257 */     GIR_EraseRootFromParent_Done,
     /* 2281258 */   // Label 30832: @2281258
     /* 2281258 */   GIM_Try, /*On fail goto*//*Label 30833*/ GIMT_Encode4(2281303), // Rule ID 51051 //
     /* 2281263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281266 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2281269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2281283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281302 */     // GIR_Coverage, 51051,
     /* 2281302 */     GIR_EraseRootFromParent_Done,
     /* 2281303 */   // Label 30833: @2281303
     /* 2281303 */   GIM_Reject,
     /* 2281304 */ // Label 30831: @2281304
     /* 2281304 */ GIM_Reject,
     /* 2281305 */ // Label 30775: @2281305
     /* 2281305 */ GIM_Try, /*On fail goto*//*Label 30834*/ GIMT_Encode4(2281419),
     /* 2281310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2281313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2281316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281328 */   GIM_Try, /*On fail goto*//*Label 30835*/ GIMT_Encode4(2281373), // Rule ID 51066 //
     /* 2281333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281336 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2281339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281372 */     // GIR_Coverage, 51066,
     /* 2281372 */     GIR_EraseRootFromParent_Done,
     /* 2281373 */   // Label 30835: @2281373
     /* 2281373 */   GIM_Try, /*On fail goto*//*Label 30836*/ GIMT_Encode4(2281418), // Rule ID 51067 //
     /* 2281378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281381 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2281384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281417 */     // GIR_Coverage, 51067,
     /* 2281417 */     GIR_EraseRootFromParent_Done,
     /* 2281418 */   // Label 30836: @2281418
     /* 2281418 */   GIM_Reject,
     /* 2281419 */ // Label 30834: @2281419
     /* 2281419 */ GIM_Reject,
     /* 2281420 */ // Label 30776: @2281420
     /* 2281420 */ GIM_Try, /*On fail goto*//*Label 30837*/ GIMT_Encode4(2281534),
     /* 2281425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2281428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2281431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281443 */   GIM_Try, /*On fail goto*//*Label 30838*/ GIMT_Encode4(2281488), // Rule ID 51082 //
     /* 2281448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281451 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281487 */     // GIR_Coverage, 51082,
     /* 2281487 */     GIR_EraseRootFromParent_Done,
     /* 2281488 */   // Label 30838: @2281488
     /* 2281488 */   GIM_Try, /*On fail goto*//*Label 30839*/ GIMT_Encode4(2281533), // Rule ID 51083 //
     /* 2281493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281496 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2281499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281532 */     // GIR_Coverage, 51083,
     /* 2281532 */     GIR_EraseRootFromParent_Done,
     /* 2281533 */   // Label 30839: @2281533
     /* 2281533 */   GIM_Reject,
     /* 2281534 */ // Label 30837: @2281534
     /* 2281534 */ GIM_Reject,
     /* 2281535 */ // Label 30777: @2281535
     /* 2281535 */ GIM_Try, /*On fail goto*//*Label 30840*/ GIMT_Encode4(2281649),
     /* 2281540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2281543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2281546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281554 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2281558 */   GIM_Try, /*On fail goto*//*Label 30841*/ GIMT_Encode4(2281603), // Rule ID 51054 //
     /* 2281563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281566 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2281569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281602 */     // GIR_Coverage, 51054,
     /* 2281602 */     GIR_EraseRootFromParent_Done,
     /* 2281603 */   // Label 30841: @2281603
     /* 2281603 */   GIM_Try, /*On fail goto*//*Label 30842*/ GIMT_Encode4(2281648), // Rule ID 51055 //
     /* 2281608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281611 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2281614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2281628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281647 */     // GIR_Coverage, 51055,
     /* 2281647 */     GIR_EraseRootFromParent_Done,
     /* 2281648 */   // Label 30842: @2281648
     /* 2281648 */   GIM_Reject,
     /* 2281649 */ // Label 30840: @2281649
     /* 2281649 */ GIM_Reject,
     /* 2281650 */ // Label 30778: @2281650
     /* 2281650 */ GIM_Try, /*On fail goto*//*Label 30843*/ GIMT_Encode4(2281764),
     /* 2281655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2281658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2281661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281673 */   GIM_Try, /*On fail goto*//*Label 30844*/ GIMT_Encode4(2281718), // Rule ID 51070 //
     /* 2281678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281681 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2281684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281717 */     // GIR_Coverage, 51070,
     /* 2281717 */     GIR_EraseRootFromParent_Done,
     /* 2281718 */   // Label 30844: @2281718
     /* 2281718 */   GIM_Try, /*On fail goto*//*Label 30845*/ GIMT_Encode4(2281763), // Rule ID 51071 //
     /* 2281723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281726 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2281729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281762 */     // GIR_Coverage, 51071,
     /* 2281762 */     GIR_EraseRootFromParent_Done,
     /* 2281763 */   // Label 30845: @2281763
     /* 2281763 */   GIM_Reject,
     /* 2281764 */ // Label 30843: @2281764
     /* 2281764 */ GIM_Reject,
     /* 2281765 */ // Label 30779: @2281765
     /* 2281765 */ GIM_Try, /*On fail goto*//*Label 30846*/ GIMT_Encode4(2281879),
     /* 2281770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2281773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2281776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2281788 */   GIM_Try, /*On fail goto*//*Label 30847*/ GIMT_Encode4(2281833), // Rule ID 51058 //
     /* 2281793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2281796 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2281799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281832 */     // GIR_Coverage, 51058,
     /* 2281832 */     GIR_EraseRootFromParent_Done,
     /* 2281833 */   // Label 30847: @2281833
     /* 2281833 */   GIM_Try, /*On fail goto*//*Label 30848*/ GIMT_Encode4(2281878), // Rule ID 51059 //
     /* 2281838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2281841 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2281844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2281858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281877 */     // GIR_Coverage, 51059,
     /* 2281877 */     GIR_EraseRootFromParent_Done,
     /* 2281878 */   // Label 30848: @2281878
     /* 2281878 */   GIM_Reject,
     /* 2281879 */ // Label 30846: @2281879
     /* 2281879 */ GIM_Reject,
     /* 2281880 */ // Label 30780: @2281880
     /* 2281880 */ GIM_Reject,
     /* 2281881 */ // Label 52: @2281881
     /* 2281881 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30873*/ GIMT_Encode4(2284614),
     /* 2281892 */ /*GILLT_s32*//*Label 30849*/ GIMT_Encode4(2282016),
     /* 2281896 */ /*GILLT_s64*//*Label 30850*/ GIMT_Encode4(2282050), GIMT_Encode4(0),
     /* 2281904 */ /*GILLT_nxv1s8*//*Label 30851*/ GIMT_Encode4(2282084),
     /* 2281908 */ /*GILLT_nxv1s16*//*Label 30852*/ GIMT_Encode4(2282199),
     /* 2281912 */ /*GILLT_nxv1s32*//*Label 30853*/ GIMT_Encode4(2282314),
     /* 2281916 */ /*GILLT_nxv1s64*//*Label 30854*/ GIMT_Encode4(2282429), GIMT_Encode4(0),
     /* 2281924 */ /*GILLT_nxv2s8*//*Label 30855*/ GIMT_Encode4(2282544),
     /* 2281928 */ /*GILLT_nxv2s16*//*Label 30856*/ GIMT_Encode4(2282659),
     /* 2281932 */ /*GILLT_nxv2s32*//*Label 30857*/ GIMT_Encode4(2282774),
     /* 2281936 */ /*GILLT_nxv2s64*//*Label 30858*/ GIMT_Encode4(2282889), GIMT_Encode4(0),
     /* 2281944 */ /*GILLT_nxv4s8*//*Label 30859*/ GIMT_Encode4(2283004),
     /* 2281948 */ /*GILLT_nxv4s16*//*Label 30860*/ GIMT_Encode4(2283119),
     /* 2281952 */ /*GILLT_nxv4s32*//*Label 30861*/ GIMT_Encode4(2283234),
     /* 2281956 */ /*GILLT_nxv4s64*//*Label 30862*/ GIMT_Encode4(2283349), GIMT_Encode4(0),
     /* 2281964 */ /*GILLT_nxv8s8*//*Label 30863*/ GIMT_Encode4(2283464),
     /* 2281968 */ /*GILLT_nxv8s16*//*Label 30864*/ GIMT_Encode4(2283579),
     /* 2281972 */ /*GILLT_nxv8s32*//*Label 30865*/ GIMT_Encode4(2283694),
     /* 2281976 */ /*GILLT_nxv8s64*//*Label 30866*/ GIMT_Encode4(2283809), GIMT_Encode4(0),
     /* 2281984 */ /*GILLT_nxv16s8*//*Label 30867*/ GIMT_Encode4(2283924),
     /* 2281988 */ /*GILLT_nxv16s16*//*Label 30868*/ GIMT_Encode4(2284039),
     /* 2281992 */ /*GILLT_nxv16s32*//*Label 30869*/ GIMT_Encode4(2284154), GIMT_Encode4(0),
     /* 2282000 */ /*GILLT_nxv32s8*//*Label 30870*/ GIMT_Encode4(2284269),
     /* 2282004 */ /*GILLT_nxv32s16*//*Label 30871*/ GIMT_Encode4(2284384), GIMT_Encode4(0),
     /* 2282012 */ /*GILLT_nxv64s8*//*Label 30872*/ GIMT_Encode4(2284499),
     /* 2282016 */ // Label 30849: @2282016
     /* 2282016 */ GIM_Try, /*On fail goto*//*Label 30874*/ GIMT_Encode4(2282049), // Rule ID 300 //
     /* 2282021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2282024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2282027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2282030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282042 */   // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2282042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2282047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2282048 */   // GIR_Coverage, 300,
     /* 2282048 */   GIR_Done,
     /* 2282049 */ // Label 30874: @2282049
     /* 2282049 */ GIM_Reject,
     /* 2282050 */ // Label 30850: @2282050
     /* 2282050 */ GIM_Try, /*On fail goto*//*Label 30875*/ GIMT_Encode4(2282083), // Rule ID 299 //
     /* 2282055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2282058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2282061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2282064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2282076 */   // (mulhs:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2282076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2282081 */   GIR_RootConstrainSelectedInstOperands,
     /* 2282082 */   // GIR_Coverage, 299,
     /* 2282082 */   GIR_Done,
     /* 2282083 */ // Label 30875: @2282083
     /* 2282083 */ GIM_Reject,
     /* 2282084 */ // Label 30851: @2282084
     /* 2282084 */ GIM_Try, /*On fail goto*//*Label 30876*/ GIMT_Encode4(2282198),
     /* 2282089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2282092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2282095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282107 */   GIM_Try, /*On fail goto*//*Label 30877*/ GIMT_Encode4(2282152), // Rule ID 50942 //
     /* 2282112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282115 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2282118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2282132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282151 */     // GIR_Coverage, 50942,
     /* 2282151 */     GIR_EraseRootFromParent_Done,
     /* 2282152 */   // Label 30877: @2282152
     /* 2282152 */   GIM_Try, /*On fail goto*//*Label 30878*/ GIMT_Encode4(2282197), // Rule ID 50943 //
     /* 2282157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282160 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2282163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2282177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282196 */     // GIR_Coverage, 50943,
     /* 2282196 */     GIR_EraseRootFromParent_Done,
     /* 2282197 */   // Label 30878: @2282197
     /* 2282197 */   GIM_Reject,
     /* 2282198 */ // Label 30876: @2282198
     /* 2282198 */ GIM_Reject,
     /* 2282199 */ // Label 30852: @2282199
     /* 2282199 */ GIM_Try, /*On fail goto*//*Label 30879*/ GIMT_Encode4(2282313),
     /* 2282204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2282207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2282210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282222 */   GIM_Try, /*On fail goto*//*Label 30880*/ GIMT_Encode4(2282267), // Rule ID 50954 //
     /* 2282227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282230 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2282233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2282247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282266 */     // GIR_Coverage, 50954,
     /* 2282266 */     GIR_EraseRootFromParent_Done,
     /* 2282267 */   // Label 30880: @2282267
     /* 2282267 */   GIM_Try, /*On fail goto*//*Label 30881*/ GIMT_Encode4(2282312), // Rule ID 50955 //
     /* 2282272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282275 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2282278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2282292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282311 */     // GIR_Coverage, 50955,
     /* 2282311 */     GIR_EraseRootFromParent_Done,
     /* 2282312 */   // Label 30881: @2282312
     /* 2282312 */   GIM_Reject,
     /* 2282313 */ // Label 30879: @2282313
     /* 2282313 */ GIM_Reject,
     /* 2282314 */ // Label 30853: @2282314
     /* 2282314 */ GIM_Try, /*On fail goto*//*Label 30882*/ GIMT_Encode4(2282428),
     /* 2282319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2282322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2282325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282337 */   GIM_Try, /*On fail goto*//*Label 30883*/ GIMT_Encode4(2282382), // Rule ID 50962 //
     /* 2282342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282345 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2282348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2282362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282381 */     // GIR_Coverage, 50962,
     /* 2282381 */     GIR_EraseRootFromParent_Done,
     /* 2282382 */   // Label 30883: @2282382
     /* 2282382 */   GIM_Try, /*On fail goto*//*Label 30884*/ GIMT_Encode4(2282427), // Rule ID 50963 //
     /* 2282387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282390 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2282393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2282407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282426 */     // GIR_Coverage, 50963,
     /* 2282426 */     GIR_EraseRootFromParent_Done,
     /* 2282427 */   // Label 30884: @2282427
     /* 2282427 */   GIM_Reject,
     /* 2282428 */ // Label 30882: @2282428
     /* 2282428 */ GIM_Reject,
     /* 2282429 */ // Label 30854: @2282429
     /* 2282429 */ GIM_Try, /*On fail goto*//*Label 30885*/ GIMT_Encode4(2282543),
     /* 2282434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2282437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2282440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282452 */   GIM_Try, /*On fail goto*//*Label 30886*/ GIMT_Encode4(2282497), // Rule ID 51086 //
     /* 2282457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2282460 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2282477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282496 */     // GIR_Coverage, 51086,
     /* 2282496 */     GIR_EraseRootFromParent_Done,
     /* 2282497 */   // Label 30886: @2282497
     /* 2282497 */   GIM_Try, /*On fail goto*//*Label 30887*/ GIMT_Encode4(2282542), // Rule ID 51087 //
     /* 2282502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2282505 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2282508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2282522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282541 */     // GIR_Coverage, 51087,
     /* 2282541 */     GIR_EraseRootFromParent_Done,
     /* 2282542 */   // Label 30887: @2282542
     /* 2282542 */   GIM_Reject,
     /* 2282543 */ // Label 30885: @2282543
     /* 2282543 */ GIM_Reject,
     /* 2282544 */ // Label 30855: @2282544
     /* 2282544 */ GIM_Try, /*On fail goto*//*Label 30888*/ GIMT_Encode4(2282658),
     /* 2282549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2282552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2282555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282563 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282567 */   GIM_Try, /*On fail goto*//*Label 30889*/ GIMT_Encode4(2282612), // Rule ID 50946 //
     /* 2282572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282575 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2282592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282611 */     // GIR_Coverage, 50946,
     /* 2282611 */     GIR_EraseRootFromParent_Done,
     /* 2282612 */   // Label 30889: @2282612
     /* 2282612 */   GIM_Try, /*On fail goto*//*Label 30890*/ GIMT_Encode4(2282657), // Rule ID 50947 //
     /* 2282617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282620 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2282623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2282637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282656 */     // GIR_Coverage, 50947,
     /* 2282656 */     GIR_EraseRootFromParent_Done,
     /* 2282657 */   // Label 30890: @2282657
     /* 2282657 */   GIM_Reject,
     /* 2282658 */ // Label 30888: @2282658
     /* 2282658 */ GIM_Reject,
     /* 2282659 */ // Label 30856: @2282659
     /* 2282659 */ GIM_Try, /*On fail goto*//*Label 30891*/ GIMT_Encode4(2282773),
     /* 2282664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2282667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2282670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282682 */   GIM_Try, /*On fail goto*//*Label 30892*/ GIMT_Encode4(2282727), // Rule ID 50958 //
     /* 2282687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282690 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2282707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282726 */     // GIR_Coverage, 50958,
     /* 2282726 */     GIR_EraseRootFromParent_Done,
     /* 2282727 */   // Label 30892: @2282727
     /* 2282727 */   GIM_Try, /*On fail goto*//*Label 30893*/ GIMT_Encode4(2282772), // Rule ID 50959 //
     /* 2282732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282735 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2282738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2282752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282771 */     // GIR_Coverage, 50959,
     /* 2282771 */     GIR_EraseRootFromParent_Done,
     /* 2282772 */   // Label 30893: @2282772
     /* 2282772 */   GIM_Reject,
     /* 2282773 */ // Label 30891: @2282773
     /* 2282773 */ GIM_Reject,
     /* 2282774 */ // Label 30857: @2282774
     /* 2282774 */ GIM_Try, /*On fail goto*//*Label 30894*/ GIMT_Encode4(2282888),
     /* 2282779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2282782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2282785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282797 */   GIM_Try, /*On fail goto*//*Label 30895*/ GIMT_Encode4(2282842), // Rule ID 50974 //
     /* 2282802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2282805 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2282822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282841 */     // GIR_Coverage, 50974,
     /* 2282841 */     GIR_EraseRootFromParent_Done,
     /* 2282842 */   // Label 30895: @2282842
     /* 2282842 */   GIM_Try, /*On fail goto*//*Label 30896*/ GIMT_Encode4(2282887), // Rule ID 50975 //
     /* 2282847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2282850 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2282867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282886 */     // GIR_Coverage, 50975,
     /* 2282886 */     GIR_EraseRootFromParent_Done,
     /* 2282887 */   // Label 30896: @2282887
     /* 2282887 */   GIM_Reject,
     /* 2282888 */ // Label 30894: @2282888
     /* 2282888 */ GIM_Reject,
     /* 2282889 */ // Label 30858: @2282889
     /* 2282889 */ GIM_Try, /*On fail goto*//*Label 30897*/ GIMT_Encode4(2283003),
     /* 2282894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2282897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2282900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282912 */   GIM_Try, /*On fail goto*//*Label 30898*/ GIMT_Encode4(2282957), // Rule ID 51090 //
     /* 2282917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2282920 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2282937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282956 */     // GIR_Coverage, 51090,
     /* 2282956 */     GIR_EraseRootFromParent_Done,
     /* 2282957 */   // Label 30898: @2282957
     /* 2282957 */   GIM_Try, /*On fail goto*//*Label 30899*/ GIMT_Encode4(2283002), // Rule ID 51091 //
     /* 2282962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2282965 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2282982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283001 */     // GIR_Coverage, 51091,
     /* 2283001 */     GIR_EraseRootFromParent_Done,
     /* 2283002 */   // Label 30899: @2283002
     /* 2283002 */   GIM_Reject,
     /* 2283003 */ // Label 30897: @2283003
     /* 2283003 */ GIM_Reject,
     /* 2283004 */ // Label 30859: @2283004
     /* 2283004 */ GIM_Try, /*On fail goto*//*Label 30900*/ GIMT_Encode4(2283118),
     /* 2283009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2283012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2283015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283027 */   GIM_Try, /*On fail goto*//*Label 30901*/ GIMT_Encode4(2283072), // Rule ID 50950 //
     /* 2283032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283035 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2283038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2283052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283071 */     // GIR_Coverage, 50950,
     /* 2283071 */     GIR_EraseRootFromParent_Done,
     /* 2283072 */   // Label 30901: @2283072
     /* 2283072 */   GIM_Try, /*On fail goto*//*Label 30902*/ GIMT_Encode4(2283117), // Rule ID 50951 //
     /* 2283077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283080 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2283083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2283097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283116 */     // GIR_Coverage, 50951,
     /* 2283116 */     GIR_EraseRootFromParent_Done,
     /* 2283117 */   // Label 30902: @2283117
     /* 2283117 */   GIM_Reject,
     /* 2283118 */ // Label 30900: @2283118
     /* 2283118 */ GIM_Reject,
     /* 2283119 */ // Label 30860: @2283119
     /* 2283119 */ GIM_Try, /*On fail goto*//*Label 30903*/ GIMT_Encode4(2283233),
     /* 2283124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2283127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2283130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283142 */   GIM_Try, /*On fail goto*//*Label 30904*/ GIMT_Encode4(2283187), // Rule ID 50970 //
     /* 2283147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283150 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283186 */     // GIR_Coverage, 50970,
     /* 2283186 */     GIR_EraseRootFromParent_Done,
     /* 2283187 */   // Label 30904: @2283187
     /* 2283187 */   GIM_Try, /*On fail goto*//*Label 30905*/ GIMT_Encode4(2283232), // Rule ID 50971 //
     /* 2283192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283195 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2283198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283231 */     // GIR_Coverage, 50971,
     /* 2283231 */     GIR_EraseRootFromParent_Done,
     /* 2283232 */   // Label 30905: @2283232
     /* 2283232 */   GIM_Reject,
     /* 2283233 */ // Label 30903: @2283233
     /* 2283233 */ GIM_Reject,
     /* 2283234 */ // Label 30861: @2283234
     /* 2283234 */ GIM_Try, /*On fail goto*//*Label 30906*/ GIMT_Encode4(2283348),
     /* 2283239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2283242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2283245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283257 */   GIM_Try, /*On fail goto*//*Label 30907*/ GIMT_Encode4(2283302), // Rule ID 51002 //
     /* 2283262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283265 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2283282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283301 */     // GIR_Coverage, 51002,
     /* 2283301 */     GIR_EraseRootFromParent_Done,
     /* 2283302 */   // Label 30907: @2283302
     /* 2283302 */   GIM_Try, /*On fail goto*//*Label 30908*/ GIMT_Encode4(2283347), // Rule ID 51003 //
     /* 2283307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283310 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2283313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2283327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283346 */     // GIR_Coverage, 51003,
     /* 2283346 */     GIR_EraseRootFromParent_Done,
     /* 2283347 */   // Label 30908: @2283347
     /* 2283347 */   GIM_Reject,
     /* 2283348 */ // Label 30906: @2283348
     /* 2283348 */ GIM_Reject,
     /* 2283349 */ // Label 30862: @2283349
     /* 2283349 */ GIM_Try, /*On fail goto*//*Label 30909*/ GIMT_Encode4(2283463),
     /* 2283354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2283357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2283360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283372 */   GIM_Try, /*On fail goto*//*Label 30910*/ GIMT_Encode4(2283417), // Rule ID 51094 //
     /* 2283377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2283380 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2283397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283416 */     // GIR_Coverage, 51094,
     /* 2283416 */     GIR_EraseRootFromParent_Done,
     /* 2283417 */   // Label 30910: @2283417
     /* 2283417 */   GIM_Try, /*On fail goto*//*Label 30911*/ GIMT_Encode4(2283462), // Rule ID 51095 //
     /* 2283422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2283425 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2283428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2283442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283461 */     // GIR_Coverage, 51095,
     /* 2283461 */     GIR_EraseRootFromParent_Done,
     /* 2283462 */   // Label 30911: @2283462
     /* 2283462 */   GIM_Reject,
     /* 2283463 */ // Label 30909: @2283463
     /* 2283463 */ GIM_Reject,
     /* 2283464 */ // Label 30863: @2283464
     /* 2283464 */ GIM_Try, /*On fail goto*//*Label 30912*/ GIMT_Encode4(2283578),
     /* 2283469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2283472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2283475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283487 */   GIM_Try, /*On fail goto*//*Label 30913*/ GIMT_Encode4(2283532), // Rule ID 50966 //
     /* 2283492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283495 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283531 */     // GIR_Coverage, 50966,
     /* 2283531 */     GIR_EraseRootFromParent_Done,
     /* 2283532 */   // Label 30913: @2283532
     /* 2283532 */   GIM_Try, /*On fail goto*//*Label 30914*/ GIMT_Encode4(2283577), // Rule ID 50967 //
     /* 2283537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283540 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2283543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2283557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283576 */     // GIR_Coverage, 50967,
     /* 2283576 */     GIR_EraseRootFromParent_Done,
     /* 2283577 */   // Label 30914: @2283577
     /* 2283577 */   GIM_Reject,
     /* 2283578 */ // Label 30912: @2283578
     /* 2283578 */ GIM_Reject,
     /* 2283579 */ // Label 30864: @2283579
     /* 2283579 */ GIM_Try, /*On fail goto*//*Label 30915*/ GIMT_Encode4(2283693),
     /* 2283584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2283587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2283590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283602 */   GIM_Try, /*On fail goto*//*Label 30916*/ GIMT_Encode4(2283647), // Rule ID 50990 //
     /* 2283607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283610 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2283627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283646 */     // GIR_Coverage, 50990,
     /* 2283646 */     GIR_EraseRootFromParent_Done,
     /* 2283647 */   // Label 30916: @2283647
     /* 2283647 */   GIM_Try, /*On fail goto*//*Label 30917*/ GIMT_Encode4(2283692), // Rule ID 50991 //
     /* 2283652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283655 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2283658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2283672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283691 */     // GIR_Coverage, 50991,
     /* 2283691 */     GIR_EraseRootFromParent_Done,
     /* 2283692 */   // Label 30917: @2283692
     /* 2283692 */   GIM_Reject,
     /* 2283693 */ // Label 30915: @2283693
     /* 2283693 */ GIM_Reject,
     /* 2283694 */ // Label 30865: @2283694
     /* 2283694 */ GIM_Try, /*On fail goto*//*Label 30918*/ GIMT_Encode4(2283808),
     /* 2283699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2283702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2283705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2283717 */   GIM_Try, /*On fail goto*//*Label 30919*/ GIMT_Encode4(2283762), // Rule ID 51006 //
     /* 2283722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283725 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2283728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2283742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283761 */     // GIR_Coverage, 51006,
     /* 2283761 */     GIR_EraseRootFromParent_Done,
     /* 2283762 */   // Label 30919: @2283762
     /* 2283762 */   GIM_Try, /*On fail goto*//*Label 30920*/ GIMT_Encode4(2283807), // Rule ID 51007 //
     /* 2283767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2283770 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2283773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2283787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283806 */     // GIR_Coverage, 51007,
     /* 2283806 */     GIR_EraseRootFromParent_Done,
     /* 2283807 */   // Label 30920: @2283807
     /* 2283807 */   GIM_Reject,
     /* 2283808 */ // Label 30918: @2283808
     /* 2283808 */ GIM_Reject,
     /* 2283809 */ // Label 30866: @2283809
     /* 2283809 */ GIM_Try, /*On fail goto*//*Label 30921*/ GIMT_Encode4(2283923),
     /* 2283814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2283817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2283820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283832 */   GIM_Try, /*On fail goto*//*Label 30922*/ GIMT_Encode4(2283877), // Rule ID 51098 //
     /* 2283837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2283840 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2283843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2283857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283876 */     // GIR_Coverage, 51098,
     /* 2283876 */     GIR_EraseRootFromParent_Done,
     /* 2283877 */   // Label 30922: @2283877
     /* 2283877 */   GIM_Try, /*On fail goto*//*Label 30923*/ GIMT_Encode4(2283922), // Rule ID 51099 //
     /* 2283882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2283885 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2283888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2283902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2283917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283921 */     // GIR_Coverage, 51099,
     /* 2283921 */     GIR_EraseRootFromParent_Done,
     /* 2283922 */   // Label 30923: @2283922
     /* 2283922 */   GIM_Reject,
     /* 2283923 */ // Label 30921: @2283923
     /* 2283923 */ GIM_Reject,
     /* 2283924 */ // Label 30867: @2283924
     /* 2283924 */ GIM_Try, /*On fail goto*//*Label 30924*/ GIMT_Encode4(2284038),
     /* 2283929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2283932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2283935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2283947 */   GIM_Try, /*On fail goto*//*Label 30925*/ GIMT_Encode4(2283992), // Rule ID 50978 //
     /* 2283952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2283955 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2283958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2283972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283991 */     // GIR_Coverage, 50978,
     /* 2283991 */     GIR_EraseRootFromParent_Done,
     /* 2283992 */   // Label 30925: @2283992
     /* 2283992 */   GIM_Try, /*On fail goto*//*Label 30926*/ GIMT_Encode4(2284037), // Rule ID 50979 //
     /* 2283997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284000 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2284003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2284017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284036 */     // GIR_Coverage, 50979,
     /* 2284036 */     GIR_EraseRootFromParent_Done,
     /* 2284037 */   // Label 30926: @2284037
     /* 2284037 */   GIM_Reject,
     /* 2284038 */ // Label 30924: @2284038
     /* 2284038 */ GIM_Reject,
     /* 2284039 */ // Label 30868: @2284039
     /* 2284039 */ GIM_Try, /*On fail goto*//*Label 30927*/ GIMT_Encode4(2284153),
     /* 2284044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2284047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2284050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284062 */   GIM_Try, /*On fail goto*//*Label 30928*/ GIMT_Encode4(2284107), // Rule ID 50994 //
     /* 2284067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284070 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284106 */     // GIR_Coverage, 50994,
     /* 2284106 */     GIR_EraseRootFromParent_Done,
     /* 2284107 */   // Label 30928: @2284107
     /* 2284107 */   GIM_Try, /*On fail goto*//*Label 30929*/ GIMT_Encode4(2284152), // Rule ID 50995 //
     /* 2284112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284115 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2284118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284151 */     // GIR_Coverage, 50995,
     /* 2284151 */     GIR_EraseRootFromParent_Done,
     /* 2284152 */   // Label 30929: @2284152
     /* 2284152 */   GIM_Reject,
     /* 2284153 */ // Label 30927: @2284153
     /* 2284153 */ GIM_Reject,
     /* 2284154 */ // Label 30869: @2284154
     /* 2284154 */ GIM_Try, /*On fail goto*//*Label 30930*/ GIMT_Encode4(2284268),
     /* 2284159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2284162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2284165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284177 */   GIM_Try, /*On fail goto*//*Label 30931*/ GIMT_Encode4(2284222), // Rule ID 51010 //
     /* 2284182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284185 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284221 */     // GIR_Coverage, 51010,
     /* 2284221 */     GIR_EraseRootFromParent_Done,
     /* 2284222 */   // Label 30931: @2284222
     /* 2284222 */   GIM_Try, /*On fail goto*//*Label 30932*/ GIMT_Encode4(2284267), // Rule ID 51011 //
     /* 2284227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284230 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2284233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284266 */     // GIR_Coverage, 51011,
     /* 2284266 */     GIR_EraseRootFromParent_Done,
     /* 2284267 */   // Label 30932: @2284267
     /* 2284267 */   GIM_Reject,
     /* 2284268 */ // Label 30930: @2284268
     /* 2284268 */ GIM_Reject,
     /* 2284269 */ // Label 30870: @2284269
     /* 2284269 */ GIM_Try, /*On fail goto*//*Label 30933*/ GIMT_Encode4(2284383),
     /* 2284274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2284277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2284280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284292 */   GIM_Try, /*On fail goto*//*Label 30934*/ GIMT_Encode4(2284337), // Rule ID 50982 //
     /* 2284297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284300 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284336 */     // GIR_Coverage, 50982,
     /* 2284336 */     GIR_EraseRootFromParent_Done,
     /* 2284337 */   // Label 30934: @2284337
     /* 2284337 */   GIM_Try, /*On fail goto*//*Label 30935*/ GIMT_Encode4(2284382), // Rule ID 50983 //
     /* 2284342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284345 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2284348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2284362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284381 */     // GIR_Coverage, 50983,
     /* 2284381 */     GIR_EraseRootFromParent_Done,
     /* 2284382 */   // Label 30935: @2284382
     /* 2284382 */   GIM_Reject,
     /* 2284383 */ // Label 30933: @2284383
     /* 2284383 */ GIM_Reject,
     /* 2284384 */ // Label 30871: @2284384
     /* 2284384 */ GIM_Try, /*On fail goto*//*Label 30936*/ GIMT_Encode4(2284498),
     /* 2284389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2284392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2284395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284407 */   GIM_Try, /*On fail goto*//*Label 30937*/ GIMT_Encode4(2284452), // Rule ID 50998 //
     /* 2284412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284415 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2284418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284451 */     // GIR_Coverage, 50998,
     /* 2284451 */     GIR_EraseRootFromParent_Done,
     /* 2284452 */   // Label 30937: @2284452
     /* 2284452 */   GIM_Try, /*On fail goto*//*Label 30938*/ GIMT_Encode4(2284497), // Rule ID 50999 //
     /* 2284457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284460 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2284463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284496 */     // GIR_Coverage, 50999,
     /* 2284496 */     GIR_EraseRootFromParent_Done,
     /* 2284497 */   // Label 30938: @2284497
     /* 2284497 */   GIM_Reject,
     /* 2284498 */ // Label 30936: @2284498
     /* 2284498 */ GIM_Reject,
     /* 2284499 */ // Label 30872: @2284499
     /* 2284499 */ GIM_Try, /*On fail goto*//*Label 30939*/ GIMT_Encode4(2284613),
     /* 2284504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2284507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2284510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2284522 */   GIM_Try, /*On fail goto*//*Label 30940*/ GIMT_Encode4(2284567), // Rule ID 50986 //
     /* 2284527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284530 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2284533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284566 */     // GIR_Coverage, 50986,
     /* 2284566 */     GIR_EraseRootFromParent_Done,
     /* 2284567 */   // Label 30940: @2284567
     /* 2284567 */   GIM_Try, /*On fail goto*//*Label 30941*/ GIMT_Encode4(2284612), // Rule ID 50987 //
     /* 2284572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284575 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2284578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2284592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284611 */     // GIR_Coverage, 50987,
     /* 2284611 */     GIR_EraseRootFromParent_Done,
     /* 2284612 */   // Label 30941: @2284612
     /* 2284612 */   GIM_Reject,
     /* 2284613 */ // Label 30939: @2284613
     /* 2284613 */ GIM_Reject,
     /* 2284614 */ // Label 30873: @2284614
     /* 2284614 */ GIM_Reject,
     /* 2284615 */ // Label 53: @2284615
     /* 2284615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30965*/ GIMT_Encode4(2287467),
     /* 2284626 */ /*GILLT_s32*//*Label 30942*/ GIMT_Encode4(2284750), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2284638 */ /*GILLT_nxv1s8*//*Label 30943*/ GIMT_Encode4(2284805),
     /* 2284642 */ /*GILLT_nxv1s16*//*Label 30944*/ GIMT_Encode4(2284926),
     /* 2284646 */ /*GILLT_nxv1s32*//*Label 30945*/ GIMT_Encode4(2285047),
     /* 2284650 */ /*GILLT_nxv1s64*//*Label 30946*/ GIMT_Encode4(2285168), GIMT_Encode4(0),
     /* 2284658 */ /*GILLT_nxv2s8*//*Label 30947*/ GIMT_Encode4(2285289),
     /* 2284662 */ /*GILLT_nxv2s16*//*Label 30948*/ GIMT_Encode4(2285410),
     /* 2284666 */ /*GILLT_nxv2s32*//*Label 30949*/ GIMT_Encode4(2285531),
     /* 2284670 */ /*GILLT_nxv2s64*//*Label 30950*/ GIMT_Encode4(2285652), GIMT_Encode4(0),
     /* 2284678 */ /*GILLT_nxv4s8*//*Label 30951*/ GIMT_Encode4(2285773),
     /* 2284682 */ /*GILLT_nxv4s16*//*Label 30952*/ GIMT_Encode4(2285894),
     /* 2284686 */ /*GILLT_nxv4s32*//*Label 30953*/ GIMT_Encode4(2286015),
     /* 2284690 */ /*GILLT_nxv4s64*//*Label 30954*/ GIMT_Encode4(2286136), GIMT_Encode4(0),
     /* 2284698 */ /*GILLT_nxv8s8*//*Label 30955*/ GIMT_Encode4(2286257),
     /* 2284702 */ /*GILLT_nxv8s16*//*Label 30956*/ GIMT_Encode4(2286378),
     /* 2284706 */ /*GILLT_nxv8s32*//*Label 30957*/ GIMT_Encode4(2286499),
     /* 2284710 */ /*GILLT_nxv8s64*//*Label 30958*/ GIMT_Encode4(2286620), GIMT_Encode4(0),
     /* 2284718 */ /*GILLT_nxv16s8*//*Label 30959*/ GIMT_Encode4(2286741),
     /* 2284722 */ /*GILLT_nxv16s16*//*Label 30960*/ GIMT_Encode4(2286862),
     /* 2284726 */ /*GILLT_nxv16s32*//*Label 30961*/ GIMT_Encode4(2286983), GIMT_Encode4(0),
     /* 2284734 */ /*GILLT_nxv32s8*//*Label 30962*/ GIMT_Encode4(2287104),
     /* 2284738 */ /*GILLT_nxv32s16*//*Label 30963*/ GIMT_Encode4(2287225), GIMT_Encode4(0),
     /* 2284746 */ /*GILLT_nxv64s8*//*Label 30964*/ GIMT_Encode4(2287346),
     /* 2284750 */ // Label 30942: @2284750
     /* 2284750 */ GIM_Try, /*On fail goto*//*Label 30966*/ GIMT_Encode4(2284804),
     /* 2284755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2284758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2284761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2284765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2284769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2284773 */   GIM_Try, /*On fail goto*//*Label 30967*/ GIMT_Encode4(2284788), // Rule ID 64574 //
     /* 2284778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2284781 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2284781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2284786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284787 */     // GIR_Coverage, 64574,
     /* 2284787 */     GIR_Done,
     /* 2284788 */   // Label 30967: @2284788
     /* 2284788 */   GIM_Try, /*On fail goto*//*Label 30968*/ GIMT_Encode4(2284803), // Rule ID 64575 //
     /* 2284793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2284796 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2284796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2284801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284802 */     // GIR_Coverage, 64575,
     /* 2284802 */     GIR_Done,
     /* 2284803 */   // Label 30968: @2284803
     /* 2284803 */   GIM_Reject,
     /* 2284804 */ // Label 30966: @2284804
     /* 2284804 */ GIM_Reject,
     /* 2284805 */ // Label 30943: @2284805
     /* 2284805 */ GIM_Try, /*On fail goto*//*Label 30969*/ GIMT_Encode4(2284925),
     /* 2284810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2284813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2284816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284828 */   GIM_Try, /*On fail goto*//*Label 30970*/ GIMT_Encode4(2284876), // Rule ID 52502 //
     /* 2284833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284836 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2284839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2284853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284875 */     // GIR_Coverage, 52502,
     /* 2284875 */     GIR_EraseRootFromParent_Done,
     /* 2284876 */   // Label 30970: @2284876
     /* 2284876 */   GIM_Try, /*On fail goto*//*Label 30971*/ GIMT_Encode4(2284924), // Rule ID 52503 //
     /* 2284881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2284884 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2284887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2284901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284923 */     // GIR_Coverage, 52503,
     /* 2284923 */     GIR_EraseRootFromParent_Done,
     /* 2284924 */   // Label 30971: @2284924
     /* 2284924 */   GIM_Reject,
     /* 2284925 */ // Label 30969: @2284925
     /* 2284925 */ GIM_Reject,
     /* 2284926 */ // Label 30944: @2284926
     /* 2284926 */ GIM_Try, /*On fail goto*//*Label 30972*/ GIMT_Encode4(2285046),
     /* 2284931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2284934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2284937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284949 */   GIM_Try, /*On fail goto*//*Label 30973*/ GIMT_Encode4(2284997), // Rule ID 52514 //
     /* 2284954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2284957 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2284960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2284974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2284995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284996 */     // GIR_Coverage, 52514,
     /* 2284996 */     GIR_EraseRootFromParent_Done,
     /* 2284997 */   // Label 30973: @2284997
     /* 2284997 */   GIM_Try, /*On fail goto*//*Label 30974*/ GIMT_Encode4(2285045), // Rule ID 52515 //
     /* 2285002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285005 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2285008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2285022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285044 */     // GIR_Coverage, 52515,
     /* 2285044 */     GIR_EraseRootFromParent_Done,
     /* 2285045 */   // Label 30974: @2285045
     /* 2285045 */   GIM_Reject,
     /* 2285046 */ // Label 30972: @2285046
     /* 2285046 */ GIM_Reject,
     /* 2285047 */ // Label 30945: @2285047
     /* 2285047 */ GIM_Try, /*On fail goto*//*Label 30975*/ GIMT_Encode4(2285167),
     /* 2285052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2285055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2285058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285070 */   GIM_Try, /*On fail goto*//*Label 30976*/ GIMT_Encode4(2285118), // Rule ID 52522 //
     /* 2285075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285078 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285117 */     // GIR_Coverage, 52522,
     /* 2285117 */     GIR_EraseRootFromParent_Done,
     /* 2285118 */   // Label 30976: @2285118
     /* 2285118 */   GIM_Try, /*On fail goto*//*Label 30977*/ GIMT_Encode4(2285166), // Rule ID 52523 //
     /* 2285123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285126 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2285129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285165 */     // GIR_Coverage, 52523,
     /* 2285165 */     GIR_EraseRootFromParent_Done,
     /* 2285166 */   // Label 30977: @2285166
     /* 2285166 */   GIM_Reject,
     /* 2285167 */ // Label 30975: @2285167
     /* 2285167 */ GIM_Reject,
     /* 2285168 */ // Label 30946: @2285168
     /* 2285168 */ GIM_Try, /*On fail goto*//*Label 30978*/ GIMT_Encode4(2285288),
     /* 2285173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2285176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2285179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285191 */   GIM_Try, /*On fail goto*//*Label 30979*/ GIMT_Encode4(2285239), // Rule ID 52538 //
     /* 2285196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2285199 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2285202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2285216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285238 */     // GIR_Coverage, 52538,
     /* 2285238 */     GIR_EraseRootFromParent_Done,
     /* 2285239 */   // Label 30979: @2285239
     /* 2285239 */   GIM_Try, /*On fail goto*//*Label 30980*/ GIMT_Encode4(2285287), // Rule ID 52539 //
     /* 2285244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2285247 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2285250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2285264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285286 */     // GIR_Coverage, 52539,
     /* 2285286 */     GIR_EraseRootFromParent_Done,
     /* 2285287 */   // Label 30980: @2285287
     /* 2285287 */   GIM_Reject,
     /* 2285288 */ // Label 30978: @2285288
     /* 2285288 */ GIM_Reject,
     /* 2285289 */ // Label 30947: @2285289
     /* 2285289 */ GIM_Try, /*On fail goto*//*Label 30981*/ GIMT_Encode4(2285409),
     /* 2285294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2285297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2285300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285312 */   GIM_Try, /*On fail goto*//*Label 30982*/ GIMT_Encode4(2285360), // Rule ID 52506 //
     /* 2285317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285320 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2285323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2285337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285359 */     // GIR_Coverage, 52506,
     /* 2285359 */     GIR_EraseRootFromParent_Done,
     /* 2285360 */   // Label 30982: @2285360
     /* 2285360 */   GIM_Try, /*On fail goto*//*Label 30983*/ GIMT_Encode4(2285408), // Rule ID 52507 //
     /* 2285365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285368 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2285371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2285385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285407 */     // GIR_Coverage, 52507,
     /* 2285407 */     GIR_EraseRootFromParent_Done,
     /* 2285408 */   // Label 30983: @2285408
     /* 2285408 */   GIM_Reject,
     /* 2285409 */ // Label 30981: @2285409
     /* 2285409 */ GIM_Reject,
     /* 2285410 */ // Label 30948: @2285410
     /* 2285410 */ GIM_Try, /*On fail goto*//*Label 30984*/ GIMT_Encode4(2285530),
     /* 2285415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2285418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2285421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285433 */   GIM_Try, /*On fail goto*//*Label 30985*/ GIMT_Encode4(2285481), // Rule ID 52518 //
     /* 2285438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285441 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2285444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285480 */     // GIR_Coverage, 52518,
     /* 2285480 */     GIR_EraseRootFromParent_Done,
     /* 2285481 */   // Label 30985: @2285481
     /* 2285481 */   GIM_Try, /*On fail goto*//*Label 30986*/ GIMT_Encode4(2285529), // Rule ID 52519 //
     /* 2285486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285489 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2285492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285528 */     // GIR_Coverage, 52519,
     /* 2285528 */     GIR_EraseRootFromParent_Done,
     /* 2285529 */   // Label 30986: @2285529
     /* 2285529 */   GIM_Reject,
     /* 2285530 */ // Label 30984: @2285530
     /* 2285530 */ GIM_Reject,
     /* 2285531 */ // Label 30949: @2285531
     /* 2285531 */ GIM_Try, /*On fail goto*//*Label 30987*/ GIMT_Encode4(2285651),
     /* 2285536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2285539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2285542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285554 */   GIM_Try, /*On fail goto*//*Label 30988*/ GIMT_Encode4(2285602), // Rule ID 52534 //
     /* 2285559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285562 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2285565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2285579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285601 */     // GIR_Coverage, 52534,
     /* 2285601 */     GIR_EraseRootFromParent_Done,
     /* 2285602 */   // Label 30988: @2285602
     /* 2285602 */   GIM_Try, /*On fail goto*//*Label 30989*/ GIMT_Encode4(2285650), // Rule ID 52535 //
     /* 2285607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285610 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2285613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2285627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285649 */     // GIR_Coverage, 52535,
     /* 2285649 */     GIR_EraseRootFromParent_Done,
     /* 2285650 */   // Label 30989: @2285650
     /* 2285650 */   GIM_Reject,
     /* 2285651 */ // Label 30987: @2285651
     /* 2285651 */ GIM_Reject,
     /* 2285652 */ // Label 30950: @2285652
     /* 2285652 */ GIM_Try, /*On fail goto*//*Label 30990*/ GIMT_Encode4(2285772),
     /* 2285657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2285660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2285663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285675 */   GIM_Try, /*On fail goto*//*Label 30991*/ GIMT_Encode4(2285723), // Rule ID 52578 //
     /* 2285680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2285683 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2285686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2285700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285722 */     // GIR_Coverage, 52578,
     /* 2285722 */     GIR_EraseRootFromParent_Done,
     /* 2285723 */   // Label 30991: @2285723
     /* 2285723 */   GIM_Try, /*On fail goto*//*Label 30992*/ GIMT_Encode4(2285771), // Rule ID 52579 //
     /* 2285728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2285731 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2285734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2285748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285770 */     // GIR_Coverage, 52579,
     /* 2285770 */     GIR_EraseRootFromParent_Done,
     /* 2285771 */   // Label 30992: @2285771
     /* 2285771 */   GIM_Reject,
     /* 2285772 */ // Label 30990: @2285772
     /* 2285772 */ GIM_Reject,
     /* 2285773 */ // Label 30951: @2285773
     /* 2285773 */ GIM_Try, /*On fail goto*//*Label 30993*/ GIMT_Encode4(2285893),
     /* 2285778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2285781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2285784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285796 */   GIM_Try, /*On fail goto*//*Label 30994*/ GIMT_Encode4(2285844), // Rule ID 52510 //
     /* 2285801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285804 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2285807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285843 */     // GIR_Coverage, 52510,
     /* 2285843 */     GIR_EraseRootFromParent_Done,
     /* 2285844 */   // Label 30994: @2285844
     /* 2285844 */   GIM_Try, /*On fail goto*//*Label 30995*/ GIMT_Encode4(2285892), // Rule ID 52511 //
     /* 2285849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285852 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2285855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2285869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285891 */     // GIR_Coverage, 52511,
     /* 2285891 */     GIR_EraseRootFromParent_Done,
     /* 2285892 */   // Label 30995: @2285892
     /* 2285892 */   GIM_Reject,
     /* 2285893 */ // Label 30993: @2285893
     /* 2285893 */ GIM_Reject,
     /* 2285894 */ // Label 30952: @2285894
     /* 2285894 */ GIM_Try, /*On fail goto*//*Label 30996*/ GIMT_Encode4(2286014),
     /* 2285899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2285902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2285905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2285917 */   GIM_Try, /*On fail goto*//*Label 30997*/ GIMT_Encode4(2285965), // Rule ID 52530 //
     /* 2285922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2285925 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2285928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2285942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2285963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285964 */     // GIR_Coverage, 52530,
     /* 2285964 */     GIR_EraseRootFromParent_Done,
     /* 2285965 */   // Label 30997: @2285965
     /* 2285965 */   GIM_Try, /*On fail goto*//*Label 30998*/ GIMT_Encode4(2286013), // Rule ID 52531 //
     /* 2285970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2285973 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2285976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2285990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286008 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286012 */     // GIR_Coverage, 52531,
     /* 2286012 */     GIR_EraseRootFromParent_Done,
     /* 2286013 */   // Label 30998: @2286013
     /* 2286013 */   GIM_Reject,
     /* 2286014 */ // Label 30996: @2286014
     /* 2286014 */ GIM_Reject,
     /* 2286015 */ // Label 30953: @2286015
     /* 2286015 */ GIM_Try, /*On fail goto*//*Label 30999*/ GIMT_Encode4(2286135),
     /* 2286020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2286023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2286026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286038 */   GIM_Try, /*On fail goto*//*Label 31000*/ GIMT_Encode4(2286086), // Rule ID 52566 //
     /* 2286043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286046 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286085 */     // GIR_Coverage, 52566,
     /* 2286085 */     GIR_EraseRootFromParent_Done,
     /* 2286086 */   // Label 31000: @2286086
     /* 2286086 */   GIM_Try, /*On fail goto*//*Label 31001*/ GIMT_Encode4(2286134), // Rule ID 52567 //
     /* 2286091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286094 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2286097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286133 */     // GIR_Coverage, 52567,
     /* 2286133 */     GIR_EraseRootFromParent_Done,
     /* 2286134 */   // Label 31001: @2286134
     /* 2286134 */   GIM_Reject,
     /* 2286135 */ // Label 30999: @2286135
     /* 2286135 */ GIM_Reject,
     /* 2286136 */ // Label 30954: @2286136
     /* 2286136 */ GIM_Try, /*On fail goto*//*Label 31002*/ GIMT_Encode4(2286256),
     /* 2286141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2286144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2286147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286159 */   GIM_Try, /*On fail goto*//*Label 31003*/ GIMT_Encode4(2286207), // Rule ID 52582 //
     /* 2286164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2286167 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2286184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286206 */     // GIR_Coverage, 52582,
     /* 2286206 */     GIR_EraseRootFromParent_Done,
     /* 2286207 */   // Label 31003: @2286207
     /* 2286207 */   GIM_Try, /*On fail goto*//*Label 31004*/ GIMT_Encode4(2286255), // Rule ID 52583 //
     /* 2286212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2286215 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2286218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2286232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286254 */     // GIR_Coverage, 52583,
     /* 2286254 */     GIR_EraseRootFromParent_Done,
     /* 2286255 */   // Label 31004: @2286255
     /* 2286255 */   GIM_Reject,
     /* 2286256 */ // Label 31002: @2286256
     /* 2286256 */ GIM_Reject,
     /* 2286257 */ // Label 30955: @2286257
     /* 2286257 */ GIM_Try, /*On fail goto*//*Label 31005*/ GIMT_Encode4(2286377),
     /* 2286262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2286265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2286268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286280 */   GIM_Try, /*On fail goto*//*Label 31006*/ GIMT_Encode4(2286328), // Rule ID 52526 //
     /* 2286285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286288 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2286305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286327 */     // GIR_Coverage, 52526,
     /* 2286327 */     GIR_EraseRootFromParent_Done,
     /* 2286328 */   // Label 31006: @2286328
     /* 2286328 */   GIM_Try, /*On fail goto*//*Label 31007*/ GIMT_Encode4(2286376), // Rule ID 52527 //
     /* 2286333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286336 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2286339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2286353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286375 */     // GIR_Coverage, 52527,
     /* 2286375 */     GIR_EraseRootFromParent_Done,
     /* 2286376 */   // Label 31007: @2286376
     /* 2286376 */   GIM_Reject,
     /* 2286377 */ // Label 31005: @2286377
     /* 2286377 */ GIM_Reject,
     /* 2286378 */ // Label 30956: @2286378
     /* 2286378 */ GIM_Try, /*On fail goto*//*Label 31008*/ GIMT_Encode4(2286498),
     /* 2286383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2286386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2286389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286401 */   GIM_Try, /*On fail goto*//*Label 31009*/ GIMT_Encode4(2286449), // Rule ID 52554 //
     /* 2286406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286409 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2286412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286448 */     // GIR_Coverage, 52554,
     /* 2286448 */     GIR_EraseRootFromParent_Done,
     /* 2286449 */   // Label 31009: @2286449
     /* 2286449 */   GIM_Try, /*On fail goto*//*Label 31010*/ GIMT_Encode4(2286497), // Rule ID 52555 //
     /* 2286454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286457 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2286460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286496 */     // GIR_Coverage, 52555,
     /* 2286496 */     GIR_EraseRootFromParent_Done,
     /* 2286497 */   // Label 31010: @2286497
     /* 2286497 */   GIM_Reject,
     /* 2286498 */ // Label 31008: @2286498
     /* 2286498 */ GIM_Reject,
     /* 2286499 */ // Label 30957: @2286499
     /* 2286499 */ GIM_Try, /*On fail goto*//*Label 31011*/ GIMT_Encode4(2286619),
     /* 2286504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2286507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2286510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286518 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286522 */   GIM_Try, /*On fail goto*//*Label 31012*/ GIMT_Encode4(2286570), // Rule ID 52570 //
     /* 2286527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286530 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2286533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2286547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286569 */     // GIR_Coverage, 52570,
     /* 2286569 */     GIR_EraseRootFromParent_Done,
     /* 2286570 */   // Label 31012: @2286570
     /* 2286570 */   GIM_Try, /*On fail goto*//*Label 31013*/ GIMT_Encode4(2286618), // Rule ID 52571 //
     /* 2286575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286578 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2286581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2286595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286617 */     // GIR_Coverage, 52571,
     /* 2286617 */     GIR_EraseRootFromParent_Done,
     /* 2286618 */   // Label 31013: @2286618
     /* 2286618 */   GIM_Reject,
     /* 2286619 */ // Label 31011: @2286619
     /* 2286619 */ GIM_Reject,
     /* 2286620 */ // Label 30958: @2286620
     /* 2286620 */ GIM_Try, /*On fail goto*//*Label 31014*/ GIMT_Encode4(2286740),
     /* 2286625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2286628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2286631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286643 */   GIM_Try, /*On fail goto*//*Label 31015*/ GIMT_Encode4(2286691), // Rule ID 52586 //
     /* 2286648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2286651 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2286654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2286668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286690 */     // GIR_Coverage, 52586,
     /* 2286690 */     GIR_EraseRootFromParent_Done,
     /* 2286691 */   // Label 31015: @2286691
     /* 2286691 */   GIM_Try, /*On fail goto*//*Label 31016*/ GIMT_Encode4(2286739), // Rule ID 52587 //
     /* 2286696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2286699 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2286702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2286716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286738 */     // GIR_Coverage, 52587,
     /* 2286738 */     GIR_EraseRootFromParent_Done,
     /* 2286739 */   // Label 31016: @2286739
     /* 2286739 */   GIM_Reject,
     /* 2286740 */ // Label 31014: @2286740
     /* 2286740 */ GIM_Reject,
     /* 2286741 */ // Label 30959: @2286741
     /* 2286741 */ GIM_Try, /*On fail goto*//*Label 31017*/ GIMT_Encode4(2286861),
     /* 2286746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2286749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2286752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286764 */   GIM_Try, /*On fail goto*//*Label 31018*/ GIMT_Encode4(2286812), // Rule ID 52542 //
     /* 2286769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286772 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2286775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286811 */     // GIR_Coverage, 52542,
     /* 2286811 */     GIR_EraseRootFromParent_Done,
     /* 2286812 */   // Label 31018: @2286812
     /* 2286812 */   GIM_Try, /*On fail goto*//*Label 31019*/ GIMT_Encode4(2286860), // Rule ID 52543 //
     /* 2286817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286820 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2286823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2286837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286859 */     // GIR_Coverage, 52543,
     /* 2286859 */     GIR_EraseRootFromParent_Done,
     /* 2286860 */   // Label 31019: @2286860
     /* 2286860 */   GIM_Reject,
     /* 2286861 */ // Label 31017: @2286861
     /* 2286861 */ GIM_Reject,
     /* 2286862 */ // Label 30960: @2286862
     /* 2286862 */ GIM_Try, /*On fail goto*//*Label 31020*/ GIMT_Encode4(2286982),
     /* 2286867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2286870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2286873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2286885 */   GIM_Try, /*On fail goto*//*Label 31021*/ GIMT_Encode4(2286933), // Rule ID 52558 //
     /* 2286890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2286893 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2286896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2286910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286932 */     // GIR_Coverage, 52558,
     /* 2286932 */     GIR_EraseRootFromParent_Done,
     /* 2286933 */   // Label 31021: @2286933
     /* 2286933 */   GIM_Try, /*On fail goto*//*Label 31022*/ GIMT_Encode4(2286981), // Rule ID 52559 //
     /* 2286938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2286941 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2286944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2286958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2286979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286980 */     // GIR_Coverage, 52559,
     /* 2286980 */     GIR_EraseRootFromParent_Done,
     /* 2286981 */   // Label 31022: @2286981
     /* 2286981 */   GIM_Reject,
     /* 2286982 */ // Label 31020: @2286982
     /* 2286982 */ GIM_Reject,
     /* 2286983 */ // Label 30961: @2286983
     /* 2286983 */ GIM_Try, /*On fail goto*//*Label 31023*/ GIMT_Encode4(2287103),
     /* 2286988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2286991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2286994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2286998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287002 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287006 */   GIM_Try, /*On fail goto*//*Label 31024*/ GIMT_Encode4(2287054), // Rule ID 52574 //
     /* 2287011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287014 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287053 */     // GIR_Coverage, 52574,
     /* 2287053 */     GIR_EraseRootFromParent_Done,
     /* 2287054 */   // Label 31024: @2287054
     /* 2287054 */   GIM_Try, /*On fail goto*//*Label 31025*/ GIMT_Encode4(2287102), // Rule ID 52575 //
     /* 2287059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287062 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287101 */     // GIR_Coverage, 52575,
     /* 2287101 */     GIR_EraseRootFromParent_Done,
     /* 2287102 */   // Label 31025: @2287102
     /* 2287102 */   GIM_Reject,
     /* 2287103 */ // Label 31023: @2287103
     /* 2287103 */ GIM_Reject,
     /* 2287104 */ // Label 30962: @2287104
     /* 2287104 */ GIM_Try, /*On fail goto*//*Label 31026*/ GIMT_Encode4(2287224),
     /* 2287109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2287112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2287115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287127 */   GIM_Try, /*On fail goto*//*Label 31027*/ GIMT_Encode4(2287175), // Rule ID 52546 //
     /* 2287132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287135 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2287138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2287152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287174 */     // GIR_Coverage, 52546,
     /* 2287174 */     GIR_EraseRootFromParent_Done,
     /* 2287175 */   // Label 31027: @2287175
     /* 2287175 */   GIM_Try, /*On fail goto*//*Label 31028*/ GIMT_Encode4(2287223), // Rule ID 52547 //
     /* 2287180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287183 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2287186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2287200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287222 */     // GIR_Coverage, 52547,
     /* 2287222 */     GIR_EraseRootFromParent_Done,
     /* 2287223 */   // Label 31028: @2287223
     /* 2287223 */   GIM_Reject,
     /* 2287224 */ // Label 31026: @2287224
     /* 2287224 */ GIM_Reject,
     /* 2287225 */ // Label 30963: @2287225
     /* 2287225 */ GIM_Try, /*On fail goto*//*Label 31029*/ GIMT_Encode4(2287345),
     /* 2287230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2287233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2287236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287248 */   GIM_Try, /*On fail goto*//*Label 31030*/ GIMT_Encode4(2287296), // Rule ID 52562 //
     /* 2287253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287256 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287295 */     // GIR_Coverage, 52562,
     /* 2287295 */     GIR_EraseRootFromParent_Done,
     /* 2287296 */   // Label 31030: @2287296
     /* 2287296 */   GIM_Try, /*On fail goto*//*Label 31031*/ GIMT_Encode4(2287344), // Rule ID 52563 //
     /* 2287301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287304 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2287307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287343 */     // GIR_Coverage, 52563,
     /* 2287343 */     GIR_EraseRootFromParent_Done,
     /* 2287344 */   // Label 31031: @2287344
     /* 2287344 */   GIM_Reject,
     /* 2287345 */ // Label 31029: @2287345
     /* 2287345 */ GIM_Reject,
     /* 2287346 */ // Label 30964: @2287346
     /* 2287346 */ GIM_Try, /*On fail goto*//*Label 31032*/ GIMT_Encode4(2287466),
     /* 2287351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2287354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2287357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287369 */   GIM_Try, /*On fail goto*//*Label 31033*/ GIMT_Encode4(2287417), // Rule ID 52550 //
     /* 2287374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287377 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287416 */     // GIR_Coverage, 52550,
     /* 2287416 */     GIR_EraseRootFromParent_Done,
     /* 2287417 */   // Label 31033: @2287417
     /* 2287417 */   GIM_Try, /*On fail goto*//*Label 31034*/ GIMT_Encode4(2287465), // Rule ID 52551 //
     /* 2287422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287425 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2287428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2287442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287464 */     // GIR_Coverage, 52551,
     /* 2287464 */     GIR_EraseRootFromParent_Done,
     /* 2287465 */   // Label 31034: @2287465
     /* 2287465 */   GIM_Reject,
     /* 2287466 */ // Label 31032: @2287466
     /* 2287466 */ GIM_Reject,
     /* 2287467 */ // Label 30965: @2287467
     /* 2287467 */ GIM_Reject,
     /* 2287468 */ // Label 54: @2287468
     /* 2287468 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31058*/ GIMT_Encode4(2290320),
     /* 2287479 */ /*GILLT_s32*//*Label 31035*/ GIMT_Encode4(2287603), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2287491 */ /*GILLT_nxv1s8*//*Label 31036*/ GIMT_Encode4(2287658),
     /* 2287495 */ /*GILLT_nxv1s16*//*Label 31037*/ GIMT_Encode4(2287779),
     /* 2287499 */ /*GILLT_nxv1s32*//*Label 31038*/ GIMT_Encode4(2287900),
     /* 2287503 */ /*GILLT_nxv1s64*//*Label 31039*/ GIMT_Encode4(2288021), GIMT_Encode4(0),
     /* 2287511 */ /*GILLT_nxv2s8*//*Label 31040*/ GIMT_Encode4(2288142),
     /* 2287515 */ /*GILLT_nxv2s16*//*Label 31041*/ GIMT_Encode4(2288263),
     /* 2287519 */ /*GILLT_nxv2s32*//*Label 31042*/ GIMT_Encode4(2288384),
     /* 2287523 */ /*GILLT_nxv2s64*//*Label 31043*/ GIMT_Encode4(2288505), GIMT_Encode4(0),
     /* 2287531 */ /*GILLT_nxv4s8*//*Label 31044*/ GIMT_Encode4(2288626),
     /* 2287535 */ /*GILLT_nxv4s16*//*Label 31045*/ GIMT_Encode4(2288747),
     /* 2287539 */ /*GILLT_nxv4s32*//*Label 31046*/ GIMT_Encode4(2288868),
     /* 2287543 */ /*GILLT_nxv4s64*//*Label 31047*/ GIMT_Encode4(2288989), GIMT_Encode4(0),
     /* 2287551 */ /*GILLT_nxv8s8*//*Label 31048*/ GIMT_Encode4(2289110),
     /* 2287555 */ /*GILLT_nxv8s16*//*Label 31049*/ GIMT_Encode4(2289231),
     /* 2287559 */ /*GILLT_nxv8s32*//*Label 31050*/ GIMT_Encode4(2289352),
     /* 2287563 */ /*GILLT_nxv8s64*//*Label 31051*/ GIMT_Encode4(2289473), GIMT_Encode4(0),
     /* 2287571 */ /*GILLT_nxv16s8*//*Label 31052*/ GIMT_Encode4(2289594),
     /* 2287575 */ /*GILLT_nxv16s16*//*Label 31053*/ GIMT_Encode4(2289715),
     /* 2287579 */ /*GILLT_nxv16s32*//*Label 31054*/ GIMT_Encode4(2289836), GIMT_Encode4(0),
     /* 2287587 */ /*GILLT_nxv32s8*//*Label 31055*/ GIMT_Encode4(2289957),
     /* 2287591 */ /*GILLT_nxv32s16*//*Label 31056*/ GIMT_Encode4(2290078), GIMT_Encode4(0),
     /* 2287599 */ /*GILLT_nxv64s8*//*Label 31057*/ GIMT_Encode4(2290199),
     /* 2287603 */ // Label 31035: @2287603
     /* 2287603 */ GIM_Try, /*On fail goto*//*Label 31059*/ GIMT_Encode4(2287657),
     /* 2287608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2287611 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2287614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2287618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2287622 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2287626 */   GIM_Try, /*On fail goto*//*Label 31060*/ GIMT_Encode4(2287641), // Rule ID 64572 //
     /* 2287631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2287634 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2287634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2287639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287640 */     // GIR_Coverage, 64572,
     /* 2287640 */     GIR_Done,
     /* 2287641 */   // Label 31060: @2287641
     /* 2287641 */   GIM_Try, /*On fail goto*//*Label 31061*/ GIMT_Encode4(2287656), // Rule ID 64573 //
     /* 2287646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2287649 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2287649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2287654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287655 */     // GIR_Coverage, 64573,
     /* 2287655 */     GIR_Done,
     /* 2287656 */   // Label 31061: @2287656
     /* 2287656 */   GIM_Reject,
     /* 2287657 */ // Label 31059: @2287657
     /* 2287657 */ GIM_Reject,
     /* 2287658 */ // Label 31036: @2287658
     /* 2287658 */ GIM_Try, /*On fail goto*//*Label 31062*/ GIMT_Encode4(2287778),
     /* 2287663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2287666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2287669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287681 */   GIM_Try, /*On fail goto*//*Label 31063*/ GIMT_Encode4(2287729), // Rule ID 52370 //
     /* 2287686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287689 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2287692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2287706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287728 */     // GIR_Coverage, 52370,
     /* 2287728 */     GIR_EraseRootFromParent_Done,
     /* 2287729 */   // Label 31063: @2287729
     /* 2287729 */   GIM_Try, /*On fail goto*//*Label 31064*/ GIMT_Encode4(2287777), // Rule ID 52371 //
     /* 2287734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287737 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2287740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2287754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287776 */     // GIR_Coverage, 52371,
     /* 2287776 */     GIR_EraseRootFromParent_Done,
     /* 2287777 */   // Label 31064: @2287777
     /* 2287777 */   GIM_Reject,
     /* 2287778 */ // Label 31062: @2287778
     /* 2287778 */ GIM_Reject,
     /* 2287779 */ // Label 31037: @2287779
     /* 2287779 */ GIM_Try, /*On fail goto*//*Label 31065*/ GIMT_Encode4(2287899),
     /* 2287784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2287787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2287790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287802 */   GIM_Try, /*On fail goto*//*Label 31066*/ GIMT_Encode4(2287850), // Rule ID 52382 //
     /* 2287807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287810 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2287813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2287827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287849 */     // GIR_Coverage, 52382,
     /* 2287849 */     GIR_EraseRootFromParent_Done,
     /* 2287850 */   // Label 31066: @2287850
     /* 2287850 */   GIM_Try, /*On fail goto*//*Label 31067*/ GIMT_Encode4(2287898), // Rule ID 52383 //
     /* 2287855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287858 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2287861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2287875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287897 */     // GIR_Coverage, 52383,
     /* 2287897 */     GIR_EraseRootFromParent_Done,
     /* 2287898 */   // Label 31067: @2287898
     /* 2287898 */   GIM_Reject,
     /* 2287899 */ // Label 31065: @2287899
     /* 2287899 */ GIM_Reject,
     /* 2287900 */ // Label 31038: @2287900
     /* 2287900 */ GIM_Try, /*On fail goto*//*Label 31068*/ GIMT_Encode4(2288020),
     /* 2287905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2287908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2287911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287923 */   GIM_Try, /*On fail goto*//*Label 31069*/ GIMT_Encode4(2287971), // Rule ID 52390 //
     /* 2287928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2287931 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2287934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2287948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2287969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287970 */     // GIR_Coverage, 52390,
     /* 2287970 */     GIR_EraseRootFromParent_Done,
     /* 2287971 */   // Label 31069: @2287971
     /* 2287971 */   GIM_Try, /*On fail goto*//*Label 31070*/ GIMT_Encode4(2288019), // Rule ID 52391 //
     /* 2287976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2287979 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2287982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2287996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288018 */     // GIR_Coverage, 52391,
     /* 2288018 */     GIR_EraseRootFromParent_Done,
     /* 2288019 */   // Label 31070: @2288019
     /* 2288019 */   GIM_Reject,
     /* 2288020 */ // Label 31068: @2288020
     /* 2288020 */ GIM_Reject,
     /* 2288021 */ // Label 31039: @2288021
     /* 2288021 */ GIM_Try, /*On fail goto*//*Label 31071*/ GIMT_Encode4(2288141),
     /* 2288026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2288029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2288032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288044 */   GIM_Try, /*On fail goto*//*Label 31072*/ GIMT_Encode4(2288092), // Rule ID 52406 //
     /* 2288049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2288052 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288091 */     // GIR_Coverage, 52406,
     /* 2288091 */     GIR_EraseRootFromParent_Done,
     /* 2288092 */   // Label 31072: @2288092
     /* 2288092 */   GIM_Try, /*On fail goto*//*Label 31073*/ GIMT_Encode4(2288140), // Rule ID 52407 //
     /* 2288097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2288100 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2288103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288139 */     // GIR_Coverage, 52407,
     /* 2288139 */     GIR_EraseRootFromParent_Done,
     /* 2288140 */   // Label 31073: @2288140
     /* 2288140 */   GIM_Reject,
     /* 2288141 */ // Label 31071: @2288141
     /* 2288141 */ GIM_Reject,
     /* 2288142 */ // Label 31040: @2288142
     /* 2288142 */ GIM_Try, /*On fail goto*//*Label 31074*/ GIMT_Encode4(2288262),
     /* 2288147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2288150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2288153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288165 */   GIM_Try, /*On fail goto*//*Label 31075*/ GIMT_Encode4(2288213), // Rule ID 52374 //
     /* 2288170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288173 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2288176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2288190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288212 */     // GIR_Coverage, 52374,
     /* 2288212 */     GIR_EraseRootFromParent_Done,
     /* 2288213 */   // Label 31075: @2288213
     /* 2288213 */   GIM_Try, /*On fail goto*//*Label 31076*/ GIMT_Encode4(2288261), // Rule ID 52375 //
     /* 2288218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288221 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2288224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2288238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288260 */     // GIR_Coverage, 52375,
     /* 2288260 */     GIR_EraseRootFromParent_Done,
     /* 2288261 */   // Label 31076: @2288261
     /* 2288261 */   GIM_Reject,
     /* 2288262 */ // Label 31074: @2288262
     /* 2288262 */ GIM_Reject,
     /* 2288263 */ // Label 31041: @2288263
     /* 2288263 */ GIM_Try, /*On fail goto*//*Label 31077*/ GIMT_Encode4(2288383),
     /* 2288268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2288271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2288274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288286 */   GIM_Try, /*On fail goto*//*Label 31078*/ GIMT_Encode4(2288334), // Rule ID 52386 //
     /* 2288291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288294 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2288311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288333 */     // GIR_Coverage, 52386,
     /* 2288333 */     GIR_EraseRootFromParent_Done,
     /* 2288334 */   // Label 31078: @2288334
     /* 2288334 */   GIM_Try, /*On fail goto*//*Label 31079*/ GIMT_Encode4(2288382), // Rule ID 52387 //
     /* 2288339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288342 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2288345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2288359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288377 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288381 */     // GIR_Coverage, 52387,
     /* 2288381 */     GIR_EraseRootFromParent_Done,
     /* 2288382 */   // Label 31079: @2288382
     /* 2288382 */   GIM_Reject,
     /* 2288383 */ // Label 31077: @2288383
     /* 2288383 */ GIM_Reject,
     /* 2288384 */ // Label 31042: @2288384
     /* 2288384 */ GIM_Try, /*On fail goto*//*Label 31080*/ GIMT_Encode4(2288504),
     /* 2288389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2288392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2288395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288407 */   GIM_Try, /*On fail goto*//*Label 31081*/ GIMT_Encode4(2288455), // Rule ID 52402 //
     /* 2288412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288415 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288454 */     // GIR_Coverage, 52402,
     /* 2288454 */     GIR_EraseRootFromParent_Done,
     /* 2288455 */   // Label 31081: @2288455
     /* 2288455 */   GIM_Try, /*On fail goto*//*Label 31082*/ GIMT_Encode4(2288503), // Rule ID 52403 //
     /* 2288460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288463 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2288466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288502 */     // GIR_Coverage, 52403,
     /* 2288502 */     GIR_EraseRootFromParent_Done,
     /* 2288503 */   // Label 31082: @2288503
     /* 2288503 */   GIM_Reject,
     /* 2288504 */ // Label 31080: @2288504
     /* 2288504 */ GIM_Reject,
     /* 2288505 */ // Label 31043: @2288505
     /* 2288505 */ GIM_Try, /*On fail goto*//*Label 31083*/ GIMT_Encode4(2288625),
     /* 2288510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2288513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2288516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288528 */   GIM_Try, /*On fail goto*//*Label 31084*/ GIMT_Encode4(2288576), // Rule ID 52446 //
     /* 2288533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2288536 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2288539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2288553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288575 */     // GIR_Coverage, 52446,
     /* 2288575 */     GIR_EraseRootFromParent_Done,
     /* 2288576 */   // Label 31084: @2288576
     /* 2288576 */   GIM_Try, /*On fail goto*//*Label 31085*/ GIMT_Encode4(2288624), // Rule ID 52447 //
     /* 2288581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2288584 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2288587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2288601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2288616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288623 */     // GIR_Coverage, 52447,
     /* 2288623 */     GIR_EraseRootFromParent_Done,
     /* 2288624 */   // Label 31085: @2288624
     /* 2288624 */   GIM_Reject,
     /* 2288625 */ // Label 31083: @2288625
     /* 2288625 */ GIM_Reject,
     /* 2288626 */ // Label 31044: @2288626
     /* 2288626 */ GIM_Try, /*On fail goto*//*Label 31086*/ GIMT_Encode4(2288746),
     /* 2288631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2288634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2288637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288649 */   GIM_Try, /*On fail goto*//*Label 31087*/ GIMT_Encode4(2288697), // Rule ID 52378 //
     /* 2288654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288657 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2288660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2288674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288696 */     // GIR_Coverage, 52378,
     /* 2288696 */     GIR_EraseRootFromParent_Done,
     /* 2288697 */   // Label 31087: @2288697
     /* 2288697 */   GIM_Try, /*On fail goto*//*Label 31088*/ GIMT_Encode4(2288745), // Rule ID 52379 //
     /* 2288702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288705 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2288708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2288722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288744 */     // GIR_Coverage, 52379,
     /* 2288744 */     GIR_EraseRootFromParent_Done,
     /* 2288745 */   // Label 31088: @2288745
     /* 2288745 */   GIM_Reject,
     /* 2288746 */ // Label 31086: @2288746
     /* 2288746 */ GIM_Reject,
     /* 2288747 */ // Label 31045: @2288747
     /* 2288747 */ GIM_Try, /*On fail goto*//*Label 31089*/ GIMT_Encode4(2288867),
     /* 2288752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2288755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2288758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2288770 */   GIM_Try, /*On fail goto*//*Label 31090*/ GIMT_Encode4(2288818), // Rule ID 52398 //
     /* 2288775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288778 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2288781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288817 */     // GIR_Coverage, 52398,
     /* 2288817 */     GIR_EraseRootFromParent_Done,
     /* 2288818 */   // Label 31090: @2288818
     /* 2288818 */   GIM_Try, /*On fail goto*//*Label 31091*/ GIMT_Encode4(2288866), // Rule ID 52399 //
     /* 2288823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288826 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2288829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2288843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288865 */     // GIR_Coverage, 52399,
     /* 2288865 */     GIR_EraseRootFromParent_Done,
     /* 2288866 */   // Label 31091: @2288866
     /* 2288866 */   GIM_Reject,
     /* 2288867 */ // Label 31089: @2288867
     /* 2288867 */ GIM_Reject,
     /* 2288868 */ // Label 31046: @2288868
     /* 2288868 */ GIM_Try, /*On fail goto*//*Label 31092*/ GIMT_Encode4(2288988),
     /* 2288873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2288876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2288879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2288891 */   GIM_Try, /*On fail goto*//*Label 31093*/ GIMT_Encode4(2288939), // Rule ID 52434 //
     /* 2288896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2288899 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2288902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2288916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288938 */     // GIR_Coverage, 52434,
     /* 2288938 */     GIR_EraseRootFromParent_Done,
     /* 2288939 */   // Label 31093: @2288939
     /* 2288939 */   GIM_Try, /*On fail goto*//*Label 31094*/ GIMT_Encode4(2288987), // Rule ID 52435 //
     /* 2288944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2288947 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2288950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2288964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2288985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288986 */     // GIR_Coverage, 52435,
     /* 2288986 */     GIR_EraseRootFromParent_Done,
     /* 2288987 */   // Label 31094: @2288987
     /* 2288987 */   GIM_Reject,
     /* 2288988 */ // Label 31092: @2288988
     /* 2288988 */ GIM_Reject,
     /* 2288989 */ // Label 31047: @2288989
     /* 2288989 */ GIM_Try, /*On fail goto*//*Label 31095*/ GIMT_Encode4(2289109),
     /* 2288994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2288997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2289000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289012 */   GIM_Try, /*On fail goto*//*Label 31096*/ GIMT_Encode4(2289060), // Rule ID 52450 //
     /* 2289017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2289020 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289059 */     // GIR_Coverage, 52450,
     /* 2289059 */     GIR_EraseRootFromParent_Done,
     /* 2289060 */   // Label 31096: @2289060
     /* 2289060 */   GIM_Try, /*On fail goto*//*Label 31097*/ GIMT_Encode4(2289108), // Rule ID 52451 //
     /* 2289065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2289068 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2289071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289107 */     // GIR_Coverage, 52451,
     /* 2289107 */     GIR_EraseRootFromParent_Done,
     /* 2289108 */   // Label 31097: @2289108
     /* 2289108 */   GIM_Reject,
     /* 2289109 */ // Label 31095: @2289109
     /* 2289109 */ GIM_Reject,
     /* 2289110 */ // Label 31048: @2289110
     /* 2289110 */ GIM_Try, /*On fail goto*//*Label 31098*/ GIMT_Encode4(2289230),
     /* 2289115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2289118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2289121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2289133 */   GIM_Try, /*On fail goto*//*Label 31099*/ GIMT_Encode4(2289181), // Rule ID 52394 //
     /* 2289138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289141 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2289144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2289158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289180 */     // GIR_Coverage, 52394,
     /* 2289180 */     GIR_EraseRootFromParent_Done,
     /* 2289181 */   // Label 31099: @2289181
     /* 2289181 */   GIM_Try, /*On fail goto*//*Label 31100*/ GIMT_Encode4(2289229), // Rule ID 52395 //
     /* 2289186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289189 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2289192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2289206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289228 */     // GIR_Coverage, 52395,
     /* 2289228 */     GIR_EraseRootFromParent_Done,
     /* 2289229 */   // Label 31100: @2289229
     /* 2289229 */   GIM_Reject,
     /* 2289230 */ // Label 31098: @2289230
     /* 2289230 */ GIM_Reject,
     /* 2289231 */ // Label 31049: @2289231
     /* 2289231 */ GIM_Try, /*On fail goto*//*Label 31101*/ GIMT_Encode4(2289351),
     /* 2289236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2289239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2289242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289254 */   GIM_Try, /*On fail goto*//*Label 31102*/ GIMT_Encode4(2289302), // Rule ID 52422 //
     /* 2289259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289262 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2289279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289301 */     // GIR_Coverage, 52422,
     /* 2289301 */     GIR_EraseRootFromParent_Done,
     /* 2289302 */   // Label 31102: @2289302
     /* 2289302 */   GIM_Try, /*On fail goto*//*Label 31103*/ GIMT_Encode4(2289350), // Rule ID 52423 //
     /* 2289307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289310 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2289313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2289327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289349 */     // GIR_Coverage, 52423,
     /* 2289349 */     GIR_EraseRootFromParent_Done,
     /* 2289350 */   // Label 31103: @2289350
     /* 2289350 */   GIM_Reject,
     /* 2289351 */ // Label 31101: @2289351
     /* 2289351 */ GIM_Reject,
     /* 2289352 */ // Label 31050: @2289352
     /* 2289352 */ GIM_Try, /*On fail goto*//*Label 31104*/ GIMT_Encode4(2289472),
     /* 2289357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2289360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2289363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289375 */   GIM_Try, /*On fail goto*//*Label 31105*/ GIMT_Encode4(2289423), // Rule ID 52438 //
     /* 2289380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289383 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289422 */     // GIR_Coverage, 52438,
     /* 2289422 */     GIR_EraseRootFromParent_Done,
     /* 2289423 */   // Label 31105: @2289423
     /* 2289423 */   GIM_Try, /*On fail goto*//*Label 31106*/ GIMT_Encode4(2289471), // Rule ID 52439 //
     /* 2289428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289431 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2289434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289470 */     // GIR_Coverage, 52439,
     /* 2289470 */     GIR_EraseRootFromParent_Done,
     /* 2289471 */   // Label 31106: @2289471
     /* 2289471 */   GIM_Reject,
     /* 2289472 */ // Label 31104: @2289472
     /* 2289472 */ GIM_Reject,
     /* 2289473 */ // Label 31051: @2289473
     /* 2289473 */ GIM_Try, /*On fail goto*//*Label 31107*/ GIMT_Encode4(2289593),
     /* 2289478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2289481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2289484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289496 */   GIM_Try, /*On fail goto*//*Label 31108*/ GIMT_Encode4(2289544), // Rule ID 52454 //
     /* 2289501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2289504 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2289521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289543 */     // GIR_Coverage, 52454,
     /* 2289543 */     GIR_EraseRootFromParent_Done,
     /* 2289544 */   // Label 31108: @2289544
     /* 2289544 */   GIM_Try, /*On fail goto*//*Label 31109*/ GIMT_Encode4(2289592), // Rule ID 52455 //
     /* 2289549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2289552 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2289555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2289569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2289584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289591 */     // GIR_Coverage, 52455,
     /* 2289591 */     GIR_EraseRootFromParent_Done,
     /* 2289592 */   // Label 31109: @2289592
     /* 2289592 */   GIM_Reject,
     /* 2289593 */ // Label 31107: @2289593
     /* 2289593 */ GIM_Reject,
     /* 2289594 */ // Label 31052: @2289594
     /* 2289594 */ GIM_Try, /*On fail goto*//*Label 31110*/ GIMT_Encode4(2289714),
     /* 2289599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2289602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2289605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2289617 */   GIM_Try, /*On fail goto*//*Label 31111*/ GIMT_Encode4(2289665), // Rule ID 52410 //
     /* 2289622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289625 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2289628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2289642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289664 */     // GIR_Coverage, 52410,
     /* 2289664 */     GIR_EraseRootFromParent_Done,
     /* 2289665 */   // Label 31111: @2289665
     /* 2289665 */   GIM_Try, /*On fail goto*//*Label 31112*/ GIMT_Encode4(2289713), // Rule ID 52411 //
     /* 2289670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289673 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2289676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2289690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289712 */     // GIR_Coverage, 52411,
     /* 2289712 */     GIR_EraseRootFromParent_Done,
     /* 2289713 */   // Label 31112: @2289713
     /* 2289713 */   GIM_Reject,
     /* 2289714 */ // Label 31110: @2289714
     /* 2289714 */ GIM_Reject,
     /* 2289715 */ // Label 31053: @2289715
     /* 2289715 */ GIM_Try, /*On fail goto*//*Label 31113*/ GIMT_Encode4(2289835),
     /* 2289720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2289723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2289726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289738 */   GIM_Try, /*On fail goto*//*Label 31114*/ GIMT_Encode4(2289786), // Rule ID 52426 //
     /* 2289743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289746 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2289749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289785 */     // GIR_Coverage, 52426,
     /* 2289785 */     GIR_EraseRootFromParent_Done,
     /* 2289786 */   // Label 31114: @2289786
     /* 2289786 */   GIM_Try, /*On fail goto*//*Label 31115*/ GIMT_Encode4(2289834), // Rule ID 52427 //
     /* 2289791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289794 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2289797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2289811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2289826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289833 */     // GIR_Coverage, 52427,
     /* 2289833 */     GIR_EraseRootFromParent_Done,
     /* 2289834 */   // Label 31115: @2289834
     /* 2289834 */   GIM_Reject,
     /* 2289835 */ // Label 31113: @2289835
     /* 2289835 */ GIM_Reject,
     /* 2289836 */ // Label 31054: @2289836
     /* 2289836 */ GIM_Try, /*On fail goto*//*Label 31116*/ GIMT_Encode4(2289956),
     /* 2289841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2289844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2289847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2289859 */   GIM_Try, /*On fail goto*//*Label 31117*/ GIMT_Encode4(2289907), // Rule ID 52442 //
     /* 2289864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289867 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2289870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2289884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289906 */     // GIR_Coverage, 52442,
     /* 2289906 */     GIR_EraseRootFromParent_Done,
     /* 2289907 */   // Label 31117: @2289907
     /* 2289907 */   GIM_Try, /*On fail goto*//*Label 31118*/ GIMT_Encode4(2289955), // Rule ID 52443 //
     /* 2289912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2289915 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2289915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2289918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2289927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2289929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2289932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2289937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2289944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2289947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2289950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2289953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289954 */     // GIR_Coverage, 52443,
     /* 2289954 */     GIR_EraseRootFromParent_Done,
     /* 2289955 */   // Label 31118: @2289955
     /* 2289955 */   GIM_Reject,
     /* 2289956 */ // Label 31116: @2289956
     /* 2289956 */ GIM_Reject,
     /* 2289957 */ // Label 31055: @2289957
     /* 2289957 */ GIM_Try, /*On fail goto*//*Label 31119*/ GIMT_Encode4(2290077),
     /* 2289962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2289965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2289968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2289980 */   GIM_Try, /*On fail goto*//*Label 31120*/ GIMT_Encode4(2290028), // Rule ID 52414 //
     /* 2289985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2289988 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2289988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2289991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2289995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2290005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290027 */     // GIR_Coverage, 52414,
     /* 2290027 */     GIR_EraseRootFromParent_Done,
     /* 2290028 */   // Label 31120: @2290028
     /* 2290028 */   GIM_Try, /*On fail goto*//*Label 31121*/ GIMT_Encode4(2290076), // Rule ID 52415 //
     /* 2290033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290036 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2290039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2290053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290075 */     // GIR_Coverage, 52415,
     /* 2290075 */     GIR_EraseRootFromParent_Done,
     /* 2290076 */   // Label 31121: @2290076
     /* 2290076 */   GIM_Reject,
     /* 2290077 */ // Label 31119: @2290077
     /* 2290077 */ GIM_Reject,
     /* 2290078 */ // Label 31056: @2290078
     /* 2290078 */ GIM_Try, /*On fail goto*//*Label 31122*/ GIMT_Encode4(2290198),
     /* 2290083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2290086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2290089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290101 */   GIM_Try, /*On fail goto*//*Label 31123*/ GIMT_Encode4(2290149), // Rule ID 52430 //
     /* 2290106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290109 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2290112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290148 */     // GIR_Coverage, 52430,
     /* 2290148 */     GIR_EraseRootFromParent_Done,
     /* 2290149 */   // Label 31123: @2290149
     /* 2290149 */   GIM_Try, /*On fail goto*//*Label 31124*/ GIMT_Encode4(2290197), // Rule ID 52431 //
     /* 2290154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290157 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2290160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290196 */     // GIR_Coverage, 52431,
     /* 2290196 */     GIR_EraseRootFromParent_Done,
     /* 2290197 */   // Label 31124: @2290197
     /* 2290197 */   GIM_Reject,
     /* 2290198 */ // Label 31122: @2290198
     /* 2290198 */ GIM_Reject,
     /* 2290199 */ // Label 31057: @2290199
     /* 2290199 */ GIM_Try, /*On fail goto*//*Label 31125*/ GIMT_Encode4(2290319),
     /* 2290204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2290207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2290210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290218 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2290222 */   GIM_Try, /*On fail goto*//*Label 31126*/ GIMT_Encode4(2290270), // Rule ID 52418 //
     /* 2290227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290230 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2290233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290269 */     // GIR_Coverage, 52418,
     /* 2290269 */     GIR_EraseRootFromParent_Done,
     /* 2290270 */   // Label 31126: @2290270
     /* 2290270 */   GIM_Try, /*On fail goto*//*Label 31127*/ GIMT_Encode4(2290318), // Rule ID 52419 //
     /* 2290275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290278 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2290281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2290295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290317 */     // GIR_Coverage, 52419,
     /* 2290317 */     GIR_EraseRootFromParent_Done,
     /* 2290318 */   // Label 31127: @2290318
     /* 2290318 */   GIM_Reject,
     /* 2290319 */ // Label 31125: @2290319
     /* 2290319 */ GIM_Reject,
     /* 2290320 */ // Label 31058: @2290320
     /* 2290320 */ GIM_Reject,
     /* 2290321 */ // Label 55: @2290321
     /* 2290321 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31151*/ GIMT_Encode4(2293173),
     /* 2290332 */ /*GILLT_s32*//*Label 31128*/ GIMT_Encode4(2290456), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2290344 */ /*GILLT_nxv1s8*//*Label 31129*/ GIMT_Encode4(2290511),
     /* 2290348 */ /*GILLT_nxv1s16*//*Label 31130*/ GIMT_Encode4(2290632),
     /* 2290352 */ /*GILLT_nxv1s32*//*Label 31131*/ GIMT_Encode4(2290753),
     /* 2290356 */ /*GILLT_nxv1s64*//*Label 31132*/ GIMT_Encode4(2290874), GIMT_Encode4(0),
     /* 2290364 */ /*GILLT_nxv2s8*//*Label 31133*/ GIMT_Encode4(2290995),
     /* 2290368 */ /*GILLT_nxv2s16*//*Label 31134*/ GIMT_Encode4(2291116),
     /* 2290372 */ /*GILLT_nxv2s32*//*Label 31135*/ GIMT_Encode4(2291237),
     /* 2290376 */ /*GILLT_nxv2s64*//*Label 31136*/ GIMT_Encode4(2291358), GIMT_Encode4(0),
     /* 2290384 */ /*GILLT_nxv4s8*//*Label 31137*/ GIMT_Encode4(2291479),
     /* 2290388 */ /*GILLT_nxv4s16*//*Label 31138*/ GIMT_Encode4(2291600),
     /* 2290392 */ /*GILLT_nxv4s32*//*Label 31139*/ GIMT_Encode4(2291721),
     /* 2290396 */ /*GILLT_nxv4s64*//*Label 31140*/ GIMT_Encode4(2291842), GIMT_Encode4(0),
     /* 2290404 */ /*GILLT_nxv8s8*//*Label 31141*/ GIMT_Encode4(2291963),
     /* 2290408 */ /*GILLT_nxv8s16*//*Label 31142*/ GIMT_Encode4(2292084),
     /* 2290412 */ /*GILLT_nxv8s32*//*Label 31143*/ GIMT_Encode4(2292205),
     /* 2290416 */ /*GILLT_nxv8s64*//*Label 31144*/ GIMT_Encode4(2292326), GIMT_Encode4(0),
     /* 2290424 */ /*GILLT_nxv16s8*//*Label 31145*/ GIMT_Encode4(2292447),
     /* 2290428 */ /*GILLT_nxv16s16*//*Label 31146*/ GIMT_Encode4(2292568),
     /* 2290432 */ /*GILLT_nxv16s32*//*Label 31147*/ GIMT_Encode4(2292689), GIMT_Encode4(0),
     /* 2290440 */ /*GILLT_nxv32s8*//*Label 31148*/ GIMT_Encode4(2292810),
     /* 2290444 */ /*GILLT_nxv32s16*//*Label 31149*/ GIMT_Encode4(2292931), GIMT_Encode4(0),
     /* 2290452 */ /*GILLT_nxv64s8*//*Label 31150*/ GIMT_Encode4(2293052),
     /* 2290456 */ // Label 31128: @2290456
     /* 2290456 */ GIM_Try, /*On fail goto*//*Label 31152*/ GIMT_Encode4(2290510),
     /* 2290461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2290467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2290479 */   GIM_Try, /*On fail goto*//*Label 31153*/ GIMT_Encode4(2290494), // Rule ID 64578 //
     /* 2290484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2290487 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2290492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290493 */     // GIR_Coverage, 64578,
     /* 2290493 */     GIR_Done,
     /* 2290494 */   // Label 31153: @2290494
     /* 2290494 */   GIM_Try, /*On fail goto*//*Label 31154*/ GIMT_Encode4(2290509), // Rule ID 64579 //
     /* 2290499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2290502 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2290502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2290507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290508 */     // GIR_Coverage, 64579,
     /* 2290508 */     GIR_Done,
     /* 2290509 */   // Label 31154: @2290509
     /* 2290509 */   GIM_Reject,
     /* 2290510 */ // Label 31152: @2290510
     /* 2290510 */ GIM_Reject,
     /* 2290511 */ // Label 31129: @2290511
     /* 2290511 */ GIM_Try, /*On fail goto*//*Label 31155*/ GIMT_Encode4(2290631),
     /* 2290516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2290519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2290522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290534 */   GIM_Try, /*On fail goto*//*Label 31156*/ GIMT_Encode4(2290582), // Rule ID 52722 //
     /* 2290539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290542 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2290545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2290559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290577 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290581 */     // GIR_Coverage, 52722,
     /* 2290581 */     GIR_EraseRootFromParent_Done,
     /* 2290582 */   // Label 31156: @2290582
     /* 2290582 */   GIM_Try, /*On fail goto*//*Label 31157*/ GIMT_Encode4(2290630), // Rule ID 52723 //
     /* 2290587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290590 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2290593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2290607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290629 */     // GIR_Coverage, 52723,
     /* 2290629 */     GIR_EraseRootFromParent_Done,
     /* 2290630 */   // Label 31157: @2290630
     /* 2290630 */   GIM_Reject,
     /* 2290631 */ // Label 31155: @2290631
     /* 2290631 */ GIM_Reject,
     /* 2290632 */ // Label 31130: @2290632
     /* 2290632 */ GIM_Try, /*On fail goto*//*Label 31158*/ GIMT_Encode4(2290752),
     /* 2290637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2290640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2290643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290655 */   GIM_Try, /*On fail goto*//*Label 31159*/ GIMT_Encode4(2290703), // Rule ID 52734 //
     /* 2290660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290663 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2290666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2290680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290702 */     // GIR_Coverage, 52734,
     /* 2290702 */     GIR_EraseRootFromParent_Done,
     /* 2290703 */   // Label 31159: @2290703
     /* 2290703 */   GIM_Try, /*On fail goto*//*Label 31160*/ GIMT_Encode4(2290751), // Rule ID 52735 //
     /* 2290708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290711 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2290714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2290728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2290743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290750 */     // GIR_Coverage, 52735,
     /* 2290750 */     GIR_EraseRootFromParent_Done,
     /* 2290751 */   // Label 31160: @2290751
     /* 2290751 */   GIM_Reject,
     /* 2290752 */ // Label 31158: @2290752
     /* 2290752 */ GIM_Reject,
     /* 2290753 */ // Label 31131: @2290753
     /* 2290753 */ GIM_Try, /*On fail goto*//*Label 31161*/ GIMT_Encode4(2290873),
     /* 2290758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2290761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2290764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290776 */   GIM_Try, /*On fail goto*//*Label 31162*/ GIMT_Encode4(2290824), // Rule ID 52742 //
     /* 2290781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2290784 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2290787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2290801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290823 */     // GIR_Coverage, 52742,
     /* 2290823 */     GIR_EraseRootFromParent_Done,
     /* 2290824 */   // Label 31162: @2290824
     /* 2290824 */   GIM_Try, /*On fail goto*//*Label 31163*/ GIMT_Encode4(2290872), // Rule ID 52743 //
     /* 2290829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2290832 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2290835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2290849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2290864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290871 */     // GIR_Coverage, 52743,
     /* 2290871 */     GIR_EraseRootFromParent_Done,
     /* 2290872 */   // Label 31163: @2290872
     /* 2290872 */   GIM_Reject,
     /* 2290873 */ // Label 31161: @2290873
     /* 2290873 */ GIM_Reject,
     /* 2290874 */ // Label 31132: @2290874
     /* 2290874 */ GIM_Try, /*On fail goto*//*Label 31164*/ GIMT_Encode4(2290994),
     /* 2290879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2290882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2290885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2290897 */   GIM_Try, /*On fail goto*//*Label 31165*/ GIMT_Encode4(2290945), // Rule ID 52758 //
     /* 2290902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2290905 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2290905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2290908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2290922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290944 */     // GIR_Coverage, 52758,
     /* 2290944 */     GIR_EraseRootFromParent_Done,
     /* 2290945 */   // Label 31165: @2290945
     /* 2290945 */   GIM_Try, /*On fail goto*//*Label 31166*/ GIMT_Encode4(2290993), // Rule ID 52759 //
     /* 2290950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2290953 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2290953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2290956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2290960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2290965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2290967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2290970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2290975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2290982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2290985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2290988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2290991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290992 */     // GIR_Coverage, 52759,
     /* 2290992 */     GIR_EraseRootFromParent_Done,
     /* 2290993 */   // Label 31166: @2290993
     /* 2290993 */   GIM_Reject,
     /* 2290994 */ // Label 31164: @2290994
     /* 2290994 */ GIM_Reject,
     /* 2290995 */ // Label 31133: @2290995
     /* 2290995 */ GIM_Try, /*On fail goto*//*Label 31167*/ GIMT_Encode4(2291115),
     /* 2291000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2291003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2291006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291018 */   GIM_Try, /*On fail goto*//*Label 31168*/ GIMT_Encode4(2291066), // Rule ID 52726 //
     /* 2291023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291026 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2291029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2291043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291065 */     // GIR_Coverage, 52726,
     /* 2291065 */     GIR_EraseRootFromParent_Done,
     /* 2291066 */   // Label 31168: @2291066
     /* 2291066 */   GIM_Try, /*On fail goto*//*Label 31169*/ GIMT_Encode4(2291114), // Rule ID 52727 //
     /* 2291071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291074 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2291077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2291091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291113 */     // GIR_Coverage, 52727,
     /* 2291113 */     GIR_EraseRootFromParent_Done,
     /* 2291114 */   // Label 31169: @2291114
     /* 2291114 */   GIM_Reject,
     /* 2291115 */ // Label 31167: @2291115
     /* 2291115 */ GIM_Reject,
     /* 2291116 */ // Label 31134: @2291116
     /* 2291116 */ GIM_Try, /*On fail goto*//*Label 31170*/ GIMT_Encode4(2291236),
     /* 2291121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2291124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2291127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291139 */   GIM_Try, /*On fail goto*//*Label 31171*/ GIMT_Encode4(2291187), // Rule ID 52738 //
     /* 2291144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291147 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2291164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291186 */     // GIR_Coverage, 52738,
     /* 2291186 */     GIR_EraseRootFromParent_Done,
     /* 2291187 */   // Label 31171: @2291187
     /* 2291187 */   GIM_Try, /*On fail goto*//*Label 31172*/ GIMT_Encode4(2291235), // Rule ID 52739 //
     /* 2291192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291195 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2291198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2291212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291234 */     // GIR_Coverage, 52739,
     /* 2291234 */     GIR_EraseRootFromParent_Done,
     /* 2291235 */   // Label 31172: @2291235
     /* 2291235 */   GIM_Reject,
     /* 2291236 */ // Label 31170: @2291236
     /* 2291236 */ GIM_Reject,
     /* 2291237 */ // Label 31135: @2291237
     /* 2291237 */ GIM_Try, /*On fail goto*//*Label 31173*/ GIMT_Encode4(2291357),
     /* 2291242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2291245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2291248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291260 */   GIM_Try, /*On fail goto*//*Label 31174*/ GIMT_Encode4(2291308), // Rule ID 52754 //
     /* 2291265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291268 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2291285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291307 */     // GIR_Coverage, 52754,
     /* 2291307 */     GIR_EraseRootFromParent_Done,
     /* 2291308 */   // Label 31174: @2291308
     /* 2291308 */   GIM_Try, /*On fail goto*//*Label 31175*/ GIMT_Encode4(2291356), // Rule ID 52755 //
     /* 2291313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291316 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2291319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2291333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291351 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291355 */     // GIR_Coverage, 52755,
     /* 2291355 */     GIR_EraseRootFromParent_Done,
     /* 2291356 */   // Label 31175: @2291356
     /* 2291356 */   GIM_Reject,
     /* 2291357 */ // Label 31173: @2291357
     /* 2291357 */ GIM_Reject,
     /* 2291358 */ // Label 31136: @2291358
     /* 2291358 */ GIM_Try, /*On fail goto*//*Label 31176*/ GIMT_Encode4(2291478),
     /* 2291363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2291366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2291369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291381 */   GIM_Try, /*On fail goto*//*Label 31177*/ GIMT_Encode4(2291429), // Rule ID 52798 //
     /* 2291386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291389 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2291406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291428 */     // GIR_Coverage, 52798,
     /* 2291428 */     GIR_EraseRootFromParent_Done,
     /* 2291429 */   // Label 31177: @2291429
     /* 2291429 */   GIM_Try, /*On fail goto*//*Label 31178*/ GIMT_Encode4(2291477), // Rule ID 52799 //
     /* 2291434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291437 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2291440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2291454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291476 */     // GIR_Coverage, 52799,
     /* 2291476 */     GIR_EraseRootFromParent_Done,
     /* 2291477 */   // Label 31178: @2291477
     /* 2291477 */   GIM_Reject,
     /* 2291478 */ // Label 31176: @2291478
     /* 2291478 */ GIM_Reject,
     /* 2291479 */ // Label 31137: @2291479
     /* 2291479 */ GIM_Try, /*On fail goto*//*Label 31179*/ GIMT_Encode4(2291599),
     /* 2291484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2291487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2291490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291502 */   GIM_Try, /*On fail goto*//*Label 31180*/ GIMT_Encode4(2291550), // Rule ID 52730 //
     /* 2291507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291510 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2291513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2291527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291549 */     // GIR_Coverage, 52730,
     /* 2291549 */     GIR_EraseRootFromParent_Done,
     /* 2291550 */   // Label 31180: @2291550
     /* 2291550 */   GIM_Try, /*On fail goto*//*Label 31181*/ GIMT_Encode4(2291598), // Rule ID 52731 //
     /* 2291555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291558 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2291561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2291575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291597 */     // GIR_Coverage, 52731,
     /* 2291597 */     GIR_EraseRootFromParent_Done,
     /* 2291598 */   // Label 31181: @2291598
     /* 2291598 */   GIM_Reject,
     /* 2291599 */ // Label 31179: @2291599
     /* 2291599 */ GIM_Reject,
     /* 2291600 */ // Label 31138: @2291600
     /* 2291600 */ GIM_Try, /*On fail goto*//*Label 31182*/ GIMT_Encode4(2291720),
     /* 2291605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2291608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2291611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291623 */   GIM_Try, /*On fail goto*//*Label 31183*/ GIMT_Encode4(2291671), // Rule ID 52750 //
     /* 2291628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291631 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2291634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2291648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291670 */     // GIR_Coverage, 52750,
     /* 2291670 */     GIR_EraseRootFromParent_Done,
     /* 2291671 */   // Label 31183: @2291671
     /* 2291671 */   GIM_Try, /*On fail goto*//*Label 31184*/ GIMT_Encode4(2291719), // Rule ID 52751 //
     /* 2291676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291679 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2291682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2291696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2291711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291718 */     // GIR_Coverage, 52751,
     /* 2291718 */     GIR_EraseRootFromParent_Done,
     /* 2291719 */   // Label 31184: @2291719
     /* 2291719 */   GIM_Reject,
     /* 2291720 */ // Label 31182: @2291720
     /* 2291720 */ GIM_Reject,
     /* 2291721 */ // Label 31139: @2291721
     /* 2291721 */ GIM_Try, /*On fail goto*//*Label 31185*/ GIMT_Encode4(2291841),
     /* 2291726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2291729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2291732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2291744 */   GIM_Try, /*On fail goto*//*Label 31186*/ GIMT_Encode4(2291792), // Rule ID 52786 //
     /* 2291749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291752 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2291755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2291769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291787 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291791 */     // GIR_Coverage, 52786,
     /* 2291791 */     GIR_EraseRootFromParent_Done,
     /* 2291792 */   // Label 31186: @2291792
     /* 2291792 */   GIM_Try, /*On fail goto*//*Label 31187*/ GIMT_Encode4(2291840), // Rule ID 52787 //
     /* 2291797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2291800 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2291803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2291817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2291832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291839 */     // GIR_Coverage, 52787,
     /* 2291839 */     GIR_EraseRootFromParent_Done,
     /* 2291840 */   // Label 31187: @2291840
     /* 2291840 */   GIM_Reject,
     /* 2291841 */ // Label 31185: @2291841
     /* 2291841 */ GIM_Reject,
     /* 2291842 */ // Label 31140: @2291842
     /* 2291842 */ GIM_Try, /*On fail goto*//*Label 31188*/ GIMT_Encode4(2291962),
     /* 2291847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2291850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2291853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2291865 */   GIM_Try, /*On fail goto*//*Label 31189*/ GIMT_Encode4(2291913), // Rule ID 52802 //
     /* 2291870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2291873 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2291876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2291890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291912 */     // GIR_Coverage, 52802,
     /* 2291912 */     GIR_EraseRootFromParent_Done,
     /* 2291913 */   // Label 31189: @2291913
     /* 2291913 */   GIM_Try, /*On fail goto*//*Label 31190*/ GIMT_Encode4(2291961), // Rule ID 52803 //
     /* 2291918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2291921 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2291921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2291924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2291928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2291933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2291935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2291938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2291943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2291950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2291953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2291956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2291959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291960 */     // GIR_Coverage, 52803,
     /* 2291960 */     GIR_EraseRootFromParent_Done,
     /* 2291961 */   // Label 31190: @2291961
     /* 2291961 */   GIM_Reject,
     /* 2291962 */ // Label 31188: @2291962
     /* 2291962 */ GIM_Reject,
     /* 2291963 */ // Label 31141: @2291963
     /* 2291963 */ GIM_Try, /*On fail goto*//*Label 31191*/ GIMT_Encode4(2292083),
     /* 2291968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2291971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2291974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2291986 */   GIM_Try, /*On fail goto*//*Label 31192*/ GIMT_Encode4(2292034), // Rule ID 52746 //
     /* 2291991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2291994 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2291994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2291997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2292011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292033 */     // GIR_Coverage, 52746,
     /* 2292033 */     GIR_EraseRootFromParent_Done,
     /* 2292034 */   // Label 31192: @2292034
     /* 2292034 */   GIM_Try, /*On fail goto*//*Label 31193*/ GIMT_Encode4(2292082), // Rule ID 52747 //
     /* 2292039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292042 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2292045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2292059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292081 */     // GIR_Coverage, 52747,
     /* 2292081 */     GIR_EraseRootFromParent_Done,
     /* 2292082 */   // Label 31193: @2292082
     /* 2292082 */   GIM_Reject,
     /* 2292083 */ // Label 31191: @2292083
     /* 2292083 */ GIM_Reject,
     /* 2292084 */ // Label 31142: @2292084
     /* 2292084 */ GIM_Try, /*On fail goto*//*Label 31194*/ GIMT_Encode4(2292204),
     /* 2292089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2292092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2292095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292107 */   GIM_Try, /*On fail goto*//*Label 31195*/ GIMT_Encode4(2292155), // Rule ID 52774 //
     /* 2292112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292115 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2292118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292154 */     // GIR_Coverage, 52774,
     /* 2292154 */     GIR_EraseRootFromParent_Done,
     /* 2292155 */   // Label 31195: @2292155
     /* 2292155 */   GIM_Try, /*On fail goto*//*Label 31196*/ GIMT_Encode4(2292203), // Rule ID 52775 //
     /* 2292160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292163 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2292166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292202 */     // GIR_Coverage, 52775,
     /* 2292202 */     GIR_EraseRootFromParent_Done,
     /* 2292203 */   // Label 31196: @2292203
     /* 2292203 */   GIM_Reject,
     /* 2292204 */ // Label 31194: @2292204
     /* 2292204 */ GIM_Reject,
     /* 2292205 */ // Label 31143: @2292205
     /* 2292205 */ GIM_Try, /*On fail goto*//*Label 31197*/ GIMT_Encode4(2292325),
     /* 2292210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2292213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2292216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292228 */   GIM_Try, /*On fail goto*//*Label 31198*/ GIMT_Encode4(2292276), // Rule ID 52790 //
     /* 2292233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292236 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2292239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292275 */     // GIR_Coverage, 52790,
     /* 2292275 */     GIR_EraseRootFromParent_Done,
     /* 2292276 */   // Label 31198: @2292276
     /* 2292276 */   GIM_Try, /*On fail goto*//*Label 31199*/ GIMT_Encode4(2292324), // Rule ID 52791 //
     /* 2292281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292284 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2292287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292323 */     // GIR_Coverage, 52791,
     /* 2292323 */     GIR_EraseRootFromParent_Done,
     /* 2292324 */   // Label 31199: @2292324
     /* 2292324 */   GIM_Reject,
     /* 2292325 */ // Label 31197: @2292325
     /* 2292325 */ GIM_Reject,
     /* 2292326 */ // Label 31144: @2292326
     /* 2292326 */ GIM_Try, /*On fail goto*//*Label 31200*/ GIMT_Encode4(2292446),
     /* 2292331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2292334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2292337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292349 */   GIM_Try, /*On fail goto*//*Label 31201*/ GIMT_Encode4(2292397), // Rule ID 52806 //
     /* 2292354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2292357 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2292374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292396 */     // GIR_Coverage, 52806,
     /* 2292396 */     GIR_EraseRootFromParent_Done,
     /* 2292397 */   // Label 31201: @2292397
     /* 2292397 */   GIM_Try, /*On fail goto*//*Label 31202*/ GIMT_Encode4(2292445), // Rule ID 52807 //
     /* 2292402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2292405 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2292408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2292422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2292437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292444 */     // GIR_Coverage, 52807,
     /* 2292444 */     GIR_EraseRootFromParent_Done,
     /* 2292445 */   // Label 31202: @2292445
     /* 2292445 */   GIM_Reject,
     /* 2292446 */ // Label 31200: @2292446
     /* 2292446 */ GIM_Reject,
     /* 2292447 */ // Label 31145: @2292447
     /* 2292447 */ GIM_Try, /*On fail goto*//*Label 31203*/ GIMT_Encode4(2292567),
     /* 2292452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2292455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2292458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2292470 */   GIM_Try, /*On fail goto*//*Label 31204*/ GIMT_Encode4(2292518), // Rule ID 52762 //
     /* 2292475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292478 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292517 */     // GIR_Coverage, 52762,
     /* 2292517 */     GIR_EraseRootFromParent_Done,
     /* 2292518 */   // Label 31204: @2292518
     /* 2292518 */   GIM_Try, /*On fail goto*//*Label 31205*/ GIMT_Encode4(2292566), // Rule ID 52763 //
     /* 2292523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292526 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2292529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2292543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292565 */     // GIR_Coverage, 52763,
     /* 2292565 */     GIR_EraseRootFromParent_Done,
     /* 2292566 */   // Label 31205: @2292566
     /* 2292566 */   GIM_Reject,
     /* 2292567 */ // Label 31203: @2292567
     /* 2292567 */ GIM_Reject,
     /* 2292568 */ // Label 31146: @2292568
     /* 2292568 */ GIM_Try, /*On fail goto*//*Label 31206*/ GIMT_Encode4(2292688),
     /* 2292573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2292576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2292579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292591 */   GIM_Try, /*On fail goto*//*Label 31207*/ GIMT_Encode4(2292639), // Rule ID 52778 //
     /* 2292596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292599 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2292602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292638 */     // GIR_Coverage, 52778,
     /* 2292638 */     GIR_EraseRootFromParent_Done,
     /* 2292639 */   // Label 31207: @2292639
     /* 2292639 */   GIM_Try, /*On fail goto*//*Label 31208*/ GIMT_Encode4(2292687), // Rule ID 52779 //
     /* 2292644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292647 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2292650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292686 */     // GIR_Coverage, 52779,
     /* 2292686 */     GIR_EraseRootFromParent_Done,
     /* 2292687 */   // Label 31208: @2292687
     /* 2292687 */   GIM_Reject,
     /* 2292688 */ // Label 31206: @2292688
     /* 2292688 */ GIM_Reject,
     /* 2292689 */ // Label 31147: @2292689
     /* 2292689 */ GIM_Try, /*On fail goto*//*Label 31209*/ GIMT_Encode4(2292809),
     /* 2292694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2292697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2292700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292712 */   GIM_Try, /*On fail goto*//*Label 31210*/ GIMT_Encode4(2292760), // Rule ID 52794 //
     /* 2292717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292720 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2292723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2292737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292759 */     // GIR_Coverage, 52794,
     /* 2292759 */     GIR_EraseRootFromParent_Done,
     /* 2292760 */   // Label 31210: @2292760
     /* 2292760 */   GIM_Try, /*On fail goto*//*Label 31211*/ GIMT_Encode4(2292808), // Rule ID 52795 //
     /* 2292765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292768 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2292771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2292785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2292800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292807 */     // GIR_Coverage, 52795,
     /* 2292807 */     GIR_EraseRootFromParent_Done,
     /* 2292808 */   // Label 31211: @2292808
     /* 2292808 */   GIM_Reject,
     /* 2292809 */ // Label 31209: @2292809
     /* 2292809 */ GIM_Reject,
     /* 2292810 */ // Label 31148: @2292810
     /* 2292810 */ GIM_Try, /*On fail goto*//*Label 31212*/ GIMT_Encode4(2292930),
     /* 2292815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2292818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2292821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292829 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2292833 */   GIM_Try, /*On fail goto*//*Label 31213*/ GIMT_Encode4(2292881), // Rule ID 52766 //
     /* 2292838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292841 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2292844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292880 */     // GIR_Coverage, 52766,
     /* 2292880 */     GIR_EraseRootFromParent_Done,
     /* 2292881 */   // Label 31213: @2292881
     /* 2292881 */   GIM_Try, /*On fail goto*//*Label 31214*/ GIMT_Encode4(2292929), // Rule ID 52767 //
     /* 2292886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2292889 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2292889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2292892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2292906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2292927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292928 */     // GIR_Coverage, 52767,
     /* 2292928 */     GIR_EraseRootFromParent_Done,
     /* 2292929 */   // Label 31214: @2292929
     /* 2292929 */   GIM_Reject,
     /* 2292930 */ // Label 31212: @2292930
     /* 2292930 */ GIM_Reject,
     /* 2292931 */ // Label 31149: @2292931
     /* 2292931 */ GIM_Try, /*On fail goto*//*Label 31215*/ GIMT_Encode4(2293051),
     /* 2292936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2292939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2292942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2292954 */   GIM_Try, /*On fail goto*//*Label 31216*/ GIMT_Encode4(2293002), // Rule ID 52782 //
     /* 2292959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2292962 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2292962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2292965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2292969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2292974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2292976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2292979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2292984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2292991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2292994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2292997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293001 */     // GIR_Coverage, 52782,
     /* 2293001 */     GIR_EraseRootFromParent_Done,
     /* 2293002 */   // Label 31216: @2293002
     /* 2293002 */   GIM_Try, /*On fail goto*//*Label 31217*/ GIMT_Encode4(2293050), // Rule ID 52783 //
     /* 2293007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293010 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2293013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2293027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293049 */     // GIR_Coverage, 52783,
     /* 2293049 */     GIR_EraseRootFromParent_Done,
     /* 2293050 */   // Label 31217: @2293050
     /* 2293050 */   GIM_Reject,
     /* 2293051 */ // Label 31215: @2293051
     /* 2293051 */ GIM_Reject,
     /* 2293052 */ // Label 31150: @2293052
     /* 2293052 */ GIM_Try, /*On fail goto*//*Label 31218*/ GIMT_Encode4(2293172),
     /* 2293057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2293060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2293063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2293075 */   GIM_Try, /*On fail goto*//*Label 31219*/ GIMT_Encode4(2293123), // Rule ID 52770 //
     /* 2293080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293083 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2293086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2293100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293122 */     // GIR_Coverage, 52770,
     /* 2293122 */     GIR_EraseRootFromParent_Done,
     /* 2293123 */   // Label 31219: @2293123
     /* 2293123 */   GIM_Try, /*On fail goto*//*Label 31220*/ GIMT_Encode4(2293171), // Rule ID 52771 //
     /* 2293128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293131 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2293134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2293148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293170 */     // GIR_Coverage, 52771,
     /* 2293170 */     GIR_EraseRootFromParent_Done,
     /* 2293171 */   // Label 31220: @2293171
     /* 2293171 */   GIM_Reject,
     /* 2293172 */ // Label 31218: @2293172
     /* 2293172 */ GIM_Reject,
     /* 2293173 */ // Label 31151: @2293173
     /* 2293173 */ GIM_Reject,
     /* 2293174 */ // Label 56: @2293174
     /* 2293174 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31244*/ GIMT_Encode4(2296026),
     /* 2293185 */ /*GILLT_s32*//*Label 31221*/ GIMT_Encode4(2293309), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2293197 */ /*GILLT_nxv1s8*//*Label 31222*/ GIMT_Encode4(2293364),
     /* 2293201 */ /*GILLT_nxv1s16*//*Label 31223*/ GIMT_Encode4(2293485),
     /* 2293205 */ /*GILLT_nxv1s32*//*Label 31224*/ GIMT_Encode4(2293606),
     /* 2293209 */ /*GILLT_nxv1s64*//*Label 31225*/ GIMT_Encode4(2293727), GIMT_Encode4(0),
     /* 2293217 */ /*GILLT_nxv2s8*//*Label 31226*/ GIMT_Encode4(2293848),
     /* 2293221 */ /*GILLT_nxv2s16*//*Label 31227*/ GIMT_Encode4(2293969),
     /* 2293225 */ /*GILLT_nxv2s32*//*Label 31228*/ GIMT_Encode4(2294090),
     /* 2293229 */ /*GILLT_nxv2s64*//*Label 31229*/ GIMT_Encode4(2294211), GIMT_Encode4(0),
     /* 2293237 */ /*GILLT_nxv4s8*//*Label 31230*/ GIMT_Encode4(2294332),
     /* 2293241 */ /*GILLT_nxv4s16*//*Label 31231*/ GIMT_Encode4(2294453),
     /* 2293245 */ /*GILLT_nxv4s32*//*Label 31232*/ GIMT_Encode4(2294574),
     /* 2293249 */ /*GILLT_nxv4s64*//*Label 31233*/ GIMT_Encode4(2294695), GIMT_Encode4(0),
     /* 2293257 */ /*GILLT_nxv8s8*//*Label 31234*/ GIMT_Encode4(2294816),
     /* 2293261 */ /*GILLT_nxv8s16*//*Label 31235*/ GIMT_Encode4(2294937),
     /* 2293265 */ /*GILLT_nxv8s32*//*Label 31236*/ GIMT_Encode4(2295058),
     /* 2293269 */ /*GILLT_nxv8s64*//*Label 31237*/ GIMT_Encode4(2295179), GIMT_Encode4(0),
     /* 2293277 */ /*GILLT_nxv16s8*//*Label 31238*/ GIMT_Encode4(2295300),
     /* 2293281 */ /*GILLT_nxv16s16*//*Label 31239*/ GIMT_Encode4(2295421),
     /* 2293285 */ /*GILLT_nxv16s32*//*Label 31240*/ GIMT_Encode4(2295542), GIMT_Encode4(0),
     /* 2293293 */ /*GILLT_nxv32s8*//*Label 31241*/ GIMT_Encode4(2295663),
     /* 2293297 */ /*GILLT_nxv32s16*//*Label 31242*/ GIMT_Encode4(2295784), GIMT_Encode4(0),
     /* 2293305 */ /*GILLT_nxv64s8*//*Label 31243*/ GIMT_Encode4(2295905),
     /* 2293309 */ // Label 31221: @2293309
     /* 2293309 */ GIM_Try, /*On fail goto*//*Label 31245*/ GIMT_Encode4(2293363),
     /* 2293314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2293317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2293320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2293332 */   GIM_Try, /*On fail goto*//*Label 31246*/ GIMT_Encode4(2293347), // Rule ID 64576 //
     /* 2293337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2293340 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2293345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293346 */     // GIR_Coverage, 64576,
     /* 2293346 */     GIR_Done,
     /* 2293347 */   // Label 31246: @2293347
     /* 2293347 */   GIM_Try, /*On fail goto*//*Label 31247*/ GIMT_Encode4(2293362), // Rule ID 64577 //
     /* 2293352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2293355 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2293355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2293360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293361 */     // GIR_Coverage, 64577,
     /* 2293361 */     GIR_Done,
     /* 2293362 */   // Label 31247: @2293362
     /* 2293362 */   GIM_Reject,
     /* 2293363 */ // Label 31245: @2293363
     /* 2293363 */ GIM_Reject,
     /* 2293364 */ // Label 31222: @2293364
     /* 2293364 */ GIM_Try, /*On fail goto*//*Label 31248*/ GIMT_Encode4(2293484),
     /* 2293369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2293372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2293375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293387 */   GIM_Try, /*On fail goto*//*Label 31249*/ GIMT_Encode4(2293435), // Rule ID 52634 //
     /* 2293392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293395 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2293412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293434 */     // GIR_Coverage, 52634,
     /* 2293434 */     GIR_EraseRootFromParent_Done,
     /* 2293435 */   // Label 31249: @2293435
     /* 2293435 */   GIM_Try, /*On fail goto*//*Label 31250*/ GIMT_Encode4(2293483), // Rule ID 52635 //
     /* 2293440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293443 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2293446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2293460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293482 */     // GIR_Coverage, 52635,
     /* 2293482 */     GIR_EraseRootFromParent_Done,
     /* 2293483 */   // Label 31250: @2293483
     /* 2293483 */   GIM_Reject,
     /* 2293484 */ // Label 31248: @2293484
     /* 2293484 */ GIM_Reject,
     /* 2293485 */ // Label 31223: @2293485
     /* 2293485 */ GIM_Try, /*On fail goto*//*Label 31251*/ GIMT_Encode4(2293605),
     /* 2293490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2293496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293508 */   GIM_Try, /*On fail goto*//*Label 31252*/ GIMT_Encode4(2293556), // Rule ID 52646 //
     /* 2293513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293516 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2293519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2293533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293555 */     // GIR_Coverage, 52646,
     /* 2293555 */     GIR_EraseRootFromParent_Done,
     /* 2293556 */   // Label 31252: @2293556
     /* 2293556 */   GIM_Try, /*On fail goto*//*Label 31253*/ GIMT_Encode4(2293604), // Rule ID 52647 //
     /* 2293561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293564 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2293567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2293581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293603 */     // GIR_Coverage, 52647,
     /* 2293603 */     GIR_EraseRootFromParent_Done,
     /* 2293604 */   // Label 31253: @2293604
     /* 2293604 */   GIM_Reject,
     /* 2293605 */ // Label 31251: @2293605
     /* 2293605 */ GIM_Reject,
     /* 2293606 */ // Label 31224: @2293606
     /* 2293606 */ GIM_Try, /*On fail goto*//*Label 31254*/ GIMT_Encode4(2293726),
     /* 2293611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2293617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293629 */   GIM_Try, /*On fail goto*//*Label 31255*/ GIMT_Encode4(2293677), // Rule ID 52654 //
     /* 2293634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293637 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2293640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2293654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293676 */     // GIR_Coverage, 52654,
     /* 2293676 */     GIR_EraseRootFromParent_Done,
     /* 2293677 */   // Label 31255: @2293677
     /* 2293677 */   GIM_Try, /*On fail goto*//*Label 31256*/ GIMT_Encode4(2293725), // Rule ID 52655 //
     /* 2293682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293685 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2293688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2293702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293724 */     // GIR_Coverage, 52655,
     /* 2293724 */     GIR_EraseRootFromParent_Done,
     /* 2293725 */   // Label 31256: @2293725
     /* 2293725 */   GIM_Reject,
     /* 2293726 */ // Label 31254: @2293726
     /* 2293726 */ GIM_Reject,
     /* 2293727 */ // Label 31225: @2293727
     /* 2293727 */ GIM_Try, /*On fail goto*//*Label 31257*/ GIMT_Encode4(2293847),
     /* 2293732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2293735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2293738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293750 */   GIM_Try, /*On fail goto*//*Label 31258*/ GIMT_Encode4(2293798), // Rule ID 52670 //
     /* 2293755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2293758 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2293761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2293775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293797 */     // GIR_Coverage, 52670,
     /* 2293797 */     GIR_EraseRootFromParent_Done,
     /* 2293798 */   // Label 31258: @2293798
     /* 2293798 */   GIM_Try, /*On fail goto*//*Label 31259*/ GIMT_Encode4(2293846), // Rule ID 52671 //
     /* 2293803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2293806 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2293809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2293823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2293838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293845 */     // GIR_Coverage, 52671,
     /* 2293845 */     GIR_EraseRootFromParent_Done,
     /* 2293846 */   // Label 31259: @2293846
     /* 2293846 */   GIM_Reject,
     /* 2293847 */ // Label 31257: @2293847
     /* 2293847 */ GIM_Reject,
     /* 2293848 */ // Label 31226: @2293848
     /* 2293848 */ GIM_Try, /*On fail goto*//*Label 31260*/ GIMT_Encode4(2293968),
     /* 2293853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2293856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2293859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293871 */   GIM_Try, /*On fail goto*//*Label 31261*/ GIMT_Encode4(2293919), // Rule ID 52638 //
     /* 2293876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2293879 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2293879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2293882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2293896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293918 */     // GIR_Coverage, 52638,
     /* 2293918 */     GIR_EraseRootFromParent_Done,
     /* 2293919 */   // Label 31261: @2293919
     /* 2293919 */   GIM_Try, /*On fail goto*//*Label 31262*/ GIMT_Encode4(2293967), // Rule ID 52639 //
     /* 2293924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2293927 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2293927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2293930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2293934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2293939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2293941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2293944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2293949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2293953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2293962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2293965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293966 */     // GIR_Coverage, 52639,
     /* 2293966 */     GIR_EraseRootFromParent_Done,
     /* 2293967 */   // Label 31262: @2293967
     /* 2293967 */   GIM_Reject,
     /* 2293968 */ // Label 31260: @2293968
     /* 2293968 */ GIM_Reject,
     /* 2293969 */ // Label 31227: @2293969
     /* 2293969 */ GIM_Try, /*On fail goto*//*Label 31263*/ GIMT_Encode4(2294089),
     /* 2293974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2293977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2293980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293992 */   GIM_Try, /*On fail goto*//*Label 31264*/ GIMT_Encode4(2294040), // Rule ID 52650 //
     /* 2293997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294000 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2294003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294039 */     // GIR_Coverage, 52650,
     /* 2294039 */     GIR_EraseRootFromParent_Done,
     /* 2294040 */   // Label 31264: @2294040
     /* 2294040 */   GIM_Try, /*On fail goto*//*Label 31265*/ GIMT_Encode4(2294088), // Rule ID 52651 //
     /* 2294045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294048 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2294051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294087 */     // GIR_Coverage, 52651,
     /* 2294087 */     GIR_EraseRootFromParent_Done,
     /* 2294088 */   // Label 31265: @2294088
     /* 2294088 */   GIM_Reject,
     /* 2294089 */ // Label 31263: @2294089
     /* 2294089 */ GIM_Reject,
     /* 2294090 */ // Label 31228: @2294090
     /* 2294090 */ GIM_Try, /*On fail goto*//*Label 31266*/ GIMT_Encode4(2294210),
     /* 2294095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2294098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2294101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294113 */   GIM_Try, /*On fail goto*//*Label 31267*/ GIMT_Encode4(2294161), // Rule ID 52666 //
     /* 2294118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294121 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2294124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294160 */     // GIR_Coverage, 52666,
     /* 2294160 */     GIR_EraseRootFromParent_Done,
     /* 2294161 */   // Label 31267: @2294161
     /* 2294161 */   GIM_Try, /*On fail goto*//*Label 31268*/ GIMT_Encode4(2294209), // Rule ID 52667 //
     /* 2294166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294169 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2294172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294208 */     // GIR_Coverage, 52667,
     /* 2294208 */     GIR_EraseRootFromParent_Done,
     /* 2294209 */   // Label 31268: @2294209
     /* 2294209 */   GIM_Reject,
     /* 2294210 */ // Label 31266: @2294210
     /* 2294210 */ GIM_Reject,
     /* 2294211 */ // Label 31229: @2294211
     /* 2294211 */ GIM_Try, /*On fail goto*//*Label 31269*/ GIMT_Encode4(2294331),
     /* 2294216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2294219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2294222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294234 */   GIM_Try, /*On fail goto*//*Label 31270*/ GIMT_Encode4(2294282), // Rule ID 52710 //
     /* 2294239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294242 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2294245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2294259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294281 */     // GIR_Coverage, 52710,
     /* 2294281 */     GIR_EraseRootFromParent_Done,
     /* 2294282 */   // Label 31270: @2294282
     /* 2294282 */   GIM_Try, /*On fail goto*//*Label 31271*/ GIMT_Encode4(2294330), // Rule ID 52711 //
     /* 2294287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294290 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2294293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2294307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294329 */     // GIR_Coverage, 52711,
     /* 2294329 */     GIR_EraseRootFromParent_Done,
     /* 2294330 */   // Label 31271: @2294330
     /* 2294330 */   GIM_Reject,
     /* 2294331 */ // Label 31269: @2294331
     /* 2294331 */ GIM_Reject,
     /* 2294332 */ // Label 31230: @2294332
     /* 2294332 */ GIM_Try, /*On fail goto*//*Label 31272*/ GIMT_Encode4(2294452),
     /* 2294337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2294340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2294343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294355 */   GIM_Try, /*On fail goto*//*Label 31273*/ GIMT_Encode4(2294403), // Rule ID 52642 //
     /* 2294360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294363 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294402 */     // GIR_Coverage, 52642,
     /* 2294402 */     GIR_EraseRootFromParent_Done,
     /* 2294403 */   // Label 31273: @2294403
     /* 2294403 */   GIM_Try, /*On fail goto*//*Label 31274*/ GIMT_Encode4(2294451), // Rule ID 52643 //
     /* 2294408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294411 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2294414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2294428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294450 */     // GIR_Coverage, 52643,
     /* 2294450 */     GIR_EraseRootFromParent_Done,
     /* 2294451 */   // Label 31274: @2294451
     /* 2294451 */   GIM_Reject,
     /* 2294452 */ // Label 31272: @2294452
     /* 2294452 */ GIM_Reject,
     /* 2294453 */ // Label 31231: @2294453
     /* 2294453 */ GIM_Try, /*On fail goto*//*Label 31275*/ GIMT_Encode4(2294573),
     /* 2294458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2294461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2294464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294476 */   GIM_Try, /*On fail goto*//*Label 31276*/ GIMT_Encode4(2294524), // Rule ID 52662 //
     /* 2294481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294484 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294523 */     // GIR_Coverage, 52662,
     /* 2294523 */     GIR_EraseRootFromParent_Done,
     /* 2294524 */   // Label 31276: @2294524
     /* 2294524 */   GIM_Try, /*On fail goto*//*Label 31277*/ GIMT_Encode4(2294572), // Rule ID 52663 //
     /* 2294529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294532 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2294535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2294564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294571 */     // GIR_Coverage, 52663,
     /* 2294571 */     GIR_EraseRootFromParent_Done,
     /* 2294572 */   // Label 31277: @2294572
     /* 2294572 */   GIM_Reject,
     /* 2294573 */ // Label 31275: @2294573
     /* 2294573 */ GIM_Reject,
     /* 2294574 */ // Label 31232: @2294574
     /* 2294574 */ GIM_Try, /*On fail goto*//*Label 31278*/ GIMT_Encode4(2294694),
     /* 2294579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2294582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2294585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294597 */   GIM_Try, /*On fail goto*//*Label 31279*/ GIMT_Encode4(2294645), // Rule ID 52698 //
     /* 2294602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294605 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2294608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2294622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294644 */     // GIR_Coverage, 52698,
     /* 2294644 */     GIR_EraseRootFromParent_Done,
     /* 2294645 */   // Label 31279: @2294645
     /* 2294645 */   GIM_Try, /*On fail goto*//*Label 31280*/ GIMT_Encode4(2294693), // Rule ID 52699 //
     /* 2294650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294653 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2294656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2294670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294692 */     // GIR_Coverage, 52699,
     /* 2294692 */     GIR_EraseRootFromParent_Done,
     /* 2294693 */   // Label 31280: @2294693
     /* 2294693 */   GIM_Reject,
     /* 2294694 */ // Label 31278: @2294694
     /* 2294694 */ GIM_Reject,
     /* 2294695 */ // Label 31233: @2294695
     /* 2294695 */ GIM_Try, /*On fail goto*//*Label 31281*/ GIMT_Encode4(2294815),
     /* 2294700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2294703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2294706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2294718 */   GIM_Try, /*On fail goto*//*Label 31282*/ GIMT_Encode4(2294766), // Rule ID 52714 //
     /* 2294723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2294726 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2294729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2294743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294765 */     // GIR_Coverage, 52714,
     /* 2294765 */     GIR_EraseRootFromParent_Done,
     /* 2294766 */   // Label 31282: @2294766
     /* 2294766 */   GIM_Try, /*On fail goto*//*Label 31283*/ GIMT_Encode4(2294814), // Rule ID 52715 //
     /* 2294771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2294774 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2294777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2294791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294813 */     // GIR_Coverage, 52715,
     /* 2294813 */     GIR_EraseRootFromParent_Done,
     /* 2294814 */   // Label 31283: @2294814
     /* 2294814 */   GIM_Reject,
     /* 2294815 */ // Label 31281: @2294815
     /* 2294815 */ GIM_Reject,
     /* 2294816 */ // Label 31234: @2294816
     /* 2294816 */ GIM_Try, /*On fail goto*//*Label 31284*/ GIMT_Encode4(2294936),
     /* 2294821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2294824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2294827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294839 */   GIM_Try, /*On fail goto*//*Label 31285*/ GIMT_Encode4(2294887), // Rule ID 52658 //
     /* 2294844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294847 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2294850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294886 */     // GIR_Coverage, 52658,
     /* 2294886 */     GIR_EraseRootFromParent_Done,
     /* 2294887 */   // Label 31285: @2294887
     /* 2294887 */   GIM_Try, /*On fail goto*//*Label 31286*/ GIMT_Encode4(2294935), // Rule ID 52659 //
     /* 2294892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2294895 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2294895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2294898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2294912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2294930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2294933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294934 */     // GIR_Coverage, 52659,
     /* 2294934 */     GIR_EraseRootFromParent_Done,
     /* 2294935 */   // Label 31286: @2294935
     /* 2294935 */   GIM_Reject,
     /* 2294936 */ // Label 31284: @2294936
     /* 2294936 */ GIM_Reject,
     /* 2294937 */ // Label 31235: @2294937
     /* 2294937 */ GIM_Try, /*On fail goto*//*Label 31287*/ GIMT_Encode4(2295057),
     /* 2294942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2294945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2294948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2294960 */   GIM_Try, /*On fail goto*//*Label 31288*/ GIMT_Encode4(2295008), // Rule ID 52686 //
     /* 2294965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2294968 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2294968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2294971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2294975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2294980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2294982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2294985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2294990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2294994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295007 */     // GIR_Coverage, 52686,
     /* 2295007 */     GIR_EraseRootFromParent_Done,
     /* 2295008 */   // Label 31288: @2295008
     /* 2295008 */   GIM_Try, /*On fail goto*//*Label 31289*/ GIMT_Encode4(2295056), // Rule ID 52687 //
     /* 2295013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295016 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2295019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2295033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295055 */     // GIR_Coverage, 52687,
     /* 2295055 */     GIR_EraseRootFromParent_Done,
     /* 2295056 */   // Label 31289: @2295056
     /* 2295056 */   GIM_Reject,
     /* 2295057 */ // Label 31287: @2295057
     /* 2295057 */ GIM_Reject,
     /* 2295058 */ // Label 31236: @2295058
     /* 2295058 */ GIM_Try, /*On fail goto*//*Label 31290*/ GIMT_Encode4(2295178),
     /* 2295063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2295066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2295069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295081 */   GIM_Try, /*On fail goto*//*Label 31291*/ GIMT_Encode4(2295129), // Rule ID 52702 //
     /* 2295086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295089 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2295092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295128 */     // GIR_Coverage, 52702,
     /* 2295128 */     GIR_EraseRootFromParent_Done,
     /* 2295129 */   // Label 31291: @2295129
     /* 2295129 */   GIM_Try, /*On fail goto*//*Label 31292*/ GIMT_Encode4(2295177), // Rule ID 52703 //
     /* 2295134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295137 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2295140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295176 */     // GIR_Coverage, 52703,
     /* 2295176 */     GIR_EraseRootFromParent_Done,
     /* 2295177 */   // Label 31292: @2295177
     /* 2295177 */   GIM_Reject,
     /* 2295178 */ // Label 31290: @2295178
     /* 2295178 */ GIM_Reject,
     /* 2295179 */ // Label 31237: @2295179
     /* 2295179 */ GIM_Try, /*On fail goto*//*Label 31293*/ GIMT_Encode4(2295299),
     /* 2295184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2295187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2295190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295202 */   GIM_Try, /*On fail goto*//*Label 31294*/ GIMT_Encode4(2295250), // Rule ID 52718 //
     /* 2295207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2295210 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2295213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2295227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295249 */     // GIR_Coverage, 52718,
     /* 2295249 */     GIR_EraseRootFromParent_Done,
     /* 2295250 */   // Label 31294: @2295250
     /* 2295250 */   GIM_Try, /*On fail goto*//*Label 31295*/ GIMT_Encode4(2295298), // Rule ID 52719 //
     /* 2295255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2295258 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2295261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2295275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295297 */     // GIR_Coverage, 52719,
     /* 2295297 */     GIR_EraseRootFromParent_Done,
     /* 2295298 */   // Label 31295: @2295298
     /* 2295298 */   GIM_Reject,
     /* 2295299 */ // Label 31293: @2295299
     /* 2295299 */ GIM_Reject,
     /* 2295300 */ // Label 31238: @2295300
     /* 2295300 */ GIM_Try, /*On fail goto*//*Label 31296*/ GIMT_Encode4(2295420),
     /* 2295305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2295308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2295311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2295323 */   GIM_Try, /*On fail goto*//*Label 31297*/ GIMT_Encode4(2295371), // Rule ID 52674 //
     /* 2295328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295331 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2295334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2295348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295370 */     // GIR_Coverage, 52674,
     /* 2295370 */     GIR_EraseRootFromParent_Done,
     /* 2295371 */   // Label 31297: @2295371
     /* 2295371 */   GIM_Try, /*On fail goto*//*Label 31298*/ GIMT_Encode4(2295419), // Rule ID 52675 //
     /* 2295376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295379 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2295382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2295396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295418 */     // GIR_Coverage, 52675,
     /* 2295418 */     GIR_EraseRootFromParent_Done,
     /* 2295419 */   // Label 31298: @2295419
     /* 2295419 */   GIM_Reject,
     /* 2295420 */ // Label 31296: @2295420
     /* 2295420 */ GIM_Reject,
     /* 2295421 */ // Label 31239: @2295421
     /* 2295421 */ GIM_Try, /*On fail goto*//*Label 31299*/ GIMT_Encode4(2295541),
     /* 2295426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2295429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2295432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295444 */   GIM_Try, /*On fail goto*//*Label 31300*/ GIMT_Encode4(2295492), // Rule ID 52690 //
     /* 2295449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295452 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295491 */     // GIR_Coverage, 52690,
     /* 2295491 */     GIR_EraseRootFromParent_Done,
     /* 2295492 */   // Label 31300: @2295492
     /* 2295492 */   GIM_Try, /*On fail goto*//*Label 31301*/ GIMT_Encode4(2295540), // Rule ID 52691 //
     /* 2295497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295500 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2295503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295539 */     // GIR_Coverage, 52691,
     /* 2295539 */     GIR_EraseRootFromParent_Done,
     /* 2295540 */   // Label 31301: @2295540
     /* 2295540 */   GIM_Reject,
     /* 2295541 */ // Label 31299: @2295541
     /* 2295541 */ GIM_Reject,
     /* 2295542 */ // Label 31240: @2295542
     /* 2295542 */ GIM_Try, /*On fail goto*//*Label 31302*/ GIMT_Encode4(2295662),
     /* 2295547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2295550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2295553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295565 */   GIM_Try, /*On fail goto*//*Label 31303*/ GIMT_Encode4(2295613), // Rule ID 52706 //
     /* 2295570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295573 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2295576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2295590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295612 */     // GIR_Coverage, 52706,
     /* 2295612 */     GIR_EraseRootFromParent_Done,
     /* 2295613 */   // Label 31303: @2295613
     /* 2295613 */   GIM_Try, /*On fail goto*//*Label 31304*/ GIMT_Encode4(2295661), // Rule ID 52707 //
     /* 2295618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295621 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2295624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2295638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2295653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295660 */     // GIR_Coverage, 52707,
     /* 2295660 */     GIR_EraseRootFromParent_Done,
     /* 2295661 */   // Label 31304: @2295661
     /* 2295661 */   GIM_Reject,
     /* 2295662 */ // Label 31302: @2295662
     /* 2295662 */ GIM_Reject,
     /* 2295663 */ // Label 31241: @2295663
     /* 2295663 */ GIM_Try, /*On fail goto*//*Label 31305*/ GIMT_Encode4(2295783),
     /* 2295668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2295671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2295674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295682 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2295686 */   GIM_Try, /*On fail goto*//*Label 31306*/ GIMT_Encode4(2295734), // Rule ID 52678 //
     /* 2295691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295694 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2295697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295733 */     // GIR_Coverage, 52678,
     /* 2295733 */     GIR_EraseRootFromParent_Done,
     /* 2295734 */   // Label 31306: @2295734
     /* 2295734 */   GIM_Try, /*On fail goto*//*Label 31307*/ GIMT_Encode4(2295782), // Rule ID 52679 //
     /* 2295739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295742 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2295745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2295759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295781 */     // GIR_Coverage, 52679,
     /* 2295781 */     GIR_EraseRootFromParent_Done,
     /* 2295782 */   // Label 31307: @2295782
     /* 2295782 */   GIM_Reject,
     /* 2295783 */ // Label 31305: @2295783
     /* 2295783 */ GIM_Reject,
     /* 2295784 */ // Label 31242: @2295784
     /* 2295784 */ GIM_Try, /*On fail goto*//*Label 31308*/ GIMT_Encode4(2295904),
     /* 2295789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2295792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2295795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295807 */   GIM_Try, /*On fail goto*//*Label 31309*/ GIMT_Encode4(2295855), // Rule ID 52694 //
     /* 2295812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295815 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2295818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2295832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295854 */     // GIR_Coverage, 52694,
     /* 2295854 */     GIR_EraseRootFromParent_Done,
     /* 2295855 */   // Label 31309: @2295855
     /* 2295855 */   GIM_Try, /*On fail goto*//*Label 31310*/ GIMT_Encode4(2295903), // Rule ID 52695 //
     /* 2295860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295863 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2295866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2295880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295902 */     // GIR_Coverage, 52695,
     /* 2295902 */     GIR_EraseRootFromParent_Done,
     /* 2295903 */   // Label 31310: @2295903
     /* 2295903 */   GIM_Reject,
     /* 2295904 */ // Label 31308: @2295904
     /* 2295904 */ GIM_Reject,
     /* 2295905 */ // Label 31243: @2295905
     /* 2295905 */ GIM_Try, /*On fail goto*//*Label 31311*/ GIMT_Encode4(2296025),
     /* 2295910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2295913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2295916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2295928 */   GIM_Try, /*On fail goto*//*Label 31312*/ GIMT_Encode4(2295976), // Rule ID 52682 //
     /* 2295933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2295936 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2295936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2295939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2295953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2295958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2295962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2295971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2295974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295975 */     // GIR_Coverage, 52682,
     /* 2295975 */     GIR_EraseRootFromParent_Done,
     /* 2295976 */   // Label 31312: @2295976
     /* 2295976 */   GIM_Try, /*On fail goto*//*Label 31313*/ GIMT_Encode4(2296024), // Rule ID 52683 //
     /* 2295981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2295984 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2295984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2295987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2295991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2295996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2295998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2296001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2296022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296023 */     // GIR_Coverage, 52683,
     /* 2296023 */     GIR_EraseRootFromParent_Done,
     /* 2296024 */   // Label 31313: @2296024
     /* 2296024 */   GIM_Reject,
     /* 2296025 */ // Label 31311: @2296025
     /* 2296025 */ GIM_Reject,
     /* 2296026 */ // Label 31244: @2296026
     /* 2296026 */ GIM_Reject,
     /* 2296027 */ // Label 57: @2296027
     /* 2296027 */ GIM_Try, /*On fail goto*//*Label 31314*/ GIMT_Encode4(2296084),
     /* 2296032 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2296035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2296038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2296041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296053 */   GIM_Try, /*On fail goto*//*Label 31315*/ GIMT_Encode4(2296068), // Rule ID 64580 //
     /* 2296058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2296061 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2296066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296067 */     // GIR_Coverage, 64580,
     /* 2296067 */     GIR_Done,
     /* 2296068 */   // Label 31315: @2296068
     /* 2296068 */   GIM_Try, /*On fail goto*//*Label 31316*/ GIMT_Encode4(2296083), // Rule ID 64581 //
     /* 2296073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2296076 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2296081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296082 */     // GIR_Coverage, 64581,
     /* 2296082 */     GIR_Done,
     /* 2296083 */   // Label 31316: @2296083
     /* 2296083 */   GIM_Reject,
     /* 2296084 */ // Label 31314: @2296084
     /* 2296084 */ GIM_Reject,
     /* 2296085 */ // Label 58: @2296085
     /* 2296085 */ GIM_Try, /*On fail goto*//*Label 31317*/ GIMT_Encode4(2296142),
     /* 2296090 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2296093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2296096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2296099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2296111 */   GIM_Try, /*On fail goto*//*Label 31318*/ GIMT_Encode4(2296126), // Rule ID 64582 //
     /* 2296116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2296119 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2296124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296125 */     // GIR_Coverage, 64582,
     /* 2296125 */     GIR_Done,
     /* 2296126 */   // Label 31318: @2296126
     /* 2296126 */   GIM_Try, /*On fail goto*//*Label 31319*/ GIMT_Encode4(2296141), // Rule ID 64583 //
     /* 2296131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2296134 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2296134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2296139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296140 */     // GIR_Coverage, 64583,
     /* 2296140 */     GIR_Done,
     /* 2296141 */   // Label 31319: @2296141
     /* 2296141 */   GIM_Reject,
     /* 2296142 */ // Label 31317: @2296142
     /* 2296142 */ GIM_Reject,
     /* 2296143 */ // Label 59: @2296143
     /* 2296143 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31338*/ GIMT_Encode4(2298570),
     /* 2296154 */ /*GILLT_s16*//*Label 31320*/ GIMT_Encode4(2296274),
     /* 2296158 */ /*GILLT_s32*//*Label 31321*/ GIMT_Encode4(2296423),
     /* 2296162 */ /*GILLT_s64*//*Label 31322*/ GIMT_Encode4(2296572), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296174 */ /*GILLT_nxv1s16*//*Label 31323*/ GIMT_Encode4(2296755),
     /* 2296178 */ /*GILLT_nxv1s32*//*Label 31324*/ GIMT_Encode4(2296876),
     /* 2296182 */ /*GILLT_nxv1s64*//*Label 31325*/ GIMT_Encode4(2296997), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296194 */ /*GILLT_nxv2s16*//*Label 31326*/ GIMT_Encode4(2297118),
     /* 2296198 */ /*GILLT_nxv2s32*//*Label 31327*/ GIMT_Encode4(2297239),
     /* 2296202 */ /*GILLT_nxv2s64*//*Label 31328*/ GIMT_Encode4(2297360), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296214 */ /*GILLT_nxv4s16*//*Label 31329*/ GIMT_Encode4(2297481),
     /* 2296218 */ /*GILLT_nxv4s32*//*Label 31330*/ GIMT_Encode4(2297602),
     /* 2296222 */ /*GILLT_nxv4s64*//*Label 31331*/ GIMT_Encode4(2297723), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296234 */ /*GILLT_nxv8s16*//*Label 31332*/ GIMT_Encode4(2297844),
     /* 2296238 */ /*GILLT_nxv8s32*//*Label 31333*/ GIMT_Encode4(2297965),
     /* 2296242 */ /*GILLT_nxv8s64*//*Label 31334*/ GIMT_Encode4(2298086), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296254 */ /*GILLT_nxv16s16*//*Label 31335*/ GIMT_Encode4(2298207),
     /* 2296258 */ /*GILLT_nxv16s32*//*Label 31336*/ GIMT_Encode4(2298328), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2296270 */ /*GILLT_nxv32s16*//*Label 31337*/ GIMT_Encode4(2298449),
     /* 2296274 */ // Label 31320: @2296274
     /* 2296274 */ GIM_Try, /*On fail goto*//*Label 31339*/ GIMT_Encode4(2296422),
     /* 2296279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2296282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2296285 */   GIM_Try, /*On fail goto*//*Label 31340*/ GIMT_Encode4(2296319), // Rule ID 1954 //
     /* 2296290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2296293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296305 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2296305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2296308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296318 */     // GIR_Coverage, 1954,
     /* 2296318 */     GIR_EraseRootFromParent_Done,
     /* 2296319 */   // Label 31340: @2296319
     /* 2296319 */   GIM_Try, /*On fail goto*//*Label 31341*/ GIMT_Encode4(2296353), // Rule ID 1955 //
     /* 2296324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2296327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2296339 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2296339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2296342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296352 */     // GIR_Coverage, 1955,
     /* 2296352 */     GIR_EraseRootFromParent_Done,
     /* 2296353 */   // Label 31341: @2296353
     /* 2296353 */   GIM_Try, /*On fail goto*//*Label 31342*/ GIMT_Encode4(2296387), // Rule ID 1958 //
     /* 2296358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2296361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296373 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2296373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2296376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296386 */     // GIR_Coverage, 1958,
     /* 2296386 */     GIR_EraseRootFromParent_Done,
     /* 2296387 */   // Label 31342: @2296387
     /* 2296387 */   GIM_Try, /*On fail goto*//*Label 31343*/ GIMT_Encode4(2296421), // Rule ID 1959 //
     /* 2296392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2296395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2296407 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2296407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2296410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296420 */     // GIR_Coverage, 1959,
     /* 2296420 */     GIR_EraseRootFromParent_Done,
     /* 2296421 */   // Label 31343: @2296421
     /* 2296421 */   GIM_Reject,
     /* 2296422 */ // Label 31339: @2296422
     /* 2296422 */ GIM_Reject,
     /* 2296423 */ // Label 31321: @2296423
     /* 2296423 */ GIM_Try, /*On fail goto*//*Label 31344*/ GIMT_Encode4(2296571),
     /* 2296428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2296431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2296434 */   GIM_Try, /*On fail goto*//*Label 31345*/ GIMT_Encode4(2296468), // Rule ID 1245 //
     /* 2296439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2296442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296454 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2296454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2296457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296467 */     // GIR_Coverage, 1245,
     /* 2296467 */     GIR_EraseRootFromParent_Done,
     /* 2296468 */   // Label 31345: @2296468
     /* 2296468 */   GIM_Try, /*On fail goto*//*Label 31346*/ GIMT_Encode4(2296502), // Rule ID 1246 //
     /* 2296473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2296476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2296488 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2296488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2296491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296501 */     // GIR_Coverage, 1246,
     /* 2296501 */     GIR_EraseRootFromParent_Done,
     /* 2296502 */   // Label 31346: @2296502
     /* 2296502 */   GIM_Try, /*On fail goto*//*Label 31347*/ GIMT_Encode4(2296536), // Rule ID 1249 //
     /* 2296507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2296510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296522 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2296522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2296525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296535 */     // GIR_Coverage, 1249,
     /* 2296535 */     GIR_EraseRootFromParent_Done,
     /* 2296536 */   // Label 31347: @2296536
     /* 2296536 */   GIM_Try, /*On fail goto*//*Label 31348*/ GIMT_Encode4(2296570), // Rule ID 1250 //
     /* 2296541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2296544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2296556 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2296556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2296559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296569 */     // GIR_Coverage, 1250,
     /* 2296569 */     GIR_EraseRootFromParent_Done,
     /* 2296570 */   // Label 31348: @2296570
     /* 2296570 */   GIM_Reject,
     /* 2296571 */ // Label 31344: @2296571
     /* 2296571 */ GIM_Reject,
     /* 2296572 */ // Label 31322: @2296572
     /* 2296572 */ GIM_Try, /*On fail goto*//*Label 31349*/ GIMT_Encode4(2296754),
     /* 2296577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2296580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2296583 */   GIM_Try, /*On fail goto*//*Label 31350*/ GIMT_Encode4(2296617), // Rule ID 1580 //
     /* 2296588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2296591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296603 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2296603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2296606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296616 */     // GIR_Coverage, 1580,
     /* 2296616 */     GIR_EraseRootFromParent_Done,
     /* 2296617 */   // Label 31350: @2296617
     /* 2296617 */   GIM_Try, /*On fail goto*//*Label 31351*/ GIMT_Encode4(2296651), // Rule ID 1581 //
     /* 2296622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2296625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2296637 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2296637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2296640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296650 */     // GIR_Coverage, 1581,
     /* 2296650 */     GIR_EraseRootFromParent_Done,
     /* 2296651 */   // Label 31351: @2296651
     /* 2296651 */   GIM_Try, /*On fail goto*//*Label 31352*/ GIMT_Encode4(2296685), // Rule ID 1584 //
     /* 2296656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2296659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296671 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2296671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2296674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296684 */     // GIR_Coverage, 1584,
     /* 2296684 */     GIR_EraseRootFromParent_Done,
     /* 2296685 */   // Label 31352: @2296685
     /* 2296685 */   GIM_Try, /*On fail goto*//*Label 31353*/ GIMT_Encode4(2296719), // Rule ID 1585 //
     /* 2296690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2296693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2296705 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2296705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2296708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296718 */     // GIR_Coverage, 1585,
     /* 2296718 */     GIR_EraseRootFromParent_Done,
     /* 2296719 */   // Label 31353: @2296719
     /* 2296719 */   GIM_Try, /*On fail goto*//*Label 31354*/ GIMT_Encode4(2296753), // Rule ID 1587 //
     /* 2296724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2296727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2296739 */     // (fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2296739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2296742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296752 */     // GIR_Coverage, 1587,
     /* 2296752 */     GIR_EraseRootFromParent_Done,
     /* 2296753 */   // Label 31354: @2296753
     /* 2296753 */   GIM_Reject,
     /* 2296754 */ // Label 31349: @2296754
     /* 2296754 */ GIM_Reject,
     /* 2296755 */ // Label 31323: @2296755
     /* 2296755 */ GIM_Try, /*On fail goto*//*Label 31355*/ GIMT_Encode4(2296875),
     /* 2296760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2296763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2296766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296778 */   GIM_Try, /*On fail goto*//*Label 31356*/ GIMT_Encode4(2296826), // Rule ID 45758 //
     /* 2296783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2296786 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2296789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2296803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296825 */     // GIR_Coverage, 45758,
     /* 2296825 */     GIR_EraseRootFromParent_Done,
     /* 2296826 */   // Label 31356: @2296826
     /* 2296826 */   GIM_Try, /*On fail goto*//*Label 31357*/ GIMT_Encode4(2296874), // Rule ID 45759 //
     /* 2296831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2296834 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2296837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2296851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296873 */     // GIR_Coverage, 45759,
     /* 2296873 */     GIR_EraseRootFromParent_Done,
     /* 2296874 */   // Label 31357: @2296874
     /* 2296874 */   GIM_Reject,
     /* 2296875 */ // Label 31355: @2296875
     /* 2296875 */ GIM_Reject,
     /* 2296876 */ // Label 31324: @2296876
     /* 2296876 */ GIM_Try, /*On fail goto*//*Label 31358*/ GIMT_Encode4(2296996),
     /* 2296881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2296884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2296887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296899 */   GIM_Try, /*On fail goto*//*Label 31359*/ GIMT_Encode4(2296947), // Rule ID 53298 //
     /* 2296904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2296907 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2296907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2296910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2296924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296946 */     // GIR_Coverage, 53298,
     /* 2296946 */     GIR_EraseRootFromParent_Done,
     /* 2296947 */   // Label 31359: @2296947
     /* 2296947 */   GIM_Try, /*On fail goto*//*Label 31360*/ GIMT_Encode4(2296995), // Rule ID 53299 //
     /* 2296952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2296955 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2296955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2296958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2296962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2296967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2296969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2296972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2296977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2296981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2296993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296994 */     // GIR_Coverage, 53299,
     /* 2296994 */     GIR_EraseRootFromParent_Done,
     /* 2296995 */   // Label 31360: @2296995
     /* 2296995 */   GIM_Reject,
     /* 2296996 */ // Label 31358: @2296996
     /* 2296996 */ GIM_Reject,
     /* 2296997 */ // Label 31325: @2296997
     /* 2296997 */ GIM_Try, /*On fail goto*//*Label 31361*/ GIMT_Encode4(2297117),
     /* 2297002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2297005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2297008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297020 */   GIM_Try, /*On fail goto*//*Label 31362*/ GIMT_Encode4(2297068), // Rule ID 53334 //
     /* 2297025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297028 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2297031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2297045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297067 */     // GIR_Coverage, 53334,
     /* 2297067 */     GIR_EraseRootFromParent_Done,
     /* 2297068 */   // Label 31362: @2297068
     /* 2297068 */   GIM_Try, /*On fail goto*//*Label 31363*/ GIMT_Encode4(2297116), // Rule ID 53335 //
     /* 2297073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297076 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2297079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2297093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297115 */     // GIR_Coverage, 53335,
     /* 2297115 */     GIR_EraseRootFromParent_Done,
     /* 2297116 */   // Label 31363: @2297116
     /* 2297116 */   GIM_Reject,
     /* 2297117 */ // Label 31361: @2297117
     /* 2297117 */ GIM_Reject,
     /* 2297118 */ // Label 31326: @2297118
     /* 2297118 */ GIM_Try, /*On fail goto*//*Label 31364*/ GIMT_Encode4(2297238),
     /* 2297123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2297126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2297129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297137 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297141 */   GIM_Try, /*On fail goto*//*Label 31365*/ GIMT_Encode4(2297189), // Rule ID 53286 //
     /* 2297146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297149 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2297152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2297166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297188 */     // GIR_Coverage, 53286,
     /* 2297188 */     GIR_EraseRootFromParent_Done,
     /* 2297189 */   // Label 31365: @2297189
     /* 2297189 */   GIM_Try, /*On fail goto*//*Label 31366*/ GIMT_Encode4(2297237), // Rule ID 53287 //
     /* 2297194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297197 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2297200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2297214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297236 */     // GIR_Coverage, 53287,
     /* 2297236 */     GIR_EraseRootFromParent_Done,
     /* 2297237 */   // Label 31366: @2297237
     /* 2297237 */   GIM_Reject,
     /* 2297238 */ // Label 31364: @2297238
     /* 2297238 */ GIM_Reject,
     /* 2297239 */ // Label 31327: @2297239
     /* 2297239 */ GIM_Try, /*On fail goto*//*Label 31367*/ GIMT_Encode4(2297359),
     /* 2297244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2297247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2297250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297262 */   GIM_Try, /*On fail goto*//*Label 31368*/ GIMT_Encode4(2297310), // Rule ID 53322 //
     /* 2297267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297270 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2297273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2297287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297309 */     // GIR_Coverage, 53322,
     /* 2297309 */     GIR_EraseRootFromParent_Done,
     /* 2297310 */   // Label 31368: @2297310
     /* 2297310 */   GIM_Try, /*On fail goto*//*Label 31369*/ GIMT_Encode4(2297358), // Rule ID 53323 //
     /* 2297315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297318 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2297321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2297335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297357 */     // GIR_Coverage, 53323,
     /* 2297357 */     GIR_EraseRootFromParent_Done,
     /* 2297358 */   // Label 31369: @2297358
     /* 2297358 */   GIM_Reject,
     /* 2297359 */ // Label 31367: @2297359
     /* 2297359 */ GIM_Reject,
     /* 2297360 */ // Label 31328: @2297360
     /* 2297360 */ GIM_Try, /*On fail goto*//*Label 31370*/ GIMT_Encode4(2297480),
     /* 2297365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2297371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297383 */   GIM_Try, /*On fail goto*//*Label 31371*/ GIMT_Encode4(2297431), // Rule ID 53418 //
     /* 2297388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297391 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2297394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2297408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297430 */     // GIR_Coverage, 53418,
     /* 2297430 */     GIR_EraseRootFromParent_Done,
     /* 2297431 */   // Label 31371: @2297431
     /* 2297431 */   GIM_Try, /*On fail goto*//*Label 31372*/ GIMT_Encode4(2297479), // Rule ID 53419 //
     /* 2297436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297439 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2297442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2297456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297478 */     // GIR_Coverage, 53419,
     /* 2297478 */     GIR_EraseRootFromParent_Done,
     /* 2297479 */   // Label 31372: @2297479
     /* 2297479 */   GIM_Reject,
     /* 2297480 */ // Label 31370: @2297480
     /* 2297480 */ GIM_Reject,
     /* 2297481 */ // Label 31329: @2297481
     /* 2297481 */ GIM_Try, /*On fail goto*//*Label 31373*/ GIMT_Encode4(2297601),
     /* 2297486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2297492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297504 */   GIM_Try, /*On fail goto*//*Label 31374*/ GIMT_Encode4(2297552), // Rule ID 53310 //
     /* 2297509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297512 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2297529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297551 */     // GIR_Coverage, 53310,
     /* 2297551 */     GIR_EraseRootFromParent_Done,
     /* 2297552 */   // Label 31374: @2297552
     /* 2297552 */   GIM_Try, /*On fail goto*//*Label 31375*/ GIMT_Encode4(2297600), // Rule ID 53311 //
     /* 2297557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297560 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2297563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2297577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297599 */     // GIR_Coverage, 53311,
     /* 2297599 */     GIR_EraseRootFromParent_Done,
     /* 2297600 */   // Label 31375: @2297600
     /* 2297600 */   GIM_Reject,
     /* 2297601 */ // Label 31373: @2297601
     /* 2297601 */ GIM_Reject,
     /* 2297602 */ // Label 31330: @2297602
     /* 2297602 */ GIM_Try, /*On fail goto*//*Label 31376*/ GIMT_Encode4(2297722),
     /* 2297607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2297610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2297613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297625 */   GIM_Try, /*On fail goto*//*Label 31377*/ GIMT_Encode4(2297673), // Rule ID 53382 //
     /* 2297630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297633 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2297636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2297650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297672 */     // GIR_Coverage, 53382,
     /* 2297672 */     GIR_EraseRootFromParent_Done,
     /* 2297673 */   // Label 31377: @2297673
     /* 2297673 */   GIM_Try, /*On fail goto*//*Label 31378*/ GIMT_Encode4(2297721), // Rule ID 53383 //
     /* 2297678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2297681 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2297684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2297698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2297716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297720 */     // GIR_Coverage, 53383,
     /* 2297720 */     GIR_EraseRootFromParent_Done,
     /* 2297721 */   // Label 31378: @2297721
     /* 2297721 */   GIM_Reject,
     /* 2297722 */ // Label 31376: @2297722
     /* 2297722 */ GIM_Reject,
     /* 2297723 */ // Label 31331: @2297723
     /* 2297723 */ GIM_Try, /*On fail goto*//*Label 31379*/ GIMT_Encode4(2297843),
     /* 2297728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2297731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2297734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297746 */   GIM_Try, /*On fail goto*//*Label 31380*/ GIMT_Encode4(2297794), // Rule ID 53430 //
     /* 2297751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297754 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2297757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2297771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297793 */     // GIR_Coverage, 53430,
     /* 2297793 */     GIR_EraseRootFromParent_Done,
     /* 2297794 */   // Label 31380: @2297794
     /* 2297794 */   GIM_Try, /*On fail goto*//*Label 31381*/ GIMT_Encode4(2297842), // Rule ID 53431 //
     /* 2297799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297802 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2297805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2297819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297841 */     // GIR_Coverage, 53431,
     /* 2297841 */     GIR_EraseRootFromParent_Done,
     /* 2297842 */   // Label 31381: @2297842
     /* 2297842 */   GIM_Reject,
     /* 2297843 */ // Label 31379: @2297843
     /* 2297843 */ GIM_Reject,
     /* 2297844 */ // Label 31332: @2297844
     /* 2297844 */ GIM_Try, /*On fail goto*//*Label 31382*/ GIMT_Encode4(2297964),
     /* 2297849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2297852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2297855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297867 */   GIM_Try, /*On fail goto*//*Label 31383*/ GIMT_Encode4(2297915), // Rule ID 53346 //
     /* 2297872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297875 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2297878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2297892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297914 */     // GIR_Coverage, 53346,
     /* 2297914 */     GIR_EraseRootFromParent_Done,
     /* 2297915 */   // Label 31383: @2297915
     /* 2297915 */   GIM_Try, /*On fail goto*//*Label 31384*/ GIMT_Encode4(2297963), // Rule ID 53347 //
     /* 2297920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297923 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2297923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2297926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2297930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2297935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2297937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2297940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2297945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2297949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2297961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297962 */     // GIR_Coverage, 53347,
     /* 2297962 */     GIR_EraseRootFromParent_Done,
     /* 2297963 */   // Label 31384: @2297963
     /* 2297963 */   GIM_Reject,
     /* 2297964 */ // Label 31382: @2297964
     /* 2297964 */ GIM_Reject,
     /* 2297965 */ // Label 31333: @2297965
     /* 2297965 */ GIM_Try, /*On fail goto*//*Label 31385*/ GIMT_Encode4(2298085),
     /* 2297970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2297973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2297976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2297988 */   GIM_Try, /*On fail goto*//*Label 31386*/ GIMT_Encode4(2298036), // Rule ID 53394 //
     /* 2297993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2297996 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2297996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2297999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2298013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298035 */     // GIR_Coverage, 53394,
     /* 2298035 */     GIR_EraseRootFromParent_Done,
     /* 2298036 */   // Label 31386: @2298036
     /* 2298036 */   GIM_Try, /*On fail goto*//*Label 31387*/ GIMT_Encode4(2298084), // Rule ID 53395 //
     /* 2298041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298044 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2298047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2298061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298083 */     // GIR_Coverage, 53395,
     /* 2298083 */     GIR_EraseRootFromParent_Done,
     /* 2298084 */   // Label 31387: @2298084
     /* 2298084 */   GIM_Reject,
     /* 2298085 */ // Label 31385: @2298085
     /* 2298085 */ GIM_Reject,
     /* 2298086 */ // Label 31334: @2298086
     /* 2298086 */ GIM_Try, /*On fail goto*//*Label 31388*/ GIMT_Encode4(2298206),
     /* 2298091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2298094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2298097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298109 */   GIM_Try, /*On fail goto*//*Label 31389*/ GIMT_Encode4(2298157), // Rule ID 53442 //
     /* 2298114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2298117 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2298120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2298134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298156 */     // GIR_Coverage, 53442,
     /* 2298156 */     GIR_EraseRootFromParent_Done,
     /* 2298157 */   // Label 31389: @2298157
     /* 2298157 */   GIM_Try, /*On fail goto*//*Label 31390*/ GIMT_Encode4(2298205), // Rule ID 53443 //
     /* 2298162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2298165 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2298168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2298182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2298200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298204 */     // GIR_Coverage, 53443,
     /* 2298204 */     GIR_EraseRootFromParent_Done,
     /* 2298205 */   // Label 31390: @2298205
     /* 2298205 */   GIM_Reject,
     /* 2298206 */ // Label 31388: @2298206
     /* 2298206 */ GIM_Reject,
     /* 2298207 */ // Label 31335: @2298207
     /* 2298207 */ GIM_Try, /*On fail goto*//*Label 31391*/ GIMT_Encode4(2298327),
     /* 2298212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2298215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2298218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2298230 */   GIM_Try, /*On fail goto*//*Label 31392*/ GIMT_Encode4(2298278), // Rule ID 53358 //
     /* 2298235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298238 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2298241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2298255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298277 */     // GIR_Coverage, 53358,
     /* 2298277 */     GIR_EraseRootFromParent_Done,
     /* 2298278 */   // Label 31392: @2298278
     /* 2298278 */   GIM_Try, /*On fail goto*//*Label 31393*/ GIMT_Encode4(2298326), // Rule ID 53359 //
     /* 2298283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298286 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2298289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2298303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298325 */     // GIR_Coverage, 53359,
     /* 2298325 */     GIR_EraseRootFromParent_Done,
     /* 2298326 */   // Label 31393: @2298326
     /* 2298326 */   GIM_Reject,
     /* 2298327 */ // Label 31391: @2298327
     /* 2298327 */ GIM_Reject,
     /* 2298328 */ // Label 31336: @2298328
     /* 2298328 */ GIM_Try, /*On fail goto*//*Label 31394*/ GIMT_Encode4(2298448),
     /* 2298333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2298336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2298339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298351 */   GIM_Try, /*On fail goto*//*Label 31395*/ GIMT_Encode4(2298399), // Rule ID 53406 //
     /* 2298356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298359 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2298376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298398 */     // GIR_Coverage, 53406,
     /* 2298398 */     GIR_EraseRootFromParent_Done,
     /* 2298399 */   // Label 31395: @2298399
     /* 2298399 */   GIM_Try, /*On fail goto*//*Label 31396*/ GIMT_Encode4(2298447), // Rule ID 53407 //
     /* 2298404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298407 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2298410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2298424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298446 */     // GIR_Coverage, 53407,
     /* 2298446 */     GIR_EraseRootFromParent_Done,
     /* 2298447 */   // Label 31396: @2298447
     /* 2298447 */   GIM_Reject,
     /* 2298448 */ // Label 31394: @2298448
     /* 2298448 */ GIM_Reject,
     /* 2298449 */ // Label 31337: @2298449
     /* 2298449 */ GIM_Try, /*On fail goto*//*Label 31397*/ GIMT_Encode4(2298569),
     /* 2298454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2298457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2298460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2298472 */   GIM_Try, /*On fail goto*//*Label 31398*/ GIMT_Encode4(2298520), // Rule ID 53370 //
     /* 2298477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298480 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2298480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2298483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2298497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298519 */     // GIR_Coverage, 53370,
     /* 2298519 */     GIR_EraseRootFromParent_Done,
     /* 2298520 */   // Label 31398: @2298520
     /* 2298520 */   GIM_Try, /*On fail goto*//*Label 31399*/ GIMT_Encode4(2298568), // Rule ID 53371 //
     /* 2298525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298528 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2298528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2298531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2298535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2298540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2298542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2298545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2298550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2298566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298567 */     // GIR_Coverage, 53371,
     /* 2298567 */     GIR_EraseRootFromParent_Done,
     /* 2298568 */   // Label 31399: @2298568
     /* 2298568 */   GIM_Reject,
     /* 2298569 */ // Label 31397: @2298569
     /* 2298569 */ GIM_Reject,
     /* 2298570 */ // Label 31338: @2298570
     /* 2298570 */ GIM_Reject,
     /* 2298571 */ // Label 60: @2298571
     /* 2298571 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31418*/ GIMT_Encode4(2300998),
     /* 2298582 */ /*GILLT_s16*//*Label 31400*/ GIMT_Encode4(2298702),
     /* 2298586 */ /*GILLT_s32*//*Label 31401*/ GIMT_Encode4(2298851),
     /* 2298590 */ /*GILLT_s64*//*Label 31402*/ GIMT_Encode4(2299000), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298602 */ /*GILLT_nxv1s16*//*Label 31403*/ GIMT_Encode4(2299183),
     /* 2298606 */ /*GILLT_nxv1s32*//*Label 31404*/ GIMT_Encode4(2299304),
     /* 2298610 */ /*GILLT_nxv1s64*//*Label 31405*/ GIMT_Encode4(2299425), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298622 */ /*GILLT_nxv2s16*//*Label 31406*/ GIMT_Encode4(2299546),
     /* 2298626 */ /*GILLT_nxv2s32*//*Label 31407*/ GIMT_Encode4(2299667),
     /* 2298630 */ /*GILLT_nxv2s64*//*Label 31408*/ GIMT_Encode4(2299788), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298642 */ /*GILLT_nxv4s16*//*Label 31409*/ GIMT_Encode4(2299909),
     /* 2298646 */ /*GILLT_nxv4s32*//*Label 31410*/ GIMT_Encode4(2300030),
     /* 2298650 */ /*GILLT_nxv4s64*//*Label 31411*/ GIMT_Encode4(2300151), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298662 */ /*GILLT_nxv8s16*//*Label 31412*/ GIMT_Encode4(2300272),
     /* 2298666 */ /*GILLT_nxv8s32*//*Label 31413*/ GIMT_Encode4(2300393),
     /* 2298670 */ /*GILLT_nxv8s64*//*Label 31414*/ GIMT_Encode4(2300514), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298682 */ /*GILLT_nxv16s16*//*Label 31415*/ GIMT_Encode4(2300635),
     /* 2298686 */ /*GILLT_nxv16s32*//*Label 31416*/ GIMT_Encode4(2300756), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2298698 */ /*GILLT_nxv32s16*//*Label 31417*/ GIMT_Encode4(2300877),
     /* 2298702 */ // Label 31400: @2298702
     /* 2298702 */ GIM_Try, /*On fail goto*//*Label 31419*/ GIMT_Encode4(2298850),
     /* 2298707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2298710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2298713 */   GIM_Try, /*On fail goto*//*Label 31420*/ GIMT_Encode4(2298747), // Rule ID 1962 //
     /* 2298718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2298721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298733 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2298733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2298736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298746 */     // GIR_Coverage, 1962,
     /* 2298746 */     GIR_EraseRootFromParent_Done,
     /* 2298747 */   // Label 31420: @2298747
     /* 2298747 */   GIM_Try, /*On fail goto*//*Label 31421*/ GIMT_Encode4(2298781), // Rule ID 1963 //
     /* 2298752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2298755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2298767 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2298767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2298770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298780 */     // GIR_Coverage, 1963,
     /* 2298780 */     GIR_EraseRootFromParent_Done,
     /* 2298781 */   // Label 31421: @2298781
     /* 2298781 */   GIM_Try, /*On fail goto*//*Label 31422*/ GIMT_Encode4(2298815), // Rule ID 1966 //
     /* 2298786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2298789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298801 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2298801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2298804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298814 */     // GIR_Coverage, 1966,
     /* 2298814 */     GIR_EraseRootFromParent_Done,
     /* 2298815 */   // Label 31422: @2298815
     /* 2298815 */   GIM_Try, /*On fail goto*//*Label 31423*/ GIMT_Encode4(2298849), // Rule ID 1967 //
     /* 2298820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2298823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2298835 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2298835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2298838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298848 */     // GIR_Coverage, 1967,
     /* 2298848 */     GIR_EraseRootFromParent_Done,
     /* 2298849 */   // Label 31423: @2298849
     /* 2298849 */   GIM_Reject,
     /* 2298850 */ // Label 31419: @2298850
     /* 2298850 */ GIM_Reject,
     /* 2298851 */ // Label 31401: @2298851
     /* 2298851 */ GIM_Try, /*On fail goto*//*Label 31424*/ GIMT_Encode4(2298999),
     /* 2298856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2298859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2298862 */   GIM_Try, /*On fail goto*//*Label 31425*/ GIMT_Encode4(2298896), // Rule ID 1253 //
     /* 2298867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2298870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298882 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2298882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2298885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298895 */     // GIR_Coverage, 1253,
     /* 2298895 */     GIR_EraseRootFromParent_Done,
     /* 2298896 */   // Label 31425: @2298896
     /* 2298896 */   GIM_Try, /*On fail goto*//*Label 31426*/ GIMT_Encode4(2298930), // Rule ID 1254 //
     /* 2298901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2298904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2298916 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2298916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2298919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298929 */     // GIR_Coverage, 1254,
     /* 2298929 */     GIR_EraseRootFromParent_Done,
     /* 2298930 */   // Label 31426: @2298930
     /* 2298930 */   GIM_Try, /*On fail goto*//*Label 31427*/ GIMT_Encode4(2298964), // Rule ID 1257 //
     /* 2298935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2298938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298950 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2298950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2298953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298963 */     // GIR_Coverage, 1257,
     /* 2298963 */     GIR_EraseRootFromParent_Done,
     /* 2298964 */   // Label 31427: @2298964
     /* 2298964 */   GIM_Try, /*On fail goto*//*Label 31428*/ GIMT_Encode4(2298998), // Rule ID 1258 //
     /* 2298969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2298972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2298984 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2298984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2298987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2298993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298997 */     // GIR_Coverage, 1258,
     /* 2298997 */     GIR_EraseRootFromParent_Done,
     /* 2298998 */   // Label 31428: @2298998
     /* 2298998 */   GIM_Reject,
     /* 2298999 */ // Label 31424: @2298999
     /* 2298999 */ GIM_Reject,
     /* 2299000 */ // Label 31402: @2299000
     /* 2299000 */ GIM_Try, /*On fail goto*//*Label 31429*/ GIMT_Encode4(2299182),
     /* 2299005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2299008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2299011 */   GIM_Try, /*On fail goto*//*Label 31430*/ GIMT_Encode4(2299045), // Rule ID 1590 //
     /* 2299016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2299019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299031 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2299031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2299034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299044 */     // GIR_Coverage, 1590,
     /* 2299044 */     GIR_EraseRootFromParent_Done,
     /* 2299045 */   // Label 31430: @2299045
     /* 2299045 */   GIM_Try, /*On fail goto*//*Label 31431*/ GIMT_Encode4(2299079), // Rule ID 1591 //
     /* 2299050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2299053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2299065 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2299065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2299068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299078 */     // GIR_Coverage, 1591,
     /* 2299078 */     GIR_EraseRootFromParent_Done,
     /* 2299079 */   // Label 31431: @2299079
     /* 2299079 */   GIM_Try, /*On fail goto*//*Label 31432*/ GIMT_Encode4(2299113), // Rule ID 1594 //
     /* 2299084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2299087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299099 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2299099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2299102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299112 */     // GIR_Coverage, 1594,
     /* 2299112 */     GIR_EraseRootFromParent_Done,
     /* 2299113 */   // Label 31432: @2299113
     /* 2299113 */   GIM_Try, /*On fail goto*//*Label 31433*/ GIMT_Encode4(2299147), // Rule ID 1595 //
     /* 2299118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2299121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2299133 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2299133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2299136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299146 */     // GIR_Coverage, 1595,
     /* 2299146 */     GIR_EraseRootFromParent_Done,
     /* 2299147 */   // Label 31433: @2299147
     /* 2299147 */   GIM_Try, /*On fail goto*//*Label 31434*/ GIMT_Encode4(2299181), // Rule ID 1597 //
     /* 2299152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2299155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2299167 */     // (fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2299167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2299170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299180 */     // GIR_Coverage, 1597,
     /* 2299180 */     GIR_EraseRootFromParent_Done,
     /* 2299181 */   // Label 31434: @2299181
     /* 2299181 */   GIM_Reject,
     /* 2299182 */ // Label 31429: @2299182
     /* 2299182 */ GIM_Reject,
     /* 2299183 */ // Label 31403: @2299183
     /* 2299183 */ GIM_Try, /*On fail goto*//*Label 31435*/ GIMT_Encode4(2299303),
     /* 2299188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2299191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2299194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299206 */   GIM_Try, /*On fail goto*//*Label 31436*/ GIMT_Encode4(2299254), // Rule ID 53454 //
     /* 2299211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299214 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2299231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299253 */     // GIR_Coverage, 53454,
     /* 2299253 */     GIR_EraseRootFromParent_Done,
     /* 2299254 */   // Label 31436: @2299254
     /* 2299254 */   GIM_Try, /*On fail goto*//*Label 31437*/ GIMT_Encode4(2299302), // Rule ID 53455 //
     /* 2299259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299262 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2299265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2299279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299301 */     // GIR_Coverage, 53455,
     /* 2299301 */     GIR_EraseRootFromParent_Done,
     /* 2299302 */   // Label 31437: @2299302
     /* 2299302 */   GIM_Reject,
     /* 2299303 */ // Label 31435: @2299303
     /* 2299303 */ GIM_Reject,
     /* 2299304 */ // Label 31404: @2299304
     /* 2299304 */ GIM_Try, /*On fail goto*//*Label 31438*/ GIMT_Encode4(2299424),
     /* 2299309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2299312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2299315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299327 */   GIM_Try, /*On fail goto*//*Label 31439*/ GIMT_Encode4(2299375), // Rule ID 53478 //
     /* 2299332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299335 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2299352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299374 */     // GIR_Coverage, 53478,
     /* 2299374 */     GIR_EraseRootFromParent_Done,
     /* 2299375 */   // Label 31439: @2299375
     /* 2299375 */   GIM_Try, /*On fail goto*//*Label 31440*/ GIMT_Encode4(2299423), // Rule ID 53479 //
     /* 2299380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299383 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2299386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2299400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299422 */     // GIR_Coverage, 53479,
     /* 2299422 */     GIR_EraseRootFromParent_Done,
     /* 2299423 */   // Label 31440: @2299423
     /* 2299423 */   GIM_Reject,
     /* 2299424 */ // Label 31438: @2299424
     /* 2299424 */ GIM_Reject,
     /* 2299425 */ // Label 31405: @2299425
     /* 2299425 */ GIM_Try, /*On fail goto*//*Label 31441*/ GIMT_Encode4(2299545),
     /* 2299430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2299433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2299436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299448 */   GIM_Try, /*On fail goto*//*Label 31442*/ GIMT_Encode4(2299496), // Rule ID 53514 //
     /* 2299453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299456 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2299473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299495 */     // GIR_Coverage, 53514,
     /* 2299495 */     GIR_EraseRootFromParent_Done,
     /* 2299496 */   // Label 31442: @2299496
     /* 2299496 */   GIM_Try, /*On fail goto*//*Label 31443*/ GIMT_Encode4(2299544), // Rule ID 53515 //
     /* 2299501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299504 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2299507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2299521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299543 */     // GIR_Coverage, 53515,
     /* 2299543 */     GIR_EraseRootFromParent_Done,
     /* 2299544 */   // Label 31443: @2299544
     /* 2299544 */   GIM_Reject,
     /* 2299545 */ // Label 31441: @2299545
     /* 2299545 */ GIM_Reject,
     /* 2299546 */ // Label 31406: @2299546
     /* 2299546 */ GIM_Try, /*On fail goto*//*Label 31444*/ GIMT_Encode4(2299666),
     /* 2299551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2299554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2299557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299569 */   GIM_Try, /*On fail goto*//*Label 31445*/ GIMT_Encode4(2299617), // Rule ID 53466 //
     /* 2299574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299577 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2299580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2299594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299616 */     // GIR_Coverage, 53466,
     /* 2299616 */     GIR_EraseRootFromParent_Done,
     /* 2299617 */   // Label 31445: @2299617
     /* 2299617 */   GIM_Try, /*On fail goto*//*Label 31446*/ GIMT_Encode4(2299665), // Rule ID 53467 //
     /* 2299622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299625 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2299628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2299642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299664 */     // GIR_Coverage, 53467,
     /* 2299664 */     GIR_EraseRootFromParent_Done,
     /* 2299665 */   // Label 31446: @2299665
     /* 2299665 */   GIM_Reject,
     /* 2299666 */ // Label 31444: @2299666
     /* 2299666 */ GIM_Reject,
     /* 2299667 */ // Label 31407: @2299667
     /* 2299667 */ GIM_Try, /*On fail goto*//*Label 31447*/ GIMT_Encode4(2299787),
     /* 2299672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2299675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2299678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299690 */   GIM_Try, /*On fail goto*//*Label 31448*/ GIMT_Encode4(2299738), // Rule ID 53502 //
     /* 2299695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299698 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2299701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2299715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299737 */     // GIR_Coverage, 53502,
     /* 2299737 */     GIR_EraseRootFromParent_Done,
     /* 2299738 */   // Label 31448: @2299738
     /* 2299738 */   GIM_Try, /*On fail goto*//*Label 31449*/ GIMT_Encode4(2299786), // Rule ID 53503 //
     /* 2299743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299746 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2299749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2299763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299785 */     // GIR_Coverage, 53503,
     /* 2299785 */     GIR_EraseRootFromParent_Done,
     /* 2299786 */   // Label 31449: @2299786
     /* 2299786 */   GIM_Reject,
     /* 2299787 */ // Label 31447: @2299787
     /* 2299787 */ GIM_Reject,
     /* 2299788 */ // Label 31408: @2299788
     /* 2299788 */ GIM_Try, /*On fail goto*//*Label 31450*/ GIMT_Encode4(2299908),
     /* 2299793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2299796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2299799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299811 */   GIM_Try, /*On fail goto*//*Label 31451*/ GIMT_Encode4(2299859), // Rule ID 53598 //
     /* 2299816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299819 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2299822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2299836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299858 */     // GIR_Coverage, 53598,
     /* 2299858 */     GIR_EraseRootFromParent_Done,
     /* 2299859 */   // Label 31451: @2299859
     /* 2299859 */   GIM_Try, /*On fail goto*//*Label 31452*/ GIMT_Encode4(2299907), // Rule ID 53599 //
     /* 2299864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299867 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2299870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299879 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2299884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299906 */     // GIR_Coverage, 53599,
     /* 2299906 */     GIR_EraseRootFromParent_Done,
     /* 2299907 */   // Label 31452: @2299907
     /* 2299907 */   GIM_Reject,
     /* 2299908 */ // Label 31450: @2299908
     /* 2299908 */ GIM_Reject,
     /* 2299909 */ // Label 31409: @2299909
     /* 2299909 */ GIM_Try, /*On fail goto*//*Label 31453*/ GIMT_Encode4(2300029),
     /* 2299914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2299917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2299920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2299932 */   GIM_Try, /*On fail goto*//*Label 31454*/ GIMT_Encode4(2299980), // Rule ID 53490 //
     /* 2299937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2299940 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2299940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2299943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2299952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2299954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2299957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2299962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2299966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2299975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2299978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299979 */     // GIR_Coverage, 53490,
     /* 2299979 */     GIR_EraseRootFromParent_Done,
     /* 2299980 */   // Label 31454: @2299980
     /* 2299980 */   GIM_Try, /*On fail goto*//*Label 31455*/ GIMT_Encode4(2300028), // Rule ID 53491 //
     /* 2299985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2299988 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2299988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2299991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2299995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2300005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300027 */     // GIR_Coverage, 53491,
     /* 2300027 */     GIR_EraseRootFromParent_Done,
     /* 2300028 */   // Label 31455: @2300028
     /* 2300028 */   GIM_Reject,
     /* 2300029 */ // Label 31453: @2300029
     /* 2300029 */ GIM_Reject,
     /* 2300030 */ // Label 31410: @2300030
     /* 2300030 */ GIM_Try, /*On fail goto*//*Label 31456*/ GIMT_Encode4(2300150),
     /* 2300035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2300038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2300041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300053 */   GIM_Try, /*On fail goto*//*Label 31457*/ GIMT_Encode4(2300101), // Rule ID 53562 //
     /* 2300058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300061 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2300078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300100 */     // GIR_Coverage, 53562,
     /* 2300100 */     GIR_EraseRootFromParent_Done,
     /* 2300101 */   // Label 31457: @2300101
     /* 2300101 */   GIM_Try, /*On fail goto*//*Label 31458*/ GIMT_Encode4(2300149), // Rule ID 53563 //
     /* 2300106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300109 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2300112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2300126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300148 */     // GIR_Coverage, 53563,
     /* 2300148 */     GIR_EraseRootFromParent_Done,
     /* 2300149 */   // Label 31458: @2300149
     /* 2300149 */   GIM_Reject,
     /* 2300150 */ // Label 31456: @2300150
     /* 2300150 */ GIM_Reject,
     /* 2300151 */ // Label 31411: @2300151
     /* 2300151 */ GIM_Try, /*On fail goto*//*Label 31459*/ GIMT_Encode4(2300271),
     /* 2300156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2300159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2300162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300174 */   GIM_Try, /*On fail goto*//*Label 31460*/ GIMT_Encode4(2300222), // Rule ID 53610 //
     /* 2300179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2300182 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2300199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300221 */     // GIR_Coverage, 53610,
     /* 2300221 */     GIR_EraseRootFromParent_Done,
     /* 2300222 */   // Label 31460: @2300222
     /* 2300222 */   GIM_Try, /*On fail goto*//*Label 31461*/ GIMT_Encode4(2300270), // Rule ID 53611 //
     /* 2300227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2300230 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2300233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2300247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300269 */     // GIR_Coverage, 53611,
     /* 2300269 */     GIR_EraseRootFromParent_Done,
     /* 2300270 */   // Label 31461: @2300270
     /* 2300270 */   GIM_Reject,
     /* 2300271 */ // Label 31459: @2300271
     /* 2300271 */ GIM_Reject,
     /* 2300272 */ // Label 31412: @2300272
     /* 2300272 */ GIM_Try, /*On fail goto*//*Label 31462*/ GIMT_Encode4(2300392),
     /* 2300277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2300283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300295 */   GIM_Try, /*On fail goto*//*Label 31463*/ GIMT_Encode4(2300343), // Rule ID 53526 //
     /* 2300300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300303 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2300306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2300320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300342 */     // GIR_Coverage, 53526,
     /* 2300342 */     GIR_EraseRootFromParent_Done,
     /* 2300343 */   // Label 31463: @2300343
     /* 2300343 */   GIM_Try, /*On fail goto*//*Label 31464*/ GIMT_Encode4(2300391), // Rule ID 53527 //
     /* 2300348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300351 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2300354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2300368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300390 */     // GIR_Coverage, 53527,
     /* 2300390 */     GIR_EraseRootFromParent_Done,
     /* 2300391 */   // Label 31464: @2300391
     /* 2300391 */   GIM_Reject,
     /* 2300392 */ // Label 31462: @2300392
     /* 2300392 */ GIM_Reject,
     /* 2300393 */ // Label 31413: @2300393
     /* 2300393 */ GIM_Try, /*On fail goto*//*Label 31465*/ GIMT_Encode4(2300513),
     /* 2300398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2300401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2300404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300416 */   GIM_Try, /*On fail goto*//*Label 31466*/ GIMT_Encode4(2300464), // Rule ID 53574 //
     /* 2300421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300424 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2300427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2300441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300463 */     // GIR_Coverage, 53574,
     /* 2300463 */     GIR_EraseRootFromParent_Done,
     /* 2300464 */   // Label 31466: @2300464
     /* 2300464 */   GIM_Try, /*On fail goto*//*Label 31467*/ GIMT_Encode4(2300512), // Rule ID 53575 //
     /* 2300469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300472 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2300475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2300489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300511 */     // GIR_Coverage, 53575,
     /* 2300511 */     GIR_EraseRootFromParent_Done,
     /* 2300512 */   // Label 31467: @2300512
     /* 2300512 */   GIM_Reject,
     /* 2300513 */ // Label 31465: @2300513
     /* 2300513 */ GIM_Reject,
     /* 2300514 */ // Label 31414: @2300514
     /* 2300514 */ GIM_Try, /*On fail goto*//*Label 31468*/ GIMT_Encode4(2300634),
     /* 2300519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2300522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2300525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300537 */   GIM_Try, /*On fail goto*//*Label 31469*/ GIMT_Encode4(2300585), // Rule ID 53622 //
     /* 2300542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2300545 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2300548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2300562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300584 */     // GIR_Coverage, 53622,
     /* 2300584 */     GIR_EraseRootFromParent_Done,
     /* 2300585 */   // Label 31469: @2300585
     /* 2300585 */   GIM_Try, /*On fail goto*//*Label 31470*/ GIMT_Encode4(2300633), // Rule ID 53623 //
     /* 2300590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2300593 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2300596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2300610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300632 */     // GIR_Coverage, 53623,
     /* 2300632 */     GIR_EraseRootFromParent_Done,
     /* 2300633 */   // Label 31470: @2300633
     /* 2300633 */   GIM_Reject,
     /* 2300634 */ // Label 31468: @2300634
     /* 2300634 */ GIM_Reject,
     /* 2300635 */ // Label 31415: @2300635
     /* 2300635 */ GIM_Try, /*On fail goto*//*Label 31471*/ GIMT_Encode4(2300755),
     /* 2300640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2300643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2300646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300658 */   GIM_Try, /*On fail goto*//*Label 31472*/ GIMT_Encode4(2300706), // Rule ID 53538 //
     /* 2300663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300666 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2300669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2300683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300705 */     // GIR_Coverage, 53538,
     /* 2300705 */     GIR_EraseRootFromParent_Done,
     /* 2300706 */   // Label 31472: @2300706
     /* 2300706 */   GIM_Try, /*On fail goto*//*Label 31473*/ GIMT_Encode4(2300754), // Rule ID 53539 //
     /* 2300711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300714 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2300717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2300731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300753 */     // GIR_Coverage, 53539,
     /* 2300753 */     GIR_EraseRootFromParent_Done,
     /* 2300754 */   // Label 31473: @2300754
     /* 2300754 */   GIM_Reject,
     /* 2300755 */ // Label 31471: @2300755
     /* 2300755 */ GIM_Reject,
     /* 2300756 */ // Label 31416: @2300756
     /* 2300756 */ GIM_Try, /*On fail goto*//*Label 31474*/ GIMT_Encode4(2300876),
     /* 2300761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2300764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2300767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300779 */   GIM_Try, /*On fail goto*//*Label 31475*/ GIMT_Encode4(2300827), // Rule ID 53586 //
     /* 2300784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300787 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2300790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2300804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300826 */     // GIR_Coverage, 53586,
     /* 2300826 */     GIR_EraseRootFromParent_Done,
     /* 2300827 */   // Label 31475: @2300827
     /* 2300827 */   GIM_Try, /*On fail goto*//*Label 31476*/ GIMT_Encode4(2300875), // Rule ID 53587 //
     /* 2300832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300835 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2300838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2300852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300874 */     // GIR_Coverage, 53587,
     /* 2300874 */     GIR_EraseRootFromParent_Done,
     /* 2300875 */   // Label 31476: @2300875
     /* 2300875 */   GIM_Reject,
     /* 2300876 */ // Label 31474: @2300876
     /* 2300876 */ GIM_Reject,
     /* 2300877 */ // Label 31417: @2300877
     /* 2300877 */ GIM_Try, /*On fail goto*//*Label 31477*/ GIMT_Encode4(2300997),
     /* 2300882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2300885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2300888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2300900 */   GIM_Try, /*On fail goto*//*Label 31478*/ GIMT_Encode4(2300948), // Rule ID 53550 //
     /* 2300905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300908 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2300908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2300911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2300925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300947 */     // GIR_Coverage, 53550,
     /* 2300947 */     GIR_EraseRootFromParent_Done,
     /* 2300948 */   // Label 31478: @2300948
     /* 2300948 */   GIM_Try, /*On fail goto*//*Label 31479*/ GIMT_Encode4(2300996), // Rule ID 53551 //
     /* 2300953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300956 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2300956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2300959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2300963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2300968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2300970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2300973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2300978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2300982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2300994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300995 */     // GIR_Coverage, 53551,
     /* 2300995 */     GIR_EraseRootFromParent_Done,
     /* 2300996 */   // Label 31479: @2300996
     /* 2300996 */   GIM_Reject,
     /* 2300997 */ // Label 31477: @2300997
     /* 2300997 */ GIM_Reject,
     /* 2300998 */ // Label 31418: @2300998
     /* 2300998 */ GIM_Reject,
     /* 2300999 */ // Label 61: @2300999
     /* 2300999 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31498*/ GIMT_Encode4(2303426),
     /* 2301010 */ /*GILLT_s16*//*Label 31480*/ GIMT_Encode4(2301130),
     /* 2301014 */ /*GILLT_s32*//*Label 31481*/ GIMT_Encode4(2301279),
     /* 2301018 */ /*GILLT_s64*//*Label 31482*/ GIMT_Encode4(2301428), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301030 */ /*GILLT_nxv1s16*//*Label 31483*/ GIMT_Encode4(2301611),
     /* 2301034 */ /*GILLT_nxv1s32*//*Label 31484*/ GIMT_Encode4(2301732),
     /* 2301038 */ /*GILLT_nxv1s64*//*Label 31485*/ GIMT_Encode4(2301853), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301050 */ /*GILLT_nxv2s16*//*Label 31486*/ GIMT_Encode4(2301974),
     /* 2301054 */ /*GILLT_nxv2s32*//*Label 31487*/ GIMT_Encode4(2302095),
     /* 2301058 */ /*GILLT_nxv2s64*//*Label 31488*/ GIMT_Encode4(2302216), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301070 */ /*GILLT_nxv4s16*//*Label 31489*/ GIMT_Encode4(2302337),
     /* 2301074 */ /*GILLT_nxv4s32*//*Label 31490*/ GIMT_Encode4(2302458),
     /* 2301078 */ /*GILLT_nxv4s64*//*Label 31491*/ GIMT_Encode4(2302579), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301090 */ /*GILLT_nxv8s16*//*Label 31492*/ GIMT_Encode4(2302700),
     /* 2301094 */ /*GILLT_nxv8s32*//*Label 31493*/ GIMT_Encode4(2302821),
     /* 2301098 */ /*GILLT_nxv8s64*//*Label 31494*/ GIMT_Encode4(2302942), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301110 */ /*GILLT_nxv16s16*//*Label 31495*/ GIMT_Encode4(2303063),
     /* 2301114 */ /*GILLT_nxv16s32*//*Label 31496*/ GIMT_Encode4(2303184), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2301126 */ /*GILLT_nxv32s16*//*Label 31497*/ GIMT_Encode4(2303305),
     /* 2301130 */ // Label 31480: @2301130
     /* 2301130 */ GIM_Try, /*On fail goto*//*Label 31499*/ GIMT_Encode4(2301278),
     /* 2301135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2301138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2301141 */   GIM_Try, /*On fail goto*//*Label 31500*/ GIMT_Encode4(2301175), // Rule ID 1970 //
     /* 2301146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2301149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301161 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2301161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2301164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301174 */     // GIR_Coverage, 1970,
     /* 2301174 */     GIR_EraseRootFromParent_Done,
     /* 2301175 */   // Label 31500: @2301175
     /* 2301175 */   GIM_Try, /*On fail goto*//*Label 31501*/ GIMT_Encode4(2301209), // Rule ID 1971 //
     /* 2301180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2301183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2301195 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2301195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2301198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301208 */     // GIR_Coverage, 1971,
     /* 2301208 */     GIR_EraseRootFromParent_Done,
     /* 2301209 */   // Label 31501: @2301209
     /* 2301209 */   GIM_Try, /*On fail goto*//*Label 31502*/ GIMT_Encode4(2301243), // Rule ID 1974 //
     /* 2301214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2301217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301229 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2301229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2301232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301242 */     // GIR_Coverage, 1974,
     /* 2301242 */     GIR_EraseRootFromParent_Done,
     /* 2301243 */   // Label 31502: @2301243
     /* 2301243 */   GIM_Try, /*On fail goto*//*Label 31503*/ GIMT_Encode4(2301277), // Rule ID 1975 //
     /* 2301248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2301251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2301263 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2301263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2301266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301276 */     // GIR_Coverage, 1975,
     /* 2301276 */     GIR_EraseRootFromParent_Done,
     /* 2301277 */   // Label 31503: @2301277
     /* 2301277 */   GIM_Reject,
     /* 2301278 */ // Label 31499: @2301278
     /* 2301278 */ GIM_Reject,
     /* 2301279 */ // Label 31481: @2301279
     /* 2301279 */ GIM_Try, /*On fail goto*//*Label 31504*/ GIMT_Encode4(2301427),
     /* 2301284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2301287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2301290 */   GIM_Try, /*On fail goto*//*Label 31505*/ GIMT_Encode4(2301324), // Rule ID 1261 //
     /* 2301295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2301298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301310 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2301310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2301313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301323 */     // GIR_Coverage, 1261,
     /* 2301323 */     GIR_EraseRootFromParent_Done,
     /* 2301324 */   // Label 31505: @2301324
     /* 2301324 */   GIM_Try, /*On fail goto*//*Label 31506*/ GIMT_Encode4(2301358), // Rule ID 1262 //
     /* 2301329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2301332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2301344 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2301344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2301347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301357 */     // GIR_Coverage, 1262,
     /* 2301357 */     GIR_EraseRootFromParent_Done,
     /* 2301358 */   // Label 31506: @2301358
     /* 2301358 */   GIM_Try, /*On fail goto*//*Label 31507*/ GIMT_Encode4(2301392), // Rule ID 1265 //
     /* 2301363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2301366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301378 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2301378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2301381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301391 */     // GIR_Coverage, 1265,
     /* 2301391 */     GIR_EraseRootFromParent_Done,
     /* 2301392 */   // Label 31507: @2301392
     /* 2301392 */   GIM_Try, /*On fail goto*//*Label 31508*/ GIMT_Encode4(2301426), // Rule ID 1266 //
     /* 2301397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2301400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2301412 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2301412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2301415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301425 */     // GIR_Coverage, 1266,
     /* 2301425 */     GIR_EraseRootFromParent_Done,
     /* 2301426 */   // Label 31508: @2301426
     /* 2301426 */   GIM_Reject,
     /* 2301427 */ // Label 31504: @2301427
     /* 2301427 */ GIM_Reject,
     /* 2301428 */ // Label 31482: @2301428
     /* 2301428 */ GIM_Try, /*On fail goto*//*Label 31509*/ GIMT_Encode4(2301610),
     /* 2301433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2301436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2301439 */   GIM_Try, /*On fail goto*//*Label 31510*/ GIMT_Encode4(2301473), // Rule ID 1600 //
     /* 2301444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2301447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301459 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2301459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2301462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301472 */     // GIR_Coverage, 1600,
     /* 2301472 */     GIR_EraseRootFromParent_Done,
     /* 2301473 */   // Label 31510: @2301473
     /* 2301473 */   GIM_Try, /*On fail goto*//*Label 31511*/ GIMT_Encode4(2301507), // Rule ID 1601 //
     /* 2301478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2301481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2301493 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2301493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2301496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301506 */     // GIR_Coverage, 1601,
     /* 2301506 */     GIR_EraseRootFromParent_Done,
     /* 2301507 */   // Label 31511: @2301507
     /* 2301507 */   GIM_Try, /*On fail goto*//*Label 31512*/ GIMT_Encode4(2301541), // Rule ID 1604 //
     /* 2301512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2301515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301527 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2301527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2301530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301540 */     // GIR_Coverage, 1604,
     /* 2301540 */     GIR_EraseRootFromParent_Done,
     /* 2301541 */   // Label 31512: @2301541
     /* 2301541 */   GIM_Try, /*On fail goto*//*Label 31513*/ GIMT_Encode4(2301575), // Rule ID 1605 //
     /* 2301546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2301549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2301561 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2301561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2301564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301574 */     // GIR_Coverage, 1605,
     /* 2301574 */     GIR_EraseRootFromParent_Done,
     /* 2301575 */   // Label 31513: @2301575
     /* 2301575 */   GIM_Try, /*On fail goto*//*Label 31514*/ GIMT_Encode4(2301609), // Rule ID 1607 //
     /* 2301580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2301583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2301595 */     // (fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2301595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2301598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301608 */     // GIR_Coverage, 1607,
     /* 2301608 */     GIR_EraseRootFromParent_Done,
     /* 2301609 */   // Label 31514: @2301609
     /* 2301609 */   GIM_Reject,
     /* 2301610 */ // Label 31509: @2301610
     /* 2301610 */ GIM_Reject,
     /* 2301611 */ // Label 31483: @2301611
     /* 2301611 */ GIM_Try, /*On fail goto*//*Label 31515*/ GIMT_Encode4(2301731),
     /* 2301616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2301619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2301622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301634 */   GIM_Try, /*On fail goto*//*Label 31516*/ GIMT_Encode4(2301682), // Rule ID 54222 //
     /* 2301639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2301642 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2301645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2301659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301681 */     // GIR_Coverage, 54222,
     /* 2301681 */     GIR_EraseRootFromParent_Done,
     /* 2301682 */   // Label 31516: @2301682
     /* 2301682 */   GIM_Try, /*On fail goto*//*Label 31517*/ GIMT_Encode4(2301730), // Rule ID 54223 //
     /* 2301687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2301690 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2301693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2301707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2301725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301729 */     // GIR_Coverage, 54223,
     /* 2301729 */     GIR_EraseRootFromParent_Done,
     /* 2301730 */   // Label 31517: @2301730
     /* 2301730 */   GIM_Reject,
     /* 2301731 */ // Label 31515: @2301731
     /* 2301731 */ GIM_Reject,
     /* 2301732 */ // Label 31484: @2301732
     /* 2301732 */ GIM_Try, /*On fail goto*//*Label 31518*/ GIMT_Encode4(2301852),
     /* 2301737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2301740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2301743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301755 */   GIM_Try, /*On fail goto*//*Label 31519*/ GIMT_Encode4(2301803), // Rule ID 54246 //
     /* 2301760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2301763 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2301766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2301780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301802 */     // GIR_Coverage, 54246,
     /* 2301802 */     GIR_EraseRootFromParent_Done,
     /* 2301803 */   // Label 31519: @2301803
     /* 2301803 */   GIM_Try, /*On fail goto*//*Label 31520*/ GIMT_Encode4(2301851), // Rule ID 54247 //
     /* 2301808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301811 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2301814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2301828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301850 */     // GIR_Coverage, 54247,
     /* 2301850 */     GIR_EraseRootFromParent_Done,
     /* 2301851 */   // Label 31520: @2301851
     /* 2301851 */   GIM_Reject,
     /* 2301852 */ // Label 31518: @2301852
     /* 2301852 */ GIM_Reject,
     /* 2301853 */ // Label 31485: @2301853
     /* 2301853 */ GIM_Try, /*On fail goto*//*Label 31521*/ GIMT_Encode4(2301973),
     /* 2301858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2301861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2301864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301876 */   GIM_Try, /*On fail goto*//*Label 31522*/ GIMT_Encode4(2301924), // Rule ID 54282 //
     /* 2301881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301884 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2301884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2301887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2301901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301923 */     // GIR_Coverage, 54282,
     /* 2301923 */     GIR_EraseRootFromParent_Done,
     /* 2301924 */   // Label 31522: @2301924
     /* 2301924 */   GIM_Try, /*On fail goto*//*Label 31523*/ GIMT_Encode4(2301972), // Rule ID 54283 //
     /* 2301929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301932 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2301932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2301935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2301939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2301944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2301946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2301949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2301954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2301958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2301970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301971 */     // GIR_Coverage, 54283,
     /* 2301971 */     GIR_EraseRootFromParent_Done,
     /* 2301972 */   // Label 31523: @2301972
     /* 2301972 */   GIM_Reject,
     /* 2301973 */ // Label 31521: @2301973
     /* 2301973 */ GIM_Reject,
     /* 2301974 */ // Label 31486: @2301974
     /* 2301974 */ GIM_Try, /*On fail goto*//*Label 31524*/ GIMT_Encode4(2302094),
     /* 2301979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2301982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2301985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2301997 */   GIM_Try, /*On fail goto*//*Label 31525*/ GIMT_Encode4(2302045), // Rule ID 54234 //
     /* 2302002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302005 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2302008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2302022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302044 */     // GIR_Coverage, 54234,
     /* 2302044 */     GIR_EraseRootFromParent_Done,
     /* 2302045 */   // Label 31525: @2302045
     /* 2302045 */   GIM_Try, /*On fail goto*//*Label 31526*/ GIMT_Encode4(2302093), // Rule ID 54235 //
     /* 2302050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302053 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2302056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2302070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302092 */     // GIR_Coverage, 54235,
     /* 2302092 */     GIR_EraseRootFromParent_Done,
     /* 2302093 */   // Label 31526: @2302093
     /* 2302093 */   GIM_Reject,
     /* 2302094 */ // Label 31524: @2302094
     /* 2302094 */ GIM_Reject,
     /* 2302095 */ // Label 31487: @2302095
     /* 2302095 */ GIM_Try, /*On fail goto*//*Label 31527*/ GIMT_Encode4(2302215),
     /* 2302100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2302103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2302106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302118 */   GIM_Try, /*On fail goto*//*Label 31528*/ GIMT_Encode4(2302166), // Rule ID 54270 //
     /* 2302123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302126 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2302129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2302143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302165 */     // GIR_Coverage, 54270,
     /* 2302165 */     GIR_EraseRootFromParent_Done,
     /* 2302166 */   // Label 31528: @2302166
     /* 2302166 */   GIM_Try, /*On fail goto*//*Label 31529*/ GIMT_Encode4(2302214), // Rule ID 54271 //
     /* 2302171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302174 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2302177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2302191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302213 */     // GIR_Coverage, 54271,
     /* 2302213 */     GIR_EraseRootFromParent_Done,
     /* 2302214 */   // Label 31529: @2302214
     /* 2302214 */   GIM_Reject,
     /* 2302215 */ // Label 31527: @2302215
     /* 2302215 */ GIM_Reject,
     /* 2302216 */ // Label 31488: @2302216
     /* 2302216 */ GIM_Try, /*On fail goto*//*Label 31530*/ GIMT_Encode4(2302336),
     /* 2302221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2302224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2302227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302239 */   GIM_Try, /*On fail goto*//*Label 31531*/ GIMT_Encode4(2302287), // Rule ID 54366 //
     /* 2302244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302247 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2302250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2302264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302286 */     // GIR_Coverage, 54366,
     /* 2302286 */     GIR_EraseRootFromParent_Done,
     /* 2302287 */   // Label 31531: @2302287
     /* 2302287 */   GIM_Try, /*On fail goto*//*Label 31532*/ GIMT_Encode4(2302335), // Rule ID 54367 //
     /* 2302292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302295 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2302298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2302312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302334 */     // GIR_Coverage, 54367,
     /* 2302334 */     GIR_EraseRootFromParent_Done,
     /* 2302335 */   // Label 31532: @2302335
     /* 2302335 */   GIM_Reject,
     /* 2302336 */ // Label 31530: @2302336
     /* 2302336 */ GIM_Reject,
     /* 2302337 */ // Label 31489: @2302337
     /* 2302337 */ GIM_Try, /*On fail goto*//*Label 31533*/ GIMT_Encode4(2302457),
     /* 2302342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2302345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2302348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2302360 */   GIM_Try, /*On fail goto*//*Label 31534*/ GIMT_Encode4(2302408), // Rule ID 54258 //
     /* 2302365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302368 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2302371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2302385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302407 */     // GIR_Coverage, 54258,
     /* 2302407 */     GIR_EraseRootFromParent_Done,
     /* 2302408 */   // Label 31534: @2302408
     /* 2302408 */   GIM_Try, /*On fail goto*//*Label 31535*/ GIMT_Encode4(2302456), // Rule ID 54259 //
     /* 2302413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302416 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2302419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2302433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302455 */     // GIR_Coverage, 54259,
     /* 2302455 */     GIR_EraseRootFromParent_Done,
     /* 2302456 */   // Label 31535: @2302456
     /* 2302456 */   GIM_Reject,
     /* 2302457 */ // Label 31533: @2302457
     /* 2302457 */ GIM_Reject,
     /* 2302458 */ // Label 31490: @2302458
     /* 2302458 */ GIM_Try, /*On fail goto*//*Label 31536*/ GIMT_Encode4(2302578),
     /* 2302463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2302466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2302469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302481 */   GIM_Try, /*On fail goto*//*Label 31537*/ GIMT_Encode4(2302529), // Rule ID 54330 //
     /* 2302486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302489 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2302492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2302506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302528 */     // GIR_Coverage, 54330,
     /* 2302528 */     GIR_EraseRootFromParent_Done,
     /* 2302529 */   // Label 31537: @2302529
     /* 2302529 */   GIM_Try, /*On fail goto*//*Label 31538*/ GIMT_Encode4(2302577), // Rule ID 54331 //
     /* 2302534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302537 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2302540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2302554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302576 */     // GIR_Coverage, 54331,
     /* 2302576 */     GIR_EraseRootFromParent_Done,
     /* 2302577 */   // Label 31538: @2302577
     /* 2302577 */   GIM_Reject,
     /* 2302578 */ // Label 31536: @2302578
     /* 2302578 */ GIM_Reject,
     /* 2302579 */ // Label 31491: @2302579
     /* 2302579 */ GIM_Try, /*On fail goto*//*Label 31539*/ GIMT_Encode4(2302699),
     /* 2302584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2302587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2302590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302602 */   GIM_Try, /*On fail goto*//*Label 31540*/ GIMT_Encode4(2302650), // Rule ID 54378 //
     /* 2302607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302610 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2302613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2302627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302649 */     // GIR_Coverage, 54378,
     /* 2302649 */     GIR_EraseRootFromParent_Done,
     /* 2302650 */   // Label 31540: @2302650
     /* 2302650 */   GIM_Try, /*On fail goto*//*Label 31541*/ GIMT_Encode4(2302698), // Rule ID 54379 //
     /* 2302655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302658 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2302661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2302675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302697 */     // GIR_Coverage, 54379,
     /* 2302697 */     GIR_EraseRootFromParent_Done,
     /* 2302698 */   // Label 31541: @2302698
     /* 2302698 */   GIM_Reject,
     /* 2302699 */ // Label 31539: @2302699
     /* 2302699 */ GIM_Reject,
     /* 2302700 */ // Label 31492: @2302700
     /* 2302700 */ GIM_Try, /*On fail goto*//*Label 31542*/ GIMT_Encode4(2302820),
     /* 2302705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2302708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2302711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2302723 */   GIM_Try, /*On fail goto*//*Label 31543*/ GIMT_Encode4(2302771), // Rule ID 54294 //
     /* 2302728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302731 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2302734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2302748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302770 */     // GIR_Coverage, 54294,
     /* 2302770 */     GIR_EraseRootFromParent_Done,
     /* 2302771 */   // Label 31543: @2302771
     /* 2302771 */   GIM_Try, /*On fail goto*//*Label 31544*/ GIMT_Encode4(2302819), // Rule ID 54295 //
     /* 2302776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302779 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2302782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2302796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302818 */     // GIR_Coverage, 54295,
     /* 2302818 */     GIR_EraseRootFromParent_Done,
     /* 2302819 */   // Label 31544: @2302819
     /* 2302819 */   GIM_Reject,
     /* 2302820 */ // Label 31542: @2302820
     /* 2302820 */ GIM_Reject,
     /* 2302821 */ // Label 31493: @2302821
     /* 2302821 */ GIM_Try, /*On fail goto*//*Label 31545*/ GIMT_Encode4(2302941),
     /* 2302826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2302829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2302832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302844 */   GIM_Try, /*On fail goto*//*Label 31546*/ GIMT_Encode4(2302892), // Rule ID 54342 //
     /* 2302849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2302852 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2302855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2302869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302891 */     // GIR_Coverage, 54342,
     /* 2302891 */     GIR_EraseRootFromParent_Done,
     /* 2302892 */   // Label 31546: @2302892
     /* 2302892 */   GIM_Try, /*On fail goto*//*Label 31547*/ GIMT_Encode4(2302940), // Rule ID 54343 //
     /* 2302897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2302900 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2302900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2302903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2302917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2302935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2302938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302939 */     // GIR_Coverage, 54343,
     /* 2302939 */     GIR_EraseRootFromParent_Done,
     /* 2302940 */   // Label 31547: @2302940
     /* 2302940 */   GIM_Reject,
     /* 2302941 */ // Label 31545: @2302941
     /* 2302941 */ GIM_Reject,
     /* 2302942 */ // Label 31494: @2302942
     /* 2302942 */ GIM_Try, /*On fail goto*//*Label 31548*/ GIMT_Encode4(2303062),
     /* 2302947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2302950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2302953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302965 */   GIM_Try, /*On fail goto*//*Label 31549*/ GIMT_Encode4(2303013), // Rule ID 54390 //
     /* 2302970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302973 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2302973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2302976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2302980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2302985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2302987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2302990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2302995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2302999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303012 */     // GIR_Coverage, 54390,
     /* 2303012 */     GIR_EraseRootFromParent_Done,
     /* 2303013 */   // Label 31549: @2303013
     /* 2303013 */   GIM_Try, /*On fail goto*//*Label 31550*/ GIMT_Encode4(2303061), // Rule ID 54391 //
     /* 2303018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2303021 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2303024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2303038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2303056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303060 */     // GIR_Coverage, 54391,
     /* 2303060 */     GIR_EraseRootFromParent_Done,
     /* 2303061 */   // Label 31550: @2303061
     /* 2303061 */   GIM_Reject,
     /* 2303062 */ // Label 31548: @2303062
     /* 2303062 */ GIM_Reject,
     /* 2303063 */ // Label 31495: @2303063
     /* 2303063 */ GIM_Try, /*On fail goto*//*Label 31551*/ GIMT_Encode4(2303183),
     /* 2303068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2303071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2303074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303086 */   GIM_Try, /*On fail goto*//*Label 31552*/ GIMT_Encode4(2303134), // Rule ID 54306 //
     /* 2303091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303094 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2303097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2303111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303133 */     // GIR_Coverage, 54306,
     /* 2303133 */     GIR_EraseRootFromParent_Done,
     /* 2303134 */   // Label 31552: @2303134
     /* 2303134 */   GIM_Try, /*On fail goto*//*Label 31553*/ GIMT_Encode4(2303182), // Rule ID 54307 //
     /* 2303139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303142 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2303145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2303159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303181 */     // GIR_Coverage, 54307,
     /* 2303181 */     GIR_EraseRootFromParent_Done,
     /* 2303182 */   // Label 31553: @2303182
     /* 2303182 */   GIM_Reject,
     /* 2303183 */ // Label 31551: @2303183
     /* 2303183 */ GIM_Reject,
     /* 2303184 */ // Label 31496: @2303184
     /* 2303184 */ GIM_Try, /*On fail goto*//*Label 31554*/ GIMT_Encode4(2303304),
     /* 2303189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2303195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303203 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303207 */   GIM_Try, /*On fail goto*//*Label 31555*/ GIMT_Encode4(2303255), // Rule ID 54354 //
     /* 2303212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303215 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2303218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2303232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303254 */     // GIR_Coverage, 54354,
     /* 2303254 */     GIR_EraseRootFromParent_Done,
     /* 2303255 */   // Label 31555: @2303255
     /* 2303255 */   GIM_Try, /*On fail goto*//*Label 31556*/ GIMT_Encode4(2303303), // Rule ID 54355 //
     /* 2303260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303263 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2303266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2303280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303302 */     // GIR_Coverage, 54355,
     /* 2303302 */     GIR_EraseRootFromParent_Done,
     /* 2303303 */   // Label 31556: @2303303
     /* 2303303 */   GIM_Reject,
     /* 2303304 */ // Label 31554: @2303304
     /* 2303304 */ GIM_Reject,
     /* 2303305 */ // Label 31497: @2303305
     /* 2303305 */ GIM_Try, /*On fail goto*//*Label 31557*/ GIMT_Encode4(2303425),
     /* 2303310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2303313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2303316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303328 */   GIM_Try, /*On fail goto*//*Label 31558*/ GIMT_Encode4(2303376), // Rule ID 54318 //
     /* 2303333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303336 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2303336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2303339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2303353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303375 */     // GIR_Coverage, 54318,
     /* 2303375 */     GIR_EraseRootFromParent_Done,
     /* 2303376 */   // Label 31558: @2303376
     /* 2303376 */   GIM_Try, /*On fail goto*//*Label 31559*/ GIMT_Encode4(2303424), // Rule ID 54319 //
     /* 2303381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303384 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2303384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2303387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2303391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2303396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2303398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2303401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2303406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2303422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303423 */     // GIR_Coverage, 54319,
     /* 2303423 */     GIR_EraseRootFromParent_Done,
     /* 2303424 */   // Label 31559: @2303424
     /* 2303424 */   GIM_Reject,
     /* 2303425 */ // Label 31557: @2303425
     /* 2303425 */ GIM_Reject,
     /* 2303426 */ // Label 31498: @2303426
     /* 2303426 */ GIM_Reject,
     /* 2303427 */ // Label 62: @2303427
     /* 2303427 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31578*/ GIMT_Encode4(2320071),
     /* 2303438 */ /*GILLT_s16*//*Label 31560*/ GIMT_Encode4(2303558),
     /* 2303442 */ /*GILLT_s32*//*Label 31561*/ GIMT_Encode4(2304994),
     /* 2303446 */ /*GILLT_s64*//*Label 31562*/ GIMT_Encode4(2306430), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303458 */ /*GILLT_nxv1s16*//*Label 31563*/ GIMT_Encode4(2308221),
     /* 2303462 */ /*GILLT_nxv1s32*//*Label 31564*/ GIMT_Encode4(2309011),
     /* 2303466 */ /*GILLT_nxv1s64*//*Label 31565*/ GIMT_Encode4(2309801), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303478 */ /*GILLT_nxv2s16*//*Label 31566*/ GIMT_Encode4(2310591),
     /* 2303482 */ /*GILLT_nxv2s32*//*Label 31567*/ GIMT_Encode4(2311381),
     /* 2303486 */ /*GILLT_nxv2s64*//*Label 31568*/ GIMT_Encode4(2312171), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303498 */ /*GILLT_nxv4s16*//*Label 31569*/ GIMT_Encode4(2312961),
     /* 2303502 */ /*GILLT_nxv4s32*//*Label 31570*/ GIMT_Encode4(2313751),
     /* 2303506 */ /*GILLT_nxv4s64*//*Label 31571*/ GIMT_Encode4(2314541), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303518 */ /*GILLT_nxv8s16*//*Label 31572*/ GIMT_Encode4(2315331),
     /* 2303522 */ /*GILLT_nxv8s32*//*Label 31573*/ GIMT_Encode4(2316121),
     /* 2303526 */ /*GILLT_nxv8s64*//*Label 31574*/ GIMT_Encode4(2316911), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303538 */ /*GILLT_nxv16s16*//*Label 31575*/ GIMT_Encode4(2317701),
     /* 2303542 */ /*GILLT_nxv16s32*//*Label 31576*/ GIMT_Encode4(2318491), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2303554 */ /*GILLT_nxv32s16*//*Label 31577*/ GIMT_Encode4(2319281),
     /* 2303558 */ // Label 31560: @2303558
     /* 2303558 */ GIM_Try, /*On fail goto*//*Label 31579*/ GIMT_Encode4(2304993),
     /* 2303563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2303569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2303572 */   GIM_Try, /*On fail goto*//*Label 31580*/ GIMT_Encode4(2303644), // Rule ID 2011 //
     /* 2303577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2303580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303624 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2303624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2303627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2303639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303643 */     // GIR_Coverage, 2011,
     /* 2303643 */     GIR_EraseRootFromParent_Done,
     /* 2303644 */   // Label 31580: @2303644
     /* 2303644 */   GIM_Try, /*On fail goto*//*Label 31581*/ GIMT_Encode4(2303716), // Rule ID 2012 //
     /* 2303649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2303652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303696 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2303696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2303699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2303711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303715 */     // GIR_Coverage, 2012,
     /* 2303715 */     GIR_EraseRootFromParent_Done,
     /* 2303716 */   // Label 31581: @2303716
     /* 2303716 */   GIM_Try, /*On fail goto*//*Label 31582*/ GIMT_Encode4(2303788), // Rule ID 2044 //
     /* 2303721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2303724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303768 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2303768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2303771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2303783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303787 */     // GIR_Coverage, 2044,
     /* 2303787 */     GIR_EraseRootFromParent_Done,
     /* 2303788 */   // Label 31582: @2303788
     /* 2303788 */   GIM_Try, /*On fail goto*//*Label 31583*/ GIMT_Encode4(2303860), // Rule ID 2045 //
     /* 2303793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2303796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2303838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303840 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2303840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2303843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2303851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2303855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303859 */     // GIR_Coverage, 2045,
     /* 2303859 */     GIR_EraseRootFromParent_Done,
     /* 2303860 */   // Label 31583: @2303860
     /* 2303860 */   GIM_Try, /*On fail goto*//*Label 31584*/ GIMT_Encode4(2303932), // Rule ID 65448 //
     /* 2303865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2303868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303912 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2303912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2303915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2303923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2303927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303931 */     // GIR_Coverage, 65448,
     /* 2303931 */     GIR_EraseRootFromParent_Done,
     /* 2303932 */   // Label 31584: @2303932
     /* 2303932 */   GIM_Try, /*On fail goto*//*Label 31585*/ GIMT_Encode4(2304004), // Rule ID 65449 //
     /* 2303937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2303940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2303977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2303982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303984 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2303984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2303987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2303995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2303999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304003 */     // GIR_Coverage, 65449,
     /* 2304003 */     GIR_EraseRootFromParent_Done,
     /* 2304004 */   // Label 31585: @2304004
     /* 2304004 */   GIM_Try, /*On fail goto*//*Label 31586*/ GIMT_Encode4(2304076), // Rule ID 65456 //
     /* 2304009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304056 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2304059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304075 */     // GIR_Coverage, 65456,
     /* 2304075 */     GIR_EraseRootFromParent_Done,
     /* 2304076 */   // Label 31586: @2304076
     /* 2304076 */   GIM_Try, /*On fail goto*//*Label 31587*/ GIMT_Encode4(2304148), // Rule ID 65457 //
     /* 2304081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304128 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2304131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2304143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304147 */     // GIR_Coverage, 65457,
     /* 2304147 */     GIR_EraseRootFromParent_Done,
     /* 2304148 */   // Label 31587: @2304148
     /* 2304148 */   GIM_Try, /*On fail goto*//*Label 31588*/ GIMT_Encode4(2304205), // Rule ID 2007 //
     /* 2304153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304187 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2304190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304204 */     // GIR_Coverage, 2007,
     /* 2304204 */     GIR_EraseRootFromParent_Done,
     /* 2304205 */   // Label 31588: @2304205
     /* 2304205 */   GIM_Try, /*On fail goto*//*Label 31589*/ GIMT_Encode4(2304262), // Rule ID 2008 //
     /* 2304210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304244 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2304247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304261 */     // GIR_Coverage, 2008,
     /* 2304261 */     GIR_EraseRootFromParent_Done,
     /* 2304262 */   // Label 31589: @2304262
     /* 2304262 */   GIM_Try, /*On fail goto*//*Label 31590*/ GIMT_Encode4(2304319), // Rule ID 2040 //
     /* 2304267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304301 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2304304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304318 */     // GIR_Coverage, 2040,
     /* 2304318 */     GIR_EraseRootFromParent_Done,
     /* 2304319 */   // Label 31590: @2304319
     /* 2304319 */   GIM_Try, /*On fail goto*//*Label 31591*/ GIMT_Encode4(2304376), // Rule ID 2041 //
     /* 2304324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304358 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2304361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304375 */     // GIR_Coverage, 2041,
     /* 2304375 */     GIR_EraseRootFromParent_Done,
     /* 2304376 */   // Label 31591: @2304376
     /* 2304376 */   GIM_Try, /*On fail goto*//*Label 31592*/ GIMT_Encode4(2304433), // Rule ID 65444 //
     /* 2304381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304415 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2304418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304432 */     // GIR_Coverage, 65444,
     /* 2304432 */     GIR_EraseRootFromParent_Done,
     /* 2304433 */   // Label 31592: @2304433
     /* 2304433 */   GIM_Try, /*On fail goto*//*Label 31593*/ GIMT_Encode4(2304490), // Rule ID 65445 //
     /* 2304438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304472 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2304475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304489 */     // GIR_Coverage, 65445,
     /* 2304489 */     GIR_EraseRootFromParent_Done,
     /* 2304490 */   // Label 31593: @2304490
     /* 2304490 */   GIM_Try, /*On fail goto*//*Label 31594*/ GIMT_Encode4(2304547), // Rule ID 65452 //
     /* 2304495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304529 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2304532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304546 */     // GIR_Coverage, 65452,
     /* 2304546 */     GIR_EraseRootFromParent_Done,
     /* 2304547 */   // Label 31594: @2304547
     /* 2304547 */   GIM_Try, /*On fail goto*//*Label 31595*/ GIMT_Encode4(2304604), // Rule ID 65453 //
     /* 2304552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304586 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2304589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2304597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304603 */     // GIR_Coverage, 65453,
     /* 2304603 */     GIR_EraseRootFromParent_Done,
     /* 2304604 */   // Label 31595: @2304604
     /* 2304604 */   GIM_Try, /*On fail goto*//*Label 31596*/ GIMT_Encode4(2304661), // Rule ID 2003 //
     /* 2304609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2304628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304643 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2304646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2304656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304660 */     // GIR_Coverage, 2003,
     /* 2304660 */     GIR_EraseRootFromParent_Done,
     /* 2304661 */   // Label 31596: @2304661
     /* 2304661 */   GIM_Try, /*On fail goto*//*Label 31597*/ GIMT_Encode4(2304718), // Rule ID 2004 //
     /* 2304666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2304685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304700 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2304703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2304713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304717 */     // GIR_Coverage, 2004,
     /* 2304717 */     GIR_EraseRootFromParent_Done,
     /* 2304718 */   // Label 31597: @2304718
     /* 2304718 */   GIM_Try, /*On fail goto*//*Label 31598*/ GIMT_Encode4(2304775), // Rule ID 2036 //
     /* 2304723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2304742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304757 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2304760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2304770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304774 */     // GIR_Coverage, 2036,
     /* 2304774 */     GIR_EraseRootFromParent_Done,
     /* 2304775 */   // Label 31598: @2304775
     /* 2304775 */   GIM_Try, /*On fail goto*//*Label 31599*/ GIMT_Encode4(2304832), // Rule ID 2037 //
     /* 2304780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2304799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304814 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2304817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2304827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304831 */     // GIR_Coverage, 2037,
     /* 2304831 */     GIR_EraseRootFromParent_Done,
     /* 2304832 */   // Label 31599: @2304832
     /* 2304832 */   GIM_Try, /*On fail goto*//*Label 31600*/ GIMT_Encode4(2304872), // Rule ID 1999 //
     /* 2304837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304856 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2304859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304871 */     // GIR_Coverage, 1999,
     /* 2304871 */     GIR_EraseRootFromParent_Done,
     /* 2304872 */   // Label 31600: @2304872
     /* 2304872 */   GIM_Try, /*On fail goto*//*Label 31601*/ GIMT_Encode4(2304912), // Rule ID 2000 //
     /* 2304877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304896 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2304899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304911 */     // GIR_Coverage, 2000,
     /* 2304911 */     GIR_EraseRootFromParent_Done,
     /* 2304912 */   // Label 31601: @2304912
     /* 2304912 */   GIM_Try, /*On fail goto*//*Label 31602*/ GIMT_Encode4(2304952), // Rule ID 2032 //
     /* 2304917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2304920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304936 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2304936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2304939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304951 */     // GIR_Coverage, 2032,
     /* 2304951 */     GIR_EraseRootFromParent_Done,
     /* 2304952 */   // Label 31602: @2304952
     /* 2304952 */   GIM_Try, /*On fail goto*//*Label 31603*/ GIMT_Encode4(2304992), // Rule ID 2033 //
     /* 2304957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2304960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2304976 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2304976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2304979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2304987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304991 */     // GIR_Coverage, 2033,
     /* 2304991 */     GIR_EraseRootFromParent_Done,
     /* 2304992 */   // Label 31603: @2304992
     /* 2304992 */   GIM_Reject,
     /* 2304993 */ // Label 31579: @2304993
     /* 2304993 */ GIM_Reject,
     /* 2304994 */ // Label 31561: @2304994
     /* 2304994 */ GIM_Try, /*On fail goto*//*Label 31604*/ GIMT_Encode4(2306429),
     /* 2304999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2305005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2305008 */   GIM_Try, /*On fail goto*//*Label 31605*/ GIMT_Encode4(2305080), // Rule ID 1310 //
     /* 2305013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2305016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305060 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2305063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305079 */     // GIR_Coverage, 1310,
     /* 2305079 */     GIR_EraseRootFromParent_Done,
     /* 2305080 */   // Label 31605: @2305080
     /* 2305080 */   GIM_Try, /*On fail goto*//*Label 31606*/ GIMT_Encode4(2305152), // Rule ID 1311 //
     /* 2305085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2305088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305132 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2305135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305151 */     // GIR_Coverage, 1311,
     /* 2305151 */     GIR_EraseRootFromParent_Done,
     /* 2305152 */   // Label 31606: @2305152
     /* 2305152 */   GIM_Try, /*On fail goto*//*Label 31607*/ GIMT_Encode4(2305224), // Rule ID 1331 //
     /* 2305157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2305160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305204 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2305207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305223 */     // GIR_Coverage, 1331,
     /* 2305223 */     GIR_EraseRootFromParent_Done,
     /* 2305224 */   // Label 31607: @2305224
     /* 2305224 */   GIM_Try, /*On fail goto*//*Label 31608*/ GIMT_Encode4(2305296), // Rule ID 1332 //
     /* 2305229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2305232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305276 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2305279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305295 */     // GIR_Coverage, 1332,
     /* 2305295 */     GIR_EraseRootFromParent_Done,
     /* 2305296 */   // Label 31608: @2305296
     /* 2305296 */   GIM_Try, /*On fail goto*//*Label 31609*/ GIMT_Encode4(2305368), // Rule ID 65412 //
     /* 2305301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2305304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305348 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2305351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305367 */     // GIR_Coverage, 65412,
     /* 2305367 */     GIR_EraseRootFromParent_Done,
     /* 2305368 */   // Label 31609: @2305368
     /* 2305368 */   GIM_Try, /*On fail goto*//*Label 31610*/ GIMT_Encode4(2305440), // Rule ID 65413 //
     /* 2305373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2305376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305420 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2305423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305439 */     // GIR_Coverage, 65413,
     /* 2305439 */     GIR_EraseRootFromParent_Done,
     /* 2305440 */   // Label 31610: @2305440
     /* 2305440 */   GIM_Try, /*On fail goto*//*Label 31611*/ GIMT_Encode4(2305512), // Rule ID 65420 //
     /* 2305445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2305448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305492 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2305495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305511 */     // GIR_Coverage, 65420,
     /* 2305511 */     GIR_EraseRootFromParent_Done,
     /* 2305512 */   // Label 31611: @2305512
     /* 2305512 */   GIM_Try, /*On fail goto*//*Label 31612*/ GIMT_Encode4(2305584), // Rule ID 65421 //
     /* 2305517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2305520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2305549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2305564 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2305567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2305579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305583 */     // GIR_Coverage, 65421,
     /* 2305583 */     GIR_EraseRootFromParent_Done,
     /* 2305584 */   // Label 31612: @2305584
     /* 2305584 */   GIM_Try, /*On fail goto*//*Label 31613*/ GIMT_Encode4(2305641), // Rule ID 1306 //
     /* 2305589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2305592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305623 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2305626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305640 */     // GIR_Coverage, 1306,
     /* 2305640 */     GIR_EraseRootFromParent_Done,
     /* 2305641 */   // Label 31613: @2305641
     /* 2305641 */   GIM_Try, /*On fail goto*//*Label 31614*/ GIMT_Encode4(2305698), // Rule ID 1307 //
     /* 2305646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2305649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305680 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2305683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305697 */     // GIR_Coverage, 1307,
     /* 2305697 */     GIR_EraseRootFromParent_Done,
     /* 2305698 */   // Label 31614: @2305698
     /* 2305698 */   GIM_Try, /*On fail goto*//*Label 31615*/ GIMT_Encode4(2305755), // Rule ID 1327 //
     /* 2305703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2305706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305737 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2305740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305754 */     // GIR_Coverage, 1327,
     /* 2305754 */     GIR_EraseRootFromParent_Done,
     /* 2305755 */   // Label 31615: @2305755
     /* 2305755 */   GIM_Try, /*On fail goto*//*Label 31616*/ GIMT_Encode4(2305812), // Rule ID 1328 //
     /* 2305760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2305763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2305771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305794 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2305797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305811 */     // GIR_Coverage, 1328,
     /* 2305811 */     GIR_EraseRootFromParent_Done,
     /* 2305812 */   // Label 31616: @2305812
     /* 2305812 */   GIM_Try, /*On fail goto*//*Label 31617*/ GIMT_Encode4(2305869), // Rule ID 65408 //
     /* 2305817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2305820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305851 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2305854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305868 */     // GIR_Coverage, 65408,
     /* 2305868 */     GIR_EraseRootFromParent_Done,
     /* 2305869 */   // Label 31617: @2305869
     /* 2305869 */   GIM_Try, /*On fail goto*//*Label 31618*/ GIMT_Encode4(2305926), // Rule ID 65409 //
     /* 2305874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2305877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305908 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2305908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2305911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305925 */     // GIR_Coverage, 65409,
     /* 2305925 */     GIR_EraseRootFromParent_Done,
     /* 2305926 */   // Label 31618: @2305926
     /* 2305926 */   GIM_Try, /*On fail goto*//*Label 31619*/ GIMT_Encode4(2305983), // Rule ID 65416 //
     /* 2305931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2305934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2305946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2305950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2305965 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2305965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2305968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2305974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2305976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2305978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305982 */     // GIR_Coverage, 65416,
     /* 2305982 */     GIR_EraseRootFromParent_Done,
     /* 2305983 */   // Label 31619: @2305983
     /* 2305983 */   GIM_Try, /*On fail goto*//*Label 31620*/ GIMT_Encode4(2306040), // Rule ID 65417 //
     /* 2305988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2305991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306022 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2306025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306039 */     // GIR_Coverage, 65417,
     /* 2306039 */     GIR_EraseRootFromParent_Done,
     /* 2306040 */   // Label 31620: @2306040
     /* 2306040 */   GIM_Try, /*On fail goto*//*Label 31621*/ GIMT_Encode4(2306097), // Rule ID 1302 //
     /* 2306045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2306048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306079 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2306082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2306092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306096 */     // GIR_Coverage, 1302,
     /* 2306096 */     GIR_EraseRootFromParent_Done,
     /* 2306097 */   // Label 31621: @2306097
     /* 2306097 */   GIM_Try, /*On fail goto*//*Label 31622*/ GIMT_Encode4(2306154), // Rule ID 1303 //
     /* 2306102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2306105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306136 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2306139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2306149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306153 */     // GIR_Coverage, 1303,
     /* 2306153 */     GIR_EraseRootFromParent_Done,
     /* 2306154 */   // Label 31622: @2306154
     /* 2306154 */   GIM_Try, /*On fail goto*//*Label 31623*/ GIMT_Encode4(2306211), // Rule ID 1323 //
     /* 2306159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2306162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306193 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2306196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2306206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306210 */     // GIR_Coverage, 1323,
     /* 2306210 */     GIR_EraseRootFromParent_Done,
     /* 2306211 */   // Label 31623: @2306211
     /* 2306211 */   GIM_Try, /*On fail goto*//*Label 31624*/ GIMT_Encode4(2306268), // Rule ID 1324 //
     /* 2306216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2306219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2306235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2306243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2306250 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2306253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2306263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306267 */     // GIR_Coverage, 1324,
     /* 2306267 */     GIR_EraseRootFromParent_Done,
     /* 2306268 */   // Label 31624: @2306268
     /* 2306268 */   GIM_Try, /*On fail goto*//*Label 31625*/ GIMT_Encode4(2306308), // Rule ID 1298 //
     /* 2306273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2306276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306292 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2306295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306307 */     // GIR_Coverage, 1298,
     /* 2306307 */     GIR_EraseRootFromParent_Done,
     /* 2306308 */   // Label 31625: @2306308
     /* 2306308 */   GIM_Try, /*On fail goto*//*Label 31626*/ GIMT_Encode4(2306348), // Rule ID 1299 //
     /* 2306313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2306316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2306332 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2306335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306347 */     // GIR_Coverage, 1299,
     /* 2306347 */     GIR_EraseRootFromParent_Done,
     /* 2306348 */   // Label 31626: @2306348
     /* 2306348 */   GIM_Try, /*On fail goto*//*Label 31627*/ GIMT_Encode4(2306388), // Rule ID 1319 //
     /* 2306353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2306356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306372 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2306372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2306375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306387 */     // GIR_Coverage, 1319,
     /* 2306387 */     GIR_EraseRootFromParent_Done,
     /* 2306388 */   // Label 31627: @2306388
     /* 2306388 */   GIM_Try, /*On fail goto*//*Label 31628*/ GIMT_Encode4(2306428), // Rule ID 1320 //
     /* 2306393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2306396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2306412 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2306412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2306415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2306423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306427 */     // GIR_Coverage, 1320,
     /* 2306427 */     GIR_EraseRootFromParent_Done,
     /* 2306428 */   // Label 31628: @2306428
     /* 2306428 */   GIM_Reject,
     /* 2306429 */ // Label 31604: @2306429
     /* 2306429 */ GIM_Reject,
     /* 2306430 */ // Label 31562: @2306430
     /* 2306430 */ GIM_Try, /*On fail goto*//*Label 31629*/ GIMT_Encode4(2308220),
     /* 2306435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2306441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2306444 */   GIM_Try, /*On fail goto*//*Label 31630*/ GIMT_Encode4(2306516), // Rule ID 1647 //
     /* 2306449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2306452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306496 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2306496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2306499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306515 */     // GIR_Coverage, 1647,
     /* 2306515 */     GIR_EraseRootFromParent_Done,
     /* 2306516 */   // Label 31630: @2306516
     /* 2306516 */   GIM_Try, /*On fail goto*//*Label 31631*/ GIMT_Encode4(2306588), // Rule ID 1648 //
     /* 2306521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2306524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306568 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2306568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2306571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306587 */     // GIR_Coverage, 1648,
     /* 2306587 */     GIR_EraseRootFromParent_Done,
     /* 2306588 */   // Label 31631: @2306588
     /* 2306588 */   GIM_Try, /*On fail goto*//*Label 31632*/ GIMT_Encode4(2306660), // Rule ID 1670 //
     /* 2306593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2306596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2306600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2306617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2306621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2306638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306640 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2306640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2306643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306659 */     // GIR_Coverage, 1670,
     /* 2306659 */     GIR_EraseRootFromParent_Done,
     /* 2306660 */   // Label 31632: @2306660
     /* 2306660 */   GIM_Try, /*On fail goto*//*Label 31633*/ GIMT_Encode4(2306732), // Rule ID 1702 //
     /* 2306665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2306668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2306672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2306689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2306693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2306710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306712 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2306712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2306715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306731 */     // GIR_Coverage, 1702,
     /* 2306731 */     GIR_EraseRootFromParent_Done,
     /* 2306732 */   // Label 31633: @2306732
     /* 2306732 */   GIM_Try, /*On fail goto*//*Label 31634*/ GIMT_Encode4(2306804), // Rule ID 1703 //
     /* 2306737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2306740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2306744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2306748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2306761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2306765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2306782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306784 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2306784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2306787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306803 */     // GIR_Coverage, 1703,
     /* 2306803 */     GIR_EraseRootFromParent_Done,
     /* 2306804 */   // Label 31634: @2306804
     /* 2306804 */   GIM_Try, /*On fail goto*//*Label 31635*/ GIMT_Encode4(2306876), // Rule ID 65428 //
     /* 2306809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2306812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306856 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2306856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2306859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306875 */     // GIR_Coverage, 65428,
     /* 2306875 */     GIR_EraseRootFromParent_Done,
     /* 2306876 */   // Label 31635: @2306876
     /* 2306876 */   GIM_Try, /*On fail goto*//*Label 31636*/ GIMT_Encode4(2306948), // Rule ID 65429 //
     /* 2306881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2306884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2306926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2306928 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2306928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2306931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2306937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2306939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2306943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306947 */     // GIR_Coverage, 65429,
     /* 2306947 */     GIR_EraseRootFromParent_Done,
     /* 2306948 */   // Label 31636: @2306948
     /* 2306948 */   GIM_Try, /*On fail goto*//*Label 31637*/ GIMT_Encode4(2307020), // Rule ID 65433 //
     /* 2306953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2306956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2306960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2306964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2306968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2306981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2306985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2306989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2306993 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2306998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307000 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2307003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307019 */     // GIR_Coverage, 65433,
     /* 2307019 */     GIR_EraseRootFromParent_Done,
     /* 2307020 */   // Label 31637: @2307020
     /* 2307020 */   GIM_Try, /*On fail goto*//*Label 31638*/ GIMT_Encode4(2307092), // Rule ID 65440 //
     /* 2307025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2307028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307065 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307072 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2307075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307091 */     // GIR_Coverage, 65440,
     /* 2307091 */     GIR_EraseRootFromParent_Done,
     /* 2307092 */   // Label 31638: @2307092
     /* 2307092 */   GIM_Try, /*On fail goto*//*Label 31639*/ GIMT_Encode4(2307164), // Rule ID 65441 //
     /* 2307097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2307100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2307129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2307144 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2307147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2307159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307163 */     // GIR_Coverage, 65441,
     /* 2307163 */     GIR_EraseRootFromParent_Done,
     /* 2307164 */   // Label 31639: @2307164
     /* 2307164 */   GIM_Try, /*On fail goto*//*Label 31640*/ GIMT_Encode4(2307221), // Rule ID 1643 //
     /* 2307169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2307172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307203 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2307206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307220 */     // GIR_Coverage, 1643,
     /* 2307220 */     GIR_EraseRootFromParent_Done,
     /* 2307221 */   // Label 31640: @2307221
     /* 2307221 */   GIM_Try, /*On fail goto*//*Label 31641*/ GIMT_Encode4(2307278), // Rule ID 1644 //
     /* 2307226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2307229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307260 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2307263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307277 */     // GIR_Coverage, 1644,
     /* 2307277 */     GIR_EraseRootFromParent_Done,
     /* 2307278 */   // Label 31641: @2307278
     /* 2307278 */   GIM_Try, /*On fail goto*//*Label 31642*/ GIMT_Encode4(2307335), // Rule ID 1668 //
     /* 2307283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307317 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2307320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307334 */     // GIR_Coverage, 1668,
     /* 2307334 */     GIR_EraseRootFromParent_Done,
     /* 2307335 */   // Label 31642: @2307335
     /* 2307335 */   GIM_Try, /*On fail goto*//*Label 31643*/ GIMT_Encode4(2307392), // Rule ID 1698 //
     /* 2307340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2307343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307374 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2307377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307391 */     // GIR_Coverage, 1698,
     /* 2307391 */     GIR_EraseRootFromParent_Done,
     /* 2307392 */   // Label 31643: @2307392
     /* 2307392 */   GIM_Try, /*On fail goto*//*Label 31644*/ GIMT_Encode4(2307449), // Rule ID 1699 //
     /* 2307397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2307400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2307408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307431 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2307434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307448 */     // GIR_Coverage, 1699,
     /* 2307448 */     GIR_EraseRootFromParent_Done,
     /* 2307449 */   // Label 31644: @2307449
     /* 2307449 */   GIM_Try, /*On fail goto*//*Label 31645*/ GIMT_Encode4(2307506), // Rule ID 65424 //
     /* 2307454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2307457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307488 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2307491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307505 */     // GIR_Coverage, 65424,
     /* 2307505 */     GIR_EraseRootFromParent_Done,
     /* 2307506 */   // Label 31645: @2307506
     /* 2307506 */   GIM_Try, /*On fail goto*//*Label 31646*/ GIMT_Encode4(2307563), // Rule ID 65425 //
     /* 2307511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2307514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307545 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2307548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307562 */     // GIR_Coverage, 65425,
     /* 2307562 */     GIR_EraseRootFromParent_Done,
     /* 2307563 */   // Label 31646: @2307563
     /* 2307563 */   GIM_Try, /*On fail goto*//*Label 31647*/ GIMT_Encode4(2307620), // Rule ID 65431 //
     /* 2307568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307602 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2307605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307619 */     // GIR_Coverage, 65431,
     /* 2307619 */     GIR_EraseRootFromParent_Done,
     /* 2307620 */   // Label 31647: @2307620
     /* 2307620 */   GIM_Try, /*On fail goto*//*Label 31648*/ GIMT_Encode4(2307677), // Rule ID 65436 //
     /* 2307625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2307628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307659 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2307662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307676 */     // GIR_Coverage, 65436,
     /* 2307676 */     GIR_EraseRootFromParent_Done,
     /* 2307677 */   // Label 31648: @2307677
     /* 2307677 */   GIM_Try, /*On fail goto*//*Label 31649*/ GIMT_Encode4(2307734), // Rule ID 65437 //
     /* 2307682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2307685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2307697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307716 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2307719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2307725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2307727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2307729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307733 */     // GIR_Coverage, 65437,
     /* 2307733 */     GIR_EraseRootFromParent_Done,
     /* 2307734 */   // Label 31649: @2307734
     /* 2307734 */   GIM_Try, /*On fail goto*//*Label 31650*/ GIMT_Encode4(2307791), // Rule ID 1639 //
     /* 2307739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2307742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307773 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2307776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2307786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307790 */     // GIR_Coverage, 1639,
     /* 2307790 */     GIR_EraseRootFromParent_Done,
     /* 2307791 */   // Label 31650: @2307791
     /* 2307791 */   GIM_Try, /*On fail goto*//*Label 31651*/ GIMT_Encode4(2307848), // Rule ID 1640 //
     /* 2307796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2307799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307830 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2307830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2307833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2307843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307847 */     // GIR_Coverage, 1640,
     /* 2307847 */     GIR_EraseRootFromParent_Done,
     /* 2307848 */   // Label 31651: @2307848
     /* 2307848 */   GIM_Try, /*On fail goto*//*Label 31652*/ GIMT_Encode4(2307905), // Rule ID 1666 //
     /* 2307853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307887 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2307890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2307900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307904 */     // GIR_Coverage, 1666,
     /* 2307904 */     GIR_EraseRootFromParent_Done,
     /* 2307905 */   // Label 31652: @2307905
     /* 2307905 */   GIM_Try, /*On fail goto*//*Label 31653*/ GIMT_Encode4(2307962), // Rule ID 1694 //
     /* 2307910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2307913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2307944 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2307944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2307947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2307957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307961 */     // GIR_Coverage, 1694,
     /* 2307961 */     GIR_EraseRootFromParent_Done,
     /* 2307962 */   // Label 31653: @2307962
     /* 2307962 */   GIM_Try, /*On fail goto*//*Label 31654*/ GIMT_Encode4(2308019), // Rule ID 1695 //
     /* 2307967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2307970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2307986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2307990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308001 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2308001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2308004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2308014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308018 */     // GIR_Coverage, 1695,
     /* 2308018 */     GIR_EraseRootFromParent_Done,
     /* 2308019 */   // Label 31654: @2308019
     /* 2308019 */   GIM_Try, /*On fail goto*//*Label 31655*/ GIMT_Encode4(2308059), // Rule ID 1635 //
     /* 2308024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2308027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308043 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2308046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308058 */     // GIR_Coverage, 1635,
     /* 2308058 */     GIR_EraseRootFromParent_Done,
     /* 2308059 */   // Label 31655: @2308059
     /* 2308059 */   GIM_Try, /*On fail goto*//*Label 31656*/ GIMT_Encode4(2308099), // Rule ID 1636 //
     /* 2308064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2308067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2308083 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2308083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2308086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308098 */     // GIR_Coverage, 1636,
     /* 2308098 */     GIR_EraseRootFromParent_Done,
     /* 2308099 */   // Label 31656: @2308099
     /* 2308099 */   GIM_Try, /*On fail goto*//*Label 31657*/ GIMT_Encode4(2308139), // Rule ID 1664 //
     /* 2308104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2308107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2308123 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2308126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308138 */     // GIR_Coverage, 1664,
     /* 2308138 */     GIR_EraseRootFromParent_Done,
     /* 2308139 */   // Label 31657: @2308139
     /* 2308139 */   GIM_Try, /*On fail goto*//*Label 31658*/ GIMT_Encode4(2308179), // Rule ID 1690 //
     /* 2308144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2308147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308163 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2308163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2308166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308178 */     // GIR_Coverage, 1690,
     /* 2308178 */     GIR_EraseRootFromParent_Done,
     /* 2308179 */   // Label 31658: @2308179
     /* 2308179 */   GIM_Try, /*On fail goto*//*Label 31659*/ GIMT_Encode4(2308219), // Rule ID 1691 //
     /* 2308184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2308187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2308203 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2308203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2308206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2308212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2308214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308218 */     // GIR_Coverage, 1691,
     /* 2308218 */     GIR_EraseRootFromParent_Done,
     /* 2308219 */   // Label 31659: @2308219
     /* 2308219 */   GIM_Reject,
     /* 2308220 */ // Label 31629: @2308220
     /* 2308220 */ GIM_Reject,
     /* 2308221 */ // Label 31563: @2308221
     /* 2308221 */ GIM_Try, /*On fail goto*//*Label 31660*/ GIMT_Encode4(2309010),
     /* 2308226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2308232 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2308235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308239 */   GIM_Try, /*On fail goto*//*Label 31661*/ GIMT_Encode4(2308316), // Rule ID 54836 //
     /* 2308244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308276 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308287 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2308290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308315 */     // GIR_Coverage, 54836,
     /* 2308315 */     GIR_EraseRootFromParent_Done,
     /* 2308316 */   // Label 31661: @2308316
     /* 2308316 */   GIM_Try, /*On fail goto*//*Label 31662*/ GIMT_Encode4(2308393), // Rule ID 54837 //
     /* 2308321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308364 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2308367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308392 */     // GIR_Coverage, 54837,
     /* 2308392 */     GIR_EraseRootFromParent_Done,
     /* 2308393 */   // Label 31662: @2308393
     /* 2308393 */   GIM_Try, /*On fail goto*//*Label 31663*/ GIMT_Encode4(2308470), // Rule ID 72412 //
     /* 2308398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308441 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2308444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308469 */     // GIR_Coverage, 72412,
     /* 2308469 */     GIR_EraseRootFromParent_Done,
     /* 2308470 */   // Label 31663: @2308470
     /* 2308470 */   GIM_Try, /*On fail goto*//*Label 31664*/ GIMT_Encode4(2308547), // Rule ID 72413 //
     /* 2308475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2308503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2308518 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2308521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2308533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308546 */     // GIR_Coverage, 72413,
     /* 2308546 */     GIR_EraseRootFromParent_Done,
     /* 2308547 */   // Label 31664: @2308547
     /* 2308547 */   GIM_Try, /*On fail goto*//*Label 31665*/ GIMT_Encode4(2308609), // Rule ID 54840 //
     /* 2308552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308582 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2308585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308608 */     // GIR_Coverage, 54840,
     /* 2308608 */     GIR_EraseRootFromParent_Done,
     /* 2308609 */   // Label 31665: @2308609
     /* 2308609 */   GIM_Try, /*On fail goto*//*Label 31666*/ GIMT_Encode4(2308671), // Rule ID 54841 //
     /* 2308614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2308621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308644 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2308647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308670 */     // GIR_Coverage, 54841,
     /* 2308670 */     GIR_EraseRootFromParent_Done,
     /* 2308671 */   // Label 31666: @2308671
     /* 2308671 */   GIM_Try, /*On fail goto*//*Label 31667*/ GIMT_Encode4(2308733), // Rule ID 72416 //
     /* 2308676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308706 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2308709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308732 */     // GIR_Coverage, 72416,
     /* 2308732 */     GIR_EraseRootFromParent_Done,
     /* 2308733 */   // Label 31667: @2308733
     /* 2308733 */   GIM_Try, /*On fail goto*//*Label 31668*/ GIMT_Encode4(2308795), // Rule ID 72417 //
     /* 2308738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2308749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308768 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2308771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2308775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2308779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308794 */     // GIR_Coverage, 72417,
     /* 2308794 */     GIR_EraseRootFromParent_Done,
     /* 2308795 */   // Label 31668: @2308795
     /* 2308795 */   GIM_Try, /*On fail goto*//*Label 31669*/ GIMT_Encode4(2308857), // Rule ID 54832 //
     /* 2308800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308830 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2308833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2308843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308856 */     // GIR_Coverage, 54832,
     /* 2308856 */     GIR_EraseRootFromParent_Done,
     /* 2308857 */   // Label 31669: @2308857
     /* 2308857 */   GIM_Try, /*On fail goto*//*Label 31670*/ GIMT_Encode4(2308919), // Rule ID 54833 //
     /* 2308862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2308877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2308881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2308885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2308892 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2308895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2308905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308918 */     // GIR_Coverage, 54833,
     /* 2308918 */     GIR_EraseRootFromParent_Done,
     /* 2308919 */   // Label 31670: @2308919
     /* 2308919 */   GIM_Try, /*On fail goto*//*Label 31671*/ GIMT_Encode4(2308964), // Rule ID 54828 //
     /* 2308924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308939 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2308939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2308942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2308962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308963 */     // GIR_Coverage, 54828,
     /* 2308963 */     GIR_EraseRootFromParent_Done,
     /* 2308964 */   // Label 31671: @2308964
     /* 2308964 */   GIM_Try, /*On fail goto*//*Label 31672*/ GIMT_Encode4(2309009), // Rule ID 54829 //
     /* 2308969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308984 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2308984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2308987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2308991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2308993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2308995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2308998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309008 */     // GIR_Coverage, 54829,
     /* 2309008 */     GIR_EraseRootFromParent_Done,
     /* 2309009 */   // Label 31672: @2309009
     /* 2309009 */   GIM_Reject,
     /* 2309010 */ // Label 31660: @2309010
     /* 2309010 */ GIM_Reject,
     /* 2309011 */ // Label 31564: @2309011
     /* 2309011 */ GIM_Try, /*On fail goto*//*Label 31673*/ GIMT_Encode4(2309800),
     /* 2309016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2309022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2309025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309029 */   GIM_Try, /*On fail goto*//*Label 31674*/ GIMT_Encode4(2309106), // Rule ID 54964 //
     /* 2309034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309070 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309077 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2309080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309105 */     // GIR_Coverage, 54964,
     /* 2309105 */     GIR_EraseRootFromParent_Done,
     /* 2309106 */   // Label 31674: @2309106
     /* 2309106 */   GIM_Try, /*On fail goto*//*Label 31675*/ GIMT_Encode4(2309183), // Rule ID 54965 //
     /* 2309111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309154 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2309157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309182 */     // GIR_Coverage, 54965,
     /* 2309182 */     GIR_EraseRootFromParent_Done,
     /* 2309183 */   // Label 31675: @2309183
     /* 2309183 */   GIM_Try, /*On fail goto*//*Label 31676*/ GIMT_Encode4(2309260), // Rule ID 72524 //
     /* 2309188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309231 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2309234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309259 */     // GIR_Coverage, 72524,
     /* 2309259 */     GIR_EraseRootFromParent_Done,
     /* 2309260 */   // Label 31676: @2309260
     /* 2309260 */   GIM_Try, /*On fail goto*//*Label 31677*/ GIMT_Encode4(2309337), // Rule ID 72525 //
     /* 2309265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309308 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2309311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309336 */     // GIR_Coverage, 72525,
     /* 2309336 */     GIR_EraseRootFromParent_Done,
     /* 2309337 */   // Label 31677: @2309337
     /* 2309337 */   GIM_Try, /*On fail goto*//*Label 31678*/ GIMT_Encode4(2309399), // Rule ID 54968 //
     /* 2309342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309372 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2309375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309398 */     // GIR_Coverage, 54968,
     /* 2309398 */     GIR_EraseRootFromParent_Done,
     /* 2309399 */   // Label 31678: @2309399
     /* 2309399 */   GIM_Try, /*On fail goto*//*Label 31679*/ GIMT_Encode4(2309461), // Rule ID 54969 //
     /* 2309404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309434 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2309437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309460 */     // GIR_Coverage, 54969,
     /* 2309460 */     GIR_EraseRootFromParent_Done,
     /* 2309461 */   // Label 31679: @2309461
     /* 2309461 */   GIM_Try, /*On fail goto*//*Label 31680*/ GIMT_Encode4(2309523), // Rule ID 72528 //
     /* 2309466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309496 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2309499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309522 */     // GIR_Coverage, 72528,
     /* 2309522 */     GIR_EraseRootFromParent_Done,
     /* 2309523 */   // Label 31680: @2309523
     /* 2309523 */   GIM_Try, /*On fail goto*//*Label 31681*/ GIMT_Encode4(2309585), // Rule ID 72529 //
     /* 2309528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309558 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2309561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2309565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309584 */     // GIR_Coverage, 72529,
     /* 2309584 */     GIR_EraseRootFromParent_Done,
     /* 2309585 */   // Label 31681: @2309585
     /* 2309585 */   GIM_Try, /*On fail goto*//*Label 31682*/ GIMT_Encode4(2309647), // Rule ID 54960 //
     /* 2309590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309620 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2309623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2309633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309646 */     // GIR_Coverage, 54960,
     /* 2309646 */     GIR_EraseRootFromParent_Done,
     /* 2309647 */   // Label 31682: @2309647
     /* 2309647 */   GIM_Try, /*On fail goto*//*Label 31683*/ GIMT_Encode4(2309709), // Rule ID 54961 //
     /* 2309652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2309667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2309675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2309682 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2309685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2309695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309708 */     // GIR_Coverage, 54961,
     /* 2309708 */     GIR_EraseRootFromParent_Done,
     /* 2309709 */   // Label 31683: @2309709
     /* 2309709 */   GIM_Try, /*On fail goto*//*Label 31684*/ GIMT_Encode4(2309754), // Rule ID 54956 //
     /* 2309714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2309717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309729 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2309732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309753 */     // GIR_Coverage, 54956,
     /* 2309753 */     GIR_EraseRootFromParent_Done,
     /* 2309754 */   // Label 31684: @2309754
     /* 2309754 */   GIM_Try, /*On fail goto*//*Label 31685*/ GIMT_Encode4(2309799), // Rule ID 54957 //
     /* 2309759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309774 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2309777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2309785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309798 */     // GIR_Coverage, 54957,
     /* 2309798 */     GIR_EraseRootFromParent_Done,
     /* 2309799 */   // Label 31685: @2309799
     /* 2309799 */   GIM_Reject,
     /* 2309800 */ // Label 31673: @2309800
     /* 2309800 */ GIM_Reject,
     /* 2309801 */ // Label 31565: @2309801
     /* 2309801 */ GIM_Try, /*On fail goto*//*Label 31686*/ GIMT_Encode4(2310590),
     /* 2309806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2309809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2309812 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2309815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309819 */   GIM_Try, /*On fail goto*//*Label 31687*/ GIMT_Encode4(2309896), // Rule ID 55156 //
     /* 2309824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2309827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2309839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2309860 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309867 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2309867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2309870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309895 */     // GIR_Coverage, 55156,
     /* 2309895 */     GIR_EraseRootFromParent_Done,
     /* 2309896 */   // Label 31687: @2309896
     /* 2309896 */   GIM_Try, /*On fail goto*//*Label 31688*/ GIMT_Encode4(2309973), // Rule ID 55157 //
     /* 2309901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2309904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2309908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2309916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2309929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2309937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2309944 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2309944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2309947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2309951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2309955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2309959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2309968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2309971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309972 */     // GIR_Coverage, 55157,
     /* 2309972 */     GIR_EraseRootFromParent_Done,
     /* 2309973 */   // Label 31688: @2309973
     /* 2309973 */   GIM_Try, /*On fail goto*//*Label 31689*/ GIMT_Encode4(2310050), // Rule ID 72692 //
     /* 2309978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2309981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2309985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2309989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2309993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2309997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310021 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2310024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310049 */     // GIR_Coverage, 72692,
     /* 2310049 */     GIR_EraseRootFromParent_Done,
     /* 2310050 */   // Label 31689: @2310050
     /* 2310050 */   GIM_Try, /*On fail goto*//*Label 31690*/ GIMT_Encode4(2310127), // Rule ID 72693 //
     /* 2310055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310098 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2310101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310126 */     // GIR_Coverage, 72693,
     /* 2310126 */     GIR_EraseRootFromParent_Done,
     /* 2310127 */   // Label 31690: @2310127
     /* 2310127 */   GIM_Try, /*On fail goto*//*Label 31691*/ GIMT_Encode4(2310189), // Rule ID 55160 //
     /* 2310132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310162 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2310165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310188 */     // GIR_Coverage, 55160,
     /* 2310188 */     GIR_EraseRootFromParent_Done,
     /* 2310189 */   // Label 31691: @2310189
     /* 2310189 */   GIM_Try, /*On fail goto*//*Label 31692*/ GIMT_Encode4(2310251), // Rule ID 55161 //
     /* 2310194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310224 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2310227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310250 */     // GIR_Coverage, 55161,
     /* 2310250 */     GIR_EraseRootFromParent_Done,
     /* 2310251 */   // Label 31692: @2310251
     /* 2310251 */   GIM_Try, /*On fail goto*//*Label 31693*/ GIMT_Encode4(2310313), // Rule ID 72696 //
     /* 2310256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310286 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2310289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310312 */     // GIR_Coverage, 72696,
     /* 2310312 */     GIR_EraseRootFromParent_Done,
     /* 2310313 */   // Label 31693: @2310313
     /* 2310313 */   GIM_Try, /*On fail goto*//*Label 31694*/ GIMT_Encode4(2310375), // Rule ID 72697 //
     /* 2310318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310348 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2310351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310374 */     // GIR_Coverage, 72697,
     /* 2310374 */     GIR_EraseRootFromParent_Done,
     /* 2310375 */   // Label 31694: @2310375
     /* 2310375 */   GIM_Try, /*On fail goto*//*Label 31695*/ GIMT_Encode4(2310437), // Rule ID 55152 //
     /* 2310380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310410 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2310413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2310423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310436 */     // GIR_Coverage, 55152,
     /* 2310436 */     GIR_EraseRootFromParent_Done,
     /* 2310437 */   // Label 31695: @2310437
     /* 2310437 */   GIM_Try, /*On fail goto*//*Label 31696*/ GIMT_Encode4(2310499), // Rule ID 55153 //
     /* 2310442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2310457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310472 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2310475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2310485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310498 */     // GIR_Coverage, 55153,
     /* 2310498 */     GIR_EraseRootFromParent_Done,
     /* 2310499 */   // Label 31696: @2310499
     /* 2310499 */   GIM_Try, /*On fail goto*//*Label 31697*/ GIMT_Encode4(2310544), // Rule ID 55148 //
     /* 2310504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2310507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310519 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2310522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310543 */     // GIR_Coverage, 55148,
     /* 2310543 */     GIR_EraseRootFromParent_Done,
     /* 2310544 */   // Label 31697: @2310544
     /* 2310544 */   GIM_Try, /*On fail goto*//*Label 31698*/ GIMT_Encode4(2310589), // Rule ID 55149 //
     /* 2310549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2310552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310564 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2310567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2310584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310588 */     // GIR_Coverage, 55149,
     /* 2310588 */     GIR_EraseRootFromParent_Done,
     /* 2310589 */   // Label 31698: @2310589
     /* 2310589 */   GIM_Reject,
     /* 2310590 */ // Label 31686: @2310590
     /* 2310590 */ GIM_Reject,
     /* 2310591 */ // Label 31566: @2310591
     /* 2310591 */ GIM_Try, /*On fail goto*//*Label 31699*/ GIMT_Encode4(2311380),
     /* 2310596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2310602 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2310605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310609 */   GIM_Try, /*On fail goto*//*Label 31700*/ GIMT_Encode4(2310686), // Rule ID 54900 //
     /* 2310614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2310617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310657 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2310660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310685 */     // GIR_Coverage, 54900,
     /* 2310685 */     GIR_EraseRootFromParent_Done,
     /* 2310686 */   // Label 31700: @2310686
     /* 2310686 */   GIM_Try, /*On fail goto*//*Label 31701*/ GIMT_Encode4(2310763), // Rule ID 54901 //
     /* 2310691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2310694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310734 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2310737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310762 */     // GIR_Coverage, 54901,
     /* 2310762 */     GIR_EraseRootFromParent_Done,
     /* 2310763 */   // Label 31701: @2310763
     /* 2310763 */   GIM_Try, /*On fail goto*//*Label 31702*/ GIMT_Encode4(2310840), // Rule ID 72468 //
     /* 2310768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2310771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310811 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2310814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310839 */     // GIR_Coverage, 72468,
     /* 2310839 */     GIR_EraseRootFromParent_Done,
     /* 2310840 */   // Label 31702: @2310840
     /* 2310840 */   GIM_Try, /*On fail goto*//*Label 31703*/ GIMT_Encode4(2310917), // Rule ID 72469 //
     /* 2310845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2310848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2310856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2310873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2310888 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2310888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2310891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2310895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2310903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310916 */     // GIR_Coverage, 72469,
     /* 2310916 */     GIR_EraseRootFromParent_Done,
     /* 2310917 */   // Label 31703: @2310917
     /* 2310917 */   GIM_Try, /*On fail goto*//*Label 31704*/ GIMT_Encode4(2310979), // Rule ID 54904 //
     /* 2310922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2310925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2310952 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2310952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2310955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2310959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2310963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2310965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2310977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310978 */     // GIR_Coverage, 54904,
     /* 2310978 */     GIR_EraseRootFromParent_Done,
     /* 2310979 */   // Label 31704: @2310979
     /* 2310979 */   GIM_Try, /*On fail goto*//*Label 31705*/ GIMT_Encode4(2311041), // Rule ID 54905 //
     /* 2310984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2310987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2310991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2310995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2310999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311014 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2311017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311040 */     // GIR_Coverage, 54905,
     /* 2311040 */     GIR_EraseRootFromParent_Done,
     /* 2311041 */   // Label 31705: @2311041
     /* 2311041 */   GIM_Try, /*On fail goto*//*Label 31706*/ GIMT_Encode4(2311103), // Rule ID 72472 //
     /* 2311046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311076 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2311079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311102 */     // GIR_Coverage, 72472,
     /* 2311102 */     GIR_EraseRootFromParent_Done,
     /* 2311103 */   // Label 31706: @2311103
     /* 2311103 */   GIM_Try, /*On fail goto*//*Label 31707*/ GIMT_Encode4(2311165), // Rule ID 72473 //
     /* 2311108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311138 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2311141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311164 */     // GIR_Coverage, 72473,
     /* 2311164 */     GIR_EraseRootFromParent_Done,
     /* 2311165 */   // Label 31707: @2311165
     /* 2311165 */   GIM_Try, /*On fail goto*//*Label 31708*/ GIMT_Encode4(2311227), // Rule ID 54896 //
     /* 2311170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311200 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2311203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2311213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311226 */     // GIR_Coverage, 54896,
     /* 2311226 */     GIR_EraseRootFromParent_Done,
     /* 2311227 */   // Label 31708: @2311227
     /* 2311227 */   GIM_Try, /*On fail goto*//*Label 31709*/ GIMT_Encode4(2311289), // Rule ID 54897 //
     /* 2311232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2311255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311262 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2311265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2311275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311288 */     // GIR_Coverage, 54897,
     /* 2311288 */     GIR_EraseRootFromParent_Done,
     /* 2311289 */   // Label 31709: @2311289
     /* 2311289 */   GIM_Try, /*On fail goto*//*Label 31710*/ GIMT_Encode4(2311334), // Rule ID 54892 //
     /* 2311294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2311297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311309 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2311312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311333 */     // GIR_Coverage, 54892,
     /* 2311333 */     GIR_EraseRootFromParent_Done,
     /* 2311334 */   // Label 31710: @2311334
     /* 2311334 */   GIM_Try, /*On fail goto*//*Label 31711*/ GIMT_Encode4(2311379), // Rule ID 54893 //
     /* 2311339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2311342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311354 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2311357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311378 */     // GIR_Coverage, 54893,
     /* 2311378 */     GIR_EraseRootFromParent_Done,
     /* 2311379 */   // Label 31711: @2311379
     /* 2311379 */   GIM_Reject,
     /* 2311380 */ // Label 31699: @2311380
     /* 2311380 */ GIM_Reject,
     /* 2311381 */ // Label 31567: @2311381
     /* 2311381 */ GIM_Try, /*On fail goto*//*Label 31712*/ GIMT_Encode4(2312170),
     /* 2311386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2311392 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2311395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311399 */   GIM_Try, /*On fail goto*//*Label 31713*/ GIMT_Encode4(2311476), // Rule ID 55092 //
     /* 2311404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311447 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2311450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311475 */     // GIR_Coverage, 55092,
     /* 2311475 */     GIR_EraseRootFromParent_Done,
     /* 2311476 */   // Label 31713: @2311476
     /* 2311476 */   GIM_Try, /*On fail goto*//*Label 31714*/ GIMT_Encode4(2311553), // Rule ID 55093 //
     /* 2311481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311524 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2311527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311552 */     // GIR_Coverage, 55093,
     /* 2311552 */     GIR_EraseRootFromParent_Done,
     /* 2311553 */   // Label 31714: @2311553
     /* 2311553 */   GIM_Try, /*On fail goto*//*Label 31715*/ GIMT_Encode4(2311630), // Rule ID 72636 //
     /* 2311558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311601 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2311604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311629 */     // GIR_Coverage, 72636,
     /* 2311629 */     GIR_EraseRootFromParent_Done,
     /* 2311630 */   // Label 31715: @2311630
     /* 2311630 */   GIM_Try, /*On fail goto*//*Label 31716*/ GIMT_Encode4(2311707), // Rule ID 72637 //
     /* 2311635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2311663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2311678 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2311681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2311693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311706 */     // GIR_Coverage, 72637,
     /* 2311706 */     GIR_EraseRootFromParent_Done,
     /* 2311707 */   // Label 31716: @2311707
     /* 2311707 */   GIM_Try, /*On fail goto*//*Label 31717*/ GIMT_Encode4(2311769), // Rule ID 55096 //
     /* 2311712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311742 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2311745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311768 */     // GIR_Coverage, 55096,
     /* 2311768 */     GIR_EraseRootFromParent_Done,
     /* 2311769 */   // Label 31717: @2311769
     /* 2311769 */   GIM_Try, /*On fail goto*//*Label 31718*/ GIMT_Encode4(2311831), // Rule ID 55097 //
     /* 2311774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2311781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311804 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2311807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311830 */     // GIR_Coverage, 55097,
     /* 2311830 */     GIR_EraseRootFromParent_Done,
     /* 2311831 */   // Label 31718: @2311831
     /* 2311831 */   GIM_Try, /*On fail goto*//*Label 31719*/ GIMT_Encode4(2311893), // Rule ID 72640 //
     /* 2311836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311866 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2311869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311892 */     // GIR_Coverage, 72640,
     /* 2311892 */     GIR_EraseRootFromParent_Done,
     /* 2311893 */   // Label 31719: @2311893
     /* 2311893 */   GIM_Try, /*On fail goto*//*Label 31720*/ GIMT_Encode4(2311955), // Rule ID 72641 //
     /* 2311898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2311901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2311909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311928 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2311928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2311931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2311935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2311939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2311941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311954 */     // GIR_Coverage, 72641,
     /* 2311954 */     GIR_EraseRootFromParent_Done,
     /* 2311955 */   // Label 31720: @2311955
     /* 2311955 */   GIM_Try, /*On fail goto*//*Label 31721*/ GIMT_Encode4(2312017), // Rule ID 55088 //
     /* 2311960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2311963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2311975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2311979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2311983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2311990 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2311990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2311993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2311997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2312003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312016 */     // GIR_Coverage, 55088,
     /* 2312016 */     GIR_EraseRootFromParent_Done,
     /* 2312017 */   // Label 31721: @2312017
     /* 2312017 */   GIM_Try, /*On fail goto*//*Label 31722*/ GIMT_Encode4(2312079), // Rule ID 55089 //
     /* 2312022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312052 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2312055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2312065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312078 */     // GIR_Coverage, 55089,
     /* 2312078 */     GIR_EraseRootFromParent_Done,
     /* 2312079 */   // Label 31722: @2312079
     /* 2312079 */   GIM_Try, /*On fail goto*//*Label 31723*/ GIMT_Encode4(2312124), // Rule ID 55084 //
     /* 2312084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2312087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312099 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2312102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312123 */     // GIR_Coverage, 55084,
     /* 2312123 */     GIR_EraseRootFromParent_Done,
     /* 2312124 */   // Label 31723: @2312124
     /* 2312124 */   GIM_Try, /*On fail goto*//*Label 31724*/ GIMT_Encode4(2312169), // Rule ID 55085 //
     /* 2312129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2312132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312144 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2312147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312168 */     // GIR_Coverage, 55085,
     /* 2312168 */     GIR_EraseRootFromParent_Done,
     /* 2312169 */   // Label 31724: @2312169
     /* 2312169 */   GIM_Reject,
     /* 2312170 */ // Label 31712: @2312170
     /* 2312170 */ GIM_Reject,
     /* 2312171 */ // Label 31568: @2312171
     /* 2312171 */ GIM_Try, /*On fail goto*//*Label 31725*/ GIMT_Encode4(2312960),
     /* 2312176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312179 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2312182 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2312185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312189 */   GIM_Try, /*On fail goto*//*Label 31726*/ GIMT_Encode4(2312266), // Rule ID 55604 //
     /* 2312194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312237 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2312240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312265 */     // GIR_Coverage, 55604,
     /* 2312265 */     GIR_EraseRootFromParent_Done,
     /* 2312266 */   // Label 31726: @2312266
     /* 2312266 */   GIM_Try, /*On fail goto*//*Label 31727*/ GIMT_Encode4(2312343), // Rule ID 55605 //
     /* 2312271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312314 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2312317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312342 */     // GIR_Coverage, 55605,
     /* 2312342 */     GIR_EraseRootFromParent_Done,
     /* 2312343 */   // Label 31727: @2312343
     /* 2312343 */   GIM_Try, /*On fail goto*//*Label 31728*/ GIMT_Encode4(2312420), // Rule ID 73084 //
     /* 2312348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312391 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2312394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312419 */     // GIR_Coverage, 73084,
     /* 2312419 */     GIR_EraseRootFromParent_Done,
     /* 2312420 */   // Label 31728: @2312420
     /* 2312420 */   GIM_Try, /*On fail goto*//*Label 31729*/ GIMT_Encode4(2312497), // Rule ID 73085 //
     /* 2312425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2312453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2312468 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2312471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2312483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312496 */     // GIR_Coverage, 73085,
     /* 2312496 */     GIR_EraseRootFromParent_Done,
     /* 2312497 */   // Label 31729: @2312497
     /* 2312497 */   GIM_Try, /*On fail goto*//*Label 31730*/ GIMT_Encode4(2312559), // Rule ID 55608 //
     /* 2312502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312532 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2312535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312558 */     // GIR_Coverage, 55608,
     /* 2312558 */     GIR_EraseRootFromParent_Done,
     /* 2312559 */   // Label 31730: @2312559
     /* 2312559 */   GIM_Try, /*On fail goto*//*Label 31731*/ GIMT_Encode4(2312621), // Rule ID 55609 //
     /* 2312564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312594 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2312597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312620 */     // GIR_Coverage, 55609,
     /* 2312620 */     GIR_EraseRootFromParent_Done,
     /* 2312621 */   // Label 31731: @2312621
     /* 2312621 */   GIM_Try, /*On fail goto*//*Label 31732*/ GIMT_Encode4(2312683), // Rule ID 73088 //
     /* 2312626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312656 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2312659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312682 */     // GIR_Coverage, 73088,
     /* 2312682 */     GIR_EraseRootFromParent_Done,
     /* 2312683 */   // Label 31732: @2312683
     /* 2312683 */   GIM_Try, /*On fail goto*//*Label 31733*/ GIMT_Encode4(2312745), // Rule ID 73089 //
     /* 2312688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2312699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312718 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2312721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2312725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2312729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312744 */     // GIR_Coverage, 73089,
     /* 2312744 */     GIR_EraseRootFromParent_Done,
     /* 2312745 */   // Label 31733: @2312745
     /* 2312745 */   GIM_Try, /*On fail goto*//*Label 31734*/ GIMT_Encode4(2312807), // Rule ID 55600 //
     /* 2312750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312780 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2312783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2312793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312806 */     // GIR_Coverage, 55600,
     /* 2312806 */     GIR_EraseRootFromParent_Done,
     /* 2312807 */   // Label 31734: @2312807
     /* 2312807 */   GIM_Try, /*On fail goto*//*Label 31735*/ GIMT_Encode4(2312869), // Rule ID 55601 //
     /* 2312812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2312827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2312835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2312842 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2312845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2312855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312868 */     // GIR_Coverage, 55601,
     /* 2312868 */     GIR_EraseRootFromParent_Done,
     /* 2312869 */   // Label 31735: @2312869
     /* 2312869 */   GIM_Try, /*On fail goto*//*Label 31736*/ GIMT_Encode4(2312914), // Rule ID 55596 //
     /* 2312874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2312877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312889 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2312889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2312892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312913 */     // GIR_Coverage, 55596,
     /* 2312913 */     GIR_EraseRootFromParent_Done,
     /* 2312914 */   // Label 31736: @2312914
     /* 2312914 */   GIM_Try, /*On fail goto*//*Label 31737*/ GIMT_Encode4(2312959), // Rule ID 55597 //
     /* 2312919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2312922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2312934 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2312934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2312937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2312941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2312945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2312948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2312957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312958 */     // GIR_Coverage, 55597,
     /* 2312958 */     GIR_EraseRootFromParent_Done,
     /* 2312959 */   // Label 31737: @2312959
     /* 2312959 */   GIM_Reject,
     /* 2312960 */ // Label 31725: @2312960
     /* 2312960 */ GIM_Reject,
     /* 2312961 */ // Label 31569: @2312961
     /* 2312961 */ GIM_Try, /*On fail goto*//*Label 31738*/ GIMT_Encode4(2313750),
     /* 2312966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2312969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2312972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2312975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312979 */   GIM_Try, /*On fail goto*//*Label 31739*/ GIMT_Encode4(2313056), // Rule ID 55028 //
     /* 2312984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2312987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2312991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2312995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2312999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313027 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2313030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313055 */     // GIR_Coverage, 55028,
     /* 2313055 */     GIR_EraseRootFromParent_Done,
     /* 2313056 */   // Label 31739: @2313056
     /* 2313056 */   GIM_Try, /*On fail goto*//*Label 31740*/ GIMT_Encode4(2313133), // Rule ID 55029 //
     /* 2313061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313104 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2313107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313132 */     // GIR_Coverage, 55029,
     /* 2313132 */     GIR_EraseRootFromParent_Done,
     /* 2313133 */   // Label 31740: @2313133
     /* 2313133 */   GIM_Try, /*On fail goto*//*Label 31741*/ GIMT_Encode4(2313210), // Rule ID 72580 //
     /* 2313138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313181 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2313184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313209 */     // GIR_Coverage, 72580,
     /* 2313209 */     GIR_EraseRootFromParent_Done,
     /* 2313210 */   // Label 31741: @2313210
     /* 2313210 */   GIM_Try, /*On fail goto*//*Label 31742*/ GIMT_Encode4(2313287), // Rule ID 72581 //
     /* 2313215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313239 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313243 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313247 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313258 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2313261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313286 */     // GIR_Coverage, 72581,
     /* 2313286 */     GIR_EraseRootFromParent_Done,
     /* 2313287 */   // Label 31742: @2313287
     /* 2313287 */   GIM_Try, /*On fail goto*//*Label 31743*/ GIMT_Encode4(2313349), // Rule ID 55032 //
     /* 2313292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313322 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2313325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313348 */     // GIR_Coverage, 55032,
     /* 2313348 */     GIR_EraseRootFromParent_Done,
     /* 2313349 */   // Label 31743: @2313349
     /* 2313349 */   GIM_Try, /*On fail goto*//*Label 31744*/ GIMT_Encode4(2313411), // Rule ID 55033 //
     /* 2313354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313384 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2313387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313410 */     // GIR_Coverage, 55033,
     /* 2313410 */     GIR_EraseRootFromParent_Done,
     /* 2313411 */   // Label 31744: @2313411
     /* 2313411 */   GIM_Try, /*On fail goto*//*Label 31745*/ GIMT_Encode4(2313473), // Rule ID 72584 //
     /* 2313416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313446 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2313449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313472 */     // GIR_Coverage, 72584,
     /* 2313472 */     GIR_EraseRootFromParent_Done,
     /* 2313473 */   // Label 31745: @2313473
     /* 2313473 */   GIM_Try, /*On fail goto*//*Label 31746*/ GIMT_Encode4(2313535), // Rule ID 72585 //
     /* 2313478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313508 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2313511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313534 */     // GIR_Coverage, 72585,
     /* 2313534 */     GIR_EraseRootFromParent_Done,
     /* 2313535 */   // Label 31746: @2313535
     /* 2313535 */   GIM_Try, /*On fail goto*//*Label 31747*/ GIMT_Encode4(2313597), // Rule ID 55024 //
     /* 2313540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313570 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2313573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2313583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313596 */     // GIR_Coverage, 55024,
     /* 2313596 */     GIR_EraseRootFromParent_Done,
     /* 2313597 */   // Label 31747: @2313597
     /* 2313597 */   GIM_Try, /*On fail goto*//*Label 31748*/ GIMT_Encode4(2313659), // Rule ID 55025 //
     /* 2313602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2313617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2313632 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2313635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2313645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313658 */     // GIR_Coverage, 55025,
     /* 2313658 */     GIR_EraseRootFromParent_Done,
     /* 2313659 */   // Label 31748: @2313659
     /* 2313659 */   GIM_Try, /*On fail goto*//*Label 31749*/ GIMT_Encode4(2313704), // Rule ID 55020 //
     /* 2313664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2313667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313679 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2313682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313703 */     // GIR_Coverage, 55020,
     /* 2313703 */     GIR_EraseRootFromParent_Done,
     /* 2313704 */   // Label 31749: @2313704
     /* 2313704 */   GIM_Try, /*On fail goto*//*Label 31750*/ GIMT_Encode4(2313749), // Rule ID 55021 //
     /* 2313709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2313712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313724 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2313727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2313735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313748 */     // GIR_Coverage, 55021,
     /* 2313748 */     GIR_EraseRootFromParent_Done,
     /* 2313749 */   // Label 31750: @2313749
     /* 2313749 */   GIM_Reject,
     /* 2313750 */ // Label 31738: @2313750
     /* 2313750 */ GIM_Reject,
     /* 2313751 */ // Label 31570: @2313751
     /* 2313751 */ GIM_Try, /*On fail goto*//*Label 31751*/ GIMT_Encode4(2314540),
     /* 2313756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2313762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2313765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313769 */   GIM_Try, /*On fail goto*//*Label 31752*/ GIMT_Encode4(2313846), // Rule ID 55412 //
     /* 2313774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2313777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313817 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2313820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313845 */     // GIR_Coverage, 55412,
     /* 2313845 */     GIR_EraseRootFromParent_Done,
     /* 2313846 */   // Label 31752: @2313846
     /* 2313846 */   GIM_Try, /*On fail goto*//*Label 31753*/ GIMT_Encode4(2313923), // Rule ID 55413 //
     /* 2313851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2313854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2313858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313894 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2313894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2313897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2313901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313922 */     // GIR_Coverage, 55413,
     /* 2313922 */     GIR_EraseRootFromParent_Done,
     /* 2313923 */   // Label 31753: @2313923
     /* 2313923 */   GIM_Try, /*On fail goto*//*Label 31754*/ GIMT_Encode4(2314000), // Rule ID 72916 //
     /* 2313928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2313931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2313939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2313956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2313960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2313971 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2313971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2313974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2313978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2313982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2313986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2313989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2313998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313999 */     // GIR_Coverage, 72916,
     /* 2313999 */     GIR_EraseRootFromParent_Done,
     /* 2314000 */   // Label 31754: @2314000
     /* 2314000 */   GIM_Try, /*On fail goto*//*Label 31755*/ GIMT_Encode4(2314077), // Rule ID 72917 //
     /* 2314005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314048 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2314051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314076 */     // GIR_Coverage, 72917,
     /* 2314076 */     GIR_EraseRootFromParent_Done,
     /* 2314077 */   // Label 31755: @2314077
     /* 2314077 */   GIM_Try, /*On fail goto*//*Label 31756*/ GIMT_Encode4(2314139), // Rule ID 55416 //
     /* 2314082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314112 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2314115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314138 */     // GIR_Coverage, 55416,
     /* 2314138 */     GIR_EraseRootFromParent_Done,
     /* 2314139 */   // Label 31756: @2314139
     /* 2314139 */   GIM_Try, /*On fail goto*//*Label 31757*/ GIMT_Encode4(2314201), // Rule ID 55417 //
     /* 2314144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314174 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2314177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314200 */     // GIR_Coverage, 55417,
     /* 2314200 */     GIR_EraseRootFromParent_Done,
     /* 2314201 */   // Label 31757: @2314201
     /* 2314201 */   GIM_Try, /*On fail goto*//*Label 31758*/ GIMT_Encode4(2314263), // Rule ID 72920 //
     /* 2314206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314236 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2314239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314262 */     // GIR_Coverage, 72920,
     /* 2314262 */     GIR_EraseRootFromParent_Done,
     /* 2314263 */   // Label 31758: @2314263
     /* 2314263 */   GIM_Try, /*On fail goto*//*Label 31759*/ GIMT_Encode4(2314325), // Rule ID 72921 //
     /* 2314268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314298 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2314301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314324 */     // GIR_Coverage, 72921,
     /* 2314324 */     GIR_EraseRootFromParent_Done,
     /* 2314325 */   // Label 31759: @2314325
     /* 2314325 */   GIM_Try, /*On fail goto*//*Label 31760*/ GIMT_Encode4(2314387), // Rule ID 55408 //
     /* 2314330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314360 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2314363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314386 */     // GIR_Coverage, 55408,
     /* 2314386 */     GIR_EraseRootFromParent_Done,
     /* 2314387 */   // Label 31760: @2314387
     /* 2314387 */   GIM_Try, /*On fail goto*//*Label 31761*/ GIMT_Encode4(2314449), // Rule ID 55409 //
     /* 2314392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2314407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314422 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2314425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2314435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314448 */     // GIR_Coverage, 55409,
     /* 2314448 */     GIR_EraseRootFromParent_Done,
     /* 2314449 */   // Label 31761: @2314449
     /* 2314449 */   GIM_Try, /*On fail goto*//*Label 31762*/ GIMT_Encode4(2314494), // Rule ID 55404 //
     /* 2314454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2314457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314469 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2314472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314493 */     // GIR_Coverage, 55404,
     /* 2314493 */     GIR_EraseRootFromParent_Done,
     /* 2314494 */   // Label 31762: @2314494
     /* 2314494 */   GIM_Try, /*On fail goto*//*Label 31763*/ GIMT_Encode4(2314539), // Rule ID 55405 //
     /* 2314499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2314502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314514 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2314517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314538 */     // GIR_Coverage, 55405,
     /* 2314538 */     GIR_EraseRootFromParent_Done,
     /* 2314539 */   // Label 31763: @2314539
     /* 2314539 */   GIM_Reject,
     /* 2314540 */ // Label 31751: @2314540
     /* 2314540 */ GIM_Reject,
     /* 2314541 */ // Label 31571: @2314541
     /* 2314541 */ GIM_Try, /*On fail goto*//*Label 31764*/ GIMT_Encode4(2315330),
     /* 2314546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2314552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2314555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314559 */   GIM_Try, /*On fail goto*//*Label 31765*/ GIMT_Encode4(2314636), // Rule ID 55668 //
     /* 2314564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2314567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314607 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2314610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314635 */     // GIR_Coverage, 55668,
     /* 2314635 */     GIR_EraseRootFromParent_Done,
     /* 2314636 */   // Label 31765: @2314636
     /* 2314636 */   GIM_Try, /*On fail goto*//*Label 31766*/ GIMT_Encode4(2314713), // Rule ID 55669 //
     /* 2314641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2314644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314677 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314684 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2314687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314712 */     // GIR_Coverage, 55669,
     /* 2314712 */     GIR_EraseRootFromParent_Done,
     /* 2314713 */   // Label 31766: @2314713
     /* 2314713 */   GIM_Try, /*On fail goto*//*Label 31767*/ GIMT_Encode4(2314790), // Rule ID 73140 //
     /* 2314718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2314721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314754 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314761 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2314764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314789 */     // GIR_Coverage, 73140,
     /* 2314789 */     GIR_EraseRootFromParent_Done,
     /* 2314790 */   // Label 31767: @2314790
     /* 2314790 */   GIM_Try, /*On fail goto*//*Label 31768*/ GIMT_Encode4(2314867), // Rule ID 73141 //
     /* 2314795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2314798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2314806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2314823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2314838 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2314841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2314845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2314853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314866 */     // GIR_Coverage, 73141,
     /* 2314866 */     GIR_EraseRootFromParent_Done,
     /* 2314867 */   // Label 31768: @2314867
     /* 2314867 */   GIM_Try, /*On fail goto*//*Label 31769*/ GIMT_Encode4(2314929), // Rule ID 55672 //
     /* 2314872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2314875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314902 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2314902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2314905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314928 */     // GIR_Coverage, 55672,
     /* 2314928 */     GIR_EraseRootFromParent_Done,
     /* 2314929 */   // Label 31769: @2314929
     /* 2314929 */   GIM_Try, /*On fail goto*//*Label 31770*/ GIMT_Encode4(2314991), // Rule ID 55673 //
     /* 2314934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2314937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2314941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2314945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2314964 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2314964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2314967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2314971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2314975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2314977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2314980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2314989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314990 */     // GIR_Coverage, 55673,
     /* 2314990 */     GIR_EraseRootFromParent_Done,
     /* 2314991 */   // Label 31770: @2314991
     /* 2314991 */   GIM_Try, /*On fail goto*//*Label 31771*/ GIMT_Encode4(2315053), // Rule ID 73144 //
     /* 2314996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2314999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315026 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2315029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315052 */     // GIR_Coverage, 73144,
     /* 2315052 */     GIR_EraseRootFromParent_Done,
     /* 2315053 */   // Label 31771: @2315053
     /* 2315053 */   GIM_Try, /*On fail goto*//*Label 31772*/ GIMT_Encode4(2315115), // Rule ID 73145 //
     /* 2315058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315088 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2315091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315114 */     // GIR_Coverage, 73145,
     /* 2315114 */     GIR_EraseRootFromParent_Done,
     /* 2315115 */   // Label 31772: @2315115
     /* 2315115 */   GIM_Try, /*On fail goto*//*Label 31773*/ GIMT_Encode4(2315177), // Rule ID 55664 //
     /* 2315120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315150 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2315153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315176 */     // GIR_Coverage, 55664,
     /* 2315176 */     GIR_EraseRootFromParent_Done,
     /* 2315177 */   // Label 31773: @2315177
     /* 2315177 */   GIM_Try, /*On fail goto*//*Label 31774*/ GIMT_Encode4(2315239), // Rule ID 55665 //
     /* 2315182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2315205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315212 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2315215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315238 */     // GIR_Coverage, 55665,
     /* 2315238 */     GIR_EraseRootFromParent_Done,
     /* 2315239 */   // Label 31774: @2315239
     /* 2315239 */   GIM_Try, /*On fail goto*//*Label 31775*/ GIMT_Encode4(2315284), // Rule ID 55660 //
     /* 2315244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2315247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315259 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2315262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315283 */     // GIR_Coverage, 55660,
     /* 2315283 */     GIR_EraseRootFromParent_Done,
     /* 2315284 */   // Label 31775: @2315284
     /* 2315284 */   GIM_Try, /*On fail goto*//*Label 31776*/ GIMT_Encode4(2315329), // Rule ID 55661 //
     /* 2315289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2315292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315304 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2315307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315328 */     // GIR_Coverage, 55661,
     /* 2315328 */     GIR_EraseRootFromParent_Done,
     /* 2315329 */   // Label 31776: @2315329
     /* 2315329 */   GIM_Reject,
     /* 2315330 */ // Label 31764: @2315330
     /* 2315330 */ GIM_Reject,
     /* 2315331 */ // Label 31572: @2315331
     /* 2315331 */ GIM_Try, /*On fail goto*//*Label 31777*/ GIMT_Encode4(2316120),
     /* 2315336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2315342 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2315345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315349 */   GIM_Try, /*On fail goto*//*Label 31778*/ GIMT_Encode4(2315426), // Rule ID 55220 //
     /* 2315354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315397 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2315400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315425 */     // GIR_Coverage, 55220,
     /* 2315425 */     GIR_EraseRootFromParent_Done,
     /* 2315426 */   // Label 31778: @2315426
     /* 2315426 */   GIM_Try, /*On fail goto*//*Label 31779*/ GIMT_Encode4(2315503), // Rule ID 55221 //
     /* 2315431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315474 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2315477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315502 */     // GIR_Coverage, 55221,
     /* 2315502 */     GIR_EraseRootFromParent_Done,
     /* 2315503 */   // Label 31779: @2315503
     /* 2315503 */   GIM_Try, /*On fail goto*//*Label 31780*/ GIMT_Encode4(2315580), // Rule ID 72748 //
     /* 2315508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315551 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2315554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315579 */     // GIR_Coverage, 72748,
     /* 2315579 */     GIR_EraseRootFromParent_Done,
     /* 2315580 */   // Label 31780: @2315580
     /* 2315580 */   GIM_Try, /*On fail goto*//*Label 31781*/ GIMT_Encode4(2315657), // Rule ID 72749 //
     /* 2315585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2315613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2315628 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2315631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2315643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315656 */     // GIR_Coverage, 72749,
     /* 2315656 */     GIR_EraseRootFromParent_Done,
     /* 2315657 */   // Label 31781: @2315657
     /* 2315657 */   GIM_Try, /*On fail goto*//*Label 31782*/ GIMT_Encode4(2315719), // Rule ID 55224 //
     /* 2315662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315692 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2315695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315718 */     // GIR_Coverage, 55224,
     /* 2315718 */     GIR_EraseRootFromParent_Done,
     /* 2315719 */   // Label 31782: @2315719
     /* 2315719 */   GIM_Try, /*On fail goto*//*Label 31783*/ GIMT_Encode4(2315781), // Rule ID 55225 //
     /* 2315724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2315731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315754 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2315757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315780 */     // GIR_Coverage, 55225,
     /* 2315780 */     GIR_EraseRootFromParent_Done,
     /* 2315781 */   // Label 31783: @2315781
     /* 2315781 */   GIM_Try, /*On fail goto*//*Label 31784*/ GIMT_Encode4(2315843), // Rule ID 72752 //
     /* 2315786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315816 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2315819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315842 */     // GIR_Coverage, 72752,
     /* 2315842 */     GIR_EraseRootFromParent_Done,
     /* 2315843 */   // Label 31784: @2315843
     /* 2315843 */   GIM_Try, /*On fail goto*//*Label 31785*/ GIMT_Encode4(2315905), // Rule ID 72753 //
     /* 2315848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2315859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315878 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2315878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2315881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2315885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2315889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2315891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315904 */     // GIR_Coverage, 72753,
     /* 2315904 */     GIR_EraseRootFromParent_Done,
     /* 2315905 */   // Label 31785: @2315905
     /* 2315905 */   GIM_Try, /*On fail goto*//*Label 31786*/ GIMT_Encode4(2315967), // Rule ID 55216 //
     /* 2315910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2315913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2315940 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2315940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2315943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2315947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2315953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2315956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2315965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315966 */     // GIR_Coverage, 55216,
     /* 2315966 */     GIR_EraseRootFromParent_Done,
     /* 2315967 */   // Label 31786: @2315967
     /* 2315967 */   GIM_Try, /*On fail goto*//*Label 31787*/ GIMT_Encode4(2316029), // Rule ID 55217 //
     /* 2315972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2315975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2315987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2315991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2315995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316002 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2316005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316028 */     // GIR_Coverage, 55217,
     /* 2316028 */     GIR_EraseRootFromParent_Done,
     /* 2316029 */   // Label 31787: @2316029
     /* 2316029 */   GIM_Try, /*On fail goto*//*Label 31788*/ GIMT_Encode4(2316074), // Rule ID 55212 //
     /* 2316034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2316037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316049 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2316052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316073 */     // GIR_Coverage, 55212,
     /* 2316073 */     GIR_EraseRootFromParent_Done,
     /* 2316074 */   // Label 31788: @2316074
     /* 2316074 */   GIM_Try, /*On fail goto*//*Label 31789*/ GIMT_Encode4(2316119), // Rule ID 55213 //
     /* 2316079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2316082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2316094 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2316097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316118 */     // GIR_Coverage, 55213,
     /* 2316118 */     GIR_EraseRootFromParent_Done,
     /* 2316119 */   // Label 31789: @2316119
     /* 2316119 */   GIM_Reject,
     /* 2316120 */ // Label 31777: @2316120
     /* 2316120 */ GIM_Reject,
     /* 2316121 */ // Label 31573: @2316121
     /* 2316121 */ GIM_Try, /*On fail goto*//*Label 31790*/ GIMT_Encode4(2316910),
     /* 2316126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2316132 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2316135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316139 */   GIM_Try, /*On fail goto*//*Label 31791*/ GIMT_Encode4(2316216), // Rule ID 55476 //
     /* 2316144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316187 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2316190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316215 */     // GIR_Coverage, 55476,
     /* 2316215 */     GIR_EraseRootFromParent_Done,
     /* 2316216 */   // Label 31791: @2316216
     /* 2316216 */   GIM_Try, /*On fail goto*//*Label 31792*/ GIMT_Encode4(2316293), // Rule ID 55477 //
     /* 2316221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316253 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316264 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2316267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316292 */     // GIR_Coverage, 55477,
     /* 2316292 */     GIR_EraseRootFromParent_Done,
     /* 2316293 */   // Label 31792: @2316293
     /* 2316293 */   GIM_Try, /*On fail goto*//*Label 31793*/ GIMT_Encode4(2316370), // Rule ID 72972 //
     /* 2316298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316341 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2316344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316369 */     // GIR_Coverage, 72972,
     /* 2316369 */     GIR_EraseRootFromParent_Done,
     /* 2316370 */   // Label 31793: @2316370
     /* 2316370 */   GIM_Try, /*On fail goto*//*Label 31794*/ GIMT_Encode4(2316447), // Rule ID 72973 //
     /* 2316375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316418 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2316421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316446 */     // GIR_Coverage, 72973,
     /* 2316446 */     GIR_EraseRootFromParent_Done,
     /* 2316447 */   // Label 31794: @2316447
     /* 2316447 */   GIM_Try, /*On fail goto*//*Label 31795*/ GIMT_Encode4(2316509), // Rule ID 55480 //
     /* 2316452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316482 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2316485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316508 */     // GIR_Coverage, 55480,
     /* 2316508 */     GIR_EraseRootFromParent_Done,
     /* 2316509 */   // Label 31795: @2316509
     /* 2316509 */   GIM_Try, /*On fail goto*//*Label 31796*/ GIMT_Encode4(2316571), // Rule ID 55481 //
     /* 2316514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316544 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2316547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316570 */     // GIR_Coverage, 55481,
     /* 2316570 */     GIR_EraseRootFromParent_Done,
     /* 2316571 */   // Label 31796: @2316571
     /* 2316571 */   GIM_Try, /*On fail goto*//*Label 31797*/ GIMT_Encode4(2316633), // Rule ID 72976 //
     /* 2316576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316606 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2316609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316632 */     // GIR_Coverage, 72976,
     /* 2316632 */     GIR_EraseRootFromParent_Done,
     /* 2316633 */   // Label 31797: @2316633
     /* 2316633 */   GIM_Try, /*On fail goto*//*Label 31798*/ GIMT_Encode4(2316695), // Rule ID 72977 //
     /* 2316638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2316649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316668 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2316671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2316675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316694 */     // GIR_Coverage, 72977,
     /* 2316694 */     GIR_EraseRootFromParent_Done,
     /* 2316695 */   // Label 31798: @2316695
     /* 2316695 */   GIM_Try, /*On fail goto*//*Label 31799*/ GIMT_Encode4(2316757), // Rule ID 55472 //
     /* 2316700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316730 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2316733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316756 */     // GIR_Coverage, 55472,
     /* 2316756 */     GIR_EraseRootFromParent_Done,
     /* 2316757 */   // Label 31799: @2316757
     /* 2316757 */   GIM_Try, /*On fail goto*//*Label 31800*/ GIMT_Encode4(2316819), // Rule ID 55473 //
     /* 2316762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2316777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2316785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2316792 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2316795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2316805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316818 */     // GIR_Coverage, 55473,
     /* 2316818 */     GIR_EraseRootFromParent_Done,
     /* 2316819 */   // Label 31800: @2316819
     /* 2316819 */   GIM_Try, /*On fail goto*//*Label 31801*/ GIMT_Encode4(2316864), // Rule ID 55468 //
     /* 2316824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2316827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316839 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2316842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316863 */     // GIR_Coverage, 55468,
     /* 2316863 */     GIR_EraseRootFromParent_Done,
     /* 2316864 */   // Label 31801: @2316864
     /* 2316864 */   GIM_Try, /*On fail goto*//*Label 31802*/ GIMT_Encode4(2316909), // Rule ID 55469 //
     /* 2316869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2316872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2316884 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2316884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2316887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2316895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2316904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316908 */     // GIR_Coverage, 55469,
     /* 2316908 */     GIR_EraseRootFromParent_Done,
     /* 2316909 */   // Label 31802: @2316909
     /* 2316909 */   GIM_Reject,
     /* 2316910 */ // Label 31790: @2316910
     /* 2316910 */ GIM_Reject,
     /* 2316911 */ // Label 31574: @2316911
     /* 2316911 */ GIM_Try, /*On fail goto*//*Label 31803*/ GIMT_Encode4(2317700),
     /* 2316916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2316919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2316922 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2316925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316929 */   GIM_Try, /*On fail goto*//*Label 31804*/ GIMT_Encode4(2317006), // Rule ID 55732 //
     /* 2316934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2316937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2316941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2316949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2316962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2316966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2316970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2316975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2316977 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2316977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2316980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2316984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2316988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2316992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2316995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317005 */     // GIR_Coverage, 55732,
     /* 2317005 */     GIR_EraseRootFromParent_Done,
     /* 2317006 */   // Label 31804: @2317006
     /* 2317006 */   GIM_Try, /*On fail goto*//*Label 31805*/ GIMT_Encode4(2317083), // Rule ID 55733 //
     /* 2317011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317054 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2317057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317082 */     // GIR_Coverage, 55733,
     /* 2317082 */     GIR_EraseRootFromParent_Done,
     /* 2317083 */   // Label 31805: @2317083
     /* 2317083 */   GIM_Try, /*On fail goto*//*Label 31806*/ GIMT_Encode4(2317160), // Rule ID 73196 //
     /* 2317088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317131 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2317134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317159 */     // GIR_Coverage, 73196,
     /* 2317159 */     GIR_EraseRootFromParent_Done,
     /* 2317160 */   // Label 31806: @2317160
     /* 2317160 */   GIM_Try, /*On fail goto*//*Label 31807*/ GIMT_Encode4(2317237), // Rule ID 73197 //
     /* 2317165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317208 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2317211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317236 */     // GIR_Coverage, 73197,
     /* 2317236 */     GIR_EraseRootFromParent_Done,
     /* 2317237 */   // Label 31807: @2317237
     /* 2317237 */   GIM_Try, /*On fail goto*//*Label 31808*/ GIMT_Encode4(2317299), // Rule ID 55736 //
     /* 2317242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317272 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2317275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317298 */     // GIR_Coverage, 55736,
     /* 2317298 */     GIR_EraseRootFromParent_Done,
     /* 2317299 */   // Label 31808: @2317299
     /* 2317299 */   GIM_Try, /*On fail goto*//*Label 31809*/ GIMT_Encode4(2317361), // Rule ID 55737 //
     /* 2317304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317334 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2317337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317360 */     // GIR_Coverage, 55737,
     /* 2317360 */     GIR_EraseRootFromParent_Done,
     /* 2317361 */   // Label 31809: @2317361
     /* 2317361 */   GIM_Try, /*On fail goto*//*Label 31810*/ GIMT_Encode4(2317423), // Rule ID 73200 //
     /* 2317366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317396 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2317399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317422 */     // GIR_Coverage, 73200,
     /* 2317422 */     GIR_EraseRootFromParent_Done,
     /* 2317423 */   // Label 31810: @2317423
     /* 2317423 */   GIM_Try, /*On fail goto*//*Label 31811*/ GIMT_Encode4(2317485), // Rule ID 73201 //
     /* 2317428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317458 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2317461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317484 */     // GIR_Coverage, 73201,
     /* 2317484 */     GIR_EraseRootFromParent_Done,
     /* 2317485 */   // Label 31811: @2317485
     /* 2317485 */   GIM_Try, /*On fail goto*//*Label 31812*/ GIMT_Encode4(2317547), // Rule ID 55728 //
     /* 2317490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317520 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2317523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317546 */     // GIR_Coverage, 55728,
     /* 2317546 */     GIR_EraseRootFromParent_Done,
     /* 2317547 */   // Label 31812: @2317547
     /* 2317547 */   GIM_Try, /*On fail goto*//*Label 31813*/ GIMT_Encode4(2317609), // Rule ID 55729 //
     /* 2317552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2317567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2317575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2317582 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2317585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2317595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317608 */     // GIR_Coverage, 55729,
     /* 2317608 */     GIR_EraseRootFromParent_Done,
     /* 2317609 */   // Label 31813: @2317609
     /* 2317609 */   GIM_Try, /*On fail goto*//*Label 31814*/ GIMT_Encode4(2317654), // Rule ID 55724 //
     /* 2317614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2317617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317629 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2317632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317653 */     // GIR_Coverage, 55724,
     /* 2317653 */     GIR_EraseRootFromParent_Done,
     /* 2317654 */   // Label 31814: @2317654
     /* 2317654 */   GIM_Try, /*On fail goto*//*Label 31815*/ GIMT_Encode4(2317699), // Rule ID 55725 //
     /* 2317659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2317662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2317674 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2317677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2317685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317698 */     // GIR_Coverage, 55725,
     /* 2317698 */     GIR_EraseRootFromParent_Done,
     /* 2317699 */   // Label 31815: @2317699
     /* 2317699 */   GIM_Reject,
     /* 2317700 */ // Label 31803: @2317700
     /* 2317700 */ GIM_Reject,
     /* 2317701 */ // Label 31575: @2317701
     /* 2317701 */ GIM_Try, /*On fail goto*//*Label 31816*/ GIMT_Encode4(2318490),
     /* 2317706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2317712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2317715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317719 */   GIM_Try, /*On fail goto*//*Label 31817*/ GIMT_Encode4(2317796), // Rule ID 55284 //
     /* 2317724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317767 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2317770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317795 */     // GIR_Coverage, 55284,
     /* 2317795 */     GIR_EraseRootFromParent_Done,
     /* 2317796 */   // Label 31817: @2317796
     /* 2317796 */   GIM_Try, /*On fail goto*//*Label 31818*/ GIMT_Encode4(2317873), // Rule ID 55285 //
     /* 2317801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2317808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317844 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2317847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2317851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317872 */     // GIR_Coverage, 55285,
     /* 2317872 */     GIR_EraseRootFromParent_Done,
     /* 2317873 */   // Label 31818: @2317873
     /* 2317873 */   GIM_Try, /*On fail goto*//*Label 31819*/ GIMT_Encode4(2317950), // Rule ID 72804 //
     /* 2317878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2317881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317921 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2317921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2317924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2317928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2317932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2317936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2317939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2317948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317949 */     // GIR_Coverage, 72804,
     /* 2317949 */     GIR_EraseRootFromParent_Done,
     /* 2317950 */   // Label 31819: @2317950
     /* 2317950 */   GIM_Try, /*On fail goto*//*Label 31820*/ GIMT_Encode4(2318027), // Rule ID 72805 //
     /* 2317955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2317958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2317966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2317983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2317987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2317991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2317996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2317998 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2317998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2318001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318026 */     // GIR_Coverage, 72805,
     /* 2318026 */     GIR_EraseRootFromParent_Done,
     /* 2318027 */   // Label 31820: @2318027
     /* 2318027 */   GIM_Try, /*On fail goto*//*Label 31821*/ GIMT_Encode4(2318089), // Rule ID 55288 //
     /* 2318032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318062 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2318065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318088 */     // GIR_Coverage, 55288,
     /* 2318088 */     GIR_EraseRootFromParent_Done,
     /* 2318089 */   // Label 31821: @2318089
     /* 2318089 */   GIM_Try, /*On fail goto*//*Label 31822*/ GIMT_Encode4(2318151), // Rule ID 55289 //
     /* 2318094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318124 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2318127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318150 */     // GIR_Coverage, 55289,
     /* 2318150 */     GIR_EraseRootFromParent_Done,
     /* 2318151 */   // Label 31822: @2318151
     /* 2318151 */   GIM_Try, /*On fail goto*//*Label 31823*/ GIMT_Encode4(2318213), // Rule ID 72808 //
     /* 2318156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318186 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2318189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318212 */     // GIR_Coverage, 72808,
     /* 2318212 */     GIR_EraseRootFromParent_Done,
     /* 2318213 */   // Label 31823: @2318213
     /* 2318213 */   GIM_Try, /*On fail goto*//*Label 31824*/ GIMT_Encode4(2318275), // Rule ID 72809 //
     /* 2318218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318248 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2318251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318274 */     // GIR_Coverage, 72809,
     /* 2318274 */     GIR_EraseRootFromParent_Done,
     /* 2318275 */   // Label 31824: @2318275
     /* 2318275 */   GIM_Try, /*On fail goto*//*Label 31825*/ GIMT_Encode4(2318337), // Rule ID 55280 //
     /* 2318280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318310 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2318313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318336 */     // GIR_Coverage, 55280,
     /* 2318336 */     GIR_EraseRootFromParent_Done,
     /* 2318337 */   // Label 31825: @2318337
     /* 2318337 */   GIM_Try, /*On fail goto*//*Label 31826*/ GIMT_Encode4(2318399), // Rule ID 55281 //
     /* 2318342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2318357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2318365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318372 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2318375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2318385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318398 */     // GIR_Coverage, 55281,
     /* 2318398 */     GIR_EraseRootFromParent_Done,
     /* 2318399 */   // Label 31826: @2318399
     /* 2318399 */   GIM_Try, /*On fail goto*//*Label 31827*/ GIMT_Encode4(2318444), // Rule ID 55276 //
     /* 2318404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2318407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318419 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2318422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318443 */     // GIR_Coverage, 55276,
     /* 2318443 */     GIR_EraseRootFromParent_Done,
     /* 2318444 */   // Label 31827: @2318444
     /* 2318444 */   GIM_Try, /*On fail goto*//*Label 31828*/ GIMT_Encode4(2318489), // Rule ID 55277 //
     /* 2318449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2318452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2318464 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2318467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318488 */     // GIR_Coverage, 55277,
     /* 2318488 */     GIR_EraseRootFromParent_Done,
     /* 2318489 */   // Label 31828: @2318489
     /* 2318489 */   GIM_Reject,
     /* 2318490 */ // Label 31816: @2318490
     /* 2318490 */ GIM_Reject,
     /* 2318491 */ // Label 31576: @2318491
     /* 2318491 */ GIM_Try, /*On fail goto*//*Label 31829*/ GIMT_Encode4(2319280),
     /* 2318496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2318502 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2318505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318509 */   GIM_Try, /*On fail goto*//*Label 31830*/ GIMT_Encode4(2318586), // Rule ID 55540 //
     /* 2318514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318550 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318557 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2318560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318585 */     // GIR_Coverage, 55540,
     /* 2318585 */     GIR_EraseRootFromParent_Done,
     /* 2318586 */   // Label 31830: @2318586
     /* 2318586 */   GIM_Try, /*On fail goto*//*Label 31831*/ GIMT_Encode4(2318663), // Rule ID 55541 //
     /* 2318591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318634 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2318637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318662 */     // GIR_Coverage, 55541,
     /* 2318662 */     GIR_EraseRootFromParent_Done,
     /* 2318663 */   // Label 31831: @2318663
     /* 2318663 */   GIM_Try, /*On fail goto*//*Label 31832*/ GIMT_Encode4(2318740), // Rule ID 73028 //
     /* 2318668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318711 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2318714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318739 */     // GIR_Coverage, 73028,
     /* 2318739 */     GIR_EraseRootFromParent_Done,
     /* 2318740 */   // Label 31832: @2318740
     /* 2318740 */   GIM_Try, /*On fail goto*//*Label 31833*/ GIMT_Encode4(2318817), // Rule ID 73029 //
     /* 2318745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2318773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2318788 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2318791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2318803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318816 */     // GIR_Coverage, 73029,
     /* 2318816 */     GIR_EraseRootFromParent_Done,
     /* 2318817 */   // Label 31833: @2318817
     /* 2318817 */   GIM_Try, /*On fail goto*//*Label 31834*/ GIMT_Encode4(2318879), // Rule ID 55544 //
     /* 2318822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318852 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2318855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318878 */     // GIR_Coverage, 55544,
     /* 2318878 */     GIR_EraseRootFromParent_Done,
     /* 2318879 */   // Label 31834: @2318879
     /* 2318879 */   GIM_Try, /*On fail goto*//*Label 31835*/ GIMT_Encode4(2318941), // Rule ID 55545 //
     /* 2318884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2318887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2318891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318914 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2318914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2318917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2318921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2318939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318940 */     // GIR_Coverage, 55545,
     /* 2318940 */     GIR_EraseRootFromParent_Done,
     /* 2318941 */   // Label 31835: @2318941
     /* 2318941 */   GIM_Try, /*On fail goto*//*Label 31836*/ GIMT_Encode4(2319003), // Rule ID 73032 //
     /* 2318946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2318949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2318957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2318961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2318965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2318974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2318976 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2318976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2318979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2318983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2318987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2318989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2318992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319002 */     // GIR_Coverage, 73032,
     /* 2319002 */     GIR_EraseRootFromParent_Done,
     /* 2319003 */   // Label 31836: @2319003
     /* 2319003 */   GIM_Try, /*On fail goto*//*Label 31837*/ GIMT_Encode4(2319065), // Rule ID 73033 //
     /* 2319008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319038 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2319041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319064 */     // GIR_Coverage, 73033,
     /* 2319064 */     GIR_EraseRootFromParent_Done,
     /* 2319065 */   // Label 31837: @2319065
     /* 2319065 */   GIM_Try, /*On fail goto*//*Label 31838*/ GIMT_Encode4(2319127), // Rule ID 55536 //
     /* 2319070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319100 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2319103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319126 */     // GIR_Coverage, 55536,
     /* 2319126 */     GIR_EraseRootFromParent_Done,
     /* 2319127 */   // Label 31838: @2319127
     /* 2319127 */   GIM_Try, /*On fail goto*//*Label 31839*/ GIMT_Encode4(2319189), // Rule ID 55537 //
     /* 2319132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2319155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319162 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2319165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319188 */     // GIR_Coverage, 55537,
     /* 2319188 */     GIR_EraseRootFromParent_Done,
     /* 2319189 */   // Label 31839: @2319189
     /* 2319189 */   GIM_Try, /*On fail goto*//*Label 31840*/ GIMT_Encode4(2319234), // Rule ID 55532 //
     /* 2319194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2319197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319209 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2319212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319233 */     // GIR_Coverage, 55532,
     /* 2319233 */     GIR_EraseRootFromParent_Done,
     /* 2319234 */   // Label 31840: @2319234
     /* 2319234 */   GIM_Try, /*On fail goto*//*Label 31841*/ GIMT_Encode4(2319279), // Rule ID 55533 //
     /* 2319239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2319242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319254 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2319257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319278 */     // GIR_Coverage, 55533,
     /* 2319278 */     GIR_EraseRootFromParent_Done,
     /* 2319279 */   // Label 31841: @2319279
     /* 2319279 */   GIM_Reject,
     /* 2319280 */ // Label 31829: @2319280
     /* 2319280 */ GIM_Reject,
     /* 2319281 */ // Label 31577: @2319281
     /* 2319281 */ GIM_Try, /*On fail goto*//*Label 31842*/ GIMT_Encode4(2320070),
     /* 2319286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2319292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2319295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319299 */   GIM_Try, /*On fail goto*//*Label 31843*/ GIMT_Encode4(2319376), // Rule ID 55348 //
     /* 2319304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319336 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319347 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2319350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319375 */     // GIR_Coverage, 55348,
     /* 2319375 */     GIR_EraseRootFromParent_Done,
     /* 2319376 */   // Label 31843: @2319376
     /* 2319376 */   GIM_Try, /*On fail goto*//*Label 31844*/ GIMT_Encode4(2319453), // Rule ID 55349 //
     /* 2319381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319424 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2319427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319452 */     // GIR_Coverage, 55349,
     /* 2319452 */     GIR_EraseRootFromParent_Done,
     /* 2319453 */   // Label 31844: @2319453
     /* 2319453 */   GIM_Try, /*On fail goto*//*Label 31845*/ GIMT_Encode4(2319530), // Rule ID 72860 //
     /* 2319458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319501 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2319504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319529 */     // GIR_Coverage, 72860,
     /* 2319529 */     GIR_EraseRootFromParent_Done,
     /* 2319530 */   // Label 31845: @2319530
     /* 2319530 */   GIM_Try, /*On fail goto*//*Label 31846*/ GIMT_Encode4(2319607), // Rule ID 72861 //
     /* 2319535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2319563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2319578 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2319581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2319593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319606 */     // GIR_Coverage, 72861,
     /* 2319606 */     GIR_EraseRootFromParent_Done,
     /* 2319607 */   // Label 31846: @2319607
     /* 2319607 */   GIM_Try, /*On fail goto*//*Label 31847*/ GIMT_Encode4(2319669), // Rule ID 55352 //
     /* 2319612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319642 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2319645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319668 */     // GIR_Coverage, 55352,
     /* 2319668 */     GIR_EraseRootFromParent_Done,
     /* 2319669 */   // Label 31847: @2319669
     /* 2319669 */   GIM_Try, /*On fail goto*//*Label 31848*/ GIMT_Encode4(2319731), // Rule ID 55353 //
     /* 2319674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2319681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319704 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2319707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319730 */     // GIR_Coverage, 55353,
     /* 2319730 */     GIR_EraseRootFromParent_Done,
     /* 2319731 */   // Label 31848: @2319731
     /* 2319731 */   GIM_Try, /*On fail goto*//*Label 31849*/ GIMT_Encode4(2319793), // Rule ID 72864 //
     /* 2319736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319766 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2319769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319792 */     // GIR_Coverage, 72864,
     /* 2319792 */     GIR_EraseRootFromParent_Done,
     /* 2319793 */   // Label 31849: @2319793
     /* 2319793 */   GIM_Try, /*On fail goto*//*Label 31850*/ GIMT_Encode4(2319855), // Rule ID 72865 //
     /* 2319798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2319809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319828 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2319831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2319835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2319839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2319841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319854 */     // GIR_Coverage, 72865,
     /* 2319854 */     GIR_EraseRootFromParent_Done,
     /* 2319855 */   // Label 31850: @2319855
     /* 2319855 */   GIM_Try, /*On fail goto*//*Label 31851*/ GIMT_Encode4(2319917), // Rule ID 55344 //
     /* 2319860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319890 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2319893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319916 */     // GIR_Coverage, 55344,
     /* 2319916 */     GIR_EraseRootFromParent_Done,
     /* 2319917 */   // Label 31851: @2319917
     /* 2319917 */   GIM_Try, /*On fail goto*//*Label 31852*/ GIMT_Encode4(2319979), // Rule ID 55345 //
     /* 2319922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2319925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2319937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2319941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2319945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2319952 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2319952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2319955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2319959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2319965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2319968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2319977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319978 */     // GIR_Coverage, 55345,
     /* 2319978 */     GIR_EraseRootFromParent_Done,
     /* 2319979 */   // Label 31852: @2319979
     /* 2319979 */   GIM_Try, /*On fail goto*//*Label 31853*/ GIMT_Encode4(2320024), // Rule ID 55340 //
     /* 2319984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2319987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319999 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2319999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2320002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320023 */     // GIR_Coverage, 55340,
     /* 2320023 */     GIR_EraseRootFromParent_Done,
     /* 2320024 */   // Label 31853: @2320024
     /* 2320024 */   GIM_Try, /*On fail goto*//*Label 31854*/ GIMT_Encode4(2320069), // Rule ID 55341 //
     /* 2320029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320044 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2320044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2320047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2320051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2320055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2320067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320068 */     // GIR_Coverage, 55341,
     /* 2320068 */     GIR_EraseRootFromParent_Done,
     /* 2320069 */   // Label 31854: @2320069
     /* 2320069 */   GIM_Reject,
     /* 2320070 */ // Label 31842: @2320070
     /* 2320070 */ GIM_Reject,
     /* 2320071 */ // Label 31578: @2320071
     /* 2320071 */ GIM_Reject,
     /* 2320072 */ // Label 63: @2320072
     /* 2320072 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31873*/ GIMT_Encode4(2322499),
     /* 2320083 */ /*GILLT_s16*//*Label 31855*/ GIMT_Encode4(2320203),
     /* 2320087 */ /*GILLT_s32*//*Label 31856*/ GIMT_Encode4(2320352),
     /* 2320091 */ /*GILLT_s64*//*Label 31857*/ GIMT_Encode4(2320501), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320103 */ /*GILLT_nxv1s16*//*Label 31858*/ GIMT_Encode4(2320684),
     /* 2320107 */ /*GILLT_nxv1s32*//*Label 31859*/ GIMT_Encode4(2320805),
     /* 2320111 */ /*GILLT_nxv1s64*//*Label 31860*/ GIMT_Encode4(2320926), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320123 */ /*GILLT_nxv2s16*//*Label 31861*/ GIMT_Encode4(2321047),
     /* 2320127 */ /*GILLT_nxv2s32*//*Label 31862*/ GIMT_Encode4(2321168),
     /* 2320131 */ /*GILLT_nxv2s64*//*Label 31863*/ GIMT_Encode4(2321289), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320143 */ /*GILLT_nxv4s16*//*Label 31864*/ GIMT_Encode4(2321410),
     /* 2320147 */ /*GILLT_nxv4s32*//*Label 31865*/ GIMT_Encode4(2321531),
     /* 2320151 */ /*GILLT_nxv4s64*//*Label 31866*/ GIMT_Encode4(2321652), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320163 */ /*GILLT_nxv8s16*//*Label 31867*/ GIMT_Encode4(2321773),
     /* 2320167 */ /*GILLT_nxv8s32*//*Label 31868*/ GIMT_Encode4(2321894),
     /* 2320171 */ /*GILLT_nxv8s64*//*Label 31869*/ GIMT_Encode4(2322015), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320183 */ /*GILLT_nxv16s16*//*Label 31870*/ GIMT_Encode4(2322136),
     /* 2320187 */ /*GILLT_nxv16s32*//*Label 31871*/ GIMT_Encode4(2322257), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320199 */ /*GILLT_nxv32s16*//*Label 31872*/ GIMT_Encode4(2322378),
     /* 2320203 */ // Label 31855: @2320203
     /* 2320203 */ GIM_Try, /*On fail goto*//*Label 31874*/ GIMT_Encode4(2320351),
     /* 2320208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2320211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2320214 */   GIM_Try, /*On fail goto*//*Label 31875*/ GIMT_Encode4(2320248), // Rule ID 1978 //
     /* 2320219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2320222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320234 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2320234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2320237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320247 */     // GIR_Coverage, 1978,
     /* 2320247 */     GIR_EraseRootFromParent_Done,
     /* 2320248 */   // Label 31875: @2320248
     /* 2320248 */   GIM_Try, /*On fail goto*//*Label 31876*/ GIMT_Encode4(2320282), // Rule ID 1979 //
     /* 2320253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2320256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2320268 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2320268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2320271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320281 */     // GIR_Coverage, 1979,
     /* 2320281 */     GIR_EraseRootFromParent_Done,
     /* 2320282 */   // Label 31876: @2320282
     /* 2320282 */   GIM_Try, /*On fail goto*//*Label 31877*/ GIMT_Encode4(2320316), // Rule ID 1982 //
     /* 2320287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2320290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320302 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2320302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2320305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320315 */     // GIR_Coverage, 1982,
     /* 2320315 */     GIR_EraseRootFromParent_Done,
     /* 2320316 */   // Label 31877: @2320316
     /* 2320316 */   GIM_Try, /*On fail goto*//*Label 31878*/ GIMT_Encode4(2320350), // Rule ID 1983 //
     /* 2320321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2320324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2320336 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2320336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2320339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320349 */     // GIR_Coverage, 1983,
     /* 2320349 */     GIR_EraseRootFromParent_Done,
     /* 2320350 */   // Label 31878: @2320350
     /* 2320350 */   GIM_Reject,
     /* 2320351 */ // Label 31874: @2320351
     /* 2320351 */ GIM_Reject,
     /* 2320352 */ // Label 31856: @2320352
     /* 2320352 */ GIM_Try, /*On fail goto*//*Label 31879*/ GIMT_Encode4(2320500),
     /* 2320357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2320360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2320363 */   GIM_Try, /*On fail goto*//*Label 31880*/ GIMT_Encode4(2320397), // Rule ID 1269 //
     /* 2320368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2320371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320383 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2320383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2320386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320396 */     // GIR_Coverage, 1269,
     /* 2320396 */     GIR_EraseRootFromParent_Done,
     /* 2320397 */   // Label 31880: @2320397
     /* 2320397 */   GIM_Try, /*On fail goto*//*Label 31881*/ GIMT_Encode4(2320431), // Rule ID 1270 //
     /* 2320402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2320405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2320417 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2320417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2320420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320430 */     // GIR_Coverage, 1270,
     /* 2320430 */     GIR_EraseRootFromParent_Done,
     /* 2320431 */   // Label 31881: @2320431
     /* 2320431 */   GIM_Try, /*On fail goto*//*Label 31882*/ GIMT_Encode4(2320465), // Rule ID 1273 //
     /* 2320436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2320439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320451 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2320451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2320454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320464 */     // GIR_Coverage, 1273,
     /* 2320464 */     GIR_EraseRootFromParent_Done,
     /* 2320465 */   // Label 31882: @2320465
     /* 2320465 */   GIM_Try, /*On fail goto*//*Label 31883*/ GIMT_Encode4(2320499), // Rule ID 1274 //
     /* 2320470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2320473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2320485 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2320485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2320488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320498 */     // GIR_Coverage, 1274,
     /* 2320498 */     GIR_EraseRootFromParent_Done,
     /* 2320499 */   // Label 31883: @2320499
     /* 2320499 */   GIM_Reject,
     /* 2320500 */ // Label 31879: @2320500
     /* 2320500 */ GIM_Reject,
     /* 2320501 */ // Label 31857: @2320501
     /* 2320501 */ GIM_Try, /*On fail goto*//*Label 31884*/ GIMT_Encode4(2320683),
     /* 2320506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2320509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2320512 */   GIM_Try, /*On fail goto*//*Label 31885*/ GIMT_Encode4(2320546), // Rule ID 1610 //
     /* 2320517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2320520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320532 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2320532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2320535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320545 */     // GIR_Coverage, 1610,
     /* 2320545 */     GIR_EraseRootFromParent_Done,
     /* 2320546 */   // Label 31885: @2320546
     /* 2320546 */   GIM_Try, /*On fail goto*//*Label 31886*/ GIMT_Encode4(2320580), // Rule ID 1611 //
     /* 2320551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2320554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2320566 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2320566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2320569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320579 */     // GIR_Coverage, 1611,
     /* 2320579 */     GIR_EraseRootFromParent_Done,
     /* 2320580 */   // Label 31886: @2320580
     /* 2320580 */   GIM_Try, /*On fail goto*//*Label 31887*/ GIMT_Encode4(2320614), // Rule ID 1614 //
     /* 2320585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2320588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2320592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2320596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2320600 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2320600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2320603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320613 */     // GIR_Coverage, 1614,
     /* 2320613 */     GIR_EraseRootFromParent_Done,
     /* 2320614 */   // Label 31887: @2320614
     /* 2320614 */   GIM_Try, /*On fail goto*//*Label 31888*/ GIMT_Encode4(2320648), // Rule ID 1615 //
     /* 2320619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2320622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2320626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2320630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2320634 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2320634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2320637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320647 */     // GIR_Coverage, 1615,
     /* 2320647 */     GIR_EraseRootFromParent_Done,
     /* 2320648 */   // Label 31888: @2320648
     /* 2320648 */   GIM_Try, /*On fail goto*//*Label 31889*/ GIMT_Encode4(2320682), // Rule ID 1617 //
     /* 2320653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2320656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2320668 */     // (fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2320668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2320671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320681 */     // GIR_Coverage, 1617,
     /* 2320681 */     GIR_EraseRootFromParent_Done,
     /* 2320682 */   // Label 31889: @2320682
     /* 2320682 */   GIM_Reject,
     /* 2320683 */ // Label 31884: @2320683
     /* 2320683 */ GIM_Reject,
     /* 2320684 */ // Label 31858: @2320684
     /* 2320684 */ GIM_Try, /*On fail goto*//*Label 31890*/ GIMT_Encode4(2320804),
     /* 2320689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2320692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2320695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320707 */   GIM_Try, /*On fail goto*//*Label 31891*/ GIMT_Encode4(2320755), // Rule ID 54402 //
     /* 2320712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2320715 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2320718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2320732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320754 */     // GIR_Coverage, 54402,
     /* 2320754 */     GIR_EraseRootFromParent_Done,
     /* 2320755 */   // Label 31891: @2320755
     /* 2320755 */   GIM_Try, /*On fail goto*//*Label 31892*/ GIMT_Encode4(2320803), // Rule ID 54403 //
     /* 2320760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2320763 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2320766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2320780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320802 */     // GIR_Coverage, 54403,
     /* 2320802 */     GIR_EraseRootFromParent_Done,
     /* 2320803 */   // Label 31892: @2320803
     /* 2320803 */   GIM_Reject,
     /* 2320804 */ // Label 31890: @2320804
     /* 2320804 */ GIM_Reject,
     /* 2320805 */ // Label 31859: @2320805
     /* 2320805 */ GIM_Try, /*On fail goto*//*Label 31893*/ GIMT_Encode4(2320925),
     /* 2320810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2320813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2320816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320824 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320828 */   GIM_Try, /*On fail goto*//*Label 31894*/ GIMT_Encode4(2320876), // Rule ID 54426 //
     /* 2320833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2320836 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2320839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2320853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320875 */     // GIR_Coverage, 54426,
     /* 2320875 */     GIR_EraseRootFromParent_Done,
     /* 2320876 */   // Label 31894: @2320876
     /* 2320876 */   GIM_Try, /*On fail goto*//*Label 31895*/ GIMT_Encode4(2320924), // Rule ID 54427 //
     /* 2320881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2320884 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2320887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2320901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320923 */     // GIR_Coverage, 54427,
     /* 2320923 */     GIR_EraseRootFromParent_Done,
     /* 2320924 */   // Label 31895: @2320924
     /* 2320924 */   GIM_Reject,
     /* 2320925 */ // Label 31893: @2320925
     /* 2320925 */ GIM_Reject,
     /* 2320926 */ // Label 31860: @2320926
     /* 2320926 */ GIM_Try, /*On fail goto*//*Label 31896*/ GIMT_Encode4(2321046),
     /* 2320931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2320934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2320937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2320949 */   GIM_Try, /*On fail goto*//*Label 31897*/ GIMT_Encode4(2320997), // Rule ID 54462 //
     /* 2320954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2320957 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2320960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2320974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2320983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2320986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320996 */     // GIR_Coverage, 54462,
     /* 2320996 */     GIR_EraseRootFromParent_Done,
     /* 2320997 */   // Label 31897: @2320997
     /* 2320997 */   GIM_Try, /*On fail goto*//*Label 31898*/ GIMT_Encode4(2321045), // Rule ID 54463 //
     /* 2321002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321005 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2321008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2321022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321044 */     // GIR_Coverage, 54463,
     /* 2321044 */     GIR_EraseRootFromParent_Done,
     /* 2321045 */   // Label 31898: @2321045
     /* 2321045 */   GIM_Reject,
     /* 2321046 */ // Label 31896: @2321046
     /* 2321046 */ GIM_Reject,
     /* 2321047 */ // Label 31861: @2321047
     /* 2321047 */ GIM_Try, /*On fail goto*//*Label 31899*/ GIMT_Encode4(2321167),
     /* 2321052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2321055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2321058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321070 */   GIM_Try, /*On fail goto*//*Label 31900*/ GIMT_Encode4(2321118), // Rule ID 54414 //
     /* 2321075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321078 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2321081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2321095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321117 */     // GIR_Coverage, 54414,
     /* 2321117 */     GIR_EraseRootFromParent_Done,
     /* 2321118 */   // Label 31900: @2321118
     /* 2321118 */   GIM_Try, /*On fail goto*//*Label 31901*/ GIMT_Encode4(2321166), // Rule ID 54415 //
     /* 2321123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321126 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2321129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2321143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321165 */     // GIR_Coverage, 54415,
     /* 2321165 */     GIR_EraseRootFromParent_Done,
     /* 2321166 */   // Label 31901: @2321166
     /* 2321166 */   GIM_Reject,
     /* 2321167 */ // Label 31899: @2321167
     /* 2321167 */ GIM_Reject,
     /* 2321168 */ // Label 31862: @2321168
     /* 2321168 */ GIM_Try, /*On fail goto*//*Label 31902*/ GIMT_Encode4(2321288),
     /* 2321173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2321176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2321179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321191 */   GIM_Try, /*On fail goto*//*Label 31903*/ GIMT_Encode4(2321239), // Rule ID 54450 //
     /* 2321196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321199 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2321202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2321216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321238 */     // GIR_Coverage, 54450,
     /* 2321238 */     GIR_EraseRootFromParent_Done,
     /* 2321239 */   // Label 31903: @2321239
     /* 2321239 */   GIM_Try, /*On fail goto*//*Label 31904*/ GIMT_Encode4(2321287), // Rule ID 54451 //
     /* 2321244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321247 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2321250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2321264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321286 */     // GIR_Coverage, 54451,
     /* 2321286 */     GIR_EraseRootFromParent_Done,
     /* 2321287 */   // Label 31904: @2321287
     /* 2321287 */   GIM_Reject,
     /* 2321288 */ // Label 31902: @2321288
     /* 2321288 */ GIM_Reject,
     /* 2321289 */ // Label 31863: @2321289
     /* 2321289 */ GIM_Try, /*On fail goto*//*Label 31905*/ GIMT_Encode4(2321409),
     /* 2321294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2321297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2321300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321312 */   GIM_Try, /*On fail goto*//*Label 31906*/ GIMT_Encode4(2321360), // Rule ID 54546 //
     /* 2321317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321320 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2321323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2321337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321359 */     // GIR_Coverage, 54546,
     /* 2321359 */     GIR_EraseRootFromParent_Done,
     /* 2321360 */   // Label 31906: @2321360
     /* 2321360 */   GIM_Try, /*On fail goto*//*Label 31907*/ GIMT_Encode4(2321408), // Rule ID 54547 //
     /* 2321365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321368 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2321371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2321385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321407 */     // GIR_Coverage, 54547,
     /* 2321407 */     GIR_EraseRootFromParent_Done,
     /* 2321408 */   // Label 31907: @2321408
     /* 2321408 */   GIM_Reject,
     /* 2321409 */ // Label 31905: @2321409
     /* 2321409 */ GIM_Reject,
     /* 2321410 */ // Label 31864: @2321410
     /* 2321410 */ GIM_Try, /*On fail goto*//*Label 31908*/ GIMT_Encode4(2321530),
     /* 2321415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2321418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2321421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321433 */   GIM_Try, /*On fail goto*//*Label 31909*/ GIMT_Encode4(2321481), // Rule ID 54438 //
     /* 2321438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321441 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2321444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2321458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321480 */     // GIR_Coverage, 54438,
     /* 2321480 */     GIR_EraseRootFromParent_Done,
     /* 2321481 */   // Label 31909: @2321481
     /* 2321481 */   GIM_Try, /*On fail goto*//*Label 31910*/ GIMT_Encode4(2321529), // Rule ID 54439 //
     /* 2321486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321489 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2321492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2321506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321528 */     // GIR_Coverage, 54439,
     /* 2321528 */     GIR_EraseRootFromParent_Done,
     /* 2321529 */   // Label 31910: @2321529
     /* 2321529 */   GIM_Reject,
     /* 2321530 */ // Label 31908: @2321530
     /* 2321530 */ GIM_Reject,
     /* 2321531 */ // Label 31865: @2321531
     /* 2321531 */ GIM_Try, /*On fail goto*//*Label 31911*/ GIMT_Encode4(2321651),
     /* 2321536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2321539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2321542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321554 */   GIM_Try, /*On fail goto*//*Label 31912*/ GIMT_Encode4(2321602), // Rule ID 54510 //
     /* 2321559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321562 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2321565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2321579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321601 */     // GIR_Coverage, 54510,
     /* 2321601 */     GIR_EraseRootFromParent_Done,
     /* 2321602 */   // Label 31912: @2321602
     /* 2321602 */   GIM_Try, /*On fail goto*//*Label 31913*/ GIMT_Encode4(2321650), // Rule ID 54511 //
     /* 2321607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321610 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2321613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2321627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321649 */     // GIR_Coverage, 54511,
     /* 2321649 */     GIR_EraseRootFromParent_Done,
     /* 2321650 */   // Label 31913: @2321650
     /* 2321650 */   GIM_Reject,
     /* 2321651 */ // Label 31911: @2321651
     /* 2321651 */ GIM_Reject,
     /* 2321652 */ // Label 31866: @2321652
     /* 2321652 */ GIM_Try, /*On fail goto*//*Label 31914*/ GIMT_Encode4(2321772),
     /* 2321657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2321660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2321663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321675 */   GIM_Try, /*On fail goto*//*Label 31915*/ GIMT_Encode4(2321723), // Rule ID 54558 //
     /* 2321680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2321683 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2321686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2321700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321722 */     // GIR_Coverage, 54558,
     /* 2321722 */     GIR_EraseRootFromParent_Done,
     /* 2321723 */   // Label 31915: @2321723
     /* 2321723 */   GIM_Try, /*On fail goto*//*Label 31916*/ GIMT_Encode4(2321771), // Rule ID 54559 //
     /* 2321728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2321731 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2321734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2321748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2321766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321770 */     // GIR_Coverage, 54559,
     /* 2321770 */     GIR_EraseRootFromParent_Done,
     /* 2321771 */   // Label 31916: @2321771
     /* 2321771 */   GIM_Reject,
     /* 2321772 */ // Label 31914: @2321772
     /* 2321772 */ GIM_Reject,
     /* 2321773 */ // Label 31867: @2321773
     /* 2321773 */ GIM_Try, /*On fail goto*//*Label 31917*/ GIMT_Encode4(2321893),
     /* 2321778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2321781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2321784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2321796 */   GIM_Try, /*On fail goto*//*Label 31918*/ GIMT_Encode4(2321844), // Rule ID 54474 //
     /* 2321801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2321804 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2321807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2321821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321843 */     // GIR_Coverage, 54474,
     /* 2321843 */     GIR_EraseRootFromParent_Done,
     /* 2321844 */   // Label 31918: @2321844
     /* 2321844 */   GIM_Try, /*On fail goto*//*Label 31919*/ GIMT_Encode4(2321892), // Rule ID 54475 //
     /* 2321849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2321852 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2321855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2321869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321891 */     // GIR_Coverage, 54475,
     /* 2321891 */     GIR_EraseRootFromParent_Done,
     /* 2321892 */   // Label 31919: @2321892
     /* 2321892 */   GIM_Reject,
     /* 2321893 */ // Label 31917: @2321893
     /* 2321893 */ GIM_Reject,
     /* 2321894 */ // Label 31868: @2321894
     /* 2321894 */ GIM_Try, /*On fail goto*//*Label 31920*/ GIMT_Encode4(2322014),
     /* 2321899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2321902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2321905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2321917 */   GIM_Try, /*On fail goto*//*Label 31921*/ GIMT_Encode4(2321965), // Rule ID 54522 //
     /* 2321922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2321925 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2321928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2321942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2321960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2321964 */     // GIR_Coverage, 54522,
     /* 2321964 */     GIR_EraseRootFromParent_Done,
     /* 2321965 */   // Label 31921: @2321965
     /* 2321965 */   GIM_Try, /*On fail goto*//*Label 31922*/ GIMT_Encode4(2322013), // Rule ID 54523 //
     /* 2321970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2321973 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2321976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2321990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2321999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322012 */     // GIR_Coverage, 54523,
     /* 2322012 */     GIR_EraseRootFromParent_Done,
     /* 2322013 */   // Label 31922: @2322013
     /* 2322013 */   GIM_Reject,
     /* 2322014 */ // Label 31920: @2322014
     /* 2322014 */ GIM_Reject,
     /* 2322015 */ // Label 31869: @2322015
     /* 2322015 */ GIM_Try, /*On fail goto*//*Label 31923*/ GIMT_Encode4(2322135),
     /* 2322020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2322023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2322026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322038 */   GIM_Try, /*On fail goto*//*Label 31924*/ GIMT_Encode4(2322086), // Rule ID 54570 //
     /* 2322043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2322046 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2322049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2322063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322085 */     // GIR_Coverage, 54570,
     /* 2322085 */     GIR_EraseRootFromParent_Done,
     /* 2322086 */   // Label 31924: @2322086
     /* 2322086 */   GIM_Try, /*On fail goto*//*Label 31925*/ GIMT_Encode4(2322134), // Rule ID 54571 //
     /* 2322091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2322094 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2322097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2322111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322133 */     // GIR_Coverage, 54571,
     /* 2322133 */     GIR_EraseRootFromParent_Done,
     /* 2322134 */   // Label 31925: @2322134
     /* 2322134 */   GIM_Reject,
     /* 2322135 */ // Label 31923: @2322135
     /* 2322135 */ GIM_Reject,
     /* 2322136 */ // Label 31870: @2322136
     /* 2322136 */ GIM_Try, /*On fail goto*//*Label 31926*/ GIMT_Encode4(2322256),
     /* 2322141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2322144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2322147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2322159 */   GIM_Try, /*On fail goto*//*Label 31927*/ GIMT_Encode4(2322207), // Rule ID 54486 //
     /* 2322164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322167 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2322170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2322184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322206 */     // GIR_Coverage, 54486,
     /* 2322206 */     GIR_EraseRootFromParent_Done,
     /* 2322207 */   // Label 31927: @2322207
     /* 2322207 */   GIM_Try, /*On fail goto*//*Label 31928*/ GIMT_Encode4(2322255), // Rule ID 54487 //
     /* 2322212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322215 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2322218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2322232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322254 */     // GIR_Coverage, 54487,
     /* 2322254 */     GIR_EraseRootFromParent_Done,
     /* 2322255 */   // Label 31928: @2322255
     /* 2322255 */   GIM_Reject,
     /* 2322256 */ // Label 31926: @2322256
     /* 2322256 */ GIM_Reject,
     /* 2322257 */ // Label 31871: @2322257
     /* 2322257 */ GIM_Try, /*On fail goto*//*Label 31929*/ GIMT_Encode4(2322377),
     /* 2322262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2322265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2322268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322280 */   GIM_Try, /*On fail goto*//*Label 31930*/ GIMT_Encode4(2322328), // Rule ID 54534 //
     /* 2322285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322288 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2322291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2322305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322327 */     // GIR_Coverage, 54534,
     /* 2322327 */     GIR_EraseRootFromParent_Done,
     /* 2322328 */   // Label 31930: @2322328
     /* 2322328 */   GIM_Try, /*On fail goto*//*Label 31931*/ GIMT_Encode4(2322376), // Rule ID 54535 //
     /* 2322333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2322336 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2322339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2322353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322375 */     // GIR_Coverage, 54535,
     /* 2322375 */     GIR_EraseRootFromParent_Done,
     /* 2322376 */   // Label 31931: @2322376
     /* 2322376 */   GIM_Reject,
     /* 2322377 */ // Label 31929: @2322377
     /* 2322377 */ GIM_Reject,
     /* 2322378 */ // Label 31872: @2322378
     /* 2322378 */ GIM_Try, /*On fail goto*//*Label 31932*/ GIMT_Encode4(2322498),
     /* 2322383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2322386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2322389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2322401 */   GIM_Try, /*On fail goto*//*Label 31933*/ GIMT_Encode4(2322449), // Rule ID 54498 //
     /* 2322406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322409 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2322412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2322426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322448 */     // GIR_Coverage, 54498,
     /* 2322448 */     GIR_EraseRootFromParent_Done,
     /* 2322449 */   // Label 31933: @2322449
     /* 2322449 */   GIM_Try, /*On fail goto*//*Label 31934*/ GIMT_Encode4(2322497), // Rule ID 54499 //
     /* 2322454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322457 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2322460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2322474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2322483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322496 */     // GIR_Coverage, 54499,
     /* 2322496 */     GIR_EraseRootFromParent_Done,
     /* 2322497 */   // Label 31934: @2322497
     /* 2322497 */   GIM_Reject,
     /* 2322498 */ // Label 31932: @2322498
     /* 2322498 */ GIM_Reject,
     /* 2322499 */ // Label 31873: @2322499
     /* 2322499 */ GIM_Reject,
     /* 2322500 */ // Label 64: @2322500
     /* 2322500 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31953*/ GIMT_Encode4(2324470),
     /* 2322511 */ /*GILLT_s16*//*Label 31935*/ GIMT_Encode4(2322631),
     /* 2322515 */ /*GILLT_s32*//*Label 31936*/ GIMT_Encode4(2322695),
     /* 2322519 */ /*GILLT_s64*//*Label 31937*/ GIMT_Encode4(2322759), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322531 */ /*GILLT_nxv1s16*//*Label 31938*/ GIMT_Encode4(2322850),
     /* 2322535 */ /*GILLT_nxv1s32*//*Label 31939*/ GIMT_Encode4(2322958),
     /* 2322539 */ /*GILLT_nxv1s64*//*Label 31940*/ GIMT_Encode4(2323066), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322551 */ /*GILLT_nxv2s16*//*Label 31941*/ GIMT_Encode4(2323174),
     /* 2322555 */ /*GILLT_nxv2s32*//*Label 31942*/ GIMT_Encode4(2323282),
     /* 2322559 */ /*GILLT_nxv2s64*//*Label 31943*/ GIMT_Encode4(2323390), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322571 */ /*GILLT_nxv4s16*//*Label 31944*/ GIMT_Encode4(2323498),
     /* 2322575 */ /*GILLT_nxv4s32*//*Label 31945*/ GIMT_Encode4(2323606),
     /* 2322579 */ /*GILLT_nxv4s64*//*Label 31946*/ GIMT_Encode4(2323714), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322591 */ /*GILLT_nxv8s16*//*Label 31947*/ GIMT_Encode4(2323822),
     /* 2322595 */ /*GILLT_nxv8s32*//*Label 31948*/ GIMT_Encode4(2323930),
     /* 2322599 */ /*GILLT_nxv8s64*//*Label 31949*/ GIMT_Encode4(2324038), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322611 */ /*GILLT_nxv16s16*//*Label 31950*/ GIMT_Encode4(2324146),
     /* 2322615 */ /*GILLT_nxv16s32*//*Label 31951*/ GIMT_Encode4(2324254), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2322627 */ /*GILLT_nxv32s16*//*Label 31952*/ GIMT_Encode4(2324362),
     /* 2322631 */ // Label 31935: @2322631
     /* 2322631 */ GIM_Try, /*On fail goto*//*Label 31954*/ GIMT_Encode4(2322694),
     /* 2322636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2322639 */   GIM_Try, /*On fail goto*//*Label 31955*/ GIMT_Encode4(2322666), // Rule ID 1988 //
     /* 2322644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2322647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2322651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2322655 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2322655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2322658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322665 */     // GIR_Coverage, 1988,
     /* 2322665 */     GIR_EraseRootFromParent_Done,
     /* 2322666 */   // Label 31955: @2322666
     /* 2322666 */   GIM_Try, /*On fail goto*//*Label 31956*/ GIMT_Encode4(2322693), // Rule ID 2021 //
     /* 2322671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2322674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2322678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2322682 */     // (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2322682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2322685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322692 */     // GIR_Coverage, 2021,
     /* 2322692 */     GIR_EraseRootFromParent_Done,
     /* 2322693 */   // Label 31956: @2322693
     /* 2322693 */   GIM_Reject,
     /* 2322694 */ // Label 31954: @2322694
     /* 2322694 */ GIM_Reject,
     /* 2322695 */ // Label 31936: @2322695
     /* 2322695 */ GIM_Try, /*On fail goto*//*Label 31957*/ GIMT_Encode4(2322758),
     /* 2322700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2322703 */   GIM_Try, /*On fail goto*//*Label 31958*/ GIMT_Encode4(2322730), // Rule ID 1279 //
     /* 2322708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2322711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2322715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2322719 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2322719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2322722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322729 */     // GIR_Coverage, 1279,
     /* 2322729 */     GIR_EraseRootFromParent_Done,
     /* 2322730 */   // Label 31958: @2322730
     /* 2322730 */   GIM_Try, /*On fail goto*//*Label 31959*/ GIMT_Encode4(2322757), // Rule ID 1287 //
     /* 2322735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2322738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2322742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2322746 */     // (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2322746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2322749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322756 */     // GIR_Coverage, 1287,
     /* 2322756 */     GIR_EraseRootFromParent_Done,
     /* 2322757 */   // Label 31959: @2322757
     /* 2322757 */   GIM_Reject,
     /* 2322758 */ // Label 31957: @2322758
     /* 2322758 */ GIM_Reject,
     /* 2322759 */ // Label 31937: @2322759
     /* 2322759 */ GIM_Try, /*On fail goto*//*Label 31960*/ GIMT_Encode4(2322849),
     /* 2322764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2322767 */   GIM_Try, /*On fail goto*//*Label 31961*/ GIMT_Encode4(2322794), // Rule ID 1622 //
     /* 2322772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2322775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2322779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2322783 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2322783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2322786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322793 */     // GIR_Coverage, 1622,
     /* 2322793 */     GIR_EraseRootFromParent_Done,
     /* 2322794 */   // Label 31961: @2322794
     /* 2322794 */   GIM_Try, /*On fail goto*//*Label 31962*/ GIMT_Encode4(2322821), // Rule ID 1655 //
     /* 2322799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2322802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2322806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2322810 */     // (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2322810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2322813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322820 */     // GIR_Coverage, 1655,
     /* 2322820 */     GIR_EraseRootFromParent_Done,
     /* 2322821 */   // Label 31962: @2322821
     /* 2322821 */   GIM_Try, /*On fail goto*//*Label 31963*/ GIMT_Encode4(2322848), // Rule ID 1677 //
     /* 2322826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2322829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2322833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2322837 */     // (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2322837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2322840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322847 */     // GIR_Coverage, 1677,
     /* 2322847 */     GIR_EraseRootFromParent_Done,
     /* 2322848 */   // Label 31963: @2322848
     /* 2322848 */   GIM_Reject,
     /* 2322849 */ // Label 31960: @2322849
     /* 2322849 */ GIM_Reject,
     /* 2322850 */ // Label 31938: @2322850
     /* 2322850 */ GIM_Try, /*On fail goto*//*Label 31964*/ GIMT_Encode4(2322957),
     /* 2322855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2322858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322866 */   GIM_Try, /*On fail goto*//*Label 31965*/ GIMT_Encode4(2322911), // Rule ID 56240 //
     /* 2322871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2322874 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2322877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2322891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2322898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2322900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322910 */     // GIR_Coverage, 56240,
     /* 2322910 */     GIR_EraseRootFromParent_Done,
     /* 2322911 */   // Label 31965: @2322911
     /* 2322911 */   GIM_Try, /*On fail goto*//*Label 31966*/ GIMT_Encode4(2322956), // Rule ID 56241 //
     /* 2322916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2322919 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2322922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2322936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2322943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2322945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2322955 */     // GIR_Coverage, 56241,
     /* 2322955 */     GIR_EraseRootFromParent_Done,
     /* 2322956 */   // Label 31966: @2322956
     /* 2322956 */   GIM_Reject,
     /* 2322957 */ // Label 31964: @2322957
     /* 2322957 */ GIM_Reject,
     /* 2322958 */ // Label 31939: @2322958
     /* 2322958 */ GIM_Try, /*On fail goto*//*Label 31967*/ GIMT_Encode4(2323065),
     /* 2322963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2322966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322974 */   GIM_Try, /*On fail goto*//*Label 31968*/ GIMT_Encode4(2323019), // Rule ID 56280 //
     /* 2322979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2322982 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2322985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2322999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323018 */     // GIR_Coverage, 56280,
     /* 2323018 */     GIR_EraseRootFromParent_Done,
     /* 2323019 */   // Label 31968: @2323019
     /* 2323019 */   GIM_Try, /*On fail goto*//*Label 31969*/ GIMT_Encode4(2323064), // Rule ID 56281 //
     /* 2323024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323027 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2323030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2323044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323063 */     // GIR_Coverage, 56281,
     /* 2323063 */     GIR_EraseRootFromParent_Done,
     /* 2323064 */   // Label 31969: @2323064
     /* 2323064 */   GIM_Reject,
     /* 2323065 */ // Label 31967: @2323065
     /* 2323065 */ GIM_Reject,
     /* 2323066 */ // Label 31940: @2323066
     /* 2323066 */ GIM_Try, /*On fail goto*//*Label 31970*/ GIMT_Encode4(2323173),
     /* 2323071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2323074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323082 */   GIM_Try, /*On fail goto*//*Label 31971*/ GIMT_Encode4(2323127), // Rule ID 56340 //
     /* 2323087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323090 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2323093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2323107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323126 */     // GIR_Coverage, 56340,
     /* 2323126 */     GIR_EraseRootFromParent_Done,
     /* 2323127 */   // Label 31971: @2323127
     /* 2323127 */   GIM_Try, /*On fail goto*//*Label 31972*/ GIMT_Encode4(2323172), // Rule ID 56341 //
     /* 2323132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323135 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2323138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2323152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323171 */     // GIR_Coverage, 56341,
     /* 2323171 */     GIR_EraseRootFromParent_Done,
     /* 2323172 */   // Label 31972: @2323172
     /* 2323172 */   GIM_Reject,
     /* 2323173 */ // Label 31970: @2323173
     /* 2323173 */ GIM_Reject,
     /* 2323174 */ // Label 31941: @2323174
     /* 2323174 */ GIM_Try, /*On fail goto*//*Label 31973*/ GIMT_Encode4(2323281),
     /* 2323179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2323182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323190 */   GIM_Try, /*On fail goto*//*Label 31974*/ GIMT_Encode4(2323235), // Rule ID 56260 //
     /* 2323195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323198 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2323201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2323215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323234 */     // GIR_Coverage, 56260,
     /* 2323234 */     GIR_EraseRootFromParent_Done,
     /* 2323235 */   // Label 31974: @2323235
     /* 2323235 */   GIM_Try, /*On fail goto*//*Label 31975*/ GIMT_Encode4(2323280), // Rule ID 56261 //
     /* 2323240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323243 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2323246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2323260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323279 */     // GIR_Coverage, 56261,
     /* 2323279 */     GIR_EraseRootFromParent_Done,
     /* 2323280 */   // Label 31975: @2323280
     /* 2323280 */   GIM_Reject,
     /* 2323281 */ // Label 31973: @2323281
     /* 2323281 */ GIM_Reject,
     /* 2323282 */ // Label 31942: @2323282
     /* 2323282 */ GIM_Try, /*On fail goto*//*Label 31976*/ GIMT_Encode4(2323389),
     /* 2323287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2323290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323298 */   GIM_Try, /*On fail goto*//*Label 31977*/ GIMT_Encode4(2323343), // Rule ID 56320 //
     /* 2323303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2323306 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2323323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323342 */     // GIR_Coverage, 56320,
     /* 2323342 */     GIR_EraseRootFromParent_Done,
     /* 2323343 */   // Label 31977: @2323343
     /* 2323343 */   GIM_Try, /*On fail goto*//*Label 31978*/ GIMT_Encode4(2323388), // Rule ID 56321 //
     /* 2323348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323351 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2323368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323387 */     // GIR_Coverage, 56321,
     /* 2323387 */     GIR_EraseRootFromParent_Done,
     /* 2323388 */   // Label 31978: @2323388
     /* 2323388 */   GIM_Reject,
     /* 2323389 */ // Label 31976: @2323389
     /* 2323389 */ GIM_Reject,
     /* 2323390 */ // Label 31943: @2323390
     /* 2323390 */ GIM_Try, /*On fail goto*//*Label 31979*/ GIMT_Encode4(2323497),
     /* 2323395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2323398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323406 */   GIM_Try, /*On fail goto*//*Label 31980*/ GIMT_Encode4(2323451), // Rule ID 56480 //
     /* 2323411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323414 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2323431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323450 */     // GIR_Coverage, 56480,
     /* 2323450 */     GIR_EraseRootFromParent_Done,
     /* 2323451 */   // Label 31980: @2323451
     /* 2323451 */   GIM_Try, /*On fail goto*//*Label 31981*/ GIMT_Encode4(2323496), // Rule ID 56481 //
     /* 2323456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323459 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2323476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323495 */     // GIR_Coverage, 56481,
     /* 2323495 */     GIR_EraseRootFromParent_Done,
     /* 2323496 */   // Label 31981: @2323496
     /* 2323496 */   GIM_Reject,
     /* 2323497 */ // Label 31979: @2323497
     /* 2323497 */ GIM_Reject,
     /* 2323498 */ // Label 31944: @2323498
     /* 2323498 */ GIM_Try, /*On fail goto*//*Label 31982*/ GIMT_Encode4(2323605),
     /* 2323503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2323506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323514 */   GIM_Try, /*On fail goto*//*Label 31983*/ GIMT_Encode4(2323559), // Rule ID 56300 //
     /* 2323519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323522 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2323539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323558 */     // GIR_Coverage, 56300,
     /* 2323558 */     GIR_EraseRootFromParent_Done,
     /* 2323559 */   // Label 31983: @2323559
     /* 2323559 */   GIM_Try, /*On fail goto*//*Label 31984*/ GIMT_Encode4(2323604), // Rule ID 56301 //
     /* 2323564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323567 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2323584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323603 */     // GIR_Coverage, 56301,
     /* 2323603 */     GIR_EraseRootFromParent_Done,
     /* 2323604 */   // Label 31984: @2323604
     /* 2323604 */   GIM_Reject,
     /* 2323605 */ // Label 31982: @2323605
     /* 2323605 */ GIM_Reject,
     /* 2323606 */ // Label 31945: @2323606
     /* 2323606 */ GIM_Try, /*On fail goto*//*Label 31985*/ GIMT_Encode4(2323713),
     /* 2323611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2323614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323622 */   GIM_Try, /*On fail goto*//*Label 31986*/ GIMT_Encode4(2323667), // Rule ID 56420 //
     /* 2323627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2323630 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2323633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2323647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323666 */     // GIR_Coverage, 56420,
     /* 2323666 */     GIR_EraseRootFromParent_Done,
     /* 2323667 */   // Label 31986: @2323667
     /* 2323667 */   GIM_Try, /*On fail goto*//*Label 31987*/ GIMT_Encode4(2323712), // Rule ID 56421 //
     /* 2323672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323675 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2323678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2323692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323711 */     // GIR_Coverage, 56421,
     /* 2323711 */     GIR_EraseRootFromParent_Done,
     /* 2323712 */   // Label 31987: @2323712
     /* 2323712 */   GIM_Reject,
     /* 2323713 */ // Label 31985: @2323713
     /* 2323713 */ GIM_Reject,
     /* 2323714 */ // Label 31946: @2323714
     /* 2323714 */ GIM_Try, /*On fail goto*//*Label 31988*/ GIMT_Encode4(2323821),
     /* 2323719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2323722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323730 */   GIM_Try, /*On fail goto*//*Label 31989*/ GIMT_Encode4(2323775), // Rule ID 56500 //
     /* 2323735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2323738 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2323741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2323755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323774 */     // GIR_Coverage, 56500,
     /* 2323774 */     GIR_EraseRootFromParent_Done,
     /* 2323775 */   // Label 31989: @2323775
     /* 2323775 */   GIM_Try, /*On fail goto*//*Label 31990*/ GIMT_Encode4(2323820), // Rule ID 56501 //
     /* 2323780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2323783 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2323786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2323800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323819 */     // GIR_Coverage, 56501,
     /* 2323819 */     GIR_EraseRootFromParent_Done,
     /* 2323820 */   // Label 31990: @2323820
     /* 2323820 */   GIM_Reject,
     /* 2323821 */ // Label 31988: @2323821
     /* 2323821 */ GIM_Reject,
     /* 2323822 */ // Label 31947: @2323822
     /* 2323822 */ GIM_Try, /*On fail goto*//*Label 31991*/ GIMT_Encode4(2323929),
     /* 2323827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2323830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323838 */   GIM_Try, /*On fail goto*//*Label 31992*/ GIMT_Encode4(2323883), // Rule ID 56360 //
     /* 2323843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2323846 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2323849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2323863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323870 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323882 */     // GIR_Coverage, 56360,
     /* 2323882 */     GIR_EraseRootFromParent_Done,
     /* 2323883 */   // Label 31992: @2323883
     /* 2323883 */   GIM_Try, /*On fail goto*//*Label 31993*/ GIMT_Encode4(2323928), // Rule ID 56361 //
     /* 2323888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2323891 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2323894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2323908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323927 */     // GIR_Coverage, 56361,
     /* 2323927 */     GIR_EraseRootFromParent_Done,
     /* 2323928 */   // Label 31993: @2323928
     /* 2323928 */   GIM_Reject,
     /* 2323929 */ // Label 31991: @2323929
     /* 2323929 */ GIM_Reject,
     /* 2323930 */ // Label 31948: @2323930
     /* 2323930 */ GIM_Try, /*On fail goto*//*Label 31994*/ GIMT_Encode4(2324037),
     /* 2323935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2323938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2323946 */   GIM_Try, /*On fail goto*//*Label 31995*/ GIMT_Encode4(2323991), // Rule ID 56440 //
     /* 2323951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2323954 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2323957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2323971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2323980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2323990 */     // GIR_Coverage, 56440,
     /* 2323990 */     GIR_EraseRootFromParent_Done,
     /* 2323991 */   // Label 31995: @2323991
     /* 2323991 */   GIM_Try, /*On fail goto*//*Label 31996*/ GIMT_Encode4(2324036), // Rule ID 56441 //
     /* 2323996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2323999 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2324016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324035 */     // GIR_Coverage, 56441,
     /* 2324035 */     GIR_EraseRootFromParent_Done,
     /* 2324036 */   // Label 31996: @2324036
     /* 2324036 */   GIM_Reject,
     /* 2324037 */ // Label 31994: @2324037
     /* 2324037 */ GIM_Reject,
     /* 2324038 */ // Label 31949: @2324038
     /* 2324038 */ GIM_Try, /*On fail goto*//*Label 31997*/ GIMT_Encode4(2324145),
     /* 2324043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2324046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324054 */   GIM_Try, /*On fail goto*//*Label 31998*/ GIMT_Encode4(2324099), // Rule ID 56520 //
     /* 2324059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2324062 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2324079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324098 */     // GIR_Coverage, 56520,
     /* 2324098 */     GIR_EraseRootFromParent_Done,
     /* 2324099 */   // Label 31998: @2324099
     /* 2324099 */   GIM_Try, /*On fail goto*//*Label 31999*/ GIMT_Encode4(2324144), // Rule ID 56521 //
     /* 2324104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2324107 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2324110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2324124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324143 */     // GIR_Coverage, 56521,
     /* 2324143 */     GIR_EraseRootFromParent_Done,
     /* 2324144 */   // Label 31999: @2324144
     /* 2324144 */   GIM_Reject,
     /* 2324145 */ // Label 31997: @2324145
     /* 2324145 */ GIM_Reject,
     /* 2324146 */ // Label 31950: @2324146
     /* 2324146 */ GIM_Try, /*On fail goto*//*Label 32000*/ GIMT_Encode4(2324253),
     /* 2324151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2324154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324162 */   GIM_Try, /*On fail goto*//*Label 32001*/ GIMT_Encode4(2324207), // Rule ID 56380 //
     /* 2324167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324170 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2324187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324206 */     // GIR_Coverage, 56380,
     /* 2324206 */     GIR_EraseRootFromParent_Done,
     /* 2324207 */   // Label 32001: @2324207
     /* 2324207 */   GIM_Try, /*On fail goto*//*Label 32002*/ GIMT_Encode4(2324252), // Rule ID 56381 //
     /* 2324212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324215 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2324218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2324232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324251 */     // GIR_Coverage, 56381,
     /* 2324251 */     GIR_EraseRootFromParent_Done,
     /* 2324252 */   // Label 32002: @2324252
     /* 2324252 */   GIM_Reject,
     /* 2324253 */ // Label 32000: @2324253
     /* 2324253 */ GIM_Reject,
     /* 2324254 */ // Label 31951: @2324254
     /* 2324254 */ GIM_Try, /*On fail goto*//*Label 32003*/ GIMT_Encode4(2324361),
     /* 2324259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2324262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324270 */   GIM_Try, /*On fail goto*//*Label 32004*/ GIMT_Encode4(2324315), // Rule ID 56460 //
     /* 2324275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2324278 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2324281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2324295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324314 */     // GIR_Coverage, 56460,
     /* 2324314 */     GIR_EraseRootFromParent_Done,
     /* 2324315 */   // Label 32004: @2324315
     /* 2324315 */   GIM_Try, /*On fail goto*//*Label 32005*/ GIMT_Encode4(2324360), // Rule ID 56461 //
     /* 2324320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2324323 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2324326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2324340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324359 */     // GIR_Coverage, 56461,
     /* 2324359 */     GIR_EraseRootFromParent_Done,
     /* 2324360 */   // Label 32005: @2324360
     /* 2324360 */   GIM_Reject,
     /* 2324361 */ // Label 32003: @2324361
     /* 2324361 */ GIM_Reject,
     /* 2324362 */ // Label 31952: @2324362
     /* 2324362 */ GIM_Try, /*On fail goto*//*Label 32006*/ GIMT_Encode4(2324469),
     /* 2324367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2324370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2324378 */   GIM_Try, /*On fail goto*//*Label 32007*/ GIMT_Encode4(2324423), // Rule ID 56400 //
     /* 2324383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2324386 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2324389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2324403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324422 */     // GIR_Coverage, 56400,
     /* 2324422 */     GIR_EraseRootFromParent_Done,
     /* 2324423 */   // Label 32007: @2324423
     /* 2324423 */   GIM_Try, /*On fail goto*//*Label 32008*/ GIMT_Encode4(2324468), // Rule ID 56401 //
     /* 2324428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2324431 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2324434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2324448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2324457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324467 */     // GIR_Coverage, 56401,
     /* 2324467 */     GIR_EraseRootFromParent_Done,
     /* 2324468 */   // Label 32008: @2324468
     /* 2324468 */   GIM_Reject,
     /* 2324469 */ // Label 32006: @2324469
     /* 2324469 */ GIM_Reject,
     /* 2324470 */ // Label 31953: @2324470
     /* 2324470 */ GIM_Reject,
     /* 2324471 */ // Label 65: @2324471
     /* 2324471 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 32011*/ GIMT_Encode4(2324923),
     /* 2324482 */ /*GILLT_s32*//*Label 32009*/ GIMT_Encode4(2324490),
     /* 2324486 */ /*GILLT_s64*//*Label 32010*/ GIMT_Encode4(2324612),
     /* 2324490 */ // Label 32009: @2324490
     /* 2324490 */ GIM_Try, /*On fail goto*//*Label 32012*/ GIMT_Encode4(2324611),
     /* 2324495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2324498 */   GIM_Try, /*On fail goto*//*Label 32013*/ GIMT_Encode4(2324526), // Rule ID 2162 //
     /* 2324503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2324506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2324510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2324514 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2324514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2324517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324525 */     // GIR_Coverage, 2162,
     /* 2324525 */     GIR_EraseRootFromParent_Done,
     /* 2324526 */   // Label 32013: @2324526
     /* 2324526 */   GIM_Try, /*On fail goto*//*Label 32014*/ GIMT_Encode4(2324554), // Rule ID 2163 //
     /* 2324531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2324534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2324538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2324542 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2324542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2324545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324553 */     // GIR_Coverage, 2163,
     /* 2324553 */     GIR_EraseRootFromParent_Done,
     /* 2324554 */   // Label 32014: @2324554
     /* 2324554 */   GIM_Try, /*On fail goto*//*Label 32015*/ GIMT_Encode4(2324582), // Rule ID 2178 //
     /* 2324559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2324562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2324566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2324570 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2324570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2324573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324581 */     // GIR_Coverage, 2178,
     /* 2324581 */     GIR_EraseRootFromParent_Done,
     /* 2324582 */   // Label 32015: @2324582
     /* 2324582 */   GIM_Try, /*On fail goto*//*Label 32016*/ GIMT_Encode4(2324610), // Rule ID 2179 //
     /* 2324587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2324590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2324594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2324598 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2324598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2324601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2324609 */     // GIR_Coverage, 2179,
     /* 2324609 */     GIR_EraseRootFromParent_Done,
     /* 2324610 */   // Label 32016: @2324610
     /* 2324610 */   GIM_Reject,
     /* 2324611 */ // Label 32012: @2324611
     /* 2324611 */ GIM_Reject,
     /* 2324612 */ // Label 32010: @2324612
     /* 2324612 */ GIM_Try, /*On fail goto*//*Label 32017*/ GIMT_Encode4(2324643), // Rule ID 1564 //
     /* 2324617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2324620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2324623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2324627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2324631 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2324631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2324634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324636 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324642 */   // GIR_Coverage, 1564,
     /* 2324642 */   GIR_EraseRootFromParent_Done,
     /* 2324643 */ // Label 32017: @2324643
     /* 2324643 */ GIM_Try, /*On fail goto*//*Label 32018*/ GIMT_Encode4(2324674), // Rule ID 1565 //
     /* 2324648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2324651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2324654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2324658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2324662 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2324662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2324665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324667 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324672 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324673 */   // GIR_Coverage, 1565,
     /* 2324673 */   GIR_EraseRootFromParent_Done,
     /* 2324674 */ // Label 32018: @2324674
     /* 2324674 */ GIM_Try, /*On fail goto*//*Label 32019*/ GIMT_Encode4(2324705), // Rule ID 1569 //
     /* 2324679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2324682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2324685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2324689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2324693 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_INX:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2324693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2324696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324698 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324704 */   // GIR_Coverage, 1569,
     /* 2324704 */   GIR_EraseRootFromParent_Done,
     /* 2324705 */ // Label 32019: @2324705
     /* 2324705 */ GIM_Try, /*On fail goto*//*Label 32020*/ GIMT_Encode4(2324736), // Rule ID 1576 //
     /* 2324710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2324713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2324716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2324720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2324724 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2324724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2324727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324729 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324735 */   // GIR_Coverage, 1576,
     /* 2324735 */   GIR_EraseRootFromParent_Done,
     /* 2324736 */ // Label 32020: @2324736
     /* 2324736 */ GIM_Try, /*On fail goto*//*Label 32021*/ GIMT_Encode4(2324767), // Rule ID 1577 //
     /* 2324741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2324744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2324747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2324751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2324755 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2324755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2324758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324760 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324765 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324766 */   // GIR_Coverage, 1577,
     /* 2324766 */   GIR_EraseRootFromParent_Done,
     /* 2324767 */ // Label 32021: @2324767
     /* 2324767 */ GIM_Try, /*On fail goto*//*Label 32022*/ GIMT_Encode4(2324798), // Rule ID 2296 //
     /* 2324772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2324775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2324778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2324782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2324786 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2324786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2324789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324791 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324797 */   // GIR_Coverage, 2296,
     /* 2324797 */   GIR_EraseRootFromParent_Done,
     /* 2324798 */ // Label 32022: @2324798
     /* 2324798 */ GIM_Try, /*On fail goto*//*Label 32023*/ GIMT_Encode4(2324829), // Rule ID 2297 //
     /* 2324803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2324806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2324809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2324813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2324817 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2324817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2324820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324822 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324828 */   // GIR_Coverage, 2297,
     /* 2324828 */   GIR_EraseRootFromParent_Done,
     /* 2324829 */ // Label 32023: @2324829
     /* 2324829 */ GIM_Try, /*On fail goto*//*Label 32024*/ GIMT_Encode4(2324860), // Rule ID 2308 //
     /* 2324834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2324837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2324840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2324844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2324848 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2324848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2324851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324859 */   // GIR_Coverage, 2308,
     /* 2324859 */   GIR_EraseRootFromParent_Done,
     /* 2324860 */ // Label 32024: @2324860
     /* 2324860 */ GIM_Try, /*On fail goto*//*Label 32025*/ GIMT_Encode4(2324891), // Rule ID 2309 //
     /* 2324865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2324868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2324871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2324875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2324879 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2324879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2324882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324884 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324889 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324890 */   // GIR_Coverage, 2309,
     /* 2324890 */   GIR_EraseRootFromParent_Done,
     /* 2324891 */ // Label 32025: @2324891
     /* 2324891 */ GIM_Try, /*On fail goto*//*Label 32026*/ GIMT_Encode4(2324922), // Rule ID 2317 //
     /* 2324896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2324899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2324902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2324906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2324910 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_INX:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2324910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2324913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324915 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2324920 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324921 */   // GIR_Coverage, 2317,
     /* 2324921 */   GIR_EraseRootFromParent_Done,
     /* 2324922 */ // Label 32026: @2324922
     /* 2324922 */ GIM_Reject,
     /* 2324923 */ // Label 32011: @2324923
     /* 2324923 */ GIM_Reject,
     /* 2324924 */ // Label 66: @2324924
     /* 2324924 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(28), /*)*//*default:*//*Label 32038*/ GIMT_Encode4(2326459),
     /* 2324935 */ /*GILLT_s16*//*Label 32027*/ GIMT_Encode4(2325039),
     /* 2324939 */ /*GILLT_s32*//*Label 32028*/ GIMT_Encode4(2325319), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2324955 */ /*GILLT_nxv1s16*//*Label 32029*/ GIMT_Encode4(2325469),
     /* 2324959 */ /*GILLT_nxv1s32*//*Label 32030*/ GIMT_Encode4(2325579), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2324975 */ /*GILLT_nxv2s16*//*Label 32031*/ GIMT_Encode4(2325689),
     /* 2324979 */ /*GILLT_nxv2s32*//*Label 32032*/ GIMT_Encode4(2325799), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2324995 */ /*GILLT_nxv4s16*//*Label 32033*/ GIMT_Encode4(2325909),
     /* 2324999 */ /*GILLT_nxv4s32*//*Label 32034*/ GIMT_Encode4(2326019), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325015 */ /*GILLT_nxv8s16*//*Label 32035*/ GIMT_Encode4(2326129),
     /* 2325019 */ /*GILLT_nxv8s32*//*Label 32036*/ GIMT_Encode4(2326239), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2325035 */ /*GILLT_nxv16s16*//*Label 32037*/ GIMT_Encode4(2326349),
     /* 2325039 */ // Label 32027: @2325039
     /* 2325039 */ GIM_Try, /*On fail goto*//*Label 32039*/ GIMT_Encode4(2325070), // Rule ID 2158 //
     /* 2325044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2325047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325058 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2325058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2325061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325063 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325069 */   // GIR_Coverage, 2158,
     /* 2325069 */   GIR_EraseRootFromParent_Done,
     /* 2325070 */ // Label 32039: @2325070
     /* 2325070 */ GIM_Try, /*On fail goto*//*Label 32040*/ GIMT_Encode4(2325101), // Rule ID 2159 //
     /* 2325075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2325078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325089 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2325089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2325092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325094 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325100 */   // GIR_Coverage, 2159,
     /* 2325100 */   GIR_EraseRootFromParent_Done,
     /* 2325101 */ // Label 32040: @2325101
     /* 2325101 */ GIM_Try, /*On fail goto*//*Label 32041*/ GIMT_Encode4(2325132), // Rule ID 2174 //
     /* 2325106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2325109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325120 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2325120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2325123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325125 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325131 */   // GIR_Coverage, 2174,
     /* 2325131 */   GIR_EraseRootFromParent_Done,
     /* 2325132 */ // Label 32041: @2325132
     /* 2325132 */ GIM_Try, /*On fail goto*//*Label 32042*/ GIMT_Encode4(2325163), // Rule ID 2175 //
     /* 2325137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2325140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2325143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325151 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2325151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2325154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325156 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325161 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325162 */   // GIR_Coverage, 2175,
     /* 2325162 */   GIR_EraseRootFromParent_Done,
     /* 2325163 */ // Label 32042: @2325163
     /* 2325163 */ GIM_Try, /*On fail goto*//*Label 32043*/ GIMT_Encode4(2325194), // Rule ID 2292 //
     /* 2325168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2325171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325182 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2325185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325187 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325193 */   // GIR_Coverage, 2292,
     /* 2325193 */   GIR_EraseRootFromParent_Done,
     /* 2325194 */ // Label 32043: @2325194
     /* 2325194 */ GIM_Try, /*On fail goto*//*Label 32044*/ GIMT_Encode4(2325225), // Rule ID 2293 //
     /* 2325199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2325202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2325209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325213 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2325213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2325216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325218 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325224 */   // GIR_Coverage, 2293,
     /* 2325224 */   GIR_EraseRootFromParent_Done,
     /* 2325225 */ // Label 32044: @2325225
     /* 2325225 */ GIM_Try, /*On fail goto*//*Label 32045*/ GIMT_Encode4(2325256), // Rule ID 2304 //
     /* 2325230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2325233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325244 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2325247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325249 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325255 */   // GIR_Coverage, 2304,
     /* 2325255 */   GIR_EraseRootFromParent_Done,
     /* 2325256 */ // Label 32045: @2325256
     /* 2325256 */ GIM_Try, /*On fail goto*//*Label 32046*/ GIMT_Encode4(2325287), // Rule ID 2305 //
     /* 2325261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2325264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325275 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2325275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2325278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325280 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325286 */   // GIR_Coverage, 2305,
     /* 2325286 */   GIR_EraseRootFromParent_Done,
     /* 2325287 */ // Label 32046: @2325287
     /* 2325287 */ GIM_Try, /*On fail goto*//*Label 32047*/ GIMT_Encode4(2325318), // Rule ID 2315 //
     /* 2325292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2325295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2325302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325306 */   // (fpround:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_INX:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2325309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325311 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325316 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325317 */   // GIR_Coverage, 2315,
     /* 2325317 */   GIR_EraseRootFromParent_Done,
     /* 2325318 */ // Label 32047: @2325318
     /* 2325318 */ GIM_Reject,
     /* 2325319 */ // Label 32028: @2325319
     /* 2325319 */ GIM_Try, /*On fail goto*//*Label 32048*/ GIMT_Encode4(2325468),
     /* 2325324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2325327 */   GIM_Try, /*On fail goto*//*Label 32049*/ GIMT_Encode4(2325355), // Rule ID 1560 //
     /* 2325332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2325335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325343 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2325346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325354 */     // GIR_Coverage, 1560,
     /* 2325354 */     GIR_EraseRootFromParent_Done,
     /* 2325355 */   // Label 32049: @2325355
     /* 2325355 */   GIM_Try, /*On fail goto*//*Label 32050*/ GIMT_Encode4(2325383), // Rule ID 1561 //
     /* 2325360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2325363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2325367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2325371 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2325371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2325374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325382 */     // GIR_Coverage, 1561,
     /* 2325382 */     GIR_EraseRootFromParent_Done,
     /* 2325383 */   // Label 32050: @2325383
     /* 2325383 */   GIM_Try, /*On fail goto*//*Label 32051*/ GIMT_Encode4(2325411), // Rule ID 1567 //
     /* 2325388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2325391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2325399 */     // (fpround:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_INX:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2325402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325410 */     // GIR_Coverage, 1567,
     /* 2325410 */     GIR_EraseRootFromParent_Done,
     /* 2325411 */   // Label 32051: @2325411
     /* 2325411 */   GIM_Try, /*On fail goto*//*Label 32052*/ GIMT_Encode4(2325439), // Rule ID 1572 //
     /* 2325416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2325419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325427 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2325427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2325430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325438 */     // GIR_Coverage, 1572,
     /* 2325438 */     GIR_EraseRootFromParent_Done,
     /* 2325439 */   // Label 32052: @2325439
     /* 2325439 */   GIM_Try, /*On fail goto*//*Label 32053*/ GIMT_Encode4(2325467), // Rule ID 1573 //
     /* 2325444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2325447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2325451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2325455 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2325455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2325458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325466 */     // GIR_Coverage, 1573,
     /* 2325466 */     GIR_EraseRootFromParent_Done,
     /* 2325467 */   // Label 32053: @2325467
     /* 2325467 */   GIM_Reject,
     /* 2325468 */ // Label 32048: @2325468
     /* 2325468 */ GIM_Reject,
     /* 2325469 */ // Label 32029: @2325469
     /* 2325469 */ GIM_Try, /*On fail goto*//*Label 32054*/ GIMT_Encode4(2325578),
     /* 2325474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2325477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325485 */   GIM_Try, /*On fail goto*//*Label 32055*/ GIMT_Encode4(2325531), // Rule ID 58888 //
     /* 2325490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2325493 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2325496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2325510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325530 */     // GIR_Coverage, 58888,
     /* 2325530 */     GIR_EraseRootFromParent_Done,
     /* 2325531 */   // Label 32055: @2325531
     /* 2325531 */   GIM_Try, /*On fail goto*//*Label 32056*/ GIMT_Encode4(2325577), // Rule ID 58889 //
     /* 2325536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2325539 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2325542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2325556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325576 */     // GIR_Coverage, 58889,
     /* 2325576 */     GIR_EraseRootFromParent_Done,
     /* 2325577 */   // Label 32056: @2325577
     /* 2325577 */   GIM_Reject,
     /* 2325578 */ // Label 32054: @2325578
     /* 2325578 */ GIM_Reject,
     /* 2325579 */ // Label 32030: @2325579
     /* 2325579 */ GIM_Try, /*On fail goto*//*Label 32057*/ GIMT_Encode4(2325688),
     /* 2325584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2325587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325595 */   GIM_Try, /*On fail goto*//*Label 32058*/ GIMT_Encode4(2325641), // Rule ID 58898 //
     /* 2325600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2325603 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2325606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2325620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325640 */     // GIR_Coverage, 58898,
     /* 2325640 */     GIR_EraseRootFromParent_Done,
     /* 2325641 */   // Label 32058: @2325641
     /* 2325641 */   GIM_Try, /*On fail goto*//*Label 32059*/ GIMT_Encode4(2325687), // Rule ID 58899 //
     /* 2325646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2325649 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2325652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2325666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325686 */     // GIR_Coverage, 58899,
     /* 2325686 */     GIR_EraseRootFromParent_Done,
     /* 2325687 */   // Label 32059: @2325687
     /* 2325687 */   GIM_Reject,
     /* 2325688 */ // Label 32057: @2325688
     /* 2325688 */ GIM_Reject,
     /* 2325689 */ // Label 32031: @2325689
     /* 2325689 */ GIM_Try, /*On fail goto*//*Label 32060*/ GIMT_Encode4(2325798),
     /* 2325694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2325697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325705 */   GIM_Try, /*On fail goto*//*Label 32061*/ GIMT_Encode4(2325751), // Rule ID 58890 //
     /* 2325710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2325713 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2325716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2325730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325750 */     // GIR_Coverage, 58890,
     /* 2325750 */     GIR_EraseRootFromParent_Done,
     /* 2325751 */   // Label 32061: @2325751
     /* 2325751 */   GIM_Try, /*On fail goto*//*Label 32062*/ GIMT_Encode4(2325797), // Rule ID 58891 //
     /* 2325756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2325759 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2325762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2325776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325796 */     // GIR_Coverage, 58891,
     /* 2325796 */     GIR_EraseRootFromParent_Done,
     /* 2325797 */   // Label 32062: @2325797
     /* 2325797 */   GIM_Reject,
     /* 2325798 */ // Label 32060: @2325798
     /* 2325798 */ GIM_Reject,
     /* 2325799 */ // Label 32032: @2325799
     /* 2325799 */ GIM_Try, /*On fail goto*//*Label 32063*/ GIMT_Encode4(2325908),
     /* 2325804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2325807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325815 */   GIM_Try, /*On fail goto*//*Label 32064*/ GIMT_Encode4(2325861), // Rule ID 58900 //
     /* 2325820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2325823 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2325826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2325840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325860 */     // GIR_Coverage, 58900,
     /* 2325860 */     GIR_EraseRootFromParent_Done,
     /* 2325861 */   // Label 32064: @2325861
     /* 2325861 */   GIM_Try, /*On fail goto*//*Label 32065*/ GIMT_Encode4(2325907), // Rule ID 58901 //
     /* 2325866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2325869 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2325872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2325886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325906 */     // GIR_Coverage, 58901,
     /* 2325906 */     GIR_EraseRootFromParent_Done,
     /* 2325907 */   // Label 32065: @2325907
     /* 2325907 */   GIM_Reject,
     /* 2325908 */ // Label 32063: @2325908
     /* 2325908 */ GIM_Reject,
     /* 2325909 */ // Label 32033: @2325909
     /* 2325909 */ GIM_Try, /*On fail goto*//*Label 32066*/ GIMT_Encode4(2326018),
     /* 2325914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2325917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2325921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325925 */   GIM_Try, /*On fail goto*//*Label 32067*/ GIMT_Encode4(2325971), // Rule ID 58892 //
     /* 2325930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2325933 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2325936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2325950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2325970 */     // GIR_Coverage, 58892,
     /* 2325970 */     GIR_EraseRootFromParent_Done,
     /* 2325971 */   // Label 32067: @2325971
     /* 2325971 */   GIM_Try, /*On fail goto*//*Label 32068*/ GIMT_Encode4(2326017), // Rule ID 58893 //
     /* 2325976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2325979 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2325982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2325996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326016 */     // GIR_Coverage, 58893,
     /* 2326016 */     GIR_EraseRootFromParent_Done,
     /* 2326017 */   // Label 32068: @2326017
     /* 2326017 */   GIM_Reject,
     /* 2326018 */ // Label 32066: @2326018
     /* 2326018 */ GIM_Reject,
     /* 2326019 */ // Label 32034: @2326019
     /* 2326019 */ GIM_Try, /*On fail goto*//*Label 32069*/ GIMT_Encode4(2326128),
     /* 2326024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2326027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326035 */   GIM_Try, /*On fail goto*//*Label 32070*/ GIMT_Encode4(2326081), // Rule ID 58902 //
     /* 2326040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2326043 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2326046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2326060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326080 */     // GIR_Coverage, 58902,
     /* 2326080 */     GIR_EraseRootFromParent_Done,
     /* 2326081 */   // Label 32070: @2326081
     /* 2326081 */   GIM_Try, /*On fail goto*//*Label 32071*/ GIMT_Encode4(2326127), // Rule ID 58903 //
     /* 2326086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2326089 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2326092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2326106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326126 */     // GIR_Coverage, 58903,
     /* 2326126 */     GIR_EraseRootFromParent_Done,
     /* 2326127 */   // Label 32071: @2326127
     /* 2326127 */   GIM_Reject,
     /* 2326128 */ // Label 32069: @2326128
     /* 2326128 */ GIM_Reject,
     /* 2326129 */ // Label 32035: @2326129
     /* 2326129 */ GIM_Try, /*On fail goto*//*Label 32072*/ GIMT_Encode4(2326238),
     /* 2326134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2326137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2326141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326145 */   GIM_Try, /*On fail goto*//*Label 32073*/ GIMT_Encode4(2326191), // Rule ID 58894 //
     /* 2326150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2326153 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2326156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2326170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326190 */     // GIR_Coverage, 58894,
     /* 2326190 */     GIR_EraseRootFromParent_Done,
     /* 2326191 */   // Label 32073: @2326191
     /* 2326191 */   GIM_Try, /*On fail goto*//*Label 32074*/ GIMT_Encode4(2326237), // Rule ID 58895 //
     /* 2326196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2326199 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2326202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2326216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326236 */     // GIR_Coverage, 58895,
     /* 2326236 */     GIR_EraseRootFromParent_Done,
     /* 2326237 */   // Label 32074: @2326237
     /* 2326237 */   GIM_Reject,
     /* 2326238 */ // Label 32072: @2326238
     /* 2326238 */ GIM_Reject,
     /* 2326239 */ // Label 32036: @2326239
     /* 2326239 */ GIM_Try, /*On fail goto*//*Label 32075*/ GIMT_Encode4(2326348),
     /* 2326244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2326247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326255 */   GIM_Try, /*On fail goto*//*Label 32076*/ GIMT_Encode4(2326301), // Rule ID 58904 //
     /* 2326260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2326263 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2326266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2326280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326300 */     // GIR_Coverage, 58904,
     /* 2326300 */     GIR_EraseRootFromParent_Done,
     /* 2326301 */   // Label 32076: @2326301
     /* 2326301 */   GIM_Try, /*On fail goto*//*Label 32077*/ GIMT_Encode4(2326347), // Rule ID 58905 //
     /* 2326306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2326309 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2326312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2326326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2326342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326346 */     // GIR_Coverage, 58905,
     /* 2326346 */     GIR_EraseRootFromParent_Done,
     /* 2326347 */   // Label 32077: @2326347
     /* 2326347 */   GIM_Reject,
     /* 2326348 */ // Label 32075: @2326348
     /* 2326348 */ GIM_Reject,
     /* 2326349 */ // Label 32037: @2326349
     /* 2326349 */ GIM_Try, /*On fail goto*//*Label 32078*/ GIMT_Encode4(2326458),
     /* 2326354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2326357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326365 */   GIM_Try, /*On fail goto*//*Label 32079*/ GIMT_Encode4(2326411), // Rule ID 58896 //
     /* 2326370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode0),
     /* 2326373 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2326376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2326390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326410 */     // GIR_Coverage, 58896,
     /* 2326410 */     GIR_EraseRootFromParent_Done,
     /* 2326411 */   // Label 32079: @2326411
     /* 2326411 */   GIM_Try, /*On fail goto*//*Label 32080*/ GIMT_Encode4(2326457), // Rule ID 58897 //
     /* 2326416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16Minimal_HwMode1),
     /* 2326419 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2326422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2326436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2326456 */     // GIR_Coverage, 58897,
     /* 2326456 */     GIR_EraseRootFromParent_Done,
     /* 2326457 */   // Label 32080: @2326457
     /* 2326457 */   GIM_Reject,
     /* 2326458 */ // Label 32078: @2326458
     /* 2326458 */ GIM_Reject,
     /* 2326459 */ // Label 32038: @2326459
     /* 2326459 */ GIM_Reject,
     /* 2326460 */ // Label 67: @2326460
     /* 2326460 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32104*/ GIMT_Encode4(2331345),
     /* 2326471 */ /*GILLT_s32*//*Label 32081*/ GIMT_Encode4(2326587),
     /* 2326475 */ /*GILLT_s64*//*Label 32082*/ GIMT_Encode4(2326960), GIMT_Encode4(0),
     /* 2326483 */ /*GILLT_nxv1s8*//*Label 32083*/ GIMT_Encode4(2327147),
     /* 2326487 */ /*GILLT_nxv1s16*//*Label 32084*/ GIMT_Encode4(2327251),
     /* 2326491 */ /*GILLT_nxv1s32*//*Label 32085*/ GIMT_Encode4(2327468),
     /* 2326495 */ /*GILLT_nxv1s64*//*Label 32086*/ GIMT_Encode4(2327793), GIMT_Encode4(0),
     /* 2326503 */ /*GILLT_nxv2s8*//*Label 32087*/ GIMT_Encode4(2328010),
     /* 2326507 */ /*GILLT_nxv2s16*//*Label 32088*/ GIMT_Encode4(2328114),
     /* 2326511 */ /*GILLT_nxv2s32*//*Label 32089*/ GIMT_Encode4(2328331),
     /* 2326515 */ /*GILLT_nxv2s64*//*Label 32090*/ GIMT_Encode4(2328656), GIMT_Encode4(0),
     /* 2326523 */ /*GILLT_nxv4s8*//*Label 32091*/ GIMT_Encode4(2328873),
     /* 2326527 */ /*GILLT_nxv4s16*//*Label 32092*/ GIMT_Encode4(2328977),
     /* 2326531 */ /*GILLT_nxv4s32*//*Label 32093*/ GIMT_Encode4(2329194),
     /* 2326535 */ /*GILLT_nxv4s64*//*Label 32094*/ GIMT_Encode4(2329519), GIMT_Encode4(0),
     /* 2326543 */ /*GILLT_nxv8s8*//*Label 32095*/ GIMT_Encode4(2329736),
     /* 2326547 */ /*GILLT_nxv8s16*//*Label 32096*/ GIMT_Encode4(2329840),
     /* 2326551 */ /*GILLT_nxv8s32*//*Label 32097*/ GIMT_Encode4(2330057),
     /* 2326555 */ /*GILLT_nxv8s64*//*Label 32098*/ GIMT_Encode4(2330382), GIMT_Encode4(0),
     /* 2326563 */ /*GILLT_nxv16s8*//*Label 32099*/ GIMT_Encode4(2330599),
     /* 2326567 */ /*GILLT_nxv16s16*//*Label 32100*/ GIMT_Encode4(2330703),
     /* 2326571 */ /*GILLT_nxv16s32*//*Label 32101*/ GIMT_Encode4(2330920), GIMT_Encode4(0),
     /* 2326579 */ /*GILLT_nxv32s8*//*Label 32102*/ GIMT_Encode4(2331137),
     /* 2326583 */ /*GILLT_nxv32s16*//*Label 32103*/ GIMT_Encode4(2331241),
     /* 2326587 */ // Label 32081: @2326587
     /* 2326587 */ GIM_Try, /*On fail goto*//*Label 32105*/ GIMT_Encode4(2326618), // Rule ID 1452 //
     /* 2326592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2326595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326606 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2326606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2326609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326611 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326616 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326617 */   // GIR_Coverage, 1452,
     /* 2326617 */   GIR_EraseRootFromParent_Done,
     /* 2326618 */ // Label 32105: @2326618
     /* 2326618 */ GIM_Try, /*On fail goto*//*Label 32106*/ GIMT_Encode4(2326649), // Rule ID 1453 //
     /* 2326623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2326626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326637 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2326637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2326640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326642 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326647 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326648 */   // GIR_Coverage, 1453,
     /* 2326648 */   GIR_EraseRootFromParent_Done,
     /* 2326649 */ // Label 32106: @2326649
     /* 2326649 */ GIM_Try, /*On fail goto*//*Label 32107*/ GIMT_Encode4(2326680), // Rule ID 1478 //
     /* 2326654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2326657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326668 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2326668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2326671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326673 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326679 */   // GIR_Coverage, 1478,
     /* 2326679 */   GIR_EraseRootFromParent_Done,
     /* 2326680 */ // Label 32107: @2326680
     /* 2326680 */ GIM_Try, /*On fail goto*//*Label 32108*/ GIMT_Encode4(2326711), // Rule ID 1479 //
     /* 2326685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2326688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326699 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2326699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2326702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326704 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326710 */   // GIR_Coverage, 1479,
     /* 2326710 */   GIR_EraseRootFromParent_Done,
     /* 2326711 */ // Label 32108: @2326711
     /* 2326711 */ GIM_Try, /*On fail goto*//*Label 32109*/ GIMT_Encode4(2326742), // Rule ID 1846 //
     /* 2326716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2326719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326730 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2326730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2326733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326735 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326741 */   // GIR_Coverage, 1846,
     /* 2326741 */   GIR_EraseRootFromParent_Done,
     /* 2326742 */ // Label 32109: @2326742
     /* 2326742 */ GIM_Try, /*On fail goto*//*Label 32110*/ GIMT_Encode4(2326773), // Rule ID 1847 //
     /* 2326747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2326750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326761 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2326761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2326764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326766 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326771 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326772 */   // GIR_Coverage, 1847,
     /* 2326772 */   GIR_EraseRootFromParent_Done,
     /* 2326773 */ // Label 32110: @2326773
     /* 2326773 */ GIM_Try, /*On fail goto*//*Label 32111*/ GIMT_Encode4(2326804), // Rule ID 1872 //
     /* 2326778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2326781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326792 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2326792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2326795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326797 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326802 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326803 */   // GIR_Coverage, 1872,
     /* 2326803 */   GIR_EraseRootFromParent_Done,
     /* 2326804 */ // Label 32111: @2326804
     /* 2326804 */ GIM_Try, /*On fail goto*//*Label 32112*/ GIMT_Encode4(2326835), // Rule ID 1873 //
     /* 2326809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2326812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2326823 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2326823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2326826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326828 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326833 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326834 */   // GIR_Coverage, 1873,
     /* 2326834 */   GIR_EraseRootFromParent_Done,
     /* 2326835 */ // Label 32112: @2326835
     /* 2326835 */ GIM_Try, /*On fail goto*//*Label 32113*/ GIMT_Encode4(2326866), // Rule ID 2188 //
     /* 2326840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2326843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2326846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326854 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2326854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2326857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326859 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326864 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326865 */   // GIR_Coverage, 2188,
     /* 2326865 */   GIR_EraseRootFromParent_Done,
     /* 2326866 */ // Label 32113: @2326866
     /* 2326866 */ GIM_Try, /*On fail goto*//*Label 32114*/ GIMT_Encode4(2326897), // Rule ID 2189 //
     /* 2326871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2326874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2326877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326885 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2326885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2326888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326890 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326896 */   // GIR_Coverage, 2189,
     /* 2326896 */   GIR_EraseRootFromParent_Done,
     /* 2326897 */ // Label 32114: @2326897
     /* 2326897 */ GIM_Try, /*On fail goto*//*Label 32115*/ GIMT_Encode4(2326928), // Rule ID 2214 //
     /* 2326902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2326905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2326908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326916 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2326916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2326919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326921 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326927 */   // GIR_Coverage, 2214,
     /* 2326927 */   GIR_EraseRootFromParent_Done,
     /* 2326928 */ // Label 32115: @2326928
     /* 2326928 */ GIM_Try, /*On fail goto*//*Label 32116*/ GIMT_Encode4(2326959), // Rule ID 2215 //
     /* 2326933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2326936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2326939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326947 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2326947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2326950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326952 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326957 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326958 */   // GIR_Coverage, 2215,
     /* 2326958 */   GIR_EraseRootFromParent_Done,
     /* 2326959 */ // Label 32116: @2326959
     /* 2326959 */ GIM_Reject,
     /* 2326960 */ // Label 32082: @2326960
     /* 2326960 */ GIM_Try, /*On fail goto*//*Label 32117*/ GIMT_Encode4(2326991), // Rule ID 1509 //
     /* 2326965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2326968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326979 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2326979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2326982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326984 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2326989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326990 */   // GIR_Coverage, 1509,
     /* 2326990 */   GIR_EraseRootFromParent_Done,
     /* 2326991 */ // Label 32117: @2326991
     /* 2326991 */ GIM_Try, /*On fail goto*//*Label 32118*/ GIMT_Encode4(2327022), // Rule ID 1537 //
     /* 2326996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2326999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2327010 */   // (fp_to_sint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2327010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2327013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327015 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327021 */   // GIR_Coverage, 1537,
     /* 2327021 */   GIR_EraseRootFromParent_Done,
     /* 2327022 */ // Label 32118: @2327022
     /* 2327022 */ GIM_Try, /*On fail goto*//*Label 32119*/ GIMT_Encode4(2327053), // Rule ID 1909 //
     /* 2327027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2327030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327041 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2327041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2327044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327046 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327051 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327052 */   // GIR_Coverage, 1909,
     /* 2327052 */   GIR_EraseRootFromParent_Done,
     /* 2327053 */ // Label 32119: @2327053
     /* 2327053 */ GIM_Try, /*On fail goto*//*Label 32120*/ GIMT_Encode4(2327084), // Rule ID 1937 //
     /* 2327058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2327061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327072 */   // (fp_to_sint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2327072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2327075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327077 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327082 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327083 */   // GIR_Coverage, 1937,
     /* 2327083 */   GIR_EraseRootFromParent_Done,
     /* 2327084 */ // Label 32120: @2327084
     /* 2327084 */ GIM_Try, /*On fail goto*//*Label 32121*/ GIMT_Encode4(2327115), // Rule ID 2243 //
     /* 2327089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2327092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2327103 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2327103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2327106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327108 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327113 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327114 */   // GIR_Coverage, 2243,
     /* 2327114 */   GIR_EraseRootFromParent_Done,
     /* 2327115 */ // Label 32121: @2327115
     /* 2327115 */ GIM_Try, /*On fail goto*//*Label 32122*/ GIMT_Encode4(2327146), // Rule ID 2269 //
     /* 2327120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2327123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2327126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2327134 */   // (fp_to_sint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2327134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2327137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327139 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2327144 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327145 */   // GIR_Coverage, 2269,
     /* 2327145 */   GIR_EraseRootFromParent_Done,
     /* 2327146 */ // Label 32122: @2327146
     /* 2327146 */ GIM_Reject,
     /* 2327147 */ // Label 32083: @2327147
     /* 2327147 */ GIM_Try, /*On fail goto*//*Label 32123*/ GIMT_Encode4(2327250),
     /* 2327152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327163 */   GIM_Try, /*On fail goto*//*Label 32124*/ GIMT_Encode4(2327206), // Rule ID 45818 //
     /* 2327168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327171 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2327174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2327188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327205 */     // GIR_Coverage, 45818,
     /* 2327205 */     GIR_EraseRootFromParent_Done,
     /* 2327206 */   // Label 32124: @2327206
     /* 2327206 */   GIM_Try, /*On fail goto*//*Label 32125*/ GIMT_Encode4(2327249), // Rule ID 45819 //
     /* 2327211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327214 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2327217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2327231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2327248 */     // GIR_Coverage, 45819,
     /* 2327248 */     GIR_EraseRootFromParent_Done,
     /* 2327249 */   // Label 32125: @2327249
     /* 2327249 */   GIM_Reject,
     /* 2327250 */ // Label 32123: @2327250
     /* 2327250 */ GIM_Reject,
     /* 2327251 */ // Label 32084: @2327251
     /* 2327251 */ GIM_Try, /*On fail goto*//*Label 32126*/ GIMT_Encode4(2327305), // Rule ID 45802 //
     /* 2327256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327270 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2327287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327292 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327303 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327304 */   // GIR_Coverage, 45802,
     /* 2327304 */   GIR_EraseRootFromParent_Done,
     /* 2327305 */ // Label 32126: @2327305
     /* 2327305 */ GIM_Try, /*On fail goto*//*Label 32127*/ GIMT_Encode4(2327359), // Rule ID 45803 //
     /* 2327310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327324 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2327341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327346 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327357 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327358 */   // GIR_Coverage, 45803,
     /* 2327358 */   GIR_EraseRootFromParent_Done,
     /* 2327359 */ // Label 32127: @2327359
     /* 2327359 */ GIM_Try, /*On fail goto*//*Label 32128*/ GIMT_Encode4(2327413), // Rule ID 58726 //
     /* 2327364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2327367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327378 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327392 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2327395 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327397 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327400 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327412 */   // GIR_Coverage, 58726,
     /* 2327412 */   GIR_EraseRootFromParent_Done,
     /* 2327413 */ // Label 32128: @2327413
     /* 2327413 */ GIM_Try, /*On fail goto*//*Label 32129*/ GIMT_Encode4(2327467), // Rule ID 58727 //
     /* 2327418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2327421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327432 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2327449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327451 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327454 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327465 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327466 */   // GIR_Coverage, 58727,
     /* 2327466 */   GIR_EraseRootFromParent_Done,
     /* 2327467 */ // Label 32129: @2327467
     /* 2327467 */ GIM_Reject,
     /* 2327468 */ // Label 32085: @2327468
     /* 2327468 */ GIM_Try, /*On fail goto*//*Label 32130*/ GIMT_Encode4(2327522), // Rule ID 45810 //
     /* 2327473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327487 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327487 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327490 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327494 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2327504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327506 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327509 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327520 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327521 */   // GIR_Coverage, 45810,
     /* 2327521 */   GIR_EraseRootFromParent_Done,
     /* 2327522 */ // Label 32130: @2327522
     /* 2327522 */ GIM_Try, /*On fail goto*//*Label 32131*/ GIMT_Encode4(2327576), // Rule ID 45811 //
     /* 2327527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327541 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327541 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327544 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327548 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327553 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2327558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327563 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327574 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327575 */   // GIR_Coverage, 45811,
     /* 2327575 */   GIR_EraseRootFromParent_Done,
     /* 2327576 */ // Label 32131: @2327576
     /* 2327576 */ GIM_Try, /*On fail goto*//*Label 32132*/ GIMT_Encode4(2327630), // Rule ID 58294 //
     /* 2327581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2327584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327595 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2327612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327617 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327629 */   // GIR_Coverage, 58294,
     /* 2327629 */   GIR_EraseRootFromParent_Done,
     /* 2327630 */ // Label 32132: @2327630
     /* 2327630 */ GIM_Try, /*On fail goto*//*Label 32133*/ GIMT_Encode4(2327684), // Rule ID 58295 //
     /* 2327635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2327638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327649 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327649 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327652 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327656 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2327666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327671 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327679 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327682 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327683 */   // GIR_Coverage, 58295,
     /* 2327683 */   GIR_EraseRootFromParent_Done,
     /* 2327684 */ // Label 32133: @2327684
     /* 2327684 */ GIM_Try, /*On fail goto*//*Label 32134*/ GIMT_Encode4(2327738), // Rule ID 58746 //
     /* 2327689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2327692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327703 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327715 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2327720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327725 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327737 */   // GIR_Coverage, 58746,
     /* 2327737 */   GIR_EraseRootFromParent_Done,
     /* 2327738 */ // Label 32134: @2327738
     /* 2327738 */ GIM_Try, /*On fail goto*//*Label 32135*/ GIMT_Encode4(2327792), // Rule ID 58747 //
     /* 2327743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2327746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327757 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327757 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327760 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327764 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2327774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327779 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327791 */   // GIR_Coverage, 58747,
     /* 2327791 */   GIR_EraseRootFromParent_Done,
     /* 2327792 */ // Label 32135: @2327792
     /* 2327792 */ GIM_Reject,
     /* 2327793 */ // Label 32086: @2327793
     /* 2327793 */ GIM_Try, /*On fail goto*//*Label 32136*/ GIMT_Encode4(2327847), // Rule ID 58306 //
     /* 2327798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2327801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327812 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2327829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327831 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327834 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327846 */   // GIR_Coverage, 58306,
     /* 2327846 */   GIR_EraseRootFromParent_Done,
     /* 2327847 */ // Label 32136: @2327847
     /* 2327847 */ GIM_Try, /*On fail goto*//*Label 32137*/ GIMT_Encode4(2327901), // Rule ID 58307 //
     /* 2327852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2327855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327866 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2327883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327888 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327900 */   // GIR_Coverage, 58307,
     /* 2327900 */   GIR_EraseRootFromParent_Done,
     /* 2327901 */ // Label 32137: @2327901
     /* 2327901 */ GIM_Try, /*On fail goto*//*Label 32138*/ GIMT_Encode4(2327955), // Rule ID 58538 //
     /* 2327906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2327909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327920 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2327937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327942 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327954 */   // GIR_Coverage, 58538,
     /* 2327954 */   GIR_EraseRootFromParent_Done,
     /* 2327955 */ // Label 32138: @2327955
     /* 2327955 */ GIM_Try, /*On fail goto*//*Label 32139*/ GIMT_Encode4(2328009), // Rule ID 58539 //
     /* 2327960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2327963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327974 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2327991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327996 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328008 */   // GIR_Coverage, 58539,
     /* 2328008 */   GIR_EraseRootFromParent_Done,
     /* 2328009 */ // Label 32139: @2328009
     /* 2328009 */ GIM_Reject,
     /* 2328010 */ // Label 32087: @2328010
     /* 2328010 */ GIM_Try, /*On fail goto*//*Label 32140*/ GIMT_Encode4(2328113),
     /* 2328015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328026 */   GIM_Try, /*On fail goto*//*Label 32141*/ GIMT_Encode4(2328069), // Rule ID 58706 //
     /* 2328031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328034 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2328037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2328051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328068 */     // GIR_Coverage, 58706,
     /* 2328068 */     GIR_EraseRootFromParent_Done,
     /* 2328069 */   // Label 32141: @2328069
     /* 2328069 */   GIM_Try, /*On fail goto*//*Label 32142*/ GIMT_Encode4(2328112), // Rule ID 58707 //
     /* 2328074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328077 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2328080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2328094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328111 */     // GIR_Coverage, 58707,
     /* 2328111 */     GIR_EraseRootFromParent_Done,
     /* 2328112 */   // Label 32142: @2328112
     /* 2328112 */   GIM_Reject,
     /* 2328113 */ // Label 32140: @2328113
     /* 2328113 */ GIM_Reject,
     /* 2328114 */ // Label 32088: @2328114
     /* 2328114 */ GIM_Try, /*On fail goto*//*Label 32143*/ GIMT_Encode4(2328168), // Rule ID 58290 //
     /* 2328119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328133 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2328150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328155 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328167 */   // GIR_Coverage, 58290,
     /* 2328167 */   GIR_EraseRootFromParent_Done,
     /* 2328168 */ // Label 32143: @2328168
     /* 2328168 */ GIM_Try, /*On fail goto*//*Label 32144*/ GIMT_Encode4(2328222), // Rule ID 58291 //
     /* 2328173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328187 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328187 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328190 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328194 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2328204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328209 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328221 */   // GIR_Coverage, 58291,
     /* 2328221 */   GIR_EraseRootFromParent_Done,
     /* 2328222 */ // Label 32144: @2328222
     /* 2328222 */ GIM_Try, /*On fail goto*//*Label 32145*/ GIMT_Encode4(2328276), // Rule ID 58730 //
     /* 2328227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2328230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328241 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2328258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328260 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328263 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328275 */   // GIR_Coverage, 58730,
     /* 2328275 */   GIR_EraseRootFromParent_Done,
     /* 2328276 */ // Label 32145: @2328276
     /* 2328276 */ GIM_Try, /*On fail goto*//*Label 32146*/ GIMT_Encode4(2328330), // Rule ID 58731 //
     /* 2328281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2328284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328295 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2328312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328317 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328329 */   // GIR_Coverage, 58731,
     /* 2328329 */   GIR_EraseRootFromParent_Done,
     /* 2328330 */ // Label 32146: @2328330
     /* 2328330 */ GIM_Reject,
     /* 2328331 */ // Label 32089: @2328331
     /* 2328331 */ GIM_Try, /*On fail goto*//*Label 32147*/ GIMT_Encode4(2328385), // Rule ID 58302 //
     /* 2328336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2328339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328350 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2328367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328372 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328383 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328384 */   // GIR_Coverage, 58302,
     /* 2328384 */   GIR_EraseRootFromParent_Done,
     /* 2328385 */ // Label 32147: @2328385
     /* 2328385 */ GIM_Try, /*On fail goto*//*Label 32148*/ GIMT_Encode4(2328439), // Rule ID 58303 //
     /* 2328390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2328393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328404 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328404 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328411 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2328421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328426 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328437 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328438 */   // GIR_Coverage, 58303,
     /* 2328438 */   GIR_EraseRootFromParent_Done,
     /* 2328439 */ // Label 32148: @2328439
     /* 2328439 */ GIM_Try, /*On fail goto*//*Label 32149*/ GIMT_Encode4(2328493), // Rule ID 58522 //
     /* 2328444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328458 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2328475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328480 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328492 */   // GIR_Coverage, 58522,
     /* 2328492 */   GIR_EraseRootFromParent_Done,
     /* 2328493 */ // Label 32149: @2328493
     /* 2328493 */ GIM_Try, /*On fail goto*//*Label 32150*/ GIMT_Encode4(2328547), // Rule ID 58523 //
     /* 2328498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328512 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2328529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328531 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328534 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328546 */   // GIR_Coverage, 58523,
     /* 2328546 */   GIR_EraseRootFromParent_Done,
     /* 2328547 */ // Label 32150: @2328547
     /* 2328547 */ GIM_Try, /*On fail goto*//*Label 32151*/ GIMT_Encode4(2328601), // Rule ID 58750 //
     /* 2328552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2328555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328566 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2328583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328588 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328599 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328600 */   // GIR_Coverage, 58750,
     /* 2328600 */   GIR_EraseRootFromParent_Done,
     /* 2328601 */ // Label 32151: @2328601
     /* 2328601 */ GIM_Try, /*On fail goto*//*Label 32152*/ GIMT_Encode4(2328655), // Rule ID 58751 //
     /* 2328606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2328609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328620 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2328637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328642 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328654 */   // GIR_Coverage, 58751,
     /* 2328654 */   GIR_EraseRootFromParent_Done,
     /* 2328655 */ // Label 32152: @2328655
     /* 2328655 */ GIM_Reject,
     /* 2328656 */ // Label 32090: @2328656
     /* 2328656 */ GIM_Try, /*On fail goto*//*Label 32153*/ GIMT_Encode4(2328710), // Rule ID 58334 //
     /* 2328661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2328664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328675 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2328678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2328692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328694 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328697 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328708 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328709 */   // GIR_Coverage, 58334,
     /* 2328709 */   GIR_EraseRootFromParent_Done,
     /* 2328710 */ // Label 32153: @2328710
     /* 2328710 */ GIM_Try, /*On fail goto*//*Label 32154*/ GIMT_Encode4(2328764), // Rule ID 58335 //
     /* 2328715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2328718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328729 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2328732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2328746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328748 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328751 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328763 */   // GIR_Coverage, 58335,
     /* 2328763 */   GIR_EraseRootFromParent_Done,
     /* 2328764 */ // Label 32154: @2328764
     /* 2328764 */ GIM_Try, /*On fail goto*//*Label 32155*/ GIMT_Encode4(2328818), // Rule ID 58542 //
     /* 2328769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2328772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328783 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328783 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2328786 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328790 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2328800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328805 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328816 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328817 */   // GIR_Coverage, 58542,
     /* 2328817 */   GIR_EraseRootFromParent_Done,
     /* 2328818 */ // Label 32155: @2328818
     /* 2328818 */ GIM_Try, /*On fail goto*//*Label 32156*/ GIMT_Encode4(2328872), // Rule ID 58543 //
     /* 2328823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2328826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328837 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2328840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2328854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328859 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328871 */   // GIR_Coverage, 58543,
     /* 2328871 */   GIR_EraseRootFromParent_Done,
     /* 2328872 */ // Label 32156: @2328872
     /* 2328872 */ GIM_Reject,
     /* 2328873 */ // Label 32091: @2328873
     /* 2328873 */ GIM_Try, /*On fail goto*//*Label 32157*/ GIMT_Encode4(2328976),
     /* 2328878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2328881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328889 */   GIM_Try, /*On fail goto*//*Label 32158*/ GIMT_Encode4(2328932), // Rule ID 58710 //
     /* 2328894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328897 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2328900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2328914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328931 */     // GIR_Coverage, 58710,
     /* 2328931 */     GIR_EraseRootFromParent_Done,
     /* 2328932 */   // Label 32158: @2328932
     /* 2328932 */   GIM_Try, /*On fail goto*//*Label 32159*/ GIMT_Encode4(2328975), // Rule ID 58711 //
     /* 2328937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328940 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2328943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2328957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2328974 */     // GIR_Coverage, 58711,
     /* 2328974 */     GIR_EraseRootFromParent_Done,
     /* 2328975 */   // Label 32159: @2328975
     /* 2328975 */   GIM_Reject,
     /* 2328976 */ // Label 32157: @2328976
     /* 2328976 */ GIM_Reject,
     /* 2328977 */ // Label 32092: @2328977
     /* 2328977 */ GIM_Try, /*On fail goto*//*Label 32160*/ GIMT_Encode4(2329031), // Rule ID 58298 //
     /* 2328982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2328988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328996 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328996 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2328999 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329003 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2329013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329018 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329030 */   // GIR_Coverage, 58298,
     /* 2329030 */   GIR_EraseRootFromParent_Done,
     /* 2329031 */ // Label 32160: @2329031
     /* 2329031 */ GIM_Try, /*On fail goto*//*Label 32161*/ GIMT_Encode4(2329085), // Rule ID 58299 //
     /* 2329036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329050 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329050 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329053 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329057 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2329067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329072 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329084 */   // GIR_Coverage, 58299,
     /* 2329084 */   GIR_EraseRootFromParent_Done,
     /* 2329085 */ // Label 32161: @2329085
     /* 2329085 */ GIM_Try, /*On fail goto*//*Label 32162*/ GIMT_Encode4(2329139), // Rule ID 58734 //
     /* 2329090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329104 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2329121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329126 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329137 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329138 */   // GIR_Coverage, 58734,
     /* 2329138 */   GIR_EraseRootFromParent_Done,
     /* 2329139 */ // Label 32162: @2329139
     /* 2329139 */ GIM_Try, /*On fail goto*//*Label 32163*/ GIMT_Encode4(2329193), // Rule ID 58735 //
     /* 2329144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2329147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329158 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329158 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329161 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329165 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2329175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329180 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329192 */   // GIR_Coverage, 58735,
     /* 2329192 */   GIR_EraseRootFromParent_Done,
     /* 2329193 */ // Label 32163: @2329193
     /* 2329193 */ GIM_Reject,
     /* 2329194 */ // Label 32093: @2329194
     /* 2329194 */ GIM_Try, /*On fail goto*//*Label 32164*/ GIMT_Encode4(2329248), // Rule ID 58322 //
     /* 2329199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329213 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2329230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329235 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329246 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329247 */   // GIR_Coverage, 58322,
     /* 2329247 */   GIR_EraseRootFromParent_Done,
     /* 2329248 */ // Label 32164: @2329248
     /* 2329248 */ GIM_Try, /*On fail goto*//*Label 32165*/ GIMT_Encode4(2329302), // Rule ID 58323 //
     /* 2329253 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2329256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329267 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2329284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329289 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329301 */   // GIR_Coverage, 58323,
     /* 2329301 */   GIR_EraseRootFromParent_Done,
     /* 2329302 */ // Label 32165: @2329302
     /* 2329302 */ GIM_Try, /*On fail goto*//*Label 32166*/ GIMT_Encode4(2329356), // Rule ID 58526 //
     /* 2329307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329321 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2329338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329343 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329354 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329355 */   // GIR_Coverage, 58526,
     /* 2329355 */   GIR_EraseRootFromParent_Done,
     /* 2329356 */ // Label 32166: @2329356
     /* 2329356 */ GIM_Try, /*On fail goto*//*Label 32167*/ GIMT_Encode4(2329410), // Rule ID 58527 //
     /* 2329361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329375 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329375 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329378 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329382 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2329392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329397 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329409 */   // GIR_Coverage, 58527,
     /* 2329409 */   GIR_EraseRootFromParent_Done,
     /* 2329410 */ // Label 32167: @2329410
     /* 2329410 */ GIM_Try, /*On fail goto*//*Label 32168*/ GIMT_Encode4(2329464), // Rule ID 58754 //
     /* 2329415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2329418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329429 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329429 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329432 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329436 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2329446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329451 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329462 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329463 */   // GIR_Coverage, 58754,
     /* 2329463 */   GIR_EraseRootFromParent_Done,
     /* 2329464 */ // Label 32168: @2329464
     /* 2329464 */ GIM_Try, /*On fail goto*//*Label 32169*/ GIMT_Encode4(2329518), // Rule ID 58755 //
     /* 2329469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2329472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329483 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2329500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329505 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329517 */   // GIR_Coverage, 58755,
     /* 2329517 */   GIR_EraseRootFromParent_Done,
     /* 2329518 */ // Label 32169: @2329518
     /* 2329518 */ GIM_Reject,
     /* 2329519 */ // Label 32094: @2329519
     /* 2329519 */ GIM_Try, /*On fail goto*//*Label 32170*/ GIMT_Encode4(2329573), // Rule ID 58338 //
     /* 2329524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2329527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329538 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329538 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329541 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329545 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2329555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329557 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329560 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329571 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329572 */   // GIR_Coverage, 58338,
     /* 2329572 */   GIR_EraseRootFromParent_Done,
     /* 2329573 */ // Label 32170: @2329573
     /* 2329573 */ GIM_Try, /*On fail goto*//*Label 32171*/ GIMT_Encode4(2329627), // Rule ID 58339 //
     /* 2329578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2329581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329592 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329592 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329595 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329599 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329604 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2329609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329611 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329614 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329625 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329626 */   // GIR_Coverage, 58339,
     /* 2329626 */   GIR_EraseRootFromParent_Done,
     /* 2329627 */ // Label 32171: @2329627
     /* 2329627 */ GIM_Try, /*On fail goto*//*Label 32172*/ GIMT_Encode4(2329681), // Rule ID 58546 //
     /* 2329632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2329635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329646 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329646 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329649 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329653 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329658 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2329663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329665 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329668 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329680 */   // GIR_Coverage, 58546,
     /* 2329680 */   GIR_EraseRootFromParent_Done,
     /* 2329681 */ // Label 32172: @2329681
     /* 2329681 */ GIM_Try, /*On fail goto*//*Label 32173*/ GIMT_Encode4(2329735), // Rule ID 58547 //
     /* 2329686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2329689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329700 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2329717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329722 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329734 */   // GIR_Coverage, 58547,
     /* 2329734 */   GIR_EraseRootFromParent_Done,
     /* 2329735 */ // Label 32173: @2329735
     /* 2329735 */ GIM_Reject,
     /* 2329736 */ // Label 32095: @2329736
     /* 2329736 */ GIM_Try, /*On fail goto*//*Label 32174*/ GIMT_Encode4(2329839),
     /* 2329741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2329744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329752 */   GIM_Try, /*On fail goto*//*Label 32175*/ GIMT_Encode4(2329795), // Rule ID 58714 //
     /* 2329757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329760 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2329763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2329777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329794 */     // GIR_Coverage, 58714,
     /* 2329794 */     GIR_EraseRootFromParent_Done,
     /* 2329795 */   // Label 32175: @2329795
     /* 2329795 */   GIM_Try, /*On fail goto*//*Label 32176*/ GIMT_Encode4(2329838), // Rule ID 58715 //
     /* 2329800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329803 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2329806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2329820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2329837 */     // GIR_Coverage, 58715,
     /* 2329837 */     GIR_EraseRootFromParent_Done,
     /* 2329838 */   // Label 32176: @2329838
     /* 2329838 */   GIM_Reject,
     /* 2329839 */ // Label 32174: @2329839
     /* 2329839 */ GIM_Reject,
     /* 2329840 */ // Label 32096: @2329840
     /* 2329840 */ GIM_Try, /*On fail goto*//*Label 32177*/ GIMT_Encode4(2329894), // Rule ID 58310 //
     /* 2329845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2329851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329859 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2329876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329881 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329893 */   // GIR_Coverage, 58310,
     /* 2329893 */   GIR_EraseRootFromParent_Done,
     /* 2329894 */ // Label 32177: @2329894
     /* 2329894 */ GIM_Try, /*On fail goto*//*Label 32178*/ GIMT_Encode4(2329948), // Rule ID 58311 //
     /* 2329899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2329905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329913 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2329930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329932 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329935 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329946 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329947 */   // GIR_Coverage, 58311,
     /* 2329947 */   GIR_EraseRootFromParent_Done,
     /* 2329948 */ // Label 32178: @2329948
     /* 2329948 */ GIM_Try, /*On fail goto*//*Label 32179*/ GIMT_Encode4(2330002), // Rule ID 58738 //
     /* 2329953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2329959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329967 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2329984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329989 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330000 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330001 */   // GIR_Coverage, 58738,
     /* 2330001 */   GIR_EraseRootFromParent_Done,
     /* 2330002 */ // Label 32179: @2330002
     /* 2330002 */ GIM_Try, /*On fail goto*//*Label 32180*/ GIMT_Encode4(2330056), // Rule ID 58739 //
     /* 2330007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330017 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330021 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2330038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330040 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330043 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330054 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330055 */   // GIR_Coverage, 58739,
     /* 2330055 */   GIR_EraseRootFromParent_Done,
     /* 2330056 */ // Label 32180: @2330056
     /* 2330056 */ GIM_Reject,
     /* 2330057 */ // Label 32097: @2330057
     /* 2330057 */ GIM_Try, /*On fail goto*//*Label 32181*/ GIMT_Encode4(2330111), // Rule ID 58326 //
     /* 2330062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330076 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2330093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330098 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330110 */   // GIR_Coverage, 58326,
     /* 2330110 */   GIR_EraseRootFromParent_Done,
     /* 2330111 */ // Label 32181: @2330111
     /* 2330111 */ GIM_Try, /*On fail goto*//*Label 32182*/ GIMT_Encode4(2330165), // Rule ID 58327 //
     /* 2330116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330130 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2330147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330149 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330152 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330164 */   // GIR_Coverage, 58327,
     /* 2330164 */   GIR_EraseRootFromParent_Done,
     /* 2330165 */ // Label 32182: @2330165
     /* 2330165 */ GIM_Try, /*On fail goto*//*Label 32183*/ GIMT_Encode4(2330219), // Rule ID 58530 //
     /* 2330170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2330176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330184 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2330201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330206 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330217 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330218 */   // GIR_Coverage, 58530,
     /* 2330218 */   GIR_EraseRootFromParent_Done,
     /* 2330219 */ // Label 32183: @2330219
     /* 2330219 */ GIM_Try, /*On fail goto*//*Label 32184*/ GIMT_Encode4(2330273), // Rule ID 58531 //
     /* 2330224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2330230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330238 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2330255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330260 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330272 */   // GIR_Coverage, 58531,
     /* 2330272 */   GIR_EraseRootFromParent_Done,
     /* 2330273 */ // Label 32184: @2330273
     /* 2330273 */ GIM_Try, /*On fail goto*//*Label 32185*/ GIMT_Encode4(2330327), // Rule ID 58758 //
     /* 2330278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2330281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330292 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2330309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330314 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330326 */   // GIR_Coverage, 58758,
     /* 2330326 */   GIR_EraseRootFromParent_Done,
     /* 2330327 */ // Label 32185: @2330327
     /* 2330327 */ GIM_Try, /*On fail goto*//*Label 32186*/ GIMT_Encode4(2330381), // Rule ID 58759 //
     /* 2330332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2330335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330346 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2330363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330368 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330373 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330379 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330380 */   // GIR_Coverage, 58759,
     /* 2330380 */   GIR_EraseRootFromParent_Done,
     /* 2330381 */ // Label 32186: @2330381
     /* 2330381 */ GIM_Reject,
     /* 2330382 */ // Label 32098: @2330382
     /* 2330382 */ GIM_Try, /*On fail goto*//*Label 32187*/ GIMT_Encode4(2330436), // Rule ID 58342 //
     /* 2330387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2330390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330401 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2330418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330420 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330423 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330435 */   // GIR_Coverage, 58342,
     /* 2330435 */   GIR_EraseRootFromParent_Done,
     /* 2330436 */ // Label 32187: @2330436
     /* 2330436 */ GIM_Try, /*On fail goto*//*Label 32188*/ GIMT_Encode4(2330490), // Rule ID 58343 //
     /* 2330441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2330444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330455 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330455 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330458 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330462 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2330472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330477 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330488 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330489 */   // GIR_Coverage, 58343,
     /* 2330489 */   GIR_EraseRootFromParent_Done,
     /* 2330490 */ // Label 32188: @2330490
     /* 2330490 */ GIM_Try, /*On fail goto*//*Label 32189*/ GIMT_Encode4(2330544), // Rule ID 58550 //
     /* 2330495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2330498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330509 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330509 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330512 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330516 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2330526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330528 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330531 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330543 */   // GIR_Coverage, 58550,
     /* 2330543 */   GIR_EraseRootFromParent_Done,
     /* 2330544 */ // Label 32189: @2330544
     /* 2330544 */ GIM_Try, /*On fail goto*//*Label 32190*/ GIMT_Encode4(2330598), // Rule ID 58551 //
     /* 2330549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2330552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330563 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330563 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330566 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330570 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2330580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330582 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330585 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330597 */   // GIR_Coverage, 58551,
     /* 2330597 */   GIR_EraseRootFromParent_Done,
     /* 2330598 */ // Label 32190: @2330598
     /* 2330598 */ GIM_Reject,
     /* 2330599 */ // Label 32099: @2330599
     /* 2330599 */ GIM_Try, /*On fail goto*//*Label 32191*/ GIMT_Encode4(2330702),
     /* 2330604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2330607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330615 */   GIM_Try, /*On fail goto*//*Label 32192*/ GIMT_Encode4(2330658), // Rule ID 58718 //
     /* 2330620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330623 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2330626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2330640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330657 */     // GIR_Coverage, 58718,
     /* 2330657 */     GIR_EraseRootFromParent_Done,
     /* 2330658 */   // Label 32192: @2330658
     /* 2330658 */   GIM_Try, /*On fail goto*//*Label 32193*/ GIMT_Encode4(2330701), // Rule ID 58719 //
     /* 2330663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330666 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2330669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2330683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2330700 */     // GIR_Coverage, 58719,
     /* 2330700 */     GIR_EraseRootFromParent_Done,
     /* 2330701 */   // Label 32193: @2330701
     /* 2330701 */   GIM_Reject,
     /* 2330702 */ // Label 32191: @2330702
     /* 2330702 */ GIM_Reject,
     /* 2330703 */ // Label 32100: @2330703
     /* 2330703 */ GIM_Try, /*On fail goto*//*Label 32194*/ GIMT_Encode4(2330757), // Rule ID 58314 //
     /* 2330708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2330714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330722 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2330739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330744 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330756 */   // GIR_Coverage, 58314,
     /* 2330756 */   GIR_EraseRootFromParent_Done,
     /* 2330757 */ // Label 32194: @2330757
     /* 2330757 */ GIM_Try, /*On fail goto*//*Label 32195*/ GIMT_Encode4(2330811), // Rule ID 58315 //
     /* 2330762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2330768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330776 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2330793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330798 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330809 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330810 */   // GIR_Coverage, 58315,
     /* 2330810 */   GIR_EraseRootFromParent_Done,
     /* 2330811 */ // Label 32195: @2330811
     /* 2330811 */ GIM_Try, /*On fail goto*//*Label 32196*/ GIMT_Encode4(2330865), // Rule ID 58742 //
     /* 2330816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330830 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2330847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330852 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330863 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330864 */   // GIR_Coverage, 58742,
     /* 2330864 */   GIR_EraseRootFromParent_Done,
     /* 2330865 */ // Label 32196: @2330865
     /* 2330865 */ GIM_Try, /*On fail goto*//*Label 32197*/ GIMT_Encode4(2330919), // Rule ID 58743 //
     /* 2330870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330884 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330896 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2330901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330906 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330917 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330918 */   // GIR_Coverage, 58743,
     /* 2330918 */   GIR_EraseRootFromParent_Done,
     /* 2330919 */ // Label 32197: @2330919
     /* 2330919 */ GIM_Reject,
     /* 2330920 */ // Label 32101: @2330920
     /* 2330920 */ GIM_Try, /*On fail goto*//*Label 32198*/ GIMT_Encode4(2330974), // Rule ID 58330 //
     /* 2330925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330939 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330939 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330942 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330946 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2330956 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330961 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330973 */   // GIR_Coverage, 58330,
     /* 2330973 */   GIR_EraseRootFromParent_Done,
     /* 2330974 */ // Label 32198: @2330974
     /* 2330974 */ GIM_Try, /*On fail goto*//*Label 32199*/ GIMT_Encode4(2331028), // Rule ID 58331 //
     /* 2330979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330993 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2330996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2331010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331015 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331027 */   // GIR_Coverage, 58331,
     /* 2331027 */   GIR_EraseRootFromParent_Done,
     /* 2331028 */ // Label 32199: @2331028
     /* 2331028 */ GIM_Try, /*On fail goto*//*Label 32200*/ GIMT_Encode4(2331082), // Rule ID 58534 //
     /* 2331033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2331039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331047 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2331064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331069 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331081 */   // GIR_Coverage, 58534,
     /* 2331081 */   GIR_EraseRootFromParent_Done,
     /* 2331082 */ // Label 32200: @2331082
     /* 2331082 */ GIM_Try, /*On fail goto*//*Label 32201*/ GIMT_Encode4(2331136), // Rule ID 58535 //
     /* 2331087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2331093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331101 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331101 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331104 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331108 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2331118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331123 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331134 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331135 */   // GIR_Coverage, 58535,
     /* 2331135 */   GIR_EraseRootFromParent_Done,
     /* 2331136 */ // Label 32201: @2331136
     /* 2331136 */ GIM_Reject,
     /* 2331137 */ // Label 32102: @2331137
     /* 2331137 */ GIM_Try, /*On fail goto*//*Label 32202*/ GIMT_Encode4(2331240),
     /* 2331142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2331145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331153 */   GIM_Try, /*On fail goto*//*Label 32203*/ GIMT_Encode4(2331196), // Rule ID 58722 //
     /* 2331158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331161 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2331164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2331178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331195 */     // GIR_Coverage, 58722,
     /* 2331195 */     GIR_EraseRootFromParent_Done,
     /* 2331196 */   // Label 32203: @2331196
     /* 2331196 */   GIM_Try, /*On fail goto*//*Label 32204*/ GIMT_Encode4(2331239), // Rule ID 58723 //
     /* 2331201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331204 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2331207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2331221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331238 */     // GIR_Coverage, 58723,
     /* 2331238 */     GIR_EraseRootFromParent_Done,
     /* 2331239 */   // Label 32204: @2331239
     /* 2331239 */   GIM_Reject,
     /* 2331240 */ // Label 32202: @2331240
     /* 2331240 */ GIM_Reject,
     /* 2331241 */ // Label 32103: @2331241
     /* 2331241 */ GIM_Try, /*On fail goto*//*Label 32205*/ GIMT_Encode4(2331344),
     /* 2331246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2331249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331257 */   GIM_Try, /*On fail goto*//*Label 32206*/ GIMT_Encode4(2331300), // Rule ID 58318 //
     /* 2331262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331265 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2331268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2331282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331299 */     // GIR_Coverage, 58318,
     /* 2331299 */     GIR_EraseRootFromParent_Done,
     /* 2331300 */   // Label 32206: @2331300
     /* 2331300 */   GIM_Try, /*On fail goto*//*Label 32207*/ GIMT_Encode4(2331343), // Rule ID 58319 //
     /* 2331305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331308 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2331311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2331325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331342 */     // GIR_Coverage, 58319,
     /* 2331342 */     GIR_EraseRootFromParent_Done,
     /* 2331343 */   // Label 32207: @2331343
     /* 2331343 */   GIM_Reject,
     /* 2331344 */ // Label 32205: @2331344
     /* 2331344 */ GIM_Reject,
     /* 2331345 */ // Label 32104: @2331345
     /* 2331345 */ GIM_Reject,
     /* 2331346 */ // Label 68: @2331346
     /* 2331346 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32231*/ GIMT_Encode4(2336231),
     /* 2331357 */ /*GILLT_s32*//*Label 32208*/ GIMT_Encode4(2331473),
     /* 2331361 */ /*GILLT_s64*//*Label 32209*/ GIMT_Encode4(2331846), GIMT_Encode4(0),
     /* 2331369 */ /*GILLT_nxv1s8*//*Label 32210*/ GIMT_Encode4(2332033),
     /* 2331373 */ /*GILLT_nxv1s16*//*Label 32211*/ GIMT_Encode4(2332137),
     /* 2331377 */ /*GILLT_nxv1s32*//*Label 32212*/ GIMT_Encode4(2332354),
     /* 2331381 */ /*GILLT_nxv1s64*//*Label 32213*/ GIMT_Encode4(2332679), GIMT_Encode4(0),
     /* 2331389 */ /*GILLT_nxv2s8*//*Label 32214*/ GIMT_Encode4(2332896),
     /* 2331393 */ /*GILLT_nxv2s16*//*Label 32215*/ GIMT_Encode4(2333000),
     /* 2331397 */ /*GILLT_nxv2s32*//*Label 32216*/ GIMT_Encode4(2333217),
     /* 2331401 */ /*GILLT_nxv2s64*//*Label 32217*/ GIMT_Encode4(2333542), GIMT_Encode4(0),
     /* 2331409 */ /*GILLT_nxv4s8*//*Label 32218*/ GIMT_Encode4(2333759),
     /* 2331413 */ /*GILLT_nxv4s16*//*Label 32219*/ GIMT_Encode4(2333863),
     /* 2331417 */ /*GILLT_nxv4s32*//*Label 32220*/ GIMT_Encode4(2334080),
     /* 2331421 */ /*GILLT_nxv4s64*//*Label 32221*/ GIMT_Encode4(2334405), GIMT_Encode4(0),
     /* 2331429 */ /*GILLT_nxv8s8*//*Label 32222*/ GIMT_Encode4(2334622),
     /* 2331433 */ /*GILLT_nxv8s16*//*Label 32223*/ GIMT_Encode4(2334726),
     /* 2331437 */ /*GILLT_nxv8s32*//*Label 32224*/ GIMT_Encode4(2334943),
     /* 2331441 */ /*GILLT_nxv8s64*//*Label 32225*/ GIMT_Encode4(2335268), GIMT_Encode4(0),
     /* 2331449 */ /*GILLT_nxv16s8*//*Label 32226*/ GIMT_Encode4(2335485),
     /* 2331453 */ /*GILLT_nxv16s16*//*Label 32227*/ GIMT_Encode4(2335589),
     /* 2331457 */ /*GILLT_nxv16s32*//*Label 32228*/ GIMT_Encode4(2335806), GIMT_Encode4(0),
     /* 2331465 */ /*GILLT_nxv32s8*//*Label 32229*/ GIMT_Encode4(2336023),
     /* 2331469 */ /*GILLT_nxv32s16*//*Label 32230*/ GIMT_Encode4(2336127),
     /* 2331473 */ // Label 32208: @2331473
     /* 2331473 */ GIM_Try, /*On fail goto*//*Label 32232*/ GIMT_Encode4(2331504), // Rule ID 1456 //
     /* 2331478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2331481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331492 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2331492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2331495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331497 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331503 */   // GIR_Coverage, 1456,
     /* 2331503 */   GIR_EraseRootFromParent_Done,
     /* 2331504 */ // Label 32232: @2331504
     /* 2331504 */ GIM_Try, /*On fail goto*//*Label 32233*/ GIMT_Encode4(2331535), // Rule ID 1457 //
     /* 2331509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2331512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331523 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2331523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2331526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331528 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331534 */   // GIR_Coverage, 1457,
     /* 2331534 */   GIR_EraseRootFromParent_Done,
     /* 2331535 */ // Label 32233: @2331535
     /* 2331535 */ GIM_Try, /*On fail goto*//*Label 32234*/ GIMT_Encode4(2331566), // Rule ID 1482 //
     /* 2331540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2331543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331554 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2331554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2331557 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331559 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331565 */   // GIR_Coverage, 1482,
     /* 2331565 */   GIR_EraseRootFromParent_Done,
     /* 2331566 */ // Label 32234: @2331566
     /* 2331566 */ GIM_Try, /*On fail goto*//*Label 32235*/ GIMT_Encode4(2331597), // Rule ID 1483 //
     /* 2331571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2331574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331585 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2331585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2331588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331590 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331596 */   // GIR_Coverage, 1483,
     /* 2331596 */   GIR_EraseRootFromParent_Done,
     /* 2331597 */ // Label 32235: @2331597
     /* 2331597 */ GIM_Try, /*On fail goto*//*Label 32236*/ GIMT_Encode4(2331628), // Rule ID 1850 //
     /* 2331602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2331605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331616 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2331616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2331619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331621 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331627 */   // GIR_Coverage, 1850,
     /* 2331627 */   GIR_EraseRootFromParent_Done,
     /* 2331628 */ // Label 32236: @2331628
     /* 2331628 */ GIM_Try, /*On fail goto*//*Label 32237*/ GIMT_Encode4(2331659), // Rule ID 1851 //
     /* 2331633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2331636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331647 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2331647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2331650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331652 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331657 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331658 */   // GIR_Coverage, 1851,
     /* 2331658 */   GIR_EraseRootFromParent_Done,
     /* 2331659 */ // Label 32237: @2331659
     /* 2331659 */ GIM_Try, /*On fail goto*//*Label 32238*/ GIMT_Encode4(2331690), // Rule ID 1876 //
     /* 2331664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2331667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331678 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2331678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2331681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331683 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331688 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331689 */   // GIR_Coverage, 1876,
     /* 2331689 */   GIR_EraseRootFromParent_Done,
     /* 2331690 */ // Label 32238: @2331690
     /* 2331690 */ GIM_Try, /*On fail goto*//*Label 32239*/ GIMT_Encode4(2331721), // Rule ID 1877 //
     /* 2331695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2331698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331709 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2331709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2331712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331714 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331720 */   // GIR_Coverage, 1877,
     /* 2331720 */   GIR_EraseRootFromParent_Done,
     /* 2331721 */ // Label 32239: @2331721
     /* 2331721 */ GIM_Try, /*On fail goto*//*Label 32240*/ GIMT_Encode4(2331752), // Rule ID 2192 //
     /* 2331726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2331729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331740 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2331740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2331743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331745 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331750 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331751 */   // GIR_Coverage, 2192,
     /* 2331751 */   GIR_EraseRootFromParent_Done,
     /* 2331752 */ // Label 32240: @2331752
     /* 2331752 */ GIM_Try, /*On fail goto*//*Label 32241*/ GIMT_Encode4(2331783), // Rule ID 2193 //
     /* 2331757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2331760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331771 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2331771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2331774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331776 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331782 */   // GIR_Coverage, 2193,
     /* 2331782 */   GIR_EraseRootFromParent_Done,
     /* 2331783 */ // Label 32241: @2331783
     /* 2331783 */ GIM_Try, /*On fail goto*//*Label 32242*/ GIMT_Encode4(2331814), // Rule ID 2218 //
     /* 2331788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2331791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331802 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2331802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2331805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331807 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331812 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331813 */   // GIR_Coverage, 2218,
     /* 2331813 */   GIR_EraseRootFromParent_Done,
     /* 2331814 */ // Label 32242: @2331814
     /* 2331814 */ GIM_Try, /*On fail goto*//*Label 32243*/ GIMT_Encode4(2331845), // Rule ID 2219 //
     /* 2331819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2331822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331833 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2331833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2331836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331838 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331843 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331844 */   // GIR_Coverage, 2219,
     /* 2331844 */   GIR_EraseRootFromParent_Done,
     /* 2331845 */ // Label 32243: @2331845
     /* 2331845 */ GIM_Reject,
     /* 2331846 */ // Label 32209: @2331846
     /* 2331846 */ GIM_Try, /*On fail goto*//*Label 32244*/ GIMT_Encode4(2331877), // Rule ID 1511 //
     /* 2331851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2331854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331865 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2331865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S),
     /* 2331868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331870 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331876 */   // GIR_Coverage, 1511,
     /* 2331876 */   GIR_EraseRootFromParent_Done,
     /* 2331877 */ // Label 32244: @2331877
     /* 2331877 */ GIM_Try, /*On fail goto*//*Label 32245*/ GIMT_Encode4(2331908), // Rule ID 1539 //
     /* 2331882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2331885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331896 */   // (fp_to_uint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2331896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S_INX),
     /* 2331899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331901 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331907 */   // GIR_Coverage, 1539,
     /* 2331907 */   GIR_EraseRootFromParent_Done,
     /* 2331908 */ // Label 32245: @2331908
     /* 2331908 */ GIM_Try, /*On fail goto*//*Label 32246*/ GIMT_Encode4(2331939), // Rule ID 1911 //
     /* 2331913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2331916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331927 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2331927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D),
     /* 2331930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331932 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331937 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331938 */   // GIR_Coverage, 1911,
     /* 2331938 */   GIR_EraseRootFromParent_Done,
     /* 2331939 */ // Label 32246: @2331939
     /* 2331939 */ GIM_Try, /*On fail goto*//*Label 32247*/ GIMT_Encode4(2331970), // Rule ID 1939 //
     /* 2331944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2331947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331958 */   // (fp_to_uint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2331958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D_INX),
     /* 2331961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331963 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331968 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331969 */   // GIR_Coverage, 1939,
     /* 2331969 */   GIR_EraseRootFromParent_Done,
     /* 2331970 */ // Label 32247: @2331970
     /* 2331970 */ GIM_Try, /*On fail goto*//*Label 32248*/ GIMT_Encode4(2332001), // Rule ID 2245 //
     /* 2331975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2331978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331989 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2331989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H),
     /* 2331992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331994 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2331999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332000 */   // GIR_Coverage, 2245,
     /* 2332000 */   GIR_EraseRootFromParent_Done,
     /* 2332001 */ // Label 32248: @2332001
     /* 2332001 */ GIM_Try, /*On fail goto*//*Label 32249*/ GIMT_Encode4(2332032), // Rule ID 2271 //
     /* 2332006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2332009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2332012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2332016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2332020 */   // (fp_to_uint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2332020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H_INX),
     /* 2332023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332025 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2332030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332031 */   // GIR_Coverage, 2271,
     /* 2332031 */   GIR_EraseRootFromParent_Done,
     /* 2332032 */ // Label 32249: @2332032
     /* 2332032 */ GIM_Reject,
     /* 2332033 */ // Label 32210: @2332033
     /* 2332033 */ GIM_Try, /*On fail goto*//*Label 32250*/ GIMT_Encode4(2332136),
     /* 2332038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332049 */   GIM_Try, /*On fail goto*//*Label 32251*/ GIMT_Encode4(2332092), // Rule ID 58762 //
     /* 2332054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332057 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2332060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2332074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332091 */     // GIR_Coverage, 58762,
     /* 2332091 */     GIR_EraseRootFromParent_Done,
     /* 2332092 */   // Label 32251: @2332092
     /* 2332092 */   GIM_Try, /*On fail goto*//*Label 32252*/ GIMT_Encode4(2332135), // Rule ID 58763 //
     /* 2332097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332100 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2332103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2332117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332134 */     // GIR_Coverage, 58763,
     /* 2332134 */     GIR_EraseRootFromParent_Done,
     /* 2332135 */   // Label 32252: @2332135
     /* 2332135 */   GIM_Reject,
     /* 2332136 */ // Label 32250: @2332136
     /* 2332136 */ GIM_Reject,
     /* 2332137 */ // Label 32211: @2332137
     /* 2332137 */ GIM_Try, /*On fail goto*//*Label 32253*/ GIMT_Encode4(2332191), // Rule ID 58346 //
     /* 2332142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332156 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2332159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2332173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332178 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332190 */   // GIR_Coverage, 58346,
     /* 2332190 */   GIR_EraseRootFromParent_Done,
     /* 2332191 */ // Label 32253: @2332191
     /* 2332191 */ GIM_Try, /*On fail goto*//*Label 32254*/ GIMT_Encode4(2332245), // Rule ID 58347 //
     /* 2332196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332210 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2332213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332222 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2332227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332232 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332244 */   // GIR_Coverage, 58347,
     /* 2332244 */   GIR_EraseRootFromParent_Done,
     /* 2332245 */ // Label 32254: @2332245
     /* 2332245 */ GIM_Try, /*On fail goto*//*Label 32255*/ GIMT_Encode4(2332299), // Rule ID 58786 //
     /* 2332250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2332253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332264 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2332267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2332281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332286 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332297 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332298 */   // GIR_Coverage, 58786,
     /* 2332298 */   GIR_EraseRootFromParent_Done,
     /* 2332299 */ // Label 32255: @2332299
     /* 2332299 */ GIM_Try, /*On fail goto*//*Label 32256*/ GIMT_Encode4(2332353), // Rule ID 58787 //
     /* 2332304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2332307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332318 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2332321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2332335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332340 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332352 */   // GIR_Coverage, 58787,
     /* 2332352 */   GIR_EraseRootFromParent_Done,
     /* 2332353 */ // Label 32256: @2332353
     /* 2332353 */ GIM_Reject,
     /* 2332354 */ // Label 32212: @2332354
     /* 2332354 */ GIM_Try, /*On fail goto*//*Label 32257*/ GIMT_Encode4(2332408), // Rule ID 58354 //
     /* 2332359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2332362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332373 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332373 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332376 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332380 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2332390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332395 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332407 */   // GIR_Coverage, 58354,
     /* 2332407 */   GIR_EraseRootFromParent_Done,
     /* 2332408 */ // Label 32257: @2332408
     /* 2332408 */ GIM_Try, /*On fail goto*//*Label 32258*/ GIMT_Encode4(2332462), // Rule ID 58355 //
     /* 2332413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2332416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332427 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2332444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332449 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332461 */   // GIR_Coverage, 58355,
     /* 2332461 */   GIR_EraseRootFromParent_Done,
     /* 2332462 */ // Label 32258: @2332462
     /* 2332462 */ GIM_Try, /*On fail goto*//*Label 32259*/ GIMT_Encode4(2332516), // Rule ID 58554 //
     /* 2332467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332481 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2332498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332515 */   // GIR_Coverage, 58554,
     /* 2332515 */   GIR_EraseRootFromParent_Done,
     /* 2332516 */ // Label 32259: @2332516
     /* 2332516 */ GIM_Try, /*On fail goto*//*Label 32260*/ GIMT_Encode4(2332570), // Rule ID 58555 //
     /* 2332521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2332527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332535 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332535 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332538 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332542 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2332552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332557 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332565 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332568 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332569 */   // GIR_Coverage, 58555,
     /* 2332569 */   GIR_EraseRootFromParent_Done,
     /* 2332570 */ // Label 32260: @2332570
     /* 2332570 */ GIM_Try, /*On fail goto*//*Label 32261*/ GIMT_Encode4(2332624), // Rule ID 58806 //
     /* 2332575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2332578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2332581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332589 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332589 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332592 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332596 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2332606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332611 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332619 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332622 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332623 */   // GIR_Coverage, 58806,
     /* 2332623 */   GIR_EraseRootFromParent_Done,
     /* 2332624 */ // Label 32261: @2332624
     /* 2332624 */ GIM_Try, /*On fail goto*//*Label 32262*/ GIMT_Encode4(2332678), // Rule ID 58807 //
     /* 2332629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2332632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2332635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332643 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2332660 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332665 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332667 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332677 */   // GIR_Coverage, 58807,
     /* 2332677 */   GIR_EraseRootFromParent_Done,
     /* 2332678 */ // Label 32262: @2332678
     /* 2332678 */ GIM_Reject,
     /* 2332679 */ // Label 32213: @2332679
     /* 2332679 */ GIM_Try, /*On fail goto*//*Label 32263*/ GIMT_Encode4(2332733), // Rule ID 58366 //
     /* 2332684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2332687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2332690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332698 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2332715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332720 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332732 */   // GIR_Coverage, 58366,
     /* 2332732 */   GIR_EraseRootFromParent_Done,
     /* 2332733 */ // Label 32263: @2332733
     /* 2332733 */ GIM_Try, /*On fail goto*//*Label 32264*/ GIMT_Encode4(2332787), // Rule ID 58367 //
     /* 2332738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2332741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2332744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332752 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2332769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332774 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332786 */   // GIR_Coverage, 58367,
     /* 2332786 */   GIR_EraseRootFromParent_Done,
     /* 2332787 */ // Label 32264: @2332787
     /* 2332787 */ GIM_Try, /*On fail goto*//*Label 32265*/ GIMT_Encode4(2332841), // Rule ID 58574 //
     /* 2332792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2332795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332806 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2332823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332825 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332828 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332836 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332839 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332840 */   // GIR_Coverage, 58574,
     /* 2332840 */   GIR_EraseRootFromParent_Done,
     /* 2332841 */ // Label 32265: @2332841
     /* 2332841 */ GIM_Try, /*On fail goto*//*Label 32266*/ GIMT_Encode4(2332895), // Rule ID 58575 //
     /* 2332846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2332849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2332852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332860 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332872 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2332877 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332882 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2332894 */   // GIR_Coverage, 58575,
     /* 2332894 */   GIR_EraseRootFromParent_Done,
     /* 2332895 */ // Label 32266: @2332895
     /* 2332895 */ GIM_Reject,
     /* 2332896 */ // Label 32214: @2332896
     /* 2332896 */ GIM_Try, /*On fail goto*//*Label 32267*/ GIMT_Encode4(2332999),
     /* 2332901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2332904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332912 */   GIM_Try, /*On fail goto*//*Label 32268*/ GIMT_Encode4(2332955), // Rule ID 58766 //
     /* 2332917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2332920 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2332923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2332937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332954 */     // GIR_Coverage, 58766,
     /* 2332954 */     GIR_EraseRootFromParent_Done,
     /* 2332955 */   // Label 32268: @2332955
     /* 2332955 */   GIM_Try, /*On fail goto*//*Label 32269*/ GIMT_Encode4(2332998), // Rule ID 58767 //
     /* 2332960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2332963 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2332966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2332980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2332987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332997 */     // GIR_Coverage, 58767,
     /* 2332997 */     GIR_EraseRootFromParent_Done,
     /* 2332998 */   // Label 32269: @2332998
     /* 2332998 */   GIM_Reject,
     /* 2332999 */ // Label 32267: @2332999
     /* 2332999 */ GIM_Reject,
     /* 2333000 */ // Label 32215: @2333000
     /* 2333000 */ GIM_Try, /*On fail goto*//*Label 32270*/ GIMT_Encode4(2333054), // Rule ID 58350 //
     /* 2333005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2333011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333019 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2333022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2333036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333041 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333053 */   // GIR_Coverage, 58350,
     /* 2333053 */   GIR_EraseRootFromParent_Done,
     /* 2333054 */ // Label 32270: @2333054
     /* 2333054 */ GIM_Try, /*On fail goto*//*Label 32271*/ GIMT_Encode4(2333108), // Rule ID 58351 //
     /* 2333059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2333065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333073 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2333076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2333090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333095 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333107 */   // GIR_Coverage, 58351,
     /* 2333107 */   GIR_EraseRootFromParent_Done,
     /* 2333108 */ // Label 32271: @2333108
     /* 2333108 */ GIM_Try, /*On fail goto*//*Label 32272*/ GIMT_Encode4(2333162), // Rule ID 58790 //
     /* 2333113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333127 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2333130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2333144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333149 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333161 */   // GIR_Coverage, 58790,
     /* 2333161 */   GIR_EraseRootFromParent_Done,
     /* 2333162 */ // Label 32272: @2333162
     /* 2333162 */ GIM_Try, /*On fail goto*//*Label 32273*/ GIMT_Encode4(2333216), // Rule ID 58791 //
     /* 2333167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333181 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2333184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2333198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333203 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333215 */   // GIR_Coverage, 58791,
     /* 2333215 */   GIR_EraseRootFromParent_Done,
     /* 2333216 */ // Label 32273: @2333216
     /* 2333216 */ GIM_Reject,
     /* 2333217 */ // Label 32216: @2333217
     /* 2333217 */ GIM_Try, /*On fail goto*//*Label 32274*/ GIMT_Encode4(2333271), // Rule ID 58362 //
     /* 2333222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333236 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2333253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333258 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333270 */   // GIR_Coverage, 58362,
     /* 2333270 */   GIR_EraseRootFromParent_Done,
     /* 2333271 */ // Label 32274: @2333271
     /* 2333271 */ GIM_Try, /*On fail goto*//*Label 32275*/ GIMT_Encode4(2333325), // Rule ID 58363 //
     /* 2333276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2333279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333290 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2333307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333312 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333324 */   // GIR_Coverage, 58363,
     /* 2333324 */   GIR_EraseRootFromParent_Done,
     /* 2333325 */ // Label 32275: @2333325
     /* 2333325 */ GIM_Try, /*On fail goto*//*Label 32276*/ GIMT_Encode4(2333379), // Rule ID 58558 //
     /* 2333330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2333336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333344 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2333361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333366 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333378 */   // GIR_Coverage, 58558,
     /* 2333378 */   GIR_EraseRootFromParent_Done,
     /* 2333379 */ // Label 32276: @2333379
     /* 2333379 */ GIM_Try, /*On fail goto*//*Label 32277*/ GIMT_Encode4(2333433), // Rule ID 58559 //
     /* 2333384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2333390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333398 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2333415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333417 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333420 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333432 */   // GIR_Coverage, 58559,
     /* 2333432 */   GIR_EraseRootFromParent_Done,
     /* 2333433 */ // Label 32277: @2333433
     /* 2333433 */ GIM_Try, /*On fail goto*//*Label 32278*/ GIMT_Encode4(2333487), // Rule ID 58810 //
     /* 2333438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2333441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2333444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333452 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2333469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333474 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333486 */   // GIR_Coverage, 58810,
     /* 2333486 */   GIR_EraseRootFromParent_Done,
     /* 2333487 */ // Label 32278: @2333487
     /* 2333487 */ GIM_Try, /*On fail goto*//*Label 32279*/ GIMT_Encode4(2333541), // Rule ID 58811 //
     /* 2333492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2333495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2333498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333506 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2333509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2333523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333528 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333540 */   // GIR_Coverage, 58811,
     /* 2333540 */   GIR_EraseRootFromParent_Done,
     /* 2333541 */ // Label 32279: @2333541
     /* 2333541 */ GIM_Reject,
     /* 2333542 */ // Label 32217: @2333542
     /* 2333542 */ GIM_Try, /*On fail goto*//*Label 32280*/ GIMT_Encode4(2333596), // Rule ID 58394 //
     /* 2333547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2333550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2333553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333561 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333561 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2333564 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333568 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333573 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2333578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333583 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333594 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333595 */   // GIR_Coverage, 58394,
     /* 2333595 */   GIR_EraseRootFromParent_Done,
     /* 2333596 */ // Label 32280: @2333596
     /* 2333596 */ GIM_Try, /*On fail goto*//*Label 32281*/ GIMT_Encode4(2333650), // Rule ID 58395 //
     /* 2333601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2333604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2333607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333615 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333615 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2333618 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333622 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2333632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333634 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333637 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333649 */   // GIR_Coverage, 58395,
     /* 2333649 */   GIR_EraseRootFromParent_Done,
     /* 2333650 */ // Label 32281: @2333650
     /* 2333650 */ GIM_Try, /*On fail goto*//*Label 32282*/ GIMT_Encode4(2333704), // Rule ID 58578 //
     /* 2333655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2333658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333669 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2333672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2333686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333691 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333703 */   // GIR_Coverage, 58578,
     /* 2333703 */   GIR_EraseRootFromParent_Done,
     /* 2333704 */ // Label 32282: @2333704
     /* 2333704 */ GIM_Try, /*On fail goto*//*Label 32283*/ GIMT_Encode4(2333758), // Rule ID 58579 //
     /* 2333709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2333712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2333715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333723 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2333726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2333740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333742 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333745 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333757 */   // GIR_Coverage, 58579,
     /* 2333757 */   GIR_EraseRootFromParent_Done,
     /* 2333758 */ // Label 32283: @2333758
     /* 2333758 */ GIM_Reject,
     /* 2333759 */ // Label 32218: @2333759
     /* 2333759 */ GIM_Try, /*On fail goto*//*Label 32284*/ GIMT_Encode4(2333862),
     /* 2333764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2333767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333775 */   GIM_Try, /*On fail goto*//*Label 32285*/ GIMT_Encode4(2333818), // Rule ID 58770 //
     /* 2333780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333783 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2333786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2333800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333817 */     // GIR_Coverage, 58770,
     /* 2333817 */     GIR_EraseRootFromParent_Done,
     /* 2333818 */   // Label 32285: @2333818
     /* 2333818 */   GIM_Try, /*On fail goto*//*Label 32286*/ GIMT_Encode4(2333861), // Rule ID 58771 //
     /* 2333823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333826 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2333829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2333843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333860 */     // GIR_Coverage, 58771,
     /* 2333860 */     GIR_EraseRootFromParent_Done,
     /* 2333861 */   // Label 32286: @2333861
     /* 2333861 */   GIM_Reject,
     /* 2333862 */ // Label 32284: @2333862
     /* 2333862 */ GIM_Reject,
     /* 2333863 */ // Label 32219: @2333863
     /* 2333863 */ GIM_Try, /*On fail goto*//*Label 32287*/ GIMT_Encode4(2333917), // Rule ID 58358 //
     /* 2333868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2333871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2333874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333882 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2333885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2333899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333904 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333916 */   // GIR_Coverage, 58358,
     /* 2333916 */   GIR_EraseRootFromParent_Done,
     /* 2333917 */ // Label 32287: @2333917
     /* 2333917 */ GIM_Try, /*On fail goto*//*Label 32288*/ GIMT_Encode4(2333971), // Rule ID 58359 //
     /* 2333922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2333925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2333928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333936 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2333939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2333953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333958 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333969 */   GIR_RootConstrainSelectedInstOperands,
     /* 2333970 */   // GIR_Coverage, 58359,
     /* 2333970 */   GIR_EraseRootFromParent_Done,
     /* 2333971 */ // Label 32288: @2333971
     /* 2333971 */ GIM_Try, /*On fail goto*//*Label 32289*/ GIMT_Encode4(2334025), // Rule ID 58794 //
     /* 2333976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2333979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2333982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2333986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2333990 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333990 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2333993 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333997 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2334007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334009 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334012 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334023 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334024 */   // GIR_Coverage, 58794,
     /* 2334024 */   GIR_EraseRootFromParent_Done,
     /* 2334025 */ // Label 32289: @2334025
     /* 2334025 */ GIM_Try, /*On fail goto*//*Label 32290*/ GIMT_Encode4(2334079), // Rule ID 58795 //
     /* 2334030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334044 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2334047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2334061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334066 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334068 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334078 */   // GIR_Coverage, 58795,
     /* 2334078 */   GIR_EraseRootFromParent_Done,
     /* 2334079 */ // Label 32290: @2334079
     /* 2334079 */ GIM_Reject,
     /* 2334080 */ // Label 32220: @2334080
     /* 2334080 */ GIM_Try, /*On fail goto*//*Label 32291*/ GIMT_Encode4(2334134), // Rule ID 58382 //
     /* 2334085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334099 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2334116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334121 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334133 */   // GIR_Coverage, 58382,
     /* 2334133 */   GIR_EraseRootFromParent_Done,
     /* 2334134 */ // Label 32291: @2334134
     /* 2334134 */ GIM_Try, /*On fail goto*//*Label 32292*/ GIMT_Encode4(2334188), // Rule ID 58383 //
     /* 2334139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334153 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2334170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334175 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334186 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334187 */   // GIR_Coverage, 58383,
     /* 2334187 */   GIR_EraseRootFromParent_Done,
     /* 2334188 */ // Label 32292: @2334188
     /* 2334188 */ GIM_Try, /*On fail goto*//*Label 32293*/ GIMT_Encode4(2334242), // Rule ID 58562 //
     /* 2334193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2334199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334207 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2334224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334229 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334240 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334241 */   // GIR_Coverage, 58562,
     /* 2334241 */   GIR_EraseRootFromParent_Done,
     /* 2334242 */ // Label 32293: @2334242
     /* 2334242 */ GIM_Try, /*On fail goto*//*Label 32294*/ GIMT_Encode4(2334296), // Rule ID 58563 //
     /* 2334247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2334253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334261 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2334278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334283 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334294 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334295 */   // GIR_Coverage, 58563,
     /* 2334295 */   GIR_EraseRootFromParent_Done,
     /* 2334296 */ // Label 32294: @2334296
     /* 2334296 */ GIM_Try, /*On fail goto*//*Label 32295*/ GIMT_Encode4(2334350), // Rule ID 58814 //
     /* 2334301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2334304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2334307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334315 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2334332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334337 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334349 */   // GIR_Coverage, 58814,
     /* 2334349 */   GIR_EraseRootFromParent_Done,
     /* 2334350 */ // Label 32295: @2334350
     /* 2334350 */ GIM_Try, /*On fail goto*//*Label 32296*/ GIMT_Encode4(2334404), // Rule ID 58815 //
     /* 2334355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2334358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2334361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334369 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334369 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2334372 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334376 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2334386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334391 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334399 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334402 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334403 */   // GIR_Coverage, 58815,
     /* 2334403 */   GIR_EraseRootFromParent_Done,
     /* 2334404 */ // Label 32296: @2334404
     /* 2334404 */ GIM_Reject,
     /* 2334405 */ // Label 32221: @2334405
     /* 2334405 */ GIM_Try, /*On fail goto*//*Label 32297*/ GIMT_Encode4(2334459), // Rule ID 58398 //
     /* 2334410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2334413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2334416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334424 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2334441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334446 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334457 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334458 */   // GIR_Coverage, 58398,
     /* 2334458 */   GIR_EraseRootFromParent_Done,
     /* 2334459 */ // Label 32297: @2334459
     /* 2334459 */ GIM_Try, /*On fail goto*//*Label 32298*/ GIMT_Encode4(2334513), // Rule ID 58399 //
     /* 2334464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2334467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2334470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334478 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2334495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334500 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2334508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334511 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334512 */   // GIR_Coverage, 58399,
     /* 2334512 */   GIR_EraseRootFromParent_Done,
     /* 2334513 */ // Label 32298: @2334513
     /* 2334513 */ GIM_Try, /*On fail goto*//*Label 32299*/ GIMT_Encode4(2334567), // Rule ID 58582 //
     /* 2334518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2334521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334532 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334532 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334535 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334539 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2334549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334554 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334566 */   // GIR_Coverage, 58582,
     /* 2334566 */   GIR_EraseRootFromParent_Done,
     /* 2334567 */ // Label 32299: @2334567
     /* 2334567 */ GIM_Try, /*On fail goto*//*Label 32300*/ GIMT_Encode4(2334621), // Rule ID 58583 //
     /* 2334572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2334575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2334578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334586 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334586 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2334589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334593 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2334603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334608 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334620 */   // GIR_Coverage, 58583,
     /* 2334620 */   GIR_EraseRootFromParent_Done,
     /* 2334621 */ // Label 32300: @2334621
     /* 2334621 */ GIM_Reject,
     /* 2334622 */ // Label 32222: @2334622
     /* 2334622 */ GIM_Try, /*On fail goto*//*Label 32301*/ GIMT_Encode4(2334725),
     /* 2334627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2334630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2334634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334638 */   GIM_Try, /*On fail goto*//*Label 32302*/ GIMT_Encode4(2334681), // Rule ID 58774 //
     /* 2334643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334646 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2334649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2334663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334680 */     // GIR_Coverage, 58774,
     /* 2334680 */     GIR_EraseRootFromParent_Done,
     /* 2334681 */   // Label 32302: @2334681
     /* 2334681 */   GIM_Try, /*On fail goto*//*Label 32303*/ GIMT_Encode4(2334724), // Rule ID 58775 //
     /* 2334686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334689 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2334692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2334706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334723 */     // GIR_Coverage, 58775,
     /* 2334723 */     GIR_EraseRootFromParent_Done,
     /* 2334724 */   // Label 32303: @2334724
     /* 2334724 */   GIM_Reject,
     /* 2334725 */ // Label 32301: @2334725
     /* 2334725 */ GIM_Reject,
     /* 2334726 */ // Label 32223: @2334726
     /* 2334726 */ GIM_Try, /*On fail goto*//*Label 32304*/ GIMT_Encode4(2334780), // Rule ID 58370 //
     /* 2334731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2334734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2334737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334745 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2334762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334767 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334778 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334779 */   // GIR_Coverage, 58370,
     /* 2334779 */   GIR_EraseRootFromParent_Done,
     /* 2334780 */ // Label 32304: @2334780
     /* 2334780 */ GIM_Try, /*On fail goto*//*Label 32305*/ GIMT_Encode4(2334834), // Rule ID 58371 //
     /* 2334785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2334788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2334791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334799 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2334816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334821 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334833 */   // GIR_Coverage, 58371,
     /* 2334833 */   GIR_EraseRootFromParent_Done,
     /* 2334834 */ // Label 32305: @2334834
     /* 2334834 */ GIM_Try, /*On fail goto*//*Label 32306*/ GIMT_Encode4(2334888), // Rule ID 58798 //
     /* 2334839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2334845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334853 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2334870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334887 */   // GIR_Coverage, 58798,
     /* 2334887 */   GIR_EraseRootFromParent_Done,
     /* 2334888 */ // Label 32306: @2334888
     /* 2334888 */ GIM_Try, /*On fail goto*//*Label 32307*/ GIMT_Encode4(2334942), // Rule ID 58799 //
     /* 2334893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2334896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2334899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2334903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334907 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2334907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2334910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2334924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334929 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2334937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334941 */   // GIR_Coverage, 58799,
     /* 2334941 */   GIR_EraseRootFromParent_Done,
     /* 2334942 */ // Label 32307: @2334942
     /* 2334942 */ GIM_Reject,
     /* 2334943 */ // Label 32224: @2334943
     /* 2334943 */ GIM_Try, /*On fail goto*//*Label 32308*/ GIMT_Encode4(2334997), // Rule ID 58386 //
     /* 2334948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2334951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2334954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2334962 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2334962 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2334965 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2334969 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2334979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334984 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2334989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2334992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2334995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2334996 */   // GIR_Coverage, 58386,
     /* 2334996 */   GIR_EraseRootFromParent_Done,
     /* 2334997 */ // Label 32308: @2334997
     /* 2334997 */ GIM_Try, /*On fail goto*//*Label 32309*/ GIMT_Encode4(2335051), // Rule ID 58387 //
     /* 2335002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335016 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2335033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335038 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335049 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335050 */   // GIR_Coverage, 58387,
     /* 2335050 */   GIR_EraseRootFromParent_Done,
     /* 2335051 */ // Label 32309: @2335051
     /* 2335051 */ GIM_Try, /*On fail goto*//*Label 32310*/ GIMT_Encode4(2335105), // Rule ID 58566 //
     /* 2335056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335070 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335070 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335073 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335077 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2335087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335092 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335104 */   // GIR_Coverage, 58566,
     /* 2335104 */   GIR_EraseRootFromParent_Done,
     /* 2335105 */ // Label 32310: @2335105
     /* 2335105 */ GIM_Try, /*On fail goto*//*Label 32311*/ GIMT_Encode4(2335159), // Rule ID 58567 //
     /* 2335110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2335116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335124 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2335141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335146 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335158 */   // GIR_Coverage, 58567,
     /* 2335158 */   GIR_EraseRootFromParent_Done,
     /* 2335159 */ // Label 32311: @2335159
     /* 2335159 */ GIM_Try, /*On fail goto*//*Label 32312*/ GIMT_Encode4(2335213), // Rule ID 58818 //
     /* 2335164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2335167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2335170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335178 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2335195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335200 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335212 */   // GIR_Coverage, 58818,
     /* 2335212 */   GIR_EraseRootFromParent_Done,
     /* 2335213 */ // Label 32312: @2335213
     /* 2335213 */ GIM_Try, /*On fail goto*//*Label 32313*/ GIMT_Encode4(2335267), // Rule ID 58819 //
     /* 2335218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2335221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2335224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335232 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335232 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2335235 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335239 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2335249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335254 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335265 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335266 */   // GIR_Coverage, 58819,
     /* 2335266 */   GIR_EraseRootFromParent_Done,
     /* 2335267 */ // Label 32313: @2335267
     /* 2335267 */ GIM_Reject,
     /* 2335268 */ // Label 32225: @2335268
     /* 2335268 */ GIM_Try, /*On fail goto*//*Label 32314*/ GIMT_Encode4(2335322), // Rule ID 58402 //
     /* 2335273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2335276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2335279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335287 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2335290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2335304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335309 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335320 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335321 */   // GIR_Coverage, 58402,
     /* 2335321 */   GIR_EraseRootFromParent_Done,
     /* 2335322 */ // Label 32314: @2335322
     /* 2335322 */ GIM_Try, /*On fail goto*//*Label 32315*/ GIMT_Encode4(2335376), // Rule ID 58403 //
     /* 2335327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2335330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2335333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335341 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2335344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2335358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335363 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2335371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335375 */   // GIR_Coverage, 58403,
     /* 2335375 */   GIR_EraseRootFromParent_Done,
     /* 2335376 */ // Label 32315: @2335376
     /* 2335376 */ GIM_Try, /*On fail goto*//*Label 32316*/ GIMT_Encode4(2335430), // Rule ID 58586 //
     /* 2335381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2335384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335395 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335395 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2335398 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335402 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335407 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2335412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335414 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335417 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335429 */   // GIR_Coverage, 58586,
     /* 2335429 */   GIR_EraseRootFromParent_Done,
     /* 2335430 */ // Label 32316: @2335430
     /* 2335430 */ GIM_Try, /*On fail goto*//*Label 32317*/ GIMT_Encode4(2335484), // Rule ID 58587 //
     /* 2335435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2335438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2335441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335449 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2335452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2335466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335471 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335483 */   // GIR_Coverage, 58587,
     /* 2335483 */   GIR_EraseRootFromParent_Done,
     /* 2335484 */ // Label 32317: @2335484
     /* 2335484 */ GIM_Reject,
     /* 2335485 */ // Label 32226: @2335485
     /* 2335485 */ GIM_Try, /*On fail goto*//*Label 32318*/ GIMT_Encode4(2335588),
     /* 2335490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2335497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335501 */   GIM_Try, /*On fail goto*//*Label 32319*/ GIMT_Encode4(2335544), // Rule ID 58778 //
     /* 2335506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335509 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2335512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2335526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335543 */     // GIR_Coverage, 58778,
     /* 2335543 */     GIR_EraseRootFromParent_Done,
     /* 2335544 */   // Label 32319: @2335544
     /* 2335544 */   GIM_Try, /*On fail goto*//*Label 32320*/ GIMT_Encode4(2335587), // Rule ID 58779 //
     /* 2335549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335552 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2335555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2335569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335586 */     // GIR_Coverage, 58779,
     /* 2335586 */     GIR_EraseRootFromParent_Done,
     /* 2335587 */   // Label 32320: @2335587
     /* 2335587 */   GIM_Reject,
     /* 2335588 */ // Label 32318: @2335588
     /* 2335588 */ GIM_Reject,
     /* 2335589 */ // Label 32227: @2335589
     /* 2335589 */ GIM_Try, /*On fail goto*//*Label 32321*/ GIMT_Encode4(2335643), // Rule ID 58374 //
     /* 2335594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335608 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2335625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335630 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335642 */   // GIR_Coverage, 58374,
     /* 2335642 */   GIR_EraseRootFromParent_Done,
     /* 2335643 */ // Label 32321: @2335643
     /* 2335643 */ GIM_Try, /*On fail goto*//*Label 32322*/ GIMT_Encode4(2335697), // Rule ID 58375 //
     /* 2335648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335662 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2335679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335684 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335695 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335696 */   // GIR_Coverage, 58375,
     /* 2335696 */   GIR_EraseRootFromParent_Done,
     /* 2335697 */ // Label 32322: @2335697
     /* 2335697 */ GIM_Try, /*On fail goto*//*Label 32323*/ GIMT_Encode4(2335751), // Rule ID 58802 //
     /* 2335702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2335708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335716 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2335733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335738 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335750 */   // GIR_Coverage, 58802,
     /* 2335750 */   GIR_EraseRootFromParent_Done,
     /* 2335751 */ // Label 32323: @2335751
     /* 2335751 */ GIM_Try, /*On fail goto*//*Label 32324*/ GIMT_Encode4(2335805), // Rule ID 58803 //
     /* 2335756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2335762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335770 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335770 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2335773 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335777 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2335787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335792 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335804 */   // GIR_Coverage, 58803,
     /* 2335804 */   GIR_EraseRootFromParent_Done,
     /* 2335805 */ // Label 32324: @2335805
     /* 2335805 */ GIM_Reject,
     /* 2335806 */ // Label 32228: @2335806
     /* 2335806 */ GIM_Try, /*On fail goto*//*Label 32325*/ GIMT_Encode4(2335860), // Rule ID 58390 //
     /* 2335811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2335814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2335817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335825 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335825 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2335828 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335832 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335837 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2335842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335847 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335859 */   // GIR_Coverage, 58390,
     /* 2335859 */   GIR_EraseRootFromParent_Done,
     /* 2335860 */ // Label 32325: @2335860
     /* 2335860 */ GIM_Try, /*On fail goto*//*Label 32326*/ GIMT_Encode4(2335914), // Rule ID 58391 //
     /* 2335865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2335868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2335871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335879 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335879 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2335882 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335886 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2335896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335901 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2335909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335912 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335913 */   // GIR_Coverage, 58391,
     /* 2335913 */   GIR_EraseRootFromParent_Done,
     /* 2335914 */ // Label 32326: @2335914
     /* 2335914 */ GIM_Try, /*On fail goto*//*Label 32327*/ GIMT_Encode4(2335968), // Rule ID 58570 //
     /* 2335919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2335922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335933 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2335936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2335950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335955 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2335967 */   // GIR_Coverage, 58570,
     /* 2335967 */   GIR_EraseRootFromParent_Done,
     /* 2335968 */ // Label 32327: @2335968
     /* 2335968 */ GIM_Try, /*On fail goto*//*Label 32328*/ GIMT_Encode4(2336022), // Rule ID 58571 //
     /* 2335973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2335976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2335979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2335983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2335987 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2335990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2336004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336009 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336021 */   // GIR_Coverage, 58571,
     /* 2336021 */   GIR_EraseRootFromParent_Done,
     /* 2336022 */ // Label 32328: @2336022
     /* 2336022 */ GIM_Reject,
     /* 2336023 */ // Label 32229: @2336023
     /* 2336023 */ GIM_Try, /*On fail goto*//*Label 32329*/ GIMT_Encode4(2336126),
     /* 2336028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2336031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2336035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336039 */   GIM_Try, /*On fail goto*//*Label 32330*/ GIMT_Encode4(2336082), // Rule ID 58782 //
     /* 2336044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336047 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2336050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2336064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336081 */     // GIR_Coverage, 58782,
     /* 2336081 */     GIR_EraseRootFromParent_Done,
     /* 2336082 */   // Label 32330: @2336082
     /* 2336082 */   GIM_Try, /*On fail goto*//*Label 32331*/ GIMT_Encode4(2336125), // Rule ID 58783 //
     /* 2336087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336090 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2336093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2336107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336124 */     // GIR_Coverage, 58783,
     /* 2336124 */     GIR_EraseRootFromParent_Done,
     /* 2336125 */   // Label 32331: @2336125
     /* 2336125 */   GIM_Reject,
     /* 2336126 */ // Label 32329: @2336126
     /* 2336126 */ GIM_Reject,
     /* 2336127 */ // Label 32230: @2336127
     /* 2336127 */ GIM_Try, /*On fail goto*//*Label 32332*/ GIMT_Encode4(2336230),
     /* 2336132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2336135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2336143 */   GIM_Try, /*On fail goto*//*Label 32333*/ GIMT_Encode4(2336186), // Rule ID 58378 //
     /* 2336148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2336151 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2336154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2336168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336185 */     // GIR_Coverage, 58378,
     /* 2336185 */     GIR_EraseRootFromParent_Done,
     /* 2336186 */   // Label 32333: @2336186
     /* 2336186 */   GIM_Try, /*On fail goto*//*Label 32334*/ GIMT_Encode4(2336229), // Rule ID 58379 //
     /* 2336191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2336194 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2336197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2336211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336228 */     // GIR_Coverage, 58379,
     /* 2336228 */     GIR_EraseRootFromParent_Done,
     /* 2336229 */   // Label 32334: @2336229
     /* 2336229 */   GIM_Reject,
     /* 2336230 */ // Label 32332: @2336230
     /* 2336230 */ GIM_Reject,
     /* 2336231 */ // Label 32231: @2336231
     /* 2336231 */ GIM_Reject,
     /* 2336232 */ // Label 69: @2336232
     /* 2336232 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32353*/ GIMT_Encode4(2341517),
     /* 2336243 */ /*GILLT_s16*//*Label 32335*/ GIMT_Encode4(2336363),
     /* 2336247 */ /*GILLT_s32*//*Label 32336*/ GIMT_Encode4(2336624),
     /* 2336251 */ /*GILLT_s64*//*Label 32337*/ GIMT_Encode4(2336885), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336263 */ /*GILLT_nxv1s16*//*Label 32338*/ GIMT_Encode4(2337146),
     /* 2336267 */ /*GILLT_nxv1s32*//*Label 32339*/ GIMT_Encode4(2337483),
     /* 2336271 */ /*GILLT_nxv1s64*//*Label 32340*/ GIMT_Encode4(2337820), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336283 */ /*GILLT_nxv2s16*//*Label 32341*/ GIMT_Encode4(2338043),
     /* 2336287 */ /*GILLT_nxv2s32*//*Label 32342*/ GIMT_Encode4(2338380),
     /* 2336291 */ /*GILLT_nxv2s64*//*Label 32343*/ GIMT_Encode4(2338717), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336303 */ /*GILLT_nxv4s16*//*Label 32344*/ GIMT_Encode4(2338940),
     /* 2336307 */ /*GILLT_nxv4s32*//*Label 32345*/ GIMT_Encode4(2339277),
     /* 2336311 */ /*GILLT_nxv4s64*//*Label 32346*/ GIMT_Encode4(2339614), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336323 */ /*GILLT_nxv8s16*//*Label 32347*/ GIMT_Encode4(2339837),
     /* 2336327 */ /*GILLT_nxv8s32*//*Label 32348*/ GIMT_Encode4(2340174),
     /* 2336331 */ /*GILLT_nxv8s64*//*Label 32349*/ GIMT_Encode4(2340511), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336343 */ /*GILLT_nxv16s16*//*Label 32350*/ GIMT_Encode4(2340734),
     /* 2336347 */ /*GILLT_nxv16s32*//*Label 32351*/ GIMT_Encode4(2341071), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2336359 */ /*GILLT_nxv32s16*//*Label 32352*/ GIMT_Encode4(2341294),
     /* 2336363 */ // Label 32335: @2336363
     /* 2336363 */ GIM_Try, /*On fail goto*//*Label 32354*/ GIMT_Encode4(2336400), // Rule ID 2257 //
     /* 2336368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2336371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2336378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2336385 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2336388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2336395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336399 */   // GIR_Coverage, 2257,
     /* 2336399 */   GIR_EraseRootFromParent_Done,
     /* 2336400 */ // Label 32354: @2336400
     /* 2336400 */ GIM_Try, /*On fail goto*//*Label 32355*/ GIMT_Encode4(2336437), // Rule ID 2283 //
     /* 2336405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2336408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2336415 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2336422 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2336425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2336432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336436 */   // GIR_Coverage, 2283,
     /* 2336436 */   GIR_EraseRootFromParent_Done,
     /* 2336437 */ // Label 32355: @2336437
     /* 2336437 */ GIM_Try, /*On fail goto*//*Label 32356*/ GIMT_Encode4(2336468), // Rule ID 2206 //
     /* 2336442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2336445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2336452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336456 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2336456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2336459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336461 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336466 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336467 */   // GIR_Coverage, 2206,
     /* 2336467 */   GIR_EraseRootFromParent_Done,
     /* 2336468 */ // Label 32356: @2336468
     /* 2336468 */ GIM_Try, /*On fail goto*//*Label 32357*/ GIMT_Encode4(2336499), // Rule ID 2207 //
     /* 2336473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2336476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2336483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336487 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2336487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2336490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336492 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336498 */   // GIR_Coverage, 2207,
     /* 2336498 */   GIR_EraseRootFromParent_Done,
     /* 2336499 */ // Label 32357: @2336499
     /* 2336499 */ GIM_Try, /*On fail goto*//*Label 32358*/ GIMT_Encode4(2336530), // Rule ID 2232 //
     /* 2336504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2336507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2336514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336518 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2336518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2336521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336523 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336528 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336529 */   // GIR_Coverage, 2232,
     /* 2336529 */   GIR_EraseRootFromParent_Done,
     /* 2336530 */ // Label 32358: @2336530
     /* 2336530 */ GIM_Try, /*On fail goto*//*Label 32359*/ GIMT_Encode4(2336561), // Rule ID 2233 //
     /* 2336535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2336538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2336545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336549 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2336549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2336552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336554 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336560 */   // GIR_Coverage, 2233,
     /* 2336560 */   GIR_EraseRootFromParent_Done,
     /* 2336561 */ // Label 32359: @2336561
     /* 2336561 */ GIM_Try, /*On fail goto*//*Label 32360*/ GIMT_Encode4(2336592), // Rule ID 2261 //
     /* 2336566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2336569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2336576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336580 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L),
     /* 2336583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336585 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336591 */   // GIR_Coverage, 2261,
     /* 2336591 */   GIR_EraseRootFromParent_Done,
     /* 2336592 */ // Label 32360: @2336592
     /* 2336592 */ GIM_Try, /*On fail goto*//*Label 32361*/ GIMT_Encode4(2336623), // Rule ID 2287 //
     /* 2336597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2336600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2336607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336611 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L_INX),
     /* 2336614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336616 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336621 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336622 */   // GIR_Coverage, 2287,
     /* 2336622 */   GIR_EraseRootFromParent_Done,
     /* 2336623 */ // Label 32361: @2336623
     /* 2336623 */ GIM_Reject,
     /* 2336624 */ // Label 32336: @2336624
     /* 2336624 */ GIM_Try, /*On fail goto*//*Label 32362*/ GIMT_Encode4(2336661), // Rule ID 1523 //
     /* 2336629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2336632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2336639 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2336646 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2336649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2336656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336660 */   // GIR_Coverage, 1523,
     /* 2336660 */   GIR_EraseRootFromParent_Done,
     /* 2336661 */ // Label 32362: @2336661
     /* 2336661 */ GIM_Try, /*On fail goto*//*Label 32363*/ GIMT_Encode4(2336698), // Rule ID 1551 //
     /* 2336666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2336669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2336676 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2336683 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2336686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2336693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336696 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336697 */   // GIR_Coverage, 1551,
     /* 2336697 */   GIR_EraseRootFromParent_Done,
     /* 2336698 */ // Label 32363: @2336698
     /* 2336698 */ GIM_Try, /*On fail goto*//*Label 32364*/ GIMT_Encode4(2336729), // Rule ID 1470 //
     /* 2336703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2336706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2336713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336717 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2336717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2336720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336722 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336728 */   // GIR_Coverage, 1470,
     /* 2336728 */   GIR_EraseRootFromParent_Done,
     /* 2336729 */ // Label 32364: @2336729
     /* 2336729 */ GIM_Try, /*On fail goto*//*Label 32365*/ GIMT_Encode4(2336760), // Rule ID 1471 //
     /* 2336734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2336737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2336744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336748 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2336748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2336751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336753 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336759 */   // GIR_Coverage, 1471,
     /* 2336759 */   GIR_EraseRootFromParent_Done,
     /* 2336760 */ // Label 32365: @2336760
     /* 2336760 */ GIM_Try, /*On fail goto*//*Label 32366*/ GIMT_Encode4(2336791), // Rule ID 1496 //
     /* 2336765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2336768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2336775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336779 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2336779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2336782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336784 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336790 */   // GIR_Coverage, 1496,
     /* 2336790 */   GIR_EraseRootFromParent_Done,
     /* 2336791 */ // Label 32366: @2336791
     /* 2336791 */ GIM_Try, /*On fail goto*//*Label 32367*/ GIMT_Encode4(2336822), // Rule ID 1497 //
     /* 2336796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2336799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2336806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336810 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2336810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2336813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336815 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336821 */   // GIR_Coverage, 1497,
     /* 2336821 */   GIR_EraseRootFromParent_Done,
     /* 2336822 */ // Label 32367: @2336822
     /* 2336822 */ GIM_Try, /*On fail goto*//*Label 32368*/ GIMT_Encode4(2336853), // Rule ID 1527 //
     /* 2336827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2336830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2336837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336841 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L),
     /* 2336844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336846 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336852 */   // GIR_Coverage, 1527,
     /* 2336852 */   GIR_EraseRootFromParent_Done,
     /* 2336853 */ // Label 32368: @2336853
     /* 2336853 */ GIM_Try, /*On fail goto*//*Label 32369*/ GIMT_Encode4(2336884), // Rule ID 1555 //
     /* 2336858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2336861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2336868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336872 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2336872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L_INX),
     /* 2336875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336877 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2336882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336883 */   // GIR_Coverage, 1555,
     /* 2336883 */   GIR_EraseRootFromParent_Done,
     /* 2336884 */ // Label 32369: @2336884
     /* 2336884 */ GIM_Reject,
     /* 2336885 */ // Label 32337: @2336885
     /* 2336885 */ GIM_Try, /*On fail goto*//*Label 32370*/ GIMT_Encode4(2336922), // Rule ID 1903 //
     /* 2336890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2336893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2336900 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2336907 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2336907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2336910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2336917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2336920 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336921 */   // GIR_Coverage, 1903,
     /* 2336921 */   GIR_EraseRootFromParent_Done,
     /* 2336922 */ // Label 32370: @2336922
     /* 2336922 */ GIM_Try, /*On fail goto*//*Label 32371*/ GIMT_Encode4(2336959), // Rule ID 1931 //
     /* 2336927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2336930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2336933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336937 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2336944 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2336944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_INX),
     /* 2336947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2336954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2336957 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336958 */   // GIR_Coverage, 1931,
     /* 2336958 */   GIR_EraseRootFromParent_Done,
     /* 2336959 */ // Label 32371: @2336959
     /* 2336959 */ GIM_Try, /*On fail goto*//*Label 32372*/ GIMT_Encode4(2336990), // Rule ID 1864 //
     /* 2336964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2336967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2336970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2336974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2336978 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2336978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2336981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336983 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2336988 */   GIR_RootConstrainSelectedInstOperands,
     /* 2336989 */   // GIR_Coverage, 1864,
     /* 2336989 */   GIR_EraseRootFromParent_Done,
     /* 2336990 */ // Label 32372: @2336990
     /* 2336990 */ GIM_Try, /*On fail goto*//*Label 32373*/ GIMT_Encode4(2337021), // Rule ID 1865 //
     /* 2336995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2336998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337009 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2337009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2337012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337014 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2337019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337020 */   // GIR_Coverage, 1865,
     /* 2337020 */   GIR_EraseRootFromParent_Done,
     /* 2337021 */ // Label 32373: @2337021
     /* 2337021 */ GIM_Try, /*On fail goto*//*Label 32374*/ GIMT_Encode4(2337052), // Rule ID 1890 //
     /* 2337026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2337029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2337036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337040 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2337040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2337043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337045 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2337050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337051 */   // GIR_Coverage, 1890,
     /* 2337051 */   GIR_EraseRootFromParent_Done,
     /* 2337052 */ // Label 32374: @2337052
     /* 2337052 */ GIM_Try, /*On fail goto*//*Label 32375*/ GIMT_Encode4(2337083), // Rule ID 1891 //
     /* 2337057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2337060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2337063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2337067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337071 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2337071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2337074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337076 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2337081 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337082 */   // GIR_Coverage, 1891,
     /* 2337082 */   GIR_EraseRootFromParent_Done,
     /* 2337083 */ // Label 32375: @2337083
     /* 2337083 */ GIM_Try, /*On fail goto*//*Label 32376*/ GIMT_Encode4(2337114), // Rule ID 1921 //
     /* 2337088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2337091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2337098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337102 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L),
     /* 2337105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337107 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337113 */   // GIR_Coverage, 1921,
     /* 2337113 */   GIR_EraseRootFromParent_Done,
     /* 2337114 */ // Label 32376: @2337114
     /* 2337114 */ GIM_Try, /*On fail goto*//*Label 32377*/ GIMT_Encode4(2337145), // Rule ID 1949 //
     /* 2337119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2337122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2337125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2337133 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2337133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L_INX),
     /* 2337136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337138 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337144 */   // GIR_Coverage, 1949,
     /* 2337144 */   GIR_EraseRootFromParent_Done,
     /* 2337145 */ // Label 32377: @2337145
     /* 2337145 */ GIM_Reject,
     /* 2337146 */ // Label 32338: @2337146
     /* 2337146 */ GIM_Try, /*On fail goto*//*Label 32378*/ GIMT_Encode4(2337203), // Rule ID 45798 //
     /* 2337151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2337157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337165 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2337182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337187 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337201 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337202 */   // GIR_Coverage, 45798,
     /* 2337202 */   GIR_EraseRootFromParent_Done,
     /* 2337203 */ // Label 32378: @2337203
     /* 2337203 */ GIM_Try, /*On fail goto*//*Label 32379*/ GIMT_Encode4(2337260), // Rule ID 45799 //
     /* 2337208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2337214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337222 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2337239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337244 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337258 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337259 */   // GIR_Coverage, 45799,
     /* 2337259 */   GIR_EraseRootFromParent_Done,
     /* 2337260 */ // Label 32379: @2337260
     /* 2337260 */ GIM_Try, /*On fail goto*//*Label 32380*/ GIMT_Encode4(2337314), // Rule ID 45806 //
     /* 2337265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2337271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337279 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2337296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337301 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337312 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337313 */   // GIR_Coverage, 45806,
     /* 2337313 */   GIR_EraseRootFromParent_Done,
     /* 2337314 */ // Label 32380: @2337314
     /* 2337314 */ GIM_Try, /*On fail goto*//*Label 32381*/ GIMT_Encode4(2337368), // Rule ID 45807 //
     /* 2337319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2337325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337333 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2337350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337355 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337367 */   // GIR_Coverage, 45807,
     /* 2337367 */   GIR_EraseRootFromParent_Done,
     /* 2337368 */ // Label 32381: @2337368
     /* 2337368 */ GIM_Try, /*On fail goto*//*Label 32382*/ GIMT_Encode4(2337425), // Rule ID 45814 //
     /* 2337373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2337376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337387 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2337404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337409 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337423 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337424 */   // GIR_Coverage, 45814,
     /* 2337424 */   GIR_EraseRootFromParent_Done,
     /* 2337425 */ // Label 32382: @2337425
     /* 2337425 */ GIM_Try, /*On fail goto*//*Label 32383*/ GIMT_Encode4(2337482), // Rule ID 45815 //
     /* 2337430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2337433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337444 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337444 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2337447 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337451 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337456 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2337461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337466 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337480 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337481 */   // GIR_Coverage, 45815,
     /* 2337481 */   GIR_EraseRootFromParent_Done,
     /* 2337482 */ // Label 32383: @2337482
     /* 2337482 */ GIM_Reject,
     /* 2337483 */ // Label 32339: @2337483
     /* 2337483 */ GIM_Try, /*On fail goto*//*Label 32384*/ GIMT_Encode4(2337540), // Rule ID 58410 //
     /* 2337488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2337491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337502 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2337505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2337519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337524 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337539 */   // GIR_Coverage, 58410,
     /* 2337539 */   GIR_EraseRootFromParent_Done,
     /* 2337540 */ // Label 32384: @2337540
     /* 2337540 */ GIM_Try, /*On fail goto*//*Label 32385*/ GIMT_Encode4(2337597), // Rule ID 58411 //
     /* 2337545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2337548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337559 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2337562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2337576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337578 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337581 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337596 */   // GIR_Coverage, 58411,
     /* 2337596 */   GIR_EraseRootFromParent_Done,
     /* 2337597 */ // Label 32385: @2337597
     /* 2337597 */ GIM_Try, /*On fail goto*//*Label 32386*/ GIMT_Encode4(2337651), // Rule ID 58610 //
     /* 2337602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2337605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2337608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337616 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2337619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2337633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337638 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337650 */   // GIR_Coverage, 58610,
     /* 2337650 */   GIR_EraseRootFromParent_Done,
     /* 2337651 */ // Label 32386: @2337651
     /* 2337651 */ GIM_Try, /*On fail goto*//*Label 32387*/ GIMT_Encode4(2337705), // Rule ID 58611 //
     /* 2337656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2337659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2337662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337670 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337670 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2337673 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337677 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2337687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337692 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337694 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337704 */   // GIR_Coverage, 58611,
     /* 2337704 */   GIR_EraseRootFromParent_Done,
     /* 2337705 */ // Label 32387: @2337705
     /* 2337705 */ GIM_Try, /*On fail goto*//*Label 32388*/ GIMT_Encode4(2337762), // Rule ID 58838 //
     /* 2337710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2337713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2337716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337724 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2337727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2337741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337746 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337748 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337760 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337761 */   // GIR_Coverage, 58838,
     /* 2337761 */   GIR_EraseRootFromParent_Done,
     /* 2337762 */ // Label 32388: @2337762
     /* 2337762 */ GIM_Try, /*On fail goto*//*Label 32389*/ GIMT_Encode4(2337819), // Rule ID 58839 //
     /* 2337767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2337770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2337773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337781 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2337784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2337798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337803 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337805 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337817 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337818 */   // GIR_Coverage, 58839,
     /* 2337818 */   GIR_EraseRootFromParent_Done,
     /* 2337819 */ // Label 32389: @2337819
     /* 2337819 */ GIM_Reject,
     /* 2337820 */ // Label 32340: @2337820
     /* 2337820 */ GIM_Try, /*On fail goto*//*Label 32390*/ GIMT_Encode4(2337877), // Rule ID 58422 //
     /* 2337825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2337828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2337831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337839 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337839 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2337842 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337846 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2337856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337861 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337876 */   // GIR_Coverage, 58422,
     /* 2337876 */   GIR_EraseRootFromParent_Done,
     /* 2337877 */ // Label 32390: @2337877
     /* 2337877 */ GIM_Try, /*On fail goto*//*Label 32391*/ GIMT_Encode4(2337934), // Rule ID 58423 //
     /* 2337882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2337885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2337888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337896 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2337899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2337913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337918 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2337923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337933 */   // GIR_Coverage, 58423,
     /* 2337933 */   GIR_EraseRootFromParent_Done,
     /* 2337934 */ // Label 32391: @2337934
     /* 2337934 */ GIM_Try, /*On fail goto*//*Label 32392*/ GIMT_Encode4(2337988), // Rule ID 58630 //
     /* 2337939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2337942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337953 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2337956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2337970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337972 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337975 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2337987 */   // GIR_Coverage, 58630,
     /* 2337987 */   GIR_EraseRootFromParent_Done,
     /* 2337988 */ // Label 32392: @2337988
     /* 2337988 */ GIM_Try, /*On fail goto*//*Label 32393*/ GIMT_Encode4(2338042), // Rule ID 58631 //
     /* 2337993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2337996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2337999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338007 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2338010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2338024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338029 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338040 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338041 */   // GIR_Coverage, 58631,
     /* 2338041 */   GIR_EraseRootFromParent_Done,
     /* 2338042 */ // Label 32393: @2338042
     /* 2338042 */ GIM_Reject,
     /* 2338043 */ // Label 32341: @2338043
     /* 2338043 */ GIM_Try, /*On fail goto*//*Label 32394*/ GIMT_Encode4(2338100), // Rule ID 58406 //
     /* 2338048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2338054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338062 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2338079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338081 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338084 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338099 */   // GIR_Coverage, 58406,
     /* 2338099 */   GIR_EraseRootFromParent_Done,
     /* 2338100 */ // Label 32394: @2338100
     /* 2338100 */ GIM_Try, /*On fail goto*//*Label 32395*/ GIMT_Encode4(2338157), // Rule ID 58407 //
     /* 2338105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2338111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338119 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2338136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338141 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338156 */   // GIR_Coverage, 58407,
     /* 2338156 */   GIR_EraseRootFromParent_Done,
     /* 2338157 */ // Label 32395: @2338157
     /* 2338157 */ GIM_Try, /*On fail goto*//*Label 32396*/ GIMT_Encode4(2338211), // Rule ID 58590 //
     /* 2338162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2338168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338176 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2338193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338198 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338209 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338210 */   // GIR_Coverage, 58590,
     /* 2338210 */   GIR_EraseRootFromParent_Done,
     /* 2338211 */ // Label 32396: @2338211
     /* 2338211 */ GIM_Try, /*On fail goto*//*Label 32397*/ GIMT_Encode4(2338265), // Rule ID 58591 //
     /* 2338216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2338222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338230 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2338247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338252 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338263 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338264 */   // GIR_Coverage, 58591,
     /* 2338264 */   GIR_EraseRootFromParent_Done,
     /* 2338265 */ // Label 32397: @2338265
     /* 2338265 */ GIM_Try, /*On fail goto*//*Label 32398*/ GIMT_Encode4(2338322), // Rule ID 58822 //
     /* 2338270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338284 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2338301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338306 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338320 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338321 */   // GIR_Coverage, 58822,
     /* 2338321 */   GIR_EraseRootFromParent_Done,
     /* 2338322 */ // Label 32398: @2338322
     /* 2338322 */ GIM_Try, /*On fail goto*//*Label 32399*/ GIMT_Encode4(2338379), // Rule ID 58823 //
     /* 2338327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2338330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338341 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2338344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2338358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338363 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338378 */   // GIR_Coverage, 58823,
     /* 2338378 */   GIR_EraseRootFromParent_Done,
     /* 2338379 */ // Label 32399: @2338379
     /* 2338379 */ GIM_Reject,
     /* 2338380 */ // Label 32342: @2338380
     /* 2338380 */ GIM_Try, /*On fail goto*//*Label 32400*/ GIMT_Encode4(2338437), // Rule ID 58418 //
     /* 2338385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338399 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2338416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338421 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338435 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338436 */   // GIR_Coverage, 58418,
     /* 2338436 */   GIR_EraseRootFromParent_Done,
     /* 2338437 */ // Label 32400: @2338437
     /* 2338437 */ GIM_Try, /*On fail goto*//*Label 32401*/ GIMT_Encode4(2338494), // Rule ID 58419 //
     /* 2338442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338456 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338456 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338463 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2338473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338475 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338478 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338493 */   // GIR_Coverage, 58419,
     /* 2338493 */   GIR_EraseRootFromParent_Done,
     /* 2338494 */ // Label 32401: @2338494
     /* 2338494 */ GIM_Try, /*On fail goto*//*Label 32402*/ GIMT_Encode4(2338548), // Rule ID 58614 //
     /* 2338499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2338502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2338505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338513 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2338530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338535 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338547 */   // GIR_Coverage, 58614,
     /* 2338547 */   GIR_EraseRootFromParent_Done,
     /* 2338548 */ // Label 32402: @2338548
     /* 2338548 */ GIM_Try, /*On fail goto*//*Label 32403*/ GIMT_Encode4(2338602), // Rule ID 58615 //
     /* 2338553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2338556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2338559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338567 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338579 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2338584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338589 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338600 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338601 */   // GIR_Coverage, 58615,
     /* 2338601 */   GIR_EraseRootFromParent_Done,
     /* 2338602 */ // Label 32403: @2338602
     /* 2338602 */ GIM_Try, /*On fail goto*//*Label 32404*/ GIMT_Encode4(2338659), // Rule ID 58842 //
     /* 2338607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2338610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2338613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338621 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2338638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338640 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338643 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338657 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338658 */   // GIR_Coverage, 58842,
     /* 2338658 */   GIR_EraseRootFromParent_Done,
     /* 2338659 */ // Label 32404: @2338659
     /* 2338659 */ GIM_Try, /*On fail goto*//*Label 32405*/ GIMT_Encode4(2338716), // Rule ID 58843 //
     /* 2338664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2338667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2338670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338678 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2338681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2338695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338697 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338700 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338714 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338715 */   // GIR_Coverage, 58843,
     /* 2338715 */   GIR_EraseRootFromParent_Done,
     /* 2338716 */ // Label 32405: @2338716
     /* 2338716 */ GIM_Reject,
     /* 2338717 */ // Label 32343: @2338717
     /* 2338717 */ GIM_Try, /*On fail goto*//*Label 32406*/ GIMT_Encode4(2338774), // Rule ID 58450 //
     /* 2338722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2338725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2338728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338736 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2338739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2338753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338758 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338773 */   // GIR_Coverage, 58450,
     /* 2338773 */   GIR_EraseRootFromParent_Done,
     /* 2338774 */ // Label 32406: @2338774
     /* 2338774 */ GIM_Try, /*On fail goto*//*Label 32407*/ GIMT_Encode4(2338831), // Rule ID 58451 //
     /* 2338779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2338782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2338785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338793 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2338796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2338810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338815 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338829 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338830 */   // GIR_Coverage, 58451,
     /* 2338830 */   GIR_EraseRootFromParent_Done,
     /* 2338831 */ // Label 32407: @2338831
     /* 2338831 */ GIM_Try, /*On fail goto*//*Label 32408*/ GIMT_Encode4(2338885), // Rule ID 58634 //
     /* 2338836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2338839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338850 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2338853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2338867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338872 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338884 */   // GIR_Coverage, 58634,
     /* 2338884 */   GIR_EraseRootFromParent_Done,
     /* 2338885 */ // Label 32408: @2338885
     /* 2338885 */ GIM_Try, /*On fail goto*//*Label 32409*/ GIMT_Encode4(2338939), // Rule ID 58635 //
     /* 2338890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2338893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2338896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338904 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338904 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2338907 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338911 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2338921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338926 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338937 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338938 */   // GIR_Coverage, 58635,
     /* 2338938 */   GIR_EraseRootFromParent_Done,
     /* 2338939 */ // Label 32409: @2338939
     /* 2338939 */ GIM_Reject,
     /* 2338940 */ // Label 32344: @2338940
     /* 2338940 */ GIM_Try, /*On fail goto*//*Label 32410*/ GIMT_Encode4(2338997), // Rule ID 58414 //
     /* 2338945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2338948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2338951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2338959 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2338962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338971 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2338976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338978 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338981 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2338986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338995 */   GIR_RootConstrainSelectedInstOperands,
     /* 2338996 */   // GIR_Coverage, 58414,
     /* 2338996 */   GIR_EraseRootFromParent_Done,
     /* 2338997 */ // Label 32410: @2338997
     /* 2338997 */ GIM_Try, /*On fail goto*//*Label 32411*/ GIMT_Encode4(2339054), // Rule ID 58415 //
     /* 2339002 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2339008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339016 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2339033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339038 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339053 */   // GIR_Coverage, 58415,
     /* 2339053 */   GIR_EraseRootFromParent_Done,
     /* 2339054 */ // Label 32411: @2339054
     /* 2339054 */ GIM_Try, /*On fail goto*//*Label 32412*/ GIMT_Encode4(2339108), // Rule ID 58594 //
     /* 2339059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2339065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339073 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2339090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339095 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339107 */   // GIR_Coverage, 58594,
     /* 2339107 */   GIR_EraseRootFromParent_Done,
     /* 2339108 */ // Label 32412: @2339108
     /* 2339108 */ GIM_Try, /*On fail goto*//*Label 32413*/ GIMT_Encode4(2339162), // Rule ID 58595 //
     /* 2339113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2339119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339127 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2339144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339149 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339160 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339161 */   // GIR_Coverage, 58595,
     /* 2339161 */   GIR_EraseRootFromParent_Done,
     /* 2339162 */ // Label 32413: @2339162
     /* 2339162 */ GIM_Try, /*On fail goto*//*Label 32414*/ GIMT_Encode4(2339219), // Rule ID 58826 //
     /* 2339167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339181 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2339198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339203 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339217 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339218 */   // GIR_Coverage, 58826,
     /* 2339218 */   GIR_EraseRootFromParent_Done,
     /* 2339219 */ // Label 32414: @2339219
     /* 2339219 */ GIM_Try, /*On fail goto*//*Label 32415*/ GIMT_Encode4(2339276), // Rule ID 58827 //
     /* 2339224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339238 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2339241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2339255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339260 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339265 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339275 */   // GIR_Coverage, 58827,
     /* 2339275 */   GIR_EraseRootFromParent_Done,
     /* 2339276 */ // Label 32415: @2339276
     /* 2339276 */ GIM_Reject,
     /* 2339277 */ // Label 32345: @2339277
     /* 2339277 */ GIM_Try, /*On fail goto*//*Label 32416*/ GIMT_Encode4(2339334), // Rule ID 58438 //
     /* 2339282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2339285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339296 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339296 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339299 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339303 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2339313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339315 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339318 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339333 */   // GIR_Coverage, 58438,
     /* 2339333 */   GIR_EraseRootFromParent_Done,
     /* 2339334 */ // Label 32416: @2339334
     /* 2339334 */ GIM_Try, /*On fail goto*//*Label 32417*/ GIMT_Encode4(2339391), // Rule ID 58439 //
     /* 2339339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2339342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339353 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2339370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339375 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339389 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339390 */   // GIR_Coverage, 58439,
     /* 2339390 */   GIR_EraseRootFromParent_Done,
     /* 2339391 */ // Label 32417: @2339391
     /* 2339391 */ GIM_Try, /*On fail goto*//*Label 32418*/ GIMT_Encode4(2339445), // Rule ID 58618 //
     /* 2339396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2339399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2339402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339410 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2339427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339432 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339444 */   // GIR_Coverage, 58618,
     /* 2339444 */   GIR_EraseRootFromParent_Done,
     /* 2339445 */ // Label 32418: @2339445
     /* 2339445 */ GIM_Try, /*On fail goto*//*Label 32419*/ GIMT_Encode4(2339499), // Rule ID 58619 //
     /* 2339450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2339453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2339456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339464 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2339481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339486 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339498 */   // GIR_Coverage, 58619,
     /* 2339498 */   GIR_EraseRootFromParent_Done,
     /* 2339499 */ // Label 32419: @2339499
     /* 2339499 */ GIM_Try, /*On fail goto*//*Label 32420*/ GIMT_Encode4(2339556), // Rule ID 58846 //
     /* 2339504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2339507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2339510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339518 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2339535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339540 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339554 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339555 */   // GIR_Coverage, 58846,
     /* 2339555 */   GIR_EraseRootFromParent_Done,
     /* 2339556 */ // Label 32420: @2339556
     /* 2339556 */ GIM_Try, /*On fail goto*//*Label 32421*/ GIMT_Encode4(2339613), // Rule ID 58847 //
     /* 2339561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2339564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2339567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339575 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339575 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2339578 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339582 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339587 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2339592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339597 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339611 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339612 */   // GIR_Coverage, 58847,
     /* 2339612 */   GIR_EraseRootFromParent_Done,
     /* 2339613 */ // Label 32421: @2339613
     /* 2339613 */ GIM_Reject,
     /* 2339614 */ // Label 32346: @2339614
     /* 2339614 */ GIM_Try, /*On fail goto*//*Label 32422*/ GIMT_Encode4(2339671), // Rule ID 58454 //
     /* 2339619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2339622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2339625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339633 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2339636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2339650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339655 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2339666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339670 */   // GIR_Coverage, 58454,
     /* 2339670 */   GIR_EraseRootFromParent_Done,
     /* 2339671 */ // Label 32422: @2339671
     /* 2339671 */ GIM_Try, /*On fail goto*//*Label 32423*/ GIMT_Encode4(2339728), // Rule ID 58455 //
     /* 2339676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2339679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2339682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339690 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2339693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2339707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339712 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2339723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339727 */   // GIR_Coverage, 58455,
     /* 2339727 */   GIR_EraseRootFromParent_Done,
     /* 2339728 */ // Label 32423: @2339728
     /* 2339728 */ GIM_Try, /*On fail goto*//*Label 32424*/ GIMT_Encode4(2339782), // Rule ID 58638 //
     /* 2339733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2339736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339747 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339747 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2339750 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339754 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2339764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339769 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339781 */   // GIR_Coverage, 58638,
     /* 2339781 */   GIR_EraseRootFromParent_Done,
     /* 2339782 */ // Label 32424: @2339782
     /* 2339782 */ GIM_Try, /*On fail goto*//*Label 32425*/ GIMT_Encode4(2339836), // Rule ID 58639 //
     /* 2339787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2339790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2339793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339801 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2339804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2339818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339823 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339834 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339835 */   // GIR_Coverage, 58639,
     /* 2339835 */   GIR_EraseRootFromParent_Done,
     /* 2339836 */ // Label 32425: @2339836
     /* 2339836 */ GIM_Reject,
     /* 2339837 */ // Label 32347: @2339837
     /* 2339837 */ GIM_Try, /*On fail goto*//*Label 32426*/ GIMT_Encode4(2339894), // Rule ID 58426 //
     /* 2339842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2339848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339856 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2339859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2339873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339878 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339892 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339893 */   // GIR_Coverage, 58426,
     /* 2339893 */   GIR_EraseRootFromParent_Done,
     /* 2339894 */ // Label 32426: @2339894
     /* 2339894 */ GIM_Try, /*On fail goto*//*Label 32427*/ GIMT_Encode4(2339951), // Rule ID 58427 //
     /* 2339899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2339902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2339905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339913 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339913 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2339916 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339920 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2339930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339932 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339935 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2339940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2339950 */   // GIR_Coverage, 58427,
     /* 2339950 */   GIR_EraseRootFromParent_Done,
     /* 2339951 */ // Label 32427: @2339951
     /* 2339951 */ GIM_Try, /*On fail goto*//*Label 32428*/ GIMT_Encode4(2340005), // Rule ID 58598 //
     /* 2339956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2339959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2339962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2339966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2339970 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2339973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2339987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339992 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340004 */   // GIR_Coverage, 58598,
     /* 2340004 */   GIR_EraseRootFromParent_Done,
     /* 2340005 */ // Label 32428: @2340005
     /* 2340005 */ GIM_Try, /*On fail goto*//*Label 32429*/ GIMT_Encode4(2340059), // Rule ID 58599 //
     /* 2340010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2340016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340024 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2340041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340043 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340046 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340057 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340058 */   // GIR_Coverage, 58599,
     /* 2340058 */   GIR_EraseRootFromParent_Done,
     /* 2340059 */ // Label 32429: @2340059
     /* 2340059 */ GIM_Try, /*On fail goto*//*Label 32430*/ GIMT_Encode4(2340116), // Rule ID 58830 //
     /* 2340064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340078 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2340095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340100 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340115 */   // GIR_Coverage, 58830,
     /* 2340115 */   GIR_EraseRootFromParent_Done,
     /* 2340116 */ // Label 32430: @2340116
     /* 2340116 */ GIM_Try, /*On fail goto*//*Label 32431*/ GIMT_Encode4(2340173), // Rule ID 58831 //
     /* 2340121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340135 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2340138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2340152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340157 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340159 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340172 */   // GIR_Coverage, 58831,
     /* 2340172 */   GIR_EraseRootFromParent_Done,
     /* 2340173 */ // Label 32431: @2340173
     /* 2340173 */ GIM_Reject,
     /* 2340174 */ // Label 32348: @2340174
     /* 2340174 */ GIM_Try, /*On fail goto*//*Label 32432*/ GIMT_Encode4(2340231), // Rule ID 58442 //
     /* 2340179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340193 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2340210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340215 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340230 */   // GIR_Coverage, 58442,
     /* 2340230 */   GIR_EraseRootFromParent_Done,
     /* 2340231 */ // Label 32432: @2340231
     /* 2340231 */ GIM_Try, /*On fail goto*//*Label 32433*/ GIMT_Encode4(2340288), // Rule ID 58443 //
     /* 2340236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340250 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2340267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340272 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340286 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340287 */   // GIR_Coverage, 58443,
     /* 2340287 */   GIR_EraseRootFromParent_Done,
     /* 2340288 */ // Label 32433: @2340288
     /* 2340288 */ GIM_Try, /*On fail goto*//*Label 32434*/ GIMT_Encode4(2340342), // Rule ID 58622 //
     /* 2340293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2340296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340307 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2340324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340329 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340341 */   // GIR_Coverage, 58622,
     /* 2340341 */   GIR_EraseRootFromParent_Done,
     /* 2340342 */ // Label 32434: @2340342
     /* 2340342 */ GIM_Try, /*On fail goto*//*Label 32435*/ GIMT_Encode4(2340396), // Rule ID 58623 //
     /* 2340347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2340350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2340353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340361 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2340378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340383 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340395 */   // GIR_Coverage, 58623,
     /* 2340395 */   GIR_EraseRootFromParent_Done,
     /* 2340396 */ // Label 32435: @2340396
     /* 2340396 */ GIM_Try, /*On fail goto*//*Label 32436*/ GIMT_Encode4(2340453), // Rule ID 58850 //
     /* 2340401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2340404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2340407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340415 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2340432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340437 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340452 */   // GIR_Coverage, 58850,
     /* 2340452 */   GIR_EraseRootFromParent_Done,
     /* 2340453 */ // Label 32436: @2340453
     /* 2340453 */ GIM_Try, /*On fail goto*//*Label 32437*/ GIMT_Encode4(2340510), // Rule ID 58851 //
     /* 2340458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2340461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2340464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340472 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2340475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2340489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340494 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340508 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340509 */   // GIR_Coverage, 58851,
     /* 2340509 */   GIR_EraseRootFromParent_Done,
     /* 2340510 */ // Label 32437: @2340510
     /* 2340510 */ GIM_Reject,
     /* 2340511 */ // Label 32349: @2340511
     /* 2340511 */ GIM_Try, /*On fail goto*//*Label 32438*/ GIMT_Encode4(2340568), // Rule ID 58458 //
     /* 2340516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2340519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2340522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340530 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2340533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2340547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340549 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340552 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340566 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340567 */   // GIR_Coverage, 58458,
     /* 2340567 */   GIR_EraseRootFromParent_Done,
     /* 2340568 */ // Label 32438: @2340568
     /* 2340568 */ GIM_Try, /*On fail goto*//*Label 32439*/ GIMT_Encode4(2340625), // Rule ID 58459 //
     /* 2340573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2340576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2340579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340587 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2340590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2340604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340609 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340623 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340624 */   // GIR_Coverage, 58459,
     /* 2340624 */   GIR_EraseRootFromParent_Done,
     /* 2340625 */ // Label 32439: @2340625
     /* 2340625 */ GIM_Try, /*On fail goto*//*Label 32440*/ GIMT_Encode4(2340679), // Rule ID 58642 //
     /* 2340630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2340633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340644 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340644 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2340647 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340651 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2340661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340666 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340678 */   // GIR_Coverage, 58642,
     /* 2340678 */   GIR_EraseRootFromParent_Done,
     /* 2340679 */ // Label 32440: @2340679
     /* 2340679 */ GIM_Try, /*On fail goto*//*Label 32441*/ GIMT_Encode4(2340733), // Rule ID 58643 //
     /* 2340684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2340687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2340690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340698 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2340701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2340715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340720 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340732 */   // GIR_Coverage, 58643,
     /* 2340732 */   GIR_EraseRootFromParent_Done,
     /* 2340733 */ // Label 32441: @2340733
     /* 2340733 */ GIM_Reject,
     /* 2340734 */ // Label 32350: @2340734
     /* 2340734 */ GIM_Try, /*On fail goto*//*Label 32442*/ GIMT_Encode4(2340791), // Rule ID 58430 //
     /* 2340739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2340745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340753 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2340756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2340770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340775 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340790 */   // GIR_Coverage, 58430,
     /* 2340790 */   GIR_EraseRootFromParent_Done,
     /* 2340791 */ // Label 32442: @2340791
     /* 2340791 */ GIM_Try, /*On fail goto*//*Label 32443*/ GIMT_Encode4(2340848), // Rule ID 58431 //
     /* 2340796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2340802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340810 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340810 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2340813 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340817 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2340827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340832 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2340837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340847 */   // GIR_Coverage, 58431,
     /* 2340847 */   GIR_EraseRootFromParent_Done,
     /* 2340848 */ // Label 32443: @2340848
     /* 2340848 */ GIM_Try, /*On fail goto*//*Label 32444*/ GIMT_Encode4(2340902), // Rule ID 58602 //
     /* 2340853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2340859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340867 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2340870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2340884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340889 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340900 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340901 */   // GIR_Coverage, 58602,
     /* 2340901 */   GIR_EraseRootFromParent_Done,
     /* 2340902 */ // Label 32444: @2340902
     /* 2340902 */ GIM_Try, /*On fail goto*//*Label 32445*/ GIMT_Encode4(2340956), // Rule ID 58603 //
     /* 2340907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2340910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2340913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340921 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2340924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2340938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340940 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340943 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340954 */   GIR_RootConstrainSelectedInstOperands,
     /* 2340955 */   // GIR_Coverage, 58603,
     /* 2340955 */   GIR_EraseRootFromParent_Done,
     /* 2340956 */ // Label 32445: @2340956
     /* 2340956 */ GIM_Try, /*On fail goto*//*Label 32446*/ GIMT_Encode4(2341013), // Rule ID 58834 //
     /* 2340961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2340964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2340967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2340971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2340975 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2340978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2340992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340997 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341012 */   // GIR_Coverage, 58834,
     /* 2341012 */   GIR_EraseRootFromParent_Done,
     /* 2341013 */ // Label 32446: @2341013
     /* 2341013 */ GIM_Try, /*On fail goto*//*Label 32447*/ GIMT_Encode4(2341070), // Rule ID 58835 //
     /* 2341018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341032 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2341049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341054 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341069 */   // GIR_Coverage, 58835,
     /* 2341069 */   GIR_EraseRootFromParent_Done,
     /* 2341070 */ // Label 32447: @2341070
     /* 2341070 */ GIM_Reject,
     /* 2341071 */ // Label 32351: @2341071
     /* 2341071 */ GIM_Try, /*On fail goto*//*Label 32448*/ GIMT_Encode4(2341128), // Rule ID 58446 //
     /* 2341076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341090 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2341107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341112 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341127 */   // GIR_Coverage, 58446,
     /* 2341127 */   GIR_EraseRootFromParent_Done,
     /* 2341128 */ // Label 32448: @2341128
     /* 2341128 */ GIM_Try, /*On fail goto*//*Label 32449*/ GIMT_Encode4(2341185), // Rule ID 58447 //
     /* 2341133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341147 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341147 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341150 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341154 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2341164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341169 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341183 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341184 */   // GIR_Coverage, 58447,
     /* 2341184 */   GIR_EraseRootFromParent_Done,
     /* 2341185 */ // Label 32449: @2341185
     /* 2341185 */ GIM_Try, /*On fail goto*//*Label 32450*/ GIMT_Encode4(2341239), // Rule ID 58626 //
     /* 2341190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2341193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341204 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2341221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341223 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341226 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341238 */   // GIR_Coverage, 58626,
     /* 2341238 */   GIR_EraseRootFromParent_Done,
     /* 2341239 */ // Label 32450: @2341239
     /* 2341239 */ GIM_Try, /*On fail goto*//*Label 32451*/ GIMT_Encode4(2341293), // Rule ID 58627 //
     /* 2341244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2341247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341258 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2341275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341280 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341292 */   // GIR_Coverage, 58627,
     /* 2341292 */   GIR_EraseRootFromParent_Done,
     /* 2341293 */ // Label 32451: @2341293
     /* 2341293 */ GIM_Reject,
     /* 2341294 */ // Label 32352: @2341294
     /* 2341294 */ GIM_Try, /*On fail goto*//*Label 32452*/ GIMT_Encode4(2341351), // Rule ID 58434 //
     /* 2341299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2341305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341313 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341313 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341316 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341320 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2341330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341335 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341349 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341350 */   // GIR_Coverage, 58434,
     /* 2341350 */   GIR_EraseRootFromParent_Done,
     /* 2341351 */ // Label 32452: @2341351
     /* 2341351 */ GIM_Try, /*On fail goto*//*Label 32453*/ GIMT_Encode4(2341408), // Rule ID 58435 //
     /* 2341356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2341362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341370 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341370 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341373 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341377 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2341387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341392 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341407 */   // GIR_Coverage, 58435,
     /* 2341407 */   GIR_EraseRootFromParent_Done,
     /* 2341408 */ // Label 32453: @2341408
     /* 2341408 */ GIM_Try, /*On fail goto*//*Label 32454*/ GIMT_Encode4(2341462), // Rule ID 58606 //
     /* 2341413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2341416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2341419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341427 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341439 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2341444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341449 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341460 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341461 */   // GIR_Coverage, 58606,
     /* 2341461 */   GIR_EraseRootFromParent_Done,
     /* 2341462 */ // Label 32454: @2341462
     /* 2341462 */ GIM_Try, /*On fail goto*//*Label 32455*/ GIMT_Encode4(2341516), // Rule ID 58607 //
     /* 2341467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2341470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2341473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341481 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2341498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341500 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341515 */   // GIR_Coverage, 58607,
     /* 2341515 */   GIR_EraseRootFromParent_Done,
     /* 2341516 */ // Label 32455: @2341516
     /* 2341516 */ GIM_Reject,
     /* 2341517 */ // Label 32353: @2341517
     /* 2341517 */ GIM_Reject,
     /* 2341518 */ // Label 70: @2341518
     /* 2341518 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32474*/ GIMT_Encode4(2346803),
     /* 2341529 */ /*GILLT_s16*//*Label 32456*/ GIMT_Encode4(2341649),
     /* 2341533 */ /*GILLT_s32*//*Label 32457*/ GIMT_Encode4(2341910),
     /* 2341537 */ /*GILLT_s64*//*Label 32458*/ GIMT_Encode4(2342171), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341549 */ /*GILLT_nxv1s16*//*Label 32459*/ GIMT_Encode4(2342432),
     /* 2341553 */ /*GILLT_nxv1s32*//*Label 32460*/ GIMT_Encode4(2342769),
     /* 2341557 */ /*GILLT_nxv1s64*//*Label 32461*/ GIMT_Encode4(2343106), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341569 */ /*GILLT_nxv2s16*//*Label 32462*/ GIMT_Encode4(2343329),
     /* 2341573 */ /*GILLT_nxv2s32*//*Label 32463*/ GIMT_Encode4(2343666),
     /* 2341577 */ /*GILLT_nxv2s64*//*Label 32464*/ GIMT_Encode4(2344003), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341589 */ /*GILLT_nxv4s16*//*Label 32465*/ GIMT_Encode4(2344226),
     /* 2341593 */ /*GILLT_nxv4s32*//*Label 32466*/ GIMT_Encode4(2344563),
     /* 2341597 */ /*GILLT_nxv4s64*//*Label 32467*/ GIMT_Encode4(2344900), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341609 */ /*GILLT_nxv8s16*//*Label 32468*/ GIMT_Encode4(2345123),
     /* 2341613 */ /*GILLT_nxv8s32*//*Label 32469*/ GIMT_Encode4(2345460),
     /* 2341617 */ /*GILLT_nxv8s64*//*Label 32470*/ GIMT_Encode4(2345797), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341629 */ /*GILLT_nxv16s16*//*Label 32471*/ GIMT_Encode4(2346020),
     /* 2341633 */ /*GILLT_nxv16s32*//*Label 32472*/ GIMT_Encode4(2346357), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341645 */ /*GILLT_nxv32s16*//*Label 32473*/ GIMT_Encode4(2346580),
     /* 2341649 */ // Label 32456: @2341649
     /* 2341649 */ GIM_Try, /*On fail goto*//*Label 32475*/ GIMT_Encode4(2341686), // Rule ID 2259 //
     /* 2341654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2341657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2341660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2341664 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2341671 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2341671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2341674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2341681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341685 */   // GIR_Coverage, 2259,
     /* 2341685 */   GIR_EraseRootFromParent_Done,
     /* 2341686 */ // Label 32475: @2341686
     /* 2341686 */ GIM_Try, /*On fail goto*//*Label 32476*/ GIMT_Encode4(2341723), // Rule ID 2285 //
     /* 2341691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2341694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2341697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2341701 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2341708 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2341708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2341711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341713 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2341718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341721 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341722 */   // GIR_Coverage, 2285,
     /* 2341722 */   GIR_EraseRootFromParent_Done,
     /* 2341723 */ // Label 32476: @2341723
     /* 2341723 */ GIM_Try, /*On fail goto*//*Label 32477*/ GIMT_Encode4(2341754), // Rule ID 2210 //
     /* 2341728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2341731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2341734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2341738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2341742 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2341742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2341745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341747 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341753 */   // GIR_Coverage, 2210,
     /* 2341753 */   GIR_EraseRootFromParent_Done,
     /* 2341754 */ // Label 32477: @2341754
     /* 2341754 */ GIM_Try, /*On fail goto*//*Label 32478*/ GIMT_Encode4(2341785), // Rule ID 2211 //
     /* 2341759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2341762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2341765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2341769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2341773 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2341773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2341776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341778 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341783 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341784 */   // GIR_Coverage, 2211,
     /* 2341784 */   GIR_EraseRootFromParent_Done,
     /* 2341785 */ // Label 32478: @2341785
     /* 2341785 */ GIM_Try, /*On fail goto*//*Label 32479*/ GIMT_Encode4(2341816), // Rule ID 2236 //
     /* 2341790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2341793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2341796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2341800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2341804 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2341804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2341807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341809 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341814 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341815 */   // GIR_Coverage, 2236,
     /* 2341815 */   GIR_EraseRootFromParent_Done,
     /* 2341816 */ // Label 32479: @2341816
     /* 2341816 */ GIM_Try, /*On fail goto*//*Label 32480*/ GIMT_Encode4(2341847), // Rule ID 2237 //
     /* 2341821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2341824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2341827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2341831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2341835 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2341835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2341838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341840 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341846 */   // GIR_Coverage, 2237,
     /* 2341846 */   GIR_EraseRootFromParent_Done,
     /* 2341847 */ // Label 32480: @2341847
     /* 2341847 */ GIM_Try, /*On fail goto*//*Label 32481*/ GIMT_Encode4(2341878), // Rule ID 2263 //
     /* 2341852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2341855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2341858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2341862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2341866 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2341866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU),
     /* 2341869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341871 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341877 */   // GIR_Coverage, 2263,
     /* 2341877 */   GIR_EraseRootFromParent_Done,
     /* 2341878 */ // Label 32481: @2341878
     /* 2341878 */ GIM_Try, /*On fail goto*//*Label 32482*/ GIMT_Encode4(2341909), // Rule ID 2289 //
     /* 2341883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2341886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2341889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2341893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2341897 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2341897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU_INX),
     /* 2341900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341902 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341907 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341908 */   // GIR_Coverage, 2289,
     /* 2341908 */   GIR_EraseRootFromParent_Done,
     /* 2341909 */ // Label 32482: @2341909
     /* 2341909 */ GIM_Reject,
     /* 2341910 */ // Label 32457: @2341910
     /* 2341910 */ GIM_Try, /*On fail goto*//*Label 32483*/ GIMT_Encode4(2341947), // Rule ID 1525 //
     /* 2341915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2341918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2341921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2341925 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2341932 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2341932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2341935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2341942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341945 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341946 */   // GIR_Coverage, 1525,
     /* 2341946 */   GIR_EraseRootFromParent_Done,
     /* 2341947 */ // Label 32483: @2341947
     /* 2341947 */ GIM_Try, /*On fail goto*//*Label 32484*/ GIMT_Encode4(2341984), // Rule ID 1553 //
     /* 2341952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2341955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2341958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2341962 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2341969 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2341969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2341972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2341979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2341982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2341983 */   // GIR_Coverage, 1553,
     /* 2341983 */   GIR_EraseRootFromParent_Done,
     /* 2341984 */ // Label 32484: @2341984
     /* 2341984 */ GIM_Try, /*On fail goto*//*Label 32485*/ GIMT_Encode4(2342015), // Rule ID 1474 //
     /* 2341989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2341992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2341995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2341999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342003 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2342006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342008 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342013 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342014 */   // GIR_Coverage, 1474,
     /* 2342014 */   GIR_EraseRootFromParent_Done,
     /* 2342015 */ // Label 32485: @2342015
     /* 2342015 */ GIM_Try, /*On fail goto*//*Label 32486*/ GIMT_Encode4(2342046), // Rule ID 1475 //
     /* 2342020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2342023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342034 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2342037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342039 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342045 */   // GIR_Coverage, 1475,
     /* 2342045 */   GIR_EraseRootFromParent_Done,
     /* 2342046 */ // Label 32486: @2342046
     /* 2342046 */ GIM_Try, /*On fail goto*//*Label 32487*/ GIMT_Encode4(2342077), // Rule ID 1500 //
     /* 2342051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2342054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342065 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2342065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2342068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342070 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342076 */   // GIR_Coverage, 1500,
     /* 2342076 */   GIR_EraseRootFromParent_Done,
     /* 2342077 */ // Label 32487: @2342077
     /* 2342077 */ GIM_Try, /*On fail goto*//*Label 32488*/ GIMT_Encode4(2342108), // Rule ID 1501 //
     /* 2342082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2342085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342096 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2342096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2342099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342101 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342107 */   // GIR_Coverage, 1501,
     /* 2342107 */   GIR_EraseRootFromParent_Done,
     /* 2342108 */ // Label 32488: @2342108
     /* 2342108 */ GIM_Try, /*On fail goto*//*Label 32489*/ GIMT_Encode4(2342139), // Rule ID 1529 //
     /* 2342113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2342116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342127 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU),
     /* 2342130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342132 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342137 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342138 */   // GIR_Coverage, 1529,
     /* 2342138 */   GIR_EraseRootFromParent_Done,
     /* 2342139 */ // Label 32489: @2342139
     /* 2342139 */ GIM_Try, /*On fail goto*//*Label 32490*/ GIMT_Encode4(2342170), // Rule ID 1557 //
     /* 2342144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2342147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342158 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU_INX),
     /* 2342161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342163 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342169 */   // GIR_Coverage, 1557,
     /* 2342169 */   GIR_EraseRootFromParent_Done,
     /* 2342170 */ // Label 32490: @2342170
     /* 2342170 */ GIM_Reject,
     /* 2342171 */ // Label 32458: @2342171
     /* 2342171 */ GIM_Try, /*On fail goto*//*Label 32491*/ GIMT_Encode4(2342208), // Rule ID 1905 //
     /* 2342176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2342179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2342193 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2342193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2342196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342198 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342207 */   // GIR_Coverage, 1905,
     /* 2342207 */   GIR_EraseRootFromParent_Done,
     /* 2342208 */ // Label 32491: @2342208
     /* 2342208 */ GIM_Try, /*On fail goto*//*Label 32492*/ GIMT_Encode4(2342245), // Rule ID 1933 //
     /* 2342213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2342216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342223 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2342230 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2342230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_INX),
     /* 2342233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2342240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342243 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342244 */   // GIR_Coverage, 1933,
     /* 2342244 */   GIR_EraseRootFromParent_Done,
     /* 2342245 */ // Label 32492: @2342245
     /* 2342245 */ GIM_Try, /*On fail goto*//*Label 32493*/ GIMT_Encode4(2342276), // Rule ID 1868 //
     /* 2342250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2342253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342264 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2342264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2342267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342269 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342274 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342275 */   // GIR_Coverage, 1868,
     /* 2342275 */   GIR_EraseRootFromParent_Done,
     /* 2342276 */ // Label 32493: @2342276
     /* 2342276 */ GIM_Try, /*On fail goto*//*Label 32494*/ GIMT_Encode4(2342307), // Rule ID 1869 //
     /* 2342281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2342284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342295 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2342295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2342298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342300 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342305 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342306 */   // GIR_Coverage, 1869,
     /* 2342306 */   GIR_EraseRootFromParent_Done,
     /* 2342307 */ // Label 32494: @2342307
     /* 2342307 */ GIM_Try, /*On fail goto*//*Label 32495*/ GIMT_Encode4(2342338), // Rule ID 1894 //
     /* 2342312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2342315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2342322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342326 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2342326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2342329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342331 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342333 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342336 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342337 */   // GIR_Coverage, 1894,
     /* 2342337 */   GIR_EraseRootFromParent_Done,
     /* 2342338 */ // Label 32495: @2342338
     /* 2342338 */ GIM_Try, /*On fail goto*//*Label 32496*/ GIMT_Encode4(2342369), // Rule ID 1895 //
     /* 2342343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2342346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2342353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342357 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2342357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2342360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342362 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342364 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2342367 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342368 */   // GIR_Coverage, 1895,
     /* 2342368 */   GIR_EraseRootFromParent_Done,
     /* 2342369 */ // Label 32496: @2342369
     /* 2342369 */ GIM_Try, /*On fail goto*//*Label 32497*/ GIMT_Encode4(2342400), // Rule ID 1923 //
     /* 2342374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2342377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342388 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU),
     /* 2342391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342393 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342399 */   // GIR_Coverage, 1923,
     /* 2342399 */   GIR_EraseRootFromParent_Done,
     /* 2342400 */ // Label 32497: @2342400
     /* 2342400 */ GIM_Try, /*On fail goto*//*Label 32498*/ GIMT_Encode4(2342431), // Rule ID 1951 //
     /* 2342405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2342408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342419 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2342419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU_INX),
     /* 2342422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342424 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342429 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342430 */   // GIR_Coverage, 1951,
     /* 2342430 */   GIR_EraseRootFromParent_Done,
     /* 2342431 */ // Label 32498: @2342431
     /* 2342431 */ GIM_Reject,
     /* 2342432 */ // Label 32459: @2342432
     /* 2342432 */ GIM_Try, /*On fail goto*//*Label 32499*/ GIMT_Encode4(2342489), // Rule ID 58462 //
     /* 2342437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2342443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342451 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342451 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342454 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342458 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2342468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342473 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342488 */   // GIR_Coverage, 58462,
     /* 2342488 */   GIR_EraseRootFromParent_Done,
     /* 2342489 */ // Label 32499: @2342489
     /* 2342489 */ GIM_Try, /*On fail goto*//*Label 32500*/ GIMT_Encode4(2342546), // Rule ID 58463 //
     /* 2342494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2342500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342508 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342508 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342511 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342515 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2342525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342530 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342545 */   // GIR_Coverage, 58463,
     /* 2342545 */   GIR_EraseRootFromParent_Done,
     /* 2342546 */ // Label 32500: @2342546
     /* 2342546 */ GIM_Try, /*On fail goto*//*Label 32501*/ GIMT_Encode4(2342600), // Rule ID 58646 //
     /* 2342551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2342557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342565 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2342582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342587 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342599 */   // GIR_Coverage, 58646,
     /* 2342599 */   GIR_EraseRootFromParent_Done,
     /* 2342600 */ // Label 32501: @2342600
     /* 2342600 */ GIM_Try, /*On fail goto*//*Label 32502*/ GIMT_Encode4(2342654), // Rule ID 58647 //
     /* 2342605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2342611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342619 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2342636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342641 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342652 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342653 */   // GIR_Coverage, 58647,
     /* 2342653 */   GIR_EraseRootFromParent_Done,
     /* 2342654 */ // Label 32502: @2342654
     /* 2342654 */ GIM_Try, /*On fail goto*//*Label 32503*/ GIMT_Encode4(2342711), // Rule ID 58854 //
     /* 2342659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2342662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2342665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342673 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342685 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2342690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342695 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342710 */   // GIR_Coverage, 58854,
     /* 2342710 */   GIR_EraseRootFromParent_Done,
     /* 2342711 */ // Label 32503: @2342711
     /* 2342711 */ GIM_Try, /*On fail goto*//*Label 32504*/ GIMT_Encode4(2342768), // Rule ID 58855 //
     /* 2342716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2342719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2342722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342730 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2342747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342752 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342767 */   // GIR_Coverage, 58855,
     /* 2342767 */   GIR_EraseRootFromParent_Done,
     /* 2342768 */ // Label 32504: @2342768
     /* 2342768 */ GIM_Reject,
     /* 2342769 */ // Label 32460: @2342769
     /* 2342769 */ GIM_Try, /*On fail goto*//*Label 32505*/ GIMT_Encode4(2342826), // Rule ID 58470 //
     /* 2342774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2342777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2342780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342788 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2342791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2342805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342810 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342825 */   // GIR_Coverage, 58470,
     /* 2342825 */   GIR_EraseRootFromParent_Done,
     /* 2342826 */ // Label 32505: @2342826
     /* 2342826 */ GIM_Try, /*On fail goto*//*Label 32506*/ GIMT_Encode4(2342883), // Rule ID 58471 //
     /* 2342831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2342834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2342837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342845 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342845 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2342848 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342852 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2342862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342867 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2342872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342881 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342882 */   // GIR_Coverage, 58471,
     /* 2342882 */   GIR_EraseRootFromParent_Done,
     /* 2342883 */ // Label 32506: @2342883
     /* 2342883 */ GIM_Try, /*On fail goto*//*Label 32507*/ GIMT_Encode4(2342937), // Rule ID 58670 //
     /* 2342888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2342891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2342894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342902 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2342905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2342919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342924 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342936 */   // GIR_Coverage, 58670,
     /* 2342936 */   GIR_EraseRootFromParent_Done,
     /* 2342937 */ // Label 32507: @2342937
     /* 2342937 */ GIM_Try, /*On fail goto*//*Label 32508*/ GIMT_Encode4(2342991), // Rule ID 58671 //
     /* 2342942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2342945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2342948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342956 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2342959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2342973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342978 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2342990 */   // GIR_Coverage, 58671,
     /* 2342990 */   GIR_EraseRootFromParent_Done,
     /* 2342991 */ // Label 32508: @2342991
     /* 2342991 */ GIM_Try, /*On fail goto*//*Label 32509*/ GIMT_Encode4(2343048), // Rule ID 58874 //
     /* 2342996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2342999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343010 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2343027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343032 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343047 */   // GIR_Coverage, 58874,
     /* 2343047 */   GIR_EraseRootFromParent_Done,
     /* 2343048 */ // Label 32509: @2343048
     /* 2343048 */ GIM_Try, /*On fail goto*//*Label 32510*/ GIMT_Encode4(2343105), // Rule ID 58875 //
     /* 2343053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2343056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343067 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343067 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2343070 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343074 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2343084 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343086 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343089 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343104 */   // GIR_Coverage, 58875,
     /* 2343104 */   GIR_EraseRootFromParent_Done,
     /* 2343105 */ // Label 32510: @2343105
     /* 2343105 */ GIM_Reject,
     /* 2343106 */ // Label 32461: @2343106
     /* 2343106 */ GIM_Try, /*On fail goto*//*Label 32511*/ GIMT_Encode4(2343163), // Rule ID 58482 //
     /* 2343111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2343114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343125 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2343142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343147 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343161 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343162 */   // GIR_Coverage, 58482,
     /* 2343162 */   GIR_EraseRootFromParent_Done,
     /* 2343163 */ // Label 32511: @2343163
     /* 2343163 */ GIM_Try, /*On fail goto*//*Label 32512*/ GIMT_Encode4(2343220), // Rule ID 58483 //
     /* 2343168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2343171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2343174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343182 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2343199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343204 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343218 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343219 */   // GIR_Coverage, 58483,
     /* 2343219 */   GIR_EraseRootFromParent_Done,
     /* 2343220 */ // Label 32512: @2343220
     /* 2343220 */ GIM_Try, /*On fail goto*//*Label 32513*/ GIMT_Encode4(2343274), // Rule ID 58690 //
     /* 2343225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2343228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343239 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2343256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343261 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343273 */   // GIR_Coverage, 58690,
     /* 2343273 */   GIR_EraseRootFromParent_Done,
     /* 2343274 */ // Label 32513: @2343274
     /* 2343274 */ GIM_Try, /*On fail goto*//*Label 32514*/ GIMT_Encode4(2343328), // Rule ID 58691 //
     /* 2343279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2343282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2343285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343293 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2343296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2343310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343315 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343327 */   // GIR_Coverage, 58691,
     /* 2343327 */   GIR_EraseRootFromParent_Done,
     /* 2343328 */ // Label 32514: @2343328
     /* 2343328 */ GIM_Reject,
     /* 2343329 */ // Label 32462: @2343329
     /* 2343329 */ GIM_Try, /*On fail goto*//*Label 32515*/ GIMT_Encode4(2343386), // Rule ID 58466 //
     /* 2343334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2343340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343348 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2343365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343367 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343370 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343385 */   // GIR_Coverage, 58466,
     /* 2343385 */   GIR_EraseRootFromParent_Done,
     /* 2343386 */ // Label 32515: @2343386
     /* 2343386 */ GIM_Try, /*On fail goto*//*Label 32516*/ GIMT_Encode4(2343443), // Rule ID 58467 //
     /* 2343391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2343397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343405 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2343422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343427 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343441 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343442 */   // GIR_Coverage, 58467,
     /* 2343442 */   GIR_EraseRootFromParent_Done,
     /* 2343443 */ // Label 32516: @2343443
     /* 2343443 */ GIM_Try, /*On fail goto*//*Label 32517*/ GIMT_Encode4(2343497), // Rule ID 58650 //
     /* 2343448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2343454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343462 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2343479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343484 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343495 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343496 */   // GIR_Coverage, 58650,
     /* 2343496 */   GIR_EraseRootFromParent_Done,
     /* 2343497 */ // Label 32517: @2343497
     /* 2343497 */ GIM_Try, /*On fail goto*//*Label 32518*/ GIMT_Encode4(2343551), // Rule ID 58651 //
     /* 2343502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2343508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343516 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343516 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343519 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343523 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2343533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343538 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343549 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343550 */   // GIR_Coverage, 58651,
     /* 2343550 */   GIR_EraseRootFromParent_Done,
     /* 2343551 */ // Label 32518: @2343551
     /* 2343551 */ GIM_Try, /*On fail goto*//*Label 32519*/ GIMT_Encode4(2343608), // Rule ID 58858 //
     /* 2343556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2343559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2343562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343570 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2343587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343592 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343607 */   // GIR_Coverage, 58858,
     /* 2343607 */   GIR_EraseRootFromParent_Done,
     /* 2343608 */ // Label 32519: @2343608
     /* 2343608 */ GIM_Try, /*On fail goto*//*Label 32520*/ GIMT_Encode4(2343665), // Rule ID 58859 //
     /* 2343613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2343616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2343619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343627 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343627 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2343630 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343634 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2343644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343649 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343664 */   // GIR_Coverage, 58859,
     /* 2343664 */   GIR_EraseRootFromParent_Done,
     /* 2343665 */ // Label 32520: @2343665
     /* 2343665 */ GIM_Reject,
     /* 2343666 */ // Label 32463: @2343666
     /* 2343666 */ GIM_Try, /*On fail goto*//*Label 32521*/ GIMT_Encode4(2343723), // Rule ID 58478 //
     /* 2343671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2343677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343685 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2343688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2343702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343704 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343707 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343721 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343722 */   // GIR_Coverage, 58478,
     /* 2343722 */   GIR_EraseRootFromParent_Done,
     /* 2343723 */ // Label 32521: @2343723
     /* 2343723 */ GIM_Try, /*On fail goto*//*Label 32522*/ GIMT_Encode4(2343780), // Rule ID 58479 //
     /* 2343728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2343734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343742 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2343745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2343759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343764 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343778 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343779 */   // GIR_Coverage, 58479,
     /* 2343779 */   GIR_EraseRootFromParent_Done,
     /* 2343780 */ // Label 32522: @2343780
     /* 2343780 */ GIM_Try, /*On fail goto*//*Label 32523*/ GIMT_Encode4(2343834), // Rule ID 58674 //
     /* 2343785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2343788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2343791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343799 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2343802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2343816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343821 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343833 */   // GIR_Coverage, 58674,
     /* 2343833 */   GIR_EraseRootFromParent_Done,
     /* 2343834 */ // Label 32523: @2343834
     /* 2343834 */ GIM_Try, /*On fail goto*//*Label 32524*/ GIMT_Encode4(2343888), // Rule ID 58675 //
     /* 2343839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2343842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2343845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343853 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2343856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2343870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343887 */   // GIR_Coverage, 58675,
     /* 2343887 */   GIR_EraseRootFromParent_Done,
     /* 2343888 */ // Label 32524: @2343888
     /* 2343888 */ GIM_Try, /*On fail goto*//*Label 32525*/ GIMT_Encode4(2343945), // Rule ID 58878 //
     /* 2343893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2343896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2343899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343907 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2343910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2343924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343929 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343943 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343944 */   // GIR_Coverage, 58878,
     /* 2343944 */   GIR_EraseRootFromParent_Done,
     /* 2343945 */ // Label 32525: @2343945
     /* 2343945 */ GIM_Try, /*On fail goto*//*Label 32526*/ GIMT_Encode4(2344002), // Rule ID 58879 //
     /* 2343950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2343953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2343956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2343960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343964 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2343967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2343981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343986 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2343991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344000 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344001 */   // GIR_Coverage, 58879,
     /* 2344001 */   GIR_EraseRootFromParent_Done,
     /* 2344002 */ // Label 32526: @2344002
     /* 2344002 */ GIM_Reject,
     /* 2344003 */ // Label 32464: @2344003
     /* 2344003 */ GIM_Try, /*On fail goto*//*Label 32527*/ GIMT_Encode4(2344060), // Rule ID 58510 //
     /* 2344008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2344011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344022 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2344039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344044 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344059 */   // GIR_Coverage, 58510,
     /* 2344059 */   GIR_EraseRootFromParent_Done,
     /* 2344060 */ // Label 32527: @2344060
     /* 2344060 */ GIM_Try, /*On fail goto*//*Label 32528*/ GIMT_Encode4(2344117), // Rule ID 58511 //
     /* 2344065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2344068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2344071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344075 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344079 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344079 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344082 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344086 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2344096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344098 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344101 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344116 */   // GIR_Coverage, 58511,
     /* 2344116 */   GIR_EraseRootFromParent_Done,
     /* 2344117 */ // Label 32528: @2344117
     /* 2344117 */ GIM_Try, /*On fail goto*//*Label 32529*/ GIMT_Encode4(2344171), // Rule ID 58694 //
     /* 2344122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2344125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344136 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2344153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344158 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344170 */   // GIR_Coverage, 58694,
     /* 2344170 */   GIR_EraseRootFromParent_Done,
     /* 2344171 */ // Label 32529: @2344171
     /* 2344171 */ GIM_Try, /*On fail goto*//*Label 32530*/ GIMT_Encode4(2344225), // Rule ID 58695 //
     /* 2344176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2344179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344190 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2344193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2344207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344212 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344224 */   // GIR_Coverage, 58695,
     /* 2344224 */   GIR_EraseRootFromParent_Done,
     /* 2344225 */ // Label 32530: @2344225
     /* 2344225 */ GIM_Reject,
     /* 2344226 */ // Label 32465: @2344226
     /* 2344226 */ GIM_Try, /*On fail goto*//*Label 32531*/ GIMT_Encode4(2344283), // Rule ID 58474 //
     /* 2344231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2344237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344245 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344245 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344248 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344252 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2344262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344267 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344282 */   // GIR_Coverage, 58474,
     /* 2344282 */   GIR_EraseRootFromParent_Done,
     /* 2344283 */ // Label 32531: @2344283
     /* 2344283 */ GIM_Try, /*On fail goto*//*Label 32532*/ GIMT_Encode4(2344340), // Rule ID 58475 //
     /* 2344288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2344294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344302 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2344319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344324 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344338 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344339 */   // GIR_Coverage, 58475,
     /* 2344339 */   GIR_EraseRootFromParent_Done,
     /* 2344340 */ // Label 32532: @2344340
     /* 2344340 */ GIM_Try, /*On fail goto*//*Label 32533*/ GIMT_Encode4(2344394), // Rule ID 58654 //
     /* 2344345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2344351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344359 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2344376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344381 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344392 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344393 */   // GIR_Coverage, 58654,
     /* 2344393 */   GIR_EraseRootFromParent_Done,
     /* 2344394 */ // Label 32533: @2344394
     /* 2344394 */ GIM_Try, /*On fail goto*//*Label 32534*/ GIMT_Encode4(2344448), // Rule ID 58655 //
     /* 2344399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2344405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344413 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2344430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344435 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344447 */   // GIR_Coverage, 58655,
     /* 2344447 */   GIR_EraseRootFromParent_Done,
     /* 2344448 */ // Label 32534: @2344448
     /* 2344448 */ GIM_Try, /*On fail goto*//*Label 32535*/ GIMT_Encode4(2344505), // Rule ID 58862 //
     /* 2344453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2344456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2344459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344467 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2344484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344489 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344503 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344504 */   // GIR_Coverage, 58862,
     /* 2344504 */   GIR_EraseRootFromParent_Done,
     /* 2344505 */ // Label 32535: @2344505
     /* 2344505 */ GIM_Try, /*On fail goto*//*Label 32536*/ GIMT_Encode4(2344562), // Rule ID 58863 //
     /* 2344510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2344513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2344516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344524 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2344527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2344541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344546 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344560 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344561 */   // GIR_Coverage, 58863,
     /* 2344561 */   GIR_EraseRootFromParent_Done,
     /* 2344562 */ // Label 32536: @2344562
     /* 2344562 */ GIM_Reject,
     /* 2344563 */ // Label 32466: @2344563
     /* 2344563 */ GIM_Try, /*On fail goto*//*Label 32537*/ GIMT_Encode4(2344620), // Rule ID 58498 //
     /* 2344568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2344571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2344574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344582 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2344585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2344599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344604 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344619 */   // GIR_Coverage, 58498,
     /* 2344619 */   GIR_EraseRootFromParent_Done,
     /* 2344620 */ // Label 32537: @2344620
     /* 2344620 */ GIM_Try, /*On fail goto*//*Label 32538*/ GIMT_Encode4(2344677), // Rule ID 58499 //
     /* 2344625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2344628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2344631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344639 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344639 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2344642 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344646 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2344656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344658 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344661 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344676 */   // GIR_Coverage, 58499,
     /* 2344676 */   GIR_EraseRootFromParent_Done,
     /* 2344677 */ // Label 32538: @2344677
     /* 2344677 */ GIM_Try, /*On fail goto*//*Label 32539*/ GIMT_Encode4(2344731), // Rule ID 58678 //
     /* 2344682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2344685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2344688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344696 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2344699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2344713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344718 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344729 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344730 */   // GIR_Coverage, 58678,
     /* 2344730 */   GIR_EraseRootFromParent_Done,
     /* 2344731 */ // Label 32539: @2344731
     /* 2344731 */ GIM_Try, /*On fail goto*//*Label 32540*/ GIMT_Encode4(2344785), // Rule ID 58679 //
     /* 2344736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2344739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2344742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344750 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2344753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2344767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344772 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344783 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344784 */   // GIR_Coverage, 58679,
     /* 2344784 */   GIR_EraseRootFromParent_Done,
     /* 2344785 */ // Label 32540: @2344785
     /* 2344785 */ GIM_Try, /*On fail goto*//*Label 32541*/ GIMT_Encode4(2344842), // Rule ID 58882 //
     /* 2344790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2344793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2344796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2344804 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2344807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2344821 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344823 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344826 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344828 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344840 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344841 */   // GIR_Coverage, 58882,
     /* 2344841 */   GIR_EraseRootFromParent_Done,
     /* 2344842 */ // Label 32541: @2344842
     /* 2344842 */ GIM_Try, /*On fail goto*//*Label 32542*/ GIMT_Encode4(2344899), // Rule ID 58883 //
     /* 2344847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2344850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2344853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2344857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2344861 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344861 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2344864 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344868 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2344878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344883 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344897 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344898 */   // GIR_Coverage, 58883,
     /* 2344898 */   GIR_EraseRootFromParent_Done,
     /* 2344899 */ // Label 32542: @2344899
     /* 2344899 */ GIM_Reject,
     /* 2344900 */ // Label 32467: @2344900
     /* 2344900 */ GIM_Try, /*On fail goto*//*Label 32543*/ GIMT_Encode4(2344957), // Rule ID 58514 //
     /* 2344905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2344908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2344911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2344915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2344919 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2344922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2344936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344941 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2344946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344956 */   // GIR_Coverage, 58514,
     /* 2344956 */   GIR_EraseRootFromParent_Done,
     /* 2344957 */ // Label 32543: @2344957
     /* 2344957 */ GIM_Try, /*On fail goto*//*Label 32544*/ GIMT_Encode4(2345014), // Rule ID 58515 //
     /* 2344962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2344965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2344968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2344972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2344976 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2344979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2344993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344998 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345013 */   // GIR_Coverage, 58515,
     /* 2345013 */   GIR_EraseRootFromParent_Done,
     /* 2345014 */ // Label 32544: @2345014
     /* 2345014 */ GIM_Try, /*On fail goto*//*Label 32545*/ GIMT_Encode4(2345068), // Rule ID 58698 //
     /* 2345019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2345022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345033 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2345050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345055 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345067 */   // GIR_Coverage, 58698,
     /* 2345067 */   GIR_EraseRootFromParent_Done,
     /* 2345068 */ // Label 32545: @2345068
     /* 2345068 */ GIM_Try, /*On fail goto*//*Label 32546*/ GIMT_Encode4(2345122), // Rule ID 58699 //
     /* 2345073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2345076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345087 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2345104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345109 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345120 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345121 */   // GIR_Coverage, 58699,
     /* 2345121 */   GIR_EraseRootFromParent_Done,
     /* 2345122 */ // Label 32546: @2345122
     /* 2345122 */ GIM_Reject,
     /* 2345123 */ // Label 32468: @2345123
     /* 2345123 */ GIM_Try, /*On fail goto*//*Label 32547*/ GIMT_Encode4(2345180), // Rule ID 58486 //
     /* 2345128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2345134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345142 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345142 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345145 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345149 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2345159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345161 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345164 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345179 */   // GIR_Coverage, 58486,
     /* 2345179 */   GIR_EraseRootFromParent_Done,
     /* 2345180 */ // Label 32547: @2345180
     /* 2345180 */ GIM_Try, /*On fail goto*//*Label 32548*/ GIMT_Encode4(2345237), // Rule ID 58487 //
     /* 2345185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2345191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345199 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2345216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345221 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345236 */   // GIR_Coverage, 58487,
     /* 2345236 */   GIR_EraseRootFromParent_Done,
     /* 2345237 */ // Label 32548: @2345237
     /* 2345237 */ GIM_Try, /*On fail goto*//*Label 32549*/ GIMT_Encode4(2345291), // Rule ID 58658 //
     /* 2345242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2345248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345256 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345256 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345259 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345263 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2345273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345278 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345289 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345290 */   // GIR_Coverage, 58658,
     /* 2345290 */   GIR_EraseRootFromParent_Done,
     /* 2345291 */ // Label 32549: @2345291
     /* 2345291 */ GIM_Try, /*On fail goto*//*Label 32550*/ GIMT_Encode4(2345345), // Rule ID 58659 //
     /* 2345296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2345302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345310 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2345327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345332 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345344 */   // GIR_Coverage, 58659,
     /* 2345344 */   GIR_EraseRootFromParent_Done,
     /* 2345345 */ // Label 32550: @2345345
     /* 2345345 */ GIM_Try, /*On fail goto*//*Label 32551*/ GIMT_Encode4(2345402), // Rule ID 58866 //
     /* 2345350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2345353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345364 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2345381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345386 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345401 */   // GIR_Coverage, 58866,
     /* 2345401 */   GIR_EraseRootFromParent_Done,
     /* 2345402 */ // Label 32551: @2345402
     /* 2345402 */ GIM_Try, /*On fail goto*//*Label 32552*/ GIMT_Encode4(2345459), // Rule ID 58867 //
     /* 2345407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2345410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345421 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345421 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345424 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345428 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2345438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345443 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345457 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345458 */   // GIR_Coverage, 58867,
     /* 2345458 */   GIR_EraseRootFromParent_Done,
     /* 2345459 */ // Label 32552: @2345459
     /* 2345459 */ GIM_Reject,
     /* 2345460 */ // Label 32469: @2345460
     /* 2345460 */ GIM_Try, /*On fail goto*//*Label 32553*/ GIMT_Encode4(2345517), // Rule ID 58502 //
     /* 2345465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345479 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2345496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345501 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345516 */   // GIR_Coverage, 58502,
     /* 2345516 */   GIR_EraseRootFromParent_Done,
     /* 2345517 */ // Label 32553: @2345517
     /* 2345517 */ GIM_Try, /*On fail goto*//*Label 32554*/ GIMT_Encode4(2345574), // Rule ID 58503 //
     /* 2345522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345536 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345536 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345539 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345543 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2345553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345555 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345558 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345572 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345573 */   // GIR_Coverage, 58503,
     /* 2345573 */   GIR_EraseRootFromParent_Done,
     /* 2345574 */ // Label 32554: @2345574
     /* 2345574 */ GIM_Try, /*On fail goto*//*Label 32555*/ GIMT_Encode4(2345628), // Rule ID 58682 //
     /* 2345579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2345582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2345585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345593 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345593 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345596 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345600 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345605 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2345610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345612 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345615 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345627 */   // GIR_Coverage, 58682,
     /* 2345627 */   GIR_EraseRootFromParent_Done,
     /* 2345628 */ // Label 32555: @2345628
     /* 2345628 */ GIM_Try, /*On fail goto*//*Label 32556*/ GIMT_Encode4(2345682), // Rule ID 58683 //
     /* 2345633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2345636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2345639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345647 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345647 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345650 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345654 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2345664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345669 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345681 */   // GIR_Coverage, 58683,
     /* 2345681 */   GIR_EraseRootFromParent_Done,
     /* 2345682 */ // Label 32556: @2345682
     /* 2345682 */ GIM_Try, /*On fail goto*//*Label 32557*/ GIMT_Encode4(2345739), // Rule ID 58886 //
     /* 2345687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2345690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2345693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345701 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2345718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345723 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345737 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345738 */   // GIR_Coverage, 58886,
     /* 2345738 */   GIR_EraseRootFromParent_Done,
     /* 2345739 */ // Label 32557: @2345739
     /* 2345739 */ GIM_Try, /*On fail goto*//*Label 32558*/ GIMT_Encode4(2345796), // Rule ID 58887 //
     /* 2345744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2345747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2345750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345758 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2345775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345780 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345795 */   // GIR_Coverage, 58887,
     /* 2345795 */   GIR_EraseRootFromParent_Done,
     /* 2345796 */ // Label 32558: @2345796
     /* 2345796 */ GIM_Reject,
     /* 2345797 */ // Label 32470: @2345797
     /* 2345797 */ GIM_Try, /*On fail goto*//*Label 32559*/ GIMT_Encode4(2345854), // Rule ID 58518 //
     /* 2345802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2345805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2345808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345816 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2345819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2345833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345835 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345838 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345852 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345853 */   // GIR_Coverage, 58518,
     /* 2345853 */   GIR_EraseRootFromParent_Done,
     /* 2345854 */ // Label 32559: @2345854
     /* 2345854 */ GIM_Try, /*On fail goto*//*Label 32560*/ GIMT_Encode4(2345911), // Rule ID 58519 //
     /* 2345859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2345862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2345865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345873 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345873 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2345876 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345880 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2345890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345892 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345895 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2345900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345909 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345910 */   // GIR_Coverage, 58519,
     /* 2345910 */   GIR_EraseRootFromParent_Done,
     /* 2345911 */ // Label 32560: @2345911
     /* 2345911 */ GIM_Try, /*On fail goto*//*Label 32561*/ GIMT_Encode4(2345965), // Rule ID 58702 //
     /* 2345916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2345919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345930 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2345933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345942 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2345947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345952 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2345964 */   // GIR_Coverage, 58702,
     /* 2345964 */   GIR_EraseRootFromParent_Done,
     /* 2345965 */ // Label 32561: @2345965
     /* 2345965 */ GIM_Try, /*On fail goto*//*Label 32562*/ GIMT_Encode4(2346019), // Rule ID 58703 //
     /* 2345970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2345973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345984 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2345987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2346001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346006 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346017 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346018 */   // GIR_Coverage, 58703,
     /* 2346018 */   GIR_EraseRootFromParent_Done,
     /* 2346019 */ // Label 32562: @2346019
     /* 2346019 */ GIM_Reject,
     /* 2346020 */ // Label 32471: @2346020
     /* 2346020 */ GIM_Try, /*On fail goto*//*Label 32563*/ GIMT_Encode4(2346077), // Rule ID 58490 //
     /* 2346025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346039 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2346056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346061 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346076 */   // GIR_Coverage, 58490,
     /* 2346076 */   GIR_EraseRootFromParent_Done,
     /* 2346077 */ // Label 32563: @2346077
     /* 2346077 */ GIM_Try, /*On fail goto*//*Label 32564*/ GIMT_Encode4(2346134), // Rule ID 58491 //
     /* 2346082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346096 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2346113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346118 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346133 */   // GIR_Coverage, 58491,
     /* 2346133 */   GIR_EraseRootFromParent_Done,
     /* 2346134 */ // Label 32564: @2346134
     /* 2346134 */ GIM_Try, /*On fail goto*//*Label 32565*/ GIMT_Encode4(2346188), // Rule ID 58662 //
     /* 2346139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2346145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346153 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2346170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346175 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346186 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346187 */   // GIR_Coverage, 58662,
     /* 2346187 */   GIR_EraseRootFromParent_Done,
     /* 2346188 */ // Label 32565: @2346188
     /* 2346188 */ GIM_Try, /*On fail goto*//*Label 32566*/ GIMT_Encode4(2346242), // Rule ID 58663 //
     /* 2346193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2346199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2346207 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346207 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346210 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346214 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2346224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346229 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346240 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346241 */   // GIR_Coverage, 58663,
     /* 2346241 */   GIR_EraseRootFromParent_Done,
     /* 2346242 */ // Label 32566: @2346242
     /* 2346242 */ GIM_Try, /*On fail goto*//*Label 32567*/ GIMT_Encode4(2346299), // Rule ID 58870 //
     /* 2346247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2346253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346261 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2346278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346283 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346297 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346298 */   // GIR_Coverage, 58870,
     /* 2346298 */   GIR_EraseRootFromParent_Done,
     /* 2346299 */ // Label 32567: @2346299
     /* 2346299 */ GIM_Try, /*On fail goto*//*Label 32568*/ GIMT_Encode4(2346356), // Rule ID 58871 //
     /* 2346304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2346310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346318 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346318 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2346321 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346325 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2346335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346340 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346354 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346355 */   // GIR_Coverage, 58871,
     /* 2346355 */   GIR_EraseRootFromParent_Done,
     /* 2346356 */ // Label 32568: @2346356
     /* 2346356 */ GIM_Reject,
     /* 2346357 */ // Label 32472: @2346357
     /* 2346357 */ GIM_Try, /*On fail goto*//*Label 32569*/ GIMT_Encode4(2346414), // Rule ID 58506 //
     /* 2346362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2346368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346376 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346376 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346379 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346383 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2346393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346395 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346398 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346412 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346413 */   // GIR_Coverage, 58506,
     /* 2346413 */   GIR_EraseRootFromParent_Done,
     /* 2346414 */ // Label 32569: @2346414
     /* 2346414 */ GIM_Try, /*On fail goto*//*Label 32570*/ GIMT_Encode4(2346471), // Rule ID 58507 //
     /* 2346419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2346425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346433 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346433 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346436 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346440 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2346450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346455 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346457 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346470 */   // GIR_Coverage, 58507,
     /* 2346470 */   GIR_EraseRootFromParent_Done,
     /* 2346471 */ // Label 32570: @2346471
     /* 2346471 */ GIM_Try, /*On fail goto*//*Label 32571*/ GIMT_Encode4(2346525), // Rule ID 58686 //
     /* 2346476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2346479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346490 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2346507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346512 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346524 */   // GIR_Coverage, 58686,
     /* 2346524 */   GIR_EraseRootFromParent_Done,
     /* 2346525 */ // Label 32571: @2346525
     /* 2346525 */ GIM_Try, /*On fail goto*//*Label 32572*/ GIMT_Encode4(2346579), // Rule ID 58687 //
     /* 2346530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2346533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2346536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346544 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2346561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346563 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346566 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346568 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346571 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346577 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346578 */   // GIR_Coverage, 58687,
     /* 2346578 */   GIR_EraseRootFromParent_Done,
     /* 2346579 */ // Label 32572: @2346579
     /* 2346579 */ GIM_Reject,
     /* 2346580 */ // Label 32473: @2346580
     /* 2346580 */ GIM_Try, /*On fail goto*//*Label 32573*/ GIMT_Encode4(2346637), // Rule ID 58494 //
     /* 2346585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2346591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346599 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2346602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2346616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346621 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346636 */   // GIR_Coverage, 58494,
     /* 2346636 */   GIR_EraseRootFromParent_Done,
     /* 2346637 */ // Label 32573: @2346637
     /* 2346637 */ GIM_Try, /*On fail goto*//*Label 32574*/ GIMT_Encode4(2346694), // Rule ID 58495 //
     /* 2346642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2346648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346656 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346656 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2346659 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346663 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2346673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346678 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2346683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346693 */   // GIR_Coverage, 58495,
     /* 2346693 */   GIR_EraseRootFromParent_Done,
     /* 2346694 */ // Label 32574: @2346694
     /* 2346694 */ GIM_Try, /*On fail goto*//*Label 32575*/ GIMT_Encode4(2346748), // Rule ID 58666 //
     /* 2346699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2346702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2346705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346713 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346713 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2346716 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346720 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346725 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2346730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346735 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346746 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346747 */   // GIR_Coverage, 58666,
     /* 2346747 */   GIR_EraseRootFromParent_Done,
     /* 2346748 */ // Label 32575: @2346748
     /* 2346748 */ GIM_Try, /*On fail goto*//*Label 32576*/ GIMT_Encode4(2346802), // Rule ID 58667 //
     /* 2346753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2346756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2346759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2346767 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346767 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2346770 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346774 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2346784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346786 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346789 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346800 */   GIR_RootConstrainSelectedInstOperands,
     /* 2346801 */   // GIR_Coverage, 58667,
     /* 2346801 */   GIR_EraseRootFromParent_Done,
     /* 2346802 */ // Label 32576: @2346802
     /* 2346802 */ GIM_Reject,
     /* 2346803 */ // Label 32474: @2346803
     /* 2346803 */ GIM_Reject,
     /* 2346804 */ // Label 71: @2346804
     /* 2346804 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32595*/ GIMT_Encode4(2348774),
     /* 2346815 */ /*GILLT_s16*//*Label 32577*/ GIMT_Encode4(2346935),
     /* 2346819 */ /*GILLT_s32*//*Label 32578*/ GIMT_Encode4(2346999),
     /* 2346823 */ /*GILLT_s64*//*Label 32579*/ GIMT_Encode4(2347063), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346835 */ /*GILLT_nxv1s16*//*Label 32580*/ GIMT_Encode4(2347154),
     /* 2346839 */ /*GILLT_nxv1s32*//*Label 32581*/ GIMT_Encode4(2347262),
     /* 2346843 */ /*GILLT_nxv1s64*//*Label 32582*/ GIMT_Encode4(2347370), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346855 */ /*GILLT_nxv2s16*//*Label 32583*/ GIMT_Encode4(2347478),
     /* 2346859 */ /*GILLT_nxv2s32*//*Label 32584*/ GIMT_Encode4(2347586),
     /* 2346863 */ /*GILLT_nxv2s64*//*Label 32585*/ GIMT_Encode4(2347694), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346875 */ /*GILLT_nxv4s16*//*Label 32586*/ GIMT_Encode4(2347802),
     /* 2346879 */ /*GILLT_nxv4s32*//*Label 32587*/ GIMT_Encode4(2347910),
     /* 2346883 */ /*GILLT_nxv4s64*//*Label 32588*/ GIMT_Encode4(2348018), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346895 */ /*GILLT_nxv8s16*//*Label 32589*/ GIMT_Encode4(2348126),
     /* 2346899 */ /*GILLT_nxv8s32*//*Label 32590*/ GIMT_Encode4(2348234),
     /* 2346903 */ /*GILLT_nxv8s64*//*Label 32591*/ GIMT_Encode4(2348342), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346915 */ /*GILLT_nxv16s16*//*Label 32592*/ GIMT_Encode4(2348450),
     /* 2346919 */ /*GILLT_nxv16s32*//*Label 32593*/ GIMT_Encode4(2348558), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346931 */ /*GILLT_nxv32s16*//*Label 32594*/ GIMT_Encode4(2348666),
     /* 2346935 */ // Label 32577: @2346935
     /* 2346935 */ GIM_Try, /*On fail goto*//*Label 32596*/ GIMT_Encode4(2346998),
     /* 2346940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2346943 */   GIM_Try, /*On fail goto*//*Label 32597*/ GIMT_Encode4(2346970), // Rule ID 1989 //
     /* 2346948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2346951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2346955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2346959 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2346959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H),
     /* 2346962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346969 */     // GIR_Coverage, 1989,
     /* 2346969 */     GIR_EraseRootFromParent_Done,
     /* 2346970 */   // Label 32597: @2346970
     /* 2346970 */   GIM_Try, /*On fail goto*//*Label 32598*/ GIMT_Encode4(2346997), // Rule ID 2022 //
     /* 2346975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2346978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2346982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2346986 */     // (fabs:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2346986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H_INX),
     /* 2346989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346996 */     // GIR_Coverage, 2022,
     /* 2346996 */     GIR_EraseRootFromParent_Done,
     /* 2346997 */   // Label 32598: @2346997
     /* 2346997 */   GIM_Reject,
     /* 2346998 */ // Label 32596: @2346998
     /* 2346998 */ GIM_Reject,
     /* 2346999 */ // Label 32578: @2346999
     /* 2346999 */ GIM_Try, /*On fail goto*//*Label 32599*/ GIMT_Encode4(2347062),
     /* 2347004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2347007 */   GIM_Try, /*On fail goto*//*Label 32600*/ GIMT_Encode4(2347034), // Rule ID 1280 //
     /* 2347012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2347015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2347019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2347023 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2347023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S),
     /* 2347026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347033 */     // GIR_Coverage, 1280,
     /* 2347033 */     GIR_EraseRootFromParent_Done,
     /* 2347034 */   // Label 32600: @2347034
     /* 2347034 */   GIM_Try, /*On fail goto*//*Label 32601*/ GIMT_Encode4(2347061), // Rule ID 1288 //
     /* 2347039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2347042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2347046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2347050 */     // (fabs:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2347050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S_INX),
     /* 2347053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347060 */     // GIR_Coverage, 1288,
     /* 2347060 */     GIR_EraseRootFromParent_Done,
     /* 2347061 */   // Label 32601: @2347061
     /* 2347061 */   GIM_Reject,
     /* 2347062 */ // Label 32599: @2347062
     /* 2347062 */ GIM_Reject,
     /* 2347063 */ // Label 32579: @2347063
     /* 2347063 */ GIM_Try, /*On fail goto*//*Label 32602*/ GIMT_Encode4(2347153),
     /* 2347068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2347071 */   GIM_Try, /*On fail goto*//*Label 32603*/ GIMT_Encode4(2347098), // Rule ID 1623 //
     /* 2347076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2347079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2347083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2347087 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2347087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D),
     /* 2347090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347097 */     // GIR_Coverage, 1623,
     /* 2347097 */     GIR_EraseRootFromParent_Done,
     /* 2347098 */   // Label 32603: @2347098
     /* 2347098 */   GIM_Try, /*On fail goto*//*Label 32604*/ GIMT_Encode4(2347125), // Rule ID 1656 //
     /* 2347103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2347106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2347114 */     // (fabs:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2347114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_INX),
     /* 2347117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347124 */     // GIR_Coverage, 1656,
     /* 2347124 */     GIR_EraseRootFromParent_Done,
     /* 2347125 */   // Label 32604: @2347125
     /* 2347125 */   GIM_Try, /*On fail goto*//*Label 32605*/ GIMT_Encode4(2347152), // Rule ID 1678 //
     /* 2347130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2347133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2347137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2347141 */     // (fabs:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2347141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_IN32X),
     /* 2347144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347151 */     // GIR_Coverage, 1678,
     /* 2347151 */     GIR_EraseRootFromParent_Done,
     /* 2347152 */   // Label 32605: @2347152
     /* 2347152 */   GIM_Reject,
     /* 2347153 */ // Label 32602: @2347153
     /* 2347153 */ GIM_Reject,
     /* 2347154 */ // Label 32580: @2347154
     /* 2347154 */ GIM_Try, /*On fail goto*//*Label 32606*/ GIMT_Encode4(2347261),
     /* 2347159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2347162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347170 */   GIM_Try, /*On fail goto*//*Label 32607*/ GIMT_Encode4(2347215), // Rule ID 56238 //
     /* 2347175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347178 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2347181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2347195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347214 */     // GIR_Coverage, 56238,
     /* 2347214 */     GIR_EraseRootFromParent_Done,
     /* 2347215 */   // Label 32607: @2347215
     /* 2347215 */   GIM_Try, /*On fail goto*//*Label 32608*/ GIMT_Encode4(2347260), // Rule ID 56239 //
     /* 2347220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347223 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2347226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2347240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347259 */     // GIR_Coverage, 56239,
     /* 2347259 */     GIR_EraseRootFromParent_Done,
     /* 2347260 */   // Label 32608: @2347260
     /* 2347260 */   GIM_Reject,
     /* 2347261 */ // Label 32606: @2347261
     /* 2347261 */ GIM_Reject,
     /* 2347262 */ // Label 32581: @2347262
     /* 2347262 */ GIM_Try, /*On fail goto*//*Label 32609*/ GIMT_Encode4(2347369),
     /* 2347267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2347270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347278 */   GIM_Try, /*On fail goto*//*Label 32610*/ GIMT_Encode4(2347323), // Rule ID 56278 //
     /* 2347283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2347286 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2347289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2347303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347322 */     // GIR_Coverage, 56278,
     /* 2347322 */     GIR_EraseRootFromParent_Done,
     /* 2347323 */   // Label 32610: @2347323
     /* 2347323 */   GIM_Try, /*On fail goto*//*Label 32611*/ GIMT_Encode4(2347368), // Rule ID 56279 //
     /* 2347328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347331 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2347334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2347348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347367 */     // GIR_Coverage, 56279,
     /* 2347367 */     GIR_EraseRootFromParent_Done,
     /* 2347368 */   // Label 32611: @2347368
     /* 2347368 */   GIM_Reject,
     /* 2347369 */ // Label 32609: @2347369
     /* 2347369 */ GIM_Reject,
     /* 2347370 */ // Label 32582: @2347370
     /* 2347370 */ GIM_Try, /*On fail goto*//*Label 32612*/ GIMT_Encode4(2347477),
     /* 2347375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2347378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347386 */   GIM_Try, /*On fail goto*//*Label 32613*/ GIMT_Encode4(2347431), // Rule ID 56338 //
     /* 2347391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2347394 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2347397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2347411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347430 */     // GIR_Coverage, 56338,
     /* 2347430 */     GIR_EraseRootFromParent_Done,
     /* 2347431 */   // Label 32613: @2347431
     /* 2347431 */   GIM_Try, /*On fail goto*//*Label 32614*/ GIMT_Encode4(2347476), // Rule ID 56339 //
     /* 2347436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2347439 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2347442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2347456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347475 */     // GIR_Coverage, 56339,
     /* 2347475 */     GIR_EraseRootFromParent_Done,
     /* 2347476 */   // Label 32614: @2347476
     /* 2347476 */   GIM_Reject,
     /* 2347477 */ // Label 32612: @2347477
     /* 2347477 */ GIM_Reject,
     /* 2347478 */ // Label 32583: @2347478
     /* 2347478 */ GIM_Try, /*On fail goto*//*Label 32615*/ GIMT_Encode4(2347585),
     /* 2347483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2347486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347494 */   GIM_Try, /*On fail goto*//*Label 32616*/ GIMT_Encode4(2347539), // Rule ID 56258 //
     /* 2347499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347502 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2347505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2347519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347538 */     // GIR_Coverage, 56258,
     /* 2347538 */     GIR_EraseRootFromParent_Done,
     /* 2347539 */   // Label 32616: @2347539
     /* 2347539 */   GIM_Try, /*On fail goto*//*Label 32617*/ GIMT_Encode4(2347584), // Rule ID 56259 //
     /* 2347544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347547 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2347550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2347564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347583 */     // GIR_Coverage, 56259,
     /* 2347583 */     GIR_EraseRootFromParent_Done,
     /* 2347584 */   // Label 32617: @2347584
     /* 2347584 */   GIM_Reject,
     /* 2347585 */ // Label 32615: @2347585
     /* 2347585 */ GIM_Reject,
     /* 2347586 */ // Label 32584: @2347586
     /* 2347586 */ GIM_Try, /*On fail goto*//*Label 32618*/ GIMT_Encode4(2347693),
     /* 2347591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2347594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347602 */   GIM_Try, /*On fail goto*//*Label 32619*/ GIMT_Encode4(2347647), // Rule ID 56318 //
     /* 2347607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2347610 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2347613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2347627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347646 */     // GIR_Coverage, 56318,
     /* 2347646 */     GIR_EraseRootFromParent_Done,
     /* 2347647 */   // Label 32619: @2347647
     /* 2347647 */   GIM_Try, /*On fail goto*//*Label 32620*/ GIMT_Encode4(2347692), // Rule ID 56319 //
     /* 2347652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347655 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2347658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2347672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347677 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347691 */     // GIR_Coverage, 56319,
     /* 2347691 */     GIR_EraseRootFromParent_Done,
     /* 2347692 */   // Label 32620: @2347692
     /* 2347692 */   GIM_Reject,
     /* 2347693 */ // Label 32618: @2347693
     /* 2347693 */ GIM_Reject,
     /* 2347694 */ // Label 32585: @2347694
     /* 2347694 */ GIM_Try, /*On fail goto*//*Label 32621*/ GIMT_Encode4(2347801),
     /* 2347699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2347702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347710 */   GIM_Try, /*On fail goto*//*Label 32622*/ GIMT_Encode4(2347755), // Rule ID 56478 //
     /* 2347715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2347718 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2347721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2347735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347754 */     // GIR_Coverage, 56478,
     /* 2347754 */     GIR_EraseRootFromParent_Done,
     /* 2347755 */   // Label 32622: @2347755
     /* 2347755 */   GIM_Try, /*On fail goto*//*Label 32623*/ GIMT_Encode4(2347800), // Rule ID 56479 //
     /* 2347760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2347763 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2347766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2347780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347799 */     // GIR_Coverage, 56479,
     /* 2347799 */     GIR_EraseRootFromParent_Done,
     /* 2347800 */   // Label 32623: @2347800
     /* 2347800 */   GIM_Reject,
     /* 2347801 */ // Label 32621: @2347801
     /* 2347801 */ GIM_Reject,
     /* 2347802 */ // Label 32586: @2347802
     /* 2347802 */ GIM_Try, /*On fail goto*//*Label 32624*/ GIMT_Encode4(2347909),
     /* 2347807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2347810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347818 */   GIM_Try, /*On fail goto*//*Label 32625*/ GIMT_Encode4(2347863), // Rule ID 56298 //
     /* 2347823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347826 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2347829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2347843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347862 */     // GIR_Coverage, 56298,
     /* 2347862 */     GIR_EraseRootFromParent_Done,
     /* 2347863 */   // Label 32625: @2347863
     /* 2347863 */   GIM_Try, /*On fail goto*//*Label 32626*/ GIMT_Encode4(2347908), // Rule ID 56299 //
     /* 2347868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347871 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2347874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2347888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347907 */     // GIR_Coverage, 56299,
     /* 2347907 */     GIR_EraseRootFromParent_Done,
     /* 2347908 */   // Label 32626: @2347908
     /* 2347908 */   GIM_Reject,
     /* 2347909 */ // Label 32624: @2347909
     /* 2347909 */ GIM_Reject,
     /* 2347910 */ // Label 32587: @2347910
     /* 2347910 */ GIM_Try, /*On fail goto*//*Label 32627*/ GIMT_Encode4(2348017),
     /* 2347915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2347918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347926 */   GIM_Try, /*On fail goto*//*Label 32628*/ GIMT_Encode4(2347971), // Rule ID 56418 //
     /* 2347931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2347934 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2347951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2347960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347970 */     // GIR_Coverage, 56418,
     /* 2347970 */     GIR_EraseRootFromParent_Done,
     /* 2347971 */   // Label 32628: @2347971
     /* 2347971 */   GIM_Try, /*On fail goto*//*Label 32629*/ GIMT_Encode4(2348016), // Rule ID 56419 //
     /* 2347976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347979 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2347996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348015 */     // GIR_Coverage, 56419,
     /* 2348015 */     GIR_EraseRootFromParent_Done,
     /* 2348016 */   // Label 32629: @2348016
     /* 2348016 */   GIM_Reject,
     /* 2348017 */ // Label 32627: @2348017
     /* 2348017 */ GIM_Reject,
     /* 2348018 */ // Label 32588: @2348018
     /* 2348018 */ GIM_Try, /*On fail goto*//*Label 32630*/ GIMT_Encode4(2348125),
     /* 2348023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2348026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348034 */   GIM_Try, /*On fail goto*//*Label 32631*/ GIMT_Encode4(2348079), // Rule ID 56498 //
     /* 2348039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2348042 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2348045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2348059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348078 */     // GIR_Coverage, 56498,
     /* 2348078 */     GIR_EraseRootFromParent_Done,
     /* 2348079 */   // Label 32631: @2348079
     /* 2348079 */   GIM_Try, /*On fail goto*//*Label 32632*/ GIMT_Encode4(2348124), // Rule ID 56499 //
     /* 2348084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2348087 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2348090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2348104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348123 */     // GIR_Coverage, 56499,
     /* 2348123 */     GIR_EraseRootFromParent_Done,
     /* 2348124 */   // Label 32632: @2348124
     /* 2348124 */   GIM_Reject,
     /* 2348125 */ // Label 32630: @2348125
     /* 2348125 */ GIM_Reject,
     /* 2348126 */ // Label 32589: @2348126
     /* 2348126 */ GIM_Try, /*On fail goto*//*Label 32633*/ GIMT_Encode4(2348233),
     /* 2348131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2348134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2348142 */   GIM_Try, /*On fail goto*//*Label 32634*/ GIMT_Encode4(2348187), // Rule ID 56358 //
     /* 2348147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348150 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2348153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2348167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348186 */     // GIR_Coverage, 56358,
     /* 2348186 */     GIR_EraseRootFromParent_Done,
     /* 2348187 */   // Label 32634: @2348187
     /* 2348187 */   GIM_Try, /*On fail goto*//*Label 32635*/ GIMT_Encode4(2348232), // Rule ID 56359 //
     /* 2348192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348195 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2348198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2348212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348231 */     // GIR_Coverage, 56359,
     /* 2348231 */     GIR_EraseRootFromParent_Done,
     /* 2348232 */   // Label 32635: @2348232
     /* 2348232 */   GIM_Reject,
     /* 2348233 */ // Label 32633: @2348233
     /* 2348233 */ GIM_Reject,
     /* 2348234 */ // Label 32590: @2348234
     /* 2348234 */ GIM_Try, /*On fail goto*//*Label 32636*/ GIMT_Encode4(2348341),
     /* 2348239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2348242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348250 */   GIM_Try, /*On fail goto*//*Label 32637*/ GIMT_Encode4(2348295), // Rule ID 56438 //
     /* 2348255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2348258 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2348261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2348275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348294 */     // GIR_Coverage, 56438,
     /* 2348294 */     GIR_EraseRootFromParent_Done,
     /* 2348295 */   // Label 32637: @2348295
     /* 2348295 */   GIM_Try, /*On fail goto*//*Label 32638*/ GIMT_Encode4(2348340), // Rule ID 56439 //
     /* 2348300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2348303 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2348306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2348320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348339 */     // GIR_Coverage, 56439,
     /* 2348339 */     GIR_EraseRootFromParent_Done,
     /* 2348340 */   // Label 32638: @2348340
     /* 2348340 */   GIM_Reject,
     /* 2348341 */ // Label 32636: @2348341
     /* 2348341 */ GIM_Reject,
     /* 2348342 */ // Label 32591: @2348342
     /* 2348342 */ GIM_Try, /*On fail goto*//*Label 32639*/ GIMT_Encode4(2348449),
     /* 2348347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2348350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348358 */   GIM_Try, /*On fail goto*//*Label 32640*/ GIMT_Encode4(2348403), // Rule ID 56518 //
     /* 2348363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2348366 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2348369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2348383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348402 */     // GIR_Coverage, 56518,
     /* 2348402 */     GIR_EraseRootFromParent_Done,
     /* 2348403 */   // Label 32640: @2348403
     /* 2348403 */   GIM_Try, /*On fail goto*//*Label 32641*/ GIMT_Encode4(2348448), // Rule ID 56519 //
     /* 2348408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2348411 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2348414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2348428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348447 */     // GIR_Coverage, 56519,
     /* 2348447 */     GIR_EraseRootFromParent_Done,
     /* 2348448 */   // Label 32641: @2348448
     /* 2348448 */   GIM_Reject,
     /* 2348449 */ // Label 32639: @2348449
     /* 2348449 */ GIM_Reject,
     /* 2348450 */ // Label 32592: @2348450
     /* 2348450 */ GIM_Try, /*On fail goto*//*Label 32642*/ GIMT_Encode4(2348557),
     /* 2348455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2348458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348466 */   GIM_Try, /*On fail goto*//*Label 32643*/ GIMT_Encode4(2348511), // Rule ID 56378 //
     /* 2348471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348474 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2348491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348510 */     // GIR_Coverage, 56378,
     /* 2348510 */     GIR_EraseRootFromParent_Done,
     /* 2348511 */   // Label 32643: @2348511
     /* 2348511 */   GIM_Try, /*On fail goto*//*Label 32644*/ GIMT_Encode4(2348556), // Rule ID 56379 //
     /* 2348516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348519 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2348536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348555 */     // GIR_Coverage, 56379,
     /* 2348555 */     GIR_EraseRootFromParent_Done,
     /* 2348556 */   // Label 32644: @2348556
     /* 2348556 */   GIM_Reject,
     /* 2348557 */ // Label 32642: @2348557
     /* 2348557 */ GIM_Reject,
     /* 2348558 */ // Label 32593: @2348558
     /* 2348558 */ GIM_Try, /*On fail goto*//*Label 32645*/ GIMT_Encode4(2348665),
     /* 2348563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2348566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348574 */   GIM_Try, /*On fail goto*//*Label 32646*/ GIMT_Encode4(2348619), // Rule ID 56458 //
     /* 2348579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2348582 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2348585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2348599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348618 */     // GIR_Coverage, 56458,
     /* 2348618 */     GIR_EraseRootFromParent_Done,
     /* 2348619 */   // Label 32646: @2348619
     /* 2348619 */   GIM_Try, /*On fail goto*//*Label 32647*/ GIMT_Encode4(2348664), // Rule ID 56459 //
     /* 2348624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2348627 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2348630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2348644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348663 */     // GIR_Coverage, 56459,
     /* 2348663 */     GIR_EraseRootFromParent_Done,
     /* 2348664 */   // Label 32647: @2348664
     /* 2348664 */   GIM_Reject,
     /* 2348665 */ // Label 32645: @2348665
     /* 2348665 */ GIM_Reject,
     /* 2348666 */ // Label 32594: @2348666
     /* 2348666 */ GIM_Try, /*On fail goto*//*Label 32648*/ GIMT_Encode4(2348773),
     /* 2348671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2348674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348682 */   GIM_Try, /*On fail goto*//*Label 32649*/ GIMT_Encode4(2348727), // Rule ID 56398 //
     /* 2348687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348690 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2348693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2348707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348726 */     // GIR_Coverage, 56398,
     /* 2348726 */     GIR_EraseRootFromParent_Done,
     /* 2348727 */   // Label 32649: @2348727
     /* 2348727 */   GIM_Try, /*On fail goto*//*Label 32650*/ GIMT_Encode4(2348772), // Rule ID 56399 //
     /* 2348732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348735 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2348738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2348752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2348761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348771 */     // GIR_Coverage, 56399,
     /* 2348771 */     GIR_EraseRootFromParent_Done,
     /* 2348772 */   // Label 32650: @2348772
     /* 2348772 */   GIM_Reject,
     /* 2348773 */ // Label 32648: @2348773
     /* 2348773 */ GIM_Reject,
     /* 2348774 */ // Label 32595: @2348774
     /* 2348774 */ GIM_Reject,
     /* 2348775 */ // Label 72: @2348775
     /* 2348775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32669*/ GIMT_Encode4(2354836),
     /* 2348786 */ /*GILLT_s16*//*Label 32651*/ GIMT_Encode4(2348906),
     /* 2348790 */ /*GILLT_s32*//*Label 32652*/ GIMT_Encode4(2349582),
     /* 2348794 */ /*GILLT_s64*//*Label 32653*/ GIMT_Encode4(2350258), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348806 */ /*GILLT_nxv1s16*//*Label 32654*/ GIMT_Encode4(2351071),
     /* 2348810 */ /*GILLT_nxv1s32*//*Label 32655*/ GIMT_Encode4(2351322),
     /* 2348814 */ /*GILLT_nxv1s64*//*Label 32656*/ GIMT_Encode4(2351573), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348826 */ /*GILLT_nxv2s16*//*Label 32657*/ GIMT_Encode4(2351824),
     /* 2348830 */ /*GILLT_nxv2s32*//*Label 32658*/ GIMT_Encode4(2352075),
     /* 2348834 */ /*GILLT_nxv2s64*//*Label 32659*/ GIMT_Encode4(2352326), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348846 */ /*GILLT_nxv4s16*//*Label 32660*/ GIMT_Encode4(2352577),
     /* 2348850 */ /*GILLT_nxv4s32*//*Label 32661*/ GIMT_Encode4(2352828),
     /* 2348854 */ /*GILLT_nxv4s64*//*Label 32662*/ GIMT_Encode4(2353079), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348866 */ /*GILLT_nxv8s16*//*Label 32663*/ GIMT_Encode4(2353330),
     /* 2348870 */ /*GILLT_nxv8s32*//*Label 32664*/ GIMT_Encode4(2353581),
     /* 2348874 */ /*GILLT_nxv8s64*//*Label 32665*/ GIMT_Encode4(2353832), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348886 */ /*GILLT_nxv16s16*//*Label 32666*/ GIMT_Encode4(2354083),
     /* 2348890 */ /*GILLT_nxv16s32*//*Label 32667*/ GIMT_Encode4(2354334), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2348902 */ /*GILLT_nxv32s16*//*Label 32668*/ GIMT_Encode4(2354585),
     /* 2348906 */ // Label 32651: @2348906
     /* 2348906 */ GIM_Try, /*On fail goto*//*Label 32670*/ GIMT_Encode4(2349581),
     /* 2348911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2348914 */   GIM_Try, /*On fail goto*//*Label 32671*/ GIMT_Encode4(2348965), // Rule ID 1994 //
     /* 2348919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2348922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2348925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2348937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2348941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2348945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2348950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2348952 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs2))  =>  (FSGNJN_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)
     /* 2348952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2348955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2348963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348964 */     // GIR_Coverage, 1994,
     /* 2348964 */     GIR_EraseRootFromParent_Done,
     /* 2348965 */   // Label 32671: @2348965
     /* 2348965 */   GIM_Try, /*On fail goto*//*Label 32672*/ GIMT_Encode4(2349016), // Rule ID 2027 //
     /* 2348970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2348973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2348976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2348980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2348984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2348988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2348992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2348996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2349003 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2))  =>  (FSGNJN_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)
     /* 2349003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2349006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2349014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349015 */     // GIR_Coverage, 2027,
     /* 2349015 */     GIR_EraseRootFromParent_Done,
     /* 2349016 */   // Label 32672: @2349016
     /* 2349016 */   GIM_Try, /*On fail goto*//*Label 32673*/ GIMT_Encode4(2349046), // Rule ID 1992 //
     /* 2349021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2349024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2349027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349039 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2349039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349045 */     // GIR_Coverage, 1992,
     /* 2349045 */     GIR_Done,
     /* 2349046 */   // Label 32673: @2349046
     /* 2349046 */   GIM_Try, /*On fail goto*//*Label 32674*/ GIMT_Encode4(2349102), // Rule ID 1995 //
     /* 2349051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2349054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349069 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2349069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2349076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349081 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349085 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349101 */     // GIR_Coverage, 1995,
     /* 2349101 */     GIR_EraseRootFromParent_Done,
     /* 2349102 */   // Label 32674: @2349102
     /* 2349102 */   GIM_Try, /*On fail goto*//*Label 32675*/ GIMT_Encode4(2349158), // Rule ID 1996 //
     /* 2349107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2349110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349125 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2349125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2349132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349141 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349157 */     // GIR_Coverage, 1996,
     /* 2349157 */     GIR_EraseRootFromParent_Done,
     /* 2349158 */   // Label 32675: @2349158
     /* 2349158 */   GIM_Try, /*On fail goto*//*Label 32676*/ GIMT_Encode4(2349188), // Rule ID 2025 //
     /* 2349163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2349166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2349169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349181 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2349181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349187 */     // GIR_Coverage, 2025,
     /* 2349187 */     GIR_Done,
     /* 2349188 */   // Label 32676: @2349188
     /* 2349188 */   GIM_Try, /*On fail goto*//*Label 32677*/ GIMT_Encode4(2349244), // Rule ID 2028 //
     /* 2349193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2349196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349211 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2349211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2349218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349227 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349243 */     // GIR_Coverage, 2028,
     /* 2349243 */     GIR_EraseRootFromParent_Done,
     /* 2349244 */   // Label 32677: @2349244
     /* 2349244 */   GIM_Try, /*On fail goto*//*Label 32678*/ GIMT_Encode4(2349300), // Rule ID 2029 //
     /* 2349249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2349252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349267 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2349267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2349274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349279 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349299 */     // GIR_Coverage, 2029,
     /* 2349299 */     GIR_EraseRootFromParent_Done,
     /* 2349300 */   // Label 32678: @2349300
     /* 2349300 */   GIM_Try, /*On fail goto*//*Label 32679*/ GIMT_Encode4(2349356), // Rule ID 2298 //
     /* 2349305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2349308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2349323 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2349323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2349330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349335 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349339 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349355 */     // GIR_Coverage, 2298,
     /* 2349355 */     GIR_EraseRootFromParent_Done,
     /* 2349356 */   // Label 32679: @2349356
     /* 2349356 */   GIM_Try, /*On fail goto*//*Label 32680*/ GIMT_Encode4(2349412), // Rule ID 2299 //
     /* 2349361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2349364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2349375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2349379 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2349379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2349386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349395 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2349403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349411 */     // GIR_Coverage, 2299,
     /* 2349411 */     GIR_EraseRootFromParent_Done,
     /* 2349412 */   // Label 32680: @2349412
     /* 2349412 */   GIM_Try, /*On fail goto*//*Label 32681*/ GIMT_Encode4(2349468), // Rule ID 2310 //
     /* 2349417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2349420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2349435 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2349435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2349442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349447 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349467 */     // GIR_Coverage, 2310,
     /* 2349467 */     GIR_EraseRootFromParent_Done,
     /* 2349468 */   // Label 32681: @2349468
     /* 2349468 */   GIM_Try, /*On fail goto*//*Label 32682*/ GIMT_Encode4(2349524), // Rule ID 2311 //
     /* 2349473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2349476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2349491 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2349491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2349498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349503 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349507 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349523 */     // GIR_Coverage, 2311,
     /* 2349523 */     GIR_EraseRootFromParent_Done,
     /* 2349524 */   // Label 32682: @2349524
     /* 2349524 */   GIM_Try, /*On fail goto*//*Label 32683*/ GIMT_Encode4(2349580), // Rule ID 2318 //
     /* 2349529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2349532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2349543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2349547 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_INX:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2349547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2349550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2349554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2349571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349579 */     // GIR_Coverage, 2318,
     /* 2349579 */     GIR_EraseRootFromParent_Done,
     /* 2349580 */   // Label 32683: @2349580
     /* 2349580 */   GIM_Reject,
     /* 2349581 */ // Label 32670: @2349581
     /* 2349581 */ GIM_Reject,
     /* 2349582 */ // Label 32652: @2349582
     /* 2349582 */ GIM_Try, /*On fail goto*//*Label 32684*/ GIMT_Encode4(2350257),
     /* 2349587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2349590 */   GIM_Try, /*On fail goto*//*Label 32685*/ GIMT_Encode4(2349641), // Rule ID 1295 //
     /* 2349595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2349598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2349613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2349617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2349621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2349628 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs2))  =>  (FSGNJN_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)
     /* 2349628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2349631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2349639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349640 */     // GIR_Coverage, 1295,
     /* 2349640 */     GIR_EraseRootFromParent_Done,
     /* 2349641 */   // Label 32685: @2349641
     /* 2349641 */   GIM_Try, /*On fail goto*//*Label 32686*/ GIMT_Encode4(2349692), // Rule ID 1316 //
     /* 2349646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2349649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2349664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2349668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2349672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2349679 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2))  =>  (FSGNJN_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)
     /* 2349679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2349682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2349690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349691 */     // GIR_Coverage, 1316,
     /* 2349691 */     GIR_EraseRootFromParent_Done,
     /* 2349692 */   // Label 32686: @2349692
     /* 2349692 */   GIM_Try, /*On fail goto*//*Label 32687*/ GIMT_Encode4(2349722), // Rule ID 1291 //
     /* 2349697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2349700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349715 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2349715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2349720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349721 */     // GIR_Coverage, 1291,
     /* 2349721 */     GIR_Done,
     /* 2349722 */   // Label 32687: @2349722
     /* 2349722 */   GIM_Try, /*On fail goto*//*Label 32688*/ GIMT_Encode4(2349752), // Rule ID 1292 //
     /* 2349727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2349730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2349733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349745 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2349745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2349750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349751 */     // GIR_Coverage, 1292,
     /* 2349751 */     GIR_Done,
     /* 2349752 */   // Label 32688: @2349752
     /* 2349752 */   GIM_Try, /*On fail goto*//*Label 32689*/ GIMT_Encode4(2349808), // Rule ID 1631 //
     /* 2349757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2349760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2349775 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2349775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2349778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2349782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349791 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2349799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349807 */     // GIR_Coverage, 1631,
     /* 2349807 */     GIR_EraseRootFromParent_Done,
     /* 2349808 */   // Label 32689: @2349808
     /* 2349808 */   GIM_Try, /*On fail goto*//*Label 32690*/ GIMT_Encode4(2349864), // Rule ID 1632 //
     /* 2349813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2349816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2349827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2349831 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2349831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2349834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2349838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349843 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349847 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2349855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349863 */     // GIR_Coverage, 1632,
     /* 2349863 */     GIR_EraseRootFromParent_Done,
     /* 2349864 */   // Label 32690: @2349864
     /* 2349864 */   GIM_Try, /*On fail goto*//*Label 32691*/ GIMT_Encode4(2349920), // Rule ID 1662 //
     /* 2349869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2349872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2349887 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_INX:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2349887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2349890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2349894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349899 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349903 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2349911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349919 */     // GIR_Coverage, 1662,
     /* 2349919 */     GIR_EraseRootFromParent_Done,
     /* 2349920 */   // Label 32691: @2349920
     /* 2349920 */   GIM_Try, /*On fail goto*//*Label 32692*/ GIMT_Encode4(2349976), // Rule ID 1686 //
     /* 2349925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2349928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2349943 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2349943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2349946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2349950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2349959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2349962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2349967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349975 */     // GIR_Coverage, 1686,
     /* 2349975 */     GIR_EraseRootFromParent_Done,
     /* 2349976 */   // Label 32692: @2349976
     /* 2349976 */   GIM_Try, /*On fail goto*//*Label 32693*/ GIMT_Encode4(2350032), // Rule ID 1687 //
     /* 2349981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2349984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2349987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2349995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2349999 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2349999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2350006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350011 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2350018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2350023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350031 */     // GIR_Coverage, 1687,
     /* 2350031 */     GIR_EraseRootFromParent_Done,
     /* 2350032 */   // Label 32693: @2350032
     /* 2350032 */   GIM_Try, /*On fail goto*//*Label 32694*/ GIMT_Encode4(2350088), // Rule ID 2170 //
     /* 2350037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2350040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2350055 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2350055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2350062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350067 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350071 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2350079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350087 */     // GIR_Coverage, 2170,
     /* 2350087 */     GIR_EraseRootFromParent_Done,
     /* 2350088 */   // Label 32694: @2350088
     /* 2350088 */   GIM_Try, /*On fail goto*//*Label 32695*/ GIMT_Encode4(2350144), // Rule ID 2171 //
     /* 2350093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2350096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2350111 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2350111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2350118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350127 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2350135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350143 */     // GIR_Coverage, 2171,
     /* 2350143 */     GIR_EraseRootFromParent_Done,
     /* 2350144 */   // Label 32695: @2350144
     /* 2350144 */   GIM_Try, /*On fail goto*//*Label 32696*/ GIMT_Encode4(2350200), // Rule ID 2184 //
     /* 2350149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2350152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2350167 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2350167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2350174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350183 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2350191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350199 */     // GIR_Coverage, 2184,
     /* 2350199 */     GIR_EraseRootFromParent_Done,
     /* 2350200 */   // Label 32696: @2350200
     /* 2350200 */   GIM_Try, /*On fail goto*//*Label 32697*/ GIMT_Encode4(2350256), // Rule ID 2185 //
     /* 2350205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2350208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2350223 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2350223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2350226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2350230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2350247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350255 */     // GIR_Coverage, 2185,
     /* 2350255 */     GIR_EraseRootFromParent_Done,
     /* 2350256 */   // Label 32697: @2350256
     /* 2350256 */   GIM_Reject,
     /* 2350257 */ // Label 32684: @2350257
     /* 2350257 */ GIM_Reject,
     /* 2350258 */ // Label 32653: @2350258
     /* 2350258 */ GIM_Try, /*On fail goto*//*Label 32698*/ GIMT_Encode4(2351070),
     /* 2350263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2350266 */   GIM_Try, /*On fail goto*//*Label 32699*/ GIMT_Encode4(2350317), // Rule ID 1628 //
     /* 2350271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2350274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2350289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2350293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2350297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2350304 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs2))  =>  (FSGNJN_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)
     /* 2350304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2350307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2350315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350316 */     // GIR_Coverage, 1628,
     /* 2350316 */     GIR_EraseRootFromParent_Done,
     /* 2350317 */   // Label 32699: @2350317
     /* 2350317 */   GIM_Try, /*On fail goto*//*Label 32700*/ GIMT_Encode4(2350368), // Rule ID 1660 //
     /* 2350322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2350325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2350340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2350344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2350348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2350355 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)
     /* 2350355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2350358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2350366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350367 */     // GIR_Coverage, 1660,
     /* 2350367 */     GIR_EraseRootFromParent_Done,
     /* 2350368 */   // Label 32700: @2350368
     /* 2350368 */   GIM_Try, /*On fail goto*//*Label 32701*/ GIMT_Encode4(2350419), // Rule ID 1683 //
     /* 2350373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2350376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2350391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2350395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2350399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2350406 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)
     /* 2350406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2350409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2350417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350418 */     // GIR_Coverage, 1683,
     /* 2350418 */     GIR_EraseRootFromParent_Done,
     /* 2350419 */   // Label 32701: @2350419
     /* 2350419 */   GIM_Try, /*On fail goto*//*Label 32702*/ GIMT_Encode4(2350449), // Rule ID 1626 //
     /* 2350424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2350427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350442 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2350442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2350447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350448 */     // GIR_Coverage, 1626,
     /* 2350448 */     GIR_Done,
     /* 2350449 */   // Label 32702: @2350449
     /* 2350449 */   GIM_Try, /*On fail goto*//*Label 32703*/ GIMT_Encode4(2350505), // Rule ID 1629 //
     /* 2350454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2350457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350472 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2350472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2350479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350484 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350488 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2350496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350504 */     // GIR_Coverage, 1629,
     /* 2350504 */     GIR_EraseRootFromParent_Done,
     /* 2350505 */   // Label 32703: @2350505
     /* 2350505 */   GIM_Try, /*On fail goto*//*Label 32704*/ GIMT_Encode4(2350561), // Rule ID 1630 //
     /* 2350510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2350513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2350528 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2350528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2350535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350540 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350544 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2350552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350560 */     // GIR_Coverage, 1630,
     /* 2350560 */     GIR_EraseRootFromParent_Done,
     /* 2350561 */   // Label 32704: @2350561
     /* 2350561 */   GIM_Try, /*On fail goto*//*Label 32705*/ GIMT_Encode4(2350591), // Rule ID 1658 //
     /* 2350566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2350569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350584 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2350584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2350589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350590 */     // GIR_Coverage, 1658,
     /* 2350590 */     GIR_Done,
     /* 2350591 */   // Label 32705: @2350591
     /* 2350591 */   GIM_Try, /*On fail goto*//*Label 32706*/ GIMT_Encode4(2350647), // Rule ID 1661 //
     /* 2350596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2350599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2350610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350614 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_INX:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2350614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2350621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350630 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2350638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350646 */     // GIR_Coverage, 1661,
     /* 2350646 */     GIR_EraseRootFromParent_Done,
     /* 2350647 */   // Label 32706: @2350647
     /* 2350647 */   GIM_Try, /*On fail goto*//*Label 32707*/ GIMT_Encode4(2350677), // Rule ID 1681 //
     /* 2350652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2350655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2350658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350670 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2350670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2350675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350676 */     // GIR_Coverage, 1681,
     /* 2350676 */     GIR_Done,
     /* 2350677 */   // Label 32707: @2350677
     /* 2350677 */   GIM_Try, /*On fail goto*//*Label 32708*/ GIMT_Encode4(2350733), // Rule ID 1684 //
     /* 2350682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2350685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350700 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2350700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2350707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350716 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2350724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350732 */     // GIR_Coverage, 1684,
     /* 2350732 */     GIR_EraseRootFromParent_Done,
     /* 2350733 */   // Label 32708: @2350733
     /* 2350733 */   GIM_Try, /*On fail goto*//*Label 32709*/ GIMT_Encode4(2350789), // Rule ID 1685 //
     /* 2350738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2350741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2350744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2350756 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2350756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2350763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2350780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350788 */     // GIR_Coverage, 1685,
     /* 2350788 */     GIR_EraseRootFromParent_Done,
     /* 2350789 */   // Label 32709: @2350789
     /* 2350789 */   GIM_Try, /*On fail goto*//*Label 32710*/ GIMT_Encode4(2350845), // Rule ID 2300 //
     /* 2350794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2350797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2350812 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2350812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2350819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2350836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350844 */     // GIR_Coverage, 2300,
     /* 2350844 */     GIR_EraseRootFromParent_Done,
     /* 2350845 */   // Label 32710: @2350845
     /* 2350845 */   GIM_Try, /*On fail goto*//*Label 32711*/ GIMT_Encode4(2350901), // Rule ID 2301 //
     /* 2350850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2350853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2350864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2350868 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2350868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2350875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350884 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2350892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350900 */     // GIR_Coverage, 2301,
     /* 2350900 */     GIR_EraseRootFromParent_Done,
     /* 2350901 */   // Label 32711: @2350901
     /* 2350901 */   GIM_Try, /*On fail goto*//*Label 32712*/ GIMT_Encode4(2350957), // Rule ID 2312 //
     /* 2350906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2350909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2350924 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2350924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2350931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350940 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2350948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350956 */     // GIR_Coverage, 2312,
     /* 2350956 */     GIR_EraseRootFromParent_Done,
     /* 2350957 */   // Label 32712: @2350957
     /* 2350957 */   GIM_Try, /*On fail goto*//*Label 32713*/ GIMT_Encode4(2351013), // Rule ID 2313 //
     /* 2350962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2350965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2350968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2350976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2350980 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2350980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2350983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2350987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2350996 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2350999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2351004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351012 */     // GIR_Coverage, 2313,
     /* 2351012 */     GIR_EraseRootFromParent_Done,
     /* 2351013 */   // Label 32713: @2351013
     /* 2351013 */   GIM_Try, /*On fail goto*//*Label 32714*/ GIMT_Encode4(2351069), // Rule ID 2319 //
     /* 2351018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2351021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2351024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2351036 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_INX:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2351036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2351039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2351043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351048 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2351052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2351055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2351060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351068 */     // GIR_Coverage, 2319,
     /* 2351068 */     GIR_EraseRootFromParent_Done,
     /* 2351069 */   // Label 32714: @2351069
     /* 2351069 */   GIM_Reject,
     /* 2351070 */ // Label 32698: @2351070
     /* 2351070 */ GIM_Reject,
     /* 2351071 */ // Label 32654: @2351071
     /* 2351071 */ GIM_Try, /*On fail goto*//*Label 32715*/ GIMT_Encode4(2351321),
     /* 2351076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2351079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2351082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351090 */   GIM_Try, /*On fail goto*//*Label 32716*/ GIMT_Encode4(2351156), // Rule ID 56248 //
     /* 2351095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2351110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351117 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2351134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351155 */     // GIR_Coverage, 56248,
     /* 2351155 */     GIR_EraseRootFromParent_Done,
     /* 2351156 */   // Label 32716: @2351156
     /* 2351156 */   GIM_Try, /*On fail goto*//*Label 32717*/ GIMT_Encode4(2351222), // Rule ID 56249 //
     /* 2351161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2351164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2351176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351183 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2351200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351221 */     // GIR_Coverage, 56249,
     /* 2351221 */     GIR_EraseRootFromParent_Done,
     /* 2351222 */   // Label 32717: @2351222
     /* 2351222 */   GIM_Try, /*On fail goto*//*Label 32718*/ GIMT_Encode4(2351271), // Rule ID 56242 //
     /* 2351227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351234 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2351251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351270 */     // GIR_Coverage, 56242,
     /* 2351270 */     GIR_EraseRootFromParent_Done,
     /* 2351271 */   // Label 32718: @2351271
     /* 2351271 */   GIM_Try, /*On fail goto*//*Label 32719*/ GIMT_Encode4(2351320), // Rule ID 56243 //
     /* 2351276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2351279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351283 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2351300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351319 */     // GIR_Coverage, 56243,
     /* 2351319 */     GIR_EraseRootFromParent_Done,
     /* 2351320 */   // Label 32719: @2351320
     /* 2351320 */   GIM_Reject,
     /* 2351321 */ // Label 32715: @2351321
     /* 2351321 */ GIM_Reject,
     /* 2351322 */ // Label 32655: @2351322
     /* 2351322 */ GIM_Try, /*On fail goto*//*Label 32720*/ GIMT_Encode4(2351572),
     /* 2351327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2351330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2351333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351341 */   GIM_Try, /*On fail goto*//*Label 32721*/ GIMT_Encode4(2351407), // Rule ID 56288 //
     /* 2351346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2351349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2351361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351368 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2351385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351406 */     // GIR_Coverage, 56288,
     /* 2351406 */     GIR_EraseRootFromParent_Done,
     /* 2351407 */   // Label 32721: @2351407
     /* 2351407 */   GIM_Try, /*On fail goto*//*Label 32722*/ GIMT_Encode4(2351473), // Rule ID 56289 //
     /* 2351412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2351415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2351427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351434 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2351451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351472 */     // GIR_Coverage, 56289,
     /* 2351472 */     GIR_EraseRootFromParent_Done,
     /* 2351473 */   // Label 32722: @2351473
     /* 2351473 */   GIM_Try, /*On fail goto*//*Label 32723*/ GIMT_Encode4(2351522), // Rule ID 56282 //
     /* 2351478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2351481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351485 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2351502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351521 */     // GIR_Coverage, 56282,
     /* 2351521 */     GIR_EraseRootFromParent_Done,
     /* 2351522 */   // Label 32723: @2351522
     /* 2351522 */   GIM_Try, /*On fail goto*//*Label 32724*/ GIMT_Encode4(2351571), // Rule ID 56283 //
     /* 2351527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2351530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351534 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2351551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351570 */     // GIR_Coverage, 56283,
     /* 2351570 */     GIR_EraseRootFromParent_Done,
     /* 2351571 */   // Label 32724: @2351571
     /* 2351571 */   GIM_Reject,
     /* 2351572 */ // Label 32720: @2351572
     /* 2351572 */ GIM_Reject,
     /* 2351573 */ // Label 32656: @2351573
     /* 2351573 */ GIM_Try, /*On fail goto*//*Label 32725*/ GIMT_Encode4(2351823),
     /* 2351578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2351581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2351584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351592 */   GIM_Try, /*On fail goto*//*Label 32726*/ GIMT_Encode4(2351658), // Rule ID 56348 //
     /* 2351597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2351600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2351612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351619 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2351622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2351636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351657 */     // GIR_Coverage, 56348,
     /* 2351657 */     GIR_EraseRootFromParent_Done,
     /* 2351658 */   // Label 32726: @2351658
     /* 2351658 */   GIM_Try, /*On fail goto*//*Label 32727*/ GIMT_Encode4(2351724), // Rule ID 56349 //
     /* 2351663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2351666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2351678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351685 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2351688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2351702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351723 */     // GIR_Coverage, 56349,
     /* 2351723 */     GIR_EraseRootFromParent_Done,
     /* 2351724 */   // Label 32727: @2351724
     /* 2351724 */   GIM_Try, /*On fail goto*//*Label 32728*/ GIMT_Encode4(2351773), // Rule ID 56342 //
     /* 2351729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2351732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351736 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2351739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2351753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351772 */     // GIR_Coverage, 56342,
     /* 2351772 */     GIR_EraseRootFromParent_Done,
     /* 2351773 */   // Label 32728: @2351773
     /* 2351773 */   GIM_Try, /*On fail goto*//*Label 32729*/ GIMT_Encode4(2351822), // Rule ID 56343 //
     /* 2351778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2351781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351785 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2351788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2351802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351821 */     // GIR_Coverage, 56343,
     /* 2351821 */     GIR_EraseRootFromParent_Done,
     /* 2351822 */   // Label 32729: @2351822
     /* 2351822 */   GIM_Reject,
     /* 2351823 */ // Label 32725: @2351823
     /* 2351823 */ GIM_Reject,
     /* 2351824 */ // Label 32657: @2351824
     /* 2351824 */ GIM_Try, /*On fail goto*//*Label 32730*/ GIMT_Encode4(2352074),
     /* 2351829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2351832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2351835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351843 */   GIM_Try, /*On fail goto*//*Label 32731*/ GIMT_Encode4(2351909), // Rule ID 56268 //
     /* 2351848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2351863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351870 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2351873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2351887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351908 */     // GIR_Coverage, 56268,
     /* 2351908 */     GIR_EraseRootFromParent_Done,
     /* 2351909 */   // Label 32731: @2351909
     /* 2351909 */   GIM_Try, /*On fail goto*//*Label 32732*/ GIMT_Encode4(2351975), // Rule ID 56269 //
     /* 2351914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2351917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2351921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2351925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2351929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2351936 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2351939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2351953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2351964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351974 */     // GIR_Coverage, 56269,
     /* 2351974 */     GIR_EraseRootFromParent_Done,
     /* 2351975 */   // Label 32732: @2351975
     /* 2351975 */   GIM_Try, /*On fail goto*//*Label 32733*/ GIMT_Encode4(2352024), // Rule ID 56262 //
     /* 2351980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2351983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351987 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2351990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2352004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352023 */     // GIR_Coverage, 56262,
     /* 2352023 */     GIR_EraseRootFromParent_Done,
     /* 2352024 */   // Label 32733: @2352024
     /* 2352024 */   GIM_Try, /*On fail goto*//*Label 32734*/ GIMT_Encode4(2352073), // Rule ID 56263 //
     /* 2352029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2352032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352036 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2352039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2352053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352072 */     // GIR_Coverage, 56263,
     /* 2352072 */     GIR_EraseRootFromParent_Done,
     /* 2352073 */   // Label 32734: @2352073
     /* 2352073 */   GIM_Reject,
     /* 2352074 */ // Label 32730: @2352074
     /* 2352074 */ GIM_Reject,
     /* 2352075 */ // Label 32658: @2352075
     /* 2352075 */ GIM_Try, /*On fail goto*//*Label 32735*/ GIMT_Encode4(2352325),
     /* 2352080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2352083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2352086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352094 */   GIM_Try, /*On fail goto*//*Label 32736*/ GIMT_Encode4(2352160), // Rule ID 56328 //
     /* 2352099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2352102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2352114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352121 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2352138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352159 */     // GIR_Coverage, 56328,
     /* 2352159 */     GIR_EraseRootFromParent_Done,
     /* 2352160 */   // Label 32736: @2352160
     /* 2352160 */   GIM_Try, /*On fail goto*//*Label 32737*/ GIMT_Encode4(2352226), // Rule ID 56329 //
     /* 2352165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2352168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2352180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352187 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2352204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352225 */     // GIR_Coverage, 56329,
     /* 2352225 */     GIR_EraseRootFromParent_Done,
     /* 2352226 */   // Label 32737: @2352226
     /* 2352226 */   GIM_Try, /*On fail goto*//*Label 32738*/ GIMT_Encode4(2352275), // Rule ID 56322 //
     /* 2352231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2352234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352238 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2352255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352274 */     // GIR_Coverage, 56322,
     /* 2352274 */     GIR_EraseRootFromParent_Done,
     /* 2352275 */   // Label 32738: @2352275
     /* 2352275 */   GIM_Try, /*On fail goto*//*Label 32739*/ GIMT_Encode4(2352324), // Rule ID 56323 //
     /* 2352280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2352283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352287 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2352304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352323 */     // GIR_Coverage, 56323,
     /* 2352323 */     GIR_EraseRootFromParent_Done,
     /* 2352324 */   // Label 32739: @2352324
     /* 2352324 */   GIM_Reject,
     /* 2352325 */ // Label 32735: @2352325
     /* 2352325 */ GIM_Reject,
     /* 2352326 */ // Label 32659: @2352326
     /* 2352326 */ GIM_Try, /*On fail goto*//*Label 32740*/ GIMT_Encode4(2352576),
     /* 2352331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2352334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2352337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352345 */   GIM_Try, /*On fail goto*//*Label 32741*/ GIMT_Encode4(2352411), // Rule ID 56488 //
     /* 2352350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2352353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2352365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352372 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2352389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352410 */     // GIR_Coverage, 56488,
     /* 2352410 */     GIR_EraseRootFromParent_Done,
     /* 2352411 */   // Label 32741: @2352411
     /* 2352411 */   GIM_Try, /*On fail goto*//*Label 32742*/ GIMT_Encode4(2352477), // Rule ID 56489 //
     /* 2352416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2352419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2352431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352438 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2352455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352476 */     // GIR_Coverage, 56489,
     /* 2352476 */     GIR_EraseRootFromParent_Done,
     /* 2352477 */   // Label 32742: @2352477
     /* 2352477 */   GIM_Try, /*On fail goto*//*Label 32743*/ GIMT_Encode4(2352526), // Rule ID 56482 //
     /* 2352482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2352485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352489 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2352506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352525 */     // GIR_Coverage, 56482,
     /* 2352525 */     GIR_EraseRootFromParent_Done,
     /* 2352526 */   // Label 32743: @2352526
     /* 2352526 */   GIM_Try, /*On fail goto*//*Label 32744*/ GIMT_Encode4(2352575), // Rule ID 56483 //
     /* 2352531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2352534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352538 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2352555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352574 */     // GIR_Coverage, 56483,
     /* 2352574 */     GIR_EraseRootFromParent_Done,
     /* 2352575 */   // Label 32744: @2352575
     /* 2352575 */   GIM_Reject,
     /* 2352576 */ // Label 32740: @2352576
     /* 2352576 */ GIM_Reject,
     /* 2352577 */ // Label 32660: @2352577
     /* 2352577 */ GIM_Try, /*On fail goto*//*Label 32745*/ GIMT_Encode4(2352827),
     /* 2352582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2352585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2352588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352596 */   GIM_Try, /*On fail goto*//*Label 32746*/ GIMT_Encode4(2352662), // Rule ID 56308 //
     /* 2352601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2352604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2352616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352623 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2352626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2352640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352661 */     // GIR_Coverage, 56308,
     /* 2352661 */     GIR_EraseRootFromParent_Done,
     /* 2352662 */   // Label 32746: @2352662
     /* 2352662 */   GIM_Try, /*On fail goto*//*Label 32747*/ GIMT_Encode4(2352728), // Rule ID 56309 //
     /* 2352667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2352670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2352682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352689 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2352692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2352706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352727 */     // GIR_Coverage, 56309,
     /* 2352727 */     GIR_EraseRootFromParent_Done,
     /* 2352728 */   // Label 32747: @2352728
     /* 2352728 */   GIM_Try, /*On fail goto*//*Label 32748*/ GIMT_Encode4(2352777), // Rule ID 56302 //
     /* 2352733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2352736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352740 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2352743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2352757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352776 */     // GIR_Coverage, 56302,
     /* 2352776 */     GIR_EraseRootFromParent_Done,
     /* 2352777 */   // Label 32748: @2352777
     /* 2352777 */   GIM_Try, /*On fail goto*//*Label 32749*/ GIMT_Encode4(2352826), // Rule ID 56303 //
     /* 2352782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2352785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352789 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2352792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2352806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352825 */     // GIR_Coverage, 56303,
     /* 2352825 */     GIR_EraseRootFromParent_Done,
     /* 2352826 */   // Label 32749: @2352826
     /* 2352826 */   GIM_Reject,
     /* 2352827 */ // Label 32745: @2352827
     /* 2352827 */ GIM_Reject,
     /* 2352828 */ // Label 32661: @2352828
     /* 2352828 */ GIM_Try, /*On fail goto*//*Label 32750*/ GIMT_Encode4(2353078),
     /* 2352833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2352836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2352839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352847 */   GIM_Try, /*On fail goto*//*Label 32751*/ GIMT_Encode4(2352913), // Rule ID 56428 //
     /* 2352852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2352855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2352867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352874 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2352877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2352891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352912 */     // GIR_Coverage, 56428,
     /* 2352912 */     GIR_EraseRootFromParent_Done,
     /* 2352913 */   // Label 32751: @2352913
     /* 2352913 */   GIM_Try, /*On fail goto*//*Label 32752*/ GIMT_Encode4(2352979), // Rule ID 56429 //
     /* 2352918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2352921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2352925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2352929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2352933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2352940 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2352943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2352957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2352968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352978 */     // GIR_Coverage, 56429,
     /* 2352978 */     GIR_EraseRootFromParent_Done,
     /* 2352979 */   // Label 32752: @2352979
     /* 2352979 */   GIM_Try, /*On fail goto*//*Label 32753*/ GIMT_Encode4(2353028), // Rule ID 56422 //
     /* 2352984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2352987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352991 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2352994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2353008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353027 */     // GIR_Coverage, 56422,
     /* 2353027 */     GIR_EraseRootFromParent_Done,
     /* 2353028 */   // Label 32753: @2353028
     /* 2353028 */   GIM_Try, /*On fail goto*//*Label 32754*/ GIMT_Encode4(2353077), // Rule ID 56423 //
     /* 2353033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353040 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2353043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2353057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353076 */     // GIR_Coverage, 56423,
     /* 2353076 */     GIR_EraseRootFromParent_Done,
     /* 2353077 */   // Label 32754: @2353077
     /* 2353077 */   GIM_Reject,
     /* 2353078 */ // Label 32750: @2353078
     /* 2353078 */ GIM_Reject,
     /* 2353079 */ // Label 32662: @2353079
     /* 2353079 */ GIM_Try, /*On fail goto*//*Label 32755*/ GIMT_Encode4(2353329),
     /* 2353084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2353087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2353090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353098 */   GIM_Try, /*On fail goto*//*Label 32756*/ GIMT_Encode4(2353164), // Rule ID 56508 //
     /* 2353103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2353118 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353125 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2353128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2353142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353163 */     // GIR_Coverage, 56508,
     /* 2353163 */     GIR_EraseRootFromParent_Done,
     /* 2353164 */   // Label 32756: @2353164
     /* 2353164 */   GIM_Try, /*On fail goto*//*Label 32757*/ GIMT_Encode4(2353230), // Rule ID 56509 //
     /* 2353169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2353172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2353184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353191 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2353194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2353208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353229 */     // GIR_Coverage, 56509,
     /* 2353229 */     GIR_EraseRootFromParent_Done,
     /* 2353230 */   // Label 32757: @2353230
     /* 2353230 */   GIM_Try, /*On fail goto*//*Label 32758*/ GIMT_Encode4(2353279), // Rule ID 56502 //
     /* 2353235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353242 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2353245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2353259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353278 */     // GIR_Coverage, 56502,
     /* 2353278 */     GIR_EraseRootFromParent_Done,
     /* 2353279 */   // Label 32758: @2353279
     /* 2353279 */   GIM_Try, /*On fail goto*//*Label 32759*/ GIMT_Encode4(2353328), // Rule ID 56503 //
     /* 2353284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2353287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353291 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2353294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2353308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353327 */     // GIR_Coverage, 56503,
     /* 2353327 */     GIR_EraseRootFromParent_Done,
     /* 2353328 */   // Label 32759: @2353328
     /* 2353328 */   GIM_Reject,
     /* 2353329 */ // Label 32755: @2353329
     /* 2353329 */ GIM_Reject,
     /* 2353330 */ // Label 32663: @2353330
     /* 2353330 */ GIM_Try, /*On fail goto*//*Label 32760*/ GIMT_Encode4(2353580),
     /* 2353335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2353338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2353341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353349 */   GIM_Try, /*On fail goto*//*Label 32761*/ GIMT_Encode4(2353415), // Rule ID 56368 //
     /* 2353354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2353369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353376 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2353379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2353393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353414 */     // GIR_Coverage, 56368,
     /* 2353414 */     GIR_EraseRootFromParent_Done,
     /* 2353415 */   // Label 32761: @2353415
     /* 2353415 */   GIM_Try, /*On fail goto*//*Label 32762*/ GIMT_Encode4(2353481), // Rule ID 56369 //
     /* 2353420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2353435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353442 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2353445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2353459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353480 */     // GIR_Coverage, 56369,
     /* 2353480 */     GIR_EraseRootFromParent_Done,
     /* 2353481 */   // Label 32762: @2353481
     /* 2353481 */   GIM_Try, /*On fail goto*//*Label 32763*/ GIMT_Encode4(2353530), // Rule ID 56362 //
     /* 2353486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2353489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353493 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2353496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2353510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353529 */     // GIR_Coverage, 56362,
     /* 2353529 */     GIR_EraseRootFromParent_Done,
     /* 2353530 */   // Label 32763: @2353530
     /* 2353530 */   GIM_Try, /*On fail goto*//*Label 32764*/ GIMT_Encode4(2353579), // Rule ID 56363 //
     /* 2353535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2353538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353542 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2353545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2353559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353578 */     // GIR_Coverage, 56363,
     /* 2353578 */     GIR_EraseRootFromParent_Done,
     /* 2353579 */   // Label 32764: @2353579
     /* 2353579 */   GIM_Reject,
     /* 2353580 */ // Label 32760: @2353580
     /* 2353580 */ GIM_Reject,
     /* 2353581 */ // Label 32664: @2353581
     /* 2353581 */ GIM_Try, /*On fail goto*//*Label 32765*/ GIMT_Encode4(2353831),
     /* 2353586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2353589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2353592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353600 */   GIM_Try, /*On fail goto*//*Label 32766*/ GIMT_Encode4(2353666), // Rule ID 56448 //
     /* 2353605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2353620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353627 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2353630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2353644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353665 */     // GIR_Coverage, 56448,
     /* 2353665 */     GIR_EraseRootFromParent_Done,
     /* 2353666 */   // Label 32766: @2353666
     /* 2353666 */   GIM_Try, /*On fail goto*//*Label 32767*/ GIMT_Encode4(2353732), // Rule ID 56449 //
     /* 2353671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2353686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353693 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2353696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2353710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353731 */     // GIR_Coverage, 56449,
     /* 2353731 */     GIR_EraseRootFromParent_Done,
     /* 2353732 */   // Label 32767: @2353732
     /* 2353732 */   GIM_Try, /*On fail goto*//*Label 32768*/ GIMT_Encode4(2353781), // Rule ID 56442 //
     /* 2353737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2353740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353744 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2353747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2353761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353780 */     // GIR_Coverage, 56442,
     /* 2353780 */     GIR_EraseRootFromParent_Done,
     /* 2353781 */   // Label 32768: @2353781
     /* 2353781 */   GIM_Try, /*On fail goto*//*Label 32769*/ GIMT_Encode4(2353830), // Rule ID 56443 //
     /* 2353786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2353789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353793 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2353796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2353810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353829 */     // GIR_Coverage, 56443,
     /* 2353829 */     GIR_EraseRootFromParent_Done,
     /* 2353830 */   // Label 32769: @2353830
     /* 2353830 */   GIM_Reject,
     /* 2353831 */ // Label 32765: @2353831
     /* 2353831 */ GIM_Reject,
     /* 2353832 */ // Label 32665: @2353832
     /* 2353832 */ GIM_Try, /*On fail goto*//*Label 32770*/ GIMT_Encode4(2354082),
     /* 2353837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2353840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2353843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353847 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353851 */   GIM_Try, /*On fail goto*//*Label 32771*/ GIMT_Encode4(2353917), // Rule ID 56528 //
     /* 2353856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2353871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353878 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2353881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2353895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353916 */     // GIR_Coverage, 56528,
     /* 2353916 */     GIR_EraseRootFromParent_Done,
     /* 2353917 */   // Label 32771: @2353917
     /* 2353917 */   GIM_Try, /*On fail goto*//*Label 32772*/ GIMT_Encode4(2353983), // Rule ID 56529 //
     /* 2353922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2353925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2353929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2353933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2353937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2353944 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2353947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2353961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2353972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353982 */     // GIR_Coverage, 56529,
     /* 2353982 */     GIR_EraseRootFromParent_Done,
     /* 2353983 */   // Label 32772: @2353983
     /* 2353983 */   GIM_Try, /*On fail goto*//*Label 32773*/ GIMT_Encode4(2354032), // Rule ID 56522 //
     /* 2353988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2353991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353995 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2353998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2354012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354031 */     // GIR_Coverage, 56522,
     /* 2354031 */     GIR_EraseRootFromParent_Done,
     /* 2354032 */   // Label 32773: @2354032
     /* 2354032 */   GIM_Try, /*On fail goto*//*Label 32774*/ GIMT_Encode4(2354081), // Rule ID 56523 //
     /* 2354037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2354040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354044 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2354047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2354061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354080 */     // GIR_Coverage, 56523,
     /* 2354080 */     GIR_EraseRootFromParent_Done,
     /* 2354081 */   // Label 32774: @2354081
     /* 2354081 */   GIM_Reject,
     /* 2354082 */ // Label 32770: @2354082
     /* 2354082 */ GIM_Reject,
     /* 2354083 */ // Label 32666: @2354083
     /* 2354083 */ GIM_Try, /*On fail goto*//*Label 32775*/ GIMT_Encode4(2354333),
     /* 2354088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2354091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2354094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354102 */   GIM_Try, /*On fail goto*//*Label 32776*/ GIMT_Encode4(2354168), // Rule ID 56388 //
     /* 2354107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2354122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354129 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2354146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354167 */     // GIR_Coverage, 56388,
     /* 2354167 */     GIR_EraseRootFromParent_Done,
     /* 2354168 */   // Label 32776: @2354168
     /* 2354168 */   GIM_Try, /*On fail goto*//*Label 32777*/ GIMT_Encode4(2354234), // Rule ID 56389 //
     /* 2354173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2354188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354195 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2354212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354233 */     // GIR_Coverage, 56389,
     /* 2354233 */     GIR_EraseRootFromParent_Done,
     /* 2354234 */   // Label 32777: @2354234
     /* 2354234 */   GIM_Try, /*On fail goto*//*Label 32778*/ GIMT_Encode4(2354283), // Rule ID 56382 //
     /* 2354239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354246 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2354263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354282 */     // GIR_Coverage, 56382,
     /* 2354282 */     GIR_EraseRootFromParent_Done,
     /* 2354283 */   // Label 32778: @2354283
     /* 2354283 */   GIM_Try, /*On fail goto*//*Label 32779*/ GIMT_Encode4(2354332), // Rule ID 56383 //
     /* 2354288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2354295 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2354298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2354312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354331 */     // GIR_Coverage, 56383,
     /* 2354331 */     GIR_EraseRootFromParent_Done,
     /* 2354332 */   // Label 32779: @2354332
     /* 2354332 */   GIM_Reject,
     /* 2354333 */ // Label 32775: @2354333
     /* 2354333 */ GIM_Reject,
     /* 2354334 */ // Label 32667: @2354334
     /* 2354334 */ GIM_Try, /*On fail goto*//*Label 32780*/ GIMT_Encode4(2354584),
     /* 2354339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2354342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2354345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354353 */   GIM_Try, /*On fail goto*//*Label 32781*/ GIMT_Encode4(2354419), // Rule ID 56468 //
     /* 2354358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2354373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354380 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2354397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354418 */     // GIR_Coverage, 56468,
     /* 2354418 */     GIR_EraseRootFromParent_Done,
     /* 2354419 */   // Label 32781: @2354419
     /* 2354419 */   GIM_Try, /*On fail goto*//*Label 32782*/ GIMT_Encode4(2354485), // Rule ID 56469 //
     /* 2354424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2354439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354446 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2354463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354484 */     // GIR_Coverage, 56469,
     /* 2354484 */     GIR_EraseRootFromParent_Done,
     /* 2354485 */   // Label 32782: @2354485
     /* 2354485 */   GIM_Try, /*On fail goto*//*Label 32783*/ GIMT_Encode4(2354534), // Rule ID 56462 //
     /* 2354490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2354493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354497 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2354514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354533 */     // GIR_Coverage, 56462,
     /* 2354533 */     GIR_EraseRootFromParent_Done,
     /* 2354534 */   // Label 32783: @2354534
     /* 2354534 */   GIM_Try, /*On fail goto*//*Label 32784*/ GIMT_Encode4(2354583), // Rule ID 56463 //
     /* 2354539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2354542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354546 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2354549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2354563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354582 */     // GIR_Coverage, 56463,
     /* 2354582 */     GIR_EraseRootFromParent_Done,
     /* 2354583 */   // Label 32784: @2354583
     /* 2354583 */   GIM_Reject,
     /* 2354584 */ // Label 32780: @2354584
     /* 2354584 */ GIM_Reject,
     /* 2354585 */ // Label 32668: @2354585
     /* 2354585 */ GIM_Try, /*On fail goto*//*Label 32785*/ GIMT_Encode4(2354835),
     /* 2354590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2354593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2354596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354604 */   GIM_Try, /*On fail goto*//*Label 32786*/ GIMT_Encode4(2354670), // Rule ID 56408 //
     /* 2354609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2354624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354631 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2354634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2354648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354669 */     // GIR_Coverage, 56408,
     /* 2354669 */     GIR_EraseRootFromParent_Done,
     /* 2354670 */   // Label 32786: @2354670
     /* 2354670 */   GIM_Try, /*On fail goto*//*Label 32787*/ GIMT_Encode4(2354736), // Rule ID 56409 //
     /* 2354675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2354682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2354686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2354690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2354697 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2354700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2354714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2354725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354735 */     // GIR_Coverage, 56409,
     /* 2354735 */     GIR_EraseRootFromParent_Done,
     /* 2354736 */   // Label 32787: @2354736
     /* 2354736 */   GIM_Try, /*On fail goto*//*Label 32788*/ GIMT_Encode4(2354785), // Rule ID 56402 //
     /* 2354741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2354744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354748 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2354751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2354765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354784 */     // GIR_Coverage, 56402,
     /* 2354784 */     GIR_EraseRootFromParent_Done,
     /* 2354785 */   // Label 32788: @2354785
     /* 2354785 */   GIM_Try, /*On fail goto*//*Label 32789*/ GIMT_Encode4(2354834), // Rule ID 56403 //
     /* 2354790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2354793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2354797 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2354800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2354814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354833 */     // GIR_Coverage, 56403,
     /* 2354833 */     GIR_EraseRootFromParent_Done,
     /* 2354834 */   // Label 32789: @2354834
     /* 2354834 */   GIM_Reject,
     /* 2354835 */ // Label 32785: @2354835
     /* 2354835 */ GIM_Reject,
     /* 2354836 */ // Label 32669: @2354836
     /* 2354836 */ GIM_Reject,
     /* 2354837 */ // Label 73: @2354837
     /* 2354837 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32793*/ GIMT_Encode4(2355026),
     /* 2354848 */ /*GILLT_s16*//*Label 32790*/ GIMT_Encode4(2354860),
     /* 2354852 */ /*GILLT_s32*//*Label 32791*/ GIMT_Encode4(2354910),
     /* 2354856 */ /*GILLT_s64*//*Label 32792*/ GIMT_Encode4(2354960),
     /* 2354860 */ // Label 32790: @2354860
     /* 2354860 */ GIM_Try, /*On fail goto*//*Label 32794*/ GIMT_Encode4(2354909),
     /* 2354865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2354868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2354872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2354876 */   GIM_Try, /*On fail goto*//*Label 32795*/ GIMT_Encode4(2354892), // Rule ID 2062 //
     /* 2354881 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2354881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2354884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354891 */     // GIR_Coverage, 2062,
     /* 2354891 */     GIR_EraseRootFromParent_Done,
     /* 2354892 */   // Label 32795: @2354892
     /* 2354892 */   GIM_Try, /*On fail goto*//*Label 32796*/ GIMT_Encode4(2354908), // Rule ID 2063 //
     /* 2354897 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2354897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2354900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354907 */     // GIR_Coverage, 2063,
     /* 2354907 */     GIR_EraseRootFromParent_Done,
     /* 2354908 */   // Label 32796: @2354908
     /* 2354908 */   GIM_Reject,
     /* 2354909 */ // Label 32794: @2354909
     /* 2354909 */ GIM_Reject,
     /* 2354910 */ // Label 32791: @2354910
     /* 2354910 */ GIM_Try, /*On fail goto*//*Label 32797*/ GIMT_Encode4(2354959),
     /* 2354915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2354918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2354922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2354926 */   GIM_Try, /*On fail goto*//*Label 32798*/ GIMT_Encode4(2354942), // Rule ID 1349 //
     /* 2354931 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2354931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2354934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354941 */     // GIR_Coverage, 1349,
     /* 2354941 */     GIR_EraseRootFromParent_Done,
     /* 2354942 */   // Label 32798: @2354942
     /* 2354942 */   GIM_Try, /*On fail goto*//*Label 32799*/ GIMT_Encode4(2354958), // Rule ID 1350 //
     /* 2354947 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2354947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2354950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354957 */     // GIR_Coverage, 1350,
     /* 2354957 */     GIR_EraseRootFromParent_Done,
     /* 2354958 */   // Label 32799: @2354958
     /* 2354958 */   GIM_Reject,
     /* 2354959 */ // Label 32797: @2354959
     /* 2354959 */ GIM_Reject,
     /* 2354960 */ // Label 32792: @2354960
     /* 2354960 */ GIM_Try, /*On fail goto*//*Label 32800*/ GIMT_Encode4(2355025),
     /* 2354965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2354968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2354972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2354976 */   GIM_Try, /*On fail goto*//*Label 32801*/ GIMT_Encode4(2354992), // Rule ID 1726 //
     /* 2354981 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2354981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2354984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354991 */     // GIR_Coverage, 1726,
     /* 2354991 */     GIR_EraseRootFromParent_Done,
     /* 2354992 */   // Label 32801: @2354992
     /* 2354992 */   GIM_Try, /*On fail goto*//*Label 32802*/ GIMT_Encode4(2355008), // Rule ID 1727 //
     /* 2354997 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2354997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2355000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355007 */     // GIR_Coverage, 1727,
     /* 2355007 */     GIR_EraseRootFromParent_Done,
     /* 2355008 */   // Label 32802: @2355008
     /* 2355008 */   GIM_Try, /*On fail goto*//*Label 32803*/ GIMT_Encode4(2355024), // Rule ID 1728 //
     /* 2355013 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2355013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2355016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355023 */     // GIR_Coverage, 1728,
     /* 2355023 */     GIR_EraseRootFromParent_Done,
     /* 2355024 */   // Label 32803: @2355024
     /* 2355024 */   GIM_Reject,
     /* 2355025 */ // Label 32800: @2355025
     /* 2355025 */ GIM_Reject,
     /* 2355026 */ // Label 32793: @2355026
     /* 2355026 */ GIM_Reject,
     /* 2355027 */ // Label 74: @2355027
     /* 2355027 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32822*/ GIMT_Encode4(2357111),
     /* 2355038 */ /*GILLT_s16*//*Label 32804*/ GIMT_Encode4(2355158),
     /* 2355042 */ /*GILLT_s32*//*Label 32805*/ GIMT_Encode4(2355225),
     /* 2355046 */ /*GILLT_s64*//*Label 32806*/ GIMT_Encode4(2355292), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355058 */ /*GILLT_nxv1s16*//*Label 32807*/ GIMT_Encode4(2355386),
     /* 2355062 */ /*GILLT_nxv1s32*//*Label 32808*/ GIMT_Encode4(2355501),
     /* 2355066 */ /*GILLT_nxv1s64*//*Label 32809*/ GIMT_Encode4(2355616), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355078 */ /*GILLT_nxv2s16*//*Label 32810*/ GIMT_Encode4(2355731),
     /* 2355082 */ /*GILLT_nxv2s32*//*Label 32811*/ GIMT_Encode4(2355846),
     /* 2355086 */ /*GILLT_nxv2s64*//*Label 32812*/ GIMT_Encode4(2355961), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355098 */ /*GILLT_nxv4s16*//*Label 32813*/ GIMT_Encode4(2356076),
     /* 2355102 */ /*GILLT_nxv4s32*//*Label 32814*/ GIMT_Encode4(2356191),
     /* 2355106 */ /*GILLT_nxv4s64*//*Label 32815*/ GIMT_Encode4(2356306), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355118 */ /*GILLT_nxv8s16*//*Label 32816*/ GIMT_Encode4(2356421),
     /* 2355122 */ /*GILLT_nxv8s32*//*Label 32817*/ GIMT_Encode4(2356536),
     /* 2355126 */ /*GILLT_nxv8s64*//*Label 32818*/ GIMT_Encode4(2356651), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355138 */ /*GILLT_nxv16s16*//*Label 32819*/ GIMT_Encode4(2356766),
     /* 2355142 */ /*GILLT_nxv16s32*//*Label 32820*/ GIMT_Encode4(2356881), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2355154 */ /*GILLT_nxv32s16*//*Label 32821*/ GIMT_Encode4(2356996),
     /* 2355158 */ // Label 32804: @2355158
     /* 2355158 */ GIM_Try, /*On fail goto*//*Label 32823*/ GIMT_Encode4(2355224),
     /* 2355163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2355166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2355169 */   GIM_Try, /*On fail goto*//*Label 32824*/ GIMT_Encode4(2355196), // Rule ID 2050 //
     /* 2355174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2355177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2355189 */     // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2355189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2355194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355195 */     // GIR_Coverage, 2050,
     /* 2355195 */     GIR_Done,
     /* 2355196 */   // Label 32824: @2355196
     /* 2355196 */   GIM_Try, /*On fail goto*//*Label 32825*/ GIMT_Encode4(2355223), // Rule ID 2051 //
     /* 2355201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2355204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2355216 */     // (fminnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2355216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2355221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355222 */     // GIR_Coverage, 2051,
     /* 2355222 */     GIR_Done,
     /* 2355223 */   // Label 32825: @2355223
     /* 2355223 */   GIM_Reject,
     /* 2355224 */ // Label 32823: @2355224
     /* 2355224 */ GIM_Reject,
     /* 2355225 */ // Label 32805: @2355225
     /* 2355225 */ GIM_Try, /*On fail goto*//*Label 32826*/ GIMT_Encode4(2355291),
     /* 2355230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2355233 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2355236 */   GIM_Try, /*On fail goto*//*Label 32827*/ GIMT_Encode4(2355263), // Rule ID 1337 //
     /* 2355241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2355244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2355256 */     // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2355256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2355261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355262 */     // GIR_Coverage, 1337,
     /* 2355262 */     GIR_Done,
     /* 2355263 */   // Label 32827: @2355263
     /* 2355263 */   GIM_Try, /*On fail goto*//*Label 32828*/ GIMT_Encode4(2355290), // Rule ID 1338 //
     /* 2355268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2355271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2355283 */     // (fminnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2355283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2355288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355289 */     // GIR_Coverage, 1338,
     /* 2355289 */     GIR_Done,
     /* 2355290 */   // Label 32828: @2355290
     /* 2355290 */   GIM_Reject,
     /* 2355291 */ // Label 32826: @2355291
     /* 2355291 */ GIM_Reject,
     /* 2355292 */ // Label 32806: @2355292
     /* 2355292 */ GIM_Try, /*On fail goto*//*Label 32829*/ GIMT_Encode4(2355385),
     /* 2355297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2355300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2355303 */   GIM_Try, /*On fail goto*//*Label 32830*/ GIMT_Encode4(2355330), // Rule ID 1708 //
     /* 2355308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2355311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2355323 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2355323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2355328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355329 */     // GIR_Coverage, 1708,
     /* 2355329 */     GIR_Done,
     /* 2355330 */   // Label 32830: @2355330
     /* 2355330 */   GIM_Try, /*On fail goto*//*Label 32831*/ GIMT_Encode4(2355357), // Rule ID 1709 //
     /* 2355335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2355338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2355350 */     // (fminnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2355350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2355355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355356 */     // GIR_Coverage, 1709,
     /* 2355356 */     GIR_Done,
     /* 2355357 */   // Label 32831: @2355357
     /* 2355357 */   GIM_Try, /*On fail goto*//*Label 32832*/ GIMT_Encode4(2355384), // Rule ID 1710 //
     /* 2355362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2355365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2355377 */     // (fminnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2355377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2355382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355383 */     // GIR_Coverage, 1710,
     /* 2355383 */     GIR_Done,
     /* 2355384 */   // Label 32832: @2355384
     /* 2355384 */   GIM_Reject,
     /* 2355385 */ // Label 32829: @2355385
     /* 2355385 */ GIM_Reject,
     /* 2355386 */ // Label 32807: @2355386
     /* 2355386 */ GIM_Try, /*On fail goto*//*Label 32833*/ GIMT_Encode4(2355500),
     /* 2355391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2355394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2355397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355409 */   GIM_Try, /*On fail goto*//*Label 32834*/ GIMT_Encode4(2355454), // Rule ID 45750 //
     /* 2355414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2355417 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2355420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2355434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355453 */     // GIR_Coverage, 45750,
     /* 2355453 */     GIR_EraseRootFromParent_Done,
     /* 2355454 */   // Label 32834: @2355454
     /* 2355454 */   GIM_Try, /*On fail goto*//*Label 32835*/ GIMT_Encode4(2355499), // Rule ID 45751 //
     /* 2355459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2355462 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2355465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2355479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355498 */     // GIR_Coverage, 45751,
     /* 2355498 */     GIR_EraseRootFromParent_Done,
     /* 2355499 */   // Label 32835: @2355499
     /* 2355499 */   GIM_Reject,
     /* 2355500 */ // Label 32833: @2355500
     /* 2355500 */ GIM_Reject,
     /* 2355501 */ // Label 32808: @2355501
     /* 2355501 */ GIM_Try, /*On fail goto*//*Label 32836*/ GIMT_Encode4(2355615),
     /* 2355506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2355509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2355512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355524 */   GIM_Try, /*On fail goto*//*Label 32837*/ GIMT_Encode4(2355569), // Rule ID 56540 //
     /* 2355529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2355532 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2355535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2355549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355568 */     // GIR_Coverage, 56540,
     /* 2355568 */     GIR_EraseRootFromParent_Done,
     /* 2355569 */   // Label 32837: @2355569
     /* 2355569 */   GIM_Try, /*On fail goto*//*Label 32838*/ GIMT_Encode4(2355614), // Rule ID 56541 //
     /* 2355574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2355577 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2355580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2355594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355613 */     // GIR_Coverage, 56541,
     /* 2355613 */     GIR_EraseRootFromParent_Done,
     /* 2355614 */   // Label 32838: @2355614
     /* 2355614 */   GIM_Reject,
     /* 2355615 */ // Label 32836: @2355615
     /* 2355615 */ GIM_Reject,
     /* 2355616 */ // Label 32809: @2355616
     /* 2355616 */ GIM_Try, /*On fail goto*//*Label 32839*/ GIMT_Encode4(2355730),
     /* 2355621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2355624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2355627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355639 */   GIM_Try, /*On fail goto*//*Label 32840*/ GIMT_Encode4(2355684), // Rule ID 56558 //
     /* 2355644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2355647 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2355650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2355664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355683 */     // GIR_Coverage, 56558,
     /* 2355683 */     GIR_EraseRootFromParent_Done,
     /* 2355684 */   // Label 32840: @2355684
     /* 2355684 */   GIM_Try, /*On fail goto*//*Label 32841*/ GIMT_Encode4(2355729), // Rule ID 56559 //
     /* 2355689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2355692 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2355695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2355709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355728 */     // GIR_Coverage, 56559,
     /* 2355728 */     GIR_EraseRootFromParent_Done,
     /* 2355729 */   // Label 32841: @2355729
     /* 2355729 */   GIM_Reject,
     /* 2355730 */ // Label 32839: @2355730
     /* 2355730 */ GIM_Reject,
     /* 2355731 */ // Label 32810: @2355731
     /* 2355731 */ GIM_Try, /*On fail goto*//*Label 32842*/ GIMT_Encode4(2355845),
     /* 2355736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2355739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2355742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355754 */   GIM_Try, /*On fail goto*//*Label 32843*/ GIMT_Encode4(2355799), // Rule ID 56534 //
     /* 2355759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2355762 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2355765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2355779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355798 */     // GIR_Coverage, 56534,
     /* 2355798 */     GIR_EraseRootFromParent_Done,
     /* 2355799 */   // Label 32843: @2355799
     /* 2355799 */   GIM_Try, /*On fail goto*//*Label 32844*/ GIMT_Encode4(2355844), // Rule ID 56535 //
     /* 2355804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2355807 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2355810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2355824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355843 */     // GIR_Coverage, 56535,
     /* 2355843 */     GIR_EraseRootFromParent_Done,
     /* 2355844 */   // Label 32844: @2355844
     /* 2355844 */   GIM_Reject,
     /* 2355845 */ // Label 32842: @2355845
     /* 2355845 */ GIM_Reject,
     /* 2355846 */ // Label 32811: @2355846
     /* 2355846 */ GIM_Try, /*On fail goto*//*Label 32845*/ GIMT_Encode4(2355960),
     /* 2355851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2355854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2355857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355869 */   GIM_Try, /*On fail goto*//*Label 32846*/ GIMT_Encode4(2355914), // Rule ID 56552 //
     /* 2355874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2355877 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2355880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2355894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355913 */     // GIR_Coverage, 56552,
     /* 2355913 */     GIR_EraseRootFromParent_Done,
     /* 2355914 */   // Label 32846: @2355914
     /* 2355914 */   GIM_Try, /*On fail goto*//*Label 32847*/ GIMT_Encode4(2355959), // Rule ID 56553 //
     /* 2355919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2355922 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2355925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2355939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355958 */     // GIR_Coverage, 56553,
     /* 2355958 */     GIR_EraseRootFromParent_Done,
     /* 2355959 */   // Label 32847: @2355959
     /* 2355959 */   GIM_Reject,
     /* 2355960 */ // Label 32845: @2355960
     /* 2355960 */ GIM_Reject,
     /* 2355961 */ // Label 32812: @2355961
     /* 2355961 */ GIM_Try, /*On fail goto*//*Label 32848*/ GIMT_Encode4(2356075),
     /* 2355966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2355969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2355972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355984 */   GIM_Try, /*On fail goto*//*Label 32849*/ GIMT_Encode4(2356029), // Rule ID 56600 //
     /* 2355989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2355992 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2355995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2356009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356028 */     // GIR_Coverage, 56600,
     /* 2356028 */     GIR_EraseRootFromParent_Done,
     /* 2356029 */   // Label 32849: @2356029
     /* 2356029 */   GIM_Try, /*On fail goto*//*Label 32850*/ GIMT_Encode4(2356074), // Rule ID 56601 //
     /* 2356034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2356037 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2356040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2356054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356073 */     // GIR_Coverage, 56601,
     /* 2356073 */     GIR_EraseRootFromParent_Done,
     /* 2356074 */   // Label 32850: @2356074
     /* 2356074 */   GIM_Reject,
     /* 2356075 */ // Label 32848: @2356075
     /* 2356075 */ GIM_Reject,
     /* 2356076 */ // Label 32813: @2356076
     /* 2356076 */ GIM_Try, /*On fail goto*//*Label 32851*/ GIMT_Encode4(2356190),
     /* 2356081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2356084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2356087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356099 */   GIM_Try, /*On fail goto*//*Label 32852*/ GIMT_Encode4(2356144), // Rule ID 56546 //
     /* 2356104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2356107 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2356110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2356124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356143 */     // GIR_Coverage, 56546,
     /* 2356143 */     GIR_EraseRootFromParent_Done,
     /* 2356144 */   // Label 32852: @2356144
     /* 2356144 */   GIM_Try, /*On fail goto*//*Label 32853*/ GIMT_Encode4(2356189), // Rule ID 56547 //
     /* 2356149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2356152 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2356155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2356169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356188 */     // GIR_Coverage, 56547,
     /* 2356188 */     GIR_EraseRootFromParent_Done,
     /* 2356189 */   // Label 32853: @2356189
     /* 2356189 */   GIM_Reject,
     /* 2356190 */ // Label 32851: @2356190
     /* 2356190 */ GIM_Reject,
     /* 2356191 */ // Label 32814: @2356191
     /* 2356191 */ GIM_Try, /*On fail goto*//*Label 32854*/ GIMT_Encode4(2356305),
     /* 2356196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2356199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2356202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356214 */   GIM_Try, /*On fail goto*//*Label 32855*/ GIMT_Encode4(2356259), // Rule ID 56582 //
     /* 2356219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2356222 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2356225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2356239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356258 */     // GIR_Coverage, 56582,
     /* 2356258 */     GIR_EraseRootFromParent_Done,
     /* 2356259 */   // Label 32855: @2356259
     /* 2356259 */   GIM_Try, /*On fail goto*//*Label 32856*/ GIMT_Encode4(2356304), // Rule ID 56583 //
     /* 2356264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2356267 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2356270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2356284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356303 */     // GIR_Coverage, 56583,
     /* 2356303 */     GIR_EraseRootFromParent_Done,
     /* 2356304 */   // Label 32856: @2356304
     /* 2356304 */   GIM_Reject,
     /* 2356305 */ // Label 32854: @2356305
     /* 2356305 */ GIM_Reject,
     /* 2356306 */ // Label 32815: @2356306
     /* 2356306 */ GIM_Try, /*On fail goto*//*Label 32857*/ GIMT_Encode4(2356420),
     /* 2356311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2356314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2356317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356329 */   GIM_Try, /*On fail goto*//*Label 32858*/ GIMT_Encode4(2356374), // Rule ID 56606 //
     /* 2356334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2356337 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2356340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2356354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356373 */     // GIR_Coverage, 56606,
     /* 2356373 */     GIR_EraseRootFromParent_Done,
     /* 2356374 */   // Label 32858: @2356374
     /* 2356374 */   GIM_Try, /*On fail goto*//*Label 32859*/ GIMT_Encode4(2356419), // Rule ID 56607 //
     /* 2356379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2356382 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2356385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2356399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356418 */     // GIR_Coverage, 56607,
     /* 2356418 */     GIR_EraseRootFromParent_Done,
     /* 2356419 */   // Label 32859: @2356419
     /* 2356419 */   GIM_Reject,
     /* 2356420 */ // Label 32857: @2356420
     /* 2356420 */ GIM_Reject,
     /* 2356421 */ // Label 32816: @2356421
     /* 2356421 */ GIM_Try, /*On fail goto*//*Label 32860*/ GIMT_Encode4(2356535),
     /* 2356426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2356429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2356432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2356444 */   GIM_Try, /*On fail goto*//*Label 32861*/ GIMT_Encode4(2356489), // Rule ID 56564 //
     /* 2356449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2356452 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2356455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2356469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356488 */     // GIR_Coverage, 56564,
     /* 2356488 */     GIR_EraseRootFromParent_Done,
     /* 2356489 */   // Label 32861: @2356489
     /* 2356489 */   GIM_Try, /*On fail goto*//*Label 32862*/ GIMT_Encode4(2356534), // Rule ID 56565 //
     /* 2356494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2356497 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2356500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2356514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356533 */     // GIR_Coverage, 56565,
     /* 2356533 */     GIR_EraseRootFromParent_Done,
     /* 2356534 */   // Label 32862: @2356534
     /* 2356534 */   GIM_Reject,
     /* 2356535 */ // Label 32860: @2356535
     /* 2356535 */ GIM_Reject,
     /* 2356536 */ // Label 32817: @2356536
     /* 2356536 */ GIM_Try, /*On fail goto*//*Label 32863*/ GIMT_Encode4(2356650),
     /* 2356541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2356544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2356547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356559 */   GIM_Try, /*On fail goto*//*Label 32864*/ GIMT_Encode4(2356604), // Rule ID 56588 //
     /* 2356564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2356567 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2356570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2356584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356603 */     // GIR_Coverage, 56588,
     /* 2356603 */     GIR_EraseRootFromParent_Done,
     /* 2356604 */   // Label 32864: @2356604
     /* 2356604 */   GIM_Try, /*On fail goto*//*Label 32865*/ GIMT_Encode4(2356649), // Rule ID 56589 //
     /* 2356609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2356612 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2356615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2356629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356648 */     // GIR_Coverage, 56589,
     /* 2356648 */     GIR_EraseRootFromParent_Done,
     /* 2356649 */   // Label 32865: @2356649
     /* 2356649 */   GIM_Reject,
     /* 2356650 */ // Label 32863: @2356650
     /* 2356650 */ GIM_Reject,
     /* 2356651 */ // Label 32818: @2356651
     /* 2356651 */ GIM_Try, /*On fail goto*//*Label 32866*/ GIMT_Encode4(2356765),
     /* 2356656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2356659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2356662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356674 */   GIM_Try, /*On fail goto*//*Label 32867*/ GIMT_Encode4(2356719), // Rule ID 56612 //
     /* 2356679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2356682 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2356685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2356699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356718 */     // GIR_Coverage, 56612,
     /* 2356718 */     GIR_EraseRootFromParent_Done,
     /* 2356719 */   // Label 32867: @2356719
     /* 2356719 */   GIM_Try, /*On fail goto*//*Label 32868*/ GIMT_Encode4(2356764), // Rule ID 56613 //
     /* 2356724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2356727 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2356730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2356744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2356759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356763 */     // GIR_Coverage, 56613,
     /* 2356763 */     GIR_EraseRootFromParent_Done,
     /* 2356764 */   // Label 32868: @2356764
     /* 2356764 */   GIM_Reject,
     /* 2356765 */ // Label 32866: @2356765
     /* 2356765 */ GIM_Reject,
     /* 2356766 */ // Label 32819: @2356766
     /* 2356766 */ GIM_Try, /*On fail goto*//*Label 32869*/ GIMT_Encode4(2356880),
     /* 2356771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2356774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2356777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356789 */   GIM_Try, /*On fail goto*//*Label 32870*/ GIMT_Encode4(2356834), // Rule ID 56570 //
     /* 2356794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2356797 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2356800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2356814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356833 */     // GIR_Coverage, 56570,
     /* 2356833 */     GIR_EraseRootFromParent_Done,
     /* 2356834 */   // Label 32870: @2356834
     /* 2356834 */   GIM_Try, /*On fail goto*//*Label 32871*/ GIMT_Encode4(2356879), // Rule ID 56571 //
     /* 2356839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2356842 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2356845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2356859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356878 */     // GIR_Coverage, 56571,
     /* 2356878 */     GIR_EraseRootFromParent_Done,
     /* 2356879 */   // Label 32871: @2356879
     /* 2356879 */   GIM_Reject,
     /* 2356880 */ // Label 32869: @2356880
     /* 2356880 */ GIM_Reject,
     /* 2356881 */ // Label 32820: @2356881
     /* 2356881 */ GIM_Try, /*On fail goto*//*Label 32872*/ GIMT_Encode4(2356995),
     /* 2356886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2356889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2356892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356904 */   GIM_Try, /*On fail goto*//*Label 32873*/ GIMT_Encode4(2356949), // Rule ID 56594 //
     /* 2356909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2356912 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2356915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2356929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356948 */     // GIR_Coverage, 56594,
     /* 2356948 */     GIR_EraseRootFromParent_Done,
     /* 2356949 */   // Label 32873: @2356949
     /* 2356949 */   GIM_Try, /*On fail goto*//*Label 32874*/ GIMT_Encode4(2356994), // Rule ID 56595 //
     /* 2356954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2356957 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2356960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2356974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356993 */     // GIR_Coverage, 56595,
     /* 2356993 */     GIR_EraseRootFromParent_Done,
     /* 2356994 */   // Label 32874: @2356994
     /* 2356994 */   GIM_Reject,
     /* 2356995 */ // Label 32872: @2356995
     /* 2356995 */ GIM_Reject,
     /* 2356996 */ // Label 32821: @2356996
     /* 2356996 */ GIM_Try, /*On fail goto*//*Label 32875*/ GIMT_Encode4(2357110),
     /* 2357001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2357004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2357007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2357019 */   GIM_Try, /*On fail goto*//*Label 32876*/ GIMT_Encode4(2357064), // Rule ID 56576 //
     /* 2357024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357027 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2357030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2357044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357063 */     // GIR_Coverage, 56576,
     /* 2357063 */     GIR_EraseRootFromParent_Done,
     /* 2357064 */   // Label 32876: @2357064
     /* 2357064 */   GIM_Try, /*On fail goto*//*Label 32877*/ GIMT_Encode4(2357109), // Rule ID 56577 //
     /* 2357069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357072 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2357075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2357089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357108 */     // GIR_Coverage, 56577,
     /* 2357108 */     GIR_EraseRootFromParent_Done,
     /* 2357109 */   // Label 32877: @2357109
     /* 2357109 */   GIM_Reject,
     /* 2357110 */ // Label 32875: @2357110
     /* 2357110 */ GIM_Reject,
     /* 2357111 */ // Label 32822: @2357111
     /* 2357111 */ GIM_Reject,
     /* 2357112 */ // Label 75: @2357112
     /* 2357112 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32896*/ GIMT_Encode4(2359196),
     /* 2357123 */ /*GILLT_s16*//*Label 32878*/ GIMT_Encode4(2357243),
     /* 2357127 */ /*GILLT_s32*//*Label 32879*/ GIMT_Encode4(2357310),
     /* 2357131 */ /*GILLT_s64*//*Label 32880*/ GIMT_Encode4(2357377), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357143 */ /*GILLT_nxv1s16*//*Label 32881*/ GIMT_Encode4(2357471),
     /* 2357147 */ /*GILLT_nxv1s32*//*Label 32882*/ GIMT_Encode4(2357586),
     /* 2357151 */ /*GILLT_nxv1s64*//*Label 32883*/ GIMT_Encode4(2357701), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357163 */ /*GILLT_nxv2s16*//*Label 32884*/ GIMT_Encode4(2357816),
     /* 2357167 */ /*GILLT_nxv2s32*//*Label 32885*/ GIMT_Encode4(2357931),
     /* 2357171 */ /*GILLT_nxv2s64*//*Label 32886*/ GIMT_Encode4(2358046), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357183 */ /*GILLT_nxv4s16*//*Label 32887*/ GIMT_Encode4(2358161),
     /* 2357187 */ /*GILLT_nxv4s32*//*Label 32888*/ GIMT_Encode4(2358276),
     /* 2357191 */ /*GILLT_nxv4s64*//*Label 32889*/ GIMT_Encode4(2358391), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357203 */ /*GILLT_nxv8s16*//*Label 32890*/ GIMT_Encode4(2358506),
     /* 2357207 */ /*GILLT_nxv8s32*//*Label 32891*/ GIMT_Encode4(2358621),
     /* 2357211 */ /*GILLT_nxv8s64*//*Label 32892*/ GIMT_Encode4(2358736), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357223 */ /*GILLT_nxv16s16*//*Label 32893*/ GIMT_Encode4(2358851),
     /* 2357227 */ /*GILLT_nxv16s32*//*Label 32894*/ GIMT_Encode4(2358966), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2357239 */ /*GILLT_nxv32s16*//*Label 32895*/ GIMT_Encode4(2359081),
     /* 2357243 */ // Label 32878: @2357243
     /* 2357243 */ GIM_Try, /*On fail goto*//*Label 32897*/ GIMT_Encode4(2357309),
     /* 2357248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2357251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2357254 */   GIM_Try, /*On fail goto*//*Label 32898*/ GIMT_Encode4(2357281), // Rule ID 2052 //
     /* 2357259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2357262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2357274 */     // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2357274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2357279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357280 */     // GIR_Coverage, 2052,
     /* 2357280 */     GIR_Done,
     /* 2357281 */   // Label 32898: @2357281
     /* 2357281 */   GIM_Try, /*On fail goto*//*Label 32899*/ GIMT_Encode4(2357308), // Rule ID 2053 //
     /* 2357286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2357289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2357301 */     // (fmaxnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2357301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2357306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357307 */     // GIR_Coverage, 2053,
     /* 2357307 */     GIR_Done,
     /* 2357308 */   // Label 32899: @2357308
     /* 2357308 */   GIM_Reject,
     /* 2357309 */ // Label 32897: @2357309
     /* 2357309 */ GIM_Reject,
     /* 2357310 */ // Label 32879: @2357310
     /* 2357310 */ GIM_Try, /*On fail goto*//*Label 32900*/ GIMT_Encode4(2357376),
     /* 2357315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2357318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2357321 */   GIM_Try, /*On fail goto*//*Label 32901*/ GIMT_Encode4(2357348), // Rule ID 1339 //
     /* 2357326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2357329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2357341 */     // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2357341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2357346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357347 */     // GIR_Coverage, 1339,
     /* 2357347 */     GIR_Done,
     /* 2357348 */   // Label 32901: @2357348
     /* 2357348 */   GIM_Try, /*On fail goto*//*Label 32902*/ GIMT_Encode4(2357375), // Rule ID 1340 //
     /* 2357353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2357356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2357360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2357364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2357368 */     // (fmaxnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2357368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2357373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357374 */     // GIR_Coverage, 1340,
     /* 2357374 */     GIR_Done,
     /* 2357375 */   // Label 32902: @2357375
     /* 2357375 */   GIM_Reject,
     /* 2357376 */ // Label 32900: @2357376
     /* 2357376 */ GIM_Reject,
     /* 2357377 */ // Label 32880: @2357377
     /* 2357377 */ GIM_Try, /*On fail goto*//*Label 32903*/ GIMT_Encode4(2357470),
     /* 2357382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2357385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2357388 */   GIM_Try, /*On fail goto*//*Label 32904*/ GIMT_Encode4(2357415), // Rule ID 1711 //
     /* 2357393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2357396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2357408 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2357408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2357413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357414 */     // GIR_Coverage, 1711,
     /* 2357414 */     GIR_Done,
     /* 2357415 */   // Label 32904: @2357415
     /* 2357415 */   GIM_Try, /*On fail goto*//*Label 32905*/ GIMT_Encode4(2357442), // Rule ID 1712 //
     /* 2357420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2357423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2357435 */     // (fmaxnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2357435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2357440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357441 */     // GIR_Coverage, 1712,
     /* 2357441 */     GIR_Done,
     /* 2357442 */   // Label 32905: @2357442
     /* 2357442 */   GIM_Try, /*On fail goto*//*Label 32906*/ GIMT_Encode4(2357469), // Rule ID 1713 //
     /* 2357447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2357450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2357462 */     // (fmaxnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2357462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2357467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357468 */     // GIR_Coverage, 1713,
     /* 2357468 */     GIR_Done,
     /* 2357469 */   // Label 32906: @2357469
     /* 2357469 */   GIM_Reject,
     /* 2357470 */ // Label 32903: @2357470
     /* 2357470 */ GIM_Reject,
     /* 2357471 */ // Label 32881: @2357471
     /* 2357471 */ GIM_Try, /*On fail goto*//*Label 32907*/ GIMT_Encode4(2357585),
     /* 2357476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2357482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357494 */   GIM_Try, /*On fail goto*//*Label 32908*/ GIMT_Encode4(2357539), // Rule ID 56618 //
     /* 2357499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357502 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2357519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357538 */     // GIR_Coverage, 56618,
     /* 2357538 */     GIR_EraseRootFromParent_Done,
     /* 2357539 */   // Label 32908: @2357539
     /* 2357539 */   GIM_Try, /*On fail goto*//*Label 32909*/ GIMT_Encode4(2357584), // Rule ID 56619 //
     /* 2357544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357547 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2357564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357583 */     // GIR_Coverage, 56619,
     /* 2357583 */     GIR_EraseRootFromParent_Done,
     /* 2357584 */   // Label 32909: @2357584
     /* 2357584 */   GIM_Reject,
     /* 2357585 */ // Label 32907: @2357585
     /* 2357585 */ GIM_Reject,
     /* 2357586 */ // Label 32882: @2357586
     /* 2357586 */ GIM_Try, /*On fail goto*//*Label 32910*/ GIMT_Encode4(2357700),
     /* 2357591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2357594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2357597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357609 */   GIM_Try, /*On fail goto*//*Label 32911*/ GIMT_Encode4(2357654), // Rule ID 56630 //
     /* 2357614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2357617 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2357634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357653 */     // GIR_Coverage, 56630,
     /* 2357653 */     GIR_EraseRootFromParent_Done,
     /* 2357654 */   // Label 32911: @2357654
     /* 2357654 */   GIM_Try, /*On fail goto*//*Label 32912*/ GIMT_Encode4(2357699), // Rule ID 56631 //
     /* 2357659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2357662 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2357679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357698 */     // GIR_Coverage, 56631,
     /* 2357698 */     GIR_EraseRootFromParent_Done,
     /* 2357699 */   // Label 32912: @2357699
     /* 2357699 */   GIM_Reject,
     /* 2357700 */ // Label 32910: @2357700
     /* 2357700 */ GIM_Reject,
     /* 2357701 */ // Label 32883: @2357701
     /* 2357701 */ GIM_Try, /*On fail goto*//*Label 32913*/ GIMT_Encode4(2357815),
     /* 2357706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2357709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2357712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357724 */   GIM_Try, /*On fail goto*//*Label 32914*/ GIMT_Encode4(2357769), // Rule ID 56648 //
     /* 2357729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2357732 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2357749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357768 */     // GIR_Coverage, 56648,
     /* 2357768 */     GIR_EraseRootFromParent_Done,
     /* 2357769 */   // Label 32914: @2357769
     /* 2357769 */   GIM_Try, /*On fail goto*//*Label 32915*/ GIMT_Encode4(2357814), // Rule ID 56649 //
     /* 2357774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2357777 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2357794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357813 */     // GIR_Coverage, 56649,
     /* 2357813 */     GIR_EraseRootFromParent_Done,
     /* 2357814 */   // Label 32915: @2357814
     /* 2357814 */   GIM_Reject,
     /* 2357815 */ // Label 32913: @2357815
     /* 2357815 */ GIM_Reject,
     /* 2357816 */ // Label 32884: @2357816
     /* 2357816 */ GIM_Try, /*On fail goto*//*Label 32916*/ GIMT_Encode4(2357930),
     /* 2357821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2357824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2357827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357839 */   GIM_Try, /*On fail goto*//*Label 32917*/ GIMT_Encode4(2357884), // Rule ID 56624 //
     /* 2357844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2357847 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2357850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2357864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357883 */     // GIR_Coverage, 56624,
     /* 2357883 */     GIR_EraseRootFromParent_Done,
     /* 2357884 */   // Label 32917: @2357884
     /* 2357884 */   GIM_Try, /*On fail goto*//*Label 32918*/ GIMT_Encode4(2357929), // Rule ID 56625 //
     /* 2357889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2357892 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2357895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2357909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357928 */     // GIR_Coverage, 56625,
     /* 2357928 */     GIR_EraseRootFromParent_Done,
     /* 2357929 */   // Label 32918: @2357929
     /* 2357929 */   GIM_Reject,
     /* 2357930 */ // Label 32916: @2357930
     /* 2357930 */ GIM_Reject,
     /* 2357931 */ // Label 32885: @2357931
     /* 2357931 */ GIM_Try, /*On fail goto*//*Label 32919*/ GIMT_Encode4(2358045),
     /* 2357936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2357939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2357942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357954 */   GIM_Try, /*On fail goto*//*Label 32920*/ GIMT_Encode4(2357999), // Rule ID 56642 //
     /* 2357959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2357962 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2357965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2357979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357984 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357998 */     // GIR_Coverage, 56642,
     /* 2357998 */     GIR_EraseRootFromParent_Done,
     /* 2357999 */   // Label 32920: @2357999
     /* 2357999 */   GIM_Try, /*On fail goto*//*Label 32921*/ GIMT_Encode4(2358044), // Rule ID 56643 //
     /* 2358004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358007 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2358010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2358024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358043 */     // GIR_Coverage, 56643,
     /* 2358043 */     GIR_EraseRootFromParent_Done,
     /* 2358044 */   // Label 32921: @2358044
     /* 2358044 */   GIM_Reject,
     /* 2358045 */ // Label 32919: @2358045
     /* 2358045 */ GIM_Reject,
     /* 2358046 */ // Label 32886: @2358046
     /* 2358046 */ GIM_Try, /*On fail goto*//*Label 32922*/ GIMT_Encode4(2358160),
     /* 2358051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2358054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2358057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358069 */   GIM_Try, /*On fail goto*//*Label 32923*/ GIMT_Encode4(2358114), // Rule ID 56690 //
     /* 2358074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358077 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2358094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358113 */     // GIR_Coverage, 56690,
     /* 2358113 */     GIR_EraseRootFromParent_Done,
     /* 2358114 */   // Label 32923: @2358114
     /* 2358114 */   GIM_Try, /*On fail goto*//*Label 32924*/ GIMT_Encode4(2358159), // Rule ID 56691 //
     /* 2358119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358122 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2358125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2358139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358158 */     // GIR_Coverage, 56691,
     /* 2358158 */     GIR_EraseRootFromParent_Done,
     /* 2358159 */   // Label 32924: @2358159
     /* 2358159 */   GIM_Reject,
     /* 2358160 */ // Label 32922: @2358160
     /* 2358160 */ GIM_Reject,
     /* 2358161 */ // Label 32887: @2358161
     /* 2358161 */ GIM_Try, /*On fail goto*//*Label 32925*/ GIMT_Encode4(2358275),
     /* 2358166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2358169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2358172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358184 */   GIM_Try, /*On fail goto*//*Label 32926*/ GIMT_Encode4(2358229), // Rule ID 56636 //
     /* 2358189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358192 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2358209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358228 */     // GIR_Coverage, 56636,
     /* 2358228 */     GIR_EraseRootFromParent_Done,
     /* 2358229 */   // Label 32926: @2358229
     /* 2358229 */   GIM_Try, /*On fail goto*//*Label 32927*/ GIMT_Encode4(2358274), // Rule ID 56637 //
     /* 2358234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358237 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2358254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358273 */     // GIR_Coverage, 56637,
     /* 2358273 */     GIR_EraseRootFromParent_Done,
     /* 2358274 */   // Label 32927: @2358274
     /* 2358274 */   GIM_Reject,
     /* 2358275 */ // Label 32925: @2358275
     /* 2358275 */ GIM_Reject,
     /* 2358276 */ // Label 32888: @2358276
     /* 2358276 */ GIM_Try, /*On fail goto*//*Label 32928*/ GIMT_Encode4(2358390),
     /* 2358281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2358284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2358287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358299 */   GIM_Try, /*On fail goto*//*Label 32929*/ GIMT_Encode4(2358344), // Rule ID 56672 //
     /* 2358304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358307 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2358310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2358324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358343 */     // GIR_Coverage, 56672,
     /* 2358343 */     GIR_EraseRootFromParent_Done,
     /* 2358344 */   // Label 32929: @2358344
     /* 2358344 */   GIM_Try, /*On fail goto*//*Label 32930*/ GIMT_Encode4(2358389), // Rule ID 56673 //
     /* 2358349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358352 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2358355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2358369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358388 */     // GIR_Coverage, 56673,
     /* 2358388 */     GIR_EraseRootFromParent_Done,
     /* 2358389 */   // Label 32930: @2358389
     /* 2358389 */   GIM_Reject,
     /* 2358390 */ // Label 32928: @2358390
     /* 2358390 */ GIM_Reject,
     /* 2358391 */ // Label 32889: @2358391
     /* 2358391 */ GIM_Try, /*On fail goto*//*Label 32931*/ GIMT_Encode4(2358505),
     /* 2358396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2358399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2358402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358414 */   GIM_Try, /*On fail goto*//*Label 32932*/ GIMT_Encode4(2358459), // Rule ID 56696 //
     /* 2358419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358422 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2358425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2358439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358458 */     // GIR_Coverage, 56696,
     /* 2358458 */     GIR_EraseRootFromParent_Done,
     /* 2358459 */   // Label 32932: @2358459
     /* 2358459 */   GIM_Try, /*On fail goto*//*Label 32933*/ GIMT_Encode4(2358504), // Rule ID 56697 //
     /* 2358464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358467 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2358470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2358484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358489 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358503 */     // GIR_Coverage, 56697,
     /* 2358503 */     GIR_EraseRootFromParent_Done,
     /* 2358504 */   // Label 32933: @2358504
     /* 2358504 */   GIM_Reject,
     /* 2358505 */ // Label 32931: @2358505
     /* 2358505 */ GIM_Reject,
     /* 2358506 */ // Label 32890: @2358506
     /* 2358506 */ GIM_Try, /*On fail goto*//*Label 32934*/ GIMT_Encode4(2358620),
     /* 2358511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2358514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2358517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358529 */   GIM_Try, /*On fail goto*//*Label 32935*/ GIMT_Encode4(2358574), // Rule ID 56654 //
     /* 2358534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358537 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2358540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2358554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358573 */     // GIR_Coverage, 56654,
     /* 2358573 */     GIR_EraseRootFromParent_Done,
     /* 2358574 */   // Label 32935: @2358574
     /* 2358574 */   GIM_Try, /*On fail goto*//*Label 32936*/ GIMT_Encode4(2358619), // Rule ID 56655 //
     /* 2358579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358582 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2358585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2358599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358618 */     // GIR_Coverage, 56655,
     /* 2358618 */     GIR_EraseRootFromParent_Done,
     /* 2358619 */   // Label 32936: @2358619
     /* 2358619 */   GIM_Reject,
     /* 2358620 */ // Label 32934: @2358620
     /* 2358620 */ GIM_Reject,
     /* 2358621 */ // Label 32891: @2358621
     /* 2358621 */ GIM_Try, /*On fail goto*//*Label 32937*/ GIMT_Encode4(2358735),
     /* 2358626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2358629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2358632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358644 */   GIM_Try, /*On fail goto*//*Label 32938*/ GIMT_Encode4(2358689), // Rule ID 56678 //
     /* 2358649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358652 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2358655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2358669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358688 */     // GIR_Coverage, 56678,
     /* 2358688 */     GIR_EraseRootFromParent_Done,
     /* 2358689 */   // Label 32938: @2358689
     /* 2358689 */   GIM_Try, /*On fail goto*//*Label 32939*/ GIMT_Encode4(2358734), // Rule ID 56679 //
     /* 2358694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2358697 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2358700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2358714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358733 */     // GIR_Coverage, 56679,
     /* 2358733 */     GIR_EraseRootFromParent_Done,
     /* 2358734 */   // Label 32939: @2358734
     /* 2358734 */   GIM_Reject,
     /* 2358735 */ // Label 32937: @2358735
     /* 2358735 */ GIM_Reject,
     /* 2358736 */ // Label 32892: @2358736
     /* 2358736 */ GIM_Try, /*On fail goto*//*Label 32940*/ GIMT_Encode4(2358850),
     /* 2358741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2358744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2358747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358759 */   GIM_Try, /*On fail goto*//*Label 32941*/ GIMT_Encode4(2358804), // Rule ID 56702 //
     /* 2358764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2358767 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2358770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2358784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358803 */     // GIR_Coverage, 56702,
     /* 2358803 */     GIR_EraseRootFromParent_Done,
     /* 2358804 */   // Label 32941: @2358804
     /* 2358804 */   GIM_Try, /*On fail goto*//*Label 32942*/ GIMT_Encode4(2358849), // Rule ID 56703 //
     /* 2358809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2358812 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2358815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2358829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358848 */     // GIR_Coverage, 56703,
     /* 2358848 */     GIR_EraseRootFromParent_Done,
     /* 2358849 */   // Label 32942: @2358849
     /* 2358849 */   GIM_Reject,
     /* 2358850 */ // Label 32940: @2358850
     /* 2358850 */ GIM_Reject,
     /* 2358851 */ // Label 32893: @2358851
     /* 2358851 */ GIM_Try, /*On fail goto*//*Label 32943*/ GIMT_Encode4(2358965),
     /* 2358856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2358859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2358862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358874 */   GIM_Try, /*On fail goto*//*Label 32944*/ GIMT_Encode4(2358919), // Rule ID 56660 //
     /* 2358879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2358882 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2358885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2358899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358918 */     // GIR_Coverage, 56660,
     /* 2358918 */     GIR_EraseRootFromParent_Done,
     /* 2358919 */   // Label 32944: @2358919
     /* 2358919 */   GIM_Try, /*On fail goto*//*Label 32945*/ GIMT_Encode4(2358964), // Rule ID 56661 //
     /* 2358924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2358927 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2358930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2358944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358963 */     // GIR_Coverage, 56661,
     /* 2358963 */     GIR_EraseRootFromParent_Done,
     /* 2358964 */   // Label 32945: @2358964
     /* 2358964 */   GIM_Reject,
     /* 2358965 */ // Label 32943: @2358965
     /* 2358965 */ GIM_Reject,
     /* 2358966 */ // Label 32894: @2358966
     /* 2358966 */ GIM_Try, /*On fail goto*//*Label 32946*/ GIMT_Encode4(2359080),
     /* 2358971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2358974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2358977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358989 */   GIM_Try, /*On fail goto*//*Label 32947*/ GIMT_Encode4(2359034), // Rule ID 56684 //
     /* 2358994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2358997 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2359000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2359014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359033 */     // GIR_Coverage, 56684,
     /* 2359033 */     GIR_EraseRootFromParent_Done,
     /* 2359034 */   // Label 32947: @2359034
     /* 2359034 */   GIM_Try, /*On fail goto*//*Label 32948*/ GIMT_Encode4(2359079), // Rule ID 56685 //
     /* 2359039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359042 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2359045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2359059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359078 */     // GIR_Coverage, 56685,
     /* 2359078 */     GIR_EraseRootFromParent_Done,
     /* 2359079 */   // Label 32948: @2359079
     /* 2359079 */   GIM_Reject,
     /* 2359080 */ // Label 32946: @2359080
     /* 2359080 */ GIM_Reject,
     /* 2359081 */ // Label 32895: @2359081
     /* 2359081 */ GIM_Try, /*On fail goto*//*Label 32949*/ GIMT_Encode4(2359195),
     /* 2359086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2359089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2359092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359104 */   GIM_Try, /*On fail goto*//*Label 32950*/ GIMT_Encode4(2359149), // Rule ID 56666 //
     /* 2359109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359112 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2359115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2359129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359148 */     // GIR_Coverage, 56666,
     /* 2359148 */     GIR_EraseRootFromParent_Done,
     /* 2359149 */   // Label 32950: @2359149
     /* 2359149 */   GIM_Try, /*On fail goto*//*Label 32951*/ GIMT_Encode4(2359194), // Rule ID 56667 //
     /* 2359154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359157 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2359160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2359174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359193 */     // GIR_Coverage, 56667,
     /* 2359193 */     GIR_EraseRootFromParent_Done,
     /* 2359194 */   // Label 32951: @2359194
     /* 2359194 */   GIM_Reject,
     /* 2359195 */ // Label 32949: @2359195
     /* 2359195 */ GIM_Reject,
     /* 2359196 */ // Label 32896: @2359196
     /* 2359196 */ GIM_Reject,
     /* 2359197 */ // Label 76: @2359197
     /* 2359197 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32955*/ GIMT_Encode4(2359322),
     /* 2359208 */ /*GILLT_s16*//*Label 32952*/ GIMT_Encode4(2359220),
     /* 2359212 */ /*GILLT_s32*//*Label 32953*/ GIMT_Encode4(2359254),
     /* 2359216 */ /*GILLT_s64*//*Label 32954*/ GIMT_Encode4(2359288),
     /* 2359220 */ // Label 32952: @2359220
     /* 2359220 */ GIM_Try, /*On fail goto*//*Label 32956*/ GIMT_Encode4(2359253), // Rule ID 2404 //
     /* 2359225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2359228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2359234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359246 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMINM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2359246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_H),
     /* 2359251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359252 */   // GIR_Coverage, 2404,
     /* 2359252 */   GIR_Done,
     /* 2359253 */ // Label 32956: @2359253
     /* 2359253 */ GIM_Reject,
     /* 2359254 */ // Label 32953: @2359254
     /* 2359254 */ GIM_Try, /*On fail goto*//*Label 32957*/ GIMT_Encode4(2359287), // Rule ID 2322 //
     /* 2359259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2359262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2359268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359280 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMINM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2359280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_S),
     /* 2359285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359286 */   // GIR_Coverage, 2322,
     /* 2359286 */   GIR_Done,
     /* 2359287 */ // Label 32957: @2359287
     /* 2359287 */ GIM_Reject,
     /* 2359288 */ // Label 32954: @2359288
     /* 2359288 */ GIM_Try, /*On fail goto*//*Label 32958*/ GIMT_Encode4(2359321), // Rule ID 2362 //
     /* 2359293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2359296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2359302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359314 */   // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMINM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359314 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_D),
     /* 2359319 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359320 */   // GIR_Coverage, 2362,
     /* 2359320 */   GIR_Done,
     /* 2359321 */ // Label 32958: @2359321
     /* 2359321 */ GIM_Reject,
     /* 2359322 */ // Label 32955: @2359322
     /* 2359322 */ GIM_Reject,
     /* 2359323 */ // Label 77: @2359323
     /* 2359323 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32962*/ GIMT_Encode4(2359448),
     /* 2359334 */ /*GILLT_s16*//*Label 32959*/ GIMT_Encode4(2359346),
     /* 2359338 */ /*GILLT_s32*//*Label 32960*/ GIMT_Encode4(2359380),
     /* 2359342 */ /*GILLT_s64*//*Label 32961*/ GIMT_Encode4(2359414),
     /* 2359346 */ // Label 32959: @2359346
     /* 2359346 */ GIM_Try, /*On fail goto*//*Label 32963*/ GIMT_Encode4(2359379), // Rule ID 2405 //
     /* 2359351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2359354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2359360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359372 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAXM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2359372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_H),
     /* 2359377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359378 */   // GIR_Coverage, 2405,
     /* 2359378 */   GIR_Done,
     /* 2359379 */ // Label 32963: @2359379
     /* 2359379 */ GIM_Reject,
     /* 2359380 */ // Label 32960: @2359380
     /* 2359380 */ GIM_Try, /*On fail goto*//*Label 32964*/ GIMT_Encode4(2359413), // Rule ID 2323 //
     /* 2359385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2359388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2359394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359406 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAXM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2359406 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_S),
     /* 2359411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359412 */   // GIR_Coverage, 2323,
     /* 2359412 */   GIR_Done,
     /* 2359413 */ // Label 32964: @2359413
     /* 2359413 */ GIM_Reject,
     /* 2359414 */ // Label 32961: @2359414
     /* 2359414 */ GIM_Try, /*On fail goto*//*Label 32965*/ GIMT_Encode4(2359447), // Rule ID 2363 //
     /* 2359419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2359422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2359428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359440 */   // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAXM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_D),
     /* 2359445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359446 */   // GIR_Coverage, 2363,
     /* 2359446 */   GIR_Done,
     /* 2359447 */ // Label 32965: @2359447
     /* 2359447 */ GIM_Reject,
     /* 2359448 */ // Label 32962: @2359448
     /* 2359448 */ GIM_Reject,
     /* 2359449 */ // Label 78: @2359449
     /* 2359449 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32984*/ GIMT_Encode4(2361533),
     /* 2359460 */ /*GILLT_s16*//*Label 32966*/ GIMT_Encode4(2359580),
     /* 2359464 */ /*GILLT_s32*//*Label 32967*/ GIMT_Encode4(2359647),
     /* 2359468 */ /*GILLT_s64*//*Label 32968*/ GIMT_Encode4(2359714), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359480 */ /*GILLT_nxv1s16*//*Label 32969*/ GIMT_Encode4(2359808),
     /* 2359484 */ /*GILLT_nxv1s32*//*Label 32970*/ GIMT_Encode4(2359923),
     /* 2359488 */ /*GILLT_nxv1s64*//*Label 32971*/ GIMT_Encode4(2360038), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359500 */ /*GILLT_nxv2s16*//*Label 32972*/ GIMT_Encode4(2360153),
     /* 2359504 */ /*GILLT_nxv2s32*//*Label 32973*/ GIMT_Encode4(2360268),
     /* 2359508 */ /*GILLT_nxv2s64*//*Label 32974*/ GIMT_Encode4(2360383), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359520 */ /*GILLT_nxv4s16*//*Label 32975*/ GIMT_Encode4(2360498),
     /* 2359524 */ /*GILLT_nxv4s32*//*Label 32976*/ GIMT_Encode4(2360613),
     /* 2359528 */ /*GILLT_nxv4s64*//*Label 32977*/ GIMT_Encode4(2360728), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359540 */ /*GILLT_nxv8s16*//*Label 32978*/ GIMT_Encode4(2360843),
     /* 2359544 */ /*GILLT_nxv8s32*//*Label 32979*/ GIMT_Encode4(2360958),
     /* 2359548 */ /*GILLT_nxv8s64*//*Label 32980*/ GIMT_Encode4(2361073), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359560 */ /*GILLT_nxv16s16*//*Label 32981*/ GIMT_Encode4(2361188),
     /* 2359564 */ /*GILLT_nxv16s32*//*Label 32982*/ GIMT_Encode4(2361303), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2359576 */ /*GILLT_nxv32s16*//*Label 32983*/ GIMT_Encode4(2361418),
     /* 2359580 */ // Label 32966: @2359580
     /* 2359580 */ GIM_Try, /*On fail goto*//*Label 32985*/ GIMT_Encode4(2359646),
     /* 2359585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2359591 */   GIM_Try, /*On fail goto*//*Label 32986*/ GIMT_Encode4(2359618), // Rule ID 2054 //
     /* 2359596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2359599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359611 */     // (fminimumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2359611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2359616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359617 */     // GIR_Coverage, 2054,
     /* 2359617 */     GIR_Done,
     /* 2359618 */   // Label 32986: @2359618
     /* 2359618 */   GIM_Try, /*On fail goto*//*Label 32987*/ GIMT_Encode4(2359645), // Rule ID 2055 //
     /* 2359623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2359626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2359630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2359634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2359638 */     // (fminimumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2359638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2359643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359644 */     // GIR_Coverage, 2055,
     /* 2359644 */     GIR_Done,
     /* 2359645 */   // Label 32987: @2359645
     /* 2359645 */   GIM_Reject,
     /* 2359646 */ // Label 32985: @2359646
     /* 2359646 */ GIM_Reject,
     /* 2359647 */ // Label 32967: @2359647
     /* 2359647 */ GIM_Try, /*On fail goto*//*Label 32988*/ GIMT_Encode4(2359713),
     /* 2359652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2359658 */   GIM_Try, /*On fail goto*//*Label 32989*/ GIMT_Encode4(2359685), // Rule ID 1341 //
     /* 2359663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2359666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359678 */     // (fminimumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2359678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2359683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359684 */     // GIR_Coverage, 1341,
     /* 2359684 */     GIR_Done,
     /* 2359685 */   // Label 32989: @2359685
     /* 2359685 */   GIM_Try, /*On fail goto*//*Label 32990*/ GIMT_Encode4(2359712), // Rule ID 1342 //
     /* 2359690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2359693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2359697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2359701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2359705 */     // (fminimumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2359705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2359710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359711 */     // GIR_Coverage, 1342,
     /* 2359711 */     GIR_Done,
     /* 2359712 */   // Label 32990: @2359712
     /* 2359712 */   GIM_Reject,
     /* 2359713 */ // Label 32988: @2359713
     /* 2359713 */ GIM_Reject,
     /* 2359714 */ // Label 32968: @2359714
     /* 2359714 */ GIM_Try, /*On fail goto*//*Label 32991*/ GIMT_Encode4(2359807),
     /* 2359719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2359725 */   GIM_Try, /*On fail goto*//*Label 32992*/ GIMT_Encode4(2359752), // Rule ID 1714 //
     /* 2359730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2359733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359745 */     // (fminimumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359745 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2359750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359751 */     // GIR_Coverage, 1714,
     /* 2359751 */     GIR_Done,
     /* 2359752 */   // Label 32992: @2359752
     /* 2359752 */   GIM_Try, /*On fail goto*//*Label 32993*/ GIMT_Encode4(2359779), // Rule ID 1715 //
     /* 2359757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2359760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2359764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2359768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2359772 */     // (fminimumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359772 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2359777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359778 */     // GIR_Coverage, 1715,
     /* 2359778 */     GIR_Done,
     /* 2359779 */   // Label 32993: @2359779
     /* 2359779 */   GIM_Try, /*On fail goto*//*Label 32994*/ GIMT_Encode4(2359806), // Rule ID 1716 //
     /* 2359784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2359787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359799 */     // (fminimumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2359799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2359804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359805 */     // GIR_Coverage, 1716,
     /* 2359805 */     GIR_Done,
     /* 2359806 */   // Label 32994: @2359806
     /* 2359806 */   GIM_Reject,
     /* 2359807 */ // Label 32991: @2359807
     /* 2359807 */ GIM_Reject,
     /* 2359808 */ // Label 32969: @2359808
     /* 2359808 */ GIM_Try, /*On fail goto*//*Label 32995*/ GIMT_Encode4(2359922),
     /* 2359813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2359816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2359819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359831 */   GIM_Try, /*On fail goto*//*Label 32996*/ GIMT_Encode4(2359876), // Rule ID 56708 //
     /* 2359836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2359839 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2359842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2359856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359875 */     // GIR_Coverage, 56708,
     /* 2359875 */     GIR_EraseRootFromParent_Done,
     /* 2359876 */   // Label 32996: @2359876
     /* 2359876 */   GIM_Try, /*On fail goto*//*Label 32997*/ GIMT_Encode4(2359921), // Rule ID 56709 //
     /* 2359881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2359884 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2359887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2359901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359920 */     // GIR_Coverage, 56709,
     /* 2359920 */     GIR_EraseRootFromParent_Done,
     /* 2359921 */   // Label 32997: @2359921
     /* 2359921 */   GIM_Reject,
     /* 2359922 */ // Label 32995: @2359922
     /* 2359922 */ GIM_Reject,
     /* 2359923 */ // Label 32970: @2359923
     /* 2359923 */ GIM_Try, /*On fail goto*//*Label 32998*/ GIMT_Encode4(2360037),
     /* 2359928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2359931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2359934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2359946 */   GIM_Try, /*On fail goto*//*Label 32999*/ GIMT_Encode4(2359991), // Rule ID 56720 //
     /* 2359951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2359954 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2359957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2359971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359990 */     // GIR_Coverage, 56720,
     /* 2359990 */     GIR_EraseRootFromParent_Done,
     /* 2359991 */   // Label 32999: @2359991
     /* 2359991 */   GIM_Try, /*On fail goto*//*Label 33000*/ GIMT_Encode4(2360036), // Rule ID 56721 //
     /* 2359996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2359999 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2360002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2360016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360035 */     // GIR_Coverage, 56721,
     /* 2360035 */     GIR_EraseRootFromParent_Done,
     /* 2360036 */   // Label 33000: @2360036
     /* 2360036 */   GIM_Reject,
     /* 2360037 */ // Label 32998: @2360037
     /* 2360037 */ GIM_Reject,
     /* 2360038 */ // Label 32971: @2360038
     /* 2360038 */ GIM_Try, /*On fail goto*//*Label 33001*/ GIMT_Encode4(2360152),
     /* 2360043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2360046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2360049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360061 */   GIM_Try, /*On fail goto*//*Label 33002*/ GIMT_Encode4(2360106), // Rule ID 56738 //
     /* 2360066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360069 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2360072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2360086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360105 */     // GIR_Coverage, 56738,
     /* 2360105 */     GIR_EraseRootFromParent_Done,
     /* 2360106 */   // Label 33002: @2360106
     /* 2360106 */   GIM_Try, /*On fail goto*//*Label 33003*/ GIMT_Encode4(2360151), // Rule ID 56739 //
     /* 2360111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360114 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2360117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2360131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360150 */     // GIR_Coverage, 56739,
     /* 2360150 */     GIR_EraseRootFromParent_Done,
     /* 2360151 */   // Label 33003: @2360151
     /* 2360151 */   GIM_Reject,
     /* 2360152 */ // Label 33001: @2360152
     /* 2360152 */ GIM_Reject,
     /* 2360153 */ // Label 32972: @2360153
     /* 2360153 */ GIM_Try, /*On fail goto*//*Label 33004*/ GIMT_Encode4(2360267),
     /* 2360158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2360161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2360164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360176 */   GIM_Try, /*On fail goto*//*Label 33005*/ GIMT_Encode4(2360221), // Rule ID 56714 //
     /* 2360181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360184 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2360187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2360201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360220 */     // GIR_Coverage, 56714,
     /* 2360220 */     GIR_EraseRootFromParent_Done,
     /* 2360221 */   // Label 33005: @2360221
     /* 2360221 */   GIM_Try, /*On fail goto*//*Label 33006*/ GIMT_Encode4(2360266), // Rule ID 56715 //
     /* 2360226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360229 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2360232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2360246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360265 */     // GIR_Coverage, 56715,
     /* 2360265 */     GIR_EraseRootFromParent_Done,
     /* 2360266 */   // Label 33006: @2360266
     /* 2360266 */   GIM_Reject,
     /* 2360267 */ // Label 33004: @2360267
     /* 2360267 */ GIM_Reject,
     /* 2360268 */ // Label 32973: @2360268
     /* 2360268 */ GIM_Try, /*On fail goto*//*Label 33007*/ GIMT_Encode4(2360382),
     /* 2360273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2360276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2360279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360291 */   GIM_Try, /*On fail goto*//*Label 33008*/ GIMT_Encode4(2360336), // Rule ID 56732 //
     /* 2360296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360299 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2360302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2360316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360335 */     // GIR_Coverage, 56732,
     /* 2360335 */     GIR_EraseRootFromParent_Done,
     /* 2360336 */   // Label 33008: @2360336
     /* 2360336 */   GIM_Try, /*On fail goto*//*Label 33009*/ GIMT_Encode4(2360381), // Rule ID 56733 //
     /* 2360341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360344 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2360347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2360361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360380 */     // GIR_Coverage, 56733,
     /* 2360380 */     GIR_EraseRootFromParent_Done,
     /* 2360381 */   // Label 33009: @2360381
     /* 2360381 */   GIM_Reject,
     /* 2360382 */ // Label 33007: @2360382
     /* 2360382 */ GIM_Reject,
     /* 2360383 */ // Label 32974: @2360383
     /* 2360383 */ GIM_Try, /*On fail goto*//*Label 33010*/ GIMT_Encode4(2360497),
     /* 2360388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2360391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2360394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360406 */   GIM_Try, /*On fail goto*//*Label 33011*/ GIMT_Encode4(2360451), // Rule ID 56780 //
     /* 2360411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360414 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2360417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2360431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360450 */     // GIR_Coverage, 56780,
     /* 2360450 */     GIR_EraseRootFromParent_Done,
     /* 2360451 */   // Label 33011: @2360451
     /* 2360451 */   GIM_Try, /*On fail goto*//*Label 33012*/ GIMT_Encode4(2360496), // Rule ID 56781 //
     /* 2360456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360459 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2360462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2360476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360495 */     // GIR_Coverage, 56781,
     /* 2360495 */     GIR_EraseRootFromParent_Done,
     /* 2360496 */   // Label 33012: @2360496
     /* 2360496 */   GIM_Reject,
     /* 2360497 */ // Label 33010: @2360497
     /* 2360497 */ GIM_Reject,
     /* 2360498 */ // Label 32975: @2360498
     /* 2360498 */ GIM_Try, /*On fail goto*//*Label 33013*/ GIMT_Encode4(2360612),
     /* 2360503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2360506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2360509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360521 */   GIM_Try, /*On fail goto*//*Label 33014*/ GIMT_Encode4(2360566), // Rule ID 56726 //
     /* 2360526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360529 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2360532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2360546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360565 */     // GIR_Coverage, 56726,
     /* 2360565 */     GIR_EraseRootFromParent_Done,
     /* 2360566 */   // Label 33014: @2360566
     /* 2360566 */   GIM_Try, /*On fail goto*//*Label 33015*/ GIMT_Encode4(2360611), // Rule ID 56727 //
     /* 2360571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360574 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2360577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2360591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360610 */     // GIR_Coverage, 56727,
     /* 2360610 */     GIR_EraseRootFromParent_Done,
     /* 2360611 */   // Label 33015: @2360611
     /* 2360611 */   GIM_Reject,
     /* 2360612 */ // Label 33013: @2360612
     /* 2360612 */ GIM_Reject,
     /* 2360613 */ // Label 32976: @2360613
     /* 2360613 */ GIM_Try, /*On fail goto*//*Label 33016*/ GIMT_Encode4(2360727),
     /* 2360618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2360621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2360624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360632 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360636 */   GIM_Try, /*On fail goto*//*Label 33017*/ GIMT_Encode4(2360681), // Rule ID 56762 //
     /* 2360641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360644 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2360647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2360661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360680 */     // GIR_Coverage, 56762,
     /* 2360680 */     GIR_EraseRootFromParent_Done,
     /* 2360681 */   // Label 33017: @2360681
     /* 2360681 */   GIM_Try, /*On fail goto*//*Label 33018*/ GIMT_Encode4(2360726), // Rule ID 56763 //
     /* 2360686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2360689 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2360692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2360706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360725 */     // GIR_Coverage, 56763,
     /* 2360725 */     GIR_EraseRootFromParent_Done,
     /* 2360726 */   // Label 33018: @2360726
     /* 2360726 */   GIM_Reject,
     /* 2360727 */ // Label 33016: @2360727
     /* 2360727 */ GIM_Reject,
     /* 2360728 */ // Label 32977: @2360728
     /* 2360728 */ GIM_Try, /*On fail goto*//*Label 33019*/ GIMT_Encode4(2360842),
     /* 2360733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2360736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2360739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360751 */   GIM_Try, /*On fail goto*//*Label 33020*/ GIMT_Encode4(2360796), // Rule ID 56786 //
     /* 2360756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2360759 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2360762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2360776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360795 */     // GIR_Coverage, 56786,
     /* 2360795 */     GIR_EraseRootFromParent_Done,
     /* 2360796 */   // Label 33020: @2360796
     /* 2360796 */   GIM_Try, /*On fail goto*//*Label 33021*/ GIMT_Encode4(2360841), // Rule ID 56787 //
     /* 2360801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2360804 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2360807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2360821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360840 */     // GIR_Coverage, 56787,
     /* 2360840 */     GIR_EraseRootFromParent_Done,
     /* 2360841 */   // Label 33021: @2360841
     /* 2360841 */   GIM_Reject,
     /* 2360842 */ // Label 33019: @2360842
     /* 2360842 */ GIM_Reject,
     /* 2360843 */ // Label 32978: @2360843
     /* 2360843 */ GIM_Try, /*On fail goto*//*Label 33022*/ GIMT_Encode4(2360957),
     /* 2360848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2360851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2360854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2360866 */   GIM_Try, /*On fail goto*//*Label 33023*/ GIMT_Encode4(2360911), // Rule ID 56744 //
     /* 2360871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2360874 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2360877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2360891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360910 */     // GIR_Coverage, 56744,
     /* 2360910 */     GIR_EraseRootFromParent_Done,
     /* 2360911 */   // Label 33023: @2360911
     /* 2360911 */   GIM_Try, /*On fail goto*//*Label 33024*/ GIMT_Encode4(2360956), // Rule ID 56745 //
     /* 2360916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2360919 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2360922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2360936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2360945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360955 */     // GIR_Coverage, 56745,
     /* 2360955 */     GIR_EraseRootFromParent_Done,
     /* 2360956 */   // Label 33024: @2360956
     /* 2360956 */   GIM_Reject,
     /* 2360957 */ // Label 33022: @2360957
     /* 2360957 */ GIM_Reject,
     /* 2360958 */ // Label 32979: @2360958
     /* 2360958 */ GIM_Try, /*On fail goto*//*Label 33025*/ GIMT_Encode4(2361072),
     /* 2360963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2360966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2360969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2360981 */   GIM_Try, /*On fail goto*//*Label 33026*/ GIMT_Encode4(2361026), // Rule ID 56768 //
     /* 2360986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2360989 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2360992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2361006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361025 */     // GIR_Coverage, 56768,
     /* 2361025 */     GIR_EraseRootFromParent_Done,
     /* 2361026 */   // Label 33026: @2361026
     /* 2361026 */   GIM_Try, /*On fail goto*//*Label 33027*/ GIMT_Encode4(2361071), // Rule ID 56769 //
     /* 2361031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2361034 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2361037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2361051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361070 */     // GIR_Coverage, 56769,
     /* 2361070 */     GIR_EraseRootFromParent_Done,
     /* 2361071 */   // Label 33027: @2361071
     /* 2361071 */   GIM_Reject,
     /* 2361072 */ // Label 33025: @2361072
     /* 2361072 */ GIM_Reject,
     /* 2361073 */ // Label 32980: @2361073
     /* 2361073 */ GIM_Try, /*On fail goto*//*Label 33028*/ GIMT_Encode4(2361187),
     /* 2361078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2361081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2361084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361096 */   GIM_Try, /*On fail goto*//*Label 33029*/ GIMT_Encode4(2361141), // Rule ID 56792 //
     /* 2361101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2361104 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2361107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2361121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361140 */     // GIR_Coverage, 56792,
     /* 2361140 */     GIR_EraseRootFromParent_Done,
     /* 2361141 */   // Label 33029: @2361141
     /* 2361141 */   GIM_Try, /*On fail goto*//*Label 33030*/ GIMT_Encode4(2361186), // Rule ID 56793 //
     /* 2361146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2361149 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2361152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2361166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361185 */     // GIR_Coverage, 56793,
     /* 2361185 */     GIR_EraseRootFromParent_Done,
     /* 2361186 */   // Label 33030: @2361186
     /* 2361186 */   GIM_Reject,
     /* 2361187 */ // Label 33028: @2361187
     /* 2361187 */ GIM_Reject,
     /* 2361188 */ // Label 32981: @2361188
     /* 2361188 */ GIM_Try, /*On fail goto*//*Label 33031*/ GIMT_Encode4(2361302),
     /* 2361193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2361196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2361199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361211 */   GIM_Try, /*On fail goto*//*Label 33032*/ GIMT_Encode4(2361256), // Rule ID 56750 //
     /* 2361216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361219 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2361222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2361236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361255 */     // GIR_Coverage, 56750,
     /* 2361255 */     GIR_EraseRootFromParent_Done,
     /* 2361256 */   // Label 33032: @2361256
     /* 2361256 */   GIM_Try, /*On fail goto*//*Label 33033*/ GIMT_Encode4(2361301), // Rule ID 56751 //
     /* 2361261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361264 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2361267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2361281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361300 */     // GIR_Coverage, 56751,
     /* 2361300 */     GIR_EraseRootFromParent_Done,
     /* 2361301 */   // Label 33033: @2361301
     /* 2361301 */   GIM_Reject,
     /* 2361302 */ // Label 33031: @2361302
     /* 2361302 */ GIM_Reject,
     /* 2361303 */ // Label 32982: @2361303
     /* 2361303 */ GIM_Try, /*On fail goto*//*Label 33034*/ GIMT_Encode4(2361417),
     /* 2361308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2361311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2361314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361322 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361326 */   GIM_Try, /*On fail goto*//*Label 33035*/ GIMT_Encode4(2361371), // Rule ID 56774 //
     /* 2361331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2361334 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2361337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2361351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361370 */     // GIR_Coverage, 56774,
     /* 2361370 */     GIR_EraseRootFromParent_Done,
     /* 2361371 */   // Label 33035: @2361371
     /* 2361371 */   GIM_Try, /*On fail goto*//*Label 33036*/ GIMT_Encode4(2361416), // Rule ID 56775 //
     /* 2361376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2361379 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2361382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2361396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361415 */     // GIR_Coverage, 56775,
     /* 2361415 */     GIR_EraseRootFromParent_Done,
     /* 2361416 */   // Label 33036: @2361416
     /* 2361416 */   GIM_Reject,
     /* 2361417 */ // Label 33034: @2361417
     /* 2361417 */ GIM_Reject,
     /* 2361418 */ // Label 32983: @2361418
     /* 2361418 */ GIM_Try, /*On fail goto*//*Label 33037*/ GIMT_Encode4(2361532),
     /* 2361423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2361426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2361429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2361441 */   GIM_Try, /*On fail goto*//*Label 33038*/ GIMT_Encode4(2361486), // Rule ID 56756 //
     /* 2361446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361449 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2361452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2361466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361485 */     // GIR_Coverage, 56756,
     /* 2361485 */     GIR_EraseRootFromParent_Done,
     /* 2361486 */   // Label 33038: @2361486
     /* 2361486 */   GIM_Try, /*On fail goto*//*Label 33039*/ GIMT_Encode4(2361531), // Rule ID 56757 //
     /* 2361491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361494 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2361497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2361511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361530 */     // GIR_Coverage, 56757,
     /* 2361530 */     GIR_EraseRootFromParent_Done,
     /* 2361531 */   // Label 33039: @2361531
     /* 2361531 */   GIM_Reject,
     /* 2361532 */ // Label 33037: @2361532
     /* 2361532 */ GIM_Reject,
     /* 2361533 */ // Label 32984: @2361533
     /* 2361533 */ GIM_Reject,
     /* 2361534 */ // Label 79: @2361534
     /* 2361534 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33058*/ GIMT_Encode4(2363618),
     /* 2361545 */ /*GILLT_s16*//*Label 33040*/ GIMT_Encode4(2361665),
     /* 2361549 */ /*GILLT_s32*//*Label 33041*/ GIMT_Encode4(2361732),
     /* 2361553 */ /*GILLT_s64*//*Label 33042*/ GIMT_Encode4(2361799), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361565 */ /*GILLT_nxv1s16*//*Label 33043*/ GIMT_Encode4(2361893),
     /* 2361569 */ /*GILLT_nxv1s32*//*Label 33044*/ GIMT_Encode4(2362008),
     /* 2361573 */ /*GILLT_nxv1s64*//*Label 33045*/ GIMT_Encode4(2362123), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361585 */ /*GILLT_nxv2s16*//*Label 33046*/ GIMT_Encode4(2362238),
     /* 2361589 */ /*GILLT_nxv2s32*//*Label 33047*/ GIMT_Encode4(2362353),
     /* 2361593 */ /*GILLT_nxv2s64*//*Label 33048*/ GIMT_Encode4(2362468), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361605 */ /*GILLT_nxv4s16*//*Label 33049*/ GIMT_Encode4(2362583),
     /* 2361609 */ /*GILLT_nxv4s32*//*Label 33050*/ GIMT_Encode4(2362698),
     /* 2361613 */ /*GILLT_nxv4s64*//*Label 33051*/ GIMT_Encode4(2362813), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361625 */ /*GILLT_nxv8s16*//*Label 33052*/ GIMT_Encode4(2362928),
     /* 2361629 */ /*GILLT_nxv8s32*//*Label 33053*/ GIMT_Encode4(2363043),
     /* 2361633 */ /*GILLT_nxv8s64*//*Label 33054*/ GIMT_Encode4(2363158), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361645 */ /*GILLT_nxv16s16*//*Label 33055*/ GIMT_Encode4(2363273),
     /* 2361649 */ /*GILLT_nxv16s32*//*Label 33056*/ GIMT_Encode4(2363388), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2361661 */ /*GILLT_nxv32s16*//*Label 33057*/ GIMT_Encode4(2363503),
     /* 2361665 */ // Label 33040: @2361665
     /* 2361665 */ GIM_Try, /*On fail goto*//*Label 33059*/ GIMT_Encode4(2361731),
     /* 2361670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2361673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2361676 */   GIM_Try, /*On fail goto*//*Label 33060*/ GIMT_Encode4(2361703), // Rule ID 2056 //
     /* 2361681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2361684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2361696 */     // (fmaximumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2361696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2361701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361702 */     // GIR_Coverage, 2056,
     /* 2361702 */     GIR_Done,
     /* 2361703 */   // Label 33060: @2361703
     /* 2361703 */   GIM_Try, /*On fail goto*//*Label 33061*/ GIMT_Encode4(2361730), // Rule ID 2057 //
     /* 2361708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2361711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2361715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2361719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2361723 */     // (fmaximumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2361723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2361728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361729 */     // GIR_Coverage, 2057,
     /* 2361729 */     GIR_Done,
     /* 2361730 */   // Label 33061: @2361730
     /* 2361730 */   GIM_Reject,
     /* 2361731 */ // Label 33059: @2361731
     /* 2361731 */ GIM_Reject,
     /* 2361732 */ // Label 33041: @2361732
     /* 2361732 */ GIM_Try, /*On fail goto*//*Label 33062*/ GIMT_Encode4(2361798),
     /* 2361737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2361740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2361743 */   GIM_Try, /*On fail goto*//*Label 33063*/ GIMT_Encode4(2361770), // Rule ID 1343 //
     /* 2361748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2361751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2361763 */     // (fmaximumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2361763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2361768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361769 */     // GIR_Coverage, 1343,
     /* 2361769 */     GIR_Done,
     /* 2361770 */   // Label 33063: @2361770
     /* 2361770 */   GIM_Try, /*On fail goto*//*Label 33064*/ GIMT_Encode4(2361797), // Rule ID 1344 //
     /* 2361775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2361778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2361782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2361786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2361790 */     // (fmaximumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2361790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2361795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361796 */     // GIR_Coverage, 1344,
     /* 2361796 */     GIR_Done,
     /* 2361797 */   // Label 33064: @2361797
     /* 2361797 */   GIM_Reject,
     /* 2361798 */ // Label 33062: @2361798
     /* 2361798 */ GIM_Reject,
     /* 2361799 */ // Label 33042: @2361799
     /* 2361799 */ GIM_Try, /*On fail goto*//*Label 33065*/ GIMT_Encode4(2361892),
     /* 2361804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2361807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2361810 */   GIM_Try, /*On fail goto*//*Label 33066*/ GIMT_Encode4(2361837), // Rule ID 1717 //
     /* 2361815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2361818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2361830 */     // (fmaximumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2361835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361836 */     // GIR_Coverage, 1717,
     /* 2361836 */     GIR_Done,
     /* 2361837 */   // Label 33066: @2361837
     /* 2361837 */   GIM_Try, /*On fail goto*//*Label 33067*/ GIMT_Encode4(2361864), // Rule ID 1718 //
     /* 2361842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2361845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2361849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2361853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2361857 */     // (fmaximumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2361862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361863 */     // GIR_Coverage, 1718,
     /* 2361863 */     GIR_Done,
     /* 2361864 */   // Label 33067: @2361864
     /* 2361864 */   GIM_Try, /*On fail goto*//*Label 33068*/ GIMT_Encode4(2361891), // Rule ID 1719 //
     /* 2361869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2361872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2361884 */     // (fmaximumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2361884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2361889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361890 */     // GIR_Coverage, 1719,
     /* 2361890 */     GIR_Done,
     /* 2361891 */   // Label 33068: @2361891
     /* 2361891 */   GIM_Reject,
     /* 2361892 */ // Label 33065: @2361892
     /* 2361892 */ GIM_Reject,
     /* 2361893 */ // Label 33043: @2361893
     /* 2361893 */ GIM_Try, /*On fail goto*//*Label 33069*/ GIMT_Encode4(2362007),
     /* 2361898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2361901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2361904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361916 */   GIM_Try, /*On fail goto*//*Label 33070*/ GIMT_Encode4(2361961), // Rule ID 56798 //
     /* 2361921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2361924 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2361927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2361941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361960 */     // GIR_Coverage, 56798,
     /* 2361960 */     GIR_EraseRootFromParent_Done,
     /* 2361961 */   // Label 33070: @2361961
     /* 2361961 */   GIM_Try, /*On fail goto*//*Label 33071*/ GIMT_Encode4(2362006), // Rule ID 56799 //
     /* 2361966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2361969 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2361972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2361986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2361995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362005 */     // GIR_Coverage, 56799,
     /* 2362005 */     GIR_EraseRootFromParent_Done,
     /* 2362006 */   // Label 33071: @2362006
     /* 2362006 */   GIM_Reject,
     /* 2362007 */ // Label 33069: @2362007
     /* 2362007 */ GIM_Reject,
     /* 2362008 */ // Label 33044: @2362008
     /* 2362008 */ GIM_Try, /*On fail goto*//*Label 33072*/ GIMT_Encode4(2362122),
     /* 2362013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2362016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2362019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362031 */   GIM_Try, /*On fail goto*//*Label 33073*/ GIMT_Encode4(2362076), // Rule ID 56810 //
     /* 2362036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362039 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2362042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2362056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362075 */     // GIR_Coverage, 56810,
     /* 2362075 */     GIR_EraseRootFromParent_Done,
     /* 2362076 */   // Label 33073: @2362076
     /* 2362076 */   GIM_Try, /*On fail goto*//*Label 33074*/ GIMT_Encode4(2362121), // Rule ID 56811 //
     /* 2362081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362084 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2362087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2362101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362120 */     // GIR_Coverage, 56811,
     /* 2362120 */     GIR_EraseRootFromParent_Done,
     /* 2362121 */   // Label 33074: @2362121
     /* 2362121 */   GIM_Reject,
     /* 2362122 */ // Label 33072: @2362122
     /* 2362122 */ GIM_Reject,
     /* 2362123 */ // Label 33045: @2362123
     /* 2362123 */ GIM_Try, /*On fail goto*//*Label 33075*/ GIMT_Encode4(2362237),
     /* 2362128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2362131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2362134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362146 */   GIM_Try, /*On fail goto*//*Label 33076*/ GIMT_Encode4(2362191), // Rule ID 56828 //
     /* 2362151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362154 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2362157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2362171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362190 */     // GIR_Coverage, 56828,
     /* 2362190 */     GIR_EraseRootFromParent_Done,
     /* 2362191 */   // Label 33076: @2362191
     /* 2362191 */   GIM_Try, /*On fail goto*//*Label 33077*/ GIMT_Encode4(2362236), // Rule ID 56829 //
     /* 2362196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362199 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2362202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2362216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362235 */     // GIR_Coverage, 56829,
     /* 2362235 */     GIR_EraseRootFromParent_Done,
     /* 2362236 */   // Label 33077: @2362236
     /* 2362236 */   GIM_Reject,
     /* 2362237 */ // Label 33075: @2362237
     /* 2362237 */ GIM_Reject,
     /* 2362238 */ // Label 33046: @2362238
     /* 2362238 */ GIM_Try, /*On fail goto*//*Label 33078*/ GIMT_Encode4(2362352),
     /* 2362243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2362246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2362249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362261 */   GIM_Try, /*On fail goto*//*Label 33079*/ GIMT_Encode4(2362306), // Rule ID 56804 //
     /* 2362266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362269 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2362272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2362286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362305 */     // GIR_Coverage, 56804,
     /* 2362305 */     GIR_EraseRootFromParent_Done,
     /* 2362306 */   // Label 33079: @2362306
     /* 2362306 */   GIM_Try, /*On fail goto*//*Label 33080*/ GIMT_Encode4(2362351), // Rule ID 56805 //
     /* 2362311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362314 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2362317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2362331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362350 */     // GIR_Coverage, 56805,
     /* 2362350 */     GIR_EraseRootFromParent_Done,
     /* 2362351 */   // Label 33080: @2362351
     /* 2362351 */   GIM_Reject,
     /* 2362352 */ // Label 33078: @2362352
     /* 2362352 */ GIM_Reject,
     /* 2362353 */ // Label 33047: @2362353
     /* 2362353 */ GIM_Try, /*On fail goto*//*Label 33081*/ GIMT_Encode4(2362467),
     /* 2362358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2362361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2362364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362376 */   GIM_Try, /*On fail goto*//*Label 33082*/ GIMT_Encode4(2362421), // Rule ID 56822 //
     /* 2362381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362384 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2362401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362420 */     // GIR_Coverage, 56822,
     /* 2362420 */     GIR_EraseRootFromParent_Done,
     /* 2362421 */   // Label 33082: @2362421
     /* 2362421 */   GIM_Try, /*On fail goto*//*Label 33083*/ GIMT_Encode4(2362466), // Rule ID 56823 //
     /* 2362426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362429 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2362432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2362446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362465 */     // GIR_Coverage, 56823,
     /* 2362465 */     GIR_EraseRootFromParent_Done,
     /* 2362466 */   // Label 33083: @2362466
     /* 2362466 */   GIM_Reject,
     /* 2362467 */ // Label 33081: @2362467
     /* 2362467 */ GIM_Reject,
     /* 2362468 */ // Label 33048: @2362468
     /* 2362468 */ GIM_Try, /*On fail goto*//*Label 33084*/ GIMT_Encode4(2362582),
     /* 2362473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2362476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2362479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362491 */   GIM_Try, /*On fail goto*//*Label 33085*/ GIMT_Encode4(2362536), // Rule ID 56870 //
     /* 2362496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362499 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2362516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362535 */     // GIR_Coverage, 56870,
     /* 2362535 */     GIR_EraseRootFromParent_Done,
     /* 2362536 */   // Label 33085: @2362536
     /* 2362536 */   GIM_Try, /*On fail goto*//*Label 33086*/ GIMT_Encode4(2362581), // Rule ID 56871 //
     /* 2362541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362544 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2362547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2362561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362580 */     // GIR_Coverage, 56871,
     /* 2362580 */     GIR_EraseRootFromParent_Done,
     /* 2362581 */   // Label 33086: @2362581
     /* 2362581 */   GIM_Reject,
     /* 2362582 */ // Label 33084: @2362582
     /* 2362582 */ GIM_Reject,
     /* 2362583 */ // Label 33049: @2362583
     /* 2362583 */ GIM_Try, /*On fail goto*//*Label 33087*/ GIMT_Encode4(2362697),
     /* 2362588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2362591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2362594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2362606 */   GIM_Try, /*On fail goto*//*Label 33088*/ GIMT_Encode4(2362651), // Rule ID 56816 //
     /* 2362611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362614 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2362617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2362631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362650 */     // GIR_Coverage, 56816,
     /* 2362650 */     GIR_EraseRootFromParent_Done,
     /* 2362651 */   // Label 33088: @2362651
     /* 2362651 */   GIM_Try, /*On fail goto*//*Label 33089*/ GIMT_Encode4(2362696), // Rule ID 56817 //
     /* 2362656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2362659 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2362662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2362676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362695 */     // GIR_Coverage, 56817,
     /* 2362695 */     GIR_EraseRootFromParent_Done,
     /* 2362696 */   // Label 33089: @2362696
     /* 2362696 */   GIM_Reject,
     /* 2362697 */ // Label 33087: @2362697
     /* 2362697 */ GIM_Reject,
     /* 2362698 */ // Label 33050: @2362698
     /* 2362698 */ GIM_Try, /*On fail goto*//*Label 33090*/ GIMT_Encode4(2362812),
     /* 2362703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2362706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2362709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362721 */   GIM_Try, /*On fail goto*//*Label 33091*/ GIMT_Encode4(2362766), // Rule ID 56852 //
     /* 2362726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2362729 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2362732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2362746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362765 */     // GIR_Coverage, 56852,
     /* 2362765 */     GIR_EraseRootFromParent_Done,
     /* 2362766 */   // Label 33091: @2362766
     /* 2362766 */   GIM_Try, /*On fail goto*//*Label 33092*/ GIMT_Encode4(2362811), // Rule ID 56853 //
     /* 2362771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2362774 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2362777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2362791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362810 */     // GIR_Coverage, 56853,
     /* 2362810 */     GIR_EraseRootFromParent_Done,
     /* 2362811 */   // Label 33092: @2362811
     /* 2362811 */   GIM_Reject,
     /* 2362812 */ // Label 33090: @2362812
     /* 2362812 */ GIM_Reject,
     /* 2362813 */ // Label 33051: @2362813
     /* 2362813 */ GIM_Try, /*On fail goto*//*Label 33093*/ GIMT_Encode4(2362927),
     /* 2362818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2362821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2362824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362836 */   GIM_Try, /*On fail goto*//*Label 33094*/ GIMT_Encode4(2362881), // Rule ID 56876 //
     /* 2362841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2362844 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2362847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2362861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362880 */     // GIR_Coverage, 56876,
     /* 2362880 */     GIR_EraseRootFromParent_Done,
     /* 2362881 */   // Label 33094: @2362881
     /* 2362881 */   GIM_Try, /*On fail goto*//*Label 33095*/ GIMT_Encode4(2362926), // Rule ID 56877 //
     /* 2362886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2362889 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2362892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2362906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362925 */     // GIR_Coverage, 56877,
     /* 2362925 */     GIR_EraseRootFromParent_Done,
     /* 2362926 */   // Label 33095: @2362926
     /* 2362926 */   GIM_Reject,
     /* 2362927 */ // Label 33093: @2362927
     /* 2362927 */ GIM_Reject,
     /* 2362928 */ // Label 33052: @2362928
     /* 2362928 */ GIM_Try, /*On fail goto*//*Label 33096*/ GIMT_Encode4(2363042),
     /* 2362933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2362936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2362939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362951 */   GIM_Try, /*On fail goto*//*Label 33097*/ GIMT_Encode4(2362996), // Rule ID 56834 //
     /* 2362956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2362959 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2362962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2362976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2362985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362995 */     // GIR_Coverage, 56834,
     /* 2362995 */     GIR_EraseRootFromParent_Done,
     /* 2362996 */   // Label 33097: @2362996
     /* 2362996 */   GIM_Try, /*On fail goto*//*Label 33098*/ GIMT_Encode4(2363041), // Rule ID 56835 //
     /* 2363001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363004 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2363007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2363021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363040 */     // GIR_Coverage, 56835,
     /* 2363040 */     GIR_EraseRootFromParent_Done,
     /* 2363041 */   // Label 33098: @2363041
     /* 2363041 */   GIM_Reject,
     /* 2363042 */ // Label 33096: @2363042
     /* 2363042 */ GIM_Reject,
     /* 2363043 */ // Label 33053: @2363043
     /* 2363043 */ GIM_Try, /*On fail goto*//*Label 33099*/ GIMT_Encode4(2363157),
     /* 2363048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2363051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2363054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363066 */   GIM_Try, /*On fail goto*//*Label 33100*/ GIMT_Encode4(2363111), // Rule ID 56858 //
     /* 2363071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363074 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2363077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2363091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363110 */     // GIR_Coverage, 56858,
     /* 2363110 */     GIR_EraseRootFromParent_Done,
     /* 2363111 */   // Label 33100: @2363111
     /* 2363111 */   GIM_Try, /*On fail goto*//*Label 33101*/ GIMT_Encode4(2363156), // Rule ID 56859 //
     /* 2363116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363119 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2363122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2363136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363155 */     // GIR_Coverage, 56859,
     /* 2363155 */     GIR_EraseRootFromParent_Done,
     /* 2363156 */   // Label 33101: @2363156
     /* 2363156 */   GIM_Reject,
     /* 2363157 */ // Label 33099: @2363157
     /* 2363157 */ GIM_Reject,
     /* 2363158 */ // Label 33054: @2363158
     /* 2363158 */ GIM_Try, /*On fail goto*//*Label 33102*/ GIMT_Encode4(2363272),
     /* 2363163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2363166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2363169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363181 */   GIM_Try, /*On fail goto*//*Label 33103*/ GIMT_Encode4(2363226), // Rule ID 56882 //
     /* 2363186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2363189 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2363192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2363206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363225 */     // GIR_Coverage, 56882,
     /* 2363225 */     GIR_EraseRootFromParent_Done,
     /* 2363226 */   // Label 33103: @2363226
     /* 2363226 */   GIM_Try, /*On fail goto*//*Label 33104*/ GIMT_Encode4(2363271), // Rule ID 56883 //
     /* 2363231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2363234 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2363237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2363251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363270 */     // GIR_Coverage, 56883,
     /* 2363270 */     GIR_EraseRootFromParent_Done,
     /* 2363271 */   // Label 33104: @2363271
     /* 2363271 */   GIM_Reject,
     /* 2363272 */ // Label 33102: @2363272
     /* 2363272 */ GIM_Reject,
     /* 2363273 */ // Label 33055: @2363273
     /* 2363273 */ GIM_Try, /*On fail goto*//*Label 33105*/ GIMT_Encode4(2363387),
     /* 2363278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2363281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2363284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2363296 */   GIM_Try, /*On fail goto*//*Label 33106*/ GIMT_Encode4(2363341), // Rule ID 56840 //
     /* 2363301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363304 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2363307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2363321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363340 */     // GIR_Coverage, 56840,
     /* 2363340 */     GIR_EraseRootFromParent_Done,
     /* 2363341 */   // Label 33106: @2363341
     /* 2363341 */   GIM_Try, /*On fail goto*//*Label 33107*/ GIMT_Encode4(2363386), // Rule ID 56841 //
     /* 2363346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363349 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2363352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2363366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363385 */     // GIR_Coverage, 56841,
     /* 2363385 */     GIR_EraseRootFromParent_Done,
     /* 2363386 */   // Label 33107: @2363386
     /* 2363386 */   GIM_Reject,
     /* 2363387 */ // Label 33105: @2363387
     /* 2363387 */ GIM_Reject,
     /* 2363388 */ // Label 33056: @2363388
     /* 2363388 */ GIM_Try, /*On fail goto*//*Label 33108*/ GIMT_Encode4(2363502),
     /* 2363393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2363396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2363399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363411 */   GIM_Try, /*On fail goto*//*Label 33109*/ GIMT_Encode4(2363456), // Rule ID 56864 //
     /* 2363416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2363419 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2363436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363455 */     // GIR_Coverage, 56864,
     /* 2363455 */     GIR_EraseRootFromParent_Done,
     /* 2363456 */   // Label 33109: @2363456
     /* 2363456 */   GIM_Try, /*On fail goto*//*Label 33110*/ GIMT_Encode4(2363501), // Rule ID 56865 //
     /* 2363461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2363464 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2363467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2363481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363500 */     // GIR_Coverage, 56865,
     /* 2363500 */     GIR_EraseRootFromParent_Done,
     /* 2363501 */   // Label 33110: @2363501
     /* 2363501 */   GIM_Reject,
     /* 2363502 */ // Label 33108: @2363502
     /* 2363502 */ GIM_Reject,
     /* 2363503 */ // Label 33057: @2363503
     /* 2363503 */ GIM_Try, /*On fail goto*//*Label 33111*/ GIMT_Encode4(2363617),
     /* 2363508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2363511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2363514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2363526 */   GIM_Try, /*On fail goto*//*Label 33112*/ GIMT_Encode4(2363571), // Rule ID 56846 //
     /* 2363531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2363534 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2363551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363570 */     // GIR_Coverage, 56846,
     /* 2363570 */     GIR_EraseRootFromParent_Done,
     /* 2363571 */   // Label 33112: @2363571
     /* 2363571 */   GIM_Try, /*On fail goto*//*Label 33113*/ GIMT_Encode4(2363616), // Rule ID 56847 //
     /* 2363576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2363579 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2363582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2363596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363615 */     // GIR_Coverage, 56847,
     /* 2363615 */     GIR_EraseRootFromParent_Done,
     /* 2363616 */   // Label 33113: @2363616
     /* 2363616 */   GIM_Reject,
     /* 2363617 */ // Label 33111: @2363617
     /* 2363617 */ GIM_Reject,
     /* 2363618 */ // Label 33058: @2363618
     /* 2363618 */ GIM_Reject,
     /* 2363619 */ // Label 80: @2363619
     /* 2363619 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33138*/ GIMT_Encode4(2366394),
     /* 2363630 */ /*GILLT_s32*//*Label 33114*/ GIMT_Encode4(2363754),
     /* 2363634 */ /*GILLT_s64*//*Label 33115*/ GIMT_Encode4(2363809), GIMT_Encode4(0),
     /* 2363642 */ /*GILLT_nxv1s8*//*Label 33116*/ GIMT_Encode4(2363864),
     /* 2363646 */ /*GILLT_nxv1s16*//*Label 33117*/ GIMT_Encode4(2363979),
     /* 2363650 */ /*GILLT_nxv1s32*//*Label 33118*/ GIMT_Encode4(2364094),
     /* 2363654 */ /*GILLT_nxv1s64*//*Label 33119*/ GIMT_Encode4(2364209), GIMT_Encode4(0),
     /* 2363662 */ /*GILLT_nxv2s8*//*Label 33120*/ GIMT_Encode4(2364324),
     /* 2363666 */ /*GILLT_nxv2s16*//*Label 33121*/ GIMT_Encode4(2364439),
     /* 2363670 */ /*GILLT_nxv2s32*//*Label 33122*/ GIMT_Encode4(2364554),
     /* 2363674 */ /*GILLT_nxv2s64*//*Label 33123*/ GIMT_Encode4(2364669), GIMT_Encode4(0),
     /* 2363682 */ /*GILLT_nxv4s8*//*Label 33124*/ GIMT_Encode4(2364784),
     /* 2363686 */ /*GILLT_nxv4s16*//*Label 33125*/ GIMT_Encode4(2364899),
     /* 2363690 */ /*GILLT_nxv4s32*//*Label 33126*/ GIMT_Encode4(2365014),
     /* 2363694 */ /*GILLT_nxv4s64*//*Label 33127*/ GIMT_Encode4(2365129), GIMT_Encode4(0),
     /* 2363702 */ /*GILLT_nxv8s8*//*Label 33128*/ GIMT_Encode4(2365244),
     /* 2363706 */ /*GILLT_nxv8s16*//*Label 33129*/ GIMT_Encode4(2365359),
     /* 2363710 */ /*GILLT_nxv8s32*//*Label 33130*/ GIMT_Encode4(2365474),
     /* 2363714 */ /*GILLT_nxv8s64*//*Label 33131*/ GIMT_Encode4(2365589), GIMT_Encode4(0),
     /* 2363722 */ /*GILLT_nxv16s8*//*Label 33132*/ GIMT_Encode4(2365704),
     /* 2363726 */ /*GILLT_nxv16s16*//*Label 33133*/ GIMT_Encode4(2365819),
     /* 2363730 */ /*GILLT_nxv16s32*//*Label 33134*/ GIMT_Encode4(2365934), GIMT_Encode4(0),
     /* 2363738 */ /*GILLT_nxv32s8*//*Label 33135*/ GIMT_Encode4(2366049),
     /* 2363742 */ /*GILLT_nxv32s16*//*Label 33136*/ GIMT_Encode4(2366164), GIMT_Encode4(0),
     /* 2363750 */ /*GILLT_nxv64s8*//*Label 33137*/ GIMT_Encode4(2366279),
     /* 2363754 */ // Label 33114: @2363754
     /* 2363754 */ GIM_Try, /*On fail goto*//*Label 33139*/ GIMT_Encode4(2363808),
     /* 2363759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2363762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2363765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363773 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363777 */   GIM_Try, /*On fail goto*//*Label 33140*/ GIMT_Encode4(2363792), // Rule ID 64460 //
     /* 2363782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2363785 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2363785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2363790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363791 */     // GIR_Coverage, 64460,
     /* 2363791 */     GIR_Done,
     /* 2363792 */   // Label 33140: @2363792
     /* 2363792 */   GIM_Try, /*On fail goto*//*Label 33141*/ GIMT_Encode4(2363807), // Rule ID 2525 //
     /* 2363797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2363800 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2363800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2363805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363806 */     // GIR_Coverage, 2525,
     /* 2363806 */     GIR_Done,
     /* 2363807 */   // Label 33141: @2363807
     /* 2363807 */   GIM_Reject,
     /* 2363808 */ // Label 33139: @2363808
     /* 2363808 */ GIM_Reject,
     /* 2363809 */ // Label 33115: @2363809
     /* 2363809 */ GIM_Try, /*On fail goto*//*Label 33142*/ GIMT_Encode4(2363863),
     /* 2363814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2363817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2363820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363832 */   GIM_Try, /*On fail goto*//*Label 33143*/ GIMT_Encode4(2363847), // Rule ID 64459 //
     /* 2363837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2363840 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2363840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2363845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363846 */     // GIR_Coverage, 64459,
     /* 2363846 */     GIR_Done,
     /* 2363847 */   // Label 33143: @2363847
     /* 2363847 */   GIM_Try, /*On fail goto*//*Label 33144*/ GIMT_Encode4(2363862), // Rule ID 2524 //
     /* 2363852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2363855 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2363855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2363860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363861 */     // GIR_Coverage, 2524,
     /* 2363861 */     GIR_Done,
     /* 2363862 */   // Label 33144: @2363862
     /* 2363862 */   GIM_Reject,
     /* 2363863 */ // Label 33142: @2363863
     /* 2363863 */ GIM_Reject,
     /* 2363864 */ // Label 33116: @2363864
     /* 2363864 */ GIM_Try, /*On fail goto*//*Label 33145*/ GIMT_Encode4(2363978),
     /* 2363869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2363872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2363875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363887 */   GIM_Try, /*On fail goto*//*Label 33146*/ GIMT_Encode4(2363932), // Rule ID 50590 //
     /* 2363892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2363895 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2363898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2363912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363931 */     // GIR_Coverage, 50590,
     /* 2363931 */     GIR_EraseRootFromParent_Done,
     /* 2363932 */   // Label 33146: @2363932
     /* 2363932 */   GIM_Try, /*On fail goto*//*Label 33147*/ GIMT_Encode4(2363977), // Rule ID 50591 //
     /* 2363937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2363940 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2363943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2363957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2363966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363976 */     // GIR_Coverage, 50591,
     /* 2363976 */     GIR_EraseRootFromParent_Done,
     /* 2363977 */   // Label 33147: @2363977
     /* 2363977 */   GIM_Reject,
     /* 2363978 */ // Label 33145: @2363978
     /* 2363978 */ GIM_Reject,
     /* 2363979 */ // Label 33117: @2363979
     /* 2363979 */ GIM_Try, /*On fail goto*//*Label 33148*/ GIMT_Encode4(2364093),
     /* 2363984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2363987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2363990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364002 */   GIM_Try, /*On fail goto*//*Label 33149*/ GIMT_Encode4(2364047), // Rule ID 50602 //
     /* 2364007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364010 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2364013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2364027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364046 */     // GIR_Coverage, 50602,
     /* 2364046 */     GIR_EraseRootFromParent_Done,
     /* 2364047 */   // Label 33149: @2364047
     /* 2364047 */   GIM_Try, /*On fail goto*//*Label 33150*/ GIMT_Encode4(2364092), // Rule ID 50603 //
     /* 2364052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364055 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2364058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2364072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364091 */     // GIR_Coverage, 50603,
     /* 2364091 */     GIR_EraseRootFromParent_Done,
     /* 2364092 */   // Label 33150: @2364092
     /* 2364092 */   GIM_Reject,
     /* 2364093 */ // Label 33148: @2364093
     /* 2364093 */ GIM_Reject,
     /* 2364094 */ // Label 33118: @2364094
     /* 2364094 */ GIM_Try, /*On fail goto*//*Label 33151*/ GIMT_Encode4(2364208),
     /* 2364099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2364102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2364105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364117 */   GIM_Try, /*On fail goto*//*Label 33152*/ GIMT_Encode4(2364162), // Rule ID 50610 //
     /* 2364122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364125 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2364128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364161 */     // GIR_Coverage, 50610,
     /* 2364161 */     GIR_EraseRootFromParent_Done,
     /* 2364162 */   // Label 33152: @2364162
     /* 2364162 */   GIM_Try, /*On fail goto*//*Label 33153*/ GIMT_Encode4(2364207), // Rule ID 50611 //
     /* 2364167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364170 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2364173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364206 */     // GIR_Coverage, 50611,
     /* 2364206 */     GIR_EraseRootFromParent_Done,
     /* 2364207 */   // Label 33153: @2364207
     /* 2364207 */   GIM_Reject,
     /* 2364208 */ // Label 33151: @2364208
     /* 2364208 */ GIM_Reject,
     /* 2364209 */ // Label 33119: @2364209
     /* 2364209 */ GIM_Try, /*On fail goto*//*Label 33154*/ GIMT_Encode4(2364323),
     /* 2364214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2364217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2364220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364232 */   GIM_Try, /*On fail goto*//*Label 33155*/ GIMT_Encode4(2364277), // Rule ID 50626 //
     /* 2364237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2364240 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2364243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2364257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364276 */     // GIR_Coverage, 50626,
     /* 2364276 */     GIR_EraseRootFromParent_Done,
     /* 2364277 */   // Label 33155: @2364277
     /* 2364277 */   GIM_Try, /*On fail goto*//*Label 33156*/ GIMT_Encode4(2364322), // Rule ID 50627 //
     /* 2364282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2364285 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2364288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2364302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364321 */     // GIR_Coverage, 50627,
     /* 2364321 */     GIR_EraseRootFromParent_Done,
     /* 2364322 */   // Label 33156: @2364322
     /* 2364322 */   GIM_Reject,
     /* 2364323 */ // Label 33154: @2364323
     /* 2364323 */ GIM_Reject,
     /* 2364324 */ // Label 33120: @2364324
     /* 2364324 */ GIM_Try, /*On fail goto*//*Label 33157*/ GIMT_Encode4(2364438),
     /* 2364329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2364332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2364335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364347 */   GIM_Try, /*On fail goto*//*Label 33158*/ GIMT_Encode4(2364392), // Rule ID 50594 //
     /* 2364352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364355 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2364358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2364372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364391 */     // GIR_Coverage, 50594,
     /* 2364391 */     GIR_EraseRootFromParent_Done,
     /* 2364392 */   // Label 33158: @2364392
     /* 2364392 */   GIM_Try, /*On fail goto*//*Label 33159*/ GIMT_Encode4(2364437), // Rule ID 50595 //
     /* 2364397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364400 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2364403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2364417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364436 */     // GIR_Coverage, 50595,
     /* 2364436 */     GIR_EraseRootFromParent_Done,
     /* 2364437 */   // Label 33159: @2364437
     /* 2364437 */   GIM_Reject,
     /* 2364438 */ // Label 33157: @2364438
     /* 2364438 */ GIM_Reject,
     /* 2364439 */ // Label 33121: @2364439
     /* 2364439 */ GIM_Try, /*On fail goto*//*Label 33160*/ GIMT_Encode4(2364553),
     /* 2364444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2364447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2364450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364462 */   GIM_Try, /*On fail goto*//*Label 33161*/ GIMT_Encode4(2364507), // Rule ID 50606 //
     /* 2364467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364470 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2364473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364506 */     // GIR_Coverage, 50606,
     /* 2364506 */     GIR_EraseRootFromParent_Done,
     /* 2364507 */   // Label 33161: @2364507
     /* 2364507 */   GIM_Try, /*On fail goto*//*Label 33162*/ GIMT_Encode4(2364552), // Rule ID 50607 //
     /* 2364512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364515 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2364518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364551 */     // GIR_Coverage, 50607,
     /* 2364551 */     GIR_EraseRootFromParent_Done,
     /* 2364552 */   // Label 33162: @2364552
     /* 2364552 */   GIM_Reject,
     /* 2364553 */ // Label 33160: @2364553
     /* 2364553 */ GIM_Reject,
     /* 2364554 */ // Label 33122: @2364554
     /* 2364554 */ GIM_Try, /*On fail goto*//*Label 33163*/ GIMT_Encode4(2364668),
     /* 2364559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2364562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2364565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364577 */   GIM_Try, /*On fail goto*//*Label 33164*/ GIMT_Encode4(2364622), // Rule ID 50622 //
     /* 2364582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364585 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2364588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2364602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364621 */     // GIR_Coverage, 50622,
     /* 2364621 */     GIR_EraseRootFromParent_Done,
     /* 2364622 */   // Label 33164: @2364622
     /* 2364622 */   GIM_Try, /*On fail goto*//*Label 33165*/ GIMT_Encode4(2364667), // Rule ID 50623 //
     /* 2364627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364630 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2364633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2364647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364666 */     // GIR_Coverage, 50623,
     /* 2364666 */     GIR_EraseRootFromParent_Done,
     /* 2364667 */   // Label 33165: @2364667
     /* 2364667 */   GIM_Reject,
     /* 2364668 */ // Label 33163: @2364668
     /* 2364668 */ GIM_Reject,
     /* 2364669 */ // Label 33123: @2364669
     /* 2364669 */ GIM_Try, /*On fail goto*//*Label 33166*/ GIMT_Encode4(2364783),
     /* 2364674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2364677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2364680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364692 */   GIM_Try, /*On fail goto*//*Label 33167*/ GIMT_Encode4(2364737), // Rule ID 50666 //
     /* 2364697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2364700 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2364703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2364717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364736 */     // GIR_Coverage, 50666,
     /* 2364736 */     GIR_EraseRootFromParent_Done,
     /* 2364737 */   // Label 33167: @2364737
     /* 2364737 */   GIM_Try, /*On fail goto*//*Label 33168*/ GIMT_Encode4(2364782), // Rule ID 50667 //
     /* 2364742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2364745 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2364748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2364762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364781 */     // GIR_Coverage, 50667,
     /* 2364781 */     GIR_EraseRootFromParent_Done,
     /* 2364782 */   // Label 33168: @2364782
     /* 2364782 */   GIM_Reject,
     /* 2364783 */ // Label 33166: @2364783
     /* 2364783 */ GIM_Reject,
     /* 2364784 */ // Label 33124: @2364784
     /* 2364784 */ GIM_Try, /*On fail goto*//*Label 33169*/ GIMT_Encode4(2364898),
     /* 2364789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2364792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2364795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364807 */   GIM_Try, /*On fail goto*//*Label 33170*/ GIMT_Encode4(2364852), // Rule ID 50598 //
     /* 2364812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364815 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2364818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364851 */     // GIR_Coverage, 50598,
     /* 2364851 */     GIR_EraseRootFromParent_Done,
     /* 2364852 */   // Label 33170: @2364852
     /* 2364852 */   GIM_Try, /*On fail goto*//*Label 33171*/ GIMT_Encode4(2364897), // Rule ID 50599 //
     /* 2364857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364860 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2364863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2364877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364896 */     // GIR_Coverage, 50599,
     /* 2364896 */     GIR_EraseRootFromParent_Done,
     /* 2364897 */   // Label 33171: @2364897
     /* 2364897 */   GIM_Reject,
     /* 2364898 */ // Label 33169: @2364898
     /* 2364898 */ GIM_Reject,
     /* 2364899 */ // Label 33125: @2364899
     /* 2364899 */ GIM_Try, /*On fail goto*//*Label 33172*/ GIMT_Encode4(2365013),
     /* 2364904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2364907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2364910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364922 */   GIM_Try, /*On fail goto*//*Label 33173*/ GIMT_Encode4(2364967), // Rule ID 50618 //
     /* 2364927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2364930 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2364933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2364947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2364956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364966 */     // GIR_Coverage, 50618,
     /* 2364966 */     GIR_EraseRootFromParent_Done,
     /* 2364967 */   // Label 33173: @2364967
     /* 2364967 */   GIM_Try, /*On fail goto*//*Label 33174*/ GIMT_Encode4(2365012), // Rule ID 50619 //
     /* 2364972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2364975 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2364978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2364992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365011 */     // GIR_Coverage, 50619,
     /* 2365011 */     GIR_EraseRootFromParent_Done,
     /* 2365012 */   // Label 33174: @2365012
     /* 2365012 */   GIM_Reject,
     /* 2365013 */ // Label 33172: @2365013
     /* 2365013 */ GIM_Reject,
     /* 2365014 */ // Label 33126: @2365014
     /* 2365014 */ GIM_Try, /*On fail goto*//*Label 33175*/ GIMT_Encode4(2365128),
     /* 2365019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2365022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2365025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365037 */   GIM_Try, /*On fail goto*//*Label 33176*/ GIMT_Encode4(2365082), // Rule ID 50654 //
     /* 2365042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365045 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2365048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365081 */     // GIR_Coverage, 50654,
     /* 2365081 */     GIR_EraseRootFromParent_Done,
     /* 2365082 */   // Label 33176: @2365082
     /* 2365082 */   GIM_Try, /*On fail goto*//*Label 33177*/ GIMT_Encode4(2365127), // Rule ID 50655 //
     /* 2365087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365090 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2365093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365126 */     // GIR_Coverage, 50655,
     /* 2365126 */     GIR_EraseRootFromParent_Done,
     /* 2365127 */   // Label 33177: @2365127
     /* 2365127 */   GIM_Reject,
     /* 2365128 */ // Label 33175: @2365128
     /* 2365128 */ GIM_Reject,
     /* 2365129 */ // Label 33127: @2365129
     /* 2365129 */ GIM_Try, /*On fail goto*//*Label 33178*/ GIMT_Encode4(2365243),
     /* 2365134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2365137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2365140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365152 */   GIM_Try, /*On fail goto*//*Label 33179*/ GIMT_Encode4(2365197), // Rule ID 50670 //
     /* 2365157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2365160 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2365163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365196 */     // GIR_Coverage, 50670,
     /* 2365196 */     GIR_EraseRootFromParent_Done,
     /* 2365197 */   // Label 33179: @2365197
     /* 2365197 */   GIM_Try, /*On fail goto*//*Label 33180*/ GIMT_Encode4(2365242), // Rule ID 50671 //
     /* 2365202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2365205 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2365208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365241 */     // GIR_Coverage, 50671,
     /* 2365241 */     GIR_EraseRootFromParent_Done,
     /* 2365242 */   // Label 33180: @2365242
     /* 2365242 */   GIM_Reject,
     /* 2365243 */ // Label 33178: @2365243
     /* 2365243 */ GIM_Reject,
     /* 2365244 */ // Label 33128: @2365244
     /* 2365244 */ GIM_Try, /*On fail goto*//*Label 33181*/ GIMT_Encode4(2365358),
     /* 2365249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2365252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2365255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365267 */   GIM_Try, /*On fail goto*//*Label 33182*/ GIMT_Encode4(2365312), // Rule ID 50614 //
     /* 2365272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365275 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2365278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2365292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365311 */     // GIR_Coverage, 50614,
     /* 2365311 */     GIR_EraseRootFromParent_Done,
     /* 2365312 */   // Label 33182: @2365312
     /* 2365312 */   GIM_Try, /*On fail goto*//*Label 33183*/ GIMT_Encode4(2365357), // Rule ID 50615 //
     /* 2365317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365320 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2365323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2365337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365356 */     // GIR_Coverage, 50615,
     /* 2365356 */     GIR_EraseRootFromParent_Done,
     /* 2365357 */   // Label 33183: @2365357
     /* 2365357 */   GIM_Reject,
     /* 2365358 */ // Label 33181: @2365358
     /* 2365358 */ GIM_Reject,
     /* 2365359 */ // Label 33129: @2365359
     /* 2365359 */ GIM_Try, /*On fail goto*//*Label 33184*/ GIMT_Encode4(2365473),
     /* 2365364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2365367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2365370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365382 */   GIM_Try, /*On fail goto*//*Label 33185*/ GIMT_Encode4(2365427), // Rule ID 50642 //
     /* 2365387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365390 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2365393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365426 */     // GIR_Coverage, 50642,
     /* 2365426 */     GIR_EraseRootFromParent_Done,
     /* 2365427 */   // Label 33185: @2365427
     /* 2365427 */   GIM_Try, /*On fail goto*//*Label 33186*/ GIMT_Encode4(2365472), // Rule ID 50643 //
     /* 2365432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365435 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2365438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365471 */     // GIR_Coverage, 50643,
     /* 2365471 */     GIR_EraseRootFromParent_Done,
     /* 2365472 */   // Label 33186: @2365472
     /* 2365472 */   GIM_Reject,
     /* 2365473 */ // Label 33184: @2365473
     /* 2365473 */ GIM_Reject,
     /* 2365474 */ // Label 33130: @2365474
     /* 2365474 */ GIM_Try, /*On fail goto*//*Label 33187*/ GIMT_Encode4(2365588),
     /* 2365479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2365482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2365485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365497 */   GIM_Try, /*On fail goto*//*Label 33188*/ GIMT_Encode4(2365542), // Rule ID 50658 //
     /* 2365502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365505 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2365508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365541 */     // GIR_Coverage, 50658,
     /* 2365541 */     GIR_EraseRootFromParent_Done,
     /* 2365542 */   // Label 33188: @2365542
     /* 2365542 */   GIM_Try, /*On fail goto*//*Label 33189*/ GIMT_Encode4(2365587), // Rule ID 50659 //
     /* 2365547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365550 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2365553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365586 */     // GIR_Coverage, 50659,
     /* 2365586 */     GIR_EraseRootFromParent_Done,
     /* 2365587 */   // Label 33189: @2365587
     /* 2365587 */   GIM_Reject,
     /* 2365588 */ // Label 33187: @2365588
     /* 2365588 */ GIM_Reject,
     /* 2365589 */ // Label 33131: @2365589
     /* 2365589 */ GIM_Try, /*On fail goto*//*Label 33190*/ GIMT_Encode4(2365703),
     /* 2365594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2365597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2365600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365612 */   GIM_Try, /*On fail goto*//*Label 33191*/ GIMT_Encode4(2365657), // Rule ID 50674 //
     /* 2365617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2365620 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2365623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2365637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365656 */     // GIR_Coverage, 50674,
     /* 2365656 */     GIR_EraseRootFromParent_Done,
     /* 2365657 */   // Label 33191: @2365657
     /* 2365657 */   GIM_Try, /*On fail goto*//*Label 33192*/ GIMT_Encode4(2365702), // Rule ID 50675 //
     /* 2365662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2365665 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2365668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2365682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2365697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365701 */     // GIR_Coverage, 50675,
     /* 2365701 */     GIR_EraseRootFromParent_Done,
     /* 2365702 */   // Label 33192: @2365702
     /* 2365702 */   GIM_Reject,
     /* 2365703 */ // Label 33190: @2365703
     /* 2365703 */ GIM_Reject,
     /* 2365704 */ // Label 33132: @2365704
     /* 2365704 */ GIM_Try, /*On fail goto*//*Label 33193*/ GIMT_Encode4(2365818),
     /* 2365709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2365712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2365715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2365727 */   GIM_Try, /*On fail goto*//*Label 33194*/ GIMT_Encode4(2365772), // Rule ID 50630 //
     /* 2365732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365735 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2365738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365771 */     // GIR_Coverage, 50630,
     /* 2365771 */     GIR_EraseRootFromParent_Done,
     /* 2365772 */   // Label 33194: @2365772
     /* 2365772 */   GIM_Try, /*On fail goto*//*Label 33195*/ GIMT_Encode4(2365817), // Rule ID 50631 //
     /* 2365777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365780 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2365783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2365797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365816 */     // GIR_Coverage, 50631,
     /* 2365816 */     GIR_EraseRootFromParent_Done,
     /* 2365817 */   // Label 33195: @2365817
     /* 2365817 */   GIM_Reject,
     /* 2365818 */ // Label 33193: @2365818
     /* 2365818 */ GIM_Reject,
     /* 2365819 */ // Label 33133: @2365819
     /* 2365819 */ GIM_Try, /*On fail goto*//*Label 33196*/ GIMT_Encode4(2365933),
     /* 2365824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2365827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2365830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365842 */   GIM_Try, /*On fail goto*//*Label 33197*/ GIMT_Encode4(2365887), // Rule ID 50646 //
     /* 2365847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365850 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365872 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365886 */     // GIR_Coverage, 50646,
     /* 2365886 */     GIR_EraseRootFromParent_Done,
     /* 2365887 */   // Label 33197: @2365887
     /* 2365887 */   GIM_Try, /*On fail goto*//*Label 33198*/ GIMT_Encode4(2365932), // Rule ID 50647 //
     /* 2365892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2365895 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2365912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365931 */     // GIR_Coverage, 50647,
     /* 2365931 */     GIR_EraseRootFromParent_Done,
     /* 2365932 */   // Label 33198: @2365932
     /* 2365932 */   GIM_Reject,
     /* 2365933 */ // Label 33196: @2365933
     /* 2365933 */ GIM_Reject,
     /* 2365934 */ // Label 33134: @2365934
     /* 2365934 */ GIM_Try, /*On fail goto*//*Label 33199*/ GIMT_Encode4(2366048),
     /* 2365939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2365942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2365945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365957 */   GIM_Try, /*On fail goto*//*Label 33200*/ GIMT_Encode4(2366002), // Rule ID 50662 //
     /* 2365962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2365965 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2365968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2365982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2365991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366001 */     // GIR_Coverage, 50662,
     /* 2366001 */     GIR_EraseRootFromParent_Done,
     /* 2366002 */   // Label 33200: @2366002
     /* 2366002 */   GIM_Try, /*On fail goto*//*Label 33201*/ GIMT_Encode4(2366047), // Rule ID 50663 //
     /* 2366007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366010 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2366013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366046 */     // GIR_Coverage, 50663,
     /* 2366046 */     GIR_EraseRootFromParent_Done,
     /* 2366047 */   // Label 33201: @2366047
     /* 2366047 */   GIM_Reject,
     /* 2366048 */ // Label 33199: @2366048
     /* 2366048 */ GIM_Reject,
     /* 2366049 */ // Label 33135: @2366049
     /* 2366049 */ GIM_Try, /*On fail goto*//*Label 33202*/ GIMT_Encode4(2366163),
     /* 2366054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2366057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2366060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366072 */   GIM_Try, /*On fail goto*//*Label 33203*/ GIMT_Encode4(2366117), // Rule ID 50634 //
     /* 2366077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366080 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2366083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2366097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366116 */     // GIR_Coverage, 50634,
     /* 2366116 */     GIR_EraseRootFromParent_Done,
     /* 2366117 */   // Label 33203: @2366117
     /* 2366117 */   GIM_Try, /*On fail goto*//*Label 33204*/ GIMT_Encode4(2366162), // Rule ID 50635 //
     /* 2366122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366125 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2366128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2366142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366144 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366161 */     // GIR_Coverage, 50635,
     /* 2366161 */     GIR_EraseRootFromParent_Done,
     /* 2366162 */   // Label 33204: @2366162
     /* 2366162 */   GIM_Reject,
     /* 2366163 */ // Label 33202: @2366163
     /* 2366163 */ GIM_Reject,
     /* 2366164 */ // Label 33136: @2366164
     /* 2366164 */ GIM_Try, /*On fail goto*//*Label 33205*/ GIMT_Encode4(2366278),
     /* 2366169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2366172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2366175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366187 */   GIM_Try, /*On fail goto*//*Label 33206*/ GIMT_Encode4(2366232), // Rule ID 50650 //
     /* 2366192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366195 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2366198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366231 */     // GIR_Coverage, 50650,
     /* 2366231 */     GIR_EraseRootFromParent_Done,
     /* 2366232 */   // Label 33206: @2366232
     /* 2366232 */   GIM_Try, /*On fail goto*//*Label 33207*/ GIMT_Encode4(2366277), // Rule ID 50651 //
     /* 2366237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366240 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2366243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366276 */     // GIR_Coverage, 50651,
     /* 2366276 */     GIR_EraseRootFromParent_Done,
     /* 2366277 */   // Label 33207: @2366277
     /* 2366277 */   GIM_Reject,
     /* 2366278 */ // Label 33205: @2366278
     /* 2366278 */ GIM_Reject,
     /* 2366279 */ // Label 33137: @2366279
     /* 2366279 */ GIM_Try, /*On fail goto*//*Label 33208*/ GIMT_Encode4(2366393),
     /* 2366284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2366287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2366290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366298 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2366302 */   GIM_Try, /*On fail goto*//*Label 33209*/ GIMT_Encode4(2366347), // Rule ID 50638 //
     /* 2366307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366310 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2366313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366346 */     // GIR_Coverage, 50638,
     /* 2366346 */     GIR_EraseRootFromParent_Done,
     /* 2366347 */   // Label 33209: @2366347
     /* 2366347 */   GIM_Try, /*On fail goto*//*Label 33210*/ GIMT_Encode4(2366392), // Rule ID 50639 //
     /* 2366352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366355 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2366358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2366372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366391 */     // GIR_Coverage, 50639,
     /* 2366391 */     GIR_EraseRootFromParent_Done,
     /* 2366392 */   // Label 33210: @2366392
     /* 2366392 */   GIM_Reject,
     /* 2366393 */ // Label 33208: @2366393
     /* 2366393 */ GIM_Reject,
     /* 2366394 */ // Label 33138: @2366394
     /* 2366394 */ GIM_Reject,
     /* 2366395 */ // Label 81: @2366395
     /* 2366395 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33235*/ GIMT_Encode4(2369170),
     /* 2366406 */ /*GILLT_s32*//*Label 33211*/ GIMT_Encode4(2366530),
     /* 2366410 */ /*GILLT_s64*//*Label 33212*/ GIMT_Encode4(2366585), GIMT_Encode4(0),
     /* 2366418 */ /*GILLT_nxv1s8*//*Label 33213*/ GIMT_Encode4(2366640),
     /* 2366422 */ /*GILLT_nxv1s16*//*Label 33214*/ GIMT_Encode4(2366755),
     /* 2366426 */ /*GILLT_nxv1s32*//*Label 33215*/ GIMT_Encode4(2366870),
     /* 2366430 */ /*GILLT_nxv1s64*//*Label 33216*/ GIMT_Encode4(2366985), GIMT_Encode4(0),
     /* 2366438 */ /*GILLT_nxv2s8*//*Label 33217*/ GIMT_Encode4(2367100),
     /* 2366442 */ /*GILLT_nxv2s16*//*Label 33218*/ GIMT_Encode4(2367215),
     /* 2366446 */ /*GILLT_nxv2s32*//*Label 33219*/ GIMT_Encode4(2367330),
     /* 2366450 */ /*GILLT_nxv2s64*//*Label 33220*/ GIMT_Encode4(2367445), GIMT_Encode4(0),
     /* 2366458 */ /*GILLT_nxv4s8*//*Label 33221*/ GIMT_Encode4(2367560),
     /* 2366462 */ /*GILLT_nxv4s16*//*Label 33222*/ GIMT_Encode4(2367675),
     /* 2366466 */ /*GILLT_nxv4s32*//*Label 33223*/ GIMT_Encode4(2367790),
     /* 2366470 */ /*GILLT_nxv4s64*//*Label 33224*/ GIMT_Encode4(2367905), GIMT_Encode4(0),
     /* 2366478 */ /*GILLT_nxv8s8*//*Label 33225*/ GIMT_Encode4(2368020),
     /* 2366482 */ /*GILLT_nxv8s16*//*Label 33226*/ GIMT_Encode4(2368135),
     /* 2366486 */ /*GILLT_nxv8s32*//*Label 33227*/ GIMT_Encode4(2368250),
     /* 2366490 */ /*GILLT_nxv8s64*//*Label 33228*/ GIMT_Encode4(2368365), GIMT_Encode4(0),
     /* 2366498 */ /*GILLT_nxv16s8*//*Label 33229*/ GIMT_Encode4(2368480),
     /* 2366502 */ /*GILLT_nxv16s16*//*Label 33230*/ GIMT_Encode4(2368595),
     /* 2366506 */ /*GILLT_nxv16s32*//*Label 33231*/ GIMT_Encode4(2368710), GIMT_Encode4(0),
     /* 2366514 */ /*GILLT_nxv32s8*//*Label 33232*/ GIMT_Encode4(2368825),
     /* 2366518 */ /*GILLT_nxv32s16*//*Label 33233*/ GIMT_Encode4(2368940), GIMT_Encode4(0),
     /* 2366526 */ /*GILLT_nxv64s8*//*Label 33234*/ GIMT_Encode4(2369055),
     /* 2366530 */ // Label 33211: @2366530
     /* 2366530 */ GIM_Try, /*On fail goto*//*Label 33236*/ GIMT_Encode4(2366584),
     /* 2366535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2366538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2366541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366553 */   GIM_Try, /*On fail goto*//*Label 33237*/ GIMT_Encode4(2366568), // Rule ID 64464 //
     /* 2366558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2366561 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2366561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2366566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366567 */     // GIR_Coverage, 64464,
     /* 2366567 */     GIR_Done,
     /* 2366568 */   // Label 33237: @2366568
     /* 2366568 */   GIM_Try, /*On fail goto*//*Label 33238*/ GIMT_Encode4(2366583), // Rule ID 2527 //
     /* 2366573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2366576 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2366576 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2366581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366582 */     // GIR_Coverage, 2527,
     /* 2366582 */     GIR_Done,
     /* 2366583 */   // Label 33238: @2366583
     /* 2366583 */   GIM_Reject,
     /* 2366584 */ // Label 33236: @2366584
     /* 2366584 */ GIM_Reject,
     /* 2366585 */ // Label 33212: @2366585
     /* 2366585 */ GIM_Try, /*On fail goto*//*Label 33239*/ GIMT_Encode4(2366639),
     /* 2366590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2366593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2366596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2366608 */   GIM_Try, /*On fail goto*//*Label 33240*/ GIMT_Encode4(2366623), // Rule ID 64463 //
     /* 2366613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2366616 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2366616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2366621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366622 */     // GIR_Coverage, 64463,
     /* 2366622 */     GIR_Done,
     /* 2366623 */   // Label 33240: @2366623
     /* 2366623 */   GIM_Try, /*On fail goto*//*Label 33241*/ GIMT_Encode4(2366638), // Rule ID 2526 //
     /* 2366628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2366631 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2366631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2366636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366637 */     // GIR_Coverage, 2526,
     /* 2366637 */     GIR_Done,
     /* 2366638 */   // Label 33241: @2366638
     /* 2366638 */   GIM_Reject,
     /* 2366639 */ // Label 33239: @2366639
     /* 2366639 */ GIM_Reject,
     /* 2366640 */ // Label 33213: @2366640
     /* 2366640 */ GIM_Try, /*On fail goto*//*Label 33242*/ GIMT_Encode4(2366754),
     /* 2366645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2366648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2366651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366663 */   GIM_Try, /*On fail goto*//*Label 33243*/ GIMT_Encode4(2366708), // Rule ID 50766 //
     /* 2366668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366671 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2366674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2366688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366707 */     // GIR_Coverage, 50766,
     /* 2366707 */     GIR_EraseRootFromParent_Done,
     /* 2366708 */   // Label 33243: @2366708
     /* 2366708 */   GIM_Try, /*On fail goto*//*Label 33244*/ GIMT_Encode4(2366753), // Rule ID 50767 //
     /* 2366713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366716 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2366719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2366733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366752 */     // GIR_Coverage, 50767,
     /* 2366752 */     GIR_EraseRootFromParent_Done,
     /* 2366753 */   // Label 33244: @2366753
     /* 2366753 */   GIM_Reject,
     /* 2366754 */ // Label 33242: @2366754
     /* 2366754 */ GIM_Reject,
     /* 2366755 */ // Label 33214: @2366755
     /* 2366755 */ GIM_Try, /*On fail goto*//*Label 33245*/ GIMT_Encode4(2366869),
     /* 2366760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2366763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2366766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366778 */   GIM_Try, /*On fail goto*//*Label 33246*/ GIMT_Encode4(2366823), // Rule ID 50778 //
     /* 2366783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366786 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2366789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2366803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366822 */     // GIR_Coverage, 50778,
     /* 2366822 */     GIR_EraseRootFromParent_Done,
     /* 2366823 */   // Label 33246: @2366823
     /* 2366823 */   GIM_Try, /*On fail goto*//*Label 33247*/ GIMT_Encode4(2366868), // Rule ID 50779 //
     /* 2366828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366831 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2366834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2366848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366867 */     // GIR_Coverage, 50779,
     /* 2366867 */     GIR_EraseRootFromParent_Done,
     /* 2366868 */   // Label 33247: @2366868
     /* 2366868 */   GIM_Reject,
     /* 2366869 */ // Label 33245: @2366869
     /* 2366869 */ GIM_Reject,
     /* 2366870 */ // Label 33215: @2366870
     /* 2366870 */ GIM_Try, /*On fail goto*//*Label 33248*/ GIMT_Encode4(2366984),
     /* 2366875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2366878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2366881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366893 */   GIM_Try, /*On fail goto*//*Label 33249*/ GIMT_Encode4(2366938), // Rule ID 50786 //
     /* 2366898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2366901 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2366918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366937 */     // GIR_Coverage, 50786,
     /* 2366937 */     GIR_EraseRootFromParent_Done,
     /* 2366938 */   // Label 33249: @2366938
     /* 2366938 */   GIM_Try, /*On fail goto*//*Label 33250*/ GIMT_Encode4(2366983), // Rule ID 50787 //
     /* 2366943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2366946 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2366963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2366972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366982 */     // GIR_Coverage, 50787,
     /* 2366982 */     GIR_EraseRootFromParent_Done,
     /* 2366983 */   // Label 33250: @2366983
     /* 2366983 */   GIM_Reject,
     /* 2366984 */ // Label 33248: @2366984
     /* 2366984 */ GIM_Reject,
     /* 2366985 */ // Label 33216: @2366985
     /* 2366985 */ GIM_Try, /*On fail goto*//*Label 33251*/ GIMT_Encode4(2367099),
     /* 2366990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2366993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2366996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367008 */   GIM_Try, /*On fail goto*//*Label 33252*/ GIMT_Encode4(2367053), // Rule ID 50802 //
     /* 2367013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2367016 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2367019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367052 */     // GIR_Coverage, 50802,
     /* 2367052 */     GIR_EraseRootFromParent_Done,
     /* 2367053 */   // Label 33252: @2367053
     /* 2367053 */   GIM_Try, /*On fail goto*//*Label 33253*/ GIMT_Encode4(2367098), // Rule ID 50803 //
     /* 2367058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2367061 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2367064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367097 */     // GIR_Coverage, 50803,
     /* 2367097 */     GIR_EraseRootFromParent_Done,
     /* 2367098 */   // Label 33253: @2367098
     /* 2367098 */   GIM_Reject,
     /* 2367099 */ // Label 33251: @2367099
     /* 2367099 */ GIM_Reject,
     /* 2367100 */ // Label 33217: @2367100
     /* 2367100 */ GIM_Try, /*On fail goto*//*Label 33254*/ GIMT_Encode4(2367214),
     /* 2367105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2367108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2367111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367123 */   GIM_Try, /*On fail goto*//*Label 33255*/ GIMT_Encode4(2367168), // Rule ID 50770 //
     /* 2367128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367131 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2367134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2367148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367167 */     // GIR_Coverage, 50770,
     /* 2367167 */     GIR_EraseRootFromParent_Done,
     /* 2367168 */   // Label 33255: @2367168
     /* 2367168 */   GIM_Try, /*On fail goto*//*Label 33256*/ GIMT_Encode4(2367213), // Rule ID 50771 //
     /* 2367173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367176 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2367179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2367193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367212 */     // GIR_Coverage, 50771,
     /* 2367212 */     GIR_EraseRootFromParent_Done,
     /* 2367213 */   // Label 33256: @2367213
     /* 2367213 */   GIM_Reject,
     /* 2367214 */ // Label 33254: @2367214
     /* 2367214 */ GIM_Reject,
     /* 2367215 */ // Label 33218: @2367215
     /* 2367215 */ GIM_Try, /*On fail goto*//*Label 33257*/ GIMT_Encode4(2367329),
     /* 2367220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2367223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2367226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367238 */   GIM_Try, /*On fail goto*//*Label 33258*/ GIMT_Encode4(2367283), // Rule ID 50782 //
     /* 2367243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367246 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2367249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2367263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367282 */     // GIR_Coverage, 50782,
     /* 2367282 */     GIR_EraseRootFromParent_Done,
     /* 2367283 */   // Label 33258: @2367283
     /* 2367283 */   GIM_Try, /*On fail goto*//*Label 33259*/ GIMT_Encode4(2367328), // Rule ID 50783 //
     /* 2367288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367291 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2367294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2367308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367327 */     // GIR_Coverage, 50783,
     /* 2367327 */     GIR_EraseRootFromParent_Done,
     /* 2367328 */   // Label 33259: @2367328
     /* 2367328 */   GIM_Reject,
     /* 2367329 */ // Label 33257: @2367329
     /* 2367329 */ GIM_Reject,
     /* 2367330 */ // Label 33219: @2367330
     /* 2367330 */ GIM_Try, /*On fail goto*//*Label 33260*/ GIMT_Encode4(2367444),
     /* 2367335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2367338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2367341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367353 */   GIM_Try, /*On fail goto*//*Label 33261*/ GIMT_Encode4(2367398), // Rule ID 50798 //
     /* 2367358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367361 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2367364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367397 */     // GIR_Coverage, 50798,
     /* 2367397 */     GIR_EraseRootFromParent_Done,
     /* 2367398 */   // Label 33261: @2367398
     /* 2367398 */   GIM_Try, /*On fail goto*//*Label 33262*/ GIMT_Encode4(2367443), // Rule ID 50799 //
     /* 2367403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367406 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2367409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367442 */     // GIR_Coverage, 50799,
     /* 2367442 */     GIR_EraseRootFromParent_Done,
     /* 2367443 */   // Label 33262: @2367443
     /* 2367443 */   GIM_Reject,
     /* 2367444 */ // Label 33260: @2367444
     /* 2367444 */ GIM_Reject,
     /* 2367445 */ // Label 33220: @2367445
     /* 2367445 */ GIM_Try, /*On fail goto*//*Label 33263*/ GIMT_Encode4(2367559),
     /* 2367450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2367453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2367456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367468 */   GIM_Try, /*On fail goto*//*Label 33264*/ GIMT_Encode4(2367513), // Rule ID 50842 //
     /* 2367473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2367476 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2367479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2367493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367512 */     // GIR_Coverage, 50842,
     /* 2367512 */     GIR_EraseRootFromParent_Done,
     /* 2367513 */   // Label 33264: @2367513
     /* 2367513 */   GIM_Try, /*On fail goto*//*Label 33265*/ GIMT_Encode4(2367558), // Rule ID 50843 //
     /* 2367518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2367521 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2367524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2367538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367557 */     // GIR_Coverage, 50843,
     /* 2367557 */     GIR_EraseRootFromParent_Done,
     /* 2367558 */   // Label 33265: @2367558
     /* 2367558 */   GIM_Reject,
     /* 2367559 */ // Label 33263: @2367559
     /* 2367559 */ GIM_Reject,
     /* 2367560 */ // Label 33221: @2367560
     /* 2367560 */ GIM_Try, /*On fail goto*//*Label 33266*/ GIMT_Encode4(2367674),
     /* 2367565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2367568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2367571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367583 */   GIM_Try, /*On fail goto*//*Label 33267*/ GIMT_Encode4(2367628), // Rule ID 50774 //
     /* 2367588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367591 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2367594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2367608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367627 */     // GIR_Coverage, 50774,
     /* 2367627 */     GIR_EraseRootFromParent_Done,
     /* 2367628 */   // Label 33267: @2367628
     /* 2367628 */   GIM_Try, /*On fail goto*//*Label 33268*/ GIMT_Encode4(2367673), // Rule ID 50775 //
     /* 2367633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367636 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2367639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2367653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367672 */     // GIR_Coverage, 50775,
     /* 2367672 */     GIR_EraseRootFromParent_Done,
     /* 2367673 */   // Label 33268: @2367673
     /* 2367673 */   GIM_Reject,
     /* 2367674 */ // Label 33266: @2367674
     /* 2367674 */ GIM_Reject,
     /* 2367675 */ // Label 33222: @2367675
     /* 2367675 */ GIM_Try, /*On fail goto*//*Label 33269*/ GIMT_Encode4(2367789),
     /* 2367680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2367683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2367686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367698 */   GIM_Try, /*On fail goto*//*Label 33270*/ GIMT_Encode4(2367743), // Rule ID 50794 //
     /* 2367703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367706 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2367709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367742 */     // GIR_Coverage, 50794,
     /* 2367742 */     GIR_EraseRootFromParent_Done,
     /* 2367743 */   // Label 33270: @2367743
     /* 2367743 */   GIM_Try, /*On fail goto*//*Label 33271*/ GIMT_Encode4(2367788), // Rule ID 50795 //
     /* 2367748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367751 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2367754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2367768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367787 */     // GIR_Coverage, 50795,
     /* 2367787 */     GIR_EraseRootFromParent_Done,
     /* 2367788 */   // Label 33271: @2367788
     /* 2367788 */   GIM_Reject,
     /* 2367789 */ // Label 33269: @2367789
     /* 2367789 */ GIM_Reject,
     /* 2367790 */ // Label 33223: @2367790
     /* 2367790 */ GIM_Try, /*On fail goto*//*Label 33272*/ GIMT_Encode4(2367904),
     /* 2367795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2367798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2367801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367813 */   GIM_Try, /*On fail goto*//*Label 33273*/ GIMT_Encode4(2367858), // Rule ID 50830 //
     /* 2367818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2367821 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2367824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2367838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367857 */     // GIR_Coverage, 50830,
     /* 2367857 */     GIR_EraseRootFromParent_Done,
     /* 2367858 */   // Label 33273: @2367858
     /* 2367858 */   GIM_Try, /*On fail goto*//*Label 33274*/ GIMT_Encode4(2367903), // Rule ID 50831 //
     /* 2367863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2367866 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2367869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2367883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367902 */     // GIR_Coverage, 50831,
     /* 2367902 */     GIR_EraseRootFromParent_Done,
     /* 2367903 */   // Label 33274: @2367903
     /* 2367903 */   GIM_Reject,
     /* 2367904 */ // Label 33272: @2367904
     /* 2367904 */ GIM_Reject,
     /* 2367905 */ // Label 33224: @2367905
     /* 2367905 */ GIM_Try, /*On fail goto*//*Label 33275*/ GIMT_Encode4(2368019),
     /* 2367910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2367913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2367916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367924 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367928 */   GIM_Try, /*On fail goto*//*Label 33276*/ GIMT_Encode4(2367973), // Rule ID 50846 //
     /* 2367933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2367936 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2367939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2367953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2367962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367972 */     // GIR_Coverage, 50846,
     /* 2367972 */     GIR_EraseRootFromParent_Done,
     /* 2367973 */   // Label 33276: @2367973
     /* 2367973 */   GIM_Try, /*On fail goto*//*Label 33277*/ GIMT_Encode4(2368018), // Rule ID 50847 //
     /* 2367978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2367981 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2367984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2367998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368017 */     // GIR_Coverage, 50847,
     /* 2368017 */     GIR_EraseRootFromParent_Done,
     /* 2368018 */   // Label 33277: @2368018
     /* 2368018 */   GIM_Reject,
     /* 2368019 */ // Label 33275: @2368019
     /* 2368019 */ GIM_Reject,
     /* 2368020 */ // Label 33225: @2368020
     /* 2368020 */ GIM_Try, /*On fail goto*//*Label 33278*/ GIMT_Encode4(2368134),
     /* 2368025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2368028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2368031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368043 */   GIM_Try, /*On fail goto*//*Label 33279*/ GIMT_Encode4(2368088), // Rule ID 50790 //
     /* 2368048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368051 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2368054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2368068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368087 */     // GIR_Coverage, 50790,
     /* 2368087 */     GIR_EraseRootFromParent_Done,
     /* 2368088 */   // Label 33279: @2368088
     /* 2368088 */   GIM_Try, /*On fail goto*//*Label 33280*/ GIMT_Encode4(2368133), // Rule ID 50791 //
     /* 2368093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368096 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2368099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2368113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368132 */     // GIR_Coverage, 50791,
     /* 2368132 */     GIR_EraseRootFromParent_Done,
     /* 2368133 */   // Label 33280: @2368133
     /* 2368133 */   GIM_Reject,
     /* 2368134 */ // Label 33278: @2368134
     /* 2368134 */ GIM_Reject,
     /* 2368135 */ // Label 33226: @2368135
     /* 2368135 */ GIM_Try, /*On fail goto*//*Label 33281*/ GIMT_Encode4(2368249),
     /* 2368140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2368143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2368146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368158 */   GIM_Try, /*On fail goto*//*Label 33282*/ GIMT_Encode4(2368203), // Rule ID 50818 //
     /* 2368163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368166 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2368169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368202 */     // GIR_Coverage, 50818,
     /* 2368202 */     GIR_EraseRootFromParent_Done,
     /* 2368203 */   // Label 33282: @2368203
     /* 2368203 */   GIM_Try, /*On fail goto*//*Label 33283*/ GIMT_Encode4(2368248), // Rule ID 50819 //
     /* 2368208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368211 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2368214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368247 */     // GIR_Coverage, 50819,
     /* 2368247 */     GIR_EraseRootFromParent_Done,
     /* 2368248 */   // Label 33283: @2368248
     /* 2368248 */   GIM_Reject,
     /* 2368249 */ // Label 33281: @2368249
     /* 2368249 */ GIM_Reject,
     /* 2368250 */ // Label 33227: @2368250
     /* 2368250 */ GIM_Try, /*On fail goto*//*Label 33284*/ GIMT_Encode4(2368364),
     /* 2368255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2368258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2368261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368273 */   GIM_Try, /*On fail goto*//*Label 33285*/ GIMT_Encode4(2368318), // Rule ID 50834 //
     /* 2368278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368281 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2368284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368317 */     // GIR_Coverage, 50834,
     /* 2368317 */     GIR_EraseRootFromParent_Done,
     /* 2368318 */   // Label 33285: @2368318
     /* 2368318 */   GIM_Try, /*On fail goto*//*Label 33286*/ GIMT_Encode4(2368363), // Rule ID 50835 //
     /* 2368323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368326 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2368329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368362 */     // GIR_Coverage, 50835,
     /* 2368362 */     GIR_EraseRootFromParent_Done,
     /* 2368363 */   // Label 33286: @2368363
     /* 2368363 */   GIM_Reject,
     /* 2368364 */ // Label 33284: @2368364
     /* 2368364 */ GIM_Reject,
     /* 2368365 */ // Label 33228: @2368365
     /* 2368365 */ GIM_Try, /*On fail goto*//*Label 33287*/ GIMT_Encode4(2368479),
     /* 2368370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2368373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2368376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368384 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368388 */   GIM_Try, /*On fail goto*//*Label 33288*/ GIMT_Encode4(2368433), // Rule ID 50850 //
     /* 2368393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2368396 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2368399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2368413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368432 */     // GIR_Coverage, 50850,
     /* 2368432 */     GIR_EraseRootFromParent_Done,
     /* 2368433 */   // Label 33288: @2368433
     /* 2368433 */   GIM_Try, /*On fail goto*//*Label 33289*/ GIMT_Encode4(2368478), // Rule ID 50851 //
     /* 2368438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2368441 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2368444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2368458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368477 */     // GIR_Coverage, 50851,
     /* 2368477 */     GIR_EraseRootFromParent_Done,
     /* 2368478 */   // Label 33289: @2368478
     /* 2368478 */   GIM_Reject,
     /* 2368479 */ // Label 33287: @2368479
     /* 2368479 */ GIM_Reject,
     /* 2368480 */ // Label 33229: @2368480
     /* 2368480 */ GIM_Try, /*On fail goto*//*Label 33290*/ GIMT_Encode4(2368594),
     /* 2368485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2368488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2368491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2368503 */   GIM_Try, /*On fail goto*//*Label 33291*/ GIMT_Encode4(2368548), // Rule ID 50806 //
     /* 2368508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368511 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368511 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2368514 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368518 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368547 */     // GIR_Coverage, 50806,
     /* 2368547 */     GIR_EraseRootFromParent_Done,
     /* 2368548 */   // Label 33291: @2368548
     /* 2368548 */   GIM_Try, /*On fail goto*//*Label 33292*/ GIMT_Encode4(2368593), // Rule ID 50807 //
     /* 2368553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368556 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2368559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2368573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368592 */     // GIR_Coverage, 50807,
     /* 2368592 */     GIR_EraseRootFromParent_Done,
     /* 2368593 */   // Label 33292: @2368593
     /* 2368593 */   GIM_Reject,
     /* 2368594 */ // Label 33290: @2368594
     /* 2368594 */ GIM_Reject,
     /* 2368595 */ // Label 33230: @2368595
     /* 2368595 */ GIM_Try, /*On fail goto*//*Label 33293*/ GIMT_Encode4(2368709),
     /* 2368600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2368603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2368606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368614 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368618 */   GIM_Try, /*On fail goto*//*Label 33294*/ GIMT_Encode4(2368663), // Rule ID 50822 //
     /* 2368623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368626 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2368629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368662 */     // GIR_Coverage, 50822,
     /* 2368662 */     GIR_EraseRootFromParent_Done,
     /* 2368663 */   // Label 33294: @2368663
     /* 2368663 */   GIM_Try, /*On fail goto*//*Label 33295*/ GIMT_Encode4(2368708), // Rule ID 50823 //
     /* 2368668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368671 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2368674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368707 */     // GIR_Coverage, 50823,
     /* 2368707 */     GIR_EraseRootFromParent_Done,
     /* 2368708 */   // Label 33295: @2368708
     /* 2368708 */   GIM_Reject,
     /* 2368709 */ // Label 33293: @2368709
     /* 2368709 */ GIM_Reject,
     /* 2368710 */ // Label 33231: @2368710
     /* 2368710 */ GIM_Try, /*On fail goto*//*Label 33296*/ GIMT_Encode4(2368824),
     /* 2368715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2368718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2368721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368733 */   GIM_Try, /*On fail goto*//*Label 33297*/ GIMT_Encode4(2368778), // Rule ID 50838 //
     /* 2368738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368741 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2368744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2368758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368777 */     // GIR_Coverage, 50838,
     /* 2368777 */     GIR_EraseRootFromParent_Done,
     /* 2368778 */   // Label 33297: @2368778
     /* 2368778 */   GIM_Try, /*On fail goto*//*Label 33298*/ GIMT_Encode4(2368823), // Rule ID 50839 //
     /* 2368783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368786 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2368789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2368803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368822 */     // GIR_Coverage, 50839,
     /* 2368822 */     GIR_EraseRootFromParent_Done,
     /* 2368823 */   // Label 33298: @2368823
     /* 2368823 */   GIM_Reject,
     /* 2368824 */ // Label 33296: @2368824
     /* 2368824 */ GIM_Reject,
     /* 2368825 */ // Label 33232: @2368825
     /* 2368825 */ GIM_Try, /*On fail goto*//*Label 33299*/ GIMT_Encode4(2368939),
     /* 2368830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2368833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2368836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2368848 */   GIM_Try, /*On fail goto*//*Label 33300*/ GIMT_Encode4(2368893), // Rule ID 50810 //
     /* 2368853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368856 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2368859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368892 */     // GIR_Coverage, 50810,
     /* 2368892 */     GIR_EraseRootFromParent_Done,
     /* 2368893 */   // Label 33300: @2368893
     /* 2368893 */   GIM_Try, /*On fail goto*//*Label 33301*/ GIMT_Encode4(2368938), // Rule ID 50811 //
     /* 2368898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2368901 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2368904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2368918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368937 */     // GIR_Coverage, 50811,
     /* 2368937 */     GIR_EraseRootFromParent_Done,
     /* 2368938 */   // Label 33301: @2368938
     /* 2368938 */   GIM_Reject,
     /* 2368939 */ // Label 33299: @2368939
     /* 2368939 */ GIM_Reject,
     /* 2368940 */ // Label 33233: @2368940
     /* 2368940 */ GIM_Try, /*On fail goto*//*Label 33302*/ GIMT_Encode4(2369054),
     /* 2368945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2368948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2368951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368963 */   GIM_Try, /*On fail goto*//*Label 33303*/ GIMT_Encode4(2369008), // Rule ID 50826 //
     /* 2368968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2368971 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2368974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2368988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2368997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369007 */     // GIR_Coverage, 50826,
     /* 2369007 */     GIR_EraseRootFromParent_Done,
     /* 2369008 */   // Label 33303: @2369008
     /* 2369008 */   GIM_Try, /*On fail goto*//*Label 33304*/ GIMT_Encode4(2369053), // Rule ID 50827 //
     /* 2369013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369016 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2369019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2369033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369052 */     // GIR_Coverage, 50827,
     /* 2369052 */     GIR_EraseRootFromParent_Done,
     /* 2369053 */   // Label 33304: @2369053
     /* 2369053 */   GIM_Reject,
     /* 2369054 */ // Label 33302: @2369054
     /* 2369054 */ GIM_Reject,
     /* 2369055 */ // Label 33234: @2369055
     /* 2369055 */ GIM_Try, /*On fail goto*//*Label 33305*/ GIMT_Encode4(2369169),
     /* 2369060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2369063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2369066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369078 */   GIM_Try, /*On fail goto*//*Label 33306*/ GIMT_Encode4(2369123), // Rule ID 50814 //
     /* 2369083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369086 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2369089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2369103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369122 */     // GIR_Coverage, 50814,
     /* 2369122 */     GIR_EraseRootFromParent_Done,
     /* 2369123 */   // Label 33306: @2369123
     /* 2369123 */   GIM_Try, /*On fail goto*//*Label 33307*/ GIMT_Encode4(2369168), // Rule ID 50815 //
     /* 2369128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369131 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2369134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2369148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369167 */     // GIR_Coverage, 50815,
     /* 2369167 */     GIR_EraseRootFromParent_Done,
     /* 2369168 */   // Label 33307: @2369168
     /* 2369168 */   GIM_Reject,
     /* 2369169 */ // Label 33305: @2369169
     /* 2369169 */ GIM_Reject,
     /* 2369170 */ // Label 33235: @2369170
     /* 2369170 */ GIM_Reject,
     /* 2369171 */ // Label 82: @2369171
     /* 2369171 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33332*/ GIMT_Encode4(2371946),
     /* 2369182 */ /*GILLT_s32*//*Label 33308*/ GIMT_Encode4(2369306),
     /* 2369186 */ /*GILLT_s64*//*Label 33309*/ GIMT_Encode4(2369361), GIMT_Encode4(0),
     /* 2369194 */ /*GILLT_nxv1s8*//*Label 33310*/ GIMT_Encode4(2369416),
     /* 2369198 */ /*GILLT_nxv1s16*//*Label 33311*/ GIMT_Encode4(2369531),
     /* 2369202 */ /*GILLT_nxv1s32*//*Label 33312*/ GIMT_Encode4(2369646),
     /* 2369206 */ /*GILLT_nxv1s64*//*Label 33313*/ GIMT_Encode4(2369761), GIMT_Encode4(0),
     /* 2369214 */ /*GILLT_nxv2s8*//*Label 33314*/ GIMT_Encode4(2369876),
     /* 2369218 */ /*GILLT_nxv2s16*//*Label 33315*/ GIMT_Encode4(2369991),
     /* 2369222 */ /*GILLT_nxv2s32*//*Label 33316*/ GIMT_Encode4(2370106),
     /* 2369226 */ /*GILLT_nxv2s64*//*Label 33317*/ GIMT_Encode4(2370221), GIMT_Encode4(0),
     /* 2369234 */ /*GILLT_nxv4s8*//*Label 33318*/ GIMT_Encode4(2370336),
     /* 2369238 */ /*GILLT_nxv4s16*//*Label 33319*/ GIMT_Encode4(2370451),
     /* 2369242 */ /*GILLT_nxv4s32*//*Label 33320*/ GIMT_Encode4(2370566),
     /* 2369246 */ /*GILLT_nxv4s64*//*Label 33321*/ GIMT_Encode4(2370681), GIMT_Encode4(0),
     /* 2369254 */ /*GILLT_nxv8s8*//*Label 33322*/ GIMT_Encode4(2370796),
     /* 2369258 */ /*GILLT_nxv8s16*//*Label 33323*/ GIMT_Encode4(2370911),
     /* 2369262 */ /*GILLT_nxv8s32*//*Label 33324*/ GIMT_Encode4(2371026),
     /* 2369266 */ /*GILLT_nxv8s64*//*Label 33325*/ GIMT_Encode4(2371141), GIMT_Encode4(0),
     /* 2369274 */ /*GILLT_nxv16s8*//*Label 33326*/ GIMT_Encode4(2371256),
     /* 2369278 */ /*GILLT_nxv16s16*//*Label 33327*/ GIMT_Encode4(2371371),
     /* 2369282 */ /*GILLT_nxv16s32*//*Label 33328*/ GIMT_Encode4(2371486), GIMT_Encode4(0),
     /* 2369290 */ /*GILLT_nxv32s8*//*Label 33329*/ GIMT_Encode4(2371601),
     /* 2369294 */ /*GILLT_nxv32s16*//*Label 33330*/ GIMT_Encode4(2371716), GIMT_Encode4(0),
     /* 2369302 */ /*GILLT_nxv64s8*//*Label 33331*/ GIMT_Encode4(2371831),
     /* 2369306 */ // Label 33308: @2369306
     /* 2369306 */ GIM_Try, /*On fail goto*//*Label 33333*/ GIMT_Encode4(2369360),
     /* 2369311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2369314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2369317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369329 */   GIM_Try, /*On fail goto*//*Label 33334*/ GIMT_Encode4(2369344), // Rule ID 64462 //
     /* 2369334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2369337 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2369342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369343 */     // GIR_Coverage, 64462,
     /* 2369343 */     GIR_Done,
     /* 2369344 */   // Label 33334: @2369344
     /* 2369344 */   GIM_Try, /*On fail goto*//*Label 33335*/ GIMT_Encode4(2369359), // Rule ID 2529 //
     /* 2369349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2369352 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2369352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2369357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369358 */     // GIR_Coverage, 2529,
     /* 2369358 */     GIR_Done,
     /* 2369359 */   // Label 33335: @2369359
     /* 2369359 */   GIM_Reject,
     /* 2369360 */ // Label 33333: @2369360
     /* 2369360 */ GIM_Reject,
     /* 2369361 */ // Label 33309: @2369361
     /* 2369361 */ GIM_Try, /*On fail goto*//*Label 33336*/ GIMT_Encode4(2369415),
     /* 2369366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2369369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2369372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2369384 */   GIM_Try, /*On fail goto*//*Label 33337*/ GIMT_Encode4(2369399), // Rule ID 64461 //
     /* 2369389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2369392 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2369392 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2369397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369398 */     // GIR_Coverage, 64461,
     /* 2369398 */     GIR_Done,
     /* 2369399 */   // Label 33337: @2369399
     /* 2369399 */   GIM_Try, /*On fail goto*//*Label 33338*/ GIMT_Encode4(2369414), // Rule ID 2528 //
     /* 2369404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2369407 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2369407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2369412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369413 */     // GIR_Coverage, 2528,
     /* 2369413 */     GIR_Done,
     /* 2369414 */   // Label 33338: @2369414
     /* 2369414 */   GIM_Reject,
     /* 2369415 */ // Label 33336: @2369415
     /* 2369415 */ GIM_Reject,
     /* 2369416 */ // Label 33310: @2369416
     /* 2369416 */ GIM_Try, /*On fail goto*//*Label 33339*/ GIMT_Encode4(2369530),
     /* 2369421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2369424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2369427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369439 */   GIM_Try, /*On fail goto*//*Label 33340*/ GIMT_Encode4(2369484), // Rule ID 50502 //
     /* 2369444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369447 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2369450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2369464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369483 */     // GIR_Coverage, 50502,
     /* 2369483 */     GIR_EraseRootFromParent_Done,
     /* 2369484 */   // Label 33340: @2369484
     /* 2369484 */   GIM_Try, /*On fail goto*//*Label 33341*/ GIMT_Encode4(2369529), // Rule ID 50503 //
     /* 2369489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369492 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2369495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2369509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369528 */     // GIR_Coverage, 50503,
     /* 2369528 */     GIR_EraseRootFromParent_Done,
     /* 2369529 */   // Label 33341: @2369529
     /* 2369529 */   GIM_Reject,
     /* 2369530 */ // Label 33339: @2369530
     /* 2369530 */ GIM_Reject,
     /* 2369531 */ // Label 33311: @2369531
     /* 2369531 */ GIM_Try, /*On fail goto*//*Label 33342*/ GIMT_Encode4(2369645),
     /* 2369536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2369539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2369542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369554 */   GIM_Try, /*On fail goto*//*Label 33343*/ GIMT_Encode4(2369599), // Rule ID 50514 //
     /* 2369559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369562 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2369565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2369579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369598 */     // GIR_Coverage, 50514,
     /* 2369598 */     GIR_EraseRootFromParent_Done,
     /* 2369599 */   // Label 33343: @2369599
     /* 2369599 */   GIM_Try, /*On fail goto*//*Label 33344*/ GIMT_Encode4(2369644), // Rule ID 50515 //
     /* 2369604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369607 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2369610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2369624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369643 */     // GIR_Coverage, 50515,
     /* 2369643 */     GIR_EraseRootFromParent_Done,
     /* 2369644 */   // Label 33344: @2369644
     /* 2369644 */   GIM_Reject,
     /* 2369645 */ // Label 33342: @2369645
     /* 2369645 */ GIM_Reject,
     /* 2369646 */ // Label 33312: @2369646
     /* 2369646 */ GIM_Try, /*On fail goto*//*Label 33345*/ GIMT_Encode4(2369760),
     /* 2369651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2369654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2369657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369669 */   GIM_Try, /*On fail goto*//*Label 33346*/ GIMT_Encode4(2369714), // Rule ID 50522 //
     /* 2369674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369677 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2369680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2369694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369713 */     // GIR_Coverage, 50522,
     /* 2369713 */     GIR_EraseRootFromParent_Done,
     /* 2369714 */   // Label 33346: @2369714
     /* 2369714 */   GIM_Try, /*On fail goto*//*Label 33347*/ GIMT_Encode4(2369759), // Rule ID 50523 //
     /* 2369719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369722 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2369725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2369739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369758 */     // GIR_Coverage, 50523,
     /* 2369758 */     GIR_EraseRootFromParent_Done,
     /* 2369759 */   // Label 33347: @2369759
     /* 2369759 */   GIM_Reject,
     /* 2369760 */ // Label 33345: @2369760
     /* 2369760 */ GIM_Reject,
     /* 2369761 */ // Label 33313: @2369761
     /* 2369761 */ GIM_Try, /*On fail goto*//*Label 33348*/ GIMT_Encode4(2369875),
     /* 2369766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2369769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2369772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369784 */   GIM_Try, /*On fail goto*//*Label 33349*/ GIMT_Encode4(2369829), // Rule ID 50538 //
     /* 2369789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2369792 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2369795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2369809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369828 */     // GIR_Coverage, 50538,
     /* 2369828 */     GIR_EraseRootFromParent_Done,
     /* 2369829 */   // Label 33349: @2369829
     /* 2369829 */   GIM_Try, /*On fail goto*//*Label 33350*/ GIMT_Encode4(2369874), // Rule ID 50539 //
     /* 2369834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2369837 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2369840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2369854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369873 */     // GIR_Coverage, 50539,
     /* 2369873 */     GIR_EraseRootFromParent_Done,
     /* 2369874 */   // Label 33350: @2369874
     /* 2369874 */   GIM_Reject,
     /* 2369875 */ // Label 33348: @2369875
     /* 2369875 */ GIM_Reject,
     /* 2369876 */ // Label 33314: @2369876
     /* 2369876 */ GIM_Try, /*On fail goto*//*Label 33351*/ GIMT_Encode4(2369990),
     /* 2369881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2369884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2369887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369899 */   GIM_Try, /*On fail goto*//*Label 33352*/ GIMT_Encode4(2369944), // Rule ID 50506 //
     /* 2369904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2369907 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2369910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2369924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369943 */     // GIR_Coverage, 50506,
     /* 2369943 */     GIR_EraseRootFromParent_Done,
     /* 2369944 */   // Label 33352: @2369944
     /* 2369944 */   GIM_Try, /*On fail goto*//*Label 33353*/ GIMT_Encode4(2369989), // Rule ID 50507 //
     /* 2369949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2369952 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2369955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2369969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2369978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369988 */     // GIR_Coverage, 50507,
     /* 2369988 */     GIR_EraseRootFromParent_Done,
     /* 2369989 */   // Label 33353: @2369989
     /* 2369989 */   GIM_Reject,
     /* 2369990 */ // Label 33351: @2369990
     /* 2369990 */ GIM_Reject,
     /* 2369991 */ // Label 33315: @2369991
     /* 2369991 */ GIM_Try, /*On fail goto*//*Label 33354*/ GIMT_Encode4(2370105),
     /* 2369996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2369999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2370002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370014 */   GIM_Try, /*On fail goto*//*Label 33355*/ GIMT_Encode4(2370059), // Rule ID 50518 //
     /* 2370019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370022 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370058 */     // GIR_Coverage, 50518,
     /* 2370058 */     GIR_EraseRootFromParent_Done,
     /* 2370059 */   // Label 33355: @2370059
     /* 2370059 */   GIM_Try, /*On fail goto*//*Label 33356*/ GIMT_Encode4(2370104), // Rule ID 50519 //
     /* 2370064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370067 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2370070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370103 */     // GIR_Coverage, 50519,
     /* 2370103 */     GIR_EraseRootFromParent_Done,
     /* 2370104 */   // Label 33356: @2370104
     /* 2370104 */   GIM_Reject,
     /* 2370105 */ // Label 33354: @2370105
     /* 2370105 */ GIM_Reject,
     /* 2370106 */ // Label 33316: @2370106
     /* 2370106 */ GIM_Try, /*On fail goto*//*Label 33357*/ GIMT_Encode4(2370220),
     /* 2370111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2370114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2370117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370129 */   GIM_Try, /*On fail goto*//*Label 33358*/ GIMT_Encode4(2370174), // Rule ID 50534 //
     /* 2370134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370137 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370173 */     // GIR_Coverage, 50534,
     /* 2370173 */     GIR_EraseRootFromParent_Done,
     /* 2370174 */   // Label 33358: @2370174
     /* 2370174 */   GIM_Try, /*On fail goto*//*Label 33359*/ GIMT_Encode4(2370219), // Rule ID 50535 //
     /* 2370179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370182 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2370185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370218 */     // GIR_Coverage, 50535,
     /* 2370218 */     GIR_EraseRootFromParent_Done,
     /* 2370219 */   // Label 33359: @2370219
     /* 2370219 */   GIM_Reject,
     /* 2370220 */ // Label 33357: @2370220
     /* 2370220 */ GIM_Reject,
     /* 2370221 */ // Label 33317: @2370221
     /* 2370221 */ GIM_Try, /*On fail goto*//*Label 33360*/ GIMT_Encode4(2370335),
     /* 2370226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2370229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2370232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370244 */   GIM_Try, /*On fail goto*//*Label 33361*/ GIMT_Encode4(2370289), // Rule ID 50578 //
     /* 2370249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370252 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2370269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370288 */     // GIR_Coverage, 50578,
     /* 2370288 */     GIR_EraseRootFromParent_Done,
     /* 2370289 */   // Label 33361: @2370289
     /* 2370289 */   GIM_Try, /*On fail goto*//*Label 33362*/ GIMT_Encode4(2370334), // Rule ID 50579 //
     /* 2370294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370297 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2370300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2370314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370333 */     // GIR_Coverage, 50579,
     /* 2370333 */     GIR_EraseRootFromParent_Done,
     /* 2370334 */   // Label 33362: @2370334
     /* 2370334 */   GIM_Reject,
     /* 2370335 */ // Label 33360: @2370335
     /* 2370335 */ GIM_Reject,
     /* 2370336 */ // Label 33318: @2370336
     /* 2370336 */ GIM_Try, /*On fail goto*//*Label 33363*/ GIMT_Encode4(2370450),
     /* 2370341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2370344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2370347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370359 */   GIM_Try, /*On fail goto*//*Label 33364*/ GIMT_Encode4(2370404), // Rule ID 50510 //
     /* 2370364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370367 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2370370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370403 */     // GIR_Coverage, 50510,
     /* 2370403 */     GIR_EraseRootFromParent_Done,
     /* 2370404 */   // Label 33364: @2370404
     /* 2370404 */   GIM_Try, /*On fail goto*//*Label 33365*/ GIMT_Encode4(2370449), // Rule ID 50511 //
     /* 2370409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370412 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2370415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2370429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370448 */     // GIR_Coverage, 50511,
     /* 2370448 */     GIR_EraseRootFromParent_Done,
     /* 2370449 */   // Label 33365: @2370449
     /* 2370449 */   GIM_Reject,
     /* 2370450 */ // Label 33363: @2370450
     /* 2370450 */ GIM_Reject,
     /* 2370451 */ // Label 33319: @2370451
     /* 2370451 */ GIM_Try, /*On fail goto*//*Label 33366*/ GIMT_Encode4(2370565),
     /* 2370456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2370459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2370462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370474 */   GIM_Try, /*On fail goto*//*Label 33367*/ GIMT_Encode4(2370519), // Rule ID 50530 //
     /* 2370479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370482 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2370485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370518 */     // GIR_Coverage, 50530,
     /* 2370518 */     GIR_EraseRootFromParent_Done,
     /* 2370519 */   // Label 33367: @2370519
     /* 2370519 */   GIM_Try, /*On fail goto*//*Label 33368*/ GIMT_Encode4(2370564), // Rule ID 50531 //
     /* 2370524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370527 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2370530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370563 */     // GIR_Coverage, 50531,
     /* 2370563 */     GIR_EraseRootFromParent_Done,
     /* 2370564 */   // Label 33368: @2370564
     /* 2370564 */   GIM_Reject,
     /* 2370565 */ // Label 33366: @2370565
     /* 2370565 */ GIM_Reject,
     /* 2370566 */ // Label 33320: @2370566
     /* 2370566 */ GIM_Try, /*On fail goto*//*Label 33369*/ GIMT_Encode4(2370680),
     /* 2370571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2370574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2370577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370589 */   GIM_Try, /*On fail goto*//*Label 33370*/ GIMT_Encode4(2370634), // Rule ID 50566 //
     /* 2370594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370597 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2370600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2370614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370633 */     // GIR_Coverage, 50566,
     /* 2370633 */     GIR_EraseRootFromParent_Done,
     /* 2370634 */   // Label 33370: @2370634
     /* 2370634 */   GIM_Try, /*On fail goto*//*Label 33371*/ GIMT_Encode4(2370679), // Rule ID 50567 //
     /* 2370639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370642 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2370645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2370659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370678 */     // GIR_Coverage, 50567,
     /* 2370678 */     GIR_EraseRootFromParent_Done,
     /* 2370679 */   // Label 33371: @2370679
     /* 2370679 */   GIM_Reject,
     /* 2370680 */ // Label 33369: @2370680
     /* 2370680 */ GIM_Reject,
     /* 2370681 */ // Label 33321: @2370681
     /* 2370681 */ GIM_Try, /*On fail goto*//*Label 33372*/ GIMT_Encode4(2370795),
     /* 2370686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2370689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2370692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370704 */   GIM_Try, /*On fail goto*//*Label 33373*/ GIMT_Encode4(2370749), // Rule ID 50582 //
     /* 2370709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2370712 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2370715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2370729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370748 */     // GIR_Coverage, 50582,
     /* 2370748 */     GIR_EraseRootFromParent_Done,
     /* 2370749 */   // Label 33373: @2370749
     /* 2370749 */   GIM_Try, /*On fail goto*//*Label 33374*/ GIMT_Encode4(2370794), // Rule ID 50583 //
     /* 2370754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2370757 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2370760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2370774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370793 */     // GIR_Coverage, 50583,
     /* 2370793 */     GIR_EraseRootFromParent_Done,
     /* 2370794 */   // Label 33374: @2370794
     /* 2370794 */   GIM_Reject,
     /* 2370795 */ // Label 33372: @2370795
     /* 2370795 */ GIM_Reject,
     /* 2370796 */ // Label 33322: @2370796
     /* 2370796 */ GIM_Try, /*On fail goto*//*Label 33375*/ GIMT_Encode4(2370910),
     /* 2370801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2370804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2370807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370819 */   GIM_Try, /*On fail goto*//*Label 33376*/ GIMT_Encode4(2370864), // Rule ID 50526 //
     /* 2370824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370827 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2370830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370863 */     // GIR_Coverage, 50526,
     /* 2370863 */     GIR_EraseRootFromParent_Done,
     /* 2370864 */   // Label 33376: @2370864
     /* 2370864 */   GIM_Try, /*On fail goto*//*Label 33377*/ GIMT_Encode4(2370909), // Rule ID 50527 //
     /* 2370869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370872 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2370875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2370889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370908 */     // GIR_Coverage, 50527,
     /* 2370908 */     GIR_EraseRootFromParent_Done,
     /* 2370909 */   // Label 33377: @2370909
     /* 2370909 */   GIM_Reject,
     /* 2370910 */ // Label 33375: @2370910
     /* 2370910 */ GIM_Reject,
     /* 2370911 */ // Label 33323: @2370911
     /* 2370911 */ GIM_Try, /*On fail goto*//*Label 33378*/ GIMT_Encode4(2371025),
     /* 2370916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2370919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2370922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370934 */   GIM_Try, /*On fail goto*//*Label 33379*/ GIMT_Encode4(2370979), // Rule ID 50554 //
     /* 2370939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2370942 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2370945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2370959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2370968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370978 */     // GIR_Coverage, 50554,
     /* 2370978 */     GIR_EraseRootFromParent_Done,
     /* 2370979 */   // Label 33379: @2370979
     /* 2370979 */   GIM_Try, /*On fail goto*//*Label 33380*/ GIMT_Encode4(2371024), // Rule ID 50555 //
     /* 2370984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2370987 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2370990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2371004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371023 */     // GIR_Coverage, 50555,
     /* 2371023 */     GIR_EraseRootFromParent_Done,
     /* 2371024 */   // Label 33380: @2371024
     /* 2371024 */   GIM_Reject,
     /* 2371025 */ // Label 33378: @2371025
     /* 2371025 */ GIM_Reject,
     /* 2371026 */ // Label 33324: @2371026
     /* 2371026 */ GIM_Try, /*On fail goto*//*Label 33381*/ GIMT_Encode4(2371140),
     /* 2371031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2371034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2371037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371049 */   GIM_Try, /*On fail goto*//*Label 33382*/ GIMT_Encode4(2371094), // Rule ID 50570 //
     /* 2371054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371057 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371093 */     // GIR_Coverage, 50570,
     /* 2371093 */     GIR_EraseRootFromParent_Done,
     /* 2371094 */   // Label 33382: @2371094
     /* 2371094 */   GIM_Try, /*On fail goto*//*Label 33383*/ GIMT_Encode4(2371139), // Rule ID 50571 //
     /* 2371099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371102 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2371105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371138 */     // GIR_Coverage, 50571,
     /* 2371138 */     GIR_EraseRootFromParent_Done,
     /* 2371139 */   // Label 33383: @2371139
     /* 2371139 */   GIM_Reject,
     /* 2371140 */ // Label 33381: @2371140
     /* 2371140 */ GIM_Reject,
     /* 2371141 */ // Label 33325: @2371141
     /* 2371141 */ GIM_Try, /*On fail goto*//*Label 33384*/ GIMT_Encode4(2371255),
     /* 2371146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2371149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2371152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371164 */   GIM_Try, /*On fail goto*//*Label 33385*/ GIMT_Encode4(2371209), // Rule ID 50586 //
     /* 2371169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2371172 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371208 */     // GIR_Coverage, 50586,
     /* 2371208 */     GIR_EraseRootFromParent_Done,
     /* 2371209 */   // Label 33385: @2371209
     /* 2371209 */   GIM_Try, /*On fail goto*//*Label 33386*/ GIMT_Encode4(2371254), // Rule ID 50587 //
     /* 2371214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2371217 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2371220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371253 */     // GIR_Coverage, 50587,
     /* 2371253 */     GIR_EraseRootFromParent_Done,
     /* 2371254 */   // Label 33386: @2371254
     /* 2371254 */   GIM_Reject,
     /* 2371255 */ // Label 33384: @2371255
     /* 2371255 */ GIM_Reject,
     /* 2371256 */ // Label 33326: @2371256
     /* 2371256 */ GIM_Try, /*On fail goto*//*Label 33387*/ GIMT_Encode4(2371370),
     /* 2371261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2371264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2371267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371279 */   GIM_Try, /*On fail goto*//*Label 33388*/ GIMT_Encode4(2371324), // Rule ID 50542 //
     /* 2371284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371287 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2371304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371323 */     // GIR_Coverage, 50542,
     /* 2371323 */     GIR_EraseRootFromParent_Done,
     /* 2371324 */   // Label 33388: @2371324
     /* 2371324 */   GIM_Try, /*On fail goto*//*Label 33389*/ GIMT_Encode4(2371369), // Rule ID 50543 //
     /* 2371329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371332 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2371335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2371349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371368 */     // GIR_Coverage, 50543,
     /* 2371368 */     GIR_EraseRootFromParent_Done,
     /* 2371369 */   // Label 33389: @2371369
     /* 2371369 */   GIM_Reject,
     /* 2371370 */ // Label 33387: @2371370
     /* 2371370 */ GIM_Reject,
     /* 2371371 */ // Label 33327: @2371371
     /* 2371371 */ GIM_Try, /*On fail goto*//*Label 33390*/ GIMT_Encode4(2371485),
     /* 2371376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2371379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2371382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371394 */   GIM_Try, /*On fail goto*//*Label 33391*/ GIMT_Encode4(2371439), // Rule ID 50558 //
     /* 2371399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371402 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2371405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371438 */     // GIR_Coverage, 50558,
     /* 2371438 */     GIR_EraseRootFromParent_Done,
     /* 2371439 */   // Label 33391: @2371439
     /* 2371439 */   GIM_Try, /*On fail goto*//*Label 33392*/ GIMT_Encode4(2371484), // Rule ID 50559 //
     /* 2371444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371447 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2371450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371483 */     // GIR_Coverage, 50559,
     /* 2371483 */     GIR_EraseRootFromParent_Done,
     /* 2371484 */   // Label 33392: @2371484
     /* 2371484 */   GIM_Reject,
     /* 2371485 */ // Label 33390: @2371485
     /* 2371485 */ GIM_Reject,
     /* 2371486 */ // Label 33328: @2371486
     /* 2371486 */ GIM_Try, /*On fail goto*//*Label 33393*/ GIMT_Encode4(2371600),
     /* 2371491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2371494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2371497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371509 */   GIM_Try, /*On fail goto*//*Label 33394*/ GIMT_Encode4(2371554), // Rule ID 50574 //
     /* 2371514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371517 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2371520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371553 */     // GIR_Coverage, 50574,
     /* 2371553 */     GIR_EraseRootFromParent_Done,
     /* 2371554 */   // Label 33394: @2371554
     /* 2371554 */   GIM_Try, /*On fail goto*//*Label 33395*/ GIMT_Encode4(2371599), // Rule ID 50575 //
     /* 2371559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371562 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2371565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371598 */     // GIR_Coverage, 50575,
     /* 2371598 */     GIR_EraseRootFromParent_Done,
     /* 2371599 */   // Label 33395: @2371599
     /* 2371599 */   GIM_Reject,
     /* 2371600 */ // Label 33393: @2371600
     /* 2371600 */ GIM_Reject,
     /* 2371601 */ // Label 33329: @2371601
     /* 2371601 */ GIM_Try, /*On fail goto*//*Label 33396*/ GIMT_Encode4(2371715),
     /* 2371606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2371609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2371612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2371624 */   GIM_Try, /*On fail goto*//*Label 33397*/ GIMT_Encode4(2371669), // Rule ID 50546 //
     /* 2371629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371632 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2371635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371668 */     // GIR_Coverage, 50546,
     /* 2371668 */     GIR_EraseRootFromParent_Done,
     /* 2371669 */   // Label 33397: @2371669
     /* 2371669 */   GIM_Try, /*On fail goto*//*Label 33398*/ GIMT_Encode4(2371714), // Rule ID 50547 //
     /* 2371674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371677 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2371680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2371694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371713 */     // GIR_Coverage, 50547,
     /* 2371713 */     GIR_EraseRootFromParent_Done,
     /* 2371714 */   // Label 33398: @2371714
     /* 2371714 */   GIM_Reject,
     /* 2371715 */ // Label 33396: @2371715
     /* 2371715 */ GIM_Reject,
     /* 2371716 */ // Label 33330: @2371716
     /* 2371716 */ GIM_Try, /*On fail goto*//*Label 33399*/ GIMT_Encode4(2371830),
     /* 2371721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2371724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2371727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371739 */   GIM_Try, /*On fail goto*//*Label 33400*/ GIMT_Encode4(2371784), // Rule ID 50562 //
     /* 2371744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371747 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2371750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371783 */     // GIR_Coverage, 50562,
     /* 2371783 */     GIR_EraseRootFromParent_Done,
     /* 2371784 */   // Label 33400: @2371784
     /* 2371784 */   GIM_Try, /*On fail goto*//*Label 33401*/ GIMT_Encode4(2371829), // Rule ID 50563 //
     /* 2371789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371792 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2371795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371828 */     // GIR_Coverage, 50563,
     /* 2371828 */     GIR_EraseRootFromParent_Done,
     /* 2371829 */   // Label 33401: @2371829
     /* 2371829 */   GIM_Reject,
     /* 2371830 */ // Label 33399: @2371830
     /* 2371830 */ GIM_Reject,
     /* 2371831 */ // Label 33331: @2371831
     /* 2371831 */ GIM_Try, /*On fail goto*//*Label 33402*/ GIMT_Encode4(2371945),
     /* 2371836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2371839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2371842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2371854 */   GIM_Try, /*On fail goto*//*Label 33403*/ GIMT_Encode4(2371899), // Rule ID 50550 //
     /* 2371859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2371862 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2371865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371898 */     // GIR_Coverage, 50550,
     /* 2371898 */     GIR_EraseRootFromParent_Done,
     /* 2371899 */   // Label 33403: @2371899
     /* 2371899 */   GIM_Try, /*On fail goto*//*Label 33404*/ GIMT_Encode4(2371944), // Rule ID 50551 //
     /* 2371904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2371907 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2371910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2371924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2371933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371943 */     // GIR_Coverage, 50551,
     /* 2371943 */     GIR_EraseRootFromParent_Done,
     /* 2371944 */   // Label 33404: @2371944
     /* 2371944 */   GIM_Reject,
     /* 2371945 */ // Label 33402: @2371945
     /* 2371945 */ GIM_Reject,
     /* 2371946 */ // Label 33332: @2371946
     /* 2371946 */ GIM_Reject,
     /* 2371947 */ // Label 83: @2371947
     /* 2371947 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33429*/ GIMT_Encode4(2374722),
     /* 2371958 */ /*GILLT_s32*//*Label 33405*/ GIMT_Encode4(2372082),
     /* 2371962 */ /*GILLT_s64*//*Label 33406*/ GIMT_Encode4(2372137), GIMT_Encode4(0),
     /* 2371970 */ /*GILLT_nxv1s8*//*Label 33407*/ GIMT_Encode4(2372192),
     /* 2371974 */ /*GILLT_nxv1s16*//*Label 33408*/ GIMT_Encode4(2372307),
     /* 2371978 */ /*GILLT_nxv1s32*//*Label 33409*/ GIMT_Encode4(2372422),
     /* 2371982 */ /*GILLT_nxv1s64*//*Label 33410*/ GIMT_Encode4(2372537), GIMT_Encode4(0),
     /* 2371990 */ /*GILLT_nxv2s8*//*Label 33411*/ GIMT_Encode4(2372652),
     /* 2371994 */ /*GILLT_nxv2s16*//*Label 33412*/ GIMT_Encode4(2372767),
     /* 2371998 */ /*GILLT_nxv2s32*//*Label 33413*/ GIMT_Encode4(2372882),
     /* 2372002 */ /*GILLT_nxv2s64*//*Label 33414*/ GIMT_Encode4(2372997), GIMT_Encode4(0),
     /* 2372010 */ /*GILLT_nxv4s8*//*Label 33415*/ GIMT_Encode4(2373112),
     /* 2372014 */ /*GILLT_nxv4s16*//*Label 33416*/ GIMT_Encode4(2373227),
     /* 2372018 */ /*GILLT_nxv4s32*//*Label 33417*/ GIMT_Encode4(2373342),
     /* 2372022 */ /*GILLT_nxv4s64*//*Label 33418*/ GIMT_Encode4(2373457), GIMT_Encode4(0),
     /* 2372030 */ /*GILLT_nxv8s8*//*Label 33419*/ GIMT_Encode4(2373572),
     /* 2372034 */ /*GILLT_nxv8s16*//*Label 33420*/ GIMT_Encode4(2373687),
     /* 2372038 */ /*GILLT_nxv8s32*//*Label 33421*/ GIMT_Encode4(2373802),
     /* 2372042 */ /*GILLT_nxv8s64*//*Label 33422*/ GIMT_Encode4(2373917), GIMT_Encode4(0),
     /* 2372050 */ /*GILLT_nxv16s8*//*Label 33423*/ GIMT_Encode4(2374032),
     /* 2372054 */ /*GILLT_nxv16s16*//*Label 33424*/ GIMT_Encode4(2374147),
     /* 2372058 */ /*GILLT_nxv16s32*//*Label 33425*/ GIMT_Encode4(2374262), GIMT_Encode4(0),
     /* 2372066 */ /*GILLT_nxv32s8*//*Label 33426*/ GIMT_Encode4(2374377),
     /* 2372070 */ /*GILLT_nxv32s16*//*Label 33427*/ GIMT_Encode4(2374492), GIMT_Encode4(0),
     /* 2372078 */ /*GILLT_nxv64s8*//*Label 33428*/ GIMT_Encode4(2374607),
     /* 2372082 */ // Label 33405: @2372082
     /* 2372082 */ GIM_Try, /*On fail goto*//*Label 33430*/ GIMT_Encode4(2372136),
     /* 2372087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2372090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2372093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372105 */   GIM_Try, /*On fail goto*//*Label 33431*/ GIMT_Encode4(2372120), // Rule ID 64466 //
     /* 2372110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2372113 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2372113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2372118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372119 */     // GIR_Coverage, 64466,
     /* 2372119 */     GIR_Done,
     /* 2372120 */   // Label 33431: @2372120
     /* 2372120 */   GIM_Try, /*On fail goto*//*Label 33432*/ GIMT_Encode4(2372135), // Rule ID 2531 //
     /* 2372125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2372128 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2372128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2372133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372134 */     // GIR_Coverage, 2531,
     /* 2372134 */     GIR_Done,
     /* 2372135 */   // Label 33432: @2372135
     /* 2372135 */   GIM_Reject,
     /* 2372136 */ // Label 33430: @2372136
     /* 2372136 */ GIM_Reject,
     /* 2372137 */ // Label 33406: @2372137
     /* 2372137 */ GIM_Try, /*On fail goto*//*Label 33433*/ GIMT_Encode4(2372191),
     /* 2372142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2372145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2372148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2372160 */   GIM_Try, /*On fail goto*//*Label 33434*/ GIMT_Encode4(2372175), // Rule ID 64465 //
     /* 2372165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2372168 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2372168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2372173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372174 */     // GIR_Coverage, 64465,
     /* 2372174 */     GIR_Done,
     /* 2372175 */   // Label 33434: @2372175
     /* 2372175 */   GIM_Try, /*On fail goto*//*Label 33435*/ GIMT_Encode4(2372190), // Rule ID 2530 //
     /* 2372180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2372183 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2372183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2372188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372189 */     // GIR_Coverage, 2530,
     /* 2372189 */     GIR_Done,
     /* 2372190 */   // Label 33435: @2372190
     /* 2372190 */   GIM_Reject,
     /* 2372191 */ // Label 33433: @2372191
     /* 2372191 */ GIM_Reject,
     /* 2372192 */ // Label 33407: @2372192
     /* 2372192 */ GIM_Try, /*On fail goto*//*Label 33436*/ GIMT_Encode4(2372306),
     /* 2372197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2372200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2372203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372215 */   GIM_Try, /*On fail goto*//*Label 33437*/ GIMT_Encode4(2372260), // Rule ID 50678 //
     /* 2372220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372223 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2372240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372259 */     // GIR_Coverage, 50678,
     /* 2372259 */     GIR_EraseRootFromParent_Done,
     /* 2372260 */   // Label 33437: @2372260
     /* 2372260 */   GIM_Try, /*On fail goto*//*Label 33438*/ GIMT_Encode4(2372305), // Rule ID 50679 //
     /* 2372265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372268 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2372271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2372285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372304 */     // GIR_Coverage, 50679,
     /* 2372304 */     GIR_EraseRootFromParent_Done,
     /* 2372305 */   // Label 33438: @2372305
     /* 2372305 */   GIM_Reject,
     /* 2372306 */ // Label 33436: @2372306
     /* 2372306 */ GIM_Reject,
     /* 2372307 */ // Label 33408: @2372307
     /* 2372307 */ GIM_Try, /*On fail goto*//*Label 33439*/ GIMT_Encode4(2372421),
     /* 2372312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2372315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2372318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372330 */   GIM_Try, /*On fail goto*//*Label 33440*/ GIMT_Encode4(2372375), // Rule ID 50690 //
     /* 2372335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372338 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2372355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372374 */     // GIR_Coverage, 50690,
     /* 2372374 */     GIR_EraseRootFromParent_Done,
     /* 2372375 */   // Label 33440: @2372375
     /* 2372375 */   GIM_Try, /*On fail goto*//*Label 33441*/ GIMT_Encode4(2372420), // Rule ID 50691 //
     /* 2372380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372383 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2372386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2372400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372419 */     // GIR_Coverage, 50691,
     /* 2372419 */     GIR_EraseRootFromParent_Done,
     /* 2372420 */   // Label 33441: @2372420
     /* 2372420 */   GIM_Reject,
     /* 2372421 */ // Label 33439: @2372421
     /* 2372421 */ GIM_Reject,
     /* 2372422 */ // Label 33409: @2372422
     /* 2372422 */ GIM_Try, /*On fail goto*//*Label 33442*/ GIMT_Encode4(2372536),
     /* 2372427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2372430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2372433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372445 */   GIM_Try, /*On fail goto*//*Label 33443*/ GIMT_Encode4(2372490), // Rule ID 50698 //
     /* 2372450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372453 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2372456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2372470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372489 */     // GIR_Coverage, 50698,
     /* 2372489 */     GIR_EraseRootFromParent_Done,
     /* 2372490 */   // Label 33443: @2372490
     /* 2372490 */   GIM_Try, /*On fail goto*//*Label 33444*/ GIMT_Encode4(2372535), // Rule ID 50699 //
     /* 2372495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372498 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2372501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2372515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372534 */     // GIR_Coverage, 50699,
     /* 2372534 */     GIR_EraseRootFromParent_Done,
     /* 2372535 */   // Label 33444: @2372535
     /* 2372535 */   GIM_Reject,
     /* 2372536 */ // Label 33442: @2372536
     /* 2372536 */ GIM_Reject,
     /* 2372537 */ // Label 33410: @2372537
     /* 2372537 */ GIM_Try, /*On fail goto*//*Label 33445*/ GIMT_Encode4(2372651),
     /* 2372542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2372545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2372548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372560 */   GIM_Try, /*On fail goto*//*Label 33446*/ GIMT_Encode4(2372605), // Rule ID 50714 //
     /* 2372565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2372568 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2372571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2372585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372604 */     // GIR_Coverage, 50714,
     /* 2372604 */     GIR_EraseRootFromParent_Done,
     /* 2372605 */   // Label 33446: @2372605
     /* 2372605 */   GIM_Try, /*On fail goto*//*Label 33447*/ GIMT_Encode4(2372650), // Rule ID 50715 //
     /* 2372610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2372613 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2372616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2372630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372649 */     // GIR_Coverage, 50715,
     /* 2372649 */     GIR_EraseRootFromParent_Done,
     /* 2372650 */   // Label 33447: @2372650
     /* 2372650 */   GIM_Reject,
     /* 2372651 */ // Label 33445: @2372651
     /* 2372651 */ GIM_Reject,
     /* 2372652 */ // Label 33411: @2372652
     /* 2372652 */ GIM_Try, /*On fail goto*//*Label 33448*/ GIMT_Encode4(2372766),
     /* 2372657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2372660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2372663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372675 */   GIM_Try, /*On fail goto*//*Label 33449*/ GIMT_Encode4(2372720), // Rule ID 50682 //
     /* 2372680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372683 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2372686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2372700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372719 */     // GIR_Coverage, 50682,
     /* 2372719 */     GIR_EraseRootFromParent_Done,
     /* 2372720 */   // Label 33449: @2372720
     /* 2372720 */   GIM_Try, /*On fail goto*//*Label 33450*/ GIMT_Encode4(2372765), // Rule ID 50683 //
     /* 2372725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372728 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2372731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2372745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372764 */     // GIR_Coverage, 50683,
     /* 2372764 */     GIR_EraseRootFromParent_Done,
     /* 2372765 */   // Label 33450: @2372765
     /* 2372765 */   GIM_Reject,
     /* 2372766 */ // Label 33448: @2372766
     /* 2372766 */ GIM_Reject,
     /* 2372767 */ // Label 33412: @2372767
     /* 2372767 */ GIM_Try, /*On fail goto*//*Label 33451*/ GIMT_Encode4(2372881),
     /* 2372772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2372775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2372778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372790 */   GIM_Try, /*On fail goto*//*Label 33452*/ GIMT_Encode4(2372835), // Rule ID 50694 //
     /* 2372795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372798 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2372801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2372815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372834 */     // GIR_Coverage, 50694,
     /* 2372834 */     GIR_EraseRootFromParent_Done,
     /* 2372835 */   // Label 33452: @2372835
     /* 2372835 */   GIM_Try, /*On fail goto*//*Label 33453*/ GIMT_Encode4(2372880), // Rule ID 50695 //
     /* 2372840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372843 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2372846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2372860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372879 */     // GIR_Coverage, 50695,
     /* 2372879 */     GIR_EraseRootFromParent_Done,
     /* 2372880 */   // Label 33453: @2372880
     /* 2372880 */   GIM_Reject,
     /* 2372881 */ // Label 33451: @2372881
     /* 2372881 */ GIM_Reject,
     /* 2372882 */ // Label 33413: @2372882
     /* 2372882 */ GIM_Try, /*On fail goto*//*Label 33454*/ GIMT_Encode4(2372996),
     /* 2372887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2372890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2372893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372905 */   GIM_Try, /*On fail goto*//*Label 33455*/ GIMT_Encode4(2372950), // Rule ID 50710 //
     /* 2372910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2372913 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2372916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2372930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372949 */     // GIR_Coverage, 50710,
     /* 2372949 */     GIR_EraseRootFromParent_Done,
     /* 2372950 */   // Label 33455: @2372950
     /* 2372950 */   GIM_Try, /*On fail goto*//*Label 33456*/ GIMT_Encode4(2372995), // Rule ID 50711 //
     /* 2372955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2372958 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2372961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2372975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2372984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372994 */     // GIR_Coverage, 50711,
     /* 2372994 */     GIR_EraseRootFromParent_Done,
     /* 2372995 */   // Label 33456: @2372995
     /* 2372995 */   GIM_Reject,
     /* 2372996 */ // Label 33454: @2372996
     /* 2372996 */ GIM_Reject,
     /* 2372997 */ // Label 33414: @2372997
     /* 2372997 */ GIM_Try, /*On fail goto*//*Label 33457*/ GIMT_Encode4(2373111),
     /* 2373002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2373005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2373008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373020 */   GIM_Try, /*On fail goto*//*Label 33458*/ GIMT_Encode4(2373065), // Rule ID 50754 //
     /* 2373025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373028 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373064 */     // GIR_Coverage, 50754,
     /* 2373064 */     GIR_EraseRootFromParent_Done,
     /* 2373065 */   // Label 33458: @2373065
     /* 2373065 */   GIM_Try, /*On fail goto*//*Label 33459*/ GIMT_Encode4(2373110), // Rule ID 50755 //
     /* 2373070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373073 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2373076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373109 */     // GIR_Coverage, 50755,
     /* 2373109 */     GIR_EraseRootFromParent_Done,
     /* 2373110 */   // Label 33459: @2373110
     /* 2373110 */   GIM_Reject,
     /* 2373111 */ // Label 33457: @2373111
     /* 2373111 */ GIM_Reject,
     /* 2373112 */ // Label 33415: @2373112
     /* 2373112 */ GIM_Try, /*On fail goto*//*Label 33460*/ GIMT_Encode4(2373226),
     /* 2373117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2373120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2373123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373131 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373135 */   GIM_Try, /*On fail goto*//*Label 33461*/ GIMT_Encode4(2373180), // Rule ID 50686 //
     /* 2373140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373143 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2373160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373179 */     // GIR_Coverage, 50686,
     /* 2373179 */     GIR_EraseRootFromParent_Done,
     /* 2373180 */   // Label 33461: @2373180
     /* 2373180 */   GIM_Try, /*On fail goto*//*Label 33462*/ GIMT_Encode4(2373225), // Rule ID 50687 //
     /* 2373185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373188 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2373191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2373205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373224 */     // GIR_Coverage, 50687,
     /* 2373224 */     GIR_EraseRootFromParent_Done,
     /* 2373225 */   // Label 33462: @2373225
     /* 2373225 */   GIM_Reject,
     /* 2373226 */ // Label 33460: @2373226
     /* 2373226 */ GIM_Reject,
     /* 2373227 */ // Label 33416: @2373227
     /* 2373227 */ GIM_Try, /*On fail goto*//*Label 33463*/ GIMT_Encode4(2373341),
     /* 2373232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2373235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2373238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373250 */   GIM_Try, /*On fail goto*//*Label 33464*/ GIMT_Encode4(2373295), // Rule ID 50706 //
     /* 2373255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373258 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373294 */     // GIR_Coverage, 50706,
     /* 2373294 */     GIR_EraseRootFromParent_Done,
     /* 2373295 */   // Label 33464: @2373295
     /* 2373295 */   GIM_Try, /*On fail goto*//*Label 33465*/ GIMT_Encode4(2373340), // Rule ID 50707 //
     /* 2373300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373303 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2373306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373339 */     // GIR_Coverage, 50707,
     /* 2373339 */     GIR_EraseRootFromParent_Done,
     /* 2373340 */   // Label 33465: @2373340
     /* 2373340 */   GIM_Reject,
     /* 2373341 */ // Label 33463: @2373341
     /* 2373341 */ GIM_Reject,
     /* 2373342 */ // Label 33417: @2373342
     /* 2373342 */ GIM_Try, /*On fail goto*//*Label 33466*/ GIMT_Encode4(2373456),
     /* 2373347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2373350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2373353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373365 */   GIM_Try, /*On fail goto*//*Label 33467*/ GIMT_Encode4(2373410), // Rule ID 50742 //
     /* 2373370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373373 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373409 */     // GIR_Coverage, 50742,
     /* 2373409 */     GIR_EraseRootFromParent_Done,
     /* 2373410 */   // Label 33467: @2373410
     /* 2373410 */   GIM_Try, /*On fail goto*//*Label 33468*/ GIMT_Encode4(2373455), // Rule ID 50743 //
     /* 2373415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373418 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2373421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373454 */     // GIR_Coverage, 50743,
     /* 2373454 */     GIR_EraseRootFromParent_Done,
     /* 2373455 */   // Label 33468: @2373455
     /* 2373455 */   GIM_Reject,
     /* 2373456 */ // Label 33466: @2373456
     /* 2373456 */ GIM_Reject,
     /* 2373457 */ // Label 33418: @2373457
     /* 2373457 */ GIM_Try, /*On fail goto*//*Label 33469*/ GIMT_Encode4(2373571),
     /* 2373462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2373465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2373468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373480 */   GIM_Try, /*On fail goto*//*Label 33470*/ GIMT_Encode4(2373525), // Rule ID 50758 //
     /* 2373485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373488 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2373491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373500 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2373505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373524 */     // GIR_Coverage, 50758,
     /* 2373524 */     GIR_EraseRootFromParent_Done,
     /* 2373525 */   // Label 33470: @2373525
     /* 2373525 */   GIM_Try, /*On fail goto*//*Label 33471*/ GIMT_Encode4(2373570), // Rule ID 50759 //
     /* 2373530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373533 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2373536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2373550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373569 */     // GIR_Coverage, 50759,
     /* 2373569 */     GIR_EraseRootFromParent_Done,
     /* 2373570 */   // Label 33471: @2373570
     /* 2373570 */   GIM_Reject,
     /* 2373571 */ // Label 33469: @2373571
     /* 2373571 */ GIM_Reject,
     /* 2373572 */ // Label 33419: @2373572
     /* 2373572 */ GIM_Try, /*On fail goto*//*Label 33472*/ GIMT_Encode4(2373686),
     /* 2373577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2373580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2373583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373595 */   GIM_Try, /*On fail goto*//*Label 33473*/ GIMT_Encode4(2373640), // Rule ID 50702 //
     /* 2373600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373603 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2373606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373639 */     // GIR_Coverage, 50702,
     /* 2373639 */     GIR_EraseRootFromParent_Done,
     /* 2373640 */   // Label 33473: @2373640
     /* 2373640 */   GIM_Try, /*On fail goto*//*Label 33474*/ GIMT_Encode4(2373685), // Rule ID 50703 //
     /* 2373645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373648 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2373651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2373665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373684 */     // GIR_Coverage, 50703,
     /* 2373684 */     GIR_EraseRootFromParent_Done,
     /* 2373685 */   // Label 33474: @2373685
     /* 2373685 */   GIM_Reject,
     /* 2373686 */ // Label 33472: @2373686
     /* 2373686 */ GIM_Reject,
     /* 2373687 */ // Label 33420: @2373687
     /* 2373687 */ GIM_Try, /*On fail goto*//*Label 33475*/ GIMT_Encode4(2373801),
     /* 2373692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2373695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2373698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373706 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2373710 */   GIM_Try, /*On fail goto*//*Label 33476*/ GIMT_Encode4(2373755), // Rule ID 50730 //
     /* 2373715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373718 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2373721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373754 */     // GIR_Coverage, 50730,
     /* 2373754 */     GIR_EraseRootFromParent_Done,
     /* 2373755 */   // Label 33476: @2373755
     /* 2373755 */   GIM_Try, /*On fail goto*//*Label 33477*/ GIMT_Encode4(2373800), // Rule ID 50731 //
     /* 2373760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373763 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2373766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2373780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373799 */     // GIR_Coverage, 50731,
     /* 2373799 */     GIR_EraseRootFromParent_Done,
     /* 2373800 */   // Label 33477: @2373800
     /* 2373800 */   GIM_Reject,
     /* 2373801 */ // Label 33475: @2373801
     /* 2373801 */ GIM_Reject,
     /* 2373802 */ // Label 33421: @2373802
     /* 2373802 */ GIM_Try, /*On fail goto*//*Label 33478*/ GIMT_Encode4(2373916),
     /* 2373807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2373810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2373813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2373825 */   GIM_Try, /*On fail goto*//*Label 33479*/ GIMT_Encode4(2373870), // Rule ID 50746 //
     /* 2373830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2373833 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2373836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2373850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373869 */     // GIR_Coverage, 50746,
     /* 2373869 */     GIR_EraseRootFromParent_Done,
     /* 2373870 */   // Label 33479: @2373870
     /* 2373870 */   GIM_Try, /*On fail goto*//*Label 33480*/ GIMT_Encode4(2373915), // Rule ID 50747 //
     /* 2373875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2373878 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2373881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2373895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2373910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373914 */     // GIR_Coverage, 50747,
     /* 2373914 */     GIR_EraseRootFromParent_Done,
     /* 2373915 */   // Label 33480: @2373915
     /* 2373915 */   GIM_Reject,
     /* 2373916 */ // Label 33478: @2373916
     /* 2373916 */ GIM_Reject,
     /* 2373917 */ // Label 33422: @2373917
     /* 2373917 */ GIM_Try, /*On fail goto*//*Label 33481*/ GIMT_Encode4(2374031),
     /* 2373922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2373925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2373928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2373932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2373936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2373940 */   GIM_Try, /*On fail goto*//*Label 33482*/ GIMT_Encode4(2373985), // Rule ID 50762 //
     /* 2373945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2373948 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2373951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2373965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2373974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2373980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373984 */     // GIR_Coverage, 50762,
     /* 2373984 */     GIR_EraseRootFromParent_Done,
     /* 2373985 */   // Label 33482: @2373985
     /* 2373985 */   GIM_Try, /*On fail goto*//*Label 33483*/ GIMT_Encode4(2374030), // Rule ID 50763 //
     /* 2373990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2373993 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2373996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374029 */     // GIR_Coverage, 50763,
     /* 2374029 */     GIR_EraseRootFromParent_Done,
     /* 2374030 */   // Label 33483: @2374030
     /* 2374030 */   GIM_Reject,
     /* 2374031 */ // Label 33481: @2374031
     /* 2374031 */ GIM_Reject,
     /* 2374032 */ // Label 33423: @2374032
     /* 2374032 */ GIM_Try, /*On fail goto*//*Label 33484*/ GIMT_Encode4(2374146),
     /* 2374037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2374040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2374043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374051 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374055 */   GIM_Try, /*On fail goto*//*Label 33485*/ GIMT_Encode4(2374100), // Rule ID 50718 //
     /* 2374060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374063 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2374080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374099 */     // GIR_Coverage, 50718,
     /* 2374099 */     GIR_EraseRootFromParent_Done,
     /* 2374100 */   // Label 33485: @2374100
     /* 2374100 */   GIM_Try, /*On fail goto*//*Label 33486*/ GIMT_Encode4(2374145), // Rule ID 50719 //
     /* 2374105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374108 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2374111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2374125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374144 */     // GIR_Coverage, 50719,
     /* 2374144 */     GIR_EraseRootFromParent_Done,
     /* 2374145 */   // Label 33486: @2374145
     /* 2374145 */   GIM_Reject,
     /* 2374146 */ // Label 33484: @2374146
     /* 2374146 */ GIM_Reject,
     /* 2374147 */ // Label 33424: @2374147
     /* 2374147 */ GIM_Try, /*On fail goto*//*Label 33487*/ GIMT_Encode4(2374261),
     /* 2374152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2374155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2374158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374170 */   GIM_Try, /*On fail goto*//*Label 33488*/ GIMT_Encode4(2374215), // Rule ID 50734 //
     /* 2374175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374178 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374214 */     // GIR_Coverage, 50734,
     /* 2374214 */     GIR_EraseRootFromParent_Done,
     /* 2374215 */   // Label 33488: @2374215
     /* 2374215 */   GIM_Try, /*On fail goto*//*Label 33489*/ GIMT_Encode4(2374260), // Rule ID 50735 //
     /* 2374220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374223 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2374226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374259 */     // GIR_Coverage, 50735,
     /* 2374259 */     GIR_EraseRootFromParent_Done,
     /* 2374260 */   // Label 33489: @2374260
     /* 2374260 */   GIM_Reject,
     /* 2374261 */ // Label 33487: @2374261
     /* 2374261 */ GIM_Reject,
     /* 2374262 */ // Label 33425: @2374262
     /* 2374262 */ GIM_Try, /*On fail goto*//*Label 33490*/ GIMT_Encode4(2374376),
     /* 2374267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2374270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2374273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374285 */   GIM_Try, /*On fail goto*//*Label 33491*/ GIMT_Encode4(2374330), // Rule ID 50750 //
     /* 2374290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374293 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374329 */     // GIR_Coverage, 50750,
     /* 2374329 */     GIR_EraseRootFromParent_Done,
     /* 2374330 */   // Label 33491: @2374330
     /* 2374330 */   GIM_Try, /*On fail goto*//*Label 33492*/ GIMT_Encode4(2374375), // Rule ID 50751 //
     /* 2374335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374338 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2374341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374374 */     // GIR_Coverage, 50751,
     /* 2374374 */     GIR_EraseRootFromParent_Done,
     /* 2374375 */   // Label 33492: @2374375
     /* 2374375 */   GIM_Reject,
     /* 2374376 */ // Label 33490: @2374376
     /* 2374376 */ GIM_Reject,
     /* 2374377 */ // Label 33426: @2374377
     /* 2374377 */ GIM_Try, /*On fail goto*//*Label 33493*/ GIMT_Encode4(2374491),
     /* 2374382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2374385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2374388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374400 */   GIM_Try, /*On fail goto*//*Label 33494*/ GIMT_Encode4(2374445), // Rule ID 50722 //
     /* 2374405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374408 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2374411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374444 */     // GIR_Coverage, 50722,
     /* 2374444 */     GIR_EraseRootFromParent_Done,
     /* 2374445 */   // Label 33494: @2374445
     /* 2374445 */   GIM_Try, /*On fail goto*//*Label 33495*/ GIMT_Encode4(2374490), // Rule ID 50723 //
     /* 2374450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374453 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2374456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2374470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374489 */     // GIR_Coverage, 50723,
     /* 2374489 */     GIR_EraseRootFromParent_Done,
     /* 2374490 */   // Label 33495: @2374490
     /* 2374490 */   GIM_Reject,
     /* 2374491 */ // Label 33493: @2374491
     /* 2374491 */ GIM_Reject,
     /* 2374492 */ // Label 33427: @2374492
     /* 2374492 */ GIM_Try, /*On fail goto*//*Label 33496*/ GIMT_Encode4(2374606),
     /* 2374497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2374500 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2374503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374515 */   GIM_Try, /*On fail goto*//*Label 33497*/ GIMT_Encode4(2374560), // Rule ID 50738 //
     /* 2374520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374523 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2374526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374559 */     // GIR_Coverage, 50738,
     /* 2374559 */     GIR_EraseRootFromParent_Done,
     /* 2374560 */   // Label 33497: @2374560
     /* 2374560 */   GIM_Try, /*On fail goto*//*Label 33498*/ GIMT_Encode4(2374605), // Rule ID 50739 //
     /* 2374565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374568 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2374571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374604 */     // GIR_Coverage, 50739,
     /* 2374604 */     GIR_EraseRootFromParent_Done,
     /* 2374605 */   // Label 33498: @2374605
     /* 2374605 */   GIM_Reject,
     /* 2374606 */ // Label 33496: @2374606
     /* 2374606 */ GIM_Reject,
     /* 2374607 */ // Label 33428: @2374607
     /* 2374607 */ GIM_Try, /*On fail goto*//*Label 33499*/ GIMT_Encode4(2374721),
     /* 2374612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2374615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2374618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2374630 */   GIM_Try, /*On fail goto*//*Label 33500*/ GIMT_Encode4(2374675), // Rule ID 50726 //
     /* 2374635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2374638 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2374641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374674 */     // GIR_Coverage, 50726,
     /* 2374674 */     GIR_EraseRootFromParent_Done,
     /* 2374675 */   // Label 33500: @2374675
     /* 2374675 */   GIM_Try, /*On fail goto*//*Label 33501*/ GIMT_Encode4(2374720), // Rule ID 50727 //
     /* 2374680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2374683 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2374686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2374700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2374709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374719 */     // GIR_Coverage, 50727,
     /* 2374719 */     GIR_EraseRootFromParent_Done,
     /* 2374720 */   // Label 33501: @2374720
     /* 2374720 */   GIM_Reject,
     /* 2374721 */ // Label 33499: @2374721
     /* 2374721 */ GIM_Reject,
     /* 2374722 */ // Label 33429: @2374722
     /* 2374722 */ GIM_Reject,
     /* 2374723 */ // Label 84: @2374723
     /* 2374723 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33504*/ GIMT_Encode4(2374880),
     /* 2374734 */ /*GILLT_s32*//*Label 33502*/ GIMT_Encode4(2374742),
     /* 2374738 */ /*GILLT_s64*//*Label 33503*/ GIMT_Encode4(2374811),
     /* 2374742 */ // Label 33502: @2374742
     /* 2374742 */ GIM_Try, /*On fail goto*//*Label 33505*/ GIMT_Encode4(2374810),
     /* 2374747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2374750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374758 */   GIM_Try, /*On fail goto*//*Label 33506*/ GIMT_Encode4(2374773), // Rule ID 64454 //
     /* 2374763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2374766 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_ABS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2374766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2374771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374772 */     // GIR_Coverage, 64454,
     /* 2374772 */     GIR_Done,
     /* 2374773 */   // Label 33506: @2374773
     /* 2374773 */   GIM_Try, /*On fail goto*//*Label 33507*/ GIMT_Encode4(2374809), // Rule ID 62509 //
     /* 2374778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode1),
     /* 2374781 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (PseudoCCSUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, 2:{ *:[i32] }, GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2374781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2374784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2374786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2374794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2374797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2374805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374808 */     // GIR_Coverage, 62509,
     /* 2374808 */     GIR_EraseRootFromParent_Done,
     /* 2374809 */   // Label 33507: @2374809
     /* 2374809 */   GIM_Reject,
     /* 2374810 */ // Label 33505: @2374810
     /* 2374810 */ GIM_Reject,
     /* 2374811 */ // Label 33503: @2374811
     /* 2374811 */ GIM_Try, /*On fail goto*//*Label 33508*/ GIMT_Encode4(2374879),
     /* 2374816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2374819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374827 */   GIM_Try, /*On fail goto*//*Label 33509*/ GIMT_Encode4(2374842), // Rule ID 64453 //
     /* 2374832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2374835 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_ABS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2374835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2374840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374841 */     // GIR_Coverage, 64453,
     /* 2374841 */     GIR_Done,
     /* 2374842 */   // Label 33509: @2374842
     /* 2374842 */   GIM_Try, /*On fail goto*//*Label 33510*/ GIMT_Encode4(2374878), // Rule ID 62508 //
     /* 2374847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode0),
     /* 2374850 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (PseudoCCSUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, 2:{ *:[i64] }, GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2374850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2374853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2374855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2374863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2374866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2374874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374877 */     // GIR_Coverage, 62508,
     /* 2374877 */     GIR_EraseRootFromParent_Done,
     /* 2374878 */   // Label 33510: @2374878
     /* 2374878 */   GIM_Reject,
     /* 2374879 */ // Label 33508: @2374879
     /* 2374879 */ GIM_Reject,
     /* 2374880 */ // Label 33504: @2374880
     /* 2374880 */ GIM_Reject,
     /* 2374881 */ // Label 85: @2374881
     /* 2374881 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33513*/ GIMT_Encode4(2375460),
     /* 2374892 */ /*GILLT_s32*//*Label 33511*/ GIMT_Encode4(2374900),
     /* 2374896 */ /*GILLT_s64*//*Label 33512*/ GIMT_Encode4(2375273),
     /* 2374900 */ // Label 33511: @2374900
     /* 2374900 */ GIM_Try, /*On fail goto*//*Label 33514*/ GIMT_Encode4(2374931), // Rule ID 1466 //
     /* 2374905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2374908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2374911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2374919 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2374919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2374922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374924 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374929 */   GIR_RootConstrainSelectedInstOperands,
     /* 2374930 */   // GIR_Coverage, 1466,
     /* 2374930 */   GIR_EraseRootFromParent_Done,
     /* 2374931 */ // Label 33514: @2374931
     /* 2374931 */ GIM_Try, /*On fail goto*//*Label 33515*/ GIMT_Encode4(2374962), // Rule ID 1467 //
     /* 2374936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2374939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2374942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2374950 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2374950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2374953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374955 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374960 */   GIR_RootConstrainSelectedInstOperands,
     /* 2374961 */   // GIR_Coverage, 1467,
     /* 2374961 */   GIR_EraseRootFromParent_Done,
     /* 2374962 */ // Label 33515: @2374962
     /* 2374962 */ GIM_Try, /*On fail goto*//*Label 33516*/ GIMT_Encode4(2374993), // Rule ID 1492 //
     /* 2374967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2374970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2374973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2374977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2374981 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2374981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2374984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374986 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2374988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2374992 */   // GIR_Coverage, 1492,
     /* 2374992 */   GIR_EraseRootFromParent_Done,
     /* 2374993 */ // Label 33516: @2374993
     /* 2374993 */ GIM_Try, /*On fail goto*//*Label 33517*/ GIMT_Encode4(2375024), // Rule ID 1493 //
     /* 2374998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2375001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2375012 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2375012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2375015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375017 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375022 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375023 */   // GIR_Coverage, 1493,
     /* 2375023 */   GIR_EraseRootFromParent_Done,
     /* 2375024 */ // Label 33517: @2375024
     /* 2375024 */ GIM_Try, /*On fail goto*//*Label 33518*/ GIMT_Encode4(2375055), // Rule ID 1860 //
     /* 2375029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2375032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375043 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2375046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375048 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375054 */   // GIR_Coverage, 1860,
     /* 2375054 */   GIR_EraseRootFromParent_Done,
     /* 2375055 */ // Label 33518: @2375055
     /* 2375055 */ GIM_Try, /*On fail goto*//*Label 33519*/ GIMT_Encode4(2375086), // Rule ID 1861 //
     /* 2375060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2375063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375074 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2375074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2375077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375079 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375085 */   // GIR_Coverage, 1861,
     /* 2375085 */   GIR_EraseRootFromParent_Done,
     /* 2375086 */ // Label 33519: @2375086
     /* 2375086 */ GIM_Try, /*On fail goto*//*Label 33520*/ GIMT_Encode4(2375117), // Rule ID 1886 //
     /* 2375091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2375094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2375105 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2375108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375110 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375116 */   // GIR_Coverage, 1886,
     /* 2375116 */   GIR_EraseRootFromParent_Done,
     /* 2375117 */ // Label 33520: @2375117
     /* 2375117 */ GIM_Try, /*On fail goto*//*Label 33521*/ GIMT_Encode4(2375148), // Rule ID 1887 //
     /* 2375122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2375125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2375136 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2375136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2375139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375141 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375147 */   // GIR_Coverage, 1887,
     /* 2375147 */   GIR_EraseRootFromParent_Done,
     /* 2375148 */ // Label 33521: @2375148
     /* 2375148 */ GIM_Try, /*On fail goto*//*Label 33522*/ GIMT_Encode4(2375179), // Rule ID 2202 //
     /* 2375153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2375156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375167 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2375170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375172 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375177 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375178 */   // GIR_Coverage, 2202,
     /* 2375178 */   GIR_EraseRootFromParent_Done,
     /* 2375179 */ // Label 33522: @2375179
     /* 2375179 */ GIM_Try, /*On fail goto*//*Label 33523*/ GIMT_Encode4(2375210), // Rule ID 2203 //
     /* 2375184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2375187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375198 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2375198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2375201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375203 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375208 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375209 */   // GIR_Coverage, 2203,
     /* 2375209 */   GIR_EraseRootFromParent_Done,
     /* 2375210 */ // Label 33523: @2375210
     /* 2375210 */ GIM_Try, /*On fail goto*//*Label 33524*/ GIMT_Encode4(2375241), // Rule ID 2228 //
     /* 2375215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2375218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2375229 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2375232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375234 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375240 */   // GIR_Coverage, 2228,
     /* 2375240 */   GIR_EraseRootFromParent_Done,
     /* 2375241 */ // Label 33524: @2375241
     /* 2375241 */ GIM_Try, /*On fail goto*//*Label 33525*/ GIMT_Encode4(2375272), // Rule ID 2229 //
     /* 2375246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2375249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2375260 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2375260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2375263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375265 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375271 */   // GIR_Coverage, 2229,
     /* 2375271 */   GIR_EraseRootFromParent_Done,
     /* 2375272 */ // Label 33525: @2375272
     /* 2375272 */ GIM_Reject,
     /* 2375273 */ // Label 33512: @2375273
     /* 2375273 */ GIM_Try, /*On fail goto*//*Label 33526*/ GIMT_Encode4(2375304), // Rule ID 1519 //
     /* 2375278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2375281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375292 */   // (lround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2375292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2375295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375297 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375303 */   // GIR_Coverage, 1519,
     /* 2375303 */   GIR_EraseRootFromParent_Done,
     /* 2375304 */ // Label 33526: @2375304
     /* 2375304 */ GIM_Try, /*On fail goto*//*Label 33527*/ GIMT_Encode4(2375335), // Rule ID 1547 //
     /* 2375309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2375312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2375323 */   // (lround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2375323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2375326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375328 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375334 */   // GIR_Coverage, 1547,
     /* 2375334 */   GIR_EraseRootFromParent_Done,
     /* 2375335 */ // Label 33527: @2375335
     /* 2375335 */ GIM_Try, /*On fail goto*//*Label 33528*/ GIMT_Encode4(2375366), // Rule ID 1917 //
     /* 2375340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2375343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375354 */   // (lround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2375357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375359 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375365 */   // GIR_Coverage, 1917,
     /* 2375365 */   GIR_EraseRootFromParent_Done,
     /* 2375366 */ // Label 33528: @2375366
     /* 2375366 */ GIM_Try, /*On fail goto*//*Label 33529*/ GIMT_Encode4(2375397), // Rule ID 1945 //
     /* 2375371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2375374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375385 */   // (lround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2375388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375390 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375396 */   // GIR_Coverage, 1945,
     /* 2375396 */   GIR_EraseRootFromParent_Done,
     /* 2375397 */ // Label 33529: @2375397
     /* 2375397 */ GIM_Try, /*On fail goto*//*Label 33530*/ GIMT_Encode4(2375428), // Rule ID 2253 //
     /* 2375402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2375405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375416 */   // (lround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2375419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375421 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375427 */   // GIR_Coverage, 2253,
     /* 2375427 */   GIR_EraseRootFromParent_Done,
     /* 2375428 */ // Label 33530: @2375428
     /* 2375428 */ GIM_Try, /*On fail goto*//*Label 33531*/ GIMT_Encode4(2375459), // Rule ID 2279 //
     /* 2375433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2375436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2375447 */   // (lround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2375450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375452 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375454 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375457 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375458 */   // GIR_Coverage, 2279,
     /* 2375458 */   GIR_EraseRootFromParent_Done,
     /* 2375459 */ // Label 33531: @2375459
     /* 2375459 */ GIM_Reject,
     /* 2375460 */ // Label 33513: @2375460
     /* 2375460 */ GIM_Reject,
     /* 2375461 */ // Label 86: @2375461
     /* 2375461 */ GIM_Try, /*On fail goto*//*Label 33532*/ GIMT_Encode4(2375670),
     /* 2375466 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2375469 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33536*/ GIMT_Encode4(2375669),
     /* 2375480 */   /*GILLT_s16*//*Label 33533*/ GIMT_Encode4(2375492),
     /* 2375484 */   /*GILLT_s32*//*Label 33534*/ GIMT_Encode4(2375551),
     /* 2375488 */   /*GILLT_s64*//*Label 33535*/ GIMT_Encode4(2375610),
     /* 2375492 */   // Label 33533: @2375492
     /* 2375492 */   GIM_Try, /*On fail goto*//*Label 33537*/ GIMT_Encode4(2375550),
     /* 2375497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375501 */     GIM_Try, /*On fail goto*//*Label 33538*/ GIMT_Encode4(2375525), // Rule ID 2255 //
     /* 2375506 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2375509 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375513 */       // (llround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375513 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2375516 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375518 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375520 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375523 */       GIR_RootConstrainSelectedInstOperands,
     /* 2375524 */       // GIR_Coverage, 2255,
     /* 2375524 */       GIR_EraseRootFromParent_Done,
     /* 2375525 */     // Label 33538: @2375525
     /* 2375525 */     GIM_Try, /*On fail goto*//*Label 33539*/ GIMT_Encode4(2375549), // Rule ID 2281 //
     /* 2375530 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2375533 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2375537 */       // (llround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2375537 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2375540 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375542 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375544 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375547 */       GIR_RootConstrainSelectedInstOperands,
     /* 2375548 */       // GIR_Coverage, 2281,
     /* 2375548 */       GIR_EraseRootFromParent_Done,
     /* 2375549 */     // Label 33539: @2375549
     /* 2375549 */     GIM_Reject,
     /* 2375550 */   // Label 33537: @2375550
     /* 2375550 */   GIM_Reject,
     /* 2375551 */   // Label 33534: @2375551
     /* 2375551 */   GIM_Try, /*On fail goto*//*Label 33540*/ GIMT_Encode4(2375609),
     /* 2375556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375560 */     GIM_Try, /*On fail goto*//*Label 33541*/ GIMT_Encode4(2375584), // Rule ID 1521 //
     /* 2375565 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2375568 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375572 */       // (llround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2375572 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2375575 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375577 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375579 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375582 */       GIR_RootConstrainSelectedInstOperands,
     /* 2375583 */       // GIR_Coverage, 1521,
     /* 2375583 */       GIR_EraseRootFromParent_Done,
     /* 2375584 */     // Label 33541: @2375584
     /* 2375584 */     GIM_Try, /*On fail goto*//*Label 33542*/ GIMT_Encode4(2375608), // Rule ID 1549 //
     /* 2375589 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2375592 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2375596 */       // (llround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2375596 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2375599 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375601 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375603 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375606 */       GIR_RootConstrainSelectedInstOperands,
     /* 2375607 */       // GIR_Coverage, 1549,
     /* 2375607 */       GIR_EraseRootFromParent_Done,
     /* 2375608 */     // Label 33542: @2375608
     /* 2375608 */     GIM_Reject,
     /* 2375609 */   // Label 33540: @2375609
     /* 2375609 */   GIM_Reject,
     /* 2375610 */   // Label 33535: @2375610
     /* 2375610 */   GIM_Try, /*On fail goto*//*Label 33543*/ GIMT_Encode4(2375668),
     /* 2375615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375619 */     GIM_Try, /*On fail goto*//*Label 33544*/ GIMT_Encode4(2375643), // Rule ID 1919 //
     /* 2375624 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2375627 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375631 */       // (llround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375631 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2375634 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375636 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375638 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375641 */       GIR_RootConstrainSelectedInstOperands,
     /* 2375642 */       // GIR_Coverage, 1919,
     /* 2375642 */       GIR_EraseRootFromParent_Done,
     /* 2375643 */     // Label 33544: @2375643
     /* 2375643 */     GIM_Try, /*On fail goto*//*Label 33545*/ GIMT_Encode4(2375667), // Rule ID 1947 //
     /* 2375648 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2375651 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375655 */       // (llround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2375655 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2375658 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375660 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375662 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375665 */       GIR_RootConstrainSelectedInstOperands,
     /* 2375666 */       // GIR_Coverage, 1947,
     /* 2375666 */       GIR_EraseRootFromParent_Done,
     /* 2375667 */     // Label 33545: @2375667
     /* 2375667 */     GIM_Reject,
     /* 2375668 */   // Label 33543: @2375668
     /* 2375668 */   GIM_Reject,
     /* 2375669 */   // Label 33536: @2375669
     /* 2375669 */   GIM_Reject,
     /* 2375670 */ // Label 33532: @2375670
     /* 2375670 */ GIM_Reject,
     /* 2375671 */ // Label 87: @2375671
     /* 2375671 */ GIM_Try, /*On fail goto*//*Label 33546*/ GIMT_Encode4(2375686), // Rule ID 4 //
     /* 2375676 */   // MIs[0] imm20
     /* 2375676 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2375679 */   // (br (bb:{ *:[Other] }):$imm20)  =>  (PseudoBR (bb:{ *:[Other] }):$imm20)
     /* 2375679 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoBR),
     /* 2375684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2375685 */   // GIR_Coverage, 4,
     /* 2375685 */   GIR_Done,
     /* 2375686 */ // Label 33546: @2375686
     /* 2375686 */ GIM_Reject,
     /* 2375687 */ // Label 88: @2375687
     /* 2375687 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33571*/ GIMT_Encode4(2378314),
     /* 2375698 */ /*GILLT_s32*//*Label 33547*/ GIMT_Encode4(2375822),
     /* 2375702 */ /*GILLT_s64*//*Label 33548*/ GIMT_Encode4(2375978), GIMT_Encode4(0),
     /* 2375710 */ /*GILLT_nxv1s8*//*Label 33549*/ GIMT_Encode4(2376026),
     /* 2375714 */ /*GILLT_nxv1s16*//*Label 33550*/ GIMT_Encode4(2376130),
     /* 2375718 */ /*GILLT_nxv1s32*//*Label 33551*/ GIMT_Encode4(2376234),
     /* 2375722 */ /*GILLT_nxv1s64*//*Label 33552*/ GIMT_Encode4(2376338), GIMT_Encode4(0),
     /* 2375730 */ /*GILLT_nxv2s8*//*Label 33553*/ GIMT_Encode4(2376442),
     /* 2375734 */ /*GILLT_nxv2s16*//*Label 33554*/ GIMT_Encode4(2376546),
     /* 2375738 */ /*GILLT_nxv2s32*//*Label 33555*/ GIMT_Encode4(2376650),
     /* 2375742 */ /*GILLT_nxv2s64*//*Label 33556*/ GIMT_Encode4(2376754), GIMT_Encode4(0),
     /* 2375750 */ /*GILLT_nxv4s8*//*Label 33557*/ GIMT_Encode4(2376858),
     /* 2375754 */ /*GILLT_nxv4s16*//*Label 33558*/ GIMT_Encode4(2376962),
     /* 2375758 */ /*GILLT_nxv4s32*//*Label 33559*/ GIMT_Encode4(2377066),
     /* 2375762 */ /*GILLT_nxv4s64*//*Label 33560*/ GIMT_Encode4(2377170), GIMT_Encode4(0),
     /* 2375770 */ /*GILLT_nxv8s8*//*Label 33561*/ GIMT_Encode4(2377274),
     /* 2375774 */ /*GILLT_nxv8s16*//*Label 33562*/ GIMT_Encode4(2377378),
     /* 2375778 */ /*GILLT_nxv8s32*//*Label 33563*/ GIMT_Encode4(2377482),
     /* 2375782 */ /*GILLT_nxv8s64*//*Label 33564*/ GIMT_Encode4(2377586), GIMT_Encode4(0),
     /* 2375790 */ /*GILLT_nxv16s8*//*Label 33565*/ GIMT_Encode4(2377690),
     /* 2375794 */ /*GILLT_nxv16s16*//*Label 33566*/ GIMT_Encode4(2377794),
     /* 2375798 */ /*GILLT_nxv16s32*//*Label 33567*/ GIMT_Encode4(2377898), GIMT_Encode4(0),
     /* 2375806 */ /*GILLT_nxv32s8*//*Label 33568*/ GIMT_Encode4(2378002),
     /* 2375810 */ /*GILLT_nxv32s16*//*Label 33569*/ GIMT_Encode4(2378106), GIMT_Encode4(0),
     /* 2375818 */ /*GILLT_nxv64s8*//*Label 33570*/ GIMT_Encode4(2378210),
     /* 2375822 */ // Label 33547: @2375822
     /* 2375822 */ GIM_Try, /*On fail goto*//*Label 33572*/ GIMT_Encode4(2375977),
     /* 2375827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375830 */   GIM_Try, /*On fail goto*//*Label 33573*/ GIMT_Encode4(2375880), // Rule ID 64640 //
     /* 2375835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2375838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2375842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2375846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2375850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2375858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375863 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2375867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2375869 */     // (cttz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CTO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2375869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CTO),
     /* 2375872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2375878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375879 */     // GIR_Coverage, 64640,
     /* 2375879 */     GIR_EraseRootFromParent_Done,
     /* 2375880 */   // Label 33573: @2375880
     /* 2375880 */   GIM_Try, /*On fail goto*//*Label 33574*/ GIMT_Encode4(2375930), // Rule ID 64641 //
     /* 2375885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2375888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2375892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2375896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2375900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2375908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375913 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2375917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2375919 */     // (cttz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CTO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2375919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CTO),
     /* 2375922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2375928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375929 */     // GIR_Coverage, 64641,
     /* 2375929 */     GIR_EraseRootFromParent_Done,
     /* 2375930 */   // Label 33574: @2375930
     /* 2375930 */   GIM_Try, /*On fail goto*//*Label 33575*/ GIMT_Encode4(2375953), // Rule ID 2513 //
     /* 2375935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2375938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375946 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CTZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2375946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2375951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375952 */     // GIR_Coverage, 2513,
     /* 2375952 */     GIR_Done,
     /* 2375953 */   // Label 33575: @2375953
     /* 2375953 */   GIM_Try, /*On fail goto*//*Label 33576*/ GIMT_Encode4(2375976), // Rule ID 64437 //
     /* 2375958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2375961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375969 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2375969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2375974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375975 */     // GIR_Coverage, 64437,
     /* 2375975 */     GIR_Done,
     /* 2375976 */   // Label 33576: @2375976
     /* 2375976 */   GIM_Reject,
     /* 2375977 */ // Label 33572: @2375977
     /* 2375977 */ GIM_Reject,
     /* 2375978 */ // Label 33548: @2375978
     /* 2375978 */ GIM_Try, /*On fail goto*//*Label 33577*/ GIMT_Encode4(2376025),
     /* 2375983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2375994 */   GIM_Try, /*On fail goto*//*Label 33578*/ GIMT_Encode4(2376009), // Rule ID 2512 //
     /* 2375999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2376002 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2376002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2376007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376008 */     // GIR_Coverage, 2512,
     /* 2376008 */     GIR_Done,
     /* 2376009 */   // Label 33578: @2376009
     /* 2376009 */   GIM_Try, /*On fail goto*//*Label 33579*/ GIMT_Encode4(2376024), // Rule ID 64436 //
     /* 2376014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2376017 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2376017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2376022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376023 */     // GIR_Coverage, 64436,
     /* 2376023 */     GIR_Done,
     /* 2376024 */   // Label 33579: @2376024
     /* 2376024 */   GIM_Reject,
     /* 2376025 */ // Label 33577: @2376025
     /* 2376025 */ GIM_Reject,
     /* 2376026 */ // Label 33549: @2376026
     /* 2376026 */ GIM_Try, /*On fail goto*//*Label 33580*/ GIMT_Encode4(2376129),
     /* 2376031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2376034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376042 */   GIM_Try, /*On fail goto*//*Label 33581*/ GIMT_Encode4(2376085), // Rule ID 59182 //
     /* 2376047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376050 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2376053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2376067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376084 */     // GIR_Coverage, 59182,
     /* 2376084 */     GIR_EraseRootFromParent_Done,
     /* 2376085 */   // Label 33581: @2376085
     /* 2376085 */   GIM_Try, /*On fail goto*//*Label 33582*/ GIMT_Encode4(2376128), // Rule ID 59183 //
     /* 2376090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376093 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2376096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2376110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376127 */     // GIR_Coverage, 59183,
     /* 2376127 */     GIR_EraseRootFromParent_Done,
     /* 2376128 */   // Label 33582: @2376128
     /* 2376128 */   GIM_Reject,
     /* 2376129 */ // Label 33580: @2376129
     /* 2376129 */ GIM_Reject,
     /* 2376130 */ // Label 33550: @2376130
     /* 2376130 */ GIM_Try, /*On fail goto*//*Label 33583*/ GIMT_Encode4(2376233),
     /* 2376135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2376138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376146 */   GIM_Try, /*On fail goto*//*Label 33584*/ GIMT_Encode4(2376189), // Rule ID 59188 //
     /* 2376151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376154 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2376157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2376171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376188 */     // GIR_Coverage, 59188,
     /* 2376188 */     GIR_EraseRootFromParent_Done,
     /* 2376189 */   // Label 33584: @2376189
     /* 2376189 */   GIM_Try, /*On fail goto*//*Label 33585*/ GIMT_Encode4(2376232), // Rule ID 59189 //
     /* 2376194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376197 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2376200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2376214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376231 */     // GIR_Coverage, 59189,
     /* 2376231 */     GIR_EraseRootFromParent_Done,
     /* 2376232 */   // Label 33585: @2376232
     /* 2376232 */   GIM_Reject,
     /* 2376233 */ // Label 33583: @2376233
     /* 2376233 */ GIM_Reject,
     /* 2376234 */ // Label 33551: @2376234
     /* 2376234 */ GIM_Try, /*On fail goto*//*Label 33586*/ GIMT_Encode4(2376337),
     /* 2376239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2376242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376250 */   GIM_Try, /*On fail goto*//*Label 33587*/ GIMT_Encode4(2376293), // Rule ID 59192 //
     /* 2376255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376258 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2376261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2376275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376292 */     // GIR_Coverage, 59192,
     /* 2376292 */     GIR_EraseRootFromParent_Done,
     /* 2376293 */   // Label 33587: @2376293
     /* 2376293 */   GIM_Try, /*On fail goto*//*Label 33588*/ GIMT_Encode4(2376336), // Rule ID 59193 //
     /* 2376298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376301 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2376304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2376318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376335 */     // GIR_Coverage, 59193,
     /* 2376335 */     GIR_EraseRootFromParent_Done,
     /* 2376336 */   // Label 33588: @2376336
     /* 2376336 */   GIM_Reject,
     /* 2376337 */ // Label 33586: @2376337
     /* 2376337 */ GIM_Reject,
     /* 2376338 */ // Label 33552: @2376338
     /* 2376338 */ GIM_Try, /*On fail goto*//*Label 33589*/ GIMT_Encode4(2376441),
     /* 2376343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2376346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376354 */   GIM_Try, /*On fail goto*//*Label 33590*/ GIMT_Encode4(2376397), // Rule ID 59200 //
     /* 2376359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2376362 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2376365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2376379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376396 */     // GIR_Coverage, 59200,
     /* 2376396 */     GIR_EraseRootFromParent_Done,
     /* 2376397 */   // Label 33590: @2376397
     /* 2376397 */   GIM_Try, /*On fail goto*//*Label 33591*/ GIMT_Encode4(2376440), // Rule ID 59201 //
     /* 2376402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2376405 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2376408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2376422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376439 */     // GIR_Coverage, 59201,
     /* 2376439 */     GIR_EraseRootFromParent_Done,
     /* 2376440 */   // Label 33591: @2376440
     /* 2376440 */   GIM_Reject,
     /* 2376441 */ // Label 33589: @2376441
     /* 2376441 */ GIM_Reject,
     /* 2376442 */ // Label 33553: @2376442
     /* 2376442 */ GIM_Try, /*On fail goto*//*Label 33592*/ GIMT_Encode4(2376545),
     /* 2376447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2376450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376458 */   GIM_Try, /*On fail goto*//*Label 33593*/ GIMT_Encode4(2376501), // Rule ID 59184 //
     /* 2376463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376466 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2376469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2376483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376500 */     // GIR_Coverage, 59184,
     /* 2376500 */     GIR_EraseRootFromParent_Done,
     /* 2376501 */   // Label 33593: @2376501
     /* 2376501 */   GIM_Try, /*On fail goto*//*Label 33594*/ GIMT_Encode4(2376544), // Rule ID 59185 //
     /* 2376506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376509 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2376512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2376526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376543 */     // GIR_Coverage, 59185,
     /* 2376543 */     GIR_EraseRootFromParent_Done,
     /* 2376544 */   // Label 33594: @2376544
     /* 2376544 */   GIM_Reject,
     /* 2376545 */ // Label 33592: @2376545
     /* 2376545 */ GIM_Reject,
     /* 2376546 */ // Label 33554: @2376546
     /* 2376546 */ GIM_Try, /*On fail goto*//*Label 33595*/ GIMT_Encode4(2376649),
     /* 2376551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2376554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376562 */   GIM_Try, /*On fail goto*//*Label 33596*/ GIMT_Encode4(2376605), // Rule ID 59190 //
     /* 2376567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376570 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2376573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2376587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376604 */     // GIR_Coverage, 59190,
     /* 2376604 */     GIR_EraseRootFromParent_Done,
     /* 2376605 */   // Label 33596: @2376605
     /* 2376605 */   GIM_Try, /*On fail goto*//*Label 33597*/ GIMT_Encode4(2376648), // Rule ID 59191 //
     /* 2376610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376613 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2376616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2376630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376647 */     // GIR_Coverage, 59191,
     /* 2376647 */     GIR_EraseRootFromParent_Done,
     /* 2376648 */   // Label 33597: @2376648
     /* 2376648 */   GIM_Reject,
     /* 2376649 */ // Label 33595: @2376649
     /* 2376649 */ GIM_Reject,
     /* 2376650 */ // Label 33555: @2376650
     /* 2376650 */ GIM_Try, /*On fail goto*//*Label 33598*/ GIMT_Encode4(2376753),
     /* 2376655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2376658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376666 */   GIM_Try, /*On fail goto*//*Label 33599*/ GIMT_Encode4(2376709), // Rule ID 59198 //
     /* 2376671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376674 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2376677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2376691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376708 */     // GIR_Coverage, 59198,
     /* 2376708 */     GIR_EraseRootFromParent_Done,
     /* 2376709 */   // Label 33599: @2376709
     /* 2376709 */   GIM_Try, /*On fail goto*//*Label 33600*/ GIMT_Encode4(2376752), // Rule ID 59199 //
     /* 2376714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376717 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2376720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2376734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376751 */     // GIR_Coverage, 59199,
     /* 2376751 */     GIR_EraseRootFromParent_Done,
     /* 2376752 */   // Label 33600: @2376752
     /* 2376752 */   GIM_Reject,
     /* 2376753 */ // Label 33598: @2376753
     /* 2376753 */ GIM_Reject,
     /* 2376754 */ // Label 33556: @2376754
     /* 2376754 */ GIM_Try, /*On fail goto*//*Label 33601*/ GIMT_Encode4(2376857),
     /* 2376759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2376762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2376770 */   GIM_Try, /*On fail goto*//*Label 33602*/ GIMT_Encode4(2376813), // Rule ID 59220 //
     /* 2376775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2376778 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2376781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2376795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376812 */     // GIR_Coverage, 59220,
     /* 2376812 */     GIR_EraseRootFromParent_Done,
     /* 2376813 */   // Label 33602: @2376813
     /* 2376813 */   GIM_Try, /*On fail goto*//*Label 33603*/ GIMT_Encode4(2376856), // Rule ID 59221 //
     /* 2376818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2376821 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2376824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2376838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2376851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376855 */     // GIR_Coverage, 59221,
     /* 2376855 */     GIR_EraseRootFromParent_Done,
     /* 2376856 */   // Label 33603: @2376856
     /* 2376856 */   GIM_Reject,
     /* 2376857 */ // Label 33601: @2376857
     /* 2376857 */ GIM_Reject,
     /* 2376858 */ // Label 33557: @2376858
     /* 2376858 */ GIM_Try, /*On fail goto*//*Label 33604*/ GIMT_Encode4(2376961),
     /* 2376863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2376866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376874 */   GIM_Try, /*On fail goto*//*Label 33605*/ GIMT_Encode4(2376917), // Rule ID 59186 //
     /* 2376879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376882 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2376885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2376899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376916 */     // GIR_Coverage, 59186,
     /* 2376916 */     GIR_EraseRootFromParent_Done,
     /* 2376917 */   // Label 33605: @2376917
     /* 2376917 */   GIM_Try, /*On fail goto*//*Label 33606*/ GIMT_Encode4(2376960), // Rule ID 59187 //
     /* 2376922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2376925 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2376928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2376942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376959 */     // GIR_Coverage, 59187,
     /* 2376959 */     GIR_EraseRootFromParent_Done,
     /* 2376960 */   // Label 33606: @2376960
     /* 2376960 */   GIM_Reject,
     /* 2376961 */ // Label 33604: @2376961
     /* 2376961 */ GIM_Reject,
     /* 2376962 */ // Label 33558: @2376962
     /* 2376962 */ GIM_Try, /*On fail goto*//*Label 33607*/ GIMT_Encode4(2377065),
     /* 2376967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2376970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376978 */   GIM_Try, /*On fail goto*//*Label 33608*/ GIMT_Encode4(2377021), // Rule ID 59196 //
     /* 2376983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2376986 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2376989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377020 */     // GIR_Coverage, 59196,
     /* 2377020 */     GIR_EraseRootFromParent_Done,
     /* 2377021 */   // Label 33608: @2377021
     /* 2377021 */   GIM_Try, /*On fail goto*//*Label 33609*/ GIMT_Encode4(2377064), // Rule ID 59197 //
     /* 2377026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377029 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2377032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377063 */     // GIR_Coverage, 59197,
     /* 2377063 */     GIR_EraseRootFromParent_Done,
     /* 2377064 */   // Label 33609: @2377064
     /* 2377064 */   GIM_Reject,
     /* 2377065 */ // Label 33607: @2377065
     /* 2377065 */ GIM_Reject,
     /* 2377066 */ // Label 33559: @2377066
     /* 2377066 */ GIM_Try, /*On fail goto*//*Label 33610*/ GIMT_Encode4(2377169),
     /* 2377071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2377074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377082 */   GIM_Try, /*On fail goto*//*Label 33611*/ GIMT_Encode4(2377125), // Rule ID 59214 //
     /* 2377087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377090 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2377093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377124 */     // GIR_Coverage, 59214,
     /* 2377124 */     GIR_EraseRootFromParent_Done,
     /* 2377125 */   // Label 33611: @2377125
     /* 2377125 */   GIM_Try, /*On fail goto*//*Label 33612*/ GIMT_Encode4(2377168), // Rule ID 59215 //
     /* 2377130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377133 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2377136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377167 */     // GIR_Coverage, 59215,
     /* 2377167 */     GIR_EraseRootFromParent_Done,
     /* 2377168 */   // Label 33612: @2377168
     /* 2377168 */   GIM_Reject,
     /* 2377169 */ // Label 33610: @2377169
     /* 2377169 */ GIM_Reject,
     /* 2377170 */ // Label 33560: @2377170
     /* 2377170 */ GIM_Try, /*On fail goto*//*Label 33613*/ GIMT_Encode4(2377273),
     /* 2377175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2377178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377186 */   GIM_Try, /*On fail goto*//*Label 33614*/ GIMT_Encode4(2377229), // Rule ID 59222 //
     /* 2377191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2377194 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2377197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377228 */     // GIR_Coverage, 59222,
     /* 2377228 */     GIR_EraseRootFromParent_Done,
     /* 2377229 */   // Label 33614: @2377229
     /* 2377229 */   GIM_Try, /*On fail goto*//*Label 33615*/ GIMT_Encode4(2377272), // Rule ID 59223 //
     /* 2377234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2377237 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2377240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377271 */     // GIR_Coverage, 59223,
     /* 2377271 */     GIR_EraseRootFromParent_Done,
     /* 2377272 */   // Label 33615: @2377272
     /* 2377272 */   GIM_Reject,
     /* 2377273 */ // Label 33613: @2377273
     /* 2377273 */ GIM_Reject,
     /* 2377274 */ // Label 33561: @2377274
     /* 2377274 */ GIM_Try, /*On fail goto*//*Label 33616*/ GIMT_Encode4(2377377),
     /* 2377279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2377282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377290 */   GIM_Try, /*On fail goto*//*Label 33617*/ GIMT_Encode4(2377333), // Rule ID 59194 //
     /* 2377295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377298 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2377301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377332 */     // GIR_Coverage, 59194,
     /* 2377332 */     GIR_EraseRootFromParent_Done,
     /* 2377333 */   // Label 33617: @2377333
     /* 2377333 */   GIM_Try, /*On fail goto*//*Label 33618*/ GIMT_Encode4(2377376), // Rule ID 59195 //
     /* 2377338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377341 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2377344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2377358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377375 */     // GIR_Coverage, 59195,
     /* 2377375 */     GIR_EraseRootFromParent_Done,
     /* 2377376 */   // Label 33618: @2377376
     /* 2377376 */   GIM_Reject,
     /* 2377377 */ // Label 33616: @2377377
     /* 2377377 */ GIM_Reject,
     /* 2377378 */ // Label 33562: @2377378
     /* 2377378 */ GIM_Try, /*On fail goto*//*Label 33619*/ GIMT_Encode4(2377481),
     /* 2377383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2377386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377394 */   GIM_Try, /*On fail goto*//*Label 33620*/ GIMT_Encode4(2377437), // Rule ID 59208 //
     /* 2377399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377402 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377436 */     // GIR_Coverage, 59208,
     /* 2377436 */     GIR_EraseRootFromParent_Done,
     /* 2377437 */   // Label 33620: @2377437
     /* 2377437 */   GIM_Try, /*On fail goto*//*Label 33621*/ GIMT_Encode4(2377480), // Rule ID 59209 //
     /* 2377442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377445 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377479 */     // GIR_Coverage, 59209,
     /* 2377479 */     GIR_EraseRootFromParent_Done,
     /* 2377480 */   // Label 33621: @2377480
     /* 2377480 */   GIM_Reject,
     /* 2377481 */ // Label 33619: @2377481
     /* 2377481 */ GIM_Reject,
     /* 2377482 */ // Label 33563: @2377482
     /* 2377482 */ GIM_Try, /*On fail goto*//*Label 33622*/ GIMT_Encode4(2377585),
     /* 2377487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2377490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377498 */   GIM_Try, /*On fail goto*//*Label 33623*/ GIMT_Encode4(2377541), // Rule ID 59216 //
     /* 2377503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377506 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2377509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377540 */     // GIR_Coverage, 59216,
     /* 2377540 */     GIR_EraseRootFromParent_Done,
     /* 2377541 */   // Label 33623: @2377541
     /* 2377541 */   GIM_Try, /*On fail goto*//*Label 33624*/ GIMT_Encode4(2377584), // Rule ID 59217 //
     /* 2377546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377549 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2377552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377583 */     // GIR_Coverage, 59217,
     /* 2377583 */     GIR_EraseRootFromParent_Done,
     /* 2377584 */   // Label 33624: @2377584
     /* 2377584 */   GIM_Reject,
     /* 2377585 */ // Label 33622: @2377585
     /* 2377585 */ GIM_Reject,
     /* 2377586 */ // Label 33564: @2377586
     /* 2377586 */ GIM_Try, /*On fail goto*//*Label 33625*/ GIMT_Encode4(2377689),
     /* 2377591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2377594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377602 */   GIM_Try, /*On fail goto*//*Label 33626*/ GIMT_Encode4(2377645), // Rule ID 59224 //
     /* 2377607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2377610 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2377613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2377627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377644 */     // GIR_Coverage, 59224,
     /* 2377644 */     GIR_EraseRootFromParent_Done,
     /* 2377645 */   // Label 33626: @2377645
     /* 2377645 */   GIM_Try, /*On fail goto*//*Label 33627*/ GIMT_Encode4(2377688), // Rule ID 59225 //
     /* 2377650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2377653 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2377656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2377670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377687 */     // GIR_Coverage, 59225,
     /* 2377687 */     GIR_EraseRootFromParent_Done,
     /* 2377688 */   // Label 33627: @2377688
     /* 2377688 */   GIM_Reject,
     /* 2377689 */ // Label 33625: @2377689
     /* 2377689 */ GIM_Reject,
     /* 2377690 */ // Label 33565: @2377690
     /* 2377690 */ GIM_Try, /*On fail goto*//*Label 33628*/ GIMT_Encode4(2377793),
     /* 2377695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2377698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377706 */   GIM_Try, /*On fail goto*//*Label 33629*/ GIMT_Encode4(2377749), // Rule ID 59202 //
     /* 2377711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377714 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2377717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377748 */     // GIR_Coverage, 59202,
     /* 2377748 */     GIR_EraseRootFromParent_Done,
     /* 2377749 */   // Label 33629: @2377749
     /* 2377749 */   GIM_Try, /*On fail goto*//*Label 33630*/ GIMT_Encode4(2377792), // Rule ID 59203 //
     /* 2377754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377757 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2377760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2377774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377791 */     // GIR_Coverage, 59203,
     /* 2377791 */     GIR_EraseRootFromParent_Done,
     /* 2377792 */   // Label 33630: @2377792
     /* 2377792 */   GIM_Reject,
     /* 2377793 */ // Label 33628: @2377793
     /* 2377793 */ GIM_Reject,
     /* 2377794 */ // Label 33566: @2377794
     /* 2377794 */ GIM_Try, /*On fail goto*//*Label 33631*/ GIMT_Encode4(2377897),
     /* 2377799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2377802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377810 */   GIM_Try, /*On fail goto*//*Label 33632*/ GIMT_Encode4(2377853), // Rule ID 59210 //
     /* 2377815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377818 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2377821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377852 */     // GIR_Coverage, 59210,
     /* 2377852 */     GIR_EraseRootFromParent_Done,
     /* 2377853 */   // Label 33632: @2377853
     /* 2377853 */   GIM_Try, /*On fail goto*//*Label 33633*/ GIMT_Encode4(2377896), // Rule ID 59211 //
     /* 2377858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377861 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2377864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2377878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377895 */     // GIR_Coverage, 59211,
     /* 2377895 */     GIR_EraseRootFromParent_Done,
     /* 2377896 */   // Label 33633: @2377896
     /* 2377896 */   GIM_Reject,
     /* 2377897 */ // Label 33631: @2377897
     /* 2377897 */ GIM_Reject,
     /* 2377898 */ // Label 33567: @2377898
     /* 2377898 */ GIM_Try, /*On fail goto*//*Label 33634*/ GIMT_Encode4(2378001),
     /* 2377903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2377906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2377914 */   GIM_Try, /*On fail goto*//*Label 33635*/ GIMT_Encode4(2377957), // Rule ID 59218 //
     /* 2377919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2377922 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2377925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2377939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377956 */     // GIR_Coverage, 59218,
     /* 2377956 */     GIR_EraseRootFromParent_Done,
     /* 2377957 */   // Label 33635: @2377957
     /* 2377957 */   GIM_Try, /*On fail goto*//*Label 33636*/ GIMT_Encode4(2378000), // Rule ID 59219 //
     /* 2377962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2377965 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2377968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2377982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377999 */     // GIR_Coverage, 59219,
     /* 2377999 */     GIR_EraseRootFromParent_Done,
     /* 2378000 */   // Label 33636: @2378000
     /* 2378000 */   GIM_Reject,
     /* 2378001 */ // Label 33634: @2378001
     /* 2378001 */ GIM_Reject,
     /* 2378002 */ // Label 33568: @2378002
     /* 2378002 */ GIM_Try, /*On fail goto*//*Label 33637*/ GIMT_Encode4(2378105),
     /* 2378007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2378010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2378014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2378018 */   GIM_Try, /*On fail goto*//*Label 33638*/ GIMT_Encode4(2378061), // Rule ID 59204 //
     /* 2378023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378026 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2378029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2378043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378060 */     // GIR_Coverage, 59204,
     /* 2378060 */     GIR_EraseRootFromParent_Done,
     /* 2378061 */   // Label 33638: @2378061
     /* 2378061 */   GIM_Try, /*On fail goto*//*Label 33639*/ GIMT_Encode4(2378104), // Rule ID 59205 //
     /* 2378066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378069 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2378072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2378086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378103 */     // GIR_Coverage, 59205,
     /* 2378103 */     GIR_EraseRootFromParent_Done,
     /* 2378104 */   // Label 33639: @2378104
     /* 2378104 */   GIM_Reject,
     /* 2378105 */ // Label 33637: @2378105
     /* 2378105 */ GIM_Reject,
     /* 2378106 */ // Label 33569: @2378106
     /* 2378106 */ GIM_Try, /*On fail goto*//*Label 33640*/ GIMT_Encode4(2378209),
     /* 2378111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2378114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378122 */   GIM_Try, /*On fail goto*//*Label 33641*/ GIMT_Encode4(2378165), // Rule ID 59212 //
     /* 2378127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378130 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2378133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378164 */     // GIR_Coverage, 59212,
     /* 2378164 */     GIR_EraseRootFromParent_Done,
     /* 2378165 */   // Label 33641: @2378165
     /* 2378165 */   GIM_Try, /*On fail goto*//*Label 33642*/ GIMT_Encode4(2378208), // Rule ID 59213 //
     /* 2378170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378173 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2378176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378207 */     // GIR_Coverage, 59213,
     /* 2378207 */     GIR_EraseRootFromParent_Done,
     /* 2378208 */   // Label 33642: @2378208
     /* 2378208 */   GIM_Reject,
     /* 2378209 */ // Label 33640: @2378209
     /* 2378209 */ GIM_Reject,
     /* 2378210 */ // Label 33570: @2378210
     /* 2378210 */ GIM_Try, /*On fail goto*//*Label 33643*/ GIMT_Encode4(2378313),
     /* 2378215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2378218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378226 */   GIM_Try, /*On fail goto*//*Label 33644*/ GIMT_Encode4(2378269), // Rule ID 59206 //
     /* 2378231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378234 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2378237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378268 */     // GIR_Coverage, 59206,
     /* 2378268 */     GIR_EraseRootFromParent_Done,
     /* 2378269 */   // Label 33644: @2378269
     /* 2378269 */   GIM_Try, /*On fail goto*//*Label 33645*/ GIMT_Encode4(2378312), // Rule ID 59207 //
     /* 2378274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378277 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2378280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2378294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378311 */     // GIR_Coverage, 59207,
     /* 2378311 */     GIR_EraseRootFromParent_Done,
     /* 2378312 */   // Label 33645: @2378312
     /* 2378312 */   GIM_Reject,
     /* 2378313 */ // Label 33643: @2378313
     /* 2378313 */ GIM_Reject,
     /* 2378314 */ // Label 33571: @2378314
     /* 2378314 */ GIM_Reject,
     /* 2378315 */ // Label 89: @2378315
     /* 2378315 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33670*/ GIMT_Encode4(2381084),
     /* 2378326 */ /*GILLT_s32*//*Label 33646*/ GIMT_Encode4(2378450),
     /* 2378330 */ /*GILLT_s64*//*Label 33647*/ GIMT_Encode4(2378679), GIMT_Encode4(0),
     /* 2378338 */ /*GILLT_nxv1s8*//*Label 33648*/ GIMT_Encode4(2378796),
     /* 2378342 */ /*GILLT_nxv1s16*//*Label 33649*/ GIMT_Encode4(2378900),
     /* 2378346 */ /*GILLT_nxv1s32*//*Label 33650*/ GIMT_Encode4(2379004),
     /* 2378350 */ /*GILLT_nxv1s64*//*Label 33651*/ GIMT_Encode4(2379108), GIMT_Encode4(0),
     /* 2378358 */ /*GILLT_nxv2s8*//*Label 33652*/ GIMT_Encode4(2379212),
     /* 2378362 */ /*GILLT_nxv2s16*//*Label 33653*/ GIMT_Encode4(2379316),
     /* 2378366 */ /*GILLT_nxv2s32*//*Label 33654*/ GIMT_Encode4(2379420),
     /* 2378370 */ /*GILLT_nxv2s64*//*Label 33655*/ GIMT_Encode4(2379524), GIMT_Encode4(0),
     /* 2378378 */ /*GILLT_nxv4s8*//*Label 33656*/ GIMT_Encode4(2379628),
     /* 2378382 */ /*GILLT_nxv4s16*//*Label 33657*/ GIMT_Encode4(2379732),
     /* 2378386 */ /*GILLT_nxv4s32*//*Label 33658*/ GIMT_Encode4(2379836),
     /* 2378390 */ /*GILLT_nxv4s64*//*Label 33659*/ GIMT_Encode4(2379940), GIMT_Encode4(0),
     /* 2378398 */ /*GILLT_nxv8s8*//*Label 33660*/ GIMT_Encode4(2380044),
     /* 2378402 */ /*GILLT_nxv8s16*//*Label 33661*/ GIMT_Encode4(2380148),
     /* 2378406 */ /*GILLT_nxv8s32*//*Label 33662*/ GIMT_Encode4(2380252),
     /* 2378410 */ /*GILLT_nxv8s64*//*Label 33663*/ GIMT_Encode4(2380356), GIMT_Encode4(0),
     /* 2378418 */ /*GILLT_nxv16s8*//*Label 33664*/ GIMT_Encode4(2380460),
     /* 2378422 */ /*GILLT_nxv16s16*//*Label 33665*/ GIMT_Encode4(2380564),
     /* 2378426 */ /*GILLT_nxv16s32*//*Label 33666*/ GIMT_Encode4(2380668), GIMT_Encode4(0),
     /* 2378434 */ /*GILLT_nxv32s8*//*Label 33667*/ GIMT_Encode4(2380772),
     /* 2378438 */ /*GILLT_nxv32s16*//*Label 33668*/ GIMT_Encode4(2380876), GIMT_Encode4(0),
     /* 2378446 */ /*GILLT_nxv64s8*//*Label 33669*/ GIMT_Encode4(2380980),
     /* 2378450 */ // Label 33646: @2378450
     /* 2378450 */ GIM_Try, /*On fail goto*//*Label 33671*/ GIMT_Encode4(2378678),
     /* 2378455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378458 */   GIM_Try, /*On fail goto*//*Label 33672*/ GIMT_Encode4(2378508), // Rule ID 62562 //
     /* 2378463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2378466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2378474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2378478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2378486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378491 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2378495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2378497 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (TH_FF0:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2378500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2378506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378507 */     // GIR_Coverage, 62562,
     /* 2378507 */     GIR_EraseRootFromParent_Done,
     /* 2378508 */   // Label 33672: @2378508
     /* 2378508 */   GIM_Try, /*On fail goto*//*Label 33673*/ GIMT_Encode4(2378558), // Rule ID 64642 //
     /* 2378513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2378516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2378520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2378524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2378528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2378536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378541 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2378545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2378547 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CLO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CLO),
     /* 2378550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2378556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378557 */     // GIR_Coverage, 64642,
     /* 2378557 */     GIR_EraseRootFromParent_Done,
     /* 2378558 */   // Label 33673: @2378558
     /* 2378558 */   GIM_Try, /*On fail goto*//*Label 33674*/ GIMT_Encode4(2378608), // Rule ID 64643 //
     /* 2378563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2378566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2378570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2378574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2378578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2378586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378591 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2378595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2378597 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (QC_CLO:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_CLO),
     /* 2378600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2378606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378607 */     // GIR_Coverage, 64643,
     /* 2378607 */     GIR_EraseRootFromParent_Done,
     /* 2378608 */   // Label 33674: @2378608
     /* 2378608 */   GIM_Try, /*On fail goto*//*Label 33675*/ GIMT_Encode4(2378631), // Rule ID 2511 //
     /* 2378613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2378616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378624 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2378629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378630 */     // GIR_Coverage, 2511,
     /* 2378630 */     GIR_Done,
     /* 2378631 */   // Label 33675: @2378631
     /* 2378631 */   GIM_Try, /*On fail goto*//*Label 33676*/ GIMT_Encode4(2378654), // Rule ID 62560 //
     /* 2378636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2378639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378647 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2378652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378653 */     // GIR_Coverage, 62560,
     /* 2378653 */     GIR_Done,
     /* 2378654 */   // Label 33676: @2378654
     /* 2378654 */   GIM_Try, /*On fail goto*//*Label 33677*/ GIMT_Encode4(2378677), // Rule ID 64439 //
     /* 2378659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2378662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378670 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FL1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2378670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2378675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378676 */     // GIR_Coverage, 64439,
     /* 2378676 */     GIR_Done,
     /* 2378677 */   // Label 33677: @2378677
     /* 2378677 */   GIM_Reject,
     /* 2378678 */ // Label 33671: @2378678
     /* 2378678 */ GIM_Reject,
     /* 2378679 */ // Label 33647: @2378679
     /* 2378679 */ GIM_Try, /*On fail goto*//*Label 33678*/ GIMT_Encode4(2378795),
     /* 2378684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2378687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378691 */   GIM_Try, /*On fail goto*//*Label 33679*/ GIMT_Encode4(2378737), // Rule ID 62561 //
     /* 2378696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2378699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2378703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2378707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2378711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2378715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378720 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2378724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2378726 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (TH_FF0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2378726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2378729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2378735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378736 */     // GIR_Coverage, 62561,
     /* 2378736 */     GIR_EraseRootFromParent_Done,
     /* 2378737 */   // Label 33679: @2378737
     /* 2378737 */   GIM_Try, /*On fail goto*//*Label 33680*/ GIMT_Encode4(2378756), // Rule ID 2510 //
     /* 2378742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2378745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378749 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2378749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2378754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378755 */     // GIR_Coverage, 2510,
     /* 2378755 */     GIR_Done,
     /* 2378756 */   // Label 33680: @2378756
     /* 2378756 */   GIM_Try, /*On fail goto*//*Label 33681*/ GIMT_Encode4(2378775), // Rule ID 62559 //
     /* 2378761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2378764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378768 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2378768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2378773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378774 */     // GIR_Coverage, 62559,
     /* 2378774 */     GIR_Done,
     /* 2378775 */   // Label 33681: @2378775
     /* 2378775 */   GIM_Try, /*On fail goto*//*Label 33682*/ GIMT_Encode4(2378794), // Rule ID 64438 //
     /* 2378780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2378783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2378787 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FL1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2378787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2378792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378793 */     // GIR_Coverage, 64438,
     /* 2378793 */     GIR_Done,
     /* 2378794 */   // Label 33682: @2378794
     /* 2378794 */   GIM_Reject,
     /* 2378795 */ // Label 33678: @2378795
     /* 2378795 */ GIM_Reject,
     /* 2378796 */ // Label 33648: @2378796
     /* 2378796 */ GIM_Try, /*On fail goto*//*Label 33683*/ GIMT_Encode4(2378899),
     /* 2378801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2378804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378812 */   GIM_Try, /*On fail goto*//*Label 33684*/ GIMT_Encode4(2378855), // Rule ID 59138 //
     /* 2378817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378820 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2378823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2378837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378854 */     // GIR_Coverage, 59138,
     /* 2378854 */     GIR_EraseRootFromParent_Done,
     /* 2378855 */   // Label 33684: @2378855
     /* 2378855 */   GIM_Try, /*On fail goto*//*Label 33685*/ GIMT_Encode4(2378898), // Rule ID 59139 //
     /* 2378860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378863 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2378866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2378880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378897 */     // GIR_Coverage, 59139,
     /* 2378897 */     GIR_EraseRootFromParent_Done,
     /* 2378898 */   // Label 33685: @2378898
     /* 2378898 */   GIM_Reject,
     /* 2378899 */ // Label 33683: @2378899
     /* 2378899 */ GIM_Reject,
     /* 2378900 */ // Label 33649: @2378900
     /* 2378900 */ GIM_Try, /*On fail goto*//*Label 33686*/ GIMT_Encode4(2379003),
     /* 2378905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2378908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2378916 */   GIM_Try, /*On fail goto*//*Label 33687*/ GIMT_Encode4(2378959), // Rule ID 59144 //
     /* 2378921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2378924 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2378941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378958 */     // GIR_Coverage, 59144,
     /* 2378958 */     GIR_EraseRootFromParent_Done,
     /* 2378959 */   // Label 33687: @2378959
     /* 2378959 */   GIM_Try, /*On fail goto*//*Label 33688*/ GIMT_Encode4(2379002), // Rule ID 59145 //
     /* 2378964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2378967 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2378970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2378984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379001 */     // GIR_Coverage, 59145,
     /* 2379001 */     GIR_EraseRootFromParent_Done,
     /* 2379002 */   // Label 33688: @2379002
     /* 2379002 */   GIM_Reject,
     /* 2379003 */ // Label 33686: @2379003
     /* 2379003 */ GIM_Reject,
     /* 2379004 */ // Label 33650: @2379004
     /* 2379004 */ GIM_Try, /*On fail goto*//*Label 33689*/ GIMT_Encode4(2379107),
     /* 2379009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2379012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379020 */   GIM_Try, /*On fail goto*//*Label 33690*/ GIMT_Encode4(2379063), // Rule ID 59148 //
     /* 2379025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379028 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2379031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379062 */     // GIR_Coverage, 59148,
     /* 2379062 */     GIR_EraseRootFromParent_Done,
     /* 2379063 */   // Label 33690: @2379063
     /* 2379063 */   GIM_Try, /*On fail goto*//*Label 33691*/ GIMT_Encode4(2379106), // Rule ID 59149 //
     /* 2379068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379071 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2379074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379105 */     // GIR_Coverage, 59149,
     /* 2379105 */     GIR_EraseRootFromParent_Done,
     /* 2379106 */   // Label 33691: @2379106
     /* 2379106 */   GIM_Reject,
     /* 2379107 */ // Label 33689: @2379107
     /* 2379107 */ GIM_Reject,
     /* 2379108 */ // Label 33651: @2379108
     /* 2379108 */ GIM_Try, /*On fail goto*//*Label 33692*/ GIMT_Encode4(2379211),
     /* 2379113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2379116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379124 */   GIM_Try, /*On fail goto*//*Label 33693*/ GIMT_Encode4(2379167), // Rule ID 59156 //
     /* 2379129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2379132 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2379135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379151 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379166 */     // GIR_Coverage, 59156,
     /* 2379166 */     GIR_EraseRootFromParent_Done,
     /* 2379167 */   // Label 33693: @2379167
     /* 2379167 */   GIM_Try, /*On fail goto*//*Label 33694*/ GIMT_Encode4(2379210), // Rule ID 59157 //
     /* 2379172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2379175 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2379178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379209 */     // GIR_Coverage, 59157,
     /* 2379209 */     GIR_EraseRootFromParent_Done,
     /* 2379210 */   // Label 33694: @2379210
     /* 2379210 */   GIM_Reject,
     /* 2379211 */ // Label 33692: @2379211
     /* 2379211 */ GIM_Reject,
     /* 2379212 */ // Label 33652: @2379212
     /* 2379212 */ GIM_Try, /*On fail goto*//*Label 33695*/ GIMT_Encode4(2379315),
     /* 2379217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2379220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379228 */   GIM_Try, /*On fail goto*//*Label 33696*/ GIMT_Encode4(2379271), // Rule ID 59140 //
     /* 2379233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379236 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2379239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2379253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379270 */     // GIR_Coverage, 59140,
     /* 2379270 */     GIR_EraseRootFromParent_Done,
     /* 2379271 */   // Label 33696: @2379271
     /* 2379271 */   GIM_Try, /*On fail goto*//*Label 33697*/ GIMT_Encode4(2379314), // Rule ID 59141 //
     /* 2379276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379279 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2379282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2379296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379313 */     // GIR_Coverage, 59141,
     /* 2379313 */     GIR_EraseRootFromParent_Done,
     /* 2379314 */   // Label 33697: @2379314
     /* 2379314 */   GIM_Reject,
     /* 2379315 */ // Label 33695: @2379315
     /* 2379315 */ GIM_Reject,
     /* 2379316 */ // Label 33653: @2379316
     /* 2379316 */ GIM_Try, /*On fail goto*//*Label 33698*/ GIMT_Encode4(2379419),
     /* 2379321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2379324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379332 */   GIM_Try, /*On fail goto*//*Label 33699*/ GIMT_Encode4(2379375), // Rule ID 59146 //
     /* 2379337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379340 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2379343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379374 */     // GIR_Coverage, 59146,
     /* 2379374 */     GIR_EraseRootFromParent_Done,
     /* 2379375 */   // Label 33699: @2379375
     /* 2379375 */   GIM_Try, /*On fail goto*//*Label 33700*/ GIMT_Encode4(2379418), // Rule ID 59147 //
     /* 2379380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379383 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2379386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379417 */     // GIR_Coverage, 59147,
     /* 2379417 */     GIR_EraseRootFromParent_Done,
     /* 2379418 */   // Label 33700: @2379418
     /* 2379418 */   GIM_Reject,
     /* 2379419 */ // Label 33698: @2379419
     /* 2379419 */ GIM_Reject,
     /* 2379420 */ // Label 33654: @2379420
     /* 2379420 */ GIM_Try, /*On fail goto*//*Label 33701*/ GIMT_Encode4(2379523),
     /* 2379425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2379428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379436 */   GIM_Try, /*On fail goto*//*Label 33702*/ GIMT_Encode4(2379479), // Rule ID 59154 //
     /* 2379441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379444 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379478 */     // GIR_Coverage, 59154,
     /* 2379478 */     GIR_EraseRootFromParent_Done,
     /* 2379479 */   // Label 33702: @2379479
     /* 2379479 */   GIM_Try, /*On fail goto*//*Label 33703*/ GIMT_Encode4(2379522), // Rule ID 59155 //
     /* 2379484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379487 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379521 */     // GIR_Coverage, 59155,
     /* 2379521 */     GIR_EraseRootFromParent_Done,
     /* 2379522 */   // Label 33703: @2379522
     /* 2379522 */   GIM_Reject,
     /* 2379523 */ // Label 33701: @2379523
     /* 2379523 */ GIM_Reject,
     /* 2379524 */ // Label 33655: @2379524
     /* 2379524 */ GIM_Try, /*On fail goto*//*Label 33704*/ GIMT_Encode4(2379627),
     /* 2379529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2379532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379540 */   GIM_Try, /*On fail goto*//*Label 33705*/ GIMT_Encode4(2379583), // Rule ID 59176 //
     /* 2379545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2379548 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2379565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379582 */     // GIR_Coverage, 59176,
     /* 2379582 */     GIR_EraseRootFromParent_Done,
     /* 2379583 */   // Label 33705: @2379583
     /* 2379583 */   GIM_Try, /*On fail goto*//*Label 33706*/ GIMT_Encode4(2379626), // Rule ID 59177 //
     /* 2379588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2379591 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2379608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379625 */     // GIR_Coverage, 59177,
     /* 2379625 */     GIR_EraseRootFromParent_Done,
     /* 2379626 */   // Label 33706: @2379626
     /* 2379626 */   GIM_Reject,
     /* 2379627 */ // Label 33704: @2379627
     /* 2379627 */ GIM_Reject,
     /* 2379628 */ // Label 33656: @2379628
     /* 2379628 */ GIM_Try, /*On fail goto*//*Label 33707*/ GIMT_Encode4(2379731),
     /* 2379633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2379636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379644 */   GIM_Try, /*On fail goto*//*Label 33708*/ GIMT_Encode4(2379687), // Rule ID 59142 //
     /* 2379649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379652 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2379655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379686 */     // GIR_Coverage, 59142,
     /* 2379686 */     GIR_EraseRootFromParent_Done,
     /* 2379687 */   // Label 33708: @2379687
     /* 2379687 */   GIM_Try, /*On fail goto*//*Label 33709*/ GIMT_Encode4(2379730), // Rule ID 59143 //
     /* 2379692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379695 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2379698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2379712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379729 */     // GIR_Coverage, 59143,
     /* 2379729 */     GIR_EraseRootFromParent_Done,
     /* 2379730 */   // Label 33709: @2379730
     /* 2379730 */   GIM_Reject,
     /* 2379731 */ // Label 33707: @2379731
     /* 2379731 */ GIM_Reject,
     /* 2379732 */ // Label 33657: @2379732
     /* 2379732 */ GIM_Try, /*On fail goto*//*Label 33710*/ GIMT_Encode4(2379835),
     /* 2379737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2379740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379748 */   GIM_Try, /*On fail goto*//*Label 33711*/ GIMT_Encode4(2379791), // Rule ID 59152 //
     /* 2379753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379756 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379790 */     // GIR_Coverage, 59152,
     /* 2379790 */     GIR_EraseRootFromParent_Done,
     /* 2379791 */   // Label 33711: @2379791
     /* 2379791 */   GIM_Try, /*On fail goto*//*Label 33712*/ GIMT_Encode4(2379834), // Rule ID 59153 //
     /* 2379796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379799 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2379816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379833 */     // GIR_Coverage, 59153,
     /* 2379833 */     GIR_EraseRootFromParent_Done,
     /* 2379834 */   // Label 33712: @2379834
     /* 2379834 */   GIM_Reject,
     /* 2379835 */ // Label 33710: @2379835
     /* 2379835 */ GIM_Reject,
     /* 2379836 */ // Label 33658: @2379836
     /* 2379836 */ GIM_Try, /*On fail goto*//*Label 33713*/ GIMT_Encode4(2379939),
     /* 2379841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2379844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379852 */   GIM_Try, /*On fail goto*//*Label 33714*/ GIMT_Encode4(2379895), // Rule ID 59170 //
     /* 2379857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2379860 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2379863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2379877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379894 */     // GIR_Coverage, 59170,
     /* 2379894 */     GIR_EraseRootFromParent_Done,
     /* 2379895 */   // Label 33714: @2379895
     /* 2379895 */   GIM_Try, /*On fail goto*//*Label 33715*/ GIMT_Encode4(2379938), // Rule ID 59171 //
     /* 2379900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2379903 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2379906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2379920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379937 */     // GIR_Coverage, 59171,
     /* 2379937 */     GIR_EraseRootFromParent_Done,
     /* 2379938 */   // Label 33715: @2379938
     /* 2379938 */   GIM_Reject,
     /* 2379939 */ // Label 33713: @2379939
     /* 2379939 */ GIM_Reject,
     /* 2379940 */ // Label 33659: @2379940
     /* 2379940 */ GIM_Try, /*On fail goto*//*Label 33716*/ GIMT_Encode4(2380043),
     /* 2379945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2379948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2379956 */   GIM_Try, /*On fail goto*//*Label 33717*/ GIMT_Encode4(2379999), // Rule ID 59178 //
     /* 2379961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2379964 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2379967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2379981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379998 */     // GIR_Coverage, 59178,
     /* 2379998 */     GIR_EraseRootFromParent_Done,
     /* 2379999 */   // Label 33717: @2379999
     /* 2379999 */   GIM_Try, /*On fail goto*//*Label 33718*/ GIMT_Encode4(2380042), // Rule ID 59179 //
     /* 2380004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2380007 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2380010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380041 */     // GIR_Coverage, 59179,
     /* 2380041 */     GIR_EraseRootFromParent_Done,
     /* 2380042 */   // Label 33718: @2380042
     /* 2380042 */   GIM_Reject,
     /* 2380043 */ // Label 33716: @2380043
     /* 2380043 */ GIM_Reject,
     /* 2380044 */ // Label 33660: @2380044
     /* 2380044 */ GIM_Try, /*On fail goto*//*Label 33719*/ GIMT_Encode4(2380147),
     /* 2380049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2380052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2380056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2380060 */   GIM_Try, /*On fail goto*//*Label 33720*/ GIMT_Encode4(2380103), // Rule ID 59150 //
     /* 2380065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380068 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2380071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2380085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380102 */     // GIR_Coverage, 59150,
     /* 2380102 */     GIR_EraseRootFromParent_Done,
     /* 2380103 */   // Label 33720: @2380103
     /* 2380103 */   GIM_Try, /*On fail goto*//*Label 33721*/ GIMT_Encode4(2380146), // Rule ID 59151 //
     /* 2380108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380111 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2380114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2380128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380145 */     // GIR_Coverage, 59151,
     /* 2380145 */     GIR_EraseRootFromParent_Done,
     /* 2380146 */   // Label 33721: @2380146
     /* 2380146 */   GIM_Reject,
     /* 2380147 */ // Label 33719: @2380147
     /* 2380147 */ GIM_Reject,
     /* 2380148 */ // Label 33661: @2380148
     /* 2380148 */ GIM_Try, /*On fail goto*//*Label 33722*/ GIMT_Encode4(2380251),
     /* 2380153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2380156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380164 */   GIM_Try, /*On fail goto*//*Label 33723*/ GIMT_Encode4(2380207), // Rule ID 59164 //
     /* 2380169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380172 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2380175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380206 */     // GIR_Coverage, 59164,
     /* 2380206 */     GIR_EraseRootFromParent_Done,
     /* 2380207 */   // Label 33723: @2380207
     /* 2380207 */   GIM_Try, /*On fail goto*//*Label 33724*/ GIMT_Encode4(2380250), // Rule ID 59165 //
     /* 2380212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380215 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2380218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380249 */     // GIR_Coverage, 59165,
     /* 2380249 */     GIR_EraseRootFromParent_Done,
     /* 2380250 */   // Label 33724: @2380250
     /* 2380250 */   GIM_Reject,
     /* 2380251 */ // Label 33722: @2380251
     /* 2380251 */ GIM_Reject,
     /* 2380252 */ // Label 33662: @2380252
     /* 2380252 */ GIM_Try, /*On fail goto*//*Label 33725*/ GIMT_Encode4(2380355),
     /* 2380257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2380260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380268 */   GIM_Try, /*On fail goto*//*Label 33726*/ GIMT_Encode4(2380311), // Rule ID 59172 //
     /* 2380273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380276 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2380279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380310 */     // GIR_Coverage, 59172,
     /* 2380310 */     GIR_EraseRootFromParent_Done,
     /* 2380311 */   // Label 33726: @2380311
     /* 2380311 */   GIM_Try, /*On fail goto*//*Label 33727*/ GIMT_Encode4(2380354), // Rule ID 59173 //
     /* 2380316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380319 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2380322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380353 */     // GIR_Coverage, 59173,
     /* 2380353 */     GIR_EraseRootFromParent_Done,
     /* 2380354 */   // Label 33727: @2380354
     /* 2380354 */   GIM_Reject,
     /* 2380355 */ // Label 33725: @2380355
     /* 2380355 */ GIM_Reject,
     /* 2380356 */ // Label 33663: @2380356
     /* 2380356 */ GIM_Try, /*On fail goto*//*Label 33728*/ GIMT_Encode4(2380459),
     /* 2380361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2380364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380372 */   GIM_Try, /*On fail goto*//*Label 33729*/ GIMT_Encode4(2380415), // Rule ID 59180 //
     /* 2380377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2380380 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2380397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380414 */     // GIR_Coverage, 59180,
     /* 2380414 */     GIR_EraseRootFromParent_Done,
     /* 2380415 */   // Label 33729: @2380415
     /* 2380415 */   GIM_Try, /*On fail goto*//*Label 33730*/ GIMT_Encode4(2380458), // Rule ID 59181 //
     /* 2380420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2380423 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2380440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380457 */     // GIR_Coverage, 59181,
     /* 2380457 */     GIR_EraseRootFromParent_Done,
     /* 2380458 */   // Label 33730: @2380458
     /* 2380458 */   GIM_Reject,
     /* 2380459 */ // Label 33728: @2380459
     /* 2380459 */ GIM_Reject,
     /* 2380460 */ // Label 33664: @2380460
     /* 2380460 */ GIM_Try, /*On fail goto*//*Label 33731*/ GIMT_Encode4(2380563),
     /* 2380465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2380468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380476 */   GIM_Try, /*On fail goto*//*Label 33732*/ GIMT_Encode4(2380519), // Rule ID 59158 //
     /* 2380481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380484 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380518 */     // GIR_Coverage, 59158,
     /* 2380518 */     GIR_EraseRootFromParent_Done,
     /* 2380519 */   // Label 33732: @2380519
     /* 2380519 */   GIM_Try, /*On fail goto*//*Label 33733*/ GIMT_Encode4(2380562), // Rule ID 59159 //
     /* 2380524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380527 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2380530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2380544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380561 */     // GIR_Coverage, 59159,
     /* 2380561 */     GIR_EraseRootFromParent_Done,
     /* 2380562 */   // Label 33733: @2380562
     /* 2380562 */   GIM_Reject,
     /* 2380563 */ // Label 33731: @2380563
     /* 2380563 */ GIM_Reject,
     /* 2380564 */ // Label 33665: @2380564
     /* 2380564 */ GIM_Try, /*On fail goto*//*Label 33734*/ GIMT_Encode4(2380667),
     /* 2380569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2380572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380580 */   GIM_Try, /*On fail goto*//*Label 33735*/ GIMT_Encode4(2380623), // Rule ID 59166 //
     /* 2380585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380588 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380622 */     // GIR_Coverage, 59166,
     /* 2380622 */     GIR_EraseRootFromParent_Done,
     /* 2380623 */   // Label 33735: @2380623
     /* 2380623 */   GIM_Try, /*On fail goto*//*Label 33736*/ GIMT_Encode4(2380666), // Rule ID 59167 //
     /* 2380628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380631 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380665 */     // GIR_Coverage, 59167,
     /* 2380665 */     GIR_EraseRootFromParent_Done,
     /* 2380666 */   // Label 33736: @2380666
     /* 2380666 */   GIM_Reject,
     /* 2380667 */ // Label 33734: @2380667
     /* 2380667 */ GIM_Reject,
     /* 2380668 */ // Label 33666: @2380668
     /* 2380668 */ GIM_Try, /*On fail goto*//*Label 33737*/ GIMT_Encode4(2380771),
     /* 2380673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2380676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380684 */   GIM_Try, /*On fail goto*//*Label 33738*/ GIMT_Encode4(2380727), // Rule ID 59174 //
     /* 2380689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380692 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2380709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380726 */     // GIR_Coverage, 59174,
     /* 2380726 */     GIR_EraseRootFromParent_Done,
     /* 2380727 */   // Label 33738: @2380727
     /* 2380727 */   GIM_Try, /*On fail goto*//*Label 33739*/ GIMT_Encode4(2380770), // Rule ID 59175 //
     /* 2380732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380735 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2380752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380769 */     // GIR_Coverage, 59175,
     /* 2380769 */     GIR_EraseRootFromParent_Done,
     /* 2380770 */   // Label 33739: @2380770
     /* 2380770 */   GIM_Reject,
     /* 2380771 */ // Label 33737: @2380771
     /* 2380771 */ GIM_Reject,
     /* 2380772 */ // Label 33667: @2380772
     /* 2380772 */ GIM_Try, /*On fail goto*//*Label 33740*/ GIMT_Encode4(2380875),
     /* 2380777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2380780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380788 */   GIM_Try, /*On fail goto*//*Label 33741*/ GIMT_Encode4(2380831), // Rule ID 59160 //
     /* 2380793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380796 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2380799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380830 */     // GIR_Coverage, 59160,
     /* 2380830 */     GIR_EraseRootFromParent_Done,
     /* 2380831 */   // Label 33741: @2380831
     /* 2380831 */   GIM_Try, /*On fail goto*//*Label 33742*/ GIMT_Encode4(2380874), // Rule ID 59161 //
     /* 2380836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380839 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2380842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2380856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380873 */     // GIR_Coverage, 59161,
     /* 2380873 */     GIR_EraseRootFromParent_Done,
     /* 2380874 */   // Label 33742: @2380874
     /* 2380874 */   GIM_Reject,
     /* 2380875 */ // Label 33740: @2380875
     /* 2380875 */ GIM_Reject,
     /* 2380876 */ // Label 33668: @2380876
     /* 2380876 */ GIM_Try, /*On fail goto*//*Label 33743*/ GIMT_Encode4(2380979),
     /* 2380881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2380884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380892 */   GIM_Try, /*On fail goto*//*Label 33744*/ GIMT_Encode4(2380935), // Rule ID 59168 //
     /* 2380897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2380900 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2380917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380934 */     // GIR_Coverage, 59168,
     /* 2380934 */     GIR_EraseRootFromParent_Done,
     /* 2380935 */   // Label 33744: @2380935
     /* 2380935 */   GIM_Try, /*On fail goto*//*Label 33745*/ GIMT_Encode4(2380978), // Rule ID 59169 //
     /* 2380940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2380943 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2380960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380977 */     // GIR_Coverage, 59169,
     /* 2380977 */     GIR_EraseRootFromParent_Done,
     /* 2380978 */   // Label 33745: @2380978
     /* 2380978 */   GIM_Reject,
     /* 2380979 */ // Label 33743: @2380979
     /* 2380979 */ GIM_Reject,
     /* 2380980 */ // Label 33669: @2380980
     /* 2380980 */ GIM_Try, /*On fail goto*//*Label 33746*/ GIMT_Encode4(2381083),
     /* 2380985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2380988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380996 */   GIM_Try, /*On fail goto*//*Label 33747*/ GIMT_Encode4(2381039), // Rule ID 59162 //
     /* 2381001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381004 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2381007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2381021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381038 */     // GIR_Coverage, 59162,
     /* 2381038 */     GIR_EraseRootFromParent_Done,
     /* 2381039 */   // Label 33747: @2381039
     /* 2381039 */   GIM_Try, /*On fail goto*//*Label 33748*/ GIMT_Encode4(2381082), // Rule ID 59163 //
     /* 2381044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381047 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2381050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2381064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381081 */     // GIR_Coverage, 59163,
     /* 2381081 */     GIR_EraseRootFromParent_Done,
     /* 2381082 */   // Label 33748: @2381082
     /* 2381082 */   GIM_Reject,
     /* 2381083 */ // Label 33746: @2381083
     /* 2381083 */ GIM_Reject,
     /* 2381084 */ // Label 33670: @2381084
     /* 2381084 */ GIM_Reject,
     /* 2381085 */ // Label 90: @2381085
     /* 2381085 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33773*/ GIMT_Encode4(2383635),
     /* 2381096 */ /*GILLT_s32*//*Label 33749*/ GIMT_Encode4(2381220),
     /* 2381100 */ /*GILLT_s64*//*Label 33750*/ GIMT_Encode4(2381268), GIMT_Encode4(0),
     /* 2381108 */ /*GILLT_nxv1s8*//*Label 33751*/ GIMT_Encode4(2381347),
     /* 2381112 */ /*GILLT_nxv1s16*//*Label 33752*/ GIMT_Encode4(2381451),
     /* 2381116 */ /*GILLT_nxv1s32*//*Label 33753*/ GIMT_Encode4(2381555),
     /* 2381120 */ /*GILLT_nxv1s64*//*Label 33754*/ GIMT_Encode4(2381659), GIMT_Encode4(0),
     /* 2381128 */ /*GILLT_nxv2s8*//*Label 33755*/ GIMT_Encode4(2381763),
     /* 2381132 */ /*GILLT_nxv2s16*//*Label 33756*/ GIMT_Encode4(2381867),
     /* 2381136 */ /*GILLT_nxv2s32*//*Label 33757*/ GIMT_Encode4(2381971),
     /* 2381140 */ /*GILLT_nxv2s64*//*Label 33758*/ GIMT_Encode4(2382075), GIMT_Encode4(0),
     /* 2381148 */ /*GILLT_nxv4s8*//*Label 33759*/ GIMT_Encode4(2382179),
     /* 2381152 */ /*GILLT_nxv4s16*//*Label 33760*/ GIMT_Encode4(2382283),
     /* 2381156 */ /*GILLT_nxv4s32*//*Label 33761*/ GIMT_Encode4(2382387),
     /* 2381160 */ /*GILLT_nxv4s64*//*Label 33762*/ GIMT_Encode4(2382491), GIMT_Encode4(0),
     /* 2381168 */ /*GILLT_nxv8s8*//*Label 33763*/ GIMT_Encode4(2382595),
     /* 2381172 */ /*GILLT_nxv8s16*//*Label 33764*/ GIMT_Encode4(2382699),
     /* 2381176 */ /*GILLT_nxv8s32*//*Label 33765*/ GIMT_Encode4(2382803),
     /* 2381180 */ /*GILLT_nxv8s64*//*Label 33766*/ GIMT_Encode4(2382907), GIMT_Encode4(0),
     /* 2381188 */ /*GILLT_nxv16s8*//*Label 33767*/ GIMT_Encode4(2383011),
     /* 2381192 */ /*GILLT_nxv16s16*//*Label 33768*/ GIMT_Encode4(2383115),
     /* 2381196 */ /*GILLT_nxv16s32*//*Label 33769*/ GIMT_Encode4(2383219), GIMT_Encode4(0),
     /* 2381204 */ /*GILLT_nxv32s8*//*Label 33770*/ GIMT_Encode4(2383323),
     /* 2381208 */ /*GILLT_nxv32s16*//*Label 33771*/ GIMT_Encode4(2383427), GIMT_Encode4(0),
     /* 2381216 */ /*GILLT_nxv64s8*//*Label 33772*/ GIMT_Encode4(2383531),
     /* 2381220 */ // Label 33749: @2381220
     /* 2381220 */ GIM_Try, /*On fail goto*//*Label 33774*/ GIMT_Encode4(2381267),
     /* 2381225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381236 */   GIM_Try, /*On fail goto*//*Label 33775*/ GIMT_Encode4(2381251), // Rule ID 2515 //
     /* 2381241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2381244 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CPOP:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2381244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2381249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381250 */     // GIR_Coverage, 2515,
     /* 2381250 */     GIR_Done,
     /* 2381251 */   // Label 33775: @2381251
     /* 2381251 */   GIM_Try, /*On fail goto*//*Label 33776*/ GIMT_Encode4(2381266), // Rule ID 64442 //
     /* 2381256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2381259 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_CNT:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2381259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2381264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381265 */     // GIR_Coverage, 64442,
     /* 2381265 */     GIR_Done,
     /* 2381266 */   // Label 33776: @2381266
     /* 2381266 */   GIM_Reject,
     /* 2381267 */ // Label 33774: @2381267
     /* 2381267 */ GIM_Reject,
     /* 2381268 */ // Label 33750: @2381268
     /* 2381268 */ GIM_Try, /*On fail goto*//*Label 33777*/ GIMT_Encode4(2381346),
     /* 2381273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381280 */   GIM_Try, /*On fail goto*//*Label 33778*/ GIMT_Encode4(2381307), // Rule ID 2518 //
     /* 2381285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2381288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2381295 */     // (ctpop:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (CPOPW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CPOPW),
     /* 2381298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2381305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381306 */     // GIR_Coverage, 2518,
     /* 2381306 */     GIR_EraseRootFromParent_Done,
     /* 2381307 */   // Label 33778: @2381307
     /* 2381307 */   GIM_Try, /*On fail goto*//*Label 33779*/ GIMT_Encode4(2381326), // Rule ID 2514 //
     /* 2381312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2381315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381319 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CPOP:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2381324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381325 */     // GIR_Coverage, 2514,
     /* 2381325 */     GIR_Done,
     /* 2381326 */   // Label 33779: @2381326
     /* 2381326 */   GIM_Try, /*On fail goto*//*Label 33780*/ GIMT_Encode4(2381345), // Rule ID 64441 //
     /* 2381331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2381334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381338 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_CNT:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2381338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2381343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381344 */     // GIR_Coverage, 64441,
     /* 2381344 */     GIR_Done,
     /* 2381345 */   // Label 33780: @2381345
     /* 2381345 */   GIM_Reject,
     /* 2381346 */ // Label 33777: @2381346
     /* 2381346 */ GIM_Reject,
     /* 2381347 */ // Label 33751: @2381347
     /* 2381347 */ GIM_Try, /*On fail goto*//*Label 33781*/ GIMT_Encode4(2381450),
     /* 2381352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2381355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381363 */   GIM_Try, /*On fail goto*//*Label 33782*/ GIMT_Encode4(2381406), // Rule ID 59226 //
     /* 2381368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381371 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2381374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2381388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381405 */     // GIR_Coverage, 59226,
     /* 2381405 */     GIR_EraseRootFromParent_Done,
     /* 2381406 */   // Label 33782: @2381406
     /* 2381406 */   GIM_Try, /*On fail goto*//*Label 33783*/ GIMT_Encode4(2381449), // Rule ID 59227 //
     /* 2381411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381414 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2381417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2381431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381448 */     // GIR_Coverage, 59227,
     /* 2381448 */     GIR_EraseRootFromParent_Done,
     /* 2381449 */   // Label 33783: @2381449
     /* 2381449 */   GIM_Reject,
     /* 2381450 */ // Label 33781: @2381450
     /* 2381450 */ GIM_Reject,
     /* 2381451 */ // Label 33752: @2381451
     /* 2381451 */ GIM_Try, /*On fail goto*//*Label 33784*/ GIMT_Encode4(2381554),
     /* 2381456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2381459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381467 */   GIM_Try, /*On fail goto*//*Label 33785*/ GIMT_Encode4(2381510), // Rule ID 59232 //
     /* 2381472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381475 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2381492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381509 */     // GIR_Coverage, 59232,
     /* 2381509 */     GIR_EraseRootFromParent_Done,
     /* 2381510 */   // Label 33785: @2381510
     /* 2381510 */   GIM_Try, /*On fail goto*//*Label 33786*/ GIMT_Encode4(2381553), // Rule ID 59233 //
     /* 2381515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381518 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2381535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381552 */     // GIR_Coverage, 59233,
     /* 2381552 */     GIR_EraseRootFromParent_Done,
     /* 2381553 */   // Label 33786: @2381553
     /* 2381553 */   GIM_Reject,
     /* 2381554 */ // Label 33784: @2381554
     /* 2381554 */ GIM_Reject,
     /* 2381555 */ // Label 33753: @2381555
     /* 2381555 */ GIM_Try, /*On fail goto*//*Label 33787*/ GIMT_Encode4(2381658),
     /* 2381560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2381563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381571 */   GIM_Try, /*On fail goto*//*Label 33788*/ GIMT_Encode4(2381614), // Rule ID 59236 //
     /* 2381576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381579 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2381582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2381596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381613 */     // GIR_Coverage, 59236,
     /* 2381613 */     GIR_EraseRootFromParent_Done,
     /* 2381614 */   // Label 33788: @2381614
     /* 2381614 */   GIM_Try, /*On fail goto*//*Label 33789*/ GIMT_Encode4(2381657), // Rule ID 59237 //
     /* 2381619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381622 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2381625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2381639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381656 */     // GIR_Coverage, 59237,
     /* 2381656 */     GIR_EraseRootFromParent_Done,
     /* 2381657 */   // Label 33789: @2381657
     /* 2381657 */   GIM_Reject,
     /* 2381658 */ // Label 33787: @2381658
     /* 2381658 */ GIM_Reject,
     /* 2381659 */ // Label 33754: @2381659
     /* 2381659 */ GIM_Try, /*On fail goto*//*Label 33790*/ GIMT_Encode4(2381762),
     /* 2381664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2381667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381675 */   GIM_Try, /*On fail goto*//*Label 33791*/ GIMT_Encode4(2381718), // Rule ID 59244 //
     /* 2381680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2381683 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2381686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2381700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381717 */     // GIR_Coverage, 59244,
     /* 2381717 */     GIR_EraseRootFromParent_Done,
     /* 2381718 */   // Label 33791: @2381718
     /* 2381718 */   GIM_Try, /*On fail goto*//*Label 33792*/ GIMT_Encode4(2381761), // Rule ID 59245 //
     /* 2381723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2381726 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2381729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2381743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381760 */     // GIR_Coverage, 59245,
     /* 2381760 */     GIR_EraseRootFromParent_Done,
     /* 2381761 */   // Label 33792: @2381761
     /* 2381761 */   GIM_Reject,
     /* 2381762 */ // Label 33790: @2381762
     /* 2381762 */ GIM_Reject,
     /* 2381763 */ // Label 33755: @2381763
     /* 2381763 */ GIM_Try, /*On fail goto*//*Label 33793*/ GIMT_Encode4(2381866),
     /* 2381768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2381771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381779 */   GIM_Try, /*On fail goto*//*Label 33794*/ GIMT_Encode4(2381822), // Rule ID 59228 //
     /* 2381784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381787 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2381790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2381804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381821 */     // GIR_Coverage, 59228,
     /* 2381821 */     GIR_EraseRootFromParent_Done,
     /* 2381822 */   // Label 33794: @2381822
     /* 2381822 */   GIM_Try, /*On fail goto*//*Label 33795*/ GIMT_Encode4(2381865), // Rule ID 59229 //
     /* 2381827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381830 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2381833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2381847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381864 */     // GIR_Coverage, 59229,
     /* 2381864 */     GIR_EraseRootFromParent_Done,
     /* 2381865 */   // Label 33795: @2381865
     /* 2381865 */   GIM_Reject,
     /* 2381866 */ // Label 33793: @2381866
     /* 2381866 */ GIM_Reject,
     /* 2381867 */ // Label 33756: @2381867
     /* 2381867 */ GIM_Try, /*On fail goto*//*Label 33796*/ GIMT_Encode4(2381970),
     /* 2381872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2381875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381883 */   GIM_Try, /*On fail goto*//*Label 33797*/ GIMT_Encode4(2381926), // Rule ID 59234 //
     /* 2381888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381891 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2381894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2381908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381913 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381925 */     // GIR_Coverage, 59234,
     /* 2381925 */     GIR_EraseRootFromParent_Done,
     /* 2381926 */   // Label 33797: @2381926
     /* 2381926 */   GIM_Try, /*On fail goto*//*Label 33798*/ GIMT_Encode4(2381969), // Rule ID 59235 //
     /* 2381931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2381934 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2381937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2381951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381968 */     // GIR_Coverage, 59235,
     /* 2381968 */     GIR_EraseRootFromParent_Done,
     /* 2381969 */   // Label 33798: @2381969
     /* 2381969 */   GIM_Reject,
     /* 2381970 */ // Label 33796: @2381970
     /* 2381970 */ GIM_Reject,
     /* 2381971 */ // Label 33757: @2381971
     /* 2381971 */ GIM_Try, /*On fail goto*//*Label 33799*/ GIMT_Encode4(2382074),
     /* 2381976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2381979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381987 */   GIM_Try, /*On fail goto*//*Label 33800*/ GIMT_Encode4(2382030), // Rule ID 59242 //
     /* 2381992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2381995 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2381998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382029 */     // GIR_Coverage, 59242,
     /* 2382029 */     GIR_EraseRootFromParent_Done,
     /* 2382030 */   // Label 33800: @2382030
     /* 2382030 */   GIM_Try, /*On fail goto*//*Label 33801*/ GIMT_Encode4(2382073), // Rule ID 59243 //
     /* 2382035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382038 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2382041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382072 */     // GIR_Coverage, 59243,
     /* 2382072 */     GIR_EraseRootFromParent_Done,
     /* 2382073 */   // Label 33801: @2382073
     /* 2382073 */   GIM_Reject,
     /* 2382074 */ // Label 33799: @2382074
     /* 2382074 */ GIM_Reject,
     /* 2382075 */ // Label 33758: @2382075
     /* 2382075 */ GIM_Try, /*On fail goto*//*Label 33802*/ GIMT_Encode4(2382178),
     /* 2382080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2382083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382091 */   GIM_Try, /*On fail goto*//*Label 33803*/ GIMT_Encode4(2382134), // Rule ID 59264 //
     /* 2382096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382099 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382133 */     // GIR_Coverage, 59264,
     /* 2382133 */     GIR_EraseRootFromParent_Done,
     /* 2382134 */   // Label 33803: @2382134
     /* 2382134 */   GIM_Try, /*On fail goto*//*Label 33804*/ GIMT_Encode4(2382177), // Rule ID 59265 //
     /* 2382139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382142 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382176 */     // GIR_Coverage, 59265,
     /* 2382176 */     GIR_EraseRootFromParent_Done,
     /* 2382177 */   // Label 33804: @2382177
     /* 2382177 */   GIM_Reject,
     /* 2382178 */ // Label 33802: @2382178
     /* 2382178 */ GIM_Reject,
     /* 2382179 */ // Label 33759: @2382179
     /* 2382179 */ GIM_Try, /*On fail goto*//*Label 33805*/ GIMT_Encode4(2382282),
     /* 2382184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2382187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382195 */   GIM_Try, /*On fail goto*//*Label 33806*/ GIMT_Encode4(2382238), // Rule ID 59230 //
     /* 2382200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382203 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2382206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2382220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382237 */     // GIR_Coverage, 59230,
     /* 2382237 */     GIR_EraseRootFromParent_Done,
     /* 2382238 */   // Label 33806: @2382238
     /* 2382238 */   GIM_Try, /*On fail goto*//*Label 33807*/ GIMT_Encode4(2382281), // Rule ID 59231 //
     /* 2382243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382246 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2382249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2382263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382280 */     // GIR_Coverage, 59231,
     /* 2382280 */     GIR_EraseRootFromParent_Done,
     /* 2382281 */   // Label 33807: @2382281
     /* 2382281 */   GIM_Reject,
     /* 2382282 */ // Label 33805: @2382282
     /* 2382282 */ GIM_Reject,
     /* 2382283 */ // Label 33760: @2382283
     /* 2382283 */ GIM_Try, /*On fail goto*//*Label 33808*/ GIMT_Encode4(2382386),
     /* 2382288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2382291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382299 */   GIM_Try, /*On fail goto*//*Label 33809*/ GIMT_Encode4(2382342), // Rule ID 59240 //
     /* 2382304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382307 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2382310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382341 */     // GIR_Coverage, 59240,
     /* 2382341 */     GIR_EraseRootFromParent_Done,
     /* 2382342 */   // Label 33809: @2382342
     /* 2382342 */   GIM_Try, /*On fail goto*//*Label 33810*/ GIMT_Encode4(2382385), // Rule ID 59241 //
     /* 2382347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382350 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2382353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382384 */     // GIR_Coverage, 59241,
     /* 2382384 */     GIR_EraseRootFromParent_Done,
     /* 2382385 */   // Label 33810: @2382385
     /* 2382385 */   GIM_Reject,
     /* 2382386 */ // Label 33808: @2382386
     /* 2382386 */ GIM_Reject,
     /* 2382387 */ // Label 33761: @2382387
     /* 2382387 */ GIM_Try, /*On fail goto*//*Label 33811*/ GIMT_Encode4(2382490),
     /* 2382392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2382395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382403 */   GIM_Try, /*On fail goto*//*Label 33812*/ GIMT_Encode4(2382446), // Rule ID 59258 //
     /* 2382408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382411 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2382414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382445 */     // GIR_Coverage, 59258,
     /* 2382445 */     GIR_EraseRootFromParent_Done,
     /* 2382446 */   // Label 33812: @2382446
     /* 2382446 */   GIM_Try, /*On fail goto*//*Label 33813*/ GIMT_Encode4(2382489), // Rule ID 59259 //
     /* 2382451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382454 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2382457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382488 */     // GIR_Coverage, 59259,
     /* 2382488 */     GIR_EraseRootFromParent_Done,
     /* 2382489 */   // Label 33813: @2382489
     /* 2382489 */   GIM_Reject,
     /* 2382490 */ // Label 33811: @2382490
     /* 2382490 */ GIM_Reject,
     /* 2382491 */ // Label 33762: @2382491
     /* 2382491 */ GIM_Try, /*On fail goto*//*Label 33814*/ GIMT_Encode4(2382594),
     /* 2382496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2382499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382507 */   GIM_Try, /*On fail goto*//*Label 33815*/ GIMT_Encode4(2382550), // Rule ID 59266 //
     /* 2382512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382515 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2382532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382549 */     // GIR_Coverage, 59266,
     /* 2382549 */     GIR_EraseRootFromParent_Done,
     /* 2382550 */   // Label 33815: @2382550
     /* 2382550 */   GIM_Try, /*On fail goto*//*Label 33816*/ GIMT_Encode4(2382593), // Rule ID 59267 //
     /* 2382555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382558 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2382575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382592 */     // GIR_Coverage, 59267,
     /* 2382592 */     GIR_EraseRootFromParent_Done,
     /* 2382593 */   // Label 33816: @2382593
     /* 2382593 */   GIM_Reject,
     /* 2382594 */ // Label 33814: @2382594
     /* 2382594 */ GIM_Reject,
     /* 2382595 */ // Label 33763: @2382595
     /* 2382595 */ GIM_Try, /*On fail goto*//*Label 33817*/ GIMT_Encode4(2382698),
     /* 2382600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2382603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382611 */   GIM_Try, /*On fail goto*//*Label 33818*/ GIMT_Encode4(2382654), // Rule ID 59238 //
     /* 2382616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382619 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2382622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382653 */     // GIR_Coverage, 59238,
     /* 2382653 */     GIR_EraseRootFromParent_Done,
     /* 2382654 */   // Label 33818: @2382654
     /* 2382654 */   GIM_Try, /*On fail goto*//*Label 33819*/ GIMT_Encode4(2382697), // Rule ID 59239 //
     /* 2382659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382662 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2382665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2382679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382684 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382696 */     // GIR_Coverage, 59239,
     /* 2382696 */     GIR_EraseRootFromParent_Done,
     /* 2382697 */   // Label 33819: @2382697
     /* 2382697 */   GIM_Reject,
     /* 2382698 */ // Label 33817: @2382698
     /* 2382698 */ GIM_Reject,
     /* 2382699 */ // Label 33764: @2382699
     /* 2382699 */ GIM_Try, /*On fail goto*//*Label 33820*/ GIMT_Encode4(2382802),
     /* 2382704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2382707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382715 */   GIM_Try, /*On fail goto*//*Label 33821*/ GIMT_Encode4(2382758), // Rule ID 59252 //
     /* 2382720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382723 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2382726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382757 */     // GIR_Coverage, 59252,
     /* 2382757 */     GIR_EraseRootFromParent_Done,
     /* 2382758 */   // Label 33821: @2382758
     /* 2382758 */   GIM_Try, /*On fail goto*//*Label 33822*/ GIMT_Encode4(2382801), // Rule ID 59253 //
     /* 2382763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382766 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2382769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2382783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382800 */     // GIR_Coverage, 59253,
     /* 2382800 */     GIR_EraseRootFromParent_Done,
     /* 2382801 */   // Label 33822: @2382801
     /* 2382801 */   GIM_Reject,
     /* 2382802 */ // Label 33820: @2382802
     /* 2382802 */ GIM_Reject,
     /* 2382803 */ // Label 33765: @2382803
     /* 2382803 */ GIM_Try, /*On fail goto*//*Label 33823*/ GIMT_Encode4(2382906),
     /* 2382808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2382811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382819 */   GIM_Try, /*On fail goto*//*Label 33824*/ GIMT_Encode4(2382862), // Rule ID 59260 //
     /* 2382824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2382827 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2382830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2382844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382861 */     // GIR_Coverage, 59260,
     /* 2382861 */     GIR_EraseRootFromParent_Done,
     /* 2382862 */   // Label 33824: @2382862
     /* 2382862 */   GIM_Try, /*On fail goto*//*Label 33825*/ GIMT_Encode4(2382905), // Rule ID 59261 //
     /* 2382867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2382870 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2382873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2382887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382904 */     // GIR_Coverage, 59261,
     /* 2382904 */     GIR_EraseRootFromParent_Done,
     /* 2382905 */   // Label 33825: @2382905
     /* 2382905 */   GIM_Reject,
     /* 2382906 */ // Label 33823: @2382906
     /* 2382906 */ GIM_Reject,
     /* 2382907 */ // Label 33766: @2382907
     /* 2382907 */ GIM_Try, /*On fail goto*//*Label 33826*/ GIMT_Encode4(2383010),
     /* 2382912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2382915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382923 */   GIM_Try, /*On fail goto*//*Label 33827*/ GIMT_Encode4(2382966), // Rule ID 59268 //
     /* 2382928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2382931 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2382934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2382948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382965 */     // GIR_Coverage, 59268,
     /* 2382965 */     GIR_EraseRootFromParent_Done,
     /* 2382966 */   // Label 33827: @2382966
     /* 2382966 */   GIM_Try, /*On fail goto*//*Label 33828*/ GIMT_Encode4(2383009), // Rule ID 59269 //
     /* 2382971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2382974 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2382977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2382991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383008 */     // GIR_Coverage, 59269,
     /* 2383008 */     GIR_EraseRootFromParent_Done,
     /* 2383009 */   // Label 33828: @2383009
     /* 2383009 */   GIM_Reject,
     /* 2383010 */ // Label 33826: @2383010
     /* 2383010 */ GIM_Reject,
     /* 2383011 */ // Label 33767: @2383011
     /* 2383011 */ GIM_Try, /*On fail goto*//*Label 33829*/ GIMT_Encode4(2383114),
     /* 2383016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2383019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2383027 */   GIM_Try, /*On fail goto*//*Label 33830*/ GIMT_Encode4(2383070), // Rule ID 59246 //
     /* 2383032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383035 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2383038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2383052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383069 */     // GIR_Coverage, 59246,
     /* 2383069 */     GIR_EraseRootFromParent_Done,
     /* 2383070 */   // Label 33830: @2383070
     /* 2383070 */   GIM_Try, /*On fail goto*//*Label 33831*/ GIMT_Encode4(2383113), // Rule ID 59247 //
     /* 2383075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383078 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2383081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2383095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383112 */     // GIR_Coverage, 59247,
     /* 2383112 */     GIR_EraseRootFromParent_Done,
     /* 2383113 */   // Label 33831: @2383113
     /* 2383113 */   GIM_Reject,
     /* 2383114 */ // Label 33829: @2383114
     /* 2383114 */ GIM_Reject,
     /* 2383115 */ // Label 33768: @2383115
     /* 2383115 */ GIM_Try, /*On fail goto*//*Label 33832*/ GIMT_Encode4(2383218),
     /* 2383120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2383123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383131 */   GIM_Try, /*On fail goto*//*Label 33833*/ GIMT_Encode4(2383174), // Rule ID 59254 //
     /* 2383136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383139 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2383142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383173 */     // GIR_Coverage, 59254,
     /* 2383173 */     GIR_EraseRootFromParent_Done,
     /* 2383174 */   // Label 33833: @2383174
     /* 2383174 */   GIM_Try, /*On fail goto*//*Label 33834*/ GIMT_Encode4(2383217), // Rule ID 59255 //
     /* 2383179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383182 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2383185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383216 */     // GIR_Coverage, 59255,
     /* 2383216 */     GIR_EraseRootFromParent_Done,
     /* 2383217 */   // Label 33834: @2383217
     /* 2383217 */   GIM_Reject,
     /* 2383218 */ // Label 33832: @2383218
     /* 2383218 */ GIM_Reject,
     /* 2383219 */ // Label 33769: @2383219
     /* 2383219 */ GIM_Try, /*On fail goto*//*Label 33835*/ GIMT_Encode4(2383322),
     /* 2383224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2383227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383235 */   GIM_Try, /*On fail goto*//*Label 33836*/ GIMT_Encode4(2383278), // Rule ID 59262 //
     /* 2383240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383243 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2383246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383277 */     // GIR_Coverage, 59262,
     /* 2383277 */     GIR_EraseRootFromParent_Done,
     /* 2383278 */   // Label 33836: @2383278
     /* 2383278 */   GIM_Try, /*On fail goto*//*Label 33837*/ GIMT_Encode4(2383321), // Rule ID 59263 //
     /* 2383283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383286 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2383289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383320 */     // GIR_Coverage, 59263,
     /* 2383320 */     GIR_EraseRootFromParent_Done,
     /* 2383321 */   // Label 33837: @2383321
     /* 2383321 */   GIM_Reject,
     /* 2383322 */ // Label 33835: @2383322
     /* 2383322 */ GIM_Reject,
     /* 2383323 */ // Label 33770: @2383323
     /* 2383323 */ GIM_Try, /*On fail goto*//*Label 33838*/ GIMT_Encode4(2383426),
     /* 2383328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2383331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383339 */   GIM_Try, /*On fail goto*//*Label 33839*/ GIMT_Encode4(2383382), // Rule ID 59248 //
     /* 2383344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383347 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2383350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383381 */     // GIR_Coverage, 59248,
     /* 2383381 */     GIR_EraseRootFromParent_Done,
     /* 2383382 */   // Label 33839: @2383382
     /* 2383382 */   GIM_Try, /*On fail goto*//*Label 33840*/ GIMT_Encode4(2383425), // Rule ID 59249 //
     /* 2383387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383390 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2383393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2383407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383424 */     // GIR_Coverage, 59249,
     /* 2383424 */     GIR_EraseRootFromParent_Done,
     /* 2383425 */   // Label 33840: @2383425
     /* 2383425 */   GIM_Reject,
     /* 2383426 */ // Label 33838: @2383426
     /* 2383426 */ GIM_Reject,
     /* 2383427 */ // Label 33771: @2383427
     /* 2383427 */ GIM_Try, /*On fail goto*//*Label 33841*/ GIMT_Encode4(2383530),
     /* 2383432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2383435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383443 */   GIM_Try, /*On fail goto*//*Label 33842*/ GIMT_Encode4(2383486), // Rule ID 59256 //
     /* 2383448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383451 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2383454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383485 */     // GIR_Coverage, 59256,
     /* 2383485 */     GIR_EraseRootFromParent_Done,
     /* 2383486 */   // Label 33842: @2383486
     /* 2383486 */   GIM_Try, /*On fail goto*//*Label 33843*/ GIMT_Encode4(2383529), // Rule ID 59257 //
     /* 2383491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383494 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2383497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383528 */     // GIR_Coverage, 59257,
     /* 2383528 */     GIR_EraseRootFromParent_Done,
     /* 2383529 */   // Label 33843: @2383529
     /* 2383529 */   GIM_Reject,
     /* 2383530 */ // Label 33841: @2383530
     /* 2383530 */ GIM_Reject,
     /* 2383531 */ // Label 33772: @2383531
     /* 2383531 */ GIM_Try, /*On fail goto*//*Label 33844*/ GIMT_Encode4(2383634),
     /* 2383536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2383539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383547 */   GIM_Try, /*On fail goto*//*Label 33845*/ GIMT_Encode4(2383590), // Rule ID 59250 //
     /* 2383552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2383555 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2383558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383589 */     // GIR_Coverage, 59250,
     /* 2383589 */     GIR_EraseRootFromParent_Done,
     /* 2383590 */   // Label 33845: @2383590
     /* 2383590 */   GIM_Try, /*On fail goto*//*Label 33846*/ GIMT_Encode4(2383633), // Rule ID 59251 //
     /* 2383595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2383598 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2383601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2383615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383632 */     // GIR_Coverage, 59251,
     /* 2383632 */     GIR_EraseRootFromParent_Done,
     /* 2383633 */   // Label 33846: @2383633
     /* 2383633 */   GIM_Reject,
     /* 2383634 */ // Label 33844: @2383634
     /* 2383634 */ GIM_Reject,
     /* 2383635 */ // Label 33773: @2383635
     /* 2383635 */ GIM_Reject,
     /* 2383636 */ // Label 91: @2383636
     /* 2383636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33871*/ GIMT_Encode4(2386170),
     /* 2383647 */ /*GILLT_s32*//*Label 33847*/ GIMT_Encode4(2383771),
     /* 2383651 */ /*GILLT_s64*//*Label 33848*/ GIMT_Encode4(2383834), GIMT_Encode4(0),
     /* 2383659 */ /*GILLT_nxv1s8*//*Label 33849*/ GIMT_Encode4(2383882),
     /* 2383663 */ /*GILLT_nxv1s16*//*Label 33850*/ GIMT_Encode4(2383986),
     /* 2383667 */ /*GILLT_nxv1s32*//*Label 33851*/ GIMT_Encode4(2384090),
     /* 2383671 */ /*GILLT_nxv1s64*//*Label 33852*/ GIMT_Encode4(2384194), GIMT_Encode4(0),
     /* 2383679 */ /*GILLT_nxv2s8*//*Label 33853*/ GIMT_Encode4(2384298),
     /* 2383683 */ /*GILLT_nxv2s16*//*Label 33854*/ GIMT_Encode4(2384402),
     /* 2383687 */ /*GILLT_nxv2s32*//*Label 33855*/ GIMT_Encode4(2384506),
     /* 2383691 */ /*GILLT_nxv2s64*//*Label 33856*/ GIMT_Encode4(2384610), GIMT_Encode4(0),
     /* 2383699 */ /*GILLT_nxv4s8*//*Label 33857*/ GIMT_Encode4(2384714),
     /* 2383703 */ /*GILLT_nxv4s16*//*Label 33858*/ GIMT_Encode4(2384818),
     /* 2383707 */ /*GILLT_nxv4s32*//*Label 33859*/ GIMT_Encode4(2384922),
     /* 2383711 */ /*GILLT_nxv4s64*//*Label 33860*/ GIMT_Encode4(2385026), GIMT_Encode4(0),
     /* 2383719 */ /*GILLT_nxv8s8*//*Label 33861*/ GIMT_Encode4(2385130),
     /* 2383723 */ /*GILLT_nxv8s16*//*Label 33862*/ GIMT_Encode4(2385234),
     /* 2383727 */ /*GILLT_nxv8s32*//*Label 33863*/ GIMT_Encode4(2385338),
     /* 2383731 */ /*GILLT_nxv8s64*//*Label 33864*/ GIMT_Encode4(2385442), GIMT_Encode4(0),
     /* 2383739 */ /*GILLT_nxv16s8*//*Label 33865*/ GIMT_Encode4(2385546),
     /* 2383743 */ /*GILLT_nxv16s16*//*Label 33866*/ GIMT_Encode4(2385650),
     /* 2383747 */ /*GILLT_nxv16s32*//*Label 33867*/ GIMT_Encode4(2385754), GIMT_Encode4(0),
     /* 2383755 */ /*GILLT_nxv32s8*//*Label 33868*/ GIMT_Encode4(2385858),
     /* 2383759 */ /*GILLT_nxv32s16*//*Label 33869*/ GIMT_Encode4(2385962), GIMT_Encode4(0),
     /* 2383767 */ /*GILLT_nxv64s8*//*Label 33870*/ GIMT_Encode4(2386066),
     /* 2383771 */ // Label 33847: @2383771
     /* 2383771 */ GIM_Try, /*On fail goto*//*Label 33872*/ GIMT_Encode4(2383833),
     /* 2383776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2383779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383787 */   GIM_Try, /*On fail goto*//*Label 33873*/ GIMT_Encode4(2383802), // Rule ID 2532 //
     /* 2383792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0),
     /* 2383795 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2383795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2383800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383801 */     // GIR_Coverage, 2532,
     /* 2383801 */     GIR_Done,
     /* 2383802 */   // Label 33873: @2383802
     /* 2383802 */   GIM_Try, /*On fail goto*//*Label 33874*/ GIMT_Encode4(2383817), // Rule ID 2533 //
     /* 2383807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1),
     /* 2383810 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2383810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2383815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383816 */     // GIR_Coverage, 2533,
     /* 2383816 */     GIR_Done,
     /* 2383817 */   // Label 33874: @2383817
     /* 2383817 */   GIM_Try, /*On fail goto*//*Label 33875*/ GIMT_Encode4(2383832), // Rule ID 62564 //
     /* 2383822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2383825 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_REV:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2383825 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2383830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383831 */     // GIR_Coverage, 62564,
     /* 2383831 */     GIR_Done,
     /* 2383832 */   // Label 33875: @2383832
     /* 2383832 */   GIM_Reject,
     /* 2383833 */ // Label 33872: @2383833
     /* 2383833 */ GIM_Reject,
     /* 2383834 */ // Label 33848: @2383834
     /* 2383834 */ GIM_Try, /*On fail goto*//*Label 33876*/ GIMT_Encode4(2383881),
     /* 2383839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2383842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383850 */   GIM_Try, /*On fail goto*//*Label 33877*/ GIMT_Encode4(2383865), // Rule ID 2534 //
     /* 2383855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2383858 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (REV8_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2383858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV64),
     /* 2383863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383864 */     // GIR_Coverage, 2534,
     /* 2383864 */     GIR_Done,
     /* 2383865 */   // Label 33877: @2383865
     /* 2383865 */   GIM_Try, /*On fail goto*//*Label 33878*/ GIMT_Encode4(2383880), // Rule ID 62563 //
     /* 2383870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2383873 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_REV:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2383873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2383878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383879 */     // GIR_Coverage, 62563,
     /* 2383879 */     GIR_Done,
     /* 2383880 */   // Label 33878: @2383880
     /* 2383880 */   GIM_Reject,
     /* 2383881 */ // Label 33876: @2383881
     /* 2383881 */ GIM_Reject,
     /* 2383882 */ // Label 33849: @2383882
     /* 2383882 */ GIM_Try, /*On fail goto*//*Label 33879*/ GIMT_Encode4(2383985),
     /* 2383887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2383890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383898 */   GIM_Try, /*On fail goto*//*Label 33880*/ GIMT_Encode4(2383941), // Rule ID 59094 //
     /* 2383903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2383906 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2383909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2383923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383940 */     // GIR_Coverage, 59094,
     /* 2383940 */     GIR_EraseRootFromParent_Done,
     /* 2383941 */   // Label 33880: @2383941
     /* 2383941 */   GIM_Try, /*On fail goto*//*Label 33881*/ GIMT_Encode4(2383984), // Rule ID 59095 //
     /* 2383946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2383949 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2383952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2383966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383983 */     // GIR_Coverage, 59095,
     /* 2383983 */     GIR_EraseRootFromParent_Done,
     /* 2383984 */   // Label 33881: @2383984
     /* 2383984 */   GIM_Reject,
     /* 2383985 */ // Label 33879: @2383985
     /* 2383985 */ GIM_Reject,
     /* 2383986 */ // Label 33850: @2383986
     /* 2383986 */ GIM_Try, /*On fail goto*//*Label 33882*/ GIMT_Encode4(2384089),
     /* 2383991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2383994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2383998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384002 */   GIM_Try, /*On fail goto*//*Label 33883*/ GIMT_Encode4(2384045), // Rule ID 59100 //
     /* 2384007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384010 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2384013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2384027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384044 */     // GIR_Coverage, 59100,
     /* 2384044 */     GIR_EraseRootFromParent_Done,
     /* 2384045 */   // Label 33883: @2384045
     /* 2384045 */   GIM_Try, /*On fail goto*//*Label 33884*/ GIMT_Encode4(2384088), // Rule ID 59101 //
     /* 2384050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384053 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2384056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2384070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384087 */     // GIR_Coverage, 59101,
     /* 2384087 */     GIR_EraseRootFromParent_Done,
     /* 2384088 */   // Label 33884: @2384088
     /* 2384088 */   GIM_Reject,
     /* 2384089 */ // Label 33882: @2384089
     /* 2384089 */ GIM_Reject,
     /* 2384090 */ // Label 33851: @2384090
     /* 2384090 */ GIM_Try, /*On fail goto*//*Label 33885*/ GIMT_Encode4(2384193),
     /* 2384095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2384098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384106 */   GIM_Try, /*On fail goto*//*Label 33886*/ GIMT_Encode4(2384149), // Rule ID 59104 //
     /* 2384111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384114 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2384117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384148 */     // GIR_Coverage, 59104,
     /* 2384148 */     GIR_EraseRootFromParent_Done,
     /* 2384149 */   // Label 33886: @2384149
     /* 2384149 */   GIM_Try, /*On fail goto*//*Label 33887*/ GIMT_Encode4(2384192), // Rule ID 59105 //
     /* 2384154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384157 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2384160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384191 */     // GIR_Coverage, 59105,
     /* 2384191 */     GIR_EraseRootFromParent_Done,
     /* 2384192 */   // Label 33887: @2384192
     /* 2384192 */   GIM_Reject,
     /* 2384193 */ // Label 33885: @2384193
     /* 2384193 */ GIM_Reject,
     /* 2384194 */ // Label 33852: @2384194
     /* 2384194 */ GIM_Try, /*On fail goto*//*Label 33888*/ GIMT_Encode4(2384297),
     /* 2384199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2384202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384210 */   GIM_Try, /*On fail goto*//*Label 33889*/ GIMT_Encode4(2384253), // Rule ID 59112 //
     /* 2384215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2384218 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2384221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2384235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384252 */     // GIR_Coverage, 59112,
     /* 2384252 */     GIR_EraseRootFromParent_Done,
     /* 2384253 */   // Label 33889: @2384253
     /* 2384253 */   GIM_Try, /*On fail goto*//*Label 33890*/ GIMT_Encode4(2384296), // Rule ID 59113 //
     /* 2384258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2384261 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2384264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2384278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384295 */     // GIR_Coverage, 59113,
     /* 2384295 */     GIR_EraseRootFromParent_Done,
     /* 2384296 */   // Label 33890: @2384296
     /* 2384296 */   GIM_Reject,
     /* 2384297 */ // Label 33888: @2384297
     /* 2384297 */ GIM_Reject,
     /* 2384298 */ // Label 33853: @2384298
     /* 2384298 */ GIM_Try, /*On fail goto*//*Label 33891*/ GIMT_Encode4(2384401),
     /* 2384303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2384306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384314 */   GIM_Try, /*On fail goto*//*Label 33892*/ GIMT_Encode4(2384357), // Rule ID 59096 //
     /* 2384319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384322 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2384325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2384339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384356 */     // GIR_Coverage, 59096,
     /* 2384356 */     GIR_EraseRootFromParent_Done,
     /* 2384357 */   // Label 33892: @2384357
     /* 2384357 */   GIM_Try, /*On fail goto*//*Label 33893*/ GIMT_Encode4(2384400), // Rule ID 59097 //
     /* 2384362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384365 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2384368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2384382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384399 */     // GIR_Coverage, 59097,
     /* 2384399 */     GIR_EraseRootFromParent_Done,
     /* 2384400 */   // Label 33893: @2384400
     /* 2384400 */   GIM_Reject,
     /* 2384401 */ // Label 33891: @2384401
     /* 2384401 */ GIM_Reject,
     /* 2384402 */ // Label 33854: @2384402
     /* 2384402 */ GIM_Try, /*On fail goto*//*Label 33894*/ GIMT_Encode4(2384505),
     /* 2384407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2384410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384418 */   GIM_Try, /*On fail goto*//*Label 33895*/ GIMT_Encode4(2384461), // Rule ID 59102 //
     /* 2384423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384426 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2384429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384460 */     // GIR_Coverage, 59102,
     /* 2384460 */     GIR_EraseRootFromParent_Done,
     /* 2384461 */   // Label 33895: @2384461
     /* 2384461 */   GIM_Try, /*On fail goto*//*Label 33896*/ GIMT_Encode4(2384504), // Rule ID 59103 //
     /* 2384466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384469 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2384472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384503 */     // GIR_Coverage, 59103,
     /* 2384503 */     GIR_EraseRootFromParent_Done,
     /* 2384504 */   // Label 33896: @2384504
     /* 2384504 */   GIM_Reject,
     /* 2384505 */ // Label 33894: @2384505
     /* 2384505 */ GIM_Reject,
     /* 2384506 */ // Label 33855: @2384506
     /* 2384506 */ GIM_Try, /*On fail goto*//*Label 33897*/ GIMT_Encode4(2384609),
     /* 2384511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2384514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384522 */   GIM_Try, /*On fail goto*//*Label 33898*/ GIMT_Encode4(2384565), // Rule ID 59110 //
     /* 2384527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384530 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2384533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2384547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384564 */     // GIR_Coverage, 59110,
     /* 2384564 */     GIR_EraseRootFromParent_Done,
     /* 2384565 */   // Label 33898: @2384565
     /* 2384565 */   GIM_Try, /*On fail goto*//*Label 33899*/ GIMT_Encode4(2384608), // Rule ID 59111 //
     /* 2384570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384573 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2384576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2384590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384607 */     // GIR_Coverage, 59111,
     /* 2384607 */     GIR_EraseRootFromParent_Done,
     /* 2384608 */   // Label 33899: @2384608
     /* 2384608 */   GIM_Reject,
     /* 2384609 */ // Label 33897: @2384609
     /* 2384609 */ GIM_Reject,
     /* 2384610 */ // Label 33856: @2384610
     /* 2384610 */ GIM_Try, /*On fail goto*//*Label 33900*/ GIMT_Encode4(2384713),
     /* 2384615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2384618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384626 */   GIM_Try, /*On fail goto*//*Label 33901*/ GIMT_Encode4(2384669), // Rule ID 59132 //
     /* 2384631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2384634 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2384637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2384651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384668 */     // GIR_Coverage, 59132,
     /* 2384668 */     GIR_EraseRootFromParent_Done,
     /* 2384669 */   // Label 33901: @2384669
     /* 2384669 */   GIM_Try, /*On fail goto*//*Label 33902*/ GIMT_Encode4(2384712), // Rule ID 59133 //
     /* 2384674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2384677 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2384680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2384694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384711 */     // GIR_Coverage, 59133,
     /* 2384711 */     GIR_EraseRootFromParent_Done,
     /* 2384712 */   // Label 33902: @2384712
     /* 2384712 */   GIM_Reject,
     /* 2384713 */ // Label 33900: @2384713
     /* 2384713 */ GIM_Reject,
     /* 2384714 */ // Label 33857: @2384714
     /* 2384714 */ GIM_Try, /*On fail goto*//*Label 33903*/ GIMT_Encode4(2384817),
     /* 2384719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2384722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384730 */   GIM_Try, /*On fail goto*//*Label 33904*/ GIMT_Encode4(2384773), // Rule ID 59098 //
     /* 2384735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384738 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2384741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384772 */     // GIR_Coverage, 59098,
     /* 2384772 */     GIR_EraseRootFromParent_Done,
     /* 2384773 */   // Label 33904: @2384773
     /* 2384773 */   GIM_Try, /*On fail goto*//*Label 33905*/ GIMT_Encode4(2384816), // Rule ID 59099 //
     /* 2384778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384781 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2384784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2384798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384815 */     // GIR_Coverage, 59099,
     /* 2384815 */     GIR_EraseRootFromParent_Done,
     /* 2384816 */   // Label 33905: @2384816
     /* 2384816 */   GIM_Reject,
     /* 2384817 */ // Label 33903: @2384817
     /* 2384817 */ GIM_Reject,
     /* 2384818 */ // Label 33858: @2384818
     /* 2384818 */ GIM_Try, /*On fail goto*//*Label 33906*/ GIMT_Encode4(2384921),
     /* 2384823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2384826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384834 */   GIM_Try, /*On fail goto*//*Label 33907*/ GIMT_Encode4(2384877), // Rule ID 59108 //
     /* 2384839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384842 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2384845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2384859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384876 */     // GIR_Coverage, 59108,
     /* 2384876 */     GIR_EraseRootFromParent_Done,
     /* 2384877 */   // Label 33907: @2384877
     /* 2384877 */   GIM_Try, /*On fail goto*//*Label 33908*/ GIMT_Encode4(2384920), // Rule ID 59109 //
     /* 2384882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384885 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2384888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2384902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384919 */     // GIR_Coverage, 59109,
     /* 2384919 */     GIR_EraseRootFromParent_Done,
     /* 2384920 */   // Label 33908: @2384920
     /* 2384920 */   GIM_Reject,
     /* 2384921 */ // Label 33906: @2384921
     /* 2384921 */ GIM_Reject,
     /* 2384922 */ // Label 33859: @2384922
     /* 2384922 */ GIM_Try, /*On fail goto*//*Label 33909*/ GIMT_Encode4(2385025),
     /* 2384927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2384930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384938 */   GIM_Try, /*On fail goto*//*Label 33910*/ GIMT_Encode4(2384981), // Rule ID 59126 //
     /* 2384943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2384946 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2384949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2384963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384980 */     // GIR_Coverage, 59126,
     /* 2384980 */     GIR_EraseRootFromParent_Done,
     /* 2384981 */   // Label 33910: @2384981
     /* 2384981 */   GIM_Try, /*On fail goto*//*Label 33911*/ GIMT_Encode4(2385024), // Rule ID 59127 //
     /* 2384986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2384989 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2384992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385023 */     // GIR_Coverage, 59127,
     /* 2385023 */     GIR_EraseRootFromParent_Done,
     /* 2385024 */   // Label 33911: @2385024
     /* 2385024 */   GIM_Reject,
     /* 2385025 */ // Label 33909: @2385025
     /* 2385025 */ GIM_Reject,
     /* 2385026 */ // Label 33860: @2385026
     /* 2385026 */ GIM_Try, /*On fail goto*//*Label 33912*/ GIMT_Encode4(2385129),
     /* 2385031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2385034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385042 */   GIM_Try, /*On fail goto*//*Label 33913*/ GIMT_Encode4(2385085), // Rule ID 59134 //
     /* 2385047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2385050 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2385053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385084 */     // GIR_Coverage, 59134,
     /* 2385084 */     GIR_EraseRootFromParent_Done,
     /* 2385085 */   // Label 33913: @2385085
     /* 2385085 */   GIM_Try, /*On fail goto*//*Label 33914*/ GIMT_Encode4(2385128), // Rule ID 59135 //
     /* 2385090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2385093 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2385096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385127 */     // GIR_Coverage, 59135,
     /* 2385127 */     GIR_EraseRootFromParent_Done,
     /* 2385128 */   // Label 33914: @2385128
     /* 2385128 */   GIM_Reject,
     /* 2385129 */ // Label 33912: @2385129
     /* 2385129 */ GIM_Reject,
     /* 2385130 */ // Label 33861: @2385130
     /* 2385130 */ GIM_Try, /*On fail goto*//*Label 33915*/ GIMT_Encode4(2385233),
     /* 2385135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2385138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385142 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2385146 */   GIM_Try, /*On fail goto*//*Label 33916*/ GIMT_Encode4(2385189), // Rule ID 59106 //
     /* 2385151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385154 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2385157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2385171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385188 */     // GIR_Coverage, 59106,
     /* 2385188 */     GIR_EraseRootFromParent_Done,
     /* 2385189 */   // Label 33916: @2385189
     /* 2385189 */   GIM_Try, /*On fail goto*//*Label 33917*/ GIMT_Encode4(2385232), // Rule ID 59107 //
     /* 2385194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385197 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2385200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2385214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385231 */     // GIR_Coverage, 59107,
     /* 2385231 */     GIR_EraseRootFromParent_Done,
     /* 2385232 */   // Label 33917: @2385232
     /* 2385232 */   GIM_Reject,
     /* 2385233 */ // Label 33915: @2385233
     /* 2385233 */ GIM_Reject,
     /* 2385234 */ // Label 33862: @2385234
     /* 2385234 */ GIM_Try, /*On fail goto*//*Label 33918*/ GIMT_Encode4(2385337),
     /* 2385239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2385242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385250 */   GIM_Try, /*On fail goto*//*Label 33919*/ GIMT_Encode4(2385293), // Rule ID 59120 //
     /* 2385255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385258 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2385261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385292 */     // GIR_Coverage, 59120,
     /* 2385292 */     GIR_EraseRootFromParent_Done,
     /* 2385293 */   // Label 33919: @2385293
     /* 2385293 */   GIM_Try, /*On fail goto*//*Label 33920*/ GIMT_Encode4(2385336), // Rule ID 59121 //
     /* 2385298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385301 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2385304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385335 */     // GIR_Coverage, 59121,
     /* 2385335 */     GIR_EraseRootFromParent_Done,
     /* 2385336 */   // Label 33920: @2385336
     /* 2385336 */   GIM_Reject,
     /* 2385337 */ // Label 33918: @2385337
     /* 2385337 */ GIM_Reject,
     /* 2385338 */ // Label 33863: @2385338
     /* 2385338 */ GIM_Try, /*On fail goto*//*Label 33921*/ GIMT_Encode4(2385441),
     /* 2385343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2385346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385354 */   GIM_Try, /*On fail goto*//*Label 33922*/ GIMT_Encode4(2385397), // Rule ID 59128 //
     /* 2385359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385362 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2385365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385396 */     // GIR_Coverage, 59128,
     /* 2385396 */     GIR_EraseRootFromParent_Done,
     /* 2385397 */   // Label 33922: @2385397
     /* 2385397 */   GIM_Try, /*On fail goto*//*Label 33923*/ GIMT_Encode4(2385440), // Rule ID 59129 //
     /* 2385402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385405 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2385408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385439 */     // GIR_Coverage, 59129,
     /* 2385439 */     GIR_EraseRootFromParent_Done,
     /* 2385440 */   // Label 33923: @2385440
     /* 2385440 */   GIM_Reject,
     /* 2385441 */ // Label 33921: @2385441
     /* 2385441 */ GIM_Reject,
     /* 2385442 */ // Label 33864: @2385442
     /* 2385442 */ GIM_Try, /*On fail goto*//*Label 33924*/ GIMT_Encode4(2385545),
     /* 2385447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2385450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385458 */   GIM_Try, /*On fail goto*//*Label 33925*/ GIMT_Encode4(2385501), // Rule ID 59136 //
     /* 2385463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2385466 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2385469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2385483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385500 */     // GIR_Coverage, 59136,
     /* 2385500 */     GIR_EraseRootFromParent_Done,
     /* 2385501 */   // Label 33925: @2385501
     /* 2385501 */   GIM_Try, /*On fail goto*//*Label 33926*/ GIMT_Encode4(2385544), // Rule ID 59137 //
     /* 2385506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2385509 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2385512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2385526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385543 */     // GIR_Coverage, 59137,
     /* 2385543 */     GIR_EraseRootFromParent_Done,
     /* 2385544 */   // Label 33926: @2385544
     /* 2385544 */   GIM_Reject,
     /* 2385545 */ // Label 33924: @2385545
     /* 2385545 */ GIM_Reject,
     /* 2385546 */ // Label 33865: @2385546
     /* 2385546 */ GIM_Try, /*On fail goto*//*Label 33927*/ GIMT_Encode4(2385649),
     /* 2385551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2385554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385562 */   GIM_Try, /*On fail goto*//*Label 33928*/ GIMT_Encode4(2385605), // Rule ID 59114 //
     /* 2385567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385570 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2385573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385604 */     // GIR_Coverage, 59114,
     /* 2385604 */     GIR_EraseRootFromParent_Done,
     /* 2385605 */   // Label 33928: @2385605
     /* 2385605 */   GIM_Try, /*On fail goto*//*Label 33929*/ GIMT_Encode4(2385648), // Rule ID 59115 //
     /* 2385610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385613 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2385616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2385630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385647 */     // GIR_Coverage, 59115,
     /* 2385647 */     GIR_EraseRootFromParent_Done,
     /* 2385648 */   // Label 33929: @2385648
     /* 2385648 */   GIM_Reject,
     /* 2385649 */ // Label 33927: @2385649
     /* 2385649 */ GIM_Reject,
     /* 2385650 */ // Label 33866: @2385650
     /* 2385650 */ GIM_Try, /*On fail goto*//*Label 33930*/ GIMT_Encode4(2385753),
     /* 2385655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2385658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385666 */   GIM_Try, /*On fail goto*//*Label 33931*/ GIMT_Encode4(2385709), // Rule ID 59122 //
     /* 2385671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385674 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2385677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385708 */     // GIR_Coverage, 59122,
     /* 2385708 */     GIR_EraseRootFromParent_Done,
     /* 2385709 */   // Label 33931: @2385709
     /* 2385709 */   GIM_Try, /*On fail goto*//*Label 33932*/ GIMT_Encode4(2385752), // Rule ID 59123 //
     /* 2385714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385717 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2385720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385751 */     // GIR_Coverage, 59123,
     /* 2385751 */     GIR_EraseRootFromParent_Done,
     /* 2385752 */   // Label 33932: @2385752
     /* 2385752 */   GIM_Reject,
     /* 2385753 */ // Label 33930: @2385753
     /* 2385753 */ GIM_Reject,
     /* 2385754 */ // Label 33867: @2385754
     /* 2385754 */ GIM_Try, /*On fail goto*//*Label 33933*/ GIMT_Encode4(2385857),
     /* 2385759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2385762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385770 */   GIM_Try, /*On fail goto*//*Label 33934*/ GIMT_Encode4(2385813), // Rule ID 59130 //
     /* 2385775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385778 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2385781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2385795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385812 */     // GIR_Coverage, 59130,
     /* 2385812 */     GIR_EraseRootFromParent_Done,
     /* 2385813 */   // Label 33934: @2385813
     /* 2385813 */   GIM_Try, /*On fail goto*//*Label 33935*/ GIMT_Encode4(2385856), // Rule ID 59131 //
     /* 2385818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385821 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2385824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2385838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385855 */     // GIR_Coverage, 59131,
     /* 2385855 */     GIR_EraseRootFromParent_Done,
     /* 2385856 */   // Label 33935: @2385856
     /* 2385856 */   GIM_Reject,
     /* 2385857 */ // Label 33933: @2385857
     /* 2385857 */ GIM_Reject,
     /* 2385858 */ // Label 33868: @2385858
     /* 2385858 */ GIM_Try, /*On fail goto*//*Label 33936*/ GIMT_Encode4(2385961),
     /* 2385863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2385866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385874 */   GIM_Try, /*On fail goto*//*Label 33937*/ GIMT_Encode4(2385917), // Rule ID 59116 //
     /* 2385879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385882 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2385885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385916 */     // GIR_Coverage, 59116,
     /* 2385916 */     GIR_EraseRootFromParent_Done,
     /* 2385917 */   // Label 33937: @2385917
     /* 2385917 */   GIM_Try, /*On fail goto*//*Label 33938*/ GIMT_Encode4(2385960), // Rule ID 59117 //
     /* 2385922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2385925 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2385928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2385942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385959 */     // GIR_Coverage, 59117,
     /* 2385959 */     GIR_EraseRootFromParent_Done,
     /* 2385960 */   // Label 33938: @2385960
     /* 2385960 */   GIM_Reject,
     /* 2385961 */ // Label 33936: @2385961
     /* 2385961 */ GIM_Reject,
     /* 2385962 */ // Label 33869: @2385962
     /* 2385962 */ GIM_Try, /*On fail goto*//*Label 33939*/ GIMT_Encode4(2386065),
     /* 2385967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2385970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385978 */   GIM_Try, /*On fail goto*//*Label 33940*/ GIMT_Encode4(2386021), // Rule ID 59124 //
     /* 2385983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2385986 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2385989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386020 */     // GIR_Coverage, 59124,
     /* 2386020 */     GIR_EraseRootFromParent_Done,
     /* 2386021 */   // Label 33940: @2386021
     /* 2386021 */   GIM_Try, /*On fail goto*//*Label 33941*/ GIMT_Encode4(2386064), // Rule ID 59125 //
     /* 2386026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386029 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2386032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386063 */     // GIR_Coverage, 59125,
     /* 2386063 */     GIR_EraseRootFromParent_Done,
     /* 2386064 */   // Label 33941: @2386064
     /* 2386064 */   GIM_Reject,
     /* 2386065 */ // Label 33939: @2386065
     /* 2386065 */ GIM_Reject,
     /* 2386066 */ // Label 33870: @2386066
     /* 2386066 */ GIM_Try, /*On fail goto*//*Label 33942*/ GIMT_Encode4(2386169),
     /* 2386071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2386074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2386082 */   GIM_Try, /*On fail goto*//*Label 33943*/ GIMT_Encode4(2386125), // Rule ID 59118 //
     /* 2386087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2386090 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2386093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386124 */     // GIR_Coverage, 59118,
     /* 2386124 */     GIR_EraseRootFromParent_Done,
     /* 2386125 */   // Label 33943: @2386125
     /* 2386125 */   GIM_Try, /*On fail goto*//*Label 33944*/ GIMT_Encode4(2386168), // Rule ID 59119 //
     /* 2386130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2386133 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2386136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2386150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386167 */     // GIR_Coverage, 59119,
     /* 2386167 */     GIR_EraseRootFromParent_Done,
     /* 2386168 */   // Label 33944: @2386168
     /* 2386168 */   GIM_Reject,
     /* 2386169 */ // Label 33942: @2386169
     /* 2386169 */ GIM_Reject,
     /* 2386170 */ // Label 33871: @2386170
     /* 2386170 */ GIM_Reject,
     /* 2386171 */ // Label 92: @2386171
     /* 2386171 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33969*/ GIMT_Encode4(2388716),
     /* 2386182 */ /*GILLT_s32*//*Label 33945*/ GIMT_Encode4(2386306),
     /* 2386186 */ /*GILLT_s64*//*Label 33946*/ GIMT_Encode4(2386393), GIMT_Encode4(0),
     /* 2386194 */ /*GILLT_nxv1s8*//*Label 33947*/ GIMT_Encode4(2386428),
     /* 2386198 */ /*GILLT_nxv1s16*//*Label 33948*/ GIMT_Encode4(2386532),
     /* 2386202 */ /*GILLT_nxv1s32*//*Label 33949*/ GIMT_Encode4(2386636),
     /* 2386206 */ /*GILLT_nxv1s64*//*Label 33950*/ GIMT_Encode4(2386740), GIMT_Encode4(0),
     /* 2386214 */ /*GILLT_nxv2s8*//*Label 33951*/ GIMT_Encode4(2386844),
     /* 2386218 */ /*GILLT_nxv2s16*//*Label 33952*/ GIMT_Encode4(2386948),
     /* 2386222 */ /*GILLT_nxv2s32*//*Label 33953*/ GIMT_Encode4(2387052),
     /* 2386226 */ /*GILLT_nxv2s64*//*Label 33954*/ GIMT_Encode4(2387156), GIMT_Encode4(0),
     /* 2386234 */ /*GILLT_nxv4s8*//*Label 33955*/ GIMT_Encode4(2387260),
     /* 2386238 */ /*GILLT_nxv4s16*//*Label 33956*/ GIMT_Encode4(2387364),
     /* 2386242 */ /*GILLT_nxv4s32*//*Label 33957*/ GIMT_Encode4(2387468),
     /* 2386246 */ /*GILLT_nxv4s64*//*Label 33958*/ GIMT_Encode4(2387572), GIMT_Encode4(0),
     /* 2386254 */ /*GILLT_nxv8s8*//*Label 33959*/ GIMT_Encode4(2387676),
     /* 2386258 */ /*GILLT_nxv8s16*//*Label 33960*/ GIMT_Encode4(2387780),
     /* 2386262 */ /*GILLT_nxv8s32*//*Label 33961*/ GIMT_Encode4(2387884),
     /* 2386266 */ /*GILLT_nxv8s64*//*Label 33962*/ GIMT_Encode4(2387988), GIMT_Encode4(0),
     /* 2386274 */ /*GILLT_nxv16s8*//*Label 33963*/ GIMT_Encode4(2388092),
     /* 2386278 */ /*GILLT_nxv16s16*//*Label 33964*/ GIMT_Encode4(2388196),
     /* 2386282 */ /*GILLT_nxv16s32*//*Label 33965*/ GIMT_Encode4(2388300), GIMT_Encode4(0),
     /* 2386290 */ /*GILLT_nxv32s8*//*Label 33966*/ GIMT_Encode4(2388404),
     /* 2386294 */ /*GILLT_nxv32s16*//*Label 33967*/ GIMT_Encode4(2388508), GIMT_Encode4(0),
     /* 2386302 */ /*GILLT_nxv64s8*//*Label 33968*/ GIMT_Encode4(2388612),
     /* 2386306 */ // Label 33945: @2386306
     /* 2386306 */ GIM_Try, /*On fail goto*//*Label 33970*/ GIMT_Encode4(2386392),
     /* 2386311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2386314 */   GIM_Try, /*On fail goto*//*Label 33971*/ GIMT_Encode4(2386345), // Rule ID 64447 //
     /* 2386319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2386322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386330 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$rs)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2386330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2386333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2386337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2386340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2386343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386344 */     // GIR_Coverage, 64447,
     /* 2386344 */     GIR_EraseRootFromParent_Done,
     /* 2386345 */   // Label 33971: @2386345
     /* 2386345 */   GIM_Try, /*On fail goto*//*Label 33972*/ GIMT_Encode4(2386368), // Rule ID 64634 //
     /* 2386350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode0),
     /* 2386353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2386357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2386361 */     // (bitreverse:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)  =>  (QC_BREV32:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)
     /* 2386361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_BREV32),
     /* 2386366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386367 */     // GIR_Coverage, 64634,
     /* 2386367 */     GIR_Done,
     /* 2386368 */   // Label 33972: @2386368
     /* 2386368 */   GIM_Try, /*On fail goto*//*Label 33973*/ GIMT_Encode4(2386391), // Rule ID 64635 //
     /* 2386373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcibm_IsRV32_HwMode1),
     /* 2386376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2386380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2386384 */     // (bitreverse:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)  =>  (QC_BREV32:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1)
     /* 2386384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_BREV32),
     /* 2386389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386390 */     // GIR_Coverage, 64635,
     /* 2386390 */     GIR_Done,
     /* 2386391 */   // Label 33973: @2386391
     /* 2386391 */   GIM_Reject,
     /* 2386392 */ // Label 33970: @2386392
     /* 2386392 */ GIM_Reject,
     /* 2386393 */ // Label 33946: @2386393
     /* 2386393 */ GIM_Try, /*On fail goto*//*Label 33974*/ GIMT_Encode4(2386427), // Rule ID 64446 //
     /* 2386398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2386401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2386404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2386412 */   // (bitreverse:{ *:[i64] } GPR:{ *:[i64] }:$rs)  =>  (CV_BITREV:{ *:[i64] } GPR:{ *:[i64] }:$rs, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2386412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2386415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386417 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2386419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2386422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2386425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2386426 */   // GIR_Coverage, 64446,
     /* 2386426 */   GIR_EraseRootFromParent_Done,
     /* 2386427 */ // Label 33974: @2386427
     /* 2386427 */ GIM_Reject,
     /* 2386428 */ // Label 33947: @2386428
     /* 2386428 */ GIM_Try, /*On fail goto*//*Label 33975*/ GIMT_Encode4(2386531),
     /* 2386433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2386436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386444 */   GIM_Try, /*On fail goto*//*Label 33976*/ GIMT_Encode4(2386487), // Rule ID 58918 //
     /* 2386449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386452 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2386455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2386469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386486 */     // GIR_Coverage, 58918,
     /* 2386486 */     GIR_EraseRootFromParent_Done,
     /* 2386487 */   // Label 33976: @2386487
     /* 2386487 */   GIM_Try, /*On fail goto*//*Label 33977*/ GIMT_Encode4(2386530), // Rule ID 58919 //
     /* 2386492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386495 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2386498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2386512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386529 */     // GIR_Coverage, 58919,
     /* 2386529 */     GIR_EraseRootFromParent_Done,
     /* 2386530 */   // Label 33977: @2386530
     /* 2386530 */   GIM_Reject,
     /* 2386531 */ // Label 33975: @2386531
     /* 2386531 */ GIM_Reject,
     /* 2386532 */ // Label 33948: @2386532
     /* 2386532 */ GIM_Try, /*On fail goto*//*Label 33978*/ GIMT_Encode4(2386635),
     /* 2386537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2386540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386548 */   GIM_Try, /*On fail goto*//*Label 33979*/ GIMT_Encode4(2386591), // Rule ID 59056 //
     /* 2386553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386556 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2386559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2386573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386590 */     // GIR_Coverage, 59056,
     /* 2386590 */     GIR_EraseRootFromParent_Done,
     /* 2386591 */   // Label 33979: @2386591
     /* 2386591 */   GIM_Try, /*On fail goto*//*Label 33980*/ GIMT_Encode4(2386634), // Rule ID 59057 //
     /* 2386596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386599 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2386602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2386616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2386629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386633 */     // GIR_Coverage, 59057,
     /* 2386633 */     GIR_EraseRootFromParent_Done,
     /* 2386634 */   // Label 33980: @2386634
     /* 2386634 */   GIM_Reject,
     /* 2386635 */ // Label 33978: @2386635
     /* 2386635 */ GIM_Reject,
     /* 2386636 */ // Label 33949: @2386636
     /* 2386636 */ GIM_Try, /*On fail goto*//*Label 33981*/ GIMT_Encode4(2386739),
     /* 2386641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2386644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386652 */   GIM_Try, /*On fail goto*//*Label 33982*/ GIMT_Encode4(2386695), // Rule ID 59060 //
     /* 2386657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386660 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2386663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2386677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386694 */     // GIR_Coverage, 59060,
     /* 2386694 */     GIR_EraseRootFromParent_Done,
     /* 2386695 */   // Label 33982: @2386695
     /* 2386695 */   GIM_Try, /*On fail goto*//*Label 33983*/ GIMT_Encode4(2386738), // Rule ID 59061 //
     /* 2386700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386703 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2386706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2386720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2386733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386737 */     // GIR_Coverage, 59061,
     /* 2386737 */     GIR_EraseRootFromParent_Done,
     /* 2386738 */   // Label 33983: @2386738
     /* 2386738 */   GIM_Reject,
     /* 2386739 */ // Label 33981: @2386739
     /* 2386739 */ GIM_Reject,
     /* 2386740 */ // Label 33950: @2386740
     /* 2386740 */ GIM_Try, /*On fail goto*//*Label 33984*/ GIMT_Encode4(2386843),
     /* 2386745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2386748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386756 */   GIM_Try, /*On fail goto*//*Label 33985*/ GIMT_Encode4(2386799), // Rule ID 59068 //
     /* 2386761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2386764 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2386767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2386781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386798 */     // GIR_Coverage, 59068,
     /* 2386798 */     GIR_EraseRootFromParent_Done,
     /* 2386799 */   // Label 33985: @2386799
     /* 2386799 */   GIM_Try, /*On fail goto*//*Label 33986*/ GIMT_Encode4(2386842), // Rule ID 59069 //
     /* 2386804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2386807 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2386810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2386824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2386837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386841 */     // GIR_Coverage, 59069,
     /* 2386841 */     GIR_EraseRootFromParent_Done,
     /* 2386842 */   // Label 33986: @2386842
     /* 2386842 */   GIM_Reject,
     /* 2386843 */ // Label 33984: @2386843
     /* 2386843 */ GIM_Reject,
     /* 2386844 */ // Label 33951: @2386844
     /* 2386844 */ GIM_Try, /*On fail goto*//*Label 33987*/ GIMT_Encode4(2386947),
     /* 2386849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2386852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386860 */   GIM_Try, /*On fail goto*//*Label 33988*/ GIMT_Encode4(2386903), // Rule ID 59052 //
     /* 2386865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386868 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2386871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2386885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386902 */     // GIR_Coverage, 59052,
     /* 2386902 */     GIR_EraseRootFromParent_Done,
     /* 2386903 */   // Label 33988: @2386903
     /* 2386903 */   GIM_Try, /*On fail goto*//*Label 33989*/ GIMT_Encode4(2386946), // Rule ID 59053 //
     /* 2386908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2386911 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2386911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2386914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2386928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2386944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386945 */     // GIR_Coverage, 59053,
     /* 2386945 */     GIR_EraseRootFromParent_Done,
     /* 2386946 */   // Label 33989: @2386946
     /* 2386946 */   GIM_Reject,
     /* 2386947 */ // Label 33987: @2386947
     /* 2386947 */ GIM_Reject,
     /* 2386948 */ // Label 33952: @2386948
     /* 2386948 */ GIM_Try, /*On fail goto*//*Label 33990*/ GIMT_Encode4(2387051),
     /* 2386953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2386956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2386964 */   GIM_Try, /*On fail goto*//*Label 33991*/ GIMT_Encode4(2387007), // Rule ID 59058 //
     /* 2386969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2386972 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2386972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2386975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2386979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2386984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2386986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2386989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2386994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2386996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2386999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387006 */     // GIR_Coverage, 59058,
     /* 2387006 */     GIR_EraseRootFromParent_Done,
     /* 2387007 */   // Label 33991: @2387007
     /* 2387007 */   GIM_Try, /*On fail goto*//*Label 33992*/ GIMT_Encode4(2387050), // Rule ID 59059 //
     /* 2387012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387015 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2387018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2387032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387049 */     // GIR_Coverage, 59059,
     /* 2387049 */     GIR_EraseRootFromParent_Done,
     /* 2387050 */   // Label 33992: @2387050
     /* 2387050 */   GIM_Reject,
     /* 2387051 */ // Label 33990: @2387051
     /* 2387051 */ GIM_Reject,
     /* 2387052 */ // Label 33953: @2387052
     /* 2387052 */ GIM_Try, /*On fail goto*//*Label 33993*/ GIMT_Encode4(2387155),
     /* 2387057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2387060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387068 */   GIM_Try, /*On fail goto*//*Label 33994*/ GIMT_Encode4(2387111), // Rule ID 59066 //
     /* 2387073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387076 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2387079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387110 */     // GIR_Coverage, 59066,
     /* 2387110 */     GIR_EraseRootFromParent_Done,
     /* 2387111 */   // Label 33994: @2387111
     /* 2387111 */   GIM_Try, /*On fail goto*//*Label 33995*/ GIMT_Encode4(2387154), // Rule ID 59067 //
     /* 2387116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387119 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2387122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387153 */     // GIR_Coverage, 59067,
     /* 2387153 */     GIR_EraseRootFromParent_Done,
     /* 2387154 */   // Label 33995: @2387154
     /* 2387154 */   GIM_Reject,
     /* 2387155 */ // Label 33993: @2387155
     /* 2387155 */ GIM_Reject,
     /* 2387156 */ // Label 33954: @2387156
     /* 2387156 */ GIM_Try, /*On fail goto*//*Label 33996*/ GIMT_Encode4(2387259),
     /* 2387161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2387164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387172 */   GIM_Try, /*On fail goto*//*Label 33997*/ GIMT_Encode4(2387215), // Rule ID 59088 //
     /* 2387177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2387180 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2387183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387214 */     // GIR_Coverage, 59088,
     /* 2387214 */     GIR_EraseRootFromParent_Done,
     /* 2387215 */   // Label 33997: @2387215
     /* 2387215 */   GIM_Try, /*On fail goto*//*Label 33998*/ GIMT_Encode4(2387258), // Rule ID 59089 //
     /* 2387220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2387223 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2387226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387257 */     // GIR_Coverage, 59089,
     /* 2387257 */     GIR_EraseRootFromParent_Done,
     /* 2387258 */   // Label 33998: @2387258
     /* 2387258 */   GIM_Reject,
     /* 2387259 */ // Label 33996: @2387259
     /* 2387259 */ GIM_Reject,
     /* 2387260 */ // Label 33955: @2387260
     /* 2387260 */ GIM_Try, /*On fail goto*//*Label 33999*/ GIMT_Encode4(2387363),
     /* 2387265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2387268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387276 */   GIM_Try, /*On fail goto*//*Label 34000*/ GIMT_Encode4(2387319), // Rule ID 59054 //
     /* 2387281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387284 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2387287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2387301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387318 */     // GIR_Coverage, 59054,
     /* 2387318 */     GIR_EraseRootFromParent_Done,
     /* 2387319 */   // Label 34000: @2387319
     /* 2387319 */   GIM_Try, /*On fail goto*//*Label 34001*/ GIMT_Encode4(2387362), // Rule ID 59055 //
     /* 2387324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387327 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2387330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2387344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387361 */     // GIR_Coverage, 59055,
     /* 2387361 */     GIR_EraseRootFromParent_Done,
     /* 2387362 */   // Label 34001: @2387362
     /* 2387362 */   GIM_Reject,
     /* 2387363 */ // Label 33999: @2387363
     /* 2387363 */ GIM_Reject,
     /* 2387364 */ // Label 33956: @2387364
     /* 2387364 */ GIM_Try, /*On fail goto*//*Label 34002*/ GIMT_Encode4(2387467),
     /* 2387369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2387372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387380 */   GIM_Try, /*On fail goto*//*Label 34003*/ GIMT_Encode4(2387423), // Rule ID 59064 //
     /* 2387385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387388 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2387391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387422 */     // GIR_Coverage, 59064,
     /* 2387422 */     GIR_EraseRootFromParent_Done,
     /* 2387423 */   // Label 34003: @2387423
     /* 2387423 */   GIM_Try, /*On fail goto*//*Label 34004*/ GIMT_Encode4(2387466), // Rule ID 59065 //
     /* 2387428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387431 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2387434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387465 */     // GIR_Coverage, 59065,
     /* 2387465 */     GIR_EraseRootFromParent_Done,
     /* 2387466 */   // Label 34004: @2387466
     /* 2387466 */   GIM_Reject,
     /* 2387467 */ // Label 34002: @2387467
     /* 2387467 */ GIM_Reject,
     /* 2387468 */ // Label 33957: @2387468
     /* 2387468 */ GIM_Try, /*On fail goto*//*Label 34005*/ GIMT_Encode4(2387571),
     /* 2387473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2387476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387484 */   GIM_Try, /*On fail goto*//*Label 34006*/ GIMT_Encode4(2387527), // Rule ID 59082 //
     /* 2387489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387492 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2387495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387526 */     // GIR_Coverage, 59082,
     /* 2387526 */     GIR_EraseRootFromParent_Done,
     /* 2387527 */   // Label 34006: @2387527
     /* 2387527 */   GIM_Try, /*On fail goto*//*Label 34007*/ GIMT_Encode4(2387570), // Rule ID 59083 //
     /* 2387532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387535 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2387538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387569 */     // GIR_Coverage, 59083,
     /* 2387569 */     GIR_EraseRootFromParent_Done,
     /* 2387570 */   // Label 34007: @2387570
     /* 2387570 */   GIM_Reject,
     /* 2387571 */ // Label 34005: @2387571
     /* 2387571 */ GIM_Reject,
     /* 2387572 */ // Label 33958: @2387572
     /* 2387572 */ GIM_Try, /*On fail goto*//*Label 34008*/ GIMT_Encode4(2387675),
     /* 2387577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2387580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387588 */   GIM_Try, /*On fail goto*//*Label 34009*/ GIMT_Encode4(2387631), // Rule ID 59090 //
     /* 2387593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2387596 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2387599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2387613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387630 */     // GIR_Coverage, 59090,
     /* 2387630 */     GIR_EraseRootFromParent_Done,
     /* 2387631 */   // Label 34009: @2387631
     /* 2387631 */   GIM_Try, /*On fail goto*//*Label 34010*/ GIMT_Encode4(2387674), // Rule ID 59091 //
     /* 2387636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2387639 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2387642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2387656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2387669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387673 */     // GIR_Coverage, 59091,
     /* 2387673 */     GIR_EraseRootFromParent_Done,
     /* 2387674 */   // Label 34010: @2387674
     /* 2387674 */   GIM_Reject,
     /* 2387675 */ // Label 34008: @2387675
     /* 2387675 */ GIM_Reject,
     /* 2387676 */ // Label 33959: @2387676
     /* 2387676 */ GIM_Try, /*On fail goto*//*Label 34011*/ GIMT_Encode4(2387779),
     /* 2387681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2387684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2387692 */   GIM_Try, /*On fail goto*//*Label 34012*/ GIMT_Encode4(2387735), // Rule ID 59062 //
     /* 2387697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387700 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2387703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387734 */     // GIR_Coverage, 59062,
     /* 2387734 */     GIR_EraseRootFromParent_Done,
     /* 2387735 */   // Label 34012: @2387735
     /* 2387735 */   GIM_Try, /*On fail goto*//*Label 34013*/ GIMT_Encode4(2387778), // Rule ID 59063 //
     /* 2387740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387743 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2387746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2387760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387777 */     // GIR_Coverage, 59063,
     /* 2387777 */     GIR_EraseRootFromParent_Done,
     /* 2387778 */   // Label 34013: @2387778
     /* 2387778 */   GIM_Reject,
     /* 2387779 */ // Label 34011: @2387779
     /* 2387779 */ GIM_Reject,
     /* 2387780 */ // Label 33960: @2387780
     /* 2387780 */ GIM_Try, /*On fail goto*//*Label 34014*/ GIMT_Encode4(2387883),
     /* 2387785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2387788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2387796 */   GIM_Try, /*On fail goto*//*Label 34015*/ GIMT_Encode4(2387839), // Rule ID 59076 //
     /* 2387801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387804 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2387807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387838 */     // GIR_Coverage, 59076,
     /* 2387838 */     GIR_EraseRootFromParent_Done,
     /* 2387839 */   // Label 34015: @2387839
     /* 2387839 */   GIM_Try, /*On fail goto*//*Label 34016*/ GIMT_Encode4(2387882), // Rule ID 59077 //
     /* 2387844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387847 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2387850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2387864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2387877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387881 */     // GIR_Coverage, 59077,
     /* 2387881 */     GIR_EraseRootFromParent_Done,
     /* 2387882 */   // Label 34016: @2387882
     /* 2387882 */   GIM_Reject,
     /* 2387883 */ // Label 34014: @2387883
     /* 2387883 */ GIM_Reject,
     /* 2387884 */ // Label 33961: @2387884
     /* 2387884 */ GIM_Try, /*On fail goto*//*Label 34017*/ GIMT_Encode4(2387987),
     /* 2387889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2387892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2387900 */   GIM_Try, /*On fail goto*//*Label 34018*/ GIMT_Encode4(2387943), // Rule ID 59084 //
     /* 2387905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2387908 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2387908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2387911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2387925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387942 */     // GIR_Coverage, 59084,
     /* 2387942 */     GIR_EraseRootFromParent_Done,
     /* 2387943 */   // Label 34018: @2387943
     /* 2387943 */   GIM_Try, /*On fail goto*//*Label 34019*/ GIMT_Encode4(2387986), // Rule ID 59085 //
     /* 2387948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2387951 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2387951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2387954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2387958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2387963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2387965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2387968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2387973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2387978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2387981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2387984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387985 */     // GIR_Coverage, 59085,
     /* 2387985 */     GIR_EraseRootFromParent_Done,
     /* 2387986 */   // Label 34019: @2387986
     /* 2387986 */   GIM_Reject,
     /* 2387987 */ // Label 34017: @2387987
     /* 2387987 */ GIM_Reject,
     /* 2387988 */ // Label 33962: @2387988
     /* 2387988 */ GIM_Try, /*On fail goto*//*Label 34020*/ GIMT_Encode4(2388091),
     /* 2387993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2387996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388004 */   GIM_Try, /*On fail goto*//*Label 34021*/ GIMT_Encode4(2388047), // Rule ID 59092 //
     /* 2388009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2388012 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2388015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388046 */     // GIR_Coverage, 59092,
     /* 2388046 */     GIR_EraseRootFromParent_Done,
     /* 2388047 */   // Label 34021: @2388047
     /* 2388047 */   GIM_Try, /*On fail goto*//*Label 34022*/ GIMT_Encode4(2388090), // Rule ID 59093 //
     /* 2388052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2388055 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2388058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2388085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388089 */     // GIR_Coverage, 59093,
     /* 2388089 */     GIR_EraseRootFromParent_Done,
     /* 2388090 */   // Label 34022: @2388090
     /* 2388090 */   GIM_Reject,
     /* 2388091 */ // Label 34020: @2388091
     /* 2388091 */ GIM_Reject,
     /* 2388092 */ // Label 33963: @2388092
     /* 2388092 */ GIM_Try, /*On fail goto*//*Label 34023*/ GIMT_Encode4(2388195),
     /* 2388097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2388100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2388108 */   GIM_Try, /*On fail goto*//*Label 34024*/ GIMT_Encode4(2388151), // Rule ID 59070 //
     /* 2388113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388116 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2388119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2388133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388150 */     // GIR_Coverage, 59070,
     /* 2388150 */     GIR_EraseRootFromParent_Done,
     /* 2388151 */   // Label 34024: @2388151
     /* 2388151 */   GIM_Try, /*On fail goto*//*Label 34025*/ GIMT_Encode4(2388194), // Rule ID 59071 //
     /* 2388156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388159 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2388162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2388176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388193 */     // GIR_Coverage, 59071,
     /* 2388193 */     GIR_EraseRootFromParent_Done,
     /* 2388194 */   // Label 34025: @2388194
     /* 2388194 */   GIM_Reject,
     /* 2388195 */ // Label 34023: @2388195
     /* 2388195 */ GIM_Reject,
     /* 2388196 */ // Label 33964: @2388196
     /* 2388196 */ GIM_Try, /*On fail goto*//*Label 34026*/ GIMT_Encode4(2388299),
     /* 2388201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2388204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388212 */   GIM_Try, /*On fail goto*//*Label 34027*/ GIMT_Encode4(2388255), // Rule ID 59078 //
     /* 2388217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388220 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2388223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388254 */     // GIR_Coverage, 59078,
     /* 2388254 */     GIR_EraseRootFromParent_Done,
     /* 2388255 */   // Label 34027: @2388255
     /* 2388255 */   GIM_Try, /*On fail goto*//*Label 34028*/ GIMT_Encode4(2388298), // Rule ID 59079 //
     /* 2388260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388263 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2388266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388297 */     // GIR_Coverage, 59079,
     /* 2388297 */     GIR_EraseRootFromParent_Done,
     /* 2388298 */   // Label 34028: @2388298
     /* 2388298 */   GIM_Reject,
     /* 2388299 */ // Label 34026: @2388299
     /* 2388299 */ GIM_Reject,
     /* 2388300 */ // Label 33965: @2388300
     /* 2388300 */ GIM_Try, /*On fail goto*//*Label 34029*/ GIMT_Encode4(2388403),
     /* 2388305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2388308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388316 */   GIM_Try, /*On fail goto*//*Label 34030*/ GIMT_Encode4(2388359), // Rule ID 59086 //
     /* 2388321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388324 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2388327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388358 */     // GIR_Coverage, 59086,
     /* 2388358 */     GIR_EraseRootFromParent_Done,
     /* 2388359 */   // Label 34030: @2388359
     /* 2388359 */   GIM_Try, /*On fail goto*//*Label 34031*/ GIMT_Encode4(2388402), // Rule ID 59087 //
     /* 2388364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388367 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2388370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2388397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388401 */     // GIR_Coverage, 59087,
     /* 2388401 */     GIR_EraseRootFromParent_Done,
     /* 2388402 */   // Label 34031: @2388402
     /* 2388402 */   GIM_Reject,
     /* 2388403 */ // Label 34029: @2388403
     /* 2388403 */ GIM_Reject,
     /* 2388404 */ // Label 33966: @2388404
     /* 2388404 */ GIM_Try, /*On fail goto*//*Label 34032*/ GIMT_Encode4(2388507),
     /* 2388409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2388412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2388420 */   GIM_Try, /*On fail goto*//*Label 34033*/ GIMT_Encode4(2388463), // Rule ID 59072 //
     /* 2388425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388428 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2388431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388462 */     // GIR_Coverage, 59072,
     /* 2388462 */     GIR_EraseRootFromParent_Done,
     /* 2388463 */   // Label 34033: @2388463
     /* 2388463 */   GIM_Try, /*On fail goto*//*Label 34034*/ GIMT_Encode4(2388506), // Rule ID 59073 //
     /* 2388468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388471 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2388474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2388488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388505 */     // GIR_Coverage, 59073,
     /* 2388505 */     GIR_EraseRootFromParent_Done,
     /* 2388506 */   // Label 34034: @2388506
     /* 2388506 */   GIM_Reject,
     /* 2388507 */ // Label 34032: @2388507
     /* 2388507 */ GIM_Reject,
     /* 2388508 */ // Label 33967: @2388508
     /* 2388508 */ GIM_Try, /*On fail goto*//*Label 34035*/ GIMT_Encode4(2388611),
     /* 2388513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2388516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388524 */   GIM_Try, /*On fail goto*//*Label 34036*/ GIMT_Encode4(2388567), // Rule ID 59080 //
     /* 2388529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388532 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2388535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388566 */     // GIR_Coverage, 59080,
     /* 2388566 */     GIR_EraseRootFromParent_Done,
     /* 2388567 */   // Label 34036: @2388567
     /* 2388567 */   GIM_Try, /*On fail goto*//*Label 34037*/ GIMT_Encode4(2388610), // Rule ID 59081 //
     /* 2388572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388575 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2388578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2388605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388609 */     // GIR_Coverage, 59081,
     /* 2388609 */     GIR_EraseRootFromParent_Done,
     /* 2388610 */   // Label 34037: @2388610
     /* 2388610 */   GIM_Reject,
     /* 2388611 */ // Label 34035: @2388611
     /* 2388611 */ GIM_Reject,
     /* 2388612 */ // Label 33968: @2388612
     /* 2388612 */ GIM_Try, /*On fail goto*//*Label 34038*/ GIMT_Encode4(2388715),
     /* 2388617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2388620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2388628 */   GIM_Try, /*On fail goto*//*Label 34039*/ GIMT_Encode4(2388671), // Rule ID 59074 //
     /* 2388633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2388636 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2388636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2388639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388670 */     // GIR_Coverage, 59074,
     /* 2388670 */     GIR_EraseRootFromParent_Done,
     /* 2388671 */   // Label 34039: @2388671
     /* 2388671 */   GIM_Try, /*On fail goto*//*Label 34040*/ GIMT_Encode4(2388714), // Rule ID 59075 //
     /* 2388676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2388679 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2388679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2388682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2388686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2388691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2388693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2388696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2388701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2388706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388713 */     // GIR_Coverage, 59075,
     /* 2388713 */     GIR_EraseRootFromParent_Done,
     /* 2388714 */   // Label 34040: @2388714
     /* 2388714 */   GIM_Reject,
     /* 2388715 */ // Label 34038: @2388715
     /* 2388715 */ GIM_Reject,
     /* 2388716 */ // Label 33969: @2388716
     /* 2388716 */ GIM_Reject,
     /* 2388717 */ // Label 93: @2388717
     /* 2388717 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34044*/ GIMT_Encode4(2388914),
     /* 2388728 */ /*GILLT_s16*//*Label 34041*/ GIMT_Encode4(2388740),
     /* 2388732 */ /*GILLT_s32*//*Label 34042*/ GIMT_Encode4(2388798),
     /* 2388736 */ /*GILLT_s64*//*Label 34043*/ GIMT_Encode4(2388856),
     /* 2388740 */ // Label 34041: @2388740
     /* 2388740 */ GIM_Try, /*On fail goto*//*Label 34045*/ GIMT_Encode4(2388797),
     /* 2388745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2388748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2388752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2388756 */   GIM_Try, /*On fail goto*//*Label 34046*/ GIMT_Encode4(2388776), // Rule ID 2428 //
     /* 2388761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2388764 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i64] })
     /* 2388764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2388767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388775 */     // GIR_Coverage, 2428,
     /* 2388775 */     GIR_EraseRootFromParent_Done,
     /* 2388776 */   // Label 34046: @2388776
     /* 2388776 */   GIM_Try, /*On fail goto*//*Label 34047*/ GIMT_Encode4(2388796), // Rule ID 2429 //
     /* 2388781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2388784 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i32] })
     /* 2388784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2388787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388795 */     // GIR_Coverage, 2429,
     /* 2388795 */     GIR_EraseRootFromParent_Done,
     /* 2388796 */   // Label 34047: @2388796
     /* 2388796 */   GIM_Reject,
     /* 2388797 */ // Label 34045: @2388797
     /* 2388797 */ GIM_Reject,
     /* 2388798 */ // Label 34042: @2388798
     /* 2388798 */ GIM_Try, /*On fail goto*//*Label 34048*/ GIMT_Encode4(2388855),
     /* 2388803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388814 */   GIM_Try, /*On fail goto*//*Label 34049*/ GIMT_Encode4(2388834), // Rule ID 2346 //
     /* 2388819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2388822 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i64] })
     /* 2388822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2388825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388833 */     // GIR_Coverage, 2346,
     /* 2388833 */     GIR_EraseRootFromParent_Done,
     /* 2388834 */   // Label 34049: @2388834
     /* 2388834 */   GIM_Try, /*On fail goto*//*Label 34050*/ GIMT_Encode4(2388854), // Rule ID 2347 //
     /* 2388839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2388842 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i32] })
     /* 2388842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2388845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388853 */     // GIR_Coverage, 2347,
     /* 2388853 */     GIR_EraseRootFromParent_Done,
     /* 2388854 */   // Label 34050: @2388854
     /* 2388854 */   GIM_Reject,
     /* 2388855 */ // Label 34048: @2388855
     /* 2388855 */ GIM_Reject,
     /* 2388856 */ // Label 34043: @2388856
     /* 2388856 */ GIM_Try, /*On fail goto*//*Label 34051*/ GIMT_Encode4(2388913),
     /* 2388861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2388864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388872 */   GIM_Try, /*On fail goto*//*Label 34052*/ GIMT_Encode4(2388892), // Rule ID 2386 //
     /* 2388877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2388880 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i64] })
     /* 2388880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2388883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388891 */     // GIR_Coverage, 2386,
     /* 2388891 */     GIR_EraseRootFromParent_Done,
     /* 2388892 */   // Label 34052: @2388892
     /* 2388892 */   GIM_Try, /*On fail goto*//*Label 34053*/ GIMT_Encode4(2388912), // Rule ID 2387 //
     /* 2388897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2388900 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i32] })
     /* 2388900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2388903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2388910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388911 */     // GIR_Coverage, 2387,
     /* 2388911 */     GIR_EraseRootFromParent_Done,
     /* 2388912 */   // Label 34053: @2388912
     /* 2388912 */   GIM_Reject,
     /* 2388913 */ // Label 34051: @2388913
     /* 2388913 */ GIM_Reject,
     /* 2388914 */ // Label 34044: @2388914
     /* 2388914 */ GIM_Reject,
     /* 2388915 */ // Label 94: @2388915
     /* 2388915 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34072*/ GIMT_Encode4(2391090),
     /* 2388926 */ /*GILLT_s16*//*Label 34054*/ GIMT_Encode4(2389046),
     /* 2388930 */ /*GILLT_s32*//*Label 34055*/ GIMT_Encode4(2389168),
     /* 2388934 */ /*GILLT_s64*//*Label 34056*/ GIMT_Encode4(2389290), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2388946 */ /*GILLT_nxv1s16*//*Label 34057*/ GIMT_Encode4(2389440),
     /* 2388950 */ /*GILLT_nxv1s32*//*Label 34058*/ GIMT_Encode4(2389550),
     /* 2388954 */ /*GILLT_nxv1s64*//*Label 34059*/ GIMT_Encode4(2389660), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2388966 */ /*GILLT_nxv2s16*//*Label 34060*/ GIMT_Encode4(2389770),
     /* 2388970 */ /*GILLT_nxv2s32*//*Label 34061*/ GIMT_Encode4(2389880),
     /* 2388974 */ /*GILLT_nxv2s64*//*Label 34062*/ GIMT_Encode4(2389990), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2388986 */ /*GILLT_nxv4s16*//*Label 34063*/ GIMT_Encode4(2390100),
     /* 2388990 */ /*GILLT_nxv4s32*//*Label 34064*/ GIMT_Encode4(2390210),
     /* 2388994 */ /*GILLT_nxv4s64*//*Label 34065*/ GIMT_Encode4(2390320), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2389006 */ /*GILLT_nxv8s16*//*Label 34066*/ GIMT_Encode4(2390430),
     /* 2389010 */ /*GILLT_nxv8s32*//*Label 34067*/ GIMT_Encode4(2390540),
     /* 2389014 */ /*GILLT_nxv8s64*//*Label 34068*/ GIMT_Encode4(2390650), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2389026 */ /*GILLT_nxv16s16*//*Label 34069*/ GIMT_Encode4(2390760),
     /* 2389030 */ /*GILLT_nxv16s32*//*Label 34070*/ GIMT_Encode4(2390870), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2389042 */ /*GILLT_nxv32s16*//*Label 34071*/ GIMT_Encode4(2390980),
     /* 2389046 */ // Label 34054: @2389046
     /* 2389046 */ GIM_Try, /*On fail goto*//*Label 34073*/ GIMT_Encode4(2389167),
     /* 2389051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2389054 */   GIM_Try, /*On fail goto*//*Label 34074*/ GIMT_Encode4(2389082), // Rule ID 1986 //
     /* 2389059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2389062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389070 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2389070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2389073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389081 */     // GIR_Coverage, 1986,
     /* 2389081 */     GIR_EraseRootFromParent_Done,
     /* 2389082 */   // Label 34074: @2389082
     /* 2389082 */   GIM_Try, /*On fail goto*//*Label 34075*/ GIMT_Encode4(2389110), // Rule ID 1987 //
     /* 2389087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2389090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2389098 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2389098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2389101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389109 */     // GIR_Coverage, 1987,
     /* 2389109 */     GIR_EraseRootFromParent_Done,
     /* 2389110 */   // Label 34075: @2389110
     /* 2389110 */   GIM_Try, /*On fail goto*//*Label 34076*/ GIMT_Encode4(2389138), // Rule ID 2019 //
     /* 2389115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2389118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2389122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2389126 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2389126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2389129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389137 */     // GIR_Coverage, 2019,
     /* 2389137 */     GIR_EraseRootFromParent_Done,
     /* 2389138 */   // Label 34076: @2389138
     /* 2389138 */   GIM_Try, /*On fail goto*//*Label 34077*/ GIMT_Encode4(2389166), // Rule ID 2020 //
     /* 2389143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2389146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2389150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2389154 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2389154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2389157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389165 */     // GIR_Coverage, 2020,
     /* 2389165 */     GIR_EraseRootFromParent_Done,
     /* 2389166 */   // Label 34077: @2389166
     /* 2389166 */   GIM_Reject,
     /* 2389167 */ // Label 34073: @2389167
     /* 2389167 */ GIM_Reject,
     /* 2389168 */ // Label 34055: @2389168
     /* 2389168 */ GIM_Try, /*On fail goto*//*Label 34078*/ GIMT_Encode4(2389289),
     /* 2389173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2389176 */   GIM_Try, /*On fail goto*//*Label 34079*/ GIMT_Encode4(2389204), // Rule ID 1277 //
     /* 2389181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2389184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389192 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2389192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2389195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389203 */     // GIR_Coverage, 1277,
     /* 2389203 */     GIR_EraseRootFromParent_Done,
     /* 2389204 */   // Label 34079: @2389204
     /* 2389204 */   GIM_Try, /*On fail goto*//*Label 34080*/ GIMT_Encode4(2389232), // Rule ID 1278 //
     /* 2389209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2389212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2389220 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2389220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2389223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389231 */     // GIR_Coverage, 1278,
     /* 2389231 */     GIR_EraseRootFromParent_Done,
     /* 2389232 */   // Label 34080: @2389232
     /* 2389232 */   GIM_Try, /*On fail goto*//*Label 34081*/ GIMT_Encode4(2389260), // Rule ID 1285 //
     /* 2389237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2389240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2389244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2389248 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2389248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2389251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389259 */     // GIR_Coverage, 1285,
     /* 2389259 */     GIR_EraseRootFromParent_Done,
     /* 2389260 */   // Label 34081: @2389260
     /* 2389260 */   GIM_Try, /*On fail goto*//*Label 34082*/ GIMT_Encode4(2389288), // Rule ID 1286 //
     /* 2389265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2389268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2389272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2389276 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2389276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2389279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389287 */     // GIR_Coverage, 1286,
     /* 2389287 */     GIR_EraseRootFromParent_Done,
     /* 2389288 */   // Label 34082: @2389288
     /* 2389288 */   GIM_Reject,
     /* 2389289 */ // Label 34078: @2389289
     /* 2389289 */ GIM_Reject,
     /* 2389290 */ // Label 34056: @2389290
     /* 2389290 */ GIM_Try, /*On fail goto*//*Label 34083*/ GIMT_Encode4(2389439),
     /* 2389295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389298 */   GIM_Try, /*On fail goto*//*Label 34084*/ GIMT_Encode4(2389326), // Rule ID 1620 //
     /* 2389303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2389306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389314 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2389314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2389317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389325 */     // GIR_Coverage, 1620,
     /* 2389325 */     GIR_EraseRootFromParent_Done,
     /* 2389326 */   // Label 34084: @2389326
     /* 2389326 */   GIM_Try, /*On fail goto*//*Label 34085*/ GIMT_Encode4(2389354), // Rule ID 1621 //
     /* 2389331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2389334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389342 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2389342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2389345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389353 */     // GIR_Coverage, 1621,
     /* 2389353 */     GIR_EraseRootFromParent_Done,
     /* 2389354 */   // Label 34085: @2389354
     /* 2389354 */   GIM_Try, /*On fail goto*//*Label 34086*/ GIMT_Encode4(2389382), // Rule ID 1654 //
     /* 2389359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2389362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389370 */     // (fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2389370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2389373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389381 */     // GIR_Coverage, 1654,
     /* 2389381 */     GIR_EraseRootFromParent_Done,
     /* 2389382 */   // Label 34086: @2389382
     /* 2389382 */   GIM_Try, /*On fail goto*//*Label 34087*/ GIMT_Encode4(2389410), // Rule ID 1675 //
     /* 2389387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2389390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389398 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2389398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2389401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389409 */     // GIR_Coverage, 1675,
     /* 2389409 */     GIR_EraseRootFromParent_Done,
     /* 2389410 */   // Label 34087: @2389410
     /* 2389410 */   GIM_Try, /*On fail goto*//*Label 34088*/ GIMT_Encode4(2389438), // Rule ID 1676 //
     /* 2389415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2389418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389426 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2389426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2389429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2389433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389437 */     // GIR_Coverage, 1676,
     /* 2389437 */     GIR_EraseRootFromParent_Done,
     /* 2389438 */   // Label 34088: @2389438
     /* 2389438 */   GIM_Reject,
     /* 2389439 */ // Label 34083: @2389439
     /* 2389439 */ GIM_Reject,
     /* 2389440 */ // Label 34057: @2389440
     /* 2389440 */ GIM_Try, /*On fail goto*//*Label 34089*/ GIMT_Encode4(2389549),
     /* 2389445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2389448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389456 */   GIM_Try, /*On fail goto*//*Label 34090*/ GIMT_Encode4(2389502), // Rule ID 56236 //
     /* 2389461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2389464 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2389467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2389481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389501 */     // GIR_Coverage, 56236,
     /* 2389501 */     GIR_EraseRootFromParent_Done,
     /* 2389502 */   // Label 34090: @2389502
     /* 2389502 */   GIM_Try, /*On fail goto*//*Label 34091*/ GIMT_Encode4(2389548), // Rule ID 56237 //
     /* 2389507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2389510 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2389513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2389527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389547 */     // GIR_Coverage, 56237,
     /* 2389547 */     GIR_EraseRootFromParent_Done,
     /* 2389548 */   // Label 34091: @2389548
     /* 2389548 */   GIM_Reject,
     /* 2389549 */ // Label 34089: @2389549
     /* 2389549 */ GIM_Reject,
     /* 2389550 */ // Label 34058: @2389550
     /* 2389550 */ GIM_Try, /*On fail goto*//*Label 34092*/ GIMT_Encode4(2389659),
     /* 2389555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2389558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389566 */   GIM_Try, /*On fail goto*//*Label 34093*/ GIMT_Encode4(2389612), // Rule ID 56276 //
     /* 2389571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2389574 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2389577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2389591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389611 */     // GIR_Coverage, 56276,
     /* 2389611 */     GIR_EraseRootFromParent_Done,
     /* 2389612 */   // Label 34093: @2389612
     /* 2389612 */   GIM_Try, /*On fail goto*//*Label 34094*/ GIMT_Encode4(2389658), // Rule ID 56277 //
     /* 2389617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2389620 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2389623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2389637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389657 */     // GIR_Coverage, 56277,
     /* 2389657 */     GIR_EraseRootFromParent_Done,
     /* 2389658 */   // Label 34094: @2389658
     /* 2389658 */   GIM_Reject,
     /* 2389659 */ // Label 34092: @2389659
     /* 2389659 */ GIM_Reject,
     /* 2389660 */ // Label 34059: @2389660
     /* 2389660 */ GIM_Try, /*On fail goto*//*Label 34095*/ GIMT_Encode4(2389769),
     /* 2389665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2389668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389676 */   GIM_Try, /*On fail goto*//*Label 34096*/ GIMT_Encode4(2389722), // Rule ID 56336 //
     /* 2389681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2389684 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2389687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2389701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389721 */     // GIR_Coverage, 56336,
     /* 2389721 */     GIR_EraseRootFromParent_Done,
     /* 2389722 */   // Label 34096: @2389722
     /* 2389722 */   GIM_Try, /*On fail goto*//*Label 34097*/ GIMT_Encode4(2389768), // Rule ID 56337 //
     /* 2389727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2389730 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2389733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2389747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2389763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389767 */     // GIR_Coverage, 56337,
     /* 2389767 */     GIR_EraseRootFromParent_Done,
     /* 2389768 */   // Label 34097: @2389768
     /* 2389768 */   GIM_Reject,
     /* 2389769 */ // Label 34095: @2389769
     /* 2389769 */ GIM_Reject,
     /* 2389770 */ // Label 34060: @2389770
     /* 2389770 */ GIM_Try, /*On fail goto*//*Label 34098*/ GIMT_Encode4(2389879),
     /* 2389775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2389778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389786 */   GIM_Try, /*On fail goto*//*Label 34099*/ GIMT_Encode4(2389832), // Rule ID 56256 //
     /* 2389791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2389794 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2389797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2389811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389831 */     // GIR_Coverage, 56256,
     /* 2389831 */     GIR_EraseRootFromParent_Done,
     /* 2389832 */   // Label 34099: @2389832
     /* 2389832 */   GIM_Try, /*On fail goto*//*Label 34100*/ GIMT_Encode4(2389878), // Rule ID 56257 //
     /* 2389837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2389840 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2389843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2389857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2389873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389877 */     // GIR_Coverage, 56257,
     /* 2389877 */     GIR_EraseRootFromParent_Done,
     /* 2389878 */   // Label 34100: @2389878
     /* 2389878 */   GIM_Reject,
     /* 2389879 */ // Label 34098: @2389879
     /* 2389879 */ GIM_Reject,
     /* 2389880 */ // Label 34061: @2389880
     /* 2389880 */ GIM_Try, /*On fail goto*//*Label 34101*/ GIMT_Encode4(2389989),
     /* 2389885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2389888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2389896 */   GIM_Try, /*On fail goto*//*Label 34102*/ GIMT_Encode4(2389942), // Rule ID 56316 //
     /* 2389901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2389904 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2389904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2389907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2389921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389941 */     // GIR_Coverage, 56316,
     /* 2389941 */     GIR_EraseRootFromParent_Done,
     /* 2389942 */   // Label 34102: @2389942
     /* 2389942 */   GIM_Try, /*On fail goto*//*Label 34103*/ GIMT_Encode4(2389988), // Rule ID 56317 //
     /* 2389947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2389950 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2389950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2389953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2389957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2389962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2389964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2389967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2389972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2389980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2389983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2389986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389987 */     // GIR_Coverage, 56317,
     /* 2389987 */     GIR_EraseRootFromParent_Done,
     /* 2389988 */   // Label 34103: @2389988
     /* 2389988 */   GIM_Reject,
     /* 2389989 */ // Label 34101: @2389989
     /* 2389989 */ GIM_Reject,
     /* 2389990 */ // Label 34062: @2389990
     /* 2389990 */ GIM_Try, /*On fail goto*//*Label 34104*/ GIMT_Encode4(2390099),
     /* 2389995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2389998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390006 */   GIM_Try, /*On fail goto*//*Label 34105*/ GIMT_Encode4(2390052), // Rule ID 56476 //
     /* 2390011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2390014 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2390017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2390031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390051 */     // GIR_Coverage, 56476,
     /* 2390051 */     GIR_EraseRootFromParent_Done,
     /* 2390052 */   // Label 34105: @2390052
     /* 2390052 */   GIM_Try, /*On fail goto*//*Label 34106*/ GIMT_Encode4(2390098), // Rule ID 56477 //
     /* 2390057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2390060 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2390063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2390077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390097 */     // GIR_Coverage, 56477,
     /* 2390097 */     GIR_EraseRootFromParent_Done,
     /* 2390098 */   // Label 34106: @2390098
     /* 2390098 */   GIM_Reject,
     /* 2390099 */ // Label 34104: @2390099
     /* 2390099 */ GIM_Reject,
     /* 2390100 */ // Label 34063: @2390100
     /* 2390100 */ GIM_Try, /*On fail goto*//*Label 34107*/ GIMT_Encode4(2390209),
     /* 2390105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2390108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390116 */   GIM_Try, /*On fail goto*//*Label 34108*/ GIMT_Encode4(2390162), // Rule ID 56296 //
     /* 2390121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390124 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2390127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2390141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390161 */     // GIR_Coverage, 56296,
     /* 2390161 */     GIR_EraseRootFromParent_Done,
     /* 2390162 */   // Label 34108: @2390162
     /* 2390162 */   GIM_Try, /*On fail goto*//*Label 34109*/ GIMT_Encode4(2390208), // Rule ID 56297 //
     /* 2390167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2390170 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2390173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2390187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390207 */     // GIR_Coverage, 56297,
     /* 2390207 */     GIR_EraseRootFromParent_Done,
     /* 2390208 */   // Label 34109: @2390208
     /* 2390208 */   GIM_Reject,
     /* 2390209 */ // Label 34107: @2390209
     /* 2390209 */ GIM_Reject,
     /* 2390210 */ // Label 34064: @2390210
     /* 2390210 */ GIM_Try, /*On fail goto*//*Label 34110*/ GIMT_Encode4(2390319),
     /* 2390215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2390218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390226 */   GIM_Try, /*On fail goto*//*Label 34111*/ GIMT_Encode4(2390272), // Rule ID 56416 //
     /* 2390231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2390234 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2390237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2390251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390271 */     // GIR_Coverage, 56416,
     /* 2390271 */     GIR_EraseRootFromParent_Done,
     /* 2390272 */   // Label 34111: @2390272
     /* 2390272 */   GIM_Try, /*On fail goto*//*Label 34112*/ GIMT_Encode4(2390318), // Rule ID 56417 //
     /* 2390277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2390280 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2390283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2390297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390317 */     // GIR_Coverage, 56417,
     /* 2390317 */     GIR_EraseRootFromParent_Done,
     /* 2390318 */   // Label 34112: @2390318
     /* 2390318 */   GIM_Reject,
     /* 2390319 */ // Label 34110: @2390319
     /* 2390319 */ GIM_Reject,
     /* 2390320 */ // Label 34065: @2390320
     /* 2390320 */ GIM_Try, /*On fail goto*//*Label 34113*/ GIMT_Encode4(2390429),
     /* 2390325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2390328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390336 */   GIM_Try, /*On fail goto*//*Label 34114*/ GIMT_Encode4(2390382), // Rule ID 56496 //
     /* 2390341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2390344 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2390347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2390361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390381 */     // GIR_Coverage, 56496,
     /* 2390381 */     GIR_EraseRootFromParent_Done,
     /* 2390382 */   // Label 34114: @2390382
     /* 2390382 */   GIM_Try, /*On fail goto*//*Label 34115*/ GIMT_Encode4(2390428), // Rule ID 56497 //
     /* 2390387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2390390 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2390393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2390407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390427 */     // GIR_Coverage, 56497,
     /* 2390427 */     GIR_EraseRootFromParent_Done,
     /* 2390428 */   // Label 34115: @2390428
     /* 2390428 */   GIM_Reject,
     /* 2390429 */ // Label 34113: @2390429
     /* 2390429 */ GIM_Reject,
     /* 2390430 */ // Label 34066: @2390430
     /* 2390430 */ GIM_Try, /*On fail goto*//*Label 34116*/ GIMT_Encode4(2390539),
     /* 2390435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2390438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2390446 */   GIM_Try, /*On fail goto*//*Label 34117*/ GIMT_Encode4(2390492), // Rule ID 56356 //
     /* 2390451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390454 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2390457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2390471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390491 */     // GIR_Coverage, 56356,
     /* 2390491 */     GIR_EraseRootFromParent_Done,
     /* 2390492 */   // Label 34117: @2390492
     /* 2390492 */   GIM_Try, /*On fail goto*//*Label 34118*/ GIMT_Encode4(2390538), // Rule ID 56357 //
     /* 2390497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2390500 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2390503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2390517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390537 */     // GIR_Coverage, 56357,
     /* 2390537 */     GIR_EraseRootFromParent_Done,
     /* 2390538 */   // Label 34118: @2390538
     /* 2390538 */   GIM_Reject,
     /* 2390539 */ // Label 34116: @2390539
     /* 2390539 */ GIM_Reject,
     /* 2390540 */ // Label 34067: @2390540
     /* 2390540 */ GIM_Try, /*On fail goto*//*Label 34119*/ GIMT_Encode4(2390649),
     /* 2390545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2390548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390556 */   GIM_Try, /*On fail goto*//*Label 34120*/ GIMT_Encode4(2390602), // Rule ID 56436 //
     /* 2390561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2390564 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2390567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2390581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390601 */     // GIR_Coverage, 56436,
     /* 2390601 */     GIR_EraseRootFromParent_Done,
     /* 2390602 */   // Label 34120: @2390602
     /* 2390602 */   GIM_Try, /*On fail goto*//*Label 34121*/ GIMT_Encode4(2390648), // Rule ID 56437 //
     /* 2390607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2390610 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2390613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2390627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390647 */     // GIR_Coverage, 56437,
     /* 2390647 */     GIR_EraseRootFromParent_Done,
     /* 2390648 */   // Label 34121: @2390648
     /* 2390648 */   GIM_Reject,
     /* 2390649 */ // Label 34119: @2390649
     /* 2390649 */ GIM_Reject,
     /* 2390650 */ // Label 34068: @2390650
     /* 2390650 */ GIM_Try, /*On fail goto*//*Label 34122*/ GIMT_Encode4(2390759),
     /* 2390655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2390658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390666 */   GIM_Try, /*On fail goto*//*Label 34123*/ GIMT_Encode4(2390712), // Rule ID 56516 //
     /* 2390671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2390674 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2390677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2390691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390711 */     // GIR_Coverage, 56516,
     /* 2390711 */     GIR_EraseRootFromParent_Done,
     /* 2390712 */   // Label 34123: @2390712
     /* 2390712 */   GIM_Try, /*On fail goto*//*Label 34124*/ GIMT_Encode4(2390758), // Rule ID 56517 //
     /* 2390717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2390720 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2390723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2390737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2390753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390757 */     // GIR_Coverage, 56517,
     /* 2390757 */     GIR_EraseRootFromParent_Done,
     /* 2390758 */   // Label 34124: @2390758
     /* 2390758 */   GIM_Reject,
     /* 2390759 */ // Label 34122: @2390759
     /* 2390759 */ GIM_Reject,
     /* 2390760 */ // Label 34069: @2390760
     /* 2390760 */ GIM_Try, /*On fail goto*//*Label 34125*/ GIMT_Encode4(2390869),
     /* 2390765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2390768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2390776 */   GIM_Try, /*On fail goto*//*Label 34126*/ GIMT_Encode4(2390822), // Rule ID 56376 //
     /* 2390781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390784 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2390787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2390801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390821 */     // GIR_Coverage, 56376,
     /* 2390821 */     GIR_EraseRootFromParent_Done,
     /* 2390822 */   // Label 34126: @2390822
     /* 2390822 */   GIM_Try, /*On fail goto*//*Label 34127*/ GIMT_Encode4(2390868), // Rule ID 56377 //
     /* 2390827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2390830 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2390833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2390847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390867 */     // GIR_Coverage, 56377,
     /* 2390867 */     GIR_EraseRootFromParent_Done,
     /* 2390868 */   // Label 34127: @2390868
     /* 2390868 */   GIM_Reject,
     /* 2390869 */ // Label 34125: @2390869
     /* 2390869 */ GIM_Reject,
     /* 2390870 */ // Label 34070: @2390870
     /* 2390870 */ GIM_Try, /*On fail goto*//*Label 34128*/ GIMT_Encode4(2390979),
     /* 2390875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2390878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390886 */   GIM_Try, /*On fail goto*//*Label 34129*/ GIMT_Encode4(2390932), // Rule ID 56456 //
     /* 2390891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2390894 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2390894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2390897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2390911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390931 */     // GIR_Coverage, 56456,
     /* 2390931 */     GIR_EraseRootFromParent_Done,
     /* 2390932 */   // Label 34129: @2390932
     /* 2390932 */   GIM_Try, /*On fail goto*//*Label 34130*/ GIMT_Encode4(2390978), // Rule ID 56457 //
     /* 2390937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2390940 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2390940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2390943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2390947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2390952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2390954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2390957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2390962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2390973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2390976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390977 */     // GIR_Coverage, 56457,
     /* 2390977 */     GIR_EraseRootFromParent_Done,
     /* 2390978 */   // Label 34130: @2390978
     /* 2390978 */   GIM_Reject,
     /* 2390979 */ // Label 34128: @2390979
     /* 2390979 */ GIM_Reject,
     /* 2390980 */ // Label 34071: @2390980
     /* 2390980 */ GIM_Try, /*On fail goto*//*Label 34131*/ GIMT_Encode4(2391089),
     /* 2390985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2390988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2390996 */   GIM_Try, /*On fail goto*//*Label 34132*/ GIMT_Encode4(2391042), // Rule ID 56396 //
     /* 2391001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2391004 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2391004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2391007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2391021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391041 */     // GIR_Coverage, 56396,
     /* 2391041 */     GIR_EraseRootFromParent_Done,
     /* 2391042 */   // Label 34132: @2391042
     /* 2391042 */   GIM_Try, /*On fail goto*//*Label 34133*/ GIMT_Encode4(2391088), // Rule ID 56397 //
     /* 2391047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2391050 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2391050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2391053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2391057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2391062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2391064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2391067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2391072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2391074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2391086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391087 */     // GIR_Coverage, 56397,
     /* 2391087 */     GIR_EraseRootFromParent_Done,
     /* 2391088 */   // Label 34133: @2391088
     /* 2391088 */   GIM_Reject,
     /* 2391089 */ // Label 34131: @2391089
     /* 2391089 */ GIM_Reject,
     /* 2391090 */ // Label 34072: @2391090
     /* 2391090 */ GIM_Reject,
     /* 2391091 */ // Label 95: @2391091
     /* 2391091 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34137*/ GIMT_Encode4(2391288),
     /* 2391102 */ /*GILLT_s16*//*Label 34134*/ GIMT_Encode4(2391114),
     /* 2391106 */ /*GILLT_s32*//*Label 34135*/ GIMT_Encode4(2391172),
     /* 2391110 */ /*GILLT_s64*//*Label 34136*/ GIMT_Encode4(2391230),
     /* 2391114 */ // Label 34134: @2391114
     /* 2391114 */ GIM_Try, /*On fail goto*//*Label 34138*/ GIMT_Encode4(2391171),
     /* 2391119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391130 */   GIM_Try, /*On fail goto*//*Label 34139*/ GIMT_Encode4(2391150), // Rule ID 2424 //
     /* 2391135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2391138 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i64] })
     /* 2391138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391149 */     // GIR_Coverage, 2424,
     /* 2391149 */     GIR_EraseRootFromParent_Done,
     /* 2391150 */   // Label 34139: @2391150
     /* 2391150 */   GIM_Try, /*On fail goto*//*Label 34140*/ GIMT_Encode4(2391170), // Rule ID 2425 //
     /* 2391155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2391158 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i32] })
     /* 2391158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391169 */     // GIR_Coverage, 2425,
     /* 2391169 */     GIR_EraseRootFromParent_Done,
     /* 2391170 */   // Label 34140: @2391170
     /* 2391170 */   GIM_Reject,
     /* 2391171 */ // Label 34138: @2391171
     /* 2391171 */ GIM_Reject,
     /* 2391172 */ // Label 34135: @2391172
     /* 2391172 */ GIM_Try, /*On fail goto*//*Label 34141*/ GIMT_Encode4(2391229),
     /* 2391177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391188 */   GIM_Try, /*On fail goto*//*Label 34142*/ GIMT_Encode4(2391208), // Rule ID 2342 //
     /* 2391193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2391196 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i64] })
     /* 2391196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2391199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391207 */     // GIR_Coverage, 2342,
     /* 2391207 */     GIR_EraseRootFromParent_Done,
     /* 2391208 */   // Label 34142: @2391208
     /* 2391208 */   GIM_Try, /*On fail goto*//*Label 34143*/ GIMT_Encode4(2391228), // Rule ID 2343 //
     /* 2391213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2391216 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i32] })
     /* 2391216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2391219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391227 */     // GIR_Coverage, 2343,
     /* 2391227 */     GIR_EraseRootFromParent_Done,
     /* 2391228 */   // Label 34143: @2391228
     /* 2391228 */   GIM_Reject,
     /* 2391229 */ // Label 34141: @2391229
     /* 2391229 */ GIM_Reject,
     /* 2391230 */ // Label 34136: @2391230
     /* 2391230 */ GIM_Try, /*On fail goto*//*Label 34144*/ GIMT_Encode4(2391287),
     /* 2391235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2391238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391246 */   GIM_Try, /*On fail goto*//*Label 34145*/ GIMT_Encode4(2391266), // Rule ID 2382 //
     /* 2391251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2391254 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i64] })
     /* 2391254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2391257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391265 */     // GIR_Coverage, 2382,
     /* 2391265 */     GIR_EraseRootFromParent_Done,
     /* 2391266 */   // Label 34145: @2391266
     /* 2391266 */   GIM_Try, /*On fail goto*//*Label 34146*/ GIMT_Encode4(2391286), // Rule ID 2383 //
     /* 2391271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2391274 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i32] })
     /* 2391274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2391277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2391284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391285 */     // GIR_Coverage, 2383,
     /* 2391285 */     GIR_EraseRootFromParent_Done,
     /* 2391286 */   // Label 34146: @2391286
     /* 2391286 */   GIM_Reject,
     /* 2391287 */ // Label 34144: @2391287
     /* 2391287 */ GIM_Reject,
     /* 2391288 */ // Label 34137: @2391288
     /* 2391288 */ GIM_Reject,
     /* 2391289 */ // Label 96: @2391289
     /* 2391289 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34150*/ GIMT_Encode4(2391486),
     /* 2391300 */ /*GILLT_s16*//*Label 34147*/ GIMT_Encode4(2391312),
     /* 2391304 */ /*GILLT_s32*//*Label 34148*/ GIMT_Encode4(2391370),
     /* 2391308 */ /*GILLT_s64*//*Label 34149*/ GIMT_Encode4(2391428),
     /* 2391312 */ // Label 34147: @2391312
     /* 2391312 */ GIM_Try, /*On fail goto*//*Label 34151*/ GIMT_Encode4(2391369),
     /* 2391317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391328 */   GIM_Try, /*On fail goto*//*Label 34152*/ GIMT_Encode4(2391348), // Rule ID 2408 //
     /* 2391333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2391336 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2391336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2391339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391347 */     // GIR_Coverage, 2408,
     /* 2391347 */     GIR_EraseRootFromParent_Done,
     /* 2391348 */   // Label 34152: @2391348
     /* 2391348 */   GIM_Try, /*On fail goto*//*Label 34153*/ GIMT_Encode4(2391368), // Rule ID 2409 //
     /* 2391353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2391356 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2391356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2391359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391367 */     // GIR_Coverage, 2409,
     /* 2391367 */     GIR_EraseRootFromParent_Done,
     /* 2391368 */   // Label 34153: @2391368
     /* 2391368 */   GIM_Reject,
     /* 2391369 */ // Label 34151: @2391369
     /* 2391369 */ GIM_Reject,
     /* 2391370 */ // Label 34148: @2391370
     /* 2391370 */ GIM_Try, /*On fail goto*//*Label 34154*/ GIMT_Encode4(2391427),
     /* 2391375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391386 */   GIM_Try, /*On fail goto*//*Label 34155*/ GIMT_Encode4(2391406), // Rule ID 2326 //
     /* 2391391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2391394 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2391394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2391397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391405 */     // GIR_Coverage, 2326,
     /* 2391405 */     GIR_EraseRootFromParent_Done,
     /* 2391406 */   // Label 34155: @2391406
     /* 2391406 */   GIM_Try, /*On fail goto*//*Label 34156*/ GIMT_Encode4(2391426), // Rule ID 2327 //
     /* 2391411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2391414 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2391414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2391417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391425 */     // GIR_Coverage, 2327,
     /* 2391425 */     GIR_EraseRootFromParent_Done,
     /* 2391426 */   // Label 34156: @2391426
     /* 2391426 */   GIM_Reject,
     /* 2391427 */ // Label 34154: @2391427
     /* 2391427 */ GIM_Reject,
     /* 2391428 */ // Label 34149: @2391428
     /* 2391428 */ GIM_Try, /*On fail goto*//*Label 34157*/ GIMT_Encode4(2391485),
     /* 2391433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2391436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391444 */   GIM_Try, /*On fail goto*//*Label 34158*/ GIMT_Encode4(2391464), // Rule ID 2366 //
     /* 2391449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2391452 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2391452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2391455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391463 */     // GIR_Coverage, 2366,
     /* 2391463 */     GIR_EraseRootFromParent_Done,
     /* 2391464 */   // Label 34158: @2391464
     /* 2391464 */   GIM_Try, /*On fail goto*//*Label 34159*/ GIMT_Encode4(2391484), // Rule ID 2367 //
     /* 2391469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2391472 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2391472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2391475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391483 */     // GIR_Coverage, 2367,
     /* 2391483 */     GIR_EraseRootFromParent_Done,
     /* 2391484 */   // Label 34159: @2391484
     /* 2391484 */   GIM_Reject,
     /* 2391485 */ // Label 34157: @2391485
     /* 2391485 */ GIM_Reject,
     /* 2391486 */ // Label 34150: @2391486
     /* 2391486 */ GIM_Reject,
     /* 2391487 */ // Label 97: @2391487
     /* 2391487 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34163*/ GIMT_Encode4(2391684),
     /* 2391498 */ /*GILLT_s16*//*Label 34160*/ GIMT_Encode4(2391510),
     /* 2391502 */ /*GILLT_s32*//*Label 34161*/ GIMT_Encode4(2391568),
     /* 2391506 */ /*GILLT_s64*//*Label 34162*/ GIMT_Encode4(2391626),
     /* 2391510 */ // Label 34160: @2391510
     /* 2391510 */ GIM_Try, /*On fail goto*//*Label 34164*/ GIMT_Encode4(2391567),
     /* 2391515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391526 */   GIM_Try, /*On fail goto*//*Label 34165*/ GIMT_Encode4(2391546), // Rule ID 2412 //
     /* 2391531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2391534 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2391534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391545 */     // GIR_Coverage, 2412,
     /* 2391545 */     GIR_EraseRootFromParent_Done,
     /* 2391546 */   // Label 34165: @2391546
     /* 2391546 */   GIM_Try, /*On fail goto*//*Label 34166*/ GIMT_Encode4(2391566), // Rule ID 2413 //
     /* 2391551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2391554 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2391554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2391557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391565 */     // GIR_Coverage, 2413,
     /* 2391565 */     GIR_EraseRootFromParent_Done,
     /* 2391566 */   // Label 34166: @2391566
     /* 2391566 */   GIM_Reject,
     /* 2391567 */ // Label 34164: @2391567
     /* 2391567 */ GIM_Reject,
     /* 2391568 */ // Label 34161: @2391568
     /* 2391568 */ GIM_Try, /*On fail goto*//*Label 34167*/ GIMT_Encode4(2391625),
     /* 2391573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391584 */   GIM_Try, /*On fail goto*//*Label 34168*/ GIMT_Encode4(2391604), // Rule ID 2330 //
     /* 2391589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2391592 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2391592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2391595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391603 */     // GIR_Coverage, 2330,
     /* 2391603 */     GIR_EraseRootFromParent_Done,
     /* 2391604 */   // Label 34168: @2391604
     /* 2391604 */   GIM_Try, /*On fail goto*//*Label 34169*/ GIMT_Encode4(2391624), // Rule ID 2331 //
     /* 2391609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2391612 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2391612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2391615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391623 */     // GIR_Coverage, 2331,
     /* 2391623 */     GIR_EraseRootFromParent_Done,
     /* 2391624 */   // Label 34169: @2391624
     /* 2391624 */   GIM_Reject,
     /* 2391625 */ // Label 34167: @2391625
     /* 2391625 */ GIM_Reject,
     /* 2391626 */ // Label 34162: @2391626
     /* 2391626 */ GIM_Try, /*On fail goto*//*Label 34170*/ GIMT_Encode4(2391683),
     /* 2391631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2391634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2391642 */   GIM_Try, /*On fail goto*//*Label 34171*/ GIMT_Encode4(2391662), // Rule ID 2370 //
     /* 2391647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2391650 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2391650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2391653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391661 */     // GIR_Coverage, 2370,
     /* 2391661 */     GIR_EraseRootFromParent_Done,
     /* 2391662 */   // Label 34171: @2391662
     /* 2391662 */   GIM_Try, /*On fail goto*//*Label 34172*/ GIMT_Encode4(2391682), // Rule ID 2371 //
     /* 2391667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2391670 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2391670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2391673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391681 */     // GIR_Coverage, 2371,
     /* 2391681 */     GIR_EraseRootFromParent_Done,
     /* 2391682 */   // Label 34172: @2391682
     /* 2391682 */   GIM_Reject,
     /* 2391683 */ // Label 34170: @2391683
     /* 2391683 */ GIM_Reject,
     /* 2391684 */ // Label 34163: @2391684
     /* 2391684 */ GIM_Reject,
     /* 2391685 */ // Label 98: @2391685
     /* 2391685 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34191*/ GIMT_Encode4(2394112),
     /* 2391696 */ /*GILLT_s16*//*Label 34173*/ GIMT_Encode4(2391816),
     /* 2391700 */ /*GILLT_s32*//*Label 34174*/ GIMT_Encode4(2391965),
     /* 2391704 */ /*GILLT_s64*//*Label 34175*/ GIMT_Encode4(2392114), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391716 */ /*GILLT_nxv1s16*//*Label 34176*/ GIMT_Encode4(2392297),
     /* 2391720 */ /*GILLT_nxv1s32*//*Label 34177*/ GIMT_Encode4(2392418),
     /* 2391724 */ /*GILLT_nxv1s64*//*Label 34178*/ GIMT_Encode4(2392539), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391736 */ /*GILLT_nxv2s16*//*Label 34179*/ GIMT_Encode4(2392660),
     /* 2391740 */ /*GILLT_nxv2s32*//*Label 34180*/ GIMT_Encode4(2392781),
     /* 2391744 */ /*GILLT_nxv2s64*//*Label 34181*/ GIMT_Encode4(2392902), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391756 */ /*GILLT_nxv4s16*//*Label 34182*/ GIMT_Encode4(2393023),
     /* 2391760 */ /*GILLT_nxv4s32*//*Label 34183*/ GIMT_Encode4(2393144),
     /* 2391764 */ /*GILLT_nxv4s64*//*Label 34184*/ GIMT_Encode4(2393265), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391776 */ /*GILLT_nxv8s16*//*Label 34185*/ GIMT_Encode4(2393386),
     /* 2391780 */ /*GILLT_nxv8s32*//*Label 34186*/ GIMT_Encode4(2393507),
     /* 2391784 */ /*GILLT_nxv8s64*//*Label 34187*/ GIMT_Encode4(2393628), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391796 */ /*GILLT_nxv16s16*//*Label 34188*/ GIMT_Encode4(2393749),
     /* 2391800 */ /*GILLT_nxv16s32*//*Label 34189*/ GIMT_Encode4(2393870), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2391812 */ /*GILLT_nxv32s16*//*Label 34190*/ GIMT_Encode4(2393991),
     /* 2391816 */ // Label 34173: @2391816
     /* 2391816 */ GIM_Try, /*On fail goto*//*Label 34192*/ GIMT_Encode4(2391964),
     /* 2391821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2391824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2391827 */   GIM_Try, /*On fail goto*//*Label 34193*/ GIMT_Encode4(2391861), // Rule ID 1952 //
     /* 2391832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2391835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391847 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2391847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2391850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391860 */     // GIR_Coverage, 1952,
     /* 2391860 */     GIR_EraseRootFromParent_Done,
     /* 2391861 */   // Label 34193: @2391861
     /* 2391861 */   GIM_Try, /*On fail goto*//*Label 34194*/ GIMT_Encode4(2391895), // Rule ID 1953 //
     /* 2391866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2391869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2391881 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2391881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2391884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391894 */     // GIR_Coverage, 1953,
     /* 2391894 */     GIR_EraseRootFromParent_Done,
     /* 2391895 */   // Label 34194: @2391895
     /* 2391895 */   GIM_Try, /*On fail goto*//*Label 34195*/ GIMT_Encode4(2391929), // Rule ID 1956 //
     /* 2391900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2391903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391915 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2391915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2391918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391928 */     // GIR_Coverage, 1956,
     /* 2391928 */     GIR_EraseRootFromParent_Done,
     /* 2391929 */   // Label 34195: @2391929
     /* 2391929 */   GIM_Try, /*On fail goto*//*Label 34196*/ GIMT_Encode4(2391963), // Rule ID 1957 //
     /* 2391934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2391937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2391949 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2391949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2391952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2391958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391962 */     // GIR_Coverage, 1957,
     /* 2391962 */     GIR_EraseRootFromParent_Done,
     /* 2391963 */   // Label 34196: @2391963
     /* 2391963 */   GIM_Reject,
     /* 2391964 */ // Label 34192: @2391964
     /* 2391964 */ GIM_Reject,
     /* 2391965 */ // Label 34174: @2391965
     /* 2391965 */ GIM_Try, /*On fail goto*//*Label 34197*/ GIMT_Encode4(2392113),
     /* 2391970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2391973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2391976 */   GIM_Try, /*On fail goto*//*Label 34198*/ GIMT_Encode4(2392010), // Rule ID 1243 //
     /* 2391981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2391984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2391996 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2391996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2391999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392009 */     // GIR_Coverage, 1243,
     /* 2392009 */     GIR_EraseRootFromParent_Done,
     /* 2392010 */   // Label 34198: @2392010
     /* 2392010 */   GIM_Try, /*On fail goto*//*Label 34199*/ GIMT_Encode4(2392044), // Rule ID 1244 //
     /* 2392015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2392018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2392030 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2392030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2392033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392043 */     // GIR_Coverage, 1244,
     /* 2392043 */     GIR_EraseRootFromParent_Done,
     /* 2392044 */   // Label 34199: @2392044
     /* 2392044 */   GIM_Try, /*On fail goto*//*Label 34200*/ GIMT_Encode4(2392078), // Rule ID 1247 //
     /* 2392049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2392052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392064 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2392064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2392067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392077 */     // GIR_Coverage, 1247,
     /* 2392077 */     GIR_EraseRootFromParent_Done,
     /* 2392078 */   // Label 34200: @2392078
     /* 2392078 */   GIM_Try, /*On fail goto*//*Label 34201*/ GIMT_Encode4(2392112), // Rule ID 1248 //
     /* 2392083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2392086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2392098 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2392098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2392101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392111 */     // GIR_Coverage, 1248,
     /* 2392111 */     GIR_EraseRootFromParent_Done,
     /* 2392112 */   // Label 34201: @2392112
     /* 2392112 */   GIM_Reject,
     /* 2392113 */ // Label 34197: @2392113
     /* 2392113 */ GIM_Reject,
     /* 2392114 */ // Label 34175: @2392114
     /* 2392114 */ GIM_Try, /*On fail goto*//*Label 34202*/ GIMT_Encode4(2392296),
     /* 2392119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2392122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2392125 */   GIM_Try, /*On fail goto*//*Label 34203*/ GIMT_Encode4(2392159), // Rule ID 1578 //
     /* 2392130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2392133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392145 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2392145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2392148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392158 */     // GIR_Coverage, 1578,
     /* 2392158 */     GIR_EraseRootFromParent_Done,
     /* 2392159 */   // Label 34203: @2392159
     /* 2392159 */   GIM_Try, /*On fail goto*//*Label 34204*/ GIMT_Encode4(2392193), // Rule ID 1579 //
     /* 2392164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2392167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2392179 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2392179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2392182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392192 */     // GIR_Coverage, 1579,
     /* 2392192 */     GIR_EraseRootFromParent_Done,
     /* 2392193 */   // Label 34204: @2392193
     /* 2392193 */   GIM_Try, /*On fail goto*//*Label 34205*/ GIMT_Encode4(2392227), // Rule ID 1582 //
     /* 2392198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2392201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392213 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2392213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2392216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392226 */     // GIR_Coverage, 1582,
     /* 2392226 */     GIR_EraseRootFromParent_Done,
     /* 2392227 */   // Label 34205: @2392227
     /* 2392227 */   GIM_Try, /*On fail goto*//*Label 34206*/ GIMT_Encode4(2392261), // Rule ID 1583 //
     /* 2392232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2392235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2392247 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2392247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2392250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392260 */     // GIR_Coverage, 1583,
     /* 2392260 */     GIR_EraseRootFromParent_Done,
     /* 2392261 */   // Label 34206: @2392261
     /* 2392261 */   GIM_Try, /*On fail goto*//*Label 34207*/ GIMT_Encode4(2392295), // Rule ID 1586 //
     /* 2392266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2392269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2392281 */     // (strict_fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2392281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2392284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392294 */     // GIR_Coverage, 1586,
     /* 2392294 */     GIR_EraseRootFromParent_Done,
     /* 2392295 */   // Label 34207: @2392295
     /* 2392295 */   GIM_Reject,
     /* 2392296 */ // Label 34202: @2392296
     /* 2392296 */ GIM_Reject,
     /* 2392297 */ // Label 34176: @2392297
     /* 2392297 */ GIM_Try, /*On fail goto*//*Label 34208*/ GIMT_Encode4(2392417),
     /* 2392302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2392305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2392308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392320 */   GIM_Try, /*On fail goto*//*Label 34209*/ GIMT_Encode4(2392368), // Rule ID 45756 //
     /* 2392325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2392328 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2392331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2392345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392367 */     // GIR_Coverage, 45756,
     /* 2392367 */     GIR_EraseRootFromParent_Done,
     /* 2392368 */   // Label 34209: @2392368
     /* 2392368 */   GIM_Try, /*On fail goto*//*Label 34210*/ GIMT_Encode4(2392416), // Rule ID 45757 //
     /* 2392373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2392376 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2392379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2392393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392415 */     // GIR_Coverage, 45757,
     /* 2392415 */     GIR_EraseRootFromParent_Done,
     /* 2392416 */   // Label 34210: @2392416
     /* 2392416 */   GIM_Reject,
     /* 2392417 */ // Label 34208: @2392417
     /* 2392417 */ GIM_Reject,
     /* 2392418 */ // Label 34177: @2392418
     /* 2392418 */ GIM_Try, /*On fail goto*//*Label 34211*/ GIMT_Encode4(2392538),
     /* 2392423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2392426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2392429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392441 */   GIM_Try, /*On fail goto*//*Label 34212*/ GIMT_Encode4(2392489), // Rule ID 53296 //
     /* 2392446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2392449 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2392452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2392466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392488 */     // GIR_Coverage, 53296,
     /* 2392488 */     GIR_EraseRootFromParent_Done,
     /* 2392489 */   // Label 34212: @2392489
     /* 2392489 */   GIM_Try, /*On fail goto*//*Label 34213*/ GIMT_Encode4(2392537), // Rule ID 53297 //
     /* 2392494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2392497 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2392500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2392514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392536 */     // GIR_Coverage, 53297,
     /* 2392536 */     GIR_EraseRootFromParent_Done,
     /* 2392537 */   // Label 34213: @2392537
     /* 2392537 */   GIM_Reject,
     /* 2392538 */ // Label 34211: @2392538
     /* 2392538 */ GIM_Reject,
     /* 2392539 */ // Label 34178: @2392539
     /* 2392539 */ GIM_Try, /*On fail goto*//*Label 34214*/ GIMT_Encode4(2392659),
     /* 2392544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2392550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392562 */   GIM_Try, /*On fail goto*//*Label 34215*/ GIMT_Encode4(2392610), // Rule ID 53332 //
     /* 2392567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392570 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2392573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2392587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392609 */     // GIR_Coverage, 53332,
     /* 2392609 */     GIR_EraseRootFromParent_Done,
     /* 2392610 */   // Label 34215: @2392610
     /* 2392610 */   GIM_Try, /*On fail goto*//*Label 34216*/ GIMT_Encode4(2392658), // Rule ID 53333 //
     /* 2392615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392618 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2392621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2392635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392657 */     // GIR_Coverage, 53333,
     /* 2392657 */     GIR_EraseRootFromParent_Done,
     /* 2392658 */   // Label 34216: @2392658
     /* 2392658 */   GIM_Reject,
     /* 2392659 */ // Label 34214: @2392659
     /* 2392659 */ GIM_Reject,
     /* 2392660 */ // Label 34179: @2392660
     /* 2392660 */ GIM_Try, /*On fail goto*//*Label 34217*/ GIMT_Encode4(2392780),
     /* 2392665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2392668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2392671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392683 */   GIM_Try, /*On fail goto*//*Label 34218*/ GIMT_Encode4(2392731), // Rule ID 53284 //
     /* 2392688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2392691 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2392694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2392708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392730 */     // GIR_Coverage, 53284,
     /* 2392730 */     GIR_EraseRootFromParent_Done,
     /* 2392731 */   // Label 34218: @2392731
     /* 2392731 */   GIM_Try, /*On fail goto*//*Label 34219*/ GIMT_Encode4(2392779), // Rule ID 53285 //
     /* 2392736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2392739 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2392742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2392756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2392774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392778 */     // GIR_Coverage, 53285,
     /* 2392778 */     GIR_EraseRootFromParent_Done,
     /* 2392779 */   // Label 34219: @2392779
     /* 2392779 */   GIM_Reject,
     /* 2392780 */ // Label 34217: @2392780
     /* 2392780 */ GIM_Reject,
     /* 2392781 */ // Label 34180: @2392781
     /* 2392781 */ GIM_Try, /*On fail goto*//*Label 34220*/ GIMT_Encode4(2392901),
     /* 2392786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2392789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2392792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392804 */   GIM_Try, /*On fail goto*//*Label 34221*/ GIMT_Encode4(2392852), // Rule ID 53320 //
     /* 2392809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2392812 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2392815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2392829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392851 */     // GIR_Coverage, 53320,
     /* 2392851 */     GIR_EraseRootFromParent_Done,
     /* 2392852 */   // Label 34221: @2392852
     /* 2392852 */   GIM_Try, /*On fail goto*//*Label 34222*/ GIMT_Encode4(2392900), // Rule ID 53321 //
     /* 2392857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2392860 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2392863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2392877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392899 */     // GIR_Coverage, 53321,
     /* 2392899 */     GIR_EraseRootFromParent_Done,
     /* 2392900 */   // Label 34222: @2392900
     /* 2392900 */   GIM_Reject,
     /* 2392901 */ // Label 34220: @2392901
     /* 2392901 */ GIM_Reject,
     /* 2392902 */ // Label 34181: @2392902
     /* 2392902 */ GIM_Try, /*On fail goto*//*Label 34223*/ GIMT_Encode4(2393022),
     /* 2392907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2392910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2392913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2392917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2392921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2392925 */   GIM_Try, /*On fail goto*//*Label 34224*/ GIMT_Encode4(2392973), // Rule ID 53416 //
     /* 2392930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392933 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2392933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2392936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2392950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2392955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2392959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2392971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392972 */     // GIR_Coverage, 53416,
     /* 2392972 */     GIR_EraseRootFromParent_Done,
     /* 2392973 */   // Label 34224: @2392973
     /* 2392973 */   GIM_Try, /*On fail goto*//*Label 34225*/ GIMT_Encode4(2393021), // Rule ID 53417 //
     /* 2392978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392981 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2392981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2392984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2392988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2392993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2392995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2392998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393020 */     // GIR_Coverage, 53417,
     /* 2393020 */     GIR_EraseRootFromParent_Done,
     /* 2393021 */   // Label 34225: @2393021
     /* 2393021 */   GIM_Reject,
     /* 2393022 */ // Label 34223: @2393022
     /* 2393022 */ GIM_Reject,
     /* 2393023 */ // Label 34182: @2393023
     /* 2393023 */ GIM_Try, /*On fail goto*//*Label 34226*/ GIMT_Encode4(2393143),
     /* 2393028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2393031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2393034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393042 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393046 */   GIM_Try, /*On fail goto*//*Label 34227*/ GIMT_Encode4(2393094), // Rule ID 53308 //
     /* 2393051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393054 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2393057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2393071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393093 */     // GIR_Coverage, 53308,
     /* 2393093 */     GIR_EraseRootFromParent_Done,
     /* 2393094 */   // Label 34227: @2393094
     /* 2393094 */   GIM_Try, /*On fail goto*//*Label 34228*/ GIMT_Encode4(2393142), // Rule ID 53309 //
     /* 2393099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393102 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2393105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2393119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393141 */     // GIR_Coverage, 53309,
     /* 2393141 */     GIR_EraseRootFromParent_Done,
     /* 2393142 */   // Label 34228: @2393142
     /* 2393142 */   GIM_Reject,
     /* 2393143 */ // Label 34226: @2393143
     /* 2393143 */ GIM_Reject,
     /* 2393144 */ // Label 34183: @2393144
     /* 2393144 */ GIM_Try, /*On fail goto*//*Label 34229*/ GIMT_Encode4(2393264),
     /* 2393149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2393152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2393155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393167 */   GIM_Try, /*On fail goto*//*Label 34230*/ GIMT_Encode4(2393215), // Rule ID 53380 //
     /* 2393172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2393175 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2393178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2393192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393214 */     // GIR_Coverage, 53380,
     /* 2393214 */     GIR_EraseRootFromParent_Done,
     /* 2393215 */   // Label 34230: @2393215
     /* 2393215 */   GIM_Try, /*On fail goto*//*Label 34231*/ GIMT_Encode4(2393263), // Rule ID 53381 //
     /* 2393220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2393223 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2393226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2393240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393262 */     // GIR_Coverage, 53381,
     /* 2393262 */     GIR_EraseRootFromParent_Done,
     /* 2393263 */   // Label 34231: @2393263
     /* 2393263 */   GIM_Reject,
     /* 2393264 */ // Label 34229: @2393264
     /* 2393264 */ GIM_Reject,
     /* 2393265 */ // Label 34184: @2393265
     /* 2393265 */ GIM_Try, /*On fail goto*//*Label 34232*/ GIMT_Encode4(2393385),
     /* 2393270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2393273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2393276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393288 */   GIM_Try, /*On fail goto*//*Label 34233*/ GIMT_Encode4(2393336), // Rule ID 53428 //
     /* 2393293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2393296 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2393299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2393313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393335 */     // GIR_Coverage, 53428,
     /* 2393335 */     GIR_EraseRootFromParent_Done,
     /* 2393336 */   // Label 34233: @2393336
     /* 2393336 */   GIM_Try, /*On fail goto*//*Label 34234*/ GIMT_Encode4(2393384), // Rule ID 53429 //
     /* 2393341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2393344 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2393347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2393361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393383 */     // GIR_Coverage, 53429,
     /* 2393383 */     GIR_EraseRootFromParent_Done,
     /* 2393384 */   // Label 34234: @2393384
     /* 2393384 */   GIM_Reject,
     /* 2393385 */ // Label 34232: @2393385
     /* 2393385 */ GIM_Reject,
     /* 2393386 */ // Label 34185: @2393386
     /* 2393386 */ GIM_Try, /*On fail goto*//*Label 34235*/ GIMT_Encode4(2393506),
     /* 2393391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2393394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2393397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2393409 */   GIM_Try, /*On fail goto*//*Label 34236*/ GIMT_Encode4(2393457), // Rule ID 53344 //
     /* 2393414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393417 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2393420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2393434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393456 */     // GIR_Coverage, 53344,
     /* 2393456 */     GIR_EraseRootFromParent_Done,
     /* 2393457 */   // Label 34236: @2393457
     /* 2393457 */   GIM_Try, /*On fail goto*//*Label 34237*/ GIMT_Encode4(2393505), // Rule ID 53345 //
     /* 2393462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393465 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2393468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2393482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393504 */     // GIR_Coverage, 53345,
     /* 2393504 */     GIR_EraseRootFromParent_Done,
     /* 2393505 */   // Label 34237: @2393505
     /* 2393505 */   GIM_Reject,
     /* 2393506 */ // Label 34235: @2393506
     /* 2393506 */ GIM_Reject,
     /* 2393507 */ // Label 34186: @2393507
     /* 2393507 */ GIM_Try, /*On fail goto*//*Label 34238*/ GIMT_Encode4(2393627),
     /* 2393512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2393515 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2393518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393530 */   GIM_Try, /*On fail goto*//*Label 34239*/ GIMT_Encode4(2393578), // Rule ID 53392 //
     /* 2393535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2393538 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2393541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2393555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393577 */     // GIR_Coverage, 53392,
     /* 2393577 */     GIR_EraseRootFromParent_Done,
     /* 2393578 */   // Label 34239: @2393578
     /* 2393578 */   GIM_Try, /*On fail goto*//*Label 34240*/ GIMT_Encode4(2393626), // Rule ID 53393 //
     /* 2393583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2393586 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2393589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2393603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393625 */     // GIR_Coverage, 53393,
     /* 2393625 */     GIR_EraseRootFromParent_Done,
     /* 2393626 */   // Label 34240: @2393626
     /* 2393626 */   GIM_Reject,
     /* 2393627 */ // Label 34238: @2393627
     /* 2393627 */ GIM_Reject,
     /* 2393628 */ // Label 34187: @2393628
     /* 2393628 */ GIM_Try, /*On fail goto*//*Label 34241*/ GIMT_Encode4(2393748),
     /* 2393633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2393636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2393639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393651 */   GIM_Try, /*On fail goto*//*Label 34242*/ GIMT_Encode4(2393699), // Rule ID 53440 //
     /* 2393656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2393659 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2393662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2393676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393698 */     // GIR_Coverage, 53440,
     /* 2393698 */     GIR_EraseRootFromParent_Done,
     /* 2393699 */   // Label 34242: @2393699
     /* 2393699 */   GIM_Try, /*On fail goto*//*Label 34243*/ GIMT_Encode4(2393747), // Rule ID 53441 //
     /* 2393704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2393707 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2393710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2393724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2393742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393746 */     // GIR_Coverage, 53441,
     /* 2393746 */     GIR_EraseRootFromParent_Done,
     /* 2393747 */   // Label 34243: @2393747
     /* 2393747 */   GIM_Reject,
     /* 2393748 */ // Label 34241: @2393748
     /* 2393748 */ GIM_Reject,
     /* 2393749 */ // Label 34188: @2393749
     /* 2393749 */ GIM_Try, /*On fail goto*//*Label 34244*/ GIMT_Encode4(2393869),
     /* 2393754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2393757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2393760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2393772 */   GIM_Try, /*On fail goto*//*Label 34245*/ GIMT_Encode4(2393820), // Rule ID 53356 //
     /* 2393777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393780 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2393783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2393797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393819 */     // GIR_Coverage, 53356,
     /* 2393819 */     GIR_EraseRootFromParent_Done,
     /* 2393820 */   // Label 34245: @2393820
     /* 2393820 */   GIM_Try, /*On fail goto*//*Label 34246*/ GIMT_Encode4(2393868), // Rule ID 53357 //
     /* 2393825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393828 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2393831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2393845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393867 */     // GIR_Coverage, 53357,
     /* 2393867 */     GIR_EraseRootFromParent_Done,
     /* 2393868 */   // Label 34246: @2393868
     /* 2393868 */   GIM_Reject,
     /* 2393869 */ // Label 34244: @2393869
     /* 2393869 */ GIM_Reject,
     /* 2393870 */ // Label 34189: @2393870
     /* 2393870 */ GIM_Try, /*On fail goto*//*Label 34247*/ GIMT_Encode4(2393990),
     /* 2393875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2393878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2393881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2393893 */   GIM_Try, /*On fail goto*//*Label 34248*/ GIMT_Encode4(2393941), // Rule ID 53404 //
     /* 2393898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2393901 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2393901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2393904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2393918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393940 */     // GIR_Coverage, 53404,
     /* 2393940 */     GIR_EraseRootFromParent_Done,
     /* 2393941 */   // Label 34248: @2393941
     /* 2393941 */   GIM_Try, /*On fail goto*//*Label 34249*/ GIMT_Encode4(2393989), // Rule ID 53405 //
     /* 2393946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2393949 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2393949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2393952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2393956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2393961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2393963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2393966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2393971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2393975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2393987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393988 */     // GIR_Coverage, 53405,
     /* 2393988 */     GIR_EraseRootFromParent_Done,
     /* 2393989 */   // Label 34249: @2393989
     /* 2393989 */   GIM_Reject,
     /* 2393990 */ // Label 34247: @2393990
     /* 2393990 */ GIM_Reject,
     /* 2393991 */ // Label 34190: @2393991
     /* 2393991 */ GIM_Try, /*On fail goto*//*Label 34250*/ GIMT_Encode4(2394111),
     /* 2393996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2393999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2394002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2394014 */   GIM_Try, /*On fail goto*//*Label 34251*/ GIMT_Encode4(2394062), // Rule ID 53368 //
     /* 2394019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2394022 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2394025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2394039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394061 */     // GIR_Coverage, 53368,
     /* 2394061 */     GIR_EraseRootFromParent_Done,
     /* 2394062 */   // Label 34251: @2394062
     /* 2394062 */   GIM_Try, /*On fail goto*//*Label 34252*/ GIMT_Encode4(2394110), // Rule ID 53369 //
     /* 2394067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2394070 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2394073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2394087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394109 */     // GIR_Coverage, 53369,
     /* 2394109 */     GIR_EraseRootFromParent_Done,
     /* 2394110 */   // Label 34252: @2394110
     /* 2394110 */   GIM_Reject,
     /* 2394111 */ // Label 34250: @2394111
     /* 2394111 */ GIM_Reject,
     /* 2394112 */ // Label 34191: @2394112
     /* 2394112 */ GIM_Reject,
     /* 2394113 */ // Label 99: @2394113
     /* 2394113 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34271*/ GIMT_Encode4(2396540),
     /* 2394124 */ /*GILLT_s16*//*Label 34253*/ GIMT_Encode4(2394244),
     /* 2394128 */ /*GILLT_s32*//*Label 34254*/ GIMT_Encode4(2394393),
     /* 2394132 */ /*GILLT_s64*//*Label 34255*/ GIMT_Encode4(2394542), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394144 */ /*GILLT_nxv1s16*//*Label 34256*/ GIMT_Encode4(2394725),
     /* 2394148 */ /*GILLT_nxv1s32*//*Label 34257*/ GIMT_Encode4(2394846),
     /* 2394152 */ /*GILLT_nxv1s64*//*Label 34258*/ GIMT_Encode4(2394967), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394164 */ /*GILLT_nxv2s16*//*Label 34259*/ GIMT_Encode4(2395088),
     /* 2394168 */ /*GILLT_nxv2s32*//*Label 34260*/ GIMT_Encode4(2395209),
     /* 2394172 */ /*GILLT_nxv2s64*//*Label 34261*/ GIMT_Encode4(2395330), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394184 */ /*GILLT_nxv4s16*//*Label 34262*/ GIMT_Encode4(2395451),
     /* 2394188 */ /*GILLT_nxv4s32*//*Label 34263*/ GIMT_Encode4(2395572),
     /* 2394192 */ /*GILLT_nxv4s64*//*Label 34264*/ GIMT_Encode4(2395693), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394204 */ /*GILLT_nxv8s16*//*Label 34265*/ GIMT_Encode4(2395814),
     /* 2394208 */ /*GILLT_nxv8s32*//*Label 34266*/ GIMT_Encode4(2395935),
     /* 2394212 */ /*GILLT_nxv8s64*//*Label 34267*/ GIMT_Encode4(2396056), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394224 */ /*GILLT_nxv16s16*//*Label 34268*/ GIMT_Encode4(2396177),
     /* 2394228 */ /*GILLT_nxv16s32*//*Label 34269*/ GIMT_Encode4(2396298), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2394240 */ /*GILLT_nxv32s16*//*Label 34270*/ GIMT_Encode4(2396419),
     /* 2394244 */ // Label 34253: @2394244
     /* 2394244 */ GIM_Try, /*On fail goto*//*Label 34272*/ GIMT_Encode4(2394392),
     /* 2394249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2394252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2394255 */   GIM_Try, /*On fail goto*//*Label 34273*/ GIMT_Encode4(2394289), // Rule ID 1960 //
     /* 2394260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2394263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394275 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2394275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2394278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394288 */     // GIR_Coverage, 1960,
     /* 2394288 */     GIR_EraseRootFromParent_Done,
     /* 2394289 */   // Label 34273: @2394289
     /* 2394289 */   GIM_Try, /*On fail goto*//*Label 34274*/ GIMT_Encode4(2394323), // Rule ID 1961 //
     /* 2394294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2394297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2394309 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2394309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2394312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394322 */     // GIR_Coverage, 1961,
     /* 2394322 */     GIR_EraseRootFromParent_Done,
     /* 2394323 */   // Label 34274: @2394323
     /* 2394323 */   GIM_Try, /*On fail goto*//*Label 34275*/ GIMT_Encode4(2394357), // Rule ID 1964 //
     /* 2394328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2394331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394343 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2394343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2394346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394356 */     // GIR_Coverage, 1964,
     /* 2394356 */     GIR_EraseRootFromParent_Done,
     /* 2394357 */   // Label 34275: @2394357
     /* 2394357 */   GIM_Try, /*On fail goto*//*Label 34276*/ GIMT_Encode4(2394391), // Rule ID 1965 //
     /* 2394362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2394365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2394377 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2394377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2394380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394390 */     // GIR_Coverage, 1965,
     /* 2394390 */     GIR_EraseRootFromParent_Done,
     /* 2394391 */   // Label 34276: @2394391
     /* 2394391 */   GIM_Reject,
     /* 2394392 */ // Label 34272: @2394392
     /* 2394392 */ GIM_Reject,
     /* 2394393 */ // Label 34254: @2394393
     /* 2394393 */ GIM_Try, /*On fail goto*//*Label 34277*/ GIMT_Encode4(2394541),
     /* 2394398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2394401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2394404 */   GIM_Try, /*On fail goto*//*Label 34278*/ GIMT_Encode4(2394438), // Rule ID 1251 //
     /* 2394409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2394412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394424 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2394424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2394427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394437 */     // GIR_Coverage, 1251,
     /* 2394437 */     GIR_EraseRootFromParent_Done,
     /* 2394438 */   // Label 34278: @2394438
     /* 2394438 */   GIM_Try, /*On fail goto*//*Label 34279*/ GIMT_Encode4(2394472), // Rule ID 1252 //
     /* 2394443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2394446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2394458 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2394458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2394461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394471 */     // GIR_Coverage, 1252,
     /* 2394471 */     GIR_EraseRootFromParent_Done,
     /* 2394472 */   // Label 34279: @2394472
     /* 2394472 */   GIM_Try, /*On fail goto*//*Label 34280*/ GIMT_Encode4(2394506), // Rule ID 1255 //
     /* 2394477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2394480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394492 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2394492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2394495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394505 */     // GIR_Coverage, 1255,
     /* 2394505 */     GIR_EraseRootFromParent_Done,
     /* 2394506 */   // Label 34280: @2394506
     /* 2394506 */   GIM_Try, /*On fail goto*//*Label 34281*/ GIMT_Encode4(2394540), // Rule ID 1256 //
     /* 2394511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2394514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2394526 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2394526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2394529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394539 */     // GIR_Coverage, 1256,
     /* 2394539 */     GIR_EraseRootFromParent_Done,
     /* 2394540 */   // Label 34281: @2394540
     /* 2394540 */   GIM_Reject,
     /* 2394541 */ // Label 34277: @2394541
     /* 2394541 */ GIM_Reject,
     /* 2394542 */ // Label 34255: @2394542
     /* 2394542 */ GIM_Try, /*On fail goto*//*Label 34282*/ GIMT_Encode4(2394724),
     /* 2394547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2394550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2394553 */   GIM_Try, /*On fail goto*//*Label 34283*/ GIMT_Encode4(2394587), // Rule ID 1588 //
     /* 2394558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2394561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394573 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2394573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2394576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394586 */     // GIR_Coverage, 1588,
     /* 2394586 */     GIR_EraseRootFromParent_Done,
     /* 2394587 */   // Label 34283: @2394587
     /* 2394587 */   GIM_Try, /*On fail goto*//*Label 34284*/ GIMT_Encode4(2394621), // Rule ID 1589 //
     /* 2394592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2394595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2394607 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2394607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2394610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394620 */     // GIR_Coverage, 1589,
     /* 2394620 */     GIR_EraseRootFromParent_Done,
     /* 2394621 */   // Label 34284: @2394621
     /* 2394621 */   GIM_Try, /*On fail goto*//*Label 34285*/ GIMT_Encode4(2394655), // Rule ID 1592 //
     /* 2394626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2394629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394641 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2394641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2394644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394654 */     // GIR_Coverage, 1592,
     /* 2394654 */     GIR_EraseRootFromParent_Done,
     /* 2394655 */   // Label 34285: @2394655
     /* 2394655 */   GIM_Try, /*On fail goto*//*Label 34286*/ GIMT_Encode4(2394689), // Rule ID 1593 //
     /* 2394660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2394663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2394675 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2394675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2394678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394688 */     // GIR_Coverage, 1593,
     /* 2394688 */     GIR_EraseRootFromParent_Done,
     /* 2394689 */   // Label 34286: @2394689
     /* 2394689 */   GIM_Try, /*On fail goto*//*Label 34287*/ GIMT_Encode4(2394723), // Rule ID 1596 //
     /* 2394694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2394697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2394709 */     // (strict_fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2394709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2394712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394722 */     // GIR_Coverage, 1596,
     /* 2394722 */     GIR_EraseRootFromParent_Done,
     /* 2394723 */   // Label 34287: @2394723
     /* 2394723 */   GIM_Reject,
     /* 2394724 */ // Label 34282: @2394724
     /* 2394724 */ GIM_Reject,
     /* 2394725 */ // Label 34256: @2394725
     /* 2394725 */ GIM_Try, /*On fail goto*//*Label 34288*/ GIMT_Encode4(2394845),
     /* 2394730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2394733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2394736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394748 */   GIM_Try, /*On fail goto*//*Label 34289*/ GIMT_Encode4(2394796), // Rule ID 53452 //
     /* 2394753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2394756 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2394759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2394773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394795 */     // GIR_Coverage, 53452,
     /* 2394795 */     GIR_EraseRootFromParent_Done,
     /* 2394796 */   // Label 34289: @2394796
     /* 2394796 */   GIM_Try, /*On fail goto*//*Label 34290*/ GIMT_Encode4(2394844), // Rule ID 53453 //
     /* 2394801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2394804 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2394807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2394821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2394839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394843 */     // GIR_Coverage, 53453,
     /* 2394843 */     GIR_EraseRootFromParent_Done,
     /* 2394844 */   // Label 34290: @2394844
     /* 2394844 */   GIM_Reject,
     /* 2394845 */ // Label 34288: @2394845
     /* 2394845 */ GIM_Reject,
     /* 2394846 */ // Label 34257: @2394846
     /* 2394846 */ GIM_Try, /*On fail goto*//*Label 34291*/ GIMT_Encode4(2394966),
     /* 2394851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2394854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2394857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394869 */   GIM_Try, /*On fail goto*//*Label 34292*/ GIMT_Encode4(2394917), // Rule ID 53476 //
     /* 2394874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2394877 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2394880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2394894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394916 */     // GIR_Coverage, 53476,
     /* 2394916 */     GIR_EraseRootFromParent_Done,
     /* 2394917 */   // Label 34292: @2394917
     /* 2394917 */   GIM_Try, /*On fail goto*//*Label 34293*/ GIMT_Encode4(2394965), // Rule ID 53477 //
     /* 2394922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2394925 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2394925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2394928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2394932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2394937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2394939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2394942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2394947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2394951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2394963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394964 */     // GIR_Coverage, 53477,
     /* 2394964 */     GIR_EraseRootFromParent_Done,
     /* 2394965 */   // Label 34293: @2394965
     /* 2394965 */   GIM_Reject,
     /* 2394966 */ // Label 34291: @2394966
     /* 2394966 */ GIM_Reject,
     /* 2394967 */ // Label 34258: @2394967
     /* 2394967 */ GIM_Try, /*On fail goto*//*Label 34294*/ GIMT_Encode4(2395087),
     /* 2394972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2394975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2394978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394990 */   GIM_Try, /*On fail goto*//*Label 34295*/ GIMT_Encode4(2395038), // Rule ID 53512 //
     /* 2394995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2394998 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2394998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2395001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2395015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395037 */     // GIR_Coverage, 53512,
     /* 2395037 */     GIR_EraseRootFromParent_Done,
     /* 2395038 */   // Label 34295: @2395038
     /* 2395038 */   GIM_Try, /*On fail goto*//*Label 34296*/ GIMT_Encode4(2395086), // Rule ID 53513 //
     /* 2395043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395046 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2395049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2395063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395085 */     // GIR_Coverage, 53513,
     /* 2395085 */     GIR_EraseRootFromParent_Done,
     /* 2395086 */   // Label 34296: @2395086
     /* 2395086 */   GIM_Reject,
     /* 2395087 */ // Label 34294: @2395087
     /* 2395087 */ GIM_Reject,
     /* 2395088 */ // Label 34259: @2395088
     /* 2395088 */ GIM_Try, /*On fail goto*//*Label 34297*/ GIMT_Encode4(2395208),
     /* 2395093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2395096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2395099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395107 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395111 */   GIM_Try, /*On fail goto*//*Label 34298*/ GIMT_Encode4(2395159), // Rule ID 53464 //
     /* 2395116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395119 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2395122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2395136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395158 */     // GIR_Coverage, 53464,
     /* 2395158 */     GIR_EraseRootFromParent_Done,
     /* 2395159 */   // Label 34298: @2395159
     /* 2395159 */   GIM_Try, /*On fail goto*//*Label 34299*/ GIMT_Encode4(2395207), // Rule ID 53465 //
     /* 2395164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395167 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2395170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2395184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395206 */     // GIR_Coverage, 53465,
     /* 2395206 */     GIR_EraseRootFromParent_Done,
     /* 2395207 */   // Label 34299: @2395207
     /* 2395207 */   GIM_Reject,
     /* 2395208 */ // Label 34297: @2395208
     /* 2395208 */ GIM_Reject,
     /* 2395209 */ // Label 34260: @2395209
     /* 2395209 */ GIM_Try, /*On fail goto*//*Label 34300*/ GIMT_Encode4(2395329),
     /* 2395214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2395217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2395220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395232 */   GIM_Try, /*On fail goto*//*Label 34301*/ GIMT_Encode4(2395280), // Rule ID 53500 //
     /* 2395237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395240 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2395243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2395257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395279 */     // GIR_Coverage, 53500,
     /* 2395279 */     GIR_EraseRootFromParent_Done,
     /* 2395280 */   // Label 34301: @2395280
     /* 2395280 */   GIM_Try, /*On fail goto*//*Label 34302*/ GIMT_Encode4(2395328), // Rule ID 53501 //
     /* 2395285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395288 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2395291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2395305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395327 */     // GIR_Coverage, 53501,
     /* 2395327 */     GIR_EraseRootFromParent_Done,
     /* 2395328 */   // Label 34302: @2395328
     /* 2395328 */   GIM_Reject,
     /* 2395329 */ // Label 34300: @2395329
     /* 2395329 */ GIM_Reject,
     /* 2395330 */ // Label 34261: @2395330
     /* 2395330 */ GIM_Try, /*On fail goto*//*Label 34303*/ GIMT_Encode4(2395450),
     /* 2395335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2395338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2395341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395353 */   GIM_Try, /*On fail goto*//*Label 34304*/ GIMT_Encode4(2395401), // Rule ID 53596 //
     /* 2395358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395361 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2395364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2395378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395400 */     // GIR_Coverage, 53596,
     /* 2395400 */     GIR_EraseRootFromParent_Done,
     /* 2395401 */   // Label 34304: @2395401
     /* 2395401 */   GIM_Try, /*On fail goto*//*Label 34305*/ GIMT_Encode4(2395449), // Rule ID 53597 //
     /* 2395406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395409 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2395412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2395426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395448 */     // GIR_Coverage, 53597,
     /* 2395448 */     GIR_EraseRootFromParent_Done,
     /* 2395449 */   // Label 34305: @2395449
     /* 2395449 */   GIM_Reject,
     /* 2395450 */ // Label 34303: @2395450
     /* 2395450 */ GIM_Reject,
     /* 2395451 */ // Label 34262: @2395451
     /* 2395451 */ GIM_Try, /*On fail goto*//*Label 34306*/ GIMT_Encode4(2395571),
     /* 2395456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2395462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395474 */   GIM_Try, /*On fail goto*//*Label 34307*/ GIMT_Encode4(2395522), // Rule ID 53488 //
     /* 2395479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395482 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2395485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2395499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395521 */     // GIR_Coverage, 53488,
     /* 2395521 */     GIR_EraseRootFromParent_Done,
     /* 2395522 */   // Label 34307: @2395522
     /* 2395522 */   GIM_Try, /*On fail goto*//*Label 34308*/ GIMT_Encode4(2395570), // Rule ID 53489 //
     /* 2395527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395530 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2395533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2395547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395569 */     // GIR_Coverage, 53489,
     /* 2395569 */     GIR_EraseRootFromParent_Done,
     /* 2395570 */   // Label 34308: @2395570
     /* 2395570 */   GIM_Reject,
     /* 2395571 */ // Label 34306: @2395571
     /* 2395571 */ GIM_Reject,
     /* 2395572 */ // Label 34263: @2395572
     /* 2395572 */ GIM_Try, /*On fail goto*//*Label 34309*/ GIMT_Encode4(2395692),
     /* 2395577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2395580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2395583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395595 */   GIM_Try, /*On fail goto*//*Label 34310*/ GIMT_Encode4(2395643), // Rule ID 53560 //
     /* 2395600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395603 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2395606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2395620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395642 */     // GIR_Coverage, 53560,
     /* 2395642 */     GIR_EraseRootFromParent_Done,
     /* 2395643 */   // Label 34310: @2395643
     /* 2395643 */   GIM_Try, /*On fail goto*//*Label 34311*/ GIMT_Encode4(2395691), // Rule ID 53561 //
     /* 2395648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2395651 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2395654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2395668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2395686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395690 */     // GIR_Coverage, 53561,
     /* 2395690 */     GIR_EraseRootFromParent_Done,
     /* 2395691 */   // Label 34311: @2395691
     /* 2395691 */   GIM_Reject,
     /* 2395692 */ // Label 34309: @2395692
     /* 2395692 */ GIM_Reject,
     /* 2395693 */ // Label 34264: @2395693
     /* 2395693 */ GIM_Try, /*On fail goto*//*Label 34312*/ GIMT_Encode4(2395813),
     /* 2395698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2395701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2395704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395716 */   GIM_Try, /*On fail goto*//*Label 34313*/ GIMT_Encode4(2395764), // Rule ID 53608 //
     /* 2395721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395724 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2395727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2395741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395763 */     // GIR_Coverage, 53608,
     /* 2395763 */     GIR_EraseRootFromParent_Done,
     /* 2395764 */   // Label 34313: @2395764
     /* 2395764 */   GIM_Try, /*On fail goto*//*Label 34314*/ GIMT_Encode4(2395812), // Rule ID 53609 //
     /* 2395769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395772 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2395775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2395789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395811 */     // GIR_Coverage, 53609,
     /* 2395811 */     GIR_EraseRootFromParent_Done,
     /* 2395812 */   // Label 34314: @2395812
     /* 2395812 */   GIM_Reject,
     /* 2395813 */ // Label 34312: @2395813
     /* 2395813 */ GIM_Reject,
     /* 2395814 */ // Label 34265: @2395814
     /* 2395814 */ GIM_Try, /*On fail goto*//*Label 34315*/ GIMT_Encode4(2395934),
     /* 2395819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2395822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2395825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395833 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395837 */   GIM_Try, /*On fail goto*//*Label 34316*/ GIMT_Encode4(2395885), // Rule ID 53524 //
     /* 2395842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395845 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2395848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2395862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395884 */     // GIR_Coverage, 53524,
     /* 2395884 */     GIR_EraseRootFromParent_Done,
     /* 2395885 */   // Label 34316: @2395885
     /* 2395885 */   GIM_Try, /*On fail goto*//*Label 34317*/ GIMT_Encode4(2395933), // Rule ID 53525 //
     /* 2395890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395893 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2395893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2395896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2395910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2395931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395932 */     // GIR_Coverage, 53525,
     /* 2395932 */     GIR_EraseRootFromParent_Done,
     /* 2395933 */   // Label 34317: @2395933
     /* 2395933 */   GIM_Reject,
     /* 2395934 */ // Label 34315: @2395934
     /* 2395934 */ GIM_Reject,
     /* 2395935 */ // Label 34266: @2395935
     /* 2395935 */ GIM_Try, /*On fail goto*//*Label 34318*/ GIMT_Encode4(2396055),
     /* 2395940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2395943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2395946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2395958 */   GIM_Try, /*On fail goto*//*Label 34319*/ GIMT_Encode4(2396006), // Rule ID 53572 //
     /* 2395963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2395966 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2395966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2395969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2395973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2395978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2395980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2395983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2395988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2395992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396005 */     // GIR_Coverage, 53572,
     /* 2396005 */     GIR_EraseRootFromParent_Done,
     /* 2396006 */   // Label 34319: @2396006
     /* 2396006 */   GIM_Try, /*On fail goto*//*Label 34320*/ GIMT_Encode4(2396054), // Rule ID 53573 //
     /* 2396011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396014 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2396017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2396031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396053 */     // GIR_Coverage, 53573,
     /* 2396053 */     GIR_EraseRootFromParent_Done,
     /* 2396054 */   // Label 34320: @2396054
     /* 2396054 */   GIM_Reject,
     /* 2396055 */ // Label 34318: @2396055
     /* 2396055 */ GIM_Reject,
     /* 2396056 */ // Label 34267: @2396056
     /* 2396056 */ GIM_Try, /*On fail goto*//*Label 34321*/ GIMT_Encode4(2396176),
     /* 2396061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2396064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2396067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396079 */   GIM_Try, /*On fail goto*//*Label 34322*/ GIMT_Encode4(2396127), // Rule ID 53620 //
     /* 2396084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396087 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2396090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2396104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396126 */     // GIR_Coverage, 53620,
     /* 2396126 */     GIR_EraseRootFromParent_Done,
     /* 2396127 */   // Label 34322: @2396127
     /* 2396127 */   GIM_Try, /*On fail goto*//*Label 34323*/ GIMT_Encode4(2396175), // Rule ID 53621 //
     /* 2396132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2396135 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2396138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2396152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2396170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396174 */     // GIR_Coverage, 53621,
     /* 2396174 */     GIR_EraseRootFromParent_Done,
     /* 2396175 */   // Label 34323: @2396175
     /* 2396175 */   GIM_Reject,
     /* 2396176 */ // Label 34321: @2396176
     /* 2396176 */ GIM_Reject,
     /* 2396177 */ // Label 34268: @2396177
     /* 2396177 */ GIM_Try, /*On fail goto*//*Label 34324*/ GIMT_Encode4(2396297),
     /* 2396182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2396185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2396188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396200 */   GIM_Try, /*On fail goto*//*Label 34325*/ GIMT_Encode4(2396248), // Rule ID 53536 //
     /* 2396205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396208 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2396225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396247 */     // GIR_Coverage, 53536,
     /* 2396247 */     GIR_EraseRootFromParent_Done,
     /* 2396248 */   // Label 34325: @2396248
     /* 2396248 */   GIM_Try, /*On fail goto*//*Label 34326*/ GIMT_Encode4(2396296), // Rule ID 53537 //
     /* 2396253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396256 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2396259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2396273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396295 */     // GIR_Coverage, 53537,
     /* 2396295 */     GIR_EraseRootFromParent_Done,
     /* 2396296 */   // Label 34326: @2396296
     /* 2396296 */   GIM_Reject,
     /* 2396297 */ // Label 34324: @2396297
     /* 2396297 */ GIM_Reject,
     /* 2396298 */ // Label 34269: @2396298
     /* 2396298 */ GIM_Try, /*On fail goto*//*Label 34327*/ GIMT_Encode4(2396418),
     /* 2396303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2396306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2396309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396321 */   GIM_Try, /*On fail goto*//*Label 34328*/ GIMT_Encode4(2396369), // Rule ID 53584 //
     /* 2396326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396329 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2396332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2396346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396368 */     // GIR_Coverage, 53584,
     /* 2396368 */     GIR_EraseRootFromParent_Done,
     /* 2396369 */   // Label 34328: @2396369
     /* 2396369 */   GIM_Try, /*On fail goto*//*Label 34329*/ GIMT_Encode4(2396417), // Rule ID 53585 //
     /* 2396374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396377 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2396380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2396394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396416 */     // GIR_Coverage, 53585,
     /* 2396416 */     GIR_EraseRootFromParent_Done,
     /* 2396417 */   // Label 34329: @2396417
     /* 2396417 */   GIM_Reject,
     /* 2396418 */ // Label 34327: @2396418
     /* 2396418 */ GIM_Reject,
     /* 2396419 */ // Label 34270: @2396419
     /* 2396419 */ GIM_Try, /*On fail goto*//*Label 34330*/ GIMT_Encode4(2396539),
     /* 2396424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2396427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2396430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2396442 */   GIM_Try, /*On fail goto*//*Label 34331*/ GIMT_Encode4(2396490), // Rule ID 53548 //
     /* 2396447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396450 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2396450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2396453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2396467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396489 */     // GIR_Coverage, 53548,
     /* 2396489 */     GIR_EraseRootFromParent_Done,
     /* 2396490 */   // Label 34331: @2396490
     /* 2396490 */   GIM_Try, /*On fail goto*//*Label 34332*/ GIMT_Encode4(2396538), // Rule ID 53549 //
     /* 2396495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396498 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2396498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2396501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2396505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2396510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2396512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2396515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2396520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2396536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396537 */     // GIR_Coverage, 53549,
     /* 2396537 */     GIR_EraseRootFromParent_Done,
     /* 2396538 */   // Label 34332: @2396538
     /* 2396538 */   GIM_Reject,
     /* 2396539 */ // Label 34330: @2396539
     /* 2396539 */ GIM_Reject,
     /* 2396540 */ // Label 34271: @2396540
     /* 2396540 */ GIM_Reject,
     /* 2396541 */ // Label 100: @2396541
     /* 2396541 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34351*/ GIMT_Encode4(2398968),
     /* 2396552 */ /*GILLT_s16*//*Label 34333*/ GIMT_Encode4(2396672),
     /* 2396556 */ /*GILLT_s32*//*Label 34334*/ GIMT_Encode4(2396821),
     /* 2396560 */ /*GILLT_s64*//*Label 34335*/ GIMT_Encode4(2396970), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396572 */ /*GILLT_nxv1s16*//*Label 34336*/ GIMT_Encode4(2397153),
     /* 2396576 */ /*GILLT_nxv1s32*//*Label 34337*/ GIMT_Encode4(2397274),
     /* 2396580 */ /*GILLT_nxv1s64*//*Label 34338*/ GIMT_Encode4(2397395), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396592 */ /*GILLT_nxv2s16*//*Label 34339*/ GIMT_Encode4(2397516),
     /* 2396596 */ /*GILLT_nxv2s32*//*Label 34340*/ GIMT_Encode4(2397637),
     /* 2396600 */ /*GILLT_nxv2s64*//*Label 34341*/ GIMT_Encode4(2397758), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396612 */ /*GILLT_nxv4s16*//*Label 34342*/ GIMT_Encode4(2397879),
     /* 2396616 */ /*GILLT_nxv4s32*//*Label 34343*/ GIMT_Encode4(2398000),
     /* 2396620 */ /*GILLT_nxv4s64*//*Label 34344*/ GIMT_Encode4(2398121), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396632 */ /*GILLT_nxv8s16*//*Label 34345*/ GIMT_Encode4(2398242),
     /* 2396636 */ /*GILLT_nxv8s32*//*Label 34346*/ GIMT_Encode4(2398363),
     /* 2396640 */ /*GILLT_nxv8s64*//*Label 34347*/ GIMT_Encode4(2398484), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396652 */ /*GILLT_nxv16s16*//*Label 34348*/ GIMT_Encode4(2398605),
     /* 2396656 */ /*GILLT_nxv16s32*//*Label 34349*/ GIMT_Encode4(2398726), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2396668 */ /*GILLT_nxv32s16*//*Label 34350*/ GIMT_Encode4(2398847),
     /* 2396672 */ // Label 34333: @2396672
     /* 2396672 */ GIM_Try, /*On fail goto*//*Label 34352*/ GIMT_Encode4(2396820),
     /* 2396677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2396680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2396683 */   GIM_Try, /*On fail goto*//*Label 34353*/ GIMT_Encode4(2396717), // Rule ID 1968 //
     /* 2396688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2396691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396703 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2396703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2396706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396716 */     // GIR_Coverage, 1968,
     /* 2396716 */     GIR_EraseRootFromParent_Done,
     /* 2396717 */   // Label 34353: @2396717
     /* 2396717 */   GIM_Try, /*On fail goto*//*Label 34354*/ GIMT_Encode4(2396751), // Rule ID 1969 //
     /* 2396722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2396725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2396737 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2396737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2396740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396750 */     // GIR_Coverage, 1969,
     /* 2396750 */     GIR_EraseRootFromParent_Done,
     /* 2396751 */   // Label 34354: @2396751
     /* 2396751 */   GIM_Try, /*On fail goto*//*Label 34355*/ GIMT_Encode4(2396785), // Rule ID 1972 //
     /* 2396756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2396759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396771 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2396771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2396774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396784 */     // GIR_Coverage, 1972,
     /* 2396784 */     GIR_EraseRootFromParent_Done,
     /* 2396785 */   // Label 34355: @2396785
     /* 2396785 */   GIM_Try, /*On fail goto*//*Label 34356*/ GIMT_Encode4(2396819), // Rule ID 1973 //
     /* 2396790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2396793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2396805 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2396805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2396808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396818 */     // GIR_Coverage, 1973,
     /* 2396818 */     GIR_EraseRootFromParent_Done,
     /* 2396819 */   // Label 34356: @2396819
     /* 2396819 */   GIM_Reject,
     /* 2396820 */ // Label 34352: @2396820
     /* 2396820 */ GIM_Reject,
     /* 2396821 */ // Label 34334: @2396821
     /* 2396821 */ GIM_Try, /*On fail goto*//*Label 34357*/ GIMT_Encode4(2396969),
     /* 2396826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2396829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2396832 */   GIM_Try, /*On fail goto*//*Label 34358*/ GIMT_Encode4(2396866), // Rule ID 1259 //
     /* 2396837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2396840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396852 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2396852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2396855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396865 */     // GIR_Coverage, 1259,
     /* 2396865 */     GIR_EraseRootFromParent_Done,
     /* 2396866 */   // Label 34358: @2396866
     /* 2396866 */   GIM_Try, /*On fail goto*//*Label 34359*/ GIMT_Encode4(2396900), // Rule ID 1260 //
     /* 2396871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2396874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2396886 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2396886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2396889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396899 */     // GIR_Coverage, 1260,
     /* 2396899 */     GIR_EraseRootFromParent_Done,
     /* 2396900 */   // Label 34359: @2396900
     /* 2396900 */   GIM_Try, /*On fail goto*//*Label 34360*/ GIMT_Encode4(2396934), // Rule ID 1263 //
     /* 2396905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2396908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396920 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2396920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2396923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396933 */     // GIR_Coverage, 1263,
     /* 2396933 */     GIR_EraseRootFromParent_Done,
     /* 2396934 */   // Label 34360: @2396934
     /* 2396934 */   GIM_Try, /*On fail goto*//*Label 34361*/ GIMT_Encode4(2396968), // Rule ID 1264 //
     /* 2396939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2396942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2396954 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2396954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2396957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2396963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396967 */     // GIR_Coverage, 1264,
     /* 2396967 */     GIR_EraseRootFromParent_Done,
     /* 2396968 */   // Label 34361: @2396968
     /* 2396968 */   GIM_Reject,
     /* 2396969 */ // Label 34357: @2396969
     /* 2396969 */ GIM_Reject,
     /* 2396970 */ // Label 34335: @2396970
     /* 2396970 */ GIM_Try, /*On fail goto*//*Label 34362*/ GIMT_Encode4(2397152),
     /* 2396975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2396978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2396981 */   GIM_Try, /*On fail goto*//*Label 34363*/ GIMT_Encode4(2397015), // Rule ID 1598 //
     /* 2396986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2396989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2396993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2396997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397001 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2397001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2397004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397014 */     // GIR_Coverage, 1598,
     /* 2397014 */     GIR_EraseRootFromParent_Done,
     /* 2397015 */   // Label 34363: @2397015
     /* 2397015 */   GIM_Try, /*On fail goto*//*Label 34364*/ GIMT_Encode4(2397049), // Rule ID 1599 //
     /* 2397020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2397023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2397035 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2397035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2397038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397048 */     // GIR_Coverage, 1599,
     /* 2397048 */     GIR_EraseRootFromParent_Done,
     /* 2397049 */   // Label 34364: @2397049
     /* 2397049 */   GIM_Try, /*On fail goto*//*Label 34365*/ GIMT_Encode4(2397083), // Rule ID 1602 //
     /* 2397054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2397057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397069 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2397069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2397072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397082 */     // GIR_Coverage, 1602,
     /* 2397082 */     GIR_EraseRootFromParent_Done,
     /* 2397083 */   // Label 34365: @2397083
     /* 2397083 */   GIM_Try, /*On fail goto*//*Label 34366*/ GIMT_Encode4(2397117), // Rule ID 1603 //
     /* 2397088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2397091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2397103 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2397103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2397106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397116 */     // GIR_Coverage, 1603,
     /* 2397116 */     GIR_EraseRootFromParent_Done,
     /* 2397117 */   // Label 34366: @2397117
     /* 2397117 */   GIM_Try, /*On fail goto*//*Label 34367*/ GIMT_Encode4(2397151), // Rule ID 1606 //
     /* 2397122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2397125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2397129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2397133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2397137 */     // (strict_fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2397137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2397140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397150 */     // GIR_Coverage, 1606,
     /* 2397150 */     GIR_EraseRootFromParent_Done,
     /* 2397151 */   // Label 34367: @2397151
     /* 2397151 */   GIM_Reject,
     /* 2397152 */ // Label 34362: @2397152
     /* 2397152 */ GIM_Reject,
     /* 2397153 */ // Label 34336: @2397153
     /* 2397153 */ GIM_Try, /*On fail goto*//*Label 34368*/ GIMT_Encode4(2397273),
     /* 2397158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2397161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2397164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397176 */   GIM_Try, /*On fail goto*//*Label 34369*/ GIMT_Encode4(2397224), // Rule ID 54220 //
     /* 2397181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397184 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2397187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2397201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397223 */     // GIR_Coverage, 54220,
     /* 2397223 */     GIR_EraseRootFromParent_Done,
     /* 2397224 */   // Label 34369: @2397224
     /* 2397224 */   GIM_Try, /*On fail goto*//*Label 34370*/ GIMT_Encode4(2397272), // Rule ID 54221 //
     /* 2397229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397232 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2397235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2397249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397271 */     // GIR_Coverage, 54221,
     /* 2397271 */     GIR_EraseRootFromParent_Done,
     /* 2397272 */   // Label 34370: @2397272
     /* 2397272 */   GIM_Reject,
     /* 2397273 */ // Label 34368: @2397273
     /* 2397273 */ GIM_Reject,
     /* 2397274 */ // Label 34337: @2397274
     /* 2397274 */ GIM_Try, /*On fail goto*//*Label 34371*/ GIMT_Encode4(2397394),
     /* 2397279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2397282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2397285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397297 */   GIM_Try, /*On fail goto*//*Label 34372*/ GIMT_Encode4(2397345), // Rule ID 54244 //
     /* 2397302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2397305 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2397308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2397322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397344 */     // GIR_Coverage, 54244,
     /* 2397344 */     GIR_EraseRootFromParent_Done,
     /* 2397345 */   // Label 34372: @2397345
     /* 2397345 */   GIM_Try, /*On fail goto*//*Label 34373*/ GIMT_Encode4(2397393), // Rule ID 54245 //
     /* 2397350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2397353 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2397356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2397370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397392 */     // GIR_Coverage, 54245,
     /* 2397392 */     GIR_EraseRootFromParent_Done,
     /* 2397393 */   // Label 34373: @2397393
     /* 2397393 */   GIM_Reject,
     /* 2397394 */ // Label 34371: @2397394
     /* 2397394 */ GIM_Reject,
     /* 2397395 */ // Label 34338: @2397395
     /* 2397395 */ GIM_Try, /*On fail goto*//*Label 34374*/ GIMT_Encode4(2397515),
     /* 2397400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2397403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2397406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397418 */   GIM_Try, /*On fail goto*//*Label 34375*/ GIMT_Encode4(2397466), // Rule ID 54280 //
     /* 2397423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397426 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2397429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2397443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397465 */     // GIR_Coverage, 54280,
     /* 2397465 */     GIR_EraseRootFromParent_Done,
     /* 2397466 */   // Label 34375: @2397466
     /* 2397466 */   GIM_Try, /*On fail goto*//*Label 34376*/ GIMT_Encode4(2397514), // Rule ID 54281 //
     /* 2397471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397474 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2397477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2397491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397513 */     // GIR_Coverage, 54281,
     /* 2397513 */     GIR_EraseRootFromParent_Done,
     /* 2397514 */   // Label 34376: @2397514
     /* 2397514 */   GIM_Reject,
     /* 2397515 */ // Label 34374: @2397515
     /* 2397515 */ GIM_Reject,
     /* 2397516 */ // Label 34339: @2397516
     /* 2397516 */ GIM_Try, /*On fail goto*//*Label 34377*/ GIMT_Encode4(2397636),
     /* 2397521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2397524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2397527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397539 */   GIM_Try, /*On fail goto*//*Label 34378*/ GIMT_Encode4(2397587), // Rule ID 54232 //
     /* 2397544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397547 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2397550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2397564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397586 */     // GIR_Coverage, 54232,
     /* 2397586 */     GIR_EraseRootFromParent_Done,
     /* 2397587 */   // Label 34378: @2397587
     /* 2397587 */   GIM_Try, /*On fail goto*//*Label 34379*/ GIMT_Encode4(2397635), // Rule ID 54233 //
     /* 2397592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397595 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2397598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2397612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397634 */     // GIR_Coverage, 54233,
     /* 2397634 */     GIR_EraseRootFromParent_Done,
     /* 2397635 */   // Label 34379: @2397635
     /* 2397635 */   GIM_Reject,
     /* 2397636 */ // Label 34377: @2397636
     /* 2397636 */ GIM_Reject,
     /* 2397637 */ // Label 34340: @2397637
     /* 2397637 */ GIM_Try, /*On fail goto*//*Label 34380*/ GIMT_Encode4(2397757),
     /* 2397642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2397645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2397648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397660 */   GIM_Try, /*On fail goto*//*Label 34381*/ GIMT_Encode4(2397708), // Rule ID 54268 //
     /* 2397665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2397668 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2397671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2397685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397707 */     // GIR_Coverage, 54268,
     /* 2397707 */     GIR_EraseRootFromParent_Done,
     /* 2397708 */   // Label 34381: @2397708
     /* 2397708 */   GIM_Try, /*On fail goto*//*Label 34382*/ GIMT_Encode4(2397756), // Rule ID 54269 //
     /* 2397713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2397716 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2397719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2397733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2397751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397755 */     // GIR_Coverage, 54269,
     /* 2397755 */     GIR_EraseRootFromParent_Done,
     /* 2397756 */   // Label 34382: @2397756
     /* 2397756 */   GIM_Reject,
     /* 2397757 */ // Label 34380: @2397757
     /* 2397757 */ GIM_Reject,
     /* 2397758 */ // Label 34341: @2397758
     /* 2397758 */ GIM_Try, /*On fail goto*//*Label 34383*/ GIMT_Encode4(2397878),
     /* 2397763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2397766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2397769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397781 */   GIM_Try, /*On fail goto*//*Label 34384*/ GIMT_Encode4(2397829), // Rule ID 54364 //
     /* 2397786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397789 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2397792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2397806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397828 */     // GIR_Coverage, 54364,
     /* 2397828 */     GIR_EraseRootFromParent_Done,
     /* 2397829 */   // Label 34384: @2397829
     /* 2397829 */   GIM_Try, /*On fail goto*//*Label 34385*/ GIMT_Encode4(2397877), // Rule ID 54365 //
     /* 2397834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397837 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2397840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2397854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397876 */     // GIR_Coverage, 54365,
     /* 2397876 */     GIR_EraseRootFromParent_Done,
     /* 2397877 */   // Label 34385: @2397877
     /* 2397877 */   GIM_Reject,
     /* 2397878 */ // Label 34383: @2397878
     /* 2397878 */ GIM_Reject,
     /* 2397879 */ // Label 34342: @2397879
     /* 2397879 */ GIM_Try, /*On fail goto*//*Label 34386*/ GIMT_Encode4(2397999),
     /* 2397884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2397887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2397890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397898 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2397902 */   GIM_Try, /*On fail goto*//*Label 34387*/ GIMT_Encode4(2397950), // Rule ID 54256 //
     /* 2397907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397910 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2397910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2397913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2397927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397949 */     // GIR_Coverage, 54256,
     /* 2397949 */     GIR_EraseRootFromParent_Done,
     /* 2397950 */   // Label 34387: @2397950
     /* 2397950 */   GIM_Try, /*On fail goto*//*Label 34388*/ GIMT_Encode4(2397998), // Rule ID 54257 //
     /* 2397955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397958 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2397958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2397961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2397965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2397970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2397972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2397975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2397980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2397984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2397996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397997 */     // GIR_Coverage, 54257,
     /* 2397997 */     GIR_EraseRootFromParent_Done,
     /* 2397998 */   // Label 34388: @2397998
     /* 2397998 */   GIM_Reject,
     /* 2397999 */ // Label 34386: @2397999
     /* 2397999 */ GIM_Reject,
     /* 2398000 */ // Label 34343: @2398000
     /* 2398000 */ GIM_Try, /*On fail goto*//*Label 34389*/ GIMT_Encode4(2398120),
     /* 2398005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2398008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2398011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398019 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398023 */   GIM_Try, /*On fail goto*//*Label 34390*/ GIMT_Encode4(2398071), // Rule ID 54328 //
     /* 2398028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398031 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2398034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2398048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398070 */     // GIR_Coverage, 54328,
     /* 2398070 */     GIR_EraseRootFromParent_Done,
     /* 2398071 */   // Label 34390: @2398071
     /* 2398071 */   GIM_Try, /*On fail goto*//*Label 34391*/ GIMT_Encode4(2398119), // Rule ID 54329 //
     /* 2398076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398079 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2398082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2398096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398118 */     // GIR_Coverage, 54329,
     /* 2398118 */     GIR_EraseRootFromParent_Done,
     /* 2398119 */   // Label 34391: @2398119
     /* 2398119 */   GIM_Reject,
     /* 2398120 */ // Label 34389: @2398120
     /* 2398120 */ GIM_Reject,
     /* 2398121 */ // Label 34344: @2398121
     /* 2398121 */ GIM_Try, /*On fail goto*//*Label 34392*/ GIMT_Encode4(2398241),
     /* 2398126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2398129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2398132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398144 */   GIM_Try, /*On fail goto*//*Label 34393*/ GIMT_Encode4(2398192), // Rule ID 54376 //
     /* 2398149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2398152 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2398155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2398169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398191 */     // GIR_Coverage, 54376,
     /* 2398191 */     GIR_EraseRootFromParent_Done,
     /* 2398192 */   // Label 34393: @2398192
     /* 2398192 */   GIM_Try, /*On fail goto*//*Label 34394*/ GIMT_Encode4(2398240), // Rule ID 54377 //
     /* 2398197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2398200 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2398203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2398217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398239 */     // GIR_Coverage, 54377,
     /* 2398239 */     GIR_EraseRootFromParent_Done,
     /* 2398240 */   // Label 34394: @2398240
     /* 2398240 */   GIM_Reject,
     /* 2398241 */ // Label 34392: @2398241
     /* 2398241 */ GIM_Reject,
     /* 2398242 */ // Label 34345: @2398242
     /* 2398242 */ GIM_Try, /*On fail goto*//*Label 34395*/ GIMT_Encode4(2398362),
     /* 2398247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2398253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398265 */   GIM_Try, /*On fail goto*//*Label 34396*/ GIMT_Encode4(2398313), // Rule ID 54292 //
     /* 2398270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398273 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2398276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2398290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398312 */     // GIR_Coverage, 54292,
     /* 2398312 */     GIR_EraseRootFromParent_Done,
     /* 2398313 */   // Label 34396: @2398313
     /* 2398313 */   GIM_Try, /*On fail goto*//*Label 34397*/ GIMT_Encode4(2398361), // Rule ID 54293 //
     /* 2398318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398321 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2398324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2398338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398360 */     // GIR_Coverage, 54293,
     /* 2398360 */     GIR_EraseRootFromParent_Done,
     /* 2398361 */   // Label 34397: @2398361
     /* 2398361 */   GIM_Reject,
     /* 2398362 */ // Label 34395: @2398362
     /* 2398362 */ GIM_Reject,
     /* 2398363 */ // Label 34346: @2398363
     /* 2398363 */ GIM_Try, /*On fail goto*//*Label 34398*/ GIMT_Encode4(2398483),
     /* 2398368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2398374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398386 */   GIM_Try, /*On fail goto*//*Label 34399*/ GIMT_Encode4(2398434), // Rule ID 54340 //
     /* 2398391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398394 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2398397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2398411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398433 */     // GIR_Coverage, 54340,
     /* 2398433 */     GIR_EraseRootFromParent_Done,
     /* 2398434 */   // Label 34399: @2398434
     /* 2398434 */   GIM_Try, /*On fail goto*//*Label 34400*/ GIMT_Encode4(2398482), // Rule ID 54341 //
     /* 2398439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398442 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2398445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2398459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398481 */     // GIR_Coverage, 54341,
     /* 2398481 */     GIR_EraseRootFromParent_Done,
     /* 2398482 */   // Label 34400: @2398482
     /* 2398482 */   GIM_Reject,
     /* 2398483 */ // Label 34398: @2398483
     /* 2398483 */ GIM_Reject,
     /* 2398484 */ // Label 34347: @2398484
     /* 2398484 */ GIM_Try, /*On fail goto*//*Label 34401*/ GIMT_Encode4(2398604),
     /* 2398489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2398492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2398495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398507 */   GIM_Try, /*On fail goto*//*Label 34402*/ GIMT_Encode4(2398555), // Rule ID 54388 //
     /* 2398512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2398515 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2398518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2398532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398554 */     // GIR_Coverage, 54388,
     /* 2398554 */     GIR_EraseRootFromParent_Done,
     /* 2398555 */   // Label 34402: @2398555
     /* 2398555 */   GIM_Try, /*On fail goto*//*Label 34403*/ GIMT_Encode4(2398603), // Rule ID 54389 //
     /* 2398560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2398563 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2398566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2398580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2398598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398602 */     // GIR_Coverage, 54389,
     /* 2398602 */     GIR_EraseRootFromParent_Done,
     /* 2398603 */   // Label 34403: @2398603
     /* 2398603 */   GIM_Reject,
     /* 2398604 */ // Label 34401: @2398604
     /* 2398604 */ GIM_Reject,
     /* 2398605 */ // Label 34348: @2398605
     /* 2398605 */ GIM_Try, /*On fail goto*//*Label 34404*/ GIMT_Encode4(2398725),
     /* 2398610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2398613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2398616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398628 */   GIM_Try, /*On fail goto*//*Label 34405*/ GIMT_Encode4(2398676), // Rule ID 54304 //
     /* 2398633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398636 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2398639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2398653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398675 */     // GIR_Coverage, 54304,
     /* 2398675 */     GIR_EraseRootFromParent_Done,
     /* 2398676 */   // Label 34405: @2398676
     /* 2398676 */   GIM_Try, /*On fail goto*//*Label 34406*/ GIMT_Encode4(2398724), // Rule ID 54305 //
     /* 2398681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398684 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2398687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2398701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398723 */     // GIR_Coverage, 54305,
     /* 2398723 */     GIR_EraseRootFromParent_Done,
     /* 2398724 */   // Label 34406: @2398724
     /* 2398724 */   GIM_Reject,
     /* 2398725 */ // Label 34404: @2398725
     /* 2398725 */ GIM_Reject,
     /* 2398726 */ // Label 34349: @2398726
     /* 2398726 */ GIM_Try, /*On fail goto*//*Label 34407*/ GIMT_Encode4(2398846),
     /* 2398731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2398734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2398737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398749 */   GIM_Try, /*On fail goto*//*Label 34408*/ GIMT_Encode4(2398797), // Rule ID 54352 //
     /* 2398754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398757 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2398760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2398774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398796 */     // GIR_Coverage, 54352,
     /* 2398796 */     GIR_EraseRootFromParent_Done,
     /* 2398797 */   // Label 34408: @2398797
     /* 2398797 */   GIM_Try, /*On fail goto*//*Label 34409*/ GIMT_Encode4(2398845), // Rule ID 54353 //
     /* 2398802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398805 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2398808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2398822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398844 */     // GIR_Coverage, 54353,
     /* 2398844 */     GIR_EraseRootFromParent_Done,
     /* 2398845 */   // Label 34409: @2398845
     /* 2398845 */   GIM_Reject,
     /* 2398846 */ // Label 34407: @2398846
     /* 2398846 */ GIM_Reject,
     /* 2398847 */ // Label 34350: @2398847
     /* 2398847 */ GIM_Try, /*On fail goto*//*Label 34410*/ GIMT_Encode4(2398967),
     /* 2398852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2398855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2398858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2398870 */   GIM_Try, /*On fail goto*//*Label 34411*/ GIMT_Encode4(2398918), // Rule ID 54316 //
     /* 2398875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398878 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2398878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2398881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2398895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398917 */     // GIR_Coverage, 54316,
     /* 2398917 */     GIR_EraseRootFromParent_Done,
     /* 2398918 */   // Label 34411: @2398918
     /* 2398918 */   GIM_Try, /*On fail goto*//*Label 34412*/ GIMT_Encode4(2398966), // Rule ID 54317 //
     /* 2398923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398926 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2398926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2398929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2398933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2398938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2398940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2398943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2398948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2398952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2398964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398965 */     // GIR_Coverage, 54317,
     /* 2398965 */     GIR_EraseRootFromParent_Done,
     /* 2398966 */   // Label 34412: @2398966
     /* 2398966 */   GIM_Reject,
     /* 2398967 */ // Label 34410: @2398967
     /* 2398967 */ GIM_Reject,
     /* 2398968 */ // Label 34351: @2398968
     /* 2398968 */ GIM_Reject,
     /* 2398969 */ // Label 101: @2398969
     /* 2398969 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34431*/ GIMT_Encode4(2401396),
     /* 2398980 */ /*GILLT_s16*//*Label 34413*/ GIMT_Encode4(2399100),
     /* 2398984 */ /*GILLT_s32*//*Label 34414*/ GIMT_Encode4(2399249),
     /* 2398988 */ /*GILLT_s64*//*Label 34415*/ GIMT_Encode4(2399398), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399000 */ /*GILLT_nxv1s16*//*Label 34416*/ GIMT_Encode4(2399581),
     /* 2399004 */ /*GILLT_nxv1s32*//*Label 34417*/ GIMT_Encode4(2399702),
     /* 2399008 */ /*GILLT_nxv1s64*//*Label 34418*/ GIMT_Encode4(2399823), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399020 */ /*GILLT_nxv2s16*//*Label 34419*/ GIMT_Encode4(2399944),
     /* 2399024 */ /*GILLT_nxv2s32*//*Label 34420*/ GIMT_Encode4(2400065),
     /* 2399028 */ /*GILLT_nxv2s64*//*Label 34421*/ GIMT_Encode4(2400186), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399040 */ /*GILLT_nxv4s16*//*Label 34422*/ GIMT_Encode4(2400307),
     /* 2399044 */ /*GILLT_nxv4s32*//*Label 34423*/ GIMT_Encode4(2400428),
     /* 2399048 */ /*GILLT_nxv4s64*//*Label 34424*/ GIMT_Encode4(2400549), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399060 */ /*GILLT_nxv8s16*//*Label 34425*/ GIMT_Encode4(2400670),
     /* 2399064 */ /*GILLT_nxv8s32*//*Label 34426*/ GIMT_Encode4(2400791),
     /* 2399068 */ /*GILLT_nxv8s64*//*Label 34427*/ GIMT_Encode4(2400912), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399080 */ /*GILLT_nxv16s16*//*Label 34428*/ GIMT_Encode4(2401033),
     /* 2399084 */ /*GILLT_nxv16s32*//*Label 34429*/ GIMT_Encode4(2401154), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2399096 */ /*GILLT_nxv32s16*//*Label 34430*/ GIMT_Encode4(2401275),
     /* 2399100 */ // Label 34413: @2399100
     /* 2399100 */ GIM_Try, /*On fail goto*//*Label 34432*/ GIMT_Encode4(2399248),
     /* 2399105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2399108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2399111 */   GIM_Try, /*On fail goto*//*Label 34433*/ GIMT_Encode4(2399145), // Rule ID 1976 //
     /* 2399116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2399119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399131 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2399131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2399134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399144 */     // GIR_Coverage, 1976,
     /* 2399144 */     GIR_EraseRootFromParent_Done,
     /* 2399145 */   // Label 34433: @2399145
     /* 2399145 */   GIM_Try, /*On fail goto*//*Label 34434*/ GIMT_Encode4(2399179), // Rule ID 1977 //
     /* 2399150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2399153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2399165 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2399165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2399168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399178 */     // GIR_Coverage, 1977,
     /* 2399178 */     GIR_EraseRootFromParent_Done,
     /* 2399179 */   // Label 34434: @2399179
     /* 2399179 */   GIM_Try, /*On fail goto*//*Label 34435*/ GIMT_Encode4(2399213), // Rule ID 1980 //
     /* 2399184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2399187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399199 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2399199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2399202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399212 */     // GIR_Coverage, 1980,
     /* 2399212 */     GIR_EraseRootFromParent_Done,
     /* 2399213 */   // Label 34435: @2399213
     /* 2399213 */   GIM_Try, /*On fail goto*//*Label 34436*/ GIMT_Encode4(2399247), // Rule ID 1981 //
     /* 2399218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2399221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2399233 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2399233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2399236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399246 */     // GIR_Coverage, 1981,
     /* 2399246 */     GIR_EraseRootFromParent_Done,
     /* 2399247 */   // Label 34436: @2399247
     /* 2399247 */   GIM_Reject,
     /* 2399248 */ // Label 34432: @2399248
     /* 2399248 */ GIM_Reject,
     /* 2399249 */ // Label 34414: @2399249
     /* 2399249 */ GIM_Try, /*On fail goto*//*Label 34437*/ GIMT_Encode4(2399397),
     /* 2399254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2399257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2399260 */   GIM_Try, /*On fail goto*//*Label 34438*/ GIMT_Encode4(2399294), // Rule ID 1267 //
     /* 2399265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2399268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399280 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2399280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2399283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399293 */     // GIR_Coverage, 1267,
     /* 2399293 */     GIR_EraseRootFromParent_Done,
     /* 2399294 */   // Label 34438: @2399294
     /* 2399294 */   GIM_Try, /*On fail goto*//*Label 34439*/ GIMT_Encode4(2399328), // Rule ID 1268 //
     /* 2399299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2399302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2399314 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2399314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2399317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399327 */     // GIR_Coverage, 1268,
     /* 2399327 */     GIR_EraseRootFromParent_Done,
     /* 2399328 */   // Label 34439: @2399328
     /* 2399328 */   GIM_Try, /*On fail goto*//*Label 34440*/ GIMT_Encode4(2399362), // Rule ID 1271 //
     /* 2399333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2399336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399348 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2399348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2399351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399361 */     // GIR_Coverage, 1271,
     /* 2399361 */     GIR_EraseRootFromParent_Done,
     /* 2399362 */   // Label 34440: @2399362
     /* 2399362 */   GIM_Try, /*On fail goto*//*Label 34441*/ GIMT_Encode4(2399396), // Rule ID 1272 //
     /* 2399367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2399370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2399382 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2399382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2399385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399395 */     // GIR_Coverage, 1272,
     /* 2399395 */     GIR_EraseRootFromParent_Done,
     /* 2399396 */   // Label 34441: @2399396
     /* 2399396 */   GIM_Reject,
     /* 2399397 */ // Label 34437: @2399397
     /* 2399397 */ GIM_Reject,
     /* 2399398 */ // Label 34415: @2399398
     /* 2399398 */ GIM_Try, /*On fail goto*//*Label 34442*/ GIMT_Encode4(2399580),
     /* 2399403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2399406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2399409 */   GIM_Try, /*On fail goto*//*Label 34443*/ GIMT_Encode4(2399443), // Rule ID 1608 //
     /* 2399414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2399417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399429 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2399429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2399432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399442 */     // GIR_Coverage, 1608,
     /* 2399442 */     GIR_EraseRootFromParent_Done,
     /* 2399443 */   // Label 34443: @2399443
     /* 2399443 */   GIM_Try, /*On fail goto*//*Label 34444*/ GIMT_Encode4(2399477), // Rule ID 1609 //
     /* 2399448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2399451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2399463 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2399463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2399466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399476 */     // GIR_Coverage, 1609,
     /* 2399476 */     GIR_EraseRootFromParent_Done,
     /* 2399477 */   // Label 34444: @2399477
     /* 2399477 */   GIM_Try, /*On fail goto*//*Label 34445*/ GIMT_Encode4(2399511), // Rule ID 1612 //
     /* 2399482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2399485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399497 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2399497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2399500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399510 */     // GIR_Coverage, 1612,
     /* 2399510 */     GIR_EraseRootFromParent_Done,
     /* 2399511 */   // Label 34445: @2399511
     /* 2399511 */   GIM_Try, /*On fail goto*//*Label 34446*/ GIMT_Encode4(2399545), // Rule ID 1613 //
     /* 2399516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2399519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2399531 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2399531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2399534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399544 */     // GIR_Coverage, 1613,
     /* 2399544 */     GIR_EraseRootFromParent_Done,
     /* 2399545 */   // Label 34446: @2399545
     /* 2399545 */   GIM_Try, /*On fail goto*//*Label 34447*/ GIMT_Encode4(2399579), // Rule ID 1616 //
     /* 2399550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2399553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2399557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2399561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2399565 */     // (strict_fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2399565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2399568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399578 */     // GIR_Coverage, 1616,
     /* 2399578 */     GIR_EraseRootFromParent_Done,
     /* 2399579 */   // Label 34447: @2399579
     /* 2399579 */   GIM_Reject,
     /* 2399580 */ // Label 34442: @2399580
     /* 2399580 */ GIM_Reject,
     /* 2399581 */ // Label 34416: @2399581
     /* 2399581 */ GIM_Try, /*On fail goto*//*Label 34448*/ GIMT_Encode4(2399701),
     /* 2399586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2399589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2399592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399604 */   GIM_Try, /*On fail goto*//*Label 34449*/ GIMT_Encode4(2399652), // Rule ID 54400 //
     /* 2399609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399612 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2399615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2399629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399651 */     // GIR_Coverage, 54400,
     /* 2399651 */     GIR_EraseRootFromParent_Done,
     /* 2399652 */   // Label 34449: @2399652
     /* 2399652 */   GIM_Try, /*On fail goto*//*Label 34450*/ GIMT_Encode4(2399700), // Rule ID 54401 //
     /* 2399657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2399660 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2399663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2399677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2399695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399699 */     // GIR_Coverage, 54401,
     /* 2399699 */     GIR_EraseRootFromParent_Done,
     /* 2399700 */   // Label 34450: @2399700
     /* 2399700 */   GIM_Reject,
     /* 2399701 */ // Label 34448: @2399701
     /* 2399701 */ GIM_Reject,
     /* 2399702 */ // Label 34417: @2399702
     /* 2399702 */ GIM_Try, /*On fail goto*//*Label 34451*/ GIMT_Encode4(2399822),
     /* 2399707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2399710 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2399713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399725 */   GIM_Try, /*On fail goto*//*Label 34452*/ GIMT_Encode4(2399773), // Rule ID 54424 //
     /* 2399730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399733 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2399736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2399750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399772 */     // GIR_Coverage, 54424,
     /* 2399772 */     GIR_EraseRootFromParent_Done,
     /* 2399773 */   // Label 34452: @2399773
     /* 2399773 */   GIM_Try, /*On fail goto*//*Label 34453*/ GIMT_Encode4(2399821), // Rule ID 54425 //
     /* 2399778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399781 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2399784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2399798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399820 */     // GIR_Coverage, 54425,
     /* 2399820 */     GIR_EraseRootFromParent_Done,
     /* 2399821 */   // Label 34453: @2399821
     /* 2399821 */   GIM_Reject,
     /* 2399822 */ // Label 34451: @2399822
     /* 2399822 */ GIM_Reject,
     /* 2399823 */ // Label 34418: @2399823
     /* 2399823 */ GIM_Try, /*On fail goto*//*Label 34454*/ GIMT_Encode4(2399943),
     /* 2399828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2399831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2399834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399842 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399846 */   GIM_Try, /*On fail goto*//*Label 34455*/ GIMT_Encode4(2399894), // Rule ID 54460 //
     /* 2399851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399854 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2399857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2399871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399893 */     // GIR_Coverage, 54460,
     /* 2399893 */     GIR_EraseRootFromParent_Done,
     /* 2399894 */   // Label 34455: @2399894
     /* 2399894 */   GIM_Try, /*On fail goto*//*Label 34456*/ GIMT_Encode4(2399942), // Rule ID 54461 //
     /* 2399899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399902 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2399902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2399905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2399919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2399928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2399940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399941 */     // GIR_Coverage, 54461,
     /* 2399941 */     GIR_EraseRootFromParent_Done,
     /* 2399942 */   // Label 34456: @2399942
     /* 2399942 */   GIM_Reject,
     /* 2399943 */ // Label 34454: @2399943
     /* 2399943 */ GIM_Reject,
     /* 2399944 */ // Label 34419: @2399944
     /* 2399944 */ GIM_Try, /*On fail goto*//*Label 34457*/ GIMT_Encode4(2400064),
     /* 2399949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2399952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2399955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2399967 */   GIM_Try, /*On fail goto*//*Label 34458*/ GIMT_Encode4(2400015), // Rule ID 54412 //
     /* 2399972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2399975 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2399975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2399978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2399982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2399987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2399989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2399992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2399997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400014 */     // GIR_Coverage, 54412,
     /* 2400014 */     GIR_EraseRootFromParent_Done,
     /* 2400015 */   // Label 34458: @2400015
     /* 2400015 */   GIM_Try, /*On fail goto*//*Label 34459*/ GIMT_Encode4(2400063), // Rule ID 54413 //
     /* 2400020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400023 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2400026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2400040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400062 */     // GIR_Coverage, 54413,
     /* 2400062 */     GIR_EraseRootFromParent_Done,
     /* 2400063 */   // Label 34459: @2400063
     /* 2400063 */   GIM_Reject,
     /* 2400064 */ // Label 34457: @2400064
     /* 2400064 */ GIM_Reject,
     /* 2400065 */ // Label 34420: @2400065
     /* 2400065 */ GIM_Try, /*On fail goto*//*Label 34460*/ GIMT_Encode4(2400185),
     /* 2400070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2400073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2400076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400088 */   GIM_Try, /*On fail goto*//*Label 34461*/ GIMT_Encode4(2400136), // Rule ID 54448 //
     /* 2400093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400096 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2400099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2400113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400135 */     // GIR_Coverage, 54448,
     /* 2400135 */     GIR_EraseRootFromParent_Done,
     /* 2400136 */   // Label 34461: @2400136
     /* 2400136 */   GIM_Try, /*On fail goto*//*Label 34462*/ GIMT_Encode4(2400184), // Rule ID 54449 //
     /* 2400141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400144 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2400147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2400161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400183 */     // GIR_Coverage, 54449,
     /* 2400183 */     GIR_EraseRootFromParent_Done,
     /* 2400184 */   // Label 34462: @2400184
     /* 2400184 */   GIM_Reject,
     /* 2400185 */ // Label 34460: @2400185
     /* 2400185 */ GIM_Reject,
     /* 2400186 */ // Label 34421: @2400186
     /* 2400186 */ GIM_Try, /*On fail goto*//*Label 34463*/ GIMT_Encode4(2400306),
     /* 2400191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2400194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2400197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400209 */   GIM_Try, /*On fail goto*//*Label 34464*/ GIMT_Encode4(2400257), // Rule ID 54544 //
     /* 2400214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2400217 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2400220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2400234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400256 */     // GIR_Coverage, 54544,
     /* 2400256 */     GIR_EraseRootFromParent_Done,
     /* 2400257 */   // Label 34464: @2400257
     /* 2400257 */   GIM_Try, /*On fail goto*//*Label 34465*/ GIMT_Encode4(2400305), // Rule ID 54545 //
     /* 2400262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2400265 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2400268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2400282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400304 */     // GIR_Coverage, 54545,
     /* 2400304 */     GIR_EraseRootFromParent_Done,
     /* 2400305 */   // Label 34465: @2400305
     /* 2400305 */   GIM_Reject,
     /* 2400306 */ // Label 34463: @2400306
     /* 2400306 */ GIM_Reject,
     /* 2400307 */ // Label 34422: @2400307
     /* 2400307 */ GIM_Try, /*On fail goto*//*Label 34466*/ GIMT_Encode4(2400427),
     /* 2400312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2400315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2400318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2400330 */   GIM_Try, /*On fail goto*//*Label 34467*/ GIMT_Encode4(2400378), // Rule ID 54436 //
     /* 2400335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400338 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2400341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2400355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400377 */     // GIR_Coverage, 54436,
     /* 2400377 */     GIR_EraseRootFromParent_Done,
     /* 2400378 */   // Label 34467: @2400378
     /* 2400378 */   GIM_Try, /*On fail goto*//*Label 34468*/ GIMT_Encode4(2400426), // Rule ID 54437 //
     /* 2400383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400386 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2400389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2400403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400425 */     // GIR_Coverage, 54437,
     /* 2400425 */     GIR_EraseRootFromParent_Done,
     /* 2400426 */   // Label 34468: @2400426
     /* 2400426 */   GIM_Reject,
     /* 2400427 */ // Label 34466: @2400427
     /* 2400427 */ GIM_Reject,
     /* 2400428 */ // Label 34423: @2400428
     /* 2400428 */ GIM_Try, /*On fail goto*//*Label 34469*/ GIMT_Encode4(2400548),
     /* 2400433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2400436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2400439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400451 */   GIM_Try, /*On fail goto*//*Label 34470*/ GIMT_Encode4(2400499), // Rule ID 54508 //
     /* 2400456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400459 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2400462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2400476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400498 */     // GIR_Coverage, 54508,
     /* 2400498 */     GIR_EraseRootFromParent_Done,
     /* 2400499 */   // Label 34470: @2400499
     /* 2400499 */   GIM_Try, /*On fail goto*//*Label 34471*/ GIMT_Encode4(2400547), // Rule ID 54509 //
     /* 2400504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400507 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2400510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2400524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400546 */     // GIR_Coverage, 54509,
     /* 2400546 */     GIR_EraseRootFromParent_Done,
     /* 2400547 */   // Label 34471: @2400547
     /* 2400547 */   GIM_Reject,
     /* 2400548 */ // Label 34469: @2400548
     /* 2400548 */ GIM_Reject,
     /* 2400549 */ // Label 34424: @2400549
     /* 2400549 */ GIM_Try, /*On fail goto*//*Label 34472*/ GIMT_Encode4(2400669),
     /* 2400554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2400557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2400560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400568 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400572 */   GIM_Try, /*On fail goto*//*Label 34473*/ GIMT_Encode4(2400620), // Rule ID 54556 //
     /* 2400577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2400580 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2400583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2400597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400619 */     // GIR_Coverage, 54556,
     /* 2400619 */     GIR_EraseRootFromParent_Done,
     /* 2400620 */   // Label 34473: @2400620
     /* 2400620 */   GIM_Try, /*On fail goto*//*Label 34474*/ GIMT_Encode4(2400668), // Rule ID 54557 //
     /* 2400625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2400628 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2400631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2400645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400667 */     // GIR_Coverage, 54557,
     /* 2400667 */     GIR_EraseRootFromParent_Done,
     /* 2400668 */   // Label 34474: @2400668
     /* 2400668 */   GIM_Reject,
     /* 2400669 */ // Label 34472: @2400669
     /* 2400669 */ GIM_Reject,
     /* 2400670 */ // Label 34425: @2400670
     /* 2400670 */ GIM_Try, /*On fail goto*//*Label 34475*/ GIMT_Encode4(2400790),
     /* 2400675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2400678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2400681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2400693 */   GIM_Try, /*On fail goto*//*Label 34476*/ GIMT_Encode4(2400741), // Rule ID 54472 //
     /* 2400698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400701 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2400704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2400718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400740 */     // GIR_Coverage, 54472,
     /* 2400740 */     GIR_EraseRootFromParent_Done,
     /* 2400741 */   // Label 34476: @2400741
     /* 2400741 */   GIM_Try, /*On fail goto*//*Label 34477*/ GIMT_Encode4(2400789), // Rule ID 54473 //
     /* 2400746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400749 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2400752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2400766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400788 */     // GIR_Coverage, 54473,
     /* 2400788 */     GIR_EraseRootFromParent_Done,
     /* 2400789 */   // Label 34477: @2400789
     /* 2400789 */   GIM_Reject,
     /* 2400790 */ // Label 34475: @2400790
     /* 2400790 */ GIM_Reject,
     /* 2400791 */ // Label 34426: @2400791
     /* 2400791 */ GIM_Try, /*On fail goto*//*Label 34478*/ GIMT_Encode4(2400911),
     /* 2400796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2400799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2400802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400814 */   GIM_Try, /*On fail goto*//*Label 34479*/ GIMT_Encode4(2400862), // Rule ID 54520 //
     /* 2400819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400822 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2400825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2400839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400861 */     // GIR_Coverage, 54520,
     /* 2400861 */     GIR_EraseRootFromParent_Done,
     /* 2400862 */   // Label 34479: @2400862
     /* 2400862 */   GIM_Try, /*On fail goto*//*Label 34480*/ GIMT_Encode4(2400910), // Rule ID 54521 //
     /* 2400867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2400870 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2400873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2400887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400909 */     // GIR_Coverage, 54521,
     /* 2400909 */     GIR_EraseRootFromParent_Done,
     /* 2400910 */   // Label 34480: @2400910
     /* 2400910 */   GIM_Reject,
     /* 2400911 */ // Label 34478: @2400911
     /* 2400911 */ GIM_Reject,
     /* 2400912 */ // Label 34427: @2400912
     /* 2400912 */ GIM_Try, /*On fail goto*//*Label 34481*/ GIMT_Encode4(2401032),
     /* 2400917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2400920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2400923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400935 */   GIM_Try, /*On fail goto*//*Label 34482*/ GIMT_Encode4(2400983), // Rule ID 54568 //
     /* 2400940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2400943 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2400943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2400946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2400955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2400957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2400960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2400965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2400969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2400981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400982 */     // GIR_Coverage, 54568,
     /* 2400982 */     GIR_EraseRootFromParent_Done,
     /* 2400983 */   // Label 34482: @2400983
     /* 2400983 */   GIM_Try, /*On fail goto*//*Label 34483*/ GIMT_Encode4(2401031), // Rule ID 54569 //
     /* 2400988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2400991 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2400991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2400994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2400998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2401008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2401026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401030 */     // GIR_Coverage, 54569,
     /* 2401030 */     GIR_EraseRootFromParent_Done,
     /* 2401031 */   // Label 34483: @2401031
     /* 2401031 */   GIM_Reject,
     /* 2401032 */ // Label 34481: @2401032
     /* 2401032 */ GIM_Reject,
     /* 2401033 */ // Label 34428: @2401033
     /* 2401033 */ GIM_Try, /*On fail goto*//*Label 34484*/ GIMT_Encode4(2401153),
     /* 2401038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2401041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2401044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2401056 */   GIM_Try, /*On fail goto*//*Label 34485*/ GIMT_Encode4(2401104), // Rule ID 54484 //
     /* 2401061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401064 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2401067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2401081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401103 */     // GIR_Coverage, 54484,
     /* 2401103 */     GIR_EraseRootFromParent_Done,
     /* 2401104 */   // Label 34485: @2401104
     /* 2401104 */   GIM_Try, /*On fail goto*//*Label 34486*/ GIMT_Encode4(2401152), // Rule ID 54485 //
     /* 2401109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401112 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2401115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2401129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401151 */     // GIR_Coverage, 54485,
     /* 2401151 */     GIR_EraseRootFromParent_Done,
     /* 2401152 */   // Label 34486: @2401152
     /* 2401152 */   GIM_Reject,
     /* 2401153 */ // Label 34484: @2401153
     /* 2401153 */ GIM_Reject,
     /* 2401154 */ // Label 34429: @2401154
     /* 2401154 */ GIM_Try, /*On fail goto*//*Label 34487*/ GIMT_Encode4(2401274),
     /* 2401159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2401165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401177 */   GIM_Try, /*On fail goto*//*Label 34488*/ GIMT_Encode4(2401225), // Rule ID 54532 //
     /* 2401182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401185 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2401188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2401202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401224 */     // GIR_Coverage, 54532,
     /* 2401224 */     GIR_EraseRootFromParent_Done,
     /* 2401225 */   // Label 34488: @2401225
     /* 2401225 */   GIM_Try, /*On fail goto*//*Label 34489*/ GIMT_Encode4(2401273), // Rule ID 54533 //
     /* 2401230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401233 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2401236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2401250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401272 */     // GIR_Coverage, 54533,
     /* 2401272 */     GIR_EraseRootFromParent_Done,
     /* 2401273 */   // Label 34489: @2401273
     /* 2401273 */   GIM_Reject,
     /* 2401274 */ // Label 34487: @2401274
     /* 2401274 */ GIM_Reject,
     /* 2401275 */ // Label 34430: @2401275
     /* 2401275 */ GIM_Try, /*On fail goto*//*Label 34490*/ GIMT_Encode4(2401395),
     /* 2401280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2401286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401298 */   GIM_Try, /*On fail goto*//*Label 34491*/ GIMT_Encode4(2401346), // Rule ID 54496 //
     /* 2401303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401306 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2401306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2401309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2401323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401345 */     // GIR_Coverage, 54496,
     /* 2401345 */     GIR_EraseRootFromParent_Done,
     /* 2401346 */   // Label 34491: @2401346
     /* 2401346 */   GIM_Try, /*On fail goto*//*Label 34492*/ GIMT_Encode4(2401394), // Rule ID 54497 //
     /* 2401351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401354 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2401354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2401357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2401361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2401366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2401368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2401371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2401376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2401392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401393 */     // GIR_Coverage, 54497,
     /* 2401393 */     GIR_EraseRootFromParent_Done,
     /* 2401394 */   // Label 34492: @2401394
     /* 2401394 */   GIM_Reject,
     /* 2401395 */ // Label 34490: @2401395
     /* 2401395 */ GIM_Reject,
     /* 2401396 */ // Label 34431: @2401396
     /* 2401396 */ GIM_Reject,
     /* 2401397 */ // Label 102: @2401397
     /* 2401397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34511*/ GIMT_Encode4(2418041),
     /* 2401408 */ /*GILLT_s16*//*Label 34493*/ GIMT_Encode4(2401528),
     /* 2401412 */ /*GILLT_s32*//*Label 34494*/ GIMT_Encode4(2402964),
     /* 2401416 */ /*GILLT_s64*//*Label 34495*/ GIMT_Encode4(2404400), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401428 */ /*GILLT_nxv1s16*//*Label 34496*/ GIMT_Encode4(2406191),
     /* 2401432 */ /*GILLT_nxv1s32*//*Label 34497*/ GIMT_Encode4(2406981),
     /* 2401436 */ /*GILLT_nxv1s64*//*Label 34498*/ GIMT_Encode4(2407771), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401448 */ /*GILLT_nxv2s16*//*Label 34499*/ GIMT_Encode4(2408561),
     /* 2401452 */ /*GILLT_nxv2s32*//*Label 34500*/ GIMT_Encode4(2409351),
     /* 2401456 */ /*GILLT_nxv2s64*//*Label 34501*/ GIMT_Encode4(2410141), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401468 */ /*GILLT_nxv4s16*//*Label 34502*/ GIMT_Encode4(2410931),
     /* 2401472 */ /*GILLT_nxv4s32*//*Label 34503*/ GIMT_Encode4(2411721),
     /* 2401476 */ /*GILLT_nxv4s64*//*Label 34504*/ GIMT_Encode4(2412511), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401488 */ /*GILLT_nxv8s16*//*Label 34505*/ GIMT_Encode4(2413301),
     /* 2401492 */ /*GILLT_nxv8s32*//*Label 34506*/ GIMT_Encode4(2414091),
     /* 2401496 */ /*GILLT_nxv8s64*//*Label 34507*/ GIMT_Encode4(2414881), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401508 */ /*GILLT_nxv16s16*//*Label 34508*/ GIMT_Encode4(2415671),
     /* 2401512 */ /*GILLT_nxv16s32*//*Label 34509*/ GIMT_Encode4(2416461), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2401524 */ /*GILLT_nxv32s16*//*Label 34510*/ GIMT_Encode4(2417251),
     /* 2401528 */ // Label 34493: @2401528
     /* 2401528 */ GIM_Try, /*On fail goto*//*Label 34512*/ GIMT_Encode4(2402963),
     /* 2401533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2401539 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2401542 */   GIM_Try, /*On fail goto*//*Label 34513*/ GIMT_Encode4(2401614), // Rule ID 2009 //
     /* 2401547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2401550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401594 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2401594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2401597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2401609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401613 */     // GIR_Coverage, 2009,
     /* 2401613 */     GIR_EraseRootFromParent_Done,
     /* 2401614 */   // Label 34513: @2401614
     /* 2401614 */   GIM_Try, /*On fail goto*//*Label 34514*/ GIMT_Encode4(2401686), // Rule ID 2010 //
     /* 2401619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2401622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401666 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2401666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2401669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2401681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401685 */     // GIR_Coverage, 2010,
     /* 2401685 */     GIR_EraseRootFromParent_Done,
     /* 2401686 */   // Label 34514: @2401686
     /* 2401686 */   GIM_Try, /*On fail goto*//*Label 34515*/ GIMT_Encode4(2401758), // Rule ID 2042 //
     /* 2401691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2401694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401738 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2401738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2401741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2401753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401757 */     // GIR_Coverage, 2042,
     /* 2401757 */     GIR_EraseRootFromParent_Done,
     /* 2401758 */   // Label 34515: @2401758
     /* 2401758 */   GIM_Try, /*On fail goto*//*Label 34516*/ GIMT_Encode4(2401830), // Rule ID 2043 //
     /* 2401763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2401766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401810 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2401810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2401813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2401821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2401825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401829 */     // GIR_Coverage, 2043,
     /* 2401829 */     GIR_EraseRootFromParent_Done,
     /* 2401830 */   // Label 34516: @2401830
     /* 2401830 */   GIM_Try, /*On fail goto*//*Label 34517*/ GIMT_Encode4(2401902), // Rule ID 65446 //
     /* 2401835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2401838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401882 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2401882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2401885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2401893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2401897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401901 */     // GIR_Coverage, 65446,
     /* 2401901 */     GIR_EraseRootFromParent_Done,
     /* 2401902 */   // Label 34517: @2401902
     /* 2401902 */   GIM_Try, /*On fail goto*//*Label 34518*/ GIMT_Encode4(2401974), // Rule ID 65447 //
     /* 2401907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2401910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2401947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2401952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401954 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2401954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2401957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2401965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2401969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401973 */     // GIR_Coverage, 65447,
     /* 2401973 */     GIR_EraseRootFromParent_Done,
     /* 2401974 */   // Label 34518: @2401974
     /* 2401974 */   GIM_Try, /*On fail goto*//*Label 34519*/ GIMT_Encode4(2402046), // Rule ID 65454 //
     /* 2401979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2401982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2401990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402026 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2402029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402045 */     // GIR_Coverage, 65454,
     /* 2402045 */     GIR_EraseRootFromParent_Done,
     /* 2402046 */   // Label 34519: @2402046
     /* 2402046 */   GIM_Try, /*On fail goto*//*Label 34520*/ GIMT_Encode4(2402118), // Rule ID 65455 //
     /* 2402051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2402083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2402098 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2402101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2402113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402117 */     // GIR_Coverage, 65455,
     /* 2402117 */     GIR_EraseRootFromParent_Done,
     /* 2402118 */   // Label 34520: @2402118
     /* 2402118 */   GIM_Try, /*On fail goto*//*Label 34521*/ GIMT_Encode4(2402175), // Rule ID 2005 //
     /* 2402123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402157 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2402160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402174 */     // GIR_Coverage, 2005,
     /* 2402174 */     GIR_EraseRootFromParent_Done,
     /* 2402175 */   // Label 34521: @2402175
     /* 2402175 */   GIM_Try, /*On fail goto*//*Label 34522*/ GIMT_Encode4(2402232), // Rule ID 2006 //
     /* 2402180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402214 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2402217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402231 */     // GIR_Coverage, 2006,
     /* 2402231 */     GIR_EraseRootFromParent_Done,
     /* 2402232 */   // Label 34522: @2402232
     /* 2402232 */   GIM_Try, /*On fail goto*//*Label 34523*/ GIMT_Encode4(2402289), // Rule ID 2038 //
     /* 2402237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402271 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2402274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402288 */     // GIR_Coverage, 2038,
     /* 2402288 */     GIR_EraseRootFromParent_Done,
     /* 2402289 */   // Label 34523: @2402289
     /* 2402289 */   GIM_Try, /*On fail goto*//*Label 34524*/ GIMT_Encode4(2402346), // Rule ID 2039 //
     /* 2402294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402328 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2402331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402345 */     // GIR_Coverage, 2039,
     /* 2402345 */     GIR_EraseRootFromParent_Done,
     /* 2402346 */   // Label 34524: @2402346
     /* 2402346 */   GIM_Try, /*On fail goto*//*Label 34525*/ GIMT_Encode4(2402403), // Rule ID 65442 //
     /* 2402351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402385 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2402388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402402 */     // GIR_Coverage, 65442,
     /* 2402402 */     GIR_EraseRootFromParent_Done,
     /* 2402403 */   // Label 34525: @2402403
     /* 2402403 */   GIM_Try, /*On fail goto*//*Label 34526*/ GIMT_Encode4(2402460), // Rule ID 65443 //
     /* 2402408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402442 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2402445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402459 */     // GIR_Coverage, 65443,
     /* 2402459 */     GIR_EraseRootFromParent_Done,
     /* 2402460 */   // Label 34526: @2402460
     /* 2402460 */   GIM_Try, /*On fail goto*//*Label 34527*/ GIMT_Encode4(2402517), // Rule ID 65450 //
     /* 2402465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402499 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2402502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402516 */     // GIR_Coverage, 65450,
     /* 2402516 */     GIR_EraseRootFromParent_Done,
     /* 2402517 */   // Label 34527: @2402517
     /* 2402517 */   GIM_Try, /*On fail goto*//*Label 34528*/ GIMT_Encode4(2402574), // Rule ID 65451 //
     /* 2402522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402556 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2402559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2402567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402573 */     // GIR_Coverage, 65451,
     /* 2402573 */     GIR_EraseRootFromParent_Done,
     /* 2402574 */   // Label 34528: @2402574
     /* 2402574 */   GIM_Try, /*On fail goto*//*Label 34529*/ GIMT_Encode4(2402631), // Rule ID 2001 //
     /* 2402579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2402598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402613 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2402616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2402626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402630 */     // GIR_Coverage, 2001,
     /* 2402630 */     GIR_EraseRootFromParent_Done,
     /* 2402631 */   // Label 34529: @2402631
     /* 2402631 */   GIM_Try, /*On fail goto*//*Label 34530*/ GIMT_Encode4(2402688), // Rule ID 2002 //
     /* 2402636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2402655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402670 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2402673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2402683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402687 */     // GIR_Coverage, 2002,
     /* 2402687 */     GIR_EraseRootFromParent_Done,
     /* 2402688 */   // Label 34530: @2402688
     /* 2402688 */   GIM_Try, /*On fail goto*//*Label 34531*/ GIMT_Encode4(2402745), // Rule ID 2034 //
     /* 2402693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2402712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402727 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2402730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2402740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402744 */     // GIR_Coverage, 2034,
     /* 2402744 */     GIR_EraseRootFromParent_Done,
     /* 2402745 */   // Label 34531: @2402745
     /* 2402745 */   GIM_Try, /*On fail goto*//*Label 34532*/ GIMT_Encode4(2402802), // Rule ID 2035 //
     /* 2402750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2402769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402784 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2402787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2402797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402801 */     // GIR_Coverage, 2035,
     /* 2402801 */     GIR_EraseRootFromParent_Done,
     /* 2402802 */   // Label 34532: @2402802
     /* 2402802 */   GIM_Try, /*On fail goto*//*Label 34533*/ GIMT_Encode4(2402842), // Rule ID 1997 //
     /* 2402807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402826 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2402829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402841 */     // GIR_Coverage, 1997,
     /* 2402841 */     GIR_EraseRootFromParent_Done,
     /* 2402842 */   // Label 34533: @2402842
     /* 2402842 */   GIM_Try, /*On fail goto*//*Label 34534*/ GIMT_Encode4(2402882), // Rule ID 1998 //
     /* 2402847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402866 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2402869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402881 */     // GIR_Coverage, 1998,
     /* 2402881 */     GIR_EraseRootFromParent_Done,
     /* 2402882 */   // Label 34534: @2402882
     /* 2402882 */   GIM_Try, /*On fail goto*//*Label 34535*/ GIMT_Encode4(2402922), // Rule ID 2030 //
     /* 2402887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402906 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2402906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2402909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402921 */     // GIR_Coverage, 2030,
     /* 2402921 */     GIR_EraseRootFromParent_Done,
     /* 2402922 */   // Label 34535: @2402922
     /* 2402922 */   GIM_Try, /*On fail goto*//*Label 34536*/ GIMT_Encode4(2402962), // Rule ID 2031 //
     /* 2402927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402946 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2402946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2402949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2402955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2402957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402961 */     // GIR_Coverage, 2031,
     /* 2402961 */     GIR_EraseRootFromParent_Done,
     /* 2402962 */   // Label 34536: @2402962
     /* 2402962 */   GIM_Reject,
     /* 2402963 */ // Label 34512: @2402963
     /* 2402963 */ GIM_Reject,
     /* 2402964 */ // Label 34494: @2402964
     /* 2402964 */ GIM_Try, /*On fail goto*//*Label 34537*/ GIMT_Encode4(2404399),
     /* 2402969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2402972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2402975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2402978 */   GIM_Try, /*On fail goto*//*Label 34538*/ GIMT_Encode4(2403050), // Rule ID 1308 //
     /* 2402983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2402986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2402990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403030 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2403033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403049 */     // GIR_Coverage, 1308,
     /* 2403049 */     GIR_EraseRootFromParent_Done,
     /* 2403050 */   // Label 34538: @2403050
     /* 2403050 */   GIM_Try, /*On fail goto*//*Label 34539*/ GIMT_Encode4(2403122), // Rule ID 1309 //
     /* 2403055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2403058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403102 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2403105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403121 */     // GIR_Coverage, 1309,
     /* 2403121 */     GIR_EraseRootFromParent_Done,
     /* 2403122 */   // Label 34539: @2403122
     /* 2403122 */   GIM_Try, /*On fail goto*//*Label 34540*/ GIMT_Encode4(2403194), // Rule ID 1329 //
     /* 2403127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2403130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403174 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2403177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403193 */     // GIR_Coverage, 1329,
     /* 2403193 */     GIR_EraseRootFromParent_Done,
     /* 2403194 */   // Label 34540: @2403194
     /* 2403194 */   GIM_Try, /*On fail goto*//*Label 34541*/ GIMT_Encode4(2403266), // Rule ID 1330 //
     /* 2403199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2403202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403246 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2403249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403265 */     // GIR_Coverage, 1330,
     /* 2403265 */     GIR_EraseRootFromParent_Done,
     /* 2403266 */   // Label 34541: @2403266
     /* 2403266 */   GIM_Try, /*On fail goto*//*Label 34542*/ GIMT_Encode4(2403338), // Rule ID 65410 //
     /* 2403271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2403274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403318 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2403321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403337 */     // GIR_Coverage, 65410,
     /* 2403337 */     GIR_EraseRootFromParent_Done,
     /* 2403338 */   // Label 34542: @2403338
     /* 2403338 */   GIM_Try, /*On fail goto*//*Label 34543*/ GIMT_Encode4(2403410), // Rule ID 65411 //
     /* 2403343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2403346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403390 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2403393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403409 */     // GIR_Coverage, 65411,
     /* 2403409 */     GIR_EraseRootFromParent_Done,
     /* 2403410 */   // Label 34543: @2403410
     /* 2403410 */   GIM_Try, /*On fail goto*//*Label 34544*/ GIMT_Encode4(2403482), // Rule ID 65418 //
     /* 2403415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2403418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403462 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2403465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403481 */     // GIR_Coverage, 65418,
     /* 2403481 */     GIR_EraseRootFromParent_Done,
     /* 2403482 */   // Label 34544: @2403482
     /* 2403482 */   GIM_Try, /*On fail goto*//*Label 34545*/ GIMT_Encode4(2403554), // Rule ID 65419 //
     /* 2403487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2403490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2403519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2403534 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2403537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2403549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403553 */     // GIR_Coverage, 65419,
     /* 2403553 */     GIR_EraseRootFromParent_Done,
     /* 2403554 */   // Label 34545: @2403554
     /* 2403554 */   GIM_Try, /*On fail goto*//*Label 34546*/ GIMT_Encode4(2403611), // Rule ID 1304 //
     /* 2403559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2403562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403593 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2403596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403610 */     // GIR_Coverage, 1304,
     /* 2403610 */     GIR_EraseRootFromParent_Done,
     /* 2403611 */   // Label 34546: @2403611
     /* 2403611 */   GIM_Try, /*On fail goto*//*Label 34547*/ GIMT_Encode4(2403668), // Rule ID 1305 //
     /* 2403616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2403619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403650 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2403653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403667 */     // GIR_Coverage, 1305,
     /* 2403667 */     GIR_EraseRootFromParent_Done,
     /* 2403668 */   // Label 34547: @2403668
     /* 2403668 */   GIM_Try, /*On fail goto*//*Label 34548*/ GIMT_Encode4(2403725), // Rule ID 1325 //
     /* 2403673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2403676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403707 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2403710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403724 */     // GIR_Coverage, 1325,
     /* 2403724 */     GIR_EraseRootFromParent_Done,
     /* 2403725 */   // Label 34548: @2403725
     /* 2403725 */   GIM_Try, /*On fail goto*//*Label 34549*/ GIMT_Encode4(2403782), // Rule ID 1326 //
     /* 2403730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2403733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2403741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403764 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2403767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2403775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403781 */     // GIR_Coverage, 1326,
     /* 2403781 */     GIR_EraseRootFromParent_Done,
     /* 2403782 */   // Label 34549: @2403782
     /* 2403782 */   GIM_Try, /*On fail goto*//*Label 34550*/ GIMT_Encode4(2403839), // Rule ID 65406 //
     /* 2403787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2403790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403821 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2403824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403838 */     // GIR_Coverage, 65406,
     /* 2403838 */     GIR_EraseRootFromParent_Done,
     /* 2403839 */   // Label 34550: @2403839
     /* 2403839 */   GIM_Try, /*On fail goto*//*Label 34551*/ GIMT_Encode4(2403896), // Rule ID 65407 //
     /* 2403844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2403847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2403876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403878 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2403881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403895 */     // GIR_Coverage, 65407,
     /* 2403895 */     GIR_EraseRootFromParent_Done,
     /* 2403896 */   // Label 34551: @2403896
     /* 2403896 */   GIM_Try, /*On fail goto*//*Label 34552*/ GIMT_Encode4(2403953), // Rule ID 65414 //
     /* 2403901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2403904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403935 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2403935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2403938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2403944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2403948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403952 */     // GIR_Coverage, 65414,
     /* 2403952 */     GIR_EraseRootFromParent_Done,
     /* 2403953 */   // Label 34552: @2403953
     /* 2403953 */   GIM_Try, /*On fail goto*//*Label 34553*/ GIMT_Encode4(2404010), // Rule ID 65415 //
     /* 2403958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2403961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2403973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2403977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2403981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2403990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2403992 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2403992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2403995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404009 */     // GIR_Coverage, 65415,
     /* 2404009 */     GIR_EraseRootFromParent_Done,
     /* 2404010 */   // Label 34553: @2404010
     /* 2404010 */   GIM_Try, /*On fail goto*//*Label 34554*/ GIMT_Encode4(2404067), // Rule ID 1300 //
     /* 2404015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2404018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404049 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2404052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404066 */     // GIR_Coverage, 1300,
     /* 2404066 */     GIR_EraseRootFromParent_Done,
     /* 2404067 */   // Label 34554: @2404067
     /* 2404067 */   GIM_Try, /*On fail goto*//*Label 34555*/ GIMT_Encode4(2404124), // Rule ID 1301 //
     /* 2404072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2404075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404106 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2404109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404123 */     // GIR_Coverage, 1301,
     /* 2404123 */     GIR_EraseRootFromParent_Done,
     /* 2404124 */   // Label 34555: @2404124
     /* 2404124 */   GIM_Try, /*On fail goto*//*Label 34556*/ GIMT_Encode4(2404181), // Rule ID 1321 //
     /* 2404129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2404132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404163 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2404166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404180 */     // GIR_Coverage, 1321,
     /* 2404180 */     GIR_EraseRootFromParent_Done,
     /* 2404181 */   // Label 34556: @2404181
     /* 2404181 */   GIM_Try, /*On fail goto*//*Label 34557*/ GIMT_Encode4(2404238), // Rule ID 1322 //
     /* 2404186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2404189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2404205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2404220 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2404223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2404233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404237 */     // GIR_Coverage, 1322,
     /* 2404237 */     GIR_EraseRootFromParent_Done,
     /* 2404238 */   // Label 34557: @2404238
     /* 2404238 */   GIM_Try, /*On fail goto*//*Label 34558*/ GIMT_Encode4(2404278), // Rule ID 1296 //
     /* 2404243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2404246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404262 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2404265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404277 */     // GIR_Coverage, 1296,
     /* 2404277 */     GIR_EraseRootFromParent_Done,
     /* 2404278 */   // Label 34558: @2404278
     /* 2404278 */   GIM_Try, /*On fail goto*//*Label 34559*/ GIMT_Encode4(2404318), // Rule ID 1297 //
     /* 2404283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2404286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404302 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2404305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404317 */     // GIR_Coverage, 1297,
     /* 2404317 */     GIR_EraseRootFromParent_Done,
     /* 2404318 */   // Label 34559: @2404318
     /* 2404318 */   GIM_Try, /*On fail goto*//*Label 34560*/ GIMT_Encode4(2404358), // Rule ID 1317 //
     /* 2404323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2404326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404342 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2404342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2404345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404357 */     // GIR_Coverage, 1317,
     /* 2404357 */     GIR_EraseRootFromParent_Done,
     /* 2404358 */   // Label 34560: @2404358
     /* 2404358 */   GIM_Try, /*On fail goto*//*Label 34561*/ GIMT_Encode4(2404398), // Rule ID 1318 //
     /* 2404363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2404366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404382 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2404382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2404385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2404389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2404393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404397 */     // GIR_Coverage, 1318,
     /* 2404397 */     GIR_EraseRootFromParent_Done,
     /* 2404398 */   // Label 34561: @2404398
     /* 2404398 */   GIM_Reject,
     /* 2404399 */ // Label 34537: @2404399
     /* 2404399 */ GIM_Reject,
     /* 2404400 */ // Label 34495: @2404400
     /* 2404400 */ GIM_Try, /*On fail goto*//*Label 34562*/ GIMT_Encode4(2406190),
     /* 2404405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2404411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2404414 */   GIM_Try, /*On fail goto*//*Label 34563*/ GIMT_Encode4(2404486), // Rule ID 1645 //
     /* 2404419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2404422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404466 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2404466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2404469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404485 */     // GIR_Coverage, 1645,
     /* 2404485 */     GIR_EraseRootFromParent_Done,
     /* 2404486 */   // Label 34563: @2404486
     /* 2404486 */   GIM_Try, /*On fail goto*//*Label 34564*/ GIMT_Encode4(2404558), // Rule ID 1646 //
     /* 2404491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2404494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404538 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2404538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2404541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404557 */     // GIR_Coverage, 1646,
     /* 2404557 */     GIR_EraseRootFromParent_Done,
     /* 2404558 */   // Label 34564: @2404558
     /* 2404558 */   GIM_Try, /*On fail goto*//*Label 34565*/ GIMT_Encode4(2404630), // Rule ID 1669 //
     /* 2404563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2404566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404610 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2404610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2404613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404629 */     // GIR_Coverage, 1669,
     /* 2404629 */     GIR_EraseRootFromParent_Done,
     /* 2404630 */   // Label 34565: @2404630
     /* 2404630 */   GIM_Try, /*On fail goto*//*Label 34566*/ GIMT_Encode4(2404702), // Rule ID 1700 //
     /* 2404635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2404638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2404642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2404659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2404663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404671 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2404680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404682 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2404682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2404685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404701 */     // GIR_Coverage, 1700,
     /* 2404701 */     GIR_EraseRootFromParent_Done,
     /* 2404702 */   // Label 34566: @2404702
     /* 2404702 */   GIM_Try, /*On fail goto*//*Label 34567*/ GIMT_Encode4(2404774), // Rule ID 1701 //
     /* 2404707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2404710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2404714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2404731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2404735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2404752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404754 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2404754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2404757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2404765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404773 */     // GIR_Coverage, 1701,
     /* 2404773 */     GIR_EraseRootFromParent_Done,
     /* 2404774 */   // Label 34567: @2404774
     /* 2404774 */   GIM_Try, /*On fail goto*//*Label 34568*/ GIMT_Encode4(2404846), // Rule ID 65426 //
     /* 2404779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2404782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404826 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2404826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2404829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404845 */     // GIR_Coverage, 65426,
     /* 2404845 */     GIR_EraseRootFromParent_Done,
     /* 2404846 */   // Label 34568: @2404846
     /* 2404846 */   GIM_Try, /*On fail goto*//*Label 34569*/ GIMT_Encode4(2404918), // Rule ID 65427 //
     /* 2404851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2404854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404898 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2404898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2404901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404917 */     // GIR_Coverage, 65427,
     /* 2404917 */     GIR_EraseRootFromParent_Done,
     /* 2404918 */   // Label 34569: @2404918
     /* 2404918 */   GIM_Try, /*On fail goto*//*Label 34570*/ GIMT_Encode4(2404990), // Rule ID 65432 //
     /* 2404923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2404926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2404938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2404955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2404959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2404970 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2404970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2404973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2404979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2404985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404989 */     // GIR_Coverage, 65432,
     /* 2404989 */     GIR_EraseRootFromParent_Done,
     /* 2404990 */   // Label 34570: @2404990
     /* 2404990 */   GIM_Try, /*On fail goto*//*Label 34571*/ GIMT_Encode4(2405062), // Rule ID 65438 //
     /* 2404995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2404998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405042 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2405045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405061 */     // GIR_Coverage, 65438,
     /* 2405061 */     GIR_EraseRootFromParent_Done,
     /* 2405062 */   // Label 34571: @2405062
     /* 2405062 */   GIM_Try, /*On fail goto*//*Label 34572*/ GIMT_Encode4(2405134), // Rule ID 65439 //
     /* 2405067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2405070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2405099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2405114 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2405117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2405129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405133 */     // GIR_Coverage, 65439,
     /* 2405133 */     GIR_EraseRootFromParent_Done,
     /* 2405134 */   // Label 34572: @2405134
     /* 2405134 */   GIM_Try, /*On fail goto*//*Label 34573*/ GIMT_Encode4(2405191), // Rule ID 1641 //
     /* 2405139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405173 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2405176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405190 */     // GIR_Coverage, 1641,
     /* 2405190 */     GIR_EraseRootFromParent_Done,
     /* 2405191 */   // Label 34573: @2405191
     /* 2405191 */   GIM_Try, /*On fail goto*//*Label 34574*/ GIMT_Encode4(2405248), // Rule ID 1642 //
     /* 2405196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2405199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405230 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2405233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405247 */     // GIR_Coverage, 1642,
     /* 2405247 */     GIR_EraseRootFromParent_Done,
     /* 2405248 */   // Label 34574: @2405248
     /* 2405248 */   GIM_Try, /*On fail goto*//*Label 34575*/ GIMT_Encode4(2405305), // Rule ID 1667 //
     /* 2405253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405287 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2405290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405304 */     // GIR_Coverage, 1667,
     /* 2405304 */     GIR_EraseRootFromParent_Done,
     /* 2405305 */   // Label 34575: @2405305
     /* 2405305 */   GIM_Try, /*On fail goto*//*Label 34576*/ GIMT_Encode4(2405362), // Rule ID 1696 //
     /* 2405310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2405313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405344 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2405347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405361 */     // GIR_Coverage, 1696,
     /* 2405361 */     GIR_EraseRootFromParent_Done,
     /* 2405362 */   // Label 34576: @2405362
     /* 2405362 */   GIM_Try, /*On fail goto*//*Label 34577*/ GIMT_Encode4(2405419), // Rule ID 1697 //
     /* 2405367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2405370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2405378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405401 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2405404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405418 */     // GIR_Coverage, 1697,
     /* 2405418 */     GIR_EraseRootFromParent_Done,
     /* 2405419 */   // Label 34577: @2405419
     /* 2405419 */   GIM_Try, /*On fail goto*//*Label 34578*/ GIMT_Encode4(2405476), // Rule ID 65422 //
     /* 2405424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405458 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2405461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405467 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405475 */     // GIR_Coverage, 65422,
     /* 2405475 */     GIR_EraseRootFromParent_Done,
     /* 2405476 */   // Label 34578: @2405476
     /* 2405476 */   GIM_Try, /*On fail goto*//*Label 34579*/ GIMT_Encode4(2405533), // Rule ID 65423 //
     /* 2405481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2405484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405515 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2405518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405532 */     // GIR_Coverage, 65423,
     /* 2405532 */     GIR_EraseRootFromParent_Done,
     /* 2405533 */   // Label 34579: @2405533
     /* 2405533 */   GIM_Try, /*On fail goto*//*Label 34580*/ GIMT_Encode4(2405590), // Rule ID 65430 //
     /* 2405538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405572 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2405575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405589 */     // GIR_Coverage, 65430,
     /* 2405589 */     GIR_EraseRootFromParent_Done,
     /* 2405590 */   // Label 34580: @2405590
     /* 2405590 */   GIM_Try, /*On fail goto*//*Label 34581*/ GIMT_Encode4(2405647), // Rule ID 65434 //
     /* 2405595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2405598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405629 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2405632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405646 */     // GIR_Coverage, 65434,
     /* 2405646 */     GIR_EraseRootFromParent_Done,
     /* 2405647 */   // Label 34581: @2405647
     /* 2405647 */   GIM_Try, /*On fail goto*//*Label 34582*/ GIMT_Encode4(2405704), // Rule ID 65435 //
     /* 2405652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2405655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405686 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2405689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2405695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2405697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2405699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405703 */     // GIR_Coverage, 65435,
     /* 2405703 */     GIR_EraseRootFromParent_Done,
     /* 2405704 */   // Label 34582: @2405704
     /* 2405704 */   GIM_Try, /*On fail goto*//*Label 34583*/ GIMT_Encode4(2405761), // Rule ID 1637 //
     /* 2405709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405743 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2405746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2405756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405760 */     // GIR_Coverage, 1637,
     /* 2405760 */     GIR_EraseRootFromParent_Done,
     /* 2405761 */   // Label 34583: @2405761
     /* 2405761 */   GIM_Try, /*On fail goto*//*Label 34584*/ GIMT_Encode4(2405818), // Rule ID 1638 //
     /* 2405766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2405769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405800 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2405803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2405813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405817 */     // GIR_Coverage, 1638,
     /* 2405817 */     GIR_EraseRootFromParent_Done,
     /* 2405818 */   // Label 34584: @2405818
     /* 2405818 */   GIM_Try, /*On fail goto*//*Label 34585*/ GIMT_Encode4(2405875), // Rule ID 1665 //
     /* 2405823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405857 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2405860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2405870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405874 */     // GIR_Coverage, 1665,
     /* 2405874 */     GIR_EraseRootFromParent_Done,
     /* 2405875 */   // Label 34585: @2405875
     /* 2405875 */   GIM_Try, /*On fail goto*//*Label 34586*/ GIMT_Encode4(2405932), // Rule ID 1692 //
     /* 2405880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2405883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405914 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2405914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2405917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2405927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405931 */     // GIR_Coverage, 1692,
     /* 2405931 */     GIR_EraseRootFromParent_Done,
     /* 2405932 */   // Label 34586: @2405932
     /* 2405932 */   GIM_Try, /*On fail goto*//*Label 34587*/ GIMT_Encode4(2405989), // Rule ID 1693 //
     /* 2405937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2405940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2405956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2405960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405971 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2405971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2405974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2405980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2405984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2405987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405988 */     // GIR_Coverage, 1693,
     /* 2405988 */     GIR_EraseRootFromParent_Done,
     /* 2405989 */   // Label 34587: @2405989
     /* 2405989 */   GIM_Try, /*On fail goto*//*Label 34588*/ GIMT_Encode4(2406029), // Rule ID 1633 //
     /* 2405994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406013 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2406016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406028 */     // GIR_Coverage, 1633,
     /* 2406028 */     GIR_EraseRootFromParent_Done,
     /* 2406029 */   // Label 34588: @2406029
     /* 2406029 */   GIM_Try, /*On fail goto*//*Label 34589*/ GIMT_Encode4(2406069), // Rule ID 1634 //
     /* 2406034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2406037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2406053 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2406053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2406056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406068 */     // GIR_Coverage, 1634,
     /* 2406068 */     GIR_EraseRootFromParent_Done,
     /* 2406069 */   // Label 34589: @2406069
     /* 2406069 */   GIM_Try, /*On fail goto*//*Label 34590*/ GIMT_Encode4(2406109), // Rule ID 1663 //
     /* 2406074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2406077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406093 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2406096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406108 */     // GIR_Coverage, 1663,
     /* 2406108 */     GIR_EraseRootFromParent_Done,
     /* 2406109 */   // Label 34590: @2406109
     /* 2406109 */   GIM_Try, /*On fail goto*//*Label 34591*/ GIMT_Encode4(2406149), // Rule ID 1688 //
     /* 2406114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2406117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406133 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2406133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2406136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406148 */     // GIR_Coverage, 1688,
     /* 2406148 */     GIR_EraseRootFromParent_Done,
     /* 2406149 */   // Label 34591: @2406149
     /* 2406149 */   GIM_Try, /*On fail goto*//*Label 34592*/ GIMT_Encode4(2406189), // Rule ID 1689 //
     /* 2406154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2406157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2406173 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2406173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2406176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2406182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2406184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406188 */     // GIR_Coverage, 1689,
     /* 2406188 */     GIR_EraseRootFromParent_Done,
     /* 2406189 */   // Label 34592: @2406189
     /* 2406189 */   GIM_Reject,
     /* 2406190 */ // Label 34562: @2406190
     /* 2406190 */ GIM_Reject,
     /* 2406191 */ // Label 34496: @2406191
     /* 2406191 */ GIM_Try, /*On fail goto*//*Label 34593*/ GIMT_Encode4(2406980),
     /* 2406196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2406202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2406205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406209 */   GIM_Try, /*On fail goto*//*Label 34594*/ GIMT_Encode4(2406286), // Rule ID 54834 //
     /* 2406214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406257 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2406260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406285 */     // GIR_Coverage, 54834,
     /* 2406285 */     GIR_EraseRootFromParent_Done,
     /* 2406286 */   // Label 34594: @2406286
     /* 2406286 */   GIM_Try, /*On fail goto*//*Label 34595*/ GIMT_Encode4(2406363), // Rule ID 54835 //
     /* 2406291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406334 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2406337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406362 */     // GIR_Coverage, 54835,
     /* 2406362 */     GIR_EraseRootFromParent_Done,
     /* 2406363 */   // Label 34595: @2406363
     /* 2406363 */   GIM_Try, /*On fail goto*//*Label 34596*/ GIMT_Encode4(2406440), // Rule ID 72410 //
     /* 2406368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406409 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406411 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2406414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406439 */     // GIR_Coverage, 72410,
     /* 2406439 */     GIR_EraseRootFromParent_Done,
     /* 2406440 */   // Label 34596: @2406440
     /* 2406440 */   GIM_Try, /*On fail goto*//*Label 34597*/ GIMT_Encode4(2406517), // Rule ID 72411 //
     /* 2406445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2406473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2406488 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2406491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2406503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406516 */     // GIR_Coverage, 72411,
     /* 2406516 */     GIR_EraseRootFromParent_Done,
     /* 2406517 */   // Label 34597: @2406517
     /* 2406517 */   GIM_Try, /*On fail goto*//*Label 34598*/ GIMT_Encode4(2406579), // Rule ID 54838 //
     /* 2406522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406552 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2406555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406578 */     // GIR_Coverage, 54838,
     /* 2406578 */     GIR_EraseRootFromParent_Done,
     /* 2406579 */   // Label 34598: @2406579
     /* 2406579 */   GIM_Try, /*On fail goto*//*Label 34599*/ GIMT_Encode4(2406641), // Rule ID 54839 //
     /* 2406584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2406591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406614 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2406617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406640 */     // GIR_Coverage, 54839,
     /* 2406640 */     GIR_EraseRootFromParent_Done,
     /* 2406641 */   // Label 34599: @2406641
     /* 2406641 */   GIM_Try, /*On fail goto*//*Label 34600*/ GIMT_Encode4(2406703), // Rule ID 72414 //
     /* 2406646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406676 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2406679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406702 */     // GIR_Coverage, 72414,
     /* 2406702 */     GIR_EraseRootFromParent_Done,
     /* 2406703 */   // Label 34600: @2406703
     /* 2406703 */   GIM_Try, /*On fail goto*//*Label 34601*/ GIMT_Encode4(2406765), // Rule ID 72415 //
     /* 2406708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2406719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406738 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2406741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2406745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2406749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406764 */     // GIR_Coverage, 72415,
     /* 2406764 */     GIR_EraseRootFromParent_Done,
     /* 2406765 */   // Label 34601: @2406765
     /* 2406765 */   GIM_Try, /*On fail goto*//*Label 34602*/ GIMT_Encode4(2406827), // Rule ID 54830 //
     /* 2406770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406800 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2406803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2406813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406826 */     // GIR_Coverage, 54830,
     /* 2406826 */     GIR_EraseRootFromParent_Done,
     /* 2406827 */   // Label 34602: @2406827
     /* 2406827 */   GIM_Try, /*On fail goto*//*Label 34603*/ GIMT_Encode4(2406889), // Rule ID 54831 //
     /* 2406832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2406847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2406851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2406855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2406862 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2406865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2406875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406888 */     // GIR_Coverage, 54831,
     /* 2406888 */     GIR_EraseRootFromParent_Done,
     /* 2406889 */   // Label 34603: @2406889
     /* 2406889 */   GIM_Try, /*On fail goto*//*Label 34604*/ GIMT_Encode4(2406934), // Rule ID 54826 //
     /* 2406894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2406897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406909 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2406909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2406912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406933 */     // GIR_Coverage, 54826,
     /* 2406933 */     GIR_EraseRootFromParent_Done,
     /* 2406934 */   // Label 34604: @2406934
     /* 2406934 */   GIM_Try, /*On fail goto*//*Label 34605*/ GIMT_Encode4(2406979), // Rule ID 54827 //
     /* 2406939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2406942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406954 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2406954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2406957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2406961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2406965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2406968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2406971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2406974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2406977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2406978 */     // GIR_Coverage, 54827,
     /* 2406978 */     GIR_EraseRootFromParent_Done,
     /* 2406979 */   // Label 34605: @2406979
     /* 2406979 */   GIM_Reject,
     /* 2406980 */ // Label 34593: @2406980
     /* 2406980 */ GIM_Reject,
     /* 2406981 */ // Label 34497: @2406981
     /* 2406981 */ GIM_Try, /*On fail goto*//*Label 34606*/ GIMT_Encode4(2407770),
     /* 2406986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2406989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2406992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2406995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406999 */   GIM_Try, /*On fail goto*//*Label 34607*/ GIMT_Encode4(2407076), // Rule ID 54962 //
     /* 2407004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407047 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2407050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407075 */     // GIR_Coverage, 54962,
     /* 2407075 */     GIR_EraseRootFromParent_Done,
     /* 2407076 */   // Label 34607: @2407076
     /* 2407076 */   GIM_Try, /*On fail goto*//*Label 34608*/ GIMT_Encode4(2407153), // Rule ID 54963 //
     /* 2407081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407124 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2407127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407152 */     // GIR_Coverage, 54963,
     /* 2407152 */     GIR_EraseRootFromParent_Done,
     /* 2407153 */   // Label 34608: @2407153
     /* 2407153 */   GIM_Try, /*On fail goto*//*Label 34609*/ GIMT_Encode4(2407230), // Rule ID 72522 //
     /* 2407158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407201 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2407204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407229 */     // GIR_Coverage, 72522,
     /* 2407229 */     GIR_EraseRootFromParent_Done,
     /* 2407230 */   // Label 34609: @2407230
     /* 2407230 */   GIM_Try, /*On fail goto*//*Label 34610*/ GIMT_Encode4(2407307), // Rule ID 72523 //
     /* 2407235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407278 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2407281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407306 */     // GIR_Coverage, 72523,
     /* 2407306 */     GIR_EraseRootFromParent_Done,
     /* 2407307 */   // Label 34610: @2407307
     /* 2407307 */   GIM_Try, /*On fail goto*//*Label 34611*/ GIMT_Encode4(2407369), // Rule ID 54966 //
     /* 2407312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407342 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2407345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407368 */     // GIR_Coverage, 54966,
     /* 2407368 */     GIR_EraseRootFromParent_Done,
     /* 2407369 */   // Label 34611: @2407369
     /* 2407369 */   GIM_Try, /*On fail goto*//*Label 34612*/ GIMT_Encode4(2407431), // Rule ID 54967 //
     /* 2407374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407404 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2407407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407430 */     // GIR_Coverage, 54967,
     /* 2407430 */     GIR_EraseRootFromParent_Done,
     /* 2407431 */   // Label 34612: @2407431
     /* 2407431 */   GIM_Try, /*On fail goto*//*Label 34613*/ GIMT_Encode4(2407493), // Rule ID 72526 //
     /* 2407436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407466 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2407469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407492 */     // GIR_Coverage, 72526,
     /* 2407492 */     GIR_EraseRootFromParent_Done,
     /* 2407493 */   // Label 34613: @2407493
     /* 2407493 */   GIM_Try, /*On fail goto*//*Label 34614*/ GIMT_Encode4(2407555), // Rule ID 72527 //
     /* 2407498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407528 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2407531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407554 */     // GIR_Coverage, 72527,
     /* 2407554 */     GIR_EraseRootFromParent_Done,
     /* 2407555 */   // Label 34614: @2407555
     /* 2407555 */   GIM_Try, /*On fail goto*//*Label 34615*/ GIMT_Encode4(2407617), // Rule ID 54958 //
     /* 2407560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2407575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407590 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2407593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2407603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407616 */     // GIR_Coverage, 54958,
     /* 2407616 */     GIR_EraseRootFromParent_Done,
     /* 2407617 */   // Label 34615: @2407617
     /* 2407617 */   GIM_Try, /*On fail goto*//*Label 34616*/ GIMT_Encode4(2407679), // Rule ID 54959 //
     /* 2407622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2407637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2407652 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2407655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2407665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407678 */     // GIR_Coverage, 54959,
     /* 2407678 */     GIR_EraseRootFromParent_Done,
     /* 2407679 */   // Label 34616: @2407679
     /* 2407679 */   GIM_Try, /*On fail goto*//*Label 34617*/ GIMT_Encode4(2407724), // Rule ID 54954 //
     /* 2407684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2407687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407699 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2407702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407723 */     // GIR_Coverage, 54954,
     /* 2407723 */     GIR_EraseRootFromParent_Done,
     /* 2407724 */   // Label 34617: @2407724
     /* 2407724 */   GIM_Try, /*On fail goto*//*Label 34618*/ GIMT_Encode4(2407769), // Rule ID 54955 //
     /* 2407729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2407732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407744 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2407747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2407753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2407755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407768 */     // GIR_Coverage, 54955,
     /* 2407768 */     GIR_EraseRootFromParent_Done,
     /* 2407769 */   // Label 34618: @2407769
     /* 2407769 */   GIM_Reject,
     /* 2407770 */ // Label 34606: @2407770
     /* 2407770 */ GIM_Reject,
     /* 2407771 */ // Label 34498: @2407771
     /* 2407771 */ GIM_Try, /*On fail goto*//*Label 34619*/ GIMT_Encode4(2408560),
     /* 2407776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2407779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2407782 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2407785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407789 */   GIM_Try, /*On fail goto*//*Label 34620*/ GIMT_Encode4(2407866), // Rule ID 55154 //
     /* 2407794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2407797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2407809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2407830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407837 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2407840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407865 */     // GIR_Coverage, 55154,
     /* 2407865 */     GIR_EraseRootFromParent_Done,
     /* 2407866 */   // Label 34620: @2407866
     /* 2407866 */   GIM_Try, /*On fail goto*//*Label 34621*/ GIMT_Encode4(2407943), // Rule ID 55155 //
     /* 2407871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2407874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2407878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2407886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2407907 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407914 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2407914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2407917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2407921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2407925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2407929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2407932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2407935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2407938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2407941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407942 */     // GIR_Coverage, 55155,
     /* 2407942 */     GIR_EraseRootFromParent_Done,
     /* 2407943 */   // Label 34621: @2407943
     /* 2407943 */   GIM_Try, /*On fail goto*//*Label 34622*/ GIMT_Encode4(2408020), // Rule ID 72690 //
     /* 2407948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2407951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2407959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2407967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2407976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2407980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2407984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2407991 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2407991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2407994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2407998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408019 */     // GIR_Coverage, 72690,
     /* 2408019 */     GIR_EraseRootFromParent_Done,
     /* 2408020 */   // Label 34622: @2408020
     /* 2408020 */   GIM_Try, /*On fail goto*//*Label 34623*/ GIMT_Encode4(2408097), // Rule ID 72691 //
     /* 2408025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408044 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408068 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2408071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408096 */     // GIR_Coverage, 72691,
     /* 2408096 */     GIR_EraseRootFromParent_Done,
     /* 2408097 */   // Label 34623: @2408097
     /* 2408097 */   GIM_Try, /*On fail goto*//*Label 34624*/ GIMT_Encode4(2408159), // Rule ID 55158 //
     /* 2408102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408132 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2408135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408158 */     // GIR_Coverage, 55158,
     /* 2408158 */     GIR_EraseRootFromParent_Done,
     /* 2408159 */   // Label 34624: @2408159
     /* 2408159 */   GIM_Try, /*On fail goto*//*Label 34625*/ GIMT_Encode4(2408221), // Rule ID 55159 //
     /* 2408164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408194 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2408197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408220 */     // GIR_Coverage, 55159,
     /* 2408220 */     GIR_EraseRootFromParent_Done,
     /* 2408221 */   // Label 34625: @2408221
     /* 2408221 */   GIM_Try, /*On fail goto*//*Label 34626*/ GIMT_Encode4(2408283), // Rule ID 72694 //
     /* 2408226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408256 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2408259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408282 */     // GIR_Coverage, 72694,
     /* 2408282 */     GIR_EraseRootFromParent_Done,
     /* 2408283 */   // Label 34626: @2408283
     /* 2408283 */   GIM_Try, /*On fail goto*//*Label 34627*/ GIMT_Encode4(2408345), // Rule ID 72695 //
     /* 2408288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408318 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2408321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408344 */     // GIR_Coverage, 72695,
     /* 2408344 */     GIR_EraseRootFromParent_Done,
     /* 2408345 */   // Label 34627: @2408345
     /* 2408345 */   GIM_Try, /*On fail goto*//*Label 34628*/ GIMT_Encode4(2408407), // Rule ID 55150 //
     /* 2408350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408380 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2408383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408389 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2408393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408406 */     // GIR_Coverage, 55150,
     /* 2408406 */     GIR_EraseRootFromParent_Done,
     /* 2408407 */   // Label 34628: @2408407
     /* 2408407 */   GIM_Try, /*On fail goto*//*Label 34629*/ GIMT_Encode4(2408469), // Rule ID 55151 //
     /* 2408412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2408427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408442 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2408445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2408455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408468 */     // GIR_Coverage, 55151,
     /* 2408468 */     GIR_EraseRootFromParent_Done,
     /* 2408469 */   // Label 34629: @2408469
     /* 2408469 */   GIM_Try, /*On fail goto*//*Label 34630*/ GIMT_Encode4(2408514), // Rule ID 55146 //
     /* 2408474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2408477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408489 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2408492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408513 */     // GIR_Coverage, 55146,
     /* 2408513 */     GIR_EraseRootFromParent_Done,
     /* 2408514 */   // Label 34630: @2408514
     /* 2408514 */   GIM_Try, /*On fail goto*//*Label 34631*/ GIMT_Encode4(2408559), // Rule ID 55147 //
     /* 2408519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2408522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408534 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2408537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2408543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408558 */     // GIR_Coverage, 55147,
     /* 2408558 */     GIR_EraseRootFromParent_Done,
     /* 2408559 */   // Label 34631: @2408559
     /* 2408559 */   GIM_Reject,
     /* 2408560 */ // Label 34619: @2408560
     /* 2408560 */ GIM_Reject,
     /* 2408561 */ // Label 34499: @2408561
     /* 2408561 */ GIM_Try, /*On fail goto*//*Label 34632*/ GIMT_Encode4(2409350),
     /* 2408566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2408572 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2408575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408579 */   GIM_Try, /*On fail goto*//*Label 34633*/ GIMT_Encode4(2408656), // Rule ID 54898 //
     /* 2408584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408627 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2408630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408655 */     // GIR_Coverage, 54898,
     /* 2408655 */     GIR_EraseRootFromParent_Done,
     /* 2408656 */   // Label 34633: @2408656
     /* 2408656 */   GIM_Try, /*On fail goto*//*Label 34634*/ GIMT_Encode4(2408733), // Rule ID 54899 //
     /* 2408661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408704 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2408707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408732 */     // GIR_Coverage, 54899,
     /* 2408732 */     GIR_EraseRootFromParent_Done,
     /* 2408733 */   // Label 34634: @2408733
     /* 2408733 */   GIM_Try, /*On fail goto*//*Label 34635*/ GIMT_Encode4(2408810), // Rule ID 72466 //
     /* 2408738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408781 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2408784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408809 */     // GIR_Coverage, 72466,
     /* 2408809 */     GIR_EraseRootFromParent_Done,
     /* 2408810 */   // Label 34635: @2408810
     /* 2408810 */   GIM_Try, /*On fail goto*//*Label 34636*/ GIMT_Encode4(2408887), // Rule ID 72467 //
     /* 2408815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2408826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2408843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2408858 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2408861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2408865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2408873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408886 */     // GIR_Coverage, 72467,
     /* 2408886 */     GIR_EraseRootFromParent_Done,
     /* 2408887 */   // Label 34636: @2408887
     /* 2408887 */   GIM_Try, /*On fail goto*//*Label 34637*/ GIMT_Encode4(2408949), // Rule ID 54902 //
     /* 2408892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2408895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408922 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2408922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2408925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2408938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2408941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2408947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408948 */     // GIR_Coverage, 54902,
     /* 2408948 */     GIR_EraseRootFromParent_Done,
     /* 2408949 */   // Label 34637: @2408949
     /* 2408949 */   GIM_Try, /*On fail goto*//*Label 34638*/ GIMT_Encode4(2409011), // Rule ID 54903 //
     /* 2408954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2408957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2408961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2408965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2408984 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2408984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2408987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2408991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2408995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2408997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409010 */     // GIR_Coverage, 54903,
     /* 2409010 */     GIR_EraseRootFromParent_Done,
     /* 2409011 */   // Label 34638: @2409011
     /* 2409011 */   GIM_Try, /*On fail goto*//*Label 34639*/ GIMT_Encode4(2409073), // Rule ID 72470 //
     /* 2409016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409046 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2409049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409072 */     // GIR_Coverage, 72470,
     /* 2409072 */     GIR_EraseRootFromParent_Done,
     /* 2409073 */   // Label 34639: @2409073
     /* 2409073 */   GIM_Try, /*On fail goto*//*Label 34640*/ GIMT_Encode4(2409135), // Rule ID 72471 //
     /* 2409078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409108 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2409111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409134 */     // GIR_Coverage, 72471,
     /* 2409134 */     GIR_EraseRootFromParent_Done,
     /* 2409135 */   // Label 34640: @2409135
     /* 2409135 */   GIM_Try, /*On fail goto*//*Label 34641*/ GIMT_Encode4(2409197), // Rule ID 54894 //
     /* 2409140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2409155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409170 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2409173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2409183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409196 */     // GIR_Coverage, 54894,
     /* 2409196 */     GIR_EraseRootFromParent_Done,
     /* 2409197 */   // Label 34641: @2409197
     /* 2409197 */   GIM_Try, /*On fail goto*//*Label 34642*/ GIMT_Encode4(2409259), // Rule ID 54895 //
     /* 2409202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2409217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2409225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409232 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2409235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2409245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409258 */     // GIR_Coverage, 54895,
     /* 2409258 */     GIR_EraseRootFromParent_Done,
     /* 2409259 */   // Label 34642: @2409259
     /* 2409259 */   GIM_Try, /*On fail goto*//*Label 34643*/ GIMT_Encode4(2409304), // Rule ID 54890 //
     /* 2409264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2409267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409279 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2409282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409303 */     // GIR_Coverage, 54890,
     /* 2409303 */     GIR_EraseRootFromParent_Done,
     /* 2409304 */   // Label 34643: @2409304
     /* 2409304 */   GIM_Try, /*On fail goto*//*Label 34644*/ GIMT_Encode4(2409349), // Rule ID 54891 //
     /* 2409309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2409312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409324 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2409327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409348 */     // GIR_Coverage, 54891,
     /* 2409348 */     GIR_EraseRootFromParent_Done,
     /* 2409349 */   // Label 34644: @2409349
     /* 2409349 */   GIM_Reject,
     /* 2409350 */ // Label 34632: @2409350
     /* 2409350 */ GIM_Reject,
     /* 2409351 */ // Label 34500: @2409351
     /* 2409351 */ GIM_Try, /*On fail goto*//*Label 34645*/ GIMT_Encode4(2410140),
     /* 2409356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2409362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2409365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409369 */   GIM_Try, /*On fail goto*//*Label 34646*/ GIMT_Encode4(2409446), // Rule ID 55090 //
     /* 2409374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409417 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2409420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409445 */     // GIR_Coverage, 55090,
     /* 2409445 */     GIR_EraseRootFromParent_Done,
     /* 2409446 */   // Label 34646: @2409446
     /* 2409446 */   GIM_Try, /*On fail goto*//*Label 34647*/ GIMT_Encode4(2409523), // Rule ID 55091 //
     /* 2409451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409494 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2409497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409522 */     // GIR_Coverage, 55091,
     /* 2409522 */     GIR_EraseRootFromParent_Done,
     /* 2409523 */   // Label 34647: @2409523
     /* 2409523 */   GIM_Try, /*On fail goto*//*Label 34648*/ GIMT_Encode4(2409600), // Rule ID 72634 //
     /* 2409528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409571 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2409574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409599 */     // GIR_Coverage, 72634,
     /* 2409599 */     GIR_EraseRootFromParent_Done,
     /* 2409600 */   // Label 34648: @2409600
     /* 2409600 */   GIM_Try, /*On fail goto*//*Label 34649*/ GIMT_Encode4(2409677), // Rule ID 72635 //
     /* 2409605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2409633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2409648 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2409651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2409663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409676 */     // GIR_Coverage, 72635,
     /* 2409676 */     GIR_EraseRootFromParent_Done,
     /* 2409677 */   // Label 34649: @2409677
     /* 2409677 */   GIM_Try, /*On fail goto*//*Label 34650*/ GIMT_Encode4(2409739), // Rule ID 55094 //
     /* 2409682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409712 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2409715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409738 */     // GIR_Coverage, 55094,
     /* 2409738 */     GIR_EraseRootFromParent_Done,
     /* 2409739 */   // Label 34650: @2409739
     /* 2409739 */   GIM_Try, /*On fail goto*//*Label 34651*/ GIMT_Encode4(2409801), // Rule ID 55095 //
     /* 2409744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2409751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409774 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2409777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409800 */     // GIR_Coverage, 55095,
     /* 2409800 */     GIR_EraseRootFromParent_Done,
     /* 2409801 */   // Label 34651: @2409801
     /* 2409801 */   GIM_Try, /*On fail goto*//*Label 34652*/ GIMT_Encode4(2409863), // Rule ID 72638 //
     /* 2409806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409836 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2409839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409862 */     // GIR_Coverage, 72638,
     /* 2409862 */     GIR_EraseRootFromParent_Done,
     /* 2409863 */   // Label 34652: @2409863
     /* 2409863 */   GIM_Try, /*On fail goto*//*Label 34653*/ GIMT_Encode4(2409925), // Rule ID 72639 //
     /* 2409868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2409879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409898 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2409898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2409901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2409905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2409909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2409911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409924 */     // GIR_Coverage, 72639,
     /* 2409924 */     GIR_EraseRootFromParent_Done,
     /* 2409925 */   // Label 34653: @2409925
     /* 2409925 */   GIM_Try, /*On fail goto*//*Label 34654*/ GIMT_Encode4(2409987), // Rule ID 55086 //
     /* 2409930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2409933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2409945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2409949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2409953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2409960 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2409960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2409963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2409967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2409969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2409973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2409976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2409979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2409985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409986 */     // GIR_Coverage, 55086,
     /* 2409986 */     GIR_EraseRootFromParent_Done,
     /* 2409987 */   // Label 34654: @2409987
     /* 2409987 */   GIM_Try, /*On fail goto*//*Label 34655*/ GIMT_Encode4(2410049), // Rule ID 55087 //
     /* 2409992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2409995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2410015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410022 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2410025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2410035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410048 */     // GIR_Coverage, 55087,
     /* 2410048 */     GIR_EraseRootFromParent_Done,
     /* 2410049 */   // Label 34655: @2410049
     /* 2410049 */   GIM_Try, /*On fail goto*//*Label 34656*/ GIMT_Encode4(2410094), // Rule ID 55082 //
     /* 2410054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2410057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410069 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2410072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410093 */     // GIR_Coverage, 55082,
     /* 2410093 */     GIR_EraseRootFromParent_Done,
     /* 2410094 */   // Label 34656: @2410094
     /* 2410094 */   GIM_Try, /*On fail goto*//*Label 34657*/ GIMT_Encode4(2410139), // Rule ID 55083 //
     /* 2410099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2410102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410114 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2410117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410138 */     // GIR_Coverage, 55083,
     /* 2410138 */     GIR_EraseRootFromParent_Done,
     /* 2410139 */   // Label 34657: @2410139
     /* 2410139 */   GIM_Reject,
     /* 2410140 */ // Label 34645: @2410140
     /* 2410140 */ GIM_Reject,
     /* 2410141 */ // Label 34501: @2410141
     /* 2410141 */ GIM_Try, /*On fail goto*//*Label 34658*/ GIMT_Encode4(2410930),
     /* 2410146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2410152 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2410155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410159 */   GIM_Try, /*On fail goto*//*Label 34659*/ GIMT_Encode4(2410236), // Rule ID 55602 //
     /* 2410164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410207 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2410210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410235 */     // GIR_Coverage, 55602,
     /* 2410235 */     GIR_EraseRootFromParent_Done,
     /* 2410236 */   // Label 34659: @2410236
     /* 2410236 */   GIM_Try, /*On fail goto*//*Label 34660*/ GIMT_Encode4(2410313), // Rule ID 55603 //
     /* 2410241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410284 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2410287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410312 */     // GIR_Coverage, 55603,
     /* 2410312 */     GIR_EraseRootFromParent_Done,
     /* 2410313 */   // Label 34660: @2410313
     /* 2410313 */   GIM_Try, /*On fail goto*//*Label 34661*/ GIMT_Encode4(2410390), // Rule ID 73082 //
     /* 2410318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410361 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2410364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410389 */     // GIR_Coverage, 73082,
     /* 2410389 */     GIR_EraseRootFromParent_Done,
     /* 2410390 */   // Label 34661: @2410390
     /* 2410390 */   GIM_Try, /*On fail goto*//*Label 34662*/ GIMT_Encode4(2410467), // Rule ID 73083 //
     /* 2410395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410438 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2410441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2410453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410466 */     // GIR_Coverage, 73083,
     /* 2410466 */     GIR_EraseRootFromParent_Done,
     /* 2410467 */   // Label 34662: @2410467
     /* 2410467 */   GIM_Try, /*On fail goto*//*Label 34663*/ GIMT_Encode4(2410529), // Rule ID 55606 //
     /* 2410472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410502 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2410505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410528 */     // GIR_Coverage, 55606,
     /* 2410528 */     GIR_EraseRootFromParent_Done,
     /* 2410529 */   // Label 34663: @2410529
     /* 2410529 */   GIM_Try, /*On fail goto*//*Label 34664*/ GIMT_Encode4(2410591), // Rule ID 55607 //
     /* 2410534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410564 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2410567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410590 */     // GIR_Coverage, 55607,
     /* 2410590 */     GIR_EraseRootFromParent_Done,
     /* 2410591 */   // Label 34664: @2410591
     /* 2410591 */   GIM_Try, /*On fail goto*//*Label 34665*/ GIMT_Encode4(2410653), // Rule ID 73086 //
     /* 2410596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410626 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2410629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410652 */     // GIR_Coverage, 73086,
     /* 2410652 */     GIR_EraseRootFromParent_Done,
     /* 2410653 */   // Label 34665: @2410653
     /* 2410653 */   GIM_Try, /*On fail goto*//*Label 34666*/ GIMT_Encode4(2410715), // Rule ID 73087 //
     /* 2410658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2410669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410688 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2410691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2410695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2410699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410714 */     // GIR_Coverage, 73087,
     /* 2410714 */     GIR_EraseRootFromParent_Done,
     /* 2410715 */   // Label 34666: @2410715
     /* 2410715 */   GIM_Try, /*On fail goto*//*Label 34667*/ GIMT_Encode4(2410777), // Rule ID 55598 //
     /* 2410720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410750 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2410753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2410763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410776 */     // GIR_Coverage, 55598,
     /* 2410776 */     GIR_EraseRootFromParent_Done,
     /* 2410777 */   // Label 34667: @2410777
     /* 2410777 */   GIM_Try, /*On fail goto*//*Label 34668*/ GIMT_Encode4(2410839), // Rule ID 55599 //
     /* 2410782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2410797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2410805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2410812 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2410815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2410825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410838 */     // GIR_Coverage, 55599,
     /* 2410838 */     GIR_EraseRootFromParent_Done,
     /* 2410839 */   // Label 34668: @2410839
     /* 2410839 */   GIM_Try, /*On fail goto*//*Label 34669*/ GIMT_Encode4(2410884), // Rule ID 55594 //
     /* 2410844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2410847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410859 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2410862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410883 */     // GIR_Coverage, 55594,
     /* 2410883 */     GIR_EraseRootFromParent_Done,
     /* 2410884 */   // Label 34669: @2410884
     /* 2410884 */   GIM_Try, /*On fail goto*//*Label 34670*/ GIMT_Encode4(2410929), // Rule ID 55595 //
     /* 2410889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2410892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410904 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2410904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2410907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2410911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2410913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2410915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2410918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2410921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2410927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410928 */     // GIR_Coverage, 55595,
     /* 2410928 */     GIR_EraseRootFromParent_Done,
     /* 2410929 */   // Label 34670: @2410929
     /* 2410929 */   GIM_Reject,
     /* 2410930 */ // Label 34658: @2410930
     /* 2410930 */ GIM_Reject,
     /* 2410931 */ // Label 34502: @2410931
     /* 2410931 */ GIM_Try, /*On fail goto*//*Label 34671*/ GIMT_Encode4(2411720),
     /* 2410936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2410939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2410942 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2410945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410949 */   GIM_Try, /*On fail goto*//*Label 34672*/ GIMT_Encode4(2411026), // Rule ID 55026 //
     /* 2410954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2410957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2410961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2410969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2410982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2410986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2410990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2410995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2410997 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2410997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2411000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411025 */     // GIR_Coverage, 55026,
     /* 2411025 */     GIR_EraseRootFromParent_Done,
     /* 2411026 */   // Label 34672: @2411026
     /* 2411026 */   GIM_Try, /*On fail goto*//*Label 34673*/ GIMT_Encode4(2411103), // Rule ID 55027 //
     /* 2411031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411074 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2411077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411102 */     // GIR_Coverage, 55027,
     /* 2411102 */     GIR_EraseRootFromParent_Done,
     /* 2411103 */   // Label 34673: @2411103
     /* 2411103 */   GIM_Try, /*On fail goto*//*Label 34674*/ GIMT_Encode4(2411180), // Rule ID 72578 //
     /* 2411108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411151 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2411154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411179 */     // GIR_Coverage, 72578,
     /* 2411179 */     GIR_EraseRootFromParent_Done,
     /* 2411180 */   // Label 34674: @2411180
     /* 2411180 */   GIM_Try, /*On fail goto*//*Label 34675*/ GIMT_Encode4(2411257), // Rule ID 72579 //
     /* 2411185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411228 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2411231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411256 */     // GIR_Coverage, 72579,
     /* 2411256 */     GIR_EraseRootFromParent_Done,
     /* 2411257 */   // Label 34675: @2411257
     /* 2411257 */   GIM_Try, /*On fail goto*//*Label 34676*/ GIMT_Encode4(2411319), // Rule ID 55030 //
     /* 2411262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411292 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2411295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411318 */     // GIR_Coverage, 55030,
     /* 2411318 */     GIR_EraseRootFromParent_Done,
     /* 2411319 */   // Label 34676: @2411319
     /* 2411319 */   GIM_Try, /*On fail goto*//*Label 34677*/ GIMT_Encode4(2411381), // Rule ID 55031 //
     /* 2411324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411354 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2411357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411380 */     // GIR_Coverage, 55031,
     /* 2411380 */     GIR_EraseRootFromParent_Done,
     /* 2411381 */   // Label 34677: @2411381
     /* 2411381 */   GIM_Try, /*On fail goto*//*Label 34678*/ GIMT_Encode4(2411443), // Rule ID 72582 //
     /* 2411386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411416 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2411419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411442 */     // GIR_Coverage, 72582,
     /* 2411442 */     GIR_EraseRootFromParent_Done,
     /* 2411443 */   // Label 34678: @2411443
     /* 2411443 */   GIM_Try, /*On fail goto*//*Label 34679*/ GIMT_Encode4(2411505), // Rule ID 72583 //
     /* 2411448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411478 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2411481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411504 */     // GIR_Coverage, 72583,
     /* 2411504 */     GIR_EraseRootFromParent_Done,
     /* 2411505 */   // Label 34679: @2411505
     /* 2411505 */   GIM_Try, /*On fail goto*//*Label 34680*/ GIMT_Encode4(2411567), // Rule ID 55022 //
     /* 2411510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411540 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2411543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2411553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411566 */     // GIR_Coverage, 55022,
     /* 2411566 */     GIR_EraseRootFromParent_Done,
     /* 2411567 */   // Label 34680: @2411567
     /* 2411567 */   GIM_Try, /*On fail goto*//*Label 34681*/ GIMT_Encode4(2411629), // Rule ID 55023 //
     /* 2411572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2411595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411602 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2411605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2411615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411628 */     // GIR_Coverage, 55023,
     /* 2411628 */     GIR_EraseRootFromParent_Done,
     /* 2411629 */   // Label 34681: @2411629
     /* 2411629 */   GIM_Try, /*On fail goto*//*Label 34682*/ GIMT_Encode4(2411674), // Rule ID 55018 //
     /* 2411634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2411637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411649 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2411652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411673 */     // GIR_Coverage, 55018,
     /* 2411673 */     GIR_EraseRootFromParent_Done,
     /* 2411674 */   // Label 34682: @2411674
     /* 2411674 */   GIM_Try, /*On fail goto*//*Label 34683*/ GIMT_Encode4(2411719), // Rule ID 55019 //
     /* 2411679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2411682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411694 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2411697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2411703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2411705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411718 */     // GIR_Coverage, 55019,
     /* 2411718 */     GIR_EraseRootFromParent_Done,
     /* 2411719 */   // Label 34683: @2411719
     /* 2411719 */   GIM_Reject,
     /* 2411720 */ // Label 34671: @2411720
     /* 2411720 */ GIM_Reject,
     /* 2411721 */ // Label 34503: @2411721
     /* 2411721 */ GIM_Try, /*On fail goto*//*Label 34684*/ GIMT_Encode4(2412510),
     /* 2411726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2411729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2411732 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2411735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411739 */   GIM_Try, /*On fail goto*//*Label 34685*/ GIMT_Encode4(2411816), // Rule ID 55410 //
     /* 2411744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2411747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2411759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2411780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411787 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2411790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411815 */     // GIR_Coverage, 55410,
     /* 2411815 */     GIR_EraseRootFromParent_Done,
     /* 2411816 */   // Label 34685: @2411816
     /* 2411816 */   GIM_Try, /*On fail goto*//*Label 34686*/ GIMT_Encode4(2411893), // Rule ID 55411 //
     /* 2411821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2411824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2411828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2411836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2411857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411864 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2411864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2411867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2411871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411892 */     // GIR_Coverage, 55411,
     /* 2411892 */     GIR_EraseRootFromParent_Done,
     /* 2411893 */   // Label 34686: @2411893
     /* 2411893 */   GIM_Try, /*On fail goto*//*Label 34687*/ GIMT_Encode4(2411970), // Rule ID 72914 //
     /* 2411898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2411901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2411917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2411926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2411934 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2411941 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2411941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2411944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2411952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2411956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2411959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2411962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2411968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411969 */     // GIR_Coverage, 72914,
     /* 2411969 */     GIR_EraseRootFromParent_Done,
     /* 2411970 */   // Label 34687: @2411970
     /* 2411970 */   GIM_Try, /*On fail goto*//*Label 34688*/ GIMT_Encode4(2412047), // Rule ID 72915 //
     /* 2411975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2411978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2411986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2411990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2411994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2411999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412018 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2412021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412046 */     // GIR_Coverage, 72915,
     /* 2412046 */     GIR_EraseRootFromParent_Done,
     /* 2412047 */   // Label 34688: @2412047
     /* 2412047 */   GIM_Try, /*On fail goto*//*Label 34689*/ GIMT_Encode4(2412109), // Rule ID 55414 //
     /* 2412052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412082 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2412085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412108 */     // GIR_Coverage, 55414,
     /* 2412108 */     GIR_EraseRootFromParent_Done,
     /* 2412109 */   // Label 34689: @2412109
     /* 2412109 */   GIM_Try, /*On fail goto*//*Label 34690*/ GIMT_Encode4(2412171), // Rule ID 55415 //
     /* 2412114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412144 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2412147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412170 */     // GIR_Coverage, 55415,
     /* 2412170 */     GIR_EraseRootFromParent_Done,
     /* 2412171 */   // Label 34690: @2412171
     /* 2412171 */   GIM_Try, /*On fail goto*//*Label 34691*/ GIMT_Encode4(2412233), // Rule ID 72918 //
     /* 2412176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412206 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2412209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412232 */     // GIR_Coverage, 72918,
     /* 2412232 */     GIR_EraseRootFromParent_Done,
     /* 2412233 */   // Label 34691: @2412233
     /* 2412233 */   GIM_Try, /*On fail goto*//*Label 34692*/ GIMT_Encode4(2412295), // Rule ID 72919 //
     /* 2412238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412268 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2412271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412294 */     // GIR_Coverage, 72919,
     /* 2412294 */     GIR_EraseRootFromParent_Done,
     /* 2412295 */   // Label 34692: @2412295
     /* 2412295 */   GIM_Try, /*On fail goto*//*Label 34693*/ GIMT_Encode4(2412357), // Rule ID 55406 //
     /* 2412300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412330 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2412333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2412343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412356 */     // GIR_Coverage, 55406,
     /* 2412356 */     GIR_EraseRootFromParent_Done,
     /* 2412357 */   // Label 34693: @2412357
     /* 2412357 */   GIM_Try, /*On fail goto*//*Label 34694*/ GIMT_Encode4(2412419), // Rule ID 55407 //
     /* 2412362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2412385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412392 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2412395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2412405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412418 */     // GIR_Coverage, 55407,
     /* 2412418 */     GIR_EraseRootFromParent_Done,
     /* 2412419 */   // Label 34694: @2412419
     /* 2412419 */   GIM_Try, /*On fail goto*//*Label 34695*/ GIMT_Encode4(2412464), // Rule ID 55402 //
     /* 2412424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2412427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412439 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2412442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412463 */     // GIR_Coverage, 55402,
     /* 2412463 */     GIR_EraseRootFromParent_Done,
     /* 2412464 */   // Label 34695: @2412464
     /* 2412464 */   GIM_Try, /*On fail goto*//*Label 34696*/ GIMT_Encode4(2412509), // Rule ID 55403 //
     /* 2412469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2412472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2412484 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2412487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2412493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412508 */     // GIR_Coverage, 55403,
     /* 2412508 */     GIR_EraseRootFromParent_Done,
     /* 2412509 */   // Label 34696: @2412509
     /* 2412509 */   GIM_Reject,
     /* 2412510 */ // Label 34684: @2412510
     /* 2412510 */ GIM_Reject,
     /* 2412511 */ // Label 34504: @2412511
     /* 2412511 */ GIM_Try, /*On fail goto*//*Label 34697*/ GIMT_Encode4(2413300),
     /* 2412516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2412522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2412525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412529 */   GIM_Try, /*On fail goto*//*Label 34698*/ GIMT_Encode4(2412606), // Rule ID 55666 //
     /* 2412534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412577 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2412580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412605 */     // GIR_Coverage, 55666,
     /* 2412605 */     GIR_EraseRootFromParent_Done,
     /* 2412606 */   // Label 34698: @2412606
     /* 2412606 */   GIM_Try, /*On fail goto*//*Label 34699*/ GIMT_Encode4(2412683), // Rule ID 55667 //
     /* 2412611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2412614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412654 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2412657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412682 */     // GIR_Coverage, 55667,
     /* 2412682 */     GIR_EraseRootFromParent_Done,
     /* 2412683 */   // Label 34699: @2412683
     /* 2412683 */   GIM_Try, /*On fail goto*//*Label 34700*/ GIMT_Encode4(2412760), // Rule ID 73138 //
     /* 2412688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412731 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2412734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412759 */     // GIR_Coverage, 73138,
     /* 2412759 */     GIR_EraseRootFromParent_Done,
     /* 2412760 */   // Label 34700: @2412760
     /* 2412760 */   GIM_Try, /*On fail goto*//*Label 34701*/ GIMT_Encode4(2412837), // Rule ID 73139 //
     /* 2412765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2412768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2412793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2412808 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2412811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2412823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412836 */     // GIR_Coverage, 73139,
     /* 2412836 */     GIR_EraseRootFromParent_Done,
     /* 2412837 */   // Label 34701: @2412837
     /* 2412837 */   GIM_Try, /*On fail goto*//*Label 34702*/ GIMT_Encode4(2412899), // Rule ID 55670 //
     /* 2412842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412872 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2412875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412898 */     // GIR_Coverage, 55670,
     /* 2412898 */     GIR_EraseRootFromParent_Done,
     /* 2412899 */   // Label 34702: @2412899
     /* 2412899 */   GIM_Try, /*On fail goto*//*Label 34703*/ GIMT_Encode4(2412961), // Rule ID 55671 //
     /* 2412904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2412907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2412911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412934 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2412934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2412937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2412941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2412945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2412950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2412953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2412956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2412959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412960 */     // GIR_Coverage, 55671,
     /* 2412960 */     GIR_EraseRootFromParent_Done,
     /* 2412961 */   // Label 34703: @2412961
     /* 2412961 */   GIM_Try, /*On fail goto*//*Label 34704*/ GIMT_Encode4(2413023), // Rule ID 73142 //
     /* 2412966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2412969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2412977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2412981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2412985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2412994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412996 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2412996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2412999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413022 */     // GIR_Coverage, 73142,
     /* 2413022 */     GIR_EraseRootFromParent_Done,
     /* 2413023 */   // Label 34704: @2413023
     /* 2413023 */   GIM_Try, /*On fail goto*//*Label 34705*/ GIMT_Encode4(2413085), // Rule ID 73143 //
     /* 2413028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413058 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2413061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413084 */     // GIR_Coverage, 73143,
     /* 2413084 */     GIR_EraseRootFromParent_Done,
     /* 2413085 */   // Label 34705: @2413085
     /* 2413085 */   GIM_Try, /*On fail goto*//*Label 34706*/ GIMT_Encode4(2413147), // Rule ID 55662 //
     /* 2413090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413120 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2413123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413146 */     // GIR_Coverage, 55662,
     /* 2413146 */     GIR_EraseRootFromParent_Done,
     /* 2413147 */   // Label 34706: @2413147
     /* 2413147 */   GIM_Try, /*On fail goto*//*Label 34707*/ GIMT_Encode4(2413209), // Rule ID 55663 //
     /* 2413152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2413175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413182 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2413185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413208 */     // GIR_Coverage, 55663,
     /* 2413208 */     GIR_EraseRootFromParent_Done,
     /* 2413209 */   // Label 34707: @2413209
     /* 2413209 */   GIM_Try, /*On fail goto*//*Label 34708*/ GIMT_Encode4(2413254), // Rule ID 55658 //
     /* 2413214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2413217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413229 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2413232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413253 */     // GIR_Coverage, 55658,
     /* 2413253 */     GIR_EraseRootFromParent_Done,
     /* 2413254 */   // Label 34708: @2413254
     /* 2413254 */   GIM_Try, /*On fail goto*//*Label 34709*/ GIMT_Encode4(2413299), // Rule ID 55659 //
     /* 2413259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2413262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2413274 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2413277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413298 */     // GIR_Coverage, 55659,
     /* 2413298 */     GIR_EraseRootFromParent_Done,
     /* 2413299 */   // Label 34709: @2413299
     /* 2413299 */   GIM_Reject,
     /* 2413300 */ // Label 34697: @2413300
     /* 2413300 */ GIM_Reject,
     /* 2413301 */ // Label 34505: @2413301
     /* 2413301 */ GIM_Try, /*On fail goto*//*Label 34710*/ GIMT_Encode4(2414090),
     /* 2413306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2413312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2413315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413319 */   GIM_Try, /*On fail goto*//*Label 34711*/ GIMT_Encode4(2413396), // Rule ID 55218 //
     /* 2413324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413367 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2413370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413395 */     // GIR_Coverage, 55218,
     /* 2413395 */     GIR_EraseRootFromParent_Done,
     /* 2413396 */   // Label 34711: @2413396
     /* 2413396 */   GIM_Try, /*On fail goto*//*Label 34712*/ GIMT_Encode4(2413473), // Rule ID 55219 //
     /* 2413401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413444 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2413447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413472 */     // GIR_Coverage, 55219,
     /* 2413472 */     GIR_EraseRootFromParent_Done,
     /* 2413473 */   // Label 34712: @2413473
     /* 2413473 */   GIM_Try, /*On fail goto*//*Label 34713*/ GIMT_Encode4(2413550), // Rule ID 72746 //
     /* 2413478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413521 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2413524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413549 */     // GIR_Coverage, 72746,
     /* 2413549 */     GIR_EraseRootFromParent_Done,
     /* 2413550 */   // Label 34713: @2413550
     /* 2413550 */   GIM_Try, /*On fail goto*//*Label 34714*/ GIMT_Encode4(2413627), // Rule ID 72747 //
     /* 2413555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2413583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2413598 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2413601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2413613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413626 */     // GIR_Coverage, 72747,
     /* 2413626 */     GIR_EraseRootFromParent_Done,
     /* 2413627 */   // Label 34714: @2413627
     /* 2413627 */   GIM_Try, /*On fail goto*//*Label 34715*/ GIMT_Encode4(2413689), // Rule ID 55222 //
     /* 2413632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413662 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2413665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413688 */     // GIR_Coverage, 55222,
     /* 2413688 */     GIR_EraseRootFromParent_Done,
     /* 2413689 */   // Label 34715: @2413689
     /* 2413689 */   GIM_Try, /*On fail goto*//*Label 34716*/ GIMT_Encode4(2413751), // Rule ID 55223 //
     /* 2413694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2413701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413724 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2413727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413750 */     // GIR_Coverage, 55223,
     /* 2413750 */     GIR_EraseRootFromParent_Done,
     /* 2413751 */   // Label 34716: @2413751
     /* 2413751 */   GIM_Try, /*On fail goto*//*Label 34717*/ GIMT_Encode4(2413813), // Rule ID 72750 //
     /* 2413756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413786 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2413789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413812 */     // GIR_Coverage, 72750,
     /* 2413812 */     GIR_EraseRootFromParent_Done,
     /* 2413813 */   // Label 34717: @2413813
     /* 2413813 */   GIM_Try, /*On fail goto*//*Label 34718*/ GIMT_Encode4(2413875), // Rule ID 72751 //
     /* 2413818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2413829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413848 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2413851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2413859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413874 */     // GIR_Coverage, 72751,
     /* 2413874 */     GIR_EraseRootFromParent_Done,
     /* 2413875 */   // Label 34718: @2413875
     /* 2413875 */   GIM_Try, /*On fail goto*//*Label 34719*/ GIMT_Encode4(2413937), // Rule ID 55214 //
     /* 2413880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2413883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413910 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2413910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2413913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413936 */     // GIR_Coverage, 55214,
     /* 2413936 */     GIR_EraseRootFromParent_Done,
     /* 2413937 */   // Label 34719: @2413937
     /* 2413937 */   GIM_Try, /*On fail goto*//*Label 34720*/ GIMT_Encode4(2413999), // Rule ID 55215 //
     /* 2413942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2413945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2413961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2413965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2413970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413972 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2413972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2413975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2413979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2413981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2413985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2413988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2413991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2413994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2413997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413998 */     // GIR_Coverage, 55215,
     /* 2413998 */     GIR_EraseRootFromParent_Done,
     /* 2413999 */   // Label 34720: @2413999
     /* 2413999 */   GIM_Try, /*On fail goto*//*Label 34721*/ GIMT_Encode4(2414044), // Rule ID 55210 //
     /* 2414004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2414007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414019 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2414022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414043 */     // GIR_Coverage, 55210,
     /* 2414043 */     GIR_EraseRootFromParent_Done,
     /* 2414044 */   // Label 34721: @2414044
     /* 2414044 */   GIM_Try, /*On fail goto*//*Label 34722*/ GIMT_Encode4(2414089), // Rule ID 55211 //
     /* 2414049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2414052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2414064 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2414067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414088 */     // GIR_Coverage, 55211,
     /* 2414088 */     GIR_EraseRootFromParent_Done,
     /* 2414089 */   // Label 34722: @2414089
     /* 2414089 */   GIM_Reject,
     /* 2414090 */ // Label 34710: @2414090
     /* 2414090 */ GIM_Reject,
     /* 2414091 */ // Label 34506: @2414091
     /* 2414091 */ GIM_Try, /*On fail goto*//*Label 34723*/ GIMT_Encode4(2414880),
     /* 2414096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2414102 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2414105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414109 */   GIM_Try, /*On fail goto*//*Label 34724*/ GIMT_Encode4(2414186), // Rule ID 55474 //
     /* 2414114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414157 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2414160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414185 */     // GIR_Coverage, 55474,
     /* 2414185 */     GIR_EraseRootFromParent_Done,
     /* 2414186 */   // Label 34724: @2414186
     /* 2414186 */   GIM_Try, /*On fail goto*//*Label 34725*/ GIMT_Encode4(2414263), // Rule ID 55475 //
     /* 2414191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414234 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2414237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414262 */     // GIR_Coverage, 55475,
     /* 2414262 */     GIR_EraseRootFromParent_Done,
     /* 2414263 */   // Label 34725: @2414263
     /* 2414263 */   GIM_Try, /*On fail goto*//*Label 34726*/ GIMT_Encode4(2414340), // Rule ID 72970 //
     /* 2414268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414311 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2414314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414339 */     // GIR_Coverage, 72970,
     /* 2414339 */     GIR_EraseRootFromParent_Done,
     /* 2414340 */   // Label 34726: @2414340
     /* 2414340 */   GIM_Try, /*On fail goto*//*Label 34727*/ GIMT_Encode4(2414417), // Rule ID 72971 //
     /* 2414345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414388 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2414391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414416 */     // GIR_Coverage, 72971,
     /* 2414416 */     GIR_EraseRootFromParent_Done,
     /* 2414417 */   // Label 34727: @2414417
     /* 2414417 */   GIM_Try, /*On fail goto*//*Label 34728*/ GIMT_Encode4(2414479), // Rule ID 55478 //
     /* 2414422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414452 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2414455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414478 */     // GIR_Coverage, 55478,
     /* 2414478 */     GIR_EraseRootFromParent_Done,
     /* 2414479 */   // Label 34728: @2414479
     /* 2414479 */   GIM_Try, /*On fail goto*//*Label 34729*/ GIMT_Encode4(2414541), // Rule ID 55479 //
     /* 2414484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414514 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2414517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414540 */     // GIR_Coverage, 55479,
     /* 2414540 */     GIR_EraseRootFromParent_Done,
     /* 2414541 */   // Label 34729: @2414541
     /* 2414541 */   GIM_Try, /*On fail goto*//*Label 34730*/ GIMT_Encode4(2414603), // Rule ID 72974 //
     /* 2414546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414576 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2414579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414602 */     // GIR_Coverage, 72974,
     /* 2414602 */     GIR_EraseRootFromParent_Done,
     /* 2414603 */   // Label 34730: @2414603
     /* 2414603 */   GIM_Try, /*On fail goto*//*Label 34731*/ GIMT_Encode4(2414665), // Rule ID 72975 //
     /* 2414608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2414619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414638 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2414641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414664 */     // GIR_Coverage, 72975,
     /* 2414664 */     GIR_EraseRootFromParent_Done,
     /* 2414665 */   // Label 34731: @2414665
     /* 2414665 */   GIM_Try, /*On fail goto*//*Label 34732*/ GIMT_Encode4(2414727), // Rule ID 55470 //
     /* 2414670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414700 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2414703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414726 */     // GIR_Coverage, 55470,
     /* 2414726 */     GIR_EraseRootFromParent_Done,
     /* 2414727 */   // Label 34732: @2414727
     /* 2414727 */   GIM_Try, /*On fail goto*//*Label 34733*/ GIMT_Encode4(2414789), // Rule ID 55471 //
     /* 2414732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2414755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414762 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2414765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2414775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414788 */     // GIR_Coverage, 55471,
     /* 2414788 */     GIR_EraseRootFromParent_Done,
     /* 2414789 */   // Label 34733: @2414789
     /* 2414789 */   GIM_Try, /*On fail goto*//*Label 34734*/ GIMT_Encode4(2414834), // Rule ID 55466 //
     /* 2414794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2414797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414809 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2414812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414833 */     // GIR_Coverage, 55466,
     /* 2414833 */     GIR_EraseRootFromParent_Done,
     /* 2414834 */   // Label 34734: @2414834
     /* 2414834 */   GIM_Try, /*On fail goto*//*Label 34735*/ GIMT_Encode4(2414879), // Rule ID 55467 //
     /* 2414839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2414842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2414854 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2414854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2414857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2414863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2414874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414878 */     // GIR_Coverage, 55467,
     /* 2414878 */     GIR_EraseRootFromParent_Done,
     /* 2414879 */   // Label 34735: @2414879
     /* 2414879 */   GIM_Reject,
     /* 2414880 */ // Label 34723: @2414880
     /* 2414880 */ GIM_Reject,
     /* 2414881 */ // Label 34507: @2414881
     /* 2414881 */ GIM_Try, /*On fail goto*//*Label 34736*/ GIMT_Encode4(2415670),
     /* 2414886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2414889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2414892 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2414895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414899 */   GIM_Try, /*On fail goto*//*Label 34737*/ GIMT_Encode4(2414976), // Rule ID 55730 //
     /* 2414904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2414907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2414919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2414932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2414940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2414945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2414947 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2414947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2414950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2414954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2414958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2414962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2414965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2414968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2414974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414975 */     // GIR_Coverage, 55730,
     /* 2414975 */     GIR_EraseRootFromParent_Done,
     /* 2414976 */   // Label 34737: @2414976
     /* 2414976 */   GIM_Try, /*On fail goto*//*Label 34738*/ GIMT_Encode4(2415053), // Rule ID 55731 //
     /* 2414981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2414984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2414988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2414992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2414996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415024 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2415027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415052 */     // GIR_Coverage, 55731,
     /* 2415052 */     GIR_EraseRootFromParent_Done,
     /* 2415053 */   // Label 34738: @2415053
     /* 2415053 */   GIM_Try, /*On fail goto*//*Label 34739*/ GIMT_Encode4(2415130), // Rule ID 73194 //
     /* 2415058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415101 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2415104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415129 */     // GIR_Coverage, 73194,
     /* 2415129 */     GIR_EraseRootFromParent_Done,
     /* 2415130 */   // Label 34739: @2415130
     /* 2415130 */   GIM_Try, /*On fail goto*//*Label 34740*/ GIMT_Encode4(2415207), // Rule ID 73195 //
     /* 2415135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415178 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2415181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415206 */     // GIR_Coverage, 73195,
     /* 2415206 */     GIR_EraseRootFromParent_Done,
     /* 2415207 */   // Label 34740: @2415207
     /* 2415207 */   GIM_Try, /*On fail goto*//*Label 34741*/ GIMT_Encode4(2415269), // Rule ID 55734 //
     /* 2415212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415242 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2415245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415268 */     // GIR_Coverage, 55734,
     /* 2415268 */     GIR_EraseRootFromParent_Done,
     /* 2415269 */   // Label 34741: @2415269
     /* 2415269 */   GIM_Try, /*On fail goto*//*Label 34742*/ GIMT_Encode4(2415331), // Rule ID 55735 //
     /* 2415274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415304 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2415307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415330 */     // GIR_Coverage, 55735,
     /* 2415330 */     GIR_EraseRootFromParent_Done,
     /* 2415331 */   // Label 34742: @2415331
     /* 2415331 */   GIM_Try, /*On fail goto*//*Label 34743*/ GIMT_Encode4(2415393), // Rule ID 73198 //
     /* 2415336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415366 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2415369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415392 */     // GIR_Coverage, 73198,
     /* 2415392 */     GIR_EraseRootFromParent_Done,
     /* 2415393 */   // Label 34743: @2415393
     /* 2415393 */   GIM_Try, /*On fail goto*//*Label 34744*/ GIMT_Encode4(2415455), // Rule ID 73199 //
     /* 2415398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415428 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2415431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415454 */     // GIR_Coverage, 73199,
     /* 2415454 */     GIR_EraseRootFromParent_Done,
     /* 2415455 */   // Label 34744: @2415455
     /* 2415455 */   GIM_Try, /*On fail goto*//*Label 34745*/ GIMT_Encode4(2415517), // Rule ID 55726 //
     /* 2415460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415490 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2415493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415516 */     // GIR_Coverage, 55726,
     /* 2415516 */     GIR_EraseRootFromParent_Done,
     /* 2415517 */   // Label 34745: @2415517
     /* 2415517 */   GIM_Try, /*On fail goto*//*Label 34746*/ GIMT_Encode4(2415579), // Rule ID 55727 //
     /* 2415522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2415545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415552 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2415555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2415565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415578 */     // GIR_Coverage, 55727,
     /* 2415578 */     GIR_EraseRootFromParent_Done,
     /* 2415579 */   // Label 34746: @2415579
     /* 2415579 */   GIM_Try, /*On fail goto*//*Label 34747*/ GIMT_Encode4(2415624), // Rule ID 55722 //
     /* 2415584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2415587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415599 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2415602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415623 */     // GIR_Coverage, 55722,
     /* 2415623 */     GIR_EraseRootFromParent_Done,
     /* 2415624 */   // Label 34747: @2415624
     /* 2415624 */   GIM_Try, /*On fail goto*//*Label 34748*/ GIMT_Encode4(2415669), // Rule ID 55723 //
     /* 2415629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2415632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2415644 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2415647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2415653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415668 */     // GIR_Coverage, 55723,
     /* 2415668 */     GIR_EraseRootFromParent_Done,
     /* 2415669 */   // Label 34748: @2415669
     /* 2415669 */   GIM_Reject,
     /* 2415670 */ // Label 34736: @2415670
     /* 2415670 */ GIM_Reject,
     /* 2415671 */ // Label 34508: @2415671
     /* 2415671 */ GIM_Try, /*On fail goto*//*Label 34749*/ GIMT_Encode4(2416460),
     /* 2415676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2415682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2415685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415689 */   GIM_Try, /*On fail goto*//*Label 34750*/ GIMT_Encode4(2415766), // Rule ID 55282 //
     /* 2415694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415737 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2415740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415765 */     // GIR_Coverage, 55282,
     /* 2415765 */     GIR_EraseRootFromParent_Done,
     /* 2415766 */   // Label 34750: @2415766
     /* 2415766 */   GIM_Try, /*On fail goto*//*Label 34751*/ GIMT_Encode4(2415843), // Rule ID 55283 //
     /* 2415771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2415778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415814 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2415817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2415821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415842 */     // GIR_Coverage, 55283,
     /* 2415842 */     GIR_EraseRootFromParent_Done,
     /* 2415843 */   // Label 34751: @2415843
     /* 2415843 */   GIM_Try, /*On fail goto*//*Label 34752*/ GIMT_Encode4(2415920), // Rule ID 72802 //
     /* 2415848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2415851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415891 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2415891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2415894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415919 */     // GIR_Coverage, 72802,
     /* 2415919 */     GIR_EraseRootFromParent_Done,
     /* 2415920 */   // Label 34752: @2415920
     /* 2415920 */   GIM_Try, /*On fail goto*//*Label 34753*/ GIMT_Encode4(2415997), // Rule ID 72803 //
     /* 2415925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2415928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2415936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2415953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2415957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2415961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2415966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2415968 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2415968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2415971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2415979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2415983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2415986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2415989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2415992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2415995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415996 */     // GIR_Coverage, 72803,
     /* 2415996 */     GIR_EraseRootFromParent_Done,
     /* 2415997 */   // Label 34753: @2415997
     /* 2415997 */   GIM_Try, /*On fail goto*//*Label 34754*/ GIMT_Encode4(2416059), // Rule ID 55286 //
     /* 2416002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416032 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2416035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416058 */     // GIR_Coverage, 55286,
     /* 2416058 */     GIR_EraseRootFromParent_Done,
     /* 2416059 */   // Label 34754: @2416059
     /* 2416059 */   GIM_Try, /*On fail goto*//*Label 34755*/ GIMT_Encode4(2416121), // Rule ID 55287 //
     /* 2416064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416094 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2416097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416120 */     // GIR_Coverage, 55287,
     /* 2416120 */     GIR_EraseRootFromParent_Done,
     /* 2416121 */   // Label 34755: @2416121
     /* 2416121 */   GIM_Try, /*On fail goto*//*Label 34756*/ GIMT_Encode4(2416183), // Rule ID 72806 //
     /* 2416126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416156 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2416159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416182 */     // GIR_Coverage, 72806,
     /* 2416182 */     GIR_EraseRootFromParent_Done,
     /* 2416183 */   // Label 34756: @2416183
     /* 2416183 */   GIM_Try, /*On fail goto*//*Label 34757*/ GIMT_Encode4(2416245), // Rule ID 72807 //
     /* 2416188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416218 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2416221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416244 */     // GIR_Coverage, 72807,
     /* 2416244 */     GIR_EraseRootFromParent_Done,
     /* 2416245 */   // Label 34757: @2416245
     /* 2416245 */   GIM_Try, /*On fail goto*//*Label 34758*/ GIMT_Encode4(2416307), // Rule ID 55278 //
     /* 2416250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416280 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2416283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416306 */     // GIR_Coverage, 55278,
     /* 2416306 */     GIR_EraseRootFromParent_Done,
     /* 2416307 */   // Label 34758: @2416307
     /* 2416307 */   GIM_Try, /*On fail goto*//*Label 34759*/ GIMT_Encode4(2416369), // Rule ID 55279 //
     /* 2416312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2416335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416342 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2416345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416349 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2416355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416368 */     // GIR_Coverage, 55279,
     /* 2416368 */     GIR_EraseRootFromParent_Done,
     /* 2416369 */   // Label 34759: @2416369
     /* 2416369 */   GIM_Try, /*On fail goto*//*Label 34760*/ GIMT_Encode4(2416414), // Rule ID 55274 //
     /* 2416374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2416377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416389 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2416392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416413 */     // GIR_Coverage, 55274,
     /* 2416413 */     GIR_EraseRootFromParent_Done,
     /* 2416414 */   // Label 34760: @2416414
     /* 2416414 */   GIM_Try, /*On fail goto*//*Label 34761*/ GIMT_Encode4(2416459), // Rule ID 55275 //
     /* 2416419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2416422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2416434 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2416437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2416443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416458 */     // GIR_Coverage, 55275,
     /* 2416458 */     GIR_EraseRootFromParent_Done,
     /* 2416459 */   // Label 34761: @2416459
     /* 2416459 */   GIM_Reject,
     /* 2416460 */ // Label 34749: @2416460
     /* 2416460 */ GIM_Reject,
     /* 2416461 */ // Label 34509: @2416461
     /* 2416461 */ GIM_Try, /*On fail goto*//*Label 34762*/ GIMT_Encode4(2417250),
     /* 2416466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2416472 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2416475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416479 */   GIM_Try, /*On fail goto*//*Label 34763*/ GIMT_Encode4(2416556), // Rule ID 55538 //
     /* 2416484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416527 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2416530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416555 */     // GIR_Coverage, 55538,
     /* 2416555 */     GIR_EraseRootFromParent_Done,
     /* 2416556 */   // Label 34763: @2416556
     /* 2416556 */   GIM_Try, /*On fail goto*//*Label 34764*/ GIMT_Encode4(2416633), // Rule ID 55539 //
     /* 2416561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416602 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416604 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2416607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416632 */     // GIR_Coverage, 55539,
     /* 2416632 */     GIR_EraseRootFromParent_Done,
     /* 2416633 */   // Label 34764: @2416633
     /* 2416633 */   GIM_Try, /*On fail goto*//*Label 34765*/ GIMT_Encode4(2416710), // Rule ID 73026 //
     /* 2416638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416681 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2416684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416709 */     // GIR_Coverage, 73026,
     /* 2416709 */     GIR_EraseRootFromParent_Done,
     /* 2416710 */   // Label 34765: @2416710
     /* 2416710 */   GIM_Try, /*On fail goto*//*Label 34766*/ GIMT_Encode4(2416787), // Rule ID 73027 //
     /* 2416715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2416743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2416758 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2416761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2416773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416786 */     // GIR_Coverage, 73027,
     /* 2416786 */     GIR_EraseRootFromParent_Done,
     /* 2416787 */   // Label 34766: @2416787
     /* 2416787 */   GIM_Try, /*On fail goto*//*Label 34767*/ GIMT_Encode4(2416849), // Rule ID 55542 //
     /* 2416792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416822 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2416825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416848 */     // GIR_Coverage, 55542,
     /* 2416848 */     GIR_EraseRootFromParent_Done,
     /* 2416849 */   // Label 34767: @2416849
     /* 2416849 */   GIM_Try, /*On fail goto*//*Label 34768*/ GIMT_Encode4(2416911), // Rule ID 55543 //
     /* 2416854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2416861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416884 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2416884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2416887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2416891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416910 */     // GIR_Coverage, 55543,
     /* 2416910 */     GIR_EraseRootFromParent_Done,
     /* 2416911 */   // Label 34768: @2416911
     /* 2416911 */   GIM_Try, /*On fail goto*//*Label 34769*/ GIMT_Encode4(2416973), // Rule ID 73030 //
     /* 2416916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2416919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416946 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2416946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2416949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2416957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2416962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2416965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2416968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2416971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416972 */     // GIR_Coverage, 73030,
     /* 2416972 */     GIR_EraseRootFromParent_Done,
     /* 2416973 */   // Label 34769: @2416973
     /* 2416973 */   GIM_Try, /*On fail goto*//*Label 34770*/ GIMT_Encode4(2417035), // Rule ID 73031 //
     /* 2416978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2416981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2416985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2416989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2416993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2416997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417008 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2417011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417034 */     // GIR_Coverage, 73031,
     /* 2417034 */     GIR_EraseRootFromParent_Done,
     /* 2417035 */   // Label 34770: @2417035
     /* 2417035 */   GIM_Try, /*On fail goto*//*Label 34771*/ GIMT_Encode4(2417097), // Rule ID 55534 //
     /* 2417040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417070 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2417073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417096 */     // GIR_Coverage, 55534,
     /* 2417096 */     GIR_EraseRootFromParent_Done,
     /* 2417097 */   // Label 34771: @2417097
     /* 2417097 */   GIM_Try, /*On fail goto*//*Label 34772*/ GIMT_Encode4(2417159), // Rule ID 55535 //
     /* 2417102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2417125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417132 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2417135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417158 */     // GIR_Coverage, 55535,
     /* 2417158 */     GIR_EraseRootFromParent_Done,
     /* 2417159 */   // Label 34772: @2417159
     /* 2417159 */   GIM_Try, /*On fail goto*//*Label 34773*/ GIMT_Encode4(2417204), // Rule ID 55530 //
     /* 2417164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2417167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417179 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2417182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417203 */     // GIR_Coverage, 55530,
     /* 2417203 */     GIR_EraseRootFromParent_Done,
     /* 2417204 */   // Label 34773: @2417204
     /* 2417204 */   GIM_Try, /*On fail goto*//*Label 34774*/ GIMT_Encode4(2417249), // Rule ID 55531 //
     /* 2417209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2417212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417224 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2417227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417248 */     // GIR_Coverage, 55531,
     /* 2417248 */     GIR_EraseRootFromParent_Done,
     /* 2417249 */   // Label 34774: @2417249
     /* 2417249 */   GIM_Reject,
     /* 2417250 */ // Label 34762: @2417250
     /* 2417250 */ GIM_Reject,
     /* 2417251 */ // Label 34510: @2417251
     /* 2417251 */ GIM_Try, /*On fail goto*//*Label 34775*/ GIMT_Encode4(2418040),
     /* 2417256 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417259 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2417262 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2417265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417269 */   GIM_Try, /*On fail goto*//*Label 34776*/ GIMT_Encode4(2417346), // Rule ID 55346 //
     /* 2417274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417317 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2417320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417345 */     // GIR_Coverage, 55346,
     /* 2417345 */     GIR_EraseRootFromParent_Done,
     /* 2417346 */   // Label 34776: @2417346
     /* 2417346 */   GIM_Try, /*On fail goto*//*Label 34777*/ GIMT_Encode4(2417423), // Rule ID 55347 //
     /* 2417351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417394 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2417397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417422 */     // GIR_Coverage, 55347,
     /* 2417422 */     GIR_EraseRootFromParent_Done,
     /* 2417423 */   // Label 34777: @2417423
     /* 2417423 */   GIM_Try, /*On fail goto*//*Label 34778*/ GIMT_Encode4(2417500), // Rule ID 72858 //
     /* 2417428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417469 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417471 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2417474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417499 */     // GIR_Coverage, 72858,
     /* 2417499 */     GIR_EraseRootFromParent_Done,
     /* 2417500 */   // Label 34778: @2417500
     /* 2417500 */   GIM_Try, /*On fail goto*//*Label 34779*/ GIMT_Encode4(2417577), // Rule ID 72859 //
     /* 2417505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2417533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2417548 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2417551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2417563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417576 */     // GIR_Coverage, 72859,
     /* 2417576 */     GIR_EraseRootFromParent_Done,
     /* 2417577 */   // Label 34779: @2417577
     /* 2417577 */   GIM_Try, /*On fail goto*//*Label 34780*/ GIMT_Encode4(2417639), // Rule ID 55350 //
     /* 2417582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417612 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2417615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417638 */     // GIR_Coverage, 55350,
     /* 2417638 */     GIR_EraseRootFromParent_Done,
     /* 2417639 */   // Label 34780: @2417639
     /* 2417639 */   GIM_Try, /*On fail goto*//*Label 34781*/ GIMT_Encode4(2417701), // Rule ID 55351 //
     /* 2417644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2417651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417674 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2417677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417700 */     // GIR_Coverage, 55351,
     /* 2417700 */     GIR_EraseRootFromParent_Done,
     /* 2417701 */   // Label 34781: @2417701
     /* 2417701 */   GIM_Try, /*On fail goto*//*Label 34782*/ GIMT_Encode4(2417763), // Rule ID 72862 //
     /* 2417706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417736 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2417739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417762 */     // GIR_Coverage, 72862,
     /* 2417762 */     GIR_EraseRootFromParent_Done,
     /* 2417763 */   // Label 34782: @2417763
     /* 2417763 */   GIM_Try, /*On fail goto*//*Label 34783*/ GIMT_Encode4(2417825), // Rule ID 72863 //
     /* 2417768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2417779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417798 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2417801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2417809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417824 */     // GIR_Coverage, 72863,
     /* 2417824 */     GIR_EraseRootFromParent_Done,
     /* 2417825 */   // Label 34783: @2417825
     /* 2417825 */   GIM_Try, /*On fail goto*//*Label 34784*/ GIMT_Encode4(2417887), // Rule ID 55342 //
     /* 2417830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417860 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2417863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417886 */     // GIR_Coverage, 55342,
     /* 2417886 */     GIR_EraseRootFromParent_Done,
     /* 2417887 */   // Label 34784: @2417887
     /* 2417887 */   GIM_Try, /*On fail goto*//*Label 34785*/ GIMT_Encode4(2417949), // Rule ID 55343 //
     /* 2417892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2417895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2417911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2417915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417922 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2417922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2417925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2417935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417948 */     // GIR_Coverage, 55343,
     /* 2417948 */     GIR_EraseRootFromParent_Done,
     /* 2417949 */   // Label 34785: @2417949
     /* 2417949 */   GIM_Try, /*On fail goto*//*Label 34786*/ GIMT_Encode4(2417994), // Rule ID 55338 //
     /* 2417954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2417957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2417969 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2417969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2417972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2417976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2417978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2417983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2417986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2417992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417993 */     // GIR_Coverage, 55338,
     /* 2417993 */     GIR_EraseRootFromParent_Done,
     /* 2417994 */   // Label 34786: @2417994
     /* 2417994 */   GIM_Try, /*On fail goto*//*Label 34787*/ GIMT_Encode4(2418039), // Rule ID 55339 //
     /* 2417999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2418014 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2418014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2418017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2418021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2418037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418038 */     // GIR_Coverage, 55339,
     /* 2418038 */     GIR_EraseRootFromParent_Done,
     /* 2418039 */   // Label 34787: @2418039
     /* 2418039 */   GIM_Reject,
     /* 2418040 */ // Label 34775: @2418040
     /* 2418040 */ GIM_Reject,
     /* 2418041 */ // Label 34511: @2418041
     /* 2418041 */ GIM_Reject,
     /* 2418042 */ // Label 103: @2418042
     /* 2418042 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34806*/ GIMT_Encode4(2420217),
     /* 2418053 */ /*GILLT_s16*//*Label 34788*/ GIMT_Encode4(2418173),
     /* 2418057 */ /*GILLT_s32*//*Label 34789*/ GIMT_Encode4(2418295),
     /* 2418061 */ /*GILLT_s64*//*Label 34790*/ GIMT_Encode4(2418417), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418073 */ /*GILLT_nxv1s16*//*Label 34791*/ GIMT_Encode4(2418567),
     /* 2418077 */ /*GILLT_nxv1s32*//*Label 34792*/ GIMT_Encode4(2418677),
     /* 2418081 */ /*GILLT_nxv1s64*//*Label 34793*/ GIMT_Encode4(2418787), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418093 */ /*GILLT_nxv2s16*//*Label 34794*/ GIMT_Encode4(2418897),
     /* 2418097 */ /*GILLT_nxv2s32*//*Label 34795*/ GIMT_Encode4(2419007),
     /* 2418101 */ /*GILLT_nxv2s64*//*Label 34796*/ GIMT_Encode4(2419117), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418113 */ /*GILLT_nxv4s16*//*Label 34797*/ GIMT_Encode4(2419227),
     /* 2418117 */ /*GILLT_nxv4s32*//*Label 34798*/ GIMT_Encode4(2419337),
     /* 2418121 */ /*GILLT_nxv4s64*//*Label 34799*/ GIMT_Encode4(2419447), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418133 */ /*GILLT_nxv8s16*//*Label 34800*/ GIMT_Encode4(2419557),
     /* 2418137 */ /*GILLT_nxv8s32*//*Label 34801*/ GIMT_Encode4(2419667),
     /* 2418141 */ /*GILLT_nxv8s64*//*Label 34802*/ GIMT_Encode4(2419777), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418153 */ /*GILLT_nxv16s16*//*Label 34803*/ GIMT_Encode4(2419887),
     /* 2418157 */ /*GILLT_nxv16s32*//*Label 34804*/ GIMT_Encode4(2419997), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2418169 */ /*GILLT_nxv32s16*//*Label 34805*/ GIMT_Encode4(2420107),
     /* 2418173 */ // Label 34788: @2418173
     /* 2418173 */ GIM_Try, /*On fail goto*//*Label 34807*/ GIMT_Encode4(2418294),
     /* 2418178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2418181 */   GIM_Try, /*On fail goto*//*Label 34808*/ GIMT_Encode4(2418209), // Rule ID 1984 //
     /* 2418186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2418189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2418193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2418197 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2418197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2418200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418208 */     // GIR_Coverage, 1984,
     /* 2418208 */     GIR_EraseRootFromParent_Done,
     /* 2418209 */   // Label 34808: @2418209
     /* 2418209 */   GIM_Try, /*On fail goto*//*Label 34809*/ GIMT_Encode4(2418237), // Rule ID 1985 //
     /* 2418214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2418217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2418221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2418225 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2418225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2418228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418236 */     // GIR_Coverage, 1985,
     /* 2418236 */     GIR_EraseRootFromParent_Done,
     /* 2418237 */   // Label 34809: @2418237
     /* 2418237 */   GIM_Try, /*On fail goto*//*Label 34810*/ GIMT_Encode4(2418265), // Rule ID 2017 //
     /* 2418242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2418245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2418249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2418253 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2418253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2418256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418264 */     // GIR_Coverage, 2017,
     /* 2418264 */     GIR_EraseRootFromParent_Done,
     /* 2418265 */   // Label 34810: @2418265
     /* 2418265 */   GIM_Try, /*On fail goto*//*Label 34811*/ GIMT_Encode4(2418293), // Rule ID 2018 //
     /* 2418270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2418273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2418277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2418281 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2418281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2418284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418292 */     // GIR_Coverage, 2018,
     /* 2418292 */     GIR_EraseRootFromParent_Done,
     /* 2418293 */   // Label 34811: @2418293
     /* 2418293 */   GIM_Reject,
     /* 2418294 */ // Label 34807: @2418294
     /* 2418294 */ GIM_Reject,
     /* 2418295 */ // Label 34789: @2418295
     /* 2418295 */ GIM_Try, /*On fail goto*//*Label 34812*/ GIMT_Encode4(2418416),
     /* 2418300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2418303 */   GIM_Try, /*On fail goto*//*Label 34813*/ GIMT_Encode4(2418331), // Rule ID 1275 //
     /* 2418308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2418311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2418315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2418319 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2418319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2418322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418330 */     // GIR_Coverage, 1275,
     /* 2418330 */     GIR_EraseRootFromParent_Done,
     /* 2418331 */   // Label 34813: @2418331
     /* 2418331 */   GIM_Try, /*On fail goto*//*Label 34814*/ GIMT_Encode4(2418359), // Rule ID 1276 //
     /* 2418336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2418339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2418343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2418347 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2418347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2418350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418358 */     // GIR_Coverage, 1276,
     /* 2418358 */     GIR_EraseRootFromParent_Done,
     /* 2418359 */   // Label 34814: @2418359
     /* 2418359 */   GIM_Try, /*On fail goto*//*Label 34815*/ GIMT_Encode4(2418387), // Rule ID 1283 //
     /* 2418364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2418367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2418371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2418375 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2418375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2418378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418386 */     // GIR_Coverage, 1283,
     /* 2418386 */     GIR_EraseRootFromParent_Done,
     /* 2418387 */   // Label 34815: @2418387
     /* 2418387 */   GIM_Try, /*On fail goto*//*Label 34816*/ GIMT_Encode4(2418415), // Rule ID 1284 //
     /* 2418392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2418395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2418399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2418403 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2418403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2418406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418414 */     // GIR_Coverage, 1284,
     /* 2418414 */     GIR_EraseRootFromParent_Done,
     /* 2418415 */   // Label 34816: @2418415
     /* 2418415 */   GIM_Reject,
     /* 2418416 */ // Label 34812: @2418416
     /* 2418416 */ GIM_Reject,
     /* 2418417 */ // Label 34790: @2418417
     /* 2418417 */ GIM_Try, /*On fail goto*//*Label 34817*/ GIMT_Encode4(2418566),
     /* 2418422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2418425 */   GIM_Try, /*On fail goto*//*Label 34818*/ GIMT_Encode4(2418453), // Rule ID 1618 //
     /* 2418430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2418433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2418437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2418441 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2418441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2418444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418452 */     // GIR_Coverage, 1618,
     /* 2418452 */     GIR_EraseRootFromParent_Done,
     /* 2418453 */   // Label 34818: @2418453
     /* 2418453 */   GIM_Try, /*On fail goto*//*Label 34819*/ GIMT_Encode4(2418481), // Rule ID 1619 //
     /* 2418458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2418461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2418465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2418469 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2418469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2418472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418480 */     // GIR_Coverage, 1619,
     /* 2418480 */     GIR_EraseRootFromParent_Done,
     /* 2418481 */   // Label 34819: @2418481
     /* 2418481 */   GIM_Try, /*On fail goto*//*Label 34820*/ GIMT_Encode4(2418509), // Rule ID 1653 //
     /* 2418486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2418489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418497 */     // (strict_fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2418497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2418500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418508 */     // GIR_Coverage, 1653,
     /* 2418508 */     GIR_EraseRootFromParent_Done,
     /* 2418509 */   // Label 34820: @2418509
     /* 2418509 */   GIM_Try, /*On fail goto*//*Label 34821*/ GIMT_Encode4(2418537), // Rule ID 1673 //
     /* 2418514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2418517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2418521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2418525 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2418525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2418528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418536 */     // GIR_Coverage, 1673,
     /* 2418536 */     GIR_EraseRootFromParent_Done,
     /* 2418537 */   // Label 34821: @2418537
     /* 2418537 */   GIM_Try, /*On fail goto*//*Label 34822*/ GIMT_Encode4(2418565), // Rule ID 1674 //
     /* 2418542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2418545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2418549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2418553 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2418553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2418556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2418560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418564 */     // GIR_Coverage, 1674,
     /* 2418564 */     GIR_EraseRootFromParent_Done,
     /* 2418565 */   // Label 34822: @2418565
     /* 2418565 */   GIM_Reject,
     /* 2418566 */ // Label 34817: @2418566
     /* 2418566 */ GIM_Reject,
     /* 2418567 */ // Label 34791: @2418567
     /* 2418567 */ GIM_Try, /*On fail goto*//*Label 34823*/ GIMT_Encode4(2418676),
     /* 2418572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2418575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418583 */   GIM_Try, /*On fail goto*//*Label 34824*/ GIMT_Encode4(2418629), // Rule ID 56234 //
     /* 2418588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418591 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2418591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2418594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2418598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2418603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2418605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2418608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2418613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2418615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418628 */     // GIR_Coverage, 56234,
     /* 2418628 */     GIR_EraseRootFromParent_Done,
     /* 2418629 */   // Label 34824: @2418629
     /* 2418629 */   GIM_Try, /*On fail goto*//*Label 34825*/ GIMT_Encode4(2418675), // Rule ID 56235 //
     /* 2418634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418637 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2418637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2418640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2418644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2418649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2418651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2418654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2418659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2418661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418674 */     // GIR_Coverage, 56235,
     /* 2418674 */     GIR_EraseRootFromParent_Done,
     /* 2418675 */   // Label 34825: @2418675
     /* 2418675 */   GIM_Reject,
     /* 2418676 */ // Label 34823: @2418676
     /* 2418676 */ GIM_Reject,
     /* 2418677 */ // Label 34792: @2418677
     /* 2418677 */ GIM_Try, /*On fail goto*//*Label 34826*/ GIMT_Encode4(2418786),
     /* 2418682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2418685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418693 */   GIM_Try, /*On fail goto*//*Label 34827*/ GIMT_Encode4(2418739), // Rule ID 56274 //
     /* 2418698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2418701 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2418701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2418704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2418708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2418713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2418715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2418718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2418723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2418725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418738 */     // GIR_Coverage, 56274,
     /* 2418738 */     GIR_EraseRootFromParent_Done,
     /* 2418739 */   // Label 34827: @2418739
     /* 2418739 */   GIM_Try, /*On fail goto*//*Label 34828*/ GIMT_Encode4(2418785), // Rule ID 56275 //
     /* 2418744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2418747 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2418747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2418750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2418754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2418759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2418761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2418764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2418769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2418771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2418780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418784 */     // GIR_Coverage, 56275,
     /* 2418784 */     GIR_EraseRootFromParent_Done,
     /* 2418785 */   // Label 34828: @2418785
     /* 2418785 */   GIM_Reject,
     /* 2418786 */ // Label 34826: @2418786
     /* 2418786 */ GIM_Reject,
     /* 2418787 */ // Label 34793: @2418787
     /* 2418787 */ GIM_Try, /*On fail goto*//*Label 34829*/ GIMT_Encode4(2418896),
     /* 2418792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2418795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418803 */   GIM_Try, /*On fail goto*//*Label 34830*/ GIMT_Encode4(2418849), // Rule ID 56334 //
     /* 2418808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2418811 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2418811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2418814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2418818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2418823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2418825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2418828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2418833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2418835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418848 */     // GIR_Coverage, 56334,
     /* 2418848 */     GIR_EraseRootFromParent_Done,
     /* 2418849 */   // Label 34830: @2418849
     /* 2418849 */   GIM_Try, /*On fail goto*//*Label 34831*/ GIMT_Encode4(2418895), // Rule ID 56335 //
     /* 2418854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2418857 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2418857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2418860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2418864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2418869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2418871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2418874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2418879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2418881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418894 */     // GIR_Coverage, 56335,
     /* 2418894 */     GIR_EraseRootFromParent_Done,
     /* 2418895 */   // Label 34831: @2418895
     /* 2418895 */   GIM_Reject,
     /* 2418896 */ // Label 34829: @2418896
     /* 2418896 */ GIM_Reject,
     /* 2418897 */ // Label 34794: @2418897
     /* 2418897 */ GIM_Try, /*On fail goto*//*Label 34832*/ GIMT_Encode4(2419006),
     /* 2418902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2418905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418913 */   GIM_Try, /*On fail goto*//*Label 34833*/ GIMT_Encode4(2418959), // Rule ID 56254 //
     /* 2418918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2418921 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2418921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2418924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2418928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2418933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2418935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2418938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2418943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2418945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418958 */     // GIR_Coverage, 56254,
     /* 2418958 */     GIR_EraseRootFromParent_Done,
     /* 2418959 */   // Label 34833: @2418959
     /* 2418959 */   GIM_Try, /*On fail goto*//*Label 34834*/ GIMT_Encode4(2419005), // Rule ID 56255 //
     /* 2418964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2418967 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2418967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2418970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2418974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2418979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2418981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2418984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2418989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2418991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2418994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2418997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419004 */     // GIR_Coverage, 56255,
     /* 2419004 */     GIR_EraseRootFromParent_Done,
     /* 2419005 */   // Label 34834: @2419005
     /* 2419005 */   GIM_Reject,
     /* 2419006 */ // Label 34832: @2419006
     /* 2419006 */ GIM_Reject,
     /* 2419007 */ // Label 34795: @2419007
     /* 2419007 */ GIM_Try, /*On fail goto*//*Label 34835*/ GIMT_Encode4(2419116),
     /* 2419012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2419015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419023 */   GIM_Try, /*On fail goto*//*Label 34836*/ GIMT_Encode4(2419069), // Rule ID 56314 //
     /* 2419028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419031 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2419034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2419048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419068 */     // GIR_Coverage, 56314,
     /* 2419068 */     GIR_EraseRootFromParent_Done,
     /* 2419069 */   // Label 34836: @2419069
     /* 2419069 */   GIM_Try, /*On fail goto*//*Label 34837*/ GIMT_Encode4(2419115), // Rule ID 56315 //
     /* 2419074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419077 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2419080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2419094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419114 */     // GIR_Coverage, 56315,
     /* 2419114 */     GIR_EraseRootFromParent_Done,
     /* 2419115 */   // Label 34837: @2419115
     /* 2419115 */   GIM_Reject,
     /* 2419116 */ // Label 34835: @2419116
     /* 2419116 */ GIM_Reject,
     /* 2419117 */ // Label 34796: @2419117
     /* 2419117 */ GIM_Try, /*On fail goto*//*Label 34838*/ GIMT_Encode4(2419226),
     /* 2419122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2419125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419133 */   GIM_Try, /*On fail goto*//*Label 34839*/ GIMT_Encode4(2419179), // Rule ID 56474 //
     /* 2419138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419141 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2419144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2419158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419178 */     // GIR_Coverage, 56474,
     /* 2419178 */     GIR_EraseRootFromParent_Done,
     /* 2419179 */   // Label 34839: @2419179
     /* 2419179 */   GIM_Try, /*On fail goto*//*Label 34840*/ GIMT_Encode4(2419225), // Rule ID 56475 //
     /* 2419184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419187 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2419190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2419204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419224 */     // GIR_Coverage, 56475,
     /* 2419224 */     GIR_EraseRootFromParent_Done,
     /* 2419225 */   // Label 34840: @2419225
     /* 2419225 */   GIM_Reject,
     /* 2419226 */ // Label 34838: @2419226
     /* 2419226 */ GIM_Reject,
     /* 2419227 */ // Label 34797: @2419227
     /* 2419227 */ GIM_Try, /*On fail goto*//*Label 34841*/ GIMT_Encode4(2419336),
     /* 2419232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2419235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2419243 */   GIM_Try, /*On fail goto*//*Label 34842*/ GIMT_Encode4(2419289), // Rule ID 56294 //
     /* 2419248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419251 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2419254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2419268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419288 */     // GIR_Coverage, 56294,
     /* 2419288 */     GIR_EraseRootFromParent_Done,
     /* 2419289 */   // Label 34842: @2419289
     /* 2419289 */   GIM_Try, /*On fail goto*//*Label 34843*/ GIMT_Encode4(2419335), // Rule ID 56295 //
     /* 2419294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419297 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2419300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2419314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419334 */     // GIR_Coverage, 56295,
     /* 2419334 */     GIR_EraseRootFromParent_Done,
     /* 2419335 */   // Label 34843: @2419335
     /* 2419335 */   GIM_Reject,
     /* 2419336 */ // Label 34841: @2419336
     /* 2419336 */ GIM_Reject,
     /* 2419337 */ // Label 34798: @2419337
     /* 2419337 */ GIM_Try, /*On fail goto*//*Label 34844*/ GIMT_Encode4(2419446),
     /* 2419342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2419345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419353 */   GIM_Try, /*On fail goto*//*Label 34845*/ GIMT_Encode4(2419399), // Rule ID 56414 //
     /* 2419358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419361 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2419364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2419378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419398 */     // GIR_Coverage, 56414,
     /* 2419398 */     GIR_EraseRootFromParent_Done,
     /* 2419399 */   // Label 34845: @2419399
     /* 2419399 */   GIM_Try, /*On fail goto*//*Label 34846*/ GIMT_Encode4(2419445), // Rule ID 56415 //
     /* 2419404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419407 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2419410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2419424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419444 */     // GIR_Coverage, 56415,
     /* 2419444 */     GIR_EraseRootFromParent_Done,
     /* 2419445 */   // Label 34846: @2419445
     /* 2419445 */   GIM_Reject,
     /* 2419446 */ // Label 34844: @2419446
     /* 2419446 */ GIM_Reject,
     /* 2419447 */ // Label 34799: @2419447
     /* 2419447 */ GIM_Try, /*On fail goto*//*Label 34847*/ GIMT_Encode4(2419556),
     /* 2419452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2419455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419463 */   GIM_Try, /*On fail goto*//*Label 34848*/ GIMT_Encode4(2419509), // Rule ID 56494 //
     /* 2419468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419471 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2419474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2419488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419508 */     // GIR_Coverage, 56494,
     /* 2419508 */     GIR_EraseRootFromParent_Done,
     /* 2419509 */   // Label 34848: @2419509
     /* 2419509 */   GIM_Try, /*On fail goto*//*Label 34849*/ GIMT_Encode4(2419555), // Rule ID 56495 //
     /* 2419514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419517 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2419520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2419534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419554 */     // GIR_Coverage, 56495,
     /* 2419554 */     GIR_EraseRootFromParent_Done,
     /* 2419555 */   // Label 34849: @2419555
     /* 2419555 */   GIM_Reject,
     /* 2419556 */ // Label 34847: @2419556
     /* 2419556 */ GIM_Reject,
     /* 2419557 */ // Label 34800: @2419557
     /* 2419557 */ GIM_Try, /*On fail goto*//*Label 34850*/ GIMT_Encode4(2419666),
     /* 2419562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2419565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419573 */   GIM_Try, /*On fail goto*//*Label 34851*/ GIMT_Encode4(2419619), // Rule ID 56354 //
     /* 2419578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419581 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2419584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2419598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419618 */     // GIR_Coverage, 56354,
     /* 2419618 */     GIR_EraseRootFromParent_Done,
     /* 2419619 */   // Label 34851: @2419619
     /* 2419619 */   GIM_Try, /*On fail goto*//*Label 34852*/ GIMT_Encode4(2419665), // Rule ID 56355 //
     /* 2419624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419627 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2419630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2419644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419664 */     // GIR_Coverage, 56355,
     /* 2419664 */     GIR_EraseRootFromParent_Done,
     /* 2419665 */   // Label 34852: @2419665
     /* 2419665 */   GIM_Reject,
     /* 2419666 */ // Label 34850: @2419666
     /* 2419666 */ GIM_Reject,
     /* 2419667 */ // Label 34801: @2419667
     /* 2419667 */ GIM_Try, /*On fail goto*//*Label 34853*/ GIMT_Encode4(2419776),
     /* 2419672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2419675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419683 */   GIM_Try, /*On fail goto*//*Label 34854*/ GIMT_Encode4(2419729), // Rule ID 56434 //
     /* 2419688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2419691 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2419694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2419708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419728 */     // GIR_Coverage, 56434,
     /* 2419728 */     GIR_EraseRootFromParent_Done,
     /* 2419729 */   // Label 34854: @2419729
     /* 2419729 */   GIM_Try, /*On fail goto*//*Label 34855*/ GIMT_Encode4(2419775), // Rule ID 56435 //
     /* 2419734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2419737 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2419740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2419754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419774 */     // GIR_Coverage, 56435,
     /* 2419774 */     GIR_EraseRootFromParent_Done,
     /* 2419775 */   // Label 34855: @2419775
     /* 2419775 */   GIM_Reject,
     /* 2419776 */ // Label 34853: @2419776
     /* 2419776 */ GIM_Reject,
     /* 2419777 */ // Label 34802: @2419777
     /* 2419777 */ GIM_Try, /*On fail goto*//*Label 34856*/ GIMT_Encode4(2419886),
     /* 2419782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2419785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2419793 */   GIM_Try, /*On fail goto*//*Label 34857*/ GIMT_Encode4(2419839), // Rule ID 56514 //
     /* 2419798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2419801 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2419804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2419818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419838 */     // GIR_Coverage, 56514,
     /* 2419838 */     GIR_EraseRootFromParent_Done,
     /* 2419839 */   // Label 34857: @2419839
     /* 2419839 */   GIM_Try, /*On fail goto*//*Label 34858*/ GIMT_Encode4(2419885), // Rule ID 56515 //
     /* 2419844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2419847 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2419850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2419864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2419880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419884 */     // GIR_Coverage, 56515,
     /* 2419884 */     GIR_EraseRootFromParent_Done,
     /* 2419885 */   // Label 34858: @2419885
     /* 2419885 */   GIM_Reject,
     /* 2419886 */ // Label 34856: @2419886
     /* 2419886 */ GIM_Reject,
     /* 2419887 */ // Label 34803: @2419887
     /* 2419887 */ GIM_Try, /*On fail goto*//*Label 34859*/ GIMT_Encode4(2419996),
     /* 2419892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2419895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419903 */   GIM_Try, /*On fail goto*//*Label 34860*/ GIMT_Encode4(2419949), // Rule ID 56374 //
     /* 2419908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2419911 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2419911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2419914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2419928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419948 */     // GIR_Coverage, 56374,
     /* 2419948 */     GIR_EraseRootFromParent_Done,
     /* 2419949 */   // Label 34860: @2419949
     /* 2419949 */   GIM_Try, /*On fail goto*//*Label 34861*/ GIMT_Encode4(2419995), // Rule ID 56375 //
     /* 2419954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2419957 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2419957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2419960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2419964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2419969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2419971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2419974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2419979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2419981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2419984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2419987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2419993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419994 */     // GIR_Coverage, 56375,
     /* 2419994 */     GIR_EraseRootFromParent_Done,
     /* 2419995 */   // Label 34861: @2419995
     /* 2419995 */   GIM_Reject,
     /* 2419996 */ // Label 34859: @2419996
     /* 2419996 */ GIM_Reject,
     /* 2419997 */ // Label 34804: @2419997
     /* 2419997 */ GIM_Try, /*On fail goto*//*Label 34862*/ GIMT_Encode4(2420106),
     /* 2420002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2420005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420013 */   GIM_Try, /*On fail goto*//*Label 34863*/ GIMT_Encode4(2420059), // Rule ID 56454 //
     /* 2420018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2420021 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2420024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2420038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420058 */     // GIR_Coverage, 56454,
     /* 2420058 */     GIR_EraseRootFromParent_Done,
     /* 2420059 */   // Label 34863: @2420059
     /* 2420059 */   GIM_Try, /*On fail goto*//*Label 34864*/ GIMT_Encode4(2420105), // Rule ID 56455 //
     /* 2420064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2420067 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2420070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2420084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420104 */     // GIR_Coverage, 56455,
     /* 2420104 */     GIR_EraseRootFromParent_Done,
     /* 2420105 */   // Label 34864: @2420105
     /* 2420105 */   GIM_Reject,
     /* 2420106 */ // Label 34862: @2420106
     /* 2420106 */ GIM_Reject,
     /* 2420107 */ // Label 34805: @2420107
     /* 2420107 */ GIM_Try, /*On fail goto*//*Label 34865*/ GIMT_Encode4(2420216),
     /* 2420112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2420115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420123 */   GIM_Try, /*On fail goto*//*Label 34866*/ GIMT_Encode4(2420169), // Rule ID 56394 //
     /* 2420128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2420131 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2420131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2420134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2420148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420168 */     // GIR_Coverage, 56394,
     /* 2420168 */     GIR_EraseRootFromParent_Done,
     /* 2420169 */   // Label 34866: @2420169
     /* 2420169 */   GIM_Try, /*On fail goto*//*Label 34867*/ GIMT_Encode4(2420215), // Rule ID 56395 //
     /* 2420174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2420177 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2420177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2420180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2420184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2420194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2420201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2420204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2420207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2420210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420214 */     // GIR_Coverage, 56395,
     /* 2420214 */     GIR_EraseRootFromParent_Done,
     /* 2420215 */   // Label 34867: @2420215
     /* 2420215 */   GIM_Reject,
     /* 2420216 */ // Label 34865: @2420216
     /* 2420216 */ GIM_Reject,
     /* 2420217 */ // Label 34806: @2420217
     /* 2420217 */ GIM_Reject,
     /* 2420218 */ // Label 104: @2420218
     /* 2420218 */ GIM_Try, /*On fail goto*//*Label 34868*/ GIMT_Encode4(2420230), // Rule ID 289 //
     /* 2420223 */   // (trap)  =>  (UNIMP)
     /* 2420223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::UNIMP),
     /* 2420228 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420229 */   // GIR_Coverage, 289,
     /* 2420229 */   GIR_Done,
     /* 2420230 */ // Label 34868: @2420230
     /* 2420230 */ GIM_Reject,
     /* 2420231 */ // Label 105: @2420231
     /* 2420231 */ GIM_Try, /*On fail goto*//*Label 34869*/ GIMT_Encode4(2420243), // Rule ID 290 //
     /* 2420236 */   // (debugtrap)  =>  (EBREAK)
     /* 2420236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::EBREAK),
     /* 2420241 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420242 */   // GIR_Coverage, 290,
     /* 2420242 */   GIR_Done,
     /* 2420243 */ // Label 34869: @2420243
     /* 2420243 */ GIM_Reject,
     /* 2420244 */ // Label 106: @2420244
     /* 2420244 */ GIM_Try, /*On fail goto*//*Label 34870*/ GIMT_Encode4(2420338),
     /* 2420249 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2420252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420259 */   GIM_Try, /*On fail goto*//*Label 34871*/ GIMT_Encode4(2420278), // Rule ID 2516 //
     /* 2420264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2420267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420271 */     // (riscv_clzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2420271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZW),
     /* 2420276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420277 */     // GIR_Coverage, 2516,
     /* 2420277 */     GIR_Done,
     /* 2420278 */   // Label 34871: @2420278
     /* 2420278 */   GIM_Try, /*On fail goto*//*Label 34872*/ GIMT_Encode4(2420337), // Rule ID 62569 //
     /* 2420283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2420286 */     // (riscv_clzw:{ *:[i64] } i64:{ *:[i64] }:$rs1)  =>  (TH_FF0:{ *:[i64] } (SLLI:{ *:[i64] } (XORI:{ *:[i64] } i64:{ *:[i64] }:$rs1, -1:{ *:[i64] }), 32:{ *:[i64] }))
     /* 2420286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 2420289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2420293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /* 2420302 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 2420305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 2420307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2420310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2420314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2420319 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2420322 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2420325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2420327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2420330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2420335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420336 */     // GIR_Coverage, 62569,
     /* 2420336 */     GIR_EraseRootFromParent_Done,
     /* 2420337 */   // Label 34872: @2420337
     /* 2420337 */   GIM_Reject,
     /* 2420338 */ // Label 34870: @2420338
     /* 2420338 */ GIM_Reject,
     /* 2420339 */ // Label 107: @2420339
     /* 2420339 */ GIM_Try, /*On fail goto*//*Label 34873*/ GIMT_Encode4(2420368), // Rule ID 2517 //
     /* 2420344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2420347 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2420350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420361 */   // (riscv_ctzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2420361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZW),
     /* 2420366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420367 */   // GIR_Coverage, 2517,
     /* 2420367 */   GIR_Done,
     /* 2420368 */ // Label 34873: @2420368
     /* 2420368 */ GIM_Reject,
     /* 2420369 */ // Label 108: @2420369
     /* 2420369 */ GIM_Try, /*On fail goto*//*Label 34874*/ GIMT_Encode4(2420405), // Rule ID 315 //
     /* 2420374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2420377 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2420380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2420386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420398 */   // (riscv_divuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2420398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVUW),
     /* 2420403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420404 */   // GIR_Coverage, 315,
     /* 2420404 */   GIR_Done,
     /* 2420405 */ // Label 34874: @2420405
     /* 2420405 */ GIM_Reject,
     /* 2420406 */ // Label 109: @2420406
     /* 2420406 */ GIM_Try, /*On fail goto*//*Label 34875*/ GIMT_Encode4(2420442), // Rule ID 314 //
     /* 2420411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2420414 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2420417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2420423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420435 */   // (riscv_divw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2420435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVW),
     /* 2420440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420441 */   // GIR_Coverage, 314,
     /* 2420441 */   GIR_Done,
     /* 2420442 */ // Label 34875: @2420442
     /* 2420442 */ GIM_Reject,
     /* 2420443 */ // Label 110: @2420443
     /* 2420443 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34878*/ GIMT_Encode4(2420802),
     /* 2420454 */ /*GILLT_s32*//*Label 34876*/ GIMT_Encode4(2420462),
     /* 2420458 */ /*GILLT_s64*//*Label 34877*/ GIMT_Encode4(2420619),
     /* 2420462 */ // Label 34876: @2420462
     /* 2420462 */ GIM_Try, /*On fail goto*//*Label 34879*/ GIMT_Encode4(2420488), // Rule ID 1282 //
     /* 2420467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2420470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2420473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2420481 */   // (riscv_fclass:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2420481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2420486 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420487 */   // GIR_Coverage, 1282,
     /* 2420487 */   GIR_Done,
     /* 2420488 */ // Label 34879: @2420488
     /* 2420488 */ GIM_Try, /*On fail goto*//*Label 34880*/ GIMT_Encode4(2420514), // Rule ID 1290 //
     /* 2420493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2420496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2420499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2420507 */   // (riscv_fclass:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2420507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2420512 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420513 */   // GIR_Coverage, 1290,
     /* 2420513 */   GIR_Done,
     /* 2420514 */ // Label 34880: @2420514
     /* 2420514 */ GIM_Try, /*On fail goto*//*Label 34881*/ GIMT_Encode4(2420540), // Rule ID 1625 //
     /* 2420519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2420522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2420533 */   // (riscv_fclass:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2420533 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2420538 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420539 */   // GIR_Coverage, 1625,
     /* 2420539 */   GIR_Done,
     /* 2420540 */ // Label 34881: @2420540
     /* 2420540 */ GIM_Try, /*On fail goto*//*Label 34882*/ GIMT_Encode4(2420566), // Rule ID 1680 //
     /* 2420545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2420548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2420559 */   // (riscv_fclass:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2420559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2420564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420565 */   // GIR_Coverage, 1680,
     /* 2420565 */   GIR_Done,
     /* 2420566 */ // Label 34882: @2420566
     /* 2420566 */ GIM_Try, /*On fail goto*//*Label 34883*/ GIMT_Encode4(2420592), // Rule ID 1991 //
     /* 2420571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2420574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2420577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2420585 */   // (riscv_fclass:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2420585 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2420590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420591 */   // GIR_Coverage, 1991,
     /* 2420591 */   GIR_Done,
     /* 2420592 */ // Label 34883: @2420592
     /* 2420592 */ GIM_Try, /*On fail goto*//*Label 34884*/ GIMT_Encode4(2420618), // Rule ID 2024 //
     /* 2420597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2420600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2420603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2420611 */   // (riscv_fclass:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2420611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2420616 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420617 */   // GIR_Coverage, 2024,
     /* 2420617 */   GIR_Done,
     /* 2420618 */ // Label 34884: @2420618
     /* 2420618 */ GIM_Reject,
     /* 2420619 */ // Label 34877: @2420619
     /* 2420619 */ GIM_Try, /*On fail goto*//*Label 34885*/ GIMT_Encode4(2420645), // Rule ID 1281 //
     /* 2420624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2420627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2420630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2420638 */   // (riscv_fclass:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2420638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2420643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420644 */   // GIR_Coverage, 1281,
     /* 2420644 */   GIR_Done,
     /* 2420645 */ // Label 34885: @2420645
     /* 2420645 */ GIM_Try, /*On fail goto*//*Label 34886*/ GIMT_Encode4(2420671), // Rule ID 1289 //
     /* 2420650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2420653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2420656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2420664 */   // (riscv_fclass:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2420664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2420669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420670 */   // GIR_Coverage, 1289,
     /* 2420670 */   GIR_Done,
     /* 2420671 */ // Label 34886: @2420671
     /* 2420671 */ GIM_Try, /*On fail goto*//*Label 34887*/ GIMT_Encode4(2420697), // Rule ID 1624 //
     /* 2420676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2420679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2420690 */   // (riscv_fclass:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2420690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2420695 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420696 */   // GIR_Coverage, 1624,
     /* 2420696 */   GIR_Done,
     /* 2420697 */ // Label 34887: @2420697
     /* 2420697 */ GIM_Try, /*On fail goto*//*Label 34888*/ GIMT_Encode4(2420723), // Rule ID 1657 //
     /* 2420702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2420705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420716 */   // (riscv_fclass:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCLASS_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2420716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_INX),
     /* 2420721 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420722 */   // GIR_Coverage, 1657,
     /* 2420722 */   GIR_Done,
     /* 2420723 */ // Label 34888: @2420723
     /* 2420723 */ GIM_Try, /*On fail goto*//*Label 34889*/ GIMT_Encode4(2420749), // Rule ID 1679 //
     /* 2420728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2420731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2420734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2420742 */   // (riscv_fclass:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2420742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2420747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420748 */   // GIR_Coverage, 1679,
     /* 2420748 */   GIR_Done,
     /* 2420749 */ // Label 34889: @2420749
     /* 2420749 */ GIM_Try, /*On fail goto*//*Label 34890*/ GIMT_Encode4(2420775), // Rule ID 1990 //
     /* 2420754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2420757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2420760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2420768 */   // (riscv_fclass:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2420768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2420773 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420774 */   // GIR_Coverage, 1990,
     /* 2420774 */   GIR_Done,
     /* 2420775 */ // Label 34890: @2420775
     /* 2420775 */ GIM_Try, /*On fail goto*//*Label 34891*/ GIMT_Encode4(2420801), // Rule ID 2023 //
     /* 2420780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2420783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2420786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2420794 */   // (riscv_fclass:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2420794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2420799 */   GIR_RootConstrainSelectedInstOperands,
     /* 2420800 */   // GIR_Coverage, 2023,
     /* 2420800 */   GIR_Done,
     /* 2420801 */ // Label 34891: @2420801
     /* 2420801 */ GIM_Reject,
     /* 2420802 */ // Label 34878: @2420802
     /* 2420802 */ GIM_Reject,
     /* 2420803 */ // Label 111: @2420803
     /* 2420803 */ GIM_Try, /*On fail goto*//*Label 34892*/ GIMT_Encode4(2421000),
     /* 2420808 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2420811 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34896*/ GIMT_Encode4(2420999),
     /* 2420822 */   /*GILLT_s16*//*Label 34893*/ GIMT_Encode4(2420834),
     /* 2420826 */   /*GILLT_s32*//*Label 34894*/ GIMT_Encode4(2420889),
     /* 2420830 */   /*GILLT_s64*//*Label 34895*/ GIMT_Encode4(2420944),
     /* 2420834 */   // Label 34893: @2420834
     /* 2420834 */   GIM_Try, /*On fail goto*//*Label 34897*/ GIMT_Encode4(2420888),
     /* 2420839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420843 */     GIM_Try, /*On fail goto*//*Label 34898*/ GIMT_Encode4(2420865), // Rule ID 2241 //
     /* 2420848 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2420851 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2420855 */       // MIs[0] frm
     /* 2420855 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2420858 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2420858 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2420863 */       GIR_RootConstrainSelectedInstOperands,
     /* 2420864 */       // GIR_Coverage, 2241,
     /* 2420864 */       GIR_Done,
     /* 2420865 */     // Label 34898: @2420865
     /* 2420865 */     GIM_Try, /*On fail goto*//*Label 34899*/ GIMT_Encode4(2420887), // Rule ID 2267 //
     /* 2420870 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2420873 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2420877 */       // MIs[0] frm
     /* 2420877 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2420880 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2420880 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2420885 */       GIR_RootConstrainSelectedInstOperands,
     /* 2420886 */       // GIR_Coverage, 2267,
     /* 2420886 */       GIR_Done,
     /* 2420887 */     // Label 34899: @2420887
     /* 2420887 */     GIM_Reject,
     /* 2420888 */   // Label 34897: @2420888
     /* 2420888 */   GIM_Reject,
     /* 2420889 */   // Label 34894: @2420889
     /* 2420889 */   GIM_Try, /*On fail goto*//*Label 34900*/ GIMT_Encode4(2420943),
     /* 2420894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420898 */     GIM_Try, /*On fail goto*//*Label 34901*/ GIMT_Encode4(2420920), // Rule ID 1507 //
     /* 2420903 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2420906 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2420910 */       // MIs[0] frm
     /* 2420910 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2420913 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2420913 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2420918 */       GIR_RootConstrainSelectedInstOperands,
     /* 2420919 */       // GIR_Coverage, 1507,
     /* 2420919 */       GIR_Done,
     /* 2420920 */     // Label 34901: @2420920
     /* 2420920 */     GIM_Try, /*On fail goto*//*Label 34902*/ GIMT_Encode4(2420942), // Rule ID 1535 //
     /* 2420925 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2420928 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2420932 */       // MIs[0] frm
     /* 2420932 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2420935 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2420935 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2420940 */       GIR_RootConstrainSelectedInstOperands,
     /* 2420941 */       // GIR_Coverage, 1535,
     /* 2420941 */       GIR_Done,
     /* 2420942 */     // Label 34902: @2420942
     /* 2420942 */     GIM_Reject,
     /* 2420943 */   // Label 34900: @2420943
     /* 2420943 */   GIM_Reject,
     /* 2420944 */   // Label 34895: @2420944
     /* 2420944 */   GIM_Try, /*On fail goto*//*Label 34903*/ GIMT_Encode4(2420998),
     /* 2420949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420953 */     GIM_Try, /*On fail goto*//*Label 34904*/ GIMT_Encode4(2420975), // Rule ID 1901 //
     /* 2420958 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2420961 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2420965 */       // MIs[0] frm
     /* 2420965 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2420968 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2420968 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2420973 */       GIR_RootConstrainSelectedInstOperands,
     /* 2420974 */       // GIR_Coverage, 1901,
     /* 2420974 */       GIR_Done,
     /* 2420975 */     // Label 34904: @2420975
     /* 2420975 */     GIM_Try, /*On fail goto*//*Label 34905*/ GIMT_Encode4(2420997), // Rule ID 1929 //
     /* 2420980 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2420983 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420987 */       // MIs[0] frm
     /* 2420987 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2420990 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2420990 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_INX),
     /* 2420995 */       GIR_RootConstrainSelectedInstOperands,
     /* 2420996 */       // GIR_Coverage, 1929,
     /* 2420996 */       GIR_Done,
     /* 2420997 */     // Label 34905: @2420997
     /* 2420997 */     GIM_Reject,
     /* 2420998 */   // Label 34903: @2420998
     /* 2420998 */   GIM_Reject,
     /* 2420999 */   // Label 34896: @2420999
     /* 2420999 */   GIM_Reject,
     /* 2421000 */ // Label 34892: @2421000
     /* 2421000 */ GIM_Reject,
     /* 2421001 */ // Label 112: @2421001
     /* 2421001 */ GIM_Try, /*On fail goto*//*Label 34906*/ GIMT_Encode4(2421198),
     /* 2421006 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421009 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34910*/ GIMT_Encode4(2421197),
     /* 2421020 */   /*GILLT_s16*//*Label 34907*/ GIMT_Encode4(2421032),
     /* 2421024 */   /*GILLT_s32*//*Label 34908*/ GIMT_Encode4(2421087),
     /* 2421028 */   /*GILLT_s64*//*Label 34909*/ GIMT_Encode4(2421142),
     /* 2421032 */   // Label 34907: @2421032
     /* 2421032 */   GIM_Try, /*On fail goto*//*Label 34911*/ GIMT_Encode4(2421086),
     /* 2421037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421041 */     GIM_Try, /*On fail goto*//*Label 34912*/ GIMT_Encode4(2421063), // Rule ID 2239 //
     /* 2421046 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2421049 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2421053 */       // MIs[0] frm
     /* 2421053 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421056 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421056 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2421061 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421062 */       // GIR_Coverage, 2239,
     /* 2421062 */       GIR_Done,
     /* 2421063 */     // Label 34912: @2421063
     /* 2421063 */     GIM_Try, /*On fail goto*//*Label 34913*/ GIMT_Encode4(2421085), // Rule ID 2265 //
     /* 2421068 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2421071 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2421075 */       // MIs[0] frm
     /* 2421075 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421078 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421078 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2421083 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421084 */       // GIR_Coverage, 2265,
     /* 2421084 */       GIR_Done,
     /* 2421085 */     // Label 34913: @2421085
     /* 2421085 */     GIM_Reject,
     /* 2421086 */   // Label 34911: @2421086
     /* 2421086 */   GIM_Reject,
     /* 2421087 */   // Label 34908: @2421087
     /* 2421087 */   GIM_Try, /*On fail goto*//*Label 34914*/ GIMT_Encode4(2421141),
     /* 2421092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421096 */     GIM_Try, /*On fail goto*//*Label 34915*/ GIMT_Encode4(2421118), // Rule ID 1505 //
     /* 2421101 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2421104 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2421108 */       // MIs[0] frm
     /* 2421108 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421111 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421111 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2421116 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421117 */       // GIR_Coverage, 1505,
     /* 2421117 */       GIR_Done,
     /* 2421118 */     // Label 34915: @2421118
     /* 2421118 */     GIM_Try, /*On fail goto*//*Label 34916*/ GIMT_Encode4(2421140), // Rule ID 1533 //
     /* 2421123 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2421126 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2421130 */       // MIs[0] frm
     /* 2421130 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421133 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421133 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2421138 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421139 */       // GIR_Coverage, 1533,
     /* 2421139 */       GIR_Done,
     /* 2421140 */     // Label 34916: @2421140
     /* 2421140 */     GIM_Reject,
     /* 2421141 */   // Label 34914: @2421141
     /* 2421141 */   GIM_Reject,
     /* 2421142 */   // Label 34909: @2421142
     /* 2421142 */   GIM_Try, /*On fail goto*//*Label 34917*/ GIMT_Encode4(2421196),
     /* 2421147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421151 */     GIM_Try, /*On fail goto*//*Label 34918*/ GIMT_Encode4(2421173), // Rule ID 1899 //
     /* 2421156 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2421159 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2421163 */       // MIs[0] frm
     /* 2421163 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421166 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421166 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2421171 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421172 */       // GIR_Coverage, 1899,
     /* 2421172 */       GIR_Done,
     /* 2421173 */     // Label 34918: @2421173
     /* 2421173 */     GIM_Try, /*On fail goto*//*Label 34919*/ GIMT_Encode4(2421195), // Rule ID 1927 //
     /* 2421178 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2421181 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421185 */       // MIs[0] frm
     /* 2421185 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2421188 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2421188 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_INX),
     /* 2421193 */       GIR_RootConstrainSelectedInstOperands,
     /* 2421194 */       // GIR_Coverage, 1927,
     /* 2421194 */       GIR_Done,
     /* 2421195 */     // Label 34919: @2421195
     /* 2421195 */     GIM_Reject,
     /* 2421196 */   // Label 34917: @2421196
     /* 2421196 */   GIM_Reject,
     /* 2421197 */   // Label 34910: @2421197
     /* 2421197 */   GIM_Reject,
     /* 2421198 */ // Label 34906: @2421198
     /* 2421198 */ GIM_Reject,
     /* 2421199 */ // Label 113: @2421199
     /* 2421199 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34922*/ GIMT_Encode4(2421258),
     /* 2421210 */ /*GILLT_s32*//*Label 34920*/ GIMT_Encode4(2421218),
     /* 2421214 */ /*GILLT_s64*//*Label 34921*/ GIMT_Encode4(2421238),
     /* 2421218 */ // Label 34920: @2421218
     /* 2421218 */ GIM_Try, /*On fail goto*//*Label 34923*/ GIMT_Encode4(2421237), // Rule ID 73 //
     /* 2421223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421230 */   // (riscv_read_vlenb:{ *:[i32] })  =>  (PseudoReadVLENB:{ *:[i32] })
     /* 2421230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2421235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421236 */   // GIR_Coverage, 73,
     /* 2421236 */   GIR_Done,
     /* 2421237 */ // Label 34923: @2421237
     /* 2421237 */ GIM_Reject,
     /* 2421238 */ // Label 34921: @2421238
     /* 2421238 */ GIM_Try, /*On fail goto*//*Label 34924*/ GIMT_Encode4(2421257), // Rule ID 72 //
     /* 2421243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421250 */   // (riscv_read_vlenb:{ *:[i64] })  =>  (PseudoReadVLENB:{ *:[i64] })
     /* 2421250 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2421255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421256 */   // GIR_Coverage, 72,
     /* 2421256 */   GIR_Done,
     /* 2421257 */ // Label 34924: @2421257
     /* 2421257 */ GIM_Reject,
     /* 2421258 */ // Label 34922: @2421258
     /* 2421258 */ GIM_Reject,
     /* 2421259 */ // Label 114: @2421259
     /* 2421259 */ GIM_Try, /*On fail goto*//*Label 34925*/ GIMT_Encode4(2421295), // Rule ID 316 //
     /* 2421264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2421267 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421288 */   // (riscv_remuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2421288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMUW),
     /* 2421293 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421294 */   // GIR_Coverage, 316,
     /* 2421294 */   GIR_Done,
     /* 2421295 */ // Label 34925: @2421295
     /* 2421295 */ GIM_Reject,
     /* 2421296 */ // Label 115: @2421296
     /* 2421296 */ GIM_Try, /*On fail goto*//*Label 34926*/ GIMT_Encode4(2421420),
     /* 2421301 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421318 */   GIM_Try, /*On fail goto*//*Label 34927*/ GIMT_Encode4(2421354), // Rule ID 2465 //
     /* 2421323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2421326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421334 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421338 */     // MIs[1] Operand 1
     /* 2421338 */     // No operand predicates
     /* 2421338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421340 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2421340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2421343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421347 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2421352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421353 */     // GIR_Coverage, 2465,
     /* 2421353 */     GIR_EraseRootFromParent_Done,
     /* 2421354 */   // Label 34927: @2421354
     /* 2421354 */   GIM_Try, /*On fail goto*//*Label 34928*/ GIMT_Encode4(2421390), // Rule ID 62566 //
     /* 2421359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2421362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421374 */     // MIs[1] Operand 1
     /* 2421374 */     // No operand predicates
     /* 2421374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421376 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2421376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2421379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421383 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2421388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421389 */     // GIR_Coverage, 62566,
     /* 2421389 */     GIR_EraseRootFromParent_Done,
     /* 2421390 */   // Label 34928: @2421390
     /* 2421390 */   GIM_Try, /*On fail goto*//*Label 34929*/ GIMT_Encode4(2421419), // Rule ID 2462 //
     /* 2421395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2421398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2421405 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2421405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROLW),
     /* 2421408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421410 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2421417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421418 */     // GIR_Coverage, 2462,
     /* 2421418 */     GIR_EraseRootFromParent_Done,
     /* 2421419 */   // Label 34929: @2421419
     /* 2421419 */   GIM_Reject,
     /* 2421420 */ // Label 34926: @2421420
     /* 2421420 */ GIM_Reject,
     /* 2421421 */ // Label 116: @2421421
     /* 2421421 */ GIM_Try, /*On fail goto*//*Label 34930*/ GIMT_Encode4(2421541),
     /* 2421426 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421443 */   GIM_Try, /*On fail goto*//*Label 34931*/ GIMT_Encode4(2421477), // Rule ID 2464 //
     /* 2421448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2421451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421463 */     // MIs[1] Operand 1
     /* 2421463 */     // No operand predicates
     /* 2421463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421465 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2421465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2421468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2421475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421476 */     // GIR_Coverage, 2464,
     /* 2421476 */     GIR_EraseRootFromParent_Done,
     /* 2421477 */   // Label 34931: @2421477
     /* 2421477 */   GIM_Try, /*On fail goto*//*Label 34932*/ GIMT_Encode4(2421511), // Rule ID 62565 //
     /* 2421482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2421485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2421489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421497 */     // MIs[1] Operand 1
     /* 2421497 */     // No operand predicates
     /* 2421497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421499 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2421499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2421502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2421509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421510 */     // GIR_Coverage, 62565,
     /* 2421510 */     GIR_EraseRootFromParent_Done,
     /* 2421511 */   // Label 34932: @2421511
     /* 2421511 */   GIM_Try, /*On fail goto*//*Label 34933*/ GIMT_Encode4(2421540), // Rule ID 2463 //
     /* 2421516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2421519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2421526 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (RORW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2421526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORW),
     /* 2421529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2421538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421539 */     // GIR_Coverage, 2463,
     /* 2421539 */     GIR_EraseRootFromParent_Done,
     /* 2421540 */   // Label 34933: @2421540
     /* 2421540 */   GIM_Reject,
     /* 2421541 */ // Label 34930: @2421541
     /* 2421541 */ GIM_Reject,
     /* 2421542 */ // Label 117: @2421542
     /* 2421542 */ GIM_Try, /*On fail goto*//*Label 34934*/ GIMT_Encode4(2421588), // Rule ID 267 //
     /* 2421547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2421550 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2421574 */   // (riscv_sllw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2421574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLW),
     /* 2421577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421579 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421581 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2421586 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421587 */   // GIR_Coverage, 267,
     /* 2421587 */   GIR_EraseRootFromParent_Done,
     /* 2421588 */ // Label 34934: @2421588
     /* 2421588 */ GIM_Reject,
     /* 2421589 */ // Label 118: @2421589
     /* 2421589 */ GIM_Try, /*On fail goto*//*Label 34935*/ GIMT_Encode4(2421635), // Rule ID 269 //
     /* 2421594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2421597 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421614 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2421621 */   // (riscv_sraw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRAW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2421621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAW),
     /* 2421624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421626 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2421633 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421634 */   // GIR_Coverage, 269,
     /* 2421634 */   GIR_EraseRootFromParent_Done,
     /* 2421635 */ // Label 34935: @2421635
     /* 2421635 */ GIM_Reject,
     /* 2421636 */ // Label 119: @2421636
     /* 2421636 */ GIM_Try, /*On fail goto*//*Label 34936*/ GIMT_Encode4(2421682), // Rule ID 268 //
     /* 2421641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2421644 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2421647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2421653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2421668 */   // (riscv_srlw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2421668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLW),
     /* 2421671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421673 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2421675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2421680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421681 */   // GIR_Coverage, 268,
     /* 2421681 */   GIR_EraseRootFromParent_Done,
     /* 2421682 */ // Label 34936: @2421682
     /* 2421682 */ GIM_Reject,
     /* 2421683 */ // Label 120: @2421683
     /* 2421683 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34944*/ GIMT_Encode4(2422331),
     /* 2421694 */ /*GILLT_nxv1s1*//*Label 34937*/ GIMT_Encode4(2421806), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2421714 */ /*GILLT_nxv2s1*//*Label 34938*/ GIMT_Encode4(2421881), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2421734 */ /*GILLT_nxv4s1*//*Label 34939*/ GIMT_Encode4(2421956), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2421754 */ /*GILLT_nxv8s1*//*Label 34940*/ GIMT_Encode4(2422031), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2421774 */ /*GILLT_nxv16s1*//*Label 34941*/ GIMT_Encode4(2422106), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2421790 */ /*GILLT_nxv32s1*//*Label 34942*/ GIMT_Encode4(2422181), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2421802 */ /*GILLT_nxv64s1*//*Label 34943*/ GIMT_Encode4(2422256),
     /* 2421806 */ // Label 34937: @2421806
     /* 2421806 */ GIM_Try, /*On fail goto*//*Label 34945*/ GIMT_Encode4(2421843), // Rule ID 44712 //
     /* 2421811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421828 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2421828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2421831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2421841 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421842 */   // GIR_Coverage, 44712,
     /* 2421842 */   GIR_EraseRootFromParent_Done,
     /* 2421843 */ // Label 34945: @2421843
     /* 2421843 */ GIM_Try, /*On fail goto*//*Label 34946*/ GIMT_Encode4(2421880), // Rule ID 44713 //
     /* 2421848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2421854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421858 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421865 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2421865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2421868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2421878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421879 */   // GIR_Coverage, 44713,
     /* 2421879 */   GIR_EraseRootFromParent_Done,
     /* 2421880 */ // Label 34946: @2421880
     /* 2421880 */ GIM_Reject,
     /* 2421881 */ // Label 34938: @2421881
     /* 2421881 */ GIM_Try, /*On fail goto*//*Label 34947*/ GIMT_Encode4(2421918), // Rule ID 44740 //
     /* 2421886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421896 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421903 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2421903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2421906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2421916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421917 */   // GIR_Coverage, 44740,
     /* 2421917 */   GIR_EraseRootFromParent_Done,
     /* 2421918 */ // Label 34947: @2421918
     /* 2421918 */ GIM_Try, /*On fail goto*//*Label 34948*/ GIMT_Encode4(2421955), // Rule ID 44741 //
     /* 2421923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2421929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421933 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421940 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2421940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2421943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421945 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2421953 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421954 */   // GIR_Coverage, 44741,
     /* 2421954 */   GIR_EraseRootFromParent_Done,
     /* 2421955 */ // Label 34948: @2421955
     /* 2421955 */ GIM_Reject,
     /* 2421956 */ // Label 34939: @2421956
     /* 2421956 */ GIM_Try, /*On fail goto*//*Label 34949*/ GIMT_Encode4(2421993), // Rule ID 44768 //
     /* 2421961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2421967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2421971 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421978 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2421978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2421981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2421991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2421992 */   // GIR_Coverage, 44768,
     /* 2421992 */   GIR_EraseRootFromParent_Done,
     /* 2421993 */ // Label 34949: @2421993
     /* 2421993 */ GIM_Try, /*On fail goto*//*Label 34950*/ GIMT_Encode4(2422030), // Rule ID 44769 //
     /* 2421998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422015 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2422018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422029 */   // GIR_Coverage, 44769,
     /* 2422029 */   GIR_EraseRootFromParent_Done,
     /* 2422030 */ // Label 34950: @2422030
     /* 2422030 */ GIM_Reject,
     /* 2422031 */ // Label 34940: @2422031
     /* 2422031 */ GIM_Try, /*On fail goto*//*Label 34951*/ GIMT_Encode4(2422068), // Rule ID 44796 //
     /* 2422036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422053 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2422056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422067 */   // GIR_Coverage, 44796,
     /* 2422067 */   GIR_EraseRootFromParent_Done,
     /* 2422068 */ // Label 34951: @2422068
     /* 2422068 */ GIM_Try, /*On fail goto*//*Label 34952*/ GIMT_Encode4(2422105), // Rule ID 44797 //
     /* 2422073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422090 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2422093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422104 */   // GIR_Coverage, 44797,
     /* 2422104 */   GIR_EraseRootFromParent_Done,
     /* 2422105 */ // Label 34952: @2422105
     /* 2422105 */ GIM_Reject,
     /* 2422106 */ // Label 34941: @2422106
     /* 2422106 */ GIM_Try, /*On fail goto*//*Label 34953*/ GIMT_Encode4(2422143), // Rule ID 44824 //
     /* 2422111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422121 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422128 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2422131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422142 */   // GIR_Coverage, 44824,
     /* 2422142 */   GIR_EraseRootFromParent_Done,
     /* 2422143 */ // Label 34953: @2422143
     /* 2422143 */ GIM_Try, /*On fail goto*//*Label 34954*/ GIMT_Encode4(2422180), // Rule ID 44825 //
     /* 2422148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422165 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2422168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422179 */   // GIR_Coverage, 44825,
     /* 2422179 */   GIR_EraseRootFromParent_Done,
     /* 2422180 */ // Label 34954: @2422180
     /* 2422180 */ GIM_Reject,
     /* 2422181 */ // Label 34942: @2422181
     /* 2422181 */ GIM_Try, /*On fail goto*//*Label 34955*/ GIMT_Encode4(2422218), // Rule ID 44852 //
     /* 2422186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422196 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422203 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2422206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422216 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422217 */   // GIR_Coverage, 44852,
     /* 2422217 */   GIR_EraseRootFromParent_Done,
     /* 2422218 */ // Label 34955: @2422218
     /* 2422218 */ GIM_Try, /*On fail goto*//*Label 34956*/ GIMT_Encode4(2422255), // Rule ID 44853 //
     /* 2422223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422233 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422240 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2422243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422253 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422254 */   // GIR_Coverage, 44853,
     /* 2422254 */   GIR_EraseRootFromParent_Done,
     /* 2422255 */ // Label 34956: @2422255
     /* 2422255 */ GIM_Reject,
     /* 2422256 */ // Label 34943: @2422256
     /* 2422256 */ GIM_Try, /*On fail goto*//*Label 34957*/ GIMT_Encode4(2422293), // Rule ID 44880 //
     /* 2422261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422271 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422278 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2422281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422291 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422292 */   // GIR_Coverage, 44880,
     /* 2422292 */   GIR_EraseRootFromParent_Done,
     /* 2422293 */ // Label 34957: @2422293
     /* 2422293 */ GIM_Try, /*On fail goto*//*Label 34958*/ GIMT_Encode4(2422330), // Rule ID 44881 //
     /* 2422298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422308 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422315 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2422318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422329 */   // GIR_Coverage, 44881,
     /* 2422329 */   GIR_EraseRootFromParent_Done,
     /* 2422330 */ // Label 34958: @2422330
     /* 2422330 */ GIM_Reject,
     /* 2422331 */ // Label 34944: @2422331
     /* 2422331 */ GIM_Reject,
     /* 2422332 */ // Label 121: @2422332
     /* 2422332 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34966*/ GIMT_Encode4(2422980),
     /* 2422343 */ /*GILLT_nxv1s1*//*Label 34959*/ GIMT_Encode4(2422455), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422363 */ /*GILLT_nxv2s1*//*Label 34960*/ GIMT_Encode4(2422530), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422383 */ /*GILLT_nxv4s1*//*Label 34961*/ GIMT_Encode4(2422605), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422403 */ /*GILLT_nxv8s1*//*Label 34962*/ GIMT_Encode4(2422680), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422423 */ /*GILLT_nxv16s1*//*Label 34963*/ GIMT_Encode4(2422755), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422439 */ /*GILLT_nxv32s1*//*Label 34964*/ GIMT_Encode4(2422830), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2422451 */ /*GILLT_nxv64s1*//*Label 34965*/ GIMT_Encode4(2422905),
     /* 2422455 */ // Label 34959: @2422455
     /* 2422455 */ GIM_Try, /*On fail goto*//*Label 34967*/ GIMT_Encode4(2422492), // Rule ID 44710 //
     /* 2422460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422470 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422477 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2422480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422491 */   // GIR_Coverage, 44710,
     /* 2422491 */   GIR_EraseRootFromParent_Done,
     /* 2422492 */ // Label 34967: @2422492
     /* 2422492 */ GIM_Try, /*On fail goto*//*Label 34968*/ GIMT_Encode4(2422529), // Rule ID 44711 //
     /* 2422497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422514 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2422517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422519 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422528 */   // GIR_Coverage, 44711,
     /* 2422528 */   GIR_EraseRootFromParent_Done,
     /* 2422529 */ // Label 34968: @2422529
     /* 2422529 */ GIM_Reject,
     /* 2422530 */ // Label 34960: @2422530
     /* 2422530 */ GIM_Try, /*On fail goto*//*Label 34969*/ GIMT_Encode4(2422567), // Rule ID 44738 //
     /* 2422535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422545 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422552 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2422555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422566 */   // GIR_Coverage, 44738,
     /* 2422566 */   GIR_EraseRootFromParent_Done,
     /* 2422567 */ // Label 34969: @2422567
     /* 2422567 */ GIM_Try, /*On fail goto*//*Label 34970*/ GIMT_Encode4(2422604), // Rule ID 44739 //
     /* 2422572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422582 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422589 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2422592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422594 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422602 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422603 */   // GIR_Coverage, 44739,
     /* 2422603 */   GIR_EraseRootFromParent_Done,
     /* 2422604 */ // Label 34970: @2422604
     /* 2422604 */ GIM_Reject,
     /* 2422605 */ // Label 34961: @2422605
     /* 2422605 */ GIM_Try, /*On fail goto*//*Label 34971*/ GIMT_Encode4(2422642), // Rule ID 44766 //
     /* 2422610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422620 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422627 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2422630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422641 */   // GIR_Coverage, 44766,
     /* 2422641 */   GIR_EraseRootFromParent_Done,
     /* 2422642 */ // Label 34971: @2422642
     /* 2422642 */ GIM_Try, /*On fail goto*//*Label 34972*/ GIMT_Encode4(2422679), // Rule ID 44767 //
     /* 2422647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422664 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2422667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422674 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422678 */   // GIR_Coverage, 44767,
     /* 2422678 */   GIR_EraseRootFromParent_Done,
     /* 2422679 */ // Label 34972: @2422679
     /* 2422679 */ GIM_Reject,
     /* 2422680 */ // Label 34962: @2422680
     /* 2422680 */ GIM_Try, /*On fail goto*//*Label 34973*/ GIMT_Encode4(2422717), // Rule ID 44794 //
     /* 2422685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422695 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422702 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2422705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422707 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422716 */   // GIR_Coverage, 44794,
     /* 2422716 */   GIR_EraseRootFromParent_Done,
     /* 2422717 */ // Label 34973: @2422717
     /* 2422717 */ GIM_Try, /*On fail goto*//*Label 34974*/ GIMT_Encode4(2422754), // Rule ID 44795 //
     /* 2422722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422732 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422739 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2422742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422753 */   // GIR_Coverage, 44795,
     /* 2422753 */   GIR_EraseRootFromParent_Done,
     /* 2422754 */ // Label 34974: @2422754
     /* 2422754 */ GIM_Reject,
     /* 2422755 */ // Label 34963: @2422755
     /* 2422755 */ GIM_Try, /*On fail goto*//*Label 34975*/ GIMT_Encode4(2422792), // Rule ID 44822 //
     /* 2422760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422770 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422777 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2422780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422791 */   // GIR_Coverage, 44822,
     /* 2422791 */   GIR_EraseRootFromParent_Done,
     /* 2422792 */ // Label 34975: @2422792
     /* 2422792 */ GIM_Try, /*On fail goto*//*Label 34976*/ GIMT_Encode4(2422829), // Rule ID 44823 //
     /* 2422797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422807 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422814 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2422817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422819 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422828 */   // GIR_Coverage, 44823,
     /* 2422828 */   GIR_EraseRootFromParent_Done,
     /* 2422829 */ // Label 34976: @2422829
     /* 2422829 */ GIM_Reject,
     /* 2422830 */ // Label 34964: @2422830
     /* 2422830 */ GIM_Try, /*On fail goto*//*Label 34977*/ GIMT_Encode4(2422867), // Rule ID 44850 //
     /* 2422835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422845 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422852 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2422855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422857 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422865 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422866 */   // GIR_Coverage, 44850,
     /* 2422866 */   GIR_EraseRootFromParent_Done,
     /* 2422867 */ // Label 34977: @2422867
     /* 2422867 */ GIM_Try, /*On fail goto*//*Label 34978*/ GIMT_Encode4(2422904), // Rule ID 44851 //
     /* 2422872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422882 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422889 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2422892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422894 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422902 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422903 */   // GIR_Coverage, 44851,
     /* 2422903 */   GIR_EraseRootFromParent_Done,
     /* 2422904 */ // Label 34978: @2422904
     /* 2422904 */ GIM_Reject,
     /* 2422905 */ // Label 34965: @2422905
     /* 2422905 */ GIM_Try, /*On fail goto*//*Label 34979*/ GIMT_Encode4(2422942), // Rule ID 44878 //
     /* 2422910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2422916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422927 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2422927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2422930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422940 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422941 */   // GIR_Coverage, 44878,
     /* 2422941 */   GIR_EraseRootFromParent_Done,
     /* 2422942 */ // Label 34979: @2422942
     /* 2422942 */ GIM_Try, /*On fail goto*//*Label 34980*/ GIMT_Encode4(2422979), // Rule ID 44879 //
     /* 2422947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2422953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2422957 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422964 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2422964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2422967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2422977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2422978 */   // GIR_Coverage, 44879,
     /* 2422978 */   GIR_EraseRootFromParent_Done,
     /* 2422979 */ // Label 34980: @2422979
     /* 2422979 */ GIM_Reject,
     /* 2422980 */ // Label 34966: @2422980
     /* 2422980 */ GIM_Reject,
     /* 2422981 */ // Label 122: @2422981
     /* 2422981 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35003*/ GIMT_Encode4(2427238),
     /* 2422992 */ /*GILLT_nxv1s8*//*Label 34981*/ GIMT_Encode4(2423104),
     /* 2422996 */ /*GILLT_nxv1s16*//*Label 34982*/ GIMT_Encode4(2423221),
     /* 2423000 */ /*GILLT_nxv1s32*//*Label 34983*/ GIMT_Encode4(2423442),
     /* 2423004 */ /*GILLT_nxv1s64*//*Label 34984*/ GIMT_Encode4(2423663), GIMT_Encode4(0),
     /* 2423012 */ /*GILLT_nxv2s8*//*Label 34985*/ GIMT_Encode4(2423884),
     /* 2423016 */ /*GILLT_nxv2s16*//*Label 34986*/ GIMT_Encode4(2424001),
     /* 2423020 */ /*GILLT_nxv2s32*//*Label 34987*/ GIMT_Encode4(2424222),
     /* 2423024 */ /*GILLT_nxv2s64*//*Label 34988*/ GIMT_Encode4(2424443), GIMT_Encode4(0),
     /* 2423032 */ /*GILLT_nxv4s8*//*Label 34989*/ GIMT_Encode4(2424664),
     /* 2423036 */ /*GILLT_nxv4s16*//*Label 34990*/ GIMT_Encode4(2424781),
     /* 2423040 */ /*GILLT_nxv4s32*//*Label 34991*/ GIMT_Encode4(2425002),
     /* 2423044 */ /*GILLT_nxv4s64*//*Label 34992*/ GIMT_Encode4(2425223), GIMT_Encode4(0),
     /* 2423052 */ /*GILLT_nxv8s8*//*Label 34993*/ GIMT_Encode4(2425444),
     /* 2423056 */ /*GILLT_nxv8s16*//*Label 34994*/ GIMT_Encode4(2425561),
     /* 2423060 */ /*GILLT_nxv8s32*//*Label 34995*/ GIMT_Encode4(2425782),
     /* 2423064 */ /*GILLT_nxv8s64*//*Label 34996*/ GIMT_Encode4(2426003), GIMT_Encode4(0),
     /* 2423072 */ /*GILLT_nxv16s8*//*Label 34997*/ GIMT_Encode4(2426224),
     /* 2423076 */ /*GILLT_nxv16s16*//*Label 34998*/ GIMT_Encode4(2426341),
     /* 2423080 */ /*GILLT_nxv16s32*//*Label 34999*/ GIMT_Encode4(2426562), GIMT_Encode4(0),
     /* 2423088 */ /*GILLT_nxv32s8*//*Label 35000*/ GIMT_Encode4(2426783),
     /* 2423092 */ /*GILLT_nxv32s16*//*Label 35001*/ GIMT_Encode4(2426900), GIMT_Encode4(0),
     /* 2423100 */ /*GILLT_nxv64s8*//*Label 35002*/ GIMT_Encode4(2427121),
     /* 2423104 */ // Label 34981: @2423104
     /* 2423104 */ GIM_Try, /*On fail goto*//*Label 35004*/ GIMT_Encode4(2423220),
     /* 2423109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2423112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2423115 */   GIM_Try, /*On fail goto*//*Label 35005*/ GIMT_Encode4(2423167), // Rule ID 32300 //
     /* 2423120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423145 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2423148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423150 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423166 */     // GIR_Coverage, 32300,
     /* 2423166 */     GIR_EraseRootFromParent_Done,
     /* 2423167 */   // Label 35005: @2423167
     /* 2423167 */   GIM_Try, /*On fail goto*//*Label 35006*/ GIMT_Encode4(2423219), // Rule ID 32301 //
     /* 2423172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423197 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2423200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423202 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423218 */     // GIR_Coverage, 32301,
     /* 2423218 */     GIR_EraseRootFromParent_Done,
     /* 2423219 */   // Label 35006: @2423219
     /* 2423219 */   GIM_Reject,
     /* 2423220 */ // Label 35004: @2423220
     /* 2423220 */ GIM_Reject,
     /* 2423221 */ // Label 34982: @2423221
     /* 2423221 */ GIM_Try, /*On fail goto*//*Label 35007*/ GIMT_Encode4(2423441),
     /* 2423226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2423229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2423232 */   GIM_Try, /*On fail goto*//*Label 35008*/ GIMT_Encode4(2423284), // Rule ID 32570 //
     /* 2423237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423262 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423267 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423283 */     // GIR_Coverage, 32570,
     /* 2423283 */     GIR_EraseRootFromParent_Done,
     /* 2423284 */   // Label 35008: @2423284
     /* 2423284 */   GIM_Try, /*On fail goto*//*Label 35009*/ GIMT_Encode4(2423336), // Rule ID 32571 //
     /* 2423289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423314 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423319 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423335 */     // GIR_Coverage, 32571,
     /* 2423335 */     GIR_EraseRootFromParent_Done,
     /* 2423336 */   // Label 35009: @2423336
     /* 2423336 */   GIM_Try, /*On fail goto*//*Label 35010*/ GIMT_Encode4(2423388), // Rule ID 34280 //
     /* 2423341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423366 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423371 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423387 */     // GIR_Coverage, 34280,
     /* 2423387 */     GIR_EraseRootFromParent_Done,
     /* 2423388 */   // Label 35010: @2423388
     /* 2423388 */   GIM_Try, /*On fail goto*//*Label 35011*/ GIMT_Encode4(2423440), // Rule ID 34281 //
     /* 2423393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423418 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423423 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423439 */     // GIR_Coverage, 34281,
     /* 2423439 */     GIR_EraseRootFromParent_Done,
     /* 2423440 */   // Label 35011: @2423440
     /* 2423440 */   GIM_Reject,
     /* 2423441 */ // Label 35007: @2423441
     /* 2423441 */ GIM_Reject,
     /* 2423442 */ // Label 34983: @2423442
     /* 2423442 */ GIM_Try, /*On fail goto*//*Label 35012*/ GIMT_Encode4(2423662),
     /* 2423447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2423450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2423453 */   GIM_Try, /*On fail goto*//*Label 35013*/ GIMT_Encode4(2423505), // Rule ID 32750 //
     /* 2423458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423483 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2423486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423488 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423504 */     // GIR_Coverage, 32750,
     /* 2423504 */     GIR_EraseRootFromParent_Done,
     /* 2423505 */   // Label 35013: @2423505
     /* 2423505 */   GIM_Try, /*On fail goto*//*Label 35014*/ GIMT_Encode4(2423557), // Rule ID 32751 //
     /* 2423510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423535 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2423538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423540 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423556 */     // GIR_Coverage, 32751,
     /* 2423556 */     GIR_EraseRootFromParent_Done,
     /* 2423557 */   // Label 35014: @2423557
     /* 2423557 */   GIM_Try, /*On fail goto*//*Label 35015*/ GIMT_Encode4(2423609), // Rule ID 34460 //
     /* 2423562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423587 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2423590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423592 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423608 */     // GIR_Coverage, 34460,
     /* 2423608 */     GIR_EraseRootFromParent_Done,
     /* 2423609 */   // Label 35015: @2423609
     /* 2423609 */   GIM_Try, /*On fail goto*//*Label 35016*/ GIMT_Encode4(2423661), // Rule ID 34461 //
     /* 2423614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423639 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2423642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423644 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2423656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423660 */     // GIR_Coverage, 34461,
     /* 2423660 */     GIR_EraseRootFromParent_Done,
     /* 2423661 */   // Label 35016: @2423661
     /* 2423661 */   GIM_Reject,
     /* 2423662 */ // Label 35012: @2423662
     /* 2423662 */ GIM_Reject,
     /* 2423663 */ // Label 34984: @2423663
     /* 2423663 */ GIM_Try, /*On fail goto*//*Label 35017*/ GIMT_Encode4(2423883),
     /* 2423668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2423671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2423674 */   GIM_Try, /*On fail goto*//*Label 35018*/ GIMT_Encode4(2423726), // Rule ID 33110 //
     /* 2423679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2423682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423704 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2423707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423709 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2423721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423725 */     // GIR_Coverage, 33110,
     /* 2423725 */     GIR_EraseRootFromParent_Done,
     /* 2423726 */   // Label 35018: @2423726
     /* 2423726 */   GIM_Try, /*On fail goto*//*Label 35019*/ GIMT_Encode4(2423778), // Rule ID 33111 //
     /* 2423731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2423734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423756 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2423759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423761 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2423773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423777 */     // GIR_Coverage, 33111,
     /* 2423777 */     GIR_EraseRootFromParent_Done,
     /* 2423778 */   // Label 35019: @2423778
     /* 2423778 */   GIM_Try, /*On fail goto*//*Label 35020*/ GIMT_Encode4(2423830), // Rule ID 34730 //
     /* 2423783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2423786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423808 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2423811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423813 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2423825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423829 */     // GIR_Coverage, 34730,
     /* 2423829 */     GIR_EraseRootFromParent_Done,
     /* 2423830 */   // Label 35020: @2423830
     /* 2423830 */   GIM_Try, /*On fail goto*//*Label 35021*/ GIMT_Encode4(2423882), // Rule ID 34731 //
     /* 2423835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2423838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423860 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2423863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423865 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2423877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423881 */     // GIR_Coverage, 34731,
     /* 2423881 */     GIR_EraseRootFromParent_Done,
     /* 2423882 */   // Label 35021: @2423882
     /* 2423882 */   GIM_Reject,
     /* 2423883 */ // Label 35017: @2423883
     /* 2423883 */ GIM_Reject,
     /* 2423884 */ // Label 34985: @2423884
     /* 2423884 */ GIM_Try, /*On fail goto*//*Label 35022*/ GIMT_Encode4(2424000),
     /* 2423889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2423892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2423895 */   GIM_Try, /*On fail goto*//*Label 35023*/ GIMT_Encode4(2423947), // Rule ID 32390 //
     /* 2423900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423925 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2423925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423930 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423946 */     // GIR_Coverage, 32390,
     /* 2423946 */     GIR_EraseRootFromParent_Done,
     /* 2423947 */   // Label 35023: @2423947
     /* 2423947 */   GIM_Try, /*On fail goto*//*Label 35024*/ GIMT_Encode4(2423999), // Rule ID 32391 //
     /* 2423952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423977 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2423977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2423980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423982 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2423984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2423986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2423997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423998 */     // GIR_Coverage, 32391,
     /* 2423998 */     GIR_EraseRootFromParent_Done,
     /* 2423999 */   // Label 35024: @2423999
     /* 2423999 */   GIM_Reject,
     /* 2424000 */ // Label 35022: @2424000
     /* 2424000 */ GIM_Reject,
     /* 2424001 */ // Label 34986: @2424001
     /* 2424001 */ GIM_Try, /*On fail goto*//*Label 35025*/ GIMT_Encode4(2424221),
     /* 2424006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2424009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2424012 */   GIM_Try, /*On fail goto*//*Label 35026*/ GIMT_Encode4(2424064), // Rule ID 32660 //
     /* 2424017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424042 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424047 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424063 */     // GIR_Coverage, 32660,
     /* 2424063 */     GIR_EraseRootFromParent_Done,
     /* 2424064 */   // Label 35026: @2424064
     /* 2424064 */   GIM_Try, /*On fail goto*//*Label 35027*/ GIMT_Encode4(2424116), // Rule ID 32661 //
     /* 2424069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424094 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424099 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424115 */     // GIR_Coverage, 32661,
     /* 2424115 */     GIR_EraseRootFromParent_Done,
     /* 2424116 */   // Label 35027: @2424116
     /* 2424116 */   GIM_Try, /*On fail goto*//*Label 35028*/ GIMT_Encode4(2424168), // Rule ID 34370 //
     /* 2424121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424146 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424151 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424167 */     // GIR_Coverage, 34370,
     /* 2424167 */     GIR_EraseRootFromParent_Done,
     /* 2424168 */   // Label 35028: @2424168
     /* 2424168 */   GIM_Try, /*On fail goto*//*Label 35029*/ GIMT_Encode4(2424220), // Rule ID 34371 //
     /* 2424173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424198 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424203 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424219 */     // GIR_Coverage, 34371,
     /* 2424219 */     GIR_EraseRootFromParent_Done,
     /* 2424220 */   // Label 35029: @2424220
     /* 2424220 */   GIM_Reject,
     /* 2424221 */ // Label 35025: @2424221
     /* 2424221 */ GIM_Reject,
     /* 2424222 */ // Label 34987: @2424222
     /* 2424222 */ GIM_Try, /*On fail goto*//*Label 35030*/ GIMT_Encode4(2424442),
     /* 2424227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2424230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2424233 */   GIM_Try, /*On fail goto*//*Label 35031*/ GIMT_Encode4(2424285), // Rule ID 33020 //
     /* 2424238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424263 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424268 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424284 */     // GIR_Coverage, 33020,
     /* 2424284 */     GIR_EraseRootFromParent_Done,
     /* 2424285 */   // Label 35031: @2424285
     /* 2424285 */   GIM_Try, /*On fail goto*//*Label 35032*/ GIMT_Encode4(2424337), // Rule ID 33021 //
     /* 2424290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424315 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424320 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424336 */     // GIR_Coverage, 33021,
     /* 2424336 */     GIR_EraseRootFromParent_Done,
     /* 2424337 */   // Label 35032: @2424337
     /* 2424337 */   GIM_Try, /*On fail goto*//*Label 35033*/ GIMT_Encode4(2424389), // Rule ID 34640 //
     /* 2424342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424367 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424372 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424388 */     // GIR_Coverage, 34640,
     /* 2424388 */     GIR_EraseRootFromParent_Done,
     /* 2424389 */   // Label 35033: @2424389
     /* 2424389 */   GIM_Try, /*On fail goto*//*Label 35034*/ GIMT_Encode4(2424441), // Rule ID 34641 //
     /* 2424394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424419 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424424 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424440 */     // GIR_Coverage, 34641,
     /* 2424440 */     GIR_EraseRootFromParent_Done,
     /* 2424441 */   // Label 35034: @2424441
     /* 2424441 */   GIM_Reject,
     /* 2424442 */ // Label 35030: @2424442
     /* 2424442 */ GIM_Reject,
     /* 2424443 */ // Label 34988: @2424443
     /* 2424443 */ GIM_Try, /*On fail goto*//*Label 35035*/ GIMT_Encode4(2424663),
     /* 2424448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2424451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2424454 */   GIM_Try, /*On fail goto*//*Label 35036*/ GIMT_Encode4(2424506), // Rule ID 34010 //
     /* 2424459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424484 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2424487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424489 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424505 */     // GIR_Coverage, 34010,
     /* 2424505 */     GIR_EraseRootFromParent_Done,
     /* 2424506 */   // Label 35036: @2424506
     /* 2424506 */   GIM_Try, /*On fail goto*//*Label 35037*/ GIMT_Encode4(2424558), // Rule ID 34011 //
     /* 2424511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2424514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424536 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2424539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424541 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424557 */     // GIR_Coverage, 34011,
     /* 2424557 */     GIR_EraseRootFromParent_Done,
     /* 2424558 */   // Label 35037: @2424558
     /* 2424558 */   GIM_Try, /*On fail goto*//*Label 35038*/ GIMT_Encode4(2424610), // Rule ID 35360 //
     /* 2424563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2424566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424588 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2424591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424593 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424609 */     // GIR_Coverage, 35360,
     /* 2424609 */     GIR_EraseRootFromParent_Done,
     /* 2424610 */   // Label 35038: @2424610
     /* 2424610 */   GIM_Try, /*On fail goto*//*Label 35039*/ GIMT_Encode4(2424662), // Rule ID 35361 //
     /* 2424615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2424618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2424633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424640 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2424643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424645 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2424657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424661 */     // GIR_Coverage, 35361,
     /* 2424661 */     GIR_EraseRootFromParent_Done,
     /* 2424662 */   // Label 35039: @2424662
     /* 2424662 */   GIM_Reject,
     /* 2424663 */ // Label 35035: @2424663
     /* 2424663 */ GIM_Reject,
     /* 2424664 */ // Label 34989: @2424664
     /* 2424664 */ GIM_Try, /*On fail goto*//*Label 35040*/ GIMT_Encode4(2424780),
     /* 2424669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2424672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2424675 */   GIM_Try, /*On fail goto*//*Label 35041*/ GIMT_Encode4(2424727), // Rule ID 32480 //
     /* 2424680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424705 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424710 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424726 */     // GIR_Coverage, 32480,
     /* 2424726 */     GIR_EraseRootFromParent_Done,
     /* 2424727 */   // Label 35041: @2424727
     /* 2424727 */   GIM_Try, /*On fail goto*//*Label 35042*/ GIMT_Encode4(2424779), // Rule ID 32481 //
     /* 2424732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424757 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2424760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424762 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2424774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424778 */     // GIR_Coverage, 32481,
     /* 2424778 */     GIR_EraseRootFromParent_Done,
     /* 2424779 */   // Label 35042: @2424779
     /* 2424779 */   GIM_Reject,
     /* 2424780 */ // Label 35040: @2424780
     /* 2424780 */ GIM_Reject,
     /* 2424781 */ // Label 34990: @2424781
     /* 2424781 */ GIM_Try, /*On fail goto*//*Label 35043*/ GIMT_Encode4(2425001),
     /* 2424786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2424789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2424792 */   GIM_Try, /*On fail goto*//*Label 35044*/ GIMT_Encode4(2424844), // Rule ID 32930 //
     /* 2424797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424822 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424827 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424843 */     // GIR_Coverage, 32930,
     /* 2424843 */     GIR_EraseRootFromParent_Done,
     /* 2424844 */   // Label 35044: @2424844
     /* 2424844 */   GIM_Try, /*On fail goto*//*Label 35045*/ GIMT_Encode4(2424896), // Rule ID 32931 //
     /* 2424849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424874 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424879 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424895 */     // GIR_Coverage, 32931,
     /* 2424895 */     GIR_EraseRootFromParent_Done,
     /* 2424896 */   // Label 35045: @2424896
     /* 2424896 */   GIM_Try, /*On fail goto*//*Label 35046*/ GIMT_Encode4(2424948), // Rule ID 34550 //
     /* 2424901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424926 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2424926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424931 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424947 */     // GIR_Coverage, 34550,
     /* 2424947 */     GIR_EraseRootFromParent_Done,
     /* 2424948 */   // Label 35046: @2424948
     /* 2424948 */   GIM_Try, /*On fail goto*//*Label 35047*/ GIMT_Encode4(2425000), // Rule ID 34551 //
     /* 2424953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424978 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2424978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2424981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424983 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2424985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2424987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2424998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424999 */     // GIR_Coverage, 34551,
     /* 2424999 */     GIR_EraseRootFromParent_Done,
     /* 2425000 */   // Label 35047: @2425000
     /* 2425000 */   GIM_Reject,
     /* 2425001 */ // Label 35043: @2425001
     /* 2425001 */ GIM_Reject,
     /* 2425002 */ // Label 34991: @2425002
     /* 2425002 */ GIM_Try, /*On fail goto*//*Label 35048*/ GIMT_Encode4(2425222),
     /* 2425007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2425010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2425013 */   GIM_Try, /*On fail goto*//*Label 35049*/ GIMT_Encode4(2425065), // Rule ID 33740 //
     /* 2425018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425043 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425048 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425064 */     // GIR_Coverage, 33740,
     /* 2425064 */     GIR_EraseRootFromParent_Done,
     /* 2425065 */   // Label 35049: @2425065
     /* 2425065 */   GIM_Try, /*On fail goto*//*Label 35050*/ GIMT_Encode4(2425117), // Rule ID 33741 //
     /* 2425070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425095 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425100 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425116 */     // GIR_Coverage, 33741,
     /* 2425116 */     GIR_EraseRootFromParent_Done,
     /* 2425117 */   // Label 35050: @2425117
     /* 2425117 */   GIM_Try, /*On fail goto*//*Label 35051*/ GIMT_Encode4(2425169), // Rule ID 35090 //
     /* 2425122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425147 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425152 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425168 */     // GIR_Coverage, 35090,
     /* 2425168 */     GIR_EraseRootFromParent_Done,
     /* 2425169 */   // Label 35051: @2425169
     /* 2425169 */   GIM_Try, /*On fail goto*//*Label 35052*/ GIMT_Encode4(2425221), // Rule ID 35091 //
     /* 2425174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425199 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425204 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425220 */     // GIR_Coverage, 35091,
     /* 2425220 */     GIR_EraseRootFromParent_Done,
     /* 2425221 */   // Label 35052: @2425221
     /* 2425221 */   GIM_Reject,
     /* 2425222 */ // Label 35048: @2425222
     /* 2425222 */ GIM_Reject,
     /* 2425223 */ // Label 34992: @2425223
     /* 2425223 */ GIM_Try, /*On fail goto*//*Label 35053*/ GIMT_Encode4(2425443),
     /* 2425228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2425231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2425234 */   GIM_Try, /*On fail goto*//*Label 35054*/ GIMT_Encode4(2425286), // Rule ID 34100 //
     /* 2425239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2425242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425264 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425269 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425285 */     // GIR_Coverage, 34100,
     /* 2425285 */     GIR_EraseRootFromParent_Done,
     /* 2425286 */   // Label 35054: @2425286
     /* 2425286 */   GIM_Try, /*On fail goto*//*Label 35055*/ GIMT_Encode4(2425338), // Rule ID 34101 //
     /* 2425291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425316 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425321 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425337 */     // GIR_Coverage, 34101,
     /* 2425337 */     GIR_EraseRootFromParent_Done,
     /* 2425338 */   // Label 35055: @2425338
     /* 2425338 */   GIM_Try, /*On fail goto*//*Label 35056*/ GIMT_Encode4(2425390), // Rule ID 35450 //
     /* 2425343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2425346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425368 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425373 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425389 */     // GIR_Coverage, 35450,
     /* 2425389 */     GIR_EraseRootFromParent_Done,
     /* 2425390 */   // Label 35056: @2425390
     /* 2425390 */   GIM_Try, /*On fail goto*//*Label 35057*/ GIMT_Encode4(2425442), // Rule ID 35451 //
     /* 2425395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425420 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425425 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425441 */     // GIR_Coverage, 35451,
     /* 2425441 */     GIR_EraseRootFromParent_Done,
     /* 2425442 */   // Label 35057: @2425442
     /* 2425442 */   GIM_Reject,
     /* 2425443 */ // Label 35053: @2425443
     /* 2425443 */ GIM_Reject,
     /* 2425444 */ // Label 34993: @2425444
     /* 2425444 */ GIM_Try, /*On fail goto*//*Label 35058*/ GIMT_Encode4(2425560),
     /* 2425449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2425452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2425455 */   GIM_Try, /*On fail goto*//*Label 35059*/ GIMT_Encode4(2425507), // Rule ID 32840 //
     /* 2425460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425485 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2425488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425490 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425506 */     // GIR_Coverage, 32840,
     /* 2425506 */     GIR_EraseRootFromParent_Done,
     /* 2425507 */   // Label 35059: @2425507
     /* 2425507 */   GIM_Try, /*On fail goto*//*Label 35060*/ GIMT_Encode4(2425559), // Rule ID 32841 //
     /* 2425512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425537 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2425540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425542 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425558 */     // GIR_Coverage, 32841,
     /* 2425558 */     GIR_EraseRootFromParent_Done,
     /* 2425559 */   // Label 35060: @2425559
     /* 2425559 */   GIM_Reject,
     /* 2425560 */ // Label 35058: @2425560
     /* 2425560 */ GIM_Reject,
     /* 2425561 */ // Label 34994: @2425561
     /* 2425561 */ GIM_Try, /*On fail goto*//*Label 35061*/ GIMT_Encode4(2425781),
     /* 2425566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2425569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2425572 */   GIM_Try, /*On fail goto*//*Label 35062*/ GIMT_Encode4(2425624), // Rule ID 33470 //
     /* 2425577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425602 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425607 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425623 */     // GIR_Coverage, 33470,
     /* 2425623 */     GIR_EraseRootFromParent_Done,
     /* 2425624 */   // Label 35062: @2425624
     /* 2425624 */   GIM_Try, /*On fail goto*//*Label 35063*/ GIMT_Encode4(2425676), // Rule ID 33471 //
     /* 2425629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425654 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425659 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425675 */     // GIR_Coverage, 33471,
     /* 2425675 */     GIR_EraseRootFromParent_Done,
     /* 2425676 */   // Label 35063: @2425676
     /* 2425676 */   GIM_Try, /*On fail goto*//*Label 35064*/ GIMT_Encode4(2425728), // Rule ID 34820 //
     /* 2425681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425706 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425711 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425727 */     // GIR_Coverage, 34820,
     /* 2425727 */     GIR_EraseRootFromParent_Done,
     /* 2425728 */   // Label 35064: @2425728
     /* 2425728 */   GIM_Try, /*On fail goto*//*Label 35065*/ GIMT_Encode4(2425780), // Rule ID 34821 //
     /* 2425733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2425751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425758 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2425761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425763 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2425775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425779 */     // GIR_Coverage, 34821,
     /* 2425779 */     GIR_EraseRootFromParent_Done,
     /* 2425780 */   // Label 35065: @2425780
     /* 2425780 */   GIM_Reject,
     /* 2425781 */ // Label 35061: @2425781
     /* 2425781 */ GIM_Reject,
     /* 2425782 */ // Label 34995: @2425782
     /* 2425782 */ GIM_Try, /*On fail goto*//*Label 35066*/ GIMT_Encode4(2426002),
     /* 2425787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2425790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2425793 */   GIM_Try, /*On fail goto*//*Label 35067*/ GIMT_Encode4(2425845), // Rule ID 33830 //
     /* 2425798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425823 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425828 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425844 */     // GIR_Coverage, 33830,
     /* 2425844 */     GIR_EraseRootFromParent_Done,
     /* 2425845 */   // Label 35067: @2425845
     /* 2425845 */   GIM_Try, /*On fail goto*//*Label 35068*/ GIMT_Encode4(2425897), // Rule ID 33831 //
     /* 2425850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425875 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425880 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425896 */     // GIR_Coverage, 33831,
     /* 2425896 */     GIR_EraseRootFromParent_Done,
     /* 2425897 */   // Label 35068: @2425897
     /* 2425897 */   GIM_Try, /*On fail goto*//*Label 35069*/ GIMT_Encode4(2425949), // Rule ID 35180 //
     /* 2425902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425927 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2425927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425932 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425948 */     // GIR_Coverage, 35180,
     /* 2425948 */     GIR_EraseRootFromParent_Done,
     /* 2425949 */   // Label 35069: @2425949
     /* 2425949 */   GIM_Try, /*On fail goto*//*Label 35070*/ GIMT_Encode4(2426001), // Rule ID 35181 //
     /* 2425954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2425972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425979 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2425979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2425982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425984 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2425986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2425988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2425999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426000 */     // GIR_Coverage, 35181,
     /* 2426000 */     GIR_EraseRootFromParent_Done,
     /* 2426001 */   // Label 35070: @2426001
     /* 2426001 */   GIM_Reject,
     /* 2426002 */ // Label 35066: @2426002
     /* 2426002 */ GIM_Reject,
     /* 2426003 */ // Label 34996: @2426003
     /* 2426003 */ GIM_Try, /*On fail goto*//*Label 35071*/ GIMT_Encode4(2426223),
     /* 2426008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2426011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2426014 */   GIM_Try, /*On fail goto*//*Label 35072*/ GIMT_Encode4(2426066), // Rule ID 34190 //
     /* 2426019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2426022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426044 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426049 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426065 */     // GIR_Coverage, 34190,
     /* 2426065 */     GIR_EraseRootFromParent_Done,
     /* 2426066 */   // Label 35072: @2426066
     /* 2426066 */   GIM_Try, /*On fail goto*//*Label 35073*/ GIMT_Encode4(2426118), // Rule ID 34191 //
     /* 2426071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2426074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426096 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426101 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426117 */     // GIR_Coverage, 34191,
     /* 2426117 */     GIR_EraseRootFromParent_Done,
     /* 2426118 */   // Label 35073: @2426118
     /* 2426118 */   GIM_Try, /*On fail goto*//*Label 35074*/ GIMT_Encode4(2426170), // Rule ID 35540 //
     /* 2426123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2426126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426148 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426153 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426169 */     // GIR_Coverage, 35540,
     /* 2426169 */     GIR_EraseRootFromParent_Done,
     /* 2426170 */   // Label 35074: @2426170
     /* 2426170 */   GIM_Try, /*On fail goto*//*Label 35075*/ GIMT_Encode4(2426222), // Rule ID 35541 //
     /* 2426175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2426178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426200 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426205 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2426217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426221 */     // GIR_Coverage, 35541,
     /* 2426221 */     GIR_EraseRootFromParent_Done,
     /* 2426222 */   // Label 35075: @2426222
     /* 2426222 */   GIM_Reject,
     /* 2426223 */ // Label 35071: @2426223
     /* 2426223 */ GIM_Reject,
     /* 2426224 */ // Label 34997: @2426224
     /* 2426224 */ GIM_Try, /*On fail goto*//*Label 35076*/ GIMT_Encode4(2426340),
     /* 2426229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2426232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2426235 */   GIM_Try, /*On fail goto*//*Label 35077*/ GIMT_Encode4(2426287), // Rule ID 33200 //
     /* 2426240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426265 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426270 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426286 */     // GIR_Coverage, 33200,
     /* 2426286 */     GIR_EraseRootFromParent_Done,
     /* 2426287 */   // Label 35077: @2426287
     /* 2426287 */   GIM_Try, /*On fail goto*//*Label 35078*/ GIMT_Encode4(2426339), // Rule ID 33201 //
     /* 2426292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2426310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426317 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2426320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426322 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426338 */     // GIR_Coverage, 33201,
     /* 2426338 */     GIR_EraseRootFromParent_Done,
     /* 2426339 */   // Label 35078: @2426339
     /* 2426339 */   GIM_Reject,
     /* 2426340 */ // Label 35076: @2426340
     /* 2426340 */ GIM_Reject,
     /* 2426341 */ // Label 34998: @2426341
     /* 2426341 */ GIM_Try, /*On fail goto*//*Label 35079*/ GIMT_Encode4(2426561),
     /* 2426346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2426349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2426352 */   GIM_Try, /*On fail goto*//*Label 35080*/ GIMT_Encode4(2426404), // Rule ID 33560 //
     /* 2426357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426382 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426387 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426403 */     // GIR_Coverage, 33560,
     /* 2426403 */     GIR_EraseRootFromParent_Done,
     /* 2426404 */   // Label 35080: @2426404
     /* 2426404 */   GIM_Try, /*On fail goto*//*Label 35081*/ GIMT_Encode4(2426456), // Rule ID 33561 //
     /* 2426409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426434 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426439 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426455 */     // GIR_Coverage, 33561,
     /* 2426455 */     GIR_EraseRootFromParent_Done,
     /* 2426456 */   // Label 35081: @2426456
     /* 2426456 */   GIM_Try, /*On fail goto*//*Label 35082*/ GIMT_Encode4(2426508), // Rule ID 34910 //
     /* 2426461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426486 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426491 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426507 */     // GIR_Coverage, 34910,
     /* 2426507 */     GIR_EraseRootFromParent_Done,
     /* 2426508 */   // Label 35082: @2426508
     /* 2426508 */   GIM_Try, /*On fail goto*//*Label 35083*/ GIMT_Encode4(2426560), // Rule ID 34911 //
     /* 2426513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426538 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426543 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426559 */     // GIR_Coverage, 34911,
     /* 2426559 */     GIR_EraseRootFromParent_Done,
     /* 2426560 */   // Label 35083: @2426560
     /* 2426560 */   GIM_Reject,
     /* 2426561 */ // Label 35079: @2426561
     /* 2426561 */ GIM_Reject,
     /* 2426562 */ // Label 34999: @2426562
     /* 2426562 */ GIM_Try, /*On fail goto*//*Label 35084*/ GIMT_Encode4(2426782),
     /* 2426567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2426570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2426573 */   GIM_Try, /*On fail goto*//*Label 35085*/ GIMT_Encode4(2426625), // Rule ID 33920 //
     /* 2426578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426603 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426608 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426624 */     // GIR_Coverage, 33920,
     /* 2426624 */     GIR_EraseRootFromParent_Done,
     /* 2426625 */   // Label 35085: @2426625
     /* 2426625 */   GIM_Try, /*On fail goto*//*Label 35086*/ GIMT_Encode4(2426677), // Rule ID 33921 //
     /* 2426630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426655 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426660 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426676 */     // GIR_Coverage, 33921,
     /* 2426676 */     GIR_EraseRootFromParent_Done,
     /* 2426677 */   // Label 35086: @2426677
     /* 2426677 */   GIM_Try, /*On fail goto*//*Label 35087*/ GIMT_Encode4(2426729), // Rule ID 35270 //
     /* 2426682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426707 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426712 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426728 */     // GIR_Coverage, 35270,
     /* 2426728 */     GIR_EraseRootFromParent_Done,
     /* 2426729 */   // Label 35087: @2426729
     /* 2426729 */   GIM_Try, /*On fail goto*//*Label 35088*/ GIMT_Encode4(2426781), // Rule ID 35271 //
     /* 2426734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426759 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426764 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426780 */     // GIR_Coverage, 35271,
     /* 2426780 */     GIR_EraseRootFromParent_Done,
     /* 2426781 */   // Label 35088: @2426781
     /* 2426781 */   GIM_Reject,
     /* 2426782 */ // Label 35084: @2426782
     /* 2426782 */ GIM_Reject,
     /* 2426783 */ // Label 35000: @2426783
     /* 2426783 */ GIM_Try, /*On fail goto*//*Label 35089*/ GIMT_Encode4(2426899),
     /* 2426788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2426791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2426794 */   GIM_Try, /*On fail goto*//*Label 35090*/ GIMT_Encode4(2426846), // Rule ID 33290 //
     /* 2426799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426824 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426829 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426845 */     // GIR_Coverage, 33290,
     /* 2426845 */     GIR_EraseRootFromParent_Done,
     /* 2426846 */   // Label 35090: @2426846
     /* 2426846 */   GIM_Try, /*On fail goto*//*Label 35091*/ GIMT_Encode4(2426898), // Rule ID 33291 //
     /* 2426851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2426869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426876 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2426879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426881 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426897 */     // GIR_Coverage, 33291,
     /* 2426897 */     GIR_EraseRootFromParent_Done,
     /* 2426898 */   // Label 35091: @2426898
     /* 2426898 */   GIM_Reject,
     /* 2426899 */ // Label 35089: @2426899
     /* 2426899 */ GIM_Reject,
     /* 2426900 */ // Label 35001: @2426900
     /* 2426900 */ GIM_Try, /*On fail goto*//*Label 35092*/ GIMT_Encode4(2427120),
     /* 2426905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2426908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2426911 */   GIM_Try, /*On fail goto*//*Label 35093*/ GIMT_Encode4(2426963), // Rule ID 33650 //
     /* 2426916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426941 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2426941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426946 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2426948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2426950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2426961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426962 */     // GIR_Coverage, 33650,
     /* 2426962 */     GIR_EraseRootFromParent_Done,
     /* 2426963 */   // Label 35093: @2426963
     /* 2426963 */   GIM_Try, /*On fail goto*//*Label 35094*/ GIMT_Encode4(2427015), // Rule ID 33651 //
     /* 2426968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2426986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426993 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2426993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2426996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426998 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427014 */     // GIR_Coverage, 33651,
     /* 2427014 */     GIR_EraseRootFromParent_Done,
     /* 2427015 */   // Label 35094: @2427015
     /* 2427015 */   GIM_Try, /*On fail goto*//*Label 35095*/ GIMT_Encode4(2427067), // Rule ID 35000 //
     /* 2427020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427045 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427050 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427066 */     // GIR_Coverage, 35000,
     /* 2427066 */     GIR_EraseRootFromParent_Done,
     /* 2427067 */   // Label 35095: @2427067
     /* 2427067 */   GIM_Try, /*On fail goto*//*Label 35096*/ GIMT_Encode4(2427119), // Rule ID 35001 //
     /* 2427072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427097 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427102 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427118 */     // GIR_Coverage, 35001,
     /* 2427118 */     GIR_EraseRootFromParent_Done,
     /* 2427119 */   // Label 35096: @2427119
     /* 2427119 */   GIM_Reject,
     /* 2427120 */ // Label 35092: @2427120
     /* 2427120 */ GIM_Reject,
     /* 2427121 */ // Label 35002: @2427121
     /* 2427121 */ GIM_Try, /*On fail goto*//*Label 35097*/ GIMT_Encode4(2427237),
     /* 2427126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2427129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2427132 */   GIM_Try, /*On fail goto*//*Label 35098*/ GIMT_Encode4(2427184), // Rule ID 33380 //
     /* 2427137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427162 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2427162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427167 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427183 */     // GIR_Coverage, 33380,
     /* 2427183 */     GIR_EraseRootFromParent_Done,
     /* 2427184 */   // Label 35098: @2427184
     /* 2427184 */   GIM_Try, /*On fail goto*//*Label 35099*/ GIMT_Encode4(2427236), // Rule ID 33381 //
     /* 2427189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2427207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427214 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2427214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2427217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427219 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2427221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2427223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2427234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427235 */     // GIR_Coverage, 33381,
     /* 2427235 */     GIR_EraseRootFromParent_Done,
     /* 2427236 */   // Label 35099: @2427236
     /* 2427236 */   GIM_Reject,
     /* 2427237 */ // Label 35097: @2427237
     /* 2427237 */ GIM_Reject,
     /* 2427238 */ // Label 35003: @2427238
     /* 2427238 */ GIM_Reject,
     /* 2427239 */ // Label 123: @2427239
     /* 2427239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35122*/ GIMT_Encode4(2439118),
     /* 2427250 */ /*GILLT_nxv1s8*//*Label 35100*/ GIMT_Encode4(2427362),
     /* 2427254 */ /*GILLT_nxv1s16*//*Label 35101*/ GIMT_Encode4(2427685),
     /* 2427258 */ /*GILLT_nxv1s32*//*Label 35102*/ GIMT_Encode4(2428318),
     /* 2427262 */ /*GILLT_nxv1s64*//*Label 35103*/ GIMT_Encode4(2428951), GIMT_Encode4(0),
     /* 2427270 */ /*GILLT_nxv2s8*//*Label 35104*/ GIMT_Encode4(2429584),
     /* 2427274 */ /*GILLT_nxv2s16*//*Label 35105*/ GIMT_Encode4(2429907),
     /* 2427278 */ /*GILLT_nxv2s32*//*Label 35106*/ GIMT_Encode4(2430540),
     /* 2427282 */ /*GILLT_nxv2s64*//*Label 35107*/ GIMT_Encode4(2431173), GIMT_Encode4(0),
     /* 2427290 */ /*GILLT_nxv4s8*//*Label 35108*/ GIMT_Encode4(2431806),
     /* 2427294 */ /*GILLT_nxv4s16*//*Label 35109*/ GIMT_Encode4(2432129),
     /* 2427298 */ /*GILLT_nxv4s32*//*Label 35110*/ GIMT_Encode4(2432762),
     /* 2427302 */ /*GILLT_nxv4s64*//*Label 35111*/ GIMT_Encode4(2433395), GIMT_Encode4(0),
     /* 2427310 */ /*GILLT_nxv8s8*//*Label 35112*/ GIMT_Encode4(2434028),
     /* 2427314 */ /*GILLT_nxv8s16*//*Label 35113*/ GIMT_Encode4(2434351),
     /* 2427318 */ /*GILLT_nxv8s32*//*Label 35114*/ GIMT_Encode4(2434984),
     /* 2427322 */ /*GILLT_nxv8s64*//*Label 35115*/ GIMT_Encode4(2435617), GIMT_Encode4(0),
     /* 2427330 */ /*GILLT_nxv16s8*//*Label 35116*/ GIMT_Encode4(2436250),
     /* 2427334 */ /*GILLT_nxv16s16*//*Label 35117*/ GIMT_Encode4(2436573),
     /* 2427338 */ /*GILLT_nxv16s32*//*Label 35118*/ GIMT_Encode4(2437206), GIMT_Encode4(0),
     /* 2427346 */ /*GILLT_nxv32s8*//*Label 35119*/ GIMT_Encode4(2437839),
     /* 2427350 */ /*GILLT_nxv32s16*//*Label 35120*/ GIMT_Encode4(2438162), GIMT_Encode4(0),
     /* 2427358 */ /*GILLT_nxv64s8*//*Label 35121*/ GIMT_Encode4(2438795),
     /* 2427362 */ // Label 35100: @2427362
     /* 2427362 */ GIM_Try, /*On fail goto*//*Label 35123*/ GIMT_Encode4(2427684),
     /* 2427367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2427370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2427373 */   GIM_Try, /*On fail goto*//*Label 35124*/ GIMT_Encode4(2427456), // Rule ID 45444 //
     /* 2427378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427414 */     // MIs[1] Operand 1
     /* 2427414 */     // No operand predicates
     /* 2427414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427418 */     // MIs[0] policy
     /* 2427418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427430 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2427433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427455 */     // GIR_Coverage, 45444,
     /* 2427455 */     GIR_EraseRootFromParent_Done,
     /* 2427456 */   // Label 35124: @2427456
     /* 2427456 */   GIM_Try, /*On fail goto*//*Label 35125*/ GIMT_Encode4(2427539), // Rule ID 45445 //
     /* 2427461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427497 */     // MIs[1] Operand 1
     /* 2427497 */     // No operand predicates
     /* 2427497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427501 */     // MIs[0] policy
     /* 2427501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427513 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2427516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427538 */     // GIR_Coverage, 45445,
     /* 2427538 */     GIR_EraseRootFromParent_Done,
     /* 2427539 */   // Label 35125: @2427539
     /* 2427539 */   GIM_Try, /*On fail goto*//*Label 35126*/ GIMT_Encode4(2427611), // Rule ID 45446 //
     /* 2427544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427576 */     // MIs[0] policy
     /* 2427576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427586 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2427589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427610 */     // GIR_Coverage, 45446,
     /* 2427610 */     GIR_EraseRootFromParent_Done,
     /* 2427611 */   // Label 35126: @2427611
     /* 2427611 */   GIM_Try, /*On fail goto*//*Label 35127*/ GIMT_Encode4(2427683), // Rule ID 45447 //
     /* 2427616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427648 */     // MIs[0] policy
     /* 2427648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427658 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2427661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2427679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427682 */     // GIR_Coverage, 45447,
     /* 2427682 */     GIR_EraseRootFromParent_Done,
     /* 2427683 */   // Label 35127: @2427683
     /* 2427683 */   GIM_Reject,
     /* 2427684 */ // Label 35123: @2427684
     /* 2427684 */ GIM_Reject,
     /* 2427685 */ // Label 35101: @2427685
     /* 2427685 */ GIM_Try, /*On fail goto*//*Label 35128*/ GIMT_Encode4(2428317),
     /* 2427690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2427693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2427696 */   GIM_Try, /*On fail goto*//*Label 35129*/ GIMT_Encode4(2427779), // Rule ID 45456 //
     /* 2427701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427737 */     // MIs[1] Operand 1
     /* 2427737 */     // No operand predicates
     /* 2427737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427741 */     // MIs[0] policy
     /* 2427741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427753 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2427756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427778 */     // GIR_Coverage, 45456,
     /* 2427778 */     GIR_EraseRootFromParent_Done,
     /* 2427779 */   // Label 35129: @2427779
     /* 2427779 */   GIM_Try, /*On fail goto*//*Label 35130*/ GIMT_Encode4(2427862), // Rule ID 45457 //
     /* 2427784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427820 */     // MIs[1] Operand 1
     /* 2427820 */     // No operand predicates
     /* 2427820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427824 */     // MIs[0] policy
     /* 2427824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427836 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2427839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427861 */     // GIR_Coverage, 45457,
     /* 2427861 */     GIR_EraseRootFromParent_Done,
     /* 2427862 */   // Label 35130: @2427862
     /* 2427862 */   GIM_Try, /*On fail goto*//*Label 35131*/ GIMT_Encode4(2427945), // Rule ID 45532 //
     /* 2427867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427903 */     // MIs[1] Operand 1
     /* 2427903 */     // No operand predicates
     /* 2427903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427907 */     // MIs[0] policy
     /* 2427907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427919 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2427922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2427941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427944 */     // GIR_Coverage, 45532,
     /* 2427944 */     GIR_EraseRootFromParent_Done,
     /* 2427945 */   // Label 35131: @2427945
     /* 2427945 */   GIM_Try, /*On fail goto*//*Label 35132*/ GIMT_Encode4(2428028), // Rule ID 45533 //
     /* 2427950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2427959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427986 */     // MIs[1] Operand 1
     /* 2427986 */     // No operand predicates
     /* 2427986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427990 */     // MIs[0] policy
     /* 2427990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428002 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2428005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428027 */     // GIR_Coverage, 45533,
     /* 2428027 */     GIR_EraseRootFromParent_Done,
     /* 2428028 */   // Label 35132: @2428028
     /* 2428028 */   GIM_Try, /*On fail goto*//*Label 35133*/ GIMT_Encode4(2428100), // Rule ID 45458 //
     /* 2428033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428065 */     // MIs[0] policy
     /* 2428065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428075 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2428078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428099 */     // GIR_Coverage, 45458,
     /* 2428099 */     GIR_EraseRootFromParent_Done,
     /* 2428100 */   // Label 35133: @2428100
     /* 2428100 */   GIM_Try, /*On fail goto*//*Label 35134*/ GIMT_Encode4(2428172), // Rule ID 45459 //
     /* 2428105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428137 */     // MIs[0] policy
     /* 2428137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428147 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2428150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428171 */     // GIR_Coverage, 45459,
     /* 2428171 */     GIR_EraseRootFromParent_Done,
     /* 2428172 */   // Label 35134: @2428172
     /* 2428172 */   GIM_Try, /*On fail goto*//*Label 35135*/ GIMT_Encode4(2428244), // Rule ID 45534 //
     /* 2428177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428209 */     // MIs[0] policy
     /* 2428209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428219 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2428222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428243 */     // GIR_Coverage, 45534,
     /* 2428243 */     GIR_EraseRootFromParent_Done,
     /* 2428244 */   // Label 35135: @2428244
     /* 2428244 */   GIM_Try, /*On fail goto*//*Label 35136*/ GIMT_Encode4(2428316), // Rule ID 45535 //
     /* 2428249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428281 */     // MIs[0] policy
     /* 2428281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428291 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2428294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428302 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428315 */     // GIR_Coverage, 45535,
     /* 2428315 */     GIR_EraseRootFromParent_Done,
     /* 2428316 */   // Label 35136: @2428316
     /* 2428316 */   GIM_Reject,
     /* 2428317 */ // Label 35128: @2428317
     /* 2428317 */ GIM_Reject,
     /* 2428318 */ // Label 35102: @2428318
     /* 2428318 */ GIM_Try, /*On fail goto*//*Label 35137*/ GIMT_Encode4(2428950),
     /* 2428323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2428326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2428329 */   GIM_Try, /*On fail goto*//*Label 35138*/ GIMT_Encode4(2428412), // Rule ID 45464 //
     /* 2428334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428370 */     // MIs[1] Operand 1
     /* 2428370 */     // No operand predicates
     /* 2428370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428374 */     // MIs[0] policy
     /* 2428374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428386 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2428389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428411 */     // GIR_Coverage, 45464,
     /* 2428411 */     GIR_EraseRootFromParent_Done,
     /* 2428412 */   // Label 35138: @2428412
     /* 2428412 */   GIM_Try, /*On fail goto*//*Label 35139*/ GIMT_Encode4(2428495), // Rule ID 45465 //
     /* 2428417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428453 */     // MIs[1] Operand 1
     /* 2428453 */     // No operand predicates
     /* 2428453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428457 */     // MIs[0] policy
     /* 2428457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428469 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2428472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428494 */     // GIR_Coverage, 45465,
     /* 2428494 */     GIR_EraseRootFromParent_Done,
     /* 2428495 */   // Label 35139: @2428495
     /* 2428495 */   GIM_Try, /*On fail goto*//*Label 35140*/ GIMT_Encode4(2428578), // Rule ID 45540 //
     /* 2428500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428536 */     // MIs[1] Operand 1
     /* 2428536 */     // No operand predicates
     /* 2428536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428540 */     // MIs[0] policy
     /* 2428540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428552 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2428555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428577 */     // GIR_Coverage, 45540,
     /* 2428577 */     GIR_EraseRootFromParent_Done,
     /* 2428578 */   // Label 35140: @2428578
     /* 2428578 */   GIM_Try, /*On fail goto*//*Label 35141*/ GIMT_Encode4(2428661), // Rule ID 45541 //
     /* 2428583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428619 */     // MIs[1] Operand 1
     /* 2428619 */     // No operand predicates
     /* 2428619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428623 */     // MIs[0] policy
     /* 2428623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428635 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2428638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428660 */     // GIR_Coverage, 45541,
     /* 2428660 */     GIR_EraseRootFromParent_Done,
     /* 2428661 */   // Label 35141: @2428661
     /* 2428661 */   GIM_Try, /*On fail goto*//*Label 35142*/ GIMT_Encode4(2428733), // Rule ID 45466 //
     /* 2428666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428698 */     // MIs[0] policy
     /* 2428698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428708 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2428711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428732 */     // GIR_Coverage, 45466,
     /* 2428732 */     GIR_EraseRootFromParent_Done,
     /* 2428733 */   // Label 35142: @2428733
     /* 2428733 */   GIM_Try, /*On fail goto*//*Label 35143*/ GIMT_Encode4(2428805), // Rule ID 45467 //
     /* 2428738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428770 */     // MIs[0] policy
     /* 2428770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428780 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2428783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428804 */     // GIR_Coverage, 45467,
     /* 2428804 */     GIR_EraseRootFromParent_Done,
     /* 2428805 */   // Label 35143: @2428805
     /* 2428805 */   GIM_Try, /*On fail goto*//*Label 35144*/ GIMT_Encode4(2428877), // Rule ID 45542 //
     /* 2428810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428842 */     // MIs[0] policy
     /* 2428842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428852 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2428855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428876 */     // GIR_Coverage, 45542,
     /* 2428876 */     GIR_EraseRootFromParent_Done,
     /* 2428877 */   // Label 35144: @2428877
     /* 2428877 */   GIM_Try, /*On fail goto*//*Label 35145*/ GIMT_Encode4(2428949), // Rule ID 45543 //
     /* 2428882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428914 */     // MIs[0] policy
     /* 2428914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428924 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2428927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2428945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428948 */     // GIR_Coverage, 45543,
     /* 2428948 */     GIR_EraseRootFromParent_Done,
     /* 2428949 */   // Label 35145: @2428949
     /* 2428949 */   GIM_Reject,
     /* 2428950 */ // Label 35137: @2428950
     /* 2428950 */ GIM_Reject,
     /* 2428951 */ // Label 35103: @2428951
     /* 2428951 */ GIM_Try, /*On fail goto*//*Label 35146*/ GIMT_Encode4(2429583),
     /* 2428956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2428959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2428962 */   GIM_Try, /*On fail goto*//*Label 35147*/ GIMT_Encode4(2429045), // Rule ID 45480 //
     /* 2428967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2428970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2428976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429003 */     // MIs[1] Operand 1
     /* 2429003 */     // No operand predicates
     /* 2429003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429007 */     // MIs[0] policy
     /* 2429007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429019 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2429022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429028 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429044 */     // GIR_Coverage, 45480,
     /* 2429044 */     GIR_EraseRootFromParent_Done,
     /* 2429045 */   // Label 35147: @2429045
     /* 2429045 */   GIM_Try, /*On fail goto*//*Label 35148*/ GIMT_Encode4(2429128), // Rule ID 45481 //
     /* 2429050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429082 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429086 */     // MIs[1] Operand 1
     /* 2429086 */     // No operand predicates
     /* 2429086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429090 */     // MIs[0] policy
     /* 2429090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429102 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2429105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429114 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429127 */     // GIR_Coverage, 45481,
     /* 2429127 */     GIR_EraseRootFromParent_Done,
     /* 2429128 */   // Label 35148: @2429128
     /* 2429128 */   GIM_Try, /*On fail goto*//*Label 35149*/ GIMT_Encode4(2429211), // Rule ID 45552 //
     /* 2429133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429169 */     // MIs[1] Operand 1
     /* 2429169 */     // No operand predicates
     /* 2429169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429173 */     // MIs[0] policy
     /* 2429173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429185 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2429188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429210 */     // GIR_Coverage, 45552,
     /* 2429210 */     GIR_EraseRootFromParent_Done,
     /* 2429211 */   // Label 35149: @2429211
     /* 2429211 */   GIM_Try, /*On fail goto*//*Label 35150*/ GIMT_Encode4(2429294), // Rule ID 45553 //
     /* 2429216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429252 */     // MIs[1] Operand 1
     /* 2429252 */     // No operand predicates
     /* 2429252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429256 */     // MIs[0] policy
     /* 2429256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429268 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2429271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429280 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429293 */     // GIR_Coverage, 45553,
     /* 2429293 */     GIR_EraseRootFromParent_Done,
     /* 2429294 */   // Label 35150: @2429294
     /* 2429294 */   GIM_Try, /*On fail goto*//*Label 35151*/ GIMT_Encode4(2429366), // Rule ID 45482 //
     /* 2429299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429331 */     // MIs[0] policy
     /* 2429331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429341 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2429344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429365 */     // GIR_Coverage, 45482,
     /* 2429365 */     GIR_EraseRootFromParent_Done,
     /* 2429366 */   // Label 35151: @2429366
     /* 2429366 */   GIM_Try, /*On fail goto*//*Label 35152*/ GIMT_Encode4(2429438), // Rule ID 45483 //
     /* 2429371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429403 */     // MIs[0] policy
     /* 2429403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429413 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2429416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429424 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429437 */     // GIR_Coverage, 45483,
     /* 2429437 */     GIR_EraseRootFromParent_Done,
     /* 2429438 */   // Label 35152: @2429438
     /* 2429438 */   GIM_Try, /*On fail goto*//*Label 35153*/ GIMT_Encode4(2429510), // Rule ID 45554 //
     /* 2429443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429475 */     // MIs[0] policy
     /* 2429475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429485 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2429488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429496 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429509 */     // GIR_Coverage, 45554,
     /* 2429509 */     GIR_EraseRootFromParent_Done,
     /* 2429510 */   // Label 35153: @2429510
     /* 2429510 */   GIM_Try, /*On fail goto*//*Label 35154*/ GIMT_Encode4(2429582), // Rule ID 45555 //
     /* 2429515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2429524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429547 */     // MIs[0] policy
     /* 2429547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429557 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2429560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429568 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429581 */     // GIR_Coverage, 45555,
     /* 2429581 */     GIR_EraseRootFromParent_Done,
     /* 2429582 */   // Label 35154: @2429582
     /* 2429582 */   GIM_Reject,
     /* 2429583 */ // Label 35146: @2429583
     /* 2429583 */ GIM_Reject,
     /* 2429584 */ // Label 35104: @2429584
     /* 2429584 */ GIM_Try, /*On fail goto*//*Label 35155*/ GIMT_Encode4(2429906),
     /* 2429589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2429592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2429595 */   GIM_Try, /*On fail goto*//*Label 35156*/ GIMT_Encode4(2429678), // Rule ID 45448 //
     /* 2429600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2429609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429636 */     // MIs[1] Operand 1
     /* 2429636 */     // No operand predicates
     /* 2429636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429640 */     // MIs[0] policy
     /* 2429640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429652 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2429655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429664 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429677 */     // GIR_Coverage, 45448,
     /* 2429677 */     GIR_EraseRootFromParent_Done,
     /* 2429678 */   // Label 35156: @2429678
     /* 2429678 */   GIM_Try, /*On fail goto*//*Label 35157*/ GIMT_Encode4(2429761), // Rule ID 45449 //
     /* 2429683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2429692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429719 */     // MIs[1] Operand 1
     /* 2429719 */     // No operand predicates
     /* 2429719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429723 */     // MIs[0] policy
     /* 2429723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429735 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2429738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429760 */     // GIR_Coverage, 45449,
     /* 2429760 */     GIR_EraseRootFromParent_Done,
     /* 2429761 */   // Label 35157: @2429761
     /* 2429761 */   GIM_Try, /*On fail goto*//*Label 35158*/ GIMT_Encode4(2429833), // Rule ID 45450 //
     /* 2429766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2429775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429798 */     // MIs[0] policy
     /* 2429798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429808 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2429811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429832 */     // GIR_Coverage, 45450,
     /* 2429832 */     GIR_EraseRootFromParent_Done,
     /* 2429833 */   // Label 35158: @2429833
     /* 2429833 */   GIM_Try, /*On fail goto*//*Label 35159*/ GIMT_Encode4(2429905), // Rule ID 45451 //
     /* 2429838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2429847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429870 */     // MIs[0] policy
     /* 2429870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429880 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2429883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2429901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429904 */     // GIR_Coverage, 45451,
     /* 2429904 */     GIR_EraseRootFromParent_Done,
     /* 2429905 */   // Label 35159: @2429905
     /* 2429905 */   GIM_Reject,
     /* 2429906 */ // Label 35155: @2429906
     /* 2429906 */ GIM_Reject,
     /* 2429907 */ // Label 35105: @2429907
     /* 2429907 */ GIM_Try, /*On fail goto*//*Label 35160*/ GIMT_Encode4(2430539),
     /* 2429912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2429915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2429918 */   GIM_Try, /*On fail goto*//*Label 35161*/ GIMT_Encode4(2430001), // Rule ID 45460 //
     /* 2429923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2429932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429959 */     // MIs[1] Operand 1
     /* 2429959 */     // No operand predicates
     /* 2429959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429963 */     // MIs[0] policy
     /* 2429963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429975 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2429978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430000 */     // GIR_Coverage, 45460,
     /* 2430000 */     GIR_EraseRootFromParent_Done,
     /* 2430001 */   // Label 35161: @2430001
     /* 2430001 */   GIM_Try, /*On fail goto*//*Label 35162*/ GIMT_Encode4(2430084), // Rule ID 45461 //
     /* 2430006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430042 */     // MIs[1] Operand 1
     /* 2430042 */     // No operand predicates
     /* 2430042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430046 */     // MIs[0] policy
     /* 2430046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430058 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430083 */     // GIR_Coverage, 45461,
     /* 2430083 */     GIR_EraseRootFromParent_Done,
     /* 2430084 */   // Label 35162: @2430084
     /* 2430084 */   GIM_Try, /*On fail goto*//*Label 35163*/ GIMT_Encode4(2430167), // Rule ID 45536 //
     /* 2430089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430125 */     // MIs[1] Operand 1
     /* 2430125 */     // No operand predicates
     /* 2430125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430129 */     // MIs[0] policy
     /* 2430129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430141 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430166 */     // GIR_Coverage, 45536,
     /* 2430166 */     GIR_EraseRootFromParent_Done,
     /* 2430167 */   // Label 35163: @2430167
     /* 2430167 */   GIM_Try, /*On fail goto*//*Label 35164*/ GIMT_Encode4(2430250), // Rule ID 45537 //
     /* 2430172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430208 */     // MIs[1] Operand 1
     /* 2430208 */     // No operand predicates
     /* 2430208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430212 */     // MIs[0] policy
     /* 2430212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430224 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2430227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430249 */     // GIR_Coverage, 45537,
     /* 2430249 */     GIR_EraseRootFromParent_Done,
     /* 2430250 */   // Label 35164: @2430250
     /* 2430250 */   GIM_Try, /*On fail goto*//*Label 35165*/ GIMT_Encode4(2430322), // Rule ID 45462 //
     /* 2430255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430287 */     // MIs[0] policy
     /* 2430287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430297 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2430300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430321 */     // GIR_Coverage, 45462,
     /* 2430321 */     GIR_EraseRootFromParent_Done,
     /* 2430322 */   // Label 35165: @2430322
     /* 2430322 */   GIM_Try, /*On fail goto*//*Label 35166*/ GIMT_Encode4(2430394), // Rule ID 45463 //
     /* 2430327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430359 */     // MIs[0] policy
     /* 2430359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430369 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2430372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430393 */     // GIR_Coverage, 45463,
     /* 2430393 */     GIR_EraseRootFromParent_Done,
     /* 2430394 */   // Label 35166: @2430394
     /* 2430394 */   GIM_Try, /*On fail goto*//*Label 35167*/ GIMT_Encode4(2430466), // Rule ID 45538 //
     /* 2430399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430431 */     // MIs[0] policy
     /* 2430431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430441 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2430444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430465 */     // GIR_Coverage, 45538,
     /* 2430465 */     GIR_EraseRootFromParent_Done,
     /* 2430466 */   // Label 35167: @2430466
     /* 2430466 */   GIM_Try, /*On fail goto*//*Label 35168*/ GIMT_Encode4(2430538), // Rule ID 45539 //
     /* 2430471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430503 */     // MIs[0] policy
     /* 2430503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430513 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2430516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430524 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430537 */     // GIR_Coverage, 45539,
     /* 2430537 */     GIR_EraseRootFromParent_Done,
     /* 2430538 */   // Label 35168: @2430538
     /* 2430538 */   GIM_Reject,
     /* 2430539 */ // Label 35160: @2430539
     /* 2430539 */ GIM_Reject,
     /* 2430540 */ // Label 35106: @2430540
     /* 2430540 */ GIM_Try, /*On fail goto*//*Label 35169*/ GIMT_Encode4(2431172),
     /* 2430545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2430548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2430551 */   GIM_Try, /*On fail goto*//*Label 35170*/ GIMT_Encode4(2430634), // Rule ID 45476 //
     /* 2430556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430592 */     // MIs[1] Operand 1
     /* 2430592 */     // No operand predicates
     /* 2430592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430596 */     // MIs[0] policy
     /* 2430596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430608 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2430611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430633 */     // GIR_Coverage, 45476,
     /* 2430633 */     GIR_EraseRootFromParent_Done,
     /* 2430634 */   // Label 35170: @2430634
     /* 2430634 */   GIM_Try, /*On fail goto*//*Label 35171*/ GIMT_Encode4(2430717), // Rule ID 45477 //
     /* 2430639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430675 */     // MIs[1] Operand 1
     /* 2430675 */     // No operand predicates
     /* 2430675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430679 */     // MIs[0] policy
     /* 2430679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430691 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2430694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430716 */     // GIR_Coverage, 45477,
     /* 2430716 */     GIR_EraseRootFromParent_Done,
     /* 2430717 */   // Label 35171: @2430717
     /* 2430717 */   GIM_Try, /*On fail goto*//*Label 35172*/ GIMT_Encode4(2430800), // Rule ID 45548 //
     /* 2430722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430758 */     // MIs[1] Operand 1
     /* 2430758 */     // No operand predicates
     /* 2430758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430762 */     // MIs[0] policy
     /* 2430762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430774 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2430777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430783 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430799 */     // GIR_Coverage, 45548,
     /* 2430799 */     GIR_EraseRootFromParent_Done,
     /* 2430800 */   // Label 35172: @2430800
     /* 2430800 */   GIM_Try, /*On fail goto*//*Label 35173*/ GIMT_Encode4(2430883), // Rule ID 45549 //
     /* 2430805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430841 */     // MIs[1] Operand 1
     /* 2430841 */     // No operand predicates
     /* 2430841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430845 */     // MIs[0] policy
     /* 2430845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430857 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2430860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430882 */     // GIR_Coverage, 45549,
     /* 2430882 */     GIR_EraseRootFromParent_Done,
     /* 2430883 */   // Label 35173: @2430883
     /* 2430883 */   GIM_Try, /*On fail goto*//*Label 35174*/ GIMT_Encode4(2430955), // Rule ID 45478 //
     /* 2430888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430920 */     // MIs[0] policy
     /* 2430920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430930 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2430933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2430951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430954 */     // GIR_Coverage, 45478,
     /* 2430954 */     GIR_EraseRootFromParent_Done,
     /* 2430955 */   // Label 35174: @2430955
     /* 2430955 */   GIM_Try, /*On fail goto*//*Label 35175*/ GIMT_Encode4(2431027), // Rule ID 45479 //
     /* 2430960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2430969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430992 */     // MIs[0] policy
     /* 2430992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431002 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431026 */     // GIR_Coverage, 45479,
     /* 2431026 */     GIR_EraseRootFromParent_Done,
     /* 2431027 */   // Label 35175: @2431027
     /* 2431027 */   GIM_Try, /*On fail goto*//*Label 35176*/ GIMT_Encode4(2431099), // Rule ID 45550 //
     /* 2431032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431064 */     // MIs[0] policy
     /* 2431064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431074 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431098 */     // GIR_Coverage, 45550,
     /* 2431098 */     GIR_EraseRootFromParent_Done,
     /* 2431099 */   // Label 35176: @2431099
     /* 2431099 */   GIM_Try, /*On fail goto*//*Label 35177*/ GIMT_Encode4(2431171), // Rule ID 45551 //
     /* 2431104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431136 */     // MIs[0] policy
     /* 2431136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431146 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2431149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431170 */     // GIR_Coverage, 45551,
     /* 2431170 */     GIR_EraseRootFromParent_Done,
     /* 2431171 */   // Label 35177: @2431171
     /* 2431171 */   GIM_Reject,
     /* 2431172 */ // Label 35169: @2431172
     /* 2431172 */ GIM_Reject,
     /* 2431173 */ // Label 35107: @2431173
     /* 2431173 */ GIM_Try, /*On fail goto*//*Label 35178*/ GIMT_Encode4(2431805),
     /* 2431178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2431181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2431184 */   GIM_Try, /*On fail goto*//*Label 35179*/ GIMT_Encode4(2431267), // Rule ID 45520 //
     /* 2431189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431225 */     // MIs[1] Operand 1
     /* 2431225 */     // No operand predicates
     /* 2431225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431229 */     // MIs[0] policy
     /* 2431229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431241 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2431244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431266 */     // GIR_Coverage, 45520,
     /* 2431266 */     GIR_EraseRootFromParent_Done,
     /* 2431267 */   // Label 35179: @2431267
     /* 2431267 */   GIM_Try, /*On fail goto*//*Label 35180*/ GIMT_Encode4(2431350), // Rule ID 45521 //
     /* 2431272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431308 */     // MIs[1] Operand 1
     /* 2431308 */     // No operand predicates
     /* 2431308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431312 */     // MIs[0] policy
     /* 2431312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431324 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2431327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431349 */     // GIR_Coverage, 45521,
     /* 2431349 */     GIR_EraseRootFromParent_Done,
     /* 2431350 */   // Label 35180: @2431350
     /* 2431350 */   GIM_Try, /*On fail goto*//*Label 35181*/ GIMT_Encode4(2431433), // Rule ID 45580 //
     /* 2431355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431391 */     // MIs[1] Operand 1
     /* 2431391 */     // No operand predicates
     /* 2431391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431395 */     // MIs[0] policy
     /* 2431395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431407 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2431410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431432 */     // GIR_Coverage, 45580,
     /* 2431432 */     GIR_EraseRootFromParent_Done,
     /* 2431433 */   // Label 35181: @2431433
     /* 2431433 */   GIM_Try, /*On fail goto*//*Label 35182*/ GIMT_Encode4(2431516), // Rule ID 45581 //
     /* 2431438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431474 */     // MIs[1] Operand 1
     /* 2431474 */     // No operand predicates
     /* 2431474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431478 */     // MIs[0] policy
     /* 2431478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431490 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2431493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431502 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431515 */     // GIR_Coverage, 45581,
     /* 2431515 */     GIR_EraseRootFromParent_Done,
     /* 2431516 */   // Label 35182: @2431516
     /* 2431516 */   GIM_Try, /*On fail goto*//*Label 35183*/ GIMT_Encode4(2431588), // Rule ID 45522 //
     /* 2431521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431553 */     // MIs[0] policy
     /* 2431553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431563 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2431566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431574 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431587 */     // GIR_Coverage, 45522,
     /* 2431587 */     GIR_EraseRootFromParent_Done,
     /* 2431588 */   // Label 35183: @2431588
     /* 2431588 */   GIM_Try, /*On fail goto*//*Label 35184*/ GIMT_Encode4(2431660), // Rule ID 45523 //
     /* 2431593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431625 */     // MIs[0] policy
     /* 2431625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431635 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2431638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431640 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431646 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431659 */     // GIR_Coverage, 45523,
     /* 2431659 */     GIR_EraseRootFromParent_Done,
     /* 2431660 */   // Label 35184: @2431660
     /* 2431660 */   GIM_Try, /*On fail goto*//*Label 35185*/ GIMT_Encode4(2431732), // Rule ID 45582 //
     /* 2431665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431697 */     // MIs[0] policy
     /* 2431697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431707 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2431710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431718 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431731 */     // GIR_Coverage, 45582,
     /* 2431731 */     GIR_EraseRootFromParent_Done,
     /* 2431732 */   // Label 35185: @2431732
     /* 2431732 */   GIM_Try, /*On fail goto*//*Label 35186*/ GIMT_Encode4(2431804), // Rule ID 45583 //
     /* 2431737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2431740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2431746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431769 */     // MIs[0] policy
     /* 2431769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431779 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2431782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2431800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431803 */     // GIR_Coverage, 45583,
     /* 2431803 */     GIR_EraseRootFromParent_Done,
     /* 2431804 */   // Label 35186: @2431804
     /* 2431804 */   GIM_Reject,
     /* 2431805 */ // Label 35178: @2431805
     /* 2431805 */ GIM_Reject,
     /* 2431806 */ // Label 35108: @2431806
     /* 2431806 */ GIM_Try, /*On fail goto*//*Label 35187*/ GIMT_Encode4(2432128),
     /* 2431811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2431814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2431817 */   GIM_Try, /*On fail goto*//*Label 35188*/ GIMT_Encode4(2431900), // Rule ID 45452 //
     /* 2431822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2431831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431858 */     // MIs[1] Operand 1
     /* 2431858 */     // No operand predicates
     /* 2431858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431862 */     // MIs[0] policy
     /* 2431862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431874 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2431877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431886 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2431896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431899 */     // GIR_Coverage, 45452,
     /* 2431899 */     GIR_EraseRootFromParent_Done,
     /* 2431900 */   // Label 35188: @2431900
     /* 2431900 */   GIM_Try, /*On fail goto*//*Label 35189*/ GIMT_Encode4(2431983), // Rule ID 45453 //
     /* 2431905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2431914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2431921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2431929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431941 */     // MIs[1] Operand 1
     /* 2431941 */     // No operand predicates
     /* 2431941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431945 */     // MIs[0] policy
     /* 2431945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431957 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2431960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431966 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2431979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431982 */     // GIR_Coverage, 45453,
     /* 2431982 */     GIR_EraseRootFromParent_Done,
     /* 2431983 */   // Label 35189: @2431983
     /* 2431983 */   GIM_Try, /*On fail goto*//*Label 35190*/ GIMT_Encode4(2432055), // Rule ID 45454 //
     /* 2431988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2431997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432020 */     // MIs[0] policy
     /* 2432020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432030 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2432033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432054 */     // GIR_Coverage, 45454,
     /* 2432054 */     GIR_EraseRootFromParent_Done,
     /* 2432055 */   // Label 35190: @2432055
     /* 2432055 */   GIM_Try, /*On fail goto*//*Label 35191*/ GIMT_Encode4(2432127), // Rule ID 45455 //
     /* 2432060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432092 */     // MIs[0] policy
     /* 2432092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432102 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2432105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432126 */     // GIR_Coverage, 45455,
     /* 2432126 */     GIR_EraseRootFromParent_Done,
     /* 2432127 */   // Label 35191: @2432127
     /* 2432127 */   GIM_Reject,
     /* 2432128 */ // Label 35187: @2432128
     /* 2432128 */ GIM_Reject,
     /* 2432129 */ // Label 35109: @2432129
     /* 2432129 */ GIM_Try, /*On fail goto*//*Label 35192*/ GIMT_Encode4(2432761),
     /* 2432134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2432137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2432140 */   GIM_Try, /*On fail goto*//*Label 35193*/ GIMT_Encode4(2432223), // Rule ID 45472 //
     /* 2432145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432181 */     // MIs[1] Operand 1
     /* 2432181 */     // No operand predicates
     /* 2432181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432185 */     // MIs[0] policy
     /* 2432185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432197 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432222 */     // GIR_Coverage, 45472,
     /* 2432222 */     GIR_EraseRootFromParent_Done,
     /* 2432223 */   // Label 35193: @2432223
     /* 2432223 */   GIM_Try, /*On fail goto*//*Label 35194*/ GIMT_Encode4(2432306), // Rule ID 45473 //
     /* 2432228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432264 */     // MIs[1] Operand 1
     /* 2432264 */     // No operand predicates
     /* 2432264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432268 */     // MIs[0] policy
     /* 2432268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432280 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432292 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432305 */     // GIR_Coverage, 45473,
     /* 2432305 */     GIR_EraseRootFromParent_Done,
     /* 2432306 */   // Label 35194: @2432306
     /* 2432306 */   GIM_Try, /*On fail goto*//*Label 35195*/ GIMT_Encode4(2432389), // Rule ID 45544 //
     /* 2432311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432347 */     // MIs[1] Operand 1
     /* 2432347 */     // No operand predicates
     /* 2432347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432351 */     // MIs[0] policy
     /* 2432351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432363 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432368 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432388 */     // GIR_Coverage, 45544,
     /* 2432388 */     GIR_EraseRootFromParent_Done,
     /* 2432389 */   // Label 35195: @2432389
     /* 2432389 */   GIM_Try, /*On fail goto*//*Label 35196*/ GIMT_Encode4(2432472), // Rule ID 45545 //
     /* 2432394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432426 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432430 */     // MIs[1] Operand 1
     /* 2432430 */     // No operand predicates
     /* 2432430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432434 */     // MIs[0] policy
     /* 2432434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432446 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2432449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432471 */     // GIR_Coverage, 45545,
     /* 2432471 */     GIR_EraseRootFromParent_Done,
     /* 2432472 */   // Label 35196: @2432472
     /* 2432472 */   GIM_Try, /*On fail goto*//*Label 35197*/ GIMT_Encode4(2432544), // Rule ID 45474 //
     /* 2432477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432509 */     // MIs[0] policy
     /* 2432509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432519 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2432522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432543 */     // GIR_Coverage, 45474,
     /* 2432543 */     GIR_EraseRootFromParent_Done,
     /* 2432544 */   // Label 35197: @2432544
     /* 2432544 */   GIM_Try, /*On fail goto*//*Label 35198*/ GIMT_Encode4(2432616), // Rule ID 45475 //
     /* 2432549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432581 */     // MIs[0] policy
     /* 2432581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432591 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2432594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432615 */     // GIR_Coverage, 45475,
     /* 2432615 */     GIR_EraseRootFromParent_Done,
     /* 2432616 */   // Label 35198: @2432616
     /* 2432616 */   GIM_Try, /*On fail goto*//*Label 35199*/ GIMT_Encode4(2432688), // Rule ID 45546 //
     /* 2432621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432653 */     // MIs[0] policy
     /* 2432653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432663 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2432666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432687 */     // GIR_Coverage, 45546,
     /* 2432687 */     GIR_EraseRootFromParent_Done,
     /* 2432688 */   // Label 35199: @2432688
     /* 2432688 */   GIM_Try, /*On fail goto*//*Label 35200*/ GIMT_Encode4(2432760), // Rule ID 45547 //
     /* 2432693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2432709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2432717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432725 */     // MIs[0] policy
     /* 2432725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432735 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2432738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432759 */     // GIR_Coverage, 45547,
     /* 2432759 */     GIR_EraseRootFromParent_Done,
     /* 2432760 */   // Label 35200: @2432760
     /* 2432760 */   GIM_Reject,
     /* 2432761 */ // Label 35192: @2432761
     /* 2432761 */ GIM_Reject,
     /* 2432762 */ // Label 35110: @2432762
     /* 2432762 */ GIM_Try, /*On fail goto*//*Label 35201*/ GIMT_Encode4(2433394),
     /* 2432767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2432770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2432773 */   GIM_Try, /*On fail goto*//*Label 35202*/ GIMT_Encode4(2432856), // Rule ID 45508 //
     /* 2432778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432814 */     // MIs[1] Operand 1
     /* 2432814 */     // No operand predicates
     /* 2432814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432818 */     // MIs[0] policy
     /* 2432818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432830 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2432833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432842 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432855 */     // GIR_Coverage, 45508,
     /* 2432855 */     GIR_EraseRootFromParent_Done,
     /* 2432856 */   // Label 35202: @2432856
     /* 2432856 */   GIM_Try, /*On fail goto*//*Label 35203*/ GIMT_Encode4(2432939), // Rule ID 45509 //
     /* 2432861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432897 */     // MIs[1] Operand 1
     /* 2432897 */     // No operand predicates
     /* 2432897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432901 */     // MIs[0] policy
     /* 2432901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432913 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2432916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2432935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432938 */     // GIR_Coverage, 45509,
     /* 2432938 */     GIR_EraseRootFromParent_Done,
     /* 2432939 */   // Label 35203: @2432939
     /* 2432939 */   GIM_Try, /*On fail goto*//*Label 35204*/ GIMT_Encode4(2433022), // Rule ID 45568 //
     /* 2432944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2432953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432980 */     // MIs[1] Operand 1
     /* 2432980 */     // No operand predicates
     /* 2432980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432984 */     // MIs[0] policy
     /* 2432984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432996 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2432999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433021 */     // GIR_Coverage, 45568,
     /* 2433021 */     GIR_EraseRootFromParent_Done,
     /* 2433022 */   // Label 35204: @2433022
     /* 2433022 */   GIM_Try, /*On fail goto*//*Label 35205*/ GIMT_Encode4(2433105), // Rule ID 45569 //
     /* 2433027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433063 */     // MIs[1] Operand 1
     /* 2433063 */     // No operand predicates
     /* 2433063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433067 */     // MIs[0] policy
     /* 2433067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433079 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2433082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433088 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433104 */     // GIR_Coverage, 45569,
     /* 2433104 */     GIR_EraseRootFromParent_Done,
     /* 2433105 */   // Label 35205: @2433105
     /* 2433105 */   GIM_Try, /*On fail goto*//*Label 35206*/ GIMT_Encode4(2433177), // Rule ID 45510 //
     /* 2433110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433142 */     // MIs[0] policy
     /* 2433142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433152 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433176 */     // GIR_Coverage, 45510,
     /* 2433176 */     GIR_EraseRootFromParent_Done,
     /* 2433177 */   // Label 35206: @2433177
     /* 2433177 */   GIM_Try, /*On fail goto*//*Label 35207*/ GIMT_Encode4(2433249), // Rule ID 45511 //
     /* 2433182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433214 */     // MIs[0] policy
     /* 2433214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433224 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433248 */     // GIR_Coverage, 45511,
     /* 2433248 */     GIR_EraseRootFromParent_Done,
     /* 2433249 */   // Label 35207: @2433249
     /* 2433249 */   GIM_Try, /*On fail goto*//*Label 35208*/ GIMT_Encode4(2433321), // Rule ID 45570 //
     /* 2433254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433286 */     // MIs[0] policy
     /* 2433286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433296 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433320 */     // GIR_Coverage, 45570,
     /* 2433320 */     GIR_EraseRootFromParent_Done,
     /* 2433321 */   // Label 35208: @2433321
     /* 2433321 */   GIM_Try, /*On fail goto*//*Label 35209*/ GIMT_Encode4(2433393), // Rule ID 45571 //
     /* 2433326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2433342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2433350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433358 */     // MIs[0] policy
     /* 2433358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433368 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2433371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433392 */     // GIR_Coverage, 45571,
     /* 2433392 */     GIR_EraseRootFromParent_Done,
     /* 2433393 */   // Label 35209: @2433393
     /* 2433393 */   GIM_Reject,
     /* 2433394 */ // Label 35201: @2433394
     /* 2433394 */ GIM_Reject,
     /* 2433395 */ // Label 35111: @2433395
     /* 2433395 */ GIM_Try, /*On fail goto*//*Label 35210*/ GIMT_Encode4(2434027),
     /* 2433400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2433403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2433406 */   GIM_Try, /*On fail goto*//*Label 35211*/ GIMT_Encode4(2433489), // Rule ID 45524 //
     /* 2433411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2433414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433447 */     // MIs[1] Operand 1
     /* 2433447 */     // No operand predicates
     /* 2433447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433451 */     // MIs[0] policy
     /* 2433451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433463 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2433466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433488 */     // GIR_Coverage, 45524,
     /* 2433488 */     GIR_EraseRootFromParent_Done,
     /* 2433489 */   // Label 35211: @2433489
     /* 2433489 */   GIM_Try, /*On fail goto*//*Label 35212*/ GIMT_Encode4(2433572), // Rule ID 45525 //
     /* 2433494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2433497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433530 */     // MIs[1] Operand 1
     /* 2433530 */     // No operand predicates
     /* 2433530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433534 */     // MIs[0] policy
     /* 2433534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433546 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2433549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433571 */     // GIR_Coverage, 45525,
     /* 2433571 */     GIR_EraseRootFromParent_Done,
     /* 2433572 */   // Label 35212: @2433572
     /* 2433572 */   GIM_Try, /*On fail goto*//*Label 35213*/ GIMT_Encode4(2433655), // Rule ID 45584 //
     /* 2433577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2433580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433613 */     // MIs[1] Operand 1
     /* 2433613 */     // No operand predicates
     /* 2433613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433617 */     // MIs[0] policy
     /* 2433617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433629 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2433632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433654 */     // GIR_Coverage, 45584,
     /* 2433654 */     GIR_EraseRootFromParent_Done,
     /* 2433655 */   // Label 35213: @2433655
     /* 2433655 */   GIM_Try, /*On fail goto*//*Label 35214*/ GIMT_Encode4(2433738), // Rule ID 45585 //
     /* 2433660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2433663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433696 */     // MIs[1] Operand 1
     /* 2433696 */     // No operand predicates
     /* 2433696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433700 */     // MIs[0] policy
     /* 2433700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433712 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2433715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433724 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433737 */     // GIR_Coverage, 45585,
     /* 2433737 */     GIR_EraseRootFromParent_Done,
     /* 2433738 */   // Label 35214: @2433738
     /* 2433738 */   GIM_Try, /*On fail goto*//*Label 35215*/ GIMT_Encode4(2433810), // Rule ID 45526 //
     /* 2433743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2433746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433775 */     // MIs[0] policy
     /* 2433775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433785 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2433788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433809 */     // GIR_Coverage, 45526,
     /* 2433809 */     GIR_EraseRootFromParent_Done,
     /* 2433810 */   // Label 35215: @2433810
     /* 2433810 */   GIM_Try, /*On fail goto*//*Label 35216*/ GIMT_Encode4(2433882), // Rule ID 45527 //
     /* 2433815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2433818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433847 */     // MIs[0] policy
     /* 2433847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433857 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2433860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433881 */     // GIR_Coverage, 45527,
     /* 2433881 */     GIR_EraseRootFromParent_Done,
     /* 2433882 */   // Label 35216: @2433882
     /* 2433882 */   GIM_Try, /*On fail goto*//*Label 35217*/ GIMT_Encode4(2433954), // Rule ID 45586 //
     /* 2433887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2433890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433919 */     // MIs[0] policy
     /* 2433919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433929 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2433932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2433950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433953 */     // GIR_Coverage, 45586,
     /* 2433953 */     GIR_EraseRootFromParent_Done,
     /* 2433954 */   // Label 35217: @2433954
     /* 2433954 */   GIM_Try, /*On fail goto*//*Label 35218*/ GIMT_Encode4(2434026), // Rule ID 45587 //
     /* 2433959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2433962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2433968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433991 */     // MIs[0] policy
     /* 2433991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434001 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2434004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434006 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2434022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434025 */     // GIR_Coverage, 45587,
     /* 2434025 */     GIR_EraseRootFromParent_Done,
     /* 2434026 */   // Label 35218: @2434026
     /* 2434026 */   GIM_Reject,
     /* 2434027 */ // Label 35210: @2434027
     /* 2434027 */ GIM_Reject,
     /* 2434028 */ // Label 35112: @2434028
     /* 2434028 */ GIM_Try, /*On fail goto*//*Label 35219*/ GIMT_Encode4(2434350),
     /* 2434033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2434036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2434039 */   GIM_Try, /*On fail goto*//*Label 35220*/ GIMT_Encode4(2434122), // Rule ID 45468 //
     /* 2434044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434080 */     // MIs[1] Operand 1
     /* 2434080 */     // No operand predicates
     /* 2434080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434084 */     // MIs[0] policy
     /* 2434084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434096 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2434099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434108 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434121 */     // GIR_Coverage, 45468,
     /* 2434121 */     GIR_EraseRootFromParent_Done,
     /* 2434122 */   // Label 35220: @2434122
     /* 2434122 */   GIM_Try, /*On fail goto*//*Label 35221*/ GIMT_Encode4(2434205), // Rule ID 45469 //
     /* 2434127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434163 */     // MIs[1] Operand 1
     /* 2434163 */     // No operand predicates
     /* 2434163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434167 */     // MIs[0] policy
     /* 2434167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434179 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2434182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434204 */     // GIR_Coverage, 45469,
     /* 2434204 */     GIR_EraseRootFromParent_Done,
     /* 2434205 */   // Label 35221: @2434205
     /* 2434205 */   GIM_Try, /*On fail goto*//*Label 35222*/ GIMT_Encode4(2434277), // Rule ID 45470 //
     /* 2434210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434242 */     // MIs[0] policy
     /* 2434242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434252 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2434255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434276 */     // GIR_Coverage, 45470,
     /* 2434276 */     GIR_EraseRootFromParent_Done,
     /* 2434277 */   // Label 35222: @2434277
     /* 2434277 */   GIM_Try, /*On fail goto*//*Label 35223*/ GIMT_Encode4(2434349), // Rule ID 45471 //
     /* 2434282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2434298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2434306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434314 */     // MIs[0] policy
     /* 2434314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434324 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2434327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434329 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434348 */     // GIR_Coverage, 45471,
     /* 2434348 */     GIR_EraseRootFromParent_Done,
     /* 2434349 */   // Label 35223: @2434349
     /* 2434349 */   GIM_Reject,
     /* 2434350 */ // Label 35219: @2434350
     /* 2434350 */ GIM_Reject,
     /* 2434351 */ // Label 35113: @2434351
     /* 2434351 */ GIM_Try, /*On fail goto*//*Label 35224*/ GIMT_Encode4(2434983),
     /* 2434356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2434359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2434362 */   GIM_Try, /*On fail goto*//*Label 35225*/ GIMT_Encode4(2434445), // Rule ID 45496 //
     /* 2434367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434403 */     // MIs[1] Operand 1
     /* 2434403 */     // No operand predicates
     /* 2434403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434407 */     // MIs[0] policy
     /* 2434407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434419 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2434422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434444 */     // GIR_Coverage, 45496,
     /* 2434444 */     GIR_EraseRootFromParent_Done,
     /* 2434445 */   // Label 35225: @2434445
     /* 2434445 */   GIM_Try, /*On fail goto*//*Label 35226*/ GIMT_Encode4(2434528), // Rule ID 45497 //
     /* 2434450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434486 */     // MIs[1] Operand 1
     /* 2434486 */     // No operand predicates
     /* 2434486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434490 */     // MIs[0] policy
     /* 2434490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434502 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2434505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434527 */     // GIR_Coverage, 45497,
     /* 2434527 */     GIR_EraseRootFromParent_Done,
     /* 2434528 */   // Label 35226: @2434528
     /* 2434528 */   GIM_Try, /*On fail goto*//*Label 35227*/ GIMT_Encode4(2434611), // Rule ID 45556 //
     /* 2434533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434569 */     // MIs[1] Operand 1
     /* 2434569 */     // No operand predicates
     /* 2434569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434573 */     // MIs[0] policy
     /* 2434573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434585 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2434588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434610 */     // GIR_Coverage, 45556,
     /* 2434610 */     GIR_EraseRootFromParent_Done,
     /* 2434611 */   // Label 35227: @2434611
     /* 2434611 */   GIM_Try, /*On fail goto*//*Label 35228*/ GIMT_Encode4(2434694), // Rule ID 45557 //
     /* 2434616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434652 */     // MIs[1] Operand 1
     /* 2434652 */     // No operand predicates
     /* 2434652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434656 */     // MIs[0] policy
     /* 2434656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434668 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2434671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434680 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434693 */     // GIR_Coverage, 45557,
     /* 2434693 */     GIR_EraseRootFromParent_Done,
     /* 2434694 */   // Label 35228: @2434694
     /* 2434694 */   GIM_Try, /*On fail goto*//*Label 35229*/ GIMT_Encode4(2434766), // Rule ID 45498 //
     /* 2434699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434731 */     // MIs[0] policy
     /* 2434731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434741 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2434744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434752 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434765 */     // GIR_Coverage, 45498,
     /* 2434765 */     GIR_EraseRootFromParent_Done,
     /* 2434766 */   // Label 35229: @2434766
     /* 2434766 */   GIM_Try, /*On fail goto*//*Label 35230*/ GIMT_Encode4(2434838), // Rule ID 45499 //
     /* 2434771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434803 */     // MIs[0] policy
     /* 2434803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434813 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2434816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434837 */     // GIR_Coverage, 45499,
     /* 2434837 */     GIR_EraseRootFromParent_Done,
     /* 2434838 */   // Label 35230: @2434838
     /* 2434838 */   GIM_Try, /*On fail goto*//*Label 35231*/ GIMT_Encode4(2434910), // Rule ID 45558 //
     /* 2434843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434875 */     // MIs[0] policy
     /* 2434875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434885 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2434888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434909 */     // GIR_Coverage, 45558,
     /* 2434909 */     GIR_EraseRootFromParent_Done,
     /* 2434910 */   // Label 35231: @2434910
     /* 2434910 */   GIM_Try, /*On fail goto*//*Label 35232*/ GIMT_Encode4(2434982), // Rule ID 45559 //
     /* 2434915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2434924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2434931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2434939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434947 */     // MIs[0] policy
     /* 2434947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434957 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2434960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434981 */     // GIR_Coverage, 45559,
     /* 2434981 */     GIR_EraseRootFromParent_Done,
     /* 2434982 */   // Label 35232: @2434982
     /* 2434982 */   GIM_Reject,
     /* 2434983 */ // Label 35224: @2434983
     /* 2434983 */ GIM_Reject,
     /* 2434984 */ // Label 35114: @2434984
     /* 2434984 */ GIM_Try, /*On fail goto*//*Label 35233*/ GIMT_Encode4(2435616),
     /* 2434989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2434992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2434995 */   GIM_Try, /*On fail goto*//*Label 35234*/ GIMT_Encode4(2435078), // Rule ID 45512 //
     /* 2435000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435036 */     // MIs[1] Operand 1
     /* 2435036 */     // No operand predicates
     /* 2435036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435040 */     // MIs[0] policy
     /* 2435040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435052 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435064 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435077 */     // GIR_Coverage, 45512,
     /* 2435077 */     GIR_EraseRootFromParent_Done,
     /* 2435078 */   // Label 35234: @2435078
     /* 2435078 */   GIM_Try, /*On fail goto*//*Label 35235*/ GIMT_Encode4(2435161), // Rule ID 45513 //
     /* 2435083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435119 */     // MIs[1] Operand 1
     /* 2435119 */     // No operand predicates
     /* 2435119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435123 */     // MIs[0] policy
     /* 2435123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435135 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435160 */     // GIR_Coverage, 45513,
     /* 2435160 */     GIR_EraseRootFromParent_Done,
     /* 2435161 */   // Label 35235: @2435161
     /* 2435161 */   GIM_Try, /*On fail goto*//*Label 35236*/ GIMT_Encode4(2435244), // Rule ID 45572 //
     /* 2435166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435202 */     // MIs[1] Operand 1
     /* 2435202 */     // No operand predicates
     /* 2435202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435206 */     // MIs[0] policy
     /* 2435206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435218 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435243 */     // GIR_Coverage, 45572,
     /* 2435243 */     GIR_EraseRootFromParent_Done,
     /* 2435244 */   // Label 35236: @2435244
     /* 2435244 */   GIM_Try, /*On fail goto*//*Label 35237*/ GIMT_Encode4(2435327), // Rule ID 45573 //
     /* 2435249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435285 */     // MIs[1] Operand 1
     /* 2435285 */     // No operand predicates
     /* 2435285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435289 */     // MIs[0] policy
     /* 2435289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435301 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2435304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435326 */     // GIR_Coverage, 45573,
     /* 2435326 */     GIR_EraseRootFromParent_Done,
     /* 2435327 */   // Label 35237: @2435327
     /* 2435327 */   GIM_Try, /*On fail goto*//*Label 35238*/ GIMT_Encode4(2435399), // Rule ID 45514 //
     /* 2435332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435364 */     // MIs[0] policy
     /* 2435364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435374 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2435377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435398 */     // GIR_Coverage, 45514,
     /* 2435398 */     GIR_EraseRootFromParent_Done,
     /* 2435399 */   // Label 35238: @2435399
     /* 2435399 */   GIM_Try, /*On fail goto*//*Label 35239*/ GIMT_Encode4(2435471), // Rule ID 45515 //
     /* 2435404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435436 */     // MIs[0] policy
     /* 2435436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435446 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2435449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435470 */     // GIR_Coverage, 45515,
     /* 2435470 */     GIR_EraseRootFromParent_Done,
     /* 2435471 */   // Label 35239: @2435471
     /* 2435471 */   GIM_Try, /*On fail goto*//*Label 35240*/ GIMT_Encode4(2435543), // Rule ID 45574 //
     /* 2435476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435508 */     // MIs[0] policy
     /* 2435508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435518 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2435521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435542 */     // GIR_Coverage, 45574,
     /* 2435542 */     GIR_EraseRootFromParent_Done,
     /* 2435543 */   // Label 35240: @2435543
     /* 2435543 */   GIM_Try, /*On fail goto*//*Label 35241*/ GIMT_Encode4(2435615), // Rule ID 45575 //
     /* 2435548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2435564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2435572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435580 */     // MIs[0] policy
     /* 2435580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435590 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2435593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2435611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435614 */     // GIR_Coverage, 45575,
     /* 2435614 */     GIR_EraseRootFromParent_Done,
     /* 2435615 */   // Label 35241: @2435615
     /* 2435615 */   GIM_Reject,
     /* 2435616 */ // Label 35233: @2435616
     /* 2435616 */ GIM_Reject,
     /* 2435617 */ // Label 35115: @2435617
     /* 2435617 */ GIM_Try, /*On fail goto*//*Label 35242*/ GIMT_Encode4(2436249),
     /* 2435622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2435625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2435628 */   GIM_Try, /*On fail goto*//*Label 35243*/ GIMT_Encode4(2435711), // Rule ID 45528 //
     /* 2435633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435669 */     // MIs[1] Operand 1
     /* 2435669 */     // No operand predicates
     /* 2435669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435673 */     // MIs[0] policy
     /* 2435673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435685 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2435688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435710 */     // GIR_Coverage, 45528,
     /* 2435710 */     GIR_EraseRootFromParent_Done,
     /* 2435711 */   // Label 35243: @2435711
     /* 2435711 */   GIM_Try, /*On fail goto*//*Label 35244*/ GIMT_Encode4(2435794), // Rule ID 45529 //
     /* 2435716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435752 */     // MIs[1] Operand 1
     /* 2435752 */     // No operand predicates
     /* 2435752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435756 */     // MIs[0] policy
     /* 2435756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435768 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2435771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435793 */     // GIR_Coverage, 45529,
     /* 2435793 */     GIR_EraseRootFromParent_Done,
     /* 2435794 */   // Label 35244: @2435794
     /* 2435794 */   GIM_Try, /*On fail goto*//*Label 35245*/ GIMT_Encode4(2435877), // Rule ID 45588 //
     /* 2435799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435835 */     // MIs[1] Operand 1
     /* 2435835 */     // No operand predicates
     /* 2435835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435839 */     // MIs[0] policy
     /* 2435839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435851 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2435854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435876 */     // GIR_Coverage, 45588,
     /* 2435876 */     GIR_EraseRootFromParent_Done,
     /* 2435877 */   // Label 35245: @2435877
     /* 2435877 */   GIM_Try, /*On fail goto*//*Label 35246*/ GIMT_Encode4(2435960), // Rule ID 45589 //
     /* 2435882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2435885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435918 */     // MIs[1] Operand 1
     /* 2435918 */     // No operand predicates
     /* 2435918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435922 */     // MIs[0] policy
     /* 2435922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435934 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2435937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2435956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435959 */     // GIR_Coverage, 45589,
     /* 2435959 */     GIR_EraseRootFromParent_Done,
     /* 2435960 */   // Label 35246: @2435960
     /* 2435960 */   GIM_Try, /*On fail goto*//*Label 35247*/ GIMT_Encode4(2436032), // Rule ID 45530 //
     /* 2435965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2435968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2435974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435997 */     // MIs[0] policy
     /* 2435997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436007 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2436010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436031 */     // GIR_Coverage, 45530,
     /* 2436031 */     GIR_EraseRootFromParent_Done,
     /* 2436032 */   // Label 35247: @2436032
     /* 2436032 */   GIM_Try, /*On fail goto*//*Label 35248*/ GIMT_Encode4(2436104), // Rule ID 45531 //
     /* 2436037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436069 */     // MIs[0] policy
     /* 2436069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436079 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2436082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436103 */     // GIR_Coverage, 45531,
     /* 2436103 */     GIR_EraseRootFromParent_Done,
     /* 2436104 */   // Label 35248: @2436104
     /* 2436104 */   GIM_Try, /*On fail goto*//*Label 35249*/ GIMT_Encode4(2436176), // Rule ID 45590 //
     /* 2436109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2436112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436141 */     // MIs[0] policy
     /* 2436141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436151 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2436154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436175 */     // GIR_Coverage, 45590,
     /* 2436175 */     GIR_EraseRootFromParent_Done,
     /* 2436176 */   // Label 35249: @2436176
     /* 2436176 */   GIM_Try, /*On fail goto*//*Label 35250*/ GIMT_Encode4(2436248), // Rule ID 45591 //
     /* 2436181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2436184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2436190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2436197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2436205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436213 */     // MIs[0] policy
     /* 2436213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436223 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2436226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436234 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2436244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436247 */     // GIR_Coverage, 45591,
     /* 2436247 */     GIR_EraseRootFromParent_Done,
     /* 2436248 */   // Label 35250: @2436248
     /* 2436248 */   GIM_Reject,
     /* 2436249 */ // Label 35242: @2436249
     /* 2436249 */ GIM_Reject,
     /* 2436250 */ // Label 35116: @2436250
     /* 2436250 */ GIM_Try, /*On fail goto*//*Label 35251*/ GIMT_Encode4(2436572),
     /* 2436255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2436258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2436261 */   GIM_Try, /*On fail goto*//*Label 35252*/ GIMT_Encode4(2436344), // Rule ID 45484 //
     /* 2436266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436302 */     // MIs[1] Operand 1
     /* 2436302 */     // No operand predicates
     /* 2436302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436306 */     // MIs[0] policy
     /* 2436306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436318 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2436321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436343 */     // GIR_Coverage, 45484,
     /* 2436343 */     GIR_EraseRootFromParent_Done,
     /* 2436344 */   // Label 35252: @2436344
     /* 2436344 */   GIM_Try, /*On fail goto*//*Label 35253*/ GIMT_Encode4(2436427), // Rule ID 45485 //
     /* 2436349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436385 */     // MIs[1] Operand 1
     /* 2436385 */     // No operand predicates
     /* 2436385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436389 */     // MIs[0] policy
     /* 2436389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436401 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2436404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436426 */     // GIR_Coverage, 45485,
     /* 2436426 */     GIR_EraseRootFromParent_Done,
     /* 2436427 */   // Label 35253: @2436427
     /* 2436427 */   GIM_Try, /*On fail goto*//*Label 35254*/ GIMT_Encode4(2436499), // Rule ID 45486 //
     /* 2436432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436464 */     // MIs[0] policy
     /* 2436464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436474 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2436477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436498 */     // GIR_Coverage, 45486,
     /* 2436498 */     GIR_EraseRootFromParent_Done,
     /* 2436499 */   // Label 35254: @2436499
     /* 2436499 */   GIM_Try, /*On fail goto*//*Label 35255*/ GIMT_Encode4(2436571), // Rule ID 45487 //
     /* 2436504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2436520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2436528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436536 */     // MIs[0] policy
     /* 2436536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436546 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2436549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2436567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436570 */     // GIR_Coverage, 45487,
     /* 2436570 */     GIR_EraseRootFromParent_Done,
     /* 2436571 */   // Label 35255: @2436571
     /* 2436571 */   GIM_Reject,
     /* 2436572 */ // Label 35251: @2436572
     /* 2436572 */ GIM_Reject,
     /* 2436573 */ // Label 35117: @2436573
     /* 2436573 */ GIM_Try, /*On fail goto*//*Label 35256*/ GIMT_Encode4(2437205),
     /* 2436578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2436581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2436584 */   GIM_Try, /*On fail goto*//*Label 35257*/ GIMT_Encode4(2436667), // Rule ID 45500 //
     /* 2436589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436625 */     // MIs[1] Operand 1
     /* 2436625 */     // No operand predicates
     /* 2436625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436629 */     // MIs[0] policy
     /* 2436629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436641 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2436644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436666 */     // GIR_Coverage, 45500,
     /* 2436666 */     GIR_EraseRootFromParent_Done,
     /* 2436667 */   // Label 35257: @2436667
     /* 2436667 */   GIM_Try, /*On fail goto*//*Label 35258*/ GIMT_Encode4(2436750), // Rule ID 45501 //
     /* 2436672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436708 */     // MIs[1] Operand 1
     /* 2436708 */     // No operand predicates
     /* 2436708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436712 */     // MIs[0] policy
     /* 2436712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436724 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2436727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436736 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436749 */     // GIR_Coverage, 45501,
     /* 2436749 */     GIR_EraseRootFromParent_Done,
     /* 2436750 */   // Label 35258: @2436750
     /* 2436750 */   GIM_Try, /*On fail goto*//*Label 35259*/ GIMT_Encode4(2436833), // Rule ID 45560 //
     /* 2436755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436791 */     // MIs[1] Operand 1
     /* 2436791 */     // No operand predicates
     /* 2436791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436795 */     // MIs[0] policy
     /* 2436795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436807 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2436810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436832 */     // GIR_Coverage, 45560,
     /* 2436832 */     GIR_EraseRootFromParent_Done,
     /* 2436833 */   // Label 35259: @2436833
     /* 2436833 */   GIM_Try, /*On fail goto*//*Label 35260*/ GIMT_Encode4(2436916), // Rule ID 45561 //
     /* 2436838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2436850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2436866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2436870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2436874 */     // MIs[1] Operand 1
     /* 2436874 */     // No operand predicates
     /* 2436874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436878 */     // MIs[0] policy
     /* 2436878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2436883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436890 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2436890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2436893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2436902 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436915 */     // GIR_Coverage, 45561,
     /* 2436915 */     GIR_EraseRootFromParent_Done,
     /* 2436916 */   // Label 35260: @2436916
     /* 2436916 */   GIM_Try, /*On fail goto*//*Label 35261*/ GIMT_Encode4(2436988), // Rule ID 45502 //
     /* 2436921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2436924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2436927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2436930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2436933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2436937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2436945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2436949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2436953 */     // MIs[0] policy
     /* 2436953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2436956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2436963 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2436963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2436966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2436968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2436970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2436972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2436974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2436976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2436981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2436984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2436986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2436987 */     // GIR_Coverage, 45502,
     /* 2436987 */     GIR_EraseRootFromParent_Done,
     /* 2436988 */   // Label 35261: @2436988
     /* 2436988 */   GIM_Try, /*On fail goto*//*Label 35262*/ GIMT_Encode4(2437060), // Rule ID 45503 //
     /* 2436993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2436996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2436999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437025 */     // MIs[0] policy
     /* 2437025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437035 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437059 */     // GIR_Coverage, 45503,
     /* 2437059 */     GIR_EraseRootFromParent_Done,
     /* 2437060 */   // Label 35262: @2437060
     /* 2437060 */   GIM_Try, /*On fail goto*//*Label 35263*/ GIMT_Encode4(2437132), // Rule ID 45562 //
     /* 2437065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437097 */     // MIs[0] policy
     /* 2437097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437107 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437118 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437131 */     // GIR_Coverage, 45562,
     /* 2437131 */     GIR_EraseRootFromParent_Done,
     /* 2437132 */   // Label 35263: @2437132
     /* 2437132 */   GIM_Try, /*On fail goto*//*Label 35264*/ GIMT_Encode4(2437204), // Rule ID 45563 //
     /* 2437137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437169 */     // MIs[0] policy
     /* 2437169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437179 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2437182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437190 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2437200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437203 */     // GIR_Coverage, 45563,
     /* 2437203 */     GIR_EraseRootFromParent_Done,
     /* 2437204 */   // Label 35264: @2437204
     /* 2437204 */   GIM_Reject,
     /* 2437205 */ // Label 35256: @2437205
     /* 2437205 */ GIM_Reject,
     /* 2437206 */ // Label 35118: @2437206
     /* 2437206 */ GIM_Try, /*On fail goto*//*Label 35265*/ GIMT_Encode4(2437838),
     /* 2437211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2437214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2437217 */   GIM_Try, /*On fail goto*//*Label 35266*/ GIMT_Encode4(2437300), // Rule ID 45516 //
     /* 2437222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437258 */     // MIs[1] Operand 1
     /* 2437258 */     // No operand predicates
     /* 2437258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437262 */     // MIs[0] policy
     /* 2437262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437274 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2437277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437299 */     // GIR_Coverage, 45516,
     /* 2437299 */     GIR_EraseRootFromParent_Done,
     /* 2437300 */   // Label 35266: @2437300
     /* 2437300 */   GIM_Try, /*On fail goto*//*Label 35267*/ GIMT_Encode4(2437383), // Rule ID 45517 //
     /* 2437305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437341 */     // MIs[1] Operand 1
     /* 2437341 */     // No operand predicates
     /* 2437341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437345 */     // MIs[0] policy
     /* 2437345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437357 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2437360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437382 */     // GIR_Coverage, 45517,
     /* 2437382 */     GIR_EraseRootFromParent_Done,
     /* 2437383 */   // Label 35267: @2437383
     /* 2437383 */   GIM_Try, /*On fail goto*//*Label 35268*/ GIMT_Encode4(2437466), // Rule ID 45576 //
     /* 2437388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437424 */     // MIs[1] Operand 1
     /* 2437424 */     // No operand predicates
     /* 2437424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437428 */     // MIs[0] policy
     /* 2437428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437440 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2437443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437465 */     // GIR_Coverage, 45576,
     /* 2437465 */     GIR_EraseRootFromParent_Done,
     /* 2437466 */   // Label 35268: @2437466
     /* 2437466 */   GIM_Try, /*On fail goto*//*Label 35269*/ GIMT_Encode4(2437549), // Rule ID 45577 //
     /* 2437471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437507 */     // MIs[1] Operand 1
     /* 2437507 */     // No operand predicates
     /* 2437507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437511 */     // MIs[0] policy
     /* 2437511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437523 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2437526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437548 */     // GIR_Coverage, 45577,
     /* 2437548 */     GIR_EraseRootFromParent_Done,
     /* 2437549 */   // Label 35269: @2437549
     /* 2437549 */   GIM_Try, /*On fail goto*//*Label 35270*/ GIMT_Encode4(2437621), // Rule ID 45518 //
     /* 2437554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437586 */     // MIs[0] policy
     /* 2437586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437596 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2437599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437620 */     // GIR_Coverage, 45518,
     /* 2437620 */     GIR_EraseRootFromParent_Done,
     /* 2437621 */   // Label 35270: @2437621
     /* 2437621 */   GIM_Try, /*On fail goto*//*Label 35271*/ GIMT_Encode4(2437693), // Rule ID 45519 //
     /* 2437626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437658 */     // MIs[0] policy
     /* 2437658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437668 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2437671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437692 */     // GIR_Coverage, 45519,
     /* 2437692 */     GIR_EraseRootFromParent_Done,
     /* 2437693 */   // Label 35271: @2437693
     /* 2437693 */   GIM_Try, /*On fail goto*//*Label 35272*/ GIMT_Encode4(2437765), // Rule ID 45578 //
     /* 2437698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437730 */     // MIs[0] policy
     /* 2437730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437740 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2437743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437764 */     // GIR_Coverage, 45578,
     /* 2437764 */     GIR_EraseRootFromParent_Done,
     /* 2437765 */   // Label 35272: @2437765
     /* 2437765 */   GIM_Try, /*On fail goto*//*Label 35273*/ GIMT_Encode4(2437837), // Rule ID 45579 //
     /* 2437770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2437779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2437786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2437794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2437798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437802 */     // MIs[0] policy
     /* 2437802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437812 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2437815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2437823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2437833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437836 */     // GIR_Coverage, 45579,
     /* 2437836 */     GIR_EraseRootFromParent_Done,
     /* 2437837 */   // Label 35273: @2437837
     /* 2437837 */   GIM_Reject,
     /* 2437838 */ // Label 35265: @2437838
     /* 2437838 */ GIM_Reject,
     /* 2437839 */ // Label 35119: @2437839
     /* 2437839 */ GIM_Try, /*On fail goto*//*Label 35274*/ GIMT_Encode4(2438161),
     /* 2437844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2437847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2437850 */   GIM_Try, /*On fail goto*//*Label 35275*/ GIMT_Encode4(2437933), // Rule ID 45488 //
     /* 2437855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2437858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2437861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2437864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2437867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437891 */     // MIs[1] Operand 1
     /* 2437891 */     // No operand predicates
     /* 2437891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437895 */     // MIs[0] policy
     /* 2437895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437907 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2437907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2437919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2437921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2437926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2437929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2437931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2437932 */     // GIR_Coverage, 45488,
     /* 2437932 */     GIR_EraseRootFromParent_Done,
     /* 2437933 */   // Label 35275: @2437933
     /* 2437933 */   GIM_Try, /*On fail goto*//*Label 35276*/ GIMT_Encode4(2438016), // Rule ID 45489 //
     /* 2437938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2437941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2437944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2437947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2437950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2437954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2437962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2437966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2437970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2437974 */     // MIs[1] Operand 1
     /* 2437974 */     // No operand predicates
     /* 2437974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2437978 */     // MIs[0] policy
     /* 2437978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2437981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2437983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2437990 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2437990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2437993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2437995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2437997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2437999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438002 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438015 */     // GIR_Coverage, 45489,
     /* 2438015 */     GIR_EraseRootFromParent_Done,
     /* 2438016 */   // Label 35276: @2438016
     /* 2438016 */   GIM_Try, /*On fail goto*//*Label 35277*/ GIMT_Encode4(2438088), // Rule ID 45490 //
     /* 2438021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438053 */     // MIs[0] policy
     /* 2438053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438063 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2438066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438074 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438087 */     // GIR_Coverage, 45490,
     /* 2438087 */     GIR_EraseRootFromParent_Done,
     /* 2438088 */   // Label 35277: @2438088
     /* 2438088 */   GIM_Try, /*On fail goto*//*Label 35278*/ GIMT_Encode4(2438160), // Rule ID 45491 //
     /* 2438093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2438109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2438117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438125 */     // MIs[0] policy
     /* 2438125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438135 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2438138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438146 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438159 */     // GIR_Coverage, 45491,
     /* 2438159 */     GIR_EraseRootFromParent_Done,
     /* 2438160 */   // Label 35278: @2438160
     /* 2438160 */   GIM_Reject,
     /* 2438161 */ // Label 35274: @2438161
     /* 2438161 */ GIM_Reject,
     /* 2438162 */ // Label 35120: @2438162
     /* 2438162 */ GIM_Try, /*On fail goto*//*Label 35279*/ GIMT_Encode4(2438794),
     /* 2438167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2438170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2438173 */   GIM_Try, /*On fail goto*//*Label 35280*/ GIMT_Encode4(2438256), // Rule ID 45504 //
     /* 2438178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438214 */     // MIs[1] Operand 1
     /* 2438214 */     // No operand predicates
     /* 2438214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438218 */     // MIs[0] policy
     /* 2438218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438230 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438255 */     // GIR_Coverage, 45504,
     /* 2438255 */     GIR_EraseRootFromParent_Done,
     /* 2438256 */   // Label 35280: @2438256
     /* 2438256 */   GIM_Try, /*On fail goto*//*Label 35281*/ GIMT_Encode4(2438339), // Rule ID 45505 //
     /* 2438261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438297 */     // MIs[1] Operand 1
     /* 2438297 */     // No operand predicates
     /* 2438297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438301 */     // MIs[0] policy
     /* 2438301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438313 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438338 */     // GIR_Coverage, 45505,
     /* 2438338 */     GIR_EraseRootFromParent_Done,
     /* 2438339 */   // Label 35281: @2438339
     /* 2438339 */   GIM_Try, /*On fail goto*//*Label 35282*/ GIMT_Encode4(2438422), // Rule ID 45564 //
     /* 2438344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438380 */     // MIs[1] Operand 1
     /* 2438380 */     // No operand predicates
     /* 2438380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438384 */     // MIs[0] policy
     /* 2438384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438396 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438421 */     // GIR_Coverage, 45564,
     /* 2438421 */     GIR_EraseRootFromParent_Done,
     /* 2438422 */   // Label 35282: @2438422
     /* 2438422 */   GIM_Try, /*On fail goto*//*Label 35283*/ GIMT_Encode4(2438505), // Rule ID 45565 //
     /* 2438427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438463 */     // MIs[1] Operand 1
     /* 2438463 */     // No operand predicates
     /* 2438463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438467 */     // MIs[0] policy
     /* 2438467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438479 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438504 */     // GIR_Coverage, 45565,
     /* 2438504 */     GIR_EraseRootFromParent_Done,
     /* 2438505 */   // Label 35283: @2438505
     /* 2438505 */   GIM_Try, /*On fail goto*//*Label 35284*/ GIMT_Encode4(2438577), // Rule ID 45506 //
     /* 2438510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438542 */     // MIs[0] policy
     /* 2438542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438552 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438576 */     // GIR_Coverage, 45506,
     /* 2438576 */     GIR_EraseRootFromParent_Done,
     /* 2438577 */   // Label 35284: @2438577
     /* 2438577 */   GIM_Try, /*On fail goto*//*Label 35285*/ GIMT_Encode4(2438649), // Rule ID 45507 //
     /* 2438582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438614 */     // MIs[0] policy
     /* 2438614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438624 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438648 */     // GIR_Coverage, 45507,
     /* 2438648 */     GIR_EraseRootFromParent_Done,
     /* 2438649 */   // Label 35285: @2438649
     /* 2438649 */   GIM_Try, /*On fail goto*//*Label 35286*/ GIMT_Encode4(2438721), // Rule ID 45566 //
     /* 2438654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438686 */     // MIs[0] policy
     /* 2438686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438696 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438720 */     // GIR_Coverage, 45566,
     /* 2438720 */     GIR_EraseRootFromParent_Done,
     /* 2438721 */   // Label 35286: @2438721
     /* 2438721 */   GIM_Try, /*On fail goto*//*Label 35287*/ GIMT_Encode4(2438793), // Rule ID 45567 //
     /* 2438726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2438735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2438754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438758 */     // MIs[0] policy
     /* 2438758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438768 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2438771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2438779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2438789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438792 */     // GIR_Coverage, 45567,
     /* 2438792 */     GIR_EraseRootFromParent_Done,
     /* 2438793 */   // Label 35287: @2438793
     /* 2438793 */   GIM_Reject,
     /* 2438794 */ // Label 35279: @2438794
     /* 2438794 */ GIM_Reject,
     /* 2438795 */ // Label 35121: @2438795
     /* 2438795 */ GIM_Try, /*On fail goto*//*Label 35288*/ GIMT_Encode4(2439117),
     /* 2438800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2438803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2438806 */   GIM_Try, /*On fail goto*//*Label 35289*/ GIMT_Encode4(2438889), // Rule ID 45492 //
     /* 2438811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2438820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438847 */     // MIs[1] Operand 1
     /* 2438847 */     // No operand predicates
     /* 2438847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438851 */     // MIs[0] policy
     /* 2438851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438863 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2438863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438868 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438888 */     // GIR_Coverage, 45492,
     /* 2438888 */     GIR_EraseRootFromParent_Done,
     /* 2438889 */   // Label 35289: @2438889
     /* 2438889 */   GIM_Try, /*On fail goto*//*Label 35290*/ GIMT_Encode4(2438972), // Rule ID 45493 //
     /* 2438894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2438897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2438900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2438903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2438906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2438922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2438926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2438930 */     // MIs[1] Operand 1
     /* 2438930 */     // No operand predicates
     /* 2438930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2438934 */     // MIs[0] policy
     /* 2438934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2438937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2438939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2438946 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2438946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2438949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2438951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2438953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2438955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2438958 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2438960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2438965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2438968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2438970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2438971 */     // GIR_Coverage, 45493,
     /* 2438971 */     GIR_EraseRootFromParent_Done,
     /* 2438972 */   // Label 35290: @2438972
     /* 2438972 */   GIM_Try, /*On fail goto*//*Label 35291*/ GIMT_Encode4(2439044), // Rule ID 45494 //
     /* 2438977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2438980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2438983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2438986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2438989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2438993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2438997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439009 */     // MIs[0] policy
     /* 2439009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439019 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439030 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439043 */     // GIR_Coverage, 45494,
     /* 2439043 */     GIR_EraseRootFromParent_Done,
     /* 2439044 */   // Label 35291: @2439044
     /* 2439044 */   GIM_Try, /*On fail goto*//*Label 35292*/ GIMT_Encode4(2439116), // Rule ID 45495 //
     /* 2439049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2439058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2439065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2439073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439081 */     // MIs[0] policy
     /* 2439081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439091 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2439094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439102 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439115 */     // GIR_Coverage, 45495,
     /* 2439115 */     GIR_EraseRootFromParent_Done,
     /* 2439116 */   // Label 35292: @2439116
     /* 2439116 */   GIM_Reject,
     /* 2439117 */ // Label 35288: @2439117
     /* 2439117 */ GIM_Reject,
     /* 2439118 */ // Label 35122: @2439118
     /* 2439118 */ GIM_Reject,
     /* 2439119 */ // Label 124: @2439119
     /* 2439119 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35315*/ GIMT_Encode4(2450998),
     /* 2439130 */ /*GILLT_nxv1s8*//*Label 35293*/ GIMT_Encode4(2439242),
     /* 2439134 */ /*GILLT_nxv1s16*//*Label 35294*/ GIMT_Encode4(2439565),
     /* 2439138 */ /*GILLT_nxv1s32*//*Label 35295*/ GIMT_Encode4(2440198),
     /* 2439142 */ /*GILLT_nxv1s64*//*Label 35296*/ GIMT_Encode4(2440831), GIMT_Encode4(0),
     /* 2439150 */ /*GILLT_nxv2s8*//*Label 35297*/ GIMT_Encode4(2441464),
     /* 2439154 */ /*GILLT_nxv2s16*//*Label 35298*/ GIMT_Encode4(2441787),
     /* 2439158 */ /*GILLT_nxv2s32*//*Label 35299*/ GIMT_Encode4(2442420),
     /* 2439162 */ /*GILLT_nxv2s64*//*Label 35300*/ GIMT_Encode4(2443053), GIMT_Encode4(0),
     /* 2439170 */ /*GILLT_nxv4s8*//*Label 35301*/ GIMT_Encode4(2443686),
     /* 2439174 */ /*GILLT_nxv4s16*//*Label 35302*/ GIMT_Encode4(2444009),
     /* 2439178 */ /*GILLT_nxv4s32*//*Label 35303*/ GIMT_Encode4(2444642),
     /* 2439182 */ /*GILLT_nxv4s64*//*Label 35304*/ GIMT_Encode4(2445275), GIMT_Encode4(0),
     /* 2439190 */ /*GILLT_nxv8s8*//*Label 35305*/ GIMT_Encode4(2445908),
     /* 2439194 */ /*GILLT_nxv8s16*//*Label 35306*/ GIMT_Encode4(2446231),
     /* 2439198 */ /*GILLT_nxv8s32*//*Label 35307*/ GIMT_Encode4(2446864),
     /* 2439202 */ /*GILLT_nxv8s64*//*Label 35308*/ GIMT_Encode4(2447497), GIMT_Encode4(0),
     /* 2439210 */ /*GILLT_nxv16s8*//*Label 35309*/ GIMT_Encode4(2448130),
     /* 2439214 */ /*GILLT_nxv16s16*//*Label 35310*/ GIMT_Encode4(2448453),
     /* 2439218 */ /*GILLT_nxv16s32*//*Label 35311*/ GIMT_Encode4(2449086), GIMT_Encode4(0),
     /* 2439226 */ /*GILLT_nxv32s8*//*Label 35312*/ GIMT_Encode4(2449719),
     /* 2439230 */ /*GILLT_nxv32s16*//*Label 35313*/ GIMT_Encode4(2450042), GIMT_Encode4(0),
     /* 2439238 */ /*GILLT_nxv64s8*//*Label 35314*/ GIMT_Encode4(2450675),
     /* 2439242 */ // Label 35293: @2439242
     /* 2439242 */ GIM_Try, /*On fail goto*//*Label 35316*/ GIMT_Encode4(2439564),
     /* 2439247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2439250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2439253 */   GIM_Try, /*On fail goto*//*Label 35317*/ GIMT_Encode4(2439336), // Rule ID 25358 //
     /* 2439258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439294 */     // MIs[1] Operand 1
     /* 2439294 */     // No operand predicates
     /* 2439294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439298 */     // MIs[0] policy
     /* 2439298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439310 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2439313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439335 */     // GIR_Coverage, 25358,
     /* 2439335 */     GIR_EraseRootFromParent_Done,
     /* 2439336 */   // Label 35317: @2439336
     /* 2439336 */   GIM_Try, /*On fail goto*//*Label 35318*/ GIMT_Encode4(2439419), // Rule ID 25359 //
     /* 2439341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439377 */     // MIs[1] Operand 1
     /* 2439377 */     // No operand predicates
     /* 2439377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439381 */     // MIs[0] policy
     /* 2439381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439393 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2439396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439418 */     // GIR_Coverage, 25359,
     /* 2439418 */     GIR_EraseRootFromParent_Done,
     /* 2439419 */   // Label 35318: @2439419
     /* 2439419 */   GIM_Try, /*On fail goto*//*Label 35319*/ GIMT_Encode4(2439491), // Rule ID 25360 //
     /* 2439424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439456 */     // MIs[0] policy
     /* 2439456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439466 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2439469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439490 */     // GIR_Coverage, 25360,
     /* 2439490 */     GIR_EraseRootFromParent_Done,
     /* 2439491 */   // Label 35319: @2439491
     /* 2439491 */   GIM_Try, /*On fail goto*//*Label 35320*/ GIMT_Encode4(2439563), // Rule ID 25361 //
     /* 2439496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439528 */     // MIs[0] policy
     /* 2439528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439538 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2439541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2439559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439562 */     // GIR_Coverage, 25361,
     /* 2439562 */     GIR_EraseRootFromParent_Done,
     /* 2439563 */   // Label 35320: @2439563
     /* 2439563 */   GIM_Reject,
     /* 2439564 */ // Label 35316: @2439564
     /* 2439564 */ GIM_Reject,
     /* 2439565 */ // Label 35294: @2439565
     /* 2439565 */ GIM_Try, /*On fail goto*//*Label 35321*/ GIMT_Encode4(2440197),
     /* 2439570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2439573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2439576 */   GIM_Try, /*On fail goto*//*Label 35322*/ GIMT_Encode4(2439659), // Rule ID 45308 //
     /* 2439581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439617 */     // MIs[1] Operand 1
     /* 2439617 */     // No operand predicates
     /* 2439617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439621 */     // MIs[0] policy
     /* 2439621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439633 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2439636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439658 */     // GIR_Coverage, 45308,
     /* 2439658 */     GIR_EraseRootFromParent_Done,
     /* 2439659 */   // Label 35322: @2439659
     /* 2439659 */   GIM_Try, /*On fail goto*//*Label 35323*/ GIMT_Encode4(2439742), // Rule ID 45309 //
     /* 2439664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439700 */     // MIs[1] Operand 1
     /* 2439700 */     // No operand predicates
     /* 2439700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439704 */     // MIs[0] policy
     /* 2439704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439716 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2439719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439741 */     // GIR_Coverage, 45309,
     /* 2439741 */     GIR_EraseRootFromParent_Done,
     /* 2439742 */   // Label 35323: @2439742
     /* 2439742 */   GIM_Try, /*On fail goto*//*Label 35324*/ GIMT_Encode4(2439825), // Rule ID 45384 //
     /* 2439747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439783 */     // MIs[1] Operand 1
     /* 2439783 */     // No operand predicates
     /* 2439783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439787 */     // MIs[0] policy
     /* 2439787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439799 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2439802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439824 */     // GIR_Coverage, 45384,
     /* 2439824 */     GIR_EraseRootFromParent_Done,
     /* 2439825 */   // Label 35324: @2439825
     /* 2439825 */   GIM_Try, /*On fail goto*//*Label 35325*/ GIMT_Encode4(2439908), // Rule ID 45385 //
     /* 2439830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2439858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2439862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2439866 */     // MIs[1] Operand 1
     /* 2439866 */     // No operand predicates
     /* 2439866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439870 */     // MIs[0] policy
     /* 2439870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2439875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439882 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2439882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2439885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2439894 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439907 */     // GIR_Coverage, 45385,
     /* 2439907 */     GIR_EraseRootFromParent_Done,
     /* 2439908 */   // Label 35325: @2439908
     /* 2439908 */   GIM_Try, /*On fail goto*//*Label 35326*/ GIMT_Encode4(2439980), // Rule ID 45310 //
     /* 2439913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2439916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2439919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2439925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2439929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2439937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2439941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2439945 */     // MIs[0] policy
     /* 2439945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2439948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2439955 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2439955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2439958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2439960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2439962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2439964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2439966 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2439968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2439973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2439976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2439978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2439979 */     // GIR_Coverage, 45310,
     /* 2439979 */     GIR_EraseRootFromParent_Done,
     /* 2439980 */   // Label 35326: @2439980
     /* 2439980 */   GIM_Try, /*On fail goto*//*Label 35327*/ GIMT_Encode4(2440052), // Rule ID 45311 //
     /* 2439985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2439988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2439991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2439994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2439997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440017 */     // MIs[0] policy
     /* 2440017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440027 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2440030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440051 */     // GIR_Coverage, 45311,
     /* 2440051 */     GIR_EraseRootFromParent_Done,
     /* 2440052 */   // Label 35327: @2440052
     /* 2440052 */   GIM_Try, /*On fail goto*//*Label 35328*/ GIMT_Encode4(2440124), // Rule ID 45386 //
     /* 2440057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440089 */     // MIs[0] policy
     /* 2440089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440099 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2440102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440110 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440123 */     // GIR_Coverage, 45386,
     /* 2440123 */     GIR_EraseRootFromParent_Done,
     /* 2440124 */   // Label 35328: @2440124
     /* 2440124 */   GIM_Try, /*On fail goto*//*Label 35329*/ GIMT_Encode4(2440196), // Rule ID 45387 //
     /* 2440129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440161 */     // MIs[0] policy
     /* 2440161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440171 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2440174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2440192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440195 */     // GIR_Coverage, 45387,
     /* 2440195 */     GIR_EraseRootFromParent_Done,
     /* 2440196 */   // Label 35329: @2440196
     /* 2440196 */   GIM_Reject,
     /* 2440197 */ // Label 35321: @2440197
     /* 2440197 */ GIM_Reject,
     /* 2440198 */ // Label 35295: @2440198
     /* 2440198 */ GIM_Try, /*On fail goto*//*Label 35330*/ GIMT_Encode4(2440830),
     /* 2440203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2440206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2440209 */   GIM_Try, /*On fail goto*//*Label 35331*/ GIMT_Encode4(2440292), // Rule ID 45316 //
     /* 2440214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440250 */     // MIs[1] Operand 1
     /* 2440250 */     // No operand predicates
     /* 2440250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440254 */     // MIs[0] policy
     /* 2440254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440266 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2440269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440278 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440291 */     // GIR_Coverage, 45316,
     /* 2440291 */     GIR_EraseRootFromParent_Done,
     /* 2440292 */   // Label 35331: @2440292
     /* 2440292 */   GIM_Try, /*On fail goto*//*Label 35332*/ GIMT_Encode4(2440375), // Rule ID 45317 //
     /* 2440297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440333 */     // MIs[1] Operand 1
     /* 2440333 */     // No operand predicates
     /* 2440333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440337 */     // MIs[0] policy
     /* 2440337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440349 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2440352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440374 */     // GIR_Coverage, 45317,
     /* 2440374 */     GIR_EraseRootFromParent_Done,
     /* 2440375 */   // Label 35332: @2440375
     /* 2440375 */   GIM_Try, /*On fail goto*//*Label 35333*/ GIMT_Encode4(2440458), // Rule ID 45392 //
     /* 2440380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440416 */     // MIs[1] Operand 1
     /* 2440416 */     // No operand predicates
     /* 2440416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440420 */     // MIs[0] policy
     /* 2440420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440432 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2440435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440444 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440457 */     // GIR_Coverage, 45392,
     /* 2440457 */     GIR_EraseRootFromParent_Done,
     /* 2440458 */   // Label 35333: @2440458
     /* 2440458 */   GIM_Try, /*On fail goto*//*Label 35334*/ GIMT_Encode4(2440541), // Rule ID 45393 //
     /* 2440463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440499 */     // MIs[1] Operand 1
     /* 2440499 */     // No operand predicates
     /* 2440499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440503 */     // MIs[0] policy
     /* 2440503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440515 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2440518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440540 */     // GIR_Coverage, 45393,
     /* 2440540 */     GIR_EraseRootFromParent_Done,
     /* 2440541 */   // Label 35334: @2440541
     /* 2440541 */   GIM_Try, /*On fail goto*//*Label 35335*/ GIMT_Encode4(2440613), // Rule ID 45318 //
     /* 2440546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440578 */     // MIs[0] policy
     /* 2440578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440588 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2440591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440612 */     // GIR_Coverage, 45318,
     /* 2440612 */     GIR_EraseRootFromParent_Done,
     /* 2440613 */   // Label 35335: @2440613
     /* 2440613 */   GIM_Try, /*On fail goto*//*Label 35336*/ GIMT_Encode4(2440685), // Rule ID 45319 //
     /* 2440618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440650 */     // MIs[0] policy
     /* 2440650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440660 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2440663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440684 */     // GIR_Coverage, 45319,
     /* 2440684 */     GIR_EraseRootFromParent_Done,
     /* 2440685 */   // Label 35336: @2440685
     /* 2440685 */   GIM_Try, /*On fail goto*//*Label 35337*/ GIMT_Encode4(2440757), // Rule ID 45394 //
     /* 2440690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2440693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440722 */     // MIs[0] policy
     /* 2440722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440732 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2440735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440756 */     // GIR_Coverage, 45394,
     /* 2440756 */     GIR_EraseRootFromParent_Done,
     /* 2440757 */   // Label 35337: @2440757
     /* 2440757 */   GIM_Try, /*On fail goto*//*Label 35338*/ GIMT_Encode4(2440829), // Rule ID 45395 //
     /* 2440762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2440765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2440790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440794 */     // MIs[0] policy
     /* 2440794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440804 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2440807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2440815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2440825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440828 */     // GIR_Coverage, 45395,
     /* 2440828 */     GIR_EraseRootFromParent_Done,
     /* 2440829 */   // Label 35338: @2440829
     /* 2440829 */   GIM_Reject,
     /* 2440830 */ // Label 35330: @2440830
     /* 2440830 */ GIM_Reject,
     /* 2440831 */ // Label 35296: @2440831
     /* 2440831 */ GIM_Try, /*On fail goto*//*Label 35339*/ GIMT_Encode4(2441463),
     /* 2440836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2440839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2440842 */   GIM_Try, /*On fail goto*//*Label 35340*/ GIMT_Encode4(2440925), // Rule ID 45332 //
     /* 2440847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2440850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2440853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2440859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440883 */     // MIs[1] Operand 1
     /* 2440883 */     // No operand predicates
     /* 2440883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440887 */     // MIs[0] policy
     /* 2440887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440899 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2440899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2440902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2440918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2440921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2440923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2440924 */     // GIR_Coverage, 45332,
     /* 2440924 */     GIR_EraseRootFromParent_Done,
     /* 2440925 */   // Label 35340: @2440925
     /* 2440925 */   GIM_Try, /*On fail goto*//*Label 35341*/ GIMT_Encode4(2441008), // Rule ID 45333 //
     /* 2440930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2440933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2440936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2440939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2440942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2440946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2440954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2440958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2440962 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2440966 */     // MIs[1] Operand 1
     /* 2440966 */     // No operand predicates
     /* 2440966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2440970 */     // MIs[0] policy
     /* 2440970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2440973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2440975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2440982 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2440982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2440985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2440987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2440989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2440991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2440994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2440996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441007 */     // GIR_Coverage, 45333,
     /* 2441007 */     GIR_EraseRootFromParent_Done,
     /* 2441008 */   // Label 35341: @2441008
     /* 2441008 */   GIM_Try, /*On fail goto*//*Label 35342*/ GIMT_Encode4(2441091), // Rule ID 45404 //
     /* 2441013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441049 */     // MIs[1] Operand 1
     /* 2441049 */     // No operand predicates
     /* 2441049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441053 */     // MIs[0] policy
     /* 2441053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441065 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2441068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441090 */     // GIR_Coverage, 45404,
     /* 2441090 */     GIR_EraseRootFromParent_Done,
     /* 2441091 */   // Label 35342: @2441091
     /* 2441091 */   GIM_Try, /*On fail goto*//*Label 35343*/ GIMT_Encode4(2441174), // Rule ID 45405 //
     /* 2441096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2441099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441132 */     // MIs[1] Operand 1
     /* 2441132 */     // No operand predicates
     /* 2441132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441136 */     // MIs[0] policy
     /* 2441136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441148 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2441151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441160 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441173 */     // GIR_Coverage, 45405,
     /* 2441173 */     GIR_EraseRootFromParent_Done,
     /* 2441174 */   // Label 35343: @2441174
     /* 2441174 */   GIM_Try, /*On fail goto*//*Label 35344*/ GIMT_Encode4(2441246), // Rule ID 45334 //
     /* 2441179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441211 */     // MIs[0] policy
     /* 2441211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441221 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2441224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441232 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441245 */     // GIR_Coverage, 45334,
     /* 2441245 */     GIR_EraseRootFromParent_Done,
     /* 2441246 */   // Label 35344: @2441246
     /* 2441246 */   GIM_Try, /*On fail goto*//*Label 35345*/ GIMT_Encode4(2441318), // Rule ID 45335 //
     /* 2441251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2441254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441283 */     // MIs[0] policy
     /* 2441283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441293 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2441296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441304 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441317 */     // GIR_Coverage, 45335,
     /* 2441317 */     GIR_EraseRootFromParent_Done,
     /* 2441318 */   // Label 35345: @2441318
     /* 2441318 */   GIM_Try, /*On fail goto*//*Label 35346*/ GIMT_Encode4(2441390), // Rule ID 45406 //
     /* 2441323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2441326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441355 */     // MIs[0] policy
     /* 2441355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441365 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2441368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441376 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441389 */     // GIR_Coverage, 45406,
     /* 2441389 */     GIR_EraseRootFromParent_Done,
     /* 2441390 */   // Label 35346: @2441390
     /* 2441390 */   GIM_Try, /*On fail goto*//*Label 35347*/ GIMT_Encode4(2441462), // Rule ID 45407 //
     /* 2441395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2441398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2441404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441427 */     // MIs[0] policy
     /* 2441427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441437 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2441440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2441458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441461 */     // GIR_Coverage, 45407,
     /* 2441461 */     GIR_EraseRootFromParent_Done,
     /* 2441462 */   // Label 35347: @2441462
     /* 2441462 */   GIM_Reject,
     /* 2441463 */ // Label 35339: @2441463
     /* 2441463 */ GIM_Reject,
     /* 2441464 */ // Label 35297: @2441464
     /* 2441464 */ GIM_Try, /*On fail goto*//*Label 35348*/ GIMT_Encode4(2441786),
     /* 2441469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2441472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2441475 */   GIM_Try, /*On fail goto*//*Label 35349*/ GIMT_Encode4(2441558), // Rule ID 45300 //
     /* 2441480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2441489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441516 */     // MIs[1] Operand 1
     /* 2441516 */     // No operand predicates
     /* 2441516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441520 */     // MIs[0] policy
     /* 2441520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441532 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2441535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441557 */     // GIR_Coverage, 45300,
     /* 2441557 */     GIR_EraseRootFromParent_Done,
     /* 2441558 */   // Label 35349: @2441558
     /* 2441558 */   GIM_Try, /*On fail goto*//*Label 35350*/ GIMT_Encode4(2441641), // Rule ID 45301 //
     /* 2441563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2441572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441599 */     // MIs[1] Operand 1
     /* 2441599 */     // No operand predicates
     /* 2441599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441603 */     // MIs[0] policy
     /* 2441603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441615 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2441618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441640 */     // GIR_Coverage, 45301,
     /* 2441640 */     GIR_EraseRootFromParent_Done,
     /* 2441641 */   // Label 35350: @2441641
     /* 2441641 */   GIM_Try, /*On fail goto*//*Label 35351*/ GIMT_Encode4(2441713), // Rule ID 45302 //
     /* 2441646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2441655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441678 */     // MIs[0] policy
     /* 2441678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441688 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2441691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441712 */     // GIR_Coverage, 45302,
     /* 2441712 */     GIR_EraseRootFromParent_Done,
     /* 2441713 */   // Label 35351: @2441713
     /* 2441713 */   GIM_Try, /*On fail goto*//*Label 35352*/ GIMT_Encode4(2441785), // Rule ID 45303 //
     /* 2441718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2441727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2441746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441750 */     // MIs[0] policy
     /* 2441750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441760 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2441763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2441771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2441781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441784 */     // GIR_Coverage, 45303,
     /* 2441784 */     GIR_EraseRootFromParent_Done,
     /* 2441785 */   // Label 35352: @2441785
     /* 2441785 */   GIM_Reject,
     /* 2441786 */ // Label 35348: @2441786
     /* 2441786 */ GIM_Reject,
     /* 2441787 */ // Label 35298: @2441787
     /* 2441787 */ GIM_Try, /*On fail goto*//*Label 35353*/ GIMT_Encode4(2442419),
     /* 2441792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2441795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2441798 */   GIM_Try, /*On fail goto*//*Label 35354*/ GIMT_Encode4(2441881), // Rule ID 45312 //
     /* 2441803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2441812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441839 */     // MIs[1] Operand 1
     /* 2441839 */     // No operand predicates
     /* 2441839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441843 */     // MIs[0] policy
     /* 2441843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441855 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2441855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2441858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2441877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441880 */     // GIR_Coverage, 45312,
     /* 2441880 */     GIR_EraseRootFromParent_Done,
     /* 2441881 */   // Label 35354: @2441881
     /* 2441881 */   GIM_Try, /*On fail goto*//*Label 35355*/ GIMT_Encode4(2441964), // Rule ID 45313 //
     /* 2441886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2441889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2441892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2441895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2441898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2441918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2441922 */     // MIs[1] Operand 1
     /* 2441922 */     // No operand predicates
     /* 2441922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2441926 */     // MIs[0] policy
     /* 2441926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2441929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2441931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2441938 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2441938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2441941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2441943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2441945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2441947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2441950 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2441952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2441957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2441960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2441962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2441963 */     // GIR_Coverage, 45313,
     /* 2441963 */     GIR_EraseRootFromParent_Done,
     /* 2441964 */   // Label 35355: @2441964
     /* 2441964 */   GIM_Try, /*On fail goto*//*Label 35356*/ GIMT_Encode4(2442047), // Rule ID 45388 //
     /* 2441969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2441972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2441975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2441978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2441981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2441985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2441993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2441997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442005 */     // MIs[1] Operand 1
     /* 2442005 */     // No operand predicates
     /* 2442005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442009 */     // MIs[0] policy
     /* 2442009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442021 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442046 */     // GIR_Coverage, 45388,
     /* 2442046 */     GIR_EraseRootFromParent_Done,
     /* 2442047 */   // Label 35356: @2442047
     /* 2442047 */   GIM_Try, /*On fail goto*//*Label 35357*/ GIMT_Encode4(2442130), // Rule ID 45389 //
     /* 2442052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442088 */     // MIs[1] Operand 1
     /* 2442088 */     // No operand predicates
     /* 2442088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442092 */     // MIs[0] policy
     /* 2442092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442104 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2442107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442116 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442129 */     // GIR_Coverage, 45389,
     /* 2442129 */     GIR_EraseRootFromParent_Done,
     /* 2442130 */   // Label 35357: @2442130
     /* 2442130 */   GIM_Try, /*On fail goto*//*Label 35358*/ GIMT_Encode4(2442202), // Rule ID 45314 //
     /* 2442135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442167 */     // MIs[0] policy
     /* 2442167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442177 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442201 */     // GIR_Coverage, 45314,
     /* 2442201 */     GIR_EraseRootFromParent_Done,
     /* 2442202 */   // Label 35358: @2442202
     /* 2442202 */   GIM_Try, /*On fail goto*//*Label 35359*/ GIMT_Encode4(2442274), // Rule ID 45315 //
     /* 2442207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442239 */     // MIs[0] policy
     /* 2442239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442249 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442273 */     // GIR_Coverage, 45315,
     /* 2442273 */     GIR_EraseRootFromParent_Done,
     /* 2442274 */   // Label 35359: @2442274
     /* 2442274 */   GIM_Try, /*On fail goto*//*Label 35360*/ GIMT_Encode4(2442346), // Rule ID 45390 //
     /* 2442279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442311 */     // MIs[0] policy
     /* 2442311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442321 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442345 */     // GIR_Coverage, 45390,
     /* 2442345 */     GIR_EraseRootFromParent_Done,
     /* 2442346 */   // Label 35360: @2442346
     /* 2442346 */   GIM_Try, /*On fail goto*//*Label 35361*/ GIMT_Encode4(2442418), // Rule ID 45391 //
     /* 2442351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442383 */     // MIs[0] policy
     /* 2442383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442393 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2442396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2442414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442417 */     // GIR_Coverage, 45391,
     /* 2442417 */     GIR_EraseRootFromParent_Done,
     /* 2442418 */   // Label 35361: @2442418
     /* 2442418 */   GIM_Reject,
     /* 2442419 */ // Label 35353: @2442419
     /* 2442419 */ GIM_Reject,
     /* 2442420 */ // Label 35299: @2442420
     /* 2442420 */ GIM_Try, /*On fail goto*//*Label 35362*/ GIMT_Encode4(2443052),
     /* 2442425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2442428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2442431 */   GIM_Try, /*On fail goto*//*Label 35363*/ GIMT_Encode4(2442514), // Rule ID 45328 //
     /* 2442436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442472 */     // MIs[1] Operand 1
     /* 2442472 */     // No operand predicates
     /* 2442472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442476 */     // MIs[0] policy
     /* 2442476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442488 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2442491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442500 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442513 */     // GIR_Coverage, 45328,
     /* 2442513 */     GIR_EraseRootFromParent_Done,
     /* 2442514 */   // Label 35363: @2442514
     /* 2442514 */   GIM_Try, /*On fail goto*//*Label 35364*/ GIMT_Encode4(2442597), // Rule ID 45329 //
     /* 2442519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442555 */     // MIs[1] Operand 1
     /* 2442555 */     // No operand predicates
     /* 2442555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442559 */     // MIs[0] policy
     /* 2442559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442571 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2442574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442596 */     // GIR_Coverage, 45329,
     /* 2442596 */     GIR_EraseRootFromParent_Done,
     /* 2442597 */   // Label 35364: @2442597
     /* 2442597 */   GIM_Try, /*On fail goto*//*Label 35365*/ GIMT_Encode4(2442680), // Rule ID 45400 //
     /* 2442602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442634 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442638 */     // MIs[1] Operand 1
     /* 2442638 */     // No operand predicates
     /* 2442638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442642 */     // MIs[0] policy
     /* 2442642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442654 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2442657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442679 */     // GIR_Coverage, 45400,
     /* 2442679 */     GIR_EraseRootFromParent_Done,
     /* 2442680 */   // Label 35365: @2442680
     /* 2442680 */   GIM_Try, /*On fail goto*//*Label 35366*/ GIMT_Encode4(2442763), // Rule ID 45401 //
     /* 2442685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2442713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2442717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2442721 */     // MIs[1] Operand 1
     /* 2442721 */     // No operand predicates
     /* 2442721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442725 */     // MIs[0] policy
     /* 2442725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2442730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442737 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2442740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442746 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2442749 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442762 */     // GIR_Coverage, 45401,
     /* 2442762 */     GIR_EraseRootFromParent_Done,
     /* 2442763 */   // Label 35366: @2442763
     /* 2442763 */   GIM_Try, /*On fail goto*//*Label 35367*/ GIMT_Encode4(2442835), // Rule ID 45330 //
     /* 2442768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442800 */     // MIs[0] policy
     /* 2442800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442810 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2442813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442834 */     // GIR_Coverage, 45330,
     /* 2442834 */     GIR_EraseRootFromParent_Done,
     /* 2442835 */   // Label 35367: @2442835
     /* 2442835 */   GIM_Try, /*On fail goto*//*Label 35368*/ GIMT_Encode4(2442907), // Rule ID 45331 //
     /* 2442840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442872 */     // MIs[0] policy
     /* 2442872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442882 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2442882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2442885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442906 */     // GIR_Coverage, 45331,
     /* 2442906 */     GIR_EraseRootFromParent_Done,
     /* 2442907 */   // Label 35368: @2442907
     /* 2442907 */   GIM_Try, /*On fail goto*//*Label 35369*/ GIMT_Encode4(2442979), // Rule ID 45402 //
     /* 2442912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2442915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2442918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2442924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2442928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2442936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2442940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2442944 */     // MIs[0] policy
     /* 2442944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2442947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2442954 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2442954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2442957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2442959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2442961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2442963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2442965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2442967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2442972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2442975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2442977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2442978 */     // GIR_Coverage, 45402,
     /* 2442978 */     GIR_EraseRootFromParent_Done,
     /* 2442979 */   // Label 35369: @2442979
     /* 2442979 */   GIM_Try, /*On fail goto*//*Label 35370*/ GIMT_Encode4(2443051), // Rule ID 45403 //
     /* 2442984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2442987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2442990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2442993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2442996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443016 */     // MIs[0] policy
     /* 2443016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443026 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2443029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2443047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443050 */     // GIR_Coverage, 45403,
     /* 2443050 */     GIR_EraseRootFromParent_Done,
     /* 2443051 */   // Label 35370: @2443051
     /* 2443051 */   GIM_Reject,
     /* 2443052 */ // Label 35362: @2443052
     /* 2443052 */ GIM_Reject,
     /* 2443053 */ // Label 35300: @2443053
     /* 2443053 */ GIM_Try, /*On fail goto*//*Label 35371*/ GIMT_Encode4(2443685),
     /* 2443058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2443061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2443064 */   GIM_Try, /*On fail goto*//*Label 35372*/ GIMT_Encode4(2443147), // Rule ID 45372 //
     /* 2443069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443105 */     // MIs[1] Operand 1
     /* 2443105 */     // No operand predicates
     /* 2443105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443109 */     // MIs[0] policy
     /* 2443109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443121 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2443124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443146 */     // GIR_Coverage, 45372,
     /* 2443146 */     GIR_EraseRootFromParent_Done,
     /* 2443147 */   // Label 35372: @2443147
     /* 2443147 */   GIM_Try, /*On fail goto*//*Label 35373*/ GIMT_Encode4(2443230), // Rule ID 45373 //
     /* 2443152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443184 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443188 */     // MIs[1] Operand 1
     /* 2443188 */     // No operand predicates
     /* 2443188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443192 */     // MIs[0] policy
     /* 2443192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443204 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2443207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443229 */     // GIR_Coverage, 45373,
     /* 2443229 */     GIR_EraseRootFromParent_Done,
     /* 2443230 */   // Label 35373: @2443230
     /* 2443230 */   GIM_Try, /*On fail goto*//*Label 35374*/ GIMT_Encode4(2443313), // Rule ID 45432 //
     /* 2443235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443271 */     // MIs[1] Operand 1
     /* 2443271 */     // No operand predicates
     /* 2443271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443275 */     // MIs[0] policy
     /* 2443275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443287 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2443290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443312 */     // GIR_Coverage, 45432,
     /* 2443312 */     GIR_EraseRootFromParent_Done,
     /* 2443313 */   // Label 35374: @2443313
     /* 2443313 */   GIM_Try, /*On fail goto*//*Label 35375*/ GIMT_Encode4(2443396), // Rule ID 45433 //
     /* 2443318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443354 */     // MIs[1] Operand 1
     /* 2443354 */     // No operand predicates
     /* 2443354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443358 */     // MIs[0] policy
     /* 2443358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443370 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2443373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443382 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443395 */     // GIR_Coverage, 45433,
     /* 2443395 */     GIR_EraseRootFromParent_Done,
     /* 2443396 */   // Label 35375: @2443396
     /* 2443396 */   GIM_Try, /*On fail goto*//*Label 35376*/ GIMT_Encode4(2443468), // Rule ID 45374 //
     /* 2443401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443417 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443433 */     // MIs[0] policy
     /* 2443433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443443 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2443446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443467 */     // GIR_Coverage, 45374,
     /* 2443467 */     GIR_EraseRootFromParent_Done,
     /* 2443468 */   // Label 35376: @2443468
     /* 2443468 */   GIM_Try, /*On fail goto*//*Label 35377*/ GIMT_Encode4(2443540), // Rule ID 45375 //
     /* 2443473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443505 */     // MIs[0] policy
     /* 2443505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443515 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2443518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443539 */     // GIR_Coverage, 45375,
     /* 2443539 */     GIR_EraseRootFromParent_Done,
     /* 2443540 */   // Label 35377: @2443540
     /* 2443540 */   GIM_Try, /*On fail goto*//*Label 35378*/ GIMT_Encode4(2443612), // Rule ID 45434 //
     /* 2443545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2443548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443577 */     // MIs[0] policy
     /* 2443577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443587 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2443590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443611 */     // GIR_Coverage, 45434,
     /* 2443611 */     GIR_EraseRootFromParent_Done,
     /* 2443612 */   // Label 35378: @2443612
     /* 2443612 */   GIM_Try, /*On fail goto*//*Label 35379*/ GIMT_Encode4(2443684), // Rule ID 45435 //
     /* 2443617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2443620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2443626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2443633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2443641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443649 */     // MIs[0] policy
     /* 2443649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443659 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2443662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2443680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443683 */     // GIR_Coverage, 45435,
     /* 2443683 */     GIR_EraseRootFromParent_Done,
     /* 2443684 */   // Label 35379: @2443684
     /* 2443684 */   GIM_Reject,
     /* 2443685 */ // Label 35371: @2443685
     /* 2443685 */ GIM_Reject,
     /* 2443686 */ // Label 35301: @2443686
     /* 2443686 */ GIM_Try, /*On fail goto*//*Label 35380*/ GIMT_Encode4(2444008),
     /* 2443691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2443694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2443697 */   GIM_Try, /*On fail goto*//*Label 35381*/ GIMT_Encode4(2443780), // Rule ID 45304 //
     /* 2443702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2443711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443738 */     // MIs[1] Operand 1
     /* 2443738 */     // No operand predicates
     /* 2443738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443742 */     // MIs[0] policy
     /* 2443742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443754 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2443757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443766 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2443776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443779 */     // GIR_Coverage, 45304,
     /* 2443779 */     GIR_EraseRootFromParent_Done,
     /* 2443780 */   // Label 35381: @2443780
     /* 2443780 */   GIM_Try, /*On fail goto*//*Label 35382*/ GIMT_Encode4(2443863), // Rule ID 45305 //
     /* 2443785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2443794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2443813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2443817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2443821 */     // MIs[1] Operand 1
     /* 2443821 */     // No operand predicates
     /* 2443821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443825 */     // MIs[0] policy
     /* 2443825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2443830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443837 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2443840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2443849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2443859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443862 */     // GIR_Coverage, 45305,
     /* 2443862 */     GIR_EraseRootFromParent_Done,
     /* 2443863 */   // Label 35382: @2443863
     /* 2443863 */   GIM_Try, /*On fail goto*//*Label 35383*/ GIMT_Encode4(2443935), // Rule ID 45306 //
     /* 2443868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2443871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2443874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2443877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2443880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443900 */     // MIs[0] policy
     /* 2443900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443910 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2443910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2443913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2443928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2443931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2443933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2443934 */     // GIR_Coverage, 45306,
     /* 2443934 */     GIR_EraseRootFromParent_Done,
     /* 2443935 */   // Label 35383: @2443935
     /* 2443935 */   GIM_Try, /*On fail goto*//*Label 35384*/ GIMT_Encode4(2444007), // Rule ID 45307 //
     /* 2443940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2443943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2443946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2443949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2443952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2443956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2443964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2443968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2443972 */     // MIs[0] policy
     /* 2443972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2443975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2443982 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2443982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2443985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2443987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2443989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2443991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2443993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2443995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2444003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444006 */     // GIR_Coverage, 45307,
     /* 2444006 */     GIR_EraseRootFromParent_Done,
     /* 2444007 */   // Label 35384: @2444007
     /* 2444007 */   GIM_Reject,
     /* 2444008 */ // Label 35380: @2444008
     /* 2444008 */ GIM_Reject,
     /* 2444009 */ // Label 35302: @2444009
     /* 2444009 */ GIM_Try, /*On fail goto*//*Label 35385*/ GIMT_Encode4(2444641),
     /* 2444014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2444017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2444020 */   GIM_Try, /*On fail goto*//*Label 35386*/ GIMT_Encode4(2444103), // Rule ID 45324 //
     /* 2444025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444061 */     // MIs[1] Operand 1
     /* 2444061 */     // No operand predicates
     /* 2444061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444065 */     // MIs[0] policy
     /* 2444065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444077 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444102 */     // GIR_Coverage, 45324,
     /* 2444102 */     GIR_EraseRootFromParent_Done,
     /* 2444103 */   // Label 35386: @2444103
     /* 2444103 */   GIM_Try, /*On fail goto*//*Label 35387*/ GIMT_Encode4(2444186), // Rule ID 45325 //
     /* 2444108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444144 */     // MIs[1] Operand 1
     /* 2444144 */     // No operand predicates
     /* 2444144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444148 */     // MIs[0] policy
     /* 2444148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444160 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444185 */     // GIR_Coverage, 45325,
     /* 2444185 */     GIR_EraseRootFromParent_Done,
     /* 2444186 */   // Label 35387: @2444186
     /* 2444186 */   GIM_Try, /*On fail goto*//*Label 35388*/ GIMT_Encode4(2444269), // Rule ID 45396 //
     /* 2444191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444227 */     // MIs[1] Operand 1
     /* 2444227 */     // No operand predicates
     /* 2444227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444231 */     // MIs[0] policy
     /* 2444231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444243 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444268 */     // GIR_Coverage, 45396,
     /* 2444268 */     GIR_EraseRootFromParent_Done,
     /* 2444269 */   // Label 35388: @2444269
     /* 2444269 */   GIM_Try, /*On fail goto*//*Label 35389*/ GIMT_Encode4(2444352), // Rule ID 45397 //
     /* 2444274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444310 */     // MIs[1] Operand 1
     /* 2444310 */     // No operand predicates
     /* 2444310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444314 */     // MIs[0] policy
     /* 2444314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444326 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2444329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444338 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444351 */     // GIR_Coverage, 45397,
     /* 2444351 */     GIR_EraseRootFromParent_Done,
     /* 2444352 */   // Label 35389: @2444352
     /* 2444352 */   GIM_Try, /*On fail goto*//*Label 35390*/ GIMT_Encode4(2444424), // Rule ID 45326 //
     /* 2444357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444389 */     // MIs[0] policy
     /* 2444389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444399 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2444402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444423 */     // GIR_Coverage, 45326,
     /* 2444423 */     GIR_EraseRootFromParent_Done,
     /* 2444424 */   // Label 35390: @2444424
     /* 2444424 */   GIM_Try, /*On fail goto*//*Label 35391*/ GIMT_Encode4(2444496), // Rule ID 45327 //
     /* 2444429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444461 */     // MIs[0] policy
     /* 2444461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444471 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2444474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444495 */     // GIR_Coverage, 45327,
     /* 2444495 */     GIR_EraseRootFromParent_Done,
     /* 2444496 */   // Label 35391: @2444496
     /* 2444496 */   GIM_Try, /*On fail goto*//*Label 35392*/ GIMT_Encode4(2444568), // Rule ID 45398 //
     /* 2444501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444533 */     // MIs[0] policy
     /* 2444533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444543 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2444546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444567 */     // GIR_Coverage, 45398,
     /* 2444567 */     GIR_EraseRootFromParent_Done,
     /* 2444568 */   // Label 35392: @2444568
     /* 2444568 */   GIM_Try, /*On fail goto*//*Label 35393*/ GIMT_Encode4(2444640), // Rule ID 45399 //
     /* 2444573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2444589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2444597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2444601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444605 */     // MIs[0] policy
     /* 2444605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444615 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2444618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2444626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2444636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444639 */     // GIR_Coverage, 45399,
     /* 2444639 */     GIR_EraseRootFromParent_Done,
     /* 2444640 */   // Label 35393: @2444640
     /* 2444640 */   GIM_Reject,
     /* 2444641 */ // Label 35385: @2444641
     /* 2444641 */ GIM_Reject,
     /* 2444642 */ // Label 35303: @2444642
     /* 2444642 */ GIM_Try, /*On fail goto*//*Label 35394*/ GIMT_Encode4(2445274),
     /* 2444647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2444650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2444653 */   GIM_Try, /*On fail goto*//*Label 35395*/ GIMT_Encode4(2444736), // Rule ID 45360 //
     /* 2444658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2444674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444694 */     // MIs[1] Operand 1
     /* 2444694 */     // No operand predicates
     /* 2444694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444698 */     // MIs[0] policy
     /* 2444698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444710 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2444713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444722 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2444732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444735 */     // GIR_Coverage, 45360,
     /* 2444735 */     GIR_EraseRootFromParent_Done,
     /* 2444736 */   // Label 35395: @2444736
     /* 2444736 */   GIM_Try, /*On fail goto*//*Label 35396*/ GIMT_Encode4(2444819), // Rule ID 45361 //
     /* 2444741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2444757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444777 */     // MIs[1] Operand 1
     /* 2444777 */     // No operand predicates
     /* 2444777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444781 */     // MIs[0] policy
     /* 2444781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444793 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2444796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2444815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444818 */     // GIR_Coverage, 45361,
     /* 2444818 */     GIR_EraseRootFromParent_Done,
     /* 2444819 */   // Label 35396: @2444819
     /* 2444819 */   GIM_Try, /*On fail goto*//*Label 35397*/ GIMT_Encode4(2444902), // Rule ID 45420 //
     /* 2444824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2444836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2444840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444860 */     // MIs[1] Operand 1
     /* 2444860 */     // No operand predicates
     /* 2444860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444864 */     // MIs[0] policy
     /* 2444864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444876 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2444876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2444879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444888 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2444898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444901 */     // GIR_Coverage, 45420,
     /* 2444901 */     GIR_EraseRootFromParent_Done,
     /* 2444902 */   // Label 35397: @2444902
     /* 2444902 */   GIM_Try, /*On fail goto*//*Label 35398*/ GIMT_Encode4(2444985), // Rule ID 45421 //
     /* 2444907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2444910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2444913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2444919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2444923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2444931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2444935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2444939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2444943 */     // MIs[1] Operand 1
     /* 2444943 */     // No operand predicates
     /* 2444943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2444947 */     // MIs[0] policy
     /* 2444947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2444950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2444952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2444959 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2444959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2444962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2444964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2444966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2444968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2444971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2444973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2444978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2444981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2444983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2444984 */     // GIR_Coverage, 45421,
     /* 2444984 */     GIR_EraseRootFromParent_Done,
     /* 2444985 */   // Label 35398: @2444985
     /* 2444985 */   GIM_Try, /*On fail goto*//*Label 35399*/ GIMT_Encode4(2445057), // Rule ID 45362 //
     /* 2444990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2444993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2444996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2444999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445022 */     // MIs[0] policy
     /* 2445022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445032 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445056 */     // GIR_Coverage, 45362,
     /* 2445056 */     GIR_EraseRootFromParent_Done,
     /* 2445057 */   // Label 35399: @2445057
     /* 2445057 */   GIM_Try, /*On fail goto*//*Label 35400*/ GIMT_Encode4(2445129), // Rule ID 45363 //
     /* 2445062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445094 */     // MIs[0] policy
     /* 2445094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445104 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445128 */     // GIR_Coverage, 45363,
     /* 2445128 */     GIR_EraseRootFromParent_Done,
     /* 2445129 */   // Label 35400: @2445129
     /* 2445129 */   GIM_Try, /*On fail goto*//*Label 35401*/ GIMT_Encode4(2445201), // Rule ID 45422 //
     /* 2445134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445166 */     // MIs[0] policy
     /* 2445166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445176 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445200 */     // GIR_Coverage, 45422,
     /* 2445200 */     GIR_EraseRootFromParent_Done,
     /* 2445201 */   // Label 35401: @2445201
     /* 2445201 */   GIM_Try, /*On fail goto*//*Label 35402*/ GIMT_Encode4(2445273), // Rule ID 45423 //
     /* 2445206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2445209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2445222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2445230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445238 */     // MIs[0] policy
     /* 2445238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445248 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2445251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2445269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445272 */     // GIR_Coverage, 45423,
     /* 2445272 */     GIR_EraseRootFromParent_Done,
     /* 2445273 */   // Label 35402: @2445273
     /* 2445273 */   GIM_Reject,
     /* 2445274 */ // Label 35394: @2445274
     /* 2445274 */ GIM_Reject,
     /* 2445275 */ // Label 35304: @2445275
     /* 2445275 */ GIM_Try, /*On fail goto*//*Label 35403*/ GIMT_Encode4(2445907),
     /* 2445280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2445283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2445286 */   GIM_Try, /*On fail goto*//*Label 35404*/ GIMT_Encode4(2445369), // Rule ID 45376 //
     /* 2445291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445327 */     // MIs[1] Operand 1
     /* 2445327 */     // No operand predicates
     /* 2445327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445331 */     // MIs[0] policy
     /* 2445331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445343 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2445346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445368 */     // GIR_Coverage, 45376,
     /* 2445368 */     GIR_EraseRootFromParent_Done,
     /* 2445369 */   // Label 35404: @2445369
     /* 2445369 */   GIM_Try, /*On fail goto*//*Label 35405*/ GIMT_Encode4(2445452), // Rule ID 45377 //
     /* 2445374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445410 */     // MIs[1] Operand 1
     /* 2445410 */     // No operand predicates
     /* 2445410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445414 */     // MIs[0] policy
     /* 2445414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445426 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2445429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445451 */     // GIR_Coverage, 45377,
     /* 2445451 */     GIR_EraseRootFromParent_Done,
     /* 2445452 */   // Label 35405: @2445452
     /* 2445452 */   GIM_Try, /*On fail goto*//*Label 35406*/ GIMT_Encode4(2445535), // Rule ID 45436 //
     /* 2445457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445493 */     // MIs[1] Operand 1
     /* 2445493 */     // No operand predicates
     /* 2445493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445497 */     // MIs[0] policy
     /* 2445497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445509 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2445512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445534 */     // GIR_Coverage, 45436,
     /* 2445534 */     GIR_EraseRootFromParent_Done,
     /* 2445535 */   // Label 35406: @2445535
     /* 2445535 */   GIM_Try, /*On fail goto*//*Label 35407*/ GIMT_Encode4(2445618), // Rule ID 45437 //
     /* 2445540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445576 */     // MIs[1] Operand 1
     /* 2445576 */     // No operand predicates
     /* 2445576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445580 */     // MIs[0] policy
     /* 2445580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445592 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2445595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445604 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445617 */     // GIR_Coverage, 45437,
     /* 2445617 */     GIR_EraseRootFromParent_Done,
     /* 2445618 */   // Label 35407: @2445618
     /* 2445618 */   GIM_Try, /*On fail goto*//*Label 35408*/ GIMT_Encode4(2445690), // Rule ID 45378 //
     /* 2445623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445655 */     // MIs[0] policy
     /* 2445655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445665 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2445668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445689 */     // GIR_Coverage, 45378,
     /* 2445689 */     GIR_EraseRootFromParent_Done,
     /* 2445690 */   // Label 35408: @2445690
     /* 2445690 */   GIM_Try, /*On fail goto*//*Label 35409*/ GIMT_Encode4(2445762), // Rule ID 45379 //
     /* 2445695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445727 */     // MIs[0] policy
     /* 2445727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445737 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2445740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445761 */     // GIR_Coverage, 45379,
     /* 2445761 */     GIR_EraseRootFromParent_Done,
     /* 2445762 */   // Label 35409: @2445762
     /* 2445762 */   GIM_Try, /*On fail goto*//*Label 35410*/ GIMT_Encode4(2445834), // Rule ID 45438 //
     /* 2445767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2445770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445799 */     // MIs[0] policy
     /* 2445799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445809 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2445812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445833 */     // GIR_Coverage, 45438,
     /* 2445833 */     GIR_EraseRootFromParent_Done,
     /* 2445834 */   // Label 35410: @2445834
     /* 2445834 */   GIM_Try, /*On fail goto*//*Label 35411*/ GIMT_Encode4(2445906), // Rule ID 45439 //
     /* 2445839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2445842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2445845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2445848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2445851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2445855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2445863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2445867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445871 */     // MIs[0] policy
     /* 2445871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445881 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2445881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2445884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2445892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2445902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2445904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2445905 */     // GIR_Coverage, 45439,
     /* 2445905 */     GIR_EraseRootFromParent_Done,
     /* 2445906 */   // Label 35411: @2445906
     /* 2445906 */   GIM_Reject,
     /* 2445907 */ // Label 35403: @2445907
     /* 2445907 */ GIM_Reject,
     /* 2445908 */ // Label 35305: @2445908
     /* 2445908 */ GIM_Try, /*On fail goto*//*Label 35412*/ GIMT_Encode4(2446230),
     /* 2445913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2445916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2445919 */   GIM_Try, /*On fail goto*//*Label 35413*/ GIMT_Encode4(2446002), // Rule ID 45320 //
     /* 2445924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2445927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2445930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2445933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2445936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2445940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2445948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2445952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2445956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2445960 */     // MIs[1] Operand 1
     /* 2445960 */     // No operand predicates
     /* 2445960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2445964 */     // MIs[0] policy
     /* 2445964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2445967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2445969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2445976 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2445976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2445979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2445981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2445983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2445985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2445988 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2445990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2445995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2445998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446001 */     // GIR_Coverage, 45320,
     /* 2446001 */     GIR_EraseRootFromParent_Done,
     /* 2446002 */   // Label 35413: @2446002
     /* 2446002 */   GIM_Try, /*On fail goto*//*Label 35414*/ GIMT_Encode4(2446085), // Rule ID 45321 //
     /* 2446007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446043 */     // MIs[1] Operand 1
     /* 2446043 */     // No operand predicates
     /* 2446043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446047 */     // MIs[0] policy
     /* 2446047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446059 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2446062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446084 */     // GIR_Coverage, 45321,
     /* 2446084 */     GIR_EraseRootFromParent_Done,
     /* 2446085 */   // Label 35414: @2446085
     /* 2446085 */   GIM_Try, /*On fail goto*//*Label 35415*/ GIMT_Encode4(2446157), // Rule ID 45322 //
     /* 2446090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446122 */     // MIs[0] policy
     /* 2446122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446132 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2446135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446156 */     // GIR_Coverage, 45322,
     /* 2446156 */     GIR_EraseRootFromParent_Done,
     /* 2446157 */   // Label 35415: @2446157
     /* 2446157 */   GIM_Try, /*On fail goto*//*Label 35416*/ GIMT_Encode4(2446229), // Rule ID 45323 //
     /* 2446162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2446178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2446186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446194 */     // MIs[0] policy
     /* 2446194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446204 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2446207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2446225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446228 */     // GIR_Coverage, 45323,
     /* 2446228 */     GIR_EraseRootFromParent_Done,
     /* 2446229 */   // Label 35416: @2446229
     /* 2446229 */   GIM_Reject,
     /* 2446230 */ // Label 35412: @2446230
     /* 2446230 */ GIM_Reject,
     /* 2446231 */ // Label 35306: @2446231
     /* 2446231 */ GIM_Try, /*On fail goto*//*Label 35417*/ GIMT_Encode4(2446863),
     /* 2446236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2446239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2446242 */   GIM_Try, /*On fail goto*//*Label 35418*/ GIMT_Encode4(2446325), // Rule ID 45348 //
     /* 2446247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446283 */     // MIs[1] Operand 1
     /* 2446283 */     // No operand predicates
     /* 2446283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446287 */     // MIs[0] policy
     /* 2446287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446299 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2446302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446324 */     // GIR_Coverage, 45348,
     /* 2446324 */     GIR_EraseRootFromParent_Done,
     /* 2446325 */   // Label 35418: @2446325
     /* 2446325 */   GIM_Try, /*On fail goto*//*Label 35419*/ GIMT_Encode4(2446408), // Rule ID 45349 //
     /* 2446330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446366 */     // MIs[1] Operand 1
     /* 2446366 */     // No operand predicates
     /* 2446366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446370 */     // MIs[0] policy
     /* 2446370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446382 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2446385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446407 */     // GIR_Coverage, 45349,
     /* 2446407 */     GIR_EraseRootFromParent_Done,
     /* 2446408 */   // Label 35419: @2446408
     /* 2446408 */   GIM_Try, /*On fail goto*//*Label 35420*/ GIMT_Encode4(2446491), // Rule ID 45408 //
     /* 2446413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446449 */     // MIs[1] Operand 1
     /* 2446449 */     // No operand predicates
     /* 2446449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446453 */     // MIs[0] policy
     /* 2446453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446465 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2446468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446490 */     // GIR_Coverage, 45408,
     /* 2446490 */     GIR_EraseRootFromParent_Done,
     /* 2446491 */   // Label 35420: @2446491
     /* 2446491 */   GIM_Try, /*On fail goto*//*Label 35421*/ GIMT_Encode4(2446574), // Rule ID 45409 //
     /* 2446496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446532 */     // MIs[1] Operand 1
     /* 2446532 */     // No operand predicates
     /* 2446532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446536 */     // MIs[0] policy
     /* 2446536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446548 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2446551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446573 */     // GIR_Coverage, 45409,
     /* 2446573 */     GIR_EraseRootFromParent_Done,
     /* 2446574 */   // Label 35421: @2446574
     /* 2446574 */   GIM_Try, /*On fail goto*//*Label 35422*/ GIMT_Encode4(2446646), // Rule ID 45350 //
     /* 2446579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446611 */     // MIs[0] policy
     /* 2446611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446621 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2446624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446645 */     // GIR_Coverage, 45350,
     /* 2446645 */     GIR_EraseRootFromParent_Done,
     /* 2446646 */   // Label 35422: @2446646
     /* 2446646 */   GIM_Try, /*On fail goto*//*Label 35423*/ GIMT_Encode4(2446718), // Rule ID 45351 //
     /* 2446651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446683 */     // MIs[0] policy
     /* 2446683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446693 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2446696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446717 */     // GIR_Coverage, 45351,
     /* 2446717 */     GIR_EraseRootFromParent_Done,
     /* 2446718 */   // Label 35423: @2446718
     /* 2446718 */   GIM_Try, /*On fail goto*//*Label 35424*/ GIMT_Encode4(2446790), // Rule ID 45410 //
     /* 2446723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446755 */     // MIs[0] policy
     /* 2446755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446765 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2446768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446789 */     // GIR_Coverage, 45410,
     /* 2446789 */     GIR_EraseRootFromParent_Done,
     /* 2446790 */   // Label 35424: @2446790
     /* 2446790 */   GIM_Try, /*On fail goto*//*Label 35425*/ GIMT_Encode4(2446862), // Rule ID 45411 //
     /* 2446795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2446811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2446819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2446823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446827 */     // MIs[0] policy
     /* 2446827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446837 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2446837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2446840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2446848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2446858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446861 */     // GIR_Coverage, 45411,
     /* 2446861 */     GIR_EraseRootFromParent_Done,
     /* 2446862 */   // Label 35425: @2446862
     /* 2446862 */   GIM_Reject,
     /* 2446863 */ // Label 35417: @2446863
     /* 2446863 */ GIM_Reject,
     /* 2446864 */ // Label 35307: @2446864
     /* 2446864 */ GIM_Try, /*On fail goto*//*Label 35426*/ GIMT_Encode4(2447496),
     /* 2446869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2446872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2446875 */   GIM_Try, /*On fail goto*//*Label 35427*/ GIMT_Encode4(2446958), // Rule ID 45364 //
     /* 2446880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2446883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2446886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2446892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2446896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446916 */     // MIs[1] Operand 1
     /* 2446916 */     // No operand predicates
     /* 2446916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2446920 */     // MIs[0] policy
     /* 2446920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2446923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2446925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2446932 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2446932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2446935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2446937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2446939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2446941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2446944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2446946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2446951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2446954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2446956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2446957 */     // GIR_Coverage, 45364,
     /* 2446957 */     GIR_EraseRootFromParent_Done,
     /* 2446958 */   // Label 35427: @2446958
     /* 2446958 */   GIM_Try, /*On fail goto*//*Label 35428*/ GIMT_Encode4(2447041), // Rule ID 45365 //
     /* 2446963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2446966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2446969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2446972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2446975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2446979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2446987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2446991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2446995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2446999 */     // MIs[1] Operand 1
     /* 2446999 */     // No operand predicates
     /* 2446999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447003 */     // MIs[0] policy
     /* 2447003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447015 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447040 */     // GIR_Coverage, 45365,
     /* 2447040 */     GIR_EraseRootFromParent_Done,
     /* 2447041 */   // Label 35428: @2447041
     /* 2447041 */   GIM_Try, /*On fail goto*//*Label 35429*/ GIMT_Encode4(2447124), // Rule ID 45424 //
     /* 2447046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447082 */     // MIs[1] Operand 1
     /* 2447082 */     // No operand predicates
     /* 2447082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447086 */     // MIs[0] policy
     /* 2447086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447098 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447110 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447123 */     // GIR_Coverage, 45424,
     /* 2447123 */     GIR_EraseRootFromParent_Done,
     /* 2447124 */   // Label 35429: @2447124
     /* 2447124 */   GIM_Try, /*On fail goto*//*Label 35430*/ GIMT_Encode4(2447207), // Rule ID 45425 //
     /* 2447129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447165 */     // MIs[1] Operand 1
     /* 2447165 */     // No operand predicates
     /* 2447165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447169 */     // MIs[0] policy
     /* 2447169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447181 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2447184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447206 */     // GIR_Coverage, 45425,
     /* 2447206 */     GIR_EraseRootFromParent_Done,
     /* 2447207 */   // Label 35430: @2447207
     /* 2447207 */   GIM_Try, /*On fail goto*//*Label 35431*/ GIMT_Encode4(2447279), // Rule ID 45366 //
     /* 2447212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447244 */     // MIs[0] policy
     /* 2447244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447254 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447278 */     // GIR_Coverage, 45366,
     /* 2447278 */     GIR_EraseRootFromParent_Done,
     /* 2447279 */   // Label 35431: @2447279
     /* 2447279 */   GIM_Try, /*On fail goto*//*Label 35432*/ GIMT_Encode4(2447351), // Rule ID 45367 //
     /* 2447284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447316 */     // MIs[0] policy
     /* 2447316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447326 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447350 */     // GIR_Coverage, 45367,
     /* 2447350 */     GIR_EraseRootFromParent_Done,
     /* 2447351 */   // Label 35432: @2447351
     /* 2447351 */   GIM_Try, /*On fail goto*//*Label 35433*/ GIMT_Encode4(2447423), // Rule ID 45426 //
     /* 2447356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2447359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447388 */     // MIs[0] policy
     /* 2447388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447398 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447422 */     // GIR_Coverage, 45426,
     /* 2447422 */     GIR_EraseRootFromParent_Done,
     /* 2447423 */   // Label 35433: @2447423
     /* 2447423 */   GIM_Try, /*On fail goto*//*Label 35434*/ GIMT_Encode4(2447495), // Rule ID 45427 //
     /* 2447428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2447431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2447444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2447452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447460 */     // MIs[0] policy
     /* 2447460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447470 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2447473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2447491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447494 */     // GIR_Coverage, 45427,
     /* 2447494 */     GIR_EraseRootFromParent_Done,
     /* 2447495 */   // Label 35434: @2447495
     /* 2447495 */   GIM_Reject,
     /* 2447496 */ // Label 35426: @2447496
     /* 2447496 */ GIM_Reject,
     /* 2447497 */ // Label 35308: @2447497
     /* 2447497 */ GIM_Try, /*On fail goto*//*Label 35435*/ GIMT_Encode4(2448129),
     /* 2447502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2447505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2447508 */   GIM_Try, /*On fail goto*//*Label 35436*/ GIMT_Encode4(2447591), // Rule ID 45380 //
     /* 2447513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2447529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447549 */     // MIs[1] Operand 1
     /* 2447549 */     // No operand predicates
     /* 2447549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447553 */     // MIs[0] policy
     /* 2447553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447565 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2447568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447590 */     // GIR_Coverage, 45380,
     /* 2447590 */     GIR_EraseRootFromParent_Done,
     /* 2447591 */   // Label 35436: @2447591
     /* 2447591 */   GIM_Try, /*On fail goto*//*Label 35437*/ GIMT_Encode4(2447674), // Rule ID 45381 //
     /* 2447596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2447612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447632 */     // MIs[1] Operand 1
     /* 2447632 */     // No operand predicates
     /* 2447632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447636 */     // MIs[0] policy
     /* 2447636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447648 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2447651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447673 */     // GIR_Coverage, 45381,
     /* 2447673 */     GIR_EraseRootFromParent_Done,
     /* 2447674 */   // Label 35437: @2447674
     /* 2447674 */   GIM_Try, /*On fail goto*//*Label 35438*/ GIMT_Encode4(2447757), // Rule ID 45440 //
     /* 2447679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2447695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447715 */     // MIs[1] Operand 1
     /* 2447715 */     // No operand predicates
     /* 2447715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447719 */     // MIs[0] policy
     /* 2447719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447731 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2447734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447756 */     // GIR_Coverage, 45440,
     /* 2447756 */     GIR_EraseRootFromParent_Done,
     /* 2447757 */   // Label 35438: @2447757
     /* 2447757 */   GIM_Try, /*On fail goto*//*Label 35439*/ GIMT_Encode4(2447840), // Rule ID 45441 //
     /* 2447762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2447778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2447790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2447794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2447798 */     // MIs[1] Operand 1
     /* 2447798 */     // No operand predicates
     /* 2447798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447802 */     // MIs[0] policy
     /* 2447802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2447807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447814 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2447817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2447826 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447839 */     // GIR_Coverage, 45441,
     /* 2447839 */     GIR_EraseRootFromParent_Done,
     /* 2447840 */   // Label 35439: @2447840
     /* 2447840 */   GIM_Try, /*On fail goto*//*Label 35440*/ GIMT_Encode4(2447912), // Rule ID 45382 //
     /* 2447845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2447857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2447861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447877 */     // MIs[0] policy
     /* 2447877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447887 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2447887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2447890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447892 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447898 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447911 */     // GIR_Coverage, 45382,
     /* 2447911 */     GIR_EraseRootFromParent_Done,
     /* 2447912 */   // Label 35440: @2447912
     /* 2447912 */   GIM_Try, /*On fail goto*//*Label 35441*/ GIMT_Encode4(2447984), // Rule ID 45383 //
     /* 2447917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2447920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2447923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2447929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2447933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2447941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2447945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2447949 */     // MIs[0] policy
     /* 2447949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2447952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2447959 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2447959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2447962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2447964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2447966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2447968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2447970 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2447972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2447977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2447980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2447982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2447983 */     // GIR_Coverage, 45383,
     /* 2447983 */     GIR_EraseRootFromParent_Done,
     /* 2447984 */   // Label 35441: @2447984
     /* 2447984 */   GIM_Try, /*On fail goto*//*Label 35442*/ GIMT_Encode4(2448056), // Rule ID 45442 //
     /* 2447989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2447992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2447995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2447998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2448005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448021 */     // MIs[0] policy
     /* 2448021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448031 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2448034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448055 */     // GIR_Coverage, 45442,
     /* 2448055 */     GIR_EraseRootFromParent_Done,
     /* 2448056 */   // Label 35442: @2448056
     /* 2448056 */   GIM_Try, /*On fail goto*//*Label 35443*/ GIMT_Encode4(2448128), // Rule ID 45443 //
     /* 2448061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2448064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2448070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2448077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2448085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448093 */     // MIs[0] policy
     /* 2448093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448103 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2448106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448114 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2448124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448127 */     // GIR_Coverage, 45443,
     /* 2448127 */     GIR_EraseRootFromParent_Done,
     /* 2448128 */   // Label 35443: @2448128
     /* 2448128 */   GIM_Reject,
     /* 2448129 */ // Label 35435: @2448129
     /* 2448129 */ GIM_Reject,
     /* 2448130 */ // Label 35309: @2448130
     /* 2448130 */ GIM_Try, /*On fail goto*//*Label 35444*/ GIMT_Encode4(2448452),
     /* 2448135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2448138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2448141 */   GIM_Try, /*On fail goto*//*Label 35445*/ GIMT_Encode4(2448224), // Rule ID 45336 //
     /* 2448146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448182 */     // MIs[1] Operand 1
     /* 2448182 */     // No operand predicates
     /* 2448182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448186 */     // MIs[0] policy
     /* 2448186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448198 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2448201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448223 */     // GIR_Coverage, 45336,
     /* 2448223 */     GIR_EraseRootFromParent_Done,
     /* 2448224 */   // Label 35445: @2448224
     /* 2448224 */   GIM_Try, /*On fail goto*//*Label 35446*/ GIMT_Encode4(2448307), // Rule ID 45337 //
     /* 2448229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448265 */     // MIs[1] Operand 1
     /* 2448265 */     // No operand predicates
     /* 2448265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448269 */     // MIs[0] policy
     /* 2448269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448281 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2448284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448293 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448306 */     // GIR_Coverage, 45337,
     /* 2448306 */     GIR_EraseRootFromParent_Done,
     /* 2448307 */   // Label 35446: @2448307
     /* 2448307 */   GIM_Try, /*On fail goto*//*Label 35447*/ GIMT_Encode4(2448379), // Rule ID 45338 //
     /* 2448312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448344 */     // MIs[0] policy
     /* 2448344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448354 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2448357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448378 */     // GIR_Coverage, 45338,
     /* 2448378 */     GIR_EraseRootFromParent_Done,
     /* 2448379 */   // Label 35447: @2448379
     /* 2448379 */   GIM_Try, /*On fail goto*//*Label 35448*/ GIMT_Encode4(2448451), // Rule ID 45339 //
     /* 2448384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2448400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2448408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448416 */     // MIs[0] policy
     /* 2448416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448426 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2448429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2448447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448450 */     // GIR_Coverage, 45339,
     /* 2448450 */     GIR_EraseRootFromParent_Done,
     /* 2448451 */   // Label 35448: @2448451
     /* 2448451 */   GIM_Reject,
     /* 2448452 */ // Label 35444: @2448452
     /* 2448452 */ GIM_Reject,
     /* 2448453 */ // Label 35310: @2448453
     /* 2448453 */ GIM_Try, /*On fail goto*//*Label 35449*/ GIMT_Encode4(2449085),
     /* 2448458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2448461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2448464 */   GIM_Try, /*On fail goto*//*Label 35450*/ GIMT_Encode4(2448547), // Rule ID 45352 //
     /* 2448469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448505 */     // MIs[1] Operand 1
     /* 2448505 */     // No operand predicates
     /* 2448505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448509 */     // MIs[0] policy
     /* 2448509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448521 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2448524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448546 */     // GIR_Coverage, 45352,
     /* 2448546 */     GIR_EraseRootFromParent_Done,
     /* 2448547 */   // Label 35450: @2448547
     /* 2448547 */   GIM_Try, /*On fail goto*//*Label 35451*/ GIMT_Encode4(2448630), // Rule ID 45353 //
     /* 2448552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448588 */     // MIs[1] Operand 1
     /* 2448588 */     // No operand predicates
     /* 2448588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448592 */     // MIs[0] policy
     /* 2448592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448604 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2448607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448629 */     // GIR_Coverage, 45353,
     /* 2448629 */     GIR_EraseRootFromParent_Done,
     /* 2448630 */   // Label 35451: @2448630
     /* 2448630 */   GIM_Try, /*On fail goto*//*Label 35452*/ GIMT_Encode4(2448713), // Rule ID 45412 //
     /* 2448635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448671 */     // MIs[1] Operand 1
     /* 2448671 */     // No operand predicates
     /* 2448671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448675 */     // MIs[0] policy
     /* 2448675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448687 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2448690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448712 */     // GIR_Coverage, 45412,
     /* 2448712 */     GIR_EraseRootFromParent_Done,
     /* 2448713 */   // Label 35452: @2448713
     /* 2448713 */   GIM_Try, /*On fail goto*//*Label 35453*/ GIMT_Encode4(2448796), // Rule ID 45413 //
     /* 2448718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2448746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2448750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2448754 */     // MIs[1] Operand 1
     /* 2448754 */     // No operand predicates
     /* 2448754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448758 */     // MIs[0] policy
     /* 2448758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2448763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448770 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2448773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2448782 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448795 */     // GIR_Coverage, 45413,
     /* 2448795 */     GIR_EraseRootFromParent_Done,
     /* 2448796 */   // Label 35453: @2448796
     /* 2448796 */   GIM_Try, /*On fail goto*//*Label 35454*/ GIMT_Encode4(2448868), // Rule ID 45354 //
     /* 2448801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448833 */     // MIs[0] policy
     /* 2448833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448843 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2448846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448867 */     // GIR_Coverage, 45354,
     /* 2448867 */     GIR_EraseRootFromParent_Done,
     /* 2448868 */   // Label 35454: @2448868
     /* 2448868 */   GIM_Try, /*On fail goto*//*Label 35455*/ GIMT_Encode4(2448940), // Rule ID 45355 //
     /* 2448873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2448876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2448879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2448885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448905 */     // MIs[0] policy
     /* 2448905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448915 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2448915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2448918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448926 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2448928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2448933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2448936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2448938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2448939 */     // GIR_Coverage, 45355,
     /* 2448939 */     GIR_EraseRootFromParent_Done,
     /* 2448940 */   // Label 35455: @2448940
     /* 2448940 */   GIM_Try, /*On fail goto*//*Label 35456*/ GIMT_Encode4(2449012), // Rule ID 45414 //
     /* 2448945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2448948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2448951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2448954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2448957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2448961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2448969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2448973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2448977 */     // MIs[0] policy
     /* 2448977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2448980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2448987 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2448987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2448990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2448992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2448994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2448996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2448998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449011 */     // GIR_Coverage, 45414,
     /* 2449011 */     GIR_EraseRootFromParent_Done,
     /* 2449012 */   // Label 35456: @2449012
     /* 2449012 */   GIM_Try, /*On fail goto*//*Label 35457*/ GIMT_Encode4(2449084), // Rule ID 45415 //
     /* 2449017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449049 */     // MIs[0] policy
     /* 2449049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449059 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449070 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2449080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449083 */     // GIR_Coverage, 45415,
     /* 2449083 */     GIR_EraseRootFromParent_Done,
     /* 2449084 */   // Label 35457: @2449084
     /* 2449084 */   GIM_Reject,
     /* 2449085 */ // Label 35449: @2449085
     /* 2449085 */ GIM_Reject,
     /* 2449086 */ // Label 35311: @2449086
     /* 2449086 */ GIM_Try, /*On fail goto*//*Label 35458*/ GIMT_Encode4(2449718),
     /* 2449091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2449094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2449097 */   GIM_Try, /*On fail goto*//*Label 35459*/ GIMT_Encode4(2449180), // Rule ID 45368 //
     /* 2449102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449138 */     // MIs[1] Operand 1
     /* 2449138 */     // No operand predicates
     /* 2449138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449142 */     // MIs[0] policy
     /* 2449142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449154 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449179 */     // GIR_Coverage, 45368,
     /* 2449179 */     GIR_EraseRootFromParent_Done,
     /* 2449180 */   // Label 35459: @2449180
     /* 2449180 */   GIM_Try, /*On fail goto*//*Label 35460*/ GIMT_Encode4(2449263), // Rule ID 45369 //
     /* 2449185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449221 */     // MIs[1] Operand 1
     /* 2449221 */     // No operand predicates
     /* 2449221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449225 */     // MIs[0] policy
     /* 2449225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449237 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449262 */     // GIR_Coverage, 45369,
     /* 2449262 */     GIR_EraseRootFromParent_Done,
     /* 2449263 */   // Label 35460: @2449263
     /* 2449263 */   GIM_Try, /*On fail goto*//*Label 35461*/ GIMT_Encode4(2449346), // Rule ID 45428 //
     /* 2449268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449304 */     // MIs[1] Operand 1
     /* 2449304 */     // No operand predicates
     /* 2449304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449308 */     // MIs[0] policy
     /* 2449308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449320 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449345 */     // GIR_Coverage, 45428,
     /* 2449345 */     GIR_EraseRootFromParent_Done,
     /* 2449346 */   // Label 35461: @2449346
     /* 2449346 */   GIM_Try, /*On fail goto*//*Label 35462*/ GIMT_Encode4(2449429), // Rule ID 45429 //
     /* 2449351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449387 */     // MIs[1] Operand 1
     /* 2449387 */     // No operand predicates
     /* 2449387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449391 */     // MIs[0] policy
     /* 2449391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449403 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2449406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449428 */     // GIR_Coverage, 45429,
     /* 2449428 */     GIR_EraseRootFromParent_Done,
     /* 2449429 */   // Label 35462: @2449429
     /* 2449429 */   GIM_Try, /*On fail goto*//*Label 35463*/ GIMT_Encode4(2449501), // Rule ID 45370 //
     /* 2449434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449466 */     // MIs[0] policy
     /* 2449466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449476 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2449479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449500 */     // GIR_Coverage, 45370,
     /* 2449500 */     GIR_EraseRootFromParent_Done,
     /* 2449501 */   // Label 35463: @2449501
     /* 2449501 */   GIM_Try, /*On fail goto*//*Label 35464*/ GIMT_Encode4(2449573), // Rule ID 45371 //
     /* 2449506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449538 */     // MIs[0] policy
     /* 2449538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449548 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2449551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449572 */     // GIR_Coverage, 45371,
     /* 2449572 */     GIR_EraseRootFromParent_Done,
     /* 2449573 */   // Label 35464: @2449573
     /* 2449573 */   GIM_Try, /*On fail goto*//*Label 35465*/ GIMT_Encode4(2449645), // Rule ID 45430 //
     /* 2449578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449610 */     // MIs[0] policy
     /* 2449610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449620 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2449623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449644 */     // GIR_Coverage, 45430,
     /* 2449644 */     GIR_EraseRootFromParent_Done,
     /* 2449645 */   // Label 35465: @2449645
     /* 2449645 */   GIM_Try, /*On fail goto*//*Label 35466*/ GIMT_Encode4(2449717), // Rule ID 45431 //
     /* 2449650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2449659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2449666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2449674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449682 */     // MIs[0] policy
     /* 2449682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449692 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2449695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2449713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449716 */     // GIR_Coverage, 45431,
     /* 2449716 */     GIR_EraseRootFromParent_Done,
     /* 2449717 */   // Label 35466: @2449717
     /* 2449717 */   GIM_Reject,
     /* 2449718 */ // Label 35458: @2449718
     /* 2449718 */ GIM_Reject,
     /* 2449719 */ // Label 35312: @2449719
     /* 2449719 */ GIM_Try, /*On fail goto*//*Label 35467*/ GIMT_Encode4(2450041),
     /* 2449724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2449727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2449730 */   GIM_Try, /*On fail goto*//*Label 35468*/ GIMT_Encode4(2449813), // Rule ID 45340 //
     /* 2449735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2449744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449771 */     // MIs[1] Operand 1
     /* 2449771 */     // No operand predicates
     /* 2449771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449775 */     // MIs[0] policy
     /* 2449775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449787 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2449790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2449809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449812 */     // GIR_Coverage, 45340,
     /* 2449812 */     GIR_EraseRootFromParent_Done,
     /* 2449813 */   // Label 35468: @2449813
     /* 2449813 */   GIM_Try, /*On fail goto*//*Label 35469*/ GIMT_Encode4(2449896), // Rule ID 45341 //
     /* 2449818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2449827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2449846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2449850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2449854 */     // MIs[1] Operand 1
     /* 2449854 */     // No operand predicates
     /* 2449854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449858 */     // MIs[0] policy
     /* 2449858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2449863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449870 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2449870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2449873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2449882 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2449892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449895 */     // GIR_Coverage, 45341,
     /* 2449895 */     GIR_EraseRootFromParent_Done,
     /* 2449896 */   // Label 35469: @2449896
     /* 2449896 */   GIM_Try, /*On fail goto*//*Label 35470*/ GIMT_Encode4(2449968), // Rule ID 45342 //
     /* 2449901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2449904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2449907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2449910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2449913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2449929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2449933 */     // MIs[0] policy
     /* 2449933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2449936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2449943 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2449943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2449946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2449948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2449950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2449952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2449954 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2449956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2449961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2449964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2449966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2449967 */     // GIR_Coverage, 45342,
     /* 2449967 */     GIR_EraseRootFromParent_Done,
     /* 2449968 */   // Label 35470: @2449968
     /* 2449968 */   GIM_Try, /*On fail goto*//*Label 35471*/ GIMT_Encode4(2450040), // Rule ID 45343 //
     /* 2449973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2449976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2449979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2449982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2449985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2449989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2449997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450005 */     // MIs[0] policy
     /* 2450005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450015 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2450018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450039 */     // GIR_Coverage, 45343,
     /* 2450039 */     GIR_EraseRootFromParent_Done,
     /* 2450040 */   // Label 35471: @2450040
     /* 2450040 */   GIM_Reject,
     /* 2450041 */ // Label 35467: @2450041
     /* 2450041 */ GIM_Reject,
     /* 2450042 */ // Label 35313: @2450042
     /* 2450042 */ GIM_Try, /*On fail goto*//*Label 35472*/ GIMT_Encode4(2450674),
     /* 2450047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2450050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2450053 */   GIM_Try, /*On fail goto*//*Label 35473*/ GIMT_Encode4(2450136), // Rule ID 45356 //
     /* 2450058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450094 */     // MIs[1] Operand 1
     /* 2450094 */     // No operand predicates
     /* 2450094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450098 */     // MIs[0] policy
     /* 2450098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450110 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450122 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450135 */     // GIR_Coverage, 45356,
     /* 2450135 */     GIR_EraseRootFromParent_Done,
     /* 2450136 */   // Label 35473: @2450136
     /* 2450136 */   GIM_Try, /*On fail goto*//*Label 35474*/ GIMT_Encode4(2450219), // Rule ID 45357 //
     /* 2450141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450177 */     // MIs[1] Operand 1
     /* 2450177 */     // No operand predicates
     /* 2450177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450181 */     // MIs[0] policy
     /* 2450181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450193 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450218 */     // GIR_Coverage, 45357,
     /* 2450218 */     GIR_EraseRootFromParent_Done,
     /* 2450219 */   // Label 35474: @2450219
     /* 2450219 */   GIM_Try, /*On fail goto*//*Label 35475*/ GIMT_Encode4(2450302), // Rule ID 45416 //
     /* 2450224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450260 */     // MIs[1] Operand 1
     /* 2450260 */     // No operand predicates
     /* 2450260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450264 */     // MIs[0] policy
     /* 2450264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450276 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450301 */     // GIR_Coverage, 45416,
     /* 2450301 */     GIR_EraseRootFromParent_Done,
     /* 2450302 */   // Label 35475: @2450302
     /* 2450302 */   GIM_Try, /*On fail goto*//*Label 35476*/ GIMT_Encode4(2450385), // Rule ID 45417 //
     /* 2450307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450343 */     // MIs[1] Operand 1
     /* 2450343 */     // No operand predicates
     /* 2450343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450347 */     // MIs[0] policy
     /* 2450347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450359 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450384 */     // GIR_Coverage, 45417,
     /* 2450384 */     GIR_EraseRootFromParent_Done,
     /* 2450385 */   // Label 35476: @2450385
     /* 2450385 */   GIM_Try, /*On fail goto*//*Label 35477*/ GIMT_Encode4(2450457), // Rule ID 45358 //
     /* 2450390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450422 */     // MIs[0] policy
     /* 2450422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450432 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450456 */     // GIR_Coverage, 45358,
     /* 2450456 */     GIR_EraseRootFromParent_Done,
     /* 2450457 */   // Label 35477: @2450457
     /* 2450457 */   GIM_Try, /*On fail goto*//*Label 35478*/ GIMT_Encode4(2450529), // Rule ID 45359 //
     /* 2450462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450494 */     // MIs[0] policy
     /* 2450494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450504 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450528 */     // GIR_Coverage, 45359,
     /* 2450528 */     GIR_EraseRootFromParent_Done,
     /* 2450529 */   // Label 35478: @2450529
     /* 2450529 */   GIM_Try, /*On fail goto*//*Label 35479*/ GIMT_Encode4(2450601), // Rule ID 45418 //
     /* 2450534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450566 */     // MIs[0] policy
     /* 2450566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450576 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450600 */     // GIR_Coverage, 45418,
     /* 2450600 */     GIR_EraseRootFromParent_Done,
     /* 2450601 */   // Label 35479: @2450601
     /* 2450601 */   GIM_Try, /*On fail goto*//*Label 35480*/ GIMT_Encode4(2450673), // Rule ID 45419 //
     /* 2450606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2450615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450638 */     // MIs[0] policy
     /* 2450638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450648 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2450669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450672 */     // GIR_Coverage, 45419,
     /* 2450672 */     GIR_EraseRootFromParent_Done,
     /* 2450673 */   // Label 35480: @2450673
     /* 2450673 */   GIM_Reject,
     /* 2450674 */ // Label 35472: @2450674
     /* 2450674 */ GIM_Reject,
     /* 2450675 */ // Label 35314: @2450675
     /* 2450675 */ GIM_Try, /*On fail goto*//*Label 35481*/ GIMT_Encode4(2450997),
     /* 2450680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2450683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2450686 */   GIM_Try, /*On fail goto*//*Label 35482*/ GIMT_Encode4(2450769), // Rule ID 45344 //
     /* 2450691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2450700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450727 */     // MIs[1] Operand 1
     /* 2450727 */     // No operand predicates
     /* 2450727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450731 */     // MIs[0] policy
     /* 2450731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450743 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450768 */     // GIR_Coverage, 45344,
     /* 2450768 */     GIR_EraseRootFromParent_Done,
     /* 2450769 */   // Label 35482: @2450769
     /* 2450769 */   GIM_Try, /*On fail goto*//*Label 35483*/ GIMT_Encode4(2450852), // Rule ID 45345 //
     /* 2450774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2450783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2450802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2450806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2450810 */     // MIs[1] Operand 1
     /* 2450810 */     // No operand predicates
     /* 2450810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450814 */     // MIs[0] policy
     /* 2450814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2450819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450826 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2450829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2450838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450851 */     // GIR_Coverage, 45345,
     /* 2450851 */     GIR_EraseRootFromParent_Done,
     /* 2450852 */   // Label 35483: @2450852
     /* 2450852 */   GIM_Try, /*On fail goto*//*Label 35484*/ GIMT_Encode4(2450924), // Rule ID 45346 //
     /* 2450857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2450860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2450863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2450866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2450869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450889 */     // MIs[0] policy
     /* 2450889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450899 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2450899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450910 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450923 */     // GIR_Coverage, 45346,
     /* 2450923 */     GIR_EraseRootFromParent_Done,
     /* 2450924 */   // Label 35484: @2450924
     /* 2450924 */   GIM_Try, /*On fail goto*//*Label 35485*/ GIMT_Encode4(2450996), // Rule ID 45347 //
     /* 2450929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2450932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2450935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2450938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2450941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2450945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2450953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2450957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2450961 */     // MIs[0] policy
     /* 2450961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2450964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2450971 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2450971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2450974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2450976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2450978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2450980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2450982 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2450984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2450989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2450992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2450994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2450995 */     // GIR_Coverage, 45347,
     /* 2450995 */     GIR_EraseRootFromParent_Done,
     /* 2450996 */   // Label 35485: @2450996
     /* 2450996 */   GIM_Reject,
     /* 2450997 */ // Label 35481: @2450997
     /* 2450997 */ GIM_Reject,
     /* 2450998 */ // Label 35315: @2450998
     /* 2450998 */ GIM_Reject,
     /* 2450999 */ // Label 125: @2450999
     /* 2450999 */ GIM_Reject,
     /* 2451000 */ }; // Size: 2451000 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
